#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 9145
#define LARGE_STATE_COUNT 2527
#define SYMBOL_COUNT 545
#define ALIAS_COUNT 5
#define TOKEN_COUNT 228
#define EXTERNAL_TOKEN_COUNT 2
#define FIELD_COUNT 50
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 218

enum ts_symbol_identifiers {
  sym_identifier = 1,
  aux_sym_preproc_include_token1 = 2,
  aux_sym_preproc_include_token2 = 3,
  aux_sym_preproc_def_token1 = 4,
  anon_sym_LPAREN = 5,
  anon_sym_DOT_DOT_DOT = 6,
  anon_sym_COMMA = 7,
  anon_sym_RPAREN = 8,
  aux_sym_preproc_if_token1 = 9,
  anon_sym_LF = 10,
  aux_sym_preproc_if_token2 = 11,
  aux_sym_preproc_ifdef_token1 = 12,
  aux_sym_preproc_ifdef_token2 = 13,
  aux_sym_preproc_else_token1 = 14,
  aux_sym_preproc_elif_token1 = 15,
  aux_sym_preproc_elifdef_token1 = 16,
  aux_sym_preproc_elifdef_token2 = 17,
  sym_preproc_arg = 18,
  sym_preproc_directive = 19,
  anon_sym_LPAREN2 = 20,
  anon_sym_defined = 21,
  anon_sym_BANG = 22,
  anon_sym_TILDE = 23,
  anon_sym_DASH = 24,
  anon_sym_PLUS = 25,
  anon_sym_STAR = 26,
  anon_sym_SLASH = 27,
  anon_sym_PERCENT = 28,
  anon_sym_PIPE_PIPE = 29,
  anon_sym_AMP_AMP = 30,
  anon_sym_PIPE = 31,
  anon_sym_CARET = 32,
  anon_sym_AMP = 33,
  anon_sym_EQ_EQ = 34,
  anon_sym_BANG_EQ = 35,
  anon_sym_GT = 36,
  anon_sym_GT_EQ = 37,
  anon_sym_LT_EQ = 38,
  anon_sym_LT = 39,
  anon_sym_LT_LT = 40,
  anon_sym_GT_GT = 41,
  anon_sym_SEMI = 42,
  anon_sym___extension__ = 43,
  anon_sym_typedef = 44,
  anon_sym___device__ = 45,
  anon_sym___host__ = 46,
  anon_sym___global__ = 47,
  anon_sym___forceinline__ = 48,
  anon_sym___noinline__ = 49,
  anon_sym_extern = 50,
  anon_sym___attribute__ = 51,
  anon_sym_COLON_COLON = 52,
  anon_sym_LBRACK_LBRACK = 53,
  anon_sym_RBRACK_RBRACK = 54,
  anon_sym___declspec = 55,
  anon_sym___based = 56,
  anon_sym___cdecl = 57,
  anon_sym___clrcall = 58,
  anon_sym___stdcall = 59,
  anon_sym___fastcall = 60,
  anon_sym___thiscall = 61,
  anon_sym___vectorcall = 62,
  sym_ms_restrict_modifier = 63,
  sym_ms_unsigned_ptr_modifier = 64,
  sym_ms_signed_ptr_modifier = 65,
  anon_sym__unaligned = 66,
  anon_sym___unaligned = 67,
  anon_sym_LBRACE = 68,
  anon_sym_RBRACE = 69,
  anon_sym_signed = 70,
  anon_sym_unsigned = 71,
  anon_sym_long = 72,
  anon_sym_short = 73,
  anon_sym_LBRACK = 74,
  anon_sym_static = 75,
  anon_sym_RBRACK = 76,
  anon_sym_EQ = 77,
  anon_sym_register = 78,
  anon_sym_inline = 79,
  anon_sym___inline = 80,
  anon_sym___inline__ = 81,
  anon_sym___forceinline = 82,
  anon_sym_thread_local = 83,
  anon_sym___thread = 84,
  anon_sym_const = 85,
  anon_sym_constexpr = 86,
  anon_sym_volatile = 87,
  anon_sym_restrict = 88,
  anon_sym___restrict__ = 89,
  anon_sym__Atomic = 90,
  anon_sym__Noreturn = 91,
  anon_sym_noreturn = 92,
  anon_sym_mutable = 93,
  anon_sym_constinit = 94,
  anon_sym_consteval = 95,
  anon_sym___shared__ = 96,
  anon_sym___local__ = 97,
  anon_sym___constant__ = 98,
  anon_sym___managed__ = 99,
  anon_sym___grid_constant__ = 100,
  anon_sym_alignas = 101,
  anon_sym__Alignas = 102,
  sym_primitive_type = 103,
  anon_sym_enum = 104,
  anon_sym_class = 105,
  anon_sym_struct = 106,
  anon_sym_union = 107,
  anon_sym_COLON = 108,
  anon_sym_if = 109,
  anon_sym_else = 110,
  anon_sym_switch = 111,
  anon_sym_case = 112,
  anon_sym_default = 113,
  anon_sym_while = 114,
  anon_sym_do = 115,
  anon_sym_for = 116,
  anon_sym_return = 117,
  anon_sym_break = 118,
  anon_sym_continue = 119,
  anon_sym_goto = 120,
  anon_sym___try = 121,
  anon_sym___except = 122,
  anon_sym___finally = 123,
  anon_sym___leave = 124,
  anon_sym_QMARK = 125,
  anon_sym_STAR_EQ = 126,
  anon_sym_SLASH_EQ = 127,
  anon_sym_PERCENT_EQ = 128,
  anon_sym_PLUS_EQ = 129,
  anon_sym_DASH_EQ = 130,
  anon_sym_LT_LT_EQ = 131,
  anon_sym_GT_GT_EQ = 132,
  anon_sym_AMP_EQ = 133,
  anon_sym_CARET_EQ = 134,
  anon_sym_PIPE_EQ = 135,
  anon_sym_and_eq = 136,
  anon_sym_or_eq = 137,
  anon_sym_xor_eq = 138,
  anon_sym_not = 139,
  anon_sym_compl = 140,
  anon_sym_LT_EQ_GT = 141,
  anon_sym_or = 142,
  anon_sym_and = 143,
  anon_sym_bitor = 144,
  anon_sym_xor = 145,
  anon_sym_bitand = 146,
  anon_sym_not_eq = 147,
  anon_sym_DASH_DASH = 148,
  anon_sym_PLUS_PLUS = 149,
  anon_sym_sizeof = 150,
  anon_sym___alignof__ = 151,
  anon_sym___alignof = 152,
  anon_sym__alignof = 153,
  anon_sym_alignof = 154,
  anon_sym__Alignof = 155,
  anon_sym_offsetof = 156,
  anon_sym__Generic = 157,
  anon_sym_asm = 158,
  anon_sym___asm__ = 159,
  anon_sym_DOT = 160,
  anon_sym_DOT_STAR = 161,
  anon_sym_DASH_GT = 162,
  sym_number_literal = 163,
  anon_sym_L_SQUOTE = 164,
  anon_sym_u_SQUOTE = 165,
  anon_sym_U_SQUOTE = 166,
  anon_sym_u8_SQUOTE = 167,
  anon_sym_SQUOTE = 168,
  aux_sym_char_literal_token1 = 169,
  anon_sym_L_DQUOTE = 170,
  anon_sym_u_DQUOTE = 171,
  anon_sym_U_DQUOTE = 172,
  anon_sym_u8_DQUOTE = 173,
  anon_sym_DQUOTE = 174,
  aux_sym_string_literal_token1 = 175,
  sym_escape_sequence = 176,
  sym_system_lib_string = 177,
  sym_true = 178,
  sym_false = 179,
  anon_sym_NULL = 180,
  anon_sym_nullptr = 181,
  sym_comment = 182,
  sym_auto = 183,
  anon_sym_decltype = 184,
  anon_sym_final = 185,
  anon_sym_override = 186,
  sym_virtual = 187,
  anon_sym_explicit = 188,
  anon_sym_typename = 189,
  anon_sym_template = 190,
  anon_sym_GT2 = 191,
  anon_sym_operator = 192,
  anon_sym_try = 193,
  anon_sym_delete = 194,
  anon_sym_0 = 195,
  anon_sym_friend = 196,
  anon_sym_public = 197,
  anon_sym_private = 198,
  anon_sym_protected = 199,
  anon_sym_noexcept = 200,
  anon_sym_throw = 201,
  anon_sym_namespace = 202,
  anon_sym_using = 203,
  anon_sym_static_assert = 204,
  anon_sym_concept = 205,
  anon_sym_co_return = 206,
  anon_sym_co_yield = 207,
  anon_sym_catch = 208,
  anon_sym_R_DQUOTE = 209,
  anon_sym_LR_DQUOTE = 210,
  anon_sym_uR_DQUOTE = 211,
  anon_sym_UR_DQUOTE = 212,
  anon_sym_u8R_DQUOTE = 213,
  anon_sym_co_await = 214,
  anon_sym_new = 215,
  anon_sym_requires = 216,
  anon_sym_DASH_GT_STAR = 217,
  anon_sym_LPAREN_RPAREN = 218,
  anon_sym_LBRACK_RBRACK = 219,
  anon_sym_DQUOTE_DQUOTE = 220,
  sym_this = 221,
  sym_literal_suffix = 222,
  aux_sym_kernel_call_syntax_token1 = 223,
  aux_sym_kernel_call_syntax_token2 = 224,
  anon_sym___launch_bounds__ = 225,
  sym_raw_string_delimiter = 226,
  sym_raw_string_content = 227,
  sym_translation_unit = 228,
  sym__top_level_item = 229,
  sym__block_item = 230,
  sym_preproc_include = 231,
  sym_preproc_def = 232,
  sym_preproc_function_def = 233,
  sym_preproc_params = 234,
  sym_preproc_call = 235,
  sym_preproc_if = 236,
  sym_preproc_ifdef = 237,
  sym_preproc_else = 238,
  sym_preproc_elif = 239,
  sym_preproc_elifdef = 240,
  sym_preproc_if_in_field_declaration_list = 241,
  sym_preproc_ifdef_in_field_declaration_list = 242,
  sym_preproc_else_in_field_declaration_list = 243,
  sym_preproc_elif_in_field_declaration_list = 244,
  sym_preproc_elifdef_in_field_declaration_list = 245,
  sym_preproc_if_in_enumerator_list = 246,
  sym_preproc_ifdef_in_enumerator_list = 247,
  sym_preproc_else_in_enumerator_list = 248,
  sym_preproc_elif_in_enumerator_list = 249,
  sym_preproc_elifdef_in_enumerator_list = 250,
  sym_preproc_if_in_enumerator_list_no_comma = 251,
  sym_preproc_ifdef_in_enumerator_list_no_comma = 252,
  sym_preproc_else_in_enumerator_list_no_comma = 253,
  sym_preproc_elif_in_enumerator_list_no_comma = 254,
  sym_preproc_elifdef_in_enumerator_list_no_comma = 255,
  sym__preproc_expression = 256,
  sym_preproc_parenthesized_expression = 257,
  sym_preproc_defined = 258,
  sym_preproc_unary_expression = 259,
  sym_preproc_call_expression = 260,
  sym_preproc_argument_list = 261,
  sym_preproc_binary_expression = 262,
  sym_function_definition = 263,
  sym_declaration = 264,
  sym_type_definition = 265,
  sym__type_definition_type = 266,
  sym__type_definition_declarators = 267,
  sym__declaration_modifiers = 268,
  sym__declaration_specifiers = 269,
  sym_linkage_specification = 270,
  sym_attribute_specifier = 271,
  sym_attribute = 272,
  sym_attribute_declaration = 273,
  sym_ms_declspec_modifier = 274,
  sym_ms_based_modifier = 275,
  sym_ms_call_modifier = 276,
  sym_ms_unaligned_ptr_modifier = 277,
  sym_ms_pointer_modifier = 278,
  sym_declaration_list = 279,
  sym__declarator = 280,
  sym__field_declarator = 281,
  sym__type_declarator = 282,
  sym__abstract_declarator = 283,
  sym_parenthesized_declarator = 284,
  sym_parenthesized_field_declarator = 285,
  sym_parenthesized_type_declarator = 286,
  sym_abstract_parenthesized_declarator = 287,
  sym_attributed_declarator = 288,
  sym_attributed_field_declarator = 289,
  sym_attributed_type_declarator = 290,
  sym_pointer_declarator = 291,
  sym_pointer_field_declarator = 292,
  sym_pointer_type_declarator = 293,
  sym_abstract_pointer_declarator = 294,
  sym_function_declarator = 295,
  sym_function_field_declarator = 296,
  sym_function_type_declarator = 297,
  sym_abstract_function_declarator = 298,
  sym_array_declarator = 299,
  sym_array_field_declarator = 300,
  sym_array_type_declarator = 301,
  sym_abstract_array_declarator = 302,
  sym_init_declarator = 303,
  sym_compound_statement = 304,
  sym_storage_class_specifier = 305,
  sym_type_qualifier = 306,
  sym_alignas_qualifier = 307,
  sym_type_specifier = 308,
  sym_sized_type_specifier = 309,
  sym_enum_specifier = 310,
  sym_enumerator_list = 311,
  sym_struct_specifier = 312,
  sym_union_specifier = 313,
  sym_field_declaration_list = 314,
  sym__field_declaration_list_item = 315,
  sym_field_declaration = 316,
  sym_bitfield_clause = 317,
  sym_enumerator = 318,
  sym_parameter_list = 319,
  sym_parameter_declaration = 320,
  sym_attributed_statement = 321,
  sym_statement = 322,
  sym__top_level_statement = 323,
  sym_labeled_statement = 324,
  sym__top_level_expression_statement = 325,
  sym_expression_statement = 326,
  sym_if_statement = 327,
  sym_else_clause = 328,
  sym_switch_statement = 329,
  sym_case_statement = 330,
  sym_while_statement = 331,
  sym_do_statement = 332,
  sym_for_statement = 333,
  sym__for_statement_body = 334,
  sym_return_statement = 335,
  sym_break_statement = 336,
  sym_continue_statement = 337,
  sym_goto_statement = 338,
  sym_seh_try_statement = 339,
  sym_seh_except_clause = 340,
  sym_seh_finally_clause = 341,
  sym_seh_leave_statement = 342,
  sym_expression = 343,
  sym__string = 344,
  sym_comma_expression = 345,
  sym_conditional_expression = 346,
  sym_assignment_expression = 347,
  sym_pointer_expression = 348,
  sym_unary_expression = 349,
  sym_binary_expression = 350,
  sym_update_expression = 351,
  sym_cast_expression = 352,
  sym_type_descriptor = 353,
  sym_sizeof_expression = 354,
  sym_alignof_expression = 355,
  sym_offsetof_expression = 356,
  sym_generic_expression = 357,
  sym_subscript_expression = 358,
  sym_call_expression = 359,
  sym_gnu_asm_expression = 360,
  sym_gnu_asm_qualifier = 361,
  sym_gnu_asm_output_operand_list = 362,
  sym_gnu_asm_output_operand = 363,
  sym_gnu_asm_input_operand_list = 364,
  sym_gnu_asm_input_operand = 365,
  sym_gnu_asm_clobber_list = 366,
  sym_gnu_asm_goto_list = 367,
  sym_argument_list = 368,
  sym_field_expression = 369,
  sym_compound_literal_expression = 370,
  sym_parenthesized_expression = 371,
  sym_initializer_list = 372,
  sym_initializer_pair = 373,
  sym_subscript_designator = 374,
  sym_subscript_range_designator = 375,
  sym_field_designator = 376,
  sym_char_literal = 377,
  sym_concatenated_string = 378,
  sym_string_literal = 379,
  sym_null = 380,
  sym__empty_declaration = 381,
  sym_placeholder_type_specifier = 382,
  sym_decltype_auto = 383,
  sym_decltype = 384,
  sym__class_declaration = 385,
  sym__class_declaration_item = 386,
  sym_class_specifier = 387,
  sym__class_name = 388,
  sym_virtual_specifier = 389,
  sym_explicit_function_specifier = 390,
  sym_base_class_clause = 391,
  sym__enum_base_clause = 392,
  sym_dependent_type = 393,
  sym_template_declaration = 394,
  sym_template_instantiation = 395,
  sym_template_parameter_list = 396,
  sym_type_parameter_declaration = 397,
  sym_variadic_type_parameter_declaration = 398,
  sym_optional_type_parameter_declaration = 399,
  sym_template_template_parameter_declaration = 400,
  sym_optional_parameter_declaration = 401,
  sym_variadic_parameter_declaration = 402,
  sym_variadic_declarator = 403,
  sym_variadic_reference_declarator = 404,
  sym_operator_cast = 405,
  sym_field_initializer_list = 406,
  sym_field_initializer = 407,
  sym_inline_method_definition = 408,
  sym__constructor_specifiers = 409,
  sym_operator_cast_definition = 410,
  sym_operator_cast_declaration = 411,
  sym_constructor_try_statement = 412,
  sym_constructor_or_destructor_definition = 413,
  sym_constructor_or_destructor_declaration = 414,
  sym_default_method_clause = 415,
  sym_delete_method_clause = 416,
  sym_pure_virtual_clause = 417,
  sym_friend_declaration = 418,
  sym_access_specifier = 419,
  sym_reference_declarator = 420,
  sym_reference_field_declarator = 421,
  sym_reference_type_declarator = 422,
  sym_abstract_reference_declarator = 423,
  sym_structured_binding_declarator = 424,
  sym_ref_qualifier = 425,
  sym__function_declarator_seq = 426,
  sym__function_attributes_start = 427,
  sym__function_exception_specification = 428,
  sym__function_attributes_end = 429,
  sym__function_postfix = 430,
  sym_trailing_return_type = 431,
  sym_noexcept = 432,
  sym_throw_specifier = 433,
  sym_template_type = 434,
  sym_template_method = 435,
  sym_template_function = 436,
  sym_template_argument_list = 437,
  sym_namespace_definition = 438,
  sym_namespace_alias_definition = 439,
  sym__namespace_specifier = 440,
  sym_nested_namespace_specifier = 441,
  sym_using_declaration = 442,
  sym_alias_declaration = 443,
  sym_static_assert_declaration = 444,
  sym_concept_definition = 445,
  sym_for_range_loop = 446,
  sym__for_range_loop_body = 447,
  sym_init_statement = 448,
  sym_condition_clause = 449,
  sym_condition_declaration = 450,
  sym_co_return_statement = 451,
  sym_co_yield_statement = 452,
  sym_throw_statement = 453,
  sym_try_statement = 454,
  sym_catch_clause = 455,
  sym_raw_string_literal = 456,
  sym_subscript_argument_list = 457,
  sym_co_await_expression = 458,
  sym_new_expression = 459,
  sym_new_declarator = 460,
  sym_delete_expression = 461,
  sym_type_requirement = 462,
  sym_compound_requirement = 463,
  sym__requirement = 464,
  sym_requirement_seq = 465,
  sym_constraint_conjunction = 466,
  sym_constraint_disjunction = 467,
  sym__requirement_clause_constraint = 468,
  sym_requires_clause = 469,
  sym_requires_parameter_list = 470,
  sym_requires_expression = 471,
  sym_lambda_expression = 472,
  sym_lambda_capture_specifier = 473,
  sym_lambda_default_capture = 474,
  sym__fold_operator = 475,
  sym__binary_fold_operator = 476,
  sym__unary_left_fold = 477,
  sym__unary_right_fold = 478,
  sym__binary_fold = 479,
  sym_fold_expression = 480,
  sym_parameter_pack_expansion = 481,
  sym_type_parameter_pack_expansion = 482,
  sym_destructor_name = 483,
  sym_dependent_identifier = 484,
  sym_dependent_field_identifier = 485,
  sym_dependent_type_identifier = 486,
  sym__scope_resolution = 487,
  sym_qualified_field_identifier = 488,
  sym_qualified_identifier = 489,
  sym_qualified_type_identifier = 490,
  sym_qualified_operator_cast_identifier = 491,
  sym__assignment_expression_lhs = 492,
  sym_operator_name = 493,
  sym_user_defined_literal = 494,
  sym_kernel_call_expression = 495,
  sym_kernel_call_syntax = 496,
  sym_launch_bounds = 497,
  aux_sym_translation_unit_repeat1 = 498,
  aux_sym_preproc_params_repeat1 = 499,
  aux_sym_preproc_if_repeat1 = 500,
  aux_sym_preproc_if_in_field_declaration_list_repeat1 = 501,
  aux_sym_preproc_if_in_enumerator_list_repeat1 = 502,
  aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1 = 503,
  aux_sym_preproc_argument_list_repeat1 = 504,
  aux_sym_declaration_repeat1 = 505,
  aux_sym_type_definition_repeat1 = 506,
  aux_sym__type_definition_type_repeat1 = 507,
  aux_sym__type_definition_declarators_repeat1 = 508,
  aux_sym__declaration_specifiers_repeat1 = 509,
  aux_sym_attribute_declaration_repeat1 = 510,
  aux_sym_attributed_declarator_repeat1 = 511,
  aux_sym_pointer_declarator_repeat1 = 512,
  aux_sym_array_declarator_repeat1 = 513,
  aux_sym_sized_type_specifier_repeat1 = 514,
  aux_sym_enumerator_list_repeat1 = 515,
  aux_sym_field_declaration_repeat1 = 516,
  aux_sym_parameter_list_repeat1 = 517,
  aux_sym_case_statement_repeat1 = 518,
  aux_sym_generic_expression_repeat1 = 519,
  aux_sym_gnu_asm_expression_repeat1 = 520,
  aux_sym_gnu_asm_output_operand_list_repeat1 = 521,
  aux_sym_gnu_asm_input_operand_list_repeat1 = 522,
  aux_sym_gnu_asm_clobber_list_repeat1 = 523,
  aux_sym_gnu_asm_goto_list_repeat1 = 524,
  aux_sym_argument_list_repeat1 = 525,
  aux_sym_initializer_list_repeat1 = 526,
  aux_sym_initializer_pair_repeat1 = 527,
  aux_sym_char_literal_repeat1 = 528,
  aux_sym_concatenated_string_repeat1 = 529,
  aux_sym_string_literal_repeat1 = 530,
  aux_sym__class_declaration_repeat1 = 531,
  aux_sym_base_class_clause_repeat1 = 532,
  aux_sym_template_parameter_list_repeat1 = 533,
  aux_sym_field_initializer_list_repeat1 = 534,
  aux_sym_operator_cast_definition_repeat1 = 535,
  aux_sym_constructor_try_statement_repeat1 = 536,
  aux_sym_structured_binding_declarator_repeat1 = 537,
  aux_sym__function_postfix_repeat1 = 538,
  aux_sym_throw_specifier_repeat1 = 539,
  aux_sym_template_argument_list_repeat1 = 540,
  aux_sym_subscript_argument_list_repeat1 = 541,
  aux_sym_requirement_seq_repeat1 = 542,
  aux_sym_requires_parameter_list_repeat1 = 543,
  aux_sym_lambda_capture_specifier_repeat1 = 544,
  alias_sym_field_identifier = 545,
  alias_sym_namespace_identifier = 546,
  alias_sym_simple_requirement = 547,
  alias_sym_statement_identifier = 548,
  alias_sym_type_identifier = 549,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [aux_sym_preproc_include_token1] = "#include",
  [aux_sym_preproc_include_token2] = "preproc_include_token2",
  [aux_sym_preproc_def_token1] = "#define",
  [anon_sym_LPAREN] = "(",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [aux_sym_preproc_if_token1] = "#if",
  [anon_sym_LF] = "\n",
  [aux_sym_preproc_if_token2] = "#endif",
  [aux_sym_preproc_ifdef_token1] = "#ifdef",
  [aux_sym_preproc_ifdef_token2] = "#ifndef",
  [aux_sym_preproc_else_token1] = "#else",
  [aux_sym_preproc_elif_token1] = "#elif",
  [aux_sym_preproc_elifdef_token1] = "#elifdef",
  [aux_sym_preproc_elifdef_token2] = "#elifndef",
  [sym_preproc_arg] = "preproc_arg",
  [sym_preproc_directive] = "preproc_directive",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_defined] = "defined",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS] = "+",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_AMP] = "&",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_SEMI] = ";",
  [anon_sym___extension__] = "__extension__",
  [anon_sym_typedef] = "typedef",
  [anon_sym___device__] = "__device__",
  [anon_sym___host__] = "__host__",
  [anon_sym___global__] = "__global__",
  [anon_sym___forceinline__] = "__forceinline__",
  [anon_sym___noinline__] = "__noinline__",
  [anon_sym_extern] = "extern",
  [anon_sym___attribute__] = "__attribute__",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym___declspec] = "__declspec",
  [anon_sym___based] = "__based",
  [anon_sym___cdecl] = "__cdecl",
  [anon_sym___clrcall] = "__clrcall",
  [anon_sym___stdcall] = "__stdcall",
  [anon_sym___fastcall] = "__fastcall",
  [anon_sym___thiscall] = "__thiscall",
  [anon_sym___vectorcall] = "__vectorcall",
  [sym_ms_restrict_modifier] = "ms_restrict_modifier",
  [sym_ms_unsigned_ptr_modifier] = "ms_unsigned_ptr_modifier",
  [sym_ms_signed_ptr_modifier] = "ms_signed_ptr_modifier",
  [anon_sym__unaligned] = "_unaligned",
  [anon_sym___unaligned] = "__unaligned",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_signed] = "signed",
  [anon_sym_unsigned] = "unsigned",
  [anon_sym_long] = "long",
  [anon_sym_short] = "short",
  [anon_sym_LBRACK] = "[",
  [anon_sym_static] = "static",
  [anon_sym_RBRACK] = "]",
  [anon_sym_EQ] = "=",
  [anon_sym_register] = "register",
  [anon_sym_inline] = "inline",
  [anon_sym___inline] = "__inline",
  [anon_sym___inline__] = "__inline__",
  [anon_sym___forceinline] = "__forceinline",
  [anon_sym_thread_local] = "thread_local",
  [anon_sym___thread] = "__thread",
  [anon_sym_const] = "const",
  [anon_sym_constexpr] = "constexpr",
  [anon_sym_volatile] = "volatile",
  [anon_sym_restrict] = "restrict",
  [anon_sym___restrict__] = "__restrict__",
  [anon_sym__Atomic] = "_Atomic",
  [anon_sym__Noreturn] = "_Noreturn",
  [anon_sym_noreturn] = "noreturn",
  [anon_sym_mutable] = "mutable",
  [anon_sym_constinit] = "constinit",
  [anon_sym_consteval] = "consteval",
  [anon_sym___shared__] = "__shared__",
  [anon_sym___local__] = "__local__",
  [anon_sym___constant__] = "__constant__",
  [anon_sym___managed__] = "__managed__",
  [anon_sym___grid_constant__] = "__grid_constant__",
  [anon_sym_alignas] = "alignas",
  [anon_sym__Alignas] = "_Alignas",
  [sym_primitive_type] = "primitive_type",
  [anon_sym_enum] = "enum",
  [anon_sym_class] = "class",
  [anon_sym_struct] = "struct",
  [anon_sym_union] = "union",
  [anon_sym_COLON] = ":",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_for] = "for",
  [anon_sym_return] = "return",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_goto] = "goto",
  [anon_sym___try] = "__try",
  [anon_sym___except] = "__except",
  [anon_sym___finally] = "__finally",
  [anon_sym___leave] = "__leave",
  [anon_sym_QMARK] = "\?",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_and_eq] = "and_eq",
  [anon_sym_or_eq] = "or_eq",
  [anon_sym_xor_eq] = "xor_eq",
  [anon_sym_not] = "not",
  [anon_sym_compl] = "compl",
  [anon_sym_LT_EQ_GT] = "<=>",
  [anon_sym_or] = "or",
  [anon_sym_and] = "and",
  [anon_sym_bitor] = "bitor",
  [anon_sym_xor] = "xor",
  [anon_sym_bitand] = "bitand",
  [anon_sym_not_eq] = "not_eq",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_sizeof] = "sizeof",
  [anon_sym___alignof__] = "__alignof__",
  [anon_sym___alignof] = "__alignof",
  [anon_sym__alignof] = "_alignof",
  [anon_sym_alignof] = "alignof",
  [anon_sym__Alignof] = "_Alignof",
  [anon_sym_offsetof] = "offsetof",
  [anon_sym__Generic] = "_Generic",
  [anon_sym_asm] = "asm",
  [anon_sym___asm__] = "__asm__",
  [anon_sym_DOT] = ".",
  [anon_sym_DOT_STAR] = ".*",
  [anon_sym_DASH_GT] = "->",
  [sym_number_literal] = "number_literal",
  [anon_sym_L_SQUOTE] = "L'",
  [anon_sym_u_SQUOTE] = "u'",
  [anon_sym_U_SQUOTE] = "U'",
  [anon_sym_u8_SQUOTE] = "u8'",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_char_literal_token1] = "character",
  [anon_sym_L_DQUOTE] = "L\"",
  [anon_sym_u_DQUOTE] = "u\"",
  [anon_sym_U_DQUOTE] = "U\"",
  [anon_sym_u8_DQUOTE] = "u8\"",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_literal_token1] = "string_content",
  [sym_escape_sequence] = "escape_sequence",
  [sym_system_lib_string] = "system_lib_string",
  [sym_true] = "true",
  [sym_false] = "false",
  [anon_sym_NULL] = "NULL",
  [anon_sym_nullptr] = "nullptr",
  [sym_comment] = "comment",
  [sym_auto] = "auto",
  [anon_sym_decltype] = "decltype",
  [anon_sym_final] = "final",
  [anon_sym_override] = "override",
  [sym_virtual] = "virtual",
  [anon_sym_explicit] = "explicit",
  [anon_sym_typename] = "typename",
  [anon_sym_template] = "template",
  [anon_sym_GT2] = ">",
  [anon_sym_operator] = "operator",
  [anon_sym_try] = "try",
  [anon_sym_delete] = "delete",
  [anon_sym_0] = "0",
  [anon_sym_friend] = "friend",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_noexcept] = "noexcept",
  [anon_sym_throw] = "throw",
  [anon_sym_namespace] = "namespace",
  [anon_sym_using] = "using",
  [anon_sym_static_assert] = "static_assert",
  [anon_sym_concept] = "concept",
  [anon_sym_co_return] = "co_return",
  [anon_sym_co_yield] = "co_yield",
  [anon_sym_catch] = "catch",
  [anon_sym_R_DQUOTE] = "R\"",
  [anon_sym_LR_DQUOTE] = "LR\"",
  [anon_sym_uR_DQUOTE] = "uR\"",
  [anon_sym_UR_DQUOTE] = "UR\"",
  [anon_sym_u8R_DQUOTE] = "u8R\"",
  [anon_sym_co_await] = "co_await",
  [anon_sym_new] = "new",
  [anon_sym_requires] = "requires",
  [anon_sym_DASH_GT_STAR] = "->*",
  [anon_sym_LPAREN_RPAREN] = "()",
  [anon_sym_LBRACK_RBRACK] = "[]",
  [anon_sym_DQUOTE_DQUOTE] = "\"\"",
  [sym_this] = "this",
  [sym_literal_suffix] = "literal_suffix",
  [aux_sym_kernel_call_syntax_token1] = "<<<",
  [aux_sym_kernel_call_syntax_token2] = ">>>",
  [anon_sym___launch_bounds__] = "__launch_bounds__",
  [sym_raw_string_delimiter] = "raw_string_delimiter",
  [sym_raw_string_content] = "raw_string_content",
  [sym_translation_unit] = "translation_unit",
  [sym__top_level_item] = "_top_level_item",
  [sym__block_item] = "_block_item",
  [sym_preproc_include] = "preproc_include",
  [sym_preproc_def] = "preproc_def",
  [sym_preproc_function_def] = "preproc_function_def",
  [sym_preproc_params] = "preproc_params",
  [sym_preproc_call] = "preproc_call",
  [sym_preproc_if] = "preproc_if",
  [sym_preproc_ifdef] = "preproc_ifdef",
  [sym_preproc_else] = "preproc_else",
  [sym_preproc_elif] = "preproc_elif",
  [sym_preproc_elifdef] = "preproc_elifdef",
  [sym_preproc_if_in_field_declaration_list] = "preproc_if",
  [sym_preproc_ifdef_in_field_declaration_list] = "preproc_ifdef",
  [sym_preproc_else_in_field_declaration_list] = "preproc_else",
  [sym_preproc_elif_in_field_declaration_list] = "preproc_elif",
  [sym_preproc_elifdef_in_field_declaration_list] = "preproc_elifdef",
  [sym_preproc_if_in_enumerator_list] = "preproc_if",
  [sym_preproc_ifdef_in_enumerator_list] = "preproc_ifdef",
  [sym_preproc_else_in_enumerator_list] = "preproc_else",
  [sym_preproc_elif_in_enumerator_list] = "preproc_elif",
  [sym_preproc_elifdef_in_enumerator_list] = "preproc_elifdef",
  [sym_preproc_if_in_enumerator_list_no_comma] = "preproc_if",
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = "preproc_ifdef",
  [sym_preproc_else_in_enumerator_list_no_comma] = "preproc_else",
  [sym_preproc_elif_in_enumerator_list_no_comma] = "preproc_elif",
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = "preproc_elifdef",
  [sym__preproc_expression] = "_preproc_expression",
  [sym_preproc_parenthesized_expression] = "parenthesized_expression",
  [sym_preproc_defined] = "preproc_defined",
  [sym_preproc_unary_expression] = "unary_expression",
  [sym_preproc_call_expression] = "call_expression",
  [sym_preproc_argument_list] = "argument_list",
  [sym_preproc_binary_expression] = "binary_expression",
  [sym_function_definition] = "function_definition",
  [sym_declaration] = "declaration",
  [sym_type_definition] = "type_definition",
  [sym__type_definition_type] = "_type_definition_type",
  [sym__type_definition_declarators] = "_type_definition_declarators",
  [sym__declaration_modifiers] = "_declaration_modifiers",
  [sym__declaration_specifiers] = "_declaration_specifiers",
  [sym_linkage_specification] = "linkage_specification",
  [sym_attribute_specifier] = "attribute_specifier",
  [sym_attribute] = "attribute",
  [sym_attribute_declaration] = "attribute_declaration",
  [sym_ms_declspec_modifier] = "ms_declspec_modifier",
  [sym_ms_based_modifier] = "ms_based_modifier",
  [sym_ms_call_modifier] = "ms_call_modifier",
  [sym_ms_unaligned_ptr_modifier] = "ms_unaligned_ptr_modifier",
  [sym_ms_pointer_modifier] = "ms_pointer_modifier",
  [sym_declaration_list] = "declaration_list",
  [sym__declarator] = "_declarator",
  [sym__field_declarator] = "_field_declarator",
  [sym__type_declarator] = "_type_declarator",
  [sym__abstract_declarator] = "_abstract_declarator",
  [sym_parenthesized_declarator] = "parenthesized_declarator",
  [sym_parenthesized_field_declarator] = "parenthesized_declarator",
  [sym_parenthesized_type_declarator] = "parenthesized_declarator",
  [sym_abstract_parenthesized_declarator] = "abstract_parenthesized_declarator",
  [sym_attributed_declarator] = "attributed_declarator",
  [sym_attributed_field_declarator] = "attributed_declarator",
  [sym_attributed_type_declarator] = "attributed_declarator",
  [sym_pointer_declarator] = "pointer_declarator",
  [sym_pointer_field_declarator] = "pointer_declarator",
  [sym_pointer_type_declarator] = "pointer_type_declarator",
  [sym_abstract_pointer_declarator] = "abstract_pointer_declarator",
  [sym_function_declarator] = "function_declarator",
  [sym_function_field_declarator] = "function_declarator",
  [sym_function_type_declarator] = "function_declarator",
  [sym_abstract_function_declarator] = "abstract_function_declarator",
  [sym_array_declarator] = "array_declarator",
  [sym_array_field_declarator] = "array_declarator",
  [sym_array_type_declarator] = "array_declarator",
  [sym_abstract_array_declarator] = "abstract_array_declarator",
  [sym_init_declarator] = "init_declarator",
  [sym_compound_statement] = "compound_statement",
  [sym_storage_class_specifier] = "storage_class_specifier",
  [sym_type_qualifier] = "type_qualifier",
  [sym_alignas_qualifier] = "alignas_qualifier",
  [sym_type_specifier] = "type_specifier",
  [sym_sized_type_specifier] = "sized_type_specifier",
  [sym_enum_specifier] = "enum_specifier",
  [sym_enumerator_list] = "enumerator_list",
  [sym_struct_specifier] = "struct_specifier",
  [sym_union_specifier] = "union_specifier",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym__field_declaration_list_item] = "_field_declaration_list_item",
  [sym_field_declaration] = "field_declaration",
  [sym_bitfield_clause] = "bitfield_clause",
  [sym_enumerator] = "enumerator",
  [sym_parameter_list] = "parameter_list",
  [sym_parameter_declaration] = "parameter_declaration",
  [sym_attributed_statement] = "attributed_statement",
  [sym_statement] = "statement",
  [sym__top_level_statement] = "_top_level_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym__top_level_expression_statement] = "expression_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_if_statement] = "if_statement",
  [sym_else_clause] = "else_clause",
  [sym_switch_statement] = "switch_statement",
  [sym_case_statement] = "case_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_for_statement] = "for_statement",
  [sym__for_statement_body] = "_for_statement_body",
  [sym_return_statement] = "return_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_goto_statement] = "goto_statement",
  [sym_seh_try_statement] = "seh_try_statement",
  [sym_seh_except_clause] = "seh_except_clause",
  [sym_seh_finally_clause] = "seh_finally_clause",
  [sym_seh_leave_statement] = "seh_leave_statement",
  [sym_expression] = "expression",
  [sym__string] = "_string",
  [sym_comma_expression] = "comma_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_pointer_expression] = "pointer_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_update_expression] = "update_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_type_descriptor] = "type_descriptor",
  [sym_sizeof_expression] = "sizeof_expression",
  [sym_alignof_expression] = "alignof_expression",
  [sym_offsetof_expression] = "offsetof_expression",
  [sym_generic_expression] = "generic_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_call_expression] = "call_expression",
  [sym_gnu_asm_expression] = "gnu_asm_expression",
  [sym_gnu_asm_qualifier] = "gnu_asm_qualifier",
  [sym_gnu_asm_output_operand_list] = "gnu_asm_output_operand_list",
  [sym_gnu_asm_output_operand] = "gnu_asm_output_operand",
  [sym_gnu_asm_input_operand_list] = "gnu_asm_input_operand_list",
  [sym_gnu_asm_input_operand] = "gnu_asm_input_operand",
  [sym_gnu_asm_clobber_list] = "gnu_asm_clobber_list",
  [sym_gnu_asm_goto_list] = "gnu_asm_goto_list",
  [sym_argument_list] = "argument_list",
  [sym_field_expression] = "field_expression",
  [sym_compound_literal_expression] = "compound_literal_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_initializer_list] = "initializer_list",
  [sym_initializer_pair] = "initializer_pair",
  [sym_subscript_designator] = "subscript_designator",
  [sym_subscript_range_designator] = "subscript_range_designator",
  [sym_field_designator] = "field_designator",
  [sym_char_literal] = "char_literal",
  [sym_concatenated_string] = "concatenated_string",
  [sym_string_literal] = "string_literal",
  [sym_null] = "null",
  [sym__empty_declaration] = "_empty_declaration",
  [sym_placeholder_type_specifier] = "placeholder_type_specifier",
  [sym_decltype_auto] = "decltype",
  [sym_decltype] = "decltype",
  [sym__class_declaration] = "_class_declaration",
  [sym__class_declaration_item] = "_class_declaration_item",
  [sym_class_specifier] = "class_specifier",
  [sym__class_name] = "_class_name",
  [sym_virtual_specifier] = "virtual_specifier",
  [sym_explicit_function_specifier] = "explicit_function_specifier",
  [sym_base_class_clause] = "base_class_clause",
  [sym__enum_base_clause] = "_enum_base_clause",
  [sym_dependent_type] = "dependent_type",
  [sym_template_declaration] = "template_declaration",
  [sym_template_instantiation] = "template_instantiation",
  [sym_template_parameter_list] = "template_parameter_list",
  [sym_type_parameter_declaration] = "type_parameter_declaration",
  [sym_variadic_type_parameter_declaration] = "variadic_type_parameter_declaration",
  [sym_optional_type_parameter_declaration] = "optional_type_parameter_declaration",
  [sym_template_template_parameter_declaration] = "template_template_parameter_declaration",
  [sym_optional_parameter_declaration] = "optional_parameter_declaration",
  [sym_variadic_parameter_declaration] = "variadic_parameter_declaration",
  [sym_variadic_declarator] = "variadic_declarator",
  [sym_variadic_reference_declarator] = "reference_declarator",
  [sym_operator_cast] = "operator_cast",
  [sym_field_initializer_list] = "field_initializer_list",
  [sym_field_initializer] = "field_initializer",
  [sym_inline_method_definition] = "function_definition",
  [sym__constructor_specifiers] = "_constructor_specifiers",
  [sym_operator_cast_definition] = "function_definition",
  [sym_operator_cast_declaration] = "declaration",
  [sym_constructor_try_statement] = "try_statement",
  [sym_constructor_or_destructor_definition] = "function_definition",
  [sym_constructor_or_destructor_declaration] = "declaration",
  [sym_default_method_clause] = "default_method_clause",
  [sym_delete_method_clause] = "delete_method_clause",
  [sym_pure_virtual_clause] = "pure_virtual_clause",
  [sym_friend_declaration] = "friend_declaration",
  [sym_access_specifier] = "access_specifier",
  [sym_reference_declarator] = "reference_declarator",
  [sym_reference_field_declarator] = "reference_declarator",
  [sym_reference_type_declarator] = "reference_declarator",
  [sym_abstract_reference_declarator] = "abstract_reference_declarator",
  [sym_structured_binding_declarator] = "structured_binding_declarator",
  [sym_ref_qualifier] = "ref_qualifier",
  [sym__function_declarator_seq] = "_function_declarator_seq",
  [sym__function_attributes_start] = "_function_attributes_start",
  [sym__function_exception_specification] = "_function_exception_specification",
  [sym__function_attributes_end] = "_function_attributes_end",
  [sym__function_postfix] = "_function_postfix",
  [sym_trailing_return_type] = "trailing_return_type",
  [sym_noexcept] = "noexcept",
  [sym_throw_specifier] = "throw_specifier",
  [sym_template_type] = "template_type",
  [sym_template_method] = "template_method",
  [sym_template_function] = "template_function",
  [sym_template_argument_list] = "template_argument_list",
  [sym_namespace_definition] = "namespace_definition",
  [sym_namespace_alias_definition] = "namespace_alias_definition",
  [sym__namespace_specifier] = "_namespace_specifier",
  [sym_nested_namespace_specifier] = "nested_namespace_specifier",
  [sym_using_declaration] = "using_declaration",
  [sym_alias_declaration] = "alias_declaration",
  [sym_static_assert_declaration] = "static_assert_declaration",
  [sym_concept_definition] = "concept_definition",
  [sym_for_range_loop] = "for_range_loop",
  [sym__for_range_loop_body] = "_for_range_loop_body",
  [sym_init_statement] = "init_statement",
  [sym_condition_clause] = "condition_clause",
  [sym_condition_declaration] = "declaration",
  [sym_co_return_statement] = "co_return_statement",
  [sym_co_yield_statement] = "co_yield_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_raw_string_literal] = "raw_string_literal",
  [sym_subscript_argument_list] = "subscript_argument_list",
  [sym_co_await_expression] = "co_await_expression",
  [sym_new_expression] = "new_expression",
  [sym_new_declarator] = "new_declarator",
  [sym_delete_expression] = "delete_expression",
  [sym_type_requirement] = "type_requirement",
  [sym_compound_requirement] = "compound_requirement",
  [sym__requirement] = "_requirement",
  [sym_requirement_seq] = "requirement_seq",
  [sym_constraint_conjunction] = "constraint_conjunction",
  [sym_constraint_disjunction] = "constraint_disjunction",
  [sym__requirement_clause_constraint] = "_requirement_clause_constraint",
  [sym_requires_clause] = "requires_clause",
  [sym_requires_parameter_list] = "parameter_list",
  [sym_requires_expression] = "requires_expression",
  [sym_lambda_expression] = "lambda_expression",
  [sym_lambda_capture_specifier] = "lambda_capture_specifier",
  [sym_lambda_default_capture] = "lambda_default_capture",
  [sym__fold_operator] = "_fold_operator",
  [sym__binary_fold_operator] = "_binary_fold_operator",
  [sym__unary_left_fold] = "_unary_left_fold",
  [sym__unary_right_fold] = "_unary_right_fold",
  [sym__binary_fold] = "_binary_fold",
  [sym_fold_expression] = "fold_expression",
  [sym_parameter_pack_expansion] = "parameter_pack_expansion",
  [sym_type_parameter_pack_expansion] = "parameter_pack_expansion",
  [sym_destructor_name] = "destructor_name",
  [sym_dependent_identifier] = "dependent_name",
  [sym_dependent_field_identifier] = "dependent_name",
  [sym_dependent_type_identifier] = "dependent_name",
  [sym__scope_resolution] = "_scope_resolution",
  [sym_qualified_field_identifier] = "qualified_identifier",
  [sym_qualified_identifier] = "qualified_identifier",
  [sym_qualified_type_identifier] = "qualified_identifier",
  [sym_qualified_operator_cast_identifier] = "qualified_identifier",
  [sym__assignment_expression_lhs] = "assignment_expression",
  [sym_operator_name] = "operator_name",
  [sym_user_defined_literal] = "user_defined_literal",
  [sym_kernel_call_expression] = "call_expression",
  [sym_kernel_call_syntax] = "kernel_call_syntax",
  [sym_launch_bounds] = "launch_bounds",
  [aux_sym_translation_unit_repeat1] = "translation_unit_repeat1",
  [aux_sym_preproc_params_repeat1] = "preproc_params_repeat1",
  [aux_sym_preproc_if_repeat1] = "preproc_if_repeat1",
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = "preproc_if_in_field_declaration_list_repeat1",
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = "preproc_if_in_enumerator_list_repeat1",
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = "preproc_if_in_enumerator_list_no_comma_repeat1",
  [aux_sym_preproc_argument_list_repeat1] = "preproc_argument_list_repeat1",
  [aux_sym_declaration_repeat1] = "declaration_repeat1",
  [aux_sym_type_definition_repeat1] = "type_definition_repeat1",
  [aux_sym__type_definition_type_repeat1] = "_type_definition_type_repeat1",
  [aux_sym__type_definition_declarators_repeat1] = "_type_definition_declarators_repeat1",
  [aux_sym__declaration_specifiers_repeat1] = "_declaration_specifiers_repeat1",
  [aux_sym_attribute_declaration_repeat1] = "attribute_declaration_repeat1",
  [aux_sym_attributed_declarator_repeat1] = "attributed_declarator_repeat1",
  [aux_sym_pointer_declarator_repeat1] = "pointer_declarator_repeat1",
  [aux_sym_array_declarator_repeat1] = "array_declarator_repeat1",
  [aux_sym_sized_type_specifier_repeat1] = "sized_type_specifier_repeat1",
  [aux_sym_enumerator_list_repeat1] = "enumerator_list_repeat1",
  [aux_sym_field_declaration_repeat1] = "field_declaration_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_generic_expression_repeat1] = "generic_expression_repeat1",
  [aux_sym_gnu_asm_expression_repeat1] = "gnu_asm_expression_repeat1",
  [aux_sym_gnu_asm_output_operand_list_repeat1] = "gnu_asm_output_operand_list_repeat1",
  [aux_sym_gnu_asm_input_operand_list_repeat1] = "gnu_asm_input_operand_list_repeat1",
  [aux_sym_gnu_asm_clobber_list_repeat1] = "gnu_asm_clobber_list_repeat1",
  [aux_sym_gnu_asm_goto_list_repeat1] = "gnu_asm_goto_list_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_initializer_list_repeat1] = "initializer_list_repeat1",
  [aux_sym_initializer_pair_repeat1] = "initializer_pair_repeat1",
  [aux_sym_char_literal_repeat1] = "char_literal_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [aux_sym__class_declaration_repeat1] = "_class_declaration_repeat1",
  [aux_sym_base_class_clause_repeat1] = "base_class_clause_repeat1",
  [aux_sym_template_parameter_list_repeat1] = "template_parameter_list_repeat1",
  [aux_sym_field_initializer_list_repeat1] = "field_initializer_list_repeat1",
  [aux_sym_operator_cast_definition_repeat1] = "operator_cast_definition_repeat1",
  [aux_sym_constructor_try_statement_repeat1] = "constructor_try_statement_repeat1",
  [aux_sym_structured_binding_declarator_repeat1] = "structured_binding_declarator_repeat1",
  [aux_sym__function_postfix_repeat1] = "_function_postfix_repeat1",
  [aux_sym_throw_specifier_repeat1] = "throw_specifier_repeat1",
  [aux_sym_template_argument_list_repeat1] = "template_argument_list_repeat1",
  [aux_sym_subscript_argument_list_repeat1] = "subscript_argument_list_repeat1",
  [aux_sym_requirement_seq_repeat1] = "requirement_seq_repeat1",
  [aux_sym_requires_parameter_list_repeat1] = "requires_parameter_list_repeat1",
  [aux_sym_lambda_capture_specifier_repeat1] = "lambda_capture_specifier_repeat1",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_namespace_identifier] = "namespace_identifier",
  [alias_sym_simple_requirement] = "simple_requirement",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [aux_sym_preproc_include_token1] = aux_sym_preproc_include_token1,
  [aux_sym_preproc_include_token2] = aux_sym_preproc_include_token2,
  [aux_sym_preproc_def_token1] = aux_sym_preproc_def_token1,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [aux_sym_preproc_if_token1] = aux_sym_preproc_if_token1,
  [anon_sym_LF] = anon_sym_LF,
  [aux_sym_preproc_if_token2] = aux_sym_preproc_if_token2,
  [aux_sym_preproc_ifdef_token1] = aux_sym_preproc_ifdef_token1,
  [aux_sym_preproc_ifdef_token2] = aux_sym_preproc_ifdef_token2,
  [aux_sym_preproc_else_token1] = aux_sym_preproc_else_token1,
  [aux_sym_preproc_elif_token1] = aux_sym_preproc_elif_token1,
  [aux_sym_preproc_elifdef_token1] = aux_sym_preproc_elifdef_token1,
  [aux_sym_preproc_elifdef_token2] = aux_sym_preproc_elifdef_token2,
  [sym_preproc_arg] = sym_preproc_arg,
  [sym_preproc_directive] = sym_preproc_directive,
  [anon_sym_LPAREN2] = anon_sym_LPAREN,
  [anon_sym_defined] = anon_sym_defined,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym___extension__] = anon_sym___extension__,
  [anon_sym_typedef] = anon_sym_typedef,
  [anon_sym___device__] = anon_sym___device__,
  [anon_sym___host__] = anon_sym___host__,
  [anon_sym___global__] = anon_sym___global__,
  [anon_sym___forceinline__] = anon_sym___forceinline__,
  [anon_sym___noinline__] = anon_sym___noinline__,
  [anon_sym_extern] = anon_sym_extern,
  [anon_sym___attribute__] = anon_sym___attribute__,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_LBRACK_LBRACK] = anon_sym_LBRACK_LBRACK,
  [anon_sym_RBRACK_RBRACK] = anon_sym_RBRACK_RBRACK,
  [anon_sym___declspec] = anon_sym___declspec,
  [anon_sym___based] = anon_sym___based,
  [anon_sym___cdecl] = anon_sym___cdecl,
  [anon_sym___clrcall] = anon_sym___clrcall,
  [anon_sym___stdcall] = anon_sym___stdcall,
  [anon_sym___fastcall] = anon_sym___fastcall,
  [anon_sym___thiscall] = anon_sym___thiscall,
  [anon_sym___vectorcall] = anon_sym___vectorcall,
  [sym_ms_restrict_modifier] = sym_ms_restrict_modifier,
  [sym_ms_unsigned_ptr_modifier] = sym_ms_unsigned_ptr_modifier,
  [sym_ms_signed_ptr_modifier] = sym_ms_signed_ptr_modifier,
  [anon_sym__unaligned] = anon_sym__unaligned,
  [anon_sym___unaligned] = anon_sym___unaligned,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_signed] = anon_sym_signed,
  [anon_sym_unsigned] = anon_sym_unsigned,
  [anon_sym_long] = anon_sym_long,
  [anon_sym_short] = anon_sym_short,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_register] = anon_sym_register,
  [anon_sym_inline] = anon_sym_inline,
  [anon_sym___inline] = anon_sym___inline,
  [anon_sym___inline__] = anon_sym___inline__,
  [anon_sym___forceinline] = anon_sym___forceinline,
  [anon_sym_thread_local] = anon_sym_thread_local,
  [anon_sym___thread] = anon_sym___thread,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_constexpr] = anon_sym_constexpr,
  [anon_sym_volatile] = anon_sym_volatile,
  [anon_sym_restrict] = anon_sym_restrict,
  [anon_sym___restrict__] = anon_sym___restrict__,
  [anon_sym__Atomic] = anon_sym__Atomic,
  [anon_sym__Noreturn] = anon_sym__Noreturn,
  [anon_sym_noreturn] = anon_sym_noreturn,
  [anon_sym_mutable] = anon_sym_mutable,
  [anon_sym_constinit] = anon_sym_constinit,
  [anon_sym_consteval] = anon_sym_consteval,
  [anon_sym___shared__] = anon_sym___shared__,
  [anon_sym___local__] = anon_sym___local__,
  [anon_sym___constant__] = anon_sym___constant__,
  [anon_sym___managed__] = anon_sym___managed__,
  [anon_sym___grid_constant__] = anon_sym___grid_constant__,
  [anon_sym_alignas] = anon_sym_alignas,
  [anon_sym__Alignas] = anon_sym__Alignas,
  [sym_primitive_type] = sym_primitive_type,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_union] = anon_sym_union,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym___try] = anon_sym___try,
  [anon_sym___except] = anon_sym___except,
  [anon_sym___finally] = anon_sym___finally,
  [anon_sym___leave] = anon_sym___leave,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_and_eq] = anon_sym_and_eq,
  [anon_sym_or_eq] = anon_sym_or_eq,
  [anon_sym_xor_eq] = anon_sym_xor_eq,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_compl] = anon_sym_compl,
  [anon_sym_LT_EQ_GT] = anon_sym_LT_EQ_GT,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_bitor] = anon_sym_bitor,
  [anon_sym_xor] = anon_sym_xor,
  [anon_sym_bitand] = anon_sym_bitand,
  [anon_sym_not_eq] = anon_sym_not_eq,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_sizeof] = anon_sym_sizeof,
  [anon_sym___alignof__] = anon_sym___alignof__,
  [anon_sym___alignof] = anon_sym___alignof,
  [anon_sym__alignof] = anon_sym__alignof,
  [anon_sym_alignof] = anon_sym_alignof,
  [anon_sym__Alignof] = anon_sym__Alignof,
  [anon_sym_offsetof] = anon_sym_offsetof,
  [anon_sym__Generic] = anon_sym__Generic,
  [anon_sym_asm] = anon_sym_asm,
  [anon_sym___asm__] = anon_sym___asm__,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_DOT_STAR] = anon_sym_DOT_STAR,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [sym_number_literal] = sym_number_literal,
  [anon_sym_L_SQUOTE] = anon_sym_L_SQUOTE,
  [anon_sym_u_SQUOTE] = anon_sym_u_SQUOTE,
  [anon_sym_U_SQUOTE] = anon_sym_U_SQUOTE,
  [anon_sym_u8_SQUOTE] = anon_sym_u8_SQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_char_literal_token1] = aux_sym_char_literal_token1,
  [anon_sym_L_DQUOTE] = anon_sym_L_DQUOTE,
  [anon_sym_u_DQUOTE] = anon_sym_u_DQUOTE,
  [anon_sym_U_DQUOTE] = anon_sym_U_DQUOTE,
  [anon_sym_u8_DQUOTE] = anon_sym_u8_DQUOTE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_literal_token1] = aux_sym_string_literal_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_system_lib_string] = sym_system_lib_string,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [anon_sym_NULL] = anon_sym_NULL,
  [anon_sym_nullptr] = anon_sym_nullptr,
  [sym_comment] = sym_comment,
  [sym_auto] = sym_auto,
  [anon_sym_decltype] = anon_sym_decltype,
  [anon_sym_final] = anon_sym_final,
  [anon_sym_override] = anon_sym_override,
  [sym_virtual] = sym_virtual,
  [anon_sym_explicit] = anon_sym_explicit,
  [anon_sym_typename] = anon_sym_typename,
  [anon_sym_template] = anon_sym_template,
  [anon_sym_GT2] = anon_sym_GT,
  [anon_sym_operator] = anon_sym_operator,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_0] = anon_sym_0,
  [anon_sym_friend] = anon_sym_friend,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_noexcept] = anon_sym_noexcept,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_static_assert] = anon_sym_static_assert,
  [anon_sym_concept] = anon_sym_concept,
  [anon_sym_co_return] = anon_sym_co_return,
  [anon_sym_co_yield] = anon_sym_co_yield,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_R_DQUOTE] = anon_sym_R_DQUOTE,
  [anon_sym_LR_DQUOTE] = anon_sym_LR_DQUOTE,
  [anon_sym_uR_DQUOTE] = anon_sym_uR_DQUOTE,
  [anon_sym_UR_DQUOTE] = anon_sym_UR_DQUOTE,
  [anon_sym_u8R_DQUOTE] = anon_sym_u8R_DQUOTE,
  [anon_sym_co_await] = anon_sym_co_await,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_requires] = anon_sym_requires,
  [anon_sym_DASH_GT_STAR] = anon_sym_DASH_GT_STAR,
  [anon_sym_LPAREN_RPAREN] = anon_sym_LPAREN_RPAREN,
  [anon_sym_LBRACK_RBRACK] = anon_sym_LBRACK_RBRACK,
  [anon_sym_DQUOTE_DQUOTE] = anon_sym_DQUOTE_DQUOTE,
  [sym_this] = sym_this,
  [sym_literal_suffix] = sym_literal_suffix,
  [aux_sym_kernel_call_syntax_token1] = aux_sym_kernel_call_syntax_token1,
  [aux_sym_kernel_call_syntax_token2] = aux_sym_kernel_call_syntax_token2,
  [anon_sym___launch_bounds__] = anon_sym___launch_bounds__,
  [sym_raw_string_delimiter] = sym_raw_string_delimiter,
  [sym_raw_string_content] = sym_raw_string_content,
  [sym_translation_unit] = sym_translation_unit,
  [sym__top_level_item] = sym__top_level_item,
  [sym__block_item] = sym__block_item,
  [sym_preproc_include] = sym_preproc_include,
  [sym_preproc_def] = sym_preproc_def,
  [sym_preproc_function_def] = sym_preproc_function_def,
  [sym_preproc_params] = sym_preproc_params,
  [sym_preproc_call] = sym_preproc_call,
  [sym_preproc_if] = sym_preproc_if,
  [sym_preproc_ifdef] = sym_preproc_ifdef,
  [sym_preproc_else] = sym_preproc_else,
  [sym_preproc_elif] = sym_preproc_elif,
  [sym_preproc_elifdef] = sym_preproc_elifdef,
  [sym_preproc_if_in_field_declaration_list] = sym_preproc_if,
  [sym_preproc_ifdef_in_field_declaration_list] = sym_preproc_ifdef,
  [sym_preproc_else_in_field_declaration_list] = sym_preproc_else,
  [sym_preproc_elif_in_field_declaration_list] = sym_preproc_elif,
  [sym_preproc_elifdef_in_field_declaration_list] = sym_preproc_elifdef,
  [sym_preproc_if_in_enumerator_list] = sym_preproc_if,
  [sym_preproc_ifdef_in_enumerator_list] = sym_preproc_ifdef,
  [sym_preproc_else_in_enumerator_list] = sym_preproc_else,
  [sym_preproc_elif_in_enumerator_list] = sym_preproc_elif,
  [sym_preproc_elifdef_in_enumerator_list] = sym_preproc_elifdef,
  [sym_preproc_if_in_enumerator_list_no_comma] = sym_preproc_if,
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = sym_preproc_ifdef,
  [sym_preproc_else_in_enumerator_list_no_comma] = sym_preproc_else,
  [sym_preproc_elif_in_enumerator_list_no_comma] = sym_preproc_elif,
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = sym_preproc_elifdef,
  [sym__preproc_expression] = sym__preproc_expression,
  [sym_preproc_parenthesized_expression] = sym_parenthesized_expression,
  [sym_preproc_defined] = sym_preproc_defined,
  [sym_preproc_unary_expression] = sym_unary_expression,
  [sym_preproc_call_expression] = sym_call_expression,
  [sym_preproc_argument_list] = sym_argument_list,
  [sym_preproc_binary_expression] = sym_binary_expression,
  [sym_function_definition] = sym_function_definition,
  [sym_declaration] = sym_declaration,
  [sym_type_definition] = sym_type_definition,
  [sym__type_definition_type] = sym__type_definition_type,
  [sym__type_definition_declarators] = sym__type_definition_declarators,
  [sym__declaration_modifiers] = sym__declaration_modifiers,
  [sym__declaration_specifiers] = sym__declaration_specifiers,
  [sym_linkage_specification] = sym_linkage_specification,
  [sym_attribute_specifier] = sym_attribute_specifier,
  [sym_attribute] = sym_attribute,
  [sym_attribute_declaration] = sym_attribute_declaration,
  [sym_ms_declspec_modifier] = sym_ms_declspec_modifier,
  [sym_ms_based_modifier] = sym_ms_based_modifier,
  [sym_ms_call_modifier] = sym_ms_call_modifier,
  [sym_ms_unaligned_ptr_modifier] = sym_ms_unaligned_ptr_modifier,
  [sym_ms_pointer_modifier] = sym_ms_pointer_modifier,
  [sym_declaration_list] = sym_declaration_list,
  [sym__declarator] = sym__declarator,
  [sym__field_declarator] = sym__field_declarator,
  [sym__type_declarator] = sym__type_declarator,
  [sym__abstract_declarator] = sym__abstract_declarator,
  [sym_parenthesized_declarator] = sym_parenthesized_declarator,
  [sym_parenthesized_field_declarator] = sym_parenthesized_declarator,
  [sym_parenthesized_type_declarator] = sym_parenthesized_declarator,
  [sym_abstract_parenthesized_declarator] = sym_abstract_parenthesized_declarator,
  [sym_attributed_declarator] = sym_attributed_declarator,
  [sym_attributed_field_declarator] = sym_attributed_declarator,
  [sym_attributed_type_declarator] = sym_attributed_declarator,
  [sym_pointer_declarator] = sym_pointer_declarator,
  [sym_pointer_field_declarator] = sym_pointer_declarator,
  [sym_pointer_type_declarator] = sym_pointer_type_declarator,
  [sym_abstract_pointer_declarator] = sym_abstract_pointer_declarator,
  [sym_function_declarator] = sym_function_declarator,
  [sym_function_field_declarator] = sym_function_declarator,
  [sym_function_type_declarator] = sym_function_declarator,
  [sym_abstract_function_declarator] = sym_abstract_function_declarator,
  [sym_array_declarator] = sym_array_declarator,
  [sym_array_field_declarator] = sym_array_declarator,
  [sym_array_type_declarator] = sym_array_declarator,
  [sym_abstract_array_declarator] = sym_abstract_array_declarator,
  [sym_init_declarator] = sym_init_declarator,
  [sym_compound_statement] = sym_compound_statement,
  [sym_storage_class_specifier] = sym_storage_class_specifier,
  [sym_type_qualifier] = sym_type_qualifier,
  [sym_alignas_qualifier] = sym_alignas_qualifier,
  [sym_type_specifier] = sym_type_specifier,
  [sym_sized_type_specifier] = sym_sized_type_specifier,
  [sym_enum_specifier] = sym_enum_specifier,
  [sym_enumerator_list] = sym_enumerator_list,
  [sym_struct_specifier] = sym_struct_specifier,
  [sym_union_specifier] = sym_union_specifier,
  [sym_field_declaration_list] = sym_field_declaration_list,
  [sym__field_declaration_list_item] = sym__field_declaration_list_item,
  [sym_field_declaration] = sym_field_declaration,
  [sym_bitfield_clause] = sym_bitfield_clause,
  [sym_enumerator] = sym_enumerator,
  [sym_parameter_list] = sym_parameter_list,
  [sym_parameter_declaration] = sym_parameter_declaration,
  [sym_attributed_statement] = sym_attributed_statement,
  [sym_statement] = sym_statement,
  [sym__top_level_statement] = sym__top_level_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym__top_level_expression_statement] = sym_expression_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_else_clause] = sym_else_clause,
  [sym_switch_statement] = sym_switch_statement,
  [sym_case_statement] = sym_case_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_for_statement] = sym_for_statement,
  [sym__for_statement_body] = sym__for_statement_body,
  [sym_return_statement] = sym_return_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_goto_statement] = sym_goto_statement,
  [sym_seh_try_statement] = sym_seh_try_statement,
  [sym_seh_except_clause] = sym_seh_except_clause,
  [sym_seh_finally_clause] = sym_seh_finally_clause,
  [sym_seh_leave_statement] = sym_seh_leave_statement,
  [sym_expression] = sym_expression,
  [sym__string] = sym__string,
  [sym_comma_expression] = sym_comma_expression,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_pointer_expression] = sym_pointer_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_type_descriptor] = sym_type_descriptor,
  [sym_sizeof_expression] = sym_sizeof_expression,
  [sym_alignof_expression] = sym_alignof_expression,
  [sym_offsetof_expression] = sym_offsetof_expression,
  [sym_generic_expression] = sym_generic_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_gnu_asm_expression] = sym_gnu_asm_expression,
  [sym_gnu_asm_qualifier] = sym_gnu_asm_qualifier,
  [sym_gnu_asm_output_operand_list] = sym_gnu_asm_output_operand_list,
  [sym_gnu_asm_output_operand] = sym_gnu_asm_output_operand,
  [sym_gnu_asm_input_operand_list] = sym_gnu_asm_input_operand_list,
  [sym_gnu_asm_input_operand] = sym_gnu_asm_input_operand,
  [sym_gnu_asm_clobber_list] = sym_gnu_asm_clobber_list,
  [sym_gnu_asm_goto_list] = sym_gnu_asm_goto_list,
  [sym_argument_list] = sym_argument_list,
  [sym_field_expression] = sym_field_expression,
  [sym_compound_literal_expression] = sym_compound_literal_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_initializer_list] = sym_initializer_list,
  [sym_initializer_pair] = sym_initializer_pair,
  [sym_subscript_designator] = sym_subscript_designator,
  [sym_subscript_range_designator] = sym_subscript_range_designator,
  [sym_field_designator] = sym_field_designator,
  [sym_char_literal] = sym_char_literal,
  [sym_concatenated_string] = sym_concatenated_string,
  [sym_string_literal] = sym_string_literal,
  [sym_null] = sym_null,
  [sym__empty_declaration] = sym__empty_declaration,
  [sym_placeholder_type_specifier] = sym_placeholder_type_specifier,
  [sym_decltype_auto] = sym_decltype,
  [sym_decltype] = sym_decltype,
  [sym__class_declaration] = sym__class_declaration,
  [sym__class_declaration_item] = sym__class_declaration_item,
  [sym_class_specifier] = sym_class_specifier,
  [sym__class_name] = sym__class_name,
  [sym_virtual_specifier] = sym_virtual_specifier,
  [sym_explicit_function_specifier] = sym_explicit_function_specifier,
  [sym_base_class_clause] = sym_base_class_clause,
  [sym__enum_base_clause] = sym__enum_base_clause,
  [sym_dependent_type] = sym_dependent_type,
  [sym_template_declaration] = sym_template_declaration,
  [sym_template_instantiation] = sym_template_instantiation,
  [sym_template_parameter_list] = sym_template_parameter_list,
  [sym_type_parameter_declaration] = sym_type_parameter_declaration,
  [sym_variadic_type_parameter_declaration] = sym_variadic_type_parameter_declaration,
  [sym_optional_type_parameter_declaration] = sym_optional_type_parameter_declaration,
  [sym_template_template_parameter_declaration] = sym_template_template_parameter_declaration,
  [sym_optional_parameter_declaration] = sym_optional_parameter_declaration,
  [sym_variadic_parameter_declaration] = sym_variadic_parameter_declaration,
  [sym_variadic_declarator] = sym_variadic_declarator,
  [sym_variadic_reference_declarator] = sym_reference_declarator,
  [sym_operator_cast] = sym_operator_cast,
  [sym_field_initializer_list] = sym_field_initializer_list,
  [sym_field_initializer] = sym_field_initializer,
  [sym_inline_method_definition] = sym_function_definition,
  [sym__constructor_specifiers] = sym__constructor_specifiers,
  [sym_operator_cast_definition] = sym_function_definition,
  [sym_operator_cast_declaration] = sym_declaration,
  [sym_constructor_try_statement] = sym_try_statement,
  [sym_constructor_or_destructor_definition] = sym_function_definition,
  [sym_constructor_or_destructor_declaration] = sym_declaration,
  [sym_default_method_clause] = sym_default_method_clause,
  [sym_delete_method_clause] = sym_delete_method_clause,
  [sym_pure_virtual_clause] = sym_pure_virtual_clause,
  [sym_friend_declaration] = sym_friend_declaration,
  [sym_access_specifier] = sym_access_specifier,
  [sym_reference_declarator] = sym_reference_declarator,
  [sym_reference_field_declarator] = sym_reference_declarator,
  [sym_reference_type_declarator] = sym_reference_declarator,
  [sym_abstract_reference_declarator] = sym_abstract_reference_declarator,
  [sym_structured_binding_declarator] = sym_structured_binding_declarator,
  [sym_ref_qualifier] = sym_ref_qualifier,
  [sym__function_declarator_seq] = sym__function_declarator_seq,
  [sym__function_attributes_start] = sym__function_attributes_start,
  [sym__function_exception_specification] = sym__function_exception_specification,
  [sym__function_attributes_end] = sym__function_attributes_end,
  [sym__function_postfix] = sym__function_postfix,
  [sym_trailing_return_type] = sym_trailing_return_type,
  [sym_noexcept] = sym_noexcept,
  [sym_throw_specifier] = sym_throw_specifier,
  [sym_template_type] = sym_template_type,
  [sym_template_method] = sym_template_method,
  [sym_template_function] = sym_template_function,
  [sym_template_argument_list] = sym_template_argument_list,
  [sym_namespace_definition] = sym_namespace_definition,
  [sym_namespace_alias_definition] = sym_namespace_alias_definition,
  [sym__namespace_specifier] = sym__namespace_specifier,
  [sym_nested_namespace_specifier] = sym_nested_namespace_specifier,
  [sym_using_declaration] = sym_using_declaration,
  [sym_alias_declaration] = sym_alias_declaration,
  [sym_static_assert_declaration] = sym_static_assert_declaration,
  [sym_concept_definition] = sym_concept_definition,
  [sym_for_range_loop] = sym_for_range_loop,
  [sym__for_range_loop_body] = sym__for_range_loop_body,
  [sym_init_statement] = sym_init_statement,
  [sym_condition_clause] = sym_condition_clause,
  [sym_condition_declaration] = sym_declaration,
  [sym_co_return_statement] = sym_co_return_statement,
  [sym_co_yield_statement] = sym_co_yield_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_raw_string_literal] = sym_raw_string_literal,
  [sym_subscript_argument_list] = sym_subscript_argument_list,
  [sym_co_await_expression] = sym_co_await_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_new_declarator] = sym_new_declarator,
  [sym_delete_expression] = sym_delete_expression,
  [sym_type_requirement] = sym_type_requirement,
  [sym_compound_requirement] = sym_compound_requirement,
  [sym__requirement] = sym__requirement,
  [sym_requirement_seq] = sym_requirement_seq,
  [sym_constraint_conjunction] = sym_constraint_conjunction,
  [sym_constraint_disjunction] = sym_constraint_disjunction,
  [sym__requirement_clause_constraint] = sym__requirement_clause_constraint,
  [sym_requires_clause] = sym_requires_clause,
  [sym_requires_parameter_list] = sym_parameter_list,
  [sym_requires_expression] = sym_requires_expression,
  [sym_lambda_expression] = sym_lambda_expression,
  [sym_lambda_capture_specifier] = sym_lambda_capture_specifier,
  [sym_lambda_default_capture] = sym_lambda_default_capture,
  [sym__fold_operator] = sym__fold_operator,
  [sym__binary_fold_operator] = sym__binary_fold_operator,
  [sym__unary_left_fold] = sym__unary_left_fold,
  [sym__unary_right_fold] = sym__unary_right_fold,
  [sym__binary_fold] = sym__binary_fold,
  [sym_fold_expression] = sym_fold_expression,
  [sym_parameter_pack_expansion] = sym_parameter_pack_expansion,
  [sym_type_parameter_pack_expansion] = sym_parameter_pack_expansion,
  [sym_destructor_name] = sym_destructor_name,
  [sym_dependent_identifier] = sym_dependent_identifier,
  [sym_dependent_field_identifier] = sym_dependent_identifier,
  [sym_dependent_type_identifier] = sym_dependent_identifier,
  [sym__scope_resolution] = sym__scope_resolution,
  [sym_qualified_field_identifier] = sym_qualified_identifier,
  [sym_qualified_identifier] = sym_qualified_identifier,
  [sym_qualified_type_identifier] = sym_qualified_identifier,
  [sym_qualified_operator_cast_identifier] = sym_qualified_identifier,
  [sym__assignment_expression_lhs] = sym_assignment_expression,
  [sym_operator_name] = sym_operator_name,
  [sym_user_defined_literal] = sym_user_defined_literal,
  [sym_kernel_call_expression] = sym_call_expression,
  [sym_kernel_call_syntax] = sym_kernel_call_syntax,
  [sym_launch_bounds] = sym_launch_bounds,
  [aux_sym_translation_unit_repeat1] = aux_sym_translation_unit_repeat1,
  [aux_sym_preproc_params_repeat1] = aux_sym_preproc_params_repeat1,
  [aux_sym_preproc_if_repeat1] = aux_sym_preproc_if_repeat1,
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = aux_sym_preproc_if_in_enumerator_list_repeat1,
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [aux_sym_preproc_argument_list_repeat1] = aux_sym_preproc_argument_list_repeat1,
  [aux_sym_declaration_repeat1] = aux_sym_declaration_repeat1,
  [aux_sym_type_definition_repeat1] = aux_sym_type_definition_repeat1,
  [aux_sym__type_definition_type_repeat1] = aux_sym__type_definition_type_repeat1,
  [aux_sym__type_definition_declarators_repeat1] = aux_sym__type_definition_declarators_repeat1,
  [aux_sym__declaration_specifiers_repeat1] = aux_sym__declaration_specifiers_repeat1,
  [aux_sym_attribute_declaration_repeat1] = aux_sym_attribute_declaration_repeat1,
  [aux_sym_attributed_declarator_repeat1] = aux_sym_attributed_declarator_repeat1,
  [aux_sym_pointer_declarator_repeat1] = aux_sym_pointer_declarator_repeat1,
  [aux_sym_array_declarator_repeat1] = aux_sym_array_declarator_repeat1,
  [aux_sym_sized_type_specifier_repeat1] = aux_sym_sized_type_specifier_repeat1,
  [aux_sym_enumerator_list_repeat1] = aux_sym_enumerator_list_repeat1,
  [aux_sym_field_declaration_repeat1] = aux_sym_field_declaration_repeat1,
  [aux_sym_parameter_list_repeat1] = aux_sym_parameter_list_repeat1,
  [aux_sym_case_statement_repeat1] = aux_sym_case_statement_repeat1,
  [aux_sym_generic_expression_repeat1] = aux_sym_generic_expression_repeat1,
  [aux_sym_gnu_asm_expression_repeat1] = aux_sym_gnu_asm_expression_repeat1,
  [aux_sym_gnu_asm_output_operand_list_repeat1] = aux_sym_gnu_asm_output_operand_list_repeat1,
  [aux_sym_gnu_asm_input_operand_list_repeat1] = aux_sym_gnu_asm_input_operand_list_repeat1,
  [aux_sym_gnu_asm_clobber_list_repeat1] = aux_sym_gnu_asm_clobber_list_repeat1,
  [aux_sym_gnu_asm_goto_list_repeat1] = aux_sym_gnu_asm_goto_list_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_initializer_list_repeat1] = aux_sym_initializer_list_repeat1,
  [aux_sym_initializer_pair_repeat1] = aux_sym_initializer_pair_repeat1,
  [aux_sym_char_literal_repeat1] = aux_sym_char_literal_repeat1,
  [aux_sym_concatenated_string_repeat1] = aux_sym_concatenated_string_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [aux_sym__class_declaration_repeat1] = aux_sym__class_declaration_repeat1,
  [aux_sym_base_class_clause_repeat1] = aux_sym_base_class_clause_repeat1,
  [aux_sym_template_parameter_list_repeat1] = aux_sym_template_parameter_list_repeat1,
  [aux_sym_field_initializer_list_repeat1] = aux_sym_field_initializer_list_repeat1,
  [aux_sym_operator_cast_definition_repeat1] = aux_sym_operator_cast_definition_repeat1,
  [aux_sym_constructor_try_statement_repeat1] = aux_sym_constructor_try_statement_repeat1,
  [aux_sym_structured_binding_declarator_repeat1] = aux_sym_structured_binding_declarator_repeat1,
  [aux_sym__function_postfix_repeat1] = aux_sym__function_postfix_repeat1,
  [aux_sym_throw_specifier_repeat1] = aux_sym_throw_specifier_repeat1,
  [aux_sym_template_argument_list_repeat1] = aux_sym_template_argument_list_repeat1,
  [aux_sym_subscript_argument_list_repeat1] = aux_sym_subscript_argument_list_repeat1,
  [aux_sym_requirement_seq_repeat1] = aux_sym_requirement_seq_repeat1,
  [aux_sym_requires_parameter_list_repeat1] = aux_sym_requires_parameter_list_repeat1,
  [aux_sym_lambda_capture_specifier_repeat1] = aux_sym_lambda_capture_specifier_repeat1,
  [alias_sym_field_identifier] = alias_sym_field_identifier,
  [alias_sym_namespace_identifier] = alias_sym_namespace_identifier,
  [alias_sym_simple_requirement] = alias_sym_simple_requirement,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_preproc_include_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_include_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_def_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_else_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elif_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elifdef_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elifdef_token2] = {
    .visible = true,
    .named = false,
  },
  [sym_preproc_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_directive] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defined] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___extension__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typedef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___device__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___host__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___global__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___forceinline__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___noinline__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___attribute__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___declspec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___based] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___cdecl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___clrcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___stdcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___fastcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___thiscall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___vectorcall] = {
    .visible = true,
    .named = false,
  },
  [sym_ms_restrict_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_unsigned_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_signed_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym__unaligned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___unaligned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_signed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsigned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_long] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_short] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_register] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___inline__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___forceinline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_thread_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___thread] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constexpr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_restrict] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___restrict__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Atomic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Noreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mutable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constinit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_consteval] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___shared__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___local__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___constant__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___managed__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___grid_constant__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alignas] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Alignas] = {
    .visible = true,
    .named = false,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___except] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___leave] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xor_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_compl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bitor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bitand] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sizeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___alignof__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_offsetof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Generic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___asm__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_L_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_U_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_char_literal_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_L_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_U_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_literal_token1] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_system_lib_string] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_NULL] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nullptr] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_auto] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_decltype] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_final] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [sym_virtual] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_explicit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typename] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_template] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_operator] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_0] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_friend] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noexcept] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_concept] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_co_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_co_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_R_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_UR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8R_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_co_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_requires] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_suffix] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_kernel_call_syntax_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_kernel_call_syntax_token2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___launch_bounds__] = {
    .visible = true,
    .named = false,
  },
  [sym_raw_string_delimiter] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym_translation_unit] = {
    .visible = true,
    .named = true,
  },
  [sym__top_level_item] = {
    .visible = false,
    .named = true,
  },
  [sym__block_item] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_include] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_function_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_params] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym__preproc_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_defined] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__type_definition_type] = {
    .visible = false,
    .named = true,
  },
  [sym__type_definition_declarators] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration_modifiers] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration_specifiers] = {
    .visible = false,
    .named = true,
  },
  [sym_linkage_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_declspec_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_based_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_call_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_unaligned_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_pointer_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__field_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__type_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__abstract_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parenthesized_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_parenthesized_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_init_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_storage_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_alignas_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_specifier] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_sized_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_union_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__field_declaration_list_item] = {
    .visible = false,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_bitfield_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__top_level_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__top_level_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_statement_body] = {
    .visible = false,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_except_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_leave_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__string] = {
    .visible = false,
    .named = true,
  },
  [sym_comma_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym_sizeof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_alignof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_offsetof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_output_operand_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_output_operand] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_input_operand_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_input_operand] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_clobber_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_goto_list] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_literal_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_range_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_field_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_char_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_placeholder_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_decltype_auto] = {
    .visible = true,
    .named = true,
  },
  [sym_decltype] = {
    .visible = true,
    .named = true,
  },
  [sym__class_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym__class_declaration_item] = {
    .visible = false,
    .named = true,
  },
  [sym_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym__class_name] = {
    .visible = false,
    .named = true,
  },
  [sym_virtual_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_explicit_function_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_base_class_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__enum_base_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_dependent_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_template_instantiation] = {
    .visible = true,
    .named = true,
  },
  [sym_template_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_template_template_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_cast] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_inline_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__constructor_specifiers] = {
    .visible = false,
    .named = true,
  },
  [sym_operator_cast_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_cast_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_or_destructor_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_or_destructor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_default_method_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_method_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_pure_virtual_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_friend_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_access_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_structured_binding_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym__function_declarator_seq] = {
    .visible = false,
    .named = true,
  },
  [sym__function_attributes_start] = {
    .visible = false,
    .named = true,
  },
  [sym__function_exception_specification] = {
    .visible = false,
    .named = true,
  },
  [sym__function_attributes_end] = {
    .visible = false,
    .named = true,
  },
  [sym__function_postfix] = {
    .visible = false,
    .named = true,
  },
  [sym_trailing_return_type] = {
    .visible = true,
    .named = true,
  },
  [sym_noexcept] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_template_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_method] = {
    .visible = true,
    .named = true,
  },
  [sym_template_function] = {
    .visible = true,
    .named = true,
  },
  [sym_template_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_alias_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__namespace_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym_nested_namespace_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_using_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_static_assert_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_concept_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_for_range_loop] = {
    .visible = true,
    .named = true,
  },
  [sym__for_range_loop_body] = {
    .visible = false,
    .named = true,
  },
  [sym_init_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_condition_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_condition_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_co_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_co_yield_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_co_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_requirement] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_requirement] = {
    .visible = true,
    .named = true,
  },
  [sym__requirement] = {
    .visible = false,
    .named = true,
  },
  [sym_requirement_seq] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint_conjunction] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint_disjunction] = {
    .visible = true,
    .named = true,
  },
  [sym__requirement_clause_constraint] = {
    .visible = false,
    .named = true,
  },
  [sym_requires_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_requires_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_requires_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_capture_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_default_capture] = {
    .visible = true,
    .named = true,
  },
  [sym__fold_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__binary_fold_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_left_fold] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_right_fold] = {
    .visible = false,
    .named = true,
  },
  [sym__binary_fold] = {
    .visible = false,
    .named = true,
  },
  [sym_fold_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_pack_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_pack_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_destructor_name] = {
    .visible = true,
    .named = true,
  },
  [sym_dependent_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_dependent_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_dependent_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__scope_resolution] = {
    .visible = false,
    .named = true,
  },
  [sym_qualified_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_operator_cast_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__assignment_expression_lhs] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_name] = {
    .visible = true,
    .named = true,
  },
  [sym_user_defined_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_kernel_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_kernel_call_syntax] = {
    .visible = true,
    .named = true,
  },
  [sym_launch_bounds] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_translation_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_params_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_definition_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_definition_declarators_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__declaration_specifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attributed_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pointer_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sized_type_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_generic_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_output_operand_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_input_operand_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_clobber_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_goto_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_pair_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_char_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__class_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_base_class_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_operator_cast_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constructor_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_structured_binding_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__function_postfix_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_throw_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_subscript_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_requirement_seq_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_requires_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_lambda_capture_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_namespace_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_simple_requirement] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_argument = 2,
  field_arguments = 3,
  field_assembly_code = 4,
  field_base = 5,
  field_body = 6,
  field_captures = 7,
  field_clobbers = 8,
  field_condition = 9,
  field_consequence = 10,
  field_constraint = 11,
  field_declarator = 12,
  field_default_type = 13,
  field_default_value = 14,
  field_delimiter = 15,
  field_designator = 16,
  field_directive = 17,
  field_end = 18,
  field_field = 19,
  field_filter = 20,
  field_function = 21,
  field_goto_labels = 22,
  field_indices = 23,
  field_initializer = 24,
  field_input_operands = 25,
  field_label = 26,
  field_left = 27,
  field_length = 28,
  field_member = 29,
  field_message = 30,
  field_name = 31,
  field_operand = 32,
  field_operator = 33,
  field_output_operands = 34,
  field_parameters = 35,
  field_path = 36,
  field_pattern = 37,
  field_placement = 38,
  field_prefix = 39,
  field_register = 40,
  field_requirements = 41,
  field_right = 42,
  field_scope = 43,
  field_size = 44,
  field_start = 45,
  field_symbol = 46,
  field_template_parameters = 47,
  field_type = 48,
  field_update = 49,
  field_value = 50,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_assembly_code] = "assembly_code",
  [field_base] = "base",
  [field_body] = "body",
  [field_captures] = "captures",
  [field_clobbers] = "clobbers",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constraint] = "constraint",
  [field_declarator] = "declarator",
  [field_default_type] = "default_type",
  [field_default_value] = "default_value",
  [field_delimiter] = "delimiter",
  [field_designator] = "designator",
  [field_directive] = "directive",
  [field_end] = "end",
  [field_field] = "field",
  [field_filter] = "filter",
  [field_function] = "function",
  [field_goto_labels] = "goto_labels",
  [field_indices] = "indices",
  [field_initializer] = "initializer",
  [field_input_operands] = "input_operands",
  [field_label] = "label",
  [field_left] = "left",
  [field_length] = "length",
  [field_member] = "member",
  [field_message] = "message",
  [field_name] = "name",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_output_operands] = "output_operands",
  [field_parameters] = "parameters",
  [field_path] = "path",
  [field_pattern] = "pattern",
  [field_placement] = "placement",
  [field_prefix] = "prefix",
  [field_register] = "register",
  [field_requirements] = "requirements",
  [field_right] = "right",
  [field_scope] = "scope",
  [field_size] = "size",
  [field_start] = "start",
  [field_symbol] = "symbol",
  [field_template_parameters] = "template_parameters",
  [field_type] = "type",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 2},
  [5] = {.index = 4, .length = 1},
  [6] = {.index = 5, .length = 1},
  [7] = {.index = 6, .length = 2},
  [8] = {.index = 8, .length = 2},
  [9] = {.index = 10, .length = 1},
  [10] = {.index = 11, .length = 1},
  [11] = {.index = 12, .length = 1},
  [12] = {.index = 13, .length = 2},
  [13] = {.index = 15, .length = 2},
  [14] = {.index = 17, .length = 1},
  [15] = {.index = 18, .length = 1},
  [16] = {.index = 19, .length = 2},
  [17] = {.index = 19, .length = 2},
  [18] = {.index = 0, .length = 1},
  [20] = {.index = 21, .length = 1},
  [21] = {.index = 22, .length = 1},
  [22] = {.index = 23, .length = 1},
  [23] = {.index = 24, .length = 1},
  [24] = {.index = 25, .length = 2},
  [25] = {.index = 27, .length = 2},
  [26] = {.index = 29, .length = 1},
  [27] = {.index = 30, .length = 1},
  [28] = {.index = 31, .length = 1},
  [29] = {.index = 32, .length = 2},
  [30] = {.index = 34, .length = 2},
  [31] = {.index = 18, .length = 1},
  [32] = {.index = 36, .length = 2},
  [33] = {.index = 38, .length = 1},
  [34] = {.index = 39, .length = 2},
  [35] = {.index = 39, .length = 2},
  [36] = {.index = 21, .length = 1},
  [37] = {.index = 41, .length = 1},
  [38] = {.index = 42, .length = 2},
  [39] = {.index = 44, .length = 2},
  [40] = {.index = 46, .length = 3},
  [41] = {.index = 49, .length = 1},
  [44] = {.index = 50, .length = 2},
  [45] = {.index = 52, .length = 1},
  [46] = {.index = 53, .length = 1},
  [47] = {.index = 54, .length = 1},
  [48] = {.index = 55, .length = 2},
  [49] = {.index = 57, .length = 2},
  [50] = {.index = 59, .length = 2},
  [51] = {.index = 61, .length = 2},
  [52] = {.index = 63, .length = 2},
  [53] = {.index = 65, .length = 1},
  [54] = {.index = 66, .length = 3},
  [55] = {.index = 69, .length = 1},
  [56] = {.index = 70, .length = 1},
  [57] = {.index = 71, .length = 1},
  [58] = {.index = 72, .length = 2},
  [60] = {.index = 55, .length = 2},
  [61] = {.index = 74, .length = 2},
  [62] = {.index = 76, .length = 2},
  [63] = {.index = 78, .length = 2},
  [65] = {.index = 80, .length = 2},
  [66] = {.index = 82, .length = 2},
  [67] = {.index = 84, .length = 3},
  [68] = {.index = 87, .length = 2},
  [69] = {.index = 89, .length = 2},
  [70] = {.index = 91, .length = 3},
  [71] = {.index = 91, .length = 3},
  [72] = {.index = 94, .length = 2},
  [73] = {.index = 96, .length = 3},
  [74] = {.index = 99, .length = 3},
  [75] = {.index = 102, .length = 3},
  [76] = {.index = 105, .length = 2},
  [77] = {.index = 107, .length = 2},
  [78] = {.index = 109, .length = 2},
  [79] = {.index = 111, .length = 1},
  [80] = {.index = 112, .length = 2},
  [81] = {.index = 114, .length = 2},
  [82] = {.index = 116, .length = 2},
  [83] = {.index = 118, .length = 3},
  [84] = {.index = 121, .length = 2},
  [85] = {.index = 123, .length = 1},
  [86] = {.index = 124, .length = 2},
  [87] = {.index = 126, .length = 2},
  [88] = {.index = 128, .length = 2},
  [89] = {.index = 130, .length = 2},
  [90] = {.index = 132, .length = 2},
  [91] = {.index = 134, .length = 2},
  [92] = {.index = 136, .length = 2},
  [93] = {.index = 138, .length = 2},
  [94] = {.index = 140, .length = 1},
  [95] = {.index = 138, .length = 2},
  [97] = {.index = 141, .length = 2},
  [98] = {.index = 143, .length = 1},
  [99] = {.index = 143, .length = 1},
  [100] = {.index = 144, .length = 3},
  [102] = {.index = 147, .length = 2},
  [103] = {.index = 149, .length = 2},
  [104] = {.index = 151, .length = 2},
  [105] = {.index = 153, .length = 3},
  [106] = {.index = 156, .length = 1},
  [107] = {.index = 157, .length = 1},
  [109] = {.index = 158, .length = 3},
  [110] = {.index = 161, .length = 3},
  [111] = {.index = 164, .length = 3},
  [112] = {.index = 167, .length = 3},
  [113] = {.index = 170, .length = 2},
  [114] = {.index = 172, .length = 3},
  [115] = {.index = 175, .length = 3},
  [116] = {.index = 178, .length = 2},
  [117] = {.index = 180, .length = 3},
  [118] = {.index = 183, .length = 2},
  [119] = {.index = 19, .length = 2},
  [120] = {.index = 39, .length = 2},
  [121] = {.index = 185, .length = 2},
  [122] = {.index = 187, .length = 2},
  [123] = {.index = 189, .length = 1},
  [124] = {.index = 190, .length = 4},
  [125] = {.index = 194, .length = 4},
  [126] = {.index = 198, .length = 2},
  [127] = {.index = 200, .length = 3},
  [128] = {.index = 203, .length = 2},
  [129] = {.index = 205, .length = 2},
  [130] = {.index = 207, .length = 1},
  [131] = {.index = 208, .length = 2},
  [132] = {.index = 210, .length = 2},
  [133] = {.index = 212, .length = 3},
  [134] = {.index = 215, .length = 3},
  [135] = {.index = 218, .length = 3},
  [136] = {.index = 221, .length = 2},
  [137] = {.index = 221, .length = 2},
  [138] = {.index = 223, .length = 2},
  [139] = {.index = 223, .length = 2},
  [140] = {.index = 225, .length = 2},
  [141] = {.index = 227, .length = 3},
  [142] = {.index = 230, .length = 2},
  [143] = {.index = 232, .length = 2},
  [144] = {.index = 234, .length = 3},
  [145] = {.index = 237, .length = 2},
  [146] = {.index = 239, .length = 3},
  [147] = {.index = 242, .length = 2},
  [148] = {.index = 244, .length = 1},
  [149] = {.index = 245, .length = 2},
  [150] = {.index = 247, .length = 2},
  [151] = {.index = 249, .length = 4},
  [152] = {.index = 253, .length = 5},
  [153] = {.index = 258, .length = 1},
  [154] = {.index = 259, .length = 1},
  [155] = {.index = 260, .length = 2},
  [156] = {.index = 262, .length = 1},
  [158] = {.index = 263, .length = 1},
  [159] = {.index = 264, .length = 2},
  [160] = {.index = 266, .length = 2},
  [161] = {.index = 11, .length = 1},
  [162] = {.index = 11, .length = 1},
  [163] = {.index = 268, .length = 2},
  [164] = {.index = 270, .length = 1},
  [165] = {.index = 271, .length = 1},
  [166] = {.index = 272, .length = 4},
  [167] = {.index = 276, .length = 2},
  [168] = {.index = 278, .length = 4},
  [169] = {.index = 282, .length = 1},
  [170] = {.index = 283, .length = 3},
  [171] = {.index = 286, .length = 2},
  [172] = {.index = 288, .length = 3},
  [173] = {.index = 291, .length = 1},
  [174] = {.index = 292, .length = 5},
  [175] = {.index = 297, .length = 2},
  [176] = {.index = 299, .length = 2},
  [177] = {.index = 301, .length = 4},
  [178] = {.index = 305, .length = 2},
  [179] = {.index = 307, .length = 3},
  [180] = {.index = 310, .length = 4},
  [181] = {.index = 314, .length = 4},
  [182] = {.index = 318, .length = 3},
  [183] = {.index = 321, .length = 2},
  [184] = {.index = 323, .length = 3},
  [185] = {.index = 326, .length = 3},
  [186] = {.index = 329, .length = 2},
  [187] = {.index = 331, .length = 2},
  [188] = {.index = 333, .length = 2},
  [189] = {.index = 335, .length = 2},
  [190] = {.index = 337, .length = 3},
  [191] = {.index = 340, .length = 2},
  [192] = {.index = 342, .length = 2},
  [193] = {.index = 344, .length = 3},
  [194] = {.index = 347, .length = 2},
  [195] = {.index = 349, .length = 2},
  [196] = {.index = 351, .length = 2},
  [197] = {.index = 353, .length = 4},
  [198] = {.index = 357, .length = 5},
  [199] = {.index = 362, .length = 3},
  [200] = {.index = 365, .length = 4},
  [201] = {.index = 369, .length = 2},
  [202] = {.index = 371, .length = 1},
  [203] = {.index = 372, .length = 4},
  [204] = {.index = 376, .length = 3},
  [205] = {.index = 379, .length = 2},
  [206] = {.index = 381, .length = 1},
  [207] = {.index = 382, .length = 5},
  [208] = {.index = 387, .length = 2},
  [209] = {.index = 389, .length = 2},
  [210] = {.index = 65, .length = 1},
  [211] = {.index = 391, .length = 5},
  [212] = {.index = 396, .length = 4},
  [213] = {.index = 400, .length = 2},
  [214] = {.index = 402, .length = 2},
  [215] = {.index = 404, .length = 5},
  [216] = {.index = 409, .length = 2},
  [217] = {.index = 411, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_type, 0},
  [1] =
    {field_directive, 0},
  [2] =
    {field_argument, 1},
    {field_operator, 0},
  [4] =
    {field_declarator, 1},
  [5] =
    {field_name, 0},
  [6] =
    {field_arguments, 1},
    {field_function, 0},
  [8] =
    {field_type, 0},
    {field_value, 1},
  [10] =
    {field_body, 1},
  [11] =
    {field_name, 1},
  [12] =
    {field_body, 0},
  [13] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [15] =
    {field_body, 0, .inherited = true},
    {field_name, 0, .inherited = true},
  [17] =
    {field_value, 1},
  [18] =
    {field_scope, 0},
  [19] =
    {field_arguments, 1},
    {field_name, 0},
  [21] =
    {field_type, 1},
  [22] =
    {field_requirements, 1},
  [23] =
    {field_constraint, 1},
  [24] =
    {field_parameters, 0},
  [25] =
    {field_declarator, 0},
    {field_parameters, 1, .inherited = true},
  [27] =
    {field_body, 1},
    {field_declarator, 0},
  [29] =
    {field_declarator, 0},
  [30] =
    {field_constraint, 0},
  [31] =
    {field_pattern, 0},
  [32] =
    {field_argument, 0},
    {field_operator, 1},
  [34] =
    {field_argument, 0},
    {field_indices, 1},
  [36] =
    {field_body, 1},
    {field_captures, 0},
  [38] =
    {field_parameters, 0, .inherited = true},
  [39] =
    {field_name, 1},
    {field_scope, 0, .inherited = true},
  [41] =
    {field_path, 1},
  [42] =
    {field_argument, 1},
    {field_directive, 0},
  [44] =
    {field_declarator, 1},
    {field_type, 0},
  [46] =
    {field_left, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [49] =
    {field_declarator, 2},
  [50] =
    {field_body, 2},
    {field_value, 1},
  [52] =
    {field_type, 2},
  [53] =
    {field_body, 2},
  [54] =
    {field_name, 2},
  [55] =
    {field_body, 2},
    {field_name, 1},
  [57] =
    {field_base, 2, .inherited = true},
    {field_name, 1},
  [59] =
    {field_body, 1},
    {field_name, 0},
  [61] =
    {field_condition, 1},
    {field_consequence, 2},
  [63] =
    {field_body, 2},
    {field_condition, 1},
  [65] =
    {field_label, 1},
  [66] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [69] =
    {field_label, 0},
  [70] =
    {field_type, 0, .inherited = true},
  [71] =
    {field_parameters, 1},
  [72] =
    {field_declarator, 2},
    {field_type, 1, .inherited = true},
  [74] =
    {field_arguments, 2},
    {field_type, 1},
  [76] =
    {field_declarator, 2},
    {field_type, 1},
  [78] =
    {field_placement, 1},
    {field_type, 2},
  [80] =
    {field_parameters, 1},
    {field_requirements, 2},
  [82] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
  [84] =
    {field_body, 2},
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
  [87] =
    {field_declarator, 0},
    {field_value, 1},
  [89] =
    {field_body, 2},
    {field_declarator, 0},
  [91] =
    {field_argument, 0},
    {field_field, 2},
    {field_operator, 1},
  [94] =
    {field_arguments, 2},
    {field_function, 0},
  [96] =
    {field_body, 2},
    {field_captures, 0},
    {field_declarator, 1},
  [99] =
    {field_body, 2},
    {field_captures, 0},
    {field_template_parameters, 1},
  [102] =
    {field_name, 1},
    {field_name, 2},
    {field_scope, 0, .inherited = true},
  [105] =
    {field_body, 2},
    {field_declarator, 1},
  [107] =
    {field_name, 1},
    {field_value, 2},
  [109] =
    {field_name, 1},
    {field_parameters, 2},
  [111] =
    {field_condition, 1},
  [112] =
    {field_alternative, 2},
    {field_name, 1},
  [114] =
    {field_declarator, 2},
    {field_type, 0},
  [116] =
    {field_left, 0},
    {field_right, 2},
  [118] =
    {field_left, 0},
    {field_operator, 1, .inherited = true},
    {field_right, 2},
  [121] =
    {field_type, 1},
    {field_value, 3},
  [123] =
    {field_declarator, 3},
  [124] =
    {field_declarator, 2, .inherited = true},
    {field_type, 1, .inherited = true},
  [126] =
    {field_declarator, 0},
    {field_parameters, 1},
  [128] =
    {field_declarator, 0},
    {field_declarator, 1, .inherited = true},
  [130] =
    {field_arguments, 3},
    {field_type, 2},
  [132] =
    {field_declarator, 3},
    {field_type, 2},
  [134] =
    {field_placement, 2},
    {field_type, 3},
  [136] =
    {field_name, 2},
    {field_prefix, 0},
  [138] =
    {field_body, 3},
    {field_name, 2},
  [140] =
    {field_body, 3},
  [141] =
    {field_base, 3, .inherited = true},
    {field_name, 2},
  [143] =
    {field_base, 1},
  [144] =
    {field_base, 2, .inherited = true},
    {field_body, 3},
    {field_name, 1},
  [147] =
    {field_body, 2, .inherited = true},
    {field_name, 2, .inherited = true},
  [149] =
    {field_body, 2},
    {field_name, 0},
  [151] =
    {field_condition, 2},
    {field_consequence, 3},
  [153] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [156] =
    {field_initializer, 0},
  [157] =
    {field_assembly_code, 2},
  [158] =
    {field_arguments, 3},
    {field_declarator, 2},
    {field_type, 1},
  [161] =
    {field_arguments, 3},
    {field_placement, 1},
    {field_type, 2},
  [164] =
    {field_declarator, 3},
    {field_placement, 1},
    {field_type, 2},
  [167] =
    {field_body, 3},
    {field_declarator, 2},
    {field_type, 0, .inherited = true},
  [170] =
    {field_declarator, 0},
    {field_value, 2},
  [172] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_type, 0, .inherited = true},
  [175] =
    {field_declarator, 1},
    {field_declarator, 2, .inherited = true},
    {field_type, 0, .inherited = true},
  [178] =
    {field_declarator, 0, .inherited = true},
    {field_declarator, 1, .inherited = true},
  [180] =
    {field_body, 3},
    {field_declarator, 2},
    {field_type, 1, .inherited = true},
  [183] =
    {field_declarator, 0},
    {field_size, 2},
  [185] =
    {field_alternative, 3},
    {field_condition, 0},
  [187] =
    {field_declarator, 0},
    {field_default_value, 2},
  [189] =
    {field_size, 1},
  [190] =
    {field_body, 3},
    {field_captures, 0},
    {field_declarator, 2},
    {field_template_parameters, 1},
  [194] =
    {field_body, 3},
    {field_captures, 0},
    {field_constraint, 2},
    {field_template_parameters, 1},
  [198] =
    {field_body, 3},
    {field_declarator, 1},
  [200] =
    {field_name, 1},
    {field_parameters, 2},
    {field_value, 3},
  [203] =
    {field_alternative, 3},
    {field_condition, 1},
  [205] =
    {field_alternative, 3},
    {field_name, 1},
  [207] =
    {field_operator, 0},
  [208] =
    {field_declarator, 3},
    {field_type, 1},
  [210] =
    {field_declarator, 3, .inherited = true},
    {field_type, 2, .inherited = true},
  [212] =
    {field_arguments, 4},
    {field_declarator, 3},
    {field_type, 2},
  [215] =
    {field_arguments, 4},
    {field_placement, 2},
    {field_type, 3},
  [218] =
    {field_declarator, 4},
    {field_placement, 2},
    {field_type, 3},
  [221] =
    {field_body, 4},
    {field_name, 3},
  [223] =
    {field_designator, 0},
    {field_value, 2},
  [225] =
    {field_name, 0},
    {field_value, 2},
  [227] =
    {field_base, 3, .inherited = true},
    {field_body, 4},
    {field_name, 2},
  [230] =
    {field_body, 3},
    {field_name, 0},
  [232] =
    {field_body, 3, .inherited = true},
    {field_name, 3, .inherited = true},
  [234] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
    {field_value, 2},
  [237] =
    {field_initializer, 1},
    {field_value, 2},
  [239] =
    {field_alternative, 4},
    {field_condition, 2},
    {field_consequence, 3},
  [242] =
    {field_body, 1},
    {field_condition, 3},
  [244] =
    {field_update, 2},
  [245] =
    {field_initializer, 0},
    {field_update, 2},
  [247] =
    {field_condition, 1},
    {field_initializer, 0},
  [249] =
    {field_body, 4},
    {field_condition, 2, .inherited = true},
    {field_initializer, 2, .inherited = true},
    {field_update, 2, .inherited = true},
  [253] =
    {field_body, 4},
    {field_declarator, 2, .inherited = true},
    {field_initializer, 2, .inherited = true},
    {field_right, 2, .inherited = true},
    {field_type, 2, .inherited = true},
  [258] =
    {field_value, 3},
  [259] =
    {field_operand, 1},
  [260] =
    {field_assembly_code, 2},
    {field_output_operands, 3},
  [262] =
    {field_assembly_code, 3},
  [263] =
    {field_default_type, 2},
  [264] =
    {field_default_value, 2},
    {field_type, 0, .inherited = true},
  [266] =
    {field_body, 2},
    {field_parameters, 1},
  [268] =
    {field_name, 1},
    {field_type, 3},
  [270] =
    {field_condition, 2},
  [271] =
    {field_length, 1},
  [272] =
    {field_arguments, 4},
    {field_declarator, 3},
    {field_placement, 1},
    {field_type, 2},
  [276] =
    {field_declarator, 1},
    {field_declarator, 2},
  [278] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_declarator, 3, .inherited = true},
    {field_type, 0, .inherited = true},
  [282] =
    {field_declarator, 4},
  [283] =
    {field_body, 4},
    {field_declarator, 3},
    {field_type, 1, .inherited = true},
  [286] =
    {field_declarator, 0},
    {field_size, 3},
  [288] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [291] =
    {field_size, 2},
  [292] =
    {field_body, 4},
    {field_captures, 0},
    {field_constraint, 2},
    {field_declarator, 3},
    {field_template_parameters, 1},
  [297] =
    {field_declarator, 1},
    {field_default_value, 3},
  [299] =
    {field_alternative, 4},
    {field_condition, 1},
  [301] =
    {field_arguments, 5},
    {field_declarator, 4},
    {field_placement, 2},
    {field_type, 3},
  [305] =
    {field_body, 2},
    {field_filter, 1},
  [307] =
    {field_declarator, 1},
    {field_default_value, 2},
    {field_type, 0, .inherited = true},
  [310] =
    {field_declarator, 1},
    {field_declarator, 2, .inherited = true},
    {field_default_value, 2, .inherited = true},
    {field_type, 0, .inherited = true},
  [314] =
    {field_declarator, 0, .inherited = true},
    {field_declarator, 1, .inherited = true},
    {field_default_value, 0, .inherited = true},
    {field_default_value, 1, .inherited = true},
  [318] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
    {field_value, 3},
  [321] =
    {field_condition, 1},
    {field_update, 3},
  [323] =
    {field_condition, 1},
    {field_initializer, 0},
    {field_update, 3},
  [326] =
    {field_declarator, 1},
    {field_right, 3},
    {field_type, 0, .inherited = true},
  [329] =
    {field_initializer, 0},
    {field_update, 3},
  [331] =
    {field_condition, 2},
    {field_initializer, 0},
  [333] =
    {field_member, 4},
    {field_type, 2},
  [335] =
    {field_operand, 1},
    {field_operand, 2, .inherited = true},
  [337] =
    {field_assembly_code, 2},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [340] =
    {field_assembly_code, 3},
    {field_output_operands, 4},
  [342] =
    {field_default_type, 3},
    {field_name, 1},
  [344] =
    {field_declarator, 1},
    {field_default_value, 3},
    {field_type, 0, .inherited = true},
  [347] =
    {field_name, 1},
    {field_type, 4},
  [349] =
    {field_end, 3},
    {field_start, 1},
  [351] =
    {field_declarator, 1},
    {field_default_value, 2},
  [353] =
    {field_declarator, 1},
    {field_declarator, 3, .inherited = true},
    {field_default_value, 3, .inherited = true},
    {field_type, 0, .inherited = true},
  [357] =
    {field_declarator, 1},
    {field_declarator, 3, .inherited = true},
    {field_default_value, 2},
    {field_default_value, 3, .inherited = true},
    {field_type, 0, .inherited = true},
  [362] =
    {field_condition, 2},
    {field_initializer, 0},
    {field_update, 4},
  [365] =
    {field_declarator, 2},
    {field_initializer, 0},
    {field_right, 4},
    {field_type, 1, .inherited = true},
  [369] =
    {field_operand, 0, .inherited = true},
    {field_operand, 1, .inherited = true},
  [371] =
    {field_register, 1},
  [372] =
    {field_assembly_code, 2},
    {field_clobbers, 5},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [376] =
    {field_assembly_code, 3},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [379] =
    {field_condition, 2},
    {field_message, 4},
  [381] =
    {field_delimiter, 1},
  [382] =
    {field_declarator, 1},
    {field_declarator, 4, .inherited = true},
    {field_default_value, 3},
    {field_default_value, 4, .inherited = true},
    {field_type, 0, .inherited = true},
  [387] =
    {field_constraint, 0},
    {field_value, 2},
  [389] =
    {field_register, 1},
    {field_register, 2, .inherited = true},
  [391] =
    {field_assembly_code, 2},
    {field_clobbers, 5},
    {field_goto_labels, 6},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [396] =
    {field_assembly_code, 3},
    {field_clobbers, 6},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [400] =
    {field_register, 0, .inherited = true},
    {field_register, 1, .inherited = true},
  [402] =
    {field_label, 1},
    {field_label, 2, .inherited = true},
  [404] =
    {field_assembly_code, 3},
    {field_clobbers, 6},
    {field_goto_labels, 7},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [409] =
    {field_label, 0, .inherited = true},
    {field_label, 1, .inherited = true},
  [411] =
    {field_constraint, 3},
    {field_symbol, 1},
    {field_value, 5},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_type_identifier,
  },
  [15] = {
    [0] = alias_sym_namespace_identifier,
  },
  [16] = {
    [0] = alias_sym_type_identifier,
  },
  [18] = {
    [0] = alias_sym_type_identifier,
  },
  [19] = {
    [0] = alias_sym_namespace_identifier,
  },
  [35] = {
    [1] = alias_sym_type_identifier,
  },
  [36] = {
    [1] = alias_sym_type_identifier,
  },
  [42] = {
    [0] = sym_primitive_type,
  },
  [43] = {
    [0] = sym_pointer_declarator,
  },
  [53] = {
    [1] = alias_sym_statement_identifier,
  },
  [55] = {
    [0] = alias_sym_statement_identifier,
  },
  [59] = {
    [1] = alias_sym_namespace_identifier,
  },
  [60] = {
    [1] = alias_sym_namespace_identifier,
  },
  [64] = {
    [0] = alias_sym_simple_requirement,
  },
  [70] = {
    [2] = alias_sym_field_identifier,
  },
  [93] = {
    [2] = alias_sym_namespace_identifier,
  },
  [96] = {
    [1] = alias_sym_field_identifier,
  },
  [99] = {
    [1] = alias_sym_type_identifier,
  },
  [101] = {
    [0] = alias_sym_field_identifier,
  },
  [108] = {
    [1] = alias_sym_type_identifier,
  },
  [119] = {
    [0] = alias_sym_field_identifier,
  },
  [120] = {
    [1] = alias_sym_field_identifier,
  },
  [136] = {
    [3] = alias_sym_namespace_identifier,
  },
  [138] = {
    [0] = alias_sym_field_identifier,
  },
  [157] = {
    [2] = alias_sym_type_identifier,
  },
  [161] = {
    [1] = alias_sym_namespace_identifier,
    [3] = alias_sym_namespace_identifier,
  },
  [162] = {
    [1] = alias_sym_namespace_identifier,
  },
  [163] = {
    [1] = alias_sym_type_identifier,
  },
  [188] = {
    [4] = alias_sym_field_identifier,
  },
  [192] = {
    [1] = alias_sym_type_identifier,
  },
  [194] = {
    [1] = alias_sym_type_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_pointer_type_declarator, 2,
    sym_pointer_type_declarator,
    sym_pointer_declarator,
  sym_expression_statement, 2,
    sym_expression_statement,
    alias_sym_simple_requirement,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 2,
  [5] = 2,
  [6] = 2,
  [7] = 2,
  [8] = 2,
  [9] = 2,
  [10] = 2,
  [11] = 2,
  [12] = 2,
  [13] = 13,
  [14] = 13,
  [15] = 15,
  [16] = 16,
  [17] = 15,
  [18] = 18,
  [19] = 18,
  [20] = 13,
  [21] = 18,
  [22] = 13,
  [23] = 23,
  [24] = 15,
  [25] = 23,
  [26] = 23,
  [27] = 18,
  [28] = 28,
  [29] = 23,
  [30] = 30,
  [31] = 31,
  [32] = 15,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 34,
  [38] = 35,
  [39] = 34,
  [40] = 34,
  [41] = 41,
  [42] = 42,
  [43] = 41,
  [44] = 35,
  [45] = 34,
  [46] = 35,
  [47] = 34,
  [48] = 34,
  [49] = 36,
  [50] = 35,
  [51] = 36,
  [52] = 35,
  [53] = 35,
  [54] = 34,
  [55] = 34,
  [56] = 34,
  [57] = 41,
  [58] = 34,
  [59] = 35,
  [60] = 35,
  [61] = 36,
  [62] = 33,
  [63] = 34,
  [64] = 35,
  [65] = 35,
  [66] = 34,
  [67] = 35,
  [68] = 35,
  [69] = 35,
  [70] = 34,
  [71] = 33,
  [72] = 34,
  [73] = 35,
  [74] = 74,
  [75] = 34,
  [76] = 35,
  [77] = 35,
  [78] = 34,
  [79] = 35,
  [80] = 34,
  [81] = 34,
  [82] = 35,
  [83] = 41,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 87,
  [92] = 86,
  [93] = 88,
  [94] = 90,
  [95] = 86,
  [96] = 89,
  [97] = 88,
  [98] = 90,
  [99] = 86,
  [100] = 90,
  [101] = 88,
  [102] = 87,
  [103] = 89,
  [104] = 89,
  [105] = 87,
  [106] = 89,
  [107] = 86,
  [108] = 87,
  [109] = 90,
  [110] = 88,
  [111] = 111,
  [112] = 111,
  [113] = 111,
  [114] = 111,
  [115] = 111,
  [116] = 111,
  [117] = 117,
  [118] = 118,
  [119] = 118,
  [120] = 118,
  [121] = 118,
  [122] = 118,
  [123] = 118,
  [124] = 118,
  [125] = 118,
  [126] = 126,
  [127] = 127,
  [128] = 127,
  [129] = 127,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 131,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 132,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 183,
  [184] = 184,
  [185] = 185,
  [186] = 186,
  [187] = 187,
  [188] = 188,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 134,
  [193] = 193,
  [194] = 194,
  [195] = 195,
  [196] = 196,
  [197] = 197,
  [198] = 198,
  [199] = 184,
  [200] = 200,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 206,
  [213] = 181,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 204,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 222,
  [223] = 134,
  [224] = 202,
  [225] = 206,
  [226] = 226,
  [227] = 227,
  [228] = 181,
  [229] = 181,
  [230] = 230,
  [231] = 231,
  [232] = 181,
  [233] = 206,
  [234] = 234,
  [235] = 235,
  [236] = 206,
  [237] = 181,
  [238] = 238,
  [239] = 239,
  [240] = 206,
  [241] = 181,
  [242] = 242,
  [243] = 133,
  [244] = 133,
  [245] = 218,
  [246] = 181,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 181,
  [251] = 251,
  [252] = 206,
  [253] = 253,
  [254] = 206,
  [255] = 206,
  [256] = 206,
  [257] = 133,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 184,
  [266] = 266,
  [267] = 206,
  [268] = 181,
  [269] = 269,
  [270] = 270,
  [271] = 202,
  [272] = 181,
  [273] = 206,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 206,
  [279] = 279,
  [280] = 280,
  [281] = 181,
  [282] = 134,
  [283] = 206,
  [284] = 204,
  [285] = 285,
  [286] = 218,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 290,
  [291] = 291,
  [292] = 292,
  [293] = 293,
  [294] = 294,
  [295] = 295,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 181,
  [301] = 181,
  [302] = 302,
  [303] = 206,
  [304] = 181,
  [305] = 136,
  [306] = 135,
  [307] = 136,
  [308] = 308,
  [309] = 135,
  [310] = 131,
  [311] = 139,
  [312] = 139,
  [313] = 131,
  [314] = 132,
  [315] = 140,
  [316] = 138,
  [317] = 308,
  [318] = 139,
  [319] = 319,
  [320] = 140,
  [321] = 132,
  [322] = 140,
  [323] = 138,
  [324] = 138,
  [325] = 174,
  [326] = 176,
  [327] = 148,
  [328] = 174,
  [329] = 162,
  [330] = 164,
  [331] = 179,
  [332] = 178,
  [333] = 143,
  [334] = 146,
  [335] = 147,
  [336] = 144,
  [337] = 151,
  [338] = 175,
  [339] = 159,
  [340] = 145,
  [341] = 172,
  [342] = 171,
  [343] = 176,
  [344] = 155,
  [345] = 154,
  [346] = 145,
  [347] = 168,
  [348] = 165,
  [349] = 179,
  [350] = 154,
  [351] = 160,
  [352] = 148,
  [353] = 157,
  [354] = 164,
  [355] = 165,
  [356] = 166,
  [357] = 167,
  [358] = 178,
  [359] = 162,
  [360] = 168,
  [361] = 158,
  [362] = 163,
  [363] = 167,
  [364] = 173,
  [365] = 170,
  [366] = 142,
  [367] = 142,
  [368] = 163,
  [369] = 158,
  [370] = 370,
  [371] = 169,
  [372] = 149,
  [373] = 172,
  [374] = 159,
  [375] = 170,
  [376] = 171,
  [377] = 173,
  [378] = 174,
  [379] = 169,
  [380] = 169,
  [381] = 156,
  [382] = 161,
  [383] = 172,
  [384] = 168,
  [385] = 171,
  [386] = 176,
  [387] = 144,
  [388] = 149,
  [389] = 179,
  [390] = 178,
  [391] = 162,
  [392] = 161,
  [393] = 145,
  [394] = 167,
  [395] = 149,
  [396] = 156,
  [397] = 147,
  [398] = 146,
  [399] = 143,
  [400] = 157,
  [401] = 175,
  [402] = 143,
  [403] = 146,
  [404] = 147,
  [405] = 153,
  [406] = 166,
  [407] = 152,
  [408] = 153,
  [409] = 165,
  [410] = 152,
  [411] = 150,
  [412] = 151,
  [413] = 164,
  [414] = 156,
  [415] = 166,
  [416] = 151,
  [417] = 150,
  [418] = 159,
  [419] = 144,
  [420] = 154,
  [421] = 177,
  [422] = 155,
  [423] = 160,
  [424] = 175,
  [425] = 177,
  [426] = 153,
  [427] = 148,
  [428] = 161,
  [429] = 177,
  [430] = 152,
  [431] = 155,
  [432] = 173,
  [433] = 170,
  [434] = 142,
  [435] = 157,
  [436] = 163,
  [437] = 158,
  [438] = 150,
  [439] = 160,
  [440] = 440,
  [441] = 440,
  [442] = 258,
  [443] = 251,
  [444] = 188,
  [445] = 280,
  [446] = 292,
  [447] = 275,
  [448] = 274,
  [449] = 266,
  [450] = 264,
  [451] = 451,
  [452] = 262,
  [453] = 205,
  [454] = 201,
  [455] = 180,
  [456] = 299,
  [457] = 298,
  [458] = 293,
  [459] = 259,
  [460] = 226,
  [461] = 249,
  [462] = 248,
  [463] = 208,
  [464] = 222,
  [465] = 247,
  [466] = 220,
  [467] = 183,
  [468] = 189,
  [469] = 191,
  [470] = 194,
  [471] = 219,
  [472] = 197,
  [473] = 185,
  [474] = 288,
  [475] = 230,
  [476] = 207,
  [477] = 231,
  [478] = 215,
  [479] = 136,
  [480] = 440,
  [481] = 242,
  [482] = 239,
  [483] = 234,
  [484] = 222,
  [485] = 238,
  [486] = 226,
  [487] = 220,
  [488] = 227,
  [489] = 230,
  [490] = 235,
  [491] = 231,
  [492] = 234,
  [493] = 235,
  [494] = 215,
  [495] = 214,
  [496] = 260,
  [497] = 263,
  [498] = 219,
  [499] = 238,
  [500] = 214,
  [501] = 276,
  [502] = 277,
  [503] = 279,
  [504] = 211,
  [505] = 291,
  [506] = 239,
  [507] = 302,
  [508] = 440,
  [509] = 211,
  [510] = 295,
  [511] = 210,
  [512] = 242,
  [513] = 203,
  [514] = 285,
  [515] = 247,
  [516] = 210,
  [517] = 193,
  [518] = 290,
  [519] = 248,
  [520] = 249,
  [521] = 294,
  [522] = 288,
  [523] = 207,
  [524] = 440,
  [525] = 186,
  [526] = 200,
  [527] = 216,
  [528] = 440,
  [529] = 196,
  [530] = 209,
  [531] = 182,
  [532] = 190,
  [533] = 440,
  [534] = 187,
  [535] = 195,
  [536] = 208,
  [537] = 221,
  [538] = 293,
  [539] = 203,
  [540] = 294,
  [541] = 221,
  [542] = 298,
  [543] = 299,
  [544] = 180,
  [545] = 308,
  [546] = 216,
  [547] = 259,
  [548] = 440,
  [549] = 253,
  [550] = 182,
  [551] = 290,
  [552] = 260,
  [553] = 262,
  [554] = 263,
  [555] = 440,
  [556] = 209,
  [557] = 285,
  [558] = 308,
  [559] = 269,
  [560] = 264,
  [561] = 195,
  [562] = 187,
  [563] = 253,
  [564] = 440,
  [565] = 266,
  [566] = 188,
  [567] = 274,
  [568] = 275,
  [569] = 440,
  [570] = 201,
  [571] = 183,
  [572] = 440,
  [573] = 276,
  [574] = 205,
  [575] = 440,
  [576] = 189,
  [577] = 149,
  [578] = 190,
  [579] = 277,
  [580] = 191,
  [581] = 193,
  [582] = 279,
  [583] = 440,
  [584] = 194,
  [585] = 291,
  [586] = 135,
  [587] = 302,
  [588] = 186,
  [589] = 440,
  [590] = 440,
  [591] = 295,
  [592] = 227,
  [593] = 185,
  [594] = 440,
  [595] = 251,
  [596] = 200,
  [597] = 280,
  [598] = 197,
  [599] = 269,
  [600] = 440,
  [601] = 196,
  [602] = 292,
  [603] = 258,
  [604] = 440,
  [605] = 605,
  [606] = 606,
  [607] = 607,
  [608] = 608,
  [609] = 608,
  [610] = 610,
  [611] = 605,
  [612] = 612,
  [613] = 613,
  [614] = 607,
  [615] = 605,
  [616] = 616,
  [617] = 607,
  [618] = 618,
  [619] = 613,
  [620] = 613,
  [621] = 608,
  [622] = 606,
  [623] = 607,
  [624] = 616,
  [625] = 608,
  [626] = 612,
  [627] = 627,
  [628] = 608,
  [629] = 208,
  [630] = 605,
  [631] = 612,
  [632] = 610,
  [633] = 613,
  [634] = 606,
  [635] = 606,
  [636] = 618,
  [637] = 637,
  [638] = 308,
  [639] = 612,
  [640] = 610,
  [641] = 616,
  [642] = 627,
  [643] = 627,
  [644] = 612,
  [645] = 612,
  [646] = 616,
  [647] = 627,
  [648] = 627,
  [649] = 618,
  [650] = 650,
  [651] = 605,
  [652] = 610,
  [653] = 618,
  [654] = 613,
  [655] = 618,
  [656] = 308,
  [657] = 610,
  [658] = 605,
  [659] = 637,
  [660] = 608,
  [661] = 610,
  [662] = 616,
  [663] = 308,
  [664] = 607,
  [665] = 606,
  [666] = 606,
  [667] = 607,
  [668] = 613,
  [669] = 185,
  [670] = 616,
  [671] = 627,
  [672] = 672,
  [673] = 672,
  [674] = 672,
  [675] = 672,
  [676] = 672,
  [677] = 672,
  [678] = 678,
  [679] = 302,
  [680] = 678,
  [681] = 260,
  [682] = 682,
  [683] = 288,
  [684] = 259,
  [685] = 239,
  [686] = 682,
  [687] = 242,
  [688] = 262,
  [689] = 196,
  [690] = 678,
  [691] = 691,
  [692] = 216,
  [693] = 209,
  [694] = 219,
  [695] = 678,
  [696] = 193,
  [697] = 220,
  [698] = 194,
  [699] = 238,
  [700] = 197,
  [701] = 370,
  [702] = 264,
  [703] = 266,
  [704] = 191,
  [705] = 678,
  [706] = 678,
  [707] = 274,
  [708] = 182,
  [709] = 235,
  [710] = 234,
  [711] = 290,
  [712] = 187,
  [713] = 678,
  [714] = 275,
  [715] = 682,
  [716] = 308,
  [717] = 186,
  [718] = 215,
  [719] = 678,
  [720] = 276,
  [721] = 277,
  [722] = 221,
  [723] = 205,
  [724] = 279,
  [725] = 201,
  [726] = 678,
  [727] = 682,
  [728] = 214,
  [729] = 253,
  [730] = 249,
  [731] = 291,
  [732] = 211,
  [733] = 248,
  [734] = 734,
  [735] = 222,
  [736] = 247,
  [737] = 231,
  [738] = 285,
  [739] = 682,
  [740] = 230,
  [741] = 682,
  [742] = 682,
  [743] = 227,
  [744] = 682,
  [745] = 180,
  [746] = 226,
  [747] = 682,
  [748] = 678,
  [749] = 263,
  [750] = 295,
  [751] = 210,
  [752] = 682,
  [753] = 293,
  [754] = 190,
  [755] = 292,
  [756] = 756,
  [757] = 189,
  [758] = 207,
  [759] = 294,
  [760] = 203,
  [761] = 682,
  [762] = 280,
  [763] = 370,
  [764] = 269,
  [765] = 183,
  [766] = 258,
  [767] = 195,
  [768] = 251,
  [769] = 678,
  [770] = 200,
  [771] = 299,
  [772] = 678,
  [773] = 682,
  [774] = 774,
  [775] = 298,
  [776] = 776,
  [777] = 776,
  [778] = 308,
  [779] = 779,
  [780] = 779,
  [781] = 779,
  [782] = 779,
  [783] = 779,
  [784] = 779,
  [785] = 779,
  [786] = 308,
  [787] = 787,
  [788] = 788,
  [789] = 308,
  [790] = 790,
  [791] = 790,
  [792] = 790,
  [793] = 308,
  [794] = 308,
  [795] = 790,
  [796] = 790,
  [797] = 790,
  [798] = 308,
  [799] = 308,
  [800] = 790,
  [801] = 801,
  [802] = 802,
  [803] = 803,
  [804] = 804,
  [805] = 804,
  [806] = 804,
  [807] = 133,
  [808] = 808,
  [809] = 134,
  [810] = 810,
  [811] = 811,
  [812] = 812,
  [813] = 811,
  [814] = 814,
  [815] = 811,
  [816] = 811,
  [817] = 138,
  [818] = 812,
  [819] = 819,
  [820] = 139,
  [821] = 821,
  [822] = 812,
  [823] = 132,
  [824] = 824,
  [825] = 821,
  [826] = 819,
  [827] = 131,
  [828] = 828,
  [829] = 824,
  [830] = 812,
  [831] = 812,
  [832] = 832,
  [833] = 828,
  [834] = 811,
  [835] = 835,
  [836] = 140,
  [837] = 837,
  [838] = 163,
  [839] = 142,
  [840] = 155,
  [841] = 154,
  [842] = 148,
  [843] = 151,
  [844] = 150,
  [845] = 144,
  [846] = 145,
  [847] = 847,
  [848] = 159,
  [849] = 158,
  [850] = 152,
  [851] = 153,
  [852] = 156,
  [853] = 147,
  [854] = 146,
  [855] = 161,
  [856] = 162,
  [857] = 143,
  [858] = 178,
  [859] = 157,
  [860] = 170,
  [861] = 179,
  [862] = 176,
  [863] = 173,
  [864] = 164,
  [865] = 787,
  [866] = 165,
  [867] = 175,
  [868] = 166,
  [869] = 174,
  [870] = 172,
  [871] = 167,
  [872] = 788,
  [873] = 803,
  [874] = 168,
  [875] = 171,
  [876] = 160,
  [877] = 169,
  [878] = 177,
  [879] = 879,
  [880] = 879,
  [881] = 879,
  [882] = 882,
  [883] = 879,
  [884] = 879,
  [885] = 882,
  [886] = 882,
  [887] = 887,
  [888] = 887,
  [889] = 889,
  [890] = 890,
  [891] = 891,
  [892] = 892,
  [893] = 893,
  [894] = 894,
  [895] = 895,
  [896] = 896,
  [897] = 897,
  [898] = 898,
  [899] = 898,
  [900] = 900,
  [901] = 901,
  [902] = 898,
  [903] = 901,
  [904] = 898,
  [905] = 901,
  [906] = 906,
  [907] = 900,
  [908] = 898,
  [909] = 900,
  [910] = 901,
  [911] = 900,
  [912] = 901,
  [913] = 900,
  [914] = 901,
  [915] = 915,
  [916] = 898,
  [917] = 901,
  [918] = 901,
  [919] = 898,
  [920] = 900,
  [921] = 901,
  [922] = 900,
  [923] = 901,
  [924] = 898,
  [925] = 898,
  [926] = 898,
  [927] = 901,
  [928] = 900,
  [929] = 898,
  [930] = 930,
  [931] = 931,
  [932] = 931,
  [933] = 930,
  [934] = 930,
  [935] = 930,
  [936] = 930,
  [937] = 930,
  [938] = 931,
  [939] = 930,
  [940] = 931,
  [941] = 931,
  [942] = 931,
  [943] = 931,
  [944] = 931,
  [945] = 930,
  [946] = 946,
  [947] = 947,
  [948] = 947,
  [949] = 949,
  [950] = 949,
  [951] = 949,
  [952] = 949,
  [953] = 953,
  [954] = 894,
  [955] = 953,
  [956] = 953,
  [957] = 953,
  [958] = 953,
  [959] = 953,
  [960] = 894,
  [961] = 953,
  [962] = 290,
  [963] = 963,
  [964] = 953,
  [965] = 253,
  [966] = 953,
  [967] = 967,
  [968] = 968,
  [969] = 968,
  [970] = 968,
  [971] = 971,
  [972] = 889,
  [973] = 968,
  [974] = 974,
  [975] = 892,
  [976] = 971,
  [977] = 896,
  [978] = 968,
  [979] = 895,
  [980] = 890,
  [981] = 974,
  [982] = 968,
  [983] = 968,
  [984] = 891,
  [985] = 974,
  [986] = 968,
  [987] = 968,
  [988] = 894,
  [989] = 968,
  [990] = 906,
  [991] = 906,
  [992] = 971,
  [993] = 968,
  [994] = 971,
  [995] = 971,
  [996] = 893,
  [997] = 997,
  [998] = 998,
  [999] = 999,
  [1000] = 997,
  [1001] = 998,
  [1002] = 997,
  [1003] = 1003,
  [1004] = 1004,
  [1005] = 1004,
  [1006] = 998,
  [1007] = 998,
  [1008] = 1004,
  [1009] = 1004,
  [1010] = 997,
  [1011] = 1004,
  [1012] = 906,
  [1013] = 998,
  [1014] = 1014,
  [1015] = 999,
  [1016] = 999,
  [1017] = 998,
  [1018] = 1018,
  [1019] = 999,
  [1020] = 999,
  [1021] = 1021,
  [1022] = 1022,
  [1023] = 1023,
  [1024] = 1024,
  [1025] = 1025,
  [1026] = 1026,
  [1027] = 998,
  [1028] = 997,
  [1029] = 1004,
  [1030] = 1030,
  [1031] = 895,
  [1032] = 997,
  [1033] = 998,
  [1034] = 896,
  [1035] = 1035,
  [1036] = 892,
  [1037] = 1004,
  [1038] = 1038,
  [1039] = 999,
  [1040] = 998,
  [1041] = 998,
  [1042] = 999,
  [1043] = 997,
  [1044] = 997,
  [1045] = 999,
  [1046] = 1014,
  [1047] = 998,
  [1048] = 997,
  [1049] = 999,
  [1050] = 1014,
  [1051] = 997,
  [1052] = 1004,
  [1053] = 998,
  [1054] = 999,
  [1055] = 1004,
  [1056] = 997,
  [1057] = 1057,
  [1058] = 1058,
  [1059] = 1004,
  [1060] = 1060,
  [1061] = 1004,
  [1062] = 891,
  [1063] = 997,
  [1064] = 998,
  [1065] = 1004,
  [1066] = 999,
  [1067] = 998,
  [1068] = 999,
  [1069] = 997,
  [1070] = 999,
  [1071] = 999,
  [1072] = 1004,
  [1073] = 997,
  [1074] = 893,
  [1075] = 889,
  [1076] = 890,
  [1077] = 1004,
  [1078] = 997,
  [1079] = 1014,
  [1080] = 999,
  [1081] = 1004,
  [1082] = 1082,
  [1083] = 998,
  [1084] = 1084,
  [1085] = 1085,
  [1086] = 1086,
  [1087] = 1086,
  [1088] = 1085,
  [1089] = 1089,
  [1090] = 1090,
  [1091] = 1091,
  [1092] = 1089,
  [1093] = 1085,
  [1094] = 1085,
  [1095] = 1086,
  [1096] = 1086,
  [1097] = 1089,
  [1098] = 1086,
  [1099] = 1089,
  [1100] = 1086,
  [1101] = 1101,
  [1102] = 1086,
  [1103] = 1085,
  [1104] = 1104,
  [1105] = 1089,
  [1106] = 1085,
  [1107] = 1107,
  [1108] = 1086,
  [1109] = 1109,
  [1110] = 1085,
  [1111] = 1086,
  [1112] = 1112,
  [1113] = 1085,
  [1114] = 1114,
  [1115] = 1086,
  [1116] = 1085,
  [1117] = 1117,
  [1118] = 1086,
  [1119] = 1085,
  [1120] = 1120,
  [1121] = 1121,
  [1122] = 1086,
  [1123] = 1086,
  [1124] = 1085,
  [1125] = 1089,
  [1126] = 1085,
  [1127] = 1127,
  [1128] = 1128,
  [1129] = 1129,
  [1130] = 1086,
  [1131] = 1131,
  [1132] = 1085,
  [1133] = 1133,
  [1134] = 1086,
  [1135] = 1135,
  [1136] = 1085,
  [1137] = 1089,
  [1138] = 1085,
  [1139] = 1089,
  [1140] = 1140,
  [1141] = 1141,
  [1142] = 1142,
  [1143] = 1143,
  [1144] = 1141,
  [1145] = 1145,
  [1146] = 1146,
  [1147] = 1143,
  [1148] = 1142,
  [1149] = 906,
  [1150] = 1150,
  [1151] = 1151,
  [1152] = 1152,
  [1153] = 1153,
  [1154] = 1143,
  [1155] = 1155,
  [1156] = 1143,
  [1157] = 1157,
  [1158] = 890,
  [1159] = 1159,
  [1160] = 1155,
  [1161] = 1151,
  [1162] = 1141,
  [1163] = 1163,
  [1164] = 1141,
  [1165] = 889,
  [1166] = 1166,
  [1167] = 893,
  [1168] = 1140,
  [1169] = 892,
  [1170] = 1143,
  [1171] = 896,
  [1172] = 895,
  [1173] = 1143,
  [1174] = 891,
  [1175] = 1143,
  [1176] = 1155,
  [1177] = 1143,
  [1178] = 1155,
  [1179] = 1151,
  [1180] = 1141,
  [1181] = 1151,
  [1182] = 1146,
  [1183] = 1143,
  [1184] = 1141,
  [1185] = 1150,
  [1186] = 1186,
  [1187] = 1143,
  [1188] = 1141,
  [1189] = 1143,
  [1190] = 1143,
  [1191] = 1141,
  [1192] = 1142,
  [1193] = 1141,
  [1194] = 1141,
  [1195] = 1141,
  [1196] = 1196,
  [1197] = 1141,
  [1198] = 1198,
  [1199] = 1199,
  [1200] = 1200,
  [1201] = 1146,
  [1202] = 1202,
  [1203] = 1203,
  [1204] = 1155,
  [1205] = 1205,
  [1206] = 1151,
  [1207] = 1141,
  [1208] = 1198,
  [1209] = 1199,
  [1210] = 1200,
  [1211] = 1202,
  [1212] = 1203,
  [1213] = 1205,
  [1214] = 1214,
  [1215] = 1215,
  [1216] = 1216,
  [1217] = 1217,
  [1218] = 1218,
  [1219] = 1219,
  [1220] = 1220,
  [1221] = 1221,
  [1222] = 1222,
  [1223] = 1223,
  [1224] = 1224,
  [1225] = 1141,
  [1226] = 1226,
  [1227] = 1214,
  [1228] = 1215,
  [1229] = 1216,
  [1230] = 1217,
  [1231] = 1218,
  [1232] = 1146,
  [1233] = 1219,
  [1234] = 1220,
  [1235] = 1140,
  [1236] = 1221,
  [1237] = 1222,
  [1238] = 1142,
  [1239] = 1145,
  [1240] = 1240,
  [1241] = 1223,
  [1242] = 1224,
  [1243] = 1226,
  [1244] = 1240,
  [1245] = 1245,
  [1246] = 1245,
  [1247] = 1142,
  [1248] = 1152,
  [1249] = 1146,
  [1250] = 1250,
  [1251] = 1251,
  [1252] = 1252,
  [1253] = 1253,
  [1254] = 1250,
  [1255] = 1251,
  [1256] = 1252,
  [1257] = 1253,
  [1258] = 1141,
  [1259] = 1163,
  [1260] = 1166,
  [1261] = 1261,
  [1262] = 1262,
  [1263] = 1263,
  [1264] = 1264,
  [1265] = 1261,
  [1266] = 1266,
  [1267] = 1267,
  [1268] = 1268,
  [1269] = 1269,
  [1270] = 1270,
  [1271] = 1271,
  [1272] = 1262,
  [1273] = 1273,
  [1274] = 1274,
  [1275] = 1275,
  [1276] = 1264,
  [1277] = 1277,
  [1278] = 1278,
  [1279] = 1275,
  [1280] = 1262,
  [1281] = 1270,
  [1282] = 1282,
  [1283] = 1283,
  [1284] = 1284,
  [1285] = 1268,
  [1286] = 1274,
  [1287] = 1283,
  [1288] = 1261,
  [1289] = 1266,
  [1290] = 1290,
  [1291] = 1290,
  [1292] = 1277,
  [1293] = 1293,
  [1294] = 1273,
  [1295] = 1267,
  [1296] = 1283,
  [1297] = 1274,
  [1298] = 1264,
  [1299] = 1299,
  [1300] = 1300,
  [1301] = 1271,
  [1302] = 1275,
  [1303] = 1303,
  [1304] = 1273,
  [1305] = 1305,
  [1306] = 1267,
  [1307] = 1266,
  [1308] = 1305,
  [1309] = 1262,
  [1310] = 1261,
  [1311] = 1270,
  [1312] = 1284,
  [1313] = 1270,
  [1314] = 1271,
  [1315] = 1262,
  [1316] = 1275,
  [1317] = 1266,
  [1318] = 1267,
  [1319] = 1271,
  [1320] = 1320,
  [1321] = 1264,
  [1322] = 1274,
  [1323] = 1273,
  [1324] = 1283,
  [1325] = 1325,
  [1326] = 1284,
  [1327] = 1261,
  [1328] = 1266,
  [1329] = 1261,
  [1330] = 1330,
  [1331] = 1284,
  [1332] = 1267,
  [1333] = 1270,
  [1334] = 1284,
  [1335] = 1325,
  [1336] = 1262,
  [1337] = 1330,
  [1338] = 1325,
  [1339] = 1339,
  [1340] = 1282,
  [1341] = 1275,
  [1342] = 1264,
  [1343] = 1274,
  [1344] = 1282,
  [1345] = 1325,
  [1346] = 1330,
  [1347] = 1271,
  [1348] = 1348,
  [1349] = 1273,
  [1350] = 1274,
  [1351] = 1305,
  [1352] = 1283,
  [1353] = 1282,
  [1354] = 1267,
  [1355] = 1355,
  [1356] = 1356,
  [1357] = 1266,
  [1358] = 1268,
  [1359] = 1284,
  [1360] = 1270,
  [1361] = 1305,
  [1362] = 1290,
  [1363] = 1305,
  [1364] = 1262,
  [1365] = 1275,
  [1366] = 1264,
  [1367] = 1268,
  [1368] = 1368,
  [1369] = 1274,
  [1370] = 1283,
  [1371] = 1290,
  [1372] = 1277,
  [1373] = 1271,
  [1374] = 1374,
  [1375] = 1271,
  [1376] = 1273,
  [1377] = 1377,
  [1378] = 1271,
  [1379] = 1273,
  [1380] = 1330,
  [1381] = 1282,
  [1382] = 1374,
  [1383] = 1383,
  [1384] = 1290,
  [1385] = 1325,
  [1386] = 1377,
  [1387] = 1387,
  [1388] = 1282,
  [1389] = 1277,
  [1390] = 1390,
  [1391] = 1377,
  [1392] = 1392,
  [1393] = 1330,
  [1394] = 1377,
  [1395] = 1395,
  [1396] = 1290,
  [1397] = 1330,
  [1398] = 1325,
  [1399] = 1277,
  [1400] = 1282,
  [1401] = 1401,
  [1402] = 1277,
  [1403] = 1387,
  [1404] = 1404,
  [1405] = 1268,
  [1406] = 1283,
  [1407] = 1305,
  [1408] = 1283,
  [1409] = 1273,
  [1410] = 1264,
  [1411] = 1268,
  [1412] = 1275,
  [1413] = 1330,
  [1414] = 1262,
  [1415] = 1270,
  [1416] = 1284,
  [1417] = 1273,
  [1418] = 1271,
  [1419] = 1261,
  [1420] = 1266,
  [1421] = 1267,
  [1422] = 1267,
  [1423] = 1266,
  [1424] = 1261,
  [1425] = 1290,
  [1426] = 1269,
  [1427] = 1305,
  [1428] = 1293,
  [1429] = 1274,
  [1430] = 1374,
  [1431] = 1271,
  [1432] = 1264,
  [1433] = 1433,
  [1434] = 1284,
  [1435] = 1275,
  [1436] = 1262,
  [1437] = 1437,
  [1438] = 1268,
  [1439] = 1439,
  [1440] = 1268,
  [1441] = 1368,
  [1442] = 1270,
  [1443] = 1268,
  [1444] = 1270,
  [1445] = 1445,
  [1446] = 1277,
  [1447] = 1283,
  [1448] = 1448,
  [1449] = 1274,
  [1450] = 1264,
  [1451] = 1392,
  [1452] = 1275,
  [1453] = 1284,
  [1454] = 1262,
  [1455] = 1395,
  [1456] = 1261,
  [1457] = 1266,
  [1458] = 1271,
  [1459] = 1262,
  [1460] = 1270,
  [1461] = 1293,
  [1462] = 1275,
  [1463] = 1433,
  [1464] = 1264,
  [1465] = 1267,
  [1466] = 1437,
  [1467] = 1439,
  [1468] = 1274,
  [1469] = 1368,
  [1470] = 1274,
  [1471] = 1261,
  [1472] = 1266,
  [1473] = 1283,
  [1474] = 1267,
  [1475] = 1305,
  [1476] = 1305,
  [1477] = 1448,
  [1478] = 1305,
  [1479] = 1392,
  [1480] = 1330,
  [1481] = 1395,
  [1482] = 1325,
  [1483] = 1330,
  [1484] = 1305,
  [1485] = 1267,
  [1486] = 1266,
  [1487] = 1261,
  [1488] = 1284,
  [1489] = 1282,
  [1490] = 1270,
  [1491] = 1284,
  [1492] = 1277,
  [1493] = 1433,
  [1494] = 1275,
  [1495] = 1264,
  [1496] = 1274,
  [1497] = 1283,
  [1498] = 1267,
  [1499] = 1277,
  [1500] = 1293,
  [1501] = 1433,
  [1502] = 1266,
  [1503] = 1437,
  [1504] = 1439,
  [1505] = 1368,
  [1506] = 1392,
  [1507] = 1448,
  [1508] = 1392,
  [1509] = 1395,
  [1510] = 1330,
  [1511] = 1330,
  [1512] = 1293,
  [1513] = 1325,
  [1514] = 1282,
  [1515] = 1433,
  [1516] = 1325,
  [1517] = 1517,
  [1518] = 1437,
  [1519] = 1282,
  [1520] = 1439,
  [1521] = 1368,
  [1522] = 1268,
  [1523] = 1448,
  [1524] = 1305,
  [1525] = 1293,
  [1526] = 1433,
  [1527] = 1445,
  [1528] = 1330,
  [1529] = 1283,
  [1530] = 1448,
  [1531] = 1437,
  [1532] = 1439,
  [1533] = 1274,
  [1534] = 1377,
  [1535] = 1368,
  [1536] = 1377,
  [1537] = 1356,
  [1538] = 1355,
  [1539] = 1268,
  [1540] = 1264,
  [1541] = 1437,
  [1542] = 1448,
  [1543] = 1275,
  [1544] = 1293,
  [1545] = 1433,
  [1546] = 1437,
  [1547] = 1547,
  [1548] = 1277,
  [1549] = 1439,
  [1550] = 1439,
  [1551] = 1368,
  [1552] = 1277,
  [1553] = 1448,
  [1554] = 1262,
  [1555] = 1433,
  [1556] = 1439,
  [1557] = 1262,
  [1558] = 1448,
  [1559] = 1559,
  [1560] = 1433,
  [1561] = 1277,
  [1562] = 1562,
  [1563] = 1261,
  [1564] = 1282,
  [1565] = 1325,
  [1566] = 1330,
  [1567] = 1305,
  [1568] = 1271,
  [1569] = 1273,
  [1570] = 1270,
  [1571] = 1282,
  [1572] = 1325,
  [1573] = 1277,
  [1574] = 1284,
  [1575] = 1390,
  [1576] = 1261,
  [1577] = 1266,
  [1578] = 1578,
  [1579] = 1273,
  [1580] = 1268,
  [1581] = 1268,
  [1582] = 1283,
  [1583] = 1271,
  [1584] = 1273,
  [1585] = 1267,
  [1586] = 1330,
  [1587] = 1284,
  [1588] = 1283,
  [1589] = 1274,
  [1590] = 1264,
  [1591] = 1275,
  [1592] = 1290,
  [1593] = 1325,
  [1594] = 1270,
  [1595] = 1270,
  [1596] = 1264,
  [1597] = 1267,
  [1598] = 1284,
  [1599] = 1261,
  [1600] = 1266,
  [1601] = 1277,
  [1602] = 1262,
  [1603] = 1267,
  [1604] = 1305,
  [1605] = 1275,
  [1606] = 1547,
  [1607] = 1275,
  [1608] = 1268,
  [1609] = 1264,
  [1610] = 1277,
  [1611] = 1271,
  [1612] = 1273,
  [1613] = 1268,
  [1614] = 1266,
  [1615] = 1325,
  [1616] = 1282,
  [1617] = 1395,
  [1618] = 1273,
  [1619] = 1325,
  [1620] = 1282,
  [1621] = 1282,
  [1622] = 1578,
  [1623] = 1262,
  [1624] = 1270,
  [1625] = 1390,
  [1626] = 1325,
  [1627] = 1330,
  [1628] = 1271,
  [1629] = 1284,
  [1630] = 1390,
  [1631] = 1261,
  [1632] = 1390,
  [1633] = 1390,
  [1634] = 1390,
  [1635] = 1635,
  [1636] = 1377,
  [1637] = 1273,
  [1638] = 1283,
  [1639] = 1274,
  [1640] = 1305,
  [1641] = 882,
  [1642] = 882,
  [1643] = 882,
  [1644] = 906,
  [1645] = 1645,
  [1646] = 1645,
  [1647] = 1645,
  [1648] = 1645,
  [1649] = 1649,
  [1650] = 890,
  [1651] = 1651,
  [1652] = 1649,
  [1653] = 1649,
  [1654] = 891,
  [1655] = 1649,
  [1656] = 1649,
  [1657] = 1649,
  [1658] = 895,
  [1659] = 896,
  [1660] = 1649,
  [1661] = 892,
  [1662] = 889,
  [1663] = 893,
  [1664] = 1664,
  [1665] = 1665,
  [1666] = 1666,
  [1667] = 1667,
  [1668] = 1668,
  [1669] = 1669,
  [1670] = 1670,
  [1671] = 1671,
  [1672] = 1672,
  [1673] = 1673,
  [1674] = 1674,
  [1675] = 1675,
  [1676] = 1676,
  [1677] = 1677,
  [1678] = 1677,
  [1679] = 1679,
  [1680] = 1680,
  [1681] = 906,
  [1682] = 906,
  [1683] = 1683,
  [1684] = 1684,
  [1685] = 1684,
  [1686] = 1684,
  [1687] = 1684,
  [1688] = 1684,
  [1689] = 134,
  [1690] = 135,
  [1691] = 136,
  [1692] = 133,
  [1693] = 1693,
  [1694] = 1694,
  [1695] = 1695,
  [1696] = 1696,
  [1697] = 1697,
  [1698] = 1695,
  [1699] = 1697,
  [1700] = 149,
  [1701] = 1697,
  [1702] = 1697,
  [1703] = 1697,
  [1704] = 1695,
  [1705] = 1697,
  [1706] = 1695,
  [1707] = 149,
  [1708] = 1697,
  [1709] = 132,
  [1710] = 1710,
  [1711] = 895,
  [1712] = 896,
  [1713] = 892,
  [1714] = 138,
  [1715] = 131,
  [1716] = 893,
  [1717] = 889,
  [1718] = 891,
  [1719] = 890,
  [1720] = 1720,
  [1721] = 194,
  [1722] = 151,
  [1723] = 150,
  [1724] = 891,
  [1725] = 1725,
  [1726] = 1726,
  [1727] = 895,
  [1728] = 288,
  [1729] = 896,
  [1730] = 892,
  [1731] = 1731,
  [1732] = 893,
  [1733] = 889,
  [1734] = 890,
  [1735] = 1735,
  [1736] = 1736,
  [1737] = 1737,
  [1738] = 1738,
  [1739] = 294,
  [1740] = 1740,
  [1741] = 298,
  [1742] = 1742,
  [1743] = 1743,
  [1744] = 299,
  [1745] = 1745,
  [1746] = 1746,
  [1747] = 1747,
  [1748] = 1748,
  [1749] = 1749,
  [1750] = 1750,
  [1751] = 180,
  [1752] = 285,
  [1753] = 295,
  [1754] = 216,
  [1755] = 1755,
  [1756] = 1756,
  [1757] = 209,
  [1758] = 1758,
  [1759] = 1759,
  [1760] = 302,
  [1761] = 1761,
  [1762] = 1762,
  [1763] = 1763,
  [1764] = 1764,
  [1765] = 291,
  [1766] = 279,
  [1767] = 1767,
  [1768] = 1768,
  [1769] = 1769,
  [1770] = 182,
  [1771] = 187,
  [1772] = 1772,
  [1773] = 1773,
  [1774] = 1774,
  [1775] = 1775,
  [1776] = 1776,
  [1777] = 1777,
  [1778] = 277,
  [1779] = 276,
  [1780] = 1780,
  [1781] = 1781,
  [1782] = 147,
  [1783] = 275,
  [1784] = 221,
  [1785] = 274,
  [1786] = 146,
  [1787] = 143,
  [1788] = 208,
  [1789] = 290,
  [1790] = 175,
  [1791] = 253,
  [1792] = 266,
  [1793] = 183,
  [1794] = 189,
  [1795] = 190,
  [1796] = 191,
  [1797] = 264,
  [1798] = 263,
  [1799] = 155,
  [1800] = 260,
  [1801] = 154,
  [1802] = 235,
  [1803] = 197,
  [1804] = 185,
  [1805] = 234,
  [1806] = 231,
  [1807] = 230,
  [1808] = 145,
  [1809] = 227,
  [1810] = 226,
  [1811] = 222,
  [1812] = 220,
  [1813] = 219,
  [1814] = 207,
  [1815] = 174,
  [1816] = 215,
  [1817] = 134,
  [1818] = 135,
  [1819] = 1819,
  [1820] = 1819,
  [1821] = 1819,
  [1822] = 1819,
  [1823] = 134,
  [1824] = 1819,
  [1825] = 133,
  [1826] = 135,
  [1827] = 1827,
  [1828] = 136,
  [1829] = 133,
  [1830] = 1830,
  [1831] = 906,
  [1832] = 1832,
  [1833] = 1833,
  [1834] = 136,
  [1835] = 1819,
  [1836] = 894,
  [1837] = 1819,
  [1838] = 149,
  [1839] = 1839,
  [1840] = 1839,
  [1841] = 1839,
  [1842] = 149,
  [1843] = 149,
  [1844] = 894,
  [1845] = 149,
  [1846] = 1846,
  [1847] = 1839,
  [1848] = 1848,
  [1849] = 1849,
  [1850] = 896,
  [1851] = 1851,
  [1852] = 906,
  [1853] = 1853,
  [1854] = 138,
  [1855] = 1855,
  [1856] = 893,
  [1857] = 889,
  [1858] = 138,
  [1859] = 1859,
  [1860] = 1860,
  [1861] = 890,
  [1862] = 894,
  [1863] = 892,
  [1864] = 1864,
  [1865] = 132,
  [1866] = 891,
  [1867] = 1710,
  [1868] = 1868,
  [1869] = 131,
  [1870] = 131,
  [1871] = 1871,
  [1872] = 132,
  [1873] = 895,
  [1874] = 1874,
  [1875] = 1737,
  [1876] = 191,
  [1877] = 194,
  [1878] = 175,
  [1879] = 1777,
  [1880] = 1776,
  [1881] = 197,
  [1882] = 1775,
  [1883] = 1774,
  [1884] = 208,
  [1885] = 1773,
  [1886] = 1772,
  [1887] = 185,
  [1888] = 294,
  [1889] = 1781,
  [1890] = 1780,
  [1891] = 1777,
  [1892] = 1776,
  [1893] = 1769,
  [1894] = 1775,
  [1895] = 1774,
  [1896] = 1896,
  [1897] = 1773,
  [1898] = 194,
  [1899] = 1772,
  [1900] = 1769,
  [1901] = 1768,
  [1902] = 189,
  [1903] = 1767,
  [1904] = 1764,
  [1905] = 1763,
  [1906] = 1762,
  [1907] = 1759,
  [1908] = 1756,
  [1909] = 1909,
  [1910] = 1755,
  [1911] = 1750,
  [1912] = 1749,
  [1913] = 1748,
  [1914] = 1914,
  [1915] = 1720,
  [1916] = 1916,
  [1917] = 1747,
  [1918] = 1746,
  [1919] = 1745,
  [1920] = 1743,
  [1921] = 1742,
  [1922] = 788,
  [1923] = 207,
  [1924] = 215,
  [1925] = 183,
  [1926] = 285,
  [1927] = 208,
  [1928] = 219,
  [1929] = 220,
  [1930] = 183,
  [1931] = 189,
  [1932] = 1932,
  [1933] = 222,
  [1934] = 226,
  [1935] = 253,
  [1936] = 227,
  [1937] = 1937,
  [1938] = 230,
  [1939] = 231,
  [1940] = 1940,
  [1941] = 290,
  [1942] = 1942,
  [1943] = 234,
  [1944] = 1944,
  [1945] = 1945,
  [1946] = 235,
  [1947] = 174,
  [1948] = 1948,
  [1949] = 155,
  [1950] = 154,
  [1951] = 1951,
  [1952] = 1952,
  [1953] = 190,
  [1954] = 295,
  [1955] = 1740,
  [1956] = 1738,
  [1957] = 1737,
  [1958] = 1736,
  [1959] = 1735,
  [1960] = 1731,
  [1961] = 1726,
  [1962] = 1725,
  [1963] = 216,
  [1964] = 209,
  [1965] = 260,
  [1966] = 302,
  [1967] = 263,
  [1968] = 264,
  [1969] = 191,
  [1970] = 1735,
  [1971] = 266,
  [1972] = 1972,
  [1973] = 197,
  [1974] = 185,
  [1975] = 143,
  [1976] = 274,
  [1977] = 275,
  [1978] = 276,
  [1979] = 277,
  [1980] = 279,
  [1981] = 146,
  [1982] = 291,
  [1983] = 291,
  [1984] = 302,
  [1985] = 295,
  [1986] = 182,
  [1987] = 187,
  [1988] = 285,
  [1989] = 180,
  [1990] = 147,
  [1991] = 150,
  [1992] = 299,
  [1993] = 1768,
  [1994] = 298,
  [1995] = 187,
  [1996] = 294,
  [1997] = 906,
  [1998] = 221,
  [1999] = 288,
  [2000] = 279,
  [2001] = 2001,
  [2002] = 151,
  [2003] = 2003,
  [2004] = 1740,
  [2005] = 277,
  [2006] = 1738,
  [2007] = 1758,
  [2008] = 1761,
  [2009] = 2009,
  [2010] = 207,
  [2011] = 2011,
  [2012] = 190,
  [2013] = 2013,
  [2014] = 1736,
  [2015] = 151,
  [2016] = 2016,
  [2017] = 1767,
  [2018] = 150,
  [2019] = 2019,
  [2020] = 276,
  [2021] = 2021,
  [2022] = 288,
  [2023] = 219,
  [2024] = 2024,
  [2025] = 220,
  [2026] = 2026,
  [2027] = 215,
  [2028] = 263,
  [2029] = 1780,
  [2030] = 1781,
  [2031] = 1731,
  [2032] = 147,
  [2033] = 146,
  [2034] = 143,
  [2035] = 2035,
  [2036] = 1726,
  [2037] = 1749,
  [2038] = 1750,
  [2039] = 1764,
  [2040] = 260,
  [2041] = 1763,
  [2042] = 1762,
  [2043] = 222,
  [2044] = 174,
  [2045] = 2045,
  [2046] = 2046,
  [2047] = 1759,
  [2048] = 2048,
  [2049] = 1742,
  [2050] = 894,
  [2051] = 1743,
  [2052] = 1745,
  [2053] = 1651,
  [2054] = 1758,
  [2055] = 221,
  [2056] = 209,
  [2057] = 2057,
  [2058] = 1746,
  [2059] = 1747,
  [2060] = 216,
  [2061] = 1720,
  [2062] = 1748,
  [2063] = 145,
  [2064] = 2064,
  [2065] = 1761,
  [2066] = 1756,
  [2067] = 2067,
  [2068] = 154,
  [2069] = 155,
  [2070] = 253,
  [2071] = 175,
  [2072] = 290,
  [2073] = 2073,
  [2074] = 787,
  [2075] = 298,
  [2076] = 299,
  [2077] = 180,
  [2078] = 1725,
  [2079] = 226,
  [2080] = 227,
  [2081] = 230,
  [2082] = 231,
  [2083] = 234,
  [2084] = 235,
  [2085] = 2085,
  [2086] = 2086,
  [2087] = 2087,
  [2088] = 2088,
  [2089] = 275,
  [2090] = 145,
  [2091] = 2091,
  [2092] = 274,
  [2093] = 2093,
  [2094] = 2094,
  [2095] = 2095,
  [2096] = 2096,
  [2097] = 266,
  [2098] = 264,
  [2099] = 1755,
  [2100] = 182,
  [2101] = 2101,
  [2102] = 892,
  [2103] = 1832,
  [2104] = 1853,
  [2105] = 1833,
  [2106] = 2106,
  [2107] = 1853,
  [2108] = 1830,
  [2109] = 1851,
  [2110] = 1849,
  [2111] = 1860,
  [2112] = 1849,
  [2113] = 1851,
  [2114] = 1972,
  [2115] = 906,
  [2116] = 131,
  [2117] = 891,
  [2118] = 896,
  [2119] = 895,
  [2120] = 1860,
  [2121] = 893,
  [2122] = 889,
  [2123] = 890,
  [2124] = 2124,
  [2125] = 1972,
  [2126] = 2126,
  [2127] = 132,
  [2128] = 2128,
  [2129] = 2129,
  [2130] = 2130,
  [2131] = 2131,
  [2132] = 2132,
  [2133] = 2133,
  [2134] = 2134,
  [2135] = 2135,
  [2136] = 2136,
  [2137] = 2137,
  [2138] = 2138,
  [2139] = 2139,
  [2140] = 2140,
  [2141] = 2141,
  [2142] = 2142,
  [2143] = 2143,
  [2144] = 2144,
  [2145] = 2145,
  [2146] = 2146,
  [2147] = 2147,
  [2148] = 2148,
  [2149] = 2149,
  [2150] = 1952,
  [2151] = 2151,
  [2152] = 1710,
  [2153] = 2153,
  [2154] = 1859,
  [2155] = 1864,
  [2156] = 2156,
  [2157] = 2048,
  [2158] = 2149,
  [2159] = 2159,
  [2160] = 1848,
  [2161] = 2149,
  [2162] = 1710,
  [2163] = 1855,
  [2164] = 2013,
  [2165] = 2148,
  [2166] = 1951,
  [2167] = 2086,
  [2168] = 2168,
  [2169] = 1916,
  [2170] = 1914,
  [2171] = 1909,
  [2172] = 1940,
  [2173] = 2048,
  [2174] = 2009,
  [2175] = 1937,
  [2176] = 2011,
  [2177] = 1874,
  [2178] = 2093,
  [2179] = 1942,
  [2180] = 2016,
  [2181] = 2046,
  [2182] = 2003,
  [2183] = 2101,
  [2184] = 2088,
  [2185] = 2064,
  [2186] = 2186,
  [2187] = 2087,
  [2188] = 1932,
  [2189] = 1948,
  [2190] = 2145,
  [2191] = 2045,
  [2192] = 2019,
  [2193] = 1896,
  [2194] = 2021,
  [2195] = 2195,
  [2196] = 2094,
  [2197] = 2073,
  [2198] = 2035,
  [2199] = 2095,
  [2200] = 2024,
  [2201] = 2057,
  [2202] = 1952,
  [2203] = 1945,
  [2204] = 2085,
  [2205] = 2148,
  [2206] = 1944,
  [2207] = 2145,
  [2208] = 2091,
  [2209] = 2096,
  [2210] = 2130,
  [2211] = 2211,
  [2212] = 2148,
  [2213] = 2213,
  [2214] = 1868,
  [2215] = 2215,
  [2216] = 2149,
  [2217] = 2217,
  [2218] = 2134,
  [2219] = 2133,
  [2220] = 2135,
  [2221] = 2221,
  [2222] = 2222,
  [2223] = 2135,
  [2224] = 2224,
  [2225] = 2134,
  [2226] = 2129,
  [2227] = 2227,
  [2228] = 2137,
  [2229] = 2229,
  [2230] = 2132,
  [2231] = 2130,
  [2232] = 2232,
  [2233] = 2233,
  [2234] = 2234,
  [2235] = 2129,
  [2236] = 2133,
  [2237] = 2137,
  [2238] = 2238,
  [2239] = 2239,
  [2240] = 2145,
  [2241] = 2241,
  [2242] = 2242,
  [2243] = 1710,
  [2244] = 2244,
  [2245] = 2132,
  [2246] = 2246,
  [2247] = 1871,
  [2248] = 2248,
  [2249] = 892,
  [2250] = 889,
  [2251] = 2251,
  [2252] = 893,
  [2253] = 1855,
  [2254] = 1860,
  [2255] = 2241,
  [2256] = 2248,
  [2257] = 2257,
  [2258] = 2136,
  [2259] = 1651,
  [2260] = 2260,
  [2261] = 2261,
  [2262] = 1853,
  [2263] = 2136,
  [2264] = 2264,
  [2265] = 2251,
  [2266] = 2251,
  [2267] = 2251,
  [2268] = 890,
  [2269] = 1832,
  [2270] = 2261,
  [2271] = 896,
  [2272] = 895,
  [2273] = 2260,
  [2274] = 2248,
  [2275] = 2248,
  [2276] = 1849,
  [2277] = 2248,
  [2278] = 2248,
  [2279] = 2239,
  [2280] = 1851,
  [2281] = 2261,
  [2282] = 891,
  [2283] = 2248,
  [2284] = 1855,
  [2285] = 2153,
  [2286] = 2168,
  [2287] = 2026,
  [2288] = 2001,
  [2289] = 2264,
  [2290] = 2001,
  [2291] = 2067,
  [2292] = 2186,
  [2293] = 2264,
  [2294] = 2294,
  [2295] = 2264,
  [2296] = 1855,
  [2297] = 1651,
  [2298] = 2067,
  [2299] = 2264,
  [2300] = 1855,
  [2301] = 2264,
  [2302] = 2026,
  [2303] = 2294,
  [2304] = 1855,
  [2305] = 1833,
  [2306] = 2306,
  [2307] = 1972,
  [2308] = 1952,
  [2309] = 2309,
  [2310] = 2310,
  [2311] = 2142,
  [2312] = 2312,
  [2313] = 1651,
  [2314] = 2310,
  [2315] = 2310,
  [2316] = 895,
  [2317] = 2227,
  [2318] = 896,
  [2319] = 892,
  [2320] = 2001,
  [2321] = 1952,
  [2322] = 1859,
  [2323] = 1855,
  [2324] = 2048,
  [2325] = 2211,
  [2326] = 2326,
  [2327] = 2310,
  [2328] = 1855,
  [2329] = 893,
  [2330] = 1864,
  [2331] = 2310,
  [2332] = 889,
  [2333] = 2310,
  [2334] = 2229,
  [2335] = 2233,
  [2336] = 2067,
  [2337] = 890,
  [2338] = 1853,
  [2339] = 1849,
  [2340] = 2139,
  [2341] = 2341,
  [2342] = 1860,
  [2343] = 2222,
  [2344] = 1855,
  [2345] = 1848,
  [2346] = 2346,
  [2347] = 2067,
  [2348] = 2140,
  [2349] = 2026,
  [2350] = 891,
  [2351] = 2246,
  [2352] = 2217,
  [2353] = 2186,
  [2354] = 2224,
  [2355] = 2153,
  [2356] = 2310,
  [2357] = 2026,
  [2358] = 2186,
  [2359] = 1855,
  [2360] = 2168,
  [2361] = 1851,
  [2362] = 2244,
  [2363] = 2168,
  [2364] = 2364,
  [2365] = 1855,
  [2366] = 2213,
  [2367] = 2048,
  [2368] = 1855,
  [2369] = 2147,
  [2370] = 2001,
  [2371] = 2326,
  [2372] = 2234,
  [2373] = 2242,
  [2374] = 2227,
  [2375] = 2375,
  [2376] = 2011,
  [2377] = 2377,
  [2378] = 1710,
  [2379] = 2153,
  [2380] = 2380,
  [2381] = 2381,
  [2382] = 2135,
  [2383] = 2383,
  [2384] = 2234,
  [2385] = 1972,
  [2386] = 2244,
  [2387] = 2242,
  [2388] = 2388,
  [2389] = 2389,
  [2390] = 2021,
  [2391] = 2088,
  [2392] = 2392,
  [2393] = 2087,
  [2394] = 2086,
  [2395] = 2085,
  [2396] = 2024,
  [2397] = 2241,
  [2398] = 2398,
  [2399] = 2213,
  [2400] = 2400,
  [2401] = 1951,
  [2402] = 1948,
  [2403] = 2403,
  [2404] = 1945,
  [2405] = 1944,
  [2406] = 1942,
  [2407] = 1940,
  [2408] = 2408,
  [2409] = 2409,
  [2410] = 2410,
  [2411] = 1937,
  [2412] = 2124,
  [2413] = 1874,
  [2414] = 2414,
  [2415] = 1932,
  [2416] = 2416,
  [2417] = 2035,
  [2418] = 2134,
  [2419] = 2091,
  [2420] = 1832,
  [2421] = 2016,
  [2422] = 2096,
  [2423] = 2073,
  [2424] = 2019,
  [2425] = 2064,
  [2426] = 2046,
  [2427] = 2045,
  [2428] = 2239,
  [2429] = 2013,
  [2430] = 2133,
  [2431] = 2241,
  [2432] = 2432,
  [2433] = 2433,
  [2434] = 2222,
  [2435] = 894,
  [2436] = 2229,
  [2437] = 2101,
  [2438] = 2132,
  [2439] = 2095,
  [2440] = 2057,
  [2441] = 2124,
  [2442] = 2326,
  [2443] = 2009,
  [2444] = 2211,
  [2445] = 1916,
  [2446] = 2094,
  [2447] = 2129,
  [2448] = 2246,
  [2449] = 2239,
  [2450] = 1914,
  [2451] = 2224,
  [2452] = 1909,
  [2453] = 1896,
  [2454] = 2233,
  [2455] = 2130,
  [2456] = 2456,
  [2457] = 2137,
  [2458] = 2093,
  [2459] = 2217,
  [2460] = 2003,
  [2461] = 2140,
  [2462] = 2130,
  [2463] = 2241,
  [2464] = 2464,
  [2465] = 1896,
  [2466] = 2140,
  [2467] = 2467,
  [2468] = 2213,
  [2469] = 2469,
  [2470] = 1952,
  [2471] = 2471,
  [2472] = 1972,
  [2473] = 2101,
  [2474] = 2224,
  [2475] = 2244,
  [2476] = 2139,
  [2477] = 1859,
  [2478] = 2234,
  [2479] = 2479,
  [2480] = 2480,
  [2481] = 2222,
  [2482] = 2482,
  [2483] = 1940,
  [2484] = 2233,
  [2485] = 2485,
  [2486] = 2147,
  [2487] = 2487,
  [2488] = 2093,
  [2489] = 2001,
  [2490] = 2241,
  [2491] = 2137,
  [2492] = 2229,
  [2493] = 2147,
  [2494] = 2239,
  [2495] = 1864,
  [2496] = 2129,
  [2497] = 2497,
  [2498] = 2498,
  [2499] = 2499,
  [2500] = 2242,
  [2501] = 1932,
  [2502] = 906,
  [2503] = 2136,
  [2504] = 2504,
  [2505] = 2505,
  [2506] = 1848,
  [2507] = 2048,
  [2508] = 2142,
  [2509] = 2086,
  [2510] = 2026,
  [2511] = 2511,
  [2512] = 2217,
  [2513] = 2139,
  [2514] = 2135,
  [2515] = 2134,
  [2516] = 2239,
  [2517] = 2227,
  [2518] = 2132,
  [2519] = 2067,
  [2520] = 2133,
  [2521] = 2136,
  [2522] = 2142,
  [2523] = 1871,
  [2524] = 2211,
  [2525] = 1868,
  [2526] = 2246,
  [2527] = 1916,
  [2528] = 2140,
  [2529] = 2529,
  [2530] = 2139,
  [2531] = 2142,
  [2532] = 2139,
  [2533] = 2533,
  [2534] = 2147,
  [2535] = 2147,
  [2536] = 2536,
  [2537] = 2537,
  [2538] = 2538,
  [2539] = 2539,
  [2540] = 2540,
  [2541] = 2147,
  [2542] = 2542,
  [2543] = 2543,
  [2544] = 2544,
  [2545] = 2545,
  [2546] = 2546,
  [2547] = 2547,
  [2548] = 2149,
  [2549] = 2545,
  [2550] = 2550,
  [2551] = 1952,
  [2552] = 2142,
  [2553] = 2140,
  [2554] = 2035,
  [2555] = 2019,
  [2556] = 2545,
  [2557] = 2124,
  [2558] = 2558,
  [2559] = 2467,
  [2560] = 2016,
  [2561] = 2013,
  [2562] = 2009,
  [2563] = 1914,
  [2564] = 2326,
  [2565] = 1909,
  [2566] = 2011,
  [2567] = 2140,
  [2568] = 2558,
  [2569] = 2057,
  [2570] = 2085,
  [2571] = 2558,
  [2572] = 2572,
  [2573] = 2003,
  [2574] = 2558,
  [2575] = 2091,
  [2576] = 2096,
  [2577] = 2469,
  [2578] = 2545,
  [2579] = 2095,
  [2580] = 2094,
  [2581] = 2153,
  [2582] = 787,
  [2583] = 2545,
  [2584] = 1710,
  [2585] = 2585,
  [2586] = 2088,
  [2587] = 2087,
  [2588] = 2139,
  [2589] = 1832,
  [2590] = 2048,
  [2591] = 2195,
  [2592] = 788,
  [2593] = 2593,
  [2594] = 1951,
  [2595] = 1948,
  [2596] = 2545,
  [2597] = 1945,
  [2598] = 2021,
  [2599] = 2024,
  [2600] = 2600,
  [2601] = 1944,
  [2602] = 1942,
  [2603] = 2073,
  [2604] = 2124,
  [2605] = 2064,
  [2606] = 2545,
  [2607] = 2147,
  [2608] = 2608,
  [2609] = 2140,
  [2610] = 2142,
  [2611] = 1830,
  [2612] = 2139,
  [2613] = 2046,
  [2614] = 2045,
  [2615] = 1874,
  [2616] = 1937,
  [2617] = 2142,
  [2618] = 2618,
  [2619] = 2619,
  [2620] = 2137,
  [2621] = 2147,
  [2622] = 2140,
  [2623] = 2623,
  [2624] = 2142,
  [2625] = 2625,
  [2626] = 787,
  [2627] = 2627,
  [2628] = 2628,
  [2629] = 1710,
  [2630] = 2149,
  [2631] = 2537,
  [2632] = 2632,
  [2633] = 1952,
  [2634] = 2130,
  [2635] = 2129,
  [2636] = 2636,
  [2637] = 2637,
  [2638] = 2136,
  [2639] = 2639,
  [2640] = 132,
  [2641] = 2641,
  [2642] = 2048,
  [2643] = 2498,
  [2644] = 2644,
  [2645] = 2149,
  [2646] = 131,
  [2647] = 1679,
  [2648] = 2648,
  [2649] = 2649,
  [2650] = 2106,
  [2651] = 2651,
  [2652] = 2652,
  [2653] = 2653,
  [2654] = 2153,
  [2655] = 788,
  [2656] = 2139,
  [2657] = 2147,
  [2658] = 2658,
  [2659] = 2659,
  [2660] = 2660,
  [2661] = 1667,
  [2662] = 1676,
  [2663] = 2126,
  [2664] = 1665,
  [2665] = 2665,
  [2666] = 1668,
  [2667] = 2241,
  [2668] = 2668,
  [2669] = 2669,
  [2670] = 2670,
  [2671] = 2469,
  [2672] = 2672,
  [2673] = 2673,
  [2674] = 2674,
  [2675] = 2135,
  [2676] = 2134,
  [2677] = 2239,
  [2678] = 2678,
  [2679] = 2139,
  [2680] = 2153,
  [2681] = 1868,
  [2682] = 1680,
  [2683] = 1675,
  [2684] = 1673,
  [2685] = 2498,
  [2686] = 2686,
  [2687] = 1670,
  [2688] = 1671,
  [2689] = 2132,
  [2690] = 2690,
  [2691] = 2691,
  [2692] = 2149,
  [2693] = 2693,
  [2694] = 2133,
  [2695] = 2479,
  [2696] = 1952,
  [2697] = 2608,
  [2698] = 2698,
  [2699] = 2699,
  [2700] = 1674,
  [2701] = 2701,
  [2702] = 2702,
  [2703] = 2703,
  [2704] = 2704,
  [2705] = 1871,
  [2706] = 2706,
  [2707] = 2326,
  [2708] = 2708,
  [2709] = 2709,
  [2710] = 2710,
  [2711] = 1710,
  [2712] = 2712,
  [2713] = 1669,
  [2714] = 2544,
  [2715] = 2048,
  [2716] = 2716,
  [2717] = 2717,
  [2718] = 2718,
  [2719] = 2719,
  [2720] = 2159,
  [2721] = 2721,
  [2722] = 2722,
  [2723] = 2723,
  [2724] = 2306,
  [2725] = 2725,
  [2726] = 2726,
  [2727] = 2467,
  [2728] = 2728,
  [2729] = 2142,
  [2730] = 2730,
  [2731] = 2731,
  [2732] = 2140,
  [2733] = 2403,
  [2734] = 2734,
  [2735] = 2735,
  [2736] = 2736,
  [2737] = 2737,
  [2738] = 2738,
  [2739] = 1672,
  [2740] = 2479,
  [2741] = 2741,
  [2742] = 2742,
  [2743] = 1666,
  [2744] = 1664,
  [2745] = 1871,
  [2746] = 2326,
  [2747] = 906,
  [2748] = 2147,
  [2749] = 2001,
  [2750] = 2498,
  [2751] = 2135,
  [2752] = 2067,
  [2753] = 2753,
  [2754] = 2134,
  [2755] = 2326,
  [2756] = 2132,
  [2757] = 2467,
  [2758] = 2026,
  [2759] = 1871,
  [2760] = 1868,
  [2761] = 2479,
  [2762] = 2129,
  [2763] = 2133,
  [2764] = 2139,
  [2765] = 2142,
  [2766] = 2140,
  [2767] = 1868,
  [2768] = 2137,
  [2769] = 2469,
  [2770] = 2130,
  [2771] = 2048,
  [2772] = 894,
  [2773] = 2137,
  [2774] = 2774,
  [2775] = 2147,
  [2776] = 2774,
  [2777] = 2777,
  [2778] = 2778,
  [2779] = 2153,
  [2780] = 2135,
  [2781] = 2149,
  [2782] = 2134,
  [2783] = 2777,
  [2784] = 2774,
  [2785] = 2137,
  [2786] = 2786,
  [2787] = 2133,
  [2788] = 2130,
  [2789] = 2469,
  [2790] = 2129,
  [2791] = 2778,
  [2792] = 1871,
  [2793] = 2135,
  [2794] = 1851,
  [2795] = 2139,
  [2796] = 2147,
  [2797] = 2326,
  [2798] = 2798,
  [2799] = 2778,
  [2800] = 2777,
  [2801] = 2778,
  [2802] = 1853,
  [2803] = 2798,
  [2804] = 2774,
  [2805] = 2132,
  [2806] = 1849,
  [2807] = 2798,
  [2808] = 2777,
  [2809] = 1952,
  [2810] = 2777,
  [2811] = 1860,
  [2812] = 2132,
  [2813] = 906,
  [2814] = 2798,
  [2815] = 2774,
  [2816] = 2774,
  [2817] = 2139,
  [2818] = 2777,
  [2819] = 2786,
  [2820] = 1871,
  [2821] = 1651,
  [2822] = 2778,
  [2823] = 1710,
  [2824] = 2129,
  [2825] = 2130,
  [2826] = 1868,
  [2827] = 2798,
  [2828] = 1868,
  [2829] = 2133,
  [2830] = 2778,
  [2831] = 2798,
  [2832] = 2467,
  [2833] = 2140,
  [2834] = 2136,
  [2835] = 2142,
  [2836] = 2134,
  [2837] = 891,
  [2838] = 893,
  [2839] = 2786,
  [2840] = 2469,
  [2841] = 1651,
  [2842] = 2403,
  [2843] = 2467,
  [2844] = 1851,
  [2845] = 2168,
  [2846] = 2215,
  [2847] = 2232,
  [2848] = 1851,
  [2849] = 2786,
  [2850] = 2136,
  [2851] = 2851,
  [2852] = 2852,
  [2853] = 2238,
  [2854] = 2854,
  [2855] = 2855,
  [2856] = 2856,
  [2857] = 2857,
  [2858] = 2186,
  [2859] = 2859,
  [2860] = 2860,
  [2861] = 2861,
  [2862] = 2862,
  [2863] = 2863,
  [2864] = 2864,
  [2865] = 2865,
  [2866] = 2866,
  [2867] = 2867,
  [2868] = 1853,
  [2869] = 1651,
  [2870] = 2326,
  [2871] = 2136,
  [2872] = 1860,
  [2873] = 1853,
  [2874] = 890,
  [2875] = 1651,
  [2876] = 1849,
  [2877] = 896,
  [2878] = 2469,
  [2879] = 1849,
  [2880] = 2467,
  [2881] = 1972,
  [2882] = 889,
  [2883] = 2883,
  [2884] = 895,
  [2885] = 2221,
  [2886] = 1860,
  [2887] = 892,
  [2888] = 2888,
  [2889] = 2242,
  [2890] = 2233,
  [2891] = 2238,
  [2892] = 2139,
  [2893] = 2142,
  [2894] = 1871,
  [2895] = 2244,
  [2896] = 2133,
  [2897] = 2786,
  [2898] = 1871,
  [2899] = 2147,
  [2900] = 2215,
  [2901] = 2234,
  [2902] = 2227,
  [2903] = 2186,
  [2904] = 1868,
  [2905] = 1868,
  [2906] = 2232,
  [2907] = 2786,
  [2908] = 2132,
  [2909] = 2786,
  [2910] = 2221,
  [2911] = 2137,
  [2912] = 1972,
  [2913] = 2786,
  [2914] = 2786,
  [2915] = 2213,
  [2916] = 1972,
  [2917] = 2221,
  [2918] = 2129,
  [2919] = 2140,
  [2920] = 2229,
  [2921] = 2222,
  [2922] = 2786,
  [2923] = 2238,
  [2924] = 2786,
  [2925] = 2585,
  [2926] = 2246,
  [2927] = 2135,
  [2928] = 2134,
  [2929] = 2550,
  [2930] = 2786,
  [2931] = 2224,
  [2932] = 2932,
  [2933] = 2232,
  [2934] = 2215,
  [2935] = 2168,
  [2936] = 2217,
  [2937] = 2211,
  [2938] = 906,
  [2939] = 2130,
  [2940] = 2940,
  [2941] = 2786,
  [2942] = 2862,
  [2943] = 2863,
  [2944] = 2668,
  [2945] = 2864,
  [2946] = 2625,
  [2947] = 2859,
  [2948] = 2678,
  [2949] = 2469,
  [2950] = 894,
  [2951] = 891,
  [2952] = 2888,
  [2953] = 2186,
  [2954] = 2861,
  [2955] = 2222,
  [2956] = 2217,
  [2957] = 2136,
  [2958] = 2958,
  [2959] = 2860,
  [2960] = 2958,
  [2961] = 2854,
  [2962] = 2786,
  [2963] = 2857,
  [2964] = 2686,
  [2965] = 890,
  [2966] = 889,
  [2967] = 893,
  [2968] = 2851,
  [2969] = 2865,
  [2970] = 2970,
  [2971] = 2168,
  [2972] = 2718,
  [2973] = 2856,
  [2974] = 2786,
  [2975] = 2227,
  [2976] = 2883,
  [2977] = 2213,
  [2978] = 2670,
  [2979] = 2234,
  [2980] = 2866,
  [2981] = 892,
  [2982] = 2728,
  [2983] = 2855,
  [2984] = 2637,
  [2985] = 2958,
  [2986] = 1851,
  [2987] = 896,
  [2988] = 2867,
  [2989] = 2786,
  [2990] = 2186,
  [2991] = 2244,
  [2992] = 895,
  [2993] = 2242,
  [2994] = 1860,
  [2995] = 2168,
  [2996] = 2224,
  [2997] = 2674,
  [2998] = 2673,
  [2999] = 2467,
  [3000] = 3000,
  [3001] = 2672,
  [3002] = 1849,
  [3003] = 1853,
  [3004] = 2246,
  [3005] = 2403,
  [3006] = 2233,
  [3007] = 2229,
  [3008] = 906,
  [3009] = 2958,
  [3010] = 2211,
  [3011] = 2852,
  [3012] = 894,
  [3013] = 2149,
  [3014] = 2224,
  [3015] = 891,
  [3016] = 2217,
  [3017] = 2242,
  [3018] = 1651,
  [3019] = 2227,
  [3020] = 1972,
  [3021] = 1849,
  [3022] = 2215,
  [3023] = 2246,
  [3024] = 2233,
  [3025] = 2211,
  [3026] = 1853,
  [3027] = 1940,
  [3028] = 2970,
  [3029] = 3029,
  [3030] = 1932,
  [3031] = 895,
  [3032] = 2346,
  [3033] = 2244,
  [3034] = 2229,
  [3035] = 2101,
  [3036] = 3036,
  [3037] = 3037,
  [3038] = 1848,
  [3039] = 2312,
  [3040] = 896,
  [3041] = 892,
  [3042] = 2364,
  [3043] = 2244,
  [3044] = 893,
  [3045] = 2233,
  [3046] = 2940,
  [3047] = 2341,
  [3048] = 2221,
  [3049] = 889,
  [3050] = 890,
  [3051] = 3051,
  [3052] = 1860,
  [3053] = 1859,
  [3054] = 1851,
  [3055] = 2093,
  [3056] = 2786,
  [3057] = 3000,
  [3058] = 1864,
  [3059] = 2234,
  [3060] = 2246,
  [3061] = 906,
  [3062] = 2224,
  [3063] = 2309,
  [3064] = 159,
  [3065] = 2213,
  [3066] = 1972,
  [3067] = 2217,
  [3068] = 2636,
  [3069] = 2227,
  [3070] = 2234,
  [3071] = 172,
  [3072] = 2242,
  [3073] = 2469,
  [3074] = 894,
  [3075] = 2086,
  [3076] = 2232,
  [3077] = 3077,
  [3078] = 2467,
  [3079] = 2786,
  [3080] = 1896,
  [3081] = 2213,
  [3082] = 2222,
  [3083] = 2238,
  [3084] = 2222,
  [3085] = 2211,
  [3086] = 2229,
  [3087] = 2852,
  [3088] = 894,
  [3089] = 2021,
  [3090] = 2482,
  [3091] = 2024,
  [3092] = 2312,
  [3093] = 2341,
  [3094] = 2471,
  [3095] = 2364,
  [3096] = 2239,
  [3097] = 2241,
  [3098] = 2346,
  [3099] = 2124,
  [3100] = 2309,
  [3101] = 2168,
  [3102] = 1859,
  [3103] = 2505,
  [3104] = 1832,
  [3105] = 2854,
  [3106] = 2312,
  [3107] = 2380,
  [3108] = 2504,
  [3109] = 2854,
  [3110] = 2855,
  [3111] = 2073,
  [3112] = 2131,
  [3113] = 906,
  [3114] = 2064,
  [3115] = 2856,
  [3116] = 2046,
  [3117] = 2364,
  [3118] = 2851,
  [3119] = 2045,
  [3120] = 2497,
  [3121] = 2859,
  [3122] = 2859,
  [3123] = 2388,
  [3124] = 2400,
  [3125] = 2416,
  [3126] = 2499,
  [3127] = 2003,
  [3128] = 2861,
  [3129] = 3129,
  [3130] = 2862,
  [3131] = 2863,
  [3132] = 2864,
  [3133] = 2865,
  [3134] = 2186,
  [3135] = 2867,
  [3136] = 1864,
  [3137] = 2883,
  [3138] = 3138,
  [3139] = 2866,
  [3140] = 2857,
  [3141] = 2861,
  [3142] = 2888,
  [3143] = 3143,
  [3144] = 2128,
  [3145] = 3138,
  [3146] = 3143,
  [3147] = 1859,
  [3148] = 2019,
  [3149] = 2433,
  [3150] = 1848,
  [3151] = 2855,
  [3152] = 1874,
  [3153] = 2341,
  [3154] = 1937,
  [3155] = 1942,
  [3156] = 1944,
  [3157] = 1945,
  [3158] = 1948,
  [3159] = 1951,
  [3160] = 1896,
  [3161] = 2851,
  [3162] = 3138,
  [3163] = 3143,
  [3164] = 2860,
  [3165] = 2101,
  [3166] = 2093,
  [3167] = 1932,
  [3168] = 2086,
  [3169] = 3169,
  [3170] = 1940,
  [3171] = 2035,
  [3172] = 2866,
  [3173] = 2888,
  [3174] = 1848,
  [3175] = 2857,
  [3176] = 2860,
  [3177] = 2086,
  [3178] = 2016,
  [3179] = 2013,
  [3180] = 2009,
  [3181] = 1940,
  [3182] = 1916,
  [3183] = 2856,
  [3184] = 1914,
  [3185] = 1909,
  [3186] = 1932,
  [3187] = 2093,
  [3188] = 2101,
  [3189] = 1864,
  [3190] = 2862,
  [3191] = 2883,
  [3192] = 2383,
  [3193] = 1896,
  [3194] = 2863,
  [3195] = 2011,
  [3196] = 2852,
  [3197] = 2480,
  [3198] = 2057,
  [3199] = 2085,
  [3200] = 2091,
  [3201] = 2096,
  [3202] = 2867,
  [3203] = 2346,
  [3204] = 2865,
  [3205] = 2095,
  [3206] = 2094,
  [3207] = 2864,
  [3208] = 2088,
  [3209] = 2087,
  [3210] = 2309,
  [3211] = 3211,
  [3212] = 1948,
  [3213] = 3213,
  [3214] = 3214,
  [3215] = 3215,
  [3216] = 2035,
  [3217] = 3215,
  [3218] = 2019,
  [3219] = 2854,
  [3220] = 3220,
  [3221] = 2016,
  [3222] = 2013,
  [3223] = 2009,
  [3224] = 1916,
  [3225] = 3211,
  [3226] = 1914,
  [3227] = 1909,
  [3228] = 3228,
  [3229] = 2433,
  [3230] = 2855,
  [3231] = 3231,
  [3232] = 3220,
  [3233] = 2856,
  [3234] = 3234,
  [3235] = 3235,
  [3236] = 3211,
  [3237] = 3237,
  [3238] = 3214,
  [3239] = 3220,
  [3240] = 2416,
  [3241] = 2859,
  [3242] = 3220,
  [3243] = 2011,
  [3244] = 3235,
  [3245] = 2471,
  [3246] = 3231,
  [3247] = 3237,
  [3248] = 3228,
  [3249] = 2057,
  [3250] = 3143,
  [3251] = 3211,
  [3252] = 2085,
  [3253] = 3231,
  [3254] = 2091,
  [3255] = 2096,
  [3256] = 2095,
  [3257] = 2094,
  [3258] = 3213,
  [3259] = 2088,
  [3260] = 2572,
  [3261] = 2087,
  [3262] = 3214,
  [3263] = 3228,
  [3264] = 2124,
  [3265] = 2380,
  [3266] = 1832,
  [3267] = 3234,
  [3268] = 2499,
  [3269] = 2866,
  [3270] = 2857,
  [3271] = 2860,
  [3272] = 2861,
  [3273] = 2862,
  [3274] = 2863,
  [3275] = 2864,
  [3276] = 2865,
  [3277] = 2867,
  [3278] = 3214,
  [3279] = 2480,
  [3280] = 2229,
  [3281] = 2852,
  [3282] = 2233,
  [3283] = 2786,
  [3284] = 3215,
  [3285] = 3211,
  [3286] = 2383,
  [3287] = 2883,
  [3288] = 1832,
  [3289] = 1951,
  [3290] = 1948,
  [3291] = 1945,
  [3292] = 1944,
  [3293] = 1942,
  [3294] = 3214,
  [3295] = 1937,
  [3296] = 1874,
  [3297] = 2888,
  [3298] = 3228,
  [3299] = 3234,
  [3300] = 3231,
  [3301] = 3215,
  [3302] = 3213,
  [3303] = 2003,
  [3304] = 2497,
  [3305] = 2851,
  [3306] = 3228,
  [3307] = 906,
  [3308] = 2504,
  [3309] = 2505,
  [3310] = 2045,
  [3311] = 2046,
  [3312] = 2064,
  [3313] = 2073,
  [3314] = 2482,
  [3315] = 3138,
  [3316] = 3231,
  [3317] = 3215,
  [3318] = 2024,
  [3319] = 2021,
  [3320] = 894,
  [3321] = 2035,
  [3322] = 2019,
  [3323] = 2471,
  [3324] = 2854,
  [3325] = 3234,
  [3326] = 3326,
  [3327] = 3213,
  [3328] = 2572,
  [3329] = 3235,
  [3330] = 2593,
  [3331] = 2016,
  [3332] = 2013,
  [3333] = 2009,
  [3334] = 1916,
  [3335] = 1914,
  [3336] = 1909,
  [3337] = 2511,
  [3338] = 2433,
  [3339] = 2855,
  [3340] = 3211,
  [3341] = 2856,
  [3342] = 2416,
  [3343] = 2859,
  [3344] = 3214,
  [3345] = 3215,
  [3346] = 2011,
  [3347] = 3211,
  [3348] = 2057,
  [3349] = 3228,
  [3350] = 2085,
  [3351] = 2091,
  [3352] = 2096,
  [3353] = 2095,
  [3354] = 2094,
  [3355] = 3214,
  [3356] = 3228,
  [3357] = 2088,
  [3358] = 3234,
  [3359] = 2213,
  [3360] = 2224,
  [3361] = 2087,
  [3362] = 3214,
  [3363] = 2234,
  [3364] = 3234,
  [3365] = 2217,
  [3366] = 3231,
  [3367] = 2380,
  [3368] = 3214,
  [3369] = 2244,
  [3370] = 2242,
  [3371] = 2499,
  [3372] = 2400,
  [3373] = 2786,
  [3374] = 3234,
  [3375] = 3213,
  [3376] = 2866,
  [3377] = 2857,
  [3378] = 2860,
  [3379] = 2861,
  [3380] = 2862,
  [3381] = 2863,
  [3382] = 2864,
  [3383] = 2865,
  [3384] = 2867,
  [3385] = 2480,
  [3386] = 3214,
  [3387] = 2852,
  [3388] = 3211,
  [3389] = 3215,
  [3390] = 2400,
  [3391] = 3220,
  [3392] = 2383,
  [3393] = 2464,
  [3394] = 3215,
  [3395] = 3234,
  [3396] = 2883,
  [3397] = 1951,
  [3398] = 3220,
  [3399] = 3215,
  [3400] = 3228,
  [3401] = 2239,
  [3402] = 1945,
  [3403] = 3213,
  [3404] = 1944,
  [3405] = 3231,
  [3406] = 3211,
  [3407] = 1942,
  [3408] = 1937,
  [3409] = 1874,
  [3410] = 2241,
  [3411] = 2485,
  [3412] = 3237,
  [3413] = 3211,
  [3414] = 2888,
  [3415] = 2572,
  [3416] = 2482,
  [3417] = 2471,
  [3418] = 2505,
  [3419] = 2003,
  [3420] = 3231,
  [3421] = 2786,
  [3422] = 2504,
  [3423] = 2497,
  [3424] = 2851,
  [3425] = 2593,
  [3426] = 2388,
  [3427] = 2504,
  [3428] = 2505,
  [3429] = 2045,
  [3430] = 3220,
  [3431] = 2046,
  [3432] = 3234,
  [3433] = 894,
  [3434] = 2064,
  [3435] = 3235,
  [3436] = 2073,
  [3437] = 3231,
  [3438] = 2851,
  [3439] = 2786,
  [3440] = 894,
  [3441] = 2497,
  [3442] = 3211,
  [3443] = 2124,
  [3444] = 3444,
  [3445] = 2482,
  [3446] = 2572,
  [3447] = 3235,
  [3448] = 2388,
  [3449] = 2024,
  [3450] = 3214,
  [3451] = 3213,
  [3452] = 3237,
  [3453] = 2021,
  [3454] = 2857,
  [3455] = 3237,
  [3456] = 2888,
  [3457] = 3211,
  [3458] = 3235,
  [3459] = 2883,
  [3460] = 3237,
  [3461] = 3228,
  [3462] = 2852,
  [3463] = 2227,
  [3464] = 2480,
  [3465] = 2867,
  [3466] = 2854,
  [3467] = 2855,
  [3468] = 3235,
  [3469] = 2865,
  [3470] = 2222,
  [3471] = 3237,
  [3472] = 2545,
  [3473] = 2856,
  [3474] = 3213,
  [3475] = 2864,
  [3476] = 2211,
  [3477] = 3477,
  [3478] = 2246,
  [3479] = 2859,
  [3480] = 3235,
  [3481] = 2863,
  [3482] = 2862,
  [3483] = 3237,
  [3484] = 2861,
  [3485] = 2860,
  [3486] = 2499,
  [3487] = 2866,
  [3488] = 2545,
  [3489] = 154,
  [3490] = 3138,
  [3491] = 2970,
  [3492] = 1864,
  [3493] = 155,
  [3494] = 253,
  [3495] = 2101,
  [3496] = 2487,
  [3497] = 2093,
  [3498] = 175,
  [3499] = 290,
  [3500] = 2086,
  [3501] = 2153,
  [3502] = 3143,
  [3503] = 3503,
  [3504] = 2456,
  [3505] = 2381,
  [3506] = 2377,
  [3507] = 2572,
  [3508] = 2572,
  [3509] = 2644,
  [3510] = 2718,
  [3511] = 2721,
  [3512] = 145,
  [3513] = 3513,
  [3514] = 788,
  [3515] = 3513,
  [3516] = 3138,
  [3517] = 2940,
  [3518] = 3513,
  [3519] = 2511,
  [3520] = 3000,
  [3521] = 906,
  [3522] = 3513,
  [3523] = 3143,
  [3524] = 906,
  [3525] = 3525,
  [3526] = 3513,
  [3527] = 3513,
  [3528] = 2691,
  [3529] = 3513,
  [3530] = 2691,
  [3531] = 3513,
  [3532] = 2668,
  [3533] = 3513,
  [3534] = 2670,
  [3535] = 3535,
  [3536] = 2001,
  [3537] = 963,
  [3538] = 2636,
  [3539] = 2469,
  [3540] = 3000,
  [3541] = 2672,
  [3542] = 2547,
  [3543] = 1896,
  [3544] = 2721,
  [3545] = 2026,
  [3546] = 1940,
  [3547] = 787,
  [3548] = 2673,
  [3549] = 2674,
  [3550] = 2408,
  [3551] = 2511,
  [3552] = 1932,
  [3553] = 2409,
  [3554] = 2398,
  [3555] = 2432,
  [3556] = 2410,
  [3557] = 2389,
  [3558] = 2414,
  [3559] = 3513,
  [3560] = 2542,
  [3561] = 2392,
  [3562] = 2067,
  [3563] = 2644,
  [3564] = 3525,
  [3565] = 2464,
  [3566] = 3513,
  [3567] = 2538,
  [3568] = 3513,
  [3569] = 3525,
  [3570] = 1848,
  [3571] = 2593,
  [3572] = 2485,
  [3573] = 2467,
  [3574] = 2600,
  [3575] = 3535,
  [3576] = 1859,
  [3577] = 3513,
  [3578] = 3513,
  [3579] = 2970,
  [3580] = 2572,
  [3581] = 2572,
  [3582] = 2940,
  [3583] = 2464,
  [3584] = 2149,
  [3585] = 2678,
  [3586] = 2485,
  [3587] = 1676,
  [3588] = 2863,
  [3589] = 2389,
  [3590] = 2432,
  [3591] = 2636,
  [3592] = 2398,
  [3593] = 2019,
  [3594] = 2409,
  [3595] = 2035,
  [3596] = 2001,
  [3597] = 2722,
  [3598] = 2888,
  [3599] = 2723,
  [3600] = 2725,
  [3601] = 2730,
  [3602] = 2686,
  [3603] = 2410,
  [3604] = 2392,
  [3605] = 2542,
  [3606] = 131,
  [3607] = 2408,
  [3608] = 2731,
  [3609] = 3609,
  [3610] = 131,
  [3611] = 3611,
  [3612] = 1874,
  [3613] = 1937,
  [3614] = 2140,
  [3615] = 2487,
  [3616] = 2970,
  [3617] = 1674,
  [3618] = 3618,
  [3619] = 2721,
  [3620] = 2529,
  [3621] = 1942,
  [3622] = 2547,
  [3623] = 2728,
  [3624] = 1944,
  [3625] = 1945,
  [3626] = 1832,
  [3627] = 1948,
  [3628] = 1951,
  [3629] = 2572,
  [3630] = 2632,
  [3631] = 2572,
  [3632] = 2717,
  [3633] = 2854,
  [3634] = 2627,
  [3635] = 2883,
  [3636] = 3618,
  [3637] = 3618,
  [3638] = 2026,
  [3639] = 1672,
  [3640] = 3609,
  [3641] = 2658,
  [3642] = 2547,
  [3643] = 2408,
  [3644] = 1673,
  [3645] = 2741,
  [3646] = 1675,
  [3647] = 894,
  [3648] = 2410,
  [3649] = 1680,
  [3650] = 2414,
  [3651] = 3611,
  [3652] = 1669,
  [3653] = 3611,
  [3654] = 2637,
  [3655] = 2026,
  [3656] = 2383,
  [3657] = 1676,
  [3658] = 2709,
  [3659] = 2668,
  [3660] = 2414,
  [3661] = 2600,
  [3662] = 3662,
  [3663] = 2665,
  [3664] = 3664,
  [3665] = 2392,
  [3666] = 788,
  [3667] = 1680,
  [3668] = 1664,
  [3669] = 1675,
  [3670] = 1673,
  [3671] = 2691,
  [3672] = 2147,
  [3673] = 2726,
  [3674] = 2543,
  [3675] = 2600,
  [3676] = 2737,
  [3677] = 1665,
  [3678] = 2641,
  [3679] = 2852,
  [3680] = 2021,
  [3681] = 2736,
  [3682] = 2480,
  [3683] = 2735,
  [3684] = 2024,
  [3685] = 2867,
  [3686] = 2636,
  [3687] = 2865,
  [3688] = 2864,
  [3689] = 2016,
  [3690] = 2013,
  [3691] = 2009,
  [3692] = 2708,
  [3693] = 1668,
  [3694] = 1667,
  [3695] = 2719,
  [3696] = 1916,
  [3697] = 3611,
  [3698] = 2710,
  [3699] = 1914,
  [3700] = 3609,
  [3701] = 1670,
  [3702] = 2636,
  [3703] = 2693,
  [3704] = 787,
  [3705] = 2862,
  [3706] = 1909,
  [3707] = 2861,
  [3708] = 2482,
  [3709] = 2487,
  [3710] = 2860,
  [3711] = 3609,
  [3712] = 2857,
  [3713] = 1671,
  [3714] = 2433,
  [3715] = 2706,
  [3716] = 2124,
  [3717] = 132,
  [3718] = 2142,
  [3719] = 2628,
  [3720] = 2073,
  [3721] = 2970,
  [3722] = 3143,
  [3723] = 1679,
  [3724] = 2855,
  [3725] = 2866,
  [3726] = 3618,
  [3727] = 2377,
  [3728] = 2704,
  [3729] = 2381,
  [3730] = 2703,
  [3731] = 2698,
  [3732] = 3618,
  [3733] = 2067,
  [3734] = 2702,
  [3735] = 2064,
  [3736] = 1668,
  [3737] = 2701,
  [3738] = 2046,
  [3739] = 3611,
  [3740] = 2045,
  [3741] = 2718,
  [3742] = 2712,
  [3743] = 1666,
  [3744] = 2678,
  [3745] = 1669,
  [3746] = 1674,
  [3747] = 2593,
  [3748] = 3138,
  [3749] = 2538,
  [3750] = 2674,
  [3751] = 2856,
  [3752] = 3609,
  [3753] = 2673,
  [3754] = 2456,
  [3755] = 2940,
  [3756] = 787,
  [3757] = 2159,
  [3758] = 2672,
  [3759] = 3000,
  [3760] = 2505,
  [3761] = 2504,
  [3762] = 2648,
  [3763] = 2380,
  [3764] = 2639,
  [3765] = 2742,
  [3766] = 2619,
  [3767] = 2326,
  [3768] = 1664,
  [3769] = 2572,
  [3770] = 2139,
  [3771] = 2734,
  [3772] = 2067,
  [3773] = 1666,
  [3774] = 1671,
  [3775] = 1670,
  [3776] = 788,
  [3777] = 2670,
  [3778] = 132,
  [3779] = 2087,
  [3780] = 2088,
  [3781] = 2738,
  [3782] = 1679,
  [3783] = 2539,
  [3784] = 2106,
  [3785] = 2651,
  [3786] = 3618,
  [3787] = 2538,
  [3788] = 2153,
  [3789] = 2593,
  [3790] = 2533,
  [3791] = 2151,
  [3792] = 2851,
  [3793] = 2094,
  [3794] = 2625,
  [3795] = 2546,
  [3796] = 2456,
  [3797] = 2536,
  [3798] = 2409,
  [3799] = 2540,
  [3800] = 2095,
  [3801] = 2542,
  [3802] = 2644,
  [3803] = 2690,
  [3804] = 2497,
  [3805] = 2572,
  [3806] = 2669,
  [3807] = 2499,
  [3808] = 2377,
  [3809] = 2091,
  [3810] = 2623,
  [3811] = 2085,
  [3812] = 2381,
  [3813] = 2057,
  [3814] = 2652,
  [3815] = 2653,
  [3816] = 2096,
  [3817] = 2003,
  [3818] = 2398,
  [3819] = 2416,
  [3820] = 2432,
  [3821] = 2389,
  [3822] = 1672,
  [3823] = 2156,
  [3824] = 2649,
  [3825] = 3825,
  [3826] = 2859,
  [3827] = 2659,
  [3828] = 2048,
  [3829] = 2660,
  [3830] = 2326,
  [3831] = 2940,
  [3832] = 1667,
  [3833] = 3000,
  [3834] = 2001,
  [3835] = 2126,
  [3836] = 1665,
  [3837] = 1952,
  [3838] = 3611,
  [3839] = 2011,
  [3840] = 3609,
  [3841] = 2726,
  [3842] = 2648,
  [3843] = 2625,
  [3844] = 2644,
  [3845] = 2130,
  [3846] = 2529,
  [3847] = 131,
  [3848] = 2137,
  [3849] = 2135,
  [3850] = 2623,
  [3851] = 2632,
  [3852] = 2543,
  [3853] = 2737,
  [3854] = 2701,
  [3855] = 2241,
  [3856] = 2132,
  [3857] = 2636,
  [3858] = 2133,
  [3859] = 132,
  [3860] = 2628,
  [3861] = 2636,
  [3862] = 2637,
  [3863] = 2736,
  [3864] = 2702,
  [3865] = 2627,
  [3866] = 890,
  [3867] = 889,
  [3868] = 893,
  [3869] = 2126,
  [3870] = 892,
  [3871] = 896,
  [3872] = 895,
  [3873] = 2702,
  [3874] = 2723,
  [3875] = 2722,
  [3876] = 891,
  [3877] = 2721,
  [3878] = 2734,
  [3879] = 2738,
  [3880] = 2641,
  [3881] = 2709,
  [3882] = 1710,
  [3883] = 1665,
  [3884] = 2726,
  [3885] = 2719,
  [3886] = 1667,
  [3887] = 2619,
  [3888] = 2706,
  [3889] = 2717,
  [3890] = 2653,
  [3891] = 132,
  [3892] = 2649,
  [3893] = 2665,
  [3894] = 131,
  [3895] = 2708,
  [3896] = 2636,
  [3897] = 2651,
  [3898] = 2706,
  [3899] = 2644,
  [3900] = 1871,
  [3901] = 2708,
  [3902] = 2652,
  [3903] = 2709,
  [3904] = 2533,
  [3905] = 2546,
  [3906] = 2717,
  [3907] = 2728,
  [3908] = 2701,
  [3909] = 2725,
  [3910] = 2728,
  [3911] = 3143,
  [3912] = 2693,
  [3913] = 2730,
  [3914] = 2639,
  [3915] = 2719,
  [3916] = 2536,
  [3917] = 2718,
  [3918] = 2625,
  [3919] = 1665,
  [3920] = 2627,
  [3921] = 2722,
  [3922] = 2686,
  [3923] = 2533,
  [3924] = 1667,
  [3925] = 2731,
  [3926] = 2628,
  [3927] = 2540,
  [3928] = 2723,
  [3929] = 2725,
  [3930] = 2632,
  [3931] = 2730,
  [3932] = 2623,
  [3933] = 2731,
  [3934] = 2636,
  [3935] = 1672,
  [3936] = 2741,
  [3937] = 3937,
  [3938] = 2239,
  [3939] = 2669,
  [3940] = 2737,
  [3941] = 2648,
  [3942] = 2690,
  [3943] = 2741,
  [3944] = 2641,
  [3945] = 2736,
  [3946] = 1669,
  [3947] = 906,
  [3948] = 2698,
  [3949] = 2639,
  [3950] = 2712,
  [3951] = 1674,
  [3952] = 1664,
  [3953] = 3953,
  [3954] = 1666,
  [3955] = 2572,
  [3956] = 1668,
  [3957] = 2619,
  [3958] = 2721,
  [3959] = 2738,
  [3960] = 2735,
  [3961] = 3961,
  [3962] = 2658,
  [3963] = 2539,
  [3964] = 2734,
  [3965] = 2742,
  [3966] = 2718,
  [3967] = 1679,
  [3968] = 2686,
  [3969] = 2690,
  [3970] = 2106,
  [3971] = 2691,
  [3972] = 2735,
  [3973] = 2669,
  [3974] = 2649,
  [3975] = 1868,
  [3976] = 2665,
  [3977] = 1666,
  [3978] = 2134,
  [3979] = 2129,
  [3980] = 1664,
  [3981] = 2668,
  [3982] = 2742,
  [3983] = 2670,
  [3984] = 2672,
  [3985] = 2673,
  [3986] = 2710,
  [3987] = 2674,
  [3988] = 2636,
  [3989] = 2678,
  [3990] = 2659,
  [3991] = 2704,
  [3992] = 2660,
  [3993] = 2636,
  [3994] = 2703,
  [3995] = 2678,
  [3996] = 1676,
  [3997] = 1680,
  [3998] = 1675,
  [3999] = 1673,
  [4000] = 2674,
  [4001] = 1679,
  [4002] = 2673,
  [4003] = 2672,
  [4004] = 2670,
  [4005] = 2668,
  [4006] = 1673,
  [4007] = 2652,
  [4008] = 2693,
  [4009] = 2653,
  [4010] = 1672,
  [4011] = 2540,
  [4012] = 2536,
  [4013] = 3138,
  [4014] = 2659,
  [4015] = 1671,
  [4016] = 1670,
  [4017] = 2546,
  [4018] = 2660,
  [4019] = 1675,
  [4020] = 2658,
  [4021] = 2529,
  [4022] = 1671,
  [4023] = 3169,
  [4024] = 2543,
  [4025] = 2691,
  [4026] = 1670,
  [4027] = 2126,
  [4028] = 1680,
  [4029] = 2698,
  [4030] = 2710,
  [4031] = 2637,
  [4032] = 2651,
  [4033] = 1676,
  [4034] = 4034,
  [4035] = 2106,
  [4036] = 2712,
  [4037] = 2539,
  [4038] = 2464,
  [4039] = 1669,
  [4040] = 1668,
  [4041] = 2703,
  [4042] = 1674,
  [4043] = 2704,
  [4044] = 2139,
  [4045] = 4045,
  [4046] = 4046,
  [4047] = 4047,
  [4048] = 1860,
  [4049] = 4049,
  [4050] = 4046,
  [4051] = 4051,
  [4052] = 3143,
  [4053] = 4049,
  [4054] = 4047,
  [4055] = 2469,
  [4056] = 4045,
  [4057] = 2241,
  [4058] = 4058,
  [4059] = 4058,
  [4060] = 2239,
  [4061] = 2239,
  [4062] = 4058,
  [4063] = 4045,
  [4064] = 3000,
  [4065] = 2940,
  [4066] = 4047,
  [4067] = 4046,
  [4068] = 4045,
  [4069] = 4049,
  [4070] = 4046,
  [4071] = 4049,
  [4072] = 4047,
  [4073] = 4045,
  [4074] = 2147,
  [4075] = 4046,
  [4076] = 3138,
  [4077] = 1849,
  [4078] = 2970,
  [4079] = 1853,
  [4080] = 4045,
  [4081] = 2241,
  [4082] = 4047,
  [4083] = 2467,
  [4084] = 4047,
  [4085] = 2142,
  [4086] = 4045,
  [4087] = 4051,
  [4088] = 2140,
  [4089] = 2464,
  [4090] = 4046,
  [4091] = 4049,
  [4092] = 4092,
  [4093] = 4049,
  [4094] = 4045,
  [4095] = 4049,
  [4096] = 4047,
  [4097] = 2542,
  [4098] = 890,
  [4099] = 889,
  [4100] = 893,
  [4101] = 4046,
  [4102] = 892,
  [4103] = 896,
  [4104] = 1851,
  [4105] = 895,
  [4106] = 891,
  [4107] = 4047,
  [4108] = 906,
  [4109] = 4051,
  [4110] = 4046,
  [4111] = 2136,
  [4112] = 906,
  [4113] = 4049,
  [4114] = 1674,
  [4115] = 1667,
  [4116] = 2730,
  [4117] = 2725,
  [4118] = 2723,
  [4119] = 2722,
  [4120] = 2693,
  [4121] = 2693,
  [4122] = 2542,
  [4123] = 2719,
  [4124] = 2717,
  [4125] = 2238,
  [4126] = 2709,
  [4127] = 2708,
  [4128] = 2706,
  [4129] = 2698,
  [4130] = 3143,
  [4131] = 2702,
  [4132] = 2701,
  [4133] = 1868,
  [4134] = 1672,
  [4135] = 2741,
  [4136] = 2215,
  [4137] = 2737,
  [4138] = 2106,
  [4139] = 4051,
  [4140] = 2736,
  [4141] = 2735,
  [4142] = 2712,
  [4143] = 1669,
  [4144] = 2627,
  [4145] = 1676,
  [4146] = 2628,
  [4147] = 3138,
  [4148] = 2632,
  [4149] = 2728,
  [4150] = 2221,
  [4151] = 2730,
  [4152] = 1673,
  [4153] = 4058,
  [4154] = 132,
  [4155] = 1675,
  [4156] = 2710,
  [4157] = 2704,
  [4158] = 1680,
  [4159] = 2731,
  [4160] = 2641,
  [4161] = 2710,
  [4162] = 2623,
  [4163] = 1671,
  [4164] = 1670,
  [4165] = 4165,
  [4166] = 2147,
  [4167] = 1871,
  [4168] = 2742,
  [4169] = 1664,
  [4170] = 2139,
  [4171] = 1972,
  [4172] = 2142,
  [4173] = 1666,
  [4174] = 2140,
  [4175] = 2625,
  [4176] = 2147,
  [4177] = 2139,
  [4178] = 4178,
  [4179] = 2142,
  [4180] = 2140,
  [4181] = 1679,
  [4182] = 2147,
  [4183] = 2232,
  [4184] = 2139,
  [4185] = 2690,
  [4186] = 1668,
  [4187] = 2142,
  [4188] = 131,
  [4189] = 2686,
  [4190] = 2665,
  [4191] = 2659,
  [4192] = 2660,
  [4193] = 2669,
  [4194] = 2703,
  [4195] = 2652,
  [4196] = 2649,
  [4197] = 2653,
  [4198] = 2140,
  [4199] = 2623,
  [4200] = 1665,
  [4201] = 2637,
  [4202] = 2126,
  [4203] = 2168,
  [4204] = 2147,
  [4205] = 2704,
  [4206] = 2147,
  [4207] = 2153,
  [4208] = 2048,
  [4209] = 2735,
  [4210] = 2467,
  [4211] = 2326,
  [4212] = 2742,
  [4213] = 4051,
  [4214] = 4058,
  [4215] = 1952,
  [4216] = 2703,
  [4217] = 2142,
  [4218] = 4218,
  [4219] = 4219,
  [4220] = 4220,
  [4221] = 2142,
  [4222] = 2139,
  [4223] = 4220,
  [4224] = 2706,
  [4225] = 2725,
  [4226] = 2659,
  [4227] = 2140,
  [4228] = 4228,
  [4229] = 2708,
  [4230] = 2701,
  [4231] = 2153,
  [4232] = 2709,
  [4233] = 2712,
  [4234] = 3138,
  [4235] = 1871,
  [4236] = 1868,
  [4237] = 1710,
  [4238] = 4058,
  [4239] = 4219,
  [4240] = 2326,
  [4241] = 2722,
  [4242] = 2186,
  [4243] = 2627,
  [4244] = 2665,
  [4245] = 2653,
  [4246] = 2690,
  [4247] = 4051,
  [4248] = 2723,
  [4249] = 2649,
  [4250] = 2149,
  [4251] = 3143,
  [4252] = 4228,
  [4253] = 3662,
  [4254] = 2139,
  [4255] = 2698,
  [4256] = 2702,
  [4257] = 2731,
  [4258] = 2669,
  [4259] = 2153,
  [4260] = 2632,
  [4261] = 4218,
  [4262] = 2741,
  [4263] = 2140,
  [4264] = 2660,
  [4265] = 2736,
  [4266] = 2628,
  [4267] = 2469,
  [4268] = 2717,
  [4269] = 2641,
  [4270] = 2652,
  [4271] = 2737,
  [4272] = 2719,
  [4273] = 3138,
  [4274] = 3143,
  [4275] = 3664,
  [4276] = 2221,
  [4277] = 2215,
  [4278] = 2233,
  [4279] = 2229,
  [4280] = 2232,
  [4281] = 2433,
  [4282] = 4282,
  [4283] = 2246,
  [4284] = 4282,
  [4285] = 3143,
  [4286] = 4286,
  [4287] = 2416,
  [4288] = 2211,
  [4289] = 4286,
  [4290] = 4290,
  [4291] = 4291,
  [4292] = 2048,
  [4293] = 2222,
  [4294] = 4290,
  [4295] = 2380,
  [4296] = 4291,
  [4297] = 4058,
  [4298] = 2326,
  [4299] = 2326,
  [4300] = 1952,
  [4301] = 4051,
  [4302] = 1710,
  [4303] = 2227,
  [4304] = 2224,
  [4305] = 3138,
  [4306] = 2383,
  [4307] = 2217,
  [4308] = 4282,
  [4309] = 2213,
  [4310] = 4291,
  [4311] = 3143,
  [4312] = 4165,
  [4313] = 2234,
  [4314] = 2244,
  [4315] = 3138,
  [4316] = 2242,
  [4317] = 4290,
  [4318] = 4286,
  [4319] = 2238,
  [4320] = 2505,
  [4321] = 1896,
  [4322] = 2129,
  [4323] = 2130,
  [4324] = 4058,
  [4325] = 2137,
  [4326] = 2504,
  [4327] = 2135,
  [4328] = 2482,
  [4329] = 2132,
  [4330] = 1848,
  [4331] = 2134,
  [4332] = 4291,
  [4333] = 1859,
  [4334] = 2101,
  [4335] = 1871,
  [4336] = 1871,
  [4337] = 4051,
  [4338] = 2093,
  [4339] = 2499,
  [4340] = 2497,
  [4341] = 2153,
  [4342] = 2133,
  [4343] = 1940,
  [4344] = 4282,
  [4345] = 1868,
  [4346] = 2086,
  [4347] = 1864,
  [4348] = 4286,
  [4349] = 1932,
  [4350] = 4350,
  [4351] = 1868,
  [4352] = 4290,
  [4353] = 2480,
  [4354] = 2137,
  [4355] = 2857,
  [4356] = 1651,
  [4357] = 2866,
  [4358] = 1945,
  [4359] = 890,
  [4360] = 1944,
  [4361] = 2856,
  [4362] = 889,
  [4363] = 1942,
  [4364] = 4291,
  [4365] = 4290,
  [4366] = 2865,
  [4367] = 2232,
  [4368] = 893,
  [4369] = 2859,
  [4370] = 1937,
  [4371] = 2467,
  [4372] = 1909,
  [4373] = 1874,
  [4374] = 1914,
  [4375] = 4286,
  [4376] = 2864,
  [4377] = 2221,
  [4378] = 1916,
  [4379] = 2863,
  [4380] = 2009,
  [4381] = 2087,
  [4382] = 892,
  [4383] = 896,
  [4384] = 2088,
  [4385] = 2135,
  [4386] = 2134,
  [4387] = 2867,
  [4388] = 2013,
  [4389] = 4389,
  [4390] = 2016,
  [4391] = 2862,
  [4392] = 2048,
  [4393] = 2326,
  [4394] = 2003,
  [4395] = 2094,
  [4396] = 2046,
  [4397] = 2215,
  [4398] = 4290,
  [4399] = 895,
  [4400] = 1871,
  [4401] = 2095,
  [4402] = 3138,
  [4403] = 1710,
  [4404] = 1948,
  [4405] = 1952,
  [4406] = 2888,
  [4407] = 3143,
  [4408] = 2096,
  [4409] = 2091,
  [4410] = 1951,
  [4411] = 2045,
  [4412] = 4058,
  [4413] = 2861,
  [4414] = 2019,
  [4415] = 2085,
  [4416] = 2469,
  [4417] = 4417,
  [4418] = 1851,
  [4419] = 2136,
  [4420] = 2035,
  [4421] = 2469,
  [4422] = 2136,
  [4423] = 1860,
  [4424] = 4424,
  [4425] = 2860,
  [4426] = 2133,
  [4427] = 2883,
  [4428] = 4282,
  [4429] = 2057,
  [4430] = 2132,
  [4431] = 4051,
  [4432] = 2467,
  [4433] = 1849,
  [4434] = 2238,
  [4435] = 1853,
  [4436] = 2467,
  [4437] = 2011,
  [4438] = 4291,
  [4439] = 2129,
  [4440] = 1868,
  [4441] = 2073,
  [4442] = 2855,
  [4443] = 2130,
  [4444] = 4282,
  [4445] = 2469,
  [4446] = 2852,
  [4447] = 2851,
  [4448] = 2854,
  [4449] = 891,
  [4450] = 2021,
  [4451] = 2064,
  [4452] = 2024,
  [4453] = 4286,
  [4454] = 4051,
  [4455] = 4282,
  [4456] = 2686,
  [4457] = 4457,
  [4458] = 4291,
  [4459] = 2625,
  [4460] = 4350,
  [4461] = 1972,
  [4462] = 2221,
  [4463] = 4058,
  [4464] = 2221,
  [4465] = 4290,
  [4466] = 2728,
  [4467] = 2149,
  [4468] = 4286,
  [4469] = 2637,
  [4470] = 2232,
  [4471] = 2153,
  [4472] = 2238,
  [4473] = 2232,
  [4474] = 2215,
  [4475] = 2215,
  [4476] = 2238,
  [4477] = 2186,
  [4478] = 4286,
  [4479] = 3000,
  [4480] = 4480,
  [4481] = 4051,
  [4482] = 2940,
  [4483] = 2970,
  [4484] = 1833,
  [4485] = 4389,
  [4486] = 4291,
  [4487] = 2497,
  [4488] = 4424,
  [4489] = 2133,
  [4490] = 2132,
  [4491] = 1860,
  [4492] = 1651,
  [4493] = 2134,
  [4494] = 2547,
  [4495] = 2135,
  [4496] = 2129,
  [4497] = 2130,
  [4498] = 2482,
  [4499] = 2137,
  [4500] = 2149,
  [4501] = 4282,
  [4502] = 2380,
  [4503] = 4058,
  [4504] = 2538,
  [4505] = 1849,
  [4506] = 2467,
  [4507] = 2433,
  [4508] = 2416,
  [4509] = 4509,
  [4510] = 891,
  [4511] = 1830,
  [4512] = 895,
  [4513] = 4480,
  [4514] = 2153,
  [4515] = 896,
  [4516] = 892,
  [4517] = 2504,
  [4518] = 893,
  [4519] = 889,
  [4520] = 2383,
  [4521] = 4350,
  [4522] = 1853,
  [4523] = 2480,
  [4524] = 2168,
  [4525] = 1832,
  [4526] = 890,
  [4527] = 2600,
  [4528] = 4290,
  [4529] = 4509,
  [4530] = 2505,
  [4531] = 2469,
  [4532] = 1851,
  [4533] = 4509,
  [4534] = 2326,
  [4535] = 2499,
  [4536] = 4536,
  [4537] = 2233,
  [4538] = 4058,
  [4539] = 2244,
  [4540] = 2859,
  [4541] = 2234,
  [4542] = 2213,
  [4543] = 4282,
  [4544] = 2866,
  [4545] = 4545,
  [4546] = 4545,
  [4547] = 4286,
  [4548] = 4545,
  [4549] = 4545,
  [4550] = 2186,
  [4551] = 2229,
  [4552] = 4457,
  [4553] = 1868,
  [4554] = 3000,
  [4555] = 4555,
  [4556] = 4058,
  [4557] = 4555,
  [4558] = 2126,
  [4559] = 4545,
  [4560] = 2467,
  [4561] = 4561,
  [4562] = 2857,
  [4563] = 2860,
  [4564] = 2861,
  [4565] = 2856,
  [4566] = 2862,
  [4567] = 2863,
  [4568] = 4561,
  [4569] = 4545,
  [4570] = 2864,
  [4571] = 2865,
  [4572] = 2867,
  [4573] = 2227,
  [4574] = 2855,
  [4575] = 2852,
  [4576] = 4561,
  [4577] = 4561,
  [4578] = 2242,
  [4579] = 2222,
  [4580] = 4290,
  [4581] = 2211,
  [4582] = 2149,
  [4583] = 4561,
  [4584] = 4291,
  [4585] = 2246,
  [4586] = 2106,
  [4587] = 4051,
  [4588] = 2126,
  [4589] = 2851,
  [4590] = 4555,
  [4591] = 4051,
  [4592] = 1871,
  [4593] = 2217,
  [4594] = 2970,
  [4595] = 2224,
  [4596] = 4545,
  [4597] = 2168,
  [4598] = 4555,
  [4599] = 4555,
  [4600] = 4555,
  [4601] = 4561,
  [4602] = 2854,
  [4603] = 4555,
  [4604] = 4561,
  [4605] = 2888,
  [4606] = 2469,
  [4607] = 4561,
  [4608] = 1868,
  [4609] = 2136,
  [4610] = 1871,
  [4611] = 2106,
  [4612] = 2883,
  [4613] = 2940,
  [4614] = 4614,
  [4615] = 4555,
  [4616] = 4545,
  [4617] = 1972,
  [4618] = 1830,
  [4619] = 1940,
  [4620] = 1833,
  [4621] = 4621,
  [4622] = 2242,
  [4623] = 4621,
  [4624] = 4624,
  [4625] = 4625,
  [4626] = 4621,
  [4627] = 4627,
  [4628] = 1859,
  [4629] = 2883,
  [4630] = 2852,
  [4631] = 4631,
  [4632] = 4286,
  [4633] = 2854,
  [4634] = 4634,
  [4635] = 4634,
  [4636] = 2227,
  [4637] = 2855,
  [4638] = 4631,
  [4639] = 2224,
  [4640] = 4621,
  [4641] = 4625,
  [4642] = 4642,
  [4643] = 4625,
  [4644] = 4621,
  [4645] = 4621,
  [4646] = 4621,
  [4647] = 2246,
  [4648] = 1868,
  [4649] = 4621,
  [4650] = 2856,
  [4651] = 4631,
  [4652] = 4621,
  [4653] = 4634,
  [4654] = 2851,
  [4655] = 4655,
  [4656] = 4621,
  [4657] = 2211,
  [4658] = 4631,
  [4659] = 4621,
  [4660] = 4660,
  [4661] = 2859,
  [4662] = 2222,
  [4663] = 4663,
  [4664] = 2244,
  [4665] = 4624,
  [4666] = 4625,
  [4667] = 4631,
  [4668] = 4627,
  [4669] = 4624,
  [4670] = 4634,
  [4671] = 2888,
  [4672] = 4621,
  [4673] = 4624,
  [4674] = 4621,
  [4675] = 1896,
  [4676] = 2217,
  [4677] = 4634,
  [4678] = 1848,
  [4679] = 4631,
  [4680] = 4621,
  [4681] = 4625,
  [4682] = 2101,
  [4683] = 2093,
  [4684] = 4625,
  [4685] = 2086,
  [4686] = 4621,
  [4687] = 4687,
  [4688] = 4624,
  [4689] = 4689,
  [4690] = 4625,
  [4691] = 4625,
  [4692] = 2326,
  [4693] = 4625,
  [4694] = 4621,
  [4695] = 2213,
  [4696] = 4696,
  [4697] = 1932,
  [4698] = 4698,
  [4699] = 1848,
  [4700] = 4631,
  [4701] = 4621,
  [4702] = 2234,
  [4703] = 4703,
  [4704] = 4704,
  [4705] = 2866,
  [4706] = 4624,
  [4707] = 2867,
  [4708] = 4621,
  [4709] = 2865,
  [4710] = 2864,
  [4711] = 4282,
  [4712] = 2863,
  [4713] = 4634,
  [4714] = 4624,
  [4715] = 4715,
  [4716] = 4631,
  [4717] = 4627,
  [4718] = 4291,
  [4719] = 1871,
  [4720] = 4624,
  [4721] = 4290,
  [4722] = 2862,
  [4723] = 4634,
  [4724] = 4631,
  [4725] = 2861,
  [4726] = 4621,
  [4727] = 4634,
  [4728] = 1864,
  [4729] = 2860,
  [4730] = 4730,
  [4731] = 2233,
  [4732] = 2857,
  [4733] = 4627,
  [4734] = 2229,
  [4735] = 4730,
  [4736] = 2865,
  [4737] = 2859,
  [4738] = 4738,
  [4739] = 4739,
  [4740] = 1664,
  [4741] = 1666,
  [4742] = 4742,
  [4743] = 4743,
  [4744] = 2073,
  [4745] = 4745,
  [4746] = 2852,
  [4747] = 2866,
  [4748] = 4748,
  [4749] = 4749,
  [4750] = 2326,
  [4751] = 2480,
  [4752] = 2867,
  [4753] = 4753,
  [4754] = 4753,
  [4755] = 2021,
  [4756] = 2024,
  [4757] = 2865,
  [4758] = 2864,
  [4759] = 2863,
  [4760] = 4742,
  [4761] = 2862,
  [4762] = 2064,
  [4763] = 2383,
  [4764] = 1940,
  [4765] = 2861,
  [4766] = 2860,
  [4767] = 2857,
  [4768] = 4768,
  [4769] = 4769,
  [4770] = 2867,
  [4771] = 2866,
  [4772] = 2046,
  [4773] = 2073,
  [4774] = 2064,
  [4775] = 2482,
  [4776] = 2046,
  [4777] = 2045,
  [4778] = 1942,
  [4779] = 2497,
  [4780] = 2883,
  [4781] = 4781,
  [4782] = 4782,
  [4783] = 2851,
  [4784] = 2504,
  [4785] = 4753,
  [4786] = 2003,
  [4787] = 4787,
  [4788] = 4742,
  [4789] = 4749,
  [4790] = 4790,
  [4791] = 2505,
  [4792] = 2504,
  [4793] = 4793,
  [4794] = 1937,
  [4795] = 2851,
  [4796] = 2499,
  [4797] = 4797,
  [4798] = 1874,
  [4799] = 2021,
  [4800] = 4800,
  [4801] = 4797,
  [4802] = 2856,
  [4803] = 1944,
  [4804] = 1675,
  [4805] = 2499,
  [4806] = 1874,
  [4807] = 1937,
  [4808] = 1945,
  [4809] = 1932,
  [4810] = 1948,
  [4811] = 1942,
  [4812] = 1944,
  [4813] = 1945,
  [4814] = 4742,
  [4815] = 4782,
  [4816] = 1948,
  [4817] = 1951,
  [4818] = 4739,
  [4819] = 4819,
  [4820] = 2045,
  [4821] = 2497,
  [4822] = 2380,
  [4823] = 4753,
  [4824] = 4797,
  [4825] = 2854,
  [4826] = 2888,
  [4827] = 2851,
  [4828] = 4742,
  [4829] = 2086,
  [4830] = 4051,
  [4831] = 2865,
  [4832] = 2505,
  [4833] = 1832,
  [4834] = 2888,
  [4835] = 4835,
  [4836] = 2087,
  [4837] = 2088,
  [4838] = 4838,
  [4839] = 4753,
  [4840] = 4739,
  [4841] = 1679,
  [4842] = 1670,
  [4843] = 2094,
  [4844] = 2095,
  [4845] = 4845,
  [4846] = 1671,
  [4847] = 2096,
  [4848] = 2091,
  [4849] = 4849,
  [4850] = 2085,
  [4851] = 2480,
  [4852] = 2057,
  [4853] = 2852,
  [4854] = 2888,
  [4855] = 4739,
  [4856] = 4742,
  [4857] = 4857,
  [4858] = 2011,
  [4859] = 4753,
  [4860] = 4860,
  [4861] = 2504,
  [4862] = 2883,
  [4863] = 2087,
  [4864] = 4753,
  [4865] = 4745,
  [4866] = 4742,
  [4867] = 4742,
  [4868] = 4868,
  [4869] = 1909,
  [4870] = 1914,
  [4871] = 2866,
  [4872] = 1916,
  [4873] = 2009,
  [4874] = 4286,
  [4875] = 2013,
  [4876] = 2016,
  [4877] = 2497,
  [4878] = 2088,
  [4879] = 4879,
  [4880] = 4880,
  [4881] = 4769,
  [4882] = 4282,
  [4883] = 2019,
  [4884] = 2035,
  [4885] = 131,
  [4886] = 4286,
  [4887] = 4290,
  [4888] = 4742,
  [4889] = 2855,
  [4890] = 4291,
  [4891] = 4797,
  [4892] = 1665,
  [4893] = 2093,
  [4894] = 2035,
  [4895] = 2094,
  [4896] = 2095,
  [4897] = 2019,
  [4898] = 2864,
  [4899] = 2854,
  [4900] = 2855,
  [4901] = 2101,
  [4902] = 2096,
  [4903] = 2091,
  [4904] = 4742,
  [4905] = 2856,
  [4906] = 2852,
  [4907] = 1676,
  [4908] = 1667,
  [4909] = 4909,
  [4910] = 2856,
  [4911] = 2854,
  [4912] = 2859,
  [4913] = 4739,
  [4914] = 2383,
  [4915] = 1672,
  [4916] = 2867,
  [4917] = 4917,
  [4918] = 4918,
  [4919] = 2416,
  [4920] = 2085,
  [4921] = 2433,
  [4922] = 2854,
  [4923] = 4909,
  [4924] = 4739,
  [4925] = 2499,
  [4926] = 2866,
  [4927] = 4787,
  [4928] = 4928,
  [4929] = 4742,
  [4930] = 2857,
  [4931] = 2186,
  [4932] = 2024,
  [4933] = 2505,
  [4934] = 2864,
  [4935] = 2057,
  [4936] = 2857,
  [4937] = 4742,
  [4938] = 2860,
  [4939] = 4880,
  [4940] = 4940,
  [4941] = 2482,
  [4942] = 1669,
  [4943] = 2861,
  [4944] = 2855,
  [4945] = 2862,
  [4946] = 2863,
  [4947] = 2380,
  [4948] = 2864,
  [4949] = 2859,
  [4950] = 2865,
  [4951] = 2867,
  [4952] = 2480,
  [4953] = 2863,
  [4954] = 2883,
  [4955] = 2168,
  [4956] = 4956,
  [4957] = 2852,
  [4958] = 2883,
  [4959] = 2011,
  [4960] = 2860,
  [4961] = 2888,
  [4962] = 2859,
  [4963] = 2862,
  [4964] = 2416,
  [4965] = 4058,
  [4966] = 2861,
  [4967] = 1673,
  [4968] = 2016,
  [4969] = 2013,
  [4970] = 4291,
  [4971] = 2863,
  [4972] = 2009,
  [4973] = 1674,
  [4974] = 1916,
  [4975] = 2482,
  [4976] = 2855,
  [4977] = 1914,
  [4978] = 2860,
  [4979] = 1909,
  [4980] = 1896,
  [4981] = 2433,
  [4982] = 2857,
  [4983] = 132,
  [4984] = 2124,
  [4985] = 4797,
  [4986] = 2861,
  [4987] = 4742,
  [4988] = 1668,
  [4989] = 4940,
  [4990] = 4417,
  [4991] = 2856,
  [4992] = 2851,
  [4993] = 2862,
  [4994] = 4742,
  [4995] = 1951,
  [4996] = 4742,
  [4997] = 2003,
  [4998] = 1680,
  [4999] = 2467,
  [5000] = 5000,
  [5001] = 5001,
  [5002] = 2464,
  [5003] = 2469,
  [5004] = 5004,
  [5005] = 5005,
  [5006] = 5006,
  [5007] = 5007,
  [5008] = 4350,
  [5009] = 5006,
  [5010] = 3000,
  [5011] = 5011,
  [5012] = 2940,
  [5013] = 5000,
  [5014] = 5014,
  [5015] = 5006,
  [5016] = 4642,
  [5017] = 5000,
  [5018] = 5018,
  [5019] = 5006,
  [5020] = 5006,
  [5021] = 5005,
  [5022] = 2217,
  [5023] = 5023,
  [5024] = 5000,
  [5025] = 5011,
  [5026] = 5006,
  [5027] = 5027,
  [5028] = 2224,
  [5029] = 5000,
  [5030] = 2246,
  [5031] = 5031,
  [5032] = 5006,
  [5033] = 5031,
  [5034] = 5034,
  [5035] = 5007,
  [5036] = 2211,
  [5037] = 4290,
  [5038] = 5000,
  [5039] = 5039,
  [5040] = 4282,
  [5041] = 5041,
  [5042] = 4282,
  [5043] = 2222,
  [5044] = 5044,
  [5045] = 5045,
  [5046] = 5018,
  [5047] = 4286,
  [5048] = 5048,
  [5049] = 5005,
  [5050] = 5050,
  [5051] = 2227,
  [5052] = 5023,
  [5053] = 2469,
  [5054] = 5023,
  [5055] = 5055,
  [5056] = 5031,
  [5057] = 5031,
  [5058] = 5058,
  [5059] = 5000,
  [5060] = 4290,
  [5061] = 5004,
  [5062] = 5062,
  [5063] = 4291,
  [5064] = 5064,
  [5065] = 2153,
  [5066] = 5023,
  [5067] = 5005,
  [5068] = 5068,
  [5069] = 5000,
  [5070] = 2242,
  [5071] = 2244,
  [5072] = 5064,
  [5073] = 5062,
  [5074] = 2467,
  [5075] = 5058,
  [5076] = 2234,
  [5077] = 5000,
  [5078] = 5005,
  [5079] = 5079,
  [5080] = 5080,
  [5081] = 2213,
  [5082] = 5007,
  [5083] = 2464,
  [5084] = 5018,
  [5085] = 5048,
  [5086] = 5064,
  [5087] = 5062,
  [5088] = 5018,
  [5089] = 5058,
  [5090] = 5011,
  [5091] = 3535,
  [5092] = 5000,
  [5093] = 5064,
  [5094] = 5062,
  [5095] = 5095,
  [5096] = 5007,
  [5097] = 5097,
  [5098] = 2233,
  [5099] = 5023,
  [5100] = 5100,
  [5101] = 5011,
  [5102] = 2229,
  [5103] = 5031,
  [5104] = 5018,
  [5105] = 5018,
  [5106] = 4642,
  [5107] = 5107,
  [5108] = 5108,
  [5109] = 5005,
  [5110] = 5023,
  [5111] = 5111,
  [5112] = 5034,
  [5113] = 5031,
  [5114] = 5004,
  [5115] = 5023,
  [5116] = 5004,
  [5117] = 5058,
  [5118] = 5048,
  [5119] = 5005,
  [5120] = 5107,
  [5121] = 5080,
  [5122] = 5018,
  [5123] = 5011,
  [5124] = 5000,
  [5125] = 5027,
  [5126] = 5006,
  [5127] = 5079,
  [5128] = 4291,
  [5129] = 5004,
  [5130] = 5130,
  [5131] = 5007,
  [5132] = 4286,
  [5133] = 5007,
  [5134] = 5134,
  [5135] = 5048,
  [5136] = 906,
  [5137] = 5137,
  [5138] = 4350,
  [5139] = 5139,
  [5140] = 5048,
  [5141] = 906,
  [5142] = 5005,
  [5143] = 5031,
  [5144] = 2467,
  [5145] = 2970,
  [5146] = 2469,
  [5147] = 5064,
  [5148] = 5058,
  [5149] = 5062,
  [5150] = 2195,
  [5151] = 1896,
  [5152] = 2542,
  [5153] = 2101,
  [5154] = 2093,
  [5155] = 2086,
  [5156] = 2970,
  [5157] = 1940,
  [5158] = 1932,
  [5159] = 1848,
  [5160] = 2940,
  [5161] = 2542,
  [5162] = 3000,
  [5163] = 3000,
  [5164] = 2940,
  [5165] = 5165,
  [5166] = 1859,
  [5167] = 1864,
  [5168] = 2970,
  [5169] = 4642,
  [5170] = 2701,
  [5171] = 2735,
  [5172] = 2632,
  [5173] = 2124,
  [5174] = 2628,
  [5175] = 2326,
  [5176] = 2704,
  [5177] = 2669,
  [5178] = 2627,
  [5179] = 2703,
  [5180] = 2741,
  [5181] = 2013,
  [5182] = 2016,
  [5183] = 2011,
  [5184] = 1679,
  [5185] = 2649,
  [5186] = 2168,
  [5187] = 2057,
  [5188] = 2665,
  [5189] = 2637,
  [5190] = 1668,
  [5191] = 1671,
  [5192] = 4286,
  [5193] = 1670,
  [5194] = 2735,
  [5195] = 2019,
  [5196] = 2035,
  [5197] = 1944,
  [5198] = 1674,
  [5199] = 1909,
  [5200] = 5200,
  [5201] = 5200,
  [5202] = 3169,
  [5203] = 5200,
  [5204] = 5204,
  [5205] = 2652,
  [5206] = 2653,
  [5207] = 2623,
  [5208] = 1914,
  [5209] = 1665,
  [5210] = 2742,
  [5211] = 2186,
  [5212] = 2126,
  [5213] = 1916,
  [5214] = 2731,
  [5215] = 2106,
  [5216] = 1669,
  [5217] = 2710,
  [5218] = 2730,
  [5219] = 2649,
  [5220] = 2736,
  [5221] = 1667,
  [5222] = 2009,
  [5223] = 2728,
  [5224] = 2725,
  [5225] = 2712,
  [5226] = 2702,
  [5227] = 2709,
  [5228] = 2627,
  [5229] = 2712,
  [5230] = 5200,
  [5231] = 2085,
  [5232] = 2723,
  [5233] = 2722,
  [5234] = 2467,
  [5235] = 1676,
  [5236] = 2690,
  [5237] = 2698,
  [5238] = 1680,
  [5239] = 2091,
  [5240] = 2021,
  [5241] = 4290,
  [5242] = 1942,
  [5243] = 2024,
  [5244] = 1675,
  [5245] = 2698,
  [5246] = 2641,
  [5247] = 2625,
  [5248] = 2725,
  [5249] = 2126,
  [5250] = 5250,
  [5251] = 2660,
  [5252] = 132,
  [5253] = 2730,
  [5254] = 2731,
  [5255] = 2628,
  [5256] = 2073,
  [5257] = 1673,
  [5258] = 5200,
  [5259] = 2703,
  [5260] = 2632,
  [5261] = 2704,
  [5262] = 2064,
  [5263] = 2469,
  [5264] = 5264,
  [5265] = 2046,
  [5266] = 5200,
  [5267] = 2045,
  [5268] = 2736,
  [5269] = 2737,
  [5270] = 2710,
  [5271] = 2719,
  [5272] = 1672,
  [5273] = 2659,
  [5274] = 4282,
  [5275] = 2003,
  [5276] = 2741,
  [5277] = 2096,
  [5278] = 2717,
  [5279] = 2709,
  [5280] = 131,
  [5281] = 5281,
  [5282] = 2095,
  [5283] = 2723,
  [5284] = 2722,
  [5285] = 2719,
  [5286] = 2717,
  [5287] = 2708,
  [5288] = 2094,
  [5289] = 2706,
  [5290] = 1666,
  [5291] = 1874,
  [5292] = 1937,
  [5293] = 2653,
  [5294] = 2637,
  [5295] = 2693,
  [5296] = 2623,
  [5297] = 2088,
  [5298] = 2087,
  [5299] = 5299,
  [5300] = 4291,
  [5301] = 2690,
  [5302] = 1664,
  [5303] = 1945,
  [5304] = 2652,
  [5305] = 2641,
  [5306] = 2737,
  [5307] = 2693,
  [5308] = 1948,
  [5309] = 2708,
  [5310] = 1951,
  [5311] = 2706,
  [5312] = 2686,
  [5313] = 2701,
  [5314] = 2702,
  [5315] = 2665,
  [5316] = 2686,
  [5317] = 1832,
  [5318] = 2660,
  [5319] = 2742,
  [5320] = 5200,
  [5321] = 2625,
  [5322] = 2106,
  [5323] = 2669,
  [5324] = 2728,
  [5325] = 2659,
  [5326] = 5326,
  [5327] = 2135,
  [5328] = 2134,
  [5329] = 5329,
  [5330] = 2130,
  [5331] = 2129,
  [5332] = 2132,
  [5333] = 5326,
  [5334] = 2137,
  [5335] = 5329,
  [5336] = 5329,
  [5337] = 5337,
  [5338] = 5329,
  [5339] = 2195,
  [5340] = 5329,
  [5341] = 2195,
  [5342] = 2048,
  [5343] = 1952,
  [5344] = 5344,
  [5345] = 5329,
  [5346] = 2133,
  [5347] = 5329,
  [5348] = 2227,
  [5349] = 2222,
  [5350] = 2224,
  [5351] = 5326,
  [5352] = 2233,
  [5353] = 2217,
  [5354] = 2213,
  [5355] = 2234,
  [5356] = 2244,
  [5357] = 2211,
  [5358] = 5326,
  [5359] = 2229,
  [5360] = 2242,
  [5361] = 2246,
  [5362] = 5362,
  [5363] = 5326,
  [5364] = 5326,
  [5365] = 5326,
  [5366] = 5326,
  [5367] = 5367,
  [5368] = 3662,
  [5369] = 3664,
  [5370] = 5370,
  [5371] = 5326,
  [5372] = 5372,
  [5373] = 5326,
  [5374] = 2136,
  [5375] = 5326,
  [5376] = 5326,
  [5377] = 5326,
  [5378] = 5326,
  [5379] = 5326,
  [5380] = 5380,
  [5381] = 5381,
  [5382] = 5381,
  [5383] = 5326,
  [5384] = 5380,
  [5385] = 2550,
  [5386] = 5381,
  [5387] = 5387,
  [5388] = 5388,
  [5389] = 4350,
  [5390] = 5387,
  [5391] = 5388,
  [5392] = 5380,
  [5393] = 5388,
  [5394] = 5326,
  [5395] = 5388,
  [5396] = 5388,
  [5397] = 2585,
  [5398] = 5326,
  [5399] = 5387,
  [5400] = 5380,
  [5401] = 5387,
  [5402] = 5387,
  [5403] = 5387,
  [5404] = 5387,
  [5405] = 5388,
  [5406] = 5387,
  [5407] = 5387,
  [5408] = 5387,
  [5409] = 5387,
  [5410] = 5388,
  [5411] = 5388,
  [5412] = 5381,
  [5413] = 5388,
  [5414] = 5388,
  [5415] = 5388,
  [5416] = 5381,
  [5417] = 5380,
  [5418] = 5381,
  [5419] = 5381,
  [5420] = 5380,
  [5421] = 5380,
  [5422] = 5380,
  [5423] = 5381,
  [5424] = 5381,
  [5425] = 5380,
  [5426] = 5380,
  [5427] = 5381,
  [5428] = 5381,
  [5429] = 5380,
  [5430] = 5381,
  [5431] = 5380,
  [5432] = 5432,
  [5433] = 5433,
  [5434] = 5432,
  [5435] = 5435,
  [5436] = 5436,
  [5437] = 5437,
  [5438] = 5435,
  [5439] = 5432,
  [5440] = 5380,
  [5441] = 5433,
  [5442] = 5442,
  [5443] = 5443,
  [5444] = 5436,
  [5445] = 5326,
  [5446] = 5446,
  [5447] = 5437,
  [5448] = 5437,
  [5449] = 5449,
  [5450] = 5450,
  [5451] = 5443,
  [5452] = 5443,
  [5453] = 5453,
  [5454] = 5433,
  [5455] = 5436,
  [5456] = 5443,
  [5457] = 5436,
  [5458] = 5432,
  [5459] = 5433,
  [5460] = 5432,
  [5461] = 5435,
  [5462] = 5435,
  [5463] = 5463,
  [5464] = 5450,
  [5465] = 5435,
  [5466] = 5436,
  [5467] = 5433,
  [5468] = 5432,
  [5469] = 5435,
  [5470] = 5436,
  [5471] = 5471,
  [5472] = 5437,
  [5473] = 5380,
  [5474] = 5436,
  [5475] = 5443,
  [5476] = 5443,
  [5477] = 5433,
  [5478] = 5478,
  [5479] = 5433,
  [5480] = 5450,
  [5481] = 5450,
  [5482] = 5463,
  [5483] = 5463,
  [5484] = 5436,
  [5485] = 5436,
  [5486] = 5443,
  [5487] = 5437,
  [5488] = 5453,
  [5489] = 5489,
  [5490] = 5326,
  [5491] = 5437,
  [5492] = 5463,
  [5493] = 5437,
  [5494] = 5326,
  [5495] = 5433,
  [5496] = 5432,
  [5497] = 5436,
  [5498] = 5380,
  [5499] = 5453,
  [5500] = 5433,
  [5501] = 5432,
  [5502] = 5435,
  [5503] = 5432,
  [5504] = 5435,
  [5505] = 5446,
  [5506] = 5432,
  [5507] = 5435,
  [5508] = 5433,
  [5509] = 5433,
  [5510] = 5432,
  [5511] = 5435,
  [5512] = 5443,
  [5513] = 5453,
  [5514] = 5436,
  [5515] = 5436,
  [5516] = 5453,
  [5517] = 5437,
  [5518] = 5437,
  [5519] = 5436,
  [5520] = 5326,
  [5521] = 5435,
  [5522] = 5432,
  [5523] = 5436,
  [5524] = 5433,
  [5525] = 5381,
  [5526] = 5436,
  [5527] = 5436,
  [5528] = 5436,
  [5529] = 5432,
  [5530] = 5435,
  [5531] = 5446,
  [5532] = 5450,
  [5533] = 5463,
  [5534] = 5433,
  [5535] = 5435,
  [5536] = 5435,
  [5537] = 5453,
  [5538] = 5432,
  [5539] = 5437,
  [5540] = 5433,
  [5541] = 5432,
  [5542] = 5432,
  [5543] = 5433,
  [5544] = 5453,
  [5545] = 5381,
  [5546] = 5443,
  [5547] = 5437,
  [5548] = 5443,
  [5549] = 5435,
  [5550] = 5433,
  [5551] = 5463,
  [5552] = 5432,
  [5553] = 5436,
  [5554] = 5436,
  [5555] = 5435,
  [5556] = 5381,
  [5557] = 5436,
  [5558] = 5433,
  [5559] = 5446,
  [5560] = 5436,
  [5561] = 5435,
  [5562] = 5432,
  [5563] = 5433,
  [5564] = 5446,
  [5565] = 5450,
  [5566] = 5381,
  [5567] = 5443,
  [5568] = 5435,
  [5569] = 5432,
  [5570] = 5463,
  [5571] = 5435,
  [5572] = 5433,
  [5573] = 5432,
  [5574] = 5435,
  [5575] = 5433,
  [5576] = 5450,
  [5577] = 5380,
  [5578] = 5578,
  [5579] = 5579,
  [5580] = 5580,
  [5581] = 5581,
  [5582] = 5579,
  [5583] = 5580,
  [5584] = 1833,
  [5585] = 5579,
  [5586] = 5579,
  [5587] = 5587,
  [5588] = 5380,
  [5589] = 5589,
  [5590] = 5590,
  [5591] = 5579,
  [5592] = 5578,
  [5593] = 5580,
  [5594] = 5579,
  [5595] = 5589,
  [5596] = 5579,
  [5597] = 5578,
  [5598] = 5580,
  [5599] = 1830,
  [5600] = 5589,
  [5601] = 5579,
  [5602] = 5602,
  [5603] = 5589,
  [5604] = 5579,
  [5605] = 5380,
  [5606] = 5579,
  [5607] = 5579,
  [5608] = 5381,
  [5609] = 5381,
  [5610] = 5590,
  [5611] = 5579,
  [5612] = 5590,
  [5613] = 5580,
  [5614] = 5579,
  [5615] = 5579,
  [5616] = 5579,
  [5617] = 5589,
  [5618] = 5590,
  [5619] = 5578,
  [5620] = 5579,
  [5621] = 5579,
  [5622] = 5579,
  [5623] = 5579,
  [5624] = 5578,
  [5625] = 5589,
  [5626] = 5580,
  [5627] = 5578,
  [5628] = 5579,
  [5629] = 5578,
  [5630] = 5580,
  [5631] = 2400,
  [5632] = 5632,
  [5633] = 5633,
  [5634] = 5634,
  [5635] = 5633,
  [5636] = 5632,
  [5637] = 5634,
  [5638] = 5381,
  [5639] = 5634,
  [5640] = 5632,
  [5641] = 5380,
  [5642] = 5380,
  [5643] = 5381,
  [5644] = 5381,
  [5645] = 5380,
  [5646] = 5634,
  [5647] = 5633,
  [5648] = 5633,
  [5649] = 5380,
  [5650] = 5381,
  [5651] = 5632,
  [5652] = 5632,
  [5653] = 5653,
  [5654] = 5633,
  [5655] = 5634,
  [5656] = 5632,
  [5657] = 5634,
  [5658] = 5653,
  [5659] = 5632,
  [5660] = 5633,
  [5661] = 5632,
  [5662] = 5653,
  [5663] = 5633,
  [5664] = 5634,
  [5665] = 5633,
  [5666] = 5633,
  [5667] = 5632,
  [5668] = 5634,
  [5669] = 5634,
  [5670] = 5633,
  [5671] = 5634,
  [5672] = 5632,
  [5673] = 5633,
  [5674] = 5653,
  [5675] = 5653,
  [5676] = 5634,
  [5677] = 5634,
  [5678] = 5632,
  [5679] = 5633,
  [5680] = 5632,
  [5681] = 5681,
  [5682] = 5633,
  [5683] = 5634,
  [5684] = 5633,
  [5685] = 5634,
  [5686] = 5634,
  [5687] = 5681,
  [5688] = 5632,
  [5689] = 5632,
  [5690] = 5632,
  [5691] = 5681,
  [5692] = 5633,
  [5693] = 5681,
  [5694] = 5681,
  [5695] = 5681,
  [5696] = 5681,
  [5697] = 5634,
  [5698] = 5681,
  [5699] = 5632,
  [5700] = 5681,
  [5701] = 5633,
  [5702] = 5632,
  [5703] = 5633,
  [5704] = 5704,
  [5705] = 5704,
  [5706] = 5704,
  [5707] = 5634,
  [5708] = 5632,
  [5709] = 5634,
  [5710] = 5710,
  [5711] = 5633,
  [5712] = 5712,
  [5713] = 5704,
  [5714] = 5712,
  [5715] = 5712,
  [5716] = 5633,
  [5717] = 5717,
  [5718] = 5718,
  [5719] = 5719,
  [5720] = 5717,
  [5721] = 5719,
  [5722] = 5717,
  [5723] = 5723,
  [5724] = 5634,
  [5725] = 5719,
  [5726] = 5704,
  [5727] = 5717,
  [5728] = 5717,
  [5729] = 5719,
  [5730] = 5717,
  [5731] = 5719,
  [5732] = 5717,
  [5733] = 5719,
  [5734] = 5719,
  [5735] = 5633,
  [5736] = 5717,
  [5737] = 5719,
  [5738] = 5723,
  [5739] = 5719,
  [5740] = 5717,
  [5741] = 5717,
  [5742] = 5634,
  [5743] = 5704,
  [5744] = 5744,
  [5745] = 5719,
  [5746] = 5717,
  [5747] = 5632,
  [5748] = 5717,
  [5749] = 5749,
  [5750] = 5750,
  [5751] = 5744,
  [5752] = 5633,
  [5753] = 5723,
  [5754] = 5723,
  [5755] = 5723,
  [5756] = 5717,
  [5757] = 5719,
  [5758] = 5719,
  [5759] = 5744,
  [5760] = 5717,
  [5761] = 5719,
  [5762] = 5632,
  [5763] = 5719,
  [5764] = 5719,
  [5765] = 5717,
  [5766] = 5634,
  [5767] = 5717,
  [5768] = 5723,
  [5769] = 5723,
  [5770] = 5633,
  [5771] = 5723,
  [5772] = 5719,
  [5773] = 5632,
  [5774] = 5717,
  [5775] = 5719,
  [5776] = 5632,
  [5777] = 5717,
  [5778] = 5723,
  [5779] = 5634,
  [5780] = 5719,
  [5781] = 5781,
  [5782] = 5704,
  [5783] = 5783,
  [5784] = 5784,
  [5785] = 5781,
  [5786] = 5781,
  [5787] = 5781,
  [5788] = 5783,
  [5789] = 5784,
  [5790] = 5790,
  [5791] = 5781,
  [5792] = 5790,
  [5793] = 5783,
  [5794] = 5781,
  [5795] = 5795,
  [5796] = 5784,
  [5797] = 5797,
  [5798] = 5781,
  [5799] = 5799,
  [5800] = 5797,
  [5801] = 5799,
  [5802] = 5795,
  [5803] = 5803,
  [5804] = 5799,
  [5805] = 5781,
  [5806] = 5795,
  [5807] = 5799,
  [5808] = 5781,
  [5809] = 5795,
  [5810] = 5799,
  [5811] = 5795,
  [5812] = 5781,
  [5813] = 5781,
  [5814] = 5799,
  [5815] = 5781,
  [5816] = 5795,
  [5817] = 5784,
  [5818] = 5783,
  [5819] = 5783,
  [5820] = 5781,
  [5821] = 5783,
  [5822] = 5784,
  [5823] = 5795,
  [5824] = 5799,
  [5825] = 5783,
  [5826] = 5784,
  [5827] = 5783,
  [5828] = 5781,
  [5829] = 5781,
  [5830] = 5784,
  [5831] = 5783,
  [5832] = 5832,
  [5833] = 5795,
  [5834] = 5799,
  [5835] = 5799,
  [5836] = 5784,
  [5837] = 5799,
  [5838] = 5795,
  [5839] = 5797,
  [5840] = 5784,
  [5841] = 5799,
  [5842] = 5784,
  [5843] = 5790,
  [5844] = 5718,
  [5845] = 5783,
  [5846] = 5781,
  [5847] = 5799,
  [5848] = 5783,
  [5849] = 5784,
  [5850] = 5784,
  [5851] = 5799,
  [5852] = 5795,
  [5853] = 5784,
  [5854] = 5795,
  [5855] = 5783,
  [5856] = 5781,
  [5857] = 5795,
  [5858] = 5799,
  [5859] = 5784,
  [5860] = 5784,
  [5861] = 5784,
  [5862] = 5795,
  [5863] = 5781,
  [5864] = 5783,
  [5865] = 5795,
  [5866] = 5783,
  [5867] = 5799,
  [5868] = 5795,
  [5869] = 5783,
  [5870] = 5781,
  [5871] = 5783,
  [5872] = 5799,
  [5873] = 5795,
  [5874] = 5784,
  [5875] = 5795,
  [5876] = 5783,
  [5877] = 5783,
  [5878] = 5784,
  [5879] = 5795,
  [5880] = 5783,
  [5881] = 5781,
  [5882] = 5799,
  [5883] = 5799,
  [5884] = 5799,
  [5885] = 5784,
  [5886] = 5784,
  [5887] = 5799,
  [5888] = 5795,
  [5889] = 5783,
  [5890] = 5795,
  [5891] = 5891,
  [5892] = 5892,
  [5893] = 5893,
  [5894] = 5894,
  [5895] = 5895,
  [5896] = 5891,
  [5897] = 5897,
  [5898] = 5898,
  [5899] = 5899,
  [5900] = 5900,
  [5901] = 5901,
  [5902] = 5902,
  [5903] = 5903,
  [5904] = 5904,
  [5905] = 5891,
  [5906] = 5900,
  [5907] = 5907,
  [5908] = 5908,
  [5909] = 5909,
  [5910] = 5891,
  [5911] = 5892,
  [5912] = 5912,
  [5913] = 5913,
  [5914] = 5891,
  [5915] = 5891,
  [5916] = 5916,
  [5917] = 5892,
  [5918] = 5918,
  [5919] = 5900,
  [5920] = 5897,
  [5921] = 5921,
  [5922] = 5897,
  [5923] = 5923,
  [5924] = 5924,
  [5925] = 5925,
  [5926] = 5926,
  [5927] = 5918,
  [5928] = 5928,
  [5929] = 5897,
  [5930] = 5900,
  [5931] = 5897,
  [5932] = 5704,
  [5933] = 5897,
  [5934] = 5891,
  [5935] = 2970,
  [5936] = 5891,
  [5937] = 5892,
  [5938] = 5749,
  [5939] = 5892,
  [5940] = 5900,
  [5941] = 5891,
  [5942] = 5942,
  [5943] = 5891,
  [5944] = 5894,
  [5945] = 5900,
  [5946] = 5750,
  [5947] = 5893,
  [5948] = 5891,
  [5949] = 5891,
  [5950] = 5898,
  [5951] = 5899,
  [5952] = 5924,
  [5953] = 5953,
  [5954] = 5954,
  [5955] = 5893,
  [5956] = 5956,
  [5957] = 5957,
  [5958] = 5891,
  [5959] = 5959,
  [5960] = 5960,
  [5961] = 5961,
  [5962] = 5954,
  [5963] = 5921,
  [5964] = 5900,
  [5965] = 5965,
  [5966] = 5900,
  [5967] = 5967,
  [5968] = 5968,
  [5969] = 5897,
  [5970] = 5970,
  [5971] = 5971,
  [5972] = 5892,
  [5973] = 5897,
  [5974] = 5974,
  [5975] = 5913,
  [5976] = 5954,
  [5977] = 5897,
  [5978] = 5978,
  [5979] = 5979,
  [5980] = 5894,
  [5981] = 5891,
  [5982] = 5982,
  [5983] = 5892,
  [5984] = 5912,
  [5985] = 5908,
  [5986] = 5891,
  [5987] = 5893,
  [5988] = 5907,
  [5989] = 5904,
  [5990] = 5903,
  [5991] = 5901,
  [5992] = 5992,
  [5993] = 5900,
  [5994] = 5994,
  [5995] = 5995,
  [5996] = 1674,
  [5997] = 131,
  [5998] = 5979,
  [5999] = 5978,
  [6000] = 5974,
  [6001] = 6001,
  [6002] = 6002,
  [6003] = 6003,
  [6004] = 5953,
  [6005] = 6005,
  [6006] = 6002,
  [6007] = 6007,
  [6008] = 1672,
  [6009] = 6009,
  [6010] = 6010,
  [6011] = 6011,
  [6012] = 5968,
  [6013] = 6013,
  [6014] = 5961,
  [6015] = 5959,
  [6016] = 5957,
  [6017] = 5956,
  [6018] = 1670,
  [6019] = 6019,
  [6020] = 6007,
  [6021] = 6021,
  [6022] = 6022,
  [6023] = 6023,
  [6024] = 6013,
  [6025] = 5965,
  [6026] = 1671,
  [6027] = 6007,
  [6028] = 6028,
  [6029] = 6023,
  [6030] = 2126,
  [6031] = 6028,
  [6032] = 5902,
  [6033] = 5923,
  [6034] = 6003,
  [6035] = 1676,
  [6036] = 6001,
  [6037] = 6013,
  [6038] = 6010,
  [6039] = 6039,
  [6040] = 6010,
  [6041] = 6041,
  [6042] = 6042,
  [6043] = 6003,
  [6044] = 6044,
  [6045] = 2126,
  [6046] = 1667,
  [6047] = 6047,
  [6048] = 6003,
  [6049] = 6001,
  [6050] = 6028,
  [6051] = 1666,
  [6052] = 1664,
  [6053] = 6011,
  [6054] = 132,
  [6055] = 6055,
  [6056] = 6007,
  [6057] = 6057,
  [6058] = 2970,
  [6059] = 6042,
  [6060] = 6002,
  [6061] = 6061,
  [6062] = 1665,
  [6063] = 6013,
  [6064] = 6042,
  [6065] = 5982,
  [6066] = 6001,
  [6067] = 1669,
  [6068] = 6068,
  [6069] = 6007,
  [6070] = 6070,
  [6071] = 5970,
  [6072] = 6003,
  [6073] = 6022,
  [6074] = 6074,
  [6075] = 6009,
  [6076] = 6019,
  [6077] = 5928,
  [6078] = 6078,
  [6079] = 6079,
  [6080] = 6080,
  [6081] = 6011,
  [6082] = 6013,
  [6083] = 6083,
  [6084] = 6002,
  [6085] = 6022,
  [6086] = 6023,
  [6087] = 6087,
  [6088] = 6019,
  [6089] = 6041,
  [6090] = 6042,
  [6091] = 6041,
  [6092] = 6010,
  [6093] = 6093,
  [6094] = 6042,
  [6095] = 6028,
  [6096] = 1673,
  [6097] = 6001,
  [6098] = 1675,
  [6099] = 1680,
  [6100] = 6100,
  [6101] = 6010,
  [6102] = 6001,
  [6103] = 6019,
  [6104] = 6011,
  [6105] = 6041,
  [6106] = 6007,
  [6107] = 6023,
  [6108] = 6022,
  [6109] = 1668,
  [6110] = 6013,
  [6111] = 6003,
  [6112] = 2106,
  [6113] = 6010,
  [6114] = 5967,
  [6115] = 6115,
  [6116] = 1679,
  [6117] = 2106,
  [6118] = 6003,
  [6119] = 6042,
  [6120] = 5704,
  [6121] = 6011,
  [6122] = 6003,
  [6123] = 6123,
  [6124] = 5992,
  [6125] = 5995,
  [6126] = 6083,
  [6127] = 6009,
  [6128] = 6057,
  [6129] = 6001,
  [6130] = 6007,
  [6131] = 6013,
  [6132] = 5704,
  [6133] = 2400,
  [6134] = 6001,
  [6135] = 6013,
  [6136] = 6010,
  [6137] = 6137,
  [6138] = 6010,
  [6139] = 6139,
  [6140] = 6140,
  [6141] = 6007,
  [6142] = 6074,
  [6143] = 6143,
  [6144] = 6144,
  [6145] = 6070,
  [6146] = 6007,
  [6147] = 6010,
  [6148] = 6148,
  [6149] = 6149,
  [6150] = 6150,
  [6151] = 6151,
  [6152] = 6152,
  [6153] = 6153,
  [6154] = 6154,
  [6155] = 6154,
  [6156] = 6156,
  [6157] = 6157,
  [6158] = 6158,
  [6159] = 6154,
  [6160] = 6160,
  [6161] = 6161,
  [6162] = 6162,
  [6163] = 6163,
  [6164] = 6157,
  [6165] = 6001,
  [6166] = 6166,
  [6167] = 6167,
  [6168] = 6001,
  [6169] = 6157,
  [6170] = 6010,
  [6171] = 6171,
  [6172] = 6154,
  [6173] = 6173,
  [6174] = 6007,
  [6175] = 6154,
  [6176] = 6171,
  [6177] = 6177,
  [6178] = 6157,
  [6179] = 6154,
  [6180] = 6157,
  [6181] = 1871,
  [6182] = 6157,
  [6183] = 6157,
  [6184] = 6184,
  [6185] = 6185,
  [6186] = 5704,
  [6187] = 6013,
  [6188] = 2067,
  [6189] = 6157,
  [6190] = 6001,
  [6191] = 6007,
  [6192] = 6171,
  [6193] = 6193,
  [6194] = 6013,
  [6195] = 6157,
  [6196] = 6013,
  [6197] = 6197,
  [6198] = 6171,
  [6199] = 6199,
  [6200] = 6157,
  [6201] = 5704,
  [6202] = 6154,
  [6203] = 6203,
  [6204] = 6010,
  [6205] = 6154,
  [6206] = 6001,
  [6207] = 6207,
  [6208] = 6154,
  [6209] = 6154,
  [6210] = 6203,
  [6211] = 6154,
  [6212] = 6007,
  [6213] = 6013,
  [6214] = 6010,
  [6215] = 6157,
  [6216] = 2026,
  [6217] = 6217,
  [6218] = 6218,
  [6219] = 6171,
  [6220] = 1868,
  [6221] = 6157,
  [6222] = 2001,
  [6223] = 6154,
  [6224] = 6224,
  [6225] = 6225,
  [6226] = 6013,
  [6227] = 6010,
  [6228] = 6002,
  [6229] = 6229,
  [6230] = 6022,
  [6231] = 1668,
  [6232] = 6229,
  [6233] = 6229,
  [6234] = 6229,
  [6235] = 6235,
  [6236] = 6023,
  [6237] = 6237,
  [6238] = 6229,
  [6239] = 1665,
  [6240] = 6229,
  [6241] = 6019,
  [6242] = 1667,
  [6243] = 6229,
  [6244] = 6041,
  [6245] = 1675,
  [6246] = 6010,
  [6247] = 1673,
  [6248] = 6229,
  [6249] = 2106,
  [6250] = 1669,
  [6251] = 1674,
  [6252] = 5704,
  [6253] = 6007,
  [6254] = 6041,
  [6255] = 6229,
  [6256] = 1664,
  [6257] = 6093,
  [6258] = 6229,
  [6259] = 6229,
  [6260] = 1666,
  [6261] = 788,
  [6262] = 6229,
  [6263] = 787,
  [6264] = 5704,
  [6265] = 2593,
  [6266] = 6266,
  [6267] = 6229,
  [6268] = 6229,
  [6269] = 6229,
  [6270] = 6013,
  [6271] = 6019,
  [6272] = 1676,
  [6273] = 6022,
  [6274] = 6001,
  [6275] = 6005,
  [6276] = 2126,
  [6277] = 1670,
  [6278] = 6229,
  [6279] = 6229,
  [6280] = 6229,
  [6281] = 6007,
  [6282] = 6023,
  [6283] = 1671,
  [6284] = 6002,
  [6285] = 132,
  [6286] = 6001,
  [6287] = 6229,
  [6288] = 1672,
  [6289] = 6289,
  [6290] = 1680,
  [6291] = 131,
  [6292] = 6229,
  [6293] = 1679,
  [6294] = 6294,
  [6295] = 6295,
  [6296] = 6295,
  [6297] = 2572,
  [6298] = 6298,
  [6299] = 6295,
  [6300] = 6300,
  [6301] = 6301,
  [6302] = 6295,
  [6303] = 6303,
  [6304] = 6304,
  [6305] = 6305,
  [6306] = 6304,
  [6307] = 6298,
  [6308] = 6305,
  [6309] = 6309,
  [6310] = 2346,
  [6311] = 6311,
  [6312] = 2309,
  [6313] = 6303,
  [6314] = 6295,
  [6315] = 6311,
  [6316] = 6316,
  [6317] = 6295,
  [6318] = 2341,
  [6319] = 6301,
  [6320] = 6294,
  [6321] = 6321,
  [6322] = 6311,
  [6323] = 6316,
  [6324] = 6311,
  [6325] = 6311,
  [6326] = 6010,
  [6327] = 6300,
  [6328] = 6316,
  [6329] = 2644,
  [6330] = 6330,
  [6331] = 6331,
  [6332] = 6295,
  [6333] = 6321,
  [6334] = 2691,
  [6335] = 6309,
  [6336] = 6311,
  [6337] = 6013,
  [6338] = 6316,
  [6339] = 2312,
  [6340] = 2364,
  [6341] = 6309,
  [6342] = 6295,
  [6343] = 6295,
  [6344] = 6298,
  [6345] = 6010,
  [6346] = 6311,
  [6347] = 6316,
  [6348] = 6321,
  [6349] = 6304,
  [6350] = 6013,
  [6351] = 6305,
  [6352] = 6352,
  [6353] = 6353,
  [6354] = 2400,
  [6355] = 6316,
  [6356] = 6303,
  [6357] = 6357,
  [6358] = 6311,
  [6359] = 6316,
  [6360] = 6311,
  [6361] = 6301,
  [6362] = 6007,
  [6363] = 6295,
  [6364] = 6321,
  [6365] = 6365,
  [6366] = 6295,
  [6367] = 6367,
  [6368] = 6321,
  [6369] = 6316,
  [6370] = 6294,
  [6371] = 6001,
  [6372] = 6316,
  [6373] = 6295,
  [6374] = 6001,
  [6375] = 6300,
  [6376] = 6007,
  [6377] = 6197,
  [6378] = 6002,
  [6379] = 6207,
  [6380] = 6380,
  [6381] = 6010,
  [6382] = 6013,
  [6383] = 6007,
  [6384] = 6001,
  [6385] = 6385,
  [6386] = 6386,
  [6387] = 906,
  [6388] = 6010,
  [6389] = 6013,
  [6390] = 6007,
  [6391] = 6173,
  [6392] = 6023,
  [6393] = 6001,
  [6394] = 6394,
  [6395] = 6002,
  [6396] = 6022,
  [6397] = 6394,
  [6398] = 6022,
  [6399] = 6158,
  [6400] = 6023,
  [6401] = 6023,
  [6402] = 6380,
  [6403] = 6022,
  [6404] = 6404,
  [6405] = 6224,
  [6406] = 6002,
  [6407] = 6380,
  [6408] = 6385,
  [6409] = 6380,
  [6410] = 6153,
  [6411] = 6394,
  [6412] = 6019,
  [6413] = 6380,
  [6414] = 6385,
  [6415] = 6019,
  [6416] = 6167,
  [6417] = 6380,
  [6418] = 6041,
  [6419] = 6300,
  [6420] = 6394,
  [6421] = 6394,
  [6422] = 6019,
  [6423] = 6023,
  [6424] = 6022,
  [6425] = 6425,
  [6426] = 6294,
  [6427] = 6301,
  [6428] = 2106,
  [6429] = 6041,
  [6430] = 6166,
  [6431] = 6431,
  [6432] = 6380,
  [6433] = 6163,
  [6434] = 6162,
  [6435] = 6161,
  [6436] = 6436,
  [6437] = 6431,
  [6438] = 6380,
  [6439] = 6439,
  [6440] = 6380,
  [6441] = 6160,
  [6442] = 6385,
  [6443] = 6041,
  [6444] = 6303,
  [6445] = 6305,
  [6446] = 2126,
  [6447] = 6304,
  [6448] = 6298,
  [6449] = 6385,
  [6450] = 6380,
  [6451] = 6451,
  [6452] = 2140,
  [6453] = 2142,
  [6454] = 6454,
  [6455] = 6385,
  [6456] = 2126,
  [6457] = 6380,
  [6458] = 6184,
  [6459] = 6459,
  [6460] = 6431,
  [6461] = 6385,
  [6462] = 6431,
  [6463] = 6394,
  [6464] = 6394,
  [6465] = 6465,
  [6466] = 6466,
  [6467] = 6454,
  [6468] = 6380,
  [6469] = 6469,
  [6470] = 6309,
  [6471] = 6471,
  [6472] = 6472,
  [6473] = 6380,
  [6474] = 6177,
  [6475] = 6386,
  [6476] = 5704,
  [6477] = 6451,
  [6478] = 6041,
  [6479] = 6436,
  [6480] = 6185,
  [6481] = 6380,
  [6482] = 6482,
  [6483] = 6431,
  [6484] = 6472,
  [6485] = 6380,
  [6486] = 2139,
  [6487] = 6431,
  [6488] = 2106,
  [6489] = 2147,
  [6490] = 6380,
  [6491] = 6380,
  [6492] = 6492,
  [6493] = 6151,
  [6494] = 6380,
  [6495] = 6380,
  [6496] = 6431,
  [6497] = 6149,
  [6498] = 6148,
  [6499] = 6152,
  [6500] = 6019,
  [6501] = 6380,
  [6502] = 6380,
  [6503] = 6193,
  [6504] = 6150,
  [6505] = 2388,
  [6506] = 6002,
  [6507] = 6507,
  [6508] = 6508,
  [6509] = 6509,
  [6510] = 6510,
  [6511] = 6511,
  [6512] = 6512,
  [6513] = 6509,
  [6514] = 6508,
  [6515] = 6515,
  [6516] = 6507,
  [6517] = 6507,
  [6518] = 6507,
  [6519] = 6519,
  [6520] = 2456,
  [6521] = 6300,
  [6522] = 6508,
  [6523] = 6523,
  [6524] = 6524,
  [6525] = 6509,
  [6526] = 6523,
  [6527] = 6508,
  [6528] = 6309,
  [6529] = 6529,
  [6530] = 6298,
  [6531] = 6531,
  [6532] = 6532,
  [6533] = 6533,
  [6534] = 6508,
  [6535] = 2364,
  [6536] = 2312,
  [6537] = 2341,
  [6538] = 2346,
  [6539] = 2309,
  [6540] = 6507,
  [6541] = 6515,
  [6542] = 6309,
  [6543] = 6543,
  [6544] = 6298,
  [6545] = 6509,
  [6546] = 2381,
  [6547] = 6304,
  [6548] = 6508,
  [6549] = 2377,
  [6550] = 6305,
  [6551] = 6509,
  [6552] = 6303,
  [6553] = 6301,
  [6554] = 6301,
  [6555] = 6294,
  [6556] = 6508,
  [6557] = 6523,
  [6558] = 6300,
  [6559] = 6559,
  [6560] = 6508,
  [6561] = 6523,
  [6562] = 6562,
  [6563] = 2389,
  [6564] = 2408,
  [6565] = 2432,
  [6566] = 6508,
  [6567] = 6507,
  [6568] = 6508,
  [6569] = 6523,
  [6570] = 2398,
  [6571] = 6507,
  [6572] = 6507,
  [6573] = 2409,
  [6574] = 6508,
  [6575] = 2721,
  [6576] = 6303,
  [6577] = 6305,
  [6578] = 2410,
  [6579] = 2414,
  [6580] = 2718,
  [6581] = 6507,
  [6582] = 6512,
  [6583] = 6583,
  [6584] = 6509,
  [6585] = 6294,
  [6586] = 6515,
  [6587] = 6507,
  [6588] = 6507,
  [6589] = 6001,
  [6590] = 6007,
  [6591] = 6013,
  [6592] = 6010,
  [6593] = 6508,
  [6594] = 6001,
  [6595] = 6512,
  [6596] = 6562,
  [6597] = 6007,
  [6598] = 6598,
  [6599] = 6509,
  [6600] = 6523,
  [6601] = 2678,
  [6602] = 6013,
  [6603] = 2674,
  [6604] = 6604,
  [6605] = 2673,
  [6606] = 2392,
  [6607] = 2672,
  [6608] = 2670,
  [6609] = 2668,
  [6610] = 6010,
  [6611] = 6304,
  [6612] = 6515,
  [6613] = 6512,
  [6614] = 6507,
  [6615] = 2364,
  [6616] = 6303,
  [6617] = 6010,
  [6618] = 6618,
  [6619] = 6013,
  [6620] = 6007,
  [6621] = 6001,
  [6622] = 6482,
  [6623] = 2312,
  [6624] = 6041,
  [6625] = 2932,
  [6626] = 2309,
  [6627] = 6618,
  [6628] = 6618,
  [6629] = 6019,
  [6630] = 6618,
  [6631] = 6618,
  [6632] = 6618,
  [6633] = 6023,
  [6634] = 6022,
  [6635] = 6635,
  [6636] = 6636,
  [6637] = 6002,
  [6638] = 6618,
  [6639] = 6618,
  [6640] = 6618,
  [6641] = 6618,
  [6642] = 6436,
  [6643] = 6451,
  [6644] = 6472,
  [6645] = 6618,
  [6646] = 6618,
  [6647] = 6010,
  [6648] = 6618,
  [6649] = 6618,
  [6650] = 6041,
  [6651] = 6618,
  [6652] = 6013,
  [6653] = 6019,
  [6654] = 6007,
  [6655] = 6023,
  [6656] = 2106,
  [6657] = 6022,
  [6658] = 2388,
  [6659] = 6001,
  [6660] = 6618,
  [6661] = 6301,
  [6662] = 6002,
  [6663] = 6300,
  [6664] = 6294,
  [6665] = 6298,
  [6666] = 6454,
  [6667] = 6618,
  [6668] = 6386,
  [6669] = 6305,
  [6670] = 6304,
  [6671] = 2126,
  [6672] = 6618,
  [6673] = 2346,
  [6674] = 2341,
  [6675] = 6675,
  [6676] = 6676,
  [6677] = 6618,
  [6678] = 6618,
  [6679] = 6618,
  [6680] = 6309,
  [6681] = 6681,
  [6682] = 6682,
  [6683] = 6683,
  [6684] = 6023,
  [6685] = 6002,
  [6686] = 6686,
  [6687] = 6687,
  [6688] = 6436,
  [6689] = 6689,
  [6690] = 6681,
  [6691] = 6691,
  [6692] = 6300,
  [6693] = 6691,
  [6694] = 6305,
  [6695] = 6695,
  [6696] = 2126,
  [6697] = 6697,
  [6698] = 6698,
  [6699] = 6699,
  [6700] = 6019,
  [6701] = 6304,
  [6702] = 6687,
  [6703] = 6703,
  [6704] = 6704,
  [6705] = 6705,
  [6706] = 6706,
  [6707] = 6707,
  [6708] = 6300,
  [6709] = 6687,
  [6710] = 6695,
  [6711] = 6711,
  [6712] = 6712,
  [6713] = 6713,
  [6714] = 6454,
  [6715] = 2106,
  [6716] = 6695,
  [6717] = 6717,
  [6718] = 6691,
  [6719] = 6719,
  [6720] = 6298,
  [6721] = 6294,
  [6722] = 2533,
  [6723] = 6687,
  [6724] = 6022,
  [6725] = 6298,
  [6726] = 6303,
  [6727] = 6691,
  [6728] = 2388,
  [6729] = 6687,
  [6730] = 6002,
  [6731] = 6731,
  [6732] = 6022,
  [6733] = 6733,
  [6734] = 6304,
  [6735] = 6301,
  [6736] = 6695,
  [6737] = 6023,
  [6738] = 6019,
  [6739] = 6687,
  [6740] = 6695,
  [6741] = 6041,
  [6742] = 6687,
  [6743] = 6743,
  [6744] = 6451,
  [6745] = 6301,
  [6746] = 6681,
  [6747] = 6386,
  [6748] = 6748,
  [6749] = 6749,
  [6750] = 6695,
  [6751] = 6309,
  [6752] = 6752,
  [6753] = 6753,
  [6754] = 6691,
  [6755] = 6681,
  [6756] = 6691,
  [6757] = 6757,
  [6758] = 6758,
  [6759] = 6691,
  [6760] = 6041,
  [6761] = 6695,
  [6762] = 6681,
  [6763] = 6763,
  [6764] = 6472,
  [6765] = 6681,
  [6766] = 6681,
  [6767] = 6767,
  [6768] = 6298,
  [6769] = 6303,
  [6770] = 6305,
  [6771] = 6304,
  [6772] = 6772,
  [6773] = 6309,
  [6774] = 6774,
  [6775] = 6775,
  [6776] = 6776,
  [6777] = 6777,
  [6778] = 6775,
  [6779] = 6779,
  [6780] = 6780,
  [6781] = 6775,
  [6782] = 892,
  [6783] = 896,
  [6784] = 6301,
  [6785] = 6294,
  [6786] = 889,
  [6787] = 6300,
  [6788] = 6775,
  [6789] = 890,
  [6790] = 6790,
  [6791] = 6775,
  [6792] = 895,
  [6793] = 893,
  [6794] = 6794,
  [6795] = 6775,
  [6796] = 891,
  [6797] = 6797,
  [6798] = 6775,
  [6799] = 6777,
  [6800] = 6775,
  [6801] = 6775,
  [6802] = 6775,
  [6803] = 6775,
  [6804] = 6775,
  [6805] = 6775,
  [6806] = 6806,
  [6807] = 6775,
  [6808] = 6775,
  [6809] = 6809,
  [6810] = 6809,
  [6811] = 6811,
  [6812] = 6812,
  [6813] = 6812,
  [6814] = 2106,
  [6815] = 6815,
  [6816] = 6809,
  [6817] = 6811,
  [6818] = 6809,
  [6819] = 6235,
  [6820] = 6820,
  [6821] = 6809,
  [6822] = 6811,
  [6823] = 6809,
  [6824] = 6301,
  [6825] = 6812,
  [6826] = 6812,
  [6827] = 6809,
  [6828] = 6237,
  [6829] = 6809,
  [6830] = 6811,
  [6831] = 6809,
  [6832] = 6809,
  [6833] = 6809,
  [6834] = 6812,
  [6835] = 6835,
  [6836] = 6809,
  [6837] = 6809,
  [6838] = 6294,
  [6839] = 6809,
  [6840] = 6812,
  [6841] = 6841,
  [6842] = 6815,
  [6843] = 6812,
  [6844] = 6303,
  [6845] = 6809,
  [6846] = 6809,
  [6847] = 6809,
  [6848] = 6809,
  [6849] = 6305,
  [6850] = 6841,
  [6851] = 6815,
  [6852] = 6841,
  [6853] = 6809,
  [6854] = 6309,
  [6855] = 6809,
  [6856] = 6300,
  [6857] = 6841,
  [6858] = 6809,
  [6859] = 6298,
  [6860] = 6815,
  [6861] = 6809,
  [6862] = 2126,
  [6863] = 6304,
  [6864] = 6809,
  [6865] = 6865,
  [6866] = 6866,
  [6867] = 6466,
  [6868] = 6866,
  [6869] = 6869,
  [6870] = 6404,
  [6871] = 6871,
  [6872] = 6872,
  [6873] = 6873,
  [6874] = 6866,
  [6875] = 6451,
  [6876] = 6298,
  [6877] = 6465,
  [6878] = 6866,
  [6879] = 6304,
  [6880] = 6880,
  [6881] = 6881,
  [6882] = 6882,
  [6883] = 6865,
  [6884] = 6884,
  [6885] = 6866,
  [6886] = 6873,
  [6887] = 6301,
  [6888] = 6866,
  [6889] = 6454,
  [6890] = 6436,
  [6891] = 6472,
  [6892] = 6237,
  [6893] = 6873,
  [6894] = 6492,
  [6895] = 6235,
  [6896] = 2572,
  [6897] = 6897,
  [6898] = 6898,
  [6899] = 6309,
  [6900] = 6294,
  [6901] = 6901,
  [6902] = 6866,
  [6903] = 6903,
  [6904] = 6865,
  [6905] = 6439,
  [6906] = 6386,
  [6907] = 6303,
  [6908] = 6305,
  [6909] = 6300,
  [6910] = 6873,
  [6911] = 6911,
  [6912] = 6912,
  [6913] = 6865,
  [6914] = 6914,
  [6915] = 6294,
  [6916] = 6916,
  [6917] = 6917,
  [6918] = 6918,
  [6919] = 6916,
  [6920] = 6916,
  [6921] = 2143,
  [6922] = 2364,
  [6923] = 6298,
  [6924] = 6309,
  [6925] = 6304,
  [6926] = 6926,
  [6927] = 2572,
  [6928] = 6305,
  [6929] = 2346,
  [6930] = 6930,
  [6931] = 6926,
  [6932] = 2312,
  [6933] = 6303,
  [6934] = 6934,
  [6935] = 6935,
  [6936] = 2141,
  [6937] = 6926,
  [6938] = 2309,
  [6939] = 6303,
  [6940] = 6917,
  [6941] = 6941,
  [6942] = 6916,
  [6943] = 6305,
  [6944] = 6917,
  [6945] = 6945,
  [6946] = 6298,
  [6947] = 6304,
  [6948] = 2138,
  [6949] = 6926,
  [6950] = 6309,
  [6951] = 6301,
  [6952] = 6300,
  [6953] = 6953,
  [6954] = 6935,
  [6955] = 6300,
  [6956] = 6294,
  [6957] = 6957,
  [6958] = 6935,
  [6959] = 6959,
  [6960] = 6301,
  [6961] = 6961,
  [6962] = 6935,
  [6963] = 2341,
  [6964] = 6935,
  [6965] = 6926,
  [6966] = 6917,
  [6967] = 6967,
  [6968] = 6968,
  [6969] = 6969,
  [6970] = 6970,
  [6971] = 6970,
  [6972] = 6967,
  [6973] = 6967,
  [6974] = 6970,
  [6975] = 6970,
  [6976] = 6967,
  [6977] = 6967,
  [6978] = 6970,
  [6979] = 6968,
  [6980] = 6980,
  [6981] = 6981,
  [6982] = 6982,
  [6983] = 6983,
  [6984] = 6967,
  [6985] = 6970,
  [6986] = 6986,
  [6987] = 6967,
  [6988] = 6967,
  [6989] = 6989,
  [6990] = 6986,
  [6991] = 6970,
  [6992] = 6970,
  [6993] = 6993,
  [6994] = 6989,
  [6995] = 6989,
  [6996] = 6986,
  [6997] = 6997,
  [6998] = 6986,
  [6999] = 6989,
  [7000] = 6989,
  [7001] = 6986,
  [7002] = 2388,
  [7003] = 2572,
  [7004] = 7004,
  [7005] = 7005,
  [7006] = 6989,
  [7007] = 6986,
  [7008] = 6636,
  [7009] = 7009,
  [7010] = 6970,
  [7011] = 6967,
  [7012] = 7012,
  [7013] = 2572,
  [7014] = 7014,
  [7015] = 7015,
  [7016] = 6986,
  [7017] = 6989,
  [7018] = 6635,
  [7019] = 6676,
  [7020] = 7020,
  [7021] = 7021,
  [7022] = 6983,
  [7023] = 7023,
  [7024] = 7024,
  [7025] = 7025,
  [7026] = 7026,
  [7027] = 7024,
  [7028] = 7028,
  [7029] = 7029,
  [7030] = 7025,
  [7031] = 7031,
  [7032] = 7032,
  [7033] = 7033,
  [7034] = 7034,
  [7035] = 7028,
  [7036] = 7036,
  [7037] = 7034,
  [7038] = 7038,
  [7039] = 6300,
  [7040] = 7040,
  [7041] = 7041,
  [7042] = 6309,
  [7043] = 7036,
  [7044] = 7029,
  [7045] = 2572,
  [7046] = 7036,
  [7047] = 7047,
  [7048] = 7025,
  [7049] = 7025,
  [7050] = 7050,
  [7051] = 7051,
  [7052] = 7034,
  [7053] = 6294,
  [7054] = 7054,
  [7055] = 2511,
  [7056] = 7034,
  [7057] = 7057,
  [7058] = 7058,
  [7059] = 6305,
  [7060] = 7060,
  [7061] = 7034,
  [7062] = 7041,
  [7063] = 6301,
  [7064] = 7060,
  [7065] = 7033,
  [7066] = 7058,
  [7067] = 2572,
  [7068] = 7057,
  [7069] = 7057,
  [7070] = 7058,
  [7071] = 7034,
  [7072] = 7060,
  [7073] = 6298,
  [7074] = 7074,
  [7075] = 7033,
  [7076] = 7050,
  [7077] = 6304,
  [7078] = 7041,
  [7079] = 7079,
  [7080] = 7029,
  [7081] = 7028,
  [7082] = 7054,
  [7083] = 6303,
  [7084] = 7084,
  [7085] = 7085,
  [7086] = 7086,
  [7087] = 7087,
  [7088] = 7088,
  [7089] = 7087,
  [7090] = 7090,
  [7091] = 7091,
  [7092] = 7092,
  [7093] = 7093,
  [7094] = 7094,
  [7095] = 7084,
  [7096] = 7096,
  [7097] = 7090,
  [7098] = 7090,
  [7099] = 7099,
  [7100] = 7084,
  [7101] = 7090,
  [7102] = 7102,
  [7103] = 7084,
  [7104] = 7104,
  [7105] = 7090,
  [7106] = 7106,
  [7107] = 7084,
  [7108] = 7108,
  [7109] = 7109,
  [7110] = 7110,
  [7111] = 7111,
  [7112] = 7112,
  [7113] = 7113,
  [7114] = 7090,
  [7115] = 7108,
  [7116] = 7106,
  [7117] = 7117,
  [7118] = 7118,
  [7119] = 7084,
  [7120] = 7111,
  [7121] = 7112,
  [7122] = 7084,
  [7123] = 7108,
  [7124] = 7084,
  [7125] = 7090,
  [7126] = 7085,
  [7127] = 7127,
  [7128] = 7128,
  [7129] = 7084,
  [7130] = 7084,
  [7131] = 7106,
  [7132] = 7086,
  [7133] = 7133,
  [7134] = 7134,
  [7135] = 7135,
  [7136] = 7108,
  [7137] = 7090,
  [7138] = 7108,
  [7139] = 7133,
  [7140] = 7108,
  [7141] = 7087,
  [7142] = 7142,
  [7143] = 7085,
  [7144] = 7087,
  [7145] = 7135,
  [7146] = 7146,
  [7147] = 7109,
  [7148] = 7133,
  [7149] = 7149,
  [7150] = 7108,
  [7151] = 7118,
  [7152] = 7108,
  [7153] = 7153,
  [7154] = 7090,
  [7155] = 7106,
  [7156] = 7135,
  [7157] = 7084,
  [7158] = 7094,
  [7159] = 7159,
  [7160] = 7108,
  [7161] = 7090,
  [7162] = 7102,
  [7163] = 7087,
  [7164] = 7112,
  [7165] = 7165,
  [7166] = 7099,
  [7167] = 7093,
  [7168] = 7084,
  [7169] = 7149,
  [7170] = 7096,
  [7171] = 7108,
  [7172] = 7090,
  [7173] = 7104,
  [7174] = 7090,
  [7175] = 7109,
  [7176] = 7096,
  [7177] = 7177,
  [7178] = 7104,
  [7179] = 7111,
  [7180] = 7084,
  [7181] = 7104,
  [7182] = 7182,
  [7183] = 7108,
  [7184] = 7113,
  [7185] = 7090,
  [7186] = 7096,
  [7187] = 7113,
  [7188] = 7090,
  [7189] = 7096,
  [7190] = 7113,
  [7191] = 7084,
  [7192] = 7086,
  [7193] = 7094,
  [7194] = 7085,
  [7195] = 7090,
  [7196] = 7104,
  [7197] = 7086,
  [7198] = 7096,
  [7199] = 7102,
  [7200] = 7108,
  [7201] = 7133,
  [7202] = 7133,
  [7203] = 7084,
  [7204] = 7109,
  [7205] = 7090,
  [7206] = 7096,
  [7207] = 7094,
  [7208] = 7111,
  [7209] = 7112,
  [7210] = 7094,
  [7211] = 7084,
  [7212] = 7094,
  [7213] = 7090,
  [7214] = 7087,
  [7215] = 7084,
  [7216] = 7135,
  [7217] = 7096,
  [7218] = 7218,
  [7219] = 7149,
  [7220] = 7087,
  [7221] = 7221,
  [7222] = 7093,
  [7223] = 7128,
  [7224] = 7111,
  [7225] = 7099,
  [7226] = 7094,
  [7227] = 7227,
  [7228] = 7133,
  [7229] = 7099,
  [7230] = 7096,
  [7231] = 7086,
  [7232] = 7093,
  [7233] = 7090,
  [7234] = 7086,
  [7235] = 7112,
  [7236] = 7102,
  [7237] = 7111,
  [7238] = 7084,
  [7239] = 7106,
  [7240] = 7109,
  [7241] = 7108,
  [7242] = 7104,
  [7243] = 7112,
  [7244] = 7133,
  [7245] = 7109,
  [7246] = 7102,
  [7247] = 7109,
  [7248] = 7104,
  [7249] = 7093,
  [7250] = 7250,
  [7251] = 7087,
  [7252] = 7118,
  [7253] = 7099,
  [7254] = 7090,
  [7255] = 7106,
  [7256] = 7256,
  [7257] = 7149,
  [7258] = 7084,
  [7259] = 7118,
  [7260] = 7096,
  [7261] = 7094,
  [7262] = 7094,
  [7263] = 7263,
  [7264] = 7096,
  [7265] = 7090,
  [7266] = 7128,
  [7267] = 7267,
  [7268] = 7084,
  [7269] = 7146,
  [7270] = 7270,
  [7271] = 7084,
  [7272] = 7104,
  [7273] = 7133,
  [7274] = 7102,
  [7275] = 7135,
  [7276] = 7149,
  [7277] = 7109,
  [7278] = 7093,
  [7279] = 7128,
  [7280] = 7146,
  [7281] = 7106,
  [7282] = 6237,
  [7283] = 7106,
  [7284] = 7099,
  [7285] = 7086,
  [7286] = 7111,
  [7287] = 7102,
  [7288] = 7102,
  [7289] = 7128,
  [7290] = 7108,
  [7291] = 7118,
  [7292] = 7133,
  [7293] = 7146,
  [7294] = 7294,
  [7295] = 7102,
  [7296] = 7133,
  [7297] = 7102,
  [7298] = 7298,
  [7299] = 7128,
  [7300] = 7109,
  [7301] = 7146,
  [7302] = 7104,
  [7303] = 7108,
  [7304] = 7109,
  [7305] = 7099,
  [7306] = 7090,
  [7307] = 7086,
  [7308] = 7096,
  [7309] = 7094,
  [7310] = 7093,
  [7311] = 7149,
  [7312] = 7128,
  [7313] = 7146,
  [7314] = 7086,
  [7315] = 7102,
  [7316] = 7085,
  [7317] = 7099,
  [7318] = 7093,
  [7319] = 7319,
  [7320] = 7128,
  [7321] = 7086,
  [7322] = 7084,
  [7323] = 7146,
  [7324] = 7085,
  [7325] = 7146,
  [7326] = 7149,
  [7327] = 7108,
  [7328] = 7328,
  [7329] = 7146,
  [7330] = 7128,
  [7331] = 7135,
  [7332] = 7133,
  [7333] = 7085,
  [7334] = 7086,
  [7335] = 7093,
  [7336] = 7099,
  [7337] = 7086,
  [7338] = 7085,
  [7339] = 7108,
  [7340] = 7102,
  [7341] = 7341,
  [7342] = 7096,
  [7343] = 7084,
  [7344] = 7090,
  [7345] = 7108,
  [7346] = 7346,
  [7347] = 7094,
  [7348] = 7094,
  [7349] = 7133,
  [7350] = 7112,
  [7351] = 7104,
  [7352] = 7133,
  [7353] = 7106,
  [7354] = 7108,
  [7355] = 7135,
  [7356] = 7118,
  [7357] = 7133,
  [7358] = 7094,
  [7359] = 7104,
  [7360] = 7085,
  [7361] = 7090,
  [7362] = 7362,
  [7363] = 7363,
  [7364] = 7109,
  [7365] = 7096,
  [7366] = 7109,
  [7367] = 7367,
  [7368] = 7368,
  [7369] = 7094,
  [7370] = 7370,
  [7371] = 7371,
  [7372] = 7372,
  [7373] = 7373,
  [7374] = 7374,
  [7375] = 7375,
  [7376] = 7376,
  [7377] = 7377,
  [7378] = 7378,
  [7379] = 7379,
  [7380] = 7380,
  [7381] = 7381,
  [7382] = 7382,
  [7383] = 7383,
  [7384] = 7384,
  [7385] = 7385,
  [7386] = 7386,
  [7387] = 7387,
  [7388] = 7388,
  [7389] = 7377,
  [7390] = 7390,
  [7391] = 7391,
  [7392] = 7388,
  [7393] = 7393,
  [7394] = 7394,
  [7395] = 7383,
  [7396] = 7396,
  [7397] = 7397,
  [7398] = 7398,
  [7399] = 7399,
  [7400] = 7400,
  [7401] = 7384,
  [7402] = 7402,
  [7403] = 7403,
  [7404] = 7404,
  [7405] = 7405,
  [7406] = 7406,
  [7407] = 7407,
  [7408] = 7408,
  [7409] = 7409,
  [7410] = 7410,
  [7411] = 7411,
  [7412] = 7412,
  [7413] = 7413,
  [7414] = 7414,
  [7415] = 7415,
  [7416] = 7416,
  [7417] = 7417,
  [7418] = 7418,
  [7419] = 7419,
  [7420] = 7420,
  [7421] = 7421,
  [7422] = 7413,
  [7423] = 7388,
  [7424] = 7411,
  [7425] = 7425,
  [7426] = 7380,
  [7427] = 7416,
  [7428] = 139,
  [7429] = 7429,
  [7430] = 7430,
  [7431] = 7394,
  [7432] = 7372,
  [7433] = 7373,
  [7434] = 7394,
  [7435] = 7417,
  [7436] = 7390,
  [7437] = 7397,
  [7438] = 7372,
  [7439] = 7439,
  [7440] = 7373,
  [7441] = 7405,
  [7442] = 7406,
  [7443] = 7407,
  [7444] = 7409,
  [7445] = 7410,
  [7446] = 7375,
  [7447] = 7447,
  [7448] = 7448,
  [7449] = 7377,
  [7450] = 7394,
  [7451] = 7372,
  [7452] = 7373,
  [7453] = 7376,
  [7454] = 7375,
  [7455] = 7376,
  [7456] = 7391,
  [7457] = 7457,
  [7458] = 7379,
  [7459] = 7379,
  [7460] = 7380,
  [7461] = 7375,
  [7462] = 7376,
  [7463] = 7384,
  [7464] = 6880,
  [7465] = 7465,
  [7466] = 7410,
  [7467] = 7411,
  [7468] = 7409,
  [7469] = 7407,
  [7470] = 7406,
  [7471] = 7405,
  [7472] = 7394,
  [7473] = 7413,
  [7474] = 7474,
  [7475] = 7417,
  [7476] = 7476,
  [7477] = 7414,
  [7478] = 7402,
  [7479] = 7476,
  [7480] = 7480,
  [7481] = 7412,
  [7482] = 7482,
  [7483] = 7379,
  [7484] = 7484,
  [7485] = 7408,
  [7486] = 7397,
  [7487] = 7476,
  [7488] = 7380,
  [7489] = 7408,
  [7490] = 7419,
  [7491] = 7377,
  [7492] = 7390,
  [7493] = 7493,
  [7494] = 7391,
  [7495] = 7391,
  [7496] = 7400,
  [7497] = 7398,
  [7498] = 7498,
  [7499] = 7499,
  [7500] = 7411,
  [7501] = 7501,
  [7502] = 7415,
  [7503] = 7413,
  [7504] = 7416,
  [7505] = 7408,
  [7506] = 7506,
  [7507] = 7419,
  [7508] = 7417,
  [7509] = 7509,
  [7510] = 7510,
  [7511] = 7380,
  [7512] = 7512,
  [7513] = 7513,
  [7514] = 7370,
  [7515] = 7515,
  [7516] = 7399,
  [7517] = 7384,
  [7518] = 7379,
  [7519] = 7398,
  [7520] = 7476,
  [7521] = 7411,
  [7522] = 7410,
  [7523] = 7414,
  [7524] = 7409,
  [7525] = 7407,
  [7526] = 7526,
  [7527] = 7399,
  [7528] = 7406,
  [7529] = 2572,
  [7530] = 7414,
  [7531] = 7531,
  [7532] = 7532,
  [7533] = 7532,
  [7534] = 7407,
  [7535] = 7409,
  [7536] = 7410,
  [7537] = 7379,
  [7538] = 7538,
  [7539] = 7539,
  [7540] = 7412,
  [7541] = 7541,
  [7542] = 7506,
  [7543] = 7412,
  [7544] = 7408,
  [7545] = 7386,
  [7546] = 7399,
  [7547] = 7412,
  [7548] = 7402,
  [7549] = 7408,
  [7550] = 7414,
  [7551] = 7376,
  [7552] = 7552,
  [7553] = 7399,
  [7554] = 7506,
  [7555] = 7375,
  [7556] = 7476,
  [7557] = 7372,
  [7558] = 7558,
  [7559] = 7559,
  [7560] = 7397,
  [7561] = 7410,
  [7562] = 7409,
  [7563] = 7563,
  [7564] = 7564,
  [7565] = 7532,
  [7566] = 7407,
  [7567] = 7493,
  [7568] = 7406,
  [7569] = 7373,
  [7570] = 7570,
  [7571] = 7405,
  [7572] = 7390,
  [7573] = 7399,
  [7574] = 7574,
  [7575] = 7405,
  [7576] = 7576,
  [7577] = 7408,
  [7578] = 7578,
  [7579] = 7399,
  [7580] = 7408,
  [7581] = 7413,
  [7582] = 7582,
  [7583] = 7411,
  [7584] = 7584,
  [7585] = 7585,
  [7586] = 7398,
  [7587] = 7414,
  [7588] = 7391,
  [7589] = 7589,
  [7590] = 7390,
  [7591] = 7411,
  [7592] = 7592,
  [7593] = 7417,
  [7594] = 7377,
  [7595] = 7397,
  [7596] = 7596,
  [7597] = 7383,
  [7598] = 7559,
  [7599] = 7386,
  [7600] = 7600,
  [7601] = 7601,
  [7602] = 7407,
  [7603] = 7409,
  [7604] = 7410,
  [7605] = 7605,
  [7606] = 7606,
  [7607] = 7607,
  [7608] = 7397,
  [7609] = 7402,
  [7610] = 7610,
  [7611] = 7402,
  [7612] = 7506,
  [7613] = 7613,
  [7614] = 7614,
  [7615] = 7386,
  [7616] = 7380,
  [7617] = 7532,
  [7618] = 7405,
  [7619] = 7613,
  [7620] = 7406,
  [7621] = 7621,
  [7622] = 7613,
  [7623] = 7407,
  [7624] = 7409,
  [7625] = 140,
  [7626] = 7404,
  [7627] = 7410,
  [7628] = 7628,
  [7629] = 7383,
  [7630] = 7380,
  [7631] = 7379,
  [7632] = 7398,
  [7633] = 7506,
  [7634] = 7379,
  [7635] = 7506,
  [7636] = 7636,
  [7637] = 7417,
  [7638] = 7408,
  [7639] = 7416,
  [7640] = 7388,
  [7641] = 7376,
  [7642] = 7408,
  [7643] = 7376,
  [7644] = 7506,
  [7645] = 7375,
  [7646] = 7375,
  [7647] = 7408,
  [7648] = 7394,
  [7649] = 7649,
  [7650] = 7411,
  [7651] = 7651,
  [7652] = 7652,
  [7653] = 7373,
  [7654] = 7372,
  [7655] = 7373,
  [7656] = 7376,
  [7657] = 7372,
  [7658] = 7407,
  [7659] = 7409,
  [7660] = 7410,
  [7661] = 7373,
  [7662] = 7377,
  [7663] = 7390,
  [7664] = 7386,
  [7665] = 7391,
  [7666] = 7375,
  [7667] = 7412,
  [7668] = 7394,
  [7669] = 7411,
  [7670] = 7376,
  [7671] = 7373,
  [7672] = 7416,
  [7673] = 7417,
  [7674] = 7414,
  [7675] = 7370,
  [7676] = 7405,
  [7677] = 7372,
  [7678] = 7408,
  [7679] = 7679,
  [7680] = 7379,
  [7681] = 7413,
  [7682] = 7411,
  [7683] = 7407,
  [7684] = 7409,
  [7685] = 7410,
  [7686] = 7476,
  [7687] = 7380,
  [7688] = 7386,
  [7689] = 7410,
  [7690] = 7372,
  [7691] = 7532,
  [7692] = 7412,
  [7693] = 7409,
  [7694] = 7694,
  [7695] = 7407,
  [7696] = 7406,
  [7697] = 7405,
  [7698] = 7698,
  [7699] = 7394,
  [7700] = 7402,
  [7701] = 7408,
  [7702] = 7408,
  [7703] = 7411,
  [7704] = 7413,
  [7705] = 7411,
  [7706] = 7407,
  [7707] = 7409,
  [7708] = 7410,
  [7709] = 7413,
  [7710] = 7384,
  [7711] = 7399,
  [7712] = 7411,
  [7713] = 7397,
  [7714] = 7415,
  [7715] = 7375,
  [7716] = 7397,
  [7717] = 7416,
  [7718] = 7406,
  [7719] = 7394,
  [7720] = 7398,
  [7721] = 7419,
  [7722] = 7722,
  [7723] = 7408,
  [7724] = 7402,
  [7725] = 7725,
  [7726] = 7407,
  [7727] = 7411,
  [7728] = 7407,
  [7729] = 7409,
  [7730] = 7410,
  [7731] = 7391,
  [7732] = 7390,
  [7733] = 7532,
  [7734] = 7734,
  [7735] = 7377,
  [7736] = 7409,
  [7737] = 7400,
  [7738] = 7388,
  [7739] = 7383,
  [7740] = 7740,
  [7741] = 7741,
  [7742] = 7417,
  [7743] = 7383,
  [7744] = 7408,
  [7745] = 7745,
  [7746] = 7377,
  [7747] = 7390,
  [7748] = 7411,
  [7749] = 7407,
  [7750] = 7409,
  [7751] = 7410,
  [7752] = 7386,
  [7753] = 7476,
  [7754] = 7391,
  [7755] = 7410,
  [7756] = 7493,
  [7757] = 7757,
  [7758] = 7383,
  [7759] = 7370,
  [7760] = 7411,
  [7761] = 7414,
  [7762] = 7539,
  [7763] = 7413,
  [7764] = 7613,
  [7765] = 7408,
  [7766] = 7532,
  [7767] = 7493,
  [7768] = 7411,
  [7769] = 7407,
  [7770] = 7409,
  [7771] = 7410,
  [7772] = 7412,
  [7773] = 7773,
  [7774] = 7398,
  [7775] = 7416,
  [7776] = 7384,
  [7777] = 7399,
  [7778] = 7585,
  [7779] = 7397,
  [7780] = 7410,
  [7781] = 7398,
  [7782] = 7398,
  [7783] = 7476,
  [7784] = 7559,
  [7785] = 7408,
  [7786] = 7409,
  [7787] = 7398,
  [7788] = 7411,
  [7789] = 7407,
  [7790] = 7409,
  [7791] = 7410,
  [7792] = 7407,
  [7793] = 7398,
  [7794] = 7406,
  [7795] = 7398,
  [7796] = 7414,
  [7797] = 7405,
  [7798] = 7415,
  [7799] = 7412,
  [7800] = 7398,
  [7801] = 7801,
  [7802] = 7559,
  [7803] = 7532,
  [7804] = 7408,
  [7805] = 7408,
  [7806] = 7419,
  [7807] = 7408,
  [7808] = 7411,
  [7809] = 7407,
  [7810] = 7409,
  [7811] = 7410,
  [7812] = 7402,
  [7813] = 7506,
  [7814] = 7408,
  [7815] = 7398,
  [7816] = 7816,
  [7817] = 7817,
  [7818] = 7818,
  [7819] = 7819,
  [7820] = 7820,
  [7821] = 7821,
  [7822] = 7822,
  [7823] = 7823,
  [7824] = 7824,
  [7825] = 7825,
  [7826] = 7826,
  [7827] = 7827,
  [7828] = 7828,
  [7829] = 7826,
  [7830] = 7830,
  [7831] = 7831,
  [7832] = 7832,
  [7833] = 7818,
  [7834] = 7834,
  [7835] = 7818,
  [7836] = 7818,
  [7837] = 7837,
  [7838] = 7818,
  [7839] = 7824,
  [7840] = 7823,
  [7841] = 7841,
  [7842] = 7842,
  [7843] = 7824,
  [7844] = 7844,
  [7845] = 7845,
  [7846] = 7846,
  [7847] = 7847,
  [7848] = 7848,
  [7849] = 7816,
  [7850] = 7850,
  [7851] = 7851,
  [7852] = 7852,
  [7853] = 7841,
  [7854] = 7837,
  [7855] = 7855,
  [7856] = 7831,
  [7857] = 7857,
  [7858] = 7828,
  [7859] = 7851,
  [7860] = 7822,
  [7861] = 7861,
  [7862] = 7827,
  [7863] = 7831,
  [7864] = 7864,
  [7865] = 7844,
  [7866] = 7826,
  [7867] = 7867,
  [7868] = 7868,
  [7869] = 7822,
  [7870] = 7870,
  [7871] = 7831,
  [7872] = 7872,
  [7873] = 7873,
  [7874] = 7818,
  [7875] = 7818,
  [7876] = 7868,
  [7877] = 7826,
  [7878] = 7861,
  [7879] = 7834,
  [7880] = 7841,
  [7881] = 7852,
  [7882] = 7882,
  [7883] = 7824,
  [7884] = 7884,
  [7885] = 7872,
  [7886] = 7848,
  [7887] = 7887,
  [7888] = 7888,
  [7889] = 7847,
  [7890] = 7857,
  [7891] = 7821,
  [7892] = 7850,
  [7893] = 7888,
  [7894] = 7821,
  [7895] = 7855,
  [7896] = 7826,
  [7897] = 7887,
  [7898] = 7825,
  [7899] = 7828,
  [7900] = 7900,
  [7901] = 7901,
  [7902] = 7850,
  [7903] = 7903,
  [7904] = 7847,
  [7905] = 7905,
  [7906] = 7816,
  [7907] = 7907,
  [7908] = 7844,
  [7909] = 7864,
  [7910] = 7826,
  [7911] = 7911,
  [7912] = 7820,
  [7913] = 7842,
  [7914] = 7831,
  [7915] = 7830,
  [7916] = 7826,
  [7917] = 7827,
  [7918] = 7918,
  [7919] = 7825,
  [7920] = 7832,
  [7921] = 7887,
  [7922] = 7821,
  [7923] = 7820,
  [7924] = 7850,
  [7925] = 7847,
  [7926] = 7818,
  [7927] = 7844,
  [7928] = 7826,
  [7929] = 7817,
  [7930] = 7819,
  [7931] = 7841,
  [7932] = 7820,
  [7933] = 7824,
  [7934] = 7816,
  [7935] = 7830,
  [7936] = 7821,
  [7937] = 7819,
  [7938] = 7938,
  [7939] = 7831,
  [7940] = 7825,
  [7941] = 7826,
  [7942] = 7842,
  [7943] = 7825,
  [7944] = 7944,
  [7945] = 7819,
  [7946] = 7830,
  [7947] = 7828,
  [7948] = 7948,
  [7949] = 7888,
  [7950] = 7828,
  [7951] = 7820,
  [7952] = 7821,
  [7953] = 7821,
  [7954] = 7847,
  [7955] = 7834,
  [7956] = 7855,
  [7957] = 7817,
  [7958] = 7958,
  [7959] = 7828,
  [7960] = 7944,
  [7961] = 7850,
  [7962] = 7852,
  [7963] = 7823,
  [7964] = 7825,
  [7965] = 7855,
  [7966] = 7884,
  [7967] = 7852,
  [7968] = 7944,
  [7969] = 7842,
  [7970] = 7861,
  [7971] = 7821,
  [7972] = 7818,
  [7973] = 7872,
  [7974] = 7834,
  [7975] = 7857,
  [7976] = 7888,
  [7977] = 7977,
  [7978] = 7884,
  [7979] = 7979,
  [7980] = 7868,
  [7981] = 7831,
  [7982] = 7825,
  [7983] = 7841,
  [7984] = 7825,
  [7985] = 7850,
  [7986] = 7986,
  [7987] = 7846,
  [7988] = 7824,
  [7989] = 7847,
  [7990] = 7884,
  [7991] = 7991,
  [7992] = 7868,
  [7993] = 7872,
  [7994] = 7831,
  [7995] = 7819,
  [7996] = 7830,
  [7997] = 7830,
  [7998] = 7888,
  [7999] = 7830,
  [8000] = 8000,
  [8001] = 7844,
  [8002] = 7855,
  [8003] = 8003,
  [8004] = 7826,
  [8005] = 7868,
  [8006] = 7850,
  [8007] = 7820,
  [8008] = 7847,
  [8009] = 7831,
  [8010] = 7830,
  [8011] = 7830,
  [8012] = 8012,
  [8013] = 8013,
  [8014] = 7852,
  [8015] = 7868,
  [8016] = 7844,
  [8017] = 7831,
  [8018] = 8018,
  [8019] = 7817,
  [8020] = 7820,
  [8021] = 7827,
  [8022] = 7823,
  [8023] = 7828,
  [8024] = 7826,
  [8025] = 7817,
  [8026] = 7944,
  [8027] = 2701,
  [8028] = 2706,
  [8029] = 2708,
  [8030] = 7850,
  [8031] = 2717,
  [8032] = 7817,
  [8033] = 2719,
  [8034] = 7847,
  [8035] = 7826,
  [8036] = 2722,
  [8037] = 7827,
  [8038] = 2723,
  [8039] = 7826,
  [8040] = 7830,
  [8041] = 7821,
  [8042] = 7817,
  [8043] = 7819,
  [8044] = 7884,
  [8045] = 7827,
  [8046] = 7841,
  [8047] = 7816,
  [8048] = 7820,
  [8049] = 8049,
  [8050] = 2737,
  [8051] = 7818,
  [8052] = 7872,
  [8053] = 2736,
  [8054] = 7857,
  [8055] = 7861,
  [8056] = 7837,
  [8057] = 7864,
  [8058] = 7818,
  [8059] = 7855,
  [8060] = 7825,
  [8061] = 7825,
  [8062] = 7831,
  [8063] = 7830,
  [8064] = 8064,
  [8065] = 7826,
  [8066] = 7841,
  [8067] = 8067,
  [8068] = 7844,
  [8069] = 7848,
  [8070] = 7846,
  [8071] = 7816,
  [8072] = 7850,
  [8073] = 7824,
  [8074] = 7847,
  [8075] = 7837,
  [8076] = 2653,
  [8077] = 7861,
  [8078] = 7826,
  [8079] = 7831,
  [8080] = 7831,
  [8081] = 7844,
  [8082] = 7847,
  [8083] = 7820,
  [8084] = 7850,
  [8085] = 7857,
  [8086] = 7820,
  [8087] = 7832,
  [8088] = 7817,
  [8089] = 7864,
  [8090] = 7830,
  [8091] = 8091,
  [8092] = 7827,
  [8093] = 7826,
  [8094] = 7834,
  [8095] = 7831,
  [8096] = 7844,
  [8097] = 7868,
  [8098] = 8018,
  [8099] = 7830,
  [8100] = 7868,
  [8101] = 7831,
  [8102] = 7847,
  [8103] = 7844,
  [8104] = 7847,
  [8105] = 7888,
  [8106] = 8106,
  [8107] = 7850,
  [8108] = 8108,
  [8109] = 8109,
  [8110] = 7821,
  [8111] = 7850,
  [8112] = 7855,
  [8113] = 7857,
  [8114] = 7825,
  [8115] = 7825,
  [8116] = 7831,
  [8117] = 7848,
  [8118] = 7816,
  [8119] = 7844,
  [8120] = 8120,
  [8121] = 7848,
  [8122] = 7826,
  [8123] = 7828,
  [8124] = 7822,
  [8125] = 7846,
  [8126] = 7847,
  [8127] = 7944,
  [8128] = 8128,
  [8129] = 8129,
  [8130] = 8130,
  [8131] = 7824,
  [8132] = 8018,
  [8133] = 7819,
  [8134] = 8018,
  [8135] = 7825,
  [8136] = 7821,
  [8137] = 7887,
  [8138] = 7850,
  [8139] = 8018,
  [8140] = 7832,
  [8141] = 8018,
  [8142] = 8018,
  [8143] = 8018,
  [8144] = 7850,
  [8145] = 7847,
  [8146] = 8018,
  [8147] = 7844,
  [8148] = 7832,
  [8149] = 8149,
  [8150] = 7816,
  [8151] = 8018,
  [8152] = 8018,
  [8153] = 7826,
  [8154] = 7817,
  [8155] = 8018,
  [8156] = 7820,
  [8157] = 7825,
  [8158] = 7821,
  [8159] = 8018,
  [8160] = 7834,
  [8161] = 7824,
  [8162] = 7830,
  [8163] = 7846,
  [8164] = 8018,
  [8165] = 7848,
  [8166] = 8018,
  [8167] = 8018,
  [8168] = 7841,
  [8169] = 7852,
  [8170] = 8170,
  [8171] = 8171,
  [8172] = 8018,
  [8173] = 7831,
  [8174] = 8174,
  [8175] = 7852,
  [8176] = 7857,
  [8177] = 7818,
  [8178] = 7861,
  [8179] = 7872,
  [8180] = 8018,
  [8181] = 8181,
  [8182] = 7822,
  [8183] = 8018,
  [8184] = 8184,
  [8185] = 8018,
  [8186] = 7887,
  [8187] = 8018,
  [8188] = 7831,
  [8189] = 8189,
  [8190] = 7822,
  [8191] = 7887,
  [8192] = 8192,
  [8193] = 8193,
  [8194] = 8194,
  [8195] = 5967,
  [8196] = 8196,
  [8197] = 8197,
  [8198] = 8198,
  [8199] = 8199,
  [8200] = 8194,
  [8201] = 8201,
  [8202] = 8202,
  [8203] = 8203,
  [8204] = 8204,
  [8205] = 8205,
  [8206] = 8206,
  [8207] = 8207,
  [8208] = 8208,
  [8209] = 8209,
  [8210] = 8210,
  [8211] = 8211,
  [8212] = 8212,
  [8213] = 5965,
  [8214] = 8214,
  [8215] = 8215,
  [8216] = 8216,
  [8217] = 8217,
  [8218] = 8218,
  [8219] = 8199,
  [8220] = 8193,
  [8221] = 8221,
  [8222] = 8222,
  [8223] = 7051,
  [8224] = 8224,
  [8225] = 8221,
  [8226] = 8226,
  [8227] = 8227,
  [8228] = 8228,
  [8229] = 8229,
  [8230] = 8230,
  [8231] = 8231,
  [8232] = 8232,
  [8233] = 8233,
  [8234] = 8234,
  [8235] = 8235,
  [8236] = 8236,
  [8237] = 8237,
  [8238] = 8238,
  [8239] = 8239,
  [8240] = 8240,
  [8241] = 8193,
  [8242] = 8242,
  [8243] = 8243,
  [8244] = 8232,
  [8245] = 8245,
  [8246] = 8246,
  [8247] = 8197,
  [8248] = 8248,
  [8249] = 8249,
  [8250] = 8250,
  [8251] = 8251,
  [8252] = 8252,
  [8253] = 8253,
  [8254] = 8254,
  [8255] = 8255,
  [8256] = 8256,
  [8257] = 8257,
  [8258] = 8258,
  [8259] = 8259,
  [8260] = 8260,
  [8261] = 8261,
  [8262] = 8262,
  [8263] = 8263,
  [8264] = 8264,
  [8265] = 8265,
  [8266] = 8266,
  [8267] = 8267,
  [8268] = 8268,
  [8269] = 8269,
  [8270] = 8270,
  [8271] = 8271,
  [8272] = 8272,
  [8273] = 8273,
  [8274] = 8274,
  [8275] = 8275,
  [8276] = 8276,
  [8277] = 8277,
  [8278] = 8278,
  [8279] = 8211,
  [8280] = 8280,
  [8281] = 8256,
  [8282] = 8282,
  [8283] = 8283,
  [8284] = 8259,
  [8285] = 8285,
  [8286] = 8286,
  [8287] = 8274,
  [8288] = 8288,
  [8289] = 8289,
  [8290] = 8290,
  [8291] = 8291,
  [8292] = 8240,
  [8293] = 8293,
  [8294] = 8206,
  [8295] = 8207,
  [8296] = 8217,
  [8297] = 8216,
  [8298] = 8298,
  [8299] = 8282,
  [8300] = 8300,
  [8301] = 8301,
  [8302] = 8302,
  [8303] = 8259,
  [8304] = 8202,
  [8305] = 8305,
  [8306] = 8306,
  [8307] = 8261,
  [8308] = 8283,
  [8309] = 8234,
  [8310] = 8310,
  [8311] = 8212,
  [8312] = 8289,
  [8313] = 8313,
  [8314] = 8314,
  [8315] = 8315,
  [8316] = 8316,
  [8317] = 8317,
  [8318] = 8318,
  [8319] = 8262,
  [8320] = 8320,
  [8321] = 8316,
  [8322] = 8322,
  [8323] = 8298,
  [8324] = 8310,
  [8325] = 8325,
  [8326] = 8326,
  [8327] = 8327,
  [8328] = 8328,
  [8329] = 8329,
  [8330] = 8256,
  [8331] = 8278,
  [8332] = 8208,
  [8333] = 8215,
  [8334] = 8334,
  [8335] = 8335,
  [8336] = 8336,
  [8337] = 8271,
  [8338] = 8259,
  [8339] = 8272,
  [8340] = 8217,
  [8341] = 8229,
  [8342] = 8230,
  [8343] = 8231,
  [8344] = 8272,
  [8345] = 8228,
  [8346] = 8224,
  [8347] = 8262,
  [8348] = 8298,
  [8349] = 8261,
  [8350] = 8239,
  [8351] = 8198,
  [8352] = 8352,
  [8353] = 8353,
  [8354] = 8289,
  [8355] = 8196,
  [8356] = 8232,
  [8357] = 8243,
  [8358] = 8268,
  [8359] = 8283,
  [8360] = 8282,
  [8361] = 8217,
  [8362] = 8258,
  [8363] = 8266,
  [8364] = 8364,
  [8365] = 8274,
  [8366] = 8266,
  [8367] = 8367,
  [8368] = 8268,
  [8369] = 8226,
  [8370] = 8236,
  [8371] = 8371,
  [8372] = 8372,
  [8373] = 8322,
  [8374] = 8320,
  [8375] = 8249,
  [8376] = 8206,
  [8377] = 8265,
  [8378] = 8378,
  [8379] = 8227,
  [8380] = 8258,
  [8381] = 8202,
  [8382] = 8258,
  [8383] = 8383,
  [8384] = 8384,
  [8385] = 8226,
  [8386] = 8386,
  [8387] = 8212,
  [8388] = 8388,
  [8389] = 8316,
  [8390] = 8210,
  [8391] = 8209,
  [8392] = 8205,
  [8393] = 8393,
  [8394] = 8194,
  [8395] = 8310,
  [8396] = 8396,
  [8397] = 8229,
  [8398] = 8197,
  [8399] = 8399,
  [8400] = 8197,
  [8401] = 8230,
  [8402] = 8215,
  [8403] = 8403,
  [8404] = 8231,
  [8405] = 8197,
  [8406] = 8298,
  [8407] = 8232,
  [8408] = 8222,
  [8409] = 8203,
  [8410] = 8231,
  [8411] = 8243,
  [8412] = 8199,
  [8413] = 8266,
  [8414] = 8414,
  [8415] = 8268,
  [8416] = 8239,
  [8417] = 8384,
  [8418] = 8418,
  [8419] = 8419,
  [8420] = 8239,
  [8421] = 8204,
  [8422] = 8422,
  [8423] = 8203,
  [8424] = 8232,
  [8425] = 8231,
  [8426] = 8258,
  [8427] = 8230,
  [8428] = 8240,
  [8429] = 8266,
  [8430] = 8229,
  [8431] = 8268,
  [8432] = 8196,
  [8433] = 8206,
  [8434] = 8221,
  [8435] = 8322,
  [8436] = 8320,
  [8437] = 8314,
  [8438] = 8216,
  [8439] = 8234,
  [8440] = 8212,
  [8441] = 8194,
  [8442] = 8442,
  [8443] = 8228,
  [8444] = 8208,
  [8445] = 8224,
  [8446] = 8446,
  [8447] = 8447,
  [8448] = 8448,
  [8449] = 8222,
  [8450] = 8222,
  [8451] = 8451,
  [8452] = 8256,
  [8453] = 8222,
  [8454] = 8215,
  [8455] = 8224,
  [8456] = 8228,
  [8457] = 8234,
  [8458] = 8215,
  [8459] = 8240,
  [8460] = 8231,
  [8461] = 8256,
  [8462] = 8256,
  [8463] = 8463,
  [8464] = 8464,
  [8465] = 8465,
  [8466] = 8239,
  [8467] = 8263,
  [8468] = 8271,
  [8469] = 8469,
  [8470] = 8204,
  [8471] = 8251,
  [8472] = 8211,
  [8473] = 8473,
  [8474] = 8214,
  [8475] = 8258,
  [8476] = 8254,
  [8477] = 8477,
  [8478] = 8266,
  [8479] = 8217,
  [8480] = 8268,
  [8481] = 8313,
  [8482] = 8206,
  [8483] = 8265,
  [8484] = 8249,
  [8485] = 8485,
  [8486] = 8486,
  [8487] = 5928,
  [8488] = 8214,
  [8489] = 8306,
  [8490] = 8316,
  [8491] = 8278,
  [8492] = 8274,
  [8493] = 8217,
  [8494] = 8282,
  [8495] = 8495,
  [8496] = 8283,
  [8497] = 8259,
  [8498] = 8215,
  [8499] = 8293,
  [8500] = 8273,
  [8501] = 8289,
  [8502] = 8231,
  [8503] = 8208,
  [8504] = 8289,
  [8505] = 8505,
  [8506] = 8506,
  [8507] = 8283,
  [8508] = 8239,
  [8509] = 8282,
  [8510] = 8216,
  [8511] = 8212,
  [8512] = 8314,
  [8513] = 8317,
  [8514] = 8293,
  [8515] = 8515,
  [8516] = 8258,
  [8517] = 8217,
  [8518] = 8282,
  [8519] = 8266,
  [8520] = 8202,
  [8521] = 8268,
  [8522] = 8217,
  [8523] = 8283,
  [8524] = 8289,
  [8525] = 8313,
  [8526] = 8526,
  [8527] = 8298,
  [8528] = 8528,
  [8529] = 8529,
  [8530] = 8530,
  [8531] = 8215,
  [8532] = 8532,
  [8533] = 8273,
  [8534] = 8231,
  [8535] = 8207,
  [8536] = 8206,
  [8537] = 8196,
  [8538] = 8239,
  [8539] = 8198,
  [8540] = 8258,
  [8541] = 8316,
  [8542] = 8310,
  [8543] = 8268,
  [8544] = 8203,
  [8545] = 8228,
  [8546] = 8208,
  [8547] = 8547,
  [8548] = 8228,
  [8549] = 8204,
  [8550] = 8208,
  [8551] = 8215,
  [8552] = 8228,
  [8553] = 8208,
  [8554] = 8278,
  [8555] = 8555,
  [8556] = 8239,
  [8557] = 8271,
  [8558] = 8558,
  [8559] = 8268,
  [8560] = 8208,
  [8561] = 8216,
  [8562] = 8562,
  [8563] = 8215,
  [8564] = 8239,
  [8565] = 8298,
  [8566] = 8268,
  [8567] = 8314,
  [8568] = 8317,
  [8569] = 8274,
  [8570] = 8215,
  [8571] = 8239,
  [8572] = 8268,
  [8573] = 8573,
  [8574] = 8228,
  [8575] = 8575,
  [8576] = 8215,
  [8577] = 8239,
  [8578] = 8268,
  [8579] = 8208,
  [8580] = 8239,
  [8581] = 8268,
  [8582] = 8261,
  [8583] = 8239,
  [8584] = 8268,
  [8585] = 8239,
  [8586] = 8268,
  [8587] = 8239,
  [8588] = 8268,
  [8589] = 8239,
  [8590] = 8268,
  [8591] = 8239,
  [8592] = 8268,
  [8593] = 8239,
  [8594] = 8268,
  [8595] = 8239,
  [8596] = 8268,
  [8597] = 8239,
  [8598] = 8268,
  [8599] = 8388,
  [8600] = 8193,
  [8601] = 8601,
  [8602] = 8602,
  [8603] = 8243,
  [8604] = 8604,
  [8605] = 8605,
  [8606] = 8606,
  [8607] = 8245,
  [8608] = 8608,
  [8609] = 8609,
  [8610] = 8199,
  [8611] = 8611,
  [8612] = 8232,
  [8613] = 8271,
  [8614] = 8614,
  [8615] = 8228,
  [8616] = 8217,
  [8617] = 8208,
  [8618] = 8197,
  [8619] = 8243,
  [8620] = 8272,
  [8621] = 8310,
  [8622] = 8622,
  [8623] = 8236,
  [8624] = 8477,
  [8625] = 8625,
  [8626] = 8234,
  [8627] = 8422,
  [8628] = 8628,
  [8629] = 8446,
  [8630] = 8262,
  [8631] = 8261,
  [8632] = 8227,
  [8633] = 8228,
  [8634] = 8622,
  [8635] = 8635,
  [8636] = 8193,
  [8637] = 8194,
  [8638] = 8208,
  [8639] = 8211,
  [8640] = 8210,
  [8641] = 8371,
  [8642] = 8205,
  [8643] = 8353,
  [8644] = 8209,
  [8645] = 8352,
  [8646] = 8210,
  [8647] = 8209,
  [8648] = 8205,
  [8649] = 8372,
  [8650] = 8448,
  [8651] = 8651,
  [8652] = 8194,
  [8653] = 8274,
  [8654] = 8197,
  [8655] = 8197,
  [8656] = 8228,
  [8657] = 8255,
  [8658] = 8208,
  [8659] = 8199,
  [8660] = 8227,
  [8661] = 8205,
  [8662] = 8236,
  [8663] = 8322,
  [8664] = 8320,
  [8665] = 8291,
  [8666] = 8666,
  [8667] = 8228,
  [8668] = 8314,
  [8669] = 8232,
  [8670] = 8334,
  [8671] = 8209,
  [8672] = 8208,
  [8673] = 8210,
  [8674] = 8204,
  [8675] = 8196,
  [8676] = 8229,
  [8677] = 8230,
  [8678] = 8678,
  [8679] = 8679,
  [8680] = 8680,
  [8681] = 8681,
  [8682] = 8232,
  [8683] = 8193,
  [8684] = 8316,
  [8685] = 8228,
  [8686] = 8243,
  [8687] = 8261,
  [8688] = 8262,
  [8689] = 8208,
  [8690] = 8314,
  [8691] = 8691,
  [8692] = 8216,
  [8693] = 8693,
  [8694] = 8208,
  [8695] = 8695,
  [8696] = 8196,
  [8697] = 8236,
  [8698] = 8236,
  [8699] = 8699,
  [8700] = 8700,
  [8701] = 8271,
  [8702] = 8702,
  [8703] = 8227,
  [8704] = 8310,
  [8705] = 8705,
  [8706] = 8706,
  [8707] = 8505,
  [8708] = 8228,
  [8709] = 8256,
  [8710] = 8208,
  [8711] = 8278,
  [8712] = 8204,
  [8713] = 8224,
  [8714] = 8228,
  [8715] = 8194,
  [8716] = 8716,
  [8717] = 8211,
  [8718] = 8236,
  [8719] = 8222,
  [8720] = 8193,
  [8721] = 8210,
  [8722] = 8209,
  [8723] = 8271,
  [8724] = 8205,
  [8725] = 8224,
  [8726] = 8228,
  [8727] = 8727,
  [8728] = 8728,
  [8729] = 8228,
  [8730] = 8240,
  [8731] = 8283,
  [8732] = 8198,
  [8733] = 8733,
  [8734] = 8393,
  [8735] = 8735,
  [8736] = 8197,
  [8737] = 8737,
  [8738] = 8738,
  [8739] = 8739,
  [8740] = 8310,
  [8741] = 8741,
  [8742] = 8742,
  [8743] = 8505,
  [8744] = 8744,
  [8745] = 8316,
  [8746] = 8203,
  [8747] = 8747,
  [8748] = 8635,
  [8749] = 8204,
  [8750] = 8750,
  [8751] = 8751,
  [8752] = 8320,
  [8753] = 8753,
  [8754] = 8322,
  [8755] = 8193,
  [8756] = 8756,
  [8757] = 8208,
  [8758] = 8204,
  [8759] = 8194,
  [8760] = 8336,
  [8761] = 8761,
  [8762] = 8199,
  [8763] = 8763,
  [8764] = 8236,
  [8765] = 8217,
  [8766] = 8245,
  [8767] = 8232,
  [8768] = 8282,
  [8769] = 8203,
  [8770] = 8259,
  [8771] = 8254,
  [8772] = 8272,
  [8773] = 8329,
  [8774] = 8232,
  [8775] = 8193,
  [8776] = 8327,
  [8777] = 8227,
  [8778] = 8318,
  [8779] = 8298,
  [8780] = 8313,
  [8781] = 8289,
  [8782] = 8271,
  [8783] = 8289,
  [8784] = 8282,
  [8785] = 8315,
  [8786] = 8217,
  [8787] = 8293,
  [8788] = 8788,
  [8789] = 8215,
  [8790] = 8211,
  [8791] = 8274,
  [8792] = 8254,
  [8793] = 8273,
  [8794] = 8232,
  [8795] = 8795,
  [8796] = 8212,
  [8797] = 8245,
  [8798] = 8798,
  [8799] = 8242,
  [8800] = 8199,
  [8801] = 8801,
  [8802] = 8802,
  [8803] = 8602,
  [8804] = 8278,
  [8805] = 8605,
  [8806] = 8606,
  [8807] = 8614,
  [8808] = 8289,
  [8809] = 8609,
  [8810] = 8239,
  [8811] = 8611,
  [8812] = 8283,
  [8813] = 8282,
  [8814] = 8447,
  [8815] = 8217,
  [8816] = 8816,
  [8817] = 8505,
  [8818] = 8818,
  [8819] = 8422,
  [8820] = 8820,
  [8821] = 8446,
  [8822] = 8822,
  [8823] = 8249,
  [8824] = 8265,
  [8825] = 8271,
  [8826] = 8622,
  [8827] = 8635,
  [8828] = 8828,
  [8829] = 8211,
  [8830] = 2147,
  [8831] = 8831,
  [8832] = 8448,
  [8833] = 8226,
  [8834] = 8204,
  [8835] = 8197,
  [8836] = 8203,
  [8837] = 8393,
  [8838] = 8291,
  [8839] = 8334,
  [8840] = 8271,
  [8841] = 8841,
  [8842] = 8602,
  [8843] = 8605,
  [8844] = 8609,
  [8845] = 8228,
  [8846] = 8611,
  [8847] = 8234,
  [8848] = 8278,
  [8849] = 8422,
  [8850] = 8611,
  [8851] = 8446,
  [8852] = 8208,
  [8853] = 8198,
  [8854] = 8854,
  [8855] = 8622,
  [8856] = 8635,
  [8857] = 8448,
  [8858] = 8196,
  [8859] = 8224,
  [8860] = 8204,
  [8861] = 8291,
  [8862] = 8334,
  [8863] = 8863,
  [8864] = 8602,
  [8865] = 8605,
  [8866] = 8609,
  [8867] = 8261,
  [8868] = 8611,
  [8869] = 8197,
  [8870] = 8451,
  [8871] = 8422,
  [8872] = 8446,
  [8873] = 8194,
  [8874] = 8874,
  [8875] = 8622,
  [8876] = 8635,
  [8877] = 8448,
  [8878] = 8878,
  [8879] = 8236,
  [8880] = 8232,
  [8881] = 8291,
  [8882] = 8334,
  [8883] = 8283,
  [8884] = 8602,
  [8885] = 8605,
  [8886] = 8609,
  [8887] = 8317,
  [8888] = 8611,
  [8889] = 8889,
  [8890] = 8890,
  [8891] = 8446,
  [8892] = 8314,
  [8893] = 8893,
  [8894] = 8622,
  [8895] = 8635,
  [8896] = 8448,
  [8897] = 8216,
  [8898] = 8208,
  [8899] = 8193,
  [8900] = 8291,
  [8901] = 8334,
  [8902] = 8232,
  [8903] = 8602,
  [8904] = 8609,
  [8905] = 8271,
  [8906] = 8611,
  [8907] = 8243,
  [8908] = 8908,
  [8909] = 8446,
  [8910] = 8234,
  [8911] = 8236,
  [8912] = 8622,
  [8913] = 8635,
  [8914] = 8448,
  [8915] = 8262,
  [8916] = 8214,
  [8917] = 8917,
  [8918] = 8291,
  [8919] = 8334,
  [8920] = 8920,
  [8921] = 8602,
  [8922] = 8609,
  [8923] = 5923,
  [8924] = 8611,
  [8925] = 8194,
  [8926] = 8446,
  [8927] = 8240,
  [8928] = 8635,
  [8929] = 8448,
  [8930] = 8197,
  [8931] = 8300,
  [8932] = 8291,
  [8933] = 8334,
  [8934] = 8301,
  [8935] = 8602,
  [8936] = 8261,
  [8937] = 8611,
  [8938] = 8234,
  [8939] = 8315,
  [8940] = 8635,
  [8941] = 8318,
  [8942] = 8291,
  [8943] = 8602,
  [8944] = 8611,
  [8945] = 8635,
  [8946] = 8291,
  [8947] = 8602,
  [8948] = 8611,
  [8949] = 8635,
  [8950] = 8291,
  [8951] = 8602,
  [8952] = 8611,
  [8953] = 8635,
  [8954] = 8291,
  [8955] = 8635,
  [8956] = 8291,
  [8957] = 8635,
  [8958] = 8291,
  [8959] = 8635,
  [8960] = 8291,
  [8961] = 8635,
  [8962] = 8291,
  [8963] = 8635,
  [8964] = 8291,
  [8965] = 8635,
  [8966] = 8291,
  [8967] = 8635,
  [8968] = 8291,
  [8969] = 8635,
  [8970] = 8291,
  [8971] = 8635,
  [8972] = 8291,
  [8973] = 8973,
  [8974] = 8974,
  [8975] = 8606,
  [8976] = 8820,
  [8977] = 8816,
  [8978] = 8289,
  [8979] = 8327,
  [8980] = 8329,
  [8981] = 8336,
  [8982] = 8283,
  [8983] = 8282,
  [8984] = 8228,
  [8985] = 8217,
  [8986] = 8193,
  [8987] = 8372,
  [8988] = 8798,
  [8989] = 8211,
  [8990] = 8204,
  [8991] = 8991,
  [8992] = 8992,
  [8993] = 8609,
  [8994] = 8202,
  [8995] = 8249,
  [8996] = 8265,
  [8997] = 8606,
  [8998] = 8196,
  [8999] = 8226,
  [9000] = 9000,
  [9001] = 8255,
  [9002] = 8301,
  [9003] = 8300,
  [9004] = 9004,
  [9005] = 9005,
  [9006] = 9006,
  [9007] = 8605,
  [9008] = 8240,
  [9009] = 8352,
  [9010] = 8353,
  [9011] = 8217,
  [9012] = 8371,
  [9013] = 9013,
  [9014] = 8222,
  [9015] = 8604,
  [9016] = 8228,
  [9017] = 8222,
  [9018] = 8197,
  [9019] = 8388,
  [9020] = 8477,
  [9021] = 8606,
  [9022] = 8820,
  [9023] = 8816,
  [9024] = 8208,
  [9025] = 9025,
  [9026] = 8372,
  [9027] = 8798,
  [9028] = 8197,
  [9029] = 8222,
  [9030] = 8602,
  [9031] = 8606,
  [9032] = 8820,
  [9033] = 8816,
  [9034] = 8208,
  [9035] = 8314,
  [9036] = 8372,
  [9037] = 8798,
  [9038] = 8204,
  [9039] = 9039,
  [9040] = 8256,
  [9041] = 8820,
  [9042] = 8816,
  [9043] = 8314,
  [9044] = 8197,
  [9045] = 8372,
  [9046] = 8798,
  [9047] = 8240,
  [9048] = 8263,
  [9049] = 8820,
  [9050] = 8816,
  [9051] = 9051,
  [9052] = 9052,
  [9053] = 8372,
  [9054] = 8798,
  [9055] = 9055,
  [9056] = 9056,
  [9057] = 8820,
  [9058] = 8816,
  [9059] = 8194,
  [9060] = 9060,
  [9061] = 8372,
  [9062] = 8798,
  [9063] = 2139,
  [9064] = 8251,
  [9065] = 8229,
  [9066] = 8236,
  [9067] = 8372,
  [9068] = 8798,
  [9069] = 8230,
  [9070] = 8232,
  [9071] = 8232,
  [9072] = 8798,
  [9073] = 8193,
  [9074] = 8798,
  [9075] = 8243,
  [9076] = 8798,
  [9077] = 8271,
  [9078] = 8798,
  [9079] = 8236,
  [9080] = 8798,
  [9081] = 9081,
  [9082] = 8798,
  [9083] = 9083,
  [9084] = 8798,
  [9085] = 9085,
  [9086] = 8798,
  [9087] = 8227,
  [9088] = 8798,
  [9089] = 9089,
  [9090] = 8798,
  [9091] = 8289,
  [9092] = 8798,
  [9093] = 8283,
  [9094] = 8798,
  [9095] = 8282,
  [9096] = 8798,
  [9097] = 8992,
  [9098] = 8651,
  [9099] = 8217,
  [9100] = 8992,
  [9101] = 8651,
  [9102] = 8210,
  [9103] = 8992,
  [9104] = 8651,
  [9105] = 9105,
  [9106] = 8992,
  [9107] = 8651,
  [9108] = 8209,
  [9109] = 8992,
  [9110] = 8651,
  [9111] = 9111,
  [9112] = 8992,
  [9113] = 8651,
  [9114] = 8205,
  [9115] = 8992,
  [9116] = 8651,
  [9117] = 8194,
  [9118] = 8651,
  [9119] = 8651,
  [9120] = 8651,
  [9121] = 8651,
  [9122] = 8651,
  [9123] = 8651,
  [9124] = 8651,
  [9125] = 8651,
  [9126] = 8651,
  [9127] = 8651,
  [9128] = 8651,
  [9129] = 8651,
  [9130] = 8651,
  [9131] = 8240,
  [9132] = 9132,
  [9133] = 9133,
  [9134] = 8234,
  [9135] = 8207,
  [9136] = 8228,
  [9137] = 8206,
  [9138] = 8991,
  [9139] = 8991,
  [9140] = 8991,
  [9141] = 8991,
  [9142] = 8991,
  [9143] = 8991,
  [9144] = 8991,
};

static TSCharacterRange sym_identifier_character_set_1[] = {
  {'$', '$'}, {'A', 'Z'}, {'\\', '\\'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba},
  {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374},
  {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5},
  {0x3f7, 0x481}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a},
  {0x66e, 0x66f}, {0x671, 0x6d3}, {0x6d5, 0x6d5}, {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710},
  {0x712, 0x72f}, {0x74d, 0x7a5}, {0x7b1, 0x7b1}, {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a},
  {0x824, 0x824}, {0x828, 0x828}, {0x840, 0x858}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939},
  {0x93d, 0x93d}, {0x950, 0x950}, {0x958, 0x961}, {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0},
  {0x9b2, 0x9b2}, {0x9b6, 0x9b9}, {0x9bd, 0x9bd}, {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc},
  {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c},
  {0xa5e, 0xa5e}, {0xa72, 0xa74}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9},
  {0xabd, 0xabd}, {0xad0, 0xad0}, {0xae0, 0xae1}, {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30},
  {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3d, 0xb3d}, {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a},
  {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9},
  {0xbd0, 0xbd0}, {0xc05, 0xc0c}, {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d},
  {0xc60, 0xc61}, {0xc80, 0xc80}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd},
  {0xcdd, 0xcde}, {0xce0, 0xce1}, {0xcf1, 0xcf2}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e},
  {0xd54, 0xd56}, {0xd5f, 0xd61}, {0xd7a, 0xd7f}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6},
  {0xe01, 0xe30}, {0xe32, 0xe32}, {0xe40, 0xe46}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5},
  {0xea7, 0xeb0}, {0xeb2, 0xeb2}, {0xebd, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47},
  {0xf49, 0xf6c}, {0xf88, 0xf8c}, {0x1000, 0x102a}, {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066},
  {0x106e, 0x1070}, {0x1075, 0x1081}, {0x108e, 0x108e}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248},
  {0x124a, 0x124d}, {0x1250, 0x1256}, {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5},
  {0x12b8, 0x12be}, {0x12c0, 0x12c0}, {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f},
  {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711},
  {0x171f, 0x1731}, {0x1740, 0x1751}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878},
  {0x1880, 0x18a8}, {0x18aa, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9},
  {0x1a00, 0x1a16}, {0x1a20, 0x1a54}, {0x1aa7, 0x1aa7}, {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5},
  {0x1c00, 0x1c23}, {0x1c4d, 0x1c4f}, {0x1c5a, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3},
  {0x1cf5, 0x1cf6}, {0x1cfa, 0x1cfa}, {0x1d00, 0x1dbf}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57},
  {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4},
  {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x2071, 0x2071}, {0x207f, 0x207f},
  {0x2090, 0x209c}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126},
  {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee},
  {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6},
  {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x3005, 0x3007},
  {0x3021, 0x3029}, {0x3031, 0x3035}, {0x3038, 0x303c}, {0x3041, 0x3096}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f},
  {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f},
  {0xa62a, 0xa62b}, {0xa640, 0xa66e}, {0xa67f, 0xa69d}, {0xa6a0, 0xa6ef}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1},
  {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa801}, {0xa803, 0xa805}, {0xa807, 0xa80a}, {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3},
  {0xa8f2, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa8fe}, {0xa90a, 0xa925}, {0xa930, 0xa946}, {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf},
  {0xa9e0, 0xa9e4}, {0xa9e6, 0xa9ef}, {0xa9fa, 0xa9fe}, {0xaa00, 0xaa28}, {0xaa40, 0xaa42}, {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a},
  {0xaa7e, 0xaaaf}, {0xaab1, 0xaab1}, {0xaab5, 0xaab6}, {0xaab9, 0xaabd}, {0xaac0, 0xaac0}, {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea},
  {0xaaf2, 0xaaf4}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69},
  {0xab70, 0xabe2}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17},
  {0xfb1d, 0xfb1d}, {0xfb1f, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1},
  {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77},
  {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xff9d}, {0xffa0, 0xffbe},
  {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d},
  {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a},
  {0x10350, 0x10375}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb},
  {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1},
  {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba},
  {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e},
  {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a00}, {0x10a10, 0x10a13},
  {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae4}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55},
  {0x10b60, 0x10b72}, {0x10b80, 0x10b91}, {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d23}, {0x10e80, 0x10ea9}, {0x10eb0, 0x10eb1},
  {0x10f00, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f45}, {0x10f70, 0x10f81}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11003, 0x11037}, {0x11071, 0x11072},
  {0x11075, 0x11075}, {0x11083, 0x110af}, {0x110d0, 0x110e8}, {0x11103, 0x11126}, {0x11144, 0x11144}, {0x11147, 0x11147}, {0x11150, 0x11172}, {0x11176, 0x11176},
  {0x11183, 0x111b2}, {0x111c1, 0x111c4}, {0x111da, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x1122b}, {0x11280, 0x11286}, {0x11288, 0x11288},
  {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112de}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330},
  {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133d, 0x1133d}, {0x11350, 0x11350}, {0x1135d, 0x11361}, {0x11400, 0x11434}, {0x11447, 0x1144a}, {0x1145f, 0x11461},
  {0x11480, 0x114af}, {0x114c4, 0x114c5}, {0x114c7, 0x114c7}, {0x11580, 0x115ae}, {0x115d8, 0x115db}, {0x11600, 0x1162f}, {0x11644, 0x11644}, {0x11680, 0x116aa},
  {0x116b8, 0x116b8}, {0x11700, 0x1171a}, {0x11740, 0x11746}, {0x11800, 0x1182b}, {0x118a0, 0x118df}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913},
  {0x11915, 0x11916}, {0x11918, 0x1192f}, {0x1193f, 0x1193f}, {0x11941, 0x11941}, {0x119a0, 0x119a7}, {0x119aa, 0x119d0}, {0x119e1, 0x119e1}, {0x119e3, 0x119e3},
  {0x11a00, 0x11a00}, {0x11a0b, 0x11a32}, {0x11a3a, 0x11a3a}, {0x11a50, 0x11a50}, {0x11a5c, 0x11a89}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08},
  {0x11c0a, 0x11c2e}, {0x11c40, 0x11c40}, {0x11c72, 0x11c8f}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d30}, {0x11d46, 0x11d46}, {0x11d60, 0x11d65},
  {0x11d67, 0x11d68}, {0x11d6a, 0x11d89}, {0x11d98, 0x11d98}, {0x11ee0, 0x11ef2}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543},
  {0x12f90, 0x12ff0}, {0x13000, 0x1342e}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a70, 0x16abe}, {0x16ad0, 0x16aed}, {0x16b00, 0x16b2f},
  {0x16b40, 0x16b43}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f50, 0x16f50}, {0x16f93, 0x16f9f}, {0x16fe0, 0x16fe1},
  {0x16fe3, 0x16fe3}, {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122},
  {0x1b150, 0x1b152}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1d400, 0x1d454},
  {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3},
  {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546},
  {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e},
  {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1df00, 0x1df1e}, {0x1e100, 0x1e12c}, {0x1e137, 0x1e13d},
  {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ad}, {0x1e2c0, 0x1e2eb}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4},
  {0x1e900, 0x1e943}, {0x1e94b, 0x1e94b}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32},
  {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f},
  {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62},
  {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b},
  {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x20000, 0x2a6df}, {0x2a700, 0x2b738}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0},
  {0x2f800, 0x2fa1d}, {0x30000, 0x3134a},
};

static TSCharacterRange sym_identifier_character_set_2[] = {
  {'$', '$'}, {'0', '9'}, {'A', 'Z'}, {'\\', '\\'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5},
  {0xb7, 0xb7}, {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec},
  {0x2ee, 0x2ee}, {0x300, 0x374}, {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1},
  {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x483, 0x487}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x591, 0x5bd},
  {0x5bf, 0x5bf}, {0x5c1, 0x5c2}, {0x5c4, 0x5c5}, {0x5c7, 0x5c7}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x610, 0x61a}, {0x620, 0x669},
  {0x66e, 0x6d3}, {0x6d5, 0x6dc}, {0x6df, 0x6e8}, {0x6ea, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x74a}, {0x74d, 0x7b1}, {0x7c0, 0x7f5},
  {0x7fa, 0x7fa}, {0x7fd, 0x7fd}, {0x800, 0x82d}, {0x840, 0x85b}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x898, 0x8e1},
  {0x8e3, 0x963}, {0x966, 0x96f}, {0x971, 0x983}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2},
  {0x9b6, 0x9b9}, {0x9bc, 0x9c4}, {0x9c7, 0x9c8}, {0x9cb, 0x9ce}, {0x9d7, 0x9d7}, {0x9dc, 0x9dd}, {0x9df, 0x9e3}, {0x9e6, 0x9f1},
  {0x9fc, 0x9fc}, {0x9fe, 0x9fe}, {0xa01, 0xa03}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33},
  {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa3c, 0xa3c}, {0xa3e, 0xa42}, {0xa47, 0xa48}, {0xa4b, 0xa4d}, {0xa51, 0xa51}, {0xa59, 0xa5c},
  {0xa5e, 0xa5e}, {0xa66, 0xa75}, {0xa81, 0xa83}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3},
  {0xab5, 0xab9}, {0xabc, 0xac5}, {0xac7, 0xac9}, {0xacb, 0xacd}, {0xad0, 0xad0}, {0xae0, 0xae3}, {0xae6, 0xaef}, {0xaf9, 0xaff},
  {0xb01, 0xb03}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3c, 0xb44},
  {0xb47, 0xb48}, {0xb4b, 0xb4d}, {0xb55, 0xb57}, {0xb5c, 0xb5d}, {0xb5f, 0xb63}, {0xb66, 0xb6f}, {0xb71, 0xb71}, {0xb82, 0xb83},
  {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa},
  {0xbae, 0xbb9}, {0xbbe, 0xbc2}, {0xbc6, 0xbc8}, {0xbca, 0xbcd}, {0xbd0, 0xbd0}, {0xbd7, 0xbd7}, {0xbe6, 0xbef}, {0xc00, 0xc0c},
  {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3c, 0xc44}, {0xc46, 0xc48}, {0xc4a, 0xc4d}, {0xc55, 0xc56}, {0xc58, 0xc5a},
  {0xc5d, 0xc5d}, {0xc60, 0xc63}, {0xc66, 0xc6f}, {0xc80, 0xc83}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3},
  {0xcb5, 0xcb9}, {0xcbc, 0xcc4}, {0xcc6, 0xcc8}, {0xcca, 0xccd}, {0xcd5, 0xcd6}, {0xcdd, 0xcde}, {0xce0, 0xce3}, {0xce6, 0xcef},
  {0xcf1, 0xcf2}, {0xd00, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd44}, {0xd46, 0xd48}, {0xd4a, 0xd4e}, {0xd54, 0xd57}, {0xd5f, 0xd63},
  {0xd66, 0xd6f}, {0xd7a, 0xd7f}, {0xd81, 0xd83}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6},
  {0xdca, 0xdca}, {0xdcf, 0xdd4}, {0xdd6, 0xdd6}, {0xdd8, 0xddf}, {0xde6, 0xdef}, {0xdf2, 0xdf3}, {0xe01, 0xe3a}, {0xe40, 0xe4e},
  {0xe50, 0xe59}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xebd}, {0xec0, 0xec4},
  {0xec6, 0xec6}, {0xec8, 0xecd}, {0xed0, 0xed9}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf18, 0xf19}, {0xf20, 0xf29}, {0xf35, 0xf35},
  {0xf37, 0xf37}, {0xf39, 0xf39}, {0xf3e, 0xf47}, {0xf49, 0xf6c}, {0xf71, 0xf84}, {0xf86, 0xf97}, {0xf99, 0xfbc}, {0xfc6, 0xfc6},
  {0x1000, 0x1049}, {0x1050, 0x109d}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d},
  {0x1250, 0x1256}, {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be},
  {0x12c0, 0x12c0}, {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x135d, 0x135f}, {0x1369, 0x1371},
  {0x1380, 0x138f}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8},
  {0x1700, 0x1715}, {0x171f, 0x1734}, {0x1740, 0x1753}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1772, 0x1773}, {0x1780, 0x17d3}, {0x17d7, 0x17d7},
  {0x17dc, 0x17dd}, {0x17e0, 0x17e9}, {0x180b, 0x180d}, {0x180f, 0x1819}, {0x1820, 0x1878}, {0x1880, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e},
  {0x1920, 0x192b}, {0x1930, 0x193b}, {0x1946, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x19d0, 0x19da}, {0x1a00, 0x1a1b},
  {0x1a20, 0x1a5e}, {0x1a60, 0x1a7c}, {0x1a7f, 0x1a89}, {0x1a90, 0x1a99}, {0x1aa7, 0x1aa7}, {0x1ab0, 0x1abd}, {0x1abf, 0x1ace}, {0x1b00, 0x1b4c},
  {0x1b50, 0x1b59}, {0x1b6b, 0x1b73}, {0x1b80, 0x1bf3}, {0x1c00, 0x1c37}, {0x1c40, 0x1c49}, {0x1c4d, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba},
  {0x1cbd, 0x1cbf}, {0x1cd0, 0x1cd2}, {0x1cd4, 0x1cfa}, {0x1d00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57},
  {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4},
  {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x203f, 0x2040}, {0x2054, 0x2054},
  {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x20d0, 0x20dc}, {0x20e1, 0x20e1}, {0x20e5, 0x20f0}, {0x2102, 0x2102}, {0x2107, 0x2107},
  {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f},
  {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d},
  {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d7f, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6},
  {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x2de0, 0x2dff}, {0x3005, 0x3007}, {0x3021, 0x302f}, {0x3031, 0x3035}, {0x3038, 0x303c},
  {0x3041, 0x3096}, {0x3099, 0x309a}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf},
  {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa62b}, {0xa640, 0xa66f}, {0xa674, 0xa67d},
  {0xa67f, 0xa6f1}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa827},
  {0xa82c, 0xa82c}, {0xa840, 0xa873}, {0xa880, 0xa8c5}, {0xa8d0, 0xa8d9}, {0xa8e0, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa92d}, {0xa930, 0xa953},
  {0xa960, 0xa97c}, {0xa980, 0xa9c0}, {0xa9cf, 0xa9d9}, {0xa9e0, 0xa9fe}, {0xaa00, 0xaa36}, {0xaa40, 0xaa4d}, {0xaa50, 0xaa59}, {0xaa60, 0xaa76},
  {0xaa7a, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaef}, {0xaaf2, 0xaaf6}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26},
  {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabea}, {0xabec, 0xabed}, {0xabf0, 0xabf9}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6},
  {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c},
  {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7},
  {0xfdf0, 0xfdf9}, {0xfe00, 0xfe0f}, {0xfe20, 0xfe2f}, {0xfe33, 0xfe34}, {0xfe4d, 0xfe4f}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77},
  {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff10, 0xff19}, {0xff21, 0xff3a}, {0xff3f, 0xff3f}, {0xff41, 0xff5a},
  {0xff66, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a},
  {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x101fd, 0x101fd}, {0x10280, 0x1029c}, {0x102a0, 0x102d0},
  {0x102e0, 0x102e0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x1037a}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5},
  {0x10400, 0x1049d}, {0x104a0, 0x104a9}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a},
  {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755},
  {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838},
  {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939},
  {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a03}, {0x10a05, 0x10a06}, {0x10a0c, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a38, 0x10a3a},
  {0x10a3f, 0x10a3f}, {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae6}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72},
  {0x10b80, 0x10b91}, {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d27}, {0x10d30, 0x10d39}, {0x10e80, 0x10ea9}, {0x10eab, 0x10eac},
  {0x10eb0, 0x10eb1}, {0x10f00, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f50}, {0x10f70, 0x10f85}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11000, 0x11046},
  {0x11066, 0x11075}, {0x1107f, 0x110ba}, {0x110c2, 0x110c2}, {0x110d0, 0x110e8}, {0x110f0, 0x110f9}, {0x11100, 0x11134}, {0x11136, 0x1113f}, {0x11144, 0x11147},
  {0x11150, 0x11173}, {0x11176, 0x11176}, {0x11180, 0x111c4}, {0x111c9, 0x111cc}, {0x111ce, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x11237},
  {0x1123e, 0x1123e}, {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112ea}, {0x112f0, 0x112f9},
  {0x11300, 0x11303}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133b, 0x11344},
  {0x11347, 0x11348}, {0x1134b, 0x1134d}, {0x11350, 0x11350}, {0x11357, 0x11357}, {0x1135d, 0x11363}, {0x11366, 0x1136c}, {0x11370, 0x11374}, {0x11400, 0x1144a},
  {0x11450, 0x11459}, {0x1145e, 0x11461}, {0x11480, 0x114c5}, {0x114c7, 0x114c7}, {0x114d0, 0x114d9}, {0x11580, 0x115b5}, {0x115b8, 0x115c0}, {0x115d8, 0x115dd},
  {0x11600, 0x11640}, {0x11644, 0x11644}, {0x11650, 0x11659}, {0x11680, 0x116b8}, {0x116c0, 0x116c9}, {0x11700, 0x1171a}, {0x1171d, 0x1172b}, {0x11730, 0x11739},
  {0x11740, 0x11746}, {0x11800, 0x1183a}, {0x118a0, 0x118e9}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x11935},
  {0x11937, 0x11938}, {0x1193b, 0x11943}, {0x11950, 0x11959}, {0x119a0, 0x119a7}, {0x119aa, 0x119d7}, {0x119da, 0x119e1}, {0x119e3, 0x119e4}, {0x11a00, 0x11a3e},
  {0x11a47, 0x11a47}, {0x11a50, 0x11a99}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c36}, {0x11c38, 0x11c40}, {0x11c50, 0x11c59},
  {0x11c72, 0x11c8f}, {0x11c92, 0x11ca7}, {0x11ca9, 0x11cb6}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d36}, {0x11d3a, 0x11d3a}, {0x11d3c, 0x11d3d},
  {0x11d3f, 0x11d47}, {0x11d50, 0x11d59}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d8e}, {0x11d90, 0x11d91}, {0x11d93, 0x11d98}, {0x11da0, 0x11da9},
  {0x11ee0, 0x11ef6}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342e}, {0x14400, 0x14646},
  {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a60, 0x16a69}, {0x16a70, 0x16abe}, {0x16ac0, 0x16ac9}, {0x16ad0, 0x16aed}, {0x16af0, 0x16af4}, {0x16b00, 0x16b36},
  {0x16b40, 0x16b43}, {0x16b50, 0x16b59}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f4f, 0x16f87}, {0x16f8f, 0x16f9f},
  {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe4}, {0x16ff0, 0x16ff1}, {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb},
  {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b150, 0x1b152}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88},
  {0x1bc90, 0x1bc99}, {0x1bc9d, 0x1bc9e}, {0x1cf00, 0x1cf2d}, {0x1cf30, 0x1cf46}, {0x1d165, 0x1d169}, {0x1d16d, 0x1d172}, {0x1d17b, 0x1d182}, {0x1d185, 0x1d18b},
  {0x1d1aa, 0x1d1ad}, {0x1d242, 0x1d244}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac},
  {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539},
  {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa},
  {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb},
  {0x1d7ce, 0x1d7ff}, {0x1da00, 0x1da36}, {0x1da3b, 0x1da6c}, {0x1da75, 0x1da75}, {0x1da84, 0x1da84}, {0x1da9b, 0x1da9f}, {0x1daa1, 0x1daaf}, {0x1df00, 0x1df1e},
  {0x1e000, 0x1e006}, {0x1e008, 0x1e018}, {0x1e01b, 0x1e021}, {0x1e023, 0x1e024}, {0x1e026, 0x1e02a}, {0x1e100, 0x1e12c}, {0x1e130, 0x1e13d}, {0x1e140, 0x1e149},
  {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ae}, {0x1e2c0, 0x1e2f9}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4},
  {0x1e8d0, 0x1e8d6}, {0x1e900, 0x1e94b}, {0x1e950, 0x1e959}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27},
  {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b},
  {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f},
  {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89},
  {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x1fbf0, 0x1fbf9}, {0x20000, 0x2a6df}, {0x2a700, 0x2b738}, {0x2b740, 0x2b81d},
  {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0xe0100, 0xe01ef},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(389);
      ADVANCE_MAP(
        '!', 456,
        '"', 581,
        '#', 336,
        '%', 480,
        '&', 490,
        '\'', 572,
        '(', 393,
        ')', 396,
        '*', 476,
        '+', 470,
        ',', 395,
        '-', 459,
        '.', 547,
        '/', 478,
        '0', 696,
        ':', 531,
        ';', 515,
        '<', 502,
        '=', 527,
        '>', 694,
        '?', 532,
        'F', 621,
        'L', 595,
        'R', 598,
        'T', 625,
        'U', 599,
        '[', 523,
        '\\', 2,
        ']', 525,
        '^', 487,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 630,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        't', 672,
        'u', 602,
        'v', 664,
        '{', 519,
        '|', 484,
        '}', 520,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(387);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(557);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(191);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(191);
      if (lookahead == '\r') SKIP(1);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(202);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(202);
      if (lookahead == '\r') SKIP(3);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(201);
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(201);
      if (lookahead == '\r') SKIP(5);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(204);
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(204);
      if (lookahead == '\r') SKIP(7);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 9:
      if (lookahead == '\n') SKIP(203);
      END_STATE();
    case 10:
      if (lookahead == '\n') SKIP(203);
      if (lookahead == '\r') SKIP(9);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 11:
      if (lookahead == '\n') SKIP(205);
      END_STATE();
    case 12:
      if (lookahead == '\n') SKIP(205);
      if (lookahead == '\r') SKIP(11);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 13:
      if (lookahead == '\n') SKIP(206);
      END_STATE();
    case 14:
      if (lookahead == '\n') SKIP(206);
      if (lookahead == '\r') SKIP(13);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 15:
      if (lookahead == '\n') SKIP(286);
      END_STATE();
    case 16:
      if (lookahead == '\n') SKIP(286);
      if (lookahead == '\r') SKIP(15);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 17:
      if (lookahead == '\n') SKIP(194);
      END_STATE();
    case 18:
      if (lookahead == '\n') SKIP(194);
      if (lookahead == '\r') SKIP(17);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 19:
      if (lookahead == '\n') SKIP(196);
      END_STATE();
    case 20:
      if (lookahead == '\n') SKIP(196);
      if (lookahead == '\r') SKIP(19);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 21:
      if (lookahead == '\n') SKIP(230);
      END_STATE();
    case 22:
      if (lookahead == '\n') SKIP(230);
      if (lookahead == '\r') SKIP(21);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 23:
      if (lookahead == '\n') SKIP(287);
      END_STATE();
    case 24:
      if (lookahead == '\n') SKIP(287);
      if (lookahead == '\r') SKIP(23);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 25:
      if (lookahead == '\n') SKIP(199);
      END_STATE();
    case 26:
      if (lookahead == '\n') SKIP(199);
      if (lookahead == '\r') SKIP(25);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 27:
      if (lookahead == '\n') SKIP(218);
      END_STATE();
    case 28:
      if (lookahead == '\n') SKIP(218);
      if (lookahead == '\r') SKIP(27);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 29:
      if (lookahead == '\n') SKIP(214);
      END_STATE();
    case 30:
      if (lookahead == '\n') SKIP(214);
      if (lookahead == '\r') SKIP(29);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 31:
      if (lookahead == '\n') SKIP(231);
      END_STATE();
    case 32:
      if (lookahead == '\n') SKIP(231);
      if (lookahead == '\r') SKIP(31);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 33:
      if (lookahead == '\n') SKIP(229);
      END_STATE();
    case 34:
      if (lookahead == '\n') SKIP(229);
      if (lookahead == '\r') SKIP(33);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 35:
      if (lookahead == '\n') SKIP(207);
      END_STATE();
    case 36:
      if (lookahead == '\n') SKIP(207);
      if (lookahead == '\r') SKIP(35);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 37:
      if (lookahead == '\n') SKIP(267);
      END_STATE();
    case 38:
      if (lookahead == '\n') SKIP(267);
      if (lookahead == '\r') SKIP(37);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 39:
      if (lookahead == '\n') SKIP(215);
      END_STATE();
    case 40:
      if (lookahead == '\n') SKIP(215);
      if (lookahead == '\r') SKIP(39);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 41:
      if (lookahead == '\n') SKIP(219);
      END_STATE();
    case 42:
      if (lookahead == '\n') SKIP(219);
      if (lookahead == '\r') SKIP(41);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 43:
      if (lookahead == '\n') SKIP(209);
      END_STATE();
    case 44:
      if (lookahead == '\n') SKIP(209);
      if (lookahead == '\r') SKIP(43);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 45:
      if (lookahead == '\n') SKIP(232);
      END_STATE();
    case 46:
      if (lookahead == '\n') SKIP(232);
      if (lookahead == '\r') SKIP(45);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 47:
      if (lookahead == '\n') SKIP(240);
      END_STATE();
    case 48:
      if (lookahead == '\n') SKIP(240);
      if (lookahead == '\r') SKIP(47);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 49:
      if (lookahead == '\n') SKIP(244);
      END_STATE();
    case 50:
      if (lookahead == '\n') SKIP(244);
      if (lookahead == '\r') SKIP(49);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 51:
      if (lookahead == '\n') SKIP(251);
      END_STATE();
    case 52:
      if (lookahead == '\n') SKIP(251);
      if (lookahead == '\r') SKIP(51);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 53:
      if (lookahead == '\n') SKIP(268);
      END_STATE();
    case 54:
      if (lookahead == '\n') SKIP(268);
      if (lookahead == '\r') SKIP(53);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 55:
      if (lookahead == '\n') SKIP(285);
      END_STATE();
    case 56:
      if (lookahead == '\n') SKIP(285);
      if (lookahead == '\r') SKIP(55);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 57:
      if (lookahead == '\n') SKIP(210);
      END_STATE();
    case 58:
      if (lookahead == '\n') SKIP(210);
      if (lookahead == '\r') SKIP(57);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 59:
      if (lookahead == '\n') SKIP(239);
      END_STATE();
    case 60:
      if (lookahead == '\n') SKIP(239);
      if (lookahead == '\r') SKIP(59);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 61:
      if (lookahead == '\n') SKIP(288);
      END_STATE();
    case 62:
      if (lookahead == '\n') SKIP(288);
      if (lookahead == '\r') SKIP(61);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 63:
      if (lookahead == '\n') SKIP(274);
      END_STATE();
    case 64:
      if (lookahead == '\n') SKIP(274);
      if (lookahead == '\r') SKIP(63);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 65:
      if (lookahead == '\n') SKIP(272);
      END_STATE();
    case 66:
      if (lookahead == '\n') SKIP(272);
      if (lookahead == '\r') SKIP(65);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 67:
      if (lookahead == '\n') SKIP(280);
      END_STATE();
    case 68:
      if (lookahead == '\n') SKIP(280);
      if (lookahead == '\r') SKIP(67);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 69:
      if (lookahead == '\n') SKIP(216);
      END_STATE();
    case 70:
      if (lookahead == '\n') SKIP(216);
      if (lookahead == '\r') SKIP(69);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 71:
      if (lookahead == '\n') SKIP(221);
      END_STATE();
    case 72:
      if (lookahead == '\n') SKIP(221);
      if (lookahead == '\r') SKIP(71);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 73:
      if (lookahead == '\n') SKIP(291);
      END_STATE();
    case 74:
      if (lookahead == '\n') SKIP(291);
      if (lookahead == '\r') SKIP(73);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 75:
      if (lookahead == '\n') SKIP(289);
      END_STATE();
    case 76:
      if (lookahead == '\n') SKIP(289);
      if (lookahead == '\r') SKIP(75);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 77:
      if (lookahead == '\n') SKIP(247);
      END_STATE();
    case 78:
      if (lookahead == '\n') SKIP(247);
      if (lookahead == '\r') SKIP(77);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 79:
      if (lookahead == '\n') SKIP(238);
      END_STATE();
    case 80:
      if (lookahead == '\n') SKIP(238);
      if (lookahead == '\r') SKIP(79);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 81:
      if (lookahead == '\n') SKIP(256);
      END_STATE();
    case 82:
      if (lookahead == '\n') SKIP(256);
      if (lookahead == '\r') SKIP(81);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 83:
      if (lookahead == '\n') SKIP(200);
      END_STATE();
    case 84:
      if (lookahead == '\n') SKIP(200);
      if (lookahead == '\r') SKIP(83);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 85:
      if (lookahead == '\n') SKIP(255);
      END_STATE();
    case 86:
      if (lookahead == '\n') SKIP(255);
      if (lookahead == '\r') SKIP(85);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 87:
      if (lookahead == '\n') SKIP(246);
      END_STATE();
    case 88:
      if (lookahead == '\n') SKIP(246);
      if (lookahead == '\r') SKIP(87);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 89:
      if (lookahead == '\n') SKIP(292);
      END_STATE();
    case 90:
      if (lookahead == '\n') SKIP(292);
      if (lookahead == '\r') SKIP(89);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 91:
      if (lookahead == '\n') SKIP(290);
      END_STATE();
    case 92:
      if (lookahead == '\n') SKIP(290);
      if (lookahead == '\r') SKIP(91);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 93:
      if (lookahead == '\n') SKIP(266);
      END_STATE();
    case 94:
      if (lookahead == '\n') SKIP(266);
      if (lookahead == '\r') SKIP(93);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 95:
      if (lookahead == '\n') SKIP(297);
      END_STATE();
    case 96:
      if (lookahead == '\n') SKIP(297);
      if (lookahead == '\r') SKIP(95);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 97:
      if (lookahead == '\n') SKIP(208);
      END_STATE();
    case 98:
      if (lookahead == '\n') SKIP(208);
      if (lookahead == '\r') SKIP(97);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 99:
      if (lookahead == '\n') SKIP(101);
      END_STATE();
    case 100:
      if (lookahead == '\n') SKIP(101);
      if (lookahead == '\r') SKIP(99);
      END_STATE();
    case 101:
      ADVANCE_MAP(
        '\n', 398,
        '!', 321,
        '%', 479,
        '&', 489,
        '(', 454,
        '*', 475,
        '+', 468,
        '-', 458,
        '/', 477,
        '<', 503,
        '=', 322,
        '>', 494,
      );
      if (lookahead == '\\') SKIP(100);
      if (lookahead == '^') ADVANCE(486);
      if (lookahead == '|') ADVANCE(485);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(101);
      END_STATE();
    case 102:
      if (lookahead == '\n') SKIP(281);
      END_STATE();
    case 103:
      if (lookahead == '\n') SKIP(281);
      if (lookahead == '\r') SKIP(102);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 104:
      if (lookahead == '\n') SKIP(296);
      END_STATE();
    case 105:
      if (lookahead == '\n') SKIP(296);
      if (lookahead == '\r') SKIP(104);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 106:
      if (lookahead == '\n') SKIP(282);
      END_STATE();
    case 107:
      if (lookahead == '\n') SKIP(282);
      if (lookahead == '\r') SKIP(106);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 108:
      if (lookahead == '\n') SKIP(283);
      if (lookahead == '"') ADVANCE(581);
      if (lookahead == '/') ADVANCE(582);
      if (lookahead == '\\') ADVANCE(109);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(585);
      if (lookahead != 0) ADVANCE(586);
      END_STATE();
    case 109:
      if (lookahead == '\n') ADVANCE(588);
      if (lookahead == '\r') ADVANCE(587);
      if (lookahead == 'U') ADVANCE(385);
      if (lookahead == 'u') ADVANCE(377);
      if (lookahead == 'x') ADVANCE(373);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(590);
      if (lookahead != 0) ADVANCE(587);
      END_STATE();
    case 110:
      if (lookahead == '\n') SKIP(293);
      if (lookahead == '\'') ADVANCE(572);
      if (lookahead == '/') ADVANCE(575);
      if (lookahead == '\\') ADVANCE(574);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(576);
      if (lookahead != 0) ADVANCE(573);
      END_STATE();
    case 111:
      if (lookahead == '\n') ADVANCE(391);
      if (lookahead == '\r') ADVANCE(115);
      if (lookahead == '(') ADVANCE(393);
      if (lookahead == '/') ADVANCE(419);
      if (lookahead == '\\') ADVANCE(414);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(310);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 112:
      if (lookahead == '\n') ADVANCE(391);
      if (lookahead == '\r') ADVANCE(115);
      if (lookahead == '/') ADVANCE(419);
      if (lookahead == '\\') ADVANCE(414);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(310);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 113:
      if (lookahead == '\n') ADVANCE(391);
      if (lookahead == '\r') ADVANCE(114);
      if (lookahead == '(') ADVANCE(454);
      if (lookahead == '/') ADVANCE(301);
      if (lookahead == '\\') SKIP(117);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(298);
      END_STATE();
    case 114:
      if (lookahead == '\n') ADVANCE(391);
      if (lookahead == '(') ADVANCE(454);
      if (lookahead == '/') ADVANCE(301);
      if (lookahead == '\\') SKIP(117);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(298);
      END_STATE();
    case 115:
      if (lookahead == '\n') ADVANCE(391);
      if (lookahead == '/') ADVANCE(419);
      if (lookahead == '\\') ADVANCE(414);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(310);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 116:
      if (lookahead == '\n') SKIP(298);
      END_STATE();
    case 117:
      if (lookahead == '\n') SKIP(298);
      if (lookahead == '\r') SKIP(116);
      END_STATE();
    case 118:
      if (lookahead == '\n') SKIP(192);
      END_STATE();
    case 119:
      if (lookahead == '\n') SKIP(192);
      if (lookahead == '\r') SKIP(118);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 120:
      if (lookahead == '\n') SKIP(195);
      END_STATE();
    case 121:
      if (lookahead == '\n') SKIP(195);
      if (lookahead == '\r') SKIP(120);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 122:
      if (lookahead == '\n') SKIP(220);
      END_STATE();
    case 123:
      if (lookahead == '\n') SKIP(220);
      if (lookahead == '\r') SKIP(122);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 124:
      if (lookahead == '\n') SKIP(241);
      END_STATE();
    case 125:
      if (lookahead == '\n') SKIP(241);
      if (lookahead == '\r') SKIP(124);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 126:
      if (lookahead == '\n') SKIP(234);
      END_STATE();
    case 127:
      if (lookahead == '\n') SKIP(234);
      if (lookahead == '\r') SKIP(126);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 128:
      if (lookahead == '\n') SKIP(245);
      END_STATE();
    case 129:
      if (lookahead == '\n') SKIP(245);
      if (lookahead == '\r') SKIP(128);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 130:
      if (lookahead == '\n') SKIP(269);
      END_STATE();
    case 131:
      if (lookahead == '\n') SKIP(269);
      if (lookahead == '\r') SKIP(130);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 132:
      if (lookahead == '\n') SKIP(212);
      END_STATE();
    case 133:
      if (lookahead == '\n') SKIP(212);
      if (lookahead == '\r') SKIP(132);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 134:
      if (lookahead == '\n') SKIP(257);
      END_STATE();
    case 135:
      if (lookahead == '\n') SKIP(257);
      if (lookahead == '\r') SKIP(134);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 136:
      if (lookahead == '\n') SKIP(270);
      END_STATE();
    case 137:
      if (lookahead == '\n') SKIP(270);
      if (lookahead == '\r') SKIP(136);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 138:
      if (lookahead == '\n') SKIP(223);
      END_STATE();
    case 139:
      if (lookahead == '\n') SKIP(223);
      if (lookahead == '\r') SKIP(138);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 140:
      if (lookahead == '\n') SKIP(237);
      END_STATE();
    case 141:
      if (lookahead == '\n') SKIP(237);
      if (lookahead == '\r') SKIP(140);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 142:
      if (lookahead == '\n') SKIP(261);
      END_STATE();
    case 143:
      if (lookahead == '\n') SKIP(261);
      if (lookahead == '\r') SKIP(142);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 144:
      if (lookahead == '\n') SKIP(249);
      END_STATE();
    case 145:
      if (lookahead == '\n') SKIP(249);
      if (lookahead == '\r') SKIP(144);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 146:
      if (lookahead == '\n') SKIP(193);
      END_STATE();
    case 147:
      if (lookahead == '\n') SKIP(193);
      if (lookahead == '\r') SKIP(146);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 148:
      if (lookahead == '\n') SKIP(198);
      END_STATE();
    case 149:
      if (lookahead == '\n') SKIP(198);
      if (lookahead == '\r') SKIP(148);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 150:
      if (lookahead == '\n') SKIP(235);
      END_STATE();
    case 151:
      if (lookahead == '\n') SKIP(235);
      if (lookahead == '\r') SKIP(150);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 152:
      if (lookahead == '\n') SKIP(262);
      END_STATE();
    case 153:
      if (lookahead == '\n') SKIP(262);
      if (lookahead == '\r') SKIP(152);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 154:
      if (lookahead == '\n') SKIP(254);
      END_STATE();
    case 155:
      if (lookahead == '\n') SKIP(254);
      if (lookahead == '\r') SKIP(154);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 156:
      if (lookahead == '\n') SKIP(227);
      END_STATE();
    case 157:
      if (lookahead == '\n') SKIP(227);
      if (lookahead == '\r') SKIP(156);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 158:
      if (lookahead == '\n') SKIP(243);
      END_STATE();
    case 159:
      if (lookahead == '\n') SKIP(243);
      if (lookahead == '\r') SKIP(158);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 160:
      if (lookahead == '\n') SKIP(264);
      END_STATE();
    case 161:
      if (lookahead == '\n') SKIP(264);
      if (lookahead == '\r') SKIP(160);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 162:
      if (lookahead == '\n') SKIP(250);
      END_STATE();
    case 163:
      if (lookahead == '\n') SKIP(250);
      if (lookahead == '\r') SKIP(162);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 164:
      if (lookahead == '\n') SKIP(197);
      END_STATE();
    case 165:
      if (lookahead == '\n') SKIP(197);
      if (lookahead == '\r') SKIP(164);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 166:
      if (lookahead == '\n') SKIP(233);
      END_STATE();
    case 167:
      if (lookahead == '\n') SKIP(233);
      if (lookahead == '\r') SKIP(166);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 168:
      if (lookahead == '\n') SKIP(277);
      END_STATE();
    case 169:
      if (lookahead == '\n') SKIP(277);
      if (lookahead == '\r') SKIP(168);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 170:
      if (lookahead == '\n') SKIP(252);
      END_STATE();
    case 171:
      if (lookahead == '\n') SKIP(252);
      if (lookahead == '\r') SKIP(170);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 172:
      if (lookahead == '\n') SKIP(225);
      END_STATE();
    case 173:
      if (lookahead == '\n') SKIP(225);
      if (lookahead == '\r') SKIP(172);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 174:
      if (lookahead == '\n') SKIP(259);
      END_STATE();
    case 175:
      if (lookahead == '\n') SKIP(259);
      if (lookahead == '\r') SKIP(174);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 176:
      if (lookahead == '\n') SKIP(253);
      END_STATE();
    case 177:
      if (lookahead == '\n') SKIP(253);
      if (lookahead == '\r') SKIP(176);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 178:
      if (lookahead == '\n') SKIP(260);
      END_STATE();
    case 179:
      if (lookahead == '\n') SKIP(260);
      if (lookahead == '\r') SKIP(178);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 180:
      if (lookahead == '\n') SKIP(271);
      END_STATE();
    case 181:
      if (lookahead == '\n') SKIP(271);
      if (lookahead == '\r') SKIP(180);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 182:
      if (lookahead == '\n') SKIP(265);
      END_STATE();
    case 183:
      if (lookahead == '\n') SKIP(265);
      if (lookahead == '\r') SKIP(182);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 184:
      if (lookahead == '\n') SKIP(273);
      END_STATE();
    case 185:
      if (lookahead == '\n') SKIP(273);
      if (lookahead == '\r') SKIP(184);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 186:
      if (lookahead == '\n') SKIP(279);
      END_STATE();
    case 187:
      if (lookahead == '\n') SKIP(279);
      if (lookahead == '\r') SKIP(186);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 188:
      if (lookahead == '\n') SKIP(276);
      END_STATE();
    case 189:
      if (lookahead == '\n') SKIP(276);
      if (lookahead == '\r') SKIP(188);
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 190:
      if (lookahead == '\r') ADVANCE(693);
      if (lookahead == '\\') ADVANCE(687);
      if (lookahead != 0) ADVANCE(692);
      END_STATE();
    case 191:
      ADVANCE_MAP(
        '!', 456,
        '"', 581,
        '#', 336,
        '%', 480,
        '&', 490,
        '\'', 572,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 470,
        ',', 395,
        '-', 459,
        '.', 547,
        '/', 478,
        '0', 696,
        ':', 531,
        ';', 515,
        '<', 502,
        '=', 527,
        '>', 694,
        '?', 532,
        'F', 621,
        'L', 595,
        'R', 598,
        'T', 625,
        'U', 599,
        '[', 523,
        '\\', 2,
        ']', 525,
        '^', 487,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 630,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        't', 672,
        'u', 602,
        'v', 664,
        '{', 519,
        '|', 484,
        '}', 520,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(191);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(557);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 192:
      ADVANCE_MAP(
        '!', 456,
        '"', 581,
        '#', 345,
        '%', 480,
        '&', 490,
        '\'', 572,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 470,
        ',', 395,
        '-', 460,
        '.', 547,
        '/', 478,
        '0', 554,
        ':', 531,
        ';', 515,
        '<', 502,
        '=', 527,
        '>', 495,
        '?', 532,
        'F', 621,
        'L', 595,
        'R', 598,
        'T', 625,
        'U', 599,
        '[', 521,
        '\\', 119,
        ']', 525,
        '^', 487,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 630,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        't', 672,
        'u', 602,
        'v', 664,
        '{', 519,
        '|', 484,
        '}', 520,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(192);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(557);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 193:
      ADVANCE_MAP(
        '!', 456,
        '"', 581,
        '#', 345,
        '%', 479,
        '&', 489,
        '\'', 572,
        '(', 454,
        ')', 396,
        '*', 475,
        '+', 471,
        ',', 395,
        '-', 461,
        '.', 547,
        '/', 477,
        '0', 554,
        ':', 531,
        ';', 515,
        '<', 506,
        '=', 322,
        '>', 494,
        '?', 532,
        'F', 621,
        'L', 595,
        'R', 598,
        'T', 625,
        'U', 599,
        '[', 521,
        '\\', 147,
        ']', 525,
        '^', 486,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 630,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        't', 672,
        'u', 602,
        'v', 664,
        '{', 519,
        '|', 485,
        '}', 520,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(193);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(557);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 194:
      ADVANCE_MAP(
        '!', 456,
        '"', 581,
        '%', 480,
        '&', 490,
        '\'', 572,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 470,
        ',', 395,
        '-', 459,
        '.', 547,
        '/', 478,
        '0', 554,
        ':', 317,
        '<', 502,
        '=', 527,
        '>', 495,
        '?', 532,
        'F', 621,
        'L', 595,
        'R', 598,
        'T', 625,
        'U', 599,
        '[', 521,
        '\\', 18,
        '^', 487,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 630,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        't', 672,
        'u', 602,
        'v', 664,
        '{', 519,
        '|', 484,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(194);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(557);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 195:
      ADVANCE_MAP(
        '!', 456,
        '"', 581,
        '%', 480,
        '&', 490,
        '\'', 572,
        '(', 454,
        '*', 476,
        '+', 470,
        ',', 395,
        '-', 460,
        '.', 547,
        '/', 478,
        '0', 554,
        ':', 317,
        '<', 502,
        '=', 527,
        '>', 694,
        '?', 532,
        'F', 621,
        'L', 595,
        'R', 598,
        'T', 625,
        'U', 599,
        '[', 521,
        '\\', 121,
        '^', 487,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 630,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        't', 672,
        'u', 602,
        'v', 664,
        '{', 519,
        '|', 484,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(195);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(557);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 196:
      ADVANCE_MAP(
        '!', 456,
        '"', 581,
        '%', 480,
        '&', 490,
        '\'', 572,
        '(', 454,
        '*', 476,
        '+', 470,
        ',', 395,
        '-', 460,
        '.', 547,
        '/', 478,
        '0', 554,
        ':', 317,
        '<', 502,
        '=', 527,
        '>', 496,
        '?', 532,
        'F', 621,
        'L', 595,
        'R', 598,
        'T', 625,
        'U', 599,
        '[', 521,
        '\\', 20,
        '^', 487,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 630,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        't', 672,
        'u', 602,
        'v', 664,
        '{', 519,
        '|', 484,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(196);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(557);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 197:
      ADVANCE_MAP(
        '!', 456,
        '"', 581,
        '%', 479,
        '&', 489,
        '\'', 572,
        '(', 454,
        '*', 475,
        '+', 471,
        ',', 395,
        '-', 461,
        '.', 547,
        '/', 477,
        '0', 554,
        ':', 317,
        '<', 506,
        '=', 322,
        '>', 694,
        '?', 532,
        'F', 621,
        'L', 595,
        'R', 598,
        'T', 625,
        'U', 599,
        '[', 521,
        '\\', 165,
        '^', 486,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 630,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        't', 672,
        'u', 602,
        'v', 664,
        '{', 519,
        '|', 485,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(197);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(557);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 198:
      ADVANCE_MAP(
        '!', 456,
        '"', 581,
        '%', 479,
        '&', 489,
        '\'', 572,
        '(', 454,
        '*', 475,
        '+', 471,
        ',', 395,
        '-', 461,
        '.', 547,
        '/', 477,
        '0', 554,
        ':', 317,
        '<', 506,
        '=', 322,
        '>', 497,
        '?', 532,
        'F', 621,
        'L', 595,
        'R', 598,
        'T', 625,
        'U', 599,
        '[', 521,
        '\\', 149,
        '^', 486,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 630,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        't', 672,
        'u', 602,
        'v', 664,
        '{', 519,
        '|', 485,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(198);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(557);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 199:
      ADVANCE_MAP(
        '!', 456,
        '"', 284,
        '%', 480,
        '&', 490,
        '(', 299,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 463,
        '/', 478,
        ':', 317,
        '<', 504,
        '=', 527,
        '>', 495,
        '[', 333,
        '\\', 26,
        '^', 487,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 659,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        'u', 652,
        'v', 664,
        '|', 484,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(199);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 200:
      ADVANCE_MAP(
        '!', 456,
        '"', 284,
        '%', 480,
        '&', 490,
        '(', 299,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 463,
        '/', 478,
        '<', 504,
        '=', 527,
        '>', 495,
        '[', 334,
        '\\', 84,
        '^', 487,
        '|', 484,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(200);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 201:
      ADVANCE_MAP(
        '!', 455,
        '"', 581,
        '#', 336,
        '&', 489,
        '\'', 572,
        '(', 454,
        '*', 475,
        '+', 471,
        ',', 395,
        '-', 462,
        '.', 365,
        '/', 301,
        '0', 554,
        ':', 317,
        ';', 515,
        '<', 319,
        '>', 323,
        'F', 621,
        'L', 595,
        'R', 598,
        'T', 625,
        'U', 599,
        '[', 522,
        '\\', 6,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 630,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        't', 672,
        'u', 602,
        'v', 664,
        '{', 519,
        '|', 483,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(201);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(557);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 202:
      ADVANCE_MAP(
        '!', 455,
        '"', 581,
        '#', 340,
        '%', 479,
        '&', 489,
        '\'', 572,
        '(', 454,
        ')', 396,
        '*', 475,
        '+', 471,
        ',', 395,
        '-', 462,
        '.', 548,
        '/', 477,
        '0', 554,
        ':', 531,
        ';', 515,
        '<', 501,
        '=', 526,
        '>', 694,
        'F', 621,
        'L', 595,
        'R', 598,
        'T', 625,
        'U', 599,
        '[', 522,
        '\\', 4,
        ']', 335,
        '^', 486,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 630,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        't', 672,
        'u', 602,
        'v', 664,
        '{', 519,
        '|', 359,
        '}', 520,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(202);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(557);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 203:
      ADVANCE_MAP(
        '!', 455,
        '"', 581,
        '#', 344,
        '&', 488,
        '\'', 572,
        '(', 454,
        ')', 396,
        '*', 475,
        '+', 471,
        '-', 462,
        '.', 307,
        '/', 301,
        '0', 554,
        ':', 317,
        ';', 515,
        '>', 493,
        'F', 621,
        'L', 595,
        'R', 598,
        'T', 625,
        'U', 599,
        '[', 522,
        '\\', 10,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 630,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        't', 672,
        'u', 602,
        'v', 664,
        '{', 519,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(203);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(557);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 204:
      ADVANCE_MAP(
        '!', 455,
        '"', 581,
        '#', 338,
        '&', 489,
        '\'', 572,
        '(', 454,
        '*', 475,
        '+', 471,
        ',', 395,
        '-', 462,
        '.', 365,
        '/', 301,
        '0', 554,
        ':', 317,
        ';', 515,
        '>', 326,
        'F', 621,
        'L', 595,
        'R', 598,
        'T', 625,
        'U', 599,
        '[', 522,
        '\\', 8,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 630,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        't', 672,
        'u', 602,
        'v', 664,
        '{', 519,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(204);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(557);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 205:
      ADVANCE_MAP(
        '!', 455,
        '"', 581,
        '&', 489,
        '\'', 572,
        '(', 454,
        ')', 396,
        '*', 475,
        '+', 471,
        ',', 395,
        '-', 462,
        '.', 548,
        '/', 301,
        '0', 554,
        ':', 317,
        ';', 515,
        '<', 501,
        '=', 526,
        '>', 694,
        'F', 621,
        'L', 595,
        'R', 598,
        'T', 625,
        'U', 599,
        '[', 521,
        '\\', 12,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 630,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        't', 672,
        'u', 602,
        'v', 664,
        '{', 519,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(205);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(557);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 206:
      ADVANCE_MAP(
        '!', 455,
        '"', 581,
        '&', 488,
        '\'', 572,
        '(', 454,
        ')', 396,
        '*', 475,
        '+', 471,
        ',', 395,
        '-', 462,
        '.', 548,
        '/', 301,
        '0', 554,
        ':', 531,
        ';', 515,
        '<', 501,
        '=', 526,
        '>', 694,
        'F', 621,
        'L', 595,
        'R', 598,
        'T', 625,
        'U', 599,
        '[', 521,
        '\\', 14,
        ']', 525,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 630,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        't', 672,
        'u', 602,
        'v', 664,
        '{', 519,
        '}', 520,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(206);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(557);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 207:
      ADVANCE_MAP(
        '!', 455,
        '"', 581,
        '&', 488,
        '\'', 572,
        '(', 454,
        '*', 475,
        '+', 471,
        '-', 462,
        '.', 365,
        '/', 301,
        '0', 696,
        ':', 317,
        'F', 621,
        'L', 595,
        'R', 598,
        'T', 625,
        'U', 599,
        '[', 521,
        '\\', 36,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 630,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        't', 672,
        'u', 602,
        'v', 664,
        '{', 519,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(207);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(557);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 208:
      ADVANCE_MAP(
        '!', 455,
        '\'', 572,
        '(', 454,
        ')', 396,
        '+', 473,
        '-', 466,
        '.', 365,
        '/', 301,
        '0', 554,
        'L', 613,
        'U', 614,
        '\\', 98,
        'u', 615,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(208);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(557);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 209:
      ADVANCE_MAP(
        '!', 321,
        '"', 581,
        '#', 345,
        '%', 480,
        '&', 490,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        ':', 531,
        ';', 515,
        '<', 502,
        '=', 527,
        '>', 495,
        '?', 532,
        'L', 596,
        'R', 598,
        'U', 600,
        '[', 521,
        '\\', 44,
        ']', 525,
        '^', 487,
        'u', 603,
        '{', 519,
        '|', 484,
        '}', 520,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(209);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 210:
      ADVANCE_MAP(
        '!', 321,
        '"', 581,
        '#', 345,
        '%', 480,
        '&', 490,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        ':', 530,
        ';', 515,
        '<', 502,
        '=', 527,
        '>', 495,
        '?', 532,
        'L', 596,
        'R', 598,
        'U', 600,
        '[', 521,
        '\\', 58,
        ']', 525,
        '^', 487,
        'u', 603,
        '|', 484,
        '}', 520,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(210);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 211:
      ADVANCE_MAP(
        '!', 321,
        '"', 581,
        '#', 345,
        '%', 480,
        '&', 490,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        ':', 530,
        ';', 515,
        '<', 502,
        '=', 527,
        '>', 495,
        '?', 532,
        'L', 706,
        'R', 707,
        'U', 708,
        '[', 521,
        '\\', 58,
        ']', 525,
        '^', 487,
        'u', 709,
        '|', 484,
        '}', 520,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(210);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 212:
      ADVANCE_MAP(
        '!', 321,
        '"', 581,
        '#', 345,
        '%', 479,
        '&', 489,
        '(', 454,
        ')', 396,
        '*', 475,
        '+', 469,
        ',', 395,
        '-', 465,
        '.', 546,
        '/', 477,
        ':', 530,
        ';', 515,
        '<', 506,
        '=', 322,
        '>', 494,
        '?', 532,
        'L', 596,
        'R', 598,
        'U', 600,
        '[', 521,
        '\\', 133,
        ']', 525,
        '^', 486,
        'u', 603,
        '|', 485,
        '}', 520,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(212);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 213:
      ADVANCE_MAP(
        '!', 321,
        '"', 581,
        '#', 345,
        '%', 479,
        '&', 489,
        '(', 454,
        ')', 396,
        '*', 475,
        '+', 469,
        ',', 395,
        '-', 465,
        '.', 546,
        '/', 477,
        ':', 530,
        ';', 515,
        '<', 506,
        '=', 322,
        '>', 494,
        '?', 532,
        'L', 706,
        'R', 707,
        'U', 708,
        '[', 521,
        '\\', 133,
        ']', 525,
        '^', 486,
        'u', 709,
        '|', 485,
        '}', 520,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(212);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 214:
      ADVANCE_MAP(
        '!', 321,
        '"', 581,
        '%', 480,
        '&', 490,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 463,
        '.', 546,
        '/', 478,
        ':', 317,
        '<', 502,
        '=', 527,
        '>', 495,
        '?', 532,
        'L', 596,
        'R', 598,
        'U', 600,
        '[', 522,
        '\\', 30,
        '^', 487,
        'u', 603,
        '{', 519,
        '|', 484,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(214);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 215:
      ADVANCE_MAP(
        '!', 321,
        '"', 581,
        '%', 480,
        '&', 490,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 463,
        '.', 546,
        '/', 478,
        ':', 317,
        '<', 502,
        '=', 527,
        '>', 495,
        '?', 532,
        'L', 596,
        'R', 598,
        'U', 600,
        '[', 521,
        '\\', 40,
        '^', 487,
        'u', 603,
        '{', 519,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(215);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 216:
      ADVANCE_MAP(
        '!', 321,
        '"', 581,
        '%', 480,
        '&', 490,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 463,
        '.', 546,
        '/', 478,
        '<', 502,
        '=', 527,
        '>', 495,
        '?', 532,
        'L', 596,
        'R', 598,
        'U', 600,
        '[', 521,
        '\\', 70,
        '^', 487,
        'u', 603,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(216);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 217:
      ADVANCE_MAP(
        '!', 321,
        '"', 581,
        '%', 480,
        '&', 490,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 463,
        '.', 546,
        '/', 478,
        '<', 502,
        '=', 527,
        '>', 495,
        '?', 532,
        'L', 706,
        'R', 707,
        'U', 708,
        '[', 521,
        '\\', 70,
        '^', 487,
        'u', 709,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(216);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 218:
      ADVANCE_MAP(
        '!', 321,
        '"', 581,
        '%', 480,
        '&', 490,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        ':', 531,
        ';', 515,
        '<', 502,
        '=', 527,
        '>', 495,
        '?', 532,
        'L', 596,
        'R', 598,
        'U', 600,
        '[', 522,
        '\\', 28,
        '^', 487,
        'u', 603,
        '{', 519,
        '|', 484,
        '}', 520,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(218);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 219:
      ADVANCE_MAP(
        '!', 321,
        '"', 581,
        '%', 480,
        '&', 490,
        '(', 454,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        ':', 317,
        '<', 502,
        '=', 527,
        '>', 694,
        '?', 532,
        'L', 596,
        'R', 598,
        'U', 600,
        '[', 521,
        '\\', 42,
        '^', 487,
        'u', 603,
        '{', 519,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(219);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 220:
      ADVANCE_MAP(
        '!', 321,
        '"', 581,
        '%', 480,
        '&', 490,
        '(', 454,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        ':', 317,
        '<', 502,
        '=', 527,
        '>', 496,
        '?', 532,
        'L', 596,
        'R', 598,
        'U', 600,
        '[', 521,
        '\\', 123,
        '^', 487,
        'u', 603,
        '{', 519,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(220);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 221:
      ADVANCE_MAP(
        '!', 321,
        '"', 581,
        '%', 480,
        '&', 490,
        '(', 454,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        '<', 502,
        '=', 527,
        '>', 694,
        '?', 532,
        'L', 596,
        'R', 598,
        'U', 600,
        '[', 521,
        '\\', 72,
        '^', 487,
        'u', 603,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(221);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 222:
      ADVANCE_MAP(
        '!', 321,
        '"', 581,
        '%', 480,
        '&', 490,
        '(', 454,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        '<', 502,
        '=', 527,
        '>', 694,
        '?', 532,
        'L', 706,
        'R', 707,
        'U', 708,
        '[', 521,
        '\\', 72,
        '^', 487,
        'u', 709,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(221);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 223:
      ADVANCE_MAP(
        '!', 321,
        '"', 581,
        '%', 480,
        '&', 490,
        '(', 454,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        '<', 502,
        '=', 527,
        '>', 496,
        '?', 532,
        'L', 596,
        'R', 598,
        'U', 600,
        '[', 521,
        '\\', 139,
        '^', 487,
        'u', 603,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(223);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 224:
      ADVANCE_MAP(
        '!', 321,
        '"', 581,
        '%', 480,
        '&', 490,
        '(', 454,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        '<', 502,
        '=', 527,
        '>', 496,
        '?', 532,
        'L', 706,
        'R', 707,
        'U', 708,
        '[', 521,
        '\\', 139,
        '^', 487,
        'u', 709,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(223);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 225:
      ADVANCE_MAP(
        '!', 321,
        '"', 581,
        '%', 479,
        '&', 489,
        '(', 454,
        '*', 475,
        '+', 469,
        ',', 395,
        '-', 465,
        '.', 546,
        '/', 477,
        '<', 506,
        '=', 322,
        '>', 694,
        '?', 532,
        'L', 596,
        'R', 598,
        'U', 600,
        '[', 521,
        '\\', 173,
        '^', 486,
        'u', 603,
        '|', 485,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(225);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 226:
      ADVANCE_MAP(
        '!', 321,
        '"', 581,
        '%', 479,
        '&', 489,
        '(', 454,
        '*', 475,
        '+', 469,
        ',', 395,
        '-', 465,
        '.', 546,
        '/', 477,
        '<', 506,
        '=', 322,
        '>', 694,
        '?', 532,
        'L', 706,
        'R', 707,
        'U', 708,
        '[', 521,
        '\\', 173,
        '^', 486,
        'u', 709,
        '|', 485,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(225);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 227:
      ADVANCE_MAP(
        '!', 321,
        '"', 581,
        '%', 479,
        '&', 489,
        '(', 454,
        '*', 475,
        '+', 469,
        ',', 395,
        '-', 465,
        '.', 546,
        '/', 477,
        '<', 506,
        '=', 322,
        '>', 497,
        '?', 532,
        'L', 596,
        'R', 598,
        'U', 600,
        '[', 521,
        '\\', 157,
        '^', 486,
        'u', 603,
        '|', 485,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(227);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 228:
      ADVANCE_MAP(
        '!', 321,
        '"', 581,
        '%', 479,
        '&', 489,
        '(', 454,
        '*', 475,
        '+', 469,
        ',', 395,
        '-', 465,
        '.', 546,
        '/', 477,
        '<', 506,
        '=', 322,
        '>', 497,
        '?', 532,
        'L', 706,
        'R', 707,
        'U', 708,
        '[', 521,
        '\\', 157,
        '^', 486,
        'u', 709,
        '|', 485,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(227);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 229:
      ADVANCE_MAP(
        '!', 321,
        '#', 356,
        '%', 480,
        '&', 490,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 463,
        '.', 546,
        '/', 478,
        ':', 317,
        ';', 515,
        '<', 502,
        '=', 527,
        '>', 495,
        '?', 532,
        '[', 522,
        '\\', 34,
        '^', 487,
        '{', 519,
        '|', 484,
        '}', 520,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(229);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 230:
      ADVANCE_MAP(
        '!', 321,
        '#', 341,
        '%', 479,
        '&', 489,
        '(', 454,
        ')', 396,
        '*', 475,
        '+', 468,
        ',', 395,
        '-', 458,
        '/', 477,
        ':', 317,
        ';', 515,
        '<', 503,
        '=', 322,
        '>', 494,
        '[', 522,
        '\\', 22,
        '^', 486,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 659,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        'u', 652,
        'v', 664,
        '|', 485,
        '}', 520,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(230);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 231:
      ADVANCE_MAP(
        '!', 321,
        '#', 345,
        '%', 480,
        '&', 490,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        '0', 695,
        ':', 531,
        ';', 515,
        '<', 502,
        '=', 527,
        '>', 495,
        '?', 532,
        '[', 522,
        '\\', 32,
        '^', 487,
        '{', 519,
        '|', 484,
        '}', 520,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(231);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 232:
      ADVANCE_MAP(
        '!', 321,
        '#', 345,
        '%', 480,
        '&', 490,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        ':', 531,
        ';', 515,
        '<', 502,
        '=', 527,
        '>', 495,
        '?', 532,
        '[', 521,
        '\\', 46,
        ']', 525,
        '^', 487,
        '{', 519,
        '|', 484,
        '}', 520,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(232);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 233:
      ADVANCE_MAP(
        '!', 321,
        '#', 345,
        '%', 480,
        '&', 490,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        ':', 530,
        ';', 515,
        '<', 502,
        '=', 527,
        '>', 495,
        '?', 532,
        '[', 522,
        '\\', 167,
        ']', 525,
        '^', 487,
        '{', 519,
        '|', 484,
        '}', 520,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(233);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 234:
      ADVANCE_MAP(
        '!', 321,
        '#', 345,
        '%', 480,
        '&', 490,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        ':', 530,
        ';', 515,
        '<', 502,
        '=', 527,
        '>', 495,
        '?', 532,
        '[', 521,
        '\\', 127,
        ']', 525,
        '^', 487,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 659,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        'u', 652,
        'v', 664,
        '{', 519,
        '|', 484,
        '}', 520,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(234);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 235:
      ADVANCE_MAP(
        '!', 321,
        '#', 345,
        '%', 480,
        '&', 490,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        ':', 530,
        ';', 515,
        '<', 502,
        '=', 527,
        '>', 495,
        '?', 532,
        '[', 521,
        '\\', 151,
        ']', 525,
        '^', 487,
        '{', 519,
        '|', 484,
        '}', 520,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(235);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 236:
      ADVANCE_MAP(
        '!', 321,
        '#', 345,
        '%', 480,
        '&', 490,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        ':', 530,
        ';', 515,
        '<', 502,
        '=', 527,
        '>', 495,
        '?', 532,
        '[', 521,
        '\\', 141,
        ']', 525,
        '^', 487,
        '|', 484,
        '}', 520,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(237);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 237:
      ADVANCE_MAP(
        '!', 321,
        '#', 345,
        '%', 480,
        '&', 490,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        ':', 530,
        ';', 515,
        '<', 502,
        '=', 527,
        '>', 495,
        '?', 532,
        '[', 521,
        '\\', 141,
        ']', 525,
        '^', 487,
        '|', 484,
        '}', 520,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(237);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 238:
      ADVANCE_MAP(
        '!', 321,
        '#', 345,
        '%', 480,
        '&', 490,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        ':', 530,
        ';', 515,
        '<', 502,
        '=', 527,
        '>', 495,
        '?', 532,
        '[', 524,
        '\\', 80,
        ']', 525,
        '^', 487,
        '|', 484,
        '}', 520,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(238);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 239:
      ADVANCE_MAP(
        '!', 321,
        '#', 345,
        '%', 479,
        '&', 489,
        '(', 454,
        ')', 396,
        '*', 475,
        '+', 469,
        ',', 395,
        '-', 465,
        '.', 546,
        '/', 477,
        ':', 531,
        ';', 515,
        '<', 506,
        '=', 322,
        '>', 494,
        '?', 532,
        '[', 521,
        '\\', 60,
        ']', 525,
        '^', 486,
        '{', 519,
        '|', 485,
        '}', 520,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(239);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 240:
      ADVANCE_MAP(
        '!', 321,
        '#', 345,
        '%', 479,
        '&', 489,
        '(', 454,
        ')', 396,
        '*', 475,
        '+', 469,
        ',', 395,
        '-', 465,
        '.', 546,
        '/', 477,
        ':', 530,
        ';', 515,
        '<', 506,
        '=', 322,
        '>', 494,
        '?', 532,
        '[', 521,
        '\\', 48,
        ']', 525,
        '^', 486,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 659,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        'u', 652,
        'v', 664,
        '{', 519,
        '|', 485,
        '}', 520,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(240);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 241:
      ADVANCE_MAP(
        '!', 321,
        '#', 345,
        '%', 479,
        '&', 489,
        '(', 454,
        ')', 396,
        '*', 475,
        '+', 469,
        ',', 395,
        '-', 465,
        '.', 546,
        '/', 477,
        ':', 530,
        ';', 515,
        '<', 506,
        '=', 322,
        '>', 494,
        '?', 532,
        '[', 521,
        '\\', 125,
        ']', 525,
        '^', 486,
        '{', 519,
        '|', 485,
        '}', 520,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(241);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 242:
      ADVANCE_MAP(
        '!', 321,
        '#', 345,
        '%', 479,
        '&', 489,
        '(', 454,
        ')', 396,
        '*', 475,
        '+', 469,
        ',', 395,
        '-', 465,
        '.', 546,
        '/', 477,
        ':', 530,
        ';', 515,
        '<', 506,
        '=', 322,
        '>', 494,
        '?', 532,
        '[', 521,
        '\\', 159,
        ']', 525,
        '^', 486,
        '|', 485,
        '}', 520,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(243);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 243:
      ADVANCE_MAP(
        '!', 321,
        '#', 345,
        '%', 479,
        '&', 489,
        '(', 454,
        ')', 396,
        '*', 475,
        '+', 469,
        ',', 395,
        '-', 465,
        '.', 546,
        '/', 477,
        ':', 530,
        ';', 515,
        '<', 506,
        '=', 322,
        '>', 494,
        '?', 532,
        '[', 521,
        '\\', 159,
        ']', 525,
        '^', 486,
        '|', 485,
        '}', 520,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(243);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 244:
      ADVANCE_MAP(
        '!', 321,
        '%', 480,
        '&', 490,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 463,
        '.', 546,
        '/', 478,
        ':', 531,
        ';', 515,
        '<', 502,
        '=', 527,
        '>', 495,
        '?', 532,
        '[', 521,
        '\\', 50,
        '^', 487,
        '{', 519,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(244);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 245:
      ADVANCE_MAP(
        '!', 321,
        '%', 480,
        '&', 490,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 463,
        '.', 546,
        '/', 478,
        ':', 530,
        '<', 502,
        '=', 527,
        '>', 495,
        '?', 532,
        '[', 521,
        '\\', 129,
        '^', 487,
        '{', 519,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(245);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 246:
      ADVANCE_MAP(
        '!', 321,
        '%', 480,
        '&', 490,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 463,
        '.', 546,
        '/', 478,
        '<', 502,
        '=', 527,
        '>', 495,
        '?', 532,
        '[', 523,
        '\\', 88,
        '^', 487,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(246);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 247:
      ADVANCE_MAP(
        '!', 321,
        '%', 480,
        '&', 490,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 463,
        '.', 546,
        '/', 478,
        '<', 502,
        '=', 527,
        '>', 495,
        '?', 532,
        '[', 521,
        '\\', 78,
        '^', 487,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 659,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        'u', 652,
        'v', 664,
        '{', 519,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(247);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 248:
      ADVANCE_MAP(
        '!', 321,
        '%', 480,
        '&', 490,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 463,
        '.', 546,
        '/', 478,
        '<', 502,
        '=', 527,
        '>', 495,
        '?', 532,
        '[', 521,
        '\\', 145,
        '^', 487,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(249);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 249:
      ADVANCE_MAP(
        '!', 321,
        '%', 480,
        '&', 490,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 463,
        '.', 546,
        '/', 478,
        '<', 502,
        '=', 527,
        '>', 495,
        '?', 532,
        '[', 521,
        '\\', 145,
        '^', 487,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(249);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 250:
      ADVANCE_MAP(
        '!', 321,
        '%', 480,
        '&', 490,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 463,
        '.', 546,
        '/', 478,
        '<', 502,
        '=', 527,
        '>', 495,
        '?', 532,
        '[', 524,
        '\\', 163,
        '^', 487,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(250);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 251:
      ADVANCE_MAP(
        '!', 321,
        '%', 480,
        '&', 490,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        ':', 531,
        '<', 502,
        '=', 527,
        '>', 694,
        '?', 532,
        '[', 521,
        '\\', 52,
        '^', 487,
        '{', 519,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(251);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 252:
      ADVANCE_MAP(
        '!', 321,
        '%', 480,
        '&', 490,
        '(', 454,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        ':', 531,
        '<', 502,
        '=', 527,
        '>', 496,
        '?', 532,
        '[', 521,
        '\\', 171,
        '^', 487,
        '{', 519,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(252);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 253:
      ADVANCE_MAP(
        '!', 321,
        '%', 480,
        '&', 490,
        '(', 454,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        ':', 530,
        '<', 502,
        '=', 527,
        '>', 694,
        '?', 532,
        '[', 521,
        '\\', 177,
        '^', 487,
        '{', 519,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(253);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 254:
      ADVANCE_MAP(
        '!', 321,
        '%', 480,
        '&', 490,
        '(', 454,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        ':', 530,
        '<', 502,
        '=', 527,
        '>', 496,
        '?', 532,
        '[', 521,
        '\\', 155,
        '^', 487,
        '{', 519,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(254);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 255:
      ADVANCE_MAP(
        '!', 321,
        '%', 480,
        '&', 490,
        '(', 454,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        ';', 515,
        '<', 502,
        '=', 527,
        '>', 495,
        '?', 532,
        '[', 523,
        '\\', 86,
        '^', 487,
        '|', 484,
        '}', 520,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(255);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 256:
      ADVANCE_MAP(
        '!', 321,
        '%', 480,
        '&', 490,
        '(', 454,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        '<', 502,
        '=', 527,
        '>', 694,
        '?', 532,
        '[', 522,
        '\\', 82,
        '^', 487,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(256);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 257:
      ADVANCE_MAP(
        '!', 321,
        '%', 480,
        '&', 490,
        '(', 454,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        '<', 502,
        '=', 527,
        '>', 694,
        '?', 532,
        '[', 521,
        '\\', 135,
        '^', 487,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 659,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        'u', 652,
        'v', 664,
        '{', 519,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(257);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 258:
      ADVANCE_MAP(
        '!', 321,
        '%', 480,
        '&', 490,
        '(', 454,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        '<', 502,
        '=', 527,
        '>', 694,
        '?', 532,
        '[', 521,
        '\\', 175,
        '^', 487,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(259);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 259:
      ADVANCE_MAP(
        '!', 321,
        '%', 480,
        '&', 490,
        '(', 454,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        '<', 502,
        '=', 527,
        '>', 694,
        '?', 532,
        '[', 521,
        '\\', 175,
        '^', 487,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(259);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 260:
      ADVANCE_MAP(
        '!', 321,
        '%', 480,
        '&', 490,
        '(', 454,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        '<', 502,
        '=', 527,
        '>', 694,
        '?', 532,
        '[', 524,
        '\\', 179,
        '^', 487,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(260);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 261:
      ADVANCE_MAP(
        '!', 321,
        '%', 480,
        '&', 490,
        '(', 454,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        '<', 502,
        '=', 527,
        '>', 496,
        '?', 532,
        '[', 522,
        '\\', 143,
        '^', 487,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(261);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 262:
      ADVANCE_MAP(
        '!', 321,
        '%', 480,
        '&', 490,
        '(', 454,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        '<', 502,
        '=', 527,
        '>', 496,
        '?', 532,
        '[', 521,
        '\\', 153,
        '^', 487,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 659,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        'u', 652,
        'v', 664,
        '{', 519,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(262);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 263:
      ADVANCE_MAP(
        '!', 321,
        '%', 480,
        '&', 490,
        '(', 454,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        '<', 502,
        '=', 527,
        '>', 496,
        '?', 532,
        '[', 521,
        '\\', 161,
        '^', 487,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 264:
      ADVANCE_MAP(
        '!', 321,
        '%', 480,
        '&', 490,
        '(', 454,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        '<', 502,
        '=', 527,
        '>', 496,
        '?', 532,
        '[', 521,
        '\\', 161,
        '^', 487,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(264);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 265:
      ADVANCE_MAP(
        '!', 321,
        '%', 480,
        '&', 490,
        '(', 454,
        '*', 476,
        '+', 472,
        ',', 395,
        '-', 464,
        '.', 546,
        '/', 478,
        '<', 502,
        '=', 527,
        '>', 496,
        '?', 532,
        '[', 524,
        '\\', 183,
        '^', 487,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(265);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 266:
      ADVANCE_MAP(
        '!', 321,
        '%', 480,
        '&', 490,
        '*', 476,
        '+', 474,
        ',', 395,
        '-', 467,
        '.', 300,
        '/', 478,
        '<', 505,
        '=', 527,
        '>', 495,
        '\\', 94,
        '^', 487,
        '|', 484,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(266);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 267:
      ADVANCE_MAP(
        '!', 321,
        '%', 479,
        '&', 489,
        '(', 454,
        ')', 396,
        '*', 475,
        '+', 469,
        ',', 395,
        '-', 465,
        '.', 546,
        '/', 477,
        ':', 531,
        ';', 515,
        '<', 506,
        '=', 527,
        '>', 494,
        '?', 532,
        '[', 522,
        '\\', 38,
        '^', 486,
        '{', 519,
        '|', 485,
        '}', 520,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(267);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 268:
      ADVANCE_MAP(
        '!', 321,
        '%', 479,
        '&', 489,
        '(', 454,
        ')', 396,
        '*', 475,
        '+', 469,
        ',', 395,
        '-', 465,
        '.', 546,
        '/', 477,
        ':', 531,
        ';', 515,
        '<', 506,
        '=', 322,
        '>', 494,
        '?', 532,
        '[', 521,
        '\\', 54,
        ']', 525,
        '^', 486,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 659,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        'u', 652,
        'v', 664,
        '{', 519,
        '|', 485,
        '}', 520,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(268);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 269:
      ADVANCE_MAP(
        '!', 321,
        '%', 479,
        '&', 489,
        '(', 454,
        ')', 396,
        '*', 475,
        '+', 469,
        ',', 395,
        '-', 465,
        '.', 546,
        '/', 477,
        ':', 317,
        ';', 515,
        '<', 506,
        '=', 322,
        '>', 494,
        '?', 532,
        '[', 521,
        '\\', 131,
        ']', 335,
        '^', 486,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 659,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        'u', 652,
        'v', 664,
        '{', 519,
        '|', 485,
        '}', 520,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(269);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 270:
      ADVANCE_MAP(
        '!', 321,
        '%', 479,
        '&', 489,
        '(', 454,
        '*', 475,
        '+', 469,
        ',', 395,
        '-', 465,
        '.', 546,
        '/', 477,
        ':', 531,
        '<', 506,
        '=', 322,
        '>', 694,
        '?', 532,
        '[', 521,
        '\\', 137,
        '^', 486,
        '{', 519,
        '|', 485,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(270);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 271:
      ADVANCE_MAP(
        '!', 321,
        '%', 479,
        '&', 489,
        '(', 454,
        '*', 475,
        '+', 469,
        ',', 395,
        '-', 465,
        '.', 546,
        '/', 477,
        ':', 531,
        '<', 506,
        '=', 322,
        '>', 497,
        '?', 532,
        '[', 521,
        '\\', 181,
        '^', 486,
        '{', 519,
        '|', 485,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(271);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 272:
      ADVANCE_MAP(
        '!', 321,
        '%', 479,
        '&', 489,
        '(', 454,
        '*', 475,
        '+', 469,
        ',', 395,
        '-', 465,
        '.', 546,
        '/', 477,
        ':', 530,
        '<', 506,
        '=', 322,
        '>', 694,
        '?', 532,
        '[', 521,
        '\\', 66,
        '^', 486,
        '{', 519,
        '|', 485,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(272);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 273:
      ADVANCE_MAP(
        '!', 321,
        '%', 479,
        '&', 489,
        '(', 454,
        '*', 475,
        '+', 469,
        ',', 395,
        '-', 465,
        '.', 546,
        '/', 477,
        ':', 530,
        '<', 506,
        '=', 322,
        '>', 497,
        '?', 532,
        '[', 521,
        '\\', 185,
        '^', 486,
        '{', 519,
        '|', 485,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(273);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 274:
      ADVANCE_MAP(
        '!', 321,
        '%', 479,
        '&', 489,
        '(', 454,
        '*', 475,
        '+', 469,
        ',', 395,
        '-', 465,
        '.', 546,
        '/', 477,
        '<', 506,
        '=', 322,
        '>', 694,
        '?', 532,
        '[', 521,
        '\\', 64,
        '^', 486,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 659,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        'u', 652,
        'v', 664,
        '{', 519,
        '|', 485,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(274);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 275:
      ADVANCE_MAP(
        '!', 321,
        '%', 479,
        '&', 489,
        '(', 454,
        '*', 475,
        '+', 469,
        ',', 395,
        '-', 465,
        '.', 546,
        '/', 477,
        '<', 506,
        '=', 322,
        '>', 694,
        '?', 532,
        '[', 521,
        '\\', 189,
        '^', 486,
        '|', 485,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(276);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 276:
      ADVANCE_MAP(
        '!', 321,
        '%', 479,
        '&', 489,
        '(', 454,
        '*', 475,
        '+', 469,
        ',', 395,
        '-', 465,
        '.', 546,
        '/', 477,
        '<', 506,
        '=', 322,
        '>', 694,
        '?', 532,
        '[', 521,
        '\\', 189,
        '^', 486,
        '|', 485,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(276);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 277:
      ADVANCE_MAP(
        '!', 321,
        '%', 479,
        '&', 489,
        '(', 454,
        '*', 475,
        '+', 469,
        ',', 395,
        '-', 465,
        '.', 546,
        '/', 477,
        '<', 506,
        '=', 322,
        '>', 497,
        '?', 532,
        '[', 521,
        '\\', 169,
        '^', 486,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 659,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        'u', 652,
        'v', 664,
        '{', 519,
        '|', 485,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(277);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 278:
      ADVANCE_MAP(
        '!', 321,
        '%', 479,
        '&', 489,
        '(', 454,
        '*', 475,
        '+', 469,
        ',', 395,
        '-', 465,
        '.', 546,
        '/', 477,
        '<', 506,
        '=', 322,
        '>', 497,
        '?', 532,
        '[', 521,
        '\\', 187,
        '^', 486,
        '|', 485,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(279);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 279:
      ADVANCE_MAP(
        '!', 321,
        '%', 479,
        '&', 489,
        '(', 454,
        '*', 475,
        '+', 469,
        ',', 395,
        '-', 465,
        '.', 546,
        '/', 477,
        '<', 506,
        '=', 322,
        '>', 497,
        '?', 532,
        '[', 521,
        '\\', 187,
        '^', 486,
        '|', 485,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(279);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 280:
      ADVANCE_MAP(
        '"', 581,
        '&', 489,
        '(', 454,
        '*', 475,
        '/', 301,
        ':', 317,
        'L', 597,
        'U', 601,
        '[', 522,
        '\\', 68,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 659,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        'u', 604,
        'v', 664,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(280);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 281:
      ADVANCE_MAP(
        '"', 581,
        ')', 396,
        ',', 395,
        '/', 301,
        ':', 530,
        'L', 596,
        'R', 598,
        'U', 600,
        '\\', 103,
        'u', 603,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(281);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 282:
      if (lookahead == '"') ADVANCE(581);
      if (lookahead == '/') ADVANCE(301);
      if (lookahead == '<') ADVANCE(328);
      if (lookahead == 'L') ADVANCE(597);
      if (lookahead == 'U') ADVANCE(601);
      if (lookahead == '\\') ADVANCE(107);
      if (lookahead == 'u') ADVANCE(605);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(282);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 283:
      if (lookahead == '"') ADVANCE(581);
      if (lookahead == '/') ADVANCE(301);
      if (lookahead == '\\') ADVANCE(109);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(283);
      END_STATE();
    case 284:
      if (lookahead == '"') ADVANCE(705);
      END_STATE();
    case 285:
      ADVANCE_MAP(
        '#', 345,
        '&', 489,
        '(', 454,
        ')', 396,
        '*', 475,
        ',', 395,
        '-', 327,
        '.', 306,
        '/', 301,
        ':', 531,
        ';', 515,
        '<', 501,
        '=', 526,
        '>', 694,
        '[', 522,
        '\\', 56,
        '{', 519,
        '|', 359,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(285);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 286:
      ADVANCE_MAP(
        '#', 337,
        '&', 489,
        '(', 454,
        ')', 396,
        '*', 475,
        '+', 468,
        ',', 395,
        '-', 327,
        '.', 306,
        '/', 301,
        ':', 531,
        ';', 515,
        '<', 501,
        '=', 526,
        '>', 694,
        '[', 522,
        '\\', 16,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 659,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        'u', 652,
        'v', 664,
        '{', 519,
        '|', 359,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(286);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 287:
      ADVANCE_MAP(
        '#', 339,
        '&', 489,
        '(', 454,
        '*', 475,
        ',', 395,
        '/', 301,
        ':', 317,
        ';', 515,
        '[', 522,
        '\\', 24,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 659,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        'u', 652,
        'v', 664,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(287);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 288:
      ADVANCE_MAP(
        '&', 489,
        '(', 454,
        ')', 396,
        '*', 475,
        ',', 395,
        '-', 327,
        '.', 306,
        '/', 301,
        ':', 531,
        ';', 515,
        '<', 501,
        '=', 526,
        '>', 694,
        '[', 521,
        '\\', 62,
        '{', 519,
        '|', 359,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(288);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 289:
      ADVANCE_MAP(
        '&', 489,
        '(', 454,
        ')', 396,
        '*', 475,
        ',', 395,
        '-', 327,
        '.', 306,
        '/', 301,
        ':', 530,
        ';', 515,
        '<', 501,
        '=', 526,
        '>', 694,
        '[', 522,
        '\\', 76,
        '{', 519,
        '|', 359,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(289);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 290:
      ADVANCE_MAP(
        '&', 489,
        '(', 454,
        ')', 396,
        '*', 475,
        ',', 395,
        '.', 306,
        '/', 301,
        ':', 530,
        ';', 515,
        '=', 526,
        '>', 694,
        '[', 521,
        '\\', 92,
        '{', 519,
        '|', 359,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(290);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 291:
      ADVANCE_MAP(
        '&', 489,
        '(', 454,
        ')', 396,
        '*', 475,
        ',', 395,
        '/', 301,
        ':', 530,
        ';', 515,
        '<', 501,
        '=', 526,
        '>', 694,
        '[', 522,
        '\\', 74,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 659,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        'u', 652,
        'v', 664,
        '{', 519,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(291);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 292:
      ADVANCE_MAP(
        '&', 489,
        '(', 454,
        ')', 396,
        '*', 475,
        ',', 395,
        '/', 301,
        ';', 515,
        '=', 526,
        '>', 694,
        '[', 521,
        '\\', 90,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 659,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        'u', 652,
        'v', 664,
        '{', 519,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(292);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 293:
      if (lookahead == '\'') ADVANCE(572);
      if (lookahead == '/') ADVANCE(301);
      if (lookahead == '\\') ADVANCE(109);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(293);
      END_STATE();
    case 294:
      if (lookahead == '\'') ADVANCE(370);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(360);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(294);
      END_STATE();
    case 295:
      if (lookahead == '\'') ADVANCE(366);
      if (lookahead == '.') ADVANCE(561);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(360);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(295);
      END_STATE();
    case 296:
      ADVANCE_MAP(
        '(', 454,
        ')', 396,
        ',', 395,
        '/', 301,
        ':', 530,
        ';', 515,
        '<', 501,
        '=', 526,
        '>', 694,
        '[', 523,
        '\\', 105,
        '{', 519,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(296);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 297:
      ADVANCE_MAP(
        '(', 454,
        '/', 301,
        ':', 317,
        'F', 621,
        'T', 625,
        '[', 521,
        '\\', 96,
        'f', 631,
        't', 672,
        '{', 519,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(297);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 298:
      if (lookahead == '(') ADVANCE(454);
      if (lookahead == '/') ADVANCE(301);
      if (lookahead == '\\') SKIP(117);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(298);
      END_STATE();
    case 299:
      if (lookahead == ')') ADVANCE(703);
      END_STATE();
    case 300:
      if (lookahead == '*') ADVANCE(549);
      END_STATE();
    case 301:
      if (lookahead == '*') ADVANCE(304);
      if (lookahead == '/') ADVANCE(692);
      END_STATE();
    case 302:
      if (lookahead == '*') ADVANCE(702);
      END_STATE();
    case 303:
      if (lookahead == '*') ADVANCE(303);
      if (lookahead == '/') ADVANCE(685);
      if (lookahead != 0) ADVANCE(304);
      END_STATE();
    case 304:
      if (lookahead == '*') ADVANCE(303);
      if (lookahead != 0) ADVANCE(304);
      END_STATE();
    case 305:
      if (lookahead == '*') ADVANCE(303);
      if (lookahead != 0) ADVANCE(412);
      END_STATE();
    case 306:
      if (lookahead == '.') ADVANCE(308);
      END_STATE();
    case 307:
      if (lookahead == '.') ADVANCE(308);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(553);
      END_STATE();
    case 308:
      if (lookahead == '.') ADVANCE(394);
      END_STATE();
    case 309:
      if (lookahead == '.') ADVANCE(370);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(559);
      END_STATE();
    case 310:
      if (lookahead == '/') ADVANCE(419);
      if (lookahead == '\\') ADVANCE(414);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(310);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 311:
      if (lookahead == '1') ADVANCE(315);
      END_STATE();
    case 312:
      if (lookahead == '2') ADVANCE(552);
      END_STATE();
    case 313:
      if (lookahead == '2') ADVANCE(316);
      if (lookahead == '6') ADVANCE(552);
      END_STATE();
    case 314:
      if (lookahead == '4') ADVANCE(552);
      END_STATE();
    case 315:
      if (lookahead == '6') ADVANCE(552);
      END_STATE();
    case 316:
      if (lookahead == '8') ADVANCE(552);
      END_STATE();
    case 317:
      if (lookahead == ':') ADVANCE(516);
      END_STATE();
    case 318:
      if (lookahead == '<') ADVANCE(716);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(318);
      END_STATE();
    case 319:
      if (lookahead == '<') ADVANCE(507);
      if (lookahead == '=') ADVANCE(499);
      END_STATE();
    case 320:
      if (lookahead == '<') ADVANCE(318);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(320);
      END_STATE();
    case 321:
      if (lookahead == '=') ADVANCE(492);
      END_STATE();
    case 322:
      if (lookahead == '=') ADVANCE(491);
      END_STATE();
    case 323:
      if (lookahead == '=') ADVANCE(498);
      if (lookahead == '>') ADVANCE(324);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(330);
      END_STATE();
    case 324:
      if (lookahead == '=') ADVANCE(539);
      if (lookahead == '>') ADVANCE(717);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(325);
      END_STATE();
    case 325:
      if (lookahead == '>') ADVANCE(717);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(325);
      END_STATE();
    case 326:
      if (lookahead == '>') ADVANCE(511);
      END_STATE();
    case 327:
      if (lookahead == '>') ADVANCE(550);
      END_STATE();
    case 328:
      if (lookahead == '>') ADVANCE(591);
      if (lookahead == '\\') ADVANCE(329);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(328);
      END_STATE();
    case 329:
      if (lookahead == '>') ADVANCE(592);
      if (lookahead == '\\') ADVANCE(329);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(328);
      END_STATE();
    case 330:
      if (lookahead == '>') ADVANCE(325);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(330);
      END_STATE();
    case 331:
      if (lookahead == 'F') ADVANCE(311);
      END_STATE();
    case 332:
      if (lookahead == 'U') ADVANCE(384);
      if (lookahead == 'u') ADVANCE(376);
      END_STATE();
    case 333:
      if (lookahead == '[') ADVANCE(517);
      if (lookahead == ']') ADVANCE(704);
      END_STATE();
    case 334:
      if (lookahead == ']') ADVANCE(704);
      END_STATE();
    case 335:
      if (lookahead == ']') ADVANCE(518);
      END_STATE();
    case 336:
      if (lookahead == 'd') ADVANCE(428);
      if (lookahead == 'e') ADVANCE(448);
      if (lookahead == 'i') ADVANCE(436);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(336);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 337:
      if (lookahead == 'd') ADVANCE(428);
      if (lookahead == 'e') ADVANCE(448);
      if (lookahead == 'i') ADVANCE(437);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(337);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 338:
      if (lookahead == 'd') ADVANCE(428);
      if (lookahead == 'e') ADVANCE(450);
      if (lookahead == 'i') ADVANCE(436);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(338);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 339:
      if (lookahead == 'd') ADVANCE(428);
      if (lookahead == 'e') ADVANCE(450);
      if (lookahead == 'i') ADVANCE(437);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(339);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 340:
      if (lookahead == 'd') ADVANCE(428);
      if (lookahead == 'i') ADVANCE(436);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(340);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 341:
      if (lookahead == 'd') ADVANCE(428);
      if (lookahead == 'i') ADVANCE(437);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(341);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 342:
      if (lookahead == 'd') ADVANCE(354);
      END_STATE();
    case 343:
      if (lookahead == 'd') ADVANCE(348);
      END_STATE();
    case 344:
      if (lookahead == 'e') ADVANCE(358);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(344);
      END_STATE();
    case 345:
      if (lookahead == 'e') ADVANCE(357);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(345);
      END_STATE();
    case 346:
      if (lookahead == 'e') ADVANCE(403);
      END_STATE();
    case 347:
      if (lookahead == 'e') ADVANCE(352);
      END_STATE();
    case 348:
      if (lookahead == 'e') ADVANCE(353);
      END_STATE();
    case 349:
      if (lookahead == 'f') ADVANCE(311);
      END_STATE();
    case 350:
      if (lookahead == 'f') ADVANCE(399);
      END_STATE();
    case 351:
      if (lookahead == 'f') ADVANCE(405);
      END_STATE();
    case 352:
      if (lookahead == 'f') ADVANCE(407);
      END_STATE();
    case 353:
      if (lookahead == 'f') ADVANCE(409);
      END_STATE();
    case 354:
      if (lookahead == 'i') ADVANCE(350);
      END_STATE();
    case 355:
      if (lookahead == 'i') ADVANCE(351);
      if (lookahead == 's') ADVANCE(346);
      END_STATE();
    case 356:
      if (lookahead == 'i') ADVANCE(437);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(356);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 357:
      if (lookahead == 'l') ADVANCE(355);
      if (lookahead == 'n') ADVANCE(342);
      END_STATE();
    case 358:
      if (lookahead == 'n') ADVANCE(342);
      END_STATE();
    case 359:
      if (lookahead == '|') ADVANCE(481);
      END_STATE();
    case 360:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(367);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(558);
      END_STATE();
    case 361:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(360);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(294);
      END_STATE();
    case 362:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(556);
      END_STATE();
    case 363:
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(295);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(555);
      END_STATE();
    case 364:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(557);
      END_STATE();
    case 365:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(553);
      END_STATE();
    case 366:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(295);
      END_STATE();
    case 367:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(558);
      END_STATE();
    case 368:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(684);
      END_STATE();
    case 369:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(559);
      END_STATE();
    case 370:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(294);
      END_STATE();
    case 371:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(587);
      END_STATE();
    case 372:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(368);
      END_STATE();
    case 373:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(371);
      END_STATE();
    case 374:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(372);
      END_STATE();
    case 375:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(373);
      END_STATE();
    case 376:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(374);
      END_STATE();
    case 377:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(375);
      END_STATE();
    case 378:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(376);
      END_STATE();
    case 379:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(377);
      END_STATE();
    case 380:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(378);
      END_STATE();
    case 381:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(379);
      END_STATE();
    case 382:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(380);
      END_STATE();
    case 383:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(381);
      END_STATE();
    case 384:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(382);
      END_STATE();
    case 385:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(383);
      END_STATE();
    case 386:
      if (lookahead != 0 &&
          lookahead != '*') ADVANCE(421);
      END_STATE();
    case 387:
      if (eof) ADVANCE(389);
      ADVANCE_MAP(
        '!', 456,
        '"', 581,
        '#', 336,
        '%', 480,
        '&', 490,
        '\'', 572,
        '(', 454,
        ')', 396,
        '*', 476,
        '+', 470,
        ',', 395,
        '-', 459,
        '.', 547,
        '/', 478,
        '0', 696,
        ':', 531,
        ';', 515,
        '<', 502,
        '=', 527,
        '>', 694,
        '?', 532,
        'F', 621,
        'L', 595,
        'R', 598,
        'T', 625,
        'U', 599,
        '[', 523,
        '\\', 2,
        ']', 525,
        '^', 487,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 630,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        't', 672,
        'u', 602,
        'v', 664,
        '{', 519,
        '|', 484,
        '}', 520,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(387);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(557);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 388:
      if (eof) ADVANCE(389);
      ADVANCE_MAP(
        '!', 455,
        '"', 581,
        '#', 340,
        '%', 479,
        '&', 489,
        '\'', 572,
        '(', 454,
        ')', 396,
        '*', 475,
        '+', 471,
        ',', 395,
        '-', 462,
        '.', 548,
        '/', 477,
        '0', 554,
        ':', 531,
        ';', 515,
        '<', 501,
        '=', 526,
        '>', 694,
        'F', 621,
        'L', 595,
        'R', 598,
        'T', 625,
        'U', 599,
        '[', 522,
        '\\', 4,
        ']', 335,
        '^', 486,
        'b', 667,
        'c', 646,
        'd', 663,
        'f', 630,
        'i', 660,
        'm', 632,
        'n', 680,
        'p', 677,
        's', 647,
        't', 672,
        'u', 602,
        'v', 664,
        '{', 519,
        '|', 359,
        '}', 520,
        '~', 457,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(388);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(557);
      if (set_contains(sym_identifier_character_set_1, 658, lookahead)) ADVANCE(684);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(aux_sym_preproc_include_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(aux_sym_preproc_include_token2);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(aux_sym_preproc_def_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(aux_sym_preproc_if_token1);
      if (lookahead == 'd') ADVANCE(432);
      if (lookahead == 'n') ADVANCE(426);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(398);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      if (lookahead == 'd') ADVANCE(347);
      if (lookahead == 'n') ADVANCE(343);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      if (lookahead == 'd') ADVANCE(434);
      if (lookahead == 'n') ADVANCE(427);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token1);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token2);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(304);
      if (lookahead == '*') ADVANCE(411);
      if (lookahead == '/') ADVANCE(685);
      if (lookahead == '\\') ADVANCE(417);
      if (lookahead != 0) ADVANCE(412);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(304);
      if (lookahead == '*') ADVANCE(411);
      if (lookahead == '/') ADVANCE(305);
      if (lookahead == '\\') ADVANCE(417);
      if (lookahead != 0) ADVANCE(412);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(692);
      if (lookahead == '\r') ADVANCE(686);
      if (lookahead == '/') ADVANCE(689);
      if (lookahead == '\\') ADVANCE(688);
      if (lookahead != 0) ADVANCE(690);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(310);
      if (lookahead == '\r') ADVANCE(415);
      if (lookahead == '/') ADVANCE(386);
      if (lookahead == '\\') ADVANCE(416);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(310);
      if (lookahead == '/') ADVANCE(386);
      if (lookahead == '\\') ADVANCE(416);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(422);
      if (lookahead == '/') ADVANCE(386);
      if (lookahead == '\\') ADVANCE(416);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(420);
      if (lookahead == '*') ADVANCE(411);
      if (lookahead == '/') ADVANCE(305);
      if (lookahead == '\\') ADVANCE(417);
      if (lookahead != 0) ADVANCE(412);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(691);
      if (lookahead == '/') ADVANCE(689);
      if (lookahead == '\\') ADVANCE(688);
      if (lookahead != 0) ADVANCE(690);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(412);
      if (lookahead == '/') ADVANCE(689);
      if (lookahead == '\\') ADVANCE(416);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(421);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(411);
      if (lookahead == '/') ADVANCE(305);
      if (lookahead == '\\') ADVANCE(417);
      if (lookahead != 0) ADVANCE(412);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(386);
      if (lookahead == '\\') ADVANCE(416);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(421);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(386);
      if (lookahead == '\\') ADVANCE(416);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'c') ADVANCE(449);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(447);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(431);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(433);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(435);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(438);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(404);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(392);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(390);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(441);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(442);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(443);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(444);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(397);
      if (lookahead == 'n') ADVANCE(423);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(397);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(445);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(406);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(400);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(401);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(402);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(408);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(410);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(451);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(439);
      if (lookahead == 's') ADVANCE(429);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(440);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(446);
      if (lookahead == 'n') ADVANCE(424);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(452);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n') ADVANCE(424);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n') ADVANCE(430);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'u') ADVANCE(425);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(453);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(492);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(544);
      if (lookahead == '.') ADVANCE(365);
      if (lookahead == '0') ADVANCE(554);
      if (lookahead == '=') ADVANCE(537);
      if (lookahead == '>') ADVANCE(551);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(557);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(544);
      if (lookahead == '.') ADVANCE(365);
      if (lookahead == '0') ADVANCE(554);
      if (lookahead == '=') ADVANCE(537);
      if (lookahead == '>') ADVANCE(550);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(557);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(544);
      if (lookahead == '.') ADVANCE(365);
      if (lookahead == '0') ADVANCE(554);
      if (lookahead == '>') ADVANCE(550);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(557);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(544);
      if (lookahead == '.') ADVANCE(365);
      if (lookahead == '0') ADVANCE(554);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(557);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(544);
      if (lookahead == '=') ADVANCE(537);
      if (lookahead == '>') ADVANCE(551);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(544);
      if (lookahead == '=') ADVANCE(537);
      if (lookahead == '>') ADVANCE(550);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(544);
      if (lookahead == '>') ADVANCE(550);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(365);
      if (lookahead == '0') ADVANCE(554);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(557);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(537);
      if (lookahead == '>') ADVANCE(302);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(545);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(545);
      if (lookahead == '.') ADVANCE(365);
      if (lookahead == '0') ADVANCE(554);
      if (lookahead == '=') ADVANCE(536);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(557);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(545);
      if (lookahead == '.') ADVANCE(365);
      if (lookahead == '0') ADVANCE(554);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(557);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(545);
      if (lookahead == '=') ADVANCE(536);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '.') ADVANCE(365);
      if (lookahead == '0') ADVANCE(554);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(557);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(536);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(533);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(304);
      if (lookahead == '/') ADVANCE(692);
      END_STATE();
    case 478:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(304);
      if (lookahead == '/') ADVANCE(692);
      if (lookahead == '=') ADVANCE(534);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(535);
      END_STATE();
    case 481:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(542);
      if (lookahead == '|') ADVANCE(481);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(481);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(541);
      END_STATE();
    case 488:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(482);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(482);
      if (lookahead == '=') ADVANCE(540);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(498);
      if (lookahead == '>') ADVANCE(511);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(498);
      if (lookahead == '>') ADVANCE(512);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(498);
      if (lookahead == '>') ADVANCE(513);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(330);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(498);
      if (lookahead == '>') ADVANCE(514);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(330);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '>') ADVANCE(543);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(508);
      if (lookahead == '=') ADVANCE(500);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(320);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(507);
      if (lookahead == '=') ADVANCE(499);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(510);
      if (lookahead == '=') ADVANCE(500);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(510);
      if (lookahead == '=') ADVANCE(499);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(509);
      if (lookahead == '=') ADVANCE(500);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(320);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '<') ADVANCE(716);
      if (lookahead == '=') ADVANCE(538);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(318);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '<') ADVANCE(716);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(318);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(538);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(539);
      END_STATE();
    case 513:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(539);
      if (lookahead == '>') ADVANCE(717);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(325);
      END_STATE();
    case 514:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(717);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(325);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[') ADVANCE(517);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[') ADVANCE(517);
      if (lookahead == ']') ADVANCE(704);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == ']') ADVANCE(704);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(491);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(sym_primitive_type);
      if (lookahead == '1') ADVANCE(620);
      if (lookahead == '3') ADVANCE(618);
      if (lookahead == '6') ADVANCE(619);
      if (lookahead == '8') ADVANCE(629);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'p') ADVANCE(678);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(sym_primitive_type);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(516);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 541:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 543:
      ACCEPT_TOKEN(anon_sym_LT_EQ_GT);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '*') ADVANCE(549);
      if (lookahead == '.') ADVANCE(308);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '*') ADVANCE(549);
      if (lookahead == '.') ADVANCE(308);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(553);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(308);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(553);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(anon_sym_DOT_STAR);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      if (lookahead == '*') ADVANCE(702);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(sym_number_literal);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 365,
        'B', 331,
        'b', 349,
        'E', 360,
        'e', 360,
        'F', 560,
        'f', 560,
        'L', 552,
        'l', 552,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(553);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 363,
        '.', 561,
        'L', 562,
        'l', 565,
        'B', 362,
        'b', 362,
        'E', 360,
        'e', 360,
        'U', 564,
        'u', 564,
        'X', 309,
        'x', 309,
        'Z', 567,
        'z', 567,
        '8', 295,
        '9', 295,
      );
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(555);
      END_STATE();
    case 555:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 363,
        '.', 561,
        'L', 562,
        'l', 565,
        'E', 360,
        'e', 360,
        'U', 564,
        'u', 564,
        'Z', 567,
        'z', 567,
        '8', 295,
        '9', 295,
      );
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(555);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 362,
        'L', 562,
        'l', 565,
        'U', 564,
        'u', 564,
        'Z', 567,
        'z', 567,
        '0', 556,
        '1', 556,
      );
      END_STATE();
    case 557:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 364,
        '.', 561,
        'L', 562,
        'l', 565,
        'E', 360,
        'e', 360,
        'U', 564,
        'u', 564,
        'Z', 567,
        'z', 567,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(557);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(367);
      if (lookahead == 'B') ADVANCE(331);
      if (lookahead == 'b') ADVANCE(349);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(560);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(552);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(558);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 369,
        '.', 361,
        'L', 562,
        'l', 565,
        'P', 360,
        'p', 360,
        'U', 564,
        'u', 564,
        'Z', 567,
        'z', 567,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(559);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '1') ADVANCE(313);
      if (lookahead == '3') ADVANCE(312);
      if (lookahead == '6') ADVANCE(314);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        'B', 331,
        'b', 349,
        'E', 360,
        'e', 360,
        'F', 560,
        'f', 560,
        'L', 552,
        'l', 552,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(553);
      END_STATE();
    case 562:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L') ADVANCE(567);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(552);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L') ADVANCE(552);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L') ADVANCE(563);
      if (lookahead == 'l') ADVANCE(566);
      if (lookahead == 'Z' ||
          lookahead == 'z') ADVANCE(552);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'l') ADVANCE(567);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(552);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'l') ADVANCE(552);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(552);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(anon_sym_L_SQUOTE);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(anon_sym_u_SQUOTE);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(anon_sym_U_SQUOTE);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(anon_sym_u8_SQUOTE);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      END_STATE();
    case 574:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '\n') ADVANCE(588);
      if (lookahead == '\r') ADVANCE(587);
      if (lookahead == 'U') ADVANCE(385);
      if (lookahead == 'u') ADVANCE(377);
      if (lookahead == 'x') ADVANCE(373);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(590);
      if (lookahead != 0) ADVANCE(587);
      END_STATE();
    case 575:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '*') ADVANCE(304);
      if (lookahead == '/') ADVANCE(692);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '\\') ADVANCE(109);
      END_STATE();
    case 577:
      ACCEPT_TOKEN(anon_sym_L_DQUOTE);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(anon_sym_u_DQUOTE);
      END_STATE();
    case 579:
      ACCEPT_TOKEN(anon_sym_U_DQUOTE);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(anon_sym_u8_DQUOTE);
      END_STATE();
    case 581:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 582:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(584);
      if (lookahead == '/') ADVANCE(586);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(586);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(583);
      if (lookahead == '/') ADVANCE(586);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(584);
      END_STATE();
    case 584:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(583);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(584);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '/') ADVANCE(582);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(585);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(586);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(586);
      END_STATE();
    case 587:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(109);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(587);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(589);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(sym_system_lib_string);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(sym_system_lib_string);
      if (lookahead == '>') ADVANCE(591);
      if (lookahead == '\\') ADVANCE(329);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(328);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(sym_true);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(sym_false);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(577);
      if (lookahead == '\'') ADVANCE(568);
      if (lookahead == 'R') ADVANCE(606);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(577);
      if (lookahead == 'R') ADVANCE(606);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(577);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(697);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(579);
      if (lookahead == '\'') ADVANCE(570);
      if (lookahead == 'R') ADVANCE(607);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 600:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(579);
      if (lookahead == 'R') ADVANCE(607);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 601:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(579);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 602:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(578);
      if (lookahead == '\'') ADVANCE(569);
      if (lookahead == '8') ADVANCE(608);
      if (lookahead == 'R') ADVANCE(611);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'i') ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(578);
      if (lookahead == '8') ADVANCE(609);
      if (lookahead == 'R') ADVANCE(611);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(578);
      if (lookahead == '8') ADVANCE(610);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'i') ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 605:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(578);
      if (lookahead == '8') ADVANCE(610);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 606:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(698);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 607:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(700);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 608:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(580);
      if (lookahead == '\'') ADVANCE(571);
      if (lookahead == 'R') ADVANCE(612);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 609:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(580);
      if (lookahead == 'R') ADVANCE(612);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 610:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(580);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 611:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(699);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 612:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(701);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 613:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(568);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 614:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(570);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 615:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(569);
      if (lookahead == '8') ADVANCE(616);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 616:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(571);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 617:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '1') ADVANCE(620);
      if (lookahead == '3') ADVANCE(618);
      if (lookahead == '6') ADVANCE(619);
      if (lookahead == '8') ADVANCE(629);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'p') ADVANCE(678);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 618:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '2') ADVANCE(629);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 619:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '4') ADVANCE(629);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 620:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '6') ADVANCE(629);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 621:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'A') ADVANCE(624);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 622:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'E') ADVANCE(593);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 623:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'E') ADVANCE(594);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 624:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'L') ADVANCE(626);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 625:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'R') ADVANCE(627);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 626:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'S') ADVANCE(623);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 627:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'U') ADVANCE(622);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 628:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == '_') ADVANCE(635);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 629:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == '_') ADVANCE(675);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 630:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'a') ADVANCE(653);
      if (lookahead == 'l') ADVANCE(665);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 631:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'a') ADVANCE(653);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 632:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'a') ADVANCE(682);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 633:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'a') ADVANCE(669);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 634:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'a') ADVANCE(675);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 635:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'a') ADVANCE(657);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 636:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'b') ADVANCE(658);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 637:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'd') ADVANCE(529);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 638:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'd') ADVANCE(649);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 639:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'e') ADVANCE(593);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 640:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'e') ADVANCE(529);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 641:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'e') ADVANCE(594);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 642:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'e') ADVANCE(629);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 643:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'f') ADVANCE(629);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 644:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'f') ADVANCE(643);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 645:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'g') ADVANCE(661);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 646:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'h') ADVANCE(633);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 647:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'i') ADVANCE(683);
      if (lookahead == 's') ADVANCE(648);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 648:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'i') ADVANCE(683);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 649:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'i') ADVANCE(644);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 650:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'i') ADVANCE(645);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 651:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'i') ADVANCE(637);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 652:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'i') ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 653:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'l') ADVANCE(673);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 654:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'l') ADVANCE(529);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 655:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'l') ADVANCE(668);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 656:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'l') ADVANCE(655);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 657:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'l') ADVANCE(650);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 658:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'l') ADVANCE(640);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 659:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'l') ADVANCE(665);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 660:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'n') ADVANCE(674);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 661:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'n') ADVANCE(629);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 662:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'n') ADVANCE(676);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 663:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'o') ADVANCE(679);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 664:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'o') ADVANCE(651);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 665:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'o') ADVANCE(634);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 666:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'o') ADVANCE(654);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 667:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'o') ADVANCE(666);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 668:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'p') ADVANCE(678);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 669:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'r') ADVANCE(528);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 670:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'r') ADVANCE(638);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 671:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'r') ADVANCE(629);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 672:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'r') ADVANCE(681);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 673:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 's') ADVANCE(641);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 674:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 't') ADVANCE(528);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 675:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 't') ADVANCE(529);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 676:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 't') ADVANCE(617);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 677:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 't') ADVANCE(670);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 678:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 't') ADVANCE(671);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 679:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(636);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 680:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(656);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 681:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(639);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 682:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'x') ADVANCE(628);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 683:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (lookahead == 'z') ADVANCE(642);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 684:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(332);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 685:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 686:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n') ADVANCE(692);
      if (lookahead == '/') ADVANCE(689);
      if (lookahead == '\\') ADVANCE(418);
      if (lookahead != 0) ADVANCE(690);
      END_STATE();
    case 687:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\r') ADVANCE(693);
      if (lookahead == '\\') ADVANCE(687);
      if (lookahead != 0) ADVANCE(692);
      END_STATE();
    case 688:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\r') ADVANCE(691);
      if (lookahead == '/') ADVANCE(689);
      if (lookahead == '\\') ADVANCE(688);
      if (lookahead != 0) ADVANCE(690);
      END_STATE();
    case 689:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '*') ADVANCE(692);
      if (lookahead == '\\') ADVANCE(413);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(690);
      END_STATE();
    case 690:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(689);
      if (lookahead == '\\') ADVANCE(418);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(690);
      END_STATE();
    case 691:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(689);
      if (lookahead == '\\') ADVANCE(418);
      if (lookahead != 0) ADVANCE(690);
      END_STATE();
    case 692:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(190);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(692);
      END_STATE();
    case 693:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(190);
      if (lookahead != 0) ADVANCE(692);
      END_STATE();
    case 694:
      ACCEPT_TOKEN(anon_sym_GT2);
      END_STATE();
    case 695:
      ACCEPT_TOKEN(anon_sym_0);
      END_STATE();
    case 696:
      ACCEPT_TOKEN(anon_sym_0);
      ADVANCE_MAP(
        '\'', 363,
        '.', 561,
        'L', 562,
        'l', 565,
        'B', 362,
        'b', 362,
        'E', 360,
        'e', 360,
        'U', 564,
        'u', 564,
        'X', 309,
        'x', 309,
        'Z', 567,
        'z', 567,
        '8', 295,
        '9', 295,
      );
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(555);
      END_STATE();
    case 697:
      ACCEPT_TOKEN(anon_sym_R_DQUOTE);
      END_STATE();
    case 698:
      ACCEPT_TOKEN(anon_sym_LR_DQUOTE);
      END_STATE();
    case 699:
      ACCEPT_TOKEN(anon_sym_uR_DQUOTE);
      END_STATE();
    case 700:
      ACCEPT_TOKEN(anon_sym_UR_DQUOTE);
      END_STATE();
    case 701:
      ACCEPT_TOKEN(anon_sym_u8R_DQUOTE);
      END_STATE();
    case 702:
      ACCEPT_TOKEN(anon_sym_DASH_GT_STAR);
      END_STATE();
    case 703:
      ACCEPT_TOKEN(anon_sym_LPAREN_RPAREN);
      END_STATE();
    case 704:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK);
      END_STATE();
    case 705:
      ACCEPT_TOKEN(anon_sym_DQUOTE_DQUOTE);
      END_STATE();
    case 706:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(577);
      if (lookahead == 'R') ADVANCE(710);
      if (lookahead == '\\') ADVANCE(332);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 707:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(697);
      if (lookahead == '\\') ADVANCE(332);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 708:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(579);
      if (lookahead == 'R') ADVANCE(711);
      if (lookahead == '\\') ADVANCE(332);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 709:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(578);
      if (lookahead == '8') ADVANCE(712);
      if (lookahead == 'R') ADVANCE(713);
      if (lookahead == '\\') ADVANCE(332);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 710:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(698);
      if (lookahead == '\\') ADVANCE(332);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 711:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(700);
      if (lookahead == '\\') ADVANCE(332);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 712:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(580);
      if (lookahead == 'R') ADVANCE(714);
      if (lookahead == '\\') ADVANCE(332);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 713:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(699);
      if (lookahead == '\\') ADVANCE(332);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 714:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(701);
      if (lookahead == '\\') ADVANCE(332);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 715:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '\\') ADVANCE(332);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(715);
      if (set_contains(sym_identifier_character_set_2, 765, lookahead)) ADVANCE(684);
      END_STATE();
    case 716:
      ACCEPT_TOKEN(aux_sym_kernel_call_syntax_token1);
      END_STATE();
    case 717:
      ACCEPT_TOKEN(aux_sym_kernel_call_syntax_token2);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'N') ADVANCE(1);
      if (lookahead == '\\') SKIP(2);
      if (lookahead == '_') ADVANCE(3);
      if (lookahead == 'a') ADVANCE(4);
      if (lookahead == 'b') ADVANCE(5);
      if (lookahead == 'c') ADVANCE(6);
      if (lookahead == 'd') ADVANCE(7);
      if (lookahead == 'e') ADVANCE(8);
      if (lookahead == 'f') ADVANCE(9);
      if (lookahead == 'g') ADVANCE(10);
      if (lookahead == 'i') ADVANCE(11);
      if (lookahead == 'l') ADVANCE(12);
      if (lookahead == 'm') ADVANCE(13);
      if (lookahead == 'n') ADVANCE(14);
      if (lookahead == 'o') ADVANCE(15);
      if (lookahead == 'p') ADVANCE(16);
      if (lookahead == 'r') ADVANCE(17);
      if (lookahead == 's') ADVANCE(18);
      if (lookahead == 't') ADVANCE(19);
      if (lookahead == 'u') ADVANCE(20);
      if (lookahead == 'v') ADVANCE(21);
      if (lookahead == 'w') ADVANCE(22);
      if (lookahead == 'x') ADVANCE(23);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'U') ADVANCE(24);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(0);
      if (lookahead == '\r') SKIP(25);
      END_STATE();
    case 3:
      if (lookahead == 'A') ADVANCE(26);
      if (lookahead == 'G') ADVANCE(27);
      if (lookahead == 'N') ADVANCE(28);
      if (lookahead == '_') ADVANCE(29);
      if (lookahead == 'a') ADVANCE(30);
      if (lookahead == 'u') ADVANCE(31);
      END_STATE();
    case 4:
      if (lookahead == 'l') ADVANCE(32);
      if (lookahead == 'n') ADVANCE(33);
      if (lookahead == 's') ADVANCE(34);
      if (lookahead == 'u') ADVANCE(35);
      END_STATE();
    case 5:
      if (lookahead == 'i') ADVANCE(36);
      if (lookahead == 'r') ADVANCE(37);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(38);
      if (lookahead == 'l') ADVANCE(39);
      if (lookahead == 'o') ADVANCE(40);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(41);
      if (lookahead == 'o') ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'l') ADVANCE(43);
      if (lookahead == 'n') ADVANCE(44);
      if (lookahead == 'x') ADVANCE(45);
      END_STATE();
    case 9:
      if (lookahead == 'i') ADVANCE(46);
      if (lookahead == 'o') ADVANCE(47);
      if (lookahead == 'r') ADVANCE(48);
      END_STATE();
    case 10:
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 11:
      if (lookahead == 'f') ADVANCE(50);
      if (lookahead == 'n') ADVANCE(51);
      END_STATE();
    case 12:
      if (lookahead == 'o') ADVANCE(52);
      END_STATE();
    case 13:
      if (lookahead == 'u') ADVANCE(53);
      END_STATE();
    case 14:
      if (lookahead == 'a') ADVANCE(54);
      if (lookahead == 'e') ADVANCE(55);
      if (lookahead == 'o') ADVANCE(56);
      if (lookahead == 'u') ADVANCE(57);
      END_STATE();
    case 15:
      if (lookahead == 'f') ADVANCE(58);
      if (lookahead == 'p') ADVANCE(59);
      if (lookahead == 'r') ADVANCE(60);
      if (lookahead == 'v') ADVANCE(61);
      END_STATE();
    case 16:
      if (lookahead == 'r') ADVANCE(62);
      if (lookahead == 'u') ADVANCE(63);
      END_STATE();
    case 17:
      if (lookahead == 'e') ADVANCE(64);
      END_STATE();
    case 18:
      if (lookahead == 'h') ADVANCE(65);
      if (lookahead == 'i') ADVANCE(66);
      if (lookahead == 't') ADVANCE(67);
      if (lookahead == 'w') ADVANCE(68);
      END_STATE();
    case 19:
      if (lookahead == 'e') ADVANCE(69);
      if (lookahead == 'h') ADVANCE(70);
      if (lookahead == 'r') ADVANCE(71);
      if (lookahead == 'y') ADVANCE(72);
      END_STATE();
    case 20:
      if (lookahead == 'n') ADVANCE(73);
      if (lookahead == 's') ADVANCE(74);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(75);
      if (lookahead == 'o') ADVANCE(76);
      END_STATE();
    case 22:
      if (lookahead == 'h') ADVANCE(77);
      END_STATE();
    case 23:
      if (lookahead == 'o') ADVANCE(78);
      END_STATE();
    case 24:
      if (lookahead == 'L') ADVANCE(79);
      END_STATE();
    case 25:
      if (lookahead == '\n') SKIP(0);
      END_STATE();
    case 26:
      if (lookahead == 'l') ADVANCE(80);
      if (lookahead == 't') ADVANCE(81);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(82);
      END_STATE();
    case 28:
      if (lookahead == 'o') ADVANCE(83);
      END_STATE();
    case 29:
      ADVANCE_MAP(
        'a', 84,
        'b', 85,
        'c', 86,
        'd', 87,
        'e', 88,
        'f', 89,
        'g', 90,
        'h', 91,
        'i', 92,
        'l', 93,
        'm', 94,
        'n', 95,
        'r', 96,
        's', 97,
        't', 98,
        'u', 99,
        'v', 100,
      );
      END_STATE();
    case 30:
      if (lookahead == 'l') ADVANCE(101);
      END_STATE();
    case 31:
      if (lookahead == 'n') ADVANCE(102);
      END_STATE();
    case 32:
      if (lookahead == 'i') ADVANCE(103);
      END_STATE();
    case 33:
      if (lookahead == 'd') ADVANCE(104);
      END_STATE();
    case 34:
      if (lookahead == 'm') ADVANCE(105);
      END_STATE();
    case 35:
      if (lookahead == 't') ADVANCE(106);
      END_STATE();
    case 36:
      if (lookahead == 't') ADVANCE(107);
      END_STATE();
    case 37:
      if (lookahead == 'e') ADVANCE(108);
      END_STATE();
    case 38:
      if (lookahead == 's') ADVANCE(109);
      if (lookahead == 't') ADVANCE(110);
      END_STATE();
    case 39:
      if (lookahead == 'a') ADVANCE(111);
      END_STATE();
    case 40:
      if (lookahead == '_') ADVANCE(112);
      if (lookahead == 'm') ADVANCE(113);
      if (lookahead == 'n') ADVANCE(114);
      END_STATE();
    case 41:
      if (lookahead == 'c') ADVANCE(115);
      if (lookahead == 'f') ADVANCE(116);
      if (lookahead == 'l') ADVANCE(117);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 43:
      if (lookahead == 's') ADVANCE(118);
      END_STATE();
    case 44:
      if (lookahead == 'u') ADVANCE(119);
      END_STATE();
    case 45:
      if (lookahead == 'p') ADVANCE(120);
      if (lookahead == 't') ADVANCE(121);
      END_STATE();
    case 46:
      if (lookahead == 'n') ADVANCE(122);
      END_STATE();
    case 47:
      if (lookahead == 'r') ADVANCE(123);
      END_STATE();
    case 48:
      if (lookahead == 'i') ADVANCE(124);
      END_STATE();
    case 49:
      if (lookahead == 't') ADVANCE(125);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 51:
      if (lookahead == 'l') ADVANCE(126);
      END_STATE();
    case 52:
      if (lookahead == 'n') ADVANCE(127);
      END_STATE();
    case 53:
      if (lookahead == 't') ADVANCE(128);
      END_STATE();
    case 54:
      if (lookahead == 'm') ADVANCE(129);
      END_STATE();
    case 55:
      if (lookahead == 'w') ADVANCE(130);
      END_STATE();
    case 56:
      if (lookahead == 'e') ADVANCE(131);
      if (lookahead == 'r') ADVANCE(132);
      if (lookahead == 't') ADVANCE(133);
      END_STATE();
    case 57:
      if (lookahead == 'l') ADVANCE(134);
      END_STATE();
    case 58:
      if (lookahead == 'f') ADVANCE(135);
      END_STATE();
    case 59:
      if (lookahead == 'e') ADVANCE(136);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == '_') ADVANCE(137);
      END_STATE();
    case 61:
      if (lookahead == 'e') ADVANCE(138);
      END_STATE();
    case 62:
      if (lookahead == 'i') ADVANCE(139);
      if (lookahead == 'o') ADVANCE(140);
      END_STATE();
    case 63:
      if (lookahead == 'b') ADVANCE(141);
      END_STATE();
    case 64:
      if (lookahead == 'g') ADVANCE(142);
      if (lookahead == 'q') ADVANCE(143);
      if (lookahead == 's') ADVANCE(144);
      if (lookahead == 't') ADVANCE(145);
      END_STATE();
    case 65:
      if (lookahead == 'o') ADVANCE(146);
      END_STATE();
    case 66:
      if (lookahead == 'g') ADVANCE(147);
      if (lookahead == 'z') ADVANCE(148);
      END_STATE();
    case 67:
      if (lookahead == 'a') ADVANCE(149);
      if (lookahead == 'r') ADVANCE(150);
      END_STATE();
    case 68:
      if (lookahead == 'i') ADVANCE(151);
      END_STATE();
    case 69:
      if (lookahead == 'm') ADVANCE(152);
      END_STATE();
    case 70:
      if (lookahead == 'i') ADVANCE(153);
      if (lookahead == 'r') ADVANCE(154);
      END_STATE();
    case 71:
      if (lookahead == 'y') ADVANCE(155);
      END_STATE();
    case 72:
      if (lookahead == 'p') ADVANCE(156);
      END_STATE();
    case 73:
      if (lookahead == 'i') ADVANCE(157);
      if (lookahead == 's') ADVANCE(158);
      END_STATE();
    case 74:
      if (lookahead == 'i') ADVANCE(159);
      END_STATE();
    case 75:
      if (lookahead == 'r') ADVANCE(160);
      END_STATE();
    case 76:
      if (lookahead == 'l') ADVANCE(161);
      END_STATE();
    case 77:
      if (lookahead == 'i') ADVANCE(162);
      END_STATE();
    case 78:
      if (lookahead == 'r') ADVANCE(163);
      END_STATE();
    case 79:
      if (lookahead == 'L') ADVANCE(164);
      END_STATE();
    case 80:
      if (lookahead == 'i') ADVANCE(165);
      END_STATE();
    case 81:
      if (lookahead == 'o') ADVANCE(166);
      END_STATE();
    case 82:
      if (lookahead == 'n') ADVANCE(167);
      END_STATE();
    case 83:
      if (lookahead == 'r') ADVANCE(168);
      END_STATE();
    case 84:
      if (lookahead == 'l') ADVANCE(169);
      if (lookahead == 's') ADVANCE(170);
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 85:
      if (lookahead == 'a') ADVANCE(172);
      END_STATE();
    case 86:
      if (lookahead == 'd') ADVANCE(173);
      if (lookahead == 'l') ADVANCE(174);
      if (lookahead == 'o') ADVANCE(175);
      END_STATE();
    case 87:
      if (lookahead == 'e') ADVANCE(176);
      END_STATE();
    case 88:
      if (lookahead == 'x') ADVANCE(177);
      END_STATE();
    case 89:
      if (lookahead == 'a') ADVANCE(178);
      if (lookahead == 'i') ADVANCE(179);
      if (lookahead == 'o') ADVANCE(180);
      END_STATE();
    case 90:
      if (lookahead == 'l') ADVANCE(181);
      if (lookahead == 'r') ADVANCE(182);
      END_STATE();
    case 91:
      if (lookahead == 'o') ADVANCE(183);
      END_STATE();
    case 92:
      if (lookahead == 'n') ADVANCE(184);
      END_STATE();
    case 93:
      if (lookahead == 'a') ADVANCE(185);
      if (lookahead == 'e') ADVANCE(186);
      if (lookahead == 'o') ADVANCE(187);
      END_STATE();
    case 94:
      if (lookahead == 'a') ADVANCE(188);
      END_STATE();
    case 95:
      if (lookahead == 'o') ADVANCE(189);
      END_STATE();
    case 96:
      if (lookahead == 'e') ADVANCE(190);
      END_STATE();
    case 97:
      if (lookahead == 'h') ADVANCE(191);
      if (lookahead == 'p') ADVANCE(192);
      if (lookahead == 't') ADVANCE(193);
      END_STATE();
    case 98:
      if (lookahead == 'h') ADVANCE(194);
      if (lookahead == 'r') ADVANCE(195);
      END_STATE();
    case 99:
      if (lookahead == 'n') ADVANCE(196);
      if (lookahead == 'p') ADVANCE(197);
      END_STATE();
    case 100:
      if (lookahead == 'e') ADVANCE(198);
      END_STATE();
    case 101:
      if (lookahead == 'i') ADVANCE(199);
      END_STATE();
    case 102:
      if (lookahead == 'a') ADVANCE(200);
      END_STATE();
    case 103:
      if (lookahead == 'g') ADVANCE(201);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_and);
      if (lookahead == '_') ADVANCE(202);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_asm);
      END_STATE();
    case 106:
      if (lookahead == 'o') ADVANCE(203);
      END_STATE();
    case 107:
      if (lookahead == 'a') ADVANCE(204);
      if (lookahead == 'o') ADVANCE(205);
      END_STATE();
    case 108:
      if (lookahead == 'a') ADVANCE(206);
      END_STATE();
    case 109:
      if (lookahead == 'e') ADVANCE(207);
      END_STATE();
    case 110:
      if (lookahead == 'c') ADVANCE(208);
      END_STATE();
    case 111:
      if (lookahead == 's') ADVANCE(209);
      END_STATE();
    case 112:
      if (lookahead == 'a') ADVANCE(210);
      if (lookahead == 'r') ADVANCE(211);
      if (lookahead == 'y') ADVANCE(212);
      END_STATE();
    case 113:
      if (lookahead == 'p') ADVANCE(213);
      END_STATE();
    case 114:
      if (lookahead == 'c') ADVANCE(214);
      if (lookahead == 's') ADVANCE(215);
      if (lookahead == 't') ADVANCE(216);
      END_STATE();
    case 115:
      if (lookahead == 'l') ADVANCE(217);
      END_STATE();
    case 116:
      if (lookahead == 'a') ADVANCE(218);
      if (lookahead == 'i') ADVANCE(219);
      END_STATE();
    case 117:
      if (lookahead == 'e') ADVANCE(220);
      END_STATE();
    case 118:
      if (lookahead == 'e') ADVANCE(221);
      END_STATE();
    case 119:
      if (lookahead == 'm') ADVANCE(222);
      END_STATE();
    case 120:
      if (lookahead == 'l') ADVANCE(223);
      END_STATE();
    case 121:
      if (lookahead == 'e') ADVANCE(224);
      END_STATE();
    case 122:
      if (lookahead == 'a') ADVANCE(225);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 124:
      if (lookahead == 'e') ADVANCE(226);
      END_STATE();
    case 125:
      if (lookahead == 'o') ADVANCE(227);
      END_STATE();
    case 126:
      if (lookahead == 'i') ADVANCE(228);
      END_STATE();
    case 127:
      if (lookahead == 'g') ADVANCE(229);
      END_STATE();
    case 128:
      if (lookahead == 'a') ADVANCE(230);
      END_STATE();
    case 129:
      if (lookahead == 'e') ADVANCE(231);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 131:
      if (lookahead == 'x') ADVANCE(232);
      END_STATE();
    case 132:
      if (lookahead == 'e') ADVANCE(233);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_not);
      if (lookahead == '_') ADVANCE(234);
      END_STATE();
    case 134:
      if (lookahead == 'l') ADVANCE(235);
      END_STATE();
    case 135:
      if (lookahead == 's') ADVANCE(236);
      END_STATE();
    case 136:
      if (lookahead == 'r') ADVANCE(237);
      END_STATE();
    case 137:
      if (lookahead == 'e') ADVANCE(238);
      END_STATE();
    case 138:
      if (lookahead == 'r') ADVANCE(239);
      END_STATE();
    case 139:
      if (lookahead == 'v') ADVANCE(240);
      END_STATE();
    case 140:
      if (lookahead == 't') ADVANCE(241);
      END_STATE();
    case 141:
      if (lookahead == 'l') ADVANCE(242);
      END_STATE();
    case 142:
      if (lookahead == 'i') ADVANCE(243);
      END_STATE();
    case 143:
      if (lookahead == 'u') ADVANCE(244);
      END_STATE();
    case 144:
      if (lookahead == 't') ADVANCE(245);
      END_STATE();
    case 145:
      if (lookahead == 'u') ADVANCE(246);
      END_STATE();
    case 146:
      if (lookahead == 'r') ADVANCE(247);
      END_STATE();
    case 147:
      if (lookahead == 'n') ADVANCE(248);
      END_STATE();
    case 148:
      if (lookahead == 'e') ADVANCE(249);
      END_STATE();
    case 149:
      if (lookahead == 't') ADVANCE(250);
      END_STATE();
    case 150:
      if (lookahead == 'u') ADVANCE(251);
      END_STATE();
    case 151:
      if (lookahead == 't') ADVANCE(252);
      END_STATE();
    case 152:
      if (lookahead == 'p') ADVANCE(253);
      END_STATE();
    case 153:
      if (lookahead == 's') ADVANCE(254);
      END_STATE();
    case 154:
      if (lookahead == 'e') ADVANCE(255);
      if (lookahead == 'o') ADVANCE(256);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 156:
      if (lookahead == 'e') ADVANCE(257);
      END_STATE();
    case 157:
      if (lookahead == 'o') ADVANCE(258);
      END_STATE();
    case 158:
      if (lookahead == 'i') ADVANCE(259);
      END_STATE();
    case 159:
      if (lookahead == 'n') ADVANCE(260);
      END_STATE();
    case 160:
      if (lookahead == 't') ADVANCE(261);
      END_STATE();
    case 161:
      if (lookahead == 'a') ADVANCE(262);
      END_STATE();
    case 162:
      if (lookahead == 'l') ADVANCE(263);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_xor);
      if (lookahead == '_') ADVANCE(264);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_NULL);
      END_STATE();
    case 165:
      if (lookahead == 'g') ADVANCE(265);
      END_STATE();
    case 166:
      if (lookahead == 'm') ADVANCE(266);
      END_STATE();
    case 167:
      if (lookahead == 'e') ADVANCE(267);
      END_STATE();
    case 168:
      if (lookahead == 'e') ADVANCE(268);
      END_STATE();
    case 169:
      if (lookahead == 'i') ADVANCE(269);
      END_STATE();
    case 170:
      if (lookahead == 'm') ADVANCE(270);
      END_STATE();
    case 171:
      if (lookahead == 't') ADVANCE(271);
      END_STATE();
    case 172:
      if (lookahead == 's') ADVANCE(272);
      END_STATE();
    case 173:
      if (lookahead == 'e') ADVANCE(273);
      END_STATE();
    case 174:
      if (lookahead == 'r') ADVANCE(274);
      END_STATE();
    case 175:
      if (lookahead == 'n') ADVANCE(275);
      END_STATE();
    case 176:
      if (lookahead == 'c') ADVANCE(276);
      if (lookahead == 'v') ADVANCE(277);
      END_STATE();
    case 177:
      if (lookahead == 'c') ADVANCE(278);
      if (lookahead == 't') ADVANCE(279);
      END_STATE();
    case 178:
      if (lookahead == 's') ADVANCE(280);
      END_STATE();
    case 179:
      if (lookahead == 'n') ADVANCE(281);
      END_STATE();
    case 180:
      if (lookahead == 'r') ADVANCE(282);
      END_STATE();
    case 181:
      if (lookahead == 'o') ADVANCE(283);
      END_STATE();
    case 182:
      if (lookahead == 'i') ADVANCE(284);
      END_STATE();
    case 183:
      if (lookahead == 's') ADVANCE(285);
      END_STATE();
    case 184:
      if (lookahead == 'l') ADVANCE(286);
      END_STATE();
    case 185:
      if (lookahead == 'u') ADVANCE(287);
      END_STATE();
    case 186:
      if (lookahead == 'a') ADVANCE(288);
      END_STATE();
    case 187:
      if (lookahead == 'c') ADVANCE(289);
      END_STATE();
    case 188:
      if (lookahead == 'n') ADVANCE(290);
      END_STATE();
    case 189:
      if (lookahead == 'i') ADVANCE(291);
      END_STATE();
    case 190:
      if (lookahead == 's') ADVANCE(292);
      END_STATE();
    case 191:
      if (lookahead == 'a') ADVANCE(293);
      END_STATE();
    case 192:
      if (lookahead == 't') ADVANCE(294);
      END_STATE();
    case 193:
      if (lookahead == 'd') ADVANCE(295);
      END_STATE();
    case 194:
      if (lookahead == 'i') ADVANCE(296);
      if (lookahead == 'r') ADVANCE(297);
      END_STATE();
    case 195:
      if (lookahead == 'y') ADVANCE(298);
      END_STATE();
    case 196:
      if (lookahead == 'a') ADVANCE(299);
      END_STATE();
    case 197:
      if (lookahead == 't') ADVANCE(300);
      END_STATE();
    case 198:
      if (lookahead == 'c') ADVANCE(301);
      END_STATE();
    case 199:
      if (lookahead == 'g') ADVANCE(302);
      END_STATE();
    case 200:
      if (lookahead == 'l') ADVANCE(303);
      END_STATE();
    case 201:
      if (lookahead == 'n') ADVANCE(304);
      END_STATE();
    case 202:
      if (lookahead == 'e') ADVANCE(305);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(sym_auto);
      END_STATE();
    case 204:
      if (lookahead == 'n') ADVANCE(306);
      END_STATE();
    case 205:
      if (lookahead == 'r') ADVANCE(307);
      END_STATE();
    case 206:
      if (lookahead == 'k') ADVANCE(308);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 208:
      if (lookahead == 'h') ADVANCE(309);
      END_STATE();
    case 209:
      if (lookahead == 's') ADVANCE(310);
      END_STATE();
    case 210:
      if (lookahead == 'w') ADVANCE(311);
      END_STATE();
    case 211:
      if (lookahead == 'e') ADVANCE(312);
      END_STATE();
    case 212:
      if (lookahead == 'i') ADVANCE(313);
      END_STATE();
    case 213:
      if (lookahead == 'l') ADVANCE(314);
      END_STATE();
    case 214:
      if (lookahead == 'e') ADVANCE(315);
      END_STATE();
    case 215:
      if (lookahead == 't') ADVANCE(316);
      END_STATE();
    case 216:
      if (lookahead == 'i') ADVANCE(317);
      END_STATE();
    case 217:
      if (lookahead == 't') ADVANCE(318);
      END_STATE();
    case 218:
      if (lookahead == 'u') ADVANCE(319);
      END_STATE();
    case 219:
      if (lookahead == 'n') ADVANCE(320);
      END_STATE();
    case 220:
      if (lookahead == 't') ADVANCE(321);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 223:
      if (lookahead == 'i') ADVANCE(322);
      END_STATE();
    case 224:
      if (lookahead == 'r') ADVANCE(323);
      END_STATE();
    case 225:
      if (lookahead == 'l') ADVANCE(324);
      END_STATE();
    case 226:
      if (lookahead == 'n') ADVANCE(325);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 228:
      if (lookahead == 'n') ADVANCE(326);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_long);
      END_STATE();
    case 230:
      if (lookahead == 'b') ADVANCE(327);
      END_STATE();
    case 231:
      if (lookahead == 's') ADVANCE(328);
      END_STATE();
    case 232:
      if (lookahead == 'c') ADVANCE(329);
      END_STATE();
    case 233:
      if (lookahead == 't') ADVANCE(330);
      END_STATE();
    case 234:
      if (lookahead == 'e') ADVANCE(331);
      END_STATE();
    case 235:
      if (lookahead == 'p') ADVANCE(332);
      END_STATE();
    case 236:
      if (lookahead == 'e') ADVANCE(333);
      END_STATE();
    case 237:
      if (lookahead == 'a') ADVANCE(334);
      END_STATE();
    case 238:
      if (lookahead == 'q') ADVANCE(335);
      END_STATE();
    case 239:
      if (lookahead == 'r') ADVANCE(336);
      END_STATE();
    case 240:
      if (lookahead == 'a') ADVANCE(337);
      END_STATE();
    case 241:
      if (lookahead == 'e') ADVANCE(338);
      END_STATE();
    case 242:
      if (lookahead == 'i') ADVANCE(339);
      END_STATE();
    case 243:
      if (lookahead == 's') ADVANCE(340);
      END_STATE();
    case 244:
      if (lookahead == 'i') ADVANCE(341);
      END_STATE();
    case 245:
      if (lookahead == 'r') ADVANCE(342);
      END_STATE();
    case 246:
      if (lookahead == 'r') ADVANCE(343);
      END_STATE();
    case 247:
      if (lookahead == 't') ADVANCE(344);
      END_STATE();
    case 248:
      if (lookahead == 'e') ADVANCE(345);
      END_STATE();
    case 249:
      if (lookahead == 'o') ADVANCE(346);
      END_STATE();
    case 250:
      if (lookahead == 'i') ADVANCE(347);
      END_STATE();
    case 251:
      if (lookahead == 'c') ADVANCE(348);
      END_STATE();
    case 252:
      if (lookahead == 'c') ADVANCE(349);
      END_STATE();
    case 253:
      if (lookahead == 'l') ADVANCE(350);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 255:
      if (lookahead == 'a') ADVANCE(351);
      END_STATE();
    case 256:
      if (lookahead == 'w') ADVANCE(352);
      END_STATE();
    case 257:
      if (lookahead == 'd') ADVANCE(353);
      if (lookahead == 'n') ADVANCE(354);
      END_STATE();
    case 258:
      if (lookahead == 'n') ADVANCE(355);
      END_STATE();
    case 259:
      if (lookahead == 'g') ADVANCE(356);
      END_STATE();
    case 260:
      if (lookahead == 'g') ADVANCE(357);
      END_STATE();
    case 261:
      if (lookahead == 'u') ADVANCE(358);
      END_STATE();
    case 262:
      if (lookahead == 't') ADVANCE(359);
      END_STATE();
    case 263:
      if (lookahead == 'e') ADVANCE(360);
      END_STATE();
    case 264:
      if (lookahead == 'e') ADVANCE(361);
      END_STATE();
    case 265:
      if (lookahead == 'n') ADVANCE(362);
      END_STATE();
    case 266:
      if (lookahead == 'i') ADVANCE(363);
      END_STATE();
    case 267:
      if (lookahead == 'r') ADVANCE(364);
      END_STATE();
    case 268:
      if (lookahead == 't') ADVANCE(365);
      END_STATE();
    case 269:
      if (lookahead == 'g') ADVANCE(366);
      END_STATE();
    case 270:
      if (lookahead == '_') ADVANCE(367);
      END_STATE();
    case 271:
      if (lookahead == 'r') ADVANCE(368);
      END_STATE();
    case 272:
      if (lookahead == 'e') ADVANCE(369);
      END_STATE();
    case 273:
      if (lookahead == 'c') ADVANCE(370);
      END_STATE();
    case 274:
      if (lookahead == 'c') ADVANCE(371);
      END_STATE();
    case 275:
      if (lookahead == 's') ADVANCE(372);
      END_STATE();
    case 276:
      if (lookahead == 'l') ADVANCE(373);
      END_STATE();
    case 277:
      if (lookahead == 'i') ADVANCE(374);
      END_STATE();
    case 278:
      if (lookahead == 'e') ADVANCE(375);
      END_STATE();
    case 279:
      if (lookahead == 'e') ADVANCE(376);
      END_STATE();
    case 280:
      if (lookahead == 't') ADVANCE(377);
      END_STATE();
    case 281:
      if (lookahead == 'a') ADVANCE(378);
      END_STATE();
    case 282:
      if (lookahead == 'c') ADVANCE(379);
      END_STATE();
    case 283:
      if (lookahead == 'b') ADVANCE(380);
      END_STATE();
    case 284:
      if (lookahead == 'd') ADVANCE(381);
      END_STATE();
    case 285:
      if (lookahead == 't') ADVANCE(382);
      END_STATE();
    case 286:
      if (lookahead == 'i') ADVANCE(383);
      END_STATE();
    case 287:
      if (lookahead == 'n') ADVANCE(384);
      END_STATE();
    case 288:
      if (lookahead == 'v') ADVANCE(385);
      END_STATE();
    case 289:
      if (lookahead == 'a') ADVANCE(386);
      END_STATE();
    case 290:
      if (lookahead == 'a') ADVANCE(387);
      END_STATE();
    case 291:
      if (lookahead == 'n') ADVANCE(388);
      END_STATE();
    case 292:
      if (lookahead == 't') ADVANCE(389);
      END_STATE();
    case 293:
      if (lookahead == 'r') ADVANCE(390);
      END_STATE();
    case 294:
      if (lookahead == 'r') ADVANCE(391);
      END_STATE();
    case 295:
      if (lookahead == 'c') ADVANCE(392);
      END_STATE();
    case 296:
      if (lookahead == 's') ADVANCE(393);
      END_STATE();
    case 297:
      if (lookahead == 'e') ADVANCE(394);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym___try);
      END_STATE();
    case 299:
      if (lookahead == 'l') ADVANCE(395);
      END_STATE();
    case 300:
      if (lookahead == 'r') ADVANCE(396);
      END_STATE();
    case 301:
      if (lookahead == 't') ADVANCE(397);
      END_STATE();
    case 302:
      if (lookahead == 'n') ADVANCE(398);
      END_STATE();
    case 303:
      if (lookahead == 'i') ADVANCE(399);
      END_STATE();
    case 304:
      if (lookahead == 'a') ADVANCE(400);
      if (lookahead == 'o') ADVANCE(401);
      END_STATE();
    case 305:
      if (lookahead == 'q') ADVANCE(402);
      END_STATE();
    case 306:
      if (lookahead == 'd') ADVANCE(403);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(anon_sym_bitor);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 311:
      if (lookahead == 'a') ADVANCE(404);
      END_STATE();
    case 312:
      if (lookahead == 't') ADVANCE(405);
      END_STATE();
    case 313:
      if (lookahead == 'e') ADVANCE(406);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(anon_sym_compl);
      END_STATE();
    case 315:
      if (lookahead == 'p') ADVANCE(407);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(anon_sym_const);
      if (lookahead == 'e') ADVANCE(408);
      if (lookahead == 'i') ADVANCE(409);
      END_STATE();
    case 317:
      if (lookahead == 'n') ADVANCE(410);
      END_STATE();
    case 318:
      if (lookahead == 'y') ADVANCE(411);
      END_STATE();
    case 319:
      if (lookahead == 'l') ADVANCE(412);
      END_STATE();
    case 320:
      if (lookahead == 'e') ADVANCE(413);
      END_STATE();
    case 321:
      if (lookahead == 'e') ADVANCE(414);
      END_STATE();
    case 322:
      if (lookahead == 'c') ADVANCE(415);
      END_STATE();
    case 323:
      if (lookahead == 'n') ADVANCE(416);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(anon_sym_final);
      END_STATE();
    case 325:
      if (lookahead == 'd') ADVANCE(417);
      END_STATE();
    case 326:
      if (lookahead == 'e') ADVANCE(418);
      END_STATE();
    case 327:
      if (lookahead == 'l') ADVANCE(419);
      END_STATE();
    case 328:
      if (lookahead == 'p') ADVANCE(420);
      END_STATE();
    case 329:
      if (lookahead == 'e') ADVANCE(421);
      END_STATE();
    case 330:
      if (lookahead == 'u') ADVANCE(422);
      END_STATE();
    case 331:
      if (lookahead == 'q') ADVANCE(423);
      END_STATE();
    case 332:
      if (lookahead == 't') ADVANCE(424);
      END_STATE();
    case 333:
      if (lookahead == 't') ADVANCE(425);
      END_STATE();
    case 334:
      if (lookahead == 't') ADVANCE(426);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(anon_sym_or_eq);
      END_STATE();
    case 336:
      if (lookahead == 'i') ADVANCE(427);
      END_STATE();
    case 337:
      if (lookahead == 't') ADVANCE(428);
      END_STATE();
    case 338:
      if (lookahead == 'c') ADVANCE(429);
      END_STATE();
    case 339:
      if (lookahead == 'c') ADVANCE(430);
      END_STATE();
    case 340:
      if (lookahead == 't') ADVANCE(431);
      END_STATE();
    case 341:
      if (lookahead == 'r') ADVANCE(432);
      END_STATE();
    case 342:
      if (lookahead == 'i') ADVANCE(433);
      END_STATE();
    case 343:
      if (lookahead == 'n') ADVANCE(434);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(anon_sym_short);
      END_STATE();
    case 345:
      if (lookahead == 'd') ADVANCE(435);
      END_STATE();
    case 346:
      if (lookahead == 'f') ADVANCE(436);
      END_STATE();
    case 347:
      if (lookahead == 'c') ADVANCE(437);
      END_STATE();
    case 348:
      if (lookahead == 't') ADVANCE(438);
      END_STATE();
    case 349:
      if (lookahead == 'h') ADVANCE(439);
      END_STATE();
    case 350:
      if (lookahead == 'a') ADVANCE(440);
      END_STATE();
    case 351:
      if (lookahead == 'd') ADVANCE(441);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 353:
      if (lookahead == 'e') ADVANCE(442);
      END_STATE();
    case 354:
      if (lookahead == 'a') ADVANCE(443);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 356:
      if (lookahead == 'n') ADVANCE(444);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 358:
      if (lookahead == 'a') ADVANCE(445);
      END_STATE();
    case 359:
      if (lookahead == 'i') ADVANCE(446);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 361:
      if (lookahead == 'q') ADVANCE(447);
      END_STATE();
    case 362:
      if (lookahead == 'a') ADVANCE(448);
      if (lookahead == 'o') ADVANCE(449);
      END_STATE();
    case 363:
      if (lookahead == 'c') ADVANCE(450);
      END_STATE();
    case 364:
      if (lookahead == 'i') ADVANCE(451);
      END_STATE();
    case 365:
      if (lookahead == 'u') ADVANCE(452);
      END_STATE();
    case 366:
      if (lookahead == 'n') ADVANCE(453);
      END_STATE();
    case 367:
      if (lookahead == '_') ADVANCE(454);
      END_STATE();
    case 368:
      if (lookahead == 'i') ADVANCE(455);
      END_STATE();
    case 369:
      if (lookahead == 'd') ADVANCE(456);
      END_STATE();
    case 370:
      if (lookahead == 'l') ADVANCE(457);
      END_STATE();
    case 371:
      if (lookahead == 'a') ADVANCE(458);
      END_STATE();
    case 372:
      if (lookahead == 't') ADVANCE(459);
      END_STATE();
    case 373:
      if (lookahead == 's') ADVANCE(460);
      END_STATE();
    case 374:
      if (lookahead == 'c') ADVANCE(461);
      END_STATE();
    case 375:
      if (lookahead == 'p') ADVANCE(462);
      END_STATE();
    case 376:
      if (lookahead == 'n') ADVANCE(463);
      END_STATE();
    case 377:
      if (lookahead == 'c') ADVANCE(464);
      END_STATE();
    case 378:
      if (lookahead == 'l') ADVANCE(465);
      END_STATE();
    case 379:
      if (lookahead == 'e') ADVANCE(466);
      END_STATE();
    case 380:
      if (lookahead == 'a') ADVANCE(467);
      END_STATE();
    case 381:
      if (lookahead == '_') ADVANCE(468);
      END_STATE();
    case 382:
      if (lookahead == '_') ADVANCE(469);
      END_STATE();
    case 383:
      if (lookahead == 'n') ADVANCE(470);
      END_STATE();
    case 384:
      if (lookahead == 'c') ADVANCE(471);
      END_STATE();
    case 385:
      if (lookahead == 'e') ADVANCE(472);
      END_STATE();
    case 386:
      if (lookahead == 'l') ADVANCE(473);
      END_STATE();
    case 387:
      if (lookahead == 'g') ADVANCE(474);
      END_STATE();
    case 388:
      if (lookahead == 'l') ADVANCE(475);
      END_STATE();
    case 389:
      if (lookahead == 'r') ADVANCE(476);
      END_STATE();
    case 390:
      if (lookahead == 'e') ADVANCE(477);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(sym_ms_signed_ptr_modifier);
      END_STATE();
    case 392:
      if (lookahead == 'a') ADVANCE(478);
      END_STATE();
    case 393:
      if (lookahead == 'c') ADVANCE(479);
      END_STATE();
    case 394:
      if (lookahead == 'a') ADVANCE(480);
      END_STATE();
    case 395:
      if (lookahead == 'i') ADVANCE(481);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(sym_ms_unsigned_ptr_modifier);
      END_STATE();
    case 397:
      if (lookahead == 'o') ADVANCE(482);
      END_STATE();
    case 398:
      if (lookahead == 'o') ADVANCE(483);
      END_STATE();
    case 399:
      if (lookahead == 'g') ADVANCE(484);
      END_STATE();
    case 400:
      if (lookahead == 's') ADVANCE(485);
      END_STATE();
    case 401:
      if (lookahead == 'f') ADVANCE(486);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(anon_sym_and_eq);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(anon_sym_bitand);
      END_STATE();
    case 404:
      if (lookahead == 'i') ADVANCE(487);
      END_STATE();
    case 405:
      if (lookahead == 'u') ADVANCE(488);
      END_STATE();
    case 406:
      if (lookahead == 'l') ADVANCE(489);
      END_STATE();
    case 407:
      if (lookahead == 't') ADVANCE(490);
      END_STATE();
    case 408:
      if (lookahead == 'v') ADVANCE(491);
      if (lookahead == 'x') ADVANCE(492);
      END_STATE();
    case 409:
      if (lookahead == 'n') ADVANCE(493);
      END_STATE();
    case 410:
      if (lookahead == 'u') ADVANCE(494);
      END_STATE();
    case 411:
      if (lookahead == 'p') ADVANCE(495);
      END_STATE();
    case 412:
      if (lookahead == 't') ADVANCE(496);
      END_STATE();
    case 413:
      if (lookahead == 'd') ADVANCE(497);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 415:
      if (lookahead == 'i') ADVANCE(498);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(anon_sym_friend);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(anon_sym_inline);
      END_STATE();
    case 419:
      if (lookahead == 'e') ADVANCE(499);
      END_STATE();
    case 420:
      if (lookahead == 'a') ADVANCE(500);
      END_STATE();
    case 421:
      if (lookahead == 'p') ADVANCE(501);
      END_STATE();
    case 422:
      if (lookahead == 'r') ADVANCE(502);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym_not_eq);
      END_STATE();
    case 424:
      if (lookahead == 'r') ADVANCE(503);
      END_STATE();
    case 425:
      if (lookahead == 'o') ADVANCE(504);
      END_STATE();
    case 426:
      if (lookahead == 'o') ADVANCE(505);
      END_STATE();
    case 427:
      if (lookahead == 'd') ADVANCE(506);
      END_STATE();
    case 428:
      if (lookahead == 'e') ADVANCE(507);
      END_STATE();
    case 429:
      if (lookahead == 't') ADVANCE(508);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 431:
      if (lookahead == 'e') ADVANCE(509);
      END_STATE();
    case 432:
      if (lookahead == 'e') ADVANCE(510);
      END_STATE();
    case 433:
      if (lookahead == 'c') ADVANCE(511);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(anon_sym_signed);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(anon_sym_sizeof);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(anon_sym_static);
      if (lookahead == '_') ADVANCE(512);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 440:
      if (lookahead == 't') ADVANCE(513);
      END_STATE();
    case 441:
      if (lookahead == '_') ADVANCE(514);
      END_STATE();
    case 442:
      if (lookahead == 'f') ADVANCE(515);
      END_STATE();
    case 443:
      if (lookahead == 'm') ADVANCE(516);
      END_STATE();
    case 444:
      if (lookahead == 'e') ADVANCE(517);
      END_STATE();
    case 445:
      if (lookahead == 'l') ADVANCE(518);
      END_STATE();
    case 446:
      if (lookahead == 'l') ADVANCE(519);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(anon_sym_xor_eq);
      END_STATE();
    case 448:
      if (lookahead == 's') ADVANCE(520);
      END_STATE();
    case 449:
      if (lookahead == 'f') ADVANCE(521);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(anon_sym__Atomic);
      END_STATE();
    case 451:
      if (lookahead == 'c') ADVANCE(522);
      END_STATE();
    case 452:
      if (lookahead == 'r') ADVANCE(523);
      END_STATE();
    case 453:
      if (lookahead == 'o') ADVANCE(524);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(anon_sym___asm__);
      END_STATE();
    case 455:
      if (lookahead == 'b') ADVANCE(525);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(anon_sym___based);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(anon_sym___cdecl);
      END_STATE();
    case 458:
      if (lookahead == 'l') ADVANCE(526);
      END_STATE();
    case 459:
      if (lookahead == 'a') ADVANCE(527);
      END_STATE();
    case 460:
      if (lookahead == 'p') ADVANCE(528);
      END_STATE();
    case 461:
      if (lookahead == 'e') ADVANCE(529);
      END_STATE();
    case 462:
      if (lookahead == 't') ADVANCE(530);
      END_STATE();
    case 463:
      if (lookahead == 's') ADVANCE(531);
      END_STATE();
    case 464:
      if (lookahead == 'a') ADVANCE(532);
      END_STATE();
    case 465:
      if (lookahead == 'l') ADVANCE(533);
      END_STATE();
    case 466:
      if (lookahead == 'i') ADVANCE(534);
      END_STATE();
    case 467:
      if (lookahead == 'l') ADVANCE(535);
      END_STATE();
    case 468:
      if (lookahead == 'c') ADVANCE(536);
      END_STATE();
    case 469:
      if (lookahead == '_') ADVANCE(537);
      END_STATE();
    case 470:
      if (lookahead == 'e') ADVANCE(538);
      END_STATE();
    case 471:
      if (lookahead == 'h') ADVANCE(539);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(anon_sym___leave);
      END_STATE();
    case 473:
      if (lookahead == '_') ADVANCE(540);
      END_STATE();
    case 474:
      if (lookahead == 'e') ADVANCE(541);
      END_STATE();
    case 475:
      if (lookahead == 'i') ADVANCE(542);
      END_STATE();
    case 476:
      if (lookahead == 'i') ADVANCE(543);
      END_STATE();
    case 477:
      if (lookahead == 'd') ADVANCE(544);
      END_STATE();
    case 478:
      if (lookahead == 'l') ADVANCE(545);
      END_STATE();
    case 479:
      if (lookahead == 'a') ADVANCE(546);
      END_STATE();
    case 480:
      if (lookahead == 'd') ADVANCE(547);
      END_STATE();
    case 481:
      if (lookahead == 'g') ADVANCE(548);
      END_STATE();
    case 482:
      if (lookahead == 'r') ADVANCE(549);
      END_STATE();
    case 483:
      if (lookahead == 'f') ADVANCE(550);
      END_STATE();
    case 484:
      if (lookahead == 'n') ADVANCE(551);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(anon_sym_alignas);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(anon_sym_alignof);
      END_STATE();
    case 487:
      if (lookahead == 't') ADVANCE(552);
      END_STATE();
    case 488:
      if (lookahead == 'r') ADVANCE(553);
      END_STATE();
    case 489:
      if (lookahead == 'd') ADVANCE(554);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(anon_sym_concept);
      END_STATE();
    case 491:
      if (lookahead == 'a') ADVANCE(555);
      END_STATE();
    case 492:
      if (lookahead == 'p') ADVANCE(556);
      END_STATE();
    case 493:
      if (lookahead == 'i') ADVANCE(557);
      END_STATE();
    case 494:
      if (lookahead == 'e') ADVANCE(558);
      END_STATE();
    case 495:
      if (lookahead == 'e') ADVANCE(559);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(anon_sym_defined);
      END_STATE();
    case 498:
      if (lookahead == 't') ADVANCE(560);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(anon_sym_mutable);
      END_STATE();
    case 500:
      if (lookahead == 'c') ADVANCE(561);
      END_STATE();
    case 501:
      if (lookahead == 't') ADVANCE(562);
      END_STATE();
    case 502:
      if (lookahead == 'n') ADVANCE(563);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(anon_sym_nullptr);
      END_STATE();
    case 504:
      if (lookahead == 'f') ADVANCE(564);
      END_STATE();
    case 505:
      if (lookahead == 'r') ADVANCE(565);
      END_STATE();
    case 506:
      if (lookahead == 'e') ADVANCE(566);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 508:
      if (lookahead == 'e') ADVANCE(567);
      END_STATE();
    case 509:
      if (lookahead == 'r') ADVANCE(568);
      END_STATE();
    case 510:
      if (lookahead == 's') ADVANCE(569);
      END_STATE();
    case 511:
      if (lookahead == 't') ADVANCE(570);
      END_STATE();
    case 512:
      if (lookahead == 'a') ADVANCE(571);
      END_STATE();
    case 513:
      if (lookahead == 'e') ADVANCE(572);
      END_STATE();
    case 514:
      if (lookahead == 'l') ADVANCE(573);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(anon_sym_typedef);
      END_STATE();
    case 516:
      if (lookahead == 'e') ADVANCE(574);
      END_STATE();
    case 517:
      if (lookahead == 'd') ADVANCE(575);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(sym_virtual);
      END_STATE();
    case 519:
      if (lookahead == 'e') ADVANCE(576);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(anon_sym__Alignas);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(anon_sym__Alignof);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(anon_sym__Generic);
      END_STATE();
    case 523:
      if (lookahead == 'n') ADVANCE(577);
      END_STATE();
    case 524:
      if (lookahead == 'f') ADVANCE(578);
      END_STATE();
    case 525:
      if (lookahead == 'u') ADVANCE(579);
      END_STATE();
    case 526:
      if (lookahead == 'l') ADVANCE(580);
      END_STATE();
    case 527:
      if (lookahead == 'n') ADVANCE(581);
      END_STATE();
    case 528:
      if (lookahead == 'e') ADVANCE(582);
      END_STATE();
    case 529:
      if (lookahead == '_') ADVANCE(583);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(anon_sym___except);
      END_STATE();
    case 531:
      if (lookahead == 'i') ADVANCE(584);
      END_STATE();
    case 532:
      if (lookahead == 'l') ADVANCE(585);
      END_STATE();
    case 533:
      if (lookahead == 'y') ADVANCE(586);
      END_STATE();
    case 534:
      if (lookahead == 'n') ADVANCE(587);
      END_STATE();
    case 535:
      if (lookahead == '_') ADVANCE(588);
      END_STATE();
    case 536:
      if (lookahead == 'o') ADVANCE(589);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(anon_sym___host__);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(anon_sym___inline);
      if (lookahead == '_') ADVANCE(590);
      END_STATE();
    case 539:
      if (lookahead == '_') ADVANCE(591);
      END_STATE();
    case 540:
      if (lookahead == '_') ADVANCE(592);
      END_STATE();
    case 541:
      if (lookahead == 'd') ADVANCE(593);
      END_STATE();
    case 542:
      if (lookahead == 'n') ADVANCE(594);
      END_STATE();
    case 543:
      if (lookahead == 'c') ADVANCE(595);
      END_STATE();
    case 544:
      if (lookahead == '_') ADVANCE(596);
      END_STATE();
    case 545:
      if (lookahead == 'l') ADVANCE(597);
      END_STATE();
    case 546:
      if (lookahead == 'l') ADVANCE(598);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(anon_sym___thread);
      END_STATE();
    case 548:
      if (lookahead == 'n') ADVANCE(599);
      END_STATE();
    case 549:
      if (lookahead == 'c') ADVANCE(600);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(anon_sym__alignof);
      END_STATE();
    case 551:
      if (lookahead == 'e') ADVANCE(601);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(anon_sym_co_await);
      END_STATE();
    case 553:
      if (lookahead == 'n') ADVANCE(602);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(anon_sym_co_yield);
      END_STATE();
    case 555:
      if (lookahead == 'l') ADVANCE(603);
      END_STATE();
    case 556:
      if (lookahead == 'r') ADVANCE(604);
      END_STATE();
    case 557:
      if (lookahead == 't') ADVANCE(605);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(anon_sym_decltype);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(anon_sym_explicit);
      END_STATE();
    case 561:
      if (lookahead == 'e') ADVANCE(606);
      END_STATE();
    case 562:
      ACCEPT_TOKEN(anon_sym_noexcept);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(anon_sym_noreturn);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(anon_sym_offsetof);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(anon_sym_operator);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 567:
      if (lookahead == 'd') ADVANCE(607);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(anon_sym_register);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(anon_sym_requires);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(anon_sym_restrict);
      END_STATE();
    case 571:
      if (lookahead == 's') ADVANCE(608);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(anon_sym_template);
      END_STATE();
    case 573:
      if (lookahead == 'o') ADVANCE(609);
      END_STATE();
    case 574:
      ACCEPT_TOKEN(anon_sym_typename);
      END_STATE();
    case 575:
      ACCEPT_TOKEN(anon_sym_unsigned);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 577:
      ACCEPT_TOKEN(anon_sym__Noreturn);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(anon_sym___alignof);
      if (lookahead == '_') ADVANCE(610);
      END_STATE();
    case 579:
      if (lookahead == 't') ADVANCE(611);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(anon_sym___clrcall);
      END_STATE();
    case 581:
      if (lookahead == 't') ADVANCE(612);
      END_STATE();
    case 582:
      if (lookahead == 'c') ADVANCE(613);
      END_STATE();
    case 583:
      if (lookahead == '_') ADVANCE(614);
      END_STATE();
    case 584:
      if (lookahead == 'o') ADVANCE(615);
      END_STATE();
    case 585:
      if (lookahead == 'l') ADVANCE(616);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(anon_sym___finally);
      END_STATE();
    case 587:
      if (lookahead == 'l') ADVANCE(617);
      END_STATE();
    case 588:
      if (lookahead == '_') ADVANCE(618);
      END_STATE();
    case 589:
      if (lookahead == 'n') ADVANCE(619);
      END_STATE();
    case 590:
      if (lookahead == '_') ADVANCE(620);
      END_STATE();
    case 591:
      if (lookahead == 'b') ADVANCE(621);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(anon_sym___local__);
      END_STATE();
    case 593:
      if (lookahead == '_') ADVANCE(622);
      END_STATE();
    case 594:
      if (lookahead == 'e') ADVANCE(623);
      END_STATE();
    case 595:
      if (lookahead == 't') ADVANCE(624);
      END_STATE();
    case 596:
      if (lookahead == '_') ADVANCE(625);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(anon_sym___stdcall);
      END_STATE();
    case 598:
      if (lookahead == 'l') ADVANCE(626);
      END_STATE();
    case 599:
      if (lookahead == 'e') ADVANCE(627);
      END_STATE();
    case 600:
      if (lookahead == 'a') ADVANCE(628);
      END_STATE();
    case 601:
      if (lookahead == 'd') ADVANCE(629);
      END_STATE();
    case 602:
      ACCEPT_TOKEN(anon_sym_co_return);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(anon_sym_consteval);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(anon_sym_constexpr);
      END_STATE();
    case 605:
      ACCEPT_TOKEN(anon_sym_constinit);
      END_STATE();
    case 606:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 607:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 608:
      if (lookahead == 's') ADVANCE(630);
      END_STATE();
    case 609:
      if (lookahead == 'c') ADVANCE(631);
      END_STATE();
    case 610:
      if (lookahead == '_') ADVANCE(632);
      END_STATE();
    case 611:
      if (lookahead == 'e') ADVANCE(633);
      END_STATE();
    case 612:
      if (lookahead == '_') ADVANCE(634);
      END_STATE();
    case 613:
      ACCEPT_TOKEN(anon_sym___declspec);
      END_STATE();
    case 614:
      ACCEPT_TOKEN(anon_sym___device__);
      END_STATE();
    case 615:
      if (lookahead == 'n') ADVANCE(635);
      END_STATE();
    case 616:
      ACCEPT_TOKEN(anon_sym___fastcall);
      END_STATE();
    case 617:
      if (lookahead == 'i') ADVANCE(636);
      END_STATE();
    case 618:
      ACCEPT_TOKEN(anon_sym___global__);
      END_STATE();
    case 619:
      if (lookahead == 's') ADVANCE(637);
      END_STATE();
    case 620:
      ACCEPT_TOKEN(anon_sym___inline__);
      END_STATE();
    case 621:
      if (lookahead == 'o') ADVANCE(638);
      END_STATE();
    case 622:
      if (lookahead == '_') ADVANCE(639);
      END_STATE();
    case 623:
      if (lookahead == '_') ADVANCE(640);
      END_STATE();
    case 624:
      ACCEPT_TOKEN(sym_ms_restrict_modifier);
      if (lookahead == '_') ADVANCE(641);
      END_STATE();
    case 625:
      ACCEPT_TOKEN(anon_sym___shared__);
      END_STATE();
    case 626:
      ACCEPT_TOKEN(anon_sym___thiscall);
      END_STATE();
    case 627:
      if (lookahead == 'd') ADVANCE(642);
      END_STATE();
    case 628:
      if (lookahead == 'l') ADVANCE(643);
      END_STATE();
    case 629:
      ACCEPT_TOKEN(anon_sym__unaligned);
      END_STATE();
    case 630:
      if (lookahead == 'e') ADVANCE(644);
      END_STATE();
    case 631:
      if (lookahead == 'a') ADVANCE(645);
      END_STATE();
    case 632:
      ACCEPT_TOKEN(anon_sym___alignof__);
      END_STATE();
    case 633:
      if (lookahead == '_') ADVANCE(646);
      END_STATE();
    case 634:
      if (lookahead == '_') ADVANCE(647);
      END_STATE();
    case 635:
      if (lookahead == '_') ADVANCE(648);
      END_STATE();
    case 636:
      if (lookahead == 'n') ADVANCE(649);
      END_STATE();
    case 637:
      if (lookahead == 't') ADVANCE(650);
      END_STATE();
    case 638:
      if (lookahead == 'u') ADVANCE(651);
      END_STATE();
    case 639:
      ACCEPT_TOKEN(anon_sym___managed__);
      END_STATE();
    case 640:
      if (lookahead == '_') ADVANCE(652);
      END_STATE();
    case 641:
      if (lookahead == '_') ADVANCE(653);
      END_STATE();
    case 642:
      ACCEPT_TOKEN(anon_sym___unaligned);
      END_STATE();
    case 643:
      if (lookahead == 'l') ADVANCE(654);
      END_STATE();
    case 644:
      if (lookahead == 'r') ADVANCE(655);
      END_STATE();
    case 645:
      if (lookahead == 'l') ADVANCE(656);
      END_STATE();
    case 646:
      if (lookahead == '_') ADVANCE(657);
      END_STATE();
    case 647:
      ACCEPT_TOKEN(anon_sym___constant__);
      END_STATE();
    case 648:
      if (lookahead == '_') ADVANCE(658);
      END_STATE();
    case 649:
      if (lookahead == 'e') ADVANCE(659);
      END_STATE();
    case 650:
      if (lookahead == 'a') ADVANCE(660);
      END_STATE();
    case 651:
      if (lookahead == 'n') ADVANCE(661);
      END_STATE();
    case 652:
      ACCEPT_TOKEN(anon_sym___noinline__);
      END_STATE();
    case 653:
      ACCEPT_TOKEN(anon_sym___restrict__);
      END_STATE();
    case 654:
      ACCEPT_TOKEN(anon_sym___vectorcall);
      END_STATE();
    case 655:
      if (lookahead == 't') ADVANCE(662);
      END_STATE();
    case 656:
      ACCEPT_TOKEN(anon_sym_thread_local);
      END_STATE();
    case 657:
      ACCEPT_TOKEN(anon_sym___attribute__);
      END_STATE();
    case 658:
      ACCEPT_TOKEN(anon_sym___extension__);
      END_STATE();
    case 659:
      ACCEPT_TOKEN(anon_sym___forceinline);
      if (lookahead == '_') ADVANCE(663);
      END_STATE();
    case 660:
      if (lookahead == 'n') ADVANCE(664);
      END_STATE();
    case 661:
      if (lookahead == 'd') ADVANCE(665);
      END_STATE();
    case 662:
      ACCEPT_TOKEN(anon_sym_static_assert);
      END_STATE();
    case 663:
      if (lookahead == '_') ADVANCE(666);
      END_STATE();
    case 664:
      if (lookahead == 't') ADVANCE(667);
      END_STATE();
    case 665:
      if (lookahead == 's') ADVANCE(668);
      END_STATE();
    case 666:
      ACCEPT_TOKEN(anon_sym___forceinline__);
      END_STATE();
    case 667:
      if (lookahead == '_') ADVANCE(669);
      END_STATE();
    case 668:
      if (lookahead == '_') ADVANCE(670);
      END_STATE();
    case 669:
      if (lookahead == '_') ADVANCE(671);
      END_STATE();
    case 670:
      if (lookahead == '_') ADVANCE(672);
      END_STATE();
    case 671:
      ACCEPT_TOKEN(anon_sym___grid_constant__);
      END_STATE();
    case 672:
      ACCEPT_TOKEN(anon_sym___launch_bounds__);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 388},
  [2] = {.lex_state = 388},
  [3] = {.lex_state = 388},
  [4] = {.lex_state = 388},
  [5] = {.lex_state = 388},
  [6] = {.lex_state = 388},
  [7] = {.lex_state = 388},
  [8] = {.lex_state = 388},
  [9] = {.lex_state = 388},
  [10] = {.lex_state = 388},
  [11] = {.lex_state = 388},
  [12] = {.lex_state = 388},
  [13] = {.lex_state = 201},
  [14] = {.lex_state = 201},
  [15] = {.lex_state = 201},
  [16] = {.lex_state = 201},
  [17] = {.lex_state = 201},
  [18] = {.lex_state = 201},
  [19] = {.lex_state = 201},
  [20] = {.lex_state = 201},
  [21] = {.lex_state = 201},
  [22] = {.lex_state = 201},
  [23] = {.lex_state = 201},
  [24] = {.lex_state = 201},
  [25] = {.lex_state = 201},
  [26] = {.lex_state = 201},
  [27] = {.lex_state = 201},
  [28] = {.lex_state = 201},
  [29] = {.lex_state = 201},
  [30] = {.lex_state = 201},
  [31] = {.lex_state = 201},
  [32] = {.lex_state = 201},
  [33] = {.lex_state = 201},
  [34] = {.lex_state = 388},
  [35] = {.lex_state = 388},
  [36] = {.lex_state = 388},
  [37] = {.lex_state = 388},
  [38] = {.lex_state = 388},
  [39] = {.lex_state = 388},
  [40] = {.lex_state = 388},
  [41] = {.lex_state = 388},
  [42] = {.lex_state = 204},
  [43] = {.lex_state = 388},
  [44] = {.lex_state = 388},
  [45] = {.lex_state = 388},
  [46] = {.lex_state = 388},
  [47] = {.lex_state = 388},
  [48] = {.lex_state = 388},
  [49] = {.lex_state = 388},
  [50] = {.lex_state = 388},
  [51] = {.lex_state = 388},
  [52] = {.lex_state = 388},
  [53] = {.lex_state = 388},
  [54] = {.lex_state = 388},
  [55] = {.lex_state = 388},
  [56] = {.lex_state = 388},
  [57] = {.lex_state = 388},
  [58] = {.lex_state = 388},
  [59] = {.lex_state = 388},
  [60] = {.lex_state = 388},
  [61] = {.lex_state = 388},
  [62] = {.lex_state = 388},
  [63] = {.lex_state = 388},
  [64] = {.lex_state = 388},
  [65] = {.lex_state = 388},
  [66] = {.lex_state = 388},
  [67] = {.lex_state = 388},
  [68] = {.lex_state = 388},
  [69] = {.lex_state = 388},
  [70] = {.lex_state = 388},
  [71] = {.lex_state = 204},
  [72] = {.lex_state = 388},
  [73] = {.lex_state = 388},
  [74] = {.lex_state = 204},
  [75] = {.lex_state = 388},
  [76] = {.lex_state = 388},
  [77] = {.lex_state = 388},
  [78] = {.lex_state = 388},
  [79] = {.lex_state = 388},
  [80] = {.lex_state = 388},
  [81] = {.lex_state = 388},
  [82] = {.lex_state = 388},
  [83] = {.lex_state = 388},
  [84] = {.lex_state = 388},
  [85] = {.lex_state = 388},
  [86] = {.lex_state = 201},
  [87] = {.lex_state = 201},
  [88] = {.lex_state = 201},
  [89] = {.lex_state = 201},
  [90] = {.lex_state = 201},
  [91] = {.lex_state = 204},
  [92] = {.lex_state = 388},
  [93] = {.lex_state = 388},
  [94] = {.lex_state = 388},
  [95] = {.lex_state = 204},
  [96] = {.lex_state = 204},
  [97] = {.lex_state = 204},
  [98] = {.lex_state = 204},
  [99] = {.lex_state = 388},
  [100] = {.lex_state = 388},
  [101] = {.lex_state = 388},
  [102] = {.lex_state = 388},
  [103] = {.lex_state = 388},
  [104] = {.lex_state = 388},
  [105] = {.lex_state = 388},
  [106] = {.lex_state = 203},
  [107] = {.lex_state = 203},
  [108] = {.lex_state = 203},
  [109] = {.lex_state = 203},
  [110] = {.lex_state = 203},
  [111] = {.lex_state = 203},
  [112] = {.lex_state = 203},
  [113] = {.lex_state = 203},
  [114] = {.lex_state = 203},
  [115] = {.lex_state = 203},
  [116] = {.lex_state = 203},
  [117] = {.lex_state = 203},
  [118] = {.lex_state = 203},
  [119] = {.lex_state = 203},
  [120] = {.lex_state = 203},
  [121] = {.lex_state = 203},
  [122] = {.lex_state = 203},
  [123] = {.lex_state = 203},
  [124] = {.lex_state = 203},
  [125] = {.lex_state = 203},
  [126] = {.lex_state = 203},
  [127] = {.lex_state = 205},
  [128] = {.lex_state = 205},
  [129] = {.lex_state = 205},
  [130] = {.lex_state = 203},
  [131] = {.lex_state = 388},
  [132] = {.lex_state = 388},
  [133] = {.lex_state = 201},
  [134] = {.lex_state = 201},
  [135] = {.lex_state = 201},
  [136] = {.lex_state = 201},
  [137] = {.lex_state = 201},
  [138] = {.lex_state = 201},
  [139] = {.lex_state = 201},
  [140] = {.lex_state = 201},
  [141] = {.lex_state = 201},
  [142] = {.lex_state = 201},
  [143] = {.lex_state = 201},
  [144] = {.lex_state = 201},
  [145] = {.lex_state = 201},
  [146] = {.lex_state = 201},
  [147] = {.lex_state = 201},
  [148] = {.lex_state = 201},
  [149] = {.lex_state = 201},
  [150] = {.lex_state = 201},
  [151] = {.lex_state = 201},
  [152] = {.lex_state = 201},
  [153] = {.lex_state = 201},
  [154] = {.lex_state = 201},
  [155] = {.lex_state = 201},
  [156] = {.lex_state = 201},
  [157] = {.lex_state = 201},
  [158] = {.lex_state = 201},
  [159] = {.lex_state = 201},
  [160] = {.lex_state = 201},
  [161] = {.lex_state = 201},
  [162] = {.lex_state = 201},
  [163] = {.lex_state = 201},
  [164] = {.lex_state = 201},
  [165] = {.lex_state = 201},
  [166] = {.lex_state = 201},
  [167] = {.lex_state = 201},
  [168] = {.lex_state = 201},
  [169] = {.lex_state = 201},
  [170] = {.lex_state = 201},
  [171] = {.lex_state = 201},
  [172] = {.lex_state = 201},
  [173] = {.lex_state = 201},
  [174] = {.lex_state = 201},
  [175] = {.lex_state = 201},
  [176] = {.lex_state = 201},
  [177] = {.lex_state = 201},
  [178] = {.lex_state = 201},
  [179] = {.lex_state = 201},
  [180] = {.lex_state = 201},
  [181] = {.lex_state = 206},
  [182] = {.lex_state = 201},
  [183] = {.lex_state = 201},
  [184] = {.lex_state = 286},
  [185] = {.lex_state = 201},
  [186] = {.lex_state = 201},
  [187] = {.lex_state = 201},
  [188] = {.lex_state = 201},
  [189] = {.lex_state = 201},
  [190] = {.lex_state = 201},
  [191] = {.lex_state = 201},
  [192] = {.lex_state = 204},
  [193] = {.lex_state = 201},
  [194] = {.lex_state = 201},
  [195] = {.lex_state = 201},
  [196] = {.lex_state = 201},
  [197] = {.lex_state = 201},
  [198] = {.lex_state = 286},
  [199] = {.lex_state = 286},
  [200] = {.lex_state = 201},
  [201] = {.lex_state = 201},
  [202] = {.lex_state = 286},
  [203] = {.lex_state = 201},
  [204] = {.lex_state = 286},
  [205] = {.lex_state = 201},
  [206] = {.lex_state = 206},
  [207] = {.lex_state = 201},
  [208] = {.lex_state = 201},
  [209] = {.lex_state = 201},
  [210] = {.lex_state = 201},
  [211] = {.lex_state = 201},
  [212] = {.lex_state = 206},
  [213] = {.lex_state = 206},
  [214] = {.lex_state = 201},
  [215] = {.lex_state = 201},
  [216] = {.lex_state = 201},
  [217] = {.lex_state = 286},
  [218] = {.lex_state = 286},
  [219] = {.lex_state = 201},
  [220] = {.lex_state = 201},
  [221] = {.lex_state = 201},
  [222] = {.lex_state = 201},
  [223] = {.lex_state = 388},
  [224] = {.lex_state = 286},
  [225] = {.lex_state = 206},
  [226] = {.lex_state = 201},
  [227] = {.lex_state = 201},
  [228] = {.lex_state = 206},
  [229] = {.lex_state = 206},
  [230] = {.lex_state = 201},
  [231] = {.lex_state = 201},
  [232] = {.lex_state = 206},
  [233] = {.lex_state = 206},
  [234] = {.lex_state = 201},
  [235] = {.lex_state = 201},
  [236] = {.lex_state = 206},
  [237] = {.lex_state = 206},
  [238] = {.lex_state = 201},
  [239] = {.lex_state = 201},
  [240] = {.lex_state = 206},
  [241] = {.lex_state = 206},
  [242] = {.lex_state = 201},
  [243] = {.lex_state = 388},
  [244] = {.lex_state = 204},
  [245] = {.lex_state = 286},
  [246] = {.lex_state = 206},
  [247] = {.lex_state = 201},
  [248] = {.lex_state = 201},
  [249] = {.lex_state = 201},
  [250] = {.lex_state = 206},
  [251] = {.lex_state = 201},
  [252] = {.lex_state = 206},
  [253] = {.lex_state = 201},
  [254] = {.lex_state = 206},
  [255] = {.lex_state = 206},
  [256] = {.lex_state = 206},
  [257] = {.lex_state = 388},
  [258] = {.lex_state = 201},
  [259] = {.lex_state = 201},
  [260] = {.lex_state = 201},
  [261] = {.lex_state = 286},
  [262] = {.lex_state = 201},
  [263] = {.lex_state = 201},
  [264] = {.lex_state = 201},
  [265] = {.lex_state = 286},
  [266] = {.lex_state = 201},
  [267] = {.lex_state = 206},
  [268] = {.lex_state = 206},
  [269] = {.lex_state = 201},
  [270] = {.lex_state = 286},
  [271] = {.lex_state = 286},
  [272] = {.lex_state = 206},
  [273] = {.lex_state = 206},
  [274] = {.lex_state = 201},
  [275] = {.lex_state = 201},
  [276] = {.lex_state = 201},
  [277] = {.lex_state = 201},
  [278] = {.lex_state = 206},
  [279] = {.lex_state = 201},
  [280] = {.lex_state = 201},
  [281] = {.lex_state = 206},
  [282] = {.lex_state = 388},
  [283] = {.lex_state = 206},
  [284] = {.lex_state = 286},
  [285] = {.lex_state = 201},
  [286] = {.lex_state = 286},
  [287] = {.lex_state = 203},
  [288] = {.lex_state = 201},
  [289] = {.lex_state = 203},
  [290] = {.lex_state = 201},
  [291] = {.lex_state = 201},
  [292] = {.lex_state = 201},
  [293] = {.lex_state = 201},
  [294] = {.lex_state = 201},
  [295] = {.lex_state = 201},
  [296] = {.lex_state = 286},
  [297] = {.lex_state = 203},
  [298] = {.lex_state = 201},
  [299] = {.lex_state = 201},
  [300] = {.lex_state = 206},
  [301] = {.lex_state = 206},
  [302] = {.lex_state = 201},
  [303] = {.lex_state = 206},
  [304] = {.lex_state = 206},
  [305] = {.lex_state = 388},
  [306] = {.lex_state = 204},
  [307] = {.lex_state = 204},
  [308] = {.lex_state = 192},
  [309] = {.lex_state = 388},
  [310] = {.lex_state = 388},
  [311] = {.lex_state = 388},
  [312] = {.lex_state = 388},
  [313] = {.lex_state = 204},
  [314] = {.lex_state = 204},
  [315] = {.lex_state = 388},
  [316] = {.lex_state = 388},
  [317] = {.lex_state = 192},
  [318] = {.lex_state = 204},
  [319] = {.lex_state = 203},
  [320] = {.lex_state = 388},
  [321] = {.lex_state = 388},
  [322] = {.lex_state = 204},
  [323] = {.lex_state = 388},
  [324] = {.lex_state = 204},
  [325] = {.lex_state = 388},
  [326] = {.lex_state = 388},
  [327] = {.lex_state = 388},
  [328] = {.lex_state = 388},
  [329] = {.lex_state = 388},
  [330] = {.lex_state = 388},
  [331] = {.lex_state = 388},
  [332] = {.lex_state = 388},
  [333] = {.lex_state = 388},
  [334] = {.lex_state = 388},
  [335] = {.lex_state = 388},
  [336] = {.lex_state = 388},
  [337] = {.lex_state = 388},
  [338] = {.lex_state = 204},
  [339] = {.lex_state = 388},
  [340] = {.lex_state = 388},
  [341] = {.lex_state = 388},
  [342] = {.lex_state = 388},
  [343] = {.lex_state = 388},
  [344] = {.lex_state = 204},
  [345] = {.lex_state = 204},
  [346] = {.lex_state = 204},
  [347] = {.lex_state = 388},
  [348] = {.lex_state = 388},
  [349] = {.lex_state = 388},
  [350] = {.lex_state = 388},
  [351] = {.lex_state = 204},
  [352] = {.lex_state = 388},
  [353] = {.lex_state = 388},
  [354] = {.lex_state = 204},
  [355] = {.lex_state = 204},
  [356] = {.lex_state = 204},
  [357] = {.lex_state = 204},
  [358] = {.lex_state = 388},
  [359] = {.lex_state = 388},
  [360] = {.lex_state = 204},
  [361] = {.lex_state = 388},
  [362] = {.lex_state = 388},
  [363] = {.lex_state = 388},
  [364] = {.lex_state = 388},
  [365] = {.lex_state = 388},
  [366] = {.lex_state = 388},
  [367] = {.lex_state = 388},
  [368] = {.lex_state = 388},
  [369] = {.lex_state = 388},
  [370] = {.lex_state = 286},
  [371] = {.lex_state = 204},
  [372] = {.lex_state = 204},
  [373] = {.lex_state = 204},
  [374] = {.lex_state = 204},
  [375] = {.lex_state = 388},
  [376] = {.lex_state = 204},
  [377] = {.lex_state = 388},
  [378] = {.lex_state = 204},
  [379] = {.lex_state = 388},
  [380] = {.lex_state = 388},
  [381] = {.lex_state = 388},
  [382] = {.lex_state = 388},
  [383] = {.lex_state = 388},
  [384] = {.lex_state = 388},
  [385] = {.lex_state = 388},
  [386] = {.lex_state = 204},
  [387] = {.lex_state = 388},
  [388] = {.lex_state = 388},
  [389] = {.lex_state = 204},
  [390] = {.lex_state = 204},
  [391] = {.lex_state = 204},
  [392] = {.lex_state = 204},
  [393] = {.lex_state = 388},
  [394] = {.lex_state = 388},
  [395] = {.lex_state = 388},
  [396] = {.lex_state = 204},
  [397] = {.lex_state = 388},
  [398] = {.lex_state = 388},
  [399] = {.lex_state = 388},
  [400] = {.lex_state = 204},
  [401] = {.lex_state = 388},
  [402] = {.lex_state = 204},
  [403] = {.lex_state = 204},
  [404] = {.lex_state = 204},
  [405] = {.lex_state = 204},
  [406] = {.lex_state = 388},
  [407] = {.lex_state = 204},
  [408] = {.lex_state = 388},
  [409] = {.lex_state = 388},
  [410] = {.lex_state = 388},
  [411] = {.lex_state = 204},
  [412] = {.lex_state = 204},
  [413] = {.lex_state = 388},
  [414] = {.lex_state = 388},
  [415] = {.lex_state = 388},
  [416] = {.lex_state = 388},
  [417] = {.lex_state = 388},
  [418] = {.lex_state = 388},
  [419] = {.lex_state = 204},
  [420] = {.lex_state = 388},
  [421] = {.lex_state = 388},
  [422] = {.lex_state = 388},
  [423] = {.lex_state = 388},
  [424] = {.lex_state = 388},
  [425] = {.lex_state = 388},
  [426] = {.lex_state = 388},
  [427] = {.lex_state = 204},
  [428] = {.lex_state = 388},
  [429] = {.lex_state = 204},
  [430] = {.lex_state = 388},
  [431] = {.lex_state = 388},
  [432] = {.lex_state = 204},
  [433] = {.lex_state = 204},
  [434] = {.lex_state = 204},
  [435] = {.lex_state = 388},
  [436] = {.lex_state = 204},
  [437] = {.lex_state = 204},
  [438] = {.lex_state = 388},
  [439] = {.lex_state = 388},
  [440] = {.lex_state = 206},
  [441] = {.lex_state = 206},
  [442] = {.lex_state = 204},
  [443] = {.lex_state = 204},
  [444] = {.lex_state = 204},
  [445] = {.lex_state = 204},
  [446] = {.lex_state = 204},
  [447] = {.lex_state = 204},
  [448] = {.lex_state = 204},
  [449] = {.lex_state = 204},
  [450] = {.lex_state = 204},
  [451] = {.lex_state = 203},
  [452] = {.lex_state = 204},
  [453] = {.lex_state = 204},
  [454] = {.lex_state = 204},
  [455] = {.lex_state = 204},
  [456] = {.lex_state = 204},
  [457] = {.lex_state = 204},
  [458] = {.lex_state = 204},
  [459] = {.lex_state = 204},
  [460] = {.lex_state = 388},
  [461] = {.lex_state = 204},
  [462] = {.lex_state = 204},
  [463] = {.lex_state = 204},
  [464] = {.lex_state = 388},
  [465] = {.lex_state = 204},
  [466] = {.lex_state = 388},
  [467] = {.lex_state = 204},
  [468] = {.lex_state = 204},
  [469] = {.lex_state = 204},
  [470] = {.lex_state = 204},
  [471] = {.lex_state = 388},
  [472] = {.lex_state = 204},
  [473] = {.lex_state = 204},
  [474] = {.lex_state = 388},
  [475] = {.lex_state = 388},
  [476] = {.lex_state = 204},
  [477] = {.lex_state = 388},
  [478] = {.lex_state = 204},
  [479] = {.lex_state = 388},
  [480] = {.lex_state = 206},
  [481] = {.lex_state = 204},
  [482] = {.lex_state = 204},
  [483] = {.lex_state = 388},
  [484] = {.lex_state = 204},
  [485] = {.lex_state = 204},
  [486] = {.lex_state = 204},
  [487] = {.lex_state = 204},
  [488] = {.lex_state = 204},
  [489] = {.lex_state = 204},
  [490] = {.lex_state = 388},
  [491] = {.lex_state = 204},
  [492] = {.lex_state = 204},
  [493] = {.lex_state = 204},
  [494] = {.lex_state = 388},
  [495] = {.lex_state = 388},
  [496] = {.lex_state = 204},
  [497] = {.lex_state = 204},
  [498] = {.lex_state = 204},
  [499] = {.lex_state = 388},
  [500] = {.lex_state = 204},
  [501] = {.lex_state = 204},
  [502] = {.lex_state = 204},
  [503] = {.lex_state = 204},
  [504] = {.lex_state = 204},
  [505] = {.lex_state = 204},
  [506] = {.lex_state = 388},
  [507] = {.lex_state = 204},
  [508] = {.lex_state = 206},
  [509] = {.lex_state = 388},
  [510] = {.lex_state = 204},
  [511] = {.lex_state = 204},
  [512] = {.lex_state = 388},
  [513] = {.lex_state = 204},
  [514] = {.lex_state = 204},
  [515] = {.lex_state = 388},
  [516] = {.lex_state = 388},
  [517] = {.lex_state = 204},
  [518] = {.lex_state = 388},
  [519] = {.lex_state = 388},
  [520] = {.lex_state = 388},
  [521] = {.lex_state = 204},
  [522] = {.lex_state = 204},
  [523] = {.lex_state = 388},
  [524] = {.lex_state = 206},
  [525] = {.lex_state = 204},
  [526] = {.lex_state = 204},
  [527] = {.lex_state = 204},
  [528] = {.lex_state = 206},
  [529] = {.lex_state = 204},
  [530] = {.lex_state = 204},
  [531] = {.lex_state = 204},
  [532] = {.lex_state = 204},
  [533] = {.lex_state = 206},
  [534] = {.lex_state = 204},
  [535] = {.lex_state = 204},
  [536] = {.lex_state = 388},
  [537] = {.lex_state = 204},
  [538] = {.lex_state = 388},
  [539] = {.lex_state = 388},
  [540] = {.lex_state = 388},
  [541] = {.lex_state = 388},
  [542] = {.lex_state = 388},
  [543] = {.lex_state = 388},
  [544] = {.lex_state = 388},
  [545] = {.lex_state = 194},
  [546] = {.lex_state = 388},
  [547] = {.lex_state = 388},
  [548] = {.lex_state = 206},
  [549] = {.lex_state = 204},
  [550] = {.lex_state = 388},
  [551] = {.lex_state = 204},
  [552] = {.lex_state = 388},
  [553] = {.lex_state = 388},
  [554] = {.lex_state = 388},
  [555] = {.lex_state = 206},
  [556] = {.lex_state = 388},
  [557] = {.lex_state = 388},
  [558] = {.lex_state = 192},
  [559] = {.lex_state = 204},
  [560] = {.lex_state = 388},
  [561] = {.lex_state = 388},
  [562] = {.lex_state = 388},
  [563] = {.lex_state = 388},
  [564] = {.lex_state = 206},
  [565] = {.lex_state = 388},
  [566] = {.lex_state = 388},
  [567] = {.lex_state = 388},
  [568] = {.lex_state = 388},
  [569] = {.lex_state = 206},
  [570] = {.lex_state = 388},
  [571] = {.lex_state = 388},
  [572] = {.lex_state = 206},
  [573] = {.lex_state = 388},
  [574] = {.lex_state = 388},
  [575] = {.lex_state = 206},
  [576] = {.lex_state = 388},
  [577] = {.lex_state = 388},
  [578] = {.lex_state = 388},
  [579] = {.lex_state = 388},
  [580] = {.lex_state = 388},
  [581] = {.lex_state = 388},
  [582] = {.lex_state = 388},
  [583] = {.lex_state = 206},
  [584] = {.lex_state = 388},
  [585] = {.lex_state = 388},
  [586] = {.lex_state = 388},
  [587] = {.lex_state = 388},
  [588] = {.lex_state = 388},
  [589] = {.lex_state = 206},
  [590] = {.lex_state = 206},
  [591] = {.lex_state = 388},
  [592] = {.lex_state = 388},
  [593] = {.lex_state = 388},
  [594] = {.lex_state = 206},
  [595] = {.lex_state = 388},
  [596] = {.lex_state = 388},
  [597] = {.lex_state = 388},
  [598] = {.lex_state = 388},
  [599] = {.lex_state = 388},
  [600] = {.lex_state = 206},
  [601] = {.lex_state = 388},
  [602] = {.lex_state = 388},
  [603] = {.lex_state = 388},
  [604] = {.lex_state = 206},
  [605] = {.lex_state = 203},
  [606] = {.lex_state = 203},
  [607] = {.lex_state = 203},
  [608] = {.lex_state = 203},
  [609] = {.lex_state = 203},
  [610] = {.lex_state = 203},
  [611] = {.lex_state = 203},
  [612] = {.lex_state = 203},
  [613] = {.lex_state = 203},
  [614] = {.lex_state = 203},
  [615] = {.lex_state = 203},
  [616] = {.lex_state = 203},
  [617] = {.lex_state = 203},
  [618] = {.lex_state = 203},
  [619] = {.lex_state = 203},
  [620] = {.lex_state = 203},
  [621] = {.lex_state = 203},
  [622] = {.lex_state = 203},
  [623] = {.lex_state = 203},
  [624] = {.lex_state = 203},
  [625] = {.lex_state = 203},
  [626] = {.lex_state = 203},
  [627] = {.lex_state = 203},
  [628] = {.lex_state = 203},
  [629] = {.lex_state = 388},
  [630] = {.lex_state = 203},
  [631] = {.lex_state = 203},
  [632] = {.lex_state = 203},
  [633] = {.lex_state = 203},
  [634] = {.lex_state = 203},
  [635] = {.lex_state = 203},
  [636] = {.lex_state = 203},
  [637] = {.lex_state = 205},
  [638] = {.lex_state = 196},
  [639] = {.lex_state = 203},
  [640] = {.lex_state = 203},
  [641] = {.lex_state = 203},
  [642] = {.lex_state = 203},
  [643] = {.lex_state = 203},
  [644] = {.lex_state = 203},
  [645] = {.lex_state = 203},
  [646] = {.lex_state = 203},
  [647] = {.lex_state = 203},
  [648] = {.lex_state = 203},
  [649] = {.lex_state = 203},
  [650] = {.lex_state = 206},
  [651] = {.lex_state = 203},
  [652] = {.lex_state = 203},
  [653] = {.lex_state = 203},
  [654] = {.lex_state = 203},
  [655] = {.lex_state = 203},
  [656] = {.lex_state = 195},
  [657] = {.lex_state = 203},
  [658] = {.lex_state = 203},
  [659] = {.lex_state = 205},
  [660] = {.lex_state = 203},
  [661] = {.lex_state = 203},
  [662] = {.lex_state = 203},
  [663] = {.lex_state = 192},
  [664] = {.lex_state = 203},
  [665] = {.lex_state = 203},
  [666] = {.lex_state = 203},
  [667] = {.lex_state = 203},
  [668] = {.lex_state = 203},
  [669] = {.lex_state = 388},
  [670] = {.lex_state = 203},
  [671] = {.lex_state = 203},
  [672] = {.lex_state = 206},
  [673] = {.lex_state = 206},
  [674] = {.lex_state = 206},
  [675] = {.lex_state = 206},
  [676] = {.lex_state = 206},
  [677] = {.lex_state = 206},
  [678] = {.lex_state = 230},
  [679] = {.lex_state = 388},
  [680] = {.lex_state = 230},
  [681] = {.lex_state = 388},
  [682] = {.lex_state = 230},
  [683] = {.lex_state = 388},
  [684] = {.lex_state = 388},
  [685] = {.lex_state = 388},
  [686] = {.lex_state = 230},
  [687] = {.lex_state = 388},
  [688] = {.lex_state = 388},
  [689] = {.lex_state = 388},
  [690] = {.lex_state = 230},
  [691] = {.lex_state = 388},
  [692] = {.lex_state = 388},
  [693] = {.lex_state = 388},
  [694] = {.lex_state = 388},
  [695] = {.lex_state = 230},
  [696] = {.lex_state = 388},
  [697] = {.lex_state = 388},
  [698] = {.lex_state = 388},
  [699] = {.lex_state = 388},
  [700] = {.lex_state = 388},
  [701] = {.lex_state = 230},
  [702] = {.lex_state = 388},
  [703] = {.lex_state = 388},
  [704] = {.lex_state = 388},
  [705] = {.lex_state = 230},
  [706] = {.lex_state = 230},
  [707] = {.lex_state = 388},
  [708] = {.lex_state = 388},
  [709] = {.lex_state = 388},
  [710] = {.lex_state = 388},
  [711] = {.lex_state = 388},
  [712] = {.lex_state = 388},
  [713] = {.lex_state = 230},
  [714] = {.lex_state = 388},
  [715] = {.lex_state = 230},
  [716] = {.lex_state = 194},
  [717] = {.lex_state = 388},
  [718] = {.lex_state = 388},
  [719] = {.lex_state = 230},
  [720] = {.lex_state = 388},
  [721] = {.lex_state = 388},
  [722] = {.lex_state = 388},
  [723] = {.lex_state = 388},
  [724] = {.lex_state = 388},
  [725] = {.lex_state = 388},
  [726] = {.lex_state = 230},
  [727] = {.lex_state = 230},
  [728] = {.lex_state = 388},
  [729] = {.lex_state = 388},
  [730] = {.lex_state = 388},
  [731] = {.lex_state = 388},
  [732] = {.lex_state = 388},
  [733] = {.lex_state = 388},
  [734] = {.lex_state = 287},
  [735] = {.lex_state = 388},
  [736] = {.lex_state = 388},
  [737] = {.lex_state = 388},
  [738] = {.lex_state = 388},
  [739] = {.lex_state = 230},
  [740] = {.lex_state = 388},
  [741] = {.lex_state = 230},
  [742] = {.lex_state = 230},
  [743] = {.lex_state = 388},
  [744] = {.lex_state = 230},
  [745] = {.lex_state = 388},
  [746] = {.lex_state = 388},
  [747] = {.lex_state = 230},
  [748] = {.lex_state = 230},
  [749] = {.lex_state = 388},
  [750] = {.lex_state = 388},
  [751] = {.lex_state = 388},
  [752] = {.lex_state = 230},
  [753] = {.lex_state = 388},
  [754] = {.lex_state = 388},
  [755] = {.lex_state = 388},
  [756] = {.lex_state = 388},
  [757] = {.lex_state = 388},
  [758] = {.lex_state = 388},
  [759] = {.lex_state = 388},
  [760] = {.lex_state = 388},
  [761] = {.lex_state = 230},
  [762] = {.lex_state = 388},
  [763] = {.lex_state = 287},
  [764] = {.lex_state = 388},
  [765] = {.lex_state = 388},
  [766] = {.lex_state = 388},
  [767] = {.lex_state = 388},
  [768] = {.lex_state = 388},
  [769] = {.lex_state = 230},
  [770] = {.lex_state = 388},
  [771] = {.lex_state = 388},
  [772] = {.lex_state = 230},
  [773] = {.lex_state = 230},
  [774] = {.lex_state = 287},
  [775] = {.lex_state = 388},
  [776] = {.lex_state = 199},
  [777] = {.lex_state = 199},
  [778] = {.lex_state = 193},
  [779] = {.lex_state = 286},
  [780] = {.lex_state = 286},
  [781] = {.lex_state = 286},
  [782] = {.lex_state = 286},
  [783] = {.lex_state = 286},
  [784] = {.lex_state = 286},
  [785] = {.lex_state = 286},
  [786] = {.lex_state = 193},
  [787] = {.lex_state = 388},
  [788] = {.lex_state = 388},
  [789] = {.lex_state = 193},
  [790] = {.lex_state = 286},
  [791] = {.lex_state = 286},
  [792] = {.lex_state = 286},
  [793] = {.lex_state = 193},
  [794] = {.lex_state = 193},
  [795] = {.lex_state = 286},
  [796] = {.lex_state = 286},
  [797] = {.lex_state = 286},
  [798] = {.lex_state = 198},
  [799] = {.lex_state = 197},
  [800] = {.lex_state = 286},
  [801] = {.lex_state = 218},
  [802] = {.lex_state = 193},
  [803] = {.lex_state = 388},
  [804] = {.lex_state = 218},
  [805] = {.lex_state = 218},
  [806] = {.lex_state = 218},
  [807] = {.lex_state = 203},
  [808] = {.lex_state = 218},
  [809] = {.lex_state = 203},
  [810] = {.lex_state = 206},
  [811] = {.lex_state = 206},
  [812] = {.lex_state = 206},
  [813] = {.lex_state = 206},
  [814] = {.lex_state = 206},
  [815] = {.lex_state = 206},
  [816] = {.lex_state = 206},
  [817] = {.lex_state = 203},
  [818] = {.lex_state = 206},
  [819] = {.lex_state = 206},
  [820] = {.lex_state = 203},
  [821] = {.lex_state = 206},
  [822] = {.lex_state = 206},
  [823] = {.lex_state = 203},
  [824] = {.lex_state = 206},
  [825] = {.lex_state = 206},
  [826] = {.lex_state = 206},
  [827] = {.lex_state = 203},
  [828] = {.lex_state = 206},
  [829] = {.lex_state = 206},
  [830] = {.lex_state = 206},
  [831] = {.lex_state = 206},
  [832] = {.lex_state = 206},
  [833] = {.lex_state = 206},
  [834] = {.lex_state = 206},
  [835] = {.lex_state = 206},
  [836] = {.lex_state = 203},
  [837] = {.lex_state = 206},
  [838] = {.lex_state = 203},
  [839] = {.lex_state = 203},
  [840] = {.lex_state = 203},
  [841] = {.lex_state = 203},
  [842] = {.lex_state = 203},
  [843] = {.lex_state = 203},
  [844] = {.lex_state = 203},
  [845] = {.lex_state = 203},
  [846] = {.lex_state = 203},
  [847] = {.lex_state = 286},
  [848] = {.lex_state = 203},
  [849] = {.lex_state = 203},
  [850] = {.lex_state = 203},
  [851] = {.lex_state = 203},
  [852] = {.lex_state = 203},
  [853] = {.lex_state = 203},
  [854] = {.lex_state = 203},
  [855] = {.lex_state = 203},
  [856] = {.lex_state = 203},
  [857] = {.lex_state = 203},
  [858] = {.lex_state = 203},
  [859] = {.lex_state = 203},
  [860] = {.lex_state = 203},
  [861] = {.lex_state = 203},
  [862] = {.lex_state = 203},
  [863] = {.lex_state = 203},
  [864] = {.lex_state = 203},
  [865] = {.lex_state = 203},
  [866] = {.lex_state = 203},
  [867] = {.lex_state = 203},
  [868] = {.lex_state = 203},
  [869] = {.lex_state = 203},
  [870] = {.lex_state = 203},
  [871] = {.lex_state = 203},
  [872] = {.lex_state = 203},
  [873] = {.lex_state = 203},
  [874] = {.lex_state = 203},
  [875] = {.lex_state = 203},
  [876] = {.lex_state = 203},
  [877] = {.lex_state = 203},
  [878] = {.lex_state = 203},
  [879] = {.lex_state = 218},
  [880] = {.lex_state = 218},
  [881] = {.lex_state = 218},
  [882] = {.lex_state = 218},
  [883] = {.lex_state = 218},
  [884] = {.lex_state = 218},
  [885] = {.lex_state = 214},
  [886] = {.lex_state = 218},
  [887] = {.lex_state = 205},
  [888] = {.lex_state = 205},
  [889] = {.lex_state = 231},
  [890] = {.lex_state = 231},
  [891] = {.lex_state = 231},
  [892] = {.lex_state = 231},
  [893] = {.lex_state = 231},
  [894] = {.lex_state = 231},
  [895] = {.lex_state = 231},
  [896] = {.lex_state = 231},
  [897] = {.lex_state = 206},
  [898] = {.lex_state = 206},
  [899] = {.lex_state = 206},
  [900] = {.lex_state = 206},
  [901] = {.lex_state = 206},
  [902] = {.lex_state = 206},
  [903] = {.lex_state = 206},
  [904] = {.lex_state = 206},
  [905] = {.lex_state = 206},
  [906] = {.lex_state = 231},
  [907] = {.lex_state = 206},
  [908] = {.lex_state = 206},
  [909] = {.lex_state = 206},
  [910] = {.lex_state = 206},
  [911] = {.lex_state = 206},
  [912] = {.lex_state = 206},
  [913] = {.lex_state = 206},
  [914] = {.lex_state = 206},
  [915] = {.lex_state = 206},
  [916] = {.lex_state = 206},
  [917] = {.lex_state = 206},
  [918] = {.lex_state = 206},
  [919] = {.lex_state = 206},
  [920] = {.lex_state = 206},
  [921] = {.lex_state = 206},
  [922] = {.lex_state = 206},
  [923] = {.lex_state = 206},
  [924] = {.lex_state = 206},
  [925] = {.lex_state = 206},
  [926] = {.lex_state = 206},
  [927] = {.lex_state = 206},
  [928] = {.lex_state = 206},
  [929] = {.lex_state = 206},
  [930] = {.lex_state = 206},
  [931] = {.lex_state = 206},
  [932] = {.lex_state = 206},
  [933] = {.lex_state = 206},
  [934] = {.lex_state = 206},
  [935] = {.lex_state = 206},
  [936] = {.lex_state = 206},
  [937] = {.lex_state = 206},
  [938] = {.lex_state = 206},
  [939] = {.lex_state = 206},
  [940] = {.lex_state = 206},
  [941] = {.lex_state = 206},
  [942] = {.lex_state = 206},
  [943] = {.lex_state = 206},
  [944] = {.lex_state = 206},
  [945] = {.lex_state = 206},
  [946] = {.lex_state = 206},
  [947] = {.lex_state = 286},
  [948] = {.lex_state = 286},
  [949] = {.lex_state = 286},
  [950] = {.lex_state = 286},
  [951] = {.lex_state = 286},
  [952] = {.lex_state = 286},
  [953] = {.lex_state = 206},
  [954] = {.lex_state = 229},
  [955] = {.lex_state = 206},
  [956] = {.lex_state = 206},
  [957] = {.lex_state = 206},
  [958] = {.lex_state = 206},
  [959] = {.lex_state = 206},
  [960] = {.lex_state = 231},
  [961] = {.lex_state = 206},
  [962] = {.lex_state = 203},
  [963] = {.lex_state = 203},
  [964] = {.lex_state = 206},
  [965] = {.lex_state = 203},
  [966] = {.lex_state = 206},
  [967] = {.lex_state = 206},
  [968] = {.lex_state = 206},
  [969] = {.lex_state = 206},
  [970] = {.lex_state = 206},
  [971] = {.lex_state = 206},
  [972] = {.lex_state = 229},
  [973] = {.lex_state = 206},
  [974] = {.lex_state = 207},
  [975] = {.lex_state = 229},
  [976] = {.lex_state = 206},
  [977] = {.lex_state = 229},
  [978] = {.lex_state = 206},
  [979] = {.lex_state = 229},
  [980] = {.lex_state = 229},
  [981] = {.lex_state = 207},
  [982] = {.lex_state = 206},
  [983] = {.lex_state = 206},
  [984] = {.lex_state = 229},
  [985] = {.lex_state = 207},
  [986] = {.lex_state = 206},
  [987] = {.lex_state = 206},
  [988] = {.lex_state = 231},
  [989] = {.lex_state = 206},
  [990] = {.lex_state = 231},
  [991] = {.lex_state = 229},
  [992] = {.lex_state = 206},
  [993] = {.lex_state = 206},
  [994] = {.lex_state = 206},
  [995] = {.lex_state = 206},
  [996] = {.lex_state = 229},
  [997] = {.lex_state = 206},
  [998] = {.lex_state = 205},
  [999] = {.lex_state = 206},
  [1000] = {.lex_state = 206},
  [1001] = {.lex_state = 205},
  [1002] = {.lex_state = 206},
  [1003] = {.lex_state = 206},
  [1004] = {.lex_state = 205},
  [1005] = {.lex_state = 205},
  [1006] = {.lex_state = 205},
  [1007] = {.lex_state = 205},
  [1008] = {.lex_state = 205},
  [1009] = {.lex_state = 205},
  [1010] = {.lex_state = 206},
  [1011] = {.lex_state = 205},
  [1012] = {.lex_state = 231},
  [1013] = {.lex_state = 205},
  [1014] = {.lex_state = 206},
  [1015] = {.lex_state = 206},
  [1016] = {.lex_state = 206},
  [1017] = {.lex_state = 205},
  [1018] = {.lex_state = 206},
  [1019] = {.lex_state = 206},
  [1020] = {.lex_state = 206},
  [1021] = {.lex_state = 206},
  [1022] = {.lex_state = 206},
  [1023] = {.lex_state = 206},
  [1024] = {.lex_state = 206},
  [1025] = {.lex_state = 206},
  [1026] = {.lex_state = 206},
  [1027] = {.lex_state = 205},
  [1028] = {.lex_state = 206},
  [1029] = {.lex_state = 205},
  [1030] = {.lex_state = 206},
  [1031] = {.lex_state = 267},
  [1032] = {.lex_state = 206},
  [1033] = {.lex_state = 205},
  [1034] = {.lex_state = 267},
  [1035] = {.lex_state = 206},
  [1036] = {.lex_state = 267},
  [1037] = {.lex_state = 205},
  [1038] = {.lex_state = 206},
  [1039] = {.lex_state = 206},
  [1040] = {.lex_state = 205},
  [1041] = {.lex_state = 205},
  [1042] = {.lex_state = 206},
  [1043] = {.lex_state = 206},
  [1044] = {.lex_state = 206},
  [1045] = {.lex_state = 206},
  [1046] = {.lex_state = 206},
  [1047] = {.lex_state = 205},
  [1048] = {.lex_state = 206},
  [1049] = {.lex_state = 206},
  [1050] = {.lex_state = 206},
  [1051] = {.lex_state = 206},
  [1052] = {.lex_state = 205},
  [1053] = {.lex_state = 205},
  [1054] = {.lex_state = 206},
  [1055] = {.lex_state = 205},
  [1056] = {.lex_state = 206},
  [1057] = {.lex_state = 206},
  [1058] = {.lex_state = 206},
  [1059] = {.lex_state = 205},
  [1060] = {.lex_state = 206},
  [1061] = {.lex_state = 205},
  [1062] = {.lex_state = 267},
  [1063] = {.lex_state = 206},
  [1064] = {.lex_state = 205},
  [1065] = {.lex_state = 205},
  [1066] = {.lex_state = 206},
  [1067] = {.lex_state = 205},
  [1068] = {.lex_state = 206},
  [1069] = {.lex_state = 206},
  [1070] = {.lex_state = 206},
  [1071] = {.lex_state = 206},
  [1072] = {.lex_state = 205},
  [1073] = {.lex_state = 206},
  [1074] = {.lex_state = 267},
  [1075] = {.lex_state = 267},
  [1076] = {.lex_state = 267},
  [1077] = {.lex_state = 205},
  [1078] = {.lex_state = 206},
  [1079] = {.lex_state = 206},
  [1080] = {.lex_state = 206},
  [1081] = {.lex_state = 205},
  [1082] = {.lex_state = 206},
  [1083] = {.lex_state = 205},
  [1084] = {.lex_state = 206},
  [1085] = {.lex_state = 206},
  [1086] = {.lex_state = 206},
  [1087] = {.lex_state = 206},
  [1088] = {.lex_state = 206},
  [1089] = {.lex_state = 206},
  [1090] = {.lex_state = 206},
  [1091] = {.lex_state = 206},
  [1092] = {.lex_state = 206},
  [1093] = {.lex_state = 206},
  [1094] = {.lex_state = 206},
  [1095] = {.lex_state = 206},
  [1096] = {.lex_state = 206},
  [1097] = {.lex_state = 206},
  [1098] = {.lex_state = 206},
  [1099] = {.lex_state = 206},
  [1100] = {.lex_state = 206},
  [1101] = {.lex_state = 206},
  [1102] = {.lex_state = 206},
  [1103] = {.lex_state = 206},
  [1104] = {.lex_state = 206},
  [1105] = {.lex_state = 206},
  [1106] = {.lex_state = 206},
  [1107] = {.lex_state = 206},
  [1108] = {.lex_state = 206},
  [1109] = {.lex_state = 206},
  [1110] = {.lex_state = 206},
  [1111] = {.lex_state = 206},
  [1112] = {.lex_state = 206},
  [1113] = {.lex_state = 206},
  [1114] = {.lex_state = 206},
  [1115] = {.lex_state = 206},
  [1116] = {.lex_state = 206},
  [1117] = {.lex_state = 206},
  [1118] = {.lex_state = 206},
  [1119] = {.lex_state = 206},
  [1120] = {.lex_state = 206},
  [1121] = {.lex_state = 206},
  [1122] = {.lex_state = 206},
  [1123] = {.lex_state = 206},
  [1124] = {.lex_state = 206},
  [1125] = {.lex_state = 206},
  [1126] = {.lex_state = 206},
  [1127] = {.lex_state = 206},
  [1128] = {.lex_state = 206},
  [1129] = {.lex_state = 206},
  [1130] = {.lex_state = 206},
  [1131] = {.lex_state = 206},
  [1132] = {.lex_state = 206},
  [1133] = {.lex_state = 206},
  [1134] = {.lex_state = 206},
  [1135] = {.lex_state = 206},
  [1136] = {.lex_state = 206},
  [1137] = {.lex_state = 206},
  [1138] = {.lex_state = 206},
  [1139] = {.lex_state = 206},
  [1140] = {.lex_state = 206},
  [1141] = {.lex_state = 206},
  [1142] = {.lex_state = 206},
  [1143] = {.lex_state = 206},
  [1144] = {.lex_state = 206},
  [1145] = {.lex_state = 206},
  [1146] = {.lex_state = 206},
  [1147] = {.lex_state = 206},
  [1148] = {.lex_state = 206},
  [1149] = {.lex_state = 229},
  [1150] = {.lex_state = 206},
  [1151] = {.lex_state = 206},
  [1152] = {.lex_state = 206},
  [1153] = {.lex_state = 206},
  [1154] = {.lex_state = 206},
  [1155] = {.lex_state = 206},
  [1156] = {.lex_state = 206},
  [1157] = {.lex_state = 206},
  [1158] = {.lex_state = 229},
  [1159] = {.lex_state = 206},
  [1160] = {.lex_state = 206},
  [1161] = {.lex_state = 206},
  [1162] = {.lex_state = 206},
  [1163] = {.lex_state = 206},
  [1164] = {.lex_state = 206},
  [1165] = {.lex_state = 229},
  [1166] = {.lex_state = 206},
  [1167] = {.lex_state = 229},
  [1168] = {.lex_state = 206},
  [1169] = {.lex_state = 229},
  [1170] = {.lex_state = 206},
  [1171] = {.lex_state = 229},
  [1172] = {.lex_state = 229},
  [1173] = {.lex_state = 206},
  [1174] = {.lex_state = 229},
  [1175] = {.lex_state = 206},
  [1176] = {.lex_state = 206},
  [1177] = {.lex_state = 206},
  [1178] = {.lex_state = 206},
  [1179] = {.lex_state = 206},
  [1180] = {.lex_state = 206},
  [1181] = {.lex_state = 206},
  [1182] = {.lex_state = 206},
  [1183] = {.lex_state = 206},
  [1184] = {.lex_state = 206},
  [1185] = {.lex_state = 206},
  [1186] = {.lex_state = 206},
  [1187] = {.lex_state = 206},
  [1188] = {.lex_state = 206},
  [1189] = {.lex_state = 206},
  [1190] = {.lex_state = 206},
  [1191] = {.lex_state = 206},
  [1192] = {.lex_state = 206},
  [1193] = {.lex_state = 206},
  [1194] = {.lex_state = 206},
  [1195] = {.lex_state = 206},
  [1196] = {.lex_state = 206},
  [1197] = {.lex_state = 206},
  [1198] = {.lex_state = 206},
  [1199] = {.lex_state = 206},
  [1200] = {.lex_state = 206},
  [1201] = {.lex_state = 206},
  [1202] = {.lex_state = 206},
  [1203] = {.lex_state = 206},
  [1204] = {.lex_state = 206},
  [1205] = {.lex_state = 206},
  [1206] = {.lex_state = 206},
  [1207] = {.lex_state = 206},
  [1208] = {.lex_state = 206},
  [1209] = {.lex_state = 206},
  [1210] = {.lex_state = 206},
  [1211] = {.lex_state = 206},
  [1212] = {.lex_state = 206},
  [1213] = {.lex_state = 206},
  [1214] = {.lex_state = 206},
  [1215] = {.lex_state = 206},
  [1216] = {.lex_state = 206},
  [1217] = {.lex_state = 206},
  [1218] = {.lex_state = 206},
  [1219] = {.lex_state = 206},
  [1220] = {.lex_state = 206},
  [1221] = {.lex_state = 206},
  [1222] = {.lex_state = 206},
  [1223] = {.lex_state = 206},
  [1224] = {.lex_state = 206},
  [1225] = {.lex_state = 206},
  [1226] = {.lex_state = 206},
  [1227] = {.lex_state = 206},
  [1228] = {.lex_state = 206},
  [1229] = {.lex_state = 206},
  [1230] = {.lex_state = 206},
  [1231] = {.lex_state = 206},
  [1232] = {.lex_state = 206},
  [1233] = {.lex_state = 206},
  [1234] = {.lex_state = 206},
  [1235] = {.lex_state = 206},
  [1236] = {.lex_state = 206},
  [1237] = {.lex_state = 206},
  [1238] = {.lex_state = 206},
  [1239] = {.lex_state = 206},
  [1240] = {.lex_state = 206},
  [1241] = {.lex_state = 206},
  [1242] = {.lex_state = 206},
  [1243] = {.lex_state = 206},
  [1244] = {.lex_state = 206},
  [1245] = {.lex_state = 206},
  [1246] = {.lex_state = 206},
  [1247] = {.lex_state = 206},
  [1248] = {.lex_state = 206},
  [1249] = {.lex_state = 206},
  [1250] = {.lex_state = 206},
  [1251] = {.lex_state = 206},
  [1252] = {.lex_state = 206},
  [1253] = {.lex_state = 206},
  [1254] = {.lex_state = 206},
  [1255] = {.lex_state = 206},
  [1256] = {.lex_state = 206},
  [1257] = {.lex_state = 206},
  [1258] = {.lex_state = 206},
  [1259] = {.lex_state = 206},
  [1260] = {.lex_state = 206},
  [1261] = {.lex_state = 206},
  [1262] = {.lex_state = 206},
  [1263] = {.lex_state = 206},
  [1264] = {.lex_state = 206},
  [1265] = {.lex_state = 206},
  [1266] = {.lex_state = 206},
  [1267] = {.lex_state = 206},
  [1268] = {.lex_state = 206},
  [1269] = {.lex_state = 206},
  [1270] = {.lex_state = 206},
  [1271] = {.lex_state = 206},
  [1272] = {.lex_state = 206},
  [1273] = {.lex_state = 206},
  [1274] = {.lex_state = 206},
  [1275] = {.lex_state = 206},
  [1276] = {.lex_state = 206},
  [1277] = {.lex_state = 206},
  [1278] = {.lex_state = 206},
  [1279] = {.lex_state = 206},
  [1280] = {.lex_state = 206},
  [1281] = {.lex_state = 206},
  [1282] = {.lex_state = 206},
  [1283] = {.lex_state = 206},
  [1284] = {.lex_state = 206},
  [1285] = {.lex_state = 206},
  [1286] = {.lex_state = 206},
  [1287] = {.lex_state = 206},
  [1288] = {.lex_state = 206},
  [1289] = {.lex_state = 206},
  [1290] = {.lex_state = 206},
  [1291] = {.lex_state = 206},
  [1292] = {.lex_state = 206},
  [1293] = {.lex_state = 206},
  [1294] = {.lex_state = 206},
  [1295] = {.lex_state = 206},
  [1296] = {.lex_state = 206},
  [1297] = {.lex_state = 206},
  [1298] = {.lex_state = 206},
  [1299] = {.lex_state = 206},
  [1300] = {.lex_state = 206},
  [1301] = {.lex_state = 206},
  [1302] = {.lex_state = 206},
  [1303] = {.lex_state = 206},
  [1304] = {.lex_state = 206},
  [1305] = {.lex_state = 206},
  [1306] = {.lex_state = 206},
  [1307] = {.lex_state = 206},
  [1308] = {.lex_state = 206},
  [1309] = {.lex_state = 206},
  [1310] = {.lex_state = 206},
  [1311] = {.lex_state = 206},
  [1312] = {.lex_state = 206},
  [1313] = {.lex_state = 206},
  [1314] = {.lex_state = 206},
  [1315] = {.lex_state = 206},
  [1316] = {.lex_state = 206},
  [1317] = {.lex_state = 206},
  [1318] = {.lex_state = 206},
  [1319] = {.lex_state = 206},
  [1320] = {.lex_state = 206},
  [1321] = {.lex_state = 206},
  [1322] = {.lex_state = 206},
  [1323] = {.lex_state = 206},
  [1324] = {.lex_state = 206},
  [1325] = {.lex_state = 206},
  [1326] = {.lex_state = 206},
  [1327] = {.lex_state = 206},
  [1328] = {.lex_state = 206},
  [1329] = {.lex_state = 206},
  [1330] = {.lex_state = 206},
  [1331] = {.lex_state = 206},
  [1332] = {.lex_state = 206},
  [1333] = {.lex_state = 206},
  [1334] = {.lex_state = 206},
  [1335] = {.lex_state = 206},
  [1336] = {.lex_state = 206},
  [1337] = {.lex_state = 206},
  [1338] = {.lex_state = 206},
  [1339] = {.lex_state = 206},
  [1340] = {.lex_state = 206},
  [1341] = {.lex_state = 206},
  [1342] = {.lex_state = 206},
  [1343] = {.lex_state = 206},
  [1344] = {.lex_state = 206},
  [1345] = {.lex_state = 206},
  [1346] = {.lex_state = 206},
  [1347] = {.lex_state = 206},
  [1348] = {.lex_state = 206},
  [1349] = {.lex_state = 206},
  [1350] = {.lex_state = 206},
  [1351] = {.lex_state = 206},
  [1352] = {.lex_state = 206},
  [1353] = {.lex_state = 206},
  [1354] = {.lex_state = 206},
  [1355] = {.lex_state = 206},
  [1356] = {.lex_state = 206},
  [1357] = {.lex_state = 206},
  [1358] = {.lex_state = 206},
  [1359] = {.lex_state = 206},
  [1360] = {.lex_state = 206},
  [1361] = {.lex_state = 206},
  [1362] = {.lex_state = 206},
  [1363] = {.lex_state = 206},
  [1364] = {.lex_state = 206},
  [1365] = {.lex_state = 206},
  [1366] = {.lex_state = 206},
  [1367] = {.lex_state = 206},
  [1368] = {.lex_state = 206},
  [1369] = {.lex_state = 206},
  [1370] = {.lex_state = 206},
  [1371] = {.lex_state = 206},
  [1372] = {.lex_state = 206},
  [1373] = {.lex_state = 206},
  [1374] = {.lex_state = 206},
  [1375] = {.lex_state = 206},
  [1376] = {.lex_state = 206},
  [1377] = {.lex_state = 206},
  [1378] = {.lex_state = 206},
  [1379] = {.lex_state = 206},
  [1380] = {.lex_state = 206},
  [1381] = {.lex_state = 206},
  [1382] = {.lex_state = 206},
  [1383] = {.lex_state = 206},
  [1384] = {.lex_state = 206},
  [1385] = {.lex_state = 206},
  [1386] = {.lex_state = 206},
  [1387] = {.lex_state = 206},
  [1388] = {.lex_state = 206},
  [1389] = {.lex_state = 206},
  [1390] = {.lex_state = 206},
  [1391] = {.lex_state = 206},
  [1392] = {.lex_state = 206},
  [1393] = {.lex_state = 206},
  [1394] = {.lex_state = 206},
  [1395] = {.lex_state = 206},
  [1396] = {.lex_state = 206},
  [1397] = {.lex_state = 206},
  [1398] = {.lex_state = 206},
  [1399] = {.lex_state = 206},
  [1400] = {.lex_state = 206},
  [1401] = {.lex_state = 206},
  [1402] = {.lex_state = 206},
  [1403] = {.lex_state = 206},
  [1404] = {.lex_state = 206},
  [1405] = {.lex_state = 206},
  [1406] = {.lex_state = 206},
  [1407] = {.lex_state = 206},
  [1408] = {.lex_state = 206},
  [1409] = {.lex_state = 206},
  [1410] = {.lex_state = 206},
  [1411] = {.lex_state = 206},
  [1412] = {.lex_state = 206},
  [1413] = {.lex_state = 206},
  [1414] = {.lex_state = 206},
  [1415] = {.lex_state = 206},
  [1416] = {.lex_state = 206},
  [1417] = {.lex_state = 206},
  [1418] = {.lex_state = 206},
  [1419] = {.lex_state = 206},
  [1420] = {.lex_state = 206},
  [1421] = {.lex_state = 206},
  [1422] = {.lex_state = 206},
  [1423] = {.lex_state = 206},
  [1424] = {.lex_state = 206},
  [1425] = {.lex_state = 206},
  [1426] = {.lex_state = 206},
  [1427] = {.lex_state = 206},
  [1428] = {.lex_state = 206},
  [1429] = {.lex_state = 206},
  [1430] = {.lex_state = 206},
  [1431] = {.lex_state = 206},
  [1432] = {.lex_state = 206},
  [1433] = {.lex_state = 206},
  [1434] = {.lex_state = 206},
  [1435] = {.lex_state = 206},
  [1436] = {.lex_state = 206},
  [1437] = {.lex_state = 206},
  [1438] = {.lex_state = 206},
  [1439] = {.lex_state = 206},
  [1440] = {.lex_state = 206},
  [1441] = {.lex_state = 206},
  [1442] = {.lex_state = 206},
  [1443] = {.lex_state = 206},
  [1444] = {.lex_state = 206},
  [1445] = {.lex_state = 206},
  [1446] = {.lex_state = 206},
  [1447] = {.lex_state = 206},
  [1448] = {.lex_state = 206},
  [1449] = {.lex_state = 206},
  [1450] = {.lex_state = 206},
  [1451] = {.lex_state = 206},
  [1452] = {.lex_state = 206},
  [1453] = {.lex_state = 206},
  [1454] = {.lex_state = 206},
  [1455] = {.lex_state = 206},
  [1456] = {.lex_state = 206},
  [1457] = {.lex_state = 206},
  [1458] = {.lex_state = 206},
  [1459] = {.lex_state = 206},
  [1460] = {.lex_state = 206},
  [1461] = {.lex_state = 206},
  [1462] = {.lex_state = 206},
  [1463] = {.lex_state = 206},
  [1464] = {.lex_state = 206},
  [1465] = {.lex_state = 206},
  [1466] = {.lex_state = 206},
  [1467] = {.lex_state = 206},
  [1468] = {.lex_state = 206},
  [1469] = {.lex_state = 206},
  [1470] = {.lex_state = 206},
  [1471] = {.lex_state = 206},
  [1472] = {.lex_state = 206},
  [1473] = {.lex_state = 206},
  [1474] = {.lex_state = 206},
  [1475] = {.lex_state = 206},
  [1476] = {.lex_state = 206},
  [1477] = {.lex_state = 206},
  [1478] = {.lex_state = 206},
  [1479] = {.lex_state = 206},
  [1480] = {.lex_state = 206},
  [1481] = {.lex_state = 206},
  [1482] = {.lex_state = 206},
  [1483] = {.lex_state = 206},
  [1484] = {.lex_state = 206},
  [1485] = {.lex_state = 206},
  [1486] = {.lex_state = 206},
  [1487] = {.lex_state = 206},
  [1488] = {.lex_state = 206},
  [1489] = {.lex_state = 206},
  [1490] = {.lex_state = 206},
  [1491] = {.lex_state = 206},
  [1492] = {.lex_state = 206},
  [1493] = {.lex_state = 206},
  [1494] = {.lex_state = 206},
  [1495] = {.lex_state = 206},
  [1496] = {.lex_state = 206},
  [1497] = {.lex_state = 206},
  [1498] = {.lex_state = 206},
  [1499] = {.lex_state = 206},
  [1500] = {.lex_state = 206},
  [1501] = {.lex_state = 206},
  [1502] = {.lex_state = 206},
  [1503] = {.lex_state = 206},
  [1504] = {.lex_state = 206},
  [1505] = {.lex_state = 206},
  [1506] = {.lex_state = 206},
  [1507] = {.lex_state = 206},
  [1508] = {.lex_state = 206},
  [1509] = {.lex_state = 206},
  [1510] = {.lex_state = 206},
  [1511] = {.lex_state = 206},
  [1512] = {.lex_state = 206},
  [1513] = {.lex_state = 206},
  [1514] = {.lex_state = 206},
  [1515] = {.lex_state = 206},
  [1516] = {.lex_state = 206},
  [1517] = {.lex_state = 206},
  [1518] = {.lex_state = 206},
  [1519] = {.lex_state = 206},
  [1520] = {.lex_state = 206},
  [1521] = {.lex_state = 206},
  [1522] = {.lex_state = 206},
  [1523] = {.lex_state = 206},
  [1524] = {.lex_state = 206},
  [1525] = {.lex_state = 206},
  [1526] = {.lex_state = 206},
  [1527] = {.lex_state = 206},
  [1528] = {.lex_state = 206},
  [1529] = {.lex_state = 206},
  [1530] = {.lex_state = 206},
  [1531] = {.lex_state = 206},
  [1532] = {.lex_state = 206},
  [1533] = {.lex_state = 206},
  [1534] = {.lex_state = 206},
  [1535] = {.lex_state = 206},
  [1536] = {.lex_state = 206},
  [1537] = {.lex_state = 206},
  [1538] = {.lex_state = 206},
  [1539] = {.lex_state = 206},
  [1540] = {.lex_state = 206},
  [1541] = {.lex_state = 206},
  [1542] = {.lex_state = 206},
  [1543] = {.lex_state = 206},
  [1544] = {.lex_state = 206},
  [1545] = {.lex_state = 206},
  [1546] = {.lex_state = 206},
  [1547] = {.lex_state = 206},
  [1548] = {.lex_state = 206},
  [1549] = {.lex_state = 206},
  [1550] = {.lex_state = 206},
  [1551] = {.lex_state = 206},
  [1552] = {.lex_state = 206},
  [1553] = {.lex_state = 206},
  [1554] = {.lex_state = 206},
  [1555] = {.lex_state = 206},
  [1556] = {.lex_state = 206},
  [1557] = {.lex_state = 206},
  [1558] = {.lex_state = 206},
  [1559] = {.lex_state = 206},
  [1560] = {.lex_state = 206},
  [1561] = {.lex_state = 206},
  [1562] = {.lex_state = 214},
  [1563] = {.lex_state = 206},
  [1564] = {.lex_state = 206},
  [1565] = {.lex_state = 206},
  [1566] = {.lex_state = 206},
  [1567] = {.lex_state = 206},
  [1568] = {.lex_state = 206},
  [1569] = {.lex_state = 206},
  [1570] = {.lex_state = 206},
  [1571] = {.lex_state = 206},
  [1572] = {.lex_state = 206},
  [1573] = {.lex_state = 206},
  [1574] = {.lex_state = 206},
  [1575] = {.lex_state = 206},
  [1576] = {.lex_state = 206},
  [1577] = {.lex_state = 206},
  [1578] = {.lex_state = 206},
  [1579] = {.lex_state = 206},
  [1580] = {.lex_state = 206},
  [1581] = {.lex_state = 206},
  [1582] = {.lex_state = 206},
  [1583] = {.lex_state = 206},
  [1584] = {.lex_state = 206},
  [1585] = {.lex_state = 206},
  [1586] = {.lex_state = 206},
  [1587] = {.lex_state = 206},
  [1588] = {.lex_state = 206},
  [1589] = {.lex_state = 206},
  [1590] = {.lex_state = 206},
  [1591] = {.lex_state = 206},
  [1592] = {.lex_state = 206},
  [1593] = {.lex_state = 206},
  [1594] = {.lex_state = 206},
  [1595] = {.lex_state = 206},
  [1596] = {.lex_state = 206},
  [1597] = {.lex_state = 206},
  [1598] = {.lex_state = 206},
  [1599] = {.lex_state = 206},
  [1600] = {.lex_state = 206},
  [1601] = {.lex_state = 206},
  [1602] = {.lex_state = 206},
  [1603] = {.lex_state = 206},
  [1604] = {.lex_state = 206},
  [1605] = {.lex_state = 206},
  [1606] = {.lex_state = 206},
  [1607] = {.lex_state = 206},
  [1608] = {.lex_state = 206},
  [1609] = {.lex_state = 206},
  [1610] = {.lex_state = 206},
  [1611] = {.lex_state = 206},
  [1612] = {.lex_state = 206},
  [1613] = {.lex_state = 206},
  [1614] = {.lex_state = 206},
  [1615] = {.lex_state = 206},
  [1616] = {.lex_state = 206},
  [1617] = {.lex_state = 206},
  [1618] = {.lex_state = 206},
  [1619] = {.lex_state = 206},
  [1620] = {.lex_state = 206},
  [1621] = {.lex_state = 206},
  [1622] = {.lex_state = 206},
  [1623] = {.lex_state = 206},
  [1624] = {.lex_state = 206},
  [1625] = {.lex_state = 206},
  [1626] = {.lex_state = 206},
  [1627] = {.lex_state = 206},
  [1628] = {.lex_state = 206},
  [1629] = {.lex_state = 206},
  [1630] = {.lex_state = 206},
  [1631] = {.lex_state = 206},
  [1632] = {.lex_state = 206},
  [1633] = {.lex_state = 206},
  [1634] = {.lex_state = 206},
  [1635] = {.lex_state = 206},
  [1636] = {.lex_state = 206},
  [1637] = {.lex_state = 206},
  [1638] = {.lex_state = 206},
  [1639] = {.lex_state = 206},
  [1640] = {.lex_state = 206},
  [1641] = {.lex_state = 215},
  [1642] = {.lex_state = 219},
  [1643] = {.lex_state = 209},
  [1644] = {.lex_state = 267},
  [1645] = {.lex_state = 286},
  [1646] = {.lex_state = 286},
  [1647] = {.lex_state = 286},
  [1648] = {.lex_state = 286},
  [1649] = {.lex_state = 286},
  [1650] = {.lex_state = 232},
  [1651] = {.lex_state = 286},
  [1652] = {.lex_state = 286},
  [1653] = {.lex_state = 286},
  [1654] = {.lex_state = 232},
  [1655] = {.lex_state = 286},
  [1656] = {.lex_state = 286},
  [1657] = {.lex_state = 286},
  [1658] = {.lex_state = 232},
  [1659] = {.lex_state = 232},
  [1660] = {.lex_state = 286},
  [1661] = {.lex_state = 232},
  [1662] = {.lex_state = 232},
  [1663] = {.lex_state = 232},
  [1664] = {.lex_state = 286},
  [1665] = {.lex_state = 286},
  [1666] = {.lex_state = 286},
  [1667] = {.lex_state = 286},
  [1668] = {.lex_state = 286},
  [1669] = {.lex_state = 286},
  [1670] = {.lex_state = 286},
  [1671] = {.lex_state = 286},
  [1672] = {.lex_state = 286},
  [1673] = {.lex_state = 286},
  [1674] = {.lex_state = 286},
  [1675] = {.lex_state = 286},
  [1676] = {.lex_state = 286},
  [1677] = {.lex_state = 286},
  [1678] = {.lex_state = 286},
  [1679] = {.lex_state = 286},
  [1680] = {.lex_state = 286},
  [1681] = {.lex_state = 267},
  [1682] = {.lex_state = 267},
  [1683] = {.lex_state = 286},
  [1684] = {.lex_state = 286},
  [1685] = {.lex_state = 286},
  [1686] = {.lex_state = 286},
  [1687] = {.lex_state = 286},
  [1688] = {.lex_state = 286},
  [1689] = {.lex_state = 286},
  [1690] = {.lex_state = 286},
  [1691] = {.lex_state = 286},
  [1692] = {.lex_state = 286},
  [1693] = {.lex_state = 286},
  [1694] = {.lex_state = 286},
  [1695] = {.lex_state = 267},
  [1696] = {.lex_state = 286},
  [1697] = {.lex_state = 267},
  [1698] = {.lex_state = 267},
  [1699] = {.lex_state = 267},
  [1700] = {.lex_state = 286},
  [1701] = {.lex_state = 267},
  [1702] = {.lex_state = 267},
  [1703] = {.lex_state = 267},
  [1704] = {.lex_state = 267},
  [1705] = {.lex_state = 267},
  [1706] = {.lex_state = 267},
  [1707] = {.lex_state = 286},
  [1708] = {.lex_state = 267},
  [1709] = {.lex_state = 286},
  [1710] = {.lex_state = 240},
  [1711] = {.lex_state = 244},
  [1712] = {.lex_state = 244},
  [1713] = {.lex_state = 244},
  [1714] = {.lex_state = 286},
  [1715] = {.lex_state = 286},
  [1716] = {.lex_state = 244},
  [1717] = {.lex_state = 244},
  [1718] = {.lex_state = 244},
  [1719] = {.lex_state = 244},
  [1720] = {.lex_state = 286},
  [1721] = {.lex_state = 286},
  [1722] = {.lex_state = 286},
  [1723] = {.lex_state = 286},
  [1724] = {.lex_state = 251},
  [1725] = {.lex_state = 286},
  [1726] = {.lex_state = 286},
  [1727] = {.lex_state = 251},
  [1728] = {.lex_state = 286},
  [1729] = {.lex_state = 251},
  [1730] = {.lex_state = 251},
  [1731] = {.lex_state = 286},
  [1732] = {.lex_state = 251},
  [1733] = {.lex_state = 251},
  [1734] = {.lex_state = 251},
  [1735] = {.lex_state = 286},
  [1736] = {.lex_state = 286},
  [1737] = {.lex_state = 286},
  [1738] = {.lex_state = 286},
  [1739] = {.lex_state = 286},
  [1740] = {.lex_state = 286},
  [1741] = {.lex_state = 286},
  [1742] = {.lex_state = 286},
  [1743] = {.lex_state = 286},
  [1744] = {.lex_state = 286},
  [1745] = {.lex_state = 286},
  [1746] = {.lex_state = 286},
  [1747] = {.lex_state = 286},
  [1748] = {.lex_state = 286},
  [1749] = {.lex_state = 286},
  [1750] = {.lex_state = 286},
  [1751] = {.lex_state = 286},
  [1752] = {.lex_state = 286},
  [1753] = {.lex_state = 286},
  [1754] = {.lex_state = 286},
  [1755] = {.lex_state = 286},
  [1756] = {.lex_state = 286},
  [1757] = {.lex_state = 286},
  [1758] = {.lex_state = 286},
  [1759] = {.lex_state = 286},
  [1760] = {.lex_state = 286},
  [1761] = {.lex_state = 286},
  [1762] = {.lex_state = 286},
  [1763] = {.lex_state = 286},
  [1764] = {.lex_state = 286},
  [1765] = {.lex_state = 286},
  [1766] = {.lex_state = 286},
  [1767] = {.lex_state = 286},
  [1768] = {.lex_state = 286},
  [1769] = {.lex_state = 286},
  [1770] = {.lex_state = 286},
  [1771] = {.lex_state = 286},
  [1772] = {.lex_state = 286},
  [1773] = {.lex_state = 286},
  [1774] = {.lex_state = 286},
  [1775] = {.lex_state = 286},
  [1776] = {.lex_state = 286},
  [1777] = {.lex_state = 286},
  [1778] = {.lex_state = 286},
  [1779] = {.lex_state = 286},
  [1780] = {.lex_state = 286},
  [1781] = {.lex_state = 286},
  [1782] = {.lex_state = 286},
  [1783] = {.lex_state = 286},
  [1784] = {.lex_state = 286},
  [1785] = {.lex_state = 286},
  [1786] = {.lex_state = 286},
  [1787] = {.lex_state = 286},
  [1788] = {.lex_state = 286},
  [1789] = {.lex_state = 286},
  [1790] = {.lex_state = 286},
  [1791] = {.lex_state = 286},
  [1792] = {.lex_state = 286},
  [1793] = {.lex_state = 286},
  [1794] = {.lex_state = 286},
  [1795] = {.lex_state = 286},
  [1796] = {.lex_state = 286},
  [1797] = {.lex_state = 286},
  [1798] = {.lex_state = 286},
  [1799] = {.lex_state = 286},
  [1800] = {.lex_state = 286},
  [1801] = {.lex_state = 286},
  [1802] = {.lex_state = 286},
  [1803] = {.lex_state = 286},
  [1804] = {.lex_state = 286},
  [1805] = {.lex_state = 286},
  [1806] = {.lex_state = 286},
  [1807] = {.lex_state = 286},
  [1808] = {.lex_state = 286},
  [1809] = {.lex_state = 286},
  [1810] = {.lex_state = 286},
  [1811] = {.lex_state = 286},
  [1812] = {.lex_state = 286},
  [1813] = {.lex_state = 286},
  [1814] = {.lex_state = 286},
  [1815] = {.lex_state = 286},
  [1816] = {.lex_state = 286},
  [1817] = {.lex_state = 287},
  [1818] = {.lex_state = 287},
  [1819] = {.lex_state = 286},
  [1820] = {.lex_state = 286},
  [1821] = {.lex_state = 286},
  [1822] = {.lex_state = 286},
  [1823] = {.lex_state = 230},
  [1824] = {.lex_state = 286},
  [1825] = {.lex_state = 287},
  [1826] = {.lex_state = 230},
  [1827] = {.lex_state = 286},
  [1828] = {.lex_state = 230},
  [1829] = {.lex_state = 230},
  [1830] = {.lex_state = 286},
  [1831] = {.lex_state = 229},
  [1832] = {.lex_state = 286},
  [1833] = {.lex_state = 286},
  [1834] = {.lex_state = 287},
  [1835] = {.lex_state = 286},
  [1836] = {.lex_state = 229},
  [1837] = {.lex_state = 286},
  [1838] = {.lex_state = 287},
  [1839] = {.lex_state = 286},
  [1840] = {.lex_state = 286},
  [1841] = {.lex_state = 286},
  [1842] = {.lex_state = 287},
  [1843] = {.lex_state = 230},
  [1844] = {.lex_state = 244},
  [1845] = {.lex_state = 230},
  [1846] = {.lex_state = 206},
  [1847] = {.lex_state = 286},
  [1848] = {.lex_state = 240},
  [1849] = {.lex_state = 268},
  [1850] = {.lex_state = 268},
  [1851] = {.lex_state = 268},
  [1852] = {.lex_state = 244},
  [1853] = {.lex_state = 268},
  [1854] = {.lex_state = 230},
  [1855] = {.lex_state = 209},
  [1856] = {.lex_state = 268},
  [1857] = {.lex_state = 268},
  [1858] = {.lex_state = 287},
  [1859] = {.lex_state = 268},
  [1860] = {.lex_state = 268},
  [1861] = {.lex_state = 268},
  [1862] = {.lex_state = 251},
  [1863] = {.lex_state = 268},
  [1864] = {.lex_state = 268},
  [1865] = {.lex_state = 287},
  [1866] = {.lex_state = 268},
  [1867] = {.lex_state = 286},
  [1868] = {.lex_state = 286},
  [1869] = {.lex_state = 287},
  [1870] = {.lex_state = 230},
  [1871] = {.lex_state = 286},
  [1872] = {.lex_state = 230},
  [1873] = {.lex_state = 268},
  [1874] = {.lex_state = 240},
  [1875] = {.lex_state = 230},
  [1876] = {.lex_state = 287},
  [1877] = {.lex_state = 287},
  [1878] = {.lex_state = 230},
  [1879] = {.lex_state = 230},
  [1880] = {.lex_state = 230},
  [1881] = {.lex_state = 287},
  [1882] = {.lex_state = 230},
  [1883] = {.lex_state = 230},
  [1884] = {.lex_state = 230},
  [1885] = {.lex_state = 230},
  [1886] = {.lex_state = 230},
  [1887] = {.lex_state = 287},
  [1888] = {.lex_state = 230},
  [1889] = {.lex_state = 287},
  [1890] = {.lex_state = 287},
  [1891] = {.lex_state = 287},
  [1892] = {.lex_state = 287},
  [1893] = {.lex_state = 230},
  [1894] = {.lex_state = 287},
  [1895] = {.lex_state = 287},
  [1896] = {.lex_state = 240},
  [1897] = {.lex_state = 287},
  [1898] = {.lex_state = 230},
  [1899] = {.lex_state = 287},
  [1900] = {.lex_state = 287},
  [1901] = {.lex_state = 287},
  [1902] = {.lex_state = 287},
  [1903] = {.lex_state = 287},
  [1904] = {.lex_state = 287},
  [1905] = {.lex_state = 287},
  [1906] = {.lex_state = 287},
  [1907] = {.lex_state = 287},
  [1908] = {.lex_state = 287},
  [1909] = {.lex_state = 240},
  [1910] = {.lex_state = 287},
  [1911] = {.lex_state = 287},
  [1912] = {.lex_state = 287},
  [1913] = {.lex_state = 287},
  [1914] = {.lex_state = 240},
  [1915] = {.lex_state = 287},
  [1916] = {.lex_state = 240},
  [1917] = {.lex_state = 287},
  [1918] = {.lex_state = 287},
  [1919] = {.lex_state = 287},
  [1920] = {.lex_state = 287},
  [1921] = {.lex_state = 287},
  [1922] = {.lex_state = 285},
  [1923] = {.lex_state = 287},
  [1924] = {.lex_state = 287},
  [1925] = {.lex_state = 287},
  [1926] = {.lex_state = 230},
  [1927] = {.lex_state = 287},
  [1928] = {.lex_state = 287},
  [1929] = {.lex_state = 287},
  [1930] = {.lex_state = 230},
  [1931] = {.lex_state = 230},
  [1932] = {.lex_state = 240},
  [1933] = {.lex_state = 287},
  [1934] = {.lex_state = 287},
  [1935] = {.lex_state = 230},
  [1936] = {.lex_state = 287},
  [1937] = {.lex_state = 240},
  [1938] = {.lex_state = 287},
  [1939] = {.lex_state = 287},
  [1940] = {.lex_state = 240},
  [1941] = {.lex_state = 230},
  [1942] = {.lex_state = 240},
  [1943] = {.lex_state = 287},
  [1944] = {.lex_state = 240},
  [1945] = {.lex_state = 240},
  [1946] = {.lex_state = 287},
  [1947] = {.lex_state = 230},
  [1948] = {.lex_state = 240},
  [1949] = {.lex_state = 230},
  [1950] = {.lex_state = 230},
  [1951] = {.lex_state = 240},
  [1952] = {.lex_state = 240},
  [1953] = {.lex_state = 230},
  [1954] = {.lex_state = 230},
  [1955] = {.lex_state = 287},
  [1956] = {.lex_state = 287},
  [1957] = {.lex_state = 287},
  [1958] = {.lex_state = 287},
  [1959] = {.lex_state = 287},
  [1960] = {.lex_state = 287},
  [1961] = {.lex_state = 287},
  [1962] = {.lex_state = 287},
  [1963] = {.lex_state = 287},
  [1964] = {.lex_state = 287},
  [1965] = {.lex_state = 287},
  [1966] = {.lex_state = 230},
  [1967] = {.lex_state = 287},
  [1968] = {.lex_state = 287},
  [1969] = {.lex_state = 230},
  [1970] = {.lex_state = 230},
  [1971] = {.lex_state = 287},
  [1972] = {.lex_state = 240},
  [1973] = {.lex_state = 230},
  [1974] = {.lex_state = 230},
  [1975] = {.lex_state = 230},
  [1976] = {.lex_state = 287},
  [1977] = {.lex_state = 287},
  [1978] = {.lex_state = 287},
  [1979] = {.lex_state = 287},
  [1980] = {.lex_state = 287},
  [1981] = {.lex_state = 230},
  [1982] = {.lex_state = 287},
  [1983] = {.lex_state = 230},
  [1984] = {.lex_state = 287},
  [1985] = {.lex_state = 287},
  [1986] = {.lex_state = 287},
  [1987] = {.lex_state = 287},
  [1988] = {.lex_state = 287},
  [1989] = {.lex_state = 287},
  [1990] = {.lex_state = 230},
  [1991] = {.lex_state = 230},
  [1992] = {.lex_state = 287},
  [1993] = {.lex_state = 230},
  [1994] = {.lex_state = 287},
  [1995] = {.lex_state = 230},
  [1996] = {.lex_state = 287},
  [1997] = {.lex_state = 251},
  [1998] = {.lex_state = 287},
  [1999] = {.lex_state = 287},
  [2000] = {.lex_state = 230},
  [2001] = {.lex_state = 211},
  [2002] = {.lex_state = 230},
  [2003] = {.lex_state = 240},
  [2004] = {.lex_state = 230},
  [2005] = {.lex_state = 230},
  [2006] = {.lex_state = 230},
  [2007] = {.lex_state = 287},
  [2008] = {.lex_state = 287},
  [2009] = {.lex_state = 240},
  [2010] = {.lex_state = 230},
  [2011] = {.lex_state = 240},
  [2012] = {.lex_state = 287},
  [2013] = {.lex_state = 240},
  [2014] = {.lex_state = 230},
  [2015] = {.lex_state = 287},
  [2016] = {.lex_state = 240},
  [2017] = {.lex_state = 230},
  [2018] = {.lex_state = 287},
  [2019] = {.lex_state = 240},
  [2020] = {.lex_state = 230},
  [2021] = {.lex_state = 240},
  [2022] = {.lex_state = 230},
  [2023] = {.lex_state = 230},
  [2024] = {.lex_state = 240},
  [2025] = {.lex_state = 230},
  [2026] = {.lex_state = 211},
  [2027] = {.lex_state = 230},
  [2028] = {.lex_state = 230},
  [2029] = {.lex_state = 230},
  [2030] = {.lex_state = 230},
  [2031] = {.lex_state = 230},
  [2032] = {.lex_state = 287},
  [2033] = {.lex_state = 287},
  [2034] = {.lex_state = 287},
  [2035] = {.lex_state = 240},
  [2036] = {.lex_state = 230},
  [2037] = {.lex_state = 230},
  [2038] = {.lex_state = 230},
  [2039] = {.lex_state = 230},
  [2040] = {.lex_state = 230},
  [2041] = {.lex_state = 230},
  [2042] = {.lex_state = 230},
  [2043] = {.lex_state = 230},
  [2044] = {.lex_state = 287},
  [2045] = {.lex_state = 240},
  [2046] = {.lex_state = 240},
  [2047] = {.lex_state = 230},
  [2048] = {.lex_state = 240},
  [2049] = {.lex_state = 230},
  [2050] = {.lex_state = 232},
  [2051] = {.lex_state = 230},
  [2052] = {.lex_state = 230},
  [2053] = {.lex_state = 239},
  [2054] = {.lex_state = 230},
  [2055] = {.lex_state = 230},
  [2056] = {.lex_state = 230},
  [2057] = {.lex_state = 240},
  [2058] = {.lex_state = 230},
  [2059] = {.lex_state = 230},
  [2060] = {.lex_state = 230},
  [2061] = {.lex_state = 230},
  [2062] = {.lex_state = 230},
  [2063] = {.lex_state = 287},
  [2064] = {.lex_state = 240},
  [2065] = {.lex_state = 230},
  [2066] = {.lex_state = 230},
  [2067] = {.lex_state = 211},
  [2068] = {.lex_state = 287},
  [2069] = {.lex_state = 287},
  [2070] = {.lex_state = 287},
  [2071] = {.lex_state = 287},
  [2072] = {.lex_state = 287},
  [2073] = {.lex_state = 240},
  [2074] = {.lex_state = 285},
  [2075] = {.lex_state = 230},
  [2076] = {.lex_state = 230},
  [2077] = {.lex_state = 230},
  [2078] = {.lex_state = 230},
  [2079] = {.lex_state = 230},
  [2080] = {.lex_state = 230},
  [2081] = {.lex_state = 230},
  [2082] = {.lex_state = 230},
  [2083] = {.lex_state = 230},
  [2084] = {.lex_state = 230},
  [2085] = {.lex_state = 240},
  [2086] = {.lex_state = 240},
  [2087] = {.lex_state = 240},
  [2088] = {.lex_state = 240},
  [2089] = {.lex_state = 230},
  [2090] = {.lex_state = 230},
  [2091] = {.lex_state = 240},
  [2092] = {.lex_state = 230},
  [2093] = {.lex_state = 240},
  [2094] = {.lex_state = 240},
  [2095] = {.lex_state = 240},
  [2096] = {.lex_state = 240},
  [2097] = {.lex_state = 230},
  [2098] = {.lex_state = 230},
  [2099] = {.lex_state = 230},
  [2100] = {.lex_state = 230},
  [2101] = {.lex_state = 240},
  [2102] = {.lex_state = 286},
  [2103] = {.lex_state = 241},
  [2104] = {.lex_state = 285},
  [2105] = {.lex_state = 206},
  [2106] = {.lex_state = 286},
  [2107] = {.lex_state = 286},
  [2108] = {.lex_state = 206},
  [2109] = {.lex_state = 286},
  [2110] = {.lex_state = 286},
  [2111] = {.lex_state = 285},
  [2112] = {.lex_state = 285},
  [2113] = {.lex_state = 285},
  [2114] = {.lex_state = 286},
  [2115] = {.lex_state = 232},
  [2116] = {.lex_state = 286},
  [2117] = {.lex_state = 286},
  [2118] = {.lex_state = 286},
  [2119] = {.lex_state = 286},
  [2120] = {.lex_state = 286},
  [2121] = {.lex_state = 286},
  [2122] = {.lex_state = 286},
  [2123] = {.lex_state = 286},
  [2124] = {.lex_state = 241},
  [2125] = {.lex_state = 285},
  [2126] = {.lex_state = 286},
  [2127] = {.lex_state = 286},
  [2128] = {.lex_state = 285},
  [2129] = {.lex_state = 241},
  [2130] = {.lex_state = 241},
  [2131] = {.lex_state = 285},
  [2132] = {.lex_state = 241},
  [2133] = {.lex_state = 241},
  [2134] = {.lex_state = 241},
  [2135] = {.lex_state = 241},
  [2136] = {.lex_state = 241},
  [2137] = {.lex_state = 241},
  [2138] = {.lex_state = 286},
  [2139] = {.lex_state = 211},
  [2140] = {.lex_state = 211},
  [2141] = {.lex_state = 286},
  [2142] = {.lex_state = 211},
  [2143] = {.lex_state = 286},
  [2144] = {.lex_state = 203},
  [2145] = {.lex_state = 288},
  [2146] = {.lex_state = 203},
  [2147] = {.lex_state = 211},
  [2148] = {.lex_state = 288},
  [2149] = {.lex_state = 241},
  [2150] = {.lex_state = 274},
  [2151] = {.lex_state = 285},
  [2152] = {.lex_state = 234},
  [2153] = {.lex_state = 285},
  [2154] = {.lex_state = 285},
  [2155] = {.lex_state = 285},
  [2156] = {.lex_state = 285},
  [2157] = {.lex_state = 274},
  [2158] = {.lex_state = 235},
  [2159] = {.lex_state = 285},
  [2160] = {.lex_state = 285},
  [2161] = {.lex_state = 285},
  [2162] = {.lex_state = 274},
  [2163] = {.lex_state = 209},
  [2164] = {.lex_state = 285},
  [2165] = {.lex_state = 288},
  [2166] = {.lex_state = 285},
  [2167] = {.lex_state = 285},
  [2168] = {.lex_state = 241},
  [2169] = {.lex_state = 285},
  [2170] = {.lex_state = 285},
  [2171] = {.lex_state = 285},
  [2172] = {.lex_state = 285},
  [2173] = {.lex_state = 286},
  [2174] = {.lex_state = 285},
  [2175] = {.lex_state = 285},
  [2176] = {.lex_state = 285},
  [2177] = {.lex_state = 285},
  [2178] = {.lex_state = 285},
  [2179] = {.lex_state = 285},
  [2180] = {.lex_state = 285},
  [2181] = {.lex_state = 285},
  [2182] = {.lex_state = 285},
  [2183] = {.lex_state = 285},
  [2184] = {.lex_state = 285},
  [2185] = {.lex_state = 285},
  [2186] = {.lex_state = 241},
  [2187] = {.lex_state = 285},
  [2188] = {.lex_state = 285},
  [2189] = {.lex_state = 285},
  [2190] = {.lex_state = 288},
  [2191] = {.lex_state = 285},
  [2192] = {.lex_state = 285},
  [2193] = {.lex_state = 285},
  [2194] = {.lex_state = 285},
  [2195] = {.lex_state = 285},
  [2196] = {.lex_state = 285},
  [2197] = {.lex_state = 285},
  [2198] = {.lex_state = 285},
  [2199] = {.lex_state = 285},
  [2200] = {.lex_state = 285},
  [2201] = {.lex_state = 285},
  [2202] = {.lex_state = 286},
  [2203] = {.lex_state = 285},
  [2204] = {.lex_state = 285},
  [2205] = {.lex_state = 239},
  [2206] = {.lex_state = 285},
  [2207] = {.lex_state = 239},
  [2208] = {.lex_state = 285},
  [2209] = {.lex_state = 285},
  [2210] = {.lex_state = 285},
  [2211] = {.lex_state = 241},
  [2212] = {.lex_state = 239},
  [2213] = {.lex_state = 241},
  [2214] = {.lex_state = 232},
  [2215] = {.lex_state = 235},
  [2216] = {.lex_state = 272},
  [2217] = {.lex_state = 241},
  [2218] = {.lex_state = 285},
  [2219] = {.lex_state = 285},
  [2220] = {.lex_state = 285},
  [2221] = {.lex_state = 235},
  [2222] = {.lex_state = 241},
  [2223] = {.lex_state = 272},
  [2224] = {.lex_state = 241},
  [2225] = {.lex_state = 272},
  [2226] = {.lex_state = 272},
  [2227] = {.lex_state = 241},
  [2228] = {.lex_state = 285},
  [2229] = {.lex_state = 241},
  [2230] = {.lex_state = 272},
  [2231] = {.lex_state = 272},
  [2232] = {.lex_state = 235},
  [2233] = {.lex_state = 241},
  [2234] = {.lex_state = 241},
  [2235] = {.lex_state = 285},
  [2236] = {.lex_state = 272},
  [2237] = {.lex_state = 272},
  [2238] = {.lex_state = 235},
  [2239] = {.lex_state = 211},
  [2240] = {.lex_state = 239},
  [2241] = {.lex_state = 211},
  [2242] = {.lex_state = 241},
  [2243] = {.lex_state = 285},
  [2244] = {.lex_state = 241},
  [2245] = {.lex_state = 285},
  [2246] = {.lex_state = 241},
  [2247] = {.lex_state = 232},
  [2248] = {.lex_state = 267},
  [2249] = {.lex_state = 285},
  [2250] = {.lex_state = 285},
  [2251] = {.lex_state = 280},
  [2252] = {.lex_state = 285},
  [2253] = {.lex_state = 209},
  [2254] = {.lex_state = 232},
  [2255] = {.lex_state = 211},
  [2256] = {.lex_state = 267},
  [2257] = {.lex_state = 209},
  [2258] = {.lex_state = 285},
  [2259] = {.lex_state = 232},
  [2260] = {.lex_state = 214},
  [2261] = {.lex_state = 214},
  [2262] = {.lex_state = 232},
  [2263] = {.lex_state = 272},
  [2264] = {.lex_state = 209},
  [2265] = {.lex_state = 280},
  [2266] = {.lex_state = 280},
  [2267] = {.lex_state = 280},
  [2268] = {.lex_state = 285},
  [2269] = {.lex_state = 285},
  [2270] = {.lex_state = 218},
  [2271] = {.lex_state = 285},
  [2272] = {.lex_state = 285},
  [2273] = {.lex_state = 218},
  [2274] = {.lex_state = 267},
  [2275] = {.lex_state = 267},
  [2276] = {.lex_state = 232},
  [2277] = {.lex_state = 267},
  [2278] = {.lex_state = 267},
  [2279] = {.lex_state = 211},
  [2280] = {.lex_state = 232},
  [2281] = {.lex_state = 218},
  [2282] = {.lex_state = 285},
  [2283] = {.lex_state = 267},
  [2284] = {.lex_state = 209},
  [2285] = {.lex_state = 232},
  [2286] = {.lex_state = 235},
  [2287] = {.lex_state = 217},
  [2288] = {.lex_state = 211},
  [2289] = {.lex_state = 209},
  [2290] = {.lex_state = 217},
  [2291] = {.lex_state = 217},
  [2292] = {.lex_state = 235},
  [2293] = {.lex_state = 209},
  [2294] = {.lex_state = 209},
  [2295] = {.lex_state = 209},
  [2296] = {.lex_state = 209},
  [2297] = {.lex_state = 285},
  [2298] = {.lex_state = 211},
  [2299] = {.lex_state = 209},
  [2300] = {.lex_state = 215},
  [2301] = {.lex_state = 209},
  [2302] = {.lex_state = 211},
  [2303] = {.lex_state = 209},
  [2304] = {.lex_state = 215},
  [2305] = {.lex_state = 285},
  [2306] = {.lex_state = 285},
  [2307] = {.lex_state = 235},
  [2308] = {.lex_state = 234},
  [2309] = {.lex_state = 233},
  [2310] = {.lex_state = 267},
  [2311] = {.lex_state = 211},
  [2312] = {.lex_state = 233},
  [2313] = {.lex_state = 270},
  [2314] = {.lex_state = 267},
  [2315] = {.lex_state = 267},
  [2316] = {.lex_state = 270},
  [2317] = {.lex_state = 235},
  [2318] = {.lex_state = 270},
  [2319] = {.lex_state = 270},
  [2320] = {.lex_state = 222},
  [2321] = {.lex_state = 234},
  [2322] = {.lex_state = 232},
  [2323] = {.lex_state = 220},
  [2324] = {.lex_state = 234},
  [2325] = {.lex_state = 235},
  [2326] = {.lex_state = 232},
  [2327] = {.lex_state = 267},
  [2328] = {.lex_state = 220},
  [2329] = {.lex_state = 270},
  [2330] = {.lex_state = 232},
  [2331] = {.lex_state = 267},
  [2332] = {.lex_state = 270},
  [2333] = {.lex_state = 267},
  [2334] = {.lex_state = 235},
  [2335] = {.lex_state = 235},
  [2336] = {.lex_state = 222},
  [2337] = {.lex_state = 270},
  [2338] = {.lex_state = 270},
  [2339] = {.lex_state = 270},
  [2340] = {.lex_state = 211},
  [2341] = {.lex_state = 233},
  [2342] = {.lex_state = 270},
  [2343] = {.lex_state = 235},
  [2344] = {.lex_state = 209},
  [2345] = {.lex_state = 235},
  [2346] = {.lex_state = 233},
  [2347] = {.lex_state = 224},
  [2348] = {.lex_state = 211},
  [2349] = {.lex_state = 222},
  [2350] = {.lex_state = 270},
  [2351] = {.lex_state = 235},
  [2352] = {.lex_state = 235},
  [2353] = {.lex_state = 272},
  [2354] = {.lex_state = 235},
  [2355] = {.lex_state = 232},
  [2356] = {.lex_state = 267},
  [2357] = {.lex_state = 224},
  [2358] = {.lex_state = 285},
  [2359] = {.lex_state = 209},
  [2360] = {.lex_state = 272},
  [2361] = {.lex_state = 270},
  [2362] = {.lex_state = 235},
  [2363] = {.lex_state = 285},
  [2364] = {.lex_state = 233},
  [2365] = {.lex_state = 219},
  [2366] = {.lex_state = 235},
  [2367] = {.lex_state = 234},
  [2368] = {.lex_state = 219},
  [2369] = {.lex_state = 211},
  [2370] = {.lex_state = 224},
  [2371] = {.lex_state = 232},
  [2372] = {.lex_state = 235},
  [2373] = {.lex_state = 235},
  [2374] = {.lex_state = 272},
  [2375] = {.lex_state = 285},
  [2376] = {.lex_state = 235},
  [2377] = {.lex_state = 233},
  [2378] = {.lex_state = 232},
  [2379] = {.lex_state = 285},
  [2380] = {.lex_state = 235},
  [2381] = {.lex_state = 233},
  [2382] = {.lex_state = 232},
  [2383] = {.lex_state = 235},
  [2384] = {.lex_state = 272},
  [2385] = {.lex_state = 272},
  [2386] = {.lex_state = 272},
  [2387] = {.lex_state = 272},
  [2388] = {.lex_state = 233},
  [2389] = {.lex_state = 233},
  [2390] = {.lex_state = 235},
  [2391] = {.lex_state = 235},
  [2392] = {.lex_state = 233},
  [2393] = {.lex_state = 235},
  [2394] = {.lex_state = 235},
  [2395] = {.lex_state = 235},
  [2396] = {.lex_state = 235},
  [2397] = {.lex_state = 217},
  [2398] = {.lex_state = 233},
  [2399] = {.lex_state = 272},
  [2400] = {.lex_state = 233},
  [2401] = {.lex_state = 235},
  [2402] = {.lex_state = 235},
  [2403] = {.lex_state = 285},
  [2404] = {.lex_state = 235},
  [2405] = {.lex_state = 235},
  [2406] = {.lex_state = 235},
  [2407] = {.lex_state = 235},
  [2408] = {.lex_state = 233},
  [2409] = {.lex_state = 233},
  [2410] = {.lex_state = 233},
  [2411] = {.lex_state = 235},
  [2412] = {.lex_state = 235},
  [2413] = {.lex_state = 235},
  [2414] = {.lex_state = 233},
  [2415] = {.lex_state = 235},
  [2416] = {.lex_state = 235},
  [2417] = {.lex_state = 235},
  [2418] = {.lex_state = 232},
  [2419] = {.lex_state = 235},
  [2420] = {.lex_state = 235},
  [2421] = {.lex_state = 235},
  [2422] = {.lex_state = 235},
  [2423] = {.lex_state = 235},
  [2424] = {.lex_state = 235},
  [2425] = {.lex_state = 235},
  [2426] = {.lex_state = 235},
  [2427] = {.lex_state = 235},
  [2428] = {.lex_state = 211},
  [2429] = {.lex_state = 235},
  [2430] = {.lex_state = 232},
  [2431] = {.lex_state = 211},
  [2432] = {.lex_state = 233},
  [2433] = {.lex_state = 235},
  [2434] = {.lex_state = 272},
  [2435] = {.lex_state = 232},
  [2436] = {.lex_state = 272},
  [2437] = {.lex_state = 235},
  [2438] = {.lex_state = 232},
  [2439] = {.lex_state = 235},
  [2440] = {.lex_state = 235},
  [2441] = {.lex_state = 291},
  [2442] = {.lex_state = 285},
  [2443] = {.lex_state = 235},
  [2444] = {.lex_state = 272},
  [2445] = {.lex_state = 235},
  [2446] = {.lex_state = 235},
  [2447] = {.lex_state = 232},
  [2448] = {.lex_state = 272},
  [2449] = {.lex_state = 217},
  [2450] = {.lex_state = 235},
  [2451] = {.lex_state = 272},
  [2452] = {.lex_state = 235},
  [2453] = {.lex_state = 235},
  [2454] = {.lex_state = 272},
  [2455] = {.lex_state = 232},
  [2456] = {.lex_state = 233},
  [2457] = {.lex_state = 232},
  [2458] = {.lex_state = 235},
  [2459] = {.lex_state = 272},
  [2460] = {.lex_state = 235},
  [2461] = {.lex_state = 211},
  [2462] = {.lex_state = 235},
  [2463] = {.lex_state = 222},
  [2464] = {.lex_state = 235},
  [2465] = {.lex_state = 272},
  [2466] = {.lex_state = 217},
  [2467] = {.lex_state = 235},
  [2468] = {.lex_state = 285},
  [2469] = {.lex_state = 235},
  [2470] = {.lex_state = 286},
  [2471] = {.lex_state = 232},
  [2472] = {.lex_state = 289},
  [2473] = {.lex_state = 272},
  [2474] = {.lex_state = 285},
  [2475] = {.lex_state = 285},
  [2476] = {.lex_state = 217},
  [2477] = {.lex_state = 270},
  [2478] = {.lex_state = 285},
  [2479] = {.lex_state = 288},
  [2480] = {.lex_state = 232},
  [2481] = {.lex_state = 285},
  [2482] = {.lex_state = 232},
  [2483] = {.lex_state = 272},
  [2484] = {.lex_state = 285},
  [2485] = {.lex_state = 232},
  [2486] = {.lex_state = 217},
  [2487] = {.lex_state = 232},
  [2488] = {.lex_state = 272},
  [2489] = {.lex_state = 217},
  [2490] = {.lex_state = 224},
  [2491] = {.lex_state = 235},
  [2492] = {.lex_state = 285},
  [2493] = {.lex_state = 211},
  [2494] = {.lex_state = 222},
  [2495] = {.lex_state = 270},
  [2496] = {.lex_state = 235},
  [2497] = {.lex_state = 232},
  [2498] = {.lex_state = 288},
  [2499] = {.lex_state = 232},
  [2500] = {.lex_state = 285},
  [2501] = {.lex_state = 272},
  [2502] = {.lex_state = 232},
  [2503] = {.lex_state = 232},
  [2504] = {.lex_state = 232},
  [2505] = {.lex_state = 232},
  [2506] = {.lex_state = 272},
  [2507] = {.lex_state = 286},
  [2508] = {.lex_state = 211},
  [2509] = {.lex_state = 272},
  [2510] = {.lex_state = 217},
  [2511] = {.lex_state = 232},
  [2512] = {.lex_state = 285},
  [2513] = {.lex_state = 211},
  [2514] = {.lex_state = 235},
  [2515] = {.lex_state = 235},
  [2516] = {.lex_state = 224},
  [2517] = {.lex_state = 285},
  [2518] = {.lex_state = 235},
  [2519] = {.lex_state = 217},
  [2520] = {.lex_state = 235},
  [2521] = {.lex_state = 235},
  [2522] = {.lex_state = 217},
  [2523] = {.lex_state = 285},
  [2524] = {.lex_state = 285},
  [2525] = {.lex_state = 285},
  [2526] = {.lex_state = 285},
  [2527] = {.lex_state = 272},
  [2528] = {.lex_state = 224},
  [2529] = {.lex_state = 235},
  [2530] = {.lex_state = 224},
  [2531] = {.lex_state = 224},
  [2532] = {.lex_state = 222},
  [2533] = {.lex_state = 235},
  [2534] = {.lex_state = 217},
  [2535] = {.lex_state = 222},
  [2536] = {.lex_state = 235},
  [2537] = {.lex_state = 285},
  [2538] = {.lex_state = 233},
  [2539] = {.lex_state = 235},
  [2540] = {.lex_state = 235},
  [2541] = {.lex_state = 224},
  [2542] = {.lex_state = 235},
  [2543] = {.lex_state = 235},
  [2544] = {.lex_state = 285},
  [2545] = {.lex_state = 286},
  [2546] = {.lex_state = 235},
  [2547] = {.lex_state = 233},
  [2548] = {.lex_state = 245},
  [2549] = {.lex_state = 286},
  [2550] = {.lex_state = 285},
  [2551] = {.lex_state = 247},
  [2552] = {.lex_state = 222},
  [2553] = {.lex_state = 222},
  [2554] = {.lex_state = 272},
  [2555] = {.lex_state = 272},
  [2556] = {.lex_state = 286},
  [2557] = {.lex_state = 272},
  [2558] = {.lex_state = 286},
  [2559] = {.lex_state = 267},
  [2560] = {.lex_state = 272},
  [2561] = {.lex_state = 272},
  [2562] = {.lex_state = 272},
  [2563] = {.lex_state = 272},
  [2564] = {.lex_state = 285},
  [2565] = {.lex_state = 272},
  [2566] = {.lex_state = 272},
  [2567] = {.lex_state = 217},
  [2568] = {.lex_state = 286},
  [2569] = {.lex_state = 272},
  [2570] = {.lex_state = 272},
  [2571] = {.lex_state = 286},
  [2572] = {.lex_state = 235},
  [2573] = {.lex_state = 272},
  [2574] = {.lex_state = 286},
  [2575] = {.lex_state = 272},
  [2576] = {.lex_state = 272},
  [2577] = {.lex_state = 267},
  [2578] = {.lex_state = 286},
  [2579] = {.lex_state = 272},
  [2580] = {.lex_state = 272},
  [2581] = {.lex_state = 244},
  [2582] = {.lex_state = 233},
  [2583] = {.lex_state = 286},
  [2584] = {.lex_state = 247},
  [2585] = {.lex_state = 285},
  [2586] = {.lex_state = 272},
  [2587] = {.lex_state = 272},
  [2588] = {.lex_state = 217},
  [2589] = {.lex_state = 272},
  [2590] = {.lex_state = 247},
  [2591] = {.lex_state = 285},
  [2592] = {.lex_state = 233},
  [2593] = {.lex_state = 238},
  [2594] = {.lex_state = 272},
  [2595] = {.lex_state = 272},
  [2596] = {.lex_state = 286},
  [2597] = {.lex_state = 272},
  [2598] = {.lex_state = 272},
  [2599] = {.lex_state = 272},
  [2600] = {.lex_state = 233},
  [2601] = {.lex_state = 272},
  [2602] = {.lex_state = 272},
  [2603] = {.lex_state = 272},
  [2604] = {.lex_state = 285},
  [2605] = {.lex_state = 272},
  [2606] = {.lex_state = 286},
  [2607] = {.lex_state = 211},
  [2608] = {.lex_state = 285},
  [2609] = {.lex_state = 211},
  [2610] = {.lex_state = 211},
  [2611] = {.lex_state = 285},
  [2612] = {.lex_state = 211},
  [2613] = {.lex_state = 272},
  [2614] = {.lex_state = 272},
  [2615] = {.lex_state = 272},
  [2616] = {.lex_state = 272},
  [2617] = {.lex_state = 217},
  [2618] = {.lex_state = 286},
  [2619] = {.lex_state = 235},
  [2620] = {.lex_state = 285},
  [2621] = {.lex_state = 224},
  [2622] = {.lex_state = 224},
  [2623] = {.lex_state = 235},
  [2624] = {.lex_state = 224},
  [2625] = {.lex_state = 235},
  [2626] = {.lex_state = 286},
  [2627] = {.lex_state = 235},
  [2628] = {.lex_state = 235},
  [2629] = {.lex_state = 257},
  [2630] = {.lex_state = 254},
  [2631] = {.lex_state = 286},
  [2632] = {.lex_state = 235},
  [2633] = {.lex_state = 262},
  [2634] = {.lex_state = 285},
  [2635] = {.lex_state = 285},
  [2636] = {.lex_state = 235},
  [2637] = {.lex_state = 235},
  [2638] = {.lex_state = 285},
  [2639] = {.lex_state = 235},
  [2640] = {.lex_state = 235},
  [2641] = {.lex_state = 235},
  [2642] = {.lex_state = 257},
  [2643] = {.lex_state = 288},
  [2644] = {.lex_state = 235},
  [2645] = {.lex_state = 289},
  [2646] = {.lex_state = 235},
  [2647] = {.lex_state = 235},
  [2648] = {.lex_state = 235},
  [2649] = {.lex_state = 235},
  [2650] = {.lex_state = 235},
  [2651] = {.lex_state = 235},
  [2652] = {.lex_state = 235},
  [2653] = {.lex_state = 235},
  [2654] = {.lex_state = 252},
  [2655] = {.lex_state = 286},
  [2656] = {.lex_state = 224},
  [2657] = {.lex_state = 222},
  [2658] = {.lex_state = 235},
  [2659] = {.lex_state = 235},
  [2660] = {.lex_state = 235},
  [2661] = {.lex_state = 235},
  [2662] = {.lex_state = 235},
  [2663] = {.lex_state = 235},
  [2664] = {.lex_state = 235},
  [2665] = {.lex_state = 235},
  [2666] = {.lex_state = 235},
  [2667] = {.lex_state = 217},
  [2668] = {.lex_state = 235},
  [2669] = {.lex_state = 235},
  [2670] = {.lex_state = 235},
  [2671] = {.lex_state = 235},
  [2672] = {.lex_state = 235},
  [2673] = {.lex_state = 235},
  [2674] = {.lex_state = 235},
  [2675] = {.lex_state = 285},
  [2676] = {.lex_state = 285},
  [2677] = {.lex_state = 217},
  [2678] = {.lex_state = 235},
  [2679] = {.lex_state = 222},
  [2680] = {.lex_state = 251},
  [2681] = {.lex_state = 285},
  [2682] = {.lex_state = 235},
  [2683] = {.lex_state = 235},
  [2684] = {.lex_state = 235},
  [2685] = {.lex_state = 239},
  [2686] = {.lex_state = 235},
  [2687] = {.lex_state = 235},
  [2688] = {.lex_state = 235},
  [2689] = {.lex_state = 285},
  [2690] = {.lex_state = 235},
  [2691] = {.lex_state = 235},
  [2692] = {.lex_state = 253},
  [2693] = {.lex_state = 235},
  [2694] = {.lex_state = 285},
  [2695] = {.lex_state = 239},
  [2696] = {.lex_state = 257},
  [2697] = {.lex_state = 286},
  [2698] = {.lex_state = 235},
  [2699] = {.lex_state = 285},
  [2700] = {.lex_state = 235},
  [2701] = {.lex_state = 235},
  [2702] = {.lex_state = 235},
  [2703] = {.lex_state = 235},
  [2704] = {.lex_state = 235},
  [2705] = {.lex_state = 285},
  [2706] = {.lex_state = 235},
  [2707] = {.lex_state = 244},
  [2708] = {.lex_state = 235},
  [2709] = {.lex_state = 235},
  [2710] = {.lex_state = 235},
  [2711] = {.lex_state = 262},
  [2712] = {.lex_state = 235},
  [2713] = {.lex_state = 235},
  [2714] = {.lex_state = 286},
  [2715] = {.lex_state = 262},
  [2716] = {.lex_state = 267},
  [2717] = {.lex_state = 235},
  [2718] = {.lex_state = 235},
  [2719] = {.lex_state = 235},
  [2720] = {.lex_state = 286},
  [2721] = {.lex_state = 235},
  [2722] = {.lex_state = 235},
  [2723] = {.lex_state = 235},
  [2724] = {.lex_state = 286},
  [2725] = {.lex_state = 235},
  [2726] = {.lex_state = 235},
  [2727] = {.lex_state = 235},
  [2728] = {.lex_state = 235},
  [2729] = {.lex_state = 222},
  [2730] = {.lex_state = 235},
  [2731] = {.lex_state = 235},
  [2732] = {.lex_state = 222},
  [2733] = {.lex_state = 285},
  [2734] = {.lex_state = 235},
  [2735] = {.lex_state = 235},
  [2736] = {.lex_state = 235},
  [2737] = {.lex_state = 235},
  [2738] = {.lex_state = 235},
  [2739] = {.lex_state = 235},
  [2740] = {.lex_state = 288},
  [2741] = {.lex_state = 235},
  [2742] = {.lex_state = 235},
  [2743] = {.lex_state = 235},
  [2744] = {.lex_state = 235},
  [2745] = {.lex_state = 244},
  [2746] = {.lex_state = 251},
  [2747] = {.lex_state = 270},
  [2748] = {.lex_state = 217},
  [2749] = {.lex_state = 213},
  [2750] = {.lex_state = 239},
  [2751] = {.lex_state = 244},
  [2752] = {.lex_state = 213},
  [2753] = {.lex_state = 285},
  [2754] = {.lex_state = 244},
  [2755] = {.lex_state = 252},
  [2756] = {.lex_state = 244},
  [2757] = {.lex_state = 285},
  [2758] = {.lex_state = 213},
  [2759] = {.lex_state = 285},
  [2760] = {.lex_state = 244},
  [2761] = {.lex_state = 239},
  [2762] = {.lex_state = 244},
  [2763] = {.lex_state = 244},
  [2764] = {.lex_state = 217},
  [2765] = {.lex_state = 217},
  [2766] = {.lex_state = 217},
  [2767] = {.lex_state = 285},
  [2768] = {.lex_state = 244},
  [2769] = {.lex_state = 285},
  [2770] = {.lex_state = 244},
  [2771] = {.lex_state = 247},
  [2772] = {.lex_state = 285},
  [2773] = {.lex_state = 254},
  [2774] = {.lex_state = 239},
  [2775] = {.lex_state = 217},
  [2776] = {.lex_state = 239},
  [2777] = {.lex_state = 239},
  [2778] = {.lex_state = 239},
  [2779] = {.lex_state = 244},
  [2780] = {.lex_state = 254},
  [2781] = {.lex_state = 245},
  [2782] = {.lex_state = 254},
  [2783] = {.lex_state = 239},
  [2784] = {.lex_state = 239},
  [2785] = {.lex_state = 251},
  [2786] = {.lex_state = 285},
  [2787] = {.lex_state = 251},
  [2788] = {.lex_state = 251},
  [2789] = {.lex_state = 245},
  [2790] = {.lex_state = 251},
  [2791] = {.lex_state = 239},
  [2792] = {.lex_state = 251},
  [2793] = {.lex_state = 251},
  [2794] = {.lex_state = 244},
  [2795] = {.lex_state = 286},
  [2796] = {.lex_state = 286},
  [2797] = {.lex_state = 285},
  [2798] = {.lex_state = 239},
  [2799] = {.lex_state = 239},
  [2800] = {.lex_state = 239},
  [2801] = {.lex_state = 239},
  [2802] = {.lex_state = 244},
  [2803] = {.lex_state = 239},
  [2804] = {.lex_state = 239},
  [2805] = {.lex_state = 254},
  [2806] = {.lex_state = 244},
  [2807] = {.lex_state = 239},
  [2808] = {.lex_state = 239},
  [2809] = {.lex_state = 247},
  [2810] = {.lex_state = 239},
  [2811] = {.lex_state = 244},
  [2812] = {.lex_state = 251},
  [2813] = {.lex_state = 239},
  [2814] = {.lex_state = 239},
  [2815] = {.lex_state = 239},
  [2816] = {.lex_state = 239},
  [2817] = {.lex_state = 217},
  [2818] = {.lex_state = 239},
  [2819] = {.lex_state = 285},
  [2820] = {.lex_state = 252},
  [2821] = {.lex_state = 244},
  [2822] = {.lex_state = 239},
  [2823] = {.lex_state = 247},
  [2824] = {.lex_state = 254},
  [2825] = {.lex_state = 254},
  [2826] = {.lex_state = 251},
  [2827] = {.lex_state = 239},
  [2828] = {.lex_state = 252},
  [2829] = {.lex_state = 254},
  [2830] = {.lex_state = 239},
  [2831] = {.lex_state = 239},
  [2832] = {.lex_state = 245},
  [2833] = {.lex_state = 217},
  [2834] = {.lex_state = 244},
  [2835] = {.lex_state = 217},
  [2836] = {.lex_state = 251},
  [2837] = {.lex_state = 252},
  [2838] = {.lex_state = 252},
  [2839] = {.lex_state = 289},
  [2840] = {.lex_state = 254},
  [2841] = {.lex_state = 251},
  [2842] = {.lex_state = 285},
  [2843] = {.lex_state = 254},
  [2844] = {.lex_state = 251},
  [2845] = {.lex_state = 285},
  [2846] = {.lex_state = 244},
  [2847] = {.lex_state = 244},
  [2848] = {.lex_state = 252},
  [2849] = {.lex_state = 289},
  [2850] = {.lex_state = 251},
  [2851] = {.lex_state = 232},
  [2852] = {.lex_state = 232},
  [2853] = {.lex_state = 244},
  [2854] = {.lex_state = 232},
  [2855] = {.lex_state = 232},
  [2856] = {.lex_state = 232},
  [2857] = {.lex_state = 232},
  [2858] = {.lex_state = 285},
  [2859] = {.lex_state = 232},
  [2860] = {.lex_state = 232},
  [2861] = {.lex_state = 232},
  [2862] = {.lex_state = 232},
  [2863] = {.lex_state = 232},
  [2864] = {.lex_state = 232},
  [2865] = {.lex_state = 232},
  [2866] = {.lex_state = 232},
  [2867] = {.lex_state = 232},
  [2868] = {.lex_state = 251},
  [2869] = {.lex_state = 252},
  [2870] = {.lex_state = 244},
  [2871] = {.lex_state = 254},
  [2872] = {.lex_state = 251},
  [2873] = {.lex_state = 252},
  [2874] = {.lex_state = 252},
  [2875] = {.lex_state = 244},
  [2876] = {.lex_state = 252},
  [2877] = {.lex_state = 252},
  [2878] = {.lex_state = 253},
  [2879] = {.lex_state = 251},
  [2880] = {.lex_state = 253},
  [2881] = {.lex_state = 245},
  [2882] = {.lex_state = 252},
  [2883] = {.lex_state = 232},
  [2884] = {.lex_state = 252},
  [2885] = {.lex_state = 244},
  [2886] = {.lex_state = 252},
  [2887] = {.lex_state = 252},
  [2888] = {.lex_state = 232},
  [2889] = {.lex_state = 285},
  [2890] = {.lex_state = 285},
  [2891] = {.lex_state = 251},
  [2892] = {.lex_state = 213},
  [2893] = {.lex_state = 213},
  [2894] = {.lex_state = 244},
  [2895] = {.lex_state = 285},
  [2896] = {.lex_state = 244},
  [2897] = {.lex_state = 289},
  [2898] = {.lex_state = 206},
  [2899] = {.lex_state = 213},
  [2900] = {.lex_state = 251},
  [2901] = {.lex_state = 285},
  [2902] = {.lex_state = 285},
  [2903] = {.lex_state = 244},
  [2904] = {.lex_state = 244},
  [2905] = {.lex_state = 206},
  [2906] = {.lex_state = 251},
  [2907] = {.lex_state = 285},
  [2908] = {.lex_state = 244},
  [2909] = {.lex_state = 285},
  [2910] = {.lex_state = 251},
  [2911] = {.lex_state = 244},
  [2912] = {.lex_state = 253},
  [2913] = {.lex_state = 285},
  [2914] = {.lex_state = 289},
  [2915] = {.lex_state = 285},
  [2916] = {.lex_state = 254},
  [2917] = {.lex_state = 254},
  [2918] = {.lex_state = 244},
  [2919] = {.lex_state = 213},
  [2920] = {.lex_state = 285},
  [2921] = {.lex_state = 285},
  [2922] = {.lex_state = 289},
  [2923] = {.lex_state = 254},
  [2924] = {.lex_state = 289},
  [2925] = {.lex_state = 267},
  [2926] = {.lex_state = 285},
  [2927] = {.lex_state = 244},
  [2928] = {.lex_state = 244},
  [2929] = {.lex_state = 267},
  [2930] = {.lex_state = 285},
  [2931] = {.lex_state = 285},
  [2932] = {.lex_state = 286},
  [2933] = {.lex_state = 254},
  [2934] = {.lex_state = 254},
  [2935] = {.lex_state = 244},
  [2936] = {.lex_state = 285},
  [2937] = {.lex_state = 285},
  [2938] = {.lex_state = 267},
  [2939] = {.lex_state = 244},
  [2940] = {.lex_state = 236},
  [2941] = {.lex_state = 267},
  [2942] = {.lex_state = 232},
  [2943] = {.lex_state = 232},
  [2944] = {.lex_state = 233},
  [2945] = {.lex_state = 232},
  [2946] = {.lex_state = 269},
  [2947] = {.lex_state = 232},
  [2948] = {.lex_state = 233},
  [2949] = {.lex_state = 245},
  [2950] = {.lex_state = 285},
  [2951] = {.lex_state = 244},
  [2952] = {.lex_state = 232},
  [2953] = {.lex_state = 254},
  [2954] = {.lex_state = 232},
  [2955] = {.lex_state = 244},
  [2956] = {.lex_state = 244},
  [2957] = {.lex_state = 244},
  [2958] = {.lex_state = 244},
  [2959] = {.lex_state = 232},
  [2960] = {.lex_state = 244},
  [2961] = {.lex_state = 232},
  [2962] = {.lex_state = 267},
  [2963] = {.lex_state = 232},
  [2964] = {.lex_state = 269},
  [2965] = {.lex_state = 244},
  [2966] = {.lex_state = 244},
  [2967] = {.lex_state = 244},
  [2968] = {.lex_state = 232},
  [2969] = {.lex_state = 232},
  [2970] = {.lex_state = 236},
  [2971] = {.lex_state = 254},
  [2972] = {.lex_state = 233},
  [2973] = {.lex_state = 232},
  [2974] = {.lex_state = 267},
  [2975] = {.lex_state = 244},
  [2976] = {.lex_state = 232},
  [2977] = {.lex_state = 244},
  [2978] = {.lex_state = 233},
  [2979] = {.lex_state = 244},
  [2980] = {.lex_state = 232},
  [2981] = {.lex_state = 244},
  [2982] = {.lex_state = 269},
  [2983] = {.lex_state = 232},
  [2984] = {.lex_state = 269},
  [2985] = {.lex_state = 244},
  [2986] = {.lex_state = 244},
  [2987] = {.lex_state = 244},
  [2988] = {.lex_state = 232},
  [2989] = {.lex_state = 267},
  [2990] = {.lex_state = 251},
  [2991] = {.lex_state = 244},
  [2992] = {.lex_state = 244},
  [2993] = {.lex_state = 244},
  [2994] = {.lex_state = 244},
  [2995] = {.lex_state = 251},
  [2996] = {.lex_state = 244},
  [2997] = {.lex_state = 233},
  [2998] = {.lex_state = 233},
  [2999] = {.lex_state = 245},
  [3000] = {.lex_state = 236},
  [3001] = {.lex_state = 233},
  [3002] = {.lex_state = 244},
  [3003] = {.lex_state = 244},
  [3004] = {.lex_state = 244},
  [3005] = {.lex_state = 285},
  [3006] = {.lex_state = 244},
  [3007] = {.lex_state = 244},
  [3008] = {.lex_state = 231},
  [3009] = {.lex_state = 244},
  [3010] = {.lex_state = 244},
  [3011] = {.lex_state = 232},
  [3012] = {.lex_state = 229},
  [3013] = {.lex_state = 289},
  [3014] = {.lex_state = 254},
  [3015] = {.lex_state = 206},
  [3016] = {.lex_state = 254},
  [3017] = {.lex_state = 251},
  [3018] = {.lex_state = 206},
  [3019] = {.lex_state = 251},
  [3020] = {.lex_state = 245},
  [3021] = {.lex_state = 206},
  [3022] = {.lex_state = 244},
  [3023] = {.lex_state = 251},
  [3024] = {.lex_state = 251},
  [3025] = {.lex_state = 251},
  [3026] = {.lex_state = 206},
  [3027] = {.lex_state = 244},
  [3028] = {.lex_state = 236},
  [3029] = {.lex_state = 206},
  [3030] = {.lex_state = 244},
  [3031] = {.lex_state = 206},
  [3032] = {.lex_state = 229},
  [3033] = {.lex_state = 254},
  [3034] = {.lex_state = 254},
  [3035] = {.lex_state = 244},
  [3036] = {.lex_state = 206},
  [3037] = {.lex_state = 206},
  [3038] = {.lex_state = 244},
  [3039] = {.lex_state = 229},
  [3040] = {.lex_state = 206},
  [3041] = {.lex_state = 206},
  [3042] = {.lex_state = 229},
  [3043] = {.lex_state = 251},
  [3044] = {.lex_state = 206},
  [3045] = {.lex_state = 254},
  [3046] = {.lex_state = 236},
  [3047] = {.lex_state = 229},
  [3048] = {.lex_state = 244},
  [3049] = {.lex_state = 206},
  [3050] = {.lex_state = 206},
  [3051] = {.lex_state = 206},
  [3052] = {.lex_state = 206},
  [3053] = {.lex_state = 244},
  [3054] = {.lex_state = 206},
  [3055] = {.lex_state = 244},
  [3056] = {.lex_state = 285},
  [3057] = {.lex_state = 236},
  [3058] = {.lex_state = 244},
  [3059] = {.lex_state = 251},
  [3060] = {.lex_state = 254},
  [3061] = {.lex_state = 285},
  [3062] = {.lex_state = 251},
  [3063] = {.lex_state = 229},
  [3064] = {.lex_state = 206},
  [3065] = {.lex_state = 251},
  [3066] = {.lex_state = 206},
  [3067] = {.lex_state = 251},
  [3068] = {.lex_state = 232},
  [3069] = {.lex_state = 254},
  [3070] = {.lex_state = 254},
  [3071] = {.lex_state = 206},
  [3072] = {.lex_state = 254},
  [3073] = {.lex_state = 289},
  [3074] = {.lex_state = 231},
  [3075] = {.lex_state = 244},
  [3076] = {.lex_state = 244},
  [3077] = {.lex_state = 206},
  [3078] = {.lex_state = 289},
  [3079] = {.lex_state = 285},
  [3080] = {.lex_state = 244},
  [3081] = {.lex_state = 254},
  [3082] = {.lex_state = 254},
  [3083] = {.lex_state = 244},
  [3084] = {.lex_state = 251},
  [3085] = {.lex_state = 254},
  [3086] = {.lex_state = 251},
  [3087] = {.lex_state = 232},
  [3088] = {.lex_state = 244},
  [3089] = {.lex_state = 244},
  [3090] = {.lex_state = 244},
  [3091] = {.lex_state = 244},
  [3092] = {.lex_state = 256},
  [3093] = {.lex_state = 261},
  [3094] = {.lex_state = 244},
  [3095] = {.lex_state = 256},
  [3096] = {.lex_state = 213},
  [3097] = {.lex_state = 213},
  [3098] = {.lex_state = 261},
  [3099] = {.lex_state = 244},
  [3100] = {.lex_state = 261},
  [3101] = {.lex_state = 244},
  [3102] = {.lex_state = 251},
  [3103] = {.lex_state = 244},
  [3104] = {.lex_state = 244},
  [3105] = {.lex_state = 244},
  [3106] = {.lex_state = 261},
  [3107] = {.lex_state = 244},
  [3108] = {.lex_state = 244},
  [3109] = {.lex_state = 232},
  [3110] = {.lex_state = 232},
  [3111] = {.lex_state = 244},
  [3112] = {.lex_state = 267},
  [3113] = {.lex_state = 229},
  [3114] = {.lex_state = 244},
  [3115] = {.lex_state = 232},
  [3116] = {.lex_state = 244},
  [3117] = {.lex_state = 261},
  [3118] = {.lex_state = 244},
  [3119] = {.lex_state = 244},
  [3120] = {.lex_state = 244},
  [3121] = {.lex_state = 232},
  [3122] = {.lex_state = 244},
  [3123] = {.lex_state = 229},
  [3124] = {.lex_state = 229},
  [3125] = {.lex_state = 244},
  [3126] = {.lex_state = 244},
  [3127] = {.lex_state = 244},
  [3128] = {.lex_state = 232},
  [3129] = {.lex_state = 286},
  [3130] = {.lex_state = 232},
  [3131] = {.lex_state = 232},
  [3132] = {.lex_state = 232},
  [3133] = {.lex_state = 232},
  [3134] = {.lex_state = 244},
  [3135] = {.lex_state = 232},
  [3136] = {.lex_state = 251},
  [3137] = {.lex_state = 232},
  [3138] = {.lex_state = 285},
  [3139] = {.lex_state = 232},
  [3140] = {.lex_state = 232},
  [3141] = {.lex_state = 244},
  [3142] = {.lex_state = 232},
  [3143] = {.lex_state = 285},
  [3144] = {.lex_state = 267},
  [3145] = {.lex_state = 289},
  [3146] = {.lex_state = 289},
  [3147] = {.lex_state = 252},
  [3148] = {.lex_state = 244},
  [3149] = {.lex_state = 244},
  [3150] = {.lex_state = 251},
  [3151] = {.lex_state = 244},
  [3152] = {.lex_state = 244},
  [3153] = {.lex_state = 256},
  [3154] = {.lex_state = 244},
  [3155] = {.lex_state = 244},
  [3156] = {.lex_state = 244},
  [3157] = {.lex_state = 244},
  [3158] = {.lex_state = 244},
  [3159] = {.lex_state = 244},
  [3160] = {.lex_state = 254},
  [3161] = {.lex_state = 232},
  [3162] = {.lex_state = 289},
  [3163] = {.lex_state = 289},
  [3164] = {.lex_state = 232},
  [3165] = {.lex_state = 254},
  [3166] = {.lex_state = 254},
  [3167] = {.lex_state = 251},
  [3168] = {.lex_state = 254},
  [3169] = {.lex_state = 291},
  [3170] = {.lex_state = 251},
  [3171] = {.lex_state = 244},
  [3172] = {.lex_state = 244},
  [3173] = {.lex_state = 244},
  [3174] = {.lex_state = 254},
  [3175] = {.lex_state = 244},
  [3176] = {.lex_state = 244},
  [3177] = {.lex_state = 251},
  [3178] = {.lex_state = 244},
  [3179] = {.lex_state = 244},
  [3180] = {.lex_state = 244},
  [3181] = {.lex_state = 254},
  [3182] = {.lex_state = 244},
  [3183] = {.lex_state = 244},
  [3184] = {.lex_state = 244},
  [3185] = {.lex_state = 244},
  [3186] = {.lex_state = 254},
  [3187] = {.lex_state = 251},
  [3188] = {.lex_state = 251},
  [3189] = {.lex_state = 252},
  [3190] = {.lex_state = 244},
  [3191] = {.lex_state = 244},
  [3192] = {.lex_state = 244},
  [3193] = {.lex_state = 251},
  [3194] = {.lex_state = 244},
  [3195] = {.lex_state = 244},
  [3196] = {.lex_state = 244},
  [3197] = {.lex_state = 244},
  [3198] = {.lex_state = 244},
  [3199] = {.lex_state = 244},
  [3200] = {.lex_state = 244},
  [3201] = {.lex_state = 244},
  [3202] = {.lex_state = 244},
  [3203] = {.lex_state = 256},
  [3204] = {.lex_state = 244},
  [3205] = {.lex_state = 244},
  [3206] = {.lex_state = 244},
  [3207] = {.lex_state = 244},
  [3208] = {.lex_state = 244},
  [3209] = {.lex_state = 244},
  [3210] = {.lex_state = 256},
  [3211] = {.lex_state = 286},
  [3212] = {.lex_state = 251},
  [3213] = {.lex_state = 286},
  [3214] = {.lex_state = 244},
  [3215] = {.lex_state = 286},
  [3216] = {.lex_state = 254},
  [3217] = {.lex_state = 286},
  [3218] = {.lex_state = 254},
  [3219] = {.lex_state = 254},
  [3220] = {.lex_state = 200},
  [3221] = {.lex_state = 254},
  [3222] = {.lex_state = 254},
  [3223] = {.lex_state = 254},
  [3224] = {.lex_state = 254},
  [3225] = {.lex_state = 286},
  [3226] = {.lex_state = 254},
  [3227] = {.lex_state = 254},
  [3228] = {.lex_state = 286},
  [3229] = {.lex_state = 254},
  [3230] = {.lex_state = 254},
  [3231] = {.lex_state = 286},
  [3232] = {.lex_state = 200},
  [3233] = {.lex_state = 254},
  [3234] = {.lex_state = 286},
  [3235] = {.lex_state = 286},
  [3236] = {.lex_state = 286},
  [3237] = {.lex_state = 286},
  [3238] = {.lex_state = 244},
  [3239] = {.lex_state = 200},
  [3240] = {.lex_state = 254},
  [3241] = {.lex_state = 254},
  [3242] = {.lex_state = 200},
  [3243] = {.lex_state = 254},
  [3244] = {.lex_state = 286},
  [3245] = {.lex_state = 235},
  [3246] = {.lex_state = 286},
  [3247] = {.lex_state = 286},
  [3248] = {.lex_state = 286},
  [3249] = {.lex_state = 254},
  [3250] = {.lex_state = 288},
  [3251] = {.lex_state = 286},
  [3252] = {.lex_state = 254},
  [3253] = {.lex_state = 286},
  [3254] = {.lex_state = 254},
  [3255] = {.lex_state = 254},
  [3256] = {.lex_state = 254},
  [3257] = {.lex_state = 254},
  [3258] = {.lex_state = 286},
  [3259] = {.lex_state = 254},
  [3260] = {.lex_state = 229},
  [3261] = {.lex_state = 254},
  [3262] = {.lex_state = 244},
  [3263] = {.lex_state = 286},
  [3264] = {.lex_state = 251},
  [3265] = {.lex_state = 254},
  [3266] = {.lex_state = 251},
  [3267] = {.lex_state = 286},
  [3268] = {.lex_state = 254},
  [3269] = {.lex_state = 254},
  [3270] = {.lex_state = 254},
  [3271] = {.lex_state = 254},
  [3272] = {.lex_state = 254},
  [3273] = {.lex_state = 254},
  [3274] = {.lex_state = 254},
  [3275] = {.lex_state = 254},
  [3276] = {.lex_state = 254},
  [3277] = {.lex_state = 254},
  [3278] = {.lex_state = 244},
  [3279] = {.lex_state = 254},
  [3280] = {.lex_state = 244},
  [3281] = {.lex_state = 254},
  [3282] = {.lex_state = 244},
  [3283] = {.lex_state = 289},
  [3284] = {.lex_state = 286},
  [3285] = {.lex_state = 286},
  [3286] = {.lex_state = 254},
  [3287] = {.lex_state = 254},
  [3288] = {.lex_state = 254},
  [3289] = {.lex_state = 254},
  [3290] = {.lex_state = 254},
  [3291] = {.lex_state = 254},
  [3292] = {.lex_state = 254},
  [3293] = {.lex_state = 254},
  [3294] = {.lex_state = 244},
  [3295] = {.lex_state = 254},
  [3296] = {.lex_state = 254},
  [3297] = {.lex_state = 254},
  [3298] = {.lex_state = 286},
  [3299] = {.lex_state = 286},
  [3300] = {.lex_state = 286},
  [3301] = {.lex_state = 286},
  [3302] = {.lex_state = 286},
  [3303] = {.lex_state = 254},
  [3304] = {.lex_state = 254},
  [3305] = {.lex_state = 254},
  [3306] = {.lex_state = 286},
  [3307] = {.lex_state = 244},
  [3308] = {.lex_state = 254},
  [3309] = {.lex_state = 254},
  [3310] = {.lex_state = 254},
  [3311] = {.lex_state = 254},
  [3312] = {.lex_state = 254},
  [3313] = {.lex_state = 254},
  [3314] = {.lex_state = 254},
  [3315] = {.lex_state = 288},
  [3316] = {.lex_state = 286},
  [3317] = {.lex_state = 286},
  [3318] = {.lex_state = 254},
  [3319] = {.lex_state = 254},
  [3320] = {.lex_state = 285},
  [3321] = {.lex_state = 251},
  [3322] = {.lex_state = 251},
  [3323] = {.lex_state = 251},
  [3324] = {.lex_state = 251},
  [3325] = {.lex_state = 286},
  [3326] = {.lex_state = 286},
  [3327] = {.lex_state = 286},
  [3328] = {.lex_state = 231},
  [3329] = {.lex_state = 286},
  [3330] = {.lex_state = 255},
  [3331] = {.lex_state = 251},
  [3332] = {.lex_state = 251},
  [3333] = {.lex_state = 251},
  [3334] = {.lex_state = 251},
  [3335] = {.lex_state = 251},
  [3336] = {.lex_state = 251},
  [3337] = {.lex_state = 244},
  [3338] = {.lex_state = 251},
  [3339] = {.lex_state = 251},
  [3340] = {.lex_state = 286},
  [3341] = {.lex_state = 251},
  [3342] = {.lex_state = 251},
  [3343] = {.lex_state = 251},
  [3344] = {.lex_state = 244},
  [3345] = {.lex_state = 286},
  [3346] = {.lex_state = 251},
  [3347] = {.lex_state = 286},
  [3348] = {.lex_state = 251},
  [3349] = {.lex_state = 286},
  [3350] = {.lex_state = 251},
  [3351] = {.lex_state = 251},
  [3352] = {.lex_state = 251},
  [3353] = {.lex_state = 251},
  [3354] = {.lex_state = 251},
  [3355] = {.lex_state = 244},
  [3356] = {.lex_state = 286},
  [3357] = {.lex_state = 251},
  [3358] = {.lex_state = 286},
  [3359] = {.lex_state = 244},
  [3360] = {.lex_state = 244},
  [3361] = {.lex_state = 251},
  [3362] = {.lex_state = 244},
  [3363] = {.lex_state = 244},
  [3364] = {.lex_state = 286},
  [3365] = {.lex_state = 244},
  [3366] = {.lex_state = 286},
  [3367] = {.lex_state = 251},
  [3368] = {.lex_state = 244},
  [3369] = {.lex_state = 244},
  [3370] = {.lex_state = 244},
  [3371] = {.lex_state = 251},
  [3372] = {.lex_state = 256},
  [3373] = {.lex_state = 289},
  [3374] = {.lex_state = 286},
  [3375] = {.lex_state = 286},
  [3376] = {.lex_state = 251},
  [3377] = {.lex_state = 251},
  [3378] = {.lex_state = 251},
  [3379] = {.lex_state = 251},
  [3380] = {.lex_state = 251},
  [3381] = {.lex_state = 251},
  [3382] = {.lex_state = 251},
  [3383] = {.lex_state = 251},
  [3384] = {.lex_state = 251},
  [3385] = {.lex_state = 251},
  [3386] = {.lex_state = 244},
  [3387] = {.lex_state = 251},
  [3388] = {.lex_state = 286},
  [3389] = {.lex_state = 286},
  [3390] = {.lex_state = 261},
  [3391] = {.lex_state = 200},
  [3392] = {.lex_state = 251},
  [3393] = {.lex_state = 244},
  [3394] = {.lex_state = 286},
  [3395] = {.lex_state = 286},
  [3396] = {.lex_state = 251},
  [3397] = {.lex_state = 251},
  [3398] = {.lex_state = 200},
  [3399] = {.lex_state = 286},
  [3400] = {.lex_state = 286},
  [3401] = {.lex_state = 213},
  [3402] = {.lex_state = 251},
  [3403] = {.lex_state = 286},
  [3404] = {.lex_state = 251},
  [3405] = {.lex_state = 286},
  [3406] = {.lex_state = 286},
  [3407] = {.lex_state = 251},
  [3408] = {.lex_state = 251},
  [3409] = {.lex_state = 251},
  [3410] = {.lex_state = 213},
  [3411] = {.lex_state = 244},
  [3412] = {.lex_state = 286},
  [3413] = {.lex_state = 286},
  [3414] = {.lex_state = 251},
  [3415] = {.lex_state = 229},
  [3416] = {.lex_state = 235},
  [3417] = {.lex_state = 254},
  [3418] = {.lex_state = 235},
  [3419] = {.lex_state = 251},
  [3420] = {.lex_state = 286},
  [3421] = {.lex_state = 289},
  [3422] = {.lex_state = 235},
  [3423] = {.lex_state = 251},
  [3424] = {.lex_state = 251},
  [3425] = {.lex_state = 246},
  [3426] = {.lex_state = 256},
  [3427] = {.lex_state = 251},
  [3428] = {.lex_state = 251},
  [3429] = {.lex_state = 251},
  [3430] = {.lex_state = 200},
  [3431] = {.lex_state = 251},
  [3432] = {.lex_state = 286},
  [3433] = {.lex_state = 251},
  [3434] = {.lex_state = 251},
  [3435] = {.lex_state = 286},
  [3436] = {.lex_state = 251},
  [3437] = {.lex_state = 286},
  [3438] = {.lex_state = 235},
  [3439] = {.lex_state = 289},
  [3440] = {.lex_state = 252},
  [3441] = {.lex_state = 235},
  [3442] = {.lex_state = 286},
  [3443] = {.lex_state = 254},
  [3444] = {.lex_state = 286},
  [3445] = {.lex_state = 251},
  [3446] = {.lex_state = 231},
  [3447] = {.lex_state = 286},
  [3448] = {.lex_state = 261},
  [3449] = {.lex_state = 251},
  [3450] = {.lex_state = 244},
  [3451] = {.lex_state = 286},
  [3452] = {.lex_state = 286},
  [3453] = {.lex_state = 251},
  [3454] = {.lex_state = 235},
  [3455] = {.lex_state = 286},
  [3456] = {.lex_state = 235},
  [3457] = {.lex_state = 286},
  [3458] = {.lex_state = 286},
  [3459] = {.lex_state = 235},
  [3460] = {.lex_state = 286},
  [3461] = {.lex_state = 286},
  [3462] = {.lex_state = 235},
  [3463] = {.lex_state = 244},
  [3464] = {.lex_state = 235},
  [3465] = {.lex_state = 235},
  [3466] = {.lex_state = 235},
  [3467] = {.lex_state = 235},
  [3468] = {.lex_state = 286},
  [3469] = {.lex_state = 235},
  [3470] = {.lex_state = 244},
  [3471] = {.lex_state = 286},
  [3472] = {.lex_state = 286},
  [3473] = {.lex_state = 235},
  [3474] = {.lex_state = 286},
  [3475] = {.lex_state = 235},
  [3476] = {.lex_state = 244},
  [3477] = {.lex_state = 232},
  [3478] = {.lex_state = 244},
  [3479] = {.lex_state = 235},
  [3480] = {.lex_state = 286},
  [3481] = {.lex_state = 235},
  [3482] = {.lex_state = 235},
  [3483] = {.lex_state = 286},
  [3484] = {.lex_state = 235},
  [3485] = {.lex_state = 235},
  [3486] = {.lex_state = 235},
  [3487] = {.lex_state = 235},
  [3488] = {.lex_state = 286},
  [3489] = {.lex_state = 286},
  [3490] = {.lex_state = 285},
  [3491] = {.lex_state = 236},
  [3492] = {.lex_state = 244},
  [3493] = {.lex_state = 286},
  [3494] = {.lex_state = 286},
  [3495] = {.lex_state = 244},
  [3496] = {.lex_state = 244},
  [3497] = {.lex_state = 244},
  [3498] = {.lex_state = 286},
  [3499] = {.lex_state = 286},
  [3500] = {.lex_state = 244},
  [3501] = {.lex_state = 239},
  [3502] = {.lex_state = 285},
  [3503] = {.lex_state = 286},
  [3504] = {.lex_state = 229},
  [3505] = {.lex_state = 229},
  [3506] = {.lex_state = 229},
  [3507] = {.lex_state = 244},
  [3508] = {.lex_state = 244},
  [3509] = {.lex_state = 229},
  [3510] = {.lex_state = 229},
  [3511] = {.lex_state = 229},
  [3512] = {.lex_state = 286},
  [3513] = {.lex_state = 286},
  [3514] = {.lex_state = 229},
  [3515] = {.lex_state = 286},
  [3516] = {.lex_state = 289},
  [3517] = {.lex_state = 236},
  [3518] = {.lex_state = 286},
  [3519] = {.lex_state = 252},
  [3520] = {.lex_state = 236},
  [3521] = {.lex_state = 251},
  [3522] = {.lex_state = 286},
  [3523] = {.lex_state = 289},
  [3524] = {.lex_state = 252},
  [3525] = {.lex_state = 231},
  [3526] = {.lex_state = 286},
  [3527] = {.lex_state = 286},
  [3528] = {.lex_state = 231},
  [3529] = {.lex_state = 286},
  [3530] = {.lex_state = 229},
  [3531] = {.lex_state = 286},
  [3532] = {.lex_state = 229},
  [3533] = {.lex_state = 286},
  [3534] = {.lex_state = 229},
  [3535] = {.lex_state = 231},
  [3536] = {.lex_state = 213},
  [3537] = {.lex_state = 286},
  [3538] = {.lex_state = 232},
  [3539] = {.lex_state = 289},
  [3540] = {.lex_state = 248},
  [3541] = {.lex_state = 229},
  [3542] = {.lex_state = 229},
  [3543] = {.lex_state = 244},
  [3544] = {.lex_state = 231},
  [3545] = {.lex_state = 213},
  [3546] = {.lex_state = 244},
  [3547] = {.lex_state = 229},
  [3548] = {.lex_state = 229},
  [3549] = {.lex_state = 229},
  [3550] = {.lex_state = 229},
  [3551] = {.lex_state = 251},
  [3552] = {.lex_state = 244},
  [3553] = {.lex_state = 229},
  [3554] = {.lex_state = 229},
  [3555] = {.lex_state = 229},
  [3556] = {.lex_state = 229},
  [3557] = {.lex_state = 229},
  [3558] = {.lex_state = 229},
  [3559] = {.lex_state = 286},
  [3560] = {.lex_state = 244},
  [3561] = {.lex_state = 229},
  [3562] = {.lex_state = 213},
  [3563] = {.lex_state = 231},
  [3564] = {.lex_state = 231},
  [3565] = {.lex_state = 251},
  [3566] = {.lex_state = 286},
  [3567] = {.lex_state = 229},
  [3568] = {.lex_state = 286},
  [3569] = {.lex_state = 229},
  [3570] = {.lex_state = 244},
  [3571] = {.lex_state = 250},
  [3572] = {.lex_state = 251},
  [3573] = {.lex_state = 289},
  [3574] = {.lex_state = 229},
  [3575] = {.lex_state = 229},
  [3576] = {.lex_state = 244},
  [3577] = {.lex_state = 286},
  [3578] = {.lex_state = 286},
  [3579] = {.lex_state = 248},
  [3580] = {.lex_state = 244},
  [3581] = {.lex_state = 232},
  [3582] = {.lex_state = 248},
  [3583] = {.lex_state = 254},
  [3584] = {.lex_state = 241},
  [3585] = {.lex_state = 229},
  [3586] = {.lex_state = 252},
  [3587] = {.lex_state = 244},
  [3588] = {.lex_state = 244},
  [3589] = {.lex_state = 261},
  [3590] = {.lex_state = 261},
  [3591] = {.lex_state = 232},
  [3592] = {.lex_state = 261},
  [3593] = {.lex_state = 244},
  [3594] = {.lex_state = 261},
  [3595] = {.lex_state = 244},
  [3596] = {.lex_state = 228},
  [3597] = {.lex_state = 244},
  [3598] = {.lex_state = 244},
  [3599] = {.lex_state = 244},
  [3600] = {.lex_state = 244},
  [3601] = {.lex_state = 244},
  [3602] = {.lex_state = 244},
  [3603] = {.lex_state = 261},
  [3604] = {.lex_state = 261},
  [3605] = {.lex_state = 254},
  [3606] = {.lex_state = 241},
  [3607] = {.lex_state = 261},
  [3608] = {.lex_state = 244},
  [3609] = {.lex_state = 239},
  [3610] = {.lex_state = 244},
  [3611] = {.lex_state = 239},
  [3612] = {.lex_state = 244},
  [3613] = {.lex_state = 244},
  [3614] = {.lex_state = 213},
  [3615] = {.lex_state = 252},
  [3616] = {.lex_state = 263},
  [3617] = {.lex_state = 241},
  [3618] = {.lex_state = 239},
  [3619] = {.lex_state = 244},
  [3620] = {.lex_state = 244},
  [3621] = {.lex_state = 244},
  [3622] = {.lex_state = 256},
  [3623] = {.lex_state = 244},
  [3624] = {.lex_state = 244},
  [3625] = {.lex_state = 244},
  [3626] = {.lex_state = 244},
  [3627] = {.lex_state = 244},
  [3628] = {.lex_state = 244},
  [3629] = {.lex_state = 254},
  [3630] = {.lex_state = 244},
  [3631] = {.lex_state = 232},
  [3632] = {.lex_state = 244},
  [3633] = {.lex_state = 244},
  [3634] = {.lex_state = 244},
  [3635] = {.lex_state = 244},
  [3636] = {.lex_state = 239},
  [3637] = {.lex_state = 239},
  [3638] = {.lex_state = 226},
  [3639] = {.lex_state = 244},
  [3640] = {.lex_state = 239},
  [3641] = {.lex_state = 244},
  [3642] = {.lex_state = 261},
  [3643] = {.lex_state = 256},
  [3644] = {.lex_state = 241},
  [3645] = {.lex_state = 244},
  [3646] = {.lex_state = 241},
  [3647] = {.lex_state = 285},
  [3648] = {.lex_state = 256},
  [3649] = {.lex_state = 241},
  [3650] = {.lex_state = 256},
  [3651] = {.lex_state = 239},
  [3652] = {.lex_state = 241},
  [3653] = {.lex_state = 239},
  [3654] = {.lex_state = 244},
  [3655] = {.lex_state = 228},
  [3656] = {.lex_state = 244},
  [3657] = {.lex_state = 241},
  [3658] = {.lex_state = 244},
  [3659] = {.lex_state = 244},
  [3660] = {.lex_state = 261},
  [3661] = {.lex_state = 261},
  [3662] = {.lex_state = 291},
  [3663] = {.lex_state = 244},
  [3664] = {.lex_state = 291},
  [3665] = {.lex_state = 256},
  [3666] = {.lex_state = 261},
  [3667] = {.lex_state = 244},
  [3668] = {.lex_state = 241},
  [3669] = {.lex_state = 244},
  [3670] = {.lex_state = 244},
  [3671] = {.lex_state = 244},
  [3672] = {.lex_state = 213},
  [3673] = {.lex_state = 244},
  [3674] = {.lex_state = 244},
  [3675] = {.lex_state = 256},
  [3676] = {.lex_state = 244},
  [3677] = {.lex_state = 241},
  [3678] = {.lex_state = 244},
  [3679] = {.lex_state = 244},
  [3680] = {.lex_state = 244},
  [3681] = {.lex_state = 244},
  [3682] = {.lex_state = 244},
  [3683] = {.lex_state = 244},
  [3684] = {.lex_state = 244},
  [3685] = {.lex_state = 244},
  [3686] = {.lex_state = 244},
  [3687] = {.lex_state = 244},
  [3688] = {.lex_state = 244},
  [3689] = {.lex_state = 244},
  [3690] = {.lex_state = 244},
  [3691] = {.lex_state = 244},
  [3692] = {.lex_state = 244},
  [3693] = {.lex_state = 241},
  [3694] = {.lex_state = 241},
  [3695] = {.lex_state = 244},
  [3696] = {.lex_state = 244},
  [3697] = {.lex_state = 239},
  [3698] = {.lex_state = 244},
  [3699] = {.lex_state = 244},
  [3700] = {.lex_state = 239},
  [3701] = {.lex_state = 241},
  [3702] = {.lex_state = 244},
  [3703] = {.lex_state = 244},
  [3704] = {.lex_state = 256},
  [3705] = {.lex_state = 244},
  [3706] = {.lex_state = 244},
  [3707] = {.lex_state = 244},
  [3708] = {.lex_state = 244},
  [3709] = {.lex_state = 251},
  [3710] = {.lex_state = 244},
  [3711] = {.lex_state = 239},
  [3712] = {.lex_state = 244},
  [3713] = {.lex_state = 241},
  [3714] = {.lex_state = 244},
  [3715] = {.lex_state = 244},
  [3716] = {.lex_state = 244},
  [3717] = {.lex_state = 244},
  [3718] = {.lex_state = 213},
  [3719] = {.lex_state = 244},
  [3720] = {.lex_state = 244},
  [3721] = {.lex_state = 258},
  [3722] = {.lex_state = 267},
  [3723] = {.lex_state = 241},
  [3724] = {.lex_state = 244},
  [3725] = {.lex_state = 244},
  [3726] = {.lex_state = 239},
  [3727] = {.lex_state = 261},
  [3728] = {.lex_state = 244},
  [3729] = {.lex_state = 261},
  [3730] = {.lex_state = 244},
  [3731] = {.lex_state = 244},
  [3732] = {.lex_state = 239},
  [3733] = {.lex_state = 228},
  [3734] = {.lex_state = 244},
  [3735] = {.lex_state = 244},
  [3736] = {.lex_state = 244},
  [3737] = {.lex_state = 244},
  [3738] = {.lex_state = 244},
  [3739] = {.lex_state = 239},
  [3740] = {.lex_state = 244},
  [3741] = {.lex_state = 244},
  [3742] = {.lex_state = 244},
  [3743] = {.lex_state = 241},
  [3744] = {.lex_state = 244},
  [3745] = {.lex_state = 244},
  [3746] = {.lex_state = 244},
  [3747] = {.lex_state = 260},
  [3748] = {.lex_state = 267},
  [3749] = {.lex_state = 256},
  [3750] = {.lex_state = 244},
  [3751] = {.lex_state = 244},
  [3752] = {.lex_state = 239},
  [3753] = {.lex_state = 244},
  [3754] = {.lex_state = 261},
  [3755] = {.lex_state = 258},
  [3756] = {.lex_state = 261},
  [3757] = {.lex_state = 267},
  [3758] = {.lex_state = 244},
  [3759] = {.lex_state = 258},
  [3760] = {.lex_state = 244},
  [3761] = {.lex_state = 244},
  [3762] = {.lex_state = 244},
  [3763] = {.lex_state = 244},
  [3764] = {.lex_state = 244},
  [3765] = {.lex_state = 244},
  [3766] = {.lex_state = 244},
  [3767] = {.lex_state = 239},
  [3768] = {.lex_state = 244},
  [3769] = {.lex_state = 251},
  [3770] = {.lex_state = 213},
  [3771] = {.lex_state = 244},
  [3772] = {.lex_state = 226},
  [3773] = {.lex_state = 244},
  [3774] = {.lex_state = 244},
  [3775] = {.lex_state = 244},
  [3776] = {.lex_state = 256},
  [3777] = {.lex_state = 244},
  [3778] = {.lex_state = 241},
  [3779] = {.lex_state = 244},
  [3780] = {.lex_state = 244},
  [3781] = {.lex_state = 244},
  [3782] = {.lex_state = 244},
  [3783] = {.lex_state = 244},
  [3784] = {.lex_state = 244},
  [3785] = {.lex_state = 244},
  [3786] = {.lex_state = 239},
  [3787] = {.lex_state = 261},
  [3788] = {.lex_state = 239},
  [3789] = {.lex_state = 265},
  [3790] = {.lex_state = 244},
  [3791] = {.lex_state = 267},
  [3792] = {.lex_state = 244},
  [3793] = {.lex_state = 244},
  [3794] = {.lex_state = 244},
  [3795] = {.lex_state = 244},
  [3796] = {.lex_state = 256},
  [3797] = {.lex_state = 244},
  [3798] = {.lex_state = 256},
  [3799] = {.lex_state = 244},
  [3800] = {.lex_state = 244},
  [3801] = {.lex_state = 251},
  [3802] = {.lex_state = 244},
  [3803] = {.lex_state = 244},
  [3804] = {.lex_state = 244},
  [3805] = {.lex_state = 251},
  [3806] = {.lex_state = 244},
  [3807] = {.lex_state = 244},
  [3808] = {.lex_state = 256},
  [3809] = {.lex_state = 244},
  [3810] = {.lex_state = 244},
  [3811] = {.lex_state = 244},
  [3812] = {.lex_state = 256},
  [3813] = {.lex_state = 244},
  [3814] = {.lex_state = 244},
  [3815] = {.lex_state = 244},
  [3816] = {.lex_state = 244},
  [3817] = {.lex_state = 244},
  [3818] = {.lex_state = 256},
  [3819] = {.lex_state = 244},
  [3820] = {.lex_state = 256},
  [3821] = {.lex_state = 256},
  [3822] = {.lex_state = 241},
  [3823] = {.lex_state = 267},
  [3824] = {.lex_state = 244},
  [3825] = {.lex_state = 206},
  [3826] = {.lex_state = 244},
  [3827] = {.lex_state = 244},
  [3828] = {.lex_state = 240},
  [3829] = {.lex_state = 244},
  [3830] = {.lex_state = 239},
  [3831] = {.lex_state = 263},
  [3832] = {.lex_state = 244},
  [3833] = {.lex_state = 263},
  [3834] = {.lex_state = 226},
  [3835] = {.lex_state = 244},
  [3836] = {.lex_state = 244},
  [3837] = {.lex_state = 240},
  [3838] = {.lex_state = 239},
  [3839] = {.lex_state = 244},
  [3840] = {.lex_state = 239},
  [3841] = {.lex_state = 254},
  [3842] = {.lex_state = 251},
  [3843] = {.lex_state = 251},
  [3844] = {.lex_state = 251},
  [3845] = {.lex_state = 239},
  [3846] = {.lex_state = 254},
  [3847] = {.lex_state = 251},
  [3848] = {.lex_state = 239},
  [3849] = {.lex_state = 239},
  [3850] = {.lex_state = 254},
  [3851] = {.lex_state = 254},
  [3852] = {.lex_state = 254},
  [3853] = {.lex_state = 254},
  [3854] = {.lex_state = 251},
  [3855] = {.lex_state = 213},
  [3856] = {.lex_state = 239},
  [3857] = {.lex_state = 232},
  [3858] = {.lex_state = 239},
  [3859] = {.lex_state = 251},
  [3860] = {.lex_state = 254},
  [3861] = {.lex_state = 254},
  [3862] = {.lex_state = 254},
  [3863] = {.lex_state = 254},
  [3864] = {.lex_state = 254},
  [3865] = {.lex_state = 254},
  [3866] = {.lex_state = 235},
  [3867] = {.lex_state = 235},
  [3868] = {.lex_state = 235},
  [3869] = {.lex_state = 254},
  [3870] = {.lex_state = 235},
  [3871] = {.lex_state = 235},
  [3872] = {.lex_state = 235},
  [3873] = {.lex_state = 251},
  [3874] = {.lex_state = 254},
  [3875] = {.lex_state = 254},
  [3876] = {.lex_state = 235},
  [3877] = {.lex_state = 251},
  [3878] = {.lex_state = 254},
  [3879] = {.lex_state = 254},
  [3880] = {.lex_state = 254},
  [3881] = {.lex_state = 251},
  [3882] = {.lex_state = 239},
  [3883] = {.lex_state = 251},
  [3884] = {.lex_state = 251},
  [3885] = {.lex_state = 254},
  [3886] = {.lex_state = 251},
  [3887] = {.lex_state = 251},
  [3888] = {.lex_state = 251},
  [3889] = {.lex_state = 254},
  [3890] = {.lex_state = 254},
  [3891] = {.lex_state = 254},
  [3892] = {.lex_state = 254},
  [3893] = {.lex_state = 254},
  [3894] = {.lex_state = 254},
  [3895] = {.lex_state = 254},
  [3896] = {.lex_state = 235},
  [3897] = {.lex_state = 254},
  [3898] = {.lex_state = 254},
  [3899] = {.lex_state = 254},
  [3900] = {.lex_state = 239},
  [3901] = {.lex_state = 251},
  [3902] = {.lex_state = 251},
  [3903] = {.lex_state = 254},
  [3904] = {.lex_state = 251},
  [3905] = {.lex_state = 254},
  [3906] = {.lex_state = 251},
  [3907] = {.lex_state = 254},
  [3908] = {.lex_state = 254},
  [3909] = {.lex_state = 251},
  [3910] = {.lex_state = 251},
  [3911] = {.lex_state = 239},
  [3912] = {.lex_state = 254},
  [3913] = {.lex_state = 251},
  [3914] = {.lex_state = 254},
  [3915] = {.lex_state = 251},
  [3916] = {.lex_state = 254},
  [3917] = {.lex_state = 251},
  [3918] = {.lex_state = 254},
  [3919] = {.lex_state = 254},
  [3920] = {.lex_state = 251},
  [3921] = {.lex_state = 251},
  [3922] = {.lex_state = 251},
  [3923] = {.lex_state = 254},
  [3924] = {.lex_state = 254},
  [3925] = {.lex_state = 251},
  [3926] = {.lex_state = 251},
  [3927] = {.lex_state = 254},
  [3928] = {.lex_state = 251},
  [3929] = {.lex_state = 254},
  [3930] = {.lex_state = 251},
  [3931] = {.lex_state = 254},
  [3932] = {.lex_state = 251},
  [3933] = {.lex_state = 254},
  [3934] = {.lex_state = 251},
  [3935] = {.lex_state = 251},
  [3936] = {.lex_state = 254},
  [3937] = {.lex_state = 231},
  [3938] = {.lex_state = 213},
  [3939] = {.lex_state = 251},
  [3940] = {.lex_state = 251},
  [3941] = {.lex_state = 254},
  [3942] = {.lex_state = 251},
  [3943] = {.lex_state = 251},
  [3944] = {.lex_state = 251},
  [3945] = {.lex_state = 251},
  [3946] = {.lex_state = 254},
  [3947] = {.lex_state = 244},
  [3948] = {.lex_state = 254},
  [3949] = {.lex_state = 251},
  [3950] = {.lex_state = 254},
  [3951] = {.lex_state = 254},
  [3952] = {.lex_state = 254},
  [3953] = {.lex_state = 267},
  [3954] = {.lex_state = 254},
  [3955] = {.lex_state = 232},
  [3956] = {.lex_state = 251},
  [3957] = {.lex_state = 254},
  [3958] = {.lex_state = 254},
  [3959] = {.lex_state = 251},
  [3960] = {.lex_state = 251},
  [3961] = {.lex_state = 267},
  [3962] = {.lex_state = 251},
  [3963] = {.lex_state = 254},
  [3964] = {.lex_state = 251},
  [3965] = {.lex_state = 254},
  [3966] = {.lex_state = 254},
  [3967] = {.lex_state = 251},
  [3968] = {.lex_state = 254},
  [3969] = {.lex_state = 254},
  [3970] = {.lex_state = 254},
  [3971] = {.lex_state = 251},
  [3972] = {.lex_state = 254},
  [3973] = {.lex_state = 254},
  [3974] = {.lex_state = 251},
  [3975] = {.lex_state = 239},
  [3976] = {.lex_state = 251},
  [3977] = {.lex_state = 251},
  [3978] = {.lex_state = 239},
  [3979] = {.lex_state = 239},
  [3980] = {.lex_state = 251},
  [3981] = {.lex_state = 254},
  [3982] = {.lex_state = 251},
  [3983] = {.lex_state = 254},
  [3984] = {.lex_state = 254},
  [3985] = {.lex_state = 254},
  [3986] = {.lex_state = 251},
  [3987] = {.lex_state = 254},
  [3988] = {.lex_state = 254},
  [3989] = {.lex_state = 254},
  [3990] = {.lex_state = 251},
  [3991] = {.lex_state = 251},
  [3992] = {.lex_state = 251},
  [3993] = {.lex_state = 251},
  [3994] = {.lex_state = 251},
  [3995] = {.lex_state = 251},
  [3996] = {.lex_state = 251},
  [3997] = {.lex_state = 251},
  [3998] = {.lex_state = 251},
  [3999] = {.lex_state = 251},
  [4000] = {.lex_state = 251},
  [4001] = {.lex_state = 254},
  [4002] = {.lex_state = 251},
  [4003] = {.lex_state = 251},
  [4004] = {.lex_state = 251},
  [4005] = {.lex_state = 251},
  [4006] = {.lex_state = 254},
  [4007] = {.lex_state = 254},
  [4008] = {.lex_state = 251},
  [4009] = {.lex_state = 251},
  [4010] = {.lex_state = 254},
  [4011] = {.lex_state = 251},
  [4012] = {.lex_state = 251},
  [4013] = {.lex_state = 239},
  [4014] = {.lex_state = 254},
  [4015] = {.lex_state = 251},
  [4016] = {.lex_state = 251},
  [4017] = {.lex_state = 251},
  [4018] = {.lex_state = 254},
  [4019] = {.lex_state = 254},
  [4020] = {.lex_state = 254},
  [4021] = {.lex_state = 251},
  [4022] = {.lex_state = 254},
  [4023] = {.lex_state = 288},
  [4024] = {.lex_state = 251},
  [4025] = {.lex_state = 254},
  [4026] = {.lex_state = 254},
  [4027] = {.lex_state = 251},
  [4028] = {.lex_state = 254},
  [4029] = {.lex_state = 251},
  [4030] = {.lex_state = 254},
  [4031] = {.lex_state = 251},
  [4032] = {.lex_state = 251},
  [4033] = {.lex_state = 254},
  [4034] = {.lex_state = 267},
  [4035] = {.lex_state = 251},
  [4036] = {.lex_state = 251},
  [4037] = {.lex_state = 251},
  [4038] = {.lex_state = 244},
  [4039] = {.lex_state = 251},
  [4040] = {.lex_state = 254},
  [4041] = {.lex_state = 254},
  [4042] = {.lex_state = 251},
  [4043] = {.lex_state = 254},
  [4044] = {.lex_state = 213},
  [4045] = {.lex_state = 286},
  [4046] = {.lex_state = 286},
  [4047] = {.lex_state = 286},
  [4048] = {.lex_state = 239},
  [4049] = {.lex_state = 286},
  [4050] = {.lex_state = 286},
  [4051] = {.lex_state = 285},
  [4052] = {.lex_state = 288},
  [4053] = {.lex_state = 286},
  [4054] = {.lex_state = 286},
  [4055] = {.lex_state = 241},
  [4056] = {.lex_state = 286},
  [4057] = {.lex_state = 226},
  [4058] = {.lex_state = 289},
  [4059] = {.lex_state = 289},
  [4060] = {.lex_state = 228},
  [4061] = {.lex_state = 226},
  [4062] = {.lex_state = 285},
  [4063] = {.lex_state = 286},
  [4064] = {.lex_state = 248},
  [4065] = {.lex_state = 248},
  [4066] = {.lex_state = 286},
  [4067] = {.lex_state = 286},
  [4068] = {.lex_state = 286},
  [4069] = {.lex_state = 286},
  [4070] = {.lex_state = 286},
  [4071] = {.lex_state = 286},
  [4072] = {.lex_state = 286},
  [4073] = {.lex_state = 286},
  [4074] = {.lex_state = 213},
  [4075] = {.lex_state = 286},
  [4076] = {.lex_state = 288},
  [4077] = {.lex_state = 239},
  [4078] = {.lex_state = 248},
  [4079] = {.lex_state = 239},
  [4080] = {.lex_state = 286},
  [4081] = {.lex_state = 228},
  [4082] = {.lex_state = 286},
  [4083] = {.lex_state = 241},
  [4084] = {.lex_state = 286},
  [4085] = {.lex_state = 213},
  [4086] = {.lex_state = 286},
  [4087] = {.lex_state = 289},
  [4088] = {.lex_state = 213},
  [4089] = {.lex_state = 241},
  [4090] = {.lex_state = 286},
  [4091] = {.lex_state = 286},
  [4092] = {.lex_state = 232},
  [4093] = {.lex_state = 286},
  [4094] = {.lex_state = 286},
  [4095] = {.lex_state = 286},
  [4096] = {.lex_state = 286},
  [4097] = {.lex_state = 244},
  [4098] = {.lex_state = 239},
  [4099] = {.lex_state = 239},
  [4100] = {.lex_state = 239},
  [4101] = {.lex_state = 286},
  [4102] = {.lex_state = 239},
  [4103] = {.lex_state = 239},
  [4104] = {.lex_state = 239},
  [4105] = {.lex_state = 239},
  [4106] = {.lex_state = 239},
  [4107] = {.lex_state = 286},
  [4108] = {.lex_state = 239},
  [4109] = {.lex_state = 289},
  [4110] = {.lex_state = 286},
  [4111] = {.lex_state = 239},
  [4112] = {.lex_state = 267},
  [4113] = {.lex_state = 286},
  [4114] = {.lex_state = 244},
  [4115] = {.lex_state = 244},
  [4116] = {.lex_state = 244},
  [4117] = {.lex_state = 244},
  [4118] = {.lex_state = 244},
  [4119] = {.lex_state = 244},
  [4120] = {.lex_state = 244},
  [4121] = {.lex_state = 241},
  [4122] = {.lex_state = 241},
  [4123] = {.lex_state = 244},
  [4124] = {.lex_state = 244},
  [4125] = {.lex_state = 239},
  [4126] = {.lex_state = 244},
  [4127] = {.lex_state = 244},
  [4128] = {.lex_state = 244},
  [4129] = {.lex_state = 244},
  [4130] = {.lex_state = 289},
  [4131] = {.lex_state = 244},
  [4132] = {.lex_state = 244},
  [4133] = {.lex_state = 239},
  [4134] = {.lex_state = 244},
  [4135] = {.lex_state = 244},
  [4136] = {.lex_state = 239},
  [4137] = {.lex_state = 244},
  [4138] = {.lex_state = 244},
  [4139] = {.lex_state = 288},
  [4140] = {.lex_state = 244},
  [4141] = {.lex_state = 244},
  [4142] = {.lex_state = 244},
  [4143] = {.lex_state = 244},
  [4144] = {.lex_state = 244},
  [4145] = {.lex_state = 244},
  [4146] = {.lex_state = 244},
  [4147] = {.lex_state = 289},
  [4148] = {.lex_state = 244},
  [4149] = {.lex_state = 244},
  [4150] = {.lex_state = 239},
  [4151] = {.lex_state = 241},
  [4152] = {.lex_state = 244},
  [4153] = {.lex_state = 288},
  [4154] = {.lex_state = 244},
  [4155] = {.lex_state = 244},
  [4156] = {.lex_state = 244},
  [4157] = {.lex_state = 244},
  [4158] = {.lex_state = 244},
  [4159] = {.lex_state = 244},
  [4160] = {.lex_state = 244},
  [4161] = {.lex_state = 241},
  [4162] = {.lex_state = 241},
  [4163] = {.lex_state = 244},
  [4164] = {.lex_state = 244},
  [4165] = {.lex_state = 285},
  [4166] = {.lex_state = 213},
  [4167] = {.lex_state = 239},
  [4168] = {.lex_state = 244},
  [4169] = {.lex_state = 244},
  [4170] = {.lex_state = 213},
  [4171] = {.lex_state = 241},
  [4172] = {.lex_state = 213},
  [4173] = {.lex_state = 244},
  [4174] = {.lex_state = 213},
  [4175] = {.lex_state = 244},
  [4176] = {.lex_state = 228},
  [4177] = {.lex_state = 228},
  [4178] = {.lex_state = 213},
  [4179] = {.lex_state = 228},
  [4180] = {.lex_state = 228},
  [4181] = {.lex_state = 244},
  [4182] = {.lex_state = 226},
  [4183] = {.lex_state = 239},
  [4184] = {.lex_state = 226},
  [4185] = {.lex_state = 244},
  [4186] = {.lex_state = 244},
  [4187] = {.lex_state = 226},
  [4188] = {.lex_state = 244},
  [4189] = {.lex_state = 244},
  [4190] = {.lex_state = 244},
  [4191] = {.lex_state = 244},
  [4192] = {.lex_state = 244},
  [4193] = {.lex_state = 244},
  [4194] = {.lex_state = 244},
  [4195] = {.lex_state = 244},
  [4196] = {.lex_state = 244},
  [4197] = {.lex_state = 244},
  [4198] = {.lex_state = 226},
  [4199] = {.lex_state = 244},
  [4200] = {.lex_state = 244},
  [4201] = {.lex_state = 244},
  [4202] = {.lex_state = 244},
  [4203] = {.lex_state = 239},
  [4204] = {.lex_state = 226},
  [4205] = {.lex_state = 241},
  [4206] = {.lex_state = 228},
  [4207] = {.lex_state = 271},
  [4208] = {.lex_state = 277},
  [4209] = {.lex_state = 241},
  [4210] = {.lex_state = 241},
  [4211] = {.lex_state = 285},
  [4212] = {.lex_state = 241},
  [4213] = {.lex_state = 289},
  [4214] = {.lex_state = 285},
  [4215] = {.lex_state = 277},
  [4216] = {.lex_state = 241},
  [4217] = {.lex_state = 228},
  [4218] = {.lex_state = 267},
  [4219] = {.lex_state = 267},
  [4220] = {.lex_state = 267},
  [4221] = {.lex_state = 226},
  [4222] = {.lex_state = 226},
  [4223] = {.lex_state = 267},
  [4224] = {.lex_state = 241},
  [4225] = {.lex_state = 241},
  [4226] = {.lex_state = 241},
  [4227] = {.lex_state = 228},
  [4228] = {.lex_state = 267},
  [4229] = {.lex_state = 241},
  [4230] = {.lex_state = 241},
  [4231] = {.lex_state = 285},
  [4232] = {.lex_state = 241},
  [4233] = {.lex_state = 241},
  [4234] = {.lex_state = 288},
  [4235] = {.lex_state = 285},
  [4236] = {.lex_state = 285},
  [4237] = {.lex_state = 277},
  [4238] = {.lex_state = 289},
  [4239] = {.lex_state = 267},
  [4240] = {.lex_state = 285},
  [4241] = {.lex_state = 241},
  [4242] = {.lex_state = 239},
  [4243] = {.lex_state = 241},
  [4244] = {.lex_state = 241},
  [4245] = {.lex_state = 241},
  [4246] = {.lex_state = 241},
  [4247] = {.lex_state = 285},
  [4248] = {.lex_state = 241},
  [4249] = {.lex_state = 241},
  [4250] = {.lex_state = 273},
  [4251] = {.lex_state = 288},
  [4252] = {.lex_state = 267},
  [4253] = {.lex_state = 288},
  [4254] = {.lex_state = 228},
  [4255] = {.lex_state = 241},
  [4256] = {.lex_state = 241},
  [4257] = {.lex_state = 241},
  [4258] = {.lex_state = 241},
  [4259] = {.lex_state = 270},
  [4260] = {.lex_state = 241},
  [4261] = {.lex_state = 267},
  [4262] = {.lex_state = 241},
  [4263] = {.lex_state = 226},
  [4264] = {.lex_state = 241},
  [4265] = {.lex_state = 241},
  [4266] = {.lex_state = 241},
  [4267] = {.lex_state = 241},
  [4268] = {.lex_state = 241},
  [4269] = {.lex_state = 241},
  [4270] = {.lex_state = 241},
  [4271] = {.lex_state = 241},
  [4272] = {.lex_state = 241},
  [4273] = {.lex_state = 241},
  [4274] = {.lex_state = 241},
  [4275] = {.lex_state = 288},
  [4276] = {.lex_state = 239},
  [4277] = {.lex_state = 239},
  [4278] = {.lex_state = 239},
  [4279] = {.lex_state = 239},
  [4280] = {.lex_state = 239},
  [4281] = {.lex_state = 241},
  [4282] = {.lex_state = 289},
  [4283] = {.lex_state = 239},
  [4284] = {.lex_state = 289},
  [4285] = {.lex_state = 288},
  [4286] = {.lex_state = 289},
  [4287] = {.lex_state = 241},
  [4288] = {.lex_state = 239},
  [4289] = {.lex_state = 289},
  [4290] = {.lex_state = 289},
  [4291] = {.lex_state = 289},
  [4292] = {.lex_state = 291},
  [4293] = {.lex_state = 239},
  [4294] = {.lex_state = 289},
  [4295] = {.lex_state = 241},
  [4296] = {.lex_state = 289},
  [4297] = {.lex_state = 267},
  [4298] = {.lex_state = 271},
  [4299] = {.lex_state = 270},
  [4300] = {.lex_state = 291},
  [4301] = {.lex_state = 267},
  [4302] = {.lex_state = 291},
  [4303] = {.lex_state = 239},
  [4304] = {.lex_state = 239},
  [4305] = {.lex_state = 239},
  [4306] = {.lex_state = 241},
  [4307] = {.lex_state = 239},
  [4308] = {.lex_state = 285},
  [4309] = {.lex_state = 239},
  [4310] = {.lex_state = 285},
  [4311] = {.lex_state = 239},
  [4312] = {.lex_state = 289},
  [4313] = {.lex_state = 239},
  [4314] = {.lex_state = 239},
  [4315] = {.lex_state = 288},
  [4316] = {.lex_state = 239},
  [4317] = {.lex_state = 285},
  [4318] = {.lex_state = 285},
  [4319] = {.lex_state = 239},
  [4320] = {.lex_state = 239},
  [4321] = {.lex_state = 239},
  [4322] = {.lex_state = 271},
  [4323] = {.lex_state = 271},
  [4324] = {.lex_state = 239},
  [4325] = {.lex_state = 271},
  [4326] = {.lex_state = 239},
  [4327] = {.lex_state = 271},
  [4328] = {.lex_state = 239},
  [4329] = {.lex_state = 271},
  [4330] = {.lex_state = 239},
  [4331] = {.lex_state = 271},
  [4332] = {.lex_state = 288},
  [4333] = {.lex_state = 239},
  [4334] = {.lex_state = 239},
  [4335] = {.lex_state = 271},
  [4336] = {.lex_state = 270},
  [4337] = {.lex_state = 239},
  [4338] = {.lex_state = 239},
  [4339] = {.lex_state = 239},
  [4340] = {.lex_state = 239},
  [4341] = {.lex_state = 288},
  [4342] = {.lex_state = 271},
  [4343] = {.lex_state = 239},
  [4344] = {.lex_state = 288},
  [4345] = {.lex_state = 271},
  [4346] = {.lex_state = 239},
  [4347] = {.lex_state = 239},
  [4348] = {.lex_state = 288},
  [4349] = {.lex_state = 239},
  [4350] = {.lex_state = 285},
  [4351] = {.lex_state = 270},
  [4352] = {.lex_state = 288},
  [4353] = {.lex_state = 239},
  [4354] = {.lex_state = 289},
  [4355] = {.lex_state = 239},
  [4356] = {.lex_state = 271},
  [4357] = {.lex_state = 239},
  [4358] = {.lex_state = 239},
  [4359] = {.lex_state = 271},
  [4360] = {.lex_state = 239},
  [4361] = {.lex_state = 239},
  [4362] = {.lex_state = 271},
  [4363] = {.lex_state = 239},
  [4364] = {.lex_state = 285},
  [4365] = {.lex_state = 289},
  [4366] = {.lex_state = 239},
  [4367] = {.lex_state = 241},
  [4368] = {.lex_state = 271},
  [4369] = {.lex_state = 239},
  [4370] = {.lex_state = 239},
  [4371] = {.lex_state = 272},
  [4372] = {.lex_state = 239},
  [4373] = {.lex_state = 239},
  [4374] = {.lex_state = 239},
  [4375] = {.lex_state = 289},
  [4376] = {.lex_state = 239},
  [4377] = {.lex_state = 241},
  [4378] = {.lex_state = 239},
  [4379] = {.lex_state = 239},
  [4380] = {.lex_state = 239},
  [4381] = {.lex_state = 239},
  [4382] = {.lex_state = 271},
  [4383] = {.lex_state = 271},
  [4384] = {.lex_state = 239},
  [4385] = {.lex_state = 289},
  [4386] = {.lex_state = 289},
  [4387] = {.lex_state = 239},
  [4388] = {.lex_state = 239},
  [4389] = {.lex_state = 285},
  [4390] = {.lex_state = 239},
  [4391] = {.lex_state = 239},
  [4392] = {.lex_state = 292},
  [4393] = {.lex_state = 288},
  [4394] = {.lex_state = 239},
  [4395] = {.lex_state = 239},
  [4396] = {.lex_state = 239},
  [4397] = {.lex_state = 241},
  [4398] = {.lex_state = 285},
  [4399] = {.lex_state = 271},
  [4400] = {.lex_state = 288},
  [4401] = {.lex_state = 239},
  [4402] = {.lex_state = 241},
  [4403] = {.lex_state = 292},
  [4404] = {.lex_state = 239},
  [4405] = {.lex_state = 292},
  [4406] = {.lex_state = 239},
  [4407] = {.lex_state = 241},
  [4408] = {.lex_state = 239},
  [4409] = {.lex_state = 239},
  [4410] = {.lex_state = 239},
  [4411] = {.lex_state = 239},
  [4412] = {.lex_state = 288},
  [4413] = {.lex_state = 239},
  [4414] = {.lex_state = 239},
  [4415] = {.lex_state = 239},
  [4416] = {.lex_state = 289},
  [4417] = {.lex_state = 239},
  [4418] = {.lex_state = 271},
  [4419] = {.lex_state = 289},
  [4420] = {.lex_state = 239},
  [4421] = {.lex_state = 273},
  [4422] = {.lex_state = 271},
  [4423] = {.lex_state = 271},
  [4424] = {.lex_state = 285},
  [4425] = {.lex_state = 239},
  [4426] = {.lex_state = 289},
  [4427] = {.lex_state = 239},
  [4428] = {.lex_state = 289},
  [4429] = {.lex_state = 239},
  [4430] = {.lex_state = 289},
  [4431] = {.lex_state = 288},
  [4432] = {.lex_state = 289},
  [4433] = {.lex_state = 271},
  [4434] = {.lex_state = 241},
  [4435] = {.lex_state = 271},
  [4436] = {.lex_state = 273},
  [4437] = {.lex_state = 239},
  [4438] = {.lex_state = 289},
  [4439] = {.lex_state = 289},
  [4440] = {.lex_state = 288},
  [4441] = {.lex_state = 239},
  [4442] = {.lex_state = 239},
  [4443] = {.lex_state = 289},
  [4444] = {.lex_state = 285},
  [4445] = {.lex_state = 272},
  [4446] = {.lex_state = 239},
  [4447] = {.lex_state = 239},
  [4448] = {.lex_state = 239},
  [4449] = {.lex_state = 271},
  [4450] = {.lex_state = 239},
  [4451] = {.lex_state = 239},
  [4452] = {.lex_state = 239},
  [4453] = {.lex_state = 285},
  [4454] = {.lex_state = 289},
  [4455] = {.lex_state = 267},
  [4456] = {.lex_state = 241},
  [4457] = {.lex_state = 285},
  [4458] = {.lex_state = 267},
  [4459] = {.lex_state = 241},
  [4460] = {.lex_state = 289},
  [4461] = {.lex_state = 273},
  [4462] = {.lex_state = 271},
  [4463] = {.lex_state = 289},
  [4464] = {.lex_state = 272},
  [4465] = {.lex_state = 267},
  [4466] = {.lex_state = 241},
  [4467] = {.lex_state = 289},
  [4468] = {.lex_state = 267},
  [4469] = {.lex_state = 241},
  [4470] = {.lex_state = 272},
  [4471] = {.lex_state = 288},
  [4472] = {.lex_state = 272},
  [4473] = {.lex_state = 271},
  [4474] = {.lex_state = 271},
  [4475] = {.lex_state = 272},
  [4476] = {.lex_state = 271},
  [4477] = {.lex_state = 271},
  [4478] = {.lex_state = 239},
  [4479] = {.lex_state = 242},
  [4480] = {.lex_state = 288},
  [4481] = {.lex_state = 241},
  [4482] = {.lex_state = 242},
  [4483] = {.lex_state = 242},
  [4484] = {.lex_state = 288},
  [4485] = {.lex_state = 289},
  [4486] = {.lex_state = 239},
  [4487] = {.lex_state = 239},
  [4488] = {.lex_state = 289},
  [4489] = {.lex_state = 288},
  [4490] = {.lex_state = 288},
  [4491] = {.lex_state = 288},
  [4492] = {.lex_state = 288},
  [4493] = {.lex_state = 288},
  [4494] = {.lex_state = 289},
  [4495] = {.lex_state = 288},
  [4496] = {.lex_state = 288},
  [4497] = {.lex_state = 288},
  [4498] = {.lex_state = 239},
  [4499] = {.lex_state = 288},
  [4500] = {.lex_state = 290},
  [4501] = {.lex_state = 239},
  [4502] = {.lex_state = 239},
  [4503] = {.lex_state = 241},
  [4504] = {.lex_state = 289},
  [4505] = {.lex_state = 288},
  [4506] = {.lex_state = 289},
  [4507] = {.lex_state = 239},
  [4508] = {.lex_state = 239},
  [4509] = {.lex_state = 239},
  [4510] = {.lex_state = 288},
  [4511] = {.lex_state = 288},
  [4512] = {.lex_state = 288},
  [4513] = {.lex_state = 288},
  [4514] = {.lex_state = 288},
  [4515] = {.lex_state = 288},
  [4516] = {.lex_state = 288},
  [4517] = {.lex_state = 239},
  [4518] = {.lex_state = 288},
  [4519] = {.lex_state = 288},
  [4520] = {.lex_state = 239},
  [4521] = {.lex_state = 286},
  [4522] = {.lex_state = 288},
  [4523] = {.lex_state = 239},
  [4524] = {.lex_state = 271},
  [4525] = {.lex_state = 289},
  [4526] = {.lex_state = 288},
  [4527] = {.lex_state = 289},
  [4528] = {.lex_state = 239},
  [4529] = {.lex_state = 239},
  [4530] = {.lex_state = 239},
  [4531] = {.lex_state = 289},
  [4532] = {.lex_state = 288},
  [4533] = {.lex_state = 239},
  [4534] = {.lex_state = 288},
  [4535] = {.lex_state = 239},
  [4536] = {.lex_state = 288},
  [4537] = {.lex_state = 271},
  [4538] = {.lex_state = 239},
  [4539] = {.lex_state = 271},
  [4540] = {.lex_state = 239},
  [4541] = {.lex_state = 271},
  [4542] = {.lex_state = 271},
  [4543] = {.lex_state = 288},
  [4544] = {.lex_state = 239},
  [4545] = {.lex_state = 286},
  [4546] = {.lex_state = 286},
  [4547] = {.lex_state = 288},
  [4548] = {.lex_state = 286},
  [4549] = {.lex_state = 286},
  [4550] = {.lex_state = 289},
  [4551] = {.lex_state = 271},
  [4552] = {.lex_state = 289},
  [4553] = {.lex_state = 288},
  [4554] = {.lex_state = 242},
  [4555] = {.lex_state = 286},
  [4556] = {.lex_state = 288},
  [4557] = {.lex_state = 286},
  [4558] = {.lex_state = 241},
  [4559] = {.lex_state = 286},
  [4560] = {.lex_state = 290},
  [4561] = {.lex_state = 286},
  [4562] = {.lex_state = 239},
  [4563] = {.lex_state = 239},
  [4564] = {.lex_state = 239},
  [4565] = {.lex_state = 239},
  [4566] = {.lex_state = 239},
  [4567] = {.lex_state = 239},
  [4568] = {.lex_state = 286},
  [4569] = {.lex_state = 286},
  [4570] = {.lex_state = 239},
  [4571] = {.lex_state = 239},
  [4572] = {.lex_state = 239},
  [4573] = {.lex_state = 271},
  [4574] = {.lex_state = 239},
  [4575] = {.lex_state = 239},
  [4576] = {.lex_state = 286},
  [4577] = {.lex_state = 286},
  [4578] = {.lex_state = 271},
  [4579] = {.lex_state = 271},
  [4580] = {.lex_state = 288},
  [4581] = {.lex_state = 271},
  [4582] = {.lex_state = 240},
  [4583] = {.lex_state = 286},
  [4584] = {.lex_state = 288},
  [4585] = {.lex_state = 271},
  [4586] = {.lex_state = 239},
  [4587] = {.lex_state = 239},
  [4588] = {.lex_state = 239},
  [4589] = {.lex_state = 239},
  [4590] = {.lex_state = 286},
  [4591] = {.lex_state = 288},
  [4592] = {.lex_state = 288},
  [4593] = {.lex_state = 271},
  [4594] = {.lex_state = 242},
  [4595] = {.lex_state = 271},
  [4596] = {.lex_state = 286},
  [4597] = {.lex_state = 289},
  [4598] = {.lex_state = 286},
  [4599] = {.lex_state = 286},
  [4600] = {.lex_state = 286},
  [4601] = {.lex_state = 286},
  [4602] = {.lex_state = 239},
  [4603] = {.lex_state = 286},
  [4604] = {.lex_state = 286},
  [4605] = {.lex_state = 239},
  [4606] = {.lex_state = 290},
  [4607] = {.lex_state = 286},
  [4608] = {.lex_state = 288},
  [4609] = {.lex_state = 288},
  [4610] = {.lex_state = 288},
  [4611] = {.lex_state = 241},
  [4612] = {.lex_state = 239},
  [4613] = {.lex_state = 242},
  [4614] = {.lex_state = 239},
  [4615] = {.lex_state = 286},
  [4616] = {.lex_state = 286},
  [4617] = {.lex_state = 290},
  [4618] = {.lex_state = 289},
  [4619] = {.lex_state = 271},
  [4620] = {.lex_state = 289},
  [4621] = {.lex_state = 272},
  [4622] = {.lex_state = 289},
  [4623] = {.lex_state = 272},
  [4624] = {.lex_state = 239},
  [4625] = {.lex_state = 239},
  [4626] = {.lex_state = 272},
  [4627] = {.lex_state = 239},
  [4628] = {.lex_state = 271},
  [4629] = {.lex_state = 239},
  [4630] = {.lex_state = 239},
  [4631] = {.lex_state = 239},
  [4632] = {.lex_state = 289},
  [4633] = {.lex_state = 239},
  [4634] = {.lex_state = 239},
  [4635] = {.lex_state = 239},
  [4636] = {.lex_state = 289},
  [4637] = {.lex_state = 239},
  [4638] = {.lex_state = 239},
  [4639] = {.lex_state = 289},
  [4640] = {.lex_state = 272},
  [4641] = {.lex_state = 239},
  [4642] = {.lex_state = 288},
  [4643] = {.lex_state = 239},
  [4644] = {.lex_state = 272},
  [4645] = {.lex_state = 272},
  [4646] = {.lex_state = 272},
  [4647] = {.lex_state = 289},
  [4648] = {.lex_state = 286},
  [4649] = {.lex_state = 272},
  [4650] = {.lex_state = 239},
  [4651] = {.lex_state = 239},
  [4652] = {.lex_state = 272},
  [4653] = {.lex_state = 239},
  [4654] = {.lex_state = 239},
  [4655] = {.lex_state = 239},
  [4656] = {.lex_state = 272},
  [4657] = {.lex_state = 289},
  [4658] = {.lex_state = 239},
  [4659] = {.lex_state = 272},
  [4660] = {.lex_state = 239},
  [4661] = {.lex_state = 239},
  [4662] = {.lex_state = 289},
  [4663] = {.lex_state = 239},
  [4664] = {.lex_state = 289},
  [4665] = {.lex_state = 239},
  [4666] = {.lex_state = 239},
  [4667] = {.lex_state = 239},
  [4668] = {.lex_state = 239},
  [4669] = {.lex_state = 239},
  [4670] = {.lex_state = 239},
  [4671] = {.lex_state = 239},
  [4672] = {.lex_state = 272},
  [4673] = {.lex_state = 239},
  [4674] = {.lex_state = 272},
  [4675] = {.lex_state = 271},
  [4676] = {.lex_state = 289},
  [4677] = {.lex_state = 239},
  [4678] = {.lex_state = 289},
  [4679] = {.lex_state = 239},
  [4680] = {.lex_state = 272},
  [4681] = {.lex_state = 239},
  [4682] = {.lex_state = 271},
  [4683] = {.lex_state = 271},
  [4684] = {.lex_state = 239},
  [4685] = {.lex_state = 271},
  [4686] = {.lex_state = 272},
  [4687] = {.lex_state = 239},
  [4688] = {.lex_state = 239},
  [4689] = {.lex_state = 239},
  [4690] = {.lex_state = 239},
  [4691] = {.lex_state = 239},
  [4692] = {.lex_state = 288},
  [4693] = {.lex_state = 239},
  [4694] = {.lex_state = 272},
  [4695] = {.lex_state = 289},
  [4696] = {.lex_state = 239},
  [4697] = {.lex_state = 271},
  [4698] = {.lex_state = 271},
  [4699] = {.lex_state = 271},
  [4700] = {.lex_state = 239},
  [4701] = {.lex_state = 272},
  [4702] = {.lex_state = 289},
  [4703] = {.lex_state = 239},
  [4704] = {.lex_state = 239},
  [4705] = {.lex_state = 239},
  [4706] = {.lex_state = 239},
  [4707] = {.lex_state = 239},
  [4708] = {.lex_state = 272},
  [4709] = {.lex_state = 239},
  [4710] = {.lex_state = 239},
  [4711] = {.lex_state = 289},
  [4712] = {.lex_state = 239},
  [4713] = {.lex_state = 239},
  [4714] = {.lex_state = 239},
  [4715] = {.lex_state = 239},
  [4716] = {.lex_state = 239},
  [4717] = {.lex_state = 239},
  [4718] = {.lex_state = 289},
  [4719] = {.lex_state = 286},
  [4720] = {.lex_state = 239},
  [4721] = {.lex_state = 289},
  [4722] = {.lex_state = 239},
  [4723] = {.lex_state = 239},
  [4724] = {.lex_state = 239},
  [4725] = {.lex_state = 239},
  [4726] = {.lex_state = 272},
  [4727] = {.lex_state = 239},
  [4728] = {.lex_state = 271},
  [4729] = {.lex_state = 239},
  [4730] = {.lex_state = 239},
  [4731] = {.lex_state = 289},
  [4732] = {.lex_state = 239},
  [4733] = {.lex_state = 239},
  [4734] = {.lex_state = 289},
  [4735] = {.lex_state = 241},
  [4736] = {.lex_state = 239},
  [4737] = {.lex_state = 239},
  [4738] = {.lex_state = 239},
  [4739] = {.lex_state = 239},
  [4740] = {.lex_state = 272},
  [4741] = {.lex_state = 272},
  [4742] = {.lex_state = 241},
  [4743] = {.lex_state = 239},
  [4744] = {.lex_state = 289},
  [4745] = {.lex_state = 267},
  [4746] = {.lex_state = 271},
  [4747] = {.lex_state = 272},
  [4748] = {.lex_state = 239},
  [4749] = {.lex_state = 239},
  [4750] = {.lex_state = 285},
  [4751] = {.lex_state = 271},
  [4752] = {.lex_state = 271},
  [4753] = {.lex_state = 239},
  [4754] = {.lex_state = 239},
  [4755] = {.lex_state = 271},
  [4756] = {.lex_state = 271},
  [4757] = {.lex_state = 271},
  [4758] = {.lex_state = 271},
  [4759] = {.lex_state = 271},
  [4760] = {.lex_state = 241},
  [4761] = {.lex_state = 271},
  [4762] = {.lex_state = 289},
  [4763] = {.lex_state = 271},
  [4764] = {.lex_state = 289},
  [4765] = {.lex_state = 271},
  [4766] = {.lex_state = 271},
  [4767] = {.lex_state = 271},
  [4768] = {.lex_state = 239},
  [4769] = {.lex_state = 272},
  [4770] = {.lex_state = 272},
  [4771] = {.lex_state = 271},
  [4772] = {.lex_state = 289},
  [4773] = {.lex_state = 271},
  [4774] = {.lex_state = 271},
  [4775] = {.lex_state = 272},
  [4776] = {.lex_state = 271},
  [4777] = {.lex_state = 271},
  [4778] = {.lex_state = 289},
  [4779] = {.lex_state = 241},
  [4780] = {.lex_state = 272},
  [4781] = {.lex_state = 272},
  [4782] = {.lex_state = 267},
  [4783] = {.lex_state = 241},
  [4784] = {.lex_state = 241},
  [4785] = {.lex_state = 239},
  [4786] = {.lex_state = 271},
  [4787] = {.lex_state = 267},
  [4788] = {.lex_state = 241},
  [4789] = {.lex_state = 272},
  [4790] = {.lex_state = 239},
  [4791] = {.lex_state = 272},
  [4792] = {.lex_state = 272},
  [4793] = {.lex_state = 289},
  [4794] = {.lex_state = 289},
  [4795] = {.lex_state = 272},
  [4796] = {.lex_state = 272},
  [4797] = {.lex_state = 239},
  [4798] = {.lex_state = 289},
  [4799] = {.lex_state = 289},
  [4800] = {.lex_state = 239},
  [4801] = {.lex_state = 239},
  [4802] = {.lex_state = 272},
  [4803] = {.lex_state = 289},
  [4804] = {.lex_state = 272},
  [4805] = {.lex_state = 271},
  [4806] = {.lex_state = 271},
  [4807] = {.lex_state = 271},
  [4808] = {.lex_state = 289},
  [4809] = {.lex_state = 289},
  [4810] = {.lex_state = 289},
  [4811] = {.lex_state = 271},
  [4812] = {.lex_state = 271},
  [4813] = {.lex_state = 271},
  [4814] = {.lex_state = 241},
  [4815] = {.lex_state = 267},
  [4816] = {.lex_state = 271},
  [4817] = {.lex_state = 271},
  [4818] = {.lex_state = 239},
  [4819] = {.lex_state = 239},
  [4820] = {.lex_state = 289},
  [4821] = {.lex_state = 272},
  [4822] = {.lex_state = 271},
  [4823] = {.lex_state = 239},
  [4824] = {.lex_state = 239},
  [4825] = {.lex_state = 239},
  [4826] = {.lex_state = 272},
  [4827] = {.lex_state = 239},
  [4828] = {.lex_state = 241},
  [4829] = {.lex_state = 289},
  [4830] = {.lex_state = 241},
  [4831] = {.lex_state = 272},
  [4832] = {.lex_state = 271},
  [4833] = {.lex_state = 271},
  [4834] = {.lex_state = 271},
  [4835] = {.lex_state = 239},
  [4836] = {.lex_state = 271},
  [4837] = {.lex_state = 271},
  [4838] = {.lex_state = 239},
  [4839] = {.lex_state = 239},
  [4840] = {.lex_state = 239},
  [4841] = {.lex_state = 272},
  [4842] = {.lex_state = 272},
  [4843] = {.lex_state = 271},
  [4844] = {.lex_state = 271},
  [4845] = {.lex_state = 239},
  [4846] = {.lex_state = 272},
  [4847] = {.lex_state = 271},
  [4848] = {.lex_state = 271},
  [4849] = {.lex_state = 239},
  [4850] = {.lex_state = 271},
  [4851] = {.lex_state = 272},
  [4852] = {.lex_state = 271},
  [4853] = {.lex_state = 272},
  [4854] = {.lex_state = 239},
  [4855] = {.lex_state = 239},
  [4856] = {.lex_state = 241},
  [4857] = {.lex_state = 239},
  [4858] = {.lex_state = 271},
  [4859] = {.lex_state = 239},
  [4860] = {.lex_state = 239},
  [4861] = {.lex_state = 271},
  [4862] = {.lex_state = 271},
  [4863] = {.lex_state = 289},
  [4864] = {.lex_state = 239},
  [4865] = {.lex_state = 267},
  [4866] = {.lex_state = 241},
  [4867] = {.lex_state = 241},
  [4868] = {.lex_state = 239},
  [4869] = {.lex_state = 271},
  [4870] = {.lex_state = 271},
  [4871] = {.lex_state = 239},
  [4872] = {.lex_state = 271},
  [4873] = {.lex_state = 271},
  [4874] = {.lex_state = 288},
  [4875] = {.lex_state = 271},
  [4876] = {.lex_state = 271},
  [4877] = {.lex_state = 271},
  [4878] = {.lex_state = 289},
  [4879] = {.lex_state = 239},
  [4880] = {.lex_state = 239},
  [4881] = {.lex_state = 239},
  [4882] = {.lex_state = 241},
  [4883] = {.lex_state = 271},
  [4884] = {.lex_state = 271},
  [4885] = {.lex_state = 272},
  [4886] = {.lex_state = 241},
  [4887] = {.lex_state = 241},
  [4888] = {.lex_state = 241},
  [4889] = {.lex_state = 272},
  [4890] = {.lex_state = 241},
  [4891] = {.lex_state = 239},
  [4892] = {.lex_state = 272},
  [4893] = {.lex_state = 289},
  [4894] = {.lex_state = 289},
  [4895] = {.lex_state = 289},
  [4896] = {.lex_state = 289},
  [4897] = {.lex_state = 289},
  [4898] = {.lex_state = 272},
  [4899] = {.lex_state = 241},
  [4900] = {.lex_state = 241},
  [4901] = {.lex_state = 289},
  [4902] = {.lex_state = 289},
  [4903] = {.lex_state = 289},
  [4904] = {.lex_state = 241},
  [4905] = {.lex_state = 239},
  [4906] = {.lex_state = 239},
  [4907] = {.lex_state = 272},
  [4908] = {.lex_state = 272},
  [4909] = {.lex_state = 239},
  [4910] = {.lex_state = 241},
  [4911] = {.lex_state = 271},
  [4912] = {.lex_state = 241},
  [4913] = {.lex_state = 239},
  [4914] = {.lex_state = 272},
  [4915] = {.lex_state = 272},
  [4916] = {.lex_state = 239},
  [4917] = {.lex_state = 239},
  [4918] = {.lex_state = 239},
  [4919] = {.lex_state = 272},
  [4920] = {.lex_state = 289},
  [4921] = {.lex_state = 272},
  [4922] = {.lex_state = 272},
  [4923] = {.lex_state = 271},
  [4924] = {.lex_state = 239},
  [4925] = {.lex_state = 241},
  [4926] = {.lex_state = 241},
  [4927] = {.lex_state = 267},
  [4928] = {.lex_state = 239},
  [4929] = {.lex_state = 241},
  [4930] = {.lex_state = 241},
  [4931] = {.lex_state = 288},
  [4932] = {.lex_state = 289},
  [4933] = {.lex_state = 241},
  [4934] = {.lex_state = 239},
  [4935] = {.lex_state = 289},
  [4936] = {.lex_state = 272},
  [4937] = {.lex_state = 241},
  [4938] = {.lex_state = 241},
  [4939] = {.lex_state = 272},
  [4940] = {.lex_state = 239},
  [4941] = {.lex_state = 241},
  [4942] = {.lex_state = 272},
  [4943] = {.lex_state = 241},
  [4944] = {.lex_state = 239},
  [4945] = {.lex_state = 241},
  [4946] = {.lex_state = 241},
  [4947] = {.lex_state = 272},
  [4948] = {.lex_state = 241},
  [4949] = {.lex_state = 272},
  [4950] = {.lex_state = 241},
  [4951] = {.lex_state = 241},
  [4952] = {.lex_state = 241},
  [4953] = {.lex_state = 239},
  [4954] = {.lex_state = 239},
  [4955] = {.lex_state = 288},
  [4956] = {.lex_state = 239},
  [4957] = {.lex_state = 241},
  [4958] = {.lex_state = 241},
  [4959] = {.lex_state = 289},
  [4960] = {.lex_state = 272},
  [4961] = {.lex_state = 241},
  [4962] = {.lex_state = 271},
  [4963] = {.lex_state = 239},
  [4964] = {.lex_state = 271},
  [4965] = {.lex_state = 241},
  [4966] = {.lex_state = 239},
  [4967] = {.lex_state = 272},
  [4968] = {.lex_state = 289},
  [4969] = {.lex_state = 289},
  [4970] = {.lex_state = 288},
  [4971] = {.lex_state = 272},
  [4972] = {.lex_state = 289},
  [4973] = {.lex_state = 272},
  [4974] = {.lex_state = 289},
  [4975] = {.lex_state = 271},
  [4976] = {.lex_state = 271},
  [4977] = {.lex_state = 289},
  [4978] = {.lex_state = 239},
  [4979] = {.lex_state = 289},
  [4980] = {.lex_state = 289},
  [4981] = {.lex_state = 271},
  [4982] = {.lex_state = 239},
  [4983] = {.lex_state = 272},
  [4984] = {.lex_state = 271},
  [4985] = {.lex_state = 239},
  [4986] = {.lex_state = 272},
  [4987] = {.lex_state = 241},
  [4988] = {.lex_state = 272},
  [4989] = {.lex_state = 239},
  [4990] = {.lex_state = 239},
  [4991] = {.lex_state = 271},
  [4992] = {.lex_state = 271},
  [4993] = {.lex_state = 272},
  [4994] = {.lex_state = 241},
  [4995] = {.lex_state = 289},
  [4996] = {.lex_state = 241},
  [4997] = {.lex_state = 289},
  [4998] = {.lex_state = 272},
  [4999] = {.lex_state = 241},
  [5000] = {.lex_state = 239},
  [5001] = {.lex_state = 266},
  [5002] = {.lex_state = 272},
  [5003] = {.lex_state = 240},
  [5004] = {.lex_state = 239},
  [5005] = {.lex_state = 239},
  [5006] = {.lex_state = 239},
  [5007] = {.lex_state = 239},
  [5008] = {.lex_state = 288},
  [5009] = {.lex_state = 239},
  [5010] = {.lex_state = 242},
  [5011] = {.lex_state = 239},
  [5012] = {.lex_state = 242},
  [5013] = {.lex_state = 239},
  [5014] = {.lex_state = 239},
  [5015] = {.lex_state = 239},
  [5016] = {.lex_state = 239},
  [5017] = {.lex_state = 239},
  [5018] = {.lex_state = 239},
  [5019] = {.lex_state = 239},
  [5020] = {.lex_state = 239},
  [5021] = {.lex_state = 239},
  [5022] = {.lex_state = 288},
  [5023] = {.lex_state = 239},
  [5024] = {.lex_state = 239},
  [5025] = {.lex_state = 239},
  [5026] = {.lex_state = 239},
  [5027] = {.lex_state = 239},
  [5028] = {.lex_state = 288},
  [5029] = {.lex_state = 239},
  [5030] = {.lex_state = 288},
  [5031] = {.lex_state = 239},
  [5032] = {.lex_state = 239},
  [5033] = {.lex_state = 239},
  [5034] = {.lex_state = 239},
  [5035] = {.lex_state = 239},
  [5036] = {.lex_state = 288},
  [5037] = {.lex_state = 288},
  [5038] = {.lex_state = 239},
  [5039] = {.lex_state = 239},
  [5040] = {.lex_state = 239},
  [5041] = {.lex_state = 239},
  [5042] = {.lex_state = 288},
  [5043] = {.lex_state = 288},
  [5044] = {.lex_state = 239},
  [5045] = {.lex_state = 239},
  [5046] = {.lex_state = 239},
  [5047] = {.lex_state = 288},
  [5048] = {.lex_state = 241},
  [5049] = {.lex_state = 239},
  [5050] = {.lex_state = 239},
  [5051] = {.lex_state = 288},
  [5052] = {.lex_state = 239},
  [5053] = {.lex_state = 241},
  [5054] = {.lex_state = 239},
  [5055] = {.lex_state = 239},
  [5056] = {.lex_state = 239},
  [5057] = {.lex_state = 239},
  [5058] = {.lex_state = 239},
  [5059] = {.lex_state = 239},
  [5060] = {.lex_state = 239},
  [5061] = {.lex_state = 239},
  [5062] = {.lex_state = 239},
  [5063] = {.lex_state = 288},
  [5064] = {.lex_state = 239},
  [5065] = {.lex_state = 286},
  [5066] = {.lex_state = 239},
  [5067] = {.lex_state = 239},
  [5068] = {.lex_state = 239},
  [5069] = {.lex_state = 239},
  [5070] = {.lex_state = 288},
  [5071] = {.lex_state = 288},
  [5072] = {.lex_state = 239},
  [5073] = {.lex_state = 239},
  [5074] = {.lex_state = 240},
  [5075] = {.lex_state = 239},
  [5076] = {.lex_state = 288},
  [5077] = {.lex_state = 239},
  [5078] = {.lex_state = 239},
  [5079] = {.lex_state = 239},
  [5080] = {.lex_state = 239},
  [5081] = {.lex_state = 288},
  [5082] = {.lex_state = 239},
  [5083] = {.lex_state = 271},
  [5084] = {.lex_state = 239},
  [5085] = {.lex_state = 241},
  [5086] = {.lex_state = 239},
  [5087] = {.lex_state = 239},
  [5088] = {.lex_state = 239},
  [5089] = {.lex_state = 239},
  [5090] = {.lex_state = 239},
  [5091] = {.lex_state = 267},
  [5092] = {.lex_state = 239},
  [5093] = {.lex_state = 239},
  [5094] = {.lex_state = 239},
  [5095] = {.lex_state = 239},
  [5096] = {.lex_state = 239},
  [5097] = {.lex_state = 239},
  [5098] = {.lex_state = 288},
  [5099] = {.lex_state = 239},
  [5100] = {.lex_state = 239},
  [5101] = {.lex_state = 239},
  [5102] = {.lex_state = 288},
  [5103] = {.lex_state = 239},
  [5104] = {.lex_state = 239},
  [5105] = {.lex_state = 239},
  [5106] = {.lex_state = 288},
  [5107] = {.lex_state = 239},
  [5108] = {.lex_state = 239},
  [5109] = {.lex_state = 239},
  [5110] = {.lex_state = 239},
  [5111] = {.lex_state = 239},
  [5112] = {.lex_state = 239},
  [5113] = {.lex_state = 239},
  [5114] = {.lex_state = 239},
  [5115] = {.lex_state = 239},
  [5116] = {.lex_state = 239},
  [5117] = {.lex_state = 239},
  [5118] = {.lex_state = 241},
  [5119] = {.lex_state = 239},
  [5120] = {.lex_state = 239},
  [5121] = {.lex_state = 239},
  [5122] = {.lex_state = 239},
  [5123] = {.lex_state = 239},
  [5124] = {.lex_state = 239},
  [5125] = {.lex_state = 239},
  [5126] = {.lex_state = 239},
  [5127] = {.lex_state = 239},
  [5128] = {.lex_state = 239},
  [5129] = {.lex_state = 239},
  [5130] = {.lex_state = 239},
  [5131] = {.lex_state = 239},
  [5132] = {.lex_state = 239},
  [5133] = {.lex_state = 239},
  [5134] = {.lex_state = 239},
  [5135] = {.lex_state = 241},
  [5136] = {.lex_state = 271},
  [5137] = {.lex_state = 239},
  [5138] = {.lex_state = 288},
  [5139] = {.lex_state = 239},
  [5140] = {.lex_state = 241},
  [5141] = {.lex_state = 270},
  [5142] = {.lex_state = 239},
  [5143] = {.lex_state = 239},
  [5144] = {.lex_state = 272},
  [5145] = {.lex_state = 242},
  [5146] = {.lex_state = 272},
  [5147] = {.lex_state = 239},
  [5148] = {.lex_state = 239},
  [5149] = {.lex_state = 239},
  [5150] = {.lex_state = 288},
  [5151] = {.lex_state = 288},
  [5152] = {.lex_state = 272},
  [5153] = {.lex_state = 288},
  [5154] = {.lex_state = 288},
  [5155] = {.lex_state = 288},
  [5156] = {.lex_state = 278},
  [5157] = {.lex_state = 288},
  [5158] = {.lex_state = 288},
  [5159] = {.lex_state = 288},
  [5160] = {.lex_state = 275},
  [5161] = {.lex_state = 271},
  [5162] = {.lex_state = 278},
  [5163] = {.lex_state = 275},
  [5164] = {.lex_state = 278},
  [5165] = {.lex_state = 239},
  [5166] = {.lex_state = 288},
  [5167] = {.lex_state = 288},
  [5168] = {.lex_state = 275},
  [5169] = {.lex_state = 239},
  [5170] = {.lex_state = 271},
  [5171] = {.lex_state = 272},
  [5172] = {.lex_state = 272},
  [5173] = {.lex_state = 288},
  [5174] = {.lex_state = 272},
  [5175] = {.lex_state = 286},
  [5176] = {.lex_state = 271},
  [5177] = {.lex_state = 271},
  [5178] = {.lex_state = 272},
  [5179] = {.lex_state = 271},
  [5180] = {.lex_state = 272},
  [5181] = {.lex_state = 288},
  [5182] = {.lex_state = 288},
  [5183] = {.lex_state = 288},
  [5184] = {.lex_state = 271},
  [5185] = {.lex_state = 271},
  [5186] = {.lex_state = 286},
  [5187] = {.lex_state = 288},
  [5188] = {.lex_state = 271},
  [5189] = {.lex_state = 272},
  [5190] = {.lex_state = 271},
  [5191] = {.lex_state = 271},
  [5192] = {.lex_state = 241},
  [5193] = {.lex_state = 271},
  [5194] = {.lex_state = 271},
  [5195] = {.lex_state = 288},
  [5196] = {.lex_state = 288},
  [5197] = {.lex_state = 288},
  [5198] = {.lex_state = 271},
  [5199] = {.lex_state = 288},
  [5200] = {.lex_state = 239},
  [5201] = {.lex_state = 239},
  [5202] = {.lex_state = 241},
  [5203] = {.lex_state = 239},
  [5204] = {.lex_state = 239},
  [5205] = {.lex_state = 272},
  [5206] = {.lex_state = 272},
  [5207] = {.lex_state = 271},
  [5208] = {.lex_state = 288},
  [5209] = {.lex_state = 271},
  [5210] = {.lex_state = 272},
  [5211] = {.lex_state = 286},
  [5212] = {.lex_state = 271},
  [5213] = {.lex_state = 288},
  [5214] = {.lex_state = 272},
  [5215] = {.lex_state = 272},
  [5216] = {.lex_state = 271},
  [5217] = {.lex_state = 271},
  [5218] = {.lex_state = 272},
  [5219] = {.lex_state = 272},
  [5220] = {.lex_state = 272},
  [5221] = {.lex_state = 271},
  [5222] = {.lex_state = 288},
  [5223] = {.lex_state = 271},
  [5224] = {.lex_state = 272},
  [5225] = {.lex_state = 271},
  [5226] = {.lex_state = 271},
  [5227] = {.lex_state = 271},
  [5228] = {.lex_state = 271},
  [5229] = {.lex_state = 272},
  [5230] = {.lex_state = 239},
  [5231] = {.lex_state = 288},
  [5232] = {.lex_state = 272},
  [5233] = {.lex_state = 272},
  [5234] = {.lex_state = 289},
  [5235] = {.lex_state = 271},
  [5236] = {.lex_state = 272},
  [5237] = {.lex_state = 272},
  [5238] = {.lex_state = 271},
  [5239] = {.lex_state = 288},
  [5240] = {.lex_state = 288},
  [5241] = {.lex_state = 241},
  [5242] = {.lex_state = 288},
  [5243] = {.lex_state = 288},
  [5244] = {.lex_state = 271},
  [5245] = {.lex_state = 271},
  [5246] = {.lex_state = 272},
  [5247] = {.lex_state = 272},
  [5248] = {.lex_state = 271},
  [5249] = {.lex_state = 272},
  [5250] = {.lex_state = 267},
  [5251] = {.lex_state = 271},
  [5252] = {.lex_state = 271},
  [5253] = {.lex_state = 271},
  [5254] = {.lex_state = 271},
  [5255] = {.lex_state = 271},
  [5256] = {.lex_state = 288},
  [5257] = {.lex_state = 271},
  [5258] = {.lex_state = 239},
  [5259] = {.lex_state = 272},
  [5260] = {.lex_state = 271},
  [5261] = {.lex_state = 272},
  [5262] = {.lex_state = 288},
  [5263] = {.lex_state = 289},
  [5264] = {.lex_state = 286},
  [5265] = {.lex_state = 288},
  [5266] = {.lex_state = 239},
  [5267] = {.lex_state = 288},
  [5268] = {.lex_state = 271},
  [5269] = {.lex_state = 271},
  [5270] = {.lex_state = 272},
  [5271] = {.lex_state = 272},
  [5272] = {.lex_state = 271},
  [5273] = {.lex_state = 271},
  [5274] = {.lex_state = 241},
  [5275] = {.lex_state = 288},
  [5276] = {.lex_state = 271},
  [5277] = {.lex_state = 288},
  [5278] = {.lex_state = 272},
  [5279] = {.lex_state = 272},
  [5280] = {.lex_state = 271},
  [5281] = {.lex_state = 286},
  [5282] = {.lex_state = 288},
  [5283] = {.lex_state = 271},
  [5284] = {.lex_state = 271},
  [5285] = {.lex_state = 271},
  [5286] = {.lex_state = 271},
  [5287] = {.lex_state = 271},
  [5288] = {.lex_state = 288},
  [5289] = {.lex_state = 271},
  [5290] = {.lex_state = 271},
  [5291] = {.lex_state = 288},
  [5292] = {.lex_state = 288},
  [5293] = {.lex_state = 271},
  [5294] = {.lex_state = 271},
  [5295] = {.lex_state = 272},
  [5296] = {.lex_state = 272},
  [5297] = {.lex_state = 288},
  [5298] = {.lex_state = 288},
  [5299] = {.lex_state = 242},
  [5300] = {.lex_state = 241},
  [5301] = {.lex_state = 271},
  [5302] = {.lex_state = 271},
  [5303] = {.lex_state = 288},
  [5304] = {.lex_state = 271},
  [5305] = {.lex_state = 271},
  [5306] = {.lex_state = 272},
  [5307] = {.lex_state = 271},
  [5308] = {.lex_state = 288},
  [5309] = {.lex_state = 272},
  [5310] = {.lex_state = 288},
  [5311] = {.lex_state = 272},
  [5312] = {.lex_state = 271},
  [5313] = {.lex_state = 272},
  [5314] = {.lex_state = 272},
  [5315] = {.lex_state = 272},
  [5316] = {.lex_state = 272},
  [5317] = {.lex_state = 288},
  [5318] = {.lex_state = 272},
  [5319] = {.lex_state = 271},
  [5320] = {.lex_state = 239},
  [5321] = {.lex_state = 271},
  [5322] = {.lex_state = 271},
  [5323] = {.lex_state = 272},
  [5324] = {.lex_state = 272},
  [5325] = {.lex_state = 272},
  [5326] = {.lex_state = 285},
  [5327] = {.lex_state = 286},
  [5328] = {.lex_state = 286},
  [5329] = {.lex_state = 239},
  [5330] = {.lex_state = 286},
  [5331] = {.lex_state = 286},
  [5332] = {.lex_state = 286},
  [5333] = {.lex_state = 285},
  [5334] = {.lex_state = 286},
  [5335] = {.lex_state = 239},
  [5336] = {.lex_state = 239},
  [5337] = {.lex_state = 239},
  [5338] = {.lex_state = 239},
  [5339] = {.lex_state = 239},
  [5340] = {.lex_state = 239},
  [5341] = {.lex_state = 239},
  [5342] = {.lex_state = 286},
  [5343] = {.lex_state = 286},
  [5344] = {.lex_state = 239},
  [5345] = {.lex_state = 239},
  [5346] = {.lex_state = 286},
  [5347] = {.lex_state = 239},
  [5348] = {.lex_state = 286},
  [5349] = {.lex_state = 286},
  [5350] = {.lex_state = 286},
  [5351] = {.lex_state = 289},
  [5352] = {.lex_state = 286},
  [5353] = {.lex_state = 286},
  [5354] = {.lex_state = 286},
  [5355] = {.lex_state = 286},
  [5356] = {.lex_state = 286},
  [5357] = {.lex_state = 286},
  [5358] = {.lex_state = 289},
  [5359] = {.lex_state = 286},
  [5360] = {.lex_state = 286},
  [5361] = {.lex_state = 286},
  [5362] = {.lex_state = 286},
  [5363] = {.lex_state = 289},
  [5364] = {.lex_state = 285},
  [5365] = {.lex_state = 285},
  [5366] = {.lex_state = 289},
  [5367] = {.lex_state = 286},
  [5368] = {.lex_state = 241},
  [5369] = {.lex_state = 241},
  [5370] = {.lex_state = 285},
  [5371] = {.lex_state = 289},
  [5372] = {.lex_state = 286},
  [5373] = {.lex_state = 285},
  [5374] = {.lex_state = 286},
  [5375] = {.lex_state = 285},
  [5376] = {.lex_state = 289},
  [5377] = {.lex_state = 267},
  [5378] = {.lex_state = 267},
  [5379] = {.lex_state = 267},
  [5380] = {.lex_state = 285},
  [5381] = {.lex_state = 285},
  [5382] = {.lex_state = 285},
  [5383] = {.lex_state = 267},
  [5384] = {.lex_state = 285},
  [5385] = {.lex_state = 288},
  [5386] = {.lex_state = 289},
  [5387] = {.lex_state = 286},
  [5388] = {.lex_state = 286},
  [5389] = {.lex_state = 241},
  [5390] = {.lex_state = 286},
  [5391] = {.lex_state = 286},
  [5392] = {.lex_state = 289},
  [5393] = {.lex_state = 286},
  [5394] = {.lex_state = 285},
  [5395] = {.lex_state = 286},
  [5396] = {.lex_state = 286},
  [5397] = {.lex_state = 288},
  [5398] = {.lex_state = 285},
  [5399] = {.lex_state = 286},
  [5400] = {.lex_state = 289},
  [5401] = {.lex_state = 286},
  [5402] = {.lex_state = 286},
  [5403] = {.lex_state = 286},
  [5404] = {.lex_state = 286},
  [5405] = {.lex_state = 286},
  [5406] = {.lex_state = 286},
  [5407] = {.lex_state = 286},
  [5408] = {.lex_state = 286},
  [5409] = {.lex_state = 286},
  [5410] = {.lex_state = 286},
  [5411] = {.lex_state = 286},
  [5412] = {.lex_state = 289},
  [5413] = {.lex_state = 286},
  [5414] = {.lex_state = 286},
  [5415] = {.lex_state = 286},
  [5416] = {.lex_state = 289},
  [5417] = {.lex_state = 289},
  [5418] = {.lex_state = 289},
  [5419] = {.lex_state = 285},
  [5420] = {.lex_state = 285},
  [5421] = {.lex_state = 289},
  [5422] = {.lex_state = 285},
  [5423] = {.lex_state = 285},
  [5424] = {.lex_state = 289},
  [5425] = {.lex_state = 289},
  [5426] = {.lex_state = 285},
  [5427] = {.lex_state = 285},
  [5428] = {.lex_state = 285},
  [5429] = {.lex_state = 289},
  [5430] = {.lex_state = 289},
  [5431] = {.lex_state = 285},
  [5432] = {.lex_state = 231},
  [5433] = {.lex_state = 231},
  [5434] = {.lex_state = 231},
  [5435] = {.lex_state = 231},
  [5436] = {.lex_state = 286},
  [5437] = {.lex_state = 286},
  [5438] = {.lex_state = 231},
  [5439] = {.lex_state = 231},
  [5440] = {.lex_state = 231},
  [5441] = {.lex_state = 231},
  [5442] = {.lex_state = 239},
  [5443] = {.lex_state = 286},
  [5444] = {.lex_state = 286},
  [5445] = {.lex_state = 289},
  [5446] = {.lex_state = 239},
  [5447] = {.lex_state = 286},
  [5448] = {.lex_state = 286},
  [5449] = {.lex_state = 239},
  [5450] = {.lex_state = 231},
  [5451] = {.lex_state = 286},
  [5452] = {.lex_state = 286},
  [5453] = {.lex_state = 231},
  [5454] = {.lex_state = 231},
  [5455] = {.lex_state = 286},
  [5456] = {.lex_state = 286},
  [5457] = {.lex_state = 286},
  [5458] = {.lex_state = 231},
  [5459] = {.lex_state = 231},
  [5460] = {.lex_state = 231},
  [5461] = {.lex_state = 231},
  [5462] = {.lex_state = 231},
  [5463] = {.lex_state = 231},
  [5464] = {.lex_state = 231},
  [5465] = {.lex_state = 231},
  [5466] = {.lex_state = 286},
  [5467] = {.lex_state = 231},
  [5468] = {.lex_state = 231},
  [5469] = {.lex_state = 231},
  [5470] = {.lex_state = 286},
  [5471] = {.lex_state = 286},
  [5472] = {.lex_state = 286},
  [5473] = {.lex_state = 231},
  [5474] = {.lex_state = 286},
  [5475] = {.lex_state = 286},
  [5476] = {.lex_state = 286},
  [5477] = {.lex_state = 231},
  [5478] = {.lex_state = 239},
  [5479] = {.lex_state = 231},
  [5480] = {.lex_state = 231},
  [5481] = {.lex_state = 231},
  [5482] = {.lex_state = 231},
  [5483] = {.lex_state = 231},
  [5484] = {.lex_state = 286},
  [5485] = {.lex_state = 286},
  [5486] = {.lex_state = 286},
  [5487] = {.lex_state = 286},
  [5488] = {.lex_state = 231},
  [5489] = {.lex_state = 286},
  [5490] = {.lex_state = 289},
  [5491] = {.lex_state = 286},
  [5492] = {.lex_state = 231},
  [5493] = {.lex_state = 286},
  [5494] = {.lex_state = 289},
  [5495] = {.lex_state = 231},
  [5496] = {.lex_state = 231},
  [5497] = {.lex_state = 286},
  [5498] = {.lex_state = 231},
  [5499] = {.lex_state = 231},
  [5500] = {.lex_state = 231},
  [5501] = {.lex_state = 231},
  [5502] = {.lex_state = 231},
  [5503] = {.lex_state = 231},
  [5504] = {.lex_state = 231},
  [5505] = {.lex_state = 239},
  [5506] = {.lex_state = 231},
  [5507] = {.lex_state = 231},
  [5508] = {.lex_state = 231},
  [5509] = {.lex_state = 231},
  [5510] = {.lex_state = 231},
  [5511] = {.lex_state = 231},
  [5512] = {.lex_state = 286},
  [5513] = {.lex_state = 231},
  [5514] = {.lex_state = 286},
  [5515] = {.lex_state = 286},
  [5516] = {.lex_state = 231},
  [5517] = {.lex_state = 286},
  [5518] = {.lex_state = 286},
  [5519] = {.lex_state = 286},
  [5520] = {.lex_state = 289},
  [5521] = {.lex_state = 231},
  [5522] = {.lex_state = 231},
  [5523] = {.lex_state = 286},
  [5524] = {.lex_state = 231},
  [5525] = {.lex_state = 231},
  [5526] = {.lex_state = 286},
  [5527] = {.lex_state = 286},
  [5528] = {.lex_state = 286},
  [5529] = {.lex_state = 231},
  [5530] = {.lex_state = 231},
  [5531] = {.lex_state = 239},
  [5532] = {.lex_state = 231},
  [5533] = {.lex_state = 231},
  [5534] = {.lex_state = 231},
  [5535] = {.lex_state = 231},
  [5536] = {.lex_state = 231},
  [5537] = {.lex_state = 231},
  [5538] = {.lex_state = 231},
  [5539] = {.lex_state = 286},
  [5540] = {.lex_state = 231},
  [5541] = {.lex_state = 231},
  [5542] = {.lex_state = 231},
  [5543] = {.lex_state = 231},
  [5544] = {.lex_state = 231},
  [5545] = {.lex_state = 231},
  [5546] = {.lex_state = 286},
  [5547] = {.lex_state = 286},
  [5548] = {.lex_state = 286},
  [5549] = {.lex_state = 231},
  [5550] = {.lex_state = 231},
  [5551] = {.lex_state = 231},
  [5552] = {.lex_state = 231},
  [5553] = {.lex_state = 286},
  [5554] = {.lex_state = 286},
  [5555] = {.lex_state = 231},
  [5556] = {.lex_state = 231},
  [5557] = {.lex_state = 286},
  [5558] = {.lex_state = 231},
  [5559] = {.lex_state = 239},
  [5560] = {.lex_state = 286},
  [5561] = {.lex_state = 231},
  [5562] = {.lex_state = 231},
  [5563] = {.lex_state = 231},
  [5564] = {.lex_state = 239},
  [5565] = {.lex_state = 231},
  [5566] = {.lex_state = 231},
  [5567] = {.lex_state = 286},
  [5568] = {.lex_state = 231},
  [5569] = {.lex_state = 231},
  [5570] = {.lex_state = 231},
  [5571] = {.lex_state = 231},
  [5572] = {.lex_state = 231},
  [5573] = {.lex_state = 231},
  [5574] = {.lex_state = 231},
  [5575] = {.lex_state = 231},
  [5576] = {.lex_state = 231},
  [5577] = {.lex_state = 231},
  [5578] = {.lex_state = 239},
  [5579] = {.lex_state = 231},
  [5580] = {.lex_state = 239},
  [5581] = {.lex_state = 239},
  [5582] = {.lex_state = 231},
  [5583] = {.lex_state = 239},
  [5584] = {.lex_state = 241},
  [5585] = {.lex_state = 231},
  [5586] = {.lex_state = 231},
  [5587] = {.lex_state = 239},
  [5588] = {.lex_state = 285},
  [5589] = {.lex_state = 239},
  [5590] = {.lex_state = 239},
  [5591] = {.lex_state = 231},
  [5592] = {.lex_state = 239},
  [5593] = {.lex_state = 239},
  [5594] = {.lex_state = 231},
  [5595] = {.lex_state = 239},
  [5596] = {.lex_state = 231},
  [5597] = {.lex_state = 239},
  [5598] = {.lex_state = 239},
  [5599] = {.lex_state = 241},
  [5600] = {.lex_state = 239},
  [5601] = {.lex_state = 231},
  [5602] = {.lex_state = 239},
  [5603] = {.lex_state = 239},
  [5604] = {.lex_state = 231},
  [5605] = {.lex_state = 285},
  [5606] = {.lex_state = 231},
  [5607] = {.lex_state = 231},
  [5608] = {.lex_state = 285},
  [5609] = {.lex_state = 285},
  [5610] = {.lex_state = 239},
  [5611] = {.lex_state = 231},
  [5612] = {.lex_state = 239},
  [5613] = {.lex_state = 239},
  [5614] = {.lex_state = 231},
  [5615] = {.lex_state = 231},
  [5616] = {.lex_state = 231},
  [5617] = {.lex_state = 239},
  [5618] = {.lex_state = 239},
  [5619] = {.lex_state = 239},
  [5620] = {.lex_state = 231},
  [5621] = {.lex_state = 231},
  [5622] = {.lex_state = 231},
  [5623] = {.lex_state = 231},
  [5624] = {.lex_state = 239},
  [5625] = {.lex_state = 239},
  [5626] = {.lex_state = 239},
  [5627] = {.lex_state = 239},
  [5628] = {.lex_state = 231},
  [5629] = {.lex_state = 239},
  [5630] = {.lex_state = 239},
  [5631] = {.lex_state = 285},
  [5632] = {.lex_state = 285},
  [5633] = {.lex_state = 285},
  [5634] = {.lex_state = 285},
  [5635] = {.lex_state = 285},
  [5636] = {.lex_state = 285},
  [5637] = {.lex_state = 285},
  [5638] = {.lex_state = 233},
  [5639] = {.lex_state = 289},
  [5640] = {.lex_state = 289},
  [5641] = {.lex_state = 233},
  [5642] = {.lex_state = 233},
  [5643] = {.lex_state = 233},
  [5644] = {.lex_state = 233},
  [5645] = {.lex_state = 233},
  [5646] = {.lex_state = 289},
  [5647] = {.lex_state = 289},
  [5648] = {.lex_state = 289},
  [5649] = {.lex_state = 233},
  [5650] = {.lex_state = 233},
  [5651] = {.lex_state = 289},
  [5652] = {.lex_state = 289},
  [5653] = {.lex_state = 286},
  [5654] = {.lex_state = 285},
  [5655] = {.lex_state = 289},
  [5656] = {.lex_state = 285},
  [5657] = {.lex_state = 289},
  [5658] = {.lex_state = 286},
  [5659] = {.lex_state = 289},
  [5660] = {.lex_state = 289},
  [5661] = {.lex_state = 285},
  [5662] = {.lex_state = 286},
  [5663] = {.lex_state = 285},
  [5664] = {.lex_state = 285},
  [5665] = {.lex_state = 289},
  [5666] = {.lex_state = 285},
  [5667] = {.lex_state = 285},
  [5668] = {.lex_state = 285},
  [5669] = {.lex_state = 289},
  [5670] = {.lex_state = 289},
  [5671] = {.lex_state = 285},
  [5672] = {.lex_state = 289},
  [5673] = {.lex_state = 289},
  [5674] = {.lex_state = 286},
  [5675] = {.lex_state = 286},
  [5676] = {.lex_state = 289},
  [5677] = {.lex_state = 285},
  [5678] = {.lex_state = 285},
  [5679] = {.lex_state = 285},
  [5680] = {.lex_state = 289},
  [5681] = {.lex_state = 297},
  [5682] = {.lex_state = 231},
  [5683] = {.lex_state = 231},
  [5684] = {.lex_state = 231},
  [5685] = {.lex_state = 231},
  [5686] = {.lex_state = 231},
  [5687] = {.lex_state = 297},
  [5688] = {.lex_state = 231},
  [5689] = {.lex_state = 231},
  [5690] = {.lex_state = 231},
  [5691] = {.lex_state = 297},
  [5692] = {.lex_state = 231},
  [5693] = {.lex_state = 297},
  [5694] = {.lex_state = 297},
  [5695] = {.lex_state = 297},
  [5696] = {.lex_state = 297},
  [5697] = {.lex_state = 231},
  [5698] = {.lex_state = 297},
  [5699] = {.lex_state = 231},
  [5700] = {.lex_state = 297},
  [5701] = {.lex_state = 231},
  [5702] = {.lex_state = 285},
  [5703] = {.lex_state = 285},
  [5704] = {.lex_state = 285},
  [5705] = {.lex_state = 289},
  [5706] = {.lex_state = 289},
  [5707] = {.lex_state = 285},
  [5708] = {.lex_state = 285},
  [5709] = {.lex_state = 285},
  [5710] = {.lex_state = 267},
  [5711] = {.lex_state = 285},
  [5712] = {.lex_state = 289},
  [5713] = {.lex_state = 288},
  [5714] = {.lex_state = 289},
  [5715] = {.lex_state = 289},
  [5716] = {.lex_state = 233},
  [5717] = {.lex_state = 297},
  [5718] = {.lex_state = 230},
  [5719] = {.lex_state = 297},
  [5720] = {.lex_state = 297},
  [5721] = {.lex_state = 297},
  [5722] = {.lex_state = 297},
  [5723] = {.lex_state = 297},
  [5724] = {.lex_state = 233},
  [5725] = {.lex_state = 297},
  [5726] = {.lex_state = 285},
  [5727] = {.lex_state = 297},
  [5728] = {.lex_state = 297},
  [5729] = {.lex_state = 297},
  [5730] = {.lex_state = 297},
  [5731] = {.lex_state = 297},
  [5732] = {.lex_state = 297},
  [5733] = {.lex_state = 297},
  [5734] = {.lex_state = 297},
  [5735] = {.lex_state = 233},
  [5736] = {.lex_state = 297},
  [5737] = {.lex_state = 297},
  [5738] = {.lex_state = 297},
  [5739] = {.lex_state = 297},
  [5740] = {.lex_state = 297},
  [5741] = {.lex_state = 297},
  [5742] = {.lex_state = 233},
  [5743] = {.lex_state = 289},
  [5744] = {.lex_state = 267},
  [5745] = {.lex_state = 297},
  [5746] = {.lex_state = 297},
  [5747] = {.lex_state = 233},
  [5748] = {.lex_state = 297},
  [5749] = {.lex_state = 285},
  [5750] = {.lex_state = 285},
  [5751] = {.lex_state = 267},
  [5752] = {.lex_state = 233},
  [5753] = {.lex_state = 297},
  [5754] = {.lex_state = 297},
  [5755] = {.lex_state = 297},
  [5756] = {.lex_state = 297},
  [5757] = {.lex_state = 297},
  [5758] = {.lex_state = 297},
  [5759] = {.lex_state = 267},
  [5760] = {.lex_state = 297},
  [5761] = {.lex_state = 297},
  [5762] = {.lex_state = 233},
  [5763] = {.lex_state = 297},
  [5764] = {.lex_state = 297},
  [5765] = {.lex_state = 297},
  [5766] = {.lex_state = 233},
  [5767] = {.lex_state = 297},
  [5768] = {.lex_state = 297},
  [5769] = {.lex_state = 297},
  [5770] = {.lex_state = 233},
  [5771] = {.lex_state = 297},
  [5772] = {.lex_state = 297},
  [5773] = {.lex_state = 233},
  [5774] = {.lex_state = 297},
  [5775] = {.lex_state = 297},
  [5776] = {.lex_state = 233},
  [5777] = {.lex_state = 297},
  [5778] = {.lex_state = 297},
  [5779] = {.lex_state = 233},
  [5780] = {.lex_state = 297},
  [5781] = {.lex_state = 231},
  [5782] = {.lex_state = 267},
  [5783] = {.lex_state = 231},
  [5784] = {.lex_state = 231},
  [5785] = {.lex_state = 231},
  [5786] = {.lex_state = 231},
  [5787] = {.lex_state = 231},
  [5788] = {.lex_state = 231},
  [5789] = {.lex_state = 231},
  [5790] = {.lex_state = 208},
  [5791] = {.lex_state = 231},
  [5792] = {.lex_state = 208},
  [5793] = {.lex_state = 231},
  [5794] = {.lex_state = 231},
  [5795] = {.lex_state = 231},
  [5796] = {.lex_state = 231},
  [5797] = {.lex_state = 230},
  [5798] = {.lex_state = 231},
  [5799] = {.lex_state = 231},
  [5800] = {.lex_state = 230},
  [5801] = {.lex_state = 231},
  [5802] = {.lex_state = 231},
  [5803] = {.lex_state = 267},
  [5804] = {.lex_state = 231},
  [5805] = {.lex_state = 231},
  [5806] = {.lex_state = 231},
  [5807] = {.lex_state = 231},
  [5808] = {.lex_state = 231},
  [5809] = {.lex_state = 231},
  [5810] = {.lex_state = 231},
  [5811] = {.lex_state = 231},
  [5812] = {.lex_state = 231},
  [5813] = {.lex_state = 231},
  [5814] = {.lex_state = 231},
  [5815] = {.lex_state = 231},
  [5816] = {.lex_state = 231},
  [5817] = {.lex_state = 231},
  [5818] = {.lex_state = 231},
  [5819] = {.lex_state = 231},
  [5820] = {.lex_state = 231},
  [5821] = {.lex_state = 231},
  [5822] = {.lex_state = 231},
  [5823] = {.lex_state = 231},
  [5824] = {.lex_state = 231},
  [5825] = {.lex_state = 231},
  [5826] = {.lex_state = 231},
  [5827] = {.lex_state = 231},
  [5828] = {.lex_state = 231},
  [5829] = {.lex_state = 231},
  [5830] = {.lex_state = 231},
  [5831] = {.lex_state = 231},
  [5832] = {.lex_state = 289},
  [5833] = {.lex_state = 231},
  [5834] = {.lex_state = 231},
  [5835] = {.lex_state = 231},
  [5836] = {.lex_state = 231},
  [5837] = {.lex_state = 231},
  [5838] = {.lex_state = 231},
  [5839] = {.lex_state = 230},
  [5840] = {.lex_state = 231},
  [5841] = {.lex_state = 231},
  [5842] = {.lex_state = 231},
  [5843] = {.lex_state = 208},
  [5844] = {.lex_state = 101},
  [5845] = {.lex_state = 231},
  [5846] = {.lex_state = 231},
  [5847] = {.lex_state = 231},
  [5848] = {.lex_state = 231},
  [5849] = {.lex_state = 231},
  [5850] = {.lex_state = 231},
  [5851] = {.lex_state = 231},
  [5852] = {.lex_state = 231},
  [5853] = {.lex_state = 231},
  [5854] = {.lex_state = 231},
  [5855] = {.lex_state = 231},
  [5856] = {.lex_state = 231},
  [5857] = {.lex_state = 231},
  [5858] = {.lex_state = 231},
  [5859] = {.lex_state = 231},
  [5860] = {.lex_state = 231},
  [5861] = {.lex_state = 231},
  [5862] = {.lex_state = 231},
  [5863] = {.lex_state = 231},
  [5864] = {.lex_state = 231},
  [5865] = {.lex_state = 231},
  [5866] = {.lex_state = 231},
  [5867] = {.lex_state = 231},
  [5868] = {.lex_state = 231},
  [5869] = {.lex_state = 231},
  [5870] = {.lex_state = 231},
  [5871] = {.lex_state = 231},
  [5872] = {.lex_state = 231},
  [5873] = {.lex_state = 231},
  [5874] = {.lex_state = 231},
  [5875] = {.lex_state = 231},
  [5876] = {.lex_state = 231},
  [5877] = {.lex_state = 231},
  [5878] = {.lex_state = 231},
  [5879] = {.lex_state = 231},
  [5880] = {.lex_state = 231},
  [5881] = {.lex_state = 231},
  [5882] = {.lex_state = 231},
  [5883] = {.lex_state = 231},
  [5884] = {.lex_state = 231},
  [5885] = {.lex_state = 231},
  [5886] = {.lex_state = 231},
  [5887] = {.lex_state = 231},
  [5888] = {.lex_state = 231},
  [5889] = {.lex_state = 231},
  [5890] = {.lex_state = 231},
  [5891] = {.lex_state = 267},
  [5892] = {.lex_state = 285},
  [5893] = {.lex_state = 208},
  [5894] = {.lex_state = 267},
  [5895] = {.lex_state = 208},
  [5896] = {.lex_state = 267},
  [5897] = {.lex_state = 286},
  [5898] = {.lex_state = 208},
  [5899] = {.lex_state = 208},
  [5900] = {.lex_state = 286},
  [5901] = {.lex_state = 208},
  [5902] = {.lex_state = 230},
  [5903] = {.lex_state = 208},
  [5904] = {.lex_state = 208},
  [5905] = {.lex_state = 267},
  [5906] = {.lex_state = 286},
  [5907] = {.lex_state = 208},
  [5908] = {.lex_state = 208},
  [5909] = {.lex_state = 208},
  [5910] = {.lex_state = 267},
  [5911] = {.lex_state = 285},
  [5912] = {.lex_state = 208},
  [5913] = {.lex_state = 208},
  [5914] = {.lex_state = 267},
  [5915] = {.lex_state = 267},
  [5916] = {.lex_state = 208},
  [5917] = {.lex_state = 285},
  [5918] = {.lex_state = 208},
  [5919] = {.lex_state = 286},
  [5920] = {.lex_state = 286},
  [5921] = {.lex_state = 208},
  [5922] = {.lex_state = 286},
  [5923] = {.lex_state = 230},
  [5924] = {.lex_state = 208},
  [5925] = {.lex_state = 208},
  [5926] = {.lex_state = 208},
  [5927] = {.lex_state = 208},
  [5928] = {.lex_state = 230},
  [5929] = {.lex_state = 286},
  [5930] = {.lex_state = 286},
  [5931] = {.lex_state = 286},
  [5932] = {.lex_state = 239},
  [5933] = {.lex_state = 286},
  [5934] = {.lex_state = 267},
  [5935] = {.lex_state = 230},
  [5936] = {.lex_state = 267},
  [5937] = {.lex_state = 285},
  [5938] = {.lex_state = 289},
  [5939] = {.lex_state = 285},
  [5940] = {.lex_state = 286},
  [5941] = {.lex_state = 267},
  [5942] = {.lex_state = 208},
  [5943] = {.lex_state = 267},
  [5944] = {.lex_state = 267},
  [5945] = {.lex_state = 286},
  [5946] = {.lex_state = 289},
  [5947] = {.lex_state = 208},
  [5948] = {.lex_state = 267},
  [5949] = {.lex_state = 267},
  [5950] = {.lex_state = 208},
  [5951] = {.lex_state = 208},
  [5952] = {.lex_state = 208},
  [5953] = {.lex_state = 230},
  [5954] = {.lex_state = 208},
  [5955] = {.lex_state = 208},
  [5956] = {.lex_state = 230},
  [5957] = {.lex_state = 230},
  [5958] = {.lex_state = 267},
  [5959] = {.lex_state = 230},
  [5960] = {.lex_state = 208},
  [5961] = {.lex_state = 230},
  [5962] = {.lex_state = 208},
  [5963] = {.lex_state = 208},
  [5964] = {.lex_state = 286},
  [5965] = {.lex_state = 230},
  [5966] = {.lex_state = 286},
  [5967] = {.lex_state = 230},
  [5968] = {.lex_state = 230},
  [5969] = {.lex_state = 286},
  [5970] = {.lex_state = 230},
  [5971] = {.lex_state = 230},
  [5972] = {.lex_state = 285},
  [5973] = {.lex_state = 286},
  [5974] = {.lex_state = 230},
  [5975] = {.lex_state = 208},
  [5976] = {.lex_state = 208},
  [5977] = {.lex_state = 286},
  [5978] = {.lex_state = 230},
  [5979] = {.lex_state = 230},
  [5980] = {.lex_state = 267},
  [5981] = {.lex_state = 267},
  [5982] = {.lex_state = 230},
  [5983] = {.lex_state = 285},
  [5984] = {.lex_state = 208},
  [5985] = {.lex_state = 208},
  [5986] = {.lex_state = 267},
  [5987] = {.lex_state = 208},
  [5988] = {.lex_state = 208},
  [5989] = {.lex_state = 208},
  [5990] = {.lex_state = 208},
  [5991] = {.lex_state = 208},
  [5992] = {.lex_state = 230},
  [5993] = {.lex_state = 286},
  [5994] = {.lex_state = 208},
  [5995] = {.lex_state = 230},
  [5996] = {.lex_state = 289},
  [5997] = {.lex_state = 289},
  [5998] = {.lex_state = 101},
  [5999] = {.lex_state = 101},
  [6000] = {.lex_state = 101},
  [6001] = {.lex_state = 285},
  [6002] = {.lex_state = 285},
  [6003] = {.lex_state = 286},
  [6004] = {.lex_state = 101},
  [6005] = {.lex_state = 289},
  [6006] = {.lex_state = 289},
  [6007] = {.lex_state = 285},
  [6008] = {.lex_state = 289},
  [6009] = {.lex_state = 101},
  [6010] = {.lex_state = 289},
  [6011] = {.lex_state = 286},
  [6012] = {.lex_state = 101},
  [6013] = {.lex_state = 289},
  [6014] = {.lex_state = 101},
  [6015] = {.lex_state = 101},
  [6016] = {.lex_state = 101},
  [6017] = {.lex_state = 101},
  [6018] = {.lex_state = 289},
  [6019] = {.lex_state = 289},
  [6020] = {.lex_state = 289},
  [6021] = {.lex_state = 101},
  [6022] = {.lex_state = 285},
  [6023] = {.lex_state = 285},
  [6024] = {.lex_state = 285},
  [6025] = {.lex_state = 101},
  [6026] = {.lex_state = 289},
  [6027] = {.lex_state = 289},
  [6028] = {.lex_state = 101},
  [6029] = {.lex_state = 289},
  [6030] = {.lex_state = 285},
  [6031] = {.lex_state = 101},
  [6032] = {.lex_state = 101},
  [6033] = {.lex_state = 101},
  [6034] = {.lex_state = 286},
  [6035] = {.lex_state = 289},
  [6036] = {.lex_state = 289},
  [6037] = {.lex_state = 289},
  [6038] = {.lex_state = 289},
  [6039] = {.lex_state = 289},
  [6040] = {.lex_state = 285},
  [6041] = {.lex_state = 289},
  [6042] = {.lex_state = 267},
  [6043] = {.lex_state = 286},
  [6044] = {.lex_state = 289},
  [6045] = {.lex_state = 289},
  [6046] = {.lex_state = 289},
  [6047] = {.lex_state = 289},
  [6048] = {.lex_state = 286},
  [6049] = {.lex_state = 289},
  [6050] = {.lex_state = 101},
  [6051] = {.lex_state = 289},
  [6052] = {.lex_state = 289},
  [6053] = {.lex_state = 286},
  [6054] = {.lex_state = 289},
  [6055] = {.lex_state = 101},
  [6056] = {.lex_state = 289},
  [6057] = {.lex_state = 285},
  [6058] = {.lex_state = 101},
  [6059] = {.lex_state = 267},
  [6060] = {.lex_state = 289},
  [6061] = {.lex_state = 289},
  [6062] = {.lex_state = 289},
  [6063] = {.lex_state = 289},
  [6064] = {.lex_state = 267},
  [6065] = {.lex_state = 101},
  [6066] = {.lex_state = 289},
  [6067] = {.lex_state = 289},
  [6068] = {.lex_state = 289},
  [6069] = {.lex_state = 289},
  [6070] = {.lex_state = 285},
  [6071] = {.lex_state = 101},
  [6072] = {.lex_state = 286},
  [6073] = {.lex_state = 289},
  [6074] = {.lex_state = 285},
  [6075] = {.lex_state = 101},
  [6076] = {.lex_state = 289},
  [6077] = {.lex_state = 101},
  [6078] = {.lex_state = 101},
  [6079] = {.lex_state = 101},
  [6080] = {.lex_state = 286},
  [6081] = {.lex_state = 286},
  [6082] = {.lex_state = 289},
  [6083] = {.lex_state = 230},
  [6084] = {.lex_state = 285},
  [6085] = {.lex_state = 285},
  [6086] = {.lex_state = 285},
  [6087] = {.lex_state = 289},
  [6088] = {.lex_state = 285},
  [6089] = {.lex_state = 285},
  [6090] = {.lex_state = 267},
  [6091] = {.lex_state = 285},
  [6092] = {.lex_state = 289},
  [6093] = {.lex_state = 289},
  [6094] = {.lex_state = 267},
  [6095] = {.lex_state = 101},
  [6096] = {.lex_state = 289},
  [6097] = {.lex_state = 289},
  [6098] = {.lex_state = 289},
  [6099] = {.lex_state = 289},
  [6100] = {.lex_state = 101},
  [6101] = {.lex_state = 289},
  [6102] = {.lex_state = 285},
  [6103] = {.lex_state = 285},
  [6104] = {.lex_state = 286},
  [6105] = {.lex_state = 289},
  [6106] = {.lex_state = 285},
  [6107] = {.lex_state = 289},
  [6108] = {.lex_state = 289},
  [6109] = {.lex_state = 289},
  [6110] = {.lex_state = 285},
  [6111] = {.lex_state = 286},
  [6112] = {.lex_state = 285},
  [6113] = {.lex_state = 285},
  [6114] = {.lex_state = 101},
  [6115] = {.lex_state = 101},
  [6116] = {.lex_state = 289},
  [6117] = {.lex_state = 289},
  [6118] = {.lex_state = 286},
  [6119] = {.lex_state = 267},
  [6120] = {.lex_state = 288},
  [6121] = {.lex_state = 286},
  [6122] = {.lex_state = 286},
  [6123] = {.lex_state = 101},
  [6124] = {.lex_state = 101},
  [6125] = {.lex_state = 101},
  [6126] = {.lex_state = 230},
  [6127] = {.lex_state = 101},
  [6128] = {.lex_state = 289},
  [6129] = {.lex_state = 288},
  [6130] = {.lex_state = 288},
  [6131] = {.lex_state = 288},
  [6132] = {.lex_state = 289},
  [6133] = {.lex_state = 289},
  [6134] = {.lex_state = 288},
  [6135] = {.lex_state = 288},
  [6136] = {.lex_state = 288},
  [6137] = {.lex_state = 231},
  [6138] = {.lex_state = 288},
  [6139] = {.lex_state = 289},
  [6140] = {.lex_state = 231},
  [6141] = {.lex_state = 288},
  [6142] = {.lex_state = 289},
  [6143] = {.lex_state = 231},
  [6144] = {.lex_state = 231},
  [6145] = {.lex_state = 289},
  [6146] = {.lex_state = 289},
  [6147] = {.lex_state = 285},
  [6148] = {.lex_state = 289},
  [6149] = {.lex_state = 289},
  [6150] = {.lex_state = 289},
  [6151] = {.lex_state = 289},
  [6152] = {.lex_state = 289},
  [6153] = {.lex_state = 289},
  [6154] = {.lex_state = 239},
  [6155] = {.lex_state = 239},
  [6156] = {.lex_state = 281},
  [6157] = {.lex_state = 205},
  [6158] = {.lex_state = 289},
  [6159] = {.lex_state = 239},
  [6160] = {.lex_state = 289},
  [6161] = {.lex_state = 289},
  [6162] = {.lex_state = 289},
  [6163] = {.lex_state = 289},
  [6164] = {.lex_state = 205},
  [6165] = {.lex_state = 289},
  [6166] = {.lex_state = 289},
  [6167] = {.lex_state = 289},
  [6168] = {.lex_state = 289},
  [6169] = {.lex_state = 205},
  [6170] = {.lex_state = 289},
  [6171] = {.lex_state = 285},
  [6172] = {.lex_state = 239},
  [6173] = {.lex_state = 289},
  [6174] = {.lex_state = 289},
  [6175] = {.lex_state = 239},
  [6176] = {.lex_state = 285},
  [6177] = {.lex_state = 289},
  [6178] = {.lex_state = 205},
  [6179] = {.lex_state = 239},
  [6180] = {.lex_state = 205},
  [6181] = {.lex_state = 288},
  [6182] = {.lex_state = 205},
  [6183] = {.lex_state = 205},
  [6184] = {.lex_state = 289},
  [6185] = {.lex_state = 289},
  [6186] = {.lex_state = 288},
  [6187] = {.lex_state = 289},
  [6188] = {.lex_state = 281},
  [6189] = {.lex_state = 205},
  [6190] = {.lex_state = 285},
  [6191] = {.lex_state = 285},
  [6192] = {.lex_state = 285},
  [6193] = {.lex_state = 289},
  [6194] = {.lex_state = 285},
  [6195] = {.lex_state = 205},
  [6196] = {.lex_state = 289},
  [6197] = {.lex_state = 289},
  [6198] = {.lex_state = 285},
  [6199] = {.lex_state = 285},
  [6200] = {.lex_state = 205},
  [6201] = {.lex_state = 241},
  [6202] = {.lex_state = 239},
  [6203] = {.lex_state = 267},
  [6204] = {.lex_state = 289},
  [6205] = {.lex_state = 239},
  [6206] = {.lex_state = 285},
  [6207] = {.lex_state = 289},
  [6208] = {.lex_state = 239},
  [6209] = {.lex_state = 239},
  [6210] = {.lex_state = 267},
  [6211] = {.lex_state = 239},
  [6212] = {.lex_state = 285},
  [6213] = {.lex_state = 285},
  [6214] = {.lex_state = 285},
  [6215] = {.lex_state = 205},
  [6216] = {.lex_state = 281},
  [6217] = {.lex_state = 267},
  [6218] = {.lex_state = 267},
  [6219] = {.lex_state = 285},
  [6220] = {.lex_state = 288},
  [6221] = {.lex_state = 205},
  [6222] = {.lex_state = 281},
  [6223] = {.lex_state = 239},
  [6224] = {.lex_state = 289},
  [6225] = {.lex_state = 231},
  [6226] = {.lex_state = 231},
  [6227] = {.lex_state = 231},
  [6228] = {.lex_state = 288},
  [6229] = {.lex_state = 286},
  [6230] = {.lex_state = 288},
  [6231] = {.lex_state = 288},
  [6232] = {.lex_state = 286},
  [6233] = {.lex_state = 286},
  [6234] = {.lex_state = 286},
  [6235] = {.lex_state = 285},
  [6236] = {.lex_state = 288},
  [6237] = {.lex_state = 285},
  [6238] = {.lex_state = 286},
  [6239] = {.lex_state = 288},
  [6240] = {.lex_state = 286},
  [6241] = {.lex_state = 288},
  [6242] = {.lex_state = 288},
  [6243] = {.lex_state = 286},
  [6244] = {.lex_state = 288},
  [6245] = {.lex_state = 288},
  [6246] = {.lex_state = 231},
  [6247] = {.lex_state = 288},
  [6248] = {.lex_state = 286},
  [6249] = {.lex_state = 288},
  [6250] = {.lex_state = 288},
  [6251] = {.lex_state = 288},
  [6252] = {.lex_state = 205},
  [6253] = {.lex_state = 231},
  [6254] = {.lex_state = 288},
  [6255] = {.lex_state = 286},
  [6256] = {.lex_state = 288},
  [6257] = {.lex_state = 290},
  [6258] = {.lex_state = 286},
  [6259] = {.lex_state = 286},
  [6260] = {.lex_state = 288},
  [6261] = {.lex_state = 289},
  [6262] = {.lex_state = 286},
  [6263] = {.lex_state = 289},
  [6264] = {.lex_state = 205},
  [6265] = {.lex_state = 296},
  [6266] = {.lex_state = 285},
  [6267] = {.lex_state = 286},
  [6268] = {.lex_state = 286},
  [6269] = {.lex_state = 286},
  [6270] = {.lex_state = 231},
  [6271] = {.lex_state = 288},
  [6272] = {.lex_state = 288},
  [6273] = {.lex_state = 288},
  [6274] = {.lex_state = 231},
  [6275] = {.lex_state = 290},
  [6276] = {.lex_state = 288},
  [6277] = {.lex_state = 288},
  [6278] = {.lex_state = 286},
  [6279] = {.lex_state = 286},
  [6280] = {.lex_state = 286},
  [6281] = {.lex_state = 231},
  [6282] = {.lex_state = 288},
  [6283] = {.lex_state = 288},
  [6284] = {.lex_state = 288},
  [6285] = {.lex_state = 288},
  [6286] = {.lex_state = 231},
  [6287] = {.lex_state = 286},
  [6288] = {.lex_state = 288},
  [6289] = {.lex_state = 231},
  [6290] = {.lex_state = 288},
  [6291] = {.lex_state = 288},
  [6292] = {.lex_state = 286},
  [6293] = {.lex_state = 288},
  [6294] = {.lex_state = 289},
  [6295] = {.lex_state = 205},
  [6296] = {.lex_state = 205},
  [6297] = {.lex_state = 289},
  [6298] = {.lex_state = 289},
  [6299] = {.lex_state = 205},
  [6300] = {.lex_state = 289},
  [6301] = {.lex_state = 289},
  [6302] = {.lex_state = 205},
  [6303] = {.lex_state = 289},
  [6304] = {.lex_state = 289},
  [6305] = {.lex_state = 289},
  [6306] = {.lex_state = 289},
  [6307] = {.lex_state = 289},
  [6308] = {.lex_state = 289},
  [6309] = {.lex_state = 289},
  [6310] = {.lex_state = 285},
  [6311] = {.lex_state = 218},
  [6312] = {.lex_state = 285},
  [6313] = {.lex_state = 289},
  [6314] = {.lex_state = 205},
  [6315] = {.lex_state = 218},
  [6316] = {.lex_state = 218},
  [6317] = {.lex_state = 205},
  [6318] = {.lex_state = 285},
  [6319] = {.lex_state = 289},
  [6320] = {.lex_state = 289},
  [6321] = {.lex_state = 231},
  [6322] = {.lex_state = 218},
  [6323] = {.lex_state = 218},
  [6324] = {.lex_state = 218},
  [6325] = {.lex_state = 218},
  [6326] = {.lex_state = 232},
  [6327] = {.lex_state = 289},
  [6328] = {.lex_state = 218},
  [6329] = {.lex_state = 289},
  [6330] = {.lex_state = 231},
  [6331] = {.lex_state = 231},
  [6332] = {.lex_state = 205},
  [6333] = {.lex_state = 231},
  [6334] = {.lex_state = 289},
  [6335] = {.lex_state = 289},
  [6336] = {.lex_state = 218},
  [6337] = {.lex_state = 232},
  [6338] = {.lex_state = 218},
  [6339] = {.lex_state = 285},
  [6340] = {.lex_state = 285},
  [6341] = {.lex_state = 285},
  [6342] = {.lex_state = 205},
  [6343] = {.lex_state = 205},
  [6344] = {.lex_state = 285},
  [6345] = {.lex_state = 232},
  [6346] = {.lex_state = 218},
  [6347] = {.lex_state = 218},
  [6348] = {.lex_state = 231},
  [6349] = {.lex_state = 285},
  [6350] = {.lex_state = 232},
  [6351] = {.lex_state = 285},
  [6352] = {.lex_state = 211},
  [6353] = {.lex_state = 218},
  [6354] = {.lex_state = 285},
  [6355] = {.lex_state = 218},
  [6356] = {.lex_state = 285},
  [6357] = {.lex_state = 231},
  [6358] = {.lex_state = 218},
  [6359] = {.lex_state = 218},
  [6360] = {.lex_state = 218},
  [6361] = {.lex_state = 285},
  [6362] = {.lex_state = 232},
  [6363] = {.lex_state = 205},
  [6364] = {.lex_state = 231},
  [6365] = {.lex_state = 231},
  [6366] = {.lex_state = 205},
  [6367] = {.lex_state = 289},
  [6368] = {.lex_state = 231},
  [6369] = {.lex_state = 218},
  [6370] = {.lex_state = 285},
  [6371] = {.lex_state = 232},
  [6372] = {.lex_state = 218},
  [6373] = {.lex_state = 205},
  [6374] = {.lex_state = 232},
  [6375] = {.lex_state = 285},
  [6376] = {.lex_state = 232},
  [6377] = {.lex_state = 290},
  [6378] = {.lex_state = 231},
  [6379] = {.lex_state = 290},
  [6380] = {.lex_state = 231},
  [6381] = {.lex_state = 251},
  [6382] = {.lex_state = 251},
  [6383] = {.lex_state = 251},
  [6384] = {.lex_state = 251},
  [6385] = {.lex_state = 218},
  [6386] = {.lex_state = 289},
  [6387] = {.lex_state = 285},
  [6388] = {.lex_state = 251},
  [6389] = {.lex_state = 251},
  [6390] = {.lex_state = 251},
  [6391] = {.lex_state = 290},
  [6392] = {.lex_state = 241},
  [6393] = {.lex_state = 251},
  [6394] = {.lex_state = 289},
  [6395] = {.lex_state = 241},
  [6396] = {.lex_state = 231},
  [6397] = {.lex_state = 289},
  [6398] = {.lex_state = 241},
  [6399] = {.lex_state = 290},
  [6400] = {.lex_state = 231},
  [6401] = {.lex_state = 241},
  [6402] = {.lex_state = 231},
  [6403] = {.lex_state = 241},
  [6404] = {.lex_state = 289},
  [6405] = {.lex_state = 290},
  [6406] = {.lex_state = 241},
  [6407] = {.lex_state = 231},
  [6408] = {.lex_state = 218},
  [6409] = {.lex_state = 231},
  [6410] = {.lex_state = 290},
  [6411] = {.lex_state = 289},
  [6412] = {.lex_state = 241},
  [6413] = {.lex_state = 231},
  [6414] = {.lex_state = 218},
  [6415] = {.lex_state = 231},
  [6416] = {.lex_state = 290},
  [6417] = {.lex_state = 231},
  [6418] = {.lex_state = 231},
  [6419] = {.lex_state = 288},
  [6420] = {.lex_state = 289},
  [6421] = {.lex_state = 289},
  [6422] = {.lex_state = 231},
  [6423] = {.lex_state = 231},
  [6424] = {.lex_state = 231},
  [6425] = {.lex_state = 231},
  [6426] = {.lex_state = 288},
  [6427] = {.lex_state = 288},
  [6428] = {.lex_state = 231},
  [6429] = {.lex_state = 241},
  [6430] = {.lex_state = 290},
  [6431] = {.lex_state = 289},
  [6432] = {.lex_state = 231},
  [6433] = {.lex_state = 290},
  [6434] = {.lex_state = 290},
  [6435] = {.lex_state = 290},
  [6436] = {.lex_state = 285},
  [6437] = {.lex_state = 289},
  [6438] = {.lex_state = 231},
  [6439] = {.lex_state = 289},
  [6440] = {.lex_state = 231},
  [6441] = {.lex_state = 290},
  [6442] = {.lex_state = 218},
  [6443] = {.lex_state = 231},
  [6444] = {.lex_state = 288},
  [6445] = {.lex_state = 288},
  [6446] = {.lex_state = 231},
  [6447] = {.lex_state = 288},
  [6448] = {.lex_state = 288},
  [6449] = {.lex_state = 218},
  [6450] = {.lex_state = 231},
  [6451] = {.lex_state = 285},
  [6452] = {.lex_state = 281},
  [6453] = {.lex_state = 281},
  [6454] = {.lex_state = 285},
  [6455] = {.lex_state = 218},
  [6456] = {.lex_state = 241},
  [6457] = {.lex_state = 231},
  [6458] = {.lex_state = 290},
  [6459] = {.lex_state = 231},
  [6460] = {.lex_state = 289},
  [6461] = {.lex_state = 218},
  [6462] = {.lex_state = 289},
  [6463] = {.lex_state = 289},
  [6464] = {.lex_state = 289},
  [6465] = {.lex_state = 289},
  [6466] = {.lex_state = 289},
  [6467] = {.lex_state = 289},
  [6468] = {.lex_state = 231},
  [6469] = {.lex_state = 231},
  [6470] = {.lex_state = 288},
  [6471] = {.lex_state = 231},
  [6472] = {.lex_state = 285},
  [6473] = {.lex_state = 231},
  [6474] = {.lex_state = 290},
  [6475] = {.lex_state = 285},
  [6476] = {.lex_state = 240},
  [6477] = {.lex_state = 289},
  [6478] = {.lex_state = 241},
  [6479] = {.lex_state = 289},
  [6480] = {.lex_state = 290},
  [6481] = {.lex_state = 231},
  [6482] = {.lex_state = 285},
  [6483] = {.lex_state = 289},
  [6484] = {.lex_state = 289},
  [6485] = {.lex_state = 231},
  [6486] = {.lex_state = 281},
  [6487] = {.lex_state = 289},
  [6488] = {.lex_state = 241},
  [6489] = {.lex_state = 281},
  [6490] = {.lex_state = 231},
  [6491] = {.lex_state = 231},
  [6492] = {.lex_state = 289},
  [6493] = {.lex_state = 290},
  [6494] = {.lex_state = 231},
  [6495] = {.lex_state = 231},
  [6496] = {.lex_state = 289},
  [6497] = {.lex_state = 290},
  [6498] = {.lex_state = 290},
  [6499] = {.lex_state = 290},
  [6500] = {.lex_state = 241},
  [6501] = {.lex_state = 231},
  [6502] = {.lex_state = 231},
  [6503] = {.lex_state = 290},
  [6504] = {.lex_state = 290},
  [6505] = {.lex_state = 285},
  [6506] = {.lex_state = 231},
  [6507] = {.lex_state = 229},
  [6508] = {.lex_state = 229},
  [6509] = {.lex_state = 0},
  [6510] = {.lex_state = 289},
  [6511] = {.lex_state = 289},
  [6512] = {.lex_state = 289},
  [6513] = {.lex_state = 0},
  [6514] = {.lex_state = 229},
  [6515] = {.lex_state = 289},
  [6516] = {.lex_state = 229},
  [6517] = {.lex_state = 229},
  [6518] = {.lex_state = 229},
  [6519] = {.lex_state = 289},
  [6520] = {.lex_state = 289},
  [6521] = {.lex_state = 289},
  [6522] = {.lex_state = 229},
  [6523] = {.lex_state = 231},
  [6524] = {.lex_state = 289},
  [6525] = {.lex_state = 0},
  [6526] = {.lex_state = 231},
  [6527] = {.lex_state = 229},
  [6528] = {.lex_state = 289},
  [6529] = {.lex_state = 205},
  [6530] = {.lex_state = 289},
  [6531] = {.lex_state = 289},
  [6532] = {.lex_state = 231},
  [6533] = {.lex_state = 289},
  [6534] = {.lex_state = 229},
  [6535] = {.lex_state = 289},
  [6536] = {.lex_state = 289},
  [6537] = {.lex_state = 289},
  [6538] = {.lex_state = 289},
  [6539] = {.lex_state = 289},
  [6540] = {.lex_state = 229},
  [6541] = {.lex_state = 289},
  [6542] = {.lex_state = 285},
  [6543] = {.lex_state = 289},
  [6544] = {.lex_state = 285},
  [6545] = {.lex_state = 0},
  [6546] = {.lex_state = 289},
  [6547] = {.lex_state = 285},
  [6548] = {.lex_state = 229},
  [6549] = {.lex_state = 289},
  [6550] = {.lex_state = 285},
  [6551] = {.lex_state = 0},
  [6552] = {.lex_state = 285},
  [6553] = {.lex_state = 289},
  [6554] = {.lex_state = 285},
  [6555] = {.lex_state = 285},
  [6556] = {.lex_state = 229},
  [6557] = {.lex_state = 231},
  [6558] = {.lex_state = 285},
  [6559] = {.lex_state = 231},
  [6560] = {.lex_state = 229},
  [6561] = {.lex_state = 231},
  [6562] = {.lex_state = 205},
  [6563] = {.lex_state = 289},
  [6564] = {.lex_state = 289},
  [6565] = {.lex_state = 289},
  [6566] = {.lex_state = 229},
  [6567] = {.lex_state = 229},
  [6568] = {.lex_state = 229},
  [6569] = {.lex_state = 231},
  [6570] = {.lex_state = 289},
  [6571] = {.lex_state = 229},
  [6572] = {.lex_state = 229},
  [6573] = {.lex_state = 289},
  [6574] = {.lex_state = 229},
  [6575] = {.lex_state = 289},
  [6576] = {.lex_state = 289},
  [6577] = {.lex_state = 289},
  [6578] = {.lex_state = 289},
  [6579] = {.lex_state = 289},
  [6580] = {.lex_state = 289},
  [6581] = {.lex_state = 229},
  [6582] = {.lex_state = 289},
  [6583] = {.lex_state = 289},
  [6584] = {.lex_state = 0},
  [6585] = {.lex_state = 289},
  [6586] = {.lex_state = 289},
  [6587] = {.lex_state = 229},
  [6588] = {.lex_state = 229},
  [6589] = {.lex_state = 233},
  [6590] = {.lex_state = 233},
  [6591] = {.lex_state = 233},
  [6592] = {.lex_state = 233},
  [6593] = {.lex_state = 229},
  [6594] = {.lex_state = 233},
  [6595] = {.lex_state = 289},
  [6596] = {.lex_state = 205},
  [6597] = {.lex_state = 233},
  [6598] = {.lex_state = 289},
  [6599] = {.lex_state = 0},
  [6600] = {.lex_state = 231},
  [6601] = {.lex_state = 289},
  [6602] = {.lex_state = 233},
  [6603] = {.lex_state = 289},
  [6604] = {.lex_state = 289},
  [6605] = {.lex_state = 289},
  [6606] = {.lex_state = 289},
  [6607] = {.lex_state = 289},
  [6608] = {.lex_state = 289},
  [6609] = {.lex_state = 289},
  [6610] = {.lex_state = 233},
  [6611] = {.lex_state = 289},
  [6612] = {.lex_state = 289},
  [6613] = {.lex_state = 289},
  [6614] = {.lex_state = 229},
  [6615] = {.lex_state = 231},
  [6616] = {.lex_state = 231},
  [6617] = {.lex_state = 241},
  [6618] = {.lex_state = 231},
  [6619] = {.lex_state = 241},
  [6620] = {.lex_state = 241},
  [6621] = {.lex_state = 241},
  [6622] = {.lex_state = 289},
  [6623] = {.lex_state = 231},
  [6624] = {.lex_state = 251},
  [6625] = {.lex_state = 239},
  [6626] = {.lex_state = 231},
  [6627] = {.lex_state = 231},
  [6628] = {.lex_state = 231},
  [6629] = {.lex_state = 251},
  [6630] = {.lex_state = 231},
  [6631] = {.lex_state = 231},
  [6632] = {.lex_state = 231},
  [6633] = {.lex_state = 251},
  [6634] = {.lex_state = 251},
  [6635] = {.lex_state = 289},
  [6636] = {.lex_state = 289},
  [6637] = {.lex_state = 251},
  [6638] = {.lex_state = 231},
  [6639] = {.lex_state = 231},
  [6640] = {.lex_state = 231},
  [6641] = {.lex_state = 231},
  [6642] = {.lex_state = 388},
  [6643] = {.lex_state = 388},
  [6644] = {.lex_state = 388},
  [6645] = {.lex_state = 231},
  [6646] = {.lex_state = 231},
  [6647] = {.lex_state = 241},
  [6648] = {.lex_state = 231},
  [6649] = {.lex_state = 231},
  [6650] = {.lex_state = 251},
  [6651] = {.lex_state = 231},
  [6652] = {.lex_state = 241},
  [6653] = {.lex_state = 251},
  [6654] = {.lex_state = 241},
  [6655] = {.lex_state = 251},
  [6656] = {.lex_state = 251},
  [6657] = {.lex_state = 251},
  [6658] = {.lex_state = 289},
  [6659] = {.lex_state = 241},
  [6660] = {.lex_state = 231},
  [6661] = {.lex_state = 231},
  [6662] = {.lex_state = 251},
  [6663] = {.lex_state = 231},
  [6664] = {.lex_state = 231},
  [6665] = {.lex_state = 231},
  [6666] = {.lex_state = 388},
  [6667] = {.lex_state = 231},
  [6668] = {.lex_state = 388},
  [6669] = {.lex_state = 231},
  [6670] = {.lex_state = 231},
  [6671] = {.lex_state = 251},
  [6672] = {.lex_state = 231},
  [6673] = {.lex_state = 231},
  [6674] = {.lex_state = 231},
  [6675] = {.lex_state = 0},
  [6676] = {.lex_state = 289},
  [6677] = {.lex_state = 231},
  [6678] = {.lex_state = 231},
  [6679] = {.lex_state = 231},
  [6680] = {.lex_state = 231},
  [6681] = {.lex_state = 231},
  [6682] = {.lex_state = 231},
  [6683] = {.lex_state = 289},
  [6684] = {.lex_state = 233},
  [6685] = {.lex_state = 233},
  [6686] = {.lex_state = 231},
  [6687] = {.lex_state = 231},
  [6688] = {.lex_state = 231},
  [6689] = {.lex_state = 289},
  [6690] = {.lex_state = 231},
  [6691] = {.lex_state = 231},
  [6692] = {.lex_state = 232},
  [6693] = {.lex_state = 231},
  [6694] = {.lex_state = 232},
  [6695] = {.lex_state = 231},
  [6696] = {.lex_state = 233},
  [6697] = {.lex_state = 231},
  [6698] = {.lex_state = 289},
  [6699] = {.lex_state = 231},
  [6700] = {.lex_state = 233},
  [6701] = {.lex_state = 232},
  [6702] = {.lex_state = 231},
  [6703] = {.lex_state = 289},
  [6704] = {.lex_state = 231},
  [6705] = {.lex_state = 231},
  [6706] = {.lex_state = 231},
  [6707] = {.lex_state = 289},
  [6708] = {.lex_state = 288},
  [6709] = {.lex_state = 231},
  [6710] = {.lex_state = 231},
  [6711] = {.lex_state = 231},
  [6712] = {.lex_state = 231},
  [6713] = {.lex_state = 231},
  [6714] = {.lex_state = 231},
  [6715] = {.lex_state = 233},
  [6716] = {.lex_state = 231},
  [6717] = {.lex_state = 231},
  [6718] = {.lex_state = 231},
  [6719] = {.lex_state = 231},
  [6720] = {.lex_state = 288},
  [6721] = {.lex_state = 232},
  [6722] = {.lex_state = 289},
  [6723] = {.lex_state = 231},
  [6724] = {.lex_state = 233},
  [6725] = {.lex_state = 232},
  [6726] = {.lex_state = 232},
  [6727] = {.lex_state = 231},
  [6728] = {.lex_state = 231},
  [6729] = {.lex_state = 231},
  [6730] = {.lex_state = 233},
  [6731] = {.lex_state = 289},
  [6732] = {.lex_state = 233},
  [6733] = {.lex_state = 231},
  [6734] = {.lex_state = 288},
  [6735] = {.lex_state = 232},
  [6736] = {.lex_state = 231},
  [6737] = {.lex_state = 233},
  [6738] = {.lex_state = 233},
  [6739] = {.lex_state = 231},
  [6740] = {.lex_state = 231},
  [6741] = {.lex_state = 233},
  [6742] = {.lex_state = 231},
  [6743] = {.lex_state = 231},
  [6744] = {.lex_state = 231},
  [6745] = {.lex_state = 288},
  [6746] = {.lex_state = 231},
  [6747] = {.lex_state = 231},
  [6748] = {.lex_state = 289},
  [6749] = {.lex_state = 231},
  [6750] = {.lex_state = 231},
  [6751] = {.lex_state = 232},
  [6752] = {.lex_state = 231},
  [6753] = {.lex_state = 289},
  [6754] = {.lex_state = 231},
  [6755] = {.lex_state = 231},
  [6756] = {.lex_state = 231},
  [6757] = {.lex_state = 289},
  [6758] = {.lex_state = 229},
  [6759] = {.lex_state = 231},
  [6760] = {.lex_state = 233},
  [6761] = {.lex_state = 231},
  [6762] = {.lex_state = 231},
  [6763] = {.lex_state = 231},
  [6764] = {.lex_state = 231},
  [6765] = {.lex_state = 231},
  [6766] = {.lex_state = 231},
  [6767] = {.lex_state = 231},
  [6768] = {.lex_state = 251},
  [6769] = {.lex_state = 251},
  [6770] = {.lex_state = 251},
  [6771] = {.lex_state = 251},
  [6772] = {.lex_state = 211},
  [6773] = {.lex_state = 251},
  [6774] = {.lex_state = 211},
  [6775] = {.lex_state = 267},
  [6776] = {.lex_state = 231},
  [6777] = {.lex_state = 388},
  [6778] = {.lex_state = 267},
  [6779] = {.lex_state = 388},
  [6780] = {.lex_state = 231},
  [6781] = {.lex_state = 267},
  [6782] = {.lex_state = 289},
  [6783] = {.lex_state = 289},
  [6784] = {.lex_state = 251},
  [6785] = {.lex_state = 251},
  [6786] = {.lex_state = 289},
  [6787] = {.lex_state = 251},
  [6788] = {.lex_state = 267},
  [6789] = {.lex_state = 289},
  [6790] = {.lex_state = 231},
  [6791] = {.lex_state = 267},
  [6792] = {.lex_state = 289},
  [6793] = {.lex_state = 289},
  [6794] = {.lex_state = 231},
  [6795] = {.lex_state = 267},
  [6796] = {.lex_state = 289},
  [6797] = {.lex_state = 231},
  [6798] = {.lex_state = 267},
  [6799] = {.lex_state = 388},
  [6800] = {.lex_state = 267},
  [6801] = {.lex_state = 267},
  [6802] = {.lex_state = 267},
  [6803] = {.lex_state = 267},
  [6804] = {.lex_state = 267},
  [6805] = {.lex_state = 267},
  [6806] = {.lex_state = 231},
  [6807] = {.lex_state = 267},
  [6808] = {.lex_state = 267},
  [6809] = {.lex_state = 231},
  [6810] = {.lex_state = 231},
  [6811] = {.lex_state = 231},
  [6812] = {.lex_state = 231},
  [6813] = {.lex_state = 231},
  [6814] = {.lex_state = 239},
  [6815] = {.lex_state = 231},
  [6816] = {.lex_state = 231},
  [6817] = {.lex_state = 231},
  [6818] = {.lex_state = 231},
  [6819] = {.lex_state = 388},
  [6820] = {.lex_state = 205},
  [6821] = {.lex_state = 231},
  [6822] = {.lex_state = 231},
  [6823] = {.lex_state = 231},
  [6824] = {.lex_state = 233},
  [6825] = {.lex_state = 231},
  [6826] = {.lex_state = 231},
  [6827] = {.lex_state = 231},
  [6828] = {.lex_state = 388},
  [6829] = {.lex_state = 231},
  [6830] = {.lex_state = 231},
  [6831] = {.lex_state = 231},
  [6832] = {.lex_state = 231},
  [6833] = {.lex_state = 231},
  [6834] = {.lex_state = 231},
  [6835] = {.lex_state = 231},
  [6836] = {.lex_state = 231},
  [6837] = {.lex_state = 231},
  [6838] = {.lex_state = 233},
  [6839] = {.lex_state = 231},
  [6840] = {.lex_state = 231},
  [6841] = {.lex_state = 282},
  [6842] = {.lex_state = 231},
  [6843] = {.lex_state = 231},
  [6844] = {.lex_state = 233},
  [6845] = {.lex_state = 231},
  [6846] = {.lex_state = 231},
  [6847] = {.lex_state = 231},
  [6848] = {.lex_state = 231},
  [6849] = {.lex_state = 233},
  [6850] = {.lex_state = 282},
  [6851] = {.lex_state = 231},
  [6852] = {.lex_state = 282},
  [6853] = {.lex_state = 231},
  [6854] = {.lex_state = 233},
  [6855] = {.lex_state = 231},
  [6856] = {.lex_state = 233},
  [6857] = {.lex_state = 282},
  [6858] = {.lex_state = 231},
  [6859] = {.lex_state = 233},
  [6860] = {.lex_state = 231},
  [6861] = {.lex_state = 231},
  [6862] = {.lex_state = 239},
  [6863] = {.lex_state = 233},
  [6864] = {.lex_state = 231},
  [6865] = {.lex_state = 388},
  [6866] = {.lex_state = 388},
  [6867] = {.lex_state = 388},
  [6868] = {.lex_state = 388},
  [6869] = {.lex_state = 231},
  [6870] = {.lex_state = 388},
  [6871] = {.lex_state = 205},
  [6872] = {.lex_state = 388},
  [6873] = {.lex_state = 388},
  [6874] = {.lex_state = 388},
  [6875] = {.lex_state = 233},
  [6876] = {.lex_state = 241},
  [6877] = {.lex_state = 388},
  [6878] = {.lex_state = 388},
  [6879] = {.lex_state = 241},
  [6880] = {.lex_state = 285},
  [6881] = {.lex_state = 267},
  [6882] = {.lex_state = 388},
  [6883] = {.lex_state = 388},
  [6884] = {.lex_state = 205},
  [6885] = {.lex_state = 388},
  [6886] = {.lex_state = 388},
  [6887] = {.lex_state = 241},
  [6888] = {.lex_state = 388},
  [6889] = {.lex_state = 233},
  [6890] = {.lex_state = 233},
  [6891] = {.lex_state = 233},
  [6892] = {.lex_state = 285},
  [6893] = {.lex_state = 388},
  [6894] = {.lex_state = 388},
  [6895] = {.lex_state = 285},
  [6896] = {.lex_state = 291},
  [6897] = {.lex_state = 388},
  [6898] = {.lex_state = 231},
  [6899] = {.lex_state = 241},
  [6900] = {.lex_state = 241},
  [6901] = {.lex_state = 233},
  [6902] = {.lex_state = 388},
  [6903] = {.lex_state = 388},
  [6904] = {.lex_state = 388},
  [6905] = {.lex_state = 388},
  [6906] = {.lex_state = 233},
  [6907] = {.lex_state = 241},
  [6908] = {.lex_state = 241},
  [6909] = {.lex_state = 241},
  [6910] = {.lex_state = 388},
  [6911] = {.lex_state = 288},
  [6912] = {.lex_state = 267},
  [6913] = {.lex_state = 388},
  [6914] = {.lex_state = 205},
  [6915] = {.lex_state = 205},
  [6916] = {.lex_state = 231},
  [6917] = {.lex_state = 231},
  [6918] = {.lex_state = 205},
  [6919] = {.lex_state = 231},
  [6920] = {.lex_state = 231},
  [6921] = {.lex_state = 239},
  [6922] = {.lex_state = 233},
  [6923] = {.lex_state = 205},
  [6924] = {.lex_state = 205},
  [6925] = {.lex_state = 205},
  [6926] = {.lex_state = 388},
  [6927] = {.lex_state = 285},
  [6928] = {.lex_state = 205},
  [6929] = {.lex_state = 233},
  [6930] = {.lex_state = 388},
  [6931] = {.lex_state = 388},
  [6932] = {.lex_state = 233},
  [6933] = {.lex_state = 205},
  [6934] = {.lex_state = 205},
  [6935] = {.lex_state = 388},
  [6936] = {.lex_state = 239},
  [6937] = {.lex_state = 388},
  [6938] = {.lex_state = 233},
  [6939] = {.lex_state = 205},
  [6940] = {.lex_state = 231},
  [6941] = {.lex_state = 205},
  [6942] = {.lex_state = 231},
  [6943] = {.lex_state = 205},
  [6944] = {.lex_state = 231},
  [6945] = {.lex_state = 205},
  [6946] = {.lex_state = 205},
  [6947] = {.lex_state = 205},
  [6948] = {.lex_state = 239},
  [6949] = {.lex_state = 388},
  [6950] = {.lex_state = 205},
  [6951] = {.lex_state = 205},
  [6952] = {.lex_state = 205},
  [6953] = {.lex_state = 231},
  [6954] = {.lex_state = 388},
  [6955] = {.lex_state = 205},
  [6956] = {.lex_state = 205},
  [6957] = {.lex_state = 388},
  [6958] = {.lex_state = 388},
  [6959] = {.lex_state = 205},
  [6960] = {.lex_state = 205},
  [6961] = {.lex_state = 205},
  [6962] = {.lex_state = 388},
  [6963] = {.lex_state = 233},
  [6964] = {.lex_state = 388},
  [6965] = {.lex_state = 388},
  [6966] = {.lex_state = 231},
  [6967] = {.lex_state = 231},
  [6968] = {.lex_state = 231},
  [6969] = {.lex_state = 229},
  [6970] = {.lex_state = 231},
  [6971] = {.lex_state = 231},
  [6972] = {.lex_state = 231},
  [6973] = {.lex_state = 231},
  [6974] = {.lex_state = 231},
  [6975] = {.lex_state = 231},
  [6976] = {.lex_state = 231},
  [6977] = {.lex_state = 231},
  [6978] = {.lex_state = 231},
  [6979] = {.lex_state = 231},
  [6980] = {.lex_state = 229},
  [6981] = {.lex_state = 229},
  [6982] = {.lex_state = 229},
  [6983] = {.lex_state = 205},
  [6984] = {.lex_state = 231},
  [6985] = {.lex_state = 231},
  [6986] = {.lex_state = 285},
  [6987] = {.lex_state = 231},
  [6988] = {.lex_state = 231},
  [6989] = {.lex_state = 285},
  [6990] = {.lex_state = 285},
  [6991] = {.lex_state = 231},
  [6992] = {.lex_state = 231},
  [6993] = {.lex_state = 0},
  [6994] = {.lex_state = 285},
  [6995] = {.lex_state = 285},
  [6996] = {.lex_state = 285},
  [6997] = {.lex_state = 229},
  [6998] = {.lex_state = 285},
  [6999] = {.lex_state = 285},
  [7000] = {.lex_state = 285},
  [7001] = {.lex_state = 285},
  [7002] = {.lex_state = 233},
  [7003] = {.lex_state = 388},
  [7004] = {.lex_state = 229},
  [7005] = {.lex_state = 231},
  [7006] = {.lex_state = 285},
  [7007] = {.lex_state = 285},
  [7008] = {.lex_state = 388},
  [7009] = {.lex_state = 0},
  [7010] = {.lex_state = 231},
  [7011] = {.lex_state = 231},
  [7012] = {.lex_state = 229},
  [7013] = {.lex_state = 388},
  [7014] = {.lex_state = 229},
  [7015] = {.lex_state = 229},
  [7016] = {.lex_state = 285},
  [7017] = {.lex_state = 285},
  [7018] = {.lex_state = 388},
  [7019] = {.lex_state = 388},
  [7020] = {.lex_state = 231},
  [7021] = {.lex_state = 229},
  [7022] = {.lex_state = 205},
  [7023] = {.lex_state = 229},
  [7024] = {.lex_state = 205},
  [7025] = {.lex_state = 231},
  [7026] = {.lex_state = 231},
  [7027] = {.lex_state = 205},
  [7028] = {.lex_state = 231},
  [7029] = {.lex_state = 231},
  [7030] = {.lex_state = 231},
  [7031] = {.lex_state = 285},
  [7032] = {.lex_state = 388},
  [7033] = {.lex_state = 231},
  [7034] = {.lex_state = 231},
  [7035] = {.lex_state = 231},
  [7036] = {.lex_state = 231},
  [7037] = {.lex_state = 231},
  [7038] = {.lex_state = 251},
  [7039] = {.lex_state = 240},
  [7040] = {.lex_state = 251},
  [7041] = {.lex_state = 231},
  [7042] = {.lex_state = 240},
  [7043] = {.lex_state = 231},
  [7044] = {.lex_state = 231},
  [7045] = {.lex_state = 388},
  [7046] = {.lex_state = 231},
  [7047] = {.lex_state = 231},
  [7048] = {.lex_state = 231},
  [7049] = {.lex_state = 231},
  [7050] = {.lex_state = 205},
  [7051] = {.lex_state = 231},
  [7052] = {.lex_state = 231},
  [7053] = {.lex_state = 240},
  [7054] = {.lex_state = 205},
  [7055] = {.lex_state = 388},
  [7056] = {.lex_state = 231},
  [7057] = {.lex_state = 231},
  [7058] = {.lex_state = 231},
  [7059] = {.lex_state = 240},
  [7060] = {.lex_state = 231},
  [7061] = {.lex_state = 231},
  [7062] = {.lex_state = 231},
  [7063] = {.lex_state = 240},
  [7064] = {.lex_state = 231},
  [7065] = {.lex_state = 231},
  [7066] = {.lex_state = 231},
  [7067] = {.lex_state = 388},
  [7068] = {.lex_state = 231},
  [7069] = {.lex_state = 231},
  [7070] = {.lex_state = 231},
  [7071] = {.lex_state = 231},
  [7072] = {.lex_state = 231},
  [7073] = {.lex_state = 240},
  [7074] = {.lex_state = 231},
  [7075] = {.lex_state = 231},
  [7076] = {.lex_state = 205},
  [7077] = {.lex_state = 240},
  [7078] = {.lex_state = 231},
  [7079] = {.lex_state = 231},
  [7080] = {.lex_state = 231},
  [7081] = {.lex_state = 231},
  [7082] = {.lex_state = 205},
  [7083] = {.lex_state = 240},
  [7084] = {.lex_state = 108},
  [7085] = {.lex_state = 231},
  [7086] = {.lex_state = 205},
  [7087] = {.lex_state = 388},
  [7088] = {.lex_state = 231},
  [7089] = {.lex_state = 388},
  [7090] = {.lex_state = 108},
  [7091] = {.lex_state = 231},
  [7092] = {.lex_state = 110},
  [7093] = {.lex_state = 231},
  [7094] = {.lex_state = 240},
  [7095] = {.lex_state = 108},
  [7096] = {.lex_state = 110},
  [7097] = {.lex_state = 108},
  [7098] = {.lex_state = 108},
  [7099] = {.lex_state = 231},
  [7100] = {.lex_state = 108},
  [7101] = {.lex_state = 108},
  [7102] = {.lex_state = 205},
  [7103] = {.lex_state = 108},
  [7104] = {.lex_state = 388},
  [7105] = {.lex_state = 108},
  [7106] = {.lex_state = 231},
  [7107] = {.lex_state = 108},
  [7108] = {.lex_state = 388},
  [7109] = {.lex_state = 205},
  [7110] = {.lex_state = 388},
  [7111] = {.lex_state = 240},
  [7112] = {.lex_state = 111},
  [7113] = {.lex_state = 388},
  [7114] = {.lex_state = 108},
  [7115] = {.lex_state = 388},
  [7116] = {.lex_state = 231},
  [7117] = {.lex_state = 231},
  [7118] = {.lex_state = 231},
  [7119] = {.lex_state = 108},
  [7120] = {.lex_state = 240},
  [7121] = {.lex_state = 111},
  [7122] = {.lex_state = 108},
  [7123] = {.lex_state = 388},
  [7124] = {.lex_state = 108},
  [7125] = {.lex_state = 108},
  [7126] = {.lex_state = 231},
  [7127] = {.lex_state = 231},
  [7128] = {.lex_state = 388},
  [7129] = {.lex_state = 108},
  [7130] = {.lex_state = 108},
  [7131] = {.lex_state = 231},
  [7132] = {.lex_state = 205},
  [7133] = {.lex_state = 240},
  [7134] = {.lex_state = 108},
  [7135] = {.lex_state = 388},
  [7136] = {.lex_state = 388},
  [7137] = {.lex_state = 108},
  [7138] = {.lex_state = 388},
  [7139] = {.lex_state = 240},
  [7140] = {.lex_state = 388},
  [7141] = {.lex_state = 388},
  [7142] = {.lex_state = 0},
  [7143] = {.lex_state = 231},
  [7144] = {.lex_state = 388},
  [7145] = {.lex_state = 388},
  [7146] = {.lex_state = 388},
  [7147] = {.lex_state = 205},
  [7148] = {.lex_state = 240},
  [7149] = {.lex_state = 285},
  [7150] = {.lex_state = 388},
  [7151] = {.lex_state = 231},
  [7152] = {.lex_state = 388},
  [7153] = {.lex_state = 240},
  [7154] = {.lex_state = 108},
  [7155] = {.lex_state = 231},
  [7156] = {.lex_state = 388},
  [7157] = {.lex_state = 108},
  [7158] = {.lex_state = 240},
  [7159] = {.lex_state = 240},
  [7160] = {.lex_state = 388},
  [7161] = {.lex_state = 108},
  [7162] = {.lex_state = 205},
  [7163] = {.lex_state = 388},
  [7164] = {.lex_state = 111},
  [7165] = {.lex_state = 231},
  [7166] = {.lex_state = 231},
  [7167] = {.lex_state = 231},
  [7168] = {.lex_state = 108},
  [7169] = {.lex_state = 285},
  [7170] = {.lex_state = 110},
  [7171] = {.lex_state = 388},
  [7172] = {.lex_state = 108},
  [7173] = {.lex_state = 388},
  [7174] = {.lex_state = 108},
  [7175] = {.lex_state = 205},
  [7176] = {.lex_state = 110},
  [7177] = {.lex_state = 285},
  [7178] = {.lex_state = 388},
  [7179] = {.lex_state = 240},
  [7180] = {.lex_state = 108},
  [7181] = {.lex_state = 388},
  [7182] = {.lex_state = 388},
  [7183] = {.lex_state = 388},
  [7184] = {.lex_state = 388},
  [7185] = {.lex_state = 108},
  [7186] = {.lex_state = 110},
  [7187] = {.lex_state = 388},
  [7188] = {.lex_state = 108},
  [7189] = {.lex_state = 110},
  [7190] = {.lex_state = 388},
  [7191] = {.lex_state = 108},
  [7192] = {.lex_state = 205},
  [7193] = {.lex_state = 240},
  [7194] = {.lex_state = 231},
  [7195] = {.lex_state = 108},
  [7196] = {.lex_state = 388},
  [7197] = {.lex_state = 205},
  [7198] = {.lex_state = 110},
  [7199] = {.lex_state = 205},
  [7200] = {.lex_state = 388},
  [7201] = {.lex_state = 240},
  [7202] = {.lex_state = 240},
  [7203] = {.lex_state = 108},
  [7204] = {.lex_state = 205},
  [7205] = {.lex_state = 108},
  [7206] = {.lex_state = 110},
  [7207] = {.lex_state = 240},
  [7208] = {.lex_state = 240},
  [7209] = {.lex_state = 111},
  [7210] = {.lex_state = 240},
  [7211] = {.lex_state = 108},
  [7212] = {.lex_state = 240},
  [7213] = {.lex_state = 108},
  [7214] = {.lex_state = 388},
  [7215] = {.lex_state = 108},
  [7216] = {.lex_state = 388},
  [7217] = {.lex_state = 110},
  [7218] = {.lex_state = 231},
  [7219] = {.lex_state = 285},
  [7220] = {.lex_state = 388},
  [7221] = {.lex_state = 231},
  [7222] = {.lex_state = 231},
  [7223] = {.lex_state = 388},
  [7224] = {.lex_state = 240},
  [7225] = {.lex_state = 231},
  [7226] = {.lex_state = 240},
  [7227] = {.lex_state = 231},
  [7228] = {.lex_state = 240},
  [7229] = {.lex_state = 231},
  [7230] = {.lex_state = 110},
  [7231] = {.lex_state = 205},
  [7232] = {.lex_state = 231},
  [7233] = {.lex_state = 108},
  [7234] = {.lex_state = 205},
  [7235] = {.lex_state = 111},
  [7236] = {.lex_state = 205},
  [7237] = {.lex_state = 240},
  [7238] = {.lex_state = 108},
  [7239] = {.lex_state = 231},
  [7240] = {.lex_state = 205},
  [7241] = {.lex_state = 388},
  [7242] = {.lex_state = 388},
  [7243] = {.lex_state = 111},
  [7244] = {.lex_state = 240},
  [7245] = {.lex_state = 205},
  [7246] = {.lex_state = 205},
  [7247] = {.lex_state = 205},
  [7248] = {.lex_state = 388},
  [7249] = {.lex_state = 231},
  [7250] = {.lex_state = 0},
  [7251] = {.lex_state = 388},
  [7252] = {.lex_state = 231},
  [7253] = {.lex_state = 231},
  [7254] = {.lex_state = 108},
  [7255] = {.lex_state = 231},
  [7256] = {.lex_state = 0},
  [7257] = {.lex_state = 285},
  [7258] = {.lex_state = 108},
  [7259] = {.lex_state = 231},
  [7260] = {.lex_state = 110},
  [7261] = {.lex_state = 240},
  [7262] = {.lex_state = 240},
  [7263] = {.lex_state = 240},
  [7264] = {.lex_state = 110},
  [7265] = {.lex_state = 108},
  [7266] = {.lex_state = 388},
  [7267] = {.lex_state = 240},
  [7268] = {.lex_state = 108},
  [7269] = {.lex_state = 388},
  [7270] = {.lex_state = 240},
  [7271] = {.lex_state = 108},
  [7272] = {.lex_state = 388},
  [7273] = {.lex_state = 240},
  [7274] = {.lex_state = 205},
  [7275] = {.lex_state = 388},
  [7276] = {.lex_state = 285},
  [7277] = {.lex_state = 205},
  [7278] = {.lex_state = 231},
  [7279] = {.lex_state = 388},
  [7280] = {.lex_state = 388},
  [7281] = {.lex_state = 231},
  [7282] = {.lex_state = 388},
  [7283] = {.lex_state = 231},
  [7284] = {.lex_state = 231},
  [7285] = {.lex_state = 205},
  [7286] = {.lex_state = 240},
  [7287] = {.lex_state = 205},
  [7288] = {.lex_state = 205},
  [7289] = {.lex_state = 388},
  [7290] = {.lex_state = 388},
  [7291] = {.lex_state = 231},
  [7292] = {.lex_state = 240},
  [7293] = {.lex_state = 388},
  [7294] = {.lex_state = 231},
  [7295] = {.lex_state = 205},
  [7296] = {.lex_state = 240},
  [7297] = {.lex_state = 205},
  [7298] = {.lex_state = 205},
  [7299] = {.lex_state = 388},
  [7300] = {.lex_state = 205},
  [7301] = {.lex_state = 388},
  [7302] = {.lex_state = 388},
  [7303] = {.lex_state = 388},
  [7304] = {.lex_state = 205},
  [7305] = {.lex_state = 231},
  [7306] = {.lex_state = 108},
  [7307] = {.lex_state = 205},
  [7308] = {.lex_state = 110},
  [7309] = {.lex_state = 240},
  [7310] = {.lex_state = 231},
  [7311] = {.lex_state = 285},
  [7312] = {.lex_state = 388},
  [7313] = {.lex_state = 388},
  [7314] = {.lex_state = 205},
  [7315] = {.lex_state = 205},
  [7316] = {.lex_state = 231},
  [7317] = {.lex_state = 231},
  [7318] = {.lex_state = 231},
  [7319] = {.lex_state = 0},
  [7320] = {.lex_state = 388},
  [7321] = {.lex_state = 205},
  [7322] = {.lex_state = 108},
  [7323] = {.lex_state = 388},
  [7324] = {.lex_state = 231},
  [7325] = {.lex_state = 388},
  [7326] = {.lex_state = 285},
  [7327] = {.lex_state = 388},
  [7328] = {.lex_state = 285},
  [7329] = {.lex_state = 388},
  [7330] = {.lex_state = 388},
  [7331] = {.lex_state = 388},
  [7332] = {.lex_state = 240},
  [7333] = {.lex_state = 231},
  [7334] = {.lex_state = 205},
  [7335] = {.lex_state = 231},
  [7336] = {.lex_state = 231},
  [7337] = {.lex_state = 205},
  [7338] = {.lex_state = 231},
  [7339] = {.lex_state = 388},
  [7340] = {.lex_state = 205},
  [7341] = {.lex_state = 240},
  [7342] = {.lex_state = 110},
  [7343] = {.lex_state = 108},
  [7344] = {.lex_state = 108},
  [7345] = {.lex_state = 388},
  [7346] = {.lex_state = 285},
  [7347] = {.lex_state = 240},
  [7348] = {.lex_state = 240},
  [7349] = {.lex_state = 240},
  [7350] = {.lex_state = 111},
  [7351] = {.lex_state = 388},
  [7352] = {.lex_state = 240},
  [7353] = {.lex_state = 231},
  [7354] = {.lex_state = 388},
  [7355] = {.lex_state = 388},
  [7356] = {.lex_state = 231},
  [7357] = {.lex_state = 240},
  [7358] = {.lex_state = 240},
  [7359] = {.lex_state = 388},
  [7360] = {.lex_state = 231},
  [7361] = {.lex_state = 108},
  [7362] = {.lex_state = 240},
  [7363] = {.lex_state = 251},
  [7364] = {.lex_state = 205},
  [7365] = {.lex_state = 110},
  [7366] = {.lex_state = 205},
  [7367] = {.lex_state = 240},
  [7368] = {.lex_state = 240},
  [7369] = {.lex_state = 240},
  [7370] = {.lex_state = 0},
  [7371] = {.lex_state = 0},
  [7372] = {.lex_state = 240},
  [7373] = {.lex_state = 240},
  [7374] = {.lex_state = 0},
  [7375] = {.lex_state = 240},
  [7376] = {.lex_state = 240},
  [7377] = {.lex_state = 0},
  [7378] = {.lex_state = 240},
  [7379] = {.lex_state = 240},
  [7380] = {.lex_state = 0},
  [7381] = {.lex_state = 240},
  [7382] = {.lex_state = 0},
  [7383] = {.lex_state = 231},
  [7384] = {.lex_state = 231},
  [7385] = {.lex_state = 0},
  [7386] = {.lex_state = 231},
  [7387] = {.lex_state = 0},
  [7388] = {.lex_state = 0},
  [7389] = {.lex_state = 0},
  [7390] = {.lex_state = 0},
  [7391] = {.lex_state = 0},
  [7392] = {.lex_state = 0},
  [7393] = {.lex_state = 0},
  [7394] = {.lex_state = 0},
  [7395] = {.lex_state = 231},
  [7396] = {.lex_state = 0},
  [7397] = {.lex_state = 0},
  [7398] = {.lex_state = 110},
  [7399] = {.lex_state = 388},
  [7400] = {.lex_state = 0},
  [7401] = {.lex_state = 231},
  [7402] = {.lex_state = 0},
  [7403] = {.lex_state = 0},
  [7404] = {.lex_state = 388},
  [7405] = {.lex_state = 240},
  [7406] = {.lex_state = 240},
  [7407] = {.lex_state = 388},
  [7408] = {.lex_state = 231},
  [7409] = {.lex_state = 388},
  [7410] = {.lex_state = 388},
  [7411] = {.lex_state = 388},
  [7412] = {.lex_state = 388},
  [7413] = {.lex_state = 240},
  [7414] = {.lex_state = 0},
  [7415] = {.lex_state = 0},
  [7416] = {.lex_state = 231},
  [7417] = {.lex_state = 0},
  [7418] = {.lex_state = 240},
  [7419] = {.lex_state = 0},
  [7420] = {.lex_state = 0},
  [7421] = {.lex_state = 240},
  [7422] = {.lex_state = 240},
  [7423] = {.lex_state = 0},
  [7424] = {.lex_state = 388},
  [7425] = {.lex_state = 0},
  [7426] = {.lex_state = 0},
  [7427] = {.lex_state = 231},
  [7428] = {.lex_state = 231},
  [7429] = {.lex_state = 0},
  [7430] = {.lex_state = 0},
  [7431] = {.lex_state = 0},
  [7432] = {.lex_state = 240},
  [7433] = {.lex_state = 240},
  [7434] = {.lex_state = 0},
  [7435] = {.lex_state = 0},
  [7436] = {.lex_state = 0},
  [7437] = {.lex_state = 0},
  [7438] = {.lex_state = 240},
  [7439] = {.lex_state = 240},
  [7440] = {.lex_state = 240},
  [7441] = {.lex_state = 240},
  [7442] = {.lex_state = 240},
  [7443] = {.lex_state = 388},
  [7444] = {.lex_state = 388},
  [7445] = {.lex_state = 388},
  [7446] = {.lex_state = 240},
  [7447] = {.lex_state = 240},
  [7448] = {.lex_state = 0},
  [7449] = {.lex_state = 0},
  [7450] = {.lex_state = 0},
  [7451] = {.lex_state = 240},
  [7452] = {.lex_state = 240},
  [7453] = {.lex_state = 240},
  [7454] = {.lex_state = 240},
  [7455] = {.lex_state = 240},
  [7456] = {.lex_state = 0},
  [7457] = {.lex_state = 0},
  [7458] = {.lex_state = 240},
  [7459] = {.lex_state = 240},
  [7460] = {.lex_state = 0},
  [7461] = {.lex_state = 240},
  [7462] = {.lex_state = 240},
  [7463] = {.lex_state = 231},
  [7464] = {.lex_state = 388},
  [7465] = {.lex_state = 201},
  [7466] = {.lex_state = 388},
  [7467] = {.lex_state = 388},
  [7468] = {.lex_state = 388},
  [7469] = {.lex_state = 388},
  [7470] = {.lex_state = 240},
  [7471] = {.lex_state = 240},
  [7472] = {.lex_state = 0},
  [7473] = {.lex_state = 240},
  [7474] = {.lex_state = 0},
  [7475] = {.lex_state = 0},
  [7476] = {.lex_state = 0},
  [7477] = {.lex_state = 0},
  [7478] = {.lex_state = 0},
  [7479] = {.lex_state = 0},
  [7480] = {.lex_state = 231},
  [7481] = {.lex_state = 388},
  [7482] = {.lex_state = 0},
  [7483] = {.lex_state = 240},
  [7484] = {.lex_state = 0},
  [7485] = {.lex_state = 231},
  [7486] = {.lex_state = 0},
  [7487] = {.lex_state = 0},
  [7488] = {.lex_state = 0},
  [7489] = {.lex_state = 231},
  [7490] = {.lex_state = 0},
  [7491] = {.lex_state = 0},
  [7492] = {.lex_state = 0},
  [7493] = {.lex_state = 113},
  [7494] = {.lex_state = 0},
  [7495] = {.lex_state = 0},
  [7496] = {.lex_state = 0},
  [7497] = {.lex_state = 110},
  [7498] = {.lex_state = 0},
  [7499] = {.lex_state = 0},
  [7500] = {.lex_state = 388},
  [7501] = {.lex_state = 0},
  [7502] = {.lex_state = 0},
  [7503] = {.lex_state = 240},
  [7504] = {.lex_state = 231},
  [7505] = {.lex_state = 231},
  [7506] = {.lex_state = 0},
  [7507] = {.lex_state = 0},
  [7508] = {.lex_state = 0},
  [7509] = {.lex_state = 240},
  [7510] = {.lex_state = 388},
  [7511] = {.lex_state = 0},
  [7512] = {.lex_state = 0},
  [7513] = {.lex_state = 231},
  [7514] = {.lex_state = 0},
  [7515] = {.lex_state = 0},
  [7516] = {.lex_state = 388},
  [7517] = {.lex_state = 231},
  [7518] = {.lex_state = 240},
  [7519] = {.lex_state = 110},
  [7520] = {.lex_state = 0},
  [7521] = {.lex_state = 388},
  [7522] = {.lex_state = 388},
  [7523] = {.lex_state = 0},
  [7524] = {.lex_state = 388},
  [7525] = {.lex_state = 388},
  [7526] = {.lex_state = 0},
  [7527] = {.lex_state = 388},
  [7528] = {.lex_state = 240},
  [7529] = {.lex_state = 388},
  [7530] = {.lex_state = 0},
  [7531] = {.lex_state = 0},
  [7532] = {.lex_state = 231},
  [7533] = {.lex_state = 231},
  [7534] = {.lex_state = 388},
  [7535] = {.lex_state = 388},
  [7536] = {.lex_state = 388},
  [7537] = {.lex_state = 240},
  [7538] = {.lex_state = 0},
  [7539] = {.lex_state = 388},
  [7540] = {.lex_state = 388},
  [7541] = {.lex_state = 0},
  [7542] = {.lex_state = 0},
  [7543] = {.lex_state = 388},
  [7544] = {.lex_state = 231},
  [7545] = {.lex_state = 231},
  [7546] = {.lex_state = 388},
  [7547] = {.lex_state = 388},
  [7548] = {.lex_state = 0},
  [7549] = {.lex_state = 231},
  [7550] = {.lex_state = 0},
  [7551] = {.lex_state = 240},
  [7552] = {.lex_state = 388},
  [7553] = {.lex_state = 388},
  [7554] = {.lex_state = 0},
  [7555] = {.lex_state = 240},
  [7556] = {.lex_state = 0},
  [7557] = {.lex_state = 240},
  [7558] = {.lex_state = 240},
  [7559] = {.lex_state = 0},
  [7560] = {.lex_state = 0},
  [7561] = {.lex_state = 388},
  [7562] = {.lex_state = 388},
  [7563] = {.lex_state = 0},
  [7564] = {.lex_state = 0},
  [7565] = {.lex_state = 231},
  [7566] = {.lex_state = 388},
  [7567] = {.lex_state = 113},
  [7568] = {.lex_state = 240},
  [7569] = {.lex_state = 240},
  [7570] = {.lex_state = 0},
  [7571] = {.lex_state = 240},
  [7572] = {.lex_state = 0},
  [7573] = {.lex_state = 388},
  [7574] = {.lex_state = 388},
  [7575] = {.lex_state = 240},
  [7576] = {.lex_state = 251},
  [7577] = {.lex_state = 231},
  [7578] = {.lex_state = 388},
  [7579] = {.lex_state = 388},
  [7580] = {.lex_state = 231},
  [7581] = {.lex_state = 240},
  [7582] = {.lex_state = 0},
  [7583] = {.lex_state = 388},
  [7584] = {.lex_state = 0},
  [7585] = {.lex_state = 201},
  [7586] = {.lex_state = 110},
  [7587] = {.lex_state = 0},
  [7588] = {.lex_state = 0},
  [7589] = {.lex_state = 231},
  [7590] = {.lex_state = 0},
  [7591] = {.lex_state = 388},
  [7592] = {.lex_state = 231},
  [7593] = {.lex_state = 0},
  [7594] = {.lex_state = 0},
  [7595] = {.lex_state = 0},
  [7596] = {.lex_state = 388},
  [7597] = {.lex_state = 231},
  [7598] = {.lex_state = 0},
  [7599] = {.lex_state = 231},
  [7600] = {.lex_state = 388},
  [7601] = {.lex_state = 0},
  [7602] = {.lex_state = 388},
  [7603] = {.lex_state = 388},
  [7604] = {.lex_state = 388},
  [7605] = {.lex_state = 0},
  [7606] = {.lex_state = 388},
  [7607] = {.lex_state = 0},
  [7608] = {.lex_state = 0},
  [7609] = {.lex_state = 0},
  [7610] = {.lex_state = 0},
  [7611] = {.lex_state = 0},
  [7612] = {.lex_state = 0},
  [7613] = {.lex_state = 0},
  [7614] = {.lex_state = 0},
  [7615] = {.lex_state = 231},
  [7616] = {.lex_state = 0},
  [7617] = {.lex_state = 231},
  [7618] = {.lex_state = 240},
  [7619] = {.lex_state = 0},
  [7620] = {.lex_state = 240},
  [7621] = {.lex_state = 205},
  [7622] = {.lex_state = 0},
  [7623] = {.lex_state = 388},
  [7624] = {.lex_state = 388},
  [7625] = {.lex_state = 231},
  [7626] = {.lex_state = 388},
  [7627] = {.lex_state = 388},
  [7628] = {.lex_state = 0},
  [7629] = {.lex_state = 231},
  [7630] = {.lex_state = 0},
  [7631] = {.lex_state = 240},
  [7632] = {.lex_state = 110},
  [7633] = {.lex_state = 0},
  [7634] = {.lex_state = 240},
  [7635] = {.lex_state = 0},
  [7636] = {.lex_state = 0},
  [7637] = {.lex_state = 0},
  [7638] = {.lex_state = 231},
  [7639] = {.lex_state = 231},
  [7640] = {.lex_state = 0},
  [7641] = {.lex_state = 240},
  [7642] = {.lex_state = 231},
  [7643] = {.lex_state = 240},
  [7644] = {.lex_state = 0},
  [7645] = {.lex_state = 240},
  [7646] = {.lex_state = 240},
  [7647] = {.lex_state = 231},
  [7648] = {.lex_state = 0},
  [7649] = {.lex_state = 0},
  [7650] = {.lex_state = 388},
  [7651] = {.lex_state = 286},
  [7652] = {.lex_state = 388},
  [7653] = {.lex_state = 240},
  [7654] = {.lex_state = 240},
  [7655] = {.lex_state = 240},
  [7656] = {.lex_state = 240},
  [7657] = {.lex_state = 240},
  [7658] = {.lex_state = 388},
  [7659] = {.lex_state = 388},
  [7660] = {.lex_state = 388},
  [7661] = {.lex_state = 240},
  [7662] = {.lex_state = 0},
  [7663] = {.lex_state = 0},
  [7664] = {.lex_state = 231},
  [7665] = {.lex_state = 0},
  [7666] = {.lex_state = 240},
  [7667] = {.lex_state = 388},
  [7668] = {.lex_state = 0},
  [7669] = {.lex_state = 388},
  [7670] = {.lex_state = 240},
  [7671] = {.lex_state = 240},
  [7672] = {.lex_state = 231},
  [7673] = {.lex_state = 0},
  [7674] = {.lex_state = 0},
  [7675] = {.lex_state = 0},
  [7676] = {.lex_state = 240},
  [7677] = {.lex_state = 240},
  [7678] = {.lex_state = 231},
  [7679] = {.lex_state = 0},
  [7680] = {.lex_state = 240},
  [7681] = {.lex_state = 240},
  [7682] = {.lex_state = 388},
  [7683] = {.lex_state = 388},
  [7684] = {.lex_state = 388},
  [7685] = {.lex_state = 388},
  [7686] = {.lex_state = 0},
  [7687] = {.lex_state = 0},
  [7688] = {.lex_state = 231},
  [7689] = {.lex_state = 388},
  [7690] = {.lex_state = 240},
  [7691] = {.lex_state = 231},
  [7692] = {.lex_state = 388},
  [7693] = {.lex_state = 388},
  [7694] = {.lex_state = 388},
  [7695] = {.lex_state = 388},
  [7696] = {.lex_state = 240},
  [7697] = {.lex_state = 240},
  [7698] = {.lex_state = 0},
  [7699] = {.lex_state = 0},
  [7700] = {.lex_state = 0},
  [7701] = {.lex_state = 231},
  [7702] = {.lex_state = 231},
  [7703] = {.lex_state = 388},
  [7704] = {.lex_state = 240},
  [7705] = {.lex_state = 388},
  [7706] = {.lex_state = 388},
  [7707] = {.lex_state = 388},
  [7708] = {.lex_state = 388},
  [7709] = {.lex_state = 240},
  [7710] = {.lex_state = 231},
  [7711] = {.lex_state = 388},
  [7712] = {.lex_state = 388},
  [7713] = {.lex_state = 0},
  [7714] = {.lex_state = 0},
  [7715] = {.lex_state = 240},
  [7716] = {.lex_state = 0},
  [7717] = {.lex_state = 231},
  [7718] = {.lex_state = 240},
  [7719] = {.lex_state = 0},
  [7720] = {.lex_state = 110},
  [7721] = {.lex_state = 0},
  [7722] = {.lex_state = 0},
  [7723] = {.lex_state = 231},
  [7724] = {.lex_state = 0},
  [7725] = {.lex_state = 205},
  [7726] = {.lex_state = 388},
  [7727] = {.lex_state = 388},
  [7728] = {.lex_state = 388},
  [7729] = {.lex_state = 388},
  [7730] = {.lex_state = 388},
  [7731] = {.lex_state = 0},
  [7732] = {.lex_state = 0},
  [7733] = {.lex_state = 231},
  [7734] = {.lex_state = 0},
  [7735] = {.lex_state = 0},
  [7736] = {.lex_state = 388},
  [7737] = {.lex_state = 0},
  [7738] = {.lex_state = 0},
  [7739] = {.lex_state = 231},
  [7740] = {.lex_state = 0},
  [7741] = {.lex_state = 0},
  [7742] = {.lex_state = 0},
  [7743] = {.lex_state = 231},
  [7744] = {.lex_state = 231},
  [7745] = {.lex_state = 0},
  [7746] = {.lex_state = 0},
  [7747] = {.lex_state = 0},
  [7748] = {.lex_state = 388},
  [7749] = {.lex_state = 388},
  [7750] = {.lex_state = 388},
  [7751] = {.lex_state = 388},
  [7752] = {.lex_state = 231},
  [7753] = {.lex_state = 0},
  [7754] = {.lex_state = 0},
  [7755] = {.lex_state = 388},
  [7756] = {.lex_state = 113},
  [7757] = {.lex_state = 0},
  [7758] = {.lex_state = 231},
  [7759] = {.lex_state = 0},
  [7760] = {.lex_state = 388},
  [7761] = {.lex_state = 0},
  [7762] = {.lex_state = 388},
  [7763] = {.lex_state = 240},
  [7764] = {.lex_state = 0},
  [7765] = {.lex_state = 231},
  [7766] = {.lex_state = 231},
  [7767] = {.lex_state = 113},
  [7768] = {.lex_state = 388},
  [7769] = {.lex_state = 388},
  [7770] = {.lex_state = 388},
  [7771] = {.lex_state = 388},
  [7772] = {.lex_state = 388},
  [7773] = {.lex_state = 205},
  [7774] = {.lex_state = 110},
  [7775] = {.lex_state = 231},
  [7776] = {.lex_state = 231},
  [7777] = {.lex_state = 388},
  [7778] = {.lex_state = 0},
  [7779] = {.lex_state = 0},
  [7780] = {.lex_state = 388},
  [7781] = {.lex_state = 110},
  [7782] = {.lex_state = 110},
  [7783] = {.lex_state = 0},
  [7784] = {.lex_state = 0},
  [7785] = {.lex_state = 231},
  [7786] = {.lex_state = 388},
  [7787] = {.lex_state = 110},
  [7788] = {.lex_state = 388},
  [7789] = {.lex_state = 388},
  [7790] = {.lex_state = 388},
  [7791] = {.lex_state = 388},
  [7792] = {.lex_state = 388},
  [7793] = {.lex_state = 110},
  [7794] = {.lex_state = 240},
  [7795] = {.lex_state = 110},
  [7796] = {.lex_state = 0},
  [7797] = {.lex_state = 240},
  [7798] = {.lex_state = 0},
  [7799] = {.lex_state = 388},
  [7800] = {.lex_state = 110},
  [7801] = {.lex_state = 0},
  [7802] = {.lex_state = 0},
  [7803] = {.lex_state = 231},
  [7804] = {.lex_state = 231},
  [7805] = {.lex_state = 231},
  [7806] = {.lex_state = 0},
  [7807] = {.lex_state = 231},
  [7808] = {.lex_state = 388},
  [7809] = {.lex_state = 388},
  [7810] = {.lex_state = 388},
  [7811] = {.lex_state = 388},
  [7812] = {.lex_state = 0},
  [7813] = {.lex_state = 0},
  [7814] = {.lex_state = 231},
  [7815] = {.lex_state = 110},
  [7816] = {.lex_state = 0},
  [7817] = {.lex_state = 388},
  [7818] = {.lex_state = 388},
  [7819] = {.lex_state = 0},
  [7820] = {.lex_state = 0},
  [7821] = {.lex_state = 0},
  [7822] = {.lex_state = 388},
  [7823] = {.lex_state = 0},
  [7824] = {.lex_state = 231},
  [7825] = {.lex_state = 0},
  [7826] = {.lex_state = 388},
  [7827] = {.lex_state = 112},
  [7828] = {.lex_state = 388},
  [7829] = {.lex_state = 388},
  [7830] = {.lex_state = 0},
  [7831] = {.lex_state = 231},
  [7832] = {.lex_state = 388},
  [7833] = {.lex_state = 388},
  [7834] = {.lex_state = 0},
  [7835] = {.lex_state = 388},
  [7836] = {.lex_state = 388},
  [7837] = {.lex_state = 0},
  [7838] = {.lex_state = 388},
  [7839] = {.lex_state = 231},
  [7840] = {.lex_state = 0},
  [7841] = {.lex_state = 0},
  [7842] = {.lex_state = 0},
  [7843] = {.lex_state = 231},
  [7844] = {.lex_state = 0},
  [7845] = {.lex_state = 0},
  [7846] = {.lex_state = 388},
  [7847] = {.lex_state = 0},
  [7848] = {.lex_state = 388},
  [7849] = {.lex_state = 0},
  [7850] = {.lex_state = 0},
  [7851] = {.lex_state = 231},
  [7852] = {.lex_state = 0},
  [7853] = {.lex_state = 0},
  [7854] = {.lex_state = 0},
  [7855] = {.lex_state = 0},
  [7856] = {.lex_state = 231},
  [7857] = {.lex_state = 112},
  [7858] = {.lex_state = 388},
  [7859] = {.lex_state = 231},
  [7860] = {.lex_state = 388},
  [7861] = {.lex_state = 0},
  [7862] = {.lex_state = 112},
  [7863] = {.lex_state = 231},
  [7864] = {.lex_state = 0},
  [7865] = {.lex_state = 0},
  [7866] = {.lex_state = 388},
  [7867] = {.lex_state = 112},
  [7868] = {.lex_state = 0},
  [7869] = {.lex_state = 388},
  [7870] = {.lex_state = 0},
  [7871] = {.lex_state = 231},
  [7872] = {.lex_state = 388},
  [7873] = {.lex_state = 0},
  [7874] = {.lex_state = 388},
  [7875] = {.lex_state = 388},
  [7876] = {.lex_state = 0},
  [7877] = {.lex_state = 388},
  [7878] = {.lex_state = 0},
  [7879] = {.lex_state = 0},
  [7880] = {.lex_state = 0},
  [7881] = {.lex_state = 0},
  [7882] = {.lex_state = 0},
  [7883] = {.lex_state = 231},
  [7884] = {.lex_state = 0},
  [7885] = {.lex_state = 388},
  [7886] = {.lex_state = 388},
  [7887] = {.lex_state = 0},
  [7888] = {.lex_state = 388},
  [7889] = {.lex_state = 0},
  [7890] = {.lex_state = 112},
  [7891] = {.lex_state = 0},
  [7892] = {.lex_state = 0},
  [7893] = {.lex_state = 388},
  [7894] = {.lex_state = 0},
  [7895] = {.lex_state = 0},
  [7896] = {.lex_state = 388},
  [7897] = {.lex_state = 0},
  [7898] = {.lex_state = 0},
  [7899] = {.lex_state = 388},
  [7900] = {.lex_state = 388},
  [7901] = {.lex_state = 231},
  [7902] = {.lex_state = 0},
  [7903] = {.lex_state = 0},
  [7904] = {.lex_state = 0},
  [7905] = {.lex_state = 388},
  [7906] = {.lex_state = 0},
  [7907] = {.lex_state = 0},
  [7908] = {.lex_state = 0},
  [7909] = {.lex_state = 0},
  [7910] = {.lex_state = 388},
  [7911] = {.lex_state = 0},
  [7912] = {.lex_state = 0},
  [7913] = {.lex_state = 0},
  [7914] = {.lex_state = 231},
  [7915] = {.lex_state = 0},
  [7916] = {.lex_state = 388},
  [7917] = {.lex_state = 112},
  [7918] = {.lex_state = 0},
  [7919] = {.lex_state = 0},
  [7920] = {.lex_state = 388},
  [7921] = {.lex_state = 0},
  [7922] = {.lex_state = 0},
  [7923] = {.lex_state = 0},
  [7924] = {.lex_state = 0},
  [7925] = {.lex_state = 0},
  [7926] = {.lex_state = 388},
  [7927] = {.lex_state = 0},
  [7928] = {.lex_state = 388},
  [7929] = {.lex_state = 388},
  [7930] = {.lex_state = 0},
  [7931] = {.lex_state = 0},
  [7932] = {.lex_state = 0},
  [7933] = {.lex_state = 231},
  [7934] = {.lex_state = 0},
  [7935] = {.lex_state = 0},
  [7936] = {.lex_state = 0},
  [7937] = {.lex_state = 0},
  [7938] = {.lex_state = 0},
  [7939] = {.lex_state = 231},
  [7940] = {.lex_state = 0},
  [7941] = {.lex_state = 388},
  [7942] = {.lex_state = 0},
  [7943] = {.lex_state = 0},
  [7944] = {.lex_state = 388},
  [7945] = {.lex_state = 0},
  [7946] = {.lex_state = 0},
  [7947] = {.lex_state = 388},
  [7948] = {.lex_state = 0},
  [7949] = {.lex_state = 388},
  [7950] = {.lex_state = 388},
  [7951] = {.lex_state = 0},
  [7952] = {.lex_state = 0},
  [7953] = {.lex_state = 0},
  [7954] = {.lex_state = 0},
  [7955] = {.lex_state = 0},
  [7956] = {.lex_state = 0},
  [7957] = {.lex_state = 388},
  [7958] = {.lex_state = 0},
  [7959] = {.lex_state = 388},
  [7960] = {.lex_state = 388},
  [7961] = {.lex_state = 0},
  [7962] = {.lex_state = 0},
  [7963] = {.lex_state = 0},
  [7964] = {.lex_state = 0},
  [7965] = {.lex_state = 0},
  [7966] = {.lex_state = 0},
  [7967] = {.lex_state = 0},
  [7968] = {.lex_state = 388},
  [7969] = {.lex_state = 0},
  [7970] = {.lex_state = 0},
  [7971] = {.lex_state = 0},
  [7972] = {.lex_state = 388},
  [7973] = {.lex_state = 388},
  [7974] = {.lex_state = 0},
  [7975] = {.lex_state = 112},
  [7976] = {.lex_state = 388},
  [7977] = {.lex_state = 0},
  [7978] = {.lex_state = 0},
  [7979] = {.lex_state = 0},
  [7980] = {.lex_state = 0},
  [7981] = {.lex_state = 231},
  [7982] = {.lex_state = 0},
  [7983] = {.lex_state = 0},
  [7984] = {.lex_state = 0},
  [7985] = {.lex_state = 0},
  [7986] = {.lex_state = 388},
  [7987] = {.lex_state = 388},
  [7988] = {.lex_state = 231},
  [7989] = {.lex_state = 0},
  [7990] = {.lex_state = 0},
  [7991] = {.lex_state = 388},
  [7992] = {.lex_state = 0},
  [7993] = {.lex_state = 388},
  [7994] = {.lex_state = 231},
  [7995] = {.lex_state = 0},
  [7996] = {.lex_state = 0},
  [7997] = {.lex_state = 0},
  [7998] = {.lex_state = 388},
  [7999] = {.lex_state = 0},
  [8000] = {.lex_state = 388},
  [8001] = {.lex_state = 0},
  [8002] = {.lex_state = 0},
  [8003] = {.lex_state = 388},
  [8004] = {.lex_state = 388},
  [8005] = {.lex_state = 0},
  [8006] = {.lex_state = 0},
  [8007] = {.lex_state = 0},
  [8008] = {.lex_state = 0},
  [8009] = {.lex_state = 231},
  [8010] = {.lex_state = 0},
  [8011] = {.lex_state = 0},
  [8012] = {.lex_state = 388},
  [8013] = {.lex_state = 0},
  [8014] = {.lex_state = 0},
  [8015] = {.lex_state = 0},
  [8016] = {.lex_state = 0},
  [8017] = {.lex_state = 231},
  [8018] = {.lex_state = 388, .external_lex_state = 2},
  [8019] = {.lex_state = 388},
  [8020] = {.lex_state = 0},
  [8021] = {.lex_state = 112},
  [8022] = {.lex_state = 0},
  [8023] = {.lex_state = 388},
  [8024] = {.lex_state = 388},
  [8025] = {.lex_state = 388},
  [8026] = {.lex_state = 388},
  [8027] = {.lex_state = 231},
  [8028] = {.lex_state = 231},
  [8029] = {.lex_state = 231},
  [8030] = {.lex_state = 0},
  [8031] = {.lex_state = 231},
  [8032] = {.lex_state = 388},
  [8033] = {.lex_state = 231},
  [8034] = {.lex_state = 0},
  [8035] = {.lex_state = 388},
  [8036] = {.lex_state = 231},
  [8037] = {.lex_state = 112},
  [8038] = {.lex_state = 231},
  [8039] = {.lex_state = 388},
  [8040] = {.lex_state = 0},
  [8041] = {.lex_state = 0},
  [8042] = {.lex_state = 388},
  [8043] = {.lex_state = 0},
  [8044] = {.lex_state = 0},
  [8045] = {.lex_state = 112},
  [8046] = {.lex_state = 0},
  [8047] = {.lex_state = 0},
  [8048] = {.lex_state = 0},
  [8049] = {.lex_state = 231},
  [8050] = {.lex_state = 231},
  [8051] = {.lex_state = 388},
  [8052] = {.lex_state = 388},
  [8053] = {.lex_state = 231},
  [8054] = {.lex_state = 112},
  [8055] = {.lex_state = 0},
  [8056] = {.lex_state = 0},
  [8057] = {.lex_state = 0},
  [8058] = {.lex_state = 388},
  [8059] = {.lex_state = 0},
  [8060] = {.lex_state = 0},
  [8061] = {.lex_state = 0},
  [8062] = {.lex_state = 231},
  [8063] = {.lex_state = 0},
  [8064] = {.lex_state = 0},
  [8065] = {.lex_state = 388},
  [8066] = {.lex_state = 0},
  [8067] = {.lex_state = 0},
  [8068] = {.lex_state = 0},
  [8069] = {.lex_state = 388},
  [8070] = {.lex_state = 388},
  [8071] = {.lex_state = 0},
  [8072] = {.lex_state = 0},
  [8073] = {.lex_state = 231},
  [8074] = {.lex_state = 0},
  [8075] = {.lex_state = 0},
  [8076] = {.lex_state = 231},
  [8077] = {.lex_state = 0},
  [8078] = {.lex_state = 388},
  [8079] = {.lex_state = 231},
  [8080] = {.lex_state = 231},
  [8081] = {.lex_state = 0},
  [8082] = {.lex_state = 0},
  [8083] = {.lex_state = 0},
  [8084] = {.lex_state = 0},
  [8085] = {.lex_state = 112},
  [8086] = {.lex_state = 0},
  [8087] = {.lex_state = 388},
  [8088] = {.lex_state = 388},
  [8089] = {.lex_state = 0},
  [8090] = {.lex_state = 0},
  [8091] = {.lex_state = 0},
  [8092] = {.lex_state = 112},
  [8093] = {.lex_state = 388},
  [8094] = {.lex_state = 0},
  [8095] = {.lex_state = 231},
  [8096] = {.lex_state = 0},
  [8097] = {.lex_state = 0},
  [8098] = {.lex_state = 388, .external_lex_state = 2},
  [8099] = {.lex_state = 0},
  [8100] = {.lex_state = 0},
  [8101] = {.lex_state = 231},
  [8102] = {.lex_state = 0},
  [8103] = {.lex_state = 0},
  [8104] = {.lex_state = 0},
  [8105] = {.lex_state = 388},
  [8106] = {.lex_state = 0},
  [8107] = {.lex_state = 0},
  [8108] = {.lex_state = 0},
  [8109] = {.lex_state = 0},
  [8110] = {.lex_state = 0},
  [8111] = {.lex_state = 0},
  [8112] = {.lex_state = 0},
  [8113] = {.lex_state = 112},
  [8114] = {.lex_state = 0},
  [8115] = {.lex_state = 0},
  [8116] = {.lex_state = 231},
  [8117] = {.lex_state = 388},
  [8118] = {.lex_state = 0},
  [8119] = {.lex_state = 0},
  [8120] = {.lex_state = 0},
  [8121] = {.lex_state = 388},
  [8122] = {.lex_state = 388},
  [8123] = {.lex_state = 388},
  [8124] = {.lex_state = 388},
  [8125] = {.lex_state = 388},
  [8126] = {.lex_state = 0},
  [8127] = {.lex_state = 388},
  [8128] = {.lex_state = 0},
  [8129] = {.lex_state = 0},
  [8130] = {.lex_state = 388},
  [8131] = {.lex_state = 231},
  [8132] = {.lex_state = 388, .external_lex_state = 2},
  [8133] = {.lex_state = 0},
  [8134] = {.lex_state = 388, .external_lex_state = 2},
  [8135] = {.lex_state = 0},
  [8136] = {.lex_state = 0},
  [8137] = {.lex_state = 0},
  [8138] = {.lex_state = 0},
  [8139] = {.lex_state = 388, .external_lex_state = 2},
  [8140] = {.lex_state = 388},
  [8141] = {.lex_state = 388, .external_lex_state = 2},
  [8142] = {.lex_state = 388, .external_lex_state = 2},
  [8143] = {.lex_state = 388, .external_lex_state = 2},
  [8144] = {.lex_state = 0},
  [8145] = {.lex_state = 0},
  [8146] = {.lex_state = 388, .external_lex_state = 2},
  [8147] = {.lex_state = 0},
  [8148] = {.lex_state = 388},
  [8149] = {.lex_state = 112},
  [8150] = {.lex_state = 0},
  [8151] = {.lex_state = 388, .external_lex_state = 2},
  [8152] = {.lex_state = 388, .external_lex_state = 2},
  [8153] = {.lex_state = 388},
  [8154] = {.lex_state = 388},
  [8155] = {.lex_state = 388, .external_lex_state = 2},
  [8156] = {.lex_state = 0},
  [8157] = {.lex_state = 0},
  [8158] = {.lex_state = 0},
  [8159] = {.lex_state = 388, .external_lex_state = 2},
  [8160] = {.lex_state = 0},
  [8161] = {.lex_state = 231},
  [8162] = {.lex_state = 0},
  [8163] = {.lex_state = 388},
  [8164] = {.lex_state = 388, .external_lex_state = 2},
  [8165] = {.lex_state = 388},
  [8166] = {.lex_state = 388, .external_lex_state = 2},
  [8167] = {.lex_state = 388, .external_lex_state = 2},
  [8168] = {.lex_state = 0},
  [8169] = {.lex_state = 0},
  [8170] = {.lex_state = 231},
  [8171] = {.lex_state = 112},
  [8172] = {.lex_state = 388, .external_lex_state = 2},
  [8173] = {.lex_state = 231},
  [8174] = {.lex_state = 0},
  [8175] = {.lex_state = 0},
  [8176] = {.lex_state = 112},
  [8177] = {.lex_state = 388},
  [8178] = {.lex_state = 0},
  [8179] = {.lex_state = 388},
  [8180] = {.lex_state = 388, .external_lex_state = 2},
  [8181] = {.lex_state = 388},
  [8182] = {.lex_state = 388},
  [8183] = {.lex_state = 388, .external_lex_state = 2},
  [8184] = {.lex_state = 0},
  [8185] = {.lex_state = 388, .external_lex_state = 2},
  [8186] = {.lex_state = 0},
  [8187] = {.lex_state = 388, .external_lex_state = 2},
  [8188] = {.lex_state = 231},
  [8189] = {.lex_state = 0},
  [8190] = {.lex_state = 388},
  [8191] = {.lex_state = 0},
  [8192] = {.lex_state = 0},
  [8193] = {.lex_state = 0},
  [8194] = {.lex_state = 231},
  [8195] = {.lex_state = 113},
  [8196] = {.lex_state = 0},
  [8197] = {.lex_state = 240},
  [8198] = {.lex_state = 0},
  [8199] = {.lex_state = 113},
  [8200] = {.lex_state = 231},
  [8201] = {.lex_state = 388},
  [8202] = {.lex_state = 231},
  [8203] = {.lex_state = 0},
  [8204] = {.lex_state = 0},
  [8205] = {.lex_state = 0},
  [8206] = {.lex_state = 231},
  [8207] = {.lex_state = 231},
  [8208] = {.lex_state = 0},
  [8209] = {.lex_state = 0},
  [8210] = {.lex_state = 0},
  [8211] = {.lex_state = 388},
  [8212] = {.lex_state = 388},
  [8213] = {.lex_state = 113},
  [8214] = {.lex_state = 203},
  [8215] = {.lex_state = 388},
  [8216] = {.lex_state = 0},
  [8217] = {.lex_state = 0},
  [8218] = {.lex_state = 203},
  [8219] = {.lex_state = 113},
  [8220] = {.lex_state = 0},
  [8221] = {.lex_state = 231},
  [8222] = {.lex_state = 0},
  [8223] = {.lex_state = 240},
  [8224] = {.lex_state = 0},
  [8225] = {.lex_state = 231},
  [8226] = {.lex_state = 240},
  [8227] = {.lex_state = 0},
  [8228] = {.lex_state = 0},
  [8229] = {.lex_state = 0},
  [8230] = {.lex_state = 0},
  [8231] = {.lex_state = 231},
  [8232] = {.lex_state = 0},
  [8233] = {.lex_state = 231},
  [8234] = {.lex_state = 0},
  [8235] = {.lex_state = 0},
  [8236] = {.lex_state = 0},
  [8237] = {.lex_state = 231},
  [8238] = {.lex_state = 203},
  [8239] = {.lex_state = 0},
  [8240] = {.lex_state = 0},
  [8241] = {.lex_state = 0},
  [8242] = {.lex_state = 0},
  [8243] = {.lex_state = 0},
  [8244] = {.lex_state = 0},
  [8245] = {.lex_state = 203},
  [8246] = {.lex_state = 231},
  [8247] = {.lex_state = 240},
  [8248] = {.lex_state = 0},
  [8249] = {.lex_state = 0},
  [8250] = {.lex_state = 231},
  [8251] = {.lex_state = 203},
  [8252] = {.lex_state = 231},
  [8253] = {.lex_state = 286},
  [8254] = {.lex_state = 203},
  [8255] = {.lex_state = 240},
  [8256] = {.lex_state = 0},
  [8257] = {.lex_state = 0},
  [8258] = {.lex_state = 231},
  [8259] = {.lex_state = 0},
  [8260] = {.lex_state = 0},
  [8261] = {.lex_state = 0},
  [8262] = {.lex_state = 0},
  [8263] = {.lex_state = 0},
  [8264] = {.lex_state = 203},
  [8265] = {.lex_state = 0},
  [8266] = {.lex_state = 0},
  [8267] = {.lex_state = 0},
  [8268] = {.lex_state = 0, .external_lex_state = 2},
  [8269] = {.lex_state = 0},
  [8270] = {.lex_state = 0},
  [8271] = {.lex_state = 0},
  [8272] = {.lex_state = 0},
  [8273] = {.lex_state = 113},
  [8274] = {.lex_state = 113},
  [8275] = {.lex_state = 0},
  [8276] = {.lex_state = 0},
  [8277] = {.lex_state = 0},
  [8278] = {.lex_state = 113},
  [8279] = {.lex_state = 388},
  [8280] = {.lex_state = 0},
  [8281] = {.lex_state = 0},
  [8282] = {.lex_state = 0},
  [8283] = {.lex_state = 0},
  [8284] = {.lex_state = 0},
  [8285] = {.lex_state = 0},
  [8286] = {.lex_state = 0},
  [8287] = {.lex_state = 113},
  [8288] = {.lex_state = 0},
  [8289] = {.lex_state = 0},
  [8290] = {.lex_state = 0},
  [8291] = {.lex_state = 0},
  [8292] = {.lex_state = 0},
  [8293] = {.lex_state = 0},
  [8294] = {.lex_state = 231},
  [8295] = {.lex_state = 231},
  [8296] = {.lex_state = 0},
  [8297] = {.lex_state = 0},
  [8298] = {.lex_state = 231},
  [8299] = {.lex_state = 0},
  [8300] = {.lex_state = 0},
  [8301] = {.lex_state = 0},
  [8302] = {.lex_state = 388},
  [8303] = {.lex_state = 0},
  [8304] = {.lex_state = 231},
  [8305] = {.lex_state = 231},
  [8306] = {.lex_state = 231},
  [8307] = {.lex_state = 0},
  [8308] = {.lex_state = 0},
  [8309] = {.lex_state = 0},
  [8310] = {.lex_state = 0},
  [8311] = {.lex_state = 388},
  [8312] = {.lex_state = 0},
  [8313] = {.lex_state = 0},
  [8314] = {.lex_state = 0},
  [8315] = {.lex_state = 0},
  [8316] = {.lex_state = 231},
  [8317] = {.lex_state = 0},
  [8318] = {.lex_state = 0},
  [8319] = {.lex_state = 0},
  [8320] = {.lex_state = 0},
  [8321] = {.lex_state = 231},
  [8322] = {.lex_state = 0},
  [8323] = {.lex_state = 231},
  [8324] = {.lex_state = 0},
  [8325] = {.lex_state = 0},
  [8326] = {.lex_state = 0},
  [8327] = {.lex_state = 0},
  [8328] = {.lex_state = 0},
  [8329] = {.lex_state = 0},
  [8330] = {.lex_state = 0},
  [8331] = {.lex_state = 113},
  [8332] = {.lex_state = 0},
  [8333] = {.lex_state = 388},
  [8334] = {.lex_state = 240},
  [8335] = {.lex_state = 231},
  [8336] = {.lex_state = 203},
  [8337] = {.lex_state = 0},
  [8338] = {.lex_state = 0},
  [8339] = {.lex_state = 0},
  [8340] = {.lex_state = 0},
  [8341] = {.lex_state = 0},
  [8342] = {.lex_state = 0},
  [8343] = {.lex_state = 231},
  [8344] = {.lex_state = 0},
  [8345] = {.lex_state = 0},
  [8346] = {.lex_state = 0},
  [8347] = {.lex_state = 0},
  [8348] = {.lex_state = 231},
  [8349] = {.lex_state = 0},
  [8350] = {.lex_state = 0},
  [8351] = {.lex_state = 0},
  [8352] = {.lex_state = 0},
  [8353] = {.lex_state = 0},
  [8354] = {.lex_state = 0},
  [8355] = {.lex_state = 0},
  [8356] = {.lex_state = 0},
  [8357] = {.lex_state = 0},
  [8358] = {.lex_state = 0, .external_lex_state = 2},
  [8359] = {.lex_state = 0},
  [8360] = {.lex_state = 0},
  [8361] = {.lex_state = 0},
  [8362] = {.lex_state = 231},
  [8363] = {.lex_state = 0},
  [8364] = {.lex_state = 0},
  [8365] = {.lex_state = 113},
  [8366] = {.lex_state = 0},
  [8367] = {.lex_state = 0},
  [8368] = {.lex_state = 0, .external_lex_state = 2},
  [8369] = {.lex_state = 240},
  [8370] = {.lex_state = 0},
  [8371] = {.lex_state = 0},
  [8372] = {.lex_state = 231},
  [8373] = {.lex_state = 0},
  [8374] = {.lex_state = 0},
  [8375] = {.lex_state = 0},
  [8376] = {.lex_state = 231},
  [8377] = {.lex_state = 0},
  [8378] = {.lex_state = 0},
  [8379] = {.lex_state = 0},
  [8380] = {.lex_state = 231},
  [8381] = {.lex_state = 231},
  [8382] = {.lex_state = 231},
  [8383] = {.lex_state = 230},
  [8384] = {.lex_state = 388},
  [8385] = {.lex_state = 240},
  [8386] = {.lex_state = 0},
  [8387] = {.lex_state = 388},
  [8388] = {.lex_state = 203},
  [8389] = {.lex_state = 231},
  [8390] = {.lex_state = 0},
  [8391] = {.lex_state = 0},
  [8392] = {.lex_state = 0},
  [8393] = {.lex_state = 0},
  [8394] = {.lex_state = 231},
  [8395] = {.lex_state = 0},
  [8396] = {.lex_state = 231},
  [8397] = {.lex_state = 0},
  [8398] = {.lex_state = 240},
  [8399] = {.lex_state = 0},
  [8400] = {.lex_state = 240},
  [8401] = {.lex_state = 0},
  [8402] = {.lex_state = 388},
  [8403] = {.lex_state = 0},
  [8404] = {.lex_state = 231},
  [8405] = {.lex_state = 240},
  [8406] = {.lex_state = 231},
  [8407] = {.lex_state = 0},
  [8408] = {.lex_state = 0},
  [8409] = {.lex_state = 0},
  [8410] = {.lex_state = 231},
  [8411] = {.lex_state = 0},
  [8412] = {.lex_state = 113},
  [8413] = {.lex_state = 0},
  [8414] = {.lex_state = 388},
  [8415] = {.lex_state = 0, .external_lex_state = 2},
  [8416] = {.lex_state = 0},
  [8417] = {.lex_state = 388},
  [8418] = {.lex_state = 0},
  [8419] = {.lex_state = 388},
  [8420] = {.lex_state = 0},
  [8421] = {.lex_state = 0},
  [8422] = {.lex_state = 231},
  [8423] = {.lex_state = 0},
  [8424] = {.lex_state = 0},
  [8425] = {.lex_state = 231},
  [8426] = {.lex_state = 231},
  [8427] = {.lex_state = 0},
  [8428] = {.lex_state = 0},
  [8429] = {.lex_state = 0},
  [8430] = {.lex_state = 0},
  [8431] = {.lex_state = 0, .external_lex_state = 2},
  [8432] = {.lex_state = 0},
  [8433] = {.lex_state = 231},
  [8434] = {.lex_state = 231},
  [8435] = {.lex_state = 0},
  [8436] = {.lex_state = 0},
  [8437] = {.lex_state = 0},
  [8438] = {.lex_state = 0},
  [8439] = {.lex_state = 0},
  [8440] = {.lex_state = 388},
  [8441] = {.lex_state = 231},
  [8442] = {.lex_state = 388},
  [8443] = {.lex_state = 0},
  [8444] = {.lex_state = 0},
  [8445] = {.lex_state = 0},
  [8446] = {.lex_state = 388},
  [8447] = {.lex_state = 231},
  [8448] = {.lex_state = 0},
  [8449] = {.lex_state = 0},
  [8450] = {.lex_state = 0},
  [8451] = {.lex_state = 0},
  [8452] = {.lex_state = 0},
  [8453] = {.lex_state = 0},
  [8454] = {.lex_state = 388},
  [8455] = {.lex_state = 0},
  [8456] = {.lex_state = 0},
  [8457] = {.lex_state = 0},
  [8458] = {.lex_state = 388},
  [8459] = {.lex_state = 0},
  [8460] = {.lex_state = 231},
  [8461] = {.lex_state = 0},
  [8462] = {.lex_state = 0},
  [8463] = {.lex_state = 231},
  [8464] = {.lex_state = 388},
  [8465] = {.lex_state = 388},
  [8466] = {.lex_state = 0},
  [8467] = {.lex_state = 0},
  [8468] = {.lex_state = 0},
  [8469] = {.lex_state = 388},
  [8470] = {.lex_state = 0},
  [8471] = {.lex_state = 203},
  [8472] = {.lex_state = 388},
  [8473] = {.lex_state = 0},
  [8474] = {.lex_state = 203},
  [8475] = {.lex_state = 231},
  [8476] = {.lex_state = 203},
  [8477] = {.lex_state = 203},
  [8478] = {.lex_state = 0},
  [8479] = {.lex_state = 0},
  [8480] = {.lex_state = 0, .external_lex_state = 2},
  [8481] = {.lex_state = 0},
  [8482] = {.lex_state = 231},
  [8483] = {.lex_state = 0},
  [8484] = {.lex_state = 0},
  [8485] = {.lex_state = 201},
  [8486] = {.lex_state = 388},
  [8487] = {.lex_state = 113},
  [8488] = {.lex_state = 203},
  [8489] = {.lex_state = 231},
  [8490] = {.lex_state = 231},
  [8491] = {.lex_state = 113},
  [8492] = {.lex_state = 113},
  [8493] = {.lex_state = 0},
  [8494] = {.lex_state = 0},
  [8495] = {.lex_state = 203},
  [8496] = {.lex_state = 0},
  [8497] = {.lex_state = 0},
  [8498] = {.lex_state = 388},
  [8499] = {.lex_state = 0},
  [8500] = {.lex_state = 113},
  [8501] = {.lex_state = 0},
  [8502] = {.lex_state = 231},
  [8503] = {.lex_state = 0},
  [8504] = {.lex_state = 0},
  [8505] = {.lex_state = 203},
  [8506] = {.lex_state = 203},
  [8507] = {.lex_state = 0},
  [8508] = {.lex_state = 0},
  [8509] = {.lex_state = 0},
  [8510] = {.lex_state = 0},
  [8511] = {.lex_state = 388},
  [8512] = {.lex_state = 0},
  [8513] = {.lex_state = 0},
  [8514] = {.lex_state = 0},
  [8515] = {.lex_state = 203},
  [8516] = {.lex_state = 231},
  [8517] = {.lex_state = 0},
  [8518] = {.lex_state = 0},
  [8519] = {.lex_state = 0},
  [8520] = {.lex_state = 231},
  [8521] = {.lex_state = 0, .external_lex_state = 2},
  [8522] = {.lex_state = 0},
  [8523] = {.lex_state = 0},
  [8524] = {.lex_state = 0},
  [8525] = {.lex_state = 0},
  [8526] = {.lex_state = 203},
  [8527] = {.lex_state = 231},
  [8528] = {.lex_state = 203},
  [8529] = {.lex_state = 0},
  [8530] = {.lex_state = 0},
  [8531] = {.lex_state = 388},
  [8532] = {.lex_state = 231},
  [8533] = {.lex_state = 113},
  [8534] = {.lex_state = 231},
  [8535] = {.lex_state = 231},
  [8536] = {.lex_state = 231},
  [8537] = {.lex_state = 0},
  [8538] = {.lex_state = 0},
  [8539] = {.lex_state = 0},
  [8540] = {.lex_state = 231},
  [8541] = {.lex_state = 231},
  [8542] = {.lex_state = 0},
  [8543] = {.lex_state = 0, .external_lex_state = 2},
  [8544] = {.lex_state = 0},
  [8545] = {.lex_state = 0},
  [8546] = {.lex_state = 0},
  [8547] = {.lex_state = 0},
  [8548] = {.lex_state = 0},
  [8549] = {.lex_state = 0},
  [8550] = {.lex_state = 0},
  [8551] = {.lex_state = 388},
  [8552] = {.lex_state = 0},
  [8553] = {.lex_state = 0},
  [8554] = {.lex_state = 113},
  [8555] = {.lex_state = 231},
  [8556] = {.lex_state = 0},
  [8557] = {.lex_state = 0},
  [8558] = {.lex_state = 203},
  [8559] = {.lex_state = 0, .external_lex_state = 2},
  [8560] = {.lex_state = 0},
  [8561] = {.lex_state = 0},
  [8562] = {.lex_state = 0},
  [8563] = {.lex_state = 388},
  [8564] = {.lex_state = 0},
  [8565] = {.lex_state = 231},
  [8566] = {.lex_state = 0, .external_lex_state = 2},
  [8567] = {.lex_state = 0},
  [8568] = {.lex_state = 0},
  [8569] = {.lex_state = 113},
  [8570] = {.lex_state = 388},
  [8571] = {.lex_state = 0},
  [8572] = {.lex_state = 0, .external_lex_state = 2},
  [8573] = {.lex_state = 0},
  [8574] = {.lex_state = 0},
  [8575] = {.lex_state = 0},
  [8576] = {.lex_state = 388},
  [8577] = {.lex_state = 0},
  [8578] = {.lex_state = 0, .external_lex_state = 2},
  [8579] = {.lex_state = 0},
  [8580] = {.lex_state = 0},
  [8581] = {.lex_state = 0, .external_lex_state = 2},
  [8582] = {.lex_state = 0},
  [8583] = {.lex_state = 0},
  [8584] = {.lex_state = 0, .external_lex_state = 2},
  [8585] = {.lex_state = 0},
  [8586] = {.lex_state = 0, .external_lex_state = 2},
  [8587] = {.lex_state = 0},
  [8588] = {.lex_state = 0, .external_lex_state = 2},
  [8589] = {.lex_state = 0},
  [8590] = {.lex_state = 0, .external_lex_state = 2},
  [8591] = {.lex_state = 0},
  [8592] = {.lex_state = 0, .external_lex_state = 2},
  [8593] = {.lex_state = 0},
  [8594] = {.lex_state = 0, .external_lex_state = 2},
  [8595] = {.lex_state = 0},
  [8596] = {.lex_state = 0, .external_lex_state = 2},
  [8597] = {.lex_state = 0},
  [8598] = {.lex_state = 0, .external_lex_state = 2},
  [8599] = {.lex_state = 203},
  [8600] = {.lex_state = 0},
  [8601] = {.lex_state = 203},
  [8602] = {.lex_state = 388},
  [8603] = {.lex_state = 0},
  [8604] = {.lex_state = 388},
  [8605] = {.lex_state = 388},
  [8606] = {.lex_state = 388},
  [8607] = {.lex_state = 203},
  [8608] = {.lex_state = 201},
  [8609] = {.lex_state = 388},
  [8610] = {.lex_state = 113},
  [8611] = {.lex_state = 388},
  [8612] = {.lex_state = 0},
  [8613] = {.lex_state = 0},
  [8614] = {.lex_state = 388},
  [8615] = {.lex_state = 0},
  [8616] = {.lex_state = 0},
  [8617] = {.lex_state = 0},
  [8618] = {.lex_state = 240},
  [8619] = {.lex_state = 0},
  [8620] = {.lex_state = 0},
  [8621] = {.lex_state = 0},
  [8622] = {.lex_state = 388},
  [8623] = {.lex_state = 0},
  [8624] = {.lex_state = 203},
  [8625] = {.lex_state = 231},
  [8626] = {.lex_state = 0},
  [8627] = {.lex_state = 231},
  [8628] = {.lex_state = 0},
  [8629] = {.lex_state = 388},
  [8630] = {.lex_state = 0},
  [8631] = {.lex_state = 0},
  [8632] = {.lex_state = 0},
  [8633] = {.lex_state = 0},
  [8634] = {.lex_state = 388},
  [8635] = {.lex_state = 0, .external_lex_state = 3},
  [8636] = {.lex_state = 0},
  [8637] = {.lex_state = 231},
  [8638] = {.lex_state = 0},
  [8639] = {.lex_state = 388},
  [8640] = {.lex_state = 0},
  [8641] = {.lex_state = 0},
  [8642] = {.lex_state = 0},
  [8643] = {.lex_state = 0},
  [8644] = {.lex_state = 0},
  [8645] = {.lex_state = 0},
  [8646] = {.lex_state = 0},
  [8647] = {.lex_state = 0},
  [8648] = {.lex_state = 0},
  [8649] = {.lex_state = 231},
  [8650] = {.lex_state = 0},
  [8651] = {.lex_state = 388},
  [8652] = {.lex_state = 231},
  [8653] = {.lex_state = 113},
  [8654] = {.lex_state = 240},
  [8655] = {.lex_state = 240},
  [8656] = {.lex_state = 0},
  [8657] = {.lex_state = 240},
  [8658] = {.lex_state = 0},
  [8659] = {.lex_state = 113},
  [8660] = {.lex_state = 0},
  [8661] = {.lex_state = 0},
  [8662] = {.lex_state = 0},
  [8663] = {.lex_state = 0},
  [8664] = {.lex_state = 0},
  [8665] = {.lex_state = 0},
  [8666] = {.lex_state = 0},
  [8667] = {.lex_state = 0},
  [8668] = {.lex_state = 0},
  [8669] = {.lex_state = 0},
  [8670] = {.lex_state = 240},
  [8671] = {.lex_state = 0},
  [8672] = {.lex_state = 0},
  [8673] = {.lex_state = 0},
  [8674] = {.lex_state = 0},
  [8675] = {.lex_state = 0},
  [8676] = {.lex_state = 0},
  [8677] = {.lex_state = 0},
  [8678] = {.lex_state = 0},
  [8679] = {.lex_state = 0},
  [8680] = {.lex_state = 0},
  [8681] = {.lex_state = 0},
  [8682] = {.lex_state = 0},
  [8683] = {.lex_state = 0},
  [8684] = {.lex_state = 231},
  [8685] = {.lex_state = 0},
  [8686] = {.lex_state = 0},
  [8687] = {.lex_state = 0},
  [8688] = {.lex_state = 0},
  [8689] = {.lex_state = 0},
  [8690] = {.lex_state = 0},
  [8691] = {.lex_state = 0},
  [8692] = {.lex_state = 0},
  [8693] = {.lex_state = 0},
  [8694] = {.lex_state = 0},
  [8695] = {.lex_state = 201},
  [8696] = {.lex_state = 0},
  [8697] = {.lex_state = 0},
  [8698] = {.lex_state = 0},
  [8699] = {.lex_state = 231},
  [8700] = {.lex_state = 231},
  [8701] = {.lex_state = 0},
  [8702] = {.lex_state = 388},
  [8703] = {.lex_state = 0},
  [8704] = {.lex_state = 0},
  [8705] = {.lex_state = 0},
  [8706] = {.lex_state = 388},
  [8707] = {.lex_state = 203},
  [8708] = {.lex_state = 0},
  [8709] = {.lex_state = 0},
  [8710] = {.lex_state = 0},
  [8711] = {.lex_state = 113},
  [8712] = {.lex_state = 0},
  [8713] = {.lex_state = 0},
  [8714] = {.lex_state = 0},
  [8715] = {.lex_state = 231},
  [8716] = {.lex_state = 0},
  [8717] = {.lex_state = 388},
  [8718] = {.lex_state = 0},
  [8719] = {.lex_state = 0},
  [8720] = {.lex_state = 0},
  [8721] = {.lex_state = 0},
  [8722] = {.lex_state = 0},
  [8723] = {.lex_state = 0},
  [8724] = {.lex_state = 0},
  [8725] = {.lex_state = 0},
  [8726] = {.lex_state = 0},
  [8727] = {.lex_state = 203},
  [8728] = {.lex_state = 201},
  [8729] = {.lex_state = 0},
  [8730] = {.lex_state = 0},
  [8731] = {.lex_state = 0},
  [8732] = {.lex_state = 0},
  [8733] = {.lex_state = 204},
  [8734] = {.lex_state = 0},
  [8735] = {.lex_state = 0},
  [8736] = {.lex_state = 240},
  [8737] = {.lex_state = 203},
  [8738] = {.lex_state = 0},
  [8739] = {.lex_state = 203},
  [8740] = {.lex_state = 0},
  [8741] = {.lex_state = 203},
  [8742] = {.lex_state = 203},
  [8743] = {.lex_state = 203},
  [8744] = {.lex_state = 231},
  [8745] = {.lex_state = 231},
  [8746] = {.lex_state = 0},
  [8747] = {.lex_state = 388},
  [8748] = {.lex_state = 0, .external_lex_state = 3},
  [8749] = {.lex_state = 0},
  [8750] = {.lex_state = 0},
  [8751] = {.lex_state = 201},
  [8752] = {.lex_state = 0},
  [8753] = {.lex_state = 203},
  [8754] = {.lex_state = 0},
  [8755] = {.lex_state = 0},
  [8756] = {.lex_state = 0},
  [8757] = {.lex_state = 0},
  [8758] = {.lex_state = 0},
  [8759] = {.lex_state = 231},
  [8760] = {.lex_state = 203},
  [8761] = {.lex_state = 0},
  [8762] = {.lex_state = 113},
  [8763] = {.lex_state = 0},
  [8764] = {.lex_state = 0},
  [8765] = {.lex_state = 0},
  [8766] = {.lex_state = 203},
  [8767] = {.lex_state = 0},
  [8768] = {.lex_state = 0},
  [8769] = {.lex_state = 0},
  [8770] = {.lex_state = 0},
  [8771] = {.lex_state = 203},
  [8772] = {.lex_state = 0},
  [8773] = {.lex_state = 0},
  [8774] = {.lex_state = 0},
  [8775] = {.lex_state = 0},
  [8776] = {.lex_state = 0},
  [8777] = {.lex_state = 0},
  [8778] = {.lex_state = 0},
  [8779] = {.lex_state = 231},
  [8780] = {.lex_state = 0},
  [8781] = {.lex_state = 0},
  [8782] = {.lex_state = 0},
  [8783] = {.lex_state = 0},
  [8784] = {.lex_state = 0},
  [8785] = {.lex_state = 0},
  [8786] = {.lex_state = 0},
  [8787] = {.lex_state = 0},
  [8788] = {.lex_state = 0},
  [8789] = {.lex_state = 388},
  [8790] = {.lex_state = 388},
  [8791] = {.lex_state = 113},
  [8792] = {.lex_state = 203},
  [8793] = {.lex_state = 113},
  [8794] = {.lex_state = 0},
  [8795] = {.lex_state = 0},
  [8796] = {.lex_state = 388},
  [8797] = {.lex_state = 203},
  [8798] = {.lex_state = 0, .external_lex_state = 3},
  [8799] = {.lex_state = 0},
  [8800] = {.lex_state = 113},
  [8801] = {.lex_state = 0},
  [8802] = {.lex_state = 0},
  [8803] = {.lex_state = 388},
  [8804] = {.lex_state = 113},
  [8805] = {.lex_state = 388},
  [8806] = {.lex_state = 388},
  [8807] = {.lex_state = 388},
  [8808] = {.lex_state = 0},
  [8809] = {.lex_state = 388},
  [8810] = {.lex_state = 0},
  [8811] = {.lex_state = 388},
  [8812] = {.lex_state = 0},
  [8813] = {.lex_state = 0},
  [8814] = {.lex_state = 231},
  [8815] = {.lex_state = 0},
  [8816] = {.lex_state = 231},
  [8817] = {.lex_state = 203},
  [8818] = {.lex_state = 0},
  [8819] = {.lex_state = 231},
  [8820] = {.lex_state = 388},
  [8821] = {.lex_state = 388},
  [8822] = {.lex_state = 0},
  [8823] = {.lex_state = 0},
  [8824] = {.lex_state = 0},
  [8825] = {.lex_state = 0},
  [8826] = {.lex_state = 388},
  [8827] = {.lex_state = 0, .external_lex_state = 3},
  [8828] = {.lex_state = 0},
  [8829] = {.lex_state = 388},
  [8830] = {.lex_state = 113},
  [8831] = {.lex_state = 0},
  [8832] = {.lex_state = 0},
  [8833] = {.lex_state = 240},
  [8834] = {.lex_state = 0},
  [8835] = {.lex_state = 240},
  [8836] = {.lex_state = 0},
  [8837] = {.lex_state = 0},
  [8838] = {.lex_state = 0},
  [8839] = {.lex_state = 240},
  [8840] = {.lex_state = 0},
  [8841] = {.lex_state = 0},
  [8842] = {.lex_state = 388},
  [8843] = {.lex_state = 388},
  [8844] = {.lex_state = 388},
  [8845] = {.lex_state = 0},
  [8846] = {.lex_state = 388},
  [8847] = {.lex_state = 0},
  [8848] = {.lex_state = 113},
  [8849] = {.lex_state = 231},
  [8850] = {.lex_state = 388},
  [8851] = {.lex_state = 388},
  [8852] = {.lex_state = 0},
  [8853] = {.lex_state = 0},
  [8854] = {.lex_state = 388},
  [8855] = {.lex_state = 388},
  [8856] = {.lex_state = 0, .external_lex_state = 3},
  [8857] = {.lex_state = 0},
  [8858] = {.lex_state = 0},
  [8859] = {.lex_state = 0},
  [8860] = {.lex_state = 0},
  [8861] = {.lex_state = 0},
  [8862] = {.lex_state = 240},
  [8863] = {.lex_state = 0},
  [8864] = {.lex_state = 388},
  [8865] = {.lex_state = 388},
  [8866] = {.lex_state = 388},
  [8867] = {.lex_state = 0},
  [8868] = {.lex_state = 388},
  [8869] = {.lex_state = 240},
  [8870] = {.lex_state = 0},
  [8871] = {.lex_state = 231},
  [8872] = {.lex_state = 388},
  [8873] = {.lex_state = 231},
  [8874] = {.lex_state = 0},
  [8875] = {.lex_state = 388},
  [8876] = {.lex_state = 0, .external_lex_state = 3},
  [8877] = {.lex_state = 0},
  [8878] = {.lex_state = 0},
  [8879] = {.lex_state = 0},
  [8880] = {.lex_state = 0},
  [8881] = {.lex_state = 0},
  [8882] = {.lex_state = 240},
  [8883] = {.lex_state = 0},
  [8884] = {.lex_state = 388},
  [8885] = {.lex_state = 388},
  [8886] = {.lex_state = 388},
  [8887] = {.lex_state = 0},
  [8888] = {.lex_state = 388},
  [8889] = {.lex_state = 0},
  [8890] = {.lex_state = 203},
  [8891] = {.lex_state = 388},
  [8892] = {.lex_state = 0},
  [8893] = {.lex_state = 203},
  [8894] = {.lex_state = 388},
  [8895] = {.lex_state = 0, .external_lex_state = 3},
  [8896] = {.lex_state = 0},
  [8897] = {.lex_state = 0},
  [8898] = {.lex_state = 0},
  [8899] = {.lex_state = 0},
  [8900] = {.lex_state = 0},
  [8901] = {.lex_state = 240},
  [8902] = {.lex_state = 0},
  [8903] = {.lex_state = 388},
  [8904] = {.lex_state = 388},
  [8905] = {.lex_state = 0},
  [8906] = {.lex_state = 388},
  [8907] = {.lex_state = 0},
  [8908] = {.lex_state = 203},
  [8909] = {.lex_state = 388},
  [8910] = {.lex_state = 0},
  [8911] = {.lex_state = 0},
  [8912] = {.lex_state = 388},
  [8913] = {.lex_state = 0, .external_lex_state = 3},
  [8914] = {.lex_state = 0},
  [8915] = {.lex_state = 0},
  [8916] = {.lex_state = 203},
  [8917] = {.lex_state = 0},
  [8918] = {.lex_state = 0},
  [8919] = {.lex_state = 240},
  [8920] = {.lex_state = 203},
  [8921] = {.lex_state = 388},
  [8922] = {.lex_state = 388},
  [8923] = {.lex_state = 113},
  [8924] = {.lex_state = 388},
  [8925] = {.lex_state = 231},
  [8926] = {.lex_state = 388},
  [8927] = {.lex_state = 0},
  [8928] = {.lex_state = 0, .external_lex_state = 3},
  [8929] = {.lex_state = 0},
  [8930] = {.lex_state = 240},
  [8931] = {.lex_state = 0},
  [8932] = {.lex_state = 0},
  [8933] = {.lex_state = 240},
  [8934] = {.lex_state = 0},
  [8935] = {.lex_state = 388},
  [8936] = {.lex_state = 0},
  [8937] = {.lex_state = 388},
  [8938] = {.lex_state = 0},
  [8939] = {.lex_state = 0},
  [8940] = {.lex_state = 0, .external_lex_state = 3},
  [8941] = {.lex_state = 0},
  [8942] = {.lex_state = 0},
  [8943] = {.lex_state = 388},
  [8944] = {.lex_state = 388},
  [8945] = {.lex_state = 0, .external_lex_state = 3},
  [8946] = {.lex_state = 0},
  [8947] = {.lex_state = 388},
  [8948] = {.lex_state = 388},
  [8949] = {.lex_state = 0, .external_lex_state = 3},
  [8950] = {.lex_state = 0},
  [8951] = {.lex_state = 388},
  [8952] = {.lex_state = 388},
  [8953] = {.lex_state = 0, .external_lex_state = 3},
  [8954] = {.lex_state = 0},
  [8955] = {.lex_state = 0, .external_lex_state = 3},
  [8956] = {.lex_state = 0},
  [8957] = {.lex_state = 0, .external_lex_state = 3},
  [8958] = {.lex_state = 0},
  [8959] = {.lex_state = 0, .external_lex_state = 3},
  [8960] = {.lex_state = 0},
  [8961] = {.lex_state = 0, .external_lex_state = 3},
  [8962] = {.lex_state = 0},
  [8963] = {.lex_state = 0, .external_lex_state = 3},
  [8964] = {.lex_state = 0},
  [8965] = {.lex_state = 0, .external_lex_state = 3},
  [8966] = {.lex_state = 0},
  [8967] = {.lex_state = 0, .external_lex_state = 3},
  [8968] = {.lex_state = 0},
  [8969] = {.lex_state = 0, .external_lex_state = 3},
  [8970] = {.lex_state = 0},
  [8971] = {.lex_state = 0, .external_lex_state = 3},
  [8972] = {.lex_state = 0},
  [8973] = {.lex_state = 203},
  [8974] = {.lex_state = 203},
  [8975] = {.lex_state = 388},
  [8976] = {.lex_state = 388},
  [8977] = {.lex_state = 231},
  [8978] = {.lex_state = 0},
  [8979] = {.lex_state = 0},
  [8980] = {.lex_state = 0},
  [8981] = {.lex_state = 203},
  [8982] = {.lex_state = 0},
  [8983] = {.lex_state = 0},
  [8984] = {.lex_state = 0},
  [8985] = {.lex_state = 0},
  [8986] = {.lex_state = 0},
  [8987] = {.lex_state = 231},
  [8988] = {.lex_state = 0, .external_lex_state = 3},
  [8989] = {.lex_state = 388},
  [8990] = {.lex_state = 0},
  [8991] = {.lex_state = 388},
  [8992] = {.lex_state = 388},
  [8993] = {.lex_state = 388},
  [8994] = {.lex_state = 231},
  [8995] = {.lex_state = 0},
  [8996] = {.lex_state = 0},
  [8997] = {.lex_state = 388},
  [8998] = {.lex_state = 0},
  [8999] = {.lex_state = 240},
  [9000] = {.lex_state = 231},
  [9001] = {.lex_state = 240},
  [9002] = {.lex_state = 0},
  [9003] = {.lex_state = 0},
  [9004] = {.lex_state = 231},
  [9005] = {.lex_state = 231},
  [9006] = {.lex_state = 0},
  [9007] = {.lex_state = 388},
  [9008] = {.lex_state = 0},
  [9009] = {.lex_state = 0},
  [9010] = {.lex_state = 0},
  [9011] = {.lex_state = 0},
  [9012] = {.lex_state = 0},
  [9013] = {.lex_state = 240},
  [9014] = {.lex_state = 0},
  [9015] = {.lex_state = 388},
  [9016] = {.lex_state = 0},
  [9017] = {.lex_state = 0},
  [9018] = {.lex_state = 240},
  [9019] = {.lex_state = 203},
  [9020] = {.lex_state = 203},
  [9021] = {.lex_state = 388},
  [9022] = {.lex_state = 388},
  [9023] = {.lex_state = 231},
  [9024] = {.lex_state = 0},
  [9025] = {.lex_state = 388},
  [9026] = {.lex_state = 231},
  [9027] = {.lex_state = 0, .external_lex_state = 3},
  [9028] = {.lex_state = 240},
  [9029] = {.lex_state = 0},
  [9030] = {.lex_state = 388},
  [9031] = {.lex_state = 388},
  [9032] = {.lex_state = 388},
  [9033] = {.lex_state = 231},
  [9034] = {.lex_state = 0},
  [9035] = {.lex_state = 0},
  [9036] = {.lex_state = 231},
  [9037] = {.lex_state = 0, .external_lex_state = 3},
  [9038] = {.lex_state = 0},
  [9039] = {.lex_state = 203},
  [9040] = {.lex_state = 0},
  [9041] = {.lex_state = 388},
  [9042] = {.lex_state = 231},
  [9043] = {.lex_state = 0},
  [9044] = {.lex_state = 240},
  [9045] = {.lex_state = 231},
  [9046] = {.lex_state = 0, .external_lex_state = 3},
  [9047] = {.lex_state = 0},
  [9048] = {.lex_state = 0},
  [9049] = {.lex_state = 388},
  [9050] = {.lex_state = 231},
  [9051] = {.lex_state = 231},
  [9052] = {.lex_state = 203},
  [9053] = {.lex_state = 231},
  [9054] = {.lex_state = 0, .external_lex_state = 3},
  [9055] = {.lex_state = 203},
  [9056] = {.lex_state = 203},
  [9057] = {.lex_state = 388},
  [9058] = {.lex_state = 231},
  [9059] = {.lex_state = 231},
  [9060] = {.lex_state = 231},
  [9061] = {.lex_state = 231},
  [9062] = {.lex_state = 0, .external_lex_state = 3},
  [9063] = {.lex_state = 113},
  [9064] = {.lex_state = 203},
  [9065] = {.lex_state = 0},
  [9066] = {.lex_state = 0},
  [9067] = {.lex_state = 231},
  [9068] = {.lex_state = 0, .external_lex_state = 3},
  [9069] = {.lex_state = 0},
  [9070] = {.lex_state = 0},
  [9071] = {.lex_state = 0},
  [9072] = {.lex_state = 0, .external_lex_state = 3},
  [9073] = {.lex_state = 0},
  [9074] = {.lex_state = 0, .external_lex_state = 3},
  [9075] = {.lex_state = 0},
  [9076] = {.lex_state = 0, .external_lex_state = 3},
  [9077] = {.lex_state = 0},
  [9078] = {.lex_state = 0, .external_lex_state = 3},
  [9079] = {.lex_state = 0},
  [9080] = {.lex_state = 0, .external_lex_state = 3},
  [9081] = {.lex_state = 231},
  [9082] = {.lex_state = 0, .external_lex_state = 3},
  [9083] = {.lex_state = 0},
  [9084] = {.lex_state = 0, .external_lex_state = 3},
  [9085] = {.lex_state = 0},
  [9086] = {.lex_state = 0, .external_lex_state = 3},
  [9087] = {.lex_state = 0},
  [9088] = {.lex_state = 0, .external_lex_state = 3},
  [9089] = {.lex_state = 0},
  [9090] = {.lex_state = 0, .external_lex_state = 3},
  [9091] = {.lex_state = 0},
  [9092] = {.lex_state = 0, .external_lex_state = 3},
  [9093] = {.lex_state = 0},
  [9094] = {.lex_state = 0, .external_lex_state = 3},
  [9095] = {.lex_state = 0},
  [9096] = {.lex_state = 0, .external_lex_state = 3},
  [9097] = {.lex_state = 388},
  [9098] = {.lex_state = 388},
  [9099] = {.lex_state = 0},
  [9100] = {.lex_state = 388},
  [9101] = {.lex_state = 388},
  [9102] = {.lex_state = 0},
  [9103] = {.lex_state = 388},
  [9104] = {.lex_state = 388},
  [9105] = {.lex_state = 0},
  [9106] = {.lex_state = 388},
  [9107] = {.lex_state = 388},
  [9108] = {.lex_state = 0},
  [9109] = {.lex_state = 388},
  [9110] = {.lex_state = 388},
  [9111] = {.lex_state = 231},
  [9112] = {.lex_state = 388},
  [9113] = {.lex_state = 388},
  [9114] = {.lex_state = 0},
  [9115] = {.lex_state = 388},
  [9116] = {.lex_state = 388},
  [9117] = {.lex_state = 231},
  [9118] = {.lex_state = 388},
  [9119] = {.lex_state = 388},
  [9120] = {.lex_state = 388},
  [9121] = {.lex_state = 388},
  [9122] = {.lex_state = 388},
  [9123] = {.lex_state = 388},
  [9124] = {.lex_state = 388},
  [9125] = {.lex_state = 388},
  [9126] = {.lex_state = 388},
  [9127] = {.lex_state = 388},
  [9128] = {.lex_state = 388},
  [9129] = {.lex_state = 388},
  [9130] = {.lex_state = 388},
  [9131] = {.lex_state = 0},
  [9132] = {.lex_state = 388},
  [9133] = {.lex_state = 231},
  [9134] = {.lex_state = 0},
  [9135] = {.lex_state = 231},
  [9136] = {.lex_state = 0},
  [9137] = {.lex_state = 231},
  [9138] = {.lex_state = 388},
  [9139] = {.lex_state = 388},
  [9140] = {.lex_state = 388},
  [9141] = {.lex_state = 388},
  [9142] = {.lex_state = 388},
  [9143] = {.lex_state = 388},
  [9144] = {.lex_state = 388},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [aux_sym_preproc_include_token1] = ACTIONS(1),
    [aux_sym_preproc_def_token1] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [aux_sym_preproc_if_token1] = ACTIONS(1),
    [aux_sym_preproc_if_token2] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1),
    [aux_sym_preproc_else_token1] = ACTIONS(1),
    [aux_sym_preproc_elif_token1] = ACTIONS(1),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1),
    [sym_preproc_directive] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_defined] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym___extension__] = ACTIONS(1),
    [anon_sym_typedef] = ACTIONS(1),
    [anon_sym___device__] = ACTIONS(1),
    [anon_sym___host__] = ACTIONS(1),
    [anon_sym___global__] = ACTIONS(1),
    [anon_sym___forceinline__] = ACTIONS(1),
    [anon_sym___noinline__] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym___attribute__] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym___declspec] = ACTIONS(1),
    [anon_sym___based] = ACTIONS(1),
    [anon_sym___cdecl] = ACTIONS(1),
    [anon_sym___clrcall] = ACTIONS(1),
    [anon_sym___stdcall] = ACTIONS(1),
    [anon_sym___fastcall] = ACTIONS(1),
    [anon_sym___thiscall] = ACTIONS(1),
    [anon_sym___vectorcall] = ACTIONS(1),
    [sym_ms_restrict_modifier] = ACTIONS(1),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(1),
    [sym_ms_signed_ptr_modifier] = ACTIONS(1),
    [anon_sym__unaligned] = ACTIONS(1),
    [anon_sym___unaligned] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_signed] = ACTIONS(1),
    [anon_sym_unsigned] = ACTIONS(1),
    [anon_sym_long] = ACTIONS(1),
    [anon_sym_short] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_register] = ACTIONS(1),
    [anon_sym_inline] = ACTIONS(1),
    [anon_sym___inline] = ACTIONS(1),
    [anon_sym___inline__] = ACTIONS(1),
    [anon_sym___forceinline] = ACTIONS(1),
    [anon_sym_thread_local] = ACTIONS(1),
    [anon_sym___thread] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_constexpr] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_restrict] = ACTIONS(1),
    [anon_sym___restrict__] = ACTIONS(1),
    [anon_sym__Atomic] = ACTIONS(1),
    [anon_sym__Noreturn] = ACTIONS(1),
    [anon_sym_noreturn] = ACTIONS(1),
    [anon_sym_mutable] = ACTIONS(1),
    [anon_sym_constinit] = ACTIONS(1),
    [anon_sym_consteval] = ACTIONS(1),
    [anon_sym___shared__] = ACTIONS(1),
    [anon_sym___local__] = ACTIONS(1),
    [anon_sym___constant__] = ACTIONS(1),
    [anon_sym___managed__] = ACTIONS(1),
    [anon_sym___grid_constant__] = ACTIONS(1),
    [anon_sym_alignas] = ACTIONS(1),
    [anon_sym__Alignas] = ACTIONS(1),
    [sym_primitive_type] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_union] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym___try] = ACTIONS(1),
    [anon_sym___except] = ACTIONS(1),
    [anon_sym___finally] = ACTIONS(1),
    [anon_sym___leave] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_and_eq] = ACTIONS(1),
    [anon_sym_or_eq] = ACTIONS(1),
    [anon_sym_xor_eq] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_compl] = ACTIONS(1),
    [anon_sym_LT_EQ_GT] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_bitor] = ACTIONS(1),
    [anon_sym_xor] = ACTIONS(1),
    [anon_sym_bitand] = ACTIONS(1),
    [anon_sym_not_eq] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_sizeof] = ACTIONS(1),
    [anon_sym___alignof__] = ACTIONS(1),
    [anon_sym___alignof] = ACTIONS(1),
    [anon_sym__alignof] = ACTIONS(1),
    [anon_sym_alignof] = ACTIONS(1),
    [anon_sym__Alignof] = ACTIONS(1),
    [anon_sym_offsetof] = ACTIONS(1),
    [anon_sym__Generic] = ACTIONS(1),
    [anon_sym_asm] = ACTIONS(1),
    [anon_sym___asm__] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DOT_STAR] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [sym_number_literal] = ACTIONS(1),
    [anon_sym_L_SQUOTE] = ACTIONS(1),
    [anon_sym_u_SQUOTE] = ACTIONS(1),
    [anon_sym_U_SQUOTE] = ACTIONS(1),
    [anon_sym_u8_SQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_L_DQUOTE] = ACTIONS(1),
    [anon_sym_u_DQUOTE] = ACTIONS(1),
    [anon_sym_U_DQUOTE] = ACTIONS(1),
    [anon_sym_u8_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [anon_sym_NULL] = ACTIONS(1),
    [anon_sym_nullptr] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1),
    [anon_sym_decltype] = ACTIONS(1),
    [anon_sym_final] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [sym_virtual] = ACTIONS(1),
    [anon_sym_explicit] = ACTIONS(1),
    [anon_sym_typename] = ACTIONS(1),
    [anon_sym_template] = ACTIONS(1),
    [anon_sym_GT2] = ACTIONS(1),
    [anon_sym_operator] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_0] = ACTIONS(1),
    [anon_sym_friend] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_noexcept] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_static_assert] = ACTIONS(1),
    [anon_sym_concept] = ACTIONS(1),
    [anon_sym_co_return] = ACTIONS(1),
    [anon_sym_co_yield] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_R_DQUOTE] = ACTIONS(1),
    [anon_sym_LR_DQUOTE] = ACTIONS(1),
    [anon_sym_uR_DQUOTE] = ACTIONS(1),
    [anon_sym_UR_DQUOTE] = ACTIONS(1),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1),
    [anon_sym_co_await] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_requires] = ACTIONS(1),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(1),
    [aux_sym_kernel_call_syntax_token2] = ACTIONS(1),
    [anon_sym___launch_bounds__] = ACTIONS(1),
    [sym_raw_string_delimiter] = ACTIONS(1),
    [sym_raw_string_content] = ACTIONS(1),
  },
  [1] = {
    [sym_translation_unit] = STATE(8801),
    [sym__top_level_item] = STATE(85),
    [sym_preproc_include] = STATE(85),
    [sym_preproc_def] = STATE(85),
    [sym_preproc_function_def] = STATE(85),
    [sym_preproc_call] = STATE(85),
    [sym_preproc_if] = STATE(85),
    [sym_preproc_ifdef] = STATE(85),
    [sym_function_definition] = STATE(85),
    [sym_declaration] = STATE(85),
    [sym_type_definition] = STATE(85),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5203),
    [sym_linkage_specification] = STATE(85),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1822),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6613),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(85),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2248),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(691),
    [sym__top_level_statement] = STATE(85),
    [sym_labeled_statement] = STATE(85),
    [sym__top_level_expression_statement] = STATE(85),
    [sym_if_statement] = STATE(85),
    [sym_switch_statement] = STATE(85),
    [sym_case_statement] = STATE(85),
    [sym_while_statement] = STATE(85),
    [sym_do_statement] = STATE(85),
    [sym_for_statement] = STATE(85),
    [sym_return_statement] = STATE(85),
    [sym_break_statement] = STATE(85),
    [sym_continue_statement] = STATE(85),
    [sym_goto_statement] = STATE(85),
    [sym_expression] = STATE(5165),
    [sym__string] = STATE(5344),
    [sym_conditional_expression] = STATE(5344),
    [sym_assignment_expression] = STATE(5344),
    [sym_pointer_expression] = STATE(4092),
    [sym_unary_expression] = STATE(5344),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(5344),
    [sym_cast_expression] = STATE(5344),
    [sym_sizeof_expression] = STATE(5344),
    [sym_alignof_expression] = STATE(5344),
    [sym_offsetof_expression] = STATE(5344),
    [sym_generic_expression] = STATE(5344),
    [sym_subscript_expression] = STATE(4092),
    [sym_call_expression] = STATE(4092),
    [sym_gnu_asm_expression] = STATE(5344),
    [sym_field_expression] = STATE(4092),
    [sym_compound_literal_expression] = STATE(5344),
    [sym_parenthesized_expression] = STATE(4092),
    [sym_char_literal] = STATE(5299),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(5344),
    [sym__empty_declaration] = STATE(85),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1706),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(85),
    [sym_template_instantiation] = STATE(85),
    [sym_operator_cast] = STATE(7006),
    [sym__constructor_specifiers] = STATE(1706),
    [sym_operator_cast_definition] = STATE(85),
    [sym_operator_cast_declaration] = STATE(85),
    [sym_constructor_or_destructor_definition] = STATE(85),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5250),
    [sym_namespace_definition] = STATE(85),
    [sym_namespace_alias_definition] = STATE(85),
    [sym_using_declaration] = STATE(85),
    [sym_alias_declaration] = STATE(85),
    [sym_static_assert_declaration] = STATE(85),
    [sym_concept_definition] = STATE(85),
    [sym_for_range_loop] = STATE(85),
    [sym_co_return_statement] = STATE(85),
    [sym_co_yield_statement] = STATE(85),
    [sym_throw_statement] = STATE(85),
    [sym_try_statement] = STATE(85),
    [sym_raw_string_literal] = STATE(4178),
    [sym_co_await_expression] = STATE(5344),
    [sym_new_expression] = STATE(5344),
    [sym_delete_expression] = STATE(5344),
    [sym_requires_clause] = STATE(5344),
    [sym_requires_expression] = STATE(5344),
    [sym_lambda_expression] = STATE(5344),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(5344),
    [sym_parameter_pack_expansion] = STATE(5344),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3937),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7006),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(4092),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_translation_unit_repeat1] = STATE(85),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(606),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1706),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(39),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(81),
    [anon_sym_default] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(111),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(117),
    [sym_false] = ACTIONS(117),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(129),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_namespace] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(141),
    [anon_sym_static_assert] = ACTIONS(143),
    [anon_sym_concept] = ACTIONS(145),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(117),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [2] = {
    [sym__block_item] = STATE(76),
    [sym_preproc_include] = STATE(76),
    [sym_preproc_def] = STATE(76),
    [sym_preproc_function_def] = STATE(76),
    [sym_preproc_call] = STATE(76),
    [sym_preproc_if] = STATE(76),
    [sym_preproc_ifdef] = STATE(76),
    [sym_function_definition] = STATE(76),
    [sym_declaration] = STATE(76),
    [sym_type_definition] = STATE(76),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(76),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(76),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4614),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7479),
    [sym_initializer_pair] = STATE(7479),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(76),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(76),
    [sym_template_instantiation] = STATE(76),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(76),
    [sym_operator_cast_declaration] = STATE(76),
    [sym_constructor_or_destructor_definition] = STATE(76),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(76),
    [sym_namespace_alias_definition] = STATE(76),
    [sym_using_declaration] = STATE(76),
    [sym_alias_declaration] = STATE(76),
    [sym_static_assert_declaration] = STATE(76),
    [sym_concept_definition] = STATE(76),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(76),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(185),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [3] = {
    [sym__block_item] = STATE(77),
    [sym_preproc_include] = STATE(77),
    [sym_preproc_def] = STATE(77),
    [sym_preproc_function_def] = STATE(77),
    [sym_preproc_call] = STATE(77),
    [sym_preproc_if] = STATE(77),
    [sym_preproc_ifdef] = STATE(77),
    [sym_function_definition] = STATE(77),
    [sym_declaration] = STATE(77),
    [sym_type_definition] = STATE(77),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(77),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(77),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4614),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7479),
    [sym_initializer_pair] = STATE(7479),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(77),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(77),
    [sym_template_instantiation] = STATE(77),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(77),
    [sym_operator_cast_declaration] = STATE(77),
    [sym_constructor_or_destructor_definition] = STATE(77),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(77),
    [sym_namespace_alias_definition] = STATE(77),
    [sym_using_declaration] = STATE(77),
    [sym_alias_declaration] = STATE(77),
    [sym_static_assert_declaration] = STATE(77),
    [sym_concept_definition] = STATE(77),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(77),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(241),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [4] = {
    [sym__block_item] = STATE(59),
    [sym_preproc_include] = STATE(59),
    [sym_preproc_def] = STATE(59),
    [sym_preproc_function_def] = STATE(59),
    [sym_preproc_call] = STATE(59),
    [sym_preproc_if] = STATE(59),
    [sym_preproc_ifdef] = STATE(59),
    [sym_function_definition] = STATE(59),
    [sym_declaration] = STATE(59),
    [sym_type_definition] = STATE(59),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(59),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(59),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4614),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7479),
    [sym_initializer_pair] = STATE(7479),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(59),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(59),
    [sym_template_instantiation] = STATE(59),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(59),
    [sym_operator_cast_declaration] = STATE(59),
    [sym_constructor_or_destructor_definition] = STATE(59),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(59),
    [sym_namespace_alias_definition] = STATE(59),
    [sym_using_declaration] = STATE(59),
    [sym_alias_declaration] = STATE(59),
    [sym_static_assert_declaration] = STATE(59),
    [sym_concept_definition] = STATE(59),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(59),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(243),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [5] = {
    [sym__block_item] = STATE(76),
    [sym_preproc_include] = STATE(76),
    [sym_preproc_def] = STATE(76),
    [sym_preproc_function_def] = STATE(76),
    [sym_preproc_call] = STATE(76),
    [sym_preproc_if] = STATE(76),
    [sym_preproc_ifdef] = STATE(76),
    [sym_function_definition] = STATE(76),
    [sym_declaration] = STATE(76),
    [sym_type_definition] = STATE(76),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(76),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(76),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4614),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7479),
    [sym_initializer_pair] = STATE(7479),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(76),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(76),
    [sym_template_instantiation] = STATE(76),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(76),
    [sym_operator_cast_declaration] = STATE(76),
    [sym_constructor_or_destructor_definition] = STATE(76),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(76),
    [sym_namespace_alias_definition] = STATE(76),
    [sym_using_declaration] = STATE(76),
    [sym_alias_declaration] = STATE(76),
    [sym_static_assert_declaration] = STATE(76),
    [sym_concept_definition] = STATE(76),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(76),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(245),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [6] = {
    [sym__block_item] = STATE(67),
    [sym_preproc_include] = STATE(67),
    [sym_preproc_def] = STATE(67),
    [sym_preproc_function_def] = STATE(67),
    [sym_preproc_call] = STATE(67),
    [sym_preproc_if] = STATE(67),
    [sym_preproc_ifdef] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_declaration] = STATE(67),
    [sym_type_definition] = STATE(67),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(67),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(67),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4614),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7479),
    [sym_initializer_pair] = STATE(7479),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(67),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(67),
    [sym_template_instantiation] = STATE(67),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(67),
    [sym_operator_cast_declaration] = STATE(67),
    [sym_constructor_or_destructor_definition] = STATE(67),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(67),
    [sym_namespace_alias_definition] = STATE(67),
    [sym_using_declaration] = STATE(67),
    [sym_alias_declaration] = STATE(67),
    [sym_static_assert_declaration] = STATE(67),
    [sym_concept_definition] = STATE(67),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(67),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(247),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [7] = {
    [sym__block_item] = STATE(60),
    [sym_preproc_include] = STATE(60),
    [sym_preproc_def] = STATE(60),
    [sym_preproc_function_def] = STATE(60),
    [sym_preproc_call] = STATE(60),
    [sym_preproc_if] = STATE(60),
    [sym_preproc_ifdef] = STATE(60),
    [sym_function_definition] = STATE(60),
    [sym_declaration] = STATE(60),
    [sym_type_definition] = STATE(60),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(60),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(60),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4614),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7479),
    [sym_initializer_pair] = STATE(7479),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(60),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(60),
    [sym_template_instantiation] = STATE(60),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(60),
    [sym_operator_cast_declaration] = STATE(60),
    [sym_constructor_or_destructor_definition] = STATE(60),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(60),
    [sym_namespace_alias_definition] = STATE(60),
    [sym_using_declaration] = STATE(60),
    [sym_alias_declaration] = STATE(60),
    [sym_static_assert_declaration] = STATE(60),
    [sym_concept_definition] = STATE(60),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(60),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(249),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [8] = {
    [sym__block_item] = STATE(77),
    [sym_preproc_include] = STATE(77),
    [sym_preproc_def] = STATE(77),
    [sym_preproc_function_def] = STATE(77),
    [sym_preproc_call] = STATE(77),
    [sym_preproc_if] = STATE(77),
    [sym_preproc_ifdef] = STATE(77),
    [sym_function_definition] = STATE(77),
    [sym_declaration] = STATE(77),
    [sym_type_definition] = STATE(77),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(77),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(77),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4614),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7479),
    [sym_initializer_pair] = STATE(7479),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(77),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(77),
    [sym_template_instantiation] = STATE(77),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(77),
    [sym_operator_cast_declaration] = STATE(77),
    [sym_constructor_or_destructor_definition] = STATE(77),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(77),
    [sym_namespace_alias_definition] = STATE(77),
    [sym_using_declaration] = STATE(77),
    [sym_alias_declaration] = STATE(77),
    [sym_static_assert_declaration] = STATE(77),
    [sym_concept_definition] = STATE(77),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(77),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(251),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [9] = {
    [sym__block_item] = STATE(52),
    [sym_preproc_include] = STATE(52),
    [sym_preproc_def] = STATE(52),
    [sym_preproc_function_def] = STATE(52),
    [sym_preproc_call] = STATE(52),
    [sym_preproc_if] = STATE(52),
    [sym_preproc_ifdef] = STATE(52),
    [sym_function_definition] = STATE(52),
    [sym_declaration] = STATE(52),
    [sym_type_definition] = STATE(52),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(52),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(52),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4614),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7479),
    [sym_initializer_pair] = STATE(7479),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(52),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(52),
    [sym_template_instantiation] = STATE(52),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(52),
    [sym_operator_cast_declaration] = STATE(52),
    [sym_constructor_or_destructor_definition] = STATE(52),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(52),
    [sym_namespace_alias_definition] = STATE(52),
    [sym_using_declaration] = STATE(52),
    [sym_alias_declaration] = STATE(52),
    [sym_static_assert_declaration] = STATE(52),
    [sym_concept_definition] = STATE(52),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(52),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(253),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [10] = {
    [sym__block_item] = STATE(52),
    [sym_preproc_include] = STATE(52),
    [sym_preproc_def] = STATE(52),
    [sym_preproc_function_def] = STATE(52),
    [sym_preproc_call] = STATE(52),
    [sym_preproc_if] = STATE(52),
    [sym_preproc_ifdef] = STATE(52),
    [sym_function_definition] = STATE(52),
    [sym_declaration] = STATE(52),
    [sym_type_definition] = STATE(52),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(52),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(52),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4614),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7479),
    [sym_initializer_pair] = STATE(7479),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(52),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(52),
    [sym_template_instantiation] = STATE(52),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(52),
    [sym_operator_cast_declaration] = STATE(52),
    [sym_constructor_or_destructor_definition] = STATE(52),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(52),
    [sym_namespace_alias_definition] = STATE(52),
    [sym_using_declaration] = STATE(52),
    [sym_alias_declaration] = STATE(52),
    [sym_static_assert_declaration] = STATE(52),
    [sym_concept_definition] = STATE(52),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(52),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(255),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [11] = {
    [sym__block_item] = STATE(60),
    [sym_preproc_include] = STATE(60),
    [sym_preproc_def] = STATE(60),
    [sym_preproc_function_def] = STATE(60),
    [sym_preproc_call] = STATE(60),
    [sym_preproc_if] = STATE(60),
    [sym_preproc_ifdef] = STATE(60),
    [sym_function_definition] = STATE(60),
    [sym_declaration] = STATE(60),
    [sym_type_definition] = STATE(60),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(60),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(60),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4614),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7479),
    [sym_initializer_pair] = STATE(7479),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(60),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(60),
    [sym_template_instantiation] = STATE(60),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(60),
    [sym_operator_cast_declaration] = STATE(60),
    [sym_constructor_or_destructor_definition] = STATE(60),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(60),
    [sym_namespace_alias_definition] = STATE(60),
    [sym_using_declaration] = STATE(60),
    [sym_alias_declaration] = STATE(60),
    [sym_static_assert_declaration] = STATE(60),
    [sym_concept_definition] = STATE(60),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(60),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(257),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [12] = {
    [sym__block_item] = STATE(69),
    [sym_preproc_include] = STATE(69),
    [sym_preproc_def] = STATE(69),
    [sym_preproc_function_def] = STATE(69),
    [sym_preproc_call] = STATE(69),
    [sym_preproc_if] = STATE(69),
    [sym_preproc_ifdef] = STATE(69),
    [sym_function_definition] = STATE(69),
    [sym_declaration] = STATE(69),
    [sym_type_definition] = STATE(69),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(69),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(69),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4614),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7479),
    [sym_initializer_pair] = STATE(7479),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(69),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(69),
    [sym_template_instantiation] = STATE(69),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(69),
    [sym_operator_cast_declaration] = STATE(69),
    [sym_constructor_or_destructor_definition] = STATE(69),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(69),
    [sym_namespace_alias_definition] = STATE(69),
    [sym_using_declaration] = STATE(69),
    [sym_alias_declaration] = STATE(69),
    [sym_static_assert_declaration] = STATE(69),
    [sym_concept_definition] = STATE(69),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(69),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(259),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [13] = {
    [sym__block_item] = STATE(29),
    [sym_preproc_include] = STATE(29),
    [sym_preproc_def] = STATE(29),
    [sym_preproc_function_def] = STATE(29),
    [sym_preproc_call] = STATE(29),
    [sym_preproc_if] = STATE(29),
    [sym_preproc_ifdef] = STATE(29),
    [sym_preproc_else] = STATE(8797),
    [sym_preproc_elif] = STATE(8797),
    [sym_preproc_elifdef] = STATE(8797),
    [sym_function_definition] = STATE(29),
    [sym_declaration] = STATE(29),
    [sym_type_definition] = STATE(29),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5266),
    [sym_linkage_specification] = STATE(29),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1824),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6582),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(160),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2275),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(188),
    [sym_statement] = STATE(29),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(29),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1698),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(29),
    [sym_template_instantiation] = STATE(29),
    [sym_operator_cast] = STATE(6995),
    [sym__constructor_specifiers] = STATE(1698),
    [sym_operator_cast_definition] = STATE(29),
    [sym_operator_cast_declaration] = STATE(29),
    [sym_constructor_or_destructor_definition] = STATE(29),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(29),
    [sym_namespace_alias_definition] = STATE(29),
    [sym_using_declaration] = STATE(29),
    [sym_alias_declaration] = STATE(29),
    [sym_static_assert_declaration] = STATE(29),
    [sym_concept_definition] = STATE(29),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(6995),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(29),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(269),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [14] = {
    [sym__block_item] = STATE(25),
    [sym_preproc_include] = STATE(25),
    [sym_preproc_def] = STATE(25),
    [sym_preproc_function_def] = STATE(25),
    [sym_preproc_call] = STATE(25),
    [sym_preproc_if] = STATE(25),
    [sym_preproc_ifdef] = STATE(25),
    [sym_preproc_else] = STATE(8245),
    [sym_preproc_elif] = STATE(8245),
    [sym_preproc_elifdef] = STATE(8245),
    [sym_function_definition] = STATE(25),
    [sym_declaration] = STATE(25),
    [sym_type_definition] = STATE(25),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5266),
    [sym_linkage_specification] = STATE(25),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1824),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6582),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(160),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2275),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(188),
    [sym_statement] = STATE(25),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(25),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1698),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(25),
    [sym_template_instantiation] = STATE(25),
    [sym_operator_cast] = STATE(6995),
    [sym__constructor_specifiers] = STATE(1698),
    [sym_operator_cast_definition] = STATE(25),
    [sym_operator_cast_declaration] = STATE(25),
    [sym_constructor_or_destructor_definition] = STATE(25),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(25),
    [sym_namespace_alias_definition] = STATE(25),
    [sym_using_declaration] = STATE(25),
    [sym_alias_declaration] = STATE(25),
    [sym_static_assert_declaration] = STATE(25),
    [sym_concept_definition] = STATE(25),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(6995),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(25),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(337),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [15] = {
    [sym__block_item] = STATE(27),
    [sym_preproc_include] = STATE(27),
    [sym_preproc_def] = STATE(27),
    [sym_preproc_function_def] = STATE(27),
    [sym_preproc_call] = STATE(27),
    [sym_preproc_if] = STATE(27),
    [sym_preproc_ifdef] = STATE(27),
    [sym_preproc_else] = STATE(8743),
    [sym_preproc_elif] = STATE(8743),
    [sym_preproc_elifdef] = STATE(8743),
    [sym_function_definition] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_type_definition] = STATE(27),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5266),
    [sym_linkage_specification] = STATE(27),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1824),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6582),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(160),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2275),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(188),
    [sym_statement] = STATE(27),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(27),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1698),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(27),
    [sym_template_instantiation] = STATE(27),
    [sym_operator_cast] = STATE(6995),
    [sym__constructor_specifiers] = STATE(1698),
    [sym_operator_cast_definition] = STATE(27),
    [sym_operator_cast_declaration] = STATE(27),
    [sym_constructor_or_destructor_definition] = STATE(27),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(27),
    [sym_namespace_alias_definition] = STATE(27),
    [sym_using_declaration] = STATE(27),
    [sym_alias_declaration] = STATE(27),
    [sym_static_assert_declaration] = STATE(27),
    [sym_concept_definition] = STATE(27),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(6995),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(27),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(339),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [16] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8727),
    [sym_preproc_elif] = STATE(8727),
    [sym_preproc_elifdef] = STATE(8727),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5266),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1824),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6582),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(160),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2275),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(188),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1698),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6995),
    [sym__constructor_specifiers] = STATE(1698),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(6995),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(341),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [17] = {
    [sym__block_item] = STATE(18),
    [sym_preproc_include] = STATE(18),
    [sym_preproc_def] = STATE(18),
    [sym_preproc_function_def] = STATE(18),
    [sym_preproc_call] = STATE(18),
    [sym_preproc_if] = STATE(18),
    [sym_preproc_ifdef] = STATE(18),
    [sym_preproc_else] = STATE(8505),
    [sym_preproc_elif] = STATE(8505),
    [sym_preproc_elifdef] = STATE(8505),
    [sym_function_definition] = STATE(18),
    [sym_declaration] = STATE(18),
    [sym_type_definition] = STATE(18),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5266),
    [sym_linkage_specification] = STATE(18),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1824),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6582),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(160),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2275),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(188),
    [sym_statement] = STATE(18),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(18),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1698),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(18),
    [sym_template_instantiation] = STATE(18),
    [sym_operator_cast] = STATE(6995),
    [sym__constructor_specifiers] = STATE(1698),
    [sym_operator_cast_definition] = STATE(18),
    [sym_operator_cast_declaration] = STATE(18),
    [sym_constructor_or_destructor_definition] = STATE(18),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(18),
    [sym_namespace_alias_definition] = STATE(18),
    [sym_using_declaration] = STATE(18),
    [sym_alias_declaration] = STATE(18),
    [sym_static_assert_declaration] = STATE(18),
    [sym_concept_definition] = STATE(18),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(6995),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(18),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(343),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [18] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8771),
    [sym_preproc_elif] = STATE(8771),
    [sym_preproc_elifdef] = STATE(8771),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5266),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1824),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6582),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(160),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2275),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(188),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1698),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6995),
    [sym__constructor_specifiers] = STATE(1698),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(6995),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(345),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [19] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8792),
    [sym_preproc_elif] = STATE(8792),
    [sym_preproc_elifdef] = STATE(8792),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5266),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1824),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6582),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(160),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2275),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(188),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1698),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6995),
    [sym__constructor_specifiers] = STATE(1698),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(6995),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(347),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [20] = {
    [sym__block_item] = STATE(26),
    [sym_preproc_include] = STATE(26),
    [sym_preproc_def] = STATE(26),
    [sym_preproc_function_def] = STATE(26),
    [sym_preproc_call] = STATE(26),
    [sym_preproc_if] = STATE(26),
    [sym_preproc_ifdef] = STATE(26),
    [sym_preproc_else] = STATE(8607),
    [sym_preproc_elif] = STATE(8607),
    [sym_preproc_elifdef] = STATE(8607),
    [sym_function_definition] = STATE(26),
    [sym_declaration] = STATE(26),
    [sym_type_definition] = STATE(26),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5266),
    [sym_linkage_specification] = STATE(26),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1824),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6582),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(160),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2275),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(188),
    [sym_statement] = STATE(26),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(26),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1698),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(26),
    [sym_template_instantiation] = STATE(26),
    [sym_operator_cast] = STATE(6995),
    [sym__constructor_specifiers] = STATE(1698),
    [sym_operator_cast_definition] = STATE(26),
    [sym_operator_cast_declaration] = STATE(26),
    [sym_constructor_or_destructor_definition] = STATE(26),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(26),
    [sym_namespace_alias_definition] = STATE(26),
    [sym_using_declaration] = STATE(26),
    [sym_alias_declaration] = STATE(26),
    [sym_static_assert_declaration] = STATE(26),
    [sym_concept_definition] = STATE(26),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(6995),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(26),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(349),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [21] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8476),
    [sym_preproc_elif] = STATE(8476),
    [sym_preproc_elifdef] = STATE(8476),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5266),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1824),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6582),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(160),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2275),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(188),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1698),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6995),
    [sym__constructor_specifiers] = STATE(1698),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(6995),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(351),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [22] = {
    [sym__block_item] = STATE(23),
    [sym_preproc_include] = STATE(23),
    [sym_preproc_def] = STATE(23),
    [sym_preproc_function_def] = STATE(23),
    [sym_preproc_call] = STATE(23),
    [sym_preproc_if] = STATE(23),
    [sym_preproc_ifdef] = STATE(23),
    [sym_preproc_else] = STATE(8766),
    [sym_preproc_elif] = STATE(8766),
    [sym_preproc_elifdef] = STATE(8766),
    [sym_function_definition] = STATE(23),
    [sym_declaration] = STATE(23),
    [sym_type_definition] = STATE(23),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5266),
    [sym_linkage_specification] = STATE(23),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1824),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6582),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(160),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2275),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(188),
    [sym_statement] = STATE(23),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(23),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1698),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(23),
    [sym_template_instantiation] = STATE(23),
    [sym_operator_cast] = STATE(6995),
    [sym__constructor_specifiers] = STATE(1698),
    [sym_operator_cast_definition] = STATE(23),
    [sym_operator_cast_declaration] = STATE(23),
    [sym_constructor_or_destructor_definition] = STATE(23),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(23),
    [sym_namespace_alias_definition] = STATE(23),
    [sym_using_declaration] = STATE(23),
    [sym_alias_declaration] = STATE(23),
    [sym_static_assert_declaration] = STATE(23),
    [sym_concept_definition] = STATE(23),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(6995),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(23),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(353),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [23] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8916),
    [sym_preproc_elif] = STATE(8916),
    [sym_preproc_elifdef] = STATE(8916),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5266),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1824),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6582),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(160),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2275),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(188),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1698),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6995),
    [sym__constructor_specifiers] = STATE(1698),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(6995),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(355),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [24] = {
    [sym__block_item] = STATE(21),
    [sym_preproc_include] = STATE(21),
    [sym_preproc_def] = STATE(21),
    [sym_preproc_function_def] = STATE(21),
    [sym_preproc_call] = STATE(21),
    [sym_preproc_if] = STATE(21),
    [sym_preproc_ifdef] = STATE(21),
    [sym_preproc_else] = STATE(8707),
    [sym_preproc_elif] = STATE(8707),
    [sym_preproc_elifdef] = STATE(8707),
    [sym_function_definition] = STATE(21),
    [sym_declaration] = STATE(21),
    [sym_type_definition] = STATE(21),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5266),
    [sym_linkage_specification] = STATE(21),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1824),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6582),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(160),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2275),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(188),
    [sym_statement] = STATE(21),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(21),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1698),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(21),
    [sym_template_instantiation] = STATE(21),
    [sym_operator_cast] = STATE(6995),
    [sym__constructor_specifiers] = STATE(1698),
    [sym_operator_cast_definition] = STATE(21),
    [sym_operator_cast_declaration] = STATE(21),
    [sym_constructor_or_destructor_definition] = STATE(21),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(21),
    [sym_namespace_alias_definition] = STATE(21),
    [sym_using_declaration] = STATE(21),
    [sym_alias_declaration] = STATE(21),
    [sym_static_assert_declaration] = STATE(21),
    [sym_concept_definition] = STATE(21),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(6995),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(21),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(357),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [25] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8214),
    [sym_preproc_elif] = STATE(8214),
    [sym_preproc_elifdef] = STATE(8214),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5266),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1824),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6582),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(160),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2275),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(188),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1698),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6995),
    [sym__constructor_specifiers] = STATE(1698),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(6995),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(359),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [26] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8474),
    [sym_preproc_elif] = STATE(8474),
    [sym_preproc_elifdef] = STATE(8474),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5266),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1824),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6582),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(160),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2275),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(188),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1698),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6995),
    [sym__constructor_specifiers] = STATE(1698),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(6995),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(361),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [27] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8254),
    [sym_preproc_elif] = STATE(8254),
    [sym_preproc_elifdef] = STATE(8254),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5266),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1824),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6582),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(160),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2275),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(188),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1698),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6995),
    [sym__constructor_specifiers] = STATE(1698),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(6995),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(363),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [28] = {
    [sym__block_item] = STATE(31),
    [sym_preproc_include] = STATE(31),
    [sym_preproc_def] = STATE(31),
    [sym_preproc_function_def] = STATE(31),
    [sym_preproc_call] = STATE(31),
    [sym_preproc_if] = STATE(31),
    [sym_preproc_ifdef] = STATE(31),
    [sym_preproc_else] = STATE(8218),
    [sym_preproc_elif] = STATE(8218),
    [sym_preproc_elifdef] = STATE(8218),
    [sym_function_definition] = STATE(31),
    [sym_declaration] = STATE(31),
    [sym_type_definition] = STATE(31),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5266),
    [sym_linkage_specification] = STATE(31),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1824),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6582),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(160),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2275),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(188),
    [sym_statement] = STATE(31),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(31),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1698),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(31),
    [sym_template_instantiation] = STATE(31),
    [sym_operator_cast] = STATE(6995),
    [sym__constructor_specifiers] = STATE(1698),
    [sym_operator_cast_definition] = STATE(31),
    [sym_operator_cast_declaration] = STATE(31),
    [sym_constructor_or_destructor_definition] = STATE(31),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(31),
    [sym_namespace_alias_definition] = STATE(31),
    [sym_using_declaration] = STATE(31),
    [sym_alias_declaration] = STATE(31),
    [sym_static_assert_declaration] = STATE(31),
    [sym_concept_definition] = STATE(31),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(6995),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(31),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(365),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [29] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8488),
    [sym_preproc_elif] = STATE(8488),
    [sym_preproc_elifdef] = STATE(8488),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5266),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1824),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6582),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(160),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2275),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(188),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1698),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6995),
    [sym__constructor_specifiers] = STATE(1698),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(6995),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(367),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [30] = {
    [sym__block_item] = STATE(16),
    [sym_preproc_include] = STATE(16),
    [sym_preproc_def] = STATE(16),
    [sym_preproc_function_def] = STATE(16),
    [sym_preproc_call] = STATE(16),
    [sym_preproc_if] = STATE(16),
    [sym_preproc_ifdef] = STATE(16),
    [sym_preproc_else] = STATE(8495),
    [sym_preproc_elif] = STATE(8495),
    [sym_preproc_elifdef] = STATE(8495),
    [sym_function_definition] = STATE(16),
    [sym_declaration] = STATE(16),
    [sym_type_definition] = STATE(16),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5266),
    [sym_linkage_specification] = STATE(16),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1824),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6582),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(160),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2275),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(188),
    [sym_statement] = STATE(16),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(16),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1698),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(16),
    [sym_template_instantiation] = STATE(16),
    [sym_operator_cast] = STATE(6995),
    [sym__constructor_specifiers] = STATE(1698),
    [sym_operator_cast_definition] = STATE(16),
    [sym_operator_cast_declaration] = STATE(16),
    [sym_constructor_or_destructor_definition] = STATE(16),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(16),
    [sym_namespace_alias_definition] = STATE(16),
    [sym_using_declaration] = STATE(16),
    [sym_alias_declaration] = STATE(16),
    [sym_static_assert_declaration] = STATE(16),
    [sym_concept_definition] = STATE(16),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(6995),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(16),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(369),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [31] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8506),
    [sym_preproc_elif] = STATE(8506),
    [sym_preproc_elifdef] = STATE(8506),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5266),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1824),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6582),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(160),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2275),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(188),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1698),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6995),
    [sym__constructor_specifiers] = STATE(1698),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(6995),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(371),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [32] = {
    [sym__block_item] = STATE(19),
    [sym_preproc_include] = STATE(19),
    [sym_preproc_def] = STATE(19),
    [sym_preproc_function_def] = STATE(19),
    [sym_preproc_call] = STATE(19),
    [sym_preproc_if] = STATE(19),
    [sym_preproc_ifdef] = STATE(19),
    [sym_preproc_else] = STATE(8817),
    [sym_preproc_elif] = STATE(8817),
    [sym_preproc_elifdef] = STATE(8817),
    [sym_function_definition] = STATE(19),
    [sym_declaration] = STATE(19),
    [sym_type_definition] = STATE(19),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5266),
    [sym_linkage_specification] = STATE(19),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1824),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6582),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(160),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2275),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(188),
    [sym_statement] = STATE(19),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(19),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1698),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(19),
    [sym_template_instantiation] = STATE(19),
    [sym_operator_cast] = STATE(6995),
    [sym__constructor_specifiers] = STATE(1698),
    [sym_operator_cast_definition] = STATE(19),
    [sym_operator_cast_declaration] = STATE(19),
    [sym_constructor_or_destructor_definition] = STATE(19),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(19),
    [sym_namespace_alias_definition] = STATE(19),
    [sym_using_declaration] = STATE(19),
    [sym_alias_declaration] = STATE(19),
    [sym_static_assert_declaration] = STATE(19),
    [sym_concept_definition] = STATE(19),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(6995),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(19),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(373),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [33] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5266),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1824),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6582),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(160),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2275),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(188),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1698),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6995),
    [sym__constructor_specifiers] = STATE(1698),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(6995),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1698),
    [sym_identifier] = ACTIONS(375),
    [aux_sym_preproc_include_token1] = ACTIONS(378),
    [aux_sym_preproc_def_token1] = ACTIONS(381),
    [aux_sym_preproc_if_token1] = ACTIONS(384),
    [aux_sym_preproc_if_token2] = ACTIONS(387),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(389),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(389),
    [aux_sym_preproc_else_token1] = ACTIONS(387),
    [aux_sym_preproc_elif_token1] = ACTIONS(387),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(387),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(387),
    [sym_preproc_directive] = ACTIONS(392),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(398),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_DASH] = ACTIONS(404),
    [anon_sym_PLUS] = ACTIONS(404),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(410),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(416),
    [anon_sym___extension__] = ACTIONS(419),
    [anon_sym_typedef] = ACTIONS(422),
    [anon_sym___device__] = ACTIONS(425),
    [anon_sym___host__] = ACTIONS(425),
    [anon_sym___global__] = ACTIONS(425),
    [anon_sym___forceinline__] = ACTIONS(425),
    [anon_sym___noinline__] = ACTIONS(425),
    [anon_sym_extern] = ACTIONS(428),
    [anon_sym___attribute__] = ACTIONS(431),
    [anon_sym_COLON_COLON] = ACTIONS(434),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(437),
    [anon_sym___declspec] = ACTIONS(440),
    [anon_sym___based] = ACTIONS(443),
    [anon_sym___cdecl] = ACTIONS(446),
    [anon_sym___clrcall] = ACTIONS(446),
    [anon_sym___stdcall] = ACTIONS(446),
    [anon_sym___fastcall] = ACTIONS(446),
    [anon_sym___thiscall] = ACTIONS(446),
    [anon_sym___vectorcall] = ACTIONS(446),
    [anon_sym_LBRACE] = ACTIONS(449),
    [anon_sym_signed] = ACTIONS(452),
    [anon_sym_unsigned] = ACTIONS(452),
    [anon_sym_long] = ACTIONS(452),
    [anon_sym_short] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(455),
    [anon_sym_static] = ACTIONS(458),
    [anon_sym_register] = ACTIONS(458),
    [anon_sym_inline] = ACTIONS(461),
    [anon_sym___inline] = ACTIONS(458),
    [anon_sym___inline__] = ACTIONS(458),
    [anon_sym___forceinline] = ACTIONS(458),
    [anon_sym_thread_local] = ACTIONS(458),
    [anon_sym___thread] = ACTIONS(458),
    [anon_sym_const] = ACTIONS(464),
    [anon_sym_constexpr] = ACTIONS(464),
    [anon_sym_volatile] = ACTIONS(464),
    [anon_sym_restrict] = ACTIONS(464),
    [anon_sym___restrict__] = ACTIONS(464),
    [anon_sym__Atomic] = ACTIONS(464),
    [anon_sym__Noreturn] = ACTIONS(464),
    [anon_sym_noreturn] = ACTIONS(464),
    [anon_sym_mutable] = ACTIONS(464),
    [anon_sym_constinit] = ACTIONS(464),
    [anon_sym_consteval] = ACTIONS(464),
    [anon_sym___shared__] = ACTIONS(464),
    [anon_sym___local__] = ACTIONS(464),
    [anon_sym___constant__] = ACTIONS(464),
    [anon_sym___managed__] = ACTIONS(464),
    [anon_sym___grid_constant__] = ACTIONS(464),
    [anon_sym_alignas] = ACTIONS(467),
    [anon_sym__Alignas] = ACTIONS(467),
    [sym_primitive_type] = ACTIONS(470),
    [anon_sym_enum] = ACTIONS(473),
    [anon_sym_class] = ACTIONS(476),
    [anon_sym_struct] = ACTIONS(479),
    [anon_sym_union] = ACTIONS(482),
    [anon_sym_if] = ACTIONS(485),
    [anon_sym_switch] = ACTIONS(488),
    [anon_sym_case] = ACTIONS(491),
    [anon_sym_default] = ACTIONS(494),
    [anon_sym_while] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(500),
    [anon_sym_for] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_break] = ACTIONS(509),
    [anon_sym_continue] = ACTIONS(512),
    [anon_sym_goto] = ACTIONS(515),
    [anon_sym___try] = ACTIONS(518),
    [anon_sym___leave] = ACTIONS(521),
    [anon_sym_not] = ACTIONS(404),
    [anon_sym_compl] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(524),
    [anon_sym_PLUS_PLUS] = ACTIONS(524),
    [anon_sym_sizeof] = ACTIONS(527),
    [anon_sym___alignof__] = ACTIONS(530),
    [anon_sym___alignof] = ACTIONS(530),
    [anon_sym__alignof] = ACTIONS(530),
    [anon_sym_alignof] = ACTIONS(530),
    [anon_sym__Alignof] = ACTIONS(530),
    [anon_sym_offsetof] = ACTIONS(533),
    [anon_sym__Generic] = ACTIONS(536),
    [anon_sym_asm] = ACTIONS(539),
    [anon_sym___asm__] = ACTIONS(539),
    [sym_number_literal] = ACTIONS(542),
    [anon_sym_L_SQUOTE] = ACTIONS(545),
    [anon_sym_u_SQUOTE] = ACTIONS(545),
    [anon_sym_U_SQUOTE] = ACTIONS(545),
    [anon_sym_u8_SQUOTE] = ACTIONS(545),
    [anon_sym_SQUOTE] = ACTIONS(545),
    [anon_sym_L_DQUOTE] = ACTIONS(548),
    [anon_sym_u_DQUOTE] = ACTIONS(548),
    [anon_sym_U_DQUOTE] = ACTIONS(548),
    [anon_sym_u8_DQUOTE] = ACTIONS(548),
    [anon_sym_DQUOTE] = ACTIONS(548),
    [sym_true] = ACTIONS(551),
    [sym_false] = ACTIONS(551),
    [anon_sym_NULL] = ACTIONS(554),
    [anon_sym_nullptr] = ACTIONS(554),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(557),
    [anon_sym_decltype] = ACTIONS(560),
    [sym_virtual] = ACTIONS(425),
    [anon_sym_explicit] = ACTIONS(563),
    [anon_sym_typename] = ACTIONS(566),
    [anon_sym_template] = ACTIONS(569),
    [anon_sym_operator] = ACTIONS(572),
    [anon_sym_try] = ACTIONS(575),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_throw] = ACTIONS(581),
    [anon_sym_namespace] = ACTIONS(584),
    [anon_sym_using] = ACTIONS(587),
    [anon_sym_static_assert] = ACTIONS(590),
    [anon_sym_concept] = ACTIONS(593),
    [anon_sym_co_return] = ACTIONS(596),
    [anon_sym_co_yield] = ACTIONS(599),
    [anon_sym_R_DQUOTE] = ACTIONS(602),
    [anon_sym_LR_DQUOTE] = ACTIONS(602),
    [anon_sym_uR_DQUOTE] = ACTIONS(602),
    [anon_sym_UR_DQUOTE] = ACTIONS(602),
    [anon_sym_u8R_DQUOTE] = ACTIONS(602),
    [anon_sym_co_await] = ACTIONS(605),
    [anon_sym_new] = ACTIONS(608),
    [anon_sym_requires] = ACTIONS(611),
    [sym_this] = ACTIONS(551),
    [anon_sym___launch_bounds__] = ACTIONS(614),
  },
  [34] = {
    [sym__block_item] = STATE(64),
    [sym_preproc_include] = STATE(64),
    [sym_preproc_def] = STATE(64),
    [sym_preproc_function_def] = STATE(64),
    [sym_preproc_call] = STATE(64),
    [sym_preproc_if] = STATE(64),
    [sym_preproc_ifdef] = STATE(64),
    [sym_function_definition] = STATE(64),
    [sym_declaration] = STATE(64),
    [sym_type_definition] = STATE(64),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(64),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(64),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(64),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(64),
    [sym_template_instantiation] = STATE(64),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(64),
    [sym_operator_cast_declaration] = STATE(64),
    [sym_constructor_or_destructor_definition] = STATE(64),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(64),
    [sym_namespace_alias_definition] = STATE(64),
    [sym_using_declaration] = STATE(64),
    [sym_alias_declaration] = STATE(64),
    [sym_static_assert_declaration] = STATE(64),
    [sym_concept_definition] = STATE(64),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(64),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(621),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [35] = {
    [sym__block_item] = STATE(62),
    [sym_preproc_include] = STATE(62),
    [sym_preproc_def] = STATE(62),
    [sym_preproc_function_def] = STATE(62),
    [sym_preproc_call] = STATE(62),
    [sym_preproc_if] = STATE(62),
    [sym_preproc_ifdef] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(62),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(62),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(62),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(62),
    [sym_template_instantiation] = STATE(62),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(62),
    [sym_operator_cast_declaration] = STATE(62),
    [sym_constructor_or_destructor_definition] = STATE(62),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(62),
    [sym_namespace_alias_definition] = STATE(62),
    [sym_using_declaration] = STATE(62),
    [sym_alias_declaration] = STATE(62),
    [sym_static_assert_declaration] = STATE(62),
    [sym_concept_definition] = STATE(62),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(62),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(623),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [36] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(625),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [37] = {
    [sym__block_item] = STATE(73),
    [sym_preproc_include] = STATE(73),
    [sym_preproc_def] = STATE(73),
    [sym_preproc_function_def] = STATE(73),
    [sym_preproc_call] = STATE(73),
    [sym_preproc_if] = STATE(73),
    [sym_preproc_ifdef] = STATE(73),
    [sym_function_definition] = STATE(73),
    [sym_declaration] = STATE(73),
    [sym_type_definition] = STATE(73),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(73),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(73),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(73),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(73),
    [sym_template_instantiation] = STATE(73),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(73),
    [sym_operator_cast_declaration] = STATE(73),
    [sym_constructor_or_destructor_definition] = STATE(73),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(73),
    [sym_namespace_alias_definition] = STATE(73),
    [sym_using_declaration] = STATE(73),
    [sym_alias_declaration] = STATE(73),
    [sym_static_assert_declaration] = STATE(73),
    [sym_concept_definition] = STATE(73),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(73),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(627),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [38] = {
    [sym__block_item] = STATE(62),
    [sym_preproc_include] = STATE(62),
    [sym_preproc_def] = STATE(62),
    [sym_preproc_function_def] = STATE(62),
    [sym_preproc_call] = STATE(62),
    [sym_preproc_if] = STATE(62),
    [sym_preproc_ifdef] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(62),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(62),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(62),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(62),
    [sym_template_instantiation] = STATE(62),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(62),
    [sym_operator_cast_declaration] = STATE(62),
    [sym_constructor_or_destructor_definition] = STATE(62),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(62),
    [sym_namespace_alias_definition] = STATE(62),
    [sym_using_declaration] = STATE(62),
    [sym_alias_declaration] = STATE(62),
    [sym_static_assert_declaration] = STATE(62),
    [sym_concept_definition] = STATE(62),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(62),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(629),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [39] = {
    [sym__block_item] = STATE(69),
    [sym_preproc_include] = STATE(69),
    [sym_preproc_def] = STATE(69),
    [sym_preproc_function_def] = STATE(69),
    [sym_preproc_call] = STATE(69),
    [sym_preproc_if] = STATE(69),
    [sym_preproc_ifdef] = STATE(69),
    [sym_function_definition] = STATE(69),
    [sym_declaration] = STATE(69),
    [sym_type_definition] = STATE(69),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(69),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(69),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(69),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(69),
    [sym_template_instantiation] = STATE(69),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(69),
    [sym_operator_cast_declaration] = STATE(69),
    [sym_constructor_or_destructor_definition] = STATE(69),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(69),
    [sym_namespace_alias_definition] = STATE(69),
    [sym_using_declaration] = STATE(69),
    [sym_alias_declaration] = STATE(69),
    [sym_static_assert_declaration] = STATE(69),
    [sym_concept_definition] = STATE(69),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(69),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(631),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [40] = {
    [sym__block_item] = STATE(38),
    [sym_preproc_include] = STATE(38),
    [sym_preproc_def] = STATE(38),
    [sym_preproc_function_def] = STATE(38),
    [sym_preproc_call] = STATE(38),
    [sym_preproc_if] = STATE(38),
    [sym_preproc_ifdef] = STATE(38),
    [sym_function_definition] = STATE(38),
    [sym_declaration] = STATE(38),
    [sym_type_definition] = STATE(38),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(38),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(38),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(38),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(38),
    [sym_template_instantiation] = STATE(38),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(38),
    [sym_operator_cast_declaration] = STATE(38),
    [sym_constructor_or_destructor_definition] = STATE(38),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(38),
    [sym_namespace_alias_definition] = STATE(38),
    [sym_using_declaration] = STATE(38),
    [sym_alias_declaration] = STATE(38),
    [sym_static_assert_declaration] = STATE(38),
    [sym_concept_definition] = STATE(38),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(38),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(633),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [41] = {
    [sym__block_item] = STATE(62),
    [sym_preproc_include] = STATE(62),
    [sym_preproc_def] = STATE(62),
    [sym_preproc_function_def] = STATE(62),
    [sym_preproc_call] = STATE(62),
    [sym_preproc_if] = STATE(62),
    [sym_preproc_ifdef] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(62),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(62),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(62),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(62),
    [sym_template_instantiation] = STATE(62),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(62),
    [sym_operator_cast_declaration] = STATE(62),
    [sym_constructor_or_destructor_definition] = STATE(62),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(62),
    [sym_namespace_alias_definition] = STATE(62),
    [sym_using_declaration] = STATE(62),
    [sym_alias_declaration] = STATE(62),
    [sym_static_assert_declaration] = STATE(62),
    [sym_concept_definition] = STATE(62),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(62),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(635),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [42] = {
    [sym__block_item] = STATE(71),
    [sym_preproc_include] = STATE(71),
    [sym_preproc_def] = STATE(71),
    [sym_preproc_function_def] = STATE(71),
    [sym_preproc_call] = STATE(71),
    [sym_preproc_if] = STATE(71),
    [sym_preproc_ifdef] = STATE(71),
    [sym_function_definition] = STATE(71),
    [sym_declaration] = STATE(71),
    [sym_type_definition] = STATE(71),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5201),
    [sym_linkage_specification] = STATE(71),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1837),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6595),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(351),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2274),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(444),
    [sym_statement] = STATE(71),
    [sym_labeled_statement] = STATE(351),
    [sym_expression_statement] = STATE(351),
    [sym_if_statement] = STATE(351),
    [sym_switch_statement] = STATE(351),
    [sym_case_statement] = STATE(351),
    [sym_while_statement] = STATE(351),
    [sym_do_statement] = STATE(351),
    [sym_for_statement] = STATE(351),
    [sym_return_statement] = STATE(351),
    [sym_break_statement] = STATE(351),
    [sym_continue_statement] = STATE(351),
    [sym_goto_statement] = STATE(351),
    [sym_seh_try_statement] = STATE(351),
    [sym_seh_leave_statement] = STATE(351),
    [sym_expression] = STATE(4855),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8338),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(71),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1704),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(71),
    [sym_template_instantiation] = STATE(71),
    [sym_operator_cast] = STATE(7017),
    [sym__constructor_specifiers] = STATE(1704),
    [sym_operator_cast_definition] = STATE(71),
    [sym_operator_cast_declaration] = STATE(71),
    [sym_constructor_or_destructor_definition] = STATE(71),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(71),
    [sym_namespace_alias_definition] = STATE(71),
    [sym_using_declaration] = STATE(71),
    [sym_alias_declaration] = STATE(71),
    [sym_static_assert_declaration] = STATE(71),
    [sym_concept_definition] = STATE(71),
    [sym_for_range_loop] = STATE(351),
    [sym_co_return_statement] = STATE(351),
    [sym_co_yield_statement] = STATE(351),
    [sym_throw_statement] = STATE(351),
    [sym_try_statement] = STATE(351),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7017),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(71),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(622),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1704),
    [sym_identifier] = ACTIONS(637),
    [aux_sym_preproc_include_token1] = ACTIONS(639),
    [aux_sym_preproc_def_token1] = ACTIONS(641),
    [aux_sym_preproc_if_token1] = ACTIONS(643),
    [aux_sym_preproc_if_token2] = ACTIONS(645),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(647),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(647),
    [sym_preproc_directive] = ACTIONS(649),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(651),
    [anon_sym___extension__] = ACTIONS(653),
    [anon_sym_typedef] = ACTIONS(655),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(657),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(661),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(663),
    [anon_sym_switch] = ACTIONS(665),
    [anon_sym_case] = ACTIONS(667),
    [anon_sym_default] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_do] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(677),
    [anon_sym_break] = ACTIONS(679),
    [anon_sym_continue] = ACTIONS(681),
    [anon_sym_goto] = ACTIONS(683),
    [anon_sym___try] = ACTIONS(685),
    [anon_sym___leave] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(689),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(691),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_using] = ACTIONS(697),
    [anon_sym_static_assert] = ACTIONS(699),
    [anon_sym_concept] = ACTIONS(701),
    [anon_sym_co_return] = ACTIONS(703),
    [anon_sym_co_yield] = ACTIONS(705),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [43] = {
    [sym__block_item] = STATE(62),
    [sym_preproc_include] = STATE(62),
    [sym_preproc_def] = STATE(62),
    [sym_preproc_function_def] = STATE(62),
    [sym_preproc_call] = STATE(62),
    [sym_preproc_if] = STATE(62),
    [sym_preproc_ifdef] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(62),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(62),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(62),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(62),
    [sym_template_instantiation] = STATE(62),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(62),
    [sym_operator_cast_declaration] = STATE(62),
    [sym_constructor_or_destructor_definition] = STATE(62),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(62),
    [sym_namespace_alias_definition] = STATE(62),
    [sym_using_declaration] = STATE(62),
    [sym_alias_declaration] = STATE(62),
    [sym_static_assert_declaration] = STATE(62),
    [sym_concept_definition] = STATE(62),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(62),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(707),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [44] = {
    [sym__block_item] = STATE(62),
    [sym_preproc_include] = STATE(62),
    [sym_preproc_def] = STATE(62),
    [sym_preproc_function_def] = STATE(62),
    [sym_preproc_call] = STATE(62),
    [sym_preproc_if] = STATE(62),
    [sym_preproc_ifdef] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(62),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(62),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(62),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(62),
    [sym_template_instantiation] = STATE(62),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(62),
    [sym_operator_cast_declaration] = STATE(62),
    [sym_constructor_or_destructor_definition] = STATE(62),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(62),
    [sym_namespace_alias_definition] = STATE(62),
    [sym_using_declaration] = STATE(62),
    [sym_alias_declaration] = STATE(62),
    [sym_static_assert_declaration] = STATE(62),
    [sym_concept_definition] = STATE(62),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(62),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(709),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [45] = {
    [sym__block_item] = STATE(44),
    [sym_preproc_include] = STATE(44),
    [sym_preproc_def] = STATE(44),
    [sym_preproc_function_def] = STATE(44),
    [sym_preproc_call] = STATE(44),
    [sym_preproc_if] = STATE(44),
    [sym_preproc_ifdef] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_declaration] = STATE(44),
    [sym_type_definition] = STATE(44),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(44),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(44),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(44),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(44),
    [sym_template_instantiation] = STATE(44),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(44),
    [sym_operator_cast_declaration] = STATE(44),
    [sym_constructor_or_destructor_definition] = STATE(44),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(44),
    [sym_namespace_alias_definition] = STATE(44),
    [sym_using_declaration] = STATE(44),
    [sym_alias_declaration] = STATE(44),
    [sym_static_assert_declaration] = STATE(44),
    [sym_concept_definition] = STATE(44),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(44),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(711),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [46] = {
    [sym__block_item] = STATE(62),
    [sym_preproc_include] = STATE(62),
    [sym_preproc_def] = STATE(62),
    [sym_preproc_function_def] = STATE(62),
    [sym_preproc_call] = STATE(62),
    [sym_preproc_if] = STATE(62),
    [sym_preproc_ifdef] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(62),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(62),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(62),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(62),
    [sym_template_instantiation] = STATE(62),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(62),
    [sym_operator_cast_declaration] = STATE(62),
    [sym_constructor_or_destructor_definition] = STATE(62),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(62),
    [sym_namespace_alias_definition] = STATE(62),
    [sym_using_declaration] = STATE(62),
    [sym_alias_declaration] = STATE(62),
    [sym_static_assert_declaration] = STATE(62),
    [sym_concept_definition] = STATE(62),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(62),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(713),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [47] = {
    [sym__block_item] = STATE(50),
    [sym_preproc_include] = STATE(50),
    [sym_preproc_def] = STATE(50),
    [sym_preproc_function_def] = STATE(50),
    [sym_preproc_call] = STATE(50),
    [sym_preproc_if] = STATE(50),
    [sym_preproc_ifdef] = STATE(50),
    [sym_function_definition] = STATE(50),
    [sym_declaration] = STATE(50),
    [sym_type_definition] = STATE(50),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(50),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(50),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(50),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(50),
    [sym_template_instantiation] = STATE(50),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(50),
    [sym_operator_cast_declaration] = STATE(50),
    [sym_constructor_or_destructor_definition] = STATE(50),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(50),
    [sym_namespace_alias_definition] = STATE(50),
    [sym_using_declaration] = STATE(50),
    [sym_alias_declaration] = STATE(50),
    [sym_static_assert_declaration] = STATE(50),
    [sym_concept_definition] = STATE(50),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(50),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(715),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [48] = {
    [sym__block_item] = STATE(46),
    [sym_preproc_include] = STATE(46),
    [sym_preproc_def] = STATE(46),
    [sym_preproc_function_def] = STATE(46),
    [sym_preproc_call] = STATE(46),
    [sym_preproc_if] = STATE(46),
    [sym_preproc_ifdef] = STATE(46),
    [sym_function_definition] = STATE(46),
    [sym_declaration] = STATE(46),
    [sym_type_definition] = STATE(46),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(46),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(46),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(46),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(46),
    [sym_template_instantiation] = STATE(46),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(46),
    [sym_operator_cast_declaration] = STATE(46),
    [sym_constructor_or_destructor_definition] = STATE(46),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(46),
    [sym_namespace_alias_definition] = STATE(46),
    [sym_using_declaration] = STATE(46),
    [sym_alias_declaration] = STATE(46),
    [sym_static_assert_declaration] = STATE(46),
    [sym_concept_definition] = STATE(46),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(46),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(717),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [49] = {
    [sym__block_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(43),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(719),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [50] = {
    [sym__block_item] = STATE(62),
    [sym_preproc_include] = STATE(62),
    [sym_preproc_def] = STATE(62),
    [sym_preproc_function_def] = STATE(62),
    [sym_preproc_call] = STATE(62),
    [sym_preproc_if] = STATE(62),
    [sym_preproc_ifdef] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(62),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(62),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(62),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(62),
    [sym_template_instantiation] = STATE(62),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(62),
    [sym_operator_cast_declaration] = STATE(62),
    [sym_constructor_or_destructor_definition] = STATE(62),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(62),
    [sym_namespace_alias_definition] = STATE(62),
    [sym_using_declaration] = STATE(62),
    [sym_alias_declaration] = STATE(62),
    [sym_static_assert_declaration] = STATE(62),
    [sym_concept_definition] = STATE(62),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(62),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(721),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [51] = {
    [sym__block_item] = STATE(83),
    [sym_preproc_include] = STATE(83),
    [sym_preproc_def] = STATE(83),
    [sym_preproc_function_def] = STATE(83),
    [sym_preproc_call] = STATE(83),
    [sym_preproc_if] = STATE(83),
    [sym_preproc_ifdef] = STATE(83),
    [sym_function_definition] = STATE(83),
    [sym_declaration] = STATE(83),
    [sym_type_definition] = STATE(83),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(83),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(83),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(83),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(83),
    [sym_template_instantiation] = STATE(83),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(83),
    [sym_operator_cast_declaration] = STATE(83),
    [sym_constructor_or_destructor_definition] = STATE(83),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(83),
    [sym_namespace_alias_definition] = STATE(83),
    [sym_using_declaration] = STATE(83),
    [sym_alias_declaration] = STATE(83),
    [sym_static_assert_declaration] = STATE(83),
    [sym_concept_definition] = STATE(83),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(83),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(723),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [52] = {
    [sym__block_item] = STATE(62),
    [sym_preproc_include] = STATE(62),
    [sym_preproc_def] = STATE(62),
    [sym_preproc_function_def] = STATE(62),
    [sym_preproc_call] = STATE(62),
    [sym_preproc_if] = STATE(62),
    [sym_preproc_ifdef] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(62),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(62),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(62),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(62),
    [sym_template_instantiation] = STATE(62),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(62),
    [sym_operator_cast_declaration] = STATE(62),
    [sym_constructor_or_destructor_definition] = STATE(62),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(62),
    [sym_namespace_alias_definition] = STATE(62),
    [sym_using_declaration] = STATE(62),
    [sym_alias_declaration] = STATE(62),
    [sym_static_assert_declaration] = STATE(62),
    [sym_concept_definition] = STATE(62),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(62),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [53] = {
    [sym__block_item] = STATE(62),
    [sym_preproc_include] = STATE(62),
    [sym_preproc_def] = STATE(62),
    [sym_preproc_function_def] = STATE(62),
    [sym_preproc_call] = STATE(62),
    [sym_preproc_if] = STATE(62),
    [sym_preproc_ifdef] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(62),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(62),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(62),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(62),
    [sym_template_instantiation] = STATE(62),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(62),
    [sym_operator_cast_declaration] = STATE(62),
    [sym_constructor_or_destructor_definition] = STATE(62),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(62),
    [sym_namespace_alias_definition] = STATE(62),
    [sym_using_declaration] = STATE(62),
    [sym_alias_declaration] = STATE(62),
    [sym_static_assert_declaration] = STATE(62),
    [sym_concept_definition] = STATE(62),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(62),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(727),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [54] = {
    [sym__block_item] = STATE(53),
    [sym_preproc_include] = STATE(53),
    [sym_preproc_def] = STATE(53),
    [sym_preproc_function_def] = STATE(53),
    [sym_preproc_call] = STATE(53),
    [sym_preproc_if] = STATE(53),
    [sym_preproc_ifdef] = STATE(53),
    [sym_function_definition] = STATE(53),
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(53),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(53),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(53),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(53),
    [sym_template_instantiation] = STATE(53),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(53),
    [sym_operator_cast_declaration] = STATE(53),
    [sym_constructor_or_destructor_definition] = STATE(53),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(53),
    [sym_namespace_alias_definition] = STATE(53),
    [sym_using_declaration] = STATE(53),
    [sym_alias_declaration] = STATE(53),
    [sym_static_assert_declaration] = STATE(53),
    [sym_concept_definition] = STATE(53),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(53),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(729),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [55] = {
    [sym__block_item] = STATE(52),
    [sym_preproc_include] = STATE(52),
    [sym_preproc_def] = STATE(52),
    [sym_preproc_function_def] = STATE(52),
    [sym_preproc_call] = STATE(52),
    [sym_preproc_if] = STATE(52),
    [sym_preproc_ifdef] = STATE(52),
    [sym_function_definition] = STATE(52),
    [sym_declaration] = STATE(52),
    [sym_type_definition] = STATE(52),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(52),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(52),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(52),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(52),
    [sym_template_instantiation] = STATE(52),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(52),
    [sym_operator_cast_declaration] = STATE(52),
    [sym_constructor_or_destructor_definition] = STATE(52),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(52),
    [sym_namespace_alias_definition] = STATE(52),
    [sym_using_declaration] = STATE(52),
    [sym_alias_declaration] = STATE(52),
    [sym_static_assert_declaration] = STATE(52),
    [sym_concept_definition] = STATE(52),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(52),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(731),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [56] = {
    [sym__block_item] = STATE(59),
    [sym_preproc_include] = STATE(59),
    [sym_preproc_def] = STATE(59),
    [sym_preproc_function_def] = STATE(59),
    [sym_preproc_call] = STATE(59),
    [sym_preproc_if] = STATE(59),
    [sym_preproc_ifdef] = STATE(59),
    [sym_function_definition] = STATE(59),
    [sym_declaration] = STATE(59),
    [sym_type_definition] = STATE(59),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(59),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(59),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(59),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(59),
    [sym_template_instantiation] = STATE(59),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(59),
    [sym_operator_cast_declaration] = STATE(59),
    [sym_constructor_or_destructor_definition] = STATE(59),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(59),
    [sym_namespace_alias_definition] = STATE(59),
    [sym_using_declaration] = STATE(59),
    [sym_alias_declaration] = STATE(59),
    [sym_static_assert_declaration] = STATE(59),
    [sym_concept_definition] = STATE(59),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(59),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(733),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [57] = {
    [sym__block_item] = STATE(62),
    [sym_preproc_include] = STATE(62),
    [sym_preproc_def] = STATE(62),
    [sym_preproc_function_def] = STATE(62),
    [sym_preproc_call] = STATE(62),
    [sym_preproc_if] = STATE(62),
    [sym_preproc_ifdef] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(62),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(62),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(62),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(62),
    [sym_template_instantiation] = STATE(62),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(62),
    [sym_operator_cast_declaration] = STATE(62),
    [sym_constructor_or_destructor_definition] = STATE(62),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(62),
    [sym_namespace_alias_definition] = STATE(62),
    [sym_using_declaration] = STATE(62),
    [sym_alias_declaration] = STATE(62),
    [sym_static_assert_declaration] = STATE(62),
    [sym_concept_definition] = STATE(62),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(62),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(735),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [58] = {
    [sym__block_item] = STATE(35),
    [sym_preproc_include] = STATE(35),
    [sym_preproc_def] = STATE(35),
    [sym_preproc_function_def] = STATE(35),
    [sym_preproc_call] = STATE(35),
    [sym_preproc_if] = STATE(35),
    [sym_preproc_ifdef] = STATE(35),
    [sym_function_definition] = STATE(35),
    [sym_declaration] = STATE(35),
    [sym_type_definition] = STATE(35),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(35),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(35),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(35),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(35),
    [sym_template_instantiation] = STATE(35),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(35),
    [sym_operator_cast_declaration] = STATE(35),
    [sym_constructor_or_destructor_definition] = STATE(35),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(35),
    [sym_namespace_alias_definition] = STATE(35),
    [sym_using_declaration] = STATE(35),
    [sym_alias_declaration] = STATE(35),
    [sym_static_assert_declaration] = STATE(35),
    [sym_concept_definition] = STATE(35),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(35),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(737),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [59] = {
    [sym__block_item] = STATE(62),
    [sym_preproc_include] = STATE(62),
    [sym_preproc_def] = STATE(62),
    [sym_preproc_function_def] = STATE(62),
    [sym_preproc_call] = STATE(62),
    [sym_preproc_if] = STATE(62),
    [sym_preproc_ifdef] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(62),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(62),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(62),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(62),
    [sym_template_instantiation] = STATE(62),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(62),
    [sym_operator_cast_declaration] = STATE(62),
    [sym_constructor_or_destructor_definition] = STATE(62),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(62),
    [sym_namespace_alias_definition] = STATE(62),
    [sym_using_declaration] = STATE(62),
    [sym_alias_declaration] = STATE(62),
    [sym_static_assert_declaration] = STATE(62),
    [sym_concept_definition] = STATE(62),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(62),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(739),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [60] = {
    [sym__block_item] = STATE(62),
    [sym_preproc_include] = STATE(62),
    [sym_preproc_def] = STATE(62),
    [sym_preproc_function_def] = STATE(62),
    [sym_preproc_call] = STATE(62),
    [sym_preproc_if] = STATE(62),
    [sym_preproc_ifdef] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(62),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(62),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(62),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(62),
    [sym_template_instantiation] = STATE(62),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(62),
    [sym_operator_cast_declaration] = STATE(62),
    [sym_constructor_or_destructor_definition] = STATE(62),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(62),
    [sym_namespace_alias_definition] = STATE(62),
    [sym_using_declaration] = STATE(62),
    [sym_alias_declaration] = STATE(62),
    [sym_static_assert_declaration] = STATE(62),
    [sym_concept_definition] = STATE(62),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(62),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(741),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [61] = {
    [sym__block_item] = STATE(57),
    [sym_preproc_include] = STATE(57),
    [sym_preproc_def] = STATE(57),
    [sym_preproc_function_def] = STATE(57),
    [sym_preproc_call] = STATE(57),
    [sym_preproc_if] = STATE(57),
    [sym_preproc_ifdef] = STATE(57),
    [sym_function_definition] = STATE(57),
    [sym_declaration] = STATE(57),
    [sym_type_definition] = STATE(57),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(57),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(57),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(57),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(57),
    [sym_template_instantiation] = STATE(57),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(57),
    [sym_operator_cast_declaration] = STATE(57),
    [sym_constructor_or_destructor_definition] = STATE(57),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(57),
    [sym_namespace_alias_definition] = STATE(57),
    [sym_using_declaration] = STATE(57),
    [sym_alias_declaration] = STATE(57),
    [sym_static_assert_declaration] = STATE(57),
    [sym_concept_definition] = STATE(57),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(57),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [62] = {
    [sym__block_item] = STATE(62),
    [sym_preproc_include] = STATE(62),
    [sym_preproc_def] = STATE(62),
    [sym_preproc_function_def] = STATE(62),
    [sym_preproc_call] = STATE(62),
    [sym_preproc_if] = STATE(62),
    [sym_preproc_ifdef] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(62),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(62),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(62),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(62),
    [sym_template_instantiation] = STATE(62),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(62),
    [sym_operator_cast_declaration] = STATE(62),
    [sym_constructor_or_destructor_definition] = STATE(62),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(62),
    [sym_namespace_alias_definition] = STATE(62),
    [sym_using_declaration] = STATE(62),
    [sym_alias_declaration] = STATE(62),
    [sym_static_assert_declaration] = STATE(62),
    [sym_concept_definition] = STATE(62),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(62),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(745),
    [aux_sym_preproc_include_token1] = ACTIONS(748),
    [aux_sym_preproc_def_token1] = ACTIONS(751),
    [aux_sym_preproc_if_token1] = ACTIONS(754),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(757),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(757),
    [sym_preproc_directive] = ACTIONS(760),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(398),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_DASH] = ACTIONS(404),
    [anon_sym_PLUS] = ACTIONS(404),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(410),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(763),
    [anon_sym___extension__] = ACTIONS(766),
    [anon_sym_typedef] = ACTIONS(769),
    [anon_sym___device__] = ACTIONS(425),
    [anon_sym___host__] = ACTIONS(425),
    [anon_sym___global__] = ACTIONS(425),
    [anon_sym___forceinline__] = ACTIONS(425),
    [anon_sym___noinline__] = ACTIONS(425),
    [anon_sym_extern] = ACTIONS(772),
    [anon_sym___attribute__] = ACTIONS(431),
    [anon_sym_COLON_COLON] = ACTIONS(434),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(437),
    [anon_sym___declspec] = ACTIONS(440),
    [anon_sym___based] = ACTIONS(443),
    [anon_sym___cdecl] = ACTIONS(446),
    [anon_sym___clrcall] = ACTIONS(446),
    [anon_sym___stdcall] = ACTIONS(446),
    [anon_sym___fastcall] = ACTIONS(446),
    [anon_sym___thiscall] = ACTIONS(446),
    [anon_sym___vectorcall] = ACTIONS(446),
    [anon_sym_LBRACE] = ACTIONS(775),
    [anon_sym_RBRACE] = ACTIONS(778),
    [anon_sym_signed] = ACTIONS(452),
    [anon_sym_unsigned] = ACTIONS(452),
    [anon_sym_long] = ACTIONS(452),
    [anon_sym_short] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(455),
    [anon_sym_static] = ACTIONS(458),
    [anon_sym_register] = ACTIONS(458),
    [anon_sym_inline] = ACTIONS(780),
    [anon_sym___inline] = ACTIONS(458),
    [anon_sym___inline__] = ACTIONS(458),
    [anon_sym___forceinline] = ACTIONS(458),
    [anon_sym_thread_local] = ACTIONS(458),
    [anon_sym___thread] = ACTIONS(458),
    [anon_sym_const] = ACTIONS(464),
    [anon_sym_constexpr] = ACTIONS(464),
    [anon_sym_volatile] = ACTIONS(464),
    [anon_sym_restrict] = ACTIONS(464),
    [anon_sym___restrict__] = ACTIONS(464),
    [anon_sym__Atomic] = ACTIONS(464),
    [anon_sym__Noreturn] = ACTIONS(464),
    [anon_sym_noreturn] = ACTIONS(464),
    [anon_sym_mutable] = ACTIONS(464),
    [anon_sym_constinit] = ACTIONS(464),
    [anon_sym_consteval] = ACTIONS(464),
    [anon_sym___shared__] = ACTIONS(464),
    [anon_sym___local__] = ACTIONS(464),
    [anon_sym___constant__] = ACTIONS(464),
    [anon_sym___managed__] = ACTIONS(464),
    [anon_sym___grid_constant__] = ACTIONS(464),
    [anon_sym_alignas] = ACTIONS(467),
    [anon_sym__Alignas] = ACTIONS(467),
    [sym_primitive_type] = ACTIONS(470),
    [anon_sym_enum] = ACTIONS(473),
    [anon_sym_class] = ACTIONS(476),
    [anon_sym_struct] = ACTIONS(479),
    [anon_sym_union] = ACTIONS(482),
    [anon_sym_if] = ACTIONS(783),
    [anon_sym_switch] = ACTIONS(786),
    [anon_sym_case] = ACTIONS(789),
    [anon_sym_default] = ACTIONS(792),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_do] = ACTIONS(798),
    [anon_sym_for] = ACTIONS(801),
    [anon_sym_return] = ACTIONS(804),
    [anon_sym_break] = ACTIONS(807),
    [anon_sym_continue] = ACTIONS(810),
    [anon_sym_goto] = ACTIONS(813),
    [anon_sym___try] = ACTIONS(816),
    [anon_sym___leave] = ACTIONS(819),
    [anon_sym_not] = ACTIONS(404),
    [anon_sym_compl] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(524),
    [anon_sym_PLUS_PLUS] = ACTIONS(524),
    [anon_sym_sizeof] = ACTIONS(527),
    [anon_sym___alignof__] = ACTIONS(530),
    [anon_sym___alignof] = ACTIONS(530),
    [anon_sym__alignof] = ACTIONS(530),
    [anon_sym_alignof] = ACTIONS(530),
    [anon_sym__Alignof] = ACTIONS(530),
    [anon_sym_offsetof] = ACTIONS(533),
    [anon_sym__Generic] = ACTIONS(536),
    [anon_sym_asm] = ACTIONS(539),
    [anon_sym___asm__] = ACTIONS(539),
    [sym_number_literal] = ACTIONS(542),
    [anon_sym_L_SQUOTE] = ACTIONS(545),
    [anon_sym_u_SQUOTE] = ACTIONS(545),
    [anon_sym_U_SQUOTE] = ACTIONS(545),
    [anon_sym_u8_SQUOTE] = ACTIONS(545),
    [anon_sym_SQUOTE] = ACTIONS(545),
    [anon_sym_L_DQUOTE] = ACTIONS(548),
    [anon_sym_u_DQUOTE] = ACTIONS(548),
    [anon_sym_U_DQUOTE] = ACTIONS(548),
    [anon_sym_u8_DQUOTE] = ACTIONS(548),
    [anon_sym_DQUOTE] = ACTIONS(548),
    [sym_true] = ACTIONS(551),
    [sym_false] = ACTIONS(551),
    [anon_sym_NULL] = ACTIONS(554),
    [anon_sym_nullptr] = ACTIONS(554),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(557),
    [anon_sym_decltype] = ACTIONS(560),
    [sym_virtual] = ACTIONS(425),
    [anon_sym_explicit] = ACTIONS(563),
    [anon_sym_typename] = ACTIONS(566),
    [anon_sym_template] = ACTIONS(822),
    [anon_sym_operator] = ACTIONS(572),
    [anon_sym_try] = ACTIONS(825),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_throw] = ACTIONS(828),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_using] = ACTIONS(834),
    [anon_sym_static_assert] = ACTIONS(837),
    [anon_sym_concept] = ACTIONS(840),
    [anon_sym_co_return] = ACTIONS(843),
    [anon_sym_co_yield] = ACTIONS(846),
    [anon_sym_R_DQUOTE] = ACTIONS(602),
    [anon_sym_LR_DQUOTE] = ACTIONS(602),
    [anon_sym_uR_DQUOTE] = ACTIONS(602),
    [anon_sym_UR_DQUOTE] = ACTIONS(602),
    [anon_sym_u8R_DQUOTE] = ACTIONS(602),
    [anon_sym_co_await] = ACTIONS(605),
    [anon_sym_new] = ACTIONS(608),
    [anon_sym_requires] = ACTIONS(611),
    [sym_this] = ACTIONS(551),
    [anon_sym___launch_bounds__] = ACTIONS(614),
  },
  [63] = {
    [sym__block_item] = STATE(60),
    [sym_preproc_include] = STATE(60),
    [sym_preproc_def] = STATE(60),
    [sym_preproc_function_def] = STATE(60),
    [sym_preproc_call] = STATE(60),
    [sym_preproc_if] = STATE(60),
    [sym_preproc_ifdef] = STATE(60),
    [sym_function_definition] = STATE(60),
    [sym_declaration] = STATE(60),
    [sym_type_definition] = STATE(60),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(60),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(60),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(60),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(60),
    [sym_template_instantiation] = STATE(60),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(60),
    [sym_operator_cast_declaration] = STATE(60),
    [sym_constructor_or_destructor_definition] = STATE(60),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(60),
    [sym_namespace_alias_definition] = STATE(60),
    [sym_using_declaration] = STATE(60),
    [sym_alias_declaration] = STATE(60),
    [sym_static_assert_declaration] = STATE(60),
    [sym_concept_definition] = STATE(60),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(60),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(849),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [64] = {
    [sym__block_item] = STATE(62),
    [sym_preproc_include] = STATE(62),
    [sym_preproc_def] = STATE(62),
    [sym_preproc_function_def] = STATE(62),
    [sym_preproc_call] = STATE(62),
    [sym_preproc_if] = STATE(62),
    [sym_preproc_ifdef] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(62),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(62),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(62),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(62),
    [sym_template_instantiation] = STATE(62),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(62),
    [sym_operator_cast_declaration] = STATE(62),
    [sym_constructor_or_destructor_definition] = STATE(62),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(62),
    [sym_namespace_alias_definition] = STATE(62),
    [sym_using_declaration] = STATE(62),
    [sym_alias_declaration] = STATE(62),
    [sym_static_assert_declaration] = STATE(62),
    [sym_concept_definition] = STATE(62),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(62),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(851),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [65] = {
    [sym__block_item] = STATE(62),
    [sym_preproc_include] = STATE(62),
    [sym_preproc_def] = STATE(62),
    [sym_preproc_function_def] = STATE(62),
    [sym_preproc_call] = STATE(62),
    [sym_preproc_if] = STATE(62),
    [sym_preproc_ifdef] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(62),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(62),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(62),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(62),
    [sym_template_instantiation] = STATE(62),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(62),
    [sym_operator_cast_declaration] = STATE(62),
    [sym_constructor_or_destructor_definition] = STATE(62),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(62),
    [sym_namespace_alias_definition] = STATE(62),
    [sym_using_declaration] = STATE(62),
    [sym_alias_declaration] = STATE(62),
    [sym_static_assert_declaration] = STATE(62),
    [sym_concept_definition] = STATE(62),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(62),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(853),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [66] = {
    [sym__block_item] = STATE(67),
    [sym_preproc_include] = STATE(67),
    [sym_preproc_def] = STATE(67),
    [sym_preproc_function_def] = STATE(67),
    [sym_preproc_call] = STATE(67),
    [sym_preproc_if] = STATE(67),
    [sym_preproc_ifdef] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_declaration] = STATE(67),
    [sym_type_definition] = STATE(67),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(67),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(67),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(67),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(67),
    [sym_template_instantiation] = STATE(67),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(67),
    [sym_operator_cast_declaration] = STATE(67),
    [sym_constructor_or_destructor_definition] = STATE(67),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(67),
    [sym_namespace_alias_definition] = STATE(67),
    [sym_using_declaration] = STATE(67),
    [sym_alias_declaration] = STATE(67),
    [sym_static_assert_declaration] = STATE(67),
    [sym_concept_definition] = STATE(67),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(67),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(855),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [67] = {
    [sym__block_item] = STATE(62),
    [sym_preproc_include] = STATE(62),
    [sym_preproc_def] = STATE(62),
    [sym_preproc_function_def] = STATE(62),
    [sym_preproc_call] = STATE(62),
    [sym_preproc_if] = STATE(62),
    [sym_preproc_ifdef] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(62),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(62),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(62),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(62),
    [sym_template_instantiation] = STATE(62),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(62),
    [sym_operator_cast_declaration] = STATE(62),
    [sym_constructor_or_destructor_definition] = STATE(62),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(62),
    [sym_namespace_alias_definition] = STATE(62),
    [sym_using_declaration] = STATE(62),
    [sym_alias_declaration] = STATE(62),
    [sym_static_assert_declaration] = STATE(62),
    [sym_concept_definition] = STATE(62),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(62),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(857),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [68] = {
    [sym__block_item] = STATE(62),
    [sym_preproc_include] = STATE(62),
    [sym_preproc_def] = STATE(62),
    [sym_preproc_function_def] = STATE(62),
    [sym_preproc_call] = STATE(62),
    [sym_preproc_if] = STATE(62),
    [sym_preproc_ifdef] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(62),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(62),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(62),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(62),
    [sym_template_instantiation] = STATE(62),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(62),
    [sym_operator_cast_declaration] = STATE(62),
    [sym_constructor_or_destructor_definition] = STATE(62),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(62),
    [sym_namespace_alias_definition] = STATE(62),
    [sym_using_declaration] = STATE(62),
    [sym_alias_declaration] = STATE(62),
    [sym_static_assert_declaration] = STATE(62),
    [sym_concept_definition] = STATE(62),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(62),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(859),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [69] = {
    [sym__block_item] = STATE(62),
    [sym_preproc_include] = STATE(62),
    [sym_preproc_def] = STATE(62),
    [sym_preproc_function_def] = STATE(62),
    [sym_preproc_call] = STATE(62),
    [sym_preproc_if] = STATE(62),
    [sym_preproc_ifdef] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(62),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(62),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(62),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(62),
    [sym_template_instantiation] = STATE(62),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(62),
    [sym_operator_cast_declaration] = STATE(62),
    [sym_constructor_or_destructor_definition] = STATE(62),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(62),
    [sym_namespace_alias_definition] = STATE(62),
    [sym_using_declaration] = STATE(62),
    [sym_alias_declaration] = STATE(62),
    [sym_static_assert_declaration] = STATE(62),
    [sym_concept_definition] = STATE(62),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(62),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(861),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [70] = {
    [sym__block_item] = STATE(68),
    [sym_preproc_include] = STATE(68),
    [sym_preproc_def] = STATE(68),
    [sym_preproc_function_def] = STATE(68),
    [sym_preproc_call] = STATE(68),
    [sym_preproc_if] = STATE(68),
    [sym_preproc_ifdef] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_declaration] = STATE(68),
    [sym_type_definition] = STATE(68),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(68),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(68),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(68),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(68),
    [sym_template_instantiation] = STATE(68),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(68),
    [sym_operator_cast_declaration] = STATE(68),
    [sym_constructor_or_destructor_definition] = STATE(68),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(68),
    [sym_namespace_alias_definition] = STATE(68),
    [sym_using_declaration] = STATE(68),
    [sym_alias_declaration] = STATE(68),
    [sym_static_assert_declaration] = STATE(68),
    [sym_concept_definition] = STATE(68),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(68),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(863),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [71] = {
    [sym__block_item] = STATE(71),
    [sym_preproc_include] = STATE(71),
    [sym_preproc_def] = STATE(71),
    [sym_preproc_function_def] = STATE(71),
    [sym_preproc_call] = STATE(71),
    [sym_preproc_if] = STATE(71),
    [sym_preproc_ifdef] = STATE(71),
    [sym_function_definition] = STATE(71),
    [sym_declaration] = STATE(71),
    [sym_type_definition] = STATE(71),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5201),
    [sym_linkage_specification] = STATE(71),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1837),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6595),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(351),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2274),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(444),
    [sym_statement] = STATE(71),
    [sym_labeled_statement] = STATE(351),
    [sym_expression_statement] = STATE(351),
    [sym_if_statement] = STATE(351),
    [sym_switch_statement] = STATE(351),
    [sym_case_statement] = STATE(351),
    [sym_while_statement] = STATE(351),
    [sym_do_statement] = STATE(351),
    [sym_for_statement] = STATE(351),
    [sym_return_statement] = STATE(351),
    [sym_break_statement] = STATE(351),
    [sym_continue_statement] = STATE(351),
    [sym_goto_statement] = STATE(351),
    [sym_seh_try_statement] = STATE(351),
    [sym_seh_leave_statement] = STATE(351),
    [sym_expression] = STATE(4855),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8338),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(71),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1704),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(71),
    [sym_template_instantiation] = STATE(71),
    [sym_operator_cast] = STATE(7017),
    [sym__constructor_specifiers] = STATE(1704),
    [sym_operator_cast_definition] = STATE(71),
    [sym_operator_cast_declaration] = STATE(71),
    [sym_constructor_or_destructor_definition] = STATE(71),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(71),
    [sym_namespace_alias_definition] = STATE(71),
    [sym_using_declaration] = STATE(71),
    [sym_alias_declaration] = STATE(71),
    [sym_static_assert_declaration] = STATE(71),
    [sym_concept_definition] = STATE(71),
    [sym_for_range_loop] = STATE(351),
    [sym_co_return_statement] = STATE(351),
    [sym_co_yield_statement] = STATE(351),
    [sym_throw_statement] = STATE(351),
    [sym_try_statement] = STATE(351),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7017),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(71),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(622),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1704),
    [sym_identifier] = ACTIONS(865),
    [aux_sym_preproc_include_token1] = ACTIONS(868),
    [aux_sym_preproc_def_token1] = ACTIONS(871),
    [aux_sym_preproc_if_token1] = ACTIONS(874),
    [aux_sym_preproc_if_token2] = ACTIONS(387),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(877),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(877),
    [sym_preproc_directive] = ACTIONS(880),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(398),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_DASH] = ACTIONS(404),
    [anon_sym_PLUS] = ACTIONS(404),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(410),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(883),
    [anon_sym___extension__] = ACTIONS(886),
    [anon_sym_typedef] = ACTIONS(889),
    [anon_sym___device__] = ACTIONS(425),
    [anon_sym___host__] = ACTIONS(425),
    [anon_sym___global__] = ACTIONS(425),
    [anon_sym___forceinline__] = ACTIONS(425),
    [anon_sym___noinline__] = ACTIONS(425),
    [anon_sym_extern] = ACTIONS(892),
    [anon_sym___attribute__] = ACTIONS(431),
    [anon_sym_COLON_COLON] = ACTIONS(434),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(437),
    [anon_sym___declspec] = ACTIONS(440),
    [anon_sym___based] = ACTIONS(443),
    [anon_sym___cdecl] = ACTIONS(446),
    [anon_sym___clrcall] = ACTIONS(446),
    [anon_sym___stdcall] = ACTIONS(446),
    [anon_sym___fastcall] = ACTIONS(446),
    [anon_sym___thiscall] = ACTIONS(446),
    [anon_sym___vectorcall] = ACTIONS(446),
    [anon_sym_LBRACE] = ACTIONS(895),
    [anon_sym_signed] = ACTIONS(452),
    [anon_sym_unsigned] = ACTIONS(452),
    [anon_sym_long] = ACTIONS(452),
    [anon_sym_short] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(455),
    [anon_sym_static] = ACTIONS(458),
    [anon_sym_register] = ACTIONS(458),
    [anon_sym_inline] = ACTIONS(898),
    [anon_sym___inline] = ACTIONS(458),
    [anon_sym___inline__] = ACTIONS(458),
    [anon_sym___forceinline] = ACTIONS(458),
    [anon_sym_thread_local] = ACTIONS(458),
    [anon_sym___thread] = ACTIONS(458),
    [anon_sym_const] = ACTIONS(464),
    [anon_sym_constexpr] = ACTIONS(464),
    [anon_sym_volatile] = ACTIONS(464),
    [anon_sym_restrict] = ACTIONS(464),
    [anon_sym___restrict__] = ACTIONS(464),
    [anon_sym__Atomic] = ACTIONS(464),
    [anon_sym__Noreturn] = ACTIONS(464),
    [anon_sym_noreturn] = ACTIONS(464),
    [anon_sym_mutable] = ACTIONS(464),
    [anon_sym_constinit] = ACTIONS(464),
    [anon_sym_consteval] = ACTIONS(464),
    [anon_sym___shared__] = ACTIONS(464),
    [anon_sym___local__] = ACTIONS(464),
    [anon_sym___constant__] = ACTIONS(464),
    [anon_sym___managed__] = ACTIONS(464),
    [anon_sym___grid_constant__] = ACTIONS(464),
    [anon_sym_alignas] = ACTIONS(467),
    [anon_sym__Alignas] = ACTIONS(467),
    [sym_primitive_type] = ACTIONS(470),
    [anon_sym_enum] = ACTIONS(473),
    [anon_sym_class] = ACTIONS(476),
    [anon_sym_struct] = ACTIONS(479),
    [anon_sym_union] = ACTIONS(482),
    [anon_sym_if] = ACTIONS(901),
    [anon_sym_switch] = ACTIONS(904),
    [anon_sym_case] = ACTIONS(907),
    [anon_sym_default] = ACTIONS(910),
    [anon_sym_while] = ACTIONS(913),
    [anon_sym_do] = ACTIONS(916),
    [anon_sym_for] = ACTIONS(919),
    [anon_sym_return] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(925),
    [anon_sym_continue] = ACTIONS(928),
    [anon_sym_goto] = ACTIONS(931),
    [anon_sym___try] = ACTIONS(934),
    [anon_sym___leave] = ACTIONS(937),
    [anon_sym_not] = ACTIONS(404),
    [anon_sym_compl] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(524),
    [anon_sym_PLUS_PLUS] = ACTIONS(524),
    [anon_sym_sizeof] = ACTIONS(527),
    [anon_sym___alignof__] = ACTIONS(530),
    [anon_sym___alignof] = ACTIONS(530),
    [anon_sym__alignof] = ACTIONS(530),
    [anon_sym_alignof] = ACTIONS(530),
    [anon_sym__Alignof] = ACTIONS(530),
    [anon_sym_offsetof] = ACTIONS(533),
    [anon_sym__Generic] = ACTIONS(536),
    [anon_sym_asm] = ACTIONS(539),
    [anon_sym___asm__] = ACTIONS(539),
    [sym_number_literal] = ACTIONS(542),
    [anon_sym_L_SQUOTE] = ACTIONS(545),
    [anon_sym_u_SQUOTE] = ACTIONS(545),
    [anon_sym_U_SQUOTE] = ACTIONS(545),
    [anon_sym_u8_SQUOTE] = ACTIONS(545),
    [anon_sym_SQUOTE] = ACTIONS(545),
    [anon_sym_L_DQUOTE] = ACTIONS(548),
    [anon_sym_u_DQUOTE] = ACTIONS(548),
    [anon_sym_U_DQUOTE] = ACTIONS(548),
    [anon_sym_u8_DQUOTE] = ACTIONS(548),
    [anon_sym_DQUOTE] = ACTIONS(548),
    [sym_true] = ACTIONS(551),
    [sym_false] = ACTIONS(551),
    [anon_sym_NULL] = ACTIONS(554),
    [anon_sym_nullptr] = ACTIONS(554),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(557),
    [anon_sym_decltype] = ACTIONS(560),
    [sym_virtual] = ACTIONS(425),
    [anon_sym_explicit] = ACTIONS(563),
    [anon_sym_typename] = ACTIONS(566),
    [anon_sym_template] = ACTIONS(940),
    [anon_sym_operator] = ACTIONS(572),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_throw] = ACTIONS(946),
    [anon_sym_namespace] = ACTIONS(949),
    [anon_sym_using] = ACTIONS(952),
    [anon_sym_static_assert] = ACTIONS(955),
    [anon_sym_concept] = ACTIONS(958),
    [anon_sym_co_return] = ACTIONS(961),
    [anon_sym_co_yield] = ACTIONS(964),
    [anon_sym_R_DQUOTE] = ACTIONS(602),
    [anon_sym_LR_DQUOTE] = ACTIONS(602),
    [anon_sym_uR_DQUOTE] = ACTIONS(602),
    [anon_sym_UR_DQUOTE] = ACTIONS(602),
    [anon_sym_u8R_DQUOTE] = ACTIONS(602),
    [anon_sym_co_await] = ACTIONS(605),
    [anon_sym_new] = ACTIONS(608),
    [anon_sym_requires] = ACTIONS(611),
    [sym_this] = ACTIONS(551),
    [anon_sym___launch_bounds__] = ACTIONS(614),
  },
  [72] = {
    [sym__block_item] = STATE(65),
    [sym_preproc_include] = STATE(65),
    [sym_preproc_def] = STATE(65),
    [sym_preproc_function_def] = STATE(65),
    [sym_preproc_call] = STATE(65),
    [sym_preproc_if] = STATE(65),
    [sym_preproc_ifdef] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_declaration] = STATE(65),
    [sym_type_definition] = STATE(65),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(65),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(65),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(65),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(65),
    [sym_template_instantiation] = STATE(65),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(65),
    [sym_operator_cast_declaration] = STATE(65),
    [sym_constructor_or_destructor_definition] = STATE(65),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(65),
    [sym_namespace_alias_definition] = STATE(65),
    [sym_using_declaration] = STATE(65),
    [sym_alias_declaration] = STATE(65),
    [sym_static_assert_declaration] = STATE(65),
    [sym_concept_definition] = STATE(65),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(65),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(967),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [73] = {
    [sym__block_item] = STATE(62),
    [sym_preproc_include] = STATE(62),
    [sym_preproc_def] = STATE(62),
    [sym_preproc_function_def] = STATE(62),
    [sym_preproc_call] = STATE(62),
    [sym_preproc_if] = STATE(62),
    [sym_preproc_ifdef] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(62),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(62),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(62),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(62),
    [sym_template_instantiation] = STATE(62),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(62),
    [sym_operator_cast_declaration] = STATE(62),
    [sym_constructor_or_destructor_definition] = STATE(62),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(62),
    [sym_namespace_alias_definition] = STATE(62),
    [sym_using_declaration] = STATE(62),
    [sym_alias_declaration] = STATE(62),
    [sym_static_assert_declaration] = STATE(62),
    [sym_concept_definition] = STATE(62),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(62),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(969),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [74] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5201),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1837),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6595),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(351),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2274),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(444),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(351),
    [sym_expression_statement] = STATE(351),
    [sym_if_statement] = STATE(351),
    [sym_switch_statement] = STATE(351),
    [sym_case_statement] = STATE(351),
    [sym_while_statement] = STATE(351),
    [sym_do_statement] = STATE(351),
    [sym_for_statement] = STATE(351),
    [sym_return_statement] = STATE(351),
    [sym_break_statement] = STATE(351),
    [sym_continue_statement] = STATE(351),
    [sym_goto_statement] = STATE(351),
    [sym_seh_try_statement] = STATE(351),
    [sym_seh_leave_statement] = STATE(351),
    [sym_expression] = STATE(4855),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8338),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1704),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(7017),
    [sym__constructor_specifiers] = STATE(1704),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(351),
    [sym_co_return_statement] = STATE(351),
    [sym_co_yield_statement] = STATE(351),
    [sym_throw_statement] = STATE(351),
    [sym_try_statement] = STATE(351),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7017),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(622),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1704),
    [sym_identifier] = ACTIONS(637),
    [aux_sym_preproc_include_token1] = ACTIONS(639),
    [aux_sym_preproc_def_token1] = ACTIONS(641),
    [aux_sym_preproc_if_token1] = ACTIONS(643),
    [aux_sym_preproc_if_token2] = ACTIONS(971),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(647),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(647),
    [sym_preproc_directive] = ACTIONS(649),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(651),
    [anon_sym___extension__] = ACTIONS(653),
    [anon_sym_typedef] = ACTIONS(655),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(657),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(661),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(663),
    [anon_sym_switch] = ACTIONS(665),
    [anon_sym_case] = ACTIONS(667),
    [anon_sym_default] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_do] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(677),
    [anon_sym_break] = ACTIONS(679),
    [anon_sym_continue] = ACTIONS(681),
    [anon_sym_goto] = ACTIONS(683),
    [anon_sym___try] = ACTIONS(685),
    [anon_sym___leave] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(689),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(691),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_using] = ACTIONS(697),
    [anon_sym_static_assert] = ACTIONS(699),
    [anon_sym_concept] = ACTIONS(701),
    [anon_sym_co_return] = ACTIONS(703),
    [anon_sym_co_yield] = ACTIONS(705),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [75] = {
    [sym__block_item] = STATE(76),
    [sym_preproc_include] = STATE(76),
    [sym_preproc_def] = STATE(76),
    [sym_preproc_function_def] = STATE(76),
    [sym_preproc_call] = STATE(76),
    [sym_preproc_if] = STATE(76),
    [sym_preproc_ifdef] = STATE(76),
    [sym_function_definition] = STATE(76),
    [sym_declaration] = STATE(76),
    [sym_type_definition] = STATE(76),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(76),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(76),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(76),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(76),
    [sym_template_instantiation] = STATE(76),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(76),
    [sym_operator_cast_declaration] = STATE(76),
    [sym_constructor_or_destructor_definition] = STATE(76),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(76),
    [sym_namespace_alias_definition] = STATE(76),
    [sym_using_declaration] = STATE(76),
    [sym_alias_declaration] = STATE(76),
    [sym_static_assert_declaration] = STATE(76),
    [sym_concept_definition] = STATE(76),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(76),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(973),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [76] = {
    [sym__block_item] = STATE(62),
    [sym_preproc_include] = STATE(62),
    [sym_preproc_def] = STATE(62),
    [sym_preproc_function_def] = STATE(62),
    [sym_preproc_call] = STATE(62),
    [sym_preproc_if] = STATE(62),
    [sym_preproc_ifdef] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(62),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(62),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(62),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(62),
    [sym_template_instantiation] = STATE(62),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(62),
    [sym_operator_cast_declaration] = STATE(62),
    [sym_constructor_or_destructor_definition] = STATE(62),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(62),
    [sym_namespace_alias_definition] = STATE(62),
    [sym_using_declaration] = STATE(62),
    [sym_alias_declaration] = STATE(62),
    [sym_static_assert_declaration] = STATE(62),
    [sym_concept_definition] = STATE(62),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(62),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [77] = {
    [sym__block_item] = STATE(62),
    [sym_preproc_include] = STATE(62),
    [sym_preproc_def] = STATE(62),
    [sym_preproc_function_def] = STATE(62),
    [sym_preproc_call] = STATE(62),
    [sym_preproc_if] = STATE(62),
    [sym_preproc_ifdef] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(62),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(62),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(62),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(62),
    [sym_template_instantiation] = STATE(62),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(62),
    [sym_operator_cast_declaration] = STATE(62),
    [sym_constructor_or_destructor_definition] = STATE(62),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(62),
    [sym_namespace_alias_definition] = STATE(62),
    [sym_using_declaration] = STATE(62),
    [sym_alias_declaration] = STATE(62),
    [sym_static_assert_declaration] = STATE(62),
    [sym_concept_definition] = STATE(62),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(62),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(977),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [78] = {
    [sym__block_item] = STATE(77),
    [sym_preproc_include] = STATE(77),
    [sym_preproc_def] = STATE(77),
    [sym_preproc_function_def] = STATE(77),
    [sym_preproc_call] = STATE(77),
    [sym_preproc_if] = STATE(77),
    [sym_preproc_ifdef] = STATE(77),
    [sym_function_definition] = STATE(77),
    [sym_declaration] = STATE(77),
    [sym_type_definition] = STATE(77),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(77),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(77),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(77),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(77),
    [sym_template_instantiation] = STATE(77),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(77),
    [sym_operator_cast_declaration] = STATE(77),
    [sym_constructor_or_destructor_definition] = STATE(77),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(77),
    [sym_namespace_alias_definition] = STATE(77),
    [sym_using_declaration] = STATE(77),
    [sym_alias_declaration] = STATE(77),
    [sym_static_assert_declaration] = STATE(77),
    [sym_concept_definition] = STATE(77),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(77),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(979),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [79] = {
    [sym__block_item] = STATE(62),
    [sym_preproc_include] = STATE(62),
    [sym_preproc_def] = STATE(62),
    [sym_preproc_function_def] = STATE(62),
    [sym_preproc_call] = STATE(62),
    [sym_preproc_if] = STATE(62),
    [sym_preproc_ifdef] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(62),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(62),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(62),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(62),
    [sym_template_instantiation] = STATE(62),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(62),
    [sym_operator_cast_declaration] = STATE(62),
    [sym_constructor_or_destructor_definition] = STATE(62),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(62),
    [sym_namespace_alias_definition] = STATE(62),
    [sym_using_declaration] = STATE(62),
    [sym_alias_declaration] = STATE(62),
    [sym_static_assert_declaration] = STATE(62),
    [sym_concept_definition] = STATE(62),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(62),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(981),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [80] = {
    [sym__block_item] = STATE(82),
    [sym_preproc_include] = STATE(82),
    [sym_preproc_def] = STATE(82),
    [sym_preproc_function_def] = STATE(82),
    [sym_preproc_call] = STATE(82),
    [sym_preproc_if] = STATE(82),
    [sym_preproc_ifdef] = STATE(82),
    [sym_function_definition] = STATE(82),
    [sym_declaration] = STATE(82),
    [sym_type_definition] = STATE(82),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(82),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(82),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(82),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(82),
    [sym_template_instantiation] = STATE(82),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(82),
    [sym_operator_cast_declaration] = STATE(82),
    [sym_constructor_or_destructor_definition] = STATE(82),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(82),
    [sym_namespace_alias_definition] = STATE(82),
    [sym_using_declaration] = STATE(82),
    [sym_alias_declaration] = STATE(82),
    [sym_static_assert_declaration] = STATE(82),
    [sym_concept_definition] = STATE(82),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(82),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(983),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [81] = {
    [sym__block_item] = STATE(79),
    [sym_preproc_include] = STATE(79),
    [sym_preproc_def] = STATE(79),
    [sym_preproc_function_def] = STATE(79),
    [sym_preproc_call] = STATE(79),
    [sym_preproc_if] = STATE(79),
    [sym_preproc_ifdef] = STATE(79),
    [sym_function_definition] = STATE(79),
    [sym_declaration] = STATE(79),
    [sym_type_definition] = STATE(79),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(79),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(79),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(79),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(79),
    [sym_template_instantiation] = STATE(79),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(79),
    [sym_operator_cast_declaration] = STATE(79),
    [sym_constructor_or_destructor_definition] = STATE(79),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(79),
    [sym_namespace_alias_definition] = STATE(79),
    [sym_using_declaration] = STATE(79),
    [sym_alias_declaration] = STATE(79),
    [sym_static_assert_declaration] = STATE(79),
    [sym_concept_definition] = STATE(79),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(79),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(985),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [82] = {
    [sym__block_item] = STATE(62),
    [sym_preproc_include] = STATE(62),
    [sym_preproc_def] = STATE(62),
    [sym_preproc_function_def] = STATE(62),
    [sym_preproc_call] = STATE(62),
    [sym_preproc_if] = STATE(62),
    [sym_preproc_ifdef] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(62),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(62),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(62),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(62),
    [sym_template_instantiation] = STATE(62),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(62),
    [sym_operator_cast_declaration] = STATE(62),
    [sym_constructor_or_destructor_definition] = STATE(62),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(62),
    [sym_namespace_alias_definition] = STATE(62),
    [sym_using_declaration] = STATE(62),
    [sym_alias_declaration] = STATE(62),
    [sym_static_assert_declaration] = STATE(62),
    [sym_concept_definition] = STATE(62),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(62),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(987),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [83] = {
    [sym__block_item] = STATE(62),
    [sym_preproc_include] = STATE(62),
    [sym_preproc_def] = STATE(62),
    [sym_preproc_function_def] = STATE(62),
    [sym_preproc_call] = STATE(62),
    [sym_preproc_if] = STATE(62),
    [sym_preproc_ifdef] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_declaration] = STATE(62),
    [sym_type_definition] = STATE(62),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_linkage_specification] = STATE(62),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6512),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(439),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(566),
    [sym_statement] = STATE(62),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym__empty_declaration] = STATE(62),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1695),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(62),
    [sym_template_instantiation] = STATE(62),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1695),
    [sym_operator_cast_definition] = STATE(62),
    [sym_operator_cast_declaration] = STATE(62),
    [sym_constructor_or_destructor_definition] = STATE(62),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5091),
    [sym_namespace_definition] = STATE(62),
    [sym_namespace_alias_definition] = STATE(62),
    [sym_using_declaration] = STATE(62),
    [sym_alias_declaration] = STATE(62),
    [sym_static_assert_declaration] = STATE(62),
    [sym_concept_definition] = STATE(62),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3564),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_repeat1] = STATE(62),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1695),
    [sym_identifier] = ACTIONS(617),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(989),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [84] = {
    [sym__top_level_item] = STATE(84),
    [sym_preproc_include] = STATE(84),
    [sym_preproc_def] = STATE(84),
    [sym_preproc_function_def] = STATE(84),
    [sym_preproc_call] = STATE(84),
    [sym_preproc_if] = STATE(84),
    [sym_preproc_ifdef] = STATE(84),
    [sym_function_definition] = STATE(84),
    [sym_declaration] = STATE(84),
    [sym_type_definition] = STATE(84),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5203),
    [sym_linkage_specification] = STATE(84),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1822),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6613),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2248),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(691),
    [sym__top_level_statement] = STATE(84),
    [sym_labeled_statement] = STATE(84),
    [sym__top_level_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_expression] = STATE(5165),
    [sym__string] = STATE(5344),
    [sym_conditional_expression] = STATE(5344),
    [sym_assignment_expression] = STATE(5344),
    [sym_pointer_expression] = STATE(4092),
    [sym_unary_expression] = STATE(5344),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(5344),
    [sym_cast_expression] = STATE(5344),
    [sym_sizeof_expression] = STATE(5344),
    [sym_alignof_expression] = STATE(5344),
    [sym_offsetof_expression] = STATE(5344),
    [sym_generic_expression] = STATE(5344),
    [sym_subscript_expression] = STATE(4092),
    [sym_call_expression] = STATE(4092),
    [sym_gnu_asm_expression] = STATE(5344),
    [sym_field_expression] = STATE(4092),
    [sym_compound_literal_expression] = STATE(5344),
    [sym_parenthesized_expression] = STATE(4092),
    [sym_char_literal] = STATE(5299),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(5344),
    [sym__empty_declaration] = STATE(84),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1706),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(84),
    [sym_template_instantiation] = STATE(84),
    [sym_operator_cast] = STATE(7006),
    [sym__constructor_specifiers] = STATE(1706),
    [sym_operator_cast_definition] = STATE(84),
    [sym_operator_cast_declaration] = STATE(84),
    [sym_constructor_or_destructor_definition] = STATE(84),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5250),
    [sym_namespace_definition] = STATE(84),
    [sym_namespace_alias_definition] = STATE(84),
    [sym_using_declaration] = STATE(84),
    [sym_alias_declaration] = STATE(84),
    [sym_static_assert_declaration] = STATE(84),
    [sym_concept_definition] = STATE(84),
    [sym_for_range_loop] = STATE(84),
    [sym_co_return_statement] = STATE(84),
    [sym_co_yield_statement] = STATE(84),
    [sym_throw_statement] = STATE(84),
    [sym_try_statement] = STATE(84),
    [sym_raw_string_literal] = STATE(4178),
    [sym_co_await_expression] = STATE(5344),
    [sym_new_expression] = STATE(5344),
    [sym_delete_expression] = STATE(5344),
    [sym_requires_clause] = STATE(5344),
    [sym_requires_expression] = STATE(5344),
    [sym_lambda_expression] = STATE(5344),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(5344),
    [sym_parameter_pack_expansion] = STATE(5344),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3937),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7006),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(4092),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_translation_unit_repeat1] = STATE(84),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(606),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1706),
    [ts_builtin_sym_end] = ACTIONS(991),
    [sym_identifier] = ACTIONS(993),
    [aux_sym_preproc_include_token1] = ACTIONS(996),
    [aux_sym_preproc_def_token1] = ACTIONS(999),
    [aux_sym_preproc_if_token1] = ACTIONS(1002),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1005),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1005),
    [sym_preproc_directive] = ACTIONS(1008),
    [anon_sym_LPAREN2] = ACTIONS(1011),
    [anon_sym_BANG] = ACTIONS(1014),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_DASH] = ACTIONS(1020),
    [anon_sym_PLUS] = ACTIONS(1020),
    [anon_sym_STAR] = ACTIONS(1023),
    [anon_sym_AMP_AMP] = ACTIONS(1026),
    [anon_sym_AMP] = ACTIONS(1029),
    [anon_sym___extension__] = ACTIONS(1032),
    [anon_sym_typedef] = ACTIONS(1035),
    [anon_sym___device__] = ACTIONS(1038),
    [anon_sym___host__] = ACTIONS(1038),
    [anon_sym___global__] = ACTIONS(1038),
    [anon_sym___forceinline__] = ACTIONS(1038),
    [anon_sym___noinline__] = ACTIONS(1038),
    [anon_sym_extern] = ACTIONS(1041),
    [anon_sym___attribute__] = ACTIONS(1044),
    [anon_sym_COLON_COLON] = ACTIONS(1047),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1050),
    [anon_sym___declspec] = ACTIONS(1053),
    [anon_sym___based] = ACTIONS(1056),
    [anon_sym___cdecl] = ACTIONS(1059),
    [anon_sym___clrcall] = ACTIONS(1059),
    [anon_sym___stdcall] = ACTIONS(1059),
    [anon_sym___fastcall] = ACTIONS(1059),
    [anon_sym___thiscall] = ACTIONS(1059),
    [anon_sym___vectorcall] = ACTIONS(1059),
    [anon_sym_LBRACE] = ACTIONS(1062),
    [anon_sym_signed] = ACTIONS(1065),
    [anon_sym_unsigned] = ACTIONS(1065),
    [anon_sym_long] = ACTIONS(1065),
    [anon_sym_short] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(1068),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_register] = ACTIONS(1071),
    [anon_sym_inline] = ACTIONS(1074),
    [anon_sym___inline] = ACTIONS(1071),
    [anon_sym___inline__] = ACTIONS(1071),
    [anon_sym___forceinline] = ACTIONS(1071),
    [anon_sym_thread_local] = ACTIONS(1071),
    [anon_sym___thread] = ACTIONS(1071),
    [anon_sym_const] = ACTIONS(1077),
    [anon_sym_constexpr] = ACTIONS(1077),
    [anon_sym_volatile] = ACTIONS(1077),
    [anon_sym_restrict] = ACTIONS(1077),
    [anon_sym___restrict__] = ACTIONS(1077),
    [anon_sym__Atomic] = ACTIONS(1077),
    [anon_sym__Noreturn] = ACTIONS(1077),
    [anon_sym_noreturn] = ACTIONS(1077),
    [anon_sym_mutable] = ACTIONS(1077),
    [anon_sym_constinit] = ACTIONS(1077),
    [anon_sym_consteval] = ACTIONS(1077),
    [anon_sym___shared__] = ACTIONS(1077),
    [anon_sym___local__] = ACTIONS(1077),
    [anon_sym___constant__] = ACTIONS(1077),
    [anon_sym___managed__] = ACTIONS(1077),
    [anon_sym___grid_constant__] = ACTIONS(1077),
    [anon_sym_alignas] = ACTIONS(1080),
    [anon_sym__Alignas] = ACTIONS(1080),
    [sym_primitive_type] = ACTIONS(1083),
    [anon_sym_enum] = ACTIONS(1086),
    [anon_sym_class] = ACTIONS(1089),
    [anon_sym_struct] = ACTIONS(1092),
    [anon_sym_union] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1098),
    [anon_sym_switch] = ACTIONS(1101),
    [anon_sym_case] = ACTIONS(1104),
    [anon_sym_default] = ACTIONS(1107),
    [anon_sym_while] = ACTIONS(1110),
    [anon_sym_do] = ACTIONS(1113),
    [anon_sym_for] = ACTIONS(1116),
    [anon_sym_return] = ACTIONS(1119),
    [anon_sym_break] = ACTIONS(1122),
    [anon_sym_continue] = ACTIONS(1125),
    [anon_sym_goto] = ACTIONS(1128),
    [anon_sym_not] = ACTIONS(1020),
    [anon_sym_compl] = ACTIONS(1020),
    [anon_sym_DASH_DASH] = ACTIONS(1131),
    [anon_sym_PLUS_PLUS] = ACTIONS(1131),
    [anon_sym_sizeof] = ACTIONS(1134),
    [anon_sym___alignof__] = ACTIONS(1137),
    [anon_sym___alignof] = ACTIONS(1137),
    [anon_sym__alignof] = ACTIONS(1137),
    [anon_sym_alignof] = ACTIONS(1137),
    [anon_sym__Alignof] = ACTIONS(1137),
    [anon_sym_offsetof] = ACTIONS(1140),
    [anon_sym__Generic] = ACTIONS(1143),
    [anon_sym_asm] = ACTIONS(1146),
    [anon_sym___asm__] = ACTIONS(1146),
    [sym_number_literal] = ACTIONS(1149),
    [anon_sym_L_SQUOTE] = ACTIONS(1152),
    [anon_sym_u_SQUOTE] = ACTIONS(1152),
    [anon_sym_U_SQUOTE] = ACTIONS(1152),
    [anon_sym_u8_SQUOTE] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym_L_DQUOTE] = ACTIONS(1155),
    [anon_sym_u_DQUOTE] = ACTIONS(1155),
    [anon_sym_U_DQUOTE] = ACTIONS(1155),
    [anon_sym_u8_DQUOTE] = ACTIONS(1155),
    [anon_sym_DQUOTE] = ACTIONS(1155),
    [sym_true] = ACTIONS(1158),
    [sym_false] = ACTIONS(1158),
    [anon_sym_NULL] = ACTIONS(1161),
    [anon_sym_nullptr] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1164),
    [anon_sym_decltype] = ACTIONS(1167),
    [sym_virtual] = ACTIONS(1038),
    [anon_sym_explicit] = ACTIONS(1170),
    [anon_sym_typename] = ACTIONS(1173),
    [anon_sym_template] = ACTIONS(1176),
    [anon_sym_operator] = ACTIONS(1179),
    [anon_sym_try] = ACTIONS(1182),
    [anon_sym_delete] = ACTIONS(1185),
    [anon_sym_throw] = ACTIONS(1188),
    [anon_sym_namespace] = ACTIONS(1191),
    [anon_sym_using] = ACTIONS(1194),
    [anon_sym_static_assert] = ACTIONS(1197),
    [anon_sym_concept] = ACTIONS(1200),
    [anon_sym_co_return] = ACTIONS(1203),
    [anon_sym_co_yield] = ACTIONS(1206),
    [anon_sym_R_DQUOTE] = ACTIONS(1209),
    [anon_sym_LR_DQUOTE] = ACTIONS(1209),
    [anon_sym_uR_DQUOTE] = ACTIONS(1209),
    [anon_sym_UR_DQUOTE] = ACTIONS(1209),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1209),
    [anon_sym_co_await] = ACTIONS(1212),
    [anon_sym_new] = ACTIONS(1215),
    [anon_sym_requires] = ACTIONS(1218),
    [sym_this] = ACTIONS(1158),
    [anon_sym___launch_bounds__] = ACTIONS(1221),
  },
  [85] = {
    [sym__top_level_item] = STATE(84),
    [sym_preproc_include] = STATE(84),
    [sym_preproc_def] = STATE(84),
    [sym_preproc_function_def] = STATE(84),
    [sym_preproc_call] = STATE(84),
    [sym_preproc_if] = STATE(84),
    [sym_preproc_ifdef] = STATE(84),
    [sym_function_definition] = STATE(84),
    [sym_declaration] = STATE(84),
    [sym_type_definition] = STATE(84),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5203),
    [sym_linkage_specification] = STATE(84),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(803),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1822),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6613),
    [sym_array_declarator] = STATE(6598),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2248),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(691),
    [sym__top_level_statement] = STATE(84),
    [sym_labeled_statement] = STATE(84),
    [sym__top_level_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_expression] = STATE(5165),
    [sym__string] = STATE(5344),
    [sym_conditional_expression] = STATE(5344),
    [sym_assignment_expression] = STATE(5344),
    [sym_pointer_expression] = STATE(4092),
    [sym_unary_expression] = STATE(5344),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(5344),
    [sym_cast_expression] = STATE(5344),
    [sym_sizeof_expression] = STATE(5344),
    [sym_alignof_expression] = STATE(5344),
    [sym_offsetof_expression] = STATE(5344),
    [sym_generic_expression] = STATE(5344),
    [sym_subscript_expression] = STATE(4092),
    [sym_call_expression] = STATE(4092),
    [sym_gnu_asm_expression] = STATE(5344),
    [sym_field_expression] = STATE(4092),
    [sym_compound_literal_expression] = STATE(5344),
    [sym_parenthesized_expression] = STATE(4092),
    [sym_char_literal] = STATE(5299),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(5344),
    [sym__empty_declaration] = STATE(84),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_explicit_function_specifier] = STATE(1706),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(84),
    [sym_template_instantiation] = STATE(84),
    [sym_operator_cast] = STATE(7006),
    [sym__constructor_specifiers] = STATE(1706),
    [sym_operator_cast_definition] = STATE(84),
    [sym_operator_cast_declaration] = STATE(84),
    [sym_constructor_or_destructor_definition] = STATE(84),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(5250),
    [sym_namespace_definition] = STATE(84),
    [sym_namespace_alias_definition] = STATE(84),
    [sym_using_declaration] = STATE(84),
    [sym_alias_declaration] = STATE(84),
    [sym_static_assert_declaration] = STATE(84),
    [sym_concept_definition] = STATE(84),
    [sym_for_range_loop] = STATE(84),
    [sym_co_return_statement] = STATE(84),
    [sym_co_yield_statement] = STATE(84),
    [sym_throw_statement] = STATE(84),
    [sym_try_statement] = STATE(84),
    [sym_raw_string_literal] = STATE(4178),
    [sym_co_await_expression] = STATE(5344),
    [sym_new_expression] = STATE(5344),
    [sym_delete_expression] = STATE(5344),
    [sym_requires_clause] = STATE(5344),
    [sym_requires_expression] = STATE(5344),
    [sym_lambda_expression] = STATE(5344),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(5344),
    [sym_parameter_pack_expansion] = STATE(5344),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5759),
    [sym_qualified_identifier] = STATE(3937),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_qualified_operator_cast_identifier] = STATE(7006),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(4092),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_translation_unit_repeat1] = STATE(84),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(606),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1706),
    [ts_builtin_sym_end] = ACTIONS(1224),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(39),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(45),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(81),
    [anon_sym_default] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(111),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(117),
    [sym_false] = ACTIONS(117),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(129),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_namespace] = ACTIONS(139),
    [anon_sym_using] = ACTIONS(141),
    [anon_sym_static_assert] = ACTIONS(143),
    [anon_sym_concept] = ACTIONS(145),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(117),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [86] = {
    [sym_declaration] = STATE(87),
    [sym_type_definition] = STATE(87),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5559),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(873),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_compound_statement] = STATE(87),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(87),
    [sym_labeled_statement] = STATE(87),
    [sym_expression_statement] = STATE(87),
    [sym_if_statement] = STATE(87),
    [sym_switch_statement] = STATE(87),
    [sym_while_statement] = STATE(87),
    [sym_do_statement] = STATE(87),
    [sym_for_statement] = STATE(87),
    [sym_return_statement] = STATE(87),
    [sym_break_statement] = STATE(87),
    [sym_continue_statement] = STATE(87),
    [sym_goto_statement] = STATE(87),
    [sym_seh_try_statement] = STATE(87),
    [sym_seh_leave_statement] = STATE(87),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(87),
    [sym_co_return_statement] = STATE(87),
    [sym_co_yield_statement] = STATE(87),
    [sym_throw_statement] = STATE(87),
    [sym_try_statement] = STATE(87),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_case_statement_repeat1] = STATE(87),
    [sym_identifier] = ACTIONS(1226),
    [aux_sym_preproc_include_token1] = ACTIONS(1228),
    [aux_sym_preproc_def_token1] = ACTIONS(1228),
    [aux_sym_preproc_if_token1] = ACTIONS(1228),
    [aux_sym_preproc_if_token2] = ACTIONS(1228),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1228),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1228),
    [aux_sym_preproc_else_token1] = ACTIONS(1228),
    [aux_sym_preproc_elif_token1] = ACTIONS(1228),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1228),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1228),
    [sym_preproc_directive] = ACTIONS(1228),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP_AMP] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(1236),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1228),
    [anon_sym___cdecl] = ACTIONS(1228),
    [anon_sym___clrcall] = ACTIONS(1228),
    [anon_sym___stdcall] = ACTIONS(1228),
    [anon_sym___fastcall] = ACTIONS(1228),
    [anon_sym___thiscall] = ACTIONS(1228),
    [anon_sym___vectorcall] = ACTIONS(1228),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_else] = ACTIONS(1228),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(1228),
    [anon_sym_default] = ACTIONS(1228),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_explicit] = ACTIONS(1228),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1228),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(1228),
    [anon_sym_using] = ACTIONS(1228),
    [anon_sym_static_assert] = ACTIONS(1228),
    [anon_sym_concept] = ACTIONS(1228),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [87] = {
    [sym_declaration] = STATE(90),
    [sym_type_definition] = STATE(90),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5559),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(873),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_compound_statement] = STATE(90),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(90),
    [sym_labeled_statement] = STATE(90),
    [sym_expression_statement] = STATE(90),
    [sym_if_statement] = STATE(90),
    [sym_switch_statement] = STATE(90),
    [sym_while_statement] = STATE(90),
    [sym_do_statement] = STATE(90),
    [sym_for_statement] = STATE(90),
    [sym_return_statement] = STATE(90),
    [sym_break_statement] = STATE(90),
    [sym_continue_statement] = STATE(90),
    [sym_goto_statement] = STATE(90),
    [sym_seh_try_statement] = STATE(90),
    [sym_seh_leave_statement] = STATE(90),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(90),
    [sym_co_return_statement] = STATE(90),
    [sym_co_yield_statement] = STATE(90),
    [sym_throw_statement] = STATE(90),
    [sym_try_statement] = STATE(90),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_case_statement_repeat1] = STATE(90),
    [sym_identifier] = ACTIONS(1226),
    [aux_sym_preproc_include_token1] = ACTIONS(1246),
    [aux_sym_preproc_def_token1] = ACTIONS(1246),
    [aux_sym_preproc_if_token1] = ACTIONS(1246),
    [aux_sym_preproc_if_token2] = ACTIONS(1246),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1246),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1246),
    [aux_sym_preproc_else_token1] = ACTIONS(1246),
    [aux_sym_preproc_elif_token1] = ACTIONS(1246),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1246),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1246),
    [sym_preproc_directive] = ACTIONS(1246),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP_AMP] = ACTIONS(1248),
    [anon_sym_AMP] = ACTIONS(1236),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1246),
    [anon_sym___cdecl] = ACTIONS(1246),
    [anon_sym___clrcall] = ACTIONS(1246),
    [anon_sym___stdcall] = ACTIONS(1246),
    [anon_sym___fastcall] = ACTIONS(1246),
    [anon_sym___thiscall] = ACTIONS(1246),
    [anon_sym___vectorcall] = ACTIONS(1246),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_else] = ACTIONS(1246),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(1246),
    [anon_sym_default] = ACTIONS(1246),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_explicit] = ACTIONS(1246),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1246),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(1246),
    [anon_sym_using] = ACTIONS(1246),
    [anon_sym_static_assert] = ACTIONS(1246),
    [anon_sym_concept] = ACTIONS(1246),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [88] = {
    [sym_declaration] = STATE(90),
    [sym_type_definition] = STATE(90),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5559),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(873),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_compound_statement] = STATE(90),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(90),
    [sym_labeled_statement] = STATE(90),
    [sym_expression_statement] = STATE(90),
    [sym_if_statement] = STATE(90),
    [sym_switch_statement] = STATE(90),
    [sym_while_statement] = STATE(90),
    [sym_do_statement] = STATE(90),
    [sym_for_statement] = STATE(90),
    [sym_return_statement] = STATE(90),
    [sym_break_statement] = STATE(90),
    [sym_continue_statement] = STATE(90),
    [sym_goto_statement] = STATE(90),
    [sym_seh_try_statement] = STATE(90),
    [sym_seh_leave_statement] = STATE(90),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(90),
    [sym_co_return_statement] = STATE(90),
    [sym_co_yield_statement] = STATE(90),
    [sym_throw_statement] = STATE(90),
    [sym_try_statement] = STATE(90),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_case_statement_repeat1] = STATE(90),
    [sym_identifier] = ACTIONS(1226),
    [aux_sym_preproc_include_token1] = ACTIONS(1250),
    [aux_sym_preproc_def_token1] = ACTIONS(1250),
    [aux_sym_preproc_if_token1] = ACTIONS(1250),
    [aux_sym_preproc_if_token2] = ACTIONS(1250),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1250),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1250),
    [aux_sym_preproc_else_token1] = ACTIONS(1250),
    [aux_sym_preproc_elif_token1] = ACTIONS(1250),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1250),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1250),
    [sym_preproc_directive] = ACTIONS(1250),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP_AMP] = ACTIONS(1252),
    [anon_sym_AMP] = ACTIONS(1236),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1250),
    [anon_sym___cdecl] = ACTIONS(1250),
    [anon_sym___clrcall] = ACTIONS(1250),
    [anon_sym___stdcall] = ACTIONS(1250),
    [anon_sym___fastcall] = ACTIONS(1250),
    [anon_sym___thiscall] = ACTIONS(1250),
    [anon_sym___vectorcall] = ACTIONS(1250),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_else] = ACTIONS(1250),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(1250),
    [anon_sym_default] = ACTIONS(1250),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_explicit] = ACTIONS(1250),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1250),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(1250),
    [anon_sym_using] = ACTIONS(1250),
    [anon_sym_static_assert] = ACTIONS(1250),
    [anon_sym_concept] = ACTIONS(1250),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [89] = {
    [sym_declaration] = STATE(88),
    [sym_type_definition] = STATE(88),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5559),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(873),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_compound_statement] = STATE(88),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(88),
    [sym_labeled_statement] = STATE(88),
    [sym_expression_statement] = STATE(88),
    [sym_if_statement] = STATE(88),
    [sym_switch_statement] = STATE(88),
    [sym_while_statement] = STATE(88),
    [sym_do_statement] = STATE(88),
    [sym_for_statement] = STATE(88),
    [sym_return_statement] = STATE(88),
    [sym_break_statement] = STATE(88),
    [sym_continue_statement] = STATE(88),
    [sym_goto_statement] = STATE(88),
    [sym_seh_try_statement] = STATE(88),
    [sym_seh_leave_statement] = STATE(88),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(88),
    [sym_co_return_statement] = STATE(88),
    [sym_co_yield_statement] = STATE(88),
    [sym_throw_statement] = STATE(88),
    [sym_try_statement] = STATE(88),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_case_statement_repeat1] = STATE(88),
    [sym_identifier] = ACTIONS(1226),
    [aux_sym_preproc_include_token1] = ACTIONS(1254),
    [aux_sym_preproc_def_token1] = ACTIONS(1254),
    [aux_sym_preproc_if_token1] = ACTIONS(1254),
    [aux_sym_preproc_if_token2] = ACTIONS(1254),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1254),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1254),
    [aux_sym_preproc_else_token1] = ACTIONS(1254),
    [aux_sym_preproc_elif_token1] = ACTIONS(1254),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1254),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1254),
    [sym_preproc_directive] = ACTIONS(1254),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP_AMP] = ACTIONS(1256),
    [anon_sym_AMP] = ACTIONS(1236),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1254),
    [anon_sym___cdecl] = ACTIONS(1254),
    [anon_sym___clrcall] = ACTIONS(1254),
    [anon_sym___stdcall] = ACTIONS(1254),
    [anon_sym___fastcall] = ACTIONS(1254),
    [anon_sym___thiscall] = ACTIONS(1254),
    [anon_sym___vectorcall] = ACTIONS(1254),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_else] = ACTIONS(1254),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(1254),
    [anon_sym_default] = ACTIONS(1254),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_explicit] = ACTIONS(1254),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1254),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(1254),
    [anon_sym_using] = ACTIONS(1254),
    [anon_sym_static_assert] = ACTIONS(1254),
    [anon_sym_concept] = ACTIONS(1254),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [90] = {
    [sym_declaration] = STATE(90),
    [sym_type_definition] = STATE(90),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5559),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(873),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_compound_statement] = STATE(90),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(90),
    [sym_labeled_statement] = STATE(90),
    [sym_expression_statement] = STATE(90),
    [sym_if_statement] = STATE(90),
    [sym_switch_statement] = STATE(90),
    [sym_while_statement] = STATE(90),
    [sym_do_statement] = STATE(90),
    [sym_for_statement] = STATE(90),
    [sym_return_statement] = STATE(90),
    [sym_break_statement] = STATE(90),
    [sym_continue_statement] = STATE(90),
    [sym_goto_statement] = STATE(90),
    [sym_seh_try_statement] = STATE(90),
    [sym_seh_leave_statement] = STATE(90),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(90),
    [sym_co_return_statement] = STATE(90),
    [sym_co_yield_statement] = STATE(90),
    [sym_throw_statement] = STATE(90),
    [sym_try_statement] = STATE(90),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_case_statement_repeat1] = STATE(90),
    [sym_identifier] = ACTIONS(1258),
    [aux_sym_preproc_include_token1] = ACTIONS(1261),
    [aux_sym_preproc_def_token1] = ACTIONS(1261),
    [aux_sym_preproc_if_token1] = ACTIONS(1261),
    [aux_sym_preproc_if_token2] = ACTIONS(1261),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1261),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1261),
    [aux_sym_preproc_else_token1] = ACTIONS(1261),
    [aux_sym_preproc_elif_token1] = ACTIONS(1261),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1261),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1261),
    [sym_preproc_directive] = ACTIONS(1261),
    [anon_sym_LPAREN2] = ACTIONS(1263),
    [anon_sym_BANG] = ACTIONS(1266),
    [anon_sym_TILDE] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_AMP_AMP] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_SEMI] = ACTIONS(1280),
    [anon_sym___extension__] = ACTIONS(1283),
    [anon_sym_typedef] = ACTIONS(1286),
    [anon_sym___device__] = ACTIONS(1289),
    [anon_sym___host__] = ACTIONS(1289),
    [anon_sym___global__] = ACTIONS(1289),
    [anon_sym___forceinline__] = ACTIONS(1289),
    [anon_sym___noinline__] = ACTIONS(1289),
    [anon_sym_extern] = ACTIONS(1292),
    [anon_sym___attribute__] = ACTIONS(1295),
    [anon_sym_COLON_COLON] = ACTIONS(1298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1301),
    [anon_sym___declspec] = ACTIONS(1304),
    [anon_sym___based] = ACTIONS(1261),
    [anon_sym___cdecl] = ACTIONS(1261),
    [anon_sym___clrcall] = ACTIONS(1261),
    [anon_sym___stdcall] = ACTIONS(1261),
    [anon_sym___fastcall] = ACTIONS(1261),
    [anon_sym___thiscall] = ACTIONS(1261),
    [anon_sym___vectorcall] = ACTIONS(1261),
    [anon_sym_LBRACE] = ACTIONS(1307),
    [anon_sym_signed] = ACTIONS(1310),
    [anon_sym_unsigned] = ACTIONS(1310),
    [anon_sym_long] = ACTIONS(1310),
    [anon_sym_short] = ACTIONS(1310),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_static] = ACTIONS(1292),
    [anon_sym_register] = ACTIONS(1292),
    [anon_sym_inline] = ACTIONS(1292),
    [anon_sym___inline] = ACTIONS(1292),
    [anon_sym___inline__] = ACTIONS(1292),
    [anon_sym___forceinline] = ACTIONS(1292),
    [anon_sym_thread_local] = ACTIONS(1292),
    [anon_sym___thread] = ACTIONS(1292),
    [anon_sym_const] = ACTIONS(1316),
    [anon_sym_constexpr] = ACTIONS(1316),
    [anon_sym_volatile] = ACTIONS(1316),
    [anon_sym_restrict] = ACTIONS(1316),
    [anon_sym___restrict__] = ACTIONS(1316),
    [anon_sym__Atomic] = ACTIONS(1316),
    [anon_sym__Noreturn] = ACTIONS(1316),
    [anon_sym_noreturn] = ACTIONS(1316),
    [anon_sym_mutable] = ACTIONS(1316),
    [anon_sym_constinit] = ACTIONS(1316),
    [anon_sym_consteval] = ACTIONS(1316),
    [anon_sym___shared__] = ACTIONS(1316),
    [anon_sym___local__] = ACTIONS(1316),
    [anon_sym___constant__] = ACTIONS(1316),
    [anon_sym___managed__] = ACTIONS(1316),
    [anon_sym___grid_constant__] = ACTIONS(1316),
    [anon_sym_alignas] = ACTIONS(1319),
    [anon_sym__Alignas] = ACTIONS(1319),
    [sym_primitive_type] = ACTIONS(1322),
    [anon_sym_enum] = ACTIONS(1325),
    [anon_sym_class] = ACTIONS(1328),
    [anon_sym_struct] = ACTIONS(1331),
    [anon_sym_union] = ACTIONS(1334),
    [anon_sym_if] = ACTIONS(1337),
    [anon_sym_else] = ACTIONS(1261),
    [anon_sym_switch] = ACTIONS(1340),
    [anon_sym_case] = ACTIONS(1261),
    [anon_sym_default] = ACTIONS(1261),
    [anon_sym_while] = ACTIONS(1343),
    [anon_sym_do] = ACTIONS(1346),
    [anon_sym_for] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1352),
    [anon_sym_break] = ACTIONS(1355),
    [anon_sym_continue] = ACTIONS(1358),
    [anon_sym_goto] = ACTIONS(1361),
    [anon_sym___try] = ACTIONS(1364),
    [anon_sym___leave] = ACTIONS(1367),
    [anon_sym_not] = ACTIONS(1269),
    [anon_sym_compl] = ACTIONS(1269),
    [anon_sym_DASH_DASH] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1370),
    [anon_sym_sizeof] = ACTIONS(1373),
    [anon_sym___alignof__] = ACTIONS(1376),
    [anon_sym___alignof] = ACTIONS(1376),
    [anon_sym__alignof] = ACTIONS(1376),
    [anon_sym_alignof] = ACTIONS(1376),
    [anon_sym__Alignof] = ACTIONS(1376),
    [anon_sym_offsetof] = ACTIONS(1379),
    [anon_sym__Generic] = ACTIONS(1382),
    [anon_sym_asm] = ACTIONS(1385),
    [anon_sym___asm__] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(1388),
    [anon_sym_L_SQUOTE] = ACTIONS(1391),
    [anon_sym_u_SQUOTE] = ACTIONS(1391),
    [anon_sym_U_SQUOTE] = ACTIONS(1391),
    [anon_sym_u8_SQUOTE] = ACTIONS(1391),
    [anon_sym_SQUOTE] = ACTIONS(1391),
    [anon_sym_L_DQUOTE] = ACTIONS(1394),
    [anon_sym_u_DQUOTE] = ACTIONS(1394),
    [anon_sym_U_DQUOTE] = ACTIONS(1394),
    [anon_sym_u8_DQUOTE] = ACTIONS(1394),
    [anon_sym_DQUOTE] = ACTIONS(1394),
    [sym_true] = ACTIONS(1397),
    [sym_false] = ACTIONS(1397),
    [anon_sym_NULL] = ACTIONS(1400),
    [anon_sym_nullptr] = ACTIONS(1400),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1403),
    [anon_sym_decltype] = ACTIONS(1406),
    [sym_virtual] = ACTIONS(1289),
    [anon_sym_explicit] = ACTIONS(1261),
    [anon_sym_typename] = ACTIONS(1409),
    [anon_sym_template] = ACTIONS(1412),
    [anon_sym_operator] = ACTIONS(1261),
    [anon_sym_try] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(1418),
    [anon_sym_throw] = ACTIONS(1421),
    [anon_sym_namespace] = ACTIONS(1261),
    [anon_sym_using] = ACTIONS(1261),
    [anon_sym_static_assert] = ACTIONS(1261),
    [anon_sym_concept] = ACTIONS(1261),
    [anon_sym_co_return] = ACTIONS(1424),
    [anon_sym_co_yield] = ACTIONS(1427),
    [anon_sym_R_DQUOTE] = ACTIONS(1430),
    [anon_sym_LR_DQUOTE] = ACTIONS(1430),
    [anon_sym_uR_DQUOTE] = ACTIONS(1430),
    [anon_sym_UR_DQUOTE] = ACTIONS(1430),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1430),
    [anon_sym_co_await] = ACTIONS(1433),
    [anon_sym_new] = ACTIONS(1436),
    [anon_sym_requires] = ACTIONS(1439),
    [sym_this] = ACTIONS(1397),
    [anon_sym___launch_bounds__] = ACTIONS(1442),
  },
  [91] = {
    [sym_declaration] = STATE(98),
    [sym_type_definition] = STATE(98),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5505),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(873),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_compound_statement] = STATE(98),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(98),
    [sym_labeled_statement] = STATE(98),
    [sym_expression_statement] = STATE(98),
    [sym_if_statement] = STATE(98),
    [sym_switch_statement] = STATE(98),
    [sym_while_statement] = STATE(98),
    [sym_do_statement] = STATE(98),
    [sym_for_statement] = STATE(98),
    [sym_return_statement] = STATE(98),
    [sym_break_statement] = STATE(98),
    [sym_continue_statement] = STATE(98),
    [sym_goto_statement] = STATE(98),
    [sym_seh_try_statement] = STATE(98),
    [sym_seh_leave_statement] = STATE(98),
    [sym_expression] = STATE(4855),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8338),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(98),
    [sym_co_return_statement] = STATE(98),
    [sym_co_yield_statement] = STATE(98),
    [sym_throw_statement] = STATE(98),
    [sym_try_statement] = STATE(98),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(622),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_case_statement_repeat1] = STATE(98),
    [sym_identifier] = ACTIONS(1445),
    [aux_sym_preproc_include_token1] = ACTIONS(1246),
    [aux_sym_preproc_def_token1] = ACTIONS(1246),
    [aux_sym_preproc_if_token1] = ACTIONS(1246),
    [aux_sym_preproc_if_token2] = ACTIONS(1246),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1246),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1246),
    [sym_preproc_directive] = ACTIONS(1246),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP_AMP] = ACTIONS(1248),
    [anon_sym_AMP] = ACTIONS(1236),
    [anon_sym_SEMI] = ACTIONS(651),
    [anon_sym___extension__] = ACTIONS(653),
    [anon_sym_typedef] = ACTIONS(655),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1246),
    [anon_sym___cdecl] = ACTIONS(1246),
    [anon_sym___clrcall] = ACTIONS(1246),
    [anon_sym___stdcall] = ACTIONS(1246),
    [anon_sym___fastcall] = ACTIONS(1246),
    [anon_sym___thiscall] = ACTIONS(1246),
    [anon_sym___vectorcall] = ACTIONS(1246),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(663),
    [anon_sym_else] = ACTIONS(1246),
    [anon_sym_switch] = ACTIONS(665),
    [anon_sym_case] = ACTIONS(1246),
    [anon_sym_default] = ACTIONS(1246),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_do] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(677),
    [anon_sym_break] = ACTIONS(679),
    [anon_sym_continue] = ACTIONS(681),
    [anon_sym_goto] = ACTIONS(683),
    [anon_sym___try] = ACTIONS(685),
    [anon_sym___leave] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_explicit] = ACTIONS(1246),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1246),
    [anon_sym_try] = ACTIONS(691),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_namespace] = ACTIONS(1246),
    [anon_sym_using] = ACTIONS(1246),
    [anon_sym_static_assert] = ACTIONS(1246),
    [anon_sym_concept] = ACTIONS(1246),
    [anon_sym_co_return] = ACTIONS(703),
    [anon_sym_co_yield] = ACTIONS(705),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [92] = {
    [sym_declaration] = STATE(102),
    [sym_type_definition] = STATE(102),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5446),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(873),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_compound_statement] = STATE(102),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(102),
    [sym_labeled_statement] = STATE(102),
    [sym_expression_statement] = STATE(102),
    [sym_if_statement] = STATE(102),
    [sym_switch_statement] = STATE(102),
    [sym_while_statement] = STATE(102),
    [sym_do_statement] = STATE(102),
    [sym_for_statement] = STATE(102),
    [sym_return_statement] = STATE(102),
    [sym_break_statement] = STATE(102),
    [sym_continue_statement] = STATE(102),
    [sym_goto_statement] = STATE(102),
    [sym_seh_try_statement] = STATE(102),
    [sym_seh_leave_statement] = STATE(102),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(102),
    [sym_co_return_statement] = STATE(102),
    [sym_co_yield_statement] = STATE(102),
    [sym_throw_statement] = STATE(102),
    [sym_try_statement] = STATE(102),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_case_statement_repeat1] = STATE(102),
    [sym_identifier] = ACTIONS(1447),
    [aux_sym_preproc_include_token1] = ACTIONS(1228),
    [aux_sym_preproc_def_token1] = ACTIONS(1228),
    [aux_sym_preproc_if_token1] = ACTIONS(1228),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1228),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1228),
    [sym_preproc_directive] = ACTIONS(1228),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP_AMP] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(1236),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1228),
    [anon_sym___cdecl] = ACTIONS(1228),
    [anon_sym___clrcall] = ACTIONS(1228),
    [anon_sym___stdcall] = ACTIONS(1228),
    [anon_sym___fastcall] = ACTIONS(1228),
    [anon_sym___thiscall] = ACTIONS(1228),
    [anon_sym___vectorcall] = ACTIONS(1228),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(1234),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_else] = ACTIONS(1228),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(1228),
    [anon_sym_default] = ACTIONS(1228),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_explicit] = ACTIONS(1228),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1228),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(1228),
    [anon_sym_using] = ACTIONS(1228),
    [anon_sym_static_assert] = ACTIONS(1228),
    [anon_sym_concept] = ACTIONS(1228),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [93] = {
    [sym_declaration] = STATE(94),
    [sym_type_definition] = STATE(94),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5446),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(873),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_compound_statement] = STATE(94),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(94),
    [sym_labeled_statement] = STATE(94),
    [sym_expression_statement] = STATE(94),
    [sym_if_statement] = STATE(94),
    [sym_switch_statement] = STATE(94),
    [sym_while_statement] = STATE(94),
    [sym_do_statement] = STATE(94),
    [sym_for_statement] = STATE(94),
    [sym_return_statement] = STATE(94),
    [sym_break_statement] = STATE(94),
    [sym_continue_statement] = STATE(94),
    [sym_goto_statement] = STATE(94),
    [sym_seh_try_statement] = STATE(94),
    [sym_seh_leave_statement] = STATE(94),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(94),
    [sym_co_return_statement] = STATE(94),
    [sym_co_yield_statement] = STATE(94),
    [sym_throw_statement] = STATE(94),
    [sym_try_statement] = STATE(94),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_case_statement_repeat1] = STATE(94),
    [sym_identifier] = ACTIONS(1447),
    [aux_sym_preproc_include_token1] = ACTIONS(1250),
    [aux_sym_preproc_def_token1] = ACTIONS(1250),
    [aux_sym_preproc_if_token1] = ACTIONS(1250),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1250),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1250),
    [sym_preproc_directive] = ACTIONS(1250),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP_AMP] = ACTIONS(1252),
    [anon_sym_AMP] = ACTIONS(1236),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1250),
    [anon_sym___cdecl] = ACTIONS(1250),
    [anon_sym___clrcall] = ACTIONS(1250),
    [anon_sym___stdcall] = ACTIONS(1250),
    [anon_sym___fastcall] = ACTIONS(1250),
    [anon_sym___thiscall] = ACTIONS(1250),
    [anon_sym___vectorcall] = ACTIONS(1250),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(1252),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_else] = ACTIONS(1250),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(1250),
    [anon_sym_default] = ACTIONS(1250),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_explicit] = ACTIONS(1250),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1250),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(1250),
    [anon_sym_using] = ACTIONS(1250),
    [anon_sym_static_assert] = ACTIONS(1250),
    [anon_sym_concept] = ACTIONS(1250),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [94] = {
    [sym_declaration] = STATE(94),
    [sym_type_definition] = STATE(94),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5446),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(873),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_compound_statement] = STATE(94),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(94),
    [sym_labeled_statement] = STATE(94),
    [sym_expression_statement] = STATE(94),
    [sym_if_statement] = STATE(94),
    [sym_switch_statement] = STATE(94),
    [sym_while_statement] = STATE(94),
    [sym_do_statement] = STATE(94),
    [sym_for_statement] = STATE(94),
    [sym_return_statement] = STATE(94),
    [sym_break_statement] = STATE(94),
    [sym_continue_statement] = STATE(94),
    [sym_goto_statement] = STATE(94),
    [sym_seh_try_statement] = STATE(94),
    [sym_seh_leave_statement] = STATE(94),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(94),
    [sym_co_return_statement] = STATE(94),
    [sym_co_yield_statement] = STATE(94),
    [sym_throw_statement] = STATE(94),
    [sym_try_statement] = STATE(94),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_case_statement_repeat1] = STATE(94),
    [sym_identifier] = ACTIONS(1449),
    [aux_sym_preproc_include_token1] = ACTIONS(1261),
    [aux_sym_preproc_def_token1] = ACTIONS(1261),
    [aux_sym_preproc_if_token1] = ACTIONS(1261),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1261),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1261),
    [sym_preproc_directive] = ACTIONS(1261),
    [anon_sym_LPAREN2] = ACTIONS(1263),
    [anon_sym_BANG] = ACTIONS(1266),
    [anon_sym_TILDE] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_AMP_AMP] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_SEMI] = ACTIONS(1452),
    [anon_sym___extension__] = ACTIONS(1455),
    [anon_sym_typedef] = ACTIONS(1458),
    [anon_sym___device__] = ACTIONS(1289),
    [anon_sym___host__] = ACTIONS(1289),
    [anon_sym___global__] = ACTIONS(1289),
    [anon_sym___forceinline__] = ACTIONS(1289),
    [anon_sym___noinline__] = ACTIONS(1289),
    [anon_sym_extern] = ACTIONS(1292),
    [anon_sym___attribute__] = ACTIONS(1295),
    [anon_sym_COLON_COLON] = ACTIONS(1298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1301),
    [anon_sym___declspec] = ACTIONS(1304),
    [anon_sym___based] = ACTIONS(1261),
    [anon_sym___cdecl] = ACTIONS(1261),
    [anon_sym___clrcall] = ACTIONS(1261),
    [anon_sym___stdcall] = ACTIONS(1261),
    [anon_sym___fastcall] = ACTIONS(1261),
    [anon_sym___thiscall] = ACTIONS(1261),
    [anon_sym___vectorcall] = ACTIONS(1261),
    [anon_sym_LBRACE] = ACTIONS(1461),
    [anon_sym_RBRACE] = ACTIONS(1275),
    [anon_sym_signed] = ACTIONS(1310),
    [anon_sym_unsigned] = ACTIONS(1310),
    [anon_sym_long] = ACTIONS(1310),
    [anon_sym_short] = ACTIONS(1310),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_static] = ACTIONS(1292),
    [anon_sym_register] = ACTIONS(1292),
    [anon_sym_inline] = ACTIONS(1292),
    [anon_sym___inline] = ACTIONS(1292),
    [anon_sym___inline__] = ACTIONS(1292),
    [anon_sym___forceinline] = ACTIONS(1292),
    [anon_sym_thread_local] = ACTIONS(1292),
    [anon_sym___thread] = ACTIONS(1292),
    [anon_sym_const] = ACTIONS(1316),
    [anon_sym_constexpr] = ACTIONS(1316),
    [anon_sym_volatile] = ACTIONS(1316),
    [anon_sym_restrict] = ACTIONS(1316),
    [anon_sym___restrict__] = ACTIONS(1316),
    [anon_sym__Atomic] = ACTIONS(1316),
    [anon_sym__Noreturn] = ACTIONS(1316),
    [anon_sym_noreturn] = ACTIONS(1316),
    [anon_sym_mutable] = ACTIONS(1316),
    [anon_sym_constinit] = ACTIONS(1316),
    [anon_sym_consteval] = ACTIONS(1316),
    [anon_sym___shared__] = ACTIONS(1316),
    [anon_sym___local__] = ACTIONS(1316),
    [anon_sym___constant__] = ACTIONS(1316),
    [anon_sym___managed__] = ACTIONS(1316),
    [anon_sym___grid_constant__] = ACTIONS(1316),
    [anon_sym_alignas] = ACTIONS(1319),
    [anon_sym__Alignas] = ACTIONS(1319),
    [sym_primitive_type] = ACTIONS(1322),
    [anon_sym_enum] = ACTIONS(1325),
    [anon_sym_class] = ACTIONS(1328),
    [anon_sym_struct] = ACTIONS(1331),
    [anon_sym_union] = ACTIONS(1334),
    [anon_sym_if] = ACTIONS(1464),
    [anon_sym_else] = ACTIONS(1261),
    [anon_sym_switch] = ACTIONS(1467),
    [anon_sym_case] = ACTIONS(1261),
    [anon_sym_default] = ACTIONS(1261),
    [anon_sym_while] = ACTIONS(1470),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_for] = ACTIONS(1476),
    [anon_sym_return] = ACTIONS(1479),
    [anon_sym_break] = ACTIONS(1482),
    [anon_sym_continue] = ACTIONS(1485),
    [anon_sym_goto] = ACTIONS(1488),
    [anon_sym___try] = ACTIONS(1491),
    [anon_sym___leave] = ACTIONS(1494),
    [anon_sym_not] = ACTIONS(1269),
    [anon_sym_compl] = ACTIONS(1269),
    [anon_sym_DASH_DASH] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1370),
    [anon_sym_sizeof] = ACTIONS(1373),
    [anon_sym___alignof__] = ACTIONS(1376),
    [anon_sym___alignof] = ACTIONS(1376),
    [anon_sym__alignof] = ACTIONS(1376),
    [anon_sym_alignof] = ACTIONS(1376),
    [anon_sym__Alignof] = ACTIONS(1376),
    [anon_sym_offsetof] = ACTIONS(1379),
    [anon_sym__Generic] = ACTIONS(1382),
    [anon_sym_asm] = ACTIONS(1385),
    [anon_sym___asm__] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(1388),
    [anon_sym_L_SQUOTE] = ACTIONS(1391),
    [anon_sym_u_SQUOTE] = ACTIONS(1391),
    [anon_sym_U_SQUOTE] = ACTIONS(1391),
    [anon_sym_u8_SQUOTE] = ACTIONS(1391),
    [anon_sym_SQUOTE] = ACTIONS(1391),
    [anon_sym_L_DQUOTE] = ACTIONS(1394),
    [anon_sym_u_DQUOTE] = ACTIONS(1394),
    [anon_sym_U_DQUOTE] = ACTIONS(1394),
    [anon_sym_u8_DQUOTE] = ACTIONS(1394),
    [anon_sym_DQUOTE] = ACTIONS(1394),
    [sym_true] = ACTIONS(1397),
    [sym_false] = ACTIONS(1397),
    [anon_sym_NULL] = ACTIONS(1400),
    [anon_sym_nullptr] = ACTIONS(1400),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1403),
    [anon_sym_decltype] = ACTIONS(1406),
    [sym_virtual] = ACTIONS(1289),
    [anon_sym_explicit] = ACTIONS(1261),
    [anon_sym_typename] = ACTIONS(1409),
    [anon_sym_template] = ACTIONS(1412),
    [anon_sym_operator] = ACTIONS(1261),
    [anon_sym_try] = ACTIONS(1497),
    [anon_sym_delete] = ACTIONS(1418),
    [anon_sym_throw] = ACTIONS(1500),
    [anon_sym_namespace] = ACTIONS(1261),
    [anon_sym_using] = ACTIONS(1261),
    [anon_sym_static_assert] = ACTIONS(1261),
    [anon_sym_concept] = ACTIONS(1261),
    [anon_sym_co_return] = ACTIONS(1503),
    [anon_sym_co_yield] = ACTIONS(1506),
    [anon_sym_R_DQUOTE] = ACTIONS(1430),
    [anon_sym_LR_DQUOTE] = ACTIONS(1430),
    [anon_sym_uR_DQUOTE] = ACTIONS(1430),
    [anon_sym_UR_DQUOTE] = ACTIONS(1430),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1430),
    [anon_sym_co_await] = ACTIONS(1433),
    [anon_sym_new] = ACTIONS(1436),
    [anon_sym_requires] = ACTIONS(1439),
    [sym_this] = ACTIONS(1397),
    [anon_sym___launch_bounds__] = ACTIONS(1442),
  },
  [95] = {
    [sym_declaration] = STATE(91),
    [sym_type_definition] = STATE(91),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5505),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(873),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_compound_statement] = STATE(91),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(91),
    [sym_labeled_statement] = STATE(91),
    [sym_expression_statement] = STATE(91),
    [sym_if_statement] = STATE(91),
    [sym_switch_statement] = STATE(91),
    [sym_while_statement] = STATE(91),
    [sym_do_statement] = STATE(91),
    [sym_for_statement] = STATE(91),
    [sym_return_statement] = STATE(91),
    [sym_break_statement] = STATE(91),
    [sym_continue_statement] = STATE(91),
    [sym_goto_statement] = STATE(91),
    [sym_seh_try_statement] = STATE(91),
    [sym_seh_leave_statement] = STATE(91),
    [sym_expression] = STATE(4855),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8338),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(91),
    [sym_co_return_statement] = STATE(91),
    [sym_co_yield_statement] = STATE(91),
    [sym_throw_statement] = STATE(91),
    [sym_try_statement] = STATE(91),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(622),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_case_statement_repeat1] = STATE(91),
    [sym_identifier] = ACTIONS(1445),
    [aux_sym_preproc_include_token1] = ACTIONS(1228),
    [aux_sym_preproc_def_token1] = ACTIONS(1228),
    [aux_sym_preproc_if_token1] = ACTIONS(1228),
    [aux_sym_preproc_if_token2] = ACTIONS(1228),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1228),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1228),
    [sym_preproc_directive] = ACTIONS(1228),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP_AMP] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(1236),
    [anon_sym_SEMI] = ACTIONS(651),
    [anon_sym___extension__] = ACTIONS(653),
    [anon_sym_typedef] = ACTIONS(655),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1228),
    [anon_sym___cdecl] = ACTIONS(1228),
    [anon_sym___clrcall] = ACTIONS(1228),
    [anon_sym___stdcall] = ACTIONS(1228),
    [anon_sym___fastcall] = ACTIONS(1228),
    [anon_sym___thiscall] = ACTIONS(1228),
    [anon_sym___vectorcall] = ACTIONS(1228),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(663),
    [anon_sym_else] = ACTIONS(1228),
    [anon_sym_switch] = ACTIONS(665),
    [anon_sym_case] = ACTIONS(1228),
    [anon_sym_default] = ACTIONS(1228),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_do] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(677),
    [anon_sym_break] = ACTIONS(679),
    [anon_sym_continue] = ACTIONS(681),
    [anon_sym_goto] = ACTIONS(683),
    [anon_sym___try] = ACTIONS(685),
    [anon_sym___leave] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_explicit] = ACTIONS(1228),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1228),
    [anon_sym_try] = ACTIONS(691),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_namespace] = ACTIONS(1228),
    [anon_sym_using] = ACTIONS(1228),
    [anon_sym_static_assert] = ACTIONS(1228),
    [anon_sym_concept] = ACTIONS(1228),
    [anon_sym_co_return] = ACTIONS(703),
    [anon_sym_co_yield] = ACTIONS(705),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [96] = {
    [sym_declaration] = STATE(97),
    [sym_type_definition] = STATE(97),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5505),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(873),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_compound_statement] = STATE(97),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(97),
    [sym_labeled_statement] = STATE(97),
    [sym_expression_statement] = STATE(97),
    [sym_if_statement] = STATE(97),
    [sym_switch_statement] = STATE(97),
    [sym_while_statement] = STATE(97),
    [sym_do_statement] = STATE(97),
    [sym_for_statement] = STATE(97),
    [sym_return_statement] = STATE(97),
    [sym_break_statement] = STATE(97),
    [sym_continue_statement] = STATE(97),
    [sym_goto_statement] = STATE(97),
    [sym_seh_try_statement] = STATE(97),
    [sym_seh_leave_statement] = STATE(97),
    [sym_expression] = STATE(4855),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8338),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(97),
    [sym_co_return_statement] = STATE(97),
    [sym_co_yield_statement] = STATE(97),
    [sym_throw_statement] = STATE(97),
    [sym_try_statement] = STATE(97),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(622),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_case_statement_repeat1] = STATE(97),
    [sym_identifier] = ACTIONS(1445),
    [aux_sym_preproc_include_token1] = ACTIONS(1254),
    [aux_sym_preproc_def_token1] = ACTIONS(1254),
    [aux_sym_preproc_if_token1] = ACTIONS(1254),
    [aux_sym_preproc_if_token2] = ACTIONS(1254),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1254),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1254),
    [sym_preproc_directive] = ACTIONS(1254),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP_AMP] = ACTIONS(1256),
    [anon_sym_AMP] = ACTIONS(1236),
    [anon_sym_SEMI] = ACTIONS(651),
    [anon_sym___extension__] = ACTIONS(653),
    [anon_sym_typedef] = ACTIONS(655),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1254),
    [anon_sym___cdecl] = ACTIONS(1254),
    [anon_sym___clrcall] = ACTIONS(1254),
    [anon_sym___stdcall] = ACTIONS(1254),
    [anon_sym___fastcall] = ACTIONS(1254),
    [anon_sym___thiscall] = ACTIONS(1254),
    [anon_sym___vectorcall] = ACTIONS(1254),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(663),
    [anon_sym_else] = ACTIONS(1254),
    [anon_sym_switch] = ACTIONS(665),
    [anon_sym_case] = ACTIONS(1254),
    [anon_sym_default] = ACTIONS(1254),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_do] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(677),
    [anon_sym_break] = ACTIONS(679),
    [anon_sym_continue] = ACTIONS(681),
    [anon_sym_goto] = ACTIONS(683),
    [anon_sym___try] = ACTIONS(685),
    [anon_sym___leave] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_explicit] = ACTIONS(1254),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1254),
    [anon_sym_try] = ACTIONS(691),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_namespace] = ACTIONS(1254),
    [anon_sym_using] = ACTIONS(1254),
    [anon_sym_static_assert] = ACTIONS(1254),
    [anon_sym_concept] = ACTIONS(1254),
    [anon_sym_co_return] = ACTIONS(703),
    [anon_sym_co_yield] = ACTIONS(705),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [97] = {
    [sym_declaration] = STATE(98),
    [sym_type_definition] = STATE(98),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5505),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(873),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_compound_statement] = STATE(98),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(98),
    [sym_labeled_statement] = STATE(98),
    [sym_expression_statement] = STATE(98),
    [sym_if_statement] = STATE(98),
    [sym_switch_statement] = STATE(98),
    [sym_while_statement] = STATE(98),
    [sym_do_statement] = STATE(98),
    [sym_for_statement] = STATE(98),
    [sym_return_statement] = STATE(98),
    [sym_break_statement] = STATE(98),
    [sym_continue_statement] = STATE(98),
    [sym_goto_statement] = STATE(98),
    [sym_seh_try_statement] = STATE(98),
    [sym_seh_leave_statement] = STATE(98),
    [sym_expression] = STATE(4855),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8338),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(98),
    [sym_co_return_statement] = STATE(98),
    [sym_co_yield_statement] = STATE(98),
    [sym_throw_statement] = STATE(98),
    [sym_try_statement] = STATE(98),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(622),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_case_statement_repeat1] = STATE(98),
    [sym_identifier] = ACTIONS(1445),
    [aux_sym_preproc_include_token1] = ACTIONS(1250),
    [aux_sym_preproc_def_token1] = ACTIONS(1250),
    [aux_sym_preproc_if_token1] = ACTIONS(1250),
    [aux_sym_preproc_if_token2] = ACTIONS(1250),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1250),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1250),
    [sym_preproc_directive] = ACTIONS(1250),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP_AMP] = ACTIONS(1252),
    [anon_sym_AMP] = ACTIONS(1236),
    [anon_sym_SEMI] = ACTIONS(651),
    [anon_sym___extension__] = ACTIONS(653),
    [anon_sym_typedef] = ACTIONS(655),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1250),
    [anon_sym___cdecl] = ACTIONS(1250),
    [anon_sym___clrcall] = ACTIONS(1250),
    [anon_sym___stdcall] = ACTIONS(1250),
    [anon_sym___fastcall] = ACTIONS(1250),
    [anon_sym___thiscall] = ACTIONS(1250),
    [anon_sym___vectorcall] = ACTIONS(1250),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(663),
    [anon_sym_else] = ACTIONS(1250),
    [anon_sym_switch] = ACTIONS(665),
    [anon_sym_case] = ACTIONS(1250),
    [anon_sym_default] = ACTIONS(1250),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_do] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(677),
    [anon_sym_break] = ACTIONS(679),
    [anon_sym_continue] = ACTIONS(681),
    [anon_sym_goto] = ACTIONS(683),
    [anon_sym___try] = ACTIONS(685),
    [anon_sym___leave] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_explicit] = ACTIONS(1250),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1250),
    [anon_sym_try] = ACTIONS(691),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_namespace] = ACTIONS(1250),
    [anon_sym_using] = ACTIONS(1250),
    [anon_sym_static_assert] = ACTIONS(1250),
    [anon_sym_concept] = ACTIONS(1250),
    [anon_sym_co_return] = ACTIONS(703),
    [anon_sym_co_yield] = ACTIONS(705),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [98] = {
    [sym_declaration] = STATE(98),
    [sym_type_definition] = STATE(98),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5505),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(873),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_compound_statement] = STATE(98),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(98),
    [sym_labeled_statement] = STATE(98),
    [sym_expression_statement] = STATE(98),
    [sym_if_statement] = STATE(98),
    [sym_switch_statement] = STATE(98),
    [sym_while_statement] = STATE(98),
    [sym_do_statement] = STATE(98),
    [sym_for_statement] = STATE(98),
    [sym_return_statement] = STATE(98),
    [sym_break_statement] = STATE(98),
    [sym_continue_statement] = STATE(98),
    [sym_goto_statement] = STATE(98),
    [sym_seh_try_statement] = STATE(98),
    [sym_seh_leave_statement] = STATE(98),
    [sym_expression] = STATE(4855),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8338),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(98),
    [sym_co_return_statement] = STATE(98),
    [sym_co_yield_statement] = STATE(98),
    [sym_throw_statement] = STATE(98),
    [sym_try_statement] = STATE(98),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(622),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_case_statement_repeat1] = STATE(98),
    [sym_identifier] = ACTIONS(1509),
    [aux_sym_preproc_include_token1] = ACTIONS(1261),
    [aux_sym_preproc_def_token1] = ACTIONS(1261),
    [aux_sym_preproc_if_token1] = ACTIONS(1261),
    [aux_sym_preproc_if_token2] = ACTIONS(1261),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1261),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1261),
    [sym_preproc_directive] = ACTIONS(1261),
    [anon_sym_LPAREN2] = ACTIONS(1263),
    [anon_sym_BANG] = ACTIONS(1266),
    [anon_sym_TILDE] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_AMP_AMP] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_SEMI] = ACTIONS(1512),
    [anon_sym___extension__] = ACTIONS(1515),
    [anon_sym_typedef] = ACTIONS(1518),
    [anon_sym___device__] = ACTIONS(1289),
    [anon_sym___host__] = ACTIONS(1289),
    [anon_sym___global__] = ACTIONS(1289),
    [anon_sym___forceinline__] = ACTIONS(1289),
    [anon_sym___noinline__] = ACTIONS(1289),
    [anon_sym_extern] = ACTIONS(1292),
    [anon_sym___attribute__] = ACTIONS(1295),
    [anon_sym_COLON_COLON] = ACTIONS(1298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1301),
    [anon_sym___declspec] = ACTIONS(1304),
    [anon_sym___based] = ACTIONS(1261),
    [anon_sym___cdecl] = ACTIONS(1261),
    [anon_sym___clrcall] = ACTIONS(1261),
    [anon_sym___stdcall] = ACTIONS(1261),
    [anon_sym___fastcall] = ACTIONS(1261),
    [anon_sym___thiscall] = ACTIONS(1261),
    [anon_sym___vectorcall] = ACTIONS(1261),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_signed] = ACTIONS(1310),
    [anon_sym_unsigned] = ACTIONS(1310),
    [anon_sym_long] = ACTIONS(1310),
    [anon_sym_short] = ACTIONS(1310),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_static] = ACTIONS(1292),
    [anon_sym_register] = ACTIONS(1292),
    [anon_sym_inline] = ACTIONS(1292),
    [anon_sym___inline] = ACTIONS(1292),
    [anon_sym___inline__] = ACTIONS(1292),
    [anon_sym___forceinline] = ACTIONS(1292),
    [anon_sym_thread_local] = ACTIONS(1292),
    [anon_sym___thread] = ACTIONS(1292),
    [anon_sym_const] = ACTIONS(1316),
    [anon_sym_constexpr] = ACTIONS(1316),
    [anon_sym_volatile] = ACTIONS(1316),
    [anon_sym_restrict] = ACTIONS(1316),
    [anon_sym___restrict__] = ACTIONS(1316),
    [anon_sym__Atomic] = ACTIONS(1316),
    [anon_sym__Noreturn] = ACTIONS(1316),
    [anon_sym_noreturn] = ACTIONS(1316),
    [anon_sym_mutable] = ACTIONS(1316),
    [anon_sym_constinit] = ACTIONS(1316),
    [anon_sym_consteval] = ACTIONS(1316),
    [anon_sym___shared__] = ACTIONS(1316),
    [anon_sym___local__] = ACTIONS(1316),
    [anon_sym___constant__] = ACTIONS(1316),
    [anon_sym___managed__] = ACTIONS(1316),
    [anon_sym___grid_constant__] = ACTIONS(1316),
    [anon_sym_alignas] = ACTIONS(1319),
    [anon_sym__Alignas] = ACTIONS(1319),
    [sym_primitive_type] = ACTIONS(1322),
    [anon_sym_enum] = ACTIONS(1325),
    [anon_sym_class] = ACTIONS(1328),
    [anon_sym_struct] = ACTIONS(1331),
    [anon_sym_union] = ACTIONS(1334),
    [anon_sym_if] = ACTIONS(1524),
    [anon_sym_else] = ACTIONS(1261),
    [anon_sym_switch] = ACTIONS(1527),
    [anon_sym_case] = ACTIONS(1261),
    [anon_sym_default] = ACTIONS(1261),
    [anon_sym_while] = ACTIONS(1530),
    [anon_sym_do] = ACTIONS(1533),
    [anon_sym_for] = ACTIONS(1536),
    [anon_sym_return] = ACTIONS(1539),
    [anon_sym_break] = ACTIONS(1542),
    [anon_sym_continue] = ACTIONS(1545),
    [anon_sym_goto] = ACTIONS(1548),
    [anon_sym___try] = ACTIONS(1551),
    [anon_sym___leave] = ACTIONS(1554),
    [anon_sym_not] = ACTIONS(1269),
    [anon_sym_compl] = ACTIONS(1269),
    [anon_sym_DASH_DASH] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1370),
    [anon_sym_sizeof] = ACTIONS(1373),
    [anon_sym___alignof__] = ACTIONS(1376),
    [anon_sym___alignof] = ACTIONS(1376),
    [anon_sym__alignof] = ACTIONS(1376),
    [anon_sym_alignof] = ACTIONS(1376),
    [anon_sym__Alignof] = ACTIONS(1376),
    [anon_sym_offsetof] = ACTIONS(1379),
    [anon_sym__Generic] = ACTIONS(1382),
    [anon_sym_asm] = ACTIONS(1385),
    [anon_sym___asm__] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(1388),
    [anon_sym_L_SQUOTE] = ACTIONS(1391),
    [anon_sym_u_SQUOTE] = ACTIONS(1391),
    [anon_sym_U_SQUOTE] = ACTIONS(1391),
    [anon_sym_u8_SQUOTE] = ACTIONS(1391),
    [anon_sym_SQUOTE] = ACTIONS(1391),
    [anon_sym_L_DQUOTE] = ACTIONS(1394),
    [anon_sym_u_DQUOTE] = ACTIONS(1394),
    [anon_sym_U_DQUOTE] = ACTIONS(1394),
    [anon_sym_u8_DQUOTE] = ACTIONS(1394),
    [anon_sym_DQUOTE] = ACTIONS(1394),
    [sym_true] = ACTIONS(1397),
    [sym_false] = ACTIONS(1397),
    [anon_sym_NULL] = ACTIONS(1400),
    [anon_sym_nullptr] = ACTIONS(1400),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1403),
    [anon_sym_decltype] = ACTIONS(1406),
    [sym_virtual] = ACTIONS(1289),
    [anon_sym_explicit] = ACTIONS(1261),
    [anon_sym_typename] = ACTIONS(1409),
    [anon_sym_template] = ACTIONS(1412),
    [anon_sym_operator] = ACTIONS(1261),
    [anon_sym_try] = ACTIONS(1557),
    [anon_sym_delete] = ACTIONS(1418),
    [anon_sym_throw] = ACTIONS(1560),
    [anon_sym_namespace] = ACTIONS(1261),
    [anon_sym_using] = ACTIONS(1261),
    [anon_sym_static_assert] = ACTIONS(1261),
    [anon_sym_concept] = ACTIONS(1261),
    [anon_sym_co_return] = ACTIONS(1563),
    [anon_sym_co_yield] = ACTIONS(1566),
    [anon_sym_R_DQUOTE] = ACTIONS(1430),
    [anon_sym_LR_DQUOTE] = ACTIONS(1430),
    [anon_sym_uR_DQUOTE] = ACTIONS(1430),
    [anon_sym_UR_DQUOTE] = ACTIONS(1430),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1430),
    [anon_sym_co_await] = ACTIONS(1433),
    [anon_sym_new] = ACTIONS(1436),
    [anon_sym_requires] = ACTIONS(1439),
    [sym_this] = ACTIONS(1397),
    [anon_sym___launch_bounds__] = ACTIONS(1442),
  },
  [99] = {
    [sym_declaration] = STATE(105),
    [sym_type_definition] = STATE(105),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5531),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(873),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_compound_statement] = STATE(105),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(105),
    [sym_labeled_statement] = STATE(105),
    [sym_expression_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_switch_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_do_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_return_statement] = STATE(105),
    [sym_break_statement] = STATE(105),
    [sym_continue_statement] = STATE(105),
    [sym_goto_statement] = STATE(105),
    [sym_seh_try_statement] = STATE(105),
    [sym_seh_leave_statement] = STATE(105),
    [sym_expression] = STATE(4913),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8497),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(105),
    [sym_co_return_statement] = STATE(105),
    [sym_co_yield_statement] = STATE(105),
    [sym_throw_statement] = STATE(105),
    [sym_try_statement] = STATE(105),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(606),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_case_statement_repeat1] = STATE(105),
    [ts_builtin_sym_end] = ACTIONS(1234),
    [sym_identifier] = ACTIONS(1569),
    [aux_sym_preproc_include_token1] = ACTIONS(1228),
    [aux_sym_preproc_def_token1] = ACTIONS(1228),
    [aux_sym_preproc_if_token1] = ACTIONS(1228),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1228),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1228),
    [sym_preproc_directive] = ACTIONS(1228),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP_AMP] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(1236),
    [anon_sym_SEMI] = ACTIONS(1571),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1228),
    [anon_sym___cdecl] = ACTIONS(1228),
    [anon_sym___clrcall] = ACTIONS(1228),
    [anon_sym___stdcall] = ACTIONS(1228),
    [anon_sym___fastcall] = ACTIONS(1228),
    [anon_sym___thiscall] = ACTIONS(1228),
    [anon_sym___vectorcall] = ACTIONS(1228),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_else] = ACTIONS(1228),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(1228),
    [anon_sym_default] = ACTIONS(1228),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(1573),
    [anon_sym___leave] = ACTIONS(1575),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_explicit] = ACTIONS(1228),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1228),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_namespace] = ACTIONS(1228),
    [anon_sym_using] = ACTIONS(1228),
    [anon_sym_static_assert] = ACTIONS(1228),
    [anon_sym_concept] = ACTIONS(1228),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [100] = {
    [sym_declaration] = STATE(100),
    [sym_type_definition] = STATE(100),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5531),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(873),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_compound_statement] = STATE(100),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(100),
    [sym_labeled_statement] = STATE(100),
    [sym_expression_statement] = STATE(100),
    [sym_if_statement] = STATE(100),
    [sym_switch_statement] = STATE(100),
    [sym_while_statement] = STATE(100),
    [sym_do_statement] = STATE(100),
    [sym_for_statement] = STATE(100),
    [sym_return_statement] = STATE(100),
    [sym_break_statement] = STATE(100),
    [sym_continue_statement] = STATE(100),
    [sym_goto_statement] = STATE(100),
    [sym_seh_try_statement] = STATE(100),
    [sym_seh_leave_statement] = STATE(100),
    [sym_expression] = STATE(4913),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8497),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(100),
    [sym_co_return_statement] = STATE(100),
    [sym_co_yield_statement] = STATE(100),
    [sym_throw_statement] = STATE(100),
    [sym_try_statement] = STATE(100),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(606),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_case_statement_repeat1] = STATE(100),
    [ts_builtin_sym_end] = ACTIONS(1275),
    [sym_identifier] = ACTIONS(1577),
    [aux_sym_preproc_include_token1] = ACTIONS(1261),
    [aux_sym_preproc_def_token1] = ACTIONS(1261),
    [aux_sym_preproc_if_token1] = ACTIONS(1261),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1261),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1261),
    [sym_preproc_directive] = ACTIONS(1261),
    [anon_sym_LPAREN2] = ACTIONS(1263),
    [anon_sym_BANG] = ACTIONS(1266),
    [anon_sym_TILDE] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_AMP_AMP] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_SEMI] = ACTIONS(1580),
    [anon_sym___extension__] = ACTIONS(1583),
    [anon_sym_typedef] = ACTIONS(1586),
    [anon_sym___device__] = ACTIONS(1289),
    [anon_sym___host__] = ACTIONS(1289),
    [anon_sym___global__] = ACTIONS(1289),
    [anon_sym___forceinline__] = ACTIONS(1289),
    [anon_sym___noinline__] = ACTIONS(1289),
    [anon_sym_extern] = ACTIONS(1292),
    [anon_sym___attribute__] = ACTIONS(1295),
    [anon_sym_COLON_COLON] = ACTIONS(1298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1301),
    [anon_sym___declspec] = ACTIONS(1304),
    [anon_sym___based] = ACTIONS(1261),
    [anon_sym___cdecl] = ACTIONS(1261),
    [anon_sym___clrcall] = ACTIONS(1261),
    [anon_sym___stdcall] = ACTIONS(1261),
    [anon_sym___fastcall] = ACTIONS(1261),
    [anon_sym___thiscall] = ACTIONS(1261),
    [anon_sym___vectorcall] = ACTIONS(1261),
    [anon_sym_LBRACE] = ACTIONS(1589),
    [anon_sym_signed] = ACTIONS(1310),
    [anon_sym_unsigned] = ACTIONS(1310),
    [anon_sym_long] = ACTIONS(1310),
    [anon_sym_short] = ACTIONS(1310),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_static] = ACTIONS(1292),
    [anon_sym_register] = ACTIONS(1292),
    [anon_sym_inline] = ACTIONS(1292),
    [anon_sym___inline] = ACTIONS(1292),
    [anon_sym___inline__] = ACTIONS(1292),
    [anon_sym___forceinline] = ACTIONS(1292),
    [anon_sym_thread_local] = ACTIONS(1292),
    [anon_sym___thread] = ACTIONS(1292),
    [anon_sym_const] = ACTIONS(1316),
    [anon_sym_constexpr] = ACTIONS(1316),
    [anon_sym_volatile] = ACTIONS(1316),
    [anon_sym_restrict] = ACTIONS(1316),
    [anon_sym___restrict__] = ACTIONS(1316),
    [anon_sym__Atomic] = ACTIONS(1316),
    [anon_sym__Noreturn] = ACTIONS(1316),
    [anon_sym_noreturn] = ACTIONS(1316),
    [anon_sym_mutable] = ACTIONS(1316),
    [anon_sym_constinit] = ACTIONS(1316),
    [anon_sym_consteval] = ACTIONS(1316),
    [anon_sym___shared__] = ACTIONS(1316),
    [anon_sym___local__] = ACTIONS(1316),
    [anon_sym___constant__] = ACTIONS(1316),
    [anon_sym___managed__] = ACTIONS(1316),
    [anon_sym___grid_constant__] = ACTIONS(1316),
    [anon_sym_alignas] = ACTIONS(1319),
    [anon_sym__Alignas] = ACTIONS(1319),
    [sym_primitive_type] = ACTIONS(1322),
    [anon_sym_enum] = ACTIONS(1325),
    [anon_sym_class] = ACTIONS(1328),
    [anon_sym_struct] = ACTIONS(1331),
    [anon_sym_union] = ACTIONS(1334),
    [anon_sym_if] = ACTIONS(1592),
    [anon_sym_else] = ACTIONS(1261),
    [anon_sym_switch] = ACTIONS(1595),
    [anon_sym_case] = ACTIONS(1261),
    [anon_sym_default] = ACTIONS(1261),
    [anon_sym_while] = ACTIONS(1598),
    [anon_sym_do] = ACTIONS(1601),
    [anon_sym_for] = ACTIONS(1604),
    [anon_sym_return] = ACTIONS(1607),
    [anon_sym_break] = ACTIONS(1610),
    [anon_sym_continue] = ACTIONS(1613),
    [anon_sym_goto] = ACTIONS(1616),
    [anon_sym___try] = ACTIONS(1619),
    [anon_sym___leave] = ACTIONS(1622),
    [anon_sym_not] = ACTIONS(1269),
    [anon_sym_compl] = ACTIONS(1269),
    [anon_sym_DASH_DASH] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1370),
    [anon_sym_sizeof] = ACTIONS(1373),
    [anon_sym___alignof__] = ACTIONS(1376),
    [anon_sym___alignof] = ACTIONS(1376),
    [anon_sym__alignof] = ACTIONS(1376),
    [anon_sym_alignof] = ACTIONS(1376),
    [anon_sym__Alignof] = ACTIONS(1376),
    [anon_sym_offsetof] = ACTIONS(1379),
    [anon_sym__Generic] = ACTIONS(1382),
    [anon_sym_asm] = ACTIONS(1385),
    [anon_sym___asm__] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(1388),
    [anon_sym_L_SQUOTE] = ACTIONS(1391),
    [anon_sym_u_SQUOTE] = ACTIONS(1391),
    [anon_sym_U_SQUOTE] = ACTIONS(1391),
    [anon_sym_u8_SQUOTE] = ACTIONS(1391),
    [anon_sym_SQUOTE] = ACTIONS(1391),
    [anon_sym_L_DQUOTE] = ACTIONS(1394),
    [anon_sym_u_DQUOTE] = ACTIONS(1394),
    [anon_sym_U_DQUOTE] = ACTIONS(1394),
    [anon_sym_u8_DQUOTE] = ACTIONS(1394),
    [anon_sym_DQUOTE] = ACTIONS(1394),
    [sym_true] = ACTIONS(1397),
    [sym_false] = ACTIONS(1397),
    [anon_sym_NULL] = ACTIONS(1400),
    [anon_sym_nullptr] = ACTIONS(1400),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1403),
    [anon_sym_decltype] = ACTIONS(1406),
    [sym_virtual] = ACTIONS(1289),
    [anon_sym_explicit] = ACTIONS(1261),
    [anon_sym_typename] = ACTIONS(1409),
    [anon_sym_template] = ACTIONS(1412),
    [anon_sym_operator] = ACTIONS(1261),
    [anon_sym_try] = ACTIONS(1625),
    [anon_sym_delete] = ACTIONS(1418),
    [anon_sym_throw] = ACTIONS(1628),
    [anon_sym_namespace] = ACTIONS(1261),
    [anon_sym_using] = ACTIONS(1261),
    [anon_sym_static_assert] = ACTIONS(1261),
    [anon_sym_concept] = ACTIONS(1261),
    [anon_sym_co_return] = ACTIONS(1631),
    [anon_sym_co_yield] = ACTIONS(1634),
    [anon_sym_R_DQUOTE] = ACTIONS(1430),
    [anon_sym_LR_DQUOTE] = ACTIONS(1430),
    [anon_sym_uR_DQUOTE] = ACTIONS(1430),
    [anon_sym_UR_DQUOTE] = ACTIONS(1430),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1430),
    [anon_sym_co_await] = ACTIONS(1433),
    [anon_sym_new] = ACTIONS(1436),
    [anon_sym_requires] = ACTIONS(1439),
    [sym_this] = ACTIONS(1397),
    [anon_sym___launch_bounds__] = ACTIONS(1442),
  },
  [101] = {
    [sym_declaration] = STATE(100),
    [sym_type_definition] = STATE(100),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5531),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(873),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_compound_statement] = STATE(100),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(100),
    [sym_labeled_statement] = STATE(100),
    [sym_expression_statement] = STATE(100),
    [sym_if_statement] = STATE(100),
    [sym_switch_statement] = STATE(100),
    [sym_while_statement] = STATE(100),
    [sym_do_statement] = STATE(100),
    [sym_for_statement] = STATE(100),
    [sym_return_statement] = STATE(100),
    [sym_break_statement] = STATE(100),
    [sym_continue_statement] = STATE(100),
    [sym_goto_statement] = STATE(100),
    [sym_seh_try_statement] = STATE(100),
    [sym_seh_leave_statement] = STATE(100),
    [sym_expression] = STATE(4913),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8497),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(100),
    [sym_co_return_statement] = STATE(100),
    [sym_co_yield_statement] = STATE(100),
    [sym_throw_statement] = STATE(100),
    [sym_try_statement] = STATE(100),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(606),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_case_statement_repeat1] = STATE(100),
    [ts_builtin_sym_end] = ACTIONS(1252),
    [sym_identifier] = ACTIONS(1569),
    [aux_sym_preproc_include_token1] = ACTIONS(1250),
    [aux_sym_preproc_def_token1] = ACTIONS(1250),
    [aux_sym_preproc_if_token1] = ACTIONS(1250),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1250),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1250),
    [sym_preproc_directive] = ACTIONS(1250),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP_AMP] = ACTIONS(1252),
    [anon_sym_AMP] = ACTIONS(1236),
    [anon_sym_SEMI] = ACTIONS(1571),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1250),
    [anon_sym___cdecl] = ACTIONS(1250),
    [anon_sym___clrcall] = ACTIONS(1250),
    [anon_sym___stdcall] = ACTIONS(1250),
    [anon_sym___fastcall] = ACTIONS(1250),
    [anon_sym___thiscall] = ACTIONS(1250),
    [anon_sym___vectorcall] = ACTIONS(1250),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_else] = ACTIONS(1250),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(1250),
    [anon_sym_default] = ACTIONS(1250),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(1573),
    [anon_sym___leave] = ACTIONS(1575),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_explicit] = ACTIONS(1250),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1250),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_namespace] = ACTIONS(1250),
    [anon_sym_using] = ACTIONS(1250),
    [anon_sym_static_assert] = ACTIONS(1250),
    [anon_sym_concept] = ACTIONS(1250),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [102] = {
    [sym_declaration] = STATE(94),
    [sym_type_definition] = STATE(94),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5446),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(873),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_compound_statement] = STATE(94),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(94),
    [sym_labeled_statement] = STATE(94),
    [sym_expression_statement] = STATE(94),
    [sym_if_statement] = STATE(94),
    [sym_switch_statement] = STATE(94),
    [sym_while_statement] = STATE(94),
    [sym_do_statement] = STATE(94),
    [sym_for_statement] = STATE(94),
    [sym_return_statement] = STATE(94),
    [sym_break_statement] = STATE(94),
    [sym_continue_statement] = STATE(94),
    [sym_goto_statement] = STATE(94),
    [sym_seh_try_statement] = STATE(94),
    [sym_seh_leave_statement] = STATE(94),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(94),
    [sym_co_return_statement] = STATE(94),
    [sym_co_yield_statement] = STATE(94),
    [sym_throw_statement] = STATE(94),
    [sym_try_statement] = STATE(94),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_case_statement_repeat1] = STATE(94),
    [sym_identifier] = ACTIONS(1447),
    [aux_sym_preproc_include_token1] = ACTIONS(1246),
    [aux_sym_preproc_def_token1] = ACTIONS(1246),
    [aux_sym_preproc_if_token1] = ACTIONS(1246),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1246),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1246),
    [sym_preproc_directive] = ACTIONS(1246),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP_AMP] = ACTIONS(1248),
    [anon_sym_AMP] = ACTIONS(1236),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1246),
    [anon_sym___cdecl] = ACTIONS(1246),
    [anon_sym___clrcall] = ACTIONS(1246),
    [anon_sym___stdcall] = ACTIONS(1246),
    [anon_sym___fastcall] = ACTIONS(1246),
    [anon_sym___thiscall] = ACTIONS(1246),
    [anon_sym___vectorcall] = ACTIONS(1246),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(1248),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_else] = ACTIONS(1246),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(1246),
    [anon_sym_default] = ACTIONS(1246),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_explicit] = ACTIONS(1246),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1246),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(1246),
    [anon_sym_using] = ACTIONS(1246),
    [anon_sym_static_assert] = ACTIONS(1246),
    [anon_sym_concept] = ACTIONS(1246),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [103] = {
    [sym_declaration] = STATE(93),
    [sym_type_definition] = STATE(93),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5446),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(873),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_compound_statement] = STATE(93),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(93),
    [sym_labeled_statement] = STATE(93),
    [sym_expression_statement] = STATE(93),
    [sym_if_statement] = STATE(93),
    [sym_switch_statement] = STATE(93),
    [sym_while_statement] = STATE(93),
    [sym_do_statement] = STATE(93),
    [sym_for_statement] = STATE(93),
    [sym_return_statement] = STATE(93),
    [sym_break_statement] = STATE(93),
    [sym_continue_statement] = STATE(93),
    [sym_goto_statement] = STATE(93),
    [sym_seh_try_statement] = STATE(93),
    [sym_seh_leave_statement] = STATE(93),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(93),
    [sym_co_return_statement] = STATE(93),
    [sym_co_yield_statement] = STATE(93),
    [sym_throw_statement] = STATE(93),
    [sym_try_statement] = STATE(93),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_case_statement_repeat1] = STATE(93),
    [sym_identifier] = ACTIONS(1447),
    [aux_sym_preproc_include_token1] = ACTIONS(1254),
    [aux_sym_preproc_def_token1] = ACTIONS(1254),
    [aux_sym_preproc_if_token1] = ACTIONS(1254),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1254),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1254),
    [sym_preproc_directive] = ACTIONS(1254),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP_AMP] = ACTIONS(1256),
    [anon_sym_AMP] = ACTIONS(1236),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1254),
    [anon_sym___cdecl] = ACTIONS(1254),
    [anon_sym___clrcall] = ACTIONS(1254),
    [anon_sym___stdcall] = ACTIONS(1254),
    [anon_sym___fastcall] = ACTIONS(1254),
    [anon_sym___thiscall] = ACTIONS(1254),
    [anon_sym___vectorcall] = ACTIONS(1254),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_RBRACE] = ACTIONS(1256),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_else] = ACTIONS(1254),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(1254),
    [anon_sym_default] = ACTIONS(1254),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_explicit] = ACTIONS(1254),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1254),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(1254),
    [anon_sym_using] = ACTIONS(1254),
    [anon_sym_static_assert] = ACTIONS(1254),
    [anon_sym_concept] = ACTIONS(1254),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [104] = {
    [sym_declaration] = STATE(101),
    [sym_type_definition] = STATE(101),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5531),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(873),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_compound_statement] = STATE(101),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(101),
    [sym_labeled_statement] = STATE(101),
    [sym_expression_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_switch_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_do_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_return_statement] = STATE(101),
    [sym_break_statement] = STATE(101),
    [sym_continue_statement] = STATE(101),
    [sym_goto_statement] = STATE(101),
    [sym_seh_try_statement] = STATE(101),
    [sym_seh_leave_statement] = STATE(101),
    [sym_expression] = STATE(4913),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8497),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(101),
    [sym_co_return_statement] = STATE(101),
    [sym_co_yield_statement] = STATE(101),
    [sym_throw_statement] = STATE(101),
    [sym_try_statement] = STATE(101),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(606),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_case_statement_repeat1] = STATE(101),
    [ts_builtin_sym_end] = ACTIONS(1256),
    [sym_identifier] = ACTIONS(1569),
    [aux_sym_preproc_include_token1] = ACTIONS(1254),
    [aux_sym_preproc_def_token1] = ACTIONS(1254),
    [aux_sym_preproc_if_token1] = ACTIONS(1254),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1254),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1254),
    [sym_preproc_directive] = ACTIONS(1254),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP_AMP] = ACTIONS(1256),
    [anon_sym_AMP] = ACTIONS(1236),
    [anon_sym_SEMI] = ACTIONS(1571),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1254),
    [anon_sym___cdecl] = ACTIONS(1254),
    [anon_sym___clrcall] = ACTIONS(1254),
    [anon_sym___stdcall] = ACTIONS(1254),
    [anon_sym___fastcall] = ACTIONS(1254),
    [anon_sym___thiscall] = ACTIONS(1254),
    [anon_sym___vectorcall] = ACTIONS(1254),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_else] = ACTIONS(1254),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(1254),
    [anon_sym_default] = ACTIONS(1254),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(1573),
    [anon_sym___leave] = ACTIONS(1575),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_explicit] = ACTIONS(1254),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1254),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_namespace] = ACTIONS(1254),
    [anon_sym_using] = ACTIONS(1254),
    [anon_sym_static_assert] = ACTIONS(1254),
    [anon_sym_concept] = ACTIONS(1254),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [105] = {
    [sym_declaration] = STATE(100),
    [sym_type_definition] = STATE(100),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5531),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(873),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_compound_statement] = STATE(100),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(100),
    [sym_labeled_statement] = STATE(100),
    [sym_expression_statement] = STATE(100),
    [sym_if_statement] = STATE(100),
    [sym_switch_statement] = STATE(100),
    [sym_while_statement] = STATE(100),
    [sym_do_statement] = STATE(100),
    [sym_for_statement] = STATE(100),
    [sym_return_statement] = STATE(100),
    [sym_break_statement] = STATE(100),
    [sym_continue_statement] = STATE(100),
    [sym_goto_statement] = STATE(100),
    [sym_seh_try_statement] = STATE(100),
    [sym_seh_leave_statement] = STATE(100),
    [sym_expression] = STATE(4913),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8497),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(100),
    [sym_co_return_statement] = STATE(100),
    [sym_co_yield_statement] = STATE(100),
    [sym_throw_statement] = STATE(100),
    [sym_try_statement] = STATE(100),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(606),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_case_statement_repeat1] = STATE(100),
    [ts_builtin_sym_end] = ACTIONS(1248),
    [sym_identifier] = ACTIONS(1569),
    [aux_sym_preproc_include_token1] = ACTIONS(1246),
    [aux_sym_preproc_def_token1] = ACTIONS(1246),
    [aux_sym_preproc_if_token1] = ACTIONS(1246),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1246),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1246),
    [sym_preproc_directive] = ACTIONS(1246),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP_AMP] = ACTIONS(1248),
    [anon_sym_AMP] = ACTIONS(1236),
    [anon_sym_SEMI] = ACTIONS(1571),
    [anon_sym___extension__] = ACTIONS(33),
    [anon_sym_typedef] = ACTIONS(35),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(1246),
    [anon_sym___cdecl] = ACTIONS(1246),
    [anon_sym___clrcall] = ACTIONS(1246),
    [anon_sym___stdcall] = ACTIONS(1246),
    [anon_sym___fastcall] = ACTIONS(1246),
    [anon_sym___thiscall] = ACTIONS(1246),
    [anon_sym___vectorcall] = ACTIONS(1246),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_else] = ACTIONS(1246),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(1246),
    [anon_sym_default] = ACTIONS(1246),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(1573),
    [anon_sym___leave] = ACTIONS(1575),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_explicit] = ACTIONS(1246),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1246),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_namespace] = ACTIONS(1246),
    [anon_sym_using] = ACTIONS(1246),
    [anon_sym_static_assert] = ACTIONS(1246),
    [anon_sym_concept] = ACTIONS(1246),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [106] = {
    [sym_declaration] = STATE(110),
    [sym_type_definition] = STATE(110),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5564),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(873),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_compound_statement] = STATE(110),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(110),
    [sym_labeled_statement] = STATE(110),
    [sym_expression_statement] = STATE(110),
    [sym_if_statement] = STATE(110),
    [sym_switch_statement] = STATE(110),
    [sym_while_statement] = STATE(110),
    [sym_do_statement] = STATE(110),
    [sym_for_statement] = STATE(110),
    [sym_return_statement] = STATE(110),
    [sym_break_statement] = STATE(110),
    [sym_continue_statement] = STATE(110),
    [sym_goto_statement] = STATE(110),
    [sym_seh_try_statement] = STATE(110),
    [sym_seh_leave_statement] = STATE(110),
    [sym_expression] = STATE(4739),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8303),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(110),
    [sym_co_return_statement] = STATE(110),
    [sym_co_yield_statement] = STATE(110),
    [sym_throw_statement] = STATE(110),
    [sym_try_statement] = STATE(110),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(665),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_case_statement_repeat1] = STATE(110),
    [sym_identifier] = ACTIONS(1637),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1639),
    [anon_sym___extension__] = ACTIONS(1641),
    [anon_sym_typedef] = ACTIONS(1643),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(1645),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(1647),
    [anon_sym_else] = ACTIONS(1254),
    [anon_sym_switch] = ACTIONS(1649),
    [anon_sym_while] = ACTIONS(1651),
    [anon_sym_do] = ACTIONS(1653),
    [anon_sym_for] = ACTIONS(1655),
    [anon_sym_return] = ACTIONS(1657),
    [anon_sym_break] = ACTIONS(1659),
    [anon_sym_continue] = ACTIONS(1661),
    [anon_sym_goto] = ACTIONS(1663),
    [anon_sym___try] = ACTIONS(1665),
    [anon_sym___leave] = ACTIONS(1667),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(1669),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_co_return] = ACTIONS(1673),
    [anon_sym_co_yield] = ACTIONS(1675),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [107] = {
    [sym_declaration] = STATE(108),
    [sym_type_definition] = STATE(108),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5564),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(873),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_compound_statement] = STATE(108),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(108),
    [sym_labeled_statement] = STATE(108),
    [sym_expression_statement] = STATE(108),
    [sym_if_statement] = STATE(108),
    [sym_switch_statement] = STATE(108),
    [sym_while_statement] = STATE(108),
    [sym_do_statement] = STATE(108),
    [sym_for_statement] = STATE(108),
    [sym_return_statement] = STATE(108),
    [sym_break_statement] = STATE(108),
    [sym_continue_statement] = STATE(108),
    [sym_goto_statement] = STATE(108),
    [sym_seh_try_statement] = STATE(108),
    [sym_seh_leave_statement] = STATE(108),
    [sym_expression] = STATE(4739),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8303),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(108),
    [sym_co_return_statement] = STATE(108),
    [sym_co_yield_statement] = STATE(108),
    [sym_throw_statement] = STATE(108),
    [sym_try_statement] = STATE(108),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(665),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_case_statement_repeat1] = STATE(108),
    [sym_identifier] = ACTIONS(1637),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1639),
    [anon_sym___extension__] = ACTIONS(1641),
    [anon_sym_typedef] = ACTIONS(1643),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(1645),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(1647),
    [anon_sym_else] = ACTIONS(1228),
    [anon_sym_switch] = ACTIONS(1649),
    [anon_sym_while] = ACTIONS(1651),
    [anon_sym_do] = ACTIONS(1653),
    [anon_sym_for] = ACTIONS(1655),
    [anon_sym_return] = ACTIONS(1657),
    [anon_sym_break] = ACTIONS(1659),
    [anon_sym_continue] = ACTIONS(1661),
    [anon_sym_goto] = ACTIONS(1663),
    [anon_sym___try] = ACTIONS(1665),
    [anon_sym___leave] = ACTIONS(1667),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(1669),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_co_return] = ACTIONS(1673),
    [anon_sym_co_yield] = ACTIONS(1675),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [108] = {
    [sym_declaration] = STATE(109),
    [sym_type_definition] = STATE(109),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5564),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(873),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_compound_statement] = STATE(109),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(109),
    [sym_labeled_statement] = STATE(109),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_switch_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_goto_statement] = STATE(109),
    [sym_seh_try_statement] = STATE(109),
    [sym_seh_leave_statement] = STATE(109),
    [sym_expression] = STATE(4739),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8303),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(109),
    [sym_co_return_statement] = STATE(109),
    [sym_co_yield_statement] = STATE(109),
    [sym_throw_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(665),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_case_statement_repeat1] = STATE(109),
    [sym_identifier] = ACTIONS(1637),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1639),
    [anon_sym___extension__] = ACTIONS(1641),
    [anon_sym_typedef] = ACTIONS(1643),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(1645),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(1647),
    [anon_sym_else] = ACTIONS(1246),
    [anon_sym_switch] = ACTIONS(1649),
    [anon_sym_while] = ACTIONS(1651),
    [anon_sym_do] = ACTIONS(1653),
    [anon_sym_for] = ACTIONS(1655),
    [anon_sym_return] = ACTIONS(1657),
    [anon_sym_break] = ACTIONS(1659),
    [anon_sym_continue] = ACTIONS(1661),
    [anon_sym_goto] = ACTIONS(1663),
    [anon_sym___try] = ACTIONS(1665),
    [anon_sym___leave] = ACTIONS(1667),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(1669),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_co_return] = ACTIONS(1673),
    [anon_sym_co_yield] = ACTIONS(1675),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [109] = {
    [sym_declaration] = STATE(109),
    [sym_type_definition] = STATE(109),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5564),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(873),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_compound_statement] = STATE(109),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(109),
    [sym_labeled_statement] = STATE(109),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_switch_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_goto_statement] = STATE(109),
    [sym_seh_try_statement] = STATE(109),
    [sym_seh_leave_statement] = STATE(109),
    [sym_expression] = STATE(4739),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8303),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(109),
    [sym_co_return_statement] = STATE(109),
    [sym_co_yield_statement] = STATE(109),
    [sym_throw_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(665),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_case_statement_repeat1] = STATE(109),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_LPAREN2] = ACTIONS(1263),
    [anon_sym_BANG] = ACTIONS(1266),
    [anon_sym_TILDE] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_PLUS] = ACTIONS(1269),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_SEMI] = ACTIONS(1680),
    [anon_sym___extension__] = ACTIONS(1683),
    [anon_sym_typedef] = ACTIONS(1686),
    [anon_sym___device__] = ACTIONS(1289),
    [anon_sym___host__] = ACTIONS(1289),
    [anon_sym___global__] = ACTIONS(1289),
    [anon_sym___forceinline__] = ACTIONS(1289),
    [anon_sym___noinline__] = ACTIONS(1289),
    [anon_sym_extern] = ACTIONS(1292),
    [anon_sym___attribute__] = ACTIONS(1295),
    [anon_sym_COLON_COLON] = ACTIONS(1298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1301),
    [anon_sym___declspec] = ACTIONS(1304),
    [anon_sym_LBRACE] = ACTIONS(1689),
    [anon_sym_signed] = ACTIONS(1310),
    [anon_sym_unsigned] = ACTIONS(1310),
    [anon_sym_long] = ACTIONS(1310),
    [anon_sym_short] = ACTIONS(1310),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_static] = ACTIONS(1292),
    [anon_sym_register] = ACTIONS(1292),
    [anon_sym_inline] = ACTIONS(1292),
    [anon_sym___inline] = ACTIONS(1292),
    [anon_sym___inline__] = ACTIONS(1292),
    [anon_sym___forceinline] = ACTIONS(1292),
    [anon_sym_thread_local] = ACTIONS(1292),
    [anon_sym___thread] = ACTIONS(1292),
    [anon_sym_const] = ACTIONS(1316),
    [anon_sym_constexpr] = ACTIONS(1316),
    [anon_sym_volatile] = ACTIONS(1316),
    [anon_sym_restrict] = ACTIONS(1316),
    [anon_sym___restrict__] = ACTIONS(1316),
    [anon_sym__Atomic] = ACTIONS(1316),
    [anon_sym__Noreturn] = ACTIONS(1316),
    [anon_sym_noreturn] = ACTIONS(1316),
    [anon_sym_mutable] = ACTIONS(1316),
    [anon_sym_constinit] = ACTIONS(1316),
    [anon_sym_consteval] = ACTIONS(1316),
    [anon_sym___shared__] = ACTIONS(1316),
    [anon_sym___local__] = ACTIONS(1316),
    [anon_sym___constant__] = ACTIONS(1316),
    [anon_sym___managed__] = ACTIONS(1316),
    [anon_sym___grid_constant__] = ACTIONS(1316),
    [anon_sym_alignas] = ACTIONS(1319),
    [anon_sym__Alignas] = ACTIONS(1319),
    [sym_primitive_type] = ACTIONS(1322),
    [anon_sym_enum] = ACTIONS(1325),
    [anon_sym_class] = ACTIONS(1328),
    [anon_sym_struct] = ACTIONS(1331),
    [anon_sym_union] = ACTIONS(1334),
    [anon_sym_if] = ACTIONS(1692),
    [anon_sym_else] = ACTIONS(1261),
    [anon_sym_switch] = ACTIONS(1695),
    [anon_sym_while] = ACTIONS(1698),
    [anon_sym_do] = ACTIONS(1701),
    [anon_sym_for] = ACTIONS(1704),
    [anon_sym_return] = ACTIONS(1707),
    [anon_sym_break] = ACTIONS(1710),
    [anon_sym_continue] = ACTIONS(1713),
    [anon_sym_goto] = ACTIONS(1716),
    [anon_sym___try] = ACTIONS(1719),
    [anon_sym___leave] = ACTIONS(1722),
    [anon_sym_not] = ACTIONS(1269),
    [anon_sym_compl] = ACTIONS(1269),
    [anon_sym_DASH_DASH] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1370),
    [anon_sym_sizeof] = ACTIONS(1373),
    [anon_sym___alignof__] = ACTIONS(1376),
    [anon_sym___alignof] = ACTIONS(1376),
    [anon_sym__alignof] = ACTIONS(1376),
    [anon_sym_alignof] = ACTIONS(1376),
    [anon_sym__Alignof] = ACTIONS(1376),
    [anon_sym_offsetof] = ACTIONS(1379),
    [anon_sym__Generic] = ACTIONS(1382),
    [anon_sym_asm] = ACTIONS(1385),
    [anon_sym___asm__] = ACTIONS(1385),
    [sym_number_literal] = ACTIONS(1388),
    [anon_sym_L_SQUOTE] = ACTIONS(1391),
    [anon_sym_u_SQUOTE] = ACTIONS(1391),
    [anon_sym_U_SQUOTE] = ACTIONS(1391),
    [anon_sym_u8_SQUOTE] = ACTIONS(1391),
    [anon_sym_SQUOTE] = ACTIONS(1391),
    [anon_sym_L_DQUOTE] = ACTIONS(1394),
    [anon_sym_u_DQUOTE] = ACTIONS(1394),
    [anon_sym_U_DQUOTE] = ACTIONS(1394),
    [anon_sym_u8_DQUOTE] = ACTIONS(1394),
    [anon_sym_DQUOTE] = ACTIONS(1394),
    [sym_true] = ACTIONS(1397),
    [sym_false] = ACTIONS(1397),
    [anon_sym_NULL] = ACTIONS(1400),
    [anon_sym_nullptr] = ACTIONS(1400),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1403),
    [anon_sym_decltype] = ACTIONS(1406),
    [sym_virtual] = ACTIONS(1289),
    [anon_sym_typename] = ACTIONS(1409),
    [anon_sym_template] = ACTIONS(1412),
    [anon_sym_try] = ACTIONS(1725),
    [anon_sym_delete] = ACTIONS(1418),
    [anon_sym_throw] = ACTIONS(1728),
    [anon_sym_co_return] = ACTIONS(1731),
    [anon_sym_co_yield] = ACTIONS(1734),
    [anon_sym_R_DQUOTE] = ACTIONS(1430),
    [anon_sym_LR_DQUOTE] = ACTIONS(1430),
    [anon_sym_uR_DQUOTE] = ACTIONS(1430),
    [anon_sym_UR_DQUOTE] = ACTIONS(1430),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1430),
    [anon_sym_co_await] = ACTIONS(1433),
    [anon_sym_new] = ACTIONS(1436),
    [anon_sym_requires] = ACTIONS(1439),
    [sym_this] = ACTIONS(1397),
    [anon_sym___launch_bounds__] = ACTIONS(1442),
  },
  [110] = {
    [sym_declaration] = STATE(109),
    [sym_type_definition] = STATE(109),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5564),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(873),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_compound_statement] = STATE(109),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_attributed_statement] = STATE(109),
    [sym_labeled_statement] = STATE(109),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_switch_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_goto_statement] = STATE(109),
    [sym_seh_try_statement] = STATE(109),
    [sym_seh_leave_statement] = STATE(109),
    [sym_expression] = STATE(4739),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8303),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(109),
    [sym_co_return_statement] = STATE(109),
    [sym_co_yield_statement] = STATE(109),
    [sym_throw_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_attributed_declarator_repeat1] = STATE(665),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_case_statement_repeat1] = STATE(109),
    [sym_identifier] = ACTIONS(1637),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1639),
    [anon_sym___extension__] = ACTIONS(1641),
    [anon_sym_typedef] = ACTIONS(1643),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(1645),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(1647),
    [anon_sym_else] = ACTIONS(1250),
    [anon_sym_switch] = ACTIONS(1649),
    [anon_sym_while] = ACTIONS(1651),
    [anon_sym_do] = ACTIONS(1653),
    [anon_sym_for] = ACTIONS(1655),
    [anon_sym_return] = ACTIONS(1657),
    [anon_sym_break] = ACTIONS(1659),
    [anon_sym_continue] = ACTIONS(1661),
    [anon_sym_goto] = ACTIONS(1663),
    [anon_sym___try] = ACTIONS(1665),
    [anon_sym___leave] = ACTIONS(1667),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(1669),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_co_return] = ACTIONS(1673),
    [anon_sym_co_yield] = ACTIONS(1675),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [111] = {
    [sym_declaration] = STATE(287),
    [sym_type_definition] = STATE(3537),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5449),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_expression_statement] = STATE(3537),
    [sym__for_statement_body] = STATE(8341),
    [sym_expression] = STATE(4790),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8399),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_alias_declaration] = STATE(3537),
    [sym__for_range_loop_body] = STATE(8342),
    [sym_init_statement] = STATE(1827),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(1737),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1739),
    [anon_sym___extension__] = ACTIONS(1741),
    [anon_sym_typedef] = ACTIONS(1743),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_using] = ACTIONS(1747),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [112] = {
    [sym_declaration] = STATE(287),
    [sym_type_definition] = STATE(3537),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5449),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_expression_statement] = STATE(3537),
    [sym__for_statement_body] = STATE(8430),
    [sym_expression] = STATE(4790),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8399),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_alias_declaration] = STATE(3537),
    [sym__for_range_loop_body] = STATE(8427),
    [sym_init_statement] = STATE(1827),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(1737),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1739),
    [anon_sym___extension__] = ACTIONS(1741),
    [anon_sym_typedef] = ACTIONS(1743),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_using] = ACTIONS(1747),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [113] = {
    [sym_declaration] = STATE(287),
    [sym_type_definition] = STATE(3537),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5449),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_expression_statement] = STATE(3537),
    [sym__for_statement_body] = STATE(8397),
    [sym_expression] = STATE(4790),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8399),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_alias_declaration] = STATE(3537),
    [sym__for_range_loop_body] = STATE(8401),
    [sym_init_statement] = STATE(1827),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(1737),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1739),
    [anon_sym___extension__] = ACTIONS(1741),
    [anon_sym_typedef] = ACTIONS(1743),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_using] = ACTIONS(1747),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [114] = {
    [sym_declaration] = STATE(287),
    [sym_type_definition] = STATE(3537),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5449),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_expression_statement] = STATE(3537),
    [sym__for_statement_body] = STATE(9065),
    [sym_expression] = STATE(4790),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8399),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_alias_declaration] = STATE(3537),
    [sym__for_range_loop_body] = STATE(9069),
    [sym_init_statement] = STATE(1827),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(1737),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1739),
    [anon_sym___extension__] = ACTIONS(1741),
    [anon_sym_typedef] = ACTIONS(1743),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_using] = ACTIONS(1747),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [115] = {
    [sym_declaration] = STATE(287),
    [sym_type_definition] = STATE(3537),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5449),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_expression_statement] = STATE(3537),
    [sym__for_statement_body] = STATE(8229),
    [sym_expression] = STATE(4790),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8399),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_alias_declaration] = STATE(3537),
    [sym__for_range_loop_body] = STATE(8230),
    [sym_init_statement] = STATE(1827),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(1737),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1739),
    [anon_sym___extension__] = ACTIONS(1741),
    [anon_sym_typedef] = ACTIONS(1743),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_using] = ACTIONS(1747),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [116] = {
    [sym_declaration] = STATE(287),
    [sym_type_definition] = STATE(3537),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5449),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_expression_statement] = STATE(3537),
    [sym__for_statement_body] = STATE(8676),
    [sym_expression] = STATE(4790),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8399),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_alias_declaration] = STATE(3537),
    [sym__for_range_loop_body] = STATE(8677),
    [sym_init_statement] = STATE(1827),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(1737),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1739),
    [anon_sym___extension__] = ACTIONS(1741),
    [anon_sym_typedef] = ACTIONS(1743),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_using] = ACTIONS(1747),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [117] = {
    [sym_declaration] = STATE(963),
    [sym_type_definition] = STATE(963),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5442),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_expression_statement] = STATE(963),
    [sym_expression] = STATE(4689),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(7977),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_alias_declaration] = STATE(963),
    [sym_init_statement] = STATE(130),
    [sym_condition_declaration] = STATE(8386),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(1737),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1639),
    [anon_sym___extension__] = ACTIONS(1641),
    [anon_sym_typedef] = ACTIONS(1643),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_using] = ACTIONS(1749),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [118] = {
    [sym__declaration_modifiers] = STATE(1847),
    [sym__declaration_specifiers] = STATE(4480),
    [sym_attribute_specifier] = STATE(1847),
    [sym_attribute_declaration] = STATE(1847),
    [sym_ms_declspec_modifier] = STATE(1847),
    [sym_storage_class_specifier] = STATE(1847),
    [sym_type_qualifier] = STATE(1847),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_parameter_declaration] = STATE(7541),
    [sym_expression] = STATE(3262),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(7992),
    [sym_dependent_type] = STATE(2200),
    [sym_optional_parameter_declaration] = STATE(7541),
    [sym_variadic_parameter_declaration] = STATE(7541),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym__unary_left_fold] = STATE(8299),
    [sym__unary_right_fold] = STATE(8308),
    [sym__binary_fold] = STATE(8312),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5934),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_launch_bounds] = STATE(1847),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1847),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(1751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_RPAREN] = ACTIONS(1755),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1765),
    [anon_sym___host__] = ACTIONS(1765),
    [anon_sym___global__] = ACTIONS(1765),
    [anon_sym___forceinline__] = ACTIONS(1765),
    [anon_sym___noinline__] = ACTIONS(1765),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1769),
    [anon_sym_enum] = ACTIONS(1771),
    [anon_sym_class] = ACTIONS(1773),
    [anon_sym_struct] = ACTIONS(1775),
    [anon_sym_union] = ACTIONS(1777),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1765),
    [anon_sym_typename] = ACTIONS(1801),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [119] = {
    [sym__declaration_modifiers] = STATE(1847),
    [sym__declaration_specifiers] = STATE(4480),
    [sym_attribute_specifier] = STATE(1847),
    [sym_attribute_declaration] = STATE(1847),
    [sym_ms_declspec_modifier] = STATE(1847),
    [sym_storage_class_specifier] = STATE(1847),
    [sym_type_qualifier] = STATE(1847),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_parameter_declaration] = STATE(7541),
    [sym_expression] = STATE(3386),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(7992),
    [sym_dependent_type] = STATE(2200),
    [sym_optional_parameter_declaration] = STATE(7541),
    [sym_variadic_parameter_declaration] = STATE(7541),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym__unary_left_fold] = STATE(8983),
    [sym__unary_right_fold] = STATE(8982),
    [sym__binary_fold] = STATE(8978),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5934),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_launch_bounds] = STATE(1847),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1847),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(1751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_RPAREN] = ACTIONS(1755),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1765),
    [anon_sym___host__] = ACTIONS(1765),
    [anon_sym___global__] = ACTIONS(1765),
    [anon_sym___forceinline__] = ACTIONS(1765),
    [anon_sym___noinline__] = ACTIONS(1765),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1769),
    [anon_sym_enum] = ACTIONS(1771),
    [anon_sym_class] = ACTIONS(1773),
    [anon_sym_struct] = ACTIONS(1775),
    [anon_sym_union] = ACTIONS(1777),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1765),
    [anon_sym_typename] = ACTIONS(1801),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [120] = {
    [sym__declaration_modifiers] = STATE(1847),
    [sym__declaration_specifiers] = STATE(4480),
    [sym_attribute_specifier] = STATE(1847),
    [sym_attribute_declaration] = STATE(1847),
    [sym_ms_declspec_modifier] = STATE(1847),
    [sym_storage_class_specifier] = STATE(1847),
    [sym_type_qualifier] = STATE(1847),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_parameter_declaration] = STATE(7541),
    [sym_expression] = STATE(3355),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(7992),
    [sym_dependent_type] = STATE(2200),
    [sym_optional_parameter_declaration] = STATE(7541),
    [sym_variadic_parameter_declaration] = STATE(7541),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym__unary_left_fold] = STATE(8518),
    [sym__unary_right_fold] = STATE(8523),
    [sym__binary_fold] = STATE(8524),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5934),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_launch_bounds] = STATE(1847),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1847),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(1751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_RPAREN] = ACTIONS(1755),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1765),
    [anon_sym___host__] = ACTIONS(1765),
    [anon_sym___global__] = ACTIONS(1765),
    [anon_sym___forceinline__] = ACTIONS(1765),
    [anon_sym___noinline__] = ACTIONS(1765),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1769),
    [anon_sym_enum] = ACTIONS(1771),
    [anon_sym_class] = ACTIONS(1773),
    [anon_sym_struct] = ACTIONS(1775),
    [anon_sym_union] = ACTIONS(1777),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1765),
    [anon_sym_typename] = ACTIONS(1801),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [121] = {
    [sym__declaration_modifiers] = STATE(1847),
    [sym__declaration_specifiers] = STATE(4480),
    [sym_attribute_specifier] = STATE(1847),
    [sym_attribute_declaration] = STATE(1847),
    [sym_ms_declspec_modifier] = STATE(1847),
    [sym_storage_class_specifier] = STATE(1847),
    [sym_type_qualifier] = STATE(1847),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_parameter_declaration] = STATE(7541),
    [sym_expression] = STATE(3238),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(7992),
    [sym_dependent_type] = STATE(2200),
    [sym_optional_parameter_declaration] = STATE(7541),
    [sym_variadic_parameter_declaration] = STATE(7541),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym__unary_left_fold] = STATE(8509),
    [sym__unary_right_fold] = STATE(8507),
    [sym__binary_fold] = STATE(8501),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5934),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_launch_bounds] = STATE(1847),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1847),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(1751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_RPAREN] = ACTIONS(1755),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1765),
    [anon_sym___host__] = ACTIONS(1765),
    [anon_sym___global__] = ACTIONS(1765),
    [anon_sym___forceinline__] = ACTIONS(1765),
    [anon_sym___noinline__] = ACTIONS(1765),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1769),
    [anon_sym_enum] = ACTIONS(1771),
    [anon_sym_class] = ACTIONS(1773),
    [anon_sym_struct] = ACTIONS(1775),
    [anon_sym_union] = ACTIONS(1777),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1765),
    [anon_sym_typename] = ACTIONS(1801),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [122] = {
    [sym__declaration_modifiers] = STATE(1847),
    [sym__declaration_specifiers] = STATE(4480),
    [sym_attribute_specifier] = STATE(1847),
    [sym_attribute_declaration] = STATE(1847),
    [sym_ms_declspec_modifier] = STATE(1847),
    [sym_storage_class_specifier] = STATE(1847),
    [sym_type_qualifier] = STATE(1847),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_parameter_declaration] = STATE(7541),
    [sym_expression] = STATE(3214),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(7992),
    [sym_dependent_type] = STATE(2200),
    [sym_optional_parameter_declaration] = STATE(7541),
    [sym_variadic_parameter_declaration] = STATE(7541),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym__unary_left_fold] = STATE(8360),
    [sym__unary_right_fold] = STATE(8359),
    [sym__binary_fold] = STATE(8354),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5934),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_launch_bounds] = STATE(1847),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1847),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(1751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_RPAREN] = ACTIONS(1755),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1765),
    [anon_sym___host__] = ACTIONS(1765),
    [anon_sym___global__] = ACTIONS(1765),
    [anon_sym___forceinline__] = ACTIONS(1765),
    [anon_sym___noinline__] = ACTIONS(1765),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1769),
    [anon_sym_enum] = ACTIONS(1771),
    [anon_sym_class] = ACTIONS(1773),
    [anon_sym_struct] = ACTIONS(1775),
    [anon_sym_union] = ACTIONS(1777),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1765),
    [anon_sym_typename] = ACTIONS(1801),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [123] = {
    [sym__declaration_modifiers] = STATE(1847),
    [sym__declaration_specifiers] = STATE(4480),
    [sym_attribute_specifier] = STATE(1847),
    [sym_attribute_declaration] = STATE(1847),
    [sym_ms_declspec_modifier] = STATE(1847),
    [sym_storage_class_specifier] = STATE(1847),
    [sym_type_qualifier] = STATE(1847),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_parameter_declaration] = STATE(7541),
    [sym_expression] = STATE(3344),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(7992),
    [sym_dependent_type] = STATE(2200),
    [sym_optional_parameter_declaration] = STATE(7541),
    [sym_variadic_parameter_declaration] = STATE(7541),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym__unary_left_fold] = STATE(8282),
    [sym__unary_right_fold] = STATE(8283),
    [sym__binary_fold] = STATE(8289),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5934),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_launch_bounds] = STATE(1847),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1847),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(1751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_RPAREN] = ACTIONS(1755),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1765),
    [anon_sym___host__] = ACTIONS(1765),
    [anon_sym___global__] = ACTIONS(1765),
    [anon_sym___forceinline__] = ACTIONS(1765),
    [anon_sym___noinline__] = ACTIONS(1765),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1769),
    [anon_sym_enum] = ACTIONS(1771),
    [anon_sym_class] = ACTIONS(1773),
    [anon_sym_struct] = ACTIONS(1775),
    [anon_sym_union] = ACTIONS(1777),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1765),
    [anon_sym_typename] = ACTIONS(1801),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [124] = {
    [sym__declaration_modifiers] = STATE(1847),
    [sym__declaration_specifiers] = STATE(4480),
    [sym_attribute_specifier] = STATE(1847),
    [sym_attribute_declaration] = STATE(1847),
    [sym_ms_declspec_modifier] = STATE(1847),
    [sym_storage_class_specifier] = STATE(1847),
    [sym_type_qualifier] = STATE(1847),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_parameter_declaration] = STATE(7541),
    [sym_expression] = STATE(3278),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(7992),
    [sym_dependent_type] = STATE(2200),
    [sym_optional_parameter_declaration] = STATE(7541),
    [sym_variadic_parameter_declaration] = STATE(7541),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym__unary_left_fold] = STATE(8784),
    [sym__unary_right_fold] = STATE(8731),
    [sym__binary_fold] = STATE(8781),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5934),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_launch_bounds] = STATE(1847),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1847),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(1751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_RPAREN] = ACTIONS(1755),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1765),
    [anon_sym___host__] = ACTIONS(1765),
    [anon_sym___global__] = ACTIONS(1765),
    [anon_sym___forceinline__] = ACTIONS(1765),
    [anon_sym___noinline__] = ACTIONS(1765),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1769),
    [anon_sym_enum] = ACTIONS(1771),
    [anon_sym_class] = ACTIONS(1773),
    [anon_sym_struct] = ACTIONS(1775),
    [anon_sym_union] = ACTIONS(1777),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1765),
    [anon_sym_typename] = ACTIONS(1801),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [125] = {
    [sym__declaration_modifiers] = STATE(1847),
    [sym__declaration_specifiers] = STATE(4480),
    [sym_attribute_specifier] = STATE(1847),
    [sym_attribute_declaration] = STATE(1847),
    [sym_ms_declspec_modifier] = STATE(1847),
    [sym_storage_class_specifier] = STATE(1847),
    [sym_type_qualifier] = STATE(1847),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_parameter_declaration] = STATE(7541),
    [sym_expression] = STATE(3362),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(7992),
    [sym_dependent_type] = STATE(2200),
    [sym_optional_parameter_declaration] = STATE(7541),
    [sym_variadic_parameter_declaration] = STATE(7541),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym__unary_left_fold] = STATE(8494),
    [sym__unary_right_fold] = STATE(8496),
    [sym__binary_fold] = STATE(8504),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5934),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_launch_bounds] = STATE(1847),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1847),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(1751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_RPAREN] = ACTIONS(1755),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1765),
    [anon_sym___host__] = ACTIONS(1765),
    [anon_sym___global__] = ACTIONS(1765),
    [anon_sym___forceinline__] = ACTIONS(1765),
    [anon_sym___noinline__] = ACTIONS(1765),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1769),
    [anon_sym_enum] = ACTIONS(1771),
    [anon_sym_class] = ACTIONS(1773),
    [anon_sym_struct] = ACTIONS(1775),
    [anon_sym_union] = ACTIONS(1777),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1765),
    [anon_sym_typename] = ACTIONS(1801),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [126] = {
    [sym__declaration_modifiers] = STATE(1847),
    [sym__declaration_specifiers] = STATE(4480),
    [sym_attribute_specifier] = STATE(1847),
    [sym_attribute_declaration] = STATE(1847),
    [sym_ms_declspec_modifier] = STATE(1847),
    [sym_compound_statement] = STATE(7587),
    [sym_storage_class_specifier] = STATE(1847),
    [sym_type_qualifier] = STATE(1847),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_parameter_declaration] = STATE(7423),
    [sym_expression] = STATE(4700),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7587),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_optional_parameter_declaration] = STATE(7423),
    [sym_variadic_parameter_declaration] = STATE(7423),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5943),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1847),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1847),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1815),
    [anon_sym_RPAREN] = ACTIONS(1817),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(1819),
    [anon_sym___device__] = ACTIONS(1765),
    [anon_sym___host__] = ACTIONS(1765),
    [anon_sym___global__] = ACTIONS(1765),
    [anon_sym___forceinline__] = ACTIONS(1765),
    [anon_sym___noinline__] = ACTIONS(1765),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(1821),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(1771),
    [anon_sym_class] = ACTIONS(1773),
    [anon_sym_struct] = ACTIONS(1775),
    [anon_sym_union] = ACTIONS(1777),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1765),
    [anon_sym_typename] = ACTIONS(1801),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [127] = {
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(5602),
    [sym__declarator] = STATE(6903),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6598),
    [sym_array_declarator] = STATE(6598),
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(2960),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8499),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8296),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3575),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8299),
    [sym__unary_right_fold] = STATE(8308),
    [sym__binary_fold] = STATE(8312),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5958),
    [sym_qualified_identifier] = STATE(3569),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8481),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(1823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(1825),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1829),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1833),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(1839),
    [anon_sym___clrcall] = ACTIONS(1839),
    [anon_sym___stdcall] = ACTIONS(1839),
    [anon_sym___fastcall] = ACTIONS(1839),
    [anon_sym___thiscall] = ACTIONS(1839),
    [anon_sym___vectorcall] = ACTIONS(1839),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(1843),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [128] = {
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(5602),
    [sym__declarator] = STATE(6903),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6598),
    [sym_array_declarator] = STATE(6598),
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(2960),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8499),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8522),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3575),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8509),
    [sym__unary_right_fold] = STATE(8507),
    [sym__binary_fold] = STATE(8501),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5958),
    [sym_qualified_identifier] = STATE(3569),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8481),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(1823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(1825),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1829),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1833),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(1839),
    [anon_sym___clrcall] = ACTIONS(1839),
    [anon_sym___stdcall] = ACTIONS(1839),
    [anon_sym___fastcall] = ACTIONS(1839),
    [anon_sym___thiscall] = ACTIONS(1839),
    [anon_sym___vectorcall] = ACTIONS(1839),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(1843),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [129] = {
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(5602),
    [sym__declarator] = STATE(6903),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6598),
    [sym_array_declarator] = STATE(6598),
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(3009),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8514),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8517),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3575),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8518),
    [sym__unary_right_fold] = STATE(8523),
    [sym__binary_fold] = STATE(8524),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5958),
    [sym_qualified_identifier] = STATE(3569),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8525),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(1823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(1825),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1829),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1833),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(1839),
    [anon_sym___clrcall] = ACTIONS(1839),
    [anon_sym___stdcall] = ACTIONS(1839),
    [anon_sym___fastcall] = ACTIONS(1839),
    [anon_sym___thiscall] = ACTIONS(1839),
    [anon_sym___vectorcall] = ACTIONS(1839),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(1843),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [130] = {
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5587),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_expression] = STATE(4738),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8378),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2550),
    [sym_template_function] = STATE(4266),
    [sym_condition_declaration] = STATE(8378),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5896),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(2585),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(1737),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(67),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [131] = {
    [ts_builtin_sym_end] = ACTIONS(1895),
    [sym_identifier] = ACTIONS(1897),
    [aux_sym_preproc_include_token1] = ACTIONS(1897),
    [aux_sym_preproc_def_token1] = ACTIONS(1897),
    [anon_sym_COMMA] = ACTIONS(1895),
    [anon_sym_RPAREN] = ACTIONS(1895),
    [aux_sym_preproc_if_token1] = ACTIONS(1897),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1897),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1897),
    [sym_preproc_directive] = ACTIONS(1897),
    [anon_sym_LPAREN2] = ACTIONS(1895),
    [anon_sym_BANG] = ACTIONS(1895),
    [anon_sym_TILDE] = ACTIONS(1895),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_PIPE_PIPE] = ACTIONS(1895),
    [anon_sym_AMP_AMP] = ACTIONS(1895),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym_SEMI] = ACTIONS(1895),
    [anon_sym___extension__] = ACTIONS(1897),
    [anon_sym_typedef] = ACTIONS(1897),
    [anon_sym___device__] = ACTIONS(1897),
    [anon_sym___host__] = ACTIONS(1897),
    [anon_sym___global__] = ACTIONS(1897),
    [anon_sym___forceinline__] = ACTIONS(1897),
    [anon_sym___noinline__] = ACTIONS(1897),
    [anon_sym_extern] = ACTIONS(1897),
    [anon_sym___attribute__] = ACTIONS(1897),
    [anon_sym_COLON_COLON] = ACTIONS(1895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1895),
    [anon_sym___declspec] = ACTIONS(1897),
    [anon_sym___based] = ACTIONS(1897),
    [anon_sym___cdecl] = ACTIONS(1897),
    [anon_sym___clrcall] = ACTIONS(1897),
    [anon_sym___stdcall] = ACTIONS(1897),
    [anon_sym___fastcall] = ACTIONS(1897),
    [anon_sym___thiscall] = ACTIONS(1897),
    [anon_sym___vectorcall] = ACTIONS(1897),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_signed] = ACTIONS(1897),
    [anon_sym_unsigned] = ACTIONS(1897),
    [anon_sym_long] = ACTIONS(1897),
    [anon_sym_short] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1897),
    [anon_sym_static] = ACTIONS(1897),
    [anon_sym_EQ] = ACTIONS(1895),
    [anon_sym_register] = ACTIONS(1897),
    [anon_sym_inline] = ACTIONS(1897),
    [anon_sym___inline] = ACTIONS(1897),
    [anon_sym___inline__] = ACTIONS(1897),
    [anon_sym___forceinline] = ACTIONS(1897),
    [anon_sym_thread_local] = ACTIONS(1897),
    [anon_sym___thread] = ACTIONS(1897),
    [anon_sym_const] = ACTIONS(1897),
    [anon_sym_constexpr] = ACTIONS(1897),
    [anon_sym_volatile] = ACTIONS(1897),
    [anon_sym_restrict] = ACTIONS(1897),
    [anon_sym___restrict__] = ACTIONS(1897),
    [anon_sym__Atomic] = ACTIONS(1897),
    [anon_sym__Noreturn] = ACTIONS(1897),
    [anon_sym_noreturn] = ACTIONS(1897),
    [anon_sym_mutable] = ACTIONS(1897),
    [anon_sym_constinit] = ACTIONS(1897),
    [anon_sym_consteval] = ACTIONS(1897),
    [anon_sym___shared__] = ACTIONS(1897),
    [anon_sym___local__] = ACTIONS(1897),
    [anon_sym___constant__] = ACTIONS(1897),
    [anon_sym___managed__] = ACTIONS(1897),
    [anon_sym___grid_constant__] = ACTIONS(1897),
    [anon_sym_alignas] = ACTIONS(1897),
    [anon_sym__Alignas] = ACTIONS(1897),
    [sym_primitive_type] = ACTIONS(1897),
    [anon_sym_enum] = ACTIONS(1897),
    [anon_sym_class] = ACTIONS(1897),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1897),
    [anon_sym_if] = ACTIONS(1897),
    [anon_sym_else] = ACTIONS(1897),
    [anon_sym_switch] = ACTIONS(1897),
    [anon_sym_case] = ACTIONS(1897),
    [anon_sym_default] = ACTIONS(1897),
    [anon_sym_while] = ACTIONS(1897),
    [anon_sym_do] = ACTIONS(1897),
    [anon_sym_for] = ACTIONS(1897),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_continue] = ACTIONS(1897),
    [anon_sym_goto] = ACTIONS(1897),
    [anon_sym___try] = ACTIONS(1897),
    [anon_sym___except] = ACTIONS(1897),
    [anon_sym___finally] = ACTIONS(1897),
    [anon_sym___leave] = ACTIONS(1897),
    [anon_sym_not] = ACTIONS(1897),
    [anon_sym_compl] = ACTIONS(1897),
    [anon_sym_or] = ACTIONS(1897),
    [anon_sym_and] = ACTIONS(1897),
    [anon_sym_DASH_DASH] = ACTIONS(1895),
    [anon_sym_PLUS_PLUS] = ACTIONS(1895),
    [anon_sym_sizeof] = ACTIONS(1897),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1897),
    [anon_sym__Generic] = ACTIONS(1897),
    [anon_sym_asm] = ACTIONS(1897),
    [anon_sym___asm__] = ACTIONS(1897),
    [sym_number_literal] = ACTIONS(1895),
    [anon_sym_L_SQUOTE] = ACTIONS(1895),
    [anon_sym_u_SQUOTE] = ACTIONS(1895),
    [anon_sym_U_SQUOTE] = ACTIONS(1895),
    [anon_sym_u8_SQUOTE] = ACTIONS(1895),
    [anon_sym_SQUOTE] = ACTIONS(1895),
    [anon_sym_L_DQUOTE] = ACTIONS(1895),
    [anon_sym_u_DQUOTE] = ACTIONS(1895),
    [anon_sym_U_DQUOTE] = ACTIONS(1895),
    [anon_sym_u8_DQUOTE] = ACTIONS(1895),
    [anon_sym_DQUOTE] = ACTIONS(1895),
    [sym_true] = ACTIONS(1897),
    [sym_false] = ACTIONS(1897),
    [anon_sym_NULL] = ACTIONS(1897),
    [anon_sym_nullptr] = ACTIONS(1897),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1897),
    [anon_sym_decltype] = ACTIONS(1897),
    [anon_sym_final] = ACTIONS(1897),
    [anon_sym_override] = ACTIONS(1897),
    [sym_virtual] = ACTIONS(1897),
    [anon_sym_explicit] = ACTIONS(1897),
    [anon_sym_typename] = ACTIONS(1897),
    [anon_sym_template] = ACTIONS(1897),
    [anon_sym_GT2] = ACTIONS(1895),
    [anon_sym_operator] = ACTIONS(1897),
    [anon_sym_try] = ACTIONS(1897),
    [anon_sym_delete] = ACTIONS(1897),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_namespace] = ACTIONS(1897),
    [anon_sym_using] = ACTIONS(1897),
    [anon_sym_static_assert] = ACTIONS(1897),
    [anon_sym_concept] = ACTIONS(1897),
    [anon_sym_co_return] = ACTIONS(1897),
    [anon_sym_co_yield] = ACTIONS(1897),
    [anon_sym_catch] = ACTIONS(1897),
    [anon_sym_R_DQUOTE] = ACTIONS(1895),
    [anon_sym_LR_DQUOTE] = ACTIONS(1895),
    [anon_sym_uR_DQUOTE] = ACTIONS(1895),
    [anon_sym_UR_DQUOTE] = ACTIONS(1895),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1895),
    [anon_sym_co_await] = ACTIONS(1897),
    [anon_sym_new] = ACTIONS(1897),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1897),
    [anon_sym___launch_bounds__] = ACTIONS(1897),
  },
  [132] = {
    [ts_builtin_sym_end] = ACTIONS(1899),
    [sym_identifier] = ACTIONS(1901),
    [aux_sym_preproc_include_token1] = ACTIONS(1901),
    [aux_sym_preproc_def_token1] = ACTIONS(1901),
    [anon_sym_COMMA] = ACTIONS(1899),
    [anon_sym_RPAREN] = ACTIONS(1899),
    [aux_sym_preproc_if_token1] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1901),
    [sym_preproc_directive] = ACTIONS(1901),
    [anon_sym_LPAREN2] = ACTIONS(1899),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_DASH] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1901),
    [anon_sym_STAR] = ACTIONS(1899),
    [anon_sym_PIPE_PIPE] = ACTIONS(1899),
    [anon_sym_AMP_AMP] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1901),
    [anon_sym_SEMI] = ACTIONS(1899),
    [anon_sym___extension__] = ACTIONS(1901),
    [anon_sym_typedef] = ACTIONS(1901),
    [anon_sym___device__] = ACTIONS(1901),
    [anon_sym___host__] = ACTIONS(1901),
    [anon_sym___global__] = ACTIONS(1901),
    [anon_sym___forceinline__] = ACTIONS(1901),
    [anon_sym___noinline__] = ACTIONS(1901),
    [anon_sym_extern] = ACTIONS(1901),
    [anon_sym___attribute__] = ACTIONS(1901),
    [anon_sym_COLON_COLON] = ACTIONS(1899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1899),
    [anon_sym___declspec] = ACTIONS(1901),
    [anon_sym___based] = ACTIONS(1901),
    [anon_sym___cdecl] = ACTIONS(1901),
    [anon_sym___clrcall] = ACTIONS(1901),
    [anon_sym___stdcall] = ACTIONS(1901),
    [anon_sym___fastcall] = ACTIONS(1901),
    [anon_sym___thiscall] = ACTIONS(1901),
    [anon_sym___vectorcall] = ACTIONS(1901),
    [anon_sym_LBRACE] = ACTIONS(1899),
    [anon_sym_signed] = ACTIONS(1901),
    [anon_sym_unsigned] = ACTIONS(1901),
    [anon_sym_long] = ACTIONS(1901),
    [anon_sym_short] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1901),
    [anon_sym_static] = ACTIONS(1901),
    [anon_sym_EQ] = ACTIONS(1899),
    [anon_sym_register] = ACTIONS(1901),
    [anon_sym_inline] = ACTIONS(1901),
    [anon_sym___inline] = ACTIONS(1901),
    [anon_sym___inline__] = ACTIONS(1901),
    [anon_sym___forceinline] = ACTIONS(1901),
    [anon_sym_thread_local] = ACTIONS(1901),
    [anon_sym___thread] = ACTIONS(1901),
    [anon_sym_const] = ACTIONS(1901),
    [anon_sym_constexpr] = ACTIONS(1901),
    [anon_sym_volatile] = ACTIONS(1901),
    [anon_sym_restrict] = ACTIONS(1901),
    [anon_sym___restrict__] = ACTIONS(1901),
    [anon_sym__Atomic] = ACTIONS(1901),
    [anon_sym__Noreturn] = ACTIONS(1901),
    [anon_sym_noreturn] = ACTIONS(1901),
    [anon_sym_mutable] = ACTIONS(1901),
    [anon_sym_constinit] = ACTIONS(1901),
    [anon_sym_consteval] = ACTIONS(1901),
    [anon_sym___shared__] = ACTIONS(1901),
    [anon_sym___local__] = ACTIONS(1901),
    [anon_sym___constant__] = ACTIONS(1901),
    [anon_sym___managed__] = ACTIONS(1901),
    [anon_sym___grid_constant__] = ACTIONS(1901),
    [anon_sym_alignas] = ACTIONS(1901),
    [anon_sym__Alignas] = ACTIONS(1901),
    [sym_primitive_type] = ACTIONS(1901),
    [anon_sym_enum] = ACTIONS(1901),
    [anon_sym_class] = ACTIONS(1901),
    [anon_sym_struct] = ACTIONS(1901),
    [anon_sym_union] = ACTIONS(1901),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_else] = ACTIONS(1901),
    [anon_sym_switch] = ACTIONS(1901),
    [anon_sym_case] = ACTIONS(1901),
    [anon_sym_default] = ACTIONS(1901),
    [anon_sym_while] = ACTIONS(1901),
    [anon_sym_do] = ACTIONS(1901),
    [anon_sym_for] = ACTIONS(1901),
    [anon_sym_return] = ACTIONS(1901),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_continue] = ACTIONS(1901),
    [anon_sym_goto] = ACTIONS(1901),
    [anon_sym___try] = ACTIONS(1901),
    [anon_sym___except] = ACTIONS(1901),
    [anon_sym___finally] = ACTIONS(1901),
    [anon_sym___leave] = ACTIONS(1901),
    [anon_sym_not] = ACTIONS(1901),
    [anon_sym_compl] = ACTIONS(1901),
    [anon_sym_or] = ACTIONS(1901),
    [anon_sym_and] = ACTIONS(1901),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_sizeof] = ACTIONS(1901),
    [anon_sym___alignof__] = ACTIONS(1901),
    [anon_sym___alignof] = ACTIONS(1901),
    [anon_sym__alignof] = ACTIONS(1901),
    [anon_sym_alignof] = ACTIONS(1901),
    [anon_sym__Alignof] = ACTIONS(1901),
    [anon_sym_offsetof] = ACTIONS(1901),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1901),
    [anon_sym___asm__] = ACTIONS(1901),
    [sym_number_literal] = ACTIONS(1899),
    [anon_sym_L_SQUOTE] = ACTIONS(1899),
    [anon_sym_u_SQUOTE] = ACTIONS(1899),
    [anon_sym_U_SQUOTE] = ACTIONS(1899),
    [anon_sym_u8_SQUOTE] = ACTIONS(1899),
    [anon_sym_SQUOTE] = ACTIONS(1899),
    [anon_sym_L_DQUOTE] = ACTIONS(1899),
    [anon_sym_u_DQUOTE] = ACTIONS(1899),
    [anon_sym_U_DQUOTE] = ACTIONS(1899),
    [anon_sym_u8_DQUOTE] = ACTIONS(1899),
    [anon_sym_DQUOTE] = ACTIONS(1899),
    [sym_true] = ACTIONS(1901),
    [sym_false] = ACTIONS(1901),
    [anon_sym_NULL] = ACTIONS(1901),
    [anon_sym_nullptr] = ACTIONS(1901),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1901),
    [anon_sym_decltype] = ACTIONS(1901),
    [anon_sym_final] = ACTIONS(1901),
    [anon_sym_override] = ACTIONS(1901),
    [sym_virtual] = ACTIONS(1901),
    [anon_sym_explicit] = ACTIONS(1901),
    [anon_sym_typename] = ACTIONS(1901),
    [anon_sym_template] = ACTIONS(1901),
    [anon_sym_GT2] = ACTIONS(1899),
    [anon_sym_operator] = ACTIONS(1901),
    [anon_sym_try] = ACTIONS(1901),
    [anon_sym_delete] = ACTIONS(1901),
    [anon_sym_throw] = ACTIONS(1901),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_using] = ACTIONS(1901),
    [anon_sym_static_assert] = ACTIONS(1901),
    [anon_sym_concept] = ACTIONS(1901),
    [anon_sym_co_return] = ACTIONS(1901),
    [anon_sym_co_yield] = ACTIONS(1901),
    [anon_sym_catch] = ACTIONS(1901),
    [anon_sym_R_DQUOTE] = ACTIONS(1899),
    [anon_sym_LR_DQUOTE] = ACTIONS(1899),
    [anon_sym_uR_DQUOTE] = ACTIONS(1899),
    [anon_sym_UR_DQUOTE] = ACTIONS(1899),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1899),
    [anon_sym_co_await] = ACTIONS(1901),
    [anon_sym_new] = ACTIONS(1901),
    [anon_sym_requires] = ACTIONS(1901),
    [sym_this] = ACTIONS(1901),
    [anon_sym___launch_bounds__] = ACTIONS(1901),
  },
  [133] = {
    [sym_catch_clause] = STATE(134),
    [aux_sym_constructor_try_statement_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(1903),
    [aux_sym_preproc_include_token1] = ACTIONS(1903),
    [aux_sym_preproc_def_token1] = ACTIONS(1903),
    [aux_sym_preproc_if_token1] = ACTIONS(1903),
    [aux_sym_preproc_if_token2] = ACTIONS(1903),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1903),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1903),
    [aux_sym_preproc_else_token1] = ACTIONS(1903),
    [aux_sym_preproc_elif_token1] = ACTIONS(1903),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1903),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1903),
    [sym_preproc_directive] = ACTIONS(1903),
    [anon_sym_LPAREN2] = ACTIONS(1905),
    [anon_sym_BANG] = ACTIONS(1905),
    [anon_sym_TILDE] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(1903),
    [anon_sym_PLUS] = ACTIONS(1903),
    [anon_sym_STAR] = ACTIONS(1905),
    [anon_sym_AMP_AMP] = ACTIONS(1905),
    [anon_sym_AMP] = ACTIONS(1903),
    [anon_sym_SEMI] = ACTIONS(1905),
    [anon_sym___extension__] = ACTIONS(1903),
    [anon_sym_typedef] = ACTIONS(1903),
    [anon_sym___device__] = ACTIONS(1903),
    [anon_sym___host__] = ACTIONS(1903),
    [anon_sym___global__] = ACTIONS(1903),
    [anon_sym___forceinline__] = ACTIONS(1903),
    [anon_sym___noinline__] = ACTIONS(1903),
    [anon_sym_extern] = ACTIONS(1903),
    [anon_sym___attribute__] = ACTIONS(1903),
    [anon_sym_COLON_COLON] = ACTIONS(1905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1905),
    [anon_sym___declspec] = ACTIONS(1903),
    [anon_sym___based] = ACTIONS(1903),
    [anon_sym___cdecl] = ACTIONS(1903),
    [anon_sym___clrcall] = ACTIONS(1903),
    [anon_sym___stdcall] = ACTIONS(1903),
    [anon_sym___fastcall] = ACTIONS(1903),
    [anon_sym___thiscall] = ACTIONS(1903),
    [anon_sym___vectorcall] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1905),
    [anon_sym_signed] = ACTIONS(1903),
    [anon_sym_unsigned] = ACTIONS(1903),
    [anon_sym_long] = ACTIONS(1903),
    [anon_sym_short] = ACTIONS(1903),
    [anon_sym_LBRACK] = ACTIONS(1903),
    [anon_sym_static] = ACTIONS(1903),
    [anon_sym_register] = ACTIONS(1903),
    [anon_sym_inline] = ACTIONS(1903),
    [anon_sym___inline] = ACTIONS(1903),
    [anon_sym___inline__] = ACTIONS(1903),
    [anon_sym___forceinline] = ACTIONS(1903),
    [anon_sym_thread_local] = ACTIONS(1903),
    [anon_sym___thread] = ACTIONS(1903),
    [anon_sym_const] = ACTIONS(1903),
    [anon_sym_constexpr] = ACTIONS(1903),
    [anon_sym_volatile] = ACTIONS(1903),
    [anon_sym_restrict] = ACTIONS(1903),
    [anon_sym___restrict__] = ACTIONS(1903),
    [anon_sym__Atomic] = ACTIONS(1903),
    [anon_sym__Noreturn] = ACTIONS(1903),
    [anon_sym_noreturn] = ACTIONS(1903),
    [anon_sym_mutable] = ACTIONS(1903),
    [anon_sym_constinit] = ACTIONS(1903),
    [anon_sym_consteval] = ACTIONS(1903),
    [anon_sym___shared__] = ACTIONS(1903),
    [anon_sym___local__] = ACTIONS(1903),
    [anon_sym___constant__] = ACTIONS(1903),
    [anon_sym___managed__] = ACTIONS(1903),
    [anon_sym___grid_constant__] = ACTIONS(1903),
    [anon_sym_alignas] = ACTIONS(1903),
    [anon_sym__Alignas] = ACTIONS(1903),
    [sym_primitive_type] = ACTIONS(1903),
    [anon_sym_enum] = ACTIONS(1903),
    [anon_sym_class] = ACTIONS(1903),
    [anon_sym_struct] = ACTIONS(1903),
    [anon_sym_union] = ACTIONS(1903),
    [anon_sym_if] = ACTIONS(1903),
    [anon_sym_else] = ACTIONS(1903),
    [anon_sym_switch] = ACTIONS(1903),
    [anon_sym_case] = ACTIONS(1903),
    [anon_sym_default] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1903),
    [anon_sym_do] = ACTIONS(1903),
    [anon_sym_for] = ACTIONS(1903),
    [anon_sym_return] = ACTIONS(1903),
    [anon_sym_break] = ACTIONS(1903),
    [anon_sym_continue] = ACTIONS(1903),
    [anon_sym_goto] = ACTIONS(1903),
    [anon_sym___try] = ACTIONS(1903),
    [anon_sym___leave] = ACTIONS(1903),
    [anon_sym_not] = ACTIONS(1903),
    [anon_sym_compl] = ACTIONS(1903),
    [anon_sym_DASH_DASH] = ACTIONS(1905),
    [anon_sym_PLUS_PLUS] = ACTIONS(1905),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1903),
    [anon_sym___alignof] = ACTIONS(1903),
    [anon_sym__alignof] = ACTIONS(1903),
    [anon_sym_alignof] = ACTIONS(1903),
    [anon_sym__Alignof] = ACTIONS(1903),
    [anon_sym_offsetof] = ACTIONS(1903),
    [anon_sym__Generic] = ACTIONS(1903),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [sym_number_literal] = ACTIONS(1905),
    [anon_sym_L_SQUOTE] = ACTIONS(1905),
    [anon_sym_u_SQUOTE] = ACTIONS(1905),
    [anon_sym_U_SQUOTE] = ACTIONS(1905),
    [anon_sym_u8_SQUOTE] = ACTIONS(1905),
    [anon_sym_SQUOTE] = ACTIONS(1905),
    [anon_sym_L_DQUOTE] = ACTIONS(1905),
    [anon_sym_u_DQUOTE] = ACTIONS(1905),
    [anon_sym_U_DQUOTE] = ACTIONS(1905),
    [anon_sym_u8_DQUOTE] = ACTIONS(1905),
    [anon_sym_DQUOTE] = ACTIONS(1905),
    [sym_true] = ACTIONS(1903),
    [sym_false] = ACTIONS(1903),
    [anon_sym_NULL] = ACTIONS(1903),
    [anon_sym_nullptr] = ACTIONS(1903),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1903),
    [anon_sym_decltype] = ACTIONS(1903),
    [sym_virtual] = ACTIONS(1903),
    [anon_sym_explicit] = ACTIONS(1903),
    [anon_sym_typename] = ACTIONS(1903),
    [anon_sym_template] = ACTIONS(1903),
    [anon_sym_operator] = ACTIONS(1903),
    [anon_sym_try] = ACTIONS(1903),
    [anon_sym_delete] = ACTIONS(1903),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_namespace] = ACTIONS(1903),
    [anon_sym_using] = ACTIONS(1903),
    [anon_sym_static_assert] = ACTIONS(1903),
    [anon_sym_concept] = ACTIONS(1903),
    [anon_sym_co_return] = ACTIONS(1903),
    [anon_sym_co_yield] = ACTIONS(1903),
    [anon_sym_catch] = ACTIONS(1907),
    [anon_sym_R_DQUOTE] = ACTIONS(1905),
    [anon_sym_LR_DQUOTE] = ACTIONS(1905),
    [anon_sym_uR_DQUOTE] = ACTIONS(1905),
    [anon_sym_UR_DQUOTE] = ACTIONS(1905),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1905),
    [anon_sym_co_await] = ACTIONS(1903),
    [anon_sym_new] = ACTIONS(1903),
    [anon_sym_requires] = ACTIONS(1903),
    [sym_this] = ACTIONS(1903),
    [anon_sym___launch_bounds__] = ACTIONS(1903),
  },
  [134] = {
    [sym_catch_clause] = STATE(134),
    [aux_sym_constructor_try_statement_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(1909),
    [aux_sym_preproc_include_token1] = ACTIONS(1909),
    [aux_sym_preproc_def_token1] = ACTIONS(1909),
    [aux_sym_preproc_if_token1] = ACTIONS(1909),
    [aux_sym_preproc_if_token2] = ACTIONS(1909),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1909),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1909),
    [aux_sym_preproc_else_token1] = ACTIONS(1909),
    [aux_sym_preproc_elif_token1] = ACTIONS(1909),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1909),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1909),
    [sym_preproc_directive] = ACTIONS(1909),
    [anon_sym_LPAREN2] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_SEMI] = ACTIONS(1911),
    [anon_sym___extension__] = ACTIONS(1909),
    [anon_sym_typedef] = ACTIONS(1909),
    [anon_sym___device__] = ACTIONS(1909),
    [anon_sym___host__] = ACTIONS(1909),
    [anon_sym___global__] = ACTIONS(1909),
    [anon_sym___forceinline__] = ACTIONS(1909),
    [anon_sym___noinline__] = ACTIONS(1909),
    [anon_sym_extern] = ACTIONS(1909),
    [anon_sym___attribute__] = ACTIONS(1909),
    [anon_sym_COLON_COLON] = ACTIONS(1911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1911),
    [anon_sym___declspec] = ACTIONS(1909),
    [anon_sym___based] = ACTIONS(1909),
    [anon_sym___cdecl] = ACTIONS(1909),
    [anon_sym___clrcall] = ACTIONS(1909),
    [anon_sym___stdcall] = ACTIONS(1909),
    [anon_sym___fastcall] = ACTIONS(1909),
    [anon_sym___thiscall] = ACTIONS(1909),
    [anon_sym___vectorcall] = ACTIONS(1909),
    [anon_sym_LBRACE] = ACTIONS(1911),
    [anon_sym_signed] = ACTIONS(1909),
    [anon_sym_unsigned] = ACTIONS(1909),
    [anon_sym_long] = ACTIONS(1909),
    [anon_sym_short] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_static] = ACTIONS(1909),
    [anon_sym_register] = ACTIONS(1909),
    [anon_sym_inline] = ACTIONS(1909),
    [anon_sym___inline] = ACTIONS(1909),
    [anon_sym___inline__] = ACTIONS(1909),
    [anon_sym___forceinline] = ACTIONS(1909),
    [anon_sym_thread_local] = ACTIONS(1909),
    [anon_sym___thread] = ACTIONS(1909),
    [anon_sym_const] = ACTIONS(1909),
    [anon_sym_constexpr] = ACTIONS(1909),
    [anon_sym_volatile] = ACTIONS(1909),
    [anon_sym_restrict] = ACTIONS(1909),
    [anon_sym___restrict__] = ACTIONS(1909),
    [anon_sym__Atomic] = ACTIONS(1909),
    [anon_sym__Noreturn] = ACTIONS(1909),
    [anon_sym_noreturn] = ACTIONS(1909),
    [anon_sym_mutable] = ACTIONS(1909),
    [anon_sym_constinit] = ACTIONS(1909),
    [anon_sym_consteval] = ACTIONS(1909),
    [anon_sym___shared__] = ACTIONS(1909),
    [anon_sym___local__] = ACTIONS(1909),
    [anon_sym___constant__] = ACTIONS(1909),
    [anon_sym___managed__] = ACTIONS(1909),
    [anon_sym___grid_constant__] = ACTIONS(1909),
    [anon_sym_alignas] = ACTIONS(1909),
    [anon_sym__Alignas] = ACTIONS(1909),
    [sym_primitive_type] = ACTIONS(1909),
    [anon_sym_enum] = ACTIONS(1909),
    [anon_sym_class] = ACTIONS(1909),
    [anon_sym_struct] = ACTIONS(1909),
    [anon_sym_union] = ACTIONS(1909),
    [anon_sym_if] = ACTIONS(1909),
    [anon_sym_else] = ACTIONS(1909),
    [anon_sym_switch] = ACTIONS(1909),
    [anon_sym_case] = ACTIONS(1909),
    [anon_sym_default] = ACTIONS(1909),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_do] = ACTIONS(1909),
    [anon_sym_for] = ACTIONS(1909),
    [anon_sym_return] = ACTIONS(1909),
    [anon_sym_break] = ACTIONS(1909),
    [anon_sym_continue] = ACTIONS(1909),
    [anon_sym_goto] = ACTIONS(1909),
    [anon_sym___try] = ACTIONS(1909),
    [anon_sym___leave] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1909),
    [anon_sym_compl] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_sizeof] = ACTIONS(1909),
    [anon_sym___alignof__] = ACTIONS(1909),
    [anon_sym___alignof] = ACTIONS(1909),
    [anon_sym__alignof] = ACTIONS(1909),
    [anon_sym_alignof] = ACTIONS(1909),
    [anon_sym__Alignof] = ACTIONS(1909),
    [anon_sym_offsetof] = ACTIONS(1909),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1909),
    [anon_sym___asm__] = ACTIONS(1909),
    [sym_number_literal] = ACTIONS(1911),
    [anon_sym_L_SQUOTE] = ACTIONS(1911),
    [anon_sym_u_SQUOTE] = ACTIONS(1911),
    [anon_sym_U_SQUOTE] = ACTIONS(1911),
    [anon_sym_u8_SQUOTE] = ACTIONS(1911),
    [anon_sym_SQUOTE] = ACTIONS(1911),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1909),
    [sym_false] = ACTIONS(1909),
    [anon_sym_NULL] = ACTIONS(1909),
    [anon_sym_nullptr] = ACTIONS(1909),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1909),
    [anon_sym_decltype] = ACTIONS(1909),
    [sym_virtual] = ACTIONS(1909),
    [anon_sym_explicit] = ACTIONS(1909),
    [anon_sym_typename] = ACTIONS(1909),
    [anon_sym_template] = ACTIONS(1909),
    [anon_sym_operator] = ACTIONS(1909),
    [anon_sym_try] = ACTIONS(1909),
    [anon_sym_delete] = ACTIONS(1909),
    [anon_sym_throw] = ACTIONS(1909),
    [anon_sym_namespace] = ACTIONS(1909),
    [anon_sym_using] = ACTIONS(1909),
    [anon_sym_static_assert] = ACTIONS(1909),
    [anon_sym_concept] = ACTIONS(1909),
    [anon_sym_co_return] = ACTIONS(1909),
    [anon_sym_co_yield] = ACTIONS(1909),
    [anon_sym_catch] = ACTIONS(1913),
    [anon_sym_R_DQUOTE] = ACTIONS(1911),
    [anon_sym_LR_DQUOTE] = ACTIONS(1911),
    [anon_sym_uR_DQUOTE] = ACTIONS(1911),
    [anon_sym_UR_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1911),
    [anon_sym_co_await] = ACTIONS(1909),
    [anon_sym_new] = ACTIONS(1909),
    [anon_sym_requires] = ACTIONS(1909),
    [sym_this] = ACTIONS(1909),
    [anon_sym___launch_bounds__] = ACTIONS(1909),
  },
  [135] = {
    [sym_catch_clause] = STATE(134),
    [aux_sym_constructor_try_statement_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(1916),
    [aux_sym_preproc_include_token1] = ACTIONS(1916),
    [aux_sym_preproc_def_token1] = ACTIONS(1916),
    [aux_sym_preproc_if_token1] = ACTIONS(1916),
    [aux_sym_preproc_if_token2] = ACTIONS(1916),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1916),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1916),
    [aux_sym_preproc_else_token1] = ACTIONS(1916),
    [aux_sym_preproc_elif_token1] = ACTIONS(1916),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1916),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1916),
    [sym_preproc_directive] = ACTIONS(1916),
    [anon_sym_LPAREN2] = ACTIONS(1918),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [anon_sym_DASH] = ACTIONS(1916),
    [anon_sym_PLUS] = ACTIONS(1916),
    [anon_sym_STAR] = ACTIONS(1918),
    [anon_sym_AMP_AMP] = ACTIONS(1918),
    [anon_sym_AMP] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1918),
    [anon_sym___extension__] = ACTIONS(1916),
    [anon_sym_typedef] = ACTIONS(1916),
    [anon_sym___device__] = ACTIONS(1916),
    [anon_sym___host__] = ACTIONS(1916),
    [anon_sym___global__] = ACTIONS(1916),
    [anon_sym___forceinline__] = ACTIONS(1916),
    [anon_sym___noinline__] = ACTIONS(1916),
    [anon_sym_extern] = ACTIONS(1916),
    [anon_sym___attribute__] = ACTIONS(1916),
    [anon_sym_COLON_COLON] = ACTIONS(1918),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1918),
    [anon_sym___declspec] = ACTIONS(1916),
    [anon_sym___based] = ACTIONS(1916),
    [anon_sym___cdecl] = ACTIONS(1916),
    [anon_sym___clrcall] = ACTIONS(1916),
    [anon_sym___stdcall] = ACTIONS(1916),
    [anon_sym___fastcall] = ACTIONS(1916),
    [anon_sym___thiscall] = ACTIONS(1916),
    [anon_sym___vectorcall] = ACTIONS(1916),
    [anon_sym_LBRACE] = ACTIONS(1918),
    [anon_sym_signed] = ACTIONS(1916),
    [anon_sym_unsigned] = ACTIONS(1916),
    [anon_sym_long] = ACTIONS(1916),
    [anon_sym_short] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1916),
    [anon_sym_static] = ACTIONS(1916),
    [anon_sym_register] = ACTIONS(1916),
    [anon_sym_inline] = ACTIONS(1916),
    [anon_sym___inline] = ACTIONS(1916),
    [anon_sym___inline__] = ACTIONS(1916),
    [anon_sym___forceinline] = ACTIONS(1916),
    [anon_sym_thread_local] = ACTIONS(1916),
    [anon_sym___thread] = ACTIONS(1916),
    [anon_sym_const] = ACTIONS(1916),
    [anon_sym_constexpr] = ACTIONS(1916),
    [anon_sym_volatile] = ACTIONS(1916),
    [anon_sym_restrict] = ACTIONS(1916),
    [anon_sym___restrict__] = ACTIONS(1916),
    [anon_sym__Atomic] = ACTIONS(1916),
    [anon_sym__Noreturn] = ACTIONS(1916),
    [anon_sym_noreturn] = ACTIONS(1916),
    [anon_sym_mutable] = ACTIONS(1916),
    [anon_sym_constinit] = ACTIONS(1916),
    [anon_sym_consteval] = ACTIONS(1916),
    [anon_sym___shared__] = ACTIONS(1916),
    [anon_sym___local__] = ACTIONS(1916),
    [anon_sym___constant__] = ACTIONS(1916),
    [anon_sym___managed__] = ACTIONS(1916),
    [anon_sym___grid_constant__] = ACTIONS(1916),
    [anon_sym_alignas] = ACTIONS(1916),
    [anon_sym__Alignas] = ACTIONS(1916),
    [sym_primitive_type] = ACTIONS(1916),
    [anon_sym_enum] = ACTIONS(1916),
    [anon_sym_class] = ACTIONS(1916),
    [anon_sym_struct] = ACTIONS(1916),
    [anon_sym_union] = ACTIONS(1916),
    [anon_sym_if] = ACTIONS(1916),
    [anon_sym_switch] = ACTIONS(1916),
    [anon_sym_case] = ACTIONS(1916),
    [anon_sym_default] = ACTIONS(1916),
    [anon_sym_while] = ACTIONS(1916),
    [anon_sym_do] = ACTIONS(1916),
    [anon_sym_for] = ACTIONS(1916),
    [anon_sym_return] = ACTIONS(1916),
    [anon_sym_break] = ACTIONS(1916),
    [anon_sym_continue] = ACTIONS(1916),
    [anon_sym_goto] = ACTIONS(1916),
    [anon_sym___try] = ACTIONS(1916),
    [anon_sym___leave] = ACTIONS(1916),
    [anon_sym_not] = ACTIONS(1916),
    [anon_sym_compl] = ACTIONS(1916),
    [anon_sym_DASH_DASH] = ACTIONS(1918),
    [anon_sym_PLUS_PLUS] = ACTIONS(1918),
    [anon_sym_sizeof] = ACTIONS(1916),
    [anon_sym___alignof__] = ACTIONS(1916),
    [anon_sym___alignof] = ACTIONS(1916),
    [anon_sym__alignof] = ACTIONS(1916),
    [anon_sym_alignof] = ACTIONS(1916),
    [anon_sym__Alignof] = ACTIONS(1916),
    [anon_sym_offsetof] = ACTIONS(1916),
    [anon_sym__Generic] = ACTIONS(1916),
    [anon_sym_asm] = ACTIONS(1916),
    [anon_sym___asm__] = ACTIONS(1916),
    [sym_number_literal] = ACTIONS(1918),
    [anon_sym_L_SQUOTE] = ACTIONS(1918),
    [anon_sym_u_SQUOTE] = ACTIONS(1918),
    [anon_sym_U_SQUOTE] = ACTIONS(1918),
    [anon_sym_u8_SQUOTE] = ACTIONS(1918),
    [anon_sym_SQUOTE] = ACTIONS(1918),
    [anon_sym_L_DQUOTE] = ACTIONS(1918),
    [anon_sym_u_DQUOTE] = ACTIONS(1918),
    [anon_sym_U_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8_DQUOTE] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1918),
    [sym_true] = ACTIONS(1916),
    [sym_false] = ACTIONS(1916),
    [anon_sym_NULL] = ACTIONS(1916),
    [anon_sym_nullptr] = ACTIONS(1916),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1916),
    [anon_sym_decltype] = ACTIONS(1916),
    [sym_virtual] = ACTIONS(1916),
    [anon_sym_explicit] = ACTIONS(1916),
    [anon_sym_typename] = ACTIONS(1916),
    [anon_sym_template] = ACTIONS(1916),
    [anon_sym_operator] = ACTIONS(1916),
    [anon_sym_try] = ACTIONS(1916),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_throw] = ACTIONS(1916),
    [anon_sym_namespace] = ACTIONS(1916),
    [anon_sym_using] = ACTIONS(1916),
    [anon_sym_static_assert] = ACTIONS(1916),
    [anon_sym_concept] = ACTIONS(1916),
    [anon_sym_co_return] = ACTIONS(1916),
    [anon_sym_co_yield] = ACTIONS(1916),
    [anon_sym_catch] = ACTIONS(1907),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1916),
    [anon_sym_new] = ACTIONS(1916),
    [anon_sym_requires] = ACTIONS(1916),
    [sym_this] = ACTIONS(1916),
    [anon_sym___launch_bounds__] = ACTIONS(1916),
  },
  [136] = {
    [sym_catch_clause] = STATE(134),
    [aux_sym_constructor_try_statement_repeat1] = STATE(134),
    [sym_identifier] = ACTIONS(1920),
    [aux_sym_preproc_include_token1] = ACTIONS(1920),
    [aux_sym_preproc_def_token1] = ACTIONS(1920),
    [aux_sym_preproc_if_token1] = ACTIONS(1920),
    [aux_sym_preproc_if_token2] = ACTIONS(1920),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1920),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1920),
    [aux_sym_preproc_else_token1] = ACTIONS(1920),
    [aux_sym_preproc_elif_token1] = ACTIONS(1920),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1920),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1920),
    [sym_preproc_directive] = ACTIONS(1920),
    [anon_sym_LPAREN2] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1922),
    [anon_sym_TILDE] = ACTIONS(1922),
    [anon_sym_DASH] = ACTIONS(1920),
    [anon_sym_PLUS] = ACTIONS(1920),
    [anon_sym_STAR] = ACTIONS(1922),
    [anon_sym_AMP_AMP] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1920),
    [anon_sym_SEMI] = ACTIONS(1922),
    [anon_sym___extension__] = ACTIONS(1920),
    [anon_sym_typedef] = ACTIONS(1920),
    [anon_sym___device__] = ACTIONS(1920),
    [anon_sym___host__] = ACTIONS(1920),
    [anon_sym___global__] = ACTIONS(1920),
    [anon_sym___forceinline__] = ACTIONS(1920),
    [anon_sym___noinline__] = ACTIONS(1920),
    [anon_sym_extern] = ACTIONS(1920),
    [anon_sym___attribute__] = ACTIONS(1920),
    [anon_sym_COLON_COLON] = ACTIONS(1922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1922),
    [anon_sym___declspec] = ACTIONS(1920),
    [anon_sym___based] = ACTIONS(1920),
    [anon_sym___cdecl] = ACTIONS(1920),
    [anon_sym___clrcall] = ACTIONS(1920),
    [anon_sym___stdcall] = ACTIONS(1920),
    [anon_sym___fastcall] = ACTIONS(1920),
    [anon_sym___thiscall] = ACTIONS(1920),
    [anon_sym___vectorcall] = ACTIONS(1920),
    [anon_sym_LBRACE] = ACTIONS(1922),
    [anon_sym_signed] = ACTIONS(1920),
    [anon_sym_unsigned] = ACTIONS(1920),
    [anon_sym_long] = ACTIONS(1920),
    [anon_sym_short] = ACTIONS(1920),
    [anon_sym_LBRACK] = ACTIONS(1920),
    [anon_sym_static] = ACTIONS(1920),
    [anon_sym_register] = ACTIONS(1920),
    [anon_sym_inline] = ACTIONS(1920),
    [anon_sym___inline] = ACTIONS(1920),
    [anon_sym___inline__] = ACTIONS(1920),
    [anon_sym___forceinline] = ACTIONS(1920),
    [anon_sym_thread_local] = ACTIONS(1920),
    [anon_sym___thread] = ACTIONS(1920),
    [anon_sym_const] = ACTIONS(1920),
    [anon_sym_constexpr] = ACTIONS(1920),
    [anon_sym_volatile] = ACTIONS(1920),
    [anon_sym_restrict] = ACTIONS(1920),
    [anon_sym___restrict__] = ACTIONS(1920),
    [anon_sym__Atomic] = ACTIONS(1920),
    [anon_sym__Noreturn] = ACTIONS(1920),
    [anon_sym_noreturn] = ACTIONS(1920),
    [anon_sym_mutable] = ACTIONS(1920),
    [anon_sym_constinit] = ACTIONS(1920),
    [anon_sym_consteval] = ACTIONS(1920),
    [anon_sym___shared__] = ACTIONS(1920),
    [anon_sym___local__] = ACTIONS(1920),
    [anon_sym___constant__] = ACTIONS(1920),
    [anon_sym___managed__] = ACTIONS(1920),
    [anon_sym___grid_constant__] = ACTIONS(1920),
    [anon_sym_alignas] = ACTIONS(1920),
    [anon_sym__Alignas] = ACTIONS(1920),
    [sym_primitive_type] = ACTIONS(1920),
    [anon_sym_enum] = ACTIONS(1920),
    [anon_sym_class] = ACTIONS(1920),
    [anon_sym_struct] = ACTIONS(1920),
    [anon_sym_union] = ACTIONS(1920),
    [anon_sym_if] = ACTIONS(1920),
    [anon_sym_switch] = ACTIONS(1920),
    [anon_sym_case] = ACTIONS(1920),
    [anon_sym_default] = ACTIONS(1920),
    [anon_sym_while] = ACTIONS(1920),
    [anon_sym_do] = ACTIONS(1920),
    [anon_sym_for] = ACTIONS(1920),
    [anon_sym_return] = ACTIONS(1920),
    [anon_sym_break] = ACTIONS(1920),
    [anon_sym_continue] = ACTIONS(1920),
    [anon_sym_goto] = ACTIONS(1920),
    [anon_sym___try] = ACTIONS(1920),
    [anon_sym___leave] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1920),
    [anon_sym_compl] = ACTIONS(1920),
    [anon_sym_DASH_DASH] = ACTIONS(1922),
    [anon_sym_PLUS_PLUS] = ACTIONS(1922),
    [anon_sym_sizeof] = ACTIONS(1920),
    [anon_sym___alignof__] = ACTIONS(1920),
    [anon_sym___alignof] = ACTIONS(1920),
    [anon_sym__alignof] = ACTIONS(1920),
    [anon_sym_alignof] = ACTIONS(1920),
    [anon_sym__Alignof] = ACTIONS(1920),
    [anon_sym_offsetof] = ACTIONS(1920),
    [anon_sym__Generic] = ACTIONS(1920),
    [anon_sym_asm] = ACTIONS(1920),
    [anon_sym___asm__] = ACTIONS(1920),
    [sym_number_literal] = ACTIONS(1922),
    [anon_sym_L_SQUOTE] = ACTIONS(1922),
    [anon_sym_u_SQUOTE] = ACTIONS(1922),
    [anon_sym_U_SQUOTE] = ACTIONS(1922),
    [anon_sym_u8_SQUOTE] = ACTIONS(1922),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_L_DQUOTE] = ACTIONS(1922),
    [anon_sym_u_DQUOTE] = ACTIONS(1922),
    [anon_sym_U_DQUOTE] = ACTIONS(1922),
    [anon_sym_u8_DQUOTE] = ACTIONS(1922),
    [anon_sym_DQUOTE] = ACTIONS(1922),
    [sym_true] = ACTIONS(1920),
    [sym_false] = ACTIONS(1920),
    [anon_sym_NULL] = ACTIONS(1920),
    [anon_sym_nullptr] = ACTIONS(1920),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1920),
    [anon_sym_decltype] = ACTIONS(1920),
    [sym_virtual] = ACTIONS(1920),
    [anon_sym_explicit] = ACTIONS(1920),
    [anon_sym_typename] = ACTIONS(1920),
    [anon_sym_template] = ACTIONS(1920),
    [anon_sym_operator] = ACTIONS(1920),
    [anon_sym_try] = ACTIONS(1920),
    [anon_sym_delete] = ACTIONS(1920),
    [anon_sym_throw] = ACTIONS(1920),
    [anon_sym_namespace] = ACTIONS(1920),
    [anon_sym_using] = ACTIONS(1920),
    [anon_sym_static_assert] = ACTIONS(1920),
    [anon_sym_concept] = ACTIONS(1920),
    [anon_sym_co_return] = ACTIONS(1920),
    [anon_sym_co_yield] = ACTIONS(1920),
    [anon_sym_catch] = ACTIONS(1907),
    [anon_sym_R_DQUOTE] = ACTIONS(1922),
    [anon_sym_LR_DQUOTE] = ACTIONS(1922),
    [anon_sym_uR_DQUOTE] = ACTIONS(1922),
    [anon_sym_UR_DQUOTE] = ACTIONS(1922),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1922),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1920),
    [anon_sym_requires] = ACTIONS(1920),
    [sym_this] = ACTIONS(1920),
    [anon_sym___launch_bounds__] = ACTIONS(1920),
  },
  [137] = {
    [sym_identifier] = ACTIONS(1897),
    [aux_sym_preproc_include_token1] = ACTIONS(1897),
    [aux_sym_preproc_def_token1] = ACTIONS(1897),
    [aux_sym_preproc_if_token1] = ACTIONS(1897),
    [aux_sym_preproc_if_token2] = ACTIONS(1897),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1897),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1897),
    [aux_sym_preproc_else_token1] = ACTIONS(1897),
    [aux_sym_preproc_elif_token1] = ACTIONS(1897),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1897),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1897),
    [sym_preproc_directive] = ACTIONS(1897),
    [anon_sym_LPAREN2] = ACTIONS(1895),
    [anon_sym_BANG] = ACTIONS(1895),
    [anon_sym_TILDE] = ACTIONS(1895),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_AMP_AMP] = ACTIONS(1895),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym_SEMI] = ACTIONS(1895),
    [anon_sym___extension__] = ACTIONS(1897),
    [anon_sym_typedef] = ACTIONS(1897),
    [anon_sym___device__] = ACTIONS(1897),
    [anon_sym___host__] = ACTIONS(1897),
    [anon_sym___global__] = ACTIONS(1897),
    [anon_sym___forceinline__] = ACTIONS(1897),
    [anon_sym___noinline__] = ACTIONS(1897),
    [anon_sym_extern] = ACTIONS(1897),
    [anon_sym___attribute__] = ACTIONS(1897),
    [anon_sym_COLON_COLON] = ACTIONS(1895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1895),
    [anon_sym___declspec] = ACTIONS(1897),
    [anon_sym___based] = ACTIONS(1897),
    [anon_sym___cdecl] = ACTIONS(1897),
    [anon_sym___clrcall] = ACTIONS(1897),
    [anon_sym___stdcall] = ACTIONS(1897),
    [anon_sym___fastcall] = ACTIONS(1897),
    [anon_sym___thiscall] = ACTIONS(1897),
    [anon_sym___vectorcall] = ACTIONS(1897),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_signed] = ACTIONS(1897),
    [anon_sym_unsigned] = ACTIONS(1897),
    [anon_sym_long] = ACTIONS(1897),
    [anon_sym_short] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1897),
    [anon_sym_static] = ACTIONS(1897),
    [anon_sym_register] = ACTIONS(1897),
    [anon_sym_inline] = ACTIONS(1897),
    [anon_sym___inline] = ACTIONS(1897),
    [anon_sym___inline__] = ACTIONS(1897),
    [anon_sym___forceinline] = ACTIONS(1897),
    [anon_sym_thread_local] = ACTIONS(1897),
    [anon_sym___thread] = ACTIONS(1897),
    [anon_sym_const] = ACTIONS(1897),
    [anon_sym_constexpr] = ACTIONS(1897),
    [anon_sym_volatile] = ACTIONS(1897),
    [anon_sym_restrict] = ACTIONS(1897),
    [anon_sym___restrict__] = ACTIONS(1897),
    [anon_sym__Atomic] = ACTIONS(1897),
    [anon_sym__Noreturn] = ACTIONS(1897),
    [anon_sym_noreturn] = ACTIONS(1897),
    [anon_sym_mutable] = ACTIONS(1897),
    [anon_sym_constinit] = ACTIONS(1897),
    [anon_sym_consteval] = ACTIONS(1897),
    [anon_sym___shared__] = ACTIONS(1897),
    [anon_sym___local__] = ACTIONS(1897),
    [anon_sym___constant__] = ACTIONS(1897),
    [anon_sym___managed__] = ACTIONS(1897),
    [anon_sym___grid_constant__] = ACTIONS(1897),
    [anon_sym_alignas] = ACTIONS(1897),
    [anon_sym__Alignas] = ACTIONS(1897),
    [sym_primitive_type] = ACTIONS(1897),
    [anon_sym_enum] = ACTIONS(1897),
    [anon_sym_class] = ACTIONS(1897),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1897),
    [anon_sym_if] = ACTIONS(1897),
    [anon_sym_else] = ACTIONS(1897),
    [anon_sym_switch] = ACTIONS(1897),
    [anon_sym_case] = ACTIONS(1897),
    [anon_sym_default] = ACTIONS(1897),
    [anon_sym_while] = ACTIONS(1897),
    [anon_sym_do] = ACTIONS(1897),
    [anon_sym_for] = ACTIONS(1897),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_continue] = ACTIONS(1897),
    [anon_sym_goto] = ACTIONS(1897),
    [anon_sym___try] = ACTIONS(1897),
    [anon_sym___leave] = ACTIONS(1897),
    [anon_sym_not] = ACTIONS(1897),
    [anon_sym_compl] = ACTIONS(1897),
    [anon_sym_DASH_DASH] = ACTIONS(1895),
    [anon_sym_PLUS_PLUS] = ACTIONS(1895),
    [anon_sym_sizeof] = ACTIONS(1897),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1897),
    [anon_sym__Generic] = ACTIONS(1897),
    [anon_sym_asm] = ACTIONS(1897),
    [anon_sym___asm__] = ACTIONS(1897),
    [sym_number_literal] = ACTIONS(1895),
    [anon_sym_L_SQUOTE] = ACTIONS(1895),
    [anon_sym_u_SQUOTE] = ACTIONS(1895),
    [anon_sym_U_SQUOTE] = ACTIONS(1895),
    [anon_sym_u8_SQUOTE] = ACTIONS(1895),
    [anon_sym_SQUOTE] = ACTIONS(1895),
    [anon_sym_L_DQUOTE] = ACTIONS(1895),
    [anon_sym_u_DQUOTE] = ACTIONS(1895),
    [anon_sym_U_DQUOTE] = ACTIONS(1895),
    [anon_sym_u8_DQUOTE] = ACTIONS(1895),
    [anon_sym_DQUOTE] = ACTIONS(1895),
    [sym_true] = ACTIONS(1897),
    [sym_false] = ACTIONS(1897),
    [anon_sym_NULL] = ACTIONS(1897),
    [anon_sym_nullptr] = ACTIONS(1897),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1897),
    [anon_sym_decltype] = ACTIONS(1897),
    [sym_virtual] = ACTIONS(1897),
    [anon_sym_explicit] = ACTIONS(1897),
    [anon_sym_typename] = ACTIONS(1897),
    [anon_sym_template] = ACTIONS(1897),
    [anon_sym_operator] = ACTIONS(1897),
    [anon_sym_try] = ACTIONS(1897),
    [anon_sym_delete] = ACTIONS(1897),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_namespace] = ACTIONS(1897),
    [anon_sym_using] = ACTIONS(1897),
    [anon_sym_static_assert] = ACTIONS(1897),
    [anon_sym_concept] = ACTIONS(1897),
    [anon_sym_co_return] = ACTIONS(1897),
    [anon_sym_co_yield] = ACTIONS(1897),
    [anon_sym_catch] = ACTIONS(1897),
    [anon_sym_R_DQUOTE] = ACTIONS(1895),
    [anon_sym_LR_DQUOTE] = ACTIONS(1895),
    [anon_sym_uR_DQUOTE] = ACTIONS(1895),
    [anon_sym_UR_DQUOTE] = ACTIONS(1895),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1895),
    [anon_sym_co_await] = ACTIONS(1897),
    [anon_sym_new] = ACTIONS(1897),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1897),
    [anon_sym___launch_bounds__] = ACTIONS(1897),
  },
  [138] = {
    [sym_identifier] = ACTIONS(1924),
    [aux_sym_preproc_include_token1] = ACTIONS(1924),
    [aux_sym_preproc_def_token1] = ACTIONS(1924),
    [aux_sym_preproc_if_token1] = ACTIONS(1924),
    [aux_sym_preproc_if_token2] = ACTIONS(1924),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1924),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1924),
    [aux_sym_preproc_else_token1] = ACTIONS(1924),
    [aux_sym_preproc_elif_token1] = ACTIONS(1924),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1924),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1924),
    [sym_preproc_directive] = ACTIONS(1924),
    [anon_sym_LPAREN2] = ACTIONS(1926),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1924),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_STAR] = ACTIONS(1926),
    [anon_sym_AMP_AMP] = ACTIONS(1926),
    [anon_sym_AMP] = ACTIONS(1924),
    [anon_sym_SEMI] = ACTIONS(1926),
    [anon_sym___extension__] = ACTIONS(1924),
    [anon_sym_typedef] = ACTIONS(1924),
    [anon_sym___device__] = ACTIONS(1924),
    [anon_sym___host__] = ACTIONS(1924),
    [anon_sym___global__] = ACTIONS(1924),
    [anon_sym___forceinline__] = ACTIONS(1924),
    [anon_sym___noinline__] = ACTIONS(1924),
    [anon_sym_extern] = ACTIONS(1924),
    [anon_sym___attribute__] = ACTIONS(1924),
    [anon_sym_COLON_COLON] = ACTIONS(1926),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1926),
    [anon_sym___declspec] = ACTIONS(1924),
    [anon_sym___based] = ACTIONS(1924),
    [anon_sym___cdecl] = ACTIONS(1924),
    [anon_sym___clrcall] = ACTIONS(1924),
    [anon_sym___stdcall] = ACTIONS(1924),
    [anon_sym___fastcall] = ACTIONS(1924),
    [anon_sym___thiscall] = ACTIONS(1924),
    [anon_sym___vectorcall] = ACTIONS(1924),
    [anon_sym_LBRACE] = ACTIONS(1926),
    [anon_sym_signed] = ACTIONS(1924),
    [anon_sym_unsigned] = ACTIONS(1924),
    [anon_sym_long] = ACTIONS(1924),
    [anon_sym_short] = ACTIONS(1924),
    [anon_sym_LBRACK] = ACTIONS(1924),
    [anon_sym_static] = ACTIONS(1924),
    [anon_sym_register] = ACTIONS(1924),
    [anon_sym_inline] = ACTIONS(1924),
    [anon_sym___inline] = ACTIONS(1924),
    [anon_sym___inline__] = ACTIONS(1924),
    [anon_sym___forceinline] = ACTIONS(1924),
    [anon_sym_thread_local] = ACTIONS(1924),
    [anon_sym___thread] = ACTIONS(1924),
    [anon_sym_const] = ACTIONS(1924),
    [anon_sym_constexpr] = ACTIONS(1924),
    [anon_sym_volatile] = ACTIONS(1924),
    [anon_sym_restrict] = ACTIONS(1924),
    [anon_sym___restrict__] = ACTIONS(1924),
    [anon_sym__Atomic] = ACTIONS(1924),
    [anon_sym__Noreturn] = ACTIONS(1924),
    [anon_sym_noreturn] = ACTIONS(1924),
    [anon_sym_mutable] = ACTIONS(1924),
    [anon_sym_constinit] = ACTIONS(1924),
    [anon_sym_consteval] = ACTIONS(1924),
    [anon_sym___shared__] = ACTIONS(1924),
    [anon_sym___local__] = ACTIONS(1924),
    [anon_sym___constant__] = ACTIONS(1924),
    [anon_sym___managed__] = ACTIONS(1924),
    [anon_sym___grid_constant__] = ACTIONS(1924),
    [anon_sym_alignas] = ACTIONS(1924),
    [anon_sym__Alignas] = ACTIONS(1924),
    [sym_primitive_type] = ACTIONS(1924),
    [anon_sym_enum] = ACTIONS(1924),
    [anon_sym_class] = ACTIONS(1924),
    [anon_sym_struct] = ACTIONS(1924),
    [anon_sym_union] = ACTIONS(1924),
    [anon_sym_if] = ACTIONS(1924),
    [anon_sym_else] = ACTIONS(1924),
    [anon_sym_switch] = ACTIONS(1924),
    [anon_sym_case] = ACTIONS(1924),
    [anon_sym_default] = ACTIONS(1924),
    [anon_sym_while] = ACTIONS(1924),
    [anon_sym_do] = ACTIONS(1924),
    [anon_sym_for] = ACTIONS(1924),
    [anon_sym_return] = ACTIONS(1924),
    [anon_sym_break] = ACTIONS(1924),
    [anon_sym_continue] = ACTIONS(1924),
    [anon_sym_goto] = ACTIONS(1924),
    [anon_sym___try] = ACTIONS(1924),
    [anon_sym___leave] = ACTIONS(1924),
    [anon_sym_not] = ACTIONS(1924),
    [anon_sym_compl] = ACTIONS(1924),
    [anon_sym_DASH_DASH] = ACTIONS(1926),
    [anon_sym_PLUS_PLUS] = ACTIONS(1926),
    [anon_sym_sizeof] = ACTIONS(1924),
    [anon_sym___alignof__] = ACTIONS(1924),
    [anon_sym___alignof] = ACTIONS(1924),
    [anon_sym__alignof] = ACTIONS(1924),
    [anon_sym_alignof] = ACTIONS(1924),
    [anon_sym__Alignof] = ACTIONS(1924),
    [anon_sym_offsetof] = ACTIONS(1924),
    [anon_sym__Generic] = ACTIONS(1924),
    [anon_sym_asm] = ACTIONS(1924),
    [anon_sym___asm__] = ACTIONS(1924),
    [sym_number_literal] = ACTIONS(1926),
    [anon_sym_L_SQUOTE] = ACTIONS(1926),
    [anon_sym_u_SQUOTE] = ACTIONS(1926),
    [anon_sym_U_SQUOTE] = ACTIONS(1926),
    [anon_sym_u8_SQUOTE] = ACTIONS(1926),
    [anon_sym_SQUOTE] = ACTIONS(1926),
    [anon_sym_L_DQUOTE] = ACTIONS(1926),
    [anon_sym_u_DQUOTE] = ACTIONS(1926),
    [anon_sym_U_DQUOTE] = ACTIONS(1926),
    [anon_sym_u8_DQUOTE] = ACTIONS(1926),
    [anon_sym_DQUOTE] = ACTIONS(1926),
    [sym_true] = ACTIONS(1924),
    [sym_false] = ACTIONS(1924),
    [anon_sym_NULL] = ACTIONS(1924),
    [anon_sym_nullptr] = ACTIONS(1924),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1924),
    [anon_sym_decltype] = ACTIONS(1924),
    [sym_virtual] = ACTIONS(1924),
    [anon_sym_explicit] = ACTIONS(1924),
    [anon_sym_typename] = ACTIONS(1924),
    [anon_sym_template] = ACTIONS(1924),
    [anon_sym_operator] = ACTIONS(1924),
    [anon_sym_try] = ACTIONS(1924),
    [anon_sym_delete] = ACTIONS(1924),
    [anon_sym_throw] = ACTIONS(1924),
    [anon_sym_namespace] = ACTIONS(1924),
    [anon_sym_using] = ACTIONS(1924),
    [anon_sym_static_assert] = ACTIONS(1924),
    [anon_sym_concept] = ACTIONS(1924),
    [anon_sym_co_return] = ACTIONS(1924),
    [anon_sym_co_yield] = ACTIONS(1924),
    [anon_sym_catch] = ACTIONS(1924),
    [anon_sym_R_DQUOTE] = ACTIONS(1926),
    [anon_sym_LR_DQUOTE] = ACTIONS(1926),
    [anon_sym_uR_DQUOTE] = ACTIONS(1926),
    [anon_sym_UR_DQUOTE] = ACTIONS(1926),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1926),
    [anon_sym_co_await] = ACTIONS(1924),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1924),
    [anon_sym___launch_bounds__] = ACTIONS(1924),
  },
  [139] = {
    [sym_else_clause] = STATE(148),
    [sym_identifier] = ACTIONS(1928),
    [aux_sym_preproc_include_token1] = ACTIONS(1928),
    [aux_sym_preproc_def_token1] = ACTIONS(1928),
    [aux_sym_preproc_if_token1] = ACTIONS(1928),
    [aux_sym_preproc_if_token2] = ACTIONS(1928),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1928),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1928),
    [aux_sym_preproc_else_token1] = ACTIONS(1928),
    [aux_sym_preproc_elif_token1] = ACTIONS(1928),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1928),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1928),
    [sym_preproc_directive] = ACTIONS(1928),
    [anon_sym_LPAREN2] = ACTIONS(1930),
    [anon_sym_BANG] = ACTIONS(1930),
    [anon_sym_TILDE] = ACTIONS(1930),
    [anon_sym_DASH] = ACTIONS(1928),
    [anon_sym_PLUS] = ACTIONS(1928),
    [anon_sym_STAR] = ACTIONS(1930),
    [anon_sym_AMP_AMP] = ACTIONS(1930),
    [anon_sym_AMP] = ACTIONS(1928),
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym___extension__] = ACTIONS(1928),
    [anon_sym_typedef] = ACTIONS(1928),
    [anon_sym___device__] = ACTIONS(1928),
    [anon_sym___host__] = ACTIONS(1928),
    [anon_sym___global__] = ACTIONS(1928),
    [anon_sym___forceinline__] = ACTIONS(1928),
    [anon_sym___noinline__] = ACTIONS(1928),
    [anon_sym_extern] = ACTIONS(1928),
    [anon_sym___attribute__] = ACTIONS(1928),
    [anon_sym_COLON_COLON] = ACTIONS(1930),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1930),
    [anon_sym___declspec] = ACTIONS(1928),
    [anon_sym___based] = ACTIONS(1928),
    [anon_sym___cdecl] = ACTIONS(1928),
    [anon_sym___clrcall] = ACTIONS(1928),
    [anon_sym___stdcall] = ACTIONS(1928),
    [anon_sym___fastcall] = ACTIONS(1928),
    [anon_sym___thiscall] = ACTIONS(1928),
    [anon_sym___vectorcall] = ACTIONS(1928),
    [anon_sym_LBRACE] = ACTIONS(1930),
    [anon_sym_signed] = ACTIONS(1928),
    [anon_sym_unsigned] = ACTIONS(1928),
    [anon_sym_long] = ACTIONS(1928),
    [anon_sym_short] = ACTIONS(1928),
    [anon_sym_LBRACK] = ACTIONS(1928),
    [anon_sym_static] = ACTIONS(1928),
    [anon_sym_register] = ACTIONS(1928),
    [anon_sym_inline] = ACTIONS(1928),
    [anon_sym___inline] = ACTIONS(1928),
    [anon_sym___inline__] = ACTIONS(1928),
    [anon_sym___forceinline] = ACTIONS(1928),
    [anon_sym_thread_local] = ACTIONS(1928),
    [anon_sym___thread] = ACTIONS(1928),
    [anon_sym_const] = ACTIONS(1928),
    [anon_sym_constexpr] = ACTIONS(1928),
    [anon_sym_volatile] = ACTIONS(1928),
    [anon_sym_restrict] = ACTIONS(1928),
    [anon_sym___restrict__] = ACTIONS(1928),
    [anon_sym__Atomic] = ACTIONS(1928),
    [anon_sym__Noreturn] = ACTIONS(1928),
    [anon_sym_noreturn] = ACTIONS(1928),
    [anon_sym_mutable] = ACTIONS(1928),
    [anon_sym_constinit] = ACTIONS(1928),
    [anon_sym_consteval] = ACTIONS(1928),
    [anon_sym___shared__] = ACTIONS(1928),
    [anon_sym___local__] = ACTIONS(1928),
    [anon_sym___constant__] = ACTIONS(1928),
    [anon_sym___managed__] = ACTIONS(1928),
    [anon_sym___grid_constant__] = ACTIONS(1928),
    [anon_sym_alignas] = ACTIONS(1928),
    [anon_sym__Alignas] = ACTIONS(1928),
    [sym_primitive_type] = ACTIONS(1928),
    [anon_sym_enum] = ACTIONS(1928),
    [anon_sym_class] = ACTIONS(1928),
    [anon_sym_struct] = ACTIONS(1928),
    [anon_sym_union] = ACTIONS(1928),
    [anon_sym_if] = ACTIONS(1928),
    [anon_sym_else] = ACTIONS(1932),
    [anon_sym_switch] = ACTIONS(1928),
    [anon_sym_case] = ACTIONS(1928),
    [anon_sym_default] = ACTIONS(1928),
    [anon_sym_while] = ACTIONS(1928),
    [anon_sym_do] = ACTIONS(1928),
    [anon_sym_for] = ACTIONS(1928),
    [anon_sym_return] = ACTIONS(1928),
    [anon_sym_break] = ACTIONS(1928),
    [anon_sym_continue] = ACTIONS(1928),
    [anon_sym_goto] = ACTIONS(1928),
    [anon_sym___try] = ACTIONS(1928),
    [anon_sym___leave] = ACTIONS(1928),
    [anon_sym_not] = ACTIONS(1928),
    [anon_sym_compl] = ACTIONS(1928),
    [anon_sym_DASH_DASH] = ACTIONS(1930),
    [anon_sym_PLUS_PLUS] = ACTIONS(1930),
    [anon_sym_sizeof] = ACTIONS(1928),
    [anon_sym___alignof__] = ACTIONS(1928),
    [anon_sym___alignof] = ACTIONS(1928),
    [anon_sym__alignof] = ACTIONS(1928),
    [anon_sym_alignof] = ACTIONS(1928),
    [anon_sym__Alignof] = ACTIONS(1928),
    [anon_sym_offsetof] = ACTIONS(1928),
    [anon_sym__Generic] = ACTIONS(1928),
    [anon_sym_asm] = ACTIONS(1928),
    [anon_sym___asm__] = ACTIONS(1928),
    [sym_number_literal] = ACTIONS(1930),
    [anon_sym_L_SQUOTE] = ACTIONS(1930),
    [anon_sym_u_SQUOTE] = ACTIONS(1930),
    [anon_sym_U_SQUOTE] = ACTIONS(1930),
    [anon_sym_u8_SQUOTE] = ACTIONS(1930),
    [anon_sym_SQUOTE] = ACTIONS(1930),
    [anon_sym_L_DQUOTE] = ACTIONS(1930),
    [anon_sym_u_DQUOTE] = ACTIONS(1930),
    [anon_sym_U_DQUOTE] = ACTIONS(1930),
    [anon_sym_u8_DQUOTE] = ACTIONS(1930),
    [anon_sym_DQUOTE] = ACTIONS(1930),
    [sym_true] = ACTIONS(1928),
    [sym_false] = ACTIONS(1928),
    [anon_sym_NULL] = ACTIONS(1928),
    [anon_sym_nullptr] = ACTIONS(1928),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1928),
    [anon_sym_decltype] = ACTIONS(1928),
    [sym_virtual] = ACTIONS(1928),
    [anon_sym_explicit] = ACTIONS(1928),
    [anon_sym_typename] = ACTIONS(1928),
    [anon_sym_template] = ACTIONS(1928),
    [anon_sym_operator] = ACTIONS(1928),
    [anon_sym_try] = ACTIONS(1928),
    [anon_sym_delete] = ACTIONS(1928),
    [anon_sym_throw] = ACTIONS(1928),
    [anon_sym_namespace] = ACTIONS(1928),
    [anon_sym_using] = ACTIONS(1928),
    [anon_sym_static_assert] = ACTIONS(1928),
    [anon_sym_concept] = ACTIONS(1928),
    [anon_sym_co_return] = ACTIONS(1928),
    [anon_sym_co_yield] = ACTIONS(1928),
    [anon_sym_R_DQUOTE] = ACTIONS(1930),
    [anon_sym_LR_DQUOTE] = ACTIONS(1930),
    [anon_sym_uR_DQUOTE] = ACTIONS(1930),
    [anon_sym_UR_DQUOTE] = ACTIONS(1930),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1930),
    [anon_sym_co_await] = ACTIONS(1928),
    [anon_sym_new] = ACTIONS(1928),
    [anon_sym_requires] = ACTIONS(1928),
    [sym_this] = ACTIONS(1928),
    [anon_sym___launch_bounds__] = ACTIONS(1928),
  },
  [140] = {
    [sym_else_clause] = STATE(158),
    [sym_identifier] = ACTIONS(1934),
    [aux_sym_preproc_include_token1] = ACTIONS(1934),
    [aux_sym_preproc_def_token1] = ACTIONS(1934),
    [aux_sym_preproc_if_token1] = ACTIONS(1934),
    [aux_sym_preproc_if_token2] = ACTIONS(1934),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1934),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1934),
    [aux_sym_preproc_else_token1] = ACTIONS(1934),
    [aux_sym_preproc_elif_token1] = ACTIONS(1934),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1934),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1934),
    [sym_preproc_directive] = ACTIONS(1934),
    [anon_sym_LPAREN2] = ACTIONS(1936),
    [anon_sym_BANG] = ACTIONS(1936),
    [anon_sym_TILDE] = ACTIONS(1936),
    [anon_sym_DASH] = ACTIONS(1934),
    [anon_sym_PLUS] = ACTIONS(1934),
    [anon_sym_STAR] = ACTIONS(1936),
    [anon_sym_AMP_AMP] = ACTIONS(1936),
    [anon_sym_AMP] = ACTIONS(1934),
    [anon_sym_SEMI] = ACTIONS(1936),
    [anon_sym___extension__] = ACTIONS(1934),
    [anon_sym_typedef] = ACTIONS(1934),
    [anon_sym___device__] = ACTIONS(1934),
    [anon_sym___host__] = ACTIONS(1934),
    [anon_sym___global__] = ACTIONS(1934),
    [anon_sym___forceinline__] = ACTIONS(1934),
    [anon_sym___noinline__] = ACTIONS(1934),
    [anon_sym_extern] = ACTIONS(1934),
    [anon_sym___attribute__] = ACTIONS(1934),
    [anon_sym_COLON_COLON] = ACTIONS(1936),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1936),
    [anon_sym___declspec] = ACTIONS(1934),
    [anon_sym___based] = ACTIONS(1934),
    [anon_sym___cdecl] = ACTIONS(1934),
    [anon_sym___clrcall] = ACTIONS(1934),
    [anon_sym___stdcall] = ACTIONS(1934),
    [anon_sym___fastcall] = ACTIONS(1934),
    [anon_sym___thiscall] = ACTIONS(1934),
    [anon_sym___vectorcall] = ACTIONS(1934),
    [anon_sym_LBRACE] = ACTIONS(1936),
    [anon_sym_signed] = ACTIONS(1934),
    [anon_sym_unsigned] = ACTIONS(1934),
    [anon_sym_long] = ACTIONS(1934),
    [anon_sym_short] = ACTIONS(1934),
    [anon_sym_LBRACK] = ACTIONS(1934),
    [anon_sym_static] = ACTIONS(1934),
    [anon_sym_register] = ACTIONS(1934),
    [anon_sym_inline] = ACTIONS(1934),
    [anon_sym___inline] = ACTIONS(1934),
    [anon_sym___inline__] = ACTIONS(1934),
    [anon_sym___forceinline] = ACTIONS(1934),
    [anon_sym_thread_local] = ACTIONS(1934),
    [anon_sym___thread] = ACTIONS(1934),
    [anon_sym_const] = ACTIONS(1934),
    [anon_sym_constexpr] = ACTIONS(1934),
    [anon_sym_volatile] = ACTIONS(1934),
    [anon_sym_restrict] = ACTIONS(1934),
    [anon_sym___restrict__] = ACTIONS(1934),
    [anon_sym__Atomic] = ACTIONS(1934),
    [anon_sym__Noreturn] = ACTIONS(1934),
    [anon_sym_noreturn] = ACTIONS(1934),
    [anon_sym_mutable] = ACTIONS(1934),
    [anon_sym_constinit] = ACTIONS(1934),
    [anon_sym_consteval] = ACTIONS(1934),
    [anon_sym___shared__] = ACTIONS(1934),
    [anon_sym___local__] = ACTIONS(1934),
    [anon_sym___constant__] = ACTIONS(1934),
    [anon_sym___managed__] = ACTIONS(1934),
    [anon_sym___grid_constant__] = ACTIONS(1934),
    [anon_sym_alignas] = ACTIONS(1934),
    [anon_sym__Alignas] = ACTIONS(1934),
    [sym_primitive_type] = ACTIONS(1934),
    [anon_sym_enum] = ACTIONS(1934),
    [anon_sym_class] = ACTIONS(1934),
    [anon_sym_struct] = ACTIONS(1934),
    [anon_sym_union] = ACTIONS(1934),
    [anon_sym_if] = ACTIONS(1934),
    [anon_sym_else] = ACTIONS(1932),
    [anon_sym_switch] = ACTIONS(1934),
    [anon_sym_case] = ACTIONS(1934),
    [anon_sym_default] = ACTIONS(1934),
    [anon_sym_while] = ACTIONS(1934),
    [anon_sym_do] = ACTIONS(1934),
    [anon_sym_for] = ACTIONS(1934),
    [anon_sym_return] = ACTIONS(1934),
    [anon_sym_break] = ACTIONS(1934),
    [anon_sym_continue] = ACTIONS(1934),
    [anon_sym_goto] = ACTIONS(1934),
    [anon_sym___try] = ACTIONS(1934),
    [anon_sym___leave] = ACTIONS(1934),
    [anon_sym_not] = ACTIONS(1934),
    [anon_sym_compl] = ACTIONS(1934),
    [anon_sym_DASH_DASH] = ACTIONS(1936),
    [anon_sym_PLUS_PLUS] = ACTIONS(1936),
    [anon_sym_sizeof] = ACTIONS(1934),
    [anon_sym___alignof__] = ACTIONS(1934),
    [anon_sym___alignof] = ACTIONS(1934),
    [anon_sym__alignof] = ACTIONS(1934),
    [anon_sym_alignof] = ACTIONS(1934),
    [anon_sym__Alignof] = ACTIONS(1934),
    [anon_sym_offsetof] = ACTIONS(1934),
    [anon_sym__Generic] = ACTIONS(1934),
    [anon_sym_asm] = ACTIONS(1934),
    [anon_sym___asm__] = ACTIONS(1934),
    [sym_number_literal] = ACTIONS(1936),
    [anon_sym_L_SQUOTE] = ACTIONS(1936),
    [anon_sym_u_SQUOTE] = ACTIONS(1936),
    [anon_sym_U_SQUOTE] = ACTIONS(1936),
    [anon_sym_u8_SQUOTE] = ACTIONS(1936),
    [anon_sym_SQUOTE] = ACTIONS(1936),
    [anon_sym_L_DQUOTE] = ACTIONS(1936),
    [anon_sym_u_DQUOTE] = ACTIONS(1936),
    [anon_sym_U_DQUOTE] = ACTIONS(1936),
    [anon_sym_u8_DQUOTE] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1936),
    [sym_true] = ACTIONS(1934),
    [sym_false] = ACTIONS(1934),
    [anon_sym_NULL] = ACTIONS(1934),
    [anon_sym_nullptr] = ACTIONS(1934),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1934),
    [anon_sym_decltype] = ACTIONS(1934),
    [sym_virtual] = ACTIONS(1934),
    [anon_sym_explicit] = ACTIONS(1934),
    [anon_sym_typename] = ACTIONS(1934),
    [anon_sym_template] = ACTIONS(1934),
    [anon_sym_operator] = ACTIONS(1934),
    [anon_sym_try] = ACTIONS(1934),
    [anon_sym_delete] = ACTIONS(1934),
    [anon_sym_throw] = ACTIONS(1934),
    [anon_sym_namespace] = ACTIONS(1934),
    [anon_sym_using] = ACTIONS(1934),
    [anon_sym_static_assert] = ACTIONS(1934),
    [anon_sym_concept] = ACTIONS(1934),
    [anon_sym_co_return] = ACTIONS(1934),
    [anon_sym_co_yield] = ACTIONS(1934),
    [anon_sym_R_DQUOTE] = ACTIONS(1936),
    [anon_sym_LR_DQUOTE] = ACTIONS(1936),
    [anon_sym_uR_DQUOTE] = ACTIONS(1936),
    [anon_sym_UR_DQUOTE] = ACTIONS(1936),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1936),
    [anon_sym_co_await] = ACTIONS(1934),
    [anon_sym_new] = ACTIONS(1934),
    [anon_sym_requires] = ACTIONS(1934),
    [sym_this] = ACTIONS(1934),
    [anon_sym___launch_bounds__] = ACTIONS(1934),
  },
  [141] = {
    [sym_identifier] = ACTIONS(1901),
    [aux_sym_preproc_include_token1] = ACTIONS(1901),
    [aux_sym_preproc_def_token1] = ACTIONS(1901),
    [aux_sym_preproc_if_token1] = ACTIONS(1901),
    [aux_sym_preproc_if_token2] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1901),
    [aux_sym_preproc_else_token1] = ACTIONS(1901),
    [aux_sym_preproc_elif_token1] = ACTIONS(1901),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1901),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1901),
    [sym_preproc_directive] = ACTIONS(1901),
    [anon_sym_LPAREN2] = ACTIONS(1899),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_DASH] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1901),
    [anon_sym_STAR] = ACTIONS(1899),
    [anon_sym_AMP_AMP] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1901),
    [anon_sym_SEMI] = ACTIONS(1899),
    [anon_sym___extension__] = ACTIONS(1901),
    [anon_sym_typedef] = ACTIONS(1901),
    [anon_sym___device__] = ACTIONS(1901),
    [anon_sym___host__] = ACTIONS(1901),
    [anon_sym___global__] = ACTIONS(1901),
    [anon_sym___forceinline__] = ACTIONS(1901),
    [anon_sym___noinline__] = ACTIONS(1901),
    [anon_sym_extern] = ACTIONS(1901),
    [anon_sym___attribute__] = ACTIONS(1901),
    [anon_sym_COLON_COLON] = ACTIONS(1899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1899),
    [anon_sym___declspec] = ACTIONS(1901),
    [anon_sym___based] = ACTIONS(1901),
    [anon_sym___cdecl] = ACTIONS(1901),
    [anon_sym___clrcall] = ACTIONS(1901),
    [anon_sym___stdcall] = ACTIONS(1901),
    [anon_sym___fastcall] = ACTIONS(1901),
    [anon_sym___thiscall] = ACTIONS(1901),
    [anon_sym___vectorcall] = ACTIONS(1901),
    [anon_sym_LBRACE] = ACTIONS(1899),
    [anon_sym_signed] = ACTIONS(1901),
    [anon_sym_unsigned] = ACTIONS(1901),
    [anon_sym_long] = ACTIONS(1901),
    [anon_sym_short] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1901),
    [anon_sym_static] = ACTIONS(1901),
    [anon_sym_register] = ACTIONS(1901),
    [anon_sym_inline] = ACTIONS(1901),
    [anon_sym___inline] = ACTIONS(1901),
    [anon_sym___inline__] = ACTIONS(1901),
    [anon_sym___forceinline] = ACTIONS(1901),
    [anon_sym_thread_local] = ACTIONS(1901),
    [anon_sym___thread] = ACTIONS(1901),
    [anon_sym_const] = ACTIONS(1901),
    [anon_sym_constexpr] = ACTIONS(1901),
    [anon_sym_volatile] = ACTIONS(1901),
    [anon_sym_restrict] = ACTIONS(1901),
    [anon_sym___restrict__] = ACTIONS(1901),
    [anon_sym__Atomic] = ACTIONS(1901),
    [anon_sym__Noreturn] = ACTIONS(1901),
    [anon_sym_noreturn] = ACTIONS(1901),
    [anon_sym_mutable] = ACTIONS(1901),
    [anon_sym_constinit] = ACTIONS(1901),
    [anon_sym_consteval] = ACTIONS(1901),
    [anon_sym___shared__] = ACTIONS(1901),
    [anon_sym___local__] = ACTIONS(1901),
    [anon_sym___constant__] = ACTIONS(1901),
    [anon_sym___managed__] = ACTIONS(1901),
    [anon_sym___grid_constant__] = ACTIONS(1901),
    [anon_sym_alignas] = ACTIONS(1901),
    [anon_sym__Alignas] = ACTIONS(1901),
    [sym_primitive_type] = ACTIONS(1901),
    [anon_sym_enum] = ACTIONS(1901),
    [anon_sym_class] = ACTIONS(1901),
    [anon_sym_struct] = ACTIONS(1901),
    [anon_sym_union] = ACTIONS(1901),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_else] = ACTIONS(1901),
    [anon_sym_switch] = ACTIONS(1901),
    [anon_sym_case] = ACTIONS(1901),
    [anon_sym_default] = ACTIONS(1901),
    [anon_sym_while] = ACTIONS(1901),
    [anon_sym_do] = ACTIONS(1901),
    [anon_sym_for] = ACTIONS(1901),
    [anon_sym_return] = ACTIONS(1901),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_continue] = ACTIONS(1901),
    [anon_sym_goto] = ACTIONS(1901),
    [anon_sym___try] = ACTIONS(1901),
    [anon_sym___leave] = ACTIONS(1901),
    [anon_sym_not] = ACTIONS(1901),
    [anon_sym_compl] = ACTIONS(1901),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_sizeof] = ACTIONS(1901),
    [anon_sym___alignof__] = ACTIONS(1901),
    [anon_sym___alignof] = ACTIONS(1901),
    [anon_sym__alignof] = ACTIONS(1901),
    [anon_sym_alignof] = ACTIONS(1901),
    [anon_sym__Alignof] = ACTIONS(1901),
    [anon_sym_offsetof] = ACTIONS(1901),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1901),
    [anon_sym___asm__] = ACTIONS(1901),
    [sym_number_literal] = ACTIONS(1899),
    [anon_sym_L_SQUOTE] = ACTIONS(1899),
    [anon_sym_u_SQUOTE] = ACTIONS(1899),
    [anon_sym_U_SQUOTE] = ACTIONS(1899),
    [anon_sym_u8_SQUOTE] = ACTIONS(1899),
    [anon_sym_SQUOTE] = ACTIONS(1899),
    [anon_sym_L_DQUOTE] = ACTIONS(1899),
    [anon_sym_u_DQUOTE] = ACTIONS(1899),
    [anon_sym_U_DQUOTE] = ACTIONS(1899),
    [anon_sym_u8_DQUOTE] = ACTIONS(1899),
    [anon_sym_DQUOTE] = ACTIONS(1899),
    [sym_true] = ACTIONS(1901),
    [sym_false] = ACTIONS(1901),
    [anon_sym_NULL] = ACTIONS(1901),
    [anon_sym_nullptr] = ACTIONS(1901),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1901),
    [anon_sym_decltype] = ACTIONS(1901),
    [sym_virtual] = ACTIONS(1901),
    [anon_sym_explicit] = ACTIONS(1901),
    [anon_sym_typename] = ACTIONS(1901),
    [anon_sym_template] = ACTIONS(1901),
    [anon_sym_operator] = ACTIONS(1901),
    [anon_sym_try] = ACTIONS(1901),
    [anon_sym_delete] = ACTIONS(1901),
    [anon_sym_throw] = ACTIONS(1901),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_using] = ACTIONS(1901),
    [anon_sym_static_assert] = ACTIONS(1901),
    [anon_sym_concept] = ACTIONS(1901),
    [anon_sym_co_return] = ACTIONS(1901),
    [anon_sym_co_yield] = ACTIONS(1901),
    [anon_sym_catch] = ACTIONS(1901),
    [anon_sym_R_DQUOTE] = ACTIONS(1899),
    [anon_sym_LR_DQUOTE] = ACTIONS(1899),
    [anon_sym_uR_DQUOTE] = ACTIONS(1899),
    [anon_sym_UR_DQUOTE] = ACTIONS(1899),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1899),
    [anon_sym_co_await] = ACTIONS(1901),
    [anon_sym_new] = ACTIONS(1901),
    [anon_sym_requires] = ACTIONS(1901),
    [sym_this] = ACTIONS(1901),
    [anon_sym___launch_bounds__] = ACTIONS(1901),
  },
  [142] = {
    [sym_identifier] = ACTIONS(1938),
    [aux_sym_preproc_include_token1] = ACTIONS(1938),
    [aux_sym_preproc_def_token1] = ACTIONS(1938),
    [aux_sym_preproc_if_token1] = ACTIONS(1938),
    [aux_sym_preproc_if_token2] = ACTIONS(1938),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1938),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1938),
    [aux_sym_preproc_else_token1] = ACTIONS(1938),
    [aux_sym_preproc_elif_token1] = ACTIONS(1938),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1938),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1938),
    [sym_preproc_directive] = ACTIONS(1938),
    [anon_sym_LPAREN2] = ACTIONS(1940),
    [anon_sym_BANG] = ACTIONS(1940),
    [anon_sym_TILDE] = ACTIONS(1940),
    [anon_sym_DASH] = ACTIONS(1938),
    [anon_sym_PLUS] = ACTIONS(1938),
    [anon_sym_STAR] = ACTIONS(1940),
    [anon_sym_AMP_AMP] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1938),
    [anon_sym_SEMI] = ACTIONS(1940),
    [anon_sym___extension__] = ACTIONS(1938),
    [anon_sym_typedef] = ACTIONS(1938),
    [anon_sym___device__] = ACTIONS(1938),
    [anon_sym___host__] = ACTIONS(1938),
    [anon_sym___global__] = ACTIONS(1938),
    [anon_sym___forceinline__] = ACTIONS(1938),
    [anon_sym___noinline__] = ACTIONS(1938),
    [anon_sym_extern] = ACTIONS(1938),
    [anon_sym___attribute__] = ACTIONS(1938),
    [anon_sym_COLON_COLON] = ACTIONS(1940),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1940),
    [anon_sym___declspec] = ACTIONS(1938),
    [anon_sym___based] = ACTIONS(1938),
    [anon_sym___cdecl] = ACTIONS(1938),
    [anon_sym___clrcall] = ACTIONS(1938),
    [anon_sym___stdcall] = ACTIONS(1938),
    [anon_sym___fastcall] = ACTIONS(1938),
    [anon_sym___thiscall] = ACTIONS(1938),
    [anon_sym___vectorcall] = ACTIONS(1938),
    [anon_sym_LBRACE] = ACTIONS(1940),
    [anon_sym_signed] = ACTIONS(1938),
    [anon_sym_unsigned] = ACTIONS(1938),
    [anon_sym_long] = ACTIONS(1938),
    [anon_sym_short] = ACTIONS(1938),
    [anon_sym_LBRACK] = ACTIONS(1938),
    [anon_sym_static] = ACTIONS(1938),
    [anon_sym_register] = ACTIONS(1938),
    [anon_sym_inline] = ACTIONS(1938),
    [anon_sym___inline] = ACTIONS(1938),
    [anon_sym___inline__] = ACTIONS(1938),
    [anon_sym___forceinline] = ACTIONS(1938),
    [anon_sym_thread_local] = ACTIONS(1938),
    [anon_sym___thread] = ACTIONS(1938),
    [anon_sym_const] = ACTIONS(1938),
    [anon_sym_constexpr] = ACTIONS(1938),
    [anon_sym_volatile] = ACTIONS(1938),
    [anon_sym_restrict] = ACTIONS(1938),
    [anon_sym___restrict__] = ACTIONS(1938),
    [anon_sym__Atomic] = ACTIONS(1938),
    [anon_sym__Noreturn] = ACTIONS(1938),
    [anon_sym_noreturn] = ACTIONS(1938),
    [anon_sym_mutable] = ACTIONS(1938),
    [anon_sym_constinit] = ACTIONS(1938),
    [anon_sym_consteval] = ACTIONS(1938),
    [anon_sym___shared__] = ACTIONS(1938),
    [anon_sym___local__] = ACTIONS(1938),
    [anon_sym___constant__] = ACTIONS(1938),
    [anon_sym___managed__] = ACTIONS(1938),
    [anon_sym___grid_constant__] = ACTIONS(1938),
    [anon_sym_alignas] = ACTIONS(1938),
    [anon_sym__Alignas] = ACTIONS(1938),
    [sym_primitive_type] = ACTIONS(1938),
    [anon_sym_enum] = ACTIONS(1938),
    [anon_sym_class] = ACTIONS(1938),
    [anon_sym_struct] = ACTIONS(1938),
    [anon_sym_union] = ACTIONS(1938),
    [anon_sym_if] = ACTIONS(1938),
    [anon_sym_else] = ACTIONS(1938),
    [anon_sym_switch] = ACTIONS(1938),
    [anon_sym_case] = ACTIONS(1938),
    [anon_sym_default] = ACTIONS(1938),
    [anon_sym_while] = ACTIONS(1938),
    [anon_sym_do] = ACTIONS(1938),
    [anon_sym_for] = ACTIONS(1938),
    [anon_sym_return] = ACTIONS(1938),
    [anon_sym_break] = ACTIONS(1938),
    [anon_sym_continue] = ACTIONS(1938),
    [anon_sym_goto] = ACTIONS(1938),
    [anon_sym___try] = ACTIONS(1938),
    [anon_sym___leave] = ACTIONS(1938),
    [anon_sym_not] = ACTIONS(1938),
    [anon_sym_compl] = ACTIONS(1938),
    [anon_sym_DASH_DASH] = ACTIONS(1940),
    [anon_sym_PLUS_PLUS] = ACTIONS(1940),
    [anon_sym_sizeof] = ACTIONS(1938),
    [anon_sym___alignof__] = ACTIONS(1938),
    [anon_sym___alignof] = ACTIONS(1938),
    [anon_sym__alignof] = ACTIONS(1938),
    [anon_sym_alignof] = ACTIONS(1938),
    [anon_sym__Alignof] = ACTIONS(1938),
    [anon_sym_offsetof] = ACTIONS(1938),
    [anon_sym__Generic] = ACTIONS(1938),
    [anon_sym_asm] = ACTIONS(1938),
    [anon_sym___asm__] = ACTIONS(1938),
    [sym_number_literal] = ACTIONS(1940),
    [anon_sym_L_SQUOTE] = ACTIONS(1940),
    [anon_sym_u_SQUOTE] = ACTIONS(1940),
    [anon_sym_U_SQUOTE] = ACTIONS(1940),
    [anon_sym_u8_SQUOTE] = ACTIONS(1940),
    [anon_sym_SQUOTE] = ACTIONS(1940),
    [anon_sym_L_DQUOTE] = ACTIONS(1940),
    [anon_sym_u_DQUOTE] = ACTIONS(1940),
    [anon_sym_U_DQUOTE] = ACTIONS(1940),
    [anon_sym_u8_DQUOTE] = ACTIONS(1940),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_true] = ACTIONS(1938),
    [sym_false] = ACTIONS(1938),
    [anon_sym_NULL] = ACTIONS(1938),
    [anon_sym_nullptr] = ACTIONS(1938),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1938),
    [anon_sym_decltype] = ACTIONS(1938),
    [sym_virtual] = ACTIONS(1938),
    [anon_sym_explicit] = ACTIONS(1938),
    [anon_sym_typename] = ACTIONS(1938),
    [anon_sym_template] = ACTIONS(1938),
    [anon_sym_operator] = ACTIONS(1938),
    [anon_sym_try] = ACTIONS(1938),
    [anon_sym_delete] = ACTIONS(1938),
    [anon_sym_throw] = ACTIONS(1938),
    [anon_sym_namespace] = ACTIONS(1938),
    [anon_sym_using] = ACTIONS(1938),
    [anon_sym_static_assert] = ACTIONS(1938),
    [anon_sym_concept] = ACTIONS(1938),
    [anon_sym_co_return] = ACTIONS(1938),
    [anon_sym_co_yield] = ACTIONS(1938),
    [anon_sym_R_DQUOTE] = ACTIONS(1940),
    [anon_sym_LR_DQUOTE] = ACTIONS(1940),
    [anon_sym_uR_DQUOTE] = ACTIONS(1940),
    [anon_sym_UR_DQUOTE] = ACTIONS(1940),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1940),
    [anon_sym_co_await] = ACTIONS(1938),
    [anon_sym_new] = ACTIONS(1938),
    [anon_sym_requires] = ACTIONS(1938),
    [sym_this] = ACTIONS(1938),
    [anon_sym___launch_bounds__] = ACTIONS(1938),
  },
  [143] = {
    [sym_identifier] = ACTIONS(1942),
    [aux_sym_preproc_include_token1] = ACTIONS(1942),
    [aux_sym_preproc_def_token1] = ACTIONS(1942),
    [aux_sym_preproc_if_token1] = ACTIONS(1942),
    [aux_sym_preproc_if_token2] = ACTIONS(1942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1942),
    [aux_sym_preproc_else_token1] = ACTIONS(1942),
    [aux_sym_preproc_elif_token1] = ACTIONS(1942),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1942),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1942),
    [sym_preproc_directive] = ACTIONS(1942),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(1944),
    [anon_sym_TILDE] = ACTIONS(1944),
    [anon_sym_DASH] = ACTIONS(1942),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym_SEMI] = ACTIONS(1944),
    [anon_sym___extension__] = ACTIONS(1942),
    [anon_sym_typedef] = ACTIONS(1942),
    [anon_sym___device__] = ACTIONS(1942),
    [anon_sym___host__] = ACTIONS(1942),
    [anon_sym___global__] = ACTIONS(1942),
    [anon_sym___forceinline__] = ACTIONS(1942),
    [anon_sym___noinline__] = ACTIONS(1942),
    [anon_sym_extern] = ACTIONS(1942),
    [anon_sym___attribute__] = ACTIONS(1942),
    [anon_sym_COLON_COLON] = ACTIONS(1944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1944),
    [anon_sym___declspec] = ACTIONS(1942),
    [anon_sym___based] = ACTIONS(1942),
    [anon_sym___cdecl] = ACTIONS(1942),
    [anon_sym___clrcall] = ACTIONS(1942),
    [anon_sym___stdcall] = ACTIONS(1942),
    [anon_sym___fastcall] = ACTIONS(1942),
    [anon_sym___thiscall] = ACTIONS(1942),
    [anon_sym___vectorcall] = ACTIONS(1942),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_signed] = ACTIONS(1942),
    [anon_sym_unsigned] = ACTIONS(1942),
    [anon_sym_long] = ACTIONS(1942),
    [anon_sym_short] = ACTIONS(1942),
    [anon_sym_LBRACK] = ACTIONS(1942),
    [anon_sym_static] = ACTIONS(1942),
    [anon_sym_register] = ACTIONS(1942),
    [anon_sym_inline] = ACTIONS(1942),
    [anon_sym___inline] = ACTIONS(1942),
    [anon_sym___inline__] = ACTIONS(1942),
    [anon_sym___forceinline] = ACTIONS(1942),
    [anon_sym_thread_local] = ACTIONS(1942),
    [anon_sym___thread] = ACTIONS(1942),
    [anon_sym_const] = ACTIONS(1942),
    [anon_sym_constexpr] = ACTIONS(1942),
    [anon_sym_volatile] = ACTIONS(1942),
    [anon_sym_restrict] = ACTIONS(1942),
    [anon_sym___restrict__] = ACTIONS(1942),
    [anon_sym__Atomic] = ACTIONS(1942),
    [anon_sym__Noreturn] = ACTIONS(1942),
    [anon_sym_noreturn] = ACTIONS(1942),
    [anon_sym_mutable] = ACTIONS(1942),
    [anon_sym_constinit] = ACTIONS(1942),
    [anon_sym_consteval] = ACTIONS(1942),
    [anon_sym___shared__] = ACTIONS(1942),
    [anon_sym___local__] = ACTIONS(1942),
    [anon_sym___constant__] = ACTIONS(1942),
    [anon_sym___managed__] = ACTIONS(1942),
    [anon_sym___grid_constant__] = ACTIONS(1942),
    [anon_sym_alignas] = ACTIONS(1942),
    [anon_sym__Alignas] = ACTIONS(1942),
    [sym_primitive_type] = ACTIONS(1942),
    [anon_sym_enum] = ACTIONS(1942),
    [anon_sym_class] = ACTIONS(1942),
    [anon_sym_struct] = ACTIONS(1942),
    [anon_sym_union] = ACTIONS(1942),
    [anon_sym_if] = ACTIONS(1942),
    [anon_sym_else] = ACTIONS(1942),
    [anon_sym_switch] = ACTIONS(1942),
    [anon_sym_case] = ACTIONS(1942),
    [anon_sym_default] = ACTIONS(1942),
    [anon_sym_while] = ACTIONS(1942),
    [anon_sym_do] = ACTIONS(1942),
    [anon_sym_for] = ACTIONS(1942),
    [anon_sym_return] = ACTIONS(1942),
    [anon_sym_break] = ACTIONS(1942),
    [anon_sym_continue] = ACTIONS(1942),
    [anon_sym_goto] = ACTIONS(1942),
    [anon_sym___try] = ACTIONS(1942),
    [anon_sym___leave] = ACTIONS(1942),
    [anon_sym_not] = ACTIONS(1942),
    [anon_sym_compl] = ACTIONS(1942),
    [anon_sym_DASH_DASH] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1944),
    [anon_sym_sizeof] = ACTIONS(1942),
    [anon_sym___alignof__] = ACTIONS(1942),
    [anon_sym___alignof] = ACTIONS(1942),
    [anon_sym__alignof] = ACTIONS(1942),
    [anon_sym_alignof] = ACTIONS(1942),
    [anon_sym__Alignof] = ACTIONS(1942),
    [anon_sym_offsetof] = ACTIONS(1942),
    [anon_sym__Generic] = ACTIONS(1942),
    [anon_sym_asm] = ACTIONS(1942),
    [anon_sym___asm__] = ACTIONS(1942),
    [sym_number_literal] = ACTIONS(1944),
    [anon_sym_L_SQUOTE] = ACTIONS(1944),
    [anon_sym_u_SQUOTE] = ACTIONS(1944),
    [anon_sym_U_SQUOTE] = ACTIONS(1944),
    [anon_sym_u8_SQUOTE] = ACTIONS(1944),
    [anon_sym_SQUOTE] = ACTIONS(1944),
    [anon_sym_L_DQUOTE] = ACTIONS(1944),
    [anon_sym_u_DQUOTE] = ACTIONS(1944),
    [anon_sym_U_DQUOTE] = ACTIONS(1944),
    [anon_sym_u8_DQUOTE] = ACTIONS(1944),
    [anon_sym_DQUOTE] = ACTIONS(1944),
    [sym_true] = ACTIONS(1942),
    [sym_false] = ACTIONS(1942),
    [anon_sym_NULL] = ACTIONS(1942),
    [anon_sym_nullptr] = ACTIONS(1942),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1942),
    [anon_sym_decltype] = ACTIONS(1942),
    [sym_virtual] = ACTIONS(1942),
    [anon_sym_explicit] = ACTIONS(1942),
    [anon_sym_typename] = ACTIONS(1942),
    [anon_sym_template] = ACTIONS(1942),
    [anon_sym_operator] = ACTIONS(1942),
    [anon_sym_try] = ACTIONS(1942),
    [anon_sym_delete] = ACTIONS(1942),
    [anon_sym_throw] = ACTIONS(1942),
    [anon_sym_namespace] = ACTIONS(1942),
    [anon_sym_using] = ACTIONS(1942),
    [anon_sym_static_assert] = ACTIONS(1942),
    [anon_sym_concept] = ACTIONS(1942),
    [anon_sym_co_return] = ACTIONS(1942),
    [anon_sym_co_yield] = ACTIONS(1942),
    [anon_sym_R_DQUOTE] = ACTIONS(1944),
    [anon_sym_LR_DQUOTE] = ACTIONS(1944),
    [anon_sym_uR_DQUOTE] = ACTIONS(1944),
    [anon_sym_UR_DQUOTE] = ACTIONS(1944),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1944),
    [anon_sym_co_await] = ACTIONS(1942),
    [anon_sym_new] = ACTIONS(1942),
    [anon_sym_requires] = ACTIONS(1942),
    [sym_this] = ACTIONS(1942),
    [anon_sym___launch_bounds__] = ACTIONS(1942),
  },
  [144] = {
    [sym_identifier] = ACTIONS(1946),
    [aux_sym_preproc_include_token1] = ACTIONS(1946),
    [aux_sym_preproc_def_token1] = ACTIONS(1946),
    [aux_sym_preproc_if_token1] = ACTIONS(1946),
    [aux_sym_preproc_if_token2] = ACTIONS(1946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1946),
    [aux_sym_preproc_else_token1] = ACTIONS(1946),
    [aux_sym_preproc_elif_token1] = ACTIONS(1946),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1946),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1946),
    [sym_preproc_directive] = ACTIONS(1946),
    [anon_sym_LPAREN2] = ACTIONS(1948),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(1948),
    [anon_sym_AMP_AMP] = ACTIONS(1948),
    [anon_sym_AMP] = ACTIONS(1946),
    [anon_sym_SEMI] = ACTIONS(1948),
    [anon_sym___extension__] = ACTIONS(1946),
    [anon_sym_typedef] = ACTIONS(1946),
    [anon_sym___device__] = ACTIONS(1946),
    [anon_sym___host__] = ACTIONS(1946),
    [anon_sym___global__] = ACTIONS(1946),
    [anon_sym___forceinline__] = ACTIONS(1946),
    [anon_sym___noinline__] = ACTIONS(1946),
    [anon_sym_extern] = ACTIONS(1946),
    [anon_sym___attribute__] = ACTIONS(1946),
    [anon_sym_COLON_COLON] = ACTIONS(1948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1948),
    [anon_sym___declspec] = ACTIONS(1946),
    [anon_sym___based] = ACTIONS(1946),
    [anon_sym___cdecl] = ACTIONS(1946),
    [anon_sym___clrcall] = ACTIONS(1946),
    [anon_sym___stdcall] = ACTIONS(1946),
    [anon_sym___fastcall] = ACTIONS(1946),
    [anon_sym___thiscall] = ACTIONS(1946),
    [anon_sym___vectorcall] = ACTIONS(1946),
    [anon_sym_LBRACE] = ACTIONS(1948),
    [anon_sym_signed] = ACTIONS(1946),
    [anon_sym_unsigned] = ACTIONS(1946),
    [anon_sym_long] = ACTIONS(1946),
    [anon_sym_short] = ACTIONS(1946),
    [anon_sym_LBRACK] = ACTIONS(1946),
    [anon_sym_static] = ACTIONS(1946),
    [anon_sym_register] = ACTIONS(1946),
    [anon_sym_inline] = ACTIONS(1946),
    [anon_sym___inline] = ACTIONS(1946),
    [anon_sym___inline__] = ACTIONS(1946),
    [anon_sym___forceinline] = ACTIONS(1946),
    [anon_sym_thread_local] = ACTIONS(1946),
    [anon_sym___thread] = ACTIONS(1946),
    [anon_sym_const] = ACTIONS(1946),
    [anon_sym_constexpr] = ACTIONS(1946),
    [anon_sym_volatile] = ACTIONS(1946),
    [anon_sym_restrict] = ACTIONS(1946),
    [anon_sym___restrict__] = ACTIONS(1946),
    [anon_sym__Atomic] = ACTIONS(1946),
    [anon_sym__Noreturn] = ACTIONS(1946),
    [anon_sym_noreturn] = ACTIONS(1946),
    [anon_sym_mutable] = ACTIONS(1946),
    [anon_sym_constinit] = ACTIONS(1946),
    [anon_sym_consteval] = ACTIONS(1946),
    [anon_sym___shared__] = ACTIONS(1946),
    [anon_sym___local__] = ACTIONS(1946),
    [anon_sym___constant__] = ACTIONS(1946),
    [anon_sym___managed__] = ACTIONS(1946),
    [anon_sym___grid_constant__] = ACTIONS(1946),
    [anon_sym_alignas] = ACTIONS(1946),
    [anon_sym__Alignas] = ACTIONS(1946),
    [sym_primitive_type] = ACTIONS(1946),
    [anon_sym_enum] = ACTIONS(1946),
    [anon_sym_class] = ACTIONS(1946),
    [anon_sym_struct] = ACTIONS(1946),
    [anon_sym_union] = ACTIONS(1946),
    [anon_sym_if] = ACTIONS(1946),
    [anon_sym_else] = ACTIONS(1946),
    [anon_sym_switch] = ACTIONS(1946),
    [anon_sym_case] = ACTIONS(1946),
    [anon_sym_default] = ACTIONS(1946),
    [anon_sym_while] = ACTIONS(1946),
    [anon_sym_do] = ACTIONS(1946),
    [anon_sym_for] = ACTIONS(1946),
    [anon_sym_return] = ACTIONS(1946),
    [anon_sym_break] = ACTIONS(1946),
    [anon_sym_continue] = ACTIONS(1946),
    [anon_sym_goto] = ACTIONS(1946),
    [anon_sym___try] = ACTIONS(1946),
    [anon_sym___leave] = ACTIONS(1946),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(1948),
    [anon_sym_PLUS_PLUS] = ACTIONS(1948),
    [anon_sym_sizeof] = ACTIONS(1946),
    [anon_sym___alignof__] = ACTIONS(1946),
    [anon_sym___alignof] = ACTIONS(1946),
    [anon_sym__alignof] = ACTIONS(1946),
    [anon_sym_alignof] = ACTIONS(1946),
    [anon_sym__Alignof] = ACTIONS(1946),
    [anon_sym_offsetof] = ACTIONS(1946),
    [anon_sym__Generic] = ACTIONS(1946),
    [anon_sym_asm] = ACTIONS(1946),
    [anon_sym___asm__] = ACTIONS(1946),
    [sym_number_literal] = ACTIONS(1948),
    [anon_sym_L_SQUOTE] = ACTIONS(1948),
    [anon_sym_u_SQUOTE] = ACTIONS(1948),
    [anon_sym_U_SQUOTE] = ACTIONS(1948),
    [anon_sym_u8_SQUOTE] = ACTIONS(1948),
    [anon_sym_SQUOTE] = ACTIONS(1948),
    [anon_sym_L_DQUOTE] = ACTIONS(1948),
    [anon_sym_u_DQUOTE] = ACTIONS(1948),
    [anon_sym_U_DQUOTE] = ACTIONS(1948),
    [anon_sym_u8_DQUOTE] = ACTIONS(1948),
    [anon_sym_DQUOTE] = ACTIONS(1948),
    [sym_true] = ACTIONS(1946),
    [sym_false] = ACTIONS(1946),
    [anon_sym_NULL] = ACTIONS(1946),
    [anon_sym_nullptr] = ACTIONS(1946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1946),
    [anon_sym_decltype] = ACTIONS(1946),
    [sym_virtual] = ACTIONS(1946),
    [anon_sym_explicit] = ACTIONS(1946),
    [anon_sym_typename] = ACTIONS(1946),
    [anon_sym_template] = ACTIONS(1946),
    [anon_sym_operator] = ACTIONS(1946),
    [anon_sym_try] = ACTIONS(1946),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_throw] = ACTIONS(1946),
    [anon_sym_namespace] = ACTIONS(1946),
    [anon_sym_using] = ACTIONS(1946),
    [anon_sym_static_assert] = ACTIONS(1946),
    [anon_sym_concept] = ACTIONS(1946),
    [anon_sym_co_return] = ACTIONS(1946),
    [anon_sym_co_yield] = ACTIONS(1946),
    [anon_sym_R_DQUOTE] = ACTIONS(1948),
    [anon_sym_LR_DQUOTE] = ACTIONS(1948),
    [anon_sym_uR_DQUOTE] = ACTIONS(1948),
    [anon_sym_UR_DQUOTE] = ACTIONS(1948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1948),
    [anon_sym_co_await] = ACTIONS(1946),
    [anon_sym_new] = ACTIONS(1946),
    [anon_sym_requires] = ACTIONS(1946),
    [sym_this] = ACTIONS(1946),
    [anon_sym___launch_bounds__] = ACTIONS(1946),
  },
  [145] = {
    [sym_identifier] = ACTIONS(1950),
    [aux_sym_preproc_include_token1] = ACTIONS(1950),
    [aux_sym_preproc_def_token1] = ACTIONS(1950),
    [aux_sym_preproc_if_token1] = ACTIONS(1950),
    [aux_sym_preproc_if_token2] = ACTIONS(1950),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1950),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1950),
    [aux_sym_preproc_else_token1] = ACTIONS(1950),
    [aux_sym_preproc_elif_token1] = ACTIONS(1950),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1950),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1950),
    [sym_preproc_directive] = ACTIONS(1950),
    [anon_sym_LPAREN2] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1952),
    [anon_sym_TILDE] = ACTIONS(1952),
    [anon_sym_DASH] = ACTIONS(1950),
    [anon_sym_PLUS] = ACTIONS(1950),
    [anon_sym_STAR] = ACTIONS(1952),
    [anon_sym_AMP_AMP] = ACTIONS(1952),
    [anon_sym_AMP] = ACTIONS(1950),
    [anon_sym_SEMI] = ACTIONS(1952),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_typedef] = ACTIONS(1950),
    [anon_sym___device__] = ACTIONS(1950),
    [anon_sym___host__] = ACTIONS(1950),
    [anon_sym___global__] = ACTIONS(1950),
    [anon_sym___forceinline__] = ACTIONS(1950),
    [anon_sym___noinline__] = ACTIONS(1950),
    [anon_sym_extern] = ACTIONS(1950),
    [anon_sym___attribute__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1952),
    [anon_sym___declspec] = ACTIONS(1950),
    [anon_sym___based] = ACTIONS(1950),
    [anon_sym___cdecl] = ACTIONS(1950),
    [anon_sym___clrcall] = ACTIONS(1950),
    [anon_sym___stdcall] = ACTIONS(1950),
    [anon_sym___fastcall] = ACTIONS(1950),
    [anon_sym___thiscall] = ACTIONS(1950),
    [anon_sym___vectorcall] = ACTIONS(1950),
    [anon_sym_LBRACE] = ACTIONS(1952),
    [anon_sym_signed] = ACTIONS(1950),
    [anon_sym_unsigned] = ACTIONS(1950),
    [anon_sym_long] = ACTIONS(1950),
    [anon_sym_short] = ACTIONS(1950),
    [anon_sym_LBRACK] = ACTIONS(1950),
    [anon_sym_static] = ACTIONS(1950),
    [anon_sym_register] = ACTIONS(1950),
    [anon_sym_inline] = ACTIONS(1950),
    [anon_sym___inline] = ACTIONS(1950),
    [anon_sym___inline__] = ACTIONS(1950),
    [anon_sym___forceinline] = ACTIONS(1950),
    [anon_sym_thread_local] = ACTIONS(1950),
    [anon_sym___thread] = ACTIONS(1950),
    [anon_sym_const] = ACTIONS(1950),
    [anon_sym_constexpr] = ACTIONS(1950),
    [anon_sym_volatile] = ACTIONS(1950),
    [anon_sym_restrict] = ACTIONS(1950),
    [anon_sym___restrict__] = ACTIONS(1950),
    [anon_sym__Atomic] = ACTIONS(1950),
    [anon_sym__Noreturn] = ACTIONS(1950),
    [anon_sym_noreturn] = ACTIONS(1950),
    [anon_sym_mutable] = ACTIONS(1950),
    [anon_sym_constinit] = ACTIONS(1950),
    [anon_sym_consteval] = ACTIONS(1950),
    [anon_sym___shared__] = ACTIONS(1950),
    [anon_sym___local__] = ACTIONS(1950),
    [anon_sym___constant__] = ACTIONS(1950),
    [anon_sym___managed__] = ACTIONS(1950),
    [anon_sym___grid_constant__] = ACTIONS(1950),
    [anon_sym_alignas] = ACTIONS(1950),
    [anon_sym__Alignas] = ACTIONS(1950),
    [sym_primitive_type] = ACTIONS(1950),
    [anon_sym_enum] = ACTIONS(1950),
    [anon_sym_class] = ACTIONS(1950),
    [anon_sym_struct] = ACTIONS(1950),
    [anon_sym_union] = ACTIONS(1950),
    [anon_sym_if] = ACTIONS(1950),
    [anon_sym_else] = ACTIONS(1950),
    [anon_sym_switch] = ACTIONS(1950),
    [anon_sym_case] = ACTIONS(1950),
    [anon_sym_default] = ACTIONS(1950),
    [anon_sym_while] = ACTIONS(1950),
    [anon_sym_do] = ACTIONS(1950),
    [anon_sym_for] = ACTIONS(1950),
    [anon_sym_return] = ACTIONS(1950),
    [anon_sym_break] = ACTIONS(1950),
    [anon_sym_continue] = ACTIONS(1950),
    [anon_sym_goto] = ACTIONS(1950),
    [anon_sym___try] = ACTIONS(1950),
    [anon_sym___leave] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1950),
    [anon_sym_compl] = ACTIONS(1950),
    [anon_sym_DASH_DASH] = ACTIONS(1952),
    [anon_sym_PLUS_PLUS] = ACTIONS(1952),
    [anon_sym_sizeof] = ACTIONS(1950),
    [anon_sym___alignof__] = ACTIONS(1950),
    [anon_sym___alignof] = ACTIONS(1950),
    [anon_sym__alignof] = ACTIONS(1950),
    [anon_sym_alignof] = ACTIONS(1950),
    [anon_sym__Alignof] = ACTIONS(1950),
    [anon_sym_offsetof] = ACTIONS(1950),
    [anon_sym__Generic] = ACTIONS(1950),
    [anon_sym_asm] = ACTIONS(1950),
    [anon_sym___asm__] = ACTIONS(1950),
    [sym_number_literal] = ACTIONS(1952),
    [anon_sym_L_SQUOTE] = ACTIONS(1952),
    [anon_sym_u_SQUOTE] = ACTIONS(1952),
    [anon_sym_U_SQUOTE] = ACTIONS(1952),
    [anon_sym_u8_SQUOTE] = ACTIONS(1952),
    [anon_sym_SQUOTE] = ACTIONS(1952),
    [anon_sym_L_DQUOTE] = ACTIONS(1952),
    [anon_sym_u_DQUOTE] = ACTIONS(1952),
    [anon_sym_U_DQUOTE] = ACTIONS(1952),
    [anon_sym_u8_DQUOTE] = ACTIONS(1952),
    [anon_sym_DQUOTE] = ACTIONS(1952),
    [sym_true] = ACTIONS(1950),
    [sym_false] = ACTIONS(1950),
    [anon_sym_NULL] = ACTIONS(1950),
    [anon_sym_nullptr] = ACTIONS(1950),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1950),
    [anon_sym_decltype] = ACTIONS(1950),
    [sym_virtual] = ACTIONS(1950),
    [anon_sym_explicit] = ACTIONS(1950),
    [anon_sym_typename] = ACTIONS(1950),
    [anon_sym_template] = ACTIONS(1950),
    [anon_sym_operator] = ACTIONS(1950),
    [anon_sym_try] = ACTIONS(1950),
    [anon_sym_delete] = ACTIONS(1950),
    [anon_sym_throw] = ACTIONS(1950),
    [anon_sym_namespace] = ACTIONS(1950),
    [anon_sym_using] = ACTIONS(1950),
    [anon_sym_static_assert] = ACTIONS(1950),
    [anon_sym_concept] = ACTIONS(1950),
    [anon_sym_co_return] = ACTIONS(1950),
    [anon_sym_co_yield] = ACTIONS(1950),
    [anon_sym_R_DQUOTE] = ACTIONS(1952),
    [anon_sym_LR_DQUOTE] = ACTIONS(1952),
    [anon_sym_uR_DQUOTE] = ACTIONS(1952),
    [anon_sym_UR_DQUOTE] = ACTIONS(1952),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1952),
    [anon_sym_co_await] = ACTIONS(1950),
    [anon_sym_new] = ACTIONS(1950),
    [anon_sym_requires] = ACTIONS(1950),
    [sym_this] = ACTIONS(1950),
    [anon_sym___launch_bounds__] = ACTIONS(1950),
  },
  [146] = {
    [sym_identifier] = ACTIONS(1942),
    [aux_sym_preproc_include_token1] = ACTIONS(1942),
    [aux_sym_preproc_def_token1] = ACTIONS(1942),
    [aux_sym_preproc_if_token1] = ACTIONS(1942),
    [aux_sym_preproc_if_token2] = ACTIONS(1942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1942),
    [aux_sym_preproc_else_token1] = ACTIONS(1942),
    [aux_sym_preproc_elif_token1] = ACTIONS(1942),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1942),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1942),
    [sym_preproc_directive] = ACTIONS(1942),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(1944),
    [anon_sym_TILDE] = ACTIONS(1944),
    [anon_sym_DASH] = ACTIONS(1942),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym_SEMI] = ACTIONS(1944),
    [anon_sym___extension__] = ACTIONS(1942),
    [anon_sym_typedef] = ACTIONS(1942),
    [anon_sym___device__] = ACTIONS(1942),
    [anon_sym___host__] = ACTIONS(1942),
    [anon_sym___global__] = ACTIONS(1942),
    [anon_sym___forceinline__] = ACTIONS(1942),
    [anon_sym___noinline__] = ACTIONS(1942),
    [anon_sym_extern] = ACTIONS(1942),
    [anon_sym___attribute__] = ACTIONS(1942),
    [anon_sym_COLON_COLON] = ACTIONS(1944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1944),
    [anon_sym___declspec] = ACTIONS(1942),
    [anon_sym___based] = ACTIONS(1942),
    [anon_sym___cdecl] = ACTIONS(1942),
    [anon_sym___clrcall] = ACTIONS(1942),
    [anon_sym___stdcall] = ACTIONS(1942),
    [anon_sym___fastcall] = ACTIONS(1942),
    [anon_sym___thiscall] = ACTIONS(1942),
    [anon_sym___vectorcall] = ACTIONS(1942),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_signed] = ACTIONS(1942),
    [anon_sym_unsigned] = ACTIONS(1942),
    [anon_sym_long] = ACTIONS(1942),
    [anon_sym_short] = ACTIONS(1942),
    [anon_sym_LBRACK] = ACTIONS(1942),
    [anon_sym_static] = ACTIONS(1942),
    [anon_sym_register] = ACTIONS(1942),
    [anon_sym_inline] = ACTIONS(1942),
    [anon_sym___inline] = ACTIONS(1942),
    [anon_sym___inline__] = ACTIONS(1942),
    [anon_sym___forceinline] = ACTIONS(1942),
    [anon_sym_thread_local] = ACTIONS(1942),
    [anon_sym___thread] = ACTIONS(1942),
    [anon_sym_const] = ACTIONS(1942),
    [anon_sym_constexpr] = ACTIONS(1942),
    [anon_sym_volatile] = ACTIONS(1942),
    [anon_sym_restrict] = ACTIONS(1942),
    [anon_sym___restrict__] = ACTIONS(1942),
    [anon_sym__Atomic] = ACTIONS(1942),
    [anon_sym__Noreturn] = ACTIONS(1942),
    [anon_sym_noreturn] = ACTIONS(1942),
    [anon_sym_mutable] = ACTIONS(1942),
    [anon_sym_constinit] = ACTIONS(1942),
    [anon_sym_consteval] = ACTIONS(1942),
    [anon_sym___shared__] = ACTIONS(1942),
    [anon_sym___local__] = ACTIONS(1942),
    [anon_sym___constant__] = ACTIONS(1942),
    [anon_sym___managed__] = ACTIONS(1942),
    [anon_sym___grid_constant__] = ACTIONS(1942),
    [anon_sym_alignas] = ACTIONS(1942),
    [anon_sym__Alignas] = ACTIONS(1942),
    [sym_primitive_type] = ACTIONS(1942),
    [anon_sym_enum] = ACTIONS(1942),
    [anon_sym_class] = ACTIONS(1942),
    [anon_sym_struct] = ACTIONS(1942),
    [anon_sym_union] = ACTIONS(1942),
    [anon_sym_if] = ACTIONS(1942),
    [anon_sym_else] = ACTIONS(1942),
    [anon_sym_switch] = ACTIONS(1942),
    [anon_sym_case] = ACTIONS(1942),
    [anon_sym_default] = ACTIONS(1942),
    [anon_sym_while] = ACTIONS(1942),
    [anon_sym_do] = ACTIONS(1942),
    [anon_sym_for] = ACTIONS(1942),
    [anon_sym_return] = ACTIONS(1942),
    [anon_sym_break] = ACTIONS(1942),
    [anon_sym_continue] = ACTIONS(1942),
    [anon_sym_goto] = ACTIONS(1942),
    [anon_sym___try] = ACTIONS(1942),
    [anon_sym___leave] = ACTIONS(1942),
    [anon_sym_not] = ACTIONS(1942),
    [anon_sym_compl] = ACTIONS(1942),
    [anon_sym_DASH_DASH] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1944),
    [anon_sym_sizeof] = ACTIONS(1942),
    [anon_sym___alignof__] = ACTIONS(1942),
    [anon_sym___alignof] = ACTIONS(1942),
    [anon_sym__alignof] = ACTIONS(1942),
    [anon_sym_alignof] = ACTIONS(1942),
    [anon_sym__Alignof] = ACTIONS(1942),
    [anon_sym_offsetof] = ACTIONS(1942),
    [anon_sym__Generic] = ACTIONS(1942),
    [anon_sym_asm] = ACTIONS(1942),
    [anon_sym___asm__] = ACTIONS(1942),
    [sym_number_literal] = ACTIONS(1944),
    [anon_sym_L_SQUOTE] = ACTIONS(1944),
    [anon_sym_u_SQUOTE] = ACTIONS(1944),
    [anon_sym_U_SQUOTE] = ACTIONS(1944),
    [anon_sym_u8_SQUOTE] = ACTIONS(1944),
    [anon_sym_SQUOTE] = ACTIONS(1944),
    [anon_sym_L_DQUOTE] = ACTIONS(1944),
    [anon_sym_u_DQUOTE] = ACTIONS(1944),
    [anon_sym_U_DQUOTE] = ACTIONS(1944),
    [anon_sym_u8_DQUOTE] = ACTIONS(1944),
    [anon_sym_DQUOTE] = ACTIONS(1944),
    [sym_true] = ACTIONS(1942),
    [sym_false] = ACTIONS(1942),
    [anon_sym_NULL] = ACTIONS(1942),
    [anon_sym_nullptr] = ACTIONS(1942),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1942),
    [anon_sym_decltype] = ACTIONS(1942),
    [sym_virtual] = ACTIONS(1942),
    [anon_sym_explicit] = ACTIONS(1942),
    [anon_sym_typename] = ACTIONS(1942),
    [anon_sym_template] = ACTIONS(1942),
    [anon_sym_operator] = ACTIONS(1942),
    [anon_sym_try] = ACTIONS(1942),
    [anon_sym_delete] = ACTIONS(1942),
    [anon_sym_throw] = ACTIONS(1942),
    [anon_sym_namespace] = ACTIONS(1942),
    [anon_sym_using] = ACTIONS(1942),
    [anon_sym_static_assert] = ACTIONS(1942),
    [anon_sym_concept] = ACTIONS(1942),
    [anon_sym_co_return] = ACTIONS(1942),
    [anon_sym_co_yield] = ACTIONS(1942),
    [anon_sym_R_DQUOTE] = ACTIONS(1944),
    [anon_sym_LR_DQUOTE] = ACTIONS(1944),
    [anon_sym_uR_DQUOTE] = ACTIONS(1944),
    [anon_sym_UR_DQUOTE] = ACTIONS(1944),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1944),
    [anon_sym_co_await] = ACTIONS(1942),
    [anon_sym_new] = ACTIONS(1942),
    [anon_sym_requires] = ACTIONS(1942),
    [sym_this] = ACTIONS(1942),
    [anon_sym___launch_bounds__] = ACTIONS(1942),
  },
  [147] = {
    [sym_identifier] = ACTIONS(1954),
    [aux_sym_preproc_include_token1] = ACTIONS(1954),
    [aux_sym_preproc_def_token1] = ACTIONS(1954),
    [aux_sym_preproc_if_token1] = ACTIONS(1954),
    [aux_sym_preproc_if_token2] = ACTIONS(1954),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1954),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1954),
    [aux_sym_preproc_else_token1] = ACTIONS(1954),
    [aux_sym_preproc_elif_token1] = ACTIONS(1954),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1954),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1954),
    [sym_preproc_directive] = ACTIONS(1954),
    [anon_sym_LPAREN2] = ACTIONS(1956),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [anon_sym_DASH] = ACTIONS(1954),
    [anon_sym_PLUS] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(1956),
    [anon_sym_AMP_AMP] = ACTIONS(1956),
    [anon_sym_AMP] = ACTIONS(1954),
    [anon_sym_SEMI] = ACTIONS(1956),
    [anon_sym___extension__] = ACTIONS(1954),
    [anon_sym_typedef] = ACTIONS(1954),
    [anon_sym___device__] = ACTIONS(1954),
    [anon_sym___host__] = ACTIONS(1954),
    [anon_sym___global__] = ACTIONS(1954),
    [anon_sym___forceinline__] = ACTIONS(1954),
    [anon_sym___noinline__] = ACTIONS(1954),
    [anon_sym_extern] = ACTIONS(1954),
    [anon_sym___attribute__] = ACTIONS(1954),
    [anon_sym_COLON_COLON] = ACTIONS(1956),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1956),
    [anon_sym___declspec] = ACTIONS(1954),
    [anon_sym___based] = ACTIONS(1954),
    [anon_sym___cdecl] = ACTIONS(1954),
    [anon_sym___clrcall] = ACTIONS(1954),
    [anon_sym___stdcall] = ACTIONS(1954),
    [anon_sym___fastcall] = ACTIONS(1954),
    [anon_sym___thiscall] = ACTIONS(1954),
    [anon_sym___vectorcall] = ACTIONS(1954),
    [anon_sym_LBRACE] = ACTIONS(1956),
    [anon_sym_signed] = ACTIONS(1954),
    [anon_sym_unsigned] = ACTIONS(1954),
    [anon_sym_long] = ACTIONS(1954),
    [anon_sym_short] = ACTIONS(1954),
    [anon_sym_LBRACK] = ACTIONS(1954),
    [anon_sym_static] = ACTIONS(1954),
    [anon_sym_register] = ACTIONS(1954),
    [anon_sym_inline] = ACTIONS(1954),
    [anon_sym___inline] = ACTIONS(1954),
    [anon_sym___inline__] = ACTIONS(1954),
    [anon_sym___forceinline] = ACTIONS(1954),
    [anon_sym_thread_local] = ACTIONS(1954),
    [anon_sym___thread] = ACTIONS(1954),
    [anon_sym_const] = ACTIONS(1954),
    [anon_sym_constexpr] = ACTIONS(1954),
    [anon_sym_volatile] = ACTIONS(1954),
    [anon_sym_restrict] = ACTIONS(1954),
    [anon_sym___restrict__] = ACTIONS(1954),
    [anon_sym__Atomic] = ACTIONS(1954),
    [anon_sym__Noreturn] = ACTIONS(1954),
    [anon_sym_noreturn] = ACTIONS(1954),
    [anon_sym_mutable] = ACTIONS(1954),
    [anon_sym_constinit] = ACTIONS(1954),
    [anon_sym_consteval] = ACTIONS(1954),
    [anon_sym___shared__] = ACTIONS(1954),
    [anon_sym___local__] = ACTIONS(1954),
    [anon_sym___constant__] = ACTIONS(1954),
    [anon_sym___managed__] = ACTIONS(1954),
    [anon_sym___grid_constant__] = ACTIONS(1954),
    [anon_sym_alignas] = ACTIONS(1954),
    [anon_sym__Alignas] = ACTIONS(1954),
    [sym_primitive_type] = ACTIONS(1954),
    [anon_sym_enum] = ACTIONS(1954),
    [anon_sym_class] = ACTIONS(1954),
    [anon_sym_struct] = ACTIONS(1954),
    [anon_sym_union] = ACTIONS(1954),
    [anon_sym_if] = ACTIONS(1954),
    [anon_sym_else] = ACTIONS(1954),
    [anon_sym_switch] = ACTIONS(1954),
    [anon_sym_case] = ACTIONS(1954),
    [anon_sym_default] = ACTIONS(1954),
    [anon_sym_while] = ACTIONS(1954),
    [anon_sym_do] = ACTIONS(1954),
    [anon_sym_for] = ACTIONS(1954),
    [anon_sym_return] = ACTIONS(1954),
    [anon_sym_break] = ACTIONS(1954),
    [anon_sym_continue] = ACTIONS(1954),
    [anon_sym_goto] = ACTIONS(1954),
    [anon_sym___try] = ACTIONS(1954),
    [anon_sym___leave] = ACTIONS(1954),
    [anon_sym_not] = ACTIONS(1954),
    [anon_sym_compl] = ACTIONS(1954),
    [anon_sym_DASH_DASH] = ACTIONS(1956),
    [anon_sym_PLUS_PLUS] = ACTIONS(1956),
    [anon_sym_sizeof] = ACTIONS(1954),
    [anon_sym___alignof__] = ACTIONS(1954),
    [anon_sym___alignof] = ACTIONS(1954),
    [anon_sym__alignof] = ACTIONS(1954),
    [anon_sym_alignof] = ACTIONS(1954),
    [anon_sym__Alignof] = ACTIONS(1954),
    [anon_sym_offsetof] = ACTIONS(1954),
    [anon_sym__Generic] = ACTIONS(1954),
    [anon_sym_asm] = ACTIONS(1954),
    [anon_sym___asm__] = ACTIONS(1954),
    [sym_number_literal] = ACTIONS(1956),
    [anon_sym_L_SQUOTE] = ACTIONS(1956),
    [anon_sym_u_SQUOTE] = ACTIONS(1956),
    [anon_sym_U_SQUOTE] = ACTIONS(1956),
    [anon_sym_u8_SQUOTE] = ACTIONS(1956),
    [anon_sym_SQUOTE] = ACTIONS(1956),
    [anon_sym_L_DQUOTE] = ACTIONS(1956),
    [anon_sym_u_DQUOTE] = ACTIONS(1956),
    [anon_sym_U_DQUOTE] = ACTIONS(1956),
    [anon_sym_u8_DQUOTE] = ACTIONS(1956),
    [anon_sym_DQUOTE] = ACTIONS(1956),
    [sym_true] = ACTIONS(1954),
    [sym_false] = ACTIONS(1954),
    [anon_sym_NULL] = ACTIONS(1954),
    [anon_sym_nullptr] = ACTIONS(1954),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1954),
    [anon_sym_decltype] = ACTIONS(1954),
    [sym_virtual] = ACTIONS(1954),
    [anon_sym_explicit] = ACTIONS(1954),
    [anon_sym_typename] = ACTIONS(1954),
    [anon_sym_template] = ACTIONS(1954),
    [anon_sym_operator] = ACTIONS(1954),
    [anon_sym_try] = ACTIONS(1954),
    [anon_sym_delete] = ACTIONS(1954),
    [anon_sym_throw] = ACTIONS(1954),
    [anon_sym_namespace] = ACTIONS(1954),
    [anon_sym_using] = ACTIONS(1954),
    [anon_sym_static_assert] = ACTIONS(1954),
    [anon_sym_concept] = ACTIONS(1954),
    [anon_sym_co_return] = ACTIONS(1954),
    [anon_sym_co_yield] = ACTIONS(1954),
    [anon_sym_R_DQUOTE] = ACTIONS(1956),
    [anon_sym_LR_DQUOTE] = ACTIONS(1956),
    [anon_sym_uR_DQUOTE] = ACTIONS(1956),
    [anon_sym_UR_DQUOTE] = ACTIONS(1956),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1956),
    [anon_sym_co_await] = ACTIONS(1954),
    [anon_sym_new] = ACTIONS(1954),
    [anon_sym_requires] = ACTIONS(1954),
    [sym_this] = ACTIONS(1954),
    [anon_sym___launch_bounds__] = ACTIONS(1954),
  },
  [148] = {
    [sym_identifier] = ACTIONS(1958),
    [aux_sym_preproc_include_token1] = ACTIONS(1958),
    [aux_sym_preproc_def_token1] = ACTIONS(1958),
    [aux_sym_preproc_if_token1] = ACTIONS(1958),
    [aux_sym_preproc_if_token2] = ACTIONS(1958),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1958),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1958),
    [aux_sym_preproc_else_token1] = ACTIONS(1958),
    [aux_sym_preproc_elif_token1] = ACTIONS(1958),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1958),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1958),
    [sym_preproc_directive] = ACTIONS(1958),
    [anon_sym_LPAREN2] = ACTIONS(1960),
    [anon_sym_BANG] = ACTIONS(1960),
    [anon_sym_TILDE] = ACTIONS(1960),
    [anon_sym_DASH] = ACTIONS(1958),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_STAR] = ACTIONS(1960),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1958),
    [anon_sym_SEMI] = ACTIONS(1960),
    [anon_sym___extension__] = ACTIONS(1958),
    [anon_sym_typedef] = ACTIONS(1958),
    [anon_sym___device__] = ACTIONS(1958),
    [anon_sym___host__] = ACTIONS(1958),
    [anon_sym___global__] = ACTIONS(1958),
    [anon_sym___forceinline__] = ACTIONS(1958),
    [anon_sym___noinline__] = ACTIONS(1958),
    [anon_sym_extern] = ACTIONS(1958),
    [anon_sym___attribute__] = ACTIONS(1958),
    [anon_sym_COLON_COLON] = ACTIONS(1960),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1960),
    [anon_sym___declspec] = ACTIONS(1958),
    [anon_sym___based] = ACTIONS(1958),
    [anon_sym___cdecl] = ACTIONS(1958),
    [anon_sym___clrcall] = ACTIONS(1958),
    [anon_sym___stdcall] = ACTIONS(1958),
    [anon_sym___fastcall] = ACTIONS(1958),
    [anon_sym___thiscall] = ACTIONS(1958),
    [anon_sym___vectorcall] = ACTIONS(1958),
    [anon_sym_LBRACE] = ACTIONS(1960),
    [anon_sym_signed] = ACTIONS(1958),
    [anon_sym_unsigned] = ACTIONS(1958),
    [anon_sym_long] = ACTIONS(1958),
    [anon_sym_short] = ACTIONS(1958),
    [anon_sym_LBRACK] = ACTIONS(1958),
    [anon_sym_static] = ACTIONS(1958),
    [anon_sym_register] = ACTIONS(1958),
    [anon_sym_inline] = ACTIONS(1958),
    [anon_sym___inline] = ACTIONS(1958),
    [anon_sym___inline__] = ACTIONS(1958),
    [anon_sym___forceinline] = ACTIONS(1958),
    [anon_sym_thread_local] = ACTIONS(1958),
    [anon_sym___thread] = ACTIONS(1958),
    [anon_sym_const] = ACTIONS(1958),
    [anon_sym_constexpr] = ACTIONS(1958),
    [anon_sym_volatile] = ACTIONS(1958),
    [anon_sym_restrict] = ACTIONS(1958),
    [anon_sym___restrict__] = ACTIONS(1958),
    [anon_sym__Atomic] = ACTIONS(1958),
    [anon_sym__Noreturn] = ACTIONS(1958),
    [anon_sym_noreturn] = ACTIONS(1958),
    [anon_sym_mutable] = ACTIONS(1958),
    [anon_sym_constinit] = ACTIONS(1958),
    [anon_sym_consteval] = ACTIONS(1958),
    [anon_sym___shared__] = ACTIONS(1958),
    [anon_sym___local__] = ACTIONS(1958),
    [anon_sym___constant__] = ACTIONS(1958),
    [anon_sym___managed__] = ACTIONS(1958),
    [anon_sym___grid_constant__] = ACTIONS(1958),
    [anon_sym_alignas] = ACTIONS(1958),
    [anon_sym__Alignas] = ACTIONS(1958),
    [sym_primitive_type] = ACTIONS(1958),
    [anon_sym_enum] = ACTIONS(1958),
    [anon_sym_class] = ACTIONS(1958),
    [anon_sym_struct] = ACTIONS(1958),
    [anon_sym_union] = ACTIONS(1958),
    [anon_sym_if] = ACTIONS(1958),
    [anon_sym_else] = ACTIONS(1958),
    [anon_sym_switch] = ACTIONS(1958),
    [anon_sym_case] = ACTIONS(1958),
    [anon_sym_default] = ACTIONS(1958),
    [anon_sym_while] = ACTIONS(1958),
    [anon_sym_do] = ACTIONS(1958),
    [anon_sym_for] = ACTIONS(1958),
    [anon_sym_return] = ACTIONS(1958),
    [anon_sym_break] = ACTIONS(1958),
    [anon_sym_continue] = ACTIONS(1958),
    [anon_sym_goto] = ACTIONS(1958),
    [anon_sym___try] = ACTIONS(1958),
    [anon_sym___leave] = ACTIONS(1958),
    [anon_sym_not] = ACTIONS(1958),
    [anon_sym_compl] = ACTIONS(1958),
    [anon_sym_DASH_DASH] = ACTIONS(1960),
    [anon_sym_PLUS_PLUS] = ACTIONS(1960),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1958),
    [anon_sym___alignof] = ACTIONS(1958),
    [anon_sym__alignof] = ACTIONS(1958),
    [anon_sym_alignof] = ACTIONS(1958),
    [anon_sym__Alignof] = ACTIONS(1958),
    [anon_sym_offsetof] = ACTIONS(1958),
    [anon_sym__Generic] = ACTIONS(1958),
    [anon_sym_asm] = ACTIONS(1958),
    [anon_sym___asm__] = ACTIONS(1958),
    [sym_number_literal] = ACTIONS(1960),
    [anon_sym_L_SQUOTE] = ACTIONS(1960),
    [anon_sym_u_SQUOTE] = ACTIONS(1960),
    [anon_sym_U_SQUOTE] = ACTIONS(1960),
    [anon_sym_u8_SQUOTE] = ACTIONS(1960),
    [anon_sym_SQUOTE] = ACTIONS(1960),
    [anon_sym_L_DQUOTE] = ACTIONS(1960),
    [anon_sym_u_DQUOTE] = ACTIONS(1960),
    [anon_sym_U_DQUOTE] = ACTIONS(1960),
    [anon_sym_u8_DQUOTE] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [sym_true] = ACTIONS(1958),
    [sym_false] = ACTIONS(1958),
    [anon_sym_NULL] = ACTIONS(1958),
    [anon_sym_nullptr] = ACTIONS(1958),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1958),
    [anon_sym_decltype] = ACTIONS(1958),
    [sym_virtual] = ACTIONS(1958),
    [anon_sym_explicit] = ACTIONS(1958),
    [anon_sym_typename] = ACTIONS(1958),
    [anon_sym_template] = ACTIONS(1958),
    [anon_sym_operator] = ACTIONS(1958),
    [anon_sym_try] = ACTIONS(1958),
    [anon_sym_delete] = ACTIONS(1958),
    [anon_sym_throw] = ACTIONS(1958),
    [anon_sym_namespace] = ACTIONS(1958),
    [anon_sym_using] = ACTIONS(1958),
    [anon_sym_static_assert] = ACTIONS(1958),
    [anon_sym_concept] = ACTIONS(1958),
    [anon_sym_co_return] = ACTIONS(1958),
    [anon_sym_co_yield] = ACTIONS(1958),
    [anon_sym_R_DQUOTE] = ACTIONS(1960),
    [anon_sym_LR_DQUOTE] = ACTIONS(1960),
    [anon_sym_uR_DQUOTE] = ACTIONS(1960),
    [anon_sym_UR_DQUOTE] = ACTIONS(1960),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1960),
    [anon_sym_co_await] = ACTIONS(1958),
    [anon_sym_new] = ACTIONS(1958),
    [anon_sym_requires] = ACTIONS(1958),
    [sym_this] = ACTIONS(1958),
    [anon_sym___launch_bounds__] = ACTIONS(1958),
  },
  [149] = {
    [sym_identifier] = ACTIONS(1901),
    [aux_sym_preproc_include_token1] = ACTIONS(1901),
    [aux_sym_preproc_def_token1] = ACTIONS(1901),
    [anon_sym_COMMA] = ACTIONS(1962),
    [aux_sym_preproc_if_token1] = ACTIONS(1901),
    [aux_sym_preproc_if_token2] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1901),
    [aux_sym_preproc_else_token1] = ACTIONS(1901),
    [aux_sym_preproc_elif_token1] = ACTIONS(1901),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1901),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1901),
    [sym_preproc_directive] = ACTIONS(1901),
    [anon_sym_LPAREN2] = ACTIONS(1899),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_DASH] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1901),
    [anon_sym_STAR] = ACTIONS(1899),
    [anon_sym_AMP_AMP] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1901),
    [anon_sym_SEMI] = ACTIONS(1962),
    [anon_sym___extension__] = ACTIONS(1901),
    [anon_sym_typedef] = ACTIONS(1901),
    [anon_sym___device__] = ACTIONS(1901),
    [anon_sym___host__] = ACTIONS(1901),
    [anon_sym___global__] = ACTIONS(1901),
    [anon_sym___forceinline__] = ACTIONS(1901),
    [anon_sym___noinline__] = ACTIONS(1901),
    [anon_sym_extern] = ACTIONS(1901),
    [anon_sym___attribute__] = ACTIONS(1901),
    [anon_sym_COLON_COLON] = ACTIONS(1899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1899),
    [anon_sym___declspec] = ACTIONS(1901),
    [anon_sym___based] = ACTIONS(1901),
    [anon_sym___cdecl] = ACTIONS(1901),
    [anon_sym___clrcall] = ACTIONS(1901),
    [anon_sym___stdcall] = ACTIONS(1901),
    [anon_sym___fastcall] = ACTIONS(1901),
    [anon_sym___thiscall] = ACTIONS(1901),
    [anon_sym___vectorcall] = ACTIONS(1901),
    [anon_sym_LBRACE] = ACTIONS(1899),
    [anon_sym_signed] = ACTIONS(1901),
    [anon_sym_unsigned] = ACTIONS(1901),
    [anon_sym_long] = ACTIONS(1901),
    [anon_sym_short] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1901),
    [anon_sym_static] = ACTIONS(1901),
    [anon_sym_register] = ACTIONS(1901),
    [anon_sym_inline] = ACTIONS(1901),
    [anon_sym___inline] = ACTIONS(1901),
    [anon_sym___inline__] = ACTIONS(1901),
    [anon_sym___forceinline] = ACTIONS(1901),
    [anon_sym_thread_local] = ACTIONS(1901),
    [anon_sym___thread] = ACTIONS(1901),
    [anon_sym_const] = ACTIONS(1901),
    [anon_sym_constexpr] = ACTIONS(1901),
    [anon_sym_volatile] = ACTIONS(1901),
    [anon_sym_restrict] = ACTIONS(1901),
    [anon_sym___restrict__] = ACTIONS(1901),
    [anon_sym__Atomic] = ACTIONS(1901),
    [anon_sym__Noreturn] = ACTIONS(1901),
    [anon_sym_noreturn] = ACTIONS(1901),
    [anon_sym_mutable] = ACTIONS(1901),
    [anon_sym_constinit] = ACTIONS(1901),
    [anon_sym_consteval] = ACTIONS(1901),
    [anon_sym___shared__] = ACTIONS(1901),
    [anon_sym___local__] = ACTIONS(1901),
    [anon_sym___constant__] = ACTIONS(1901),
    [anon_sym___managed__] = ACTIONS(1901),
    [anon_sym___grid_constant__] = ACTIONS(1901),
    [anon_sym_alignas] = ACTIONS(1901),
    [anon_sym__Alignas] = ACTIONS(1901),
    [sym_primitive_type] = ACTIONS(1901),
    [anon_sym_enum] = ACTIONS(1901),
    [anon_sym_class] = ACTIONS(1901),
    [anon_sym_struct] = ACTIONS(1901),
    [anon_sym_union] = ACTIONS(1901),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_switch] = ACTIONS(1901),
    [anon_sym_case] = ACTIONS(1901),
    [anon_sym_default] = ACTIONS(1901),
    [anon_sym_while] = ACTIONS(1901),
    [anon_sym_do] = ACTIONS(1901),
    [anon_sym_for] = ACTIONS(1901),
    [anon_sym_return] = ACTIONS(1901),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_continue] = ACTIONS(1901),
    [anon_sym_goto] = ACTIONS(1901),
    [anon_sym___try] = ACTIONS(1901),
    [anon_sym___leave] = ACTIONS(1901),
    [anon_sym_not] = ACTIONS(1901),
    [anon_sym_compl] = ACTIONS(1901),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_sizeof] = ACTIONS(1901),
    [anon_sym___alignof__] = ACTIONS(1901),
    [anon_sym___alignof] = ACTIONS(1901),
    [anon_sym__alignof] = ACTIONS(1901),
    [anon_sym_alignof] = ACTIONS(1901),
    [anon_sym__Alignof] = ACTIONS(1901),
    [anon_sym_offsetof] = ACTIONS(1901),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1901),
    [anon_sym___asm__] = ACTIONS(1901),
    [sym_number_literal] = ACTIONS(1899),
    [anon_sym_L_SQUOTE] = ACTIONS(1899),
    [anon_sym_u_SQUOTE] = ACTIONS(1899),
    [anon_sym_U_SQUOTE] = ACTIONS(1899),
    [anon_sym_u8_SQUOTE] = ACTIONS(1899),
    [anon_sym_SQUOTE] = ACTIONS(1899),
    [anon_sym_L_DQUOTE] = ACTIONS(1899),
    [anon_sym_u_DQUOTE] = ACTIONS(1899),
    [anon_sym_U_DQUOTE] = ACTIONS(1899),
    [anon_sym_u8_DQUOTE] = ACTIONS(1899),
    [anon_sym_DQUOTE] = ACTIONS(1899),
    [sym_true] = ACTIONS(1901),
    [sym_false] = ACTIONS(1901),
    [anon_sym_NULL] = ACTIONS(1901),
    [anon_sym_nullptr] = ACTIONS(1901),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1901),
    [anon_sym_decltype] = ACTIONS(1901),
    [sym_virtual] = ACTIONS(1901),
    [anon_sym_explicit] = ACTIONS(1901),
    [anon_sym_typename] = ACTIONS(1901),
    [anon_sym_template] = ACTIONS(1901),
    [anon_sym_operator] = ACTIONS(1901),
    [anon_sym_try] = ACTIONS(1901),
    [anon_sym_delete] = ACTIONS(1901),
    [anon_sym_throw] = ACTIONS(1901),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_using] = ACTIONS(1901),
    [anon_sym_static_assert] = ACTIONS(1901),
    [anon_sym_concept] = ACTIONS(1901),
    [anon_sym_co_return] = ACTIONS(1901),
    [anon_sym_co_yield] = ACTIONS(1901),
    [anon_sym_R_DQUOTE] = ACTIONS(1899),
    [anon_sym_LR_DQUOTE] = ACTIONS(1899),
    [anon_sym_uR_DQUOTE] = ACTIONS(1899),
    [anon_sym_UR_DQUOTE] = ACTIONS(1899),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1899),
    [anon_sym_co_await] = ACTIONS(1901),
    [anon_sym_new] = ACTIONS(1901),
    [anon_sym_requires] = ACTIONS(1901),
    [sym_this] = ACTIONS(1901),
    [anon_sym___launch_bounds__] = ACTIONS(1901),
  },
  [150] = {
    [sym_identifier] = ACTIONS(1964),
    [aux_sym_preproc_include_token1] = ACTIONS(1964),
    [aux_sym_preproc_def_token1] = ACTIONS(1964),
    [aux_sym_preproc_if_token1] = ACTIONS(1964),
    [aux_sym_preproc_if_token2] = ACTIONS(1964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1964),
    [aux_sym_preproc_else_token1] = ACTIONS(1964),
    [aux_sym_preproc_elif_token1] = ACTIONS(1964),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1964),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1964),
    [sym_preproc_directive] = ACTIONS(1964),
    [anon_sym_LPAREN2] = ACTIONS(1966),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [anon_sym_DASH] = ACTIONS(1964),
    [anon_sym_PLUS] = ACTIONS(1964),
    [anon_sym_STAR] = ACTIONS(1966),
    [anon_sym_AMP_AMP] = ACTIONS(1966),
    [anon_sym_AMP] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym___extension__] = ACTIONS(1964),
    [anon_sym_typedef] = ACTIONS(1964),
    [anon_sym___device__] = ACTIONS(1964),
    [anon_sym___host__] = ACTIONS(1964),
    [anon_sym___global__] = ACTIONS(1964),
    [anon_sym___forceinline__] = ACTIONS(1964),
    [anon_sym___noinline__] = ACTIONS(1964),
    [anon_sym_extern] = ACTIONS(1964),
    [anon_sym___attribute__] = ACTIONS(1964),
    [anon_sym_COLON_COLON] = ACTIONS(1966),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1966),
    [anon_sym___declspec] = ACTIONS(1964),
    [anon_sym___based] = ACTIONS(1964),
    [anon_sym___cdecl] = ACTIONS(1964),
    [anon_sym___clrcall] = ACTIONS(1964),
    [anon_sym___stdcall] = ACTIONS(1964),
    [anon_sym___fastcall] = ACTIONS(1964),
    [anon_sym___thiscall] = ACTIONS(1964),
    [anon_sym___vectorcall] = ACTIONS(1964),
    [anon_sym_LBRACE] = ACTIONS(1966),
    [anon_sym_signed] = ACTIONS(1964),
    [anon_sym_unsigned] = ACTIONS(1964),
    [anon_sym_long] = ACTIONS(1964),
    [anon_sym_short] = ACTIONS(1964),
    [anon_sym_LBRACK] = ACTIONS(1964),
    [anon_sym_static] = ACTIONS(1964),
    [anon_sym_register] = ACTIONS(1964),
    [anon_sym_inline] = ACTIONS(1964),
    [anon_sym___inline] = ACTIONS(1964),
    [anon_sym___inline__] = ACTIONS(1964),
    [anon_sym___forceinline] = ACTIONS(1964),
    [anon_sym_thread_local] = ACTIONS(1964),
    [anon_sym___thread] = ACTIONS(1964),
    [anon_sym_const] = ACTIONS(1964),
    [anon_sym_constexpr] = ACTIONS(1964),
    [anon_sym_volatile] = ACTIONS(1964),
    [anon_sym_restrict] = ACTIONS(1964),
    [anon_sym___restrict__] = ACTIONS(1964),
    [anon_sym__Atomic] = ACTIONS(1964),
    [anon_sym__Noreturn] = ACTIONS(1964),
    [anon_sym_noreturn] = ACTIONS(1964),
    [anon_sym_mutable] = ACTIONS(1964),
    [anon_sym_constinit] = ACTIONS(1964),
    [anon_sym_consteval] = ACTIONS(1964),
    [anon_sym___shared__] = ACTIONS(1964),
    [anon_sym___local__] = ACTIONS(1964),
    [anon_sym___constant__] = ACTIONS(1964),
    [anon_sym___managed__] = ACTIONS(1964),
    [anon_sym___grid_constant__] = ACTIONS(1964),
    [anon_sym_alignas] = ACTIONS(1964),
    [anon_sym__Alignas] = ACTIONS(1964),
    [sym_primitive_type] = ACTIONS(1964),
    [anon_sym_enum] = ACTIONS(1964),
    [anon_sym_class] = ACTIONS(1964),
    [anon_sym_struct] = ACTIONS(1964),
    [anon_sym_union] = ACTIONS(1964),
    [anon_sym_if] = ACTIONS(1964),
    [anon_sym_else] = ACTIONS(1964),
    [anon_sym_switch] = ACTIONS(1964),
    [anon_sym_case] = ACTIONS(1964),
    [anon_sym_default] = ACTIONS(1964),
    [anon_sym_while] = ACTIONS(1964),
    [anon_sym_do] = ACTIONS(1964),
    [anon_sym_for] = ACTIONS(1964),
    [anon_sym_return] = ACTIONS(1964),
    [anon_sym_break] = ACTIONS(1964),
    [anon_sym_continue] = ACTIONS(1964),
    [anon_sym_goto] = ACTIONS(1964),
    [anon_sym___try] = ACTIONS(1964),
    [anon_sym___leave] = ACTIONS(1964),
    [anon_sym_not] = ACTIONS(1964),
    [anon_sym_compl] = ACTIONS(1964),
    [anon_sym_DASH_DASH] = ACTIONS(1966),
    [anon_sym_PLUS_PLUS] = ACTIONS(1966),
    [anon_sym_sizeof] = ACTIONS(1964),
    [anon_sym___alignof__] = ACTIONS(1964),
    [anon_sym___alignof] = ACTIONS(1964),
    [anon_sym__alignof] = ACTIONS(1964),
    [anon_sym_alignof] = ACTIONS(1964),
    [anon_sym__Alignof] = ACTIONS(1964),
    [anon_sym_offsetof] = ACTIONS(1964),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1964),
    [anon_sym___asm__] = ACTIONS(1964),
    [sym_number_literal] = ACTIONS(1966),
    [anon_sym_L_SQUOTE] = ACTIONS(1966),
    [anon_sym_u_SQUOTE] = ACTIONS(1966),
    [anon_sym_U_SQUOTE] = ACTIONS(1966),
    [anon_sym_u8_SQUOTE] = ACTIONS(1966),
    [anon_sym_SQUOTE] = ACTIONS(1966),
    [anon_sym_L_DQUOTE] = ACTIONS(1966),
    [anon_sym_u_DQUOTE] = ACTIONS(1966),
    [anon_sym_U_DQUOTE] = ACTIONS(1966),
    [anon_sym_u8_DQUOTE] = ACTIONS(1966),
    [anon_sym_DQUOTE] = ACTIONS(1966),
    [sym_true] = ACTIONS(1964),
    [sym_false] = ACTIONS(1964),
    [anon_sym_NULL] = ACTIONS(1964),
    [anon_sym_nullptr] = ACTIONS(1964),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1964),
    [anon_sym_decltype] = ACTIONS(1964),
    [sym_virtual] = ACTIONS(1964),
    [anon_sym_explicit] = ACTIONS(1964),
    [anon_sym_typename] = ACTIONS(1964),
    [anon_sym_template] = ACTIONS(1964),
    [anon_sym_operator] = ACTIONS(1964),
    [anon_sym_try] = ACTIONS(1964),
    [anon_sym_delete] = ACTIONS(1964),
    [anon_sym_throw] = ACTIONS(1964),
    [anon_sym_namespace] = ACTIONS(1964),
    [anon_sym_using] = ACTIONS(1964),
    [anon_sym_static_assert] = ACTIONS(1964),
    [anon_sym_concept] = ACTIONS(1964),
    [anon_sym_co_return] = ACTIONS(1964),
    [anon_sym_co_yield] = ACTIONS(1964),
    [anon_sym_R_DQUOTE] = ACTIONS(1966),
    [anon_sym_LR_DQUOTE] = ACTIONS(1966),
    [anon_sym_uR_DQUOTE] = ACTIONS(1966),
    [anon_sym_UR_DQUOTE] = ACTIONS(1966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1966),
    [anon_sym_co_await] = ACTIONS(1964),
    [anon_sym_new] = ACTIONS(1964),
    [anon_sym_requires] = ACTIONS(1964),
    [sym_this] = ACTIONS(1964),
    [anon_sym___launch_bounds__] = ACTIONS(1964),
  },
  [151] = {
    [sym_identifier] = ACTIONS(1964),
    [aux_sym_preproc_include_token1] = ACTIONS(1964),
    [aux_sym_preproc_def_token1] = ACTIONS(1964),
    [aux_sym_preproc_if_token1] = ACTIONS(1964),
    [aux_sym_preproc_if_token2] = ACTIONS(1964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1964),
    [aux_sym_preproc_else_token1] = ACTIONS(1964),
    [aux_sym_preproc_elif_token1] = ACTIONS(1964),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1964),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1964),
    [sym_preproc_directive] = ACTIONS(1964),
    [anon_sym_LPAREN2] = ACTIONS(1966),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [anon_sym_DASH] = ACTIONS(1964),
    [anon_sym_PLUS] = ACTIONS(1964),
    [anon_sym_STAR] = ACTIONS(1966),
    [anon_sym_AMP_AMP] = ACTIONS(1966),
    [anon_sym_AMP] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym___extension__] = ACTIONS(1964),
    [anon_sym_typedef] = ACTIONS(1964),
    [anon_sym___device__] = ACTIONS(1964),
    [anon_sym___host__] = ACTIONS(1964),
    [anon_sym___global__] = ACTIONS(1964),
    [anon_sym___forceinline__] = ACTIONS(1964),
    [anon_sym___noinline__] = ACTIONS(1964),
    [anon_sym_extern] = ACTIONS(1964),
    [anon_sym___attribute__] = ACTIONS(1964),
    [anon_sym_COLON_COLON] = ACTIONS(1966),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1966),
    [anon_sym___declspec] = ACTIONS(1964),
    [anon_sym___based] = ACTIONS(1964),
    [anon_sym___cdecl] = ACTIONS(1964),
    [anon_sym___clrcall] = ACTIONS(1964),
    [anon_sym___stdcall] = ACTIONS(1964),
    [anon_sym___fastcall] = ACTIONS(1964),
    [anon_sym___thiscall] = ACTIONS(1964),
    [anon_sym___vectorcall] = ACTIONS(1964),
    [anon_sym_LBRACE] = ACTIONS(1966),
    [anon_sym_signed] = ACTIONS(1964),
    [anon_sym_unsigned] = ACTIONS(1964),
    [anon_sym_long] = ACTIONS(1964),
    [anon_sym_short] = ACTIONS(1964),
    [anon_sym_LBRACK] = ACTIONS(1964),
    [anon_sym_static] = ACTIONS(1964),
    [anon_sym_register] = ACTIONS(1964),
    [anon_sym_inline] = ACTIONS(1964),
    [anon_sym___inline] = ACTIONS(1964),
    [anon_sym___inline__] = ACTIONS(1964),
    [anon_sym___forceinline] = ACTIONS(1964),
    [anon_sym_thread_local] = ACTIONS(1964),
    [anon_sym___thread] = ACTIONS(1964),
    [anon_sym_const] = ACTIONS(1964),
    [anon_sym_constexpr] = ACTIONS(1964),
    [anon_sym_volatile] = ACTIONS(1964),
    [anon_sym_restrict] = ACTIONS(1964),
    [anon_sym___restrict__] = ACTIONS(1964),
    [anon_sym__Atomic] = ACTIONS(1964),
    [anon_sym__Noreturn] = ACTIONS(1964),
    [anon_sym_noreturn] = ACTIONS(1964),
    [anon_sym_mutable] = ACTIONS(1964),
    [anon_sym_constinit] = ACTIONS(1964),
    [anon_sym_consteval] = ACTIONS(1964),
    [anon_sym___shared__] = ACTIONS(1964),
    [anon_sym___local__] = ACTIONS(1964),
    [anon_sym___constant__] = ACTIONS(1964),
    [anon_sym___managed__] = ACTIONS(1964),
    [anon_sym___grid_constant__] = ACTIONS(1964),
    [anon_sym_alignas] = ACTIONS(1964),
    [anon_sym__Alignas] = ACTIONS(1964),
    [sym_primitive_type] = ACTIONS(1964),
    [anon_sym_enum] = ACTIONS(1964),
    [anon_sym_class] = ACTIONS(1964),
    [anon_sym_struct] = ACTIONS(1964),
    [anon_sym_union] = ACTIONS(1964),
    [anon_sym_if] = ACTIONS(1964),
    [anon_sym_else] = ACTIONS(1964),
    [anon_sym_switch] = ACTIONS(1964),
    [anon_sym_case] = ACTIONS(1964),
    [anon_sym_default] = ACTIONS(1964),
    [anon_sym_while] = ACTIONS(1964),
    [anon_sym_do] = ACTIONS(1964),
    [anon_sym_for] = ACTIONS(1964),
    [anon_sym_return] = ACTIONS(1964),
    [anon_sym_break] = ACTIONS(1964),
    [anon_sym_continue] = ACTIONS(1964),
    [anon_sym_goto] = ACTIONS(1964),
    [anon_sym___try] = ACTIONS(1964),
    [anon_sym___leave] = ACTIONS(1964),
    [anon_sym_not] = ACTIONS(1964),
    [anon_sym_compl] = ACTIONS(1964),
    [anon_sym_DASH_DASH] = ACTIONS(1966),
    [anon_sym_PLUS_PLUS] = ACTIONS(1966),
    [anon_sym_sizeof] = ACTIONS(1964),
    [anon_sym___alignof__] = ACTIONS(1964),
    [anon_sym___alignof] = ACTIONS(1964),
    [anon_sym__alignof] = ACTIONS(1964),
    [anon_sym_alignof] = ACTIONS(1964),
    [anon_sym__Alignof] = ACTIONS(1964),
    [anon_sym_offsetof] = ACTIONS(1964),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1964),
    [anon_sym___asm__] = ACTIONS(1964),
    [sym_number_literal] = ACTIONS(1966),
    [anon_sym_L_SQUOTE] = ACTIONS(1966),
    [anon_sym_u_SQUOTE] = ACTIONS(1966),
    [anon_sym_U_SQUOTE] = ACTIONS(1966),
    [anon_sym_u8_SQUOTE] = ACTIONS(1966),
    [anon_sym_SQUOTE] = ACTIONS(1966),
    [anon_sym_L_DQUOTE] = ACTIONS(1966),
    [anon_sym_u_DQUOTE] = ACTIONS(1966),
    [anon_sym_U_DQUOTE] = ACTIONS(1966),
    [anon_sym_u8_DQUOTE] = ACTIONS(1966),
    [anon_sym_DQUOTE] = ACTIONS(1966),
    [sym_true] = ACTIONS(1964),
    [sym_false] = ACTIONS(1964),
    [anon_sym_NULL] = ACTIONS(1964),
    [anon_sym_nullptr] = ACTIONS(1964),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1964),
    [anon_sym_decltype] = ACTIONS(1964),
    [sym_virtual] = ACTIONS(1964),
    [anon_sym_explicit] = ACTIONS(1964),
    [anon_sym_typename] = ACTIONS(1964),
    [anon_sym_template] = ACTIONS(1964),
    [anon_sym_operator] = ACTIONS(1964),
    [anon_sym_try] = ACTIONS(1964),
    [anon_sym_delete] = ACTIONS(1964),
    [anon_sym_throw] = ACTIONS(1964),
    [anon_sym_namespace] = ACTIONS(1964),
    [anon_sym_using] = ACTIONS(1964),
    [anon_sym_static_assert] = ACTIONS(1964),
    [anon_sym_concept] = ACTIONS(1964),
    [anon_sym_co_return] = ACTIONS(1964),
    [anon_sym_co_yield] = ACTIONS(1964),
    [anon_sym_R_DQUOTE] = ACTIONS(1966),
    [anon_sym_LR_DQUOTE] = ACTIONS(1966),
    [anon_sym_uR_DQUOTE] = ACTIONS(1966),
    [anon_sym_UR_DQUOTE] = ACTIONS(1966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1966),
    [anon_sym_co_await] = ACTIONS(1964),
    [anon_sym_new] = ACTIONS(1964),
    [anon_sym_requires] = ACTIONS(1964),
    [sym_this] = ACTIONS(1964),
    [anon_sym___launch_bounds__] = ACTIONS(1964),
  },
  [152] = {
    [sym_identifier] = ACTIONS(1968),
    [aux_sym_preproc_include_token1] = ACTIONS(1968),
    [aux_sym_preproc_def_token1] = ACTIONS(1968),
    [aux_sym_preproc_if_token1] = ACTIONS(1968),
    [aux_sym_preproc_if_token2] = ACTIONS(1968),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1968),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1968),
    [aux_sym_preproc_else_token1] = ACTIONS(1968),
    [aux_sym_preproc_elif_token1] = ACTIONS(1968),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1968),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1968),
    [sym_preproc_directive] = ACTIONS(1968),
    [anon_sym_LPAREN2] = ACTIONS(1970),
    [anon_sym_BANG] = ACTIONS(1970),
    [anon_sym_TILDE] = ACTIONS(1970),
    [anon_sym_DASH] = ACTIONS(1968),
    [anon_sym_PLUS] = ACTIONS(1968),
    [anon_sym_STAR] = ACTIONS(1970),
    [anon_sym_AMP_AMP] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(1968),
    [anon_sym_SEMI] = ACTIONS(1970),
    [anon_sym___extension__] = ACTIONS(1968),
    [anon_sym_typedef] = ACTIONS(1968),
    [anon_sym___device__] = ACTIONS(1968),
    [anon_sym___host__] = ACTIONS(1968),
    [anon_sym___global__] = ACTIONS(1968),
    [anon_sym___forceinline__] = ACTIONS(1968),
    [anon_sym___noinline__] = ACTIONS(1968),
    [anon_sym_extern] = ACTIONS(1968),
    [anon_sym___attribute__] = ACTIONS(1968),
    [anon_sym_COLON_COLON] = ACTIONS(1970),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1970),
    [anon_sym___declspec] = ACTIONS(1968),
    [anon_sym___based] = ACTIONS(1968),
    [anon_sym___cdecl] = ACTIONS(1968),
    [anon_sym___clrcall] = ACTIONS(1968),
    [anon_sym___stdcall] = ACTIONS(1968),
    [anon_sym___fastcall] = ACTIONS(1968),
    [anon_sym___thiscall] = ACTIONS(1968),
    [anon_sym___vectorcall] = ACTIONS(1968),
    [anon_sym_LBRACE] = ACTIONS(1970),
    [anon_sym_signed] = ACTIONS(1968),
    [anon_sym_unsigned] = ACTIONS(1968),
    [anon_sym_long] = ACTIONS(1968),
    [anon_sym_short] = ACTIONS(1968),
    [anon_sym_LBRACK] = ACTIONS(1968),
    [anon_sym_static] = ACTIONS(1968),
    [anon_sym_register] = ACTIONS(1968),
    [anon_sym_inline] = ACTIONS(1968),
    [anon_sym___inline] = ACTIONS(1968),
    [anon_sym___inline__] = ACTIONS(1968),
    [anon_sym___forceinline] = ACTIONS(1968),
    [anon_sym_thread_local] = ACTIONS(1968),
    [anon_sym___thread] = ACTIONS(1968),
    [anon_sym_const] = ACTIONS(1968),
    [anon_sym_constexpr] = ACTIONS(1968),
    [anon_sym_volatile] = ACTIONS(1968),
    [anon_sym_restrict] = ACTIONS(1968),
    [anon_sym___restrict__] = ACTIONS(1968),
    [anon_sym__Atomic] = ACTIONS(1968),
    [anon_sym__Noreturn] = ACTIONS(1968),
    [anon_sym_noreturn] = ACTIONS(1968),
    [anon_sym_mutable] = ACTIONS(1968),
    [anon_sym_constinit] = ACTIONS(1968),
    [anon_sym_consteval] = ACTIONS(1968),
    [anon_sym___shared__] = ACTIONS(1968),
    [anon_sym___local__] = ACTIONS(1968),
    [anon_sym___constant__] = ACTIONS(1968),
    [anon_sym___managed__] = ACTIONS(1968),
    [anon_sym___grid_constant__] = ACTIONS(1968),
    [anon_sym_alignas] = ACTIONS(1968),
    [anon_sym__Alignas] = ACTIONS(1968),
    [sym_primitive_type] = ACTIONS(1968),
    [anon_sym_enum] = ACTIONS(1968),
    [anon_sym_class] = ACTIONS(1968),
    [anon_sym_struct] = ACTIONS(1968),
    [anon_sym_union] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_else] = ACTIONS(1968),
    [anon_sym_switch] = ACTIONS(1968),
    [anon_sym_case] = ACTIONS(1968),
    [anon_sym_default] = ACTIONS(1968),
    [anon_sym_while] = ACTIONS(1968),
    [anon_sym_do] = ACTIONS(1968),
    [anon_sym_for] = ACTIONS(1968),
    [anon_sym_return] = ACTIONS(1968),
    [anon_sym_break] = ACTIONS(1968),
    [anon_sym_continue] = ACTIONS(1968),
    [anon_sym_goto] = ACTIONS(1968),
    [anon_sym___try] = ACTIONS(1968),
    [anon_sym___leave] = ACTIONS(1968),
    [anon_sym_not] = ACTIONS(1968),
    [anon_sym_compl] = ACTIONS(1968),
    [anon_sym_DASH_DASH] = ACTIONS(1970),
    [anon_sym_PLUS_PLUS] = ACTIONS(1970),
    [anon_sym_sizeof] = ACTIONS(1968),
    [anon_sym___alignof__] = ACTIONS(1968),
    [anon_sym___alignof] = ACTIONS(1968),
    [anon_sym__alignof] = ACTIONS(1968),
    [anon_sym_alignof] = ACTIONS(1968),
    [anon_sym__Alignof] = ACTIONS(1968),
    [anon_sym_offsetof] = ACTIONS(1968),
    [anon_sym__Generic] = ACTIONS(1968),
    [anon_sym_asm] = ACTIONS(1968),
    [anon_sym___asm__] = ACTIONS(1968),
    [sym_number_literal] = ACTIONS(1970),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1970),
    [anon_sym_u_DQUOTE] = ACTIONS(1970),
    [anon_sym_U_DQUOTE] = ACTIONS(1970),
    [anon_sym_u8_DQUOTE] = ACTIONS(1970),
    [anon_sym_DQUOTE] = ACTIONS(1970),
    [sym_true] = ACTIONS(1968),
    [sym_false] = ACTIONS(1968),
    [anon_sym_NULL] = ACTIONS(1968),
    [anon_sym_nullptr] = ACTIONS(1968),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1968),
    [anon_sym_decltype] = ACTIONS(1968),
    [sym_virtual] = ACTIONS(1968),
    [anon_sym_explicit] = ACTIONS(1968),
    [anon_sym_typename] = ACTIONS(1968),
    [anon_sym_template] = ACTIONS(1968),
    [anon_sym_operator] = ACTIONS(1968),
    [anon_sym_try] = ACTIONS(1968),
    [anon_sym_delete] = ACTIONS(1968),
    [anon_sym_throw] = ACTIONS(1968),
    [anon_sym_namespace] = ACTIONS(1968),
    [anon_sym_using] = ACTIONS(1968),
    [anon_sym_static_assert] = ACTIONS(1968),
    [anon_sym_concept] = ACTIONS(1968),
    [anon_sym_co_return] = ACTIONS(1968),
    [anon_sym_co_yield] = ACTIONS(1968),
    [anon_sym_R_DQUOTE] = ACTIONS(1970),
    [anon_sym_LR_DQUOTE] = ACTIONS(1970),
    [anon_sym_uR_DQUOTE] = ACTIONS(1970),
    [anon_sym_UR_DQUOTE] = ACTIONS(1970),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1970),
    [anon_sym_co_await] = ACTIONS(1968),
    [anon_sym_new] = ACTIONS(1968),
    [anon_sym_requires] = ACTIONS(1968),
    [sym_this] = ACTIONS(1968),
    [anon_sym___launch_bounds__] = ACTIONS(1968),
  },
  [153] = {
    [sym_identifier] = ACTIONS(1972),
    [aux_sym_preproc_include_token1] = ACTIONS(1972),
    [aux_sym_preproc_def_token1] = ACTIONS(1972),
    [aux_sym_preproc_if_token1] = ACTIONS(1972),
    [aux_sym_preproc_if_token2] = ACTIONS(1972),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1972),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1972),
    [aux_sym_preproc_else_token1] = ACTIONS(1972),
    [aux_sym_preproc_elif_token1] = ACTIONS(1972),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1972),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1972),
    [sym_preproc_directive] = ACTIONS(1972),
    [anon_sym_LPAREN2] = ACTIONS(1974),
    [anon_sym_BANG] = ACTIONS(1974),
    [anon_sym_TILDE] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1972),
    [anon_sym_PLUS] = ACTIONS(1972),
    [anon_sym_STAR] = ACTIONS(1974),
    [anon_sym_AMP_AMP] = ACTIONS(1974),
    [anon_sym_AMP] = ACTIONS(1972),
    [anon_sym_SEMI] = ACTIONS(1974),
    [anon_sym___extension__] = ACTIONS(1972),
    [anon_sym_typedef] = ACTIONS(1972),
    [anon_sym___device__] = ACTIONS(1972),
    [anon_sym___host__] = ACTIONS(1972),
    [anon_sym___global__] = ACTIONS(1972),
    [anon_sym___forceinline__] = ACTIONS(1972),
    [anon_sym___noinline__] = ACTIONS(1972),
    [anon_sym_extern] = ACTIONS(1972),
    [anon_sym___attribute__] = ACTIONS(1972),
    [anon_sym_COLON_COLON] = ACTIONS(1974),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1974),
    [anon_sym___declspec] = ACTIONS(1972),
    [anon_sym___based] = ACTIONS(1972),
    [anon_sym___cdecl] = ACTIONS(1972),
    [anon_sym___clrcall] = ACTIONS(1972),
    [anon_sym___stdcall] = ACTIONS(1972),
    [anon_sym___fastcall] = ACTIONS(1972),
    [anon_sym___thiscall] = ACTIONS(1972),
    [anon_sym___vectorcall] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1974),
    [anon_sym_signed] = ACTIONS(1972),
    [anon_sym_unsigned] = ACTIONS(1972),
    [anon_sym_long] = ACTIONS(1972),
    [anon_sym_short] = ACTIONS(1972),
    [anon_sym_LBRACK] = ACTIONS(1972),
    [anon_sym_static] = ACTIONS(1972),
    [anon_sym_register] = ACTIONS(1972),
    [anon_sym_inline] = ACTIONS(1972),
    [anon_sym___inline] = ACTIONS(1972),
    [anon_sym___inline__] = ACTIONS(1972),
    [anon_sym___forceinline] = ACTIONS(1972),
    [anon_sym_thread_local] = ACTIONS(1972),
    [anon_sym___thread] = ACTIONS(1972),
    [anon_sym_const] = ACTIONS(1972),
    [anon_sym_constexpr] = ACTIONS(1972),
    [anon_sym_volatile] = ACTIONS(1972),
    [anon_sym_restrict] = ACTIONS(1972),
    [anon_sym___restrict__] = ACTIONS(1972),
    [anon_sym__Atomic] = ACTIONS(1972),
    [anon_sym__Noreturn] = ACTIONS(1972),
    [anon_sym_noreturn] = ACTIONS(1972),
    [anon_sym_mutable] = ACTIONS(1972),
    [anon_sym_constinit] = ACTIONS(1972),
    [anon_sym_consteval] = ACTIONS(1972),
    [anon_sym___shared__] = ACTIONS(1972),
    [anon_sym___local__] = ACTIONS(1972),
    [anon_sym___constant__] = ACTIONS(1972),
    [anon_sym___managed__] = ACTIONS(1972),
    [anon_sym___grid_constant__] = ACTIONS(1972),
    [anon_sym_alignas] = ACTIONS(1972),
    [anon_sym__Alignas] = ACTIONS(1972),
    [sym_primitive_type] = ACTIONS(1972),
    [anon_sym_enum] = ACTIONS(1972),
    [anon_sym_class] = ACTIONS(1972),
    [anon_sym_struct] = ACTIONS(1972),
    [anon_sym_union] = ACTIONS(1972),
    [anon_sym_if] = ACTIONS(1972),
    [anon_sym_else] = ACTIONS(1972),
    [anon_sym_switch] = ACTIONS(1972),
    [anon_sym_case] = ACTIONS(1972),
    [anon_sym_default] = ACTIONS(1972),
    [anon_sym_while] = ACTIONS(1972),
    [anon_sym_do] = ACTIONS(1972),
    [anon_sym_for] = ACTIONS(1972),
    [anon_sym_return] = ACTIONS(1972),
    [anon_sym_break] = ACTIONS(1972),
    [anon_sym_continue] = ACTIONS(1972),
    [anon_sym_goto] = ACTIONS(1972),
    [anon_sym___try] = ACTIONS(1972),
    [anon_sym___leave] = ACTIONS(1972),
    [anon_sym_not] = ACTIONS(1972),
    [anon_sym_compl] = ACTIONS(1972),
    [anon_sym_DASH_DASH] = ACTIONS(1974),
    [anon_sym_PLUS_PLUS] = ACTIONS(1974),
    [anon_sym_sizeof] = ACTIONS(1972),
    [anon_sym___alignof__] = ACTIONS(1972),
    [anon_sym___alignof] = ACTIONS(1972),
    [anon_sym__alignof] = ACTIONS(1972),
    [anon_sym_alignof] = ACTIONS(1972),
    [anon_sym__Alignof] = ACTIONS(1972),
    [anon_sym_offsetof] = ACTIONS(1972),
    [anon_sym__Generic] = ACTIONS(1972),
    [anon_sym_asm] = ACTIONS(1972),
    [anon_sym___asm__] = ACTIONS(1972),
    [sym_number_literal] = ACTIONS(1974),
    [anon_sym_L_SQUOTE] = ACTIONS(1974),
    [anon_sym_u_SQUOTE] = ACTIONS(1974),
    [anon_sym_U_SQUOTE] = ACTIONS(1974),
    [anon_sym_u8_SQUOTE] = ACTIONS(1974),
    [anon_sym_SQUOTE] = ACTIONS(1974),
    [anon_sym_L_DQUOTE] = ACTIONS(1974),
    [anon_sym_u_DQUOTE] = ACTIONS(1974),
    [anon_sym_U_DQUOTE] = ACTIONS(1974),
    [anon_sym_u8_DQUOTE] = ACTIONS(1974),
    [anon_sym_DQUOTE] = ACTIONS(1974),
    [sym_true] = ACTIONS(1972),
    [sym_false] = ACTIONS(1972),
    [anon_sym_NULL] = ACTIONS(1972),
    [anon_sym_nullptr] = ACTIONS(1972),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1972),
    [anon_sym_decltype] = ACTIONS(1972),
    [sym_virtual] = ACTIONS(1972),
    [anon_sym_explicit] = ACTIONS(1972),
    [anon_sym_typename] = ACTIONS(1972),
    [anon_sym_template] = ACTIONS(1972),
    [anon_sym_operator] = ACTIONS(1972),
    [anon_sym_try] = ACTIONS(1972),
    [anon_sym_delete] = ACTIONS(1972),
    [anon_sym_throw] = ACTIONS(1972),
    [anon_sym_namespace] = ACTIONS(1972),
    [anon_sym_using] = ACTIONS(1972),
    [anon_sym_static_assert] = ACTIONS(1972),
    [anon_sym_concept] = ACTIONS(1972),
    [anon_sym_co_return] = ACTIONS(1972),
    [anon_sym_co_yield] = ACTIONS(1972),
    [anon_sym_R_DQUOTE] = ACTIONS(1974),
    [anon_sym_LR_DQUOTE] = ACTIONS(1974),
    [anon_sym_uR_DQUOTE] = ACTIONS(1974),
    [anon_sym_UR_DQUOTE] = ACTIONS(1974),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1974),
    [anon_sym_co_await] = ACTIONS(1972),
    [anon_sym_new] = ACTIONS(1972),
    [anon_sym_requires] = ACTIONS(1972),
    [sym_this] = ACTIONS(1972),
    [anon_sym___launch_bounds__] = ACTIONS(1972),
  },
  [154] = {
    [sym_identifier] = ACTIONS(1976),
    [aux_sym_preproc_include_token1] = ACTIONS(1976),
    [aux_sym_preproc_def_token1] = ACTIONS(1976),
    [aux_sym_preproc_if_token1] = ACTIONS(1976),
    [aux_sym_preproc_if_token2] = ACTIONS(1976),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1976),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1976),
    [aux_sym_preproc_else_token1] = ACTIONS(1976),
    [aux_sym_preproc_elif_token1] = ACTIONS(1976),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1976),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1976),
    [sym_preproc_directive] = ACTIONS(1976),
    [anon_sym_LPAREN2] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1978),
    [anon_sym_TILDE] = ACTIONS(1978),
    [anon_sym_DASH] = ACTIONS(1976),
    [anon_sym_PLUS] = ACTIONS(1976),
    [anon_sym_STAR] = ACTIONS(1978),
    [anon_sym_AMP_AMP] = ACTIONS(1978),
    [anon_sym_AMP] = ACTIONS(1976),
    [anon_sym_SEMI] = ACTIONS(1978),
    [anon_sym___extension__] = ACTIONS(1976),
    [anon_sym_typedef] = ACTIONS(1976),
    [anon_sym___device__] = ACTIONS(1976),
    [anon_sym___host__] = ACTIONS(1976),
    [anon_sym___global__] = ACTIONS(1976),
    [anon_sym___forceinline__] = ACTIONS(1976),
    [anon_sym___noinline__] = ACTIONS(1976),
    [anon_sym_extern] = ACTIONS(1976),
    [anon_sym___attribute__] = ACTIONS(1976),
    [anon_sym_COLON_COLON] = ACTIONS(1978),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1978),
    [anon_sym___declspec] = ACTIONS(1976),
    [anon_sym___based] = ACTIONS(1976),
    [anon_sym___cdecl] = ACTIONS(1976),
    [anon_sym___clrcall] = ACTIONS(1976),
    [anon_sym___stdcall] = ACTIONS(1976),
    [anon_sym___fastcall] = ACTIONS(1976),
    [anon_sym___thiscall] = ACTIONS(1976),
    [anon_sym___vectorcall] = ACTIONS(1976),
    [anon_sym_LBRACE] = ACTIONS(1978),
    [anon_sym_signed] = ACTIONS(1976),
    [anon_sym_unsigned] = ACTIONS(1976),
    [anon_sym_long] = ACTIONS(1976),
    [anon_sym_short] = ACTIONS(1976),
    [anon_sym_LBRACK] = ACTIONS(1976),
    [anon_sym_static] = ACTIONS(1976),
    [anon_sym_register] = ACTIONS(1976),
    [anon_sym_inline] = ACTIONS(1976),
    [anon_sym___inline] = ACTIONS(1976),
    [anon_sym___inline__] = ACTIONS(1976),
    [anon_sym___forceinline] = ACTIONS(1976),
    [anon_sym_thread_local] = ACTIONS(1976),
    [anon_sym___thread] = ACTIONS(1976),
    [anon_sym_const] = ACTIONS(1976),
    [anon_sym_constexpr] = ACTIONS(1976),
    [anon_sym_volatile] = ACTIONS(1976),
    [anon_sym_restrict] = ACTIONS(1976),
    [anon_sym___restrict__] = ACTIONS(1976),
    [anon_sym__Atomic] = ACTIONS(1976),
    [anon_sym__Noreturn] = ACTIONS(1976),
    [anon_sym_noreturn] = ACTIONS(1976),
    [anon_sym_mutable] = ACTIONS(1976),
    [anon_sym_constinit] = ACTIONS(1976),
    [anon_sym_consteval] = ACTIONS(1976),
    [anon_sym___shared__] = ACTIONS(1976),
    [anon_sym___local__] = ACTIONS(1976),
    [anon_sym___constant__] = ACTIONS(1976),
    [anon_sym___managed__] = ACTIONS(1976),
    [anon_sym___grid_constant__] = ACTIONS(1976),
    [anon_sym_alignas] = ACTIONS(1976),
    [anon_sym__Alignas] = ACTIONS(1976),
    [sym_primitive_type] = ACTIONS(1976),
    [anon_sym_enum] = ACTIONS(1976),
    [anon_sym_class] = ACTIONS(1976),
    [anon_sym_struct] = ACTIONS(1976),
    [anon_sym_union] = ACTIONS(1976),
    [anon_sym_if] = ACTIONS(1976),
    [anon_sym_else] = ACTIONS(1976),
    [anon_sym_switch] = ACTIONS(1976),
    [anon_sym_case] = ACTIONS(1976),
    [anon_sym_default] = ACTIONS(1976),
    [anon_sym_while] = ACTIONS(1976),
    [anon_sym_do] = ACTIONS(1976),
    [anon_sym_for] = ACTIONS(1976),
    [anon_sym_return] = ACTIONS(1976),
    [anon_sym_break] = ACTIONS(1976),
    [anon_sym_continue] = ACTIONS(1976),
    [anon_sym_goto] = ACTIONS(1976),
    [anon_sym___try] = ACTIONS(1976),
    [anon_sym___leave] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1976),
    [anon_sym_compl] = ACTIONS(1976),
    [anon_sym_DASH_DASH] = ACTIONS(1978),
    [anon_sym_PLUS_PLUS] = ACTIONS(1978),
    [anon_sym_sizeof] = ACTIONS(1976),
    [anon_sym___alignof__] = ACTIONS(1976),
    [anon_sym___alignof] = ACTIONS(1976),
    [anon_sym__alignof] = ACTIONS(1976),
    [anon_sym_alignof] = ACTIONS(1976),
    [anon_sym__Alignof] = ACTIONS(1976),
    [anon_sym_offsetof] = ACTIONS(1976),
    [anon_sym__Generic] = ACTIONS(1976),
    [anon_sym_asm] = ACTIONS(1976),
    [anon_sym___asm__] = ACTIONS(1976),
    [sym_number_literal] = ACTIONS(1978),
    [anon_sym_L_SQUOTE] = ACTIONS(1978),
    [anon_sym_u_SQUOTE] = ACTIONS(1978),
    [anon_sym_U_SQUOTE] = ACTIONS(1978),
    [anon_sym_u8_SQUOTE] = ACTIONS(1978),
    [anon_sym_SQUOTE] = ACTIONS(1978),
    [anon_sym_L_DQUOTE] = ACTIONS(1978),
    [anon_sym_u_DQUOTE] = ACTIONS(1978),
    [anon_sym_U_DQUOTE] = ACTIONS(1978),
    [anon_sym_u8_DQUOTE] = ACTIONS(1978),
    [anon_sym_DQUOTE] = ACTIONS(1978),
    [sym_true] = ACTIONS(1976),
    [sym_false] = ACTIONS(1976),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1976),
    [anon_sym_decltype] = ACTIONS(1976),
    [sym_virtual] = ACTIONS(1976),
    [anon_sym_explicit] = ACTIONS(1976),
    [anon_sym_typename] = ACTIONS(1976),
    [anon_sym_template] = ACTIONS(1976),
    [anon_sym_operator] = ACTIONS(1976),
    [anon_sym_try] = ACTIONS(1976),
    [anon_sym_delete] = ACTIONS(1976),
    [anon_sym_throw] = ACTIONS(1976),
    [anon_sym_namespace] = ACTIONS(1976),
    [anon_sym_using] = ACTIONS(1976),
    [anon_sym_static_assert] = ACTIONS(1976),
    [anon_sym_concept] = ACTIONS(1976),
    [anon_sym_co_return] = ACTIONS(1976),
    [anon_sym_co_yield] = ACTIONS(1976),
    [anon_sym_R_DQUOTE] = ACTIONS(1978),
    [anon_sym_LR_DQUOTE] = ACTIONS(1978),
    [anon_sym_uR_DQUOTE] = ACTIONS(1978),
    [anon_sym_UR_DQUOTE] = ACTIONS(1978),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1978),
    [anon_sym_co_await] = ACTIONS(1976),
    [anon_sym_new] = ACTIONS(1976),
    [anon_sym_requires] = ACTIONS(1976),
    [sym_this] = ACTIONS(1976),
    [anon_sym___launch_bounds__] = ACTIONS(1976),
  },
  [155] = {
    [sym_identifier] = ACTIONS(1980),
    [aux_sym_preproc_include_token1] = ACTIONS(1980),
    [aux_sym_preproc_def_token1] = ACTIONS(1980),
    [aux_sym_preproc_if_token1] = ACTIONS(1980),
    [aux_sym_preproc_if_token2] = ACTIONS(1980),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1980),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1980),
    [aux_sym_preproc_else_token1] = ACTIONS(1980),
    [aux_sym_preproc_elif_token1] = ACTIONS(1980),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1980),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1980),
    [sym_preproc_directive] = ACTIONS(1980),
    [anon_sym_LPAREN2] = ACTIONS(1982),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_AMP_AMP] = ACTIONS(1982),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_SEMI] = ACTIONS(1982),
    [anon_sym___extension__] = ACTIONS(1980),
    [anon_sym_typedef] = ACTIONS(1980),
    [anon_sym___device__] = ACTIONS(1980),
    [anon_sym___host__] = ACTIONS(1980),
    [anon_sym___global__] = ACTIONS(1980),
    [anon_sym___forceinline__] = ACTIONS(1980),
    [anon_sym___noinline__] = ACTIONS(1980),
    [anon_sym_extern] = ACTIONS(1980),
    [anon_sym___attribute__] = ACTIONS(1980),
    [anon_sym_COLON_COLON] = ACTIONS(1982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1982),
    [anon_sym___declspec] = ACTIONS(1980),
    [anon_sym___based] = ACTIONS(1980),
    [anon_sym___cdecl] = ACTIONS(1980),
    [anon_sym___clrcall] = ACTIONS(1980),
    [anon_sym___stdcall] = ACTIONS(1980),
    [anon_sym___fastcall] = ACTIONS(1980),
    [anon_sym___thiscall] = ACTIONS(1980),
    [anon_sym___vectorcall] = ACTIONS(1980),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_signed] = ACTIONS(1980),
    [anon_sym_unsigned] = ACTIONS(1980),
    [anon_sym_long] = ACTIONS(1980),
    [anon_sym_short] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_static] = ACTIONS(1980),
    [anon_sym_register] = ACTIONS(1980),
    [anon_sym_inline] = ACTIONS(1980),
    [anon_sym___inline] = ACTIONS(1980),
    [anon_sym___inline__] = ACTIONS(1980),
    [anon_sym___forceinline] = ACTIONS(1980),
    [anon_sym_thread_local] = ACTIONS(1980),
    [anon_sym___thread] = ACTIONS(1980),
    [anon_sym_const] = ACTIONS(1980),
    [anon_sym_constexpr] = ACTIONS(1980),
    [anon_sym_volatile] = ACTIONS(1980),
    [anon_sym_restrict] = ACTIONS(1980),
    [anon_sym___restrict__] = ACTIONS(1980),
    [anon_sym__Atomic] = ACTIONS(1980),
    [anon_sym__Noreturn] = ACTIONS(1980),
    [anon_sym_noreturn] = ACTIONS(1980),
    [anon_sym_mutable] = ACTIONS(1980),
    [anon_sym_constinit] = ACTIONS(1980),
    [anon_sym_consteval] = ACTIONS(1980),
    [anon_sym___shared__] = ACTIONS(1980),
    [anon_sym___local__] = ACTIONS(1980),
    [anon_sym___constant__] = ACTIONS(1980),
    [anon_sym___managed__] = ACTIONS(1980),
    [anon_sym___grid_constant__] = ACTIONS(1980),
    [anon_sym_alignas] = ACTIONS(1980),
    [anon_sym__Alignas] = ACTIONS(1980),
    [sym_primitive_type] = ACTIONS(1980),
    [anon_sym_enum] = ACTIONS(1980),
    [anon_sym_class] = ACTIONS(1980),
    [anon_sym_struct] = ACTIONS(1980),
    [anon_sym_union] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_else] = ACTIONS(1980),
    [anon_sym_switch] = ACTIONS(1980),
    [anon_sym_case] = ACTIONS(1980),
    [anon_sym_default] = ACTIONS(1980),
    [anon_sym_while] = ACTIONS(1980),
    [anon_sym_do] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_return] = ACTIONS(1980),
    [anon_sym_break] = ACTIONS(1980),
    [anon_sym_continue] = ACTIONS(1980),
    [anon_sym_goto] = ACTIONS(1980),
    [anon_sym___try] = ACTIONS(1980),
    [anon_sym___leave] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_compl] = ACTIONS(1980),
    [anon_sym_DASH_DASH] = ACTIONS(1982),
    [anon_sym_PLUS_PLUS] = ACTIONS(1982),
    [anon_sym_sizeof] = ACTIONS(1980),
    [anon_sym___alignof__] = ACTIONS(1980),
    [anon_sym___alignof] = ACTIONS(1980),
    [anon_sym__alignof] = ACTIONS(1980),
    [anon_sym_alignof] = ACTIONS(1980),
    [anon_sym__Alignof] = ACTIONS(1980),
    [anon_sym_offsetof] = ACTIONS(1980),
    [anon_sym__Generic] = ACTIONS(1980),
    [anon_sym_asm] = ACTIONS(1980),
    [anon_sym___asm__] = ACTIONS(1980),
    [sym_number_literal] = ACTIONS(1982),
    [anon_sym_L_SQUOTE] = ACTIONS(1982),
    [anon_sym_u_SQUOTE] = ACTIONS(1982),
    [anon_sym_U_SQUOTE] = ACTIONS(1982),
    [anon_sym_u8_SQUOTE] = ACTIONS(1982),
    [anon_sym_SQUOTE] = ACTIONS(1982),
    [anon_sym_L_DQUOTE] = ACTIONS(1982),
    [anon_sym_u_DQUOTE] = ACTIONS(1982),
    [anon_sym_U_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8_DQUOTE] = ACTIONS(1982),
    [anon_sym_DQUOTE] = ACTIONS(1982),
    [sym_true] = ACTIONS(1980),
    [sym_false] = ACTIONS(1980),
    [anon_sym_NULL] = ACTIONS(1980),
    [anon_sym_nullptr] = ACTIONS(1980),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1980),
    [anon_sym_decltype] = ACTIONS(1980),
    [sym_virtual] = ACTIONS(1980),
    [anon_sym_explicit] = ACTIONS(1980),
    [anon_sym_typename] = ACTIONS(1980),
    [anon_sym_template] = ACTIONS(1980),
    [anon_sym_operator] = ACTIONS(1980),
    [anon_sym_try] = ACTIONS(1980),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_throw] = ACTIONS(1980),
    [anon_sym_namespace] = ACTIONS(1980),
    [anon_sym_using] = ACTIONS(1980),
    [anon_sym_static_assert] = ACTIONS(1980),
    [anon_sym_concept] = ACTIONS(1980),
    [anon_sym_co_return] = ACTIONS(1980),
    [anon_sym_co_yield] = ACTIONS(1980),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1980),
    [anon_sym_new] = ACTIONS(1980),
    [anon_sym_requires] = ACTIONS(1980),
    [sym_this] = ACTIONS(1980),
    [anon_sym___launch_bounds__] = ACTIONS(1980),
  },
  [156] = {
    [sym_identifier] = ACTIONS(1984),
    [aux_sym_preproc_include_token1] = ACTIONS(1984),
    [aux_sym_preproc_def_token1] = ACTIONS(1984),
    [aux_sym_preproc_if_token1] = ACTIONS(1984),
    [aux_sym_preproc_if_token2] = ACTIONS(1984),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1984),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1984),
    [aux_sym_preproc_else_token1] = ACTIONS(1984),
    [aux_sym_preproc_elif_token1] = ACTIONS(1984),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1984),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1984),
    [sym_preproc_directive] = ACTIONS(1984),
    [anon_sym_LPAREN2] = ACTIONS(1986),
    [anon_sym_BANG] = ACTIONS(1986),
    [anon_sym_TILDE] = ACTIONS(1986),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_AMP_AMP] = ACTIONS(1986),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_SEMI] = ACTIONS(1986),
    [anon_sym___extension__] = ACTIONS(1984),
    [anon_sym_typedef] = ACTIONS(1984),
    [anon_sym___device__] = ACTIONS(1984),
    [anon_sym___host__] = ACTIONS(1984),
    [anon_sym___global__] = ACTIONS(1984),
    [anon_sym___forceinline__] = ACTIONS(1984),
    [anon_sym___noinline__] = ACTIONS(1984),
    [anon_sym_extern] = ACTIONS(1984),
    [anon_sym___attribute__] = ACTIONS(1984),
    [anon_sym_COLON_COLON] = ACTIONS(1986),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1986),
    [anon_sym___declspec] = ACTIONS(1984),
    [anon_sym___based] = ACTIONS(1984),
    [anon_sym___cdecl] = ACTIONS(1984),
    [anon_sym___clrcall] = ACTIONS(1984),
    [anon_sym___stdcall] = ACTIONS(1984),
    [anon_sym___fastcall] = ACTIONS(1984),
    [anon_sym___thiscall] = ACTIONS(1984),
    [anon_sym___vectorcall] = ACTIONS(1984),
    [anon_sym_LBRACE] = ACTIONS(1986),
    [anon_sym_signed] = ACTIONS(1984),
    [anon_sym_unsigned] = ACTIONS(1984),
    [anon_sym_long] = ACTIONS(1984),
    [anon_sym_short] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_static] = ACTIONS(1984),
    [anon_sym_register] = ACTIONS(1984),
    [anon_sym_inline] = ACTIONS(1984),
    [anon_sym___inline] = ACTIONS(1984),
    [anon_sym___inline__] = ACTIONS(1984),
    [anon_sym___forceinline] = ACTIONS(1984),
    [anon_sym_thread_local] = ACTIONS(1984),
    [anon_sym___thread] = ACTIONS(1984),
    [anon_sym_const] = ACTIONS(1984),
    [anon_sym_constexpr] = ACTIONS(1984),
    [anon_sym_volatile] = ACTIONS(1984),
    [anon_sym_restrict] = ACTIONS(1984),
    [anon_sym___restrict__] = ACTIONS(1984),
    [anon_sym__Atomic] = ACTIONS(1984),
    [anon_sym__Noreturn] = ACTIONS(1984),
    [anon_sym_noreturn] = ACTIONS(1984),
    [anon_sym_mutable] = ACTIONS(1984),
    [anon_sym_constinit] = ACTIONS(1984),
    [anon_sym_consteval] = ACTIONS(1984),
    [anon_sym___shared__] = ACTIONS(1984),
    [anon_sym___local__] = ACTIONS(1984),
    [anon_sym___constant__] = ACTIONS(1984),
    [anon_sym___managed__] = ACTIONS(1984),
    [anon_sym___grid_constant__] = ACTIONS(1984),
    [anon_sym_alignas] = ACTIONS(1984),
    [anon_sym__Alignas] = ACTIONS(1984),
    [sym_primitive_type] = ACTIONS(1984),
    [anon_sym_enum] = ACTIONS(1984),
    [anon_sym_class] = ACTIONS(1984),
    [anon_sym_struct] = ACTIONS(1984),
    [anon_sym_union] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_else] = ACTIONS(1984),
    [anon_sym_switch] = ACTIONS(1984),
    [anon_sym_case] = ACTIONS(1984),
    [anon_sym_default] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1984),
    [anon_sym_do] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_return] = ACTIONS(1984),
    [anon_sym_break] = ACTIONS(1984),
    [anon_sym_continue] = ACTIONS(1984),
    [anon_sym_goto] = ACTIONS(1984),
    [anon_sym___try] = ACTIONS(1984),
    [anon_sym___leave] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_compl] = ACTIONS(1984),
    [anon_sym_DASH_DASH] = ACTIONS(1986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1986),
    [anon_sym_sizeof] = ACTIONS(1984),
    [anon_sym___alignof__] = ACTIONS(1984),
    [anon_sym___alignof] = ACTIONS(1984),
    [anon_sym__alignof] = ACTIONS(1984),
    [anon_sym_alignof] = ACTIONS(1984),
    [anon_sym__Alignof] = ACTIONS(1984),
    [anon_sym_offsetof] = ACTIONS(1984),
    [anon_sym__Generic] = ACTIONS(1984),
    [anon_sym_asm] = ACTIONS(1984),
    [anon_sym___asm__] = ACTIONS(1984),
    [sym_number_literal] = ACTIONS(1986),
    [anon_sym_L_SQUOTE] = ACTIONS(1986),
    [anon_sym_u_SQUOTE] = ACTIONS(1986),
    [anon_sym_U_SQUOTE] = ACTIONS(1986),
    [anon_sym_u8_SQUOTE] = ACTIONS(1986),
    [anon_sym_SQUOTE] = ACTIONS(1986),
    [anon_sym_L_DQUOTE] = ACTIONS(1986),
    [anon_sym_u_DQUOTE] = ACTIONS(1986),
    [anon_sym_U_DQUOTE] = ACTIONS(1986),
    [anon_sym_u8_DQUOTE] = ACTIONS(1986),
    [anon_sym_DQUOTE] = ACTIONS(1986),
    [sym_true] = ACTIONS(1984),
    [sym_false] = ACTIONS(1984),
    [anon_sym_NULL] = ACTIONS(1984),
    [anon_sym_nullptr] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1984),
    [anon_sym_decltype] = ACTIONS(1984),
    [sym_virtual] = ACTIONS(1984),
    [anon_sym_explicit] = ACTIONS(1984),
    [anon_sym_typename] = ACTIONS(1984),
    [anon_sym_template] = ACTIONS(1984),
    [anon_sym_operator] = ACTIONS(1984),
    [anon_sym_try] = ACTIONS(1984),
    [anon_sym_delete] = ACTIONS(1984),
    [anon_sym_throw] = ACTIONS(1984),
    [anon_sym_namespace] = ACTIONS(1984),
    [anon_sym_using] = ACTIONS(1984),
    [anon_sym_static_assert] = ACTIONS(1984),
    [anon_sym_concept] = ACTIONS(1984),
    [anon_sym_co_return] = ACTIONS(1984),
    [anon_sym_co_yield] = ACTIONS(1984),
    [anon_sym_R_DQUOTE] = ACTIONS(1986),
    [anon_sym_LR_DQUOTE] = ACTIONS(1986),
    [anon_sym_uR_DQUOTE] = ACTIONS(1986),
    [anon_sym_UR_DQUOTE] = ACTIONS(1986),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1986),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1984),
    [anon_sym_requires] = ACTIONS(1984),
    [sym_this] = ACTIONS(1984),
    [anon_sym___launch_bounds__] = ACTIONS(1984),
  },
  [157] = {
    [sym_identifier] = ACTIONS(1988),
    [aux_sym_preproc_include_token1] = ACTIONS(1988),
    [aux_sym_preproc_def_token1] = ACTIONS(1988),
    [aux_sym_preproc_if_token1] = ACTIONS(1988),
    [aux_sym_preproc_if_token2] = ACTIONS(1988),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1988),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1988),
    [aux_sym_preproc_else_token1] = ACTIONS(1988),
    [aux_sym_preproc_elif_token1] = ACTIONS(1988),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1988),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1988),
    [sym_preproc_directive] = ACTIONS(1988),
    [anon_sym_LPAREN2] = ACTIONS(1990),
    [anon_sym_BANG] = ACTIONS(1990),
    [anon_sym_TILDE] = ACTIONS(1990),
    [anon_sym_DASH] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(1990),
    [anon_sym_AMP_AMP] = ACTIONS(1990),
    [anon_sym_AMP] = ACTIONS(1988),
    [anon_sym_SEMI] = ACTIONS(1990),
    [anon_sym___extension__] = ACTIONS(1988),
    [anon_sym_typedef] = ACTIONS(1988),
    [anon_sym___device__] = ACTIONS(1988),
    [anon_sym___host__] = ACTIONS(1988),
    [anon_sym___global__] = ACTIONS(1988),
    [anon_sym___forceinline__] = ACTIONS(1988),
    [anon_sym___noinline__] = ACTIONS(1988),
    [anon_sym_extern] = ACTIONS(1988),
    [anon_sym___attribute__] = ACTIONS(1988),
    [anon_sym_COLON_COLON] = ACTIONS(1990),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1990),
    [anon_sym___declspec] = ACTIONS(1988),
    [anon_sym___based] = ACTIONS(1988),
    [anon_sym___cdecl] = ACTIONS(1988),
    [anon_sym___clrcall] = ACTIONS(1988),
    [anon_sym___stdcall] = ACTIONS(1988),
    [anon_sym___fastcall] = ACTIONS(1988),
    [anon_sym___thiscall] = ACTIONS(1988),
    [anon_sym___vectorcall] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1990),
    [anon_sym_signed] = ACTIONS(1988),
    [anon_sym_unsigned] = ACTIONS(1988),
    [anon_sym_long] = ACTIONS(1988),
    [anon_sym_short] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_static] = ACTIONS(1988),
    [anon_sym_register] = ACTIONS(1988),
    [anon_sym_inline] = ACTIONS(1988),
    [anon_sym___inline] = ACTIONS(1988),
    [anon_sym___inline__] = ACTIONS(1988),
    [anon_sym___forceinline] = ACTIONS(1988),
    [anon_sym_thread_local] = ACTIONS(1988),
    [anon_sym___thread] = ACTIONS(1988),
    [anon_sym_const] = ACTIONS(1988),
    [anon_sym_constexpr] = ACTIONS(1988),
    [anon_sym_volatile] = ACTIONS(1988),
    [anon_sym_restrict] = ACTIONS(1988),
    [anon_sym___restrict__] = ACTIONS(1988),
    [anon_sym__Atomic] = ACTIONS(1988),
    [anon_sym__Noreturn] = ACTIONS(1988),
    [anon_sym_noreturn] = ACTIONS(1988),
    [anon_sym_mutable] = ACTIONS(1988),
    [anon_sym_constinit] = ACTIONS(1988),
    [anon_sym_consteval] = ACTIONS(1988),
    [anon_sym___shared__] = ACTIONS(1988),
    [anon_sym___local__] = ACTIONS(1988),
    [anon_sym___constant__] = ACTIONS(1988),
    [anon_sym___managed__] = ACTIONS(1988),
    [anon_sym___grid_constant__] = ACTIONS(1988),
    [anon_sym_alignas] = ACTIONS(1988),
    [anon_sym__Alignas] = ACTIONS(1988),
    [sym_primitive_type] = ACTIONS(1988),
    [anon_sym_enum] = ACTIONS(1988),
    [anon_sym_class] = ACTIONS(1988),
    [anon_sym_struct] = ACTIONS(1988),
    [anon_sym_union] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_else] = ACTIONS(1988),
    [anon_sym_switch] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_default] = ACTIONS(1988),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_do] = ACTIONS(1988),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_return] = ACTIONS(1988),
    [anon_sym_break] = ACTIONS(1988),
    [anon_sym_continue] = ACTIONS(1988),
    [anon_sym_goto] = ACTIONS(1988),
    [anon_sym___try] = ACTIONS(1988),
    [anon_sym___leave] = ACTIONS(1988),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_compl] = ACTIONS(1988),
    [anon_sym_DASH_DASH] = ACTIONS(1990),
    [anon_sym_PLUS_PLUS] = ACTIONS(1990),
    [anon_sym_sizeof] = ACTIONS(1988),
    [anon_sym___alignof__] = ACTIONS(1988),
    [anon_sym___alignof] = ACTIONS(1988),
    [anon_sym__alignof] = ACTIONS(1988),
    [anon_sym_alignof] = ACTIONS(1988),
    [anon_sym__Alignof] = ACTIONS(1988),
    [anon_sym_offsetof] = ACTIONS(1988),
    [anon_sym__Generic] = ACTIONS(1988),
    [anon_sym_asm] = ACTIONS(1988),
    [anon_sym___asm__] = ACTIONS(1988),
    [sym_number_literal] = ACTIONS(1990),
    [anon_sym_L_SQUOTE] = ACTIONS(1990),
    [anon_sym_u_SQUOTE] = ACTIONS(1990),
    [anon_sym_U_SQUOTE] = ACTIONS(1990),
    [anon_sym_u8_SQUOTE] = ACTIONS(1990),
    [anon_sym_SQUOTE] = ACTIONS(1990),
    [anon_sym_L_DQUOTE] = ACTIONS(1990),
    [anon_sym_u_DQUOTE] = ACTIONS(1990),
    [anon_sym_U_DQUOTE] = ACTIONS(1990),
    [anon_sym_u8_DQUOTE] = ACTIONS(1990),
    [anon_sym_DQUOTE] = ACTIONS(1990),
    [sym_true] = ACTIONS(1988),
    [sym_false] = ACTIONS(1988),
    [anon_sym_NULL] = ACTIONS(1988),
    [anon_sym_nullptr] = ACTIONS(1988),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1988),
    [anon_sym_decltype] = ACTIONS(1988),
    [sym_virtual] = ACTIONS(1988),
    [anon_sym_explicit] = ACTIONS(1988),
    [anon_sym_typename] = ACTIONS(1988),
    [anon_sym_template] = ACTIONS(1988),
    [anon_sym_operator] = ACTIONS(1988),
    [anon_sym_try] = ACTIONS(1988),
    [anon_sym_delete] = ACTIONS(1988),
    [anon_sym_throw] = ACTIONS(1988),
    [anon_sym_namespace] = ACTIONS(1988),
    [anon_sym_using] = ACTIONS(1988),
    [anon_sym_static_assert] = ACTIONS(1988),
    [anon_sym_concept] = ACTIONS(1988),
    [anon_sym_co_return] = ACTIONS(1988),
    [anon_sym_co_yield] = ACTIONS(1988),
    [anon_sym_R_DQUOTE] = ACTIONS(1990),
    [anon_sym_LR_DQUOTE] = ACTIONS(1990),
    [anon_sym_uR_DQUOTE] = ACTIONS(1990),
    [anon_sym_UR_DQUOTE] = ACTIONS(1990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1990),
    [anon_sym_co_await] = ACTIONS(1988),
    [anon_sym_new] = ACTIONS(1988),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1988),
    [anon_sym___launch_bounds__] = ACTIONS(1988),
  },
  [158] = {
    [sym_identifier] = ACTIONS(1992),
    [aux_sym_preproc_include_token1] = ACTIONS(1992),
    [aux_sym_preproc_def_token1] = ACTIONS(1992),
    [aux_sym_preproc_if_token1] = ACTIONS(1992),
    [aux_sym_preproc_if_token2] = ACTIONS(1992),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1992),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1992),
    [aux_sym_preproc_else_token1] = ACTIONS(1992),
    [aux_sym_preproc_elif_token1] = ACTIONS(1992),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1992),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1992),
    [sym_preproc_directive] = ACTIONS(1992),
    [anon_sym_LPAREN2] = ACTIONS(1994),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1994),
    [anon_sym_AMP_AMP] = ACTIONS(1994),
    [anon_sym_AMP] = ACTIONS(1992),
    [anon_sym_SEMI] = ACTIONS(1994),
    [anon_sym___extension__] = ACTIONS(1992),
    [anon_sym_typedef] = ACTIONS(1992),
    [anon_sym___device__] = ACTIONS(1992),
    [anon_sym___host__] = ACTIONS(1992),
    [anon_sym___global__] = ACTIONS(1992),
    [anon_sym___forceinline__] = ACTIONS(1992),
    [anon_sym___noinline__] = ACTIONS(1992),
    [anon_sym_extern] = ACTIONS(1992),
    [anon_sym___attribute__] = ACTIONS(1992),
    [anon_sym_COLON_COLON] = ACTIONS(1994),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1994),
    [anon_sym___declspec] = ACTIONS(1992),
    [anon_sym___based] = ACTIONS(1992),
    [anon_sym___cdecl] = ACTIONS(1992),
    [anon_sym___clrcall] = ACTIONS(1992),
    [anon_sym___stdcall] = ACTIONS(1992),
    [anon_sym___fastcall] = ACTIONS(1992),
    [anon_sym___thiscall] = ACTIONS(1992),
    [anon_sym___vectorcall] = ACTIONS(1992),
    [anon_sym_LBRACE] = ACTIONS(1994),
    [anon_sym_signed] = ACTIONS(1992),
    [anon_sym_unsigned] = ACTIONS(1992),
    [anon_sym_long] = ACTIONS(1992),
    [anon_sym_short] = ACTIONS(1992),
    [anon_sym_LBRACK] = ACTIONS(1992),
    [anon_sym_static] = ACTIONS(1992),
    [anon_sym_register] = ACTIONS(1992),
    [anon_sym_inline] = ACTIONS(1992),
    [anon_sym___inline] = ACTIONS(1992),
    [anon_sym___inline__] = ACTIONS(1992),
    [anon_sym___forceinline] = ACTIONS(1992),
    [anon_sym_thread_local] = ACTIONS(1992),
    [anon_sym___thread] = ACTIONS(1992),
    [anon_sym_const] = ACTIONS(1992),
    [anon_sym_constexpr] = ACTIONS(1992),
    [anon_sym_volatile] = ACTIONS(1992),
    [anon_sym_restrict] = ACTIONS(1992),
    [anon_sym___restrict__] = ACTIONS(1992),
    [anon_sym__Atomic] = ACTIONS(1992),
    [anon_sym__Noreturn] = ACTIONS(1992),
    [anon_sym_noreturn] = ACTIONS(1992),
    [anon_sym_mutable] = ACTIONS(1992),
    [anon_sym_constinit] = ACTIONS(1992),
    [anon_sym_consteval] = ACTIONS(1992),
    [anon_sym___shared__] = ACTIONS(1992),
    [anon_sym___local__] = ACTIONS(1992),
    [anon_sym___constant__] = ACTIONS(1992),
    [anon_sym___managed__] = ACTIONS(1992),
    [anon_sym___grid_constant__] = ACTIONS(1992),
    [anon_sym_alignas] = ACTIONS(1992),
    [anon_sym__Alignas] = ACTIONS(1992),
    [sym_primitive_type] = ACTIONS(1992),
    [anon_sym_enum] = ACTIONS(1992),
    [anon_sym_class] = ACTIONS(1992),
    [anon_sym_struct] = ACTIONS(1992),
    [anon_sym_union] = ACTIONS(1992),
    [anon_sym_if] = ACTIONS(1992),
    [anon_sym_else] = ACTIONS(1992),
    [anon_sym_switch] = ACTIONS(1992),
    [anon_sym_case] = ACTIONS(1992),
    [anon_sym_default] = ACTIONS(1992),
    [anon_sym_while] = ACTIONS(1992),
    [anon_sym_do] = ACTIONS(1992),
    [anon_sym_for] = ACTIONS(1992),
    [anon_sym_return] = ACTIONS(1992),
    [anon_sym_break] = ACTIONS(1992),
    [anon_sym_continue] = ACTIONS(1992),
    [anon_sym_goto] = ACTIONS(1992),
    [anon_sym___try] = ACTIONS(1992),
    [anon_sym___leave] = ACTIONS(1992),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(1994),
    [anon_sym_PLUS_PLUS] = ACTIONS(1994),
    [anon_sym_sizeof] = ACTIONS(1992),
    [anon_sym___alignof__] = ACTIONS(1992),
    [anon_sym___alignof] = ACTIONS(1992),
    [anon_sym__alignof] = ACTIONS(1992),
    [anon_sym_alignof] = ACTIONS(1992),
    [anon_sym__Alignof] = ACTIONS(1992),
    [anon_sym_offsetof] = ACTIONS(1992),
    [anon_sym__Generic] = ACTIONS(1992),
    [anon_sym_asm] = ACTIONS(1992),
    [anon_sym___asm__] = ACTIONS(1992),
    [sym_number_literal] = ACTIONS(1994),
    [anon_sym_L_SQUOTE] = ACTIONS(1994),
    [anon_sym_u_SQUOTE] = ACTIONS(1994),
    [anon_sym_U_SQUOTE] = ACTIONS(1994),
    [anon_sym_u8_SQUOTE] = ACTIONS(1994),
    [anon_sym_SQUOTE] = ACTIONS(1994),
    [anon_sym_L_DQUOTE] = ACTIONS(1994),
    [anon_sym_u_DQUOTE] = ACTIONS(1994),
    [anon_sym_U_DQUOTE] = ACTIONS(1994),
    [anon_sym_u8_DQUOTE] = ACTIONS(1994),
    [anon_sym_DQUOTE] = ACTIONS(1994),
    [sym_true] = ACTIONS(1992),
    [sym_false] = ACTIONS(1992),
    [anon_sym_NULL] = ACTIONS(1992),
    [anon_sym_nullptr] = ACTIONS(1992),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1992),
    [anon_sym_decltype] = ACTIONS(1992),
    [sym_virtual] = ACTIONS(1992),
    [anon_sym_explicit] = ACTIONS(1992),
    [anon_sym_typename] = ACTIONS(1992),
    [anon_sym_template] = ACTIONS(1992),
    [anon_sym_operator] = ACTIONS(1992),
    [anon_sym_try] = ACTIONS(1992),
    [anon_sym_delete] = ACTIONS(1992),
    [anon_sym_throw] = ACTIONS(1992),
    [anon_sym_namespace] = ACTIONS(1992),
    [anon_sym_using] = ACTIONS(1992),
    [anon_sym_static_assert] = ACTIONS(1992),
    [anon_sym_concept] = ACTIONS(1992),
    [anon_sym_co_return] = ACTIONS(1992),
    [anon_sym_co_yield] = ACTIONS(1992),
    [anon_sym_R_DQUOTE] = ACTIONS(1994),
    [anon_sym_LR_DQUOTE] = ACTIONS(1994),
    [anon_sym_uR_DQUOTE] = ACTIONS(1994),
    [anon_sym_UR_DQUOTE] = ACTIONS(1994),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1994),
    [anon_sym_co_await] = ACTIONS(1992),
    [anon_sym_new] = ACTIONS(1992),
    [anon_sym_requires] = ACTIONS(1992),
    [sym_this] = ACTIONS(1992),
    [anon_sym___launch_bounds__] = ACTIONS(1992),
  },
  [159] = {
    [sym_identifier] = ACTIONS(1996),
    [aux_sym_preproc_include_token1] = ACTIONS(1996),
    [aux_sym_preproc_def_token1] = ACTIONS(1996),
    [aux_sym_preproc_if_token1] = ACTIONS(1996),
    [aux_sym_preproc_if_token2] = ACTIONS(1996),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1996),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1996),
    [aux_sym_preproc_else_token1] = ACTIONS(1996),
    [aux_sym_preproc_elif_token1] = ACTIONS(1996),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1996),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1996),
    [sym_preproc_directive] = ACTIONS(1996),
    [anon_sym_LPAREN2] = ACTIONS(1998),
    [anon_sym_BANG] = ACTIONS(1998),
    [anon_sym_TILDE] = ACTIONS(1998),
    [anon_sym_DASH] = ACTIONS(1996),
    [anon_sym_PLUS] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(1998),
    [anon_sym_AMP_AMP] = ACTIONS(1998),
    [anon_sym_AMP] = ACTIONS(1996),
    [anon_sym_SEMI] = ACTIONS(1998),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_typedef] = ACTIONS(1996),
    [anon_sym___device__] = ACTIONS(1996),
    [anon_sym___host__] = ACTIONS(1996),
    [anon_sym___global__] = ACTIONS(1996),
    [anon_sym___forceinline__] = ACTIONS(1996),
    [anon_sym___noinline__] = ACTIONS(1996),
    [anon_sym_extern] = ACTIONS(1996),
    [anon_sym___attribute__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1998),
    [anon_sym___declspec] = ACTIONS(1996),
    [anon_sym___based] = ACTIONS(1996),
    [anon_sym___cdecl] = ACTIONS(1996),
    [anon_sym___clrcall] = ACTIONS(1996),
    [anon_sym___stdcall] = ACTIONS(1996),
    [anon_sym___fastcall] = ACTIONS(1996),
    [anon_sym___thiscall] = ACTIONS(1996),
    [anon_sym___vectorcall] = ACTIONS(1996),
    [anon_sym_LBRACE] = ACTIONS(1998),
    [anon_sym_signed] = ACTIONS(1996),
    [anon_sym_unsigned] = ACTIONS(1996),
    [anon_sym_long] = ACTIONS(1996),
    [anon_sym_short] = ACTIONS(1996),
    [anon_sym_LBRACK] = ACTIONS(1996),
    [anon_sym_static] = ACTIONS(1996),
    [anon_sym_register] = ACTIONS(1996),
    [anon_sym_inline] = ACTIONS(1996),
    [anon_sym___inline] = ACTIONS(1996),
    [anon_sym___inline__] = ACTIONS(1996),
    [anon_sym___forceinline] = ACTIONS(1996),
    [anon_sym_thread_local] = ACTIONS(1996),
    [anon_sym___thread] = ACTIONS(1996),
    [anon_sym_const] = ACTIONS(1996),
    [anon_sym_constexpr] = ACTIONS(1996),
    [anon_sym_volatile] = ACTIONS(1996),
    [anon_sym_restrict] = ACTIONS(1996),
    [anon_sym___restrict__] = ACTIONS(1996),
    [anon_sym__Atomic] = ACTIONS(1996),
    [anon_sym__Noreturn] = ACTIONS(1996),
    [anon_sym_noreturn] = ACTIONS(1996),
    [anon_sym_mutable] = ACTIONS(1996),
    [anon_sym_constinit] = ACTIONS(1996),
    [anon_sym_consteval] = ACTIONS(1996),
    [anon_sym___shared__] = ACTIONS(1996),
    [anon_sym___local__] = ACTIONS(1996),
    [anon_sym___constant__] = ACTIONS(1996),
    [anon_sym___managed__] = ACTIONS(1996),
    [anon_sym___grid_constant__] = ACTIONS(1996),
    [anon_sym_alignas] = ACTIONS(1996),
    [anon_sym__Alignas] = ACTIONS(1996),
    [sym_primitive_type] = ACTIONS(1996),
    [anon_sym_enum] = ACTIONS(1996),
    [anon_sym_class] = ACTIONS(1996),
    [anon_sym_struct] = ACTIONS(1996),
    [anon_sym_union] = ACTIONS(1996),
    [anon_sym_if] = ACTIONS(1996),
    [anon_sym_else] = ACTIONS(1996),
    [anon_sym_switch] = ACTIONS(1996),
    [anon_sym_case] = ACTIONS(1996),
    [anon_sym_default] = ACTIONS(1996),
    [anon_sym_while] = ACTIONS(1996),
    [anon_sym_do] = ACTIONS(1996),
    [anon_sym_for] = ACTIONS(1996),
    [anon_sym_return] = ACTIONS(1996),
    [anon_sym_break] = ACTIONS(1996),
    [anon_sym_continue] = ACTIONS(1996),
    [anon_sym_goto] = ACTIONS(1996),
    [anon_sym___try] = ACTIONS(1996),
    [anon_sym___leave] = ACTIONS(1996),
    [anon_sym_not] = ACTIONS(1996),
    [anon_sym_compl] = ACTIONS(1996),
    [anon_sym_DASH_DASH] = ACTIONS(1998),
    [anon_sym_PLUS_PLUS] = ACTIONS(1998),
    [anon_sym_sizeof] = ACTIONS(1996),
    [anon_sym___alignof__] = ACTIONS(1996),
    [anon_sym___alignof] = ACTIONS(1996),
    [anon_sym__alignof] = ACTIONS(1996),
    [anon_sym_alignof] = ACTIONS(1996),
    [anon_sym__Alignof] = ACTIONS(1996),
    [anon_sym_offsetof] = ACTIONS(1996),
    [anon_sym__Generic] = ACTIONS(1996),
    [anon_sym_asm] = ACTIONS(1996),
    [anon_sym___asm__] = ACTIONS(1996),
    [sym_number_literal] = ACTIONS(1998),
    [anon_sym_L_SQUOTE] = ACTIONS(1998),
    [anon_sym_u_SQUOTE] = ACTIONS(1998),
    [anon_sym_U_SQUOTE] = ACTIONS(1998),
    [anon_sym_u8_SQUOTE] = ACTIONS(1998),
    [anon_sym_SQUOTE] = ACTIONS(1998),
    [anon_sym_L_DQUOTE] = ACTIONS(1998),
    [anon_sym_u_DQUOTE] = ACTIONS(1998),
    [anon_sym_U_DQUOTE] = ACTIONS(1998),
    [anon_sym_u8_DQUOTE] = ACTIONS(1998),
    [anon_sym_DQUOTE] = ACTIONS(1998),
    [sym_true] = ACTIONS(1996),
    [sym_false] = ACTIONS(1996),
    [anon_sym_NULL] = ACTIONS(1996),
    [anon_sym_nullptr] = ACTIONS(1996),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1996),
    [anon_sym_decltype] = ACTIONS(1996),
    [sym_virtual] = ACTIONS(1996),
    [anon_sym_explicit] = ACTIONS(1996),
    [anon_sym_typename] = ACTIONS(1996),
    [anon_sym_template] = ACTIONS(1996),
    [anon_sym_operator] = ACTIONS(1996),
    [anon_sym_try] = ACTIONS(1996),
    [anon_sym_delete] = ACTIONS(1996),
    [anon_sym_throw] = ACTIONS(1996),
    [anon_sym_namespace] = ACTIONS(1996),
    [anon_sym_using] = ACTIONS(1996),
    [anon_sym_static_assert] = ACTIONS(1996),
    [anon_sym_concept] = ACTIONS(1996),
    [anon_sym_co_return] = ACTIONS(1996),
    [anon_sym_co_yield] = ACTIONS(1996),
    [anon_sym_R_DQUOTE] = ACTIONS(1998),
    [anon_sym_LR_DQUOTE] = ACTIONS(1998),
    [anon_sym_uR_DQUOTE] = ACTIONS(1998),
    [anon_sym_UR_DQUOTE] = ACTIONS(1998),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1998),
    [anon_sym_co_await] = ACTIONS(1996),
    [anon_sym_new] = ACTIONS(1996),
    [anon_sym_requires] = ACTIONS(1996),
    [sym_this] = ACTIONS(1996),
    [anon_sym___launch_bounds__] = ACTIONS(1996),
  },
  [160] = {
    [sym_identifier] = ACTIONS(2000),
    [aux_sym_preproc_include_token1] = ACTIONS(2000),
    [aux_sym_preproc_def_token1] = ACTIONS(2000),
    [aux_sym_preproc_if_token1] = ACTIONS(2000),
    [aux_sym_preproc_if_token2] = ACTIONS(2000),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2000),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2000),
    [aux_sym_preproc_else_token1] = ACTIONS(2000),
    [aux_sym_preproc_elif_token1] = ACTIONS(2000),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2000),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2000),
    [sym_preproc_directive] = ACTIONS(2000),
    [anon_sym_LPAREN2] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2002),
    [anon_sym_TILDE] = ACTIONS(2002),
    [anon_sym_DASH] = ACTIONS(2000),
    [anon_sym_PLUS] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(2002),
    [anon_sym_AMP_AMP] = ACTIONS(2002),
    [anon_sym_AMP] = ACTIONS(2000),
    [anon_sym_SEMI] = ACTIONS(2002),
    [anon_sym___extension__] = ACTIONS(2000),
    [anon_sym_typedef] = ACTIONS(2000),
    [anon_sym___device__] = ACTIONS(2000),
    [anon_sym___host__] = ACTIONS(2000),
    [anon_sym___global__] = ACTIONS(2000),
    [anon_sym___forceinline__] = ACTIONS(2000),
    [anon_sym___noinline__] = ACTIONS(2000),
    [anon_sym_extern] = ACTIONS(2000),
    [anon_sym___attribute__] = ACTIONS(2000),
    [anon_sym_COLON_COLON] = ACTIONS(2002),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2002),
    [anon_sym___declspec] = ACTIONS(2000),
    [anon_sym___based] = ACTIONS(2000),
    [anon_sym___cdecl] = ACTIONS(2000),
    [anon_sym___clrcall] = ACTIONS(2000),
    [anon_sym___stdcall] = ACTIONS(2000),
    [anon_sym___fastcall] = ACTIONS(2000),
    [anon_sym___thiscall] = ACTIONS(2000),
    [anon_sym___vectorcall] = ACTIONS(2000),
    [anon_sym_LBRACE] = ACTIONS(2002),
    [anon_sym_signed] = ACTIONS(2000),
    [anon_sym_unsigned] = ACTIONS(2000),
    [anon_sym_long] = ACTIONS(2000),
    [anon_sym_short] = ACTIONS(2000),
    [anon_sym_LBRACK] = ACTIONS(2000),
    [anon_sym_static] = ACTIONS(2000),
    [anon_sym_register] = ACTIONS(2000),
    [anon_sym_inline] = ACTIONS(2000),
    [anon_sym___inline] = ACTIONS(2000),
    [anon_sym___inline__] = ACTIONS(2000),
    [anon_sym___forceinline] = ACTIONS(2000),
    [anon_sym_thread_local] = ACTIONS(2000),
    [anon_sym___thread] = ACTIONS(2000),
    [anon_sym_const] = ACTIONS(2000),
    [anon_sym_constexpr] = ACTIONS(2000),
    [anon_sym_volatile] = ACTIONS(2000),
    [anon_sym_restrict] = ACTIONS(2000),
    [anon_sym___restrict__] = ACTIONS(2000),
    [anon_sym__Atomic] = ACTIONS(2000),
    [anon_sym__Noreturn] = ACTIONS(2000),
    [anon_sym_noreturn] = ACTIONS(2000),
    [anon_sym_mutable] = ACTIONS(2000),
    [anon_sym_constinit] = ACTIONS(2000),
    [anon_sym_consteval] = ACTIONS(2000),
    [anon_sym___shared__] = ACTIONS(2000),
    [anon_sym___local__] = ACTIONS(2000),
    [anon_sym___constant__] = ACTIONS(2000),
    [anon_sym___managed__] = ACTIONS(2000),
    [anon_sym___grid_constant__] = ACTIONS(2000),
    [anon_sym_alignas] = ACTIONS(2000),
    [anon_sym__Alignas] = ACTIONS(2000),
    [sym_primitive_type] = ACTIONS(2000),
    [anon_sym_enum] = ACTIONS(2000),
    [anon_sym_class] = ACTIONS(2000),
    [anon_sym_struct] = ACTIONS(2000),
    [anon_sym_union] = ACTIONS(2000),
    [anon_sym_if] = ACTIONS(2000),
    [anon_sym_else] = ACTIONS(2000),
    [anon_sym_switch] = ACTIONS(2000),
    [anon_sym_case] = ACTIONS(2000),
    [anon_sym_default] = ACTIONS(2000),
    [anon_sym_while] = ACTIONS(2000),
    [anon_sym_do] = ACTIONS(2000),
    [anon_sym_for] = ACTIONS(2000),
    [anon_sym_return] = ACTIONS(2000),
    [anon_sym_break] = ACTIONS(2000),
    [anon_sym_continue] = ACTIONS(2000),
    [anon_sym_goto] = ACTIONS(2000),
    [anon_sym___try] = ACTIONS(2000),
    [anon_sym___leave] = ACTIONS(2000),
    [anon_sym_not] = ACTIONS(2000),
    [anon_sym_compl] = ACTIONS(2000),
    [anon_sym_DASH_DASH] = ACTIONS(2002),
    [anon_sym_PLUS_PLUS] = ACTIONS(2002),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(2000),
    [anon_sym___alignof] = ACTIONS(2000),
    [anon_sym__alignof] = ACTIONS(2000),
    [anon_sym_alignof] = ACTIONS(2000),
    [anon_sym__Alignof] = ACTIONS(2000),
    [anon_sym_offsetof] = ACTIONS(2000),
    [anon_sym__Generic] = ACTIONS(2000),
    [anon_sym_asm] = ACTIONS(2000),
    [anon_sym___asm__] = ACTIONS(2000),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2002),
    [anon_sym_u_SQUOTE] = ACTIONS(2002),
    [anon_sym_U_SQUOTE] = ACTIONS(2002),
    [anon_sym_u8_SQUOTE] = ACTIONS(2002),
    [anon_sym_SQUOTE] = ACTIONS(2002),
    [anon_sym_L_DQUOTE] = ACTIONS(2002),
    [anon_sym_u_DQUOTE] = ACTIONS(2002),
    [anon_sym_U_DQUOTE] = ACTIONS(2002),
    [anon_sym_u8_DQUOTE] = ACTIONS(2002),
    [anon_sym_DQUOTE] = ACTIONS(2002),
    [sym_true] = ACTIONS(2000),
    [sym_false] = ACTIONS(2000),
    [anon_sym_NULL] = ACTIONS(2000),
    [anon_sym_nullptr] = ACTIONS(2000),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2000),
    [anon_sym_decltype] = ACTIONS(2000),
    [sym_virtual] = ACTIONS(2000),
    [anon_sym_explicit] = ACTIONS(2000),
    [anon_sym_typename] = ACTIONS(2000),
    [anon_sym_template] = ACTIONS(2000),
    [anon_sym_operator] = ACTIONS(2000),
    [anon_sym_try] = ACTIONS(2000),
    [anon_sym_delete] = ACTIONS(2000),
    [anon_sym_throw] = ACTIONS(2000),
    [anon_sym_namespace] = ACTIONS(2000),
    [anon_sym_using] = ACTIONS(2000),
    [anon_sym_static_assert] = ACTIONS(2000),
    [anon_sym_concept] = ACTIONS(2000),
    [anon_sym_co_return] = ACTIONS(2000),
    [anon_sym_co_yield] = ACTIONS(2000),
    [anon_sym_R_DQUOTE] = ACTIONS(2002),
    [anon_sym_LR_DQUOTE] = ACTIONS(2002),
    [anon_sym_uR_DQUOTE] = ACTIONS(2002),
    [anon_sym_UR_DQUOTE] = ACTIONS(2002),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2002),
    [anon_sym_co_await] = ACTIONS(2000),
    [anon_sym_new] = ACTIONS(2000),
    [anon_sym_requires] = ACTIONS(2000),
    [sym_this] = ACTIONS(2000),
    [anon_sym___launch_bounds__] = ACTIONS(2000),
  },
  [161] = {
    [sym_identifier] = ACTIONS(2004),
    [aux_sym_preproc_include_token1] = ACTIONS(2004),
    [aux_sym_preproc_def_token1] = ACTIONS(2004),
    [aux_sym_preproc_if_token1] = ACTIONS(2004),
    [aux_sym_preproc_if_token2] = ACTIONS(2004),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2004),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2004),
    [aux_sym_preproc_else_token1] = ACTIONS(2004),
    [aux_sym_preproc_elif_token1] = ACTIONS(2004),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2004),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2004),
    [sym_preproc_directive] = ACTIONS(2004),
    [anon_sym_LPAREN2] = ACTIONS(2006),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(2006),
    [anon_sym_DASH] = ACTIONS(2004),
    [anon_sym_PLUS] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(2006),
    [anon_sym_AMP_AMP] = ACTIONS(2006),
    [anon_sym_AMP] = ACTIONS(2004),
    [anon_sym_SEMI] = ACTIONS(2006),
    [anon_sym___extension__] = ACTIONS(2004),
    [anon_sym_typedef] = ACTIONS(2004),
    [anon_sym___device__] = ACTIONS(2004),
    [anon_sym___host__] = ACTIONS(2004),
    [anon_sym___global__] = ACTIONS(2004),
    [anon_sym___forceinline__] = ACTIONS(2004),
    [anon_sym___noinline__] = ACTIONS(2004),
    [anon_sym_extern] = ACTIONS(2004),
    [anon_sym___attribute__] = ACTIONS(2004),
    [anon_sym_COLON_COLON] = ACTIONS(2006),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2006),
    [anon_sym___declspec] = ACTIONS(2004),
    [anon_sym___based] = ACTIONS(2004),
    [anon_sym___cdecl] = ACTIONS(2004),
    [anon_sym___clrcall] = ACTIONS(2004),
    [anon_sym___stdcall] = ACTIONS(2004),
    [anon_sym___fastcall] = ACTIONS(2004),
    [anon_sym___thiscall] = ACTIONS(2004),
    [anon_sym___vectorcall] = ACTIONS(2004),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_signed] = ACTIONS(2004),
    [anon_sym_unsigned] = ACTIONS(2004),
    [anon_sym_long] = ACTIONS(2004),
    [anon_sym_short] = ACTIONS(2004),
    [anon_sym_LBRACK] = ACTIONS(2004),
    [anon_sym_static] = ACTIONS(2004),
    [anon_sym_register] = ACTIONS(2004),
    [anon_sym_inline] = ACTIONS(2004),
    [anon_sym___inline] = ACTIONS(2004),
    [anon_sym___inline__] = ACTIONS(2004),
    [anon_sym___forceinline] = ACTIONS(2004),
    [anon_sym_thread_local] = ACTIONS(2004),
    [anon_sym___thread] = ACTIONS(2004),
    [anon_sym_const] = ACTIONS(2004),
    [anon_sym_constexpr] = ACTIONS(2004),
    [anon_sym_volatile] = ACTIONS(2004),
    [anon_sym_restrict] = ACTIONS(2004),
    [anon_sym___restrict__] = ACTIONS(2004),
    [anon_sym__Atomic] = ACTIONS(2004),
    [anon_sym__Noreturn] = ACTIONS(2004),
    [anon_sym_noreturn] = ACTIONS(2004),
    [anon_sym_mutable] = ACTIONS(2004),
    [anon_sym_constinit] = ACTIONS(2004),
    [anon_sym_consteval] = ACTIONS(2004),
    [anon_sym___shared__] = ACTIONS(2004),
    [anon_sym___local__] = ACTIONS(2004),
    [anon_sym___constant__] = ACTIONS(2004),
    [anon_sym___managed__] = ACTIONS(2004),
    [anon_sym___grid_constant__] = ACTIONS(2004),
    [anon_sym_alignas] = ACTIONS(2004),
    [anon_sym__Alignas] = ACTIONS(2004),
    [sym_primitive_type] = ACTIONS(2004),
    [anon_sym_enum] = ACTIONS(2004),
    [anon_sym_class] = ACTIONS(2004),
    [anon_sym_struct] = ACTIONS(2004),
    [anon_sym_union] = ACTIONS(2004),
    [anon_sym_if] = ACTIONS(2004),
    [anon_sym_else] = ACTIONS(2004),
    [anon_sym_switch] = ACTIONS(2004),
    [anon_sym_case] = ACTIONS(2004),
    [anon_sym_default] = ACTIONS(2004),
    [anon_sym_while] = ACTIONS(2004),
    [anon_sym_do] = ACTIONS(2004),
    [anon_sym_for] = ACTIONS(2004),
    [anon_sym_return] = ACTIONS(2004),
    [anon_sym_break] = ACTIONS(2004),
    [anon_sym_continue] = ACTIONS(2004),
    [anon_sym_goto] = ACTIONS(2004),
    [anon_sym___try] = ACTIONS(2004),
    [anon_sym___leave] = ACTIONS(2004),
    [anon_sym_not] = ACTIONS(2004),
    [anon_sym_compl] = ACTIONS(2004),
    [anon_sym_DASH_DASH] = ACTIONS(2006),
    [anon_sym_PLUS_PLUS] = ACTIONS(2006),
    [anon_sym_sizeof] = ACTIONS(2004),
    [anon_sym___alignof__] = ACTIONS(2004),
    [anon_sym___alignof] = ACTIONS(2004),
    [anon_sym__alignof] = ACTIONS(2004),
    [anon_sym_alignof] = ACTIONS(2004),
    [anon_sym__Alignof] = ACTIONS(2004),
    [anon_sym_offsetof] = ACTIONS(2004),
    [anon_sym__Generic] = ACTIONS(2004),
    [anon_sym_asm] = ACTIONS(2004),
    [anon_sym___asm__] = ACTIONS(2004),
    [sym_number_literal] = ACTIONS(2006),
    [anon_sym_L_SQUOTE] = ACTIONS(2006),
    [anon_sym_u_SQUOTE] = ACTIONS(2006),
    [anon_sym_U_SQUOTE] = ACTIONS(2006),
    [anon_sym_u8_SQUOTE] = ACTIONS(2006),
    [anon_sym_SQUOTE] = ACTIONS(2006),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(2004),
    [sym_false] = ACTIONS(2004),
    [anon_sym_NULL] = ACTIONS(2004),
    [anon_sym_nullptr] = ACTIONS(2004),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2004),
    [anon_sym_decltype] = ACTIONS(2004),
    [sym_virtual] = ACTIONS(2004),
    [anon_sym_explicit] = ACTIONS(2004),
    [anon_sym_typename] = ACTIONS(2004),
    [anon_sym_template] = ACTIONS(2004),
    [anon_sym_operator] = ACTIONS(2004),
    [anon_sym_try] = ACTIONS(2004),
    [anon_sym_delete] = ACTIONS(2004),
    [anon_sym_throw] = ACTIONS(2004),
    [anon_sym_namespace] = ACTIONS(2004),
    [anon_sym_using] = ACTIONS(2004),
    [anon_sym_static_assert] = ACTIONS(2004),
    [anon_sym_concept] = ACTIONS(2004),
    [anon_sym_co_return] = ACTIONS(2004),
    [anon_sym_co_yield] = ACTIONS(2004),
    [anon_sym_R_DQUOTE] = ACTIONS(2006),
    [anon_sym_LR_DQUOTE] = ACTIONS(2006),
    [anon_sym_uR_DQUOTE] = ACTIONS(2006),
    [anon_sym_UR_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2006),
    [anon_sym_co_await] = ACTIONS(2004),
    [anon_sym_new] = ACTIONS(2004),
    [anon_sym_requires] = ACTIONS(2004),
    [sym_this] = ACTIONS(2004),
    [anon_sym___launch_bounds__] = ACTIONS(2004),
  },
  [162] = {
    [sym_identifier] = ACTIONS(2008),
    [aux_sym_preproc_include_token1] = ACTIONS(2008),
    [aux_sym_preproc_def_token1] = ACTIONS(2008),
    [aux_sym_preproc_if_token1] = ACTIONS(2008),
    [aux_sym_preproc_if_token2] = ACTIONS(2008),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2008),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2008),
    [aux_sym_preproc_else_token1] = ACTIONS(2008),
    [aux_sym_preproc_elif_token1] = ACTIONS(2008),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2008),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2008),
    [sym_preproc_directive] = ACTIONS(2008),
    [anon_sym_LPAREN2] = ACTIONS(2010),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_TILDE] = ACTIONS(2010),
    [anon_sym_DASH] = ACTIONS(2008),
    [anon_sym_PLUS] = ACTIONS(2008),
    [anon_sym_STAR] = ACTIONS(2010),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2008),
    [anon_sym_SEMI] = ACTIONS(2010),
    [anon_sym___extension__] = ACTIONS(2008),
    [anon_sym_typedef] = ACTIONS(2008),
    [anon_sym___device__] = ACTIONS(2008),
    [anon_sym___host__] = ACTIONS(2008),
    [anon_sym___global__] = ACTIONS(2008),
    [anon_sym___forceinline__] = ACTIONS(2008),
    [anon_sym___noinline__] = ACTIONS(2008),
    [anon_sym_extern] = ACTIONS(2008),
    [anon_sym___attribute__] = ACTIONS(2008),
    [anon_sym_COLON_COLON] = ACTIONS(2010),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2010),
    [anon_sym___declspec] = ACTIONS(2008),
    [anon_sym___based] = ACTIONS(2008),
    [anon_sym___cdecl] = ACTIONS(2008),
    [anon_sym___clrcall] = ACTIONS(2008),
    [anon_sym___stdcall] = ACTIONS(2008),
    [anon_sym___fastcall] = ACTIONS(2008),
    [anon_sym___thiscall] = ACTIONS(2008),
    [anon_sym___vectorcall] = ACTIONS(2008),
    [anon_sym_LBRACE] = ACTIONS(2010),
    [anon_sym_signed] = ACTIONS(2008),
    [anon_sym_unsigned] = ACTIONS(2008),
    [anon_sym_long] = ACTIONS(2008),
    [anon_sym_short] = ACTIONS(2008),
    [anon_sym_LBRACK] = ACTIONS(2008),
    [anon_sym_static] = ACTIONS(2008),
    [anon_sym_register] = ACTIONS(2008),
    [anon_sym_inline] = ACTIONS(2008),
    [anon_sym___inline] = ACTIONS(2008),
    [anon_sym___inline__] = ACTIONS(2008),
    [anon_sym___forceinline] = ACTIONS(2008),
    [anon_sym_thread_local] = ACTIONS(2008),
    [anon_sym___thread] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(2008),
    [anon_sym_constexpr] = ACTIONS(2008),
    [anon_sym_volatile] = ACTIONS(2008),
    [anon_sym_restrict] = ACTIONS(2008),
    [anon_sym___restrict__] = ACTIONS(2008),
    [anon_sym__Atomic] = ACTIONS(2008),
    [anon_sym__Noreturn] = ACTIONS(2008),
    [anon_sym_noreturn] = ACTIONS(2008),
    [anon_sym_mutable] = ACTIONS(2008),
    [anon_sym_constinit] = ACTIONS(2008),
    [anon_sym_consteval] = ACTIONS(2008),
    [anon_sym___shared__] = ACTIONS(2008),
    [anon_sym___local__] = ACTIONS(2008),
    [anon_sym___constant__] = ACTIONS(2008),
    [anon_sym___managed__] = ACTIONS(2008),
    [anon_sym___grid_constant__] = ACTIONS(2008),
    [anon_sym_alignas] = ACTIONS(2008),
    [anon_sym__Alignas] = ACTIONS(2008),
    [sym_primitive_type] = ACTIONS(2008),
    [anon_sym_enum] = ACTIONS(2008),
    [anon_sym_class] = ACTIONS(2008),
    [anon_sym_struct] = ACTIONS(2008),
    [anon_sym_union] = ACTIONS(2008),
    [anon_sym_if] = ACTIONS(2008),
    [anon_sym_else] = ACTIONS(2008),
    [anon_sym_switch] = ACTIONS(2008),
    [anon_sym_case] = ACTIONS(2008),
    [anon_sym_default] = ACTIONS(2008),
    [anon_sym_while] = ACTIONS(2008),
    [anon_sym_do] = ACTIONS(2008),
    [anon_sym_for] = ACTIONS(2008),
    [anon_sym_return] = ACTIONS(2008),
    [anon_sym_break] = ACTIONS(2008),
    [anon_sym_continue] = ACTIONS(2008),
    [anon_sym_goto] = ACTIONS(2008),
    [anon_sym___try] = ACTIONS(2008),
    [anon_sym___leave] = ACTIONS(2008),
    [anon_sym_not] = ACTIONS(2008),
    [anon_sym_compl] = ACTIONS(2008),
    [anon_sym_DASH_DASH] = ACTIONS(2010),
    [anon_sym_PLUS_PLUS] = ACTIONS(2010),
    [anon_sym_sizeof] = ACTIONS(2008),
    [anon_sym___alignof__] = ACTIONS(2008),
    [anon_sym___alignof] = ACTIONS(2008),
    [anon_sym__alignof] = ACTIONS(2008),
    [anon_sym_alignof] = ACTIONS(2008),
    [anon_sym__Alignof] = ACTIONS(2008),
    [anon_sym_offsetof] = ACTIONS(2008),
    [anon_sym__Generic] = ACTIONS(2008),
    [anon_sym_asm] = ACTIONS(2008),
    [anon_sym___asm__] = ACTIONS(2008),
    [sym_number_literal] = ACTIONS(2010),
    [anon_sym_L_SQUOTE] = ACTIONS(2010),
    [anon_sym_u_SQUOTE] = ACTIONS(2010),
    [anon_sym_U_SQUOTE] = ACTIONS(2010),
    [anon_sym_u8_SQUOTE] = ACTIONS(2010),
    [anon_sym_SQUOTE] = ACTIONS(2010),
    [anon_sym_L_DQUOTE] = ACTIONS(2010),
    [anon_sym_u_DQUOTE] = ACTIONS(2010),
    [anon_sym_U_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8_DQUOTE] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [sym_true] = ACTIONS(2008),
    [sym_false] = ACTIONS(2008),
    [anon_sym_NULL] = ACTIONS(2008),
    [anon_sym_nullptr] = ACTIONS(2008),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2008),
    [anon_sym_decltype] = ACTIONS(2008),
    [sym_virtual] = ACTIONS(2008),
    [anon_sym_explicit] = ACTIONS(2008),
    [anon_sym_typename] = ACTIONS(2008),
    [anon_sym_template] = ACTIONS(2008),
    [anon_sym_operator] = ACTIONS(2008),
    [anon_sym_try] = ACTIONS(2008),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_throw] = ACTIONS(2008),
    [anon_sym_namespace] = ACTIONS(2008),
    [anon_sym_using] = ACTIONS(2008),
    [anon_sym_static_assert] = ACTIONS(2008),
    [anon_sym_concept] = ACTIONS(2008),
    [anon_sym_co_return] = ACTIONS(2008),
    [anon_sym_co_yield] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2008),
    [anon_sym_new] = ACTIONS(2008),
    [anon_sym_requires] = ACTIONS(2008),
    [sym_this] = ACTIONS(2008),
    [anon_sym___launch_bounds__] = ACTIONS(2008),
  },
  [163] = {
    [sym_identifier] = ACTIONS(2012),
    [aux_sym_preproc_include_token1] = ACTIONS(2012),
    [aux_sym_preproc_def_token1] = ACTIONS(2012),
    [aux_sym_preproc_if_token1] = ACTIONS(2012),
    [aux_sym_preproc_if_token2] = ACTIONS(2012),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2012),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2012),
    [aux_sym_preproc_else_token1] = ACTIONS(2012),
    [aux_sym_preproc_elif_token1] = ACTIONS(2012),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2012),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2012),
    [sym_preproc_directive] = ACTIONS(2012),
    [anon_sym_LPAREN2] = ACTIONS(2014),
    [anon_sym_BANG] = ACTIONS(2014),
    [anon_sym_TILDE] = ACTIONS(2014),
    [anon_sym_DASH] = ACTIONS(2012),
    [anon_sym_PLUS] = ACTIONS(2012),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_AMP_AMP] = ACTIONS(2014),
    [anon_sym_AMP] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2014),
    [anon_sym___extension__] = ACTIONS(2012),
    [anon_sym_typedef] = ACTIONS(2012),
    [anon_sym___device__] = ACTIONS(2012),
    [anon_sym___host__] = ACTIONS(2012),
    [anon_sym___global__] = ACTIONS(2012),
    [anon_sym___forceinline__] = ACTIONS(2012),
    [anon_sym___noinline__] = ACTIONS(2012),
    [anon_sym_extern] = ACTIONS(2012),
    [anon_sym___attribute__] = ACTIONS(2012),
    [anon_sym_COLON_COLON] = ACTIONS(2014),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2014),
    [anon_sym___declspec] = ACTIONS(2012),
    [anon_sym___based] = ACTIONS(2012),
    [anon_sym___cdecl] = ACTIONS(2012),
    [anon_sym___clrcall] = ACTIONS(2012),
    [anon_sym___stdcall] = ACTIONS(2012),
    [anon_sym___fastcall] = ACTIONS(2012),
    [anon_sym___thiscall] = ACTIONS(2012),
    [anon_sym___vectorcall] = ACTIONS(2012),
    [anon_sym_LBRACE] = ACTIONS(2014),
    [anon_sym_signed] = ACTIONS(2012),
    [anon_sym_unsigned] = ACTIONS(2012),
    [anon_sym_long] = ACTIONS(2012),
    [anon_sym_short] = ACTIONS(2012),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_static] = ACTIONS(2012),
    [anon_sym_register] = ACTIONS(2012),
    [anon_sym_inline] = ACTIONS(2012),
    [anon_sym___inline] = ACTIONS(2012),
    [anon_sym___inline__] = ACTIONS(2012),
    [anon_sym___forceinline] = ACTIONS(2012),
    [anon_sym_thread_local] = ACTIONS(2012),
    [anon_sym___thread] = ACTIONS(2012),
    [anon_sym_const] = ACTIONS(2012),
    [anon_sym_constexpr] = ACTIONS(2012),
    [anon_sym_volatile] = ACTIONS(2012),
    [anon_sym_restrict] = ACTIONS(2012),
    [anon_sym___restrict__] = ACTIONS(2012),
    [anon_sym__Atomic] = ACTIONS(2012),
    [anon_sym__Noreturn] = ACTIONS(2012),
    [anon_sym_noreturn] = ACTIONS(2012),
    [anon_sym_mutable] = ACTIONS(2012),
    [anon_sym_constinit] = ACTIONS(2012),
    [anon_sym_consteval] = ACTIONS(2012),
    [anon_sym___shared__] = ACTIONS(2012),
    [anon_sym___local__] = ACTIONS(2012),
    [anon_sym___constant__] = ACTIONS(2012),
    [anon_sym___managed__] = ACTIONS(2012),
    [anon_sym___grid_constant__] = ACTIONS(2012),
    [anon_sym_alignas] = ACTIONS(2012),
    [anon_sym__Alignas] = ACTIONS(2012),
    [sym_primitive_type] = ACTIONS(2012),
    [anon_sym_enum] = ACTIONS(2012),
    [anon_sym_class] = ACTIONS(2012),
    [anon_sym_struct] = ACTIONS(2012),
    [anon_sym_union] = ACTIONS(2012),
    [anon_sym_if] = ACTIONS(2012),
    [anon_sym_else] = ACTIONS(2012),
    [anon_sym_switch] = ACTIONS(2012),
    [anon_sym_case] = ACTIONS(2012),
    [anon_sym_default] = ACTIONS(2012),
    [anon_sym_while] = ACTIONS(2012),
    [anon_sym_do] = ACTIONS(2012),
    [anon_sym_for] = ACTIONS(2012),
    [anon_sym_return] = ACTIONS(2012),
    [anon_sym_break] = ACTIONS(2012),
    [anon_sym_continue] = ACTIONS(2012),
    [anon_sym_goto] = ACTIONS(2012),
    [anon_sym___try] = ACTIONS(2012),
    [anon_sym___leave] = ACTIONS(2012),
    [anon_sym_not] = ACTIONS(2012),
    [anon_sym_compl] = ACTIONS(2012),
    [anon_sym_DASH_DASH] = ACTIONS(2014),
    [anon_sym_PLUS_PLUS] = ACTIONS(2014),
    [anon_sym_sizeof] = ACTIONS(2012),
    [anon_sym___alignof__] = ACTIONS(2012),
    [anon_sym___alignof] = ACTIONS(2012),
    [anon_sym__alignof] = ACTIONS(2012),
    [anon_sym_alignof] = ACTIONS(2012),
    [anon_sym__Alignof] = ACTIONS(2012),
    [anon_sym_offsetof] = ACTIONS(2012),
    [anon_sym__Generic] = ACTIONS(2012),
    [anon_sym_asm] = ACTIONS(2012),
    [anon_sym___asm__] = ACTIONS(2012),
    [sym_number_literal] = ACTIONS(2014),
    [anon_sym_L_SQUOTE] = ACTIONS(2014),
    [anon_sym_u_SQUOTE] = ACTIONS(2014),
    [anon_sym_U_SQUOTE] = ACTIONS(2014),
    [anon_sym_u8_SQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2014),
    [anon_sym_L_DQUOTE] = ACTIONS(2014),
    [anon_sym_u_DQUOTE] = ACTIONS(2014),
    [anon_sym_U_DQUOTE] = ACTIONS(2014),
    [anon_sym_u8_DQUOTE] = ACTIONS(2014),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [sym_true] = ACTIONS(2012),
    [sym_false] = ACTIONS(2012),
    [anon_sym_NULL] = ACTIONS(2012),
    [anon_sym_nullptr] = ACTIONS(2012),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2012),
    [anon_sym_decltype] = ACTIONS(2012),
    [sym_virtual] = ACTIONS(2012),
    [anon_sym_explicit] = ACTIONS(2012),
    [anon_sym_typename] = ACTIONS(2012),
    [anon_sym_template] = ACTIONS(2012),
    [anon_sym_operator] = ACTIONS(2012),
    [anon_sym_try] = ACTIONS(2012),
    [anon_sym_delete] = ACTIONS(2012),
    [anon_sym_throw] = ACTIONS(2012),
    [anon_sym_namespace] = ACTIONS(2012),
    [anon_sym_using] = ACTIONS(2012),
    [anon_sym_static_assert] = ACTIONS(2012),
    [anon_sym_concept] = ACTIONS(2012),
    [anon_sym_co_return] = ACTIONS(2012),
    [anon_sym_co_yield] = ACTIONS(2012),
    [anon_sym_R_DQUOTE] = ACTIONS(2014),
    [anon_sym_LR_DQUOTE] = ACTIONS(2014),
    [anon_sym_uR_DQUOTE] = ACTIONS(2014),
    [anon_sym_UR_DQUOTE] = ACTIONS(2014),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2014),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2012),
    [anon_sym_requires] = ACTIONS(2012),
    [sym_this] = ACTIONS(2012),
    [anon_sym___launch_bounds__] = ACTIONS(2012),
  },
  [164] = {
    [sym_identifier] = ACTIONS(2016),
    [aux_sym_preproc_include_token1] = ACTIONS(2016),
    [aux_sym_preproc_def_token1] = ACTIONS(2016),
    [aux_sym_preproc_if_token1] = ACTIONS(2016),
    [aux_sym_preproc_if_token2] = ACTIONS(2016),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2016),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2016),
    [aux_sym_preproc_else_token1] = ACTIONS(2016),
    [aux_sym_preproc_elif_token1] = ACTIONS(2016),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2016),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2016),
    [sym_preproc_directive] = ACTIONS(2016),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(2018),
    [anon_sym_TILDE] = ACTIONS(2018),
    [anon_sym_DASH] = ACTIONS(2016),
    [anon_sym_PLUS] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(2018),
    [anon_sym_AMP_AMP] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(2016),
    [anon_sym_SEMI] = ACTIONS(2018),
    [anon_sym___extension__] = ACTIONS(2016),
    [anon_sym_typedef] = ACTIONS(2016),
    [anon_sym___device__] = ACTIONS(2016),
    [anon_sym___host__] = ACTIONS(2016),
    [anon_sym___global__] = ACTIONS(2016),
    [anon_sym___forceinline__] = ACTIONS(2016),
    [anon_sym___noinline__] = ACTIONS(2016),
    [anon_sym_extern] = ACTIONS(2016),
    [anon_sym___attribute__] = ACTIONS(2016),
    [anon_sym_COLON_COLON] = ACTIONS(2018),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2018),
    [anon_sym___declspec] = ACTIONS(2016),
    [anon_sym___based] = ACTIONS(2016),
    [anon_sym___cdecl] = ACTIONS(2016),
    [anon_sym___clrcall] = ACTIONS(2016),
    [anon_sym___stdcall] = ACTIONS(2016),
    [anon_sym___fastcall] = ACTIONS(2016),
    [anon_sym___thiscall] = ACTIONS(2016),
    [anon_sym___vectorcall] = ACTIONS(2016),
    [anon_sym_LBRACE] = ACTIONS(2018),
    [anon_sym_signed] = ACTIONS(2016),
    [anon_sym_unsigned] = ACTIONS(2016),
    [anon_sym_long] = ACTIONS(2016),
    [anon_sym_short] = ACTIONS(2016),
    [anon_sym_LBRACK] = ACTIONS(2016),
    [anon_sym_static] = ACTIONS(2016),
    [anon_sym_register] = ACTIONS(2016),
    [anon_sym_inline] = ACTIONS(2016),
    [anon_sym___inline] = ACTIONS(2016),
    [anon_sym___inline__] = ACTIONS(2016),
    [anon_sym___forceinline] = ACTIONS(2016),
    [anon_sym_thread_local] = ACTIONS(2016),
    [anon_sym___thread] = ACTIONS(2016),
    [anon_sym_const] = ACTIONS(2016),
    [anon_sym_constexpr] = ACTIONS(2016),
    [anon_sym_volatile] = ACTIONS(2016),
    [anon_sym_restrict] = ACTIONS(2016),
    [anon_sym___restrict__] = ACTIONS(2016),
    [anon_sym__Atomic] = ACTIONS(2016),
    [anon_sym__Noreturn] = ACTIONS(2016),
    [anon_sym_noreturn] = ACTIONS(2016),
    [anon_sym_mutable] = ACTIONS(2016),
    [anon_sym_constinit] = ACTIONS(2016),
    [anon_sym_consteval] = ACTIONS(2016),
    [anon_sym___shared__] = ACTIONS(2016),
    [anon_sym___local__] = ACTIONS(2016),
    [anon_sym___constant__] = ACTIONS(2016),
    [anon_sym___managed__] = ACTIONS(2016),
    [anon_sym___grid_constant__] = ACTIONS(2016),
    [anon_sym_alignas] = ACTIONS(2016),
    [anon_sym__Alignas] = ACTIONS(2016),
    [sym_primitive_type] = ACTIONS(2016),
    [anon_sym_enum] = ACTIONS(2016),
    [anon_sym_class] = ACTIONS(2016),
    [anon_sym_struct] = ACTIONS(2016),
    [anon_sym_union] = ACTIONS(2016),
    [anon_sym_if] = ACTIONS(2016),
    [anon_sym_else] = ACTIONS(2016),
    [anon_sym_switch] = ACTIONS(2016),
    [anon_sym_case] = ACTIONS(2016),
    [anon_sym_default] = ACTIONS(2016),
    [anon_sym_while] = ACTIONS(2016),
    [anon_sym_do] = ACTIONS(2016),
    [anon_sym_for] = ACTIONS(2016),
    [anon_sym_return] = ACTIONS(2016),
    [anon_sym_break] = ACTIONS(2016),
    [anon_sym_continue] = ACTIONS(2016),
    [anon_sym_goto] = ACTIONS(2016),
    [anon_sym___try] = ACTIONS(2016),
    [anon_sym___leave] = ACTIONS(2016),
    [anon_sym_not] = ACTIONS(2016),
    [anon_sym_compl] = ACTIONS(2016),
    [anon_sym_DASH_DASH] = ACTIONS(2018),
    [anon_sym_PLUS_PLUS] = ACTIONS(2018),
    [anon_sym_sizeof] = ACTIONS(2016),
    [anon_sym___alignof__] = ACTIONS(2016),
    [anon_sym___alignof] = ACTIONS(2016),
    [anon_sym__alignof] = ACTIONS(2016),
    [anon_sym_alignof] = ACTIONS(2016),
    [anon_sym__Alignof] = ACTIONS(2016),
    [anon_sym_offsetof] = ACTIONS(2016),
    [anon_sym__Generic] = ACTIONS(2016),
    [anon_sym_asm] = ACTIONS(2016),
    [anon_sym___asm__] = ACTIONS(2016),
    [sym_number_literal] = ACTIONS(2018),
    [anon_sym_L_SQUOTE] = ACTIONS(2018),
    [anon_sym_u_SQUOTE] = ACTIONS(2018),
    [anon_sym_U_SQUOTE] = ACTIONS(2018),
    [anon_sym_u8_SQUOTE] = ACTIONS(2018),
    [anon_sym_SQUOTE] = ACTIONS(2018),
    [anon_sym_L_DQUOTE] = ACTIONS(2018),
    [anon_sym_u_DQUOTE] = ACTIONS(2018),
    [anon_sym_U_DQUOTE] = ACTIONS(2018),
    [anon_sym_u8_DQUOTE] = ACTIONS(2018),
    [anon_sym_DQUOTE] = ACTIONS(2018),
    [sym_true] = ACTIONS(2016),
    [sym_false] = ACTIONS(2016),
    [anon_sym_NULL] = ACTIONS(2016),
    [anon_sym_nullptr] = ACTIONS(2016),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2016),
    [anon_sym_decltype] = ACTIONS(2016),
    [sym_virtual] = ACTIONS(2016),
    [anon_sym_explicit] = ACTIONS(2016),
    [anon_sym_typename] = ACTIONS(2016),
    [anon_sym_template] = ACTIONS(2016),
    [anon_sym_operator] = ACTIONS(2016),
    [anon_sym_try] = ACTIONS(2016),
    [anon_sym_delete] = ACTIONS(2016),
    [anon_sym_throw] = ACTIONS(2016),
    [anon_sym_namespace] = ACTIONS(2016),
    [anon_sym_using] = ACTIONS(2016),
    [anon_sym_static_assert] = ACTIONS(2016),
    [anon_sym_concept] = ACTIONS(2016),
    [anon_sym_co_return] = ACTIONS(2016),
    [anon_sym_co_yield] = ACTIONS(2016),
    [anon_sym_R_DQUOTE] = ACTIONS(2018),
    [anon_sym_LR_DQUOTE] = ACTIONS(2018),
    [anon_sym_uR_DQUOTE] = ACTIONS(2018),
    [anon_sym_UR_DQUOTE] = ACTIONS(2018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2018),
    [anon_sym_co_await] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2016),
    [anon_sym_requires] = ACTIONS(2016),
    [sym_this] = ACTIONS(2016),
    [anon_sym___launch_bounds__] = ACTIONS(2016),
  },
  [165] = {
    [sym_identifier] = ACTIONS(2020),
    [aux_sym_preproc_include_token1] = ACTIONS(2020),
    [aux_sym_preproc_def_token1] = ACTIONS(2020),
    [aux_sym_preproc_if_token1] = ACTIONS(2020),
    [aux_sym_preproc_if_token2] = ACTIONS(2020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2020),
    [aux_sym_preproc_else_token1] = ACTIONS(2020),
    [aux_sym_preproc_elif_token1] = ACTIONS(2020),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2020),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2020),
    [sym_preproc_directive] = ACTIONS(2020),
    [anon_sym_LPAREN2] = ACTIONS(2022),
    [anon_sym_BANG] = ACTIONS(2022),
    [anon_sym_TILDE] = ACTIONS(2022),
    [anon_sym_DASH] = ACTIONS(2020),
    [anon_sym_PLUS] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(2022),
    [anon_sym_AMP_AMP] = ACTIONS(2022),
    [anon_sym_AMP] = ACTIONS(2020),
    [anon_sym_SEMI] = ACTIONS(2022),
    [anon_sym___extension__] = ACTIONS(2020),
    [anon_sym_typedef] = ACTIONS(2020),
    [anon_sym___device__] = ACTIONS(2020),
    [anon_sym___host__] = ACTIONS(2020),
    [anon_sym___global__] = ACTIONS(2020),
    [anon_sym___forceinline__] = ACTIONS(2020),
    [anon_sym___noinline__] = ACTIONS(2020),
    [anon_sym_extern] = ACTIONS(2020),
    [anon_sym___attribute__] = ACTIONS(2020),
    [anon_sym_COLON_COLON] = ACTIONS(2022),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2022),
    [anon_sym___declspec] = ACTIONS(2020),
    [anon_sym___based] = ACTIONS(2020),
    [anon_sym___cdecl] = ACTIONS(2020),
    [anon_sym___clrcall] = ACTIONS(2020),
    [anon_sym___stdcall] = ACTIONS(2020),
    [anon_sym___fastcall] = ACTIONS(2020),
    [anon_sym___thiscall] = ACTIONS(2020),
    [anon_sym___vectorcall] = ACTIONS(2020),
    [anon_sym_LBRACE] = ACTIONS(2022),
    [anon_sym_signed] = ACTIONS(2020),
    [anon_sym_unsigned] = ACTIONS(2020),
    [anon_sym_long] = ACTIONS(2020),
    [anon_sym_short] = ACTIONS(2020),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(2020),
    [anon_sym_register] = ACTIONS(2020),
    [anon_sym_inline] = ACTIONS(2020),
    [anon_sym___inline] = ACTIONS(2020),
    [anon_sym___inline__] = ACTIONS(2020),
    [anon_sym___forceinline] = ACTIONS(2020),
    [anon_sym_thread_local] = ACTIONS(2020),
    [anon_sym___thread] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(2020),
    [anon_sym_constexpr] = ACTIONS(2020),
    [anon_sym_volatile] = ACTIONS(2020),
    [anon_sym_restrict] = ACTIONS(2020),
    [anon_sym___restrict__] = ACTIONS(2020),
    [anon_sym__Atomic] = ACTIONS(2020),
    [anon_sym__Noreturn] = ACTIONS(2020),
    [anon_sym_noreturn] = ACTIONS(2020),
    [anon_sym_mutable] = ACTIONS(2020),
    [anon_sym_constinit] = ACTIONS(2020),
    [anon_sym_consteval] = ACTIONS(2020),
    [anon_sym___shared__] = ACTIONS(2020),
    [anon_sym___local__] = ACTIONS(2020),
    [anon_sym___constant__] = ACTIONS(2020),
    [anon_sym___managed__] = ACTIONS(2020),
    [anon_sym___grid_constant__] = ACTIONS(2020),
    [anon_sym_alignas] = ACTIONS(2020),
    [anon_sym__Alignas] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2020),
    [anon_sym_enum] = ACTIONS(2020),
    [anon_sym_class] = ACTIONS(2020),
    [anon_sym_struct] = ACTIONS(2020),
    [anon_sym_union] = ACTIONS(2020),
    [anon_sym_if] = ACTIONS(2020),
    [anon_sym_else] = ACTIONS(2020),
    [anon_sym_switch] = ACTIONS(2020),
    [anon_sym_case] = ACTIONS(2020),
    [anon_sym_default] = ACTIONS(2020),
    [anon_sym_while] = ACTIONS(2020),
    [anon_sym_do] = ACTIONS(2020),
    [anon_sym_for] = ACTIONS(2020),
    [anon_sym_return] = ACTIONS(2020),
    [anon_sym_break] = ACTIONS(2020),
    [anon_sym_continue] = ACTIONS(2020),
    [anon_sym_goto] = ACTIONS(2020),
    [anon_sym___try] = ACTIONS(2020),
    [anon_sym___leave] = ACTIONS(2020),
    [anon_sym_not] = ACTIONS(2020),
    [anon_sym_compl] = ACTIONS(2020),
    [anon_sym_DASH_DASH] = ACTIONS(2022),
    [anon_sym_PLUS_PLUS] = ACTIONS(2022),
    [anon_sym_sizeof] = ACTIONS(2020),
    [anon_sym___alignof__] = ACTIONS(2020),
    [anon_sym___alignof] = ACTIONS(2020),
    [anon_sym__alignof] = ACTIONS(2020),
    [anon_sym_alignof] = ACTIONS(2020),
    [anon_sym__Alignof] = ACTIONS(2020),
    [anon_sym_offsetof] = ACTIONS(2020),
    [anon_sym__Generic] = ACTIONS(2020),
    [anon_sym_asm] = ACTIONS(2020),
    [anon_sym___asm__] = ACTIONS(2020),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_L_SQUOTE] = ACTIONS(2022),
    [anon_sym_u_SQUOTE] = ACTIONS(2022),
    [anon_sym_U_SQUOTE] = ACTIONS(2022),
    [anon_sym_u8_SQUOTE] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(2022),
    [anon_sym_L_DQUOTE] = ACTIONS(2022),
    [anon_sym_u_DQUOTE] = ACTIONS(2022),
    [anon_sym_U_DQUOTE] = ACTIONS(2022),
    [anon_sym_u8_DQUOTE] = ACTIONS(2022),
    [anon_sym_DQUOTE] = ACTIONS(2022),
    [sym_true] = ACTIONS(2020),
    [sym_false] = ACTIONS(2020),
    [anon_sym_NULL] = ACTIONS(2020),
    [anon_sym_nullptr] = ACTIONS(2020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2020),
    [anon_sym_decltype] = ACTIONS(2020),
    [sym_virtual] = ACTIONS(2020),
    [anon_sym_explicit] = ACTIONS(2020),
    [anon_sym_typename] = ACTIONS(2020),
    [anon_sym_template] = ACTIONS(2020),
    [anon_sym_operator] = ACTIONS(2020),
    [anon_sym_try] = ACTIONS(2020),
    [anon_sym_delete] = ACTIONS(2020),
    [anon_sym_throw] = ACTIONS(2020),
    [anon_sym_namespace] = ACTIONS(2020),
    [anon_sym_using] = ACTIONS(2020),
    [anon_sym_static_assert] = ACTIONS(2020),
    [anon_sym_concept] = ACTIONS(2020),
    [anon_sym_co_return] = ACTIONS(2020),
    [anon_sym_co_yield] = ACTIONS(2020),
    [anon_sym_R_DQUOTE] = ACTIONS(2022),
    [anon_sym_LR_DQUOTE] = ACTIONS(2022),
    [anon_sym_uR_DQUOTE] = ACTIONS(2022),
    [anon_sym_UR_DQUOTE] = ACTIONS(2022),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2022),
    [anon_sym_co_await] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(2020),
    [anon_sym_requires] = ACTIONS(2020),
    [sym_this] = ACTIONS(2020),
    [anon_sym___launch_bounds__] = ACTIONS(2020),
  },
  [166] = {
    [sym_identifier] = ACTIONS(2024),
    [aux_sym_preproc_include_token1] = ACTIONS(2024),
    [aux_sym_preproc_def_token1] = ACTIONS(2024),
    [aux_sym_preproc_if_token1] = ACTIONS(2024),
    [aux_sym_preproc_if_token2] = ACTIONS(2024),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2024),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2024),
    [aux_sym_preproc_else_token1] = ACTIONS(2024),
    [aux_sym_preproc_elif_token1] = ACTIONS(2024),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2024),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2024),
    [sym_preproc_directive] = ACTIONS(2024),
    [anon_sym_LPAREN2] = ACTIONS(2026),
    [anon_sym_BANG] = ACTIONS(2026),
    [anon_sym_TILDE] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2024),
    [anon_sym_PLUS] = ACTIONS(2024),
    [anon_sym_STAR] = ACTIONS(2026),
    [anon_sym_AMP_AMP] = ACTIONS(2026),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_SEMI] = ACTIONS(2026),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_typedef] = ACTIONS(2024),
    [anon_sym___device__] = ACTIONS(2024),
    [anon_sym___host__] = ACTIONS(2024),
    [anon_sym___global__] = ACTIONS(2024),
    [anon_sym___forceinline__] = ACTIONS(2024),
    [anon_sym___noinline__] = ACTIONS(2024),
    [anon_sym_extern] = ACTIONS(2024),
    [anon_sym___attribute__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(2026),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2026),
    [anon_sym___declspec] = ACTIONS(2024),
    [anon_sym___based] = ACTIONS(2024),
    [anon_sym___cdecl] = ACTIONS(2024),
    [anon_sym___clrcall] = ACTIONS(2024),
    [anon_sym___stdcall] = ACTIONS(2024),
    [anon_sym___fastcall] = ACTIONS(2024),
    [anon_sym___thiscall] = ACTIONS(2024),
    [anon_sym___vectorcall] = ACTIONS(2024),
    [anon_sym_LBRACE] = ACTIONS(2026),
    [anon_sym_signed] = ACTIONS(2024),
    [anon_sym_unsigned] = ACTIONS(2024),
    [anon_sym_long] = ACTIONS(2024),
    [anon_sym_short] = ACTIONS(2024),
    [anon_sym_LBRACK] = ACTIONS(2024),
    [anon_sym_static] = ACTIONS(2024),
    [anon_sym_register] = ACTIONS(2024),
    [anon_sym_inline] = ACTIONS(2024),
    [anon_sym___inline] = ACTIONS(2024),
    [anon_sym___inline__] = ACTIONS(2024),
    [anon_sym___forceinline] = ACTIONS(2024),
    [anon_sym_thread_local] = ACTIONS(2024),
    [anon_sym___thread] = ACTIONS(2024),
    [anon_sym_const] = ACTIONS(2024),
    [anon_sym_constexpr] = ACTIONS(2024),
    [anon_sym_volatile] = ACTIONS(2024),
    [anon_sym_restrict] = ACTIONS(2024),
    [anon_sym___restrict__] = ACTIONS(2024),
    [anon_sym__Atomic] = ACTIONS(2024),
    [anon_sym__Noreturn] = ACTIONS(2024),
    [anon_sym_noreturn] = ACTIONS(2024),
    [anon_sym_mutable] = ACTIONS(2024),
    [anon_sym_constinit] = ACTIONS(2024),
    [anon_sym_consteval] = ACTIONS(2024),
    [anon_sym___shared__] = ACTIONS(2024),
    [anon_sym___local__] = ACTIONS(2024),
    [anon_sym___constant__] = ACTIONS(2024),
    [anon_sym___managed__] = ACTIONS(2024),
    [anon_sym___grid_constant__] = ACTIONS(2024),
    [anon_sym_alignas] = ACTIONS(2024),
    [anon_sym__Alignas] = ACTIONS(2024),
    [sym_primitive_type] = ACTIONS(2024),
    [anon_sym_enum] = ACTIONS(2024),
    [anon_sym_class] = ACTIONS(2024),
    [anon_sym_struct] = ACTIONS(2024),
    [anon_sym_union] = ACTIONS(2024),
    [anon_sym_if] = ACTIONS(2024),
    [anon_sym_else] = ACTIONS(2024),
    [anon_sym_switch] = ACTIONS(2024),
    [anon_sym_case] = ACTIONS(2024),
    [anon_sym_default] = ACTIONS(2024),
    [anon_sym_while] = ACTIONS(2024),
    [anon_sym_do] = ACTIONS(2024),
    [anon_sym_for] = ACTIONS(2024),
    [anon_sym_return] = ACTIONS(2024),
    [anon_sym_break] = ACTIONS(2024),
    [anon_sym_continue] = ACTIONS(2024),
    [anon_sym_goto] = ACTIONS(2024),
    [anon_sym___try] = ACTIONS(2024),
    [anon_sym___leave] = ACTIONS(2024),
    [anon_sym_not] = ACTIONS(2024),
    [anon_sym_compl] = ACTIONS(2024),
    [anon_sym_DASH_DASH] = ACTIONS(2026),
    [anon_sym_PLUS_PLUS] = ACTIONS(2026),
    [anon_sym_sizeof] = ACTIONS(2024),
    [anon_sym___alignof__] = ACTIONS(2024),
    [anon_sym___alignof] = ACTIONS(2024),
    [anon_sym__alignof] = ACTIONS(2024),
    [anon_sym_alignof] = ACTIONS(2024),
    [anon_sym__Alignof] = ACTIONS(2024),
    [anon_sym_offsetof] = ACTIONS(2024),
    [anon_sym__Generic] = ACTIONS(2024),
    [anon_sym_asm] = ACTIONS(2024),
    [anon_sym___asm__] = ACTIONS(2024),
    [sym_number_literal] = ACTIONS(2026),
    [anon_sym_L_SQUOTE] = ACTIONS(2026),
    [anon_sym_u_SQUOTE] = ACTIONS(2026),
    [anon_sym_U_SQUOTE] = ACTIONS(2026),
    [anon_sym_u8_SQUOTE] = ACTIONS(2026),
    [anon_sym_SQUOTE] = ACTIONS(2026),
    [anon_sym_L_DQUOTE] = ACTIONS(2026),
    [anon_sym_u_DQUOTE] = ACTIONS(2026),
    [anon_sym_U_DQUOTE] = ACTIONS(2026),
    [anon_sym_u8_DQUOTE] = ACTIONS(2026),
    [anon_sym_DQUOTE] = ACTIONS(2026),
    [sym_true] = ACTIONS(2024),
    [sym_false] = ACTIONS(2024),
    [anon_sym_NULL] = ACTIONS(2024),
    [anon_sym_nullptr] = ACTIONS(2024),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2024),
    [anon_sym_decltype] = ACTIONS(2024),
    [sym_virtual] = ACTIONS(2024),
    [anon_sym_explicit] = ACTIONS(2024),
    [anon_sym_typename] = ACTIONS(2024),
    [anon_sym_template] = ACTIONS(2024),
    [anon_sym_operator] = ACTIONS(2024),
    [anon_sym_try] = ACTIONS(2024),
    [anon_sym_delete] = ACTIONS(2024),
    [anon_sym_throw] = ACTIONS(2024),
    [anon_sym_namespace] = ACTIONS(2024),
    [anon_sym_using] = ACTIONS(2024),
    [anon_sym_static_assert] = ACTIONS(2024),
    [anon_sym_concept] = ACTIONS(2024),
    [anon_sym_co_return] = ACTIONS(2024),
    [anon_sym_co_yield] = ACTIONS(2024),
    [anon_sym_R_DQUOTE] = ACTIONS(2026),
    [anon_sym_LR_DQUOTE] = ACTIONS(2026),
    [anon_sym_uR_DQUOTE] = ACTIONS(2026),
    [anon_sym_UR_DQUOTE] = ACTIONS(2026),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2026),
    [anon_sym_co_await] = ACTIONS(2024),
    [anon_sym_new] = ACTIONS(2024),
    [anon_sym_requires] = ACTIONS(2024),
    [sym_this] = ACTIONS(2024),
    [anon_sym___launch_bounds__] = ACTIONS(2024),
  },
  [167] = {
    [sym_identifier] = ACTIONS(2028),
    [aux_sym_preproc_include_token1] = ACTIONS(2028),
    [aux_sym_preproc_def_token1] = ACTIONS(2028),
    [aux_sym_preproc_if_token1] = ACTIONS(2028),
    [aux_sym_preproc_if_token2] = ACTIONS(2028),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2028),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2028),
    [aux_sym_preproc_else_token1] = ACTIONS(2028),
    [aux_sym_preproc_elif_token1] = ACTIONS(2028),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2028),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2028),
    [sym_preproc_directive] = ACTIONS(2028),
    [anon_sym_LPAREN2] = ACTIONS(2030),
    [anon_sym_BANG] = ACTIONS(2030),
    [anon_sym_TILDE] = ACTIONS(2030),
    [anon_sym_DASH] = ACTIONS(2028),
    [anon_sym_PLUS] = ACTIONS(2028),
    [anon_sym_STAR] = ACTIONS(2030),
    [anon_sym_AMP_AMP] = ACTIONS(2030),
    [anon_sym_AMP] = ACTIONS(2028),
    [anon_sym_SEMI] = ACTIONS(2030),
    [anon_sym___extension__] = ACTIONS(2028),
    [anon_sym_typedef] = ACTIONS(2028),
    [anon_sym___device__] = ACTIONS(2028),
    [anon_sym___host__] = ACTIONS(2028),
    [anon_sym___global__] = ACTIONS(2028),
    [anon_sym___forceinline__] = ACTIONS(2028),
    [anon_sym___noinline__] = ACTIONS(2028),
    [anon_sym_extern] = ACTIONS(2028),
    [anon_sym___attribute__] = ACTIONS(2028),
    [anon_sym_COLON_COLON] = ACTIONS(2030),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2030),
    [anon_sym___declspec] = ACTIONS(2028),
    [anon_sym___based] = ACTIONS(2028),
    [anon_sym___cdecl] = ACTIONS(2028),
    [anon_sym___clrcall] = ACTIONS(2028),
    [anon_sym___stdcall] = ACTIONS(2028),
    [anon_sym___fastcall] = ACTIONS(2028),
    [anon_sym___thiscall] = ACTIONS(2028),
    [anon_sym___vectorcall] = ACTIONS(2028),
    [anon_sym_LBRACE] = ACTIONS(2030),
    [anon_sym_signed] = ACTIONS(2028),
    [anon_sym_unsigned] = ACTIONS(2028),
    [anon_sym_long] = ACTIONS(2028),
    [anon_sym_short] = ACTIONS(2028),
    [anon_sym_LBRACK] = ACTIONS(2028),
    [anon_sym_static] = ACTIONS(2028),
    [anon_sym_register] = ACTIONS(2028),
    [anon_sym_inline] = ACTIONS(2028),
    [anon_sym___inline] = ACTIONS(2028),
    [anon_sym___inline__] = ACTIONS(2028),
    [anon_sym___forceinline] = ACTIONS(2028),
    [anon_sym_thread_local] = ACTIONS(2028),
    [anon_sym___thread] = ACTIONS(2028),
    [anon_sym_const] = ACTIONS(2028),
    [anon_sym_constexpr] = ACTIONS(2028),
    [anon_sym_volatile] = ACTIONS(2028),
    [anon_sym_restrict] = ACTIONS(2028),
    [anon_sym___restrict__] = ACTIONS(2028),
    [anon_sym__Atomic] = ACTIONS(2028),
    [anon_sym__Noreturn] = ACTIONS(2028),
    [anon_sym_noreturn] = ACTIONS(2028),
    [anon_sym_mutable] = ACTIONS(2028),
    [anon_sym_constinit] = ACTIONS(2028),
    [anon_sym_consteval] = ACTIONS(2028),
    [anon_sym___shared__] = ACTIONS(2028),
    [anon_sym___local__] = ACTIONS(2028),
    [anon_sym___constant__] = ACTIONS(2028),
    [anon_sym___managed__] = ACTIONS(2028),
    [anon_sym___grid_constant__] = ACTIONS(2028),
    [anon_sym_alignas] = ACTIONS(2028),
    [anon_sym__Alignas] = ACTIONS(2028),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_enum] = ACTIONS(2028),
    [anon_sym_class] = ACTIONS(2028),
    [anon_sym_struct] = ACTIONS(2028),
    [anon_sym_union] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(2028),
    [anon_sym_else] = ACTIONS(2028),
    [anon_sym_switch] = ACTIONS(2028),
    [anon_sym_case] = ACTIONS(2028),
    [anon_sym_default] = ACTIONS(2028),
    [anon_sym_while] = ACTIONS(2028),
    [anon_sym_do] = ACTIONS(2028),
    [anon_sym_for] = ACTIONS(2028),
    [anon_sym_return] = ACTIONS(2028),
    [anon_sym_break] = ACTIONS(2028),
    [anon_sym_continue] = ACTIONS(2028),
    [anon_sym_goto] = ACTIONS(2028),
    [anon_sym___try] = ACTIONS(2028),
    [anon_sym___leave] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(2028),
    [anon_sym_compl] = ACTIONS(2028),
    [anon_sym_DASH_DASH] = ACTIONS(2030),
    [anon_sym_PLUS_PLUS] = ACTIONS(2030),
    [anon_sym_sizeof] = ACTIONS(2028),
    [anon_sym___alignof__] = ACTIONS(2028),
    [anon_sym___alignof] = ACTIONS(2028),
    [anon_sym__alignof] = ACTIONS(2028),
    [anon_sym_alignof] = ACTIONS(2028),
    [anon_sym__Alignof] = ACTIONS(2028),
    [anon_sym_offsetof] = ACTIONS(2028),
    [anon_sym__Generic] = ACTIONS(2028),
    [anon_sym_asm] = ACTIONS(2028),
    [anon_sym___asm__] = ACTIONS(2028),
    [sym_number_literal] = ACTIONS(2030),
    [anon_sym_L_SQUOTE] = ACTIONS(2030),
    [anon_sym_u_SQUOTE] = ACTIONS(2030),
    [anon_sym_U_SQUOTE] = ACTIONS(2030),
    [anon_sym_u8_SQUOTE] = ACTIONS(2030),
    [anon_sym_SQUOTE] = ACTIONS(2030),
    [anon_sym_L_DQUOTE] = ACTIONS(2030),
    [anon_sym_u_DQUOTE] = ACTIONS(2030),
    [anon_sym_U_DQUOTE] = ACTIONS(2030),
    [anon_sym_u8_DQUOTE] = ACTIONS(2030),
    [anon_sym_DQUOTE] = ACTIONS(2030),
    [sym_true] = ACTIONS(2028),
    [sym_false] = ACTIONS(2028),
    [anon_sym_NULL] = ACTIONS(2028),
    [anon_sym_nullptr] = ACTIONS(2028),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2028),
    [anon_sym_decltype] = ACTIONS(2028),
    [sym_virtual] = ACTIONS(2028),
    [anon_sym_explicit] = ACTIONS(2028),
    [anon_sym_typename] = ACTIONS(2028),
    [anon_sym_template] = ACTIONS(2028),
    [anon_sym_operator] = ACTIONS(2028),
    [anon_sym_try] = ACTIONS(2028),
    [anon_sym_delete] = ACTIONS(2028),
    [anon_sym_throw] = ACTIONS(2028),
    [anon_sym_namespace] = ACTIONS(2028),
    [anon_sym_using] = ACTIONS(2028),
    [anon_sym_static_assert] = ACTIONS(2028),
    [anon_sym_concept] = ACTIONS(2028),
    [anon_sym_co_return] = ACTIONS(2028),
    [anon_sym_co_yield] = ACTIONS(2028),
    [anon_sym_R_DQUOTE] = ACTIONS(2030),
    [anon_sym_LR_DQUOTE] = ACTIONS(2030),
    [anon_sym_uR_DQUOTE] = ACTIONS(2030),
    [anon_sym_UR_DQUOTE] = ACTIONS(2030),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2030),
    [anon_sym_co_await] = ACTIONS(2028),
    [anon_sym_new] = ACTIONS(2028),
    [anon_sym_requires] = ACTIONS(2028),
    [sym_this] = ACTIONS(2028),
    [anon_sym___launch_bounds__] = ACTIONS(2028),
  },
  [168] = {
    [sym_identifier] = ACTIONS(2032),
    [aux_sym_preproc_include_token1] = ACTIONS(2032),
    [aux_sym_preproc_def_token1] = ACTIONS(2032),
    [aux_sym_preproc_if_token1] = ACTIONS(2032),
    [aux_sym_preproc_if_token2] = ACTIONS(2032),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2032),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2032),
    [aux_sym_preproc_else_token1] = ACTIONS(2032),
    [aux_sym_preproc_elif_token1] = ACTIONS(2032),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2032),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2032),
    [sym_preproc_directive] = ACTIONS(2032),
    [anon_sym_LPAREN2] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2034),
    [anon_sym_TILDE] = ACTIONS(2034),
    [anon_sym_DASH] = ACTIONS(2032),
    [anon_sym_PLUS] = ACTIONS(2032),
    [anon_sym_STAR] = ACTIONS(2034),
    [anon_sym_AMP_AMP] = ACTIONS(2034),
    [anon_sym_AMP] = ACTIONS(2032),
    [anon_sym_SEMI] = ACTIONS(2034),
    [anon_sym___extension__] = ACTIONS(2032),
    [anon_sym_typedef] = ACTIONS(2032),
    [anon_sym___device__] = ACTIONS(2032),
    [anon_sym___host__] = ACTIONS(2032),
    [anon_sym___global__] = ACTIONS(2032),
    [anon_sym___forceinline__] = ACTIONS(2032),
    [anon_sym___noinline__] = ACTIONS(2032),
    [anon_sym_extern] = ACTIONS(2032),
    [anon_sym___attribute__] = ACTIONS(2032),
    [anon_sym_COLON_COLON] = ACTIONS(2034),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2034),
    [anon_sym___declspec] = ACTIONS(2032),
    [anon_sym___based] = ACTIONS(2032),
    [anon_sym___cdecl] = ACTIONS(2032),
    [anon_sym___clrcall] = ACTIONS(2032),
    [anon_sym___stdcall] = ACTIONS(2032),
    [anon_sym___fastcall] = ACTIONS(2032),
    [anon_sym___thiscall] = ACTIONS(2032),
    [anon_sym___vectorcall] = ACTIONS(2032),
    [anon_sym_LBRACE] = ACTIONS(2034),
    [anon_sym_signed] = ACTIONS(2032),
    [anon_sym_unsigned] = ACTIONS(2032),
    [anon_sym_long] = ACTIONS(2032),
    [anon_sym_short] = ACTIONS(2032),
    [anon_sym_LBRACK] = ACTIONS(2032),
    [anon_sym_static] = ACTIONS(2032),
    [anon_sym_register] = ACTIONS(2032),
    [anon_sym_inline] = ACTIONS(2032),
    [anon_sym___inline] = ACTIONS(2032),
    [anon_sym___inline__] = ACTIONS(2032),
    [anon_sym___forceinline] = ACTIONS(2032),
    [anon_sym_thread_local] = ACTIONS(2032),
    [anon_sym___thread] = ACTIONS(2032),
    [anon_sym_const] = ACTIONS(2032),
    [anon_sym_constexpr] = ACTIONS(2032),
    [anon_sym_volatile] = ACTIONS(2032),
    [anon_sym_restrict] = ACTIONS(2032),
    [anon_sym___restrict__] = ACTIONS(2032),
    [anon_sym__Atomic] = ACTIONS(2032),
    [anon_sym__Noreturn] = ACTIONS(2032),
    [anon_sym_noreturn] = ACTIONS(2032),
    [anon_sym_mutable] = ACTIONS(2032),
    [anon_sym_constinit] = ACTIONS(2032),
    [anon_sym_consteval] = ACTIONS(2032),
    [anon_sym___shared__] = ACTIONS(2032),
    [anon_sym___local__] = ACTIONS(2032),
    [anon_sym___constant__] = ACTIONS(2032),
    [anon_sym___managed__] = ACTIONS(2032),
    [anon_sym___grid_constant__] = ACTIONS(2032),
    [anon_sym_alignas] = ACTIONS(2032),
    [anon_sym__Alignas] = ACTIONS(2032),
    [sym_primitive_type] = ACTIONS(2032),
    [anon_sym_enum] = ACTIONS(2032),
    [anon_sym_class] = ACTIONS(2032),
    [anon_sym_struct] = ACTIONS(2032),
    [anon_sym_union] = ACTIONS(2032),
    [anon_sym_if] = ACTIONS(2032),
    [anon_sym_else] = ACTIONS(2032),
    [anon_sym_switch] = ACTIONS(2032),
    [anon_sym_case] = ACTIONS(2032),
    [anon_sym_default] = ACTIONS(2032),
    [anon_sym_while] = ACTIONS(2032),
    [anon_sym_do] = ACTIONS(2032),
    [anon_sym_for] = ACTIONS(2032),
    [anon_sym_return] = ACTIONS(2032),
    [anon_sym_break] = ACTIONS(2032),
    [anon_sym_continue] = ACTIONS(2032),
    [anon_sym_goto] = ACTIONS(2032),
    [anon_sym___try] = ACTIONS(2032),
    [anon_sym___leave] = ACTIONS(2032),
    [anon_sym_not] = ACTIONS(2032),
    [anon_sym_compl] = ACTIONS(2032),
    [anon_sym_DASH_DASH] = ACTIONS(2034),
    [anon_sym_PLUS_PLUS] = ACTIONS(2034),
    [anon_sym_sizeof] = ACTIONS(2032),
    [anon_sym___alignof__] = ACTIONS(2032),
    [anon_sym___alignof] = ACTIONS(2032),
    [anon_sym__alignof] = ACTIONS(2032),
    [anon_sym_alignof] = ACTIONS(2032),
    [anon_sym__Alignof] = ACTIONS(2032),
    [anon_sym_offsetof] = ACTIONS(2032),
    [anon_sym__Generic] = ACTIONS(2032),
    [anon_sym_asm] = ACTIONS(2032),
    [anon_sym___asm__] = ACTIONS(2032),
    [sym_number_literal] = ACTIONS(2034),
    [anon_sym_L_SQUOTE] = ACTIONS(2034),
    [anon_sym_u_SQUOTE] = ACTIONS(2034),
    [anon_sym_U_SQUOTE] = ACTIONS(2034),
    [anon_sym_u8_SQUOTE] = ACTIONS(2034),
    [anon_sym_SQUOTE] = ACTIONS(2034),
    [anon_sym_L_DQUOTE] = ACTIONS(2034),
    [anon_sym_u_DQUOTE] = ACTIONS(2034),
    [anon_sym_U_DQUOTE] = ACTIONS(2034),
    [anon_sym_u8_DQUOTE] = ACTIONS(2034),
    [anon_sym_DQUOTE] = ACTIONS(2034),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [anon_sym_NULL] = ACTIONS(2032),
    [anon_sym_nullptr] = ACTIONS(2032),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2032),
    [anon_sym_decltype] = ACTIONS(2032),
    [sym_virtual] = ACTIONS(2032),
    [anon_sym_explicit] = ACTIONS(2032),
    [anon_sym_typename] = ACTIONS(2032),
    [anon_sym_template] = ACTIONS(2032),
    [anon_sym_operator] = ACTIONS(2032),
    [anon_sym_try] = ACTIONS(2032),
    [anon_sym_delete] = ACTIONS(2032),
    [anon_sym_throw] = ACTIONS(2032),
    [anon_sym_namespace] = ACTIONS(2032),
    [anon_sym_using] = ACTIONS(2032),
    [anon_sym_static_assert] = ACTIONS(2032),
    [anon_sym_concept] = ACTIONS(2032),
    [anon_sym_co_return] = ACTIONS(2032),
    [anon_sym_co_yield] = ACTIONS(2032),
    [anon_sym_R_DQUOTE] = ACTIONS(2034),
    [anon_sym_LR_DQUOTE] = ACTIONS(2034),
    [anon_sym_uR_DQUOTE] = ACTIONS(2034),
    [anon_sym_UR_DQUOTE] = ACTIONS(2034),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2034),
    [anon_sym_co_await] = ACTIONS(2032),
    [anon_sym_new] = ACTIONS(2032),
    [anon_sym_requires] = ACTIONS(2032),
    [sym_this] = ACTIONS(2032),
    [anon_sym___launch_bounds__] = ACTIONS(2032),
  },
  [169] = {
    [sym_identifier] = ACTIONS(2036),
    [aux_sym_preproc_include_token1] = ACTIONS(2036),
    [aux_sym_preproc_def_token1] = ACTIONS(2036),
    [aux_sym_preproc_if_token1] = ACTIONS(2036),
    [aux_sym_preproc_if_token2] = ACTIONS(2036),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2036),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2036),
    [aux_sym_preproc_else_token1] = ACTIONS(2036),
    [aux_sym_preproc_elif_token1] = ACTIONS(2036),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2036),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2036),
    [sym_preproc_directive] = ACTIONS(2036),
    [anon_sym_LPAREN2] = ACTIONS(2038),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2038),
    [anon_sym_DASH] = ACTIONS(2036),
    [anon_sym_PLUS] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(2038),
    [anon_sym_AMP_AMP] = ACTIONS(2038),
    [anon_sym_AMP] = ACTIONS(2036),
    [anon_sym_SEMI] = ACTIONS(2038),
    [anon_sym___extension__] = ACTIONS(2036),
    [anon_sym_typedef] = ACTIONS(2036),
    [anon_sym___device__] = ACTIONS(2036),
    [anon_sym___host__] = ACTIONS(2036),
    [anon_sym___global__] = ACTIONS(2036),
    [anon_sym___forceinline__] = ACTIONS(2036),
    [anon_sym___noinline__] = ACTIONS(2036),
    [anon_sym_extern] = ACTIONS(2036),
    [anon_sym___attribute__] = ACTIONS(2036),
    [anon_sym_COLON_COLON] = ACTIONS(2038),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2038),
    [anon_sym___declspec] = ACTIONS(2036),
    [anon_sym___based] = ACTIONS(2036),
    [anon_sym___cdecl] = ACTIONS(2036),
    [anon_sym___clrcall] = ACTIONS(2036),
    [anon_sym___stdcall] = ACTIONS(2036),
    [anon_sym___fastcall] = ACTIONS(2036),
    [anon_sym___thiscall] = ACTIONS(2036),
    [anon_sym___vectorcall] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2038),
    [anon_sym_signed] = ACTIONS(2036),
    [anon_sym_unsigned] = ACTIONS(2036),
    [anon_sym_long] = ACTIONS(2036),
    [anon_sym_short] = ACTIONS(2036),
    [anon_sym_LBRACK] = ACTIONS(2036),
    [anon_sym_static] = ACTIONS(2036),
    [anon_sym_register] = ACTIONS(2036),
    [anon_sym_inline] = ACTIONS(2036),
    [anon_sym___inline] = ACTIONS(2036),
    [anon_sym___inline__] = ACTIONS(2036),
    [anon_sym___forceinline] = ACTIONS(2036),
    [anon_sym_thread_local] = ACTIONS(2036),
    [anon_sym___thread] = ACTIONS(2036),
    [anon_sym_const] = ACTIONS(2036),
    [anon_sym_constexpr] = ACTIONS(2036),
    [anon_sym_volatile] = ACTIONS(2036),
    [anon_sym_restrict] = ACTIONS(2036),
    [anon_sym___restrict__] = ACTIONS(2036),
    [anon_sym__Atomic] = ACTIONS(2036),
    [anon_sym__Noreturn] = ACTIONS(2036),
    [anon_sym_noreturn] = ACTIONS(2036),
    [anon_sym_mutable] = ACTIONS(2036),
    [anon_sym_constinit] = ACTIONS(2036),
    [anon_sym_consteval] = ACTIONS(2036),
    [anon_sym___shared__] = ACTIONS(2036),
    [anon_sym___local__] = ACTIONS(2036),
    [anon_sym___constant__] = ACTIONS(2036),
    [anon_sym___managed__] = ACTIONS(2036),
    [anon_sym___grid_constant__] = ACTIONS(2036),
    [anon_sym_alignas] = ACTIONS(2036),
    [anon_sym__Alignas] = ACTIONS(2036),
    [sym_primitive_type] = ACTIONS(2036),
    [anon_sym_enum] = ACTIONS(2036),
    [anon_sym_class] = ACTIONS(2036),
    [anon_sym_struct] = ACTIONS(2036),
    [anon_sym_union] = ACTIONS(2036),
    [anon_sym_if] = ACTIONS(2036),
    [anon_sym_else] = ACTIONS(2036),
    [anon_sym_switch] = ACTIONS(2036),
    [anon_sym_case] = ACTIONS(2036),
    [anon_sym_default] = ACTIONS(2036),
    [anon_sym_while] = ACTIONS(2036),
    [anon_sym_do] = ACTIONS(2036),
    [anon_sym_for] = ACTIONS(2036),
    [anon_sym_return] = ACTIONS(2036),
    [anon_sym_break] = ACTIONS(2036),
    [anon_sym_continue] = ACTIONS(2036),
    [anon_sym_goto] = ACTIONS(2036),
    [anon_sym___try] = ACTIONS(2036),
    [anon_sym___leave] = ACTIONS(2036),
    [anon_sym_not] = ACTIONS(2036),
    [anon_sym_compl] = ACTIONS(2036),
    [anon_sym_DASH_DASH] = ACTIONS(2038),
    [anon_sym_PLUS_PLUS] = ACTIONS(2038),
    [anon_sym_sizeof] = ACTIONS(2036),
    [anon_sym___alignof__] = ACTIONS(2036),
    [anon_sym___alignof] = ACTIONS(2036),
    [anon_sym__alignof] = ACTIONS(2036),
    [anon_sym_alignof] = ACTIONS(2036),
    [anon_sym__Alignof] = ACTIONS(2036),
    [anon_sym_offsetof] = ACTIONS(2036),
    [anon_sym__Generic] = ACTIONS(2036),
    [anon_sym_asm] = ACTIONS(2036),
    [anon_sym___asm__] = ACTIONS(2036),
    [sym_number_literal] = ACTIONS(2038),
    [anon_sym_L_SQUOTE] = ACTIONS(2038),
    [anon_sym_u_SQUOTE] = ACTIONS(2038),
    [anon_sym_U_SQUOTE] = ACTIONS(2038),
    [anon_sym_u8_SQUOTE] = ACTIONS(2038),
    [anon_sym_SQUOTE] = ACTIONS(2038),
    [anon_sym_L_DQUOTE] = ACTIONS(2038),
    [anon_sym_u_DQUOTE] = ACTIONS(2038),
    [anon_sym_U_DQUOTE] = ACTIONS(2038),
    [anon_sym_u8_DQUOTE] = ACTIONS(2038),
    [anon_sym_DQUOTE] = ACTIONS(2038),
    [sym_true] = ACTIONS(2036),
    [sym_false] = ACTIONS(2036),
    [anon_sym_NULL] = ACTIONS(2036),
    [anon_sym_nullptr] = ACTIONS(2036),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2036),
    [anon_sym_decltype] = ACTIONS(2036),
    [sym_virtual] = ACTIONS(2036),
    [anon_sym_explicit] = ACTIONS(2036),
    [anon_sym_typename] = ACTIONS(2036),
    [anon_sym_template] = ACTIONS(2036),
    [anon_sym_operator] = ACTIONS(2036),
    [anon_sym_try] = ACTIONS(2036),
    [anon_sym_delete] = ACTIONS(2036),
    [anon_sym_throw] = ACTIONS(2036),
    [anon_sym_namespace] = ACTIONS(2036),
    [anon_sym_using] = ACTIONS(2036),
    [anon_sym_static_assert] = ACTIONS(2036),
    [anon_sym_concept] = ACTIONS(2036),
    [anon_sym_co_return] = ACTIONS(2036),
    [anon_sym_co_yield] = ACTIONS(2036),
    [anon_sym_R_DQUOTE] = ACTIONS(2038),
    [anon_sym_LR_DQUOTE] = ACTIONS(2038),
    [anon_sym_uR_DQUOTE] = ACTIONS(2038),
    [anon_sym_UR_DQUOTE] = ACTIONS(2038),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2038),
    [anon_sym_co_await] = ACTIONS(2036),
    [anon_sym_new] = ACTIONS(2036),
    [anon_sym_requires] = ACTIONS(2036),
    [sym_this] = ACTIONS(2036),
    [anon_sym___launch_bounds__] = ACTIONS(2036),
  },
  [170] = {
    [sym_identifier] = ACTIONS(2040),
    [aux_sym_preproc_include_token1] = ACTIONS(2040),
    [aux_sym_preproc_def_token1] = ACTIONS(2040),
    [aux_sym_preproc_if_token1] = ACTIONS(2040),
    [aux_sym_preproc_if_token2] = ACTIONS(2040),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2040),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2040),
    [aux_sym_preproc_else_token1] = ACTIONS(2040),
    [aux_sym_preproc_elif_token1] = ACTIONS(2040),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2040),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2040),
    [sym_preproc_directive] = ACTIONS(2040),
    [anon_sym_LPAREN2] = ACTIONS(2042),
    [anon_sym_BANG] = ACTIONS(2042),
    [anon_sym_TILDE] = ACTIONS(2042),
    [anon_sym_DASH] = ACTIONS(2040),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_STAR] = ACTIONS(2042),
    [anon_sym_AMP_AMP] = ACTIONS(2042),
    [anon_sym_AMP] = ACTIONS(2040),
    [anon_sym_SEMI] = ACTIONS(2042),
    [anon_sym___extension__] = ACTIONS(2040),
    [anon_sym_typedef] = ACTIONS(2040),
    [anon_sym___device__] = ACTIONS(2040),
    [anon_sym___host__] = ACTIONS(2040),
    [anon_sym___global__] = ACTIONS(2040),
    [anon_sym___forceinline__] = ACTIONS(2040),
    [anon_sym___noinline__] = ACTIONS(2040),
    [anon_sym_extern] = ACTIONS(2040),
    [anon_sym___attribute__] = ACTIONS(2040),
    [anon_sym_COLON_COLON] = ACTIONS(2042),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2042),
    [anon_sym___declspec] = ACTIONS(2040),
    [anon_sym___based] = ACTIONS(2040),
    [anon_sym___cdecl] = ACTIONS(2040),
    [anon_sym___clrcall] = ACTIONS(2040),
    [anon_sym___stdcall] = ACTIONS(2040),
    [anon_sym___fastcall] = ACTIONS(2040),
    [anon_sym___thiscall] = ACTIONS(2040),
    [anon_sym___vectorcall] = ACTIONS(2040),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_signed] = ACTIONS(2040),
    [anon_sym_unsigned] = ACTIONS(2040),
    [anon_sym_long] = ACTIONS(2040),
    [anon_sym_short] = ACTIONS(2040),
    [anon_sym_LBRACK] = ACTIONS(2040),
    [anon_sym_static] = ACTIONS(2040),
    [anon_sym_register] = ACTIONS(2040),
    [anon_sym_inline] = ACTIONS(2040),
    [anon_sym___inline] = ACTIONS(2040),
    [anon_sym___inline__] = ACTIONS(2040),
    [anon_sym___forceinline] = ACTIONS(2040),
    [anon_sym_thread_local] = ACTIONS(2040),
    [anon_sym___thread] = ACTIONS(2040),
    [anon_sym_const] = ACTIONS(2040),
    [anon_sym_constexpr] = ACTIONS(2040),
    [anon_sym_volatile] = ACTIONS(2040),
    [anon_sym_restrict] = ACTIONS(2040),
    [anon_sym___restrict__] = ACTIONS(2040),
    [anon_sym__Atomic] = ACTIONS(2040),
    [anon_sym__Noreturn] = ACTIONS(2040),
    [anon_sym_noreturn] = ACTIONS(2040),
    [anon_sym_mutable] = ACTIONS(2040),
    [anon_sym_constinit] = ACTIONS(2040),
    [anon_sym_consteval] = ACTIONS(2040),
    [anon_sym___shared__] = ACTIONS(2040),
    [anon_sym___local__] = ACTIONS(2040),
    [anon_sym___constant__] = ACTIONS(2040),
    [anon_sym___managed__] = ACTIONS(2040),
    [anon_sym___grid_constant__] = ACTIONS(2040),
    [anon_sym_alignas] = ACTIONS(2040),
    [anon_sym__Alignas] = ACTIONS(2040),
    [sym_primitive_type] = ACTIONS(2040),
    [anon_sym_enum] = ACTIONS(2040),
    [anon_sym_class] = ACTIONS(2040),
    [anon_sym_struct] = ACTIONS(2040),
    [anon_sym_union] = ACTIONS(2040),
    [anon_sym_if] = ACTIONS(2040),
    [anon_sym_else] = ACTIONS(2040),
    [anon_sym_switch] = ACTIONS(2040),
    [anon_sym_case] = ACTIONS(2040),
    [anon_sym_default] = ACTIONS(2040),
    [anon_sym_while] = ACTIONS(2040),
    [anon_sym_do] = ACTIONS(2040),
    [anon_sym_for] = ACTIONS(2040),
    [anon_sym_return] = ACTIONS(2040),
    [anon_sym_break] = ACTIONS(2040),
    [anon_sym_continue] = ACTIONS(2040),
    [anon_sym_goto] = ACTIONS(2040),
    [anon_sym___try] = ACTIONS(2040),
    [anon_sym___leave] = ACTIONS(2040),
    [anon_sym_not] = ACTIONS(2040),
    [anon_sym_compl] = ACTIONS(2040),
    [anon_sym_DASH_DASH] = ACTIONS(2042),
    [anon_sym_PLUS_PLUS] = ACTIONS(2042),
    [anon_sym_sizeof] = ACTIONS(2040),
    [anon_sym___alignof__] = ACTIONS(2040),
    [anon_sym___alignof] = ACTIONS(2040),
    [anon_sym__alignof] = ACTIONS(2040),
    [anon_sym_alignof] = ACTIONS(2040),
    [anon_sym__Alignof] = ACTIONS(2040),
    [anon_sym_offsetof] = ACTIONS(2040),
    [anon_sym__Generic] = ACTIONS(2040),
    [anon_sym_asm] = ACTIONS(2040),
    [anon_sym___asm__] = ACTIONS(2040),
    [sym_number_literal] = ACTIONS(2042),
    [anon_sym_L_SQUOTE] = ACTIONS(2042),
    [anon_sym_u_SQUOTE] = ACTIONS(2042),
    [anon_sym_U_SQUOTE] = ACTIONS(2042),
    [anon_sym_u8_SQUOTE] = ACTIONS(2042),
    [anon_sym_SQUOTE] = ACTIONS(2042),
    [anon_sym_L_DQUOTE] = ACTIONS(2042),
    [anon_sym_u_DQUOTE] = ACTIONS(2042),
    [anon_sym_U_DQUOTE] = ACTIONS(2042),
    [anon_sym_u8_DQUOTE] = ACTIONS(2042),
    [anon_sym_DQUOTE] = ACTIONS(2042),
    [sym_true] = ACTIONS(2040),
    [sym_false] = ACTIONS(2040),
    [anon_sym_NULL] = ACTIONS(2040),
    [anon_sym_nullptr] = ACTIONS(2040),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2040),
    [anon_sym_decltype] = ACTIONS(2040),
    [sym_virtual] = ACTIONS(2040),
    [anon_sym_explicit] = ACTIONS(2040),
    [anon_sym_typename] = ACTIONS(2040),
    [anon_sym_template] = ACTIONS(2040),
    [anon_sym_operator] = ACTIONS(2040),
    [anon_sym_try] = ACTIONS(2040),
    [anon_sym_delete] = ACTIONS(2040),
    [anon_sym_throw] = ACTIONS(2040),
    [anon_sym_namespace] = ACTIONS(2040),
    [anon_sym_using] = ACTIONS(2040),
    [anon_sym_static_assert] = ACTIONS(2040),
    [anon_sym_concept] = ACTIONS(2040),
    [anon_sym_co_return] = ACTIONS(2040),
    [anon_sym_co_yield] = ACTIONS(2040),
    [anon_sym_R_DQUOTE] = ACTIONS(2042),
    [anon_sym_LR_DQUOTE] = ACTIONS(2042),
    [anon_sym_uR_DQUOTE] = ACTIONS(2042),
    [anon_sym_UR_DQUOTE] = ACTIONS(2042),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2042),
    [anon_sym_co_await] = ACTIONS(2040),
    [anon_sym_new] = ACTIONS(2040),
    [anon_sym_requires] = ACTIONS(2040),
    [sym_this] = ACTIONS(2040),
    [anon_sym___launch_bounds__] = ACTIONS(2040),
  },
  [171] = {
    [sym_identifier] = ACTIONS(2044),
    [aux_sym_preproc_include_token1] = ACTIONS(2044),
    [aux_sym_preproc_def_token1] = ACTIONS(2044),
    [aux_sym_preproc_if_token1] = ACTIONS(2044),
    [aux_sym_preproc_if_token2] = ACTIONS(2044),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2044),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2044),
    [aux_sym_preproc_else_token1] = ACTIONS(2044),
    [aux_sym_preproc_elif_token1] = ACTIONS(2044),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2044),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2044),
    [sym_preproc_directive] = ACTIONS(2044),
    [anon_sym_LPAREN2] = ACTIONS(2046),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2044),
    [anon_sym_PLUS] = ACTIONS(2044),
    [anon_sym_STAR] = ACTIONS(2046),
    [anon_sym_AMP_AMP] = ACTIONS(2046),
    [anon_sym_AMP] = ACTIONS(2044),
    [anon_sym_SEMI] = ACTIONS(2046),
    [anon_sym___extension__] = ACTIONS(2044),
    [anon_sym_typedef] = ACTIONS(2044),
    [anon_sym___device__] = ACTIONS(2044),
    [anon_sym___host__] = ACTIONS(2044),
    [anon_sym___global__] = ACTIONS(2044),
    [anon_sym___forceinline__] = ACTIONS(2044),
    [anon_sym___noinline__] = ACTIONS(2044),
    [anon_sym_extern] = ACTIONS(2044),
    [anon_sym___attribute__] = ACTIONS(2044),
    [anon_sym_COLON_COLON] = ACTIONS(2046),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2046),
    [anon_sym___declspec] = ACTIONS(2044),
    [anon_sym___based] = ACTIONS(2044),
    [anon_sym___cdecl] = ACTIONS(2044),
    [anon_sym___clrcall] = ACTIONS(2044),
    [anon_sym___stdcall] = ACTIONS(2044),
    [anon_sym___fastcall] = ACTIONS(2044),
    [anon_sym___thiscall] = ACTIONS(2044),
    [anon_sym___vectorcall] = ACTIONS(2044),
    [anon_sym_LBRACE] = ACTIONS(2046),
    [anon_sym_signed] = ACTIONS(2044),
    [anon_sym_unsigned] = ACTIONS(2044),
    [anon_sym_long] = ACTIONS(2044),
    [anon_sym_short] = ACTIONS(2044),
    [anon_sym_LBRACK] = ACTIONS(2044),
    [anon_sym_static] = ACTIONS(2044),
    [anon_sym_register] = ACTIONS(2044),
    [anon_sym_inline] = ACTIONS(2044),
    [anon_sym___inline] = ACTIONS(2044),
    [anon_sym___inline__] = ACTIONS(2044),
    [anon_sym___forceinline] = ACTIONS(2044),
    [anon_sym_thread_local] = ACTIONS(2044),
    [anon_sym___thread] = ACTIONS(2044),
    [anon_sym_const] = ACTIONS(2044),
    [anon_sym_constexpr] = ACTIONS(2044),
    [anon_sym_volatile] = ACTIONS(2044),
    [anon_sym_restrict] = ACTIONS(2044),
    [anon_sym___restrict__] = ACTIONS(2044),
    [anon_sym__Atomic] = ACTIONS(2044),
    [anon_sym__Noreturn] = ACTIONS(2044),
    [anon_sym_noreturn] = ACTIONS(2044),
    [anon_sym_mutable] = ACTIONS(2044),
    [anon_sym_constinit] = ACTIONS(2044),
    [anon_sym_consteval] = ACTIONS(2044),
    [anon_sym___shared__] = ACTIONS(2044),
    [anon_sym___local__] = ACTIONS(2044),
    [anon_sym___constant__] = ACTIONS(2044),
    [anon_sym___managed__] = ACTIONS(2044),
    [anon_sym___grid_constant__] = ACTIONS(2044),
    [anon_sym_alignas] = ACTIONS(2044),
    [anon_sym__Alignas] = ACTIONS(2044),
    [sym_primitive_type] = ACTIONS(2044),
    [anon_sym_enum] = ACTIONS(2044),
    [anon_sym_class] = ACTIONS(2044),
    [anon_sym_struct] = ACTIONS(2044),
    [anon_sym_union] = ACTIONS(2044),
    [anon_sym_if] = ACTIONS(2044),
    [anon_sym_else] = ACTIONS(2044),
    [anon_sym_switch] = ACTIONS(2044),
    [anon_sym_case] = ACTIONS(2044),
    [anon_sym_default] = ACTIONS(2044),
    [anon_sym_while] = ACTIONS(2044),
    [anon_sym_do] = ACTIONS(2044),
    [anon_sym_for] = ACTIONS(2044),
    [anon_sym_return] = ACTIONS(2044),
    [anon_sym_break] = ACTIONS(2044),
    [anon_sym_continue] = ACTIONS(2044),
    [anon_sym_goto] = ACTIONS(2044),
    [anon_sym___try] = ACTIONS(2044),
    [anon_sym___leave] = ACTIONS(2044),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_compl] = ACTIONS(2044),
    [anon_sym_DASH_DASH] = ACTIONS(2046),
    [anon_sym_PLUS_PLUS] = ACTIONS(2046),
    [anon_sym_sizeof] = ACTIONS(2044),
    [anon_sym___alignof__] = ACTIONS(2044),
    [anon_sym___alignof] = ACTIONS(2044),
    [anon_sym__alignof] = ACTIONS(2044),
    [anon_sym_alignof] = ACTIONS(2044),
    [anon_sym__Alignof] = ACTIONS(2044),
    [anon_sym_offsetof] = ACTIONS(2044),
    [anon_sym__Generic] = ACTIONS(2044),
    [anon_sym_asm] = ACTIONS(2044),
    [anon_sym___asm__] = ACTIONS(2044),
    [sym_number_literal] = ACTIONS(2046),
    [anon_sym_L_SQUOTE] = ACTIONS(2046),
    [anon_sym_u_SQUOTE] = ACTIONS(2046),
    [anon_sym_U_SQUOTE] = ACTIONS(2046),
    [anon_sym_u8_SQUOTE] = ACTIONS(2046),
    [anon_sym_SQUOTE] = ACTIONS(2046),
    [anon_sym_L_DQUOTE] = ACTIONS(2046),
    [anon_sym_u_DQUOTE] = ACTIONS(2046),
    [anon_sym_U_DQUOTE] = ACTIONS(2046),
    [anon_sym_u8_DQUOTE] = ACTIONS(2046),
    [anon_sym_DQUOTE] = ACTIONS(2046),
    [sym_true] = ACTIONS(2044),
    [sym_false] = ACTIONS(2044),
    [anon_sym_NULL] = ACTIONS(2044),
    [anon_sym_nullptr] = ACTIONS(2044),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2044),
    [anon_sym_decltype] = ACTIONS(2044),
    [sym_virtual] = ACTIONS(2044),
    [anon_sym_explicit] = ACTIONS(2044),
    [anon_sym_typename] = ACTIONS(2044),
    [anon_sym_template] = ACTIONS(2044),
    [anon_sym_operator] = ACTIONS(2044),
    [anon_sym_try] = ACTIONS(2044),
    [anon_sym_delete] = ACTIONS(2044),
    [anon_sym_throw] = ACTIONS(2044),
    [anon_sym_namespace] = ACTIONS(2044),
    [anon_sym_using] = ACTIONS(2044),
    [anon_sym_static_assert] = ACTIONS(2044),
    [anon_sym_concept] = ACTIONS(2044),
    [anon_sym_co_return] = ACTIONS(2044),
    [anon_sym_co_yield] = ACTIONS(2044),
    [anon_sym_R_DQUOTE] = ACTIONS(2046),
    [anon_sym_LR_DQUOTE] = ACTIONS(2046),
    [anon_sym_uR_DQUOTE] = ACTIONS(2046),
    [anon_sym_UR_DQUOTE] = ACTIONS(2046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2046),
    [anon_sym_co_await] = ACTIONS(2044),
    [anon_sym_new] = ACTIONS(2044),
    [anon_sym_requires] = ACTIONS(2044),
    [sym_this] = ACTIONS(2044),
    [anon_sym___launch_bounds__] = ACTIONS(2044),
  },
  [172] = {
    [sym_identifier] = ACTIONS(2048),
    [aux_sym_preproc_include_token1] = ACTIONS(2048),
    [aux_sym_preproc_def_token1] = ACTIONS(2048),
    [aux_sym_preproc_if_token1] = ACTIONS(2048),
    [aux_sym_preproc_if_token2] = ACTIONS(2048),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2048),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2048),
    [aux_sym_preproc_else_token1] = ACTIONS(2048),
    [aux_sym_preproc_elif_token1] = ACTIONS(2048),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2048),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2048),
    [sym_preproc_directive] = ACTIONS(2048),
    [anon_sym_LPAREN2] = ACTIONS(2050),
    [anon_sym_BANG] = ACTIONS(2050),
    [anon_sym_TILDE] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2048),
    [anon_sym_PLUS] = ACTIONS(2048),
    [anon_sym_STAR] = ACTIONS(2050),
    [anon_sym_AMP_AMP] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2048),
    [anon_sym_SEMI] = ACTIONS(2050),
    [anon_sym___extension__] = ACTIONS(2048),
    [anon_sym_typedef] = ACTIONS(2048),
    [anon_sym___device__] = ACTIONS(2048),
    [anon_sym___host__] = ACTIONS(2048),
    [anon_sym___global__] = ACTIONS(2048),
    [anon_sym___forceinline__] = ACTIONS(2048),
    [anon_sym___noinline__] = ACTIONS(2048),
    [anon_sym_extern] = ACTIONS(2048),
    [anon_sym___attribute__] = ACTIONS(2048),
    [anon_sym_COLON_COLON] = ACTIONS(2050),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2050),
    [anon_sym___declspec] = ACTIONS(2048),
    [anon_sym___based] = ACTIONS(2048),
    [anon_sym___cdecl] = ACTIONS(2048),
    [anon_sym___clrcall] = ACTIONS(2048),
    [anon_sym___stdcall] = ACTIONS(2048),
    [anon_sym___fastcall] = ACTIONS(2048),
    [anon_sym___thiscall] = ACTIONS(2048),
    [anon_sym___vectorcall] = ACTIONS(2048),
    [anon_sym_LBRACE] = ACTIONS(2050),
    [anon_sym_signed] = ACTIONS(2048),
    [anon_sym_unsigned] = ACTIONS(2048),
    [anon_sym_long] = ACTIONS(2048),
    [anon_sym_short] = ACTIONS(2048),
    [anon_sym_LBRACK] = ACTIONS(2048),
    [anon_sym_static] = ACTIONS(2048),
    [anon_sym_register] = ACTIONS(2048),
    [anon_sym_inline] = ACTIONS(2048),
    [anon_sym___inline] = ACTIONS(2048),
    [anon_sym___inline__] = ACTIONS(2048),
    [anon_sym___forceinline] = ACTIONS(2048),
    [anon_sym_thread_local] = ACTIONS(2048),
    [anon_sym___thread] = ACTIONS(2048),
    [anon_sym_const] = ACTIONS(2048),
    [anon_sym_constexpr] = ACTIONS(2048),
    [anon_sym_volatile] = ACTIONS(2048),
    [anon_sym_restrict] = ACTIONS(2048),
    [anon_sym___restrict__] = ACTIONS(2048),
    [anon_sym__Atomic] = ACTIONS(2048),
    [anon_sym__Noreturn] = ACTIONS(2048),
    [anon_sym_noreturn] = ACTIONS(2048),
    [anon_sym_mutable] = ACTIONS(2048),
    [anon_sym_constinit] = ACTIONS(2048),
    [anon_sym_consteval] = ACTIONS(2048),
    [anon_sym___shared__] = ACTIONS(2048),
    [anon_sym___local__] = ACTIONS(2048),
    [anon_sym___constant__] = ACTIONS(2048),
    [anon_sym___managed__] = ACTIONS(2048),
    [anon_sym___grid_constant__] = ACTIONS(2048),
    [anon_sym_alignas] = ACTIONS(2048),
    [anon_sym__Alignas] = ACTIONS(2048),
    [sym_primitive_type] = ACTIONS(2048),
    [anon_sym_enum] = ACTIONS(2048),
    [anon_sym_class] = ACTIONS(2048),
    [anon_sym_struct] = ACTIONS(2048),
    [anon_sym_union] = ACTIONS(2048),
    [anon_sym_if] = ACTIONS(2048),
    [anon_sym_else] = ACTIONS(2048),
    [anon_sym_switch] = ACTIONS(2048),
    [anon_sym_case] = ACTIONS(2048),
    [anon_sym_default] = ACTIONS(2048),
    [anon_sym_while] = ACTIONS(2048),
    [anon_sym_do] = ACTIONS(2048),
    [anon_sym_for] = ACTIONS(2048),
    [anon_sym_return] = ACTIONS(2048),
    [anon_sym_break] = ACTIONS(2048),
    [anon_sym_continue] = ACTIONS(2048),
    [anon_sym_goto] = ACTIONS(2048),
    [anon_sym___try] = ACTIONS(2048),
    [anon_sym___leave] = ACTIONS(2048),
    [anon_sym_not] = ACTIONS(2048),
    [anon_sym_compl] = ACTIONS(2048),
    [anon_sym_DASH_DASH] = ACTIONS(2050),
    [anon_sym_PLUS_PLUS] = ACTIONS(2050),
    [anon_sym_sizeof] = ACTIONS(2048),
    [anon_sym___alignof__] = ACTIONS(2048),
    [anon_sym___alignof] = ACTIONS(2048),
    [anon_sym__alignof] = ACTIONS(2048),
    [anon_sym_alignof] = ACTIONS(2048),
    [anon_sym__Alignof] = ACTIONS(2048),
    [anon_sym_offsetof] = ACTIONS(2048),
    [anon_sym__Generic] = ACTIONS(2048),
    [anon_sym_asm] = ACTIONS(2048),
    [anon_sym___asm__] = ACTIONS(2048),
    [sym_number_literal] = ACTIONS(2050),
    [anon_sym_L_SQUOTE] = ACTIONS(2050),
    [anon_sym_u_SQUOTE] = ACTIONS(2050),
    [anon_sym_U_SQUOTE] = ACTIONS(2050),
    [anon_sym_u8_SQUOTE] = ACTIONS(2050),
    [anon_sym_SQUOTE] = ACTIONS(2050),
    [anon_sym_L_DQUOTE] = ACTIONS(2050),
    [anon_sym_u_DQUOTE] = ACTIONS(2050),
    [anon_sym_U_DQUOTE] = ACTIONS(2050),
    [anon_sym_u8_DQUOTE] = ACTIONS(2050),
    [anon_sym_DQUOTE] = ACTIONS(2050),
    [sym_true] = ACTIONS(2048),
    [sym_false] = ACTIONS(2048),
    [anon_sym_NULL] = ACTIONS(2048),
    [anon_sym_nullptr] = ACTIONS(2048),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2048),
    [anon_sym_decltype] = ACTIONS(2048),
    [sym_virtual] = ACTIONS(2048),
    [anon_sym_explicit] = ACTIONS(2048),
    [anon_sym_typename] = ACTIONS(2048),
    [anon_sym_template] = ACTIONS(2048),
    [anon_sym_operator] = ACTIONS(2048),
    [anon_sym_try] = ACTIONS(2048),
    [anon_sym_delete] = ACTIONS(2048),
    [anon_sym_throw] = ACTIONS(2048),
    [anon_sym_namespace] = ACTIONS(2048),
    [anon_sym_using] = ACTIONS(2048),
    [anon_sym_static_assert] = ACTIONS(2048),
    [anon_sym_concept] = ACTIONS(2048),
    [anon_sym_co_return] = ACTIONS(2048),
    [anon_sym_co_yield] = ACTIONS(2048),
    [anon_sym_R_DQUOTE] = ACTIONS(2050),
    [anon_sym_LR_DQUOTE] = ACTIONS(2050),
    [anon_sym_uR_DQUOTE] = ACTIONS(2050),
    [anon_sym_UR_DQUOTE] = ACTIONS(2050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2050),
    [anon_sym_co_await] = ACTIONS(2048),
    [anon_sym_new] = ACTIONS(2048),
    [anon_sym_requires] = ACTIONS(2048),
    [sym_this] = ACTIONS(2048),
    [anon_sym___launch_bounds__] = ACTIONS(2048),
  },
  [173] = {
    [sym_identifier] = ACTIONS(2052),
    [aux_sym_preproc_include_token1] = ACTIONS(2052),
    [aux_sym_preproc_def_token1] = ACTIONS(2052),
    [aux_sym_preproc_if_token1] = ACTIONS(2052),
    [aux_sym_preproc_if_token2] = ACTIONS(2052),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2052),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2052),
    [aux_sym_preproc_else_token1] = ACTIONS(2052),
    [aux_sym_preproc_elif_token1] = ACTIONS(2052),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2052),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2052),
    [sym_preproc_directive] = ACTIONS(2052),
    [anon_sym_LPAREN2] = ACTIONS(2054),
    [anon_sym_BANG] = ACTIONS(2054),
    [anon_sym_TILDE] = ACTIONS(2054),
    [anon_sym_DASH] = ACTIONS(2052),
    [anon_sym_PLUS] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(2054),
    [anon_sym_AMP_AMP] = ACTIONS(2054),
    [anon_sym_AMP] = ACTIONS(2052),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym___extension__] = ACTIONS(2052),
    [anon_sym_typedef] = ACTIONS(2052),
    [anon_sym___device__] = ACTIONS(2052),
    [anon_sym___host__] = ACTIONS(2052),
    [anon_sym___global__] = ACTIONS(2052),
    [anon_sym___forceinline__] = ACTIONS(2052),
    [anon_sym___noinline__] = ACTIONS(2052),
    [anon_sym_extern] = ACTIONS(2052),
    [anon_sym___attribute__] = ACTIONS(2052),
    [anon_sym_COLON_COLON] = ACTIONS(2054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2054),
    [anon_sym___declspec] = ACTIONS(2052),
    [anon_sym___based] = ACTIONS(2052),
    [anon_sym___cdecl] = ACTIONS(2052),
    [anon_sym___clrcall] = ACTIONS(2052),
    [anon_sym___stdcall] = ACTIONS(2052),
    [anon_sym___fastcall] = ACTIONS(2052),
    [anon_sym___thiscall] = ACTIONS(2052),
    [anon_sym___vectorcall] = ACTIONS(2052),
    [anon_sym_LBRACE] = ACTIONS(2054),
    [anon_sym_signed] = ACTIONS(2052),
    [anon_sym_unsigned] = ACTIONS(2052),
    [anon_sym_long] = ACTIONS(2052),
    [anon_sym_short] = ACTIONS(2052),
    [anon_sym_LBRACK] = ACTIONS(2052),
    [anon_sym_static] = ACTIONS(2052),
    [anon_sym_register] = ACTIONS(2052),
    [anon_sym_inline] = ACTIONS(2052),
    [anon_sym___inline] = ACTIONS(2052),
    [anon_sym___inline__] = ACTIONS(2052),
    [anon_sym___forceinline] = ACTIONS(2052),
    [anon_sym_thread_local] = ACTIONS(2052),
    [anon_sym___thread] = ACTIONS(2052),
    [anon_sym_const] = ACTIONS(2052),
    [anon_sym_constexpr] = ACTIONS(2052),
    [anon_sym_volatile] = ACTIONS(2052),
    [anon_sym_restrict] = ACTIONS(2052),
    [anon_sym___restrict__] = ACTIONS(2052),
    [anon_sym__Atomic] = ACTIONS(2052),
    [anon_sym__Noreturn] = ACTIONS(2052),
    [anon_sym_noreturn] = ACTIONS(2052),
    [anon_sym_mutable] = ACTIONS(2052),
    [anon_sym_constinit] = ACTIONS(2052),
    [anon_sym_consteval] = ACTIONS(2052),
    [anon_sym___shared__] = ACTIONS(2052),
    [anon_sym___local__] = ACTIONS(2052),
    [anon_sym___constant__] = ACTIONS(2052),
    [anon_sym___managed__] = ACTIONS(2052),
    [anon_sym___grid_constant__] = ACTIONS(2052),
    [anon_sym_alignas] = ACTIONS(2052),
    [anon_sym__Alignas] = ACTIONS(2052),
    [sym_primitive_type] = ACTIONS(2052),
    [anon_sym_enum] = ACTIONS(2052),
    [anon_sym_class] = ACTIONS(2052),
    [anon_sym_struct] = ACTIONS(2052),
    [anon_sym_union] = ACTIONS(2052),
    [anon_sym_if] = ACTIONS(2052),
    [anon_sym_else] = ACTIONS(2052),
    [anon_sym_switch] = ACTIONS(2052),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2052),
    [anon_sym_while] = ACTIONS(2052),
    [anon_sym_do] = ACTIONS(2052),
    [anon_sym_for] = ACTIONS(2052),
    [anon_sym_return] = ACTIONS(2052),
    [anon_sym_break] = ACTIONS(2052),
    [anon_sym_continue] = ACTIONS(2052),
    [anon_sym_goto] = ACTIONS(2052),
    [anon_sym___try] = ACTIONS(2052),
    [anon_sym___leave] = ACTIONS(2052),
    [anon_sym_not] = ACTIONS(2052),
    [anon_sym_compl] = ACTIONS(2052),
    [anon_sym_DASH_DASH] = ACTIONS(2054),
    [anon_sym_PLUS_PLUS] = ACTIONS(2054),
    [anon_sym_sizeof] = ACTIONS(2052),
    [anon_sym___alignof__] = ACTIONS(2052),
    [anon_sym___alignof] = ACTIONS(2052),
    [anon_sym__alignof] = ACTIONS(2052),
    [anon_sym_alignof] = ACTIONS(2052),
    [anon_sym__Alignof] = ACTIONS(2052),
    [anon_sym_offsetof] = ACTIONS(2052),
    [anon_sym__Generic] = ACTIONS(2052),
    [anon_sym_asm] = ACTIONS(2052),
    [anon_sym___asm__] = ACTIONS(2052),
    [sym_number_literal] = ACTIONS(2054),
    [anon_sym_L_SQUOTE] = ACTIONS(2054),
    [anon_sym_u_SQUOTE] = ACTIONS(2054),
    [anon_sym_U_SQUOTE] = ACTIONS(2054),
    [anon_sym_u8_SQUOTE] = ACTIONS(2054),
    [anon_sym_SQUOTE] = ACTIONS(2054),
    [anon_sym_L_DQUOTE] = ACTIONS(2054),
    [anon_sym_u_DQUOTE] = ACTIONS(2054),
    [anon_sym_U_DQUOTE] = ACTIONS(2054),
    [anon_sym_u8_DQUOTE] = ACTIONS(2054),
    [anon_sym_DQUOTE] = ACTIONS(2054),
    [sym_true] = ACTIONS(2052),
    [sym_false] = ACTIONS(2052),
    [anon_sym_NULL] = ACTIONS(2052),
    [anon_sym_nullptr] = ACTIONS(2052),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2052),
    [anon_sym_decltype] = ACTIONS(2052),
    [sym_virtual] = ACTIONS(2052),
    [anon_sym_explicit] = ACTIONS(2052),
    [anon_sym_typename] = ACTIONS(2052),
    [anon_sym_template] = ACTIONS(2052),
    [anon_sym_operator] = ACTIONS(2052),
    [anon_sym_try] = ACTIONS(2052),
    [anon_sym_delete] = ACTIONS(2052),
    [anon_sym_throw] = ACTIONS(2052),
    [anon_sym_namespace] = ACTIONS(2052),
    [anon_sym_using] = ACTIONS(2052),
    [anon_sym_static_assert] = ACTIONS(2052),
    [anon_sym_concept] = ACTIONS(2052),
    [anon_sym_co_return] = ACTIONS(2052),
    [anon_sym_co_yield] = ACTIONS(2052),
    [anon_sym_R_DQUOTE] = ACTIONS(2054),
    [anon_sym_LR_DQUOTE] = ACTIONS(2054),
    [anon_sym_uR_DQUOTE] = ACTIONS(2054),
    [anon_sym_UR_DQUOTE] = ACTIONS(2054),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2054),
    [anon_sym_co_await] = ACTIONS(2052),
    [anon_sym_new] = ACTIONS(2052),
    [anon_sym_requires] = ACTIONS(2052),
    [sym_this] = ACTIONS(2052),
    [anon_sym___launch_bounds__] = ACTIONS(2052),
  },
  [174] = {
    [sym_identifier] = ACTIONS(2056),
    [aux_sym_preproc_include_token1] = ACTIONS(2056),
    [aux_sym_preproc_def_token1] = ACTIONS(2056),
    [aux_sym_preproc_if_token1] = ACTIONS(2056),
    [aux_sym_preproc_if_token2] = ACTIONS(2056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2056),
    [aux_sym_preproc_else_token1] = ACTIONS(2056),
    [aux_sym_preproc_elif_token1] = ACTIONS(2056),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2056),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2056),
    [sym_preproc_directive] = ACTIONS(2056),
    [anon_sym_LPAREN2] = ACTIONS(2058),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_DASH] = ACTIONS(2056),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_STAR] = ACTIONS(2058),
    [anon_sym_AMP_AMP] = ACTIONS(2058),
    [anon_sym_AMP] = ACTIONS(2056),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_typedef] = ACTIONS(2056),
    [anon_sym___device__] = ACTIONS(2056),
    [anon_sym___host__] = ACTIONS(2056),
    [anon_sym___global__] = ACTIONS(2056),
    [anon_sym___forceinline__] = ACTIONS(2056),
    [anon_sym___noinline__] = ACTIONS(2056),
    [anon_sym_extern] = ACTIONS(2056),
    [anon_sym___attribute__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2058),
    [anon_sym___declspec] = ACTIONS(2056),
    [anon_sym___based] = ACTIONS(2056),
    [anon_sym___cdecl] = ACTIONS(2056),
    [anon_sym___clrcall] = ACTIONS(2056),
    [anon_sym___stdcall] = ACTIONS(2056),
    [anon_sym___fastcall] = ACTIONS(2056),
    [anon_sym___thiscall] = ACTIONS(2056),
    [anon_sym___vectorcall] = ACTIONS(2056),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_signed] = ACTIONS(2056),
    [anon_sym_unsigned] = ACTIONS(2056),
    [anon_sym_long] = ACTIONS(2056),
    [anon_sym_short] = ACTIONS(2056),
    [anon_sym_LBRACK] = ACTIONS(2056),
    [anon_sym_static] = ACTIONS(2056),
    [anon_sym_register] = ACTIONS(2056),
    [anon_sym_inline] = ACTIONS(2056),
    [anon_sym___inline] = ACTIONS(2056),
    [anon_sym___inline__] = ACTIONS(2056),
    [anon_sym___forceinline] = ACTIONS(2056),
    [anon_sym_thread_local] = ACTIONS(2056),
    [anon_sym___thread] = ACTIONS(2056),
    [anon_sym_const] = ACTIONS(2056),
    [anon_sym_constexpr] = ACTIONS(2056),
    [anon_sym_volatile] = ACTIONS(2056),
    [anon_sym_restrict] = ACTIONS(2056),
    [anon_sym___restrict__] = ACTIONS(2056),
    [anon_sym__Atomic] = ACTIONS(2056),
    [anon_sym__Noreturn] = ACTIONS(2056),
    [anon_sym_noreturn] = ACTIONS(2056),
    [anon_sym_mutable] = ACTIONS(2056),
    [anon_sym_constinit] = ACTIONS(2056),
    [anon_sym_consteval] = ACTIONS(2056),
    [anon_sym___shared__] = ACTIONS(2056),
    [anon_sym___local__] = ACTIONS(2056),
    [anon_sym___constant__] = ACTIONS(2056),
    [anon_sym___managed__] = ACTIONS(2056),
    [anon_sym___grid_constant__] = ACTIONS(2056),
    [anon_sym_alignas] = ACTIONS(2056),
    [anon_sym__Alignas] = ACTIONS(2056),
    [sym_primitive_type] = ACTIONS(2056),
    [anon_sym_enum] = ACTIONS(2056),
    [anon_sym_class] = ACTIONS(2056),
    [anon_sym_struct] = ACTIONS(2056),
    [anon_sym_union] = ACTIONS(2056),
    [anon_sym_if] = ACTIONS(2056),
    [anon_sym_else] = ACTIONS(2056),
    [anon_sym_switch] = ACTIONS(2056),
    [anon_sym_case] = ACTIONS(2056),
    [anon_sym_default] = ACTIONS(2056),
    [anon_sym_while] = ACTIONS(2056),
    [anon_sym_do] = ACTIONS(2056),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2056),
    [anon_sym_break] = ACTIONS(2056),
    [anon_sym_continue] = ACTIONS(2056),
    [anon_sym_goto] = ACTIONS(2056),
    [anon_sym___try] = ACTIONS(2056),
    [anon_sym___leave] = ACTIONS(2056),
    [anon_sym_not] = ACTIONS(2056),
    [anon_sym_compl] = ACTIONS(2056),
    [anon_sym_DASH_DASH] = ACTIONS(2058),
    [anon_sym_PLUS_PLUS] = ACTIONS(2058),
    [anon_sym_sizeof] = ACTIONS(2056),
    [anon_sym___alignof__] = ACTIONS(2056),
    [anon_sym___alignof] = ACTIONS(2056),
    [anon_sym__alignof] = ACTIONS(2056),
    [anon_sym_alignof] = ACTIONS(2056),
    [anon_sym__Alignof] = ACTIONS(2056),
    [anon_sym_offsetof] = ACTIONS(2056),
    [anon_sym__Generic] = ACTIONS(2056),
    [anon_sym_asm] = ACTIONS(2056),
    [anon_sym___asm__] = ACTIONS(2056),
    [sym_number_literal] = ACTIONS(2058),
    [anon_sym_L_SQUOTE] = ACTIONS(2058),
    [anon_sym_u_SQUOTE] = ACTIONS(2058),
    [anon_sym_U_SQUOTE] = ACTIONS(2058),
    [anon_sym_u8_SQUOTE] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [anon_sym_L_DQUOTE] = ACTIONS(2058),
    [anon_sym_u_DQUOTE] = ACTIONS(2058),
    [anon_sym_U_DQUOTE] = ACTIONS(2058),
    [anon_sym_u8_DQUOTE] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [sym_true] = ACTIONS(2056),
    [sym_false] = ACTIONS(2056),
    [anon_sym_NULL] = ACTIONS(2056),
    [anon_sym_nullptr] = ACTIONS(2056),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2056),
    [anon_sym_decltype] = ACTIONS(2056),
    [sym_virtual] = ACTIONS(2056),
    [anon_sym_explicit] = ACTIONS(2056),
    [anon_sym_typename] = ACTIONS(2056),
    [anon_sym_template] = ACTIONS(2056),
    [anon_sym_operator] = ACTIONS(2056),
    [anon_sym_try] = ACTIONS(2056),
    [anon_sym_delete] = ACTIONS(2056),
    [anon_sym_throw] = ACTIONS(2056),
    [anon_sym_namespace] = ACTIONS(2056),
    [anon_sym_using] = ACTIONS(2056),
    [anon_sym_static_assert] = ACTIONS(2056),
    [anon_sym_concept] = ACTIONS(2056),
    [anon_sym_co_return] = ACTIONS(2056),
    [anon_sym_co_yield] = ACTIONS(2056),
    [anon_sym_R_DQUOTE] = ACTIONS(2058),
    [anon_sym_LR_DQUOTE] = ACTIONS(2058),
    [anon_sym_uR_DQUOTE] = ACTIONS(2058),
    [anon_sym_UR_DQUOTE] = ACTIONS(2058),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2058),
    [anon_sym_co_await] = ACTIONS(2056),
    [anon_sym_new] = ACTIONS(2056),
    [anon_sym_requires] = ACTIONS(2056),
    [sym_this] = ACTIONS(2056),
    [anon_sym___launch_bounds__] = ACTIONS(2056),
  },
  [175] = {
    [sym_identifier] = ACTIONS(2060),
    [aux_sym_preproc_include_token1] = ACTIONS(2060),
    [aux_sym_preproc_def_token1] = ACTIONS(2060),
    [aux_sym_preproc_if_token1] = ACTIONS(2060),
    [aux_sym_preproc_if_token2] = ACTIONS(2060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2060),
    [aux_sym_preproc_else_token1] = ACTIONS(2060),
    [aux_sym_preproc_elif_token1] = ACTIONS(2060),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2060),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2060),
    [sym_preproc_directive] = ACTIONS(2060),
    [anon_sym_LPAREN2] = ACTIONS(2062),
    [anon_sym_BANG] = ACTIONS(2062),
    [anon_sym_TILDE] = ACTIONS(2062),
    [anon_sym_DASH] = ACTIONS(2060),
    [anon_sym_PLUS] = ACTIONS(2060),
    [anon_sym_STAR] = ACTIONS(2062),
    [anon_sym_AMP_AMP] = ACTIONS(2062),
    [anon_sym_AMP] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2062),
    [anon_sym___extension__] = ACTIONS(2060),
    [anon_sym_typedef] = ACTIONS(2060),
    [anon_sym___device__] = ACTIONS(2060),
    [anon_sym___host__] = ACTIONS(2060),
    [anon_sym___global__] = ACTIONS(2060),
    [anon_sym___forceinline__] = ACTIONS(2060),
    [anon_sym___noinline__] = ACTIONS(2060),
    [anon_sym_extern] = ACTIONS(2060),
    [anon_sym___attribute__] = ACTIONS(2060),
    [anon_sym_COLON_COLON] = ACTIONS(2062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2062),
    [anon_sym___declspec] = ACTIONS(2060),
    [anon_sym___based] = ACTIONS(2060),
    [anon_sym___cdecl] = ACTIONS(2060),
    [anon_sym___clrcall] = ACTIONS(2060),
    [anon_sym___stdcall] = ACTIONS(2060),
    [anon_sym___fastcall] = ACTIONS(2060),
    [anon_sym___thiscall] = ACTIONS(2060),
    [anon_sym___vectorcall] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(2062),
    [anon_sym_signed] = ACTIONS(2060),
    [anon_sym_unsigned] = ACTIONS(2060),
    [anon_sym_long] = ACTIONS(2060),
    [anon_sym_short] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2060),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_register] = ACTIONS(2060),
    [anon_sym_inline] = ACTIONS(2060),
    [anon_sym___inline] = ACTIONS(2060),
    [anon_sym___inline__] = ACTIONS(2060),
    [anon_sym___forceinline] = ACTIONS(2060),
    [anon_sym_thread_local] = ACTIONS(2060),
    [anon_sym___thread] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_constexpr] = ACTIONS(2060),
    [anon_sym_volatile] = ACTIONS(2060),
    [anon_sym_restrict] = ACTIONS(2060),
    [anon_sym___restrict__] = ACTIONS(2060),
    [anon_sym__Atomic] = ACTIONS(2060),
    [anon_sym__Noreturn] = ACTIONS(2060),
    [anon_sym_noreturn] = ACTIONS(2060),
    [anon_sym_mutable] = ACTIONS(2060),
    [anon_sym_constinit] = ACTIONS(2060),
    [anon_sym_consteval] = ACTIONS(2060),
    [anon_sym___shared__] = ACTIONS(2060),
    [anon_sym___local__] = ACTIONS(2060),
    [anon_sym___constant__] = ACTIONS(2060),
    [anon_sym___managed__] = ACTIONS(2060),
    [anon_sym___grid_constant__] = ACTIONS(2060),
    [anon_sym_alignas] = ACTIONS(2060),
    [anon_sym__Alignas] = ACTIONS(2060),
    [sym_primitive_type] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_struct] = ACTIONS(2060),
    [anon_sym_union] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_else] = ACTIONS(2060),
    [anon_sym_switch] = ACTIONS(2060),
    [anon_sym_case] = ACTIONS(2060),
    [anon_sym_default] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_do] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_goto] = ACTIONS(2060),
    [anon_sym___try] = ACTIONS(2060),
    [anon_sym___leave] = ACTIONS(2060),
    [anon_sym_not] = ACTIONS(2060),
    [anon_sym_compl] = ACTIONS(2060),
    [anon_sym_DASH_DASH] = ACTIONS(2062),
    [anon_sym_PLUS_PLUS] = ACTIONS(2062),
    [anon_sym_sizeof] = ACTIONS(2060),
    [anon_sym___alignof__] = ACTIONS(2060),
    [anon_sym___alignof] = ACTIONS(2060),
    [anon_sym__alignof] = ACTIONS(2060),
    [anon_sym_alignof] = ACTIONS(2060),
    [anon_sym__Alignof] = ACTIONS(2060),
    [anon_sym_offsetof] = ACTIONS(2060),
    [anon_sym__Generic] = ACTIONS(2060),
    [anon_sym_asm] = ACTIONS(2060),
    [anon_sym___asm__] = ACTIONS(2060),
    [sym_number_literal] = ACTIONS(2062),
    [anon_sym_L_SQUOTE] = ACTIONS(2062),
    [anon_sym_u_SQUOTE] = ACTIONS(2062),
    [anon_sym_U_SQUOTE] = ACTIONS(2062),
    [anon_sym_u8_SQUOTE] = ACTIONS(2062),
    [anon_sym_SQUOTE] = ACTIONS(2062),
    [anon_sym_L_DQUOTE] = ACTIONS(2062),
    [anon_sym_u_DQUOTE] = ACTIONS(2062),
    [anon_sym_U_DQUOTE] = ACTIONS(2062),
    [anon_sym_u8_DQUOTE] = ACTIONS(2062),
    [anon_sym_DQUOTE] = ACTIONS(2062),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [anon_sym_NULL] = ACTIONS(2060),
    [anon_sym_nullptr] = ACTIONS(2060),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2060),
    [anon_sym_decltype] = ACTIONS(2060),
    [sym_virtual] = ACTIONS(2060),
    [anon_sym_explicit] = ACTIONS(2060),
    [anon_sym_typename] = ACTIONS(2060),
    [anon_sym_template] = ACTIONS(2060),
    [anon_sym_operator] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [anon_sym_delete] = ACTIONS(2060),
    [anon_sym_throw] = ACTIONS(2060),
    [anon_sym_namespace] = ACTIONS(2060),
    [anon_sym_using] = ACTIONS(2060),
    [anon_sym_static_assert] = ACTIONS(2060),
    [anon_sym_concept] = ACTIONS(2060),
    [anon_sym_co_return] = ACTIONS(2060),
    [anon_sym_co_yield] = ACTIONS(2060),
    [anon_sym_R_DQUOTE] = ACTIONS(2062),
    [anon_sym_LR_DQUOTE] = ACTIONS(2062),
    [anon_sym_uR_DQUOTE] = ACTIONS(2062),
    [anon_sym_UR_DQUOTE] = ACTIONS(2062),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2062),
    [anon_sym_co_await] = ACTIONS(2060),
    [anon_sym_new] = ACTIONS(2060),
    [anon_sym_requires] = ACTIONS(2060),
    [sym_this] = ACTIONS(2060),
    [anon_sym___launch_bounds__] = ACTIONS(2060),
  },
  [176] = {
    [sym_identifier] = ACTIONS(2064),
    [aux_sym_preproc_include_token1] = ACTIONS(2064),
    [aux_sym_preproc_def_token1] = ACTIONS(2064),
    [aux_sym_preproc_if_token1] = ACTIONS(2064),
    [aux_sym_preproc_if_token2] = ACTIONS(2064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2064),
    [aux_sym_preproc_else_token1] = ACTIONS(2064),
    [aux_sym_preproc_elif_token1] = ACTIONS(2064),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2064),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2064),
    [sym_preproc_directive] = ACTIONS(2064),
    [anon_sym_LPAREN2] = ACTIONS(2066),
    [anon_sym_BANG] = ACTIONS(2066),
    [anon_sym_TILDE] = ACTIONS(2066),
    [anon_sym_DASH] = ACTIONS(2064),
    [anon_sym_PLUS] = ACTIONS(2064),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_AMP_AMP] = ACTIONS(2066),
    [anon_sym_AMP] = ACTIONS(2064),
    [anon_sym_SEMI] = ACTIONS(2066),
    [anon_sym___extension__] = ACTIONS(2064),
    [anon_sym_typedef] = ACTIONS(2064),
    [anon_sym___device__] = ACTIONS(2064),
    [anon_sym___host__] = ACTIONS(2064),
    [anon_sym___global__] = ACTIONS(2064),
    [anon_sym___forceinline__] = ACTIONS(2064),
    [anon_sym___noinline__] = ACTIONS(2064),
    [anon_sym_extern] = ACTIONS(2064),
    [anon_sym___attribute__] = ACTIONS(2064),
    [anon_sym_COLON_COLON] = ACTIONS(2066),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2066),
    [anon_sym___declspec] = ACTIONS(2064),
    [anon_sym___based] = ACTIONS(2064),
    [anon_sym___cdecl] = ACTIONS(2064),
    [anon_sym___clrcall] = ACTIONS(2064),
    [anon_sym___stdcall] = ACTIONS(2064),
    [anon_sym___fastcall] = ACTIONS(2064),
    [anon_sym___thiscall] = ACTIONS(2064),
    [anon_sym___vectorcall] = ACTIONS(2064),
    [anon_sym_LBRACE] = ACTIONS(2066),
    [anon_sym_signed] = ACTIONS(2064),
    [anon_sym_unsigned] = ACTIONS(2064),
    [anon_sym_long] = ACTIONS(2064),
    [anon_sym_short] = ACTIONS(2064),
    [anon_sym_LBRACK] = ACTIONS(2064),
    [anon_sym_static] = ACTIONS(2064),
    [anon_sym_register] = ACTIONS(2064),
    [anon_sym_inline] = ACTIONS(2064),
    [anon_sym___inline] = ACTIONS(2064),
    [anon_sym___inline__] = ACTIONS(2064),
    [anon_sym___forceinline] = ACTIONS(2064),
    [anon_sym_thread_local] = ACTIONS(2064),
    [anon_sym___thread] = ACTIONS(2064),
    [anon_sym_const] = ACTIONS(2064),
    [anon_sym_constexpr] = ACTIONS(2064),
    [anon_sym_volatile] = ACTIONS(2064),
    [anon_sym_restrict] = ACTIONS(2064),
    [anon_sym___restrict__] = ACTIONS(2064),
    [anon_sym__Atomic] = ACTIONS(2064),
    [anon_sym__Noreturn] = ACTIONS(2064),
    [anon_sym_noreturn] = ACTIONS(2064),
    [anon_sym_mutable] = ACTIONS(2064),
    [anon_sym_constinit] = ACTIONS(2064),
    [anon_sym_consteval] = ACTIONS(2064),
    [anon_sym___shared__] = ACTIONS(2064),
    [anon_sym___local__] = ACTIONS(2064),
    [anon_sym___constant__] = ACTIONS(2064),
    [anon_sym___managed__] = ACTIONS(2064),
    [anon_sym___grid_constant__] = ACTIONS(2064),
    [anon_sym_alignas] = ACTIONS(2064),
    [anon_sym__Alignas] = ACTIONS(2064),
    [sym_primitive_type] = ACTIONS(2064),
    [anon_sym_enum] = ACTIONS(2064),
    [anon_sym_class] = ACTIONS(2064),
    [anon_sym_struct] = ACTIONS(2064),
    [anon_sym_union] = ACTIONS(2064),
    [anon_sym_if] = ACTIONS(2064),
    [anon_sym_else] = ACTIONS(2064),
    [anon_sym_switch] = ACTIONS(2064),
    [anon_sym_case] = ACTIONS(2064),
    [anon_sym_default] = ACTIONS(2064),
    [anon_sym_while] = ACTIONS(2064),
    [anon_sym_do] = ACTIONS(2064),
    [anon_sym_for] = ACTIONS(2064),
    [anon_sym_return] = ACTIONS(2064),
    [anon_sym_break] = ACTIONS(2064),
    [anon_sym_continue] = ACTIONS(2064),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym___try] = ACTIONS(2064),
    [anon_sym___leave] = ACTIONS(2064),
    [anon_sym_not] = ACTIONS(2064),
    [anon_sym_compl] = ACTIONS(2064),
    [anon_sym_DASH_DASH] = ACTIONS(2066),
    [anon_sym_PLUS_PLUS] = ACTIONS(2066),
    [anon_sym_sizeof] = ACTIONS(2064),
    [anon_sym___alignof__] = ACTIONS(2064),
    [anon_sym___alignof] = ACTIONS(2064),
    [anon_sym__alignof] = ACTIONS(2064),
    [anon_sym_alignof] = ACTIONS(2064),
    [anon_sym__Alignof] = ACTIONS(2064),
    [anon_sym_offsetof] = ACTIONS(2064),
    [anon_sym__Generic] = ACTIONS(2064),
    [anon_sym_asm] = ACTIONS(2064),
    [anon_sym___asm__] = ACTIONS(2064),
    [sym_number_literal] = ACTIONS(2066),
    [anon_sym_L_SQUOTE] = ACTIONS(2066),
    [anon_sym_u_SQUOTE] = ACTIONS(2066),
    [anon_sym_U_SQUOTE] = ACTIONS(2066),
    [anon_sym_u8_SQUOTE] = ACTIONS(2066),
    [anon_sym_SQUOTE] = ACTIONS(2066),
    [anon_sym_L_DQUOTE] = ACTIONS(2066),
    [anon_sym_u_DQUOTE] = ACTIONS(2066),
    [anon_sym_U_DQUOTE] = ACTIONS(2066),
    [anon_sym_u8_DQUOTE] = ACTIONS(2066),
    [anon_sym_DQUOTE] = ACTIONS(2066),
    [sym_true] = ACTIONS(2064),
    [sym_false] = ACTIONS(2064),
    [anon_sym_NULL] = ACTIONS(2064),
    [anon_sym_nullptr] = ACTIONS(2064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2064),
    [anon_sym_decltype] = ACTIONS(2064),
    [sym_virtual] = ACTIONS(2064),
    [anon_sym_explicit] = ACTIONS(2064),
    [anon_sym_typename] = ACTIONS(2064),
    [anon_sym_template] = ACTIONS(2064),
    [anon_sym_operator] = ACTIONS(2064),
    [anon_sym_try] = ACTIONS(2064),
    [anon_sym_delete] = ACTIONS(2064),
    [anon_sym_throw] = ACTIONS(2064),
    [anon_sym_namespace] = ACTIONS(2064),
    [anon_sym_using] = ACTIONS(2064),
    [anon_sym_static_assert] = ACTIONS(2064),
    [anon_sym_concept] = ACTIONS(2064),
    [anon_sym_co_return] = ACTIONS(2064),
    [anon_sym_co_yield] = ACTIONS(2064),
    [anon_sym_R_DQUOTE] = ACTIONS(2066),
    [anon_sym_LR_DQUOTE] = ACTIONS(2066),
    [anon_sym_uR_DQUOTE] = ACTIONS(2066),
    [anon_sym_UR_DQUOTE] = ACTIONS(2066),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2066),
    [anon_sym_co_await] = ACTIONS(2064),
    [anon_sym_new] = ACTIONS(2064),
    [anon_sym_requires] = ACTIONS(2064),
    [sym_this] = ACTIONS(2064),
    [anon_sym___launch_bounds__] = ACTIONS(2064),
  },
  [177] = {
    [sym_identifier] = ACTIONS(2068),
    [aux_sym_preproc_include_token1] = ACTIONS(2068),
    [aux_sym_preproc_def_token1] = ACTIONS(2068),
    [aux_sym_preproc_if_token1] = ACTIONS(2068),
    [aux_sym_preproc_if_token2] = ACTIONS(2068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2068),
    [aux_sym_preproc_else_token1] = ACTIONS(2068),
    [aux_sym_preproc_elif_token1] = ACTIONS(2068),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2068),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2068),
    [sym_preproc_directive] = ACTIONS(2068),
    [anon_sym_LPAREN2] = ACTIONS(2070),
    [anon_sym_BANG] = ACTIONS(2070),
    [anon_sym_TILDE] = ACTIONS(2070),
    [anon_sym_DASH] = ACTIONS(2068),
    [anon_sym_PLUS] = ACTIONS(2068),
    [anon_sym_STAR] = ACTIONS(2070),
    [anon_sym_AMP_AMP] = ACTIONS(2070),
    [anon_sym_AMP] = ACTIONS(2068),
    [anon_sym_SEMI] = ACTIONS(2070),
    [anon_sym___extension__] = ACTIONS(2068),
    [anon_sym_typedef] = ACTIONS(2068),
    [anon_sym___device__] = ACTIONS(2068),
    [anon_sym___host__] = ACTIONS(2068),
    [anon_sym___global__] = ACTIONS(2068),
    [anon_sym___forceinline__] = ACTIONS(2068),
    [anon_sym___noinline__] = ACTIONS(2068),
    [anon_sym_extern] = ACTIONS(2068),
    [anon_sym___attribute__] = ACTIONS(2068),
    [anon_sym_COLON_COLON] = ACTIONS(2070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2070),
    [anon_sym___declspec] = ACTIONS(2068),
    [anon_sym___based] = ACTIONS(2068),
    [anon_sym___cdecl] = ACTIONS(2068),
    [anon_sym___clrcall] = ACTIONS(2068),
    [anon_sym___stdcall] = ACTIONS(2068),
    [anon_sym___fastcall] = ACTIONS(2068),
    [anon_sym___thiscall] = ACTIONS(2068),
    [anon_sym___vectorcall] = ACTIONS(2068),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_signed] = ACTIONS(2068),
    [anon_sym_unsigned] = ACTIONS(2068),
    [anon_sym_long] = ACTIONS(2068),
    [anon_sym_short] = ACTIONS(2068),
    [anon_sym_LBRACK] = ACTIONS(2068),
    [anon_sym_static] = ACTIONS(2068),
    [anon_sym_register] = ACTIONS(2068),
    [anon_sym_inline] = ACTIONS(2068),
    [anon_sym___inline] = ACTIONS(2068),
    [anon_sym___inline__] = ACTIONS(2068),
    [anon_sym___forceinline] = ACTIONS(2068),
    [anon_sym_thread_local] = ACTIONS(2068),
    [anon_sym___thread] = ACTIONS(2068),
    [anon_sym_const] = ACTIONS(2068),
    [anon_sym_constexpr] = ACTIONS(2068),
    [anon_sym_volatile] = ACTIONS(2068),
    [anon_sym_restrict] = ACTIONS(2068),
    [anon_sym___restrict__] = ACTIONS(2068),
    [anon_sym__Atomic] = ACTIONS(2068),
    [anon_sym__Noreturn] = ACTIONS(2068),
    [anon_sym_noreturn] = ACTIONS(2068),
    [anon_sym_mutable] = ACTIONS(2068),
    [anon_sym_constinit] = ACTIONS(2068),
    [anon_sym_consteval] = ACTIONS(2068),
    [anon_sym___shared__] = ACTIONS(2068),
    [anon_sym___local__] = ACTIONS(2068),
    [anon_sym___constant__] = ACTIONS(2068),
    [anon_sym___managed__] = ACTIONS(2068),
    [anon_sym___grid_constant__] = ACTIONS(2068),
    [anon_sym_alignas] = ACTIONS(2068),
    [anon_sym__Alignas] = ACTIONS(2068),
    [sym_primitive_type] = ACTIONS(2068),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2068),
    [anon_sym_struct] = ACTIONS(2068),
    [anon_sym_union] = ACTIONS(2068),
    [anon_sym_if] = ACTIONS(2068),
    [anon_sym_else] = ACTIONS(2068),
    [anon_sym_switch] = ACTIONS(2068),
    [anon_sym_case] = ACTIONS(2068),
    [anon_sym_default] = ACTIONS(2068),
    [anon_sym_while] = ACTIONS(2068),
    [anon_sym_do] = ACTIONS(2068),
    [anon_sym_for] = ACTIONS(2068),
    [anon_sym_return] = ACTIONS(2068),
    [anon_sym_break] = ACTIONS(2068),
    [anon_sym_continue] = ACTIONS(2068),
    [anon_sym_goto] = ACTIONS(2068),
    [anon_sym___try] = ACTIONS(2068),
    [anon_sym___leave] = ACTIONS(2068),
    [anon_sym_not] = ACTIONS(2068),
    [anon_sym_compl] = ACTIONS(2068),
    [anon_sym_DASH_DASH] = ACTIONS(2070),
    [anon_sym_PLUS_PLUS] = ACTIONS(2070),
    [anon_sym_sizeof] = ACTIONS(2068),
    [anon_sym___alignof__] = ACTIONS(2068),
    [anon_sym___alignof] = ACTIONS(2068),
    [anon_sym__alignof] = ACTIONS(2068),
    [anon_sym_alignof] = ACTIONS(2068),
    [anon_sym__Alignof] = ACTIONS(2068),
    [anon_sym_offsetof] = ACTIONS(2068),
    [anon_sym__Generic] = ACTIONS(2068),
    [anon_sym_asm] = ACTIONS(2068),
    [anon_sym___asm__] = ACTIONS(2068),
    [sym_number_literal] = ACTIONS(2070),
    [anon_sym_L_SQUOTE] = ACTIONS(2070),
    [anon_sym_u_SQUOTE] = ACTIONS(2070),
    [anon_sym_U_SQUOTE] = ACTIONS(2070),
    [anon_sym_u8_SQUOTE] = ACTIONS(2070),
    [anon_sym_SQUOTE] = ACTIONS(2070),
    [anon_sym_L_DQUOTE] = ACTIONS(2070),
    [anon_sym_u_DQUOTE] = ACTIONS(2070),
    [anon_sym_U_DQUOTE] = ACTIONS(2070),
    [anon_sym_u8_DQUOTE] = ACTIONS(2070),
    [anon_sym_DQUOTE] = ACTIONS(2070),
    [sym_true] = ACTIONS(2068),
    [sym_false] = ACTIONS(2068),
    [anon_sym_NULL] = ACTIONS(2068),
    [anon_sym_nullptr] = ACTIONS(2068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2068),
    [anon_sym_decltype] = ACTIONS(2068),
    [sym_virtual] = ACTIONS(2068),
    [anon_sym_explicit] = ACTIONS(2068),
    [anon_sym_typename] = ACTIONS(2068),
    [anon_sym_template] = ACTIONS(2068),
    [anon_sym_operator] = ACTIONS(2068),
    [anon_sym_try] = ACTIONS(2068),
    [anon_sym_delete] = ACTIONS(2068),
    [anon_sym_throw] = ACTIONS(2068),
    [anon_sym_namespace] = ACTIONS(2068),
    [anon_sym_using] = ACTIONS(2068),
    [anon_sym_static_assert] = ACTIONS(2068),
    [anon_sym_concept] = ACTIONS(2068),
    [anon_sym_co_return] = ACTIONS(2068),
    [anon_sym_co_yield] = ACTIONS(2068),
    [anon_sym_R_DQUOTE] = ACTIONS(2070),
    [anon_sym_LR_DQUOTE] = ACTIONS(2070),
    [anon_sym_uR_DQUOTE] = ACTIONS(2070),
    [anon_sym_UR_DQUOTE] = ACTIONS(2070),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2070),
    [anon_sym_co_await] = ACTIONS(2068),
    [anon_sym_new] = ACTIONS(2068),
    [anon_sym_requires] = ACTIONS(2068),
    [sym_this] = ACTIONS(2068),
    [anon_sym___launch_bounds__] = ACTIONS(2068),
  },
  [178] = {
    [sym_identifier] = ACTIONS(2072),
    [aux_sym_preproc_include_token1] = ACTIONS(2072),
    [aux_sym_preproc_def_token1] = ACTIONS(2072),
    [aux_sym_preproc_if_token1] = ACTIONS(2072),
    [aux_sym_preproc_if_token2] = ACTIONS(2072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2072),
    [aux_sym_preproc_else_token1] = ACTIONS(2072),
    [aux_sym_preproc_elif_token1] = ACTIONS(2072),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2072),
    [sym_preproc_directive] = ACTIONS(2072),
    [anon_sym_LPAREN2] = ACTIONS(2074),
    [anon_sym_BANG] = ACTIONS(2074),
    [anon_sym_TILDE] = ACTIONS(2074),
    [anon_sym_DASH] = ACTIONS(2072),
    [anon_sym_PLUS] = ACTIONS(2072),
    [anon_sym_STAR] = ACTIONS(2074),
    [anon_sym_AMP_AMP] = ACTIONS(2074),
    [anon_sym_AMP] = ACTIONS(2072),
    [anon_sym_SEMI] = ACTIONS(2074),
    [anon_sym___extension__] = ACTIONS(2072),
    [anon_sym_typedef] = ACTIONS(2072),
    [anon_sym___device__] = ACTIONS(2072),
    [anon_sym___host__] = ACTIONS(2072),
    [anon_sym___global__] = ACTIONS(2072),
    [anon_sym___forceinline__] = ACTIONS(2072),
    [anon_sym___noinline__] = ACTIONS(2072),
    [anon_sym_extern] = ACTIONS(2072),
    [anon_sym___attribute__] = ACTIONS(2072),
    [anon_sym_COLON_COLON] = ACTIONS(2074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2074),
    [anon_sym___declspec] = ACTIONS(2072),
    [anon_sym___based] = ACTIONS(2072),
    [anon_sym___cdecl] = ACTIONS(2072),
    [anon_sym___clrcall] = ACTIONS(2072),
    [anon_sym___stdcall] = ACTIONS(2072),
    [anon_sym___fastcall] = ACTIONS(2072),
    [anon_sym___thiscall] = ACTIONS(2072),
    [anon_sym___vectorcall] = ACTIONS(2072),
    [anon_sym_LBRACE] = ACTIONS(2074),
    [anon_sym_signed] = ACTIONS(2072),
    [anon_sym_unsigned] = ACTIONS(2072),
    [anon_sym_long] = ACTIONS(2072),
    [anon_sym_short] = ACTIONS(2072),
    [anon_sym_LBRACK] = ACTIONS(2072),
    [anon_sym_static] = ACTIONS(2072),
    [anon_sym_register] = ACTIONS(2072),
    [anon_sym_inline] = ACTIONS(2072),
    [anon_sym___inline] = ACTIONS(2072),
    [anon_sym___inline__] = ACTIONS(2072),
    [anon_sym___forceinline] = ACTIONS(2072),
    [anon_sym_thread_local] = ACTIONS(2072),
    [anon_sym___thread] = ACTIONS(2072),
    [anon_sym_const] = ACTIONS(2072),
    [anon_sym_constexpr] = ACTIONS(2072),
    [anon_sym_volatile] = ACTIONS(2072),
    [anon_sym_restrict] = ACTIONS(2072),
    [anon_sym___restrict__] = ACTIONS(2072),
    [anon_sym__Atomic] = ACTIONS(2072),
    [anon_sym__Noreturn] = ACTIONS(2072),
    [anon_sym_noreturn] = ACTIONS(2072),
    [anon_sym_mutable] = ACTIONS(2072),
    [anon_sym_constinit] = ACTIONS(2072),
    [anon_sym_consteval] = ACTIONS(2072),
    [anon_sym___shared__] = ACTIONS(2072),
    [anon_sym___local__] = ACTIONS(2072),
    [anon_sym___constant__] = ACTIONS(2072),
    [anon_sym___managed__] = ACTIONS(2072),
    [anon_sym___grid_constant__] = ACTIONS(2072),
    [anon_sym_alignas] = ACTIONS(2072),
    [anon_sym__Alignas] = ACTIONS(2072),
    [sym_primitive_type] = ACTIONS(2072),
    [anon_sym_enum] = ACTIONS(2072),
    [anon_sym_class] = ACTIONS(2072),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2072),
    [anon_sym_if] = ACTIONS(2072),
    [anon_sym_else] = ACTIONS(2072),
    [anon_sym_switch] = ACTIONS(2072),
    [anon_sym_case] = ACTIONS(2072),
    [anon_sym_default] = ACTIONS(2072),
    [anon_sym_while] = ACTIONS(2072),
    [anon_sym_do] = ACTIONS(2072),
    [anon_sym_for] = ACTIONS(2072),
    [anon_sym_return] = ACTIONS(2072),
    [anon_sym_break] = ACTIONS(2072),
    [anon_sym_continue] = ACTIONS(2072),
    [anon_sym_goto] = ACTIONS(2072),
    [anon_sym___try] = ACTIONS(2072),
    [anon_sym___leave] = ACTIONS(2072),
    [anon_sym_not] = ACTIONS(2072),
    [anon_sym_compl] = ACTIONS(2072),
    [anon_sym_DASH_DASH] = ACTIONS(2074),
    [anon_sym_PLUS_PLUS] = ACTIONS(2074),
    [anon_sym_sizeof] = ACTIONS(2072),
    [anon_sym___alignof__] = ACTIONS(2072),
    [anon_sym___alignof] = ACTIONS(2072),
    [anon_sym__alignof] = ACTIONS(2072),
    [anon_sym_alignof] = ACTIONS(2072),
    [anon_sym__Alignof] = ACTIONS(2072),
    [anon_sym_offsetof] = ACTIONS(2072),
    [anon_sym__Generic] = ACTIONS(2072),
    [anon_sym_asm] = ACTIONS(2072),
    [anon_sym___asm__] = ACTIONS(2072),
    [sym_number_literal] = ACTIONS(2074),
    [anon_sym_L_SQUOTE] = ACTIONS(2074),
    [anon_sym_u_SQUOTE] = ACTIONS(2074),
    [anon_sym_U_SQUOTE] = ACTIONS(2074),
    [anon_sym_u8_SQUOTE] = ACTIONS(2074),
    [anon_sym_SQUOTE] = ACTIONS(2074),
    [anon_sym_L_DQUOTE] = ACTIONS(2074),
    [anon_sym_u_DQUOTE] = ACTIONS(2074),
    [anon_sym_U_DQUOTE] = ACTIONS(2074),
    [anon_sym_u8_DQUOTE] = ACTIONS(2074),
    [anon_sym_DQUOTE] = ACTIONS(2074),
    [sym_true] = ACTIONS(2072),
    [sym_false] = ACTIONS(2072),
    [anon_sym_NULL] = ACTIONS(2072),
    [anon_sym_nullptr] = ACTIONS(2072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2072),
    [anon_sym_decltype] = ACTIONS(2072),
    [sym_virtual] = ACTIONS(2072),
    [anon_sym_explicit] = ACTIONS(2072),
    [anon_sym_typename] = ACTIONS(2072),
    [anon_sym_template] = ACTIONS(2072),
    [anon_sym_operator] = ACTIONS(2072),
    [anon_sym_try] = ACTIONS(2072),
    [anon_sym_delete] = ACTIONS(2072),
    [anon_sym_throw] = ACTIONS(2072),
    [anon_sym_namespace] = ACTIONS(2072),
    [anon_sym_using] = ACTIONS(2072),
    [anon_sym_static_assert] = ACTIONS(2072),
    [anon_sym_concept] = ACTIONS(2072),
    [anon_sym_co_return] = ACTIONS(2072),
    [anon_sym_co_yield] = ACTIONS(2072),
    [anon_sym_R_DQUOTE] = ACTIONS(2074),
    [anon_sym_LR_DQUOTE] = ACTIONS(2074),
    [anon_sym_uR_DQUOTE] = ACTIONS(2074),
    [anon_sym_UR_DQUOTE] = ACTIONS(2074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2074),
    [anon_sym_co_await] = ACTIONS(2072),
    [anon_sym_new] = ACTIONS(2072),
    [anon_sym_requires] = ACTIONS(2072),
    [sym_this] = ACTIONS(2072),
    [anon_sym___launch_bounds__] = ACTIONS(2072),
  },
  [179] = {
    [sym_identifier] = ACTIONS(2076),
    [aux_sym_preproc_include_token1] = ACTIONS(2076),
    [aux_sym_preproc_def_token1] = ACTIONS(2076),
    [aux_sym_preproc_if_token1] = ACTIONS(2076),
    [aux_sym_preproc_if_token2] = ACTIONS(2076),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2076),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2076),
    [aux_sym_preproc_else_token1] = ACTIONS(2076),
    [aux_sym_preproc_elif_token1] = ACTIONS(2076),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2076),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2076),
    [sym_preproc_directive] = ACTIONS(2076),
    [anon_sym_LPAREN2] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2078),
    [anon_sym_TILDE] = ACTIONS(2078),
    [anon_sym_DASH] = ACTIONS(2076),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_STAR] = ACTIONS(2078),
    [anon_sym_AMP_AMP] = ACTIONS(2078),
    [anon_sym_AMP] = ACTIONS(2076),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym___extension__] = ACTIONS(2076),
    [anon_sym_typedef] = ACTIONS(2076),
    [anon_sym___device__] = ACTIONS(2076),
    [anon_sym___host__] = ACTIONS(2076),
    [anon_sym___global__] = ACTIONS(2076),
    [anon_sym___forceinline__] = ACTIONS(2076),
    [anon_sym___noinline__] = ACTIONS(2076),
    [anon_sym_extern] = ACTIONS(2076),
    [anon_sym___attribute__] = ACTIONS(2076),
    [anon_sym_COLON_COLON] = ACTIONS(2078),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2078),
    [anon_sym___declspec] = ACTIONS(2076),
    [anon_sym___based] = ACTIONS(2076),
    [anon_sym___cdecl] = ACTIONS(2076),
    [anon_sym___clrcall] = ACTIONS(2076),
    [anon_sym___stdcall] = ACTIONS(2076),
    [anon_sym___fastcall] = ACTIONS(2076),
    [anon_sym___thiscall] = ACTIONS(2076),
    [anon_sym___vectorcall] = ACTIONS(2076),
    [anon_sym_LBRACE] = ACTIONS(2078),
    [anon_sym_signed] = ACTIONS(2076),
    [anon_sym_unsigned] = ACTIONS(2076),
    [anon_sym_long] = ACTIONS(2076),
    [anon_sym_short] = ACTIONS(2076),
    [anon_sym_LBRACK] = ACTIONS(2076),
    [anon_sym_static] = ACTIONS(2076),
    [anon_sym_register] = ACTIONS(2076),
    [anon_sym_inline] = ACTIONS(2076),
    [anon_sym___inline] = ACTIONS(2076),
    [anon_sym___inline__] = ACTIONS(2076),
    [anon_sym___forceinline] = ACTIONS(2076),
    [anon_sym_thread_local] = ACTIONS(2076),
    [anon_sym___thread] = ACTIONS(2076),
    [anon_sym_const] = ACTIONS(2076),
    [anon_sym_constexpr] = ACTIONS(2076),
    [anon_sym_volatile] = ACTIONS(2076),
    [anon_sym_restrict] = ACTIONS(2076),
    [anon_sym___restrict__] = ACTIONS(2076),
    [anon_sym__Atomic] = ACTIONS(2076),
    [anon_sym__Noreturn] = ACTIONS(2076),
    [anon_sym_noreturn] = ACTIONS(2076),
    [anon_sym_mutable] = ACTIONS(2076),
    [anon_sym_constinit] = ACTIONS(2076),
    [anon_sym_consteval] = ACTIONS(2076),
    [anon_sym___shared__] = ACTIONS(2076),
    [anon_sym___local__] = ACTIONS(2076),
    [anon_sym___constant__] = ACTIONS(2076),
    [anon_sym___managed__] = ACTIONS(2076),
    [anon_sym___grid_constant__] = ACTIONS(2076),
    [anon_sym_alignas] = ACTIONS(2076),
    [anon_sym__Alignas] = ACTIONS(2076),
    [sym_primitive_type] = ACTIONS(2076),
    [anon_sym_enum] = ACTIONS(2076),
    [anon_sym_class] = ACTIONS(2076),
    [anon_sym_struct] = ACTIONS(2076),
    [anon_sym_union] = ACTIONS(2076),
    [anon_sym_if] = ACTIONS(2076),
    [anon_sym_else] = ACTIONS(2076),
    [anon_sym_switch] = ACTIONS(2076),
    [anon_sym_case] = ACTIONS(2076),
    [anon_sym_default] = ACTIONS(2076),
    [anon_sym_while] = ACTIONS(2076),
    [anon_sym_do] = ACTIONS(2076),
    [anon_sym_for] = ACTIONS(2076),
    [anon_sym_return] = ACTIONS(2076),
    [anon_sym_break] = ACTIONS(2076),
    [anon_sym_continue] = ACTIONS(2076),
    [anon_sym_goto] = ACTIONS(2076),
    [anon_sym___try] = ACTIONS(2076),
    [anon_sym___leave] = ACTIONS(2076),
    [anon_sym_not] = ACTIONS(2076),
    [anon_sym_compl] = ACTIONS(2076),
    [anon_sym_DASH_DASH] = ACTIONS(2078),
    [anon_sym_PLUS_PLUS] = ACTIONS(2078),
    [anon_sym_sizeof] = ACTIONS(2076),
    [anon_sym___alignof__] = ACTIONS(2076),
    [anon_sym___alignof] = ACTIONS(2076),
    [anon_sym__alignof] = ACTIONS(2076),
    [anon_sym_alignof] = ACTIONS(2076),
    [anon_sym__Alignof] = ACTIONS(2076),
    [anon_sym_offsetof] = ACTIONS(2076),
    [anon_sym__Generic] = ACTIONS(2076),
    [anon_sym_asm] = ACTIONS(2076),
    [anon_sym___asm__] = ACTIONS(2076),
    [sym_number_literal] = ACTIONS(2078),
    [anon_sym_L_SQUOTE] = ACTIONS(2078),
    [anon_sym_u_SQUOTE] = ACTIONS(2078),
    [anon_sym_U_SQUOTE] = ACTIONS(2078),
    [anon_sym_u8_SQUOTE] = ACTIONS(2078),
    [anon_sym_SQUOTE] = ACTIONS(2078),
    [anon_sym_L_DQUOTE] = ACTIONS(2078),
    [anon_sym_u_DQUOTE] = ACTIONS(2078),
    [anon_sym_U_DQUOTE] = ACTIONS(2078),
    [anon_sym_u8_DQUOTE] = ACTIONS(2078),
    [anon_sym_DQUOTE] = ACTIONS(2078),
    [sym_true] = ACTIONS(2076),
    [sym_false] = ACTIONS(2076),
    [anon_sym_NULL] = ACTIONS(2076),
    [anon_sym_nullptr] = ACTIONS(2076),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2076),
    [anon_sym_decltype] = ACTIONS(2076),
    [sym_virtual] = ACTIONS(2076),
    [anon_sym_explicit] = ACTIONS(2076),
    [anon_sym_typename] = ACTIONS(2076),
    [anon_sym_template] = ACTIONS(2076),
    [anon_sym_operator] = ACTIONS(2076),
    [anon_sym_try] = ACTIONS(2076),
    [anon_sym_delete] = ACTIONS(2076),
    [anon_sym_throw] = ACTIONS(2076),
    [anon_sym_namespace] = ACTIONS(2076),
    [anon_sym_using] = ACTIONS(2076),
    [anon_sym_static_assert] = ACTIONS(2076),
    [anon_sym_concept] = ACTIONS(2076),
    [anon_sym_co_return] = ACTIONS(2076),
    [anon_sym_co_yield] = ACTIONS(2076),
    [anon_sym_R_DQUOTE] = ACTIONS(2078),
    [anon_sym_LR_DQUOTE] = ACTIONS(2078),
    [anon_sym_uR_DQUOTE] = ACTIONS(2078),
    [anon_sym_UR_DQUOTE] = ACTIONS(2078),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2078),
    [anon_sym_co_await] = ACTIONS(2076),
    [anon_sym_new] = ACTIONS(2076),
    [anon_sym_requires] = ACTIONS(2076),
    [sym_this] = ACTIONS(2076),
    [anon_sym___launch_bounds__] = ACTIONS(2076),
  },
  [180] = {
    [sym_identifier] = ACTIONS(2080),
    [aux_sym_preproc_include_token1] = ACTIONS(2080),
    [aux_sym_preproc_def_token1] = ACTIONS(2080),
    [aux_sym_preproc_if_token1] = ACTIONS(2080),
    [aux_sym_preproc_if_token2] = ACTIONS(2080),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2080),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2080),
    [aux_sym_preproc_else_token1] = ACTIONS(2080),
    [aux_sym_preproc_elif_token1] = ACTIONS(2080),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2080),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2080),
    [sym_preproc_directive] = ACTIONS(2080),
    [anon_sym_LPAREN2] = ACTIONS(2082),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_DASH] = ACTIONS(2080),
    [anon_sym_PLUS] = ACTIONS(2080),
    [anon_sym_STAR] = ACTIONS(2082),
    [anon_sym_AMP_AMP] = ACTIONS(2082),
    [anon_sym_AMP] = ACTIONS(2080),
    [anon_sym_SEMI] = ACTIONS(2082),
    [anon_sym___extension__] = ACTIONS(2080),
    [anon_sym_typedef] = ACTIONS(2080),
    [anon_sym___device__] = ACTIONS(2080),
    [anon_sym___host__] = ACTIONS(2080),
    [anon_sym___global__] = ACTIONS(2080),
    [anon_sym___forceinline__] = ACTIONS(2080),
    [anon_sym___noinline__] = ACTIONS(2080),
    [anon_sym_extern] = ACTIONS(2080),
    [anon_sym___attribute__] = ACTIONS(2080),
    [anon_sym_COLON_COLON] = ACTIONS(2082),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2082),
    [anon_sym___declspec] = ACTIONS(2080),
    [anon_sym___based] = ACTIONS(2080),
    [anon_sym___cdecl] = ACTIONS(2080),
    [anon_sym___clrcall] = ACTIONS(2080),
    [anon_sym___stdcall] = ACTIONS(2080),
    [anon_sym___fastcall] = ACTIONS(2080),
    [anon_sym___thiscall] = ACTIONS(2080),
    [anon_sym___vectorcall] = ACTIONS(2080),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_signed] = ACTIONS(2080),
    [anon_sym_unsigned] = ACTIONS(2080),
    [anon_sym_long] = ACTIONS(2080),
    [anon_sym_short] = ACTIONS(2080),
    [anon_sym_LBRACK] = ACTIONS(2080),
    [anon_sym_static] = ACTIONS(2080),
    [anon_sym_register] = ACTIONS(2080),
    [anon_sym_inline] = ACTIONS(2080),
    [anon_sym___inline] = ACTIONS(2080),
    [anon_sym___inline__] = ACTIONS(2080),
    [anon_sym___forceinline] = ACTIONS(2080),
    [anon_sym_thread_local] = ACTIONS(2080),
    [anon_sym___thread] = ACTIONS(2080),
    [anon_sym_const] = ACTIONS(2080),
    [anon_sym_constexpr] = ACTIONS(2080),
    [anon_sym_volatile] = ACTIONS(2080),
    [anon_sym_restrict] = ACTIONS(2080),
    [anon_sym___restrict__] = ACTIONS(2080),
    [anon_sym__Atomic] = ACTIONS(2080),
    [anon_sym__Noreturn] = ACTIONS(2080),
    [anon_sym_noreturn] = ACTIONS(2080),
    [anon_sym_mutable] = ACTIONS(2080),
    [anon_sym_constinit] = ACTIONS(2080),
    [anon_sym_consteval] = ACTIONS(2080),
    [anon_sym___shared__] = ACTIONS(2080),
    [anon_sym___local__] = ACTIONS(2080),
    [anon_sym___constant__] = ACTIONS(2080),
    [anon_sym___managed__] = ACTIONS(2080),
    [anon_sym___grid_constant__] = ACTIONS(2080),
    [anon_sym_alignas] = ACTIONS(2080),
    [anon_sym__Alignas] = ACTIONS(2080),
    [sym_primitive_type] = ACTIONS(2080),
    [anon_sym_enum] = ACTIONS(2080),
    [anon_sym_class] = ACTIONS(2080),
    [anon_sym_struct] = ACTIONS(2080),
    [anon_sym_union] = ACTIONS(2080),
    [anon_sym_if] = ACTIONS(2080),
    [anon_sym_switch] = ACTIONS(2080),
    [anon_sym_case] = ACTIONS(2080),
    [anon_sym_default] = ACTIONS(2080),
    [anon_sym_while] = ACTIONS(2080),
    [anon_sym_do] = ACTIONS(2080),
    [anon_sym_for] = ACTIONS(2080),
    [anon_sym_return] = ACTIONS(2080),
    [anon_sym_break] = ACTIONS(2080),
    [anon_sym_continue] = ACTIONS(2080),
    [anon_sym_goto] = ACTIONS(2080),
    [anon_sym___try] = ACTIONS(2080),
    [anon_sym___leave] = ACTIONS(2080),
    [anon_sym_not] = ACTIONS(2080),
    [anon_sym_compl] = ACTIONS(2080),
    [anon_sym_DASH_DASH] = ACTIONS(2082),
    [anon_sym_PLUS_PLUS] = ACTIONS(2082),
    [anon_sym_sizeof] = ACTIONS(2080),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2080),
    [anon_sym__Generic] = ACTIONS(2080),
    [anon_sym_asm] = ACTIONS(2080),
    [anon_sym___asm__] = ACTIONS(2080),
    [sym_number_literal] = ACTIONS(2082),
    [anon_sym_L_SQUOTE] = ACTIONS(2082),
    [anon_sym_u_SQUOTE] = ACTIONS(2082),
    [anon_sym_U_SQUOTE] = ACTIONS(2082),
    [anon_sym_u8_SQUOTE] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2082),
    [anon_sym_L_DQUOTE] = ACTIONS(2082),
    [anon_sym_u_DQUOTE] = ACTIONS(2082),
    [anon_sym_U_DQUOTE] = ACTIONS(2082),
    [anon_sym_u8_DQUOTE] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [sym_true] = ACTIONS(2080),
    [sym_false] = ACTIONS(2080),
    [anon_sym_NULL] = ACTIONS(2080),
    [anon_sym_nullptr] = ACTIONS(2080),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2080),
    [anon_sym_decltype] = ACTIONS(2080),
    [sym_virtual] = ACTIONS(2080),
    [anon_sym_explicit] = ACTIONS(2080),
    [anon_sym_typename] = ACTIONS(2080),
    [anon_sym_template] = ACTIONS(2080),
    [anon_sym_operator] = ACTIONS(2080),
    [anon_sym_try] = ACTIONS(2080),
    [anon_sym_delete] = ACTIONS(2080),
    [anon_sym_throw] = ACTIONS(2080),
    [anon_sym_namespace] = ACTIONS(2080),
    [anon_sym_using] = ACTIONS(2080),
    [anon_sym_static_assert] = ACTIONS(2080),
    [anon_sym_concept] = ACTIONS(2080),
    [anon_sym_co_return] = ACTIONS(2080),
    [anon_sym_co_yield] = ACTIONS(2080),
    [anon_sym_R_DQUOTE] = ACTIONS(2082),
    [anon_sym_LR_DQUOTE] = ACTIONS(2082),
    [anon_sym_uR_DQUOTE] = ACTIONS(2082),
    [anon_sym_UR_DQUOTE] = ACTIONS(2082),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2082),
    [anon_sym_co_await] = ACTIONS(2080),
    [anon_sym_new] = ACTIONS(2080),
    [anon_sym_requires] = ACTIONS(2080),
    [sym_this] = ACTIONS(2080),
    [anon_sym___launch_bounds__] = ACTIONS(2080),
  },
  [181] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(2960),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8499),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8774),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8299),
    [sym__unary_right_fold] = STATE(8308),
    [sym__binary_fold] = STATE(8312),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8481),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [182] = {
    [sym_identifier] = ACTIONS(2090),
    [aux_sym_preproc_include_token1] = ACTIONS(2090),
    [aux_sym_preproc_def_token1] = ACTIONS(2090),
    [aux_sym_preproc_if_token1] = ACTIONS(2090),
    [aux_sym_preproc_if_token2] = ACTIONS(2090),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2090),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2090),
    [aux_sym_preproc_else_token1] = ACTIONS(2090),
    [aux_sym_preproc_elif_token1] = ACTIONS(2090),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2090),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2090),
    [sym_preproc_directive] = ACTIONS(2090),
    [anon_sym_LPAREN2] = ACTIONS(2092),
    [anon_sym_BANG] = ACTIONS(2092),
    [anon_sym_TILDE] = ACTIONS(2092),
    [anon_sym_DASH] = ACTIONS(2090),
    [anon_sym_PLUS] = ACTIONS(2090),
    [anon_sym_STAR] = ACTIONS(2092),
    [anon_sym_AMP_AMP] = ACTIONS(2092),
    [anon_sym_AMP] = ACTIONS(2090),
    [anon_sym_SEMI] = ACTIONS(2092),
    [anon_sym___extension__] = ACTIONS(2090),
    [anon_sym_typedef] = ACTIONS(2090),
    [anon_sym___device__] = ACTIONS(2090),
    [anon_sym___host__] = ACTIONS(2090),
    [anon_sym___global__] = ACTIONS(2090),
    [anon_sym___forceinline__] = ACTIONS(2090),
    [anon_sym___noinline__] = ACTIONS(2090),
    [anon_sym_extern] = ACTIONS(2090),
    [anon_sym___attribute__] = ACTIONS(2090),
    [anon_sym_COLON_COLON] = ACTIONS(2092),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2092),
    [anon_sym___declspec] = ACTIONS(2090),
    [anon_sym___based] = ACTIONS(2090),
    [anon_sym___cdecl] = ACTIONS(2090),
    [anon_sym___clrcall] = ACTIONS(2090),
    [anon_sym___stdcall] = ACTIONS(2090),
    [anon_sym___fastcall] = ACTIONS(2090),
    [anon_sym___thiscall] = ACTIONS(2090),
    [anon_sym___vectorcall] = ACTIONS(2090),
    [anon_sym_LBRACE] = ACTIONS(2092),
    [anon_sym_signed] = ACTIONS(2090),
    [anon_sym_unsigned] = ACTIONS(2090),
    [anon_sym_long] = ACTIONS(2090),
    [anon_sym_short] = ACTIONS(2090),
    [anon_sym_LBRACK] = ACTIONS(2090),
    [anon_sym_static] = ACTIONS(2090),
    [anon_sym_register] = ACTIONS(2090),
    [anon_sym_inline] = ACTIONS(2090),
    [anon_sym___inline] = ACTIONS(2090),
    [anon_sym___inline__] = ACTIONS(2090),
    [anon_sym___forceinline] = ACTIONS(2090),
    [anon_sym_thread_local] = ACTIONS(2090),
    [anon_sym___thread] = ACTIONS(2090),
    [anon_sym_const] = ACTIONS(2090),
    [anon_sym_constexpr] = ACTIONS(2090),
    [anon_sym_volatile] = ACTIONS(2090),
    [anon_sym_restrict] = ACTIONS(2090),
    [anon_sym___restrict__] = ACTIONS(2090),
    [anon_sym__Atomic] = ACTIONS(2090),
    [anon_sym__Noreturn] = ACTIONS(2090),
    [anon_sym_noreturn] = ACTIONS(2090),
    [anon_sym_mutable] = ACTIONS(2090),
    [anon_sym_constinit] = ACTIONS(2090),
    [anon_sym_consteval] = ACTIONS(2090),
    [anon_sym___shared__] = ACTIONS(2090),
    [anon_sym___local__] = ACTIONS(2090),
    [anon_sym___constant__] = ACTIONS(2090),
    [anon_sym___managed__] = ACTIONS(2090),
    [anon_sym___grid_constant__] = ACTIONS(2090),
    [anon_sym_alignas] = ACTIONS(2090),
    [anon_sym__Alignas] = ACTIONS(2090),
    [sym_primitive_type] = ACTIONS(2090),
    [anon_sym_enum] = ACTIONS(2090),
    [anon_sym_class] = ACTIONS(2090),
    [anon_sym_struct] = ACTIONS(2090),
    [anon_sym_union] = ACTIONS(2090),
    [anon_sym_if] = ACTIONS(2090),
    [anon_sym_switch] = ACTIONS(2090),
    [anon_sym_case] = ACTIONS(2090),
    [anon_sym_default] = ACTIONS(2090),
    [anon_sym_while] = ACTIONS(2090),
    [anon_sym_do] = ACTIONS(2090),
    [anon_sym_for] = ACTIONS(2090),
    [anon_sym_return] = ACTIONS(2090),
    [anon_sym_break] = ACTIONS(2090),
    [anon_sym_continue] = ACTIONS(2090),
    [anon_sym_goto] = ACTIONS(2090),
    [anon_sym___try] = ACTIONS(2090),
    [anon_sym___leave] = ACTIONS(2090),
    [anon_sym_not] = ACTIONS(2090),
    [anon_sym_compl] = ACTIONS(2090),
    [anon_sym_DASH_DASH] = ACTIONS(2092),
    [anon_sym_PLUS_PLUS] = ACTIONS(2092),
    [anon_sym_sizeof] = ACTIONS(2090),
    [anon_sym___alignof__] = ACTIONS(2090),
    [anon_sym___alignof] = ACTIONS(2090),
    [anon_sym__alignof] = ACTIONS(2090),
    [anon_sym_alignof] = ACTIONS(2090),
    [anon_sym__Alignof] = ACTIONS(2090),
    [anon_sym_offsetof] = ACTIONS(2090),
    [anon_sym__Generic] = ACTIONS(2090),
    [anon_sym_asm] = ACTIONS(2090),
    [anon_sym___asm__] = ACTIONS(2090),
    [sym_number_literal] = ACTIONS(2092),
    [anon_sym_L_SQUOTE] = ACTIONS(2092),
    [anon_sym_u_SQUOTE] = ACTIONS(2092),
    [anon_sym_U_SQUOTE] = ACTIONS(2092),
    [anon_sym_u8_SQUOTE] = ACTIONS(2092),
    [anon_sym_SQUOTE] = ACTIONS(2092),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2090),
    [sym_false] = ACTIONS(2090),
    [anon_sym_NULL] = ACTIONS(2090),
    [anon_sym_nullptr] = ACTIONS(2090),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2090),
    [anon_sym_decltype] = ACTIONS(2090),
    [sym_virtual] = ACTIONS(2090),
    [anon_sym_explicit] = ACTIONS(2090),
    [anon_sym_typename] = ACTIONS(2090),
    [anon_sym_template] = ACTIONS(2090),
    [anon_sym_operator] = ACTIONS(2090),
    [anon_sym_try] = ACTIONS(2090),
    [anon_sym_delete] = ACTIONS(2090),
    [anon_sym_throw] = ACTIONS(2090),
    [anon_sym_namespace] = ACTIONS(2090),
    [anon_sym_using] = ACTIONS(2090),
    [anon_sym_static_assert] = ACTIONS(2090),
    [anon_sym_concept] = ACTIONS(2090),
    [anon_sym_co_return] = ACTIONS(2090),
    [anon_sym_co_yield] = ACTIONS(2090),
    [anon_sym_R_DQUOTE] = ACTIONS(2092),
    [anon_sym_LR_DQUOTE] = ACTIONS(2092),
    [anon_sym_uR_DQUOTE] = ACTIONS(2092),
    [anon_sym_UR_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2092),
    [anon_sym_co_await] = ACTIONS(2090),
    [anon_sym_new] = ACTIONS(2090),
    [anon_sym_requires] = ACTIONS(2090),
    [sym_this] = ACTIONS(2090),
    [anon_sym___launch_bounds__] = ACTIONS(2090),
  },
  [183] = {
    [sym_identifier] = ACTIONS(2094),
    [aux_sym_preproc_include_token1] = ACTIONS(2094),
    [aux_sym_preproc_def_token1] = ACTIONS(2094),
    [aux_sym_preproc_if_token1] = ACTIONS(2094),
    [aux_sym_preproc_if_token2] = ACTIONS(2094),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2094),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2094),
    [aux_sym_preproc_else_token1] = ACTIONS(2094),
    [aux_sym_preproc_elif_token1] = ACTIONS(2094),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2094),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2094),
    [sym_preproc_directive] = ACTIONS(2094),
    [anon_sym_LPAREN2] = ACTIONS(2096),
    [anon_sym_BANG] = ACTIONS(2096),
    [anon_sym_TILDE] = ACTIONS(2096),
    [anon_sym_DASH] = ACTIONS(2094),
    [anon_sym_PLUS] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(2096),
    [anon_sym_AMP_AMP] = ACTIONS(2096),
    [anon_sym_AMP] = ACTIONS(2094),
    [anon_sym_SEMI] = ACTIONS(2096),
    [anon_sym___extension__] = ACTIONS(2094),
    [anon_sym_typedef] = ACTIONS(2094),
    [anon_sym___device__] = ACTIONS(2094),
    [anon_sym___host__] = ACTIONS(2094),
    [anon_sym___global__] = ACTIONS(2094),
    [anon_sym___forceinline__] = ACTIONS(2094),
    [anon_sym___noinline__] = ACTIONS(2094),
    [anon_sym_extern] = ACTIONS(2094),
    [anon_sym___attribute__] = ACTIONS(2094),
    [anon_sym_COLON_COLON] = ACTIONS(2096),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2096),
    [anon_sym___declspec] = ACTIONS(2094),
    [anon_sym___based] = ACTIONS(2094),
    [anon_sym___cdecl] = ACTIONS(2094),
    [anon_sym___clrcall] = ACTIONS(2094),
    [anon_sym___stdcall] = ACTIONS(2094),
    [anon_sym___fastcall] = ACTIONS(2094),
    [anon_sym___thiscall] = ACTIONS(2094),
    [anon_sym___vectorcall] = ACTIONS(2094),
    [anon_sym_LBRACE] = ACTIONS(2096),
    [anon_sym_signed] = ACTIONS(2094),
    [anon_sym_unsigned] = ACTIONS(2094),
    [anon_sym_long] = ACTIONS(2094),
    [anon_sym_short] = ACTIONS(2094),
    [anon_sym_LBRACK] = ACTIONS(2094),
    [anon_sym_static] = ACTIONS(2094),
    [anon_sym_register] = ACTIONS(2094),
    [anon_sym_inline] = ACTIONS(2094),
    [anon_sym___inline] = ACTIONS(2094),
    [anon_sym___inline__] = ACTIONS(2094),
    [anon_sym___forceinline] = ACTIONS(2094),
    [anon_sym_thread_local] = ACTIONS(2094),
    [anon_sym___thread] = ACTIONS(2094),
    [anon_sym_const] = ACTIONS(2094),
    [anon_sym_constexpr] = ACTIONS(2094),
    [anon_sym_volatile] = ACTIONS(2094),
    [anon_sym_restrict] = ACTIONS(2094),
    [anon_sym___restrict__] = ACTIONS(2094),
    [anon_sym__Atomic] = ACTIONS(2094),
    [anon_sym__Noreturn] = ACTIONS(2094),
    [anon_sym_noreturn] = ACTIONS(2094),
    [anon_sym_mutable] = ACTIONS(2094),
    [anon_sym_constinit] = ACTIONS(2094),
    [anon_sym_consteval] = ACTIONS(2094),
    [anon_sym___shared__] = ACTIONS(2094),
    [anon_sym___local__] = ACTIONS(2094),
    [anon_sym___constant__] = ACTIONS(2094),
    [anon_sym___managed__] = ACTIONS(2094),
    [anon_sym___grid_constant__] = ACTIONS(2094),
    [anon_sym_alignas] = ACTIONS(2094),
    [anon_sym__Alignas] = ACTIONS(2094),
    [sym_primitive_type] = ACTIONS(2094),
    [anon_sym_enum] = ACTIONS(2094),
    [anon_sym_class] = ACTIONS(2094),
    [anon_sym_struct] = ACTIONS(2094),
    [anon_sym_union] = ACTIONS(2094),
    [anon_sym_if] = ACTIONS(2094),
    [anon_sym_switch] = ACTIONS(2094),
    [anon_sym_case] = ACTIONS(2094),
    [anon_sym_default] = ACTIONS(2094),
    [anon_sym_while] = ACTIONS(2094),
    [anon_sym_do] = ACTIONS(2094),
    [anon_sym_for] = ACTIONS(2094),
    [anon_sym_return] = ACTIONS(2094),
    [anon_sym_break] = ACTIONS(2094),
    [anon_sym_continue] = ACTIONS(2094),
    [anon_sym_goto] = ACTIONS(2094),
    [anon_sym___try] = ACTIONS(2094),
    [anon_sym___leave] = ACTIONS(2094),
    [anon_sym_not] = ACTIONS(2094),
    [anon_sym_compl] = ACTIONS(2094),
    [anon_sym_DASH_DASH] = ACTIONS(2096),
    [anon_sym_PLUS_PLUS] = ACTIONS(2096),
    [anon_sym_sizeof] = ACTIONS(2094),
    [anon_sym___alignof__] = ACTIONS(2094),
    [anon_sym___alignof] = ACTIONS(2094),
    [anon_sym__alignof] = ACTIONS(2094),
    [anon_sym_alignof] = ACTIONS(2094),
    [anon_sym__Alignof] = ACTIONS(2094),
    [anon_sym_offsetof] = ACTIONS(2094),
    [anon_sym__Generic] = ACTIONS(2094),
    [anon_sym_asm] = ACTIONS(2094),
    [anon_sym___asm__] = ACTIONS(2094),
    [sym_number_literal] = ACTIONS(2096),
    [anon_sym_L_SQUOTE] = ACTIONS(2096),
    [anon_sym_u_SQUOTE] = ACTIONS(2096),
    [anon_sym_U_SQUOTE] = ACTIONS(2096),
    [anon_sym_u8_SQUOTE] = ACTIONS(2096),
    [anon_sym_SQUOTE] = ACTIONS(2096),
    [anon_sym_L_DQUOTE] = ACTIONS(2096),
    [anon_sym_u_DQUOTE] = ACTIONS(2096),
    [anon_sym_U_DQUOTE] = ACTIONS(2096),
    [anon_sym_u8_DQUOTE] = ACTIONS(2096),
    [anon_sym_DQUOTE] = ACTIONS(2096),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2094),
    [anon_sym_nullptr] = ACTIONS(2094),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2094),
    [anon_sym_decltype] = ACTIONS(2094),
    [sym_virtual] = ACTIONS(2094),
    [anon_sym_explicit] = ACTIONS(2094),
    [anon_sym_typename] = ACTIONS(2094),
    [anon_sym_template] = ACTIONS(2094),
    [anon_sym_operator] = ACTIONS(2094),
    [anon_sym_try] = ACTIONS(2094),
    [anon_sym_delete] = ACTIONS(2094),
    [anon_sym_throw] = ACTIONS(2094),
    [anon_sym_namespace] = ACTIONS(2094),
    [anon_sym_using] = ACTIONS(2094),
    [anon_sym_static_assert] = ACTIONS(2094),
    [anon_sym_concept] = ACTIONS(2094),
    [anon_sym_co_return] = ACTIONS(2094),
    [anon_sym_co_yield] = ACTIONS(2094),
    [anon_sym_R_DQUOTE] = ACTIONS(2096),
    [anon_sym_LR_DQUOTE] = ACTIONS(2096),
    [anon_sym_uR_DQUOTE] = ACTIONS(2096),
    [anon_sym_UR_DQUOTE] = ACTIONS(2096),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2096),
    [anon_sym_co_await] = ACTIONS(2094),
    [anon_sym_new] = ACTIONS(2094),
    [anon_sym_requires] = ACTIONS(2094),
    [sym_this] = ACTIONS(2094),
    [anon_sym___launch_bounds__] = ACTIONS(2094),
  },
  [184] = {
    [sym_preproc_def] = STATE(370),
    [sym_preproc_function_def] = STATE(370),
    [sym_preproc_call] = STATE(370),
    [sym_preproc_if_in_field_declaration_list] = STATE(370),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(370),
    [sym_preproc_else_in_field_declaration_list] = STATE(8760),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8760),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8760),
    [sym_type_definition] = STATE(370),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5944),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6464),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(370),
    [sym_field_declaration] = STATE(370),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1701),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(370),
    [sym_operator_cast] = STATE(6994),
    [sym_inline_method_definition] = STATE(370),
    [sym__constructor_specifiers] = STATE(1701),
    [sym_operator_cast_definition] = STATE(370),
    [sym_operator_cast_declaration] = STATE(370),
    [sym_constructor_or_destructor_definition] = STATE(370),
    [sym_constructor_or_destructor_declaration] = STATE(370),
    [sym_friend_declaration] = STATE(370),
    [sym_access_specifier] = STATE(9001),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(370),
    [sym_alias_declaration] = STATE(370),
    [sym_static_assert_declaration] = STATE(370),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6994),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(370),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1701),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(2100),
    [aux_sym_preproc_if_token1] = ACTIONS(2102),
    [aux_sym_preproc_if_token2] = ACTIONS(2104),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2106),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2106),
    [aux_sym_preproc_else_token1] = ACTIONS(2108),
    [aux_sym_preproc_elif_token1] = ACTIONS(2110),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2112),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2112),
    [sym_preproc_directive] = ACTIONS(2114),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(2124),
    [anon_sym_typedef] = ACTIONS(2126),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(2144),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2146),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(2150),
    [anon_sym_static_assert] = ACTIONS(2152),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [185] = {
    [sym_identifier] = ACTIONS(2154),
    [aux_sym_preproc_include_token1] = ACTIONS(2154),
    [aux_sym_preproc_def_token1] = ACTIONS(2154),
    [aux_sym_preproc_if_token1] = ACTIONS(2154),
    [aux_sym_preproc_if_token2] = ACTIONS(2154),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2154),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2154),
    [aux_sym_preproc_else_token1] = ACTIONS(2154),
    [aux_sym_preproc_elif_token1] = ACTIONS(2154),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2154),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2154),
    [sym_preproc_directive] = ACTIONS(2154),
    [anon_sym_LPAREN2] = ACTIONS(2156),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [anon_sym_DASH] = ACTIONS(2154),
    [anon_sym_PLUS] = ACTIONS(2154),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_AMP_AMP] = ACTIONS(2156),
    [anon_sym_AMP] = ACTIONS(2154),
    [anon_sym_SEMI] = ACTIONS(2156),
    [anon_sym___extension__] = ACTIONS(2154),
    [anon_sym_typedef] = ACTIONS(2154),
    [anon_sym___device__] = ACTIONS(2154),
    [anon_sym___host__] = ACTIONS(2154),
    [anon_sym___global__] = ACTIONS(2154),
    [anon_sym___forceinline__] = ACTIONS(2154),
    [anon_sym___noinline__] = ACTIONS(2154),
    [anon_sym_extern] = ACTIONS(2154),
    [anon_sym___attribute__] = ACTIONS(2154),
    [anon_sym_COLON_COLON] = ACTIONS(2156),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2156),
    [anon_sym___declspec] = ACTIONS(2154),
    [anon_sym___based] = ACTIONS(2154),
    [anon_sym___cdecl] = ACTIONS(2154),
    [anon_sym___clrcall] = ACTIONS(2154),
    [anon_sym___stdcall] = ACTIONS(2154),
    [anon_sym___fastcall] = ACTIONS(2154),
    [anon_sym___thiscall] = ACTIONS(2154),
    [anon_sym___vectorcall] = ACTIONS(2154),
    [anon_sym_LBRACE] = ACTIONS(2156),
    [anon_sym_signed] = ACTIONS(2154),
    [anon_sym_unsigned] = ACTIONS(2154),
    [anon_sym_long] = ACTIONS(2154),
    [anon_sym_short] = ACTIONS(2154),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_static] = ACTIONS(2154),
    [anon_sym_register] = ACTIONS(2154),
    [anon_sym_inline] = ACTIONS(2154),
    [anon_sym___inline] = ACTIONS(2154),
    [anon_sym___inline__] = ACTIONS(2154),
    [anon_sym___forceinline] = ACTIONS(2154),
    [anon_sym_thread_local] = ACTIONS(2154),
    [anon_sym___thread] = ACTIONS(2154),
    [anon_sym_const] = ACTIONS(2154),
    [anon_sym_constexpr] = ACTIONS(2154),
    [anon_sym_volatile] = ACTIONS(2154),
    [anon_sym_restrict] = ACTIONS(2154),
    [anon_sym___restrict__] = ACTIONS(2154),
    [anon_sym__Atomic] = ACTIONS(2154),
    [anon_sym__Noreturn] = ACTIONS(2154),
    [anon_sym_noreturn] = ACTIONS(2154),
    [anon_sym_mutable] = ACTIONS(2154),
    [anon_sym_constinit] = ACTIONS(2154),
    [anon_sym_consteval] = ACTIONS(2154),
    [anon_sym___shared__] = ACTIONS(2154),
    [anon_sym___local__] = ACTIONS(2154),
    [anon_sym___constant__] = ACTIONS(2154),
    [anon_sym___managed__] = ACTIONS(2154),
    [anon_sym___grid_constant__] = ACTIONS(2154),
    [anon_sym_alignas] = ACTIONS(2154),
    [anon_sym__Alignas] = ACTIONS(2154),
    [sym_primitive_type] = ACTIONS(2154),
    [anon_sym_enum] = ACTIONS(2154),
    [anon_sym_class] = ACTIONS(2154),
    [anon_sym_struct] = ACTIONS(2154),
    [anon_sym_union] = ACTIONS(2154),
    [anon_sym_if] = ACTIONS(2154),
    [anon_sym_switch] = ACTIONS(2154),
    [anon_sym_case] = ACTIONS(2154),
    [anon_sym_default] = ACTIONS(2154),
    [anon_sym_while] = ACTIONS(2154),
    [anon_sym_do] = ACTIONS(2154),
    [anon_sym_for] = ACTIONS(2154),
    [anon_sym_return] = ACTIONS(2154),
    [anon_sym_break] = ACTIONS(2154),
    [anon_sym_continue] = ACTIONS(2154),
    [anon_sym_goto] = ACTIONS(2154),
    [anon_sym___try] = ACTIONS(2154),
    [anon_sym___leave] = ACTIONS(2154),
    [anon_sym_not] = ACTIONS(2154),
    [anon_sym_compl] = ACTIONS(2154),
    [anon_sym_DASH_DASH] = ACTIONS(2156),
    [anon_sym_PLUS_PLUS] = ACTIONS(2156),
    [anon_sym_sizeof] = ACTIONS(2154),
    [anon_sym___alignof__] = ACTIONS(2154),
    [anon_sym___alignof] = ACTIONS(2154),
    [anon_sym__alignof] = ACTIONS(2154),
    [anon_sym_alignof] = ACTIONS(2154),
    [anon_sym__Alignof] = ACTIONS(2154),
    [anon_sym_offsetof] = ACTIONS(2154),
    [anon_sym__Generic] = ACTIONS(2154),
    [anon_sym_asm] = ACTIONS(2154),
    [anon_sym___asm__] = ACTIONS(2154),
    [sym_number_literal] = ACTIONS(2156),
    [anon_sym_L_SQUOTE] = ACTIONS(2156),
    [anon_sym_u_SQUOTE] = ACTIONS(2156),
    [anon_sym_U_SQUOTE] = ACTIONS(2156),
    [anon_sym_u8_SQUOTE] = ACTIONS(2156),
    [anon_sym_SQUOTE] = ACTIONS(2156),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(2154),
    [sym_false] = ACTIONS(2154),
    [anon_sym_NULL] = ACTIONS(2154),
    [anon_sym_nullptr] = ACTIONS(2154),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2154),
    [anon_sym_decltype] = ACTIONS(2154),
    [sym_virtual] = ACTIONS(2154),
    [anon_sym_explicit] = ACTIONS(2154),
    [anon_sym_typename] = ACTIONS(2154),
    [anon_sym_template] = ACTIONS(2154),
    [anon_sym_operator] = ACTIONS(2154),
    [anon_sym_try] = ACTIONS(2154),
    [anon_sym_delete] = ACTIONS(2154),
    [anon_sym_throw] = ACTIONS(2154),
    [anon_sym_namespace] = ACTIONS(2154),
    [anon_sym_using] = ACTIONS(2154),
    [anon_sym_static_assert] = ACTIONS(2154),
    [anon_sym_concept] = ACTIONS(2154),
    [anon_sym_co_return] = ACTIONS(2154),
    [anon_sym_co_yield] = ACTIONS(2154),
    [anon_sym_R_DQUOTE] = ACTIONS(2156),
    [anon_sym_LR_DQUOTE] = ACTIONS(2156),
    [anon_sym_uR_DQUOTE] = ACTIONS(2156),
    [anon_sym_UR_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2156),
    [anon_sym_co_await] = ACTIONS(2154),
    [anon_sym_new] = ACTIONS(2154),
    [anon_sym_requires] = ACTIONS(2154),
    [sym_this] = ACTIONS(2154),
    [anon_sym___launch_bounds__] = ACTIONS(2154),
  },
  [186] = {
    [sym_identifier] = ACTIONS(2158),
    [aux_sym_preproc_include_token1] = ACTIONS(2158),
    [aux_sym_preproc_def_token1] = ACTIONS(2158),
    [aux_sym_preproc_if_token1] = ACTIONS(2158),
    [aux_sym_preproc_if_token2] = ACTIONS(2158),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2158),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2158),
    [aux_sym_preproc_else_token1] = ACTIONS(2158),
    [aux_sym_preproc_elif_token1] = ACTIONS(2158),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2158),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2158),
    [sym_preproc_directive] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_STAR] = ACTIONS(2160),
    [anon_sym_AMP_AMP] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym___extension__] = ACTIONS(2158),
    [anon_sym_typedef] = ACTIONS(2158),
    [anon_sym___device__] = ACTIONS(2158),
    [anon_sym___host__] = ACTIONS(2158),
    [anon_sym___global__] = ACTIONS(2158),
    [anon_sym___forceinline__] = ACTIONS(2158),
    [anon_sym___noinline__] = ACTIONS(2158),
    [anon_sym_extern] = ACTIONS(2158),
    [anon_sym___attribute__] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2160),
    [anon_sym___declspec] = ACTIONS(2158),
    [anon_sym___based] = ACTIONS(2158),
    [anon_sym___cdecl] = ACTIONS(2158),
    [anon_sym___clrcall] = ACTIONS(2158),
    [anon_sym___stdcall] = ACTIONS(2158),
    [anon_sym___fastcall] = ACTIONS(2158),
    [anon_sym___thiscall] = ACTIONS(2158),
    [anon_sym___vectorcall] = ACTIONS(2158),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_signed] = ACTIONS(2158),
    [anon_sym_unsigned] = ACTIONS(2158),
    [anon_sym_long] = ACTIONS(2158),
    [anon_sym_short] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_static] = ACTIONS(2158),
    [anon_sym_register] = ACTIONS(2158),
    [anon_sym_inline] = ACTIONS(2158),
    [anon_sym___inline] = ACTIONS(2158),
    [anon_sym___inline__] = ACTIONS(2158),
    [anon_sym___forceinline] = ACTIONS(2158),
    [anon_sym_thread_local] = ACTIONS(2158),
    [anon_sym___thread] = ACTIONS(2158),
    [anon_sym_const] = ACTIONS(2158),
    [anon_sym_constexpr] = ACTIONS(2158),
    [anon_sym_volatile] = ACTIONS(2158),
    [anon_sym_restrict] = ACTIONS(2158),
    [anon_sym___restrict__] = ACTIONS(2158),
    [anon_sym__Atomic] = ACTIONS(2158),
    [anon_sym__Noreturn] = ACTIONS(2158),
    [anon_sym_noreturn] = ACTIONS(2158),
    [anon_sym_mutable] = ACTIONS(2158),
    [anon_sym_constinit] = ACTIONS(2158),
    [anon_sym_consteval] = ACTIONS(2158),
    [anon_sym___shared__] = ACTIONS(2158),
    [anon_sym___local__] = ACTIONS(2158),
    [anon_sym___constant__] = ACTIONS(2158),
    [anon_sym___managed__] = ACTIONS(2158),
    [anon_sym___grid_constant__] = ACTIONS(2158),
    [anon_sym_alignas] = ACTIONS(2158),
    [anon_sym__Alignas] = ACTIONS(2158),
    [sym_primitive_type] = ACTIONS(2158),
    [anon_sym_enum] = ACTIONS(2158),
    [anon_sym_class] = ACTIONS(2158),
    [anon_sym_struct] = ACTIONS(2158),
    [anon_sym_union] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_switch] = ACTIONS(2158),
    [anon_sym_case] = ACTIONS(2158),
    [anon_sym_default] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_break] = ACTIONS(2158),
    [anon_sym_continue] = ACTIONS(2158),
    [anon_sym_goto] = ACTIONS(2158),
    [anon_sym___try] = ACTIONS(2158),
    [anon_sym___leave] = ACTIONS(2158),
    [anon_sym_not] = ACTIONS(2158),
    [anon_sym_compl] = ACTIONS(2158),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_sizeof] = ACTIONS(2158),
    [anon_sym___alignof__] = ACTIONS(2158),
    [anon_sym___alignof] = ACTIONS(2158),
    [anon_sym__alignof] = ACTIONS(2158),
    [anon_sym_alignof] = ACTIONS(2158),
    [anon_sym__Alignof] = ACTIONS(2158),
    [anon_sym_offsetof] = ACTIONS(2158),
    [anon_sym__Generic] = ACTIONS(2158),
    [anon_sym_asm] = ACTIONS(2158),
    [anon_sym___asm__] = ACTIONS(2158),
    [sym_number_literal] = ACTIONS(2160),
    [anon_sym_L_SQUOTE] = ACTIONS(2160),
    [anon_sym_u_SQUOTE] = ACTIONS(2160),
    [anon_sym_U_SQUOTE] = ACTIONS(2160),
    [anon_sym_u8_SQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_L_DQUOTE] = ACTIONS(2160),
    [anon_sym_u_DQUOTE] = ACTIONS(2160),
    [anon_sym_U_DQUOTE] = ACTIONS(2160),
    [anon_sym_u8_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [sym_true] = ACTIONS(2158),
    [sym_false] = ACTIONS(2158),
    [anon_sym_NULL] = ACTIONS(2158),
    [anon_sym_nullptr] = ACTIONS(2158),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2158),
    [anon_sym_decltype] = ACTIONS(2158),
    [sym_virtual] = ACTIONS(2158),
    [anon_sym_explicit] = ACTIONS(2158),
    [anon_sym_typename] = ACTIONS(2158),
    [anon_sym_template] = ACTIONS(2158),
    [anon_sym_operator] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_delete] = ACTIONS(2158),
    [anon_sym_throw] = ACTIONS(2158),
    [anon_sym_namespace] = ACTIONS(2158),
    [anon_sym_using] = ACTIONS(2158),
    [anon_sym_static_assert] = ACTIONS(2158),
    [anon_sym_concept] = ACTIONS(2158),
    [anon_sym_co_return] = ACTIONS(2158),
    [anon_sym_co_yield] = ACTIONS(2158),
    [anon_sym_R_DQUOTE] = ACTIONS(2160),
    [anon_sym_LR_DQUOTE] = ACTIONS(2160),
    [anon_sym_uR_DQUOTE] = ACTIONS(2160),
    [anon_sym_UR_DQUOTE] = ACTIONS(2160),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2160),
    [anon_sym_co_await] = ACTIONS(2158),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_requires] = ACTIONS(2158),
    [sym_this] = ACTIONS(2158),
    [anon_sym___launch_bounds__] = ACTIONS(2158),
  },
  [187] = {
    [sym_identifier] = ACTIONS(2162),
    [aux_sym_preproc_include_token1] = ACTIONS(2162),
    [aux_sym_preproc_def_token1] = ACTIONS(2162),
    [aux_sym_preproc_if_token1] = ACTIONS(2162),
    [aux_sym_preproc_if_token2] = ACTIONS(2162),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2162),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2162),
    [aux_sym_preproc_else_token1] = ACTIONS(2162),
    [aux_sym_preproc_elif_token1] = ACTIONS(2162),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2162),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2162),
    [sym_preproc_directive] = ACTIONS(2162),
    [anon_sym_LPAREN2] = ACTIONS(2164),
    [anon_sym_BANG] = ACTIONS(2164),
    [anon_sym_TILDE] = ACTIONS(2164),
    [anon_sym_DASH] = ACTIONS(2162),
    [anon_sym_PLUS] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(2164),
    [anon_sym_AMP_AMP] = ACTIONS(2164),
    [anon_sym_AMP] = ACTIONS(2162),
    [anon_sym_SEMI] = ACTIONS(2164),
    [anon_sym___extension__] = ACTIONS(2162),
    [anon_sym_typedef] = ACTIONS(2162),
    [anon_sym___device__] = ACTIONS(2162),
    [anon_sym___host__] = ACTIONS(2162),
    [anon_sym___global__] = ACTIONS(2162),
    [anon_sym___forceinline__] = ACTIONS(2162),
    [anon_sym___noinline__] = ACTIONS(2162),
    [anon_sym_extern] = ACTIONS(2162),
    [anon_sym___attribute__] = ACTIONS(2162),
    [anon_sym_COLON_COLON] = ACTIONS(2164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2164),
    [anon_sym___declspec] = ACTIONS(2162),
    [anon_sym___based] = ACTIONS(2162),
    [anon_sym___cdecl] = ACTIONS(2162),
    [anon_sym___clrcall] = ACTIONS(2162),
    [anon_sym___stdcall] = ACTIONS(2162),
    [anon_sym___fastcall] = ACTIONS(2162),
    [anon_sym___thiscall] = ACTIONS(2162),
    [anon_sym___vectorcall] = ACTIONS(2162),
    [anon_sym_LBRACE] = ACTIONS(2164),
    [anon_sym_signed] = ACTIONS(2162),
    [anon_sym_unsigned] = ACTIONS(2162),
    [anon_sym_long] = ACTIONS(2162),
    [anon_sym_short] = ACTIONS(2162),
    [anon_sym_LBRACK] = ACTIONS(2162),
    [anon_sym_static] = ACTIONS(2162),
    [anon_sym_register] = ACTIONS(2162),
    [anon_sym_inline] = ACTIONS(2162),
    [anon_sym___inline] = ACTIONS(2162),
    [anon_sym___inline__] = ACTIONS(2162),
    [anon_sym___forceinline] = ACTIONS(2162),
    [anon_sym_thread_local] = ACTIONS(2162),
    [anon_sym___thread] = ACTIONS(2162),
    [anon_sym_const] = ACTIONS(2162),
    [anon_sym_constexpr] = ACTIONS(2162),
    [anon_sym_volatile] = ACTIONS(2162),
    [anon_sym_restrict] = ACTIONS(2162),
    [anon_sym___restrict__] = ACTIONS(2162),
    [anon_sym__Atomic] = ACTIONS(2162),
    [anon_sym__Noreturn] = ACTIONS(2162),
    [anon_sym_noreturn] = ACTIONS(2162),
    [anon_sym_mutable] = ACTIONS(2162),
    [anon_sym_constinit] = ACTIONS(2162),
    [anon_sym_consteval] = ACTIONS(2162),
    [anon_sym___shared__] = ACTIONS(2162),
    [anon_sym___local__] = ACTIONS(2162),
    [anon_sym___constant__] = ACTIONS(2162),
    [anon_sym___managed__] = ACTIONS(2162),
    [anon_sym___grid_constant__] = ACTIONS(2162),
    [anon_sym_alignas] = ACTIONS(2162),
    [anon_sym__Alignas] = ACTIONS(2162),
    [sym_primitive_type] = ACTIONS(2162),
    [anon_sym_enum] = ACTIONS(2162),
    [anon_sym_class] = ACTIONS(2162),
    [anon_sym_struct] = ACTIONS(2162),
    [anon_sym_union] = ACTIONS(2162),
    [anon_sym_if] = ACTIONS(2162),
    [anon_sym_switch] = ACTIONS(2162),
    [anon_sym_case] = ACTIONS(2162),
    [anon_sym_default] = ACTIONS(2162),
    [anon_sym_while] = ACTIONS(2162),
    [anon_sym_do] = ACTIONS(2162),
    [anon_sym_for] = ACTIONS(2162),
    [anon_sym_return] = ACTIONS(2162),
    [anon_sym_break] = ACTIONS(2162),
    [anon_sym_continue] = ACTIONS(2162),
    [anon_sym_goto] = ACTIONS(2162),
    [anon_sym___try] = ACTIONS(2162),
    [anon_sym___leave] = ACTIONS(2162),
    [anon_sym_not] = ACTIONS(2162),
    [anon_sym_compl] = ACTIONS(2162),
    [anon_sym_DASH_DASH] = ACTIONS(2164),
    [anon_sym_PLUS_PLUS] = ACTIONS(2164),
    [anon_sym_sizeof] = ACTIONS(2162),
    [anon_sym___alignof__] = ACTIONS(2162),
    [anon_sym___alignof] = ACTIONS(2162),
    [anon_sym__alignof] = ACTIONS(2162),
    [anon_sym_alignof] = ACTIONS(2162),
    [anon_sym__Alignof] = ACTIONS(2162),
    [anon_sym_offsetof] = ACTIONS(2162),
    [anon_sym__Generic] = ACTIONS(2162),
    [anon_sym_asm] = ACTIONS(2162),
    [anon_sym___asm__] = ACTIONS(2162),
    [sym_number_literal] = ACTIONS(2164),
    [anon_sym_L_SQUOTE] = ACTIONS(2164),
    [anon_sym_u_SQUOTE] = ACTIONS(2164),
    [anon_sym_U_SQUOTE] = ACTIONS(2164),
    [anon_sym_u8_SQUOTE] = ACTIONS(2164),
    [anon_sym_SQUOTE] = ACTIONS(2164),
    [anon_sym_L_DQUOTE] = ACTIONS(2164),
    [anon_sym_u_DQUOTE] = ACTIONS(2164),
    [anon_sym_U_DQUOTE] = ACTIONS(2164),
    [anon_sym_u8_DQUOTE] = ACTIONS(2164),
    [anon_sym_DQUOTE] = ACTIONS(2164),
    [sym_true] = ACTIONS(2162),
    [sym_false] = ACTIONS(2162),
    [anon_sym_NULL] = ACTIONS(2162),
    [anon_sym_nullptr] = ACTIONS(2162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2162),
    [anon_sym_decltype] = ACTIONS(2162),
    [sym_virtual] = ACTIONS(2162),
    [anon_sym_explicit] = ACTIONS(2162),
    [anon_sym_typename] = ACTIONS(2162),
    [anon_sym_template] = ACTIONS(2162),
    [anon_sym_operator] = ACTIONS(2162),
    [anon_sym_try] = ACTIONS(2162),
    [anon_sym_delete] = ACTIONS(2162),
    [anon_sym_throw] = ACTIONS(2162),
    [anon_sym_namespace] = ACTIONS(2162),
    [anon_sym_using] = ACTIONS(2162),
    [anon_sym_static_assert] = ACTIONS(2162),
    [anon_sym_concept] = ACTIONS(2162),
    [anon_sym_co_return] = ACTIONS(2162),
    [anon_sym_co_yield] = ACTIONS(2162),
    [anon_sym_R_DQUOTE] = ACTIONS(2164),
    [anon_sym_LR_DQUOTE] = ACTIONS(2164),
    [anon_sym_uR_DQUOTE] = ACTIONS(2164),
    [anon_sym_UR_DQUOTE] = ACTIONS(2164),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2164),
    [anon_sym_co_await] = ACTIONS(2162),
    [anon_sym_new] = ACTIONS(2162),
    [anon_sym_requires] = ACTIONS(2162),
    [sym_this] = ACTIONS(2162),
    [anon_sym___launch_bounds__] = ACTIONS(2162),
  },
  [188] = {
    [sym_identifier] = ACTIONS(2166),
    [aux_sym_preproc_include_token1] = ACTIONS(2166),
    [aux_sym_preproc_def_token1] = ACTIONS(2166),
    [aux_sym_preproc_if_token1] = ACTIONS(2166),
    [aux_sym_preproc_if_token2] = ACTIONS(2166),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2166),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2166),
    [aux_sym_preproc_else_token1] = ACTIONS(2166),
    [aux_sym_preproc_elif_token1] = ACTIONS(2166),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2166),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2166),
    [sym_preproc_directive] = ACTIONS(2166),
    [anon_sym_LPAREN2] = ACTIONS(2169),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2169),
    [anon_sym_DASH] = ACTIONS(2166),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_AMP_AMP] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2166),
    [anon_sym_SEMI] = ACTIONS(2169),
    [anon_sym___extension__] = ACTIONS(2166),
    [anon_sym_typedef] = ACTIONS(2166),
    [anon_sym___device__] = ACTIONS(2166),
    [anon_sym___host__] = ACTIONS(2166),
    [anon_sym___global__] = ACTIONS(2166),
    [anon_sym___forceinline__] = ACTIONS(2166),
    [anon_sym___noinline__] = ACTIONS(2166),
    [anon_sym_extern] = ACTIONS(2166),
    [anon_sym___attribute__] = ACTIONS(2166),
    [anon_sym_COLON_COLON] = ACTIONS(2169),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2169),
    [anon_sym___declspec] = ACTIONS(2166),
    [anon_sym___based] = ACTIONS(2166),
    [anon_sym___cdecl] = ACTIONS(2166),
    [anon_sym___clrcall] = ACTIONS(2166),
    [anon_sym___stdcall] = ACTIONS(2166),
    [anon_sym___fastcall] = ACTIONS(2166),
    [anon_sym___thiscall] = ACTIONS(2166),
    [anon_sym___vectorcall] = ACTIONS(2166),
    [anon_sym_LBRACE] = ACTIONS(2169),
    [anon_sym_signed] = ACTIONS(2166),
    [anon_sym_unsigned] = ACTIONS(2166),
    [anon_sym_long] = ACTIONS(2166),
    [anon_sym_short] = ACTIONS(2166),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [anon_sym_static] = ACTIONS(2166),
    [anon_sym_register] = ACTIONS(2166),
    [anon_sym_inline] = ACTIONS(2166),
    [anon_sym___inline] = ACTIONS(2166),
    [anon_sym___inline__] = ACTIONS(2166),
    [anon_sym___forceinline] = ACTIONS(2166),
    [anon_sym_thread_local] = ACTIONS(2166),
    [anon_sym___thread] = ACTIONS(2166),
    [anon_sym_const] = ACTIONS(2166),
    [anon_sym_constexpr] = ACTIONS(2166),
    [anon_sym_volatile] = ACTIONS(2166),
    [anon_sym_restrict] = ACTIONS(2166),
    [anon_sym___restrict__] = ACTIONS(2166),
    [anon_sym__Atomic] = ACTIONS(2166),
    [anon_sym__Noreturn] = ACTIONS(2166),
    [anon_sym_noreturn] = ACTIONS(2166),
    [anon_sym_mutable] = ACTIONS(2166),
    [anon_sym_constinit] = ACTIONS(2166),
    [anon_sym_consteval] = ACTIONS(2166),
    [anon_sym___shared__] = ACTIONS(2166),
    [anon_sym___local__] = ACTIONS(2166),
    [anon_sym___constant__] = ACTIONS(2166),
    [anon_sym___managed__] = ACTIONS(2166),
    [anon_sym___grid_constant__] = ACTIONS(2166),
    [anon_sym_alignas] = ACTIONS(2166),
    [anon_sym__Alignas] = ACTIONS(2166),
    [sym_primitive_type] = ACTIONS(2166),
    [anon_sym_enum] = ACTIONS(2166),
    [anon_sym_class] = ACTIONS(2166),
    [anon_sym_struct] = ACTIONS(2166),
    [anon_sym_union] = ACTIONS(2166),
    [anon_sym_if] = ACTIONS(2166),
    [anon_sym_switch] = ACTIONS(2166),
    [anon_sym_case] = ACTIONS(2166),
    [anon_sym_default] = ACTIONS(2166),
    [anon_sym_while] = ACTIONS(2166),
    [anon_sym_do] = ACTIONS(2166),
    [anon_sym_for] = ACTIONS(2166),
    [anon_sym_return] = ACTIONS(2166),
    [anon_sym_break] = ACTIONS(2166),
    [anon_sym_continue] = ACTIONS(2166),
    [anon_sym_goto] = ACTIONS(2166),
    [anon_sym___try] = ACTIONS(2166),
    [anon_sym___leave] = ACTIONS(2166),
    [anon_sym_not] = ACTIONS(2166),
    [anon_sym_compl] = ACTIONS(2166),
    [anon_sym_DASH_DASH] = ACTIONS(2169),
    [anon_sym_PLUS_PLUS] = ACTIONS(2169),
    [anon_sym_sizeof] = ACTIONS(2166),
    [anon_sym___alignof__] = ACTIONS(2166),
    [anon_sym___alignof] = ACTIONS(2166),
    [anon_sym__alignof] = ACTIONS(2166),
    [anon_sym_alignof] = ACTIONS(2166),
    [anon_sym__Alignof] = ACTIONS(2166),
    [anon_sym_offsetof] = ACTIONS(2166),
    [anon_sym__Generic] = ACTIONS(2166),
    [anon_sym_asm] = ACTIONS(2166),
    [anon_sym___asm__] = ACTIONS(2166),
    [sym_number_literal] = ACTIONS(2169),
    [anon_sym_L_SQUOTE] = ACTIONS(2169),
    [anon_sym_u_SQUOTE] = ACTIONS(2169),
    [anon_sym_U_SQUOTE] = ACTIONS(2169),
    [anon_sym_u8_SQUOTE] = ACTIONS(2169),
    [anon_sym_SQUOTE] = ACTIONS(2169),
    [anon_sym_L_DQUOTE] = ACTIONS(2169),
    [anon_sym_u_DQUOTE] = ACTIONS(2169),
    [anon_sym_U_DQUOTE] = ACTIONS(2169),
    [anon_sym_u8_DQUOTE] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2169),
    [sym_true] = ACTIONS(2166),
    [sym_false] = ACTIONS(2166),
    [anon_sym_NULL] = ACTIONS(2166),
    [anon_sym_nullptr] = ACTIONS(2166),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2166),
    [anon_sym_decltype] = ACTIONS(2166),
    [sym_virtual] = ACTIONS(2166),
    [anon_sym_explicit] = ACTIONS(2166),
    [anon_sym_typename] = ACTIONS(2166),
    [anon_sym_template] = ACTIONS(2166),
    [anon_sym_operator] = ACTIONS(2166),
    [anon_sym_try] = ACTIONS(2166),
    [anon_sym_delete] = ACTIONS(2166),
    [anon_sym_throw] = ACTIONS(2166),
    [anon_sym_namespace] = ACTIONS(2166),
    [anon_sym_using] = ACTIONS(2166),
    [anon_sym_static_assert] = ACTIONS(2166),
    [anon_sym_concept] = ACTIONS(2166),
    [anon_sym_co_return] = ACTIONS(2166),
    [anon_sym_co_yield] = ACTIONS(2166),
    [anon_sym_R_DQUOTE] = ACTIONS(2169),
    [anon_sym_LR_DQUOTE] = ACTIONS(2169),
    [anon_sym_uR_DQUOTE] = ACTIONS(2169),
    [anon_sym_UR_DQUOTE] = ACTIONS(2169),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2169),
    [anon_sym_co_await] = ACTIONS(2166),
    [anon_sym_new] = ACTIONS(2166),
    [anon_sym_requires] = ACTIONS(2166),
    [sym_this] = ACTIONS(2166),
    [anon_sym___launch_bounds__] = ACTIONS(2166),
  },
  [189] = {
    [sym_identifier] = ACTIONS(2172),
    [aux_sym_preproc_include_token1] = ACTIONS(2172),
    [aux_sym_preproc_def_token1] = ACTIONS(2172),
    [aux_sym_preproc_if_token1] = ACTIONS(2172),
    [aux_sym_preproc_if_token2] = ACTIONS(2172),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2172),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2172),
    [aux_sym_preproc_else_token1] = ACTIONS(2172),
    [aux_sym_preproc_elif_token1] = ACTIONS(2172),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2172),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2172),
    [sym_preproc_directive] = ACTIONS(2172),
    [anon_sym_LPAREN2] = ACTIONS(2174),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2174),
    [anon_sym_DASH] = ACTIONS(2172),
    [anon_sym_PLUS] = ACTIONS(2172),
    [anon_sym_STAR] = ACTIONS(2174),
    [anon_sym_AMP_AMP] = ACTIONS(2174),
    [anon_sym_AMP] = ACTIONS(2172),
    [anon_sym_SEMI] = ACTIONS(2174),
    [anon_sym___extension__] = ACTIONS(2172),
    [anon_sym_typedef] = ACTIONS(2172),
    [anon_sym___device__] = ACTIONS(2172),
    [anon_sym___host__] = ACTIONS(2172),
    [anon_sym___global__] = ACTIONS(2172),
    [anon_sym___forceinline__] = ACTIONS(2172),
    [anon_sym___noinline__] = ACTIONS(2172),
    [anon_sym_extern] = ACTIONS(2172),
    [anon_sym___attribute__] = ACTIONS(2172),
    [anon_sym_COLON_COLON] = ACTIONS(2174),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2174),
    [anon_sym___declspec] = ACTIONS(2172),
    [anon_sym___based] = ACTIONS(2172),
    [anon_sym___cdecl] = ACTIONS(2172),
    [anon_sym___clrcall] = ACTIONS(2172),
    [anon_sym___stdcall] = ACTIONS(2172),
    [anon_sym___fastcall] = ACTIONS(2172),
    [anon_sym___thiscall] = ACTIONS(2172),
    [anon_sym___vectorcall] = ACTIONS(2172),
    [anon_sym_LBRACE] = ACTIONS(2174),
    [anon_sym_signed] = ACTIONS(2172),
    [anon_sym_unsigned] = ACTIONS(2172),
    [anon_sym_long] = ACTIONS(2172),
    [anon_sym_short] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2172),
    [anon_sym_static] = ACTIONS(2172),
    [anon_sym_register] = ACTIONS(2172),
    [anon_sym_inline] = ACTIONS(2172),
    [anon_sym___inline] = ACTIONS(2172),
    [anon_sym___inline__] = ACTIONS(2172),
    [anon_sym___forceinline] = ACTIONS(2172),
    [anon_sym_thread_local] = ACTIONS(2172),
    [anon_sym___thread] = ACTIONS(2172),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_constexpr] = ACTIONS(2172),
    [anon_sym_volatile] = ACTIONS(2172),
    [anon_sym_restrict] = ACTIONS(2172),
    [anon_sym___restrict__] = ACTIONS(2172),
    [anon_sym__Atomic] = ACTIONS(2172),
    [anon_sym__Noreturn] = ACTIONS(2172),
    [anon_sym_noreturn] = ACTIONS(2172),
    [anon_sym_mutable] = ACTIONS(2172),
    [anon_sym_constinit] = ACTIONS(2172),
    [anon_sym_consteval] = ACTIONS(2172),
    [anon_sym___shared__] = ACTIONS(2172),
    [anon_sym___local__] = ACTIONS(2172),
    [anon_sym___constant__] = ACTIONS(2172),
    [anon_sym___managed__] = ACTIONS(2172),
    [anon_sym___grid_constant__] = ACTIONS(2172),
    [anon_sym_alignas] = ACTIONS(2172),
    [anon_sym__Alignas] = ACTIONS(2172),
    [sym_primitive_type] = ACTIONS(2172),
    [anon_sym_enum] = ACTIONS(2172),
    [anon_sym_class] = ACTIONS(2172),
    [anon_sym_struct] = ACTIONS(2172),
    [anon_sym_union] = ACTIONS(2172),
    [anon_sym_if] = ACTIONS(2172),
    [anon_sym_switch] = ACTIONS(2172),
    [anon_sym_case] = ACTIONS(2172),
    [anon_sym_default] = ACTIONS(2172),
    [anon_sym_while] = ACTIONS(2172),
    [anon_sym_do] = ACTIONS(2172),
    [anon_sym_for] = ACTIONS(2172),
    [anon_sym_return] = ACTIONS(2172),
    [anon_sym_break] = ACTIONS(2172),
    [anon_sym_continue] = ACTIONS(2172),
    [anon_sym_goto] = ACTIONS(2172),
    [anon_sym___try] = ACTIONS(2172),
    [anon_sym___leave] = ACTIONS(2172),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_compl] = ACTIONS(2172),
    [anon_sym_DASH_DASH] = ACTIONS(2174),
    [anon_sym_PLUS_PLUS] = ACTIONS(2174),
    [anon_sym_sizeof] = ACTIONS(2172),
    [anon_sym___alignof__] = ACTIONS(2172),
    [anon_sym___alignof] = ACTIONS(2172),
    [anon_sym__alignof] = ACTIONS(2172),
    [anon_sym_alignof] = ACTIONS(2172),
    [anon_sym__Alignof] = ACTIONS(2172),
    [anon_sym_offsetof] = ACTIONS(2172),
    [anon_sym__Generic] = ACTIONS(2172),
    [anon_sym_asm] = ACTIONS(2172),
    [anon_sym___asm__] = ACTIONS(2172),
    [sym_number_literal] = ACTIONS(2174),
    [anon_sym_L_SQUOTE] = ACTIONS(2174),
    [anon_sym_u_SQUOTE] = ACTIONS(2174),
    [anon_sym_U_SQUOTE] = ACTIONS(2174),
    [anon_sym_u8_SQUOTE] = ACTIONS(2174),
    [anon_sym_SQUOTE] = ACTIONS(2174),
    [anon_sym_L_DQUOTE] = ACTIONS(2174),
    [anon_sym_u_DQUOTE] = ACTIONS(2174),
    [anon_sym_U_DQUOTE] = ACTIONS(2174),
    [anon_sym_u8_DQUOTE] = ACTIONS(2174),
    [anon_sym_DQUOTE] = ACTIONS(2174),
    [sym_true] = ACTIONS(2172),
    [sym_false] = ACTIONS(2172),
    [anon_sym_NULL] = ACTIONS(2172),
    [anon_sym_nullptr] = ACTIONS(2172),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2172),
    [anon_sym_decltype] = ACTIONS(2172),
    [sym_virtual] = ACTIONS(2172),
    [anon_sym_explicit] = ACTIONS(2172),
    [anon_sym_typename] = ACTIONS(2172),
    [anon_sym_template] = ACTIONS(2172),
    [anon_sym_operator] = ACTIONS(2172),
    [anon_sym_try] = ACTIONS(2172),
    [anon_sym_delete] = ACTIONS(2172),
    [anon_sym_throw] = ACTIONS(2172),
    [anon_sym_namespace] = ACTIONS(2172),
    [anon_sym_using] = ACTIONS(2172),
    [anon_sym_static_assert] = ACTIONS(2172),
    [anon_sym_concept] = ACTIONS(2172),
    [anon_sym_co_return] = ACTIONS(2172),
    [anon_sym_co_yield] = ACTIONS(2172),
    [anon_sym_R_DQUOTE] = ACTIONS(2174),
    [anon_sym_LR_DQUOTE] = ACTIONS(2174),
    [anon_sym_uR_DQUOTE] = ACTIONS(2174),
    [anon_sym_UR_DQUOTE] = ACTIONS(2174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2174),
    [anon_sym_co_await] = ACTIONS(2172),
    [anon_sym_new] = ACTIONS(2172),
    [anon_sym_requires] = ACTIONS(2172),
    [sym_this] = ACTIONS(2172),
    [anon_sym___launch_bounds__] = ACTIONS(2172),
  },
  [190] = {
    [sym_identifier] = ACTIONS(2176),
    [aux_sym_preproc_include_token1] = ACTIONS(2176),
    [aux_sym_preproc_def_token1] = ACTIONS(2176),
    [aux_sym_preproc_if_token1] = ACTIONS(2176),
    [aux_sym_preproc_if_token2] = ACTIONS(2176),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2176),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2176),
    [aux_sym_preproc_else_token1] = ACTIONS(2176),
    [aux_sym_preproc_elif_token1] = ACTIONS(2176),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2176),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2176),
    [sym_preproc_directive] = ACTIONS(2176),
    [anon_sym_LPAREN2] = ACTIONS(2178),
    [anon_sym_BANG] = ACTIONS(2178),
    [anon_sym_TILDE] = ACTIONS(2178),
    [anon_sym_DASH] = ACTIONS(2176),
    [anon_sym_PLUS] = ACTIONS(2176),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_AMP_AMP] = ACTIONS(2178),
    [anon_sym_AMP] = ACTIONS(2176),
    [anon_sym_SEMI] = ACTIONS(2178),
    [anon_sym___extension__] = ACTIONS(2176),
    [anon_sym_typedef] = ACTIONS(2176),
    [anon_sym___device__] = ACTIONS(2176),
    [anon_sym___host__] = ACTIONS(2176),
    [anon_sym___global__] = ACTIONS(2176),
    [anon_sym___forceinline__] = ACTIONS(2176),
    [anon_sym___noinline__] = ACTIONS(2176),
    [anon_sym_extern] = ACTIONS(2176),
    [anon_sym___attribute__] = ACTIONS(2176),
    [anon_sym_COLON_COLON] = ACTIONS(2178),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2178),
    [anon_sym___declspec] = ACTIONS(2176),
    [anon_sym___based] = ACTIONS(2176),
    [anon_sym___cdecl] = ACTIONS(2176),
    [anon_sym___clrcall] = ACTIONS(2176),
    [anon_sym___stdcall] = ACTIONS(2176),
    [anon_sym___fastcall] = ACTIONS(2176),
    [anon_sym___thiscall] = ACTIONS(2176),
    [anon_sym___vectorcall] = ACTIONS(2176),
    [anon_sym_LBRACE] = ACTIONS(2178),
    [anon_sym_signed] = ACTIONS(2176),
    [anon_sym_unsigned] = ACTIONS(2176),
    [anon_sym_long] = ACTIONS(2176),
    [anon_sym_short] = ACTIONS(2176),
    [anon_sym_LBRACK] = ACTIONS(2176),
    [anon_sym_static] = ACTIONS(2176),
    [anon_sym_register] = ACTIONS(2176),
    [anon_sym_inline] = ACTIONS(2176),
    [anon_sym___inline] = ACTIONS(2176),
    [anon_sym___inline__] = ACTIONS(2176),
    [anon_sym___forceinline] = ACTIONS(2176),
    [anon_sym_thread_local] = ACTIONS(2176),
    [anon_sym___thread] = ACTIONS(2176),
    [anon_sym_const] = ACTIONS(2176),
    [anon_sym_constexpr] = ACTIONS(2176),
    [anon_sym_volatile] = ACTIONS(2176),
    [anon_sym_restrict] = ACTIONS(2176),
    [anon_sym___restrict__] = ACTIONS(2176),
    [anon_sym__Atomic] = ACTIONS(2176),
    [anon_sym__Noreturn] = ACTIONS(2176),
    [anon_sym_noreturn] = ACTIONS(2176),
    [anon_sym_mutable] = ACTIONS(2176),
    [anon_sym_constinit] = ACTIONS(2176),
    [anon_sym_consteval] = ACTIONS(2176),
    [anon_sym___shared__] = ACTIONS(2176),
    [anon_sym___local__] = ACTIONS(2176),
    [anon_sym___constant__] = ACTIONS(2176),
    [anon_sym___managed__] = ACTIONS(2176),
    [anon_sym___grid_constant__] = ACTIONS(2176),
    [anon_sym_alignas] = ACTIONS(2176),
    [anon_sym__Alignas] = ACTIONS(2176),
    [sym_primitive_type] = ACTIONS(2176),
    [anon_sym_enum] = ACTIONS(2176),
    [anon_sym_class] = ACTIONS(2176),
    [anon_sym_struct] = ACTIONS(2176),
    [anon_sym_union] = ACTIONS(2176),
    [anon_sym_if] = ACTIONS(2176),
    [anon_sym_switch] = ACTIONS(2176),
    [anon_sym_case] = ACTIONS(2176),
    [anon_sym_default] = ACTIONS(2176),
    [anon_sym_while] = ACTIONS(2176),
    [anon_sym_do] = ACTIONS(2176),
    [anon_sym_for] = ACTIONS(2176),
    [anon_sym_return] = ACTIONS(2176),
    [anon_sym_break] = ACTIONS(2176),
    [anon_sym_continue] = ACTIONS(2176),
    [anon_sym_goto] = ACTIONS(2176),
    [anon_sym___try] = ACTIONS(2176),
    [anon_sym___leave] = ACTIONS(2176),
    [anon_sym_not] = ACTIONS(2176),
    [anon_sym_compl] = ACTIONS(2176),
    [anon_sym_DASH_DASH] = ACTIONS(2178),
    [anon_sym_PLUS_PLUS] = ACTIONS(2178),
    [anon_sym_sizeof] = ACTIONS(2176),
    [anon_sym___alignof__] = ACTIONS(2176),
    [anon_sym___alignof] = ACTIONS(2176),
    [anon_sym__alignof] = ACTIONS(2176),
    [anon_sym_alignof] = ACTIONS(2176),
    [anon_sym__Alignof] = ACTIONS(2176),
    [anon_sym_offsetof] = ACTIONS(2176),
    [anon_sym__Generic] = ACTIONS(2176),
    [anon_sym_asm] = ACTIONS(2176),
    [anon_sym___asm__] = ACTIONS(2176),
    [sym_number_literal] = ACTIONS(2178),
    [anon_sym_L_SQUOTE] = ACTIONS(2178),
    [anon_sym_u_SQUOTE] = ACTIONS(2178),
    [anon_sym_U_SQUOTE] = ACTIONS(2178),
    [anon_sym_u8_SQUOTE] = ACTIONS(2178),
    [anon_sym_SQUOTE] = ACTIONS(2178),
    [anon_sym_L_DQUOTE] = ACTIONS(2178),
    [anon_sym_u_DQUOTE] = ACTIONS(2178),
    [anon_sym_U_DQUOTE] = ACTIONS(2178),
    [anon_sym_u8_DQUOTE] = ACTIONS(2178),
    [anon_sym_DQUOTE] = ACTIONS(2178),
    [sym_true] = ACTIONS(2176),
    [sym_false] = ACTIONS(2176),
    [anon_sym_NULL] = ACTIONS(2176),
    [anon_sym_nullptr] = ACTIONS(2176),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2176),
    [anon_sym_decltype] = ACTIONS(2176),
    [sym_virtual] = ACTIONS(2176),
    [anon_sym_explicit] = ACTIONS(2176),
    [anon_sym_typename] = ACTIONS(2176),
    [anon_sym_template] = ACTIONS(2176),
    [anon_sym_operator] = ACTIONS(2176),
    [anon_sym_try] = ACTIONS(2176),
    [anon_sym_delete] = ACTIONS(2176),
    [anon_sym_throw] = ACTIONS(2176),
    [anon_sym_namespace] = ACTIONS(2176),
    [anon_sym_using] = ACTIONS(2176),
    [anon_sym_static_assert] = ACTIONS(2176),
    [anon_sym_concept] = ACTIONS(2176),
    [anon_sym_co_return] = ACTIONS(2176),
    [anon_sym_co_yield] = ACTIONS(2176),
    [anon_sym_R_DQUOTE] = ACTIONS(2178),
    [anon_sym_LR_DQUOTE] = ACTIONS(2178),
    [anon_sym_uR_DQUOTE] = ACTIONS(2178),
    [anon_sym_UR_DQUOTE] = ACTIONS(2178),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2178),
    [anon_sym_co_await] = ACTIONS(2176),
    [anon_sym_new] = ACTIONS(2176),
    [anon_sym_requires] = ACTIONS(2176),
    [sym_this] = ACTIONS(2176),
    [anon_sym___launch_bounds__] = ACTIONS(2176),
  },
  [191] = {
    [sym_identifier] = ACTIONS(2180),
    [aux_sym_preproc_include_token1] = ACTIONS(2180),
    [aux_sym_preproc_def_token1] = ACTIONS(2180),
    [aux_sym_preproc_if_token1] = ACTIONS(2180),
    [aux_sym_preproc_if_token2] = ACTIONS(2180),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2180),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2180),
    [aux_sym_preproc_else_token1] = ACTIONS(2180),
    [aux_sym_preproc_elif_token1] = ACTIONS(2180),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2180),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2180),
    [sym_preproc_directive] = ACTIONS(2180),
    [anon_sym_LPAREN2] = ACTIONS(2182),
    [anon_sym_BANG] = ACTIONS(2182),
    [anon_sym_TILDE] = ACTIONS(2182),
    [anon_sym_DASH] = ACTIONS(2180),
    [anon_sym_PLUS] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(2182),
    [anon_sym_AMP_AMP] = ACTIONS(2182),
    [anon_sym_AMP] = ACTIONS(2180),
    [anon_sym_SEMI] = ACTIONS(2182),
    [anon_sym___extension__] = ACTIONS(2180),
    [anon_sym_typedef] = ACTIONS(2180),
    [anon_sym___device__] = ACTIONS(2180),
    [anon_sym___host__] = ACTIONS(2180),
    [anon_sym___global__] = ACTIONS(2180),
    [anon_sym___forceinline__] = ACTIONS(2180),
    [anon_sym___noinline__] = ACTIONS(2180),
    [anon_sym_extern] = ACTIONS(2180),
    [anon_sym___attribute__] = ACTIONS(2180),
    [anon_sym_COLON_COLON] = ACTIONS(2182),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2182),
    [anon_sym___declspec] = ACTIONS(2180),
    [anon_sym___based] = ACTIONS(2180),
    [anon_sym___cdecl] = ACTIONS(2180),
    [anon_sym___clrcall] = ACTIONS(2180),
    [anon_sym___stdcall] = ACTIONS(2180),
    [anon_sym___fastcall] = ACTIONS(2180),
    [anon_sym___thiscall] = ACTIONS(2180),
    [anon_sym___vectorcall] = ACTIONS(2180),
    [anon_sym_LBRACE] = ACTIONS(2182),
    [anon_sym_signed] = ACTIONS(2180),
    [anon_sym_unsigned] = ACTIONS(2180),
    [anon_sym_long] = ACTIONS(2180),
    [anon_sym_short] = ACTIONS(2180),
    [anon_sym_LBRACK] = ACTIONS(2180),
    [anon_sym_static] = ACTIONS(2180),
    [anon_sym_register] = ACTIONS(2180),
    [anon_sym_inline] = ACTIONS(2180),
    [anon_sym___inline] = ACTIONS(2180),
    [anon_sym___inline__] = ACTIONS(2180),
    [anon_sym___forceinline] = ACTIONS(2180),
    [anon_sym_thread_local] = ACTIONS(2180),
    [anon_sym___thread] = ACTIONS(2180),
    [anon_sym_const] = ACTIONS(2180),
    [anon_sym_constexpr] = ACTIONS(2180),
    [anon_sym_volatile] = ACTIONS(2180),
    [anon_sym_restrict] = ACTIONS(2180),
    [anon_sym___restrict__] = ACTIONS(2180),
    [anon_sym__Atomic] = ACTIONS(2180),
    [anon_sym__Noreturn] = ACTIONS(2180),
    [anon_sym_noreturn] = ACTIONS(2180),
    [anon_sym_mutable] = ACTIONS(2180),
    [anon_sym_constinit] = ACTIONS(2180),
    [anon_sym_consteval] = ACTIONS(2180),
    [anon_sym___shared__] = ACTIONS(2180),
    [anon_sym___local__] = ACTIONS(2180),
    [anon_sym___constant__] = ACTIONS(2180),
    [anon_sym___managed__] = ACTIONS(2180),
    [anon_sym___grid_constant__] = ACTIONS(2180),
    [anon_sym_alignas] = ACTIONS(2180),
    [anon_sym__Alignas] = ACTIONS(2180),
    [sym_primitive_type] = ACTIONS(2180),
    [anon_sym_enum] = ACTIONS(2180),
    [anon_sym_class] = ACTIONS(2180),
    [anon_sym_struct] = ACTIONS(2180),
    [anon_sym_union] = ACTIONS(2180),
    [anon_sym_if] = ACTIONS(2180),
    [anon_sym_switch] = ACTIONS(2180),
    [anon_sym_case] = ACTIONS(2180),
    [anon_sym_default] = ACTIONS(2180),
    [anon_sym_while] = ACTIONS(2180),
    [anon_sym_do] = ACTIONS(2180),
    [anon_sym_for] = ACTIONS(2180),
    [anon_sym_return] = ACTIONS(2180),
    [anon_sym_break] = ACTIONS(2180),
    [anon_sym_continue] = ACTIONS(2180),
    [anon_sym_goto] = ACTIONS(2180),
    [anon_sym___try] = ACTIONS(2180),
    [anon_sym___leave] = ACTIONS(2180),
    [anon_sym_not] = ACTIONS(2180),
    [anon_sym_compl] = ACTIONS(2180),
    [anon_sym_DASH_DASH] = ACTIONS(2182),
    [anon_sym_PLUS_PLUS] = ACTIONS(2182),
    [anon_sym_sizeof] = ACTIONS(2180),
    [anon_sym___alignof__] = ACTIONS(2180),
    [anon_sym___alignof] = ACTIONS(2180),
    [anon_sym__alignof] = ACTIONS(2180),
    [anon_sym_alignof] = ACTIONS(2180),
    [anon_sym__Alignof] = ACTIONS(2180),
    [anon_sym_offsetof] = ACTIONS(2180),
    [anon_sym__Generic] = ACTIONS(2180),
    [anon_sym_asm] = ACTIONS(2180),
    [anon_sym___asm__] = ACTIONS(2180),
    [sym_number_literal] = ACTIONS(2182),
    [anon_sym_L_SQUOTE] = ACTIONS(2182),
    [anon_sym_u_SQUOTE] = ACTIONS(2182),
    [anon_sym_U_SQUOTE] = ACTIONS(2182),
    [anon_sym_u8_SQUOTE] = ACTIONS(2182),
    [anon_sym_SQUOTE] = ACTIONS(2182),
    [anon_sym_L_DQUOTE] = ACTIONS(2182),
    [anon_sym_u_DQUOTE] = ACTIONS(2182),
    [anon_sym_U_DQUOTE] = ACTIONS(2182),
    [anon_sym_u8_DQUOTE] = ACTIONS(2182),
    [anon_sym_DQUOTE] = ACTIONS(2182),
    [sym_true] = ACTIONS(2180),
    [sym_false] = ACTIONS(2180),
    [anon_sym_NULL] = ACTIONS(2180),
    [anon_sym_nullptr] = ACTIONS(2180),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2180),
    [anon_sym_decltype] = ACTIONS(2180),
    [sym_virtual] = ACTIONS(2180),
    [anon_sym_explicit] = ACTIONS(2180),
    [anon_sym_typename] = ACTIONS(2180),
    [anon_sym_template] = ACTIONS(2180),
    [anon_sym_operator] = ACTIONS(2180),
    [anon_sym_try] = ACTIONS(2180),
    [anon_sym_delete] = ACTIONS(2180),
    [anon_sym_throw] = ACTIONS(2180),
    [anon_sym_namespace] = ACTIONS(2180),
    [anon_sym_using] = ACTIONS(2180),
    [anon_sym_static_assert] = ACTIONS(2180),
    [anon_sym_concept] = ACTIONS(2180),
    [anon_sym_co_return] = ACTIONS(2180),
    [anon_sym_co_yield] = ACTIONS(2180),
    [anon_sym_R_DQUOTE] = ACTIONS(2182),
    [anon_sym_LR_DQUOTE] = ACTIONS(2182),
    [anon_sym_uR_DQUOTE] = ACTIONS(2182),
    [anon_sym_UR_DQUOTE] = ACTIONS(2182),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2182),
    [anon_sym_co_await] = ACTIONS(2180),
    [anon_sym_new] = ACTIONS(2180),
    [anon_sym_requires] = ACTIONS(2180),
    [sym_this] = ACTIONS(2180),
    [anon_sym___launch_bounds__] = ACTIONS(2180),
  },
  [192] = {
    [sym_catch_clause] = STATE(192),
    [aux_sym_constructor_try_statement_repeat1] = STATE(192),
    [sym_identifier] = ACTIONS(1909),
    [aux_sym_preproc_include_token1] = ACTIONS(1909),
    [aux_sym_preproc_def_token1] = ACTIONS(1909),
    [aux_sym_preproc_if_token1] = ACTIONS(1909),
    [aux_sym_preproc_if_token2] = ACTIONS(1909),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1909),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1909),
    [sym_preproc_directive] = ACTIONS(1909),
    [anon_sym_LPAREN2] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_SEMI] = ACTIONS(1911),
    [anon_sym___extension__] = ACTIONS(1909),
    [anon_sym_typedef] = ACTIONS(1909),
    [anon_sym___device__] = ACTIONS(1909),
    [anon_sym___host__] = ACTIONS(1909),
    [anon_sym___global__] = ACTIONS(1909),
    [anon_sym___forceinline__] = ACTIONS(1909),
    [anon_sym___noinline__] = ACTIONS(1909),
    [anon_sym_extern] = ACTIONS(1909),
    [anon_sym___attribute__] = ACTIONS(1909),
    [anon_sym_COLON_COLON] = ACTIONS(1911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1911),
    [anon_sym___declspec] = ACTIONS(1909),
    [anon_sym___based] = ACTIONS(1909),
    [anon_sym___cdecl] = ACTIONS(1909),
    [anon_sym___clrcall] = ACTIONS(1909),
    [anon_sym___stdcall] = ACTIONS(1909),
    [anon_sym___fastcall] = ACTIONS(1909),
    [anon_sym___thiscall] = ACTIONS(1909),
    [anon_sym___vectorcall] = ACTIONS(1909),
    [anon_sym_LBRACE] = ACTIONS(1911),
    [anon_sym_signed] = ACTIONS(1909),
    [anon_sym_unsigned] = ACTIONS(1909),
    [anon_sym_long] = ACTIONS(1909),
    [anon_sym_short] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_static] = ACTIONS(1909),
    [anon_sym_register] = ACTIONS(1909),
    [anon_sym_inline] = ACTIONS(1909),
    [anon_sym___inline] = ACTIONS(1909),
    [anon_sym___inline__] = ACTIONS(1909),
    [anon_sym___forceinline] = ACTIONS(1909),
    [anon_sym_thread_local] = ACTIONS(1909),
    [anon_sym___thread] = ACTIONS(1909),
    [anon_sym_const] = ACTIONS(1909),
    [anon_sym_constexpr] = ACTIONS(1909),
    [anon_sym_volatile] = ACTIONS(1909),
    [anon_sym_restrict] = ACTIONS(1909),
    [anon_sym___restrict__] = ACTIONS(1909),
    [anon_sym__Atomic] = ACTIONS(1909),
    [anon_sym__Noreturn] = ACTIONS(1909),
    [anon_sym_noreturn] = ACTIONS(1909),
    [anon_sym_mutable] = ACTIONS(1909),
    [anon_sym_constinit] = ACTIONS(1909),
    [anon_sym_consteval] = ACTIONS(1909),
    [anon_sym___shared__] = ACTIONS(1909),
    [anon_sym___local__] = ACTIONS(1909),
    [anon_sym___constant__] = ACTIONS(1909),
    [anon_sym___managed__] = ACTIONS(1909),
    [anon_sym___grid_constant__] = ACTIONS(1909),
    [anon_sym_alignas] = ACTIONS(1909),
    [anon_sym__Alignas] = ACTIONS(1909),
    [sym_primitive_type] = ACTIONS(1909),
    [anon_sym_enum] = ACTIONS(1909),
    [anon_sym_class] = ACTIONS(1909),
    [anon_sym_struct] = ACTIONS(1909),
    [anon_sym_union] = ACTIONS(1909),
    [anon_sym_if] = ACTIONS(1909),
    [anon_sym_else] = ACTIONS(1909),
    [anon_sym_switch] = ACTIONS(1909),
    [anon_sym_case] = ACTIONS(1909),
    [anon_sym_default] = ACTIONS(1909),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_do] = ACTIONS(1909),
    [anon_sym_for] = ACTIONS(1909),
    [anon_sym_return] = ACTIONS(1909),
    [anon_sym_break] = ACTIONS(1909),
    [anon_sym_continue] = ACTIONS(1909),
    [anon_sym_goto] = ACTIONS(1909),
    [anon_sym___try] = ACTIONS(1909),
    [anon_sym___leave] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1909),
    [anon_sym_compl] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_sizeof] = ACTIONS(1909),
    [anon_sym___alignof__] = ACTIONS(1909),
    [anon_sym___alignof] = ACTIONS(1909),
    [anon_sym__alignof] = ACTIONS(1909),
    [anon_sym_alignof] = ACTIONS(1909),
    [anon_sym__Alignof] = ACTIONS(1909),
    [anon_sym_offsetof] = ACTIONS(1909),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1909),
    [anon_sym___asm__] = ACTIONS(1909),
    [sym_number_literal] = ACTIONS(1911),
    [anon_sym_L_SQUOTE] = ACTIONS(1911),
    [anon_sym_u_SQUOTE] = ACTIONS(1911),
    [anon_sym_U_SQUOTE] = ACTIONS(1911),
    [anon_sym_u8_SQUOTE] = ACTIONS(1911),
    [anon_sym_SQUOTE] = ACTIONS(1911),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1909),
    [sym_false] = ACTIONS(1909),
    [anon_sym_NULL] = ACTIONS(1909),
    [anon_sym_nullptr] = ACTIONS(1909),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1909),
    [anon_sym_decltype] = ACTIONS(1909),
    [sym_virtual] = ACTIONS(1909),
    [anon_sym_explicit] = ACTIONS(1909),
    [anon_sym_typename] = ACTIONS(1909),
    [anon_sym_template] = ACTIONS(1909),
    [anon_sym_operator] = ACTIONS(1909),
    [anon_sym_try] = ACTIONS(1909),
    [anon_sym_delete] = ACTIONS(1909),
    [anon_sym_throw] = ACTIONS(1909),
    [anon_sym_namespace] = ACTIONS(1909),
    [anon_sym_using] = ACTIONS(1909),
    [anon_sym_static_assert] = ACTIONS(1909),
    [anon_sym_concept] = ACTIONS(1909),
    [anon_sym_co_return] = ACTIONS(1909),
    [anon_sym_co_yield] = ACTIONS(1909),
    [anon_sym_catch] = ACTIONS(2184),
    [anon_sym_R_DQUOTE] = ACTIONS(1911),
    [anon_sym_LR_DQUOTE] = ACTIONS(1911),
    [anon_sym_uR_DQUOTE] = ACTIONS(1911),
    [anon_sym_UR_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1911),
    [anon_sym_co_await] = ACTIONS(1909),
    [anon_sym_new] = ACTIONS(1909),
    [anon_sym_requires] = ACTIONS(1909),
    [sym_this] = ACTIONS(1909),
    [anon_sym___launch_bounds__] = ACTIONS(1909),
  },
  [193] = {
    [sym_identifier] = ACTIONS(2187),
    [aux_sym_preproc_include_token1] = ACTIONS(2187),
    [aux_sym_preproc_def_token1] = ACTIONS(2187),
    [aux_sym_preproc_if_token1] = ACTIONS(2187),
    [aux_sym_preproc_if_token2] = ACTIONS(2187),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2187),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2187),
    [aux_sym_preproc_else_token1] = ACTIONS(2187),
    [aux_sym_preproc_elif_token1] = ACTIONS(2187),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2187),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2187),
    [sym_preproc_directive] = ACTIONS(2187),
    [anon_sym_LPAREN2] = ACTIONS(2189),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_AMP_AMP] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_SEMI] = ACTIONS(2189),
    [anon_sym___extension__] = ACTIONS(2187),
    [anon_sym_typedef] = ACTIONS(2187),
    [anon_sym___device__] = ACTIONS(2187),
    [anon_sym___host__] = ACTIONS(2187),
    [anon_sym___global__] = ACTIONS(2187),
    [anon_sym___forceinline__] = ACTIONS(2187),
    [anon_sym___noinline__] = ACTIONS(2187),
    [anon_sym_extern] = ACTIONS(2187),
    [anon_sym___attribute__] = ACTIONS(2187),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2189),
    [anon_sym___declspec] = ACTIONS(2187),
    [anon_sym___based] = ACTIONS(2187),
    [anon_sym___cdecl] = ACTIONS(2187),
    [anon_sym___clrcall] = ACTIONS(2187),
    [anon_sym___stdcall] = ACTIONS(2187),
    [anon_sym___fastcall] = ACTIONS(2187),
    [anon_sym___thiscall] = ACTIONS(2187),
    [anon_sym___vectorcall] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2189),
    [anon_sym_signed] = ACTIONS(2187),
    [anon_sym_unsigned] = ACTIONS(2187),
    [anon_sym_long] = ACTIONS(2187),
    [anon_sym_short] = ACTIONS(2187),
    [anon_sym_LBRACK] = ACTIONS(2187),
    [anon_sym_static] = ACTIONS(2187),
    [anon_sym_register] = ACTIONS(2187),
    [anon_sym_inline] = ACTIONS(2187),
    [anon_sym___inline] = ACTIONS(2187),
    [anon_sym___inline__] = ACTIONS(2187),
    [anon_sym___forceinline] = ACTIONS(2187),
    [anon_sym_thread_local] = ACTIONS(2187),
    [anon_sym___thread] = ACTIONS(2187),
    [anon_sym_const] = ACTIONS(2187),
    [anon_sym_constexpr] = ACTIONS(2187),
    [anon_sym_volatile] = ACTIONS(2187),
    [anon_sym_restrict] = ACTIONS(2187),
    [anon_sym___restrict__] = ACTIONS(2187),
    [anon_sym__Atomic] = ACTIONS(2187),
    [anon_sym__Noreturn] = ACTIONS(2187),
    [anon_sym_noreturn] = ACTIONS(2187),
    [anon_sym_mutable] = ACTIONS(2187),
    [anon_sym_constinit] = ACTIONS(2187),
    [anon_sym_consteval] = ACTIONS(2187),
    [anon_sym___shared__] = ACTIONS(2187),
    [anon_sym___local__] = ACTIONS(2187),
    [anon_sym___constant__] = ACTIONS(2187),
    [anon_sym___managed__] = ACTIONS(2187),
    [anon_sym___grid_constant__] = ACTIONS(2187),
    [anon_sym_alignas] = ACTIONS(2187),
    [anon_sym__Alignas] = ACTIONS(2187),
    [sym_primitive_type] = ACTIONS(2187),
    [anon_sym_enum] = ACTIONS(2187),
    [anon_sym_class] = ACTIONS(2187),
    [anon_sym_struct] = ACTIONS(2187),
    [anon_sym_union] = ACTIONS(2187),
    [anon_sym_if] = ACTIONS(2187),
    [anon_sym_switch] = ACTIONS(2187),
    [anon_sym_case] = ACTIONS(2187),
    [anon_sym_default] = ACTIONS(2187),
    [anon_sym_while] = ACTIONS(2187),
    [anon_sym_do] = ACTIONS(2187),
    [anon_sym_for] = ACTIONS(2187),
    [anon_sym_return] = ACTIONS(2187),
    [anon_sym_break] = ACTIONS(2187),
    [anon_sym_continue] = ACTIONS(2187),
    [anon_sym_goto] = ACTIONS(2187),
    [anon_sym___try] = ACTIONS(2187),
    [anon_sym___leave] = ACTIONS(2187),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_compl] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_sizeof] = ACTIONS(2187),
    [anon_sym___alignof__] = ACTIONS(2187),
    [anon_sym___alignof] = ACTIONS(2187),
    [anon_sym__alignof] = ACTIONS(2187),
    [anon_sym_alignof] = ACTIONS(2187),
    [anon_sym__Alignof] = ACTIONS(2187),
    [anon_sym_offsetof] = ACTIONS(2187),
    [anon_sym__Generic] = ACTIONS(2187),
    [anon_sym_asm] = ACTIONS(2187),
    [anon_sym___asm__] = ACTIONS(2187),
    [sym_number_literal] = ACTIONS(2189),
    [anon_sym_L_SQUOTE] = ACTIONS(2189),
    [anon_sym_u_SQUOTE] = ACTIONS(2189),
    [anon_sym_U_SQUOTE] = ACTIONS(2189),
    [anon_sym_u8_SQUOTE] = ACTIONS(2189),
    [anon_sym_SQUOTE] = ACTIONS(2189),
    [anon_sym_L_DQUOTE] = ACTIONS(2189),
    [anon_sym_u_DQUOTE] = ACTIONS(2189),
    [anon_sym_U_DQUOTE] = ACTIONS(2189),
    [anon_sym_u8_DQUOTE] = ACTIONS(2189),
    [anon_sym_DQUOTE] = ACTIONS(2189),
    [sym_true] = ACTIONS(2187),
    [sym_false] = ACTIONS(2187),
    [anon_sym_NULL] = ACTIONS(2187),
    [anon_sym_nullptr] = ACTIONS(2187),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2187),
    [anon_sym_decltype] = ACTIONS(2187),
    [sym_virtual] = ACTIONS(2187),
    [anon_sym_explicit] = ACTIONS(2187),
    [anon_sym_typename] = ACTIONS(2187),
    [anon_sym_template] = ACTIONS(2187),
    [anon_sym_operator] = ACTIONS(2187),
    [anon_sym_try] = ACTIONS(2187),
    [anon_sym_delete] = ACTIONS(2187),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_namespace] = ACTIONS(2187),
    [anon_sym_using] = ACTIONS(2187),
    [anon_sym_static_assert] = ACTIONS(2187),
    [anon_sym_concept] = ACTIONS(2187),
    [anon_sym_co_return] = ACTIONS(2187),
    [anon_sym_co_yield] = ACTIONS(2187),
    [anon_sym_R_DQUOTE] = ACTIONS(2189),
    [anon_sym_LR_DQUOTE] = ACTIONS(2189),
    [anon_sym_uR_DQUOTE] = ACTIONS(2189),
    [anon_sym_UR_DQUOTE] = ACTIONS(2189),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2189),
    [anon_sym_co_await] = ACTIONS(2187),
    [anon_sym_new] = ACTIONS(2187),
    [anon_sym_requires] = ACTIONS(2187),
    [sym_this] = ACTIONS(2187),
    [anon_sym___launch_bounds__] = ACTIONS(2187),
  },
  [194] = {
    [sym_identifier] = ACTIONS(2191),
    [aux_sym_preproc_include_token1] = ACTIONS(2191),
    [aux_sym_preproc_def_token1] = ACTIONS(2191),
    [aux_sym_preproc_if_token1] = ACTIONS(2191),
    [aux_sym_preproc_if_token2] = ACTIONS(2191),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2191),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2191),
    [aux_sym_preproc_else_token1] = ACTIONS(2191),
    [aux_sym_preproc_elif_token1] = ACTIONS(2191),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2191),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2191),
    [sym_preproc_directive] = ACTIONS(2191),
    [anon_sym_LPAREN2] = ACTIONS(2193),
    [anon_sym_BANG] = ACTIONS(2193),
    [anon_sym_TILDE] = ACTIONS(2193),
    [anon_sym_DASH] = ACTIONS(2191),
    [anon_sym_PLUS] = ACTIONS(2191),
    [anon_sym_STAR] = ACTIONS(2193),
    [anon_sym_AMP_AMP] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2191),
    [anon_sym_SEMI] = ACTIONS(2193),
    [anon_sym___extension__] = ACTIONS(2191),
    [anon_sym_typedef] = ACTIONS(2191),
    [anon_sym___device__] = ACTIONS(2191),
    [anon_sym___host__] = ACTIONS(2191),
    [anon_sym___global__] = ACTIONS(2191),
    [anon_sym___forceinline__] = ACTIONS(2191),
    [anon_sym___noinline__] = ACTIONS(2191),
    [anon_sym_extern] = ACTIONS(2191),
    [anon_sym___attribute__] = ACTIONS(2191),
    [anon_sym_COLON_COLON] = ACTIONS(2193),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2193),
    [anon_sym___declspec] = ACTIONS(2191),
    [anon_sym___based] = ACTIONS(2191),
    [anon_sym___cdecl] = ACTIONS(2191),
    [anon_sym___clrcall] = ACTIONS(2191),
    [anon_sym___stdcall] = ACTIONS(2191),
    [anon_sym___fastcall] = ACTIONS(2191),
    [anon_sym___thiscall] = ACTIONS(2191),
    [anon_sym___vectorcall] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2193),
    [anon_sym_signed] = ACTIONS(2191),
    [anon_sym_unsigned] = ACTIONS(2191),
    [anon_sym_long] = ACTIONS(2191),
    [anon_sym_short] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2191),
    [anon_sym_static] = ACTIONS(2191),
    [anon_sym_register] = ACTIONS(2191),
    [anon_sym_inline] = ACTIONS(2191),
    [anon_sym___inline] = ACTIONS(2191),
    [anon_sym___inline__] = ACTIONS(2191),
    [anon_sym___forceinline] = ACTIONS(2191),
    [anon_sym_thread_local] = ACTIONS(2191),
    [anon_sym___thread] = ACTIONS(2191),
    [anon_sym_const] = ACTIONS(2191),
    [anon_sym_constexpr] = ACTIONS(2191),
    [anon_sym_volatile] = ACTIONS(2191),
    [anon_sym_restrict] = ACTIONS(2191),
    [anon_sym___restrict__] = ACTIONS(2191),
    [anon_sym__Atomic] = ACTIONS(2191),
    [anon_sym__Noreturn] = ACTIONS(2191),
    [anon_sym_noreturn] = ACTIONS(2191),
    [anon_sym_mutable] = ACTIONS(2191),
    [anon_sym_constinit] = ACTIONS(2191),
    [anon_sym_consteval] = ACTIONS(2191),
    [anon_sym___shared__] = ACTIONS(2191),
    [anon_sym___local__] = ACTIONS(2191),
    [anon_sym___constant__] = ACTIONS(2191),
    [anon_sym___managed__] = ACTIONS(2191),
    [anon_sym___grid_constant__] = ACTIONS(2191),
    [anon_sym_alignas] = ACTIONS(2191),
    [anon_sym__Alignas] = ACTIONS(2191),
    [sym_primitive_type] = ACTIONS(2191),
    [anon_sym_enum] = ACTIONS(2191),
    [anon_sym_class] = ACTIONS(2191),
    [anon_sym_struct] = ACTIONS(2191),
    [anon_sym_union] = ACTIONS(2191),
    [anon_sym_if] = ACTIONS(2191),
    [anon_sym_switch] = ACTIONS(2191),
    [anon_sym_case] = ACTIONS(2191),
    [anon_sym_default] = ACTIONS(2191),
    [anon_sym_while] = ACTIONS(2191),
    [anon_sym_do] = ACTIONS(2191),
    [anon_sym_for] = ACTIONS(2191),
    [anon_sym_return] = ACTIONS(2191),
    [anon_sym_break] = ACTIONS(2191),
    [anon_sym_continue] = ACTIONS(2191),
    [anon_sym_goto] = ACTIONS(2191),
    [anon_sym___try] = ACTIONS(2191),
    [anon_sym___leave] = ACTIONS(2191),
    [anon_sym_not] = ACTIONS(2191),
    [anon_sym_compl] = ACTIONS(2191),
    [anon_sym_DASH_DASH] = ACTIONS(2193),
    [anon_sym_PLUS_PLUS] = ACTIONS(2193),
    [anon_sym_sizeof] = ACTIONS(2191),
    [anon_sym___alignof__] = ACTIONS(2191),
    [anon_sym___alignof] = ACTIONS(2191),
    [anon_sym__alignof] = ACTIONS(2191),
    [anon_sym_alignof] = ACTIONS(2191),
    [anon_sym__Alignof] = ACTIONS(2191),
    [anon_sym_offsetof] = ACTIONS(2191),
    [anon_sym__Generic] = ACTIONS(2191),
    [anon_sym_asm] = ACTIONS(2191),
    [anon_sym___asm__] = ACTIONS(2191),
    [sym_number_literal] = ACTIONS(2193),
    [anon_sym_L_SQUOTE] = ACTIONS(2193),
    [anon_sym_u_SQUOTE] = ACTIONS(2193),
    [anon_sym_U_SQUOTE] = ACTIONS(2193),
    [anon_sym_u8_SQUOTE] = ACTIONS(2193),
    [anon_sym_SQUOTE] = ACTIONS(2193),
    [anon_sym_L_DQUOTE] = ACTIONS(2193),
    [anon_sym_u_DQUOTE] = ACTIONS(2193),
    [anon_sym_U_DQUOTE] = ACTIONS(2193),
    [anon_sym_u8_DQUOTE] = ACTIONS(2193),
    [anon_sym_DQUOTE] = ACTIONS(2193),
    [sym_true] = ACTIONS(2191),
    [sym_false] = ACTIONS(2191),
    [anon_sym_NULL] = ACTIONS(2191),
    [anon_sym_nullptr] = ACTIONS(2191),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2191),
    [anon_sym_decltype] = ACTIONS(2191),
    [sym_virtual] = ACTIONS(2191),
    [anon_sym_explicit] = ACTIONS(2191),
    [anon_sym_typename] = ACTIONS(2191),
    [anon_sym_template] = ACTIONS(2191),
    [anon_sym_operator] = ACTIONS(2191),
    [anon_sym_try] = ACTIONS(2191),
    [anon_sym_delete] = ACTIONS(2191),
    [anon_sym_throw] = ACTIONS(2191),
    [anon_sym_namespace] = ACTIONS(2191),
    [anon_sym_using] = ACTIONS(2191),
    [anon_sym_static_assert] = ACTIONS(2191),
    [anon_sym_concept] = ACTIONS(2191),
    [anon_sym_co_return] = ACTIONS(2191),
    [anon_sym_co_yield] = ACTIONS(2191),
    [anon_sym_R_DQUOTE] = ACTIONS(2193),
    [anon_sym_LR_DQUOTE] = ACTIONS(2193),
    [anon_sym_uR_DQUOTE] = ACTIONS(2193),
    [anon_sym_UR_DQUOTE] = ACTIONS(2193),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2193),
    [anon_sym_co_await] = ACTIONS(2191),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_requires] = ACTIONS(2191),
    [sym_this] = ACTIONS(2191),
    [anon_sym___launch_bounds__] = ACTIONS(2191),
  },
  [195] = {
    [sym_identifier] = ACTIONS(2195),
    [aux_sym_preproc_include_token1] = ACTIONS(2195),
    [aux_sym_preproc_def_token1] = ACTIONS(2195),
    [aux_sym_preproc_if_token1] = ACTIONS(2195),
    [aux_sym_preproc_if_token2] = ACTIONS(2195),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2195),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2195),
    [aux_sym_preproc_else_token1] = ACTIONS(2195),
    [aux_sym_preproc_elif_token1] = ACTIONS(2195),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2195),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2195),
    [sym_preproc_directive] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(2197),
    [anon_sym_BANG] = ACTIONS(2197),
    [anon_sym_TILDE] = ACTIONS(2197),
    [anon_sym_DASH] = ACTIONS(2195),
    [anon_sym_PLUS] = ACTIONS(2195),
    [anon_sym_STAR] = ACTIONS(2197),
    [anon_sym_AMP_AMP] = ACTIONS(2197),
    [anon_sym_AMP] = ACTIONS(2195),
    [anon_sym_SEMI] = ACTIONS(2197),
    [anon_sym___extension__] = ACTIONS(2195),
    [anon_sym_typedef] = ACTIONS(2195),
    [anon_sym___device__] = ACTIONS(2195),
    [anon_sym___host__] = ACTIONS(2195),
    [anon_sym___global__] = ACTIONS(2195),
    [anon_sym___forceinline__] = ACTIONS(2195),
    [anon_sym___noinline__] = ACTIONS(2195),
    [anon_sym_extern] = ACTIONS(2195),
    [anon_sym___attribute__] = ACTIONS(2195),
    [anon_sym_COLON_COLON] = ACTIONS(2197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2197),
    [anon_sym___declspec] = ACTIONS(2195),
    [anon_sym___based] = ACTIONS(2195),
    [anon_sym___cdecl] = ACTIONS(2195),
    [anon_sym___clrcall] = ACTIONS(2195),
    [anon_sym___stdcall] = ACTIONS(2195),
    [anon_sym___fastcall] = ACTIONS(2195),
    [anon_sym___thiscall] = ACTIONS(2195),
    [anon_sym___vectorcall] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(2197),
    [anon_sym_signed] = ACTIONS(2195),
    [anon_sym_unsigned] = ACTIONS(2195),
    [anon_sym_long] = ACTIONS(2195),
    [anon_sym_short] = ACTIONS(2195),
    [anon_sym_LBRACK] = ACTIONS(2195),
    [anon_sym_static] = ACTIONS(2195),
    [anon_sym_register] = ACTIONS(2195),
    [anon_sym_inline] = ACTIONS(2195),
    [anon_sym___inline] = ACTIONS(2195),
    [anon_sym___inline__] = ACTIONS(2195),
    [anon_sym___forceinline] = ACTIONS(2195),
    [anon_sym_thread_local] = ACTIONS(2195),
    [anon_sym___thread] = ACTIONS(2195),
    [anon_sym_const] = ACTIONS(2195),
    [anon_sym_constexpr] = ACTIONS(2195),
    [anon_sym_volatile] = ACTIONS(2195),
    [anon_sym_restrict] = ACTIONS(2195),
    [anon_sym___restrict__] = ACTIONS(2195),
    [anon_sym__Atomic] = ACTIONS(2195),
    [anon_sym__Noreturn] = ACTIONS(2195),
    [anon_sym_noreturn] = ACTIONS(2195),
    [anon_sym_mutable] = ACTIONS(2195),
    [anon_sym_constinit] = ACTIONS(2195),
    [anon_sym_consteval] = ACTIONS(2195),
    [anon_sym___shared__] = ACTIONS(2195),
    [anon_sym___local__] = ACTIONS(2195),
    [anon_sym___constant__] = ACTIONS(2195),
    [anon_sym___managed__] = ACTIONS(2195),
    [anon_sym___grid_constant__] = ACTIONS(2195),
    [anon_sym_alignas] = ACTIONS(2195),
    [anon_sym__Alignas] = ACTIONS(2195),
    [sym_primitive_type] = ACTIONS(2195),
    [anon_sym_enum] = ACTIONS(2195),
    [anon_sym_class] = ACTIONS(2195),
    [anon_sym_struct] = ACTIONS(2195),
    [anon_sym_union] = ACTIONS(2195),
    [anon_sym_if] = ACTIONS(2195),
    [anon_sym_switch] = ACTIONS(2195),
    [anon_sym_case] = ACTIONS(2195),
    [anon_sym_default] = ACTIONS(2195),
    [anon_sym_while] = ACTIONS(2195),
    [anon_sym_do] = ACTIONS(2195),
    [anon_sym_for] = ACTIONS(2195),
    [anon_sym_return] = ACTIONS(2195),
    [anon_sym_break] = ACTIONS(2195),
    [anon_sym_continue] = ACTIONS(2195),
    [anon_sym_goto] = ACTIONS(2195),
    [anon_sym___try] = ACTIONS(2195),
    [anon_sym___leave] = ACTIONS(2195),
    [anon_sym_not] = ACTIONS(2195),
    [anon_sym_compl] = ACTIONS(2195),
    [anon_sym_DASH_DASH] = ACTIONS(2197),
    [anon_sym_PLUS_PLUS] = ACTIONS(2197),
    [anon_sym_sizeof] = ACTIONS(2195),
    [anon_sym___alignof__] = ACTIONS(2195),
    [anon_sym___alignof] = ACTIONS(2195),
    [anon_sym__alignof] = ACTIONS(2195),
    [anon_sym_alignof] = ACTIONS(2195),
    [anon_sym__Alignof] = ACTIONS(2195),
    [anon_sym_offsetof] = ACTIONS(2195),
    [anon_sym__Generic] = ACTIONS(2195),
    [anon_sym_asm] = ACTIONS(2195),
    [anon_sym___asm__] = ACTIONS(2195),
    [sym_number_literal] = ACTIONS(2197),
    [anon_sym_L_SQUOTE] = ACTIONS(2197),
    [anon_sym_u_SQUOTE] = ACTIONS(2197),
    [anon_sym_U_SQUOTE] = ACTIONS(2197),
    [anon_sym_u8_SQUOTE] = ACTIONS(2197),
    [anon_sym_SQUOTE] = ACTIONS(2197),
    [anon_sym_L_DQUOTE] = ACTIONS(2197),
    [anon_sym_u_DQUOTE] = ACTIONS(2197),
    [anon_sym_U_DQUOTE] = ACTIONS(2197),
    [anon_sym_u8_DQUOTE] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(2197),
    [sym_true] = ACTIONS(2195),
    [sym_false] = ACTIONS(2195),
    [anon_sym_NULL] = ACTIONS(2195),
    [anon_sym_nullptr] = ACTIONS(2195),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2195),
    [anon_sym_decltype] = ACTIONS(2195),
    [sym_virtual] = ACTIONS(2195),
    [anon_sym_explicit] = ACTIONS(2195),
    [anon_sym_typename] = ACTIONS(2195),
    [anon_sym_template] = ACTIONS(2195),
    [anon_sym_operator] = ACTIONS(2195),
    [anon_sym_try] = ACTIONS(2195),
    [anon_sym_delete] = ACTIONS(2195),
    [anon_sym_throw] = ACTIONS(2195),
    [anon_sym_namespace] = ACTIONS(2195),
    [anon_sym_using] = ACTIONS(2195),
    [anon_sym_static_assert] = ACTIONS(2195),
    [anon_sym_concept] = ACTIONS(2195),
    [anon_sym_co_return] = ACTIONS(2195),
    [anon_sym_co_yield] = ACTIONS(2195),
    [anon_sym_R_DQUOTE] = ACTIONS(2197),
    [anon_sym_LR_DQUOTE] = ACTIONS(2197),
    [anon_sym_uR_DQUOTE] = ACTIONS(2197),
    [anon_sym_UR_DQUOTE] = ACTIONS(2197),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2197),
    [anon_sym_co_await] = ACTIONS(2195),
    [anon_sym_new] = ACTIONS(2195),
    [anon_sym_requires] = ACTIONS(2195),
    [sym_this] = ACTIONS(2195),
    [anon_sym___launch_bounds__] = ACTIONS(2195),
  },
  [196] = {
    [sym_identifier] = ACTIONS(2199),
    [aux_sym_preproc_include_token1] = ACTIONS(2199),
    [aux_sym_preproc_def_token1] = ACTIONS(2199),
    [aux_sym_preproc_if_token1] = ACTIONS(2199),
    [aux_sym_preproc_if_token2] = ACTIONS(2199),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2199),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2199),
    [aux_sym_preproc_else_token1] = ACTIONS(2199),
    [aux_sym_preproc_elif_token1] = ACTIONS(2199),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2199),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2199),
    [sym_preproc_directive] = ACTIONS(2199),
    [anon_sym_LPAREN2] = ACTIONS(2201),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2201),
    [anon_sym_AMP_AMP] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2199),
    [anon_sym_SEMI] = ACTIONS(2201),
    [anon_sym___extension__] = ACTIONS(2199),
    [anon_sym_typedef] = ACTIONS(2199),
    [anon_sym___device__] = ACTIONS(2199),
    [anon_sym___host__] = ACTIONS(2199),
    [anon_sym___global__] = ACTIONS(2199),
    [anon_sym___forceinline__] = ACTIONS(2199),
    [anon_sym___noinline__] = ACTIONS(2199),
    [anon_sym_extern] = ACTIONS(2199),
    [anon_sym___attribute__] = ACTIONS(2199),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2201),
    [anon_sym___declspec] = ACTIONS(2199),
    [anon_sym___based] = ACTIONS(2199),
    [anon_sym___cdecl] = ACTIONS(2199),
    [anon_sym___clrcall] = ACTIONS(2199),
    [anon_sym___stdcall] = ACTIONS(2199),
    [anon_sym___fastcall] = ACTIONS(2199),
    [anon_sym___thiscall] = ACTIONS(2199),
    [anon_sym___vectorcall] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(2201),
    [anon_sym_signed] = ACTIONS(2199),
    [anon_sym_unsigned] = ACTIONS(2199),
    [anon_sym_long] = ACTIONS(2199),
    [anon_sym_short] = ACTIONS(2199),
    [anon_sym_LBRACK] = ACTIONS(2199),
    [anon_sym_static] = ACTIONS(2199),
    [anon_sym_register] = ACTIONS(2199),
    [anon_sym_inline] = ACTIONS(2199),
    [anon_sym___inline] = ACTIONS(2199),
    [anon_sym___inline__] = ACTIONS(2199),
    [anon_sym___forceinline] = ACTIONS(2199),
    [anon_sym_thread_local] = ACTIONS(2199),
    [anon_sym___thread] = ACTIONS(2199),
    [anon_sym_const] = ACTIONS(2199),
    [anon_sym_constexpr] = ACTIONS(2199),
    [anon_sym_volatile] = ACTIONS(2199),
    [anon_sym_restrict] = ACTIONS(2199),
    [anon_sym___restrict__] = ACTIONS(2199),
    [anon_sym__Atomic] = ACTIONS(2199),
    [anon_sym__Noreturn] = ACTIONS(2199),
    [anon_sym_noreturn] = ACTIONS(2199),
    [anon_sym_mutable] = ACTIONS(2199),
    [anon_sym_constinit] = ACTIONS(2199),
    [anon_sym_consteval] = ACTIONS(2199),
    [anon_sym___shared__] = ACTIONS(2199),
    [anon_sym___local__] = ACTIONS(2199),
    [anon_sym___constant__] = ACTIONS(2199),
    [anon_sym___managed__] = ACTIONS(2199),
    [anon_sym___grid_constant__] = ACTIONS(2199),
    [anon_sym_alignas] = ACTIONS(2199),
    [anon_sym__Alignas] = ACTIONS(2199),
    [sym_primitive_type] = ACTIONS(2199),
    [anon_sym_enum] = ACTIONS(2199),
    [anon_sym_class] = ACTIONS(2199),
    [anon_sym_struct] = ACTIONS(2199),
    [anon_sym_union] = ACTIONS(2199),
    [anon_sym_if] = ACTIONS(2199),
    [anon_sym_switch] = ACTIONS(2199),
    [anon_sym_case] = ACTIONS(2199),
    [anon_sym_default] = ACTIONS(2199),
    [anon_sym_while] = ACTIONS(2199),
    [anon_sym_do] = ACTIONS(2199),
    [anon_sym_for] = ACTIONS(2199),
    [anon_sym_return] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2199),
    [anon_sym_continue] = ACTIONS(2199),
    [anon_sym_goto] = ACTIONS(2199),
    [anon_sym___try] = ACTIONS(2199),
    [anon_sym___leave] = ACTIONS(2199),
    [anon_sym_not] = ACTIONS(2199),
    [anon_sym_compl] = ACTIONS(2199),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_sizeof] = ACTIONS(2199),
    [anon_sym___alignof__] = ACTIONS(2199),
    [anon_sym___alignof] = ACTIONS(2199),
    [anon_sym__alignof] = ACTIONS(2199),
    [anon_sym_alignof] = ACTIONS(2199),
    [anon_sym__Alignof] = ACTIONS(2199),
    [anon_sym_offsetof] = ACTIONS(2199),
    [anon_sym__Generic] = ACTIONS(2199),
    [anon_sym_asm] = ACTIONS(2199),
    [anon_sym___asm__] = ACTIONS(2199),
    [sym_number_literal] = ACTIONS(2201),
    [anon_sym_L_SQUOTE] = ACTIONS(2201),
    [anon_sym_u_SQUOTE] = ACTIONS(2201),
    [anon_sym_U_SQUOTE] = ACTIONS(2201),
    [anon_sym_u8_SQUOTE] = ACTIONS(2201),
    [anon_sym_SQUOTE] = ACTIONS(2201),
    [anon_sym_L_DQUOTE] = ACTIONS(2201),
    [anon_sym_u_DQUOTE] = ACTIONS(2201),
    [anon_sym_U_DQUOTE] = ACTIONS(2201),
    [anon_sym_u8_DQUOTE] = ACTIONS(2201),
    [anon_sym_DQUOTE] = ACTIONS(2201),
    [sym_true] = ACTIONS(2199),
    [sym_false] = ACTIONS(2199),
    [anon_sym_NULL] = ACTIONS(2199),
    [anon_sym_nullptr] = ACTIONS(2199),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2199),
    [anon_sym_decltype] = ACTIONS(2199),
    [sym_virtual] = ACTIONS(2199),
    [anon_sym_explicit] = ACTIONS(2199),
    [anon_sym_typename] = ACTIONS(2199),
    [anon_sym_template] = ACTIONS(2199),
    [anon_sym_operator] = ACTIONS(2199),
    [anon_sym_try] = ACTIONS(2199),
    [anon_sym_delete] = ACTIONS(2199),
    [anon_sym_throw] = ACTIONS(2199),
    [anon_sym_namespace] = ACTIONS(2199),
    [anon_sym_using] = ACTIONS(2199),
    [anon_sym_static_assert] = ACTIONS(2199),
    [anon_sym_concept] = ACTIONS(2199),
    [anon_sym_co_return] = ACTIONS(2199),
    [anon_sym_co_yield] = ACTIONS(2199),
    [anon_sym_R_DQUOTE] = ACTIONS(2201),
    [anon_sym_LR_DQUOTE] = ACTIONS(2201),
    [anon_sym_uR_DQUOTE] = ACTIONS(2201),
    [anon_sym_UR_DQUOTE] = ACTIONS(2201),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2201),
    [anon_sym_co_await] = ACTIONS(2199),
    [anon_sym_new] = ACTIONS(2199),
    [anon_sym_requires] = ACTIONS(2199),
    [sym_this] = ACTIONS(2199),
    [anon_sym___launch_bounds__] = ACTIONS(2199),
  },
  [197] = {
    [sym_identifier] = ACTIONS(2203),
    [aux_sym_preproc_include_token1] = ACTIONS(2203),
    [aux_sym_preproc_def_token1] = ACTIONS(2203),
    [aux_sym_preproc_if_token1] = ACTIONS(2203),
    [aux_sym_preproc_if_token2] = ACTIONS(2203),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2203),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2203),
    [aux_sym_preproc_else_token1] = ACTIONS(2203),
    [aux_sym_preproc_elif_token1] = ACTIONS(2203),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2203),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2203),
    [sym_preproc_directive] = ACTIONS(2203),
    [anon_sym_LPAREN2] = ACTIONS(2205),
    [anon_sym_BANG] = ACTIONS(2205),
    [anon_sym_TILDE] = ACTIONS(2205),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_AMP_AMP] = ACTIONS(2205),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_SEMI] = ACTIONS(2205),
    [anon_sym___extension__] = ACTIONS(2203),
    [anon_sym_typedef] = ACTIONS(2203),
    [anon_sym___device__] = ACTIONS(2203),
    [anon_sym___host__] = ACTIONS(2203),
    [anon_sym___global__] = ACTIONS(2203),
    [anon_sym___forceinline__] = ACTIONS(2203),
    [anon_sym___noinline__] = ACTIONS(2203),
    [anon_sym_extern] = ACTIONS(2203),
    [anon_sym___attribute__] = ACTIONS(2203),
    [anon_sym_COLON_COLON] = ACTIONS(2205),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2205),
    [anon_sym___declspec] = ACTIONS(2203),
    [anon_sym___based] = ACTIONS(2203),
    [anon_sym___cdecl] = ACTIONS(2203),
    [anon_sym___clrcall] = ACTIONS(2203),
    [anon_sym___stdcall] = ACTIONS(2203),
    [anon_sym___fastcall] = ACTIONS(2203),
    [anon_sym___thiscall] = ACTIONS(2203),
    [anon_sym___vectorcall] = ACTIONS(2203),
    [anon_sym_LBRACE] = ACTIONS(2205),
    [anon_sym_signed] = ACTIONS(2203),
    [anon_sym_unsigned] = ACTIONS(2203),
    [anon_sym_long] = ACTIONS(2203),
    [anon_sym_short] = ACTIONS(2203),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_static] = ACTIONS(2203),
    [anon_sym_register] = ACTIONS(2203),
    [anon_sym_inline] = ACTIONS(2203),
    [anon_sym___inline] = ACTIONS(2203),
    [anon_sym___inline__] = ACTIONS(2203),
    [anon_sym___forceinline] = ACTIONS(2203),
    [anon_sym_thread_local] = ACTIONS(2203),
    [anon_sym___thread] = ACTIONS(2203),
    [anon_sym_const] = ACTIONS(2203),
    [anon_sym_constexpr] = ACTIONS(2203),
    [anon_sym_volatile] = ACTIONS(2203),
    [anon_sym_restrict] = ACTIONS(2203),
    [anon_sym___restrict__] = ACTIONS(2203),
    [anon_sym__Atomic] = ACTIONS(2203),
    [anon_sym__Noreturn] = ACTIONS(2203),
    [anon_sym_noreturn] = ACTIONS(2203),
    [anon_sym_mutable] = ACTIONS(2203),
    [anon_sym_constinit] = ACTIONS(2203),
    [anon_sym_consteval] = ACTIONS(2203),
    [anon_sym___shared__] = ACTIONS(2203),
    [anon_sym___local__] = ACTIONS(2203),
    [anon_sym___constant__] = ACTIONS(2203),
    [anon_sym___managed__] = ACTIONS(2203),
    [anon_sym___grid_constant__] = ACTIONS(2203),
    [anon_sym_alignas] = ACTIONS(2203),
    [anon_sym__Alignas] = ACTIONS(2203),
    [sym_primitive_type] = ACTIONS(2203),
    [anon_sym_enum] = ACTIONS(2203),
    [anon_sym_class] = ACTIONS(2203),
    [anon_sym_struct] = ACTIONS(2203),
    [anon_sym_union] = ACTIONS(2203),
    [anon_sym_if] = ACTIONS(2203),
    [anon_sym_switch] = ACTIONS(2203),
    [anon_sym_case] = ACTIONS(2203),
    [anon_sym_default] = ACTIONS(2203),
    [anon_sym_while] = ACTIONS(2203),
    [anon_sym_do] = ACTIONS(2203),
    [anon_sym_for] = ACTIONS(2203),
    [anon_sym_return] = ACTIONS(2203),
    [anon_sym_break] = ACTIONS(2203),
    [anon_sym_continue] = ACTIONS(2203),
    [anon_sym_goto] = ACTIONS(2203),
    [anon_sym___try] = ACTIONS(2203),
    [anon_sym___leave] = ACTIONS(2203),
    [anon_sym_not] = ACTIONS(2203),
    [anon_sym_compl] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2205),
    [anon_sym_PLUS_PLUS] = ACTIONS(2205),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2203),
    [anon_sym___alignof] = ACTIONS(2203),
    [anon_sym__alignof] = ACTIONS(2203),
    [anon_sym_alignof] = ACTIONS(2203),
    [anon_sym__Alignof] = ACTIONS(2203),
    [anon_sym_offsetof] = ACTIONS(2203),
    [anon_sym__Generic] = ACTIONS(2203),
    [anon_sym_asm] = ACTIONS(2203),
    [anon_sym___asm__] = ACTIONS(2203),
    [sym_number_literal] = ACTIONS(2205),
    [anon_sym_L_SQUOTE] = ACTIONS(2205),
    [anon_sym_u_SQUOTE] = ACTIONS(2205),
    [anon_sym_U_SQUOTE] = ACTIONS(2205),
    [anon_sym_u8_SQUOTE] = ACTIONS(2205),
    [anon_sym_SQUOTE] = ACTIONS(2205),
    [anon_sym_L_DQUOTE] = ACTIONS(2205),
    [anon_sym_u_DQUOTE] = ACTIONS(2205),
    [anon_sym_U_DQUOTE] = ACTIONS(2205),
    [anon_sym_u8_DQUOTE] = ACTIONS(2205),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [sym_true] = ACTIONS(2203),
    [sym_false] = ACTIONS(2203),
    [anon_sym_NULL] = ACTIONS(2203),
    [anon_sym_nullptr] = ACTIONS(2203),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2203),
    [anon_sym_decltype] = ACTIONS(2203),
    [sym_virtual] = ACTIONS(2203),
    [anon_sym_explicit] = ACTIONS(2203),
    [anon_sym_typename] = ACTIONS(2203),
    [anon_sym_template] = ACTIONS(2203),
    [anon_sym_operator] = ACTIONS(2203),
    [anon_sym_try] = ACTIONS(2203),
    [anon_sym_delete] = ACTIONS(2203),
    [anon_sym_throw] = ACTIONS(2203),
    [anon_sym_namespace] = ACTIONS(2203),
    [anon_sym_using] = ACTIONS(2203),
    [anon_sym_static_assert] = ACTIONS(2203),
    [anon_sym_concept] = ACTIONS(2203),
    [anon_sym_co_return] = ACTIONS(2203),
    [anon_sym_co_yield] = ACTIONS(2203),
    [anon_sym_R_DQUOTE] = ACTIONS(2205),
    [anon_sym_LR_DQUOTE] = ACTIONS(2205),
    [anon_sym_uR_DQUOTE] = ACTIONS(2205),
    [anon_sym_UR_DQUOTE] = ACTIONS(2205),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2205),
    [anon_sym_co_await] = ACTIONS(2203),
    [anon_sym_new] = ACTIONS(2203),
    [anon_sym_requires] = ACTIONS(2203),
    [sym_this] = ACTIONS(2203),
    [anon_sym___launch_bounds__] = ACTIONS(2203),
  },
  [198] = {
    [sym_preproc_def] = STATE(261),
    [sym_preproc_function_def] = STATE(261),
    [sym_preproc_call] = STATE(261),
    [sym_preproc_if_in_field_declaration_list] = STATE(261),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(261),
    [sym_preproc_else_in_field_declaration_list] = STATE(8753),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8753),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8753),
    [sym_type_definition] = STATE(261),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5944),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6464),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(261),
    [sym_field_declaration] = STATE(261),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1701),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(261),
    [sym_operator_cast] = STATE(6994),
    [sym_inline_method_definition] = STATE(261),
    [sym__constructor_specifiers] = STATE(1701),
    [sym_operator_cast_definition] = STATE(261),
    [sym_operator_cast_declaration] = STATE(261),
    [sym_constructor_or_destructor_definition] = STATE(261),
    [sym_constructor_or_destructor_declaration] = STATE(261),
    [sym_friend_declaration] = STATE(261),
    [sym_access_specifier] = STATE(9001),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(261),
    [sym_alias_declaration] = STATE(261),
    [sym_static_assert_declaration] = STATE(261),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6994),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(261),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1701),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(2100),
    [aux_sym_preproc_if_token1] = ACTIONS(2102),
    [aux_sym_preproc_if_token2] = ACTIONS(2207),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2106),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2106),
    [aux_sym_preproc_else_token1] = ACTIONS(2108),
    [aux_sym_preproc_elif_token1] = ACTIONS(2110),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2112),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2112),
    [sym_preproc_directive] = ACTIONS(2114),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(2124),
    [anon_sym_typedef] = ACTIONS(2126),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(2144),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2146),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(2150),
    [anon_sym_static_assert] = ACTIONS(2152),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [199] = {
    [sym_preproc_def] = STATE(370),
    [sym_preproc_function_def] = STATE(370),
    [sym_preproc_call] = STATE(370),
    [sym_preproc_if_in_field_declaration_list] = STATE(370),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(370),
    [sym_preproc_else_in_field_declaration_list] = STATE(8981),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8981),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8981),
    [sym_type_definition] = STATE(370),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5944),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6464),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(370),
    [sym_field_declaration] = STATE(370),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1701),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(370),
    [sym_operator_cast] = STATE(6994),
    [sym_inline_method_definition] = STATE(370),
    [sym__constructor_specifiers] = STATE(1701),
    [sym_operator_cast_definition] = STATE(370),
    [sym_operator_cast_declaration] = STATE(370),
    [sym_constructor_or_destructor_definition] = STATE(370),
    [sym_constructor_or_destructor_declaration] = STATE(370),
    [sym_friend_declaration] = STATE(370),
    [sym_access_specifier] = STATE(9001),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(370),
    [sym_alias_declaration] = STATE(370),
    [sym_static_assert_declaration] = STATE(370),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6994),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(370),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1701),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(2100),
    [aux_sym_preproc_if_token1] = ACTIONS(2102),
    [aux_sym_preproc_if_token2] = ACTIONS(2209),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2106),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2106),
    [aux_sym_preproc_else_token1] = ACTIONS(2108),
    [aux_sym_preproc_elif_token1] = ACTIONS(2110),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2112),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2112),
    [sym_preproc_directive] = ACTIONS(2114),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(2124),
    [anon_sym_typedef] = ACTIONS(2126),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(2144),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2146),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(2150),
    [anon_sym_static_assert] = ACTIONS(2152),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [200] = {
    [sym_identifier] = ACTIONS(2211),
    [aux_sym_preproc_include_token1] = ACTIONS(2211),
    [aux_sym_preproc_def_token1] = ACTIONS(2211),
    [aux_sym_preproc_if_token1] = ACTIONS(2211),
    [aux_sym_preproc_if_token2] = ACTIONS(2211),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2211),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2211),
    [aux_sym_preproc_else_token1] = ACTIONS(2211),
    [aux_sym_preproc_elif_token1] = ACTIONS(2211),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2211),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2211),
    [sym_preproc_directive] = ACTIONS(2211),
    [anon_sym_LPAREN2] = ACTIONS(2213),
    [anon_sym_BANG] = ACTIONS(2213),
    [anon_sym_TILDE] = ACTIONS(2213),
    [anon_sym_DASH] = ACTIONS(2211),
    [anon_sym_PLUS] = ACTIONS(2211),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_AMP_AMP] = ACTIONS(2213),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_SEMI] = ACTIONS(2213),
    [anon_sym___extension__] = ACTIONS(2211),
    [anon_sym_typedef] = ACTIONS(2211),
    [anon_sym___device__] = ACTIONS(2211),
    [anon_sym___host__] = ACTIONS(2211),
    [anon_sym___global__] = ACTIONS(2211),
    [anon_sym___forceinline__] = ACTIONS(2211),
    [anon_sym___noinline__] = ACTIONS(2211),
    [anon_sym_extern] = ACTIONS(2211),
    [anon_sym___attribute__] = ACTIONS(2211),
    [anon_sym_COLON_COLON] = ACTIONS(2213),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2213),
    [anon_sym___declspec] = ACTIONS(2211),
    [anon_sym___based] = ACTIONS(2211),
    [anon_sym___cdecl] = ACTIONS(2211),
    [anon_sym___clrcall] = ACTIONS(2211),
    [anon_sym___stdcall] = ACTIONS(2211),
    [anon_sym___fastcall] = ACTIONS(2211),
    [anon_sym___thiscall] = ACTIONS(2211),
    [anon_sym___vectorcall] = ACTIONS(2211),
    [anon_sym_LBRACE] = ACTIONS(2213),
    [anon_sym_signed] = ACTIONS(2211),
    [anon_sym_unsigned] = ACTIONS(2211),
    [anon_sym_long] = ACTIONS(2211),
    [anon_sym_short] = ACTIONS(2211),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_static] = ACTIONS(2211),
    [anon_sym_register] = ACTIONS(2211),
    [anon_sym_inline] = ACTIONS(2211),
    [anon_sym___inline] = ACTIONS(2211),
    [anon_sym___inline__] = ACTIONS(2211),
    [anon_sym___forceinline] = ACTIONS(2211),
    [anon_sym_thread_local] = ACTIONS(2211),
    [anon_sym___thread] = ACTIONS(2211),
    [anon_sym_const] = ACTIONS(2211),
    [anon_sym_constexpr] = ACTIONS(2211),
    [anon_sym_volatile] = ACTIONS(2211),
    [anon_sym_restrict] = ACTIONS(2211),
    [anon_sym___restrict__] = ACTIONS(2211),
    [anon_sym__Atomic] = ACTIONS(2211),
    [anon_sym__Noreturn] = ACTIONS(2211),
    [anon_sym_noreturn] = ACTIONS(2211),
    [anon_sym_mutable] = ACTIONS(2211),
    [anon_sym_constinit] = ACTIONS(2211),
    [anon_sym_consteval] = ACTIONS(2211),
    [anon_sym___shared__] = ACTIONS(2211),
    [anon_sym___local__] = ACTIONS(2211),
    [anon_sym___constant__] = ACTIONS(2211),
    [anon_sym___managed__] = ACTIONS(2211),
    [anon_sym___grid_constant__] = ACTIONS(2211),
    [anon_sym_alignas] = ACTIONS(2211),
    [anon_sym__Alignas] = ACTIONS(2211),
    [sym_primitive_type] = ACTIONS(2211),
    [anon_sym_enum] = ACTIONS(2211),
    [anon_sym_class] = ACTIONS(2211),
    [anon_sym_struct] = ACTIONS(2211),
    [anon_sym_union] = ACTIONS(2211),
    [anon_sym_if] = ACTIONS(2211),
    [anon_sym_switch] = ACTIONS(2211),
    [anon_sym_case] = ACTIONS(2211),
    [anon_sym_default] = ACTIONS(2211),
    [anon_sym_while] = ACTIONS(2211),
    [anon_sym_do] = ACTIONS(2211),
    [anon_sym_for] = ACTIONS(2211),
    [anon_sym_return] = ACTIONS(2211),
    [anon_sym_break] = ACTIONS(2211),
    [anon_sym_continue] = ACTIONS(2211),
    [anon_sym_goto] = ACTIONS(2211),
    [anon_sym___try] = ACTIONS(2211),
    [anon_sym___leave] = ACTIONS(2211),
    [anon_sym_not] = ACTIONS(2211),
    [anon_sym_compl] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2213),
    [anon_sym_PLUS_PLUS] = ACTIONS(2213),
    [anon_sym_sizeof] = ACTIONS(2211),
    [anon_sym___alignof__] = ACTIONS(2211),
    [anon_sym___alignof] = ACTIONS(2211),
    [anon_sym__alignof] = ACTIONS(2211),
    [anon_sym_alignof] = ACTIONS(2211),
    [anon_sym__Alignof] = ACTIONS(2211),
    [anon_sym_offsetof] = ACTIONS(2211),
    [anon_sym__Generic] = ACTIONS(2211),
    [anon_sym_asm] = ACTIONS(2211),
    [anon_sym___asm__] = ACTIONS(2211),
    [sym_number_literal] = ACTIONS(2213),
    [anon_sym_L_SQUOTE] = ACTIONS(2213),
    [anon_sym_u_SQUOTE] = ACTIONS(2213),
    [anon_sym_U_SQUOTE] = ACTIONS(2213),
    [anon_sym_u8_SQUOTE] = ACTIONS(2213),
    [anon_sym_SQUOTE] = ACTIONS(2213),
    [anon_sym_L_DQUOTE] = ACTIONS(2213),
    [anon_sym_u_DQUOTE] = ACTIONS(2213),
    [anon_sym_U_DQUOTE] = ACTIONS(2213),
    [anon_sym_u8_DQUOTE] = ACTIONS(2213),
    [anon_sym_DQUOTE] = ACTIONS(2213),
    [sym_true] = ACTIONS(2211),
    [sym_false] = ACTIONS(2211),
    [anon_sym_NULL] = ACTIONS(2211),
    [anon_sym_nullptr] = ACTIONS(2211),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2211),
    [anon_sym_decltype] = ACTIONS(2211),
    [sym_virtual] = ACTIONS(2211),
    [anon_sym_explicit] = ACTIONS(2211),
    [anon_sym_typename] = ACTIONS(2211),
    [anon_sym_template] = ACTIONS(2211),
    [anon_sym_operator] = ACTIONS(2211),
    [anon_sym_try] = ACTIONS(2211),
    [anon_sym_delete] = ACTIONS(2211),
    [anon_sym_throw] = ACTIONS(2211),
    [anon_sym_namespace] = ACTIONS(2211),
    [anon_sym_using] = ACTIONS(2211),
    [anon_sym_static_assert] = ACTIONS(2211),
    [anon_sym_concept] = ACTIONS(2211),
    [anon_sym_co_return] = ACTIONS(2211),
    [anon_sym_co_yield] = ACTIONS(2211),
    [anon_sym_R_DQUOTE] = ACTIONS(2213),
    [anon_sym_LR_DQUOTE] = ACTIONS(2213),
    [anon_sym_uR_DQUOTE] = ACTIONS(2213),
    [anon_sym_UR_DQUOTE] = ACTIONS(2213),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2213),
    [anon_sym_co_await] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(2211),
    [anon_sym_requires] = ACTIONS(2211),
    [sym_this] = ACTIONS(2211),
    [anon_sym___launch_bounds__] = ACTIONS(2211),
  },
  [201] = {
    [sym_identifier] = ACTIONS(2215),
    [aux_sym_preproc_include_token1] = ACTIONS(2215),
    [aux_sym_preproc_def_token1] = ACTIONS(2215),
    [aux_sym_preproc_if_token1] = ACTIONS(2215),
    [aux_sym_preproc_if_token2] = ACTIONS(2215),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2215),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2215),
    [aux_sym_preproc_else_token1] = ACTIONS(2215),
    [aux_sym_preproc_elif_token1] = ACTIONS(2215),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2215),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2215),
    [sym_preproc_directive] = ACTIONS(2215),
    [anon_sym_LPAREN2] = ACTIONS(2217),
    [anon_sym_BANG] = ACTIONS(2217),
    [anon_sym_TILDE] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2215),
    [anon_sym_PLUS] = ACTIONS(2215),
    [anon_sym_STAR] = ACTIONS(2217),
    [anon_sym_AMP_AMP] = ACTIONS(2217),
    [anon_sym_AMP] = ACTIONS(2215),
    [anon_sym_SEMI] = ACTIONS(2217),
    [anon_sym___extension__] = ACTIONS(2215),
    [anon_sym_typedef] = ACTIONS(2215),
    [anon_sym___device__] = ACTIONS(2215),
    [anon_sym___host__] = ACTIONS(2215),
    [anon_sym___global__] = ACTIONS(2215),
    [anon_sym___forceinline__] = ACTIONS(2215),
    [anon_sym___noinline__] = ACTIONS(2215),
    [anon_sym_extern] = ACTIONS(2215),
    [anon_sym___attribute__] = ACTIONS(2215),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2217),
    [anon_sym___declspec] = ACTIONS(2215),
    [anon_sym___based] = ACTIONS(2215),
    [anon_sym___cdecl] = ACTIONS(2215),
    [anon_sym___clrcall] = ACTIONS(2215),
    [anon_sym___stdcall] = ACTIONS(2215),
    [anon_sym___fastcall] = ACTIONS(2215),
    [anon_sym___thiscall] = ACTIONS(2215),
    [anon_sym___vectorcall] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_signed] = ACTIONS(2215),
    [anon_sym_unsigned] = ACTIONS(2215),
    [anon_sym_long] = ACTIONS(2215),
    [anon_sym_short] = ACTIONS(2215),
    [anon_sym_LBRACK] = ACTIONS(2215),
    [anon_sym_static] = ACTIONS(2215),
    [anon_sym_register] = ACTIONS(2215),
    [anon_sym_inline] = ACTIONS(2215),
    [anon_sym___inline] = ACTIONS(2215),
    [anon_sym___inline__] = ACTIONS(2215),
    [anon_sym___forceinline] = ACTIONS(2215),
    [anon_sym_thread_local] = ACTIONS(2215),
    [anon_sym___thread] = ACTIONS(2215),
    [anon_sym_const] = ACTIONS(2215),
    [anon_sym_constexpr] = ACTIONS(2215),
    [anon_sym_volatile] = ACTIONS(2215),
    [anon_sym_restrict] = ACTIONS(2215),
    [anon_sym___restrict__] = ACTIONS(2215),
    [anon_sym__Atomic] = ACTIONS(2215),
    [anon_sym__Noreturn] = ACTIONS(2215),
    [anon_sym_noreturn] = ACTIONS(2215),
    [anon_sym_mutable] = ACTIONS(2215),
    [anon_sym_constinit] = ACTIONS(2215),
    [anon_sym_consteval] = ACTIONS(2215),
    [anon_sym___shared__] = ACTIONS(2215),
    [anon_sym___local__] = ACTIONS(2215),
    [anon_sym___constant__] = ACTIONS(2215),
    [anon_sym___managed__] = ACTIONS(2215),
    [anon_sym___grid_constant__] = ACTIONS(2215),
    [anon_sym_alignas] = ACTIONS(2215),
    [anon_sym__Alignas] = ACTIONS(2215),
    [sym_primitive_type] = ACTIONS(2215),
    [anon_sym_enum] = ACTIONS(2215),
    [anon_sym_class] = ACTIONS(2215),
    [anon_sym_struct] = ACTIONS(2215),
    [anon_sym_union] = ACTIONS(2215),
    [anon_sym_if] = ACTIONS(2215),
    [anon_sym_switch] = ACTIONS(2215),
    [anon_sym_case] = ACTIONS(2215),
    [anon_sym_default] = ACTIONS(2215),
    [anon_sym_while] = ACTIONS(2215),
    [anon_sym_do] = ACTIONS(2215),
    [anon_sym_for] = ACTIONS(2215),
    [anon_sym_return] = ACTIONS(2215),
    [anon_sym_break] = ACTIONS(2215),
    [anon_sym_continue] = ACTIONS(2215),
    [anon_sym_goto] = ACTIONS(2215),
    [anon_sym___try] = ACTIONS(2215),
    [anon_sym___leave] = ACTIONS(2215),
    [anon_sym_not] = ACTIONS(2215),
    [anon_sym_compl] = ACTIONS(2215),
    [anon_sym_DASH_DASH] = ACTIONS(2217),
    [anon_sym_PLUS_PLUS] = ACTIONS(2217),
    [anon_sym_sizeof] = ACTIONS(2215),
    [anon_sym___alignof__] = ACTIONS(2215),
    [anon_sym___alignof] = ACTIONS(2215),
    [anon_sym__alignof] = ACTIONS(2215),
    [anon_sym_alignof] = ACTIONS(2215),
    [anon_sym__Alignof] = ACTIONS(2215),
    [anon_sym_offsetof] = ACTIONS(2215),
    [anon_sym__Generic] = ACTIONS(2215),
    [anon_sym_asm] = ACTIONS(2215),
    [anon_sym___asm__] = ACTIONS(2215),
    [sym_number_literal] = ACTIONS(2217),
    [anon_sym_L_SQUOTE] = ACTIONS(2217),
    [anon_sym_u_SQUOTE] = ACTIONS(2217),
    [anon_sym_U_SQUOTE] = ACTIONS(2217),
    [anon_sym_u8_SQUOTE] = ACTIONS(2217),
    [anon_sym_SQUOTE] = ACTIONS(2217),
    [anon_sym_L_DQUOTE] = ACTIONS(2217),
    [anon_sym_u_DQUOTE] = ACTIONS(2217),
    [anon_sym_U_DQUOTE] = ACTIONS(2217),
    [anon_sym_u8_DQUOTE] = ACTIONS(2217),
    [anon_sym_DQUOTE] = ACTIONS(2217),
    [sym_true] = ACTIONS(2215),
    [sym_false] = ACTIONS(2215),
    [anon_sym_NULL] = ACTIONS(2215),
    [anon_sym_nullptr] = ACTIONS(2215),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2215),
    [anon_sym_decltype] = ACTIONS(2215),
    [sym_virtual] = ACTIONS(2215),
    [anon_sym_explicit] = ACTIONS(2215),
    [anon_sym_typename] = ACTIONS(2215),
    [anon_sym_template] = ACTIONS(2215),
    [anon_sym_operator] = ACTIONS(2215),
    [anon_sym_try] = ACTIONS(2215),
    [anon_sym_delete] = ACTIONS(2215),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_namespace] = ACTIONS(2215),
    [anon_sym_using] = ACTIONS(2215),
    [anon_sym_static_assert] = ACTIONS(2215),
    [anon_sym_concept] = ACTIONS(2215),
    [anon_sym_co_return] = ACTIONS(2215),
    [anon_sym_co_yield] = ACTIONS(2215),
    [anon_sym_R_DQUOTE] = ACTIONS(2217),
    [anon_sym_LR_DQUOTE] = ACTIONS(2217),
    [anon_sym_uR_DQUOTE] = ACTIONS(2217),
    [anon_sym_UR_DQUOTE] = ACTIONS(2217),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2217),
    [anon_sym_co_await] = ACTIONS(2215),
    [anon_sym_new] = ACTIONS(2215),
    [anon_sym_requires] = ACTIONS(2215),
    [sym_this] = ACTIONS(2215),
    [anon_sym___launch_bounds__] = ACTIONS(2215),
  },
  [202] = {
    [sym_preproc_def] = STATE(370),
    [sym_preproc_function_def] = STATE(370),
    [sym_preproc_call] = STATE(370),
    [sym_preproc_if_in_field_declaration_list] = STATE(370),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(370),
    [sym_preproc_else_in_field_declaration_list] = STATE(9019),
    [sym_preproc_elif_in_field_declaration_list] = STATE(9019),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(9019),
    [sym_type_definition] = STATE(370),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5944),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6464),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(370),
    [sym_field_declaration] = STATE(370),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1701),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(370),
    [sym_operator_cast] = STATE(6994),
    [sym_inline_method_definition] = STATE(370),
    [sym__constructor_specifiers] = STATE(1701),
    [sym_operator_cast_definition] = STATE(370),
    [sym_operator_cast_declaration] = STATE(370),
    [sym_constructor_or_destructor_definition] = STATE(370),
    [sym_constructor_or_destructor_declaration] = STATE(370),
    [sym_friend_declaration] = STATE(370),
    [sym_access_specifier] = STATE(9001),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(370),
    [sym_alias_declaration] = STATE(370),
    [sym_static_assert_declaration] = STATE(370),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6994),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(370),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1701),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(2100),
    [aux_sym_preproc_if_token1] = ACTIONS(2102),
    [aux_sym_preproc_if_token2] = ACTIONS(2219),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2106),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2106),
    [aux_sym_preproc_else_token1] = ACTIONS(2108),
    [aux_sym_preproc_elif_token1] = ACTIONS(2110),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2112),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2112),
    [sym_preproc_directive] = ACTIONS(2114),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(2124),
    [anon_sym_typedef] = ACTIONS(2126),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(2144),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2146),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(2150),
    [anon_sym_static_assert] = ACTIONS(2152),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [203] = {
    [sym_identifier] = ACTIONS(2221),
    [aux_sym_preproc_include_token1] = ACTIONS(2221),
    [aux_sym_preproc_def_token1] = ACTIONS(2221),
    [aux_sym_preproc_if_token1] = ACTIONS(2221),
    [aux_sym_preproc_if_token2] = ACTIONS(2221),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2221),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2221),
    [aux_sym_preproc_else_token1] = ACTIONS(2221),
    [aux_sym_preproc_elif_token1] = ACTIONS(2221),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2221),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2221),
    [sym_preproc_directive] = ACTIONS(2221),
    [anon_sym_LPAREN2] = ACTIONS(2223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym___extension__] = ACTIONS(2221),
    [anon_sym_typedef] = ACTIONS(2221),
    [anon_sym___device__] = ACTIONS(2221),
    [anon_sym___host__] = ACTIONS(2221),
    [anon_sym___global__] = ACTIONS(2221),
    [anon_sym___forceinline__] = ACTIONS(2221),
    [anon_sym___noinline__] = ACTIONS(2221),
    [anon_sym_extern] = ACTIONS(2221),
    [anon_sym___attribute__] = ACTIONS(2221),
    [anon_sym_COLON_COLON] = ACTIONS(2223),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2223),
    [anon_sym___declspec] = ACTIONS(2221),
    [anon_sym___based] = ACTIONS(2221),
    [anon_sym___cdecl] = ACTIONS(2221),
    [anon_sym___clrcall] = ACTIONS(2221),
    [anon_sym___stdcall] = ACTIONS(2221),
    [anon_sym___fastcall] = ACTIONS(2221),
    [anon_sym___thiscall] = ACTIONS(2221),
    [anon_sym___vectorcall] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(2223),
    [anon_sym_signed] = ACTIONS(2221),
    [anon_sym_unsigned] = ACTIONS(2221),
    [anon_sym_long] = ACTIONS(2221),
    [anon_sym_short] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2221),
    [anon_sym_static] = ACTIONS(2221),
    [anon_sym_register] = ACTIONS(2221),
    [anon_sym_inline] = ACTIONS(2221),
    [anon_sym___inline] = ACTIONS(2221),
    [anon_sym___inline__] = ACTIONS(2221),
    [anon_sym___forceinline] = ACTIONS(2221),
    [anon_sym_thread_local] = ACTIONS(2221),
    [anon_sym___thread] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2221),
    [anon_sym_constexpr] = ACTIONS(2221),
    [anon_sym_volatile] = ACTIONS(2221),
    [anon_sym_restrict] = ACTIONS(2221),
    [anon_sym___restrict__] = ACTIONS(2221),
    [anon_sym__Atomic] = ACTIONS(2221),
    [anon_sym__Noreturn] = ACTIONS(2221),
    [anon_sym_noreturn] = ACTIONS(2221),
    [anon_sym_mutable] = ACTIONS(2221),
    [anon_sym_constinit] = ACTIONS(2221),
    [anon_sym_consteval] = ACTIONS(2221),
    [anon_sym___shared__] = ACTIONS(2221),
    [anon_sym___local__] = ACTIONS(2221),
    [anon_sym___constant__] = ACTIONS(2221),
    [anon_sym___managed__] = ACTIONS(2221),
    [anon_sym___grid_constant__] = ACTIONS(2221),
    [anon_sym_alignas] = ACTIONS(2221),
    [anon_sym__Alignas] = ACTIONS(2221),
    [sym_primitive_type] = ACTIONS(2221),
    [anon_sym_enum] = ACTIONS(2221),
    [anon_sym_class] = ACTIONS(2221),
    [anon_sym_struct] = ACTIONS(2221),
    [anon_sym_union] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_case] = ACTIONS(2221),
    [anon_sym_default] = ACTIONS(2221),
    [anon_sym_while] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2221),
    [anon_sym_for] = ACTIONS(2221),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_break] = ACTIONS(2221),
    [anon_sym_continue] = ACTIONS(2221),
    [anon_sym_goto] = ACTIONS(2221),
    [anon_sym___try] = ACTIONS(2221),
    [anon_sym___leave] = ACTIONS(2221),
    [anon_sym_not] = ACTIONS(2221),
    [anon_sym_compl] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_sizeof] = ACTIONS(2221),
    [anon_sym___alignof__] = ACTIONS(2221),
    [anon_sym___alignof] = ACTIONS(2221),
    [anon_sym__alignof] = ACTIONS(2221),
    [anon_sym_alignof] = ACTIONS(2221),
    [anon_sym__Alignof] = ACTIONS(2221),
    [anon_sym_offsetof] = ACTIONS(2221),
    [anon_sym__Generic] = ACTIONS(2221),
    [anon_sym_asm] = ACTIONS(2221),
    [anon_sym___asm__] = ACTIONS(2221),
    [sym_number_literal] = ACTIONS(2223),
    [anon_sym_L_SQUOTE] = ACTIONS(2223),
    [anon_sym_u_SQUOTE] = ACTIONS(2223),
    [anon_sym_U_SQUOTE] = ACTIONS(2223),
    [anon_sym_u8_SQUOTE] = ACTIONS(2223),
    [anon_sym_SQUOTE] = ACTIONS(2223),
    [anon_sym_L_DQUOTE] = ACTIONS(2223),
    [anon_sym_u_DQUOTE] = ACTIONS(2223),
    [anon_sym_U_DQUOTE] = ACTIONS(2223),
    [anon_sym_u8_DQUOTE] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2223),
    [sym_true] = ACTIONS(2221),
    [sym_false] = ACTIONS(2221),
    [anon_sym_NULL] = ACTIONS(2221),
    [anon_sym_nullptr] = ACTIONS(2221),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2221),
    [anon_sym_decltype] = ACTIONS(2221),
    [sym_virtual] = ACTIONS(2221),
    [anon_sym_explicit] = ACTIONS(2221),
    [anon_sym_typename] = ACTIONS(2221),
    [anon_sym_template] = ACTIONS(2221),
    [anon_sym_operator] = ACTIONS(2221),
    [anon_sym_try] = ACTIONS(2221),
    [anon_sym_delete] = ACTIONS(2221),
    [anon_sym_throw] = ACTIONS(2221),
    [anon_sym_namespace] = ACTIONS(2221),
    [anon_sym_using] = ACTIONS(2221),
    [anon_sym_static_assert] = ACTIONS(2221),
    [anon_sym_concept] = ACTIONS(2221),
    [anon_sym_co_return] = ACTIONS(2221),
    [anon_sym_co_yield] = ACTIONS(2221),
    [anon_sym_R_DQUOTE] = ACTIONS(2223),
    [anon_sym_LR_DQUOTE] = ACTIONS(2223),
    [anon_sym_uR_DQUOTE] = ACTIONS(2223),
    [anon_sym_UR_DQUOTE] = ACTIONS(2223),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2223),
    [anon_sym_co_await] = ACTIONS(2221),
    [anon_sym_new] = ACTIONS(2221),
    [anon_sym_requires] = ACTIONS(2221),
    [sym_this] = ACTIONS(2221),
    [anon_sym___launch_bounds__] = ACTIONS(2221),
  },
  [204] = {
    [sym_preproc_def] = STATE(199),
    [sym_preproc_function_def] = STATE(199),
    [sym_preproc_call] = STATE(199),
    [sym_preproc_if_in_field_declaration_list] = STATE(199),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(199),
    [sym_preproc_else_in_field_declaration_list] = STATE(9020),
    [sym_preproc_elif_in_field_declaration_list] = STATE(9020),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(9020),
    [sym_type_definition] = STATE(199),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5944),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6464),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(199),
    [sym_field_declaration] = STATE(199),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1701),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(199),
    [sym_operator_cast] = STATE(6994),
    [sym_inline_method_definition] = STATE(199),
    [sym__constructor_specifiers] = STATE(1701),
    [sym_operator_cast_definition] = STATE(199),
    [sym_operator_cast_declaration] = STATE(199),
    [sym_constructor_or_destructor_definition] = STATE(199),
    [sym_constructor_or_destructor_declaration] = STATE(199),
    [sym_friend_declaration] = STATE(199),
    [sym_access_specifier] = STATE(9001),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(199),
    [sym_alias_declaration] = STATE(199),
    [sym_static_assert_declaration] = STATE(199),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6994),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(199),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1701),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(2100),
    [aux_sym_preproc_if_token1] = ACTIONS(2102),
    [aux_sym_preproc_if_token2] = ACTIONS(2225),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2106),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2106),
    [aux_sym_preproc_else_token1] = ACTIONS(2108),
    [aux_sym_preproc_elif_token1] = ACTIONS(2110),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2112),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2112),
    [sym_preproc_directive] = ACTIONS(2114),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(2124),
    [anon_sym_typedef] = ACTIONS(2126),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(2144),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2146),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(2150),
    [anon_sym_static_assert] = ACTIONS(2152),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [205] = {
    [sym_identifier] = ACTIONS(2227),
    [aux_sym_preproc_include_token1] = ACTIONS(2227),
    [aux_sym_preproc_def_token1] = ACTIONS(2227),
    [aux_sym_preproc_if_token1] = ACTIONS(2227),
    [aux_sym_preproc_if_token2] = ACTIONS(2227),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2227),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2227),
    [aux_sym_preproc_else_token1] = ACTIONS(2227),
    [aux_sym_preproc_elif_token1] = ACTIONS(2227),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2227),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2227),
    [sym_preproc_directive] = ACTIONS(2227),
    [anon_sym_LPAREN2] = ACTIONS(2229),
    [anon_sym_BANG] = ACTIONS(2229),
    [anon_sym_TILDE] = ACTIONS(2229),
    [anon_sym_DASH] = ACTIONS(2227),
    [anon_sym_PLUS] = ACTIONS(2227),
    [anon_sym_STAR] = ACTIONS(2229),
    [anon_sym_AMP_AMP] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2227),
    [anon_sym_SEMI] = ACTIONS(2229),
    [anon_sym___extension__] = ACTIONS(2227),
    [anon_sym_typedef] = ACTIONS(2227),
    [anon_sym___device__] = ACTIONS(2227),
    [anon_sym___host__] = ACTIONS(2227),
    [anon_sym___global__] = ACTIONS(2227),
    [anon_sym___forceinline__] = ACTIONS(2227),
    [anon_sym___noinline__] = ACTIONS(2227),
    [anon_sym_extern] = ACTIONS(2227),
    [anon_sym___attribute__] = ACTIONS(2227),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2229),
    [anon_sym___declspec] = ACTIONS(2227),
    [anon_sym___based] = ACTIONS(2227),
    [anon_sym___cdecl] = ACTIONS(2227),
    [anon_sym___clrcall] = ACTIONS(2227),
    [anon_sym___stdcall] = ACTIONS(2227),
    [anon_sym___fastcall] = ACTIONS(2227),
    [anon_sym___thiscall] = ACTIONS(2227),
    [anon_sym___vectorcall] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(2229),
    [anon_sym_signed] = ACTIONS(2227),
    [anon_sym_unsigned] = ACTIONS(2227),
    [anon_sym_long] = ACTIONS(2227),
    [anon_sym_short] = ACTIONS(2227),
    [anon_sym_LBRACK] = ACTIONS(2227),
    [anon_sym_static] = ACTIONS(2227),
    [anon_sym_register] = ACTIONS(2227),
    [anon_sym_inline] = ACTIONS(2227),
    [anon_sym___inline] = ACTIONS(2227),
    [anon_sym___inline__] = ACTIONS(2227),
    [anon_sym___forceinline] = ACTIONS(2227),
    [anon_sym_thread_local] = ACTIONS(2227),
    [anon_sym___thread] = ACTIONS(2227),
    [anon_sym_const] = ACTIONS(2227),
    [anon_sym_constexpr] = ACTIONS(2227),
    [anon_sym_volatile] = ACTIONS(2227),
    [anon_sym_restrict] = ACTIONS(2227),
    [anon_sym___restrict__] = ACTIONS(2227),
    [anon_sym__Atomic] = ACTIONS(2227),
    [anon_sym__Noreturn] = ACTIONS(2227),
    [anon_sym_noreturn] = ACTIONS(2227),
    [anon_sym_mutable] = ACTIONS(2227),
    [anon_sym_constinit] = ACTIONS(2227),
    [anon_sym_consteval] = ACTIONS(2227),
    [anon_sym___shared__] = ACTIONS(2227),
    [anon_sym___local__] = ACTIONS(2227),
    [anon_sym___constant__] = ACTIONS(2227),
    [anon_sym___managed__] = ACTIONS(2227),
    [anon_sym___grid_constant__] = ACTIONS(2227),
    [anon_sym_alignas] = ACTIONS(2227),
    [anon_sym__Alignas] = ACTIONS(2227),
    [sym_primitive_type] = ACTIONS(2227),
    [anon_sym_enum] = ACTIONS(2227),
    [anon_sym_class] = ACTIONS(2227),
    [anon_sym_struct] = ACTIONS(2227),
    [anon_sym_union] = ACTIONS(2227),
    [anon_sym_if] = ACTIONS(2227),
    [anon_sym_switch] = ACTIONS(2227),
    [anon_sym_case] = ACTIONS(2227),
    [anon_sym_default] = ACTIONS(2227),
    [anon_sym_while] = ACTIONS(2227),
    [anon_sym_do] = ACTIONS(2227),
    [anon_sym_for] = ACTIONS(2227),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_break] = ACTIONS(2227),
    [anon_sym_continue] = ACTIONS(2227),
    [anon_sym_goto] = ACTIONS(2227),
    [anon_sym___try] = ACTIONS(2227),
    [anon_sym___leave] = ACTIONS(2227),
    [anon_sym_not] = ACTIONS(2227),
    [anon_sym_compl] = ACTIONS(2227),
    [anon_sym_DASH_DASH] = ACTIONS(2229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2229),
    [anon_sym_sizeof] = ACTIONS(2227),
    [anon_sym___alignof__] = ACTIONS(2227),
    [anon_sym___alignof] = ACTIONS(2227),
    [anon_sym__alignof] = ACTIONS(2227),
    [anon_sym_alignof] = ACTIONS(2227),
    [anon_sym__Alignof] = ACTIONS(2227),
    [anon_sym_offsetof] = ACTIONS(2227),
    [anon_sym__Generic] = ACTIONS(2227),
    [anon_sym_asm] = ACTIONS(2227),
    [anon_sym___asm__] = ACTIONS(2227),
    [sym_number_literal] = ACTIONS(2229),
    [anon_sym_L_SQUOTE] = ACTIONS(2229),
    [anon_sym_u_SQUOTE] = ACTIONS(2229),
    [anon_sym_U_SQUOTE] = ACTIONS(2229),
    [anon_sym_u8_SQUOTE] = ACTIONS(2229),
    [anon_sym_SQUOTE] = ACTIONS(2229),
    [anon_sym_L_DQUOTE] = ACTIONS(2229),
    [anon_sym_u_DQUOTE] = ACTIONS(2229),
    [anon_sym_U_DQUOTE] = ACTIONS(2229),
    [anon_sym_u8_DQUOTE] = ACTIONS(2229),
    [anon_sym_DQUOTE] = ACTIONS(2229),
    [sym_true] = ACTIONS(2227),
    [sym_false] = ACTIONS(2227),
    [anon_sym_NULL] = ACTIONS(2227),
    [anon_sym_nullptr] = ACTIONS(2227),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2227),
    [anon_sym_decltype] = ACTIONS(2227),
    [sym_virtual] = ACTIONS(2227),
    [anon_sym_explicit] = ACTIONS(2227),
    [anon_sym_typename] = ACTIONS(2227),
    [anon_sym_template] = ACTIONS(2227),
    [anon_sym_operator] = ACTIONS(2227),
    [anon_sym_try] = ACTIONS(2227),
    [anon_sym_delete] = ACTIONS(2227),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_namespace] = ACTIONS(2227),
    [anon_sym_using] = ACTIONS(2227),
    [anon_sym_static_assert] = ACTIONS(2227),
    [anon_sym_concept] = ACTIONS(2227),
    [anon_sym_co_return] = ACTIONS(2227),
    [anon_sym_co_yield] = ACTIONS(2227),
    [anon_sym_R_DQUOTE] = ACTIONS(2229),
    [anon_sym_LR_DQUOTE] = ACTIONS(2229),
    [anon_sym_uR_DQUOTE] = ACTIONS(2229),
    [anon_sym_UR_DQUOTE] = ACTIONS(2229),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2229),
    [anon_sym_co_await] = ACTIONS(2227),
    [anon_sym_new] = ACTIONS(2227),
    [anon_sym_requires] = ACTIONS(2227),
    [sym_this] = ACTIONS(2227),
    [anon_sym___launch_bounds__] = ACTIONS(2227),
  },
  [206] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(2960),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8499),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8217),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8509),
    [sym__unary_right_fold] = STATE(8507),
    [sym__binary_fold] = STATE(8501),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8481),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [207] = {
    [sym_identifier] = ACTIONS(2231),
    [aux_sym_preproc_include_token1] = ACTIONS(2231),
    [aux_sym_preproc_def_token1] = ACTIONS(2231),
    [aux_sym_preproc_if_token1] = ACTIONS(2231),
    [aux_sym_preproc_if_token2] = ACTIONS(2231),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2231),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2231),
    [aux_sym_preproc_else_token1] = ACTIONS(2231),
    [aux_sym_preproc_elif_token1] = ACTIONS(2231),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2231),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2231),
    [sym_preproc_directive] = ACTIONS(2231),
    [anon_sym_LPAREN2] = ACTIONS(2233),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym_SEMI] = ACTIONS(2233),
    [anon_sym___extension__] = ACTIONS(2231),
    [anon_sym_typedef] = ACTIONS(2231),
    [anon_sym___device__] = ACTIONS(2231),
    [anon_sym___host__] = ACTIONS(2231),
    [anon_sym___global__] = ACTIONS(2231),
    [anon_sym___forceinline__] = ACTIONS(2231),
    [anon_sym___noinline__] = ACTIONS(2231),
    [anon_sym_extern] = ACTIONS(2231),
    [anon_sym___attribute__] = ACTIONS(2231),
    [anon_sym_COLON_COLON] = ACTIONS(2233),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2233),
    [anon_sym___declspec] = ACTIONS(2231),
    [anon_sym___based] = ACTIONS(2231),
    [anon_sym___cdecl] = ACTIONS(2231),
    [anon_sym___clrcall] = ACTIONS(2231),
    [anon_sym___stdcall] = ACTIONS(2231),
    [anon_sym___fastcall] = ACTIONS(2231),
    [anon_sym___thiscall] = ACTIONS(2231),
    [anon_sym___vectorcall] = ACTIONS(2231),
    [anon_sym_LBRACE] = ACTIONS(2233),
    [anon_sym_signed] = ACTIONS(2231),
    [anon_sym_unsigned] = ACTIONS(2231),
    [anon_sym_long] = ACTIONS(2231),
    [anon_sym_short] = ACTIONS(2231),
    [anon_sym_LBRACK] = ACTIONS(2231),
    [anon_sym_static] = ACTIONS(2231),
    [anon_sym_register] = ACTIONS(2231),
    [anon_sym_inline] = ACTIONS(2231),
    [anon_sym___inline] = ACTIONS(2231),
    [anon_sym___inline__] = ACTIONS(2231),
    [anon_sym___forceinline] = ACTIONS(2231),
    [anon_sym_thread_local] = ACTIONS(2231),
    [anon_sym___thread] = ACTIONS(2231),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_constexpr] = ACTIONS(2231),
    [anon_sym_volatile] = ACTIONS(2231),
    [anon_sym_restrict] = ACTIONS(2231),
    [anon_sym___restrict__] = ACTIONS(2231),
    [anon_sym__Atomic] = ACTIONS(2231),
    [anon_sym__Noreturn] = ACTIONS(2231),
    [anon_sym_noreturn] = ACTIONS(2231),
    [anon_sym_mutable] = ACTIONS(2231),
    [anon_sym_constinit] = ACTIONS(2231),
    [anon_sym_consteval] = ACTIONS(2231),
    [anon_sym___shared__] = ACTIONS(2231),
    [anon_sym___local__] = ACTIONS(2231),
    [anon_sym___constant__] = ACTIONS(2231),
    [anon_sym___managed__] = ACTIONS(2231),
    [anon_sym___grid_constant__] = ACTIONS(2231),
    [anon_sym_alignas] = ACTIONS(2231),
    [anon_sym__Alignas] = ACTIONS(2231),
    [sym_primitive_type] = ACTIONS(2231),
    [anon_sym_enum] = ACTIONS(2231),
    [anon_sym_class] = ACTIONS(2231),
    [anon_sym_struct] = ACTIONS(2231),
    [anon_sym_union] = ACTIONS(2231),
    [anon_sym_if] = ACTIONS(2231),
    [anon_sym_switch] = ACTIONS(2231),
    [anon_sym_case] = ACTIONS(2231),
    [anon_sym_default] = ACTIONS(2231),
    [anon_sym_while] = ACTIONS(2231),
    [anon_sym_do] = ACTIONS(2231),
    [anon_sym_for] = ACTIONS(2231),
    [anon_sym_return] = ACTIONS(2231),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_continue] = ACTIONS(2231),
    [anon_sym_goto] = ACTIONS(2231),
    [anon_sym___try] = ACTIONS(2231),
    [anon_sym___leave] = ACTIONS(2231),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_compl] = ACTIONS(2231),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_sizeof] = ACTIONS(2231),
    [anon_sym___alignof__] = ACTIONS(2231),
    [anon_sym___alignof] = ACTIONS(2231),
    [anon_sym__alignof] = ACTIONS(2231),
    [anon_sym_alignof] = ACTIONS(2231),
    [anon_sym__Alignof] = ACTIONS(2231),
    [anon_sym_offsetof] = ACTIONS(2231),
    [anon_sym__Generic] = ACTIONS(2231),
    [anon_sym_asm] = ACTIONS(2231),
    [anon_sym___asm__] = ACTIONS(2231),
    [sym_number_literal] = ACTIONS(2233),
    [anon_sym_L_SQUOTE] = ACTIONS(2233),
    [anon_sym_u_SQUOTE] = ACTIONS(2233),
    [anon_sym_U_SQUOTE] = ACTIONS(2233),
    [anon_sym_u8_SQUOTE] = ACTIONS(2233),
    [anon_sym_SQUOTE] = ACTIONS(2233),
    [anon_sym_L_DQUOTE] = ACTIONS(2233),
    [anon_sym_u_DQUOTE] = ACTIONS(2233),
    [anon_sym_U_DQUOTE] = ACTIONS(2233),
    [anon_sym_u8_DQUOTE] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(2233),
    [sym_true] = ACTIONS(2231),
    [sym_false] = ACTIONS(2231),
    [anon_sym_NULL] = ACTIONS(2231),
    [anon_sym_nullptr] = ACTIONS(2231),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2231),
    [anon_sym_decltype] = ACTIONS(2231),
    [sym_virtual] = ACTIONS(2231),
    [anon_sym_explicit] = ACTIONS(2231),
    [anon_sym_typename] = ACTIONS(2231),
    [anon_sym_template] = ACTIONS(2231),
    [anon_sym_operator] = ACTIONS(2231),
    [anon_sym_try] = ACTIONS(2231),
    [anon_sym_delete] = ACTIONS(2231),
    [anon_sym_throw] = ACTIONS(2231),
    [anon_sym_namespace] = ACTIONS(2231),
    [anon_sym_using] = ACTIONS(2231),
    [anon_sym_static_assert] = ACTIONS(2231),
    [anon_sym_concept] = ACTIONS(2231),
    [anon_sym_co_return] = ACTIONS(2231),
    [anon_sym_co_yield] = ACTIONS(2231),
    [anon_sym_R_DQUOTE] = ACTIONS(2233),
    [anon_sym_LR_DQUOTE] = ACTIONS(2233),
    [anon_sym_uR_DQUOTE] = ACTIONS(2233),
    [anon_sym_UR_DQUOTE] = ACTIONS(2233),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2233),
    [anon_sym_co_await] = ACTIONS(2231),
    [anon_sym_new] = ACTIONS(2231),
    [anon_sym_requires] = ACTIONS(2231),
    [sym_this] = ACTIONS(2231),
    [anon_sym___launch_bounds__] = ACTIONS(2231),
  },
  [208] = {
    [sym_identifier] = ACTIONS(2235),
    [aux_sym_preproc_include_token1] = ACTIONS(2235),
    [aux_sym_preproc_def_token1] = ACTIONS(2235),
    [aux_sym_preproc_if_token1] = ACTIONS(2235),
    [aux_sym_preproc_if_token2] = ACTIONS(2235),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2235),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2235),
    [aux_sym_preproc_else_token1] = ACTIONS(2235),
    [aux_sym_preproc_elif_token1] = ACTIONS(2235),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2235),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2235),
    [sym_preproc_directive] = ACTIONS(2235),
    [anon_sym_LPAREN2] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2237),
    [anon_sym_TILDE] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_STAR] = ACTIONS(2237),
    [anon_sym_AMP_AMP] = ACTIONS(2237),
    [anon_sym_AMP] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2237),
    [anon_sym___extension__] = ACTIONS(2235),
    [anon_sym_typedef] = ACTIONS(2235),
    [anon_sym___device__] = ACTIONS(2235),
    [anon_sym___host__] = ACTIONS(2235),
    [anon_sym___global__] = ACTIONS(2235),
    [anon_sym___forceinline__] = ACTIONS(2235),
    [anon_sym___noinline__] = ACTIONS(2235),
    [anon_sym_extern] = ACTIONS(2235),
    [anon_sym___attribute__] = ACTIONS(2235),
    [anon_sym_COLON_COLON] = ACTIONS(2237),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2237),
    [anon_sym___declspec] = ACTIONS(2235),
    [anon_sym___based] = ACTIONS(2235),
    [anon_sym___cdecl] = ACTIONS(2235),
    [anon_sym___clrcall] = ACTIONS(2235),
    [anon_sym___stdcall] = ACTIONS(2235),
    [anon_sym___fastcall] = ACTIONS(2235),
    [anon_sym___thiscall] = ACTIONS(2235),
    [anon_sym___vectorcall] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2237),
    [anon_sym_signed] = ACTIONS(2235),
    [anon_sym_unsigned] = ACTIONS(2235),
    [anon_sym_long] = ACTIONS(2235),
    [anon_sym_short] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_static] = ACTIONS(2235),
    [anon_sym_register] = ACTIONS(2235),
    [anon_sym_inline] = ACTIONS(2235),
    [anon_sym___inline] = ACTIONS(2235),
    [anon_sym___inline__] = ACTIONS(2235),
    [anon_sym___forceinline] = ACTIONS(2235),
    [anon_sym_thread_local] = ACTIONS(2235),
    [anon_sym___thread] = ACTIONS(2235),
    [anon_sym_const] = ACTIONS(2235),
    [anon_sym_constexpr] = ACTIONS(2235),
    [anon_sym_volatile] = ACTIONS(2235),
    [anon_sym_restrict] = ACTIONS(2235),
    [anon_sym___restrict__] = ACTIONS(2235),
    [anon_sym__Atomic] = ACTIONS(2235),
    [anon_sym__Noreturn] = ACTIONS(2235),
    [anon_sym_noreturn] = ACTIONS(2235),
    [anon_sym_mutable] = ACTIONS(2235),
    [anon_sym_constinit] = ACTIONS(2235),
    [anon_sym_consteval] = ACTIONS(2235),
    [anon_sym___shared__] = ACTIONS(2235),
    [anon_sym___local__] = ACTIONS(2235),
    [anon_sym___constant__] = ACTIONS(2235),
    [anon_sym___managed__] = ACTIONS(2235),
    [anon_sym___grid_constant__] = ACTIONS(2235),
    [anon_sym_alignas] = ACTIONS(2235),
    [anon_sym__Alignas] = ACTIONS(2235),
    [sym_primitive_type] = ACTIONS(2235),
    [anon_sym_enum] = ACTIONS(2235),
    [anon_sym_class] = ACTIONS(2235),
    [anon_sym_struct] = ACTIONS(2235),
    [anon_sym_union] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_switch] = ACTIONS(2235),
    [anon_sym_case] = ACTIONS(2235),
    [anon_sym_default] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_for] = ACTIONS(2235),
    [anon_sym_return] = ACTIONS(2235),
    [anon_sym_break] = ACTIONS(2235),
    [anon_sym_continue] = ACTIONS(2235),
    [anon_sym_goto] = ACTIONS(2235),
    [anon_sym___try] = ACTIONS(2235),
    [anon_sym___leave] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2235),
    [anon_sym_compl] = ACTIONS(2235),
    [anon_sym_DASH_DASH] = ACTIONS(2237),
    [anon_sym_PLUS_PLUS] = ACTIONS(2237),
    [anon_sym_sizeof] = ACTIONS(2235),
    [anon_sym___alignof__] = ACTIONS(2235),
    [anon_sym___alignof] = ACTIONS(2235),
    [anon_sym__alignof] = ACTIONS(2235),
    [anon_sym_alignof] = ACTIONS(2235),
    [anon_sym__Alignof] = ACTIONS(2235),
    [anon_sym_offsetof] = ACTIONS(2235),
    [anon_sym__Generic] = ACTIONS(2235),
    [anon_sym_asm] = ACTIONS(2235),
    [anon_sym___asm__] = ACTIONS(2235),
    [sym_number_literal] = ACTIONS(2237),
    [anon_sym_L_SQUOTE] = ACTIONS(2237),
    [anon_sym_u_SQUOTE] = ACTIONS(2237),
    [anon_sym_U_SQUOTE] = ACTIONS(2237),
    [anon_sym_u8_SQUOTE] = ACTIONS(2237),
    [anon_sym_SQUOTE] = ACTIONS(2237),
    [anon_sym_L_DQUOTE] = ACTIONS(2237),
    [anon_sym_u_DQUOTE] = ACTIONS(2237),
    [anon_sym_U_DQUOTE] = ACTIONS(2237),
    [anon_sym_u8_DQUOTE] = ACTIONS(2237),
    [anon_sym_DQUOTE] = ACTIONS(2237),
    [sym_true] = ACTIONS(2235),
    [sym_false] = ACTIONS(2235),
    [anon_sym_NULL] = ACTIONS(2235),
    [anon_sym_nullptr] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2235),
    [anon_sym_decltype] = ACTIONS(2235),
    [sym_virtual] = ACTIONS(2235),
    [anon_sym_explicit] = ACTIONS(2235),
    [anon_sym_typename] = ACTIONS(2235),
    [anon_sym_template] = ACTIONS(2235),
    [anon_sym_operator] = ACTIONS(2235),
    [anon_sym_try] = ACTIONS(2235),
    [anon_sym_delete] = ACTIONS(2235),
    [anon_sym_throw] = ACTIONS(2235),
    [anon_sym_namespace] = ACTIONS(2235),
    [anon_sym_using] = ACTIONS(2235),
    [anon_sym_static_assert] = ACTIONS(2235),
    [anon_sym_concept] = ACTIONS(2235),
    [anon_sym_co_return] = ACTIONS(2235),
    [anon_sym_co_yield] = ACTIONS(2235),
    [anon_sym_R_DQUOTE] = ACTIONS(2237),
    [anon_sym_LR_DQUOTE] = ACTIONS(2237),
    [anon_sym_uR_DQUOTE] = ACTIONS(2237),
    [anon_sym_UR_DQUOTE] = ACTIONS(2237),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2237),
    [anon_sym_co_await] = ACTIONS(2235),
    [anon_sym_new] = ACTIONS(2235),
    [anon_sym_requires] = ACTIONS(2235),
    [sym_this] = ACTIONS(2235),
    [anon_sym___launch_bounds__] = ACTIONS(2235),
  },
  [209] = {
    [sym_identifier] = ACTIONS(2239),
    [aux_sym_preproc_include_token1] = ACTIONS(2239),
    [aux_sym_preproc_def_token1] = ACTIONS(2239),
    [aux_sym_preproc_if_token1] = ACTIONS(2239),
    [aux_sym_preproc_if_token2] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2239),
    [aux_sym_preproc_else_token1] = ACTIONS(2239),
    [aux_sym_preproc_elif_token1] = ACTIONS(2239),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2239),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2239),
    [sym_preproc_directive] = ACTIONS(2239),
    [anon_sym_LPAREN2] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2239),
    [anon_sym_PLUS] = ACTIONS(2239),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_SEMI] = ACTIONS(2241),
    [anon_sym___extension__] = ACTIONS(2239),
    [anon_sym_typedef] = ACTIONS(2239),
    [anon_sym___device__] = ACTIONS(2239),
    [anon_sym___host__] = ACTIONS(2239),
    [anon_sym___global__] = ACTIONS(2239),
    [anon_sym___forceinline__] = ACTIONS(2239),
    [anon_sym___noinline__] = ACTIONS(2239),
    [anon_sym_extern] = ACTIONS(2239),
    [anon_sym___attribute__] = ACTIONS(2239),
    [anon_sym_COLON_COLON] = ACTIONS(2241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2241),
    [anon_sym___declspec] = ACTIONS(2239),
    [anon_sym___based] = ACTIONS(2239),
    [anon_sym___cdecl] = ACTIONS(2239),
    [anon_sym___clrcall] = ACTIONS(2239),
    [anon_sym___stdcall] = ACTIONS(2239),
    [anon_sym___fastcall] = ACTIONS(2239),
    [anon_sym___thiscall] = ACTIONS(2239),
    [anon_sym___vectorcall] = ACTIONS(2239),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_signed] = ACTIONS(2239),
    [anon_sym_unsigned] = ACTIONS(2239),
    [anon_sym_long] = ACTIONS(2239),
    [anon_sym_short] = ACTIONS(2239),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_static] = ACTIONS(2239),
    [anon_sym_register] = ACTIONS(2239),
    [anon_sym_inline] = ACTIONS(2239),
    [anon_sym___inline] = ACTIONS(2239),
    [anon_sym___inline__] = ACTIONS(2239),
    [anon_sym___forceinline] = ACTIONS(2239),
    [anon_sym_thread_local] = ACTIONS(2239),
    [anon_sym___thread] = ACTIONS(2239),
    [anon_sym_const] = ACTIONS(2239),
    [anon_sym_constexpr] = ACTIONS(2239),
    [anon_sym_volatile] = ACTIONS(2239),
    [anon_sym_restrict] = ACTIONS(2239),
    [anon_sym___restrict__] = ACTIONS(2239),
    [anon_sym__Atomic] = ACTIONS(2239),
    [anon_sym__Noreturn] = ACTIONS(2239),
    [anon_sym_noreturn] = ACTIONS(2239),
    [anon_sym_mutable] = ACTIONS(2239),
    [anon_sym_constinit] = ACTIONS(2239),
    [anon_sym_consteval] = ACTIONS(2239),
    [anon_sym___shared__] = ACTIONS(2239),
    [anon_sym___local__] = ACTIONS(2239),
    [anon_sym___constant__] = ACTIONS(2239),
    [anon_sym___managed__] = ACTIONS(2239),
    [anon_sym___grid_constant__] = ACTIONS(2239),
    [anon_sym_alignas] = ACTIONS(2239),
    [anon_sym__Alignas] = ACTIONS(2239),
    [sym_primitive_type] = ACTIONS(2239),
    [anon_sym_enum] = ACTIONS(2239),
    [anon_sym_class] = ACTIONS(2239),
    [anon_sym_struct] = ACTIONS(2239),
    [anon_sym_union] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(2239),
    [anon_sym_switch] = ACTIONS(2239),
    [anon_sym_case] = ACTIONS(2239),
    [anon_sym_default] = ACTIONS(2239),
    [anon_sym_while] = ACTIONS(2239),
    [anon_sym_do] = ACTIONS(2239),
    [anon_sym_for] = ACTIONS(2239),
    [anon_sym_return] = ACTIONS(2239),
    [anon_sym_break] = ACTIONS(2239),
    [anon_sym_continue] = ACTIONS(2239),
    [anon_sym_goto] = ACTIONS(2239),
    [anon_sym___try] = ACTIONS(2239),
    [anon_sym___leave] = ACTIONS(2239),
    [anon_sym_not] = ACTIONS(2239),
    [anon_sym_compl] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_sizeof] = ACTIONS(2239),
    [anon_sym___alignof__] = ACTIONS(2239),
    [anon_sym___alignof] = ACTIONS(2239),
    [anon_sym__alignof] = ACTIONS(2239),
    [anon_sym_alignof] = ACTIONS(2239),
    [anon_sym__Alignof] = ACTIONS(2239),
    [anon_sym_offsetof] = ACTIONS(2239),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2239),
    [anon_sym___asm__] = ACTIONS(2239),
    [sym_number_literal] = ACTIONS(2241),
    [anon_sym_L_SQUOTE] = ACTIONS(2241),
    [anon_sym_u_SQUOTE] = ACTIONS(2241),
    [anon_sym_U_SQUOTE] = ACTIONS(2241),
    [anon_sym_u8_SQUOTE] = ACTIONS(2241),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_L_DQUOTE] = ACTIONS(2241),
    [anon_sym_u_DQUOTE] = ACTIONS(2241),
    [anon_sym_U_DQUOTE] = ACTIONS(2241),
    [anon_sym_u8_DQUOTE] = ACTIONS(2241),
    [anon_sym_DQUOTE] = ACTIONS(2241),
    [sym_true] = ACTIONS(2239),
    [sym_false] = ACTIONS(2239),
    [anon_sym_NULL] = ACTIONS(2239),
    [anon_sym_nullptr] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2239),
    [anon_sym_decltype] = ACTIONS(2239),
    [sym_virtual] = ACTIONS(2239),
    [anon_sym_explicit] = ACTIONS(2239),
    [anon_sym_typename] = ACTIONS(2239),
    [anon_sym_template] = ACTIONS(2239),
    [anon_sym_operator] = ACTIONS(2239),
    [anon_sym_try] = ACTIONS(2239),
    [anon_sym_delete] = ACTIONS(2239),
    [anon_sym_throw] = ACTIONS(2239),
    [anon_sym_namespace] = ACTIONS(2239),
    [anon_sym_using] = ACTIONS(2239),
    [anon_sym_static_assert] = ACTIONS(2239),
    [anon_sym_concept] = ACTIONS(2239),
    [anon_sym_co_return] = ACTIONS(2239),
    [anon_sym_co_yield] = ACTIONS(2239),
    [anon_sym_R_DQUOTE] = ACTIONS(2241),
    [anon_sym_LR_DQUOTE] = ACTIONS(2241),
    [anon_sym_uR_DQUOTE] = ACTIONS(2241),
    [anon_sym_UR_DQUOTE] = ACTIONS(2241),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2241),
    [anon_sym_co_await] = ACTIONS(2239),
    [anon_sym_new] = ACTIONS(2239),
    [anon_sym_requires] = ACTIONS(2239),
    [sym_this] = ACTIONS(2239),
    [anon_sym___launch_bounds__] = ACTIONS(2239),
  },
  [210] = {
    [sym_identifier] = ACTIONS(2243),
    [aux_sym_preproc_include_token1] = ACTIONS(2243),
    [aux_sym_preproc_def_token1] = ACTIONS(2243),
    [aux_sym_preproc_if_token1] = ACTIONS(2243),
    [aux_sym_preproc_if_token2] = ACTIONS(2243),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2243),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2243),
    [aux_sym_preproc_else_token1] = ACTIONS(2243),
    [aux_sym_preproc_elif_token1] = ACTIONS(2243),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2243),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2243),
    [sym_preproc_directive] = ACTIONS(2243),
    [anon_sym_LPAREN2] = ACTIONS(2245),
    [anon_sym_BANG] = ACTIONS(2245),
    [anon_sym_TILDE] = ACTIONS(2245),
    [anon_sym_DASH] = ACTIONS(2243),
    [anon_sym_PLUS] = ACTIONS(2243),
    [anon_sym_STAR] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2245),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_SEMI] = ACTIONS(2245),
    [anon_sym___extension__] = ACTIONS(2243),
    [anon_sym_typedef] = ACTIONS(2243),
    [anon_sym___device__] = ACTIONS(2243),
    [anon_sym___host__] = ACTIONS(2243),
    [anon_sym___global__] = ACTIONS(2243),
    [anon_sym___forceinline__] = ACTIONS(2243),
    [anon_sym___noinline__] = ACTIONS(2243),
    [anon_sym_extern] = ACTIONS(2243),
    [anon_sym___attribute__] = ACTIONS(2243),
    [anon_sym_COLON_COLON] = ACTIONS(2245),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2245),
    [anon_sym___declspec] = ACTIONS(2243),
    [anon_sym___based] = ACTIONS(2243),
    [anon_sym___cdecl] = ACTIONS(2243),
    [anon_sym___clrcall] = ACTIONS(2243),
    [anon_sym___stdcall] = ACTIONS(2243),
    [anon_sym___fastcall] = ACTIONS(2243),
    [anon_sym___thiscall] = ACTIONS(2243),
    [anon_sym___vectorcall] = ACTIONS(2243),
    [anon_sym_LBRACE] = ACTIONS(2245),
    [anon_sym_signed] = ACTIONS(2243),
    [anon_sym_unsigned] = ACTIONS(2243),
    [anon_sym_long] = ACTIONS(2243),
    [anon_sym_short] = ACTIONS(2243),
    [anon_sym_LBRACK] = ACTIONS(2243),
    [anon_sym_static] = ACTIONS(2243),
    [anon_sym_register] = ACTIONS(2243),
    [anon_sym_inline] = ACTIONS(2243),
    [anon_sym___inline] = ACTIONS(2243),
    [anon_sym___inline__] = ACTIONS(2243),
    [anon_sym___forceinline] = ACTIONS(2243),
    [anon_sym_thread_local] = ACTIONS(2243),
    [anon_sym___thread] = ACTIONS(2243),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2243),
    [anon_sym_volatile] = ACTIONS(2243),
    [anon_sym_restrict] = ACTIONS(2243),
    [anon_sym___restrict__] = ACTIONS(2243),
    [anon_sym__Atomic] = ACTIONS(2243),
    [anon_sym__Noreturn] = ACTIONS(2243),
    [anon_sym_noreturn] = ACTIONS(2243),
    [anon_sym_mutable] = ACTIONS(2243),
    [anon_sym_constinit] = ACTIONS(2243),
    [anon_sym_consteval] = ACTIONS(2243),
    [anon_sym___shared__] = ACTIONS(2243),
    [anon_sym___local__] = ACTIONS(2243),
    [anon_sym___constant__] = ACTIONS(2243),
    [anon_sym___managed__] = ACTIONS(2243),
    [anon_sym___grid_constant__] = ACTIONS(2243),
    [anon_sym_alignas] = ACTIONS(2243),
    [anon_sym__Alignas] = ACTIONS(2243),
    [sym_primitive_type] = ACTIONS(2243),
    [anon_sym_enum] = ACTIONS(2243),
    [anon_sym_class] = ACTIONS(2243),
    [anon_sym_struct] = ACTIONS(2243),
    [anon_sym_union] = ACTIONS(2243),
    [anon_sym_if] = ACTIONS(2243),
    [anon_sym_switch] = ACTIONS(2243),
    [anon_sym_case] = ACTIONS(2243),
    [anon_sym_default] = ACTIONS(2243),
    [anon_sym_while] = ACTIONS(2243),
    [anon_sym_do] = ACTIONS(2243),
    [anon_sym_for] = ACTIONS(2243),
    [anon_sym_return] = ACTIONS(2243),
    [anon_sym_break] = ACTIONS(2243),
    [anon_sym_continue] = ACTIONS(2243),
    [anon_sym_goto] = ACTIONS(2243),
    [anon_sym___try] = ACTIONS(2243),
    [anon_sym___leave] = ACTIONS(2243),
    [anon_sym_not] = ACTIONS(2243),
    [anon_sym_compl] = ACTIONS(2243),
    [anon_sym_DASH_DASH] = ACTIONS(2245),
    [anon_sym_PLUS_PLUS] = ACTIONS(2245),
    [anon_sym_sizeof] = ACTIONS(2243),
    [anon_sym___alignof__] = ACTIONS(2243),
    [anon_sym___alignof] = ACTIONS(2243),
    [anon_sym__alignof] = ACTIONS(2243),
    [anon_sym_alignof] = ACTIONS(2243),
    [anon_sym__Alignof] = ACTIONS(2243),
    [anon_sym_offsetof] = ACTIONS(2243),
    [anon_sym__Generic] = ACTIONS(2243),
    [anon_sym_asm] = ACTIONS(2243),
    [anon_sym___asm__] = ACTIONS(2243),
    [sym_number_literal] = ACTIONS(2245),
    [anon_sym_L_SQUOTE] = ACTIONS(2245),
    [anon_sym_u_SQUOTE] = ACTIONS(2245),
    [anon_sym_U_SQUOTE] = ACTIONS(2245),
    [anon_sym_u8_SQUOTE] = ACTIONS(2245),
    [anon_sym_SQUOTE] = ACTIONS(2245),
    [anon_sym_L_DQUOTE] = ACTIONS(2245),
    [anon_sym_u_DQUOTE] = ACTIONS(2245),
    [anon_sym_U_DQUOTE] = ACTIONS(2245),
    [anon_sym_u8_DQUOTE] = ACTIONS(2245),
    [anon_sym_DQUOTE] = ACTIONS(2245),
    [sym_true] = ACTIONS(2243),
    [sym_false] = ACTIONS(2243),
    [anon_sym_NULL] = ACTIONS(2243),
    [anon_sym_nullptr] = ACTIONS(2243),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2243),
    [anon_sym_decltype] = ACTIONS(2243),
    [sym_virtual] = ACTIONS(2243),
    [anon_sym_explicit] = ACTIONS(2243),
    [anon_sym_typename] = ACTIONS(2243),
    [anon_sym_template] = ACTIONS(2243),
    [anon_sym_operator] = ACTIONS(2243),
    [anon_sym_try] = ACTIONS(2243),
    [anon_sym_delete] = ACTIONS(2243),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_namespace] = ACTIONS(2243),
    [anon_sym_using] = ACTIONS(2243),
    [anon_sym_static_assert] = ACTIONS(2243),
    [anon_sym_concept] = ACTIONS(2243),
    [anon_sym_co_return] = ACTIONS(2243),
    [anon_sym_co_yield] = ACTIONS(2243),
    [anon_sym_R_DQUOTE] = ACTIONS(2245),
    [anon_sym_LR_DQUOTE] = ACTIONS(2245),
    [anon_sym_uR_DQUOTE] = ACTIONS(2245),
    [anon_sym_UR_DQUOTE] = ACTIONS(2245),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2245),
    [anon_sym_co_await] = ACTIONS(2243),
    [anon_sym_new] = ACTIONS(2243),
    [anon_sym_requires] = ACTIONS(2243),
    [sym_this] = ACTIONS(2243),
    [anon_sym___launch_bounds__] = ACTIONS(2243),
  },
  [211] = {
    [sym_identifier] = ACTIONS(2247),
    [aux_sym_preproc_include_token1] = ACTIONS(2247),
    [aux_sym_preproc_def_token1] = ACTIONS(2247),
    [aux_sym_preproc_if_token1] = ACTIONS(2247),
    [aux_sym_preproc_if_token2] = ACTIONS(2247),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2247),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2247),
    [aux_sym_preproc_else_token1] = ACTIONS(2247),
    [aux_sym_preproc_elif_token1] = ACTIONS(2247),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2247),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2247),
    [sym_preproc_directive] = ACTIONS(2247),
    [anon_sym_LPAREN2] = ACTIONS(2249),
    [anon_sym_BANG] = ACTIONS(2249),
    [anon_sym_TILDE] = ACTIONS(2249),
    [anon_sym_DASH] = ACTIONS(2247),
    [anon_sym_PLUS] = ACTIONS(2247),
    [anon_sym_STAR] = ACTIONS(2249),
    [anon_sym_AMP_AMP] = ACTIONS(2249),
    [anon_sym_AMP] = ACTIONS(2247),
    [anon_sym_SEMI] = ACTIONS(2249),
    [anon_sym___extension__] = ACTIONS(2247),
    [anon_sym_typedef] = ACTIONS(2247),
    [anon_sym___device__] = ACTIONS(2247),
    [anon_sym___host__] = ACTIONS(2247),
    [anon_sym___global__] = ACTIONS(2247),
    [anon_sym___forceinline__] = ACTIONS(2247),
    [anon_sym___noinline__] = ACTIONS(2247),
    [anon_sym_extern] = ACTIONS(2247),
    [anon_sym___attribute__] = ACTIONS(2247),
    [anon_sym_COLON_COLON] = ACTIONS(2249),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2249),
    [anon_sym___declspec] = ACTIONS(2247),
    [anon_sym___based] = ACTIONS(2247),
    [anon_sym___cdecl] = ACTIONS(2247),
    [anon_sym___clrcall] = ACTIONS(2247),
    [anon_sym___stdcall] = ACTIONS(2247),
    [anon_sym___fastcall] = ACTIONS(2247),
    [anon_sym___thiscall] = ACTIONS(2247),
    [anon_sym___vectorcall] = ACTIONS(2247),
    [anon_sym_LBRACE] = ACTIONS(2249),
    [anon_sym_signed] = ACTIONS(2247),
    [anon_sym_unsigned] = ACTIONS(2247),
    [anon_sym_long] = ACTIONS(2247),
    [anon_sym_short] = ACTIONS(2247),
    [anon_sym_LBRACK] = ACTIONS(2247),
    [anon_sym_static] = ACTIONS(2247),
    [anon_sym_register] = ACTIONS(2247),
    [anon_sym_inline] = ACTIONS(2247),
    [anon_sym___inline] = ACTIONS(2247),
    [anon_sym___inline__] = ACTIONS(2247),
    [anon_sym___forceinline] = ACTIONS(2247),
    [anon_sym_thread_local] = ACTIONS(2247),
    [anon_sym___thread] = ACTIONS(2247),
    [anon_sym_const] = ACTIONS(2247),
    [anon_sym_constexpr] = ACTIONS(2247),
    [anon_sym_volatile] = ACTIONS(2247),
    [anon_sym_restrict] = ACTIONS(2247),
    [anon_sym___restrict__] = ACTIONS(2247),
    [anon_sym__Atomic] = ACTIONS(2247),
    [anon_sym__Noreturn] = ACTIONS(2247),
    [anon_sym_noreturn] = ACTIONS(2247),
    [anon_sym_mutable] = ACTIONS(2247),
    [anon_sym_constinit] = ACTIONS(2247),
    [anon_sym_consteval] = ACTIONS(2247),
    [anon_sym___shared__] = ACTIONS(2247),
    [anon_sym___local__] = ACTIONS(2247),
    [anon_sym___constant__] = ACTIONS(2247),
    [anon_sym___managed__] = ACTIONS(2247),
    [anon_sym___grid_constant__] = ACTIONS(2247),
    [anon_sym_alignas] = ACTIONS(2247),
    [anon_sym__Alignas] = ACTIONS(2247),
    [sym_primitive_type] = ACTIONS(2247),
    [anon_sym_enum] = ACTIONS(2247),
    [anon_sym_class] = ACTIONS(2247),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_union] = ACTIONS(2247),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_switch] = ACTIONS(2247),
    [anon_sym_case] = ACTIONS(2247),
    [anon_sym_default] = ACTIONS(2247),
    [anon_sym_while] = ACTIONS(2247),
    [anon_sym_do] = ACTIONS(2247),
    [anon_sym_for] = ACTIONS(2247),
    [anon_sym_return] = ACTIONS(2247),
    [anon_sym_break] = ACTIONS(2247),
    [anon_sym_continue] = ACTIONS(2247),
    [anon_sym_goto] = ACTIONS(2247),
    [anon_sym___try] = ACTIONS(2247),
    [anon_sym___leave] = ACTIONS(2247),
    [anon_sym_not] = ACTIONS(2247),
    [anon_sym_compl] = ACTIONS(2247),
    [anon_sym_DASH_DASH] = ACTIONS(2249),
    [anon_sym_PLUS_PLUS] = ACTIONS(2249),
    [anon_sym_sizeof] = ACTIONS(2247),
    [anon_sym___alignof__] = ACTIONS(2247),
    [anon_sym___alignof] = ACTIONS(2247),
    [anon_sym__alignof] = ACTIONS(2247),
    [anon_sym_alignof] = ACTIONS(2247),
    [anon_sym__Alignof] = ACTIONS(2247),
    [anon_sym_offsetof] = ACTIONS(2247),
    [anon_sym__Generic] = ACTIONS(2247),
    [anon_sym_asm] = ACTIONS(2247),
    [anon_sym___asm__] = ACTIONS(2247),
    [sym_number_literal] = ACTIONS(2249),
    [anon_sym_L_SQUOTE] = ACTIONS(2249),
    [anon_sym_u_SQUOTE] = ACTIONS(2249),
    [anon_sym_U_SQUOTE] = ACTIONS(2249),
    [anon_sym_u8_SQUOTE] = ACTIONS(2249),
    [anon_sym_SQUOTE] = ACTIONS(2249),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_true] = ACTIONS(2247),
    [sym_false] = ACTIONS(2247),
    [anon_sym_NULL] = ACTIONS(2247),
    [anon_sym_nullptr] = ACTIONS(2247),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2247),
    [anon_sym_decltype] = ACTIONS(2247),
    [sym_virtual] = ACTIONS(2247),
    [anon_sym_explicit] = ACTIONS(2247),
    [anon_sym_typename] = ACTIONS(2247),
    [anon_sym_template] = ACTIONS(2247),
    [anon_sym_operator] = ACTIONS(2247),
    [anon_sym_try] = ACTIONS(2247),
    [anon_sym_delete] = ACTIONS(2247),
    [anon_sym_throw] = ACTIONS(2247),
    [anon_sym_namespace] = ACTIONS(2247),
    [anon_sym_using] = ACTIONS(2247),
    [anon_sym_static_assert] = ACTIONS(2247),
    [anon_sym_concept] = ACTIONS(2247),
    [anon_sym_co_return] = ACTIONS(2247),
    [anon_sym_co_yield] = ACTIONS(2247),
    [anon_sym_R_DQUOTE] = ACTIONS(2249),
    [anon_sym_LR_DQUOTE] = ACTIONS(2249),
    [anon_sym_uR_DQUOTE] = ACTIONS(2249),
    [anon_sym_UR_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2249),
    [anon_sym_co_await] = ACTIONS(2247),
    [anon_sym_new] = ACTIONS(2247),
    [anon_sym_requires] = ACTIONS(2247),
    [sym_this] = ACTIONS(2247),
    [anon_sym___launch_bounds__] = ACTIONS(2247),
  },
  [212] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(2958),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8293),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8786),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8784),
    [sym__unary_right_fold] = STATE(8731),
    [sym__binary_fold] = STATE(8781),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8313),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [213] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(2960),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8499),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8880),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8299),
    [sym__unary_right_fold] = STATE(8308),
    [sym__binary_fold] = STATE(8312),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8481),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [214] = {
    [sym_identifier] = ACTIONS(2251),
    [aux_sym_preproc_include_token1] = ACTIONS(2251),
    [aux_sym_preproc_def_token1] = ACTIONS(2251),
    [aux_sym_preproc_if_token1] = ACTIONS(2251),
    [aux_sym_preproc_if_token2] = ACTIONS(2251),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2251),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2251),
    [aux_sym_preproc_else_token1] = ACTIONS(2251),
    [aux_sym_preproc_elif_token1] = ACTIONS(2251),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2251),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2251),
    [sym_preproc_directive] = ACTIONS(2251),
    [anon_sym_LPAREN2] = ACTIONS(2253),
    [anon_sym_BANG] = ACTIONS(2253),
    [anon_sym_TILDE] = ACTIONS(2253),
    [anon_sym_DASH] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2251),
    [anon_sym_STAR] = ACTIONS(2253),
    [anon_sym_AMP_AMP] = ACTIONS(2253),
    [anon_sym_AMP] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(2253),
    [anon_sym___extension__] = ACTIONS(2251),
    [anon_sym_typedef] = ACTIONS(2251),
    [anon_sym___device__] = ACTIONS(2251),
    [anon_sym___host__] = ACTIONS(2251),
    [anon_sym___global__] = ACTIONS(2251),
    [anon_sym___forceinline__] = ACTIONS(2251),
    [anon_sym___noinline__] = ACTIONS(2251),
    [anon_sym_extern] = ACTIONS(2251),
    [anon_sym___attribute__] = ACTIONS(2251),
    [anon_sym_COLON_COLON] = ACTIONS(2253),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2253),
    [anon_sym___declspec] = ACTIONS(2251),
    [anon_sym___based] = ACTIONS(2251),
    [anon_sym___cdecl] = ACTIONS(2251),
    [anon_sym___clrcall] = ACTIONS(2251),
    [anon_sym___stdcall] = ACTIONS(2251),
    [anon_sym___fastcall] = ACTIONS(2251),
    [anon_sym___thiscall] = ACTIONS(2251),
    [anon_sym___vectorcall] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(2253),
    [anon_sym_signed] = ACTIONS(2251),
    [anon_sym_unsigned] = ACTIONS(2251),
    [anon_sym_long] = ACTIONS(2251),
    [anon_sym_short] = ACTIONS(2251),
    [anon_sym_LBRACK] = ACTIONS(2251),
    [anon_sym_static] = ACTIONS(2251),
    [anon_sym_register] = ACTIONS(2251),
    [anon_sym_inline] = ACTIONS(2251),
    [anon_sym___inline] = ACTIONS(2251),
    [anon_sym___inline__] = ACTIONS(2251),
    [anon_sym___forceinline] = ACTIONS(2251),
    [anon_sym_thread_local] = ACTIONS(2251),
    [anon_sym___thread] = ACTIONS(2251),
    [anon_sym_const] = ACTIONS(2251),
    [anon_sym_constexpr] = ACTIONS(2251),
    [anon_sym_volatile] = ACTIONS(2251),
    [anon_sym_restrict] = ACTIONS(2251),
    [anon_sym___restrict__] = ACTIONS(2251),
    [anon_sym__Atomic] = ACTIONS(2251),
    [anon_sym__Noreturn] = ACTIONS(2251),
    [anon_sym_noreturn] = ACTIONS(2251),
    [anon_sym_mutable] = ACTIONS(2251),
    [anon_sym_constinit] = ACTIONS(2251),
    [anon_sym_consteval] = ACTIONS(2251),
    [anon_sym___shared__] = ACTIONS(2251),
    [anon_sym___local__] = ACTIONS(2251),
    [anon_sym___constant__] = ACTIONS(2251),
    [anon_sym___managed__] = ACTIONS(2251),
    [anon_sym___grid_constant__] = ACTIONS(2251),
    [anon_sym_alignas] = ACTIONS(2251),
    [anon_sym__Alignas] = ACTIONS(2251),
    [sym_primitive_type] = ACTIONS(2251),
    [anon_sym_enum] = ACTIONS(2251),
    [anon_sym_class] = ACTIONS(2251),
    [anon_sym_struct] = ACTIONS(2251),
    [anon_sym_union] = ACTIONS(2251),
    [anon_sym_if] = ACTIONS(2251),
    [anon_sym_switch] = ACTIONS(2251),
    [anon_sym_case] = ACTIONS(2251),
    [anon_sym_default] = ACTIONS(2251),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_do] = ACTIONS(2251),
    [anon_sym_for] = ACTIONS(2251),
    [anon_sym_return] = ACTIONS(2251),
    [anon_sym_break] = ACTIONS(2251),
    [anon_sym_continue] = ACTIONS(2251),
    [anon_sym_goto] = ACTIONS(2251),
    [anon_sym___try] = ACTIONS(2251),
    [anon_sym___leave] = ACTIONS(2251),
    [anon_sym_not] = ACTIONS(2251),
    [anon_sym_compl] = ACTIONS(2251),
    [anon_sym_DASH_DASH] = ACTIONS(2253),
    [anon_sym_PLUS_PLUS] = ACTIONS(2253),
    [anon_sym_sizeof] = ACTIONS(2251),
    [anon_sym___alignof__] = ACTIONS(2251),
    [anon_sym___alignof] = ACTIONS(2251),
    [anon_sym__alignof] = ACTIONS(2251),
    [anon_sym_alignof] = ACTIONS(2251),
    [anon_sym__Alignof] = ACTIONS(2251),
    [anon_sym_offsetof] = ACTIONS(2251),
    [anon_sym__Generic] = ACTIONS(2251),
    [anon_sym_asm] = ACTIONS(2251),
    [anon_sym___asm__] = ACTIONS(2251),
    [sym_number_literal] = ACTIONS(2253),
    [anon_sym_L_SQUOTE] = ACTIONS(2253),
    [anon_sym_u_SQUOTE] = ACTIONS(2253),
    [anon_sym_U_SQUOTE] = ACTIONS(2253),
    [anon_sym_u8_SQUOTE] = ACTIONS(2253),
    [anon_sym_SQUOTE] = ACTIONS(2253),
    [anon_sym_L_DQUOTE] = ACTIONS(2253),
    [anon_sym_u_DQUOTE] = ACTIONS(2253),
    [anon_sym_U_DQUOTE] = ACTIONS(2253),
    [anon_sym_u8_DQUOTE] = ACTIONS(2253),
    [anon_sym_DQUOTE] = ACTIONS(2253),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [anon_sym_NULL] = ACTIONS(2251),
    [anon_sym_nullptr] = ACTIONS(2251),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2251),
    [anon_sym_decltype] = ACTIONS(2251),
    [sym_virtual] = ACTIONS(2251),
    [anon_sym_explicit] = ACTIONS(2251),
    [anon_sym_typename] = ACTIONS(2251),
    [anon_sym_template] = ACTIONS(2251),
    [anon_sym_operator] = ACTIONS(2251),
    [anon_sym_try] = ACTIONS(2251),
    [anon_sym_delete] = ACTIONS(2251),
    [anon_sym_throw] = ACTIONS(2251),
    [anon_sym_namespace] = ACTIONS(2251),
    [anon_sym_using] = ACTIONS(2251),
    [anon_sym_static_assert] = ACTIONS(2251),
    [anon_sym_concept] = ACTIONS(2251),
    [anon_sym_co_return] = ACTIONS(2251),
    [anon_sym_co_yield] = ACTIONS(2251),
    [anon_sym_R_DQUOTE] = ACTIONS(2253),
    [anon_sym_LR_DQUOTE] = ACTIONS(2253),
    [anon_sym_uR_DQUOTE] = ACTIONS(2253),
    [anon_sym_UR_DQUOTE] = ACTIONS(2253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2253),
    [anon_sym_co_await] = ACTIONS(2251),
    [anon_sym_new] = ACTIONS(2251),
    [anon_sym_requires] = ACTIONS(2251),
    [sym_this] = ACTIONS(2251),
    [anon_sym___launch_bounds__] = ACTIONS(2251),
  },
  [215] = {
    [sym_identifier] = ACTIONS(2255),
    [aux_sym_preproc_include_token1] = ACTIONS(2255),
    [aux_sym_preproc_def_token1] = ACTIONS(2255),
    [aux_sym_preproc_if_token1] = ACTIONS(2255),
    [aux_sym_preproc_if_token2] = ACTIONS(2255),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2255),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2255),
    [aux_sym_preproc_else_token1] = ACTIONS(2255),
    [aux_sym_preproc_elif_token1] = ACTIONS(2255),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2255),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2255),
    [sym_preproc_directive] = ACTIONS(2255),
    [anon_sym_LPAREN2] = ACTIONS(2257),
    [anon_sym_BANG] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2257),
    [anon_sym_AMP_AMP] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2255),
    [anon_sym_SEMI] = ACTIONS(2257),
    [anon_sym___extension__] = ACTIONS(2255),
    [anon_sym_typedef] = ACTIONS(2255),
    [anon_sym___device__] = ACTIONS(2255),
    [anon_sym___host__] = ACTIONS(2255),
    [anon_sym___global__] = ACTIONS(2255),
    [anon_sym___forceinline__] = ACTIONS(2255),
    [anon_sym___noinline__] = ACTIONS(2255),
    [anon_sym_extern] = ACTIONS(2255),
    [anon_sym___attribute__] = ACTIONS(2255),
    [anon_sym_COLON_COLON] = ACTIONS(2257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2257),
    [anon_sym___declspec] = ACTIONS(2255),
    [anon_sym___based] = ACTIONS(2255),
    [anon_sym___cdecl] = ACTIONS(2255),
    [anon_sym___clrcall] = ACTIONS(2255),
    [anon_sym___stdcall] = ACTIONS(2255),
    [anon_sym___fastcall] = ACTIONS(2255),
    [anon_sym___thiscall] = ACTIONS(2255),
    [anon_sym___vectorcall] = ACTIONS(2255),
    [anon_sym_LBRACE] = ACTIONS(2257),
    [anon_sym_signed] = ACTIONS(2255),
    [anon_sym_unsigned] = ACTIONS(2255),
    [anon_sym_long] = ACTIONS(2255),
    [anon_sym_short] = ACTIONS(2255),
    [anon_sym_LBRACK] = ACTIONS(2255),
    [anon_sym_static] = ACTIONS(2255),
    [anon_sym_register] = ACTIONS(2255),
    [anon_sym_inline] = ACTIONS(2255),
    [anon_sym___inline] = ACTIONS(2255),
    [anon_sym___inline__] = ACTIONS(2255),
    [anon_sym___forceinline] = ACTIONS(2255),
    [anon_sym_thread_local] = ACTIONS(2255),
    [anon_sym___thread] = ACTIONS(2255),
    [anon_sym_const] = ACTIONS(2255),
    [anon_sym_constexpr] = ACTIONS(2255),
    [anon_sym_volatile] = ACTIONS(2255),
    [anon_sym_restrict] = ACTIONS(2255),
    [anon_sym___restrict__] = ACTIONS(2255),
    [anon_sym__Atomic] = ACTIONS(2255),
    [anon_sym__Noreturn] = ACTIONS(2255),
    [anon_sym_noreturn] = ACTIONS(2255),
    [anon_sym_mutable] = ACTIONS(2255),
    [anon_sym_constinit] = ACTIONS(2255),
    [anon_sym_consteval] = ACTIONS(2255),
    [anon_sym___shared__] = ACTIONS(2255),
    [anon_sym___local__] = ACTIONS(2255),
    [anon_sym___constant__] = ACTIONS(2255),
    [anon_sym___managed__] = ACTIONS(2255),
    [anon_sym___grid_constant__] = ACTIONS(2255),
    [anon_sym_alignas] = ACTIONS(2255),
    [anon_sym__Alignas] = ACTIONS(2255),
    [sym_primitive_type] = ACTIONS(2255),
    [anon_sym_enum] = ACTIONS(2255),
    [anon_sym_class] = ACTIONS(2255),
    [anon_sym_struct] = ACTIONS(2255),
    [anon_sym_union] = ACTIONS(2255),
    [anon_sym_if] = ACTIONS(2255),
    [anon_sym_switch] = ACTIONS(2255),
    [anon_sym_case] = ACTIONS(2255),
    [anon_sym_default] = ACTIONS(2255),
    [anon_sym_while] = ACTIONS(2255),
    [anon_sym_do] = ACTIONS(2255),
    [anon_sym_for] = ACTIONS(2255),
    [anon_sym_return] = ACTIONS(2255),
    [anon_sym_break] = ACTIONS(2255),
    [anon_sym_continue] = ACTIONS(2255),
    [anon_sym_goto] = ACTIONS(2255),
    [anon_sym___try] = ACTIONS(2255),
    [anon_sym___leave] = ACTIONS(2255),
    [anon_sym_not] = ACTIONS(2255),
    [anon_sym_compl] = ACTIONS(2255),
    [anon_sym_DASH_DASH] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2257),
    [anon_sym_sizeof] = ACTIONS(2255),
    [anon_sym___alignof__] = ACTIONS(2255),
    [anon_sym___alignof] = ACTIONS(2255),
    [anon_sym__alignof] = ACTIONS(2255),
    [anon_sym_alignof] = ACTIONS(2255),
    [anon_sym__Alignof] = ACTIONS(2255),
    [anon_sym_offsetof] = ACTIONS(2255),
    [anon_sym__Generic] = ACTIONS(2255),
    [anon_sym_asm] = ACTIONS(2255),
    [anon_sym___asm__] = ACTIONS(2255),
    [sym_number_literal] = ACTIONS(2257),
    [anon_sym_L_SQUOTE] = ACTIONS(2257),
    [anon_sym_u_SQUOTE] = ACTIONS(2257),
    [anon_sym_U_SQUOTE] = ACTIONS(2257),
    [anon_sym_u8_SQUOTE] = ACTIONS(2257),
    [anon_sym_SQUOTE] = ACTIONS(2257),
    [anon_sym_L_DQUOTE] = ACTIONS(2257),
    [anon_sym_u_DQUOTE] = ACTIONS(2257),
    [anon_sym_U_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8_DQUOTE] = ACTIONS(2257),
    [anon_sym_DQUOTE] = ACTIONS(2257),
    [sym_true] = ACTIONS(2255),
    [sym_false] = ACTIONS(2255),
    [anon_sym_NULL] = ACTIONS(2255),
    [anon_sym_nullptr] = ACTIONS(2255),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2255),
    [anon_sym_decltype] = ACTIONS(2255),
    [sym_virtual] = ACTIONS(2255),
    [anon_sym_explicit] = ACTIONS(2255),
    [anon_sym_typename] = ACTIONS(2255),
    [anon_sym_template] = ACTIONS(2255),
    [anon_sym_operator] = ACTIONS(2255),
    [anon_sym_try] = ACTIONS(2255),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_throw] = ACTIONS(2255),
    [anon_sym_namespace] = ACTIONS(2255),
    [anon_sym_using] = ACTIONS(2255),
    [anon_sym_static_assert] = ACTIONS(2255),
    [anon_sym_concept] = ACTIONS(2255),
    [anon_sym_co_return] = ACTIONS(2255),
    [anon_sym_co_yield] = ACTIONS(2255),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [anon_sym_co_await] = ACTIONS(2255),
    [anon_sym_new] = ACTIONS(2255),
    [anon_sym_requires] = ACTIONS(2255),
    [sym_this] = ACTIONS(2255),
    [anon_sym___launch_bounds__] = ACTIONS(2255),
  },
  [216] = {
    [sym_identifier] = ACTIONS(2259),
    [aux_sym_preproc_include_token1] = ACTIONS(2259),
    [aux_sym_preproc_def_token1] = ACTIONS(2259),
    [aux_sym_preproc_if_token1] = ACTIONS(2259),
    [aux_sym_preproc_if_token2] = ACTIONS(2259),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2259),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2259),
    [aux_sym_preproc_else_token1] = ACTIONS(2259),
    [aux_sym_preproc_elif_token1] = ACTIONS(2259),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2259),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2259),
    [sym_preproc_directive] = ACTIONS(2259),
    [anon_sym_LPAREN2] = ACTIONS(2261),
    [anon_sym_BANG] = ACTIONS(2261),
    [anon_sym_TILDE] = ACTIONS(2261),
    [anon_sym_DASH] = ACTIONS(2259),
    [anon_sym_PLUS] = ACTIONS(2259),
    [anon_sym_STAR] = ACTIONS(2261),
    [anon_sym_AMP_AMP] = ACTIONS(2261),
    [anon_sym_AMP] = ACTIONS(2259),
    [anon_sym_SEMI] = ACTIONS(2261),
    [anon_sym___extension__] = ACTIONS(2259),
    [anon_sym_typedef] = ACTIONS(2259),
    [anon_sym___device__] = ACTIONS(2259),
    [anon_sym___host__] = ACTIONS(2259),
    [anon_sym___global__] = ACTIONS(2259),
    [anon_sym___forceinline__] = ACTIONS(2259),
    [anon_sym___noinline__] = ACTIONS(2259),
    [anon_sym_extern] = ACTIONS(2259),
    [anon_sym___attribute__] = ACTIONS(2259),
    [anon_sym_COLON_COLON] = ACTIONS(2261),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2261),
    [anon_sym___declspec] = ACTIONS(2259),
    [anon_sym___based] = ACTIONS(2259),
    [anon_sym___cdecl] = ACTIONS(2259),
    [anon_sym___clrcall] = ACTIONS(2259),
    [anon_sym___stdcall] = ACTIONS(2259),
    [anon_sym___fastcall] = ACTIONS(2259),
    [anon_sym___thiscall] = ACTIONS(2259),
    [anon_sym___vectorcall] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(2261),
    [anon_sym_signed] = ACTIONS(2259),
    [anon_sym_unsigned] = ACTIONS(2259),
    [anon_sym_long] = ACTIONS(2259),
    [anon_sym_short] = ACTIONS(2259),
    [anon_sym_LBRACK] = ACTIONS(2259),
    [anon_sym_static] = ACTIONS(2259),
    [anon_sym_register] = ACTIONS(2259),
    [anon_sym_inline] = ACTIONS(2259),
    [anon_sym___inline] = ACTIONS(2259),
    [anon_sym___inline__] = ACTIONS(2259),
    [anon_sym___forceinline] = ACTIONS(2259),
    [anon_sym_thread_local] = ACTIONS(2259),
    [anon_sym___thread] = ACTIONS(2259),
    [anon_sym_const] = ACTIONS(2259),
    [anon_sym_constexpr] = ACTIONS(2259),
    [anon_sym_volatile] = ACTIONS(2259),
    [anon_sym_restrict] = ACTIONS(2259),
    [anon_sym___restrict__] = ACTIONS(2259),
    [anon_sym__Atomic] = ACTIONS(2259),
    [anon_sym__Noreturn] = ACTIONS(2259),
    [anon_sym_noreturn] = ACTIONS(2259),
    [anon_sym_mutable] = ACTIONS(2259),
    [anon_sym_constinit] = ACTIONS(2259),
    [anon_sym_consteval] = ACTIONS(2259),
    [anon_sym___shared__] = ACTIONS(2259),
    [anon_sym___local__] = ACTIONS(2259),
    [anon_sym___constant__] = ACTIONS(2259),
    [anon_sym___managed__] = ACTIONS(2259),
    [anon_sym___grid_constant__] = ACTIONS(2259),
    [anon_sym_alignas] = ACTIONS(2259),
    [anon_sym__Alignas] = ACTIONS(2259),
    [sym_primitive_type] = ACTIONS(2259),
    [anon_sym_enum] = ACTIONS(2259),
    [anon_sym_class] = ACTIONS(2259),
    [anon_sym_struct] = ACTIONS(2259),
    [anon_sym_union] = ACTIONS(2259),
    [anon_sym_if] = ACTIONS(2259),
    [anon_sym_switch] = ACTIONS(2259),
    [anon_sym_case] = ACTIONS(2259),
    [anon_sym_default] = ACTIONS(2259),
    [anon_sym_while] = ACTIONS(2259),
    [anon_sym_do] = ACTIONS(2259),
    [anon_sym_for] = ACTIONS(2259),
    [anon_sym_return] = ACTIONS(2259),
    [anon_sym_break] = ACTIONS(2259),
    [anon_sym_continue] = ACTIONS(2259),
    [anon_sym_goto] = ACTIONS(2259),
    [anon_sym___try] = ACTIONS(2259),
    [anon_sym___leave] = ACTIONS(2259),
    [anon_sym_not] = ACTIONS(2259),
    [anon_sym_compl] = ACTIONS(2259),
    [anon_sym_DASH_DASH] = ACTIONS(2261),
    [anon_sym_PLUS_PLUS] = ACTIONS(2261),
    [anon_sym_sizeof] = ACTIONS(2259),
    [anon_sym___alignof__] = ACTIONS(2259),
    [anon_sym___alignof] = ACTIONS(2259),
    [anon_sym__alignof] = ACTIONS(2259),
    [anon_sym_alignof] = ACTIONS(2259),
    [anon_sym__Alignof] = ACTIONS(2259),
    [anon_sym_offsetof] = ACTIONS(2259),
    [anon_sym__Generic] = ACTIONS(2259),
    [anon_sym_asm] = ACTIONS(2259),
    [anon_sym___asm__] = ACTIONS(2259),
    [sym_number_literal] = ACTIONS(2261),
    [anon_sym_L_SQUOTE] = ACTIONS(2261),
    [anon_sym_u_SQUOTE] = ACTIONS(2261),
    [anon_sym_U_SQUOTE] = ACTIONS(2261),
    [anon_sym_u8_SQUOTE] = ACTIONS(2261),
    [anon_sym_SQUOTE] = ACTIONS(2261),
    [anon_sym_L_DQUOTE] = ACTIONS(2261),
    [anon_sym_u_DQUOTE] = ACTIONS(2261),
    [anon_sym_U_DQUOTE] = ACTIONS(2261),
    [anon_sym_u8_DQUOTE] = ACTIONS(2261),
    [anon_sym_DQUOTE] = ACTIONS(2261),
    [sym_true] = ACTIONS(2259),
    [sym_false] = ACTIONS(2259),
    [anon_sym_NULL] = ACTIONS(2259),
    [anon_sym_nullptr] = ACTIONS(2259),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2259),
    [anon_sym_decltype] = ACTIONS(2259),
    [sym_virtual] = ACTIONS(2259),
    [anon_sym_explicit] = ACTIONS(2259),
    [anon_sym_typename] = ACTIONS(2259),
    [anon_sym_template] = ACTIONS(2259),
    [anon_sym_operator] = ACTIONS(2259),
    [anon_sym_try] = ACTIONS(2259),
    [anon_sym_delete] = ACTIONS(2259),
    [anon_sym_throw] = ACTIONS(2259),
    [anon_sym_namespace] = ACTIONS(2259),
    [anon_sym_using] = ACTIONS(2259),
    [anon_sym_static_assert] = ACTIONS(2259),
    [anon_sym_concept] = ACTIONS(2259),
    [anon_sym_co_return] = ACTIONS(2259),
    [anon_sym_co_yield] = ACTIONS(2259),
    [anon_sym_R_DQUOTE] = ACTIONS(2261),
    [anon_sym_LR_DQUOTE] = ACTIONS(2261),
    [anon_sym_uR_DQUOTE] = ACTIONS(2261),
    [anon_sym_UR_DQUOTE] = ACTIONS(2261),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2261),
    [anon_sym_co_await] = ACTIONS(2259),
    [anon_sym_new] = ACTIONS(2259),
    [anon_sym_requires] = ACTIONS(2259),
    [sym_this] = ACTIONS(2259),
    [anon_sym___launch_bounds__] = ACTIONS(2259),
  },
  [217] = {
    [sym_preproc_def] = STATE(184),
    [sym_preproc_function_def] = STATE(184),
    [sym_preproc_call] = STATE(184),
    [sym_preproc_if_in_field_declaration_list] = STATE(184),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(184),
    [sym_preproc_else_in_field_declaration_list] = STATE(8624),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8624),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8624),
    [sym_type_definition] = STATE(184),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5944),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6464),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(184),
    [sym_field_declaration] = STATE(184),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1701),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(184),
    [sym_operator_cast] = STATE(6994),
    [sym_inline_method_definition] = STATE(184),
    [sym__constructor_specifiers] = STATE(1701),
    [sym_operator_cast_definition] = STATE(184),
    [sym_operator_cast_declaration] = STATE(184),
    [sym_constructor_or_destructor_definition] = STATE(184),
    [sym_constructor_or_destructor_declaration] = STATE(184),
    [sym_friend_declaration] = STATE(184),
    [sym_access_specifier] = STATE(9001),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(184),
    [sym_alias_declaration] = STATE(184),
    [sym_static_assert_declaration] = STATE(184),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6994),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(184),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1701),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(2100),
    [aux_sym_preproc_if_token1] = ACTIONS(2102),
    [aux_sym_preproc_if_token2] = ACTIONS(2263),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2106),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2106),
    [aux_sym_preproc_else_token1] = ACTIONS(2108),
    [aux_sym_preproc_elif_token1] = ACTIONS(2110),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2112),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2112),
    [sym_preproc_directive] = ACTIONS(2114),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(2124),
    [anon_sym_typedef] = ACTIONS(2126),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(2144),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2146),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(2150),
    [anon_sym_static_assert] = ACTIONS(2152),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [218] = {
    [sym_preproc_def] = STATE(202),
    [sym_preproc_function_def] = STATE(202),
    [sym_preproc_call] = STATE(202),
    [sym_preproc_if_in_field_declaration_list] = STATE(202),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(202),
    [sym_preproc_else_in_field_declaration_list] = STATE(9064),
    [sym_preproc_elif_in_field_declaration_list] = STATE(9064),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(9064),
    [sym_type_definition] = STATE(202),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5944),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6464),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(202),
    [sym_field_declaration] = STATE(202),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1701),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(202),
    [sym_operator_cast] = STATE(6994),
    [sym_inline_method_definition] = STATE(202),
    [sym__constructor_specifiers] = STATE(1701),
    [sym_operator_cast_definition] = STATE(202),
    [sym_operator_cast_declaration] = STATE(202),
    [sym_constructor_or_destructor_definition] = STATE(202),
    [sym_constructor_or_destructor_declaration] = STATE(202),
    [sym_friend_declaration] = STATE(202),
    [sym_access_specifier] = STATE(9001),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(202),
    [sym_alias_declaration] = STATE(202),
    [sym_static_assert_declaration] = STATE(202),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6994),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(202),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1701),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(2100),
    [aux_sym_preproc_if_token1] = ACTIONS(2102),
    [aux_sym_preproc_if_token2] = ACTIONS(2265),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2106),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2106),
    [aux_sym_preproc_else_token1] = ACTIONS(2108),
    [aux_sym_preproc_elif_token1] = ACTIONS(2110),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2112),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2112),
    [sym_preproc_directive] = ACTIONS(2114),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(2124),
    [anon_sym_typedef] = ACTIONS(2126),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(2144),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2146),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(2150),
    [anon_sym_static_assert] = ACTIONS(2152),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [219] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_include_token1] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token2] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [aux_sym_preproc_else_token1] = ACTIONS(2267),
    [aux_sym_preproc_elif_token1] = ACTIONS(2267),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2269),
    [anon_sym_BANG] = ACTIONS(2269),
    [anon_sym_TILDE] = ACTIONS(2269),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_STAR] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(2269),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym___device__] = ACTIONS(2267),
    [anon_sym___host__] = ACTIONS(2267),
    [anon_sym___global__] = ACTIONS(2267),
    [anon_sym___forceinline__] = ACTIONS(2267),
    [anon_sym___noinline__] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2269),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2269),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym___cdecl] = ACTIONS(2267),
    [anon_sym___clrcall] = ACTIONS(2267),
    [anon_sym___stdcall] = ACTIONS(2267),
    [anon_sym___fastcall] = ACTIONS(2267),
    [anon_sym___thiscall] = ACTIONS(2267),
    [anon_sym___vectorcall] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2269),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym___shared__] = ACTIONS(2267),
    [anon_sym___local__] = ACTIONS(2267),
    [anon_sym___constant__] = ACTIONS(2267),
    [anon_sym___managed__] = ACTIONS(2267),
    [anon_sym___grid_constant__] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym__Alignas] = ACTIONS(2267),
    [sym_primitive_type] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_switch] = ACTIONS(2267),
    [anon_sym_case] = ACTIONS(2267),
    [anon_sym_default] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_for] = ACTIONS(2267),
    [anon_sym_return] = ACTIONS(2267),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_continue] = ACTIONS(2267),
    [anon_sym_goto] = ACTIONS(2267),
    [anon_sym___try] = ACTIONS(2267),
    [anon_sym___leave] = ACTIONS(2267),
    [anon_sym_not] = ACTIONS(2267),
    [anon_sym_compl] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2269),
    [anon_sym_PLUS_PLUS] = ACTIONS(2269),
    [anon_sym_sizeof] = ACTIONS(2267),
    [anon_sym___alignof__] = ACTIONS(2267),
    [anon_sym___alignof] = ACTIONS(2267),
    [anon_sym__alignof] = ACTIONS(2267),
    [anon_sym_alignof] = ACTIONS(2267),
    [anon_sym__Alignof] = ACTIONS(2267),
    [anon_sym_offsetof] = ACTIONS(2267),
    [anon_sym__Generic] = ACTIONS(2267),
    [anon_sym_asm] = ACTIONS(2267),
    [anon_sym___asm__] = ACTIONS(2267),
    [sym_number_literal] = ACTIONS(2269),
    [anon_sym_L_SQUOTE] = ACTIONS(2269),
    [anon_sym_u_SQUOTE] = ACTIONS(2269),
    [anon_sym_U_SQUOTE] = ACTIONS(2269),
    [anon_sym_u8_SQUOTE] = ACTIONS(2269),
    [anon_sym_SQUOTE] = ACTIONS(2269),
    [anon_sym_L_DQUOTE] = ACTIONS(2269),
    [anon_sym_u_DQUOTE] = ACTIONS(2269),
    [anon_sym_U_DQUOTE] = ACTIONS(2269),
    [anon_sym_u8_DQUOTE] = ACTIONS(2269),
    [anon_sym_DQUOTE] = ACTIONS(2269),
    [sym_true] = ACTIONS(2267),
    [sym_false] = ACTIONS(2267),
    [anon_sym_NULL] = ACTIONS(2267),
    [anon_sym_nullptr] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [sym_virtual] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_try] = ACTIONS(2267),
    [anon_sym_delete] = ACTIONS(2267),
    [anon_sym_throw] = ACTIONS(2267),
    [anon_sym_namespace] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym_concept] = ACTIONS(2267),
    [anon_sym_co_return] = ACTIONS(2267),
    [anon_sym_co_yield] = ACTIONS(2267),
    [anon_sym_R_DQUOTE] = ACTIONS(2269),
    [anon_sym_LR_DQUOTE] = ACTIONS(2269),
    [anon_sym_uR_DQUOTE] = ACTIONS(2269),
    [anon_sym_UR_DQUOTE] = ACTIONS(2269),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2269),
    [anon_sym_co_await] = ACTIONS(2267),
    [anon_sym_new] = ACTIONS(2267),
    [anon_sym_requires] = ACTIONS(2267),
    [sym_this] = ACTIONS(2267),
    [anon_sym___launch_bounds__] = ACTIONS(2267),
  },
  [220] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_include_token1] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token2] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [aux_sym_preproc_else_token1] = ACTIONS(2267),
    [aux_sym_preproc_elif_token1] = ACTIONS(2267),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2269),
    [anon_sym_BANG] = ACTIONS(2269),
    [anon_sym_TILDE] = ACTIONS(2269),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_STAR] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(2269),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym___device__] = ACTIONS(2267),
    [anon_sym___host__] = ACTIONS(2267),
    [anon_sym___global__] = ACTIONS(2267),
    [anon_sym___forceinline__] = ACTIONS(2267),
    [anon_sym___noinline__] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2269),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2269),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym___cdecl] = ACTIONS(2267),
    [anon_sym___clrcall] = ACTIONS(2267),
    [anon_sym___stdcall] = ACTIONS(2267),
    [anon_sym___fastcall] = ACTIONS(2267),
    [anon_sym___thiscall] = ACTIONS(2267),
    [anon_sym___vectorcall] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2269),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym___shared__] = ACTIONS(2267),
    [anon_sym___local__] = ACTIONS(2267),
    [anon_sym___constant__] = ACTIONS(2267),
    [anon_sym___managed__] = ACTIONS(2267),
    [anon_sym___grid_constant__] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym__Alignas] = ACTIONS(2267),
    [sym_primitive_type] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_switch] = ACTIONS(2267),
    [anon_sym_case] = ACTIONS(2267),
    [anon_sym_default] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_for] = ACTIONS(2267),
    [anon_sym_return] = ACTIONS(2267),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_continue] = ACTIONS(2267),
    [anon_sym_goto] = ACTIONS(2267),
    [anon_sym___try] = ACTIONS(2267),
    [anon_sym___leave] = ACTIONS(2267),
    [anon_sym_not] = ACTIONS(2267),
    [anon_sym_compl] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2269),
    [anon_sym_PLUS_PLUS] = ACTIONS(2269),
    [anon_sym_sizeof] = ACTIONS(2267),
    [anon_sym___alignof__] = ACTIONS(2267),
    [anon_sym___alignof] = ACTIONS(2267),
    [anon_sym__alignof] = ACTIONS(2267),
    [anon_sym_alignof] = ACTIONS(2267),
    [anon_sym__Alignof] = ACTIONS(2267),
    [anon_sym_offsetof] = ACTIONS(2267),
    [anon_sym__Generic] = ACTIONS(2267),
    [anon_sym_asm] = ACTIONS(2267),
    [anon_sym___asm__] = ACTIONS(2267),
    [sym_number_literal] = ACTIONS(2269),
    [anon_sym_L_SQUOTE] = ACTIONS(2269),
    [anon_sym_u_SQUOTE] = ACTIONS(2269),
    [anon_sym_U_SQUOTE] = ACTIONS(2269),
    [anon_sym_u8_SQUOTE] = ACTIONS(2269),
    [anon_sym_SQUOTE] = ACTIONS(2269),
    [anon_sym_L_DQUOTE] = ACTIONS(2269),
    [anon_sym_u_DQUOTE] = ACTIONS(2269),
    [anon_sym_U_DQUOTE] = ACTIONS(2269),
    [anon_sym_u8_DQUOTE] = ACTIONS(2269),
    [anon_sym_DQUOTE] = ACTIONS(2269),
    [sym_true] = ACTIONS(2267),
    [sym_false] = ACTIONS(2267),
    [anon_sym_NULL] = ACTIONS(2267),
    [anon_sym_nullptr] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [sym_virtual] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_try] = ACTIONS(2267),
    [anon_sym_delete] = ACTIONS(2267),
    [anon_sym_throw] = ACTIONS(2267),
    [anon_sym_namespace] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym_concept] = ACTIONS(2267),
    [anon_sym_co_return] = ACTIONS(2267),
    [anon_sym_co_yield] = ACTIONS(2267),
    [anon_sym_R_DQUOTE] = ACTIONS(2269),
    [anon_sym_LR_DQUOTE] = ACTIONS(2269),
    [anon_sym_uR_DQUOTE] = ACTIONS(2269),
    [anon_sym_UR_DQUOTE] = ACTIONS(2269),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2269),
    [anon_sym_co_await] = ACTIONS(2267),
    [anon_sym_new] = ACTIONS(2267),
    [anon_sym_requires] = ACTIONS(2267),
    [sym_this] = ACTIONS(2267),
    [anon_sym___launch_bounds__] = ACTIONS(2267),
  },
  [221] = {
    [sym_identifier] = ACTIONS(2271),
    [aux_sym_preproc_include_token1] = ACTIONS(2271),
    [aux_sym_preproc_def_token1] = ACTIONS(2271),
    [aux_sym_preproc_if_token1] = ACTIONS(2271),
    [aux_sym_preproc_if_token2] = ACTIONS(2271),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2271),
    [aux_sym_preproc_else_token1] = ACTIONS(2271),
    [aux_sym_preproc_elif_token1] = ACTIONS(2271),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2271),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2271),
    [sym_preproc_directive] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2273),
    [anon_sym_TILDE] = ACTIONS(2273),
    [anon_sym_DASH] = ACTIONS(2271),
    [anon_sym_PLUS] = ACTIONS(2271),
    [anon_sym_STAR] = ACTIONS(2273),
    [anon_sym_AMP_AMP] = ACTIONS(2273),
    [anon_sym_AMP] = ACTIONS(2271),
    [anon_sym_SEMI] = ACTIONS(2273),
    [anon_sym___extension__] = ACTIONS(2271),
    [anon_sym_typedef] = ACTIONS(2271),
    [anon_sym___device__] = ACTIONS(2271),
    [anon_sym___host__] = ACTIONS(2271),
    [anon_sym___global__] = ACTIONS(2271),
    [anon_sym___forceinline__] = ACTIONS(2271),
    [anon_sym___noinline__] = ACTIONS(2271),
    [anon_sym_extern] = ACTIONS(2271),
    [anon_sym___attribute__] = ACTIONS(2271),
    [anon_sym_COLON_COLON] = ACTIONS(2273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2273),
    [anon_sym___declspec] = ACTIONS(2271),
    [anon_sym___based] = ACTIONS(2271),
    [anon_sym___cdecl] = ACTIONS(2271),
    [anon_sym___clrcall] = ACTIONS(2271),
    [anon_sym___stdcall] = ACTIONS(2271),
    [anon_sym___fastcall] = ACTIONS(2271),
    [anon_sym___thiscall] = ACTIONS(2271),
    [anon_sym___vectorcall] = ACTIONS(2271),
    [anon_sym_LBRACE] = ACTIONS(2273),
    [anon_sym_signed] = ACTIONS(2271),
    [anon_sym_unsigned] = ACTIONS(2271),
    [anon_sym_long] = ACTIONS(2271),
    [anon_sym_short] = ACTIONS(2271),
    [anon_sym_LBRACK] = ACTIONS(2271),
    [anon_sym_static] = ACTIONS(2271),
    [anon_sym_register] = ACTIONS(2271),
    [anon_sym_inline] = ACTIONS(2271),
    [anon_sym___inline] = ACTIONS(2271),
    [anon_sym___inline__] = ACTIONS(2271),
    [anon_sym___forceinline] = ACTIONS(2271),
    [anon_sym_thread_local] = ACTIONS(2271),
    [anon_sym___thread] = ACTIONS(2271),
    [anon_sym_const] = ACTIONS(2271),
    [anon_sym_constexpr] = ACTIONS(2271),
    [anon_sym_volatile] = ACTIONS(2271),
    [anon_sym_restrict] = ACTIONS(2271),
    [anon_sym___restrict__] = ACTIONS(2271),
    [anon_sym__Atomic] = ACTIONS(2271),
    [anon_sym__Noreturn] = ACTIONS(2271),
    [anon_sym_noreturn] = ACTIONS(2271),
    [anon_sym_mutable] = ACTIONS(2271),
    [anon_sym_constinit] = ACTIONS(2271),
    [anon_sym_consteval] = ACTIONS(2271),
    [anon_sym___shared__] = ACTIONS(2271),
    [anon_sym___local__] = ACTIONS(2271),
    [anon_sym___constant__] = ACTIONS(2271),
    [anon_sym___managed__] = ACTIONS(2271),
    [anon_sym___grid_constant__] = ACTIONS(2271),
    [anon_sym_alignas] = ACTIONS(2271),
    [anon_sym__Alignas] = ACTIONS(2271),
    [sym_primitive_type] = ACTIONS(2271),
    [anon_sym_enum] = ACTIONS(2271),
    [anon_sym_class] = ACTIONS(2271),
    [anon_sym_struct] = ACTIONS(2271),
    [anon_sym_union] = ACTIONS(2271),
    [anon_sym_if] = ACTIONS(2271),
    [anon_sym_switch] = ACTIONS(2271),
    [anon_sym_case] = ACTIONS(2271),
    [anon_sym_default] = ACTIONS(2271),
    [anon_sym_while] = ACTIONS(2271),
    [anon_sym_do] = ACTIONS(2271),
    [anon_sym_for] = ACTIONS(2271),
    [anon_sym_return] = ACTIONS(2271),
    [anon_sym_break] = ACTIONS(2271),
    [anon_sym_continue] = ACTIONS(2271),
    [anon_sym_goto] = ACTIONS(2271),
    [anon_sym___try] = ACTIONS(2271),
    [anon_sym___leave] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2271),
    [anon_sym_compl] = ACTIONS(2271),
    [anon_sym_DASH_DASH] = ACTIONS(2273),
    [anon_sym_PLUS_PLUS] = ACTIONS(2273),
    [anon_sym_sizeof] = ACTIONS(2271),
    [anon_sym___alignof__] = ACTIONS(2271),
    [anon_sym___alignof] = ACTIONS(2271),
    [anon_sym__alignof] = ACTIONS(2271),
    [anon_sym_alignof] = ACTIONS(2271),
    [anon_sym__Alignof] = ACTIONS(2271),
    [anon_sym_offsetof] = ACTIONS(2271),
    [anon_sym__Generic] = ACTIONS(2271),
    [anon_sym_asm] = ACTIONS(2271),
    [anon_sym___asm__] = ACTIONS(2271),
    [sym_number_literal] = ACTIONS(2273),
    [anon_sym_L_SQUOTE] = ACTIONS(2273),
    [anon_sym_u_SQUOTE] = ACTIONS(2273),
    [anon_sym_U_SQUOTE] = ACTIONS(2273),
    [anon_sym_u8_SQUOTE] = ACTIONS(2273),
    [anon_sym_SQUOTE] = ACTIONS(2273),
    [anon_sym_L_DQUOTE] = ACTIONS(2273),
    [anon_sym_u_DQUOTE] = ACTIONS(2273),
    [anon_sym_U_DQUOTE] = ACTIONS(2273),
    [anon_sym_u8_DQUOTE] = ACTIONS(2273),
    [anon_sym_DQUOTE] = ACTIONS(2273),
    [sym_true] = ACTIONS(2271),
    [sym_false] = ACTIONS(2271),
    [anon_sym_NULL] = ACTIONS(2271),
    [anon_sym_nullptr] = ACTIONS(2271),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2271),
    [anon_sym_decltype] = ACTIONS(2271),
    [sym_virtual] = ACTIONS(2271),
    [anon_sym_explicit] = ACTIONS(2271),
    [anon_sym_typename] = ACTIONS(2271),
    [anon_sym_template] = ACTIONS(2271),
    [anon_sym_operator] = ACTIONS(2271),
    [anon_sym_try] = ACTIONS(2271),
    [anon_sym_delete] = ACTIONS(2271),
    [anon_sym_throw] = ACTIONS(2271),
    [anon_sym_namespace] = ACTIONS(2271),
    [anon_sym_using] = ACTIONS(2271),
    [anon_sym_static_assert] = ACTIONS(2271),
    [anon_sym_concept] = ACTIONS(2271),
    [anon_sym_co_return] = ACTIONS(2271),
    [anon_sym_co_yield] = ACTIONS(2271),
    [anon_sym_R_DQUOTE] = ACTIONS(2273),
    [anon_sym_LR_DQUOTE] = ACTIONS(2273),
    [anon_sym_uR_DQUOTE] = ACTIONS(2273),
    [anon_sym_UR_DQUOTE] = ACTIONS(2273),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2273),
    [anon_sym_co_await] = ACTIONS(2271),
    [anon_sym_new] = ACTIONS(2271),
    [anon_sym_requires] = ACTIONS(2271),
    [sym_this] = ACTIONS(2271),
    [anon_sym___launch_bounds__] = ACTIONS(2271),
  },
  [222] = {
    [sym_identifier] = ACTIONS(2275),
    [aux_sym_preproc_include_token1] = ACTIONS(2275),
    [aux_sym_preproc_def_token1] = ACTIONS(2275),
    [aux_sym_preproc_if_token1] = ACTIONS(2275),
    [aux_sym_preproc_if_token2] = ACTIONS(2275),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2275),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2275),
    [aux_sym_preproc_else_token1] = ACTIONS(2275),
    [aux_sym_preproc_elif_token1] = ACTIONS(2275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2275),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2275),
    [sym_preproc_directive] = ACTIONS(2275),
    [anon_sym_LPAREN2] = ACTIONS(2277),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [anon_sym_DASH] = ACTIONS(2275),
    [anon_sym_PLUS] = ACTIONS(2275),
    [anon_sym_STAR] = ACTIONS(2277),
    [anon_sym_AMP_AMP] = ACTIONS(2277),
    [anon_sym_AMP] = ACTIONS(2275),
    [anon_sym_SEMI] = ACTIONS(2277),
    [anon_sym___extension__] = ACTIONS(2275),
    [anon_sym_typedef] = ACTIONS(2275),
    [anon_sym___device__] = ACTIONS(2275),
    [anon_sym___host__] = ACTIONS(2275),
    [anon_sym___global__] = ACTIONS(2275),
    [anon_sym___forceinline__] = ACTIONS(2275),
    [anon_sym___noinline__] = ACTIONS(2275),
    [anon_sym_extern] = ACTIONS(2275),
    [anon_sym___attribute__] = ACTIONS(2275),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2277),
    [anon_sym___declspec] = ACTIONS(2275),
    [anon_sym___based] = ACTIONS(2275),
    [anon_sym___cdecl] = ACTIONS(2275),
    [anon_sym___clrcall] = ACTIONS(2275),
    [anon_sym___stdcall] = ACTIONS(2275),
    [anon_sym___fastcall] = ACTIONS(2275),
    [anon_sym___thiscall] = ACTIONS(2275),
    [anon_sym___vectorcall] = ACTIONS(2275),
    [anon_sym_LBRACE] = ACTIONS(2277),
    [anon_sym_signed] = ACTIONS(2275),
    [anon_sym_unsigned] = ACTIONS(2275),
    [anon_sym_long] = ACTIONS(2275),
    [anon_sym_short] = ACTIONS(2275),
    [anon_sym_LBRACK] = ACTIONS(2275),
    [anon_sym_static] = ACTIONS(2275),
    [anon_sym_register] = ACTIONS(2275),
    [anon_sym_inline] = ACTIONS(2275),
    [anon_sym___inline] = ACTIONS(2275),
    [anon_sym___inline__] = ACTIONS(2275),
    [anon_sym___forceinline] = ACTIONS(2275),
    [anon_sym_thread_local] = ACTIONS(2275),
    [anon_sym___thread] = ACTIONS(2275),
    [anon_sym_const] = ACTIONS(2275),
    [anon_sym_constexpr] = ACTIONS(2275),
    [anon_sym_volatile] = ACTIONS(2275),
    [anon_sym_restrict] = ACTIONS(2275),
    [anon_sym___restrict__] = ACTIONS(2275),
    [anon_sym__Atomic] = ACTIONS(2275),
    [anon_sym__Noreturn] = ACTIONS(2275),
    [anon_sym_noreturn] = ACTIONS(2275),
    [anon_sym_mutable] = ACTIONS(2275),
    [anon_sym_constinit] = ACTIONS(2275),
    [anon_sym_consteval] = ACTIONS(2275),
    [anon_sym___shared__] = ACTIONS(2275),
    [anon_sym___local__] = ACTIONS(2275),
    [anon_sym___constant__] = ACTIONS(2275),
    [anon_sym___managed__] = ACTIONS(2275),
    [anon_sym___grid_constant__] = ACTIONS(2275),
    [anon_sym_alignas] = ACTIONS(2275),
    [anon_sym__Alignas] = ACTIONS(2275),
    [sym_primitive_type] = ACTIONS(2275),
    [anon_sym_enum] = ACTIONS(2275),
    [anon_sym_class] = ACTIONS(2275),
    [anon_sym_struct] = ACTIONS(2275),
    [anon_sym_union] = ACTIONS(2275),
    [anon_sym_if] = ACTIONS(2275),
    [anon_sym_switch] = ACTIONS(2275),
    [anon_sym_case] = ACTIONS(2275),
    [anon_sym_default] = ACTIONS(2275),
    [anon_sym_while] = ACTIONS(2275),
    [anon_sym_do] = ACTIONS(2275),
    [anon_sym_for] = ACTIONS(2275),
    [anon_sym_return] = ACTIONS(2275),
    [anon_sym_break] = ACTIONS(2275),
    [anon_sym_continue] = ACTIONS(2275),
    [anon_sym_goto] = ACTIONS(2275),
    [anon_sym___try] = ACTIONS(2275),
    [anon_sym___leave] = ACTIONS(2275),
    [anon_sym_not] = ACTIONS(2275),
    [anon_sym_compl] = ACTIONS(2275),
    [anon_sym_DASH_DASH] = ACTIONS(2277),
    [anon_sym_PLUS_PLUS] = ACTIONS(2277),
    [anon_sym_sizeof] = ACTIONS(2275),
    [anon_sym___alignof__] = ACTIONS(2275),
    [anon_sym___alignof] = ACTIONS(2275),
    [anon_sym__alignof] = ACTIONS(2275),
    [anon_sym_alignof] = ACTIONS(2275),
    [anon_sym__Alignof] = ACTIONS(2275),
    [anon_sym_offsetof] = ACTIONS(2275),
    [anon_sym__Generic] = ACTIONS(2275),
    [anon_sym_asm] = ACTIONS(2275),
    [anon_sym___asm__] = ACTIONS(2275),
    [sym_number_literal] = ACTIONS(2277),
    [anon_sym_L_SQUOTE] = ACTIONS(2277),
    [anon_sym_u_SQUOTE] = ACTIONS(2277),
    [anon_sym_U_SQUOTE] = ACTIONS(2277),
    [anon_sym_u8_SQUOTE] = ACTIONS(2277),
    [anon_sym_SQUOTE] = ACTIONS(2277),
    [anon_sym_L_DQUOTE] = ACTIONS(2277),
    [anon_sym_u_DQUOTE] = ACTIONS(2277),
    [anon_sym_U_DQUOTE] = ACTIONS(2277),
    [anon_sym_u8_DQUOTE] = ACTIONS(2277),
    [anon_sym_DQUOTE] = ACTIONS(2277),
    [sym_true] = ACTIONS(2275),
    [sym_false] = ACTIONS(2275),
    [anon_sym_NULL] = ACTIONS(2275),
    [anon_sym_nullptr] = ACTIONS(2275),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2275),
    [anon_sym_decltype] = ACTIONS(2275),
    [sym_virtual] = ACTIONS(2275),
    [anon_sym_explicit] = ACTIONS(2275),
    [anon_sym_typename] = ACTIONS(2275),
    [anon_sym_template] = ACTIONS(2275),
    [anon_sym_operator] = ACTIONS(2275),
    [anon_sym_try] = ACTIONS(2275),
    [anon_sym_delete] = ACTIONS(2275),
    [anon_sym_throw] = ACTIONS(2275),
    [anon_sym_namespace] = ACTIONS(2275),
    [anon_sym_using] = ACTIONS(2275),
    [anon_sym_static_assert] = ACTIONS(2275),
    [anon_sym_concept] = ACTIONS(2275),
    [anon_sym_co_return] = ACTIONS(2275),
    [anon_sym_co_yield] = ACTIONS(2275),
    [anon_sym_R_DQUOTE] = ACTIONS(2277),
    [anon_sym_LR_DQUOTE] = ACTIONS(2277),
    [anon_sym_uR_DQUOTE] = ACTIONS(2277),
    [anon_sym_UR_DQUOTE] = ACTIONS(2277),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2277),
    [anon_sym_co_await] = ACTIONS(2275),
    [anon_sym_new] = ACTIONS(2275),
    [anon_sym_requires] = ACTIONS(2275),
    [sym_this] = ACTIONS(2275),
    [anon_sym___launch_bounds__] = ACTIONS(2275),
  },
  [223] = {
    [sym_catch_clause] = STATE(223),
    [aux_sym_constructor_try_statement_repeat1] = STATE(223),
    [sym_identifier] = ACTIONS(1909),
    [aux_sym_preproc_include_token1] = ACTIONS(1909),
    [aux_sym_preproc_def_token1] = ACTIONS(1909),
    [aux_sym_preproc_if_token1] = ACTIONS(1909),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1909),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1909),
    [sym_preproc_directive] = ACTIONS(1909),
    [anon_sym_LPAREN2] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_SEMI] = ACTIONS(1911),
    [anon_sym___extension__] = ACTIONS(1909),
    [anon_sym_typedef] = ACTIONS(1909),
    [anon_sym___device__] = ACTIONS(1909),
    [anon_sym___host__] = ACTIONS(1909),
    [anon_sym___global__] = ACTIONS(1909),
    [anon_sym___forceinline__] = ACTIONS(1909),
    [anon_sym___noinline__] = ACTIONS(1909),
    [anon_sym_extern] = ACTIONS(1909),
    [anon_sym___attribute__] = ACTIONS(1909),
    [anon_sym_COLON_COLON] = ACTIONS(1911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1911),
    [anon_sym___declspec] = ACTIONS(1909),
    [anon_sym___based] = ACTIONS(1909),
    [anon_sym___cdecl] = ACTIONS(1909),
    [anon_sym___clrcall] = ACTIONS(1909),
    [anon_sym___stdcall] = ACTIONS(1909),
    [anon_sym___fastcall] = ACTIONS(1909),
    [anon_sym___thiscall] = ACTIONS(1909),
    [anon_sym___vectorcall] = ACTIONS(1909),
    [anon_sym_LBRACE] = ACTIONS(1911),
    [anon_sym_RBRACE] = ACTIONS(1911),
    [anon_sym_signed] = ACTIONS(1909),
    [anon_sym_unsigned] = ACTIONS(1909),
    [anon_sym_long] = ACTIONS(1909),
    [anon_sym_short] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_static] = ACTIONS(1909),
    [anon_sym_register] = ACTIONS(1909),
    [anon_sym_inline] = ACTIONS(1909),
    [anon_sym___inline] = ACTIONS(1909),
    [anon_sym___inline__] = ACTIONS(1909),
    [anon_sym___forceinline] = ACTIONS(1909),
    [anon_sym_thread_local] = ACTIONS(1909),
    [anon_sym___thread] = ACTIONS(1909),
    [anon_sym_const] = ACTIONS(1909),
    [anon_sym_constexpr] = ACTIONS(1909),
    [anon_sym_volatile] = ACTIONS(1909),
    [anon_sym_restrict] = ACTIONS(1909),
    [anon_sym___restrict__] = ACTIONS(1909),
    [anon_sym__Atomic] = ACTIONS(1909),
    [anon_sym__Noreturn] = ACTIONS(1909),
    [anon_sym_noreturn] = ACTIONS(1909),
    [anon_sym_mutable] = ACTIONS(1909),
    [anon_sym_constinit] = ACTIONS(1909),
    [anon_sym_consteval] = ACTIONS(1909),
    [anon_sym___shared__] = ACTIONS(1909),
    [anon_sym___local__] = ACTIONS(1909),
    [anon_sym___constant__] = ACTIONS(1909),
    [anon_sym___managed__] = ACTIONS(1909),
    [anon_sym___grid_constant__] = ACTIONS(1909),
    [anon_sym_alignas] = ACTIONS(1909),
    [anon_sym__Alignas] = ACTIONS(1909),
    [sym_primitive_type] = ACTIONS(1909),
    [anon_sym_enum] = ACTIONS(1909),
    [anon_sym_class] = ACTIONS(1909),
    [anon_sym_struct] = ACTIONS(1909),
    [anon_sym_union] = ACTIONS(1909),
    [anon_sym_if] = ACTIONS(1909),
    [anon_sym_else] = ACTIONS(1909),
    [anon_sym_switch] = ACTIONS(1909),
    [anon_sym_case] = ACTIONS(1909),
    [anon_sym_default] = ACTIONS(1909),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_do] = ACTIONS(1909),
    [anon_sym_for] = ACTIONS(1909),
    [anon_sym_return] = ACTIONS(1909),
    [anon_sym_break] = ACTIONS(1909),
    [anon_sym_continue] = ACTIONS(1909),
    [anon_sym_goto] = ACTIONS(1909),
    [anon_sym___try] = ACTIONS(1909),
    [anon_sym___leave] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1909),
    [anon_sym_compl] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_sizeof] = ACTIONS(1909),
    [anon_sym___alignof__] = ACTIONS(1909),
    [anon_sym___alignof] = ACTIONS(1909),
    [anon_sym__alignof] = ACTIONS(1909),
    [anon_sym_alignof] = ACTIONS(1909),
    [anon_sym__Alignof] = ACTIONS(1909),
    [anon_sym_offsetof] = ACTIONS(1909),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1909),
    [anon_sym___asm__] = ACTIONS(1909),
    [sym_number_literal] = ACTIONS(1911),
    [anon_sym_L_SQUOTE] = ACTIONS(1911),
    [anon_sym_u_SQUOTE] = ACTIONS(1911),
    [anon_sym_U_SQUOTE] = ACTIONS(1911),
    [anon_sym_u8_SQUOTE] = ACTIONS(1911),
    [anon_sym_SQUOTE] = ACTIONS(1911),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1909),
    [sym_false] = ACTIONS(1909),
    [anon_sym_NULL] = ACTIONS(1909),
    [anon_sym_nullptr] = ACTIONS(1909),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1909),
    [anon_sym_decltype] = ACTIONS(1909),
    [sym_virtual] = ACTIONS(1909),
    [anon_sym_explicit] = ACTIONS(1909),
    [anon_sym_typename] = ACTIONS(1909),
    [anon_sym_template] = ACTIONS(1909),
    [anon_sym_operator] = ACTIONS(1909),
    [anon_sym_try] = ACTIONS(1909),
    [anon_sym_delete] = ACTIONS(1909),
    [anon_sym_throw] = ACTIONS(1909),
    [anon_sym_namespace] = ACTIONS(1909),
    [anon_sym_using] = ACTIONS(1909),
    [anon_sym_static_assert] = ACTIONS(1909),
    [anon_sym_concept] = ACTIONS(1909),
    [anon_sym_co_return] = ACTIONS(1909),
    [anon_sym_co_yield] = ACTIONS(1909),
    [anon_sym_catch] = ACTIONS(2279),
    [anon_sym_R_DQUOTE] = ACTIONS(1911),
    [anon_sym_LR_DQUOTE] = ACTIONS(1911),
    [anon_sym_uR_DQUOTE] = ACTIONS(1911),
    [anon_sym_UR_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1911),
    [anon_sym_co_await] = ACTIONS(1909),
    [anon_sym_new] = ACTIONS(1909),
    [anon_sym_requires] = ACTIONS(1909),
    [sym_this] = ACTIONS(1909),
    [anon_sym___launch_bounds__] = ACTIONS(1909),
  },
  [224] = {
    [sym_preproc_def] = STATE(370),
    [sym_preproc_function_def] = STATE(370),
    [sym_preproc_call] = STATE(370),
    [sym_preproc_if_in_field_declaration_list] = STATE(370),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(370),
    [sym_preproc_else_in_field_declaration_list] = STATE(8599),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8599),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8599),
    [sym_type_definition] = STATE(370),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5944),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6464),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(370),
    [sym_field_declaration] = STATE(370),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1701),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(370),
    [sym_operator_cast] = STATE(6994),
    [sym_inline_method_definition] = STATE(370),
    [sym__constructor_specifiers] = STATE(1701),
    [sym_operator_cast_definition] = STATE(370),
    [sym_operator_cast_declaration] = STATE(370),
    [sym_constructor_or_destructor_definition] = STATE(370),
    [sym_constructor_or_destructor_declaration] = STATE(370),
    [sym_friend_declaration] = STATE(370),
    [sym_access_specifier] = STATE(9001),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(370),
    [sym_alias_declaration] = STATE(370),
    [sym_static_assert_declaration] = STATE(370),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6994),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(370),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1701),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(2100),
    [aux_sym_preproc_if_token1] = ACTIONS(2102),
    [aux_sym_preproc_if_token2] = ACTIONS(2282),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2106),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2106),
    [aux_sym_preproc_else_token1] = ACTIONS(2108),
    [aux_sym_preproc_elif_token1] = ACTIONS(2110),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2112),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2112),
    [sym_preproc_directive] = ACTIONS(2114),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(2124),
    [anon_sym_typedef] = ACTIONS(2126),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(2144),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2146),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(2150),
    [anon_sym_static_assert] = ACTIONS(2152),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [225] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(2960),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8499),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8815),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8509),
    [sym__unary_right_fold] = STATE(8507),
    [sym__binary_fold] = STATE(8501),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8481),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [226] = {
    [sym_identifier] = ACTIONS(2284),
    [aux_sym_preproc_include_token1] = ACTIONS(2284),
    [aux_sym_preproc_def_token1] = ACTIONS(2284),
    [aux_sym_preproc_if_token1] = ACTIONS(2284),
    [aux_sym_preproc_if_token2] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2284),
    [aux_sym_preproc_else_token1] = ACTIONS(2284),
    [aux_sym_preproc_elif_token1] = ACTIONS(2284),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2284),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2284),
    [sym_preproc_directive] = ACTIONS(2284),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_typedef] = ACTIONS(2284),
    [anon_sym___device__] = ACTIONS(2284),
    [anon_sym___host__] = ACTIONS(2284),
    [anon_sym___global__] = ACTIONS(2284),
    [anon_sym___forceinline__] = ACTIONS(2284),
    [anon_sym___noinline__] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2286),
    [anon_sym___declspec] = ACTIONS(2284),
    [anon_sym___based] = ACTIONS(2284),
    [anon_sym___cdecl] = ACTIONS(2284),
    [anon_sym___clrcall] = ACTIONS(2284),
    [anon_sym___stdcall] = ACTIONS(2284),
    [anon_sym___fastcall] = ACTIONS(2284),
    [anon_sym___thiscall] = ACTIONS(2284),
    [anon_sym___vectorcall] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_signed] = ACTIONS(2284),
    [anon_sym_unsigned] = ACTIONS(2284),
    [anon_sym_long] = ACTIONS(2284),
    [anon_sym_short] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym___inline] = ACTIONS(2284),
    [anon_sym___inline__] = ACTIONS(2284),
    [anon_sym___forceinline] = ACTIONS(2284),
    [anon_sym_thread_local] = ACTIONS(2284),
    [anon_sym___thread] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym___shared__] = ACTIONS(2284),
    [anon_sym___local__] = ACTIONS(2284),
    [anon_sym___constant__] = ACTIONS(2284),
    [anon_sym___managed__] = ACTIONS(2284),
    [anon_sym___grid_constant__] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [sym_primitive_type] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
    [anon_sym_class] = ACTIONS(2284),
    [anon_sym_struct] = ACTIONS(2284),
    [anon_sym_union] = ACTIONS(2284),
    [anon_sym_if] = ACTIONS(2284),
    [anon_sym_switch] = ACTIONS(2284),
    [anon_sym_case] = ACTIONS(2284),
    [anon_sym_default] = ACTIONS(2284),
    [anon_sym_while] = ACTIONS(2284),
    [anon_sym_do] = ACTIONS(2284),
    [anon_sym_for] = ACTIONS(2284),
    [anon_sym_return] = ACTIONS(2284),
    [anon_sym_break] = ACTIONS(2284),
    [anon_sym_continue] = ACTIONS(2284),
    [anon_sym_goto] = ACTIONS(2284),
    [anon_sym___try] = ACTIONS(2284),
    [anon_sym___leave] = ACTIONS(2284),
    [anon_sym_not] = ACTIONS(2284),
    [anon_sym_compl] = ACTIONS(2284),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_sizeof] = ACTIONS(2284),
    [anon_sym___alignof__] = ACTIONS(2284),
    [anon_sym___alignof] = ACTIONS(2284),
    [anon_sym__alignof] = ACTIONS(2284),
    [anon_sym_alignof] = ACTIONS(2284),
    [anon_sym__Alignof] = ACTIONS(2284),
    [anon_sym_offsetof] = ACTIONS(2284),
    [anon_sym__Generic] = ACTIONS(2284),
    [anon_sym_asm] = ACTIONS(2284),
    [anon_sym___asm__] = ACTIONS(2284),
    [sym_number_literal] = ACTIONS(2286),
    [anon_sym_L_SQUOTE] = ACTIONS(2286),
    [anon_sym_u_SQUOTE] = ACTIONS(2286),
    [anon_sym_U_SQUOTE] = ACTIONS(2286),
    [anon_sym_u8_SQUOTE] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [anon_sym_L_DQUOTE] = ACTIONS(2286),
    [anon_sym_u_DQUOTE] = ACTIONS(2286),
    [anon_sym_U_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8_DQUOTE] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [sym_true] = ACTIONS(2284),
    [sym_false] = ACTIONS(2284),
    [anon_sym_NULL] = ACTIONS(2284),
    [anon_sym_nullptr] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [sym_virtual] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_typename] = ACTIONS(2284),
    [anon_sym_template] = ACTIONS(2284),
    [anon_sym_operator] = ACTIONS(2284),
    [anon_sym_try] = ACTIONS(2284),
    [anon_sym_delete] = ACTIONS(2284),
    [anon_sym_throw] = ACTIONS(2284),
    [anon_sym_namespace] = ACTIONS(2284),
    [anon_sym_using] = ACTIONS(2284),
    [anon_sym_static_assert] = ACTIONS(2284),
    [anon_sym_concept] = ACTIONS(2284),
    [anon_sym_co_return] = ACTIONS(2284),
    [anon_sym_co_yield] = ACTIONS(2284),
    [anon_sym_R_DQUOTE] = ACTIONS(2286),
    [anon_sym_LR_DQUOTE] = ACTIONS(2286),
    [anon_sym_uR_DQUOTE] = ACTIONS(2286),
    [anon_sym_UR_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2286),
    [anon_sym_co_await] = ACTIONS(2284),
    [anon_sym_new] = ACTIONS(2284),
    [anon_sym_requires] = ACTIONS(2284),
    [sym_this] = ACTIONS(2284),
    [anon_sym___launch_bounds__] = ACTIONS(2284),
  },
  [227] = {
    [sym_identifier] = ACTIONS(2288),
    [aux_sym_preproc_include_token1] = ACTIONS(2288),
    [aux_sym_preproc_def_token1] = ACTIONS(2288),
    [aux_sym_preproc_if_token1] = ACTIONS(2288),
    [aux_sym_preproc_if_token2] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2288),
    [aux_sym_preproc_else_token1] = ACTIONS(2288),
    [aux_sym_preproc_elif_token1] = ACTIONS(2288),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2288),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2288),
    [sym_preproc_directive] = ACTIONS(2288),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym_typedef] = ACTIONS(2288),
    [anon_sym___device__] = ACTIONS(2288),
    [anon_sym___host__] = ACTIONS(2288),
    [anon_sym___global__] = ACTIONS(2288),
    [anon_sym___forceinline__] = ACTIONS(2288),
    [anon_sym___noinline__] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2290),
    [anon_sym___declspec] = ACTIONS(2288),
    [anon_sym___based] = ACTIONS(2288),
    [anon_sym___cdecl] = ACTIONS(2288),
    [anon_sym___clrcall] = ACTIONS(2288),
    [anon_sym___stdcall] = ACTIONS(2288),
    [anon_sym___fastcall] = ACTIONS(2288),
    [anon_sym___thiscall] = ACTIONS(2288),
    [anon_sym___vectorcall] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_signed] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym___inline] = ACTIONS(2288),
    [anon_sym___inline__] = ACTIONS(2288),
    [anon_sym___forceinline] = ACTIONS(2288),
    [anon_sym_thread_local] = ACTIONS(2288),
    [anon_sym___thread] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym___shared__] = ACTIONS(2288),
    [anon_sym___local__] = ACTIONS(2288),
    [anon_sym___constant__] = ACTIONS(2288),
    [anon_sym___managed__] = ACTIONS(2288),
    [anon_sym___grid_constant__] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_goto] = ACTIONS(2288),
    [anon_sym___try] = ACTIONS(2288),
    [anon_sym___leave] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2288),
    [anon_sym_compl] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_sizeof] = ACTIONS(2288),
    [anon_sym___alignof__] = ACTIONS(2288),
    [anon_sym___alignof] = ACTIONS(2288),
    [anon_sym__alignof] = ACTIONS(2288),
    [anon_sym_alignof] = ACTIONS(2288),
    [anon_sym__Alignof] = ACTIONS(2288),
    [anon_sym_offsetof] = ACTIONS(2288),
    [anon_sym__Generic] = ACTIONS(2288),
    [anon_sym_asm] = ACTIONS(2288),
    [anon_sym___asm__] = ACTIONS(2288),
    [sym_number_literal] = ACTIONS(2290),
    [anon_sym_L_SQUOTE] = ACTIONS(2290),
    [anon_sym_u_SQUOTE] = ACTIONS(2290),
    [anon_sym_U_SQUOTE] = ACTIONS(2290),
    [anon_sym_u8_SQUOTE] = ACTIONS(2290),
    [anon_sym_SQUOTE] = ACTIONS(2290),
    [anon_sym_L_DQUOTE] = ACTIONS(2290),
    [anon_sym_u_DQUOTE] = ACTIONS(2290),
    [anon_sym_U_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8_DQUOTE] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [anon_sym_NULL] = ACTIONS(2288),
    [anon_sym_nullptr] = ACTIONS(2288),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [sym_virtual] = ACTIONS(2288),
    [anon_sym_explicit] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_operator] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_static_assert] = ACTIONS(2288),
    [anon_sym_concept] = ACTIONS(2288),
    [anon_sym_co_return] = ACTIONS(2288),
    [anon_sym_co_yield] = ACTIONS(2288),
    [anon_sym_R_DQUOTE] = ACTIONS(2290),
    [anon_sym_LR_DQUOTE] = ACTIONS(2290),
    [anon_sym_uR_DQUOTE] = ACTIONS(2290),
    [anon_sym_UR_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2290),
    [anon_sym_co_await] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_requires] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [anon_sym___launch_bounds__] = ACTIONS(2288),
  },
  [228] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(2960),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8499),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8424),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8509),
    [sym__unary_right_fold] = STATE(8507),
    [sym__binary_fold] = STATE(8501),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8481),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [229] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(2960),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8499),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8794),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8509),
    [sym__unary_right_fold] = STATE(8507),
    [sym__binary_fold] = STATE(8501),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8481),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [230] = {
    [sym_identifier] = ACTIONS(2292),
    [aux_sym_preproc_include_token1] = ACTIONS(2292),
    [aux_sym_preproc_def_token1] = ACTIONS(2292),
    [aux_sym_preproc_if_token1] = ACTIONS(2292),
    [aux_sym_preproc_if_token2] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2292),
    [aux_sym_preproc_else_token1] = ACTIONS(2292),
    [aux_sym_preproc_elif_token1] = ACTIONS(2292),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2292),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2292),
    [sym_preproc_directive] = ACTIONS(2292),
    [anon_sym_LPAREN2] = ACTIONS(2294),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym___extension__] = ACTIONS(2292),
    [anon_sym_typedef] = ACTIONS(2292),
    [anon_sym___device__] = ACTIONS(2292),
    [anon_sym___host__] = ACTIONS(2292),
    [anon_sym___global__] = ACTIONS(2292),
    [anon_sym___forceinline__] = ACTIONS(2292),
    [anon_sym___noinline__] = ACTIONS(2292),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym___attribute__] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2294),
    [anon_sym___declspec] = ACTIONS(2292),
    [anon_sym___based] = ACTIONS(2292),
    [anon_sym___cdecl] = ACTIONS(2292),
    [anon_sym___clrcall] = ACTIONS(2292),
    [anon_sym___stdcall] = ACTIONS(2292),
    [anon_sym___fastcall] = ACTIONS(2292),
    [anon_sym___thiscall] = ACTIONS(2292),
    [anon_sym___vectorcall] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_signed] = ACTIONS(2292),
    [anon_sym_unsigned] = ACTIONS(2292),
    [anon_sym_long] = ACTIONS(2292),
    [anon_sym_short] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_register] = ACTIONS(2292),
    [anon_sym_inline] = ACTIONS(2292),
    [anon_sym___inline] = ACTIONS(2292),
    [anon_sym___inline__] = ACTIONS(2292),
    [anon_sym___forceinline] = ACTIONS(2292),
    [anon_sym_thread_local] = ACTIONS(2292),
    [anon_sym___thread] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym___restrict__] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym__Noreturn] = ACTIONS(2292),
    [anon_sym_noreturn] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_constinit] = ACTIONS(2292),
    [anon_sym_consteval] = ACTIONS(2292),
    [anon_sym___shared__] = ACTIONS(2292),
    [anon_sym___local__] = ACTIONS(2292),
    [anon_sym___constant__] = ACTIONS(2292),
    [anon_sym___managed__] = ACTIONS(2292),
    [anon_sym___grid_constant__] = ACTIONS(2292),
    [anon_sym_alignas] = ACTIONS(2292),
    [anon_sym__Alignas] = ACTIONS(2292),
    [sym_primitive_type] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_struct] = ACTIONS(2292),
    [anon_sym_union] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_case] = ACTIONS(2292),
    [anon_sym_default] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_goto] = ACTIONS(2292),
    [anon_sym___try] = ACTIONS(2292),
    [anon_sym___leave] = ACTIONS(2292),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_compl] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_sizeof] = ACTIONS(2292),
    [anon_sym___alignof__] = ACTIONS(2292),
    [anon_sym___alignof] = ACTIONS(2292),
    [anon_sym__alignof] = ACTIONS(2292),
    [anon_sym_alignof] = ACTIONS(2292),
    [anon_sym__Alignof] = ACTIONS(2292),
    [anon_sym_offsetof] = ACTIONS(2292),
    [anon_sym__Generic] = ACTIONS(2292),
    [anon_sym_asm] = ACTIONS(2292),
    [anon_sym___asm__] = ACTIONS(2292),
    [sym_number_literal] = ACTIONS(2294),
    [anon_sym_L_SQUOTE] = ACTIONS(2294),
    [anon_sym_u_SQUOTE] = ACTIONS(2294),
    [anon_sym_U_SQUOTE] = ACTIONS(2294),
    [anon_sym_u8_SQUOTE] = ACTIONS(2294),
    [anon_sym_SQUOTE] = ACTIONS(2294),
    [anon_sym_L_DQUOTE] = ACTIONS(2294),
    [anon_sym_u_DQUOTE] = ACTIONS(2294),
    [anon_sym_U_DQUOTE] = ACTIONS(2294),
    [anon_sym_u8_DQUOTE] = ACTIONS(2294),
    [anon_sym_DQUOTE] = ACTIONS(2294),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [anon_sym_NULL] = ACTIONS(2292),
    [anon_sym_nullptr] = ACTIONS(2292),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2292),
    [anon_sym_decltype] = ACTIONS(2292),
    [sym_virtual] = ACTIONS(2292),
    [anon_sym_explicit] = ACTIONS(2292),
    [anon_sym_typename] = ACTIONS(2292),
    [anon_sym_template] = ACTIONS(2292),
    [anon_sym_operator] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_delete] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_namespace] = ACTIONS(2292),
    [anon_sym_using] = ACTIONS(2292),
    [anon_sym_static_assert] = ACTIONS(2292),
    [anon_sym_concept] = ACTIONS(2292),
    [anon_sym_co_return] = ACTIONS(2292),
    [anon_sym_co_yield] = ACTIONS(2292),
    [anon_sym_R_DQUOTE] = ACTIONS(2294),
    [anon_sym_LR_DQUOTE] = ACTIONS(2294),
    [anon_sym_uR_DQUOTE] = ACTIONS(2294),
    [anon_sym_UR_DQUOTE] = ACTIONS(2294),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2294),
    [anon_sym_co_await] = ACTIONS(2292),
    [anon_sym_new] = ACTIONS(2292),
    [anon_sym_requires] = ACTIONS(2292),
    [sym_this] = ACTIONS(2292),
    [anon_sym___launch_bounds__] = ACTIONS(2292),
  },
  [231] = {
    [sym_identifier] = ACTIONS(2296),
    [aux_sym_preproc_include_token1] = ACTIONS(2296),
    [aux_sym_preproc_def_token1] = ACTIONS(2296),
    [aux_sym_preproc_if_token1] = ACTIONS(2296),
    [aux_sym_preproc_if_token2] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2296),
    [aux_sym_preproc_else_token1] = ACTIONS(2296),
    [aux_sym_preproc_elif_token1] = ACTIONS(2296),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2296),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2296),
    [sym_preproc_directive] = ACTIONS(2296),
    [anon_sym_LPAREN2] = ACTIONS(2298),
    [anon_sym_BANG] = ACTIONS(2298),
    [anon_sym_TILDE] = ACTIONS(2298),
    [anon_sym_DASH] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2296),
    [anon_sym_STAR] = ACTIONS(2298),
    [anon_sym_AMP_AMP] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(2298),
    [anon_sym___extension__] = ACTIONS(2296),
    [anon_sym_typedef] = ACTIONS(2296),
    [anon_sym___device__] = ACTIONS(2296),
    [anon_sym___host__] = ACTIONS(2296),
    [anon_sym___global__] = ACTIONS(2296),
    [anon_sym___forceinline__] = ACTIONS(2296),
    [anon_sym___noinline__] = ACTIONS(2296),
    [anon_sym_extern] = ACTIONS(2296),
    [anon_sym___attribute__] = ACTIONS(2296),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2298),
    [anon_sym___declspec] = ACTIONS(2296),
    [anon_sym___based] = ACTIONS(2296),
    [anon_sym___cdecl] = ACTIONS(2296),
    [anon_sym___clrcall] = ACTIONS(2296),
    [anon_sym___stdcall] = ACTIONS(2296),
    [anon_sym___fastcall] = ACTIONS(2296),
    [anon_sym___thiscall] = ACTIONS(2296),
    [anon_sym___vectorcall] = ACTIONS(2296),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_signed] = ACTIONS(2296),
    [anon_sym_unsigned] = ACTIONS(2296),
    [anon_sym_long] = ACTIONS(2296),
    [anon_sym_short] = ACTIONS(2296),
    [anon_sym_LBRACK] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_register] = ACTIONS(2296),
    [anon_sym_inline] = ACTIONS(2296),
    [anon_sym___inline] = ACTIONS(2296),
    [anon_sym___inline__] = ACTIONS(2296),
    [anon_sym___forceinline] = ACTIONS(2296),
    [anon_sym_thread_local] = ACTIONS(2296),
    [anon_sym___thread] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_constexpr] = ACTIONS(2296),
    [anon_sym_volatile] = ACTIONS(2296),
    [anon_sym_restrict] = ACTIONS(2296),
    [anon_sym___restrict__] = ACTIONS(2296),
    [anon_sym__Atomic] = ACTIONS(2296),
    [anon_sym__Noreturn] = ACTIONS(2296),
    [anon_sym_noreturn] = ACTIONS(2296),
    [anon_sym_mutable] = ACTIONS(2296),
    [anon_sym_constinit] = ACTIONS(2296),
    [anon_sym_consteval] = ACTIONS(2296),
    [anon_sym___shared__] = ACTIONS(2296),
    [anon_sym___local__] = ACTIONS(2296),
    [anon_sym___constant__] = ACTIONS(2296),
    [anon_sym___managed__] = ACTIONS(2296),
    [anon_sym___grid_constant__] = ACTIONS(2296),
    [anon_sym_alignas] = ACTIONS(2296),
    [anon_sym__Alignas] = ACTIONS(2296),
    [sym_primitive_type] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2296),
    [anon_sym_class] = ACTIONS(2296),
    [anon_sym_struct] = ACTIONS(2296),
    [anon_sym_union] = ACTIONS(2296),
    [anon_sym_if] = ACTIONS(2296),
    [anon_sym_switch] = ACTIONS(2296),
    [anon_sym_case] = ACTIONS(2296),
    [anon_sym_default] = ACTIONS(2296),
    [anon_sym_while] = ACTIONS(2296),
    [anon_sym_do] = ACTIONS(2296),
    [anon_sym_for] = ACTIONS(2296),
    [anon_sym_return] = ACTIONS(2296),
    [anon_sym_break] = ACTIONS(2296),
    [anon_sym_continue] = ACTIONS(2296),
    [anon_sym_goto] = ACTIONS(2296),
    [anon_sym___try] = ACTIONS(2296),
    [anon_sym___leave] = ACTIONS(2296),
    [anon_sym_not] = ACTIONS(2296),
    [anon_sym_compl] = ACTIONS(2296),
    [anon_sym_DASH_DASH] = ACTIONS(2298),
    [anon_sym_PLUS_PLUS] = ACTIONS(2298),
    [anon_sym_sizeof] = ACTIONS(2296),
    [anon_sym___alignof__] = ACTIONS(2296),
    [anon_sym___alignof] = ACTIONS(2296),
    [anon_sym__alignof] = ACTIONS(2296),
    [anon_sym_alignof] = ACTIONS(2296),
    [anon_sym__Alignof] = ACTIONS(2296),
    [anon_sym_offsetof] = ACTIONS(2296),
    [anon_sym__Generic] = ACTIONS(2296),
    [anon_sym_asm] = ACTIONS(2296),
    [anon_sym___asm__] = ACTIONS(2296),
    [sym_number_literal] = ACTIONS(2298),
    [anon_sym_L_SQUOTE] = ACTIONS(2298),
    [anon_sym_u_SQUOTE] = ACTIONS(2298),
    [anon_sym_U_SQUOTE] = ACTIONS(2298),
    [anon_sym_u8_SQUOTE] = ACTIONS(2298),
    [anon_sym_SQUOTE] = ACTIONS(2298),
    [anon_sym_L_DQUOTE] = ACTIONS(2298),
    [anon_sym_u_DQUOTE] = ACTIONS(2298),
    [anon_sym_U_DQUOTE] = ACTIONS(2298),
    [anon_sym_u8_DQUOTE] = ACTIONS(2298),
    [anon_sym_DQUOTE] = ACTIONS(2298),
    [sym_true] = ACTIONS(2296),
    [sym_false] = ACTIONS(2296),
    [anon_sym_NULL] = ACTIONS(2296),
    [anon_sym_nullptr] = ACTIONS(2296),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2296),
    [anon_sym_decltype] = ACTIONS(2296),
    [sym_virtual] = ACTIONS(2296),
    [anon_sym_explicit] = ACTIONS(2296),
    [anon_sym_typename] = ACTIONS(2296),
    [anon_sym_template] = ACTIONS(2296),
    [anon_sym_operator] = ACTIONS(2296),
    [anon_sym_try] = ACTIONS(2296),
    [anon_sym_delete] = ACTIONS(2296),
    [anon_sym_throw] = ACTIONS(2296),
    [anon_sym_namespace] = ACTIONS(2296),
    [anon_sym_using] = ACTIONS(2296),
    [anon_sym_static_assert] = ACTIONS(2296),
    [anon_sym_concept] = ACTIONS(2296),
    [anon_sym_co_return] = ACTIONS(2296),
    [anon_sym_co_yield] = ACTIONS(2296),
    [anon_sym_R_DQUOTE] = ACTIONS(2298),
    [anon_sym_LR_DQUOTE] = ACTIONS(2298),
    [anon_sym_uR_DQUOTE] = ACTIONS(2298),
    [anon_sym_UR_DQUOTE] = ACTIONS(2298),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2298),
    [anon_sym_co_await] = ACTIONS(2296),
    [anon_sym_new] = ACTIONS(2296),
    [anon_sym_requires] = ACTIONS(2296),
    [sym_this] = ACTIONS(2296),
    [anon_sym___launch_bounds__] = ACTIONS(2296),
  },
  [232] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(2958),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8293),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8612),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8494),
    [sym__unary_right_fold] = STATE(8496),
    [sym__binary_fold] = STATE(8504),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8313),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [233] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(2958),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8293),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8493),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8494),
    [sym__unary_right_fold] = STATE(8496),
    [sym__binary_fold] = STATE(8504),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8313),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [234] = {
    [sym_identifier] = ACTIONS(2300),
    [aux_sym_preproc_include_token1] = ACTIONS(2300),
    [aux_sym_preproc_def_token1] = ACTIONS(2300),
    [aux_sym_preproc_if_token1] = ACTIONS(2300),
    [aux_sym_preproc_if_token2] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2300),
    [aux_sym_preproc_else_token1] = ACTIONS(2300),
    [aux_sym_preproc_elif_token1] = ACTIONS(2300),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2300),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2300),
    [sym_preproc_directive] = ACTIONS(2300),
    [anon_sym_LPAREN2] = ACTIONS(2302),
    [anon_sym_BANG] = ACTIONS(2302),
    [anon_sym_TILDE] = ACTIONS(2302),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2302),
    [anon_sym_AMP_AMP] = ACTIONS(2302),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2302),
    [anon_sym___extension__] = ACTIONS(2300),
    [anon_sym_typedef] = ACTIONS(2300),
    [anon_sym___device__] = ACTIONS(2300),
    [anon_sym___host__] = ACTIONS(2300),
    [anon_sym___global__] = ACTIONS(2300),
    [anon_sym___forceinline__] = ACTIONS(2300),
    [anon_sym___noinline__] = ACTIONS(2300),
    [anon_sym_extern] = ACTIONS(2300),
    [anon_sym___attribute__] = ACTIONS(2300),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2302),
    [anon_sym___declspec] = ACTIONS(2300),
    [anon_sym___based] = ACTIONS(2300),
    [anon_sym___cdecl] = ACTIONS(2300),
    [anon_sym___clrcall] = ACTIONS(2300),
    [anon_sym___stdcall] = ACTIONS(2300),
    [anon_sym___fastcall] = ACTIONS(2300),
    [anon_sym___thiscall] = ACTIONS(2300),
    [anon_sym___vectorcall] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_signed] = ACTIONS(2300),
    [anon_sym_unsigned] = ACTIONS(2300),
    [anon_sym_long] = ACTIONS(2300),
    [anon_sym_short] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_register] = ACTIONS(2300),
    [anon_sym_inline] = ACTIONS(2300),
    [anon_sym___inline] = ACTIONS(2300),
    [anon_sym___inline__] = ACTIONS(2300),
    [anon_sym___forceinline] = ACTIONS(2300),
    [anon_sym_thread_local] = ACTIONS(2300),
    [anon_sym___thread] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_constexpr] = ACTIONS(2300),
    [anon_sym_volatile] = ACTIONS(2300),
    [anon_sym_restrict] = ACTIONS(2300),
    [anon_sym___restrict__] = ACTIONS(2300),
    [anon_sym__Atomic] = ACTIONS(2300),
    [anon_sym__Noreturn] = ACTIONS(2300),
    [anon_sym_noreturn] = ACTIONS(2300),
    [anon_sym_mutable] = ACTIONS(2300),
    [anon_sym_constinit] = ACTIONS(2300),
    [anon_sym_consteval] = ACTIONS(2300),
    [anon_sym___shared__] = ACTIONS(2300),
    [anon_sym___local__] = ACTIONS(2300),
    [anon_sym___constant__] = ACTIONS(2300),
    [anon_sym___managed__] = ACTIONS(2300),
    [anon_sym___grid_constant__] = ACTIONS(2300),
    [anon_sym_alignas] = ACTIONS(2300),
    [anon_sym__Alignas] = ACTIONS(2300),
    [sym_primitive_type] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_struct] = ACTIONS(2300),
    [anon_sym_union] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_case] = ACTIONS(2300),
    [anon_sym_default] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_goto] = ACTIONS(2300),
    [anon_sym___try] = ACTIONS(2300),
    [anon_sym___leave] = ACTIONS(2300),
    [anon_sym_not] = ACTIONS(2300),
    [anon_sym_compl] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2302),
    [anon_sym_PLUS_PLUS] = ACTIONS(2302),
    [anon_sym_sizeof] = ACTIONS(2300),
    [anon_sym___alignof__] = ACTIONS(2300),
    [anon_sym___alignof] = ACTIONS(2300),
    [anon_sym__alignof] = ACTIONS(2300),
    [anon_sym_alignof] = ACTIONS(2300),
    [anon_sym__Alignof] = ACTIONS(2300),
    [anon_sym_offsetof] = ACTIONS(2300),
    [anon_sym__Generic] = ACTIONS(2300),
    [anon_sym_asm] = ACTIONS(2300),
    [anon_sym___asm__] = ACTIONS(2300),
    [sym_number_literal] = ACTIONS(2302),
    [anon_sym_L_SQUOTE] = ACTIONS(2302),
    [anon_sym_u_SQUOTE] = ACTIONS(2302),
    [anon_sym_U_SQUOTE] = ACTIONS(2302),
    [anon_sym_u8_SQUOTE] = ACTIONS(2302),
    [anon_sym_SQUOTE] = ACTIONS(2302),
    [anon_sym_L_DQUOTE] = ACTIONS(2302),
    [anon_sym_u_DQUOTE] = ACTIONS(2302),
    [anon_sym_U_DQUOTE] = ACTIONS(2302),
    [anon_sym_u8_DQUOTE] = ACTIONS(2302),
    [anon_sym_DQUOTE] = ACTIONS(2302),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [anon_sym_NULL] = ACTIONS(2300),
    [anon_sym_nullptr] = ACTIONS(2300),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2300),
    [anon_sym_decltype] = ACTIONS(2300),
    [sym_virtual] = ACTIONS(2300),
    [anon_sym_explicit] = ACTIONS(2300),
    [anon_sym_typename] = ACTIONS(2300),
    [anon_sym_template] = ACTIONS(2300),
    [anon_sym_operator] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_delete] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_static_assert] = ACTIONS(2300),
    [anon_sym_concept] = ACTIONS(2300),
    [anon_sym_co_return] = ACTIONS(2300),
    [anon_sym_co_yield] = ACTIONS(2300),
    [anon_sym_R_DQUOTE] = ACTIONS(2302),
    [anon_sym_LR_DQUOTE] = ACTIONS(2302),
    [anon_sym_uR_DQUOTE] = ACTIONS(2302),
    [anon_sym_UR_DQUOTE] = ACTIONS(2302),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2302),
    [anon_sym_co_await] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_requires] = ACTIONS(2300),
    [sym_this] = ACTIONS(2300),
    [anon_sym___launch_bounds__] = ACTIONS(2300),
  },
  [235] = {
    [sym_identifier] = ACTIONS(2304),
    [aux_sym_preproc_include_token1] = ACTIONS(2304),
    [aux_sym_preproc_def_token1] = ACTIONS(2304),
    [aux_sym_preproc_if_token1] = ACTIONS(2304),
    [aux_sym_preproc_if_token2] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2304),
    [aux_sym_preproc_else_token1] = ACTIONS(2304),
    [aux_sym_preproc_elif_token1] = ACTIONS(2304),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2304),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2304),
    [sym_preproc_directive] = ACTIONS(2304),
    [anon_sym_LPAREN2] = ACTIONS(2306),
    [anon_sym_BANG] = ACTIONS(2306),
    [anon_sym_TILDE] = ACTIONS(2306),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2306),
    [anon_sym___extension__] = ACTIONS(2304),
    [anon_sym_typedef] = ACTIONS(2304),
    [anon_sym___device__] = ACTIONS(2304),
    [anon_sym___host__] = ACTIONS(2304),
    [anon_sym___global__] = ACTIONS(2304),
    [anon_sym___forceinline__] = ACTIONS(2304),
    [anon_sym___noinline__] = ACTIONS(2304),
    [anon_sym_extern] = ACTIONS(2304),
    [anon_sym___attribute__] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2306),
    [anon_sym___declspec] = ACTIONS(2304),
    [anon_sym___based] = ACTIONS(2304),
    [anon_sym___cdecl] = ACTIONS(2304),
    [anon_sym___clrcall] = ACTIONS(2304),
    [anon_sym___stdcall] = ACTIONS(2304),
    [anon_sym___fastcall] = ACTIONS(2304),
    [anon_sym___thiscall] = ACTIONS(2304),
    [anon_sym___vectorcall] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_signed] = ACTIONS(2304),
    [anon_sym_unsigned] = ACTIONS(2304),
    [anon_sym_long] = ACTIONS(2304),
    [anon_sym_short] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_register] = ACTIONS(2304),
    [anon_sym_inline] = ACTIONS(2304),
    [anon_sym___inline] = ACTIONS(2304),
    [anon_sym___inline__] = ACTIONS(2304),
    [anon_sym___forceinline] = ACTIONS(2304),
    [anon_sym_thread_local] = ACTIONS(2304),
    [anon_sym___thread] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_constexpr] = ACTIONS(2304),
    [anon_sym_volatile] = ACTIONS(2304),
    [anon_sym_restrict] = ACTIONS(2304),
    [anon_sym___restrict__] = ACTIONS(2304),
    [anon_sym__Atomic] = ACTIONS(2304),
    [anon_sym__Noreturn] = ACTIONS(2304),
    [anon_sym_noreturn] = ACTIONS(2304),
    [anon_sym_mutable] = ACTIONS(2304),
    [anon_sym_constinit] = ACTIONS(2304),
    [anon_sym_consteval] = ACTIONS(2304),
    [anon_sym___shared__] = ACTIONS(2304),
    [anon_sym___local__] = ACTIONS(2304),
    [anon_sym___constant__] = ACTIONS(2304),
    [anon_sym___managed__] = ACTIONS(2304),
    [anon_sym___grid_constant__] = ACTIONS(2304),
    [anon_sym_alignas] = ACTIONS(2304),
    [anon_sym__Alignas] = ACTIONS(2304),
    [sym_primitive_type] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_struct] = ACTIONS(2304),
    [anon_sym_union] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_case] = ACTIONS(2304),
    [anon_sym_default] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_goto] = ACTIONS(2304),
    [anon_sym___try] = ACTIONS(2304),
    [anon_sym___leave] = ACTIONS(2304),
    [anon_sym_not] = ACTIONS(2304),
    [anon_sym_compl] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_sizeof] = ACTIONS(2304),
    [anon_sym___alignof__] = ACTIONS(2304),
    [anon_sym___alignof] = ACTIONS(2304),
    [anon_sym__alignof] = ACTIONS(2304),
    [anon_sym_alignof] = ACTIONS(2304),
    [anon_sym__Alignof] = ACTIONS(2304),
    [anon_sym_offsetof] = ACTIONS(2304),
    [anon_sym__Generic] = ACTIONS(2304),
    [anon_sym_asm] = ACTIONS(2304),
    [anon_sym___asm__] = ACTIONS(2304),
    [sym_number_literal] = ACTIONS(2306),
    [anon_sym_L_SQUOTE] = ACTIONS(2306),
    [anon_sym_u_SQUOTE] = ACTIONS(2306),
    [anon_sym_U_SQUOTE] = ACTIONS(2306),
    [anon_sym_u8_SQUOTE] = ACTIONS(2306),
    [anon_sym_SQUOTE] = ACTIONS(2306),
    [anon_sym_L_DQUOTE] = ACTIONS(2306),
    [anon_sym_u_DQUOTE] = ACTIONS(2306),
    [anon_sym_U_DQUOTE] = ACTIONS(2306),
    [anon_sym_u8_DQUOTE] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [anon_sym_NULL] = ACTIONS(2304),
    [anon_sym_nullptr] = ACTIONS(2304),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2304),
    [anon_sym_decltype] = ACTIONS(2304),
    [sym_virtual] = ACTIONS(2304),
    [anon_sym_explicit] = ACTIONS(2304),
    [anon_sym_typename] = ACTIONS(2304),
    [anon_sym_template] = ACTIONS(2304),
    [anon_sym_operator] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_delete] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_namespace] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_static_assert] = ACTIONS(2304),
    [anon_sym_concept] = ACTIONS(2304),
    [anon_sym_co_return] = ACTIONS(2304),
    [anon_sym_co_yield] = ACTIONS(2304),
    [anon_sym_R_DQUOTE] = ACTIONS(2306),
    [anon_sym_LR_DQUOTE] = ACTIONS(2306),
    [anon_sym_uR_DQUOTE] = ACTIONS(2306),
    [anon_sym_UR_DQUOTE] = ACTIONS(2306),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2306),
    [anon_sym_co_await] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_requires] = ACTIONS(2304),
    [sym_this] = ACTIONS(2304),
    [anon_sym___launch_bounds__] = ACTIONS(2304),
  },
  [236] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(2985),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8787),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8765),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8983),
    [sym__unary_right_fold] = STATE(8982),
    [sym__binary_fold] = STATE(8978),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8780),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [237] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(2985),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8787),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8902),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8983),
    [sym__unary_right_fold] = STATE(8982),
    [sym__binary_fold] = STATE(8978),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8780),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [238] = {
    [sym_identifier] = ACTIONS(2308),
    [aux_sym_preproc_include_token1] = ACTIONS(2308),
    [aux_sym_preproc_def_token1] = ACTIONS(2308),
    [aux_sym_preproc_if_token1] = ACTIONS(2308),
    [aux_sym_preproc_if_token2] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2308),
    [aux_sym_preproc_else_token1] = ACTIONS(2308),
    [aux_sym_preproc_elif_token1] = ACTIONS(2308),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2308),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2308),
    [sym_preproc_directive] = ACTIONS(2308),
    [anon_sym_LPAREN2] = ACTIONS(2310),
    [anon_sym_BANG] = ACTIONS(2310),
    [anon_sym_TILDE] = ACTIONS(2310),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2310),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym___extension__] = ACTIONS(2308),
    [anon_sym_typedef] = ACTIONS(2308),
    [anon_sym___device__] = ACTIONS(2308),
    [anon_sym___host__] = ACTIONS(2308),
    [anon_sym___global__] = ACTIONS(2308),
    [anon_sym___forceinline__] = ACTIONS(2308),
    [anon_sym___noinline__] = ACTIONS(2308),
    [anon_sym_extern] = ACTIONS(2308),
    [anon_sym___attribute__] = ACTIONS(2308),
    [anon_sym_COLON_COLON] = ACTIONS(2310),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2310),
    [anon_sym___declspec] = ACTIONS(2308),
    [anon_sym___based] = ACTIONS(2308),
    [anon_sym___cdecl] = ACTIONS(2308),
    [anon_sym___clrcall] = ACTIONS(2308),
    [anon_sym___stdcall] = ACTIONS(2308),
    [anon_sym___fastcall] = ACTIONS(2308),
    [anon_sym___thiscall] = ACTIONS(2308),
    [anon_sym___vectorcall] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_signed] = ACTIONS(2308),
    [anon_sym_unsigned] = ACTIONS(2308),
    [anon_sym_long] = ACTIONS(2308),
    [anon_sym_short] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_register] = ACTIONS(2308),
    [anon_sym_inline] = ACTIONS(2308),
    [anon_sym___inline] = ACTIONS(2308),
    [anon_sym___inline__] = ACTIONS(2308),
    [anon_sym___forceinline] = ACTIONS(2308),
    [anon_sym_thread_local] = ACTIONS(2308),
    [anon_sym___thread] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_constexpr] = ACTIONS(2308),
    [anon_sym_volatile] = ACTIONS(2308),
    [anon_sym_restrict] = ACTIONS(2308),
    [anon_sym___restrict__] = ACTIONS(2308),
    [anon_sym__Atomic] = ACTIONS(2308),
    [anon_sym__Noreturn] = ACTIONS(2308),
    [anon_sym_noreturn] = ACTIONS(2308),
    [anon_sym_mutable] = ACTIONS(2308),
    [anon_sym_constinit] = ACTIONS(2308),
    [anon_sym_consteval] = ACTIONS(2308),
    [anon_sym___shared__] = ACTIONS(2308),
    [anon_sym___local__] = ACTIONS(2308),
    [anon_sym___constant__] = ACTIONS(2308),
    [anon_sym___managed__] = ACTIONS(2308),
    [anon_sym___grid_constant__] = ACTIONS(2308),
    [anon_sym_alignas] = ACTIONS(2308),
    [anon_sym__Alignas] = ACTIONS(2308),
    [sym_primitive_type] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
    [anon_sym_class] = ACTIONS(2308),
    [anon_sym_struct] = ACTIONS(2308),
    [anon_sym_union] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_switch] = ACTIONS(2308),
    [anon_sym_case] = ACTIONS(2308),
    [anon_sym_default] = ACTIONS(2308),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_do] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_goto] = ACTIONS(2308),
    [anon_sym___try] = ACTIONS(2308),
    [anon_sym___leave] = ACTIONS(2308),
    [anon_sym_not] = ACTIONS(2308),
    [anon_sym_compl] = ACTIONS(2308),
    [anon_sym_DASH_DASH] = ACTIONS(2310),
    [anon_sym_PLUS_PLUS] = ACTIONS(2310),
    [anon_sym_sizeof] = ACTIONS(2308),
    [anon_sym___alignof__] = ACTIONS(2308),
    [anon_sym___alignof] = ACTIONS(2308),
    [anon_sym__alignof] = ACTIONS(2308),
    [anon_sym_alignof] = ACTIONS(2308),
    [anon_sym__Alignof] = ACTIONS(2308),
    [anon_sym_offsetof] = ACTIONS(2308),
    [anon_sym__Generic] = ACTIONS(2308),
    [anon_sym_asm] = ACTIONS(2308),
    [anon_sym___asm__] = ACTIONS(2308),
    [sym_number_literal] = ACTIONS(2310),
    [anon_sym_L_SQUOTE] = ACTIONS(2310),
    [anon_sym_u_SQUOTE] = ACTIONS(2310),
    [anon_sym_U_SQUOTE] = ACTIONS(2310),
    [anon_sym_u8_SQUOTE] = ACTIONS(2310),
    [anon_sym_SQUOTE] = ACTIONS(2310),
    [anon_sym_L_DQUOTE] = ACTIONS(2310),
    [anon_sym_u_DQUOTE] = ACTIONS(2310),
    [anon_sym_U_DQUOTE] = ACTIONS(2310),
    [anon_sym_u8_DQUOTE] = ACTIONS(2310),
    [anon_sym_DQUOTE] = ACTIONS(2310),
    [sym_true] = ACTIONS(2308),
    [sym_false] = ACTIONS(2308),
    [anon_sym_NULL] = ACTIONS(2308),
    [anon_sym_nullptr] = ACTIONS(2308),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2308),
    [anon_sym_decltype] = ACTIONS(2308),
    [sym_virtual] = ACTIONS(2308),
    [anon_sym_explicit] = ACTIONS(2308),
    [anon_sym_typename] = ACTIONS(2308),
    [anon_sym_template] = ACTIONS(2308),
    [anon_sym_operator] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [anon_sym_delete] = ACTIONS(2308),
    [anon_sym_throw] = ACTIONS(2308),
    [anon_sym_namespace] = ACTIONS(2308),
    [anon_sym_using] = ACTIONS(2308),
    [anon_sym_static_assert] = ACTIONS(2308),
    [anon_sym_concept] = ACTIONS(2308),
    [anon_sym_co_return] = ACTIONS(2308),
    [anon_sym_co_yield] = ACTIONS(2308),
    [anon_sym_R_DQUOTE] = ACTIONS(2310),
    [anon_sym_LR_DQUOTE] = ACTIONS(2310),
    [anon_sym_uR_DQUOTE] = ACTIONS(2310),
    [anon_sym_UR_DQUOTE] = ACTIONS(2310),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2310),
    [anon_sym_co_await] = ACTIONS(2308),
    [anon_sym_new] = ACTIONS(2308),
    [anon_sym_requires] = ACTIONS(2308),
    [sym_this] = ACTIONS(2308),
    [anon_sym___launch_bounds__] = ACTIONS(2308),
  },
  [239] = {
    [sym_identifier] = ACTIONS(2312),
    [aux_sym_preproc_include_token1] = ACTIONS(2312),
    [aux_sym_preproc_def_token1] = ACTIONS(2312),
    [aux_sym_preproc_if_token1] = ACTIONS(2312),
    [aux_sym_preproc_if_token2] = ACTIONS(2312),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2312),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2312),
    [aux_sym_preproc_else_token1] = ACTIONS(2312),
    [aux_sym_preproc_elif_token1] = ACTIONS(2312),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2312),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2312),
    [sym_preproc_directive] = ACTIONS(2312),
    [anon_sym_LPAREN2] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2314),
    [anon_sym_TILDE] = ACTIONS(2314),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_AMP_AMP] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(2314),
    [anon_sym___extension__] = ACTIONS(2312),
    [anon_sym_typedef] = ACTIONS(2312),
    [anon_sym___device__] = ACTIONS(2312),
    [anon_sym___host__] = ACTIONS(2312),
    [anon_sym___global__] = ACTIONS(2312),
    [anon_sym___forceinline__] = ACTIONS(2312),
    [anon_sym___noinline__] = ACTIONS(2312),
    [anon_sym_extern] = ACTIONS(2312),
    [anon_sym___attribute__] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2314),
    [anon_sym___declspec] = ACTIONS(2312),
    [anon_sym___based] = ACTIONS(2312),
    [anon_sym___cdecl] = ACTIONS(2312),
    [anon_sym___clrcall] = ACTIONS(2312),
    [anon_sym___stdcall] = ACTIONS(2312),
    [anon_sym___fastcall] = ACTIONS(2312),
    [anon_sym___thiscall] = ACTIONS(2312),
    [anon_sym___vectorcall] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_signed] = ACTIONS(2312),
    [anon_sym_unsigned] = ACTIONS(2312),
    [anon_sym_long] = ACTIONS(2312),
    [anon_sym_short] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_register] = ACTIONS(2312),
    [anon_sym_inline] = ACTIONS(2312),
    [anon_sym___inline] = ACTIONS(2312),
    [anon_sym___inline__] = ACTIONS(2312),
    [anon_sym___forceinline] = ACTIONS(2312),
    [anon_sym_thread_local] = ACTIONS(2312),
    [anon_sym___thread] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_constexpr] = ACTIONS(2312),
    [anon_sym_volatile] = ACTIONS(2312),
    [anon_sym_restrict] = ACTIONS(2312),
    [anon_sym___restrict__] = ACTIONS(2312),
    [anon_sym__Atomic] = ACTIONS(2312),
    [anon_sym__Noreturn] = ACTIONS(2312),
    [anon_sym_noreturn] = ACTIONS(2312),
    [anon_sym_mutable] = ACTIONS(2312),
    [anon_sym_constinit] = ACTIONS(2312),
    [anon_sym_consteval] = ACTIONS(2312),
    [anon_sym___shared__] = ACTIONS(2312),
    [anon_sym___local__] = ACTIONS(2312),
    [anon_sym___constant__] = ACTIONS(2312),
    [anon_sym___managed__] = ACTIONS(2312),
    [anon_sym___grid_constant__] = ACTIONS(2312),
    [anon_sym_alignas] = ACTIONS(2312),
    [anon_sym__Alignas] = ACTIONS(2312),
    [sym_primitive_type] = ACTIONS(2312),
    [anon_sym_enum] = ACTIONS(2312),
    [anon_sym_class] = ACTIONS(2312),
    [anon_sym_struct] = ACTIONS(2312),
    [anon_sym_union] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_switch] = ACTIONS(2312),
    [anon_sym_case] = ACTIONS(2312),
    [anon_sym_default] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_break] = ACTIONS(2312),
    [anon_sym_continue] = ACTIONS(2312),
    [anon_sym_goto] = ACTIONS(2312),
    [anon_sym___try] = ACTIONS(2312),
    [anon_sym___leave] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2312),
    [anon_sym_compl] = ACTIONS(2312),
    [anon_sym_DASH_DASH] = ACTIONS(2314),
    [anon_sym_PLUS_PLUS] = ACTIONS(2314),
    [anon_sym_sizeof] = ACTIONS(2312),
    [anon_sym___alignof__] = ACTIONS(2312),
    [anon_sym___alignof] = ACTIONS(2312),
    [anon_sym__alignof] = ACTIONS(2312),
    [anon_sym_alignof] = ACTIONS(2312),
    [anon_sym__Alignof] = ACTIONS(2312),
    [anon_sym_offsetof] = ACTIONS(2312),
    [anon_sym__Generic] = ACTIONS(2312),
    [anon_sym_asm] = ACTIONS(2312),
    [anon_sym___asm__] = ACTIONS(2312),
    [sym_number_literal] = ACTIONS(2314),
    [anon_sym_L_SQUOTE] = ACTIONS(2314),
    [anon_sym_u_SQUOTE] = ACTIONS(2314),
    [anon_sym_U_SQUOTE] = ACTIONS(2314),
    [anon_sym_u8_SQUOTE] = ACTIONS(2314),
    [anon_sym_SQUOTE] = ACTIONS(2314),
    [anon_sym_L_DQUOTE] = ACTIONS(2314),
    [anon_sym_u_DQUOTE] = ACTIONS(2314),
    [anon_sym_U_DQUOTE] = ACTIONS(2314),
    [anon_sym_u8_DQUOTE] = ACTIONS(2314),
    [anon_sym_DQUOTE] = ACTIONS(2314),
    [sym_true] = ACTIONS(2312),
    [sym_false] = ACTIONS(2312),
    [anon_sym_NULL] = ACTIONS(2312),
    [anon_sym_nullptr] = ACTIONS(2312),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2312),
    [anon_sym_decltype] = ACTIONS(2312),
    [sym_virtual] = ACTIONS(2312),
    [anon_sym_explicit] = ACTIONS(2312),
    [anon_sym_typename] = ACTIONS(2312),
    [anon_sym_template] = ACTIONS(2312),
    [anon_sym_operator] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_delete] = ACTIONS(2312),
    [anon_sym_throw] = ACTIONS(2312),
    [anon_sym_namespace] = ACTIONS(2312),
    [anon_sym_using] = ACTIONS(2312),
    [anon_sym_static_assert] = ACTIONS(2312),
    [anon_sym_concept] = ACTIONS(2312),
    [anon_sym_co_return] = ACTIONS(2312),
    [anon_sym_co_yield] = ACTIONS(2312),
    [anon_sym_R_DQUOTE] = ACTIONS(2314),
    [anon_sym_LR_DQUOTE] = ACTIONS(2314),
    [anon_sym_uR_DQUOTE] = ACTIONS(2314),
    [anon_sym_UR_DQUOTE] = ACTIONS(2314),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2314),
    [anon_sym_co_await] = ACTIONS(2312),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_requires] = ACTIONS(2312),
    [sym_this] = ACTIONS(2312),
    [anon_sym___launch_bounds__] = ACTIONS(2312),
  },
  [240] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(2960),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8499),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8616),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8509),
    [sym__unary_right_fold] = STATE(8507),
    [sym__binary_fold] = STATE(8501),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8481),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [241] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(2960),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8499),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8407),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8509),
    [sym__unary_right_fold] = STATE(8507),
    [sym__binary_fold] = STATE(8501),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8481),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [242] = {
    [sym_identifier] = ACTIONS(2316),
    [aux_sym_preproc_include_token1] = ACTIONS(2316),
    [aux_sym_preproc_def_token1] = ACTIONS(2316),
    [aux_sym_preproc_if_token1] = ACTIONS(2316),
    [aux_sym_preproc_if_token2] = ACTIONS(2316),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2316),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2316),
    [aux_sym_preproc_else_token1] = ACTIONS(2316),
    [aux_sym_preproc_elif_token1] = ACTIONS(2316),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2316),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2316),
    [sym_preproc_directive] = ACTIONS(2316),
    [anon_sym_LPAREN2] = ACTIONS(2318),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2318),
    [anon_sym_DASH] = ACTIONS(2316),
    [anon_sym_PLUS] = ACTIONS(2316),
    [anon_sym_STAR] = ACTIONS(2318),
    [anon_sym_AMP_AMP] = ACTIONS(2318),
    [anon_sym_AMP] = ACTIONS(2316),
    [anon_sym_SEMI] = ACTIONS(2318),
    [anon_sym___extension__] = ACTIONS(2316),
    [anon_sym_typedef] = ACTIONS(2316),
    [anon_sym___device__] = ACTIONS(2316),
    [anon_sym___host__] = ACTIONS(2316),
    [anon_sym___global__] = ACTIONS(2316),
    [anon_sym___forceinline__] = ACTIONS(2316),
    [anon_sym___noinline__] = ACTIONS(2316),
    [anon_sym_extern] = ACTIONS(2316),
    [anon_sym___attribute__] = ACTIONS(2316),
    [anon_sym_COLON_COLON] = ACTIONS(2318),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2318),
    [anon_sym___declspec] = ACTIONS(2316),
    [anon_sym___based] = ACTIONS(2316),
    [anon_sym___cdecl] = ACTIONS(2316),
    [anon_sym___clrcall] = ACTIONS(2316),
    [anon_sym___stdcall] = ACTIONS(2316),
    [anon_sym___fastcall] = ACTIONS(2316),
    [anon_sym___thiscall] = ACTIONS(2316),
    [anon_sym___vectorcall] = ACTIONS(2316),
    [anon_sym_LBRACE] = ACTIONS(2318),
    [anon_sym_signed] = ACTIONS(2316),
    [anon_sym_unsigned] = ACTIONS(2316),
    [anon_sym_long] = ACTIONS(2316),
    [anon_sym_short] = ACTIONS(2316),
    [anon_sym_LBRACK] = ACTIONS(2316),
    [anon_sym_static] = ACTIONS(2316),
    [anon_sym_register] = ACTIONS(2316),
    [anon_sym_inline] = ACTIONS(2316),
    [anon_sym___inline] = ACTIONS(2316),
    [anon_sym___inline__] = ACTIONS(2316),
    [anon_sym___forceinline] = ACTIONS(2316),
    [anon_sym_thread_local] = ACTIONS(2316),
    [anon_sym___thread] = ACTIONS(2316),
    [anon_sym_const] = ACTIONS(2316),
    [anon_sym_constexpr] = ACTIONS(2316),
    [anon_sym_volatile] = ACTIONS(2316),
    [anon_sym_restrict] = ACTIONS(2316),
    [anon_sym___restrict__] = ACTIONS(2316),
    [anon_sym__Atomic] = ACTIONS(2316),
    [anon_sym__Noreturn] = ACTIONS(2316),
    [anon_sym_noreturn] = ACTIONS(2316),
    [anon_sym_mutable] = ACTIONS(2316),
    [anon_sym_constinit] = ACTIONS(2316),
    [anon_sym_consteval] = ACTIONS(2316),
    [anon_sym___shared__] = ACTIONS(2316),
    [anon_sym___local__] = ACTIONS(2316),
    [anon_sym___constant__] = ACTIONS(2316),
    [anon_sym___managed__] = ACTIONS(2316),
    [anon_sym___grid_constant__] = ACTIONS(2316),
    [anon_sym_alignas] = ACTIONS(2316),
    [anon_sym__Alignas] = ACTIONS(2316),
    [sym_primitive_type] = ACTIONS(2316),
    [anon_sym_enum] = ACTIONS(2316),
    [anon_sym_class] = ACTIONS(2316),
    [anon_sym_struct] = ACTIONS(2316),
    [anon_sym_union] = ACTIONS(2316),
    [anon_sym_if] = ACTIONS(2316),
    [anon_sym_switch] = ACTIONS(2316),
    [anon_sym_case] = ACTIONS(2316),
    [anon_sym_default] = ACTIONS(2316),
    [anon_sym_while] = ACTIONS(2316),
    [anon_sym_do] = ACTIONS(2316),
    [anon_sym_for] = ACTIONS(2316),
    [anon_sym_return] = ACTIONS(2316),
    [anon_sym_break] = ACTIONS(2316),
    [anon_sym_continue] = ACTIONS(2316),
    [anon_sym_goto] = ACTIONS(2316),
    [anon_sym___try] = ACTIONS(2316),
    [anon_sym___leave] = ACTIONS(2316),
    [anon_sym_not] = ACTIONS(2316),
    [anon_sym_compl] = ACTIONS(2316),
    [anon_sym_DASH_DASH] = ACTIONS(2318),
    [anon_sym_PLUS_PLUS] = ACTIONS(2318),
    [anon_sym_sizeof] = ACTIONS(2316),
    [anon_sym___alignof__] = ACTIONS(2316),
    [anon_sym___alignof] = ACTIONS(2316),
    [anon_sym__alignof] = ACTIONS(2316),
    [anon_sym_alignof] = ACTIONS(2316),
    [anon_sym__Alignof] = ACTIONS(2316),
    [anon_sym_offsetof] = ACTIONS(2316),
    [anon_sym__Generic] = ACTIONS(2316),
    [anon_sym_asm] = ACTIONS(2316),
    [anon_sym___asm__] = ACTIONS(2316),
    [sym_number_literal] = ACTIONS(2318),
    [anon_sym_L_SQUOTE] = ACTIONS(2318),
    [anon_sym_u_SQUOTE] = ACTIONS(2318),
    [anon_sym_U_SQUOTE] = ACTIONS(2318),
    [anon_sym_u8_SQUOTE] = ACTIONS(2318),
    [anon_sym_SQUOTE] = ACTIONS(2318),
    [anon_sym_L_DQUOTE] = ACTIONS(2318),
    [anon_sym_u_DQUOTE] = ACTIONS(2318),
    [anon_sym_U_DQUOTE] = ACTIONS(2318),
    [anon_sym_u8_DQUOTE] = ACTIONS(2318),
    [anon_sym_DQUOTE] = ACTIONS(2318),
    [sym_true] = ACTIONS(2316),
    [sym_false] = ACTIONS(2316),
    [anon_sym_NULL] = ACTIONS(2316),
    [anon_sym_nullptr] = ACTIONS(2316),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2316),
    [anon_sym_decltype] = ACTIONS(2316),
    [sym_virtual] = ACTIONS(2316),
    [anon_sym_explicit] = ACTIONS(2316),
    [anon_sym_typename] = ACTIONS(2316),
    [anon_sym_template] = ACTIONS(2316),
    [anon_sym_operator] = ACTIONS(2316),
    [anon_sym_try] = ACTIONS(2316),
    [anon_sym_delete] = ACTIONS(2316),
    [anon_sym_throw] = ACTIONS(2316),
    [anon_sym_namespace] = ACTIONS(2316),
    [anon_sym_using] = ACTIONS(2316),
    [anon_sym_static_assert] = ACTIONS(2316),
    [anon_sym_concept] = ACTIONS(2316),
    [anon_sym_co_return] = ACTIONS(2316),
    [anon_sym_co_yield] = ACTIONS(2316),
    [anon_sym_R_DQUOTE] = ACTIONS(2318),
    [anon_sym_LR_DQUOTE] = ACTIONS(2318),
    [anon_sym_uR_DQUOTE] = ACTIONS(2318),
    [anon_sym_UR_DQUOTE] = ACTIONS(2318),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2318),
    [anon_sym_co_await] = ACTIONS(2316),
    [anon_sym_new] = ACTIONS(2316),
    [anon_sym_requires] = ACTIONS(2316),
    [sym_this] = ACTIONS(2316),
    [anon_sym___launch_bounds__] = ACTIONS(2316),
  },
  [243] = {
    [sym_catch_clause] = STATE(282),
    [aux_sym_constructor_try_statement_repeat1] = STATE(282),
    [ts_builtin_sym_end] = ACTIONS(1905),
    [sym_identifier] = ACTIONS(1903),
    [aux_sym_preproc_include_token1] = ACTIONS(1903),
    [aux_sym_preproc_def_token1] = ACTIONS(1903),
    [aux_sym_preproc_if_token1] = ACTIONS(1903),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1903),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1903),
    [sym_preproc_directive] = ACTIONS(1903),
    [anon_sym_LPAREN2] = ACTIONS(1905),
    [anon_sym_BANG] = ACTIONS(1905),
    [anon_sym_TILDE] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(1903),
    [anon_sym_PLUS] = ACTIONS(1903),
    [anon_sym_STAR] = ACTIONS(1905),
    [anon_sym_AMP_AMP] = ACTIONS(1905),
    [anon_sym_AMP] = ACTIONS(1903),
    [anon_sym_SEMI] = ACTIONS(1905),
    [anon_sym___extension__] = ACTIONS(1903),
    [anon_sym_typedef] = ACTIONS(1903),
    [anon_sym___device__] = ACTIONS(1903),
    [anon_sym___host__] = ACTIONS(1903),
    [anon_sym___global__] = ACTIONS(1903),
    [anon_sym___forceinline__] = ACTIONS(1903),
    [anon_sym___noinline__] = ACTIONS(1903),
    [anon_sym_extern] = ACTIONS(1903),
    [anon_sym___attribute__] = ACTIONS(1903),
    [anon_sym_COLON_COLON] = ACTIONS(1905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1905),
    [anon_sym___declspec] = ACTIONS(1903),
    [anon_sym___based] = ACTIONS(1903),
    [anon_sym___cdecl] = ACTIONS(1903),
    [anon_sym___clrcall] = ACTIONS(1903),
    [anon_sym___stdcall] = ACTIONS(1903),
    [anon_sym___fastcall] = ACTIONS(1903),
    [anon_sym___thiscall] = ACTIONS(1903),
    [anon_sym___vectorcall] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1905),
    [anon_sym_signed] = ACTIONS(1903),
    [anon_sym_unsigned] = ACTIONS(1903),
    [anon_sym_long] = ACTIONS(1903),
    [anon_sym_short] = ACTIONS(1903),
    [anon_sym_LBRACK] = ACTIONS(1903),
    [anon_sym_static] = ACTIONS(1903),
    [anon_sym_register] = ACTIONS(1903),
    [anon_sym_inline] = ACTIONS(1903),
    [anon_sym___inline] = ACTIONS(1903),
    [anon_sym___inline__] = ACTIONS(1903),
    [anon_sym___forceinline] = ACTIONS(1903),
    [anon_sym_thread_local] = ACTIONS(1903),
    [anon_sym___thread] = ACTIONS(1903),
    [anon_sym_const] = ACTIONS(1903),
    [anon_sym_constexpr] = ACTIONS(1903),
    [anon_sym_volatile] = ACTIONS(1903),
    [anon_sym_restrict] = ACTIONS(1903),
    [anon_sym___restrict__] = ACTIONS(1903),
    [anon_sym__Atomic] = ACTIONS(1903),
    [anon_sym__Noreturn] = ACTIONS(1903),
    [anon_sym_noreturn] = ACTIONS(1903),
    [anon_sym_mutable] = ACTIONS(1903),
    [anon_sym_constinit] = ACTIONS(1903),
    [anon_sym_consteval] = ACTIONS(1903),
    [anon_sym___shared__] = ACTIONS(1903),
    [anon_sym___local__] = ACTIONS(1903),
    [anon_sym___constant__] = ACTIONS(1903),
    [anon_sym___managed__] = ACTIONS(1903),
    [anon_sym___grid_constant__] = ACTIONS(1903),
    [anon_sym_alignas] = ACTIONS(1903),
    [anon_sym__Alignas] = ACTIONS(1903),
    [sym_primitive_type] = ACTIONS(1903),
    [anon_sym_enum] = ACTIONS(1903),
    [anon_sym_class] = ACTIONS(1903),
    [anon_sym_struct] = ACTIONS(1903),
    [anon_sym_union] = ACTIONS(1903),
    [anon_sym_if] = ACTIONS(1903),
    [anon_sym_else] = ACTIONS(1903),
    [anon_sym_switch] = ACTIONS(1903),
    [anon_sym_case] = ACTIONS(1903),
    [anon_sym_default] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1903),
    [anon_sym_do] = ACTIONS(1903),
    [anon_sym_for] = ACTIONS(1903),
    [anon_sym_return] = ACTIONS(1903),
    [anon_sym_break] = ACTIONS(1903),
    [anon_sym_continue] = ACTIONS(1903),
    [anon_sym_goto] = ACTIONS(1903),
    [anon_sym___try] = ACTIONS(1903),
    [anon_sym___leave] = ACTIONS(1903),
    [anon_sym_not] = ACTIONS(1903),
    [anon_sym_compl] = ACTIONS(1903),
    [anon_sym_DASH_DASH] = ACTIONS(1905),
    [anon_sym_PLUS_PLUS] = ACTIONS(1905),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1903),
    [anon_sym___alignof] = ACTIONS(1903),
    [anon_sym__alignof] = ACTIONS(1903),
    [anon_sym_alignof] = ACTIONS(1903),
    [anon_sym__Alignof] = ACTIONS(1903),
    [anon_sym_offsetof] = ACTIONS(1903),
    [anon_sym__Generic] = ACTIONS(1903),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [sym_number_literal] = ACTIONS(1905),
    [anon_sym_L_SQUOTE] = ACTIONS(1905),
    [anon_sym_u_SQUOTE] = ACTIONS(1905),
    [anon_sym_U_SQUOTE] = ACTIONS(1905),
    [anon_sym_u8_SQUOTE] = ACTIONS(1905),
    [anon_sym_SQUOTE] = ACTIONS(1905),
    [anon_sym_L_DQUOTE] = ACTIONS(1905),
    [anon_sym_u_DQUOTE] = ACTIONS(1905),
    [anon_sym_U_DQUOTE] = ACTIONS(1905),
    [anon_sym_u8_DQUOTE] = ACTIONS(1905),
    [anon_sym_DQUOTE] = ACTIONS(1905),
    [sym_true] = ACTIONS(1903),
    [sym_false] = ACTIONS(1903),
    [anon_sym_NULL] = ACTIONS(1903),
    [anon_sym_nullptr] = ACTIONS(1903),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1903),
    [anon_sym_decltype] = ACTIONS(1903),
    [sym_virtual] = ACTIONS(1903),
    [anon_sym_explicit] = ACTIONS(1903),
    [anon_sym_typename] = ACTIONS(1903),
    [anon_sym_template] = ACTIONS(1903),
    [anon_sym_operator] = ACTIONS(1903),
    [anon_sym_try] = ACTIONS(1903),
    [anon_sym_delete] = ACTIONS(1903),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_namespace] = ACTIONS(1903),
    [anon_sym_using] = ACTIONS(1903),
    [anon_sym_static_assert] = ACTIONS(1903),
    [anon_sym_concept] = ACTIONS(1903),
    [anon_sym_co_return] = ACTIONS(1903),
    [anon_sym_co_yield] = ACTIONS(1903),
    [anon_sym_catch] = ACTIONS(2320),
    [anon_sym_R_DQUOTE] = ACTIONS(1905),
    [anon_sym_LR_DQUOTE] = ACTIONS(1905),
    [anon_sym_uR_DQUOTE] = ACTIONS(1905),
    [anon_sym_UR_DQUOTE] = ACTIONS(1905),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1905),
    [anon_sym_co_await] = ACTIONS(1903),
    [anon_sym_new] = ACTIONS(1903),
    [anon_sym_requires] = ACTIONS(1903),
    [sym_this] = ACTIONS(1903),
    [anon_sym___launch_bounds__] = ACTIONS(1903),
  },
  [244] = {
    [sym_catch_clause] = STATE(192),
    [aux_sym_constructor_try_statement_repeat1] = STATE(192),
    [sym_identifier] = ACTIONS(1903),
    [aux_sym_preproc_include_token1] = ACTIONS(1903),
    [aux_sym_preproc_def_token1] = ACTIONS(1903),
    [aux_sym_preproc_if_token1] = ACTIONS(1903),
    [aux_sym_preproc_if_token2] = ACTIONS(1903),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1903),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1903),
    [sym_preproc_directive] = ACTIONS(1903),
    [anon_sym_LPAREN2] = ACTIONS(1905),
    [anon_sym_BANG] = ACTIONS(1905),
    [anon_sym_TILDE] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(1903),
    [anon_sym_PLUS] = ACTIONS(1903),
    [anon_sym_STAR] = ACTIONS(1905),
    [anon_sym_AMP_AMP] = ACTIONS(1905),
    [anon_sym_AMP] = ACTIONS(1903),
    [anon_sym_SEMI] = ACTIONS(1905),
    [anon_sym___extension__] = ACTIONS(1903),
    [anon_sym_typedef] = ACTIONS(1903),
    [anon_sym___device__] = ACTIONS(1903),
    [anon_sym___host__] = ACTIONS(1903),
    [anon_sym___global__] = ACTIONS(1903),
    [anon_sym___forceinline__] = ACTIONS(1903),
    [anon_sym___noinline__] = ACTIONS(1903),
    [anon_sym_extern] = ACTIONS(1903),
    [anon_sym___attribute__] = ACTIONS(1903),
    [anon_sym_COLON_COLON] = ACTIONS(1905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1905),
    [anon_sym___declspec] = ACTIONS(1903),
    [anon_sym___based] = ACTIONS(1903),
    [anon_sym___cdecl] = ACTIONS(1903),
    [anon_sym___clrcall] = ACTIONS(1903),
    [anon_sym___stdcall] = ACTIONS(1903),
    [anon_sym___fastcall] = ACTIONS(1903),
    [anon_sym___thiscall] = ACTIONS(1903),
    [anon_sym___vectorcall] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1905),
    [anon_sym_signed] = ACTIONS(1903),
    [anon_sym_unsigned] = ACTIONS(1903),
    [anon_sym_long] = ACTIONS(1903),
    [anon_sym_short] = ACTIONS(1903),
    [anon_sym_LBRACK] = ACTIONS(1903),
    [anon_sym_static] = ACTIONS(1903),
    [anon_sym_register] = ACTIONS(1903),
    [anon_sym_inline] = ACTIONS(1903),
    [anon_sym___inline] = ACTIONS(1903),
    [anon_sym___inline__] = ACTIONS(1903),
    [anon_sym___forceinline] = ACTIONS(1903),
    [anon_sym_thread_local] = ACTIONS(1903),
    [anon_sym___thread] = ACTIONS(1903),
    [anon_sym_const] = ACTIONS(1903),
    [anon_sym_constexpr] = ACTIONS(1903),
    [anon_sym_volatile] = ACTIONS(1903),
    [anon_sym_restrict] = ACTIONS(1903),
    [anon_sym___restrict__] = ACTIONS(1903),
    [anon_sym__Atomic] = ACTIONS(1903),
    [anon_sym__Noreturn] = ACTIONS(1903),
    [anon_sym_noreturn] = ACTIONS(1903),
    [anon_sym_mutable] = ACTIONS(1903),
    [anon_sym_constinit] = ACTIONS(1903),
    [anon_sym_consteval] = ACTIONS(1903),
    [anon_sym___shared__] = ACTIONS(1903),
    [anon_sym___local__] = ACTIONS(1903),
    [anon_sym___constant__] = ACTIONS(1903),
    [anon_sym___managed__] = ACTIONS(1903),
    [anon_sym___grid_constant__] = ACTIONS(1903),
    [anon_sym_alignas] = ACTIONS(1903),
    [anon_sym__Alignas] = ACTIONS(1903),
    [sym_primitive_type] = ACTIONS(1903),
    [anon_sym_enum] = ACTIONS(1903),
    [anon_sym_class] = ACTIONS(1903),
    [anon_sym_struct] = ACTIONS(1903),
    [anon_sym_union] = ACTIONS(1903),
    [anon_sym_if] = ACTIONS(1903),
    [anon_sym_else] = ACTIONS(1903),
    [anon_sym_switch] = ACTIONS(1903),
    [anon_sym_case] = ACTIONS(1903),
    [anon_sym_default] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1903),
    [anon_sym_do] = ACTIONS(1903),
    [anon_sym_for] = ACTIONS(1903),
    [anon_sym_return] = ACTIONS(1903),
    [anon_sym_break] = ACTIONS(1903),
    [anon_sym_continue] = ACTIONS(1903),
    [anon_sym_goto] = ACTIONS(1903),
    [anon_sym___try] = ACTIONS(1903),
    [anon_sym___leave] = ACTIONS(1903),
    [anon_sym_not] = ACTIONS(1903),
    [anon_sym_compl] = ACTIONS(1903),
    [anon_sym_DASH_DASH] = ACTIONS(1905),
    [anon_sym_PLUS_PLUS] = ACTIONS(1905),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1903),
    [anon_sym___alignof] = ACTIONS(1903),
    [anon_sym__alignof] = ACTIONS(1903),
    [anon_sym_alignof] = ACTIONS(1903),
    [anon_sym__Alignof] = ACTIONS(1903),
    [anon_sym_offsetof] = ACTIONS(1903),
    [anon_sym__Generic] = ACTIONS(1903),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [sym_number_literal] = ACTIONS(1905),
    [anon_sym_L_SQUOTE] = ACTIONS(1905),
    [anon_sym_u_SQUOTE] = ACTIONS(1905),
    [anon_sym_U_SQUOTE] = ACTIONS(1905),
    [anon_sym_u8_SQUOTE] = ACTIONS(1905),
    [anon_sym_SQUOTE] = ACTIONS(1905),
    [anon_sym_L_DQUOTE] = ACTIONS(1905),
    [anon_sym_u_DQUOTE] = ACTIONS(1905),
    [anon_sym_U_DQUOTE] = ACTIONS(1905),
    [anon_sym_u8_DQUOTE] = ACTIONS(1905),
    [anon_sym_DQUOTE] = ACTIONS(1905),
    [sym_true] = ACTIONS(1903),
    [sym_false] = ACTIONS(1903),
    [anon_sym_NULL] = ACTIONS(1903),
    [anon_sym_nullptr] = ACTIONS(1903),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1903),
    [anon_sym_decltype] = ACTIONS(1903),
    [sym_virtual] = ACTIONS(1903),
    [anon_sym_explicit] = ACTIONS(1903),
    [anon_sym_typename] = ACTIONS(1903),
    [anon_sym_template] = ACTIONS(1903),
    [anon_sym_operator] = ACTIONS(1903),
    [anon_sym_try] = ACTIONS(1903),
    [anon_sym_delete] = ACTIONS(1903),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_namespace] = ACTIONS(1903),
    [anon_sym_using] = ACTIONS(1903),
    [anon_sym_static_assert] = ACTIONS(1903),
    [anon_sym_concept] = ACTIONS(1903),
    [anon_sym_co_return] = ACTIONS(1903),
    [anon_sym_co_yield] = ACTIONS(1903),
    [anon_sym_catch] = ACTIONS(2322),
    [anon_sym_R_DQUOTE] = ACTIONS(1905),
    [anon_sym_LR_DQUOTE] = ACTIONS(1905),
    [anon_sym_uR_DQUOTE] = ACTIONS(1905),
    [anon_sym_UR_DQUOTE] = ACTIONS(1905),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1905),
    [anon_sym_co_await] = ACTIONS(1903),
    [anon_sym_new] = ACTIONS(1903),
    [anon_sym_requires] = ACTIONS(1903),
    [sym_this] = ACTIONS(1903),
    [anon_sym___launch_bounds__] = ACTIONS(1903),
  },
  [245] = {
    [sym_preproc_def] = STATE(224),
    [sym_preproc_function_def] = STATE(224),
    [sym_preproc_call] = STATE(224),
    [sym_preproc_if_in_field_declaration_list] = STATE(224),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(224),
    [sym_preproc_else_in_field_declaration_list] = STATE(8251),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8251),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8251),
    [sym_type_definition] = STATE(224),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5944),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6464),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(224),
    [sym_field_declaration] = STATE(224),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1701),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(224),
    [sym_operator_cast] = STATE(6994),
    [sym_inline_method_definition] = STATE(224),
    [sym__constructor_specifiers] = STATE(1701),
    [sym_operator_cast_definition] = STATE(224),
    [sym_operator_cast_declaration] = STATE(224),
    [sym_constructor_or_destructor_definition] = STATE(224),
    [sym_constructor_or_destructor_declaration] = STATE(224),
    [sym_friend_declaration] = STATE(224),
    [sym_access_specifier] = STATE(9001),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(224),
    [sym_alias_declaration] = STATE(224),
    [sym_static_assert_declaration] = STATE(224),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6994),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(224),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1701),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(2100),
    [aux_sym_preproc_if_token1] = ACTIONS(2102),
    [aux_sym_preproc_if_token2] = ACTIONS(2324),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2106),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2106),
    [aux_sym_preproc_else_token1] = ACTIONS(2108),
    [aux_sym_preproc_elif_token1] = ACTIONS(2110),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2112),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2112),
    [sym_preproc_directive] = ACTIONS(2114),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(2124),
    [anon_sym_typedef] = ACTIONS(2126),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(2144),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2146),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(2150),
    [anon_sym_static_assert] = ACTIONS(2152),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [246] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(2958),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8293),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8669),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8784),
    [sym__unary_right_fold] = STATE(8731),
    [sym__binary_fold] = STATE(8781),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8313),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [247] = {
    [sym_identifier] = ACTIONS(2326),
    [aux_sym_preproc_include_token1] = ACTIONS(2326),
    [aux_sym_preproc_def_token1] = ACTIONS(2326),
    [aux_sym_preproc_if_token1] = ACTIONS(2326),
    [aux_sym_preproc_if_token2] = ACTIONS(2326),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2326),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2326),
    [aux_sym_preproc_else_token1] = ACTIONS(2326),
    [aux_sym_preproc_elif_token1] = ACTIONS(2326),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2326),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2326),
    [sym_preproc_directive] = ACTIONS(2326),
    [anon_sym_LPAREN2] = ACTIONS(2328),
    [anon_sym_BANG] = ACTIONS(2328),
    [anon_sym_TILDE] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_STAR] = ACTIONS(2328),
    [anon_sym_AMP_AMP] = ACTIONS(2328),
    [anon_sym_AMP] = ACTIONS(2326),
    [anon_sym_SEMI] = ACTIONS(2328),
    [anon_sym___extension__] = ACTIONS(2326),
    [anon_sym_typedef] = ACTIONS(2326),
    [anon_sym___device__] = ACTIONS(2326),
    [anon_sym___host__] = ACTIONS(2326),
    [anon_sym___global__] = ACTIONS(2326),
    [anon_sym___forceinline__] = ACTIONS(2326),
    [anon_sym___noinline__] = ACTIONS(2326),
    [anon_sym_extern] = ACTIONS(2326),
    [anon_sym___attribute__] = ACTIONS(2326),
    [anon_sym_COLON_COLON] = ACTIONS(2328),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2328),
    [anon_sym___declspec] = ACTIONS(2326),
    [anon_sym___based] = ACTIONS(2326),
    [anon_sym___cdecl] = ACTIONS(2326),
    [anon_sym___clrcall] = ACTIONS(2326),
    [anon_sym___stdcall] = ACTIONS(2326),
    [anon_sym___fastcall] = ACTIONS(2326),
    [anon_sym___thiscall] = ACTIONS(2326),
    [anon_sym___vectorcall] = ACTIONS(2326),
    [anon_sym_LBRACE] = ACTIONS(2328),
    [anon_sym_signed] = ACTIONS(2326),
    [anon_sym_unsigned] = ACTIONS(2326),
    [anon_sym_long] = ACTIONS(2326),
    [anon_sym_short] = ACTIONS(2326),
    [anon_sym_LBRACK] = ACTIONS(2326),
    [anon_sym_static] = ACTIONS(2326),
    [anon_sym_register] = ACTIONS(2326),
    [anon_sym_inline] = ACTIONS(2326),
    [anon_sym___inline] = ACTIONS(2326),
    [anon_sym___inline__] = ACTIONS(2326),
    [anon_sym___forceinline] = ACTIONS(2326),
    [anon_sym_thread_local] = ACTIONS(2326),
    [anon_sym___thread] = ACTIONS(2326),
    [anon_sym_const] = ACTIONS(2326),
    [anon_sym_constexpr] = ACTIONS(2326),
    [anon_sym_volatile] = ACTIONS(2326),
    [anon_sym_restrict] = ACTIONS(2326),
    [anon_sym___restrict__] = ACTIONS(2326),
    [anon_sym__Atomic] = ACTIONS(2326),
    [anon_sym__Noreturn] = ACTIONS(2326),
    [anon_sym_noreturn] = ACTIONS(2326),
    [anon_sym_mutable] = ACTIONS(2326),
    [anon_sym_constinit] = ACTIONS(2326),
    [anon_sym_consteval] = ACTIONS(2326),
    [anon_sym___shared__] = ACTIONS(2326),
    [anon_sym___local__] = ACTIONS(2326),
    [anon_sym___constant__] = ACTIONS(2326),
    [anon_sym___managed__] = ACTIONS(2326),
    [anon_sym___grid_constant__] = ACTIONS(2326),
    [anon_sym_alignas] = ACTIONS(2326),
    [anon_sym__Alignas] = ACTIONS(2326),
    [sym_primitive_type] = ACTIONS(2326),
    [anon_sym_enum] = ACTIONS(2326),
    [anon_sym_class] = ACTIONS(2326),
    [anon_sym_struct] = ACTIONS(2326),
    [anon_sym_union] = ACTIONS(2326),
    [anon_sym_if] = ACTIONS(2326),
    [anon_sym_switch] = ACTIONS(2326),
    [anon_sym_case] = ACTIONS(2326),
    [anon_sym_default] = ACTIONS(2326),
    [anon_sym_while] = ACTIONS(2326),
    [anon_sym_do] = ACTIONS(2326),
    [anon_sym_for] = ACTIONS(2326),
    [anon_sym_return] = ACTIONS(2326),
    [anon_sym_break] = ACTIONS(2326),
    [anon_sym_continue] = ACTIONS(2326),
    [anon_sym_goto] = ACTIONS(2326),
    [anon_sym___try] = ACTIONS(2326),
    [anon_sym___leave] = ACTIONS(2326),
    [anon_sym_not] = ACTIONS(2326),
    [anon_sym_compl] = ACTIONS(2326),
    [anon_sym_DASH_DASH] = ACTIONS(2328),
    [anon_sym_PLUS_PLUS] = ACTIONS(2328),
    [anon_sym_sizeof] = ACTIONS(2326),
    [anon_sym___alignof__] = ACTIONS(2326),
    [anon_sym___alignof] = ACTIONS(2326),
    [anon_sym__alignof] = ACTIONS(2326),
    [anon_sym_alignof] = ACTIONS(2326),
    [anon_sym__Alignof] = ACTIONS(2326),
    [anon_sym_offsetof] = ACTIONS(2326),
    [anon_sym__Generic] = ACTIONS(2326),
    [anon_sym_asm] = ACTIONS(2326),
    [anon_sym___asm__] = ACTIONS(2326),
    [sym_number_literal] = ACTIONS(2328),
    [anon_sym_L_SQUOTE] = ACTIONS(2328),
    [anon_sym_u_SQUOTE] = ACTIONS(2328),
    [anon_sym_U_SQUOTE] = ACTIONS(2328),
    [anon_sym_u8_SQUOTE] = ACTIONS(2328),
    [anon_sym_SQUOTE] = ACTIONS(2328),
    [anon_sym_L_DQUOTE] = ACTIONS(2328),
    [anon_sym_u_DQUOTE] = ACTIONS(2328),
    [anon_sym_U_DQUOTE] = ACTIONS(2328),
    [anon_sym_u8_DQUOTE] = ACTIONS(2328),
    [anon_sym_DQUOTE] = ACTIONS(2328),
    [sym_true] = ACTIONS(2326),
    [sym_false] = ACTIONS(2326),
    [anon_sym_NULL] = ACTIONS(2326),
    [anon_sym_nullptr] = ACTIONS(2326),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2326),
    [anon_sym_decltype] = ACTIONS(2326),
    [sym_virtual] = ACTIONS(2326),
    [anon_sym_explicit] = ACTIONS(2326),
    [anon_sym_typename] = ACTIONS(2326),
    [anon_sym_template] = ACTIONS(2326),
    [anon_sym_operator] = ACTIONS(2326),
    [anon_sym_try] = ACTIONS(2326),
    [anon_sym_delete] = ACTIONS(2326),
    [anon_sym_throw] = ACTIONS(2326),
    [anon_sym_namespace] = ACTIONS(2326),
    [anon_sym_using] = ACTIONS(2326),
    [anon_sym_static_assert] = ACTIONS(2326),
    [anon_sym_concept] = ACTIONS(2326),
    [anon_sym_co_return] = ACTIONS(2326),
    [anon_sym_co_yield] = ACTIONS(2326),
    [anon_sym_R_DQUOTE] = ACTIONS(2328),
    [anon_sym_LR_DQUOTE] = ACTIONS(2328),
    [anon_sym_uR_DQUOTE] = ACTIONS(2328),
    [anon_sym_UR_DQUOTE] = ACTIONS(2328),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2328),
    [anon_sym_co_await] = ACTIONS(2326),
    [anon_sym_new] = ACTIONS(2326),
    [anon_sym_requires] = ACTIONS(2326),
    [sym_this] = ACTIONS(2326),
    [anon_sym___launch_bounds__] = ACTIONS(2326),
  },
  [248] = {
    [sym_identifier] = ACTIONS(2330),
    [aux_sym_preproc_include_token1] = ACTIONS(2330),
    [aux_sym_preproc_def_token1] = ACTIONS(2330),
    [aux_sym_preproc_if_token1] = ACTIONS(2330),
    [aux_sym_preproc_if_token2] = ACTIONS(2330),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2330),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2330),
    [aux_sym_preproc_else_token1] = ACTIONS(2330),
    [aux_sym_preproc_elif_token1] = ACTIONS(2330),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2330),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2330),
    [sym_preproc_directive] = ACTIONS(2330),
    [anon_sym_LPAREN2] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2332),
    [anon_sym_TILDE] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(2330),
    [anon_sym_STAR] = ACTIONS(2332),
    [anon_sym_AMP_AMP] = ACTIONS(2332),
    [anon_sym_AMP] = ACTIONS(2330),
    [anon_sym_SEMI] = ACTIONS(2332),
    [anon_sym___extension__] = ACTIONS(2330),
    [anon_sym_typedef] = ACTIONS(2330),
    [anon_sym___device__] = ACTIONS(2330),
    [anon_sym___host__] = ACTIONS(2330),
    [anon_sym___global__] = ACTIONS(2330),
    [anon_sym___forceinline__] = ACTIONS(2330),
    [anon_sym___noinline__] = ACTIONS(2330),
    [anon_sym_extern] = ACTIONS(2330),
    [anon_sym___attribute__] = ACTIONS(2330),
    [anon_sym_COLON_COLON] = ACTIONS(2332),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2332),
    [anon_sym___declspec] = ACTIONS(2330),
    [anon_sym___based] = ACTIONS(2330),
    [anon_sym___cdecl] = ACTIONS(2330),
    [anon_sym___clrcall] = ACTIONS(2330),
    [anon_sym___stdcall] = ACTIONS(2330),
    [anon_sym___fastcall] = ACTIONS(2330),
    [anon_sym___thiscall] = ACTIONS(2330),
    [anon_sym___vectorcall] = ACTIONS(2330),
    [anon_sym_LBRACE] = ACTIONS(2332),
    [anon_sym_signed] = ACTIONS(2330),
    [anon_sym_unsigned] = ACTIONS(2330),
    [anon_sym_long] = ACTIONS(2330),
    [anon_sym_short] = ACTIONS(2330),
    [anon_sym_LBRACK] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2330),
    [anon_sym_register] = ACTIONS(2330),
    [anon_sym_inline] = ACTIONS(2330),
    [anon_sym___inline] = ACTIONS(2330),
    [anon_sym___inline__] = ACTIONS(2330),
    [anon_sym___forceinline] = ACTIONS(2330),
    [anon_sym_thread_local] = ACTIONS(2330),
    [anon_sym___thread] = ACTIONS(2330),
    [anon_sym_const] = ACTIONS(2330),
    [anon_sym_constexpr] = ACTIONS(2330),
    [anon_sym_volatile] = ACTIONS(2330),
    [anon_sym_restrict] = ACTIONS(2330),
    [anon_sym___restrict__] = ACTIONS(2330),
    [anon_sym__Atomic] = ACTIONS(2330),
    [anon_sym__Noreturn] = ACTIONS(2330),
    [anon_sym_noreturn] = ACTIONS(2330),
    [anon_sym_mutable] = ACTIONS(2330),
    [anon_sym_constinit] = ACTIONS(2330),
    [anon_sym_consteval] = ACTIONS(2330),
    [anon_sym___shared__] = ACTIONS(2330),
    [anon_sym___local__] = ACTIONS(2330),
    [anon_sym___constant__] = ACTIONS(2330),
    [anon_sym___managed__] = ACTIONS(2330),
    [anon_sym___grid_constant__] = ACTIONS(2330),
    [anon_sym_alignas] = ACTIONS(2330),
    [anon_sym__Alignas] = ACTIONS(2330),
    [sym_primitive_type] = ACTIONS(2330),
    [anon_sym_enum] = ACTIONS(2330),
    [anon_sym_class] = ACTIONS(2330),
    [anon_sym_struct] = ACTIONS(2330),
    [anon_sym_union] = ACTIONS(2330),
    [anon_sym_if] = ACTIONS(2330),
    [anon_sym_switch] = ACTIONS(2330),
    [anon_sym_case] = ACTIONS(2330),
    [anon_sym_default] = ACTIONS(2330),
    [anon_sym_while] = ACTIONS(2330),
    [anon_sym_do] = ACTIONS(2330),
    [anon_sym_for] = ACTIONS(2330),
    [anon_sym_return] = ACTIONS(2330),
    [anon_sym_break] = ACTIONS(2330),
    [anon_sym_continue] = ACTIONS(2330),
    [anon_sym_goto] = ACTIONS(2330),
    [anon_sym___try] = ACTIONS(2330),
    [anon_sym___leave] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2330),
    [anon_sym_compl] = ACTIONS(2330),
    [anon_sym_DASH_DASH] = ACTIONS(2332),
    [anon_sym_PLUS_PLUS] = ACTIONS(2332),
    [anon_sym_sizeof] = ACTIONS(2330),
    [anon_sym___alignof__] = ACTIONS(2330),
    [anon_sym___alignof] = ACTIONS(2330),
    [anon_sym__alignof] = ACTIONS(2330),
    [anon_sym_alignof] = ACTIONS(2330),
    [anon_sym__Alignof] = ACTIONS(2330),
    [anon_sym_offsetof] = ACTIONS(2330),
    [anon_sym__Generic] = ACTIONS(2330),
    [anon_sym_asm] = ACTIONS(2330),
    [anon_sym___asm__] = ACTIONS(2330),
    [sym_number_literal] = ACTIONS(2332),
    [anon_sym_L_SQUOTE] = ACTIONS(2332),
    [anon_sym_u_SQUOTE] = ACTIONS(2332),
    [anon_sym_U_SQUOTE] = ACTIONS(2332),
    [anon_sym_u8_SQUOTE] = ACTIONS(2332),
    [anon_sym_SQUOTE] = ACTIONS(2332),
    [anon_sym_L_DQUOTE] = ACTIONS(2332),
    [anon_sym_u_DQUOTE] = ACTIONS(2332),
    [anon_sym_U_DQUOTE] = ACTIONS(2332),
    [anon_sym_u8_DQUOTE] = ACTIONS(2332),
    [anon_sym_DQUOTE] = ACTIONS(2332),
    [sym_true] = ACTIONS(2330),
    [sym_false] = ACTIONS(2330),
    [anon_sym_NULL] = ACTIONS(2330),
    [anon_sym_nullptr] = ACTIONS(2330),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2330),
    [anon_sym_decltype] = ACTIONS(2330),
    [sym_virtual] = ACTIONS(2330),
    [anon_sym_explicit] = ACTIONS(2330),
    [anon_sym_typename] = ACTIONS(2330),
    [anon_sym_template] = ACTIONS(2330),
    [anon_sym_operator] = ACTIONS(2330),
    [anon_sym_try] = ACTIONS(2330),
    [anon_sym_delete] = ACTIONS(2330),
    [anon_sym_throw] = ACTIONS(2330),
    [anon_sym_namespace] = ACTIONS(2330),
    [anon_sym_using] = ACTIONS(2330),
    [anon_sym_static_assert] = ACTIONS(2330),
    [anon_sym_concept] = ACTIONS(2330),
    [anon_sym_co_return] = ACTIONS(2330),
    [anon_sym_co_yield] = ACTIONS(2330),
    [anon_sym_R_DQUOTE] = ACTIONS(2332),
    [anon_sym_LR_DQUOTE] = ACTIONS(2332),
    [anon_sym_uR_DQUOTE] = ACTIONS(2332),
    [anon_sym_UR_DQUOTE] = ACTIONS(2332),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2332),
    [anon_sym_co_await] = ACTIONS(2330),
    [anon_sym_new] = ACTIONS(2330),
    [anon_sym_requires] = ACTIONS(2330),
    [sym_this] = ACTIONS(2330),
    [anon_sym___launch_bounds__] = ACTIONS(2330),
  },
  [249] = {
    [sym_identifier] = ACTIONS(2334),
    [aux_sym_preproc_include_token1] = ACTIONS(2334),
    [aux_sym_preproc_def_token1] = ACTIONS(2334),
    [aux_sym_preproc_if_token1] = ACTIONS(2334),
    [aux_sym_preproc_if_token2] = ACTIONS(2334),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2334),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2334),
    [aux_sym_preproc_else_token1] = ACTIONS(2334),
    [aux_sym_preproc_elif_token1] = ACTIONS(2334),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2334),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2334),
    [sym_preproc_directive] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(2336),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [anon_sym_DASH] = ACTIONS(2334),
    [anon_sym_PLUS] = ACTIONS(2334),
    [anon_sym_STAR] = ACTIONS(2336),
    [anon_sym_AMP_AMP] = ACTIONS(2336),
    [anon_sym_AMP] = ACTIONS(2334),
    [anon_sym_SEMI] = ACTIONS(2336),
    [anon_sym___extension__] = ACTIONS(2334),
    [anon_sym_typedef] = ACTIONS(2334),
    [anon_sym___device__] = ACTIONS(2334),
    [anon_sym___host__] = ACTIONS(2334),
    [anon_sym___global__] = ACTIONS(2334),
    [anon_sym___forceinline__] = ACTIONS(2334),
    [anon_sym___noinline__] = ACTIONS(2334),
    [anon_sym_extern] = ACTIONS(2334),
    [anon_sym___attribute__] = ACTIONS(2334),
    [anon_sym_COLON_COLON] = ACTIONS(2336),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2336),
    [anon_sym___declspec] = ACTIONS(2334),
    [anon_sym___based] = ACTIONS(2334),
    [anon_sym___cdecl] = ACTIONS(2334),
    [anon_sym___clrcall] = ACTIONS(2334),
    [anon_sym___stdcall] = ACTIONS(2334),
    [anon_sym___fastcall] = ACTIONS(2334),
    [anon_sym___thiscall] = ACTIONS(2334),
    [anon_sym___vectorcall] = ACTIONS(2334),
    [anon_sym_LBRACE] = ACTIONS(2336),
    [anon_sym_signed] = ACTIONS(2334),
    [anon_sym_unsigned] = ACTIONS(2334),
    [anon_sym_long] = ACTIONS(2334),
    [anon_sym_short] = ACTIONS(2334),
    [anon_sym_LBRACK] = ACTIONS(2334),
    [anon_sym_static] = ACTIONS(2334),
    [anon_sym_register] = ACTIONS(2334),
    [anon_sym_inline] = ACTIONS(2334),
    [anon_sym___inline] = ACTIONS(2334),
    [anon_sym___inline__] = ACTIONS(2334),
    [anon_sym___forceinline] = ACTIONS(2334),
    [anon_sym_thread_local] = ACTIONS(2334),
    [anon_sym___thread] = ACTIONS(2334),
    [anon_sym_const] = ACTIONS(2334),
    [anon_sym_constexpr] = ACTIONS(2334),
    [anon_sym_volatile] = ACTIONS(2334),
    [anon_sym_restrict] = ACTIONS(2334),
    [anon_sym___restrict__] = ACTIONS(2334),
    [anon_sym__Atomic] = ACTIONS(2334),
    [anon_sym__Noreturn] = ACTIONS(2334),
    [anon_sym_noreturn] = ACTIONS(2334),
    [anon_sym_mutable] = ACTIONS(2334),
    [anon_sym_constinit] = ACTIONS(2334),
    [anon_sym_consteval] = ACTIONS(2334),
    [anon_sym___shared__] = ACTIONS(2334),
    [anon_sym___local__] = ACTIONS(2334),
    [anon_sym___constant__] = ACTIONS(2334),
    [anon_sym___managed__] = ACTIONS(2334),
    [anon_sym___grid_constant__] = ACTIONS(2334),
    [anon_sym_alignas] = ACTIONS(2334),
    [anon_sym__Alignas] = ACTIONS(2334),
    [sym_primitive_type] = ACTIONS(2334),
    [anon_sym_enum] = ACTIONS(2334),
    [anon_sym_class] = ACTIONS(2334),
    [anon_sym_struct] = ACTIONS(2334),
    [anon_sym_union] = ACTIONS(2334),
    [anon_sym_if] = ACTIONS(2334),
    [anon_sym_switch] = ACTIONS(2334),
    [anon_sym_case] = ACTIONS(2334),
    [anon_sym_default] = ACTIONS(2334),
    [anon_sym_while] = ACTIONS(2334),
    [anon_sym_do] = ACTIONS(2334),
    [anon_sym_for] = ACTIONS(2334),
    [anon_sym_return] = ACTIONS(2334),
    [anon_sym_break] = ACTIONS(2334),
    [anon_sym_continue] = ACTIONS(2334),
    [anon_sym_goto] = ACTIONS(2334),
    [anon_sym___try] = ACTIONS(2334),
    [anon_sym___leave] = ACTIONS(2334),
    [anon_sym_not] = ACTIONS(2334),
    [anon_sym_compl] = ACTIONS(2334),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_sizeof] = ACTIONS(2334),
    [anon_sym___alignof__] = ACTIONS(2334),
    [anon_sym___alignof] = ACTIONS(2334),
    [anon_sym__alignof] = ACTIONS(2334),
    [anon_sym_alignof] = ACTIONS(2334),
    [anon_sym__Alignof] = ACTIONS(2334),
    [anon_sym_offsetof] = ACTIONS(2334),
    [anon_sym__Generic] = ACTIONS(2334),
    [anon_sym_asm] = ACTIONS(2334),
    [anon_sym___asm__] = ACTIONS(2334),
    [sym_number_literal] = ACTIONS(2336),
    [anon_sym_L_SQUOTE] = ACTIONS(2336),
    [anon_sym_u_SQUOTE] = ACTIONS(2336),
    [anon_sym_U_SQUOTE] = ACTIONS(2336),
    [anon_sym_u8_SQUOTE] = ACTIONS(2336),
    [anon_sym_SQUOTE] = ACTIONS(2336),
    [anon_sym_L_DQUOTE] = ACTIONS(2336),
    [anon_sym_u_DQUOTE] = ACTIONS(2336),
    [anon_sym_U_DQUOTE] = ACTIONS(2336),
    [anon_sym_u8_DQUOTE] = ACTIONS(2336),
    [anon_sym_DQUOTE] = ACTIONS(2336),
    [sym_true] = ACTIONS(2334),
    [sym_false] = ACTIONS(2334),
    [anon_sym_NULL] = ACTIONS(2334),
    [anon_sym_nullptr] = ACTIONS(2334),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2334),
    [anon_sym_decltype] = ACTIONS(2334),
    [sym_virtual] = ACTIONS(2334),
    [anon_sym_explicit] = ACTIONS(2334),
    [anon_sym_typename] = ACTIONS(2334),
    [anon_sym_template] = ACTIONS(2334),
    [anon_sym_operator] = ACTIONS(2334),
    [anon_sym_try] = ACTIONS(2334),
    [anon_sym_delete] = ACTIONS(2334),
    [anon_sym_throw] = ACTIONS(2334),
    [anon_sym_namespace] = ACTIONS(2334),
    [anon_sym_using] = ACTIONS(2334),
    [anon_sym_static_assert] = ACTIONS(2334),
    [anon_sym_concept] = ACTIONS(2334),
    [anon_sym_co_return] = ACTIONS(2334),
    [anon_sym_co_yield] = ACTIONS(2334),
    [anon_sym_R_DQUOTE] = ACTIONS(2336),
    [anon_sym_LR_DQUOTE] = ACTIONS(2336),
    [anon_sym_uR_DQUOTE] = ACTIONS(2336),
    [anon_sym_UR_DQUOTE] = ACTIONS(2336),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2336),
    [anon_sym_co_await] = ACTIONS(2334),
    [anon_sym_new] = ACTIONS(2334),
    [anon_sym_requires] = ACTIONS(2334),
    [sym_this] = ACTIONS(2334),
    [anon_sym___launch_bounds__] = ACTIONS(2334),
  },
  [250] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(2960),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8499),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8682),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8299),
    [sym__unary_right_fold] = STATE(8308),
    [sym__binary_fold] = STATE(8312),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8481),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [251] = {
    [sym_identifier] = ACTIONS(2338),
    [aux_sym_preproc_include_token1] = ACTIONS(2338),
    [aux_sym_preproc_def_token1] = ACTIONS(2338),
    [aux_sym_preproc_if_token1] = ACTIONS(2338),
    [aux_sym_preproc_if_token2] = ACTIONS(2338),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2338),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2338),
    [aux_sym_preproc_else_token1] = ACTIONS(2338),
    [aux_sym_preproc_elif_token1] = ACTIONS(2338),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2338),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2338),
    [sym_preproc_directive] = ACTIONS(2338),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2338),
    [anon_sym_PLUS] = ACTIONS(2338),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_AMP] = ACTIONS(2338),
    [anon_sym_SEMI] = ACTIONS(2340),
    [anon_sym___extension__] = ACTIONS(2338),
    [anon_sym_typedef] = ACTIONS(2338),
    [anon_sym___device__] = ACTIONS(2338),
    [anon_sym___host__] = ACTIONS(2338),
    [anon_sym___global__] = ACTIONS(2338),
    [anon_sym___forceinline__] = ACTIONS(2338),
    [anon_sym___noinline__] = ACTIONS(2338),
    [anon_sym_extern] = ACTIONS(2338),
    [anon_sym___attribute__] = ACTIONS(2338),
    [anon_sym_COLON_COLON] = ACTIONS(2340),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2340),
    [anon_sym___declspec] = ACTIONS(2338),
    [anon_sym___based] = ACTIONS(2338),
    [anon_sym___cdecl] = ACTIONS(2338),
    [anon_sym___clrcall] = ACTIONS(2338),
    [anon_sym___stdcall] = ACTIONS(2338),
    [anon_sym___fastcall] = ACTIONS(2338),
    [anon_sym___thiscall] = ACTIONS(2338),
    [anon_sym___vectorcall] = ACTIONS(2338),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_signed] = ACTIONS(2338),
    [anon_sym_unsigned] = ACTIONS(2338),
    [anon_sym_long] = ACTIONS(2338),
    [anon_sym_short] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2338),
    [anon_sym_static] = ACTIONS(2338),
    [anon_sym_register] = ACTIONS(2338),
    [anon_sym_inline] = ACTIONS(2338),
    [anon_sym___inline] = ACTIONS(2338),
    [anon_sym___inline__] = ACTIONS(2338),
    [anon_sym___forceinline] = ACTIONS(2338),
    [anon_sym_thread_local] = ACTIONS(2338),
    [anon_sym___thread] = ACTIONS(2338),
    [anon_sym_const] = ACTIONS(2338),
    [anon_sym_constexpr] = ACTIONS(2338),
    [anon_sym_volatile] = ACTIONS(2338),
    [anon_sym_restrict] = ACTIONS(2338),
    [anon_sym___restrict__] = ACTIONS(2338),
    [anon_sym__Atomic] = ACTIONS(2338),
    [anon_sym__Noreturn] = ACTIONS(2338),
    [anon_sym_noreturn] = ACTIONS(2338),
    [anon_sym_mutable] = ACTIONS(2338),
    [anon_sym_constinit] = ACTIONS(2338),
    [anon_sym_consteval] = ACTIONS(2338),
    [anon_sym___shared__] = ACTIONS(2338),
    [anon_sym___local__] = ACTIONS(2338),
    [anon_sym___constant__] = ACTIONS(2338),
    [anon_sym___managed__] = ACTIONS(2338),
    [anon_sym___grid_constant__] = ACTIONS(2338),
    [anon_sym_alignas] = ACTIONS(2338),
    [anon_sym__Alignas] = ACTIONS(2338),
    [sym_primitive_type] = ACTIONS(2338),
    [anon_sym_enum] = ACTIONS(2338),
    [anon_sym_class] = ACTIONS(2338),
    [anon_sym_struct] = ACTIONS(2338),
    [anon_sym_union] = ACTIONS(2338),
    [anon_sym_if] = ACTIONS(2338),
    [anon_sym_switch] = ACTIONS(2338),
    [anon_sym_case] = ACTIONS(2338),
    [anon_sym_default] = ACTIONS(2338),
    [anon_sym_while] = ACTIONS(2338),
    [anon_sym_do] = ACTIONS(2338),
    [anon_sym_for] = ACTIONS(2338),
    [anon_sym_return] = ACTIONS(2338),
    [anon_sym_break] = ACTIONS(2338),
    [anon_sym_continue] = ACTIONS(2338),
    [anon_sym_goto] = ACTIONS(2338),
    [anon_sym___try] = ACTIONS(2338),
    [anon_sym___leave] = ACTIONS(2338),
    [anon_sym_not] = ACTIONS(2338),
    [anon_sym_compl] = ACTIONS(2338),
    [anon_sym_DASH_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_PLUS] = ACTIONS(2340),
    [anon_sym_sizeof] = ACTIONS(2338),
    [anon_sym___alignof__] = ACTIONS(2338),
    [anon_sym___alignof] = ACTIONS(2338),
    [anon_sym__alignof] = ACTIONS(2338),
    [anon_sym_alignof] = ACTIONS(2338),
    [anon_sym__Alignof] = ACTIONS(2338),
    [anon_sym_offsetof] = ACTIONS(2338),
    [anon_sym__Generic] = ACTIONS(2338),
    [anon_sym_asm] = ACTIONS(2338),
    [anon_sym___asm__] = ACTIONS(2338),
    [sym_number_literal] = ACTIONS(2340),
    [anon_sym_L_SQUOTE] = ACTIONS(2340),
    [anon_sym_u_SQUOTE] = ACTIONS(2340),
    [anon_sym_U_SQUOTE] = ACTIONS(2340),
    [anon_sym_u8_SQUOTE] = ACTIONS(2340),
    [anon_sym_SQUOTE] = ACTIONS(2340),
    [anon_sym_L_DQUOTE] = ACTIONS(2340),
    [anon_sym_u_DQUOTE] = ACTIONS(2340),
    [anon_sym_U_DQUOTE] = ACTIONS(2340),
    [anon_sym_u8_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [sym_true] = ACTIONS(2338),
    [sym_false] = ACTIONS(2338),
    [anon_sym_NULL] = ACTIONS(2338),
    [anon_sym_nullptr] = ACTIONS(2338),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2338),
    [anon_sym_decltype] = ACTIONS(2338),
    [sym_virtual] = ACTIONS(2338),
    [anon_sym_explicit] = ACTIONS(2338),
    [anon_sym_typename] = ACTIONS(2338),
    [anon_sym_template] = ACTIONS(2338),
    [anon_sym_operator] = ACTIONS(2338),
    [anon_sym_try] = ACTIONS(2338),
    [anon_sym_delete] = ACTIONS(2338),
    [anon_sym_throw] = ACTIONS(2338),
    [anon_sym_namespace] = ACTIONS(2338),
    [anon_sym_using] = ACTIONS(2338),
    [anon_sym_static_assert] = ACTIONS(2338),
    [anon_sym_concept] = ACTIONS(2338),
    [anon_sym_co_return] = ACTIONS(2338),
    [anon_sym_co_yield] = ACTIONS(2338),
    [anon_sym_R_DQUOTE] = ACTIONS(2340),
    [anon_sym_LR_DQUOTE] = ACTIONS(2340),
    [anon_sym_uR_DQUOTE] = ACTIONS(2340),
    [anon_sym_UR_DQUOTE] = ACTIONS(2340),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2340),
    [anon_sym_co_await] = ACTIONS(2338),
    [anon_sym_new] = ACTIONS(2338),
    [anon_sym_requires] = ACTIONS(2338),
    [sym_this] = ACTIONS(2338),
    [anon_sym___launch_bounds__] = ACTIONS(2338),
  },
  [252] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(2960),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8499),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8296),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8299),
    [sym__unary_right_fold] = STATE(8308),
    [sym__binary_fold] = STATE(8312),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8481),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [253] = {
    [sym_identifier] = ACTIONS(2342),
    [aux_sym_preproc_include_token1] = ACTIONS(2342),
    [aux_sym_preproc_def_token1] = ACTIONS(2342),
    [aux_sym_preproc_if_token1] = ACTIONS(2342),
    [aux_sym_preproc_if_token2] = ACTIONS(2342),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2342),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2342),
    [aux_sym_preproc_else_token1] = ACTIONS(2342),
    [aux_sym_preproc_elif_token1] = ACTIONS(2342),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2342),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2342),
    [sym_preproc_directive] = ACTIONS(2342),
    [anon_sym_LPAREN2] = ACTIONS(2344),
    [anon_sym_BANG] = ACTIONS(2344),
    [anon_sym_TILDE] = ACTIONS(2344),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2342),
    [anon_sym_SEMI] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2342),
    [anon_sym_typedef] = ACTIONS(2342),
    [anon_sym___device__] = ACTIONS(2342),
    [anon_sym___host__] = ACTIONS(2342),
    [anon_sym___global__] = ACTIONS(2342),
    [anon_sym___forceinline__] = ACTIONS(2342),
    [anon_sym___noinline__] = ACTIONS(2342),
    [anon_sym_extern] = ACTIONS(2342),
    [anon_sym___attribute__] = ACTIONS(2342),
    [anon_sym_COLON_COLON] = ACTIONS(2344),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2344),
    [anon_sym___declspec] = ACTIONS(2342),
    [anon_sym___based] = ACTIONS(2342),
    [anon_sym___cdecl] = ACTIONS(2342),
    [anon_sym___clrcall] = ACTIONS(2342),
    [anon_sym___stdcall] = ACTIONS(2342),
    [anon_sym___fastcall] = ACTIONS(2342),
    [anon_sym___thiscall] = ACTIONS(2342),
    [anon_sym___vectorcall] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2344),
    [anon_sym_signed] = ACTIONS(2342),
    [anon_sym_unsigned] = ACTIONS(2342),
    [anon_sym_long] = ACTIONS(2342),
    [anon_sym_short] = ACTIONS(2342),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_static] = ACTIONS(2342),
    [anon_sym_register] = ACTIONS(2342),
    [anon_sym_inline] = ACTIONS(2342),
    [anon_sym___inline] = ACTIONS(2342),
    [anon_sym___inline__] = ACTIONS(2342),
    [anon_sym___forceinline] = ACTIONS(2342),
    [anon_sym_thread_local] = ACTIONS(2342),
    [anon_sym___thread] = ACTIONS(2342),
    [anon_sym_const] = ACTIONS(2342),
    [anon_sym_constexpr] = ACTIONS(2342),
    [anon_sym_volatile] = ACTIONS(2342),
    [anon_sym_restrict] = ACTIONS(2342),
    [anon_sym___restrict__] = ACTIONS(2342),
    [anon_sym__Atomic] = ACTIONS(2342),
    [anon_sym__Noreturn] = ACTIONS(2342),
    [anon_sym_noreturn] = ACTIONS(2342),
    [anon_sym_mutable] = ACTIONS(2342),
    [anon_sym_constinit] = ACTIONS(2342),
    [anon_sym_consteval] = ACTIONS(2342),
    [anon_sym___shared__] = ACTIONS(2342),
    [anon_sym___local__] = ACTIONS(2342),
    [anon_sym___constant__] = ACTIONS(2342),
    [anon_sym___managed__] = ACTIONS(2342),
    [anon_sym___grid_constant__] = ACTIONS(2342),
    [anon_sym_alignas] = ACTIONS(2342),
    [anon_sym__Alignas] = ACTIONS(2342),
    [sym_primitive_type] = ACTIONS(2342),
    [anon_sym_enum] = ACTIONS(2342),
    [anon_sym_class] = ACTIONS(2342),
    [anon_sym_struct] = ACTIONS(2342),
    [anon_sym_union] = ACTIONS(2342),
    [anon_sym_if] = ACTIONS(2342),
    [anon_sym_switch] = ACTIONS(2342),
    [anon_sym_case] = ACTIONS(2342),
    [anon_sym_default] = ACTIONS(2342),
    [anon_sym_while] = ACTIONS(2342),
    [anon_sym_do] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2342),
    [anon_sym_return] = ACTIONS(2342),
    [anon_sym_break] = ACTIONS(2342),
    [anon_sym_continue] = ACTIONS(2342),
    [anon_sym_goto] = ACTIONS(2342),
    [anon_sym___try] = ACTIONS(2342),
    [anon_sym___leave] = ACTIONS(2342),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2344),
    [anon_sym_PLUS_PLUS] = ACTIONS(2344),
    [anon_sym_sizeof] = ACTIONS(2342),
    [anon_sym___alignof__] = ACTIONS(2342),
    [anon_sym___alignof] = ACTIONS(2342),
    [anon_sym__alignof] = ACTIONS(2342),
    [anon_sym_alignof] = ACTIONS(2342),
    [anon_sym__Alignof] = ACTIONS(2342),
    [anon_sym_offsetof] = ACTIONS(2342),
    [anon_sym__Generic] = ACTIONS(2342),
    [anon_sym_asm] = ACTIONS(2342),
    [anon_sym___asm__] = ACTIONS(2342),
    [sym_number_literal] = ACTIONS(2344),
    [anon_sym_L_SQUOTE] = ACTIONS(2344),
    [anon_sym_u_SQUOTE] = ACTIONS(2344),
    [anon_sym_U_SQUOTE] = ACTIONS(2344),
    [anon_sym_u8_SQUOTE] = ACTIONS(2344),
    [anon_sym_SQUOTE] = ACTIONS(2344),
    [anon_sym_L_DQUOTE] = ACTIONS(2344),
    [anon_sym_u_DQUOTE] = ACTIONS(2344),
    [anon_sym_U_DQUOTE] = ACTIONS(2344),
    [anon_sym_u8_DQUOTE] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [sym_true] = ACTIONS(2342),
    [sym_false] = ACTIONS(2342),
    [anon_sym_NULL] = ACTIONS(2342),
    [anon_sym_nullptr] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2342),
    [anon_sym_decltype] = ACTIONS(2342),
    [sym_virtual] = ACTIONS(2342),
    [anon_sym_explicit] = ACTIONS(2342),
    [anon_sym_typename] = ACTIONS(2342),
    [anon_sym_template] = ACTIONS(2342),
    [anon_sym_operator] = ACTIONS(2342),
    [anon_sym_try] = ACTIONS(2342),
    [anon_sym_delete] = ACTIONS(2342),
    [anon_sym_throw] = ACTIONS(2342),
    [anon_sym_namespace] = ACTIONS(2342),
    [anon_sym_using] = ACTIONS(2342),
    [anon_sym_static_assert] = ACTIONS(2342),
    [anon_sym_concept] = ACTIONS(2342),
    [anon_sym_co_return] = ACTIONS(2342),
    [anon_sym_co_yield] = ACTIONS(2342),
    [anon_sym_R_DQUOTE] = ACTIONS(2344),
    [anon_sym_LR_DQUOTE] = ACTIONS(2344),
    [anon_sym_uR_DQUOTE] = ACTIONS(2344),
    [anon_sym_UR_DQUOTE] = ACTIONS(2344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2344),
    [anon_sym_co_await] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2342),
    [anon_sym_requires] = ACTIONS(2342),
    [sym_this] = ACTIONS(2342),
    [anon_sym___launch_bounds__] = ACTIONS(2342),
  },
  [254] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(2960),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8499),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(9011),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8299),
    [sym__unary_right_fold] = STATE(8308),
    [sym__binary_fold] = STATE(8312),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8481),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [255] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(2960),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8499),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8522),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8509),
    [sym__unary_right_fold] = STATE(8507),
    [sym__binary_fold] = STATE(8501),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8481),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [256] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(2960),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8499),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(9099),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8299),
    [sym__unary_right_fold] = STATE(8308),
    [sym__binary_fold] = STATE(8312),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8481),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [257] = {
    [sym_catch_clause] = STATE(223),
    [aux_sym_constructor_try_statement_repeat1] = STATE(223),
    [sym_identifier] = ACTIONS(1903),
    [aux_sym_preproc_include_token1] = ACTIONS(1903),
    [aux_sym_preproc_def_token1] = ACTIONS(1903),
    [aux_sym_preproc_if_token1] = ACTIONS(1903),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1903),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1903),
    [sym_preproc_directive] = ACTIONS(1903),
    [anon_sym_LPAREN2] = ACTIONS(1905),
    [anon_sym_BANG] = ACTIONS(1905),
    [anon_sym_TILDE] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(1903),
    [anon_sym_PLUS] = ACTIONS(1903),
    [anon_sym_STAR] = ACTIONS(1905),
    [anon_sym_AMP_AMP] = ACTIONS(1905),
    [anon_sym_AMP] = ACTIONS(1903),
    [anon_sym_SEMI] = ACTIONS(1905),
    [anon_sym___extension__] = ACTIONS(1903),
    [anon_sym_typedef] = ACTIONS(1903),
    [anon_sym___device__] = ACTIONS(1903),
    [anon_sym___host__] = ACTIONS(1903),
    [anon_sym___global__] = ACTIONS(1903),
    [anon_sym___forceinline__] = ACTIONS(1903),
    [anon_sym___noinline__] = ACTIONS(1903),
    [anon_sym_extern] = ACTIONS(1903),
    [anon_sym___attribute__] = ACTIONS(1903),
    [anon_sym_COLON_COLON] = ACTIONS(1905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1905),
    [anon_sym___declspec] = ACTIONS(1903),
    [anon_sym___based] = ACTIONS(1903),
    [anon_sym___cdecl] = ACTIONS(1903),
    [anon_sym___clrcall] = ACTIONS(1903),
    [anon_sym___stdcall] = ACTIONS(1903),
    [anon_sym___fastcall] = ACTIONS(1903),
    [anon_sym___thiscall] = ACTIONS(1903),
    [anon_sym___vectorcall] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1905),
    [anon_sym_RBRACE] = ACTIONS(1905),
    [anon_sym_signed] = ACTIONS(1903),
    [anon_sym_unsigned] = ACTIONS(1903),
    [anon_sym_long] = ACTIONS(1903),
    [anon_sym_short] = ACTIONS(1903),
    [anon_sym_LBRACK] = ACTIONS(1903),
    [anon_sym_static] = ACTIONS(1903),
    [anon_sym_register] = ACTIONS(1903),
    [anon_sym_inline] = ACTIONS(1903),
    [anon_sym___inline] = ACTIONS(1903),
    [anon_sym___inline__] = ACTIONS(1903),
    [anon_sym___forceinline] = ACTIONS(1903),
    [anon_sym_thread_local] = ACTIONS(1903),
    [anon_sym___thread] = ACTIONS(1903),
    [anon_sym_const] = ACTIONS(1903),
    [anon_sym_constexpr] = ACTIONS(1903),
    [anon_sym_volatile] = ACTIONS(1903),
    [anon_sym_restrict] = ACTIONS(1903),
    [anon_sym___restrict__] = ACTIONS(1903),
    [anon_sym__Atomic] = ACTIONS(1903),
    [anon_sym__Noreturn] = ACTIONS(1903),
    [anon_sym_noreturn] = ACTIONS(1903),
    [anon_sym_mutable] = ACTIONS(1903),
    [anon_sym_constinit] = ACTIONS(1903),
    [anon_sym_consteval] = ACTIONS(1903),
    [anon_sym___shared__] = ACTIONS(1903),
    [anon_sym___local__] = ACTIONS(1903),
    [anon_sym___constant__] = ACTIONS(1903),
    [anon_sym___managed__] = ACTIONS(1903),
    [anon_sym___grid_constant__] = ACTIONS(1903),
    [anon_sym_alignas] = ACTIONS(1903),
    [anon_sym__Alignas] = ACTIONS(1903),
    [sym_primitive_type] = ACTIONS(1903),
    [anon_sym_enum] = ACTIONS(1903),
    [anon_sym_class] = ACTIONS(1903),
    [anon_sym_struct] = ACTIONS(1903),
    [anon_sym_union] = ACTIONS(1903),
    [anon_sym_if] = ACTIONS(1903),
    [anon_sym_else] = ACTIONS(1903),
    [anon_sym_switch] = ACTIONS(1903),
    [anon_sym_case] = ACTIONS(1903),
    [anon_sym_default] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1903),
    [anon_sym_do] = ACTIONS(1903),
    [anon_sym_for] = ACTIONS(1903),
    [anon_sym_return] = ACTIONS(1903),
    [anon_sym_break] = ACTIONS(1903),
    [anon_sym_continue] = ACTIONS(1903),
    [anon_sym_goto] = ACTIONS(1903),
    [anon_sym___try] = ACTIONS(1903),
    [anon_sym___leave] = ACTIONS(1903),
    [anon_sym_not] = ACTIONS(1903),
    [anon_sym_compl] = ACTIONS(1903),
    [anon_sym_DASH_DASH] = ACTIONS(1905),
    [anon_sym_PLUS_PLUS] = ACTIONS(1905),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1903),
    [anon_sym___alignof] = ACTIONS(1903),
    [anon_sym__alignof] = ACTIONS(1903),
    [anon_sym_alignof] = ACTIONS(1903),
    [anon_sym__Alignof] = ACTIONS(1903),
    [anon_sym_offsetof] = ACTIONS(1903),
    [anon_sym__Generic] = ACTIONS(1903),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [sym_number_literal] = ACTIONS(1905),
    [anon_sym_L_SQUOTE] = ACTIONS(1905),
    [anon_sym_u_SQUOTE] = ACTIONS(1905),
    [anon_sym_U_SQUOTE] = ACTIONS(1905),
    [anon_sym_u8_SQUOTE] = ACTIONS(1905),
    [anon_sym_SQUOTE] = ACTIONS(1905),
    [anon_sym_L_DQUOTE] = ACTIONS(1905),
    [anon_sym_u_DQUOTE] = ACTIONS(1905),
    [anon_sym_U_DQUOTE] = ACTIONS(1905),
    [anon_sym_u8_DQUOTE] = ACTIONS(1905),
    [anon_sym_DQUOTE] = ACTIONS(1905),
    [sym_true] = ACTIONS(1903),
    [sym_false] = ACTIONS(1903),
    [anon_sym_NULL] = ACTIONS(1903),
    [anon_sym_nullptr] = ACTIONS(1903),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1903),
    [anon_sym_decltype] = ACTIONS(1903),
    [sym_virtual] = ACTIONS(1903),
    [anon_sym_explicit] = ACTIONS(1903),
    [anon_sym_typename] = ACTIONS(1903),
    [anon_sym_template] = ACTIONS(1903),
    [anon_sym_operator] = ACTIONS(1903),
    [anon_sym_try] = ACTIONS(1903),
    [anon_sym_delete] = ACTIONS(1903),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_namespace] = ACTIONS(1903),
    [anon_sym_using] = ACTIONS(1903),
    [anon_sym_static_assert] = ACTIONS(1903),
    [anon_sym_concept] = ACTIONS(1903),
    [anon_sym_co_return] = ACTIONS(1903),
    [anon_sym_co_yield] = ACTIONS(1903),
    [anon_sym_catch] = ACTIONS(2346),
    [anon_sym_R_DQUOTE] = ACTIONS(1905),
    [anon_sym_LR_DQUOTE] = ACTIONS(1905),
    [anon_sym_uR_DQUOTE] = ACTIONS(1905),
    [anon_sym_UR_DQUOTE] = ACTIONS(1905),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1905),
    [anon_sym_co_await] = ACTIONS(1903),
    [anon_sym_new] = ACTIONS(1903),
    [anon_sym_requires] = ACTIONS(1903),
    [sym_this] = ACTIONS(1903),
    [anon_sym___launch_bounds__] = ACTIONS(1903),
  },
  [258] = {
    [sym_identifier] = ACTIONS(2348),
    [aux_sym_preproc_include_token1] = ACTIONS(2348),
    [aux_sym_preproc_def_token1] = ACTIONS(2348),
    [aux_sym_preproc_if_token1] = ACTIONS(2348),
    [aux_sym_preproc_if_token2] = ACTIONS(2348),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2348),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2348),
    [aux_sym_preproc_else_token1] = ACTIONS(2348),
    [aux_sym_preproc_elif_token1] = ACTIONS(2348),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2348),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2348),
    [sym_preproc_directive] = ACTIONS(2348),
    [anon_sym_LPAREN2] = ACTIONS(2350),
    [anon_sym_BANG] = ACTIONS(2350),
    [anon_sym_TILDE] = ACTIONS(2350),
    [anon_sym_DASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(2348),
    [anon_sym_STAR] = ACTIONS(2350),
    [anon_sym_AMP_AMP] = ACTIONS(2350),
    [anon_sym_AMP] = ACTIONS(2348),
    [anon_sym_SEMI] = ACTIONS(2350),
    [anon_sym___extension__] = ACTIONS(2348),
    [anon_sym_typedef] = ACTIONS(2348),
    [anon_sym___device__] = ACTIONS(2348),
    [anon_sym___host__] = ACTIONS(2348),
    [anon_sym___global__] = ACTIONS(2348),
    [anon_sym___forceinline__] = ACTIONS(2348),
    [anon_sym___noinline__] = ACTIONS(2348),
    [anon_sym_extern] = ACTIONS(2348),
    [anon_sym___attribute__] = ACTIONS(2348),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2350),
    [anon_sym___declspec] = ACTIONS(2348),
    [anon_sym___based] = ACTIONS(2348),
    [anon_sym___cdecl] = ACTIONS(2348),
    [anon_sym___clrcall] = ACTIONS(2348),
    [anon_sym___stdcall] = ACTIONS(2348),
    [anon_sym___fastcall] = ACTIONS(2348),
    [anon_sym___thiscall] = ACTIONS(2348),
    [anon_sym___vectorcall] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(2350),
    [anon_sym_signed] = ACTIONS(2348),
    [anon_sym_unsigned] = ACTIONS(2348),
    [anon_sym_long] = ACTIONS(2348),
    [anon_sym_short] = ACTIONS(2348),
    [anon_sym_LBRACK] = ACTIONS(2348),
    [anon_sym_static] = ACTIONS(2348),
    [anon_sym_register] = ACTIONS(2348),
    [anon_sym_inline] = ACTIONS(2348),
    [anon_sym___inline] = ACTIONS(2348),
    [anon_sym___inline__] = ACTIONS(2348),
    [anon_sym___forceinline] = ACTIONS(2348),
    [anon_sym_thread_local] = ACTIONS(2348),
    [anon_sym___thread] = ACTIONS(2348),
    [anon_sym_const] = ACTIONS(2348),
    [anon_sym_constexpr] = ACTIONS(2348),
    [anon_sym_volatile] = ACTIONS(2348),
    [anon_sym_restrict] = ACTIONS(2348),
    [anon_sym___restrict__] = ACTIONS(2348),
    [anon_sym__Atomic] = ACTIONS(2348),
    [anon_sym__Noreturn] = ACTIONS(2348),
    [anon_sym_noreturn] = ACTIONS(2348),
    [anon_sym_mutable] = ACTIONS(2348),
    [anon_sym_constinit] = ACTIONS(2348),
    [anon_sym_consteval] = ACTIONS(2348),
    [anon_sym___shared__] = ACTIONS(2348),
    [anon_sym___local__] = ACTIONS(2348),
    [anon_sym___constant__] = ACTIONS(2348),
    [anon_sym___managed__] = ACTIONS(2348),
    [anon_sym___grid_constant__] = ACTIONS(2348),
    [anon_sym_alignas] = ACTIONS(2348),
    [anon_sym__Alignas] = ACTIONS(2348),
    [sym_primitive_type] = ACTIONS(2348),
    [anon_sym_enum] = ACTIONS(2348),
    [anon_sym_class] = ACTIONS(2348),
    [anon_sym_struct] = ACTIONS(2348),
    [anon_sym_union] = ACTIONS(2348),
    [anon_sym_if] = ACTIONS(2348),
    [anon_sym_switch] = ACTIONS(2348),
    [anon_sym_case] = ACTIONS(2348),
    [anon_sym_default] = ACTIONS(2348),
    [anon_sym_while] = ACTIONS(2348),
    [anon_sym_do] = ACTIONS(2348),
    [anon_sym_for] = ACTIONS(2348),
    [anon_sym_return] = ACTIONS(2348),
    [anon_sym_break] = ACTIONS(2348),
    [anon_sym_continue] = ACTIONS(2348),
    [anon_sym_goto] = ACTIONS(2348),
    [anon_sym___try] = ACTIONS(2348),
    [anon_sym___leave] = ACTIONS(2348),
    [anon_sym_not] = ACTIONS(2348),
    [anon_sym_compl] = ACTIONS(2348),
    [anon_sym_DASH_DASH] = ACTIONS(2350),
    [anon_sym_PLUS_PLUS] = ACTIONS(2350),
    [anon_sym_sizeof] = ACTIONS(2348),
    [anon_sym___alignof__] = ACTIONS(2348),
    [anon_sym___alignof] = ACTIONS(2348),
    [anon_sym__alignof] = ACTIONS(2348),
    [anon_sym_alignof] = ACTIONS(2348),
    [anon_sym__Alignof] = ACTIONS(2348),
    [anon_sym_offsetof] = ACTIONS(2348),
    [anon_sym__Generic] = ACTIONS(2348),
    [anon_sym_asm] = ACTIONS(2348),
    [anon_sym___asm__] = ACTIONS(2348),
    [sym_number_literal] = ACTIONS(2350),
    [anon_sym_L_SQUOTE] = ACTIONS(2350),
    [anon_sym_u_SQUOTE] = ACTIONS(2350),
    [anon_sym_U_SQUOTE] = ACTIONS(2350),
    [anon_sym_u8_SQUOTE] = ACTIONS(2350),
    [anon_sym_SQUOTE] = ACTIONS(2350),
    [anon_sym_L_DQUOTE] = ACTIONS(2350),
    [anon_sym_u_DQUOTE] = ACTIONS(2350),
    [anon_sym_U_DQUOTE] = ACTIONS(2350),
    [anon_sym_u8_DQUOTE] = ACTIONS(2350),
    [anon_sym_DQUOTE] = ACTIONS(2350),
    [sym_true] = ACTIONS(2348),
    [sym_false] = ACTIONS(2348),
    [anon_sym_NULL] = ACTIONS(2348),
    [anon_sym_nullptr] = ACTIONS(2348),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2348),
    [anon_sym_decltype] = ACTIONS(2348),
    [sym_virtual] = ACTIONS(2348),
    [anon_sym_explicit] = ACTIONS(2348),
    [anon_sym_typename] = ACTIONS(2348),
    [anon_sym_template] = ACTIONS(2348),
    [anon_sym_operator] = ACTIONS(2348),
    [anon_sym_try] = ACTIONS(2348),
    [anon_sym_delete] = ACTIONS(2348),
    [anon_sym_throw] = ACTIONS(2348),
    [anon_sym_namespace] = ACTIONS(2348),
    [anon_sym_using] = ACTIONS(2348),
    [anon_sym_static_assert] = ACTIONS(2348),
    [anon_sym_concept] = ACTIONS(2348),
    [anon_sym_co_return] = ACTIONS(2348),
    [anon_sym_co_yield] = ACTIONS(2348),
    [anon_sym_R_DQUOTE] = ACTIONS(2350),
    [anon_sym_LR_DQUOTE] = ACTIONS(2350),
    [anon_sym_uR_DQUOTE] = ACTIONS(2350),
    [anon_sym_UR_DQUOTE] = ACTIONS(2350),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2350),
    [anon_sym_co_await] = ACTIONS(2348),
    [anon_sym_new] = ACTIONS(2348),
    [anon_sym_requires] = ACTIONS(2348),
    [sym_this] = ACTIONS(2348),
    [anon_sym___launch_bounds__] = ACTIONS(2348),
  },
  [259] = {
    [sym_identifier] = ACTIONS(2352),
    [aux_sym_preproc_include_token1] = ACTIONS(2352),
    [aux_sym_preproc_def_token1] = ACTIONS(2352),
    [aux_sym_preproc_if_token1] = ACTIONS(2352),
    [aux_sym_preproc_if_token2] = ACTIONS(2352),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2352),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2352),
    [aux_sym_preproc_else_token1] = ACTIONS(2352),
    [aux_sym_preproc_elif_token1] = ACTIONS(2352),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2352),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2352),
    [sym_preproc_directive] = ACTIONS(2352),
    [anon_sym_LPAREN2] = ACTIONS(2354),
    [anon_sym_BANG] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2354),
    [anon_sym_DASH] = ACTIONS(2352),
    [anon_sym_PLUS] = ACTIONS(2352),
    [anon_sym_STAR] = ACTIONS(2354),
    [anon_sym_AMP_AMP] = ACTIONS(2354),
    [anon_sym_AMP] = ACTIONS(2352),
    [anon_sym_SEMI] = ACTIONS(2354),
    [anon_sym___extension__] = ACTIONS(2352),
    [anon_sym_typedef] = ACTIONS(2352),
    [anon_sym___device__] = ACTIONS(2352),
    [anon_sym___host__] = ACTIONS(2352),
    [anon_sym___global__] = ACTIONS(2352),
    [anon_sym___forceinline__] = ACTIONS(2352),
    [anon_sym___noinline__] = ACTIONS(2352),
    [anon_sym_extern] = ACTIONS(2352),
    [anon_sym___attribute__] = ACTIONS(2352),
    [anon_sym_COLON_COLON] = ACTIONS(2354),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2354),
    [anon_sym___declspec] = ACTIONS(2352),
    [anon_sym___based] = ACTIONS(2352),
    [anon_sym___cdecl] = ACTIONS(2352),
    [anon_sym___clrcall] = ACTIONS(2352),
    [anon_sym___stdcall] = ACTIONS(2352),
    [anon_sym___fastcall] = ACTIONS(2352),
    [anon_sym___thiscall] = ACTIONS(2352),
    [anon_sym___vectorcall] = ACTIONS(2352),
    [anon_sym_LBRACE] = ACTIONS(2354),
    [anon_sym_signed] = ACTIONS(2352),
    [anon_sym_unsigned] = ACTIONS(2352),
    [anon_sym_long] = ACTIONS(2352),
    [anon_sym_short] = ACTIONS(2352),
    [anon_sym_LBRACK] = ACTIONS(2352),
    [anon_sym_static] = ACTIONS(2352),
    [anon_sym_register] = ACTIONS(2352),
    [anon_sym_inline] = ACTIONS(2352),
    [anon_sym___inline] = ACTIONS(2352),
    [anon_sym___inline__] = ACTIONS(2352),
    [anon_sym___forceinline] = ACTIONS(2352),
    [anon_sym_thread_local] = ACTIONS(2352),
    [anon_sym___thread] = ACTIONS(2352),
    [anon_sym_const] = ACTIONS(2352),
    [anon_sym_constexpr] = ACTIONS(2352),
    [anon_sym_volatile] = ACTIONS(2352),
    [anon_sym_restrict] = ACTIONS(2352),
    [anon_sym___restrict__] = ACTIONS(2352),
    [anon_sym__Atomic] = ACTIONS(2352),
    [anon_sym__Noreturn] = ACTIONS(2352),
    [anon_sym_noreturn] = ACTIONS(2352),
    [anon_sym_mutable] = ACTIONS(2352),
    [anon_sym_constinit] = ACTIONS(2352),
    [anon_sym_consteval] = ACTIONS(2352),
    [anon_sym___shared__] = ACTIONS(2352),
    [anon_sym___local__] = ACTIONS(2352),
    [anon_sym___constant__] = ACTIONS(2352),
    [anon_sym___managed__] = ACTIONS(2352),
    [anon_sym___grid_constant__] = ACTIONS(2352),
    [anon_sym_alignas] = ACTIONS(2352),
    [anon_sym__Alignas] = ACTIONS(2352),
    [sym_primitive_type] = ACTIONS(2352),
    [anon_sym_enum] = ACTIONS(2352),
    [anon_sym_class] = ACTIONS(2352),
    [anon_sym_struct] = ACTIONS(2352),
    [anon_sym_union] = ACTIONS(2352),
    [anon_sym_if] = ACTIONS(2352),
    [anon_sym_switch] = ACTIONS(2352),
    [anon_sym_case] = ACTIONS(2352),
    [anon_sym_default] = ACTIONS(2352),
    [anon_sym_while] = ACTIONS(2352),
    [anon_sym_do] = ACTIONS(2352),
    [anon_sym_for] = ACTIONS(2352),
    [anon_sym_return] = ACTIONS(2352),
    [anon_sym_break] = ACTIONS(2352),
    [anon_sym_continue] = ACTIONS(2352),
    [anon_sym_goto] = ACTIONS(2352),
    [anon_sym___try] = ACTIONS(2352),
    [anon_sym___leave] = ACTIONS(2352),
    [anon_sym_not] = ACTIONS(2352),
    [anon_sym_compl] = ACTIONS(2352),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_sizeof] = ACTIONS(2352),
    [anon_sym___alignof__] = ACTIONS(2352),
    [anon_sym___alignof] = ACTIONS(2352),
    [anon_sym__alignof] = ACTIONS(2352),
    [anon_sym_alignof] = ACTIONS(2352),
    [anon_sym__Alignof] = ACTIONS(2352),
    [anon_sym_offsetof] = ACTIONS(2352),
    [anon_sym__Generic] = ACTIONS(2352),
    [anon_sym_asm] = ACTIONS(2352),
    [anon_sym___asm__] = ACTIONS(2352),
    [sym_number_literal] = ACTIONS(2354),
    [anon_sym_L_SQUOTE] = ACTIONS(2354),
    [anon_sym_u_SQUOTE] = ACTIONS(2354),
    [anon_sym_U_SQUOTE] = ACTIONS(2354),
    [anon_sym_u8_SQUOTE] = ACTIONS(2354),
    [anon_sym_SQUOTE] = ACTIONS(2354),
    [anon_sym_L_DQUOTE] = ACTIONS(2354),
    [anon_sym_u_DQUOTE] = ACTIONS(2354),
    [anon_sym_U_DQUOTE] = ACTIONS(2354),
    [anon_sym_u8_DQUOTE] = ACTIONS(2354),
    [anon_sym_DQUOTE] = ACTIONS(2354),
    [sym_true] = ACTIONS(2352),
    [sym_false] = ACTIONS(2352),
    [anon_sym_NULL] = ACTIONS(2352),
    [anon_sym_nullptr] = ACTIONS(2352),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2352),
    [anon_sym_decltype] = ACTIONS(2352),
    [sym_virtual] = ACTIONS(2352),
    [anon_sym_explicit] = ACTIONS(2352),
    [anon_sym_typename] = ACTIONS(2352),
    [anon_sym_template] = ACTIONS(2352),
    [anon_sym_operator] = ACTIONS(2352),
    [anon_sym_try] = ACTIONS(2352),
    [anon_sym_delete] = ACTIONS(2352),
    [anon_sym_throw] = ACTIONS(2352),
    [anon_sym_namespace] = ACTIONS(2352),
    [anon_sym_using] = ACTIONS(2352),
    [anon_sym_static_assert] = ACTIONS(2352),
    [anon_sym_concept] = ACTIONS(2352),
    [anon_sym_co_return] = ACTIONS(2352),
    [anon_sym_co_yield] = ACTIONS(2352),
    [anon_sym_R_DQUOTE] = ACTIONS(2354),
    [anon_sym_LR_DQUOTE] = ACTIONS(2354),
    [anon_sym_uR_DQUOTE] = ACTIONS(2354),
    [anon_sym_UR_DQUOTE] = ACTIONS(2354),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2354),
    [anon_sym_co_await] = ACTIONS(2352),
    [anon_sym_new] = ACTIONS(2352),
    [anon_sym_requires] = ACTIONS(2352),
    [sym_this] = ACTIONS(2352),
    [anon_sym___launch_bounds__] = ACTIONS(2352),
  },
  [260] = {
    [sym_identifier] = ACTIONS(2356),
    [aux_sym_preproc_include_token1] = ACTIONS(2356),
    [aux_sym_preproc_def_token1] = ACTIONS(2356),
    [aux_sym_preproc_if_token1] = ACTIONS(2356),
    [aux_sym_preproc_if_token2] = ACTIONS(2356),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2356),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2356),
    [aux_sym_preproc_else_token1] = ACTIONS(2356),
    [aux_sym_preproc_elif_token1] = ACTIONS(2356),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2356),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2356),
    [sym_preproc_directive] = ACTIONS(2356),
    [anon_sym_LPAREN2] = ACTIONS(2358),
    [anon_sym_BANG] = ACTIONS(2358),
    [anon_sym_TILDE] = ACTIONS(2358),
    [anon_sym_DASH] = ACTIONS(2356),
    [anon_sym_PLUS] = ACTIONS(2356),
    [anon_sym_STAR] = ACTIONS(2358),
    [anon_sym_AMP_AMP] = ACTIONS(2358),
    [anon_sym_AMP] = ACTIONS(2356),
    [anon_sym_SEMI] = ACTIONS(2358),
    [anon_sym___extension__] = ACTIONS(2356),
    [anon_sym_typedef] = ACTIONS(2356),
    [anon_sym___device__] = ACTIONS(2356),
    [anon_sym___host__] = ACTIONS(2356),
    [anon_sym___global__] = ACTIONS(2356),
    [anon_sym___forceinline__] = ACTIONS(2356),
    [anon_sym___noinline__] = ACTIONS(2356),
    [anon_sym_extern] = ACTIONS(2356),
    [anon_sym___attribute__] = ACTIONS(2356),
    [anon_sym_COLON_COLON] = ACTIONS(2358),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2358),
    [anon_sym___declspec] = ACTIONS(2356),
    [anon_sym___based] = ACTIONS(2356),
    [anon_sym___cdecl] = ACTIONS(2356),
    [anon_sym___clrcall] = ACTIONS(2356),
    [anon_sym___stdcall] = ACTIONS(2356),
    [anon_sym___fastcall] = ACTIONS(2356),
    [anon_sym___thiscall] = ACTIONS(2356),
    [anon_sym___vectorcall] = ACTIONS(2356),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_signed] = ACTIONS(2356),
    [anon_sym_unsigned] = ACTIONS(2356),
    [anon_sym_long] = ACTIONS(2356),
    [anon_sym_short] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2356),
    [anon_sym_register] = ACTIONS(2356),
    [anon_sym_inline] = ACTIONS(2356),
    [anon_sym___inline] = ACTIONS(2356),
    [anon_sym___inline__] = ACTIONS(2356),
    [anon_sym___forceinline] = ACTIONS(2356),
    [anon_sym_thread_local] = ACTIONS(2356),
    [anon_sym___thread] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(2356),
    [anon_sym_constexpr] = ACTIONS(2356),
    [anon_sym_volatile] = ACTIONS(2356),
    [anon_sym_restrict] = ACTIONS(2356),
    [anon_sym___restrict__] = ACTIONS(2356),
    [anon_sym__Atomic] = ACTIONS(2356),
    [anon_sym__Noreturn] = ACTIONS(2356),
    [anon_sym_noreturn] = ACTIONS(2356),
    [anon_sym_mutable] = ACTIONS(2356),
    [anon_sym_constinit] = ACTIONS(2356),
    [anon_sym_consteval] = ACTIONS(2356),
    [anon_sym___shared__] = ACTIONS(2356),
    [anon_sym___local__] = ACTIONS(2356),
    [anon_sym___constant__] = ACTIONS(2356),
    [anon_sym___managed__] = ACTIONS(2356),
    [anon_sym___grid_constant__] = ACTIONS(2356),
    [anon_sym_alignas] = ACTIONS(2356),
    [anon_sym__Alignas] = ACTIONS(2356),
    [sym_primitive_type] = ACTIONS(2356),
    [anon_sym_enum] = ACTIONS(2356),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_struct] = ACTIONS(2356),
    [anon_sym_union] = ACTIONS(2356),
    [anon_sym_if] = ACTIONS(2356),
    [anon_sym_switch] = ACTIONS(2356),
    [anon_sym_case] = ACTIONS(2356),
    [anon_sym_default] = ACTIONS(2356),
    [anon_sym_while] = ACTIONS(2356),
    [anon_sym_do] = ACTIONS(2356),
    [anon_sym_for] = ACTIONS(2356),
    [anon_sym_return] = ACTIONS(2356),
    [anon_sym_break] = ACTIONS(2356),
    [anon_sym_continue] = ACTIONS(2356),
    [anon_sym_goto] = ACTIONS(2356),
    [anon_sym___try] = ACTIONS(2356),
    [anon_sym___leave] = ACTIONS(2356),
    [anon_sym_not] = ACTIONS(2356),
    [anon_sym_compl] = ACTIONS(2356),
    [anon_sym_DASH_DASH] = ACTIONS(2358),
    [anon_sym_PLUS_PLUS] = ACTIONS(2358),
    [anon_sym_sizeof] = ACTIONS(2356),
    [anon_sym___alignof__] = ACTIONS(2356),
    [anon_sym___alignof] = ACTIONS(2356),
    [anon_sym__alignof] = ACTIONS(2356),
    [anon_sym_alignof] = ACTIONS(2356),
    [anon_sym__Alignof] = ACTIONS(2356),
    [anon_sym_offsetof] = ACTIONS(2356),
    [anon_sym__Generic] = ACTIONS(2356),
    [anon_sym_asm] = ACTIONS(2356),
    [anon_sym___asm__] = ACTIONS(2356),
    [sym_number_literal] = ACTIONS(2358),
    [anon_sym_L_SQUOTE] = ACTIONS(2358),
    [anon_sym_u_SQUOTE] = ACTIONS(2358),
    [anon_sym_U_SQUOTE] = ACTIONS(2358),
    [anon_sym_u8_SQUOTE] = ACTIONS(2358),
    [anon_sym_SQUOTE] = ACTIONS(2358),
    [anon_sym_L_DQUOTE] = ACTIONS(2358),
    [anon_sym_u_DQUOTE] = ACTIONS(2358),
    [anon_sym_U_DQUOTE] = ACTIONS(2358),
    [anon_sym_u8_DQUOTE] = ACTIONS(2358),
    [anon_sym_DQUOTE] = ACTIONS(2358),
    [sym_true] = ACTIONS(2356),
    [sym_false] = ACTIONS(2356),
    [anon_sym_NULL] = ACTIONS(2356),
    [anon_sym_nullptr] = ACTIONS(2356),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2356),
    [anon_sym_decltype] = ACTIONS(2356),
    [sym_virtual] = ACTIONS(2356),
    [anon_sym_explicit] = ACTIONS(2356),
    [anon_sym_typename] = ACTIONS(2356),
    [anon_sym_template] = ACTIONS(2356),
    [anon_sym_operator] = ACTIONS(2356),
    [anon_sym_try] = ACTIONS(2356),
    [anon_sym_delete] = ACTIONS(2356),
    [anon_sym_throw] = ACTIONS(2356),
    [anon_sym_namespace] = ACTIONS(2356),
    [anon_sym_using] = ACTIONS(2356),
    [anon_sym_static_assert] = ACTIONS(2356),
    [anon_sym_concept] = ACTIONS(2356),
    [anon_sym_co_return] = ACTIONS(2356),
    [anon_sym_co_yield] = ACTIONS(2356),
    [anon_sym_R_DQUOTE] = ACTIONS(2358),
    [anon_sym_LR_DQUOTE] = ACTIONS(2358),
    [anon_sym_uR_DQUOTE] = ACTIONS(2358),
    [anon_sym_UR_DQUOTE] = ACTIONS(2358),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2358),
    [anon_sym_co_await] = ACTIONS(2356),
    [anon_sym_new] = ACTIONS(2356),
    [anon_sym_requires] = ACTIONS(2356),
    [sym_this] = ACTIONS(2356),
    [anon_sym___launch_bounds__] = ACTIONS(2356),
  },
  [261] = {
    [sym_preproc_def] = STATE(370),
    [sym_preproc_function_def] = STATE(370),
    [sym_preproc_call] = STATE(370),
    [sym_preproc_if_in_field_declaration_list] = STATE(370),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(370),
    [sym_preproc_else_in_field_declaration_list] = STATE(8974),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8974),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8974),
    [sym_type_definition] = STATE(370),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5944),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6464),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(370),
    [sym_field_declaration] = STATE(370),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1701),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(370),
    [sym_operator_cast] = STATE(6994),
    [sym_inline_method_definition] = STATE(370),
    [sym__constructor_specifiers] = STATE(1701),
    [sym_operator_cast_definition] = STATE(370),
    [sym_operator_cast_declaration] = STATE(370),
    [sym_constructor_or_destructor_definition] = STATE(370),
    [sym_constructor_or_destructor_declaration] = STATE(370),
    [sym_friend_declaration] = STATE(370),
    [sym_access_specifier] = STATE(9001),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(370),
    [sym_alias_declaration] = STATE(370),
    [sym_static_assert_declaration] = STATE(370),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6994),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(370),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1701),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(2100),
    [aux_sym_preproc_if_token1] = ACTIONS(2102),
    [aux_sym_preproc_if_token2] = ACTIONS(2360),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2106),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2106),
    [aux_sym_preproc_else_token1] = ACTIONS(2108),
    [aux_sym_preproc_elif_token1] = ACTIONS(2110),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2112),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2112),
    [sym_preproc_directive] = ACTIONS(2114),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(2124),
    [anon_sym_typedef] = ACTIONS(2126),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(2144),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2146),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(2150),
    [anon_sym_static_assert] = ACTIONS(2152),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [262] = {
    [sym_identifier] = ACTIONS(2362),
    [aux_sym_preproc_include_token1] = ACTIONS(2362),
    [aux_sym_preproc_def_token1] = ACTIONS(2362),
    [aux_sym_preproc_if_token1] = ACTIONS(2362),
    [aux_sym_preproc_if_token2] = ACTIONS(2362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2362),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2362),
    [aux_sym_preproc_else_token1] = ACTIONS(2362),
    [aux_sym_preproc_elif_token1] = ACTIONS(2362),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2362),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2362),
    [sym_preproc_directive] = ACTIONS(2362),
    [anon_sym_LPAREN2] = ACTIONS(2364),
    [anon_sym_BANG] = ACTIONS(2364),
    [anon_sym_TILDE] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2362),
    [anon_sym_PLUS] = ACTIONS(2362),
    [anon_sym_STAR] = ACTIONS(2364),
    [anon_sym_AMP_AMP] = ACTIONS(2364),
    [anon_sym_AMP] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym___extension__] = ACTIONS(2362),
    [anon_sym_typedef] = ACTIONS(2362),
    [anon_sym___device__] = ACTIONS(2362),
    [anon_sym___host__] = ACTIONS(2362),
    [anon_sym___global__] = ACTIONS(2362),
    [anon_sym___forceinline__] = ACTIONS(2362),
    [anon_sym___noinline__] = ACTIONS(2362),
    [anon_sym_extern] = ACTIONS(2362),
    [anon_sym___attribute__] = ACTIONS(2362),
    [anon_sym_COLON_COLON] = ACTIONS(2364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2364),
    [anon_sym___declspec] = ACTIONS(2362),
    [anon_sym___based] = ACTIONS(2362),
    [anon_sym___cdecl] = ACTIONS(2362),
    [anon_sym___clrcall] = ACTIONS(2362),
    [anon_sym___stdcall] = ACTIONS(2362),
    [anon_sym___fastcall] = ACTIONS(2362),
    [anon_sym___thiscall] = ACTIONS(2362),
    [anon_sym___vectorcall] = ACTIONS(2362),
    [anon_sym_LBRACE] = ACTIONS(2364),
    [anon_sym_signed] = ACTIONS(2362),
    [anon_sym_unsigned] = ACTIONS(2362),
    [anon_sym_long] = ACTIONS(2362),
    [anon_sym_short] = ACTIONS(2362),
    [anon_sym_LBRACK] = ACTIONS(2362),
    [anon_sym_static] = ACTIONS(2362),
    [anon_sym_register] = ACTIONS(2362),
    [anon_sym_inline] = ACTIONS(2362),
    [anon_sym___inline] = ACTIONS(2362),
    [anon_sym___inline__] = ACTIONS(2362),
    [anon_sym___forceinline] = ACTIONS(2362),
    [anon_sym_thread_local] = ACTIONS(2362),
    [anon_sym___thread] = ACTIONS(2362),
    [anon_sym_const] = ACTIONS(2362),
    [anon_sym_constexpr] = ACTIONS(2362),
    [anon_sym_volatile] = ACTIONS(2362),
    [anon_sym_restrict] = ACTIONS(2362),
    [anon_sym___restrict__] = ACTIONS(2362),
    [anon_sym__Atomic] = ACTIONS(2362),
    [anon_sym__Noreturn] = ACTIONS(2362),
    [anon_sym_noreturn] = ACTIONS(2362),
    [anon_sym_mutable] = ACTIONS(2362),
    [anon_sym_constinit] = ACTIONS(2362),
    [anon_sym_consteval] = ACTIONS(2362),
    [anon_sym___shared__] = ACTIONS(2362),
    [anon_sym___local__] = ACTIONS(2362),
    [anon_sym___constant__] = ACTIONS(2362),
    [anon_sym___managed__] = ACTIONS(2362),
    [anon_sym___grid_constant__] = ACTIONS(2362),
    [anon_sym_alignas] = ACTIONS(2362),
    [anon_sym__Alignas] = ACTIONS(2362),
    [sym_primitive_type] = ACTIONS(2362),
    [anon_sym_enum] = ACTIONS(2362),
    [anon_sym_class] = ACTIONS(2362),
    [anon_sym_struct] = ACTIONS(2362),
    [anon_sym_union] = ACTIONS(2362),
    [anon_sym_if] = ACTIONS(2362),
    [anon_sym_switch] = ACTIONS(2362),
    [anon_sym_case] = ACTIONS(2362),
    [anon_sym_default] = ACTIONS(2362),
    [anon_sym_while] = ACTIONS(2362),
    [anon_sym_do] = ACTIONS(2362),
    [anon_sym_for] = ACTIONS(2362),
    [anon_sym_return] = ACTIONS(2362),
    [anon_sym_break] = ACTIONS(2362),
    [anon_sym_continue] = ACTIONS(2362),
    [anon_sym_goto] = ACTIONS(2362),
    [anon_sym___try] = ACTIONS(2362),
    [anon_sym___leave] = ACTIONS(2362),
    [anon_sym_not] = ACTIONS(2362),
    [anon_sym_compl] = ACTIONS(2362),
    [anon_sym_DASH_DASH] = ACTIONS(2364),
    [anon_sym_PLUS_PLUS] = ACTIONS(2364),
    [anon_sym_sizeof] = ACTIONS(2362),
    [anon_sym___alignof__] = ACTIONS(2362),
    [anon_sym___alignof] = ACTIONS(2362),
    [anon_sym__alignof] = ACTIONS(2362),
    [anon_sym_alignof] = ACTIONS(2362),
    [anon_sym__Alignof] = ACTIONS(2362),
    [anon_sym_offsetof] = ACTIONS(2362),
    [anon_sym__Generic] = ACTIONS(2362),
    [anon_sym_asm] = ACTIONS(2362),
    [anon_sym___asm__] = ACTIONS(2362),
    [sym_number_literal] = ACTIONS(2364),
    [anon_sym_L_SQUOTE] = ACTIONS(2364),
    [anon_sym_u_SQUOTE] = ACTIONS(2364),
    [anon_sym_U_SQUOTE] = ACTIONS(2364),
    [anon_sym_u8_SQUOTE] = ACTIONS(2364),
    [anon_sym_SQUOTE] = ACTIONS(2364),
    [anon_sym_L_DQUOTE] = ACTIONS(2364),
    [anon_sym_u_DQUOTE] = ACTIONS(2364),
    [anon_sym_U_DQUOTE] = ACTIONS(2364),
    [anon_sym_u8_DQUOTE] = ACTIONS(2364),
    [anon_sym_DQUOTE] = ACTIONS(2364),
    [sym_true] = ACTIONS(2362),
    [sym_false] = ACTIONS(2362),
    [anon_sym_NULL] = ACTIONS(2362),
    [anon_sym_nullptr] = ACTIONS(2362),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2362),
    [anon_sym_decltype] = ACTIONS(2362),
    [sym_virtual] = ACTIONS(2362),
    [anon_sym_explicit] = ACTIONS(2362),
    [anon_sym_typename] = ACTIONS(2362),
    [anon_sym_template] = ACTIONS(2362),
    [anon_sym_operator] = ACTIONS(2362),
    [anon_sym_try] = ACTIONS(2362),
    [anon_sym_delete] = ACTIONS(2362),
    [anon_sym_throw] = ACTIONS(2362),
    [anon_sym_namespace] = ACTIONS(2362),
    [anon_sym_using] = ACTIONS(2362),
    [anon_sym_static_assert] = ACTIONS(2362),
    [anon_sym_concept] = ACTIONS(2362),
    [anon_sym_co_return] = ACTIONS(2362),
    [anon_sym_co_yield] = ACTIONS(2362),
    [anon_sym_R_DQUOTE] = ACTIONS(2364),
    [anon_sym_LR_DQUOTE] = ACTIONS(2364),
    [anon_sym_uR_DQUOTE] = ACTIONS(2364),
    [anon_sym_UR_DQUOTE] = ACTIONS(2364),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2364),
    [anon_sym_co_await] = ACTIONS(2362),
    [anon_sym_new] = ACTIONS(2362),
    [anon_sym_requires] = ACTIONS(2362),
    [sym_this] = ACTIONS(2362),
    [anon_sym___launch_bounds__] = ACTIONS(2362),
  },
  [263] = {
    [sym_identifier] = ACTIONS(2366),
    [aux_sym_preproc_include_token1] = ACTIONS(2366),
    [aux_sym_preproc_def_token1] = ACTIONS(2366),
    [aux_sym_preproc_if_token1] = ACTIONS(2366),
    [aux_sym_preproc_if_token2] = ACTIONS(2366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2366),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2366),
    [aux_sym_preproc_else_token1] = ACTIONS(2366),
    [aux_sym_preproc_elif_token1] = ACTIONS(2366),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2366),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2366),
    [sym_preproc_directive] = ACTIONS(2366),
    [anon_sym_LPAREN2] = ACTIONS(2368),
    [anon_sym_BANG] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(2368),
    [anon_sym_DASH] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(2366),
    [anon_sym_STAR] = ACTIONS(2368),
    [anon_sym_AMP_AMP] = ACTIONS(2368),
    [anon_sym_AMP] = ACTIONS(2366),
    [anon_sym_SEMI] = ACTIONS(2368),
    [anon_sym___extension__] = ACTIONS(2366),
    [anon_sym_typedef] = ACTIONS(2366),
    [anon_sym___device__] = ACTIONS(2366),
    [anon_sym___host__] = ACTIONS(2366),
    [anon_sym___global__] = ACTIONS(2366),
    [anon_sym___forceinline__] = ACTIONS(2366),
    [anon_sym___noinline__] = ACTIONS(2366),
    [anon_sym_extern] = ACTIONS(2366),
    [anon_sym___attribute__] = ACTIONS(2366),
    [anon_sym_COLON_COLON] = ACTIONS(2368),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2368),
    [anon_sym___declspec] = ACTIONS(2366),
    [anon_sym___based] = ACTIONS(2366),
    [anon_sym___cdecl] = ACTIONS(2366),
    [anon_sym___clrcall] = ACTIONS(2366),
    [anon_sym___stdcall] = ACTIONS(2366),
    [anon_sym___fastcall] = ACTIONS(2366),
    [anon_sym___thiscall] = ACTIONS(2366),
    [anon_sym___vectorcall] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(2368),
    [anon_sym_signed] = ACTIONS(2366),
    [anon_sym_unsigned] = ACTIONS(2366),
    [anon_sym_long] = ACTIONS(2366),
    [anon_sym_short] = ACTIONS(2366),
    [anon_sym_LBRACK] = ACTIONS(2366),
    [anon_sym_static] = ACTIONS(2366),
    [anon_sym_register] = ACTIONS(2366),
    [anon_sym_inline] = ACTIONS(2366),
    [anon_sym___inline] = ACTIONS(2366),
    [anon_sym___inline__] = ACTIONS(2366),
    [anon_sym___forceinline] = ACTIONS(2366),
    [anon_sym_thread_local] = ACTIONS(2366),
    [anon_sym___thread] = ACTIONS(2366),
    [anon_sym_const] = ACTIONS(2366),
    [anon_sym_constexpr] = ACTIONS(2366),
    [anon_sym_volatile] = ACTIONS(2366),
    [anon_sym_restrict] = ACTIONS(2366),
    [anon_sym___restrict__] = ACTIONS(2366),
    [anon_sym__Atomic] = ACTIONS(2366),
    [anon_sym__Noreturn] = ACTIONS(2366),
    [anon_sym_noreturn] = ACTIONS(2366),
    [anon_sym_mutable] = ACTIONS(2366),
    [anon_sym_constinit] = ACTIONS(2366),
    [anon_sym_consteval] = ACTIONS(2366),
    [anon_sym___shared__] = ACTIONS(2366),
    [anon_sym___local__] = ACTIONS(2366),
    [anon_sym___constant__] = ACTIONS(2366),
    [anon_sym___managed__] = ACTIONS(2366),
    [anon_sym___grid_constant__] = ACTIONS(2366),
    [anon_sym_alignas] = ACTIONS(2366),
    [anon_sym__Alignas] = ACTIONS(2366),
    [sym_primitive_type] = ACTIONS(2366),
    [anon_sym_enum] = ACTIONS(2366),
    [anon_sym_class] = ACTIONS(2366),
    [anon_sym_struct] = ACTIONS(2366),
    [anon_sym_union] = ACTIONS(2366),
    [anon_sym_if] = ACTIONS(2366),
    [anon_sym_switch] = ACTIONS(2366),
    [anon_sym_case] = ACTIONS(2366),
    [anon_sym_default] = ACTIONS(2366),
    [anon_sym_while] = ACTIONS(2366),
    [anon_sym_do] = ACTIONS(2366),
    [anon_sym_for] = ACTIONS(2366),
    [anon_sym_return] = ACTIONS(2366),
    [anon_sym_break] = ACTIONS(2366),
    [anon_sym_continue] = ACTIONS(2366),
    [anon_sym_goto] = ACTIONS(2366),
    [anon_sym___try] = ACTIONS(2366),
    [anon_sym___leave] = ACTIONS(2366),
    [anon_sym_not] = ACTIONS(2366),
    [anon_sym_compl] = ACTIONS(2366),
    [anon_sym_DASH_DASH] = ACTIONS(2368),
    [anon_sym_PLUS_PLUS] = ACTIONS(2368),
    [anon_sym_sizeof] = ACTIONS(2366),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2366),
    [anon_sym__Generic] = ACTIONS(2366),
    [anon_sym_asm] = ACTIONS(2366),
    [anon_sym___asm__] = ACTIONS(2366),
    [sym_number_literal] = ACTIONS(2368),
    [anon_sym_L_SQUOTE] = ACTIONS(2368),
    [anon_sym_u_SQUOTE] = ACTIONS(2368),
    [anon_sym_U_SQUOTE] = ACTIONS(2368),
    [anon_sym_u8_SQUOTE] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(2368),
    [anon_sym_L_DQUOTE] = ACTIONS(2368),
    [anon_sym_u_DQUOTE] = ACTIONS(2368),
    [anon_sym_U_DQUOTE] = ACTIONS(2368),
    [anon_sym_u8_DQUOTE] = ACTIONS(2368),
    [anon_sym_DQUOTE] = ACTIONS(2368),
    [sym_true] = ACTIONS(2366),
    [sym_false] = ACTIONS(2366),
    [anon_sym_NULL] = ACTIONS(2366),
    [anon_sym_nullptr] = ACTIONS(2366),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2366),
    [anon_sym_decltype] = ACTIONS(2366),
    [sym_virtual] = ACTIONS(2366),
    [anon_sym_explicit] = ACTIONS(2366),
    [anon_sym_typename] = ACTIONS(2366),
    [anon_sym_template] = ACTIONS(2366),
    [anon_sym_operator] = ACTIONS(2366),
    [anon_sym_try] = ACTIONS(2366),
    [anon_sym_delete] = ACTIONS(2366),
    [anon_sym_throw] = ACTIONS(2366),
    [anon_sym_namespace] = ACTIONS(2366),
    [anon_sym_using] = ACTIONS(2366),
    [anon_sym_static_assert] = ACTIONS(2366),
    [anon_sym_concept] = ACTIONS(2366),
    [anon_sym_co_return] = ACTIONS(2366),
    [anon_sym_co_yield] = ACTIONS(2366),
    [anon_sym_R_DQUOTE] = ACTIONS(2368),
    [anon_sym_LR_DQUOTE] = ACTIONS(2368),
    [anon_sym_uR_DQUOTE] = ACTIONS(2368),
    [anon_sym_UR_DQUOTE] = ACTIONS(2368),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2368),
    [anon_sym_co_await] = ACTIONS(2366),
    [anon_sym_new] = ACTIONS(2366),
    [anon_sym_requires] = ACTIONS(2366),
    [sym_this] = ACTIONS(2366),
    [anon_sym___launch_bounds__] = ACTIONS(2366),
  },
  [264] = {
    [sym_identifier] = ACTIONS(2370),
    [aux_sym_preproc_include_token1] = ACTIONS(2370),
    [aux_sym_preproc_def_token1] = ACTIONS(2370),
    [aux_sym_preproc_if_token1] = ACTIONS(2370),
    [aux_sym_preproc_if_token2] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2370),
    [aux_sym_preproc_else_token1] = ACTIONS(2370),
    [aux_sym_preproc_elif_token1] = ACTIONS(2370),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2370),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2370),
    [sym_preproc_directive] = ACTIONS(2370),
    [anon_sym_LPAREN2] = ACTIONS(2372),
    [anon_sym_BANG] = ACTIONS(2372),
    [anon_sym_TILDE] = ACTIONS(2372),
    [anon_sym_DASH] = ACTIONS(2370),
    [anon_sym_PLUS] = ACTIONS(2370),
    [anon_sym_STAR] = ACTIONS(2372),
    [anon_sym_AMP_AMP] = ACTIONS(2372),
    [anon_sym_AMP] = ACTIONS(2370),
    [anon_sym_SEMI] = ACTIONS(2372),
    [anon_sym___extension__] = ACTIONS(2370),
    [anon_sym_typedef] = ACTIONS(2370),
    [anon_sym___device__] = ACTIONS(2370),
    [anon_sym___host__] = ACTIONS(2370),
    [anon_sym___global__] = ACTIONS(2370),
    [anon_sym___forceinline__] = ACTIONS(2370),
    [anon_sym___noinline__] = ACTIONS(2370),
    [anon_sym_extern] = ACTIONS(2370),
    [anon_sym___attribute__] = ACTIONS(2370),
    [anon_sym_COLON_COLON] = ACTIONS(2372),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2372),
    [anon_sym___declspec] = ACTIONS(2370),
    [anon_sym___based] = ACTIONS(2370),
    [anon_sym___cdecl] = ACTIONS(2370),
    [anon_sym___clrcall] = ACTIONS(2370),
    [anon_sym___stdcall] = ACTIONS(2370),
    [anon_sym___fastcall] = ACTIONS(2370),
    [anon_sym___thiscall] = ACTIONS(2370),
    [anon_sym___vectorcall] = ACTIONS(2370),
    [anon_sym_LBRACE] = ACTIONS(2372),
    [anon_sym_signed] = ACTIONS(2370),
    [anon_sym_unsigned] = ACTIONS(2370),
    [anon_sym_long] = ACTIONS(2370),
    [anon_sym_short] = ACTIONS(2370),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_static] = ACTIONS(2370),
    [anon_sym_register] = ACTIONS(2370),
    [anon_sym_inline] = ACTIONS(2370),
    [anon_sym___inline] = ACTIONS(2370),
    [anon_sym___inline__] = ACTIONS(2370),
    [anon_sym___forceinline] = ACTIONS(2370),
    [anon_sym_thread_local] = ACTIONS(2370),
    [anon_sym___thread] = ACTIONS(2370),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_constexpr] = ACTIONS(2370),
    [anon_sym_volatile] = ACTIONS(2370),
    [anon_sym_restrict] = ACTIONS(2370),
    [anon_sym___restrict__] = ACTIONS(2370),
    [anon_sym__Atomic] = ACTIONS(2370),
    [anon_sym__Noreturn] = ACTIONS(2370),
    [anon_sym_noreturn] = ACTIONS(2370),
    [anon_sym_mutable] = ACTIONS(2370),
    [anon_sym_constinit] = ACTIONS(2370),
    [anon_sym_consteval] = ACTIONS(2370),
    [anon_sym___shared__] = ACTIONS(2370),
    [anon_sym___local__] = ACTIONS(2370),
    [anon_sym___constant__] = ACTIONS(2370),
    [anon_sym___managed__] = ACTIONS(2370),
    [anon_sym___grid_constant__] = ACTIONS(2370),
    [anon_sym_alignas] = ACTIONS(2370),
    [anon_sym__Alignas] = ACTIONS(2370),
    [sym_primitive_type] = ACTIONS(2370),
    [anon_sym_enum] = ACTIONS(2370),
    [anon_sym_class] = ACTIONS(2370),
    [anon_sym_struct] = ACTIONS(2370),
    [anon_sym_union] = ACTIONS(2370),
    [anon_sym_if] = ACTIONS(2370),
    [anon_sym_switch] = ACTIONS(2370),
    [anon_sym_case] = ACTIONS(2370),
    [anon_sym_default] = ACTIONS(2370),
    [anon_sym_while] = ACTIONS(2370),
    [anon_sym_do] = ACTIONS(2370),
    [anon_sym_for] = ACTIONS(2370),
    [anon_sym_return] = ACTIONS(2370),
    [anon_sym_break] = ACTIONS(2370),
    [anon_sym_continue] = ACTIONS(2370),
    [anon_sym_goto] = ACTIONS(2370),
    [anon_sym___try] = ACTIONS(2370),
    [anon_sym___leave] = ACTIONS(2370),
    [anon_sym_not] = ACTIONS(2370),
    [anon_sym_compl] = ACTIONS(2370),
    [anon_sym_DASH_DASH] = ACTIONS(2372),
    [anon_sym_PLUS_PLUS] = ACTIONS(2372),
    [anon_sym_sizeof] = ACTIONS(2370),
    [anon_sym___alignof__] = ACTIONS(2370),
    [anon_sym___alignof] = ACTIONS(2370),
    [anon_sym__alignof] = ACTIONS(2370),
    [anon_sym_alignof] = ACTIONS(2370),
    [anon_sym__Alignof] = ACTIONS(2370),
    [anon_sym_offsetof] = ACTIONS(2370),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2370),
    [anon_sym___asm__] = ACTIONS(2370),
    [sym_number_literal] = ACTIONS(2372),
    [anon_sym_L_SQUOTE] = ACTIONS(2372),
    [anon_sym_u_SQUOTE] = ACTIONS(2372),
    [anon_sym_U_SQUOTE] = ACTIONS(2372),
    [anon_sym_u8_SQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [anon_sym_L_DQUOTE] = ACTIONS(2372),
    [anon_sym_u_DQUOTE] = ACTIONS(2372),
    [anon_sym_U_DQUOTE] = ACTIONS(2372),
    [anon_sym_u8_DQUOTE] = ACTIONS(2372),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [sym_true] = ACTIONS(2370),
    [sym_false] = ACTIONS(2370),
    [anon_sym_NULL] = ACTIONS(2370),
    [anon_sym_nullptr] = ACTIONS(2370),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2370),
    [anon_sym_decltype] = ACTIONS(2370),
    [sym_virtual] = ACTIONS(2370),
    [anon_sym_explicit] = ACTIONS(2370),
    [anon_sym_typename] = ACTIONS(2370),
    [anon_sym_template] = ACTIONS(2370),
    [anon_sym_operator] = ACTIONS(2370),
    [anon_sym_try] = ACTIONS(2370),
    [anon_sym_delete] = ACTIONS(2370),
    [anon_sym_throw] = ACTIONS(2370),
    [anon_sym_namespace] = ACTIONS(2370),
    [anon_sym_using] = ACTIONS(2370),
    [anon_sym_static_assert] = ACTIONS(2370),
    [anon_sym_concept] = ACTIONS(2370),
    [anon_sym_co_return] = ACTIONS(2370),
    [anon_sym_co_yield] = ACTIONS(2370),
    [anon_sym_R_DQUOTE] = ACTIONS(2372),
    [anon_sym_LR_DQUOTE] = ACTIONS(2372),
    [anon_sym_uR_DQUOTE] = ACTIONS(2372),
    [anon_sym_UR_DQUOTE] = ACTIONS(2372),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2372),
    [anon_sym_co_await] = ACTIONS(2370),
    [anon_sym_new] = ACTIONS(2370),
    [anon_sym_requires] = ACTIONS(2370),
    [sym_this] = ACTIONS(2370),
    [anon_sym___launch_bounds__] = ACTIONS(2370),
  },
  [265] = {
    [sym_preproc_def] = STATE(370),
    [sym_preproc_function_def] = STATE(370),
    [sym_preproc_call] = STATE(370),
    [sym_preproc_if_in_field_declaration_list] = STATE(370),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(370),
    [sym_preproc_else_in_field_declaration_list] = STATE(8336),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8336),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8336),
    [sym_type_definition] = STATE(370),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5944),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6464),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(370),
    [sym_field_declaration] = STATE(370),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1701),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(370),
    [sym_operator_cast] = STATE(6994),
    [sym_inline_method_definition] = STATE(370),
    [sym__constructor_specifiers] = STATE(1701),
    [sym_operator_cast_definition] = STATE(370),
    [sym_operator_cast_declaration] = STATE(370),
    [sym_constructor_or_destructor_definition] = STATE(370),
    [sym_constructor_or_destructor_declaration] = STATE(370),
    [sym_friend_declaration] = STATE(370),
    [sym_access_specifier] = STATE(9001),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(370),
    [sym_alias_declaration] = STATE(370),
    [sym_static_assert_declaration] = STATE(370),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6994),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(370),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1701),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(2100),
    [aux_sym_preproc_if_token1] = ACTIONS(2102),
    [aux_sym_preproc_if_token2] = ACTIONS(2374),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2106),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2106),
    [aux_sym_preproc_else_token1] = ACTIONS(2108),
    [aux_sym_preproc_elif_token1] = ACTIONS(2110),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2112),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2112),
    [sym_preproc_directive] = ACTIONS(2114),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(2124),
    [anon_sym_typedef] = ACTIONS(2126),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(2144),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2146),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(2150),
    [anon_sym_static_assert] = ACTIONS(2152),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [266] = {
    [sym_identifier] = ACTIONS(2370),
    [aux_sym_preproc_include_token1] = ACTIONS(2370),
    [aux_sym_preproc_def_token1] = ACTIONS(2370),
    [aux_sym_preproc_if_token1] = ACTIONS(2370),
    [aux_sym_preproc_if_token2] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2370),
    [aux_sym_preproc_else_token1] = ACTIONS(2370),
    [aux_sym_preproc_elif_token1] = ACTIONS(2370),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2370),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2370),
    [sym_preproc_directive] = ACTIONS(2370),
    [anon_sym_LPAREN2] = ACTIONS(2372),
    [anon_sym_BANG] = ACTIONS(2372),
    [anon_sym_TILDE] = ACTIONS(2372),
    [anon_sym_DASH] = ACTIONS(2370),
    [anon_sym_PLUS] = ACTIONS(2370),
    [anon_sym_STAR] = ACTIONS(2372),
    [anon_sym_AMP_AMP] = ACTIONS(2372),
    [anon_sym_AMP] = ACTIONS(2370),
    [anon_sym_SEMI] = ACTIONS(2372),
    [anon_sym___extension__] = ACTIONS(2370),
    [anon_sym_typedef] = ACTIONS(2370),
    [anon_sym___device__] = ACTIONS(2370),
    [anon_sym___host__] = ACTIONS(2370),
    [anon_sym___global__] = ACTIONS(2370),
    [anon_sym___forceinline__] = ACTIONS(2370),
    [anon_sym___noinline__] = ACTIONS(2370),
    [anon_sym_extern] = ACTIONS(2370),
    [anon_sym___attribute__] = ACTIONS(2370),
    [anon_sym_COLON_COLON] = ACTIONS(2372),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2372),
    [anon_sym___declspec] = ACTIONS(2370),
    [anon_sym___based] = ACTIONS(2370),
    [anon_sym___cdecl] = ACTIONS(2370),
    [anon_sym___clrcall] = ACTIONS(2370),
    [anon_sym___stdcall] = ACTIONS(2370),
    [anon_sym___fastcall] = ACTIONS(2370),
    [anon_sym___thiscall] = ACTIONS(2370),
    [anon_sym___vectorcall] = ACTIONS(2370),
    [anon_sym_LBRACE] = ACTIONS(2372),
    [anon_sym_signed] = ACTIONS(2370),
    [anon_sym_unsigned] = ACTIONS(2370),
    [anon_sym_long] = ACTIONS(2370),
    [anon_sym_short] = ACTIONS(2370),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_static] = ACTIONS(2370),
    [anon_sym_register] = ACTIONS(2370),
    [anon_sym_inline] = ACTIONS(2370),
    [anon_sym___inline] = ACTIONS(2370),
    [anon_sym___inline__] = ACTIONS(2370),
    [anon_sym___forceinline] = ACTIONS(2370),
    [anon_sym_thread_local] = ACTIONS(2370),
    [anon_sym___thread] = ACTIONS(2370),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_constexpr] = ACTIONS(2370),
    [anon_sym_volatile] = ACTIONS(2370),
    [anon_sym_restrict] = ACTIONS(2370),
    [anon_sym___restrict__] = ACTIONS(2370),
    [anon_sym__Atomic] = ACTIONS(2370),
    [anon_sym__Noreturn] = ACTIONS(2370),
    [anon_sym_noreturn] = ACTIONS(2370),
    [anon_sym_mutable] = ACTIONS(2370),
    [anon_sym_constinit] = ACTIONS(2370),
    [anon_sym_consteval] = ACTIONS(2370),
    [anon_sym___shared__] = ACTIONS(2370),
    [anon_sym___local__] = ACTIONS(2370),
    [anon_sym___constant__] = ACTIONS(2370),
    [anon_sym___managed__] = ACTIONS(2370),
    [anon_sym___grid_constant__] = ACTIONS(2370),
    [anon_sym_alignas] = ACTIONS(2370),
    [anon_sym__Alignas] = ACTIONS(2370),
    [sym_primitive_type] = ACTIONS(2370),
    [anon_sym_enum] = ACTIONS(2370),
    [anon_sym_class] = ACTIONS(2370),
    [anon_sym_struct] = ACTIONS(2370),
    [anon_sym_union] = ACTIONS(2370),
    [anon_sym_if] = ACTIONS(2370),
    [anon_sym_switch] = ACTIONS(2370),
    [anon_sym_case] = ACTIONS(2370),
    [anon_sym_default] = ACTIONS(2370),
    [anon_sym_while] = ACTIONS(2370),
    [anon_sym_do] = ACTIONS(2370),
    [anon_sym_for] = ACTIONS(2370),
    [anon_sym_return] = ACTIONS(2370),
    [anon_sym_break] = ACTIONS(2370),
    [anon_sym_continue] = ACTIONS(2370),
    [anon_sym_goto] = ACTIONS(2370),
    [anon_sym___try] = ACTIONS(2370),
    [anon_sym___leave] = ACTIONS(2370),
    [anon_sym_not] = ACTIONS(2370),
    [anon_sym_compl] = ACTIONS(2370),
    [anon_sym_DASH_DASH] = ACTIONS(2372),
    [anon_sym_PLUS_PLUS] = ACTIONS(2372),
    [anon_sym_sizeof] = ACTIONS(2370),
    [anon_sym___alignof__] = ACTIONS(2370),
    [anon_sym___alignof] = ACTIONS(2370),
    [anon_sym__alignof] = ACTIONS(2370),
    [anon_sym_alignof] = ACTIONS(2370),
    [anon_sym__Alignof] = ACTIONS(2370),
    [anon_sym_offsetof] = ACTIONS(2370),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2370),
    [anon_sym___asm__] = ACTIONS(2370),
    [sym_number_literal] = ACTIONS(2372),
    [anon_sym_L_SQUOTE] = ACTIONS(2372),
    [anon_sym_u_SQUOTE] = ACTIONS(2372),
    [anon_sym_U_SQUOTE] = ACTIONS(2372),
    [anon_sym_u8_SQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [anon_sym_L_DQUOTE] = ACTIONS(2372),
    [anon_sym_u_DQUOTE] = ACTIONS(2372),
    [anon_sym_U_DQUOTE] = ACTIONS(2372),
    [anon_sym_u8_DQUOTE] = ACTIONS(2372),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [sym_true] = ACTIONS(2370),
    [sym_false] = ACTIONS(2370),
    [anon_sym_NULL] = ACTIONS(2370),
    [anon_sym_nullptr] = ACTIONS(2370),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2370),
    [anon_sym_decltype] = ACTIONS(2370),
    [sym_virtual] = ACTIONS(2370),
    [anon_sym_explicit] = ACTIONS(2370),
    [anon_sym_typename] = ACTIONS(2370),
    [anon_sym_template] = ACTIONS(2370),
    [anon_sym_operator] = ACTIONS(2370),
    [anon_sym_try] = ACTIONS(2370),
    [anon_sym_delete] = ACTIONS(2370),
    [anon_sym_throw] = ACTIONS(2370),
    [anon_sym_namespace] = ACTIONS(2370),
    [anon_sym_using] = ACTIONS(2370),
    [anon_sym_static_assert] = ACTIONS(2370),
    [anon_sym_concept] = ACTIONS(2370),
    [anon_sym_co_return] = ACTIONS(2370),
    [anon_sym_co_yield] = ACTIONS(2370),
    [anon_sym_R_DQUOTE] = ACTIONS(2372),
    [anon_sym_LR_DQUOTE] = ACTIONS(2372),
    [anon_sym_uR_DQUOTE] = ACTIONS(2372),
    [anon_sym_UR_DQUOTE] = ACTIONS(2372),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2372),
    [anon_sym_co_await] = ACTIONS(2370),
    [anon_sym_new] = ACTIONS(2370),
    [anon_sym_requires] = ACTIONS(2370),
    [sym_this] = ACTIONS(2370),
    [anon_sym___launch_bounds__] = ACTIONS(2370),
  },
  [267] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(3009),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8514),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8517),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8518),
    [sym__unary_right_fold] = STATE(8523),
    [sym__binary_fold] = STATE(8524),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8525),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [268] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(2960),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8499),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(9070),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8509),
    [sym__unary_right_fold] = STATE(8507),
    [sym__binary_fold] = STATE(8501),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8481),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [269] = {
    [sym_identifier] = ACTIONS(2376),
    [aux_sym_preproc_include_token1] = ACTIONS(2376),
    [aux_sym_preproc_def_token1] = ACTIONS(2376),
    [aux_sym_preproc_if_token1] = ACTIONS(2376),
    [aux_sym_preproc_if_token2] = ACTIONS(2376),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2376),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2376),
    [aux_sym_preproc_else_token1] = ACTIONS(2376),
    [aux_sym_preproc_elif_token1] = ACTIONS(2376),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2376),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2376),
    [sym_preproc_directive] = ACTIONS(2376),
    [anon_sym_LPAREN2] = ACTIONS(2378),
    [anon_sym_BANG] = ACTIONS(2378),
    [anon_sym_TILDE] = ACTIONS(2378),
    [anon_sym_DASH] = ACTIONS(2376),
    [anon_sym_PLUS] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(2378),
    [anon_sym_AMP_AMP] = ACTIONS(2378),
    [anon_sym_AMP] = ACTIONS(2376),
    [anon_sym_SEMI] = ACTIONS(2378),
    [anon_sym___extension__] = ACTIONS(2376),
    [anon_sym_typedef] = ACTIONS(2376),
    [anon_sym___device__] = ACTIONS(2376),
    [anon_sym___host__] = ACTIONS(2376),
    [anon_sym___global__] = ACTIONS(2376),
    [anon_sym___forceinline__] = ACTIONS(2376),
    [anon_sym___noinline__] = ACTIONS(2376),
    [anon_sym_extern] = ACTIONS(2376),
    [anon_sym___attribute__] = ACTIONS(2376),
    [anon_sym_COLON_COLON] = ACTIONS(2378),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2378),
    [anon_sym___declspec] = ACTIONS(2376),
    [anon_sym___based] = ACTIONS(2376),
    [anon_sym___cdecl] = ACTIONS(2376),
    [anon_sym___clrcall] = ACTIONS(2376),
    [anon_sym___stdcall] = ACTIONS(2376),
    [anon_sym___fastcall] = ACTIONS(2376),
    [anon_sym___thiscall] = ACTIONS(2376),
    [anon_sym___vectorcall] = ACTIONS(2376),
    [anon_sym_LBRACE] = ACTIONS(2378),
    [anon_sym_signed] = ACTIONS(2376),
    [anon_sym_unsigned] = ACTIONS(2376),
    [anon_sym_long] = ACTIONS(2376),
    [anon_sym_short] = ACTIONS(2376),
    [anon_sym_LBRACK] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2376),
    [anon_sym_register] = ACTIONS(2376),
    [anon_sym_inline] = ACTIONS(2376),
    [anon_sym___inline] = ACTIONS(2376),
    [anon_sym___inline__] = ACTIONS(2376),
    [anon_sym___forceinline] = ACTIONS(2376),
    [anon_sym_thread_local] = ACTIONS(2376),
    [anon_sym___thread] = ACTIONS(2376),
    [anon_sym_const] = ACTIONS(2376),
    [anon_sym_constexpr] = ACTIONS(2376),
    [anon_sym_volatile] = ACTIONS(2376),
    [anon_sym_restrict] = ACTIONS(2376),
    [anon_sym___restrict__] = ACTIONS(2376),
    [anon_sym__Atomic] = ACTIONS(2376),
    [anon_sym__Noreturn] = ACTIONS(2376),
    [anon_sym_noreturn] = ACTIONS(2376),
    [anon_sym_mutable] = ACTIONS(2376),
    [anon_sym_constinit] = ACTIONS(2376),
    [anon_sym_consteval] = ACTIONS(2376),
    [anon_sym___shared__] = ACTIONS(2376),
    [anon_sym___local__] = ACTIONS(2376),
    [anon_sym___constant__] = ACTIONS(2376),
    [anon_sym___managed__] = ACTIONS(2376),
    [anon_sym___grid_constant__] = ACTIONS(2376),
    [anon_sym_alignas] = ACTIONS(2376),
    [anon_sym__Alignas] = ACTIONS(2376),
    [sym_primitive_type] = ACTIONS(2376),
    [anon_sym_enum] = ACTIONS(2376),
    [anon_sym_class] = ACTIONS(2376),
    [anon_sym_struct] = ACTIONS(2376),
    [anon_sym_union] = ACTIONS(2376),
    [anon_sym_if] = ACTIONS(2376),
    [anon_sym_switch] = ACTIONS(2376),
    [anon_sym_case] = ACTIONS(2376),
    [anon_sym_default] = ACTIONS(2376),
    [anon_sym_while] = ACTIONS(2376),
    [anon_sym_do] = ACTIONS(2376),
    [anon_sym_for] = ACTIONS(2376),
    [anon_sym_return] = ACTIONS(2376),
    [anon_sym_break] = ACTIONS(2376),
    [anon_sym_continue] = ACTIONS(2376),
    [anon_sym_goto] = ACTIONS(2376),
    [anon_sym___try] = ACTIONS(2376),
    [anon_sym___leave] = ACTIONS(2376),
    [anon_sym_not] = ACTIONS(2376),
    [anon_sym_compl] = ACTIONS(2376),
    [anon_sym_DASH_DASH] = ACTIONS(2378),
    [anon_sym_PLUS_PLUS] = ACTIONS(2378),
    [anon_sym_sizeof] = ACTIONS(2376),
    [anon_sym___alignof__] = ACTIONS(2376),
    [anon_sym___alignof] = ACTIONS(2376),
    [anon_sym__alignof] = ACTIONS(2376),
    [anon_sym_alignof] = ACTIONS(2376),
    [anon_sym__Alignof] = ACTIONS(2376),
    [anon_sym_offsetof] = ACTIONS(2376),
    [anon_sym__Generic] = ACTIONS(2376),
    [anon_sym_asm] = ACTIONS(2376),
    [anon_sym___asm__] = ACTIONS(2376),
    [sym_number_literal] = ACTIONS(2378),
    [anon_sym_L_SQUOTE] = ACTIONS(2378),
    [anon_sym_u_SQUOTE] = ACTIONS(2378),
    [anon_sym_U_SQUOTE] = ACTIONS(2378),
    [anon_sym_u8_SQUOTE] = ACTIONS(2378),
    [anon_sym_SQUOTE] = ACTIONS(2378),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2376),
    [sym_false] = ACTIONS(2376),
    [anon_sym_NULL] = ACTIONS(2376),
    [anon_sym_nullptr] = ACTIONS(2376),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2376),
    [anon_sym_decltype] = ACTIONS(2376),
    [sym_virtual] = ACTIONS(2376),
    [anon_sym_explicit] = ACTIONS(2376),
    [anon_sym_typename] = ACTIONS(2376),
    [anon_sym_template] = ACTIONS(2376),
    [anon_sym_operator] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2376),
    [anon_sym_delete] = ACTIONS(2376),
    [anon_sym_throw] = ACTIONS(2376),
    [anon_sym_namespace] = ACTIONS(2376),
    [anon_sym_using] = ACTIONS(2376),
    [anon_sym_static_assert] = ACTIONS(2376),
    [anon_sym_concept] = ACTIONS(2376),
    [anon_sym_co_return] = ACTIONS(2376),
    [anon_sym_co_yield] = ACTIONS(2376),
    [anon_sym_R_DQUOTE] = ACTIONS(2378),
    [anon_sym_LR_DQUOTE] = ACTIONS(2378),
    [anon_sym_uR_DQUOTE] = ACTIONS(2378),
    [anon_sym_UR_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2378),
    [anon_sym_co_await] = ACTIONS(2376),
    [anon_sym_new] = ACTIONS(2376),
    [anon_sym_requires] = ACTIONS(2376),
    [sym_this] = ACTIONS(2376),
    [anon_sym___launch_bounds__] = ACTIONS(2376),
  },
  [270] = {
    [sym_preproc_def] = STATE(296),
    [sym_preproc_function_def] = STATE(296),
    [sym_preproc_call] = STATE(296),
    [sym_preproc_if_in_field_declaration_list] = STATE(296),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(296),
    [sym_preproc_else_in_field_declaration_list] = STATE(8973),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8973),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8973),
    [sym_type_definition] = STATE(296),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5944),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6464),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(296),
    [sym_field_declaration] = STATE(296),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1701),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(296),
    [sym_operator_cast] = STATE(6994),
    [sym_inline_method_definition] = STATE(296),
    [sym__constructor_specifiers] = STATE(1701),
    [sym_operator_cast_definition] = STATE(296),
    [sym_operator_cast_declaration] = STATE(296),
    [sym_constructor_or_destructor_definition] = STATE(296),
    [sym_constructor_or_destructor_declaration] = STATE(296),
    [sym_friend_declaration] = STATE(296),
    [sym_access_specifier] = STATE(9001),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(296),
    [sym_alias_declaration] = STATE(296),
    [sym_static_assert_declaration] = STATE(296),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6994),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(296),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1701),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(2100),
    [aux_sym_preproc_if_token1] = ACTIONS(2102),
    [aux_sym_preproc_if_token2] = ACTIONS(2380),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2106),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2106),
    [aux_sym_preproc_else_token1] = ACTIONS(2108),
    [aux_sym_preproc_elif_token1] = ACTIONS(2110),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2112),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2112),
    [sym_preproc_directive] = ACTIONS(2114),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(2124),
    [anon_sym_typedef] = ACTIONS(2126),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(2144),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2146),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(2150),
    [anon_sym_static_assert] = ACTIONS(2152),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [271] = {
    [sym_preproc_def] = STATE(370),
    [sym_preproc_function_def] = STATE(370),
    [sym_preproc_call] = STATE(370),
    [sym_preproc_if_in_field_declaration_list] = STATE(370),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(370),
    [sym_preproc_else_in_field_declaration_list] = STATE(8388),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8388),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8388),
    [sym_type_definition] = STATE(370),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5944),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6464),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(370),
    [sym_field_declaration] = STATE(370),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1701),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(370),
    [sym_operator_cast] = STATE(6994),
    [sym_inline_method_definition] = STATE(370),
    [sym__constructor_specifiers] = STATE(1701),
    [sym_operator_cast_definition] = STATE(370),
    [sym_operator_cast_declaration] = STATE(370),
    [sym_constructor_or_destructor_definition] = STATE(370),
    [sym_constructor_or_destructor_declaration] = STATE(370),
    [sym_friend_declaration] = STATE(370),
    [sym_access_specifier] = STATE(9001),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(370),
    [sym_alias_declaration] = STATE(370),
    [sym_static_assert_declaration] = STATE(370),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6994),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(370),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1701),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(2100),
    [aux_sym_preproc_if_token1] = ACTIONS(2102),
    [aux_sym_preproc_if_token2] = ACTIONS(2382),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2106),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2106),
    [aux_sym_preproc_else_token1] = ACTIONS(2108),
    [aux_sym_preproc_elif_token1] = ACTIONS(2110),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2112),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2112),
    [sym_preproc_directive] = ACTIONS(2114),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(2124),
    [anon_sym_typedef] = ACTIONS(2126),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(2144),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2146),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(2150),
    [anon_sym_static_assert] = ACTIONS(2152),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [272] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(2985),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8787),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8356),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8282),
    [sym__unary_right_fold] = STATE(8283),
    [sym__binary_fold] = STATE(8289),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8780),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [273] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(2960),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8499),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8479),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8509),
    [sym__unary_right_fold] = STATE(8507),
    [sym__binary_fold] = STATE(8501),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8481),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [274] = {
    [sym_identifier] = ACTIONS(2384),
    [aux_sym_preproc_include_token1] = ACTIONS(2384),
    [aux_sym_preproc_def_token1] = ACTIONS(2384),
    [aux_sym_preproc_if_token1] = ACTIONS(2384),
    [aux_sym_preproc_if_token2] = ACTIONS(2384),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2384),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2384),
    [aux_sym_preproc_else_token1] = ACTIONS(2384),
    [aux_sym_preproc_elif_token1] = ACTIONS(2384),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2384),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2384),
    [sym_preproc_directive] = ACTIONS(2384),
    [anon_sym_LPAREN2] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2386),
    [anon_sym_TILDE] = ACTIONS(2386),
    [anon_sym_DASH] = ACTIONS(2384),
    [anon_sym_PLUS] = ACTIONS(2384),
    [anon_sym_STAR] = ACTIONS(2386),
    [anon_sym_AMP_AMP] = ACTIONS(2386),
    [anon_sym_AMP] = ACTIONS(2384),
    [anon_sym_SEMI] = ACTIONS(2386),
    [anon_sym___extension__] = ACTIONS(2384),
    [anon_sym_typedef] = ACTIONS(2384),
    [anon_sym___device__] = ACTIONS(2384),
    [anon_sym___host__] = ACTIONS(2384),
    [anon_sym___global__] = ACTIONS(2384),
    [anon_sym___forceinline__] = ACTIONS(2384),
    [anon_sym___noinline__] = ACTIONS(2384),
    [anon_sym_extern] = ACTIONS(2384),
    [anon_sym___attribute__] = ACTIONS(2384),
    [anon_sym_COLON_COLON] = ACTIONS(2386),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2386),
    [anon_sym___declspec] = ACTIONS(2384),
    [anon_sym___based] = ACTIONS(2384),
    [anon_sym___cdecl] = ACTIONS(2384),
    [anon_sym___clrcall] = ACTIONS(2384),
    [anon_sym___stdcall] = ACTIONS(2384),
    [anon_sym___fastcall] = ACTIONS(2384),
    [anon_sym___thiscall] = ACTIONS(2384),
    [anon_sym___vectorcall] = ACTIONS(2384),
    [anon_sym_LBRACE] = ACTIONS(2386),
    [anon_sym_signed] = ACTIONS(2384),
    [anon_sym_unsigned] = ACTIONS(2384),
    [anon_sym_long] = ACTIONS(2384),
    [anon_sym_short] = ACTIONS(2384),
    [anon_sym_LBRACK] = ACTIONS(2384),
    [anon_sym_static] = ACTIONS(2384),
    [anon_sym_register] = ACTIONS(2384),
    [anon_sym_inline] = ACTIONS(2384),
    [anon_sym___inline] = ACTIONS(2384),
    [anon_sym___inline__] = ACTIONS(2384),
    [anon_sym___forceinline] = ACTIONS(2384),
    [anon_sym_thread_local] = ACTIONS(2384),
    [anon_sym___thread] = ACTIONS(2384),
    [anon_sym_const] = ACTIONS(2384),
    [anon_sym_constexpr] = ACTIONS(2384),
    [anon_sym_volatile] = ACTIONS(2384),
    [anon_sym_restrict] = ACTIONS(2384),
    [anon_sym___restrict__] = ACTIONS(2384),
    [anon_sym__Atomic] = ACTIONS(2384),
    [anon_sym__Noreturn] = ACTIONS(2384),
    [anon_sym_noreturn] = ACTIONS(2384),
    [anon_sym_mutable] = ACTIONS(2384),
    [anon_sym_constinit] = ACTIONS(2384),
    [anon_sym_consteval] = ACTIONS(2384),
    [anon_sym___shared__] = ACTIONS(2384),
    [anon_sym___local__] = ACTIONS(2384),
    [anon_sym___constant__] = ACTIONS(2384),
    [anon_sym___managed__] = ACTIONS(2384),
    [anon_sym___grid_constant__] = ACTIONS(2384),
    [anon_sym_alignas] = ACTIONS(2384),
    [anon_sym__Alignas] = ACTIONS(2384),
    [sym_primitive_type] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2384),
    [anon_sym_class] = ACTIONS(2384),
    [anon_sym_struct] = ACTIONS(2384),
    [anon_sym_union] = ACTIONS(2384),
    [anon_sym_if] = ACTIONS(2384),
    [anon_sym_switch] = ACTIONS(2384),
    [anon_sym_case] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2384),
    [anon_sym_while] = ACTIONS(2384),
    [anon_sym_do] = ACTIONS(2384),
    [anon_sym_for] = ACTIONS(2384),
    [anon_sym_return] = ACTIONS(2384),
    [anon_sym_break] = ACTIONS(2384),
    [anon_sym_continue] = ACTIONS(2384),
    [anon_sym_goto] = ACTIONS(2384),
    [anon_sym___try] = ACTIONS(2384),
    [anon_sym___leave] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_compl] = ACTIONS(2384),
    [anon_sym_DASH_DASH] = ACTIONS(2386),
    [anon_sym_PLUS_PLUS] = ACTIONS(2386),
    [anon_sym_sizeof] = ACTIONS(2384),
    [anon_sym___alignof__] = ACTIONS(2384),
    [anon_sym___alignof] = ACTIONS(2384),
    [anon_sym__alignof] = ACTIONS(2384),
    [anon_sym_alignof] = ACTIONS(2384),
    [anon_sym__Alignof] = ACTIONS(2384),
    [anon_sym_offsetof] = ACTIONS(2384),
    [anon_sym__Generic] = ACTIONS(2384),
    [anon_sym_asm] = ACTIONS(2384),
    [anon_sym___asm__] = ACTIONS(2384),
    [sym_number_literal] = ACTIONS(2386),
    [anon_sym_L_SQUOTE] = ACTIONS(2386),
    [anon_sym_u_SQUOTE] = ACTIONS(2386),
    [anon_sym_U_SQUOTE] = ACTIONS(2386),
    [anon_sym_u8_SQUOTE] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2386),
    [anon_sym_L_DQUOTE] = ACTIONS(2386),
    [anon_sym_u_DQUOTE] = ACTIONS(2386),
    [anon_sym_U_DQUOTE] = ACTIONS(2386),
    [anon_sym_u8_DQUOTE] = ACTIONS(2386),
    [anon_sym_DQUOTE] = ACTIONS(2386),
    [sym_true] = ACTIONS(2384),
    [sym_false] = ACTIONS(2384),
    [anon_sym_NULL] = ACTIONS(2384),
    [anon_sym_nullptr] = ACTIONS(2384),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2384),
    [anon_sym_decltype] = ACTIONS(2384),
    [sym_virtual] = ACTIONS(2384),
    [anon_sym_explicit] = ACTIONS(2384),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(2384),
    [anon_sym_operator] = ACTIONS(2384),
    [anon_sym_try] = ACTIONS(2384),
    [anon_sym_delete] = ACTIONS(2384),
    [anon_sym_throw] = ACTIONS(2384),
    [anon_sym_namespace] = ACTIONS(2384),
    [anon_sym_using] = ACTIONS(2384),
    [anon_sym_static_assert] = ACTIONS(2384),
    [anon_sym_concept] = ACTIONS(2384),
    [anon_sym_co_return] = ACTIONS(2384),
    [anon_sym_co_yield] = ACTIONS(2384),
    [anon_sym_R_DQUOTE] = ACTIONS(2386),
    [anon_sym_LR_DQUOTE] = ACTIONS(2386),
    [anon_sym_uR_DQUOTE] = ACTIONS(2386),
    [anon_sym_UR_DQUOTE] = ACTIONS(2386),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2386),
    [anon_sym_co_await] = ACTIONS(2384),
    [anon_sym_new] = ACTIONS(2384),
    [anon_sym_requires] = ACTIONS(2384),
    [sym_this] = ACTIONS(2384),
    [anon_sym___launch_bounds__] = ACTIONS(2384),
  },
  [275] = {
    [sym_identifier] = ACTIONS(2384),
    [aux_sym_preproc_include_token1] = ACTIONS(2384),
    [aux_sym_preproc_def_token1] = ACTIONS(2384),
    [aux_sym_preproc_if_token1] = ACTIONS(2384),
    [aux_sym_preproc_if_token2] = ACTIONS(2384),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2384),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2384),
    [aux_sym_preproc_else_token1] = ACTIONS(2384),
    [aux_sym_preproc_elif_token1] = ACTIONS(2384),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2384),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2384),
    [sym_preproc_directive] = ACTIONS(2384),
    [anon_sym_LPAREN2] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2386),
    [anon_sym_TILDE] = ACTIONS(2386),
    [anon_sym_DASH] = ACTIONS(2384),
    [anon_sym_PLUS] = ACTIONS(2384),
    [anon_sym_STAR] = ACTIONS(2386),
    [anon_sym_AMP_AMP] = ACTIONS(2386),
    [anon_sym_AMP] = ACTIONS(2384),
    [anon_sym_SEMI] = ACTIONS(2386),
    [anon_sym___extension__] = ACTIONS(2384),
    [anon_sym_typedef] = ACTIONS(2384),
    [anon_sym___device__] = ACTIONS(2384),
    [anon_sym___host__] = ACTIONS(2384),
    [anon_sym___global__] = ACTIONS(2384),
    [anon_sym___forceinline__] = ACTIONS(2384),
    [anon_sym___noinline__] = ACTIONS(2384),
    [anon_sym_extern] = ACTIONS(2384),
    [anon_sym___attribute__] = ACTIONS(2384),
    [anon_sym_COLON_COLON] = ACTIONS(2386),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2386),
    [anon_sym___declspec] = ACTIONS(2384),
    [anon_sym___based] = ACTIONS(2384),
    [anon_sym___cdecl] = ACTIONS(2384),
    [anon_sym___clrcall] = ACTIONS(2384),
    [anon_sym___stdcall] = ACTIONS(2384),
    [anon_sym___fastcall] = ACTIONS(2384),
    [anon_sym___thiscall] = ACTIONS(2384),
    [anon_sym___vectorcall] = ACTIONS(2384),
    [anon_sym_LBRACE] = ACTIONS(2386),
    [anon_sym_signed] = ACTIONS(2384),
    [anon_sym_unsigned] = ACTIONS(2384),
    [anon_sym_long] = ACTIONS(2384),
    [anon_sym_short] = ACTIONS(2384),
    [anon_sym_LBRACK] = ACTIONS(2384),
    [anon_sym_static] = ACTIONS(2384),
    [anon_sym_register] = ACTIONS(2384),
    [anon_sym_inline] = ACTIONS(2384),
    [anon_sym___inline] = ACTIONS(2384),
    [anon_sym___inline__] = ACTIONS(2384),
    [anon_sym___forceinline] = ACTIONS(2384),
    [anon_sym_thread_local] = ACTIONS(2384),
    [anon_sym___thread] = ACTIONS(2384),
    [anon_sym_const] = ACTIONS(2384),
    [anon_sym_constexpr] = ACTIONS(2384),
    [anon_sym_volatile] = ACTIONS(2384),
    [anon_sym_restrict] = ACTIONS(2384),
    [anon_sym___restrict__] = ACTIONS(2384),
    [anon_sym__Atomic] = ACTIONS(2384),
    [anon_sym__Noreturn] = ACTIONS(2384),
    [anon_sym_noreturn] = ACTIONS(2384),
    [anon_sym_mutable] = ACTIONS(2384),
    [anon_sym_constinit] = ACTIONS(2384),
    [anon_sym_consteval] = ACTIONS(2384),
    [anon_sym___shared__] = ACTIONS(2384),
    [anon_sym___local__] = ACTIONS(2384),
    [anon_sym___constant__] = ACTIONS(2384),
    [anon_sym___managed__] = ACTIONS(2384),
    [anon_sym___grid_constant__] = ACTIONS(2384),
    [anon_sym_alignas] = ACTIONS(2384),
    [anon_sym__Alignas] = ACTIONS(2384),
    [sym_primitive_type] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2384),
    [anon_sym_class] = ACTIONS(2384),
    [anon_sym_struct] = ACTIONS(2384),
    [anon_sym_union] = ACTIONS(2384),
    [anon_sym_if] = ACTIONS(2384),
    [anon_sym_switch] = ACTIONS(2384),
    [anon_sym_case] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2384),
    [anon_sym_while] = ACTIONS(2384),
    [anon_sym_do] = ACTIONS(2384),
    [anon_sym_for] = ACTIONS(2384),
    [anon_sym_return] = ACTIONS(2384),
    [anon_sym_break] = ACTIONS(2384),
    [anon_sym_continue] = ACTIONS(2384),
    [anon_sym_goto] = ACTIONS(2384),
    [anon_sym___try] = ACTIONS(2384),
    [anon_sym___leave] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_compl] = ACTIONS(2384),
    [anon_sym_DASH_DASH] = ACTIONS(2386),
    [anon_sym_PLUS_PLUS] = ACTIONS(2386),
    [anon_sym_sizeof] = ACTIONS(2384),
    [anon_sym___alignof__] = ACTIONS(2384),
    [anon_sym___alignof] = ACTIONS(2384),
    [anon_sym__alignof] = ACTIONS(2384),
    [anon_sym_alignof] = ACTIONS(2384),
    [anon_sym__Alignof] = ACTIONS(2384),
    [anon_sym_offsetof] = ACTIONS(2384),
    [anon_sym__Generic] = ACTIONS(2384),
    [anon_sym_asm] = ACTIONS(2384),
    [anon_sym___asm__] = ACTIONS(2384),
    [sym_number_literal] = ACTIONS(2386),
    [anon_sym_L_SQUOTE] = ACTIONS(2386),
    [anon_sym_u_SQUOTE] = ACTIONS(2386),
    [anon_sym_U_SQUOTE] = ACTIONS(2386),
    [anon_sym_u8_SQUOTE] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2386),
    [anon_sym_L_DQUOTE] = ACTIONS(2386),
    [anon_sym_u_DQUOTE] = ACTIONS(2386),
    [anon_sym_U_DQUOTE] = ACTIONS(2386),
    [anon_sym_u8_DQUOTE] = ACTIONS(2386),
    [anon_sym_DQUOTE] = ACTIONS(2386),
    [sym_true] = ACTIONS(2384),
    [sym_false] = ACTIONS(2384),
    [anon_sym_NULL] = ACTIONS(2384),
    [anon_sym_nullptr] = ACTIONS(2384),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2384),
    [anon_sym_decltype] = ACTIONS(2384),
    [sym_virtual] = ACTIONS(2384),
    [anon_sym_explicit] = ACTIONS(2384),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(2384),
    [anon_sym_operator] = ACTIONS(2384),
    [anon_sym_try] = ACTIONS(2384),
    [anon_sym_delete] = ACTIONS(2384),
    [anon_sym_throw] = ACTIONS(2384),
    [anon_sym_namespace] = ACTIONS(2384),
    [anon_sym_using] = ACTIONS(2384),
    [anon_sym_static_assert] = ACTIONS(2384),
    [anon_sym_concept] = ACTIONS(2384),
    [anon_sym_co_return] = ACTIONS(2384),
    [anon_sym_co_yield] = ACTIONS(2384),
    [anon_sym_R_DQUOTE] = ACTIONS(2386),
    [anon_sym_LR_DQUOTE] = ACTIONS(2386),
    [anon_sym_uR_DQUOTE] = ACTIONS(2386),
    [anon_sym_UR_DQUOTE] = ACTIONS(2386),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2386),
    [anon_sym_co_await] = ACTIONS(2384),
    [anon_sym_new] = ACTIONS(2384),
    [anon_sym_requires] = ACTIONS(2384),
    [sym_this] = ACTIONS(2384),
    [anon_sym___launch_bounds__] = ACTIONS(2384),
  },
  [276] = {
    [sym_identifier] = ACTIONS(2388),
    [aux_sym_preproc_include_token1] = ACTIONS(2388),
    [aux_sym_preproc_def_token1] = ACTIONS(2388),
    [aux_sym_preproc_if_token1] = ACTIONS(2388),
    [aux_sym_preproc_if_token2] = ACTIONS(2388),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2388),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2388),
    [aux_sym_preproc_else_token1] = ACTIONS(2388),
    [aux_sym_preproc_elif_token1] = ACTIONS(2388),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2388),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2388),
    [sym_preproc_directive] = ACTIONS(2388),
    [anon_sym_LPAREN2] = ACTIONS(2390),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [anon_sym_DASH] = ACTIONS(2388),
    [anon_sym_PLUS] = ACTIONS(2388),
    [anon_sym_STAR] = ACTIONS(2390),
    [anon_sym_AMP_AMP] = ACTIONS(2390),
    [anon_sym_AMP] = ACTIONS(2388),
    [anon_sym_SEMI] = ACTIONS(2390),
    [anon_sym___extension__] = ACTIONS(2388),
    [anon_sym_typedef] = ACTIONS(2388),
    [anon_sym___device__] = ACTIONS(2388),
    [anon_sym___host__] = ACTIONS(2388),
    [anon_sym___global__] = ACTIONS(2388),
    [anon_sym___forceinline__] = ACTIONS(2388),
    [anon_sym___noinline__] = ACTIONS(2388),
    [anon_sym_extern] = ACTIONS(2388),
    [anon_sym___attribute__] = ACTIONS(2388),
    [anon_sym_COLON_COLON] = ACTIONS(2390),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2390),
    [anon_sym___declspec] = ACTIONS(2388),
    [anon_sym___based] = ACTIONS(2388),
    [anon_sym___cdecl] = ACTIONS(2388),
    [anon_sym___clrcall] = ACTIONS(2388),
    [anon_sym___stdcall] = ACTIONS(2388),
    [anon_sym___fastcall] = ACTIONS(2388),
    [anon_sym___thiscall] = ACTIONS(2388),
    [anon_sym___vectorcall] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2390),
    [anon_sym_signed] = ACTIONS(2388),
    [anon_sym_unsigned] = ACTIONS(2388),
    [anon_sym_long] = ACTIONS(2388),
    [anon_sym_short] = ACTIONS(2388),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [anon_sym_static] = ACTIONS(2388),
    [anon_sym_register] = ACTIONS(2388),
    [anon_sym_inline] = ACTIONS(2388),
    [anon_sym___inline] = ACTIONS(2388),
    [anon_sym___inline__] = ACTIONS(2388),
    [anon_sym___forceinline] = ACTIONS(2388),
    [anon_sym_thread_local] = ACTIONS(2388),
    [anon_sym___thread] = ACTIONS(2388),
    [anon_sym_const] = ACTIONS(2388),
    [anon_sym_constexpr] = ACTIONS(2388),
    [anon_sym_volatile] = ACTIONS(2388),
    [anon_sym_restrict] = ACTIONS(2388),
    [anon_sym___restrict__] = ACTIONS(2388),
    [anon_sym__Atomic] = ACTIONS(2388),
    [anon_sym__Noreturn] = ACTIONS(2388),
    [anon_sym_noreturn] = ACTIONS(2388),
    [anon_sym_mutable] = ACTIONS(2388),
    [anon_sym_constinit] = ACTIONS(2388),
    [anon_sym_consteval] = ACTIONS(2388),
    [anon_sym___shared__] = ACTIONS(2388),
    [anon_sym___local__] = ACTIONS(2388),
    [anon_sym___constant__] = ACTIONS(2388),
    [anon_sym___managed__] = ACTIONS(2388),
    [anon_sym___grid_constant__] = ACTIONS(2388),
    [anon_sym_alignas] = ACTIONS(2388),
    [anon_sym__Alignas] = ACTIONS(2388),
    [sym_primitive_type] = ACTIONS(2388),
    [anon_sym_enum] = ACTIONS(2388),
    [anon_sym_class] = ACTIONS(2388),
    [anon_sym_struct] = ACTIONS(2388),
    [anon_sym_union] = ACTIONS(2388),
    [anon_sym_if] = ACTIONS(2388),
    [anon_sym_switch] = ACTIONS(2388),
    [anon_sym_case] = ACTIONS(2388),
    [anon_sym_default] = ACTIONS(2388),
    [anon_sym_while] = ACTIONS(2388),
    [anon_sym_do] = ACTIONS(2388),
    [anon_sym_for] = ACTIONS(2388),
    [anon_sym_return] = ACTIONS(2388),
    [anon_sym_break] = ACTIONS(2388),
    [anon_sym_continue] = ACTIONS(2388),
    [anon_sym_goto] = ACTIONS(2388),
    [anon_sym___try] = ACTIONS(2388),
    [anon_sym___leave] = ACTIONS(2388),
    [anon_sym_not] = ACTIONS(2388),
    [anon_sym_compl] = ACTIONS(2388),
    [anon_sym_DASH_DASH] = ACTIONS(2390),
    [anon_sym_PLUS_PLUS] = ACTIONS(2390),
    [anon_sym_sizeof] = ACTIONS(2388),
    [anon_sym___alignof__] = ACTIONS(2388),
    [anon_sym___alignof] = ACTIONS(2388),
    [anon_sym__alignof] = ACTIONS(2388),
    [anon_sym_alignof] = ACTIONS(2388),
    [anon_sym__Alignof] = ACTIONS(2388),
    [anon_sym_offsetof] = ACTIONS(2388),
    [anon_sym__Generic] = ACTIONS(2388),
    [anon_sym_asm] = ACTIONS(2388),
    [anon_sym___asm__] = ACTIONS(2388),
    [sym_number_literal] = ACTIONS(2390),
    [anon_sym_L_SQUOTE] = ACTIONS(2390),
    [anon_sym_u_SQUOTE] = ACTIONS(2390),
    [anon_sym_U_SQUOTE] = ACTIONS(2390),
    [anon_sym_u8_SQUOTE] = ACTIONS(2390),
    [anon_sym_SQUOTE] = ACTIONS(2390),
    [anon_sym_L_DQUOTE] = ACTIONS(2390),
    [anon_sym_u_DQUOTE] = ACTIONS(2390),
    [anon_sym_U_DQUOTE] = ACTIONS(2390),
    [anon_sym_u8_DQUOTE] = ACTIONS(2390),
    [anon_sym_DQUOTE] = ACTIONS(2390),
    [sym_true] = ACTIONS(2388),
    [sym_false] = ACTIONS(2388),
    [anon_sym_NULL] = ACTIONS(2388),
    [anon_sym_nullptr] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2388),
    [anon_sym_decltype] = ACTIONS(2388),
    [sym_virtual] = ACTIONS(2388),
    [anon_sym_explicit] = ACTIONS(2388),
    [anon_sym_typename] = ACTIONS(2388),
    [anon_sym_template] = ACTIONS(2388),
    [anon_sym_operator] = ACTIONS(2388),
    [anon_sym_try] = ACTIONS(2388),
    [anon_sym_delete] = ACTIONS(2388),
    [anon_sym_throw] = ACTIONS(2388),
    [anon_sym_namespace] = ACTIONS(2388),
    [anon_sym_using] = ACTIONS(2388),
    [anon_sym_static_assert] = ACTIONS(2388),
    [anon_sym_concept] = ACTIONS(2388),
    [anon_sym_co_return] = ACTIONS(2388),
    [anon_sym_co_yield] = ACTIONS(2388),
    [anon_sym_R_DQUOTE] = ACTIONS(2390),
    [anon_sym_LR_DQUOTE] = ACTIONS(2390),
    [anon_sym_uR_DQUOTE] = ACTIONS(2390),
    [anon_sym_UR_DQUOTE] = ACTIONS(2390),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2390),
    [anon_sym_co_await] = ACTIONS(2388),
    [anon_sym_new] = ACTIONS(2388),
    [anon_sym_requires] = ACTIONS(2388),
    [sym_this] = ACTIONS(2388),
    [anon_sym___launch_bounds__] = ACTIONS(2388),
  },
  [277] = {
    [sym_identifier] = ACTIONS(2392),
    [aux_sym_preproc_include_token1] = ACTIONS(2392),
    [aux_sym_preproc_def_token1] = ACTIONS(2392),
    [aux_sym_preproc_if_token1] = ACTIONS(2392),
    [aux_sym_preproc_if_token2] = ACTIONS(2392),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2392),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2392),
    [aux_sym_preproc_else_token1] = ACTIONS(2392),
    [aux_sym_preproc_elif_token1] = ACTIONS(2392),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2392),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2392),
    [sym_preproc_directive] = ACTIONS(2392),
    [anon_sym_LPAREN2] = ACTIONS(2394),
    [anon_sym_BANG] = ACTIONS(2394),
    [anon_sym_TILDE] = ACTIONS(2394),
    [anon_sym_DASH] = ACTIONS(2392),
    [anon_sym_PLUS] = ACTIONS(2392),
    [anon_sym_STAR] = ACTIONS(2394),
    [anon_sym_AMP_AMP] = ACTIONS(2394),
    [anon_sym_AMP] = ACTIONS(2392),
    [anon_sym_SEMI] = ACTIONS(2394),
    [anon_sym___extension__] = ACTIONS(2392),
    [anon_sym_typedef] = ACTIONS(2392),
    [anon_sym___device__] = ACTIONS(2392),
    [anon_sym___host__] = ACTIONS(2392),
    [anon_sym___global__] = ACTIONS(2392),
    [anon_sym___forceinline__] = ACTIONS(2392),
    [anon_sym___noinline__] = ACTIONS(2392),
    [anon_sym_extern] = ACTIONS(2392),
    [anon_sym___attribute__] = ACTIONS(2392),
    [anon_sym_COLON_COLON] = ACTIONS(2394),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2394),
    [anon_sym___declspec] = ACTIONS(2392),
    [anon_sym___based] = ACTIONS(2392),
    [anon_sym___cdecl] = ACTIONS(2392),
    [anon_sym___clrcall] = ACTIONS(2392),
    [anon_sym___stdcall] = ACTIONS(2392),
    [anon_sym___fastcall] = ACTIONS(2392),
    [anon_sym___thiscall] = ACTIONS(2392),
    [anon_sym___vectorcall] = ACTIONS(2392),
    [anon_sym_LBRACE] = ACTIONS(2394),
    [anon_sym_signed] = ACTIONS(2392),
    [anon_sym_unsigned] = ACTIONS(2392),
    [anon_sym_long] = ACTIONS(2392),
    [anon_sym_short] = ACTIONS(2392),
    [anon_sym_LBRACK] = ACTIONS(2392),
    [anon_sym_static] = ACTIONS(2392),
    [anon_sym_register] = ACTIONS(2392),
    [anon_sym_inline] = ACTIONS(2392),
    [anon_sym___inline] = ACTIONS(2392),
    [anon_sym___inline__] = ACTIONS(2392),
    [anon_sym___forceinline] = ACTIONS(2392),
    [anon_sym_thread_local] = ACTIONS(2392),
    [anon_sym___thread] = ACTIONS(2392),
    [anon_sym_const] = ACTIONS(2392),
    [anon_sym_constexpr] = ACTIONS(2392),
    [anon_sym_volatile] = ACTIONS(2392),
    [anon_sym_restrict] = ACTIONS(2392),
    [anon_sym___restrict__] = ACTIONS(2392),
    [anon_sym__Atomic] = ACTIONS(2392),
    [anon_sym__Noreturn] = ACTIONS(2392),
    [anon_sym_noreturn] = ACTIONS(2392),
    [anon_sym_mutable] = ACTIONS(2392),
    [anon_sym_constinit] = ACTIONS(2392),
    [anon_sym_consteval] = ACTIONS(2392),
    [anon_sym___shared__] = ACTIONS(2392),
    [anon_sym___local__] = ACTIONS(2392),
    [anon_sym___constant__] = ACTIONS(2392),
    [anon_sym___managed__] = ACTIONS(2392),
    [anon_sym___grid_constant__] = ACTIONS(2392),
    [anon_sym_alignas] = ACTIONS(2392),
    [anon_sym__Alignas] = ACTIONS(2392),
    [sym_primitive_type] = ACTIONS(2392),
    [anon_sym_enum] = ACTIONS(2392),
    [anon_sym_class] = ACTIONS(2392),
    [anon_sym_struct] = ACTIONS(2392),
    [anon_sym_union] = ACTIONS(2392),
    [anon_sym_if] = ACTIONS(2392),
    [anon_sym_switch] = ACTIONS(2392),
    [anon_sym_case] = ACTIONS(2392),
    [anon_sym_default] = ACTIONS(2392),
    [anon_sym_while] = ACTIONS(2392),
    [anon_sym_do] = ACTIONS(2392),
    [anon_sym_for] = ACTIONS(2392),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_break] = ACTIONS(2392),
    [anon_sym_continue] = ACTIONS(2392),
    [anon_sym_goto] = ACTIONS(2392),
    [anon_sym___try] = ACTIONS(2392),
    [anon_sym___leave] = ACTIONS(2392),
    [anon_sym_not] = ACTIONS(2392),
    [anon_sym_compl] = ACTIONS(2392),
    [anon_sym_DASH_DASH] = ACTIONS(2394),
    [anon_sym_PLUS_PLUS] = ACTIONS(2394),
    [anon_sym_sizeof] = ACTIONS(2392),
    [anon_sym___alignof__] = ACTIONS(2392),
    [anon_sym___alignof] = ACTIONS(2392),
    [anon_sym__alignof] = ACTIONS(2392),
    [anon_sym_alignof] = ACTIONS(2392),
    [anon_sym__Alignof] = ACTIONS(2392),
    [anon_sym_offsetof] = ACTIONS(2392),
    [anon_sym__Generic] = ACTIONS(2392),
    [anon_sym_asm] = ACTIONS(2392),
    [anon_sym___asm__] = ACTIONS(2392),
    [sym_number_literal] = ACTIONS(2394),
    [anon_sym_L_SQUOTE] = ACTIONS(2394),
    [anon_sym_u_SQUOTE] = ACTIONS(2394),
    [anon_sym_U_SQUOTE] = ACTIONS(2394),
    [anon_sym_u8_SQUOTE] = ACTIONS(2394),
    [anon_sym_SQUOTE] = ACTIONS(2394),
    [anon_sym_L_DQUOTE] = ACTIONS(2394),
    [anon_sym_u_DQUOTE] = ACTIONS(2394),
    [anon_sym_U_DQUOTE] = ACTIONS(2394),
    [anon_sym_u8_DQUOTE] = ACTIONS(2394),
    [anon_sym_DQUOTE] = ACTIONS(2394),
    [sym_true] = ACTIONS(2392),
    [sym_false] = ACTIONS(2392),
    [anon_sym_NULL] = ACTIONS(2392),
    [anon_sym_nullptr] = ACTIONS(2392),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2392),
    [anon_sym_decltype] = ACTIONS(2392),
    [sym_virtual] = ACTIONS(2392),
    [anon_sym_explicit] = ACTIONS(2392),
    [anon_sym_typename] = ACTIONS(2392),
    [anon_sym_template] = ACTIONS(2392),
    [anon_sym_operator] = ACTIONS(2392),
    [anon_sym_try] = ACTIONS(2392),
    [anon_sym_delete] = ACTIONS(2392),
    [anon_sym_throw] = ACTIONS(2392),
    [anon_sym_namespace] = ACTIONS(2392),
    [anon_sym_using] = ACTIONS(2392),
    [anon_sym_static_assert] = ACTIONS(2392),
    [anon_sym_concept] = ACTIONS(2392),
    [anon_sym_co_return] = ACTIONS(2392),
    [anon_sym_co_yield] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2394),
    [anon_sym_LR_DQUOTE] = ACTIONS(2394),
    [anon_sym_uR_DQUOTE] = ACTIONS(2394),
    [anon_sym_UR_DQUOTE] = ACTIONS(2394),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2394),
    [anon_sym_co_await] = ACTIONS(2392),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2392),
    [sym_this] = ACTIONS(2392),
    [anon_sym___launch_bounds__] = ACTIONS(2392),
  },
  [278] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(2960),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8499),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8985),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8299),
    [sym__unary_right_fold] = STATE(8308),
    [sym__binary_fold] = STATE(8312),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8481),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [279] = {
    [sym_identifier] = ACTIONS(2396),
    [aux_sym_preproc_include_token1] = ACTIONS(2396),
    [aux_sym_preproc_def_token1] = ACTIONS(2396),
    [aux_sym_preproc_if_token1] = ACTIONS(2396),
    [aux_sym_preproc_if_token2] = ACTIONS(2396),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2396),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2396),
    [aux_sym_preproc_else_token1] = ACTIONS(2396),
    [aux_sym_preproc_elif_token1] = ACTIONS(2396),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2396),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2396),
    [sym_preproc_directive] = ACTIONS(2396),
    [anon_sym_LPAREN2] = ACTIONS(2398),
    [anon_sym_BANG] = ACTIONS(2398),
    [anon_sym_TILDE] = ACTIONS(2398),
    [anon_sym_DASH] = ACTIONS(2396),
    [anon_sym_PLUS] = ACTIONS(2396),
    [anon_sym_STAR] = ACTIONS(2398),
    [anon_sym_AMP_AMP] = ACTIONS(2398),
    [anon_sym_AMP] = ACTIONS(2396),
    [anon_sym_SEMI] = ACTIONS(2398),
    [anon_sym___extension__] = ACTIONS(2396),
    [anon_sym_typedef] = ACTIONS(2396),
    [anon_sym___device__] = ACTIONS(2396),
    [anon_sym___host__] = ACTIONS(2396),
    [anon_sym___global__] = ACTIONS(2396),
    [anon_sym___forceinline__] = ACTIONS(2396),
    [anon_sym___noinline__] = ACTIONS(2396),
    [anon_sym_extern] = ACTIONS(2396),
    [anon_sym___attribute__] = ACTIONS(2396),
    [anon_sym_COLON_COLON] = ACTIONS(2398),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2398),
    [anon_sym___declspec] = ACTIONS(2396),
    [anon_sym___based] = ACTIONS(2396),
    [anon_sym___cdecl] = ACTIONS(2396),
    [anon_sym___clrcall] = ACTIONS(2396),
    [anon_sym___stdcall] = ACTIONS(2396),
    [anon_sym___fastcall] = ACTIONS(2396),
    [anon_sym___thiscall] = ACTIONS(2396),
    [anon_sym___vectorcall] = ACTIONS(2396),
    [anon_sym_LBRACE] = ACTIONS(2398),
    [anon_sym_signed] = ACTIONS(2396),
    [anon_sym_unsigned] = ACTIONS(2396),
    [anon_sym_long] = ACTIONS(2396),
    [anon_sym_short] = ACTIONS(2396),
    [anon_sym_LBRACK] = ACTIONS(2396),
    [anon_sym_static] = ACTIONS(2396),
    [anon_sym_register] = ACTIONS(2396),
    [anon_sym_inline] = ACTIONS(2396),
    [anon_sym___inline] = ACTIONS(2396),
    [anon_sym___inline__] = ACTIONS(2396),
    [anon_sym___forceinline] = ACTIONS(2396),
    [anon_sym_thread_local] = ACTIONS(2396),
    [anon_sym___thread] = ACTIONS(2396),
    [anon_sym_const] = ACTIONS(2396),
    [anon_sym_constexpr] = ACTIONS(2396),
    [anon_sym_volatile] = ACTIONS(2396),
    [anon_sym_restrict] = ACTIONS(2396),
    [anon_sym___restrict__] = ACTIONS(2396),
    [anon_sym__Atomic] = ACTIONS(2396),
    [anon_sym__Noreturn] = ACTIONS(2396),
    [anon_sym_noreturn] = ACTIONS(2396),
    [anon_sym_mutable] = ACTIONS(2396),
    [anon_sym_constinit] = ACTIONS(2396),
    [anon_sym_consteval] = ACTIONS(2396),
    [anon_sym___shared__] = ACTIONS(2396),
    [anon_sym___local__] = ACTIONS(2396),
    [anon_sym___constant__] = ACTIONS(2396),
    [anon_sym___managed__] = ACTIONS(2396),
    [anon_sym___grid_constant__] = ACTIONS(2396),
    [anon_sym_alignas] = ACTIONS(2396),
    [anon_sym__Alignas] = ACTIONS(2396),
    [sym_primitive_type] = ACTIONS(2396),
    [anon_sym_enum] = ACTIONS(2396),
    [anon_sym_class] = ACTIONS(2396),
    [anon_sym_struct] = ACTIONS(2396),
    [anon_sym_union] = ACTIONS(2396),
    [anon_sym_if] = ACTIONS(2396),
    [anon_sym_switch] = ACTIONS(2396),
    [anon_sym_case] = ACTIONS(2396),
    [anon_sym_default] = ACTIONS(2396),
    [anon_sym_while] = ACTIONS(2396),
    [anon_sym_do] = ACTIONS(2396),
    [anon_sym_for] = ACTIONS(2396),
    [anon_sym_return] = ACTIONS(2396),
    [anon_sym_break] = ACTIONS(2396),
    [anon_sym_continue] = ACTIONS(2396),
    [anon_sym_goto] = ACTIONS(2396),
    [anon_sym___try] = ACTIONS(2396),
    [anon_sym___leave] = ACTIONS(2396),
    [anon_sym_not] = ACTIONS(2396),
    [anon_sym_compl] = ACTIONS(2396),
    [anon_sym_DASH_DASH] = ACTIONS(2398),
    [anon_sym_PLUS_PLUS] = ACTIONS(2398),
    [anon_sym_sizeof] = ACTIONS(2396),
    [anon_sym___alignof__] = ACTIONS(2396),
    [anon_sym___alignof] = ACTIONS(2396),
    [anon_sym__alignof] = ACTIONS(2396),
    [anon_sym_alignof] = ACTIONS(2396),
    [anon_sym__Alignof] = ACTIONS(2396),
    [anon_sym_offsetof] = ACTIONS(2396),
    [anon_sym__Generic] = ACTIONS(2396),
    [anon_sym_asm] = ACTIONS(2396),
    [anon_sym___asm__] = ACTIONS(2396),
    [sym_number_literal] = ACTIONS(2398),
    [anon_sym_L_SQUOTE] = ACTIONS(2398),
    [anon_sym_u_SQUOTE] = ACTIONS(2398),
    [anon_sym_U_SQUOTE] = ACTIONS(2398),
    [anon_sym_u8_SQUOTE] = ACTIONS(2398),
    [anon_sym_SQUOTE] = ACTIONS(2398),
    [anon_sym_L_DQUOTE] = ACTIONS(2398),
    [anon_sym_u_DQUOTE] = ACTIONS(2398),
    [anon_sym_U_DQUOTE] = ACTIONS(2398),
    [anon_sym_u8_DQUOTE] = ACTIONS(2398),
    [anon_sym_DQUOTE] = ACTIONS(2398),
    [sym_true] = ACTIONS(2396),
    [sym_false] = ACTIONS(2396),
    [anon_sym_NULL] = ACTIONS(2396),
    [anon_sym_nullptr] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2396),
    [anon_sym_decltype] = ACTIONS(2396),
    [sym_virtual] = ACTIONS(2396),
    [anon_sym_explicit] = ACTIONS(2396),
    [anon_sym_typename] = ACTIONS(2396),
    [anon_sym_template] = ACTIONS(2396),
    [anon_sym_operator] = ACTIONS(2396),
    [anon_sym_try] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_throw] = ACTIONS(2396),
    [anon_sym_namespace] = ACTIONS(2396),
    [anon_sym_using] = ACTIONS(2396),
    [anon_sym_static_assert] = ACTIONS(2396),
    [anon_sym_concept] = ACTIONS(2396),
    [anon_sym_co_return] = ACTIONS(2396),
    [anon_sym_co_yield] = ACTIONS(2396),
    [anon_sym_R_DQUOTE] = ACTIONS(2398),
    [anon_sym_LR_DQUOTE] = ACTIONS(2398),
    [anon_sym_uR_DQUOTE] = ACTIONS(2398),
    [anon_sym_UR_DQUOTE] = ACTIONS(2398),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2398),
    [anon_sym_co_await] = ACTIONS(2396),
    [anon_sym_new] = ACTIONS(2396),
    [anon_sym_requires] = ACTIONS(2396),
    [sym_this] = ACTIONS(2396),
    [anon_sym___launch_bounds__] = ACTIONS(2396),
  },
  [280] = {
    [sym_identifier] = ACTIONS(2400),
    [aux_sym_preproc_include_token1] = ACTIONS(2400),
    [aux_sym_preproc_def_token1] = ACTIONS(2400),
    [aux_sym_preproc_if_token1] = ACTIONS(2400),
    [aux_sym_preproc_if_token2] = ACTIONS(2400),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2400),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2400),
    [aux_sym_preproc_else_token1] = ACTIONS(2400),
    [aux_sym_preproc_elif_token1] = ACTIONS(2400),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2400),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2400),
    [sym_preproc_directive] = ACTIONS(2400),
    [anon_sym_LPAREN2] = ACTIONS(2402),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_TILDE] = ACTIONS(2402),
    [anon_sym_DASH] = ACTIONS(2400),
    [anon_sym_PLUS] = ACTIONS(2400),
    [anon_sym_STAR] = ACTIONS(2402),
    [anon_sym_AMP_AMP] = ACTIONS(2402),
    [anon_sym_AMP] = ACTIONS(2400),
    [anon_sym_SEMI] = ACTIONS(2402),
    [anon_sym___extension__] = ACTIONS(2400),
    [anon_sym_typedef] = ACTIONS(2400),
    [anon_sym___device__] = ACTIONS(2400),
    [anon_sym___host__] = ACTIONS(2400),
    [anon_sym___global__] = ACTIONS(2400),
    [anon_sym___forceinline__] = ACTIONS(2400),
    [anon_sym___noinline__] = ACTIONS(2400),
    [anon_sym_extern] = ACTIONS(2400),
    [anon_sym___attribute__] = ACTIONS(2400),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2402),
    [anon_sym___declspec] = ACTIONS(2400),
    [anon_sym___based] = ACTIONS(2400),
    [anon_sym___cdecl] = ACTIONS(2400),
    [anon_sym___clrcall] = ACTIONS(2400),
    [anon_sym___stdcall] = ACTIONS(2400),
    [anon_sym___fastcall] = ACTIONS(2400),
    [anon_sym___thiscall] = ACTIONS(2400),
    [anon_sym___vectorcall] = ACTIONS(2400),
    [anon_sym_LBRACE] = ACTIONS(2402),
    [anon_sym_signed] = ACTIONS(2400),
    [anon_sym_unsigned] = ACTIONS(2400),
    [anon_sym_long] = ACTIONS(2400),
    [anon_sym_short] = ACTIONS(2400),
    [anon_sym_LBRACK] = ACTIONS(2400),
    [anon_sym_static] = ACTIONS(2400),
    [anon_sym_register] = ACTIONS(2400),
    [anon_sym_inline] = ACTIONS(2400),
    [anon_sym___inline] = ACTIONS(2400),
    [anon_sym___inline__] = ACTIONS(2400),
    [anon_sym___forceinline] = ACTIONS(2400),
    [anon_sym_thread_local] = ACTIONS(2400),
    [anon_sym___thread] = ACTIONS(2400),
    [anon_sym_const] = ACTIONS(2400),
    [anon_sym_constexpr] = ACTIONS(2400),
    [anon_sym_volatile] = ACTIONS(2400),
    [anon_sym_restrict] = ACTIONS(2400),
    [anon_sym___restrict__] = ACTIONS(2400),
    [anon_sym__Atomic] = ACTIONS(2400),
    [anon_sym__Noreturn] = ACTIONS(2400),
    [anon_sym_noreturn] = ACTIONS(2400),
    [anon_sym_mutable] = ACTIONS(2400),
    [anon_sym_constinit] = ACTIONS(2400),
    [anon_sym_consteval] = ACTIONS(2400),
    [anon_sym___shared__] = ACTIONS(2400),
    [anon_sym___local__] = ACTIONS(2400),
    [anon_sym___constant__] = ACTIONS(2400),
    [anon_sym___managed__] = ACTIONS(2400),
    [anon_sym___grid_constant__] = ACTIONS(2400),
    [anon_sym_alignas] = ACTIONS(2400),
    [anon_sym__Alignas] = ACTIONS(2400),
    [sym_primitive_type] = ACTIONS(2400),
    [anon_sym_enum] = ACTIONS(2400),
    [anon_sym_class] = ACTIONS(2400),
    [anon_sym_struct] = ACTIONS(2400),
    [anon_sym_union] = ACTIONS(2400),
    [anon_sym_if] = ACTIONS(2400),
    [anon_sym_switch] = ACTIONS(2400),
    [anon_sym_case] = ACTIONS(2400),
    [anon_sym_default] = ACTIONS(2400),
    [anon_sym_while] = ACTIONS(2400),
    [anon_sym_do] = ACTIONS(2400),
    [anon_sym_for] = ACTIONS(2400),
    [anon_sym_return] = ACTIONS(2400),
    [anon_sym_break] = ACTIONS(2400),
    [anon_sym_continue] = ACTIONS(2400),
    [anon_sym_goto] = ACTIONS(2400),
    [anon_sym___try] = ACTIONS(2400),
    [anon_sym___leave] = ACTIONS(2400),
    [anon_sym_not] = ACTIONS(2400),
    [anon_sym_compl] = ACTIONS(2400),
    [anon_sym_DASH_DASH] = ACTIONS(2402),
    [anon_sym_PLUS_PLUS] = ACTIONS(2402),
    [anon_sym_sizeof] = ACTIONS(2400),
    [anon_sym___alignof__] = ACTIONS(2400),
    [anon_sym___alignof] = ACTIONS(2400),
    [anon_sym__alignof] = ACTIONS(2400),
    [anon_sym_alignof] = ACTIONS(2400),
    [anon_sym__Alignof] = ACTIONS(2400),
    [anon_sym_offsetof] = ACTIONS(2400),
    [anon_sym__Generic] = ACTIONS(2400),
    [anon_sym_asm] = ACTIONS(2400),
    [anon_sym___asm__] = ACTIONS(2400),
    [sym_number_literal] = ACTIONS(2402),
    [anon_sym_L_SQUOTE] = ACTIONS(2402),
    [anon_sym_u_SQUOTE] = ACTIONS(2402),
    [anon_sym_U_SQUOTE] = ACTIONS(2402),
    [anon_sym_u8_SQUOTE] = ACTIONS(2402),
    [anon_sym_SQUOTE] = ACTIONS(2402),
    [anon_sym_L_DQUOTE] = ACTIONS(2402),
    [anon_sym_u_DQUOTE] = ACTIONS(2402),
    [anon_sym_U_DQUOTE] = ACTIONS(2402),
    [anon_sym_u8_DQUOTE] = ACTIONS(2402),
    [anon_sym_DQUOTE] = ACTIONS(2402),
    [sym_true] = ACTIONS(2400),
    [sym_false] = ACTIONS(2400),
    [anon_sym_NULL] = ACTIONS(2400),
    [anon_sym_nullptr] = ACTIONS(2400),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2400),
    [anon_sym_decltype] = ACTIONS(2400),
    [sym_virtual] = ACTIONS(2400),
    [anon_sym_explicit] = ACTIONS(2400),
    [anon_sym_typename] = ACTIONS(2400),
    [anon_sym_template] = ACTIONS(2400),
    [anon_sym_operator] = ACTIONS(2400),
    [anon_sym_try] = ACTIONS(2400),
    [anon_sym_delete] = ACTIONS(2400),
    [anon_sym_throw] = ACTIONS(2400),
    [anon_sym_namespace] = ACTIONS(2400),
    [anon_sym_using] = ACTIONS(2400),
    [anon_sym_static_assert] = ACTIONS(2400),
    [anon_sym_concept] = ACTIONS(2400),
    [anon_sym_co_return] = ACTIONS(2400),
    [anon_sym_co_yield] = ACTIONS(2400),
    [anon_sym_R_DQUOTE] = ACTIONS(2402),
    [anon_sym_LR_DQUOTE] = ACTIONS(2402),
    [anon_sym_uR_DQUOTE] = ACTIONS(2402),
    [anon_sym_UR_DQUOTE] = ACTIONS(2402),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2402),
    [anon_sym_co_await] = ACTIONS(2400),
    [anon_sym_new] = ACTIONS(2400),
    [anon_sym_requires] = ACTIONS(2400),
    [sym_this] = ACTIONS(2400),
    [anon_sym___launch_bounds__] = ACTIONS(2400),
  },
  [281] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(2960),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8499),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8232),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8509),
    [sym__unary_right_fold] = STATE(8507),
    [sym__binary_fold] = STATE(8501),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8481),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [282] = {
    [sym_catch_clause] = STATE(282),
    [aux_sym_constructor_try_statement_repeat1] = STATE(282),
    [ts_builtin_sym_end] = ACTIONS(1911),
    [sym_identifier] = ACTIONS(1909),
    [aux_sym_preproc_include_token1] = ACTIONS(1909),
    [aux_sym_preproc_def_token1] = ACTIONS(1909),
    [aux_sym_preproc_if_token1] = ACTIONS(1909),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1909),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1909),
    [sym_preproc_directive] = ACTIONS(1909),
    [anon_sym_LPAREN2] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_SEMI] = ACTIONS(1911),
    [anon_sym___extension__] = ACTIONS(1909),
    [anon_sym_typedef] = ACTIONS(1909),
    [anon_sym___device__] = ACTIONS(1909),
    [anon_sym___host__] = ACTIONS(1909),
    [anon_sym___global__] = ACTIONS(1909),
    [anon_sym___forceinline__] = ACTIONS(1909),
    [anon_sym___noinline__] = ACTIONS(1909),
    [anon_sym_extern] = ACTIONS(1909),
    [anon_sym___attribute__] = ACTIONS(1909),
    [anon_sym_COLON_COLON] = ACTIONS(1911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1911),
    [anon_sym___declspec] = ACTIONS(1909),
    [anon_sym___based] = ACTIONS(1909),
    [anon_sym___cdecl] = ACTIONS(1909),
    [anon_sym___clrcall] = ACTIONS(1909),
    [anon_sym___stdcall] = ACTIONS(1909),
    [anon_sym___fastcall] = ACTIONS(1909),
    [anon_sym___thiscall] = ACTIONS(1909),
    [anon_sym___vectorcall] = ACTIONS(1909),
    [anon_sym_LBRACE] = ACTIONS(1911),
    [anon_sym_signed] = ACTIONS(1909),
    [anon_sym_unsigned] = ACTIONS(1909),
    [anon_sym_long] = ACTIONS(1909),
    [anon_sym_short] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_static] = ACTIONS(1909),
    [anon_sym_register] = ACTIONS(1909),
    [anon_sym_inline] = ACTIONS(1909),
    [anon_sym___inline] = ACTIONS(1909),
    [anon_sym___inline__] = ACTIONS(1909),
    [anon_sym___forceinline] = ACTIONS(1909),
    [anon_sym_thread_local] = ACTIONS(1909),
    [anon_sym___thread] = ACTIONS(1909),
    [anon_sym_const] = ACTIONS(1909),
    [anon_sym_constexpr] = ACTIONS(1909),
    [anon_sym_volatile] = ACTIONS(1909),
    [anon_sym_restrict] = ACTIONS(1909),
    [anon_sym___restrict__] = ACTIONS(1909),
    [anon_sym__Atomic] = ACTIONS(1909),
    [anon_sym__Noreturn] = ACTIONS(1909),
    [anon_sym_noreturn] = ACTIONS(1909),
    [anon_sym_mutable] = ACTIONS(1909),
    [anon_sym_constinit] = ACTIONS(1909),
    [anon_sym_consteval] = ACTIONS(1909),
    [anon_sym___shared__] = ACTIONS(1909),
    [anon_sym___local__] = ACTIONS(1909),
    [anon_sym___constant__] = ACTIONS(1909),
    [anon_sym___managed__] = ACTIONS(1909),
    [anon_sym___grid_constant__] = ACTIONS(1909),
    [anon_sym_alignas] = ACTIONS(1909),
    [anon_sym__Alignas] = ACTIONS(1909),
    [sym_primitive_type] = ACTIONS(1909),
    [anon_sym_enum] = ACTIONS(1909),
    [anon_sym_class] = ACTIONS(1909),
    [anon_sym_struct] = ACTIONS(1909),
    [anon_sym_union] = ACTIONS(1909),
    [anon_sym_if] = ACTIONS(1909),
    [anon_sym_else] = ACTIONS(1909),
    [anon_sym_switch] = ACTIONS(1909),
    [anon_sym_case] = ACTIONS(1909),
    [anon_sym_default] = ACTIONS(1909),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_do] = ACTIONS(1909),
    [anon_sym_for] = ACTIONS(1909),
    [anon_sym_return] = ACTIONS(1909),
    [anon_sym_break] = ACTIONS(1909),
    [anon_sym_continue] = ACTIONS(1909),
    [anon_sym_goto] = ACTIONS(1909),
    [anon_sym___try] = ACTIONS(1909),
    [anon_sym___leave] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1909),
    [anon_sym_compl] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_sizeof] = ACTIONS(1909),
    [anon_sym___alignof__] = ACTIONS(1909),
    [anon_sym___alignof] = ACTIONS(1909),
    [anon_sym__alignof] = ACTIONS(1909),
    [anon_sym_alignof] = ACTIONS(1909),
    [anon_sym__Alignof] = ACTIONS(1909),
    [anon_sym_offsetof] = ACTIONS(1909),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1909),
    [anon_sym___asm__] = ACTIONS(1909),
    [sym_number_literal] = ACTIONS(1911),
    [anon_sym_L_SQUOTE] = ACTIONS(1911),
    [anon_sym_u_SQUOTE] = ACTIONS(1911),
    [anon_sym_U_SQUOTE] = ACTIONS(1911),
    [anon_sym_u8_SQUOTE] = ACTIONS(1911),
    [anon_sym_SQUOTE] = ACTIONS(1911),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1909),
    [sym_false] = ACTIONS(1909),
    [anon_sym_NULL] = ACTIONS(1909),
    [anon_sym_nullptr] = ACTIONS(1909),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1909),
    [anon_sym_decltype] = ACTIONS(1909),
    [sym_virtual] = ACTIONS(1909),
    [anon_sym_explicit] = ACTIONS(1909),
    [anon_sym_typename] = ACTIONS(1909),
    [anon_sym_template] = ACTIONS(1909),
    [anon_sym_operator] = ACTIONS(1909),
    [anon_sym_try] = ACTIONS(1909),
    [anon_sym_delete] = ACTIONS(1909),
    [anon_sym_throw] = ACTIONS(1909),
    [anon_sym_namespace] = ACTIONS(1909),
    [anon_sym_using] = ACTIONS(1909),
    [anon_sym_static_assert] = ACTIONS(1909),
    [anon_sym_concept] = ACTIONS(1909),
    [anon_sym_co_return] = ACTIONS(1909),
    [anon_sym_co_yield] = ACTIONS(1909),
    [anon_sym_catch] = ACTIONS(2404),
    [anon_sym_R_DQUOTE] = ACTIONS(1911),
    [anon_sym_LR_DQUOTE] = ACTIONS(1911),
    [anon_sym_uR_DQUOTE] = ACTIONS(1911),
    [anon_sym_UR_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1911),
    [anon_sym_co_await] = ACTIONS(1909),
    [anon_sym_new] = ACTIONS(1909),
    [anon_sym_requires] = ACTIONS(1909),
    [sym_this] = ACTIONS(1909),
    [anon_sym___launch_bounds__] = ACTIONS(1909),
  },
  [283] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(2985),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8787),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8340),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8282),
    [sym__unary_right_fold] = STATE(8283),
    [sym__binary_fold] = STATE(8289),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8780),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [284] = {
    [sym_preproc_def] = STATE(265),
    [sym_preproc_function_def] = STATE(265),
    [sym_preproc_call] = STATE(265),
    [sym_preproc_if_in_field_declaration_list] = STATE(265),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(265),
    [sym_preproc_else_in_field_declaration_list] = STATE(8477),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8477),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8477),
    [sym_type_definition] = STATE(265),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5944),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6464),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(265),
    [sym_field_declaration] = STATE(265),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1701),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(265),
    [sym_operator_cast] = STATE(6994),
    [sym_inline_method_definition] = STATE(265),
    [sym__constructor_specifiers] = STATE(1701),
    [sym_operator_cast_definition] = STATE(265),
    [sym_operator_cast_declaration] = STATE(265),
    [sym_constructor_or_destructor_definition] = STATE(265),
    [sym_constructor_or_destructor_declaration] = STATE(265),
    [sym_friend_declaration] = STATE(265),
    [sym_access_specifier] = STATE(9001),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(265),
    [sym_alias_declaration] = STATE(265),
    [sym_static_assert_declaration] = STATE(265),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6994),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(265),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1701),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(2100),
    [aux_sym_preproc_if_token1] = ACTIONS(2102),
    [aux_sym_preproc_if_token2] = ACTIONS(2407),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2106),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2106),
    [aux_sym_preproc_else_token1] = ACTIONS(2108),
    [aux_sym_preproc_elif_token1] = ACTIONS(2110),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2112),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2112),
    [sym_preproc_directive] = ACTIONS(2114),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(2124),
    [anon_sym_typedef] = ACTIONS(2126),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(2144),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2146),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(2150),
    [anon_sym_static_assert] = ACTIONS(2152),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [285] = {
    [sym_identifier] = ACTIONS(2409),
    [aux_sym_preproc_include_token1] = ACTIONS(2409),
    [aux_sym_preproc_def_token1] = ACTIONS(2409),
    [aux_sym_preproc_if_token1] = ACTIONS(2409),
    [aux_sym_preproc_if_token2] = ACTIONS(2409),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2409),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2409),
    [aux_sym_preproc_else_token1] = ACTIONS(2409),
    [aux_sym_preproc_elif_token1] = ACTIONS(2409),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2409),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2409),
    [sym_preproc_directive] = ACTIONS(2409),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_BANG] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2409),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2409),
    [anon_sym_SEMI] = ACTIONS(2411),
    [anon_sym___extension__] = ACTIONS(2409),
    [anon_sym_typedef] = ACTIONS(2409),
    [anon_sym___device__] = ACTIONS(2409),
    [anon_sym___host__] = ACTIONS(2409),
    [anon_sym___global__] = ACTIONS(2409),
    [anon_sym___forceinline__] = ACTIONS(2409),
    [anon_sym___noinline__] = ACTIONS(2409),
    [anon_sym_extern] = ACTIONS(2409),
    [anon_sym___attribute__] = ACTIONS(2409),
    [anon_sym_COLON_COLON] = ACTIONS(2411),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2411),
    [anon_sym___declspec] = ACTIONS(2409),
    [anon_sym___based] = ACTIONS(2409),
    [anon_sym___cdecl] = ACTIONS(2409),
    [anon_sym___clrcall] = ACTIONS(2409),
    [anon_sym___stdcall] = ACTIONS(2409),
    [anon_sym___fastcall] = ACTIONS(2409),
    [anon_sym___thiscall] = ACTIONS(2409),
    [anon_sym___vectorcall] = ACTIONS(2409),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_signed] = ACTIONS(2409),
    [anon_sym_unsigned] = ACTIONS(2409),
    [anon_sym_long] = ACTIONS(2409),
    [anon_sym_short] = ACTIONS(2409),
    [anon_sym_LBRACK] = ACTIONS(2409),
    [anon_sym_static] = ACTIONS(2409),
    [anon_sym_register] = ACTIONS(2409),
    [anon_sym_inline] = ACTIONS(2409),
    [anon_sym___inline] = ACTIONS(2409),
    [anon_sym___inline__] = ACTIONS(2409),
    [anon_sym___forceinline] = ACTIONS(2409),
    [anon_sym_thread_local] = ACTIONS(2409),
    [anon_sym___thread] = ACTIONS(2409),
    [anon_sym_const] = ACTIONS(2409),
    [anon_sym_constexpr] = ACTIONS(2409),
    [anon_sym_volatile] = ACTIONS(2409),
    [anon_sym_restrict] = ACTIONS(2409),
    [anon_sym___restrict__] = ACTIONS(2409),
    [anon_sym__Atomic] = ACTIONS(2409),
    [anon_sym__Noreturn] = ACTIONS(2409),
    [anon_sym_noreturn] = ACTIONS(2409),
    [anon_sym_mutable] = ACTIONS(2409),
    [anon_sym_constinit] = ACTIONS(2409),
    [anon_sym_consteval] = ACTIONS(2409),
    [anon_sym___shared__] = ACTIONS(2409),
    [anon_sym___local__] = ACTIONS(2409),
    [anon_sym___constant__] = ACTIONS(2409),
    [anon_sym___managed__] = ACTIONS(2409),
    [anon_sym___grid_constant__] = ACTIONS(2409),
    [anon_sym_alignas] = ACTIONS(2409),
    [anon_sym__Alignas] = ACTIONS(2409),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2409),
    [anon_sym_class] = ACTIONS(2409),
    [anon_sym_struct] = ACTIONS(2409),
    [anon_sym_union] = ACTIONS(2409),
    [anon_sym_if] = ACTIONS(2409),
    [anon_sym_switch] = ACTIONS(2409),
    [anon_sym_case] = ACTIONS(2409),
    [anon_sym_default] = ACTIONS(2409),
    [anon_sym_while] = ACTIONS(2409),
    [anon_sym_do] = ACTIONS(2409),
    [anon_sym_for] = ACTIONS(2409),
    [anon_sym_return] = ACTIONS(2409),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_continue] = ACTIONS(2409),
    [anon_sym_goto] = ACTIONS(2409),
    [anon_sym___try] = ACTIONS(2409),
    [anon_sym___leave] = ACTIONS(2409),
    [anon_sym_not] = ACTIONS(2409),
    [anon_sym_compl] = ACTIONS(2409),
    [anon_sym_DASH_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_PLUS] = ACTIONS(2411),
    [anon_sym_sizeof] = ACTIONS(2409),
    [anon_sym___alignof__] = ACTIONS(2409),
    [anon_sym___alignof] = ACTIONS(2409),
    [anon_sym__alignof] = ACTIONS(2409),
    [anon_sym_alignof] = ACTIONS(2409),
    [anon_sym__Alignof] = ACTIONS(2409),
    [anon_sym_offsetof] = ACTIONS(2409),
    [anon_sym__Generic] = ACTIONS(2409),
    [anon_sym_asm] = ACTIONS(2409),
    [anon_sym___asm__] = ACTIONS(2409),
    [sym_number_literal] = ACTIONS(2411),
    [anon_sym_L_SQUOTE] = ACTIONS(2411),
    [anon_sym_u_SQUOTE] = ACTIONS(2411),
    [anon_sym_U_SQUOTE] = ACTIONS(2411),
    [anon_sym_u8_SQUOTE] = ACTIONS(2411),
    [anon_sym_SQUOTE] = ACTIONS(2411),
    [anon_sym_L_DQUOTE] = ACTIONS(2411),
    [anon_sym_u_DQUOTE] = ACTIONS(2411),
    [anon_sym_U_DQUOTE] = ACTIONS(2411),
    [anon_sym_u8_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [sym_true] = ACTIONS(2409),
    [sym_false] = ACTIONS(2409),
    [anon_sym_NULL] = ACTIONS(2409),
    [anon_sym_nullptr] = ACTIONS(2409),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2409),
    [anon_sym_decltype] = ACTIONS(2409),
    [sym_virtual] = ACTIONS(2409),
    [anon_sym_explicit] = ACTIONS(2409),
    [anon_sym_typename] = ACTIONS(2409),
    [anon_sym_template] = ACTIONS(2409),
    [anon_sym_operator] = ACTIONS(2409),
    [anon_sym_try] = ACTIONS(2409),
    [anon_sym_delete] = ACTIONS(2409),
    [anon_sym_throw] = ACTIONS(2409),
    [anon_sym_namespace] = ACTIONS(2409),
    [anon_sym_using] = ACTIONS(2409),
    [anon_sym_static_assert] = ACTIONS(2409),
    [anon_sym_concept] = ACTIONS(2409),
    [anon_sym_co_return] = ACTIONS(2409),
    [anon_sym_co_yield] = ACTIONS(2409),
    [anon_sym_R_DQUOTE] = ACTIONS(2411),
    [anon_sym_LR_DQUOTE] = ACTIONS(2411),
    [anon_sym_uR_DQUOTE] = ACTIONS(2411),
    [anon_sym_UR_DQUOTE] = ACTIONS(2411),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2411),
    [anon_sym_co_await] = ACTIONS(2409),
    [anon_sym_new] = ACTIONS(2409),
    [anon_sym_requires] = ACTIONS(2409),
    [sym_this] = ACTIONS(2409),
    [anon_sym___launch_bounds__] = ACTIONS(2409),
  },
  [286] = {
    [sym_preproc_def] = STATE(271),
    [sym_preproc_function_def] = STATE(271),
    [sym_preproc_call] = STATE(271),
    [sym_preproc_if_in_field_declaration_list] = STATE(271),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(271),
    [sym_preproc_else_in_field_declaration_list] = STATE(8471),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8471),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8471),
    [sym_type_definition] = STATE(271),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5944),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6464),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(271),
    [sym_field_declaration] = STATE(271),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1701),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(271),
    [sym_operator_cast] = STATE(6994),
    [sym_inline_method_definition] = STATE(271),
    [sym__constructor_specifiers] = STATE(1701),
    [sym_operator_cast_definition] = STATE(271),
    [sym_operator_cast_declaration] = STATE(271),
    [sym_constructor_or_destructor_definition] = STATE(271),
    [sym_constructor_or_destructor_declaration] = STATE(271),
    [sym_friend_declaration] = STATE(271),
    [sym_access_specifier] = STATE(9001),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(271),
    [sym_alias_declaration] = STATE(271),
    [sym_static_assert_declaration] = STATE(271),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6994),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(271),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1701),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(2100),
    [aux_sym_preproc_if_token1] = ACTIONS(2102),
    [aux_sym_preproc_if_token2] = ACTIONS(2413),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2106),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2106),
    [aux_sym_preproc_else_token1] = ACTIONS(2108),
    [aux_sym_preproc_elif_token1] = ACTIONS(2110),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2112),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2112),
    [sym_preproc_directive] = ACTIONS(2114),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(2124),
    [anon_sym_typedef] = ACTIONS(2126),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(2144),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2146),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(2150),
    [anon_sym_static_assert] = ACTIONS(2152),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [287] = {
    [sym_expression] = STATE(4819),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8364),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2415),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(2418),
    [anon_sym___extension__] = ACTIONS(2420),
    [anon_sym___device__] = ACTIONS(2420),
    [anon_sym___host__] = ACTIONS(2420),
    [anon_sym___global__] = ACTIONS(2420),
    [anon_sym___forceinline__] = ACTIONS(2420),
    [anon_sym___noinline__] = ACTIONS(2420),
    [anon_sym_extern] = ACTIONS(2420),
    [anon_sym___attribute__] = ACTIONS(2420),
    [anon_sym_COLON_COLON] = ACTIONS(2422),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2425),
    [anon_sym___declspec] = ACTIONS(2420),
    [anon_sym_signed] = ACTIONS(2420),
    [anon_sym_unsigned] = ACTIONS(2420),
    [anon_sym_long] = ACTIONS(2420),
    [anon_sym_short] = ACTIONS(2420),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(2420),
    [anon_sym_register] = ACTIONS(2420),
    [anon_sym_inline] = ACTIONS(2420),
    [anon_sym___inline] = ACTIONS(2420),
    [anon_sym___inline__] = ACTIONS(2420),
    [anon_sym___forceinline] = ACTIONS(2420),
    [anon_sym_thread_local] = ACTIONS(2420),
    [anon_sym___thread] = ACTIONS(2420),
    [anon_sym_const] = ACTIONS(2420),
    [anon_sym_constexpr] = ACTIONS(2420),
    [anon_sym_volatile] = ACTIONS(2420),
    [anon_sym_restrict] = ACTIONS(2420),
    [anon_sym___restrict__] = ACTIONS(2420),
    [anon_sym__Atomic] = ACTIONS(2420),
    [anon_sym__Noreturn] = ACTIONS(2420),
    [anon_sym_noreturn] = ACTIONS(2420),
    [anon_sym_mutable] = ACTIONS(2420),
    [anon_sym_constinit] = ACTIONS(2420),
    [anon_sym_consteval] = ACTIONS(2420),
    [anon_sym___shared__] = ACTIONS(2420),
    [anon_sym___local__] = ACTIONS(2420),
    [anon_sym___constant__] = ACTIONS(2420),
    [anon_sym___managed__] = ACTIONS(2420),
    [anon_sym___grid_constant__] = ACTIONS(2420),
    [anon_sym_alignas] = ACTIONS(2420),
    [anon_sym__Alignas] = ACTIONS(2420),
    [sym_primitive_type] = ACTIONS(2427),
    [anon_sym_enum] = ACTIONS(2420),
    [anon_sym_class] = ACTIONS(2420),
    [anon_sym_struct] = ACTIONS(2420),
    [anon_sym_union] = ACTIONS(2420),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2420),
    [anon_sym_decltype] = ACTIONS(2430),
    [sym_virtual] = ACTIONS(2420),
    [anon_sym_typename] = ACTIONS(2420),
    [anon_sym_template] = ACTIONS(2433),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(2420),
  },
  [288] = {
    [sym_identifier] = ACTIONS(2436),
    [aux_sym_preproc_include_token1] = ACTIONS(2436),
    [aux_sym_preproc_def_token1] = ACTIONS(2436),
    [aux_sym_preproc_if_token1] = ACTIONS(2436),
    [aux_sym_preproc_if_token2] = ACTIONS(2436),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2436),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2436),
    [aux_sym_preproc_else_token1] = ACTIONS(2436),
    [aux_sym_preproc_elif_token1] = ACTIONS(2436),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2436),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2436),
    [sym_preproc_directive] = ACTIONS(2436),
    [anon_sym_LPAREN2] = ACTIONS(2438),
    [anon_sym_BANG] = ACTIONS(2438),
    [anon_sym_TILDE] = ACTIONS(2438),
    [anon_sym_DASH] = ACTIONS(2436),
    [anon_sym_PLUS] = ACTIONS(2436),
    [anon_sym_STAR] = ACTIONS(2438),
    [anon_sym_AMP_AMP] = ACTIONS(2438),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym_SEMI] = ACTIONS(2438),
    [anon_sym___extension__] = ACTIONS(2436),
    [anon_sym_typedef] = ACTIONS(2436),
    [anon_sym___device__] = ACTIONS(2436),
    [anon_sym___host__] = ACTIONS(2436),
    [anon_sym___global__] = ACTIONS(2436),
    [anon_sym___forceinline__] = ACTIONS(2436),
    [anon_sym___noinline__] = ACTIONS(2436),
    [anon_sym_extern] = ACTIONS(2436),
    [anon_sym___attribute__] = ACTIONS(2436),
    [anon_sym_COLON_COLON] = ACTIONS(2438),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2438),
    [anon_sym___declspec] = ACTIONS(2436),
    [anon_sym___based] = ACTIONS(2436),
    [anon_sym___cdecl] = ACTIONS(2436),
    [anon_sym___clrcall] = ACTIONS(2436),
    [anon_sym___stdcall] = ACTIONS(2436),
    [anon_sym___fastcall] = ACTIONS(2436),
    [anon_sym___thiscall] = ACTIONS(2436),
    [anon_sym___vectorcall] = ACTIONS(2436),
    [anon_sym_LBRACE] = ACTIONS(2438),
    [anon_sym_signed] = ACTIONS(2436),
    [anon_sym_unsigned] = ACTIONS(2436),
    [anon_sym_long] = ACTIONS(2436),
    [anon_sym_short] = ACTIONS(2436),
    [anon_sym_LBRACK] = ACTIONS(2436),
    [anon_sym_static] = ACTIONS(2436),
    [anon_sym_register] = ACTIONS(2436),
    [anon_sym_inline] = ACTIONS(2436),
    [anon_sym___inline] = ACTIONS(2436),
    [anon_sym___inline__] = ACTIONS(2436),
    [anon_sym___forceinline] = ACTIONS(2436),
    [anon_sym_thread_local] = ACTIONS(2436),
    [anon_sym___thread] = ACTIONS(2436),
    [anon_sym_const] = ACTIONS(2436),
    [anon_sym_constexpr] = ACTIONS(2436),
    [anon_sym_volatile] = ACTIONS(2436),
    [anon_sym_restrict] = ACTIONS(2436),
    [anon_sym___restrict__] = ACTIONS(2436),
    [anon_sym__Atomic] = ACTIONS(2436),
    [anon_sym__Noreturn] = ACTIONS(2436),
    [anon_sym_noreturn] = ACTIONS(2436),
    [anon_sym_mutable] = ACTIONS(2436),
    [anon_sym_constinit] = ACTIONS(2436),
    [anon_sym_consteval] = ACTIONS(2436),
    [anon_sym___shared__] = ACTIONS(2436),
    [anon_sym___local__] = ACTIONS(2436),
    [anon_sym___constant__] = ACTIONS(2436),
    [anon_sym___managed__] = ACTIONS(2436),
    [anon_sym___grid_constant__] = ACTIONS(2436),
    [anon_sym_alignas] = ACTIONS(2436),
    [anon_sym__Alignas] = ACTIONS(2436),
    [sym_primitive_type] = ACTIONS(2436),
    [anon_sym_enum] = ACTIONS(2436),
    [anon_sym_class] = ACTIONS(2436),
    [anon_sym_struct] = ACTIONS(2436),
    [anon_sym_union] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(2436),
    [anon_sym_switch] = ACTIONS(2436),
    [anon_sym_case] = ACTIONS(2436),
    [anon_sym_default] = ACTIONS(2436),
    [anon_sym_while] = ACTIONS(2436),
    [anon_sym_do] = ACTIONS(2436),
    [anon_sym_for] = ACTIONS(2436),
    [anon_sym_return] = ACTIONS(2436),
    [anon_sym_break] = ACTIONS(2436),
    [anon_sym_continue] = ACTIONS(2436),
    [anon_sym_goto] = ACTIONS(2436),
    [anon_sym___try] = ACTIONS(2436),
    [anon_sym___leave] = ACTIONS(2436),
    [anon_sym_not] = ACTIONS(2436),
    [anon_sym_compl] = ACTIONS(2436),
    [anon_sym_DASH_DASH] = ACTIONS(2438),
    [anon_sym_PLUS_PLUS] = ACTIONS(2438),
    [anon_sym_sizeof] = ACTIONS(2436),
    [anon_sym___alignof__] = ACTIONS(2436),
    [anon_sym___alignof] = ACTIONS(2436),
    [anon_sym__alignof] = ACTIONS(2436),
    [anon_sym_alignof] = ACTIONS(2436),
    [anon_sym__Alignof] = ACTIONS(2436),
    [anon_sym_offsetof] = ACTIONS(2436),
    [anon_sym__Generic] = ACTIONS(2436),
    [anon_sym_asm] = ACTIONS(2436),
    [anon_sym___asm__] = ACTIONS(2436),
    [sym_number_literal] = ACTIONS(2438),
    [anon_sym_L_SQUOTE] = ACTIONS(2438),
    [anon_sym_u_SQUOTE] = ACTIONS(2438),
    [anon_sym_U_SQUOTE] = ACTIONS(2438),
    [anon_sym_u8_SQUOTE] = ACTIONS(2438),
    [anon_sym_SQUOTE] = ACTIONS(2438),
    [anon_sym_L_DQUOTE] = ACTIONS(2438),
    [anon_sym_u_DQUOTE] = ACTIONS(2438),
    [anon_sym_U_DQUOTE] = ACTIONS(2438),
    [anon_sym_u8_DQUOTE] = ACTIONS(2438),
    [anon_sym_DQUOTE] = ACTIONS(2438),
    [sym_true] = ACTIONS(2436),
    [sym_false] = ACTIONS(2436),
    [anon_sym_NULL] = ACTIONS(2436),
    [anon_sym_nullptr] = ACTIONS(2436),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2436),
    [anon_sym_decltype] = ACTIONS(2436),
    [sym_virtual] = ACTIONS(2436),
    [anon_sym_explicit] = ACTIONS(2436),
    [anon_sym_typename] = ACTIONS(2436),
    [anon_sym_template] = ACTIONS(2436),
    [anon_sym_operator] = ACTIONS(2436),
    [anon_sym_try] = ACTIONS(2436),
    [anon_sym_delete] = ACTIONS(2436),
    [anon_sym_throw] = ACTIONS(2436),
    [anon_sym_namespace] = ACTIONS(2436),
    [anon_sym_using] = ACTIONS(2436),
    [anon_sym_static_assert] = ACTIONS(2436),
    [anon_sym_concept] = ACTIONS(2436),
    [anon_sym_co_return] = ACTIONS(2436),
    [anon_sym_co_yield] = ACTIONS(2436),
    [anon_sym_R_DQUOTE] = ACTIONS(2438),
    [anon_sym_LR_DQUOTE] = ACTIONS(2438),
    [anon_sym_uR_DQUOTE] = ACTIONS(2438),
    [anon_sym_UR_DQUOTE] = ACTIONS(2438),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2438),
    [anon_sym_co_await] = ACTIONS(2436),
    [anon_sym_new] = ACTIONS(2436),
    [anon_sym_requires] = ACTIONS(2436),
    [sym_this] = ACTIONS(2436),
    [anon_sym___launch_bounds__] = ACTIONS(2436),
  },
  [289] = {
    [sym_expression] = STATE(4835),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8367),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2440),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(2443),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym___device__] = ACTIONS(1996),
    [anon_sym___host__] = ACTIONS(1996),
    [anon_sym___global__] = ACTIONS(1996),
    [anon_sym___forceinline__] = ACTIONS(1996),
    [anon_sym___noinline__] = ACTIONS(1996),
    [anon_sym_extern] = ACTIONS(1996),
    [anon_sym___attribute__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(2445),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1998),
    [anon_sym___declspec] = ACTIONS(1996),
    [anon_sym_signed] = ACTIONS(1996),
    [anon_sym_unsigned] = ACTIONS(1996),
    [anon_sym_long] = ACTIONS(1996),
    [anon_sym_short] = ACTIONS(1996),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(1996),
    [anon_sym_register] = ACTIONS(1996),
    [anon_sym_inline] = ACTIONS(1996),
    [anon_sym___inline] = ACTIONS(1996),
    [anon_sym___inline__] = ACTIONS(1996),
    [anon_sym___forceinline] = ACTIONS(1996),
    [anon_sym_thread_local] = ACTIONS(1996),
    [anon_sym___thread] = ACTIONS(1996),
    [anon_sym_const] = ACTIONS(1996),
    [anon_sym_constexpr] = ACTIONS(1996),
    [anon_sym_volatile] = ACTIONS(1996),
    [anon_sym_restrict] = ACTIONS(1996),
    [anon_sym___restrict__] = ACTIONS(1996),
    [anon_sym__Atomic] = ACTIONS(1996),
    [anon_sym__Noreturn] = ACTIONS(1996),
    [anon_sym_noreturn] = ACTIONS(1996),
    [anon_sym_mutable] = ACTIONS(1996),
    [anon_sym_constinit] = ACTIONS(1996),
    [anon_sym_consteval] = ACTIONS(1996),
    [anon_sym___shared__] = ACTIONS(1996),
    [anon_sym___local__] = ACTIONS(1996),
    [anon_sym___constant__] = ACTIONS(1996),
    [anon_sym___managed__] = ACTIONS(1996),
    [anon_sym___grid_constant__] = ACTIONS(1996),
    [anon_sym_alignas] = ACTIONS(1996),
    [anon_sym__Alignas] = ACTIONS(1996),
    [sym_primitive_type] = ACTIONS(2448),
    [anon_sym_enum] = ACTIONS(1996),
    [anon_sym_class] = ACTIONS(1996),
    [anon_sym_struct] = ACTIONS(1996),
    [anon_sym_union] = ACTIONS(1996),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1996),
    [anon_sym_decltype] = ACTIONS(2451),
    [sym_virtual] = ACTIONS(1996),
    [anon_sym_typename] = ACTIONS(1996),
    [anon_sym_template] = ACTIONS(2454),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(1996),
  },
  [290] = {
    [sym_identifier] = ACTIONS(2457),
    [aux_sym_preproc_include_token1] = ACTIONS(2457),
    [aux_sym_preproc_def_token1] = ACTIONS(2457),
    [aux_sym_preproc_if_token1] = ACTIONS(2457),
    [aux_sym_preproc_if_token2] = ACTIONS(2457),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2457),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2457),
    [aux_sym_preproc_else_token1] = ACTIONS(2457),
    [aux_sym_preproc_elif_token1] = ACTIONS(2457),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2457),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2457),
    [sym_preproc_directive] = ACTIONS(2457),
    [anon_sym_LPAREN2] = ACTIONS(2459),
    [anon_sym_BANG] = ACTIONS(2459),
    [anon_sym_TILDE] = ACTIONS(2459),
    [anon_sym_DASH] = ACTIONS(2457),
    [anon_sym_PLUS] = ACTIONS(2457),
    [anon_sym_STAR] = ACTIONS(2459),
    [anon_sym_AMP_AMP] = ACTIONS(2459),
    [anon_sym_AMP] = ACTIONS(2457),
    [anon_sym_SEMI] = ACTIONS(2459),
    [anon_sym___extension__] = ACTIONS(2457),
    [anon_sym_typedef] = ACTIONS(2457),
    [anon_sym___device__] = ACTIONS(2457),
    [anon_sym___host__] = ACTIONS(2457),
    [anon_sym___global__] = ACTIONS(2457),
    [anon_sym___forceinline__] = ACTIONS(2457),
    [anon_sym___noinline__] = ACTIONS(2457),
    [anon_sym_extern] = ACTIONS(2457),
    [anon_sym___attribute__] = ACTIONS(2457),
    [anon_sym_COLON_COLON] = ACTIONS(2459),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2459),
    [anon_sym___declspec] = ACTIONS(2457),
    [anon_sym___based] = ACTIONS(2457),
    [anon_sym___cdecl] = ACTIONS(2457),
    [anon_sym___clrcall] = ACTIONS(2457),
    [anon_sym___stdcall] = ACTIONS(2457),
    [anon_sym___fastcall] = ACTIONS(2457),
    [anon_sym___thiscall] = ACTIONS(2457),
    [anon_sym___vectorcall] = ACTIONS(2457),
    [anon_sym_LBRACE] = ACTIONS(2459),
    [anon_sym_signed] = ACTIONS(2457),
    [anon_sym_unsigned] = ACTIONS(2457),
    [anon_sym_long] = ACTIONS(2457),
    [anon_sym_short] = ACTIONS(2457),
    [anon_sym_LBRACK] = ACTIONS(2457),
    [anon_sym_static] = ACTIONS(2457),
    [anon_sym_register] = ACTIONS(2457),
    [anon_sym_inline] = ACTIONS(2457),
    [anon_sym___inline] = ACTIONS(2457),
    [anon_sym___inline__] = ACTIONS(2457),
    [anon_sym___forceinline] = ACTIONS(2457),
    [anon_sym_thread_local] = ACTIONS(2457),
    [anon_sym___thread] = ACTIONS(2457),
    [anon_sym_const] = ACTIONS(2457),
    [anon_sym_constexpr] = ACTIONS(2457),
    [anon_sym_volatile] = ACTIONS(2457),
    [anon_sym_restrict] = ACTIONS(2457),
    [anon_sym___restrict__] = ACTIONS(2457),
    [anon_sym__Atomic] = ACTIONS(2457),
    [anon_sym__Noreturn] = ACTIONS(2457),
    [anon_sym_noreturn] = ACTIONS(2457),
    [anon_sym_mutable] = ACTIONS(2457),
    [anon_sym_constinit] = ACTIONS(2457),
    [anon_sym_consteval] = ACTIONS(2457),
    [anon_sym___shared__] = ACTIONS(2457),
    [anon_sym___local__] = ACTIONS(2457),
    [anon_sym___constant__] = ACTIONS(2457),
    [anon_sym___managed__] = ACTIONS(2457),
    [anon_sym___grid_constant__] = ACTIONS(2457),
    [anon_sym_alignas] = ACTIONS(2457),
    [anon_sym__Alignas] = ACTIONS(2457),
    [sym_primitive_type] = ACTIONS(2457),
    [anon_sym_enum] = ACTIONS(2457),
    [anon_sym_class] = ACTIONS(2457),
    [anon_sym_struct] = ACTIONS(2457),
    [anon_sym_union] = ACTIONS(2457),
    [anon_sym_if] = ACTIONS(2457),
    [anon_sym_switch] = ACTIONS(2457),
    [anon_sym_case] = ACTIONS(2457),
    [anon_sym_default] = ACTIONS(2457),
    [anon_sym_while] = ACTIONS(2457),
    [anon_sym_do] = ACTIONS(2457),
    [anon_sym_for] = ACTIONS(2457),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_break] = ACTIONS(2457),
    [anon_sym_continue] = ACTIONS(2457),
    [anon_sym_goto] = ACTIONS(2457),
    [anon_sym___try] = ACTIONS(2457),
    [anon_sym___leave] = ACTIONS(2457),
    [anon_sym_not] = ACTIONS(2457),
    [anon_sym_compl] = ACTIONS(2457),
    [anon_sym_DASH_DASH] = ACTIONS(2459),
    [anon_sym_PLUS_PLUS] = ACTIONS(2459),
    [anon_sym_sizeof] = ACTIONS(2457),
    [anon_sym___alignof__] = ACTIONS(2457),
    [anon_sym___alignof] = ACTIONS(2457),
    [anon_sym__alignof] = ACTIONS(2457),
    [anon_sym_alignof] = ACTIONS(2457),
    [anon_sym__Alignof] = ACTIONS(2457),
    [anon_sym_offsetof] = ACTIONS(2457),
    [anon_sym__Generic] = ACTIONS(2457),
    [anon_sym_asm] = ACTIONS(2457),
    [anon_sym___asm__] = ACTIONS(2457),
    [sym_number_literal] = ACTIONS(2459),
    [anon_sym_L_SQUOTE] = ACTIONS(2459),
    [anon_sym_u_SQUOTE] = ACTIONS(2459),
    [anon_sym_U_SQUOTE] = ACTIONS(2459),
    [anon_sym_u8_SQUOTE] = ACTIONS(2459),
    [anon_sym_SQUOTE] = ACTIONS(2459),
    [anon_sym_L_DQUOTE] = ACTIONS(2459),
    [anon_sym_u_DQUOTE] = ACTIONS(2459),
    [anon_sym_U_DQUOTE] = ACTIONS(2459),
    [anon_sym_u8_DQUOTE] = ACTIONS(2459),
    [anon_sym_DQUOTE] = ACTIONS(2459),
    [sym_true] = ACTIONS(2457),
    [sym_false] = ACTIONS(2457),
    [anon_sym_NULL] = ACTIONS(2457),
    [anon_sym_nullptr] = ACTIONS(2457),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2457),
    [anon_sym_decltype] = ACTIONS(2457),
    [sym_virtual] = ACTIONS(2457),
    [anon_sym_explicit] = ACTIONS(2457),
    [anon_sym_typename] = ACTIONS(2457),
    [anon_sym_template] = ACTIONS(2457),
    [anon_sym_operator] = ACTIONS(2457),
    [anon_sym_try] = ACTIONS(2457),
    [anon_sym_delete] = ACTIONS(2457),
    [anon_sym_throw] = ACTIONS(2457),
    [anon_sym_namespace] = ACTIONS(2457),
    [anon_sym_using] = ACTIONS(2457),
    [anon_sym_static_assert] = ACTIONS(2457),
    [anon_sym_concept] = ACTIONS(2457),
    [anon_sym_co_return] = ACTIONS(2457),
    [anon_sym_co_yield] = ACTIONS(2457),
    [anon_sym_R_DQUOTE] = ACTIONS(2459),
    [anon_sym_LR_DQUOTE] = ACTIONS(2459),
    [anon_sym_uR_DQUOTE] = ACTIONS(2459),
    [anon_sym_UR_DQUOTE] = ACTIONS(2459),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2459),
    [anon_sym_co_await] = ACTIONS(2457),
    [anon_sym_new] = ACTIONS(2457),
    [anon_sym_requires] = ACTIONS(2457),
    [sym_this] = ACTIONS(2457),
    [anon_sym___launch_bounds__] = ACTIONS(2457),
  },
  [291] = {
    [sym_identifier] = ACTIONS(2461),
    [aux_sym_preproc_include_token1] = ACTIONS(2461),
    [aux_sym_preproc_def_token1] = ACTIONS(2461),
    [aux_sym_preproc_if_token1] = ACTIONS(2461),
    [aux_sym_preproc_if_token2] = ACTIONS(2461),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2461),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2461),
    [aux_sym_preproc_else_token1] = ACTIONS(2461),
    [aux_sym_preproc_elif_token1] = ACTIONS(2461),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2461),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2461),
    [sym_preproc_directive] = ACTIONS(2461),
    [anon_sym_LPAREN2] = ACTIONS(2463),
    [anon_sym_BANG] = ACTIONS(2463),
    [anon_sym_TILDE] = ACTIONS(2463),
    [anon_sym_DASH] = ACTIONS(2461),
    [anon_sym_PLUS] = ACTIONS(2461),
    [anon_sym_STAR] = ACTIONS(2463),
    [anon_sym_AMP_AMP] = ACTIONS(2463),
    [anon_sym_AMP] = ACTIONS(2461),
    [anon_sym_SEMI] = ACTIONS(2463),
    [anon_sym___extension__] = ACTIONS(2461),
    [anon_sym_typedef] = ACTIONS(2461),
    [anon_sym___device__] = ACTIONS(2461),
    [anon_sym___host__] = ACTIONS(2461),
    [anon_sym___global__] = ACTIONS(2461),
    [anon_sym___forceinline__] = ACTIONS(2461),
    [anon_sym___noinline__] = ACTIONS(2461),
    [anon_sym_extern] = ACTIONS(2461),
    [anon_sym___attribute__] = ACTIONS(2461),
    [anon_sym_COLON_COLON] = ACTIONS(2463),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2463),
    [anon_sym___declspec] = ACTIONS(2461),
    [anon_sym___based] = ACTIONS(2461),
    [anon_sym___cdecl] = ACTIONS(2461),
    [anon_sym___clrcall] = ACTIONS(2461),
    [anon_sym___stdcall] = ACTIONS(2461),
    [anon_sym___fastcall] = ACTIONS(2461),
    [anon_sym___thiscall] = ACTIONS(2461),
    [anon_sym___vectorcall] = ACTIONS(2461),
    [anon_sym_LBRACE] = ACTIONS(2463),
    [anon_sym_signed] = ACTIONS(2461),
    [anon_sym_unsigned] = ACTIONS(2461),
    [anon_sym_long] = ACTIONS(2461),
    [anon_sym_short] = ACTIONS(2461),
    [anon_sym_LBRACK] = ACTIONS(2461),
    [anon_sym_static] = ACTIONS(2461),
    [anon_sym_register] = ACTIONS(2461),
    [anon_sym_inline] = ACTIONS(2461),
    [anon_sym___inline] = ACTIONS(2461),
    [anon_sym___inline__] = ACTIONS(2461),
    [anon_sym___forceinline] = ACTIONS(2461),
    [anon_sym_thread_local] = ACTIONS(2461),
    [anon_sym___thread] = ACTIONS(2461),
    [anon_sym_const] = ACTIONS(2461),
    [anon_sym_constexpr] = ACTIONS(2461),
    [anon_sym_volatile] = ACTIONS(2461),
    [anon_sym_restrict] = ACTIONS(2461),
    [anon_sym___restrict__] = ACTIONS(2461),
    [anon_sym__Atomic] = ACTIONS(2461),
    [anon_sym__Noreturn] = ACTIONS(2461),
    [anon_sym_noreturn] = ACTIONS(2461),
    [anon_sym_mutable] = ACTIONS(2461),
    [anon_sym_constinit] = ACTIONS(2461),
    [anon_sym_consteval] = ACTIONS(2461),
    [anon_sym___shared__] = ACTIONS(2461),
    [anon_sym___local__] = ACTIONS(2461),
    [anon_sym___constant__] = ACTIONS(2461),
    [anon_sym___managed__] = ACTIONS(2461),
    [anon_sym___grid_constant__] = ACTIONS(2461),
    [anon_sym_alignas] = ACTIONS(2461),
    [anon_sym__Alignas] = ACTIONS(2461),
    [sym_primitive_type] = ACTIONS(2461),
    [anon_sym_enum] = ACTIONS(2461),
    [anon_sym_class] = ACTIONS(2461),
    [anon_sym_struct] = ACTIONS(2461),
    [anon_sym_union] = ACTIONS(2461),
    [anon_sym_if] = ACTIONS(2461),
    [anon_sym_switch] = ACTIONS(2461),
    [anon_sym_case] = ACTIONS(2461),
    [anon_sym_default] = ACTIONS(2461),
    [anon_sym_while] = ACTIONS(2461),
    [anon_sym_do] = ACTIONS(2461),
    [anon_sym_for] = ACTIONS(2461),
    [anon_sym_return] = ACTIONS(2461),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_continue] = ACTIONS(2461),
    [anon_sym_goto] = ACTIONS(2461),
    [anon_sym___try] = ACTIONS(2461),
    [anon_sym___leave] = ACTIONS(2461),
    [anon_sym_not] = ACTIONS(2461),
    [anon_sym_compl] = ACTIONS(2461),
    [anon_sym_DASH_DASH] = ACTIONS(2463),
    [anon_sym_PLUS_PLUS] = ACTIONS(2463),
    [anon_sym_sizeof] = ACTIONS(2461),
    [anon_sym___alignof__] = ACTIONS(2461),
    [anon_sym___alignof] = ACTIONS(2461),
    [anon_sym__alignof] = ACTIONS(2461),
    [anon_sym_alignof] = ACTIONS(2461),
    [anon_sym__Alignof] = ACTIONS(2461),
    [anon_sym_offsetof] = ACTIONS(2461),
    [anon_sym__Generic] = ACTIONS(2461),
    [anon_sym_asm] = ACTIONS(2461),
    [anon_sym___asm__] = ACTIONS(2461),
    [sym_number_literal] = ACTIONS(2463),
    [anon_sym_L_SQUOTE] = ACTIONS(2463),
    [anon_sym_u_SQUOTE] = ACTIONS(2463),
    [anon_sym_U_SQUOTE] = ACTIONS(2463),
    [anon_sym_u8_SQUOTE] = ACTIONS(2463),
    [anon_sym_SQUOTE] = ACTIONS(2463),
    [anon_sym_L_DQUOTE] = ACTIONS(2463),
    [anon_sym_u_DQUOTE] = ACTIONS(2463),
    [anon_sym_U_DQUOTE] = ACTIONS(2463),
    [anon_sym_u8_DQUOTE] = ACTIONS(2463),
    [anon_sym_DQUOTE] = ACTIONS(2463),
    [sym_true] = ACTIONS(2461),
    [sym_false] = ACTIONS(2461),
    [anon_sym_NULL] = ACTIONS(2461),
    [anon_sym_nullptr] = ACTIONS(2461),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2461),
    [anon_sym_decltype] = ACTIONS(2461),
    [sym_virtual] = ACTIONS(2461),
    [anon_sym_explicit] = ACTIONS(2461),
    [anon_sym_typename] = ACTIONS(2461),
    [anon_sym_template] = ACTIONS(2461),
    [anon_sym_operator] = ACTIONS(2461),
    [anon_sym_try] = ACTIONS(2461),
    [anon_sym_delete] = ACTIONS(2461),
    [anon_sym_throw] = ACTIONS(2461),
    [anon_sym_namespace] = ACTIONS(2461),
    [anon_sym_using] = ACTIONS(2461),
    [anon_sym_static_assert] = ACTIONS(2461),
    [anon_sym_concept] = ACTIONS(2461),
    [anon_sym_co_return] = ACTIONS(2461),
    [anon_sym_co_yield] = ACTIONS(2461),
    [anon_sym_R_DQUOTE] = ACTIONS(2463),
    [anon_sym_LR_DQUOTE] = ACTIONS(2463),
    [anon_sym_uR_DQUOTE] = ACTIONS(2463),
    [anon_sym_UR_DQUOTE] = ACTIONS(2463),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2463),
    [anon_sym_co_await] = ACTIONS(2461),
    [anon_sym_new] = ACTIONS(2461),
    [anon_sym_requires] = ACTIONS(2461),
    [sym_this] = ACTIONS(2461),
    [anon_sym___launch_bounds__] = ACTIONS(2461),
  },
  [292] = {
    [sym_identifier] = ACTIONS(2465),
    [aux_sym_preproc_include_token1] = ACTIONS(2465),
    [aux_sym_preproc_def_token1] = ACTIONS(2465),
    [aux_sym_preproc_if_token1] = ACTIONS(2465),
    [aux_sym_preproc_if_token2] = ACTIONS(2465),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2465),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2465),
    [aux_sym_preproc_else_token1] = ACTIONS(2465),
    [aux_sym_preproc_elif_token1] = ACTIONS(2465),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2465),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2465),
    [sym_preproc_directive] = ACTIONS(2465),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(2467),
    [anon_sym_TILDE] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(2465),
    [anon_sym_PLUS] = ACTIONS(2465),
    [anon_sym_STAR] = ACTIONS(2467),
    [anon_sym_AMP_AMP] = ACTIONS(2467),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym_SEMI] = ACTIONS(2467),
    [anon_sym___extension__] = ACTIONS(2465),
    [anon_sym_typedef] = ACTIONS(2465),
    [anon_sym___device__] = ACTIONS(2465),
    [anon_sym___host__] = ACTIONS(2465),
    [anon_sym___global__] = ACTIONS(2465),
    [anon_sym___forceinline__] = ACTIONS(2465),
    [anon_sym___noinline__] = ACTIONS(2465),
    [anon_sym_extern] = ACTIONS(2465),
    [anon_sym___attribute__] = ACTIONS(2465),
    [anon_sym_COLON_COLON] = ACTIONS(2467),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2467),
    [anon_sym___declspec] = ACTIONS(2465),
    [anon_sym___based] = ACTIONS(2465),
    [anon_sym___cdecl] = ACTIONS(2465),
    [anon_sym___clrcall] = ACTIONS(2465),
    [anon_sym___stdcall] = ACTIONS(2465),
    [anon_sym___fastcall] = ACTIONS(2465),
    [anon_sym___thiscall] = ACTIONS(2465),
    [anon_sym___vectorcall] = ACTIONS(2465),
    [anon_sym_LBRACE] = ACTIONS(2467),
    [anon_sym_signed] = ACTIONS(2465),
    [anon_sym_unsigned] = ACTIONS(2465),
    [anon_sym_long] = ACTIONS(2465),
    [anon_sym_short] = ACTIONS(2465),
    [anon_sym_LBRACK] = ACTIONS(2465),
    [anon_sym_static] = ACTIONS(2465),
    [anon_sym_register] = ACTIONS(2465),
    [anon_sym_inline] = ACTIONS(2465),
    [anon_sym___inline] = ACTIONS(2465),
    [anon_sym___inline__] = ACTIONS(2465),
    [anon_sym___forceinline] = ACTIONS(2465),
    [anon_sym_thread_local] = ACTIONS(2465),
    [anon_sym___thread] = ACTIONS(2465),
    [anon_sym_const] = ACTIONS(2465),
    [anon_sym_constexpr] = ACTIONS(2465),
    [anon_sym_volatile] = ACTIONS(2465),
    [anon_sym_restrict] = ACTIONS(2465),
    [anon_sym___restrict__] = ACTIONS(2465),
    [anon_sym__Atomic] = ACTIONS(2465),
    [anon_sym__Noreturn] = ACTIONS(2465),
    [anon_sym_noreturn] = ACTIONS(2465),
    [anon_sym_mutable] = ACTIONS(2465),
    [anon_sym_constinit] = ACTIONS(2465),
    [anon_sym_consteval] = ACTIONS(2465),
    [anon_sym___shared__] = ACTIONS(2465),
    [anon_sym___local__] = ACTIONS(2465),
    [anon_sym___constant__] = ACTIONS(2465),
    [anon_sym___managed__] = ACTIONS(2465),
    [anon_sym___grid_constant__] = ACTIONS(2465),
    [anon_sym_alignas] = ACTIONS(2465),
    [anon_sym__Alignas] = ACTIONS(2465),
    [sym_primitive_type] = ACTIONS(2465),
    [anon_sym_enum] = ACTIONS(2465),
    [anon_sym_class] = ACTIONS(2465),
    [anon_sym_struct] = ACTIONS(2465),
    [anon_sym_union] = ACTIONS(2465),
    [anon_sym_if] = ACTIONS(2465),
    [anon_sym_switch] = ACTIONS(2465),
    [anon_sym_case] = ACTIONS(2465),
    [anon_sym_default] = ACTIONS(2465),
    [anon_sym_while] = ACTIONS(2465),
    [anon_sym_do] = ACTIONS(2465),
    [anon_sym_for] = ACTIONS(2465),
    [anon_sym_return] = ACTIONS(2465),
    [anon_sym_break] = ACTIONS(2465),
    [anon_sym_continue] = ACTIONS(2465),
    [anon_sym_goto] = ACTIONS(2465),
    [anon_sym___try] = ACTIONS(2465),
    [anon_sym___leave] = ACTIONS(2465),
    [anon_sym_not] = ACTIONS(2465),
    [anon_sym_compl] = ACTIONS(2465),
    [anon_sym_DASH_DASH] = ACTIONS(2467),
    [anon_sym_PLUS_PLUS] = ACTIONS(2467),
    [anon_sym_sizeof] = ACTIONS(2465),
    [anon_sym___alignof__] = ACTIONS(2465),
    [anon_sym___alignof] = ACTIONS(2465),
    [anon_sym__alignof] = ACTIONS(2465),
    [anon_sym_alignof] = ACTIONS(2465),
    [anon_sym__Alignof] = ACTIONS(2465),
    [anon_sym_offsetof] = ACTIONS(2465),
    [anon_sym__Generic] = ACTIONS(2465),
    [anon_sym_asm] = ACTIONS(2465),
    [anon_sym___asm__] = ACTIONS(2465),
    [sym_number_literal] = ACTIONS(2467),
    [anon_sym_L_SQUOTE] = ACTIONS(2467),
    [anon_sym_u_SQUOTE] = ACTIONS(2467),
    [anon_sym_U_SQUOTE] = ACTIONS(2467),
    [anon_sym_u8_SQUOTE] = ACTIONS(2467),
    [anon_sym_SQUOTE] = ACTIONS(2467),
    [anon_sym_L_DQUOTE] = ACTIONS(2467),
    [anon_sym_u_DQUOTE] = ACTIONS(2467),
    [anon_sym_U_DQUOTE] = ACTIONS(2467),
    [anon_sym_u8_DQUOTE] = ACTIONS(2467),
    [anon_sym_DQUOTE] = ACTIONS(2467),
    [sym_true] = ACTIONS(2465),
    [sym_false] = ACTIONS(2465),
    [anon_sym_NULL] = ACTIONS(2465),
    [anon_sym_nullptr] = ACTIONS(2465),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2465),
    [anon_sym_decltype] = ACTIONS(2465),
    [sym_virtual] = ACTIONS(2465),
    [anon_sym_explicit] = ACTIONS(2465),
    [anon_sym_typename] = ACTIONS(2465),
    [anon_sym_template] = ACTIONS(2465),
    [anon_sym_operator] = ACTIONS(2465),
    [anon_sym_try] = ACTIONS(2465),
    [anon_sym_delete] = ACTIONS(2465),
    [anon_sym_throw] = ACTIONS(2465),
    [anon_sym_namespace] = ACTIONS(2465),
    [anon_sym_using] = ACTIONS(2465),
    [anon_sym_static_assert] = ACTIONS(2465),
    [anon_sym_concept] = ACTIONS(2465),
    [anon_sym_co_return] = ACTIONS(2465),
    [anon_sym_co_yield] = ACTIONS(2465),
    [anon_sym_R_DQUOTE] = ACTIONS(2467),
    [anon_sym_LR_DQUOTE] = ACTIONS(2467),
    [anon_sym_uR_DQUOTE] = ACTIONS(2467),
    [anon_sym_UR_DQUOTE] = ACTIONS(2467),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2467),
    [anon_sym_co_await] = ACTIONS(2465),
    [anon_sym_new] = ACTIONS(2465),
    [anon_sym_requires] = ACTIONS(2465),
    [sym_this] = ACTIONS(2465),
    [anon_sym___launch_bounds__] = ACTIONS(2465),
  },
  [293] = {
    [sym_identifier] = ACTIONS(2469),
    [aux_sym_preproc_include_token1] = ACTIONS(2469),
    [aux_sym_preproc_def_token1] = ACTIONS(2469),
    [aux_sym_preproc_if_token1] = ACTIONS(2469),
    [aux_sym_preproc_if_token2] = ACTIONS(2469),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2469),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2469),
    [aux_sym_preproc_else_token1] = ACTIONS(2469),
    [aux_sym_preproc_elif_token1] = ACTIONS(2469),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2469),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2469),
    [sym_preproc_directive] = ACTIONS(2469),
    [anon_sym_LPAREN2] = ACTIONS(2471),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_STAR] = ACTIONS(2471),
    [anon_sym_AMP_AMP] = ACTIONS(2471),
    [anon_sym_AMP] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym___extension__] = ACTIONS(2469),
    [anon_sym_typedef] = ACTIONS(2469),
    [anon_sym___device__] = ACTIONS(2469),
    [anon_sym___host__] = ACTIONS(2469),
    [anon_sym___global__] = ACTIONS(2469),
    [anon_sym___forceinline__] = ACTIONS(2469),
    [anon_sym___noinline__] = ACTIONS(2469),
    [anon_sym_extern] = ACTIONS(2469),
    [anon_sym___attribute__] = ACTIONS(2469),
    [anon_sym_COLON_COLON] = ACTIONS(2471),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2471),
    [anon_sym___declspec] = ACTIONS(2469),
    [anon_sym___based] = ACTIONS(2469),
    [anon_sym___cdecl] = ACTIONS(2469),
    [anon_sym___clrcall] = ACTIONS(2469),
    [anon_sym___stdcall] = ACTIONS(2469),
    [anon_sym___fastcall] = ACTIONS(2469),
    [anon_sym___thiscall] = ACTIONS(2469),
    [anon_sym___vectorcall] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_signed] = ACTIONS(2469),
    [anon_sym_unsigned] = ACTIONS(2469),
    [anon_sym_long] = ACTIONS(2469),
    [anon_sym_short] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_register] = ACTIONS(2469),
    [anon_sym_inline] = ACTIONS(2469),
    [anon_sym___inline] = ACTIONS(2469),
    [anon_sym___inline__] = ACTIONS(2469),
    [anon_sym___forceinline] = ACTIONS(2469),
    [anon_sym_thread_local] = ACTIONS(2469),
    [anon_sym___thread] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_constexpr] = ACTIONS(2469),
    [anon_sym_volatile] = ACTIONS(2469),
    [anon_sym_restrict] = ACTIONS(2469),
    [anon_sym___restrict__] = ACTIONS(2469),
    [anon_sym__Atomic] = ACTIONS(2469),
    [anon_sym__Noreturn] = ACTIONS(2469),
    [anon_sym_noreturn] = ACTIONS(2469),
    [anon_sym_mutable] = ACTIONS(2469),
    [anon_sym_constinit] = ACTIONS(2469),
    [anon_sym_consteval] = ACTIONS(2469),
    [anon_sym___shared__] = ACTIONS(2469),
    [anon_sym___local__] = ACTIONS(2469),
    [anon_sym___constant__] = ACTIONS(2469),
    [anon_sym___managed__] = ACTIONS(2469),
    [anon_sym___grid_constant__] = ACTIONS(2469),
    [anon_sym_alignas] = ACTIONS(2469),
    [anon_sym__Alignas] = ACTIONS(2469),
    [sym_primitive_type] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [anon_sym_class] = ACTIONS(2469),
    [anon_sym_struct] = ACTIONS(2469),
    [anon_sym_union] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_goto] = ACTIONS(2469),
    [anon_sym___try] = ACTIONS(2469),
    [anon_sym___leave] = ACTIONS(2469),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_compl] = ACTIONS(2469),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_sizeof] = ACTIONS(2469),
    [anon_sym___alignof__] = ACTIONS(2469),
    [anon_sym___alignof] = ACTIONS(2469),
    [anon_sym__alignof] = ACTIONS(2469),
    [anon_sym_alignof] = ACTIONS(2469),
    [anon_sym__Alignof] = ACTIONS(2469),
    [anon_sym_offsetof] = ACTIONS(2469),
    [anon_sym__Generic] = ACTIONS(2469),
    [anon_sym_asm] = ACTIONS(2469),
    [anon_sym___asm__] = ACTIONS(2469),
    [sym_number_literal] = ACTIONS(2471),
    [anon_sym_L_SQUOTE] = ACTIONS(2471),
    [anon_sym_u_SQUOTE] = ACTIONS(2471),
    [anon_sym_U_SQUOTE] = ACTIONS(2471),
    [anon_sym_u8_SQUOTE] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [anon_sym_L_DQUOTE] = ACTIONS(2471),
    [anon_sym_u_DQUOTE] = ACTIONS(2471),
    [anon_sym_U_DQUOTE] = ACTIONS(2471),
    [anon_sym_u8_DQUOTE] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [anon_sym_NULL] = ACTIONS(2469),
    [anon_sym_nullptr] = ACTIONS(2469),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2469),
    [anon_sym_decltype] = ACTIONS(2469),
    [sym_virtual] = ACTIONS(2469),
    [anon_sym_explicit] = ACTIONS(2469),
    [anon_sym_typename] = ACTIONS(2469),
    [anon_sym_template] = ACTIONS(2469),
    [anon_sym_operator] = ACTIONS(2469),
    [anon_sym_try] = ACTIONS(2469),
    [anon_sym_delete] = ACTIONS(2469),
    [anon_sym_throw] = ACTIONS(2469),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_using] = ACTIONS(2469),
    [anon_sym_static_assert] = ACTIONS(2469),
    [anon_sym_concept] = ACTIONS(2469),
    [anon_sym_co_return] = ACTIONS(2469),
    [anon_sym_co_yield] = ACTIONS(2469),
    [anon_sym_R_DQUOTE] = ACTIONS(2471),
    [anon_sym_LR_DQUOTE] = ACTIONS(2471),
    [anon_sym_uR_DQUOTE] = ACTIONS(2471),
    [anon_sym_UR_DQUOTE] = ACTIONS(2471),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2471),
    [anon_sym_co_await] = ACTIONS(2469),
    [anon_sym_new] = ACTIONS(2469),
    [anon_sym_requires] = ACTIONS(2469),
    [sym_this] = ACTIONS(2469),
    [anon_sym___launch_bounds__] = ACTIONS(2469),
  },
  [294] = {
    [sym_identifier] = ACTIONS(2473),
    [aux_sym_preproc_include_token1] = ACTIONS(2473),
    [aux_sym_preproc_def_token1] = ACTIONS(2473),
    [aux_sym_preproc_if_token1] = ACTIONS(2473),
    [aux_sym_preproc_if_token2] = ACTIONS(2473),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2473),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2473),
    [aux_sym_preproc_else_token1] = ACTIONS(2473),
    [aux_sym_preproc_elif_token1] = ACTIONS(2473),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2473),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2473),
    [sym_preproc_directive] = ACTIONS(2473),
    [anon_sym_LPAREN2] = ACTIONS(2475),
    [anon_sym_BANG] = ACTIONS(2475),
    [anon_sym_TILDE] = ACTIONS(2475),
    [anon_sym_DASH] = ACTIONS(2473),
    [anon_sym_PLUS] = ACTIONS(2473),
    [anon_sym_STAR] = ACTIONS(2475),
    [anon_sym_AMP_AMP] = ACTIONS(2475),
    [anon_sym_AMP] = ACTIONS(2473),
    [anon_sym_SEMI] = ACTIONS(2475),
    [anon_sym___extension__] = ACTIONS(2473),
    [anon_sym_typedef] = ACTIONS(2473),
    [anon_sym___device__] = ACTIONS(2473),
    [anon_sym___host__] = ACTIONS(2473),
    [anon_sym___global__] = ACTIONS(2473),
    [anon_sym___forceinline__] = ACTIONS(2473),
    [anon_sym___noinline__] = ACTIONS(2473),
    [anon_sym_extern] = ACTIONS(2473),
    [anon_sym___attribute__] = ACTIONS(2473),
    [anon_sym_COLON_COLON] = ACTIONS(2475),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2475),
    [anon_sym___declspec] = ACTIONS(2473),
    [anon_sym___based] = ACTIONS(2473),
    [anon_sym___cdecl] = ACTIONS(2473),
    [anon_sym___clrcall] = ACTIONS(2473),
    [anon_sym___stdcall] = ACTIONS(2473),
    [anon_sym___fastcall] = ACTIONS(2473),
    [anon_sym___thiscall] = ACTIONS(2473),
    [anon_sym___vectorcall] = ACTIONS(2473),
    [anon_sym_LBRACE] = ACTIONS(2475),
    [anon_sym_signed] = ACTIONS(2473),
    [anon_sym_unsigned] = ACTIONS(2473),
    [anon_sym_long] = ACTIONS(2473),
    [anon_sym_short] = ACTIONS(2473),
    [anon_sym_LBRACK] = ACTIONS(2473),
    [anon_sym_static] = ACTIONS(2473),
    [anon_sym_register] = ACTIONS(2473),
    [anon_sym_inline] = ACTIONS(2473),
    [anon_sym___inline] = ACTIONS(2473),
    [anon_sym___inline__] = ACTIONS(2473),
    [anon_sym___forceinline] = ACTIONS(2473),
    [anon_sym_thread_local] = ACTIONS(2473),
    [anon_sym___thread] = ACTIONS(2473),
    [anon_sym_const] = ACTIONS(2473),
    [anon_sym_constexpr] = ACTIONS(2473),
    [anon_sym_volatile] = ACTIONS(2473),
    [anon_sym_restrict] = ACTIONS(2473),
    [anon_sym___restrict__] = ACTIONS(2473),
    [anon_sym__Atomic] = ACTIONS(2473),
    [anon_sym__Noreturn] = ACTIONS(2473),
    [anon_sym_noreturn] = ACTIONS(2473),
    [anon_sym_mutable] = ACTIONS(2473),
    [anon_sym_constinit] = ACTIONS(2473),
    [anon_sym_consteval] = ACTIONS(2473),
    [anon_sym___shared__] = ACTIONS(2473),
    [anon_sym___local__] = ACTIONS(2473),
    [anon_sym___constant__] = ACTIONS(2473),
    [anon_sym___managed__] = ACTIONS(2473),
    [anon_sym___grid_constant__] = ACTIONS(2473),
    [anon_sym_alignas] = ACTIONS(2473),
    [anon_sym__Alignas] = ACTIONS(2473),
    [sym_primitive_type] = ACTIONS(2473),
    [anon_sym_enum] = ACTIONS(2473),
    [anon_sym_class] = ACTIONS(2473),
    [anon_sym_struct] = ACTIONS(2473),
    [anon_sym_union] = ACTIONS(2473),
    [anon_sym_if] = ACTIONS(2473),
    [anon_sym_switch] = ACTIONS(2473),
    [anon_sym_case] = ACTIONS(2473),
    [anon_sym_default] = ACTIONS(2473),
    [anon_sym_while] = ACTIONS(2473),
    [anon_sym_do] = ACTIONS(2473),
    [anon_sym_for] = ACTIONS(2473),
    [anon_sym_return] = ACTIONS(2473),
    [anon_sym_break] = ACTIONS(2473),
    [anon_sym_continue] = ACTIONS(2473),
    [anon_sym_goto] = ACTIONS(2473),
    [anon_sym___try] = ACTIONS(2473),
    [anon_sym___leave] = ACTIONS(2473),
    [anon_sym_not] = ACTIONS(2473),
    [anon_sym_compl] = ACTIONS(2473),
    [anon_sym_DASH_DASH] = ACTIONS(2475),
    [anon_sym_PLUS_PLUS] = ACTIONS(2475),
    [anon_sym_sizeof] = ACTIONS(2473),
    [anon_sym___alignof__] = ACTIONS(2473),
    [anon_sym___alignof] = ACTIONS(2473),
    [anon_sym__alignof] = ACTIONS(2473),
    [anon_sym_alignof] = ACTIONS(2473),
    [anon_sym__Alignof] = ACTIONS(2473),
    [anon_sym_offsetof] = ACTIONS(2473),
    [anon_sym__Generic] = ACTIONS(2473),
    [anon_sym_asm] = ACTIONS(2473),
    [anon_sym___asm__] = ACTIONS(2473),
    [sym_number_literal] = ACTIONS(2475),
    [anon_sym_L_SQUOTE] = ACTIONS(2475),
    [anon_sym_u_SQUOTE] = ACTIONS(2475),
    [anon_sym_U_SQUOTE] = ACTIONS(2475),
    [anon_sym_u8_SQUOTE] = ACTIONS(2475),
    [anon_sym_SQUOTE] = ACTIONS(2475),
    [anon_sym_L_DQUOTE] = ACTIONS(2475),
    [anon_sym_u_DQUOTE] = ACTIONS(2475),
    [anon_sym_U_DQUOTE] = ACTIONS(2475),
    [anon_sym_u8_DQUOTE] = ACTIONS(2475),
    [anon_sym_DQUOTE] = ACTIONS(2475),
    [sym_true] = ACTIONS(2473),
    [sym_false] = ACTIONS(2473),
    [anon_sym_NULL] = ACTIONS(2473),
    [anon_sym_nullptr] = ACTIONS(2473),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2473),
    [anon_sym_decltype] = ACTIONS(2473),
    [sym_virtual] = ACTIONS(2473),
    [anon_sym_explicit] = ACTIONS(2473),
    [anon_sym_typename] = ACTIONS(2473),
    [anon_sym_template] = ACTIONS(2473),
    [anon_sym_operator] = ACTIONS(2473),
    [anon_sym_try] = ACTIONS(2473),
    [anon_sym_delete] = ACTIONS(2473),
    [anon_sym_throw] = ACTIONS(2473),
    [anon_sym_namespace] = ACTIONS(2473),
    [anon_sym_using] = ACTIONS(2473),
    [anon_sym_static_assert] = ACTIONS(2473),
    [anon_sym_concept] = ACTIONS(2473),
    [anon_sym_co_return] = ACTIONS(2473),
    [anon_sym_co_yield] = ACTIONS(2473),
    [anon_sym_R_DQUOTE] = ACTIONS(2475),
    [anon_sym_LR_DQUOTE] = ACTIONS(2475),
    [anon_sym_uR_DQUOTE] = ACTIONS(2475),
    [anon_sym_UR_DQUOTE] = ACTIONS(2475),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2475),
    [anon_sym_co_await] = ACTIONS(2473),
    [anon_sym_new] = ACTIONS(2473),
    [anon_sym_requires] = ACTIONS(2473),
    [sym_this] = ACTIONS(2473),
    [anon_sym___launch_bounds__] = ACTIONS(2473),
  },
  [295] = {
    [sym_identifier] = ACTIONS(2477),
    [aux_sym_preproc_include_token1] = ACTIONS(2477),
    [aux_sym_preproc_def_token1] = ACTIONS(2477),
    [aux_sym_preproc_if_token1] = ACTIONS(2477),
    [aux_sym_preproc_if_token2] = ACTIONS(2477),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2477),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2477),
    [aux_sym_preproc_else_token1] = ACTIONS(2477),
    [aux_sym_preproc_elif_token1] = ACTIONS(2477),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2477),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2477),
    [sym_preproc_directive] = ACTIONS(2477),
    [anon_sym_LPAREN2] = ACTIONS(2479),
    [anon_sym_BANG] = ACTIONS(2479),
    [anon_sym_TILDE] = ACTIONS(2479),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_STAR] = ACTIONS(2479),
    [anon_sym_AMP_AMP] = ACTIONS(2479),
    [anon_sym_AMP] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(2479),
    [anon_sym___extension__] = ACTIONS(2477),
    [anon_sym_typedef] = ACTIONS(2477),
    [anon_sym___device__] = ACTIONS(2477),
    [anon_sym___host__] = ACTIONS(2477),
    [anon_sym___global__] = ACTIONS(2477),
    [anon_sym___forceinline__] = ACTIONS(2477),
    [anon_sym___noinline__] = ACTIONS(2477),
    [anon_sym_extern] = ACTIONS(2477),
    [anon_sym___attribute__] = ACTIONS(2477),
    [anon_sym_COLON_COLON] = ACTIONS(2479),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2479),
    [anon_sym___declspec] = ACTIONS(2477),
    [anon_sym___based] = ACTIONS(2477),
    [anon_sym___cdecl] = ACTIONS(2477),
    [anon_sym___clrcall] = ACTIONS(2477),
    [anon_sym___stdcall] = ACTIONS(2477),
    [anon_sym___fastcall] = ACTIONS(2477),
    [anon_sym___thiscall] = ACTIONS(2477),
    [anon_sym___vectorcall] = ACTIONS(2477),
    [anon_sym_LBRACE] = ACTIONS(2479),
    [anon_sym_signed] = ACTIONS(2477),
    [anon_sym_unsigned] = ACTIONS(2477),
    [anon_sym_long] = ACTIONS(2477),
    [anon_sym_short] = ACTIONS(2477),
    [anon_sym_LBRACK] = ACTIONS(2477),
    [anon_sym_static] = ACTIONS(2477),
    [anon_sym_register] = ACTIONS(2477),
    [anon_sym_inline] = ACTIONS(2477),
    [anon_sym___inline] = ACTIONS(2477),
    [anon_sym___inline__] = ACTIONS(2477),
    [anon_sym___forceinline] = ACTIONS(2477),
    [anon_sym_thread_local] = ACTIONS(2477),
    [anon_sym___thread] = ACTIONS(2477),
    [anon_sym_const] = ACTIONS(2477),
    [anon_sym_constexpr] = ACTIONS(2477),
    [anon_sym_volatile] = ACTIONS(2477),
    [anon_sym_restrict] = ACTIONS(2477),
    [anon_sym___restrict__] = ACTIONS(2477),
    [anon_sym__Atomic] = ACTIONS(2477),
    [anon_sym__Noreturn] = ACTIONS(2477),
    [anon_sym_noreturn] = ACTIONS(2477),
    [anon_sym_mutable] = ACTIONS(2477),
    [anon_sym_constinit] = ACTIONS(2477),
    [anon_sym_consteval] = ACTIONS(2477),
    [anon_sym___shared__] = ACTIONS(2477),
    [anon_sym___local__] = ACTIONS(2477),
    [anon_sym___constant__] = ACTIONS(2477),
    [anon_sym___managed__] = ACTIONS(2477),
    [anon_sym___grid_constant__] = ACTIONS(2477),
    [anon_sym_alignas] = ACTIONS(2477),
    [anon_sym__Alignas] = ACTIONS(2477),
    [sym_primitive_type] = ACTIONS(2477),
    [anon_sym_enum] = ACTIONS(2477),
    [anon_sym_class] = ACTIONS(2477),
    [anon_sym_struct] = ACTIONS(2477),
    [anon_sym_union] = ACTIONS(2477),
    [anon_sym_if] = ACTIONS(2477),
    [anon_sym_switch] = ACTIONS(2477),
    [anon_sym_case] = ACTIONS(2477),
    [anon_sym_default] = ACTIONS(2477),
    [anon_sym_while] = ACTIONS(2477),
    [anon_sym_do] = ACTIONS(2477),
    [anon_sym_for] = ACTIONS(2477),
    [anon_sym_return] = ACTIONS(2477),
    [anon_sym_break] = ACTIONS(2477),
    [anon_sym_continue] = ACTIONS(2477),
    [anon_sym_goto] = ACTIONS(2477),
    [anon_sym___try] = ACTIONS(2477),
    [anon_sym___leave] = ACTIONS(2477),
    [anon_sym_not] = ACTIONS(2477),
    [anon_sym_compl] = ACTIONS(2477),
    [anon_sym_DASH_DASH] = ACTIONS(2479),
    [anon_sym_PLUS_PLUS] = ACTIONS(2479),
    [anon_sym_sizeof] = ACTIONS(2477),
    [anon_sym___alignof__] = ACTIONS(2477),
    [anon_sym___alignof] = ACTIONS(2477),
    [anon_sym__alignof] = ACTIONS(2477),
    [anon_sym_alignof] = ACTIONS(2477),
    [anon_sym__Alignof] = ACTIONS(2477),
    [anon_sym_offsetof] = ACTIONS(2477),
    [anon_sym__Generic] = ACTIONS(2477),
    [anon_sym_asm] = ACTIONS(2477),
    [anon_sym___asm__] = ACTIONS(2477),
    [sym_number_literal] = ACTIONS(2479),
    [anon_sym_L_SQUOTE] = ACTIONS(2479),
    [anon_sym_u_SQUOTE] = ACTIONS(2479),
    [anon_sym_U_SQUOTE] = ACTIONS(2479),
    [anon_sym_u8_SQUOTE] = ACTIONS(2479),
    [anon_sym_SQUOTE] = ACTIONS(2479),
    [anon_sym_L_DQUOTE] = ACTIONS(2479),
    [anon_sym_u_DQUOTE] = ACTIONS(2479),
    [anon_sym_U_DQUOTE] = ACTIONS(2479),
    [anon_sym_u8_DQUOTE] = ACTIONS(2479),
    [anon_sym_DQUOTE] = ACTIONS(2479),
    [sym_true] = ACTIONS(2477),
    [sym_false] = ACTIONS(2477),
    [anon_sym_NULL] = ACTIONS(2477),
    [anon_sym_nullptr] = ACTIONS(2477),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2477),
    [anon_sym_decltype] = ACTIONS(2477),
    [sym_virtual] = ACTIONS(2477),
    [anon_sym_explicit] = ACTIONS(2477),
    [anon_sym_typename] = ACTIONS(2477),
    [anon_sym_template] = ACTIONS(2477),
    [anon_sym_operator] = ACTIONS(2477),
    [anon_sym_try] = ACTIONS(2477),
    [anon_sym_delete] = ACTIONS(2477),
    [anon_sym_throw] = ACTIONS(2477),
    [anon_sym_namespace] = ACTIONS(2477),
    [anon_sym_using] = ACTIONS(2477),
    [anon_sym_static_assert] = ACTIONS(2477),
    [anon_sym_concept] = ACTIONS(2477),
    [anon_sym_co_return] = ACTIONS(2477),
    [anon_sym_co_yield] = ACTIONS(2477),
    [anon_sym_R_DQUOTE] = ACTIONS(2479),
    [anon_sym_LR_DQUOTE] = ACTIONS(2479),
    [anon_sym_uR_DQUOTE] = ACTIONS(2479),
    [anon_sym_UR_DQUOTE] = ACTIONS(2479),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2479),
    [anon_sym_co_await] = ACTIONS(2477),
    [anon_sym_new] = ACTIONS(2477),
    [anon_sym_requires] = ACTIONS(2477),
    [sym_this] = ACTIONS(2477),
    [anon_sym___launch_bounds__] = ACTIONS(2477),
  },
  [296] = {
    [sym_preproc_def] = STATE(370),
    [sym_preproc_function_def] = STATE(370),
    [sym_preproc_call] = STATE(370),
    [sym_preproc_if_in_field_declaration_list] = STATE(370),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(370),
    [sym_preproc_else_in_field_declaration_list] = STATE(9056),
    [sym_preproc_elif_in_field_declaration_list] = STATE(9056),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(9056),
    [sym_type_definition] = STATE(370),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5944),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6464),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(370),
    [sym_field_declaration] = STATE(370),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1701),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(370),
    [sym_operator_cast] = STATE(6994),
    [sym_inline_method_definition] = STATE(370),
    [sym__constructor_specifiers] = STATE(1701),
    [sym_operator_cast_definition] = STATE(370),
    [sym_operator_cast_declaration] = STATE(370),
    [sym_constructor_or_destructor_definition] = STATE(370),
    [sym_constructor_or_destructor_declaration] = STATE(370),
    [sym_friend_declaration] = STATE(370),
    [sym_access_specifier] = STATE(9001),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(370),
    [sym_alias_declaration] = STATE(370),
    [sym_static_assert_declaration] = STATE(370),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6994),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(370),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1701),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(2100),
    [aux_sym_preproc_if_token1] = ACTIONS(2102),
    [aux_sym_preproc_if_token2] = ACTIONS(2481),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2106),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2106),
    [aux_sym_preproc_else_token1] = ACTIONS(2108),
    [aux_sym_preproc_elif_token1] = ACTIONS(2110),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2112),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2112),
    [sym_preproc_directive] = ACTIONS(2114),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(2124),
    [anon_sym_typedef] = ACTIONS(2126),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(2144),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2146),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(2150),
    [anon_sym_static_assert] = ACTIONS(2152),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [297] = {
    [sym_expression] = STATE(4879),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8328),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2483),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(2486),
    [anon_sym___extension__] = ACTIONS(2048),
    [anon_sym___device__] = ACTIONS(2048),
    [anon_sym___host__] = ACTIONS(2048),
    [anon_sym___global__] = ACTIONS(2048),
    [anon_sym___forceinline__] = ACTIONS(2048),
    [anon_sym___noinline__] = ACTIONS(2048),
    [anon_sym_extern] = ACTIONS(2048),
    [anon_sym___attribute__] = ACTIONS(2048),
    [anon_sym_COLON_COLON] = ACTIONS(2488),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2050),
    [anon_sym___declspec] = ACTIONS(2048),
    [anon_sym_signed] = ACTIONS(2048),
    [anon_sym_unsigned] = ACTIONS(2048),
    [anon_sym_long] = ACTIONS(2048),
    [anon_sym_short] = ACTIONS(2048),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(2048),
    [anon_sym_register] = ACTIONS(2048),
    [anon_sym_inline] = ACTIONS(2048),
    [anon_sym___inline] = ACTIONS(2048),
    [anon_sym___inline__] = ACTIONS(2048),
    [anon_sym___forceinline] = ACTIONS(2048),
    [anon_sym_thread_local] = ACTIONS(2048),
    [anon_sym___thread] = ACTIONS(2048),
    [anon_sym_const] = ACTIONS(2048),
    [anon_sym_constexpr] = ACTIONS(2048),
    [anon_sym_volatile] = ACTIONS(2048),
    [anon_sym_restrict] = ACTIONS(2048),
    [anon_sym___restrict__] = ACTIONS(2048),
    [anon_sym__Atomic] = ACTIONS(2048),
    [anon_sym__Noreturn] = ACTIONS(2048),
    [anon_sym_noreturn] = ACTIONS(2048),
    [anon_sym_mutable] = ACTIONS(2048),
    [anon_sym_constinit] = ACTIONS(2048),
    [anon_sym_consteval] = ACTIONS(2048),
    [anon_sym___shared__] = ACTIONS(2048),
    [anon_sym___local__] = ACTIONS(2048),
    [anon_sym___constant__] = ACTIONS(2048),
    [anon_sym___managed__] = ACTIONS(2048),
    [anon_sym___grid_constant__] = ACTIONS(2048),
    [anon_sym_alignas] = ACTIONS(2048),
    [anon_sym__Alignas] = ACTIONS(2048),
    [sym_primitive_type] = ACTIONS(2491),
    [anon_sym_enum] = ACTIONS(2048),
    [anon_sym_class] = ACTIONS(2048),
    [anon_sym_struct] = ACTIONS(2048),
    [anon_sym_union] = ACTIONS(2048),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2048),
    [anon_sym_decltype] = ACTIONS(2494),
    [sym_virtual] = ACTIONS(2048),
    [anon_sym_typename] = ACTIONS(2048),
    [anon_sym_template] = ACTIONS(2497),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(2048),
  },
  [298] = {
    [sym_identifier] = ACTIONS(2500),
    [aux_sym_preproc_include_token1] = ACTIONS(2500),
    [aux_sym_preproc_def_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token2] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2500),
    [aux_sym_preproc_else_token1] = ACTIONS(2500),
    [aux_sym_preproc_elif_token1] = ACTIONS(2500),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2500),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2500),
    [sym_preproc_directive] = ACTIONS(2500),
    [anon_sym_LPAREN2] = ACTIONS(2502),
    [anon_sym_BANG] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [anon_sym_DASH] = ACTIONS(2500),
    [anon_sym_PLUS] = ACTIONS(2500),
    [anon_sym_STAR] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_typedef] = ACTIONS(2500),
    [anon_sym___device__] = ACTIONS(2500),
    [anon_sym___host__] = ACTIONS(2500),
    [anon_sym___global__] = ACTIONS(2500),
    [anon_sym___forceinline__] = ACTIONS(2500),
    [anon_sym___noinline__] = ACTIONS(2500),
    [anon_sym_extern] = ACTIONS(2500),
    [anon_sym___attribute__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2502),
    [anon_sym___declspec] = ACTIONS(2500),
    [anon_sym___based] = ACTIONS(2500),
    [anon_sym___cdecl] = ACTIONS(2500),
    [anon_sym___clrcall] = ACTIONS(2500),
    [anon_sym___stdcall] = ACTIONS(2500),
    [anon_sym___fastcall] = ACTIONS(2500),
    [anon_sym___thiscall] = ACTIONS(2500),
    [anon_sym___vectorcall] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(2502),
    [anon_sym_signed] = ACTIONS(2500),
    [anon_sym_unsigned] = ACTIONS(2500),
    [anon_sym_long] = ACTIONS(2500),
    [anon_sym_short] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_static] = ACTIONS(2500),
    [anon_sym_register] = ACTIONS(2500),
    [anon_sym_inline] = ACTIONS(2500),
    [anon_sym___inline] = ACTIONS(2500),
    [anon_sym___inline__] = ACTIONS(2500),
    [anon_sym___forceinline] = ACTIONS(2500),
    [anon_sym_thread_local] = ACTIONS(2500),
    [anon_sym___thread] = ACTIONS(2500),
    [anon_sym_const] = ACTIONS(2500),
    [anon_sym_constexpr] = ACTIONS(2500),
    [anon_sym_volatile] = ACTIONS(2500),
    [anon_sym_restrict] = ACTIONS(2500),
    [anon_sym___restrict__] = ACTIONS(2500),
    [anon_sym__Atomic] = ACTIONS(2500),
    [anon_sym__Noreturn] = ACTIONS(2500),
    [anon_sym_noreturn] = ACTIONS(2500),
    [anon_sym_mutable] = ACTIONS(2500),
    [anon_sym_constinit] = ACTIONS(2500),
    [anon_sym_consteval] = ACTIONS(2500),
    [anon_sym___shared__] = ACTIONS(2500),
    [anon_sym___local__] = ACTIONS(2500),
    [anon_sym___constant__] = ACTIONS(2500),
    [anon_sym___managed__] = ACTIONS(2500),
    [anon_sym___grid_constant__] = ACTIONS(2500),
    [anon_sym_alignas] = ACTIONS(2500),
    [anon_sym__Alignas] = ACTIONS(2500),
    [sym_primitive_type] = ACTIONS(2500),
    [anon_sym_enum] = ACTIONS(2500),
    [anon_sym_class] = ACTIONS(2500),
    [anon_sym_struct] = ACTIONS(2500),
    [anon_sym_union] = ACTIONS(2500),
    [anon_sym_if] = ACTIONS(2500),
    [anon_sym_switch] = ACTIONS(2500),
    [anon_sym_case] = ACTIONS(2500),
    [anon_sym_default] = ACTIONS(2500),
    [anon_sym_while] = ACTIONS(2500),
    [anon_sym_do] = ACTIONS(2500),
    [anon_sym_for] = ACTIONS(2500),
    [anon_sym_return] = ACTIONS(2500),
    [anon_sym_break] = ACTIONS(2500),
    [anon_sym_continue] = ACTIONS(2500),
    [anon_sym_goto] = ACTIONS(2500),
    [anon_sym___try] = ACTIONS(2500),
    [anon_sym___leave] = ACTIONS(2500),
    [anon_sym_not] = ACTIONS(2500),
    [anon_sym_compl] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(2502),
    [anon_sym_PLUS_PLUS] = ACTIONS(2502),
    [anon_sym_sizeof] = ACTIONS(2500),
    [anon_sym___alignof__] = ACTIONS(2500),
    [anon_sym___alignof] = ACTIONS(2500),
    [anon_sym__alignof] = ACTIONS(2500),
    [anon_sym_alignof] = ACTIONS(2500),
    [anon_sym__Alignof] = ACTIONS(2500),
    [anon_sym_offsetof] = ACTIONS(2500),
    [anon_sym__Generic] = ACTIONS(2500),
    [anon_sym_asm] = ACTIONS(2500),
    [anon_sym___asm__] = ACTIONS(2500),
    [sym_number_literal] = ACTIONS(2502),
    [anon_sym_L_SQUOTE] = ACTIONS(2502),
    [anon_sym_u_SQUOTE] = ACTIONS(2502),
    [anon_sym_U_SQUOTE] = ACTIONS(2502),
    [anon_sym_u8_SQUOTE] = ACTIONS(2502),
    [anon_sym_SQUOTE] = ACTIONS(2502),
    [anon_sym_L_DQUOTE] = ACTIONS(2502),
    [anon_sym_u_DQUOTE] = ACTIONS(2502),
    [anon_sym_U_DQUOTE] = ACTIONS(2502),
    [anon_sym_u8_DQUOTE] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [sym_true] = ACTIONS(2500),
    [sym_false] = ACTIONS(2500),
    [anon_sym_NULL] = ACTIONS(2500),
    [anon_sym_nullptr] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2500),
    [anon_sym_decltype] = ACTIONS(2500),
    [sym_virtual] = ACTIONS(2500),
    [anon_sym_explicit] = ACTIONS(2500),
    [anon_sym_typename] = ACTIONS(2500),
    [anon_sym_template] = ACTIONS(2500),
    [anon_sym_operator] = ACTIONS(2500),
    [anon_sym_try] = ACTIONS(2500),
    [anon_sym_delete] = ACTIONS(2500),
    [anon_sym_throw] = ACTIONS(2500),
    [anon_sym_namespace] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_static_assert] = ACTIONS(2500),
    [anon_sym_concept] = ACTIONS(2500),
    [anon_sym_co_return] = ACTIONS(2500),
    [anon_sym_co_yield] = ACTIONS(2500),
    [anon_sym_R_DQUOTE] = ACTIONS(2502),
    [anon_sym_LR_DQUOTE] = ACTIONS(2502),
    [anon_sym_uR_DQUOTE] = ACTIONS(2502),
    [anon_sym_UR_DQUOTE] = ACTIONS(2502),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2502),
    [anon_sym_co_await] = ACTIONS(2500),
    [anon_sym_new] = ACTIONS(2500),
    [anon_sym_requires] = ACTIONS(2500),
    [sym_this] = ACTIONS(2500),
    [anon_sym___launch_bounds__] = ACTIONS(2500),
  },
  [299] = {
    [sym_identifier] = ACTIONS(2500),
    [aux_sym_preproc_include_token1] = ACTIONS(2500),
    [aux_sym_preproc_def_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token2] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2500),
    [aux_sym_preproc_else_token1] = ACTIONS(2500),
    [aux_sym_preproc_elif_token1] = ACTIONS(2500),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2500),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2500),
    [sym_preproc_directive] = ACTIONS(2500),
    [anon_sym_LPAREN2] = ACTIONS(2502),
    [anon_sym_BANG] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [anon_sym_DASH] = ACTIONS(2500),
    [anon_sym_PLUS] = ACTIONS(2500),
    [anon_sym_STAR] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_typedef] = ACTIONS(2500),
    [anon_sym___device__] = ACTIONS(2500),
    [anon_sym___host__] = ACTIONS(2500),
    [anon_sym___global__] = ACTIONS(2500),
    [anon_sym___forceinline__] = ACTIONS(2500),
    [anon_sym___noinline__] = ACTIONS(2500),
    [anon_sym_extern] = ACTIONS(2500),
    [anon_sym___attribute__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2502),
    [anon_sym___declspec] = ACTIONS(2500),
    [anon_sym___based] = ACTIONS(2500),
    [anon_sym___cdecl] = ACTIONS(2500),
    [anon_sym___clrcall] = ACTIONS(2500),
    [anon_sym___stdcall] = ACTIONS(2500),
    [anon_sym___fastcall] = ACTIONS(2500),
    [anon_sym___thiscall] = ACTIONS(2500),
    [anon_sym___vectorcall] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(2502),
    [anon_sym_signed] = ACTIONS(2500),
    [anon_sym_unsigned] = ACTIONS(2500),
    [anon_sym_long] = ACTIONS(2500),
    [anon_sym_short] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_static] = ACTIONS(2500),
    [anon_sym_register] = ACTIONS(2500),
    [anon_sym_inline] = ACTIONS(2500),
    [anon_sym___inline] = ACTIONS(2500),
    [anon_sym___inline__] = ACTIONS(2500),
    [anon_sym___forceinline] = ACTIONS(2500),
    [anon_sym_thread_local] = ACTIONS(2500),
    [anon_sym___thread] = ACTIONS(2500),
    [anon_sym_const] = ACTIONS(2500),
    [anon_sym_constexpr] = ACTIONS(2500),
    [anon_sym_volatile] = ACTIONS(2500),
    [anon_sym_restrict] = ACTIONS(2500),
    [anon_sym___restrict__] = ACTIONS(2500),
    [anon_sym__Atomic] = ACTIONS(2500),
    [anon_sym__Noreturn] = ACTIONS(2500),
    [anon_sym_noreturn] = ACTIONS(2500),
    [anon_sym_mutable] = ACTIONS(2500),
    [anon_sym_constinit] = ACTIONS(2500),
    [anon_sym_consteval] = ACTIONS(2500),
    [anon_sym___shared__] = ACTIONS(2500),
    [anon_sym___local__] = ACTIONS(2500),
    [anon_sym___constant__] = ACTIONS(2500),
    [anon_sym___managed__] = ACTIONS(2500),
    [anon_sym___grid_constant__] = ACTIONS(2500),
    [anon_sym_alignas] = ACTIONS(2500),
    [anon_sym__Alignas] = ACTIONS(2500),
    [sym_primitive_type] = ACTIONS(2500),
    [anon_sym_enum] = ACTIONS(2500),
    [anon_sym_class] = ACTIONS(2500),
    [anon_sym_struct] = ACTIONS(2500),
    [anon_sym_union] = ACTIONS(2500),
    [anon_sym_if] = ACTIONS(2500),
    [anon_sym_switch] = ACTIONS(2500),
    [anon_sym_case] = ACTIONS(2500),
    [anon_sym_default] = ACTIONS(2500),
    [anon_sym_while] = ACTIONS(2500),
    [anon_sym_do] = ACTIONS(2500),
    [anon_sym_for] = ACTIONS(2500),
    [anon_sym_return] = ACTIONS(2500),
    [anon_sym_break] = ACTIONS(2500),
    [anon_sym_continue] = ACTIONS(2500),
    [anon_sym_goto] = ACTIONS(2500),
    [anon_sym___try] = ACTIONS(2500),
    [anon_sym___leave] = ACTIONS(2500),
    [anon_sym_not] = ACTIONS(2500),
    [anon_sym_compl] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(2502),
    [anon_sym_PLUS_PLUS] = ACTIONS(2502),
    [anon_sym_sizeof] = ACTIONS(2500),
    [anon_sym___alignof__] = ACTIONS(2500),
    [anon_sym___alignof] = ACTIONS(2500),
    [anon_sym__alignof] = ACTIONS(2500),
    [anon_sym_alignof] = ACTIONS(2500),
    [anon_sym__Alignof] = ACTIONS(2500),
    [anon_sym_offsetof] = ACTIONS(2500),
    [anon_sym__Generic] = ACTIONS(2500),
    [anon_sym_asm] = ACTIONS(2500),
    [anon_sym___asm__] = ACTIONS(2500),
    [sym_number_literal] = ACTIONS(2502),
    [anon_sym_L_SQUOTE] = ACTIONS(2502),
    [anon_sym_u_SQUOTE] = ACTIONS(2502),
    [anon_sym_U_SQUOTE] = ACTIONS(2502),
    [anon_sym_u8_SQUOTE] = ACTIONS(2502),
    [anon_sym_SQUOTE] = ACTIONS(2502),
    [anon_sym_L_DQUOTE] = ACTIONS(2502),
    [anon_sym_u_DQUOTE] = ACTIONS(2502),
    [anon_sym_U_DQUOTE] = ACTIONS(2502),
    [anon_sym_u8_DQUOTE] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [sym_true] = ACTIONS(2500),
    [sym_false] = ACTIONS(2500),
    [anon_sym_NULL] = ACTIONS(2500),
    [anon_sym_nullptr] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2500),
    [anon_sym_decltype] = ACTIONS(2500),
    [sym_virtual] = ACTIONS(2500),
    [anon_sym_explicit] = ACTIONS(2500),
    [anon_sym_typename] = ACTIONS(2500),
    [anon_sym_template] = ACTIONS(2500),
    [anon_sym_operator] = ACTIONS(2500),
    [anon_sym_try] = ACTIONS(2500),
    [anon_sym_delete] = ACTIONS(2500),
    [anon_sym_throw] = ACTIONS(2500),
    [anon_sym_namespace] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_static_assert] = ACTIONS(2500),
    [anon_sym_concept] = ACTIONS(2500),
    [anon_sym_co_return] = ACTIONS(2500),
    [anon_sym_co_yield] = ACTIONS(2500),
    [anon_sym_R_DQUOTE] = ACTIONS(2502),
    [anon_sym_LR_DQUOTE] = ACTIONS(2502),
    [anon_sym_uR_DQUOTE] = ACTIONS(2502),
    [anon_sym_UR_DQUOTE] = ACTIONS(2502),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2502),
    [anon_sym_co_await] = ACTIONS(2500),
    [anon_sym_new] = ACTIONS(2500),
    [anon_sym_requires] = ACTIONS(2500),
    [sym_this] = ACTIONS(2500),
    [anon_sym___launch_bounds__] = ACTIONS(2500),
  },
  [300] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(3009),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8514),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8244),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8360),
    [sym__unary_right_fold] = STATE(8359),
    [sym__binary_fold] = STATE(8354),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8525),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [301] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(2960),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8499),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8767),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8299),
    [sym__unary_right_fold] = STATE(8308),
    [sym__binary_fold] = STATE(8312),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8481),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [302] = {
    [sym_identifier] = ACTIONS(2504),
    [aux_sym_preproc_include_token1] = ACTIONS(2504),
    [aux_sym_preproc_def_token1] = ACTIONS(2504),
    [aux_sym_preproc_if_token1] = ACTIONS(2504),
    [aux_sym_preproc_if_token2] = ACTIONS(2504),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2504),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2504),
    [aux_sym_preproc_else_token1] = ACTIONS(2504),
    [aux_sym_preproc_elif_token1] = ACTIONS(2504),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2504),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2504),
    [sym_preproc_directive] = ACTIONS(2504),
    [anon_sym_LPAREN2] = ACTIONS(2506),
    [anon_sym_BANG] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2506),
    [anon_sym_DASH] = ACTIONS(2504),
    [anon_sym_PLUS] = ACTIONS(2504),
    [anon_sym_STAR] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2504),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym___extension__] = ACTIONS(2504),
    [anon_sym_typedef] = ACTIONS(2504),
    [anon_sym___device__] = ACTIONS(2504),
    [anon_sym___host__] = ACTIONS(2504),
    [anon_sym___global__] = ACTIONS(2504),
    [anon_sym___forceinline__] = ACTIONS(2504),
    [anon_sym___noinline__] = ACTIONS(2504),
    [anon_sym_extern] = ACTIONS(2504),
    [anon_sym___attribute__] = ACTIONS(2504),
    [anon_sym_COLON_COLON] = ACTIONS(2506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2506),
    [anon_sym___declspec] = ACTIONS(2504),
    [anon_sym___based] = ACTIONS(2504),
    [anon_sym___cdecl] = ACTIONS(2504),
    [anon_sym___clrcall] = ACTIONS(2504),
    [anon_sym___stdcall] = ACTIONS(2504),
    [anon_sym___fastcall] = ACTIONS(2504),
    [anon_sym___thiscall] = ACTIONS(2504),
    [anon_sym___vectorcall] = ACTIONS(2504),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_signed] = ACTIONS(2504),
    [anon_sym_unsigned] = ACTIONS(2504),
    [anon_sym_long] = ACTIONS(2504),
    [anon_sym_short] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(2504),
    [anon_sym_static] = ACTIONS(2504),
    [anon_sym_register] = ACTIONS(2504),
    [anon_sym_inline] = ACTIONS(2504),
    [anon_sym___inline] = ACTIONS(2504),
    [anon_sym___inline__] = ACTIONS(2504),
    [anon_sym___forceinline] = ACTIONS(2504),
    [anon_sym_thread_local] = ACTIONS(2504),
    [anon_sym___thread] = ACTIONS(2504),
    [anon_sym_const] = ACTIONS(2504),
    [anon_sym_constexpr] = ACTIONS(2504),
    [anon_sym_volatile] = ACTIONS(2504),
    [anon_sym_restrict] = ACTIONS(2504),
    [anon_sym___restrict__] = ACTIONS(2504),
    [anon_sym__Atomic] = ACTIONS(2504),
    [anon_sym__Noreturn] = ACTIONS(2504),
    [anon_sym_noreturn] = ACTIONS(2504),
    [anon_sym_mutable] = ACTIONS(2504),
    [anon_sym_constinit] = ACTIONS(2504),
    [anon_sym_consteval] = ACTIONS(2504),
    [anon_sym___shared__] = ACTIONS(2504),
    [anon_sym___local__] = ACTIONS(2504),
    [anon_sym___constant__] = ACTIONS(2504),
    [anon_sym___managed__] = ACTIONS(2504),
    [anon_sym___grid_constant__] = ACTIONS(2504),
    [anon_sym_alignas] = ACTIONS(2504),
    [anon_sym__Alignas] = ACTIONS(2504),
    [sym_primitive_type] = ACTIONS(2504),
    [anon_sym_enum] = ACTIONS(2504),
    [anon_sym_class] = ACTIONS(2504),
    [anon_sym_struct] = ACTIONS(2504),
    [anon_sym_union] = ACTIONS(2504),
    [anon_sym_if] = ACTIONS(2504),
    [anon_sym_switch] = ACTIONS(2504),
    [anon_sym_case] = ACTIONS(2504),
    [anon_sym_default] = ACTIONS(2504),
    [anon_sym_while] = ACTIONS(2504),
    [anon_sym_do] = ACTIONS(2504),
    [anon_sym_for] = ACTIONS(2504),
    [anon_sym_return] = ACTIONS(2504),
    [anon_sym_break] = ACTIONS(2504),
    [anon_sym_continue] = ACTIONS(2504),
    [anon_sym_goto] = ACTIONS(2504),
    [anon_sym___try] = ACTIONS(2504),
    [anon_sym___leave] = ACTIONS(2504),
    [anon_sym_not] = ACTIONS(2504),
    [anon_sym_compl] = ACTIONS(2504),
    [anon_sym_DASH_DASH] = ACTIONS(2506),
    [anon_sym_PLUS_PLUS] = ACTIONS(2506),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(2504),
    [anon_sym___alignof] = ACTIONS(2504),
    [anon_sym__alignof] = ACTIONS(2504),
    [anon_sym_alignof] = ACTIONS(2504),
    [anon_sym__Alignof] = ACTIONS(2504),
    [anon_sym_offsetof] = ACTIONS(2504),
    [anon_sym__Generic] = ACTIONS(2504),
    [anon_sym_asm] = ACTIONS(2504),
    [anon_sym___asm__] = ACTIONS(2504),
    [sym_number_literal] = ACTIONS(2506),
    [anon_sym_L_SQUOTE] = ACTIONS(2506),
    [anon_sym_u_SQUOTE] = ACTIONS(2506),
    [anon_sym_U_SQUOTE] = ACTIONS(2506),
    [anon_sym_u8_SQUOTE] = ACTIONS(2506),
    [anon_sym_SQUOTE] = ACTIONS(2506),
    [anon_sym_L_DQUOTE] = ACTIONS(2506),
    [anon_sym_u_DQUOTE] = ACTIONS(2506),
    [anon_sym_U_DQUOTE] = ACTIONS(2506),
    [anon_sym_u8_DQUOTE] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [sym_true] = ACTIONS(2504),
    [sym_false] = ACTIONS(2504),
    [anon_sym_NULL] = ACTIONS(2504),
    [anon_sym_nullptr] = ACTIONS(2504),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2504),
    [anon_sym_decltype] = ACTIONS(2504),
    [sym_virtual] = ACTIONS(2504),
    [anon_sym_explicit] = ACTIONS(2504),
    [anon_sym_typename] = ACTIONS(2504),
    [anon_sym_template] = ACTIONS(2504),
    [anon_sym_operator] = ACTIONS(2504),
    [anon_sym_try] = ACTIONS(2504),
    [anon_sym_delete] = ACTIONS(2504),
    [anon_sym_throw] = ACTIONS(2504),
    [anon_sym_namespace] = ACTIONS(2504),
    [anon_sym_using] = ACTIONS(2504),
    [anon_sym_static_assert] = ACTIONS(2504),
    [anon_sym_concept] = ACTIONS(2504),
    [anon_sym_co_return] = ACTIONS(2504),
    [anon_sym_co_yield] = ACTIONS(2504),
    [anon_sym_R_DQUOTE] = ACTIONS(2506),
    [anon_sym_LR_DQUOTE] = ACTIONS(2506),
    [anon_sym_uR_DQUOTE] = ACTIONS(2506),
    [anon_sym_UR_DQUOTE] = ACTIONS(2506),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2506),
    [anon_sym_co_await] = ACTIONS(2504),
    [anon_sym_new] = ACTIONS(2504),
    [anon_sym_requires] = ACTIONS(2504),
    [sym_this] = ACTIONS(2504),
    [anon_sym___launch_bounds__] = ACTIONS(2504),
  },
  [303] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(3009),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8514),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(8361),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8360),
    [sym__unary_right_fold] = STATE(8359),
    [sym__binary_fold] = STATE(8354),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8525),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [304] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(3009),
    [sym__string] = STATE(3719),
    [sym_comma_expression] = STATE(8514),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_type_descriptor] = STATE(9071),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(7868),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym__unary_left_fold] = STATE(8518),
    [sym__unary_right_fold] = STATE(8523),
    [sym__binary_fold] = STATE(8524),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5986),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym__assignment_expression_lhs] = STATE(8525),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [305] = {
    [sym_catch_clause] = STATE(223),
    [aux_sym_constructor_try_statement_repeat1] = STATE(223),
    [sym_identifier] = ACTIONS(1920),
    [aux_sym_preproc_include_token1] = ACTIONS(1920),
    [aux_sym_preproc_def_token1] = ACTIONS(1920),
    [aux_sym_preproc_if_token1] = ACTIONS(1920),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1920),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1920),
    [sym_preproc_directive] = ACTIONS(1920),
    [anon_sym_LPAREN2] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1922),
    [anon_sym_TILDE] = ACTIONS(1922),
    [anon_sym_DASH] = ACTIONS(1920),
    [anon_sym_PLUS] = ACTIONS(1920),
    [anon_sym_STAR] = ACTIONS(1922),
    [anon_sym_AMP_AMP] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1920),
    [anon_sym_SEMI] = ACTIONS(1922),
    [anon_sym___extension__] = ACTIONS(1920),
    [anon_sym_typedef] = ACTIONS(1920),
    [anon_sym___device__] = ACTIONS(1920),
    [anon_sym___host__] = ACTIONS(1920),
    [anon_sym___global__] = ACTIONS(1920),
    [anon_sym___forceinline__] = ACTIONS(1920),
    [anon_sym___noinline__] = ACTIONS(1920),
    [anon_sym_extern] = ACTIONS(1920),
    [anon_sym___attribute__] = ACTIONS(1920),
    [anon_sym_COLON_COLON] = ACTIONS(1922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1922),
    [anon_sym___declspec] = ACTIONS(1920),
    [anon_sym___based] = ACTIONS(1920),
    [anon_sym___cdecl] = ACTIONS(1920),
    [anon_sym___clrcall] = ACTIONS(1920),
    [anon_sym___stdcall] = ACTIONS(1920),
    [anon_sym___fastcall] = ACTIONS(1920),
    [anon_sym___thiscall] = ACTIONS(1920),
    [anon_sym___vectorcall] = ACTIONS(1920),
    [anon_sym_LBRACE] = ACTIONS(1922),
    [anon_sym_RBRACE] = ACTIONS(1922),
    [anon_sym_signed] = ACTIONS(1920),
    [anon_sym_unsigned] = ACTIONS(1920),
    [anon_sym_long] = ACTIONS(1920),
    [anon_sym_short] = ACTIONS(1920),
    [anon_sym_LBRACK] = ACTIONS(1920),
    [anon_sym_static] = ACTIONS(1920),
    [anon_sym_register] = ACTIONS(1920),
    [anon_sym_inline] = ACTIONS(1920),
    [anon_sym___inline] = ACTIONS(1920),
    [anon_sym___inline__] = ACTIONS(1920),
    [anon_sym___forceinline] = ACTIONS(1920),
    [anon_sym_thread_local] = ACTIONS(1920),
    [anon_sym___thread] = ACTIONS(1920),
    [anon_sym_const] = ACTIONS(1920),
    [anon_sym_constexpr] = ACTIONS(1920),
    [anon_sym_volatile] = ACTIONS(1920),
    [anon_sym_restrict] = ACTIONS(1920),
    [anon_sym___restrict__] = ACTIONS(1920),
    [anon_sym__Atomic] = ACTIONS(1920),
    [anon_sym__Noreturn] = ACTIONS(1920),
    [anon_sym_noreturn] = ACTIONS(1920),
    [anon_sym_mutable] = ACTIONS(1920),
    [anon_sym_constinit] = ACTIONS(1920),
    [anon_sym_consteval] = ACTIONS(1920),
    [anon_sym___shared__] = ACTIONS(1920),
    [anon_sym___local__] = ACTIONS(1920),
    [anon_sym___constant__] = ACTIONS(1920),
    [anon_sym___managed__] = ACTIONS(1920),
    [anon_sym___grid_constant__] = ACTIONS(1920),
    [anon_sym_alignas] = ACTIONS(1920),
    [anon_sym__Alignas] = ACTIONS(1920),
    [sym_primitive_type] = ACTIONS(1920),
    [anon_sym_enum] = ACTIONS(1920),
    [anon_sym_class] = ACTIONS(1920),
    [anon_sym_struct] = ACTIONS(1920),
    [anon_sym_union] = ACTIONS(1920),
    [anon_sym_if] = ACTIONS(1920),
    [anon_sym_switch] = ACTIONS(1920),
    [anon_sym_case] = ACTIONS(1920),
    [anon_sym_default] = ACTIONS(1920),
    [anon_sym_while] = ACTIONS(1920),
    [anon_sym_do] = ACTIONS(1920),
    [anon_sym_for] = ACTIONS(1920),
    [anon_sym_return] = ACTIONS(1920),
    [anon_sym_break] = ACTIONS(1920),
    [anon_sym_continue] = ACTIONS(1920),
    [anon_sym_goto] = ACTIONS(1920),
    [anon_sym___try] = ACTIONS(1920),
    [anon_sym___leave] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1920),
    [anon_sym_compl] = ACTIONS(1920),
    [anon_sym_DASH_DASH] = ACTIONS(1922),
    [anon_sym_PLUS_PLUS] = ACTIONS(1922),
    [anon_sym_sizeof] = ACTIONS(1920),
    [anon_sym___alignof__] = ACTIONS(1920),
    [anon_sym___alignof] = ACTIONS(1920),
    [anon_sym__alignof] = ACTIONS(1920),
    [anon_sym_alignof] = ACTIONS(1920),
    [anon_sym__Alignof] = ACTIONS(1920),
    [anon_sym_offsetof] = ACTIONS(1920),
    [anon_sym__Generic] = ACTIONS(1920),
    [anon_sym_asm] = ACTIONS(1920),
    [anon_sym___asm__] = ACTIONS(1920),
    [sym_number_literal] = ACTIONS(1922),
    [anon_sym_L_SQUOTE] = ACTIONS(1922),
    [anon_sym_u_SQUOTE] = ACTIONS(1922),
    [anon_sym_U_SQUOTE] = ACTIONS(1922),
    [anon_sym_u8_SQUOTE] = ACTIONS(1922),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_L_DQUOTE] = ACTIONS(1922),
    [anon_sym_u_DQUOTE] = ACTIONS(1922),
    [anon_sym_U_DQUOTE] = ACTIONS(1922),
    [anon_sym_u8_DQUOTE] = ACTIONS(1922),
    [anon_sym_DQUOTE] = ACTIONS(1922),
    [sym_true] = ACTIONS(1920),
    [sym_false] = ACTIONS(1920),
    [anon_sym_NULL] = ACTIONS(1920),
    [anon_sym_nullptr] = ACTIONS(1920),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1920),
    [anon_sym_decltype] = ACTIONS(1920),
    [sym_virtual] = ACTIONS(1920),
    [anon_sym_explicit] = ACTIONS(1920),
    [anon_sym_typename] = ACTIONS(1920),
    [anon_sym_template] = ACTIONS(1920),
    [anon_sym_operator] = ACTIONS(1920),
    [anon_sym_try] = ACTIONS(1920),
    [anon_sym_delete] = ACTIONS(1920),
    [anon_sym_throw] = ACTIONS(1920),
    [anon_sym_namespace] = ACTIONS(1920),
    [anon_sym_using] = ACTIONS(1920),
    [anon_sym_static_assert] = ACTIONS(1920),
    [anon_sym_concept] = ACTIONS(1920),
    [anon_sym_co_return] = ACTIONS(1920),
    [anon_sym_co_yield] = ACTIONS(1920),
    [anon_sym_catch] = ACTIONS(2346),
    [anon_sym_R_DQUOTE] = ACTIONS(1922),
    [anon_sym_LR_DQUOTE] = ACTIONS(1922),
    [anon_sym_uR_DQUOTE] = ACTIONS(1922),
    [anon_sym_UR_DQUOTE] = ACTIONS(1922),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1922),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1920),
    [anon_sym_requires] = ACTIONS(1920),
    [sym_this] = ACTIONS(1920),
    [anon_sym___launch_bounds__] = ACTIONS(1920),
  },
  [306] = {
    [sym_catch_clause] = STATE(192),
    [aux_sym_constructor_try_statement_repeat1] = STATE(192),
    [sym_identifier] = ACTIONS(1916),
    [aux_sym_preproc_include_token1] = ACTIONS(1916),
    [aux_sym_preproc_def_token1] = ACTIONS(1916),
    [aux_sym_preproc_if_token1] = ACTIONS(1916),
    [aux_sym_preproc_if_token2] = ACTIONS(1916),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1916),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1916),
    [sym_preproc_directive] = ACTIONS(1916),
    [anon_sym_LPAREN2] = ACTIONS(1918),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [anon_sym_DASH] = ACTIONS(1916),
    [anon_sym_PLUS] = ACTIONS(1916),
    [anon_sym_STAR] = ACTIONS(1918),
    [anon_sym_AMP_AMP] = ACTIONS(1918),
    [anon_sym_AMP] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1918),
    [anon_sym___extension__] = ACTIONS(1916),
    [anon_sym_typedef] = ACTIONS(1916),
    [anon_sym___device__] = ACTIONS(1916),
    [anon_sym___host__] = ACTIONS(1916),
    [anon_sym___global__] = ACTIONS(1916),
    [anon_sym___forceinline__] = ACTIONS(1916),
    [anon_sym___noinline__] = ACTIONS(1916),
    [anon_sym_extern] = ACTIONS(1916),
    [anon_sym___attribute__] = ACTIONS(1916),
    [anon_sym_COLON_COLON] = ACTIONS(1918),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1918),
    [anon_sym___declspec] = ACTIONS(1916),
    [anon_sym___based] = ACTIONS(1916),
    [anon_sym___cdecl] = ACTIONS(1916),
    [anon_sym___clrcall] = ACTIONS(1916),
    [anon_sym___stdcall] = ACTIONS(1916),
    [anon_sym___fastcall] = ACTIONS(1916),
    [anon_sym___thiscall] = ACTIONS(1916),
    [anon_sym___vectorcall] = ACTIONS(1916),
    [anon_sym_LBRACE] = ACTIONS(1918),
    [anon_sym_signed] = ACTIONS(1916),
    [anon_sym_unsigned] = ACTIONS(1916),
    [anon_sym_long] = ACTIONS(1916),
    [anon_sym_short] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1916),
    [anon_sym_static] = ACTIONS(1916),
    [anon_sym_register] = ACTIONS(1916),
    [anon_sym_inline] = ACTIONS(1916),
    [anon_sym___inline] = ACTIONS(1916),
    [anon_sym___inline__] = ACTIONS(1916),
    [anon_sym___forceinline] = ACTIONS(1916),
    [anon_sym_thread_local] = ACTIONS(1916),
    [anon_sym___thread] = ACTIONS(1916),
    [anon_sym_const] = ACTIONS(1916),
    [anon_sym_constexpr] = ACTIONS(1916),
    [anon_sym_volatile] = ACTIONS(1916),
    [anon_sym_restrict] = ACTIONS(1916),
    [anon_sym___restrict__] = ACTIONS(1916),
    [anon_sym__Atomic] = ACTIONS(1916),
    [anon_sym__Noreturn] = ACTIONS(1916),
    [anon_sym_noreturn] = ACTIONS(1916),
    [anon_sym_mutable] = ACTIONS(1916),
    [anon_sym_constinit] = ACTIONS(1916),
    [anon_sym_consteval] = ACTIONS(1916),
    [anon_sym___shared__] = ACTIONS(1916),
    [anon_sym___local__] = ACTIONS(1916),
    [anon_sym___constant__] = ACTIONS(1916),
    [anon_sym___managed__] = ACTIONS(1916),
    [anon_sym___grid_constant__] = ACTIONS(1916),
    [anon_sym_alignas] = ACTIONS(1916),
    [anon_sym__Alignas] = ACTIONS(1916),
    [sym_primitive_type] = ACTIONS(1916),
    [anon_sym_enum] = ACTIONS(1916),
    [anon_sym_class] = ACTIONS(1916),
    [anon_sym_struct] = ACTIONS(1916),
    [anon_sym_union] = ACTIONS(1916),
    [anon_sym_if] = ACTIONS(1916),
    [anon_sym_switch] = ACTIONS(1916),
    [anon_sym_case] = ACTIONS(1916),
    [anon_sym_default] = ACTIONS(1916),
    [anon_sym_while] = ACTIONS(1916),
    [anon_sym_do] = ACTIONS(1916),
    [anon_sym_for] = ACTIONS(1916),
    [anon_sym_return] = ACTIONS(1916),
    [anon_sym_break] = ACTIONS(1916),
    [anon_sym_continue] = ACTIONS(1916),
    [anon_sym_goto] = ACTIONS(1916),
    [anon_sym___try] = ACTIONS(1916),
    [anon_sym___leave] = ACTIONS(1916),
    [anon_sym_not] = ACTIONS(1916),
    [anon_sym_compl] = ACTIONS(1916),
    [anon_sym_DASH_DASH] = ACTIONS(1918),
    [anon_sym_PLUS_PLUS] = ACTIONS(1918),
    [anon_sym_sizeof] = ACTIONS(1916),
    [anon_sym___alignof__] = ACTIONS(1916),
    [anon_sym___alignof] = ACTIONS(1916),
    [anon_sym__alignof] = ACTIONS(1916),
    [anon_sym_alignof] = ACTIONS(1916),
    [anon_sym__Alignof] = ACTIONS(1916),
    [anon_sym_offsetof] = ACTIONS(1916),
    [anon_sym__Generic] = ACTIONS(1916),
    [anon_sym_asm] = ACTIONS(1916),
    [anon_sym___asm__] = ACTIONS(1916),
    [sym_number_literal] = ACTIONS(1918),
    [anon_sym_L_SQUOTE] = ACTIONS(1918),
    [anon_sym_u_SQUOTE] = ACTIONS(1918),
    [anon_sym_U_SQUOTE] = ACTIONS(1918),
    [anon_sym_u8_SQUOTE] = ACTIONS(1918),
    [anon_sym_SQUOTE] = ACTIONS(1918),
    [anon_sym_L_DQUOTE] = ACTIONS(1918),
    [anon_sym_u_DQUOTE] = ACTIONS(1918),
    [anon_sym_U_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8_DQUOTE] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1918),
    [sym_true] = ACTIONS(1916),
    [sym_false] = ACTIONS(1916),
    [anon_sym_NULL] = ACTIONS(1916),
    [anon_sym_nullptr] = ACTIONS(1916),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1916),
    [anon_sym_decltype] = ACTIONS(1916),
    [sym_virtual] = ACTIONS(1916),
    [anon_sym_explicit] = ACTIONS(1916),
    [anon_sym_typename] = ACTIONS(1916),
    [anon_sym_template] = ACTIONS(1916),
    [anon_sym_operator] = ACTIONS(1916),
    [anon_sym_try] = ACTIONS(1916),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_throw] = ACTIONS(1916),
    [anon_sym_namespace] = ACTIONS(1916),
    [anon_sym_using] = ACTIONS(1916),
    [anon_sym_static_assert] = ACTIONS(1916),
    [anon_sym_concept] = ACTIONS(1916),
    [anon_sym_co_return] = ACTIONS(1916),
    [anon_sym_co_yield] = ACTIONS(1916),
    [anon_sym_catch] = ACTIONS(2322),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1916),
    [anon_sym_new] = ACTIONS(1916),
    [anon_sym_requires] = ACTIONS(1916),
    [sym_this] = ACTIONS(1916),
    [anon_sym___launch_bounds__] = ACTIONS(1916),
  },
  [307] = {
    [sym_catch_clause] = STATE(192),
    [aux_sym_constructor_try_statement_repeat1] = STATE(192),
    [sym_identifier] = ACTIONS(1920),
    [aux_sym_preproc_include_token1] = ACTIONS(1920),
    [aux_sym_preproc_def_token1] = ACTIONS(1920),
    [aux_sym_preproc_if_token1] = ACTIONS(1920),
    [aux_sym_preproc_if_token2] = ACTIONS(1920),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1920),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1920),
    [sym_preproc_directive] = ACTIONS(1920),
    [anon_sym_LPAREN2] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1922),
    [anon_sym_TILDE] = ACTIONS(1922),
    [anon_sym_DASH] = ACTIONS(1920),
    [anon_sym_PLUS] = ACTIONS(1920),
    [anon_sym_STAR] = ACTIONS(1922),
    [anon_sym_AMP_AMP] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1920),
    [anon_sym_SEMI] = ACTIONS(1922),
    [anon_sym___extension__] = ACTIONS(1920),
    [anon_sym_typedef] = ACTIONS(1920),
    [anon_sym___device__] = ACTIONS(1920),
    [anon_sym___host__] = ACTIONS(1920),
    [anon_sym___global__] = ACTIONS(1920),
    [anon_sym___forceinline__] = ACTIONS(1920),
    [anon_sym___noinline__] = ACTIONS(1920),
    [anon_sym_extern] = ACTIONS(1920),
    [anon_sym___attribute__] = ACTIONS(1920),
    [anon_sym_COLON_COLON] = ACTIONS(1922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1922),
    [anon_sym___declspec] = ACTIONS(1920),
    [anon_sym___based] = ACTIONS(1920),
    [anon_sym___cdecl] = ACTIONS(1920),
    [anon_sym___clrcall] = ACTIONS(1920),
    [anon_sym___stdcall] = ACTIONS(1920),
    [anon_sym___fastcall] = ACTIONS(1920),
    [anon_sym___thiscall] = ACTIONS(1920),
    [anon_sym___vectorcall] = ACTIONS(1920),
    [anon_sym_LBRACE] = ACTIONS(1922),
    [anon_sym_signed] = ACTIONS(1920),
    [anon_sym_unsigned] = ACTIONS(1920),
    [anon_sym_long] = ACTIONS(1920),
    [anon_sym_short] = ACTIONS(1920),
    [anon_sym_LBRACK] = ACTIONS(1920),
    [anon_sym_static] = ACTIONS(1920),
    [anon_sym_register] = ACTIONS(1920),
    [anon_sym_inline] = ACTIONS(1920),
    [anon_sym___inline] = ACTIONS(1920),
    [anon_sym___inline__] = ACTIONS(1920),
    [anon_sym___forceinline] = ACTIONS(1920),
    [anon_sym_thread_local] = ACTIONS(1920),
    [anon_sym___thread] = ACTIONS(1920),
    [anon_sym_const] = ACTIONS(1920),
    [anon_sym_constexpr] = ACTIONS(1920),
    [anon_sym_volatile] = ACTIONS(1920),
    [anon_sym_restrict] = ACTIONS(1920),
    [anon_sym___restrict__] = ACTIONS(1920),
    [anon_sym__Atomic] = ACTIONS(1920),
    [anon_sym__Noreturn] = ACTIONS(1920),
    [anon_sym_noreturn] = ACTIONS(1920),
    [anon_sym_mutable] = ACTIONS(1920),
    [anon_sym_constinit] = ACTIONS(1920),
    [anon_sym_consteval] = ACTIONS(1920),
    [anon_sym___shared__] = ACTIONS(1920),
    [anon_sym___local__] = ACTIONS(1920),
    [anon_sym___constant__] = ACTIONS(1920),
    [anon_sym___managed__] = ACTIONS(1920),
    [anon_sym___grid_constant__] = ACTIONS(1920),
    [anon_sym_alignas] = ACTIONS(1920),
    [anon_sym__Alignas] = ACTIONS(1920),
    [sym_primitive_type] = ACTIONS(1920),
    [anon_sym_enum] = ACTIONS(1920),
    [anon_sym_class] = ACTIONS(1920),
    [anon_sym_struct] = ACTIONS(1920),
    [anon_sym_union] = ACTIONS(1920),
    [anon_sym_if] = ACTIONS(1920),
    [anon_sym_switch] = ACTIONS(1920),
    [anon_sym_case] = ACTIONS(1920),
    [anon_sym_default] = ACTIONS(1920),
    [anon_sym_while] = ACTIONS(1920),
    [anon_sym_do] = ACTIONS(1920),
    [anon_sym_for] = ACTIONS(1920),
    [anon_sym_return] = ACTIONS(1920),
    [anon_sym_break] = ACTIONS(1920),
    [anon_sym_continue] = ACTIONS(1920),
    [anon_sym_goto] = ACTIONS(1920),
    [anon_sym___try] = ACTIONS(1920),
    [anon_sym___leave] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1920),
    [anon_sym_compl] = ACTIONS(1920),
    [anon_sym_DASH_DASH] = ACTIONS(1922),
    [anon_sym_PLUS_PLUS] = ACTIONS(1922),
    [anon_sym_sizeof] = ACTIONS(1920),
    [anon_sym___alignof__] = ACTIONS(1920),
    [anon_sym___alignof] = ACTIONS(1920),
    [anon_sym__alignof] = ACTIONS(1920),
    [anon_sym_alignof] = ACTIONS(1920),
    [anon_sym__Alignof] = ACTIONS(1920),
    [anon_sym_offsetof] = ACTIONS(1920),
    [anon_sym__Generic] = ACTIONS(1920),
    [anon_sym_asm] = ACTIONS(1920),
    [anon_sym___asm__] = ACTIONS(1920),
    [sym_number_literal] = ACTIONS(1922),
    [anon_sym_L_SQUOTE] = ACTIONS(1922),
    [anon_sym_u_SQUOTE] = ACTIONS(1922),
    [anon_sym_U_SQUOTE] = ACTIONS(1922),
    [anon_sym_u8_SQUOTE] = ACTIONS(1922),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_L_DQUOTE] = ACTIONS(1922),
    [anon_sym_u_DQUOTE] = ACTIONS(1922),
    [anon_sym_U_DQUOTE] = ACTIONS(1922),
    [anon_sym_u8_DQUOTE] = ACTIONS(1922),
    [anon_sym_DQUOTE] = ACTIONS(1922),
    [sym_true] = ACTIONS(1920),
    [sym_false] = ACTIONS(1920),
    [anon_sym_NULL] = ACTIONS(1920),
    [anon_sym_nullptr] = ACTIONS(1920),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1920),
    [anon_sym_decltype] = ACTIONS(1920),
    [sym_virtual] = ACTIONS(1920),
    [anon_sym_explicit] = ACTIONS(1920),
    [anon_sym_typename] = ACTIONS(1920),
    [anon_sym_template] = ACTIONS(1920),
    [anon_sym_operator] = ACTIONS(1920),
    [anon_sym_try] = ACTIONS(1920),
    [anon_sym_delete] = ACTIONS(1920),
    [anon_sym_throw] = ACTIONS(1920),
    [anon_sym_namespace] = ACTIONS(1920),
    [anon_sym_using] = ACTIONS(1920),
    [anon_sym_static_assert] = ACTIONS(1920),
    [anon_sym_concept] = ACTIONS(1920),
    [anon_sym_co_return] = ACTIONS(1920),
    [anon_sym_co_yield] = ACTIONS(1920),
    [anon_sym_catch] = ACTIONS(2322),
    [anon_sym_R_DQUOTE] = ACTIONS(1922),
    [anon_sym_LR_DQUOTE] = ACTIONS(1922),
    [anon_sym_uR_DQUOTE] = ACTIONS(1922),
    [anon_sym_UR_DQUOTE] = ACTIONS(1922),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1922),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1920),
    [anon_sym_requires] = ACTIONS(1920),
    [sym_this] = ACTIONS(1920),
    [anon_sym___launch_bounds__] = ACTIONS(1920),
  },
  [308] = {
    [sym_expression] = STATE(2499),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_initializer_list] = STATE(2690),
    [sym_char_literal] = STATE(2940),
    [sym_concatenated_string] = STATE(3000),
    [sym_string_literal] = STATE(2241),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2239),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2508),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2510),
    [aux_sym_preproc_if_token2] = ACTIONS(2510),
    [aux_sym_preproc_else_token1] = ACTIONS(2510),
    [aux_sym_preproc_elif_token1] = ACTIONS(2508),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2510),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_BANG] = ACTIONS(2512),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2508),
    [anon_sym_STAR] = ACTIONS(2508),
    [anon_sym_SLASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_PIPE] = ACTIONS(2508),
    [anon_sym_CARET] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_EQ_EQ] = ACTIONS(2510),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_GT] = ACTIONS(2508),
    [anon_sym_GT_EQ] = ACTIONS(2510),
    [anon_sym_LT_EQ] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_LT_LT] = ACTIONS(2508),
    [anon_sym_GT_GT] = ACTIONS(2508),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_EQ] = ACTIONS(2508),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_STAR_EQ] = ACTIONS(2510),
    [anon_sym_SLASH_EQ] = ACTIONS(2510),
    [anon_sym_PERCENT_EQ] = ACTIONS(2510),
    [anon_sym_PLUS_EQ] = ACTIONS(2510),
    [anon_sym_DASH_EQ] = ACTIONS(2510),
    [anon_sym_LT_LT_EQ] = ACTIONS(2510),
    [anon_sym_GT_GT_EQ] = ACTIONS(2510),
    [anon_sym_AMP_EQ] = ACTIONS(2510),
    [anon_sym_CARET_EQ] = ACTIONS(2510),
    [anon_sym_PIPE_EQ] = ACTIONS(2510),
    [anon_sym_and_eq] = ACTIONS(2508),
    [anon_sym_or_eq] = ACTIONS(2508),
    [anon_sym_xor_eq] = ACTIONS(2508),
    [anon_sym_not] = ACTIONS(2512),
    [anon_sym_compl] = ACTIONS(2512),
    [anon_sym_LT_EQ_GT] = ACTIONS(2510),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_bitor] = ACTIONS(2508),
    [anon_sym_xor] = ACTIONS(2508),
    [anon_sym_bitand] = ACTIONS(2508),
    [anon_sym_not_eq] = ACTIONS(2508),
    [anon_sym_DASH_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_PLUS] = ACTIONS(2510),
    [anon_sym_sizeof] = ACTIONS(2522),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [anon_sym_DOT] = ACTIONS(2508),
    [anon_sym_DOT_STAR] = ACTIONS(2510),
    [anon_sym_DASH_GT] = ACTIONS(2510),
    [sym_number_literal] = ACTIONS(2532),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [anon_sym_co_await] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(2510),
  },
  [309] = {
    [sym_catch_clause] = STATE(223),
    [aux_sym_constructor_try_statement_repeat1] = STATE(223),
    [sym_identifier] = ACTIONS(1916),
    [aux_sym_preproc_include_token1] = ACTIONS(1916),
    [aux_sym_preproc_def_token1] = ACTIONS(1916),
    [aux_sym_preproc_if_token1] = ACTIONS(1916),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1916),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1916),
    [sym_preproc_directive] = ACTIONS(1916),
    [anon_sym_LPAREN2] = ACTIONS(1918),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [anon_sym_DASH] = ACTIONS(1916),
    [anon_sym_PLUS] = ACTIONS(1916),
    [anon_sym_STAR] = ACTIONS(1918),
    [anon_sym_AMP_AMP] = ACTIONS(1918),
    [anon_sym_AMP] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1918),
    [anon_sym___extension__] = ACTIONS(1916),
    [anon_sym_typedef] = ACTIONS(1916),
    [anon_sym___device__] = ACTIONS(1916),
    [anon_sym___host__] = ACTIONS(1916),
    [anon_sym___global__] = ACTIONS(1916),
    [anon_sym___forceinline__] = ACTIONS(1916),
    [anon_sym___noinline__] = ACTIONS(1916),
    [anon_sym_extern] = ACTIONS(1916),
    [anon_sym___attribute__] = ACTIONS(1916),
    [anon_sym_COLON_COLON] = ACTIONS(1918),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1918),
    [anon_sym___declspec] = ACTIONS(1916),
    [anon_sym___based] = ACTIONS(1916),
    [anon_sym___cdecl] = ACTIONS(1916),
    [anon_sym___clrcall] = ACTIONS(1916),
    [anon_sym___stdcall] = ACTIONS(1916),
    [anon_sym___fastcall] = ACTIONS(1916),
    [anon_sym___thiscall] = ACTIONS(1916),
    [anon_sym___vectorcall] = ACTIONS(1916),
    [anon_sym_LBRACE] = ACTIONS(1918),
    [anon_sym_RBRACE] = ACTIONS(1918),
    [anon_sym_signed] = ACTIONS(1916),
    [anon_sym_unsigned] = ACTIONS(1916),
    [anon_sym_long] = ACTIONS(1916),
    [anon_sym_short] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1916),
    [anon_sym_static] = ACTIONS(1916),
    [anon_sym_register] = ACTIONS(1916),
    [anon_sym_inline] = ACTIONS(1916),
    [anon_sym___inline] = ACTIONS(1916),
    [anon_sym___inline__] = ACTIONS(1916),
    [anon_sym___forceinline] = ACTIONS(1916),
    [anon_sym_thread_local] = ACTIONS(1916),
    [anon_sym___thread] = ACTIONS(1916),
    [anon_sym_const] = ACTIONS(1916),
    [anon_sym_constexpr] = ACTIONS(1916),
    [anon_sym_volatile] = ACTIONS(1916),
    [anon_sym_restrict] = ACTIONS(1916),
    [anon_sym___restrict__] = ACTIONS(1916),
    [anon_sym__Atomic] = ACTIONS(1916),
    [anon_sym__Noreturn] = ACTIONS(1916),
    [anon_sym_noreturn] = ACTIONS(1916),
    [anon_sym_mutable] = ACTIONS(1916),
    [anon_sym_constinit] = ACTIONS(1916),
    [anon_sym_consteval] = ACTIONS(1916),
    [anon_sym___shared__] = ACTIONS(1916),
    [anon_sym___local__] = ACTIONS(1916),
    [anon_sym___constant__] = ACTIONS(1916),
    [anon_sym___managed__] = ACTIONS(1916),
    [anon_sym___grid_constant__] = ACTIONS(1916),
    [anon_sym_alignas] = ACTIONS(1916),
    [anon_sym__Alignas] = ACTIONS(1916),
    [sym_primitive_type] = ACTIONS(1916),
    [anon_sym_enum] = ACTIONS(1916),
    [anon_sym_class] = ACTIONS(1916),
    [anon_sym_struct] = ACTIONS(1916),
    [anon_sym_union] = ACTIONS(1916),
    [anon_sym_if] = ACTIONS(1916),
    [anon_sym_switch] = ACTIONS(1916),
    [anon_sym_case] = ACTIONS(1916),
    [anon_sym_default] = ACTIONS(1916),
    [anon_sym_while] = ACTIONS(1916),
    [anon_sym_do] = ACTIONS(1916),
    [anon_sym_for] = ACTIONS(1916),
    [anon_sym_return] = ACTIONS(1916),
    [anon_sym_break] = ACTIONS(1916),
    [anon_sym_continue] = ACTIONS(1916),
    [anon_sym_goto] = ACTIONS(1916),
    [anon_sym___try] = ACTIONS(1916),
    [anon_sym___leave] = ACTIONS(1916),
    [anon_sym_not] = ACTIONS(1916),
    [anon_sym_compl] = ACTIONS(1916),
    [anon_sym_DASH_DASH] = ACTIONS(1918),
    [anon_sym_PLUS_PLUS] = ACTIONS(1918),
    [anon_sym_sizeof] = ACTIONS(1916),
    [anon_sym___alignof__] = ACTIONS(1916),
    [anon_sym___alignof] = ACTIONS(1916),
    [anon_sym__alignof] = ACTIONS(1916),
    [anon_sym_alignof] = ACTIONS(1916),
    [anon_sym__Alignof] = ACTIONS(1916),
    [anon_sym_offsetof] = ACTIONS(1916),
    [anon_sym__Generic] = ACTIONS(1916),
    [anon_sym_asm] = ACTIONS(1916),
    [anon_sym___asm__] = ACTIONS(1916),
    [sym_number_literal] = ACTIONS(1918),
    [anon_sym_L_SQUOTE] = ACTIONS(1918),
    [anon_sym_u_SQUOTE] = ACTIONS(1918),
    [anon_sym_U_SQUOTE] = ACTIONS(1918),
    [anon_sym_u8_SQUOTE] = ACTIONS(1918),
    [anon_sym_SQUOTE] = ACTIONS(1918),
    [anon_sym_L_DQUOTE] = ACTIONS(1918),
    [anon_sym_u_DQUOTE] = ACTIONS(1918),
    [anon_sym_U_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8_DQUOTE] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1918),
    [sym_true] = ACTIONS(1916),
    [sym_false] = ACTIONS(1916),
    [anon_sym_NULL] = ACTIONS(1916),
    [anon_sym_nullptr] = ACTIONS(1916),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1916),
    [anon_sym_decltype] = ACTIONS(1916),
    [sym_virtual] = ACTIONS(1916),
    [anon_sym_explicit] = ACTIONS(1916),
    [anon_sym_typename] = ACTIONS(1916),
    [anon_sym_template] = ACTIONS(1916),
    [anon_sym_operator] = ACTIONS(1916),
    [anon_sym_try] = ACTIONS(1916),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_throw] = ACTIONS(1916),
    [anon_sym_namespace] = ACTIONS(1916),
    [anon_sym_using] = ACTIONS(1916),
    [anon_sym_static_assert] = ACTIONS(1916),
    [anon_sym_concept] = ACTIONS(1916),
    [anon_sym_co_return] = ACTIONS(1916),
    [anon_sym_co_yield] = ACTIONS(1916),
    [anon_sym_catch] = ACTIONS(2346),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1916),
    [anon_sym_new] = ACTIONS(1916),
    [anon_sym_requires] = ACTIONS(1916),
    [sym_this] = ACTIONS(1916),
    [anon_sym___launch_bounds__] = ACTIONS(1916),
  },
  [310] = {
    [sym_identifier] = ACTIONS(1897),
    [aux_sym_preproc_include_token1] = ACTIONS(1897),
    [aux_sym_preproc_def_token1] = ACTIONS(1897),
    [aux_sym_preproc_if_token1] = ACTIONS(1897),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1897),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1897),
    [sym_preproc_directive] = ACTIONS(1897),
    [anon_sym_LPAREN2] = ACTIONS(1895),
    [anon_sym_BANG] = ACTIONS(1895),
    [anon_sym_TILDE] = ACTIONS(1895),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_AMP_AMP] = ACTIONS(1895),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym_SEMI] = ACTIONS(1895),
    [anon_sym___extension__] = ACTIONS(1897),
    [anon_sym_typedef] = ACTIONS(1897),
    [anon_sym___device__] = ACTIONS(1897),
    [anon_sym___host__] = ACTIONS(1897),
    [anon_sym___global__] = ACTIONS(1897),
    [anon_sym___forceinline__] = ACTIONS(1897),
    [anon_sym___noinline__] = ACTIONS(1897),
    [anon_sym_extern] = ACTIONS(1897),
    [anon_sym___attribute__] = ACTIONS(1897),
    [anon_sym_COLON_COLON] = ACTIONS(1895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1895),
    [anon_sym___declspec] = ACTIONS(1897),
    [anon_sym___based] = ACTIONS(1897),
    [anon_sym___cdecl] = ACTIONS(1897),
    [anon_sym___clrcall] = ACTIONS(1897),
    [anon_sym___stdcall] = ACTIONS(1897),
    [anon_sym___fastcall] = ACTIONS(1897),
    [anon_sym___thiscall] = ACTIONS(1897),
    [anon_sym___vectorcall] = ACTIONS(1897),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_RBRACE] = ACTIONS(1895),
    [anon_sym_signed] = ACTIONS(1897),
    [anon_sym_unsigned] = ACTIONS(1897),
    [anon_sym_long] = ACTIONS(1897),
    [anon_sym_short] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1897),
    [anon_sym_static] = ACTIONS(1897),
    [anon_sym_register] = ACTIONS(1897),
    [anon_sym_inline] = ACTIONS(1897),
    [anon_sym___inline] = ACTIONS(1897),
    [anon_sym___inline__] = ACTIONS(1897),
    [anon_sym___forceinline] = ACTIONS(1897),
    [anon_sym_thread_local] = ACTIONS(1897),
    [anon_sym___thread] = ACTIONS(1897),
    [anon_sym_const] = ACTIONS(1897),
    [anon_sym_constexpr] = ACTIONS(1897),
    [anon_sym_volatile] = ACTIONS(1897),
    [anon_sym_restrict] = ACTIONS(1897),
    [anon_sym___restrict__] = ACTIONS(1897),
    [anon_sym__Atomic] = ACTIONS(1897),
    [anon_sym__Noreturn] = ACTIONS(1897),
    [anon_sym_noreturn] = ACTIONS(1897),
    [anon_sym_mutable] = ACTIONS(1897),
    [anon_sym_constinit] = ACTIONS(1897),
    [anon_sym_consteval] = ACTIONS(1897),
    [anon_sym___shared__] = ACTIONS(1897),
    [anon_sym___local__] = ACTIONS(1897),
    [anon_sym___constant__] = ACTIONS(1897),
    [anon_sym___managed__] = ACTIONS(1897),
    [anon_sym___grid_constant__] = ACTIONS(1897),
    [anon_sym_alignas] = ACTIONS(1897),
    [anon_sym__Alignas] = ACTIONS(1897),
    [sym_primitive_type] = ACTIONS(1897),
    [anon_sym_enum] = ACTIONS(1897),
    [anon_sym_class] = ACTIONS(1897),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1897),
    [anon_sym_if] = ACTIONS(1897),
    [anon_sym_else] = ACTIONS(1897),
    [anon_sym_switch] = ACTIONS(1897),
    [anon_sym_case] = ACTIONS(1897),
    [anon_sym_default] = ACTIONS(1897),
    [anon_sym_while] = ACTIONS(1897),
    [anon_sym_do] = ACTIONS(1897),
    [anon_sym_for] = ACTIONS(1897),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_continue] = ACTIONS(1897),
    [anon_sym_goto] = ACTIONS(1897),
    [anon_sym___try] = ACTIONS(1897),
    [anon_sym___leave] = ACTIONS(1897),
    [anon_sym_not] = ACTIONS(1897),
    [anon_sym_compl] = ACTIONS(1897),
    [anon_sym_DASH_DASH] = ACTIONS(1895),
    [anon_sym_PLUS_PLUS] = ACTIONS(1895),
    [anon_sym_sizeof] = ACTIONS(1897),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1897),
    [anon_sym__Generic] = ACTIONS(1897),
    [anon_sym_asm] = ACTIONS(1897),
    [anon_sym___asm__] = ACTIONS(1897),
    [sym_number_literal] = ACTIONS(1895),
    [anon_sym_L_SQUOTE] = ACTIONS(1895),
    [anon_sym_u_SQUOTE] = ACTIONS(1895),
    [anon_sym_U_SQUOTE] = ACTIONS(1895),
    [anon_sym_u8_SQUOTE] = ACTIONS(1895),
    [anon_sym_SQUOTE] = ACTIONS(1895),
    [anon_sym_L_DQUOTE] = ACTIONS(1895),
    [anon_sym_u_DQUOTE] = ACTIONS(1895),
    [anon_sym_U_DQUOTE] = ACTIONS(1895),
    [anon_sym_u8_DQUOTE] = ACTIONS(1895),
    [anon_sym_DQUOTE] = ACTIONS(1895),
    [sym_true] = ACTIONS(1897),
    [sym_false] = ACTIONS(1897),
    [anon_sym_NULL] = ACTIONS(1897),
    [anon_sym_nullptr] = ACTIONS(1897),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1897),
    [anon_sym_decltype] = ACTIONS(1897),
    [sym_virtual] = ACTIONS(1897),
    [anon_sym_explicit] = ACTIONS(1897),
    [anon_sym_typename] = ACTIONS(1897),
    [anon_sym_template] = ACTIONS(1897),
    [anon_sym_operator] = ACTIONS(1897),
    [anon_sym_try] = ACTIONS(1897),
    [anon_sym_delete] = ACTIONS(1897),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_namespace] = ACTIONS(1897),
    [anon_sym_using] = ACTIONS(1897),
    [anon_sym_static_assert] = ACTIONS(1897),
    [anon_sym_concept] = ACTIONS(1897),
    [anon_sym_co_return] = ACTIONS(1897),
    [anon_sym_co_yield] = ACTIONS(1897),
    [anon_sym_catch] = ACTIONS(1897),
    [anon_sym_R_DQUOTE] = ACTIONS(1895),
    [anon_sym_LR_DQUOTE] = ACTIONS(1895),
    [anon_sym_uR_DQUOTE] = ACTIONS(1895),
    [anon_sym_UR_DQUOTE] = ACTIONS(1895),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1895),
    [anon_sym_co_await] = ACTIONS(1897),
    [anon_sym_new] = ACTIONS(1897),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1897),
    [anon_sym___launch_bounds__] = ACTIONS(1897),
  },
  [311] = {
    [sym_else_clause] = STATE(327),
    [ts_builtin_sym_end] = ACTIONS(1930),
    [sym_identifier] = ACTIONS(1928),
    [aux_sym_preproc_include_token1] = ACTIONS(1928),
    [aux_sym_preproc_def_token1] = ACTIONS(1928),
    [aux_sym_preproc_if_token1] = ACTIONS(1928),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1928),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1928),
    [sym_preproc_directive] = ACTIONS(1928),
    [anon_sym_LPAREN2] = ACTIONS(1930),
    [anon_sym_BANG] = ACTIONS(1930),
    [anon_sym_TILDE] = ACTIONS(1930),
    [anon_sym_DASH] = ACTIONS(1928),
    [anon_sym_PLUS] = ACTIONS(1928),
    [anon_sym_STAR] = ACTIONS(1930),
    [anon_sym_AMP_AMP] = ACTIONS(1930),
    [anon_sym_AMP] = ACTIONS(1928),
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym___extension__] = ACTIONS(1928),
    [anon_sym_typedef] = ACTIONS(1928),
    [anon_sym___device__] = ACTIONS(1928),
    [anon_sym___host__] = ACTIONS(1928),
    [anon_sym___global__] = ACTIONS(1928),
    [anon_sym___forceinline__] = ACTIONS(1928),
    [anon_sym___noinline__] = ACTIONS(1928),
    [anon_sym_extern] = ACTIONS(1928),
    [anon_sym___attribute__] = ACTIONS(1928),
    [anon_sym_COLON_COLON] = ACTIONS(1930),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1930),
    [anon_sym___declspec] = ACTIONS(1928),
    [anon_sym___based] = ACTIONS(1928),
    [anon_sym___cdecl] = ACTIONS(1928),
    [anon_sym___clrcall] = ACTIONS(1928),
    [anon_sym___stdcall] = ACTIONS(1928),
    [anon_sym___fastcall] = ACTIONS(1928),
    [anon_sym___thiscall] = ACTIONS(1928),
    [anon_sym___vectorcall] = ACTIONS(1928),
    [anon_sym_LBRACE] = ACTIONS(1930),
    [anon_sym_signed] = ACTIONS(1928),
    [anon_sym_unsigned] = ACTIONS(1928),
    [anon_sym_long] = ACTIONS(1928),
    [anon_sym_short] = ACTIONS(1928),
    [anon_sym_LBRACK] = ACTIONS(1928),
    [anon_sym_static] = ACTIONS(1928),
    [anon_sym_register] = ACTIONS(1928),
    [anon_sym_inline] = ACTIONS(1928),
    [anon_sym___inline] = ACTIONS(1928),
    [anon_sym___inline__] = ACTIONS(1928),
    [anon_sym___forceinline] = ACTIONS(1928),
    [anon_sym_thread_local] = ACTIONS(1928),
    [anon_sym___thread] = ACTIONS(1928),
    [anon_sym_const] = ACTIONS(1928),
    [anon_sym_constexpr] = ACTIONS(1928),
    [anon_sym_volatile] = ACTIONS(1928),
    [anon_sym_restrict] = ACTIONS(1928),
    [anon_sym___restrict__] = ACTIONS(1928),
    [anon_sym__Atomic] = ACTIONS(1928),
    [anon_sym__Noreturn] = ACTIONS(1928),
    [anon_sym_noreturn] = ACTIONS(1928),
    [anon_sym_mutable] = ACTIONS(1928),
    [anon_sym_constinit] = ACTIONS(1928),
    [anon_sym_consteval] = ACTIONS(1928),
    [anon_sym___shared__] = ACTIONS(1928),
    [anon_sym___local__] = ACTIONS(1928),
    [anon_sym___constant__] = ACTIONS(1928),
    [anon_sym___managed__] = ACTIONS(1928),
    [anon_sym___grid_constant__] = ACTIONS(1928),
    [anon_sym_alignas] = ACTIONS(1928),
    [anon_sym__Alignas] = ACTIONS(1928),
    [sym_primitive_type] = ACTIONS(1928),
    [anon_sym_enum] = ACTIONS(1928),
    [anon_sym_class] = ACTIONS(1928),
    [anon_sym_struct] = ACTIONS(1928),
    [anon_sym_union] = ACTIONS(1928),
    [anon_sym_if] = ACTIONS(1928),
    [anon_sym_else] = ACTIONS(2554),
    [anon_sym_switch] = ACTIONS(1928),
    [anon_sym_case] = ACTIONS(1928),
    [anon_sym_default] = ACTIONS(1928),
    [anon_sym_while] = ACTIONS(1928),
    [anon_sym_do] = ACTIONS(1928),
    [anon_sym_for] = ACTIONS(1928),
    [anon_sym_return] = ACTIONS(1928),
    [anon_sym_break] = ACTIONS(1928),
    [anon_sym_continue] = ACTIONS(1928),
    [anon_sym_goto] = ACTIONS(1928),
    [anon_sym___try] = ACTIONS(1928),
    [anon_sym___leave] = ACTIONS(1928),
    [anon_sym_not] = ACTIONS(1928),
    [anon_sym_compl] = ACTIONS(1928),
    [anon_sym_DASH_DASH] = ACTIONS(1930),
    [anon_sym_PLUS_PLUS] = ACTIONS(1930),
    [anon_sym_sizeof] = ACTIONS(1928),
    [anon_sym___alignof__] = ACTIONS(1928),
    [anon_sym___alignof] = ACTIONS(1928),
    [anon_sym__alignof] = ACTIONS(1928),
    [anon_sym_alignof] = ACTIONS(1928),
    [anon_sym__Alignof] = ACTIONS(1928),
    [anon_sym_offsetof] = ACTIONS(1928),
    [anon_sym__Generic] = ACTIONS(1928),
    [anon_sym_asm] = ACTIONS(1928),
    [anon_sym___asm__] = ACTIONS(1928),
    [sym_number_literal] = ACTIONS(1930),
    [anon_sym_L_SQUOTE] = ACTIONS(1930),
    [anon_sym_u_SQUOTE] = ACTIONS(1930),
    [anon_sym_U_SQUOTE] = ACTIONS(1930),
    [anon_sym_u8_SQUOTE] = ACTIONS(1930),
    [anon_sym_SQUOTE] = ACTIONS(1930),
    [anon_sym_L_DQUOTE] = ACTIONS(1930),
    [anon_sym_u_DQUOTE] = ACTIONS(1930),
    [anon_sym_U_DQUOTE] = ACTIONS(1930),
    [anon_sym_u8_DQUOTE] = ACTIONS(1930),
    [anon_sym_DQUOTE] = ACTIONS(1930),
    [sym_true] = ACTIONS(1928),
    [sym_false] = ACTIONS(1928),
    [anon_sym_NULL] = ACTIONS(1928),
    [anon_sym_nullptr] = ACTIONS(1928),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1928),
    [anon_sym_decltype] = ACTIONS(1928),
    [sym_virtual] = ACTIONS(1928),
    [anon_sym_explicit] = ACTIONS(1928),
    [anon_sym_typename] = ACTIONS(1928),
    [anon_sym_template] = ACTIONS(1928),
    [anon_sym_operator] = ACTIONS(1928),
    [anon_sym_try] = ACTIONS(1928),
    [anon_sym_delete] = ACTIONS(1928),
    [anon_sym_throw] = ACTIONS(1928),
    [anon_sym_namespace] = ACTIONS(1928),
    [anon_sym_using] = ACTIONS(1928),
    [anon_sym_static_assert] = ACTIONS(1928),
    [anon_sym_concept] = ACTIONS(1928),
    [anon_sym_co_return] = ACTIONS(1928),
    [anon_sym_co_yield] = ACTIONS(1928),
    [anon_sym_R_DQUOTE] = ACTIONS(1930),
    [anon_sym_LR_DQUOTE] = ACTIONS(1930),
    [anon_sym_uR_DQUOTE] = ACTIONS(1930),
    [anon_sym_UR_DQUOTE] = ACTIONS(1930),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1930),
    [anon_sym_co_await] = ACTIONS(1928),
    [anon_sym_new] = ACTIONS(1928),
    [anon_sym_requires] = ACTIONS(1928),
    [sym_this] = ACTIONS(1928),
    [anon_sym___launch_bounds__] = ACTIONS(1928),
  },
  [312] = {
    [sym_else_clause] = STATE(352),
    [sym_identifier] = ACTIONS(1928),
    [aux_sym_preproc_include_token1] = ACTIONS(1928),
    [aux_sym_preproc_def_token1] = ACTIONS(1928),
    [aux_sym_preproc_if_token1] = ACTIONS(1928),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1928),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1928),
    [sym_preproc_directive] = ACTIONS(1928),
    [anon_sym_LPAREN2] = ACTIONS(1930),
    [anon_sym_BANG] = ACTIONS(1930),
    [anon_sym_TILDE] = ACTIONS(1930),
    [anon_sym_DASH] = ACTIONS(1928),
    [anon_sym_PLUS] = ACTIONS(1928),
    [anon_sym_STAR] = ACTIONS(1930),
    [anon_sym_AMP_AMP] = ACTIONS(1930),
    [anon_sym_AMP] = ACTIONS(1928),
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym___extension__] = ACTIONS(1928),
    [anon_sym_typedef] = ACTIONS(1928),
    [anon_sym___device__] = ACTIONS(1928),
    [anon_sym___host__] = ACTIONS(1928),
    [anon_sym___global__] = ACTIONS(1928),
    [anon_sym___forceinline__] = ACTIONS(1928),
    [anon_sym___noinline__] = ACTIONS(1928),
    [anon_sym_extern] = ACTIONS(1928),
    [anon_sym___attribute__] = ACTIONS(1928),
    [anon_sym_COLON_COLON] = ACTIONS(1930),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1930),
    [anon_sym___declspec] = ACTIONS(1928),
    [anon_sym___based] = ACTIONS(1928),
    [anon_sym___cdecl] = ACTIONS(1928),
    [anon_sym___clrcall] = ACTIONS(1928),
    [anon_sym___stdcall] = ACTIONS(1928),
    [anon_sym___fastcall] = ACTIONS(1928),
    [anon_sym___thiscall] = ACTIONS(1928),
    [anon_sym___vectorcall] = ACTIONS(1928),
    [anon_sym_LBRACE] = ACTIONS(1930),
    [anon_sym_RBRACE] = ACTIONS(1930),
    [anon_sym_signed] = ACTIONS(1928),
    [anon_sym_unsigned] = ACTIONS(1928),
    [anon_sym_long] = ACTIONS(1928),
    [anon_sym_short] = ACTIONS(1928),
    [anon_sym_LBRACK] = ACTIONS(1928),
    [anon_sym_static] = ACTIONS(1928),
    [anon_sym_register] = ACTIONS(1928),
    [anon_sym_inline] = ACTIONS(1928),
    [anon_sym___inline] = ACTIONS(1928),
    [anon_sym___inline__] = ACTIONS(1928),
    [anon_sym___forceinline] = ACTIONS(1928),
    [anon_sym_thread_local] = ACTIONS(1928),
    [anon_sym___thread] = ACTIONS(1928),
    [anon_sym_const] = ACTIONS(1928),
    [anon_sym_constexpr] = ACTIONS(1928),
    [anon_sym_volatile] = ACTIONS(1928),
    [anon_sym_restrict] = ACTIONS(1928),
    [anon_sym___restrict__] = ACTIONS(1928),
    [anon_sym__Atomic] = ACTIONS(1928),
    [anon_sym__Noreturn] = ACTIONS(1928),
    [anon_sym_noreturn] = ACTIONS(1928),
    [anon_sym_mutable] = ACTIONS(1928),
    [anon_sym_constinit] = ACTIONS(1928),
    [anon_sym_consteval] = ACTIONS(1928),
    [anon_sym___shared__] = ACTIONS(1928),
    [anon_sym___local__] = ACTIONS(1928),
    [anon_sym___constant__] = ACTIONS(1928),
    [anon_sym___managed__] = ACTIONS(1928),
    [anon_sym___grid_constant__] = ACTIONS(1928),
    [anon_sym_alignas] = ACTIONS(1928),
    [anon_sym__Alignas] = ACTIONS(1928),
    [sym_primitive_type] = ACTIONS(1928),
    [anon_sym_enum] = ACTIONS(1928),
    [anon_sym_class] = ACTIONS(1928),
    [anon_sym_struct] = ACTIONS(1928),
    [anon_sym_union] = ACTIONS(1928),
    [anon_sym_if] = ACTIONS(1928),
    [anon_sym_else] = ACTIONS(2556),
    [anon_sym_switch] = ACTIONS(1928),
    [anon_sym_case] = ACTIONS(1928),
    [anon_sym_default] = ACTIONS(1928),
    [anon_sym_while] = ACTIONS(1928),
    [anon_sym_do] = ACTIONS(1928),
    [anon_sym_for] = ACTIONS(1928),
    [anon_sym_return] = ACTIONS(1928),
    [anon_sym_break] = ACTIONS(1928),
    [anon_sym_continue] = ACTIONS(1928),
    [anon_sym_goto] = ACTIONS(1928),
    [anon_sym___try] = ACTIONS(1928),
    [anon_sym___leave] = ACTIONS(1928),
    [anon_sym_not] = ACTIONS(1928),
    [anon_sym_compl] = ACTIONS(1928),
    [anon_sym_DASH_DASH] = ACTIONS(1930),
    [anon_sym_PLUS_PLUS] = ACTIONS(1930),
    [anon_sym_sizeof] = ACTIONS(1928),
    [anon_sym___alignof__] = ACTIONS(1928),
    [anon_sym___alignof] = ACTIONS(1928),
    [anon_sym__alignof] = ACTIONS(1928),
    [anon_sym_alignof] = ACTIONS(1928),
    [anon_sym__Alignof] = ACTIONS(1928),
    [anon_sym_offsetof] = ACTIONS(1928),
    [anon_sym__Generic] = ACTIONS(1928),
    [anon_sym_asm] = ACTIONS(1928),
    [anon_sym___asm__] = ACTIONS(1928),
    [sym_number_literal] = ACTIONS(1930),
    [anon_sym_L_SQUOTE] = ACTIONS(1930),
    [anon_sym_u_SQUOTE] = ACTIONS(1930),
    [anon_sym_U_SQUOTE] = ACTIONS(1930),
    [anon_sym_u8_SQUOTE] = ACTIONS(1930),
    [anon_sym_SQUOTE] = ACTIONS(1930),
    [anon_sym_L_DQUOTE] = ACTIONS(1930),
    [anon_sym_u_DQUOTE] = ACTIONS(1930),
    [anon_sym_U_DQUOTE] = ACTIONS(1930),
    [anon_sym_u8_DQUOTE] = ACTIONS(1930),
    [anon_sym_DQUOTE] = ACTIONS(1930),
    [sym_true] = ACTIONS(1928),
    [sym_false] = ACTIONS(1928),
    [anon_sym_NULL] = ACTIONS(1928),
    [anon_sym_nullptr] = ACTIONS(1928),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1928),
    [anon_sym_decltype] = ACTIONS(1928),
    [sym_virtual] = ACTIONS(1928),
    [anon_sym_explicit] = ACTIONS(1928),
    [anon_sym_typename] = ACTIONS(1928),
    [anon_sym_template] = ACTIONS(1928),
    [anon_sym_operator] = ACTIONS(1928),
    [anon_sym_try] = ACTIONS(1928),
    [anon_sym_delete] = ACTIONS(1928),
    [anon_sym_throw] = ACTIONS(1928),
    [anon_sym_namespace] = ACTIONS(1928),
    [anon_sym_using] = ACTIONS(1928),
    [anon_sym_static_assert] = ACTIONS(1928),
    [anon_sym_concept] = ACTIONS(1928),
    [anon_sym_co_return] = ACTIONS(1928),
    [anon_sym_co_yield] = ACTIONS(1928),
    [anon_sym_R_DQUOTE] = ACTIONS(1930),
    [anon_sym_LR_DQUOTE] = ACTIONS(1930),
    [anon_sym_uR_DQUOTE] = ACTIONS(1930),
    [anon_sym_UR_DQUOTE] = ACTIONS(1930),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1930),
    [anon_sym_co_await] = ACTIONS(1928),
    [anon_sym_new] = ACTIONS(1928),
    [anon_sym_requires] = ACTIONS(1928),
    [sym_this] = ACTIONS(1928),
    [anon_sym___launch_bounds__] = ACTIONS(1928),
  },
  [313] = {
    [sym_identifier] = ACTIONS(1897),
    [aux_sym_preproc_include_token1] = ACTIONS(1897),
    [aux_sym_preproc_def_token1] = ACTIONS(1897),
    [aux_sym_preproc_if_token1] = ACTIONS(1897),
    [aux_sym_preproc_if_token2] = ACTIONS(1897),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1897),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1897),
    [sym_preproc_directive] = ACTIONS(1897),
    [anon_sym_LPAREN2] = ACTIONS(1895),
    [anon_sym_BANG] = ACTIONS(1895),
    [anon_sym_TILDE] = ACTIONS(1895),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_AMP_AMP] = ACTIONS(1895),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym_SEMI] = ACTIONS(1895),
    [anon_sym___extension__] = ACTIONS(1897),
    [anon_sym_typedef] = ACTIONS(1897),
    [anon_sym___device__] = ACTIONS(1897),
    [anon_sym___host__] = ACTIONS(1897),
    [anon_sym___global__] = ACTIONS(1897),
    [anon_sym___forceinline__] = ACTIONS(1897),
    [anon_sym___noinline__] = ACTIONS(1897),
    [anon_sym_extern] = ACTIONS(1897),
    [anon_sym___attribute__] = ACTIONS(1897),
    [anon_sym_COLON_COLON] = ACTIONS(1895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1895),
    [anon_sym___declspec] = ACTIONS(1897),
    [anon_sym___based] = ACTIONS(1897),
    [anon_sym___cdecl] = ACTIONS(1897),
    [anon_sym___clrcall] = ACTIONS(1897),
    [anon_sym___stdcall] = ACTIONS(1897),
    [anon_sym___fastcall] = ACTIONS(1897),
    [anon_sym___thiscall] = ACTIONS(1897),
    [anon_sym___vectorcall] = ACTIONS(1897),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_signed] = ACTIONS(1897),
    [anon_sym_unsigned] = ACTIONS(1897),
    [anon_sym_long] = ACTIONS(1897),
    [anon_sym_short] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1897),
    [anon_sym_static] = ACTIONS(1897),
    [anon_sym_register] = ACTIONS(1897),
    [anon_sym_inline] = ACTIONS(1897),
    [anon_sym___inline] = ACTIONS(1897),
    [anon_sym___inline__] = ACTIONS(1897),
    [anon_sym___forceinline] = ACTIONS(1897),
    [anon_sym_thread_local] = ACTIONS(1897),
    [anon_sym___thread] = ACTIONS(1897),
    [anon_sym_const] = ACTIONS(1897),
    [anon_sym_constexpr] = ACTIONS(1897),
    [anon_sym_volatile] = ACTIONS(1897),
    [anon_sym_restrict] = ACTIONS(1897),
    [anon_sym___restrict__] = ACTIONS(1897),
    [anon_sym__Atomic] = ACTIONS(1897),
    [anon_sym__Noreturn] = ACTIONS(1897),
    [anon_sym_noreturn] = ACTIONS(1897),
    [anon_sym_mutable] = ACTIONS(1897),
    [anon_sym_constinit] = ACTIONS(1897),
    [anon_sym_consteval] = ACTIONS(1897),
    [anon_sym___shared__] = ACTIONS(1897),
    [anon_sym___local__] = ACTIONS(1897),
    [anon_sym___constant__] = ACTIONS(1897),
    [anon_sym___managed__] = ACTIONS(1897),
    [anon_sym___grid_constant__] = ACTIONS(1897),
    [anon_sym_alignas] = ACTIONS(1897),
    [anon_sym__Alignas] = ACTIONS(1897),
    [sym_primitive_type] = ACTIONS(1897),
    [anon_sym_enum] = ACTIONS(1897),
    [anon_sym_class] = ACTIONS(1897),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1897),
    [anon_sym_if] = ACTIONS(1897),
    [anon_sym_else] = ACTIONS(1897),
    [anon_sym_switch] = ACTIONS(1897),
    [anon_sym_case] = ACTIONS(1897),
    [anon_sym_default] = ACTIONS(1897),
    [anon_sym_while] = ACTIONS(1897),
    [anon_sym_do] = ACTIONS(1897),
    [anon_sym_for] = ACTIONS(1897),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_continue] = ACTIONS(1897),
    [anon_sym_goto] = ACTIONS(1897),
    [anon_sym___try] = ACTIONS(1897),
    [anon_sym___leave] = ACTIONS(1897),
    [anon_sym_not] = ACTIONS(1897),
    [anon_sym_compl] = ACTIONS(1897),
    [anon_sym_DASH_DASH] = ACTIONS(1895),
    [anon_sym_PLUS_PLUS] = ACTIONS(1895),
    [anon_sym_sizeof] = ACTIONS(1897),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1897),
    [anon_sym__Generic] = ACTIONS(1897),
    [anon_sym_asm] = ACTIONS(1897),
    [anon_sym___asm__] = ACTIONS(1897),
    [sym_number_literal] = ACTIONS(1895),
    [anon_sym_L_SQUOTE] = ACTIONS(1895),
    [anon_sym_u_SQUOTE] = ACTIONS(1895),
    [anon_sym_U_SQUOTE] = ACTIONS(1895),
    [anon_sym_u8_SQUOTE] = ACTIONS(1895),
    [anon_sym_SQUOTE] = ACTIONS(1895),
    [anon_sym_L_DQUOTE] = ACTIONS(1895),
    [anon_sym_u_DQUOTE] = ACTIONS(1895),
    [anon_sym_U_DQUOTE] = ACTIONS(1895),
    [anon_sym_u8_DQUOTE] = ACTIONS(1895),
    [anon_sym_DQUOTE] = ACTIONS(1895),
    [sym_true] = ACTIONS(1897),
    [sym_false] = ACTIONS(1897),
    [anon_sym_NULL] = ACTIONS(1897),
    [anon_sym_nullptr] = ACTIONS(1897),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1897),
    [anon_sym_decltype] = ACTIONS(1897),
    [sym_virtual] = ACTIONS(1897),
    [anon_sym_explicit] = ACTIONS(1897),
    [anon_sym_typename] = ACTIONS(1897),
    [anon_sym_template] = ACTIONS(1897),
    [anon_sym_operator] = ACTIONS(1897),
    [anon_sym_try] = ACTIONS(1897),
    [anon_sym_delete] = ACTIONS(1897),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_namespace] = ACTIONS(1897),
    [anon_sym_using] = ACTIONS(1897),
    [anon_sym_static_assert] = ACTIONS(1897),
    [anon_sym_concept] = ACTIONS(1897),
    [anon_sym_co_return] = ACTIONS(1897),
    [anon_sym_co_yield] = ACTIONS(1897),
    [anon_sym_catch] = ACTIONS(1897),
    [anon_sym_R_DQUOTE] = ACTIONS(1895),
    [anon_sym_LR_DQUOTE] = ACTIONS(1895),
    [anon_sym_uR_DQUOTE] = ACTIONS(1895),
    [anon_sym_UR_DQUOTE] = ACTIONS(1895),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1895),
    [anon_sym_co_await] = ACTIONS(1897),
    [anon_sym_new] = ACTIONS(1897),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1897),
    [anon_sym___launch_bounds__] = ACTIONS(1897),
  },
  [314] = {
    [sym_identifier] = ACTIONS(1901),
    [aux_sym_preproc_include_token1] = ACTIONS(1901),
    [aux_sym_preproc_def_token1] = ACTIONS(1901),
    [aux_sym_preproc_if_token1] = ACTIONS(1901),
    [aux_sym_preproc_if_token2] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1901),
    [sym_preproc_directive] = ACTIONS(1901),
    [anon_sym_LPAREN2] = ACTIONS(1899),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_DASH] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1901),
    [anon_sym_STAR] = ACTIONS(1899),
    [anon_sym_AMP_AMP] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1901),
    [anon_sym_SEMI] = ACTIONS(1899),
    [anon_sym___extension__] = ACTIONS(1901),
    [anon_sym_typedef] = ACTIONS(1901),
    [anon_sym___device__] = ACTIONS(1901),
    [anon_sym___host__] = ACTIONS(1901),
    [anon_sym___global__] = ACTIONS(1901),
    [anon_sym___forceinline__] = ACTIONS(1901),
    [anon_sym___noinline__] = ACTIONS(1901),
    [anon_sym_extern] = ACTIONS(1901),
    [anon_sym___attribute__] = ACTIONS(1901),
    [anon_sym_COLON_COLON] = ACTIONS(1899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1899),
    [anon_sym___declspec] = ACTIONS(1901),
    [anon_sym___based] = ACTIONS(1901),
    [anon_sym___cdecl] = ACTIONS(1901),
    [anon_sym___clrcall] = ACTIONS(1901),
    [anon_sym___stdcall] = ACTIONS(1901),
    [anon_sym___fastcall] = ACTIONS(1901),
    [anon_sym___thiscall] = ACTIONS(1901),
    [anon_sym___vectorcall] = ACTIONS(1901),
    [anon_sym_LBRACE] = ACTIONS(1899),
    [anon_sym_signed] = ACTIONS(1901),
    [anon_sym_unsigned] = ACTIONS(1901),
    [anon_sym_long] = ACTIONS(1901),
    [anon_sym_short] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1901),
    [anon_sym_static] = ACTIONS(1901),
    [anon_sym_register] = ACTIONS(1901),
    [anon_sym_inline] = ACTIONS(1901),
    [anon_sym___inline] = ACTIONS(1901),
    [anon_sym___inline__] = ACTIONS(1901),
    [anon_sym___forceinline] = ACTIONS(1901),
    [anon_sym_thread_local] = ACTIONS(1901),
    [anon_sym___thread] = ACTIONS(1901),
    [anon_sym_const] = ACTIONS(1901),
    [anon_sym_constexpr] = ACTIONS(1901),
    [anon_sym_volatile] = ACTIONS(1901),
    [anon_sym_restrict] = ACTIONS(1901),
    [anon_sym___restrict__] = ACTIONS(1901),
    [anon_sym__Atomic] = ACTIONS(1901),
    [anon_sym__Noreturn] = ACTIONS(1901),
    [anon_sym_noreturn] = ACTIONS(1901),
    [anon_sym_mutable] = ACTIONS(1901),
    [anon_sym_constinit] = ACTIONS(1901),
    [anon_sym_consteval] = ACTIONS(1901),
    [anon_sym___shared__] = ACTIONS(1901),
    [anon_sym___local__] = ACTIONS(1901),
    [anon_sym___constant__] = ACTIONS(1901),
    [anon_sym___managed__] = ACTIONS(1901),
    [anon_sym___grid_constant__] = ACTIONS(1901),
    [anon_sym_alignas] = ACTIONS(1901),
    [anon_sym__Alignas] = ACTIONS(1901),
    [sym_primitive_type] = ACTIONS(1901),
    [anon_sym_enum] = ACTIONS(1901),
    [anon_sym_class] = ACTIONS(1901),
    [anon_sym_struct] = ACTIONS(1901),
    [anon_sym_union] = ACTIONS(1901),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_else] = ACTIONS(1901),
    [anon_sym_switch] = ACTIONS(1901),
    [anon_sym_case] = ACTIONS(1901),
    [anon_sym_default] = ACTIONS(1901),
    [anon_sym_while] = ACTIONS(1901),
    [anon_sym_do] = ACTIONS(1901),
    [anon_sym_for] = ACTIONS(1901),
    [anon_sym_return] = ACTIONS(1901),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_continue] = ACTIONS(1901),
    [anon_sym_goto] = ACTIONS(1901),
    [anon_sym___try] = ACTIONS(1901),
    [anon_sym___leave] = ACTIONS(1901),
    [anon_sym_not] = ACTIONS(1901),
    [anon_sym_compl] = ACTIONS(1901),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_sizeof] = ACTIONS(1901),
    [anon_sym___alignof__] = ACTIONS(1901),
    [anon_sym___alignof] = ACTIONS(1901),
    [anon_sym__alignof] = ACTIONS(1901),
    [anon_sym_alignof] = ACTIONS(1901),
    [anon_sym__Alignof] = ACTIONS(1901),
    [anon_sym_offsetof] = ACTIONS(1901),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1901),
    [anon_sym___asm__] = ACTIONS(1901),
    [sym_number_literal] = ACTIONS(1899),
    [anon_sym_L_SQUOTE] = ACTIONS(1899),
    [anon_sym_u_SQUOTE] = ACTIONS(1899),
    [anon_sym_U_SQUOTE] = ACTIONS(1899),
    [anon_sym_u8_SQUOTE] = ACTIONS(1899),
    [anon_sym_SQUOTE] = ACTIONS(1899),
    [anon_sym_L_DQUOTE] = ACTIONS(1899),
    [anon_sym_u_DQUOTE] = ACTIONS(1899),
    [anon_sym_U_DQUOTE] = ACTIONS(1899),
    [anon_sym_u8_DQUOTE] = ACTIONS(1899),
    [anon_sym_DQUOTE] = ACTIONS(1899),
    [sym_true] = ACTIONS(1901),
    [sym_false] = ACTIONS(1901),
    [anon_sym_NULL] = ACTIONS(1901),
    [anon_sym_nullptr] = ACTIONS(1901),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1901),
    [anon_sym_decltype] = ACTIONS(1901),
    [sym_virtual] = ACTIONS(1901),
    [anon_sym_explicit] = ACTIONS(1901),
    [anon_sym_typename] = ACTIONS(1901),
    [anon_sym_template] = ACTIONS(1901),
    [anon_sym_operator] = ACTIONS(1901),
    [anon_sym_try] = ACTIONS(1901),
    [anon_sym_delete] = ACTIONS(1901),
    [anon_sym_throw] = ACTIONS(1901),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_using] = ACTIONS(1901),
    [anon_sym_static_assert] = ACTIONS(1901),
    [anon_sym_concept] = ACTIONS(1901),
    [anon_sym_co_return] = ACTIONS(1901),
    [anon_sym_co_yield] = ACTIONS(1901),
    [anon_sym_catch] = ACTIONS(1901),
    [anon_sym_R_DQUOTE] = ACTIONS(1899),
    [anon_sym_LR_DQUOTE] = ACTIONS(1899),
    [anon_sym_uR_DQUOTE] = ACTIONS(1899),
    [anon_sym_UR_DQUOTE] = ACTIONS(1899),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1899),
    [anon_sym_co_await] = ACTIONS(1901),
    [anon_sym_new] = ACTIONS(1901),
    [anon_sym_requires] = ACTIONS(1901),
    [sym_this] = ACTIONS(1901),
    [anon_sym___launch_bounds__] = ACTIONS(1901),
  },
  [315] = {
    [sym_else_clause] = STATE(361),
    [sym_identifier] = ACTIONS(1934),
    [aux_sym_preproc_include_token1] = ACTIONS(1934),
    [aux_sym_preproc_def_token1] = ACTIONS(1934),
    [aux_sym_preproc_if_token1] = ACTIONS(1934),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1934),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1934),
    [sym_preproc_directive] = ACTIONS(1934),
    [anon_sym_LPAREN2] = ACTIONS(1936),
    [anon_sym_BANG] = ACTIONS(1936),
    [anon_sym_TILDE] = ACTIONS(1936),
    [anon_sym_DASH] = ACTIONS(1934),
    [anon_sym_PLUS] = ACTIONS(1934),
    [anon_sym_STAR] = ACTIONS(1936),
    [anon_sym_AMP_AMP] = ACTIONS(1936),
    [anon_sym_AMP] = ACTIONS(1934),
    [anon_sym_SEMI] = ACTIONS(1936),
    [anon_sym___extension__] = ACTIONS(1934),
    [anon_sym_typedef] = ACTIONS(1934),
    [anon_sym___device__] = ACTIONS(1934),
    [anon_sym___host__] = ACTIONS(1934),
    [anon_sym___global__] = ACTIONS(1934),
    [anon_sym___forceinline__] = ACTIONS(1934),
    [anon_sym___noinline__] = ACTIONS(1934),
    [anon_sym_extern] = ACTIONS(1934),
    [anon_sym___attribute__] = ACTIONS(1934),
    [anon_sym_COLON_COLON] = ACTIONS(1936),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1936),
    [anon_sym___declspec] = ACTIONS(1934),
    [anon_sym___based] = ACTIONS(1934),
    [anon_sym___cdecl] = ACTIONS(1934),
    [anon_sym___clrcall] = ACTIONS(1934),
    [anon_sym___stdcall] = ACTIONS(1934),
    [anon_sym___fastcall] = ACTIONS(1934),
    [anon_sym___thiscall] = ACTIONS(1934),
    [anon_sym___vectorcall] = ACTIONS(1934),
    [anon_sym_LBRACE] = ACTIONS(1936),
    [anon_sym_RBRACE] = ACTIONS(1936),
    [anon_sym_signed] = ACTIONS(1934),
    [anon_sym_unsigned] = ACTIONS(1934),
    [anon_sym_long] = ACTIONS(1934),
    [anon_sym_short] = ACTIONS(1934),
    [anon_sym_LBRACK] = ACTIONS(1934),
    [anon_sym_static] = ACTIONS(1934),
    [anon_sym_register] = ACTIONS(1934),
    [anon_sym_inline] = ACTIONS(1934),
    [anon_sym___inline] = ACTIONS(1934),
    [anon_sym___inline__] = ACTIONS(1934),
    [anon_sym___forceinline] = ACTIONS(1934),
    [anon_sym_thread_local] = ACTIONS(1934),
    [anon_sym___thread] = ACTIONS(1934),
    [anon_sym_const] = ACTIONS(1934),
    [anon_sym_constexpr] = ACTIONS(1934),
    [anon_sym_volatile] = ACTIONS(1934),
    [anon_sym_restrict] = ACTIONS(1934),
    [anon_sym___restrict__] = ACTIONS(1934),
    [anon_sym__Atomic] = ACTIONS(1934),
    [anon_sym__Noreturn] = ACTIONS(1934),
    [anon_sym_noreturn] = ACTIONS(1934),
    [anon_sym_mutable] = ACTIONS(1934),
    [anon_sym_constinit] = ACTIONS(1934),
    [anon_sym_consteval] = ACTIONS(1934),
    [anon_sym___shared__] = ACTIONS(1934),
    [anon_sym___local__] = ACTIONS(1934),
    [anon_sym___constant__] = ACTIONS(1934),
    [anon_sym___managed__] = ACTIONS(1934),
    [anon_sym___grid_constant__] = ACTIONS(1934),
    [anon_sym_alignas] = ACTIONS(1934),
    [anon_sym__Alignas] = ACTIONS(1934),
    [sym_primitive_type] = ACTIONS(1934),
    [anon_sym_enum] = ACTIONS(1934),
    [anon_sym_class] = ACTIONS(1934),
    [anon_sym_struct] = ACTIONS(1934),
    [anon_sym_union] = ACTIONS(1934),
    [anon_sym_if] = ACTIONS(1934),
    [anon_sym_else] = ACTIONS(2556),
    [anon_sym_switch] = ACTIONS(1934),
    [anon_sym_case] = ACTIONS(1934),
    [anon_sym_default] = ACTIONS(1934),
    [anon_sym_while] = ACTIONS(1934),
    [anon_sym_do] = ACTIONS(1934),
    [anon_sym_for] = ACTIONS(1934),
    [anon_sym_return] = ACTIONS(1934),
    [anon_sym_break] = ACTIONS(1934),
    [anon_sym_continue] = ACTIONS(1934),
    [anon_sym_goto] = ACTIONS(1934),
    [anon_sym___try] = ACTIONS(1934),
    [anon_sym___leave] = ACTIONS(1934),
    [anon_sym_not] = ACTIONS(1934),
    [anon_sym_compl] = ACTIONS(1934),
    [anon_sym_DASH_DASH] = ACTIONS(1936),
    [anon_sym_PLUS_PLUS] = ACTIONS(1936),
    [anon_sym_sizeof] = ACTIONS(1934),
    [anon_sym___alignof__] = ACTIONS(1934),
    [anon_sym___alignof] = ACTIONS(1934),
    [anon_sym__alignof] = ACTIONS(1934),
    [anon_sym_alignof] = ACTIONS(1934),
    [anon_sym__Alignof] = ACTIONS(1934),
    [anon_sym_offsetof] = ACTIONS(1934),
    [anon_sym__Generic] = ACTIONS(1934),
    [anon_sym_asm] = ACTIONS(1934),
    [anon_sym___asm__] = ACTIONS(1934),
    [sym_number_literal] = ACTIONS(1936),
    [anon_sym_L_SQUOTE] = ACTIONS(1936),
    [anon_sym_u_SQUOTE] = ACTIONS(1936),
    [anon_sym_U_SQUOTE] = ACTIONS(1936),
    [anon_sym_u8_SQUOTE] = ACTIONS(1936),
    [anon_sym_SQUOTE] = ACTIONS(1936),
    [anon_sym_L_DQUOTE] = ACTIONS(1936),
    [anon_sym_u_DQUOTE] = ACTIONS(1936),
    [anon_sym_U_DQUOTE] = ACTIONS(1936),
    [anon_sym_u8_DQUOTE] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1936),
    [sym_true] = ACTIONS(1934),
    [sym_false] = ACTIONS(1934),
    [anon_sym_NULL] = ACTIONS(1934),
    [anon_sym_nullptr] = ACTIONS(1934),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1934),
    [anon_sym_decltype] = ACTIONS(1934),
    [sym_virtual] = ACTIONS(1934),
    [anon_sym_explicit] = ACTIONS(1934),
    [anon_sym_typename] = ACTIONS(1934),
    [anon_sym_template] = ACTIONS(1934),
    [anon_sym_operator] = ACTIONS(1934),
    [anon_sym_try] = ACTIONS(1934),
    [anon_sym_delete] = ACTIONS(1934),
    [anon_sym_throw] = ACTIONS(1934),
    [anon_sym_namespace] = ACTIONS(1934),
    [anon_sym_using] = ACTIONS(1934),
    [anon_sym_static_assert] = ACTIONS(1934),
    [anon_sym_concept] = ACTIONS(1934),
    [anon_sym_co_return] = ACTIONS(1934),
    [anon_sym_co_yield] = ACTIONS(1934),
    [anon_sym_R_DQUOTE] = ACTIONS(1936),
    [anon_sym_LR_DQUOTE] = ACTIONS(1936),
    [anon_sym_uR_DQUOTE] = ACTIONS(1936),
    [anon_sym_UR_DQUOTE] = ACTIONS(1936),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1936),
    [anon_sym_co_await] = ACTIONS(1934),
    [anon_sym_new] = ACTIONS(1934),
    [anon_sym_requires] = ACTIONS(1934),
    [sym_this] = ACTIONS(1934),
    [anon_sym___launch_bounds__] = ACTIONS(1934),
  },
  [316] = {
    [sym_identifier] = ACTIONS(1924),
    [aux_sym_preproc_include_token1] = ACTIONS(1924),
    [aux_sym_preproc_def_token1] = ACTIONS(1924),
    [aux_sym_preproc_if_token1] = ACTIONS(1924),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1924),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1924),
    [sym_preproc_directive] = ACTIONS(1924),
    [anon_sym_LPAREN2] = ACTIONS(1926),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1924),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_STAR] = ACTIONS(1926),
    [anon_sym_AMP_AMP] = ACTIONS(1926),
    [anon_sym_AMP] = ACTIONS(1924),
    [anon_sym_SEMI] = ACTIONS(1926),
    [anon_sym___extension__] = ACTIONS(1924),
    [anon_sym_typedef] = ACTIONS(1924),
    [anon_sym___device__] = ACTIONS(1924),
    [anon_sym___host__] = ACTIONS(1924),
    [anon_sym___global__] = ACTIONS(1924),
    [anon_sym___forceinline__] = ACTIONS(1924),
    [anon_sym___noinline__] = ACTIONS(1924),
    [anon_sym_extern] = ACTIONS(1924),
    [anon_sym___attribute__] = ACTIONS(1924),
    [anon_sym_COLON_COLON] = ACTIONS(1926),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1926),
    [anon_sym___declspec] = ACTIONS(1924),
    [anon_sym___based] = ACTIONS(1924),
    [anon_sym___cdecl] = ACTIONS(1924),
    [anon_sym___clrcall] = ACTIONS(1924),
    [anon_sym___stdcall] = ACTIONS(1924),
    [anon_sym___fastcall] = ACTIONS(1924),
    [anon_sym___thiscall] = ACTIONS(1924),
    [anon_sym___vectorcall] = ACTIONS(1924),
    [anon_sym_LBRACE] = ACTIONS(1926),
    [anon_sym_RBRACE] = ACTIONS(1926),
    [anon_sym_signed] = ACTIONS(1924),
    [anon_sym_unsigned] = ACTIONS(1924),
    [anon_sym_long] = ACTIONS(1924),
    [anon_sym_short] = ACTIONS(1924),
    [anon_sym_LBRACK] = ACTIONS(1924),
    [anon_sym_static] = ACTIONS(1924),
    [anon_sym_register] = ACTIONS(1924),
    [anon_sym_inline] = ACTIONS(1924),
    [anon_sym___inline] = ACTIONS(1924),
    [anon_sym___inline__] = ACTIONS(1924),
    [anon_sym___forceinline] = ACTIONS(1924),
    [anon_sym_thread_local] = ACTIONS(1924),
    [anon_sym___thread] = ACTIONS(1924),
    [anon_sym_const] = ACTIONS(1924),
    [anon_sym_constexpr] = ACTIONS(1924),
    [anon_sym_volatile] = ACTIONS(1924),
    [anon_sym_restrict] = ACTIONS(1924),
    [anon_sym___restrict__] = ACTIONS(1924),
    [anon_sym__Atomic] = ACTIONS(1924),
    [anon_sym__Noreturn] = ACTIONS(1924),
    [anon_sym_noreturn] = ACTIONS(1924),
    [anon_sym_mutable] = ACTIONS(1924),
    [anon_sym_constinit] = ACTIONS(1924),
    [anon_sym_consteval] = ACTIONS(1924),
    [anon_sym___shared__] = ACTIONS(1924),
    [anon_sym___local__] = ACTIONS(1924),
    [anon_sym___constant__] = ACTIONS(1924),
    [anon_sym___managed__] = ACTIONS(1924),
    [anon_sym___grid_constant__] = ACTIONS(1924),
    [anon_sym_alignas] = ACTIONS(1924),
    [anon_sym__Alignas] = ACTIONS(1924),
    [sym_primitive_type] = ACTIONS(1924),
    [anon_sym_enum] = ACTIONS(1924),
    [anon_sym_class] = ACTIONS(1924),
    [anon_sym_struct] = ACTIONS(1924),
    [anon_sym_union] = ACTIONS(1924),
    [anon_sym_if] = ACTIONS(1924),
    [anon_sym_else] = ACTIONS(1924),
    [anon_sym_switch] = ACTIONS(1924),
    [anon_sym_case] = ACTIONS(1924),
    [anon_sym_default] = ACTIONS(1924),
    [anon_sym_while] = ACTIONS(1924),
    [anon_sym_do] = ACTIONS(1924),
    [anon_sym_for] = ACTIONS(1924),
    [anon_sym_return] = ACTIONS(1924),
    [anon_sym_break] = ACTIONS(1924),
    [anon_sym_continue] = ACTIONS(1924),
    [anon_sym_goto] = ACTIONS(1924),
    [anon_sym___try] = ACTIONS(1924),
    [anon_sym___leave] = ACTIONS(1924),
    [anon_sym_not] = ACTIONS(1924),
    [anon_sym_compl] = ACTIONS(1924),
    [anon_sym_DASH_DASH] = ACTIONS(1926),
    [anon_sym_PLUS_PLUS] = ACTIONS(1926),
    [anon_sym_sizeof] = ACTIONS(1924),
    [anon_sym___alignof__] = ACTIONS(1924),
    [anon_sym___alignof] = ACTIONS(1924),
    [anon_sym__alignof] = ACTIONS(1924),
    [anon_sym_alignof] = ACTIONS(1924),
    [anon_sym__Alignof] = ACTIONS(1924),
    [anon_sym_offsetof] = ACTIONS(1924),
    [anon_sym__Generic] = ACTIONS(1924),
    [anon_sym_asm] = ACTIONS(1924),
    [anon_sym___asm__] = ACTIONS(1924),
    [sym_number_literal] = ACTIONS(1926),
    [anon_sym_L_SQUOTE] = ACTIONS(1926),
    [anon_sym_u_SQUOTE] = ACTIONS(1926),
    [anon_sym_U_SQUOTE] = ACTIONS(1926),
    [anon_sym_u8_SQUOTE] = ACTIONS(1926),
    [anon_sym_SQUOTE] = ACTIONS(1926),
    [anon_sym_L_DQUOTE] = ACTIONS(1926),
    [anon_sym_u_DQUOTE] = ACTIONS(1926),
    [anon_sym_U_DQUOTE] = ACTIONS(1926),
    [anon_sym_u8_DQUOTE] = ACTIONS(1926),
    [anon_sym_DQUOTE] = ACTIONS(1926),
    [sym_true] = ACTIONS(1924),
    [sym_false] = ACTIONS(1924),
    [anon_sym_NULL] = ACTIONS(1924),
    [anon_sym_nullptr] = ACTIONS(1924),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1924),
    [anon_sym_decltype] = ACTIONS(1924),
    [sym_virtual] = ACTIONS(1924),
    [anon_sym_explicit] = ACTIONS(1924),
    [anon_sym_typename] = ACTIONS(1924),
    [anon_sym_template] = ACTIONS(1924),
    [anon_sym_operator] = ACTIONS(1924),
    [anon_sym_try] = ACTIONS(1924),
    [anon_sym_delete] = ACTIONS(1924),
    [anon_sym_throw] = ACTIONS(1924),
    [anon_sym_namespace] = ACTIONS(1924),
    [anon_sym_using] = ACTIONS(1924),
    [anon_sym_static_assert] = ACTIONS(1924),
    [anon_sym_concept] = ACTIONS(1924),
    [anon_sym_co_return] = ACTIONS(1924),
    [anon_sym_co_yield] = ACTIONS(1924),
    [anon_sym_catch] = ACTIONS(1924),
    [anon_sym_R_DQUOTE] = ACTIONS(1926),
    [anon_sym_LR_DQUOTE] = ACTIONS(1926),
    [anon_sym_uR_DQUOTE] = ACTIONS(1926),
    [anon_sym_UR_DQUOTE] = ACTIONS(1926),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1926),
    [anon_sym_co_await] = ACTIONS(1924),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1924),
    [anon_sym___launch_bounds__] = ACTIONS(1924),
  },
  [317] = {
    [sym_expression] = STATE(2499),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_initializer_list] = STATE(2690),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2510),
    [anon_sym_RPAREN] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_BANG] = ACTIONS(2560),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2508),
    [anon_sym_STAR] = ACTIONS(2508),
    [anon_sym_SLASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_PIPE] = ACTIONS(2508),
    [anon_sym_CARET] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_EQ_EQ] = ACTIONS(2510),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_GT] = ACTIONS(2508),
    [anon_sym_GT_EQ] = ACTIONS(2510),
    [anon_sym_LT_EQ] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_LT_LT] = ACTIONS(2508),
    [anon_sym_GT_GT] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_RBRACE] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_RBRACK] = ACTIONS(2510),
    [anon_sym_EQ] = ACTIONS(2508),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_STAR_EQ] = ACTIONS(2510),
    [anon_sym_SLASH_EQ] = ACTIONS(2510),
    [anon_sym_PERCENT_EQ] = ACTIONS(2510),
    [anon_sym_PLUS_EQ] = ACTIONS(2510),
    [anon_sym_DASH_EQ] = ACTIONS(2510),
    [anon_sym_LT_LT_EQ] = ACTIONS(2510),
    [anon_sym_GT_GT_EQ] = ACTIONS(2510),
    [anon_sym_AMP_EQ] = ACTIONS(2510),
    [anon_sym_CARET_EQ] = ACTIONS(2510),
    [anon_sym_PIPE_EQ] = ACTIONS(2510),
    [anon_sym_and_eq] = ACTIONS(2508),
    [anon_sym_or_eq] = ACTIONS(2508),
    [anon_sym_xor_eq] = ACTIONS(2508),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_LT_EQ_GT] = ACTIONS(2510),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_bitor] = ACTIONS(2508),
    [anon_sym_xor] = ACTIONS(2508),
    [anon_sym_bitand] = ACTIONS(2508),
    [anon_sym_not_eq] = ACTIONS(2508),
    [anon_sym_DASH_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_PLUS] = ACTIONS(2510),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [anon_sym_DOT] = ACTIONS(2508),
    [anon_sym_DOT_STAR] = ACTIONS(2510),
    [anon_sym_DASH_GT] = ACTIONS(2510),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(2510),
  },
  [318] = {
    [sym_else_clause] = STATE(427),
    [sym_identifier] = ACTIONS(1928),
    [aux_sym_preproc_include_token1] = ACTIONS(1928),
    [aux_sym_preproc_def_token1] = ACTIONS(1928),
    [aux_sym_preproc_if_token1] = ACTIONS(1928),
    [aux_sym_preproc_if_token2] = ACTIONS(1928),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1928),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1928),
    [sym_preproc_directive] = ACTIONS(1928),
    [anon_sym_LPAREN2] = ACTIONS(1930),
    [anon_sym_BANG] = ACTIONS(1930),
    [anon_sym_TILDE] = ACTIONS(1930),
    [anon_sym_DASH] = ACTIONS(1928),
    [anon_sym_PLUS] = ACTIONS(1928),
    [anon_sym_STAR] = ACTIONS(1930),
    [anon_sym_AMP_AMP] = ACTIONS(1930),
    [anon_sym_AMP] = ACTIONS(1928),
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym___extension__] = ACTIONS(1928),
    [anon_sym_typedef] = ACTIONS(1928),
    [anon_sym___device__] = ACTIONS(1928),
    [anon_sym___host__] = ACTIONS(1928),
    [anon_sym___global__] = ACTIONS(1928),
    [anon_sym___forceinline__] = ACTIONS(1928),
    [anon_sym___noinline__] = ACTIONS(1928),
    [anon_sym_extern] = ACTIONS(1928),
    [anon_sym___attribute__] = ACTIONS(1928),
    [anon_sym_COLON_COLON] = ACTIONS(1930),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1930),
    [anon_sym___declspec] = ACTIONS(1928),
    [anon_sym___based] = ACTIONS(1928),
    [anon_sym___cdecl] = ACTIONS(1928),
    [anon_sym___clrcall] = ACTIONS(1928),
    [anon_sym___stdcall] = ACTIONS(1928),
    [anon_sym___fastcall] = ACTIONS(1928),
    [anon_sym___thiscall] = ACTIONS(1928),
    [anon_sym___vectorcall] = ACTIONS(1928),
    [anon_sym_LBRACE] = ACTIONS(1930),
    [anon_sym_signed] = ACTIONS(1928),
    [anon_sym_unsigned] = ACTIONS(1928),
    [anon_sym_long] = ACTIONS(1928),
    [anon_sym_short] = ACTIONS(1928),
    [anon_sym_LBRACK] = ACTIONS(1928),
    [anon_sym_static] = ACTIONS(1928),
    [anon_sym_register] = ACTIONS(1928),
    [anon_sym_inline] = ACTIONS(1928),
    [anon_sym___inline] = ACTIONS(1928),
    [anon_sym___inline__] = ACTIONS(1928),
    [anon_sym___forceinline] = ACTIONS(1928),
    [anon_sym_thread_local] = ACTIONS(1928),
    [anon_sym___thread] = ACTIONS(1928),
    [anon_sym_const] = ACTIONS(1928),
    [anon_sym_constexpr] = ACTIONS(1928),
    [anon_sym_volatile] = ACTIONS(1928),
    [anon_sym_restrict] = ACTIONS(1928),
    [anon_sym___restrict__] = ACTIONS(1928),
    [anon_sym__Atomic] = ACTIONS(1928),
    [anon_sym__Noreturn] = ACTIONS(1928),
    [anon_sym_noreturn] = ACTIONS(1928),
    [anon_sym_mutable] = ACTIONS(1928),
    [anon_sym_constinit] = ACTIONS(1928),
    [anon_sym_consteval] = ACTIONS(1928),
    [anon_sym___shared__] = ACTIONS(1928),
    [anon_sym___local__] = ACTIONS(1928),
    [anon_sym___constant__] = ACTIONS(1928),
    [anon_sym___managed__] = ACTIONS(1928),
    [anon_sym___grid_constant__] = ACTIONS(1928),
    [anon_sym_alignas] = ACTIONS(1928),
    [anon_sym__Alignas] = ACTIONS(1928),
    [sym_primitive_type] = ACTIONS(1928),
    [anon_sym_enum] = ACTIONS(1928),
    [anon_sym_class] = ACTIONS(1928),
    [anon_sym_struct] = ACTIONS(1928),
    [anon_sym_union] = ACTIONS(1928),
    [anon_sym_if] = ACTIONS(1928),
    [anon_sym_else] = ACTIONS(2582),
    [anon_sym_switch] = ACTIONS(1928),
    [anon_sym_case] = ACTIONS(1928),
    [anon_sym_default] = ACTIONS(1928),
    [anon_sym_while] = ACTIONS(1928),
    [anon_sym_do] = ACTIONS(1928),
    [anon_sym_for] = ACTIONS(1928),
    [anon_sym_return] = ACTIONS(1928),
    [anon_sym_break] = ACTIONS(1928),
    [anon_sym_continue] = ACTIONS(1928),
    [anon_sym_goto] = ACTIONS(1928),
    [anon_sym___try] = ACTIONS(1928),
    [anon_sym___leave] = ACTIONS(1928),
    [anon_sym_not] = ACTIONS(1928),
    [anon_sym_compl] = ACTIONS(1928),
    [anon_sym_DASH_DASH] = ACTIONS(1930),
    [anon_sym_PLUS_PLUS] = ACTIONS(1930),
    [anon_sym_sizeof] = ACTIONS(1928),
    [anon_sym___alignof__] = ACTIONS(1928),
    [anon_sym___alignof] = ACTIONS(1928),
    [anon_sym__alignof] = ACTIONS(1928),
    [anon_sym_alignof] = ACTIONS(1928),
    [anon_sym__Alignof] = ACTIONS(1928),
    [anon_sym_offsetof] = ACTIONS(1928),
    [anon_sym__Generic] = ACTIONS(1928),
    [anon_sym_asm] = ACTIONS(1928),
    [anon_sym___asm__] = ACTIONS(1928),
    [sym_number_literal] = ACTIONS(1930),
    [anon_sym_L_SQUOTE] = ACTIONS(1930),
    [anon_sym_u_SQUOTE] = ACTIONS(1930),
    [anon_sym_U_SQUOTE] = ACTIONS(1930),
    [anon_sym_u8_SQUOTE] = ACTIONS(1930),
    [anon_sym_SQUOTE] = ACTIONS(1930),
    [anon_sym_L_DQUOTE] = ACTIONS(1930),
    [anon_sym_u_DQUOTE] = ACTIONS(1930),
    [anon_sym_U_DQUOTE] = ACTIONS(1930),
    [anon_sym_u8_DQUOTE] = ACTIONS(1930),
    [anon_sym_DQUOTE] = ACTIONS(1930),
    [sym_true] = ACTIONS(1928),
    [sym_false] = ACTIONS(1928),
    [anon_sym_NULL] = ACTIONS(1928),
    [anon_sym_nullptr] = ACTIONS(1928),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1928),
    [anon_sym_decltype] = ACTIONS(1928),
    [sym_virtual] = ACTIONS(1928),
    [anon_sym_explicit] = ACTIONS(1928),
    [anon_sym_typename] = ACTIONS(1928),
    [anon_sym_template] = ACTIONS(1928),
    [anon_sym_operator] = ACTIONS(1928),
    [anon_sym_try] = ACTIONS(1928),
    [anon_sym_delete] = ACTIONS(1928),
    [anon_sym_throw] = ACTIONS(1928),
    [anon_sym_namespace] = ACTIONS(1928),
    [anon_sym_using] = ACTIONS(1928),
    [anon_sym_static_assert] = ACTIONS(1928),
    [anon_sym_concept] = ACTIONS(1928),
    [anon_sym_co_return] = ACTIONS(1928),
    [anon_sym_co_yield] = ACTIONS(1928),
    [anon_sym_R_DQUOTE] = ACTIONS(1930),
    [anon_sym_LR_DQUOTE] = ACTIONS(1930),
    [anon_sym_uR_DQUOTE] = ACTIONS(1930),
    [anon_sym_UR_DQUOTE] = ACTIONS(1930),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1930),
    [anon_sym_co_await] = ACTIONS(1928),
    [anon_sym_new] = ACTIONS(1928),
    [anon_sym_requires] = ACTIONS(1928),
    [sym_this] = ACTIONS(1928),
    [anon_sym___launch_bounds__] = ACTIONS(1928),
  },
  [319] = {
    [sym_expression] = STATE(4625),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(2586),
    [anon_sym___device__] = ACTIONS(2586),
    [anon_sym___host__] = ACTIONS(2586),
    [anon_sym___global__] = ACTIONS(2586),
    [anon_sym___forceinline__] = ACTIONS(2586),
    [anon_sym___noinline__] = ACTIONS(2586),
    [anon_sym_extern] = ACTIONS(2586),
    [anon_sym___attribute__] = ACTIONS(2586),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2588),
    [anon_sym___declspec] = ACTIONS(2586),
    [anon_sym_signed] = ACTIONS(2586),
    [anon_sym_unsigned] = ACTIONS(2586),
    [anon_sym_long] = ACTIONS(2586),
    [anon_sym_short] = ACTIONS(2586),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_static] = ACTIONS(2586),
    [anon_sym_register] = ACTIONS(2586),
    [anon_sym_inline] = ACTIONS(2586),
    [anon_sym___inline] = ACTIONS(2586),
    [anon_sym___inline__] = ACTIONS(2586),
    [anon_sym___forceinline] = ACTIONS(2586),
    [anon_sym_thread_local] = ACTIONS(2586),
    [anon_sym___thread] = ACTIONS(2586),
    [anon_sym_const] = ACTIONS(2586),
    [anon_sym_constexpr] = ACTIONS(2586),
    [anon_sym_volatile] = ACTIONS(2586),
    [anon_sym_restrict] = ACTIONS(2586),
    [anon_sym___restrict__] = ACTIONS(2586),
    [anon_sym__Atomic] = ACTIONS(2586),
    [anon_sym__Noreturn] = ACTIONS(2586),
    [anon_sym_noreturn] = ACTIONS(2586),
    [anon_sym_mutable] = ACTIONS(2586),
    [anon_sym_constinit] = ACTIONS(2586),
    [anon_sym_consteval] = ACTIONS(2586),
    [anon_sym___shared__] = ACTIONS(2586),
    [anon_sym___local__] = ACTIONS(2586),
    [anon_sym___constant__] = ACTIONS(2586),
    [anon_sym___managed__] = ACTIONS(2586),
    [anon_sym___grid_constant__] = ACTIONS(2586),
    [anon_sym_alignas] = ACTIONS(2586),
    [anon_sym__Alignas] = ACTIONS(2586),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_enum] = ACTIONS(2586),
    [anon_sym_class] = ACTIONS(2586),
    [anon_sym_struct] = ACTIONS(2586),
    [anon_sym_union] = ACTIONS(2586),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2586),
    [anon_sym_decltype] = ACTIONS(2542),
    [sym_virtual] = ACTIONS(2586),
    [anon_sym_typename] = ACTIONS(2586),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [anon_sym___launch_bounds__] = ACTIONS(2586),
  },
  [320] = {
    [sym_else_clause] = STATE(369),
    [ts_builtin_sym_end] = ACTIONS(1936),
    [sym_identifier] = ACTIONS(1934),
    [aux_sym_preproc_include_token1] = ACTIONS(1934),
    [aux_sym_preproc_def_token1] = ACTIONS(1934),
    [aux_sym_preproc_if_token1] = ACTIONS(1934),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1934),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1934),
    [sym_preproc_directive] = ACTIONS(1934),
    [anon_sym_LPAREN2] = ACTIONS(1936),
    [anon_sym_BANG] = ACTIONS(1936),
    [anon_sym_TILDE] = ACTIONS(1936),
    [anon_sym_DASH] = ACTIONS(1934),
    [anon_sym_PLUS] = ACTIONS(1934),
    [anon_sym_STAR] = ACTIONS(1936),
    [anon_sym_AMP_AMP] = ACTIONS(1936),
    [anon_sym_AMP] = ACTIONS(1934),
    [anon_sym_SEMI] = ACTIONS(1936),
    [anon_sym___extension__] = ACTIONS(1934),
    [anon_sym_typedef] = ACTIONS(1934),
    [anon_sym___device__] = ACTIONS(1934),
    [anon_sym___host__] = ACTIONS(1934),
    [anon_sym___global__] = ACTIONS(1934),
    [anon_sym___forceinline__] = ACTIONS(1934),
    [anon_sym___noinline__] = ACTIONS(1934),
    [anon_sym_extern] = ACTIONS(1934),
    [anon_sym___attribute__] = ACTIONS(1934),
    [anon_sym_COLON_COLON] = ACTIONS(1936),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1936),
    [anon_sym___declspec] = ACTIONS(1934),
    [anon_sym___based] = ACTIONS(1934),
    [anon_sym___cdecl] = ACTIONS(1934),
    [anon_sym___clrcall] = ACTIONS(1934),
    [anon_sym___stdcall] = ACTIONS(1934),
    [anon_sym___fastcall] = ACTIONS(1934),
    [anon_sym___thiscall] = ACTIONS(1934),
    [anon_sym___vectorcall] = ACTIONS(1934),
    [anon_sym_LBRACE] = ACTIONS(1936),
    [anon_sym_signed] = ACTIONS(1934),
    [anon_sym_unsigned] = ACTIONS(1934),
    [anon_sym_long] = ACTIONS(1934),
    [anon_sym_short] = ACTIONS(1934),
    [anon_sym_LBRACK] = ACTIONS(1934),
    [anon_sym_static] = ACTIONS(1934),
    [anon_sym_register] = ACTIONS(1934),
    [anon_sym_inline] = ACTIONS(1934),
    [anon_sym___inline] = ACTIONS(1934),
    [anon_sym___inline__] = ACTIONS(1934),
    [anon_sym___forceinline] = ACTIONS(1934),
    [anon_sym_thread_local] = ACTIONS(1934),
    [anon_sym___thread] = ACTIONS(1934),
    [anon_sym_const] = ACTIONS(1934),
    [anon_sym_constexpr] = ACTIONS(1934),
    [anon_sym_volatile] = ACTIONS(1934),
    [anon_sym_restrict] = ACTIONS(1934),
    [anon_sym___restrict__] = ACTIONS(1934),
    [anon_sym__Atomic] = ACTIONS(1934),
    [anon_sym__Noreturn] = ACTIONS(1934),
    [anon_sym_noreturn] = ACTIONS(1934),
    [anon_sym_mutable] = ACTIONS(1934),
    [anon_sym_constinit] = ACTIONS(1934),
    [anon_sym_consteval] = ACTIONS(1934),
    [anon_sym___shared__] = ACTIONS(1934),
    [anon_sym___local__] = ACTIONS(1934),
    [anon_sym___constant__] = ACTIONS(1934),
    [anon_sym___managed__] = ACTIONS(1934),
    [anon_sym___grid_constant__] = ACTIONS(1934),
    [anon_sym_alignas] = ACTIONS(1934),
    [anon_sym__Alignas] = ACTIONS(1934),
    [sym_primitive_type] = ACTIONS(1934),
    [anon_sym_enum] = ACTIONS(1934),
    [anon_sym_class] = ACTIONS(1934),
    [anon_sym_struct] = ACTIONS(1934),
    [anon_sym_union] = ACTIONS(1934),
    [anon_sym_if] = ACTIONS(1934),
    [anon_sym_else] = ACTIONS(2554),
    [anon_sym_switch] = ACTIONS(1934),
    [anon_sym_case] = ACTIONS(1934),
    [anon_sym_default] = ACTIONS(1934),
    [anon_sym_while] = ACTIONS(1934),
    [anon_sym_do] = ACTIONS(1934),
    [anon_sym_for] = ACTIONS(1934),
    [anon_sym_return] = ACTIONS(1934),
    [anon_sym_break] = ACTIONS(1934),
    [anon_sym_continue] = ACTIONS(1934),
    [anon_sym_goto] = ACTIONS(1934),
    [anon_sym___try] = ACTIONS(1934),
    [anon_sym___leave] = ACTIONS(1934),
    [anon_sym_not] = ACTIONS(1934),
    [anon_sym_compl] = ACTIONS(1934),
    [anon_sym_DASH_DASH] = ACTIONS(1936),
    [anon_sym_PLUS_PLUS] = ACTIONS(1936),
    [anon_sym_sizeof] = ACTIONS(1934),
    [anon_sym___alignof__] = ACTIONS(1934),
    [anon_sym___alignof] = ACTIONS(1934),
    [anon_sym__alignof] = ACTIONS(1934),
    [anon_sym_alignof] = ACTIONS(1934),
    [anon_sym__Alignof] = ACTIONS(1934),
    [anon_sym_offsetof] = ACTIONS(1934),
    [anon_sym__Generic] = ACTIONS(1934),
    [anon_sym_asm] = ACTIONS(1934),
    [anon_sym___asm__] = ACTIONS(1934),
    [sym_number_literal] = ACTIONS(1936),
    [anon_sym_L_SQUOTE] = ACTIONS(1936),
    [anon_sym_u_SQUOTE] = ACTIONS(1936),
    [anon_sym_U_SQUOTE] = ACTIONS(1936),
    [anon_sym_u8_SQUOTE] = ACTIONS(1936),
    [anon_sym_SQUOTE] = ACTIONS(1936),
    [anon_sym_L_DQUOTE] = ACTIONS(1936),
    [anon_sym_u_DQUOTE] = ACTIONS(1936),
    [anon_sym_U_DQUOTE] = ACTIONS(1936),
    [anon_sym_u8_DQUOTE] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1936),
    [sym_true] = ACTIONS(1934),
    [sym_false] = ACTIONS(1934),
    [anon_sym_NULL] = ACTIONS(1934),
    [anon_sym_nullptr] = ACTIONS(1934),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1934),
    [anon_sym_decltype] = ACTIONS(1934),
    [sym_virtual] = ACTIONS(1934),
    [anon_sym_explicit] = ACTIONS(1934),
    [anon_sym_typename] = ACTIONS(1934),
    [anon_sym_template] = ACTIONS(1934),
    [anon_sym_operator] = ACTIONS(1934),
    [anon_sym_try] = ACTIONS(1934),
    [anon_sym_delete] = ACTIONS(1934),
    [anon_sym_throw] = ACTIONS(1934),
    [anon_sym_namespace] = ACTIONS(1934),
    [anon_sym_using] = ACTIONS(1934),
    [anon_sym_static_assert] = ACTIONS(1934),
    [anon_sym_concept] = ACTIONS(1934),
    [anon_sym_co_return] = ACTIONS(1934),
    [anon_sym_co_yield] = ACTIONS(1934),
    [anon_sym_R_DQUOTE] = ACTIONS(1936),
    [anon_sym_LR_DQUOTE] = ACTIONS(1936),
    [anon_sym_uR_DQUOTE] = ACTIONS(1936),
    [anon_sym_UR_DQUOTE] = ACTIONS(1936),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1936),
    [anon_sym_co_await] = ACTIONS(1934),
    [anon_sym_new] = ACTIONS(1934),
    [anon_sym_requires] = ACTIONS(1934),
    [sym_this] = ACTIONS(1934),
    [anon_sym___launch_bounds__] = ACTIONS(1934),
  },
  [321] = {
    [sym_identifier] = ACTIONS(1901),
    [aux_sym_preproc_include_token1] = ACTIONS(1901),
    [aux_sym_preproc_def_token1] = ACTIONS(1901),
    [aux_sym_preproc_if_token1] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1901),
    [sym_preproc_directive] = ACTIONS(1901),
    [anon_sym_LPAREN2] = ACTIONS(1899),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_DASH] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1901),
    [anon_sym_STAR] = ACTIONS(1899),
    [anon_sym_AMP_AMP] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1901),
    [anon_sym_SEMI] = ACTIONS(1899),
    [anon_sym___extension__] = ACTIONS(1901),
    [anon_sym_typedef] = ACTIONS(1901),
    [anon_sym___device__] = ACTIONS(1901),
    [anon_sym___host__] = ACTIONS(1901),
    [anon_sym___global__] = ACTIONS(1901),
    [anon_sym___forceinline__] = ACTIONS(1901),
    [anon_sym___noinline__] = ACTIONS(1901),
    [anon_sym_extern] = ACTIONS(1901),
    [anon_sym___attribute__] = ACTIONS(1901),
    [anon_sym_COLON_COLON] = ACTIONS(1899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1899),
    [anon_sym___declspec] = ACTIONS(1901),
    [anon_sym___based] = ACTIONS(1901),
    [anon_sym___cdecl] = ACTIONS(1901),
    [anon_sym___clrcall] = ACTIONS(1901),
    [anon_sym___stdcall] = ACTIONS(1901),
    [anon_sym___fastcall] = ACTIONS(1901),
    [anon_sym___thiscall] = ACTIONS(1901),
    [anon_sym___vectorcall] = ACTIONS(1901),
    [anon_sym_LBRACE] = ACTIONS(1899),
    [anon_sym_RBRACE] = ACTIONS(1899),
    [anon_sym_signed] = ACTIONS(1901),
    [anon_sym_unsigned] = ACTIONS(1901),
    [anon_sym_long] = ACTIONS(1901),
    [anon_sym_short] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1901),
    [anon_sym_static] = ACTIONS(1901),
    [anon_sym_register] = ACTIONS(1901),
    [anon_sym_inline] = ACTIONS(1901),
    [anon_sym___inline] = ACTIONS(1901),
    [anon_sym___inline__] = ACTIONS(1901),
    [anon_sym___forceinline] = ACTIONS(1901),
    [anon_sym_thread_local] = ACTIONS(1901),
    [anon_sym___thread] = ACTIONS(1901),
    [anon_sym_const] = ACTIONS(1901),
    [anon_sym_constexpr] = ACTIONS(1901),
    [anon_sym_volatile] = ACTIONS(1901),
    [anon_sym_restrict] = ACTIONS(1901),
    [anon_sym___restrict__] = ACTIONS(1901),
    [anon_sym__Atomic] = ACTIONS(1901),
    [anon_sym__Noreturn] = ACTIONS(1901),
    [anon_sym_noreturn] = ACTIONS(1901),
    [anon_sym_mutable] = ACTIONS(1901),
    [anon_sym_constinit] = ACTIONS(1901),
    [anon_sym_consteval] = ACTIONS(1901),
    [anon_sym___shared__] = ACTIONS(1901),
    [anon_sym___local__] = ACTIONS(1901),
    [anon_sym___constant__] = ACTIONS(1901),
    [anon_sym___managed__] = ACTIONS(1901),
    [anon_sym___grid_constant__] = ACTIONS(1901),
    [anon_sym_alignas] = ACTIONS(1901),
    [anon_sym__Alignas] = ACTIONS(1901),
    [sym_primitive_type] = ACTIONS(1901),
    [anon_sym_enum] = ACTIONS(1901),
    [anon_sym_class] = ACTIONS(1901),
    [anon_sym_struct] = ACTIONS(1901),
    [anon_sym_union] = ACTIONS(1901),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_else] = ACTIONS(1901),
    [anon_sym_switch] = ACTIONS(1901),
    [anon_sym_case] = ACTIONS(1901),
    [anon_sym_default] = ACTIONS(1901),
    [anon_sym_while] = ACTIONS(1901),
    [anon_sym_do] = ACTIONS(1901),
    [anon_sym_for] = ACTIONS(1901),
    [anon_sym_return] = ACTIONS(1901),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_continue] = ACTIONS(1901),
    [anon_sym_goto] = ACTIONS(1901),
    [anon_sym___try] = ACTIONS(1901),
    [anon_sym___leave] = ACTIONS(1901),
    [anon_sym_not] = ACTIONS(1901),
    [anon_sym_compl] = ACTIONS(1901),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_sizeof] = ACTIONS(1901),
    [anon_sym___alignof__] = ACTIONS(1901),
    [anon_sym___alignof] = ACTIONS(1901),
    [anon_sym__alignof] = ACTIONS(1901),
    [anon_sym_alignof] = ACTIONS(1901),
    [anon_sym__Alignof] = ACTIONS(1901),
    [anon_sym_offsetof] = ACTIONS(1901),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1901),
    [anon_sym___asm__] = ACTIONS(1901),
    [sym_number_literal] = ACTIONS(1899),
    [anon_sym_L_SQUOTE] = ACTIONS(1899),
    [anon_sym_u_SQUOTE] = ACTIONS(1899),
    [anon_sym_U_SQUOTE] = ACTIONS(1899),
    [anon_sym_u8_SQUOTE] = ACTIONS(1899),
    [anon_sym_SQUOTE] = ACTIONS(1899),
    [anon_sym_L_DQUOTE] = ACTIONS(1899),
    [anon_sym_u_DQUOTE] = ACTIONS(1899),
    [anon_sym_U_DQUOTE] = ACTIONS(1899),
    [anon_sym_u8_DQUOTE] = ACTIONS(1899),
    [anon_sym_DQUOTE] = ACTIONS(1899),
    [sym_true] = ACTIONS(1901),
    [sym_false] = ACTIONS(1901),
    [anon_sym_NULL] = ACTIONS(1901),
    [anon_sym_nullptr] = ACTIONS(1901),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1901),
    [anon_sym_decltype] = ACTIONS(1901),
    [sym_virtual] = ACTIONS(1901),
    [anon_sym_explicit] = ACTIONS(1901),
    [anon_sym_typename] = ACTIONS(1901),
    [anon_sym_template] = ACTIONS(1901),
    [anon_sym_operator] = ACTIONS(1901),
    [anon_sym_try] = ACTIONS(1901),
    [anon_sym_delete] = ACTIONS(1901),
    [anon_sym_throw] = ACTIONS(1901),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_using] = ACTIONS(1901),
    [anon_sym_static_assert] = ACTIONS(1901),
    [anon_sym_concept] = ACTIONS(1901),
    [anon_sym_co_return] = ACTIONS(1901),
    [anon_sym_co_yield] = ACTIONS(1901),
    [anon_sym_catch] = ACTIONS(1901),
    [anon_sym_R_DQUOTE] = ACTIONS(1899),
    [anon_sym_LR_DQUOTE] = ACTIONS(1899),
    [anon_sym_uR_DQUOTE] = ACTIONS(1899),
    [anon_sym_UR_DQUOTE] = ACTIONS(1899),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1899),
    [anon_sym_co_await] = ACTIONS(1901),
    [anon_sym_new] = ACTIONS(1901),
    [anon_sym_requires] = ACTIONS(1901),
    [sym_this] = ACTIONS(1901),
    [anon_sym___launch_bounds__] = ACTIONS(1901),
  },
  [322] = {
    [sym_else_clause] = STATE(437),
    [sym_identifier] = ACTIONS(1934),
    [aux_sym_preproc_include_token1] = ACTIONS(1934),
    [aux_sym_preproc_def_token1] = ACTIONS(1934),
    [aux_sym_preproc_if_token1] = ACTIONS(1934),
    [aux_sym_preproc_if_token2] = ACTIONS(1934),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1934),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1934),
    [sym_preproc_directive] = ACTIONS(1934),
    [anon_sym_LPAREN2] = ACTIONS(1936),
    [anon_sym_BANG] = ACTIONS(1936),
    [anon_sym_TILDE] = ACTIONS(1936),
    [anon_sym_DASH] = ACTIONS(1934),
    [anon_sym_PLUS] = ACTIONS(1934),
    [anon_sym_STAR] = ACTIONS(1936),
    [anon_sym_AMP_AMP] = ACTIONS(1936),
    [anon_sym_AMP] = ACTIONS(1934),
    [anon_sym_SEMI] = ACTIONS(1936),
    [anon_sym___extension__] = ACTIONS(1934),
    [anon_sym_typedef] = ACTIONS(1934),
    [anon_sym___device__] = ACTIONS(1934),
    [anon_sym___host__] = ACTIONS(1934),
    [anon_sym___global__] = ACTIONS(1934),
    [anon_sym___forceinline__] = ACTIONS(1934),
    [anon_sym___noinline__] = ACTIONS(1934),
    [anon_sym_extern] = ACTIONS(1934),
    [anon_sym___attribute__] = ACTIONS(1934),
    [anon_sym_COLON_COLON] = ACTIONS(1936),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1936),
    [anon_sym___declspec] = ACTIONS(1934),
    [anon_sym___based] = ACTIONS(1934),
    [anon_sym___cdecl] = ACTIONS(1934),
    [anon_sym___clrcall] = ACTIONS(1934),
    [anon_sym___stdcall] = ACTIONS(1934),
    [anon_sym___fastcall] = ACTIONS(1934),
    [anon_sym___thiscall] = ACTIONS(1934),
    [anon_sym___vectorcall] = ACTIONS(1934),
    [anon_sym_LBRACE] = ACTIONS(1936),
    [anon_sym_signed] = ACTIONS(1934),
    [anon_sym_unsigned] = ACTIONS(1934),
    [anon_sym_long] = ACTIONS(1934),
    [anon_sym_short] = ACTIONS(1934),
    [anon_sym_LBRACK] = ACTIONS(1934),
    [anon_sym_static] = ACTIONS(1934),
    [anon_sym_register] = ACTIONS(1934),
    [anon_sym_inline] = ACTIONS(1934),
    [anon_sym___inline] = ACTIONS(1934),
    [anon_sym___inline__] = ACTIONS(1934),
    [anon_sym___forceinline] = ACTIONS(1934),
    [anon_sym_thread_local] = ACTIONS(1934),
    [anon_sym___thread] = ACTIONS(1934),
    [anon_sym_const] = ACTIONS(1934),
    [anon_sym_constexpr] = ACTIONS(1934),
    [anon_sym_volatile] = ACTIONS(1934),
    [anon_sym_restrict] = ACTIONS(1934),
    [anon_sym___restrict__] = ACTIONS(1934),
    [anon_sym__Atomic] = ACTIONS(1934),
    [anon_sym__Noreturn] = ACTIONS(1934),
    [anon_sym_noreturn] = ACTIONS(1934),
    [anon_sym_mutable] = ACTIONS(1934),
    [anon_sym_constinit] = ACTIONS(1934),
    [anon_sym_consteval] = ACTIONS(1934),
    [anon_sym___shared__] = ACTIONS(1934),
    [anon_sym___local__] = ACTIONS(1934),
    [anon_sym___constant__] = ACTIONS(1934),
    [anon_sym___managed__] = ACTIONS(1934),
    [anon_sym___grid_constant__] = ACTIONS(1934),
    [anon_sym_alignas] = ACTIONS(1934),
    [anon_sym__Alignas] = ACTIONS(1934),
    [sym_primitive_type] = ACTIONS(1934),
    [anon_sym_enum] = ACTIONS(1934),
    [anon_sym_class] = ACTIONS(1934),
    [anon_sym_struct] = ACTIONS(1934),
    [anon_sym_union] = ACTIONS(1934),
    [anon_sym_if] = ACTIONS(1934),
    [anon_sym_else] = ACTIONS(2582),
    [anon_sym_switch] = ACTIONS(1934),
    [anon_sym_case] = ACTIONS(1934),
    [anon_sym_default] = ACTIONS(1934),
    [anon_sym_while] = ACTIONS(1934),
    [anon_sym_do] = ACTIONS(1934),
    [anon_sym_for] = ACTIONS(1934),
    [anon_sym_return] = ACTIONS(1934),
    [anon_sym_break] = ACTIONS(1934),
    [anon_sym_continue] = ACTIONS(1934),
    [anon_sym_goto] = ACTIONS(1934),
    [anon_sym___try] = ACTIONS(1934),
    [anon_sym___leave] = ACTIONS(1934),
    [anon_sym_not] = ACTIONS(1934),
    [anon_sym_compl] = ACTIONS(1934),
    [anon_sym_DASH_DASH] = ACTIONS(1936),
    [anon_sym_PLUS_PLUS] = ACTIONS(1936),
    [anon_sym_sizeof] = ACTIONS(1934),
    [anon_sym___alignof__] = ACTIONS(1934),
    [anon_sym___alignof] = ACTIONS(1934),
    [anon_sym__alignof] = ACTIONS(1934),
    [anon_sym_alignof] = ACTIONS(1934),
    [anon_sym__Alignof] = ACTIONS(1934),
    [anon_sym_offsetof] = ACTIONS(1934),
    [anon_sym__Generic] = ACTIONS(1934),
    [anon_sym_asm] = ACTIONS(1934),
    [anon_sym___asm__] = ACTIONS(1934),
    [sym_number_literal] = ACTIONS(1936),
    [anon_sym_L_SQUOTE] = ACTIONS(1936),
    [anon_sym_u_SQUOTE] = ACTIONS(1936),
    [anon_sym_U_SQUOTE] = ACTIONS(1936),
    [anon_sym_u8_SQUOTE] = ACTIONS(1936),
    [anon_sym_SQUOTE] = ACTIONS(1936),
    [anon_sym_L_DQUOTE] = ACTIONS(1936),
    [anon_sym_u_DQUOTE] = ACTIONS(1936),
    [anon_sym_U_DQUOTE] = ACTIONS(1936),
    [anon_sym_u8_DQUOTE] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1936),
    [sym_true] = ACTIONS(1934),
    [sym_false] = ACTIONS(1934),
    [anon_sym_NULL] = ACTIONS(1934),
    [anon_sym_nullptr] = ACTIONS(1934),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1934),
    [anon_sym_decltype] = ACTIONS(1934),
    [sym_virtual] = ACTIONS(1934),
    [anon_sym_explicit] = ACTIONS(1934),
    [anon_sym_typename] = ACTIONS(1934),
    [anon_sym_template] = ACTIONS(1934),
    [anon_sym_operator] = ACTIONS(1934),
    [anon_sym_try] = ACTIONS(1934),
    [anon_sym_delete] = ACTIONS(1934),
    [anon_sym_throw] = ACTIONS(1934),
    [anon_sym_namespace] = ACTIONS(1934),
    [anon_sym_using] = ACTIONS(1934),
    [anon_sym_static_assert] = ACTIONS(1934),
    [anon_sym_concept] = ACTIONS(1934),
    [anon_sym_co_return] = ACTIONS(1934),
    [anon_sym_co_yield] = ACTIONS(1934),
    [anon_sym_R_DQUOTE] = ACTIONS(1936),
    [anon_sym_LR_DQUOTE] = ACTIONS(1936),
    [anon_sym_uR_DQUOTE] = ACTIONS(1936),
    [anon_sym_UR_DQUOTE] = ACTIONS(1936),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1936),
    [anon_sym_co_await] = ACTIONS(1934),
    [anon_sym_new] = ACTIONS(1934),
    [anon_sym_requires] = ACTIONS(1934),
    [sym_this] = ACTIONS(1934),
    [anon_sym___launch_bounds__] = ACTIONS(1934),
  },
  [323] = {
    [ts_builtin_sym_end] = ACTIONS(1926),
    [sym_identifier] = ACTIONS(1924),
    [aux_sym_preproc_include_token1] = ACTIONS(1924),
    [aux_sym_preproc_def_token1] = ACTIONS(1924),
    [aux_sym_preproc_if_token1] = ACTIONS(1924),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1924),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1924),
    [sym_preproc_directive] = ACTIONS(1924),
    [anon_sym_LPAREN2] = ACTIONS(1926),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1924),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_STAR] = ACTIONS(1926),
    [anon_sym_AMP_AMP] = ACTIONS(1926),
    [anon_sym_AMP] = ACTIONS(1924),
    [anon_sym_SEMI] = ACTIONS(1926),
    [anon_sym___extension__] = ACTIONS(1924),
    [anon_sym_typedef] = ACTIONS(1924),
    [anon_sym___device__] = ACTIONS(1924),
    [anon_sym___host__] = ACTIONS(1924),
    [anon_sym___global__] = ACTIONS(1924),
    [anon_sym___forceinline__] = ACTIONS(1924),
    [anon_sym___noinline__] = ACTIONS(1924),
    [anon_sym_extern] = ACTIONS(1924),
    [anon_sym___attribute__] = ACTIONS(1924),
    [anon_sym_COLON_COLON] = ACTIONS(1926),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1926),
    [anon_sym___declspec] = ACTIONS(1924),
    [anon_sym___based] = ACTIONS(1924),
    [anon_sym___cdecl] = ACTIONS(1924),
    [anon_sym___clrcall] = ACTIONS(1924),
    [anon_sym___stdcall] = ACTIONS(1924),
    [anon_sym___fastcall] = ACTIONS(1924),
    [anon_sym___thiscall] = ACTIONS(1924),
    [anon_sym___vectorcall] = ACTIONS(1924),
    [anon_sym_LBRACE] = ACTIONS(1926),
    [anon_sym_signed] = ACTIONS(1924),
    [anon_sym_unsigned] = ACTIONS(1924),
    [anon_sym_long] = ACTIONS(1924),
    [anon_sym_short] = ACTIONS(1924),
    [anon_sym_LBRACK] = ACTIONS(1924),
    [anon_sym_static] = ACTIONS(1924),
    [anon_sym_register] = ACTIONS(1924),
    [anon_sym_inline] = ACTIONS(1924),
    [anon_sym___inline] = ACTIONS(1924),
    [anon_sym___inline__] = ACTIONS(1924),
    [anon_sym___forceinline] = ACTIONS(1924),
    [anon_sym_thread_local] = ACTIONS(1924),
    [anon_sym___thread] = ACTIONS(1924),
    [anon_sym_const] = ACTIONS(1924),
    [anon_sym_constexpr] = ACTIONS(1924),
    [anon_sym_volatile] = ACTIONS(1924),
    [anon_sym_restrict] = ACTIONS(1924),
    [anon_sym___restrict__] = ACTIONS(1924),
    [anon_sym__Atomic] = ACTIONS(1924),
    [anon_sym__Noreturn] = ACTIONS(1924),
    [anon_sym_noreturn] = ACTIONS(1924),
    [anon_sym_mutable] = ACTIONS(1924),
    [anon_sym_constinit] = ACTIONS(1924),
    [anon_sym_consteval] = ACTIONS(1924),
    [anon_sym___shared__] = ACTIONS(1924),
    [anon_sym___local__] = ACTIONS(1924),
    [anon_sym___constant__] = ACTIONS(1924),
    [anon_sym___managed__] = ACTIONS(1924),
    [anon_sym___grid_constant__] = ACTIONS(1924),
    [anon_sym_alignas] = ACTIONS(1924),
    [anon_sym__Alignas] = ACTIONS(1924),
    [sym_primitive_type] = ACTIONS(1924),
    [anon_sym_enum] = ACTIONS(1924),
    [anon_sym_class] = ACTIONS(1924),
    [anon_sym_struct] = ACTIONS(1924),
    [anon_sym_union] = ACTIONS(1924),
    [anon_sym_if] = ACTIONS(1924),
    [anon_sym_else] = ACTIONS(1924),
    [anon_sym_switch] = ACTIONS(1924),
    [anon_sym_case] = ACTIONS(1924),
    [anon_sym_default] = ACTIONS(1924),
    [anon_sym_while] = ACTIONS(1924),
    [anon_sym_do] = ACTIONS(1924),
    [anon_sym_for] = ACTIONS(1924),
    [anon_sym_return] = ACTIONS(1924),
    [anon_sym_break] = ACTIONS(1924),
    [anon_sym_continue] = ACTIONS(1924),
    [anon_sym_goto] = ACTIONS(1924),
    [anon_sym___try] = ACTIONS(1924),
    [anon_sym___leave] = ACTIONS(1924),
    [anon_sym_not] = ACTIONS(1924),
    [anon_sym_compl] = ACTIONS(1924),
    [anon_sym_DASH_DASH] = ACTIONS(1926),
    [anon_sym_PLUS_PLUS] = ACTIONS(1926),
    [anon_sym_sizeof] = ACTIONS(1924),
    [anon_sym___alignof__] = ACTIONS(1924),
    [anon_sym___alignof] = ACTIONS(1924),
    [anon_sym__alignof] = ACTIONS(1924),
    [anon_sym_alignof] = ACTIONS(1924),
    [anon_sym__Alignof] = ACTIONS(1924),
    [anon_sym_offsetof] = ACTIONS(1924),
    [anon_sym__Generic] = ACTIONS(1924),
    [anon_sym_asm] = ACTIONS(1924),
    [anon_sym___asm__] = ACTIONS(1924),
    [sym_number_literal] = ACTIONS(1926),
    [anon_sym_L_SQUOTE] = ACTIONS(1926),
    [anon_sym_u_SQUOTE] = ACTIONS(1926),
    [anon_sym_U_SQUOTE] = ACTIONS(1926),
    [anon_sym_u8_SQUOTE] = ACTIONS(1926),
    [anon_sym_SQUOTE] = ACTIONS(1926),
    [anon_sym_L_DQUOTE] = ACTIONS(1926),
    [anon_sym_u_DQUOTE] = ACTIONS(1926),
    [anon_sym_U_DQUOTE] = ACTIONS(1926),
    [anon_sym_u8_DQUOTE] = ACTIONS(1926),
    [anon_sym_DQUOTE] = ACTIONS(1926),
    [sym_true] = ACTIONS(1924),
    [sym_false] = ACTIONS(1924),
    [anon_sym_NULL] = ACTIONS(1924),
    [anon_sym_nullptr] = ACTIONS(1924),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1924),
    [anon_sym_decltype] = ACTIONS(1924),
    [sym_virtual] = ACTIONS(1924),
    [anon_sym_explicit] = ACTIONS(1924),
    [anon_sym_typename] = ACTIONS(1924),
    [anon_sym_template] = ACTIONS(1924),
    [anon_sym_operator] = ACTIONS(1924),
    [anon_sym_try] = ACTIONS(1924),
    [anon_sym_delete] = ACTIONS(1924),
    [anon_sym_throw] = ACTIONS(1924),
    [anon_sym_namespace] = ACTIONS(1924),
    [anon_sym_using] = ACTIONS(1924),
    [anon_sym_static_assert] = ACTIONS(1924),
    [anon_sym_concept] = ACTIONS(1924),
    [anon_sym_co_return] = ACTIONS(1924),
    [anon_sym_co_yield] = ACTIONS(1924),
    [anon_sym_catch] = ACTIONS(1924),
    [anon_sym_R_DQUOTE] = ACTIONS(1926),
    [anon_sym_LR_DQUOTE] = ACTIONS(1926),
    [anon_sym_uR_DQUOTE] = ACTIONS(1926),
    [anon_sym_UR_DQUOTE] = ACTIONS(1926),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1926),
    [anon_sym_co_await] = ACTIONS(1924),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1924),
    [anon_sym___launch_bounds__] = ACTIONS(1924),
  },
  [324] = {
    [sym_identifier] = ACTIONS(1924),
    [aux_sym_preproc_include_token1] = ACTIONS(1924),
    [aux_sym_preproc_def_token1] = ACTIONS(1924),
    [aux_sym_preproc_if_token1] = ACTIONS(1924),
    [aux_sym_preproc_if_token2] = ACTIONS(1924),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1924),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1924),
    [sym_preproc_directive] = ACTIONS(1924),
    [anon_sym_LPAREN2] = ACTIONS(1926),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1924),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_STAR] = ACTIONS(1926),
    [anon_sym_AMP_AMP] = ACTIONS(1926),
    [anon_sym_AMP] = ACTIONS(1924),
    [anon_sym_SEMI] = ACTIONS(1926),
    [anon_sym___extension__] = ACTIONS(1924),
    [anon_sym_typedef] = ACTIONS(1924),
    [anon_sym___device__] = ACTIONS(1924),
    [anon_sym___host__] = ACTIONS(1924),
    [anon_sym___global__] = ACTIONS(1924),
    [anon_sym___forceinline__] = ACTIONS(1924),
    [anon_sym___noinline__] = ACTIONS(1924),
    [anon_sym_extern] = ACTIONS(1924),
    [anon_sym___attribute__] = ACTIONS(1924),
    [anon_sym_COLON_COLON] = ACTIONS(1926),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1926),
    [anon_sym___declspec] = ACTIONS(1924),
    [anon_sym___based] = ACTIONS(1924),
    [anon_sym___cdecl] = ACTIONS(1924),
    [anon_sym___clrcall] = ACTIONS(1924),
    [anon_sym___stdcall] = ACTIONS(1924),
    [anon_sym___fastcall] = ACTIONS(1924),
    [anon_sym___thiscall] = ACTIONS(1924),
    [anon_sym___vectorcall] = ACTIONS(1924),
    [anon_sym_LBRACE] = ACTIONS(1926),
    [anon_sym_signed] = ACTIONS(1924),
    [anon_sym_unsigned] = ACTIONS(1924),
    [anon_sym_long] = ACTIONS(1924),
    [anon_sym_short] = ACTIONS(1924),
    [anon_sym_LBRACK] = ACTIONS(1924),
    [anon_sym_static] = ACTIONS(1924),
    [anon_sym_register] = ACTIONS(1924),
    [anon_sym_inline] = ACTIONS(1924),
    [anon_sym___inline] = ACTIONS(1924),
    [anon_sym___inline__] = ACTIONS(1924),
    [anon_sym___forceinline] = ACTIONS(1924),
    [anon_sym_thread_local] = ACTIONS(1924),
    [anon_sym___thread] = ACTIONS(1924),
    [anon_sym_const] = ACTIONS(1924),
    [anon_sym_constexpr] = ACTIONS(1924),
    [anon_sym_volatile] = ACTIONS(1924),
    [anon_sym_restrict] = ACTIONS(1924),
    [anon_sym___restrict__] = ACTIONS(1924),
    [anon_sym__Atomic] = ACTIONS(1924),
    [anon_sym__Noreturn] = ACTIONS(1924),
    [anon_sym_noreturn] = ACTIONS(1924),
    [anon_sym_mutable] = ACTIONS(1924),
    [anon_sym_constinit] = ACTIONS(1924),
    [anon_sym_consteval] = ACTIONS(1924),
    [anon_sym___shared__] = ACTIONS(1924),
    [anon_sym___local__] = ACTIONS(1924),
    [anon_sym___constant__] = ACTIONS(1924),
    [anon_sym___managed__] = ACTIONS(1924),
    [anon_sym___grid_constant__] = ACTIONS(1924),
    [anon_sym_alignas] = ACTIONS(1924),
    [anon_sym__Alignas] = ACTIONS(1924),
    [sym_primitive_type] = ACTIONS(1924),
    [anon_sym_enum] = ACTIONS(1924),
    [anon_sym_class] = ACTIONS(1924),
    [anon_sym_struct] = ACTIONS(1924),
    [anon_sym_union] = ACTIONS(1924),
    [anon_sym_if] = ACTIONS(1924),
    [anon_sym_else] = ACTIONS(1924),
    [anon_sym_switch] = ACTIONS(1924),
    [anon_sym_case] = ACTIONS(1924),
    [anon_sym_default] = ACTIONS(1924),
    [anon_sym_while] = ACTIONS(1924),
    [anon_sym_do] = ACTIONS(1924),
    [anon_sym_for] = ACTIONS(1924),
    [anon_sym_return] = ACTIONS(1924),
    [anon_sym_break] = ACTIONS(1924),
    [anon_sym_continue] = ACTIONS(1924),
    [anon_sym_goto] = ACTIONS(1924),
    [anon_sym___try] = ACTIONS(1924),
    [anon_sym___leave] = ACTIONS(1924),
    [anon_sym_not] = ACTIONS(1924),
    [anon_sym_compl] = ACTIONS(1924),
    [anon_sym_DASH_DASH] = ACTIONS(1926),
    [anon_sym_PLUS_PLUS] = ACTIONS(1926),
    [anon_sym_sizeof] = ACTIONS(1924),
    [anon_sym___alignof__] = ACTIONS(1924),
    [anon_sym___alignof] = ACTIONS(1924),
    [anon_sym__alignof] = ACTIONS(1924),
    [anon_sym_alignof] = ACTIONS(1924),
    [anon_sym__Alignof] = ACTIONS(1924),
    [anon_sym_offsetof] = ACTIONS(1924),
    [anon_sym__Generic] = ACTIONS(1924),
    [anon_sym_asm] = ACTIONS(1924),
    [anon_sym___asm__] = ACTIONS(1924),
    [sym_number_literal] = ACTIONS(1926),
    [anon_sym_L_SQUOTE] = ACTIONS(1926),
    [anon_sym_u_SQUOTE] = ACTIONS(1926),
    [anon_sym_U_SQUOTE] = ACTIONS(1926),
    [anon_sym_u8_SQUOTE] = ACTIONS(1926),
    [anon_sym_SQUOTE] = ACTIONS(1926),
    [anon_sym_L_DQUOTE] = ACTIONS(1926),
    [anon_sym_u_DQUOTE] = ACTIONS(1926),
    [anon_sym_U_DQUOTE] = ACTIONS(1926),
    [anon_sym_u8_DQUOTE] = ACTIONS(1926),
    [anon_sym_DQUOTE] = ACTIONS(1926),
    [sym_true] = ACTIONS(1924),
    [sym_false] = ACTIONS(1924),
    [anon_sym_NULL] = ACTIONS(1924),
    [anon_sym_nullptr] = ACTIONS(1924),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1924),
    [anon_sym_decltype] = ACTIONS(1924),
    [sym_virtual] = ACTIONS(1924),
    [anon_sym_explicit] = ACTIONS(1924),
    [anon_sym_typename] = ACTIONS(1924),
    [anon_sym_template] = ACTIONS(1924),
    [anon_sym_operator] = ACTIONS(1924),
    [anon_sym_try] = ACTIONS(1924),
    [anon_sym_delete] = ACTIONS(1924),
    [anon_sym_throw] = ACTIONS(1924),
    [anon_sym_namespace] = ACTIONS(1924),
    [anon_sym_using] = ACTIONS(1924),
    [anon_sym_static_assert] = ACTIONS(1924),
    [anon_sym_concept] = ACTIONS(1924),
    [anon_sym_co_return] = ACTIONS(1924),
    [anon_sym_co_yield] = ACTIONS(1924),
    [anon_sym_catch] = ACTIONS(1924),
    [anon_sym_R_DQUOTE] = ACTIONS(1926),
    [anon_sym_LR_DQUOTE] = ACTIONS(1926),
    [anon_sym_uR_DQUOTE] = ACTIONS(1926),
    [anon_sym_UR_DQUOTE] = ACTIONS(1926),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1926),
    [anon_sym_co_await] = ACTIONS(1924),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1924),
    [anon_sym___launch_bounds__] = ACTIONS(1924),
  },
  [325] = {
    [sym_identifier] = ACTIONS(2056),
    [aux_sym_preproc_include_token1] = ACTIONS(2056),
    [aux_sym_preproc_def_token1] = ACTIONS(2056),
    [aux_sym_preproc_if_token1] = ACTIONS(2056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2056),
    [sym_preproc_directive] = ACTIONS(2056),
    [anon_sym_LPAREN2] = ACTIONS(2058),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_DASH] = ACTIONS(2056),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_STAR] = ACTIONS(2058),
    [anon_sym_AMP_AMP] = ACTIONS(2058),
    [anon_sym_AMP] = ACTIONS(2056),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_typedef] = ACTIONS(2056),
    [anon_sym___device__] = ACTIONS(2056),
    [anon_sym___host__] = ACTIONS(2056),
    [anon_sym___global__] = ACTIONS(2056),
    [anon_sym___forceinline__] = ACTIONS(2056),
    [anon_sym___noinline__] = ACTIONS(2056),
    [anon_sym_extern] = ACTIONS(2056),
    [anon_sym___attribute__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2058),
    [anon_sym___declspec] = ACTIONS(2056),
    [anon_sym___based] = ACTIONS(2056),
    [anon_sym___cdecl] = ACTIONS(2056),
    [anon_sym___clrcall] = ACTIONS(2056),
    [anon_sym___stdcall] = ACTIONS(2056),
    [anon_sym___fastcall] = ACTIONS(2056),
    [anon_sym___thiscall] = ACTIONS(2056),
    [anon_sym___vectorcall] = ACTIONS(2056),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_RBRACE] = ACTIONS(2058),
    [anon_sym_signed] = ACTIONS(2056),
    [anon_sym_unsigned] = ACTIONS(2056),
    [anon_sym_long] = ACTIONS(2056),
    [anon_sym_short] = ACTIONS(2056),
    [anon_sym_LBRACK] = ACTIONS(2056),
    [anon_sym_static] = ACTIONS(2056),
    [anon_sym_register] = ACTIONS(2056),
    [anon_sym_inline] = ACTIONS(2056),
    [anon_sym___inline] = ACTIONS(2056),
    [anon_sym___inline__] = ACTIONS(2056),
    [anon_sym___forceinline] = ACTIONS(2056),
    [anon_sym_thread_local] = ACTIONS(2056),
    [anon_sym___thread] = ACTIONS(2056),
    [anon_sym_const] = ACTIONS(2056),
    [anon_sym_constexpr] = ACTIONS(2056),
    [anon_sym_volatile] = ACTIONS(2056),
    [anon_sym_restrict] = ACTIONS(2056),
    [anon_sym___restrict__] = ACTIONS(2056),
    [anon_sym__Atomic] = ACTIONS(2056),
    [anon_sym__Noreturn] = ACTIONS(2056),
    [anon_sym_noreturn] = ACTIONS(2056),
    [anon_sym_mutable] = ACTIONS(2056),
    [anon_sym_constinit] = ACTIONS(2056),
    [anon_sym_consteval] = ACTIONS(2056),
    [anon_sym___shared__] = ACTIONS(2056),
    [anon_sym___local__] = ACTIONS(2056),
    [anon_sym___constant__] = ACTIONS(2056),
    [anon_sym___managed__] = ACTIONS(2056),
    [anon_sym___grid_constant__] = ACTIONS(2056),
    [anon_sym_alignas] = ACTIONS(2056),
    [anon_sym__Alignas] = ACTIONS(2056),
    [sym_primitive_type] = ACTIONS(2056),
    [anon_sym_enum] = ACTIONS(2056),
    [anon_sym_class] = ACTIONS(2056),
    [anon_sym_struct] = ACTIONS(2056),
    [anon_sym_union] = ACTIONS(2056),
    [anon_sym_if] = ACTIONS(2056),
    [anon_sym_else] = ACTIONS(2056),
    [anon_sym_switch] = ACTIONS(2056),
    [anon_sym_case] = ACTIONS(2056),
    [anon_sym_default] = ACTIONS(2056),
    [anon_sym_while] = ACTIONS(2056),
    [anon_sym_do] = ACTIONS(2056),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2056),
    [anon_sym_break] = ACTIONS(2056),
    [anon_sym_continue] = ACTIONS(2056),
    [anon_sym_goto] = ACTIONS(2056),
    [anon_sym___try] = ACTIONS(2056),
    [anon_sym___leave] = ACTIONS(2056),
    [anon_sym_not] = ACTIONS(2056),
    [anon_sym_compl] = ACTIONS(2056),
    [anon_sym_DASH_DASH] = ACTIONS(2058),
    [anon_sym_PLUS_PLUS] = ACTIONS(2058),
    [anon_sym_sizeof] = ACTIONS(2056),
    [anon_sym___alignof__] = ACTIONS(2056),
    [anon_sym___alignof] = ACTIONS(2056),
    [anon_sym__alignof] = ACTIONS(2056),
    [anon_sym_alignof] = ACTIONS(2056),
    [anon_sym__Alignof] = ACTIONS(2056),
    [anon_sym_offsetof] = ACTIONS(2056),
    [anon_sym__Generic] = ACTIONS(2056),
    [anon_sym_asm] = ACTIONS(2056),
    [anon_sym___asm__] = ACTIONS(2056),
    [sym_number_literal] = ACTIONS(2058),
    [anon_sym_L_SQUOTE] = ACTIONS(2058),
    [anon_sym_u_SQUOTE] = ACTIONS(2058),
    [anon_sym_U_SQUOTE] = ACTIONS(2058),
    [anon_sym_u8_SQUOTE] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [anon_sym_L_DQUOTE] = ACTIONS(2058),
    [anon_sym_u_DQUOTE] = ACTIONS(2058),
    [anon_sym_U_DQUOTE] = ACTIONS(2058),
    [anon_sym_u8_DQUOTE] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [sym_true] = ACTIONS(2056),
    [sym_false] = ACTIONS(2056),
    [anon_sym_NULL] = ACTIONS(2056),
    [anon_sym_nullptr] = ACTIONS(2056),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2056),
    [anon_sym_decltype] = ACTIONS(2056),
    [sym_virtual] = ACTIONS(2056),
    [anon_sym_explicit] = ACTIONS(2056),
    [anon_sym_typename] = ACTIONS(2056),
    [anon_sym_template] = ACTIONS(2056),
    [anon_sym_operator] = ACTIONS(2056),
    [anon_sym_try] = ACTIONS(2056),
    [anon_sym_delete] = ACTIONS(2056),
    [anon_sym_throw] = ACTIONS(2056),
    [anon_sym_namespace] = ACTIONS(2056),
    [anon_sym_using] = ACTIONS(2056),
    [anon_sym_static_assert] = ACTIONS(2056),
    [anon_sym_concept] = ACTIONS(2056),
    [anon_sym_co_return] = ACTIONS(2056),
    [anon_sym_co_yield] = ACTIONS(2056),
    [anon_sym_R_DQUOTE] = ACTIONS(2058),
    [anon_sym_LR_DQUOTE] = ACTIONS(2058),
    [anon_sym_uR_DQUOTE] = ACTIONS(2058),
    [anon_sym_UR_DQUOTE] = ACTIONS(2058),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2058),
    [anon_sym_co_await] = ACTIONS(2056),
    [anon_sym_new] = ACTIONS(2056),
    [anon_sym_requires] = ACTIONS(2056),
    [sym_this] = ACTIONS(2056),
    [anon_sym___launch_bounds__] = ACTIONS(2056),
  },
  [326] = {
    [sym_identifier] = ACTIONS(2064),
    [aux_sym_preproc_include_token1] = ACTIONS(2064),
    [aux_sym_preproc_def_token1] = ACTIONS(2064),
    [aux_sym_preproc_if_token1] = ACTIONS(2064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2064),
    [sym_preproc_directive] = ACTIONS(2064),
    [anon_sym_LPAREN2] = ACTIONS(2066),
    [anon_sym_BANG] = ACTIONS(2066),
    [anon_sym_TILDE] = ACTIONS(2066),
    [anon_sym_DASH] = ACTIONS(2064),
    [anon_sym_PLUS] = ACTIONS(2064),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_AMP_AMP] = ACTIONS(2066),
    [anon_sym_AMP] = ACTIONS(2064),
    [anon_sym_SEMI] = ACTIONS(2066),
    [anon_sym___extension__] = ACTIONS(2064),
    [anon_sym_typedef] = ACTIONS(2064),
    [anon_sym___device__] = ACTIONS(2064),
    [anon_sym___host__] = ACTIONS(2064),
    [anon_sym___global__] = ACTIONS(2064),
    [anon_sym___forceinline__] = ACTIONS(2064),
    [anon_sym___noinline__] = ACTIONS(2064),
    [anon_sym_extern] = ACTIONS(2064),
    [anon_sym___attribute__] = ACTIONS(2064),
    [anon_sym_COLON_COLON] = ACTIONS(2066),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2066),
    [anon_sym___declspec] = ACTIONS(2064),
    [anon_sym___based] = ACTIONS(2064),
    [anon_sym___cdecl] = ACTIONS(2064),
    [anon_sym___clrcall] = ACTIONS(2064),
    [anon_sym___stdcall] = ACTIONS(2064),
    [anon_sym___fastcall] = ACTIONS(2064),
    [anon_sym___thiscall] = ACTIONS(2064),
    [anon_sym___vectorcall] = ACTIONS(2064),
    [anon_sym_LBRACE] = ACTIONS(2066),
    [anon_sym_RBRACE] = ACTIONS(2066),
    [anon_sym_signed] = ACTIONS(2064),
    [anon_sym_unsigned] = ACTIONS(2064),
    [anon_sym_long] = ACTIONS(2064),
    [anon_sym_short] = ACTIONS(2064),
    [anon_sym_LBRACK] = ACTIONS(2064),
    [anon_sym_static] = ACTIONS(2064),
    [anon_sym_register] = ACTIONS(2064),
    [anon_sym_inline] = ACTIONS(2064),
    [anon_sym___inline] = ACTIONS(2064),
    [anon_sym___inline__] = ACTIONS(2064),
    [anon_sym___forceinline] = ACTIONS(2064),
    [anon_sym_thread_local] = ACTIONS(2064),
    [anon_sym___thread] = ACTIONS(2064),
    [anon_sym_const] = ACTIONS(2064),
    [anon_sym_constexpr] = ACTIONS(2064),
    [anon_sym_volatile] = ACTIONS(2064),
    [anon_sym_restrict] = ACTIONS(2064),
    [anon_sym___restrict__] = ACTIONS(2064),
    [anon_sym__Atomic] = ACTIONS(2064),
    [anon_sym__Noreturn] = ACTIONS(2064),
    [anon_sym_noreturn] = ACTIONS(2064),
    [anon_sym_mutable] = ACTIONS(2064),
    [anon_sym_constinit] = ACTIONS(2064),
    [anon_sym_consteval] = ACTIONS(2064),
    [anon_sym___shared__] = ACTIONS(2064),
    [anon_sym___local__] = ACTIONS(2064),
    [anon_sym___constant__] = ACTIONS(2064),
    [anon_sym___managed__] = ACTIONS(2064),
    [anon_sym___grid_constant__] = ACTIONS(2064),
    [anon_sym_alignas] = ACTIONS(2064),
    [anon_sym__Alignas] = ACTIONS(2064),
    [sym_primitive_type] = ACTIONS(2064),
    [anon_sym_enum] = ACTIONS(2064),
    [anon_sym_class] = ACTIONS(2064),
    [anon_sym_struct] = ACTIONS(2064),
    [anon_sym_union] = ACTIONS(2064),
    [anon_sym_if] = ACTIONS(2064),
    [anon_sym_else] = ACTIONS(2064),
    [anon_sym_switch] = ACTIONS(2064),
    [anon_sym_case] = ACTIONS(2064),
    [anon_sym_default] = ACTIONS(2064),
    [anon_sym_while] = ACTIONS(2064),
    [anon_sym_do] = ACTIONS(2064),
    [anon_sym_for] = ACTIONS(2064),
    [anon_sym_return] = ACTIONS(2064),
    [anon_sym_break] = ACTIONS(2064),
    [anon_sym_continue] = ACTIONS(2064),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym___try] = ACTIONS(2064),
    [anon_sym___leave] = ACTIONS(2064),
    [anon_sym_not] = ACTIONS(2064),
    [anon_sym_compl] = ACTIONS(2064),
    [anon_sym_DASH_DASH] = ACTIONS(2066),
    [anon_sym_PLUS_PLUS] = ACTIONS(2066),
    [anon_sym_sizeof] = ACTIONS(2064),
    [anon_sym___alignof__] = ACTIONS(2064),
    [anon_sym___alignof] = ACTIONS(2064),
    [anon_sym__alignof] = ACTIONS(2064),
    [anon_sym_alignof] = ACTIONS(2064),
    [anon_sym__Alignof] = ACTIONS(2064),
    [anon_sym_offsetof] = ACTIONS(2064),
    [anon_sym__Generic] = ACTIONS(2064),
    [anon_sym_asm] = ACTIONS(2064),
    [anon_sym___asm__] = ACTIONS(2064),
    [sym_number_literal] = ACTIONS(2066),
    [anon_sym_L_SQUOTE] = ACTIONS(2066),
    [anon_sym_u_SQUOTE] = ACTIONS(2066),
    [anon_sym_U_SQUOTE] = ACTIONS(2066),
    [anon_sym_u8_SQUOTE] = ACTIONS(2066),
    [anon_sym_SQUOTE] = ACTIONS(2066),
    [anon_sym_L_DQUOTE] = ACTIONS(2066),
    [anon_sym_u_DQUOTE] = ACTIONS(2066),
    [anon_sym_U_DQUOTE] = ACTIONS(2066),
    [anon_sym_u8_DQUOTE] = ACTIONS(2066),
    [anon_sym_DQUOTE] = ACTIONS(2066),
    [sym_true] = ACTIONS(2064),
    [sym_false] = ACTIONS(2064),
    [anon_sym_NULL] = ACTIONS(2064),
    [anon_sym_nullptr] = ACTIONS(2064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2064),
    [anon_sym_decltype] = ACTIONS(2064),
    [sym_virtual] = ACTIONS(2064),
    [anon_sym_explicit] = ACTIONS(2064),
    [anon_sym_typename] = ACTIONS(2064),
    [anon_sym_template] = ACTIONS(2064),
    [anon_sym_operator] = ACTIONS(2064),
    [anon_sym_try] = ACTIONS(2064),
    [anon_sym_delete] = ACTIONS(2064),
    [anon_sym_throw] = ACTIONS(2064),
    [anon_sym_namespace] = ACTIONS(2064),
    [anon_sym_using] = ACTIONS(2064),
    [anon_sym_static_assert] = ACTIONS(2064),
    [anon_sym_concept] = ACTIONS(2064),
    [anon_sym_co_return] = ACTIONS(2064),
    [anon_sym_co_yield] = ACTIONS(2064),
    [anon_sym_R_DQUOTE] = ACTIONS(2066),
    [anon_sym_LR_DQUOTE] = ACTIONS(2066),
    [anon_sym_uR_DQUOTE] = ACTIONS(2066),
    [anon_sym_UR_DQUOTE] = ACTIONS(2066),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2066),
    [anon_sym_co_await] = ACTIONS(2064),
    [anon_sym_new] = ACTIONS(2064),
    [anon_sym_requires] = ACTIONS(2064),
    [sym_this] = ACTIONS(2064),
    [anon_sym___launch_bounds__] = ACTIONS(2064),
  },
  [327] = {
    [ts_builtin_sym_end] = ACTIONS(1960),
    [sym_identifier] = ACTIONS(1958),
    [aux_sym_preproc_include_token1] = ACTIONS(1958),
    [aux_sym_preproc_def_token1] = ACTIONS(1958),
    [aux_sym_preproc_if_token1] = ACTIONS(1958),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1958),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1958),
    [sym_preproc_directive] = ACTIONS(1958),
    [anon_sym_LPAREN2] = ACTIONS(1960),
    [anon_sym_BANG] = ACTIONS(1960),
    [anon_sym_TILDE] = ACTIONS(1960),
    [anon_sym_DASH] = ACTIONS(1958),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_STAR] = ACTIONS(1960),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1958),
    [anon_sym_SEMI] = ACTIONS(1960),
    [anon_sym___extension__] = ACTIONS(1958),
    [anon_sym_typedef] = ACTIONS(1958),
    [anon_sym___device__] = ACTIONS(1958),
    [anon_sym___host__] = ACTIONS(1958),
    [anon_sym___global__] = ACTIONS(1958),
    [anon_sym___forceinline__] = ACTIONS(1958),
    [anon_sym___noinline__] = ACTIONS(1958),
    [anon_sym_extern] = ACTIONS(1958),
    [anon_sym___attribute__] = ACTIONS(1958),
    [anon_sym_COLON_COLON] = ACTIONS(1960),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1960),
    [anon_sym___declspec] = ACTIONS(1958),
    [anon_sym___based] = ACTIONS(1958),
    [anon_sym___cdecl] = ACTIONS(1958),
    [anon_sym___clrcall] = ACTIONS(1958),
    [anon_sym___stdcall] = ACTIONS(1958),
    [anon_sym___fastcall] = ACTIONS(1958),
    [anon_sym___thiscall] = ACTIONS(1958),
    [anon_sym___vectorcall] = ACTIONS(1958),
    [anon_sym_LBRACE] = ACTIONS(1960),
    [anon_sym_signed] = ACTIONS(1958),
    [anon_sym_unsigned] = ACTIONS(1958),
    [anon_sym_long] = ACTIONS(1958),
    [anon_sym_short] = ACTIONS(1958),
    [anon_sym_LBRACK] = ACTIONS(1958),
    [anon_sym_static] = ACTIONS(1958),
    [anon_sym_register] = ACTIONS(1958),
    [anon_sym_inline] = ACTIONS(1958),
    [anon_sym___inline] = ACTIONS(1958),
    [anon_sym___inline__] = ACTIONS(1958),
    [anon_sym___forceinline] = ACTIONS(1958),
    [anon_sym_thread_local] = ACTIONS(1958),
    [anon_sym___thread] = ACTIONS(1958),
    [anon_sym_const] = ACTIONS(1958),
    [anon_sym_constexpr] = ACTIONS(1958),
    [anon_sym_volatile] = ACTIONS(1958),
    [anon_sym_restrict] = ACTIONS(1958),
    [anon_sym___restrict__] = ACTIONS(1958),
    [anon_sym__Atomic] = ACTIONS(1958),
    [anon_sym__Noreturn] = ACTIONS(1958),
    [anon_sym_noreturn] = ACTIONS(1958),
    [anon_sym_mutable] = ACTIONS(1958),
    [anon_sym_constinit] = ACTIONS(1958),
    [anon_sym_consteval] = ACTIONS(1958),
    [anon_sym___shared__] = ACTIONS(1958),
    [anon_sym___local__] = ACTIONS(1958),
    [anon_sym___constant__] = ACTIONS(1958),
    [anon_sym___managed__] = ACTIONS(1958),
    [anon_sym___grid_constant__] = ACTIONS(1958),
    [anon_sym_alignas] = ACTIONS(1958),
    [anon_sym__Alignas] = ACTIONS(1958),
    [sym_primitive_type] = ACTIONS(1958),
    [anon_sym_enum] = ACTIONS(1958),
    [anon_sym_class] = ACTIONS(1958),
    [anon_sym_struct] = ACTIONS(1958),
    [anon_sym_union] = ACTIONS(1958),
    [anon_sym_if] = ACTIONS(1958),
    [anon_sym_else] = ACTIONS(1958),
    [anon_sym_switch] = ACTIONS(1958),
    [anon_sym_case] = ACTIONS(1958),
    [anon_sym_default] = ACTIONS(1958),
    [anon_sym_while] = ACTIONS(1958),
    [anon_sym_do] = ACTIONS(1958),
    [anon_sym_for] = ACTIONS(1958),
    [anon_sym_return] = ACTIONS(1958),
    [anon_sym_break] = ACTIONS(1958),
    [anon_sym_continue] = ACTIONS(1958),
    [anon_sym_goto] = ACTIONS(1958),
    [anon_sym___try] = ACTIONS(1958),
    [anon_sym___leave] = ACTIONS(1958),
    [anon_sym_not] = ACTIONS(1958),
    [anon_sym_compl] = ACTIONS(1958),
    [anon_sym_DASH_DASH] = ACTIONS(1960),
    [anon_sym_PLUS_PLUS] = ACTIONS(1960),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1958),
    [anon_sym___alignof] = ACTIONS(1958),
    [anon_sym__alignof] = ACTIONS(1958),
    [anon_sym_alignof] = ACTIONS(1958),
    [anon_sym__Alignof] = ACTIONS(1958),
    [anon_sym_offsetof] = ACTIONS(1958),
    [anon_sym__Generic] = ACTIONS(1958),
    [anon_sym_asm] = ACTIONS(1958),
    [anon_sym___asm__] = ACTIONS(1958),
    [sym_number_literal] = ACTIONS(1960),
    [anon_sym_L_SQUOTE] = ACTIONS(1960),
    [anon_sym_u_SQUOTE] = ACTIONS(1960),
    [anon_sym_U_SQUOTE] = ACTIONS(1960),
    [anon_sym_u8_SQUOTE] = ACTIONS(1960),
    [anon_sym_SQUOTE] = ACTIONS(1960),
    [anon_sym_L_DQUOTE] = ACTIONS(1960),
    [anon_sym_u_DQUOTE] = ACTIONS(1960),
    [anon_sym_U_DQUOTE] = ACTIONS(1960),
    [anon_sym_u8_DQUOTE] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [sym_true] = ACTIONS(1958),
    [sym_false] = ACTIONS(1958),
    [anon_sym_NULL] = ACTIONS(1958),
    [anon_sym_nullptr] = ACTIONS(1958),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1958),
    [anon_sym_decltype] = ACTIONS(1958),
    [sym_virtual] = ACTIONS(1958),
    [anon_sym_explicit] = ACTIONS(1958),
    [anon_sym_typename] = ACTIONS(1958),
    [anon_sym_template] = ACTIONS(1958),
    [anon_sym_operator] = ACTIONS(1958),
    [anon_sym_try] = ACTIONS(1958),
    [anon_sym_delete] = ACTIONS(1958),
    [anon_sym_throw] = ACTIONS(1958),
    [anon_sym_namespace] = ACTIONS(1958),
    [anon_sym_using] = ACTIONS(1958),
    [anon_sym_static_assert] = ACTIONS(1958),
    [anon_sym_concept] = ACTIONS(1958),
    [anon_sym_co_return] = ACTIONS(1958),
    [anon_sym_co_yield] = ACTIONS(1958),
    [anon_sym_R_DQUOTE] = ACTIONS(1960),
    [anon_sym_LR_DQUOTE] = ACTIONS(1960),
    [anon_sym_uR_DQUOTE] = ACTIONS(1960),
    [anon_sym_UR_DQUOTE] = ACTIONS(1960),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1960),
    [anon_sym_co_await] = ACTIONS(1958),
    [anon_sym_new] = ACTIONS(1958),
    [anon_sym_requires] = ACTIONS(1958),
    [sym_this] = ACTIONS(1958),
    [anon_sym___launch_bounds__] = ACTIONS(1958),
  },
  [328] = {
    [ts_builtin_sym_end] = ACTIONS(2058),
    [sym_identifier] = ACTIONS(2056),
    [aux_sym_preproc_include_token1] = ACTIONS(2056),
    [aux_sym_preproc_def_token1] = ACTIONS(2056),
    [aux_sym_preproc_if_token1] = ACTIONS(2056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2056),
    [sym_preproc_directive] = ACTIONS(2056),
    [anon_sym_LPAREN2] = ACTIONS(2058),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_DASH] = ACTIONS(2056),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_STAR] = ACTIONS(2058),
    [anon_sym_AMP_AMP] = ACTIONS(2058),
    [anon_sym_AMP] = ACTIONS(2056),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_typedef] = ACTIONS(2056),
    [anon_sym___device__] = ACTIONS(2056),
    [anon_sym___host__] = ACTIONS(2056),
    [anon_sym___global__] = ACTIONS(2056),
    [anon_sym___forceinline__] = ACTIONS(2056),
    [anon_sym___noinline__] = ACTIONS(2056),
    [anon_sym_extern] = ACTIONS(2056),
    [anon_sym___attribute__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2058),
    [anon_sym___declspec] = ACTIONS(2056),
    [anon_sym___based] = ACTIONS(2056),
    [anon_sym___cdecl] = ACTIONS(2056),
    [anon_sym___clrcall] = ACTIONS(2056),
    [anon_sym___stdcall] = ACTIONS(2056),
    [anon_sym___fastcall] = ACTIONS(2056),
    [anon_sym___thiscall] = ACTIONS(2056),
    [anon_sym___vectorcall] = ACTIONS(2056),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_signed] = ACTIONS(2056),
    [anon_sym_unsigned] = ACTIONS(2056),
    [anon_sym_long] = ACTIONS(2056),
    [anon_sym_short] = ACTIONS(2056),
    [anon_sym_LBRACK] = ACTIONS(2056),
    [anon_sym_static] = ACTIONS(2056),
    [anon_sym_register] = ACTIONS(2056),
    [anon_sym_inline] = ACTIONS(2056),
    [anon_sym___inline] = ACTIONS(2056),
    [anon_sym___inline__] = ACTIONS(2056),
    [anon_sym___forceinline] = ACTIONS(2056),
    [anon_sym_thread_local] = ACTIONS(2056),
    [anon_sym___thread] = ACTIONS(2056),
    [anon_sym_const] = ACTIONS(2056),
    [anon_sym_constexpr] = ACTIONS(2056),
    [anon_sym_volatile] = ACTIONS(2056),
    [anon_sym_restrict] = ACTIONS(2056),
    [anon_sym___restrict__] = ACTIONS(2056),
    [anon_sym__Atomic] = ACTIONS(2056),
    [anon_sym__Noreturn] = ACTIONS(2056),
    [anon_sym_noreturn] = ACTIONS(2056),
    [anon_sym_mutable] = ACTIONS(2056),
    [anon_sym_constinit] = ACTIONS(2056),
    [anon_sym_consteval] = ACTIONS(2056),
    [anon_sym___shared__] = ACTIONS(2056),
    [anon_sym___local__] = ACTIONS(2056),
    [anon_sym___constant__] = ACTIONS(2056),
    [anon_sym___managed__] = ACTIONS(2056),
    [anon_sym___grid_constant__] = ACTIONS(2056),
    [anon_sym_alignas] = ACTIONS(2056),
    [anon_sym__Alignas] = ACTIONS(2056),
    [sym_primitive_type] = ACTIONS(2056),
    [anon_sym_enum] = ACTIONS(2056),
    [anon_sym_class] = ACTIONS(2056),
    [anon_sym_struct] = ACTIONS(2056),
    [anon_sym_union] = ACTIONS(2056),
    [anon_sym_if] = ACTIONS(2056),
    [anon_sym_else] = ACTIONS(2056),
    [anon_sym_switch] = ACTIONS(2056),
    [anon_sym_case] = ACTIONS(2056),
    [anon_sym_default] = ACTIONS(2056),
    [anon_sym_while] = ACTIONS(2056),
    [anon_sym_do] = ACTIONS(2056),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2056),
    [anon_sym_break] = ACTIONS(2056),
    [anon_sym_continue] = ACTIONS(2056),
    [anon_sym_goto] = ACTIONS(2056),
    [anon_sym___try] = ACTIONS(2056),
    [anon_sym___leave] = ACTIONS(2056),
    [anon_sym_not] = ACTIONS(2056),
    [anon_sym_compl] = ACTIONS(2056),
    [anon_sym_DASH_DASH] = ACTIONS(2058),
    [anon_sym_PLUS_PLUS] = ACTIONS(2058),
    [anon_sym_sizeof] = ACTIONS(2056),
    [anon_sym___alignof__] = ACTIONS(2056),
    [anon_sym___alignof] = ACTIONS(2056),
    [anon_sym__alignof] = ACTIONS(2056),
    [anon_sym_alignof] = ACTIONS(2056),
    [anon_sym__Alignof] = ACTIONS(2056),
    [anon_sym_offsetof] = ACTIONS(2056),
    [anon_sym__Generic] = ACTIONS(2056),
    [anon_sym_asm] = ACTIONS(2056),
    [anon_sym___asm__] = ACTIONS(2056),
    [sym_number_literal] = ACTIONS(2058),
    [anon_sym_L_SQUOTE] = ACTIONS(2058),
    [anon_sym_u_SQUOTE] = ACTIONS(2058),
    [anon_sym_U_SQUOTE] = ACTIONS(2058),
    [anon_sym_u8_SQUOTE] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [anon_sym_L_DQUOTE] = ACTIONS(2058),
    [anon_sym_u_DQUOTE] = ACTIONS(2058),
    [anon_sym_U_DQUOTE] = ACTIONS(2058),
    [anon_sym_u8_DQUOTE] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [sym_true] = ACTIONS(2056),
    [sym_false] = ACTIONS(2056),
    [anon_sym_NULL] = ACTIONS(2056),
    [anon_sym_nullptr] = ACTIONS(2056),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2056),
    [anon_sym_decltype] = ACTIONS(2056),
    [sym_virtual] = ACTIONS(2056),
    [anon_sym_explicit] = ACTIONS(2056),
    [anon_sym_typename] = ACTIONS(2056),
    [anon_sym_template] = ACTIONS(2056),
    [anon_sym_operator] = ACTIONS(2056),
    [anon_sym_try] = ACTIONS(2056),
    [anon_sym_delete] = ACTIONS(2056),
    [anon_sym_throw] = ACTIONS(2056),
    [anon_sym_namespace] = ACTIONS(2056),
    [anon_sym_using] = ACTIONS(2056),
    [anon_sym_static_assert] = ACTIONS(2056),
    [anon_sym_concept] = ACTIONS(2056),
    [anon_sym_co_return] = ACTIONS(2056),
    [anon_sym_co_yield] = ACTIONS(2056),
    [anon_sym_R_DQUOTE] = ACTIONS(2058),
    [anon_sym_LR_DQUOTE] = ACTIONS(2058),
    [anon_sym_uR_DQUOTE] = ACTIONS(2058),
    [anon_sym_UR_DQUOTE] = ACTIONS(2058),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2058),
    [anon_sym_co_await] = ACTIONS(2056),
    [anon_sym_new] = ACTIONS(2056),
    [anon_sym_requires] = ACTIONS(2056),
    [sym_this] = ACTIONS(2056),
    [anon_sym___launch_bounds__] = ACTIONS(2056),
  },
  [329] = {
    [sym_identifier] = ACTIONS(2008),
    [aux_sym_preproc_include_token1] = ACTIONS(2008),
    [aux_sym_preproc_def_token1] = ACTIONS(2008),
    [aux_sym_preproc_if_token1] = ACTIONS(2008),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2008),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2008),
    [sym_preproc_directive] = ACTIONS(2008),
    [anon_sym_LPAREN2] = ACTIONS(2010),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_TILDE] = ACTIONS(2010),
    [anon_sym_DASH] = ACTIONS(2008),
    [anon_sym_PLUS] = ACTIONS(2008),
    [anon_sym_STAR] = ACTIONS(2010),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2008),
    [anon_sym_SEMI] = ACTIONS(2010),
    [anon_sym___extension__] = ACTIONS(2008),
    [anon_sym_typedef] = ACTIONS(2008),
    [anon_sym___device__] = ACTIONS(2008),
    [anon_sym___host__] = ACTIONS(2008),
    [anon_sym___global__] = ACTIONS(2008),
    [anon_sym___forceinline__] = ACTIONS(2008),
    [anon_sym___noinline__] = ACTIONS(2008),
    [anon_sym_extern] = ACTIONS(2008),
    [anon_sym___attribute__] = ACTIONS(2008),
    [anon_sym_COLON_COLON] = ACTIONS(2010),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2010),
    [anon_sym___declspec] = ACTIONS(2008),
    [anon_sym___based] = ACTIONS(2008),
    [anon_sym___cdecl] = ACTIONS(2008),
    [anon_sym___clrcall] = ACTIONS(2008),
    [anon_sym___stdcall] = ACTIONS(2008),
    [anon_sym___fastcall] = ACTIONS(2008),
    [anon_sym___thiscall] = ACTIONS(2008),
    [anon_sym___vectorcall] = ACTIONS(2008),
    [anon_sym_LBRACE] = ACTIONS(2010),
    [anon_sym_RBRACE] = ACTIONS(2010),
    [anon_sym_signed] = ACTIONS(2008),
    [anon_sym_unsigned] = ACTIONS(2008),
    [anon_sym_long] = ACTIONS(2008),
    [anon_sym_short] = ACTIONS(2008),
    [anon_sym_LBRACK] = ACTIONS(2008),
    [anon_sym_static] = ACTIONS(2008),
    [anon_sym_register] = ACTIONS(2008),
    [anon_sym_inline] = ACTIONS(2008),
    [anon_sym___inline] = ACTIONS(2008),
    [anon_sym___inline__] = ACTIONS(2008),
    [anon_sym___forceinline] = ACTIONS(2008),
    [anon_sym_thread_local] = ACTIONS(2008),
    [anon_sym___thread] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(2008),
    [anon_sym_constexpr] = ACTIONS(2008),
    [anon_sym_volatile] = ACTIONS(2008),
    [anon_sym_restrict] = ACTIONS(2008),
    [anon_sym___restrict__] = ACTIONS(2008),
    [anon_sym__Atomic] = ACTIONS(2008),
    [anon_sym__Noreturn] = ACTIONS(2008),
    [anon_sym_noreturn] = ACTIONS(2008),
    [anon_sym_mutable] = ACTIONS(2008),
    [anon_sym_constinit] = ACTIONS(2008),
    [anon_sym_consteval] = ACTIONS(2008),
    [anon_sym___shared__] = ACTIONS(2008),
    [anon_sym___local__] = ACTIONS(2008),
    [anon_sym___constant__] = ACTIONS(2008),
    [anon_sym___managed__] = ACTIONS(2008),
    [anon_sym___grid_constant__] = ACTIONS(2008),
    [anon_sym_alignas] = ACTIONS(2008),
    [anon_sym__Alignas] = ACTIONS(2008),
    [sym_primitive_type] = ACTIONS(2008),
    [anon_sym_enum] = ACTIONS(2008),
    [anon_sym_class] = ACTIONS(2008),
    [anon_sym_struct] = ACTIONS(2008),
    [anon_sym_union] = ACTIONS(2008),
    [anon_sym_if] = ACTIONS(2008),
    [anon_sym_else] = ACTIONS(2008),
    [anon_sym_switch] = ACTIONS(2008),
    [anon_sym_case] = ACTIONS(2008),
    [anon_sym_default] = ACTIONS(2008),
    [anon_sym_while] = ACTIONS(2008),
    [anon_sym_do] = ACTIONS(2008),
    [anon_sym_for] = ACTIONS(2008),
    [anon_sym_return] = ACTIONS(2008),
    [anon_sym_break] = ACTIONS(2008),
    [anon_sym_continue] = ACTIONS(2008),
    [anon_sym_goto] = ACTIONS(2008),
    [anon_sym___try] = ACTIONS(2008),
    [anon_sym___leave] = ACTIONS(2008),
    [anon_sym_not] = ACTIONS(2008),
    [anon_sym_compl] = ACTIONS(2008),
    [anon_sym_DASH_DASH] = ACTIONS(2010),
    [anon_sym_PLUS_PLUS] = ACTIONS(2010),
    [anon_sym_sizeof] = ACTIONS(2008),
    [anon_sym___alignof__] = ACTIONS(2008),
    [anon_sym___alignof] = ACTIONS(2008),
    [anon_sym__alignof] = ACTIONS(2008),
    [anon_sym_alignof] = ACTIONS(2008),
    [anon_sym__Alignof] = ACTIONS(2008),
    [anon_sym_offsetof] = ACTIONS(2008),
    [anon_sym__Generic] = ACTIONS(2008),
    [anon_sym_asm] = ACTIONS(2008),
    [anon_sym___asm__] = ACTIONS(2008),
    [sym_number_literal] = ACTIONS(2010),
    [anon_sym_L_SQUOTE] = ACTIONS(2010),
    [anon_sym_u_SQUOTE] = ACTIONS(2010),
    [anon_sym_U_SQUOTE] = ACTIONS(2010),
    [anon_sym_u8_SQUOTE] = ACTIONS(2010),
    [anon_sym_SQUOTE] = ACTIONS(2010),
    [anon_sym_L_DQUOTE] = ACTIONS(2010),
    [anon_sym_u_DQUOTE] = ACTIONS(2010),
    [anon_sym_U_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8_DQUOTE] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [sym_true] = ACTIONS(2008),
    [sym_false] = ACTIONS(2008),
    [anon_sym_NULL] = ACTIONS(2008),
    [anon_sym_nullptr] = ACTIONS(2008),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2008),
    [anon_sym_decltype] = ACTIONS(2008),
    [sym_virtual] = ACTIONS(2008),
    [anon_sym_explicit] = ACTIONS(2008),
    [anon_sym_typename] = ACTIONS(2008),
    [anon_sym_template] = ACTIONS(2008),
    [anon_sym_operator] = ACTIONS(2008),
    [anon_sym_try] = ACTIONS(2008),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_throw] = ACTIONS(2008),
    [anon_sym_namespace] = ACTIONS(2008),
    [anon_sym_using] = ACTIONS(2008),
    [anon_sym_static_assert] = ACTIONS(2008),
    [anon_sym_concept] = ACTIONS(2008),
    [anon_sym_co_return] = ACTIONS(2008),
    [anon_sym_co_yield] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2008),
    [anon_sym_new] = ACTIONS(2008),
    [anon_sym_requires] = ACTIONS(2008),
    [sym_this] = ACTIONS(2008),
    [anon_sym___launch_bounds__] = ACTIONS(2008),
  },
  [330] = {
    [sym_identifier] = ACTIONS(2016),
    [aux_sym_preproc_include_token1] = ACTIONS(2016),
    [aux_sym_preproc_def_token1] = ACTIONS(2016),
    [aux_sym_preproc_if_token1] = ACTIONS(2016),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2016),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2016),
    [sym_preproc_directive] = ACTIONS(2016),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(2018),
    [anon_sym_TILDE] = ACTIONS(2018),
    [anon_sym_DASH] = ACTIONS(2016),
    [anon_sym_PLUS] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(2018),
    [anon_sym_AMP_AMP] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(2016),
    [anon_sym_SEMI] = ACTIONS(2018),
    [anon_sym___extension__] = ACTIONS(2016),
    [anon_sym_typedef] = ACTIONS(2016),
    [anon_sym___device__] = ACTIONS(2016),
    [anon_sym___host__] = ACTIONS(2016),
    [anon_sym___global__] = ACTIONS(2016),
    [anon_sym___forceinline__] = ACTIONS(2016),
    [anon_sym___noinline__] = ACTIONS(2016),
    [anon_sym_extern] = ACTIONS(2016),
    [anon_sym___attribute__] = ACTIONS(2016),
    [anon_sym_COLON_COLON] = ACTIONS(2018),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2018),
    [anon_sym___declspec] = ACTIONS(2016),
    [anon_sym___based] = ACTIONS(2016),
    [anon_sym___cdecl] = ACTIONS(2016),
    [anon_sym___clrcall] = ACTIONS(2016),
    [anon_sym___stdcall] = ACTIONS(2016),
    [anon_sym___fastcall] = ACTIONS(2016),
    [anon_sym___thiscall] = ACTIONS(2016),
    [anon_sym___vectorcall] = ACTIONS(2016),
    [anon_sym_LBRACE] = ACTIONS(2018),
    [anon_sym_RBRACE] = ACTIONS(2018),
    [anon_sym_signed] = ACTIONS(2016),
    [anon_sym_unsigned] = ACTIONS(2016),
    [anon_sym_long] = ACTIONS(2016),
    [anon_sym_short] = ACTIONS(2016),
    [anon_sym_LBRACK] = ACTIONS(2016),
    [anon_sym_static] = ACTIONS(2016),
    [anon_sym_register] = ACTIONS(2016),
    [anon_sym_inline] = ACTIONS(2016),
    [anon_sym___inline] = ACTIONS(2016),
    [anon_sym___inline__] = ACTIONS(2016),
    [anon_sym___forceinline] = ACTIONS(2016),
    [anon_sym_thread_local] = ACTIONS(2016),
    [anon_sym___thread] = ACTIONS(2016),
    [anon_sym_const] = ACTIONS(2016),
    [anon_sym_constexpr] = ACTIONS(2016),
    [anon_sym_volatile] = ACTIONS(2016),
    [anon_sym_restrict] = ACTIONS(2016),
    [anon_sym___restrict__] = ACTIONS(2016),
    [anon_sym__Atomic] = ACTIONS(2016),
    [anon_sym__Noreturn] = ACTIONS(2016),
    [anon_sym_noreturn] = ACTIONS(2016),
    [anon_sym_mutable] = ACTIONS(2016),
    [anon_sym_constinit] = ACTIONS(2016),
    [anon_sym_consteval] = ACTIONS(2016),
    [anon_sym___shared__] = ACTIONS(2016),
    [anon_sym___local__] = ACTIONS(2016),
    [anon_sym___constant__] = ACTIONS(2016),
    [anon_sym___managed__] = ACTIONS(2016),
    [anon_sym___grid_constant__] = ACTIONS(2016),
    [anon_sym_alignas] = ACTIONS(2016),
    [anon_sym__Alignas] = ACTIONS(2016),
    [sym_primitive_type] = ACTIONS(2016),
    [anon_sym_enum] = ACTIONS(2016),
    [anon_sym_class] = ACTIONS(2016),
    [anon_sym_struct] = ACTIONS(2016),
    [anon_sym_union] = ACTIONS(2016),
    [anon_sym_if] = ACTIONS(2016),
    [anon_sym_else] = ACTIONS(2016),
    [anon_sym_switch] = ACTIONS(2016),
    [anon_sym_case] = ACTIONS(2016),
    [anon_sym_default] = ACTIONS(2016),
    [anon_sym_while] = ACTIONS(2016),
    [anon_sym_do] = ACTIONS(2016),
    [anon_sym_for] = ACTIONS(2016),
    [anon_sym_return] = ACTIONS(2016),
    [anon_sym_break] = ACTIONS(2016),
    [anon_sym_continue] = ACTIONS(2016),
    [anon_sym_goto] = ACTIONS(2016),
    [anon_sym___try] = ACTIONS(2016),
    [anon_sym___leave] = ACTIONS(2016),
    [anon_sym_not] = ACTIONS(2016),
    [anon_sym_compl] = ACTIONS(2016),
    [anon_sym_DASH_DASH] = ACTIONS(2018),
    [anon_sym_PLUS_PLUS] = ACTIONS(2018),
    [anon_sym_sizeof] = ACTIONS(2016),
    [anon_sym___alignof__] = ACTIONS(2016),
    [anon_sym___alignof] = ACTIONS(2016),
    [anon_sym__alignof] = ACTIONS(2016),
    [anon_sym_alignof] = ACTIONS(2016),
    [anon_sym__Alignof] = ACTIONS(2016),
    [anon_sym_offsetof] = ACTIONS(2016),
    [anon_sym__Generic] = ACTIONS(2016),
    [anon_sym_asm] = ACTIONS(2016),
    [anon_sym___asm__] = ACTIONS(2016),
    [sym_number_literal] = ACTIONS(2018),
    [anon_sym_L_SQUOTE] = ACTIONS(2018),
    [anon_sym_u_SQUOTE] = ACTIONS(2018),
    [anon_sym_U_SQUOTE] = ACTIONS(2018),
    [anon_sym_u8_SQUOTE] = ACTIONS(2018),
    [anon_sym_SQUOTE] = ACTIONS(2018),
    [anon_sym_L_DQUOTE] = ACTIONS(2018),
    [anon_sym_u_DQUOTE] = ACTIONS(2018),
    [anon_sym_U_DQUOTE] = ACTIONS(2018),
    [anon_sym_u8_DQUOTE] = ACTIONS(2018),
    [anon_sym_DQUOTE] = ACTIONS(2018),
    [sym_true] = ACTIONS(2016),
    [sym_false] = ACTIONS(2016),
    [anon_sym_NULL] = ACTIONS(2016),
    [anon_sym_nullptr] = ACTIONS(2016),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2016),
    [anon_sym_decltype] = ACTIONS(2016),
    [sym_virtual] = ACTIONS(2016),
    [anon_sym_explicit] = ACTIONS(2016),
    [anon_sym_typename] = ACTIONS(2016),
    [anon_sym_template] = ACTIONS(2016),
    [anon_sym_operator] = ACTIONS(2016),
    [anon_sym_try] = ACTIONS(2016),
    [anon_sym_delete] = ACTIONS(2016),
    [anon_sym_throw] = ACTIONS(2016),
    [anon_sym_namespace] = ACTIONS(2016),
    [anon_sym_using] = ACTIONS(2016),
    [anon_sym_static_assert] = ACTIONS(2016),
    [anon_sym_concept] = ACTIONS(2016),
    [anon_sym_co_return] = ACTIONS(2016),
    [anon_sym_co_yield] = ACTIONS(2016),
    [anon_sym_R_DQUOTE] = ACTIONS(2018),
    [anon_sym_LR_DQUOTE] = ACTIONS(2018),
    [anon_sym_uR_DQUOTE] = ACTIONS(2018),
    [anon_sym_UR_DQUOTE] = ACTIONS(2018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2018),
    [anon_sym_co_await] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2016),
    [anon_sym_requires] = ACTIONS(2016),
    [sym_this] = ACTIONS(2016),
    [anon_sym___launch_bounds__] = ACTIONS(2016),
  },
  [331] = {
    [sym_identifier] = ACTIONS(2076),
    [aux_sym_preproc_include_token1] = ACTIONS(2076),
    [aux_sym_preproc_def_token1] = ACTIONS(2076),
    [aux_sym_preproc_if_token1] = ACTIONS(2076),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2076),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2076),
    [sym_preproc_directive] = ACTIONS(2076),
    [anon_sym_LPAREN2] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2078),
    [anon_sym_TILDE] = ACTIONS(2078),
    [anon_sym_DASH] = ACTIONS(2076),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_STAR] = ACTIONS(2078),
    [anon_sym_AMP_AMP] = ACTIONS(2078),
    [anon_sym_AMP] = ACTIONS(2076),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym___extension__] = ACTIONS(2076),
    [anon_sym_typedef] = ACTIONS(2076),
    [anon_sym___device__] = ACTIONS(2076),
    [anon_sym___host__] = ACTIONS(2076),
    [anon_sym___global__] = ACTIONS(2076),
    [anon_sym___forceinline__] = ACTIONS(2076),
    [anon_sym___noinline__] = ACTIONS(2076),
    [anon_sym_extern] = ACTIONS(2076),
    [anon_sym___attribute__] = ACTIONS(2076),
    [anon_sym_COLON_COLON] = ACTIONS(2078),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2078),
    [anon_sym___declspec] = ACTIONS(2076),
    [anon_sym___based] = ACTIONS(2076),
    [anon_sym___cdecl] = ACTIONS(2076),
    [anon_sym___clrcall] = ACTIONS(2076),
    [anon_sym___stdcall] = ACTIONS(2076),
    [anon_sym___fastcall] = ACTIONS(2076),
    [anon_sym___thiscall] = ACTIONS(2076),
    [anon_sym___vectorcall] = ACTIONS(2076),
    [anon_sym_LBRACE] = ACTIONS(2078),
    [anon_sym_RBRACE] = ACTIONS(2078),
    [anon_sym_signed] = ACTIONS(2076),
    [anon_sym_unsigned] = ACTIONS(2076),
    [anon_sym_long] = ACTIONS(2076),
    [anon_sym_short] = ACTIONS(2076),
    [anon_sym_LBRACK] = ACTIONS(2076),
    [anon_sym_static] = ACTIONS(2076),
    [anon_sym_register] = ACTIONS(2076),
    [anon_sym_inline] = ACTIONS(2076),
    [anon_sym___inline] = ACTIONS(2076),
    [anon_sym___inline__] = ACTIONS(2076),
    [anon_sym___forceinline] = ACTIONS(2076),
    [anon_sym_thread_local] = ACTIONS(2076),
    [anon_sym___thread] = ACTIONS(2076),
    [anon_sym_const] = ACTIONS(2076),
    [anon_sym_constexpr] = ACTIONS(2076),
    [anon_sym_volatile] = ACTIONS(2076),
    [anon_sym_restrict] = ACTIONS(2076),
    [anon_sym___restrict__] = ACTIONS(2076),
    [anon_sym__Atomic] = ACTIONS(2076),
    [anon_sym__Noreturn] = ACTIONS(2076),
    [anon_sym_noreturn] = ACTIONS(2076),
    [anon_sym_mutable] = ACTIONS(2076),
    [anon_sym_constinit] = ACTIONS(2076),
    [anon_sym_consteval] = ACTIONS(2076),
    [anon_sym___shared__] = ACTIONS(2076),
    [anon_sym___local__] = ACTIONS(2076),
    [anon_sym___constant__] = ACTIONS(2076),
    [anon_sym___managed__] = ACTIONS(2076),
    [anon_sym___grid_constant__] = ACTIONS(2076),
    [anon_sym_alignas] = ACTIONS(2076),
    [anon_sym__Alignas] = ACTIONS(2076),
    [sym_primitive_type] = ACTIONS(2076),
    [anon_sym_enum] = ACTIONS(2076),
    [anon_sym_class] = ACTIONS(2076),
    [anon_sym_struct] = ACTIONS(2076),
    [anon_sym_union] = ACTIONS(2076),
    [anon_sym_if] = ACTIONS(2076),
    [anon_sym_else] = ACTIONS(2076),
    [anon_sym_switch] = ACTIONS(2076),
    [anon_sym_case] = ACTIONS(2076),
    [anon_sym_default] = ACTIONS(2076),
    [anon_sym_while] = ACTIONS(2076),
    [anon_sym_do] = ACTIONS(2076),
    [anon_sym_for] = ACTIONS(2076),
    [anon_sym_return] = ACTIONS(2076),
    [anon_sym_break] = ACTIONS(2076),
    [anon_sym_continue] = ACTIONS(2076),
    [anon_sym_goto] = ACTIONS(2076),
    [anon_sym___try] = ACTIONS(2076),
    [anon_sym___leave] = ACTIONS(2076),
    [anon_sym_not] = ACTIONS(2076),
    [anon_sym_compl] = ACTIONS(2076),
    [anon_sym_DASH_DASH] = ACTIONS(2078),
    [anon_sym_PLUS_PLUS] = ACTIONS(2078),
    [anon_sym_sizeof] = ACTIONS(2076),
    [anon_sym___alignof__] = ACTIONS(2076),
    [anon_sym___alignof] = ACTIONS(2076),
    [anon_sym__alignof] = ACTIONS(2076),
    [anon_sym_alignof] = ACTIONS(2076),
    [anon_sym__Alignof] = ACTIONS(2076),
    [anon_sym_offsetof] = ACTIONS(2076),
    [anon_sym__Generic] = ACTIONS(2076),
    [anon_sym_asm] = ACTIONS(2076),
    [anon_sym___asm__] = ACTIONS(2076),
    [sym_number_literal] = ACTIONS(2078),
    [anon_sym_L_SQUOTE] = ACTIONS(2078),
    [anon_sym_u_SQUOTE] = ACTIONS(2078),
    [anon_sym_U_SQUOTE] = ACTIONS(2078),
    [anon_sym_u8_SQUOTE] = ACTIONS(2078),
    [anon_sym_SQUOTE] = ACTIONS(2078),
    [anon_sym_L_DQUOTE] = ACTIONS(2078),
    [anon_sym_u_DQUOTE] = ACTIONS(2078),
    [anon_sym_U_DQUOTE] = ACTIONS(2078),
    [anon_sym_u8_DQUOTE] = ACTIONS(2078),
    [anon_sym_DQUOTE] = ACTIONS(2078),
    [sym_true] = ACTIONS(2076),
    [sym_false] = ACTIONS(2076),
    [anon_sym_NULL] = ACTIONS(2076),
    [anon_sym_nullptr] = ACTIONS(2076),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2076),
    [anon_sym_decltype] = ACTIONS(2076),
    [sym_virtual] = ACTIONS(2076),
    [anon_sym_explicit] = ACTIONS(2076),
    [anon_sym_typename] = ACTIONS(2076),
    [anon_sym_template] = ACTIONS(2076),
    [anon_sym_operator] = ACTIONS(2076),
    [anon_sym_try] = ACTIONS(2076),
    [anon_sym_delete] = ACTIONS(2076),
    [anon_sym_throw] = ACTIONS(2076),
    [anon_sym_namespace] = ACTIONS(2076),
    [anon_sym_using] = ACTIONS(2076),
    [anon_sym_static_assert] = ACTIONS(2076),
    [anon_sym_concept] = ACTIONS(2076),
    [anon_sym_co_return] = ACTIONS(2076),
    [anon_sym_co_yield] = ACTIONS(2076),
    [anon_sym_R_DQUOTE] = ACTIONS(2078),
    [anon_sym_LR_DQUOTE] = ACTIONS(2078),
    [anon_sym_uR_DQUOTE] = ACTIONS(2078),
    [anon_sym_UR_DQUOTE] = ACTIONS(2078),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2078),
    [anon_sym_co_await] = ACTIONS(2076),
    [anon_sym_new] = ACTIONS(2076),
    [anon_sym_requires] = ACTIONS(2076),
    [sym_this] = ACTIONS(2076),
    [anon_sym___launch_bounds__] = ACTIONS(2076),
  },
  [332] = {
    [sym_identifier] = ACTIONS(2072),
    [aux_sym_preproc_include_token1] = ACTIONS(2072),
    [aux_sym_preproc_def_token1] = ACTIONS(2072),
    [aux_sym_preproc_if_token1] = ACTIONS(2072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2072),
    [sym_preproc_directive] = ACTIONS(2072),
    [anon_sym_LPAREN2] = ACTIONS(2074),
    [anon_sym_BANG] = ACTIONS(2074),
    [anon_sym_TILDE] = ACTIONS(2074),
    [anon_sym_DASH] = ACTIONS(2072),
    [anon_sym_PLUS] = ACTIONS(2072),
    [anon_sym_STAR] = ACTIONS(2074),
    [anon_sym_AMP_AMP] = ACTIONS(2074),
    [anon_sym_AMP] = ACTIONS(2072),
    [anon_sym_SEMI] = ACTIONS(2074),
    [anon_sym___extension__] = ACTIONS(2072),
    [anon_sym_typedef] = ACTIONS(2072),
    [anon_sym___device__] = ACTIONS(2072),
    [anon_sym___host__] = ACTIONS(2072),
    [anon_sym___global__] = ACTIONS(2072),
    [anon_sym___forceinline__] = ACTIONS(2072),
    [anon_sym___noinline__] = ACTIONS(2072),
    [anon_sym_extern] = ACTIONS(2072),
    [anon_sym___attribute__] = ACTIONS(2072),
    [anon_sym_COLON_COLON] = ACTIONS(2074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2074),
    [anon_sym___declspec] = ACTIONS(2072),
    [anon_sym___based] = ACTIONS(2072),
    [anon_sym___cdecl] = ACTIONS(2072),
    [anon_sym___clrcall] = ACTIONS(2072),
    [anon_sym___stdcall] = ACTIONS(2072),
    [anon_sym___fastcall] = ACTIONS(2072),
    [anon_sym___thiscall] = ACTIONS(2072),
    [anon_sym___vectorcall] = ACTIONS(2072),
    [anon_sym_LBRACE] = ACTIONS(2074),
    [anon_sym_RBRACE] = ACTIONS(2074),
    [anon_sym_signed] = ACTIONS(2072),
    [anon_sym_unsigned] = ACTIONS(2072),
    [anon_sym_long] = ACTIONS(2072),
    [anon_sym_short] = ACTIONS(2072),
    [anon_sym_LBRACK] = ACTIONS(2072),
    [anon_sym_static] = ACTIONS(2072),
    [anon_sym_register] = ACTIONS(2072),
    [anon_sym_inline] = ACTIONS(2072),
    [anon_sym___inline] = ACTIONS(2072),
    [anon_sym___inline__] = ACTIONS(2072),
    [anon_sym___forceinline] = ACTIONS(2072),
    [anon_sym_thread_local] = ACTIONS(2072),
    [anon_sym___thread] = ACTIONS(2072),
    [anon_sym_const] = ACTIONS(2072),
    [anon_sym_constexpr] = ACTIONS(2072),
    [anon_sym_volatile] = ACTIONS(2072),
    [anon_sym_restrict] = ACTIONS(2072),
    [anon_sym___restrict__] = ACTIONS(2072),
    [anon_sym__Atomic] = ACTIONS(2072),
    [anon_sym__Noreturn] = ACTIONS(2072),
    [anon_sym_noreturn] = ACTIONS(2072),
    [anon_sym_mutable] = ACTIONS(2072),
    [anon_sym_constinit] = ACTIONS(2072),
    [anon_sym_consteval] = ACTIONS(2072),
    [anon_sym___shared__] = ACTIONS(2072),
    [anon_sym___local__] = ACTIONS(2072),
    [anon_sym___constant__] = ACTIONS(2072),
    [anon_sym___managed__] = ACTIONS(2072),
    [anon_sym___grid_constant__] = ACTIONS(2072),
    [anon_sym_alignas] = ACTIONS(2072),
    [anon_sym__Alignas] = ACTIONS(2072),
    [sym_primitive_type] = ACTIONS(2072),
    [anon_sym_enum] = ACTIONS(2072),
    [anon_sym_class] = ACTIONS(2072),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2072),
    [anon_sym_if] = ACTIONS(2072),
    [anon_sym_else] = ACTIONS(2072),
    [anon_sym_switch] = ACTIONS(2072),
    [anon_sym_case] = ACTIONS(2072),
    [anon_sym_default] = ACTIONS(2072),
    [anon_sym_while] = ACTIONS(2072),
    [anon_sym_do] = ACTIONS(2072),
    [anon_sym_for] = ACTIONS(2072),
    [anon_sym_return] = ACTIONS(2072),
    [anon_sym_break] = ACTIONS(2072),
    [anon_sym_continue] = ACTIONS(2072),
    [anon_sym_goto] = ACTIONS(2072),
    [anon_sym___try] = ACTIONS(2072),
    [anon_sym___leave] = ACTIONS(2072),
    [anon_sym_not] = ACTIONS(2072),
    [anon_sym_compl] = ACTIONS(2072),
    [anon_sym_DASH_DASH] = ACTIONS(2074),
    [anon_sym_PLUS_PLUS] = ACTIONS(2074),
    [anon_sym_sizeof] = ACTIONS(2072),
    [anon_sym___alignof__] = ACTIONS(2072),
    [anon_sym___alignof] = ACTIONS(2072),
    [anon_sym__alignof] = ACTIONS(2072),
    [anon_sym_alignof] = ACTIONS(2072),
    [anon_sym__Alignof] = ACTIONS(2072),
    [anon_sym_offsetof] = ACTIONS(2072),
    [anon_sym__Generic] = ACTIONS(2072),
    [anon_sym_asm] = ACTIONS(2072),
    [anon_sym___asm__] = ACTIONS(2072),
    [sym_number_literal] = ACTIONS(2074),
    [anon_sym_L_SQUOTE] = ACTIONS(2074),
    [anon_sym_u_SQUOTE] = ACTIONS(2074),
    [anon_sym_U_SQUOTE] = ACTIONS(2074),
    [anon_sym_u8_SQUOTE] = ACTIONS(2074),
    [anon_sym_SQUOTE] = ACTIONS(2074),
    [anon_sym_L_DQUOTE] = ACTIONS(2074),
    [anon_sym_u_DQUOTE] = ACTIONS(2074),
    [anon_sym_U_DQUOTE] = ACTIONS(2074),
    [anon_sym_u8_DQUOTE] = ACTIONS(2074),
    [anon_sym_DQUOTE] = ACTIONS(2074),
    [sym_true] = ACTIONS(2072),
    [sym_false] = ACTIONS(2072),
    [anon_sym_NULL] = ACTIONS(2072),
    [anon_sym_nullptr] = ACTIONS(2072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2072),
    [anon_sym_decltype] = ACTIONS(2072),
    [sym_virtual] = ACTIONS(2072),
    [anon_sym_explicit] = ACTIONS(2072),
    [anon_sym_typename] = ACTIONS(2072),
    [anon_sym_template] = ACTIONS(2072),
    [anon_sym_operator] = ACTIONS(2072),
    [anon_sym_try] = ACTIONS(2072),
    [anon_sym_delete] = ACTIONS(2072),
    [anon_sym_throw] = ACTIONS(2072),
    [anon_sym_namespace] = ACTIONS(2072),
    [anon_sym_using] = ACTIONS(2072),
    [anon_sym_static_assert] = ACTIONS(2072),
    [anon_sym_concept] = ACTIONS(2072),
    [anon_sym_co_return] = ACTIONS(2072),
    [anon_sym_co_yield] = ACTIONS(2072),
    [anon_sym_R_DQUOTE] = ACTIONS(2074),
    [anon_sym_LR_DQUOTE] = ACTIONS(2074),
    [anon_sym_uR_DQUOTE] = ACTIONS(2074),
    [anon_sym_UR_DQUOTE] = ACTIONS(2074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2074),
    [anon_sym_co_await] = ACTIONS(2072),
    [anon_sym_new] = ACTIONS(2072),
    [anon_sym_requires] = ACTIONS(2072),
    [sym_this] = ACTIONS(2072),
    [anon_sym___launch_bounds__] = ACTIONS(2072),
  },
  [333] = {
    [sym_identifier] = ACTIONS(1942),
    [aux_sym_preproc_include_token1] = ACTIONS(1942),
    [aux_sym_preproc_def_token1] = ACTIONS(1942),
    [aux_sym_preproc_if_token1] = ACTIONS(1942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1942),
    [sym_preproc_directive] = ACTIONS(1942),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(1944),
    [anon_sym_TILDE] = ACTIONS(1944),
    [anon_sym_DASH] = ACTIONS(1942),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym_SEMI] = ACTIONS(1944),
    [anon_sym___extension__] = ACTIONS(1942),
    [anon_sym_typedef] = ACTIONS(1942),
    [anon_sym___device__] = ACTIONS(1942),
    [anon_sym___host__] = ACTIONS(1942),
    [anon_sym___global__] = ACTIONS(1942),
    [anon_sym___forceinline__] = ACTIONS(1942),
    [anon_sym___noinline__] = ACTIONS(1942),
    [anon_sym_extern] = ACTIONS(1942),
    [anon_sym___attribute__] = ACTIONS(1942),
    [anon_sym_COLON_COLON] = ACTIONS(1944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1944),
    [anon_sym___declspec] = ACTIONS(1942),
    [anon_sym___based] = ACTIONS(1942),
    [anon_sym___cdecl] = ACTIONS(1942),
    [anon_sym___clrcall] = ACTIONS(1942),
    [anon_sym___stdcall] = ACTIONS(1942),
    [anon_sym___fastcall] = ACTIONS(1942),
    [anon_sym___thiscall] = ACTIONS(1942),
    [anon_sym___vectorcall] = ACTIONS(1942),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_RBRACE] = ACTIONS(1944),
    [anon_sym_signed] = ACTIONS(1942),
    [anon_sym_unsigned] = ACTIONS(1942),
    [anon_sym_long] = ACTIONS(1942),
    [anon_sym_short] = ACTIONS(1942),
    [anon_sym_LBRACK] = ACTIONS(1942),
    [anon_sym_static] = ACTIONS(1942),
    [anon_sym_register] = ACTIONS(1942),
    [anon_sym_inline] = ACTIONS(1942),
    [anon_sym___inline] = ACTIONS(1942),
    [anon_sym___inline__] = ACTIONS(1942),
    [anon_sym___forceinline] = ACTIONS(1942),
    [anon_sym_thread_local] = ACTIONS(1942),
    [anon_sym___thread] = ACTIONS(1942),
    [anon_sym_const] = ACTIONS(1942),
    [anon_sym_constexpr] = ACTIONS(1942),
    [anon_sym_volatile] = ACTIONS(1942),
    [anon_sym_restrict] = ACTIONS(1942),
    [anon_sym___restrict__] = ACTIONS(1942),
    [anon_sym__Atomic] = ACTIONS(1942),
    [anon_sym__Noreturn] = ACTIONS(1942),
    [anon_sym_noreturn] = ACTIONS(1942),
    [anon_sym_mutable] = ACTIONS(1942),
    [anon_sym_constinit] = ACTIONS(1942),
    [anon_sym_consteval] = ACTIONS(1942),
    [anon_sym___shared__] = ACTIONS(1942),
    [anon_sym___local__] = ACTIONS(1942),
    [anon_sym___constant__] = ACTIONS(1942),
    [anon_sym___managed__] = ACTIONS(1942),
    [anon_sym___grid_constant__] = ACTIONS(1942),
    [anon_sym_alignas] = ACTIONS(1942),
    [anon_sym__Alignas] = ACTIONS(1942),
    [sym_primitive_type] = ACTIONS(1942),
    [anon_sym_enum] = ACTIONS(1942),
    [anon_sym_class] = ACTIONS(1942),
    [anon_sym_struct] = ACTIONS(1942),
    [anon_sym_union] = ACTIONS(1942),
    [anon_sym_if] = ACTIONS(1942),
    [anon_sym_else] = ACTIONS(1942),
    [anon_sym_switch] = ACTIONS(1942),
    [anon_sym_case] = ACTIONS(1942),
    [anon_sym_default] = ACTIONS(1942),
    [anon_sym_while] = ACTIONS(1942),
    [anon_sym_do] = ACTIONS(1942),
    [anon_sym_for] = ACTIONS(1942),
    [anon_sym_return] = ACTIONS(1942),
    [anon_sym_break] = ACTIONS(1942),
    [anon_sym_continue] = ACTIONS(1942),
    [anon_sym_goto] = ACTIONS(1942),
    [anon_sym___try] = ACTIONS(1942),
    [anon_sym___leave] = ACTIONS(1942),
    [anon_sym_not] = ACTIONS(1942),
    [anon_sym_compl] = ACTIONS(1942),
    [anon_sym_DASH_DASH] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1944),
    [anon_sym_sizeof] = ACTIONS(1942),
    [anon_sym___alignof__] = ACTIONS(1942),
    [anon_sym___alignof] = ACTIONS(1942),
    [anon_sym__alignof] = ACTIONS(1942),
    [anon_sym_alignof] = ACTIONS(1942),
    [anon_sym__Alignof] = ACTIONS(1942),
    [anon_sym_offsetof] = ACTIONS(1942),
    [anon_sym__Generic] = ACTIONS(1942),
    [anon_sym_asm] = ACTIONS(1942),
    [anon_sym___asm__] = ACTIONS(1942),
    [sym_number_literal] = ACTIONS(1944),
    [anon_sym_L_SQUOTE] = ACTIONS(1944),
    [anon_sym_u_SQUOTE] = ACTIONS(1944),
    [anon_sym_U_SQUOTE] = ACTIONS(1944),
    [anon_sym_u8_SQUOTE] = ACTIONS(1944),
    [anon_sym_SQUOTE] = ACTIONS(1944),
    [anon_sym_L_DQUOTE] = ACTIONS(1944),
    [anon_sym_u_DQUOTE] = ACTIONS(1944),
    [anon_sym_U_DQUOTE] = ACTIONS(1944),
    [anon_sym_u8_DQUOTE] = ACTIONS(1944),
    [anon_sym_DQUOTE] = ACTIONS(1944),
    [sym_true] = ACTIONS(1942),
    [sym_false] = ACTIONS(1942),
    [anon_sym_NULL] = ACTIONS(1942),
    [anon_sym_nullptr] = ACTIONS(1942),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1942),
    [anon_sym_decltype] = ACTIONS(1942),
    [sym_virtual] = ACTIONS(1942),
    [anon_sym_explicit] = ACTIONS(1942),
    [anon_sym_typename] = ACTIONS(1942),
    [anon_sym_template] = ACTIONS(1942),
    [anon_sym_operator] = ACTIONS(1942),
    [anon_sym_try] = ACTIONS(1942),
    [anon_sym_delete] = ACTIONS(1942),
    [anon_sym_throw] = ACTIONS(1942),
    [anon_sym_namespace] = ACTIONS(1942),
    [anon_sym_using] = ACTIONS(1942),
    [anon_sym_static_assert] = ACTIONS(1942),
    [anon_sym_concept] = ACTIONS(1942),
    [anon_sym_co_return] = ACTIONS(1942),
    [anon_sym_co_yield] = ACTIONS(1942),
    [anon_sym_R_DQUOTE] = ACTIONS(1944),
    [anon_sym_LR_DQUOTE] = ACTIONS(1944),
    [anon_sym_uR_DQUOTE] = ACTIONS(1944),
    [anon_sym_UR_DQUOTE] = ACTIONS(1944),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1944),
    [anon_sym_co_await] = ACTIONS(1942),
    [anon_sym_new] = ACTIONS(1942),
    [anon_sym_requires] = ACTIONS(1942),
    [sym_this] = ACTIONS(1942),
    [anon_sym___launch_bounds__] = ACTIONS(1942),
  },
  [334] = {
    [sym_identifier] = ACTIONS(1942),
    [aux_sym_preproc_include_token1] = ACTIONS(1942),
    [aux_sym_preproc_def_token1] = ACTIONS(1942),
    [aux_sym_preproc_if_token1] = ACTIONS(1942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1942),
    [sym_preproc_directive] = ACTIONS(1942),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(1944),
    [anon_sym_TILDE] = ACTIONS(1944),
    [anon_sym_DASH] = ACTIONS(1942),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym_SEMI] = ACTIONS(1944),
    [anon_sym___extension__] = ACTIONS(1942),
    [anon_sym_typedef] = ACTIONS(1942),
    [anon_sym___device__] = ACTIONS(1942),
    [anon_sym___host__] = ACTIONS(1942),
    [anon_sym___global__] = ACTIONS(1942),
    [anon_sym___forceinline__] = ACTIONS(1942),
    [anon_sym___noinline__] = ACTIONS(1942),
    [anon_sym_extern] = ACTIONS(1942),
    [anon_sym___attribute__] = ACTIONS(1942),
    [anon_sym_COLON_COLON] = ACTIONS(1944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1944),
    [anon_sym___declspec] = ACTIONS(1942),
    [anon_sym___based] = ACTIONS(1942),
    [anon_sym___cdecl] = ACTIONS(1942),
    [anon_sym___clrcall] = ACTIONS(1942),
    [anon_sym___stdcall] = ACTIONS(1942),
    [anon_sym___fastcall] = ACTIONS(1942),
    [anon_sym___thiscall] = ACTIONS(1942),
    [anon_sym___vectorcall] = ACTIONS(1942),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_RBRACE] = ACTIONS(1944),
    [anon_sym_signed] = ACTIONS(1942),
    [anon_sym_unsigned] = ACTIONS(1942),
    [anon_sym_long] = ACTIONS(1942),
    [anon_sym_short] = ACTIONS(1942),
    [anon_sym_LBRACK] = ACTIONS(1942),
    [anon_sym_static] = ACTIONS(1942),
    [anon_sym_register] = ACTIONS(1942),
    [anon_sym_inline] = ACTIONS(1942),
    [anon_sym___inline] = ACTIONS(1942),
    [anon_sym___inline__] = ACTIONS(1942),
    [anon_sym___forceinline] = ACTIONS(1942),
    [anon_sym_thread_local] = ACTIONS(1942),
    [anon_sym___thread] = ACTIONS(1942),
    [anon_sym_const] = ACTIONS(1942),
    [anon_sym_constexpr] = ACTIONS(1942),
    [anon_sym_volatile] = ACTIONS(1942),
    [anon_sym_restrict] = ACTIONS(1942),
    [anon_sym___restrict__] = ACTIONS(1942),
    [anon_sym__Atomic] = ACTIONS(1942),
    [anon_sym__Noreturn] = ACTIONS(1942),
    [anon_sym_noreturn] = ACTIONS(1942),
    [anon_sym_mutable] = ACTIONS(1942),
    [anon_sym_constinit] = ACTIONS(1942),
    [anon_sym_consteval] = ACTIONS(1942),
    [anon_sym___shared__] = ACTIONS(1942),
    [anon_sym___local__] = ACTIONS(1942),
    [anon_sym___constant__] = ACTIONS(1942),
    [anon_sym___managed__] = ACTIONS(1942),
    [anon_sym___grid_constant__] = ACTIONS(1942),
    [anon_sym_alignas] = ACTIONS(1942),
    [anon_sym__Alignas] = ACTIONS(1942),
    [sym_primitive_type] = ACTIONS(1942),
    [anon_sym_enum] = ACTIONS(1942),
    [anon_sym_class] = ACTIONS(1942),
    [anon_sym_struct] = ACTIONS(1942),
    [anon_sym_union] = ACTIONS(1942),
    [anon_sym_if] = ACTIONS(1942),
    [anon_sym_else] = ACTIONS(1942),
    [anon_sym_switch] = ACTIONS(1942),
    [anon_sym_case] = ACTIONS(1942),
    [anon_sym_default] = ACTIONS(1942),
    [anon_sym_while] = ACTIONS(1942),
    [anon_sym_do] = ACTIONS(1942),
    [anon_sym_for] = ACTIONS(1942),
    [anon_sym_return] = ACTIONS(1942),
    [anon_sym_break] = ACTIONS(1942),
    [anon_sym_continue] = ACTIONS(1942),
    [anon_sym_goto] = ACTIONS(1942),
    [anon_sym___try] = ACTIONS(1942),
    [anon_sym___leave] = ACTIONS(1942),
    [anon_sym_not] = ACTIONS(1942),
    [anon_sym_compl] = ACTIONS(1942),
    [anon_sym_DASH_DASH] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1944),
    [anon_sym_sizeof] = ACTIONS(1942),
    [anon_sym___alignof__] = ACTIONS(1942),
    [anon_sym___alignof] = ACTIONS(1942),
    [anon_sym__alignof] = ACTIONS(1942),
    [anon_sym_alignof] = ACTIONS(1942),
    [anon_sym__Alignof] = ACTIONS(1942),
    [anon_sym_offsetof] = ACTIONS(1942),
    [anon_sym__Generic] = ACTIONS(1942),
    [anon_sym_asm] = ACTIONS(1942),
    [anon_sym___asm__] = ACTIONS(1942),
    [sym_number_literal] = ACTIONS(1944),
    [anon_sym_L_SQUOTE] = ACTIONS(1944),
    [anon_sym_u_SQUOTE] = ACTIONS(1944),
    [anon_sym_U_SQUOTE] = ACTIONS(1944),
    [anon_sym_u8_SQUOTE] = ACTIONS(1944),
    [anon_sym_SQUOTE] = ACTIONS(1944),
    [anon_sym_L_DQUOTE] = ACTIONS(1944),
    [anon_sym_u_DQUOTE] = ACTIONS(1944),
    [anon_sym_U_DQUOTE] = ACTIONS(1944),
    [anon_sym_u8_DQUOTE] = ACTIONS(1944),
    [anon_sym_DQUOTE] = ACTIONS(1944),
    [sym_true] = ACTIONS(1942),
    [sym_false] = ACTIONS(1942),
    [anon_sym_NULL] = ACTIONS(1942),
    [anon_sym_nullptr] = ACTIONS(1942),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1942),
    [anon_sym_decltype] = ACTIONS(1942),
    [sym_virtual] = ACTIONS(1942),
    [anon_sym_explicit] = ACTIONS(1942),
    [anon_sym_typename] = ACTIONS(1942),
    [anon_sym_template] = ACTIONS(1942),
    [anon_sym_operator] = ACTIONS(1942),
    [anon_sym_try] = ACTIONS(1942),
    [anon_sym_delete] = ACTIONS(1942),
    [anon_sym_throw] = ACTIONS(1942),
    [anon_sym_namespace] = ACTIONS(1942),
    [anon_sym_using] = ACTIONS(1942),
    [anon_sym_static_assert] = ACTIONS(1942),
    [anon_sym_concept] = ACTIONS(1942),
    [anon_sym_co_return] = ACTIONS(1942),
    [anon_sym_co_yield] = ACTIONS(1942),
    [anon_sym_R_DQUOTE] = ACTIONS(1944),
    [anon_sym_LR_DQUOTE] = ACTIONS(1944),
    [anon_sym_uR_DQUOTE] = ACTIONS(1944),
    [anon_sym_UR_DQUOTE] = ACTIONS(1944),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1944),
    [anon_sym_co_await] = ACTIONS(1942),
    [anon_sym_new] = ACTIONS(1942),
    [anon_sym_requires] = ACTIONS(1942),
    [sym_this] = ACTIONS(1942),
    [anon_sym___launch_bounds__] = ACTIONS(1942),
  },
  [335] = {
    [sym_identifier] = ACTIONS(1954),
    [aux_sym_preproc_include_token1] = ACTIONS(1954),
    [aux_sym_preproc_def_token1] = ACTIONS(1954),
    [aux_sym_preproc_if_token1] = ACTIONS(1954),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1954),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1954),
    [sym_preproc_directive] = ACTIONS(1954),
    [anon_sym_LPAREN2] = ACTIONS(1956),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [anon_sym_DASH] = ACTIONS(1954),
    [anon_sym_PLUS] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(1956),
    [anon_sym_AMP_AMP] = ACTIONS(1956),
    [anon_sym_AMP] = ACTIONS(1954),
    [anon_sym_SEMI] = ACTIONS(1956),
    [anon_sym___extension__] = ACTIONS(1954),
    [anon_sym_typedef] = ACTIONS(1954),
    [anon_sym___device__] = ACTIONS(1954),
    [anon_sym___host__] = ACTIONS(1954),
    [anon_sym___global__] = ACTIONS(1954),
    [anon_sym___forceinline__] = ACTIONS(1954),
    [anon_sym___noinline__] = ACTIONS(1954),
    [anon_sym_extern] = ACTIONS(1954),
    [anon_sym___attribute__] = ACTIONS(1954),
    [anon_sym_COLON_COLON] = ACTIONS(1956),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1956),
    [anon_sym___declspec] = ACTIONS(1954),
    [anon_sym___based] = ACTIONS(1954),
    [anon_sym___cdecl] = ACTIONS(1954),
    [anon_sym___clrcall] = ACTIONS(1954),
    [anon_sym___stdcall] = ACTIONS(1954),
    [anon_sym___fastcall] = ACTIONS(1954),
    [anon_sym___thiscall] = ACTIONS(1954),
    [anon_sym___vectorcall] = ACTIONS(1954),
    [anon_sym_LBRACE] = ACTIONS(1956),
    [anon_sym_RBRACE] = ACTIONS(1956),
    [anon_sym_signed] = ACTIONS(1954),
    [anon_sym_unsigned] = ACTIONS(1954),
    [anon_sym_long] = ACTIONS(1954),
    [anon_sym_short] = ACTIONS(1954),
    [anon_sym_LBRACK] = ACTIONS(1954),
    [anon_sym_static] = ACTIONS(1954),
    [anon_sym_register] = ACTIONS(1954),
    [anon_sym_inline] = ACTIONS(1954),
    [anon_sym___inline] = ACTIONS(1954),
    [anon_sym___inline__] = ACTIONS(1954),
    [anon_sym___forceinline] = ACTIONS(1954),
    [anon_sym_thread_local] = ACTIONS(1954),
    [anon_sym___thread] = ACTIONS(1954),
    [anon_sym_const] = ACTIONS(1954),
    [anon_sym_constexpr] = ACTIONS(1954),
    [anon_sym_volatile] = ACTIONS(1954),
    [anon_sym_restrict] = ACTIONS(1954),
    [anon_sym___restrict__] = ACTIONS(1954),
    [anon_sym__Atomic] = ACTIONS(1954),
    [anon_sym__Noreturn] = ACTIONS(1954),
    [anon_sym_noreturn] = ACTIONS(1954),
    [anon_sym_mutable] = ACTIONS(1954),
    [anon_sym_constinit] = ACTIONS(1954),
    [anon_sym_consteval] = ACTIONS(1954),
    [anon_sym___shared__] = ACTIONS(1954),
    [anon_sym___local__] = ACTIONS(1954),
    [anon_sym___constant__] = ACTIONS(1954),
    [anon_sym___managed__] = ACTIONS(1954),
    [anon_sym___grid_constant__] = ACTIONS(1954),
    [anon_sym_alignas] = ACTIONS(1954),
    [anon_sym__Alignas] = ACTIONS(1954),
    [sym_primitive_type] = ACTIONS(1954),
    [anon_sym_enum] = ACTIONS(1954),
    [anon_sym_class] = ACTIONS(1954),
    [anon_sym_struct] = ACTIONS(1954),
    [anon_sym_union] = ACTIONS(1954),
    [anon_sym_if] = ACTIONS(1954),
    [anon_sym_else] = ACTIONS(1954),
    [anon_sym_switch] = ACTIONS(1954),
    [anon_sym_case] = ACTIONS(1954),
    [anon_sym_default] = ACTIONS(1954),
    [anon_sym_while] = ACTIONS(1954),
    [anon_sym_do] = ACTIONS(1954),
    [anon_sym_for] = ACTIONS(1954),
    [anon_sym_return] = ACTIONS(1954),
    [anon_sym_break] = ACTIONS(1954),
    [anon_sym_continue] = ACTIONS(1954),
    [anon_sym_goto] = ACTIONS(1954),
    [anon_sym___try] = ACTIONS(1954),
    [anon_sym___leave] = ACTIONS(1954),
    [anon_sym_not] = ACTIONS(1954),
    [anon_sym_compl] = ACTIONS(1954),
    [anon_sym_DASH_DASH] = ACTIONS(1956),
    [anon_sym_PLUS_PLUS] = ACTIONS(1956),
    [anon_sym_sizeof] = ACTIONS(1954),
    [anon_sym___alignof__] = ACTIONS(1954),
    [anon_sym___alignof] = ACTIONS(1954),
    [anon_sym__alignof] = ACTIONS(1954),
    [anon_sym_alignof] = ACTIONS(1954),
    [anon_sym__Alignof] = ACTIONS(1954),
    [anon_sym_offsetof] = ACTIONS(1954),
    [anon_sym__Generic] = ACTIONS(1954),
    [anon_sym_asm] = ACTIONS(1954),
    [anon_sym___asm__] = ACTIONS(1954),
    [sym_number_literal] = ACTIONS(1956),
    [anon_sym_L_SQUOTE] = ACTIONS(1956),
    [anon_sym_u_SQUOTE] = ACTIONS(1956),
    [anon_sym_U_SQUOTE] = ACTIONS(1956),
    [anon_sym_u8_SQUOTE] = ACTIONS(1956),
    [anon_sym_SQUOTE] = ACTIONS(1956),
    [anon_sym_L_DQUOTE] = ACTIONS(1956),
    [anon_sym_u_DQUOTE] = ACTIONS(1956),
    [anon_sym_U_DQUOTE] = ACTIONS(1956),
    [anon_sym_u8_DQUOTE] = ACTIONS(1956),
    [anon_sym_DQUOTE] = ACTIONS(1956),
    [sym_true] = ACTIONS(1954),
    [sym_false] = ACTIONS(1954),
    [anon_sym_NULL] = ACTIONS(1954),
    [anon_sym_nullptr] = ACTIONS(1954),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1954),
    [anon_sym_decltype] = ACTIONS(1954),
    [sym_virtual] = ACTIONS(1954),
    [anon_sym_explicit] = ACTIONS(1954),
    [anon_sym_typename] = ACTIONS(1954),
    [anon_sym_template] = ACTIONS(1954),
    [anon_sym_operator] = ACTIONS(1954),
    [anon_sym_try] = ACTIONS(1954),
    [anon_sym_delete] = ACTIONS(1954),
    [anon_sym_throw] = ACTIONS(1954),
    [anon_sym_namespace] = ACTIONS(1954),
    [anon_sym_using] = ACTIONS(1954),
    [anon_sym_static_assert] = ACTIONS(1954),
    [anon_sym_concept] = ACTIONS(1954),
    [anon_sym_co_return] = ACTIONS(1954),
    [anon_sym_co_yield] = ACTIONS(1954),
    [anon_sym_R_DQUOTE] = ACTIONS(1956),
    [anon_sym_LR_DQUOTE] = ACTIONS(1956),
    [anon_sym_uR_DQUOTE] = ACTIONS(1956),
    [anon_sym_UR_DQUOTE] = ACTIONS(1956),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1956),
    [anon_sym_co_await] = ACTIONS(1954),
    [anon_sym_new] = ACTIONS(1954),
    [anon_sym_requires] = ACTIONS(1954),
    [sym_this] = ACTIONS(1954),
    [anon_sym___launch_bounds__] = ACTIONS(1954),
  },
  [336] = {
    [sym_identifier] = ACTIONS(1946),
    [aux_sym_preproc_include_token1] = ACTIONS(1946),
    [aux_sym_preproc_def_token1] = ACTIONS(1946),
    [aux_sym_preproc_if_token1] = ACTIONS(1946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1946),
    [sym_preproc_directive] = ACTIONS(1946),
    [anon_sym_LPAREN2] = ACTIONS(1948),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(1948),
    [anon_sym_AMP_AMP] = ACTIONS(1948),
    [anon_sym_AMP] = ACTIONS(1946),
    [anon_sym_SEMI] = ACTIONS(1948),
    [anon_sym___extension__] = ACTIONS(1946),
    [anon_sym_typedef] = ACTIONS(1946),
    [anon_sym___device__] = ACTIONS(1946),
    [anon_sym___host__] = ACTIONS(1946),
    [anon_sym___global__] = ACTIONS(1946),
    [anon_sym___forceinline__] = ACTIONS(1946),
    [anon_sym___noinline__] = ACTIONS(1946),
    [anon_sym_extern] = ACTIONS(1946),
    [anon_sym___attribute__] = ACTIONS(1946),
    [anon_sym_COLON_COLON] = ACTIONS(1948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1948),
    [anon_sym___declspec] = ACTIONS(1946),
    [anon_sym___based] = ACTIONS(1946),
    [anon_sym___cdecl] = ACTIONS(1946),
    [anon_sym___clrcall] = ACTIONS(1946),
    [anon_sym___stdcall] = ACTIONS(1946),
    [anon_sym___fastcall] = ACTIONS(1946),
    [anon_sym___thiscall] = ACTIONS(1946),
    [anon_sym___vectorcall] = ACTIONS(1946),
    [anon_sym_LBRACE] = ACTIONS(1948),
    [anon_sym_RBRACE] = ACTIONS(1948),
    [anon_sym_signed] = ACTIONS(1946),
    [anon_sym_unsigned] = ACTIONS(1946),
    [anon_sym_long] = ACTIONS(1946),
    [anon_sym_short] = ACTIONS(1946),
    [anon_sym_LBRACK] = ACTIONS(1946),
    [anon_sym_static] = ACTIONS(1946),
    [anon_sym_register] = ACTIONS(1946),
    [anon_sym_inline] = ACTIONS(1946),
    [anon_sym___inline] = ACTIONS(1946),
    [anon_sym___inline__] = ACTIONS(1946),
    [anon_sym___forceinline] = ACTIONS(1946),
    [anon_sym_thread_local] = ACTIONS(1946),
    [anon_sym___thread] = ACTIONS(1946),
    [anon_sym_const] = ACTIONS(1946),
    [anon_sym_constexpr] = ACTIONS(1946),
    [anon_sym_volatile] = ACTIONS(1946),
    [anon_sym_restrict] = ACTIONS(1946),
    [anon_sym___restrict__] = ACTIONS(1946),
    [anon_sym__Atomic] = ACTIONS(1946),
    [anon_sym__Noreturn] = ACTIONS(1946),
    [anon_sym_noreturn] = ACTIONS(1946),
    [anon_sym_mutable] = ACTIONS(1946),
    [anon_sym_constinit] = ACTIONS(1946),
    [anon_sym_consteval] = ACTIONS(1946),
    [anon_sym___shared__] = ACTIONS(1946),
    [anon_sym___local__] = ACTIONS(1946),
    [anon_sym___constant__] = ACTIONS(1946),
    [anon_sym___managed__] = ACTIONS(1946),
    [anon_sym___grid_constant__] = ACTIONS(1946),
    [anon_sym_alignas] = ACTIONS(1946),
    [anon_sym__Alignas] = ACTIONS(1946),
    [sym_primitive_type] = ACTIONS(1946),
    [anon_sym_enum] = ACTIONS(1946),
    [anon_sym_class] = ACTIONS(1946),
    [anon_sym_struct] = ACTIONS(1946),
    [anon_sym_union] = ACTIONS(1946),
    [anon_sym_if] = ACTIONS(1946),
    [anon_sym_else] = ACTIONS(1946),
    [anon_sym_switch] = ACTIONS(1946),
    [anon_sym_case] = ACTIONS(1946),
    [anon_sym_default] = ACTIONS(1946),
    [anon_sym_while] = ACTIONS(1946),
    [anon_sym_do] = ACTIONS(1946),
    [anon_sym_for] = ACTIONS(1946),
    [anon_sym_return] = ACTIONS(1946),
    [anon_sym_break] = ACTIONS(1946),
    [anon_sym_continue] = ACTIONS(1946),
    [anon_sym_goto] = ACTIONS(1946),
    [anon_sym___try] = ACTIONS(1946),
    [anon_sym___leave] = ACTIONS(1946),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(1948),
    [anon_sym_PLUS_PLUS] = ACTIONS(1948),
    [anon_sym_sizeof] = ACTIONS(1946),
    [anon_sym___alignof__] = ACTIONS(1946),
    [anon_sym___alignof] = ACTIONS(1946),
    [anon_sym__alignof] = ACTIONS(1946),
    [anon_sym_alignof] = ACTIONS(1946),
    [anon_sym__Alignof] = ACTIONS(1946),
    [anon_sym_offsetof] = ACTIONS(1946),
    [anon_sym__Generic] = ACTIONS(1946),
    [anon_sym_asm] = ACTIONS(1946),
    [anon_sym___asm__] = ACTIONS(1946),
    [sym_number_literal] = ACTIONS(1948),
    [anon_sym_L_SQUOTE] = ACTIONS(1948),
    [anon_sym_u_SQUOTE] = ACTIONS(1948),
    [anon_sym_U_SQUOTE] = ACTIONS(1948),
    [anon_sym_u8_SQUOTE] = ACTIONS(1948),
    [anon_sym_SQUOTE] = ACTIONS(1948),
    [anon_sym_L_DQUOTE] = ACTIONS(1948),
    [anon_sym_u_DQUOTE] = ACTIONS(1948),
    [anon_sym_U_DQUOTE] = ACTIONS(1948),
    [anon_sym_u8_DQUOTE] = ACTIONS(1948),
    [anon_sym_DQUOTE] = ACTIONS(1948),
    [sym_true] = ACTIONS(1946),
    [sym_false] = ACTIONS(1946),
    [anon_sym_NULL] = ACTIONS(1946),
    [anon_sym_nullptr] = ACTIONS(1946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1946),
    [anon_sym_decltype] = ACTIONS(1946),
    [sym_virtual] = ACTIONS(1946),
    [anon_sym_explicit] = ACTIONS(1946),
    [anon_sym_typename] = ACTIONS(1946),
    [anon_sym_template] = ACTIONS(1946),
    [anon_sym_operator] = ACTIONS(1946),
    [anon_sym_try] = ACTIONS(1946),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_throw] = ACTIONS(1946),
    [anon_sym_namespace] = ACTIONS(1946),
    [anon_sym_using] = ACTIONS(1946),
    [anon_sym_static_assert] = ACTIONS(1946),
    [anon_sym_concept] = ACTIONS(1946),
    [anon_sym_co_return] = ACTIONS(1946),
    [anon_sym_co_yield] = ACTIONS(1946),
    [anon_sym_R_DQUOTE] = ACTIONS(1948),
    [anon_sym_LR_DQUOTE] = ACTIONS(1948),
    [anon_sym_uR_DQUOTE] = ACTIONS(1948),
    [anon_sym_UR_DQUOTE] = ACTIONS(1948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1948),
    [anon_sym_co_await] = ACTIONS(1946),
    [anon_sym_new] = ACTIONS(1946),
    [anon_sym_requires] = ACTIONS(1946),
    [sym_this] = ACTIONS(1946),
    [anon_sym___launch_bounds__] = ACTIONS(1946),
  },
  [337] = {
    [ts_builtin_sym_end] = ACTIONS(1966),
    [sym_identifier] = ACTIONS(1964),
    [aux_sym_preproc_include_token1] = ACTIONS(1964),
    [aux_sym_preproc_def_token1] = ACTIONS(1964),
    [aux_sym_preproc_if_token1] = ACTIONS(1964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1964),
    [sym_preproc_directive] = ACTIONS(1964),
    [anon_sym_LPAREN2] = ACTIONS(1966),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [anon_sym_DASH] = ACTIONS(1964),
    [anon_sym_PLUS] = ACTIONS(1964),
    [anon_sym_STAR] = ACTIONS(1966),
    [anon_sym_AMP_AMP] = ACTIONS(1966),
    [anon_sym_AMP] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym___extension__] = ACTIONS(1964),
    [anon_sym_typedef] = ACTIONS(1964),
    [anon_sym___device__] = ACTIONS(1964),
    [anon_sym___host__] = ACTIONS(1964),
    [anon_sym___global__] = ACTIONS(1964),
    [anon_sym___forceinline__] = ACTIONS(1964),
    [anon_sym___noinline__] = ACTIONS(1964),
    [anon_sym_extern] = ACTIONS(1964),
    [anon_sym___attribute__] = ACTIONS(1964),
    [anon_sym_COLON_COLON] = ACTIONS(1966),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1966),
    [anon_sym___declspec] = ACTIONS(1964),
    [anon_sym___based] = ACTIONS(1964),
    [anon_sym___cdecl] = ACTIONS(1964),
    [anon_sym___clrcall] = ACTIONS(1964),
    [anon_sym___stdcall] = ACTIONS(1964),
    [anon_sym___fastcall] = ACTIONS(1964),
    [anon_sym___thiscall] = ACTIONS(1964),
    [anon_sym___vectorcall] = ACTIONS(1964),
    [anon_sym_LBRACE] = ACTIONS(1966),
    [anon_sym_signed] = ACTIONS(1964),
    [anon_sym_unsigned] = ACTIONS(1964),
    [anon_sym_long] = ACTIONS(1964),
    [anon_sym_short] = ACTIONS(1964),
    [anon_sym_LBRACK] = ACTIONS(1964),
    [anon_sym_static] = ACTIONS(1964),
    [anon_sym_register] = ACTIONS(1964),
    [anon_sym_inline] = ACTIONS(1964),
    [anon_sym___inline] = ACTIONS(1964),
    [anon_sym___inline__] = ACTIONS(1964),
    [anon_sym___forceinline] = ACTIONS(1964),
    [anon_sym_thread_local] = ACTIONS(1964),
    [anon_sym___thread] = ACTIONS(1964),
    [anon_sym_const] = ACTIONS(1964),
    [anon_sym_constexpr] = ACTIONS(1964),
    [anon_sym_volatile] = ACTIONS(1964),
    [anon_sym_restrict] = ACTIONS(1964),
    [anon_sym___restrict__] = ACTIONS(1964),
    [anon_sym__Atomic] = ACTIONS(1964),
    [anon_sym__Noreturn] = ACTIONS(1964),
    [anon_sym_noreturn] = ACTIONS(1964),
    [anon_sym_mutable] = ACTIONS(1964),
    [anon_sym_constinit] = ACTIONS(1964),
    [anon_sym_consteval] = ACTIONS(1964),
    [anon_sym___shared__] = ACTIONS(1964),
    [anon_sym___local__] = ACTIONS(1964),
    [anon_sym___constant__] = ACTIONS(1964),
    [anon_sym___managed__] = ACTIONS(1964),
    [anon_sym___grid_constant__] = ACTIONS(1964),
    [anon_sym_alignas] = ACTIONS(1964),
    [anon_sym__Alignas] = ACTIONS(1964),
    [sym_primitive_type] = ACTIONS(1964),
    [anon_sym_enum] = ACTIONS(1964),
    [anon_sym_class] = ACTIONS(1964),
    [anon_sym_struct] = ACTIONS(1964),
    [anon_sym_union] = ACTIONS(1964),
    [anon_sym_if] = ACTIONS(1964),
    [anon_sym_else] = ACTIONS(1964),
    [anon_sym_switch] = ACTIONS(1964),
    [anon_sym_case] = ACTIONS(1964),
    [anon_sym_default] = ACTIONS(1964),
    [anon_sym_while] = ACTIONS(1964),
    [anon_sym_do] = ACTIONS(1964),
    [anon_sym_for] = ACTIONS(1964),
    [anon_sym_return] = ACTIONS(1964),
    [anon_sym_break] = ACTIONS(1964),
    [anon_sym_continue] = ACTIONS(1964),
    [anon_sym_goto] = ACTIONS(1964),
    [anon_sym___try] = ACTIONS(1964),
    [anon_sym___leave] = ACTIONS(1964),
    [anon_sym_not] = ACTIONS(1964),
    [anon_sym_compl] = ACTIONS(1964),
    [anon_sym_DASH_DASH] = ACTIONS(1966),
    [anon_sym_PLUS_PLUS] = ACTIONS(1966),
    [anon_sym_sizeof] = ACTIONS(1964),
    [anon_sym___alignof__] = ACTIONS(1964),
    [anon_sym___alignof] = ACTIONS(1964),
    [anon_sym__alignof] = ACTIONS(1964),
    [anon_sym_alignof] = ACTIONS(1964),
    [anon_sym__Alignof] = ACTIONS(1964),
    [anon_sym_offsetof] = ACTIONS(1964),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1964),
    [anon_sym___asm__] = ACTIONS(1964),
    [sym_number_literal] = ACTIONS(1966),
    [anon_sym_L_SQUOTE] = ACTIONS(1966),
    [anon_sym_u_SQUOTE] = ACTIONS(1966),
    [anon_sym_U_SQUOTE] = ACTIONS(1966),
    [anon_sym_u8_SQUOTE] = ACTIONS(1966),
    [anon_sym_SQUOTE] = ACTIONS(1966),
    [anon_sym_L_DQUOTE] = ACTIONS(1966),
    [anon_sym_u_DQUOTE] = ACTIONS(1966),
    [anon_sym_U_DQUOTE] = ACTIONS(1966),
    [anon_sym_u8_DQUOTE] = ACTIONS(1966),
    [anon_sym_DQUOTE] = ACTIONS(1966),
    [sym_true] = ACTIONS(1964),
    [sym_false] = ACTIONS(1964),
    [anon_sym_NULL] = ACTIONS(1964),
    [anon_sym_nullptr] = ACTIONS(1964),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1964),
    [anon_sym_decltype] = ACTIONS(1964),
    [sym_virtual] = ACTIONS(1964),
    [anon_sym_explicit] = ACTIONS(1964),
    [anon_sym_typename] = ACTIONS(1964),
    [anon_sym_template] = ACTIONS(1964),
    [anon_sym_operator] = ACTIONS(1964),
    [anon_sym_try] = ACTIONS(1964),
    [anon_sym_delete] = ACTIONS(1964),
    [anon_sym_throw] = ACTIONS(1964),
    [anon_sym_namespace] = ACTIONS(1964),
    [anon_sym_using] = ACTIONS(1964),
    [anon_sym_static_assert] = ACTIONS(1964),
    [anon_sym_concept] = ACTIONS(1964),
    [anon_sym_co_return] = ACTIONS(1964),
    [anon_sym_co_yield] = ACTIONS(1964),
    [anon_sym_R_DQUOTE] = ACTIONS(1966),
    [anon_sym_LR_DQUOTE] = ACTIONS(1966),
    [anon_sym_uR_DQUOTE] = ACTIONS(1966),
    [anon_sym_UR_DQUOTE] = ACTIONS(1966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1966),
    [anon_sym_co_await] = ACTIONS(1964),
    [anon_sym_new] = ACTIONS(1964),
    [anon_sym_requires] = ACTIONS(1964),
    [sym_this] = ACTIONS(1964),
    [anon_sym___launch_bounds__] = ACTIONS(1964),
  },
  [338] = {
    [sym_identifier] = ACTIONS(2060),
    [aux_sym_preproc_include_token1] = ACTIONS(2060),
    [aux_sym_preproc_def_token1] = ACTIONS(2060),
    [aux_sym_preproc_if_token1] = ACTIONS(2060),
    [aux_sym_preproc_if_token2] = ACTIONS(2060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2060),
    [sym_preproc_directive] = ACTIONS(2060),
    [anon_sym_LPAREN2] = ACTIONS(2062),
    [anon_sym_BANG] = ACTIONS(2062),
    [anon_sym_TILDE] = ACTIONS(2062),
    [anon_sym_DASH] = ACTIONS(2060),
    [anon_sym_PLUS] = ACTIONS(2060),
    [anon_sym_STAR] = ACTIONS(2062),
    [anon_sym_AMP_AMP] = ACTIONS(2062),
    [anon_sym_AMP] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2062),
    [anon_sym___extension__] = ACTIONS(2060),
    [anon_sym_typedef] = ACTIONS(2060),
    [anon_sym___device__] = ACTIONS(2060),
    [anon_sym___host__] = ACTIONS(2060),
    [anon_sym___global__] = ACTIONS(2060),
    [anon_sym___forceinline__] = ACTIONS(2060),
    [anon_sym___noinline__] = ACTIONS(2060),
    [anon_sym_extern] = ACTIONS(2060),
    [anon_sym___attribute__] = ACTIONS(2060),
    [anon_sym_COLON_COLON] = ACTIONS(2062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2062),
    [anon_sym___declspec] = ACTIONS(2060),
    [anon_sym___based] = ACTIONS(2060),
    [anon_sym___cdecl] = ACTIONS(2060),
    [anon_sym___clrcall] = ACTIONS(2060),
    [anon_sym___stdcall] = ACTIONS(2060),
    [anon_sym___fastcall] = ACTIONS(2060),
    [anon_sym___thiscall] = ACTIONS(2060),
    [anon_sym___vectorcall] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(2062),
    [anon_sym_signed] = ACTIONS(2060),
    [anon_sym_unsigned] = ACTIONS(2060),
    [anon_sym_long] = ACTIONS(2060),
    [anon_sym_short] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2060),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_register] = ACTIONS(2060),
    [anon_sym_inline] = ACTIONS(2060),
    [anon_sym___inline] = ACTIONS(2060),
    [anon_sym___inline__] = ACTIONS(2060),
    [anon_sym___forceinline] = ACTIONS(2060),
    [anon_sym_thread_local] = ACTIONS(2060),
    [anon_sym___thread] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_constexpr] = ACTIONS(2060),
    [anon_sym_volatile] = ACTIONS(2060),
    [anon_sym_restrict] = ACTIONS(2060),
    [anon_sym___restrict__] = ACTIONS(2060),
    [anon_sym__Atomic] = ACTIONS(2060),
    [anon_sym__Noreturn] = ACTIONS(2060),
    [anon_sym_noreturn] = ACTIONS(2060),
    [anon_sym_mutable] = ACTIONS(2060),
    [anon_sym_constinit] = ACTIONS(2060),
    [anon_sym_consteval] = ACTIONS(2060),
    [anon_sym___shared__] = ACTIONS(2060),
    [anon_sym___local__] = ACTIONS(2060),
    [anon_sym___constant__] = ACTIONS(2060),
    [anon_sym___managed__] = ACTIONS(2060),
    [anon_sym___grid_constant__] = ACTIONS(2060),
    [anon_sym_alignas] = ACTIONS(2060),
    [anon_sym__Alignas] = ACTIONS(2060),
    [sym_primitive_type] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_struct] = ACTIONS(2060),
    [anon_sym_union] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_else] = ACTIONS(2060),
    [anon_sym_switch] = ACTIONS(2060),
    [anon_sym_case] = ACTIONS(2060),
    [anon_sym_default] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_do] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_goto] = ACTIONS(2060),
    [anon_sym___try] = ACTIONS(2060),
    [anon_sym___leave] = ACTIONS(2060),
    [anon_sym_not] = ACTIONS(2060),
    [anon_sym_compl] = ACTIONS(2060),
    [anon_sym_DASH_DASH] = ACTIONS(2062),
    [anon_sym_PLUS_PLUS] = ACTIONS(2062),
    [anon_sym_sizeof] = ACTIONS(2060),
    [anon_sym___alignof__] = ACTIONS(2060),
    [anon_sym___alignof] = ACTIONS(2060),
    [anon_sym__alignof] = ACTIONS(2060),
    [anon_sym_alignof] = ACTIONS(2060),
    [anon_sym__Alignof] = ACTIONS(2060),
    [anon_sym_offsetof] = ACTIONS(2060),
    [anon_sym__Generic] = ACTIONS(2060),
    [anon_sym_asm] = ACTIONS(2060),
    [anon_sym___asm__] = ACTIONS(2060),
    [sym_number_literal] = ACTIONS(2062),
    [anon_sym_L_SQUOTE] = ACTIONS(2062),
    [anon_sym_u_SQUOTE] = ACTIONS(2062),
    [anon_sym_U_SQUOTE] = ACTIONS(2062),
    [anon_sym_u8_SQUOTE] = ACTIONS(2062),
    [anon_sym_SQUOTE] = ACTIONS(2062),
    [anon_sym_L_DQUOTE] = ACTIONS(2062),
    [anon_sym_u_DQUOTE] = ACTIONS(2062),
    [anon_sym_U_DQUOTE] = ACTIONS(2062),
    [anon_sym_u8_DQUOTE] = ACTIONS(2062),
    [anon_sym_DQUOTE] = ACTIONS(2062),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [anon_sym_NULL] = ACTIONS(2060),
    [anon_sym_nullptr] = ACTIONS(2060),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2060),
    [anon_sym_decltype] = ACTIONS(2060),
    [sym_virtual] = ACTIONS(2060),
    [anon_sym_explicit] = ACTIONS(2060),
    [anon_sym_typename] = ACTIONS(2060),
    [anon_sym_template] = ACTIONS(2060),
    [anon_sym_operator] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [anon_sym_delete] = ACTIONS(2060),
    [anon_sym_throw] = ACTIONS(2060),
    [anon_sym_namespace] = ACTIONS(2060),
    [anon_sym_using] = ACTIONS(2060),
    [anon_sym_static_assert] = ACTIONS(2060),
    [anon_sym_concept] = ACTIONS(2060),
    [anon_sym_co_return] = ACTIONS(2060),
    [anon_sym_co_yield] = ACTIONS(2060),
    [anon_sym_R_DQUOTE] = ACTIONS(2062),
    [anon_sym_LR_DQUOTE] = ACTIONS(2062),
    [anon_sym_uR_DQUOTE] = ACTIONS(2062),
    [anon_sym_UR_DQUOTE] = ACTIONS(2062),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2062),
    [anon_sym_co_await] = ACTIONS(2060),
    [anon_sym_new] = ACTIONS(2060),
    [anon_sym_requires] = ACTIONS(2060),
    [sym_this] = ACTIONS(2060),
    [anon_sym___launch_bounds__] = ACTIONS(2060),
  },
  [339] = {
    [sym_identifier] = ACTIONS(1996),
    [aux_sym_preproc_include_token1] = ACTIONS(1996),
    [aux_sym_preproc_def_token1] = ACTIONS(1996),
    [aux_sym_preproc_if_token1] = ACTIONS(1996),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1996),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1996),
    [sym_preproc_directive] = ACTIONS(1996),
    [anon_sym_LPAREN2] = ACTIONS(1998),
    [anon_sym_BANG] = ACTIONS(1998),
    [anon_sym_TILDE] = ACTIONS(1998),
    [anon_sym_DASH] = ACTIONS(1996),
    [anon_sym_PLUS] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(1998),
    [anon_sym_AMP_AMP] = ACTIONS(1998),
    [anon_sym_AMP] = ACTIONS(1996),
    [anon_sym_SEMI] = ACTIONS(1998),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_typedef] = ACTIONS(1996),
    [anon_sym___device__] = ACTIONS(1996),
    [anon_sym___host__] = ACTIONS(1996),
    [anon_sym___global__] = ACTIONS(1996),
    [anon_sym___forceinline__] = ACTIONS(1996),
    [anon_sym___noinline__] = ACTIONS(1996),
    [anon_sym_extern] = ACTIONS(1996),
    [anon_sym___attribute__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1998),
    [anon_sym___declspec] = ACTIONS(1996),
    [anon_sym___based] = ACTIONS(1996),
    [anon_sym___cdecl] = ACTIONS(1996),
    [anon_sym___clrcall] = ACTIONS(1996),
    [anon_sym___stdcall] = ACTIONS(1996),
    [anon_sym___fastcall] = ACTIONS(1996),
    [anon_sym___thiscall] = ACTIONS(1996),
    [anon_sym___vectorcall] = ACTIONS(1996),
    [anon_sym_LBRACE] = ACTIONS(1998),
    [anon_sym_RBRACE] = ACTIONS(1998),
    [anon_sym_signed] = ACTIONS(1996),
    [anon_sym_unsigned] = ACTIONS(1996),
    [anon_sym_long] = ACTIONS(1996),
    [anon_sym_short] = ACTIONS(1996),
    [anon_sym_LBRACK] = ACTIONS(1996),
    [anon_sym_static] = ACTIONS(1996),
    [anon_sym_register] = ACTIONS(1996),
    [anon_sym_inline] = ACTIONS(1996),
    [anon_sym___inline] = ACTIONS(1996),
    [anon_sym___inline__] = ACTIONS(1996),
    [anon_sym___forceinline] = ACTIONS(1996),
    [anon_sym_thread_local] = ACTIONS(1996),
    [anon_sym___thread] = ACTIONS(1996),
    [anon_sym_const] = ACTIONS(1996),
    [anon_sym_constexpr] = ACTIONS(1996),
    [anon_sym_volatile] = ACTIONS(1996),
    [anon_sym_restrict] = ACTIONS(1996),
    [anon_sym___restrict__] = ACTIONS(1996),
    [anon_sym__Atomic] = ACTIONS(1996),
    [anon_sym__Noreturn] = ACTIONS(1996),
    [anon_sym_noreturn] = ACTIONS(1996),
    [anon_sym_mutable] = ACTIONS(1996),
    [anon_sym_constinit] = ACTIONS(1996),
    [anon_sym_consteval] = ACTIONS(1996),
    [anon_sym___shared__] = ACTIONS(1996),
    [anon_sym___local__] = ACTIONS(1996),
    [anon_sym___constant__] = ACTIONS(1996),
    [anon_sym___managed__] = ACTIONS(1996),
    [anon_sym___grid_constant__] = ACTIONS(1996),
    [anon_sym_alignas] = ACTIONS(1996),
    [anon_sym__Alignas] = ACTIONS(1996),
    [sym_primitive_type] = ACTIONS(1996),
    [anon_sym_enum] = ACTIONS(1996),
    [anon_sym_class] = ACTIONS(1996),
    [anon_sym_struct] = ACTIONS(1996),
    [anon_sym_union] = ACTIONS(1996),
    [anon_sym_if] = ACTIONS(1996),
    [anon_sym_else] = ACTIONS(1996),
    [anon_sym_switch] = ACTIONS(1996),
    [anon_sym_case] = ACTIONS(1996),
    [anon_sym_default] = ACTIONS(1996),
    [anon_sym_while] = ACTIONS(1996),
    [anon_sym_do] = ACTIONS(1996),
    [anon_sym_for] = ACTIONS(1996),
    [anon_sym_return] = ACTIONS(1996),
    [anon_sym_break] = ACTIONS(1996),
    [anon_sym_continue] = ACTIONS(1996),
    [anon_sym_goto] = ACTIONS(1996),
    [anon_sym___try] = ACTIONS(1996),
    [anon_sym___leave] = ACTIONS(1996),
    [anon_sym_not] = ACTIONS(1996),
    [anon_sym_compl] = ACTIONS(1996),
    [anon_sym_DASH_DASH] = ACTIONS(1998),
    [anon_sym_PLUS_PLUS] = ACTIONS(1998),
    [anon_sym_sizeof] = ACTIONS(1996),
    [anon_sym___alignof__] = ACTIONS(1996),
    [anon_sym___alignof] = ACTIONS(1996),
    [anon_sym__alignof] = ACTIONS(1996),
    [anon_sym_alignof] = ACTIONS(1996),
    [anon_sym__Alignof] = ACTIONS(1996),
    [anon_sym_offsetof] = ACTIONS(1996),
    [anon_sym__Generic] = ACTIONS(1996),
    [anon_sym_asm] = ACTIONS(1996),
    [anon_sym___asm__] = ACTIONS(1996),
    [sym_number_literal] = ACTIONS(1998),
    [anon_sym_L_SQUOTE] = ACTIONS(1998),
    [anon_sym_u_SQUOTE] = ACTIONS(1998),
    [anon_sym_U_SQUOTE] = ACTIONS(1998),
    [anon_sym_u8_SQUOTE] = ACTIONS(1998),
    [anon_sym_SQUOTE] = ACTIONS(1998),
    [anon_sym_L_DQUOTE] = ACTIONS(1998),
    [anon_sym_u_DQUOTE] = ACTIONS(1998),
    [anon_sym_U_DQUOTE] = ACTIONS(1998),
    [anon_sym_u8_DQUOTE] = ACTIONS(1998),
    [anon_sym_DQUOTE] = ACTIONS(1998),
    [sym_true] = ACTIONS(1996),
    [sym_false] = ACTIONS(1996),
    [anon_sym_NULL] = ACTIONS(1996),
    [anon_sym_nullptr] = ACTIONS(1996),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1996),
    [anon_sym_decltype] = ACTIONS(1996),
    [sym_virtual] = ACTIONS(1996),
    [anon_sym_explicit] = ACTIONS(1996),
    [anon_sym_typename] = ACTIONS(1996),
    [anon_sym_template] = ACTIONS(1996),
    [anon_sym_operator] = ACTIONS(1996),
    [anon_sym_try] = ACTIONS(1996),
    [anon_sym_delete] = ACTIONS(1996),
    [anon_sym_throw] = ACTIONS(1996),
    [anon_sym_namespace] = ACTIONS(1996),
    [anon_sym_using] = ACTIONS(1996),
    [anon_sym_static_assert] = ACTIONS(1996),
    [anon_sym_concept] = ACTIONS(1996),
    [anon_sym_co_return] = ACTIONS(1996),
    [anon_sym_co_yield] = ACTIONS(1996),
    [anon_sym_R_DQUOTE] = ACTIONS(1998),
    [anon_sym_LR_DQUOTE] = ACTIONS(1998),
    [anon_sym_uR_DQUOTE] = ACTIONS(1998),
    [anon_sym_UR_DQUOTE] = ACTIONS(1998),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1998),
    [anon_sym_co_await] = ACTIONS(1996),
    [anon_sym_new] = ACTIONS(1996),
    [anon_sym_requires] = ACTIONS(1996),
    [sym_this] = ACTIONS(1996),
    [anon_sym___launch_bounds__] = ACTIONS(1996),
  },
  [340] = {
    [ts_builtin_sym_end] = ACTIONS(1952),
    [sym_identifier] = ACTIONS(1950),
    [aux_sym_preproc_include_token1] = ACTIONS(1950),
    [aux_sym_preproc_def_token1] = ACTIONS(1950),
    [aux_sym_preproc_if_token1] = ACTIONS(1950),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1950),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1950),
    [sym_preproc_directive] = ACTIONS(1950),
    [anon_sym_LPAREN2] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1952),
    [anon_sym_TILDE] = ACTIONS(1952),
    [anon_sym_DASH] = ACTIONS(1950),
    [anon_sym_PLUS] = ACTIONS(1950),
    [anon_sym_STAR] = ACTIONS(1952),
    [anon_sym_AMP_AMP] = ACTIONS(1952),
    [anon_sym_AMP] = ACTIONS(1950),
    [anon_sym_SEMI] = ACTIONS(1952),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_typedef] = ACTIONS(1950),
    [anon_sym___device__] = ACTIONS(1950),
    [anon_sym___host__] = ACTIONS(1950),
    [anon_sym___global__] = ACTIONS(1950),
    [anon_sym___forceinline__] = ACTIONS(1950),
    [anon_sym___noinline__] = ACTIONS(1950),
    [anon_sym_extern] = ACTIONS(1950),
    [anon_sym___attribute__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1952),
    [anon_sym___declspec] = ACTIONS(1950),
    [anon_sym___based] = ACTIONS(1950),
    [anon_sym___cdecl] = ACTIONS(1950),
    [anon_sym___clrcall] = ACTIONS(1950),
    [anon_sym___stdcall] = ACTIONS(1950),
    [anon_sym___fastcall] = ACTIONS(1950),
    [anon_sym___thiscall] = ACTIONS(1950),
    [anon_sym___vectorcall] = ACTIONS(1950),
    [anon_sym_LBRACE] = ACTIONS(1952),
    [anon_sym_signed] = ACTIONS(1950),
    [anon_sym_unsigned] = ACTIONS(1950),
    [anon_sym_long] = ACTIONS(1950),
    [anon_sym_short] = ACTIONS(1950),
    [anon_sym_LBRACK] = ACTIONS(1950),
    [anon_sym_static] = ACTIONS(1950),
    [anon_sym_register] = ACTIONS(1950),
    [anon_sym_inline] = ACTIONS(1950),
    [anon_sym___inline] = ACTIONS(1950),
    [anon_sym___inline__] = ACTIONS(1950),
    [anon_sym___forceinline] = ACTIONS(1950),
    [anon_sym_thread_local] = ACTIONS(1950),
    [anon_sym___thread] = ACTIONS(1950),
    [anon_sym_const] = ACTIONS(1950),
    [anon_sym_constexpr] = ACTIONS(1950),
    [anon_sym_volatile] = ACTIONS(1950),
    [anon_sym_restrict] = ACTIONS(1950),
    [anon_sym___restrict__] = ACTIONS(1950),
    [anon_sym__Atomic] = ACTIONS(1950),
    [anon_sym__Noreturn] = ACTIONS(1950),
    [anon_sym_noreturn] = ACTIONS(1950),
    [anon_sym_mutable] = ACTIONS(1950),
    [anon_sym_constinit] = ACTIONS(1950),
    [anon_sym_consteval] = ACTIONS(1950),
    [anon_sym___shared__] = ACTIONS(1950),
    [anon_sym___local__] = ACTIONS(1950),
    [anon_sym___constant__] = ACTIONS(1950),
    [anon_sym___managed__] = ACTIONS(1950),
    [anon_sym___grid_constant__] = ACTIONS(1950),
    [anon_sym_alignas] = ACTIONS(1950),
    [anon_sym__Alignas] = ACTIONS(1950),
    [sym_primitive_type] = ACTIONS(1950),
    [anon_sym_enum] = ACTIONS(1950),
    [anon_sym_class] = ACTIONS(1950),
    [anon_sym_struct] = ACTIONS(1950),
    [anon_sym_union] = ACTIONS(1950),
    [anon_sym_if] = ACTIONS(1950),
    [anon_sym_else] = ACTIONS(1950),
    [anon_sym_switch] = ACTIONS(1950),
    [anon_sym_case] = ACTIONS(1950),
    [anon_sym_default] = ACTIONS(1950),
    [anon_sym_while] = ACTIONS(1950),
    [anon_sym_do] = ACTIONS(1950),
    [anon_sym_for] = ACTIONS(1950),
    [anon_sym_return] = ACTIONS(1950),
    [anon_sym_break] = ACTIONS(1950),
    [anon_sym_continue] = ACTIONS(1950),
    [anon_sym_goto] = ACTIONS(1950),
    [anon_sym___try] = ACTIONS(1950),
    [anon_sym___leave] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1950),
    [anon_sym_compl] = ACTIONS(1950),
    [anon_sym_DASH_DASH] = ACTIONS(1952),
    [anon_sym_PLUS_PLUS] = ACTIONS(1952),
    [anon_sym_sizeof] = ACTIONS(1950),
    [anon_sym___alignof__] = ACTIONS(1950),
    [anon_sym___alignof] = ACTIONS(1950),
    [anon_sym__alignof] = ACTIONS(1950),
    [anon_sym_alignof] = ACTIONS(1950),
    [anon_sym__Alignof] = ACTIONS(1950),
    [anon_sym_offsetof] = ACTIONS(1950),
    [anon_sym__Generic] = ACTIONS(1950),
    [anon_sym_asm] = ACTIONS(1950),
    [anon_sym___asm__] = ACTIONS(1950),
    [sym_number_literal] = ACTIONS(1952),
    [anon_sym_L_SQUOTE] = ACTIONS(1952),
    [anon_sym_u_SQUOTE] = ACTIONS(1952),
    [anon_sym_U_SQUOTE] = ACTIONS(1952),
    [anon_sym_u8_SQUOTE] = ACTIONS(1952),
    [anon_sym_SQUOTE] = ACTIONS(1952),
    [anon_sym_L_DQUOTE] = ACTIONS(1952),
    [anon_sym_u_DQUOTE] = ACTIONS(1952),
    [anon_sym_U_DQUOTE] = ACTIONS(1952),
    [anon_sym_u8_DQUOTE] = ACTIONS(1952),
    [anon_sym_DQUOTE] = ACTIONS(1952),
    [sym_true] = ACTIONS(1950),
    [sym_false] = ACTIONS(1950),
    [anon_sym_NULL] = ACTIONS(1950),
    [anon_sym_nullptr] = ACTIONS(1950),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1950),
    [anon_sym_decltype] = ACTIONS(1950),
    [sym_virtual] = ACTIONS(1950),
    [anon_sym_explicit] = ACTIONS(1950),
    [anon_sym_typename] = ACTIONS(1950),
    [anon_sym_template] = ACTIONS(1950),
    [anon_sym_operator] = ACTIONS(1950),
    [anon_sym_try] = ACTIONS(1950),
    [anon_sym_delete] = ACTIONS(1950),
    [anon_sym_throw] = ACTIONS(1950),
    [anon_sym_namespace] = ACTIONS(1950),
    [anon_sym_using] = ACTIONS(1950),
    [anon_sym_static_assert] = ACTIONS(1950),
    [anon_sym_concept] = ACTIONS(1950),
    [anon_sym_co_return] = ACTIONS(1950),
    [anon_sym_co_yield] = ACTIONS(1950),
    [anon_sym_R_DQUOTE] = ACTIONS(1952),
    [anon_sym_LR_DQUOTE] = ACTIONS(1952),
    [anon_sym_uR_DQUOTE] = ACTIONS(1952),
    [anon_sym_UR_DQUOTE] = ACTIONS(1952),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1952),
    [anon_sym_co_await] = ACTIONS(1950),
    [anon_sym_new] = ACTIONS(1950),
    [anon_sym_requires] = ACTIONS(1950),
    [sym_this] = ACTIONS(1950),
    [anon_sym___launch_bounds__] = ACTIONS(1950),
  },
  [341] = {
    [ts_builtin_sym_end] = ACTIONS(2050),
    [sym_identifier] = ACTIONS(2048),
    [aux_sym_preproc_include_token1] = ACTIONS(2048),
    [aux_sym_preproc_def_token1] = ACTIONS(2048),
    [aux_sym_preproc_if_token1] = ACTIONS(2048),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2048),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2048),
    [sym_preproc_directive] = ACTIONS(2048),
    [anon_sym_LPAREN2] = ACTIONS(2050),
    [anon_sym_BANG] = ACTIONS(2050),
    [anon_sym_TILDE] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2048),
    [anon_sym_PLUS] = ACTIONS(2048),
    [anon_sym_STAR] = ACTIONS(2050),
    [anon_sym_AMP_AMP] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2048),
    [anon_sym_SEMI] = ACTIONS(2050),
    [anon_sym___extension__] = ACTIONS(2048),
    [anon_sym_typedef] = ACTIONS(2048),
    [anon_sym___device__] = ACTIONS(2048),
    [anon_sym___host__] = ACTIONS(2048),
    [anon_sym___global__] = ACTIONS(2048),
    [anon_sym___forceinline__] = ACTIONS(2048),
    [anon_sym___noinline__] = ACTIONS(2048),
    [anon_sym_extern] = ACTIONS(2048),
    [anon_sym___attribute__] = ACTIONS(2048),
    [anon_sym_COLON_COLON] = ACTIONS(2050),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2050),
    [anon_sym___declspec] = ACTIONS(2048),
    [anon_sym___based] = ACTIONS(2048),
    [anon_sym___cdecl] = ACTIONS(2048),
    [anon_sym___clrcall] = ACTIONS(2048),
    [anon_sym___stdcall] = ACTIONS(2048),
    [anon_sym___fastcall] = ACTIONS(2048),
    [anon_sym___thiscall] = ACTIONS(2048),
    [anon_sym___vectorcall] = ACTIONS(2048),
    [anon_sym_LBRACE] = ACTIONS(2050),
    [anon_sym_signed] = ACTIONS(2048),
    [anon_sym_unsigned] = ACTIONS(2048),
    [anon_sym_long] = ACTIONS(2048),
    [anon_sym_short] = ACTIONS(2048),
    [anon_sym_LBRACK] = ACTIONS(2048),
    [anon_sym_static] = ACTIONS(2048),
    [anon_sym_register] = ACTIONS(2048),
    [anon_sym_inline] = ACTIONS(2048),
    [anon_sym___inline] = ACTIONS(2048),
    [anon_sym___inline__] = ACTIONS(2048),
    [anon_sym___forceinline] = ACTIONS(2048),
    [anon_sym_thread_local] = ACTIONS(2048),
    [anon_sym___thread] = ACTIONS(2048),
    [anon_sym_const] = ACTIONS(2048),
    [anon_sym_constexpr] = ACTIONS(2048),
    [anon_sym_volatile] = ACTIONS(2048),
    [anon_sym_restrict] = ACTIONS(2048),
    [anon_sym___restrict__] = ACTIONS(2048),
    [anon_sym__Atomic] = ACTIONS(2048),
    [anon_sym__Noreturn] = ACTIONS(2048),
    [anon_sym_noreturn] = ACTIONS(2048),
    [anon_sym_mutable] = ACTIONS(2048),
    [anon_sym_constinit] = ACTIONS(2048),
    [anon_sym_consteval] = ACTIONS(2048),
    [anon_sym___shared__] = ACTIONS(2048),
    [anon_sym___local__] = ACTIONS(2048),
    [anon_sym___constant__] = ACTIONS(2048),
    [anon_sym___managed__] = ACTIONS(2048),
    [anon_sym___grid_constant__] = ACTIONS(2048),
    [anon_sym_alignas] = ACTIONS(2048),
    [anon_sym__Alignas] = ACTIONS(2048),
    [sym_primitive_type] = ACTIONS(2048),
    [anon_sym_enum] = ACTIONS(2048),
    [anon_sym_class] = ACTIONS(2048),
    [anon_sym_struct] = ACTIONS(2048),
    [anon_sym_union] = ACTIONS(2048),
    [anon_sym_if] = ACTIONS(2048),
    [anon_sym_else] = ACTIONS(2048),
    [anon_sym_switch] = ACTIONS(2048),
    [anon_sym_case] = ACTIONS(2048),
    [anon_sym_default] = ACTIONS(2048),
    [anon_sym_while] = ACTIONS(2048),
    [anon_sym_do] = ACTIONS(2048),
    [anon_sym_for] = ACTIONS(2048),
    [anon_sym_return] = ACTIONS(2048),
    [anon_sym_break] = ACTIONS(2048),
    [anon_sym_continue] = ACTIONS(2048),
    [anon_sym_goto] = ACTIONS(2048),
    [anon_sym___try] = ACTIONS(2048),
    [anon_sym___leave] = ACTIONS(2048),
    [anon_sym_not] = ACTIONS(2048),
    [anon_sym_compl] = ACTIONS(2048),
    [anon_sym_DASH_DASH] = ACTIONS(2050),
    [anon_sym_PLUS_PLUS] = ACTIONS(2050),
    [anon_sym_sizeof] = ACTIONS(2048),
    [anon_sym___alignof__] = ACTIONS(2048),
    [anon_sym___alignof] = ACTIONS(2048),
    [anon_sym__alignof] = ACTIONS(2048),
    [anon_sym_alignof] = ACTIONS(2048),
    [anon_sym__Alignof] = ACTIONS(2048),
    [anon_sym_offsetof] = ACTIONS(2048),
    [anon_sym__Generic] = ACTIONS(2048),
    [anon_sym_asm] = ACTIONS(2048),
    [anon_sym___asm__] = ACTIONS(2048),
    [sym_number_literal] = ACTIONS(2050),
    [anon_sym_L_SQUOTE] = ACTIONS(2050),
    [anon_sym_u_SQUOTE] = ACTIONS(2050),
    [anon_sym_U_SQUOTE] = ACTIONS(2050),
    [anon_sym_u8_SQUOTE] = ACTIONS(2050),
    [anon_sym_SQUOTE] = ACTIONS(2050),
    [anon_sym_L_DQUOTE] = ACTIONS(2050),
    [anon_sym_u_DQUOTE] = ACTIONS(2050),
    [anon_sym_U_DQUOTE] = ACTIONS(2050),
    [anon_sym_u8_DQUOTE] = ACTIONS(2050),
    [anon_sym_DQUOTE] = ACTIONS(2050),
    [sym_true] = ACTIONS(2048),
    [sym_false] = ACTIONS(2048),
    [anon_sym_NULL] = ACTIONS(2048),
    [anon_sym_nullptr] = ACTIONS(2048),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2048),
    [anon_sym_decltype] = ACTIONS(2048),
    [sym_virtual] = ACTIONS(2048),
    [anon_sym_explicit] = ACTIONS(2048),
    [anon_sym_typename] = ACTIONS(2048),
    [anon_sym_template] = ACTIONS(2048),
    [anon_sym_operator] = ACTIONS(2048),
    [anon_sym_try] = ACTIONS(2048),
    [anon_sym_delete] = ACTIONS(2048),
    [anon_sym_throw] = ACTIONS(2048),
    [anon_sym_namespace] = ACTIONS(2048),
    [anon_sym_using] = ACTIONS(2048),
    [anon_sym_static_assert] = ACTIONS(2048),
    [anon_sym_concept] = ACTIONS(2048),
    [anon_sym_co_return] = ACTIONS(2048),
    [anon_sym_co_yield] = ACTIONS(2048),
    [anon_sym_R_DQUOTE] = ACTIONS(2050),
    [anon_sym_LR_DQUOTE] = ACTIONS(2050),
    [anon_sym_uR_DQUOTE] = ACTIONS(2050),
    [anon_sym_UR_DQUOTE] = ACTIONS(2050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2050),
    [anon_sym_co_await] = ACTIONS(2048),
    [anon_sym_new] = ACTIONS(2048),
    [anon_sym_requires] = ACTIONS(2048),
    [sym_this] = ACTIONS(2048),
    [anon_sym___launch_bounds__] = ACTIONS(2048),
  },
  [342] = {
    [ts_builtin_sym_end] = ACTIONS(2046),
    [sym_identifier] = ACTIONS(2044),
    [aux_sym_preproc_include_token1] = ACTIONS(2044),
    [aux_sym_preproc_def_token1] = ACTIONS(2044),
    [aux_sym_preproc_if_token1] = ACTIONS(2044),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2044),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2044),
    [sym_preproc_directive] = ACTIONS(2044),
    [anon_sym_LPAREN2] = ACTIONS(2046),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2044),
    [anon_sym_PLUS] = ACTIONS(2044),
    [anon_sym_STAR] = ACTIONS(2046),
    [anon_sym_AMP_AMP] = ACTIONS(2046),
    [anon_sym_AMP] = ACTIONS(2044),
    [anon_sym_SEMI] = ACTIONS(2046),
    [anon_sym___extension__] = ACTIONS(2044),
    [anon_sym_typedef] = ACTIONS(2044),
    [anon_sym___device__] = ACTIONS(2044),
    [anon_sym___host__] = ACTIONS(2044),
    [anon_sym___global__] = ACTIONS(2044),
    [anon_sym___forceinline__] = ACTIONS(2044),
    [anon_sym___noinline__] = ACTIONS(2044),
    [anon_sym_extern] = ACTIONS(2044),
    [anon_sym___attribute__] = ACTIONS(2044),
    [anon_sym_COLON_COLON] = ACTIONS(2046),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2046),
    [anon_sym___declspec] = ACTIONS(2044),
    [anon_sym___based] = ACTIONS(2044),
    [anon_sym___cdecl] = ACTIONS(2044),
    [anon_sym___clrcall] = ACTIONS(2044),
    [anon_sym___stdcall] = ACTIONS(2044),
    [anon_sym___fastcall] = ACTIONS(2044),
    [anon_sym___thiscall] = ACTIONS(2044),
    [anon_sym___vectorcall] = ACTIONS(2044),
    [anon_sym_LBRACE] = ACTIONS(2046),
    [anon_sym_signed] = ACTIONS(2044),
    [anon_sym_unsigned] = ACTIONS(2044),
    [anon_sym_long] = ACTIONS(2044),
    [anon_sym_short] = ACTIONS(2044),
    [anon_sym_LBRACK] = ACTIONS(2044),
    [anon_sym_static] = ACTIONS(2044),
    [anon_sym_register] = ACTIONS(2044),
    [anon_sym_inline] = ACTIONS(2044),
    [anon_sym___inline] = ACTIONS(2044),
    [anon_sym___inline__] = ACTIONS(2044),
    [anon_sym___forceinline] = ACTIONS(2044),
    [anon_sym_thread_local] = ACTIONS(2044),
    [anon_sym___thread] = ACTIONS(2044),
    [anon_sym_const] = ACTIONS(2044),
    [anon_sym_constexpr] = ACTIONS(2044),
    [anon_sym_volatile] = ACTIONS(2044),
    [anon_sym_restrict] = ACTIONS(2044),
    [anon_sym___restrict__] = ACTIONS(2044),
    [anon_sym__Atomic] = ACTIONS(2044),
    [anon_sym__Noreturn] = ACTIONS(2044),
    [anon_sym_noreturn] = ACTIONS(2044),
    [anon_sym_mutable] = ACTIONS(2044),
    [anon_sym_constinit] = ACTIONS(2044),
    [anon_sym_consteval] = ACTIONS(2044),
    [anon_sym___shared__] = ACTIONS(2044),
    [anon_sym___local__] = ACTIONS(2044),
    [anon_sym___constant__] = ACTIONS(2044),
    [anon_sym___managed__] = ACTIONS(2044),
    [anon_sym___grid_constant__] = ACTIONS(2044),
    [anon_sym_alignas] = ACTIONS(2044),
    [anon_sym__Alignas] = ACTIONS(2044),
    [sym_primitive_type] = ACTIONS(2044),
    [anon_sym_enum] = ACTIONS(2044),
    [anon_sym_class] = ACTIONS(2044),
    [anon_sym_struct] = ACTIONS(2044),
    [anon_sym_union] = ACTIONS(2044),
    [anon_sym_if] = ACTIONS(2044),
    [anon_sym_else] = ACTIONS(2044),
    [anon_sym_switch] = ACTIONS(2044),
    [anon_sym_case] = ACTIONS(2044),
    [anon_sym_default] = ACTIONS(2044),
    [anon_sym_while] = ACTIONS(2044),
    [anon_sym_do] = ACTIONS(2044),
    [anon_sym_for] = ACTIONS(2044),
    [anon_sym_return] = ACTIONS(2044),
    [anon_sym_break] = ACTIONS(2044),
    [anon_sym_continue] = ACTIONS(2044),
    [anon_sym_goto] = ACTIONS(2044),
    [anon_sym___try] = ACTIONS(2044),
    [anon_sym___leave] = ACTIONS(2044),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_compl] = ACTIONS(2044),
    [anon_sym_DASH_DASH] = ACTIONS(2046),
    [anon_sym_PLUS_PLUS] = ACTIONS(2046),
    [anon_sym_sizeof] = ACTIONS(2044),
    [anon_sym___alignof__] = ACTIONS(2044),
    [anon_sym___alignof] = ACTIONS(2044),
    [anon_sym__alignof] = ACTIONS(2044),
    [anon_sym_alignof] = ACTIONS(2044),
    [anon_sym__Alignof] = ACTIONS(2044),
    [anon_sym_offsetof] = ACTIONS(2044),
    [anon_sym__Generic] = ACTIONS(2044),
    [anon_sym_asm] = ACTIONS(2044),
    [anon_sym___asm__] = ACTIONS(2044),
    [sym_number_literal] = ACTIONS(2046),
    [anon_sym_L_SQUOTE] = ACTIONS(2046),
    [anon_sym_u_SQUOTE] = ACTIONS(2046),
    [anon_sym_U_SQUOTE] = ACTIONS(2046),
    [anon_sym_u8_SQUOTE] = ACTIONS(2046),
    [anon_sym_SQUOTE] = ACTIONS(2046),
    [anon_sym_L_DQUOTE] = ACTIONS(2046),
    [anon_sym_u_DQUOTE] = ACTIONS(2046),
    [anon_sym_U_DQUOTE] = ACTIONS(2046),
    [anon_sym_u8_DQUOTE] = ACTIONS(2046),
    [anon_sym_DQUOTE] = ACTIONS(2046),
    [sym_true] = ACTIONS(2044),
    [sym_false] = ACTIONS(2044),
    [anon_sym_NULL] = ACTIONS(2044),
    [anon_sym_nullptr] = ACTIONS(2044),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2044),
    [anon_sym_decltype] = ACTIONS(2044),
    [sym_virtual] = ACTIONS(2044),
    [anon_sym_explicit] = ACTIONS(2044),
    [anon_sym_typename] = ACTIONS(2044),
    [anon_sym_template] = ACTIONS(2044),
    [anon_sym_operator] = ACTIONS(2044),
    [anon_sym_try] = ACTIONS(2044),
    [anon_sym_delete] = ACTIONS(2044),
    [anon_sym_throw] = ACTIONS(2044),
    [anon_sym_namespace] = ACTIONS(2044),
    [anon_sym_using] = ACTIONS(2044),
    [anon_sym_static_assert] = ACTIONS(2044),
    [anon_sym_concept] = ACTIONS(2044),
    [anon_sym_co_return] = ACTIONS(2044),
    [anon_sym_co_yield] = ACTIONS(2044),
    [anon_sym_R_DQUOTE] = ACTIONS(2046),
    [anon_sym_LR_DQUOTE] = ACTIONS(2046),
    [anon_sym_uR_DQUOTE] = ACTIONS(2046),
    [anon_sym_UR_DQUOTE] = ACTIONS(2046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2046),
    [anon_sym_co_await] = ACTIONS(2044),
    [anon_sym_new] = ACTIONS(2044),
    [anon_sym_requires] = ACTIONS(2044),
    [sym_this] = ACTIONS(2044),
    [anon_sym___launch_bounds__] = ACTIONS(2044),
  },
  [343] = {
    [ts_builtin_sym_end] = ACTIONS(2066),
    [sym_identifier] = ACTIONS(2064),
    [aux_sym_preproc_include_token1] = ACTIONS(2064),
    [aux_sym_preproc_def_token1] = ACTIONS(2064),
    [aux_sym_preproc_if_token1] = ACTIONS(2064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2064),
    [sym_preproc_directive] = ACTIONS(2064),
    [anon_sym_LPAREN2] = ACTIONS(2066),
    [anon_sym_BANG] = ACTIONS(2066),
    [anon_sym_TILDE] = ACTIONS(2066),
    [anon_sym_DASH] = ACTIONS(2064),
    [anon_sym_PLUS] = ACTIONS(2064),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_AMP_AMP] = ACTIONS(2066),
    [anon_sym_AMP] = ACTIONS(2064),
    [anon_sym_SEMI] = ACTIONS(2066),
    [anon_sym___extension__] = ACTIONS(2064),
    [anon_sym_typedef] = ACTIONS(2064),
    [anon_sym___device__] = ACTIONS(2064),
    [anon_sym___host__] = ACTIONS(2064),
    [anon_sym___global__] = ACTIONS(2064),
    [anon_sym___forceinline__] = ACTIONS(2064),
    [anon_sym___noinline__] = ACTIONS(2064),
    [anon_sym_extern] = ACTIONS(2064),
    [anon_sym___attribute__] = ACTIONS(2064),
    [anon_sym_COLON_COLON] = ACTIONS(2066),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2066),
    [anon_sym___declspec] = ACTIONS(2064),
    [anon_sym___based] = ACTIONS(2064),
    [anon_sym___cdecl] = ACTIONS(2064),
    [anon_sym___clrcall] = ACTIONS(2064),
    [anon_sym___stdcall] = ACTIONS(2064),
    [anon_sym___fastcall] = ACTIONS(2064),
    [anon_sym___thiscall] = ACTIONS(2064),
    [anon_sym___vectorcall] = ACTIONS(2064),
    [anon_sym_LBRACE] = ACTIONS(2066),
    [anon_sym_signed] = ACTIONS(2064),
    [anon_sym_unsigned] = ACTIONS(2064),
    [anon_sym_long] = ACTIONS(2064),
    [anon_sym_short] = ACTIONS(2064),
    [anon_sym_LBRACK] = ACTIONS(2064),
    [anon_sym_static] = ACTIONS(2064),
    [anon_sym_register] = ACTIONS(2064),
    [anon_sym_inline] = ACTIONS(2064),
    [anon_sym___inline] = ACTIONS(2064),
    [anon_sym___inline__] = ACTIONS(2064),
    [anon_sym___forceinline] = ACTIONS(2064),
    [anon_sym_thread_local] = ACTIONS(2064),
    [anon_sym___thread] = ACTIONS(2064),
    [anon_sym_const] = ACTIONS(2064),
    [anon_sym_constexpr] = ACTIONS(2064),
    [anon_sym_volatile] = ACTIONS(2064),
    [anon_sym_restrict] = ACTIONS(2064),
    [anon_sym___restrict__] = ACTIONS(2064),
    [anon_sym__Atomic] = ACTIONS(2064),
    [anon_sym__Noreturn] = ACTIONS(2064),
    [anon_sym_noreturn] = ACTIONS(2064),
    [anon_sym_mutable] = ACTIONS(2064),
    [anon_sym_constinit] = ACTIONS(2064),
    [anon_sym_consteval] = ACTIONS(2064),
    [anon_sym___shared__] = ACTIONS(2064),
    [anon_sym___local__] = ACTIONS(2064),
    [anon_sym___constant__] = ACTIONS(2064),
    [anon_sym___managed__] = ACTIONS(2064),
    [anon_sym___grid_constant__] = ACTIONS(2064),
    [anon_sym_alignas] = ACTIONS(2064),
    [anon_sym__Alignas] = ACTIONS(2064),
    [sym_primitive_type] = ACTIONS(2064),
    [anon_sym_enum] = ACTIONS(2064),
    [anon_sym_class] = ACTIONS(2064),
    [anon_sym_struct] = ACTIONS(2064),
    [anon_sym_union] = ACTIONS(2064),
    [anon_sym_if] = ACTIONS(2064),
    [anon_sym_else] = ACTIONS(2064),
    [anon_sym_switch] = ACTIONS(2064),
    [anon_sym_case] = ACTIONS(2064),
    [anon_sym_default] = ACTIONS(2064),
    [anon_sym_while] = ACTIONS(2064),
    [anon_sym_do] = ACTIONS(2064),
    [anon_sym_for] = ACTIONS(2064),
    [anon_sym_return] = ACTIONS(2064),
    [anon_sym_break] = ACTIONS(2064),
    [anon_sym_continue] = ACTIONS(2064),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym___try] = ACTIONS(2064),
    [anon_sym___leave] = ACTIONS(2064),
    [anon_sym_not] = ACTIONS(2064),
    [anon_sym_compl] = ACTIONS(2064),
    [anon_sym_DASH_DASH] = ACTIONS(2066),
    [anon_sym_PLUS_PLUS] = ACTIONS(2066),
    [anon_sym_sizeof] = ACTIONS(2064),
    [anon_sym___alignof__] = ACTIONS(2064),
    [anon_sym___alignof] = ACTIONS(2064),
    [anon_sym__alignof] = ACTIONS(2064),
    [anon_sym_alignof] = ACTIONS(2064),
    [anon_sym__Alignof] = ACTIONS(2064),
    [anon_sym_offsetof] = ACTIONS(2064),
    [anon_sym__Generic] = ACTIONS(2064),
    [anon_sym_asm] = ACTIONS(2064),
    [anon_sym___asm__] = ACTIONS(2064),
    [sym_number_literal] = ACTIONS(2066),
    [anon_sym_L_SQUOTE] = ACTIONS(2066),
    [anon_sym_u_SQUOTE] = ACTIONS(2066),
    [anon_sym_U_SQUOTE] = ACTIONS(2066),
    [anon_sym_u8_SQUOTE] = ACTIONS(2066),
    [anon_sym_SQUOTE] = ACTIONS(2066),
    [anon_sym_L_DQUOTE] = ACTIONS(2066),
    [anon_sym_u_DQUOTE] = ACTIONS(2066),
    [anon_sym_U_DQUOTE] = ACTIONS(2066),
    [anon_sym_u8_DQUOTE] = ACTIONS(2066),
    [anon_sym_DQUOTE] = ACTIONS(2066),
    [sym_true] = ACTIONS(2064),
    [sym_false] = ACTIONS(2064),
    [anon_sym_NULL] = ACTIONS(2064),
    [anon_sym_nullptr] = ACTIONS(2064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2064),
    [anon_sym_decltype] = ACTIONS(2064),
    [sym_virtual] = ACTIONS(2064),
    [anon_sym_explicit] = ACTIONS(2064),
    [anon_sym_typename] = ACTIONS(2064),
    [anon_sym_template] = ACTIONS(2064),
    [anon_sym_operator] = ACTIONS(2064),
    [anon_sym_try] = ACTIONS(2064),
    [anon_sym_delete] = ACTIONS(2064),
    [anon_sym_throw] = ACTIONS(2064),
    [anon_sym_namespace] = ACTIONS(2064),
    [anon_sym_using] = ACTIONS(2064),
    [anon_sym_static_assert] = ACTIONS(2064),
    [anon_sym_concept] = ACTIONS(2064),
    [anon_sym_co_return] = ACTIONS(2064),
    [anon_sym_co_yield] = ACTIONS(2064),
    [anon_sym_R_DQUOTE] = ACTIONS(2066),
    [anon_sym_LR_DQUOTE] = ACTIONS(2066),
    [anon_sym_uR_DQUOTE] = ACTIONS(2066),
    [anon_sym_UR_DQUOTE] = ACTIONS(2066),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2066),
    [anon_sym_co_await] = ACTIONS(2064),
    [anon_sym_new] = ACTIONS(2064),
    [anon_sym_requires] = ACTIONS(2064),
    [sym_this] = ACTIONS(2064),
    [anon_sym___launch_bounds__] = ACTIONS(2064),
  },
  [344] = {
    [sym_identifier] = ACTIONS(1980),
    [aux_sym_preproc_include_token1] = ACTIONS(1980),
    [aux_sym_preproc_def_token1] = ACTIONS(1980),
    [aux_sym_preproc_if_token1] = ACTIONS(1980),
    [aux_sym_preproc_if_token2] = ACTIONS(1980),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1980),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1980),
    [sym_preproc_directive] = ACTIONS(1980),
    [anon_sym_LPAREN2] = ACTIONS(1982),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_AMP_AMP] = ACTIONS(1982),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_SEMI] = ACTIONS(1982),
    [anon_sym___extension__] = ACTIONS(1980),
    [anon_sym_typedef] = ACTIONS(1980),
    [anon_sym___device__] = ACTIONS(1980),
    [anon_sym___host__] = ACTIONS(1980),
    [anon_sym___global__] = ACTIONS(1980),
    [anon_sym___forceinline__] = ACTIONS(1980),
    [anon_sym___noinline__] = ACTIONS(1980),
    [anon_sym_extern] = ACTIONS(1980),
    [anon_sym___attribute__] = ACTIONS(1980),
    [anon_sym_COLON_COLON] = ACTIONS(1982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1982),
    [anon_sym___declspec] = ACTIONS(1980),
    [anon_sym___based] = ACTIONS(1980),
    [anon_sym___cdecl] = ACTIONS(1980),
    [anon_sym___clrcall] = ACTIONS(1980),
    [anon_sym___stdcall] = ACTIONS(1980),
    [anon_sym___fastcall] = ACTIONS(1980),
    [anon_sym___thiscall] = ACTIONS(1980),
    [anon_sym___vectorcall] = ACTIONS(1980),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_signed] = ACTIONS(1980),
    [anon_sym_unsigned] = ACTIONS(1980),
    [anon_sym_long] = ACTIONS(1980),
    [anon_sym_short] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_static] = ACTIONS(1980),
    [anon_sym_register] = ACTIONS(1980),
    [anon_sym_inline] = ACTIONS(1980),
    [anon_sym___inline] = ACTIONS(1980),
    [anon_sym___inline__] = ACTIONS(1980),
    [anon_sym___forceinline] = ACTIONS(1980),
    [anon_sym_thread_local] = ACTIONS(1980),
    [anon_sym___thread] = ACTIONS(1980),
    [anon_sym_const] = ACTIONS(1980),
    [anon_sym_constexpr] = ACTIONS(1980),
    [anon_sym_volatile] = ACTIONS(1980),
    [anon_sym_restrict] = ACTIONS(1980),
    [anon_sym___restrict__] = ACTIONS(1980),
    [anon_sym__Atomic] = ACTIONS(1980),
    [anon_sym__Noreturn] = ACTIONS(1980),
    [anon_sym_noreturn] = ACTIONS(1980),
    [anon_sym_mutable] = ACTIONS(1980),
    [anon_sym_constinit] = ACTIONS(1980),
    [anon_sym_consteval] = ACTIONS(1980),
    [anon_sym___shared__] = ACTIONS(1980),
    [anon_sym___local__] = ACTIONS(1980),
    [anon_sym___constant__] = ACTIONS(1980),
    [anon_sym___managed__] = ACTIONS(1980),
    [anon_sym___grid_constant__] = ACTIONS(1980),
    [anon_sym_alignas] = ACTIONS(1980),
    [anon_sym__Alignas] = ACTIONS(1980),
    [sym_primitive_type] = ACTIONS(1980),
    [anon_sym_enum] = ACTIONS(1980),
    [anon_sym_class] = ACTIONS(1980),
    [anon_sym_struct] = ACTIONS(1980),
    [anon_sym_union] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_else] = ACTIONS(1980),
    [anon_sym_switch] = ACTIONS(1980),
    [anon_sym_case] = ACTIONS(1980),
    [anon_sym_default] = ACTIONS(1980),
    [anon_sym_while] = ACTIONS(1980),
    [anon_sym_do] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_return] = ACTIONS(1980),
    [anon_sym_break] = ACTIONS(1980),
    [anon_sym_continue] = ACTIONS(1980),
    [anon_sym_goto] = ACTIONS(1980),
    [anon_sym___try] = ACTIONS(1980),
    [anon_sym___leave] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_compl] = ACTIONS(1980),
    [anon_sym_DASH_DASH] = ACTIONS(1982),
    [anon_sym_PLUS_PLUS] = ACTIONS(1982),
    [anon_sym_sizeof] = ACTIONS(1980),
    [anon_sym___alignof__] = ACTIONS(1980),
    [anon_sym___alignof] = ACTIONS(1980),
    [anon_sym__alignof] = ACTIONS(1980),
    [anon_sym_alignof] = ACTIONS(1980),
    [anon_sym__Alignof] = ACTIONS(1980),
    [anon_sym_offsetof] = ACTIONS(1980),
    [anon_sym__Generic] = ACTIONS(1980),
    [anon_sym_asm] = ACTIONS(1980),
    [anon_sym___asm__] = ACTIONS(1980),
    [sym_number_literal] = ACTIONS(1982),
    [anon_sym_L_SQUOTE] = ACTIONS(1982),
    [anon_sym_u_SQUOTE] = ACTIONS(1982),
    [anon_sym_U_SQUOTE] = ACTIONS(1982),
    [anon_sym_u8_SQUOTE] = ACTIONS(1982),
    [anon_sym_SQUOTE] = ACTIONS(1982),
    [anon_sym_L_DQUOTE] = ACTIONS(1982),
    [anon_sym_u_DQUOTE] = ACTIONS(1982),
    [anon_sym_U_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8_DQUOTE] = ACTIONS(1982),
    [anon_sym_DQUOTE] = ACTIONS(1982),
    [sym_true] = ACTIONS(1980),
    [sym_false] = ACTIONS(1980),
    [anon_sym_NULL] = ACTIONS(1980),
    [anon_sym_nullptr] = ACTIONS(1980),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1980),
    [anon_sym_decltype] = ACTIONS(1980),
    [sym_virtual] = ACTIONS(1980),
    [anon_sym_explicit] = ACTIONS(1980),
    [anon_sym_typename] = ACTIONS(1980),
    [anon_sym_template] = ACTIONS(1980),
    [anon_sym_operator] = ACTIONS(1980),
    [anon_sym_try] = ACTIONS(1980),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_throw] = ACTIONS(1980),
    [anon_sym_namespace] = ACTIONS(1980),
    [anon_sym_using] = ACTIONS(1980),
    [anon_sym_static_assert] = ACTIONS(1980),
    [anon_sym_concept] = ACTIONS(1980),
    [anon_sym_co_return] = ACTIONS(1980),
    [anon_sym_co_yield] = ACTIONS(1980),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1980),
    [anon_sym_new] = ACTIONS(1980),
    [anon_sym_requires] = ACTIONS(1980),
    [sym_this] = ACTIONS(1980),
    [anon_sym___launch_bounds__] = ACTIONS(1980),
  },
  [345] = {
    [sym_identifier] = ACTIONS(1976),
    [aux_sym_preproc_include_token1] = ACTIONS(1976),
    [aux_sym_preproc_def_token1] = ACTIONS(1976),
    [aux_sym_preproc_if_token1] = ACTIONS(1976),
    [aux_sym_preproc_if_token2] = ACTIONS(1976),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1976),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1976),
    [sym_preproc_directive] = ACTIONS(1976),
    [anon_sym_LPAREN2] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1978),
    [anon_sym_TILDE] = ACTIONS(1978),
    [anon_sym_DASH] = ACTIONS(1976),
    [anon_sym_PLUS] = ACTIONS(1976),
    [anon_sym_STAR] = ACTIONS(1978),
    [anon_sym_AMP_AMP] = ACTIONS(1978),
    [anon_sym_AMP] = ACTIONS(1976),
    [anon_sym_SEMI] = ACTIONS(1978),
    [anon_sym___extension__] = ACTIONS(1976),
    [anon_sym_typedef] = ACTIONS(1976),
    [anon_sym___device__] = ACTIONS(1976),
    [anon_sym___host__] = ACTIONS(1976),
    [anon_sym___global__] = ACTIONS(1976),
    [anon_sym___forceinline__] = ACTIONS(1976),
    [anon_sym___noinline__] = ACTIONS(1976),
    [anon_sym_extern] = ACTIONS(1976),
    [anon_sym___attribute__] = ACTIONS(1976),
    [anon_sym_COLON_COLON] = ACTIONS(1978),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1978),
    [anon_sym___declspec] = ACTIONS(1976),
    [anon_sym___based] = ACTIONS(1976),
    [anon_sym___cdecl] = ACTIONS(1976),
    [anon_sym___clrcall] = ACTIONS(1976),
    [anon_sym___stdcall] = ACTIONS(1976),
    [anon_sym___fastcall] = ACTIONS(1976),
    [anon_sym___thiscall] = ACTIONS(1976),
    [anon_sym___vectorcall] = ACTIONS(1976),
    [anon_sym_LBRACE] = ACTIONS(1978),
    [anon_sym_signed] = ACTIONS(1976),
    [anon_sym_unsigned] = ACTIONS(1976),
    [anon_sym_long] = ACTIONS(1976),
    [anon_sym_short] = ACTIONS(1976),
    [anon_sym_LBRACK] = ACTIONS(1976),
    [anon_sym_static] = ACTIONS(1976),
    [anon_sym_register] = ACTIONS(1976),
    [anon_sym_inline] = ACTIONS(1976),
    [anon_sym___inline] = ACTIONS(1976),
    [anon_sym___inline__] = ACTIONS(1976),
    [anon_sym___forceinline] = ACTIONS(1976),
    [anon_sym_thread_local] = ACTIONS(1976),
    [anon_sym___thread] = ACTIONS(1976),
    [anon_sym_const] = ACTIONS(1976),
    [anon_sym_constexpr] = ACTIONS(1976),
    [anon_sym_volatile] = ACTIONS(1976),
    [anon_sym_restrict] = ACTIONS(1976),
    [anon_sym___restrict__] = ACTIONS(1976),
    [anon_sym__Atomic] = ACTIONS(1976),
    [anon_sym__Noreturn] = ACTIONS(1976),
    [anon_sym_noreturn] = ACTIONS(1976),
    [anon_sym_mutable] = ACTIONS(1976),
    [anon_sym_constinit] = ACTIONS(1976),
    [anon_sym_consteval] = ACTIONS(1976),
    [anon_sym___shared__] = ACTIONS(1976),
    [anon_sym___local__] = ACTIONS(1976),
    [anon_sym___constant__] = ACTIONS(1976),
    [anon_sym___managed__] = ACTIONS(1976),
    [anon_sym___grid_constant__] = ACTIONS(1976),
    [anon_sym_alignas] = ACTIONS(1976),
    [anon_sym__Alignas] = ACTIONS(1976),
    [sym_primitive_type] = ACTIONS(1976),
    [anon_sym_enum] = ACTIONS(1976),
    [anon_sym_class] = ACTIONS(1976),
    [anon_sym_struct] = ACTIONS(1976),
    [anon_sym_union] = ACTIONS(1976),
    [anon_sym_if] = ACTIONS(1976),
    [anon_sym_else] = ACTIONS(1976),
    [anon_sym_switch] = ACTIONS(1976),
    [anon_sym_case] = ACTIONS(1976),
    [anon_sym_default] = ACTIONS(1976),
    [anon_sym_while] = ACTIONS(1976),
    [anon_sym_do] = ACTIONS(1976),
    [anon_sym_for] = ACTIONS(1976),
    [anon_sym_return] = ACTIONS(1976),
    [anon_sym_break] = ACTIONS(1976),
    [anon_sym_continue] = ACTIONS(1976),
    [anon_sym_goto] = ACTIONS(1976),
    [anon_sym___try] = ACTIONS(1976),
    [anon_sym___leave] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1976),
    [anon_sym_compl] = ACTIONS(1976),
    [anon_sym_DASH_DASH] = ACTIONS(1978),
    [anon_sym_PLUS_PLUS] = ACTIONS(1978),
    [anon_sym_sizeof] = ACTIONS(1976),
    [anon_sym___alignof__] = ACTIONS(1976),
    [anon_sym___alignof] = ACTIONS(1976),
    [anon_sym__alignof] = ACTIONS(1976),
    [anon_sym_alignof] = ACTIONS(1976),
    [anon_sym__Alignof] = ACTIONS(1976),
    [anon_sym_offsetof] = ACTIONS(1976),
    [anon_sym__Generic] = ACTIONS(1976),
    [anon_sym_asm] = ACTIONS(1976),
    [anon_sym___asm__] = ACTIONS(1976),
    [sym_number_literal] = ACTIONS(1978),
    [anon_sym_L_SQUOTE] = ACTIONS(1978),
    [anon_sym_u_SQUOTE] = ACTIONS(1978),
    [anon_sym_U_SQUOTE] = ACTIONS(1978),
    [anon_sym_u8_SQUOTE] = ACTIONS(1978),
    [anon_sym_SQUOTE] = ACTIONS(1978),
    [anon_sym_L_DQUOTE] = ACTIONS(1978),
    [anon_sym_u_DQUOTE] = ACTIONS(1978),
    [anon_sym_U_DQUOTE] = ACTIONS(1978),
    [anon_sym_u8_DQUOTE] = ACTIONS(1978),
    [anon_sym_DQUOTE] = ACTIONS(1978),
    [sym_true] = ACTIONS(1976),
    [sym_false] = ACTIONS(1976),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1976),
    [anon_sym_decltype] = ACTIONS(1976),
    [sym_virtual] = ACTIONS(1976),
    [anon_sym_explicit] = ACTIONS(1976),
    [anon_sym_typename] = ACTIONS(1976),
    [anon_sym_template] = ACTIONS(1976),
    [anon_sym_operator] = ACTIONS(1976),
    [anon_sym_try] = ACTIONS(1976),
    [anon_sym_delete] = ACTIONS(1976),
    [anon_sym_throw] = ACTIONS(1976),
    [anon_sym_namespace] = ACTIONS(1976),
    [anon_sym_using] = ACTIONS(1976),
    [anon_sym_static_assert] = ACTIONS(1976),
    [anon_sym_concept] = ACTIONS(1976),
    [anon_sym_co_return] = ACTIONS(1976),
    [anon_sym_co_yield] = ACTIONS(1976),
    [anon_sym_R_DQUOTE] = ACTIONS(1978),
    [anon_sym_LR_DQUOTE] = ACTIONS(1978),
    [anon_sym_uR_DQUOTE] = ACTIONS(1978),
    [anon_sym_UR_DQUOTE] = ACTIONS(1978),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1978),
    [anon_sym_co_await] = ACTIONS(1976),
    [anon_sym_new] = ACTIONS(1976),
    [anon_sym_requires] = ACTIONS(1976),
    [sym_this] = ACTIONS(1976),
    [anon_sym___launch_bounds__] = ACTIONS(1976),
  },
  [346] = {
    [sym_identifier] = ACTIONS(1950),
    [aux_sym_preproc_include_token1] = ACTIONS(1950),
    [aux_sym_preproc_def_token1] = ACTIONS(1950),
    [aux_sym_preproc_if_token1] = ACTIONS(1950),
    [aux_sym_preproc_if_token2] = ACTIONS(1950),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1950),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1950),
    [sym_preproc_directive] = ACTIONS(1950),
    [anon_sym_LPAREN2] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1952),
    [anon_sym_TILDE] = ACTIONS(1952),
    [anon_sym_DASH] = ACTIONS(1950),
    [anon_sym_PLUS] = ACTIONS(1950),
    [anon_sym_STAR] = ACTIONS(1952),
    [anon_sym_AMP_AMP] = ACTIONS(1952),
    [anon_sym_AMP] = ACTIONS(1950),
    [anon_sym_SEMI] = ACTIONS(1952),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_typedef] = ACTIONS(1950),
    [anon_sym___device__] = ACTIONS(1950),
    [anon_sym___host__] = ACTIONS(1950),
    [anon_sym___global__] = ACTIONS(1950),
    [anon_sym___forceinline__] = ACTIONS(1950),
    [anon_sym___noinline__] = ACTIONS(1950),
    [anon_sym_extern] = ACTIONS(1950),
    [anon_sym___attribute__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1952),
    [anon_sym___declspec] = ACTIONS(1950),
    [anon_sym___based] = ACTIONS(1950),
    [anon_sym___cdecl] = ACTIONS(1950),
    [anon_sym___clrcall] = ACTIONS(1950),
    [anon_sym___stdcall] = ACTIONS(1950),
    [anon_sym___fastcall] = ACTIONS(1950),
    [anon_sym___thiscall] = ACTIONS(1950),
    [anon_sym___vectorcall] = ACTIONS(1950),
    [anon_sym_LBRACE] = ACTIONS(1952),
    [anon_sym_signed] = ACTIONS(1950),
    [anon_sym_unsigned] = ACTIONS(1950),
    [anon_sym_long] = ACTIONS(1950),
    [anon_sym_short] = ACTIONS(1950),
    [anon_sym_LBRACK] = ACTIONS(1950),
    [anon_sym_static] = ACTIONS(1950),
    [anon_sym_register] = ACTIONS(1950),
    [anon_sym_inline] = ACTIONS(1950),
    [anon_sym___inline] = ACTIONS(1950),
    [anon_sym___inline__] = ACTIONS(1950),
    [anon_sym___forceinline] = ACTIONS(1950),
    [anon_sym_thread_local] = ACTIONS(1950),
    [anon_sym___thread] = ACTIONS(1950),
    [anon_sym_const] = ACTIONS(1950),
    [anon_sym_constexpr] = ACTIONS(1950),
    [anon_sym_volatile] = ACTIONS(1950),
    [anon_sym_restrict] = ACTIONS(1950),
    [anon_sym___restrict__] = ACTIONS(1950),
    [anon_sym__Atomic] = ACTIONS(1950),
    [anon_sym__Noreturn] = ACTIONS(1950),
    [anon_sym_noreturn] = ACTIONS(1950),
    [anon_sym_mutable] = ACTIONS(1950),
    [anon_sym_constinit] = ACTIONS(1950),
    [anon_sym_consteval] = ACTIONS(1950),
    [anon_sym___shared__] = ACTIONS(1950),
    [anon_sym___local__] = ACTIONS(1950),
    [anon_sym___constant__] = ACTIONS(1950),
    [anon_sym___managed__] = ACTIONS(1950),
    [anon_sym___grid_constant__] = ACTIONS(1950),
    [anon_sym_alignas] = ACTIONS(1950),
    [anon_sym__Alignas] = ACTIONS(1950),
    [sym_primitive_type] = ACTIONS(1950),
    [anon_sym_enum] = ACTIONS(1950),
    [anon_sym_class] = ACTIONS(1950),
    [anon_sym_struct] = ACTIONS(1950),
    [anon_sym_union] = ACTIONS(1950),
    [anon_sym_if] = ACTIONS(1950),
    [anon_sym_else] = ACTIONS(1950),
    [anon_sym_switch] = ACTIONS(1950),
    [anon_sym_case] = ACTIONS(1950),
    [anon_sym_default] = ACTIONS(1950),
    [anon_sym_while] = ACTIONS(1950),
    [anon_sym_do] = ACTIONS(1950),
    [anon_sym_for] = ACTIONS(1950),
    [anon_sym_return] = ACTIONS(1950),
    [anon_sym_break] = ACTIONS(1950),
    [anon_sym_continue] = ACTIONS(1950),
    [anon_sym_goto] = ACTIONS(1950),
    [anon_sym___try] = ACTIONS(1950),
    [anon_sym___leave] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1950),
    [anon_sym_compl] = ACTIONS(1950),
    [anon_sym_DASH_DASH] = ACTIONS(1952),
    [anon_sym_PLUS_PLUS] = ACTIONS(1952),
    [anon_sym_sizeof] = ACTIONS(1950),
    [anon_sym___alignof__] = ACTIONS(1950),
    [anon_sym___alignof] = ACTIONS(1950),
    [anon_sym__alignof] = ACTIONS(1950),
    [anon_sym_alignof] = ACTIONS(1950),
    [anon_sym__Alignof] = ACTIONS(1950),
    [anon_sym_offsetof] = ACTIONS(1950),
    [anon_sym__Generic] = ACTIONS(1950),
    [anon_sym_asm] = ACTIONS(1950),
    [anon_sym___asm__] = ACTIONS(1950),
    [sym_number_literal] = ACTIONS(1952),
    [anon_sym_L_SQUOTE] = ACTIONS(1952),
    [anon_sym_u_SQUOTE] = ACTIONS(1952),
    [anon_sym_U_SQUOTE] = ACTIONS(1952),
    [anon_sym_u8_SQUOTE] = ACTIONS(1952),
    [anon_sym_SQUOTE] = ACTIONS(1952),
    [anon_sym_L_DQUOTE] = ACTIONS(1952),
    [anon_sym_u_DQUOTE] = ACTIONS(1952),
    [anon_sym_U_DQUOTE] = ACTIONS(1952),
    [anon_sym_u8_DQUOTE] = ACTIONS(1952),
    [anon_sym_DQUOTE] = ACTIONS(1952),
    [sym_true] = ACTIONS(1950),
    [sym_false] = ACTIONS(1950),
    [anon_sym_NULL] = ACTIONS(1950),
    [anon_sym_nullptr] = ACTIONS(1950),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1950),
    [anon_sym_decltype] = ACTIONS(1950),
    [sym_virtual] = ACTIONS(1950),
    [anon_sym_explicit] = ACTIONS(1950),
    [anon_sym_typename] = ACTIONS(1950),
    [anon_sym_template] = ACTIONS(1950),
    [anon_sym_operator] = ACTIONS(1950),
    [anon_sym_try] = ACTIONS(1950),
    [anon_sym_delete] = ACTIONS(1950),
    [anon_sym_throw] = ACTIONS(1950),
    [anon_sym_namespace] = ACTIONS(1950),
    [anon_sym_using] = ACTIONS(1950),
    [anon_sym_static_assert] = ACTIONS(1950),
    [anon_sym_concept] = ACTIONS(1950),
    [anon_sym_co_return] = ACTIONS(1950),
    [anon_sym_co_yield] = ACTIONS(1950),
    [anon_sym_R_DQUOTE] = ACTIONS(1952),
    [anon_sym_LR_DQUOTE] = ACTIONS(1952),
    [anon_sym_uR_DQUOTE] = ACTIONS(1952),
    [anon_sym_UR_DQUOTE] = ACTIONS(1952),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1952),
    [anon_sym_co_await] = ACTIONS(1950),
    [anon_sym_new] = ACTIONS(1950),
    [anon_sym_requires] = ACTIONS(1950),
    [sym_this] = ACTIONS(1950),
    [anon_sym___launch_bounds__] = ACTIONS(1950),
  },
  [347] = {
    [ts_builtin_sym_end] = ACTIONS(2034),
    [sym_identifier] = ACTIONS(2032),
    [aux_sym_preproc_include_token1] = ACTIONS(2032),
    [aux_sym_preproc_def_token1] = ACTIONS(2032),
    [aux_sym_preproc_if_token1] = ACTIONS(2032),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2032),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2032),
    [sym_preproc_directive] = ACTIONS(2032),
    [anon_sym_LPAREN2] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2034),
    [anon_sym_TILDE] = ACTIONS(2034),
    [anon_sym_DASH] = ACTIONS(2032),
    [anon_sym_PLUS] = ACTIONS(2032),
    [anon_sym_STAR] = ACTIONS(2034),
    [anon_sym_AMP_AMP] = ACTIONS(2034),
    [anon_sym_AMP] = ACTIONS(2032),
    [anon_sym_SEMI] = ACTIONS(2034),
    [anon_sym___extension__] = ACTIONS(2032),
    [anon_sym_typedef] = ACTIONS(2032),
    [anon_sym___device__] = ACTIONS(2032),
    [anon_sym___host__] = ACTIONS(2032),
    [anon_sym___global__] = ACTIONS(2032),
    [anon_sym___forceinline__] = ACTIONS(2032),
    [anon_sym___noinline__] = ACTIONS(2032),
    [anon_sym_extern] = ACTIONS(2032),
    [anon_sym___attribute__] = ACTIONS(2032),
    [anon_sym_COLON_COLON] = ACTIONS(2034),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2034),
    [anon_sym___declspec] = ACTIONS(2032),
    [anon_sym___based] = ACTIONS(2032),
    [anon_sym___cdecl] = ACTIONS(2032),
    [anon_sym___clrcall] = ACTIONS(2032),
    [anon_sym___stdcall] = ACTIONS(2032),
    [anon_sym___fastcall] = ACTIONS(2032),
    [anon_sym___thiscall] = ACTIONS(2032),
    [anon_sym___vectorcall] = ACTIONS(2032),
    [anon_sym_LBRACE] = ACTIONS(2034),
    [anon_sym_signed] = ACTIONS(2032),
    [anon_sym_unsigned] = ACTIONS(2032),
    [anon_sym_long] = ACTIONS(2032),
    [anon_sym_short] = ACTIONS(2032),
    [anon_sym_LBRACK] = ACTIONS(2032),
    [anon_sym_static] = ACTIONS(2032),
    [anon_sym_register] = ACTIONS(2032),
    [anon_sym_inline] = ACTIONS(2032),
    [anon_sym___inline] = ACTIONS(2032),
    [anon_sym___inline__] = ACTIONS(2032),
    [anon_sym___forceinline] = ACTIONS(2032),
    [anon_sym_thread_local] = ACTIONS(2032),
    [anon_sym___thread] = ACTIONS(2032),
    [anon_sym_const] = ACTIONS(2032),
    [anon_sym_constexpr] = ACTIONS(2032),
    [anon_sym_volatile] = ACTIONS(2032),
    [anon_sym_restrict] = ACTIONS(2032),
    [anon_sym___restrict__] = ACTIONS(2032),
    [anon_sym__Atomic] = ACTIONS(2032),
    [anon_sym__Noreturn] = ACTIONS(2032),
    [anon_sym_noreturn] = ACTIONS(2032),
    [anon_sym_mutable] = ACTIONS(2032),
    [anon_sym_constinit] = ACTIONS(2032),
    [anon_sym_consteval] = ACTIONS(2032),
    [anon_sym___shared__] = ACTIONS(2032),
    [anon_sym___local__] = ACTIONS(2032),
    [anon_sym___constant__] = ACTIONS(2032),
    [anon_sym___managed__] = ACTIONS(2032),
    [anon_sym___grid_constant__] = ACTIONS(2032),
    [anon_sym_alignas] = ACTIONS(2032),
    [anon_sym__Alignas] = ACTIONS(2032),
    [sym_primitive_type] = ACTIONS(2032),
    [anon_sym_enum] = ACTIONS(2032),
    [anon_sym_class] = ACTIONS(2032),
    [anon_sym_struct] = ACTIONS(2032),
    [anon_sym_union] = ACTIONS(2032),
    [anon_sym_if] = ACTIONS(2032),
    [anon_sym_else] = ACTIONS(2032),
    [anon_sym_switch] = ACTIONS(2032),
    [anon_sym_case] = ACTIONS(2032),
    [anon_sym_default] = ACTIONS(2032),
    [anon_sym_while] = ACTIONS(2032),
    [anon_sym_do] = ACTIONS(2032),
    [anon_sym_for] = ACTIONS(2032),
    [anon_sym_return] = ACTIONS(2032),
    [anon_sym_break] = ACTIONS(2032),
    [anon_sym_continue] = ACTIONS(2032),
    [anon_sym_goto] = ACTIONS(2032),
    [anon_sym___try] = ACTIONS(2032),
    [anon_sym___leave] = ACTIONS(2032),
    [anon_sym_not] = ACTIONS(2032),
    [anon_sym_compl] = ACTIONS(2032),
    [anon_sym_DASH_DASH] = ACTIONS(2034),
    [anon_sym_PLUS_PLUS] = ACTIONS(2034),
    [anon_sym_sizeof] = ACTIONS(2032),
    [anon_sym___alignof__] = ACTIONS(2032),
    [anon_sym___alignof] = ACTIONS(2032),
    [anon_sym__alignof] = ACTIONS(2032),
    [anon_sym_alignof] = ACTIONS(2032),
    [anon_sym__Alignof] = ACTIONS(2032),
    [anon_sym_offsetof] = ACTIONS(2032),
    [anon_sym__Generic] = ACTIONS(2032),
    [anon_sym_asm] = ACTIONS(2032),
    [anon_sym___asm__] = ACTIONS(2032),
    [sym_number_literal] = ACTIONS(2034),
    [anon_sym_L_SQUOTE] = ACTIONS(2034),
    [anon_sym_u_SQUOTE] = ACTIONS(2034),
    [anon_sym_U_SQUOTE] = ACTIONS(2034),
    [anon_sym_u8_SQUOTE] = ACTIONS(2034),
    [anon_sym_SQUOTE] = ACTIONS(2034),
    [anon_sym_L_DQUOTE] = ACTIONS(2034),
    [anon_sym_u_DQUOTE] = ACTIONS(2034),
    [anon_sym_U_DQUOTE] = ACTIONS(2034),
    [anon_sym_u8_DQUOTE] = ACTIONS(2034),
    [anon_sym_DQUOTE] = ACTIONS(2034),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [anon_sym_NULL] = ACTIONS(2032),
    [anon_sym_nullptr] = ACTIONS(2032),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2032),
    [anon_sym_decltype] = ACTIONS(2032),
    [sym_virtual] = ACTIONS(2032),
    [anon_sym_explicit] = ACTIONS(2032),
    [anon_sym_typename] = ACTIONS(2032),
    [anon_sym_template] = ACTIONS(2032),
    [anon_sym_operator] = ACTIONS(2032),
    [anon_sym_try] = ACTIONS(2032),
    [anon_sym_delete] = ACTIONS(2032),
    [anon_sym_throw] = ACTIONS(2032),
    [anon_sym_namespace] = ACTIONS(2032),
    [anon_sym_using] = ACTIONS(2032),
    [anon_sym_static_assert] = ACTIONS(2032),
    [anon_sym_concept] = ACTIONS(2032),
    [anon_sym_co_return] = ACTIONS(2032),
    [anon_sym_co_yield] = ACTIONS(2032),
    [anon_sym_R_DQUOTE] = ACTIONS(2034),
    [anon_sym_LR_DQUOTE] = ACTIONS(2034),
    [anon_sym_uR_DQUOTE] = ACTIONS(2034),
    [anon_sym_UR_DQUOTE] = ACTIONS(2034),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2034),
    [anon_sym_co_await] = ACTIONS(2032),
    [anon_sym_new] = ACTIONS(2032),
    [anon_sym_requires] = ACTIONS(2032),
    [sym_this] = ACTIONS(2032),
    [anon_sym___launch_bounds__] = ACTIONS(2032),
  },
  [348] = {
    [sym_identifier] = ACTIONS(2020),
    [aux_sym_preproc_include_token1] = ACTIONS(2020),
    [aux_sym_preproc_def_token1] = ACTIONS(2020),
    [aux_sym_preproc_if_token1] = ACTIONS(2020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2020),
    [sym_preproc_directive] = ACTIONS(2020),
    [anon_sym_LPAREN2] = ACTIONS(2022),
    [anon_sym_BANG] = ACTIONS(2022),
    [anon_sym_TILDE] = ACTIONS(2022),
    [anon_sym_DASH] = ACTIONS(2020),
    [anon_sym_PLUS] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(2022),
    [anon_sym_AMP_AMP] = ACTIONS(2022),
    [anon_sym_AMP] = ACTIONS(2020),
    [anon_sym_SEMI] = ACTIONS(2022),
    [anon_sym___extension__] = ACTIONS(2020),
    [anon_sym_typedef] = ACTIONS(2020),
    [anon_sym___device__] = ACTIONS(2020),
    [anon_sym___host__] = ACTIONS(2020),
    [anon_sym___global__] = ACTIONS(2020),
    [anon_sym___forceinline__] = ACTIONS(2020),
    [anon_sym___noinline__] = ACTIONS(2020),
    [anon_sym_extern] = ACTIONS(2020),
    [anon_sym___attribute__] = ACTIONS(2020),
    [anon_sym_COLON_COLON] = ACTIONS(2022),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2022),
    [anon_sym___declspec] = ACTIONS(2020),
    [anon_sym___based] = ACTIONS(2020),
    [anon_sym___cdecl] = ACTIONS(2020),
    [anon_sym___clrcall] = ACTIONS(2020),
    [anon_sym___stdcall] = ACTIONS(2020),
    [anon_sym___fastcall] = ACTIONS(2020),
    [anon_sym___thiscall] = ACTIONS(2020),
    [anon_sym___vectorcall] = ACTIONS(2020),
    [anon_sym_LBRACE] = ACTIONS(2022),
    [anon_sym_RBRACE] = ACTIONS(2022),
    [anon_sym_signed] = ACTIONS(2020),
    [anon_sym_unsigned] = ACTIONS(2020),
    [anon_sym_long] = ACTIONS(2020),
    [anon_sym_short] = ACTIONS(2020),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(2020),
    [anon_sym_register] = ACTIONS(2020),
    [anon_sym_inline] = ACTIONS(2020),
    [anon_sym___inline] = ACTIONS(2020),
    [anon_sym___inline__] = ACTIONS(2020),
    [anon_sym___forceinline] = ACTIONS(2020),
    [anon_sym_thread_local] = ACTIONS(2020),
    [anon_sym___thread] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(2020),
    [anon_sym_constexpr] = ACTIONS(2020),
    [anon_sym_volatile] = ACTIONS(2020),
    [anon_sym_restrict] = ACTIONS(2020),
    [anon_sym___restrict__] = ACTIONS(2020),
    [anon_sym__Atomic] = ACTIONS(2020),
    [anon_sym__Noreturn] = ACTIONS(2020),
    [anon_sym_noreturn] = ACTIONS(2020),
    [anon_sym_mutable] = ACTIONS(2020),
    [anon_sym_constinit] = ACTIONS(2020),
    [anon_sym_consteval] = ACTIONS(2020),
    [anon_sym___shared__] = ACTIONS(2020),
    [anon_sym___local__] = ACTIONS(2020),
    [anon_sym___constant__] = ACTIONS(2020),
    [anon_sym___managed__] = ACTIONS(2020),
    [anon_sym___grid_constant__] = ACTIONS(2020),
    [anon_sym_alignas] = ACTIONS(2020),
    [anon_sym__Alignas] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2020),
    [anon_sym_enum] = ACTIONS(2020),
    [anon_sym_class] = ACTIONS(2020),
    [anon_sym_struct] = ACTIONS(2020),
    [anon_sym_union] = ACTIONS(2020),
    [anon_sym_if] = ACTIONS(2020),
    [anon_sym_else] = ACTIONS(2020),
    [anon_sym_switch] = ACTIONS(2020),
    [anon_sym_case] = ACTIONS(2020),
    [anon_sym_default] = ACTIONS(2020),
    [anon_sym_while] = ACTIONS(2020),
    [anon_sym_do] = ACTIONS(2020),
    [anon_sym_for] = ACTIONS(2020),
    [anon_sym_return] = ACTIONS(2020),
    [anon_sym_break] = ACTIONS(2020),
    [anon_sym_continue] = ACTIONS(2020),
    [anon_sym_goto] = ACTIONS(2020),
    [anon_sym___try] = ACTIONS(2020),
    [anon_sym___leave] = ACTIONS(2020),
    [anon_sym_not] = ACTIONS(2020),
    [anon_sym_compl] = ACTIONS(2020),
    [anon_sym_DASH_DASH] = ACTIONS(2022),
    [anon_sym_PLUS_PLUS] = ACTIONS(2022),
    [anon_sym_sizeof] = ACTIONS(2020),
    [anon_sym___alignof__] = ACTIONS(2020),
    [anon_sym___alignof] = ACTIONS(2020),
    [anon_sym__alignof] = ACTIONS(2020),
    [anon_sym_alignof] = ACTIONS(2020),
    [anon_sym__Alignof] = ACTIONS(2020),
    [anon_sym_offsetof] = ACTIONS(2020),
    [anon_sym__Generic] = ACTIONS(2020),
    [anon_sym_asm] = ACTIONS(2020),
    [anon_sym___asm__] = ACTIONS(2020),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_L_SQUOTE] = ACTIONS(2022),
    [anon_sym_u_SQUOTE] = ACTIONS(2022),
    [anon_sym_U_SQUOTE] = ACTIONS(2022),
    [anon_sym_u8_SQUOTE] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(2022),
    [anon_sym_L_DQUOTE] = ACTIONS(2022),
    [anon_sym_u_DQUOTE] = ACTIONS(2022),
    [anon_sym_U_DQUOTE] = ACTIONS(2022),
    [anon_sym_u8_DQUOTE] = ACTIONS(2022),
    [anon_sym_DQUOTE] = ACTIONS(2022),
    [sym_true] = ACTIONS(2020),
    [sym_false] = ACTIONS(2020),
    [anon_sym_NULL] = ACTIONS(2020),
    [anon_sym_nullptr] = ACTIONS(2020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2020),
    [anon_sym_decltype] = ACTIONS(2020),
    [sym_virtual] = ACTIONS(2020),
    [anon_sym_explicit] = ACTIONS(2020),
    [anon_sym_typename] = ACTIONS(2020),
    [anon_sym_template] = ACTIONS(2020),
    [anon_sym_operator] = ACTIONS(2020),
    [anon_sym_try] = ACTIONS(2020),
    [anon_sym_delete] = ACTIONS(2020),
    [anon_sym_throw] = ACTIONS(2020),
    [anon_sym_namespace] = ACTIONS(2020),
    [anon_sym_using] = ACTIONS(2020),
    [anon_sym_static_assert] = ACTIONS(2020),
    [anon_sym_concept] = ACTIONS(2020),
    [anon_sym_co_return] = ACTIONS(2020),
    [anon_sym_co_yield] = ACTIONS(2020),
    [anon_sym_R_DQUOTE] = ACTIONS(2022),
    [anon_sym_LR_DQUOTE] = ACTIONS(2022),
    [anon_sym_uR_DQUOTE] = ACTIONS(2022),
    [anon_sym_UR_DQUOTE] = ACTIONS(2022),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2022),
    [anon_sym_co_await] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(2020),
    [anon_sym_requires] = ACTIONS(2020),
    [sym_this] = ACTIONS(2020),
    [anon_sym___launch_bounds__] = ACTIONS(2020),
  },
  [349] = {
    [ts_builtin_sym_end] = ACTIONS(2078),
    [sym_identifier] = ACTIONS(2076),
    [aux_sym_preproc_include_token1] = ACTIONS(2076),
    [aux_sym_preproc_def_token1] = ACTIONS(2076),
    [aux_sym_preproc_if_token1] = ACTIONS(2076),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2076),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2076),
    [sym_preproc_directive] = ACTIONS(2076),
    [anon_sym_LPAREN2] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2078),
    [anon_sym_TILDE] = ACTIONS(2078),
    [anon_sym_DASH] = ACTIONS(2076),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_STAR] = ACTIONS(2078),
    [anon_sym_AMP_AMP] = ACTIONS(2078),
    [anon_sym_AMP] = ACTIONS(2076),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym___extension__] = ACTIONS(2076),
    [anon_sym_typedef] = ACTIONS(2076),
    [anon_sym___device__] = ACTIONS(2076),
    [anon_sym___host__] = ACTIONS(2076),
    [anon_sym___global__] = ACTIONS(2076),
    [anon_sym___forceinline__] = ACTIONS(2076),
    [anon_sym___noinline__] = ACTIONS(2076),
    [anon_sym_extern] = ACTIONS(2076),
    [anon_sym___attribute__] = ACTIONS(2076),
    [anon_sym_COLON_COLON] = ACTIONS(2078),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2078),
    [anon_sym___declspec] = ACTIONS(2076),
    [anon_sym___based] = ACTIONS(2076),
    [anon_sym___cdecl] = ACTIONS(2076),
    [anon_sym___clrcall] = ACTIONS(2076),
    [anon_sym___stdcall] = ACTIONS(2076),
    [anon_sym___fastcall] = ACTIONS(2076),
    [anon_sym___thiscall] = ACTIONS(2076),
    [anon_sym___vectorcall] = ACTIONS(2076),
    [anon_sym_LBRACE] = ACTIONS(2078),
    [anon_sym_signed] = ACTIONS(2076),
    [anon_sym_unsigned] = ACTIONS(2076),
    [anon_sym_long] = ACTIONS(2076),
    [anon_sym_short] = ACTIONS(2076),
    [anon_sym_LBRACK] = ACTIONS(2076),
    [anon_sym_static] = ACTIONS(2076),
    [anon_sym_register] = ACTIONS(2076),
    [anon_sym_inline] = ACTIONS(2076),
    [anon_sym___inline] = ACTIONS(2076),
    [anon_sym___inline__] = ACTIONS(2076),
    [anon_sym___forceinline] = ACTIONS(2076),
    [anon_sym_thread_local] = ACTIONS(2076),
    [anon_sym___thread] = ACTIONS(2076),
    [anon_sym_const] = ACTIONS(2076),
    [anon_sym_constexpr] = ACTIONS(2076),
    [anon_sym_volatile] = ACTIONS(2076),
    [anon_sym_restrict] = ACTIONS(2076),
    [anon_sym___restrict__] = ACTIONS(2076),
    [anon_sym__Atomic] = ACTIONS(2076),
    [anon_sym__Noreturn] = ACTIONS(2076),
    [anon_sym_noreturn] = ACTIONS(2076),
    [anon_sym_mutable] = ACTIONS(2076),
    [anon_sym_constinit] = ACTIONS(2076),
    [anon_sym_consteval] = ACTIONS(2076),
    [anon_sym___shared__] = ACTIONS(2076),
    [anon_sym___local__] = ACTIONS(2076),
    [anon_sym___constant__] = ACTIONS(2076),
    [anon_sym___managed__] = ACTIONS(2076),
    [anon_sym___grid_constant__] = ACTIONS(2076),
    [anon_sym_alignas] = ACTIONS(2076),
    [anon_sym__Alignas] = ACTIONS(2076),
    [sym_primitive_type] = ACTIONS(2076),
    [anon_sym_enum] = ACTIONS(2076),
    [anon_sym_class] = ACTIONS(2076),
    [anon_sym_struct] = ACTIONS(2076),
    [anon_sym_union] = ACTIONS(2076),
    [anon_sym_if] = ACTIONS(2076),
    [anon_sym_else] = ACTIONS(2076),
    [anon_sym_switch] = ACTIONS(2076),
    [anon_sym_case] = ACTIONS(2076),
    [anon_sym_default] = ACTIONS(2076),
    [anon_sym_while] = ACTIONS(2076),
    [anon_sym_do] = ACTIONS(2076),
    [anon_sym_for] = ACTIONS(2076),
    [anon_sym_return] = ACTIONS(2076),
    [anon_sym_break] = ACTIONS(2076),
    [anon_sym_continue] = ACTIONS(2076),
    [anon_sym_goto] = ACTIONS(2076),
    [anon_sym___try] = ACTIONS(2076),
    [anon_sym___leave] = ACTIONS(2076),
    [anon_sym_not] = ACTIONS(2076),
    [anon_sym_compl] = ACTIONS(2076),
    [anon_sym_DASH_DASH] = ACTIONS(2078),
    [anon_sym_PLUS_PLUS] = ACTIONS(2078),
    [anon_sym_sizeof] = ACTIONS(2076),
    [anon_sym___alignof__] = ACTIONS(2076),
    [anon_sym___alignof] = ACTIONS(2076),
    [anon_sym__alignof] = ACTIONS(2076),
    [anon_sym_alignof] = ACTIONS(2076),
    [anon_sym__Alignof] = ACTIONS(2076),
    [anon_sym_offsetof] = ACTIONS(2076),
    [anon_sym__Generic] = ACTIONS(2076),
    [anon_sym_asm] = ACTIONS(2076),
    [anon_sym___asm__] = ACTIONS(2076),
    [sym_number_literal] = ACTIONS(2078),
    [anon_sym_L_SQUOTE] = ACTIONS(2078),
    [anon_sym_u_SQUOTE] = ACTIONS(2078),
    [anon_sym_U_SQUOTE] = ACTIONS(2078),
    [anon_sym_u8_SQUOTE] = ACTIONS(2078),
    [anon_sym_SQUOTE] = ACTIONS(2078),
    [anon_sym_L_DQUOTE] = ACTIONS(2078),
    [anon_sym_u_DQUOTE] = ACTIONS(2078),
    [anon_sym_U_DQUOTE] = ACTIONS(2078),
    [anon_sym_u8_DQUOTE] = ACTIONS(2078),
    [anon_sym_DQUOTE] = ACTIONS(2078),
    [sym_true] = ACTIONS(2076),
    [sym_false] = ACTIONS(2076),
    [anon_sym_NULL] = ACTIONS(2076),
    [anon_sym_nullptr] = ACTIONS(2076),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2076),
    [anon_sym_decltype] = ACTIONS(2076),
    [sym_virtual] = ACTIONS(2076),
    [anon_sym_explicit] = ACTIONS(2076),
    [anon_sym_typename] = ACTIONS(2076),
    [anon_sym_template] = ACTIONS(2076),
    [anon_sym_operator] = ACTIONS(2076),
    [anon_sym_try] = ACTIONS(2076),
    [anon_sym_delete] = ACTIONS(2076),
    [anon_sym_throw] = ACTIONS(2076),
    [anon_sym_namespace] = ACTIONS(2076),
    [anon_sym_using] = ACTIONS(2076),
    [anon_sym_static_assert] = ACTIONS(2076),
    [anon_sym_concept] = ACTIONS(2076),
    [anon_sym_co_return] = ACTIONS(2076),
    [anon_sym_co_yield] = ACTIONS(2076),
    [anon_sym_R_DQUOTE] = ACTIONS(2078),
    [anon_sym_LR_DQUOTE] = ACTIONS(2078),
    [anon_sym_uR_DQUOTE] = ACTIONS(2078),
    [anon_sym_UR_DQUOTE] = ACTIONS(2078),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2078),
    [anon_sym_co_await] = ACTIONS(2076),
    [anon_sym_new] = ACTIONS(2076),
    [anon_sym_requires] = ACTIONS(2076),
    [sym_this] = ACTIONS(2076),
    [anon_sym___launch_bounds__] = ACTIONS(2076),
  },
  [350] = {
    [sym_identifier] = ACTIONS(1976),
    [aux_sym_preproc_include_token1] = ACTIONS(1976),
    [aux_sym_preproc_def_token1] = ACTIONS(1976),
    [aux_sym_preproc_if_token1] = ACTIONS(1976),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1976),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1976),
    [sym_preproc_directive] = ACTIONS(1976),
    [anon_sym_LPAREN2] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1978),
    [anon_sym_TILDE] = ACTIONS(1978),
    [anon_sym_DASH] = ACTIONS(1976),
    [anon_sym_PLUS] = ACTIONS(1976),
    [anon_sym_STAR] = ACTIONS(1978),
    [anon_sym_AMP_AMP] = ACTIONS(1978),
    [anon_sym_AMP] = ACTIONS(1976),
    [anon_sym_SEMI] = ACTIONS(1978),
    [anon_sym___extension__] = ACTIONS(1976),
    [anon_sym_typedef] = ACTIONS(1976),
    [anon_sym___device__] = ACTIONS(1976),
    [anon_sym___host__] = ACTIONS(1976),
    [anon_sym___global__] = ACTIONS(1976),
    [anon_sym___forceinline__] = ACTIONS(1976),
    [anon_sym___noinline__] = ACTIONS(1976),
    [anon_sym_extern] = ACTIONS(1976),
    [anon_sym___attribute__] = ACTIONS(1976),
    [anon_sym_COLON_COLON] = ACTIONS(1978),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1978),
    [anon_sym___declspec] = ACTIONS(1976),
    [anon_sym___based] = ACTIONS(1976),
    [anon_sym___cdecl] = ACTIONS(1976),
    [anon_sym___clrcall] = ACTIONS(1976),
    [anon_sym___stdcall] = ACTIONS(1976),
    [anon_sym___fastcall] = ACTIONS(1976),
    [anon_sym___thiscall] = ACTIONS(1976),
    [anon_sym___vectorcall] = ACTIONS(1976),
    [anon_sym_LBRACE] = ACTIONS(1978),
    [anon_sym_RBRACE] = ACTIONS(1978),
    [anon_sym_signed] = ACTIONS(1976),
    [anon_sym_unsigned] = ACTIONS(1976),
    [anon_sym_long] = ACTIONS(1976),
    [anon_sym_short] = ACTIONS(1976),
    [anon_sym_LBRACK] = ACTIONS(1976),
    [anon_sym_static] = ACTIONS(1976),
    [anon_sym_register] = ACTIONS(1976),
    [anon_sym_inline] = ACTIONS(1976),
    [anon_sym___inline] = ACTIONS(1976),
    [anon_sym___inline__] = ACTIONS(1976),
    [anon_sym___forceinline] = ACTIONS(1976),
    [anon_sym_thread_local] = ACTIONS(1976),
    [anon_sym___thread] = ACTIONS(1976),
    [anon_sym_const] = ACTIONS(1976),
    [anon_sym_constexpr] = ACTIONS(1976),
    [anon_sym_volatile] = ACTIONS(1976),
    [anon_sym_restrict] = ACTIONS(1976),
    [anon_sym___restrict__] = ACTIONS(1976),
    [anon_sym__Atomic] = ACTIONS(1976),
    [anon_sym__Noreturn] = ACTIONS(1976),
    [anon_sym_noreturn] = ACTIONS(1976),
    [anon_sym_mutable] = ACTIONS(1976),
    [anon_sym_constinit] = ACTIONS(1976),
    [anon_sym_consteval] = ACTIONS(1976),
    [anon_sym___shared__] = ACTIONS(1976),
    [anon_sym___local__] = ACTIONS(1976),
    [anon_sym___constant__] = ACTIONS(1976),
    [anon_sym___managed__] = ACTIONS(1976),
    [anon_sym___grid_constant__] = ACTIONS(1976),
    [anon_sym_alignas] = ACTIONS(1976),
    [anon_sym__Alignas] = ACTIONS(1976),
    [sym_primitive_type] = ACTIONS(1976),
    [anon_sym_enum] = ACTIONS(1976),
    [anon_sym_class] = ACTIONS(1976),
    [anon_sym_struct] = ACTIONS(1976),
    [anon_sym_union] = ACTIONS(1976),
    [anon_sym_if] = ACTIONS(1976),
    [anon_sym_else] = ACTIONS(1976),
    [anon_sym_switch] = ACTIONS(1976),
    [anon_sym_case] = ACTIONS(1976),
    [anon_sym_default] = ACTIONS(1976),
    [anon_sym_while] = ACTIONS(1976),
    [anon_sym_do] = ACTIONS(1976),
    [anon_sym_for] = ACTIONS(1976),
    [anon_sym_return] = ACTIONS(1976),
    [anon_sym_break] = ACTIONS(1976),
    [anon_sym_continue] = ACTIONS(1976),
    [anon_sym_goto] = ACTIONS(1976),
    [anon_sym___try] = ACTIONS(1976),
    [anon_sym___leave] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1976),
    [anon_sym_compl] = ACTIONS(1976),
    [anon_sym_DASH_DASH] = ACTIONS(1978),
    [anon_sym_PLUS_PLUS] = ACTIONS(1978),
    [anon_sym_sizeof] = ACTIONS(1976),
    [anon_sym___alignof__] = ACTIONS(1976),
    [anon_sym___alignof] = ACTIONS(1976),
    [anon_sym__alignof] = ACTIONS(1976),
    [anon_sym_alignof] = ACTIONS(1976),
    [anon_sym__Alignof] = ACTIONS(1976),
    [anon_sym_offsetof] = ACTIONS(1976),
    [anon_sym__Generic] = ACTIONS(1976),
    [anon_sym_asm] = ACTIONS(1976),
    [anon_sym___asm__] = ACTIONS(1976),
    [sym_number_literal] = ACTIONS(1978),
    [anon_sym_L_SQUOTE] = ACTIONS(1978),
    [anon_sym_u_SQUOTE] = ACTIONS(1978),
    [anon_sym_U_SQUOTE] = ACTIONS(1978),
    [anon_sym_u8_SQUOTE] = ACTIONS(1978),
    [anon_sym_SQUOTE] = ACTIONS(1978),
    [anon_sym_L_DQUOTE] = ACTIONS(1978),
    [anon_sym_u_DQUOTE] = ACTIONS(1978),
    [anon_sym_U_DQUOTE] = ACTIONS(1978),
    [anon_sym_u8_DQUOTE] = ACTIONS(1978),
    [anon_sym_DQUOTE] = ACTIONS(1978),
    [sym_true] = ACTIONS(1976),
    [sym_false] = ACTIONS(1976),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1976),
    [anon_sym_decltype] = ACTIONS(1976),
    [sym_virtual] = ACTIONS(1976),
    [anon_sym_explicit] = ACTIONS(1976),
    [anon_sym_typename] = ACTIONS(1976),
    [anon_sym_template] = ACTIONS(1976),
    [anon_sym_operator] = ACTIONS(1976),
    [anon_sym_try] = ACTIONS(1976),
    [anon_sym_delete] = ACTIONS(1976),
    [anon_sym_throw] = ACTIONS(1976),
    [anon_sym_namespace] = ACTIONS(1976),
    [anon_sym_using] = ACTIONS(1976),
    [anon_sym_static_assert] = ACTIONS(1976),
    [anon_sym_concept] = ACTIONS(1976),
    [anon_sym_co_return] = ACTIONS(1976),
    [anon_sym_co_yield] = ACTIONS(1976),
    [anon_sym_R_DQUOTE] = ACTIONS(1978),
    [anon_sym_LR_DQUOTE] = ACTIONS(1978),
    [anon_sym_uR_DQUOTE] = ACTIONS(1978),
    [anon_sym_UR_DQUOTE] = ACTIONS(1978),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1978),
    [anon_sym_co_await] = ACTIONS(1976),
    [anon_sym_new] = ACTIONS(1976),
    [anon_sym_requires] = ACTIONS(1976),
    [sym_this] = ACTIONS(1976),
    [anon_sym___launch_bounds__] = ACTIONS(1976),
  },
  [351] = {
    [sym_identifier] = ACTIONS(2000),
    [aux_sym_preproc_include_token1] = ACTIONS(2000),
    [aux_sym_preproc_def_token1] = ACTIONS(2000),
    [aux_sym_preproc_if_token1] = ACTIONS(2000),
    [aux_sym_preproc_if_token2] = ACTIONS(2000),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2000),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2000),
    [sym_preproc_directive] = ACTIONS(2000),
    [anon_sym_LPAREN2] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2002),
    [anon_sym_TILDE] = ACTIONS(2002),
    [anon_sym_DASH] = ACTIONS(2000),
    [anon_sym_PLUS] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(2002),
    [anon_sym_AMP_AMP] = ACTIONS(2002),
    [anon_sym_AMP] = ACTIONS(2000),
    [anon_sym_SEMI] = ACTIONS(2002),
    [anon_sym___extension__] = ACTIONS(2000),
    [anon_sym_typedef] = ACTIONS(2000),
    [anon_sym___device__] = ACTIONS(2000),
    [anon_sym___host__] = ACTIONS(2000),
    [anon_sym___global__] = ACTIONS(2000),
    [anon_sym___forceinline__] = ACTIONS(2000),
    [anon_sym___noinline__] = ACTIONS(2000),
    [anon_sym_extern] = ACTIONS(2000),
    [anon_sym___attribute__] = ACTIONS(2000),
    [anon_sym_COLON_COLON] = ACTIONS(2002),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2002),
    [anon_sym___declspec] = ACTIONS(2000),
    [anon_sym___based] = ACTIONS(2000),
    [anon_sym___cdecl] = ACTIONS(2000),
    [anon_sym___clrcall] = ACTIONS(2000),
    [anon_sym___stdcall] = ACTIONS(2000),
    [anon_sym___fastcall] = ACTIONS(2000),
    [anon_sym___thiscall] = ACTIONS(2000),
    [anon_sym___vectorcall] = ACTIONS(2000),
    [anon_sym_LBRACE] = ACTIONS(2002),
    [anon_sym_signed] = ACTIONS(2000),
    [anon_sym_unsigned] = ACTIONS(2000),
    [anon_sym_long] = ACTIONS(2000),
    [anon_sym_short] = ACTIONS(2000),
    [anon_sym_LBRACK] = ACTIONS(2000),
    [anon_sym_static] = ACTIONS(2000),
    [anon_sym_register] = ACTIONS(2000),
    [anon_sym_inline] = ACTIONS(2000),
    [anon_sym___inline] = ACTIONS(2000),
    [anon_sym___inline__] = ACTIONS(2000),
    [anon_sym___forceinline] = ACTIONS(2000),
    [anon_sym_thread_local] = ACTIONS(2000),
    [anon_sym___thread] = ACTIONS(2000),
    [anon_sym_const] = ACTIONS(2000),
    [anon_sym_constexpr] = ACTIONS(2000),
    [anon_sym_volatile] = ACTIONS(2000),
    [anon_sym_restrict] = ACTIONS(2000),
    [anon_sym___restrict__] = ACTIONS(2000),
    [anon_sym__Atomic] = ACTIONS(2000),
    [anon_sym__Noreturn] = ACTIONS(2000),
    [anon_sym_noreturn] = ACTIONS(2000),
    [anon_sym_mutable] = ACTIONS(2000),
    [anon_sym_constinit] = ACTIONS(2000),
    [anon_sym_consteval] = ACTIONS(2000),
    [anon_sym___shared__] = ACTIONS(2000),
    [anon_sym___local__] = ACTIONS(2000),
    [anon_sym___constant__] = ACTIONS(2000),
    [anon_sym___managed__] = ACTIONS(2000),
    [anon_sym___grid_constant__] = ACTIONS(2000),
    [anon_sym_alignas] = ACTIONS(2000),
    [anon_sym__Alignas] = ACTIONS(2000),
    [sym_primitive_type] = ACTIONS(2000),
    [anon_sym_enum] = ACTIONS(2000),
    [anon_sym_class] = ACTIONS(2000),
    [anon_sym_struct] = ACTIONS(2000),
    [anon_sym_union] = ACTIONS(2000),
    [anon_sym_if] = ACTIONS(2000),
    [anon_sym_else] = ACTIONS(2000),
    [anon_sym_switch] = ACTIONS(2000),
    [anon_sym_case] = ACTIONS(2000),
    [anon_sym_default] = ACTIONS(2000),
    [anon_sym_while] = ACTIONS(2000),
    [anon_sym_do] = ACTIONS(2000),
    [anon_sym_for] = ACTIONS(2000),
    [anon_sym_return] = ACTIONS(2000),
    [anon_sym_break] = ACTIONS(2000),
    [anon_sym_continue] = ACTIONS(2000),
    [anon_sym_goto] = ACTIONS(2000),
    [anon_sym___try] = ACTIONS(2000),
    [anon_sym___leave] = ACTIONS(2000),
    [anon_sym_not] = ACTIONS(2000),
    [anon_sym_compl] = ACTIONS(2000),
    [anon_sym_DASH_DASH] = ACTIONS(2002),
    [anon_sym_PLUS_PLUS] = ACTIONS(2002),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(2000),
    [anon_sym___alignof] = ACTIONS(2000),
    [anon_sym__alignof] = ACTIONS(2000),
    [anon_sym_alignof] = ACTIONS(2000),
    [anon_sym__Alignof] = ACTIONS(2000),
    [anon_sym_offsetof] = ACTIONS(2000),
    [anon_sym__Generic] = ACTIONS(2000),
    [anon_sym_asm] = ACTIONS(2000),
    [anon_sym___asm__] = ACTIONS(2000),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2002),
    [anon_sym_u_SQUOTE] = ACTIONS(2002),
    [anon_sym_U_SQUOTE] = ACTIONS(2002),
    [anon_sym_u8_SQUOTE] = ACTIONS(2002),
    [anon_sym_SQUOTE] = ACTIONS(2002),
    [anon_sym_L_DQUOTE] = ACTIONS(2002),
    [anon_sym_u_DQUOTE] = ACTIONS(2002),
    [anon_sym_U_DQUOTE] = ACTIONS(2002),
    [anon_sym_u8_DQUOTE] = ACTIONS(2002),
    [anon_sym_DQUOTE] = ACTIONS(2002),
    [sym_true] = ACTIONS(2000),
    [sym_false] = ACTIONS(2000),
    [anon_sym_NULL] = ACTIONS(2000),
    [anon_sym_nullptr] = ACTIONS(2000),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2000),
    [anon_sym_decltype] = ACTIONS(2000),
    [sym_virtual] = ACTIONS(2000),
    [anon_sym_explicit] = ACTIONS(2000),
    [anon_sym_typename] = ACTIONS(2000),
    [anon_sym_template] = ACTIONS(2000),
    [anon_sym_operator] = ACTIONS(2000),
    [anon_sym_try] = ACTIONS(2000),
    [anon_sym_delete] = ACTIONS(2000),
    [anon_sym_throw] = ACTIONS(2000),
    [anon_sym_namespace] = ACTIONS(2000),
    [anon_sym_using] = ACTIONS(2000),
    [anon_sym_static_assert] = ACTIONS(2000),
    [anon_sym_concept] = ACTIONS(2000),
    [anon_sym_co_return] = ACTIONS(2000),
    [anon_sym_co_yield] = ACTIONS(2000),
    [anon_sym_R_DQUOTE] = ACTIONS(2002),
    [anon_sym_LR_DQUOTE] = ACTIONS(2002),
    [anon_sym_uR_DQUOTE] = ACTIONS(2002),
    [anon_sym_UR_DQUOTE] = ACTIONS(2002),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2002),
    [anon_sym_co_await] = ACTIONS(2000),
    [anon_sym_new] = ACTIONS(2000),
    [anon_sym_requires] = ACTIONS(2000),
    [sym_this] = ACTIONS(2000),
    [anon_sym___launch_bounds__] = ACTIONS(2000),
  },
  [352] = {
    [sym_identifier] = ACTIONS(1958),
    [aux_sym_preproc_include_token1] = ACTIONS(1958),
    [aux_sym_preproc_def_token1] = ACTIONS(1958),
    [aux_sym_preproc_if_token1] = ACTIONS(1958),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1958),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1958),
    [sym_preproc_directive] = ACTIONS(1958),
    [anon_sym_LPAREN2] = ACTIONS(1960),
    [anon_sym_BANG] = ACTIONS(1960),
    [anon_sym_TILDE] = ACTIONS(1960),
    [anon_sym_DASH] = ACTIONS(1958),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_STAR] = ACTIONS(1960),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1958),
    [anon_sym_SEMI] = ACTIONS(1960),
    [anon_sym___extension__] = ACTIONS(1958),
    [anon_sym_typedef] = ACTIONS(1958),
    [anon_sym___device__] = ACTIONS(1958),
    [anon_sym___host__] = ACTIONS(1958),
    [anon_sym___global__] = ACTIONS(1958),
    [anon_sym___forceinline__] = ACTIONS(1958),
    [anon_sym___noinline__] = ACTIONS(1958),
    [anon_sym_extern] = ACTIONS(1958),
    [anon_sym___attribute__] = ACTIONS(1958),
    [anon_sym_COLON_COLON] = ACTIONS(1960),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1960),
    [anon_sym___declspec] = ACTIONS(1958),
    [anon_sym___based] = ACTIONS(1958),
    [anon_sym___cdecl] = ACTIONS(1958),
    [anon_sym___clrcall] = ACTIONS(1958),
    [anon_sym___stdcall] = ACTIONS(1958),
    [anon_sym___fastcall] = ACTIONS(1958),
    [anon_sym___thiscall] = ACTIONS(1958),
    [anon_sym___vectorcall] = ACTIONS(1958),
    [anon_sym_LBRACE] = ACTIONS(1960),
    [anon_sym_RBRACE] = ACTIONS(1960),
    [anon_sym_signed] = ACTIONS(1958),
    [anon_sym_unsigned] = ACTIONS(1958),
    [anon_sym_long] = ACTIONS(1958),
    [anon_sym_short] = ACTIONS(1958),
    [anon_sym_LBRACK] = ACTIONS(1958),
    [anon_sym_static] = ACTIONS(1958),
    [anon_sym_register] = ACTIONS(1958),
    [anon_sym_inline] = ACTIONS(1958),
    [anon_sym___inline] = ACTIONS(1958),
    [anon_sym___inline__] = ACTIONS(1958),
    [anon_sym___forceinline] = ACTIONS(1958),
    [anon_sym_thread_local] = ACTIONS(1958),
    [anon_sym___thread] = ACTIONS(1958),
    [anon_sym_const] = ACTIONS(1958),
    [anon_sym_constexpr] = ACTIONS(1958),
    [anon_sym_volatile] = ACTIONS(1958),
    [anon_sym_restrict] = ACTIONS(1958),
    [anon_sym___restrict__] = ACTIONS(1958),
    [anon_sym__Atomic] = ACTIONS(1958),
    [anon_sym__Noreturn] = ACTIONS(1958),
    [anon_sym_noreturn] = ACTIONS(1958),
    [anon_sym_mutable] = ACTIONS(1958),
    [anon_sym_constinit] = ACTIONS(1958),
    [anon_sym_consteval] = ACTIONS(1958),
    [anon_sym___shared__] = ACTIONS(1958),
    [anon_sym___local__] = ACTIONS(1958),
    [anon_sym___constant__] = ACTIONS(1958),
    [anon_sym___managed__] = ACTIONS(1958),
    [anon_sym___grid_constant__] = ACTIONS(1958),
    [anon_sym_alignas] = ACTIONS(1958),
    [anon_sym__Alignas] = ACTIONS(1958),
    [sym_primitive_type] = ACTIONS(1958),
    [anon_sym_enum] = ACTIONS(1958),
    [anon_sym_class] = ACTIONS(1958),
    [anon_sym_struct] = ACTIONS(1958),
    [anon_sym_union] = ACTIONS(1958),
    [anon_sym_if] = ACTIONS(1958),
    [anon_sym_else] = ACTIONS(1958),
    [anon_sym_switch] = ACTIONS(1958),
    [anon_sym_case] = ACTIONS(1958),
    [anon_sym_default] = ACTIONS(1958),
    [anon_sym_while] = ACTIONS(1958),
    [anon_sym_do] = ACTIONS(1958),
    [anon_sym_for] = ACTIONS(1958),
    [anon_sym_return] = ACTIONS(1958),
    [anon_sym_break] = ACTIONS(1958),
    [anon_sym_continue] = ACTIONS(1958),
    [anon_sym_goto] = ACTIONS(1958),
    [anon_sym___try] = ACTIONS(1958),
    [anon_sym___leave] = ACTIONS(1958),
    [anon_sym_not] = ACTIONS(1958),
    [anon_sym_compl] = ACTIONS(1958),
    [anon_sym_DASH_DASH] = ACTIONS(1960),
    [anon_sym_PLUS_PLUS] = ACTIONS(1960),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1958),
    [anon_sym___alignof] = ACTIONS(1958),
    [anon_sym__alignof] = ACTIONS(1958),
    [anon_sym_alignof] = ACTIONS(1958),
    [anon_sym__Alignof] = ACTIONS(1958),
    [anon_sym_offsetof] = ACTIONS(1958),
    [anon_sym__Generic] = ACTIONS(1958),
    [anon_sym_asm] = ACTIONS(1958),
    [anon_sym___asm__] = ACTIONS(1958),
    [sym_number_literal] = ACTIONS(1960),
    [anon_sym_L_SQUOTE] = ACTIONS(1960),
    [anon_sym_u_SQUOTE] = ACTIONS(1960),
    [anon_sym_U_SQUOTE] = ACTIONS(1960),
    [anon_sym_u8_SQUOTE] = ACTIONS(1960),
    [anon_sym_SQUOTE] = ACTIONS(1960),
    [anon_sym_L_DQUOTE] = ACTIONS(1960),
    [anon_sym_u_DQUOTE] = ACTIONS(1960),
    [anon_sym_U_DQUOTE] = ACTIONS(1960),
    [anon_sym_u8_DQUOTE] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [sym_true] = ACTIONS(1958),
    [sym_false] = ACTIONS(1958),
    [anon_sym_NULL] = ACTIONS(1958),
    [anon_sym_nullptr] = ACTIONS(1958),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1958),
    [anon_sym_decltype] = ACTIONS(1958),
    [sym_virtual] = ACTIONS(1958),
    [anon_sym_explicit] = ACTIONS(1958),
    [anon_sym_typename] = ACTIONS(1958),
    [anon_sym_template] = ACTIONS(1958),
    [anon_sym_operator] = ACTIONS(1958),
    [anon_sym_try] = ACTIONS(1958),
    [anon_sym_delete] = ACTIONS(1958),
    [anon_sym_throw] = ACTIONS(1958),
    [anon_sym_namespace] = ACTIONS(1958),
    [anon_sym_using] = ACTIONS(1958),
    [anon_sym_static_assert] = ACTIONS(1958),
    [anon_sym_concept] = ACTIONS(1958),
    [anon_sym_co_return] = ACTIONS(1958),
    [anon_sym_co_yield] = ACTIONS(1958),
    [anon_sym_R_DQUOTE] = ACTIONS(1960),
    [anon_sym_LR_DQUOTE] = ACTIONS(1960),
    [anon_sym_uR_DQUOTE] = ACTIONS(1960),
    [anon_sym_UR_DQUOTE] = ACTIONS(1960),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1960),
    [anon_sym_co_await] = ACTIONS(1958),
    [anon_sym_new] = ACTIONS(1958),
    [anon_sym_requires] = ACTIONS(1958),
    [sym_this] = ACTIONS(1958),
    [anon_sym___launch_bounds__] = ACTIONS(1958),
  },
  [353] = {
    [ts_builtin_sym_end] = ACTIONS(1990),
    [sym_identifier] = ACTIONS(1988),
    [aux_sym_preproc_include_token1] = ACTIONS(1988),
    [aux_sym_preproc_def_token1] = ACTIONS(1988),
    [aux_sym_preproc_if_token1] = ACTIONS(1988),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1988),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1988),
    [sym_preproc_directive] = ACTIONS(1988),
    [anon_sym_LPAREN2] = ACTIONS(1990),
    [anon_sym_BANG] = ACTIONS(1990),
    [anon_sym_TILDE] = ACTIONS(1990),
    [anon_sym_DASH] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(1990),
    [anon_sym_AMP_AMP] = ACTIONS(1990),
    [anon_sym_AMP] = ACTIONS(1988),
    [anon_sym_SEMI] = ACTIONS(1990),
    [anon_sym___extension__] = ACTIONS(1988),
    [anon_sym_typedef] = ACTIONS(1988),
    [anon_sym___device__] = ACTIONS(1988),
    [anon_sym___host__] = ACTIONS(1988),
    [anon_sym___global__] = ACTIONS(1988),
    [anon_sym___forceinline__] = ACTIONS(1988),
    [anon_sym___noinline__] = ACTIONS(1988),
    [anon_sym_extern] = ACTIONS(1988),
    [anon_sym___attribute__] = ACTIONS(1988),
    [anon_sym_COLON_COLON] = ACTIONS(1990),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1990),
    [anon_sym___declspec] = ACTIONS(1988),
    [anon_sym___based] = ACTIONS(1988),
    [anon_sym___cdecl] = ACTIONS(1988),
    [anon_sym___clrcall] = ACTIONS(1988),
    [anon_sym___stdcall] = ACTIONS(1988),
    [anon_sym___fastcall] = ACTIONS(1988),
    [anon_sym___thiscall] = ACTIONS(1988),
    [anon_sym___vectorcall] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1990),
    [anon_sym_signed] = ACTIONS(1988),
    [anon_sym_unsigned] = ACTIONS(1988),
    [anon_sym_long] = ACTIONS(1988),
    [anon_sym_short] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_static] = ACTIONS(1988),
    [anon_sym_register] = ACTIONS(1988),
    [anon_sym_inline] = ACTIONS(1988),
    [anon_sym___inline] = ACTIONS(1988),
    [anon_sym___inline__] = ACTIONS(1988),
    [anon_sym___forceinline] = ACTIONS(1988),
    [anon_sym_thread_local] = ACTIONS(1988),
    [anon_sym___thread] = ACTIONS(1988),
    [anon_sym_const] = ACTIONS(1988),
    [anon_sym_constexpr] = ACTIONS(1988),
    [anon_sym_volatile] = ACTIONS(1988),
    [anon_sym_restrict] = ACTIONS(1988),
    [anon_sym___restrict__] = ACTIONS(1988),
    [anon_sym__Atomic] = ACTIONS(1988),
    [anon_sym__Noreturn] = ACTIONS(1988),
    [anon_sym_noreturn] = ACTIONS(1988),
    [anon_sym_mutable] = ACTIONS(1988),
    [anon_sym_constinit] = ACTIONS(1988),
    [anon_sym_consteval] = ACTIONS(1988),
    [anon_sym___shared__] = ACTIONS(1988),
    [anon_sym___local__] = ACTIONS(1988),
    [anon_sym___constant__] = ACTIONS(1988),
    [anon_sym___managed__] = ACTIONS(1988),
    [anon_sym___grid_constant__] = ACTIONS(1988),
    [anon_sym_alignas] = ACTIONS(1988),
    [anon_sym__Alignas] = ACTIONS(1988),
    [sym_primitive_type] = ACTIONS(1988),
    [anon_sym_enum] = ACTIONS(1988),
    [anon_sym_class] = ACTIONS(1988),
    [anon_sym_struct] = ACTIONS(1988),
    [anon_sym_union] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_else] = ACTIONS(1988),
    [anon_sym_switch] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_default] = ACTIONS(1988),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_do] = ACTIONS(1988),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_return] = ACTIONS(1988),
    [anon_sym_break] = ACTIONS(1988),
    [anon_sym_continue] = ACTIONS(1988),
    [anon_sym_goto] = ACTIONS(1988),
    [anon_sym___try] = ACTIONS(1988),
    [anon_sym___leave] = ACTIONS(1988),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_compl] = ACTIONS(1988),
    [anon_sym_DASH_DASH] = ACTIONS(1990),
    [anon_sym_PLUS_PLUS] = ACTIONS(1990),
    [anon_sym_sizeof] = ACTIONS(1988),
    [anon_sym___alignof__] = ACTIONS(1988),
    [anon_sym___alignof] = ACTIONS(1988),
    [anon_sym__alignof] = ACTIONS(1988),
    [anon_sym_alignof] = ACTIONS(1988),
    [anon_sym__Alignof] = ACTIONS(1988),
    [anon_sym_offsetof] = ACTIONS(1988),
    [anon_sym__Generic] = ACTIONS(1988),
    [anon_sym_asm] = ACTIONS(1988),
    [anon_sym___asm__] = ACTIONS(1988),
    [sym_number_literal] = ACTIONS(1990),
    [anon_sym_L_SQUOTE] = ACTIONS(1990),
    [anon_sym_u_SQUOTE] = ACTIONS(1990),
    [anon_sym_U_SQUOTE] = ACTIONS(1990),
    [anon_sym_u8_SQUOTE] = ACTIONS(1990),
    [anon_sym_SQUOTE] = ACTIONS(1990),
    [anon_sym_L_DQUOTE] = ACTIONS(1990),
    [anon_sym_u_DQUOTE] = ACTIONS(1990),
    [anon_sym_U_DQUOTE] = ACTIONS(1990),
    [anon_sym_u8_DQUOTE] = ACTIONS(1990),
    [anon_sym_DQUOTE] = ACTIONS(1990),
    [sym_true] = ACTIONS(1988),
    [sym_false] = ACTIONS(1988),
    [anon_sym_NULL] = ACTIONS(1988),
    [anon_sym_nullptr] = ACTIONS(1988),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1988),
    [anon_sym_decltype] = ACTIONS(1988),
    [sym_virtual] = ACTIONS(1988),
    [anon_sym_explicit] = ACTIONS(1988),
    [anon_sym_typename] = ACTIONS(1988),
    [anon_sym_template] = ACTIONS(1988),
    [anon_sym_operator] = ACTIONS(1988),
    [anon_sym_try] = ACTIONS(1988),
    [anon_sym_delete] = ACTIONS(1988),
    [anon_sym_throw] = ACTIONS(1988),
    [anon_sym_namespace] = ACTIONS(1988),
    [anon_sym_using] = ACTIONS(1988),
    [anon_sym_static_assert] = ACTIONS(1988),
    [anon_sym_concept] = ACTIONS(1988),
    [anon_sym_co_return] = ACTIONS(1988),
    [anon_sym_co_yield] = ACTIONS(1988),
    [anon_sym_R_DQUOTE] = ACTIONS(1990),
    [anon_sym_LR_DQUOTE] = ACTIONS(1990),
    [anon_sym_uR_DQUOTE] = ACTIONS(1990),
    [anon_sym_UR_DQUOTE] = ACTIONS(1990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1990),
    [anon_sym_co_await] = ACTIONS(1988),
    [anon_sym_new] = ACTIONS(1988),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1988),
    [anon_sym___launch_bounds__] = ACTIONS(1988),
  },
  [354] = {
    [sym_identifier] = ACTIONS(2016),
    [aux_sym_preproc_include_token1] = ACTIONS(2016),
    [aux_sym_preproc_def_token1] = ACTIONS(2016),
    [aux_sym_preproc_if_token1] = ACTIONS(2016),
    [aux_sym_preproc_if_token2] = ACTIONS(2016),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2016),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2016),
    [sym_preproc_directive] = ACTIONS(2016),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(2018),
    [anon_sym_TILDE] = ACTIONS(2018),
    [anon_sym_DASH] = ACTIONS(2016),
    [anon_sym_PLUS] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(2018),
    [anon_sym_AMP_AMP] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(2016),
    [anon_sym_SEMI] = ACTIONS(2018),
    [anon_sym___extension__] = ACTIONS(2016),
    [anon_sym_typedef] = ACTIONS(2016),
    [anon_sym___device__] = ACTIONS(2016),
    [anon_sym___host__] = ACTIONS(2016),
    [anon_sym___global__] = ACTIONS(2016),
    [anon_sym___forceinline__] = ACTIONS(2016),
    [anon_sym___noinline__] = ACTIONS(2016),
    [anon_sym_extern] = ACTIONS(2016),
    [anon_sym___attribute__] = ACTIONS(2016),
    [anon_sym_COLON_COLON] = ACTIONS(2018),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2018),
    [anon_sym___declspec] = ACTIONS(2016),
    [anon_sym___based] = ACTIONS(2016),
    [anon_sym___cdecl] = ACTIONS(2016),
    [anon_sym___clrcall] = ACTIONS(2016),
    [anon_sym___stdcall] = ACTIONS(2016),
    [anon_sym___fastcall] = ACTIONS(2016),
    [anon_sym___thiscall] = ACTIONS(2016),
    [anon_sym___vectorcall] = ACTIONS(2016),
    [anon_sym_LBRACE] = ACTIONS(2018),
    [anon_sym_signed] = ACTIONS(2016),
    [anon_sym_unsigned] = ACTIONS(2016),
    [anon_sym_long] = ACTIONS(2016),
    [anon_sym_short] = ACTIONS(2016),
    [anon_sym_LBRACK] = ACTIONS(2016),
    [anon_sym_static] = ACTIONS(2016),
    [anon_sym_register] = ACTIONS(2016),
    [anon_sym_inline] = ACTIONS(2016),
    [anon_sym___inline] = ACTIONS(2016),
    [anon_sym___inline__] = ACTIONS(2016),
    [anon_sym___forceinline] = ACTIONS(2016),
    [anon_sym_thread_local] = ACTIONS(2016),
    [anon_sym___thread] = ACTIONS(2016),
    [anon_sym_const] = ACTIONS(2016),
    [anon_sym_constexpr] = ACTIONS(2016),
    [anon_sym_volatile] = ACTIONS(2016),
    [anon_sym_restrict] = ACTIONS(2016),
    [anon_sym___restrict__] = ACTIONS(2016),
    [anon_sym__Atomic] = ACTIONS(2016),
    [anon_sym__Noreturn] = ACTIONS(2016),
    [anon_sym_noreturn] = ACTIONS(2016),
    [anon_sym_mutable] = ACTIONS(2016),
    [anon_sym_constinit] = ACTIONS(2016),
    [anon_sym_consteval] = ACTIONS(2016),
    [anon_sym___shared__] = ACTIONS(2016),
    [anon_sym___local__] = ACTIONS(2016),
    [anon_sym___constant__] = ACTIONS(2016),
    [anon_sym___managed__] = ACTIONS(2016),
    [anon_sym___grid_constant__] = ACTIONS(2016),
    [anon_sym_alignas] = ACTIONS(2016),
    [anon_sym__Alignas] = ACTIONS(2016),
    [sym_primitive_type] = ACTIONS(2016),
    [anon_sym_enum] = ACTIONS(2016),
    [anon_sym_class] = ACTIONS(2016),
    [anon_sym_struct] = ACTIONS(2016),
    [anon_sym_union] = ACTIONS(2016),
    [anon_sym_if] = ACTIONS(2016),
    [anon_sym_else] = ACTIONS(2016),
    [anon_sym_switch] = ACTIONS(2016),
    [anon_sym_case] = ACTIONS(2016),
    [anon_sym_default] = ACTIONS(2016),
    [anon_sym_while] = ACTIONS(2016),
    [anon_sym_do] = ACTIONS(2016),
    [anon_sym_for] = ACTIONS(2016),
    [anon_sym_return] = ACTIONS(2016),
    [anon_sym_break] = ACTIONS(2016),
    [anon_sym_continue] = ACTIONS(2016),
    [anon_sym_goto] = ACTIONS(2016),
    [anon_sym___try] = ACTIONS(2016),
    [anon_sym___leave] = ACTIONS(2016),
    [anon_sym_not] = ACTIONS(2016),
    [anon_sym_compl] = ACTIONS(2016),
    [anon_sym_DASH_DASH] = ACTIONS(2018),
    [anon_sym_PLUS_PLUS] = ACTIONS(2018),
    [anon_sym_sizeof] = ACTIONS(2016),
    [anon_sym___alignof__] = ACTIONS(2016),
    [anon_sym___alignof] = ACTIONS(2016),
    [anon_sym__alignof] = ACTIONS(2016),
    [anon_sym_alignof] = ACTIONS(2016),
    [anon_sym__Alignof] = ACTIONS(2016),
    [anon_sym_offsetof] = ACTIONS(2016),
    [anon_sym__Generic] = ACTIONS(2016),
    [anon_sym_asm] = ACTIONS(2016),
    [anon_sym___asm__] = ACTIONS(2016),
    [sym_number_literal] = ACTIONS(2018),
    [anon_sym_L_SQUOTE] = ACTIONS(2018),
    [anon_sym_u_SQUOTE] = ACTIONS(2018),
    [anon_sym_U_SQUOTE] = ACTIONS(2018),
    [anon_sym_u8_SQUOTE] = ACTIONS(2018),
    [anon_sym_SQUOTE] = ACTIONS(2018),
    [anon_sym_L_DQUOTE] = ACTIONS(2018),
    [anon_sym_u_DQUOTE] = ACTIONS(2018),
    [anon_sym_U_DQUOTE] = ACTIONS(2018),
    [anon_sym_u8_DQUOTE] = ACTIONS(2018),
    [anon_sym_DQUOTE] = ACTIONS(2018),
    [sym_true] = ACTIONS(2016),
    [sym_false] = ACTIONS(2016),
    [anon_sym_NULL] = ACTIONS(2016),
    [anon_sym_nullptr] = ACTIONS(2016),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2016),
    [anon_sym_decltype] = ACTIONS(2016),
    [sym_virtual] = ACTIONS(2016),
    [anon_sym_explicit] = ACTIONS(2016),
    [anon_sym_typename] = ACTIONS(2016),
    [anon_sym_template] = ACTIONS(2016),
    [anon_sym_operator] = ACTIONS(2016),
    [anon_sym_try] = ACTIONS(2016),
    [anon_sym_delete] = ACTIONS(2016),
    [anon_sym_throw] = ACTIONS(2016),
    [anon_sym_namespace] = ACTIONS(2016),
    [anon_sym_using] = ACTIONS(2016),
    [anon_sym_static_assert] = ACTIONS(2016),
    [anon_sym_concept] = ACTIONS(2016),
    [anon_sym_co_return] = ACTIONS(2016),
    [anon_sym_co_yield] = ACTIONS(2016),
    [anon_sym_R_DQUOTE] = ACTIONS(2018),
    [anon_sym_LR_DQUOTE] = ACTIONS(2018),
    [anon_sym_uR_DQUOTE] = ACTIONS(2018),
    [anon_sym_UR_DQUOTE] = ACTIONS(2018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2018),
    [anon_sym_co_await] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2016),
    [anon_sym_requires] = ACTIONS(2016),
    [sym_this] = ACTIONS(2016),
    [anon_sym___launch_bounds__] = ACTIONS(2016),
  },
  [355] = {
    [sym_identifier] = ACTIONS(2020),
    [aux_sym_preproc_include_token1] = ACTIONS(2020),
    [aux_sym_preproc_def_token1] = ACTIONS(2020),
    [aux_sym_preproc_if_token1] = ACTIONS(2020),
    [aux_sym_preproc_if_token2] = ACTIONS(2020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2020),
    [sym_preproc_directive] = ACTIONS(2020),
    [anon_sym_LPAREN2] = ACTIONS(2022),
    [anon_sym_BANG] = ACTIONS(2022),
    [anon_sym_TILDE] = ACTIONS(2022),
    [anon_sym_DASH] = ACTIONS(2020),
    [anon_sym_PLUS] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(2022),
    [anon_sym_AMP_AMP] = ACTIONS(2022),
    [anon_sym_AMP] = ACTIONS(2020),
    [anon_sym_SEMI] = ACTIONS(2022),
    [anon_sym___extension__] = ACTIONS(2020),
    [anon_sym_typedef] = ACTIONS(2020),
    [anon_sym___device__] = ACTIONS(2020),
    [anon_sym___host__] = ACTIONS(2020),
    [anon_sym___global__] = ACTIONS(2020),
    [anon_sym___forceinline__] = ACTIONS(2020),
    [anon_sym___noinline__] = ACTIONS(2020),
    [anon_sym_extern] = ACTIONS(2020),
    [anon_sym___attribute__] = ACTIONS(2020),
    [anon_sym_COLON_COLON] = ACTIONS(2022),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2022),
    [anon_sym___declspec] = ACTIONS(2020),
    [anon_sym___based] = ACTIONS(2020),
    [anon_sym___cdecl] = ACTIONS(2020),
    [anon_sym___clrcall] = ACTIONS(2020),
    [anon_sym___stdcall] = ACTIONS(2020),
    [anon_sym___fastcall] = ACTIONS(2020),
    [anon_sym___thiscall] = ACTIONS(2020),
    [anon_sym___vectorcall] = ACTIONS(2020),
    [anon_sym_LBRACE] = ACTIONS(2022),
    [anon_sym_signed] = ACTIONS(2020),
    [anon_sym_unsigned] = ACTIONS(2020),
    [anon_sym_long] = ACTIONS(2020),
    [anon_sym_short] = ACTIONS(2020),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(2020),
    [anon_sym_register] = ACTIONS(2020),
    [anon_sym_inline] = ACTIONS(2020),
    [anon_sym___inline] = ACTIONS(2020),
    [anon_sym___inline__] = ACTIONS(2020),
    [anon_sym___forceinline] = ACTIONS(2020),
    [anon_sym_thread_local] = ACTIONS(2020),
    [anon_sym___thread] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(2020),
    [anon_sym_constexpr] = ACTIONS(2020),
    [anon_sym_volatile] = ACTIONS(2020),
    [anon_sym_restrict] = ACTIONS(2020),
    [anon_sym___restrict__] = ACTIONS(2020),
    [anon_sym__Atomic] = ACTIONS(2020),
    [anon_sym__Noreturn] = ACTIONS(2020),
    [anon_sym_noreturn] = ACTIONS(2020),
    [anon_sym_mutable] = ACTIONS(2020),
    [anon_sym_constinit] = ACTIONS(2020),
    [anon_sym_consteval] = ACTIONS(2020),
    [anon_sym___shared__] = ACTIONS(2020),
    [anon_sym___local__] = ACTIONS(2020),
    [anon_sym___constant__] = ACTIONS(2020),
    [anon_sym___managed__] = ACTIONS(2020),
    [anon_sym___grid_constant__] = ACTIONS(2020),
    [anon_sym_alignas] = ACTIONS(2020),
    [anon_sym__Alignas] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2020),
    [anon_sym_enum] = ACTIONS(2020),
    [anon_sym_class] = ACTIONS(2020),
    [anon_sym_struct] = ACTIONS(2020),
    [anon_sym_union] = ACTIONS(2020),
    [anon_sym_if] = ACTIONS(2020),
    [anon_sym_else] = ACTIONS(2020),
    [anon_sym_switch] = ACTIONS(2020),
    [anon_sym_case] = ACTIONS(2020),
    [anon_sym_default] = ACTIONS(2020),
    [anon_sym_while] = ACTIONS(2020),
    [anon_sym_do] = ACTIONS(2020),
    [anon_sym_for] = ACTIONS(2020),
    [anon_sym_return] = ACTIONS(2020),
    [anon_sym_break] = ACTIONS(2020),
    [anon_sym_continue] = ACTIONS(2020),
    [anon_sym_goto] = ACTIONS(2020),
    [anon_sym___try] = ACTIONS(2020),
    [anon_sym___leave] = ACTIONS(2020),
    [anon_sym_not] = ACTIONS(2020),
    [anon_sym_compl] = ACTIONS(2020),
    [anon_sym_DASH_DASH] = ACTIONS(2022),
    [anon_sym_PLUS_PLUS] = ACTIONS(2022),
    [anon_sym_sizeof] = ACTIONS(2020),
    [anon_sym___alignof__] = ACTIONS(2020),
    [anon_sym___alignof] = ACTIONS(2020),
    [anon_sym__alignof] = ACTIONS(2020),
    [anon_sym_alignof] = ACTIONS(2020),
    [anon_sym__Alignof] = ACTIONS(2020),
    [anon_sym_offsetof] = ACTIONS(2020),
    [anon_sym__Generic] = ACTIONS(2020),
    [anon_sym_asm] = ACTIONS(2020),
    [anon_sym___asm__] = ACTIONS(2020),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_L_SQUOTE] = ACTIONS(2022),
    [anon_sym_u_SQUOTE] = ACTIONS(2022),
    [anon_sym_U_SQUOTE] = ACTIONS(2022),
    [anon_sym_u8_SQUOTE] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(2022),
    [anon_sym_L_DQUOTE] = ACTIONS(2022),
    [anon_sym_u_DQUOTE] = ACTIONS(2022),
    [anon_sym_U_DQUOTE] = ACTIONS(2022),
    [anon_sym_u8_DQUOTE] = ACTIONS(2022),
    [anon_sym_DQUOTE] = ACTIONS(2022),
    [sym_true] = ACTIONS(2020),
    [sym_false] = ACTIONS(2020),
    [anon_sym_NULL] = ACTIONS(2020),
    [anon_sym_nullptr] = ACTIONS(2020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2020),
    [anon_sym_decltype] = ACTIONS(2020),
    [sym_virtual] = ACTIONS(2020),
    [anon_sym_explicit] = ACTIONS(2020),
    [anon_sym_typename] = ACTIONS(2020),
    [anon_sym_template] = ACTIONS(2020),
    [anon_sym_operator] = ACTIONS(2020),
    [anon_sym_try] = ACTIONS(2020),
    [anon_sym_delete] = ACTIONS(2020),
    [anon_sym_throw] = ACTIONS(2020),
    [anon_sym_namespace] = ACTIONS(2020),
    [anon_sym_using] = ACTIONS(2020),
    [anon_sym_static_assert] = ACTIONS(2020),
    [anon_sym_concept] = ACTIONS(2020),
    [anon_sym_co_return] = ACTIONS(2020),
    [anon_sym_co_yield] = ACTIONS(2020),
    [anon_sym_R_DQUOTE] = ACTIONS(2022),
    [anon_sym_LR_DQUOTE] = ACTIONS(2022),
    [anon_sym_uR_DQUOTE] = ACTIONS(2022),
    [anon_sym_UR_DQUOTE] = ACTIONS(2022),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2022),
    [anon_sym_co_await] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(2020),
    [anon_sym_requires] = ACTIONS(2020),
    [sym_this] = ACTIONS(2020),
    [anon_sym___launch_bounds__] = ACTIONS(2020),
  },
  [356] = {
    [sym_identifier] = ACTIONS(2024),
    [aux_sym_preproc_include_token1] = ACTIONS(2024),
    [aux_sym_preproc_def_token1] = ACTIONS(2024),
    [aux_sym_preproc_if_token1] = ACTIONS(2024),
    [aux_sym_preproc_if_token2] = ACTIONS(2024),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2024),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2024),
    [sym_preproc_directive] = ACTIONS(2024),
    [anon_sym_LPAREN2] = ACTIONS(2026),
    [anon_sym_BANG] = ACTIONS(2026),
    [anon_sym_TILDE] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2024),
    [anon_sym_PLUS] = ACTIONS(2024),
    [anon_sym_STAR] = ACTIONS(2026),
    [anon_sym_AMP_AMP] = ACTIONS(2026),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_SEMI] = ACTIONS(2026),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_typedef] = ACTIONS(2024),
    [anon_sym___device__] = ACTIONS(2024),
    [anon_sym___host__] = ACTIONS(2024),
    [anon_sym___global__] = ACTIONS(2024),
    [anon_sym___forceinline__] = ACTIONS(2024),
    [anon_sym___noinline__] = ACTIONS(2024),
    [anon_sym_extern] = ACTIONS(2024),
    [anon_sym___attribute__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(2026),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2026),
    [anon_sym___declspec] = ACTIONS(2024),
    [anon_sym___based] = ACTIONS(2024),
    [anon_sym___cdecl] = ACTIONS(2024),
    [anon_sym___clrcall] = ACTIONS(2024),
    [anon_sym___stdcall] = ACTIONS(2024),
    [anon_sym___fastcall] = ACTIONS(2024),
    [anon_sym___thiscall] = ACTIONS(2024),
    [anon_sym___vectorcall] = ACTIONS(2024),
    [anon_sym_LBRACE] = ACTIONS(2026),
    [anon_sym_signed] = ACTIONS(2024),
    [anon_sym_unsigned] = ACTIONS(2024),
    [anon_sym_long] = ACTIONS(2024),
    [anon_sym_short] = ACTIONS(2024),
    [anon_sym_LBRACK] = ACTIONS(2024),
    [anon_sym_static] = ACTIONS(2024),
    [anon_sym_register] = ACTIONS(2024),
    [anon_sym_inline] = ACTIONS(2024),
    [anon_sym___inline] = ACTIONS(2024),
    [anon_sym___inline__] = ACTIONS(2024),
    [anon_sym___forceinline] = ACTIONS(2024),
    [anon_sym_thread_local] = ACTIONS(2024),
    [anon_sym___thread] = ACTIONS(2024),
    [anon_sym_const] = ACTIONS(2024),
    [anon_sym_constexpr] = ACTIONS(2024),
    [anon_sym_volatile] = ACTIONS(2024),
    [anon_sym_restrict] = ACTIONS(2024),
    [anon_sym___restrict__] = ACTIONS(2024),
    [anon_sym__Atomic] = ACTIONS(2024),
    [anon_sym__Noreturn] = ACTIONS(2024),
    [anon_sym_noreturn] = ACTIONS(2024),
    [anon_sym_mutable] = ACTIONS(2024),
    [anon_sym_constinit] = ACTIONS(2024),
    [anon_sym_consteval] = ACTIONS(2024),
    [anon_sym___shared__] = ACTIONS(2024),
    [anon_sym___local__] = ACTIONS(2024),
    [anon_sym___constant__] = ACTIONS(2024),
    [anon_sym___managed__] = ACTIONS(2024),
    [anon_sym___grid_constant__] = ACTIONS(2024),
    [anon_sym_alignas] = ACTIONS(2024),
    [anon_sym__Alignas] = ACTIONS(2024),
    [sym_primitive_type] = ACTIONS(2024),
    [anon_sym_enum] = ACTIONS(2024),
    [anon_sym_class] = ACTIONS(2024),
    [anon_sym_struct] = ACTIONS(2024),
    [anon_sym_union] = ACTIONS(2024),
    [anon_sym_if] = ACTIONS(2024),
    [anon_sym_else] = ACTIONS(2024),
    [anon_sym_switch] = ACTIONS(2024),
    [anon_sym_case] = ACTIONS(2024),
    [anon_sym_default] = ACTIONS(2024),
    [anon_sym_while] = ACTIONS(2024),
    [anon_sym_do] = ACTIONS(2024),
    [anon_sym_for] = ACTIONS(2024),
    [anon_sym_return] = ACTIONS(2024),
    [anon_sym_break] = ACTIONS(2024),
    [anon_sym_continue] = ACTIONS(2024),
    [anon_sym_goto] = ACTIONS(2024),
    [anon_sym___try] = ACTIONS(2024),
    [anon_sym___leave] = ACTIONS(2024),
    [anon_sym_not] = ACTIONS(2024),
    [anon_sym_compl] = ACTIONS(2024),
    [anon_sym_DASH_DASH] = ACTIONS(2026),
    [anon_sym_PLUS_PLUS] = ACTIONS(2026),
    [anon_sym_sizeof] = ACTIONS(2024),
    [anon_sym___alignof__] = ACTIONS(2024),
    [anon_sym___alignof] = ACTIONS(2024),
    [anon_sym__alignof] = ACTIONS(2024),
    [anon_sym_alignof] = ACTIONS(2024),
    [anon_sym__Alignof] = ACTIONS(2024),
    [anon_sym_offsetof] = ACTIONS(2024),
    [anon_sym__Generic] = ACTIONS(2024),
    [anon_sym_asm] = ACTIONS(2024),
    [anon_sym___asm__] = ACTIONS(2024),
    [sym_number_literal] = ACTIONS(2026),
    [anon_sym_L_SQUOTE] = ACTIONS(2026),
    [anon_sym_u_SQUOTE] = ACTIONS(2026),
    [anon_sym_U_SQUOTE] = ACTIONS(2026),
    [anon_sym_u8_SQUOTE] = ACTIONS(2026),
    [anon_sym_SQUOTE] = ACTIONS(2026),
    [anon_sym_L_DQUOTE] = ACTIONS(2026),
    [anon_sym_u_DQUOTE] = ACTIONS(2026),
    [anon_sym_U_DQUOTE] = ACTIONS(2026),
    [anon_sym_u8_DQUOTE] = ACTIONS(2026),
    [anon_sym_DQUOTE] = ACTIONS(2026),
    [sym_true] = ACTIONS(2024),
    [sym_false] = ACTIONS(2024),
    [anon_sym_NULL] = ACTIONS(2024),
    [anon_sym_nullptr] = ACTIONS(2024),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2024),
    [anon_sym_decltype] = ACTIONS(2024),
    [sym_virtual] = ACTIONS(2024),
    [anon_sym_explicit] = ACTIONS(2024),
    [anon_sym_typename] = ACTIONS(2024),
    [anon_sym_template] = ACTIONS(2024),
    [anon_sym_operator] = ACTIONS(2024),
    [anon_sym_try] = ACTIONS(2024),
    [anon_sym_delete] = ACTIONS(2024),
    [anon_sym_throw] = ACTIONS(2024),
    [anon_sym_namespace] = ACTIONS(2024),
    [anon_sym_using] = ACTIONS(2024),
    [anon_sym_static_assert] = ACTIONS(2024),
    [anon_sym_concept] = ACTIONS(2024),
    [anon_sym_co_return] = ACTIONS(2024),
    [anon_sym_co_yield] = ACTIONS(2024),
    [anon_sym_R_DQUOTE] = ACTIONS(2026),
    [anon_sym_LR_DQUOTE] = ACTIONS(2026),
    [anon_sym_uR_DQUOTE] = ACTIONS(2026),
    [anon_sym_UR_DQUOTE] = ACTIONS(2026),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2026),
    [anon_sym_co_await] = ACTIONS(2024),
    [anon_sym_new] = ACTIONS(2024),
    [anon_sym_requires] = ACTIONS(2024),
    [sym_this] = ACTIONS(2024),
    [anon_sym___launch_bounds__] = ACTIONS(2024),
  },
  [357] = {
    [sym_identifier] = ACTIONS(2028),
    [aux_sym_preproc_include_token1] = ACTIONS(2028),
    [aux_sym_preproc_def_token1] = ACTIONS(2028),
    [aux_sym_preproc_if_token1] = ACTIONS(2028),
    [aux_sym_preproc_if_token2] = ACTIONS(2028),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2028),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2028),
    [sym_preproc_directive] = ACTIONS(2028),
    [anon_sym_LPAREN2] = ACTIONS(2030),
    [anon_sym_BANG] = ACTIONS(2030),
    [anon_sym_TILDE] = ACTIONS(2030),
    [anon_sym_DASH] = ACTIONS(2028),
    [anon_sym_PLUS] = ACTIONS(2028),
    [anon_sym_STAR] = ACTIONS(2030),
    [anon_sym_AMP_AMP] = ACTIONS(2030),
    [anon_sym_AMP] = ACTIONS(2028),
    [anon_sym_SEMI] = ACTIONS(2030),
    [anon_sym___extension__] = ACTIONS(2028),
    [anon_sym_typedef] = ACTIONS(2028),
    [anon_sym___device__] = ACTIONS(2028),
    [anon_sym___host__] = ACTIONS(2028),
    [anon_sym___global__] = ACTIONS(2028),
    [anon_sym___forceinline__] = ACTIONS(2028),
    [anon_sym___noinline__] = ACTIONS(2028),
    [anon_sym_extern] = ACTIONS(2028),
    [anon_sym___attribute__] = ACTIONS(2028),
    [anon_sym_COLON_COLON] = ACTIONS(2030),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2030),
    [anon_sym___declspec] = ACTIONS(2028),
    [anon_sym___based] = ACTIONS(2028),
    [anon_sym___cdecl] = ACTIONS(2028),
    [anon_sym___clrcall] = ACTIONS(2028),
    [anon_sym___stdcall] = ACTIONS(2028),
    [anon_sym___fastcall] = ACTIONS(2028),
    [anon_sym___thiscall] = ACTIONS(2028),
    [anon_sym___vectorcall] = ACTIONS(2028),
    [anon_sym_LBRACE] = ACTIONS(2030),
    [anon_sym_signed] = ACTIONS(2028),
    [anon_sym_unsigned] = ACTIONS(2028),
    [anon_sym_long] = ACTIONS(2028),
    [anon_sym_short] = ACTIONS(2028),
    [anon_sym_LBRACK] = ACTIONS(2028),
    [anon_sym_static] = ACTIONS(2028),
    [anon_sym_register] = ACTIONS(2028),
    [anon_sym_inline] = ACTIONS(2028),
    [anon_sym___inline] = ACTIONS(2028),
    [anon_sym___inline__] = ACTIONS(2028),
    [anon_sym___forceinline] = ACTIONS(2028),
    [anon_sym_thread_local] = ACTIONS(2028),
    [anon_sym___thread] = ACTIONS(2028),
    [anon_sym_const] = ACTIONS(2028),
    [anon_sym_constexpr] = ACTIONS(2028),
    [anon_sym_volatile] = ACTIONS(2028),
    [anon_sym_restrict] = ACTIONS(2028),
    [anon_sym___restrict__] = ACTIONS(2028),
    [anon_sym__Atomic] = ACTIONS(2028),
    [anon_sym__Noreturn] = ACTIONS(2028),
    [anon_sym_noreturn] = ACTIONS(2028),
    [anon_sym_mutable] = ACTIONS(2028),
    [anon_sym_constinit] = ACTIONS(2028),
    [anon_sym_consteval] = ACTIONS(2028),
    [anon_sym___shared__] = ACTIONS(2028),
    [anon_sym___local__] = ACTIONS(2028),
    [anon_sym___constant__] = ACTIONS(2028),
    [anon_sym___managed__] = ACTIONS(2028),
    [anon_sym___grid_constant__] = ACTIONS(2028),
    [anon_sym_alignas] = ACTIONS(2028),
    [anon_sym__Alignas] = ACTIONS(2028),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_enum] = ACTIONS(2028),
    [anon_sym_class] = ACTIONS(2028),
    [anon_sym_struct] = ACTIONS(2028),
    [anon_sym_union] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(2028),
    [anon_sym_else] = ACTIONS(2028),
    [anon_sym_switch] = ACTIONS(2028),
    [anon_sym_case] = ACTIONS(2028),
    [anon_sym_default] = ACTIONS(2028),
    [anon_sym_while] = ACTIONS(2028),
    [anon_sym_do] = ACTIONS(2028),
    [anon_sym_for] = ACTIONS(2028),
    [anon_sym_return] = ACTIONS(2028),
    [anon_sym_break] = ACTIONS(2028),
    [anon_sym_continue] = ACTIONS(2028),
    [anon_sym_goto] = ACTIONS(2028),
    [anon_sym___try] = ACTIONS(2028),
    [anon_sym___leave] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(2028),
    [anon_sym_compl] = ACTIONS(2028),
    [anon_sym_DASH_DASH] = ACTIONS(2030),
    [anon_sym_PLUS_PLUS] = ACTIONS(2030),
    [anon_sym_sizeof] = ACTIONS(2028),
    [anon_sym___alignof__] = ACTIONS(2028),
    [anon_sym___alignof] = ACTIONS(2028),
    [anon_sym__alignof] = ACTIONS(2028),
    [anon_sym_alignof] = ACTIONS(2028),
    [anon_sym__Alignof] = ACTIONS(2028),
    [anon_sym_offsetof] = ACTIONS(2028),
    [anon_sym__Generic] = ACTIONS(2028),
    [anon_sym_asm] = ACTIONS(2028),
    [anon_sym___asm__] = ACTIONS(2028),
    [sym_number_literal] = ACTIONS(2030),
    [anon_sym_L_SQUOTE] = ACTIONS(2030),
    [anon_sym_u_SQUOTE] = ACTIONS(2030),
    [anon_sym_U_SQUOTE] = ACTIONS(2030),
    [anon_sym_u8_SQUOTE] = ACTIONS(2030),
    [anon_sym_SQUOTE] = ACTIONS(2030),
    [anon_sym_L_DQUOTE] = ACTIONS(2030),
    [anon_sym_u_DQUOTE] = ACTIONS(2030),
    [anon_sym_U_DQUOTE] = ACTIONS(2030),
    [anon_sym_u8_DQUOTE] = ACTIONS(2030),
    [anon_sym_DQUOTE] = ACTIONS(2030),
    [sym_true] = ACTIONS(2028),
    [sym_false] = ACTIONS(2028),
    [anon_sym_NULL] = ACTIONS(2028),
    [anon_sym_nullptr] = ACTIONS(2028),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2028),
    [anon_sym_decltype] = ACTIONS(2028),
    [sym_virtual] = ACTIONS(2028),
    [anon_sym_explicit] = ACTIONS(2028),
    [anon_sym_typename] = ACTIONS(2028),
    [anon_sym_template] = ACTIONS(2028),
    [anon_sym_operator] = ACTIONS(2028),
    [anon_sym_try] = ACTIONS(2028),
    [anon_sym_delete] = ACTIONS(2028),
    [anon_sym_throw] = ACTIONS(2028),
    [anon_sym_namespace] = ACTIONS(2028),
    [anon_sym_using] = ACTIONS(2028),
    [anon_sym_static_assert] = ACTIONS(2028),
    [anon_sym_concept] = ACTIONS(2028),
    [anon_sym_co_return] = ACTIONS(2028),
    [anon_sym_co_yield] = ACTIONS(2028),
    [anon_sym_R_DQUOTE] = ACTIONS(2030),
    [anon_sym_LR_DQUOTE] = ACTIONS(2030),
    [anon_sym_uR_DQUOTE] = ACTIONS(2030),
    [anon_sym_UR_DQUOTE] = ACTIONS(2030),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2030),
    [anon_sym_co_await] = ACTIONS(2028),
    [anon_sym_new] = ACTIONS(2028),
    [anon_sym_requires] = ACTIONS(2028),
    [sym_this] = ACTIONS(2028),
    [anon_sym___launch_bounds__] = ACTIONS(2028),
  },
  [358] = {
    [ts_builtin_sym_end] = ACTIONS(2074),
    [sym_identifier] = ACTIONS(2072),
    [aux_sym_preproc_include_token1] = ACTIONS(2072),
    [aux_sym_preproc_def_token1] = ACTIONS(2072),
    [aux_sym_preproc_if_token1] = ACTIONS(2072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2072),
    [sym_preproc_directive] = ACTIONS(2072),
    [anon_sym_LPAREN2] = ACTIONS(2074),
    [anon_sym_BANG] = ACTIONS(2074),
    [anon_sym_TILDE] = ACTIONS(2074),
    [anon_sym_DASH] = ACTIONS(2072),
    [anon_sym_PLUS] = ACTIONS(2072),
    [anon_sym_STAR] = ACTIONS(2074),
    [anon_sym_AMP_AMP] = ACTIONS(2074),
    [anon_sym_AMP] = ACTIONS(2072),
    [anon_sym_SEMI] = ACTIONS(2074),
    [anon_sym___extension__] = ACTIONS(2072),
    [anon_sym_typedef] = ACTIONS(2072),
    [anon_sym___device__] = ACTIONS(2072),
    [anon_sym___host__] = ACTIONS(2072),
    [anon_sym___global__] = ACTIONS(2072),
    [anon_sym___forceinline__] = ACTIONS(2072),
    [anon_sym___noinline__] = ACTIONS(2072),
    [anon_sym_extern] = ACTIONS(2072),
    [anon_sym___attribute__] = ACTIONS(2072),
    [anon_sym_COLON_COLON] = ACTIONS(2074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2074),
    [anon_sym___declspec] = ACTIONS(2072),
    [anon_sym___based] = ACTIONS(2072),
    [anon_sym___cdecl] = ACTIONS(2072),
    [anon_sym___clrcall] = ACTIONS(2072),
    [anon_sym___stdcall] = ACTIONS(2072),
    [anon_sym___fastcall] = ACTIONS(2072),
    [anon_sym___thiscall] = ACTIONS(2072),
    [anon_sym___vectorcall] = ACTIONS(2072),
    [anon_sym_LBRACE] = ACTIONS(2074),
    [anon_sym_signed] = ACTIONS(2072),
    [anon_sym_unsigned] = ACTIONS(2072),
    [anon_sym_long] = ACTIONS(2072),
    [anon_sym_short] = ACTIONS(2072),
    [anon_sym_LBRACK] = ACTIONS(2072),
    [anon_sym_static] = ACTIONS(2072),
    [anon_sym_register] = ACTIONS(2072),
    [anon_sym_inline] = ACTIONS(2072),
    [anon_sym___inline] = ACTIONS(2072),
    [anon_sym___inline__] = ACTIONS(2072),
    [anon_sym___forceinline] = ACTIONS(2072),
    [anon_sym_thread_local] = ACTIONS(2072),
    [anon_sym___thread] = ACTIONS(2072),
    [anon_sym_const] = ACTIONS(2072),
    [anon_sym_constexpr] = ACTIONS(2072),
    [anon_sym_volatile] = ACTIONS(2072),
    [anon_sym_restrict] = ACTIONS(2072),
    [anon_sym___restrict__] = ACTIONS(2072),
    [anon_sym__Atomic] = ACTIONS(2072),
    [anon_sym__Noreturn] = ACTIONS(2072),
    [anon_sym_noreturn] = ACTIONS(2072),
    [anon_sym_mutable] = ACTIONS(2072),
    [anon_sym_constinit] = ACTIONS(2072),
    [anon_sym_consteval] = ACTIONS(2072),
    [anon_sym___shared__] = ACTIONS(2072),
    [anon_sym___local__] = ACTIONS(2072),
    [anon_sym___constant__] = ACTIONS(2072),
    [anon_sym___managed__] = ACTIONS(2072),
    [anon_sym___grid_constant__] = ACTIONS(2072),
    [anon_sym_alignas] = ACTIONS(2072),
    [anon_sym__Alignas] = ACTIONS(2072),
    [sym_primitive_type] = ACTIONS(2072),
    [anon_sym_enum] = ACTIONS(2072),
    [anon_sym_class] = ACTIONS(2072),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2072),
    [anon_sym_if] = ACTIONS(2072),
    [anon_sym_else] = ACTIONS(2072),
    [anon_sym_switch] = ACTIONS(2072),
    [anon_sym_case] = ACTIONS(2072),
    [anon_sym_default] = ACTIONS(2072),
    [anon_sym_while] = ACTIONS(2072),
    [anon_sym_do] = ACTIONS(2072),
    [anon_sym_for] = ACTIONS(2072),
    [anon_sym_return] = ACTIONS(2072),
    [anon_sym_break] = ACTIONS(2072),
    [anon_sym_continue] = ACTIONS(2072),
    [anon_sym_goto] = ACTIONS(2072),
    [anon_sym___try] = ACTIONS(2072),
    [anon_sym___leave] = ACTIONS(2072),
    [anon_sym_not] = ACTIONS(2072),
    [anon_sym_compl] = ACTIONS(2072),
    [anon_sym_DASH_DASH] = ACTIONS(2074),
    [anon_sym_PLUS_PLUS] = ACTIONS(2074),
    [anon_sym_sizeof] = ACTIONS(2072),
    [anon_sym___alignof__] = ACTIONS(2072),
    [anon_sym___alignof] = ACTIONS(2072),
    [anon_sym__alignof] = ACTIONS(2072),
    [anon_sym_alignof] = ACTIONS(2072),
    [anon_sym__Alignof] = ACTIONS(2072),
    [anon_sym_offsetof] = ACTIONS(2072),
    [anon_sym__Generic] = ACTIONS(2072),
    [anon_sym_asm] = ACTIONS(2072),
    [anon_sym___asm__] = ACTIONS(2072),
    [sym_number_literal] = ACTIONS(2074),
    [anon_sym_L_SQUOTE] = ACTIONS(2074),
    [anon_sym_u_SQUOTE] = ACTIONS(2074),
    [anon_sym_U_SQUOTE] = ACTIONS(2074),
    [anon_sym_u8_SQUOTE] = ACTIONS(2074),
    [anon_sym_SQUOTE] = ACTIONS(2074),
    [anon_sym_L_DQUOTE] = ACTIONS(2074),
    [anon_sym_u_DQUOTE] = ACTIONS(2074),
    [anon_sym_U_DQUOTE] = ACTIONS(2074),
    [anon_sym_u8_DQUOTE] = ACTIONS(2074),
    [anon_sym_DQUOTE] = ACTIONS(2074),
    [sym_true] = ACTIONS(2072),
    [sym_false] = ACTIONS(2072),
    [anon_sym_NULL] = ACTIONS(2072),
    [anon_sym_nullptr] = ACTIONS(2072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2072),
    [anon_sym_decltype] = ACTIONS(2072),
    [sym_virtual] = ACTIONS(2072),
    [anon_sym_explicit] = ACTIONS(2072),
    [anon_sym_typename] = ACTIONS(2072),
    [anon_sym_template] = ACTIONS(2072),
    [anon_sym_operator] = ACTIONS(2072),
    [anon_sym_try] = ACTIONS(2072),
    [anon_sym_delete] = ACTIONS(2072),
    [anon_sym_throw] = ACTIONS(2072),
    [anon_sym_namespace] = ACTIONS(2072),
    [anon_sym_using] = ACTIONS(2072),
    [anon_sym_static_assert] = ACTIONS(2072),
    [anon_sym_concept] = ACTIONS(2072),
    [anon_sym_co_return] = ACTIONS(2072),
    [anon_sym_co_yield] = ACTIONS(2072),
    [anon_sym_R_DQUOTE] = ACTIONS(2074),
    [anon_sym_LR_DQUOTE] = ACTIONS(2074),
    [anon_sym_uR_DQUOTE] = ACTIONS(2074),
    [anon_sym_UR_DQUOTE] = ACTIONS(2074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2074),
    [anon_sym_co_await] = ACTIONS(2072),
    [anon_sym_new] = ACTIONS(2072),
    [anon_sym_requires] = ACTIONS(2072),
    [sym_this] = ACTIONS(2072),
    [anon_sym___launch_bounds__] = ACTIONS(2072),
  },
  [359] = {
    [ts_builtin_sym_end] = ACTIONS(2010),
    [sym_identifier] = ACTIONS(2008),
    [aux_sym_preproc_include_token1] = ACTIONS(2008),
    [aux_sym_preproc_def_token1] = ACTIONS(2008),
    [aux_sym_preproc_if_token1] = ACTIONS(2008),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2008),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2008),
    [sym_preproc_directive] = ACTIONS(2008),
    [anon_sym_LPAREN2] = ACTIONS(2010),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_TILDE] = ACTIONS(2010),
    [anon_sym_DASH] = ACTIONS(2008),
    [anon_sym_PLUS] = ACTIONS(2008),
    [anon_sym_STAR] = ACTIONS(2010),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2008),
    [anon_sym_SEMI] = ACTIONS(2010),
    [anon_sym___extension__] = ACTIONS(2008),
    [anon_sym_typedef] = ACTIONS(2008),
    [anon_sym___device__] = ACTIONS(2008),
    [anon_sym___host__] = ACTIONS(2008),
    [anon_sym___global__] = ACTIONS(2008),
    [anon_sym___forceinline__] = ACTIONS(2008),
    [anon_sym___noinline__] = ACTIONS(2008),
    [anon_sym_extern] = ACTIONS(2008),
    [anon_sym___attribute__] = ACTIONS(2008),
    [anon_sym_COLON_COLON] = ACTIONS(2010),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2010),
    [anon_sym___declspec] = ACTIONS(2008),
    [anon_sym___based] = ACTIONS(2008),
    [anon_sym___cdecl] = ACTIONS(2008),
    [anon_sym___clrcall] = ACTIONS(2008),
    [anon_sym___stdcall] = ACTIONS(2008),
    [anon_sym___fastcall] = ACTIONS(2008),
    [anon_sym___thiscall] = ACTIONS(2008),
    [anon_sym___vectorcall] = ACTIONS(2008),
    [anon_sym_LBRACE] = ACTIONS(2010),
    [anon_sym_signed] = ACTIONS(2008),
    [anon_sym_unsigned] = ACTIONS(2008),
    [anon_sym_long] = ACTIONS(2008),
    [anon_sym_short] = ACTIONS(2008),
    [anon_sym_LBRACK] = ACTIONS(2008),
    [anon_sym_static] = ACTIONS(2008),
    [anon_sym_register] = ACTIONS(2008),
    [anon_sym_inline] = ACTIONS(2008),
    [anon_sym___inline] = ACTIONS(2008),
    [anon_sym___inline__] = ACTIONS(2008),
    [anon_sym___forceinline] = ACTIONS(2008),
    [anon_sym_thread_local] = ACTIONS(2008),
    [anon_sym___thread] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(2008),
    [anon_sym_constexpr] = ACTIONS(2008),
    [anon_sym_volatile] = ACTIONS(2008),
    [anon_sym_restrict] = ACTIONS(2008),
    [anon_sym___restrict__] = ACTIONS(2008),
    [anon_sym__Atomic] = ACTIONS(2008),
    [anon_sym__Noreturn] = ACTIONS(2008),
    [anon_sym_noreturn] = ACTIONS(2008),
    [anon_sym_mutable] = ACTIONS(2008),
    [anon_sym_constinit] = ACTIONS(2008),
    [anon_sym_consteval] = ACTIONS(2008),
    [anon_sym___shared__] = ACTIONS(2008),
    [anon_sym___local__] = ACTIONS(2008),
    [anon_sym___constant__] = ACTIONS(2008),
    [anon_sym___managed__] = ACTIONS(2008),
    [anon_sym___grid_constant__] = ACTIONS(2008),
    [anon_sym_alignas] = ACTIONS(2008),
    [anon_sym__Alignas] = ACTIONS(2008),
    [sym_primitive_type] = ACTIONS(2008),
    [anon_sym_enum] = ACTIONS(2008),
    [anon_sym_class] = ACTIONS(2008),
    [anon_sym_struct] = ACTIONS(2008),
    [anon_sym_union] = ACTIONS(2008),
    [anon_sym_if] = ACTIONS(2008),
    [anon_sym_else] = ACTIONS(2008),
    [anon_sym_switch] = ACTIONS(2008),
    [anon_sym_case] = ACTIONS(2008),
    [anon_sym_default] = ACTIONS(2008),
    [anon_sym_while] = ACTIONS(2008),
    [anon_sym_do] = ACTIONS(2008),
    [anon_sym_for] = ACTIONS(2008),
    [anon_sym_return] = ACTIONS(2008),
    [anon_sym_break] = ACTIONS(2008),
    [anon_sym_continue] = ACTIONS(2008),
    [anon_sym_goto] = ACTIONS(2008),
    [anon_sym___try] = ACTIONS(2008),
    [anon_sym___leave] = ACTIONS(2008),
    [anon_sym_not] = ACTIONS(2008),
    [anon_sym_compl] = ACTIONS(2008),
    [anon_sym_DASH_DASH] = ACTIONS(2010),
    [anon_sym_PLUS_PLUS] = ACTIONS(2010),
    [anon_sym_sizeof] = ACTIONS(2008),
    [anon_sym___alignof__] = ACTIONS(2008),
    [anon_sym___alignof] = ACTIONS(2008),
    [anon_sym__alignof] = ACTIONS(2008),
    [anon_sym_alignof] = ACTIONS(2008),
    [anon_sym__Alignof] = ACTIONS(2008),
    [anon_sym_offsetof] = ACTIONS(2008),
    [anon_sym__Generic] = ACTIONS(2008),
    [anon_sym_asm] = ACTIONS(2008),
    [anon_sym___asm__] = ACTIONS(2008),
    [sym_number_literal] = ACTIONS(2010),
    [anon_sym_L_SQUOTE] = ACTIONS(2010),
    [anon_sym_u_SQUOTE] = ACTIONS(2010),
    [anon_sym_U_SQUOTE] = ACTIONS(2010),
    [anon_sym_u8_SQUOTE] = ACTIONS(2010),
    [anon_sym_SQUOTE] = ACTIONS(2010),
    [anon_sym_L_DQUOTE] = ACTIONS(2010),
    [anon_sym_u_DQUOTE] = ACTIONS(2010),
    [anon_sym_U_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8_DQUOTE] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [sym_true] = ACTIONS(2008),
    [sym_false] = ACTIONS(2008),
    [anon_sym_NULL] = ACTIONS(2008),
    [anon_sym_nullptr] = ACTIONS(2008),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2008),
    [anon_sym_decltype] = ACTIONS(2008),
    [sym_virtual] = ACTIONS(2008),
    [anon_sym_explicit] = ACTIONS(2008),
    [anon_sym_typename] = ACTIONS(2008),
    [anon_sym_template] = ACTIONS(2008),
    [anon_sym_operator] = ACTIONS(2008),
    [anon_sym_try] = ACTIONS(2008),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_throw] = ACTIONS(2008),
    [anon_sym_namespace] = ACTIONS(2008),
    [anon_sym_using] = ACTIONS(2008),
    [anon_sym_static_assert] = ACTIONS(2008),
    [anon_sym_concept] = ACTIONS(2008),
    [anon_sym_co_return] = ACTIONS(2008),
    [anon_sym_co_yield] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2008),
    [anon_sym_new] = ACTIONS(2008),
    [anon_sym_requires] = ACTIONS(2008),
    [sym_this] = ACTIONS(2008),
    [anon_sym___launch_bounds__] = ACTIONS(2008),
  },
  [360] = {
    [sym_identifier] = ACTIONS(2032),
    [aux_sym_preproc_include_token1] = ACTIONS(2032),
    [aux_sym_preproc_def_token1] = ACTIONS(2032),
    [aux_sym_preproc_if_token1] = ACTIONS(2032),
    [aux_sym_preproc_if_token2] = ACTIONS(2032),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2032),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2032),
    [sym_preproc_directive] = ACTIONS(2032),
    [anon_sym_LPAREN2] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2034),
    [anon_sym_TILDE] = ACTIONS(2034),
    [anon_sym_DASH] = ACTIONS(2032),
    [anon_sym_PLUS] = ACTIONS(2032),
    [anon_sym_STAR] = ACTIONS(2034),
    [anon_sym_AMP_AMP] = ACTIONS(2034),
    [anon_sym_AMP] = ACTIONS(2032),
    [anon_sym_SEMI] = ACTIONS(2034),
    [anon_sym___extension__] = ACTIONS(2032),
    [anon_sym_typedef] = ACTIONS(2032),
    [anon_sym___device__] = ACTIONS(2032),
    [anon_sym___host__] = ACTIONS(2032),
    [anon_sym___global__] = ACTIONS(2032),
    [anon_sym___forceinline__] = ACTIONS(2032),
    [anon_sym___noinline__] = ACTIONS(2032),
    [anon_sym_extern] = ACTIONS(2032),
    [anon_sym___attribute__] = ACTIONS(2032),
    [anon_sym_COLON_COLON] = ACTIONS(2034),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2034),
    [anon_sym___declspec] = ACTIONS(2032),
    [anon_sym___based] = ACTIONS(2032),
    [anon_sym___cdecl] = ACTIONS(2032),
    [anon_sym___clrcall] = ACTIONS(2032),
    [anon_sym___stdcall] = ACTIONS(2032),
    [anon_sym___fastcall] = ACTIONS(2032),
    [anon_sym___thiscall] = ACTIONS(2032),
    [anon_sym___vectorcall] = ACTIONS(2032),
    [anon_sym_LBRACE] = ACTIONS(2034),
    [anon_sym_signed] = ACTIONS(2032),
    [anon_sym_unsigned] = ACTIONS(2032),
    [anon_sym_long] = ACTIONS(2032),
    [anon_sym_short] = ACTIONS(2032),
    [anon_sym_LBRACK] = ACTIONS(2032),
    [anon_sym_static] = ACTIONS(2032),
    [anon_sym_register] = ACTIONS(2032),
    [anon_sym_inline] = ACTIONS(2032),
    [anon_sym___inline] = ACTIONS(2032),
    [anon_sym___inline__] = ACTIONS(2032),
    [anon_sym___forceinline] = ACTIONS(2032),
    [anon_sym_thread_local] = ACTIONS(2032),
    [anon_sym___thread] = ACTIONS(2032),
    [anon_sym_const] = ACTIONS(2032),
    [anon_sym_constexpr] = ACTIONS(2032),
    [anon_sym_volatile] = ACTIONS(2032),
    [anon_sym_restrict] = ACTIONS(2032),
    [anon_sym___restrict__] = ACTIONS(2032),
    [anon_sym__Atomic] = ACTIONS(2032),
    [anon_sym__Noreturn] = ACTIONS(2032),
    [anon_sym_noreturn] = ACTIONS(2032),
    [anon_sym_mutable] = ACTIONS(2032),
    [anon_sym_constinit] = ACTIONS(2032),
    [anon_sym_consteval] = ACTIONS(2032),
    [anon_sym___shared__] = ACTIONS(2032),
    [anon_sym___local__] = ACTIONS(2032),
    [anon_sym___constant__] = ACTIONS(2032),
    [anon_sym___managed__] = ACTIONS(2032),
    [anon_sym___grid_constant__] = ACTIONS(2032),
    [anon_sym_alignas] = ACTIONS(2032),
    [anon_sym__Alignas] = ACTIONS(2032),
    [sym_primitive_type] = ACTIONS(2032),
    [anon_sym_enum] = ACTIONS(2032),
    [anon_sym_class] = ACTIONS(2032),
    [anon_sym_struct] = ACTIONS(2032),
    [anon_sym_union] = ACTIONS(2032),
    [anon_sym_if] = ACTIONS(2032),
    [anon_sym_else] = ACTIONS(2032),
    [anon_sym_switch] = ACTIONS(2032),
    [anon_sym_case] = ACTIONS(2032),
    [anon_sym_default] = ACTIONS(2032),
    [anon_sym_while] = ACTIONS(2032),
    [anon_sym_do] = ACTIONS(2032),
    [anon_sym_for] = ACTIONS(2032),
    [anon_sym_return] = ACTIONS(2032),
    [anon_sym_break] = ACTIONS(2032),
    [anon_sym_continue] = ACTIONS(2032),
    [anon_sym_goto] = ACTIONS(2032),
    [anon_sym___try] = ACTIONS(2032),
    [anon_sym___leave] = ACTIONS(2032),
    [anon_sym_not] = ACTIONS(2032),
    [anon_sym_compl] = ACTIONS(2032),
    [anon_sym_DASH_DASH] = ACTIONS(2034),
    [anon_sym_PLUS_PLUS] = ACTIONS(2034),
    [anon_sym_sizeof] = ACTIONS(2032),
    [anon_sym___alignof__] = ACTIONS(2032),
    [anon_sym___alignof] = ACTIONS(2032),
    [anon_sym__alignof] = ACTIONS(2032),
    [anon_sym_alignof] = ACTIONS(2032),
    [anon_sym__Alignof] = ACTIONS(2032),
    [anon_sym_offsetof] = ACTIONS(2032),
    [anon_sym__Generic] = ACTIONS(2032),
    [anon_sym_asm] = ACTIONS(2032),
    [anon_sym___asm__] = ACTIONS(2032),
    [sym_number_literal] = ACTIONS(2034),
    [anon_sym_L_SQUOTE] = ACTIONS(2034),
    [anon_sym_u_SQUOTE] = ACTIONS(2034),
    [anon_sym_U_SQUOTE] = ACTIONS(2034),
    [anon_sym_u8_SQUOTE] = ACTIONS(2034),
    [anon_sym_SQUOTE] = ACTIONS(2034),
    [anon_sym_L_DQUOTE] = ACTIONS(2034),
    [anon_sym_u_DQUOTE] = ACTIONS(2034),
    [anon_sym_U_DQUOTE] = ACTIONS(2034),
    [anon_sym_u8_DQUOTE] = ACTIONS(2034),
    [anon_sym_DQUOTE] = ACTIONS(2034),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [anon_sym_NULL] = ACTIONS(2032),
    [anon_sym_nullptr] = ACTIONS(2032),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2032),
    [anon_sym_decltype] = ACTIONS(2032),
    [sym_virtual] = ACTIONS(2032),
    [anon_sym_explicit] = ACTIONS(2032),
    [anon_sym_typename] = ACTIONS(2032),
    [anon_sym_template] = ACTIONS(2032),
    [anon_sym_operator] = ACTIONS(2032),
    [anon_sym_try] = ACTIONS(2032),
    [anon_sym_delete] = ACTIONS(2032),
    [anon_sym_throw] = ACTIONS(2032),
    [anon_sym_namespace] = ACTIONS(2032),
    [anon_sym_using] = ACTIONS(2032),
    [anon_sym_static_assert] = ACTIONS(2032),
    [anon_sym_concept] = ACTIONS(2032),
    [anon_sym_co_return] = ACTIONS(2032),
    [anon_sym_co_yield] = ACTIONS(2032),
    [anon_sym_R_DQUOTE] = ACTIONS(2034),
    [anon_sym_LR_DQUOTE] = ACTIONS(2034),
    [anon_sym_uR_DQUOTE] = ACTIONS(2034),
    [anon_sym_UR_DQUOTE] = ACTIONS(2034),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2034),
    [anon_sym_co_await] = ACTIONS(2032),
    [anon_sym_new] = ACTIONS(2032),
    [anon_sym_requires] = ACTIONS(2032),
    [sym_this] = ACTIONS(2032),
    [anon_sym___launch_bounds__] = ACTIONS(2032),
  },
  [361] = {
    [sym_identifier] = ACTIONS(1992),
    [aux_sym_preproc_include_token1] = ACTIONS(1992),
    [aux_sym_preproc_def_token1] = ACTIONS(1992),
    [aux_sym_preproc_if_token1] = ACTIONS(1992),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1992),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1992),
    [sym_preproc_directive] = ACTIONS(1992),
    [anon_sym_LPAREN2] = ACTIONS(1994),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1994),
    [anon_sym_AMP_AMP] = ACTIONS(1994),
    [anon_sym_AMP] = ACTIONS(1992),
    [anon_sym_SEMI] = ACTIONS(1994),
    [anon_sym___extension__] = ACTIONS(1992),
    [anon_sym_typedef] = ACTIONS(1992),
    [anon_sym___device__] = ACTIONS(1992),
    [anon_sym___host__] = ACTIONS(1992),
    [anon_sym___global__] = ACTIONS(1992),
    [anon_sym___forceinline__] = ACTIONS(1992),
    [anon_sym___noinline__] = ACTIONS(1992),
    [anon_sym_extern] = ACTIONS(1992),
    [anon_sym___attribute__] = ACTIONS(1992),
    [anon_sym_COLON_COLON] = ACTIONS(1994),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1994),
    [anon_sym___declspec] = ACTIONS(1992),
    [anon_sym___based] = ACTIONS(1992),
    [anon_sym___cdecl] = ACTIONS(1992),
    [anon_sym___clrcall] = ACTIONS(1992),
    [anon_sym___stdcall] = ACTIONS(1992),
    [anon_sym___fastcall] = ACTIONS(1992),
    [anon_sym___thiscall] = ACTIONS(1992),
    [anon_sym___vectorcall] = ACTIONS(1992),
    [anon_sym_LBRACE] = ACTIONS(1994),
    [anon_sym_RBRACE] = ACTIONS(1994),
    [anon_sym_signed] = ACTIONS(1992),
    [anon_sym_unsigned] = ACTIONS(1992),
    [anon_sym_long] = ACTIONS(1992),
    [anon_sym_short] = ACTIONS(1992),
    [anon_sym_LBRACK] = ACTIONS(1992),
    [anon_sym_static] = ACTIONS(1992),
    [anon_sym_register] = ACTIONS(1992),
    [anon_sym_inline] = ACTIONS(1992),
    [anon_sym___inline] = ACTIONS(1992),
    [anon_sym___inline__] = ACTIONS(1992),
    [anon_sym___forceinline] = ACTIONS(1992),
    [anon_sym_thread_local] = ACTIONS(1992),
    [anon_sym___thread] = ACTIONS(1992),
    [anon_sym_const] = ACTIONS(1992),
    [anon_sym_constexpr] = ACTIONS(1992),
    [anon_sym_volatile] = ACTIONS(1992),
    [anon_sym_restrict] = ACTIONS(1992),
    [anon_sym___restrict__] = ACTIONS(1992),
    [anon_sym__Atomic] = ACTIONS(1992),
    [anon_sym__Noreturn] = ACTIONS(1992),
    [anon_sym_noreturn] = ACTIONS(1992),
    [anon_sym_mutable] = ACTIONS(1992),
    [anon_sym_constinit] = ACTIONS(1992),
    [anon_sym_consteval] = ACTIONS(1992),
    [anon_sym___shared__] = ACTIONS(1992),
    [anon_sym___local__] = ACTIONS(1992),
    [anon_sym___constant__] = ACTIONS(1992),
    [anon_sym___managed__] = ACTIONS(1992),
    [anon_sym___grid_constant__] = ACTIONS(1992),
    [anon_sym_alignas] = ACTIONS(1992),
    [anon_sym__Alignas] = ACTIONS(1992),
    [sym_primitive_type] = ACTIONS(1992),
    [anon_sym_enum] = ACTIONS(1992),
    [anon_sym_class] = ACTIONS(1992),
    [anon_sym_struct] = ACTIONS(1992),
    [anon_sym_union] = ACTIONS(1992),
    [anon_sym_if] = ACTIONS(1992),
    [anon_sym_else] = ACTIONS(1992),
    [anon_sym_switch] = ACTIONS(1992),
    [anon_sym_case] = ACTIONS(1992),
    [anon_sym_default] = ACTIONS(1992),
    [anon_sym_while] = ACTIONS(1992),
    [anon_sym_do] = ACTIONS(1992),
    [anon_sym_for] = ACTIONS(1992),
    [anon_sym_return] = ACTIONS(1992),
    [anon_sym_break] = ACTIONS(1992),
    [anon_sym_continue] = ACTIONS(1992),
    [anon_sym_goto] = ACTIONS(1992),
    [anon_sym___try] = ACTIONS(1992),
    [anon_sym___leave] = ACTIONS(1992),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(1994),
    [anon_sym_PLUS_PLUS] = ACTIONS(1994),
    [anon_sym_sizeof] = ACTIONS(1992),
    [anon_sym___alignof__] = ACTIONS(1992),
    [anon_sym___alignof] = ACTIONS(1992),
    [anon_sym__alignof] = ACTIONS(1992),
    [anon_sym_alignof] = ACTIONS(1992),
    [anon_sym__Alignof] = ACTIONS(1992),
    [anon_sym_offsetof] = ACTIONS(1992),
    [anon_sym__Generic] = ACTIONS(1992),
    [anon_sym_asm] = ACTIONS(1992),
    [anon_sym___asm__] = ACTIONS(1992),
    [sym_number_literal] = ACTIONS(1994),
    [anon_sym_L_SQUOTE] = ACTIONS(1994),
    [anon_sym_u_SQUOTE] = ACTIONS(1994),
    [anon_sym_U_SQUOTE] = ACTIONS(1994),
    [anon_sym_u8_SQUOTE] = ACTIONS(1994),
    [anon_sym_SQUOTE] = ACTIONS(1994),
    [anon_sym_L_DQUOTE] = ACTIONS(1994),
    [anon_sym_u_DQUOTE] = ACTIONS(1994),
    [anon_sym_U_DQUOTE] = ACTIONS(1994),
    [anon_sym_u8_DQUOTE] = ACTIONS(1994),
    [anon_sym_DQUOTE] = ACTIONS(1994),
    [sym_true] = ACTIONS(1992),
    [sym_false] = ACTIONS(1992),
    [anon_sym_NULL] = ACTIONS(1992),
    [anon_sym_nullptr] = ACTIONS(1992),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1992),
    [anon_sym_decltype] = ACTIONS(1992),
    [sym_virtual] = ACTIONS(1992),
    [anon_sym_explicit] = ACTIONS(1992),
    [anon_sym_typename] = ACTIONS(1992),
    [anon_sym_template] = ACTIONS(1992),
    [anon_sym_operator] = ACTIONS(1992),
    [anon_sym_try] = ACTIONS(1992),
    [anon_sym_delete] = ACTIONS(1992),
    [anon_sym_throw] = ACTIONS(1992),
    [anon_sym_namespace] = ACTIONS(1992),
    [anon_sym_using] = ACTIONS(1992),
    [anon_sym_static_assert] = ACTIONS(1992),
    [anon_sym_concept] = ACTIONS(1992),
    [anon_sym_co_return] = ACTIONS(1992),
    [anon_sym_co_yield] = ACTIONS(1992),
    [anon_sym_R_DQUOTE] = ACTIONS(1994),
    [anon_sym_LR_DQUOTE] = ACTIONS(1994),
    [anon_sym_uR_DQUOTE] = ACTIONS(1994),
    [anon_sym_UR_DQUOTE] = ACTIONS(1994),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1994),
    [anon_sym_co_await] = ACTIONS(1992),
    [anon_sym_new] = ACTIONS(1992),
    [anon_sym_requires] = ACTIONS(1992),
    [sym_this] = ACTIONS(1992),
    [anon_sym___launch_bounds__] = ACTIONS(1992),
  },
  [362] = {
    [sym_identifier] = ACTIONS(2012),
    [aux_sym_preproc_include_token1] = ACTIONS(2012),
    [aux_sym_preproc_def_token1] = ACTIONS(2012),
    [aux_sym_preproc_if_token1] = ACTIONS(2012),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2012),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2012),
    [sym_preproc_directive] = ACTIONS(2012),
    [anon_sym_LPAREN2] = ACTIONS(2014),
    [anon_sym_BANG] = ACTIONS(2014),
    [anon_sym_TILDE] = ACTIONS(2014),
    [anon_sym_DASH] = ACTIONS(2012),
    [anon_sym_PLUS] = ACTIONS(2012),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_AMP_AMP] = ACTIONS(2014),
    [anon_sym_AMP] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2014),
    [anon_sym___extension__] = ACTIONS(2012),
    [anon_sym_typedef] = ACTIONS(2012),
    [anon_sym___device__] = ACTIONS(2012),
    [anon_sym___host__] = ACTIONS(2012),
    [anon_sym___global__] = ACTIONS(2012),
    [anon_sym___forceinline__] = ACTIONS(2012),
    [anon_sym___noinline__] = ACTIONS(2012),
    [anon_sym_extern] = ACTIONS(2012),
    [anon_sym___attribute__] = ACTIONS(2012),
    [anon_sym_COLON_COLON] = ACTIONS(2014),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2014),
    [anon_sym___declspec] = ACTIONS(2012),
    [anon_sym___based] = ACTIONS(2012),
    [anon_sym___cdecl] = ACTIONS(2012),
    [anon_sym___clrcall] = ACTIONS(2012),
    [anon_sym___stdcall] = ACTIONS(2012),
    [anon_sym___fastcall] = ACTIONS(2012),
    [anon_sym___thiscall] = ACTIONS(2012),
    [anon_sym___vectorcall] = ACTIONS(2012),
    [anon_sym_LBRACE] = ACTIONS(2014),
    [anon_sym_RBRACE] = ACTIONS(2014),
    [anon_sym_signed] = ACTIONS(2012),
    [anon_sym_unsigned] = ACTIONS(2012),
    [anon_sym_long] = ACTIONS(2012),
    [anon_sym_short] = ACTIONS(2012),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_static] = ACTIONS(2012),
    [anon_sym_register] = ACTIONS(2012),
    [anon_sym_inline] = ACTIONS(2012),
    [anon_sym___inline] = ACTIONS(2012),
    [anon_sym___inline__] = ACTIONS(2012),
    [anon_sym___forceinline] = ACTIONS(2012),
    [anon_sym_thread_local] = ACTIONS(2012),
    [anon_sym___thread] = ACTIONS(2012),
    [anon_sym_const] = ACTIONS(2012),
    [anon_sym_constexpr] = ACTIONS(2012),
    [anon_sym_volatile] = ACTIONS(2012),
    [anon_sym_restrict] = ACTIONS(2012),
    [anon_sym___restrict__] = ACTIONS(2012),
    [anon_sym__Atomic] = ACTIONS(2012),
    [anon_sym__Noreturn] = ACTIONS(2012),
    [anon_sym_noreturn] = ACTIONS(2012),
    [anon_sym_mutable] = ACTIONS(2012),
    [anon_sym_constinit] = ACTIONS(2012),
    [anon_sym_consteval] = ACTIONS(2012),
    [anon_sym___shared__] = ACTIONS(2012),
    [anon_sym___local__] = ACTIONS(2012),
    [anon_sym___constant__] = ACTIONS(2012),
    [anon_sym___managed__] = ACTIONS(2012),
    [anon_sym___grid_constant__] = ACTIONS(2012),
    [anon_sym_alignas] = ACTIONS(2012),
    [anon_sym__Alignas] = ACTIONS(2012),
    [sym_primitive_type] = ACTIONS(2012),
    [anon_sym_enum] = ACTIONS(2012),
    [anon_sym_class] = ACTIONS(2012),
    [anon_sym_struct] = ACTIONS(2012),
    [anon_sym_union] = ACTIONS(2012),
    [anon_sym_if] = ACTIONS(2012),
    [anon_sym_else] = ACTIONS(2012),
    [anon_sym_switch] = ACTIONS(2012),
    [anon_sym_case] = ACTIONS(2012),
    [anon_sym_default] = ACTIONS(2012),
    [anon_sym_while] = ACTIONS(2012),
    [anon_sym_do] = ACTIONS(2012),
    [anon_sym_for] = ACTIONS(2012),
    [anon_sym_return] = ACTIONS(2012),
    [anon_sym_break] = ACTIONS(2012),
    [anon_sym_continue] = ACTIONS(2012),
    [anon_sym_goto] = ACTIONS(2012),
    [anon_sym___try] = ACTIONS(2012),
    [anon_sym___leave] = ACTIONS(2012),
    [anon_sym_not] = ACTIONS(2012),
    [anon_sym_compl] = ACTIONS(2012),
    [anon_sym_DASH_DASH] = ACTIONS(2014),
    [anon_sym_PLUS_PLUS] = ACTIONS(2014),
    [anon_sym_sizeof] = ACTIONS(2012),
    [anon_sym___alignof__] = ACTIONS(2012),
    [anon_sym___alignof] = ACTIONS(2012),
    [anon_sym__alignof] = ACTIONS(2012),
    [anon_sym_alignof] = ACTIONS(2012),
    [anon_sym__Alignof] = ACTIONS(2012),
    [anon_sym_offsetof] = ACTIONS(2012),
    [anon_sym__Generic] = ACTIONS(2012),
    [anon_sym_asm] = ACTIONS(2012),
    [anon_sym___asm__] = ACTIONS(2012),
    [sym_number_literal] = ACTIONS(2014),
    [anon_sym_L_SQUOTE] = ACTIONS(2014),
    [anon_sym_u_SQUOTE] = ACTIONS(2014),
    [anon_sym_U_SQUOTE] = ACTIONS(2014),
    [anon_sym_u8_SQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2014),
    [anon_sym_L_DQUOTE] = ACTIONS(2014),
    [anon_sym_u_DQUOTE] = ACTIONS(2014),
    [anon_sym_U_DQUOTE] = ACTIONS(2014),
    [anon_sym_u8_DQUOTE] = ACTIONS(2014),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [sym_true] = ACTIONS(2012),
    [sym_false] = ACTIONS(2012),
    [anon_sym_NULL] = ACTIONS(2012),
    [anon_sym_nullptr] = ACTIONS(2012),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2012),
    [anon_sym_decltype] = ACTIONS(2012),
    [sym_virtual] = ACTIONS(2012),
    [anon_sym_explicit] = ACTIONS(2012),
    [anon_sym_typename] = ACTIONS(2012),
    [anon_sym_template] = ACTIONS(2012),
    [anon_sym_operator] = ACTIONS(2012),
    [anon_sym_try] = ACTIONS(2012),
    [anon_sym_delete] = ACTIONS(2012),
    [anon_sym_throw] = ACTIONS(2012),
    [anon_sym_namespace] = ACTIONS(2012),
    [anon_sym_using] = ACTIONS(2012),
    [anon_sym_static_assert] = ACTIONS(2012),
    [anon_sym_concept] = ACTIONS(2012),
    [anon_sym_co_return] = ACTIONS(2012),
    [anon_sym_co_yield] = ACTIONS(2012),
    [anon_sym_R_DQUOTE] = ACTIONS(2014),
    [anon_sym_LR_DQUOTE] = ACTIONS(2014),
    [anon_sym_uR_DQUOTE] = ACTIONS(2014),
    [anon_sym_UR_DQUOTE] = ACTIONS(2014),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2014),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2012),
    [anon_sym_requires] = ACTIONS(2012),
    [sym_this] = ACTIONS(2012),
    [anon_sym___launch_bounds__] = ACTIONS(2012),
  },
  [363] = {
    [ts_builtin_sym_end] = ACTIONS(2030),
    [sym_identifier] = ACTIONS(2028),
    [aux_sym_preproc_include_token1] = ACTIONS(2028),
    [aux_sym_preproc_def_token1] = ACTIONS(2028),
    [aux_sym_preproc_if_token1] = ACTIONS(2028),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2028),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2028),
    [sym_preproc_directive] = ACTIONS(2028),
    [anon_sym_LPAREN2] = ACTIONS(2030),
    [anon_sym_BANG] = ACTIONS(2030),
    [anon_sym_TILDE] = ACTIONS(2030),
    [anon_sym_DASH] = ACTIONS(2028),
    [anon_sym_PLUS] = ACTIONS(2028),
    [anon_sym_STAR] = ACTIONS(2030),
    [anon_sym_AMP_AMP] = ACTIONS(2030),
    [anon_sym_AMP] = ACTIONS(2028),
    [anon_sym_SEMI] = ACTIONS(2030),
    [anon_sym___extension__] = ACTIONS(2028),
    [anon_sym_typedef] = ACTIONS(2028),
    [anon_sym___device__] = ACTIONS(2028),
    [anon_sym___host__] = ACTIONS(2028),
    [anon_sym___global__] = ACTIONS(2028),
    [anon_sym___forceinline__] = ACTIONS(2028),
    [anon_sym___noinline__] = ACTIONS(2028),
    [anon_sym_extern] = ACTIONS(2028),
    [anon_sym___attribute__] = ACTIONS(2028),
    [anon_sym_COLON_COLON] = ACTIONS(2030),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2030),
    [anon_sym___declspec] = ACTIONS(2028),
    [anon_sym___based] = ACTIONS(2028),
    [anon_sym___cdecl] = ACTIONS(2028),
    [anon_sym___clrcall] = ACTIONS(2028),
    [anon_sym___stdcall] = ACTIONS(2028),
    [anon_sym___fastcall] = ACTIONS(2028),
    [anon_sym___thiscall] = ACTIONS(2028),
    [anon_sym___vectorcall] = ACTIONS(2028),
    [anon_sym_LBRACE] = ACTIONS(2030),
    [anon_sym_signed] = ACTIONS(2028),
    [anon_sym_unsigned] = ACTIONS(2028),
    [anon_sym_long] = ACTIONS(2028),
    [anon_sym_short] = ACTIONS(2028),
    [anon_sym_LBRACK] = ACTIONS(2028),
    [anon_sym_static] = ACTIONS(2028),
    [anon_sym_register] = ACTIONS(2028),
    [anon_sym_inline] = ACTIONS(2028),
    [anon_sym___inline] = ACTIONS(2028),
    [anon_sym___inline__] = ACTIONS(2028),
    [anon_sym___forceinline] = ACTIONS(2028),
    [anon_sym_thread_local] = ACTIONS(2028),
    [anon_sym___thread] = ACTIONS(2028),
    [anon_sym_const] = ACTIONS(2028),
    [anon_sym_constexpr] = ACTIONS(2028),
    [anon_sym_volatile] = ACTIONS(2028),
    [anon_sym_restrict] = ACTIONS(2028),
    [anon_sym___restrict__] = ACTIONS(2028),
    [anon_sym__Atomic] = ACTIONS(2028),
    [anon_sym__Noreturn] = ACTIONS(2028),
    [anon_sym_noreturn] = ACTIONS(2028),
    [anon_sym_mutable] = ACTIONS(2028),
    [anon_sym_constinit] = ACTIONS(2028),
    [anon_sym_consteval] = ACTIONS(2028),
    [anon_sym___shared__] = ACTIONS(2028),
    [anon_sym___local__] = ACTIONS(2028),
    [anon_sym___constant__] = ACTIONS(2028),
    [anon_sym___managed__] = ACTIONS(2028),
    [anon_sym___grid_constant__] = ACTIONS(2028),
    [anon_sym_alignas] = ACTIONS(2028),
    [anon_sym__Alignas] = ACTIONS(2028),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_enum] = ACTIONS(2028),
    [anon_sym_class] = ACTIONS(2028),
    [anon_sym_struct] = ACTIONS(2028),
    [anon_sym_union] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(2028),
    [anon_sym_else] = ACTIONS(2028),
    [anon_sym_switch] = ACTIONS(2028),
    [anon_sym_case] = ACTIONS(2028),
    [anon_sym_default] = ACTIONS(2028),
    [anon_sym_while] = ACTIONS(2028),
    [anon_sym_do] = ACTIONS(2028),
    [anon_sym_for] = ACTIONS(2028),
    [anon_sym_return] = ACTIONS(2028),
    [anon_sym_break] = ACTIONS(2028),
    [anon_sym_continue] = ACTIONS(2028),
    [anon_sym_goto] = ACTIONS(2028),
    [anon_sym___try] = ACTIONS(2028),
    [anon_sym___leave] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(2028),
    [anon_sym_compl] = ACTIONS(2028),
    [anon_sym_DASH_DASH] = ACTIONS(2030),
    [anon_sym_PLUS_PLUS] = ACTIONS(2030),
    [anon_sym_sizeof] = ACTIONS(2028),
    [anon_sym___alignof__] = ACTIONS(2028),
    [anon_sym___alignof] = ACTIONS(2028),
    [anon_sym__alignof] = ACTIONS(2028),
    [anon_sym_alignof] = ACTIONS(2028),
    [anon_sym__Alignof] = ACTIONS(2028),
    [anon_sym_offsetof] = ACTIONS(2028),
    [anon_sym__Generic] = ACTIONS(2028),
    [anon_sym_asm] = ACTIONS(2028),
    [anon_sym___asm__] = ACTIONS(2028),
    [sym_number_literal] = ACTIONS(2030),
    [anon_sym_L_SQUOTE] = ACTIONS(2030),
    [anon_sym_u_SQUOTE] = ACTIONS(2030),
    [anon_sym_U_SQUOTE] = ACTIONS(2030),
    [anon_sym_u8_SQUOTE] = ACTIONS(2030),
    [anon_sym_SQUOTE] = ACTIONS(2030),
    [anon_sym_L_DQUOTE] = ACTIONS(2030),
    [anon_sym_u_DQUOTE] = ACTIONS(2030),
    [anon_sym_U_DQUOTE] = ACTIONS(2030),
    [anon_sym_u8_DQUOTE] = ACTIONS(2030),
    [anon_sym_DQUOTE] = ACTIONS(2030),
    [sym_true] = ACTIONS(2028),
    [sym_false] = ACTIONS(2028),
    [anon_sym_NULL] = ACTIONS(2028),
    [anon_sym_nullptr] = ACTIONS(2028),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2028),
    [anon_sym_decltype] = ACTIONS(2028),
    [sym_virtual] = ACTIONS(2028),
    [anon_sym_explicit] = ACTIONS(2028),
    [anon_sym_typename] = ACTIONS(2028),
    [anon_sym_template] = ACTIONS(2028),
    [anon_sym_operator] = ACTIONS(2028),
    [anon_sym_try] = ACTIONS(2028),
    [anon_sym_delete] = ACTIONS(2028),
    [anon_sym_throw] = ACTIONS(2028),
    [anon_sym_namespace] = ACTIONS(2028),
    [anon_sym_using] = ACTIONS(2028),
    [anon_sym_static_assert] = ACTIONS(2028),
    [anon_sym_concept] = ACTIONS(2028),
    [anon_sym_co_return] = ACTIONS(2028),
    [anon_sym_co_yield] = ACTIONS(2028),
    [anon_sym_R_DQUOTE] = ACTIONS(2030),
    [anon_sym_LR_DQUOTE] = ACTIONS(2030),
    [anon_sym_uR_DQUOTE] = ACTIONS(2030),
    [anon_sym_UR_DQUOTE] = ACTIONS(2030),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2030),
    [anon_sym_co_await] = ACTIONS(2028),
    [anon_sym_new] = ACTIONS(2028),
    [anon_sym_requires] = ACTIONS(2028),
    [sym_this] = ACTIONS(2028),
    [anon_sym___launch_bounds__] = ACTIONS(2028),
  },
  [364] = {
    [ts_builtin_sym_end] = ACTIONS(2054),
    [sym_identifier] = ACTIONS(2052),
    [aux_sym_preproc_include_token1] = ACTIONS(2052),
    [aux_sym_preproc_def_token1] = ACTIONS(2052),
    [aux_sym_preproc_if_token1] = ACTIONS(2052),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2052),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2052),
    [sym_preproc_directive] = ACTIONS(2052),
    [anon_sym_LPAREN2] = ACTIONS(2054),
    [anon_sym_BANG] = ACTIONS(2054),
    [anon_sym_TILDE] = ACTIONS(2054),
    [anon_sym_DASH] = ACTIONS(2052),
    [anon_sym_PLUS] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(2054),
    [anon_sym_AMP_AMP] = ACTIONS(2054),
    [anon_sym_AMP] = ACTIONS(2052),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym___extension__] = ACTIONS(2052),
    [anon_sym_typedef] = ACTIONS(2052),
    [anon_sym___device__] = ACTIONS(2052),
    [anon_sym___host__] = ACTIONS(2052),
    [anon_sym___global__] = ACTIONS(2052),
    [anon_sym___forceinline__] = ACTIONS(2052),
    [anon_sym___noinline__] = ACTIONS(2052),
    [anon_sym_extern] = ACTIONS(2052),
    [anon_sym___attribute__] = ACTIONS(2052),
    [anon_sym_COLON_COLON] = ACTIONS(2054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2054),
    [anon_sym___declspec] = ACTIONS(2052),
    [anon_sym___based] = ACTIONS(2052),
    [anon_sym___cdecl] = ACTIONS(2052),
    [anon_sym___clrcall] = ACTIONS(2052),
    [anon_sym___stdcall] = ACTIONS(2052),
    [anon_sym___fastcall] = ACTIONS(2052),
    [anon_sym___thiscall] = ACTIONS(2052),
    [anon_sym___vectorcall] = ACTIONS(2052),
    [anon_sym_LBRACE] = ACTIONS(2054),
    [anon_sym_signed] = ACTIONS(2052),
    [anon_sym_unsigned] = ACTIONS(2052),
    [anon_sym_long] = ACTIONS(2052),
    [anon_sym_short] = ACTIONS(2052),
    [anon_sym_LBRACK] = ACTIONS(2052),
    [anon_sym_static] = ACTIONS(2052),
    [anon_sym_register] = ACTIONS(2052),
    [anon_sym_inline] = ACTIONS(2052),
    [anon_sym___inline] = ACTIONS(2052),
    [anon_sym___inline__] = ACTIONS(2052),
    [anon_sym___forceinline] = ACTIONS(2052),
    [anon_sym_thread_local] = ACTIONS(2052),
    [anon_sym___thread] = ACTIONS(2052),
    [anon_sym_const] = ACTIONS(2052),
    [anon_sym_constexpr] = ACTIONS(2052),
    [anon_sym_volatile] = ACTIONS(2052),
    [anon_sym_restrict] = ACTIONS(2052),
    [anon_sym___restrict__] = ACTIONS(2052),
    [anon_sym__Atomic] = ACTIONS(2052),
    [anon_sym__Noreturn] = ACTIONS(2052),
    [anon_sym_noreturn] = ACTIONS(2052),
    [anon_sym_mutable] = ACTIONS(2052),
    [anon_sym_constinit] = ACTIONS(2052),
    [anon_sym_consteval] = ACTIONS(2052),
    [anon_sym___shared__] = ACTIONS(2052),
    [anon_sym___local__] = ACTIONS(2052),
    [anon_sym___constant__] = ACTIONS(2052),
    [anon_sym___managed__] = ACTIONS(2052),
    [anon_sym___grid_constant__] = ACTIONS(2052),
    [anon_sym_alignas] = ACTIONS(2052),
    [anon_sym__Alignas] = ACTIONS(2052),
    [sym_primitive_type] = ACTIONS(2052),
    [anon_sym_enum] = ACTIONS(2052),
    [anon_sym_class] = ACTIONS(2052),
    [anon_sym_struct] = ACTIONS(2052),
    [anon_sym_union] = ACTIONS(2052),
    [anon_sym_if] = ACTIONS(2052),
    [anon_sym_else] = ACTIONS(2052),
    [anon_sym_switch] = ACTIONS(2052),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2052),
    [anon_sym_while] = ACTIONS(2052),
    [anon_sym_do] = ACTIONS(2052),
    [anon_sym_for] = ACTIONS(2052),
    [anon_sym_return] = ACTIONS(2052),
    [anon_sym_break] = ACTIONS(2052),
    [anon_sym_continue] = ACTIONS(2052),
    [anon_sym_goto] = ACTIONS(2052),
    [anon_sym___try] = ACTIONS(2052),
    [anon_sym___leave] = ACTIONS(2052),
    [anon_sym_not] = ACTIONS(2052),
    [anon_sym_compl] = ACTIONS(2052),
    [anon_sym_DASH_DASH] = ACTIONS(2054),
    [anon_sym_PLUS_PLUS] = ACTIONS(2054),
    [anon_sym_sizeof] = ACTIONS(2052),
    [anon_sym___alignof__] = ACTIONS(2052),
    [anon_sym___alignof] = ACTIONS(2052),
    [anon_sym__alignof] = ACTIONS(2052),
    [anon_sym_alignof] = ACTIONS(2052),
    [anon_sym__Alignof] = ACTIONS(2052),
    [anon_sym_offsetof] = ACTIONS(2052),
    [anon_sym__Generic] = ACTIONS(2052),
    [anon_sym_asm] = ACTIONS(2052),
    [anon_sym___asm__] = ACTIONS(2052),
    [sym_number_literal] = ACTIONS(2054),
    [anon_sym_L_SQUOTE] = ACTIONS(2054),
    [anon_sym_u_SQUOTE] = ACTIONS(2054),
    [anon_sym_U_SQUOTE] = ACTIONS(2054),
    [anon_sym_u8_SQUOTE] = ACTIONS(2054),
    [anon_sym_SQUOTE] = ACTIONS(2054),
    [anon_sym_L_DQUOTE] = ACTIONS(2054),
    [anon_sym_u_DQUOTE] = ACTIONS(2054),
    [anon_sym_U_DQUOTE] = ACTIONS(2054),
    [anon_sym_u8_DQUOTE] = ACTIONS(2054),
    [anon_sym_DQUOTE] = ACTIONS(2054),
    [sym_true] = ACTIONS(2052),
    [sym_false] = ACTIONS(2052),
    [anon_sym_NULL] = ACTIONS(2052),
    [anon_sym_nullptr] = ACTIONS(2052),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2052),
    [anon_sym_decltype] = ACTIONS(2052),
    [sym_virtual] = ACTIONS(2052),
    [anon_sym_explicit] = ACTIONS(2052),
    [anon_sym_typename] = ACTIONS(2052),
    [anon_sym_template] = ACTIONS(2052),
    [anon_sym_operator] = ACTIONS(2052),
    [anon_sym_try] = ACTIONS(2052),
    [anon_sym_delete] = ACTIONS(2052),
    [anon_sym_throw] = ACTIONS(2052),
    [anon_sym_namespace] = ACTIONS(2052),
    [anon_sym_using] = ACTIONS(2052),
    [anon_sym_static_assert] = ACTIONS(2052),
    [anon_sym_concept] = ACTIONS(2052),
    [anon_sym_co_return] = ACTIONS(2052),
    [anon_sym_co_yield] = ACTIONS(2052),
    [anon_sym_R_DQUOTE] = ACTIONS(2054),
    [anon_sym_LR_DQUOTE] = ACTIONS(2054),
    [anon_sym_uR_DQUOTE] = ACTIONS(2054),
    [anon_sym_UR_DQUOTE] = ACTIONS(2054),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2054),
    [anon_sym_co_await] = ACTIONS(2052),
    [anon_sym_new] = ACTIONS(2052),
    [anon_sym_requires] = ACTIONS(2052),
    [sym_this] = ACTIONS(2052),
    [anon_sym___launch_bounds__] = ACTIONS(2052),
  },
  [365] = {
    [ts_builtin_sym_end] = ACTIONS(2042),
    [sym_identifier] = ACTIONS(2040),
    [aux_sym_preproc_include_token1] = ACTIONS(2040),
    [aux_sym_preproc_def_token1] = ACTIONS(2040),
    [aux_sym_preproc_if_token1] = ACTIONS(2040),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2040),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2040),
    [sym_preproc_directive] = ACTIONS(2040),
    [anon_sym_LPAREN2] = ACTIONS(2042),
    [anon_sym_BANG] = ACTIONS(2042),
    [anon_sym_TILDE] = ACTIONS(2042),
    [anon_sym_DASH] = ACTIONS(2040),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_STAR] = ACTIONS(2042),
    [anon_sym_AMP_AMP] = ACTIONS(2042),
    [anon_sym_AMP] = ACTIONS(2040),
    [anon_sym_SEMI] = ACTIONS(2042),
    [anon_sym___extension__] = ACTIONS(2040),
    [anon_sym_typedef] = ACTIONS(2040),
    [anon_sym___device__] = ACTIONS(2040),
    [anon_sym___host__] = ACTIONS(2040),
    [anon_sym___global__] = ACTIONS(2040),
    [anon_sym___forceinline__] = ACTIONS(2040),
    [anon_sym___noinline__] = ACTIONS(2040),
    [anon_sym_extern] = ACTIONS(2040),
    [anon_sym___attribute__] = ACTIONS(2040),
    [anon_sym_COLON_COLON] = ACTIONS(2042),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2042),
    [anon_sym___declspec] = ACTIONS(2040),
    [anon_sym___based] = ACTIONS(2040),
    [anon_sym___cdecl] = ACTIONS(2040),
    [anon_sym___clrcall] = ACTIONS(2040),
    [anon_sym___stdcall] = ACTIONS(2040),
    [anon_sym___fastcall] = ACTIONS(2040),
    [anon_sym___thiscall] = ACTIONS(2040),
    [anon_sym___vectorcall] = ACTIONS(2040),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_signed] = ACTIONS(2040),
    [anon_sym_unsigned] = ACTIONS(2040),
    [anon_sym_long] = ACTIONS(2040),
    [anon_sym_short] = ACTIONS(2040),
    [anon_sym_LBRACK] = ACTIONS(2040),
    [anon_sym_static] = ACTIONS(2040),
    [anon_sym_register] = ACTIONS(2040),
    [anon_sym_inline] = ACTIONS(2040),
    [anon_sym___inline] = ACTIONS(2040),
    [anon_sym___inline__] = ACTIONS(2040),
    [anon_sym___forceinline] = ACTIONS(2040),
    [anon_sym_thread_local] = ACTIONS(2040),
    [anon_sym___thread] = ACTIONS(2040),
    [anon_sym_const] = ACTIONS(2040),
    [anon_sym_constexpr] = ACTIONS(2040),
    [anon_sym_volatile] = ACTIONS(2040),
    [anon_sym_restrict] = ACTIONS(2040),
    [anon_sym___restrict__] = ACTIONS(2040),
    [anon_sym__Atomic] = ACTIONS(2040),
    [anon_sym__Noreturn] = ACTIONS(2040),
    [anon_sym_noreturn] = ACTIONS(2040),
    [anon_sym_mutable] = ACTIONS(2040),
    [anon_sym_constinit] = ACTIONS(2040),
    [anon_sym_consteval] = ACTIONS(2040),
    [anon_sym___shared__] = ACTIONS(2040),
    [anon_sym___local__] = ACTIONS(2040),
    [anon_sym___constant__] = ACTIONS(2040),
    [anon_sym___managed__] = ACTIONS(2040),
    [anon_sym___grid_constant__] = ACTIONS(2040),
    [anon_sym_alignas] = ACTIONS(2040),
    [anon_sym__Alignas] = ACTIONS(2040),
    [sym_primitive_type] = ACTIONS(2040),
    [anon_sym_enum] = ACTIONS(2040),
    [anon_sym_class] = ACTIONS(2040),
    [anon_sym_struct] = ACTIONS(2040),
    [anon_sym_union] = ACTIONS(2040),
    [anon_sym_if] = ACTIONS(2040),
    [anon_sym_else] = ACTIONS(2040),
    [anon_sym_switch] = ACTIONS(2040),
    [anon_sym_case] = ACTIONS(2040),
    [anon_sym_default] = ACTIONS(2040),
    [anon_sym_while] = ACTIONS(2040),
    [anon_sym_do] = ACTIONS(2040),
    [anon_sym_for] = ACTIONS(2040),
    [anon_sym_return] = ACTIONS(2040),
    [anon_sym_break] = ACTIONS(2040),
    [anon_sym_continue] = ACTIONS(2040),
    [anon_sym_goto] = ACTIONS(2040),
    [anon_sym___try] = ACTIONS(2040),
    [anon_sym___leave] = ACTIONS(2040),
    [anon_sym_not] = ACTIONS(2040),
    [anon_sym_compl] = ACTIONS(2040),
    [anon_sym_DASH_DASH] = ACTIONS(2042),
    [anon_sym_PLUS_PLUS] = ACTIONS(2042),
    [anon_sym_sizeof] = ACTIONS(2040),
    [anon_sym___alignof__] = ACTIONS(2040),
    [anon_sym___alignof] = ACTIONS(2040),
    [anon_sym__alignof] = ACTIONS(2040),
    [anon_sym_alignof] = ACTIONS(2040),
    [anon_sym__Alignof] = ACTIONS(2040),
    [anon_sym_offsetof] = ACTIONS(2040),
    [anon_sym__Generic] = ACTIONS(2040),
    [anon_sym_asm] = ACTIONS(2040),
    [anon_sym___asm__] = ACTIONS(2040),
    [sym_number_literal] = ACTIONS(2042),
    [anon_sym_L_SQUOTE] = ACTIONS(2042),
    [anon_sym_u_SQUOTE] = ACTIONS(2042),
    [anon_sym_U_SQUOTE] = ACTIONS(2042),
    [anon_sym_u8_SQUOTE] = ACTIONS(2042),
    [anon_sym_SQUOTE] = ACTIONS(2042),
    [anon_sym_L_DQUOTE] = ACTIONS(2042),
    [anon_sym_u_DQUOTE] = ACTIONS(2042),
    [anon_sym_U_DQUOTE] = ACTIONS(2042),
    [anon_sym_u8_DQUOTE] = ACTIONS(2042),
    [anon_sym_DQUOTE] = ACTIONS(2042),
    [sym_true] = ACTIONS(2040),
    [sym_false] = ACTIONS(2040),
    [anon_sym_NULL] = ACTIONS(2040),
    [anon_sym_nullptr] = ACTIONS(2040),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2040),
    [anon_sym_decltype] = ACTIONS(2040),
    [sym_virtual] = ACTIONS(2040),
    [anon_sym_explicit] = ACTIONS(2040),
    [anon_sym_typename] = ACTIONS(2040),
    [anon_sym_template] = ACTIONS(2040),
    [anon_sym_operator] = ACTIONS(2040),
    [anon_sym_try] = ACTIONS(2040),
    [anon_sym_delete] = ACTIONS(2040),
    [anon_sym_throw] = ACTIONS(2040),
    [anon_sym_namespace] = ACTIONS(2040),
    [anon_sym_using] = ACTIONS(2040),
    [anon_sym_static_assert] = ACTIONS(2040),
    [anon_sym_concept] = ACTIONS(2040),
    [anon_sym_co_return] = ACTIONS(2040),
    [anon_sym_co_yield] = ACTIONS(2040),
    [anon_sym_R_DQUOTE] = ACTIONS(2042),
    [anon_sym_LR_DQUOTE] = ACTIONS(2042),
    [anon_sym_uR_DQUOTE] = ACTIONS(2042),
    [anon_sym_UR_DQUOTE] = ACTIONS(2042),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2042),
    [anon_sym_co_await] = ACTIONS(2040),
    [anon_sym_new] = ACTIONS(2040),
    [anon_sym_requires] = ACTIONS(2040),
    [sym_this] = ACTIONS(2040),
    [anon_sym___launch_bounds__] = ACTIONS(2040),
  },
  [366] = {
    [sym_identifier] = ACTIONS(1938),
    [aux_sym_preproc_include_token1] = ACTIONS(1938),
    [aux_sym_preproc_def_token1] = ACTIONS(1938),
    [aux_sym_preproc_if_token1] = ACTIONS(1938),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1938),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1938),
    [sym_preproc_directive] = ACTIONS(1938),
    [anon_sym_LPAREN2] = ACTIONS(1940),
    [anon_sym_BANG] = ACTIONS(1940),
    [anon_sym_TILDE] = ACTIONS(1940),
    [anon_sym_DASH] = ACTIONS(1938),
    [anon_sym_PLUS] = ACTIONS(1938),
    [anon_sym_STAR] = ACTIONS(1940),
    [anon_sym_AMP_AMP] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1938),
    [anon_sym_SEMI] = ACTIONS(1940),
    [anon_sym___extension__] = ACTIONS(1938),
    [anon_sym_typedef] = ACTIONS(1938),
    [anon_sym___device__] = ACTIONS(1938),
    [anon_sym___host__] = ACTIONS(1938),
    [anon_sym___global__] = ACTIONS(1938),
    [anon_sym___forceinline__] = ACTIONS(1938),
    [anon_sym___noinline__] = ACTIONS(1938),
    [anon_sym_extern] = ACTIONS(1938),
    [anon_sym___attribute__] = ACTIONS(1938),
    [anon_sym_COLON_COLON] = ACTIONS(1940),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1940),
    [anon_sym___declspec] = ACTIONS(1938),
    [anon_sym___based] = ACTIONS(1938),
    [anon_sym___cdecl] = ACTIONS(1938),
    [anon_sym___clrcall] = ACTIONS(1938),
    [anon_sym___stdcall] = ACTIONS(1938),
    [anon_sym___fastcall] = ACTIONS(1938),
    [anon_sym___thiscall] = ACTIONS(1938),
    [anon_sym___vectorcall] = ACTIONS(1938),
    [anon_sym_LBRACE] = ACTIONS(1940),
    [anon_sym_RBRACE] = ACTIONS(1940),
    [anon_sym_signed] = ACTIONS(1938),
    [anon_sym_unsigned] = ACTIONS(1938),
    [anon_sym_long] = ACTIONS(1938),
    [anon_sym_short] = ACTIONS(1938),
    [anon_sym_LBRACK] = ACTIONS(1938),
    [anon_sym_static] = ACTIONS(1938),
    [anon_sym_register] = ACTIONS(1938),
    [anon_sym_inline] = ACTIONS(1938),
    [anon_sym___inline] = ACTIONS(1938),
    [anon_sym___inline__] = ACTIONS(1938),
    [anon_sym___forceinline] = ACTIONS(1938),
    [anon_sym_thread_local] = ACTIONS(1938),
    [anon_sym___thread] = ACTIONS(1938),
    [anon_sym_const] = ACTIONS(1938),
    [anon_sym_constexpr] = ACTIONS(1938),
    [anon_sym_volatile] = ACTIONS(1938),
    [anon_sym_restrict] = ACTIONS(1938),
    [anon_sym___restrict__] = ACTIONS(1938),
    [anon_sym__Atomic] = ACTIONS(1938),
    [anon_sym__Noreturn] = ACTIONS(1938),
    [anon_sym_noreturn] = ACTIONS(1938),
    [anon_sym_mutable] = ACTIONS(1938),
    [anon_sym_constinit] = ACTIONS(1938),
    [anon_sym_consteval] = ACTIONS(1938),
    [anon_sym___shared__] = ACTIONS(1938),
    [anon_sym___local__] = ACTIONS(1938),
    [anon_sym___constant__] = ACTIONS(1938),
    [anon_sym___managed__] = ACTIONS(1938),
    [anon_sym___grid_constant__] = ACTIONS(1938),
    [anon_sym_alignas] = ACTIONS(1938),
    [anon_sym__Alignas] = ACTIONS(1938),
    [sym_primitive_type] = ACTIONS(1938),
    [anon_sym_enum] = ACTIONS(1938),
    [anon_sym_class] = ACTIONS(1938),
    [anon_sym_struct] = ACTIONS(1938),
    [anon_sym_union] = ACTIONS(1938),
    [anon_sym_if] = ACTIONS(1938),
    [anon_sym_else] = ACTIONS(1938),
    [anon_sym_switch] = ACTIONS(1938),
    [anon_sym_case] = ACTIONS(1938),
    [anon_sym_default] = ACTIONS(1938),
    [anon_sym_while] = ACTIONS(1938),
    [anon_sym_do] = ACTIONS(1938),
    [anon_sym_for] = ACTIONS(1938),
    [anon_sym_return] = ACTIONS(1938),
    [anon_sym_break] = ACTIONS(1938),
    [anon_sym_continue] = ACTIONS(1938),
    [anon_sym_goto] = ACTIONS(1938),
    [anon_sym___try] = ACTIONS(1938),
    [anon_sym___leave] = ACTIONS(1938),
    [anon_sym_not] = ACTIONS(1938),
    [anon_sym_compl] = ACTIONS(1938),
    [anon_sym_DASH_DASH] = ACTIONS(1940),
    [anon_sym_PLUS_PLUS] = ACTIONS(1940),
    [anon_sym_sizeof] = ACTIONS(1938),
    [anon_sym___alignof__] = ACTIONS(1938),
    [anon_sym___alignof] = ACTIONS(1938),
    [anon_sym__alignof] = ACTIONS(1938),
    [anon_sym_alignof] = ACTIONS(1938),
    [anon_sym__Alignof] = ACTIONS(1938),
    [anon_sym_offsetof] = ACTIONS(1938),
    [anon_sym__Generic] = ACTIONS(1938),
    [anon_sym_asm] = ACTIONS(1938),
    [anon_sym___asm__] = ACTIONS(1938),
    [sym_number_literal] = ACTIONS(1940),
    [anon_sym_L_SQUOTE] = ACTIONS(1940),
    [anon_sym_u_SQUOTE] = ACTIONS(1940),
    [anon_sym_U_SQUOTE] = ACTIONS(1940),
    [anon_sym_u8_SQUOTE] = ACTIONS(1940),
    [anon_sym_SQUOTE] = ACTIONS(1940),
    [anon_sym_L_DQUOTE] = ACTIONS(1940),
    [anon_sym_u_DQUOTE] = ACTIONS(1940),
    [anon_sym_U_DQUOTE] = ACTIONS(1940),
    [anon_sym_u8_DQUOTE] = ACTIONS(1940),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_true] = ACTIONS(1938),
    [sym_false] = ACTIONS(1938),
    [anon_sym_NULL] = ACTIONS(1938),
    [anon_sym_nullptr] = ACTIONS(1938),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1938),
    [anon_sym_decltype] = ACTIONS(1938),
    [sym_virtual] = ACTIONS(1938),
    [anon_sym_explicit] = ACTIONS(1938),
    [anon_sym_typename] = ACTIONS(1938),
    [anon_sym_template] = ACTIONS(1938),
    [anon_sym_operator] = ACTIONS(1938),
    [anon_sym_try] = ACTIONS(1938),
    [anon_sym_delete] = ACTIONS(1938),
    [anon_sym_throw] = ACTIONS(1938),
    [anon_sym_namespace] = ACTIONS(1938),
    [anon_sym_using] = ACTIONS(1938),
    [anon_sym_static_assert] = ACTIONS(1938),
    [anon_sym_concept] = ACTIONS(1938),
    [anon_sym_co_return] = ACTIONS(1938),
    [anon_sym_co_yield] = ACTIONS(1938),
    [anon_sym_R_DQUOTE] = ACTIONS(1940),
    [anon_sym_LR_DQUOTE] = ACTIONS(1940),
    [anon_sym_uR_DQUOTE] = ACTIONS(1940),
    [anon_sym_UR_DQUOTE] = ACTIONS(1940),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1940),
    [anon_sym_co_await] = ACTIONS(1938),
    [anon_sym_new] = ACTIONS(1938),
    [anon_sym_requires] = ACTIONS(1938),
    [sym_this] = ACTIONS(1938),
    [anon_sym___launch_bounds__] = ACTIONS(1938),
  },
  [367] = {
    [ts_builtin_sym_end] = ACTIONS(1940),
    [sym_identifier] = ACTIONS(1938),
    [aux_sym_preproc_include_token1] = ACTIONS(1938),
    [aux_sym_preproc_def_token1] = ACTIONS(1938),
    [aux_sym_preproc_if_token1] = ACTIONS(1938),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1938),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1938),
    [sym_preproc_directive] = ACTIONS(1938),
    [anon_sym_LPAREN2] = ACTIONS(1940),
    [anon_sym_BANG] = ACTIONS(1940),
    [anon_sym_TILDE] = ACTIONS(1940),
    [anon_sym_DASH] = ACTIONS(1938),
    [anon_sym_PLUS] = ACTIONS(1938),
    [anon_sym_STAR] = ACTIONS(1940),
    [anon_sym_AMP_AMP] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1938),
    [anon_sym_SEMI] = ACTIONS(1940),
    [anon_sym___extension__] = ACTIONS(1938),
    [anon_sym_typedef] = ACTIONS(1938),
    [anon_sym___device__] = ACTIONS(1938),
    [anon_sym___host__] = ACTIONS(1938),
    [anon_sym___global__] = ACTIONS(1938),
    [anon_sym___forceinline__] = ACTIONS(1938),
    [anon_sym___noinline__] = ACTIONS(1938),
    [anon_sym_extern] = ACTIONS(1938),
    [anon_sym___attribute__] = ACTIONS(1938),
    [anon_sym_COLON_COLON] = ACTIONS(1940),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1940),
    [anon_sym___declspec] = ACTIONS(1938),
    [anon_sym___based] = ACTIONS(1938),
    [anon_sym___cdecl] = ACTIONS(1938),
    [anon_sym___clrcall] = ACTIONS(1938),
    [anon_sym___stdcall] = ACTIONS(1938),
    [anon_sym___fastcall] = ACTIONS(1938),
    [anon_sym___thiscall] = ACTIONS(1938),
    [anon_sym___vectorcall] = ACTIONS(1938),
    [anon_sym_LBRACE] = ACTIONS(1940),
    [anon_sym_signed] = ACTIONS(1938),
    [anon_sym_unsigned] = ACTIONS(1938),
    [anon_sym_long] = ACTIONS(1938),
    [anon_sym_short] = ACTIONS(1938),
    [anon_sym_LBRACK] = ACTIONS(1938),
    [anon_sym_static] = ACTIONS(1938),
    [anon_sym_register] = ACTIONS(1938),
    [anon_sym_inline] = ACTIONS(1938),
    [anon_sym___inline] = ACTIONS(1938),
    [anon_sym___inline__] = ACTIONS(1938),
    [anon_sym___forceinline] = ACTIONS(1938),
    [anon_sym_thread_local] = ACTIONS(1938),
    [anon_sym___thread] = ACTIONS(1938),
    [anon_sym_const] = ACTIONS(1938),
    [anon_sym_constexpr] = ACTIONS(1938),
    [anon_sym_volatile] = ACTIONS(1938),
    [anon_sym_restrict] = ACTIONS(1938),
    [anon_sym___restrict__] = ACTIONS(1938),
    [anon_sym__Atomic] = ACTIONS(1938),
    [anon_sym__Noreturn] = ACTIONS(1938),
    [anon_sym_noreturn] = ACTIONS(1938),
    [anon_sym_mutable] = ACTIONS(1938),
    [anon_sym_constinit] = ACTIONS(1938),
    [anon_sym_consteval] = ACTIONS(1938),
    [anon_sym___shared__] = ACTIONS(1938),
    [anon_sym___local__] = ACTIONS(1938),
    [anon_sym___constant__] = ACTIONS(1938),
    [anon_sym___managed__] = ACTIONS(1938),
    [anon_sym___grid_constant__] = ACTIONS(1938),
    [anon_sym_alignas] = ACTIONS(1938),
    [anon_sym__Alignas] = ACTIONS(1938),
    [sym_primitive_type] = ACTIONS(1938),
    [anon_sym_enum] = ACTIONS(1938),
    [anon_sym_class] = ACTIONS(1938),
    [anon_sym_struct] = ACTIONS(1938),
    [anon_sym_union] = ACTIONS(1938),
    [anon_sym_if] = ACTIONS(1938),
    [anon_sym_else] = ACTIONS(1938),
    [anon_sym_switch] = ACTIONS(1938),
    [anon_sym_case] = ACTIONS(1938),
    [anon_sym_default] = ACTIONS(1938),
    [anon_sym_while] = ACTIONS(1938),
    [anon_sym_do] = ACTIONS(1938),
    [anon_sym_for] = ACTIONS(1938),
    [anon_sym_return] = ACTIONS(1938),
    [anon_sym_break] = ACTIONS(1938),
    [anon_sym_continue] = ACTIONS(1938),
    [anon_sym_goto] = ACTIONS(1938),
    [anon_sym___try] = ACTIONS(1938),
    [anon_sym___leave] = ACTIONS(1938),
    [anon_sym_not] = ACTIONS(1938),
    [anon_sym_compl] = ACTIONS(1938),
    [anon_sym_DASH_DASH] = ACTIONS(1940),
    [anon_sym_PLUS_PLUS] = ACTIONS(1940),
    [anon_sym_sizeof] = ACTIONS(1938),
    [anon_sym___alignof__] = ACTIONS(1938),
    [anon_sym___alignof] = ACTIONS(1938),
    [anon_sym__alignof] = ACTIONS(1938),
    [anon_sym_alignof] = ACTIONS(1938),
    [anon_sym__Alignof] = ACTIONS(1938),
    [anon_sym_offsetof] = ACTIONS(1938),
    [anon_sym__Generic] = ACTIONS(1938),
    [anon_sym_asm] = ACTIONS(1938),
    [anon_sym___asm__] = ACTIONS(1938),
    [sym_number_literal] = ACTIONS(1940),
    [anon_sym_L_SQUOTE] = ACTIONS(1940),
    [anon_sym_u_SQUOTE] = ACTIONS(1940),
    [anon_sym_U_SQUOTE] = ACTIONS(1940),
    [anon_sym_u8_SQUOTE] = ACTIONS(1940),
    [anon_sym_SQUOTE] = ACTIONS(1940),
    [anon_sym_L_DQUOTE] = ACTIONS(1940),
    [anon_sym_u_DQUOTE] = ACTIONS(1940),
    [anon_sym_U_DQUOTE] = ACTIONS(1940),
    [anon_sym_u8_DQUOTE] = ACTIONS(1940),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_true] = ACTIONS(1938),
    [sym_false] = ACTIONS(1938),
    [anon_sym_NULL] = ACTIONS(1938),
    [anon_sym_nullptr] = ACTIONS(1938),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1938),
    [anon_sym_decltype] = ACTIONS(1938),
    [sym_virtual] = ACTIONS(1938),
    [anon_sym_explicit] = ACTIONS(1938),
    [anon_sym_typename] = ACTIONS(1938),
    [anon_sym_template] = ACTIONS(1938),
    [anon_sym_operator] = ACTIONS(1938),
    [anon_sym_try] = ACTIONS(1938),
    [anon_sym_delete] = ACTIONS(1938),
    [anon_sym_throw] = ACTIONS(1938),
    [anon_sym_namespace] = ACTIONS(1938),
    [anon_sym_using] = ACTIONS(1938),
    [anon_sym_static_assert] = ACTIONS(1938),
    [anon_sym_concept] = ACTIONS(1938),
    [anon_sym_co_return] = ACTIONS(1938),
    [anon_sym_co_yield] = ACTIONS(1938),
    [anon_sym_R_DQUOTE] = ACTIONS(1940),
    [anon_sym_LR_DQUOTE] = ACTIONS(1940),
    [anon_sym_uR_DQUOTE] = ACTIONS(1940),
    [anon_sym_UR_DQUOTE] = ACTIONS(1940),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1940),
    [anon_sym_co_await] = ACTIONS(1938),
    [anon_sym_new] = ACTIONS(1938),
    [anon_sym_requires] = ACTIONS(1938),
    [sym_this] = ACTIONS(1938),
    [anon_sym___launch_bounds__] = ACTIONS(1938),
  },
  [368] = {
    [ts_builtin_sym_end] = ACTIONS(2014),
    [sym_identifier] = ACTIONS(2012),
    [aux_sym_preproc_include_token1] = ACTIONS(2012),
    [aux_sym_preproc_def_token1] = ACTIONS(2012),
    [aux_sym_preproc_if_token1] = ACTIONS(2012),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2012),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2012),
    [sym_preproc_directive] = ACTIONS(2012),
    [anon_sym_LPAREN2] = ACTIONS(2014),
    [anon_sym_BANG] = ACTIONS(2014),
    [anon_sym_TILDE] = ACTIONS(2014),
    [anon_sym_DASH] = ACTIONS(2012),
    [anon_sym_PLUS] = ACTIONS(2012),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_AMP_AMP] = ACTIONS(2014),
    [anon_sym_AMP] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2014),
    [anon_sym___extension__] = ACTIONS(2012),
    [anon_sym_typedef] = ACTIONS(2012),
    [anon_sym___device__] = ACTIONS(2012),
    [anon_sym___host__] = ACTIONS(2012),
    [anon_sym___global__] = ACTIONS(2012),
    [anon_sym___forceinline__] = ACTIONS(2012),
    [anon_sym___noinline__] = ACTIONS(2012),
    [anon_sym_extern] = ACTIONS(2012),
    [anon_sym___attribute__] = ACTIONS(2012),
    [anon_sym_COLON_COLON] = ACTIONS(2014),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2014),
    [anon_sym___declspec] = ACTIONS(2012),
    [anon_sym___based] = ACTIONS(2012),
    [anon_sym___cdecl] = ACTIONS(2012),
    [anon_sym___clrcall] = ACTIONS(2012),
    [anon_sym___stdcall] = ACTIONS(2012),
    [anon_sym___fastcall] = ACTIONS(2012),
    [anon_sym___thiscall] = ACTIONS(2012),
    [anon_sym___vectorcall] = ACTIONS(2012),
    [anon_sym_LBRACE] = ACTIONS(2014),
    [anon_sym_signed] = ACTIONS(2012),
    [anon_sym_unsigned] = ACTIONS(2012),
    [anon_sym_long] = ACTIONS(2012),
    [anon_sym_short] = ACTIONS(2012),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_static] = ACTIONS(2012),
    [anon_sym_register] = ACTIONS(2012),
    [anon_sym_inline] = ACTIONS(2012),
    [anon_sym___inline] = ACTIONS(2012),
    [anon_sym___inline__] = ACTIONS(2012),
    [anon_sym___forceinline] = ACTIONS(2012),
    [anon_sym_thread_local] = ACTIONS(2012),
    [anon_sym___thread] = ACTIONS(2012),
    [anon_sym_const] = ACTIONS(2012),
    [anon_sym_constexpr] = ACTIONS(2012),
    [anon_sym_volatile] = ACTIONS(2012),
    [anon_sym_restrict] = ACTIONS(2012),
    [anon_sym___restrict__] = ACTIONS(2012),
    [anon_sym__Atomic] = ACTIONS(2012),
    [anon_sym__Noreturn] = ACTIONS(2012),
    [anon_sym_noreturn] = ACTIONS(2012),
    [anon_sym_mutable] = ACTIONS(2012),
    [anon_sym_constinit] = ACTIONS(2012),
    [anon_sym_consteval] = ACTIONS(2012),
    [anon_sym___shared__] = ACTIONS(2012),
    [anon_sym___local__] = ACTIONS(2012),
    [anon_sym___constant__] = ACTIONS(2012),
    [anon_sym___managed__] = ACTIONS(2012),
    [anon_sym___grid_constant__] = ACTIONS(2012),
    [anon_sym_alignas] = ACTIONS(2012),
    [anon_sym__Alignas] = ACTIONS(2012),
    [sym_primitive_type] = ACTIONS(2012),
    [anon_sym_enum] = ACTIONS(2012),
    [anon_sym_class] = ACTIONS(2012),
    [anon_sym_struct] = ACTIONS(2012),
    [anon_sym_union] = ACTIONS(2012),
    [anon_sym_if] = ACTIONS(2012),
    [anon_sym_else] = ACTIONS(2012),
    [anon_sym_switch] = ACTIONS(2012),
    [anon_sym_case] = ACTIONS(2012),
    [anon_sym_default] = ACTIONS(2012),
    [anon_sym_while] = ACTIONS(2012),
    [anon_sym_do] = ACTIONS(2012),
    [anon_sym_for] = ACTIONS(2012),
    [anon_sym_return] = ACTIONS(2012),
    [anon_sym_break] = ACTIONS(2012),
    [anon_sym_continue] = ACTIONS(2012),
    [anon_sym_goto] = ACTIONS(2012),
    [anon_sym___try] = ACTIONS(2012),
    [anon_sym___leave] = ACTIONS(2012),
    [anon_sym_not] = ACTIONS(2012),
    [anon_sym_compl] = ACTIONS(2012),
    [anon_sym_DASH_DASH] = ACTIONS(2014),
    [anon_sym_PLUS_PLUS] = ACTIONS(2014),
    [anon_sym_sizeof] = ACTIONS(2012),
    [anon_sym___alignof__] = ACTIONS(2012),
    [anon_sym___alignof] = ACTIONS(2012),
    [anon_sym__alignof] = ACTIONS(2012),
    [anon_sym_alignof] = ACTIONS(2012),
    [anon_sym__Alignof] = ACTIONS(2012),
    [anon_sym_offsetof] = ACTIONS(2012),
    [anon_sym__Generic] = ACTIONS(2012),
    [anon_sym_asm] = ACTIONS(2012),
    [anon_sym___asm__] = ACTIONS(2012),
    [sym_number_literal] = ACTIONS(2014),
    [anon_sym_L_SQUOTE] = ACTIONS(2014),
    [anon_sym_u_SQUOTE] = ACTIONS(2014),
    [anon_sym_U_SQUOTE] = ACTIONS(2014),
    [anon_sym_u8_SQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2014),
    [anon_sym_L_DQUOTE] = ACTIONS(2014),
    [anon_sym_u_DQUOTE] = ACTIONS(2014),
    [anon_sym_U_DQUOTE] = ACTIONS(2014),
    [anon_sym_u8_DQUOTE] = ACTIONS(2014),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [sym_true] = ACTIONS(2012),
    [sym_false] = ACTIONS(2012),
    [anon_sym_NULL] = ACTIONS(2012),
    [anon_sym_nullptr] = ACTIONS(2012),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2012),
    [anon_sym_decltype] = ACTIONS(2012),
    [sym_virtual] = ACTIONS(2012),
    [anon_sym_explicit] = ACTIONS(2012),
    [anon_sym_typename] = ACTIONS(2012),
    [anon_sym_template] = ACTIONS(2012),
    [anon_sym_operator] = ACTIONS(2012),
    [anon_sym_try] = ACTIONS(2012),
    [anon_sym_delete] = ACTIONS(2012),
    [anon_sym_throw] = ACTIONS(2012),
    [anon_sym_namespace] = ACTIONS(2012),
    [anon_sym_using] = ACTIONS(2012),
    [anon_sym_static_assert] = ACTIONS(2012),
    [anon_sym_concept] = ACTIONS(2012),
    [anon_sym_co_return] = ACTIONS(2012),
    [anon_sym_co_yield] = ACTIONS(2012),
    [anon_sym_R_DQUOTE] = ACTIONS(2014),
    [anon_sym_LR_DQUOTE] = ACTIONS(2014),
    [anon_sym_uR_DQUOTE] = ACTIONS(2014),
    [anon_sym_UR_DQUOTE] = ACTIONS(2014),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2014),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2012),
    [anon_sym_requires] = ACTIONS(2012),
    [sym_this] = ACTIONS(2012),
    [anon_sym___launch_bounds__] = ACTIONS(2012),
  },
  [369] = {
    [ts_builtin_sym_end] = ACTIONS(1994),
    [sym_identifier] = ACTIONS(1992),
    [aux_sym_preproc_include_token1] = ACTIONS(1992),
    [aux_sym_preproc_def_token1] = ACTIONS(1992),
    [aux_sym_preproc_if_token1] = ACTIONS(1992),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1992),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1992),
    [sym_preproc_directive] = ACTIONS(1992),
    [anon_sym_LPAREN2] = ACTIONS(1994),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1994),
    [anon_sym_AMP_AMP] = ACTIONS(1994),
    [anon_sym_AMP] = ACTIONS(1992),
    [anon_sym_SEMI] = ACTIONS(1994),
    [anon_sym___extension__] = ACTIONS(1992),
    [anon_sym_typedef] = ACTIONS(1992),
    [anon_sym___device__] = ACTIONS(1992),
    [anon_sym___host__] = ACTIONS(1992),
    [anon_sym___global__] = ACTIONS(1992),
    [anon_sym___forceinline__] = ACTIONS(1992),
    [anon_sym___noinline__] = ACTIONS(1992),
    [anon_sym_extern] = ACTIONS(1992),
    [anon_sym___attribute__] = ACTIONS(1992),
    [anon_sym_COLON_COLON] = ACTIONS(1994),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1994),
    [anon_sym___declspec] = ACTIONS(1992),
    [anon_sym___based] = ACTIONS(1992),
    [anon_sym___cdecl] = ACTIONS(1992),
    [anon_sym___clrcall] = ACTIONS(1992),
    [anon_sym___stdcall] = ACTIONS(1992),
    [anon_sym___fastcall] = ACTIONS(1992),
    [anon_sym___thiscall] = ACTIONS(1992),
    [anon_sym___vectorcall] = ACTIONS(1992),
    [anon_sym_LBRACE] = ACTIONS(1994),
    [anon_sym_signed] = ACTIONS(1992),
    [anon_sym_unsigned] = ACTIONS(1992),
    [anon_sym_long] = ACTIONS(1992),
    [anon_sym_short] = ACTIONS(1992),
    [anon_sym_LBRACK] = ACTIONS(1992),
    [anon_sym_static] = ACTIONS(1992),
    [anon_sym_register] = ACTIONS(1992),
    [anon_sym_inline] = ACTIONS(1992),
    [anon_sym___inline] = ACTIONS(1992),
    [anon_sym___inline__] = ACTIONS(1992),
    [anon_sym___forceinline] = ACTIONS(1992),
    [anon_sym_thread_local] = ACTIONS(1992),
    [anon_sym___thread] = ACTIONS(1992),
    [anon_sym_const] = ACTIONS(1992),
    [anon_sym_constexpr] = ACTIONS(1992),
    [anon_sym_volatile] = ACTIONS(1992),
    [anon_sym_restrict] = ACTIONS(1992),
    [anon_sym___restrict__] = ACTIONS(1992),
    [anon_sym__Atomic] = ACTIONS(1992),
    [anon_sym__Noreturn] = ACTIONS(1992),
    [anon_sym_noreturn] = ACTIONS(1992),
    [anon_sym_mutable] = ACTIONS(1992),
    [anon_sym_constinit] = ACTIONS(1992),
    [anon_sym_consteval] = ACTIONS(1992),
    [anon_sym___shared__] = ACTIONS(1992),
    [anon_sym___local__] = ACTIONS(1992),
    [anon_sym___constant__] = ACTIONS(1992),
    [anon_sym___managed__] = ACTIONS(1992),
    [anon_sym___grid_constant__] = ACTIONS(1992),
    [anon_sym_alignas] = ACTIONS(1992),
    [anon_sym__Alignas] = ACTIONS(1992),
    [sym_primitive_type] = ACTIONS(1992),
    [anon_sym_enum] = ACTIONS(1992),
    [anon_sym_class] = ACTIONS(1992),
    [anon_sym_struct] = ACTIONS(1992),
    [anon_sym_union] = ACTIONS(1992),
    [anon_sym_if] = ACTIONS(1992),
    [anon_sym_else] = ACTIONS(1992),
    [anon_sym_switch] = ACTIONS(1992),
    [anon_sym_case] = ACTIONS(1992),
    [anon_sym_default] = ACTIONS(1992),
    [anon_sym_while] = ACTIONS(1992),
    [anon_sym_do] = ACTIONS(1992),
    [anon_sym_for] = ACTIONS(1992),
    [anon_sym_return] = ACTIONS(1992),
    [anon_sym_break] = ACTIONS(1992),
    [anon_sym_continue] = ACTIONS(1992),
    [anon_sym_goto] = ACTIONS(1992),
    [anon_sym___try] = ACTIONS(1992),
    [anon_sym___leave] = ACTIONS(1992),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(1994),
    [anon_sym_PLUS_PLUS] = ACTIONS(1994),
    [anon_sym_sizeof] = ACTIONS(1992),
    [anon_sym___alignof__] = ACTIONS(1992),
    [anon_sym___alignof] = ACTIONS(1992),
    [anon_sym__alignof] = ACTIONS(1992),
    [anon_sym_alignof] = ACTIONS(1992),
    [anon_sym__Alignof] = ACTIONS(1992),
    [anon_sym_offsetof] = ACTIONS(1992),
    [anon_sym__Generic] = ACTIONS(1992),
    [anon_sym_asm] = ACTIONS(1992),
    [anon_sym___asm__] = ACTIONS(1992),
    [sym_number_literal] = ACTIONS(1994),
    [anon_sym_L_SQUOTE] = ACTIONS(1994),
    [anon_sym_u_SQUOTE] = ACTIONS(1994),
    [anon_sym_U_SQUOTE] = ACTIONS(1994),
    [anon_sym_u8_SQUOTE] = ACTIONS(1994),
    [anon_sym_SQUOTE] = ACTIONS(1994),
    [anon_sym_L_DQUOTE] = ACTIONS(1994),
    [anon_sym_u_DQUOTE] = ACTIONS(1994),
    [anon_sym_U_DQUOTE] = ACTIONS(1994),
    [anon_sym_u8_DQUOTE] = ACTIONS(1994),
    [anon_sym_DQUOTE] = ACTIONS(1994),
    [sym_true] = ACTIONS(1992),
    [sym_false] = ACTIONS(1992),
    [anon_sym_NULL] = ACTIONS(1992),
    [anon_sym_nullptr] = ACTIONS(1992),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1992),
    [anon_sym_decltype] = ACTIONS(1992),
    [sym_virtual] = ACTIONS(1992),
    [anon_sym_explicit] = ACTIONS(1992),
    [anon_sym_typename] = ACTIONS(1992),
    [anon_sym_template] = ACTIONS(1992),
    [anon_sym_operator] = ACTIONS(1992),
    [anon_sym_try] = ACTIONS(1992),
    [anon_sym_delete] = ACTIONS(1992),
    [anon_sym_throw] = ACTIONS(1992),
    [anon_sym_namespace] = ACTIONS(1992),
    [anon_sym_using] = ACTIONS(1992),
    [anon_sym_static_assert] = ACTIONS(1992),
    [anon_sym_concept] = ACTIONS(1992),
    [anon_sym_co_return] = ACTIONS(1992),
    [anon_sym_co_yield] = ACTIONS(1992),
    [anon_sym_R_DQUOTE] = ACTIONS(1994),
    [anon_sym_LR_DQUOTE] = ACTIONS(1994),
    [anon_sym_uR_DQUOTE] = ACTIONS(1994),
    [anon_sym_UR_DQUOTE] = ACTIONS(1994),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1994),
    [anon_sym_co_await] = ACTIONS(1992),
    [anon_sym_new] = ACTIONS(1992),
    [anon_sym_requires] = ACTIONS(1992),
    [sym_this] = ACTIONS(1992),
    [anon_sym___launch_bounds__] = ACTIONS(1992),
  },
  [370] = {
    [sym_preproc_def] = STATE(370),
    [sym_preproc_function_def] = STATE(370),
    [sym_preproc_call] = STATE(370),
    [sym_preproc_if_in_field_declaration_list] = STATE(370),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(370),
    [sym_type_definition] = STATE(370),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5944),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6464),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(370),
    [sym_field_declaration] = STATE(370),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1701),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(370),
    [sym_operator_cast] = STATE(6994),
    [sym_inline_method_definition] = STATE(370),
    [sym__constructor_specifiers] = STATE(1701),
    [sym_operator_cast_definition] = STATE(370),
    [sym_operator_cast_declaration] = STATE(370),
    [sym_constructor_or_destructor_definition] = STATE(370),
    [sym_constructor_or_destructor_declaration] = STATE(370),
    [sym_friend_declaration] = STATE(370),
    [sym_access_specifier] = STATE(9001),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(370),
    [sym_alias_declaration] = STATE(370),
    [sym_static_assert_declaration] = STATE(370),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6994),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(370),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1701),
    [sym_identifier] = ACTIONS(2592),
    [aux_sym_preproc_def_token1] = ACTIONS(2595),
    [aux_sym_preproc_if_token1] = ACTIONS(2598),
    [aux_sym_preproc_if_token2] = ACTIONS(2601),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2603),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2603),
    [aux_sym_preproc_else_token1] = ACTIONS(2601),
    [aux_sym_preproc_elif_token1] = ACTIONS(2601),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2601),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2601),
    [sym_preproc_directive] = ACTIONS(2606),
    [anon_sym_LPAREN2] = ACTIONS(2609),
    [anon_sym_TILDE] = ACTIONS(2612),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_AMP_AMP] = ACTIONS(2618),
    [anon_sym_AMP] = ACTIONS(2621),
    [anon_sym___extension__] = ACTIONS(2624),
    [anon_sym_typedef] = ACTIONS(2627),
    [anon_sym___device__] = ACTIONS(2630),
    [anon_sym___host__] = ACTIONS(2630),
    [anon_sym___global__] = ACTIONS(2630),
    [anon_sym___forceinline__] = ACTIONS(2630),
    [anon_sym___noinline__] = ACTIONS(2630),
    [anon_sym_extern] = ACTIONS(2633),
    [anon_sym___attribute__] = ACTIONS(2636),
    [anon_sym_COLON_COLON] = ACTIONS(2639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2642),
    [anon_sym___declspec] = ACTIONS(2645),
    [anon_sym___based] = ACTIONS(2648),
    [anon_sym_signed] = ACTIONS(2651),
    [anon_sym_unsigned] = ACTIONS(2651),
    [anon_sym_long] = ACTIONS(2651),
    [anon_sym_short] = ACTIONS(2651),
    [anon_sym_LBRACK] = ACTIONS(2654),
    [anon_sym_static] = ACTIONS(2633),
    [anon_sym_register] = ACTIONS(2633),
    [anon_sym_inline] = ACTIONS(2633),
    [anon_sym___inline] = ACTIONS(2633),
    [anon_sym___inline__] = ACTIONS(2633),
    [anon_sym___forceinline] = ACTIONS(2633),
    [anon_sym_thread_local] = ACTIONS(2633),
    [anon_sym___thread] = ACTIONS(2633),
    [anon_sym_const] = ACTIONS(2657),
    [anon_sym_constexpr] = ACTIONS(2657),
    [anon_sym_volatile] = ACTIONS(2657),
    [anon_sym_restrict] = ACTIONS(2657),
    [anon_sym___restrict__] = ACTIONS(2657),
    [anon_sym__Atomic] = ACTIONS(2657),
    [anon_sym__Noreturn] = ACTIONS(2657),
    [anon_sym_noreturn] = ACTIONS(2657),
    [anon_sym_mutable] = ACTIONS(2657),
    [anon_sym_constinit] = ACTIONS(2657),
    [anon_sym_consteval] = ACTIONS(2657),
    [anon_sym___shared__] = ACTIONS(2657),
    [anon_sym___local__] = ACTIONS(2657),
    [anon_sym___constant__] = ACTIONS(2657),
    [anon_sym___managed__] = ACTIONS(2657),
    [anon_sym___grid_constant__] = ACTIONS(2657),
    [anon_sym_alignas] = ACTIONS(2660),
    [anon_sym__Alignas] = ACTIONS(2660),
    [sym_primitive_type] = ACTIONS(2663),
    [anon_sym_enum] = ACTIONS(2666),
    [anon_sym_class] = ACTIONS(2669),
    [anon_sym_struct] = ACTIONS(2672),
    [anon_sym_union] = ACTIONS(2675),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2678),
    [anon_sym_decltype] = ACTIONS(2681),
    [sym_virtual] = ACTIONS(2630),
    [anon_sym_explicit] = ACTIONS(2684),
    [anon_sym_typename] = ACTIONS(2687),
    [anon_sym_template] = ACTIONS(2690),
    [anon_sym_operator] = ACTIONS(2693),
    [anon_sym_friend] = ACTIONS(2696),
    [anon_sym_public] = ACTIONS(2699),
    [anon_sym_private] = ACTIONS(2699),
    [anon_sym_protected] = ACTIONS(2699),
    [anon_sym_using] = ACTIONS(2702),
    [anon_sym_static_assert] = ACTIONS(2705),
    [anon_sym___launch_bounds__] = ACTIONS(2708),
  },
  [371] = {
    [sym_identifier] = ACTIONS(2036),
    [aux_sym_preproc_include_token1] = ACTIONS(2036),
    [aux_sym_preproc_def_token1] = ACTIONS(2036),
    [aux_sym_preproc_if_token1] = ACTIONS(2036),
    [aux_sym_preproc_if_token2] = ACTIONS(2036),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2036),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2036),
    [sym_preproc_directive] = ACTIONS(2036),
    [anon_sym_LPAREN2] = ACTIONS(2038),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2038),
    [anon_sym_DASH] = ACTIONS(2036),
    [anon_sym_PLUS] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(2038),
    [anon_sym_AMP_AMP] = ACTIONS(2038),
    [anon_sym_AMP] = ACTIONS(2036),
    [anon_sym_SEMI] = ACTIONS(2038),
    [anon_sym___extension__] = ACTIONS(2036),
    [anon_sym_typedef] = ACTIONS(2036),
    [anon_sym___device__] = ACTIONS(2036),
    [anon_sym___host__] = ACTIONS(2036),
    [anon_sym___global__] = ACTIONS(2036),
    [anon_sym___forceinline__] = ACTIONS(2036),
    [anon_sym___noinline__] = ACTIONS(2036),
    [anon_sym_extern] = ACTIONS(2036),
    [anon_sym___attribute__] = ACTIONS(2036),
    [anon_sym_COLON_COLON] = ACTIONS(2038),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2038),
    [anon_sym___declspec] = ACTIONS(2036),
    [anon_sym___based] = ACTIONS(2036),
    [anon_sym___cdecl] = ACTIONS(2036),
    [anon_sym___clrcall] = ACTIONS(2036),
    [anon_sym___stdcall] = ACTIONS(2036),
    [anon_sym___fastcall] = ACTIONS(2036),
    [anon_sym___thiscall] = ACTIONS(2036),
    [anon_sym___vectorcall] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2038),
    [anon_sym_signed] = ACTIONS(2036),
    [anon_sym_unsigned] = ACTIONS(2036),
    [anon_sym_long] = ACTIONS(2036),
    [anon_sym_short] = ACTIONS(2036),
    [anon_sym_LBRACK] = ACTIONS(2036),
    [anon_sym_static] = ACTIONS(2036),
    [anon_sym_register] = ACTIONS(2036),
    [anon_sym_inline] = ACTIONS(2036),
    [anon_sym___inline] = ACTIONS(2036),
    [anon_sym___inline__] = ACTIONS(2036),
    [anon_sym___forceinline] = ACTIONS(2036),
    [anon_sym_thread_local] = ACTIONS(2036),
    [anon_sym___thread] = ACTIONS(2036),
    [anon_sym_const] = ACTIONS(2036),
    [anon_sym_constexpr] = ACTIONS(2036),
    [anon_sym_volatile] = ACTIONS(2036),
    [anon_sym_restrict] = ACTIONS(2036),
    [anon_sym___restrict__] = ACTIONS(2036),
    [anon_sym__Atomic] = ACTIONS(2036),
    [anon_sym__Noreturn] = ACTIONS(2036),
    [anon_sym_noreturn] = ACTIONS(2036),
    [anon_sym_mutable] = ACTIONS(2036),
    [anon_sym_constinit] = ACTIONS(2036),
    [anon_sym_consteval] = ACTIONS(2036),
    [anon_sym___shared__] = ACTIONS(2036),
    [anon_sym___local__] = ACTIONS(2036),
    [anon_sym___constant__] = ACTIONS(2036),
    [anon_sym___managed__] = ACTIONS(2036),
    [anon_sym___grid_constant__] = ACTIONS(2036),
    [anon_sym_alignas] = ACTIONS(2036),
    [anon_sym__Alignas] = ACTIONS(2036),
    [sym_primitive_type] = ACTIONS(2036),
    [anon_sym_enum] = ACTIONS(2036),
    [anon_sym_class] = ACTIONS(2036),
    [anon_sym_struct] = ACTIONS(2036),
    [anon_sym_union] = ACTIONS(2036),
    [anon_sym_if] = ACTIONS(2036),
    [anon_sym_else] = ACTIONS(2036),
    [anon_sym_switch] = ACTIONS(2036),
    [anon_sym_case] = ACTIONS(2036),
    [anon_sym_default] = ACTIONS(2036),
    [anon_sym_while] = ACTIONS(2036),
    [anon_sym_do] = ACTIONS(2036),
    [anon_sym_for] = ACTIONS(2036),
    [anon_sym_return] = ACTIONS(2036),
    [anon_sym_break] = ACTIONS(2036),
    [anon_sym_continue] = ACTIONS(2036),
    [anon_sym_goto] = ACTIONS(2036),
    [anon_sym___try] = ACTIONS(2036),
    [anon_sym___leave] = ACTIONS(2036),
    [anon_sym_not] = ACTIONS(2036),
    [anon_sym_compl] = ACTIONS(2036),
    [anon_sym_DASH_DASH] = ACTIONS(2038),
    [anon_sym_PLUS_PLUS] = ACTIONS(2038),
    [anon_sym_sizeof] = ACTIONS(2036),
    [anon_sym___alignof__] = ACTIONS(2036),
    [anon_sym___alignof] = ACTIONS(2036),
    [anon_sym__alignof] = ACTIONS(2036),
    [anon_sym_alignof] = ACTIONS(2036),
    [anon_sym__Alignof] = ACTIONS(2036),
    [anon_sym_offsetof] = ACTIONS(2036),
    [anon_sym__Generic] = ACTIONS(2036),
    [anon_sym_asm] = ACTIONS(2036),
    [anon_sym___asm__] = ACTIONS(2036),
    [sym_number_literal] = ACTIONS(2038),
    [anon_sym_L_SQUOTE] = ACTIONS(2038),
    [anon_sym_u_SQUOTE] = ACTIONS(2038),
    [anon_sym_U_SQUOTE] = ACTIONS(2038),
    [anon_sym_u8_SQUOTE] = ACTIONS(2038),
    [anon_sym_SQUOTE] = ACTIONS(2038),
    [anon_sym_L_DQUOTE] = ACTIONS(2038),
    [anon_sym_u_DQUOTE] = ACTIONS(2038),
    [anon_sym_U_DQUOTE] = ACTIONS(2038),
    [anon_sym_u8_DQUOTE] = ACTIONS(2038),
    [anon_sym_DQUOTE] = ACTIONS(2038),
    [sym_true] = ACTIONS(2036),
    [sym_false] = ACTIONS(2036),
    [anon_sym_NULL] = ACTIONS(2036),
    [anon_sym_nullptr] = ACTIONS(2036),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2036),
    [anon_sym_decltype] = ACTIONS(2036),
    [sym_virtual] = ACTIONS(2036),
    [anon_sym_explicit] = ACTIONS(2036),
    [anon_sym_typename] = ACTIONS(2036),
    [anon_sym_template] = ACTIONS(2036),
    [anon_sym_operator] = ACTIONS(2036),
    [anon_sym_try] = ACTIONS(2036),
    [anon_sym_delete] = ACTIONS(2036),
    [anon_sym_throw] = ACTIONS(2036),
    [anon_sym_namespace] = ACTIONS(2036),
    [anon_sym_using] = ACTIONS(2036),
    [anon_sym_static_assert] = ACTIONS(2036),
    [anon_sym_concept] = ACTIONS(2036),
    [anon_sym_co_return] = ACTIONS(2036),
    [anon_sym_co_yield] = ACTIONS(2036),
    [anon_sym_R_DQUOTE] = ACTIONS(2038),
    [anon_sym_LR_DQUOTE] = ACTIONS(2038),
    [anon_sym_uR_DQUOTE] = ACTIONS(2038),
    [anon_sym_UR_DQUOTE] = ACTIONS(2038),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2038),
    [anon_sym_co_await] = ACTIONS(2036),
    [anon_sym_new] = ACTIONS(2036),
    [anon_sym_requires] = ACTIONS(2036),
    [sym_this] = ACTIONS(2036),
    [anon_sym___launch_bounds__] = ACTIONS(2036),
  },
  [372] = {
    [sym_identifier] = ACTIONS(1901),
    [aux_sym_preproc_include_token1] = ACTIONS(1901),
    [aux_sym_preproc_def_token1] = ACTIONS(1901),
    [anon_sym_COMMA] = ACTIONS(1962),
    [aux_sym_preproc_if_token1] = ACTIONS(1901),
    [aux_sym_preproc_if_token2] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1901),
    [sym_preproc_directive] = ACTIONS(1901),
    [anon_sym_LPAREN2] = ACTIONS(1899),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_DASH] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1901),
    [anon_sym_STAR] = ACTIONS(1899),
    [anon_sym_AMP_AMP] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1901),
    [anon_sym_SEMI] = ACTIONS(1962),
    [anon_sym___extension__] = ACTIONS(1901),
    [anon_sym_typedef] = ACTIONS(1901),
    [anon_sym___device__] = ACTIONS(1901),
    [anon_sym___host__] = ACTIONS(1901),
    [anon_sym___global__] = ACTIONS(1901),
    [anon_sym___forceinline__] = ACTIONS(1901),
    [anon_sym___noinline__] = ACTIONS(1901),
    [anon_sym_extern] = ACTIONS(1901),
    [anon_sym___attribute__] = ACTIONS(1901),
    [anon_sym_COLON_COLON] = ACTIONS(1899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1899),
    [anon_sym___declspec] = ACTIONS(1901),
    [anon_sym___based] = ACTIONS(1901),
    [anon_sym___cdecl] = ACTIONS(1901),
    [anon_sym___clrcall] = ACTIONS(1901),
    [anon_sym___stdcall] = ACTIONS(1901),
    [anon_sym___fastcall] = ACTIONS(1901),
    [anon_sym___thiscall] = ACTIONS(1901),
    [anon_sym___vectorcall] = ACTIONS(1901),
    [anon_sym_LBRACE] = ACTIONS(1899),
    [anon_sym_signed] = ACTIONS(1901),
    [anon_sym_unsigned] = ACTIONS(1901),
    [anon_sym_long] = ACTIONS(1901),
    [anon_sym_short] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1901),
    [anon_sym_static] = ACTIONS(1901),
    [anon_sym_register] = ACTIONS(1901),
    [anon_sym_inline] = ACTIONS(1901),
    [anon_sym___inline] = ACTIONS(1901),
    [anon_sym___inline__] = ACTIONS(1901),
    [anon_sym___forceinline] = ACTIONS(1901),
    [anon_sym_thread_local] = ACTIONS(1901),
    [anon_sym___thread] = ACTIONS(1901),
    [anon_sym_const] = ACTIONS(1901),
    [anon_sym_constexpr] = ACTIONS(1901),
    [anon_sym_volatile] = ACTIONS(1901),
    [anon_sym_restrict] = ACTIONS(1901),
    [anon_sym___restrict__] = ACTIONS(1901),
    [anon_sym__Atomic] = ACTIONS(1901),
    [anon_sym__Noreturn] = ACTIONS(1901),
    [anon_sym_noreturn] = ACTIONS(1901),
    [anon_sym_mutable] = ACTIONS(1901),
    [anon_sym_constinit] = ACTIONS(1901),
    [anon_sym_consteval] = ACTIONS(1901),
    [anon_sym___shared__] = ACTIONS(1901),
    [anon_sym___local__] = ACTIONS(1901),
    [anon_sym___constant__] = ACTIONS(1901),
    [anon_sym___managed__] = ACTIONS(1901),
    [anon_sym___grid_constant__] = ACTIONS(1901),
    [anon_sym_alignas] = ACTIONS(1901),
    [anon_sym__Alignas] = ACTIONS(1901),
    [sym_primitive_type] = ACTIONS(1901),
    [anon_sym_enum] = ACTIONS(1901),
    [anon_sym_class] = ACTIONS(1901),
    [anon_sym_struct] = ACTIONS(1901),
    [anon_sym_union] = ACTIONS(1901),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_switch] = ACTIONS(1901),
    [anon_sym_case] = ACTIONS(1901),
    [anon_sym_default] = ACTIONS(1901),
    [anon_sym_while] = ACTIONS(1901),
    [anon_sym_do] = ACTIONS(1901),
    [anon_sym_for] = ACTIONS(1901),
    [anon_sym_return] = ACTIONS(1901),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_continue] = ACTIONS(1901),
    [anon_sym_goto] = ACTIONS(1901),
    [anon_sym___try] = ACTIONS(1901),
    [anon_sym___leave] = ACTIONS(1901),
    [anon_sym_not] = ACTIONS(1901),
    [anon_sym_compl] = ACTIONS(1901),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_sizeof] = ACTIONS(1901),
    [anon_sym___alignof__] = ACTIONS(1901),
    [anon_sym___alignof] = ACTIONS(1901),
    [anon_sym__alignof] = ACTIONS(1901),
    [anon_sym_alignof] = ACTIONS(1901),
    [anon_sym__Alignof] = ACTIONS(1901),
    [anon_sym_offsetof] = ACTIONS(1901),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1901),
    [anon_sym___asm__] = ACTIONS(1901),
    [sym_number_literal] = ACTIONS(1899),
    [anon_sym_L_SQUOTE] = ACTIONS(1899),
    [anon_sym_u_SQUOTE] = ACTIONS(1899),
    [anon_sym_U_SQUOTE] = ACTIONS(1899),
    [anon_sym_u8_SQUOTE] = ACTIONS(1899),
    [anon_sym_SQUOTE] = ACTIONS(1899),
    [anon_sym_L_DQUOTE] = ACTIONS(1899),
    [anon_sym_u_DQUOTE] = ACTIONS(1899),
    [anon_sym_U_DQUOTE] = ACTIONS(1899),
    [anon_sym_u8_DQUOTE] = ACTIONS(1899),
    [anon_sym_DQUOTE] = ACTIONS(1899),
    [sym_true] = ACTIONS(1901),
    [sym_false] = ACTIONS(1901),
    [anon_sym_NULL] = ACTIONS(1901),
    [anon_sym_nullptr] = ACTIONS(1901),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1901),
    [anon_sym_decltype] = ACTIONS(1901),
    [sym_virtual] = ACTIONS(1901),
    [anon_sym_explicit] = ACTIONS(1901),
    [anon_sym_typename] = ACTIONS(1901),
    [anon_sym_template] = ACTIONS(1901),
    [anon_sym_operator] = ACTIONS(1901),
    [anon_sym_try] = ACTIONS(1901),
    [anon_sym_delete] = ACTIONS(1901),
    [anon_sym_throw] = ACTIONS(1901),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_using] = ACTIONS(1901),
    [anon_sym_static_assert] = ACTIONS(1901),
    [anon_sym_concept] = ACTIONS(1901),
    [anon_sym_co_return] = ACTIONS(1901),
    [anon_sym_co_yield] = ACTIONS(1901),
    [anon_sym_R_DQUOTE] = ACTIONS(1899),
    [anon_sym_LR_DQUOTE] = ACTIONS(1899),
    [anon_sym_uR_DQUOTE] = ACTIONS(1899),
    [anon_sym_UR_DQUOTE] = ACTIONS(1899),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1899),
    [anon_sym_co_await] = ACTIONS(1901),
    [anon_sym_new] = ACTIONS(1901),
    [anon_sym_requires] = ACTIONS(1901),
    [sym_this] = ACTIONS(1901),
    [anon_sym___launch_bounds__] = ACTIONS(1901),
  },
  [373] = {
    [sym_identifier] = ACTIONS(2048),
    [aux_sym_preproc_include_token1] = ACTIONS(2048),
    [aux_sym_preproc_def_token1] = ACTIONS(2048),
    [aux_sym_preproc_if_token1] = ACTIONS(2048),
    [aux_sym_preproc_if_token2] = ACTIONS(2048),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2048),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2048),
    [sym_preproc_directive] = ACTIONS(2048),
    [anon_sym_LPAREN2] = ACTIONS(2050),
    [anon_sym_BANG] = ACTIONS(2050),
    [anon_sym_TILDE] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2048),
    [anon_sym_PLUS] = ACTIONS(2048),
    [anon_sym_STAR] = ACTIONS(2050),
    [anon_sym_AMP_AMP] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2048),
    [anon_sym_SEMI] = ACTIONS(2050),
    [anon_sym___extension__] = ACTIONS(2048),
    [anon_sym_typedef] = ACTIONS(2048),
    [anon_sym___device__] = ACTIONS(2048),
    [anon_sym___host__] = ACTIONS(2048),
    [anon_sym___global__] = ACTIONS(2048),
    [anon_sym___forceinline__] = ACTIONS(2048),
    [anon_sym___noinline__] = ACTIONS(2048),
    [anon_sym_extern] = ACTIONS(2048),
    [anon_sym___attribute__] = ACTIONS(2048),
    [anon_sym_COLON_COLON] = ACTIONS(2050),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2050),
    [anon_sym___declspec] = ACTIONS(2048),
    [anon_sym___based] = ACTIONS(2048),
    [anon_sym___cdecl] = ACTIONS(2048),
    [anon_sym___clrcall] = ACTIONS(2048),
    [anon_sym___stdcall] = ACTIONS(2048),
    [anon_sym___fastcall] = ACTIONS(2048),
    [anon_sym___thiscall] = ACTIONS(2048),
    [anon_sym___vectorcall] = ACTIONS(2048),
    [anon_sym_LBRACE] = ACTIONS(2050),
    [anon_sym_signed] = ACTIONS(2048),
    [anon_sym_unsigned] = ACTIONS(2048),
    [anon_sym_long] = ACTIONS(2048),
    [anon_sym_short] = ACTIONS(2048),
    [anon_sym_LBRACK] = ACTIONS(2048),
    [anon_sym_static] = ACTIONS(2048),
    [anon_sym_register] = ACTIONS(2048),
    [anon_sym_inline] = ACTIONS(2048),
    [anon_sym___inline] = ACTIONS(2048),
    [anon_sym___inline__] = ACTIONS(2048),
    [anon_sym___forceinline] = ACTIONS(2048),
    [anon_sym_thread_local] = ACTIONS(2048),
    [anon_sym___thread] = ACTIONS(2048),
    [anon_sym_const] = ACTIONS(2048),
    [anon_sym_constexpr] = ACTIONS(2048),
    [anon_sym_volatile] = ACTIONS(2048),
    [anon_sym_restrict] = ACTIONS(2048),
    [anon_sym___restrict__] = ACTIONS(2048),
    [anon_sym__Atomic] = ACTIONS(2048),
    [anon_sym__Noreturn] = ACTIONS(2048),
    [anon_sym_noreturn] = ACTIONS(2048),
    [anon_sym_mutable] = ACTIONS(2048),
    [anon_sym_constinit] = ACTIONS(2048),
    [anon_sym_consteval] = ACTIONS(2048),
    [anon_sym___shared__] = ACTIONS(2048),
    [anon_sym___local__] = ACTIONS(2048),
    [anon_sym___constant__] = ACTIONS(2048),
    [anon_sym___managed__] = ACTIONS(2048),
    [anon_sym___grid_constant__] = ACTIONS(2048),
    [anon_sym_alignas] = ACTIONS(2048),
    [anon_sym__Alignas] = ACTIONS(2048),
    [sym_primitive_type] = ACTIONS(2048),
    [anon_sym_enum] = ACTIONS(2048),
    [anon_sym_class] = ACTIONS(2048),
    [anon_sym_struct] = ACTIONS(2048),
    [anon_sym_union] = ACTIONS(2048),
    [anon_sym_if] = ACTIONS(2048),
    [anon_sym_else] = ACTIONS(2048),
    [anon_sym_switch] = ACTIONS(2048),
    [anon_sym_case] = ACTIONS(2048),
    [anon_sym_default] = ACTIONS(2048),
    [anon_sym_while] = ACTIONS(2048),
    [anon_sym_do] = ACTIONS(2048),
    [anon_sym_for] = ACTIONS(2048),
    [anon_sym_return] = ACTIONS(2048),
    [anon_sym_break] = ACTIONS(2048),
    [anon_sym_continue] = ACTIONS(2048),
    [anon_sym_goto] = ACTIONS(2048),
    [anon_sym___try] = ACTIONS(2048),
    [anon_sym___leave] = ACTIONS(2048),
    [anon_sym_not] = ACTIONS(2048),
    [anon_sym_compl] = ACTIONS(2048),
    [anon_sym_DASH_DASH] = ACTIONS(2050),
    [anon_sym_PLUS_PLUS] = ACTIONS(2050),
    [anon_sym_sizeof] = ACTIONS(2048),
    [anon_sym___alignof__] = ACTIONS(2048),
    [anon_sym___alignof] = ACTIONS(2048),
    [anon_sym__alignof] = ACTIONS(2048),
    [anon_sym_alignof] = ACTIONS(2048),
    [anon_sym__Alignof] = ACTIONS(2048),
    [anon_sym_offsetof] = ACTIONS(2048),
    [anon_sym__Generic] = ACTIONS(2048),
    [anon_sym_asm] = ACTIONS(2048),
    [anon_sym___asm__] = ACTIONS(2048),
    [sym_number_literal] = ACTIONS(2050),
    [anon_sym_L_SQUOTE] = ACTIONS(2050),
    [anon_sym_u_SQUOTE] = ACTIONS(2050),
    [anon_sym_U_SQUOTE] = ACTIONS(2050),
    [anon_sym_u8_SQUOTE] = ACTIONS(2050),
    [anon_sym_SQUOTE] = ACTIONS(2050),
    [anon_sym_L_DQUOTE] = ACTIONS(2050),
    [anon_sym_u_DQUOTE] = ACTIONS(2050),
    [anon_sym_U_DQUOTE] = ACTIONS(2050),
    [anon_sym_u8_DQUOTE] = ACTIONS(2050),
    [anon_sym_DQUOTE] = ACTIONS(2050),
    [sym_true] = ACTIONS(2048),
    [sym_false] = ACTIONS(2048),
    [anon_sym_NULL] = ACTIONS(2048),
    [anon_sym_nullptr] = ACTIONS(2048),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2048),
    [anon_sym_decltype] = ACTIONS(2048),
    [sym_virtual] = ACTIONS(2048),
    [anon_sym_explicit] = ACTIONS(2048),
    [anon_sym_typename] = ACTIONS(2048),
    [anon_sym_template] = ACTIONS(2048),
    [anon_sym_operator] = ACTIONS(2048),
    [anon_sym_try] = ACTIONS(2048),
    [anon_sym_delete] = ACTIONS(2048),
    [anon_sym_throw] = ACTIONS(2048),
    [anon_sym_namespace] = ACTIONS(2048),
    [anon_sym_using] = ACTIONS(2048),
    [anon_sym_static_assert] = ACTIONS(2048),
    [anon_sym_concept] = ACTIONS(2048),
    [anon_sym_co_return] = ACTIONS(2048),
    [anon_sym_co_yield] = ACTIONS(2048),
    [anon_sym_R_DQUOTE] = ACTIONS(2050),
    [anon_sym_LR_DQUOTE] = ACTIONS(2050),
    [anon_sym_uR_DQUOTE] = ACTIONS(2050),
    [anon_sym_UR_DQUOTE] = ACTIONS(2050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2050),
    [anon_sym_co_await] = ACTIONS(2048),
    [anon_sym_new] = ACTIONS(2048),
    [anon_sym_requires] = ACTIONS(2048),
    [sym_this] = ACTIONS(2048),
    [anon_sym___launch_bounds__] = ACTIONS(2048),
  },
  [374] = {
    [sym_identifier] = ACTIONS(1996),
    [aux_sym_preproc_include_token1] = ACTIONS(1996),
    [aux_sym_preproc_def_token1] = ACTIONS(1996),
    [aux_sym_preproc_if_token1] = ACTIONS(1996),
    [aux_sym_preproc_if_token2] = ACTIONS(1996),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1996),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1996),
    [sym_preproc_directive] = ACTIONS(1996),
    [anon_sym_LPAREN2] = ACTIONS(1998),
    [anon_sym_BANG] = ACTIONS(1998),
    [anon_sym_TILDE] = ACTIONS(1998),
    [anon_sym_DASH] = ACTIONS(1996),
    [anon_sym_PLUS] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(1998),
    [anon_sym_AMP_AMP] = ACTIONS(1998),
    [anon_sym_AMP] = ACTIONS(1996),
    [anon_sym_SEMI] = ACTIONS(1998),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_typedef] = ACTIONS(1996),
    [anon_sym___device__] = ACTIONS(1996),
    [anon_sym___host__] = ACTIONS(1996),
    [anon_sym___global__] = ACTIONS(1996),
    [anon_sym___forceinline__] = ACTIONS(1996),
    [anon_sym___noinline__] = ACTIONS(1996),
    [anon_sym_extern] = ACTIONS(1996),
    [anon_sym___attribute__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1998),
    [anon_sym___declspec] = ACTIONS(1996),
    [anon_sym___based] = ACTIONS(1996),
    [anon_sym___cdecl] = ACTIONS(1996),
    [anon_sym___clrcall] = ACTIONS(1996),
    [anon_sym___stdcall] = ACTIONS(1996),
    [anon_sym___fastcall] = ACTIONS(1996),
    [anon_sym___thiscall] = ACTIONS(1996),
    [anon_sym___vectorcall] = ACTIONS(1996),
    [anon_sym_LBRACE] = ACTIONS(1998),
    [anon_sym_signed] = ACTIONS(1996),
    [anon_sym_unsigned] = ACTIONS(1996),
    [anon_sym_long] = ACTIONS(1996),
    [anon_sym_short] = ACTIONS(1996),
    [anon_sym_LBRACK] = ACTIONS(1996),
    [anon_sym_static] = ACTIONS(1996),
    [anon_sym_register] = ACTIONS(1996),
    [anon_sym_inline] = ACTIONS(1996),
    [anon_sym___inline] = ACTIONS(1996),
    [anon_sym___inline__] = ACTIONS(1996),
    [anon_sym___forceinline] = ACTIONS(1996),
    [anon_sym_thread_local] = ACTIONS(1996),
    [anon_sym___thread] = ACTIONS(1996),
    [anon_sym_const] = ACTIONS(1996),
    [anon_sym_constexpr] = ACTIONS(1996),
    [anon_sym_volatile] = ACTIONS(1996),
    [anon_sym_restrict] = ACTIONS(1996),
    [anon_sym___restrict__] = ACTIONS(1996),
    [anon_sym__Atomic] = ACTIONS(1996),
    [anon_sym__Noreturn] = ACTIONS(1996),
    [anon_sym_noreturn] = ACTIONS(1996),
    [anon_sym_mutable] = ACTIONS(1996),
    [anon_sym_constinit] = ACTIONS(1996),
    [anon_sym_consteval] = ACTIONS(1996),
    [anon_sym___shared__] = ACTIONS(1996),
    [anon_sym___local__] = ACTIONS(1996),
    [anon_sym___constant__] = ACTIONS(1996),
    [anon_sym___managed__] = ACTIONS(1996),
    [anon_sym___grid_constant__] = ACTIONS(1996),
    [anon_sym_alignas] = ACTIONS(1996),
    [anon_sym__Alignas] = ACTIONS(1996),
    [sym_primitive_type] = ACTIONS(1996),
    [anon_sym_enum] = ACTIONS(1996),
    [anon_sym_class] = ACTIONS(1996),
    [anon_sym_struct] = ACTIONS(1996),
    [anon_sym_union] = ACTIONS(1996),
    [anon_sym_if] = ACTIONS(1996),
    [anon_sym_else] = ACTIONS(1996),
    [anon_sym_switch] = ACTIONS(1996),
    [anon_sym_case] = ACTIONS(1996),
    [anon_sym_default] = ACTIONS(1996),
    [anon_sym_while] = ACTIONS(1996),
    [anon_sym_do] = ACTIONS(1996),
    [anon_sym_for] = ACTIONS(1996),
    [anon_sym_return] = ACTIONS(1996),
    [anon_sym_break] = ACTIONS(1996),
    [anon_sym_continue] = ACTIONS(1996),
    [anon_sym_goto] = ACTIONS(1996),
    [anon_sym___try] = ACTIONS(1996),
    [anon_sym___leave] = ACTIONS(1996),
    [anon_sym_not] = ACTIONS(1996),
    [anon_sym_compl] = ACTIONS(1996),
    [anon_sym_DASH_DASH] = ACTIONS(1998),
    [anon_sym_PLUS_PLUS] = ACTIONS(1998),
    [anon_sym_sizeof] = ACTIONS(1996),
    [anon_sym___alignof__] = ACTIONS(1996),
    [anon_sym___alignof] = ACTIONS(1996),
    [anon_sym__alignof] = ACTIONS(1996),
    [anon_sym_alignof] = ACTIONS(1996),
    [anon_sym__Alignof] = ACTIONS(1996),
    [anon_sym_offsetof] = ACTIONS(1996),
    [anon_sym__Generic] = ACTIONS(1996),
    [anon_sym_asm] = ACTIONS(1996),
    [anon_sym___asm__] = ACTIONS(1996),
    [sym_number_literal] = ACTIONS(1998),
    [anon_sym_L_SQUOTE] = ACTIONS(1998),
    [anon_sym_u_SQUOTE] = ACTIONS(1998),
    [anon_sym_U_SQUOTE] = ACTIONS(1998),
    [anon_sym_u8_SQUOTE] = ACTIONS(1998),
    [anon_sym_SQUOTE] = ACTIONS(1998),
    [anon_sym_L_DQUOTE] = ACTIONS(1998),
    [anon_sym_u_DQUOTE] = ACTIONS(1998),
    [anon_sym_U_DQUOTE] = ACTIONS(1998),
    [anon_sym_u8_DQUOTE] = ACTIONS(1998),
    [anon_sym_DQUOTE] = ACTIONS(1998),
    [sym_true] = ACTIONS(1996),
    [sym_false] = ACTIONS(1996),
    [anon_sym_NULL] = ACTIONS(1996),
    [anon_sym_nullptr] = ACTIONS(1996),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1996),
    [anon_sym_decltype] = ACTIONS(1996),
    [sym_virtual] = ACTIONS(1996),
    [anon_sym_explicit] = ACTIONS(1996),
    [anon_sym_typename] = ACTIONS(1996),
    [anon_sym_template] = ACTIONS(1996),
    [anon_sym_operator] = ACTIONS(1996),
    [anon_sym_try] = ACTIONS(1996),
    [anon_sym_delete] = ACTIONS(1996),
    [anon_sym_throw] = ACTIONS(1996),
    [anon_sym_namespace] = ACTIONS(1996),
    [anon_sym_using] = ACTIONS(1996),
    [anon_sym_static_assert] = ACTIONS(1996),
    [anon_sym_concept] = ACTIONS(1996),
    [anon_sym_co_return] = ACTIONS(1996),
    [anon_sym_co_yield] = ACTIONS(1996),
    [anon_sym_R_DQUOTE] = ACTIONS(1998),
    [anon_sym_LR_DQUOTE] = ACTIONS(1998),
    [anon_sym_uR_DQUOTE] = ACTIONS(1998),
    [anon_sym_UR_DQUOTE] = ACTIONS(1998),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1998),
    [anon_sym_co_await] = ACTIONS(1996),
    [anon_sym_new] = ACTIONS(1996),
    [anon_sym_requires] = ACTIONS(1996),
    [sym_this] = ACTIONS(1996),
    [anon_sym___launch_bounds__] = ACTIONS(1996),
  },
  [375] = {
    [sym_identifier] = ACTIONS(2040),
    [aux_sym_preproc_include_token1] = ACTIONS(2040),
    [aux_sym_preproc_def_token1] = ACTIONS(2040),
    [aux_sym_preproc_if_token1] = ACTIONS(2040),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2040),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2040),
    [sym_preproc_directive] = ACTIONS(2040),
    [anon_sym_LPAREN2] = ACTIONS(2042),
    [anon_sym_BANG] = ACTIONS(2042),
    [anon_sym_TILDE] = ACTIONS(2042),
    [anon_sym_DASH] = ACTIONS(2040),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_STAR] = ACTIONS(2042),
    [anon_sym_AMP_AMP] = ACTIONS(2042),
    [anon_sym_AMP] = ACTIONS(2040),
    [anon_sym_SEMI] = ACTIONS(2042),
    [anon_sym___extension__] = ACTIONS(2040),
    [anon_sym_typedef] = ACTIONS(2040),
    [anon_sym___device__] = ACTIONS(2040),
    [anon_sym___host__] = ACTIONS(2040),
    [anon_sym___global__] = ACTIONS(2040),
    [anon_sym___forceinline__] = ACTIONS(2040),
    [anon_sym___noinline__] = ACTIONS(2040),
    [anon_sym_extern] = ACTIONS(2040),
    [anon_sym___attribute__] = ACTIONS(2040),
    [anon_sym_COLON_COLON] = ACTIONS(2042),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2042),
    [anon_sym___declspec] = ACTIONS(2040),
    [anon_sym___based] = ACTIONS(2040),
    [anon_sym___cdecl] = ACTIONS(2040),
    [anon_sym___clrcall] = ACTIONS(2040),
    [anon_sym___stdcall] = ACTIONS(2040),
    [anon_sym___fastcall] = ACTIONS(2040),
    [anon_sym___thiscall] = ACTIONS(2040),
    [anon_sym___vectorcall] = ACTIONS(2040),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_RBRACE] = ACTIONS(2042),
    [anon_sym_signed] = ACTIONS(2040),
    [anon_sym_unsigned] = ACTIONS(2040),
    [anon_sym_long] = ACTIONS(2040),
    [anon_sym_short] = ACTIONS(2040),
    [anon_sym_LBRACK] = ACTIONS(2040),
    [anon_sym_static] = ACTIONS(2040),
    [anon_sym_register] = ACTIONS(2040),
    [anon_sym_inline] = ACTIONS(2040),
    [anon_sym___inline] = ACTIONS(2040),
    [anon_sym___inline__] = ACTIONS(2040),
    [anon_sym___forceinline] = ACTIONS(2040),
    [anon_sym_thread_local] = ACTIONS(2040),
    [anon_sym___thread] = ACTIONS(2040),
    [anon_sym_const] = ACTIONS(2040),
    [anon_sym_constexpr] = ACTIONS(2040),
    [anon_sym_volatile] = ACTIONS(2040),
    [anon_sym_restrict] = ACTIONS(2040),
    [anon_sym___restrict__] = ACTIONS(2040),
    [anon_sym__Atomic] = ACTIONS(2040),
    [anon_sym__Noreturn] = ACTIONS(2040),
    [anon_sym_noreturn] = ACTIONS(2040),
    [anon_sym_mutable] = ACTIONS(2040),
    [anon_sym_constinit] = ACTIONS(2040),
    [anon_sym_consteval] = ACTIONS(2040),
    [anon_sym___shared__] = ACTIONS(2040),
    [anon_sym___local__] = ACTIONS(2040),
    [anon_sym___constant__] = ACTIONS(2040),
    [anon_sym___managed__] = ACTIONS(2040),
    [anon_sym___grid_constant__] = ACTIONS(2040),
    [anon_sym_alignas] = ACTIONS(2040),
    [anon_sym__Alignas] = ACTIONS(2040),
    [sym_primitive_type] = ACTIONS(2040),
    [anon_sym_enum] = ACTIONS(2040),
    [anon_sym_class] = ACTIONS(2040),
    [anon_sym_struct] = ACTIONS(2040),
    [anon_sym_union] = ACTIONS(2040),
    [anon_sym_if] = ACTIONS(2040),
    [anon_sym_else] = ACTIONS(2040),
    [anon_sym_switch] = ACTIONS(2040),
    [anon_sym_case] = ACTIONS(2040),
    [anon_sym_default] = ACTIONS(2040),
    [anon_sym_while] = ACTIONS(2040),
    [anon_sym_do] = ACTIONS(2040),
    [anon_sym_for] = ACTIONS(2040),
    [anon_sym_return] = ACTIONS(2040),
    [anon_sym_break] = ACTIONS(2040),
    [anon_sym_continue] = ACTIONS(2040),
    [anon_sym_goto] = ACTIONS(2040),
    [anon_sym___try] = ACTIONS(2040),
    [anon_sym___leave] = ACTIONS(2040),
    [anon_sym_not] = ACTIONS(2040),
    [anon_sym_compl] = ACTIONS(2040),
    [anon_sym_DASH_DASH] = ACTIONS(2042),
    [anon_sym_PLUS_PLUS] = ACTIONS(2042),
    [anon_sym_sizeof] = ACTIONS(2040),
    [anon_sym___alignof__] = ACTIONS(2040),
    [anon_sym___alignof] = ACTIONS(2040),
    [anon_sym__alignof] = ACTIONS(2040),
    [anon_sym_alignof] = ACTIONS(2040),
    [anon_sym__Alignof] = ACTIONS(2040),
    [anon_sym_offsetof] = ACTIONS(2040),
    [anon_sym__Generic] = ACTIONS(2040),
    [anon_sym_asm] = ACTIONS(2040),
    [anon_sym___asm__] = ACTIONS(2040),
    [sym_number_literal] = ACTIONS(2042),
    [anon_sym_L_SQUOTE] = ACTIONS(2042),
    [anon_sym_u_SQUOTE] = ACTIONS(2042),
    [anon_sym_U_SQUOTE] = ACTIONS(2042),
    [anon_sym_u8_SQUOTE] = ACTIONS(2042),
    [anon_sym_SQUOTE] = ACTIONS(2042),
    [anon_sym_L_DQUOTE] = ACTIONS(2042),
    [anon_sym_u_DQUOTE] = ACTIONS(2042),
    [anon_sym_U_DQUOTE] = ACTIONS(2042),
    [anon_sym_u8_DQUOTE] = ACTIONS(2042),
    [anon_sym_DQUOTE] = ACTIONS(2042),
    [sym_true] = ACTIONS(2040),
    [sym_false] = ACTIONS(2040),
    [anon_sym_NULL] = ACTIONS(2040),
    [anon_sym_nullptr] = ACTIONS(2040),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2040),
    [anon_sym_decltype] = ACTIONS(2040),
    [sym_virtual] = ACTIONS(2040),
    [anon_sym_explicit] = ACTIONS(2040),
    [anon_sym_typename] = ACTIONS(2040),
    [anon_sym_template] = ACTIONS(2040),
    [anon_sym_operator] = ACTIONS(2040),
    [anon_sym_try] = ACTIONS(2040),
    [anon_sym_delete] = ACTIONS(2040),
    [anon_sym_throw] = ACTIONS(2040),
    [anon_sym_namespace] = ACTIONS(2040),
    [anon_sym_using] = ACTIONS(2040),
    [anon_sym_static_assert] = ACTIONS(2040),
    [anon_sym_concept] = ACTIONS(2040),
    [anon_sym_co_return] = ACTIONS(2040),
    [anon_sym_co_yield] = ACTIONS(2040),
    [anon_sym_R_DQUOTE] = ACTIONS(2042),
    [anon_sym_LR_DQUOTE] = ACTIONS(2042),
    [anon_sym_uR_DQUOTE] = ACTIONS(2042),
    [anon_sym_UR_DQUOTE] = ACTIONS(2042),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2042),
    [anon_sym_co_await] = ACTIONS(2040),
    [anon_sym_new] = ACTIONS(2040),
    [anon_sym_requires] = ACTIONS(2040),
    [sym_this] = ACTIONS(2040),
    [anon_sym___launch_bounds__] = ACTIONS(2040),
  },
  [376] = {
    [sym_identifier] = ACTIONS(2044),
    [aux_sym_preproc_include_token1] = ACTIONS(2044),
    [aux_sym_preproc_def_token1] = ACTIONS(2044),
    [aux_sym_preproc_if_token1] = ACTIONS(2044),
    [aux_sym_preproc_if_token2] = ACTIONS(2044),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2044),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2044),
    [sym_preproc_directive] = ACTIONS(2044),
    [anon_sym_LPAREN2] = ACTIONS(2046),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2044),
    [anon_sym_PLUS] = ACTIONS(2044),
    [anon_sym_STAR] = ACTIONS(2046),
    [anon_sym_AMP_AMP] = ACTIONS(2046),
    [anon_sym_AMP] = ACTIONS(2044),
    [anon_sym_SEMI] = ACTIONS(2046),
    [anon_sym___extension__] = ACTIONS(2044),
    [anon_sym_typedef] = ACTIONS(2044),
    [anon_sym___device__] = ACTIONS(2044),
    [anon_sym___host__] = ACTIONS(2044),
    [anon_sym___global__] = ACTIONS(2044),
    [anon_sym___forceinline__] = ACTIONS(2044),
    [anon_sym___noinline__] = ACTIONS(2044),
    [anon_sym_extern] = ACTIONS(2044),
    [anon_sym___attribute__] = ACTIONS(2044),
    [anon_sym_COLON_COLON] = ACTIONS(2046),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2046),
    [anon_sym___declspec] = ACTIONS(2044),
    [anon_sym___based] = ACTIONS(2044),
    [anon_sym___cdecl] = ACTIONS(2044),
    [anon_sym___clrcall] = ACTIONS(2044),
    [anon_sym___stdcall] = ACTIONS(2044),
    [anon_sym___fastcall] = ACTIONS(2044),
    [anon_sym___thiscall] = ACTIONS(2044),
    [anon_sym___vectorcall] = ACTIONS(2044),
    [anon_sym_LBRACE] = ACTIONS(2046),
    [anon_sym_signed] = ACTIONS(2044),
    [anon_sym_unsigned] = ACTIONS(2044),
    [anon_sym_long] = ACTIONS(2044),
    [anon_sym_short] = ACTIONS(2044),
    [anon_sym_LBRACK] = ACTIONS(2044),
    [anon_sym_static] = ACTIONS(2044),
    [anon_sym_register] = ACTIONS(2044),
    [anon_sym_inline] = ACTIONS(2044),
    [anon_sym___inline] = ACTIONS(2044),
    [anon_sym___inline__] = ACTIONS(2044),
    [anon_sym___forceinline] = ACTIONS(2044),
    [anon_sym_thread_local] = ACTIONS(2044),
    [anon_sym___thread] = ACTIONS(2044),
    [anon_sym_const] = ACTIONS(2044),
    [anon_sym_constexpr] = ACTIONS(2044),
    [anon_sym_volatile] = ACTIONS(2044),
    [anon_sym_restrict] = ACTIONS(2044),
    [anon_sym___restrict__] = ACTIONS(2044),
    [anon_sym__Atomic] = ACTIONS(2044),
    [anon_sym__Noreturn] = ACTIONS(2044),
    [anon_sym_noreturn] = ACTIONS(2044),
    [anon_sym_mutable] = ACTIONS(2044),
    [anon_sym_constinit] = ACTIONS(2044),
    [anon_sym_consteval] = ACTIONS(2044),
    [anon_sym___shared__] = ACTIONS(2044),
    [anon_sym___local__] = ACTIONS(2044),
    [anon_sym___constant__] = ACTIONS(2044),
    [anon_sym___managed__] = ACTIONS(2044),
    [anon_sym___grid_constant__] = ACTIONS(2044),
    [anon_sym_alignas] = ACTIONS(2044),
    [anon_sym__Alignas] = ACTIONS(2044),
    [sym_primitive_type] = ACTIONS(2044),
    [anon_sym_enum] = ACTIONS(2044),
    [anon_sym_class] = ACTIONS(2044),
    [anon_sym_struct] = ACTIONS(2044),
    [anon_sym_union] = ACTIONS(2044),
    [anon_sym_if] = ACTIONS(2044),
    [anon_sym_else] = ACTIONS(2044),
    [anon_sym_switch] = ACTIONS(2044),
    [anon_sym_case] = ACTIONS(2044),
    [anon_sym_default] = ACTIONS(2044),
    [anon_sym_while] = ACTIONS(2044),
    [anon_sym_do] = ACTIONS(2044),
    [anon_sym_for] = ACTIONS(2044),
    [anon_sym_return] = ACTIONS(2044),
    [anon_sym_break] = ACTIONS(2044),
    [anon_sym_continue] = ACTIONS(2044),
    [anon_sym_goto] = ACTIONS(2044),
    [anon_sym___try] = ACTIONS(2044),
    [anon_sym___leave] = ACTIONS(2044),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_compl] = ACTIONS(2044),
    [anon_sym_DASH_DASH] = ACTIONS(2046),
    [anon_sym_PLUS_PLUS] = ACTIONS(2046),
    [anon_sym_sizeof] = ACTIONS(2044),
    [anon_sym___alignof__] = ACTIONS(2044),
    [anon_sym___alignof] = ACTIONS(2044),
    [anon_sym__alignof] = ACTIONS(2044),
    [anon_sym_alignof] = ACTIONS(2044),
    [anon_sym__Alignof] = ACTIONS(2044),
    [anon_sym_offsetof] = ACTIONS(2044),
    [anon_sym__Generic] = ACTIONS(2044),
    [anon_sym_asm] = ACTIONS(2044),
    [anon_sym___asm__] = ACTIONS(2044),
    [sym_number_literal] = ACTIONS(2046),
    [anon_sym_L_SQUOTE] = ACTIONS(2046),
    [anon_sym_u_SQUOTE] = ACTIONS(2046),
    [anon_sym_U_SQUOTE] = ACTIONS(2046),
    [anon_sym_u8_SQUOTE] = ACTIONS(2046),
    [anon_sym_SQUOTE] = ACTIONS(2046),
    [anon_sym_L_DQUOTE] = ACTIONS(2046),
    [anon_sym_u_DQUOTE] = ACTIONS(2046),
    [anon_sym_U_DQUOTE] = ACTIONS(2046),
    [anon_sym_u8_DQUOTE] = ACTIONS(2046),
    [anon_sym_DQUOTE] = ACTIONS(2046),
    [sym_true] = ACTIONS(2044),
    [sym_false] = ACTIONS(2044),
    [anon_sym_NULL] = ACTIONS(2044),
    [anon_sym_nullptr] = ACTIONS(2044),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2044),
    [anon_sym_decltype] = ACTIONS(2044),
    [sym_virtual] = ACTIONS(2044),
    [anon_sym_explicit] = ACTIONS(2044),
    [anon_sym_typename] = ACTIONS(2044),
    [anon_sym_template] = ACTIONS(2044),
    [anon_sym_operator] = ACTIONS(2044),
    [anon_sym_try] = ACTIONS(2044),
    [anon_sym_delete] = ACTIONS(2044),
    [anon_sym_throw] = ACTIONS(2044),
    [anon_sym_namespace] = ACTIONS(2044),
    [anon_sym_using] = ACTIONS(2044),
    [anon_sym_static_assert] = ACTIONS(2044),
    [anon_sym_concept] = ACTIONS(2044),
    [anon_sym_co_return] = ACTIONS(2044),
    [anon_sym_co_yield] = ACTIONS(2044),
    [anon_sym_R_DQUOTE] = ACTIONS(2046),
    [anon_sym_LR_DQUOTE] = ACTIONS(2046),
    [anon_sym_uR_DQUOTE] = ACTIONS(2046),
    [anon_sym_UR_DQUOTE] = ACTIONS(2046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2046),
    [anon_sym_co_await] = ACTIONS(2044),
    [anon_sym_new] = ACTIONS(2044),
    [anon_sym_requires] = ACTIONS(2044),
    [sym_this] = ACTIONS(2044),
    [anon_sym___launch_bounds__] = ACTIONS(2044),
  },
  [377] = {
    [sym_identifier] = ACTIONS(2052),
    [aux_sym_preproc_include_token1] = ACTIONS(2052),
    [aux_sym_preproc_def_token1] = ACTIONS(2052),
    [aux_sym_preproc_if_token1] = ACTIONS(2052),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2052),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2052),
    [sym_preproc_directive] = ACTIONS(2052),
    [anon_sym_LPAREN2] = ACTIONS(2054),
    [anon_sym_BANG] = ACTIONS(2054),
    [anon_sym_TILDE] = ACTIONS(2054),
    [anon_sym_DASH] = ACTIONS(2052),
    [anon_sym_PLUS] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(2054),
    [anon_sym_AMP_AMP] = ACTIONS(2054),
    [anon_sym_AMP] = ACTIONS(2052),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym___extension__] = ACTIONS(2052),
    [anon_sym_typedef] = ACTIONS(2052),
    [anon_sym___device__] = ACTIONS(2052),
    [anon_sym___host__] = ACTIONS(2052),
    [anon_sym___global__] = ACTIONS(2052),
    [anon_sym___forceinline__] = ACTIONS(2052),
    [anon_sym___noinline__] = ACTIONS(2052),
    [anon_sym_extern] = ACTIONS(2052),
    [anon_sym___attribute__] = ACTIONS(2052),
    [anon_sym_COLON_COLON] = ACTIONS(2054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2054),
    [anon_sym___declspec] = ACTIONS(2052),
    [anon_sym___based] = ACTIONS(2052),
    [anon_sym___cdecl] = ACTIONS(2052),
    [anon_sym___clrcall] = ACTIONS(2052),
    [anon_sym___stdcall] = ACTIONS(2052),
    [anon_sym___fastcall] = ACTIONS(2052),
    [anon_sym___thiscall] = ACTIONS(2052),
    [anon_sym___vectorcall] = ACTIONS(2052),
    [anon_sym_LBRACE] = ACTIONS(2054),
    [anon_sym_RBRACE] = ACTIONS(2054),
    [anon_sym_signed] = ACTIONS(2052),
    [anon_sym_unsigned] = ACTIONS(2052),
    [anon_sym_long] = ACTIONS(2052),
    [anon_sym_short] = ACTIONS(2052),
    [anon_sym_LBRACK] = ACTIONS(2052),
    [anon_sym_static] = ACTIONS(2052),
    [anon_sym_register] = ACTIONS(2052),
    [anon_sym_inline] = ACTIONS(2052),
    [anon_sym___inline] = ACTIONS(2052),
    [anon_sym___inline__] = ACTIONS(2052),
    [anon_sym___forceinline] = ACTIONS(2052),
    [anon_sym_thread_local] = ACTIONS(2052),
    [anon_sym___thread] = ACTIONS(2052),
    [anon_sym_const] = ACTIONS(2052),
    [anon_sym_constexpr] = ACTIONS(2052),
    [anon_sym_volatile] = ACTIONS(2052),
    [anon_sym_restrict] = ACTIONS(2052),
    [anon_sym___restrict__] = ACTIONS(2052),
    [anon_sym__Atomic] = ACTIONS(2052),
    [anon_sym__Noreturn] = ACTIONS(2052),
    [anon_sym_noreturn] = ACTIONS(2052),
    [anon_sym_mutable] = ACTIONS(2052),
    [anon_sym_constinit] = ACTIONS(2052),
    [anon_sym_consteval] = ACTIONS(2052),
    [anon_sym___shared__] = ACTIONS(2052),
    [anon_sym___local__] = ACTIONS(2052),
    [anon_sym___constant__] = ACTIONS(2052),
    [anon_sym___managed__] = ACTIONS(2052),
    [anon_sym___grid_constant__] = ACTIONS(2052),
    [anon_sym_alignas] = ACTIONS(2052),
    [anon_sym__Alignas] = ACTIONS(2052),
    [sym_primitive_type] = ACTIONS(2052),
    [anon_sym_enum] = ACTIONS(2052),
    [anon_sym_class] = ACTIONS(2052),
    [anon_sym_struct] = ACTIONS(2052),
    [anon_sym_union] = ACTIONS(2052),
    [anon_sym_if] = ACTIONS(2052),
    [anon_sym_else] = ACTIONS(2052),
    [anon_sym_switch] = ACTIONS(2052),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2052),
    [anon_sym_while] = ACTIONS(2052),
    [anon_sym_do] = ACTIONS(2052),
    [anon_sym_for] = ACTIONS(2052),
    [anon_sym_return] = ACTIONS(2052),
    [anon_sym_break] = ACTIONS(2052),
    [anon_sym_continue] = ACTIONS(2052),
    [anon_sym_goto] = ACTIONS(2052),
    [anon_sym___try] = ACTIONS(2052),
    [anon_sym___leave] = ACTIONS(2052),
    [anon_sym_not] = ACTIONS(2052),
    [anon_sym_compl] = ACTIONS(2052),
    [anon_sym_DASH_DASH] = ACTIONS(2054),
    [anon_sym_PLUS_PLUS] = ACTIONS(2054),
    [anon_sym_sizeof] = ACTIONS(2052),
    [anon_sym___alignof__] = ACTIONS(2052),
    [anon_sym___alignof] = ACTIONS(2052),
    [anon_sym__alignof] = ACTIONS(2052),
    [anon_sym_alignof] = ACTIONS(2052),
    [anon_sym__Alignof] = ACTIONS(2052),
    [anon_sym_offsetof] = ACTIONS(2052),
    [anon_sym__Generic] = ACTIONS(2052),
    [anon_sym_asm] = ACTIONS(2052),
    [anon_sym___asm__] = ACTIONS(2052),
    [sym_number_literal] = ACTIONS(2054),
    [anon_sym_L_SQUOTE] = ACTIONS(2054),
    [anon_sym_u_SQUOTE] = ACTIONS(2054),
    [anon_sym_U_SQUOTE] = ACTIONS(2054),
    [anon_sym_u8_SQUOTE] = ACTIONS(2054),
    [anon_sym_SQUOTE] = ACTIONS(2054),
    [anon_sym_L_DQUOTE] = ACTIONS(2054),
    [anon_sym_u_DQUOTE] = ACTIONS(2054),
    [anon_sym_U_DQUOTE] = ACTIONS(2054),
    [anon_sym_u8_DQUOTE] = ACTIONS(2054),
    [anon_sym_DQUOTE] = ACTIONS(2054),
    [sym_true] = ACTIONS(2052),
    [sym_false] = ACTIONS(2052),
    [anon_sym_NULL] = ACTIONS(2052),
    [anon_sym_nullptr] = ACTIONS(2052),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2052),
    [anon_sym_decltype] = ACTIONS(2052),
    [sym_virtual] = ACTIONS(2052),
    [anon_sym_explicit] = ACTIONS(2052),
    [anon_sym_typename] = ACTIONS(2052),
    [anon_sym_template] = ACTIONS(2052),
    [anon_sym_operator] = ACTIONS(2052),
    [anon_sym_try] = ACTIONS(2052),
    [anon_sym_delete] = ACTIONS(2052),
    [anon_sym_throw] = ACTIONS(2052),
    [anon_sym_namespace] = ACTIONS(2052),
    [anon_sym_using] = ACTIONS(2052),
    [anon_sym_static_assert] = ACTIONS(2052),
    [anon_sym_concept] = ACTIONS(2052),
    [anon_sym_co_return] = ACTIONS(2052),
    [anon_sym_co_yield] = ACTIONS(2052),
    [anon_sym_R_DQUOTE] = ACTIONS(2054),
    [anon_sym_LR_DQUOTE] = ACTIONS(2054),
    [anon_sym_uR_DQUOTE] = ACTIONS(2054),
    [anon_sym_UR_DQUOTE] = ACTIONS(2054),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2054),
    [anon_sym_co_await] = ACTIONS(2052),
    [anon_sym_new] = ACTIONS(2052),
    [anon_sym_requires] = ACTIONS(2052),
    [sym_this] = ACTIONS(2052),
    [anon_sym___launch_bounds__] = ACTIONS(2052),
  },
  [378] = {
    [sym_identifier] = ACTIONS(2056),
    [aux_sym_preproc_include_token1] = ACTIONS(2056),
    [aux_sym_preproc_def_token1] = ACTIONS(2056),
    [aux_sym_preproc_if_token1] = ACTIONS(2056),
    [aux_sym_preproc_if_token2] = ACTIONS(2056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2056),
    [sym_preproc_directive] = ACTIONS(2056),
    [anon_sym_LPAREN2] = ACTIONS(2058),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_DASH] = ACTIONS(2056),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_STAR] = ACTIONS(2058),
    [anon_sym_AMP_AMP] = ACTIONS(2058),
    [anon_sym_AMP] = ACTIONS(2056),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_typedef] = ACTIONS(2056),
    [anon_sym___device__] = ACTIONS(2056),
    [anon_sym___host__] = ACTIONS(2056),
    [anon_sym___global__] = ACTIONS(2056),
    [anon_sym___forceinline__] = ACTIONS(2056),
    [anon_sym___noinline__] = ACTIONS(2056),
    [anon_sym_extern] = ACTIONS(2056),
    [anon_sym___attribute__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2058),
    [anon_sym___declspec] = ACTIONS(2056),
    [anon_sym___based] = ACTIONS(2056),
    [anon_sym___cdecl] = ACTIONS(2056),
    [anon_sym___clrcall] = ACTIONS(2056),
    [anon_sym___stdcall] = ACTIONS(2056),
    [anon_sym___fastcall] = ACTIONS(2056),
    [anon_sym___thiscall] = ACTIONS(2056),
    [anon_sym___vectorcall] = ACTIONS(2056),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_signed] = ACTIONS(2056),
    [anon_sym_unsigned] = ACTIONS(2056),
    [anon_sym_long] = ACTIONS(2056),
    [anon_sym_short] = ACTIONS(2056),
    [anon_sym_LBRACK] = ACTIONS(2056),
    [anon_sym_static] = ACTIONS(2056),
    [anon_sym_register] = ACTIONS(2056),
    [anon_sym_inline] = ACTIONS(2056),
    [anon_sym___inline] = ACTIONS(2056),
    [anon_sym___inline__] = ACTIONS(2056),
    [anon_sym___forceinline] = ACTIONS(2056),
    [anon_sym_thread_local] = ACTIONS(2056),
    [anon_sym___thread] = ACTIONS(2056),
    [anon_sym_const] = ACTIONS(2056),
    [anon_sym_constexpr] = ACTIONS(2056),
    [anon_sym_volatile] = ACTIONS(2056),
    [anon_sym_restrict] = ACTIONS(2056),
    [anon_sym___restrict__] = ACTIONS(2056),
    [anon_sym__Atomic] = ACTIONS(2056),
    [anon_sym__Noreturn] = ACTIONS(2056),
    [anon_sym_noreturn] = ACTIONS(2056),
    [anon_sym_mutable] = ACTIONS(2056),
    [anon_sym_constinit] = ACTIONS(2056),
    [anon_sym_consteval] = ACTIONS(2056),
    [anon_sym___shared__] = ACTIONS(2056),
    [anon_sym___local__] = ACTIONS(2056),
    [anon_sym___constant__] = ACTIONS(2056),
    [anon_sym___managed__] = ACTIONS(2056),
    [anon_sym___grid_constant__] = ACTIONS(2056),
    [anon_sym_alignas] = ACTIONS(2056),
    [anon_sym__Alignas] = ACTIONS(2056),
    [sym_primitive_type] = ACTIONS(2056),
    [anon_sym_enum] = ACTIONS(2056),
    [anon_sym_class] = ACTIONS(2056),
    [anon_sym_struct] = ACTIONS(2056),
    [anon_sym_union] = ACTIONS(2056),
    [anon_sym_if] = ACTIONS(2056),
    [anon_sym_else] = ACTIONS(2056),
    [anon_sym_switch] = ACTIONS(2056),
    [anon_sym_case] = ACTIONS(2056),
    [anon_sym_default] = ACTIONS(2056),
    [anon_sym_while] = ACTIONS(2056),
    [anon_sym_do] = ACTIONS(2056),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2056),
    [anon_sym_break] = ACTIONS(2056),
    [anon_sym_continue] = ACTIONS(2056),
    [anon_sym_goto] = ACTIONS(2056),
    [anon_sym___try] = ACTIONS(2056),
    [anon_sym___leave] = ACTIONS(2056),
    [anon_sym_not] = ACTIONS(2056),
    [anon_sym_compl] = ACTIONS(2056),
    [anon_sym_DASH_DASH] = ACTIONS(2058),
    [anon_sym_PLUS_PLUS] = ACTIONS(2058),
    [anon_sym_sizeof] = ACTIONS(2056),
    [anon_sym___alignof__] = ACTIONS(2056),
    [anon_sym___alignof] = ACTIONS(2056),
    [anon_sym__alignof] = ACTIONS(2056),
    [anon_sym_alignof] = ACTIONS(2056),
    [anon_sym__Alignof] = ACTIONS(2056),
    [anon_sym_offsetof] = ACTIONS(2056),
    [anon_sym__Generic] = ACTIONS(2056),
    [anon_sym_asm] = ACTIONS(2056),
    [anon_sym___asm__] = ACTIONS(2056),
    [sym_number_literal] = ACTIONS(2058),
    [anon_sym_L_SQUOTE] = ACTIONS(2058),
    [anon_sym_u_SQUOTE] = ACTIONS(2058),
    [anon_sym_U_SQUOTE] = ACTIONS(2058),
    [anon_sym_u8_SQUOTE] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [anon_sym_L_DQUOTE] = ACTIONS(2058),
    [anon_sym_u_DQUOTE] = ACTIONS(2058),
    [anon_sym_U_DQUOTE] = ACTIONS(2058),
    [anon_sym_u8_DQUOTE] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [sym_true] = ACTIONS(2056),
    [sym_false] = ACTIONS(2056),
    [anon_sym_NULL] = ACTIONS(2056),
    [anon_sym_nullptr] = ACTIONS(2056),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2056),
    [anon_sym_decltype] = ACTIONS(2056),
    [sym_virtual] = ACTIONS(2056),
    [anon_sym_explicit] = ACTIONS(2056),
    [anon_sym_typename] = ACTIONS(2056),
    [anon_sym_template] = ACTIONS(2056),
    [anon_sym_operator] = ACTIONS(2056),
    [anon_sym_try] = ACTIONS(2056),
    [anon_sym_delete] = ACTIONS(2056),
    [anon_sym_throw] = ACTIONS(2056),
    [anon_sym_namespace] = ACTIONS(2056),
    [anon_sym_using] = ACTIONS(2056),
    [anon_sym_static_assert] = ACTIONS(2056),
    [anon_sym_concept] = ACTIONS(2056),
    [anon_sym_co_return] = ACTIONS(2056),
    [anon_sym_co_yield] = ACTIONS(2056),
    [anon_sym_R_DQUOTE] = ACTIONS(2058),
    [anon_sym_LR_DQUOTE] = ACTIONS(2058),
    [anon_sym_uR_DQUOTE] = ACTIONS(2058),
    [anon_sym_UR_DQUOTE] = ACTIONS(2058),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2058),
    [anon_sym_co_await] = ACTIONS(2056),
    [anon_sym_new] = ACTIONS(2056),
    [anon_sym_requires] = ACTIONS(2056),
    [sym_this] = ACTIONS(2056),
    [anon_sym___launch_bounds__] = ACTIONS(2056),
  },
  [379] = {
    [sym_identifier] = ACTIONS(2036),
    [aux_sym_preproc_include_token1] = ACTIONS(2036),
    [aux_sym_preproc_def_token1] = ACTIONS(2036),
    [aux_sym_preproc_if_token1] = ACTIONS(2036),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2036),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2036),
    [sym_preproc_directive] = ACTIONS(2036),
    [anon_sym_LPAREN2] = ACTIONS(2038),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2038),
    [anon_sym_DASH] = ACTIONS(2036),
    [anon_sym_PLUS] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(2038),
    [anon_sym_AMP_AMP] = ACTIONS(2038),
    [anon_sym_AMP] = ACTIONS(2036),
    [anon_sym_SEMI] = ACTIONS(2038),
    [anon_sym___extension__] = ACTIONS(2036),
    [anon_sym_typedef] = ACTIONS(2036),
    [anon_sym___device__] = ACTIONS(2036),
    [anon_sym___host__] = ACTIONS(2036),
    [anon_sym___global__] = ACTIONS(2036),
    [anon_sym___forceinline__] = ACTIONS(2036),
    [anon_sym___noinline__] = ACTIONS(2036),
    [anon_sym_extern] = ACTIONS(2036),
    [anon_sym___attribute__] = ACTIONS(2036),
    [anon_sym_COLON_COLON] = ACTIONS(2038),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2038),
    [anon_sym___declspec] = ACTIONS(2036),
    [anon_sym___based] = ACTIONS(2036),
    [anon_sym___cdecl] = ACTIONS(2036),
    [anon_sym___clrcall] = ACTIONS(2036),
    [anon_sym___stdcall] = ACTIONS(2036),
    [anon_sym___fastcall] = ACTIONS(2036),
    [anon_sym___thiscall] = ACTIONS(2036),
    [anon_sym___vectorcall] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2038),
    [anon_sym_RBRACE] = ACTIONS(2038),
    [anon_sym_signed] = ACTIONS(2036),
    [anon_sym_unsigned] = ACTIONS(2036),
    [anon_sym_long] = ACTIONS(2036),
    [anon_sym_short] = ACTIONS(2036),
    [anon_sym_LBRACK] = ACTIONS(2036),
    [anon_sym_static] = ACTIONS(2036),
    [anon_sym_register] = ACTIONS(2036),
    [anon_sym_inline] = ACTIONS(2036),
    [anon_sym___inline] = ACTIONS(2036),
    [anon_sym___inline__] = ACTIONS(2036),
    [anon_sym___forceinline] = ACTIONS(2036),
    [anon_sym_thread_local] = ACTIONS(2036),
    [anon_sym___thread] = ACTIONS(2036),
    [anon_sym_const] = ACTIONS(2036),
    [anon_sym_constexpr] = ACTIONS(2036),
    [anon_sym_volatile] = ACTIONS(2036),
    [anon_sym_restrict] = ACTIONS(2036),
    [anon_sym___restrict__] = ACTIONS(2036),
    [anon_sym__Atomic] = ACTIONS(2036),
    [anon_sym__Noreturn] = ACTIONS(2036),
    [anon_sym_noreturn] = ACTIONS(2036),
    [anon_sym_mutable] = ACTIONS(2036),
    [anon_sym_constinit] = ACTIONS(2036),
    [anon_sym_consteval] = ACTIONS(2036),
    [anon_sym___shared__] = ACTIONS(2036),
    [anon_sym___local__] = ACTIONS(2036),
    [anon_sym___constant__] = ACTIONS(2036),
    [anon_sym___managed__] = ACTIONS(2036),
    [anon_sym___grid_constant__] = ACTIONS(2036),
    [anon_sym_alignas] = ACTIONS(2036),
    [anon_sym__Alignas] = ACTIONS(2036),
    [sym_primitive_type] = ACTIONS(2036),
    [anon_sym_enum] = ACTIONS(2036),
    [anon_sym_class] = ACTIONS(2036),
    [anon_sym_struct] = ACTIONS(2036),
    [anon_sym_union] = ACTIONS(2036),
    [anon_sym_if] = ACTIONS(2036),
    [anon_sym_else] = ACTIONS(2036),
    [anon_sym_switch] = ACTIONS(2036),
    [anon_sym_case] = ACTIONS(2036),
    [anon_sym_default] = ACTIONS(2036),
    [anon_sym_while] = ACTIONS(2036),
    [anon_sym_do] = ACTIONS(2036),
    [anon_sym_for] = ACTIONS(2036),
    [anon_sym_return] = ACTIONS(2036),
    [anon_sym_break] = ACTIONS(2036),
    [anon_sym_continue] = ACTIONS(2036),
    [anon_sym_goto] = ACTIONS(2036),
    [anon_sym___try] = ACTIONS(2036),
    [anon_sym___leave] = ACTIONS(2036),
    [anon_sym_not] = ACTIONS(2036),
    [anon_sym_compl] = ACTIONS(2036),
    [anon_sym_DASH_DASH] = ACTIONS(2038),
    [anon_sym_PLUS_PLUS] = ACTIONS(2038),
    [anon_sym_sizeof] = ACTIONS(2036),
    [anon_sym___alignof__] = ACTIONS(2036),
    [anon_sym___alignof] = ACTIONS(2036),
    [anon_sym__alignof] = ACTIONS(2036),
    [anon_sym_alignof] = ACTIONS(2036),
    [anon_sym__Alignof] = ACTIONS(2036),
    [anon_sym_offsetof] = ACTIONS(2036),
    [anon_sym__Generic] = ACTIONS(2036),
    [anon_sym_asm] = ACTIONS(2036),
    [anon_sym___asm__] = ACTIONS(2036),
    [sym_number_literal] = ACTIONS(2038),
    [anon_sym_L_SQUOTE] = ACTIONS(2038),
    [anon_sym_u_SQUOTE] = ACTIONS(2038),
    [anon_sym_U_SQUOTE] = ACTIONS(2038),
    [anon_sym_u8_SQUOTE] = ACTIONS(2038),
    [anon_sym_SQUOTE] = ACTIONS(2038),
    [anon_sym_L_DQUOTE] = ACTIONS(2038),
    [anon_sym_u_DQUOTE] = ACTIONS(2038),
    [anon_sym_U_DQUOTE] = ACTIONS(2038),
    [anon_sym_u8_DQUOTE] = ACTIONS(2038),
    [anon_sym_DQUOTE] = ACTIONS(2038),
    [sym_true] = ACTIONS(2036),
    [sym_false] = ACTIONS(2036),
    [anon_sym_NULL] = ACTIONS(2036),
    [anon_sym_nullptr] = ACTIONS(2036),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2036),
    [anon_sym_decltype] = ACTIONS(2036),
    [sym_virtual] = ACTIONS(2036),
    [anon_sym_explicit] = ACTIONS(2036),
    [anon_sym_typename] = ACTIONS(2036),
    [anon_sym_template] = ACTIONS(2036),
    [anon_sym_operator] = ACTIONS(2036),
    [anon_sym_try] = ACTIONS(2036),
    [anon_sym_delete] = ACTIONS(2036),
    [anon_sym_throw] = ACTIONS(2036),
    [anon_sym_namespace] = ACTIONS(2036),
    [anon_sym_using] = ACTIONS(2036),
    [anon_sym_static_assert] = ACTIONS(2036),
    [anon_sym_concept] = ACTIONS(2036),
    [anon_sym_co_return] = ACTIONS(2036),
    [anon_sym_co_yield] = ACTIONS(2036),
    [anon_sym_R_DQUOTE] = ACTIONS(2038),
    [anon_sym_LR_DQUOTE] = ACTIONS(2038),
    [anon_sym_uR_DQUOTE] = ACTIONS(2038),
    [anon_sym_UR_DQUOTE] = ACTIONS(2038),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2038),
    [anon_sym_co_await] = ACTIONS(2036),
    [anon_sym_new] = ACTIONS(2036),
    [anon_sym_requires] = ACTIONS(2036),
    [sym_this] = ACTIONS(2036),
    [anon_sym___launch_bounds__] = ACTIONS(2036),
  },
  [380] = {
    [ts_builtin_sym_end] = ACTIONS(2038),
    [sym_identifier] = ACTIONS(2036),
    [aux_sym_preproc_include_token1] = ACTIONS(2036),
    [aux_sym_preproc_def_token1] = ACTIONS(2036),
    [aux_sym_preproc_if_token1] = ACTIONS(2036),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2036),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2036),
    [sym_preproc_directive] = ACTIONS(2036),
    [anon_sym_LPAREN2] = ACTIONS(2038),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2038),
    [anon_sym_DASH] = ACTIONS(2036),
    [anon_sym_PLUS] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(2038),
    [anon_sym_AMP_AMP] = ACTIONS(2038),
    [anon_sym_AMP] = ACTIONS(2036),
    [anon_sym_SEMI] = ACTIONS(2038),
    [anon_sym___extension__] = ACTIONS(2036),
    [anon_sym_typedef] = ACTIONS(2036),
    [anon_sym___device__] = ACTIONS(2036),
    [anon_sym___host__] = ACTIONS(2036),
    [anon_sym___global__] = ACTIONS(2036),
    [anon_sym___forceinline__] = ACTIONS(2036),
    [anon_sym___noinline__] = ACTIONS(2036),
    [anon_sym_extern] = ACTIONS(2036),
    [anon_sym___attribute__] = ACTIONS(2036),
    [anon_sym_COLON_COLON] = ACTIONS(2038),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2038),
    [anon_sym___declspec] = ACTIONS(2036),
    [anon_sym___based] = ACTIONS(2036),
    [anon_sym___cdecl] = ACTIONS(2036),
    [anon_sym___clrcall] = ACTIONS(2036),
    [anon_sym___stdcall] = ACTIONS(2036),
    [anon_sym___fastcall] = ACTIONS(2036),
    [anon_sym___thiscall] = ACTIONS(2036),
    [anon_sym___vectorcall] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2038),
    [anon_sym_signed] = ACTIONS(2036),
    [anon_sym_unsigned] = ACTIONS(2036),
    [anon_sym_long] = ACTIONS(2036),
    [anon_sym_short] = ACTIONS(2036),
    [anon_sym_LBRACK] = ACTIONS(2036),
    [anon_sym_static] = ACTIONS(2036),
    [anon_sym_register] = ACTIONS(2036),
    [anon_sym_inline] = ACTIONS(2036),
    [anon_sym___inline] = ACTIONS(2036),
    [anon_sym___inline__] = ACTIONS(2036),
    [anon_sym___forceinline] = ACTIONS(2036),
    [anon_sym_thread_local] = ACTIONS(2036),
    [anon_sym___thread] = ACTIONS(2036),
    [anon_sym_const] = ACTIONS(2036),
    [anon_sym_constexpr] = ACTIONS(2036),
    [anon_sym_volatile] = ACTIONS(2036),
    [anon_sym_restrict] = ACTIONS(2036),
    [anon_sym___restrict__] = ACTIONS(2036),
    [anon_sym__Atomic] = ACTIONS(2036),
    [anon_sym__Noreturn] = ACTIONS(2036),
    [anon_sym_noreturn] = ACTIONS(2036),
    [anon_sym_mutable] = ACTIONS(2036),
    [anon_sym_constinit] = ACTIONS(2036),
    [anon_sym_consteval] = ACTIONS(2036),
    [anon_sym___shared__] = ACTIONS(2036),
    [anon_sym___local__] = ACTIONS(2036),
    [anon_sym___constant__] = ACTIONS(2036),
    [anon_sym___managed__] = ACTIONS(2036),
    [anon_sym___grid_constant__] = ACTIONS(2036),
    [anon_sym_alignas] = ACTIONS(2036),
    [anon_sym__Alignas] = ACTIONS(2036),
    [sym_primitive_type] = ACTIONS(2036),
    [anon_sym_enum] = ACTIONS(2036),
    [anon_sym_class] = ACTIONS(2036),
    [anon_sym_struct] = ACTIONS(2036),
    [anon_sym_union] = ACTIONS(2036),
    [anon_sym_if] = ACTIONS(2036),
    [anon_sym_else] = ACTIONS(2036),
    [anon_sym_switch] = ACTIONS(2036),
    [anon_sym_case] = ACTIONS(2036),
    [anon_sym_default] = ACTIONS(2036),
    [anon_sym_while] = ACTIONS(2036),
    [anon_sym_do] = ACTIONS(2036),
    [anon_sym_for] = ACTIONS(2036),
    [anon_sym_return] = ACTIONS(2036),
    [anon_sym_break] = ACTIONS(2036),
    [anon_sym_continue] = ACTIONS(2036),
    [anon_sym_goto] = ACTIONS(2036),
    [anon_sym___try] = ACTIONS(2036),
    [anon_sym___leave] = ACTIONS(2036),
    [anon_sym_not] = ACTIONS(2036),
    [anon_sym_compl] = ACTIONS(2036),
    [anon_sym_DASH_DASH] = ACTIONS(2038),
    [anon_sym_PLUS_PLUS] = ACTIONS(2038),
    [anon_sym_sizeof] = ACTIONS(2036),
    [anon_sym___alignof__] = ACTIONS(2036),
    [anon_sym___alignof] = ACTIONS(2036),
    [anon_sym__alignof] = ACTIONS(2036),
    [anon_sym_alignof] = ACTIONS(2036),
    [anon_sym__Alignof] = ACTIONS(2036),
    [anon_sym_offsetof] = ACTIONS(2036),
    [anon_sym__Generic] = ACTIONS(2036),
    [anon_sym_asm] = ACTIONS(2036),
    [anon_sym___asm__] = ACTIONS(2036),
    [sym_number_literal] = ACTIONS(2038),
    [anon_sym_L_SQUOTE] = ACTIONS(2038),
    [anon_sym_u_SQUOTE] = ACTIONS(2038),
    [anon_sym_U_SQUOTE] = ACTIONS(2038),
    [anon_sym_u8_SQUOTE] = ACTIONS(2038),
    [anon_sym_SQUOTE] = ACTIONS(2038),
    [anon_sym_L_DQUOTE] = ACTIONS(2038),
    [anon_sym_u_DQUOTE] = ACTIONS(2038),
    [anon_sym_U_DQUOTE] = ACTIONS(2038),
    [anon_sym_u8_DQUOTE] = ACTIONS(2038),
    [anon_sym_DQUOTE] = ACTIONS(2038),
    [sym_true] = ACTIONS(2036),
    [sym_false] = ACTIONS(2036),
    [anon_sym_NULL] = ACTIONS(2036),
    [anon_sym_nullptr] = ACTIONS(2036),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2036),
    [anon_sym_decltype] = ACTIONS(2036),
    [sym_virtual] = ACTIONS(2036),
    [anon_sym_explicit] = ACTIONS(2036),
    [anon_sym_typename] = ACTIONS(2036),
    [anon_sym_template] = ACTIONS(2036),
    [anon_sym_operator] = ACTIONS(2036),
    [anon_sym_try] = ACTIONS(2036),
    [anon_sym_delete] = ACTIONS(2036),
    [anon_sym_throw] = ACTIONS(2036),
    [anon_sym_namespace] = ACTIONS(2036),
    [anon_sym_using] = ACTIONS(2036),
    [anon_sym_static_assert] = ACTIONS(2036),
    [anon_sym_concept] = ACTIONS(2036),
    [anon_sym_co_return] = ACTIONS(2036),
    [anon_sym_co_yield] = ACTIONS(2036),
    [anon_sym_R_DQUOTE] = ACTIONS(2038),
    [anon_sym_LR_DQUOTE] = ACTIONS(2038),
    [anon_sym_uR_DQUOTE] = ACTIONS(2038),
    [anon_sym_UR_DQUOTE] = ACTIONS(2038),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2038),
    [anon_sym_co_await] = ACTIONS(2036),
    [anon_sym_new] = ACTIONS(2036),
    [anon_sym_requires] = ACTIONS(2036),
    [sym_this] = ACTIONS(2036),
    [anon_sym___launch_bounds__] = ACTIONS(2036),
  },
  [381] = {
    [sym_identifier] = ACTIONS(1984),
    [aux_sym_preproc_include_token1] = ACTIONS(1984),
    [aux_sym_preproc_def_token1] = ACTIONS(1984),
    [aux_sym_preproc_if_token1] = ACTIONS(1984),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1984),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1984),
    [sym_preproc_directive] = ACTIONS(1984),
    [anon_sym_LPAREN2] = ACTIONS(1986),
    [anon_sym_BANG] = ACTIONS(1986),
    [anon_sym_TILDE] = ACTIONS(1986),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_AMP_AMP] = ACTIONS(1986),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_SEMI] = ACTIONS(1986),
    [anon_sym___extension__] = ACTIONS(1984),
    [anon_sym_typedef] = ACTIONS(1984),
    [anon_sym___device__] = ACTIONS(1984),
    [anon_sym___host__] = ACTIONS(1984),
    [anon_sym___global__] = ACTIONS(1984),
    [anon_sym___forceinline__] = ACTIONS(1984),
    [anon_sym___noinline__] = ACTIONS(1984),
    [anon_sym_extern] = ACTIONS(1984),
    [anon_sym___attribute__] = ACTIONS(1984),
    [anon_sym_COLON_COLON] = ACTIONS(1986),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1986),
    [anon_sym___declspec] = ACTIONS(1984),
    [anon_sym___based] = ACTIONS(1984),
    [anon_sym___cdecl] = ACTIONS(1984),
    [anon_sym___clrcall] = ACTIONS(1984),
    [anon_sym___stdcall] = ACTIONS(1984),
    [anon_sym___fastcall] = ACTIONS(1984),
    [anon_sym___thiscall] = ACTIONS(1984),
    [anon_sym___vectorcall] = ACTIONS(1984),
    [anon_sym_LBRACE] = ACTIONS(1986),
    [anon_sym_RBRACE] = ACTIONS(1986),
    [anon_sym_signed] = ACTIONS(1984),
    [anon_sym_unsigned] = ACTIONS(1984),
    [anon_sym_long] = ACTIONS(1984),
    [anon_sym_short] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_static] = ACTIONS(1984),
    [anon_sym_register] = ACTIONS(1984),
    [anon_sym_inline] = ACTIONS(1984),
    [anon_sym___inline] = ACTIONS(1984),
    [anon_sym___inline__] = ACTIONS(1984),
    [anon_sym___forceinline] = ACTIONS(1984),
    [anon_sym_thread_local] = ACTIONS(1984),
    [anon_sym___thread] = ACTIONS(1984),
    [anon_sym_const] = ACTIONS(1984),
    [anon_sym_constexpr] = ACTIONS(1984),
    [anon_sym_volatile] = ACTIONS(1984),
    [anon_sym_restrict] = ACTIONS(1984),
    [anon_sym___restrict__] = ACTIONS(1984),
    [anon_sym__Atomic] = ACTIONS(1984),
    [anon_sym__Noreturn] = ACTIONS(1984),
    [anon_sym_noreturn] = ACTIONS(1984),
    [anon_sym_mutable] = ACTIONS(1984),
    [anon_sym_constinit] = ACTIONS(1984),
    [anon_sym_consteval] = ACTIONS(1984),
    [anon_sym___shared__] = ACTIONS(1984),
    [anon_sym___local__] = ACTIONS(1984),
    [anon_sym___constant__] = ACTIONS(1984),
    [anon_sym___managed__] = ACTIONS(1984),
    [anon_sym___grid_constant__] = ACTIONS(1984),
    [anon_sym_alignas] = ACTIONS(1984),
    [anon_sym__Alignas] = ACTIONS(1984),
    [sym_primitive_type] = ACTIONS(1984),
    [anon_sym_enum] = ACTIONS(1984),
    [anon_sym_class] = ACTIONS(1984),
    [anon_sym_struct] = ACTIONS(1984),
    [anon_sym_union] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_else] = ACTIONS(1984),
    [anon_sym_switch] = ACTIONS(1984),
    [anon_sym_case] = ACTIONS(1984),
    [anon_sym_default] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1984),
    [anon_sym_do] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_return] = ACTIONS(1984),
    [anon_sym_break] = ACTIONS(1984),
    [anon_sym_continue] = ACTIONS(1984),
    [anon_sym_goto] = ACTIONS(1984),
    [anon_sym___try] = ACTIONS(1984),
    [anon_sym___leave] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_compl] = ACTIONS(1984),
    [anon_sym_DASH_DASH] = ACTIONS(1986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1986),
    [anon_sym_sizeof] = ACTIONS(1984),
    [anon_sym___alignof__] = ACTIONS(1984),
    [anon_sym___alignof] = ACTIONS(1984),
    [anon_sym__alignof] = ACTIONS(1984),
    [anon_sym_alignof] = ACTIONS(1984),
    [anon_sym__Alignof] = ACTIONS(1984),
    [anon_sym_offsetof] = ACTIONS(1984),
    [anon_sym__Generic] = ACTIONS(1984),
    [anon_sym_asm] = ACTIONS(1984),
    [anon_sym___asm__] = ACTIONS(1984),
    [sym_number_literal] = ACTIONS(1986),
    [anon_sym_L_SQUOTE] = ACTIONS(1986),
    [anon_sym_u_SQUOTE] = ACTIONS(1986),
    [anon_sym_U_SQUOTE] = ACTIONS(1986),
    [anon_sym_u8_SQUOTE] = ACTIONS(1986),
    [anon_sym_SQUOTE] = ACTIONS(1986),
    [anon_sym_L_DQUOTE] = ACTIONS(1986),
    [anon_sym_u_DQUOTE] = ACTIONS(1986),
    [anon_sym_U_DQUOTE] = ACTIONS(1986),
    [anon_sym_u8_DQUOTE] = ACTIONS(1986),
    [anon_sym_DQUOTE] = ACTIONS(1986),
    [sym_true] = ACTIONS(1984),
    [sym_false] = ACTIONS(1984),
    [anon_sym_NULL] = ACTIONS(1984),
    [anon_sym_nullptr] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1984),
    [anon_sym_decltype] = ACTIONS(1984),
    [sym_virtual] = ACTIONS(1984),
    [anon_sym_explicit] = ACTIONS(1984),
    [anon_sym_typename] = ACTIONS(1984),
    [anon_sym_template] = ACTIONS(1984),
    [anon_sym_operator] = ACTIONS(1984),
    [anon_sym_try] = ACTIONS(1984),
    [anon_sym_delete] = ACTIONS(1984),
    [anon_sym_throw] = ACTIONS(1984),
    [anon_sym_namespace] = ACTIONS(1984),
    [anon_sym_using] = ACTIONS(1984),
    [anon_sym_static_assert] = ACTIONS(1984),
    [anon_sym_concept] = ACTIONS(1984),
    [anon_sym_co_return] = ACTIONS(1984),
    [anon_sym_co_yield] = ACTIONS(1984),
    [anon_sym_R_DQUOTE] = ACTIONS(1986),
    [anon_sym_LR_DQUOTE] = ACTIONS(1986),
    [anon_sym_uR_DQUOTE] = ACTIONS(1986),
    [anon_sym_UR_DQUOTE] = ACTIONS(1986),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1986),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1984),
    [anon_sym_requires] = ACTIONS(1984),
    [sym_this] = ACTIONS(1984),
    [anon_sym___launch_bounds__] = ACTIONS(1984),
  },
  [382] = {
    [ts_builtin_sym_end] = ACTIONS(2006),
    [sym_identifier] = ACTIONS(2004),
    [aux_sym_preproc_include_token1] = ACTIONS(2004),
    [aux_sym_preproc_def_token1] = ACTIONS(2004),
    [aux_sym_preproc_if_token1] = ACTIONS(2004),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2004),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2004),
    [sym_preproc_directive] = ACTIONS(2004),
    [anon_sym_LPAREN2] = ACTIONS(2006),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(2006),
    [anon_sym_DASH] = ACTIONS(2004),
    [anon_sym_PLUS] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(2006),
    [anon_sym_AMP_AMP] = ACTIONS(2006),
    [anon_sym_AMP] = ACTIONS(2004),
    [anon_sym_SEMI] = ACTIONS(2006),
    [anon_sym___extension__] = ACTIONS(2004),
    [anon_sym_typedef] = ACTIONS(2004),
    [anon_sym___device__] = ACTIONS(2004),
    [anon_sym___host__] = ACTIONS(2004),
    [anon_sym___global__] = ACTIONS(2004),
    [anon_sym___forceinline__] = ACTIONS(2004),
    [anon_sym___noinline__] = ACTIONS(2004),
    [anon_sym_extern] = ACTIONS(2004),
    [anon_sym___attribute__] = ACTIONS(2004),
    [anon_sym_COLON_COLON] = ACTIONS(2006),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2006),
    [anon_sym___declspec] = ACTIONS(2004),
    [anon_sym___based] = ACTIONS(2004),
    [anon_sym___cdecl] = ACTIONS(2004),
    [anon_sym___clrcall] = ACTIONS(2004),
    [anon_sym___stdcall] = ACTIONS(2004),
    [anon_sym___fastcall] = ACTIONS(2004),
    [anon_sym___thiscall] = ACTIONS(2004),
    [anon_sym___vectorcall] = ACTIONS(2004),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_signed] = ACTIONS(2004),
    [anon_sym_unsigned] = ACTIONS(2004),
    [anon_sym_long] = ACTIONS(2004),
    [anon_sym_short] = ACTIONS(2004),
    [anon_sym_LBRACK] = ACTIONS(2004),
    [anon_sym_static] = ACTIONS(2004),
    [anon_sym_register] = ACTIONS(2004),
    [anon_sym_inline] = ACTIONS(2004),
    [anon_sym___inline] = ACTIONS(2004),
    [anon_sym___inline__] = ACTIONS(2004),
    [anon_sym___forceinline] = ACTIONS(2004),
    [anon_sym_thread_local] = ACTIONS(2004),
    [anon_sym___thread] = ACTIONS(2004),
    [anon_sym_const] = ACTIONS(2004),
    [anon_sym_constexpr] = ACTIONS(2004),
    [anon_sym_volatile] = ACTIONS(2004),
    [anon_sym_restrict] = ACTIONS(2004),
    [anon_sym___restrict__] = ACTIONS(2004),
    [anon_sym__Atomic] = ACTIONS(2004),
    [anon_sym__Noreturn] = ACTIONS(2004),
    [anon_sym_noreturn] = ACTIONS(2004),
    [anon_sym_mutable] = ACTIONS(2004),
    [anon_sym_constinit] = ACTIONS(2004),
    [anon_sym_consteval] = ACTIONS(2004),
    [anon_sym___shared__] = ACTIONS(2004),
    [anon_sym___local__] = ACTIONS(2004),
    [anon_sym___constant__] = ACTIONS(2004),
    [anon_sym___managed__] = ACTIONS(2004),
    [anon_sym___grid_constant__] = ACTIONS(2004),
    [anon_sym_alignas] = ACTIONS(2004),
    [anon_sym__Alignas] = ACTIONS(2004),
    [sym_primitive_type] = ACTIONS(2004),
    [anon_sym_enum] = ACTIONS(2004),
    [anon_sym_class] = ACTIONS(2004),
    [anon_sym_struct] = ACTIONS(2004),
    [anon_sym_union] = ACTIONS(2004),
    [anon_sym_if] = ACTIONS(2004),
    [anon_sym_else] = ACTIONS(2004),
    [anon_sym_switch] = ACTIONS(2004),
    [anon_sym_case] = ACTIONS(2004),
    [anon_sym_default] = ACTIONS(2004),
    [anon_sym_while] = ACTIONS(2004),
    [anon_sym_do] = ACTIONS(2004),
    [anon_sym_for] = ACTIONS(2004),
    [anon_sym_return] = ACTIONS(2004),
    [anon_sym_break] = ACTIONS(2004),
    [anon_sym_continue] = ACTIONS(2004),
    [anon_sym_goto] = ACTIONS(2004),
    [anon_sym___try] = ACTIONS(2004),
    [anon_sym___leave] = ACTIONS(2004),
    [anon_sym_not] = ACTIONS(2004),
    [anon_sym_compl] = ACTIONS(2004),
    [anon_sym_DASH_DASH] = ACTIONS(2006),
    [anon_sym_PLUS_PLUS] = ACTIONS(2006),
    [anon_sym_sizeof] = ACTIONS(2004),
    [anon_sym___alignof__] = ACTIONS(2004),
    [anon_sym___alignof] = ACTIONS(2004),
    [anon_sym__alignof] = ACTIONS(2004),
    [anon_sym_alignof] = ACTIONS(2004),
    [anon_sym__Alignof] = ACTIONS(2004),
    [anon_sym_offsetof] = ACTIONS(2004),
    [anon_sym__Generic] = ACTIONS(2004),
    [anon_sym_asm] = ACTIONS(2004),
    [anon_sym___asm__] = ACTIONS(2004),
    [sym_number_literal] = ACTIONS(2006),
    [anon_sym_L_SQUOTE] = ACTIONS(2006),
    [anon_sym_u_SQUOTE] = ACTIONS(2006),
    [anon_sym_U_SQUOTE] = ACTIONS(2006),
    [anon_sym_u8_SQUOTE] = ACTIONS(2006),
    [anon_sym_SQUOTE] = ACTIONS(2006),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(2004),
    [sym_false] = ACTIONS(2004),
    [anon_sym_NULL] = ACTIONS(2004),
    [anon_sym_nullptr] = ACTIONS(2004),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2004),
    [anon_sym_decltype] = ACTIONS(2004),
    [sym_virtual] = ACTIONS(2004),
    [anon_sym_explicit] = ACTIONS(2004),
    [anon_sym_typename] = ACTIONS(2004),
    [anon_sym_template] = ACTIONS(2004),
    [anon_sym_operator] = ACTIONS(2004),
    [anon_sym_try] = ACTIONS(2004),
    [anon_sym_delete] = ACTIONS(2004),
    [anon_sym_throw] = ACTIONS(2004),
    [anon_sym_namespace] = ACTIONS(2004),
    [anon_sym_using] = ACTIONS(2004),
    [anon_sym_static_assert] = ACTIONS(2004),
    [anon_sym_concept] = ACTIONS(2004),
    [anon_sym_co_return] = ACTIONS(2004),
    [anon_sym_co_yield] = ACTIONS(2004),
    [anon_sym_R_DQUOTE] = ACTIONS(2006),
    [anon_sym_LR_DQUOTE] = ACTIONS(2006),
    [anon_sym_uR_DQUOTE] = ACTIONS(2006),
    [anon_sym_UR_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2006),
    [anon_sym_co_await] = ACTIONS(2004),
    [anon_sym_new] = ACTIONS(2004),
    [anon_sym_requires] = ACTIONS(2004),
    [sym_this] = ACTIONS(2004),
    [anon_sym___launch_bounds__] = ACTIONS(2004),
  },
  [383] = {
    [sym_identifier] = ACTIONS(2048),
    [aux_sym_preproc_include_token1] = ACTIONS(2048),
    [aux_sym_preproc_def_token1] = ACTIONS(2048),
    [aux_sym_preproc_if_token1] = ACTIONS(2048),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2048),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2048),
    [sym_preproc_directive] = ACTIONS(2048),
    [anon_sym_LPAREN2] = ACTIONS(2050),
    [anon_sym_BANG] = ACTIONS(2050),
    [anon_sym_TILDE] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2048),
    [anon_sym_PLUS] = ACTIONS(2048),
    [anon_sym_STAR] = ACTIONS(2050),
    [anon_sym_AMP_AMP] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2048),
    [anon_sym_SEMI] = ACTIONS(2050),
    [anon_sym___extension__] = ACTIONS(2048),
    [anon_sym_typedef] = ACTIONS(2048),
    [anon_sym___device__] = ACTIONS(2048),
    [anon_sym___host__] = ACTIONS(2048),
    [anon_sym___global__] = ACTIONS(2048),
    [anon_sym___forceinline__] = ACTIONS(2048),
    [anon_sym___noinline__] = ACTIONS(2048),
    [anon_sym_extern] = ACTIONS(2048),
    [anon_sym___attribute__] = ACTIONS(2048),
    [anon_sym_COLON_COLON] = ACTIONS(2050),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2050),
    [anon_sym___declspec] = ACTIONS(2048),
    [anon_sym___based] = ACTIONS(2048),
    [anon_sym___cdecl] = ACTIONS(2048),
    [anon_sym___clrcall] = ACTIONS(2048),
    [anon_sym___stdcall] = ACTIONS(2048),
    [anon_sym___fastcall] = ACTIONS(2048),
    [anon_sym___thiscall] = ACTIONS(2048),
    [anon_sym___vectorcall] = ACTIONS(2048),
    [anon_sym_LBRACE] = ACTIONS(2050),
    [anon_sym_RBRACE] = ACTIONS(2050),
    [anon_sym_signed] = ACTIONS(2048),
    [anon_sym_unsigned] = ACTIONS(2048),
    [anon_sym_long] = ACTIONS(2048),
    [anon_sym_short] = ACTIONS(2048),
    [anon_sym_LBRACK] = ACTIONS(2048),
    [anon_sym_static] = ACTIONS(2048),
    [anon_sym_register] = ACTIONS(2048),
    [anon_sym_inline] = ACTIONS(2048),
    [anon_sym___inline] = ACTIONS(2048),
    [anon_sym___inline__] = ACTIONS(2048),
    [anon_sym___forceinline] = ACTIONS(2048),
    [anon_sym_thread_local] = ACTIONS(2048),
    [anon_sym___thread] = ACTIONS(2048),
    [anon_sym_const] = ACTIONS(2048),
    [anon_sym_constexpr] = ACTIONS(2048),
    [anon_sym_volatile] = ACTIONS(2048),
    [anon_sym_restrict] = ACTIONS(2048),
    [anon_sym___restrict__] = ACTIONS(2048),
    [anon_sym__Atomic] = ACTIONS(2048),
    [anon_sym__Noreturn] = ACTIONS(2048),
    [anon_sym_noreturn] = ACTIONS(2048),
    [anon_sym_mutable] = ACTIONS(2048),
    [anon_sym_constinit] = ACTIONS(2048),
    [anon_sym_consteval] = ACTIONS(2048),
    [anon_sym___shared__] = ACTIONS(2048),
    [anon_sym___local__] = ACTIONS(2048),
    [anon_sym___constant__] = ACTIONS(2048),
    [anon_sym___managed__] = ACTIONS(2048),
    [anon_sym___grid_constant__] = ACTIONS(2048),
    [anon_sym_alignas] = ACTIONS(2048),
    [anon_sym__Alignas] = ACTIONS(2048),
    [sym_primitive_type] = ACTIONS(2048),
    [anon_sym_enum] = ACTIONS(2048),
    [anon_sym_class] = ACTIONS(2048),
    [anon_sym_struct] = ACTIONS(2048),
    [anon_sym_union] = ACTIONS(2048),
    [anon_sym_if] = ACTIONS(2048),
    [anon_sym_else] = ACTIONS(2048),
    [anon_sym_switch] = ACTIONS(2048),
    [anon_sym_case] = ACTIONS(2048),
    [anon_sym_default] = ACTIONS(2048),
    [anon_sym_while] = ACTIONS(2048),
    [anon_sym_do] = ACTIONS(2048),
    [anon_sym_for] = ACTIONS(2048),
    [anon_sym_return] = ACTIONS(2048),
    [anon_sym_break] = ACTIONS(2048),
    [anon_sym_continue] = ACTIONS(2048),
    [anon_sym_goto] = ACTIONS(2048),
    [anon_sym___try] = ACTIONS(2048),
    [anon_sym___leave] = ACTIONS(2048),
    [anon_sym_not] = ACTIONS(2048),
    [anon_sym_compl] = ACTIONS(2048),
    [anon_sym_DASH_DASH] = ACTIONS(2050),
    [anon_sym_PLUS_PLUS] = ACTIONS(2050),
    [anon_sym_sizeof] = ACTIONS(2048),
    [anon_sym___alignof__] = ACTIONS(2048),
    [anon_sym___alignof] = ACTIONS(2048),
    [anon_sym__alignof] = ACTIONS(2048),
    [anon_sym_alignof] = ACTIONS(2048),
    [anon_sym__Alignof] = ACTIONS(2048),
    [anon_sym_offsetof] = ACTIONS(2048),
    [anon_sym__Generic] = ACTIONS(2048),
    [anon_sym_asm] = ACTIONS(2048),
    [anon_sym___asm__] = ACTIONS(2048),
    [sym_number_literal] = ACTIONS(2050),
    [anon_sym_L_SQUOTE] = ACTIONS(2050),
    [anon_sym_u_SQUOTE] = ACTIONS(2050),
    [anon_sym_U_SQUOTE] = ACTIONS(2050),
    [anon_sym_u8_SQUOTE] = ACTIONS(2050),
    [anon_sym_SQUOTE] = ACTIONS(2050),
    [anon_sym_L_DQUOTE] = ACTIONS(2050),
    [anon_sym_u_DQUOTE] = ACTIONS(2050),
    [anon_sym_U_DQUOTE] = ACTIONS(2050),
    [anon_sym_u8_DQUOTE] = ACTIONS(2050),
    [anon_sym_DQUOTE] = ACTIONS(2050),
    [sym_true] = ACTIONS(2048),
    [sym_false] = ACTIONS(2048),
    [anon_sym_NULL] = ACTIONS(2048),
    [anon_sym_nullptr] = ACTIONS(2048),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2048),
    [anon_sym_decltype] = ACTIONS(2048),
    [sym_virtual] = ACTIONS(2048),
    [anon_sym_explicit] = ACTIONS(2048),
    [anon_sym_typename] = ACTIONS(2048),
    [anon_sym_template] = ACTIONS(2048),
    [anon_sym_operator] = ACTIONS(2048),
    [anon_sym_try] = ACTIONS(2048),
    [anon_sym_delete] = ACTIONS(2048),
    [anon_sym_throw] = ACTIONS(2048),
    [anon_sym_namespace] = ACTIONS(2048),
    [anon_sym_using] = ACTIONS(2048),
    [anon_sym_static_assert] = ACTIONS(2048),
    [anon_sym_concept] = ACTIONS(2048),
    [anon_sym_co_return] = ACTIONS(2048),
    [anon_sym_co_yield] = ACTIONS(2048),
    [anon_sym_R_DQUOTE] = ACTIONS(2050),
    [anon_sym_LR_DQUOTE] = ACTIONS(2050),
    [anon_sym_uR_DQUOTE] = ACTIONS(2050),
    [anon_sym_UR_DQUOTE] = ACTIONS(2050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2050),
    [anon_sym_co_await] = ACTIONS(2048),
    [anon_sym_new] = ACTIONS(2048),
    [anon_sym_requires] = ACTIONS(2048),
    [sym_this] = ACTIONS(2048),
    [anon_sym___launch_bounds__] = ACTIONS(2048),
  },
  [384] = {
    [sym_identifier] = ACTIONS(2032),
    [aux_sym_preproc_include_token1] = ACTIONS(2032),
    [aux_sym_preproc_def_token1] = ACTIONS(2032),
    [aux_sym_preproc_if_token1] = ACTIONS(2032),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2032),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2032),
    [sym_preproc_directive] = ACTIONS(2032),
    [anon_sym_LPAREN2] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2034),
    [anon_sym_TILDE] = ACTIONS(2034),
    [anon_sym_DASH] = ACTIONS(2032),
    [anon_sym_PLUS] = ACTIONS(2032),
    [anon_sym_STAR] = ACTIONS(2034),
    [anon_sym_AMP_AMP] = ACTIONS(2034),
    [anon_sym_AMP] = ACTIONS(2032),
    [anon_sym_SEMI] = ACTIONS(2034),
    [anon_sym___extension__] = ACTIONS(2032),
    [anon_sym_typedef] = ACTIONS(2032),
    [anon_sym___device__] = ACTIONS(2032),
    [anon_sym___host__] = ACTIONS(2032),
    [anon_sym___global__] = ACTIONS(2032),
    [anon_sym___forceinline__] = ACTIONS(2032),
    [anon_sym___noinline__] = ACTIONS(2032),
    [anon_sym_extern] = ACTIONS(2032),
    [anon_sym___attribute__] = ACTIONS(2032),
    [anon_sym_COLON_COLON] = ACTIONS(2034),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2034),
    [anon_sym___declspec] = ACTIONS(2032),
    [anon_sym___based] = ACTIONS(2032),
    [anon_sym___cdecl] = ACTIONS(2032),
    [anon_sym___clrcall] = ACTIONS(2032),
    [anon_sym___stdcall] = ACTIONS(2032),
    [anon_sym___fastcall] = ACTIONS(2032),
    [anon_sym___thiscall] = ACTIONS(2032),
    [anon_sym___vectorcall] = ACTIONS(2032),
    [anon_sym_LBRACE] = ACTIONS(2034),
    [anon_sym_RBRACE] = ACTIONS(2034),
    [anon_sym_signed] = ACTIONS(2032),
    [anon_sym_unsigned] = ACTIONS(2032),
    [anon_sym_long] = ACTIONS(2032),
    [anon_sym_short] = ACTIONS(2032),
    [anon_sym_LBRACK] = ACTIONS(2032),
    [anon_sym_static] = ACTIONS(2032),
    [anon_sym_register] = ACTIONS(2032),
    [anon_sym_inline] = ACTIONS(2032),
    [anon_sym___inline] = ACTIONS(2032),
    [anon_sym___inline__] = ACTIONS(2032),
    [anon_sym___forceinline] = ACTIONS(2032),
    [anon_sym_thread_local] = ACTIONS(2032),
    [anon_sym___thread] = ACTIONS(2032),
    [anon_sym_const] = ACTIONS(2032),
    [anon_sym_constexpr] = ACTIONS(2032),
    [anon_sym_volatile] = ACTIONS(2032),
    [anon_sym_restrict] = ACTIONS(2032),
    [anon_sym___restrict__] = ACTIONS(2032),
    [anon_sym__Atomic] = ACTIONS(2032),
    [anon_sym__Noreturn] = ACTIONS(2032),
    [anon_sym_noreturn] = ACTIONS(2032),
    [anon_sym_mutable] = ACTIONS(2032),
    [anon_sym_constinit] = ACTIONS(2032),
    [anon_sym_consteval] = ACTIONS(2032),
    [anon_sym___shared__] = ACTIONS(2032),
    [anon_sym___local__] = ACTIONS(2032),
    [anon_sym___constant__] = ACTIONS(2032),
    [anon_sym___managed__] = ACTIONS(2032),
    [anon_sym___grid_constant__] = ACTIONS(2032),
    [anon_sym_alignas] = ACTIONS(2032),
    [anon_sym__Alignas] = ACTIONS(2032),
    [sym_primitive_type] = ACTIONS(2032),
    [anon_sym_enum] = ACTIONS(2032),
    [anon_sym_class] = ACTIONS(2032),
    [anon_sym_struct] = ACTIONS(2032),
    [anon_sym_union] = ACTIONS(2032),
    [anon_sym_if] = ACTIONS(2032),
    [anon_sym_else] = ACTIONS(2032),
    [anon_sym_switch] = ACTIONS(2032),
    [anon_sym_case] = ACTIONS(2032),
    [anon_sym_default] = ACTIONS(2032),
    [anon_sym_while] = ACTIONS(2032),
    [anon_sym_do] = ACTIONS(2032),
    [anon_sym_for] = ACTIONS(2032),
    [anon_sym_return] = ACTIONS(2032),
    [anon_sym_break] = ACTIONS(2032),
    [anon_sym_continue] = ACTIONS(2032),
    [anon_sym_goto] = ACTIONS(2032),
    [anon_sym___try] = ACTIONS(2032),
    [anon_sym___leave] = ACTIONS(2032),
    [anon_sym_not] = ACTIONS(2032),
    [anon_sym_compl] = ACTIONS(2032),
    [anon_sym_DASH_DASH] = ACTIONS(2034),
    [anon_sym_PLUS_PLUS] = ACTIONS(2034),
    [anon_sym_sizeof] = ACTIONS(2032),
    [anon_sym___alignof__] = ACTIONS(2032),
    [anon_sym___alignof] = ACTIONS(2032),
    [anon_sym__alignof] = ACTIONS(2032),
    [anon_sym_alignof] = ACTIONS(2032),
    [anon_sym__Alignof] = ACTIONS(2032),
    [anon_sym_offsetof] = ACTIONS(2032),
    [anon_sym__Generic] = ACTIONS(2032),
    [anon_sym_asm] = ACTIONS(2032),
    [anon_sym___asm__] = ACTIONS(2032),
    [sym_number_literal] = ACTIONS(2034),
    [anon_sym_L_SQUOTE] = ACTIONS(2034),
    [anon_sym_u_SQUOTE] = ACTIONS(2034),
    [anon_sym_U_SQUOTE] = ACTIONS(2034),
    [anon_sym_u8_SQUOTE] = ACTIONS(2034),
    [anon_sym_SQUOTE] = ACTIONS(2034),
    [anon_sym_L_DQUOTE] = ACTIONS(2034),
    [anon_sym_u_DQUOTE] = ACTIONS(2034),
    [anon_sym_U_DQUOTE] = ACTIONS(2034),
    [anon_sym_u8_DQUOTE] = ACTIONS(2034),
    [anon_sym_DQUOTE] = ACTIONS(2034),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [anon_sym_NULL] = ACTIONS(2032),
    [anon_sym_nullptr] = ACTIONS(2032),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2032),
    [anon_sym_decltype] = ACTIONS(2032),
    [sym_virtual] = ACTIONS(2032),
    [anon_sym_explicit] = ACTIONS(2032),
    [anon_sym_typename] = ACTIONS(2032),
    [anon_sym_template] = ACTIONS(2032),
    [anon_sym_operator] = ACTIONS(2032),
    [anon_sym_try] = ACTIONS(2032),
    [anon_sym_delete] = ACTIONS(2032),
    [anon_sym_throw] = ACTIONS(2032),
    [anon_sym_namespace] = ACTIONS(2032),
    [anon_sym_using] = ACTIONS(2032),
    [anon_sym_static_assert] = ACTIONS(2032),
    [anon_sym_concept] = ACTIONS(2032),
    [anon_sym_co_return] = ACTIONS(2032),
    [anon_sym_co_yield] = ACTIONS(2032),
    [anon_sym_R_DQUOTE] = ACTIONS(2034),
    [anon_sym_LR_DQUOTE] = ACTIONS(2034),
    [anon_sym_uR_DQUOTE] = ACTIONS(2034),
    [anon_sym_UR_DQUOTE] = ACTIONS(2034),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2034),
    [anon_sym_co_await] = ACTIONS(2032),
    [anon_sym_new] = ACTIONS(2032),
    [anon_sym_requires] = ACTIONS(2032),
    [sym_this] = ACTIONS(2032),
    [anon_sym___launch_bounds__] = ACTIONS(2032),
  },
  [385] = {
    [sym_identifier] = ACTIONS(2044),
    [aux_sym_preproc_include_token1] = ACTIONS(2044),
    [aux_sym_preproc_def_token1] = ACTIONS(2044),
    [aux_sym_preproc_if_token1] = ACTIONS(2044),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2044),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2044),
    [sym_preproc_directive] = ACTIONS(2044),
    [anon_sym_LPAREN2] = ACTIONS(2046),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2044),
    [anon_sym_PLUS] = ACTIONS(2044),
    [anon_sym_STAR] = ACTIONS(2046),
    [anon_sym_AMP_AMP] = ACTIONS(2046),
    [anon_sym_AMP] = ACTIONS(2044),
    [anon_sym_SEMI] = ACTIONS(2046),
    [anon_sym___extension__] = ACTIONS(2044),
    [anon_sym_typedef] = ACTIONS(2044),
    [anon_sym___device__] = ACTIONS(2044),
    [anon_sym___host__] = ACTIONS(2044),
    [anon_sym___global__] = ACTIONS(2044),
    [anon_sym___forceinline__] = ACTIONS(2044),
    [anon_sym___noinline__] = ACTIONS(2044),
    [anon_sym_extern] = ACTIONS(2044),
    [anon_sym___attribute__] = ACTIONS(2044),
    [anon_sym_COLON_COLON] = ACTIONS(2046),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2046),
    [anon_sym___declspec] = ACTIONS(2044),
    [anon_sym___based] = ACTIONS(2044),
    [anon_sym___cdecl] = ACTIONS(2044),
    [anon_sym___clrcall] = ACTIONS(2044),
    [anon_sym___stdcall] = ACTIONS(2044),
    [anon_sym___fastcall] = ACTIONS(2044),
    [anon_sym___thiscall] = ACTIONS(2044),
    [anon_sym___vectorcall] = ACTIONS(2044),
    [anon_sym_LBRACE] = ACTIONS(2046),
    [anon_sym_RBRACE] = ACTIONS(2046),
    [anon_sym_signed] = ACTIONS(2044),
    [anon_sym_unsigned] = ACTIONS(2044),
    [anon_sym_long] = ACTIONS(2044),
    [anon_sym_short] = ACTIONS(2044),
    [anon_sym_LBRACK] = ACTIONS(2044),
    [anon_sym_static] = ACTIONS(2044),
    [anon_sym_register] = ACTIONS(2044),
    [anon_sym_inline] = ACTIONS(2044),
    [anon_sym___inline] = ACTIONS(2044),
    [anon_sym___inline__] = ACTIONS(2044),
    [anon_sym___forceinline] = ACTIONS(2044),
    [anon_sym_thread_local] = ACTIONS(2044),
    [anon_sym___thread] = ACTIONS(2044),
    [anon_sym_const] = ACTIONS(2044),
    [anon_sym_constexpr] = ACTIONS(2044),
    [anon_sym_volatile] = ACTIONS(2044),
    [anon_sym_restrict] = ACTIONS(2044),
    [anon_sym___restrict__] = ACTIONS(2044),
    [anon_sym__Atomic] = ACTIONS(2044),
    [anon_sym__Noreturn] = ACTIONS(2044),
    [anon_sym_noreturn] = ACTIONS(2044),
    [anon_sym_mutable] = ACTIONS(2044),
    [anon_sym_constinit] = ACTIONS(2044),
    [anon_sym_consteval] = ACTIONS(2044),
    [anon_sym___shared__] = ACTIONS(2044),
    [anon_sym___local__] = ACTIONS(2044),
    [anon_sym___constant__] = ACTIONS(2044),
    [anon_sym___managed__] = ACTIONS(2044),
    [anon_sym___grid_constant__] = ACTIONS(2044),
    [anon_sym_alignas] = ACTIONS(2044),
    [anon_sym__Alignas] = ACTIONS(2044),
    [sym_primitive_type] = ACTIONS(2044),
    [anon_sym_enum] = ACTIONS(2044),
    [anon_sym_class] = ACTIONS(2044),
    [anon_sym_struct] = ACTIONS(2044),
    [anon_sym_union] = ACTIONS(2044),
    [anon_sym_if] = ACTIONS(2044),
    [anon_sym_else] = ACTIONS(2044),
    [anon_sym_switch] = ACTIONS(2044),
    [anon_sym_case] = ACTIONS(2044),
    [anon_sym_default] = ACTIONS(2044),
    [anon_sym_while] = ACTIONS(2044),
    [anon_sym_do] = ACTIONS(2044),
    [anon_sym_for] = ACTIONS(2044),
    [anon_sym_return] = ACTIONS(2044),
    [anon_sym_break] = ACTIONS(2044),
    [anon_sym_continue] = ACTIONS(2044),
    [anon_sym_goto] = ACTIONS(2044),
    [anon_sym___try] = ACTIONS(2044),
    [anon_sym___leave] = ACTIONS(2044),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_compl] = ACTIONS(2044),
    [anon_sym_DASH_DASH] = ACTIONS(2046),
    [anon_sym_PLUS_PLUS] = ACTIONS(2046),
    [anon_sym_sizeof] = ACTIONS(2044),
    [anon_sym___alignof__] = ACTIONS(2044),
    [anon_sym___alignof] = ACTIONS(2044),
    [anon_sym__alignof] = ACTIONS(2044),
    [anon_sym_alignof] = ACTIONS(2044),
    [anon_sym__Alignof] = ACTIONS(2044),
    [anon_sym_offsetof] = ACTIONS(2044),
    [anon_sym__Generic] = ACTIONS(2044),
    [anon_sym_asm] = ACTIONS(2044),
    [anon_sym___asm__] = ACTIONS(2044),
    [sym_number_literal] = ACTIONS(2046),
    [anon_sym_L_SQUOTE] = ACTIONS(2046),
    [anon_sym_u_SQUOTE] = ACTIONS(2046),
    [anon_sym_U_SQUOTE] = ACTIONS(2046),
    [anon_sym_u8_SQUOTE] = ACTIONS(2046),
    [anon_sym_SQUOTE] = ACTIONS(2046),
    [anon_sym_L_DQUOTE] = ACTIONS(2046),
    [anon_sym_u_DQUOTE] = ACTIONS(2046),
    [anon_sym_U_DQUOTE] = ACTIONS(2046),
    [anon_sym_u8_DQUOTE] = ACTIONS(2046),
    [anon_sym_DQUOTE] = ACTIONS(2046),
    [sym_true] = ACTIONS(2044),
    [sym_false] = ACTIONS(2044),
    [anon_sym_NULL] = ACTIONS(2044),
    [anon_sym_nullptr] = ACTIONS(2044),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2044),
    [anon_sym_decltype] = ACTIONS(2044),
    [sym_virtual] = ACTIONS(2044),
    [anon_sym_explicit] = ACTIONS(2044),
    [anon_sym_typename] = ACTIONS(2044),
    [anon_sym_template] = ACTIONS(2044),
    [anon_sym_operator] = ACTIONS(2044),
    [anon_sym_try] = ACTIONS(2044),
    [anon_sym_delete] = ACTIONS(2044),
    [anon_sym_throw] = ACTIONS(2044),
    [anon_sym_namespace] = ACTIONS(2044),
    [anon_sym_using] = ACTIONS(2044),
    [anon_sym_static_assert] = ACTIONS(2044),
    [anon_sym_concept] = ACTIONS(2044),
    [anon_sym_co_return] = ACTIONS(2044),
    [anon_sym_co_yield] = ACTIONS(2044),
    [anon_sym_R_DQUOTE] = ACTIONS(2046),
    [anon_sym_LR_DQUOTE] = ACTIONS(2046),
    [anon_sym_uR_DQUOTE] = ACTIONS(2046),
    [anon_sym_UR_DQUOTE] = ACTIONS(2046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2046),
    [anon_sym_co_await] = ACTIONS(2044),
    [anon_sym_new] = ACTIONS(2044),
    [anon_sym_requires] = ACTIONS(2044),
    [sym_this] = ACTIONS(2044),
    [anon_sym___launch_bounds__] = ACTIONS(2044),
  },
  [386] = {
    [sym_identifier] = ACTIONS(2064),
    [aux_sym_preproc_include_token1] = ACTIONS(2064),
    [aux_sym_preproc_def_token1] = ACTIONS(2064),
    [aux_sym_preproc_if_token1] = ACTIONS(2064),
    [aux_sym_preproc_if_token2] = ACTIONS(2064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2064),
    [sym_preproc_directive] = ACTIONS(2064),
    [anon_sym_LPAREN2] = ACTIONS(2066),
    [anon_sym_BANG] = ACTIONS(2066),
    [anon_sym_TILDE] = ACTIONS(2066),
    [anon_sym_DASH] = ACTIONS(2064),
    [anon_sym_PLUS] = ACTIONS(2064),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_AMP_AMP] = ACTIONS(2066),
    [anon_sym_AMP] = ACTIONS(2064),
    [anon_sym_SEMI] = ACTIONS(2066),
    [anon_sym___extension__] = ACTIONS(2064),
    [anon_sym_typedef] = ACTIONS(2064),
    [anon_sym___device__] = ACTIONS(2064),
    [anon_sym___host__] = ACTIONS(2064),
    [anon_sym___global__] = ACTIONS(2064),
    [anon_sym___forceinline__] = ACTIONS(2064),
    [anon_sym___noinline__] = ACTIONS(2064),
    [anon_sym_extern] = ACTIONS(2064),
    [anon_sym___attribute__] = ACTIONS(2064),
    [anon_sym_COLON_COLON] = ACTIONS(2066),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2066),
    [anon_sym___declspec] = ACTIONS(2064),
    [anon_sym___based] = ACTIONS(2064),
    [anon_sym___cdecl] = ACTIONS(2064),
    [anon_sym___clrcall] = ACTIONS(2064),
    [anon_sym___stdcall] = ACTIONS(2064),
    [anon_sym___fastcall] = ACTIONS(2064),
    [anon_sym___thiscall] = ACTIONS(2064),
    [anon_sym___vectorcall] = ACTIONS(2064),
    [anon_sym_LBRACE] = ACTIONS(2066),
    [anon_sym_signed] = ACTIONS(2064),
    [anon_sym_unsigned] = ACTIONS(2064),
    [anon_sym_long] = ACTIONS(2064),
    [anon_sym_short] = ACTIONS(2064),
    [anon_sym_LBRACK] = ACTIONS(2064),
    [anon_sym_static] = ACTIONS(2064),
    [anon_sym_register] = ACTIONS(2064),
    [anon_sym_inline] = ACTIONS(2064),
    [anon_sym___inline] = ACTIONS(2064),
    [anon_sym___inline__] = ACTIONS(2064),
    [anon_sym___forceinline] = ACTIONS(2064),
    [anon_sym_thread_local] = ACTIONS(2064),
    [anon_sym___thread] = ACTIONS(2064),
    [anon_sym_const] = ACTIONS(2064),
    [anon_sym_constexpr] = ACTIONS(2064),
    [anon_sym_volatile] = ACTIONS(2064),
    [anon_sym_restrict] = ACTIONS(2064),
    [anon_sym___restrict__] = ACTIONS(2064),
    [anon_sym__Atomic] = ACTIONS(2064),
    [anon_sym__Noreturn] = ACTIONS(2064),
    [anon_sym_noreturn] = ACTIONS(2064),
    [anon_sym_mutable] = ACTIONS(2064),
    [anon_sym_constinit] = ACTIONS(2064),
    [anon_sym_consteval] = ACTIONS(2064),
    [anon_sym___shared__] = ACTIONS(2064),
    [anon_sym___local__] = ACTIONS(2064),
    [anon_sym___constant__] = ACTIONS(2064),
    [anon_sym___managed__] = ACTIONS(2064),
    [anon_sym___grid_constant__] = ACTIONS(2064),
    [anon_sym_alignas] = ACTIONS(2064),
    [anon_sym__Alignas] = ACTIONS(2064),
    [sym_primitive_type] = ACTIONS(2064),
    [anon_sym_enum] = ACTIONS(2064),
    [anon_sym_class] = ACTIONS(2064),
    [anon_sym_struct] = ACTIONS(2064),
    [anon_sym_union] = ACTIONS(2064),
    [anon_sym_if] = ACTIONS(2064),
    [anon_sym_else] = ACTIONS(2064),
    [anon_sym_switch] = ACTIONS(2064),
    [anon_sym_case] = ACTIONS(2064),
    [anon_sym_default] = ACTIONS(2064),
    [anon_sym_while] = ACTIONS(2064),
    [anon_sym_do] = ACTIONS(2064),
    [anon_sym_for] = ACTIONS(2064),
    [anon_sym_return] = ACTIONS(2064),
    [anon_sym_break] = ACTIONS(2064),
    [anon_sym_continue] = ACTIONS(2064),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym___try] = ACTIONS(2064),
    [anon_sym___leave] = ACTIONS(2064),
    [anon_sym_not] = ACTIONS(2064),
    [anon_sym_compl] = ACTIONS(2064),
    [anon_sym_DASH_DASH] = ACTIONS(2066),
    [anon_sym_PLUS_PLUS] = ACTIONS(2066),
    [anon_sym_sizeof] = ACTIONS(2064),
    [anon_sym___alignof__] = ACTIONS(2064),
    [anon_sym___alignof] = ACTIONS(2064),
    [anon_sym__alignof] = ACTIONS(2064),
    [anon_sym_alignof] = ACTIONS(2064),
    [anon_sym__Alignof] = ACTIONS(2064),
    [anon_sym_offsetof] = ACTIONS(2064),
    [anon_sym__Generic] = ACTIONS(2064),
    [anon_sym_asm] = ACTIONS(2064),
    [anon_sym___asm__] = ACTIONS(2064),
    [sym_number_literal] = ACTIONS(2066),
    [anon_sym_L_SQUOTE] = ACTIONS(2066),
    [anon_sym_u_SQUOTE] = ACTIONS(2066),
    [anon_sym_U_SQUOTE] = ACTIONS(2066),
    [anon_sym_u8_SQUOTE] = ACTIONS(2066),
    [anon_sym_SQUOTE] = ACTIONS(2066),
    [anon_sym_L_DQUOTE] = ACTIONS(2066),
    [anon_sym_u_DQUOTE] = ACTIONS(2066),
    [anon_sym_U_DQUOTE] = ACTIONS(2066),
    [anon_sym_u8_DQUOTE] = ACTIONS(2066),
    [anon_sym_DQUOTE] = ACTIONS(2066),
    [sym_true] = ACTIONS(2064),
    [sym_false] = ACTIONS(2064),
    [anon_sym_NULL] = ACTIONS(2064),
    [anon_sym_nullptr] = ACTIONS(2064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2064),
    [anon_sym_decltype] = ACTIONS(2064),
    [sym_virtual] = ACTIONS(2064),
    [anon_sym_explicit] = ACTIONS(2064),
    [anon_sym_typename] = ACTIONS(2064),
    [anon_sym_template] = ACTIONS(2064),
    [anon_sym_operator] = ACTIONS(2064),
    [anon_sym_try] = ACTIONS(2064),
    [anon_sym_delete] = ACTIONS(2064),
    [anon_sym_throw] = ACTIONS(2064),
    [anon_sym_namespace] = ACTIONS(2064),
    [anon_sym_using] = ACTIONS(2064),
    [anon_sym_static_assert] = ACTIONS(2064),
    [anon_sym_concept] = ACTIONS(2064),
    [anon_sym_co_return] = ACTIONS(2064),
    [anon_sym_co_yield] = ACTIONS(2064),
    [anon_sym_R_DQUOTE] = ACTIONS(2066),
    [anon_sym_LR_DQUOTE] = ACTIONS(2066),
    [anon_sym_uR_DQUOTE] = ACTIONS(2066),
    [anon_sym_UR_DQUOTE] = ACTIONS(2066),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2066),
    [anon_sym_co_await] = ACTIONS(2064),
    [anon_sym_new] = ACTIONS(2064),
    [anon_sym_requires] = ACTIONS(2064),
    [sym_this] = ACTIONS(2064),
    [anon_sym___launch_bounds__] = ACTIONS(2064),
  },
  [387] = {
    [ts_builtin_sym_end] = ACTIONS(1948),
    [sym_identifier] = ACTIONS(1946),
    [aux_sym_preproc_include_token1] = ACTIONS(1946),
    [aux_sym_preproc_def_token1] = ACTIONS(1946),
    [aux_sym_preproc_if_token1] = ACTIONS(1946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1946),
    [sym_preproc_directive] = ACTIONS(1946),
    [anon_sym_LPAREN2] = ACTIONS(1948),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(1948),
    [anon_sym_AMP_AMP] = ACTIONS(1948),
    [anon_sym_AMP] = ACTIONS(1946),
    [anon_sym_SEMI] = ACTIONS(1948),
    [anon_sym___extension__] = ACTIONS(1946),
    [anon_sym_typedef] = ACTIONS(1946),
    [anon_sym___device__] = ACTIONS(1946),
    [anon_sym___host__] = ACTIONS(1946),
    [anon_sym___global__] = ACTIONS(1946),
    [anon_sym___forceinline__] = ACTIONS(1946),
    [anon_sym___noinline__] = ACTIONS(1946),
    [anon_sym_extern] = ACTIONS(1946),
    [anon_sym___attribute__] = ACTIONS(1946),
    [anon_sym_COLON_COLON] = ACTIONS(1948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1948),
    [anon_sym___declspec] = ACTIONS(1946),
    [anon_sym___based] = ACTIONS(1946),
    [anon_sym___cdecl] = ACTIONS(1946),
    [anon_sym___clrcall] = ACTIONS(1946),
    [anon_sym___stdcall] = ACTIONS(1946),
    [anon_sym___fastcall] = ACTIONS(1946),
    [anon_sym___thiscall] = ACTIONS(1946),
    [anon_sym___vectorcall] = ACTIONS(1946),
    [anon_sym_LBRACE] = ACTIONS(1948),
    [anon_sym_signed] = ACTIONS(1946),
    [anon_sym_unsigned] = ACTIONS(1946),
    [anon_sym_long] = ACTIONS(1946),
    [anon_sym_short] = ACTIONS(1946),
    [anon_sym_LBRACK] = ACTIONS(1946),
    [anon_sym_static] = ACTIONS(1946),
    [anon_sym_register] = ACTIONS(1946),
    [anon_sym_inline] = ACTIONS(1946),
    [anon_sym___inline] = ACTIONS(1946),
    [anon_sym___inline__] = ACTIONS(1946),
    [anon_sym___forceinline] = ACTIONS(1946),
    [anon_sym_thread_local] = ACTIONS(1946),
    [anon_sym___thread] = ACTIONS(1946),
    [anon_sym_const] = ACTIONS(1946),
    [anon_sym_constexpr] = ACTIONS(1946),
    [anon_sym_volatile] = ACTIONS(1946),
    [anon_sym_restrict] = ACTIONS(1946),
    [anon_sym___restrict__] = ACTIONS(1946),
    [anon_sym__Atomic] = ACTIONS(1946),
    [anon_sym__Noreturn] = ACTIONS(1946),
    [anon_sym_noreturn] = ACTIONS(1946),
    [anon_sym_mutable] = ACTIONS(1946),
    [anon_sym_constinit] = ACTIONS(1946),
    [anon_sym_consteval] = ACTIONS(1946),
    [anon_sym___shared__] = ACTIONS(1946),
    [anon_sym___local__] = ACTIONS(1946),
    [anon_sym___constant__] = ACTIONS(1946),
    [anon_sym___managed__] = ACTIONS(1946),
    [anon_sym___grid_constant__] = ACTIONS(1946),
    [anon_sym_alignas] = ACTIONS(1946),
    [anon_sym__Alignas] = ACTIONS(1946),
    [sym_primitive_type] = ACTIONS(1946),
    [anon_sym_enum] = ACTIONS(1946),
    [anon_sym_class] = ACTIONS(1946),
    [anon_sym_struct] = ACTIONS(1946),
    [anon_sym_union] = ACTIONS(1946),
    [anon_sym_if] = ACTIONS(1946),
    [anon_sym_else] = ACTIONS(1946),
    [anon_sym_switch] = ACTIONS(1946),
    [anon_sym_case] = ACTIONS(1946),
    [anon_sym_default] = ACTIONS(1946),
    [anon_sym_while] = ACTIONS(1946),
    [anon_sym_do] = ACTIONS(1946),
    [anon_sym_for] = ACTIONS(1946),
    [anon_sym_return] = ACTIONS(1946),
    [anon_sym_break] = ACTIONS(1946),
    [anon_sym_continue] = ACTIONS(1946),
    [anon_sym_goto] = ACTIONS(1946),
    [anon_sym___try] = ACTIONS(1946),
    [anon_sym___leave] = ACTIONS(1946),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(1948),
    [anon_sym_PLUS_PLUS] = ACTIONS(1948),
    [anon_sym_sizeof] = ACTIONS(1946),
    [anon_sym___alignof__] = ACTIONS(1946),
    [anon_sym___alignof] = ACTIONS(1946),
    [anon_sym__alignof] = ACTIONS(1946),
    [anon_sym_alignof] = ACTIONS(1946),
    [anon_sym__Alignof] = ACTIONS(1946),
    [anon_sym_offsetof] = ACTIONS(1946),
    [anon_sym__Generic] = ACTIONS(1946),
    [anon_sym_asm] = ACTIONS(1946),
    [anon_sym___asm__] = ACTIONS(1946),
    [sym_number_literal] = ACTIONS(1948),
    [anon_sym_L_SQUOTE] = ACTIONS(1948),
    [anon_sym_u_SQUOTE] = ACTIONS(1948),
    [anon_sym_U_SQUOTE] = ACTIONS(1948),
    [anon_sym_u8_SQUOTE] = ACTIONS(1948),
    [anon_sym_SQUOTE] = ACTIONS(1948),
    [anon_sym_L_DQUOTE] = ACTIONS(1948),
    [anon_sym_u_DQUOTE] = ACTIONS(1948),
    [anon_sym_U_DQUOTE] = ACTIONS(1948),
    [anon_sym_u8_DQUOTE] = ACTIONS(1948),
    [anon_sym_DQUOTE] = ACTIONS(1948),
    [sym_true] = ACTIONS(1946),
    [sym_false] = ACTIONS(1946),
    [anon_sym_NULL] = ACTIONS(1946),
    [anon_sym_nullptr] = ACTIONS(1946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1946),
    [anon_sym_decltype] = ACTIONS(1946),
    [sym_virtual] = ACTIONS(1946),
    [anon_sym_explicit] = ACTIONS(1946),
    [anon_sym_typename] = ACTIONS(1946),
    [anon_sym_template] = ACTIONS(1946),
    [anon_sym_operator] = ACTIONS(1946),
    [anon_sym_try] = ACTIONS(1946),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_throw] = ACTIONS(1946),
    [anon_sym_namespace] = ACTIONS(1946),
    [anon_sym_using] = ACTIONS(1946),
    [anon_sym_static_assert] = ACTIONS(1946),
    [anon_sym_concept] = ACTIONS(1946),
    [anon_sym_co_return] = ACTIONS(1946),
    [anon_sym_co_yield] = ACTIONS(1946),
    [anon_sym_R_DQUOTE] = ACTIONS(1948),
    [anon_sym_LR_DQUOTE] = ACTIONS(1948),
    [anon_sym_uR_DQUOTE] = ACTIONS(1948),
    [anon_sym_UR_DQUOTE] = ACTIONS(1948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1948),
    [anon_sym_co_await] = ACTIONS(1946),
    [anon_sym_new] = ACTIONS(1946),
    [anon_sym_requires] = ACTIONS(1946),
    [sym_this] = ACTIONS(1946),
    [anon_sym___launch_bounds__] = ACTIONS(1946),
  },
  [388] = {
    [sym_identifier] = ACTIONS(1901),
    [aux_sym_preproc_include_token1] = ACTIONS(1901),
    [aux_sym_preproc_def_token1] = ACTIONS(1901),
    [anon_sym_COMMA] = ACTIONS(1962),
    [aux_sym_preproc_if_token1] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1901),
    [sym_preproc_directive] = ACTIONS(1901),
    [anon_sym_LPAREN2] = ACTIONS(1899),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_DASH] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1901),
    [anon_sym_STAR] = ACTIONS(1899),
    [anon_sym_AMP_AMP] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1901),
    [anon_sym_SEMI] = ACTIONS(1899),
    [anon_sym___extension__] = ACTIONS(1901),
    [anon_sym_typedef] = ACTIONS(1901),
    [anon_sym___device__] = ACTIONS(1901),
    [anon_sym___host__] = ACTIONS(1901),
    [anon_sym___global__] = ACTIONS(1901),
    [anon_sym___forceinline__] = ACTIONS(1901),
    [anon_sym___noinline__] = ACTIONS(1901),
    [anon_sym_extern] = ACTIONS(1901),
    [anon_sym___attribute__] = ACTIONS(1901),
    [anon_sym_COLON_COLON] = ACTIONS(1899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1899),
    [anon_sym___declspec] = ACTIONS(1901),
    [anon_sym___based] = ACTIONS(1901),
    [anon_sym___cdecl] = ACTIONS(1901),
    [anon_sym___clrcall] = ACTIONS(1901),
    [anon_sym___stdcall] = ACTIONS(1901),
    [anon_sym___fastcall] = ACTIONS(1901),
    [anon_sym___thiscall] = ACTIONS(1901),
    [anon_sym___vectorcall] = ACTIONS(1901),
    [anon_sym_LBRACE] = ACTIONS(1899),
    [anon_sym_RBRACE] = ACTIONS(1962),
    [anon_sym_signed] = ACTIONS(1901),
    [anon_sym_unsigned] = ACTIONS(1901),
    [anon_sym_long] = ACTIONS(1901),
    [anon_sym_short] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1901),
    [anon_sym_static] = ACTIONS(1901),
    [anon_sym_register] = ACTIONS(1901),
    [anon_sym_inline] = ACTIONS(1901),
    [anon_sym___inline] = ACTIONS(1901),
    [anon_sym___inline__] = ACTIONS(1901),
    [anon_sym___forceinline] = ACTIONS(1901),
    [anon_sym_thread_local] = ACTIONS(1901),
    [anon_sym___thread] = ACTIONS(1901),
    [anon_sym_const] = ACTIONS(1901),
    [anon_sym_constexpr] = ACTIONS(1901),
    [anon_sym_volatile] = ACTIONS(1901),
    [anon_sym_restrict] = ACTIONS(1901),
    [anon_sym___restrict__] = ACTIONS(1901),
    [anon_sym__Atomic] = ACTIONS(1901),
    [anon_sym__Noreturn] = ACTIONS(1901),
    [anon_sym_noreturn] = ACTIONS(1901),
    [anon_sym_mutable] = ACTIONS(1901),
    [anon_sym_constinit] = ACTIONS(1901),
    [anon_sym_consteval] = ACTIONS(1901),
    [anon_sym___shared__] = ACTIONS(1901),
    [anon_sym___local__] = ACTIONS(1901),
    [anon_sym___constant__] = ACTIONS(1901),
    [anon_sym___managed__] = ACTIONS(1901),
    [anon_sym___grid_constant__] = ACTIONS(1901),
    [anon_sym_alignas] = ACTIONS(1901),
    [anon_sym__Alignas] = ACTIONS(1901),
    [sym_primitive_type] = ACTIONS(1901),
    [anon_sym_enum] = ACTIONS(1901),
    [anon_sym_class] = ACTIONS(1901),
    [anon_sym_struct] = ACTIONS(1901),
    [anon_sym_union] = ACTIONS(1901),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_switch] = ACTIONS(1901),
    [anon_sym_case] = ACTIONS(1901),
    [anon_sym_default] = ACTIONS(1901),
    [anon_sym_while] = ACTIONS(1901),
    [anon_sym_do] = ACTIONS(1901),
    [anon_sym_for] = ACTIONS(1901),
    [anon_sym_return] = ACTIONS(1901),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_continue] = ACTIONS(1901),
    [anon_sym_goto] = ACTIONS(1901),
    [anon_sym___try] = ACTIONS(1901),
    [anon_sym___leave] = ACTIONS(1901),
    [anon_sym_not] = ACTIONS(1901),
    [anon_sym_compl] = ACTIONS(1901),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_sizeof] = ACTIONS(1901),
    [anon_sym___alignof__] = ACTIONS(1901),
    [anon_sym___alignof] = ACTIONS(1901),
    [anon_sym__alignof] = ACTIONS(1901),
    [anon_sym_alignof] = ACTIONS(1901),
    [anon_sym__Alignof] = ACTIONS(1901),
    [anon_sym_offsetof] = ACTIONS(1901),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1901),
    [anon_sym___asm__] = ACTIONS(1901),
    [sym_number_literal] = ACTIONS(1899),
    [anon_sym_L_SQUOTE] = ACTIONS(1899),
    [anon_sym_u_SQUOTE] = ACTIONS(1899),
    [anon_sym_U_SQUOTE] = ACTIONS(1899),
    [anon_sym_u8_SQUOTE] = ACTIONS(1899),
    [anon_sym_SQUOTE] = ACTIONS(1899),
    [anon_sym_L_DQUOTE] = ACTIONS(1899),
    [anon_sym_u_DQUOTE] = ACTIONS(1899),
    [anon_sym_U_DQUOTE] = ACTIONS(1899),
    [anon_sym_u8_DQUOTE] = ACTIONS(1899),
    [anon_sym_DQUOTE] = ACTIONS(1899),
    [sym_true] = ACTIONS(1901),
    [sym_false] = ACTIONS(1901),
    [anon_sym_NULL] = ACTIONS(1901),
    [anon_sym_nullptr] = ACTIONS(1901),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1901),
    [anon_sym_decltype] = ACTIONS(1901),
    [sym_virtual] = ACTIONS(1901),
    [anon_sym_explicit] = ACTIONS(1901),
    [anon_sym_typename] = ACTIONS(1901),
    [anon_sym_template] = ACTIONS(1901),
    [anon_sym_operator] = ACTIONS(1901),
    [anon_sym_try] = ACTIONS(1901),
    [anon_sym_delete] = ACTIONS(1901),
    [anon_sym_throw] = ACTIONS(1901),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_using] = ACTIONS(1901),
    [anon_sym_static_assert] = ACTIONS(1901),
    [anon_sym_concept] = ACTIONS(1901),
    [anon_sym_co_return] = ACTIONS(1901),
    [anon_sym_co_yield] = ACTIONS(1901),
    [anon_sym_R_DQUOTE] = ACTIONS(1899),
    [anon_sym_LR_DQUOTE] = ACTIONS(1899),
    [anon_sym_uR_DQUOTE] = ACTIONS(1899),
    [anon_sym_UR_DQUOTE] = ACTIONS(1899),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1899),
    [anon_sym_co_await] = ACTIONS(1901),
    [anon_sym_new] = ACTIONS(1901),
    [anon_sym_requires] = ACTIONS(1901),
    [sym_this] = ACTIONS(1901),
    [anon_sym___launch_bounds__] = ACTIONS(1901),
  },
  [389] = {
    [sym_identifier] = ACTIONS(2076),
    [aux_sym_preproc_include_token1] = ACTIONS(2076),
    [aux_sym_preproc_def_token1] = ACTIONS(2076),
    [aux_sym_preproc_if_token1] = ACTIONS(2076),
    [aux_sym_preproc_if_token2] = ACTIONS(2076),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2076),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2076),
    [sym_preproc_directive] = ACTIONS(2076),
    [anon_sym_LPAREN2] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2078),
    [anon_sym_TILDE] = ACTIONS(2078),
    [anon_sym_DASH] = ACTIONS(2076),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_STAR] = ACTIONS(2078),
    [anon_sym_AMP_AMP] = ACTIONS(2078),
    [anon_sym_AMP] = ACTIONS(2076),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym___extension__] = ACTIONS(2076),
    [anon_sym_typedef] = ACTIONS(2076),
    [anon_sym___device__] = ACTIONS(2076),
    [anon_sym___host__] = ACTIONS(2076),
    [anon_sym___global__] = ACTIONS(2076),
    [anon_sym___forceinline__] = ACTIONS(2076),
    [anon_sym___noinline__] = ACTIONS(2076),
    [anon_sym_extern] = ACTIONS(2076),
    [anon_sym___attribute__] = ACTIONS(2076),
    [anon_sym_COLON_COLON] = ACTIONS(2078),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2078),
    [anon_sym___declspec] = ACTIONS(2076),
    [anon_sym___based] = ACTIONS(2076),
    [anon_sym___cdecl] = ACTIONS(2076),
    [anon_sym___clrcall] = ACTIONS(2076),
    [anon_sym___stdcall] = ACTIONS(2076),
    [anon_sym___fastcall] = ACTIONS(2076),
    [anon_sym___thiscall] = ACTIONS(2076),
    [anon_sym___vectorcall] = ACTIONS(2076),
    [anon_sym_LBRACE] = ACTIONS(2078),
    [anon_sym_signed] = ACTIONS(2076),
    [anon_sym_unsigned] = ACTIONS(2076),
    [anon_sym_long] = ACTIONS(2076),
    [anon_sym_short] = ACTIONS(2076),
    [anon_sym_LBRACK] = ACTIONS(2076),
    [anon_sym_static] = ACTIONS(2076),
    [anon_sym_register] = ACTIONS(2076),
    [anon_sym_inline] = ACTIONS(2076),
    [anon_sym___inline] = ACTIONS(2076),
    [anon_sym___inline__] = ACTIONS(2076),
    [anon_sym___forceinline] = ACTIONS(2076),
    [anon_sym_thread_local] = ACTIONS(2076),
    [anon_sym___thread] = ACTIONS(2076),
    [anon_sym_const] = ACTIONS(2076),
    [anon_sym_constexpr] = ACTIONS(2076),
    [anon_sym_volatile] = ACTIONS(2076),
    [anon_sym_restrict] = ACTIONS(2076),
    [anon_sym___restrict__] = ACTIONS(2076),
    [anon_sym__Atomic] = ACTIONS(2076),
    [anon_sym__Noreturn] = ACTIONS(2076),
    [anon_sym_noreturn] = ACTIONS(2076),
    [anon_sym_mutable] = ACTIONS(2076),
    [anon_sym_constinit] = ACTIONS(2076),
    [anon_sym_consteval] = ACTIONS(2076),
    [anon_sym___shared__] = ACTIONS(2076),
    [anon_sym___local__] = ACTIONS(2076),
    [anon_sym___constant__] = ACTIONS(2076),
    [anon_sym___managed__] = ACTIONS(2076),
    [anon_sym___grid_constant__] = ACTIONS(2076),
    [anon_sym_alignas] = ACTIONS(2076),
    [anon_sym__Alignas] = ACTIONS(2076),
    [sym_primitive_type] = ACTIONS(2076),
    [anon_sym_enum] = ACTIONS(2076),
    [anon_sym_class] = ACTIONS(2076),
    [anon_sym_struct] = ACTIONS(2076),
    [anon_sym_union] = ACTIONS(2076),
    [anon_sym_if] = ACTIONS(2076),
    [anon_sym_else] = ACTIONS(2076),
    [anon_sym_switch] = ACTIONS(2076),
    [anon_sym_case] = ACTIONS(2076),
    [anon_sym_default] = ACTIONS(2076),
    [anon_sym_while] = ACTIONS(2076),
    [anon_sym_do] = ACTIONS(2076),
    [anon_sym_for] = ACTIONS(2076),
    [anon_sym_return] = ACTIONS(2076),
    [anon_sym_break] = ACTIONS(2076),
    [anon_sym_continue] = ACTIONS(2076),
    [anon_sym_goto] = ACTIONS(2076),
    [anon_sym___try] = ACTIONS(2076),
    [anon_sym___leave] = ACTIONS(2076),
    [anon_sym_not] = ACTIONS(2076),
    [anon_sym_compl] = ACTIONS(2076),
    [anon_sym_DASH_DASH] = ACTIONS(2078),
    [anon_sym_PLUS_PLUS] = ACTIONS(2078),
    [anon_sym_sizeof] = ACTIONS(2076),
    [anon_sym___alignof__] = ACTIONS(2076),
    [anon_sym___alignof] = ACTIONS(2076),
    [anon_sym__alignof] = ACTIONS(2076),
    [anon_sym_alignof] = ACTIONS(2076),
    [anon_sym__Alignof] = ACTIONS(2076),
    [anon_sym_offsetof] = ACTIONS(2076),
    [anon_sym__Generic] = ACTIONS(2076),
    [anon_sym_asm] = ACTIONS(2076),
    [anon_sym___asm__] = ACTIONS(2076),
    [sym_number_literal] = ACTIONS(2078),
    [anon_sym_L_SQUOTE] = ACTIONS(2078),
    [anon_sym_u_SQUOTE] = ACTIONS(2078),
    [anon_sym_U_SQUOTE] = ACTIONS(2078),
    [anon_sym_u8_SQUOTE] = ACTIONS(2078),
    [anon_sym_SQUOTE] = ACTIONS(2078),
    [anon_sym_L_DQUOTE] = ACTIONS(2078),
    [anon_sym_u_DQUOTE] = ACTIONS(2078),
    [anon_sym_U_DQUOTE] = ACTIONS(2078),
    [anon_sym_u8_DQUOTE] = ACTIONS(2078),
    [anon_sym_DQUOTE] = ACTIONS(2078),
    [sym_true] = ACTIONS(2076),
    [sym_false] = ACTIONS(2076),
    [anon_sym_NULL] = ACTIONS(2076),
    [anon_sym_nullptr] = ACTIONS(2076),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2076),
    [anon_sym_decltype] = ACTIONS(2076),
    [sym_virtual] = ACTIONS(2076),
    [anon_sym_explicit] = ACTIONS(2076),
    [anon_sym_typename] = ACTIONS(2076),
    [anon_sym_template] = ACTIONS(2076),
    [anon_sym_operator] = ACTIONS(2076),
    [anon_sym_try] = ACTIONS(2076),
    [anon_sym_delete] = ACTIONS(2076),
    [anon_sym_throw] = ACTIONS(2076),
    [anon_sym_namespace] = ACTIONS(2076),
    [anon_sym_using] = ACTIONS(2076),
    [anon_sym_static_assert] = ACTIONS(2076),
    [anon_sym_concept] = ACTIONS(2076),
    [anon_sym_co_return] = ACTIONS(2076),
    [anon_sym_co_yield] = ACTIONS(2076),
    [anon_sym_R_DQUOTE] = ACTIONS(2078),
    [anon_sym_LR_DQUOTE] = ACTIONS(2078),
    [anon_sym_uR_DQUOTE] = ACTIONS(2078),
    [anon_sym_UR_DQUOTE] = ACTIONS(2078),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2078),
    [anon_sym_co_await] = ACTIONS(2076),
    [anon_sym_new] = ACTIONS(2076),
    [anon_sym_requires] = ACTIONS(2076),
    [sym_this] = ACTIONS(2076),
    [anon_sym___launch_bounds__] = ACTIONS(2076),
  },
  [390] = {
    [sym_identifier] = ACTIONS(2072),
    [aux_sym_preproc_include_token1] = ACTIONS(2072),
    [aux_sym_preproc_def_token1] = ACTIONS(2072),
    [aux_sym_preproc_if_token1] = ACTIONS(2072),
    [aux_sym_preproc_if_token2] = ACTIONS(2072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2072),
    [sym_preproc_directive] = ACTIONS(2072),
    [anon_sym_LPAREN2] = ACTIONS(2074),
    [anon_sym_BANG] = ACTIONS(2074),
    [anon_sym_TILDE] = ACTIONS(2074),
    [anon_sym_DASH] = ACTIONS(2072),
    [anon_sym_PLUS] = ACTIONS(2072),
    [anon_sym_STAR] = ACTIONS(2074),
    [anon_sym_AMP_AMP] = ACTIONS(2074),
    [anon_sym_AMP] = ACTIONS(2072),
    [anon_sym_SEMI] = ACTIONS(2074),
    [anon_sym___extension__] = ACTIONS(2072),
    [anon_sym_typedef] = ACTIONS(2072),
    [anon_sym___device__] = ACTIONS(2072),
    [anon_sym___host__] = ACTIONS(2072),
    [anon_sym___global__] = ACTIONS(2072),
    [anon_sym___forceinline__] = ACTIONS(2072),
    [anon_sym___noinline__] = ACTIONS(2072),
    [anon_sym_extern] = ACTIONS(2072),
    [anon_sym___attribute__] = ACTIONS(2072),
    [anon_sym_COLON_COLON] = ACTIONS(2074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2074),
    [anon_sym___declspec] = ACTIONS(2072),
    [anon_sym___based] = ACTIONS(2072),
    [anon_sym___cdecl] = ACTIONS(2072),
    [anon_sym___clrcall] = ACTIONS(2072),
    [anon_sym___stdcall] = ACTIONS(2072),
    [anon_sym___fastcall] = ACTIONS(2072),
    [anon_sym___thiscall] = ACTIONS(2072),
    [anon_sym___vectorcall] = ACTIONS(2072),
    [anon_sym_LBRACE] = ACTIONS(2074),
    [anon_sym_signed] = ACTIONS(2072),
    [anon_sym_unsigned] = ACTIONS(2072),
    [anon_sym_long] = ACTIONS(2072),
    [anon_sym_short] = ACTIONS(2072),
    [anon_sym_LBRACK] = ACTIONS(2072),
    [anon_sym_static] = ACTIONS(2072),
    [anon_sym_register] = ACTIONS(2072),
    [anon_sym_inline] = ACTIONS(2072),
    [anon_sym___inline] = ACTIONS(2072),
    [anon_sym___inline__] = ACTIONS(2072),
    [anon_sym___forceinline] = ACTIONS(2072),
    [anon_sym_thread_local] = ACTIONS(2072),
    [anon_sym___thread] = ACTIONS(2072),
    [anon_sym_const] = ACTIONS(2072),
    [anon_sym_constexpr] = ACTIONS(2072),
    [anon_sym_volatile] = ACTIONS(2072),
    [anon_sym_restrict] = ACTIONS(2072),
    [anon_sym___restrict__] = ACTIONS(2072),
    [anon_sym__Atomic] = ACTIONS(2072),
    [anon_sym__Noreturn] = ACTIONS(2072),
    [anon_sym_noreturn] = ACTIONS(2072),
    [anon_sym_mutable] = ACTIONS(2072),
    [anon_sym_constinit] = ACTIONS(2072),
    [anon_sym_consteval] = ACTIONS(2072),
    [anon_sym___shared__] = ACTIONS(2072),
    [anon_sym___local__] = ACTIONS(2072),
    [anon_sym___constant__] = ACTIONS(2072),
    [anon_sym___managed__] = ACTIONS(2072),
    [anon_sym___grid_constant__] = ACTIONS(2072),
    [anon_sym_alignas] = ACTIONS(2072),
    [anon_sym__Alignas] = ACTIONS(2072),
    [sym_primitive_type] = ACTIONS(2072),
    [anon_sym_enum] = ACTIONS(2072),
    [anon_sym_class] = ACTIONS(2072),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2072),
    [anon_sym_if] = ACTIONS(2072),
    [anon_sym_else] = ACTIONS(2072),
    [anon_sym_switch] = ACTIONS(2072),
    [anon_sym_case] = ACTIONS(2072),
    [anon_sym_default] = ACTIONS(2072),
    [anon_sym_while] = ACTIONS(2072),
    [anon_sym_do] = ACTIONS(2072),
    [anon_sym_for] = ACTIONS(2072),
    [anon_sym_return] = ACTIONS(2072),
    [anon_sym_break] = ACTIONS(2072),
    [anon_sym_continue] = ACTIONS(2072),
    [anon_sym_goto] = ACTIONS(2072),
    [anon_sym___try] = ACTIONS(2072),
    [anon_sym___leave] = ACTIONS(2072),
    [anon_sym_not] = ACTIONS(2072),
    [anon_sym_compl] = ACTIONS(2072),
    [anon_sym_DASH_DASH] = ACTIONS(2074),
    [anon_sym_PLUS_PLUS] = ACTIONS(2074),
    [anon_sym_sizeof] = ACTIONS(2072),
    [anon_sym___alignof__] = ACTIONS(2072),
    [anon_sym___alignof] = ACTIONS(2072),
    [anon_sym__alignof] = ACTIONS(2072),
    [anon_sym_alignof] = ACTIONS(2072),
    [anon_sym__Alignof] = ACTIONS(2072),
    [anon_sym_offsetof] = ACTIONS(2072),
    [anon_sym__Generic] = ACTIONS(2072),
    [anon_sym_asm] = ACTIONS(2072),
    [anon_sym___asm__] = ACTIONS(2072),
    [sym_number_literal] = ACTIONS(2074),
    [anon_sym_L_SQUOTE] = ACTIONS(2074),
    [anon_sym_u_SQUOTE] = ACTIONS(2074),
    [anon_sym_U_SQUOTE] = ACTIONS(2074),
    [anon_sym_u8_SQUOTE] = ACTIONS(2074),
    [anon_sym_SQUOTE] = ACTIONS(2074),
    [anon_sym_L_DQUOTE] = ACTIONS(2074),
    [anon_sym_u_DQUOTE] = ACTIONS(2074),
    [anon_sym_U_DQUOTE] = ACTIONS(2074),
    [anon_sym_u8_DQUOTE] = ACTIONS(2074),
    [anon_sym_DQUOTE] = ACTIONS(2074),
    [sym_true] = ACTIONS(2072),
    [sym_false] = ACTIONS(2072),
    [anon_sym_NULL] = ACTIONS(2072),
    [anon_sym_nullptr] = ACTIONS(2072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2072),
    [anon_sym_decltype] = ACTIONS(2072),
    [sym_virtual] = ACTIONS(2072),
    [anon_sym_explicit] = ACTIONS(2072),
    [anon_sym_typename] = ACTIONS(2072),
    [anon_sym_template] = ACTIONS(2072),
    [anon_sym_operator] = ACTIONS(2072),
    [anon_sym_try] = ACTIONS(2072),
    [anon_sym_delete] = ACTIONS(2072),
    [anon_sym_throw] = ACTIONS(2072),
    [anon_sym_namespace] = ACTIONS(2072),
    [anon_sym_using] = ACTIONS(2072),
    [anon_sym_static_assert] = ACTIONS(2072),
    [anon_sym_concept] = ACTIONS(2072),
    [anon_sym_co_return] = ACTIONS(2072),
    [anon_sym_co_yield] = ACTIONS(2072),
    [anon_sym_R_DQUOTE] = ACTIONS(2074),
    [anon_sym_LR_DQUOTE] = ACTIONS(2074),
    [anon_sym_uR_DQUOTE] = ACTIONS(2074),
    [anon_sym_UR_DQUOTE] = ACTIONS(2074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2074),
    [anon_sym_co_await] = ACTIONS(2072),
    [anon_sym_new] = ACTIONS(2072),
    [anon_sym_requires] = ACTIONS(2072),
    [sym_this] = ACTIONS(2072),
    [anon_sym___launch_bounds__] = ACTIONS(2072),
  },
  [391] = {
    [sym_identifier] = ACTIONS(2008),
    [aux_sym_preproc_include_token1] = ACTIONS(2008),
    [aux_sym_preproc_def_token1] = ACTIONS(2008),
    [aux_sym_preproc_if_token1] = ACTIONS(2008),
    [aux_sym_preproc_if_token2] = ACTIONS(2008),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2008),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2008),
    [sym_preproc_directive] = ACTIONS(2008),
    [anon_sym_LPAREN2] = ACTIONS(2010),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_TILDE] = ACTIONS(2010),
    [anon_sym_DASH] = ACTIONS(2008),
    [anon_sym_PLUS] = ACTIONS(2008),
    [anon_sym_STAR] = ACTIONS(2010),
    [anon_sym_AMP_AMP] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2008),
    [anon_sym_SEMI] = ACTIONS(2010),
    [anon_sym___extension__] = ACTIONS(2008),
    [anon_sym_typedef] = ACTIONS(2008),
    [anon_sym___device__] = ACTIONS(2008),
    [anon_sym___host__] = ACTIONS(2008),
    [anon_sym___global__] = ACTIONS(2008),
    [anon_sym___forceinline__] = ACTIONS(2008),
    [anon_sym___noinline__] = ACTIONS(2008),
    [anon_sym_extern] = ACTIONS(2008),
    [anon_sym___attribute__] = ACTIONS(2008),
    [anon_sym_COLON_COLON] = ACTIONS(2010),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2010),
    [anon_sym___declspec] = ACTIONS(2008),
    [anon_sym___based] = ACTIONS(2008),
    [anon_sym___cdecl] = ACTIONS(2008),
    [anon_sym___clrcall] = ACTIONS(2008),
    [anon_sym___stdcall] = ACTIONS(2008),
    [anon_sym___fastcall] = ACTIONS(2008),
    [anon_sym___thiscall] = ACTIONS(2008),
    [anon_sym___vectorcall] = ACTIONS(2008),
    [anon_sym_LBRACE] = ACTIONS(2010),
    [anon_sym_signed] = ACTIONS(2008),
    [anon_sym_unsigned] = ACTIONS(2008),
    [anon_sym_long] = ACTIONS(2008),
    [anon_sym_short] = ACTIONS(2008),
    [anon_sym_LBRACK] = ACTIONS(2008),
    [anon_sym_static] = ACTIONS(2008),
    [anon_sym_register] = ACTIONS(2008),
    [anon_sym_inline] = ACTIONS(2008),
    [anon_sym___inline] = ACTIONS(2008),
    [anon_sym___inline__] = ACTIONS(2008),
    [anon_sym___forceinline] = ACTIONS(2008),
    [anon_sym_thread_local] = ACTIONS(2008),
    [anon_sym___thread] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(2008),
    [anon_sym_constexpr] = ACTIONS(2008),
    [anon_sym_volatile] = ACTIONS(2008),
    [anon_sym_restrict] = ACTIONS(2008),
    [anon_sym___restrict__] = ACTIONS(2008),
    [anon_sym__Atomic] = ACTIONS(2008),
    [anon_sym__Noreturn] = ACTIONS(2008),
    [anon_sym_noreturn] = ACTIONS(2008),
    [anon_sym_mutable] = ACTIONS(2008),
    [anon_sym_constinit] = ACTIONS(2008),
    [anon_sym_consteval] = ACTIONS(2008),
    [anon_sym___shared__] = ACTIONS(2008),
    [anon_sym___local__] = ACTIONS(2008),
    [anon_sym___constant__] = ACTIONS(2008),
    [anon_sym___managed__] = ACTIONS(2008),
    [anon_sym___grid_constant__] = ACTIONS(2008),
    [anon_sym_alignas] = ACTIONS(2008),
    [anon_sym__Alignas] = ACTIONS(2008),
    [sym_primitive_type] = ACTIONS(2008),
    [anon_sym_enum] = ACTIONS(2008),
    [anon_sym_class] = ACTIONS(2008),
    [anon_sym_struct] = ACTIONS(2008),
    [anon_sym_union] = ACTIONS(2008),
    [anon_sym_if] = ACTIONS(2008),
    [anon_sym_else] = ACTIONS(2008),
    [anon_sym_switch] = ACTIONS(2008),
    [anon_sym_case] = ACTIONS(2008),
    [anon_sym_default] = ACTIONS(2008),
    [anon_sym_while] = ACTIONS(2008),
    [anon_sym_do] = ACTIONS(2008),
    [anon_sym_for] = ACTIONS(2008),
    [anon_sym_return] = ACTIONS(2008),
    [anon_sym_break] = ACTIONS(2008),
    [anon_sym_continue] = ACTIONS(2008),
    [anon_sym_goto] = ACTIONS(2008),
    [anon_sym___try] = ACTIONS(2008),
    [anon_sym___leave] = ACTIONS(2008),
    [anon_sym_not] = ACTIONS(2008),
    [anon_sym_compl] = ACTIONS(2008),
    [anon_sym_DASH_DASH] = ACTIONS(2010),
    [anon_sym_PLUS_PLUS] = ACTIONS(2010),
    [anon_sym_sizeof] = ACTIONS(2008),
    [anon_sym___alignof__] = ACTIONS(2008),
    [anon_sym___alignof] = ACTIONS(2008),
    [anon_sym__alignof] = ACTIONS(2008),
    [anon_sym_alignof] = ACTIONS(2008),
    [anon_sym__Alignof] = ACTIONS(2008),
    [anon_sym_offsetof] = ACTIONS(2008),
    [anon_sym__Generic] = ACTIONS(2008),
    [anon_sym_asm] = ACTIONS(2008),
    [anon_sym___asm__] = ACTIONS(2008),
    [sym_number_literal] = ACTIONS(2010),
    [anon_sym_L_SQUOTE] = ACTIONS(2010),
    [anon_sym_u_SQUOTE] = ACTIONS(2010),
    [anon_sym_U_SQUOTE] = ACTIONS(2010),
    [anon_sym_u8_SQUOTE] = ACTIONS(2010),
    [anon_sym_SQUOTE] = ACTIONS(2010),
    [anon_sym_L_DQUOTE] = ACTIONS(2010),
    [anon_sym_u_DQUOTE] = ACTIONS(2010),
    [anon_sym_U_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8_DQUOTE] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [sym_true] = ACTIONS(2008),
    [sym_false] = ACTIONS(2008),
    [anon_sym_NULL] = ACTIONS(2008),
    [anon_sym_nullptr] = ACTIONS(2008),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2008),
    [anon_sym_decltype] = ACTIONS(2008),
    [sym_virtual] = ACTIONS(2008),
    [anon_sym_explicit] = ACTIONS(2008),
    [anon_sym_typename] = ACTIONS(2008),
    [anon_sym_template] = ACTIONS(2008),
    [anon_sym_operator] = ACTIONS(2008),
    [anon_sym_try] = ACTIONS(2008),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_throw] = ACTIONS(2008),
    [anon_sym_namespace] = ACTIONS(2008),
    [anon_sym_using] = ACTIONS(2008),
    [anon_sym_static_assert] = ACTIONS(2008),
    [anon_sym_concept] = ACTIONS(2008),
    [anon_sym_co_return] = ACTIONS(2008),
    [anon_sym_co_yield] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2008),
    [anon_sym_new] = ACTIONS(2008),
    [anon_sym_requires] = ACTIONS(2008),
    [sym_this] = ACTIONS(2008),
    [anon_sym___launch_bounds__] = ACTIONS(2008),
  },
  [392] = {
    [sym_identifier] = ACTIONS(2004),
    [aux_sym_preproc_include_token1] = ACTIONS(2004),
    [aux_sym_preproc_def_token1] = ACTIONS(2004),
    [aux_sym_preproc_if_token1] = ACTIONS(2004),
    [aux_sym_preproc_if_token2] = ACTIONS(2004),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2004),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2004),
    [sym_preproc_directive] = ACTIONS(2004),
    [anon_sym_LPAREN2] = ACTIONS(2006),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(2006),
    [anon_sym_DASH] = ACTIONS(2004),
    [anon_sym_PLUS] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(2006),
    [anon_sym_AMP_AMP] = ACTIONS(2006),
    [anon_sym_AMP] = ACTIONS(2004),
    [anon_sym_SEMI] = ACTIONS(2006),
    [anon_sym___extension__] = ACTIONS(2004),
    [anon_sym_typedef] = ACTIONS(2004),
    [anon_sym___device__] = ACTIONS(2004),
    [anon_sym___host__] = ACTIONS(2004),
    [anon_sym___global__] = ACTIONS(2004),
    [anon_sym___forceinline__] = ACTIONS(2004),
    [anon_sym___noinline__] = ACTIONS(2004),
    [anon_sym_extern] = ACTIONS(2004),
    [anon_sym___attribute__] = ACTIONS(2004),
    [anon_sym_COLON_COLON] = ACTIONS(2006),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2006),
    [anon_sym___declspec] = ACTIONS(2004),
    [anon_sym___based] = ACTIONS(2004),
    [anon_sym___cdecl] = ACTIONS(2004),
    [anon_sym___clrcall] = ACTIONS(2004),
    [anon_sym___stdcall] = ACTIONS(2004),
    [anon_sym___fastcall] = ACTIONS(2004),
    [anon_sym___thiscall] = ACTIONS(2004),
    [anon_sym___vectorcall] = ACTIONS(2004),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_signed] = ACTIONS(2004),
    [anon_sym_unsigned] = ACTIONS(2004),
    [anon_sym_long] = ACTIONS(2004),
    [anon_sym_short] = ACTIONS(2004),
    [anon_sym_LBRACK] = ACTIONS(2004),
    [anon_sym_static] = ACTIONS(2004),
    [anon_sym_register] = ACTIONS(2004),
    [anon_sym_inline] = ACTIONS(2004),
    [anon_sym___inline] = ACTIONS(2004),
    [anon_sym___inline__] = ACTIONS(2004),
    [anon_sym___forceinline] = ACTIONS(2004),
    [anon_sym_thread_local] = ACTIONS(2004),
    [anon_sym___thread] = ACTIONS(2004),
    [anon_sym_const] = ACTIONS(2004),
    [anon_sym_constexpr] = ACTIONS(2004),
    [anon_sym_volatile] = ACTIONS(2004),
    [anon_sym_restrict] = ACTIONS(2004),
    [anon_sym___restrict__] = ACTIONS(2004),
    [anon_sym__Atomic] = ACTIONS(2004),
    [anon_sym__Noreturn] = ACTIONS(2004),
    [anon_sym_noreturn] = ACTIONS(2004),
    [anon_sym_mutable] = ACTIONS(2004),
    [anon_sym_constinit] = ACTIONS(2004),
    [anon_sym_consteval] = ACTIONS(2004),
    [anon_sym___shared__] = ACTIONS(2004),
    [anon_sym___local__] = ACTIONS(2004),
    [anon_sym___constant__] = ACTIONS(2004),
    [anon_sym___managed__] = ACTIONS(2004),
    [anon_sym___grid_constant__] = ACTIONS(2004),
    [anon_sym_alignas] = ACTIONS(2004),
    [anon_sym__Alignas] = ACTIONS(2004),
    [sym_primitive_type] = ACTIONS(2004),
    [anon_sym_enum] = ACTIONS(2004),
    [anon_sym_class] = ACTIONS(2004),
    [anon_sym_struct] = ACTIONS(2004),
    [anon_sym_union] = ACTIONS(2004),
    [anon_sym_if] = ACTIONS(2004),
    [anon_sym_else] = ACTIONS(2004),
    [anon_sym_switch] = ACTIONS(2004),
    [anon_sym_case] = ACTIONS(2004),
    [anon_sym_default] = ACTIONS(2004),
    [anon_sym_while] = ACTIONS(2004),
    [anon_sym_do] = ACTIONS(2004),
    [anon_sym_for] = ACTIONS(2004),
    [anon_sym_return] = ACTIONS(2004),
    [anon_sym_break] = ACTIONS(2004),
    [anon_sym_continue] = ACTIONS(2004),
    [anon_sym_goto] = ACTIONS(2004),
    [anon_sym___try] = ACTIONS(2004),
    [anon_sym___leave] = ACTIONS(2004),
    [anon_sym_not] = ACTIONS(2004),
    [anon_sym_compl] = ACTIONS(2004),
    [anon_sym_DASH_DASH] = ACTIONS(2006),
    [anon_sym_PLUS_PLUS] = ACTIONS(2006),
    [anon_sym_sizeof] = ACTIONS(2004),
    [anon_sym___alignof__] = ACTIONS(2004),
    [anon_sym___alignof] = ACTIONS(2004),
    [anon_sym__alignof] = ACTIONS(2004),
    [anon_sym_alignof] = ACTIONS(2004),
    [anon_sym__Alignof] = ACTIONS(2004),
    [anon_sym_offsetof] = ACTIONS(2004),
    [anon_sym__Generic] = ACTIONS(2004),
    [anon_sym_asm] = ACTIONS(2004),
    [anon_sym___asm__] = ACTIONS(2004),
    [sym_number_literal] = ACTIONS(2006),
    [anon_sym_L_SQUOTE] = ACTIONS(2006),
    [anon_sym_u_SQUOTE] = ACTIONS(2006),
    [anon_sym_U_SQUOTE] = ACTIONS(2006),
    [anon_sym_u8_SQUOTE] = ACTIONS(2006),
    [anon_sym_SQUOTE] = ACTIONS(2006),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(2004),
    [sym_false] = ACTIONS(2004),
    [anon_sym_NULL] = ACTIONS(2004),
    [anon_sym_nullptr] = ACTIONS(2004),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2004),
    [anon_sym_decltype] = ACTIONS(2004),
    [sym_virtual] = ACTIONS(2004),
    [anon_sym_explicit] = ACTIONS(2004),
    [anon_sym_typename] = ACTIONS(2004),
    [anon_sym_template] = ACTIONS(2004),
    [anon_sym_operator] = ACTIONS(2004),
    [anon_sym_try] = ACTIONS(2004),
    [anon_sym_delete] = ACTIONS(2004),
    [anon_sym_throw] = ACTIONS(2004),
    [anon_sym_namespace] = ACTIONS(2004),
    [anon_sym_using] = ACTIONS(2004),
    [anon_sym_static_assert] = ACTIONS(2004),
    [anon_sym_concept] = ACTIONS(2004),
    [anon_sym_co_return] = ACTIONS(2004),
    [anon_sym_co_yield] = ACTIONS(2004),
    [anon_sym_R_DQUOTE] = ACTIONS(2006),
    [anon_sym_LR_DQUOTE] = ACTIONS(2006),
    [anon_sym_uR_DQUOTE] = ACTIONS(2006),
    [anon_sym_UR_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2006),
    [anon_sym_co_await] = ACTIONS(2004),
    [anon_sym_new] = ACTIONS(2004),
    [anon_sym_requires] = ACTIONS(2004),
    [sym_this] = ACTIONS(2004),
    [anon_sym___launch_bounds__] = ACTIONS(2004),
  },
  [393] = {
    [sym_identifier] = ACTIONS(1950),
    [aux_sym_preproc_include_token1] = ACTIONS(1950),
    [aux_sym_preproc_def_token1] = ACTIONS(1950),
    [aux_sym_preproc_if_token1] = ACTIONS(1950),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1950),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1950),
    [sym_preproc_directive] = ACTIONS(1950),
    [anon_sym_LPAREN2] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1952),
    [anon_sym_TILDE] = ACTIONS(1952),
    [anon_sym_DASH] = ACTIONS(1950),
    [anon_sym_PLUS] = ACTIONS(1950),
    [anon_sym_STAR] = ACTIONS(1952),
    [anon_sym_AMP_AMP] = ACTIONS(1952),
    [anon_sym_AMP] = ACTIONS(1950),
    [anon_sym_SEMI] = ACTIONS(1952),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_typedef] = ACTIONS(1950),
    [anon_sym___device__] = ACTIONS(1950),
    [anon_sym___host__] = ACTIONS(1950),
    [anon_sym___global__] = ACTIONS(1950),
    [anon_sym___forceinline__] = ACTIONS(1950),
    [anon_sym___noinline__] = ACTIONS(1950),
    [anon_sym_extern] = ACTIONS(1950),
    [anon_sym___attribute__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1952),
    [anon_sym___declspec] = ACTIONS(1950),
    [anon_sym___based] = ACTIONS(1950),
    [anon_sym___cdecl] = ACTIONS(1950),
    [anon_sym___clrcall] = ACTIONS(1950),
    [anon_sym___stdcall] = ACTIONS(1950),
    [anon_sym___fastcall] = ACTIONS(1950),
    [anon_sym___thiscall] = ACTIONS(1950),
    [anon_sym___vectorcall] = ACTIONS(1950),
    [anon_sym_LBRACE] = ACTIONS(1952),
    [anon_sym_RBRACE] = ACTIONS(1952),
    [anon_sym_signed] = ACTIONS(1950),
    [anon_sym_unsigned] = ACTIONS(1950),
    [anon_sym_long] = ACTIONS(1950),
    [anon_sym_short] = ACTIONS(1950),
    [anon_sym_LBRACK] = ACTIONS(1950),
    [anon_sym_static] = ACTIONS(1950),
    [anon_sym_register] = ACTIONS(1950),
    [anon_sym_inline] = ACTIONS(1950),
    [anon_sym___inline] = ACTIONS(1950),
    [anon_sym___inline__] = ACTIONS(1950),
    [anon_sym___forceinline] = ACTIONS(1950),
    [anon_sym_thread_local] = ACTIONS(1950),
    [anon_sym___thread] = ACTIONS(1950),
    [anon_sym_const] = ACTIONS(1950),
    [anon_sym_constexpr] = ACTIONS(1950),
    [anon_sym_volatile] = ACTIONS(1950),
    [anon_sym_restrict] = ACTIONS(1950),
    [anon_sym___restrict__] = ACTIONS(1950),
    [anon_sym__Atomic] = ACTIONS(1950),
    [anon_sym__Noreturn] = ACTIONS(1950),
    [anon_sym_noreturn] = ACTIONS(1950),
    [anon_sym_mutable] = ACTIONS(1950),
    [anon_sym_constinit] = ACTIONS(1950),
    [anon_sym_consteval] = ACTIONS(1950),
    [anon_sym___shared__] = ACTIONS(1950),
    [anon_sym___local__] = ACTIONS(1950),
    [anon_sym___constant__] = ACTIONS(1950),
    [anon_sym___managed__] = ACTIONS(1950),
    [anon_sym___grid_constant__] = ACTIONS(1950),
    [anon_sym_alignas] = ACTIONS(1950),
    [anon_sym__Alignas] = ACTIONS(1950),
    [sym_primitive_type] = ACTIONS(1950),
    [anon_sym_enum] = ACTIONS(1950),
    [anon_sym_class] = ACTIONS(1950),
    [anon_sym_struct] = ACTIONS(1950),
    [anon_sym_union] = ACTIONS(1950),
    [anon_sym_if] = ACTIONS(1950),
    [anon_sym_else] = ACTIONS(1950),
    [anon_sym_switch] = ACTIONS(1950),
    [anon_sym_case] = ACTIONS(1950),
    [anon_sym_default] = ACTIONS(1950),
    [anon_sym_while] = ACTIONS(1950),
    [anon_sym_do] = ACTIONS(1950),
    [anon_sym_for] = ACTIONS(1950),
    [anon_sym_return] = ACTIONS(1950),
    [anon_sym_break] = ACTIONS(1950),
    [anon_sym_continue] = ACTIONS(1950),
    [anon_sym_goto] = ACTIONS(1950),
    [anon_sym___try] = ACTIONS(1950),
    [anon_sym___leave] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1950),
    [anon_sym_compl] = ACTIONS(1950),
    [anon_sym_DASH_DASH] = ACTIONS(1952),
    [anon_sym_PLUS_PLUS] = ACTIONS(1952),
    [anon_sym_sizeof] = ACTIONS(1950),
    [anon_sym___alignof__] = ACTIONS(1950),
    [anon_sym___alignof] = ACTIONS(1950),
    [anon_sym__alignof] = ACTIONS(1950),
    [anon_sym_alignof] = ACTIONS(1950),
    [anon_sym__Alignof] = ACTIONS(1950),
    [anon_sym_offsetof] = ACTIONS(1950),
    [anon_sym__Generic] = ACTIONS(1950),
    [anon_sym_asm] = ACTIONS(1950),
    [anon_sym___asm__] = ACTIONS(1950),
    [sym_number_literal] = ACTIONS(1952),
    [anon_sym_L_SQUOTE] = ACTIONS(1952),
    [anon_sym_u_SQUOTE] = ACTIONS(1952),
    [anon_sym_U_SQUOTE] = ACTIONS(1952),
    [anon_sym_u8_SQUOTE] = ACTIONS(1952),
    [anon_sym_SQUOTE] = ACTIONS(1952),
    [anon_sym_L_DQUOTE] = ACTIONS(1952),
    [anon_sym_u_DQUOTE] = ACTIONS(1952),
    [anon_sym_U_DQUOTE] = ACTIONS(1952),
    [anon_sym_u8_DQUOTE] = ACTIONS(1952),
    [anon_sym_DQUOTE] = ACTIONS(1952),
    [sym_true] = ACTIONS(1950),
    [sym_false] = ACTIONS(1950),
    [anon_sym_NULL] = ACTIONS(1950),
    [anon_sym_nullptr] = ACTIONS(1950),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1950),
    [anon_sym_decltype] = ACTIONS(1950),
    [sym_virtual] = ACTIONS(1950),
    [anon_sym_explicit] = ACTIONS(1950),
    [anon_sym_typename] = ACTIONS(1950),
    [anon_sym_template] = ACTIONS(1950),
    [anon_sym_operator] = ACTIONS(1950),
    [anon_sym_try] = ACTIONS(1950),
    [anon_sym_delete] = ACTIONS(1950),
    [anon_sym_throw] = ACTIONS(1950),
    [anon_sym_namespace] = ACTIONS(1950),
    [anon_sym_using] = ACTIONS(1950),
    [anon_sym_static_assert] = ACTIONS(1950),
    [anon_sym_concept] = ACTIONS(1950),
    [anon_sym_co_return] = ACTIONS(1950),
    [anon_sym_co_yield] = ACTIONS(1950),
    [anon_sym_R_DQUOTE] = ACTIONS(1952),
    [anon_sym_LR_DQUOTE] = ACTIONS(1952),
    [anon_sym_uR_DQUOTE] = ACTIONS(1952),
    [anon_sym_UR_DQUOTE] = ACTIONS(1952),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1952),
    [anon_sym_co_await] = ACTIONS(1950),
    [anon_sym_new] = ACTIONS(1950),
    [anon_sym_requires] = ACTIONS(1950),
    [sym_this] = ACTIONS(1950),
    [anon_sym___launch_bounds__] = ACTIONS(1950),
  },
  [394] = {
    [sym_identifier] = ACTIONS(2028),
    [aux_sym_preproc_include_token1] = ACTIONS(2028),
    [aux_sym_preproc_def_token1] = ACTIONS(2028),
    [aux_sym_preproc_if_token1] = ACTIONS(2028),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2028),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2028),
    [sym_preproc_directive] = ACTIONS(2028),
    [anon_sym_LPAREN2] = ACTIONS(2030),
    [anon_sym_BANG] = ACTIONS(2030),
    [anon_sym_TILDE] = ACTIONS(2030),
    [anon_sym_DASH] = ACTIONS(2028),
    [anon_sym_PLUS] = ACTIONS(2028),
    [anon_sym_STAR] = ACTIONS(2030),
    [anon_sym_AMP_AMP] = ACTIONS(2030),
    [anon_sym_AMP] = ACTIONS(2028),
    [anon_sym_SEMI] = ACTIONS(2030),
    [anon_sym___extension__] = ACTIONS(2028),
    [anon_sym_typedef] = ACTIONS(2028),
    [anon_sym___device__] = ACTIONS(2028),
    [anon_sym___host__] = ACTIONS(2028),
    [anon_sym___global__] = ACTIONS(2028),
    [anon_sym___forceinline__] = ACTIONS(2028),
    [anon_sym___noinline__] = ACTIONS(2028),
    [anon_sym_extern] = ACTIONS(2028),
    [anon_sym___attribute__] = ACTIONS(2028),
    [anon_sym_COLON_COLON] = ACTIONS(2030),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2030),
    [anon_sym___declspec] = ACTIONS(2028),
    [anon_sym___based] = ACTIONS(2028),
    [anon_sym___cdecl] = ACTIONS(2028),
    [anon_sym___clrcall] = ACTIONS(2028),
    [anon_sym___stdcall] = ACTIONS(2028),
    [anon_sym___fastcall] = ACTIONS(2028),
    [anon_sym___thiscall] = ACTIONS(2028),
    [anon_sym___vectorcall] = ACTIONS(2028),
    [anon_sym_LBRACE] = ACTIONS(2030),
    [anon_sym_RBRACE] = ACTIONS(2030),
    [anon_sym_signed] = ACTIONS(2028),
    [anon_sym_unsigned] = ACTIONS(2028),
    [anon_sym_long] = ACTIONS(2028),
    [anon_sym_short] = ACTIONS(2028),
    [anon_sym_LBRACK] = ACTIONS(2028),
    [anon_sym_static] = ACTIONS(2028),
    [anon_sym_register] = ACTIONS(2028),
    [anon_sym_inline] = ACTIONS(2028),
    [anon_sym___inline] = ACTIONS(2028),
    [anon_sym___inline__] = ACTIONS(2028),
    [anon_sym___forceinline] = ACTIONS(2028),
    [anon_sym_thread_local] = ACTIONS(2028),
    [anon_sym___thread] = ACTIONS(2028),
    [anon_sym_const] = ACTIONS(2028),
    [anon_sym_constexpr] = ACTIONS(2028),
    [anon_sym_volatile] = ACTIONS(2028),
    [anon_sym_restrict] = ACTIONS(2028),
    [anon_sym___restrict__] = ACTIONS(2028),
    [anon_sym__Atomic] = ACTIONS(2028),
    [anon_sym__Noreturn] = ACTIONS(2028),
    [anon_sym_noreturn] = ACTIONS(2028),
    [anon_sym_mutable] = ACTIONS(2028),
    [anon_sym_constinit] = ACTIONS(2028),
    [anon_sym_consteval] = ACTIONS(2028),
    [anon_sym___shared__] = ACTIONS(2028),
    [anon_sym___local__] = ACTIONS(2028),
    [anon_sym___constant__] = ACTIONS(2028),
    [anon_sym___managed__] = ACTIONS(2028),
    [anon_sym___grid_constant__] = ACTIONS(2028),
    [anon_sym_alignas] = ACTIONS(2028),
    [anon_sym__Alignas] = ACTIONS(2028),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_enum] = ACTIONS(2028),
    [anon_sym_class] = ACTIONS(2028),
    [anon_sym_struct] = ACTIONS(2028),
    [anon_sym_union] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(2028),
    [anon_sym_else] = ACTIONS(2028),
    [anon_sym_switch] = ACTIONS(2028),
    [anon_sym_case] = ACTIONS(2028),
    [anon_sym_default] = ACTIONS(2028),
    [anon_sym_while] = ACTIONS(2028),
    [anon_sym_do] = ACTIONS(2028),
    [anon_sym_for] = ACTIONS(2028),
    [anon_sym_return] = ACTIONS(2028),
    [anon_sym_break] = ACTIONS(2028),
    [anon_sym_continue] = ACTIONS(2028),
    [anon_sym_goto] = ACTIONS(2028),
    [anon_sym___try] = ACTIONS(2028),
    [anon_sym___leave] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(2028),
    [anon_sym_compl] = ACTIONS(2028),
    [anon_sym_DASH_DASH] = ACTIONS(2030),
    [anon_sym_PLUS_PLUS] = ACTIONS(2030),
    [anon_sym_sizeof] = ACTIONS(2028),
    [anon_sym___alignof__] = ACTIONS(2028),
    [anon_sym___alignof] = ACTIONS(2028),
    [anon_sym__alignof] = ACTIONS(2028),
    [anon_sym_alignof] = ACTIONS(2028),
    [anon_sym__Alignof] = ACTIONS(2028),
    [anon_sym_offsetof] = ACTIONS(2028),
    [anon_sym__Generic] = ACTIONS(2028),
    [anon_sym_asm] = ACTIONS(2028),
    [anon_sym___asm__] = ACTIONS(2028),
    [sym_number_literal] = ACTIONS(2030),
    [anon_sym_L_SQUOTE] = ACTIONS(2030),
    [anon_sym_u_SQUOTE] = ACTIONS(2030),
    [anon_sym_U_SQUOTE] = ACTIONS(2030),
    [anon_sym_u8_SQUOTE] = ACTIONS(2030),
    [anon_sym_SQUOTE] = ACTIONS(2030),
    [anon_sym_L_DQUOTE] = ACTIONS(2030),
    [anon_sym_u_DQUOTE] = ACTIONS(2030),
    [anon_sym_U_DQUOTE] = ACTIONS(2030),
    [anon_sym_u8_DQUOTE] = ACTIONS(2030),
    [anon_sym_DQUOTE] = ACTIONS(2030),
    [sym_true] = ACTIONS(2028),
    [sym_false] = ACTIONS(2028),
    [anon_sym_NULL] = ACTIONS(2028),
    [anon_sym_nullptr] = ACTIONS(2028),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2028),
    [anon_sym_decltype] = ACTIONS(2028),
    [sym_virtual] = ACTIONS(2028),
    [anon_sym_explicit] = ACTIONS(2028),
    [anon_sym_typename] = ACTIONS(2028),
    [anon_sym_template] = ACTIONS(2028),
    [anon_sym_operator] = ACTIONS(2028),
    [anon_sym_try] = ACTIONS(2028),
    [anon_sym_delete] = ACTIONS(2028),
    [anon_sym_throw] = ACTIONS(2028),
    [anon_sym_namespace] = ACTIONS(2028),
    [anon_sym_using] = ACTIONS(2028),
    [anon_sym_static_assert] = ACTIONS(2028),
    [anon_sym_concept] = ACTIONS(2028),
    [anon_sym_co_return] = ACTIONS(2028),
    [anon_sym_co_yield] = ACTIONS(2028),
    [anon_sym_R_DQUOTE] = ACTIONS(2030),
    [anon_sym_LR_DQUOTE] = ACTIONS(2030),
    [anon_sym_uR_DQUOTE] = ACTIONS(2030),
    [anon_sym_UR_DQUOTE] = ACTIONS(2030),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2030),
    [anon_sym_co_await] = ACTIONS(2028),
    [anon_sym_new] = ACTIONS(2028),
    [anon_sym_requires] = ACTIONS(2028),
    [sym_this] = ACTIONS(2028),
    [anon_sym___launch_bounds__] = ACTIONS(2028),
  },
  [395] = {
    [sym_identifier] = ACTIONS(1901),
    [aux_sym_preproc_include_token1] = ACTIONS(1901),
    [aux_sym_preproc_def_token1] = ACTIONS(1901),
    [anon_sym_COMMA] = ACTIONS(1962),
    [aux_sym_preproc_if_token1] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1901),
    [sym_preproc_directive] = ACTIONS(1901),
    [anon_sym_LPAREN2] = ACTIONS(1899),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_DASH] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1901),
    [anon_sym_STAR] = ACTIONS(1899),
    [anon_sym_AMP_AMP] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1901),
    [anon_sym_SEMI] = ACTIONS(1962),
    [anon_sym___extension__] = ACTIONS(1901),
    [anon_sym_typedef] = ACTIONS(1901),
    [anon_sym___device__] = ACTIONS(1901),
    [anon_sym___host__] = ACTIONS(1901),
    [anon_sym___global__] = ACTIONS(1901),
    [anon_sym___forceinline__] = ACTIONS(1901),
    [anon_sym___noinline__] = ACTIONS(1901),
    [anon_sym_extern] = ACTIONS(1901),
    [anon_sym___attribute__] = ACTIONS(1901),
    [anon_sym_COLON_COLON] = ACTIONS(1899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1899),
    [anon_sym___declspec] = ACTIONS(1901),
    [anon_sym___based] = ACTIONS(1901),
    [anon_sym___cdecl] = ACTIONS(1901),
    [anon_sym___clrcall] = ACTIONS(1901),
    [anon_sym___stdcall] = ACTIONS(1901),
    [anon_sym___fastcall] = ACTIONS(1901),
    [anon_sym___thiscall] = ACTIONS(1901),
    [anon_sym___vectorcall] = ACTIONS(1901),
    [anon_sym_LBRACE] = ACTIONS(1899),
    [anon_sym_RBRACE] = ACTIONS(1899),
    [anon_sym_signed] = ACTIONS(1901),
    [anon_sym_unsigned] = ACTIONS(1901),
    [anon_sym_long] = ACTIONS(1901),
    [anon_sym_short] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1901),
    [anon_sym_static] = ACTIONS(1901),
    [anon_sym_register] = ACTIONS(1901),
    [anon_sym_inline] = ACTIONS(1901),
    [anon_sym___inline] = ACTIONS(1901),
    [anon_sym___inline__] = ACTIONS(1901),
    [anon_sym___forceinline] = ACTIONS(1901),
    [anon_sym_thread_local] = ACTIONS(1901),
    [anon_sym___thread] = ACTIONS(1901),
    [anon_sym_const] = ACTIONS(1901),
    [anon_sym_constexpr] = ACTIONS(1901),
    [anon_sym_volatile] = ACTIONS(1901),
    [anon_sym_restrict] = ACTIONS(1901),
    [anon_sym___restrict__] = ACTIONS(1901),
    [anon_sym__Atomic] = ACTIONS(1901),
    [anon_sym__Noreturn] = ACTIONS(1901),
    [anon_sym_noreturn] = ACTIONS(1901),
    [anon_sym_mutable] = ACTIONS(1901),
    [anon_sym_constinit] = ACTIONS(1901),
    [anon_sym_consteval] = ACTIONS(1901),
    [anon_sym___shared__] = ACTIONS(1901),
    [anon_sym___local__] = ACTIONS(1901),
    [anon_sym___constant__] = ACTIONS(1901),
    [anon_sym___managed__] = ACTIONS(1901),
    [anon_sym___grid_constant__] = ACTIONS(1901),
    [anon_sym_alignas] = ACTIONS(1901),
    [anon_sym__Alignas] = ACTIONS(1901),
    [sym_primitive_type] = ACTIONS(1901),
    [anon_sym_enum] = ACTIONS(1901),
    [anon_sym_class] = ACTIONS(1901),
    [anon_sym_struct] = ACTIONS(1901),
    [anon_sym_union] = ACTIONS(1901),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_switch] = ACTIONS(1901),
    [anon_sym_case] = ACTIONS(1901),
    [anon_sym_default] = ACTIONS(1901),
    [anon_sym_while] = ACTIONS(1901),
    [anon_sym_do] = ACTIONS(1901),
    [anon_sym_for] = ACTIONS(1901),
    [anon_sym_return] = ACTIONS(1901),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_continue] = ACTIONS(1901),
    [anon_sym_goto] = ACTIONS(1901),
    [anon_sym___try] = ACTIONS(1901),
    [anon_sym___leave] = ACTIONS(1901),
    [anon_sym_not] = ACTIONS(1901),
    [anon_sym_compl] = ACTIONS(1901),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_sizeof] = ACTIONS(1901),
    [anon_sym___alignof__] = ACTIONS(1901),
    [anon_sym___alignof] = ACTIONS(1901),
    [anon_sym__alignof] = ACTIONS(1901),
    [anon_sym_alignof] = ACTIONS(1901),
    [anon_sym__Alignof] = ACTIONS(1901),
    [anon_sym_offsetof] = ACTIONS(1901),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1901),
    [anon_sym___asm__] = ACTIONS(1901),
    [sym_number_literal] = ACTIONS(1899),
    [anon_sym_L_SQUOTE] = ACTIONS(1899),
    [anon_sym_u_SQUOTE] = ACTIONS(1899),
    [anon_sym_U_SQUOTE] = ACTIONS(1899),
    [anon_sym_u8_SQUOTE] = ACTIONS(1899),
    [anon_sym_SQUOTE] = ACTIONS(1899),
    [anon_sym_L_DQUOTE] = ACTIONS(1899),
    [anon_sym_u_DQUOTE] = ACTIONS(1899),
    [anon_sym_U_DQUOTE] = ACTIONS(1899),
    [anon_sym_u8_DQUOTE] = ACTIONS(1899),
    [anon_sym_DQUOTE] = ACTIONS(1899),
    [sym_true] = ACTIONS(1901),
    [sym_false] = ACTIONS(1901),
    [anon_sym_NULL] = ACTIONS(1901),
    [anon_sym_nullptr] = ACTIONS(1901),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1901),
    [anon_sym_decltype] = ACTIONS(1901),
    [sym_virtual] = ACTIONS(1901),
    [anon_sym_explicit] = ACTIONS(1901),
    [anon_sym_typename] = ACTIONS(1901),
    [anon_sym_template] = ACTIONS(1901),
    [anon_sym_operator] = ACTIONS(1901),
    [anon_sym_try] = ACTIONS(1901),
    [anon_sym_delete] = ACTIONS(1901),
    [anon_sym_throw] = ACTIONS(1901),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_using] = ACTIONS(1901),
    [anon_sym_static_assert] = ACTIONS(1901),
    [anon_sym_concept] = ACTIONS(1901),
    [anon_sym_co_return] = ACTIONS(1901),
    [anon_sym_co_yield] = ACTIONS(1901),
    [anon_sym_R_DQUOTE] = ACTIONS(1899),
    [anon_sym_LR_DQUOTE] = ACTIONS(1899),
    [anon_sym_uR_DQUOTE] = ACTIONS(1899),
    [anon_sym_UR_DQUOTE] = ACTIONS(1899),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1899),
    [anon_sym_co_await] = ACTIONS(1901),
    [anon_sym_new] = ACTIONS(1901),
    [anon_sym_requires] = ACTIONS(1901),
    [sym_this] = ACTIONS(1901),
    [anon_sym___launch_bounds__] = ACTIONS(1901),
  },
  [396] = {
    [sym_identifier] = ACTIONS(1984),
    [aux_sym_preproc_include_token1] = ACTIONS(1984),
    [aux_sym_preproc_def_token1] = ACTIONS(1984),
    [aux_sym_preproc_if_token1] = ACTIONS(1984),
    [aux_sym_preproc_if_token2] = ACTIONS(1984),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1984),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1984),
    [sym_preproc_directive] = ACTIONS(1984),
    [anon_sym_LPAREN2] = ACTIONS(1986),
    [anon_sym_BANG] = ACTIONS(1986),
    [anon_sym_TILDE] = ACTIONS(1986),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_AMP_AMP] = ACTIONS(1986),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_SEMI] = ACTIONS(1986),
    [anon_sym___extension__] = ACTIONS(1984),
    [anon_sym_typedef] = ACTIONS(1984),
    [anon_sym___device__] = ACTIONS(1984),
    [anon_sym___host__] = ACTIONS(1984),
    [anon_sym___global__] = ACTIONS(1984),
    [anon_sym___forceinline__] = ACTIONS(1984),
    [anon_sym___noinline__] = ACTIONS(1984),
    [anon_sym_extern] = ACTIONS(1984),
    [anon_sym___attribute__] = ACTIONS(1984),
    [anon_sym_COLON_COLON] = ACTIONS(1986),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1986),
    [anon_sym___declspec] = ACTIONS(1984),
    [anon_sym___based] = ACTIONS(1984),
    [anon_sym___cdecl] = ACTIONS(1984),
    [anon_sym___clrcall] = ACTIONS(1984),
    [anon_sym___stdcall] = ACTIONS(1984),
    [anon_sym___fastcall] = ACTIONS(1984),
    [anon_sym___thiscall] = ACTIONS(1984),
    [anon_sym___vectorcall] = ACTIONS(1984),
    [anon_sym_LBRACE] = ACTIONS(1986),
    [anon_sym_signed] = ACTIONS(1984),
    [anon_sym_unsigned] = ACTIONS(1984),
    [anon_sym_long] = ACTIONS(1984),
    [anon_sym_short] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_static] = ACTIONS(1984),
    [anon_sym_register] = ACTIONS(1984),
    [anon_sym_inline] = ACTIONS(1984),
    [anon_sym___inline] = ACTIONS(1984),
    [anon_sym___inline__] = ACTIONS(1984),
    [anon_sym___forceinline] = ACTIONS(1984),
    [anon_sym_thread_local] = ACTIONS(1984),
    [anon_sym___thread] = ACTIONS(1984),
    [anon_sym_const] = ACTIONS(1984),
    [anon_sym_constexpr] = ACTIONS(1984),
    [anon_sym_volatile] = ACTIONS(1984),
    [anon_sym_restrict] = ACTIONS(1984),
    [anon_sym___restrict__] = ACTIONS(1984),
    [anon_sym__Atomic] = ACTIONS(1984),
    [anon_sym__Noreturn] = ACTIONS(1984),
    [anon_sym_noreturn] = ACTIONS(1984),
    [anon_sym_mutable] = ACTIONS(1984),
    [anon_sym_constinit] = ACTIONS(1984),
    [anon_sym_consteval] = ACTIONS(1984),
    [anon_sym___shared__] = ACTIONS(1984),
    [anon_sym___local__] = ACTIONS(1984),
    [anon_sym___constant__] = ACTIONS(1984),
    [anon_sym___managed__] = ACTIONS(1984),
    [anon_sym___grid_constant__] = ACTIONS(1984),
    [anon_sym_alignas] = ACTIONS(1984),
    [anon_sym__Alignas] = ACTIONS(1984),
    [sym_primitive_type] = ACTIONS(1984),
    [anon_sym_enum] = ACTIONS(1984),
    [anon_sym_class] = ACTIONS(1984),
    [anon_sym_struct] = ACTIONS(1984),
    [anon_sym_union] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_else] = ACTIONS(1984),
    [anon_sym_switch] = ACTIONS(1984),
    [anon_sym_case] = ACTIONS(1984),
    [anon_sym_default] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1984),
    [anon_sym_do] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_return] = ACTIONS(1984),
    [anon_sym_break] = ACTIONS(1984),
    [anon_sym_continue] = ACTIONS(1984),
    [anon_sym_goto] = ACTIONS(1984),
    [anon_sym___try] = ACTIONS(1984),
    [anon_sym___leave] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_compl] = ACTIONS(1984),
    [anon_sym_DASH_DASH] = ACTIONS(1986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1986),
    [anon_sym_sizeof] = ACTIONS(1984),
    [anon_sym___alignof__] = ACTIONS(1984),
    [anon_sym___alignof] = ACTIONS(1984),
    [anon_sym__alignof] = ACTIONS(1984),
    [anon_sym_alignof] = ACTIONS(1984),
    [anon_sym__Alignof] = ACTIONS(1984),
    [anon_sym_offsetof] = ACTIONS(1984),
    [anon_sym__Generic] = ACTIONS(1984),
    [anon_sym_asm] = ACTIONS(1984),
    [anon_sym___asm__] = ACTIONS(1984),
    [sym_number_literal] = ACTIONS(1986),
    [anon_sym_L_SQUOTE] = ACTIONS(1986),
    [anon_sym_u_SQUOTE] = ACTIONS(1986),
    [anon_sym_U_SQUOTE] = ACTIONS(1986),
    [anon_sym_u8_SQUOTE] = ACTIONS(1986),
    [anon_sym_SQUOTE] = ACTIONS(1986),
    [anon_sym_L_DQUOTE] = ACTIONS(1986),
    [anon_sym_u_DQUOTE] = ACTIONS(1986),
    [anon_sym_U_DQUOTE] = ACTIONS(1986),
    [anon_sym_u8_DQUOTE] = ACTIONS(1986),
    [anon_sym_DQUOTE] = ACTIONS(1986),
    [sym_true] = ACTIONS(1984),
    [sym_false] = ACTIONS(1984),
    [anon_sym_NULL] = ACTIONS(1984),
    [anon_sym_nullptr] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1984),
    [anon_sym_decltype] = ACTIONS(1984),
    [sym_virtual] = ACTIONS(1984),
    [anon_sym_explicit] = ACTIONS(1984),
    [anon_sym_typename] = ACTIONS(1984),
    [anon_sym_template] = ACTIONS(1984),
    [anon_sym_operator] = ACTIONS(1984),
    [anon_sym_try] = ACTIONS(1984),
    [anon_sym_delete] = ACTIONS(1984),
    [anon_sym_throw] = ACTIONS(1984),
    [anon_sym_namespace] = ACTIONS(1984),
    [anon_sym_using] = ACTIONS(1984),
    [anon_sym_static_assert] = ACTIONS(1984),
    [anon_sym_concept] = ACTIONS(1984),
    [anon_sym_co_return] = ACTIONS(1984),
    [anon_sym_co_yield] = ACTIONS(1984),
    [anon_sym_R_DQUOTE] = ACTIONS(1986),
    [anon_sym_LR_DQUOTE] = ACTIONS(1986),
    [anon_sym_uR_DQUOTE] = ACTIONS(1986),
    [anon_sym_UR_DQUOTE] = ACTIONS(1986),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1986),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1984),
    [anon_sym_requires] = ACTIONS(1984),
    [sym_this] = ACTIONS(1984),
    [anon_sym___launch_bounds__] = ACTIONS(1984),
  },
  [397] = {
    [ts_builtin_sym_end] = ACTIONS(1956),
    [sym_identifier] = ACTIONS(1954),
    [aux_sym_preproc_include_token1] = ACTIONS(1954),
    [aux_sym_preproc_def_token1] = ACTIONS(1954),
    [aux_sym_preproc_if_token1] = ACTIONS(1954),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1954),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1954),
    [sym_preproc_directive] = ACTIONS(1954),
    [anon_sym_LPAREN2] = ACTIONS(1956),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [anon_sym_DASH] = ACTIONS(1954),
    [anon_sym_PLUS] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(1956),
    [anon_sym_AMP_AMP] = ACTIONS(1956),
    [anon_sym_AMP] = ACTIONS(1954),
    [anon_sym_SEMI] = ACTIONS(1956),
    [anon_sym___extension__] = ACTIONS(1954),
    [anon_sym_typedef] = ACTIONS(1954),
    [anon_sym___device__] = ACTIONS(1954),
    [anon_sym___host__] = ACTIONS(1954),
    [anon_sym___global__] = ACTIONS(1954),
    [anon_sym___forceinline__] = ACTIONS(1954),
    [anon_sym___noinline__] = ACTIONS(1954),
    [anon_sym_extern] = ACTIONS(1954),
    [anon_sym___attribute__] = ACTIONS(1954),
    [anon_sym_COLON_COLON] = ACTIONS(1956),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1956),
    [anon_sym___declspec] = ACTIONS(1954),
    [anon_sym___based] = ACTIONS(1954),
    [anon_sym___cdecl] = ACTIONS(1954),
    [anon_sym___clrcall] = ACTIONS(1954),
    [anon_sym___stdcall] = ACTIONS(1954),
    [anon_sym___fastcall] = ACTIONS(1954),
    [anon_sym___thiscall] = ACTIONS(1954),
    [anon_sym___vectorcall] = ACTIONS(1954),
    [anon_sym_LBRACE] = ACTIONS(1956),
    [anon_sym_signed] = ACTIONS(1954),
    [anon_sym_unsigned] = ACTIONS(1954),
    [anon_sym_long] = ACTIONS(1954),
    [anon_sym_short] = ACTIONS(1954),
    [anon_sym_LBRACK] = ACTIONS(1954),
    [anon_sym_static] = ACTIONS(1954),
    [anon_sym_register] = ACTIONS(1954),
    [anon_sym_inline] = ACTIONS(1954),
    [anon_sym___inline] = ACTIONS(1954),
    [anon_sym___inline__] = ACTIONS(1954),
    [anon_sym___forceinline] = ACTIONS(1954),
    [anon_sym_thread_local] = ACTIONS(1954),
    [anon_sym___thread] = ACTIONS(1954),
    [anon_sym_const] = ACTIONS(1954),
    [anon_sym_constexpr] = ACTIONS(1954),
    [anon_sym_volatile] = ACTIONS(1954),
    [anon_sym_restrict] = ACTIONS(1954),
    [anon_sym___restrict__] = ACTIONS(1954),
    [anon_sym__Atomic] = ACTIONS(1954),
    [anon_sym__Noreturn] = ACTIONS(1954),
    [anon_sym_noreturn] = ACTIONS(1954),
    [anon_sym_mutable] = ACTIONS(1954),
    [anon_sym_constinit] = ACTIONS(1954),
    [anon_sym_consteval] = ACTIONS(1954),
    [anon_sym___shared__] = ACTIONS(1954),
    [anon_sym___local__] = ACTIONS(1954),
    [anon_sym___constant__] = ACTIONS(1954),
    [anon_sym___managed__] = ACTIONS(1954),
    [anon_sym___grid_constant__] = ACTIONS(1954),
    [anon_sym_alignas] = ACTIONS(1954),
    [anon_sym__Alignas] = ACTIONS(1954),
    [sym_primitive_type] = ACTIONS(1954),
    [anon_sym_enum] = ACTIONS(1954),
    [anon_sym_class] = ACTIONS(1954),
    [anon_sym_struct] = ACTIONS(1954),
    [anon_sym_union] = ACTIONS(1954),
    [anon_sym_if] = ACTIONS(1954),
    [anon_sym_else] = ACTIONS(1954),
    [anon_sym_switch] = ACTIONS(1954),
    [anon_sym_case] = ACTIONS(1954),
    [anon_sym_default] = ACTIONS(1954),
    [anon_sym_while] = ACTIONS(1954),
    [anon_sym_do] = ACTIONS(1954),
    [anon_sym_for] = ACTIONS(1954),
    [anon_sym_return] = ACTIONS(1954),
    [anon_sym_break] = ACTIONS(1954),
    [anon_sym_continue] = ACTIONS(1954),
    [anon_sym_goto] = ACTIONS(1954),
    [anon_sym___try] = ACTIONS(1954),
    [anon_sym___leave] = ACTIONS(1954),
    [anon_sym_not] = ACTIONS(1954),
    [anon_sym_compl] = ACTIONS(1954),
    [anon_sym_DASH_DASH] = ACTIONS(1956),
    [anon_sym_PLUS_PLUS] = ACTIONS(1956),
    [anon_sym_sizeof] = ACTIONS(1954),
    [anon_sym___alignof__] = ACTIONS(1954),
    [anon_sym___alignof] = ACTIONS(1954),
    [anon_sym__alignof] = ACTIONS(1954),
    [anon_sym_alignof] = ACTIONS(1954),
    [anon_sym__Alignof] = ACTIONS(1954),
    [anon_sym_offsetof] = ACTIONS(1954),
    [anon_sym__Generic] = ACTIONS(1954),
    [anon_sym_asm] = ACTIONS(1954),
    [anon_sym___asm__] = ACTIONS(1954),
    [sym_number_literal] = ACTIONS(1956),
    [anon_sym_L_SQUOTE] = ACTIONS(1956),
    [anon_sym_u_SQUOTE] = ACTIONS(1956),
    [anon_sym_U_SQUOTE] = ACTIONS(1956),
    [anon_sym_u8_SQUOTE] = ACTIONS(1956),
    [anon_sym_SQUOTE] = ACTIONS(1956),
    [anon_sym_L_DQUOTE] = ACTIONS(1956),
    [anon_sym_u_DQUOTE] = ACTIONS(1956),
    [anon_sym_U_DQUOTE] = ACTIONS(1956),
    [anon_sym_u8_DQUOTE] = ACTIONS(1956),
    [anon_sym_DQUOTE] = ACTIONS(1956),
    [sym_true] = ACTIONS(1954),
    [sym_false] = ACTIONS(1954),
    [anon_sym_NULL] = ACTIONS(1954),
    [anon_sym_nullptr] = ACTIONS(1954),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1954),
    [anon_sym_decltype] = ACTIONS(1954),
    [sym_virtual] = ACTIONS(1954),
    [anon_sym_explicit] = ACTIONS(1954),
    [anon_sym_typename] = ACTIONS(1954),
    [anon_sym_template] = ACTIONS(1954),
    [anon_sym_operator] = ACTIONS(1954),
    [anon_sym_try] = ACTIONS(1954),
    [anon_sym_delete] = ACTIONS(1954),
    [anon_sym_throw] = ACTIONS(1954),
    [anon_sym_namespace] = ACTIONS(1954),
    [anon_sym_using] = ACTIONS(1954),
    [anon_sym_static_assert] = ACTIONS(1954),
    [anon_sym_concept] = ACTIONS(1954),
    [anon_sym_co_return] = ACTIONS(1954),
    [anon_sym_co_yield] = ACTIONS(1954),
    [anon_sym_R_DQUOTE] = ACTIONS(1956),
    [anon_sym_LR_DQUOTE] = ACTIONS(1956),
    [anon_sym_uR_DQUOTE] = ACTIONS(1956),
    [anon_sym_UR_DQUOTE] = ACTIONS(1956),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1956),
    [anon_sym_co_await] = ACTIONS(1954),
    [anon_sym_new] = ACTIONS(1954),
    [anon_sym_requires] = ACTIONS(1954),
    [sym_this] = ACTIONS(1954),
    [anon_sym___launch_bounds__] = ACTIONS(1954),
  },
  [398] = {
    [ts_builtin_sym_end] = ACTIONS(1944),
    [sym_identifier] = ACTIONS(1942),
    [aux_sym_preproc_include_token1] = ACTIONS(1942),
    [aux_sym_preproc_def_token1] = ACTIONS(1942),
    [aux_sym_preproc_if_token1] = ACTIONS(1942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1942),
    [sym_preproc_directive] = ACTIONS(1942),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(1944),
    [anon_sym_TILDE] = ACTIONS(1944),
    [anon_sym_DASH] = ACTIONS(1942),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym_SEMI] = ACTIONS(1944),
    [anon_sym___extension__] = ACTIONS(1942),
    [anon_sym_typedef] = ACTIONS(1942),
    [anon_sym___device__] = ACTIONS(1942),
    [anon_sym___host__] = ACTIONS(1942),
    [anon_sym___global__] = ACTIONS(1942),
    [anon_sym___forceinline__] = ACTIONS(1942),
    [anon_sym___noinline__] = ACTIONS(1942),
    [anon_sym_extern] = ACTIONS(1942),
    [anon_sym___attribute__] = ACTIONS(1942),
    [anon_sym_COLON_COLON] = ACTIONS(1944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1944),
    [anon_sym___declspec] = ACTIONS(1942),
    [anon_sym___based] = ACTIONS(1942),
    [anon_sym___cdecl] = ACTIONS(1942),
    [anon_sym___clrcall] = ACTIONS(1942),
    [anon_sym___stdcall] = ACTIONS(1942),
    [anon_sym___fastcall] = ACTIONS(1942),
    [anon_sym___thiscall] = ACTIONS(1942),
    [anon_sym___vectorcall] = ACTIONS(1942),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_signed] = ACTIONS(1942),
    [anon_sym_unsigned] = ACTIONS(1942),
    [anon_sym_long] = ACTIONS(1942),
    [anon_sym_short] = ACTIONS(1942),
    [anon_sym_LBRACK] = ACTIONS(1942),
    [anon_sym_static] = ACTIONS(1942),
    [anon_sym_register] = ACTIONS(1942),
    [anon_sym_inline] = ACTIONS(1942),
    [anon_sym___inline] = ACTIONS(1942),
    [anon_sym___inline__] = ACTIONS(1942),
    [anon_sym___forceinline] = ACTIONS(1942),
    [anon_sym_thread_local] = ACTIONS(1942),
    [anon_sym___thread] = ACTIONS(1942),
    [anon_sym_const] = ACTIONS(1942),
    [anon_sym_constexpr] = ACTIONS(1942),
    [anon_sym_volatile] = ACTIONS(1942),
    [anon_sym_restrict] = ACTIONS(1942),
    [anon_sym___restrict__] = ACTIONS(1942),
    [anon_sym__Atomic] = ACTIONS(1942),
    [anon_sym__Noreturn] = ACTIONS(1942),
    [anon_sym_noreturn] = ACTIONS(1942),
    [anon_sym_mutable] = ACTIONS(1942),
    [anon_sym_constinit] = ACTIONS(1942),
    [anon_sym_consteval] = ACTIONS(1942),
    [anon_sym___shared__] = ACTIONS(1942),
    [anon_sym___local__] = ACTIONS(1942),
    [anon_sym___constant__] = ACTIONS(1942),
    [anon_sym___managed__] = ACTIONS(1942),
    [anon_sym___grid_constant__] = ACTIONS(1942),
    [anon_sym_alignas] = ACTIONS(1942),
    [anon_sym__Alignas] = ACTIONS(1942),
    [sym_primitive_type] = ACTIONS(1942),
    [anon_sym_enum] = ACTIONS(1942),
    [anon_sym_class] = ACTIONS(1942),
    [anon_sym_struct] = ACTIONS(1942),
    [anon_sym_union] = ACTIONS(1942),
    [anon_sym_if] = ACTIONS(1942),
    [anon_sym_else] = ACTIONS(1942),
    [anon_sym_switch] = ACTIONS(1942),
    [anon_sym_case] = ACTIONS(1942),
    [anon_sym_default] = ACTIONS(1942),
    [anon_sym_while] = ACTIONS(1942),
    [anon_sym_do] = ACTIONS(1942),
    [anon_sym_for] = ACTIONS(1942),
    [anon_sym_return] = ACTIONS(1942),
    [anon_sym_break] = ACTIONS(1942),
    [anon_sym_continue] = ACTIONS(1942),
    [anon_sym_goto] = ACTIONS(1942),
    [anon_sym___try] = ACTIONS(1942),
    [anon_sym___leave] = ACTIONS(1942),
    [anon_sym_not] = ACTIONS(1942),
    [anon_sym_compl] = ACTIONS(1942),
    [anon_sym_DASH_DASH] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1944),
    [anon_sym_sizeof] = ACTIONS(1942),
    [anon_sym___alignof__] = ACTIONS(1942),
    [anon_sym___alignof] = ACTIONS(1942),
    [anon_sym__alignof] = ACTIONS(1942),
    [anon_sym_alignof] = ACTIONS(1942),
    [anon_sym__Alignof] = ACTIONS(1942),
    [anon_sym_offsetof] = ACTIONS(1942),
    [anon_sym__Generic] = ACTIONS(1942),
    [anon_sym_asm] = ACTIONS(1942),
    [anon_sym___asm__] = ACTIONS(1942),
    [sym_number_literal] = ACTIONS(1944),
    [anon_sym_L_SQUOTE] = ACTIONS(1944),
    [anon_sym_u_SQUOTE] = ACTIONS(1944),
    [anon_sym_U_SQUOTE] = ACTIONS(1944),
    [anon_sym_u8_SQUOTE] = ACTIONS(1944),
    [anon_sym_SQUOTE] = ACTIONS(1944),
    [anon_sym_L_DQUOTE] = ACTIONS(1944),
    [anon_sym_u_DQUOTE] = ACTIONS(1944),
    [anon_sym_U_DQUOTE] = ACTIONS(1944),
    [anon_sym_u8_DQUOTE] = ACTIONS(1944),
    [anon_sym_DQUOTE] = ACTIONS(1944),
    [sym_true] = ACTIONS(1942),
    [sym_false] = ACTIONS(1942),
    [anon_sym_NULL] = ACTIONS(1942),
    [anon_sym_nullptr] = ACTIONS(1942),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1942),
    [anon_sym_decltype] = ACTIONS(1942),
    [sym_virtual] = ACTIONS(1942),
    [anon_sym_explicit] = ACTIONS(1942),
    [anon_sym_typename] = ACTIONS(1942),
    [anon_sym_template] = ACTIONS(1942),
    [anon_sym_operator] = ACTIONS(1942),
    [anon_sym_try] = ACTIONS(1942),
    [anon_sym_delete] = ACTIONS(1942),
    [anon_sym_throw] = ACTIONS(1942),
    [anon_sym_namespace] = ACTIONS(1942),
    [anon_sym_using] = ACTIONS(1942),
    [anon_sym_static_assert] = ACTIONS(1942),
    [anon_sym_concept] = ACTIONS(1942),
    [anon_sym_co_return] = ACTIONS(1942),
    [anon_sym_co_yield] = ACTIONS(1942),
    [anon_sym_R_DQUOTE] = ACTIONS(1944),
    [anon_sym_LR_DQUOTE] = ACTIONS(1944),
    [anon_sym_uR_DQUOTE] = ACTIONS(1944),
    [anon_sym_UR_DQUOTE] = ACTIONS(1944),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1944),
    [anon_sym_co_await] = ACTIONS(1942),
    [anon_sym_new] = ACTIONS(1942),
    [anon_sym_requires] = ACTIONS(1942),
    [sym_this] = ACTIONS(1942),
    [anon_sym___launch_bounds__] = ACTIONS(1942),
  },
  [399] = {
    [ts_builtin_sym_end] = ACTIONS(1944),
    [sym_identifier] = ACTIONS(1942),
    [aux_sym_preproc_include_token1] = ACTIONS(1942),
    [aux_sym_preproc_def_token1] = ACTIONS(1942),
    [aux_sym_preproc_if_token1] = ACTIONS(1942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1942),
    [sym_preproc_directive] = ACTIONS(1942),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(1944),
    [anon_sym_TILDE] = ACTIONS(1944),
    [anon_sym_DASH] = ACTIONS(1942),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym_SEMI] = ACTIONS(1944),
    [anon_sym___extension__] = ACTIONS(1942),
    [anon_sym_typedef] = ACTIONS(1942),
    [anon_sym___device__] = ACTIONS(1942),
    [anon_sym___host__] = ACTIONS(1942),
    [anon_sym___global__] = ACTIONS(1942),
    [anon_sym___forceinline__] = ACTIONS(1942),
    [anon_sym___noinline__] = ACTIONS(1942),
    [anon_sym_extern] = ACTIONS(1942),
    [anon_sym___attribute__] = ACTIONS(1942),
    [anon_sym_COLON_COLON] = ACTIONS(1944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1944),
    [anon_sym___declspec] = ACTIONS(1942),
    [anon_sym___based] = ACTIONS(1942),
    [anon_sym___cdecl] = ACTIONS(1942),
    [anon_sym___clrcall] = ACTIONS(1942),
    [anon_sym___stdcall] = ACTIONS(1942),
    [anon_sym___fastcall] = ACTIONS(1942),
    [anon_sym___thiscall] = ACTIONS(1942),
    [anon_sym___vectorcall] = ACTIONS(1942),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_signed] = ACTIONS(1942),
    [anon_sym_unsigned] = ACTIONS(1942),
    [anon_sym_long] = ACTIONS(1942),
    [anon_sym_short] = ACTIONS(1942),
    [anon_sym_LBRACK] = ACTIONS(1942),
    [anon_sym_static] = ACTIONS(1942),
    [anon_sym_register] = ACTIONS(1942),
    [anon_sym_inline] = ACTIONS(1942),
    [anon_sym___inline] = ACTIONS(1942),
    [anon_sym___inline__] = ACTIONS(1942),
    [anon_sym___forceinline] = ACTIONS(1942),
    [anon_sym_thread_local] = ACTIONS(1942),
    [anon_sym___thread] = ACTIONS(1942),
    [anon_sym_const] = ACTIONS(1942),
    [anon_sym_constexpr] = ACTIONS(1942),
    [anon_sym_volatile] = ACTIONS(1942),
    [anon_sym_restrict] = ACTIONS(1942),
    [anon_sym___restrict__] = ACTIONS(1942),
    [anon_sym__Atomic] = ACTIONS(1942),
    [anon_sym__Noreturn] = ACTIONS(1942),
    [anon_sym_noreturn] = ACTIONS(1942),
    [anon_sym_mutable] = ACTIONS(1942),
    [anon_sym_constinit] = ACTIONS(1942),
    [anon_sym_consteval] = ACTIONS(1942),
    [anon_sym___shared__] = ACTIONS(1942),
    [anon_sym___local__] = ACTIONS(1942),
    [anon_sym___constant__] = ACTIONS(1942),
    [anon_sym___managed__] = ACTIONS(1942),
    [anon_sym___grid_constant__] = ACTIONS(1942),
    [anon_sym_alignas] = ACTIONS(1942),
    [anon_sym__Alignas] = ACTIONS(1942),
    [sym_primitive_type] = ACTIONS(1942),
    [anon_sym_enum] = ACTIONS(1942),
    [anon_sym_class] = ACTIONS(1942),
    [anon_sym_struct] = ACTIONS(1942),
    [anon_sym_union] = ACTIONS(1942),
    [anon_sym_if] = ACTIONS(1942),
    [anon_sym_else] = ACTIONS(1942),
    [anon_sym_switch] = ACTIONS(1942),
    [anon_sym_case] = ACTIONS(1942),
    [anon_sym_default] = ACTIONS(1942),
    [anon_sym_while] = ACTIONS(1942),
    [anon_sym_do] = ACTIONS(1942),
    [anon_sym_for] = ACTIONS(1942),
    [anon_sym_return] = ACTIONS(1942),
    [anon_sym_break] = ACTIONS(1942),
    [anon_sym_continue] = ACTIONS(1942),
    [anon_sym_goto] = ACTIONS(1942),
    [anon_sym___try] = ACTIONS(1942),
    [anon_sym___leave] = ACTIONS(1942),
    [anon_sym_not] = ACTIONS(1942),
    [anon_sym_compl] = ACTIONS(1942),
    [anon_sym_DASH_DASH] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1944),
    [anon_sym_sizeof] = ACTIONS(1942),
    [anon_sym___alignof__] = ACTIONS(1942),
    [anon_sym___alignof] = ACTIONS(1942),
    [anon_sym__alignof] = ACTIONS(1942),
    [anon_sym_alignof] = ACTIONS(1942),
    [anon_sym__Alignof] = ACTIONS(1942),
    [anon_sym_offsetof] = ACTIONS(1942),
    [anon_sym__Generic] = ACTIONS(1942),
    [anon_sym_asm] = ACTIONS(1942),
    [anon_sym___asm__] = ACTIONS(1942),
    [sym_number_literal] = ACTIONS(1944),
    [anon_sym_L_SQUOTE] = ACTIONS(1944),
    [anon_sym_u_SQUOTE] = ACTIONS(1944),
    [anon_sym_U_SQUOTE] = ACTIONS(1944),
    [anon_sym_u8_SQUOTE] = ACTIONS(1944),
    [anon_sym_SQUOTE] = ACTIONS(1944),
    [anon_sym_L_DQUOTE] = ACTIONS(1944),
    [anon_sym_u_DQUOTE] = ACTIONS(1944),
    [anon_sym_U_DQUOTE] = ACTIONS(1944),
    [anon_sym_u8_DQUOTE] = ACTIONS(1944),
    [anon_sym_DQUOTE] = ACTIONS(1944),
    [sym_true] = ACTIONS(1942),
    [sym_false] = ACTIONS(1942),
    [anon_sym_NULL] = ACTIONS(1942),
    [anon_sym_nullptr] = ACTIONS(1942),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1942),
    [anon_sym_decltype] = ACTIONS(1942),
    [sym_virtual] = ACTIONS(1942),
    [anon_sym_explicit] = ACTIONS(1942),
    [anon_sym_typename] = ACTIONS(1942),
    [anon_sym_template] = ACTIONS(1942),
    [anon_sym_operator] = ACTIONS(1942),
    [anon_sym_try] = ACTIONS(1942),
    [anon_sym_delete] = ACTIONS(1942),
    [anon_sym_throw] = ACTIONS(1942),
    [anon_sym_namespace] = ACTIONS(1942),
    [anon_sym_using] = ACTIONS(1942),
    [anon_sym_static_assert] = ACTIONS(1942),
    [anon_sym_concept] = ACTIONS(1942),
    [anon_sym_co_return] = ACTIONS(1942),
    [anon_sym_co_yield] = ACTIONS(1942),
    [anon_sym_R_DQUOTE] = ACTIONS(1944),
    [anon_sym_LR_DQUOTE] = ACTIONS(1944),
    [anon_sym_uR_DQUOTE] = ACTIONS(1944),
    [anon_sym_UR_DQUOTE] = ACTIONS(1944),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1944),
    [anon_sym_co_await] = ACTIONS(1942),
    [anon_sym_new] = ACTIONS(1942),
    [anon_sym_requires] = ACTIONS(1942),
    [sym_this] = ACTIONS(1942),
    [anon_sym___launch_bounds__] = ACTIONS(1942),
  },
  [400] = {
    [sym_identifier] = ACTIONS(1988),
    [aux_sym_preproc_include_token1] = ACTIONS(1988),
    [aux_sym_preproc_def_token1] = ACTIONS(1988),
    [aux_sym_preproc_if_token1] = ACTIONS(1988),
    [aux_sym_preproc_if_token2] = ACTIONS(1988),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1988),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1988),
    [sym_preproc_directive] = ACTIONS(1988),
    [anon_sym_LPAREN2] = ACTIONS(1990),
    [anon_sym_BANG] = ACTIONS(1990),
    [anon_sym_TILDE] = ACTIONS(1990),
    [anon_sym_DASH] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(1990),
    [anon_sym_AMP_AMP] = ACTIONS(1990),
    [anon_sym_AMP] = ACTIONS(1988),
    [anon_sym_SEMI] = ACTIONS(1990),
    [anon_sym___extension__] = ACTIONS(1988),
    [anon_sym_typedef] = ACTIONS(1988),
    [anon_sym___device__] = ACTIONS(1988),
    [anon_sym___host__] = ACTIONS(1988),
    [anon_sym___global__] = ACTIONS(1988),
    [anon_sym___forceinline__] = ACTIONS(1988),
    [anon_sym___noinline__] = ACTIONS(1988),
    [anon_sym_extern] = ACTIONS(1988),
    [anon_sym___attribute__] = ACTIONS(1988),
    [anon_sym_COLON_COLON] = ACTIONS(1990),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1990),
    [anon_sym___declspec] = ACTIONS(1988),
    [anon_sym___based] = ACTIONS(1988),
    [anon_sym___cdecl] = ACTIONS(1988),
    [anon_sym___clrcall] = ACTIONS(1988),
    [anon_sym___stdcall] = ACTIONS(1988),
    [anon_sym___fastcall] = ACTIONS(1988),
    [anon_sym___thiscall] = ACTIONS(1988),
    [anon_sym___vectorcall] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1990),
    [anon_sym_signed] = ACTIONS(1988),
    [anon_sym_unsigned] = ACTIONS(1988),
    [anon_sym_long] = ACTIONS(1988),
    [anon_sym_short] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_static] = ACTIONS(1988),
    [anon_sym_register] = ACTIONS(1988),
    [anon_sym_inline] = ACTIONS(1988),
    [anon_sym___inline] = ACTIONS(1988),
    [anon_sym___inline__] = ACTIONS(1988),
    [anon_sym___forceinline] = ACTIONS(1988),
    [anon_sym_thread_local] = ACTIONS(1988),
    [anon_sym___thread] = ACTIONS(1988),
    [anon_sym_const] = ACTIONS(1988),
    [anon_sym_constexpr] = ACTIONS(1988),
    [anon_sym_volatile] = ACTIONS(1988),
    [anon_sym_restrict] = ACTIONS(1988),
    [anon_sym___restrict__] = ACTIONS(1988),
    [anon_sym__Atomic] = ACTIONS(1988),
    [anon_sym__Noreturn] = ACTIONS(1988),
    [anon_sym_noreturn] = ACTIONS(1988),
    [anon_sym_mutable] = ACTIONS(1988),
    [anon_sym_constinit] = ACTIONS(1988),
    [anon_sym_consteval] = ACTIONS(1988),
    [anon_sym___shared__] = ACTIONS(1988),
    [anon_sym___local__] = ACTIONS(1988),
    [anon_sym___constant__] = ACTIONS(1988),
    [anon_sym___managed__] = ACTIONS(1988),
    [anon_sym___grid_constant__] = ACTIONS(1988),
    [anon_sym_alignas] = ACTIONS(1988),
    [anon_sym__Alignas] = ACTIONS(1988),
    [sym_primitive_type] = ACTIONS(1988),
    [anon_sym_enum] = ACTIONS(1988),
    [anon_sym_class] = ACTIONS(1988),
    [anon_sym_struct] = ACTIONS(1988),
    [anon_sym_union] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_else] = ACTIONS(1988),
    [anon_sym_switch] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_default] = ACTIONS(1988),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_do] = ACTIONS(1988),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_return] = ACTIONS(1988),
    [anon_sym_break] = ACTIONS(1988),
    [anon_sym_continue] = ACTIONS(1988),
    [anon_sym_goto] = ACTIONS(1988),
    [anon_sym___try] = ACTIONS(1988),
    [anon_sym___leave] = ACTIONS(1988),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_compl] = ACTIONS(1988),
    [anon_sym_DASH_DASH] = ACTIONS(1990),
    [anon_sym_PLUS_PLUS] = ACTIONS(1990),
    [anon_sym_sizeof] = ACTIONS(1988),
    [anon_sym___alignof__] = ACTIONS(1988),
    [anon_sym___alignof] = ACTIONS(1988),
    [anon_sym__alignof] = ACTIONS(1988),
    [anon_sym_alignof] = ACTIONS(1988),
    [anon_sym__Alignof] = ACTIONS(1988),
    [anon_sym_offsetof] = ACTIONS(1988),
    [anon_sym__Generic] = ACTIONS(1988),
    [anon_sym_asm] = ACTIONS(1988),
    [anon_sym___asm__] = ACTIONS(1988),
    [sym_number_literal] = ACTIONS(1990),
    [anon_sym_L_SQUOTE] = ACTIONS(1990),
    [anon_sym_u_SQUOTE] = ACTIONS(1990),
    [anon_sym_U_SQUOTE] = ACTIONS(1990),
    [anon_sym_u8_SQUOTE] = ACTIONS(1990),
    [anon_sym_SQUOTE] = ACTIONS(1990),
    [anon_sym_L_DQUOTE] = ACTIONS(1990),
    [anon_sym_u_DQUOTE] = ACTIONS(1990),
    [anon_sym_U_DQUOTE] = ACTIONS(1990),
    [anon_sym_u8_DQUOTE] = ACTIONS(1990),
    [anon_sym_DQUOTE] = ACTIONS(1990),
    [sym_true] = ACTIONS(1988),
    [sym_false] = ACTIONS(1988),
    [anon_sym_NULL] = ACTIONS(1988),
    [anon_sym_nullptr] = ACTIONS(1988),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1988),
    [anon_sym_decltype] = ACTIONS(1988),
    [sym_virtual] = ACTIONS(1988),
    [anon_sym_explicit] = ACTIONS(1988),
    [anon_sym_typename] = ACTIONS(1988),
    [anon_sym_template] = ACTIONS(1988),
    [anon_sym_operator] = ACTIONS(1988),
    [anon_sym_try] = ACTIONS(1988),
    [anon_sym_delete] = ACTIONS(1988),
    [anon_sym_throw] = ACTIONS(1988),
    [anon_sym_namespace] = ACTIONS(1988),
    [anon_sym_using] = ACTIONS(1988),
    [anon_sym_static_assert] = ACTIONS(1988),
    [anon_sym_concept] = ACTIONS(1988),
    [anon_sym_co_return] = ACTIONS(1988),
    [anon_sym_co_yield] = ACTIONS(1988),
    [anon_sym_R_DQUOTE] = ACTIONS(1990),
    [anon_sym_LR_DQUOTE] = ACTIONS(1990),
    [anon_sym_uR_DQUOTE] = ACTIONS(1990),
    [anon_sym_UR_DQUOTE] = ACTIONS(1990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1990),
    [anon_sym_co_await] = ACTIONS(1988),
    [anon_sym_new] = ACTIONS(1988),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1988),
    [anon_sym___launch_bounds__] = ACTIONS(1988),
  },
  [401] = {
    [ts_builtin_sym_end] = ACTIONS(2062),
    [sym_identifier] = ACTIONS(2060),
    [aux_sym_preproc_include_token1] = ACTIONS(2060),
    [aux_sym_preproc_def_token1] = ACTIONS(2060),
    [aux_sym_preproc_if_token1] = ACTIONS(2060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2060),
    [sym_preproc_directive] = ACTIONS(2060),
    [anon_sym_LPAREN2] = ACTIONS(2062),
    [anon_sym_BANG] = ACTIONS(2062),
    [anon_sym_TILDE] = ACTIONS(2062),
    [anon_sym_DASH] = ACTIONS(2060),
    [anon_sym_PLUS] = ACTIONS(2060),
    [anon_sym_STAR] = ACTIONS(2062),
    [anon_sym_AMP_AMP] = ACTIONS(2062),
    [anon_sym_AMP] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2062),
    [anon_sym___extension__] = ACTIONS(2060),
    [anon_sym_typedef] = ACTIONS(2060),
    [anon_sym___device__] = ACTIONS(2060),
    [anon_sym___host__] = ACTIONS(2060),
    [anon_sym___global__] = ACTIONS(2060),
    [anon_sym___forceinline__] = ACTIONS(2060),
    [anon_sym___noinline__] = ACTIONS(2060),
    [anon_sym_extern] = ACTIONS(2060),
    [anon_sym___attribute__] = ACTIONS(2060),
    [anon_sym_COLON_COLON] = ACTIONS(2062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2062),
    [anon_sym___declspec] = ACTIONS(2060),
    [anon_sym___based] = ACTIONS(2060),
    [anon_sym___cdecl] = ACTIONS(2060),
    [anon_sym___clrcall] = ACTIONS(2060),
    [anon_sym___stdcall] = ACTIONS(2060),
    [anon_sym___fastcall] = ACTIONS(2060),
    [anon_sym___thiscall] = ACTIONS(2060),
    [anon_sym___vectorcall] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(2062),
    [anon_sym_signed] = ACTIONS(2060),
    [anon_sym_unsigned] = ACTIONS(2060),
    [anon_sym_long] = ACTIONS(2060),
    [anon_sym_short] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2060),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_register] = ACTIONS(2060),
    [anon_sym_inline] = ACTIONS(2060),
    [anon_sym___inline] = ACTIONS(2060),
    [anon_sym___inline__] = ACTIONS(2060),
    [anon_sym___forceinline] = ACTIONS(2060),
    [anon_sym_thread_local] = ACTIONS(2060),
    [anon_sym___thread] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_constexpr] = ACTIONS(2060),
    [anon_sym_volatile] = ACTIONS(2060),
    [anon_sym_restrict] = ACTIONS(2060),
    [anon_sym___restrict__] = ACTIONS(2060),
    [anon_sym__Atomic] = ACTIONS(2060),
    [anon_sym__Noreturn] = ACTIONS(2060),
    [anon_sym_noreturn] = ACTIONS(2060),
    [anon_sym_mutable] = ACTIONS(2060),
    [anon_sym_constinit] = ACTIONS(2060),
    [anon_sym_consteval] = ACTIONS(2060),
    [anon_sym___shared__] = ACTIONS(2060),
    [anon_sym___local__] = ACTIONS(2060),
    [anon_sym___constant__] = ACTIONS(2060),
    [anon_sym___managed__] = ACTIONS(2060),
    [anon_sym___grid_constant__] = ACTIONS(2060),
    [anon_sym_alignas] = ACTIONS(2060),
    [anon_sym__Alignas] = ACTIONS(2060),
    [sym_primitive_type] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_struct] = ACTIONS(2060),
    [anon_sym_union] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_else] = ACTIONS(2060),
    [anon_sym_switch] = ACTIONS(2060),
    [anon_sym_case] = ACTIONS(2060),
    [anon_sym_default] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_do] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_goto] = ACTIONS(2060),
    [anon_sym___try] = ACTIONS(2060),
    [anon_sym___leave] = ACTIONS(2060),
    [anon_sym_not] = ACTIONS(2060),
    [anon_sym_compl] = ACTIONS(2060),
    [anon_sym_DASH_DASH] = ACTIONS(2062),
    [anon_sym_PLUS_PLUS] = ACTIONS(2062),
    [anon_sym_sizeof] = ACTIONS(2060),
    [anon_sym___alignof__] = ACTIONS(2060),
    [anon_sym___alignof] = ACTIONS(2060),
    [anon_sym__alignof] = ACTIONS(2060),
    [anon_sym_alignof] = ACTIONS(2060),
    [anon_sym__Alignof] = ACTIONS(2060),
    [anon_sym_offsetof] = ACTIONS(2060),
    [anon_sym__Generic] = ACTIONS(2060),
    [anon_sym_asm] = ACTIONS(2060),
    [anon_sym___asm__] = ACTIONS(2060),
    [sym_number_literal] = ACTIONS(2062),
    [anon_sym_L_SQUOTE] = ACTIONS(2062),
    [anon_sym_u_SQUOTE] = ACTIONS(2062),
    [anon_sym_U_SQUOTE] = ACTIONS(2062),
    [anon_sym_u8_SQUOTE] = ACTIONS(2062),
    [anon_sym_SQUOTE] = ACTIONS(2062),
    [anon_sym_L_DQUOTE] = ACTIONS(2062),
    [anon_sym_u_DQUOTE] = ACTIONS(2062),
    [anon_sym_U_DQUOTE] = ACTIONS(2062),
    [anon_sym_u8_DQUOTE] = ACTIONS(2062),
    [anon_sym_DQUOTE] = ACTIONS(2062),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [anon_sym_NULL] = ACTIONS(2060),
    [anon_sym_nullptr] = ACTIONS(2060),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2060),
    [anon_sym_decltype] = ACTIONS(2060),
    [sym_virtual] = ACTIONS(2060),
    [anon_sym_explicit] = ACTIONS(2060),
    [anon_sym_typename] = ACTIONS(2060),
    [anon_sym_template] = ACTIONS(2060),
    [anon_sym_operator] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [anon_sym_delete] = ACTIONS(2060),
    [anon_sym_throw] = ACTIONS(2060),
    [anon_sym_namespace] = ACTIONS(2060),
    [anon_sym_using] = ACTIONS(2060),
    [anon_sym_static_assert] = ACTIONS(2060),
    [anon_sym_concept] = ACTIONS(2060),
    [anon_sym_co_return] = ACTIONS(2060),
    [anon_sym_co_yield] = ACTIONS(2060),
    [anon_sym_R_DQUOTE] = ACTIONS(2062),
    [anon_sym_LR_DQUOTE] = ACTIONS(2062),
    [anon_sym_uR_DQUOTE] = ACTIONS(2062),
    [anon_sym_UR_DQUOTE] = ACTIONS(2062),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2062),
    [anon_sym_co_await] = ACTIONS(2060),
    [anon_sym_new] = ACTIONS(2060),
    [anon_sym_requires] = ACTIONS(2060),
    [sym_this] = ACTIONS(2060),
    [anon_sym___launch_bounds__] = ACTIONS(2060),
  },
  [402] = {
    [sym_identifier] = ACTIONS(1942),
    [aux_sym_preproc_include_token1] = ACTIONS(1942),
    [aux_sym_preproc_def_token1] = ACTIONS(1942),
    [aux_sym_preproc_if_token1] = ACTIONS(1942),
    [aux_sym_preproc_if_token2] = ACTIONS(1942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1942),
    [sym_preproc_directive] = ACTIONS(1942),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(1944),
    [anon_sym_TILDE] = ACTIONS(1944),
    [anon_sym_DASH] = ACTIONS(1942),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym_SEMI] = ACTIONS(1944),
    [anon_sym___extension__] = ACTIONS(1942),
    [anon_sym_typedef] = ACTIONS(1942),
    [anon_sym___device__] = ACTIONS(1942),
    [anon_sym___host__] = ACTIONS(1942),
    [anon_sym___global__] = ACTIONS(1942),
    [anon_sym___forceinline__] = ACTIONS(1942),
    [anon_sym___noinline__] = ACTIONS(1942),
    [anon_sym_extern] = ACTIONS(1942),
    [anon_sym___attribute__] = ACTIONS(1942),
    [anon_sym_COLON_COLON] = ACTIONS(1944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1944),
    [anon_sym___declspec] = ACTIONS(1942),
    [anon_sym___based] = ACTIONS(1942),
    [anon_sym___cdecl] = ACTIONS(1942),
    [anon_sym___clrcall] = ACTIONS(1942),
    [anon_sym___stdcall] = ACTIONS(1942),
    [anon_sym___fastcall] = ACTIONS(1942),
    [anon_sym___thiscall] = ACTIONS(1942),
    [anon_sym___vectorcall] = ACTIONS(1942),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_signed] = ACTIONS(1942),
    [anon_sym_unsigned] = ACTIONS(1942),
    [anon_sym_long] = ACTIONS(1942),
    [anon_sym_short] = ACTIONS(1942),
    [anon_sym_LBRACK] = ACTIONS(1942),
    [anon_sym_static] = ACTIONS(1942),
    [anon_sym_register] = ACTIONS(1942),
    [anon_sym_inline] = ACTIONS(1942),
    [anon_sym___inline] = ACTIONS(1942),
    [anon_sym___inline__] = ACTIONS(1942),
    [anon_sym___forceinline] = ACTIONS(1942),
    [anon_sym_thread_local] = ACTIONS(1942),
    [anon_sym___thread] = ACTIONS(1942),
    [anon_sym_const] = ACTIONS(1942),
    [anon_sym_constexpr] = ACTIONS(1942),
    [anon_sym_volatile] = ACTIONS(1942),
    [anon_sym_restrict] = ACTIONS(1942),
    [anon_sym___restrict__] = ACTIONS(1942),
    [anon_sym__Atomic] = ACTIONS(1942),
    [anon_sym__Noreturn] = ACTIONS(1942),
    [anon_sym_noreturn] = ACTIONS(1942),
    [anon_sym_mutable] = ACTIONS(1942),
    [anon_sym_constinit] = ACTIONS(1942),
    [anon_sym_consteval] = ACTIONS(1942),
    [anon_sym___shared__] = ACTIONS(1942),
    [anon_sym___local__] = ACTIONS(1942),
    [anon_sym___constant__] = ACTIONS(1942),
    [anon_sym___managed__] = ACTIONS(1942),
    [anon_sym___grid_constant__] = ACTIONS(1942),
    [anon_sym_alignas] = ACTIONS(1942),
    [anon_sym__Alignas] = ACTIONS(1942),
    [sym_primitive_type] = ACTIONS(1942),
    [anon_sym_enum] = ACTIONS(1942),
    [anon_sym_class] = ACTIONS(1942),
    [anon_sym_struct] = ACTIONS(1942),
    [anon_sym_union] = ACTIONS(1942),
    [anon_sym_if] = ACTIONS(1942),
    [anon_sym_else] = ACTIONS(1942),
    [anon_sym_switch] = ACTIONS(1942),
    [anon_sym_case] = ACTIONS(1942),
    [anon_sym_default] = ACTIONS(1942),
    [anon_sym_while] = ACTIONS(1942),
    [anon_sym_do] = ACTIONS(1942),
    [anon_sym_for] = ACTIONS(1942),
    [anon_sym_return] = ACTIONS(1942),
    [anon_sym_break] = ACTIONS(1942),
    [anon_sym_continue] = ACTIONS(1942),
    [anon_sym_goto] = ACTIONS(1942),
    [anon_sym___try] = ACTIONS(1942),
    [anon_sym___leave] = ACTIONS(1942),
    [anon_sym_not] = ACTIONS(1942),
    [anon_sym_compl] = ACTIONS(1942),
    [anon_sym_DASH_DASH] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1944),
    [anon_sym_sizeof] = ACTIONS(1942),
    [anon_sym___alignof__] = ACTIONS(1942),
    [anon_sym___alignof] = ACTIONS(1942),
    [anon_sym__alignof] = ACTIONS(1942),
    [anon_sym_alignof] = ACTIONS(1942),
    [anon_sym__Alignof] = ACTIONS(1942),
    [anon_sym_offsetof] = ACTIONS(1942),
    [anon_sym__Generic] = ACTIONS(1942),
    [anon_sym_asm] = ACTIONS(1942),
    [anon_sym___asm__] = ACTIONS(1942),
    [sym_number_literal] = ACTIONS(1944),
    [anon_sym_L_SQUOTE] = ACTIONS(1944),
    [anon_sym_u_SQUOTE] = ACTIONS(1944),
    [anon_sym_U_SQUOTE] = ACTIONS(1944),
    [anon_sym_u8_SQUOTE] = ACTIONS(1944),
    [anon_sym_SQUOTE] = ACTIONS(1944),
    [anon_sym_L_DQUOTE] = ACTIONS(1944),
    [anon_sym_u_DQUOTE] = ACTIONS(1944),
    [anon_sym_U_DQUOTE] = ACTIONS(1944),
    [anon_sym_u8_DQUOTE] = ACTIONS(1944),
    [anon_sym_DQUOTE] = ACTIONS(1944),
    [sym_true] = ACTIONS(1942),
    [sym_false] = ACTIONS(1942),
    [anon_sym_NULL] = ACTIONS(1942),
    [anon_sym_nullptr] = ACTIONS(1942),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1942),
    [anon_sym_decltype] = ACTIONS(1942),
    [sym_virtual] = ACTIONS(1942),
    [anon_sym_explicit] = ACTIONS(1942),
    [anon_sym_typename] = ACTIONS(1942),
    [anon_sym_template] = ACTIONS(1942),
    [anon_sym_operator] = ACTIONS(1942),
    [anon_sym_try] = ACTIONS(1942),
    [anon_sym_delete] = ACTIONS(1942),
    [anon_sym_throw] = ACTIONS(1942),
    [anon_sym_namespace] = ACTIONS(1942),
    [anon_sym_using] = ACTIONS(1942),
    [anon_sym_static_assert] = ACTIONS(1942),
    [anon_sym_concept] = ACTIONS(1942),
    [anon_sym_co_return] = ACTIONS(1942),
    [anon_sym_co_yield] = ACTIONS(1942),
    [anon_sym_R_DQUOTE] = ACTIONS(1944),
    [anon_sym_LR_DQUOTE] = ACTIONS(1944),
    [anon_sym_uR_DQUOTE] = ACTIONS(1944),
    [anon_sym_UR_DQUOTE] = ACTIONS(1944),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1944),
    [anon_sym_co_await] = ACTIONS(1942),
    [anon_sym_new] = ACTIONS(1942),
    [anon_sym_requires] = ACTIONS(1942),
    [sym_this] = ACTIONS(1942),
    [anon_sym___launch_bounds__] = ACTIONS(1942),
  },
  [403] = {
    [sym_identifier] = ACTIONS(1942),
    [aux_sym_preproc_include_token1] = ACTIONS(1942),
    [aux_sym_preproc_def_token1] = ACTIONS(1942),
    [aux_sym_preproc_if_token1] = ACTIONS(1942),
    [aux_sym_preproc_if_token2] = ACTIONS(1942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1942),
    [sym_preproc_directive] = ACTIONS(1942),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(1944),
    [anon_sym_TILDE] = ACTIONS(1944),
    [anon_sym_DASH] = ACTIONS(1942),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym_SEMI] = ACTIONS(1944),
    [anon_sym___extension__] = ACTIONS(1942),
    [anon_sym_typedef] = ACTIONS(1942),
    [anon_sym___device__] = ACTIONS(1942),
    [anon_sym___host__] = ACTIONS(1942),
    [anon_sym___global__] = ACTIONS(1942),
    [anon_sym___forceinline__] = ACTIONS(1942),
    [anon_sym___noinline__] = ACTIONS(1942),
    [anon_sym_extern] = ACTIONS(1942),
    [anon_sym___attribute__] = ACTIONS(1942),
    [anon_sym_COLON_COLON] = ACTIONS(1944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1944),
    [anon_sym___declspec] = ACTIONS(1942),
    [anon_sym___based] = ACTIONS(1942),
    [anon_sym___cdecl] = ACTIONS(1942),
    [anon_sym___clrcall] = ACTIONS(1942),
    [anon_sym___stdcall] = ACTIONS(1942),
    [anon_sym___fastcall] = ACTIONS(1942),
    [anon_sym___thiscall] = ACTIONS(1942),
    [anon_sym___vectorcall] = ACTIONS(1942),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_signed] = ACTIONS(1942),
    [anon_sym_unsigned] = ACTIONS(1942),
    [anon_sym_long] = ACTIONS(1942),
    [anon_sym_short] = ACTIONS(1942),
    [anon_sym_LBRACK] = ACTIONS(1942),
    [anon_sym_static] = ACTIONS(1942),
    [anon_sym_register] = ACTIONS(1942),
    [anon_sym_inline] = ACTIONS(1942),
    [anon_sym___inline] = ACTIONS(1942),
    [anon_sym___inline__] = ACTIONS(1942),
    [anon_sym___forceinline] = ACTIONS(1942),
    [anon_sym_thread_local] = ACTIONS(1942),
    [anon_sym___thread] = ACTIONS(1942),
    [anon_sym_const] = ACTIONS(1942),
    [anon_sym_constexpr] = ACTIONS(1942),
    [anon_sym_volatile] = ACTIONS(1942),
    [anon_sym_restrict] = ACTIONS(1942),
    [anon_sym___restrict__] = ACTIONS(1942),
    [anon_sym__Atomic] = ACTIONS(1942),
    [anon_sym__Noreturn] = ACTIONS(1942),
    [anon_sym_noreturn] = ACTIONS(1942),
    [anon_sym_mutable] = ACTIONS(1942),
    [anon_sym_constinit] = ACTIONS(1942),
    [anon_sym_consteval] = ACTIONS(1942),
    [anon_sym___shared__] = ACTIONS(1942),
    [anon_sym___local__] = ACTIONS(1942),
    [anon_sym___constant__] = ACTIONS(1942),
    [anon_sym___managed__] = ACTIONS(1942),
    [anon_sym___grid_constant__] = ACTIONS(1942),
    [anon_sym_alignas] = ACTIONS(1942),
    [anon_sym__Alignas] = ACTIONS(1942),
    [sym_primitive_type] = ACTIONS(1942),
    [anon_sym_enum] = ACTIONS(1942),
    [anon_sym_class] = ACTIONS(1942),
    [anon_sym_struct] = ACTIONS(1942),
    [anon_sym_union] = ACTIONS(1942),
    [anon_sym_if] = ACTIONS(1942),
    [anon_sym_else] = ACTIONS(1942),
    [anon_sym_switch] = ACTIONS(1942),
    [anon_sym_case] = ACTIONS(1942),
    [anon_sym_default] = ACTIONS(1942),
    [anon_sym_while] = ACTIONS(1942),
    [anon_sym_do] = ACTIONS(1942),
    [anon_sym_for] = ACTIONS(1942),
    [anon_sym_return] = ACTIONS(1942),
    [anon_sym_break] = ACTIONS(1942),
    [anon_sym_continue] = ACTIONS(1942),
    [anon_sym_goto] = ACTIONS(1942),
    [anon_sym___try] = ACTIONS(1942),
    [anon_sym___leave] = ACTIONS(1942),
    [anon_sym_not] = ACTIONS(1942),
    [anon_sym_compl] = ACTIONS(1942),
    [anon_sym_DASH_DASH] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1944),
    [anon_sym_sizeof] = ACTIONS(1942),
    [anon_sym___alignof__] = ACTIONS(1942),
    [anon_sym___alignof] = ACTIONS(1942),
    [anon_sym__alignof] = ACTIONS(1942),
    [anon_sym_alignof] = ACTIONS(1942),
    [anon_sym__Alignof] = ACTIONS(1942),
    [anon_sym_offsetof] = ACTIONS(1942),
    [anon_sym__Generic] = ACTIONS(1942),
    [anon_sym_asm] = ACTIONS(1942),
    [anon_sym___asm__] = ACTIONS(1942),
    [sym_number_literal] = ACTIONS(1944),
    [anon_sym_L_SQUOTE] = ACTIONS(1944),
    [anon_sym_u_SQUOTE] = ACTIONS(1944),
    [anon_sym_U_SQUOTE] = ACTIONS(1944),
    [anon_sym_u8_SQUOTE] = ACTIONS(1944),
    [anon_sym_SQUOTE] = ACTIONS(1944),
    [anon_sym_L_DQUOTE] = ACTIONS(1944),
    [anon_sym_u_DQUOTE] = ACTIONS(1944),
    [anon_sym_U_DQUOTE] = ACTIONS(1944),
    [anon_sym_u8_DQUOTE] = ACTIONS(1944),
    [anon_sym_DQUOTE] = ACTIONS(1944),
    [sym_true] = ACTIONS(1942),
    [sym_false] = ACTIONS(1942),
    [anon_sym_NULL] = ACTIONS(1942),
    [anon_sym_nullptr] = ACTIONS(1942),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1942),
    [anon_sym_decltype] = ACTIONS(1942),
    [sym_virtual] = ACTIONS(1942),
    [anon_sym_explicit] = ACTIONS(1942),
    [anon_sym_typename] = ACTIONS(1942),
    [anon_sym_template] = ACTIONS(1942),
    [anon_sym_operator] = ACTIONS(1942),
    [anon_sym_try] = ACTIONS(1942),
    [anon_sym_delete] = ACTIONS(1942),
    [anon_sym_throw] = ACTIONS(1942),
    [anon_sym_namespace] = ACTIONS(1942),
    [anon_sym_using] = ACTIONS(1942),
    [anon_sym_static_assert] = ACTIONS(1942),
    [anon_sym_concept] = ACTIONS(1942),
    [anon_sym_co_return] = ACTIONS(1942),
    [anon_sym_co_yield] = ACTIONS(1942),
    [anon_sym_R_DQUOTE] = ACTIONS(1944),
    [anon_sym_LR_DQUOTE] = ACTIONS(1944),
    [anon_sym_uR_DQUOTE] = ACTIONS(1944),
    [anon_sym_UR_DQUOTE] = ACTIONS(1944),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1944),
    [anon_sym_co_await] = ACTIONS(1942),
    [anon_sym_new] = ACTIONS(1942),
    [anon_sym_requires] = ACTIONS(1942),
    [sym_this] = ACTIONS(1942),
    [anon_sym___launch_bounds__] = ACTIONS(1942),
  },
  [404] = {
    [sym_identifier] = ACTIONS(1954),
    [aux_sym_preproc_include_token1] = ACTIONS(1954),
    [aux_sym_preproc_def_token1] = ACTIONS(1954),
    [aux_sym_preproc_if_token1] = ACTIONS(1954),
    [aux_sym_preproc_if_token2] = ACTIONS(1954),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1954),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1954),
    [sym_preproc_directive] = ACTIONS(1954),
    [anon_sym_LPAREN2] = ACTIONS(1956),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [anon_sym_DASH] = ACTIONS(1954),
    [anon_sym_PLUS] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(1956),
    [anon_sym_AMP_AMP] = ACTIONS(1956),
    [anon_sym_AMP] = ACTIONS(1954),
    [anon_sym_SEMI] = ACTIONS(1956),
    [anon_sym___extension__] = ACTIONS(1954),
    [anon_sym_typedef] = ACTIONS(1954),
    [anon_sym___device__] = ACTIONS(1954),
    [anon_sym___host__] = ACTIONS(1954),
    [anon_sym___global__] = ACTIONS(1954),
    [anon_sym___forceinline__] = ACTIONS(1954),
    [anon_sym___noinline__] = ACTIONS(1954),
    [anon_sym_extern] = ACTIONS(1954),
    [anon_sym___attribute__] = ACTIONS(1954),
    [anon_sym_COLON_COLON] = ACTIONS(1956),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1956),
    [anon_sym___declspec] = ACTIONS(1954),
    [anon_sym___based] = ACTIONS(1954),
    [anon_sym___cdecl] = ACTIONS(1954),
    [anon_sym___clrcall] = ACTIONS(1954),
    [anon_sym___stdcall] = ACTIONS(1954),
    [anon_sym___fastcall] = ACTIONS(1954),
    [anon_sym___thiscall] = ACTIONS(1954),
    [anon_sym___vectorcall] = ACTIONS(1954),
    [anon_sym_LBRACE] = ACTIONS(1956),
    [anon_sym_signed] = ACTIONS(1954),
    [anon_sym_unsigned] = ACTIONS(1954),
    [anon_sym_long] = ACTIONS(1954),
    [anon_sym_short] = ACTIONS(1954),
    [anon_sym_LBRACK] = ACTIONS(1954),
    [anon_sym_static] = ACTIONS(1954),
    [anon_sym_register] = ACTIONS(1954),
    [anon_sym_inline] = ACTIONS(1954),
    [anon_sym___inline] = ACTIONS(1954),
    [anon_sym___inline__] = ACTIONS(1954),
    [anon_sym___forceinline] = ACTIONS(1954),
    [anon_sym_thread_local] = ACTIONS(1954),
    [anon_sym___thread] = ACTIONS(1954),
    [anon_sym_const] = ACTIONS(1954),
    [anon_sym_constexpr] = ACTIONS(1954),
    [anon_sym_volatile] = ACTIONS(1954),
    [anon_sym_restrict] = ACTIONS(1954),
    [anon_sym___restrict__] = ACTIONS(1954),
    [anon_sym__Atomic] = ACTIONS(1954),
    [anon_sym__Noreturn] = ACTIONS(1954),
    [anon_sym_noreturn] = ACTIONS(1954),
    [anon_sym_mutable] = ACTIONS(1954),
    [anon_sym_constinit] = ACTIONS(1954),
    [anon_sym_consteval] = ACTIONS(1954),
    [anon_sym___shared__] = ACTIONS(1954),
    [anon_sym___local__] = ACTIONS(1954),
    [anon_sym___constant__] = ACTIONS(1954),
    [anon_sym___managed__] = ACTIONS(1954),
    [anon_sym___grid_constant__] = ACTIONS(1954),
    [anon_sym_alignas] = ACTIONS(1954),
    [anon_sym__Alignas] = ACTIONS(1954),
    [sym_primitive_type] = ACTIONS(1954),
    [anon_sym_enum] = ACTIONS(1954),
    [anon_sym_class] = ACTIONS(1954),
    [anon_sym_struct] = ACTIONS(1954),
    [anon_sym_union] = ACTIONS(1954),
    [anon_sym_if] = ACTIONS(1954),
    [anon_sym_else] = ACTIONS(1954),
    [anon_sym_switch] = ACTIONS(1954),
    [anon_sym_case] = ACTIONS(1954),
    [anon_sym_default] = ACTIONS(1954),
    [anon_sym_while] = ACTIONS(1954),
    [anon_sym_do] = ACTIONS(1954),
    [anon_sym_for] = ACTIONS(1954),
    [anon_sym_return] = ACTIONS(1954),
    [anon_sym_break] = ACTIONS(1954),
    [anon_sym_continue] = ACTIONS(1954),
    [anon_sym_goto] = ACTIONS(1954),
    [anon_sym___try] = ACTIONS(1954),
    [anon_sym___leave] = ACTIONS(1954),
    [anon_sym_not] = ACTIONS(1954),
    [anon_sym_compl] = ACTIONS(1954),
    [anon_sym_DASH_DASH] = ACTIONS(1956),
    [anon_sym_PLUS_PLUS] = ACTIONS(1956),
    [anon_sym_sizeof] = ACTIONS(1954),
    [anon_sym___alignof__] = ACTIONS(1954),
    [anon_sym___alignof] = ACTIONS(1954),
    [anon_sym__alignof] = ACTIONS(1954),
    [anon_sym_alignof] = ACTIONS(1954),
    [anon_sym__Alignof] = ACTIONS(1954),
    [anon_sym_offsetof] = ACTIONS(1954),
    [anon_sym__Generic] = ACTIONS(1954),
    [anon_sym_asm] = ACTIONS(1954),
    [anon_sym___asm__] = ACTIONS(1954),
    [sym_number_literal] = ACTIONS(1956),
    [anon_sym_L_SQUOTE] = ACTIONS(1956),
    [anon_sym_u_SQUOTE] = ACTIONS(1956),
    [anon_sym_U_SQUOTE] = ACTIONS(1956),
    [anon_sym_u8_SQUOTE] = ACTIONS(1956),
    [anon_sym_SQUOTE] = ACTIONS(1956),
    [anon_sym_L_DQUOTE] = ACTIONS(1956),
    [anon_sym_u_DQUOTE] = ACTIONS(1956),
    [anon_sym_U_DQUOTE] = ACTIONS(1956),
    [anon_sym_u8_DQUOTE] = ACTIONS(1956),
    [anon_sym_DQUOTE] = ACTIONS(1956),
    [sym_true] = ACTIONS(1954),
    [sym_false] = ACTIONS(1954),
    [anon_sym_NULL] = ACTIONS(1954),
    [anon_sym_nullptr] = ACTIONS(1954),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1954),
    [anon_sym_decltype] = ACTIONS(1954),
    [sym_virtual] = ACTIONS(1954),
    [anon_sym_explicit] = ACTIONS(1954),
    [anon_sym_typename] = ACTIONS(1954),
    [anon_sym_template] = ACTIONS(1954),
    [anon_sym_operator] = ACTIONS(1954),
    [anon_sym_try] = ACTIONS(1954),
    [anon_sym_delete] = ACTIONS(1954),
    [anon_sym_throw] = ACTIONS(1954),
    [anon_sym_namespace] = ACTIONS(1954),
    [anon_sym_using] = ACTIONS(1954),
    [anon_sym_static_assert] = ACTIONS(1954),
    [anon_sym_concept] = ACTIONS(1954),
    [anon_sym_co_return] = ACTIONS(1954),
    [anon_sym_co_yield] = ACTIONS(1954),
    [anon_sym_R_DQUOTE] = ACTIONS(1956),
    [anon_sym_LR_DQUOTE] = ACTIONS(1956),
    [anon_sym_uR_DQUOTE] = ACTIONS(1956),
    [anon_sym_UR_DQUOTE] = ACTIONS(1956),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1956),
    [anon_sym_co_await] = ACTIONS(1954),
    [anon_sym_new] = ACTIONS(1954),
    [anon_sym_requires] = ACTIONS(1954),
    [sym_this] = ACTIONS(1954),
    [anon_sym___launch_bounds__] = ACTIONS(1954),
  },
  [405] = {
    [sym_identifier] = ACTIONS(1972),
    [aux_sym_preproc_include_token1] = ACTIONS(1972),
    [aux_sym_preproc_def_token1] = ACTIONS(1972),
    [aux_sym_preproc_if_token1] = ACTIONS(1972),
    [aux_sym_preproc_if_token2] = ACTIONS(1972),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1972),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1972),
    [sym_preproc_directive] = ACTIONS(1972),
    [anon_sym_LPAREN2] = ACTIONS(1974),
    [anon_sym_BANG] = ACTIONS(1974),
    [anon_sym_TILDE] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1972),
    [anon_sym_PLUS] = ACTIONS(1972),
    [anon_sym_STAR] = ACTIONS(1974),
    [anon_sym_AMP_AMP] = ACTIONS(1974),
    [anon_sym_AMP] = ACTIONS(1972),
    [anon_sym_SEMI] = ACTIONS(1974),
    [anon_sym___extension__] = ACTIONS(1972),
    [anon_sym_typedef] = ACTIONS(1972),
    [anon_sym___device__] = ACTIONS(1972),
    [anon_sym___host__] = ACTIONS(1972),
    [anon_sym___global__] = ACTIONS(1972),
    [anon_sym___forceinline__] = ACTIONS(1972),
    [anon_sym___noinline__] = ACTIONS(1972),
    [anon_sym_extern] = ACTIONS(1972),
    [anon_sym___attribute__] = ACTIONS(1972),
    [anon_sym_COLON_COLON] = ACTIONS(1974),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1974),
    [anon_sym___declspec] = ACTIONS(1972),
    [anon_sym___based] = ACTIONS(1972),
    [anon_sym___cdecl] = ACTIONS(1972),
    [anon_sym___clrcall] = ACTIONS(1972),
    [anon_sym___stdcall] = ACTIONS(1972),
    [anon_sym___fastcall] = ACTIONS(1972),
    [anon_sym___thiscall] = ACTIONS(1972),
    [anon_sym___vectorcall] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1974),
    [anon_sym_signed] = ACTIONS(1972),
    [anon_sym_unsigned] = ACTIONS(1972),
    [anon_sym_long] = ACTIONS(1972),
    [anon_sym_short] = ACTIONS(1972),
    [anon_sym_LBRACK] = ACTIONS(1972),
    [anon_sym_static] = ACTIONS(1972),
    [anon_sym_register] = ACTIONS(1972),
    [anon_sym_inline] = ACTIONS(1972),
    [anon_sym___inline] = ACTIONS(1972),
    [anon_sym___inline__] = ACTIONS(1972),
    [anon_sym___forceinline] = ACTIONS(1972),
    [anon_sym_thread_local] = ACTIONS(1972),
    [anon_sym___thread] = ACTIONS(1972),
    [anon_sym_const] = ACTIONS(1972),
    [anon_sym_constexpr] = ACTIONS(1972),
    [anon_sym_volatile] = ACTIONS(1972),
    [anon_sym_restrict] = ACTIONS(1972),
    [anon_sym___restrict__] = ACTIONS(1972),
    [anon_sym__Atomic] = ACTIONS(1972),
    [anon_sym__Noreturn] = ACTIONS(1972),
    [anon_sym_noreturn] = ACTIONS(1972),
    [anon_sym_mutable] = ACTIONS(1972),
    [anon_sym_constinit] = ACTIONS(1972),
    [anon_sym_consteval] = ACTIONS(1972),
    [anon_sym___shared__] = ACTIONS(1972),
    [anon_sym___local__] = ACTIONS(1972),
    [anon_sym___constant__] = ACTIONS(1972),
    [anon_sym___managed__] = ACTIONS(1972),
    [anon_sym___grid_constant__] = ACTIONS(1972),
    [anon_sym_alignas] = ACTIONS(1972),
    [anon_sym__Alignas] = ACTIONS(1972),
    [sym_primitive_type] = ACTIONS(1972),
    [anon_sym_enum] = ACTIONS(1972),
    [anon_sym_class] = ACTIONS(1972),
    [anon_sym_struct] = ACTIONS(1972),
    [anon_sym_union] = ACTIONS(1972),
    [anon_sym_if] = ACTIONS(1972),
    [anon_sym_else] = ACTIONS(1972),
    [anon_sym_switch] = ACTIONS(1972),
    [anon_sym_case] = ACTIONS(1972),
    [anon_sym_default] = ACTIONS(1972),
    [anon_sym_while] = ACTIONS(1972),
    [anon_sym_do] = ACTIONS(1972),
    [anon_sym_for] = ACTIONS(1972),
    [anon_sym_return] = ACTIONS(1972),
    [anon_sym_break] = ACTIONS(1972),
    [anon_sym_continue] = ACTIONS(1972),
    [anon_sym_goto] = ACTIONS(1972),
    [anon_sym___try] = ACTIONS(1972),
    [anon_sym___leave] = ACTIONS(1972),
    [anon_sym_not] = ACTIONS(1972),
    [anon_sym_compl] = ACTIONS(1972),
    [anon_sym_DASH_DASH] = ACTIONS(1974),
    [anon_sym_PLUS_PLUS] = ACTIONS(1974),
    [anon_sym_sizeof] = ACTIONS(1972),
    [anon_sym___alignof__] = ACTIONS(1972),
    [anon_sym___alignof] = ACTIONS(1972),
    [anon_sym__alignof] = ACTIONS(1972),
    [anon_sym_alignof] = ACTIONS(1972),
    [anon_sym__Alignof] = ACTIONS(1972),
    [anon_sym_offsetof] = ACTIONS(1972),
    [anon_sym__Generic] = ACTIONS(1972),
    [anon_sym_asm] = ACTIONS(1972),
    [anon_sym___asm__] = ACTIONS(1972),
    [sym_number_literal] = ACTIONS(1974),
    [anon_sym_L_SQUOTE] = ACTIONS(1974),
    [anon_sym_u_SQUOTE] = ACTIONS(1974),
    [anon_sym_U_SQUOTE] = ACTIONS(1974),
    [anon_sym_u8_SQUOTE] = ACTIONS(1974),
    [anon_sym_SQUOTE] = ACTIONS(1974),
    [anon_sym_L_DQUOTE] = ACTIONS(1974),
    [anon_sym_u_DQUOTE] = ACTIONS(1974),
    [anon_sym_U_DQUOTE] = ACTIONS(1974),
    [anon_sym_u8_DQUOTE] = ACTIONS(1974),
    [anon_sym_DQUOTE] = ACTIONS(1974),
    [sym_true] = ACTIONS(1972),
    [sym_false] = ACTIONS(1972),
    [anon_sym_NULL] = ACTIONS(1972),
    [anon_sym_nullptr] = ACTIONS(1972),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1972),
    [anon_sym_decltype] = ACTIONS(1972),
    [sym_virtual] = ACTIONS(1972),
    [anon_sym_explicit] = ACTIONS(1972),
    [anon_sym_typename] = ACTIONS(1972),
    [anon_sym_template] = ACTIONS(1972),
    [anon_sym_operator] = ACTIONS(1972),
    [anon_sym_try] = ACTIONS(1972),
    [anon_sym_delete] = ACTIONS(1972),
    [anon_sym_throw] = ACTIONS(1972),
    [anon_sym_namespace] = ACTIONS(1972),
    [anon_sym_using] = ACTIONS(1972),
    [anon_sym_static_assert] = ACTIONS(1972),
    [anon_sym_concept] = ACTIONS(1972),
    [anon_sym_co_return] = ACTIONS(1972),
    [anon_sym_co_yield] = ACTIONS(1972),
    [anon_sym_R_DQUOTE] = ACTIONS(1974),
    [anon_sym_LR_DQUOTE] = ACTIONS(1974),
    [anon_sym_uR_DQUOTE] = ACTIONS(1974),
    [anon_sym_UR_DQUOTE] = ACTIONS(1974),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1974),
    [anon_sym_co_await] = ACTIONS(1972),
    [anon_sym_new] = ACTIONS(1972),
    [anon_sym_requires] = ACTIONS(1972),
    [sym_this] = ACTIONS(1972),
    [anon_sym___launch_bounds__] = ACTIONS(1972),
  },
  [406] = {
    [ts_builtin_sym_end] = ACTIONS(2026),
    [sym_identifier] = ACTIONS(2024),
    [aux_sym_preproc_include_token1] = ACTIONS(2024),
    [aux_sym_preproc_def_token1] = ACTIONS(2024),
    [aux_sym_preproc_if_token1] = ACTIONS(2024),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2024),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2024),
    [sym_preproc_directive] = ACTIONS(2024),
    [anon_sym_LPAREN2] = ACTIONS(2026),
    [anon_sym_BANG] = ACTIONS(2026),
    [anon_sym_TILDE] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2024),
    [anon_sym_PLUS] = ACTIONS(2024),
    [anon_sym_STAR] = ACTIONS(2026),
    [anon_sym_AMP_AMP] = ACTIONS(2026),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_SEMI] = ACTIONS(2026),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_typedef] = ACTIONS(2024),
    [anon_sym___device__] = ACTIONS(2024),
    [anon_sym___host__] = ACTIONS(2024),
    [anon_sym___global__] = ACTIONS(2024),
    [anon_sym___forceinline__] = ACTIONS(2024),
    [anon_sym___noinline__] = ACTIONS(2024),
    [anon_sym_extern] = ACTIONS(2024),
    [anon_sym___attribute__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(2026),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2026),
    [anon_sym___declspec] = ACTIONS(2024),
    [anon_sym___based] = ACTIONS(2024),
    [anon_sym___cdecl] = ACTIONS(2024),
    [anon_sym___clrcall] = ACTIONS(2024),
    [anon_sym___stdcall] = ACTIONS(2024),
    [anon_sym___fastcall] = ACTIONS(2024),
    [anon_sym___thiscall] = ACTIONS(2024),
    [anon_sym___vectorcall] = ACTIONS(2024),
    [anon_sym_LBRACE] = ACTIONS(2026),
    [anon_sym_signed] = ACTIONS(2024),
    [anon_sym_unsigned] = ACTIONS(2024),
    [anon_sym_long] = ACTIONS(2024),
    [anon_sym_short] = ACTIONS(2024),
    [anon_sym_LBRACK] = ACTIONS(2024),
    [anon_sym_static] = ACTIONS(2024),
    [anon_sym_register] = ACTIONS(2024),
    [anon_sym_inline] = ACTIONS(2024),
    [anon_sym___inline] = ACTIONS(2024),
    [anon_sym___inline__] = ACTIONS(2024),
    [anon_sym___forceinline] = ACTIONS(2024),
    [anon_sym_thread_local] = ACTIONS(2024),
    [anon_sym___thread] = ACTIONS(2024),
    [anon_sym_const] = ACTIONS(2024),
    [anon_sym_constexpr] = ACTIONS(2024),
    [anon_sym_volatile] = ACTIONS(2024),
    [anon_sym_restrict] = ACTIONS(2024),
    [anon_sym___restrict__] = ACTIONS(2024),
    [anon_sym__Atomic] = ACTIONS(2024),
    [anon_sym__Noreturn] = ACTIONS(2024),
    [anon_sym_noreturn] = ACTIONS(2024),
    [anon_sym_mutable] = ACTIONS(2024),
    [anon_sym_constinit] = ACTIONS(2024),
    [anon_sym_consteval] = ACTIONS(2024),
    [anon_sym___shared__] = ACTIONS(2024),
    [anon_sym___local__] = ACTIONS(2024),
    [anon_sym___constant__] = ACTIONS(2024),
    [anon_sym___managed__] = ACTIONS(2024),
    [anon_sym___grid_constant__] = ACTIONS(2024),
    [anon_sym_alignas] = ACTIONS(2024),
    [anon_sym__Alignas] = ACTIONS(2024),
    [sym_primitive_type] = ACTIONS(2024),
    [anon_sym_enum] = ACTIONS(2024),
    [anon_sym_class] = ACTIONS(2024),
    [anon_sym_struct] = ACTIONS(2024),
    [anon_sym_union] = ACTIONS(2024),
    [anon_sym_if] = ACTIONS(2024),
    [anon_sym_else] = ACTIONS(2024),
    [anon_sym_switch] = ACTIONS(2024),
    [anon_sym_case] = ACTIONS(2024),
    [anon_sym_default] = ACTIONS(2024),
    [anon_sym_while] = ACTIONS(2024),
    [anon_sym_do] = ACTIONS(2024),
    [anon_sym_for] = ACTIONS(2024),
    [anon_sym_return] = ACTIONS(2024),
    [anon_sym_break] = ACTIONS(2024),
    [anon_sym_continue] = ACTIONS(2024),
    [anon_sym_goto] = ACTIONS(2024),
    [anon_sym___try] = ACTIONS(2024),
    [anon_sym___leave] = ACTIONS(2024),
    [anon_sym_not] = ACTIONS(2024),
    [anon_sym_compl] = ACTIONS(2024),
    [anon_sym_DASH_DASH] = ACTIONS(2026),
    [anon_sym_PLUS_PLUS] = ACTIONS(2026),
    [anon_sym_sizeof] = ACTIONS(2024),
    [anon_sym___alignof__] = ACTIONS(2024),
    [anon_sym___alignof] = ACTIONS(2024),
    [anon_sym__alignof] = ACTIONS(2024),
    [anon_sym_alignof] = ACTIONS(2024),
    [anon_sym__Alignof] = ACTIONS(2024),
    [anon_sym_offsetof] = ACTIONS(2024),
    [anon_sym__Generic] = ACTIONS(2024),
    [anon_sym_asm] = ACTIONS(2024),
    [anon_sym___asm__] = ACTIONS(2024),
    [sym_number_literal] = ACTIONS(2026),
    [anon_sym_L_SQUOTE] = ACTIONS(2026),
    [anon_sym_u_SQUOTE] = ACTIONS(2026),
    [anon_sym_U_SQUOTE] = ACTIONS(2026),
    [anon_sym_u8_SQUOTE] = ACTIONS(2026),
    [anon_sym_SQUOTE] = ACTIONS(2026),
    [anon_sym_L_DQUOTE] = ACTIONS(2026),
    [anon_sym_u_DQUOTE] = ACTIONS(2026),
    [anon_sym_U_DQUOTE] = ACTIONS(2026),
    [anon_sym_u8_DQUOTE] = ACTIONS(2026),
    [anon_sym_DQUOTE] = ACTIONS(2026),
    [sym_true] = ACTIONS(2024),
    [sym_false] = ACTIONS(2024),
    [anon_sym_NULL] = ACTIONS(2024),
    [anon_sym_nullptr] = ACTIONS(2024),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2024),
    [anon_sym_decltype] = ACTIONS(2024),
    [sym_virtual] = ACTIONS(2024),
    [anon_sym_explicit] = ACTIONS(2024),
    [anon_sym_typename] = ACTIONS(2024),
    [anon_sym_template] = ACTIONS(2024),
    [anon_sym_operator] = ACTIONS(2024),
    [anon_sym_try] = ACTIONS(2024),
    [anon_sym_delete] = ACTIONS(2024),
    [anon_sym_throw] = ACTIONS(2024),
    [anon_sym_namespace] = ACTIONS(2024),
    [anon_sym_using] = ACTIONS(2024),
    [anon_sym_static_assert] = ACTIONS(2024),
    [anon_sym_concept] = ACTIONS(2024),
    [anon_sym_co_return] = ACTIONS(2024),
    [anon_sym_co_yield] = ACTIONS(2024),
    [anon_sym_R_DQUOTE] = ACTIONS(2026),
    [anon_sym_LR_DQUOTE] = ACTIONS(2026),
    [anon_sym_uR_DQUOTE] = ACTIONS(2026),
    [anon_sym_UR_DQUOTE] = ACTIONS(2026),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2026),
    [anon_sym_co_await] = ACTIONS(2024),
    [anon_sym_new] = ACTIONS(2024),
    [anon_sym_requires] = ACTIONS(2024),
    [sym_this] = ACTIONS(2024),
    [anon_sym___launch_bounds__] = ACTIONS(2024),
  },
  [407] = {
    [sym_identifier] = ACTIONS(1968),
    [aux_sym_preproc_include_token1] = ACTIONS(1968),
    [aux_sym_preproc_def_token1] = ACTIONS(1968),
    [aux_sym_preproc_if_token1] = ACTIONS(1968),
    [aux_sym_preproc_if_token2] = ACTIONS(1968),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1968),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1968),
    [sym_preproc_directive] = ACTIONS(1968),
    [anon_sym_LPAREN2] = ACTIONS(1970),
    [anon_sym_BANG] = ACTIONS(1970),
    [anon_sym_TILDE] = ACTIONS(1970),
    [anon_sym_DASH] = ACTIONS(1968),
    [anon_sym_PLUS] = ACTIONS(1968),
    [anon_sym_STAR] = ACTIONS(1970),
    [anon_sym_AMP_AMP] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(1968),
    [anon_sym_SEMI] = ACTIONS(1970),
    [anon_sym___extension__] = ACTIONS(1968),
    [anon_sym_typedef] = ACTIONS(1968),
    [anon_sym___device__] = ACTIONS(1968),
    [anon_sym___host__] = ACTIONS(1968),
    [anon_sym___global__] = ACTIONS(1968),
    [anon_sym___forceinline__] = ACTIONS(1968),
    [anon_sym___noinline__] = ACTIONS(1968),
    [anon_sym_extern] = ACTIONS(1968),
    [anon_sym___attribute__] = ACTIONS(1968),
    [anon_sym_COLON_COLON] = ACTIONS(1970),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1970),
    [anon_sym___declspec] = ACTIONS(1968),
    [anon_sym___based] = ACTIONS(1968),
    [anon_sym___cdecl] = ACTIONS(1968),
    [anon_sym___clrcall] = ACTIONS(1968),
    [anon_sym___stdcall] = ACTIONS(1968),
    [anon_sym___fastcall] = ACTIONS(1968),
    [anon_sym___thiscall] = ACTIONS(1968),
    [anon_sym___vectorcall] = ACTIONS(1968),
    [anon_sym_LBRACE] = ACTIONS(1970),
    [anon_sym_signed] = ACTIONS(1968),
    [anon_sym_unsigned] = ACTIONS(1968),
    [anon_sym_long] = ACTIONS(1968),
    [anon_sym_short] = ACTIONS(1968),
    [anon_sym_LBRACK] = ACTIONS(1968),
    [anon_sym_static] = ACTIONS(1968),
    [anon_sym_register] = ACTIONS(1968),
    [anon_sym_inline] = ACTIONS(1968),
    [anon_sym___inline] = ACTIONS(1968),
    [anon_sym___inline__] = ACTIONS(1968),
    [anon_sym___forceinline] = ACTIONS(1968),
    [anon_sym_thread_local] = ACTIONS(1968),
    [anon_sym___thread] = ACTIONS(1968),
    [anon_sym_const] = ACTIONS(1968),
    [anon_sym_constexpr] = ACTIONS(1968),
    [anon_sym_volatile] = ACTIONS(1968),
    [anon_sym_restrict] = ACTIONS(1968),
    [anon_sym___restrict__] = ACTIONS(1968),
    [anon_sym__Atomic] = ACTIONS(1968),
    [anon_sym__Noreturn] = ACTIONS(1968),
    [anon_sym_noreturn] = ACTIONS(1968),
    [anon_sym_mutable] = ACTIONS(1968),
    [anon_sym_constinit] = ACTIONS(1968),
    [anon_sym_consteval] = ACTIONS(1968),
    [anon_sym___shared__] = ACTIONS(1968),
    [anon_sym___local__] = ACTIONS(1968),
    [anon_sym___constant__] = ACTIONS(1968),
    [anon_sym___managed__] = ACTIONS(1968),
    [anon_sym___grid_constant__] = ACTIONS(1968),
    [anon_sym_alignas] = ACTIONS(1968),
    [anon_sym__Alignas] = ACTIONS(1968),
    [sym_primitive_type] = ACTIONS(1968),
    [anon_sym_enum] = ACTIONS(1968),
    [anon_sym_class] = ACTIONS(1968),
    [anon_sym_struct] = ACTIONS(1968),
    [anon_sym_union] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_else] = ACTIONS(1968),
    [anon_sym_switch] = ACTIONS(1968),
    [anon_sym_case] = ACTIONS(1968),
    [anon_sym_default] = ACTIONS(1968),
    [anon_sym_while] = ACTIONS(1968),
    [anon_sym_do] = ACTIONS(1968),
    [anon_sym_for] = ACTIONS(1968),
    [anon_sym_return] = ACTIONS(1968),
    [anon_sym_break] = ACTIONS(1968),
    [anon_sym_continue] = ACTIONS(1968),
    [anon_sym_goto] = ACTIONS(1968),
    [anon_sym___try] = ACTIONS(1968),
    [anon_sym___leave] = ACTIONS(1968),
    [anon_sym_not] = ACTIONS(1968),
    [anon_sym_compl] = ACTIONS(1968),
    [anon_sym_DASH_DASH] = ACTIONS(1970),
    [anon_sym_PLUS_PLUS] = ACTIONS(1970),
    [anon_sym_sizeof] = ACTIONS(1968),
    [anon_sym___alignof__] = ACTIONS(1968),
    [anon_sym___alignof] = ACTIONS(1968),
    [anon_sym__alignof] = ACTIONS(1968),
    [anon_sym_alignof] = ACTIONS(1968),
    [anon_sym__Alignof] = ACTIONS(1968),
    [anon_sym_offsetof] = ACTIONS(1968),
    [anon_sym__Generic] = ACTIONS(1968),
    [anon_sym_asm] = ACTIONS(1968),
    [anon_sym___asm__] = ACTIONS(1968),
    [sym_number_literal] = ACTIONS(1970),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1970),
    [anon_sym_u_DQUOTE] = ACTIONS(1970),
    [anon_sym_U_DQUOTE] = ACTIONS(1970),
    [anon_sym_u8_DQUOTE] = ACTIONS(1970),
    [anon_sym_DQUOTE] = ACTIONS(1970),
    [sym_true] = ACTIONS(1968),
    [sym_false] = ACTIONS(1968),
    [anon_sym_NULL] = ACTIONS(1968),
    [anon_sym_nullptr] = ACTIONS(1968),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1968),
    [anon_sym_decltype] = ACTIONS(1968),
    [sym_virtual] = ACTIONS(1968),
    [anon_sym_explicit] = ACTIONS(1968),
    [anon_sym_typename] = ACTIONS(1968),
    [anon_sym_template] = ACTIONS(1968),
    [anon_sym_operator] = ACTIONS(1968),
    [anon_sym_try] = ACTIONS(1968),
    [anon_sym_delete] = ACTIONS(1968),
    [anon_sym_throw] = ACTIONS(1968),
    [anon_sym_namespace] = ACTIONS(1968),
    [anon_sym_using] = ACTIONS(1968),
    [anon_sym_static_assert] = ACTIONS(1968),
    [anon_sym_concept] = ACTIONS(1968),
    [anon_sym_co_return] = ACTIONS(1968),
    [anon_sym_co_yield] = ACTIONS(1968),
    [anon_sym_R_DQUOTE] = ACTIONS(1970),
    [anon_sym_LR_DQUOTE] = ACTIONS(1970),
    [anon_sym_uR_DQUOTE] = ACTIONS(1970),
    [anon_sym_UR_DQUOTE] = ACTIONS(1970),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1970),
    [anon_sym_co_await] = ACTIONS(1968),
    [anon_sym_new] = ACTIONS(1968),
    [anon_sym_requires] = ACTIONS(1968),
    [sym_this] = ACTIONS(1968),
    [anon_sym___launch_bounds__] = ACTIONS(1968),
  },
  [408] = {
    [sym_identifier] = ACTIONS(1972),
    [aux_sym_preproc_include_token1] = ACTIONS(1972),
    [aux_sym_preproc_def_token1] = ACTIONS(1972),
    [aux_sym_preproc_if_token1] = ACTIONS(1972),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1972),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1972),
    [sym_preproc_directive] = ACTIONS(1972),
    [anon_sym_LPAREN2] = ACTIONS(1974),
    [anon_sym_BANG] = ACTIONS(1974),
    [anon_sym_TILDE] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1972),
    [anon_sym_PLUS] = ACTIONS(1972),
    [anon_sym_STAR] = ACTIONS(1974),
    [anon_sym_AMP_AMP] = ACTIONS(1974),
    [anon_sym_AMP] = ACTIONS(1972),
    [anon_sym_SEMI] = ACTIONS(1974),
    [anon_sym___extension__] = ACTIONS(1972),
    [anon_sym_typedef] = ACTIONS(1972),
    [anon_sym___device__] = ACTIONS(1972),
    [anon_sym___host__] = ACTIONS(1972),
    [anon_sym___global__] = ACTIONS(1972),
    [anon_sym___forceinline__] = ACTIONS(1972),
    [anon_sym___noinline__] = ACTIONS(1972),
    [anon_sym_extern] = ACTIONS(1972),
    [anon_sym___attribute__] = ACTIONS(1972),
    [anon_sym_COLON_COLON] = ACTIONS(1974),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1974),
    [anon_sym___declspec] = ACTIONS(1972),
    [anon_sym___based] = ACTIONS(1972),
    [anon_sym___cdecl] = ACTIONS(1972),
    [anon_sym___clrcall] = ACTIONS(1972),
    [anon_sym___stdcall] = ACTIONS(1972),
    [anon_sym___fastcall] = ACTIONS(1972),
    [anon_sym___thiscall] = ACTIONS(1972),
    [anon_sym___vectorcall] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1974),
    [anon_sym_RBRACE] = ACTIONS(1974),
    [anon_sym_signed] = ACTIONS(1972),
    [anon_sym_unsigned] = ACTIONS(1972),
    [anon_sym_long] = ACTIONS(1972),
    [anon_sym_short] = ACTIONS(1972),
    [anon_sym_LBRACK] = ACTIONS(1972),
    [anon_sym_static] = ACTIONS(1972),
    [anon_sym_register] = ACTIONS(1972),
    [anon_sym_inline] = ACTIONS(1972),
    [anon_sym___inline] = ACTIONS(1972),
    [anon_sym___inline__] = ACTIONS(1972),
    [anon_sym___forceinline] = ACTIONS(1972),
    [anon_sym_thread_local] = ACTIONS(1972),
    [anon_sym___thread] = ACTIONS(1972),
    [anon_sym_const] = ACTIONS(1972),
    [anon_sym_constexpr] = ACTIONS(1972),
    [anon_sym_volatile] = ACTIONS(1972),
    [anon_sym_restrict] = ACTIONS(1972),
    [anon_sym___restrict__] = ACTIONS(1972),
    [anon_sym__Atomic] = ACTIONS(1972),
    [anon_sym__Noreturn] = ACTIONS(1972),
    [anon_sym_noreturn] = ACTIONS(1972),
    [anon_sym_mutable] = ACTIONS(1972),
    [anon_sym_constinit] = ACTIONS(1972),
    [anon_sym_consteval] = ACTIONS(1972),
    [anon_sym___shared__] = ACTIONS(1972),
    [anon_sym___local__] = ACTIONS(1972),
    [anon_sym___constant__] = ACTIONS(1972),
    [anon_sym___managed__] = ACTIONS(1972),
    [anon_sym___grid_constant__] = ACTIONS(1972),
    [anon_sym_alignas] = ACTIONS(1972),
    [anon_sym__Alignas] = ACTIONS(1972),
    [sym_primitive_type] = ACTIONS(1972),
    [anon_sym_enum] = ACTIONS(1972),
    [anon_sym_class] = ACTIONS(1972),
    [anon_sym_struct] = ACTIONS(1972),
    [anon_sym_union] = ACTIONS(1972),
    [anon_sym_if] = ACTIONS(1972),
    [anon_sym_else] = ACTIONS(1972),
    [anon_sym_switch] = ACTIONS(1972),
    [anon_sym_case] = ACTIONS(1972),
    [anon_sym_default] = ACTIONS(1972),
    [anon_sym_while] = ACTIONS(1972),
    [anon_sym_do] = ACTIONS(1972),
    [anon_sym_for] = ACTIONS(1972),
    [anon_sym_return] = ACTIONS(1972),
    [anon_sym_break] = ACTIONS(1972),
    [anon_sym_continue] = ACTIONS(1972),
    [anon_sym_goto] = ACTIONS(1972),
    [anon_sym___try] = ACTIONS(1972),
    [anon_sym___leave] = ACTIONS(1972),
    [anon_sym_not] = ACTIONS(1972),
    [anon_sym_compl] = ACTIONS(1972),
    [anon_sym_DASH_DASH] = ACTIONS(1974),
    [anon_sym_PLUS_PLUS] = ACTIONS(1974),
    [anon_sym_sizeof] = ACTIONS(1972),
    [anon_sym___alignof__] = ACTIONS(1972),
    [anon_sym___alignof] = ACTIONS(1972),
    [anon_sym__alignof] = ACTIONS(1972),
    [anon_sym_alignof] = ACTIONS(1972),
    [anon_sym__Alignof] = ACTIONS(1972),
    [anon_sym_offsetof] = ACTIONS(1972),
    [anon_sym__Generic] = ACTIONS(1972),
    [anon_sym_asm] = ACTIONS(1972),
    [anon_sym___asm__] = ACTIONS(1972),
    [sym_number_literal] = ACTIONS(1974),
    [anon_sym_L_SQUOTE] = ACTIONS(1974),
    [anon_sym_u_SQUOTE] = ACTIONS(1974),
    [anon_sym_U_SQUOTE] = ACTIONS(1974),
    [anon_sym_u8_SQUOTE] = ACTIONS(1974),
    [anon_sym_SQUOTE] = ACTIONS(1974),
    [anon_sym_L_DQUOTE] = ACTIONS(1974),
    [anon_sym_u_DQUOTE] = ACTIONS(1974),
    [anon_sym_U_DQUOTE] = ACTIONS(1974),
    [anon_sym_u8_DQUOTE] = ACTIONS(1974),
    [anon_sym_DQUOTE] = ACTIONS(1974),
    [sym_true] = ACTIONS(1972),
    [sym_false] = ACTIONS(1972),
    [anon_sym_NULL] = ACTIONS(1972),
    [anon_sym_nullptr] = ACTIONS(1972),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1972),
    [anon_sym_decltype] = ACTIONS(1972),
    [sym_virtual] = ACTIONS(1972),
    [anon_sym_explicit] = ACTIONS(1972),
    [anon_sym_typename] = ACTIONS(1972),
    [anon_sym_template] = ACTIONS(1972),
    [anon_sym_operator] = ACTIONS(1972),
    [anon_sym_try] = ACTIONS(1972),
    [anon_sym_delete] = ACTIONS(1972),
    [anon_sym_throw] = ACTIONS(1972),
    [anon_sym_namespace] = ACTIONS(1972),
    [anon_sym_using] = ACTIONS(1972),
    [anon_sym_static_assert] = ACTIONS(1972),
    [anon_sym_concept] = ACTIONS(1972),
    [anon_sym_co_return] = ACTIONS(1972),
    [anon_sym_co_yield] = ACTIONS(1972),
    [anon_sym_R_DQUOTE] = ACTIONS(1974),
    [anon_sym_LR_DQUOTE] = ACTIONS(1974),
    [anon_sym_uR_DQUOTE] = ACTIONS(1974),
    [anon_sym_UR_DQUOTE] = ACTIONS(1974),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1974),
    [anon_sym_co_await] = ACTIONS(1972),
    [anon_sym_new] = ACTIONS(1972),
    [anon_sym_requires] = ACTIONS(1972),
    [sym_this] = ACTIONS(1972),
    [anon_sym___launch_bounds__] = ACTIONS(1972),
  },
  [409] = {
    [ts_builtin_sym_end] = ACTIONS(2022),
    [sym_identifier] = ACTIONS(2020),
    [aux_sym_preproc_include_token1] = ACTIONS(2020),
    [aux_sym_preproc_def_token1] = ACTIONS(2020),
    [aux_sym_preproc_if_token1] = ACTIONS(2020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2020),
    [sym_preproc_directive] = ACTIONS(2020),
    [anon_sym_LPAREN2] = ACTIONS(2022),
    [anon_sym_BANG] = ACTIONS(2022),
    [anon_sym_TILDE] = ACTIONS(2022),
    [anon_sym_DASH] = ACTIONS(2020),
    [anon_sym_PLUS] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(2022),
    [anon_sym_AMP_AMP] = ACTIONS(2022),
    [anon_sym_AMP] = ACTIONS(2020),
    [anon_sym_SEMI] = ACTIONS(2022),
    [anon_sym___extension__] = ACTIONS(2020),
    [anon_sym_typedef] = ACTIONS(2020),
    [anon_sym___device__] = ACTIONS(2020),
    [anon_sym___host__] = ACTIONS(2020),
    [anon_sym___global__] = ACTIONS(2020),
    [anon_sym___forceinline__] = ACTIONS(2020),
    [anon_sym___noinline__] = ACTIONS(2020),
    [anon_sym_extern] = ACTIONS(2020),
    [anon_sym___attribute__] = ACTIONS(2020),
    [anon_sym_COLON_COLON] = ACTIONS(2022),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2022),
    [anon_sym___declspec] = ACTIONS(2020),
    [anon_sym___based] = ACTIONS(2020),
    [anon_sym___cdecl] = ACTIONS(2020),
    [anon_sym___clrcall] = ACTIONS(2020),
    [anon_sym___stdcall] = ACTIONS(2020),
    [anon_sym___fastcall] = ACTIONS(2020),
    [anon_sym___thiscall] = ACTIONS(2020),
    [anon_sym___vectorcall] = ACTIONS(2020),
    [anon_sym_LBRACE] = ACTIONS(2022),
    [anon_sym_signed] = ACTIONS(2020),
    [anon_sym_unsigned] = ACTIONS(2020),
    [anon_sym_long] = ACTIONS(2020),
    [anon_sym_short] = ACTIONS(2020),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(2020),
    [anon_sym_register] = ACTIONS(2020),
    [anon_sym_inline] = ACTIONS(2020),
    [anon_sym___inline] = ACTIONS(2020),
    [anon_sym___inline__] = ACTIONS(2020),
    [anon_sym___forceinline] = ACTIONS(2020),
    [anon_sym_thread_local] = ACTIONS(2020),
    [anon_sym___thread] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(2020),
    [anon_sym_constexpr] = ACTIONS(2020),
    [anon_sym_volatile] = ACTIONS(2020),
    [anon_sym_restrict] = ACTIONS(2020),
    [anon_sym___restrict__] = ACTIONS(2020),
    [anon_sym__Atomic] = ACTIONS(2020),
    [anon_sym__Noreturn] = ACTIONS(2020),
    [anon_sym_noreturn] = ACTIONS(2020),
    [anon_sym_mutable] = ACTIONS(2020),
    [anon_sym_constinit] = ACTIONS(2020),
    [anon_sym_consteval] = ACTIONS(2020),
    [anon_sym___shared__] = ACTIONS(2020),
    [anon_sym___local__] = ACTIONS(2020),
    [anon_sym___constant__] = ACTIONS(2020),
    [anon_sym___managed__] = ACTIONS(2020),
    [anon_sym___grid_constant__] = ACTIONS(2020),
    [anon_sym_alignas] = ACTIONS(2020),
    [anon_sym__Alignas] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2020),
    [anon_sym_enum] = ACTIONS(2020),
    [anon_sym_class] = ACTIONS(2020),
    [anon_sym_struct] = ACTIONS(2020),
    [anon_sym_union] = ACTIONS(2020),
    [anon_sym_if] = ACTIONS(2020),
    [anon_sym_else] = ACTIONS(2020),
    [anon_sym_switch] = ACTIONS(2020),
    [anon_sym_case] = ACTIONS(2020),
    [anon_sym_default] = ACTIONS(2020),
    [anon_sym_while] = ACTIONS(2020),
    [anon_sym_do] = ACTIONS(2020),
    [anon_sym_for] = ACTIONS(2020),
    [anon_sym_return] = ACTIONS(2020),
    [anon_sym_break] = ACTIONS(2020),
    [anon_sym_continue] = ACTIONS(2020),
    [anon_sym_goto] = ACTIONS(2020),
    [anon_sym___try] = ACTIONS(2020),
    [anon_sym___leave] = ACTIONS(2020),
    [anon_sym_not] = ACTIONS(2020),
    [anon_sym_compl] = ACTIONS(2020),
    [anon_sym_DASH_DASH] = ACTIONS(2022),
    [anon_sym_PLUS_PLUS] = ACTIONS(2022),
    [anon_sym_sizeof] = ACTIONS(2020),
    [anon_sym___alignof__] = ACTIONS(2020),
    [anon_sym___alignof] = ACTIONS(2020),
    [anon_sym__alignof] = ACTIONS(2020),
    [anon_sym_alignof] = ACTIONS(2020),
    [anon_sym__Alignof] = ACTIONS(2020),
    [anon_sym_offsetof] = ACTIONS(2020),
    [anon_sym__Generic] = ACTIONS(2020),
    [anon_sym_asm] = ACTIONS(2020),
    [anon_sym___asm__] = ACTIONS(2020),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_L_SQUOTE] = ACTIONS(2022),
    [anon_sym_u_SQUOTE] = ACTIONS(2022),
    [anon_sym_U_SQUOTE] = ACTIONS(2022),
    [anon_sym_u8_SQUOTE] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(2022),
    [anon_sym_L_DQUOTE] = ACTIONS(2022),
    [anon_sym_u_DQUOTE] = ACTIONS(2022),
    [anon_sym_U_DQUOTE] = ACTIONS(2022),
    [anon_sym_u8_DQUOTE] = ACTIONS(2022),
    [anon_sym_DQUOTE] = ACTIONS(2022),
    [sym_true] = ACTIONS(2020),
    [sym_false] = ACTIONS(2020),
    [anon_sym_NULL] = ACTIONS(2020),
    [anon_sym_nullptr] = ACTIONS(2020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2020),
    [anon_sym_decltype] = ACTIONS(2020),
    [sym_virtual] = ACTIONS(2020),
    [anon_sym_explicit] = ACTIONS(2020),
    [anon_sym_typename] = ACTIONS(2020),
    [anon_sym_template] = ACTIONS(2020),
    [anon_sym_operator] = ACTIONS(2020),
    [anon_sym_try] = ACTIONS(2020),
    [anon_sym_delete] = ACTIONS(2020),
    [anon_sym_throw] = ACTIONS(2020),
    [anon_sym_namespace] = ACTIONS(2020),
    [anon_sym_using] = ACTIONS(2020),
    [anon_sym_static_assert] = ACTIONS(2020),
    [anon_sym_concept] = ACTIONS(2020),
    [anon_sym_co_return] = ACTIONS(2020),
    [anon_sym_co_yield] = ACTIONS(2020),
    [anon_sym_R_DQUOTE] = ACTIONS(2022),
    [anon_sym_LR_DQUOTE] = ACTIONS(2022),
    [anon_sym_uR_DQUOTE] = ACTIONS(2022),
    [anon_sym_UR_DQUOTE] = ACTIONS(2022),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2022),
    [anon_sym_co_await] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(2020),
    [anon_sym_requires] = ACTIONS(2020),
    [sym_this] = ACTIONS(2020),
    [anon_sym___launch_bounds__] = ACTIONS(2020),
  },
  [410] = {
    [sym_identifier] = ACTIONS(1968),
    [aux_sym_preproc_include_token1] = ACTIONS(1968),
    [aux_sym_preproc_def_token1] = ACTIONS(1968),
    [aux_sym_preproc_if_token1] = ACTIONS(1968),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1968),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1968),
    [sym_preproc_directive] = ACTIONS(1968),
    [anon_sym_LPAREN2] = ACTIONS(1970),
    [anon_sym_BANG] = ACTIONS(1970),
    [anon_sym_TILDE] = ACTIONS(1970),
    [anon_sym_DASH] = ACTIONS(1968),
    [anon_sym_PLUS] = ACTIONS(1968),
    [anon_sym_STAR] = ACTIONS(1970),
    [anon_sym_AMP_AMP] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(1968),
    [anon_sym_SEMI] = ACTIONS(1970),
    [anon_sym___extension__] = ACTIONS(1968),
    [anon_sym_typedef] = ACTIONS(1968),
    [anon_sym___device__] = ACTIONS(1968),
    [anon_sym___host__] = ACTIONS(1968),
    [anon_sym___global__] = ACTIONS(1968),
    [anon_sym___forceinline__] = ACTIONS(1968),
    [anon_sym___noinline__] = ACTIONS(1968),
    [anon_sym_extern] = ACTIONS(1968),
    [anon_sym___attribute__] = ACTIONS(1968),
    [anon_sym_COLON_COLON] = ACTIONS(1970),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1970),
    [anon_sym___declspec] = ACTIONS(1968),
    [anon_sym___based] = ACTIONS(1968),
    [anon_sym___cdecl] = ACTIONS(1968),
    [anon_sym___clrcall] = ACTIONS(1968),
    [anon_sym___stdcall] = ACTIONS(1968),
    [anon_sym___fastcall] = ACTIONS(1968),
    [anon_sym___thiscall] = ACTIONS(1968),
    [anon_sym___vectorcall] = ACTIONS(1968),
    [anon_sym_LBRACE] = ACTIONS(1970),
    [anon_sym_RBRACE] = ACTIONS(1970),
    [anon_sym_signed] = ACTIONS(1968),
    [anon_sym_unsigned] = ACTIONS(1968),
    [anon_sym_long] = ACTIONS(1968),
    [anon_sym_short] = ACTIONS(1968),
    [anon_sym_LBRACK] = ACTIONS(1968),
    [anon_sym_static] = ACTIONS(1968),
    [anon_sym_register] = ACTIONS(1968),
    [anon_sym_inline] = ACTIONS(1968),
    [anon_sym___inline] = ACTIONS(1968),
    [anon_sym___inline__] = ACTIONS(1968),
    [anon_sym___forceinline] = ACTIONS(1968),
    [anon_sym_thread_local] = ACTIONS(1968),
    [anon_sym___thread] = ACTIONS(1968),
    [anon_sym_const] = ACTIONS(1968),
    [anon_sym_constexpr] = ACTIONS(1968),
    [anon_sym_volatile] = ACTIONS(1968),
    [anon_sym_restrict] = ACTIONS(1968),
    [anon_sym___restrict__] = ACTIONS(1968),
    [anon_sym__Atomic] = ACTIONS(1968),
    [anon_sym__Noreturn] = ACTIONS(1968),
    [anon_sym_noreturn] = ACTIONS(1968),
    [anon_sym_mutable] = ACTIONS(1968),
    [anon_sym_constinit] = ACTIONS(1968),
    [anon_sym_consteval] = ACTIONS(1968),
    [anon_sym___shared__] = ACTIONS(1968),
    [anon_sym___local__] = ACTIONS(1968),
    [anon_sym___constant__] = ACTIONS(1968),
    [anon_sym___managed__] = ACTIONS(1968),
    [anon_sym___grid_constant__] = ACTIONS(1968),
    [anon_sym_alignas] = ACTIONS(1968),
    [anon_sym__Alignas] = ACTIONS(1968),
    [sym_primitive_type] = ACTIONS(1968),
    [anon_sym_enum] = ACTIONS(1968),
    [anon_sym_class] = ACTIONS(1968),
    [anon_sym_struct] = ACTIONS(1968),
    [anon_sym_union] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_else] = ACTIONS(1968),
    [anon_sym_switch] = ACTIONS(1968),
    [anon_sym_case] = ACTIONS(1968),
    [anon_sym_default] = ACTIONS(1968),
    [anon_sym_while] = ACTIONS(1968),
    [anon_sym_do] = ACTIONS(1968),
    [anon_sym_for] = ACTIONS(1968),
    [anon_sym_return] = ACTIONS(1968),
    [anon_sym_break] = ACTIONS(1968),
    [anon_sym_continue] = ACTIONS(1968),
    [anon_sym_goto] = ACTIONS(1968),
    [anon_sym___try] = ACTIONS(1968),
    [anon_sym___leave] = ACTIONS(1968),
    [anon_sym_not] = ACTIONS(1968),
    [anon_sym_compl] = ACTIONS(1968),
    [anon_sym_DASH_DASH] = ACTIONS(1970),
    [anon_sym_PLUS_PLUS] = ACTIONS(1970),
    [anon_sym_sizeof] = ACTIONS(1968),
    [anon_sym___alignof__] = ACTIONS(1968),
    [anon_sym___alignof] = ACTIONS(1968),
    [anon_sym__alignof] = ACTIONS(1968),
    [anon_sym_alignof] = ACTIONS(1968),
    [anon_sym__Alignof] = ACTIONS(1968),
    [anon_sym_offsetof] = ACTIONS(1968),
    [anon_sym__Generic] = ACTIONS(1968),
    [anon_sym_asm] = ACTIONS(1968),
    [anon_sym___asm__] = ACTIONS(1968),
    [sym_number_literal] = ACTIONS(1970),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1970),
    [anon_sym_u_DQUOTE] = ACTIONS(1970),
    [anon_sym_U_DQUOTE] = ACTIONS(1970),
    [anon_sym_u8_DQUOTE] = ACTIONS(1970),
    [anon_sym_DQUOTE] = ACTIONS(1970),
    [sym_true] = ACTIONS(1968),
    [sym_false] = ACTIONS(1968),
    [anon_sym_NULL] = ACTIONS(1968),
    [anon_sym_nullptr] = ACTIONS(1968),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1968),
    [anon_sym_decltype] = ACTIONS(1968),
    [sym_virtual] = ACTIONS(1968),
    [anon_sym_explicit] = ACTIONS(1968),
    [anon_sym_typename] = ACTIONS(1968),
    [anon_sym_template] = ACTIONS(1968),
    [anon_sym_operator] = ACTIONS(1968),
    [anon_sym_try] = ACTIONS(1968),
    [anon_sym_delete] = ACTIONS(1968),
    [anon_sym_throw] = ACTIONS(1968),
    [anon_sym_namespace] = ACTIONS(1968),
    [anon_sym_using] = ACTIONS(1968),
    [anon_sym_static_assert] = ACTIONS(1968),
    [anon_sym_concept] = ACTIONS(1968),
    [anon_sym_co_return] = ACTIONS(1968),
    [anon_sym_co_yield] = ACTIONS(1968),
    [anon_sym_R_DQUOTE] = ACTIONS(1970),
    [anon_sym_LR_DQUOTE] = ACTIONS(1970),
    [anon_sym_uR_DQUOTE] = ACTIONS(1970),
    [anon_sym_UR_DQUOTE] = ACTIONS(1970),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1970),
    [anon_sym_co_await] = ACTIONS(1968),
    [anon_sym_new] = ACTIONS(1968),
    [anon_sym_requires] = ACTIONS(1968),
    [sym_this] = ACTIONS(1968),
    [anon_sym___launch_bounds__] = ACTIONS(1968),
  },
  [411] = {
    [sym_identifier] = ACTIONS(1964),
    [aux_sym_preproc_include_token1] = ACTIONS(1964),
    [aux_sym_preproc_def_token1] = ACTIONS(1964),
    [aux_sym_preproc_if_token1] = ACTIONS(1964),
    [aux_sym_preproc_if_token2] = ACTIONS(1964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1964),
    [sym_preproc_directive] = ACTIONS(1964),
    [anon_sym_LPAREN2] = ACTIONS(1966),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [anon_sym_DASH] = ACTIONS(1964),
    [anon_sym_PLUS] = ACTIONS(1964),
    [anon_sym_STAR] = ACTIONS(1966),
    [anon_sym_AMP_AMP] = ACTIONS(1966),
    [anon_sym_AMP] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym___extension__] = ACTIONS(1964),
    [anon_sym_typedef] = ACTIONS(1964),
    [anon_sym___device__] = ACTIONS(1964),
    [anon_sym___host__] = ACTIONS(1964),
    [anon_sym___global__] = ACTIONS(1964),
    [anon_sym___forceinline__] = ACTIONS(1964),
    [anon_sym___noinline__] = ACTIONS(1964),
    [anon_sym_extern] = ACTIONS(1964),
    [anon_sym___attribute__] = ACTIONS(1964),
    [anon_sym_COLON_COLON] = ACTIONS(1966),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1966),
    [anon_sym___declspec] = ACTIONS(1964),
    [anon_sym___based] = ACTIONS(1964),
    [anon_sym___cdecl] = ACTIONS(1964),
    [anon_sym___clrcall] = ACTIONS(1964),
    [anon_sym___stdcall] = ACTIONS(1964),
    [anon_sym___fastcall] = ACTIONS(1964),
    [anon_sym___thiscall] = ACTIONS(1964),
    [anon_sym___vectorcall] = ACTIONS(1964),
    [anon_sym_LBRACE] = ACTIONS(1966),
    [anon_sym_signed] = ACTIONS(1964),
    [anon_sym_unsigned] = ACTIONS(1964),
    [anon_sym_long] = ACTIONS(1964),
    [anon_sym_short] = ACTIONS(1964),
    [anon_sym_LBRACK] = ACTIONS(1964),
    [anon_sym_static] = ACTIONS(1964),
    [anon_sym_register] = ACTIONS(1964),
    [anon_sym_inline] = ACTIONS(1964),
    [anon_sym___inline] = ACTIONS(1964),
    [anon_sym___inline__] = ACTIONS(1964),
    [anon_sym___forceinline] = ACTIONS(1964),
    [anon_sym_thread_local] = ACTIONS(1964),
    [anon_sym___thread] = ACTIONS(1964),
    [anon_sym_const] = ACTIONS(1964),
    [anon_sym_constexpr] = ACTIONS(1964),
    [anon_sym_volatile] = ACTIONS(1964),
    [anon_sym_restrict] = ACTIONS(1964),
    [anon_sym___restrict__] = ACTIONS(1964),
    [anon_sym__Atomic] = ACTIONS(1964),
    [anon_sym__Noreturn] = ACTIONS(1964),
    [anon_sym_noreturn] = ACTIONS(1964),
    [anon_sym_mutable] = ACTIONS(1964),
    [anon_sym_constinit] = ACTIONS(1964),
    [anon_sym_consteval] = ACTIONS(1964),
    [anon_sym___shared__] = ACTIONS(1964),
    [anon_sym___local__] = ACTIONS(1964),
    [anon_sym___constant__] = ACTIONS(1964),
    [anon_sym___managed__] = ACTIONS(1964),
    [anon_sym___grid_constant__] = ACTIONS(1964),
    [anon_sym_alignas] = ACTIONS(1964),
    [anon_sym__Alignas] = ACTIONS(1964),
    [sym_primitive_type] = ACTIONS(1964),
    [anon_sym_enum] = ACTIONS(1964),
    [anon_sym_class] = ACTIONS(1964),
    [anon_sym_struct] = ACTIONS(1964),
    [anon_sym_union] = ACTIONS(1964),
    [anon_sym_if] = ACTIONS(1964),
    [anon_sym_else] = ACTIONS(1964),
    [anon_sym_switch] = ACTIONS(1964),
    [anon_sym_case] = ACTIONS(1964),
    [anon_sym_default] = ACTIONS(1964),
    [anon_sym_while] = ACTIONS(1964),
    [anon_sym_do] = ACTIONS(1964),
    [anon_sym_for] = ACTIONS(1964),
    [anon_sym_return] = ACTIONS(1964),
    [anon_sym_break] = ACTIONS(1964),
    [anon_sym_continue] = ACTIONS(1964),
    [anon_sym_goto] = ACTIONS(1964),
    [anon_sym___try] = ACTIONS(1964),
    [anon_sym___leave] = ACTIONS(1964),
    [anon_sym_not] = ACTIONS(1964),
    [anon_sym_compl] = ACTIONS(1964),
    [anon_sym_DASH_DASH] = ACTIONS(1966),
    [anon_sym_PLUS_PLUS] = ACTIONS(1966),
    [anon_sym_sizeof] = ACTIONS(1964),
    [anon_sym___alignof__] = ACTIONS(1964),
    [anon_sym___alignof] = ACTIONS(1964),
    [anon_sym__alignof] = ACTIONS(1964),
    [anon_sym_alignof] = ACTIONS(1964),
    [anon_sym__Alignof] = ACTIONS(1964),
    [anon_sym_offsetof] = ACTIONS(1964),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1964),
    [anon_sym___asm__] = ACTIONS(1964),
    [sym_number_literal] = ACTIONS(1966),
    [anon_sym_L_SQUOTE] = ACTIONS(1966),
    [anon_sym_u_SQUOTE] = ACTIONS(1966),
    [anon_sym_U_SQUOTE] = ACTIONS(1966),
    [anon_sym_u8_SQUOTE] = ACTIONS(1966),
    [anon_sym_SQUOTE] = ACTIONS(1966),
    [anon_sym_L_DQUOTE] = ACTIONS(1966),
    [anon_sym_u_DQUOTE] = ACTIONS(1966),
    [anon_sym_U_DQUOTE] = ACTIONS(1966),
    [anon_sym_u8_DQUOTE] = ACTIONS(1966),
    [anon_sym_DQUOTE] = ACTIONS(1966),
    [sym_true] = ACTIONS(1964),
    [sym_false] = ACTIONS(1964),
    [anon_sym_NULL] = ACTIONS(1964),
    [anon_sym_nullptr] = ACTIONS(1964),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1964),
    [anon_sym_decltype] = ACTIONS(1964),
    [sym_virtual] = ACTIONS(1964),
    [anon_sym_explicit] = ACTIONS(1964),
    [anon_sym_typename] = ACTIONS(1964),
    [anon_sym_template] = ACTIONS(1964),
    [anon_sym_operator] = ACTIONS(1964),
    [anon_sym_try] = ACTIONS(1964),
    [anon_sym_delete] = ACTIONS(1964),
    [anon_sym_throw] = ACTIONS(1964),
    [anon_sym_namespace] = ACTIONS(1964),
    [anon_sym_using] = ACTIONS(1964),
    [anon_sym_static_assert] = ACTIONS(1964),
    [anon_sym_concept] = ACTIONS(1964),
    [anon_sym_co_return] = ACTIONS(1964),
    [anon_sym_co_yield] = ACTIONS(1964),
    [anon_sym_R_DQUOTE] = ACTIONS(1966),
    [anon_sym_LR_DQUOTE] = ACTIONS(1966),
    [anon_sym_uR_DQUOTE] = ACTIONS(1966),
    [anon_sym_UR_DQUOTE] = ACTIONS(1966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1966),
    [anon_sym_co_await] = ACTIONS(1964),
    [anon_sym_new] = ACTIONS(1964),
    [anon_sym_requires] = ACTIONS(1964),
    [sym_this] = ACTIONS(1964),
    [anon_sym___launch_bounds__] = ACTIONS(1964),
  },
  [412] = {
    [sym_identifier] = ACTIONS(1964),
    [aux_sym_preproc_include_token1] = ACTIONS(1964),
    [aux_sym_preproc_def_token1] = ACTIONS(1964),
    [aux_sym_preproc_if_token1] = ACTIONS(1964),
    [aux_sym_preproc_if_token2] = ACTIONS(1964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1964),
    [sym_preproc_directive] = ACTIONS(1964),
    [anon_sym_LPAREN2] = ACTIONS(1966),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [anon_sym_DASH] = ACTIONS(1964),
    [anon_sym_PLUS] = ACTIONS(1964),
    [anon_sym_STAR] = ACTIONS(1966),
    [anon_sym_AMP_AMP] = ACTIONS(1966),
    [anon_sym_AMP] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym___extension__] = ACTIONS(1964),
    [anon_sym_typedef] = ACTIONS(1964),
    [anon_sym___device__] = ACTIONS(1964),
    [anon_sym___host__] = ACTIONS(1964),
    [anon_sym___global__] = ACTIONS(1964),
    [anon_sym___forceinline__] = ACTIONS(1964),
    [anon_sym___noinline__] = ACTIONS(1964),
    [anon_sym_extern] = ACTIONS(1964),
    [anon_sym___attribute__] = ACTIONS(1964),
    [anon_sym_COLON_COLON] = ACTIONS(1966),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1966),
    [anon_sym___declspec] = ACTIONS(1964),
    [anon_sym___based] = ACTIONS(1964),
    [anon_sym___cdecl] = ACTIONS(1964),
    [anon_sym___clrcall] = ACTIONS(1964),
    [anon_sym___stdcall] = ACTIONS(1964),
    [anon_sym___fastcall] = ACTIONS(1964),
    [anon_sym___thiscall] = ACTIONS(1964),
    [anon_sym___vectorcall] = ACTIONS(1964),
    [anon_sym_LBRACE] = ACTIONS(1966),
    [anon_sym_signed] = ACTIONS(1964),
    [anon_sym_unsigned] = ACTIONS(1964),
    [anon_sym_long] = ACTIONS(1964),
    [anon_sym_short] = ACTIONS(1964),
    [anon_sym_LBRACK] = ACTIONS(1964),
    [anon_sym_static] = ACTIONS(1964),
    [anon_sym_register] = ACTIONS(1964),
    [anon_sym_inline] = ACTIONS(1964),
    [anon_sym___inline] = ACTIONS(1964),
    [anon_sym___inline__] = ACTIONS(1964),
    [anon_sym___forceinline] = ACTIONS(1964),
    [anon_sym_thread_local] = ACTIONS(1964),
    [anon_sym___thread] = ACTIONS(1964),
    [anon_sym_const] = ACTIONS(1964),
    [anon_sym_constexpr] = ACTIONS(1964),
    [anon_sym_volatile] = ACTIONS(1964),
    [anon_sym_restrict] = ACTIONS(1964),
    [anon_sym___restrict__] = ACTIONS(1964),
    [anon_sym__Atomic] = ACTIONS(1964),
    [anon_sym__Noreturn] = ACTIONS(1964),
    [anon_sym_noreturn] = ACTIONS(1964),
    [anon_sym_mutable] = ACTIONS(1964),
    [anon_sym_constinit] = ACTIONS(1964),
    [anon_sym_consteval] = ACTIONS(1964),
    [anon_sym___shared__] = ACTIONS(1964),
    [anon_sym___local__] = ACTIONS(1964),
    [anon_sym___constant__] = ACTIONS(1964),
    [anon_sym___managed__] = ACTIONS(1964),
    [anon_sym___grid_constant__] = ACTIONS(1964),
    [anon_sym_alignas] = ACTIONS(1964),
    [anon_sym__Alignas] = ACTIONS(1964),
    [sym_primitive_type] = ACTIONS(1964),
    [anon_sym_enum] = ACTIONS(1964),
    [anon_sym_class] = ACTIONS(1964),
    [anon_sym_struct] = ACTIONS(1964),
    [anon_sym_union] = ACTIONS(1964),
    [anon_sym_if] = ACTIONS(1964),
    [anon_sym_else] = ACTIONS(1964),
    [anon_sym_switch] = ACTIONS(1964),
    [anon_sym_case] = ACTIONS(1964),
    [anon_sym_default] = ACTIONS(1964),
    [anon_sym_while] = ACTIONS(1964),
    [anon_sym_do] = ACTIONS(1964),
    [anon_sym_for] = ACTIONS(1964),
    [anon_sym_return] = ACTIONS(1964),
    [anon_sym_break] = ACTIONS(1964),
    [anon_sym_continue] = ACTIONS(1964),
    [anon_sym_goto] = ACTIONS(1964),
    [anon_sym___try] = ACTIONS(1964),
    [anon_sym___leave] = ACTIONS(1964),
    [anon_sym_not] = ACTIONS(1964),
    [anon_sym_compl] = ACTIONS(1964),
    [anon_sym_DASH_DASH] = ACTIONS(1966),
    [anon_sym_PLUS_PLUS] = ACTIONS(1966),
    [anon_sym_sizeof] = ACTIONS(1964),
    [anon_sym___alignof__] = ACTIONS(1964),
    [anon_sym___alignof] = ACTIONS(1964),
    [anon_sym__alignof] = ACTIONS(1964),
    [anon_sym_alignof] = ACTIONS(1964),
    [anon_sym__Alignof] = ACTIONS(1964),
    [anon_sym_offsetof] = ACTIONS(1964),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1964),
    [anon_sym___asm__] = ACTIONS(1964),
    [sym_number_literal] = ACTIONS(1966),
    [anon_sym_L_SQUOTE] = ACTIONS(1966),
    [anon_sym_u_SQUOTE] = ACTIONS(1966),
    [anon_sym_U_SQUOTE] = ACTIONS(1966),
    [anon_sym_u8_SQUOTE] = ACTIONS(1966),
    [anon_sym_SQUOTE] = ACTIONS(1966),
    [anon_sym_L_DQUOTE] = ACTIONS(1966),
    [anon_sym_u_DQUOTE] = ACTIONS(1966),
    [anon_sym_U_DQUOTE] = ACTIONS(1966),
    [anon_sym_u8_DQUOTE] = ACTIONS(1966),
    [anon_sym_DQUOTE] = ACTIONS(1966),
    [sym_true] = ACTIONS(1964),
    [sym_false] = ACTIONS(1964),
    [anon_sym_NULL] = ACTIONS(1964),
    [anon_sym_nullptr] = ACTIONS(1964),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1964),
    [anon_sym_decltype] = ACTIONS(1964),
    [sym_virtual] = ACTIONS(1964),
    [anon_sym_explicit] = ACTIONS(1964),
    [anon_sym_typename] = ACTIONS(1964),
    [anon_sym_template] = ACTIONS(1964),
    [anon_sym_operator] = ACTIONS(1964),
    [anon_sym_try] = ACTIONS(1964),
    [anon_sym_delete] = ACTIONS(1964),
    [anon_sym_throw] = ACTIONS(1964),
    [anon_sym_namespace] = ACTIONS(1964),
    [anon_sym_using] = ACTIONS(1964),
    [anon_sym_static_assert] = ACTIONS(1964),
    [anon_sym_concept] = ACTIONS(1964),
    [anon_sym_co_return] = ACTIONS(1964),
    [anon_sym_co_yield] = ACTIONS(1964),
    [anon_sym_R_DQUOTE] = ACTIONS(1966),
    [anon_sym_LR_DQUOTE] = ACTIONS(1966),
    [anon_sym_uR_DQUOTE] = ACTIONS(1966),
    [anon_sym_UR_DQUOTE] = ACTIONS(1966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1966),
    [anon_sym_co_await] = ACTIONS(1964),
    [anon_sym_new] = ACTIONS(1964),
    [anon_sym_requires] = ACTIONS(1964),
    [sym_this] = ACTIONS(1964),
    [anon_sym___launch_bounds__] = ACTIONS(1964),
  },
  [413] = {
    [ts_builtin_sym_end] = ACTIONS(2018),
    [sym_identifier] = ACTIONS(2016),
    [aux_sym_preproc_include_token1] = ACTIONS(2016),
    [aux_sym_preproc_def_token1] = ACTIONS(2016),
    [aux_sym_preproc_if_token1] = ACTIONS(2016),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2016),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2016),
    [sym_preproc_directive] = ACTIONS(2016),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(2018),
    [anon_sym_TILDE] = ACTIONS(2018),
    [anon_sym_DASH] = ACTIONS(2016),
    [anon_sym_PLUS] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(2018),
    [anon_sym_AMP_AMP] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(2016),
    [anon_sym_SEMI] = ACTIONS(2018),
    [anon_sym___extension__] = ACTIONS(2016),
    [anon_sym_typedef] = ACTIONS(2016),
    [anon_sym___device__] = ACTIONS(2016),
    [anon_sym___host__] = ACTIONS(2016),
    [anon_sym___global__] = ACTIONS(2016),
    [anon_sym___forceinline__] = ACTIONS(2016),
    [anon_sym___noinline__] = ACTIONS(2016),
    [anon_sym_extern] = ACTIONS(2016),
    [anon_sym___attribute__] = ACTIONS(2016),
    [anon_sym_COLON_COLON] = ACTIONS(2018),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2018),
    [anon_sym___declspec] = ACTIONS(2016),
    [anon_sym___based] = ACTIONS(2016),
    [anon_sym___cdecl] = ACTIONS(2016),
    [anon_sym___clrcall] = ACTIONS(2016),
    [anon_sym___stdcall] = ACTIONS(2016),
    [anon_sym___fastcall] = ACTIONS(2016),
    [anon_sym___thiscall] = ACTIONS(2016),
    [anon_sym___vectorcall] = ACTIONS(2016),
    [anon_sym_LBRACE] = ACTIONS(2018),
    [anon_sym_signed] = ACTIONS(2016),
    [anon_sym_unsigned] = ACTIONS(2016),
    [anon_sym_long] = ACTIONS(2016),
    [anon_sym_short] = ACTIONS(2016),
    [anon_sym_LBRACK] = ACTIONS(2016),
    [anon_sym_static] = ACTIONS(2016),
    [anon_sym_register] = ACTIONS(2016),
    [anon_sym_inline] = ACTIONS(2016),
    [anon_sym___inline] = ACTIONS(2016),
    [anon_sym___inline__] = ACTIONS(2016),
    [anon_sym___forceinline] = ACTIONS(2016),
    [anon_sym_thread_local] = ACTIONS(2016),
    [anon_sym___thread] = ACTIONS(2016),
    [anon_sym_const] = ACTIONS(2016),
    [anon_sym_constexpr] = ACTIONS(2016),
    [anon_sym_volatile] = ACTIONS(2016),
    [anon_sym_restrict] = ACTIONS(2016),
    [anon_sym___restrict__] = ACTIONS(2016),
    [anon_sym__Atomic] = ACTIONS(2016),
    [anon_sym__Noreturn] = ACTIONS(2016),
    [anon_sym_noreturn] = ACTIONS(2016),
    [anon_sym_mutable] = ACTIONS(2016),
    [anon_sym_constinit] = ACTIONS(2016),
    [anon_sym_consteval] = ACTIONS(2016),
    [anon_sym___shared__] = ACTIONS(2016),
    [anon_sym___local__] = ACTIONS(2016),
    [anon_sym___constant__] = ACTIONS(2016),
    [anon_sym___managed__] = ACTIONS(2016),
    [anon_sym___grid_constant__] = ACTIONS(2016),
    [anon_sym_alignas] = ACTIONS(2016),
    [anon_sym__Alignas] = ACTIONS(2016),
    [sym_primitive_type] = ACTIONS(2016),
    [anon_sym_enum] = ACTIONS(2016),
    [anon_sym_class] = ACTIONS(2016),
    [anon_sym_struct] = ACTIONS(2016),
    [anon_sym_union] = ACTIONS(2016),
    [anon_sym_if] = ACTIONS(2016),
    [anon_sym_else] = ACTIONS(2016),
    [anon_sym_switch] = ACTIONS(2016),
    [anon_sym_case] = ACTIONS(2016),
    [anon_sym_default] = ACTIONS(2016),
    [anon_sym_while] = ACTIONS(2016),
    [anon_sym_do] = ACTIONS(2016),
    [anon_sym_for] = ACTIONS(2016),
    [anon_sym_return] = ACTIONS(2016),
    [anon_sym_break] = ACTIONS(2016),
    [anon_sym_continue] = ACTIONS(2016),
    [anon_sym_goto] = ACTIONS(2016),
    [anon_sym___try] = ACTIONS(2016),
    [anon_sym___leave] = ACTIONS(2016),
    [anon_sym_not] = ACTIONS(2016),
    [anon_sym_compl] = ACTIONS(2016),
    [anon_sym_DASH_DASH] = ACTIONS(2018),
    [anon_sym_PLUS_PLUS] = ACTIONS(2018),
    [anon_sym_sizeof] = ACTIONS(2016),
    [anon_sym___alignof__] = ACTIONS(2016),
    [anon_sym___alignof] = ACTIONS(2016),
    [anon_sym__alignof] = ACTIONS(2016),
    [anon_sym_alignof] = ACTIONS(2016),
    [anon_sym__Alignof] = ACTIONS(2016),
    [anon_sym_offsetof] = ACTIONS(2016),
    [anon_sym__Generic] = ACTIONS(2016),
    [anon_sym_asm] = ACTIONS(2016),
    [anon_sym___asm__] = ACTIONS(2016),
    [sym_number_literal] = ACTIONS(2018),
    [anon_sym_L_SQUOTE] = ACTIONS(2018),
    [anon_sym_u_SQUOTE] = ACTIONS(2018),
    [anon_sym_U_SQUOTE] = ACTIONS(2018),
    [anon_sym_u8_SQUOTE] = ACTIONS(2018),
    [anon_sym_SQUOTE] = ACTIONS(2018),
    [anon_sym_L_DQUOTE] = ACTIONS(2018),
    [anon_sym_u_DQUOTE] = ACTIONS(2018),
    [anon_sym_U_DQUOTE] = ACTIONS(2018),
    [anon_sym_u8_DQUOTE] = ACTIONS(2018),
    [anon_sym_DQUOTE] = ACTIONS(2018),
    [sym_true] = ACTIONS(2016),
    [sym_false] = ACTIONS(2016),
    [anon_sym_NULL] = ACTIONS(2016),
    [anon_sym_nullptr] = ACTIONS(2016),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2016),
    [anon_sym_decltype] = ACTIONS(2016),
    [sym_virtual] = ACTIONS(2016),
    [anon_sym_explicit] = ACTIONS(2016),
    [anon_sym_typename] = ACTIONS(2016),
    [anon_sym_template] = ACTIONS(2016),
    [anon_sym_operator] = ACTIONS(2016),
    [anon_sym_try] = ACTIONS(2016),
    [anon_sym_delete] = ACTIONS(2016),
    [anon_sym_throw] = ACTIONS(2016),
    [anon_sym_namespace] = ACTIONS(2016),
    [anon_sym_using] = ACTIONS(2016),
    [anon_sym_static_assert] = ACTIONS(2016),
    [anon_sym_concept] = ACTIONS(2016),
    [anon_sym_co_return] = ACTIONS(2016),
    [anon_sym_co_yield] = ACTIONS(2016),
    [anon_sym_R_DQUOTE] = ACTIONS(2018),
    [anon_sym_LR_DQUOTE] = ACTIONS(2018),
    [anon_sym_uR_DQUOTE] = ACTIONS(2018),
    [anon_sym_UR_DQUOTE] = ACTIONS(2018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2018),
    [anon_sym_co_await] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2016),
    [anon_sym_requires] = ACTIONS(2016),
    [sym_this] = ACTIONS(2016),
    [anon_sym___launch_bounds__] = ACTIONS(2016),
  },
  [414] = {
    [ts_builtin_sym_end] = ACTIONS(1986),
    [sym_identifier] = ACTIONS(1984),
    [aux_sym_preproc_include_token1] = ACTIONS(1984),
    [aux_sym_preproc_def_token1] = ACTIONS(1984),
    [aux_sym_preproc_if_token1] = ACTIONS(1984),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1984),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1984),
    [sym_preproc_directive] = ACTIONS(1984),
    [anon_sym_LPAREN2] = ACTIONS(1986),
    [anon_sym_BANG] = ACTIONS(1986),
    [anon_sym_TILDE] = ACTIONS(1986),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_AMP_AMP] = ACTIONS(1986),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_SEMI] = ACTIONS(1986),
    [anon_sym___extension__] = ACTIONS(1984),
    [anon_sym_typedef] = ACTIONS(1984),
    [anon_sym___device__] = ACTIONS(1984),
    [anon_sym___host__] = ACTIONS(1984),
    [anon_sym___global__] = ACTIONS(1984),
    [anon_sym___forceinline__] = ACTIONS(1984),
    [anon_sym___noinline__] = ACTIONS(1984),
    [anon_sym_extern] = ACTIONS(1984),
    [anon_sym___attribute__] = ACTIONS(1984),
    [anon_sym_COLON_COLON] = ACTIONS(1986),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1986),
    [anon_sym___declspec] = ACTIONS(1984),
    [anon_sym___based] = ACTIONS(1984),
    [anon_sym___cdecl] = ACTIONS(1984),
    [anon_sym___clrcall] = ACTIONS(1984),
    [anon_sym___stdcall] = ACTIONS(1984),
    [anon_sym___fastcall] = ACTIONS(1984),
    [anon_sym___thiscall] = ACTIONS(1984),
    [anon_sym___vectorcall] = ACTIONS(1984),
    [anon_sym_LBRACE] = ACTIONS(1986),
    [anon_sym_signed] = ACTIONS(1984),
    [anon_sym_unsigned] = ACTIONS(1984),
    [anon_sym_long] = ACTIONS(1984),
    [anon_sym_short] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_static] = ACTIONS(1984),
    [anon_sym_register] = ACTIONS(1984),
    [anon_sym_inline] = ACTIONS(1984),
    [anon_sym___inline] = ACTIONS(1984),
    [anon_sym___inline__] = ACTIONS(1984),
    [anon_sym___forceinline] = ACTIONS(1984),
    [anon_sym_thread_local] = ACTIONS(1984),
    [anon_sym___thread] = ACTIONS(1984),
    [anon_sym_const] = ACTIONS(1984),
    [anon_sym_constexpr] = ACTIONS(1984),
    [anon_sym_volatile] = ACTIONS(1984),
    [anon_sym_restrict] = ACTIONS(1984),
    [anon_sym___restrict__] = ACTIONS(1984),
    [anon_sym__Atomic] = ACTIONS(1984),
    [anon_sym__Noreturn] = ACTIONS(1984),
    [anon_sym_noreturn] = ACTIONS(1984),
    [anon_sym_mutable] = ACTIONS(1984),
    [anon_sym_constinit] = ACTIONS(1984),
    [anon_sym_consteval] = ACTIONS(1984),
    [anon_sym___shared__] = ACTIONS(1984),
    [anon_sym___local__] = ACTIONS(1984),
    [anon_sym___constant__] = ACTIONS(1984),
    [anon_sym___managed__] = ACTIONS(1984),
    [anon_sym___grid_constant__] = ACTIONS(1984),
    [anon_sym_alignas] = ACTIONS(1984),
    [anon_sym__Alignas] = ACTIONS(1984),
    [sym_primitive_type] = ACTIONS(1984),
    [anon_sym_enum] = ACTIONS(1984),
    [anon_sym_class] = ACTIONS(1984),
    [anon_sym_struct] = ACTIONS(1984),
    [anon_sym_union] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_else] = ACTIONS(1984),
    [anon_sym_switch] = ACTIONS(1984),
    [anon_sym_case] = ACTIONS(1984),
    [anon_sym_default] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1984),
    [anon_sym_do] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_return] = ACTIONS(1984),
    [anon_sym_break] = ACTIONS(1984),
    [anon_sym_continue] = ACTIONS(1984),
    [anon_sym_goto] = ACTIONS(1984),
    [anon_sym___try] = ACTIONS(1984),
    [anon_sym___leave] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_compl] = ACTIONS(1984),
    [anon_sym_DASH_DASH] = ACTIONS(1986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1986),
    [anon_sym_sizeof] = ACTIONS(1984),
    [anon_sym___alignof__] = ACTIONS(1984),
    [anon_sym___alignof] = ACTIONS(1984),
    [anon_sym__alignof] = ACTIONS(1984),
    [anon_sym_alignof] = ACTIONS(1984),
    [anon_sym__Alignof] = ACTIONS(1984),
    [anon_sym_offsetof] = ACTIONS(1984),
    [anon_sym__Generic] = ACTIONS(1984),
    [anon_sym_asm] = ACTIONS(1984),
    [anon_sym___asm__] = ACTIONS(1984),
    [sym_number_literal] = ACTIONS(1986),
    [anon_sym_L_SQUOTE] = ACTIONS(1986),
    [anon_sym_u_SQUOTE] = ACTIONS(1986),
    [anon_sym_U_SQUOTE] = ACTIONS(1986),
    [anon_sym_u8_SQUOTE] = ACTIONS(1986),
    [anon_sym_SQUOTE] = ACTIONS(1986),
    [anon_sym_L_DQUOTE] = ACTIONS(1986),
    [anon_sym_u_DQUOTE] = ACTIONS(1986),
    [anon_sym_U_DQUOTE] = ACTIONS(1986),
    [anon_sym_u8_DQUOTE] = ACTIONS(1986),
    [anon_sym_DQUOTE] = ACTIONS(1986),
    [sym_true] = ACTIONS(1984),
    [sym_false] = ACTIONS(1984),
    [anon_sym_NULL] = ACTIONS(1984),
    [anon_sym_nullptr] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1984),
    [anon_sym_decltype] = ACTIONS(1984),
    [sym_virtual] = ACTIONS(1984),
    [anon_sym_explicit] = ACTIONS(1984),
    [anon_sym_typename] = ACTIONS(1984),
    [anon_sym_template] = ACTIONS(1984),
    [anon_sym_operator] = ACTIONS(1984),
    [anon_sym_try] = ACTIONS(1984),
    [anon_sym_delete] = ACTIONS(1984),
    [anon_sym_throw] = ACTIONS(1984),
    [anon_sym_namespace] = ACTIONS(1984),
    [anon_sym_using] = ACTIONS(1984),
    [anon_sym_static_assert] = ACTIONS(1984),
    [anon_sym_concept] = ACTIONS(1984),
    [anon_sym_co_return] = ACTIONS(1984),
    [anon_sym_co_yield] = ACTIONS(1984),
    [anon_sym_R_DQUOTE] = ACTIONS(1986),
    [anon_sym_LR_DQUOTE] = ACTIONS(1986),
    [anon_sym_uR_DQUOTE] = ACTIONS(1986),
    [anon_sym_UR_DQUOTE] = ACTIONS(1986),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1986),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1984),
    [anon_sym_requires] = ACTIONS(1984),
    [sym_this] = ACTIONS(1984),
    [anon_sym___launch_bounds__] = ACTIONS(1984),
  },
  [415] = {
    [sym_identifier] = ACTIONS(2024),
    [aux_sym_preproc_include_token1] = ACTIONS(2024),
    [aux_sym_preproc_def_token1] = ACTIONS(2024),
    [aux_sym_preproc_if_token1] = ACTIONS(2024),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2024),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2024),
    [sym_preproc_directive] = ACTIONS(2024),
    [anon_sym_LPAREN2] = ACTIONS(2026),
    [anon_sym_BANG] = ACTIONS(2026),
    [anon_sym_TILDE] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2024),
    [anon_sym_PLUS] = ACTIONS(2024),
    [anon_sym_STAR] = ACTIONS(2026),
    [anon_sym_AMP_AMP] = ACTIONS(2026),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_SEMI] = ACTIONS(2026),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_typedef] = ACTIONS(2024),
    [anon_sym___device__] = ACTIONS(2024),
    [anon_sym___host__] = ACTIONS(2024),
    [anon_sym___global__] = ACTIONS(2024),
    [anon_sym___forceinline__] = ACTIONS(2024),
    [anon_sym___noinline__] = ACTIONS(2024),
    [anon_sym_extern] = ACTIONS(2024),
    [anon_sym___attribute__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(2026),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2026),
    [anon_sym___declspec] = ACTIONS(2024),
    [anon_sym___based] = ACTIONS(2024),
    [anon_sym___cdecl] = ACTIONS(2024),
    [anon_sym___clrcall] = ACTIONS(2024),
    [anon_sym___stdcall] = ACTIONS(2024),
    [anon_sym___fastcall] = ACTIONS(2024),
    [anon_sym___thiscall] = ACTIONS(2024),
    [anon_sym___vectorcall] = ACTIONS(2024),
    [anon_sym_LBRACE] = ACTIONS(2026),
    [anon_sym_RBRACE] = ACTIONS(2026),
    [anon_sym_signed] = ACTIONS(2024),
    [anon_sym_unsigned] = ACTIONS(2024),
    [anon_sym_long] = ACTIONS(2024),
    [anon_sym_short] = ACTIONS(2024),
    [anon_sym_LBRACK] = ACTIONS(2024),
    [anon_sym_static] = ACTIONS(2024),
    [anon_sym_register] = ACTIONS(2024),
    [anon_sym_inline] = ACTIONS(2024),
    [anon_sym___inline] = ACTIONS(2024),
    [anon_sym___inline__] = ACTIONS(2024),
    [anon_sym___forceinline] = ACTIONS(2024),
    [anon_sym_thread_local] = ACTIONS(2024),
    [anon_sym___thread] = ACTIONS(2024),
    [anon_sym_const] = ACTIONS(2024),
    [anon_sym_constexpr] = ACTIONS(2024),
    [anon_sym_volatile] = ACTIONS(2024),
    [anon_sym_restrict] = ACTIONS(2024),
    [anon_sym___restrict__] = ACTIONS(2024),
    [anon_sym__Atomic] = ACTIONS(2024),
    [anon_sym__Noreturn] = ACTIONS(2024),
    [anon_sym_noreturn] = ACTIONS(2024),
    [anon_sym_mutable] = ACTIONS(2024),
    [anon_sym_constinit] = ACTIONS(2024),
    [anon_sym_consteval] = ACTIONS(2024),
    [anon_sym___shared__] = ACTIONS(2024),
    [anon_sym___local__] = ACTIONS(2024),
    [anon_sym___constant__] = ACTIONS(2024),
    [anon_sym___managed__] = ACTIONS(2024),
    [anon_sym___grid_constant__] = ACTIONS(2024),
    [anon_sym_alignas] = ACTIONS(2024),
    [anon_sym__Alignas] = ACTIONS(2024),
    [sym_primitive_type] = ACTIONS(2024),
    [anon_sym_enum] = ACTIONS(2024),
    [anon_sym_class] = ACTIONS(2024),
    [anon_sym_struct] = ACTIONS(2024),
    [anon_sym_union] = ACTIONS(2024),
    [anon_sym_if] = ACTIONS(2024),
    [anon_sym_else] = ACTIONS(2024),
    [anon_sym_switch] = ACTIONS(2024),
    [anon_sym_case] = ACTIONS(2024),
    [anon_sym_default] = ACTIONS(2024),
    [anon_sym_while] = ACTIONS(2024),
    [anon_sym_do] = ACTIONS(2024),
    [anon_sym_for] = ACTIONS(2024),
    [anon_sym_return] = ACTIONS(2024),
    [anon_sym_break] = ACTIONS(2024),
    [anon_sym_continue] = ACTIONS(2024),
    [anon_sym_goto] = ACTIONS(2024),
    [anon_sym___try] = ACTIONS(2024),
    [anon_sym___leave] = ACTIONS(2024),
    [anon_sym_not] = ACTIONS(2024),
    [anon_sym_compl] = ACTIONS(2024),
    [anon_sym_DASH_DASH] = ACTIONS(2026),
    [anon_sym_PLUS_PLUS] = ACTIONS(2026),
    [anon_sym_sizeof] = ACTIONS(2024),
    [anon_sym___alignof__] = ACTIONS(2024),
    [anon_sym___alignof] = ACTIONS(2024),
    [anon_sym__alignof] = ACTIONS(2024),
    [anon_sym_alignof] = ACTIONS(2024),
    [anon_sym__Alignof] = ACTIONS(2024),
    [anon_sym_offsetof] = ACTIONS(2024),
    [anon_sym__Generic] = ACTIONS(2024),
    [anon_sym_asm] = ACTIONS(2024),
    [anon_sym___asm__] = ACTIONS(2024),
    [sym_number_literal] = ACTIONS(2026),
    [anon_sym_L_SQUOTE] = ACTIONS(2026),
    [anon_sym_u_SQUOTE] = ACTIONS(2026),
    [anon_sym_U_SQUOTE] = ACTIONS(2026),
    [anon_sym_u8_SQUOTE] = ACTIONS(2026),
    [anon_sym_SQUOTE] = ACTIONS(2026),
    [anon_sym_L_DQUOTE] = ACTIONS(2026),
    [anon_sym_u_DQUOTE] = ACTIONS(2026),
    [anon_sym_U_DQUOTE] = ACTIONS(2026),
    [anon_sym_u8_DQUOTE] = ACTIONS(2026),
    [anon_sym_DQUOTE] = ACTIONS(2026),
    [sym_true] = ACTIONS(2024),
    [sym_false] = ACTIONS(2024),
    [anon_sym_NULL] = ACTIONS(2024),
    [anon_sym_nullptr] = ACTIONS(2024),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2024),
    [anon_sym_decltype] = ACTIONS(2024),
    [sym_virtual] = ACTIONS(2024),
    [anon_sym_explicit] = ACTIONS(2024),
    [anon_sym_typename] = ACTIONS(2024),
    [anon_sym_template] = ACTIONS(2024),
    [anon_sym_operator] = ACTIONS(2024),
    [anon_sym_try] = ACTIONS(2024),
    [anon_sym_delete] = ACTIONS(2024),
    [anon_sym_throw] = ACTIONS(2024),
    [anon_sym_namespace] = ACTIONS(2024),
    [anon_sym_using] = ACTIONS(2024),
    [anon_sym_static_assert] = ACTIONS(2024),
    [anon_sym_concept] = ACTIONS(2024),
    [anon_sym_co_return] = ACTIONS(2024),
    [anon_sym_co_yield] = ACTIONS(2024),
    [anon_sym_R_DQUOTE] = ACTIONS(2026),
    [anon_sym_LR_DQUOTE] = ACTIONS(2026),
    [anon_sym_uR_DQUOTE] = ACTIONS(2026),
    [anon_sym_UR_DQUOTE] = ACTIONS(2026),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2026),
    [anon_sym_co_await] = ACTIONS(2024),
    [anon_sym_new] = ACTIONS(2024),
    [anon_sym_requires] = ACTIONS(2024),
    [sym_this] = ACTIONS(2024),
    [anon_sym___launch_bounds__] = ACTIONS(2024),
  },
  [416] = {
    [sym_identifier] = ACTIONS(1964),
    [aux_sym_preproc_include_token1] = ACTIONS(1964),
    [aux_sym_preproc_def_token1] = ACTIONS(1964),
    [aux_sym_preproc_if_token1] = ACTIONS(1964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1964),
    [sym_preproc_directive] = ACTIONS(1964),
    [anon_sym_LPAREN2] = ACTIONS(1966),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [anon_sym_DASH] = ACTIONS(1964),
    [anon_sym_PLUS] = ACTIONS(1964),
    [anon_sym_STAR] = ACTIONS(1966),
    [anon_sym_AMP_AMP] = ACTIONS(1966),
    [anon_sym_AMP] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym___extension__] = ACTIONS(1964),
    [anon_sym_typedef] = ACTIONS(1964),
    [anon_sym___device__] = ACTIONS(1964),
    [anon_sym___host__] = ACTIONS(1964),
    [anon_sym___global__] = ACTIONS(1964),
    [anon_sym___forceinline__] = ACTIONS(1964),
    [anon_sym___noinline__] = ACTIONS(1964),
    [anon_sym_extern] = ACTIONS(1964),
    [anon_sym___attribute__] = ACTIONS(1964),
    [anon_sym_COLON_COLON] = ACTIONS(1966),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1966),
    [anon_sym___declspec] = ACTIONS(1964),
    [anon_sym___based] = ACTIONS(1964),
    [anon_sym___cdecl] = ACTIONS(1964),
    [anon_sym___clrcall] = ACTIONS(1964),
    [anon_sym___stdcall] = ACTIONS(1964),
    [anon_sym___fastcall] = ACTIONS(1964),
    [anon_sym___thiscall] = ACTIONS(1964),
    [anon_sym___vectorcall] = ACTIONS(1964),
    [anon_sym_LBRACE] = ACTIONS(1966),
    [anon_sym_RBRACE] = ACTIONS(1966),
    [anon_sym_signed] = ACTIONS(1964),
    [anon_sym_unsigned] = ACTIONS(1964),
    [anon_sym_long] = ACTIONS(1964),
    [anon_sym_short] = ACTIONS(1964),
    [anon_sym_LBRACK] = ACTIONS(1964),
    [anon_sym_static] = ACTIONS(1964),
    [anon_sym_register] = ACTIONS(1964),
    [anon_sym_inline] = ACTIONS(1964),
    [anon_sym___inline] = ACTIONS(1964),
    [anon_sym___inline__] = ACTIONS(1964),
    [anon_sym___forceinline] = ACTIONS(1964),
    [anon_sym_thread_local] = ACTIONS(1964),
    [anon_sym___thread] = ACTIONS(1964),
    [anon_sym_const] = ACTIONS(1964),
    [anon_sym_constexpr] = ACTIONS(1964),
    [anon_sym_volatile] = ACTIONS(1964),
    [anon_sym_restrict] = ACTIONS(1964),
    [anon_sym___restrict__] = ACTIONS(1964),
    [anon_sym__Atomic] = ACTIONS(1964),
    [anon_sym__Noreturn] = ACTIONS(1964),
    [anon_sym_noreturn] = ACTIONS(1964),
    [anon_sym_mutable] = ACTIONS(1964),
    [anon_sym_constinit] = ACTIONS(1964),
    [anon_sym_consteval] = ACTIONS(1964),
    [anon_sym___shared__] = ACTIONS(1964),
    [anon_sym___local__] = ACTIONS(1964),
    [anon_sym___constant__] = ACTIONS(1964),
    [anon_sym___managed__] = ACTIONS(1964),
    [anon_sym___grid_constant__] = ACTIONS(1964),
    [anon_sym_alignas] = ACTIONS(1964),
    [anon_sym__Alignas] = ACTIONS(1964),
    [sym_primitive_type] = ACTIONS(1964),
    [anon_sym_enum] = ACTIONS(1964),
    [anon_sym_class] = ACTIONS(1964),
    [anon_sym_struct] = ACTIONS(1964),
    [anon_sym_union] = ACTIONS(1964),
    [anon_sym_if] = ACTIONS(1964),
    [anon_sym_else] = ACTIONS(1964),
    [anon_sym_switch] = ACTIONS(1964),
    [anon_sym_case] = ACTIONS(1964),
    [anon_sym_default] = ACTIONS(1964),
    [anon_sym_while] = ACTIONS(1964),
    [anon_sym_do] = ACTIONS(1964),
    [anon_sym_for] = ACTIONS(1964),
    [anon_sym_return] = ACTIONS(1964),
    [anon_sym_break] = ACTIONS(1964),
    [anon_sym_continue] = ACTIONS(1964),
    [anon_sym_goto] = ACTIONS(1964),
    [anon_sym___try] = ACTIONS(1964),
    [anon_sym___leave] = ACTIONS(1964),
    [anon_sym_not] = ACTIONS(1964),
    [anon_sym_compl] = ACTIONS(1964),
    [anon_sym_DASH_DASH] = ACTIONS(1966),
    [anon_sym_PLUS_PLUS] = ACTIONS(1966),
    [anon_sym_sizeof] = ACTIONS(1964),
    [anon_sym___alignof__] = ACTIONS(1964),
    [anon_sym___alignof] = ACTIONS(1964),
    [anon_sym__alignof] = ACTIONS(1964),
    [anon_sym_alignof] = ACTIONS(1964),
    [anon_sym__Alignof] = ACTIONS(1964),
    [anon_sym_offsetof] = ACTIONS(1964),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1964),
    [anon_sym___asm__] = ACTIONS(1964),
    [sym_number_literal] = ACTIONS(1966),
    [anon_sym_L_SQUOTE] = ACTIONS(1966),
    [anon_sym_u_SQUOTE] = ACTIONS(1966),
    [anon_sym_U_SQUOTE] = ACTIONS(1966),
    [anon_sym_u8_SQUOTE] = ACTIONS(1966),
    [anon_sym_SQUOTE] = ACTIONS(1966),
    [anon_sym_L_DQUOTE] = ACTIONS(1966),
    [anon_sym_u_DQUOTE] = ACTIONS(1966),
    [anon_sym_U_DQUOTE] = ACTIONS(1966),
    [anon_sym_u8_DQUOTE] = ACTIONS(1966),
    [anon_sym_DQUOTE] = ACTIONS(1966),
    [sym_true] = ACTIONS(1964),
    [sym_false] = ACTIONS(1964),
    [anon_sym_NULL] = ACTIONS(1964),
    [anon_sym_nullptr] = ACTIONS(1964),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1964),
    [anon_sym_decltype] = ACTIONS(1964),
    [sym_virtual] = ACTIONS(1964),
    [anon_sym_explicit] = ACTIONS(1964),
    [anon_sym_typename] = ACTIONS(1964),
    [anon_sym_template] = ACTIONS(1964),
    [anon_sym_operator] = ACTIONS(1964),
    [anon_sym_try] = ACTIONS(1964),
    [anon_sym_delete] = ACTIONS(1964),
    [anon_sym_throw] = ACTIONS(1964),
    [anon_sym_namespace] = ACTIONS(1964),
    [anon_sym_using] = ACTIONS(1964),
    [anon_sym_static_assert] = ACTIONS(1964),
    [anon_sym_concept] = ACTIONS(1964),
    [anon_sym_co_return] = ACTIONS(1964),
    [anon_sym_co_yield] = ACTIONS(1964),
    [anon_sym_R_DQUOTE] = ACTIONS(1966),
    [anon_sym_LR_DQUOTE] = ACTIONS(1966),
    [anon_sym_uR_DQUOTE] = ACTIONS(1966),
    [anon_sym_UR_DQUOTE] = ACTIONS(1966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1966),
    [anon_sym_co_await] = ACTIONS(1964),
    [anon_sym_new] = ACTIONS(1964),
    [anon_sym_requires] = ACTIONS(1964),
    [sym_this] = ACTIONS(1964),
    [anon_sym___launch_bounds__] = ACTIONS(1964),
  },
  [417] = {
    [sym_identifier] = ACTIONS(1964),
    [aux_sym_preproc_include_token1] = ACTIONS(1964),
    [aux_sym_preproc_def_token1] = ACTIONS(1964),
    [aux_sym_preproc_if_token1] = ACTIONS(1964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1964),
    [sym_preproc_directive] = ACTIONS(1964),
    [anon_sym_LPAREN2] = ACTIONS(1966),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [anon_sym_DASH] = ACTIONS(1964),
    [anon_sym_PLUS] = ACTIONS(1964),
    [anon_sym_STAR] = ACTIONS(1966),
    [anon_sym_AMP_AMP] = ACTIONS(1966),
    [anon_sym_AMP] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym___extension__] = ACTIONS(1964),
    [anon_sym_typedef] = ACTIONS(1964),
    [anon_sym___device__] = ACTIONS(1964),
    [anon_sym___host__] = ACTIONS(1964),
    [anon_sym___global__] = ACTIONS(1964),
    [anon_sym___forceinline__] = ACTIONS(1964),
    [anon_sym___noinline__] = ACTIONS(1964),
    [anon_sym_extern] = ACTIONS(1964),
    [anon_sym___attribute__] = ACTIONS(1964),
    [anon_sym_COLON_COLON] = ACTIONS(1966),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1966),
    [anon_sym___declspec] = ACTIONS(1964),
    [anon_sym___based] = ACTIONS(1964),
    [anon_sym___cdecl] = ACTIONS(1964),
    [anon_sym___clrcall] = ACTIONS(1964),
    [anon_sym___stdcall] = ACTIONS(1964),
    [anon_sym___fastcall] = ACTIONS(1964),
    [anon_sym___thiscall] = ACTIONS(1964),
    [anon_sym___vectorcall] = ACTIONS(1964),
    [anon_sym_LBRACE] = ACTIONS(1966),
    [anon_sym_RBRACE] = ACTIONS(1966),
    [anon_sym_signed] = ACTIONS(1964),
    [anon_sym_unsigned] = ACTIONS(1964),
    [anon_sym_long] = ACTIONS(1964),
    [anon_sym_short] = ACTIONS(1964),
    [anon_sym_LBRACK] = ACTIONS(1964),
    [anon_sym_static] = ACTIONS(1964),
    [anon_sym_register] = ACTIONS(1964),
    [anon_sym_inline] = ACTIONS(1964),
    [anon_sym___inline] = ACTIONS(1964),
    [anon_sym___inline__] = ACTIONS(1964),
    [anon_sym___forceinline] = ACTIONS(1964),
    [anon_sym_thread_local] = ACTIONS(1964),
    [anon_sym___thread] = ACTIONS(1964),
    [anon_sym_const] = ACTIONS(1964),
    [anon_sym_constexpr] = ACTIONS(1964),
    [anon_sym_volatile] = ACTIONS(1964),
    [anon_sym_restrict] = ACTIONS(1964),
    [anon_sym___restrict__] = ACTIONS(1964),
    [anon_sym__Atomic] = ACTIONS(1964),
    [anon_sym__Noreturn] = ACTIONS(1964),
    [anon_sym_noreturn] = ACTIONS(1964),
    [anon_sym_mutable] = ACTIONS(1964),
    [anon_sym_constinit] = ACTIONS(1964),
    [anon_sym_consteval] = ACTIONS(1964),
    [anon_sym___shared__] = ACTIONS(1964),
    [anon_sym___local__] = ACTIONS(1964),
    [anon_sym___constant__] = ACTIONS(1964),
    [anon_sym___managed__] = ACTIONS(1964),
    [anon_sym___grid_constant__] = ACTIONS(1964),
    [anon_sym_alignas] = ACTIONS(1964),
    [anon_sym__Alignas] = ACTIONS(1964),
    [sym_primitive_type] = ACTIONS(1964),
    [anon_sym_enum] = ACTIONS(1964),
    [anon_sym_class] = ACTIONS(1964),
    [anon_sym_struct] = ACTIONS(1964),
    [anon_sym_union] = ACTIONS(1964),
    [anon_sym_if] = ACTIONS(1964),
    [anon_sym_else] = ACTIONS(1964),
    [anon_sym_switch] = ACTIONS(1964),
    [anon_sym_case] = ACTIONS(1964),
    [anon_sym_default] = ACTIONS(1964),
    [anon_sym_while] = ACTIONS(1964),
    [anon_sym_do] = ACTIONS(1964),
    [anon_sym_for] = ACTIONS(1964),
    [anon_sym_return] = ACTIONS(1964),
    [anon_sym_break] = ACTIONS(1964),
    [anon_sym_continue] = ACTIONS(1964),
    [anon_sym_goto] = ACTIONS(1964),
    [anon_sym___try] = ACTIONS(1964),
    [anon_sym___leave] = ACTIONS(1964),
    [anon_sym_not] = ACTIONS(1964),
    [anon_sym_compl] = ACTIONS(1964),
    [anon_sym_DASH_DASH] = ACTIONS(1966),
    [anon_sym_PLUS_PLUS] = ACTIONS(1966),
    [anon_sym_sizeof] = ACTIONS(1964),
    [anon_sym___alignof__] = ACTIONS(1964),
    [anon_sym___alignof] = ACTIONS(1964),
    [anon_sym__alignof] = ACTIONS(1964),
    [anon_sym_alignof] = ACTIONS(1964),
    [anon_sym__Alignof] = ACTIONS(1964),
    [anon_sym_offsetof] = ACTIONS(1964),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1964),
    [anon_sym___asm__] = ACTIONS(1964),
    [sym_number_literal] = ACTIONS(1966),
    [anon_sym_L_SQUOTE] = ACTIONS(1966),
    [anon_sym_u_SQUOTE] = ACTIONS(1966),
    [anon_sym_U_SQUOTE] = ACTIONS(1966),
    [anon_sym_u8_SQUOTE] = ACTIONS(1966),
    [anon_sym_SQUOTE] = ACTIONS(1966),
    [anon_sym_L_DQUOTE] = ACTIONS(1966),
    [anon_sym_u_DQUOTE] = ACTIONS(1966),
    [anon_sym_U_DQUOTE] = ACTIONS(1966),
    [anon_sym_u8_DQUOTE] = ACTIONS(1966),
    [anon_sym_DQUOTE] = ACTIONS(1966),
    [sym_true] = ACTIONS(1964),
    [sym_false] = ACTIONS(1964),
    [anon_sym_NULL] = ACTIONS(1964),
    [anon_sym_nullptr] = ACTIONS(1964),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1964),
    [anon_sym_decltype] = ACTIONS(1964),
    [sym_virtual] = ACTIONS(1964),
    [anon_sym_explicit] = ACTIONS(1964),
    [anon_sym_typename] = ACTIONS(1964),
    [anon_sym_template] = ACTIONS(1964),
    [anon_sym_operator] = ACTIONS(1964),
    [anon_sym_try] = ACTIONS(1964),
    [anon_sym_delete] = ACTIONS(1964),
    [anon_sym_throw] = ACTIONS(1964),
    [anon_sym_namespace] = ACTIONS(1964),
    [anon_sym_using] = ACTIONS(1964),
    [anon_sym_static_assert] = ACTIONS(1964),
    [anon_sym_concept] = ACTIONS(1964),
    [anon_sym_co_return] = ACTIONS(1964),
    [anon_sym_co_yield] = ACTIONS(1964),
    [anon_sym_R_DQUOTE] = ACTIONS(1966),
    [anon_sym_LR_DQUOTE] = ACTIONS(1966),
    [anon_sym_uR_DQUOTE] = ACTIONS(1966),
    [anon_sym_UR_DQUOTE] = ACTIONS(1966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1966),
    [anon_sym_co_await] = ACTIONS(1964),
    [anon_sym_new] = ACTIONS(1964),
    [anon_sym_requires] = ACTIONS(1964),
    [sym_this] = ACTIONS(1964),
    [anon_sym___launch_bounds__] = ACTIONS(1964),
  },
  [418] = {
    [ts_builtin_sym_end] = ACTIONS(1998),
    [sym_identifier] = ACTIONS(1996),
    [aux_sym_preproc_include_token1] = ACTIONS(1996),
    [aux_sym_preproc_def_token1] = ACTIONS(1996),
    [aux_sym_preproc_if_token1] = ACTIONS(1996),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1996),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1996),
    [sym_preproc_directive] = ACTIONS(1996),
    [anon_sym_LPAREN2] = ACTIONS(1998),
    [anon_sym_BANG] = ACTIONS(1998),
    [anon_sym_TILDE] = ACTIONS(1998),
    [anon_sym_DASH] = ACTIONS(1996),
    [anon_sym_PLUS] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(1998),
    [anon_sym_AMP_AMP] = ACTIONS(1998),
    [anon_sym_AMP] = ACTIONS(1996),
    [anon_sym_SEMI] = ACTIONS(1998),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_typedef] = ACTIONS(1996),
    [anon_sym___device__] = ACTIONS(1996),
    [anon_sym___host__] = ACTIONS(1996),
    [anon_sym___global__] = ACTIONS(1996),
    [anon_sym___forceinline__] = ACTIONS(1996),
    [anon_sym___noinline__] = ACTIONS(1996),
    [anon_sym_extern] = ACTIONS(1996),
    [anon_sym___attribute__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1998),
    [anon_sym___declspec] = ACTIONS(1996),
    [anon_sym___based] = ACTIONS(1996),
    [anon_sym___cdecl] = ACTIONS(1996),
    [anon_sym___clrcall] = ACTIONS(1996),
    [anon_sym___stdcall] = ACTIONS(1996),
    [anon_sym___fastcall] = ACTIONS(1996),
    [anon_sym___thiscall] = ACTIONS(1996),
    [anon_sym___vectorcall] = ACTIONS(1996),
    [anon_sym_LBRACE] = ACTIONS(1998),
    [anon_sym_signed] = ACTIONS(1996),
    [anon_sym_unsigned] = ACTIONS(1996),
    [anon_sym_long] = ACTIONS(1996),
    [anon_sym_short] = ACTIONS(1996),
    [anon_sym_LBRACK] = ACTIONS(1996),
    [anon_sym_static] = ACTIONS(1996),
    [anon_sym_register] = ACTIONS(1996),
    [anon_sym_inline] = ACTIONS(1996),
    [anon_sym___inline] = ACTIONS(1996),
    [anon_sym___inline__] = ACTIONS(1996),
    [anon_sym___forceinline] = ACTIONS(1996),
    [anon_sym_thread_local] = ACTIONS(1996),
    [anon_sym___thread] = ACTIONS(1996),
    [anon_sym_const] = ACTIONS(1996),
    [anon_sym_constexpr] = ACTIONS(1996),
    [anon_sym_volatile] = ACTIONS(1996),
    [anon_sym_restrict] = ACTIONS(1996),
    [anon_sym___restrict__] = ACTIONS(1996),
    [anon_sym__Atomic] = ACTIONS(1996),
    [anon_sym__Noreturn] = ACTIONS(1996),
    [anon_sym_noreturn] = ACTIONS(1996),
    [anon_sym_mutable] = ACTIONS(1996),
    [anon_sym_constinit] = ACTIONS(1996),
    [anon_sym_consteval] = ACTIONS(1996),
    [anon_sym___shared__] = ACTIONS(1996),
    [anon_sym___local__] = ACTIONS(1996),
    [anon_sym___constant__] = ACTIONS(1996),
    [anon_sym___managed__] = ACTIONS(1996),
    [anon_sym___grid_constant__] = ACTIONS(1996),
    [anon_sym_alignas] = ACTIONS(1996),
    [anon_sym__Alignas] = ACTIONS(1996),
    [sym_primitive_type] = ACTIONS(1996),
    [anon_sym_enum] = ACTIONS(1996),
    [anon_sym_class] = ACTIONS(1996),
    [anon_sym_struct] = ACTIONS(1996),
    [anon_sym_union] = ACTIONS(1996),
    [anon_sym_if] = ACTIONS(1996),
    [anon_sym_else] = ACTIONS(1996),
    [anon_sym_switch] = ACTIONS(1996),
    [anon_sym_case] = ACTIONS(1996),
    [anon_sym_default] = ACTIONS(1996),
    [anon_sym_while] = ACTIONS(1996),
    [anon_sym_do] = ACTIONS(1996),
    [anon_sym_for] = ACTIONS(1996),
    [anon_sym_return] = ACTIONS(1996),
    [anon_sym_break] = ACTIONS(1996),
    [anon_sym_continue] = ACTIONS(1996),
    [anon_sym_goto] = ACTIONS(1996),
    [anon_sym___try] = ACTIONS(1996),
    [anon_sym___leave] = ACTIONS(1996),
    [anon_sym_not] = ACTIONS(1996),
    [anon_sym_compl] = ACTIONS(1996),
    [anon_sym_DASH_DASH] = ACTIONS(1998),
    [anon_sym_PLUS_PLUS] = ACTIONS(1998),
    [anon_sym_sizeof] = ACTIONS(1996),
    [anon_sym___alignof__] = ACTIONS(1996),
    [anon_sym___alignof] = ACTIONS(1996),
    [anon_sym__alignof] = ACTIONS(1996),
    [anon_sym_alignof] = ACTIONS(1996),
    [anon_sym__Alignof] = ACTIONS(1996),
    [anon_sym_offsetof] = ACTIONS(1996),
    [anon_sym__Generic] = ACTIONS(1996),
    [anon_sym_asm] = ACTIONS(1996),
    [anon_sym___asm__] = ACTIONS(1996),
    [sym_number_literal] = ACTIONS(1998),
    [anon_sym_L_SQUOTE] = ACTIONS(1998),
    [anon_sym_u_SQUOTE] = ACTIONS(1998),
    [anon_sym_U_SQUOTE] = ACTIONS(1998),
    [anon_sym_u8_SQUOTE] = ACTIONS(1998),
    [anon_sym_SQUOTE] = ACTIONS(1998),
    [anon_sym_L_DQUOTE] = ACTIONS(1998),
    [anon_sym_u_DQUOTE] = ACTIONS(1998),
    [anon_sym_U_DQUOTE] = ACTIONS(1998),
    [anon_sym_u8_DQUOTE] = ACTIONS(1998),
    [anon_sym_DQUOTE] = ACTIONS(1998),
    [sym_true] = ACTIONS(1996),
    [sym_false] = ACTIONS(1996),
    [anon_sym_NULL] = ACTIONS(1996),
    [anon_sym_nullptr] = ACTIONS(1996),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1996),
    [anon_sym_decltype] = ACTIONS(1996),
    [sym_virtual] = ACTIONS(1996),
    [anon_sym_explicit] = ACTIONS(1996),
    [anon_sym_typename] = ACTIONS(1996),
    [anon_sym_template] = ACTIONS(1996),
    [anon_sym_operator] = ACTIONS(1996),
    [anon_sym_try] = ACTIONS(1996),
    [anon_sym_delete] = ACTIONS(1996),
    [anon_sym_throw] = ACTIONS(1996),
    [anon_sym_namespace] = ACTIONS(1996),
    [anon_sym_using] = ACTIONS(1996),
    [anon_sym_static_assert] = ACTIONS(1996),
    [anon_sym_concept] = ACTIONS(1996),
    [anon_sym_co_return] = ACTIONS(1996),
    [anon_sym_co_yield] = ACTIONS(1996),
    [anon_sym_R_DQUOTE] = ACTIONS(1998),
    [anon_sym_LR_DQUOTE] = ACTIONS(1998),
    [anon_sym_uR_DQUOTE] = ACTIONS(1998),
    [anon_sym_UR_DQUOTE] = ACTIONS(1998),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1998),
    [anon_sym_co_await] = ACTIONS(1996),
    [anon_sym_new] = ACTIONS(1996),
    [anon_sym_requires] = ACTIONS(1996),
    [sym_this] = ACTIONS(1996),
    [anon_sym___launch_bounds__] = ACTIONS(1996),
  },
  [419] = {
    [sym_identifier] = ACTIONS(1946),
    [aux_sym_preproc_include_token1] = ACTIONS(1946),
    [aux_sym_preproc_def_token1] = ACTIONS(1946),
    [aux_sym_preproc_if_token1] = ACTIONS(1946),
    [aux_sym_preproc_if_token2] = ACTIONS(1946),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1946),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1946),
    [sym_preproc_directive] = ACTIONS(1946),
    [anon_sym_LPAREN2] = ACTIONS(1948),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(1948),
    [anon_sym_AMP_AMP] = ACTIONS(1948),
    [anon_sym_AMP] = ACTIONS(1946),
    [anon_sym_SEMI] = ACTIONS(1948),
    [anon_sym___extension__] = ACTIONS(1946),
    [anon_sym_typedef] = ACTIONS(1946),
    [anon_sym___device__] = ACTIONS(1946),
    [anon_sym___host__] = ACTIONS(1946),
    [anon_sym___global__] = ACTIONS(1946),
    [anon_sym___forceinline__] = ACTIONS(1946),
    [anon_sym___noinline__] = ACTIONS(1946),
    [anon_sym_extern] = ACTIONS(1946),
    [anon_sym___attribute__] = ACTIONS(1946),
    [anon_sym_COLON_COLON] = ACTIONS(1948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1948),
    [anon_sym___declspec] = ACTIONS(1946),
    [anon_sym___based] = ACTIONS(1946),
    [anon_sym___cdecl] = ACTIONS(1946),
    [anon_sym___clrcall] = ACTIONS(1946),
    [anon_sym___stdcall] = ACTIONS(1946),
    [anon_sym___fastcall] = ACTIONS(1946),
    [anon_sym___thiscall] = ACTIONS(1946),
    [anon_sym___vectorcall] = ACTIONS(1946),
    [anon_sym_LBRACE] = ACTIONS(1948),
    [anon_sym_signed] = ACTIONS(1946),
    [anon_sym_unsigned] = ACTIONS(1946),
    [anon_sym_long] = ACTIONS(1946),
    [anon_sym_short] = ACTIONS(1946),
    [anon_sym_LBRACK] = ACTIONS(1946),
    [anon_sym_static] = ACTIONS(1946),
    [anon_sym_register] = ACTIONS(1946),
    [anon_sym_inline] = ACTIONS(1946),
    [anon_sym___inline] = ACTIONS(1946),
    [anon_sym___inline__] = ACTIONS(1946),
    [anon_sym___forceinline] = ACTIONS(1946),
    [anon_sym_thread_local] = ACTIONS(1946),
    [anon_sym___thread] = ACTIONS(1946),
    [anon_sym_const] = ACTIONS(1946),
    [anon_sym_constexpr] = ACTIONS(1946),
    [anon_sym_volatile] = ACTIONS(1946),
    [anon_sym_restrict] = ACTIONS(1946),
    [anon_sym___restrict__] = ACTIONS(1946),
    [anon_sym__Atomic] = ACTIONS(1946),
    [anon_sym__Noreturn] = ACTIONS(1946),
    [anon_sym_noreturn] = ACTIONS(1946),
    [anon_sym_mutable] = ACTIONS(1946),
    [anon_sym_constinit] = ACTIONS(1946),
    [anon_sym_consteval] = ACTIONS(1946),
    [anon_sym___shared__] = ACTIONS(1946),
    [anon_sym___local__] = ACTIONS(1946),
    [anon_sym___constant__] = ACTIONS(1946),
    [anon_sym___managed__] = ACTIONS(1946),
    [anon_sym___grid_constant__] = ACTIONS(1946),
    [anon_sym_alignas] = ACTIONS(1946),
    [anon_sym__Alignas] = ACTIONS(1946),
    [sym_primitive_type] = ACTIONS(1946),
    [anon_sym_enum] = ACTIONS(1946),
    [anon_sym_class] = ACTIONS(1946),
    [anon_sym_struct] = ACTIONS(1946),
    [anon_sym_union] = ACTIONS(1946),
    [anon_sym_if] = ACTIONS(1946),
    [anon_sym_else] = ACTIONS(1946),
    [anon_sym_switch] = ACTIONS(1946),
    [anon_sym_case] = ACTIONS(1946),
    [anon_sym_default] = ACTIONS(1946),
    [anon_sym_while] = ACTIONS(1946),
    [anon_sym_do] = ACTIONS(1946),
    [anon_sym_for] = ACTIONS(1946),
    [anon_sym_return] = ACTIONS(1946),
    [anon_sym_break] = ACTIONS(1946),
    [anon_sym_continue] = ACTIONS(1946),
    [anon_sym_goto] = ACTIONS(1946),
    [anon_sym___try] = ACTIONS(1946),
    [anon_sym___leave] = ACTIONS(1946),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(1948),
    [anon_sym_PLUS_PLUS] = ACTIONS(1948),
    [anon_sym_sizeof] = ACTIONS(1946),
    [anon_sym___alignof__] = ACTIONS(1946),
    [anon_sym___alignof] = ACTIONS(1946),
    [anon_sym__alignof] = ACTIONS(1946),
    [anon_sym_alignof] = ACTIONS(1946),
    [anon_sym__Alignof] = ACTIONS(1946),
    [anon_sym_offsetof] = ACTIONS(1946),
    [anon_sym__Generic] = ACTIONS(1946),
    [anon_sym_asm] = ACTIONS(1946),
    [anon_sym___asm__] = ACTIONS(1946),
    [sym_number_literal] = ACTIONS(1948),
    [anon_sym_L_SQUOTE] = ACTIONS(1948),
    [anon_sym_u_SQUOTE] = ACTIONS(1948),
    [anon_sym_U_SQUOTE] = ACTIONS(1948),
    [anon_sym_u8_SQUOTE] = ACTIONS(1948),
    [anon_sym_SQUOTE] = ACTIONS(1948),
    [anon_sym_L_DQUOTE] = ACTIONS(1948),
    [anon_sym_u_DQUOTE] = ACTIONS(1948),
    [anon_sym_U_DQUOTE] = ACTIONS(1948),
    [anon_sym_u8_DQUOTE] = ACTIONS(1948),
    [anon_sym_DQUOTE] = ACTIONS(1948),
    [sym_true] = ACTIONS(1946),
    [sym_false] = ACTIONS(1946),
    [anon_sym_NULL] = ACTIONS(1946),
    [anon_sym_nullptr] = ACTIONS(1946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1946),
    [anon_sym_decltype] = ACTIONS(1946),
    [sym_virtual] = ACTIONS(1946),
    [anon_sym_explicit] = ACTIONS(1946),
    [anon_sym_typename] = ACTIONS(1946),
    [anon_sym_template] = ACTIONS(1946),
    [anon_sym_operator] = ACTIONS(1946),
    [anon_sym_try] = ACTIONS(1946),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_throw] = ACTIONS(1946),
    [anon_sym_namespace] = ACTIONS(1946),
    [anon_sym_using] = ACTIONS(1946),
    [anon_sym_static_assert] = ACTIONS(1946),
    [anon_sym_concept] = ACTIONS(1946),
    [anon_sym_co_return] = ACTIONS(1946),
    [anon_sym_co_yield] = ACTIONS(1946),
    [anon_sym_R_DQUOTE] = ACTIONS(1948),
    [anon_sym_LR_DQUOTE] = ACTIONS(1948),
    [anon_sym_uR_DQUOTE] = ACTIONS(1948),
    [anon_sym_UR_DQUOTE] = ACTIONS(1948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1948),
    [anon_sym_co_await] = ACTIONS(1946),
    [anon_sym_new] = ACTIONS(1946),
    [anon_sym_requires] = ACTIONS(1946),
    [sym_this] = ACTIONS(1946),
    [anon_sym___launch_bounds__] = ACTIONS(1946),
  },
  [420] = {
    [ts_builtin_sym_end] = ACTIONS(1978),
    [sym_identifier] = ACTIONS(1976),
    [aux_sym_preproc_include_token1] = ACTIONS(1976),
    [aux_sym_preproc_def_token1] = ACTIONS(1976),
    [aux_sym_preproc_if_token1] = ACTIONS(1976),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1976),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1976),
    [sym_preproc_directive] = ACTIONS(1976),
    [anon_sym_LPAREN2] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1978),
    [anon_sym_TILDE] = ACTIONS(1978),
    [anon_sym_DASH] = ACTIONS(1976),
    [anon_sym_PLUS] = ACTIONS(1976),
    [anon_sym_STAR] = ACTIONS(1978),
    [anon_sym_AMP_AMP] = ACTIONS(1978),
    [anon_sym_AMP] = ACTIONS(1976),
    [anon_sym_SEMI] = ACTIONS(1978),
    [anon_sym___extension__] = ACTIONS(1976),
    [anon_sym_typedef] = ACTIONS(1976),
    [anon_sym___device__] = ACTIONS(1976),
    [anon_sym___host__] = ACTIONS(1976),
    [anon_sym___global__] = ACTIONS(1976),
    [anon_sym___forceinline__] = ACTIONS(1976),
    [anon_sym___noinline__] = ACTIONS(1976),
    [anon_sym_extern] = ACTIONS(1976),
    [anon_sym___attribute__] = ACTIONS(1976),
    [anon_sym_COLON_COLON] = ACTIONS(1978),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1978),
    [anon_sym___declspec] = ACTIONS(1976),
    [anon_sym___based] = ACTIONS(1976),
    [anon_sym___cdecl] = ACTIONS(1976),
    [anon_sym___clrcall] = ACTIONS(1976),
    [anon_sym___stdcall] = ACTIONS(1976),
    [anon_sym___fastcall] = ACTIONS(1976),
    [anon_sym___thiscall] = ACTIONS(1976),
    [anon_sym___vectorcall] = ACTIONS(1976),
    [anon_sym_LBRACE] = ACTIONS(1978),
    [anon_sym_signed] = ACTIONS(1976),
    [anon_sym_unsigned] = ACTIONS(1976),
    [anon_sym_long] = ACTIONS(1976),
    [anon_sym_short] = ACTIONS(1976),
    [anon_sym_LBRACK] = ACTIONS(1976),
    [anon_sym_static] = ACTIONS(1976),
    [anon_sym_register] = ACTIONS(1976),
    [anon_sym_inline] = ACTIONS(1976),
    [anon_sym___inline] = ACTIONS(1976),
    [anon_sym___inline__] = ACTIONS(1976),
    [anon_sym___forceinline] = ACTIONS(1976),
    [anon_sym_thread_local] = ACTIONS(1976),
    [anon_sym___thread] = ACTIONS(1976),
    [anon_sym_const] = ACTIONS(1976),
    [anon_sym_constexpr] = ACTIONS(1976),
    [anon_sym_volatile] = ACTIONS(1976),
    [anon_sym_restrict] = ACTIONS(1976),
    [anon_sym___restrict__] = ACTIONS(1976),
    [anon_sym__Atomic] = ACTIONS(1976),
    [anon_sym__Noreturn] = ACTIONS(1976),
    [anon_sym_noreturn] = ACTIONS(1976),
    [anon_sym_mutable] = ACTIONS(1976),
    [anon_sym_constinit] = ACTIONS(1976),
    [anon_sym_consteval] = ACTIONS(1976),
    [anon_sym___shared__] = ACTIONS(1976),
    [anon_sym___local__] = ACTIONS(1976),
    [anon_sym___constant__] = ACTIONS(1976),
    [anon_sym___managed__] = ACTIONS(1976),
    [anon_sym___grid_constant__] = ACTIONS(1976),
    [anon_sym_alignas] = ACTIONS(1976),
    [anon_sym__Alignas] = ACTIONS(1976),
    [sym_primitive_type] = ACTIONS(1976),
    [anon_sym_enum] = ACTIONS(1976),
    [anon_sym_class] = ACTIONS(1976),
    [anon_sym_struct] = ACTIONS(1976),
    [anon_sym_union] = ACTIONS(1976),
    [anon_sym_if] = ACTIONS(1976),
    [anon_sym_else] = ACTIONS(1976),
    [anon_sym_switch] = ACTIONS(1976),
    [anon_sym_case] = ACTIONS(1976),
    [anon_sym_default] = ACTIONS(1976),
    [anon_sym_while] = ACTIONS(1976),
    [anon_sym_do] = ACTIONS(1976),
    [anon_sym_for] = ACTIONS(1976),
    [anon_sym_return] = ACTIONS(1976),
    [anon_sym_break] = ACTIONS(1976),
    [anon_sym_continue] = ACTIONS(1976),
    [anon_sym_goto] = ACTIONS(1976),
    [anon_sym___try] = ACTIONS(1976),
    [anon_sym___leave] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1976),
    [anon_sym_compl] = ACTIONS(1976),
    [anon_sym_DASH_DASH] = ACTIONS(1978),
    [anon_sym_PLUS_PLUS] = ACTIONS(1978),
    [anon_sym_sizeof] = ACTIONS(1976),
    [anon_sym___alignof__] = ACTIONS(1976),
    [anon_sym___alignof] = ACTIONS(1976),
    [anon_sym__alignof] = ACTIONS(1976),
    [anon_sym_alignof] = ACTIONS(1976),
    [anon_sym__Alignof] = ACTIONS(1976),
    [anon_sym_offsetof] = ACTIONS(1976),
    [anon_sym__Generic] = ACTIONS(1976),
    [anon_sym_asm] = ACTIONS(1976),
    [anon_sym___asm__] = ACTIONS(1976),
    [sym_number_literal] = ACTIONS(1978),
    [anon_sym_L_SQUOTE] = ACTIONS(1978),
    [anon_sym_u_SQUOTE] = ACTIONS(1978),
    [anon_sym_U_SQUOTE] = ACTIONS(1978),
    [anon_sym_u8_SQUOTE] = ACTIONS(1978),
    [anon_sym_SQUOTE] = ACTIONS(1978),
    [anon_sym_L_DQUOTE] = ACTIONS(1978),
    [anon_sym_u_DQUOTE] = ACTIONS(1978),
    [anon_sym_U_DQUOTE] = ACTIONS(1978),
    [anon_sym_u8_DQUOTE] = ACTIONS(1978),
    [anon_sym_DQUOTE] = ACTIONS(1978),
    [sym_true] = ACTIONS(1976),
    [sym_false] = ACTIONS(1976),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1976),
    [anon_sym_decltype] = ACTIONS(1976),
    [sym_virtual] = ACTIONS(1976),
    [anon_sym_explicit] = ACTIONS(1976),
    [anon_sym_typename] = ACTIONS(1976),
    [anon_sym_template] = ACTIONS(1976),
    [anon_sym_operator] = ACTIONS(1976),
    [anon_sym_try] = ACTIONS(1976),
    [anon_sym_delete] = ACTIONS(1976),
    [anon_sym_throw] = ACTIONS(1976),
    [anon_sym_namespace] = ACTIONS(1976),
    [anon_sym_using] = ACTIONS(1976),
    [anon_sym_static_assert] = ACTIONS(1976),
    [anon_sym_concept] = ACTIONS(1976),
    [anon_sym_co_return] = ACTIONS(1976),
    [anon_sym_co_yield] = ACTIONS(1976),
    [anon_sym_R_DQUOTE] = ACTIONS(1978),
    [anon_sym_LR_DQUOTE] = ACTIONS(1978),
    [anon_sym_uR_DQUOTE] = ACTIONS(1978),
    [anon_sym_UR_DQUOTE] = ACTIONS(1978),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1978),
    [anon_sym_co_await] = ACTIONS(1976),
    [anon_sym_new] = ACTIONS(1976),
    [anon_sym_requires] = ACTIONS(1976),
    [sym_this] = ACTIONS(1976),
    [anon_sym___launch_bounds__] = ACTIONS(1976),
  },
  [421] = {
    [sym_identifier] = ACTIONS(2068),
    [aux_sym_preproc_include_token1] = ACTIONS(2068),
    [aux_sym_preproc_def_token1] = ACTIONS(2068),
    [aux_sym_preproc_if_token1] = ACTIONS(2068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2068),
    [sym_preproc_directive] = ACTIONS(2068),
    [anon_sym_LPAREN2] = ACTIONS(2070),
    [anon_sym_BANG] = ACTIONS(2070),
    [anon_sym_TILDE] = ACTIONS(2070),
    [anon_sym_DASH] = ACTIONS(2068),
    [anon_sym_PLUS] = ACTIONS(2068),
    [anon_sym_STAR] = ACTIONS(2070),
    [anon_sym_AMP_AMP] = ACTIONS(2070),
    [anon_sym_AMP] = ACTIONS(2068),
    [anon_sym_SEMI] = ACTIONS(2070),
    [anon_sym___extension__] = ACTIONS(2068),
    [anon_sym_typedef] = ACTIONS(2068),
    [anon_sym___device__] = ACTIONS(2068),
    [anon_sym___host__] = ACTIONS(2068),
    [anon_sym___global__] = ACTIONS(2068),
    [anon_sym___forceinline__] = ACTIONS(2068),
    [anon_sym___noinline__] = ACTIONS(2068),
    [anon_sym_extern] = ACTIONS(2068),
    [anon_sym___attribute__] = ACTIONS(2068),
    [anon_sym_COLON_COLON] = ACTIONS(2070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2070),
    [anon_sym___declspec] = ACTIONS(2068),
    [anon_sym___based] = ACTIONS(2068),
    [anon_sym___cdecl] = ACTIONS(2068),
    [anon_sym___clrcall] = ACTIONS(2068),
    [anon_sym___stdcall] = ACTIONS(2068),
    [anon_sym___fastcall] = ACTIONS(2068),
    [anon_sym___thiscall] = ACTIONS(2068),
    [anon_sym___vectorcall] = ACTIONS(2068),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_RBRACE] = ACTIONS(2070),
    [anon_sym_signed] = ACTIONS(2068),
    [anon_sym_unsigned] = ACTIONS(2068),
    [anon_sym_long] = ACTIONS(2068),
    [anon_sym_short] = ACTIONS(2068),
    [anon_sym_LBRACK] = ACTIONS(2068),
    [anon_sym_static] = ACTIONS(2068),
    [anon_sym_register] = ACTIONS(2068),
    [anon_sym_inline] = ACTIONS(2068),
    [anon_sym___inline] = ACTIONS(2068),
    [anon_sym___inline__] = ACTIONS(2068),
    [anon_sym___forceinline] = ACTIONS(2068),
    [anon_sym_thread_local] = ACTIONS(2068),
    [anon_sym___thread] = ACTIONS(2068),
    [anon_sym_const] = ACTIONS(2068),
    [anon_sym_constexpr] = ACTIONS(2068),
    [anon_sym_volatile] = ACTIONS(2068),
    [anon_sym_restrict] = ACTIONS(2068),
    [anon_sym___restrict__] = ACTIONS(2068),
    [anon_sym__Atomic] = ACTIONS(2068),
    [anon_sym__Noreturn] = ACTIONS(2068),
    [anon_sym_noreturn] = ACTIONS(2068),
    [anon_sym_mutable] = ACTIONS(2068),
    [anon_sym_constinit] = ACTIONS(2068),
    [anon_sym_consteval] = ACTIONS(2068),
    [anon_sym___shared__] = ACTIONS(2068),
    [anon_sym___local__] = ACTIONS(2068),
    [anon_sym___constant__] = ACTIONS(2068),
    [anon_sym___managed__] = ACTIONS(2068),
    [anon_sym___grid_constant__] = ACTIONS(2068),
    [anon_sym_alignas] = ACTIONS(2068),
    [anon_sym__Alignas] = ACTIONS(2068),
    [sym_primitive_type] = ACTIONS(2068),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2068),
    [anon_sym_struct] = ACTIONS(2068),
    [anon_sym_union] = ACTIONS(2068),
    [anon_sym_if] = ACTIONS(2068),
    [anon_sym_else] = ACTIONS(2068),
    [anon_sym_switch] = ACTIONS(2068),
    [anon_sym_case] = ACTIONS(2068),
    [anon_sym_default] = ACTIONS(2068),
    [anon_sym_while] = ACTIONS(2068),
    [anon_sym_do] = ACTIONS(2068),
    [anon_sym_for] = ACTIONS(2068),
    [anon_sym_return] = ACTIONS(2068),
    [anon_sym_break] = ACTIONS(2068),
    [anon_sym_continue] = ACTIONS(2068),
    [anon_sym_goto] = ACTIONS(2068),
    [anon_sym___try] = ACTIONS(2068),
    [anon_sym___leave] = ACTIONS(2068),
    [anon_sym_not] = ACTIONS(2068),
    [anon_sym_compl] = ACTIONS(2068),
    [anon_sym_DASH_DASH] = ACTIONS(2070),
    [anon_sym_PLUS_PLUS] = ACTIONS(2070),
    [anon_sym_sizeof] = ACTIONS(2068),
    [anon_sym___alignof__] = ACTIONS(2068),
    [anon_sym___alignof] = ACTIONS(2068),
    [anon_sym__alignof] = ACTIONS(2068),
    [anon_sym_alignof] = ACTIONS(2068),
    [anon_sym__Alignof] = ACTIONS(2068),
    [anon_sym_offsetof] = ACTIONS(2068),
    [anon_sym__Generic] = ACTIONS(2068),
    [anon_sym_asm] = ACTIONS(2068),
    [anon_sym___asm__] = ACTIONS(2068),
    [sym_number_literal] = ACTIONS(2070),
    [anon_sym_L_SQUOTE] = ACTIONS(2070),
    [anon_sym_u_SQUOTE] = ACTIONS(2070),
    [anon_sym_U_SQUOTE] = ACTIONS(2070),
    [anon_sym_u8_SQUOTE] = ACTIONS(2070),
    [anon_sym_SQUOTE] = ACTIONS(2070),
    [anon_sym_L_DQUOTE] = ACTIONS(2070),
    [anon_sym_u_DQUOTE] = ACTIONS(2070),
    [anon_sym_U_DQUOTE] = ACTIONS(2070),
    [anon_sym_u8_DQUOTE] = ACTIONS(2070),
    [anon_sym_DQUOTE] = ACTIONS(2070),
    [sym_true] = ACTIONS(2068),
    [sym_false] = ACTIONS(2068),
    [anon_sym_NULL] = ACTIONS(2068),
    [anon_sym_nullptr] = ACTIONS(2068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2068),
    [anon_sym_decltype] = ACTIONS(2068),
    [sym_virtual] = ACTIONS(2068),
    [anon_sym_explicit] = ACTIONS(2068),
    [anon_sym_typename] = ACTIONS(2068),
    [anon_sym_template] = ACTIONS(2068),
    [anon_sym_operator] = ACTIONS(2068),
    [anon_sym_try] = ACTIONS(2068),
    [anon_sym_delete] = ACTIONS(2068),
    [anon_sym_throw] = ACTIONS(2068),
    [anon_sym_namespace] = ACTIONS(2068),
    [anon_sym_using] = ACTIONS(2068),
    [anon_sym_static_assert] = ACTIONS(2068),
    [anon_sym_concept] = ACTIONS(2068),
    [anon_sym_co_return] = ACTIONS(2068),
    [anon_sym_co_yield] = ACTIONS(2068),
    [anon_sym_R_DQUOTE] = ACTIONS(2070),
    [anon_sym_LR_DQUOTE] = ACTIONS(2070),
    [anon_sym_uR_DQUOTE] = ACTIONS(2070),
    [anon_sym_UR_DQUOTE] = ACTIONS(2070),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2070),
    [anon_sym_co_await] = ACTIONS(2068),
    [anon_sym_new] = ACTIONS(2068),
    [anon_sym_requires] = ACTIONS(2068),
    [sym_this] = ACTIONS(2068),
    [anon_sym___launch_bounds__] = ACTIONS(2068),
  },
  [422] = {
    [ts_builtin_sym_end] = ACTIONS(1982),
    [sym_identifier] = ACTIONS(1980),
    [aux_sym_preproc_include_token1] = ACTIONS(1980),
    [aux_sym_preproc_def_token1] = ACTIONS(1980),
    [aux_sym_preproc_if_token1] = ACTIONS(1980),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1980),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1980),
    [sym_preproc_directive] = ACTIONS(1980),
    [anon_sym_LPAREN2] = ACTIONS(1982),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_AMP_AMP] = ACTIONS(1982),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_SEMI] = ACTIONS(1982),
    [anon_sym___extension__] = ACTIONS(1980),
    [anon_sym_typedef] = ACTIONS(1980),
    [anon_sym___device__] = ACTIONS(1980),
    [anon_sym___host__] = ACTIONS(1980),
    [anon_sym___global__] = ACTIONS(1980),
    [anon_sym___forceinline__] = ACTIONS(1980),
    [anon_sym___noinline__] = ACTIONS(1980),
    [anon_sym_extern] = ACTIONS(1980),
    [anon_sym___attribute__] = ACTIONS(1980),
    [anon_sym_COLON_COLON] = ACTIONS(1982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1982),
    [anon_sym___declspec] = ACTIONS(1980),
    [anon_sym___based] = ACTIONS(1980),
    [anon_sym___cdecl] = ACTIONS(1980),
    [anon_sym___clrcall] = ACTIONS(1980),
    [anon_sym___stdcall] = ACTIONS(1980),
    [anon_sym___fastcall] = ACTIONS(1980),
    [anon_sym___thiscall] = ACTIONS(1980),
    [anon_sym___vectorcall] = ACTIONS(1980),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_signed] = ACTIONS(1980),
    [anon_sym_unsigned] = ACTIONS(1980),
    [anon_sym_long] = ACTIONS(1980),
    [anon_sym_short] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_static] = ACTIONS(1980),
    [anon_sym_register] = ACTIONS(1980),
    [anon_sym_inline] = ACTIONS(1980),
    [anon_sym___inline] = ACTIONS(1980),
    [anon_sym___inline__] = ACTIONS(1980),
    [anon_sym___forceinline] = ACTIONS(1980),
    [anon_sym_thread_local] = ACTIONS(1980),
    [anon_sym___thread] = ACTIONS(1980),
    [anon_sym_const] = ACTIONS(1980),
    [anon_sym_constexpr] = ACTIONS(1980),
    [anon_sym_volatile] = ACTIONS(1980),
    [anon_sym_restrict] = ACTIONS(1980),
    [anon_sym___restrict__] = ACTIONS(1980),
    [anon_sym__Atomic] = ACTIONS(1980),
    [anon_sym__Noreturn] = ACTIONS(1980),
    [anon_sym_noreturn] = ACTIONS(1980),
    [anon_sym_mutable] = ACTIONS(1980),
    [anon_sym_constinit] = ACTIONS(1980),
    [anon_sym_consteval] = ACTIONS(1980),
    [anon_sym___shared__] = ACTIONS(1980),
    [anon_sym___local__] = ACTIONS(1980),
    [anon_sym___constant__] = ACTIONS(1980),
    [anon_sym___managed__] = ACTIONS(1980),
    [anon_sym___grid_constant__] = ACTIONS(1980),
    [anon_sym_alignas] = ACTIONS(1980),
    [anon_sym__Alignas] = ACTIONS(1980),
    [sym_primitive_type] = ACTIONS(1980),
    [anon_sym_enum] = ACTIONS(1980),
    [anon_sym_class] = ACTIONS(1980),
    [anon_sym_struct] = ACTIONS(1980),
    [anon_sym_union] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_else] = ACTIONS(1980),
    [anon_sym_switch] = ACTIONS(1980),
    [anon_sym_case] = ACTIONS(1980),
    [anon_sym_default] = ACTIONS(1980),
    [anon_sym_while] = ACTIONS(1980),
    [anon_sym_do] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_return] = ACTIONS(1980),
    [anon_sym_break] = ACTIONS(1980),
    [anon_sym_continue] = ACTIONS(1980),
    [anon_sym_goto] = ACTIONS(1980),
    [anon_sym___try] = ACTIONS(1980),
    [anon_sym___leave] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_compl] = ACTIONS(1980),
    [anon_sym_DASH_DASH] = ACTIONS(1982),
    [anon_sym_PLUS_PLUS] = ACTIONS(1982),
    [anon_sym_sizeof] = ACTIONS(1980),
    [anon_sym___alignof__] = ACTIONS(1980),
    [anon_sym___alignof] = ACTIONS(1980),
    [anon_sym__alignof] = ACTIONS(1980),
    [anon_sym_alignof] = ACTIONS(1980),
    [anon_sym__Alignof] = ACTIONS(1980),
    [anon_sym_offsetof] = ACTIONS(1980),
    [anon_sym__Generic] = ACTIONS(1980),
    [anon_sym_asm] = ACTIONS(1980),
    [anon_sym___asm__] = ACTIONS(1980),
    [sym_number_literal] = ACTIONS(1982),
    [anon_sym_L_SQUOTE] = ACTIONS(1982),
    [anon_sym_u_SQUOTE] = ACTIONS(1982),
    [anon_sym_U_SQUOTE] = ACTIONS(1982),
    [anon_sym_u8_SQUOTE] = ACTIONS(1982),
    [anon_sym_SQUOTE] = ACTIONS(1982),
    [anon_sym_L_DQUOTE] = ACTIONS(1982),
    [anon_sym_u_DQUOTE] = ACTIONS(1982),
    [anon_sym_U_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8_DQUOTE] = ACTIONS(1982),
    [anon_sym_DQUOTE] = ACTIONS(1982),
    [sym_true] = ACTIONS(1980),
    [sym_false] = ACTIONS(1980),
    [anon_sym_NULL] = ACTIONS(1980),
    [anon_sym_nullptr] = ACTIONS(1980),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1980),
    [anon_sym_decltype] = ACTIONS(1980),
    [sym_virtual] = ACTIONS(1980),
    [anon_sym_explicit] = ACTIONS(1980),
    [anon_sym_typename] = ACTIONS(1980),
    [anon_sym_template] = ACTIONS(1980),
    [anon_sym_operator] = ACTIONS(1980),
    [anon_sym_try] = ACTIONS(1980),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_throw] = ACTIONS(1980),
    [anon_sym_namespace] = ACTIONS(1980),
    [anon_sym_using] = ACTIONS(1980),
    [anon_sym_static_assert] = ACTIONS(1980),
    [anon_sym_concept] = ACTIONS(1980),
    [anon_sym_co_return] = ACTIONS(1980),
    [anon_sym_co_yield] = ACTIONS(1980),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1980),
    [anon_sym_new] = ACTIONS(1980),
    [anon_sym_requires] = ACTIONS(1980),
    [sym_this] = ACTIONS(1980),
    [anon_sym___launch_bounds__] = ACTIONS(1980),
  },
  [423] = {
    [ts_builtin_sym_end] = ACTIONS(2002),
    [sym_identifier] = ACTIONS(2000),
    [aux_sym_preproc_include_token1] = ACTIONS(2000),
    [aux_sym_preproc_def_token1] = ACTIONS(2000),
    [aux_sym_preproc_if_token1] = ACTIONS(2000),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2000),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2000),
    [sym_preproc_directive] = ACTIONS(2000),
    [anon_sym_LPAREN2] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2002),
    [anon_sym_TILDE] = ACTIONS(2002),
    [anon_sym_DASH] = ACTIONS(2000),
    [anon_sym_PLUS] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(2002),
    [anon_sym_AMP_AMP] = ACTIONS(2002),
    [anon_sym_AMP] = ACTIONS(2000),
    [anon_sym_SEMI] = ACTIONS(2002),
    [anon_sym___extension__] = ACTIONS(2000),
    [anon_sym_typedef] = ACTIONS(2000),
    [anon_sym___device__] = ACTIONS(2000),
    [anon_sym___host__] = ACTIONS(2000),
    [anon_sym___global__] = ACTIONS(2000),
    [anon_sym___forceinline__] = ACTIONS(2000),
    [anon_sym___noinline__] = ACTIONS(2000),
    [anon_sym_extern] = ACTIONS(2000),
    [anon_sym___attribute__] = ACTIONS(2000),
    [anon_sym_COLON_COLON] = ACTIONS(2002),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2002),
    [anon_sym___declspec] = ACTIONS(2000),
    [anon_sym___based] = ACTIONS(2000),
    [anon_sym___cdecl] = ACTIONS(2000),
    [anon_sym___clrcall] = ACTIONS(2000),
    [anon_sym___stdcall] = ACTIONS(2000),
    [anon_sym___fastcall] = ACTIONS(2000),
    [anon_sym___thiscall] = ACTIONS(2000),
    [anon_sym___vectorcall] = ACTIONS(2000),
    [anon_sym_LBRACE] = ACTIONS(2002),
    [anon_sym_signed] = ACTIONS(2000),
    [anon_sym_unsigned] = ACTIONS(2000),
    [anon_sym_long] = ACTIONS(2000),
    [anon_sym_short] = ACTIONS(2000),
    [anon_sym_LBRACK] = ACTIONS(2000),
    [anon_sym_static] = ACTIONS(2000),
    [anon_sym_register] = ACTIONS(2000),
    [anon_sym_inline] = ACTIONS(2000),
    [anon_sym___inline] = ACTIONS(2000),
    [anon_sym___inline__] = ACTIONS(2000),
    [anon_sym___forceinline] = ACTIONS(2000),
    [anon_sym_thread_local] = ACTIONS(2000),
    [anon_sym___thread] = ACTIONS(2000),
    [anon_sym_const] = ACTIONS(2000),
    [anon_sym_constexpr] = ACTIONS(2000),
    [anon_sym_volatile] = ACTIONS(2000),
    [anon_sym_restrict] = ACTIONS(2000),
    [anon_sym___restrict__] = ACTIONS(2000),
    [anon_sym__Atomic] = ACTIONS(2000),
    [anon_sym__Noreturn] = ACTIONS(2000),
    [anon_sym_noreturn] = ACTIONS(2000),
    [anon_sym_mutable] = ACTIONS(2000),
    [anon_sym_constinit] = ACTIONS(2000),
    [anon_sym_consteval] = ACTIONS(2000),
    [anon_sym___shared__] = ACTIONS(2000),
    [anon_sym___local__] = ACTIONS(2000),
    [anon_sym___constant__] = ACTIONS(2000),
    [anon_sym___managed__] = ACTIONS(2000),
    [anon_sym___grid_constant__] = ACTIONS(2000),
    [anon_sym_alignas] = ACTIONS(2000),
    [anon_sym__Alignas] = ACTIONS(2000),
    [sym_primitive_type] = ACTIONS(2000),
    [anon_sym_enum] = ACTIONS(2000),
    [anon_sym_class] = ACTIONS(2000),
    [anon_sym_struct] = ACTIONS(2000),
    [anon_sym_union] = ACTIONS(2000),
    [anon_sym_if] = ACTIONS(2000),
    [anon_sym_else] = ACTIONS(2000),
    [anon_sym_switch] = ACTIONS(2000),
    [anon_sym_case] = ACTIONS(2000),
    [anon_sym_default] = ACTIONS(2000),
    [anon_sym_while] = ACTIONS(2000),
    [anon_sym_do] = ACTIONS(2000),
    [anon_sym_for] = ACTIONS(2000),
    [anon_sym_return] = ACTIONS(2000),
    [anon_sym_break] = ACTIONS(2000),
    [anon_sym_continue] = ACTIONS(2000),
    [anon_sym_goto] = ACTIONS(2000),
    [anon_sym___try] = ACTIONS(2000),
    [anon_sym___leave] = ACTIONS(2000),
    [anon_sym_not] = ACTIONS(2000),
    [anon_sym_compl] = ACTIONS(2000),
    [anon_sym_DASH_DASH] = ACTIONS(2002),
    [anon_sym_PLUS_PLUS] = ACTIONS(2002),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(2000),
    [anon_sym___alignof] = ACTIONS(2000),
    [anon_sym__alignof] = ACTIONS(2000),
    [anon_sym_alignof] = ACTIONS(2000),
    [anon_sym__Alignof] = ACTIONS(2000),
    [anon_sym_offsetof] = ACTIONS(2000),
    [anon_sym__Generic] = ACTIONS(2000),
    [anon_sym_asm] = ACTIONS(2000),
    [anon_sym___asm__] = ACTIONS(2000),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2002),
    [anon_sym_u_SQUOTE] = ACTIONS(2002),
    [anon_sym_U_SQUOTE] = ACTIONS(2002),
    [anon_sym_u8_SQUOTE] = ACTIONS(2002),
    [anon_sym_SQUOTE] = ACTIONS(2002),
    [anon_sym_L_DQUOTE] = ACTIONS(2002),
    [anon_sym_u_DQUOTE] = ACTIONS(2002),
    [anon_sym_U_DQUOTE] = ACTIONS(2002),
    [anon_sym_u8_DQUOTE] = ACTIONS(2002),
    [anon_sym_DQUOTE] = ACTIONS(2002),
    [sym_true] = ACTIONS(2000),
    [sym_false] = ACTIONS(2000),
    [anon_sym_NULL] = ACTIONS(2000),
    [anon_sym_nullptr] = ACTIONS(2000),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2000),
    [anon_sym_decltype] = ACTIONS(2000),
    [sym_virtual] = ACTIONS(2000),
    [anon_sym_explicit] = ACTIONS(2000),
    [anon_sym_typename] = ACTIONS(2000),
    [anon_sym_template] = ACTIONS(2000),
    [anon_sym_operator] = ACTIONS(2000),
    [anon_sym_try] = ACTIONS(2000),
    [anon_sym_delete] = ACTIONS(2000),
    [anon_sym_throw] = ACTIONS(2000),
    [anon_sym_namespace] = ACTIONS(2000),
    [anon_sym_using] = ACTIONS(2000),
    [anon_sym_static_assert] = ACTIONS(2000),
    [anon_sym_concept] = ACTIONS(2000),
    [anon_sym_co_return] = ACTIONS(2000),
    [anon_sym_co_yield] = ACTIONS(2000),
    [anon_sym_R_DQUOTE] = ACTIONS(2002),
    [anon_sym_LR_DQUOTE] = ACTIONS(2002),
    [anon_sym_uR_DQUOTE] = ACTIONS(2002),
    [anon_sym_UR_DQUOTE] = ACTIONS(2002),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2002),
    [anon_sym_co_await] = ACTIONS(2000),
    [anon_sym_new] = ACTIONS(2000),
    [anon_sym_requires] = ACTIONS(2000),
    [sym_this] = ACTIONS(2000),
    [anon_sym___launch_bounds__] = ACTIONS(2000),
  },
  [424] = {
    [sym_identifier] = ACTIONS(2060),
    [aux_sym_preproc_include_token1] = ACTIONS(2060),
    [aux_sym_preproc_def_token1] = ACTIONS(2060),
    [aux_sym_preproc_if_token1] = ACTIONS(2060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2060),
    [sym_preproc_directive] = ACTIONS(2060),
    [anon_sym_LPAREN2] = ACTIONS(2062),
    [anon_sym_BANG] = ACTIONS(2062),
    [anon_sym_TILDE] = ACTIONS(2062),
    [anon_sym_DASH] = ACTIONS(2060),
    [anon_sym_PLUS] = ACTIONS(2060),
    [anon_sym_STAR] = ACTIONS(2062),
    [anon_sym_AMP_AMP] = ACTIONS(2062),
    [anon_sym_AMP] = ACTIONS(2060),
    [anon_sym_SEMI] = ACTIONS(2062),
    [anon_sym___extension__] = ACTIONS(2060),
    [anon_sym_typedef] = ACTIONS(2060),
    [anon_sym___device__] = ACTIONS(2060),
    [anon_sym___host__] = ACTIONS(2060),
    [anon_sym___global__] = ACTIONS(2060),
    [anon_sym___forceinline__] = ACTIONS(2060),
    [anon_sym___noinline__] = ACTIONS(2060),
    [anon_sym_extern] = ACTIONS(2060),
    [anon_sym___attribute__] = ACTIONS(2060),
    [anon_sym_COLON_COLON] = ACTIONS(2062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2062),
    [anon_sym___declspec] = ACTIONS(2060),
    [anon_sym___based] = ACTIONS(2060),
    [anon_sym___cdecl] = ACTIONS(2060),
    [anon_sym___clrcall] = ACTIONS(2060),
    [anon_sym___stdcall] = ACTIONS(2060),
    [anon_sym___fastcall] = ACTIONS(2060),
    [anon_sym___thiscall] = ACTIONS(2060),
    [anon_sym___vectorcall] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(2062),
    [anon_sym_RBRACE] = ACTIONS(2062),
    [anon_sym_signed] = ACTIONS(2060),
    [anon_sym_unsigned] = ACTIONS(2060),
    [anon_sym_long] = ACTIONS(2060),
    [anon_sym_short] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2060),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_register] = ACTIONS(2060),
    [anon_sym_inline] = ACTIONS(2060),
    [anon_sym___inline] = ACTIONS(2060),
    [anon_sym___inline__] = ACTIONS(2060),
    [anon_sym___forceinline] = ACTIONS(2060),
    [anon_sym_thread_local] = ACTIONS(2060),
    [anon_sym___thread] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_constexpr] = ACTIONS(2060),
    [anon_sym_volatile] = ACTIONS(2060),
    [anon_sym_restrict] = ACTIONS(2060),
    [anon_sym___restrict__] = ACTIONS(2060),
    [anon_sym__Atomic] = ACTIONS(2060),
    [anon_sym__Noreturn] = ACTIONS(2060),
    [anon_sym_noreturn] = ACTIONS(2060),
    [anon_sym_mutable] = ACTIONS(2060),
    [anon_sym_constinit] = ACTIONS(2060),
    [anon_sym_consteval] = ACTIONS(2060),
    [anon_sym___shared__] = ACTIONS(2060),
    [anon_sym___local__] = ACTIONS(2060),
    [anon_sym___constant__] = ACTIONS(2060),
    [anon_sym___managed__] = ACTIONS(2060),
    [anon_sym___grid_constant__] = ACTIONS(2060),
    [anon_sym_alignas] = ACTIONS(2060),
    [anon_sym__Alignas] = ACTIONS(2060),
    [sym_primitive_type] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_struct] = ACTIONS(2060),
    [anon_sym_union] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_else] = ACTIONS(2060),
    [anon_sym_switch] = ACTIONS(2060),
    [anon_sym_case] = ACTIONS(2060),
    [anon_sym_default] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_do] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_goto] = ACTIONS(2060),
    [anon_sym___try] = ACTIONS(2060),
    [anon_sym___leave] = ACTIONS(2060),
    [anon_sym_not] = ACTIONS(2060),
    [anon_sym_compl] = ACTIONS(2060),
    [anon_sym_DASH_DASH] = ACTIONS(2062),
    [anon_sym_PLUS_PLUS] = ACTIONS(2062),
    [anon_sym_sizeof] = ACTIONS(2060),
    [anon_sym___alignof__] = ACTIONS(2060),
    [anon_sym___alignof] = ACTIONS(2060),
    [anon_sym__alignof] = ACTIONS(2060),
    [anon_sym_alignof] = ACTIONS(2060),
    [anon_sym__Alignof] = ACTIONS(2060),
    [anon_sym_offsetof] = ACTIONS(2060),
    [anon_sym__Generic] = ACTIONS(2060),
    [anon_sym_asm] = ACTIONS(2060),
    [anon_sym___asm__] = ACTIONS(2060),
    [sym_number_literal] = ACTIONS(2062),
    [anon_sym_L_SQUOTE] = ACTIONS(2062),
    [anon_sym_u_SQUOTE] = ACTIONS(2062),
    [anon_sym_U_SQUOTE] = ACTIONS(2062),
    [anon_sym_u8_SQUOTE] = ACTIONS(2062),
    [anon_sym_SQUOTE] = ACTIONS(2062),
    [anon_sym_L_DQUOTE] = ACTIONS(2062),
    [anon_sym_u_DQUOTE] = ACTIONS(2062),
    [anon_sym_U_DQUOTE] = ACTIONS(2062),
    [anon_sym_u8_DQUOTE] = ACTIONS(2062),
    [anon_sym_DQUOTE] = ACTIONS(2062),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [anon_sym_NULL] = ACTIONS(2060),
    [anon_sym_nullptr] = ACTIONS(2060),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2060),
    [anon_sym_decltype] = ACTIONS(2060),
    [sym_virtual] = ACTIONS(2060),
    [anon_sym_explicit] = ACTIONS(2060),
    [anon_sym_typename] = ACTIONS(2060),
    [anon_sym_template] = ACTIONS(2060),
    [anon_sym_operator] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [anon_sym_delete] = ACTIONS(2060),
    [anon_sym_throw] = ACTIONS(2060),
    [anon_sym_namespace] = ACTIONS(2060),
    [anon_sym_using] = ACTIONS(2060),
    [anon_sym_static_assert] = ACTIONS(2060),
    [anon_sym_concept] = ACTIONS(2060),
    [anon_sym_co_return] = ACTIONS(2060),
    [anon_sym_co_yield] = ACTIONS(2060),
    [anon_sym_R_DQUOTE] = ACTIONS(2062),
    [anon_sym_LR_DQUOTE] = ACTIONS(2062),
    [anon_sym_uR_DQUOTE] = ACTIONS(2062),
    [anon_sym_UR_DQUOTE] = ACTIONS(2062),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2062),
    [anon_sym_co_await] = ACTIONS(2060),
    [anon_sym_new] = ACTIONS(2060),
    [anon_sym_requires] = ACTIONS(2060),
    [sym_this] = ACTIONS(2060),
    [anon_sym___launch_bounds__] = ACTIONS(2060),
  },
  [425] = {
    [ts_builtin_sym_end] = ACTIONS(2070),
    [sym_identifier] = ACTIONS(2068),
    [aux_sym_preproc_include_token1] = ACTIONS(2068),
    [aux_sym_preproc_def_token1] = ACTIONS(2068),
    [aux_sym_preproc_if_token1] = ACTIONS(2068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2068),
    [sym_preproc_directive] = ACTIONS(2068),
    [anon_sym_LPAREN2] = ACTIONS(2070),
    [anon_sym_BANG] = ACTIONS(2070),
    [anon_sym_TILDE] = ACTIONS(2070),
    [anon_sym_DASH] = ACTIONS(2068),
    [anon_sym_PLUS] = ACTIONS(2068),
    [anon_sym_STAR] = ACTIONS(2070),
    [anon_sym_AMP_AMP] = ACTIONS(2070),
    [anon_sym_AMP] = ACTIONS(2068),
    [anon_sym_SEMI] = ACTIONS(2070),
    [anon_sym___extension__] = ACTIONS(2068),
    [anon_sym_typedef] = ACTIONS(2068),
    [anon_sym___device__] = ACTIONS(2068),
    [anon_sym___host__] = ACTIONS(2068),
    [anon_sym___global__] = ACTIONS(2068),
    [anon_sym___forceinline__] = ACTIONS(2068),
    [anon_sym___noinline__] = ACTIONS(2068),
    [anon_sym_extern] = ACTIONS(2068),
    [anon_sym___attribute__] = ACTIONS(2068),
    [anon_sym_COLON_COLON] = ACTIONS(2070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2070),
    [anon_sym___declspec] = ACTIONS(2068),
    [anon_sym___based] = ACTIONS(2068),
    [anon_sym___cdecl] = ACTIONS(2068),
    [anon_sym___clrcall] = ACTIONS(2068),
    [anon_sym___stdcall] = ACTIONS(2068),
    [anon_sym___fastcall] = ACTIONS(2068),
    [anon_sym___thiscall] = ACTIONS(2068),
    [anon_sym___vectorcall] = ACTIONS(2068),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_signed] = ACTIONS(2068),
    [anon_sym_unsigned] = ACTIONS(2068),
    [anon_sym_long] = ACTIONS(2068),
    [anon_sym_short] = ACTIONS(2068),
    [anon_sym_LBRACK] = ACTIONS(2068),
    [anon_sym_static] = ACTIONS(2068),
    [anon_sym_register] = ACTIONS(2068),
    [anon_sym_inline] = ACTIONS(2068),
    [anon_sym___inline] = ACTIONS(2068),
    [anon_sym___inline__] = ACTIONS(2068),
    [anon_sym___forceinline] = ACTIONS(2068),
    [anon_sym_thread_local] = ACTIONS(2068),
    [anon_sym___thread] = ACTIONS(2068),
    [anon_sym_const] = ACTIONS(2068),
    [anon_sym_constexpr] = ACTIONS(2068),
    [anon_sym_volatile] = ACTIONS(2068),
    [anon_sym_restrict] = ACTIONS(2068),
    [anon_sym___restrict__] = ACTIONS(2068),
    [anon_sym__Atomic] = ACTIONS(2068),
    [anon_sym__Noreturn] = ACTIONS(2068),
    [anon_sym_noreturn] = ACTIONS(2068),
    [anon_sym_mutable] = ACTIONS(2068),
    [anon_sym_constinit] = ACTIONS(2068),
    [anon_sym_consteval] = ACTIONS(2068),
    [anon_sym___shared__] = ACTIONS(2068),
    [anon_sym___local__] = ACTIONS(2068),
    [anon_sym___constant__] = ACTIONS(2068),
    [anon_sym___managed__] = ACTIONS(2068),
    [anon_sym___grid_constant__] = ACTIONS(2068),
    [anon_sym_alignas] = ACTIONS(2068),
    [anon_sym__Alignas] = ACTIONS(2068),
    [sym_primitive_type] = ACTIONS(2068),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2068),
    [anon_sym_struct] = ACTIONS(2068),
    [anon_sym_union] = ACTIONS(2068),
    [anon_sym_if] = ACTIONS(2068),
    [anon_sym_else] = ACTIONS(2068),
    [anon_sym_switch] = ACTIONS(2068),
    [anon_sym_case] = ACTIONS(2068),
    [anon_sym_default] = ACTIONS(2068),
    [anon_sym_while] = ACTIONS(2068),
    [anon_sym_do] = ACTIONS(2068),
    [anon_sym_for] = ACTIONS(2068),
    [anon_sym_return] = ACTIONS(2068),
    [anon_sym_break] = ACTIONS(2068),
    [anon_sym_continue] = ACTIONS(2068),
    [anon_sym_goto] = ACTIONS(2068),
    [anon_sym___try] = ACTIONS(2068),
    [anon_sym___leave] = ACTIONS(2068),
    [anon_sym_not] = ACTIONS(2068),
    [anon_sym_compl] = ACTIONS(2068),
    [anon_sym_DASH_DASH] = ACTIONS(2070),
    [anon_sym_PLUS_PLUS] = ACTIONS(2070),
    [anon_sym_sizeof] = ACTIONS(2068),
    [anon_sym___alignof__] = ACTIONS(2068),
    [anon_sym___alignof] = ACTIONS(2068),
    [anon_sym__alignof] = ACTIONS(2068),
    [anon_sym_alignof] = ACTIONS(2068),
    [anon_sym__Alignof] = ACTIONS(2068),
    [anon_sym_offsetof] = ACTIONS(2068),
    [anon_sym__Generic] = ACTIONS(2068),
    [anon_sym_asm] = ACTIONS(2068),
    [anon_sym___asm__] = ACTIONS(2068),
    [sym_number_literal] = ACTIONS(2070),
    [anon_sym_L_SQUOTE] = ACTIONS(2070),
    [anon_sym_u_SQUOTE] = ACTIONS(2070),
    [anon_sym_U_SQUOTE] = ACTIONS(2070),
    [anon_sym_u8_SQUOTE] = ACTIONS(2070),
    [anon_sym_SQUOTE] = ACTIONS(2070),
    [anon_sym_L_DQUOTE] = ACTIONS(2070),
    [anon_sym_u_DQUOTE] = ACTIONS(2070),
    [anon_sym_U_DQUOTE] = ACTIONS(2070),
    [anon_sym_u8_DQUOTE] = ACTIONS(2070),
    [anon_sym_DQUOTE] = ACTIONS(2070),
    [sym_true] = ACTIONS(2068),
    [sym_false] = ACTIONS(2068),
    [anon_sym_NULL] = ACTIONS(2068),
    [anon_sym_nullptr] = ACTIONS(2068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2068),
    [anon_sym_decltype] = ACTIONS(2068),
    [sym_virtual] = ACTIONS(2068),
    [anon_sym_explicit] = ACTIONS(2068),
    [anon_sym_typename] = ACTIONS(2068),
    [anon_sym_template] = ACTIONS(2068),
    [anon_sym_operator] = ACTIONS(2068),
    [anon_sym_try] = ACTIONS(2068),
    [anon_sym_delete] = ACTIONS(2068),
    [anon_sym_throw] = ACTIONS(2068),
    [anon_sym_namespace] = ACTIONS(2068),
    [anon_sym_using] = ACTIONS(2068),
    [anon_sym_static_assert] = ACTIONS(2068),
    [anon_sym_concept] = ACTIONS(2068),
    [anon_sym_co_return] = ACTIONS(2068),
    [anon_sym_co_yield] = ACTIONS(2068),
    [anon_sym_R_DQUOTE] = ACTIONS(2070),
    [anon_sym_LR_DQUOTE] = ACTIONS(2070),
    [anon_sym_uR_DQUOTE] = ACTIONS(2070),
    [anon_sym_UR_DQUOTE] = ACTIONS(2070),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2070),
    [anon_sym_co_await] = ACTIONS(2068),
    [anon_sym_new] = ACTIONS(2068),
    [anon_sym_requires] = ACTIONS(2068),
    [sym_this] = ACTIONS(2068),
    [anon_sym___launch_bounds__] = ACTIONS(2068),
  },
  [426] = {
    [ts_builtin_sym_end] = ACTIONS(1974),
    [sym_identifier] = ACTIONS(1972),
    [aux_sym_preproc_include_token1] = ACTIONS(1972),
    [aux_sym_preproc_def_token1] = ACTIONS(1972),
    [aux_sym_preproc_if_token1] = ACTIONS(1972),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1972),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1972),
    [sym_preproc_directive] = ACTIONS(1972),
    [anon_sym_LPAREN2] = ACTIONS(1974),
    [anon_sym_BANG] = ACTIONS(1974),
    [anon_sym_TILDE] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1972),
    [anon_sym_PLUS] = ACTIONS(1972),
    [anon_sym_STAR] = ACTIONS(1974),
    [anon_sym_AMP_AMP] = ACTIONS(1974),
    [anon_sym_AMP] = ACTIONS(1972),
    [anon_sym_SEMI] = ACTIONS(1974),
    [anon_sym___extension__] = ACTIONS(1972),
    [anon_sym_typedef] = ACTIONS(1972),
    [anon_sym___device__] = ACTIONS(1972),
    [anon_sym___host__] = ACTIONS(1972),
    [anon_sym___global__] = ACTIONS(1972),
    [anon_sym___forceinline__] = ACTIONS(1972),
    [anon_sym___noinline__] = ACTIONS(1972),
    [anon_sym_extern] = ACTIONS(1972),
    [anon_sym___attribute__] = ACTIONS(1972),
    [anon_sym_COLON_COLON] = ACTIONS(1974),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1974),
    [anon_sym___declspec] = ACTIONS(1972),
    [anon_sym___based] = ACTIONS(1972),
    [anon_sym___cdecl] = ACTIONS(1972),
    [anon_sym___clrcall] = ACTIONS(1972),
    [anon_sym___stdcall] = ACTIONS(1972),
    [anon_sym___fastcall] = ACTIONS(1972),
    [anon_sym___thiscall] = ACTIONS(1972),
    [anon_sym___vectorcall] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1974),
    [anon_sym_signed] = ACTIONS(1972),
    [anon_sym_unsigned] = ACTIONS(1972),
    [anon_sym_long] = ACTIONS(1972),
    [anon_sym_short] = ACTIONS(1972),
    [anon_sym_LBRACK] = ACTIONS(1972),
    [anon_sym_static] = ACTIONS(1972),
    [anon_sym_register] = ACTIONS(1972),
    [anon_sym_inline] = ACTIONS(1972),
    [anon_sym___inline] = ACTIONS(1972),
    [anon_sym___inline__] = ACTIONS(1972),
    [anon_sym___forceinline] = ACTIONS(1972),
    [anon_sym_thread_local] = ACTIONS(1972),
    [anon_sym___thread] = ACTIONS(1972),
    [anon_sym_const] = ACTIONS(1972),
    [anon_sym_constexpr] = ACTIONS(1972),
    [anon_sym_volatile] = ACTIONS(1972),
    [anon_sym_restrict] = ACTIONS(1972),
    [anon_sym___restrict__] = ACTIONS(1972),
    [anon_sym__Atomic] = ACTIONS(1972),
    [anon_sym__Noreturn] = ACTIONS(1972),
    [anon_sym_noreturn] = ACTIONS(1972),
    [anon_sym_mutable] = ACTIONS(1972),
    [anon_sym_constinit] = ACTIONS(1972),
    [anon_sym_consteval] = ACTIONS(1972),
    [anon_sym___shared__] = ACTIONS(1972),
    [anon_sym___local__] = ACTIONS(1972),
    [anon_sym___constant__] = ACTIONS(1972),
    [anon_sym___managed__] = ACTIONS(1972),
    [anon_sym___grid_constant__] = ACTIONS(1972),
    [anon_sym_alignas] = ACTIONS(1972),
    [anon_sym__Alignas] = ACTIONS(1972),
    [sym_primitive_type] = ACTIONS(1972),
    [anon_sym_enum] = ACTIONS(1972),
    [anon_sym_class] = ACTIONS(1972),
    [anon_sym_struct] = ACTIONS(1972),
    [anon_sym_union] = ACTIONS(1972),
    [anon_sym_if] = ACTIONS(1972),
    [anon_sym_else] = ACTIONS(1972),
    [anon_sym_switch] = ACTIONS(1972),
    [anon_sym_case] = ACTIONS(1972),
    [anon_sym_default] = ACTIONS(1972),
    [anon_sym_while] = ACTIONS(1972),
    [anon_sym_do] = ACTIONS(1972),
    [anon_sym_for] = ACTIONS(1972),
    [anon_sym_return] = ACTIONS(1972),
    [anon_sym_break] = ACTIONS(1972),
    [anon_sym_continue] = ACTIONS(1972),
    [anon_sym_goto] = ACTIONS(1972),
    [anon_sym___try] = ACTIONS(1972),
    [anon_sym___leave] = ACTIONS(1972),
    [anon_sym_not] = ACTIONS(1972),
    [anon_sym_compl] = ACTIONS(1972),
    [anon_sym_DASH_DASH] = ACTIONS(1974),
    [anon_sym_PLUS_PLUS] = ACTIONS(1974),
    [anon_sym_sizeof] = ACTIONS(1972),
    [anon_sym___alignof__] = ACTIONS(1972),
    [anon_sym___alignof] = ACTIONS(1972),
    [anon_sym__alignof] = ACTIONS(1972),
    [anon_sym_alignof] = ACTIONS(1972),
    [anon_sym__Alignof] = ACTIONS(1972),
    [anon_sym_offsetof] = ACTIONS(1972),
    [anon_sym__Generic] = ACTIONS(1972),
    [anon_sym_asm] = ACTIONS(1972),
    [anon_sym___asm__] = ACTIONS(1972),
    [sym_number_literal] = ACTIONS(1974),
    [anon_sym_L_SQUOTE] = ACTIONS(1974),
    [anon_sym_u_SQUOTE] = ACTIONS(1974),
    [anon_sym_U_SQUOTE] = ACTIONS(1974),
    [anon_sym_u8_SQUOTE] = ACTIONS(1974),
    [anon_sym_SQUOTE] = ACTIONS(1974),
    [anon_sym_L_DQUOTE] = ACTIONS(1974),
    [anon_sym_u_DQUOTE] = ACTIONS(1974),
    [anon_sym_U_DQUOTE] = ACTIONS(1974),
    [anon_sym_u8_DQUOTE] = ACTIONS(1974),
    [anon_sym_DQUOTE] = ACTIONS(1974),
    [sym_true] = ACTIONS(1972),
    [sym_false] = ACTIONS(1972),
    [anon_sym_NULL] = ACTIONS(1972),
    [anon_sym_nullptr] = ACTIONS(1972),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1972),
    [anon_sym_decltype] = ACTIONS(1972),
    [sym_virtual] = ACTIONS(1972),
    [anon_sym_explicit] = ACTIONS(1972),
    [anon_sym_typename] = ACTIONS(1972),
    [anon_sym_template] = ACTIONS(1972),
    [anon_sym_operator] = ACTIONS(1972),
    [anon_sym_try] = ACTIONS(1972),
    [anon_sym_delete] = ACTIONS(1972),
    [anon_sym_throw] = ACTIONS(1972),
    [anon_sym_namespace] = ACTIONS(1972),
    [anon_sym_using] = ACTIONS(1972),
    [anon_sym_static_assert] = ACTIONS(1972),
    [anon_sym_concept] = ACTIONS(1972),
    [anon_sym_co_return] = ACTIONS(1972),
    [anon_sym_co_yield] = ACTIONS(1972),
    [anon_sym_R_DQUOTE] = ACTIONS(1974),
    [anon_sym_LR_DQUOTE] = ACTIONS(1974),
    [anon_sym_uR_DQUOTE] = ACTIONS(1974),
    [anon_sym_UR_DQUOTE] = ACTIONS(1974),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1974),
    [anon_sym_co_await] = ACTIONS(1972),
    [anon_sym_new] = ACTIONS(1972),
    [anon_sym_requires] = ACTIONS(1972),
    [sym_this] = ACTIONS(1972),
    [anon_sym___launch_bounds__] = ACTIONS(1972),
  },
  [427] = {
    [sym_identifier] = ACTIONS(1958),
    [aux_sym_preproc_include_token1] = ACTIONS(1958),
    [aux_sym_preproc_def_token1] = ACTIONS(1958),
    [aux_sym_preproc_if_token1] = ACTIONS(1958),
    [aux_sym_preproc_if_token2] = ACTIONS(1958),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1958),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1958),
    [sym_preproc_directive] = ACTIONS(1958),
    [anon_sym_LPAREN2] = ACTIONS(1960),
    [anon_sym_BANG] = ACTIONS(1960),
    [anon_sym_TILDE] = ACTIONS(1960),
    [anon_sym_DASH] = ACTIONS(1958),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_STAR] = ACTIONS(1960),
    [anon_sym_AMP_AMP] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1958),
    [anon_sym_SEMI] = ACTIONS(1960),
    [anon_sym___extension__] = ACTIONS(1958),
    [anon_sym_typedef] = ACTIONS(1958),
    [anon_sym___device__] = ACTIONS(1958),
    [anon_sym___host__] = ACTIONS(1958),
    [anon_sym___global__] = ACTIONS(1958),
    [anon_sym___forceinline__] = ACTIONS(1958),
    [anon_sym___noinline__] = ACTIONS(1958),
    [anon_sym_extern] = ACTIONS(1958),
    [anon_sym___attribute__] = ACTIONS(1958),
    [anon_sym_COLON_COLON] = ACTIONS(1960),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1960),
    [anon_sym___declspec] = ACTIONS(1958),
    [anon_sym___based] = ACTIONS(1958),
    [anon_sym___cdecl] = ACTIONS(1958),
    [anon_sym___clrcall] = ACTIONS(1958),
    [anon_sym___stdcall] = ACTIONS(1958),
    [anon_sym___fastcall] = ACTIONS(1958),
    [anon_sym___thiscall] = ACTIONS(1958),
    [anon_sym___vectorcall] = ACTIONS(1958),
    [anon_sym_LBRACE] = ACTIONS(1960),
    [anon_sym_signed] = ACTIONS(1958),
    [anon_sym_unsigned] = ACTIONS(1958),
    [anon_sym_long] = ACTIONS(1958),
    [anon_sym_short] = ACTIONS(1958),
    [anon_sym_LBRACK] = ACTIONS(1958),
    [anon_sym_static] = ACTIONS(1958),
    [anon_sym_register] = ACTIONS(1958),
    [anon_sym_inline] = ACTIONS(1958),
    [anon_sym___inline] = ACTIONS(1958),
    [anon_sym___inline__] = ACTIONS(1958),
    [anon_sym___forceinline] = ACTIONS(1958),
    [anon_sym_thread_local] = ACTIONS(1958),
    [anon_sym___thread] = ACTIONS(1958),
    [anon_sym_const] = ACTIONS(1958),
    [anon_sym_constexpr] = ACTIONS(1958),
    [anon_sym_volatile] = ACTIONS(1958),
    [anon_sym_restrict] = ACTIONS(1958),
    [anon_sym___restrict__] = ACTIONS(1958),
    [anon_sym__Atomic] = ACTIONS(1958),
    [anon_sym__Noreturn] = ACTIONS(1958),
    [anon_sym_noreturn] = ACTIONS(1958),
    [anon_sym_mutable] = ACTIONS(1958),
    [anon_sym_constinit] = ACTIONS(1958),
    [anon_sym_consteval] = ACTIONS(1958),
    [anon_sym___shared__] = ACTIONS(1958),
    [anon_sym___local__] = ACTIONS(1958),
    [anon_sym___constant__] = ACTIONS(1958),
    [anon_sym___managed__] = ACTIONS(1958),
    [anon_sym___grid_constant__] = ACTIONS(1958),
    [anon_sym_alignas] = ACTIONS(1958),
    [anon_sym__Alignas] = ACTIONS(1958),
    [sym_primitive_type] = ACTIONS(1958),
    [anon_sym_enum] = ACTIONS(1958),
    [anon_sym_class] = ACTIONS(1958),
    [anon_sym_struct] = ACTIONS(1958),
    [anon_sym_union] = ACTIONS(1958),
    [anon_sym_if] = ACTIONS(1958),
    [anon_sym_else] = ACTIONS(1958),
    [anon_sym_switch] = ACTIONS(1958),
    [anon_sym_case] = ACTIONS(1958),
    [anon_sym_default] = ACTIONS(1958),
    [anon_sym_while] = ACTIONS(1958),
    [anon_sym_do] = ACTIONS(1958),
    [anon_sym_for] = ACTIONS(1958),
    [anon_sym_return] = ACTIONS(1958),
    [anon_sym_break] = ACTIONS(1958),
    [anon_sym_continue] = ACTIONS(1958),
    [anon_sym_goto] = ACTIONS(1958),
    [anon_sym___try] = ACTIONS(1958),
    [anon_sym___leave] = ACTIONS(1958),
    [anon_sym_not] = ACTIONS(1958),
    [anon_sym_compl] = ACTIONS(1958),
    [anon_sym_DASH_DASH] = ACTIONS(1960),
    [anon_sym_PLUS_PLUS] = ACTIONS(1960),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1958),
    [anon_sym___alignof] = ACTIONS(1958),
    [anon_sym__alignof] = ACTIONS(1958),
    [anon_sym_alignof] = ACTIONS(1958),
    [anon_sym__Alignof] = ACTIONS(1958),
    [anon_sym_offsetof] = ACTIONS(1958),
    [anon_sym__Generic] = ACTIONS(1958),
    [anon_sym_asm] = ACTIONS(1958),
    [anon_sym___asm__] = ACTIONS(1958),
    [sym_number_literal] = ACTIONS(1960),
    [anon_sym_L_SQUOTE] = ACTIONS(1960),
    [anon_sym_u_SQUOTE] = ACTIONS(1960),
    [anon_sym_U_SQUOTE] = ACTIONS(1960),
    [anon_sym_u8_SQUOTE] = ACTIONS(1960),
    [anon_sym_SQUOTE] = ACTIONS(1960),
    [anon_sym_L_DQUOTE] = ACTIONS(1960),
    [anon_sym_u_DQUOTE] = ACTIONS(1960),
    [anon_sym_U_DQUOTE] = ACTIONS(1960),
    [anon_sym_u8_DQUOTE] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [sym_true] = ACTIONS(1958),
    [sym_false] = ACTIONS(1958),
    [anon_sym_NULL] = ACTIONS(1958),
    [anon_sym_nullptr] = ACTIONS(1958),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1958),
    [anon_sym_decltype] = ACTIONS(1958),
    [sym_virtual] = ACTIONS(1958),
    [anon_sym_explicit] = ACTIONS(1958),
    [anon_sym_typename] = ACTIONS(1958),
    [anon_sym_template] = ACTIONS(1958),
    [anon_sym_operator] = ACTIONS(1958),
    [anon_sym_try] = ACTIONS(1958),
    [anon_sym_delete] = ACTIONS(1958),
    [anon_sym_throw] = ACTIONS(1958),
    [anon_sym_namespace] = ACTIONS(1958),
    [anon_sym_using] = ACTIONS(1958),
    [anon_sym_static_assert] = ACTIONS(1958),
    [anon_sym_concept] = ACTIONS(1958),
    [anon_sym_co_return] = ACTIONS(1958),
    [anon_sym_co_yield] = ACTIONS(1958),
    [anon_sym_R_DQUOTE] = ACTIONS(1960),
    [anon_sym_LR_DQUOTE] = ACTIONS(1960),
    [anon_sym_uR_DQUOTE] = ACTIONS(1960),
    [anon_sym_UR_DQUOTE] = ACTIONS(1960),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1960),
    [anon_sym_co_await] = ACTIONS(1958),
    [anon_sym_new] = ACTIONS(1958),
    [anon_sym_requires] = ACTIONS(1958),
    [sym_this] = ACTIONS(1958),
    [anon_sym___launch_bounds__] = ACTIONS(1958),
  },
  [428] = {
    [sym_identifier] = ACTIONS(2004),
    [aux_sym_preproc_include_token1] = ACTIONS(2004),
    [aux_sym_preproc_def_token1] = ACTIONS(2004),
    [aux_sym_preproc_if_token1] = ACTIONS(2004),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2004),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2004),
    [sym_preproc_directive] = ACTIONS(2004),
    [anon_sym_LPAREN2] = ACTIONS(2006),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(2006),
    [anon_sym_DASH] = ACTIONS(2004),
    [anon_sym_PLUS] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(2006),
    [anon_sym_AMP_AMP] = ACTIONS(2006),
    [anon_sym_AMP] = ACTIONS(2004),
    [anon_sym_SEMI] = ACTIONS(2006),
    [anon_sym___extension__] = ACTIONS(2004),
    [anon_sym_typedef] = ACTIONS(2004),
    [anon_sym___device__] = ACTIONS(2004),
    [anon_sym___host__] = ACTIONS(2004),
    [anon_sym___global__] = ACTIONS(2004),
    [anon_sym___forceinline__] = ACTIONS(2004),
    [anon_sym___noinline__] = ACTIONS(2004),
    [anon_sym_extern] = ACTIONS(2004),
    [anon_sym___attribute__] = ACTIONS(2004),
    [anon_sym_COLON_COLON] = ACTIONS(2006),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2006),
    [anon_sym___declspec] = ACTIONS(2004),
    [anon_sym___based] = ACTIONS(2004),
    [anon_sym___cdecl] = ACTIONS(2004),
    [anon_sym___clrcall] = ACTIONS(2004),
    [anon_sym___stdcall] = ACTIONS(2004),
    [anon_sym___fastcall] = ACTIONS(2004),
    [anon_sym___thiscall] = ACTIONS(2004),
    [anon_sym___vectorcall] = ACTIONS(2004),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_RBRACE] = ACTIONS(2006),
    [anon_sym_signed] = ACTIONS(2004),
    [anon_sym_unsigned] = ACTIONS(2004),
    [anon_sym_long] = ACTIONS(2004),
    [anon_sym_short] = ACTIONS(2004),
    [anon_sym_LBRACK] = ACTIONS(2004),
    [anon_sym_static] = ACTIONS(2004),
    [anon_sym_register] = ACTIONS(2004),
    [anon_sym_inline] = ACTIONS(2004),
    [anon_sym___inline] = ACTIONS(2004),
    [anon_sym___inline__] = ACTIONS(2004),
    [anon_sym___forceinline] = ACTIONS(2004),
    [anon_sym_thread_local] = ACTIONS(2004),
    [anon_sym___thread] = ACTIONS(2004),
    [anon_sym_const] = ACTIONS(2004),
    [anon_sym_constexpr] = ACTIONS(2004),
    [anon_sym_volatile] = ACTIONS(2004),
    [anon_sym_restrict] = ACTIONS(2004),
    [anon_sym___restrict__] = ACTIONS(2004),
    [anon_sym__Atomic] = ACTIONS(2004),
    [anon_sym__Noreturn] = ACTIONS(2004),
    [anon_sym_noreturn] = ACTIONS(2004),
    [anon_sym_mutable] = ACTIONS(2004),
    [anon_sym_constinit] = ACTIONS(2004),
    [anon_sym_consteval] = ACTIONS(2004),
    [anon_sym___shared__] = ACTIONS(2004),
    [anon_sym___local__] = ACTIONS(2004),
    [anon_sym___constant__] = ACTIONS(2004),
    [anon_sym___managed__] = ACTIONS(2004),
    [anon_sym___grid_constant__] = ACTIONS(2004),
    [anon_sym_alignas] = ACTIONS(2004),
    [anon_sym__Alignas] = ACTIONS(2004),
    [sym_primitive_type] = ACTIONS(2004),
    [anon_sym_enum] = ACTIONS(2004),
    [anon_sym_class] = ACTIONS(2004),
    [anon_sym_struct] = ACTIONS(2004),
    [anon_sym_union] = ACTIONS(2004),
    [anon_sym_if] = ACTIONS(2004),
    [anon_sym_else] = ACTIONS(2004),
    [anon_sym_switch] = ACTIONS(2004),
    [anon_sym_case] = ACTIONS(2004),
    [anon_sym_default] = ACTIONS(2004),
    [anon_sym_while] = ACTIONS(2004),
    [anon_sym_do] = ACTIONS(2004),
    [anon_sym_for] = ACTIONS(2004),
    [anon_sym_return] = ACTIONS(2004),
    [anon_sym_break] = ACTIONS(2004),
    [anon_sym_continue] = ACTIONS(2004),
    [anon_sym_goto] = ACTIONS(2004),
    [anon_sym___try] = ACTIONS(2004),
    [anon_sym___leave] = ACTIONS(2004),
    [anon_sym_not] = ACTIONS(2004),
    [anon_sym_compl] = ACTIONS(2004),
    [anon_sym_DASH_DASH] = ACTIONS(2006),
    [anon_sym_PLUS_PLUS] = ACTIONS(2006),
    [anon_sym_sizeof] = ACTIONS(2004),
    [anon_sym___alignof__] = ACTIONS(2004),
    [anon_sym___alignof] = ACTIONS(2004),
    [anon_sym__alignof] = ACTIONS(2004),
    [anon_sym_alignof] = ACTIONS(2004),
    [anon_sym__Alignof] = ACTIONS(2004),
    [anon_sym_offsetof] = ACTIONS(2004),
    [anon_sym__Generic] = ACTIONS(2004),
    [anon_sym_asm] = ACTIONS(2004),
    [anon_sym___asm__] = ACTIONS(2004),
    [sym_number_literal] = ACTIONS(2006),
    [anon_sym_L_SQUOTE] = ACTIONS(2006),
    [anon_sym_u_SQUOTE] = ACTIONS(2006),
    [anon_sym_U_SQUOTE] = ACTIONS(2006),
    [anon_sym_u8_SQUOTE] = ACTIONS(2006),
    [anon_sym_SQUOTE] = ACTIONS(2006),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(2004),
    [sym_false] = ACTIONS(2004),
    [anon_sym_NULL] = ACTIONS(2004),
    [anon_sym_nullptr] = ACTIONS(2004),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2004),
    [anon_sym_decltype] = ACTIONS(2004),
    [sym_virtual] = ACTIONS(2004),
    [anon_sym_explicit] = ACTIONS(2004),
    [anon_sym_typename] = ACTIONS(2004),
    [anon_sym_template] = ACTIONS(2004),
    [anon_sym_operator] = ACTIONS(2004),
    [anon_sym_try] = ACTIONS(2004),
    [anon_sym_delete] = ACTIONS(2004),
    [anon_sym_throw] = ACTIONS(2004),
    [anon_sym_namespace] = ACTIONS(2004),
    [anon_sym_using] = ACTIONS(2004),
    [anon_sym_static_assert] = ACTIONS(2004),
    [anon_sym_concept] = ACTIONS(2004),
    [anon_sym_co_return] = ACTIONS(2004),
    [anon_sym_co_yield] = ACTIONS(2004),
    [anon_sym_R_DQUOTE] = ACTIONS(2006),
    [anon_sym_LR_DQUOTE] = ACTIONS(2006),
    [anon_sym_uR_DQUOTE] = ACTIONS(2006),
    [anon_sym_UR_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2006),
    [anon_sym_co_await] = ACTIONS(2004),
    [anon_sym_new] = ACTIONS(2004),
    [anon_sym_requires] = ACTIONS(2004),
    [sym_this] = ACTIONS(2004),
    [anon_sym___launch_bounds__] = ACTIONS(2004),
  },
  [429] = {
    [sym_identifier] = ACTIONS(2068),
    [aux_sym_preproc_include_token1] = ACTIONS(2068),
    [aux_sym_preproc_def_token1] = ACTIONS(2068),
    [aux_sym_preproc_if_token1] = ACTIONS(2068),
    [aux_sym_preproc_if_token2] = ACTIONS(2068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2068),
    [sym_preproc_directive] = ACTIONS(2068),
    [anon_sym_LPAREN2] = ACTIONS(2070),
    [anon_sym_BANG] = ACTIONS(2070),
    [anon_sym_TILDE] = ACTIONS(2070),
    [anon_sym_DASH] = ACTIONS(2068),
    [anon_sym_PLUS] = ACTIONS(2068),
    [anon_sym_STAR] = ACTIONS(2070),
    [anon_sym_AMP_AMP] = ACTIONS(2070),
    [anon_sym_AMP] = ACTIONS(2068),
    [anon_sym_SEMI] = ACTIONS(2070),
    [anon_sym___extension__] = ACTIONS(2068),
    [anon_sym_typedef] = ACTIONS(2068),
    [anon_sym___device__] = ACTIONS(2068),
    [anon_sym___host__] = ACTIONS(2068),
    [anon_sym___global__] = ACTIONS(2068),
    [anon_sym___forceinline__] = ACTIONS(2068),
    [anon_sym___noinline__] = ACTIONS(2068),
    [anon_sym_extern] = ACTIONS(2068),
    [anon_sym___attribute__] = ACTIONS(2068),
    [anon_sym_COLON_COLON] = ACTIONS(2070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2070),
    [anon_sym___declspec] = ACTIONS(2068),
    [anon_sym___based] = ACTIONS(2068),
    [anon_sym___cdecl] = ACTIONS(2068),
    [anon_sym___clrcall] = ACTIONS(2068),
    [anon_sym___stdcall] = ACTIONS(2068),
    [anon_sym___fastcall] = ACTIONS(2068),
    [anon_sym___thiscall] = ACTIONS(2068),
    [anon_sym___vectorcall] = ACTIONS(2068),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_signed] = ACTIONS(2068),
    [anon_sym_unsigned] = ACTIONS(2068),
    [anon_sym_long] = ACTIONS(2068),
    [anon_sym_short] = ACTIONS(2068),
    [anon_sym_LBRACK] = ACTIONS(2068),
    [anon_sym_static] = ACTIONS(2068),
    [anon_sym_register] = ACTIONS(2068),
    [anon_sym_inline] = ACTIONS(2068),
    [anon_sym___inline] = ACTIONS(2068),
    [anon_sym___inline__] = ACTIONS(2068),
    [anon_sym___forceinline] = ACTIONS(2068),
    [anon_sym_thread_local] = ACTIONS(2068),
    [anon_sym___thread] = ACTIONS(2068),
    [anon_sym_const] = ACTIONS(2068),
    [anon_sym_constexpr] = ACTIONS(2068),
    [anon_sym_volatile] = ACTIONS(2068),
    [anon_sym_restrict] = ACTIONS(2068),
    [anon_sym___restrict__] = ACTIONS(2068),
    [anon_sym__Atomic] = ACTIONS(2068),
    [anon_sym__Noreturn] = ACTIONS(2068),
    [anon_sym_noreturn] = ACTIONS(2068),
    [anon_sym_mutable] = ACTIONS(2068),
    [anon_sym_constinit] = ACTIONS(2068),
    [anon_sym_consteval] = ACTIONS(2068),
    [anon_sym___shared__] = ACTIONS(2068),
    [anon_sym___local__] = ACTIONS(2068),
    [anon_sym___constant__] = ACTIONS(2068),
    [anon_sym___managed__] = ACTIONS(2068),
    [anon_sym___grid_constant__] = ACTIONS(2068),
    [anon_sym_alignas] = ACTIONS(2068),
    [anon_sym__Alignas] = ACTIONS(2068),
    [sym_primitive_type] = ACTIONS(2068),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2068),
    [anon_sym_struct] = ACTIONS(2068),
    [anon_sym_union] = ACTIONS(2068),
    [anon_sym_if] = ACTIONS(2068),
    [anon_sym_else] = ACTIONS(2068),
    [anon_sym_switch] = ACTIONS(2068),
    [anon_sym_case] = ACTIONS(2068),
    [anon_sym_default] = ACTIONS(2068),
    [anon_sym_while] = ACTIONS(2068),
    [anon_sym_do] = ACTIONS(2068),
    [anon_sym_for] = ACTIONS(2068),
    [anon_sym_return] = ACTIONS(2068),
    [anon_sym_break] = ACTIONS(2068),
    [anon_sym_continue] = ACTIONS(2068),
    [anon_sym_goto] = ACTIONS(2068),
    [anon_sym___try] = ACTIONS(2068),
    [anon_sym___leave] = ACTIONS(2068),
    [anon_sym_not] = ACTIONS(2068),
    [anon_sym_compl] = ACTIONS(2068),
    [anon_sym_DASH_DASH] = ACTIONS(2070),
    [anon_sym_PLUS_PLUS] = ACTIONS(2070),
    [anon_sym_sizeof] = ACTIONS(2068),
    [anon_sym___alignof__] = ACTIONS(2068),
    [anon_sym___alignof] = ACTIONS(2068),
    [anon_sym__alignof] = ACTIONS(2068),
    [anon_sym_alignof] = ACTIONS(2068),
    [anon_sym__Alignof] = ACTIONS(2068),
    [anon_sym_offsetof] = ACTIONS(2068),
    [anon_sym__Generic] = ACTIONS(2068),
    [anon_sym_asm] = ACTIONS(2068),
    [anon_sym___asm__] = ACTIONS(2068),
    [sym_number_literal] = ACTIONS(2070),
    [anon_sym_L_SQUOTE] = ACTIONS(2070),
    [anon_sym_u_SQUOTE] = ACTIONS(2070),
    [anon_sym_U_SQUOTE] = ACTIONS(2070),
    [anon_sym_u8_SQUOTE] = ACTIONS(2070),
    [anon_sym_SQUOTE] = ACTIONS(2070),
    [anon_sym_L_DQUOTE] = ACTIONS(2070),
    [anon_sym_u_DQUOTE] = ACTIONS(2070),
    [anon_sym_U_DQUOTE] = ACTIONS(2070),
    [anon_sym_u8_DQUOTE] = ACTIONS(2070),
    [anon_sym_DQUOTE] = ACTIONS(2070),
    [sym_true] = ACTIONS(2068),
    [sym_false] = ACTIONS(2068),
    [anon_sym_NULL] = ACTIONS(2068),
    [anon_sym_nullptr] = ACTIONS(2068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2068),
    [anon_sym_decltype] = ACTIONS(2068),
    [sym_virtual] = ACTIONS(2068),
    [anon_sym_explicit] = ACTIONS(2068),
    [anon_sym_typename] = ACTIONS(2068),
    [anon_sym_template] = ACTIONS(2068),
    [anon_sym_operator] = ACTIONS(2068),
    [anon_sym_try] = ACTIONS(2068),
    [anon_sym_delete] = ACTIONS(2068),
    [anon_sym_throw] = ACTIONS(2068),
    [anon_sym_namespace] = ACTIONS(2068),
    [anon_sym_using] = ACTIONS(2068),
    [anon_sym_static_assert] = ACTIONS(2068),
    [anon_sym_concept] = ACTIONS(2068),
    [anon_sym_co_return] = ACTIONS(2068),
    [anon_sym_co_yield] = ACTIONS(2068),
    [anon_sym_R_DQUOTE] = ACTIONS(2070),
    [anon_sym_LR_DQUOTE] = ACTIONS(2070),
    [anon_sym_uR_DQUOTE] = ACTIONS(2070),
    [anon_sym_UR_DQUOTE] = ACTIONS(2070),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2070),
    [anon_sym_co_await] = ACTIONS(2068),
    [anon_sym_new] = ACTIONS(2068),
    [anon_sym_requires] = ACTIONS(2068),
    [sym_this] = ACTIONS(2068),
    [anon_sym___launch_bounds__] = ACTIONS(2068),
  },
  [430] = {
    [ts_builtin_sym_end] = ACTIONS(1970),
    [sym_identifier] = ACTIONS(1968),
    [aux_sym_preproc_include_token1] = ACTIONS(1968),
    [aux_sym_preproc_def_token1] = ACTIONS(1968),
    [aux_sym_preproc_if_token1] = ACTIONS(1968),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1968),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1968),
    [sym_preproc_directive] = ACTIONS(1968),
    [anon_sym_LPAREN2] = ACTIONS(1970),
    [anon_sym_BANG] = ACTIONS(1970),
    [anon_sym_TILDE] = ACTIONS(1970),
    [anon_sym_DASH] = ACTIONS(1968),
    [anon_sym_PLUS] = ACTIONS(1968),
    [anon_sym_STAR] = ACTIONS(1970),
    [anon_sym_AMP_AMP] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(1968),
    [anon_sym_SEMI] = ACTIONS(1970),
    [anon_sym___extension__] = ACTIONS(1968),
    [anon_sym_typedef] = ACTIONS(1968),
    [anon_sym___device__] = ACTIONS(1968),
    [anon_sym___host__] = ACTIONS(1968),
    [anon_sym___global__] = ACTIONS(1968),
    [anon_sym___forceinline__] = ACTIONS(1968),
    [anon_sym___noinline__] = ACTIONS(1968),
    [anon_sym_extern] = ACTIONS(1968),
    [anon_sym___attribute__] = ACTIONS(1968),
    [anon_sym_COLON_COLON] = ACTIONS(1970),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1970),
    [anon_sym___declspec] = ACTIONS(1968),
    [anon_sym___based] = ACTIONS(1968),
    [anon_sym___cdecl] = ACTIONS(1968),
    [anon_sym___clrcall] = ACTIONS(1968),
    [anon_sym___stdcall] = ACTIONS(1968),
    [anon_sym___fastcall] = ACTIONS(1968),
    [anon_sym___thiscall] = ACTIONS(1968),
    [anon_sym___vectorcall] = ACTIONS(1968),
    [anon_sym_LBRACE] = ACTIONS(1970),
    [anon_sym_signed] = ACTIONS(1968),
    [anon_sym_unsigned] = ACTIONS(1968),
    [anon_sym_long] = ACTIONS(1968),
    [anon_sym_short] = ACTIONS(1968),
    [anon_sym_LBRACK] = ACTIONS(1968),
    [anon_sym_static] = ACTIONS(1968),
    [anon_sym_register] = ACTIONS(1968),
    [anon_sym_inline] = ACTIONS(1968),
    [anon_sym___inline] = ACTIONS(1968),
    [anon_sym___inline__] = ACTIONS(1968),
    [anon_sym___forceinline] = ACTIONS(1968),
    [anon_sym_thread_local] = ACTIONS(1968),
    [anon_sym___thread] = ACTIONS(1968),
    [anon_sym_const] = ACTIONS(1968),
    [anon_sym_constexpr] = ACTIONS(1968),
    [anon_sym_volatile] = ACTIONS(1968),
    [anon_sym_restrict] = ACTIONS(1968),
    [anon_sym___restrict__] = ACTIONS(1968),
    [anon_sym__Atomic] = ACTIONS(1968),
    [anon_sym__Noreturn] = ACTIONS(1968),
    [anon_sym_noreturn] = ACTIONS(1968),
    [anon_sym_mutable] = ACTIONS(1968),
    [anon_sym_constinit] = ACTIONS(1968),
    [anon_sym_consteval] = ACTIONS(1968),
    [anon_sym___shared__] = ACTIONS(1968),
    [anon_sym___local__] = ACTIONS(1968),
    [anon_sym___constant__] = ACTIONS(1968),
    [anon_sym___managed__] = ACTIONS(1968),
    [anon_sym___grid_constant__] = ACTIONS(1968),
    [anon_sym_alignas] = ACTIONS(1968),
    [anon_sym__Alignas] = ACTIONS(1968),
    [sym_primitive_type] = ACTIONS(1968),
    [anon_sym_enum] = ACTIONS(1968),
    [anon_sym_class] = ACTIONS(1968),
    [anon_sym_struct] = ACTIONS(1968),
    [anon_sym_union] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_else] = ACTIONS(1968),
    [anon_sym_switch] = ACTIONS(1968),
    [anon_sym_case] = ACTIONS(1968),
    [anon_sym_default] = ACTIONS(1968),
    [anon_sym_while] = ACTIONS(1968),
    [anon_sym_do] = ACTIONS(1968),
    [anon_sym_for] = ACTIONS(1968),
    [anon_sym_return] = ACTIONS(1968),
    [anon_sym_break] = ACTIONS(1968),
    [anon_sym_continue] = ACTIONS(1968),
    [anon_sym_goto] = ACTIONS(1968),
    [anon_sym___try] = ACTIONS(1968),
    [anon_sym___leave] = ACTIONS(1968),
    [anon_sym_not] = ACTIONS(1968),
    [anon_sym_compl] = ACTIONS(1968),
    [anon_sym_DASH_DASH] = ACTIONS(1970),
    [anon_sym_PLUS_PLUS] = ACTIONS(1970),
    [anon_sym_sizeof] = ACTIONS(1968),
    [anon_sym___alignof__] = ACTIONS(1968),
    [anon_sym___alignof] = ACTIONS(1968),
    [anon_sym__alignof] = ACTIONS(1968),
    [anon_sym_alignof] = ACTIONS(1968),
    [anon_sym__Alignof] = ACTIONS(1968),
    [anon_sym_offsetof] = ACTIONS(1968),
    [anon_sym__Generic] = ACTIONS(1968),
    [anon_sym_asm] = ACTIONS(1968),
    [anon_sym___asm__] = ACTIONS(1968),
    [sym_number_literal] = ACTIONS(1970),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1970),
    [anon_sym_u_DQUOTE] = ACTIONS(1970),
    [anon_sym_U_DQUOTE] = ACTIONS(1970),
    [anon_sym_u8_DQUOTE] = ACTIONS(1970),
    [anon_sym_DQUOTE] = ACTIONS(1970),
    [sym_true] = ACTIONS(1968),
    [sym_false] = ACTIONS(1968),
    [anon_sym_NULL] = ACTIONS(1968),
    [anon_sym_nullptr] = ACTIONS(1968),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1968),
    [anon_sym_decltype] = ACTIONS(1968),
    [sym_virtual] = ACTIONS(1968),
    [anon_sym_explicit] = ACTIONS(1968),
    [anon_sym_typename] = ACTIONS(1968),
    [anon_sym_template] = ACTIONS(1968),
    [anon_sym_operator] = ACTIONS(1968),
    [anon_sym_try] = ACTIONS(1968),
    [anon_sym_delete] = ACTIONS(1968),
    [anon_sym_throw] = ACTIONS(1968),
    [anon_sym_namespace] = ACTIONS(1968),
    [anon_sym_using] = ACTIONS(1968),
    [anon_sym_static_assert] = ACTIONS(1968),
    [anon_sym_concept] = ACTIONS(1968),
    [anon_sym_co_return] = ACTIONS(1968),
    [anon_sym_co_yield] = ACTIONS(1968),
    [anon_sym_R_DQUOTE] = ACTIONS(1970),
    [anon_sym_LR_DQUOTE] = ACTIONS(1970),
    [anon_sym_uR_DQUOTE] = ACTIONS(1970),
    [anon_sym_UR_DQUOTE] = ACTIONS(1970),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1970),
    [anon_sym_co_await] = ACTIONS(1968),
    [anon_sym_new] = ACTIONS(1968),
    [anon_sym_requires] = ACTIONS(1968),
    [sym_this] = ACTIONS(1968),
    [anon_sym___launch_bounds__] = ACTIONS(1968),
  },
  [431] = {
    [sym_identifier] = ACTIONS(1980),
    [aux_sym_preproc_include_token1] = ACTIONS(1980),
    [aux_sym_preproc_def_token1] = ACTIONS(1980),
    [aux_sym_preproc_if_token1] = ACTIONS(1980),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1980),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1980),
    [sym_preproc_directive] = ACTIONS(1980),
    [anon_sym_LPAREN2] = ACTIONS(1982),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_AMP_AMP] = ACTIONS(1982),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_SEMI] = ACTIONS(1982),
    [anon_sym___extension__] = ACTIONS(1980),
    [anon_sym_typedef] = ACTIONS(1980),
    [anon_sym___device__] = ACTIONS(1980),
    [anon_sym___host__] = ACTIONS(1980),
    [anon_sym___global__] = ACTIONS(1980),
    [anon_sym___forceinline__] = ACTIONS(1980),
    [anon_sym___noinline__] = ACTIONS(1980),
    [anon_sym_extern] = ACTIONS(1980),
    [anon_sym___attribute__] = ACTIONS(1980),
    [anon_sym_COLON_COLON] = ACTIONS(1982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1982),
    [anon_sym___declspec] = ACTIONS(1980),
    [anon_sym___based] = ACTIONS(1980),
    [anon_sym___cdecl] = ACTIONS(1980),
    [anon_sym___clrcall] = ACTIONS(1980),
    [anon_sym___stdcall] = ACTIONS(1980),
    [anon_sym___fastcall] = ACTIONS(1980),
    [anon_sym___thiscall] = ACTIONS(1980),
    [anon_sym___vectorcall] = ACTIONS(1980),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_RBRACE] = ACTIONS(1982),
    [anon_sym_signed] = ACTIONS(1980),
    [anon_sym_unsigned] = ACTIONS(1980),
    [anon_sym_long] = ACTIONS(1980),
    [anon_sym_short] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_static] = ACTIONS(1980),
    [anon_sym_register] = ACTIONS(1980),
    [anon_sym_inline] = ACTIONS(1980),
    [anon_sym___inline] = ACTIONS(1980),
    [anon_sym___inline__] = ACTIONS(1980),
    [anon_sym___forceinline] = ACTIONS(1980),
    [anon_sym_thread_local] = ACTIONS(1980),
    [anon_sym___thread] = ACTIONS(1980),
    [anon_sym_const] = ACTIONS(1980),
    [anon_sym_constexpr] = ACTIONS(1980),
    [anon_sym_volatile] = ACTIONS(1980),
    [anon_sym_restrict] = ACTIONS(1980),
    [anon_sym___restrict__] = ACTIONS(1980),
    [anon_sym__Atomic] = ACTIONS(1980),
    [anon_sym__Noreturn] = ACTIONS(1980),
    [anon_sym_noreturn] = ACTIONS(1980),
    [anon_sym_mutable] = ACTIONS(1980),
    [anon_sym_constinit] = ACTIONS(1980),
    [anon_sym_consteval] = ACTIONS(1980),
    [anon_sym___shared__] = ACTIONS(1980),
    [anon_sym___local__] = ACTIONS(1980),
    [anon_sym___constant__] = ACTIONS(1980),
    [anon_sym___managed__] = ACTIONS(1980),
    [anon_sym___grid_constant__] = ACTIONS(1980),
    [anon_sym_alignas] = ACTIONS(1980),
    [anon_sym__Alignas] = ACTIONS(1980),
    [sym_primitive_type] = ACTIONS(1980),
    [anon_sym_enum] = ACTIONS(1980),
    [anon_sym_class] = ACTIONS(1980),
    [anon_sym_struct] = ACTIONS(1980),
    [anon_sym_union] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_else] = ACTIONS(1980),
    [anon_sym_switch] = ACTIONS(1980),
    [anon_sym_case] = ACTIONS(1980),
    [anon_sym_default] = ACTIONS(1980),
    [anon_sym_while] = ACTIONS(1980),
    [anon_sym_do] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_return] = ACTIONS(1980),
    [anon_sym_break] = ACTIONS(1980),
    [anon_sym_continue] = ACTIONS(1980),
    [anon_sym_goto] = ACTIONS(1980),
    [anon_sym___try] = ACTIONS(1980),
    [anon_sym___leave] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_compl] = ACTIONS(1980),
    [anon_sym_DASH_DASH] = ACTIONS(1982),
    [anon_sym_PLUS_PLUS] = ACTIONS(1982),
    [anon_sym_sizeof] = ACTIONS(1980),
    [anon_sym___alignof__] = ACTIONS(1980),
    [anon_sym___alignof] = ACTIONS(1980),
    [anon_sym__alignof] = ACTIONS(1980),
    [anon_sym_alignof] = ACTIONS(1980),
    [anon_sym__Alignof] = ACTIONS(1980),
    [anon_sym_offsetof] = ACTIONS(1980),
    [anon_sym__Generic] = ACTIONS(1980),
    [anon_sym_asm] = ACTIONS(1980),
    [anon_sym___asm__] = ACTIONS(1980),
    [sym_number_literal] = ACTIONS(1982),
    [anon_sym_L_SQUOTE] = ACTIONS(1982),
    [anon_sym_u_SQUOTE] = ACTIONS(1982),
    [anon_sym_U_SQUOTE] = ACTIONS(1982),
    [anon_sym_u8_SQUOTE] = ACTIONS(1982),
    [anon_sym_SQUOTE] = ACTIONS(1982),
    [anon_sym_L_DQUOTE] = ACTIONS(1982),
    [anon_sym_u_DQUOTE] = ACTIONS(1982),
    [anon_sym_U_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8_DQUOTE] = ACTIONS(1982),
    [anon_sym_DQUOTE] = ACTIONS(1982),
    [sym_true] = ACTIONS(1980),
    [sym_false] = ACTIONS(1980),
    [anon_sym_NULL] = ACTIONS(1980),
    [anon_sym_nullptr] = ACTIONS(1980),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1980),
    [anon_sym_decltype] = ACTIONS(1980),
    [sym_virtual] = ACTIONS(1980),
    [anon_sym_explicit] = ACTIONS(1980),
    [anon_sym_typename] = ACTIONS(1980),
    [anon_sym_template] = ACTIONS(1980),
    [anon_sym_operator] = ACTIONS(1980),
    [anon_sym_try] = ACTIONS(1980),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_throw] = ACTIONS(1980),
    [anon_sym_namespace] = ACTIONS(1980),
    [anon_sym_using] = ACTIONS(1980),
    [anon_sym_static_assert] = ACTIONS(1980),
    [anon_sym_concept] = ACTIONS(1980),
    [anon_sym_co_return] = ACTIONS(1980),
    [anon_sym_co_yield] = ACTIONS(1980),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1980),
    [anon_sym_new] = ACTIONS(1980),
    [anon_sym_requires] = ACTIONS(1980),
    [sym_this] = ACTIONS(1980),
    [anon_sym___launch_bounds__] = ACTIONS(1980),
  },
  [432] = {
    [sym_identifier] = ACTIONS(2052),
    [aux_sym_preproc_include_token1] = ACTIONS(2052),
    [aux_sym_preproc_def_token1] = ACTIONS(2052),
    [aux_sym_preproc_if_token1] = ACTIONS(2052),
    [aux_sym_preproc_if_token2] = ACTIONS(2052),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2052),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2052),
    [sym_preproc_directive] = ACTIONS(2052),
    [anon_sym_LPAREN2] = ACTIONS(2054),
    [anon_sym_BANG] = ACTIONS(2054),
    [anon_sym_TILDE] = ACTIONS(2054),
    [anon_sym_DASH] = ACTIONS(2052),
    [anon_sym_PLUS] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(2054),
    [anon_sym_AMP_AMP] = ACTIONS(2054),
    [anon_sym_AMP] = ACTIONS(2052),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym___extension__] = ACTIONS(2052),
    [anon_sym_typedef] = ACTIONS(2052),
    [anon_sym___device__] = ACTIONS(2052),
    [anon_sym___host__] = ACTIONS(2052),
    [anon_sym___global__] = ACTIONS(2052),
    [anon_sym___forceinline__] = ACTIONS(2052),
    [anon_sym___noinline__] = ACTIONS(2052),
    [anon_sym_extern] = ACTIONS(2052),
    [anon_sym___attribute__] = ACTIONS(2052),
    [anon_sym_COLON_COLON] = ACTIONS(2054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2054),
    [anon_sym___declspec] = ACTIONS(2052),
    [anon_sym___based] = ACTIONS(2052),
    [anon_sym___cdecl] = ACTIONS(2052),
    [anon_sym___clrcall] = ACTIONS(2052),
    [anon_sym___stdcall] = ACTIONS(2052),
    [anon_sym___fastcall] = ACTIONS(2052),
    [anon_sym___thiscall] = ACTIONS(2052),
    [anon_sym___vectorcall] = ACTIONS(2052),
    [anon_sym_LBRACE] = ACTIONS(2054),
    [anon_sym_signed] = ACTIONS(2052),
    [anon_sym_unsigned] = ACTIONS(2052),
    [anon_sym_long] = ACTIONS(2052),
    [anon_sym_short] = ACTIONS(2052),
    [anon_sym_LBRACK] = ACTIONS(2052),
    [anon_sym_static] = ACTIONS(2052),
    [anon_sym_register] = ACTIONS(2052),
    [anon_sym_inline] = ACTIONS(2052),
    [anon_sym___inline] = ACTIONS(2052),
    [anon_sym___inline__] = ACTIONS(2052),
    [anon_sym___forceinline] = ACTIONS(2052),
    [anon_sym_thread_local] = ACTIONS(2052),
    [anon_sym___thread] = ACTIONS(2052),
    [anon_sym_const] = ACTIONS(2052),
    [anon_sym_constexpr] = ACTIONS(2052),
    [anon_sym_volatile] = ACTIONS(2052),
    [anon_sym_restrict] = ACTIONS(2052),
    [anon_sym___restrict__] = ACTIONS(2052),
    [anon_sym__Atomic] = ACTIONS(2052),
    [anon_sym__Noreturn] = ACTIONS(2052),
    [anon_sym_noreturn] = ACTIONS(2052),
    [anon_sym_mutable] = ACTIONS(2052),
    [anon_sym_constinit] = ACTIONS(2052),
    [anon_sym_consteval] = ACTIONS(2052),
    [anon_sym___shared__] = ACTIONS(2052),
    [anon_sym___local__] = ACTIONS(2052),
    [anon_sym___constant__] = ACTIONS(2052),
    [anon_sym___managed__] = ACTIONS(2052),
    [anon_sym___grid_constant__] = ACTIONS(2052),
    [anon_sym_alignas] = ACTIONS(2052),
    [anon_sym__Alignas] = ACTIONS(2052),
    [sym_primitive_type] = ACTIONS(2052),
    [anon_sym_enum] = ACTIONS(2052),
    [anon_sym_class] = ACTIONS(2052),
    [anon_sym_struct] = ACTIONS(2052),
    [anon_sym_union] = ACTIONS(2052),
    [anon_sym_if] = ACTIONS(2052),
    [anon_sym_else] = ACTIONS(2052),
    [anon_sym_switch] = ACTIONS(2052),
    [anon_sym_case] = ACTIONS(2052),
    [anon_sym_default] = ACTIONS(2052),
    [anon_sym_while] = ACTIONS(2052),
    [anon_sym_do] = ACTIONS(2052),
    [anon_sym_for] = ACTIONS(2052),
    [anon_sym_return] = ACTIONS(2052),
    [anon_sym_break] = ACTIONS(2052),
    [anon_sym_continue] = ACTIONS(2052),
    [anon_sym_goto] = ACTIONS(2052),
    [anon_sym___try] = ACTIONS(2052),
    [anon_sym___leave] = ACTIONS(2052),
    [anon_sym_not] = ACTIONS(2052),
    [anon_sym_compl] = ACTIONS(2052),
    [anon_sym_DASH_DASH] = ACTIONS(2054),
    [anon_sym_PLUS_PLUS] = ACTIONS(2054),
    [anon_sym_sizeof] = ACTIONS(2052),
    [anon_sym___alignof__] = ACTIONS(2052),
    [anon_sym___alignof] = ACTIONS(2052),
    [anon_sym__alignof] = ACTIONS(2052),
    [anon_sym_alignof] = ACTIONS(2052),
    [anon_sym__Alignof] = ACTIONS(2052),
    [anon_sym_offsetof] = ACTIONS(2052),
    [anon_sym__Generic] = ACTIONS(2052),
    [anon_sym_asm] = ACTIONS(2052),
    [anon_sym___asm__] = ACTIONS(2052),
    [sym_number_literal] = ACTIONS(2054),
    [anon_sym_L_SQUOTE] = ACTIONS(2054),
    [anon_sym_u_SQUOTE] = ACTIONS(2054),
    [anon_sym_U_SQUOTE] = ACTIONS(2054),
    [anon_sym_u8_SQUOTE] = ACTIONS(2054),
    [anon_sym_SQUOTE] = ACTIONS(2054),
    [anon_sym_L_DQUOTE] = ACTIONS(2054),
    [anon_sym_u_DQUOTE] = ACTIONS(2054),
    [anon_sym_U_DQUOTE] = ACTIONS(2054),
    [anon_sym_u8_DQUOTE] = ACTIONS(2054),
    [anon_sym_DQUOTE] = ACTIONS(2054),
    [sym_true] = ACTIONS(2052),
    [sym_false] = ACTIONS(2052),
    [anon_sym_NULL] = ACTIONS(2052),
    [anon_sym_nullptr] = ACTIONS(2052),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2052),
    [anon_sym_decltype] = ACTIONS(2052),
    [sym_virtual] = ACTIONS(2052),
    [anon_sym_explicit] = ACTIONS(2052),
    [anon_sym_typename] = ACTIONS(2052),
    [anon_sym_template] = ACTIONS(2052),
    [anon_sym_operator] = ACTIONS(2052),
    [anon_sym_try] = ACTIONS(2052),
    [anon_sym_delete] = ACTIONS(2052),
    [anon_sym_throw] = ACTIONS(2052),
    [anon_sym_namespace] = ACTIONS(2052),
    [anon_sym_using] = ACTIONS(2052),
    [anon_sym_static_assert] = ACTIONS(2052),
    [anon_sym_concept] = ACTIONS(2052),
    [anon_sym_co_return] = ACTIONS(2052),
    [anon_sym_co_yield] = ACTIONS(2052),
    [anon_sym_R_DQUOTE] = ACTIONS(2054),
    [anon_sym_LR_DQUOTE] = ACTIONS(2054),
    [anon_sym_uR_DQUOTE] = ACTIONS(2054),
    [anon_sym_UR_DQUOTE] = ACTIONS(2054),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2054),
    [anon_sym_co_await] = ACTIONS(2052),
    [anon_sym_new] = ACTIONS(2052),
    [anon_sym_requires] = ACTIONS(2052),
    [sym_this] = ACTIONS(2052),
    [anon_sym___launch_bounds__] = ACTIONS(2052),
  },
  [433] = {
    [sym_identifier] = ACTIONS(2040),
    [aux_sym_preproc_include_token1] = ACTIONS(2040),
    [aux_sym_preproc_def_token1] = ACTIONS(2040),
    [aux_sym_preproc_if_token1] = ACTIONS(2040),
    [aux_sym_preproc_if_token2] = ACTIONS(2040),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2040),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2040),
    [sym_preproc_directive] = ACTIONS(2040),
    [anon_sym_LPAREN2] = ACTIONS(2042),
    [anon_sym_BANG] = ACTIONS(2042),
    [anon_sym_TILDE] = ACTIONS(2042),
    [anon_sym_DASH] = ACTIONS(2040),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_STAR] = ACTIONS(2042),
    [anon_sym_AMP_AMP] = ACTIONS(2042),
    [anon_sym_AMP] = ACTIONS(2040),
    [anon_sym_SEMI] = ACTIONS(2042),
    [anon_sym___extension__] = ACTIONS(2040),
    [anon_sym_typedef] = ACTIONS(2040),
    [anon_sym___device__] = ACTIONS(2040),
    [anon_sym___host__] = ACTIONS(2040),
    [anon_sym___global__] = ACTIONS(2040),
    [anon_sym___forceinline__] = ACTIONS(2040),
    [anon_sym___noinline__] = ACTIONS(2040),
    [anon_sym_extern] = ACTIONS(2040),
    [anon_sym___attribute__] = ACTIONS(2040),
    [anon_sym_COLON_COLON] = ACTIONS(2042),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2042),
    [anon_sym___declspec] = ACTIONS(2040),
    [anon_sym___based] = ACTIONS(2040),
    [anon_sym___cdecl] = ACTIONS(2040),
    [anon_sym___clrcall] = ACTIONS(2040),
    [anon_sym___stdcall] = ACTIONS(2040),
    [anon_sym___fastcall] = ACTIONS(2040),
    [anon_sym___thiscall] = ACTIONS(2040),
    [anon_sym___vectorcall] = ACTIONS(2040),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_signed] = ACTIONS(2040),
    [anon_sym_unsigned] = ACTIONS(2040),
    [anon_sym_long] = ACTIONS(2040),
    [anon_sym_short] = ACTIONS(2040),
    [anon_sym_LBRACK] = ACTIONS(2040),
    [anon_sym_static] = ACTIONS(2040),
    [anon_sym_register] = ACTIONS(2040),
    [anon_sym_inline] = ACTIONS(2040),
    [anon_sym___inline] = ACTIONS(2040),
    [anon_sym___inline__] = ACTIONS(2040),
    [anon_sym___forceinline] = ACTIONS(2040),
    [anon_sym_thread_local] = ACTIONS(2040),
    [anon_sym___thread] = ACTIONS(2040),
    [anon_sym_const] = ACTIONS(2040),
    [anon_sym_constexpr] = ACTIONS(2040),
    [anon_sym_volatile] = ACTIONS(2040),
    [anon_sym_restrict] = ACTIONS(2040),
    [anon_sym___restrict__] = ACTIONS(2040),
    [anon_sym__Atomic] = ACTIONS(2040),
    [anon_sym__Noreturn] = ACTIONS(2040),
    [anon_sym_noreturn] = ACTIONS(2040),
    [anon_sym_mutable] = ACTIONS(2040),
    [anon_sym_constinit] = ACTIONS(2040),
    [anon_sym_consteval] = ACTIONS(2040),
    [anon_sym___shared__] = ACTIONS(2040),
    [anon_sym___local__] = ACTIONS(2040),
    [anon_sym___constant__] = ACTIONS(2040),
    [anon_sym___managed__] = ACTIONS(2040),
    [anon_sym___grid_constant__] = ACTIONS(2040),
    [anon_sym_alignas] = ACTIONS(2040),
    [anon_sym__Alignas] = ACTIONS(2040),
    [sym_primitive_type] = ACTIONS(2040),
    [anon_sym_enum] = ACTIONS(2040),
    [anon_sym_class] = ACTIONS(2040),
    [anon_sym_struct] = ACTIONS(2040),
    [anon_sym_union] = ACTIONS(2040),
    [anon_sym_if] = ACTIONS(2040),
    [anon_sym_else] = ACTIONS(2040),
    [anon_sym_switch] = ACTIONS(2040),
    [anon_sym_case] = ACTIONS(2040),
    [anon_sym_default] = ACTIONS(2040),
    [anon_sym_while] = ACTIONS(2040),
    [anon_sym_do] = ACTIONS(2040),
    [anon_sym_for] = ACTIONS(2040),
    [anon_sym_return] = ACTIONS(2040),
    [anon_sym_break] = ACTIONS(2040),
    [anon_sym_continue] = ACTIONS(2040),
    [anon_sym_goto] = ACTIONS(2040),
    [anon_sym___try] = ACTIONS(2040),
    [anon_sym___leave] = ACTIONS(2040),
    [anon_sym_not] = ACTIONS(2040),
    [anon_sym_compl] = ACTIONS(2040),
    [anon_sym_DASH_DASH] = ACTIONS(2042),
    [anon_sym_PLUS_PLUS] = ACTIONS(2042),
    [anon_sym_sizeof] = ACTIONS(2040),
    [anon_sym___alignof__] = ACTIONS(2040),
    [anon_sym___alignof] = ACTIONS(2040),
    [anon_sym__alignof] = ACTIONS(2040),
    [anon_sym_alignof] = ACTIONS(2040),
    [anon_sym__Alignof] = ACTIONS(2040),
    [anon_sym_offsetof] = ACTIONS(2040),
    [anon_sym__Generic] = ACTIONS(2040),
    [anon_sym_asm] = ACTIONS(2040),
    [anon_sym___asm__] = ACTIONS(2040),
    [sym_number_literal] = ACTIONS(2042),
    [anon_sym_L_SQUOTE] = ACTIONS(2042),
    [anon_sym_u_SQUOTE] = ACTIONS(2042),
    [anon_sym_U_SQUOTE] = ACTIONS(2042),
    [anon_sym_u8_SQUOTE] = ACTIONS(2042),
    [anon_sym_SQUOTE] = ACTIONS(2042),
    [anon_sym_L_DQUOTE] = ACTIONS(2042),
    [anon_sym_u_DQUOTE] = ACTIONS(2042),
    [anon_sym_U_DQUOTE] = ACTIONS(2042),
    [anon_sym_u8_DQUOTE] = ACTIONS(2042),
    [anon_sym_DQUOTE] = ACTIONS(2042),
    [sym_true] = ACTIONS(2040),
    [sym_false] = ACTIONS(2040),
    [anon_sym_NULL] = ACTIONS(2040),
    [anon_sym_nullptr] = ACTIONS(2040),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2040),
    [anon_sym_decltype] = ACTIONS(2040),
    [sym_virtual] = ACTIONS(2040),
    [anon_sym_explicit] = ACTIONS(2040),
    [anon_sym_typename] = ACTIONS(2040),
    [anon_sym_template] = ACTIONS(2040),
    [anon_sym_operator] = ACTIONS(2040),
    [anon_sym_try] = ACTIONS(2040),
    [anon_sym_delete] = ACTIONS(2040),
    [anon_sym_throw] = ACTIONS(2040),
    [anon_sym_namespace] = ACTIONS(2040),
    [anon_sym_using] = ACTIONS(2040),
    [anon_sym_static_assert] = ACTIONS(2040),
    [anon_sym_concept] = ACTIONS(2040),
    [anon_sym_co_return] = ACTIONS(2040),
    [anon_sym_co_yield] = ACTIONS(2040),
    [anon_sym_R_DQUOTE] = ACTIONS(2042),
    [anon_sym_LR_DQUOTE] = ACTIONS(2042),
    [anon_sym_uR_DQUOTE] = ACTIONS(2042),
    [anon_sym_UR_DQUOTE] = ACTIONS(2042),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2042),
    [anon_sym_co_await] = ACTIONS(2040),
    [anon_sym_new] = ACTIONS(2040),
    [anon_sym_requires] = ACTIONS(2040),
    [sym_this] = ACTIONS(2040),
    [anon_sym___launch_bounds__] = ACTIONS(2040),
  },
  [434] = {
    [sym_identifier] = ACTIONS(1938),
    [aux_sym_preproc_include_token1] = ACTIONS(1938),
    [aux_sym_preproc_def_token1] = ACTIONS(1938),
    [aux_sym_preproc_if_token1] = ACTIONS(1938),
    [aux_sym_preproc_if_token2] = ACTIONS(1938),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1938),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1938),
    [sym_preproc_directive] = ACTIONS(1938),
    [anon_sym_LPAREN2] = ACTIONS(1940),
    [anon_sym_BANG] = ACTIONS(1940),
    [anon_sym_TILDE] = ACTIONS(1940),
    [anon_sym_DASH] = ACTIONS(1938),
    [anon_sym_PLUS] = ACTIONS(1938),
    [anon_sym_STAR] = ACTIONS(1940),
    [anon_sym_AMP_AMP] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1938),
    [anon_sym_SEMI] = ACTIONS(1940),
    [anon_sym___extension__] = ACTIONS(1938),
    [anon_sym_typedef] = ACTIONS(1938),
    [anon_sym___device__] = ACTIONS(1938),
    [anon_sym___host__] = ACTIONS(1938),
    [anon_sym___global__] = ACTIONS(1938),
    [anon_sym___forceinline__] = ACTIONS(1938),
    [anon_sym___noinline__] = ACTIONS(1938),
    [anon_sym_extern] = ACTIONS(1938),
    [anon_sym___attribute__] = ACTIONS(1938),
    [anon_sym_COLON_COLON] = ACTIONS(1940),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1940),
    [anon_sym___declspec] = ACTIONS(1938),
    [anon_sym___based] = ACTIONS(1938),
    [anon_sym___cdecl] = ACTIONS(1938),
    [anon_sym___clrcall] = ACTIONS(1938),
    [anon_sym___stdcall] = ACTIONS(1938),
    [anon_sym___fastcall] = ACTIONS(1938),
    [anon_sym___thiscall] = ACTIONS(1938),
    [anon_sym___vectorcall] = ACTIONS(1938),
    [anon_sym_LBRACE] = ACTIONS(1940),
    [anon_sym_signed] = ACTIONS(1938),
    [anon_sym_unsigned] = ACTIONS(1938),
    [anon_sym_long] = ACTIONS(1938),
    [anon_sym_short] = ACTIONS(1938),
    [anon_sym_LBRACK] = ACTIONS(1938),
    [anon_sym_static] = ACTIONS(1938),
    [anon_sym_register] = ACTIONS(1938),
    [anon_sym_inline] = ACTIONS(1938),
    [anon_sym___inline] = ACTIONS(1938),
    [anon_sym___inline__] = ACTIONS(1938),
    [anon_sym___forceinline] = ACTIONS(1938),
    [anon_sym_thread_local] = ACTIONS(1938),
    [anon_sym___thread] = ACTIONS(1938),
    [anon_sym_const] = ACTIONS(1938),
    [anon_sym_constexpr] = ACTIONS(1938),
    [anon_sym_volatile] = ACTIONS(1938),
    [anon_sym_restrict] = ACTIONS(1938),
    [anon_sym___restrict__] = ACTIONS(1938),
    [anon_sym__Atomic] = ACTIONS(1938),
    [anon_sym__Noreturn] = ACTIONS(1938),
    [anon_sym_noreturn] = ACTIONS(1938),
    [anon_sym_mutable] = ACTIONS(1938),
    [anon_sym_constinit] = ACTIONS(1938),
    [anon_sym_consteval] = ACTIONS(1938),
    [anon_sym___shared__] = ACTIONS(1938),
    [anon_sym___local__] = ACTIONS(1938),
    [anon_sym___constant__] = ACTIONS(1938),
    [anon_sym___managed__] = ACTIONS(1938),
    [anon_sym___grid_constant__] = ACTIONS(1938),
    [anon_sym_alignas] = ACTIONS(1938),
    [anon_sym__Alignas] = ACTIONS(1938),
    [sym_primitive_type] = ACTIONS(1938),
    [anon_sym_enum] = ACTIONS(1938),
    [anon_sym_class] = ACTIONS(1938),
    [anon_sym_struct] = ACTIONS(1938),
    [anon_sym_union] = ACTIONS(1938),
    [anon_sym_if] = ACTIONS(1938),
    [anon_sym_else] = ACTIONS(1938),
    [anon_sym_switch] = ACTIONS(1938),
    [anon_sym_case] = ACTIONS(1938),
    [anon_sym_default] = ACTIONS(1938),
    [anon_sym_while] = ACTIONS(1938),
    [anon_sym_do] = ACTIONS(1938),
    [anon_sym_for] = ACTIONS(1938),
    [anon_sym_return] = ACTIONS(1938),
    [anon_sym_break] = ACTIONS(1938),
    [anon_sym_continue] = ACTIONS(1938),
    [anon_sym_goto] = ACTIONS(1938),
    [anon_sym___try] = ACTIONS(1938),
    [anon_sym___leave] = ACTIONS(1938),
    [anon_sym_not] = ACTIONS(1938),
    [anon_sym_compl] = ACTIONS(1938),
    [anon_sym_DASH_DASH] = ACTIONS(1940),
    [anon_sym_PLUS_PLUS] = ACTIONS(1940),
    [anon_sym_sizeof] = ACTIONS(1938),
    [anon_sym___alignof__] = ACTIONS(1938),
    [anon_sym___alignof] = ACTIONS(1938),
    [anon_sym__alignof] = ACTIONS(1938),
    [anon_sym_alignof] = ACTIONS(1938),
    [anon_sym__Alignof] = ACTIONS(1938),
    [anon_sym_offsetof] = ACTIONS(1938),
    [anon_sym__Generic] = ACTIONS(1938),
    [anon_sym_asm] = ACTIONS(1938),
    [anon_sym___asm__] = ACTIONS(1938),
    [sym_number_literal] = ACTIONS(1940),
    [anon_sym_L_SQUOTE] = ACTIONS(1940),
    [anon_sym_u_SQUOTE] = ACTIONS(1940),
    [anon_sym_U_SQUOTE] = ACTIONS(1940),
    [anon_sym_u8_SQUOTE] = ACTIONS(1940),
    [anon_sym_SQUOTE] = ACTIONS(1940),
    [anon_sym_L_DQUOTE] = ACTIONS(1940),
    [anon_sym_u_DQUOTE] = ACTIONS(1940),
    [anon_sym_U_DQUOTE] = ACTIONS(1940),
    [anon_sym_u8_DQUOTE] = ACTIONS(1940),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_true] = ACTIONS(1938),
    [sym_false] = ACTIONS(1938),
    [anon_sym_NULL] = ACTIONS(1938),
    [anon_sym_nullptr] = ACTIONS(1938),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1938),
    [anon_sym_decltype] = ACTIONS(1938),
    [sym_virtual] = ACTIONS(1938),
    [anon_sym_explicit] = ACTIONS(1938),
    [anon_sym_typename] = ACTIONS(1938),
    [anon_sym_template] = ACTIONS(1938),
    [anon_sym_operator] = ACTIONS(1938),
    [anon_sym_try] = ACTIONS(1938),
    [anon_sym_delete] = ACTIONS(1938),
    [anon_sym_throw] = ACTIONS(1938),
    [anon_sym_namespace] = ACTIONS(1938),
    [anon_sym_using] = ACTIONS(1938),
    [anon_sym_static_assert] = ACTIONS(1938),
    [anon_sym_concept] = ACTIONS(1938),
    [anon_sym_co_return] = ACTIONS(1938),
    [anon_sym_co_yield] = ACTIONS(1938),
    [anon_sym_R_DQUOTE] = ACTIONS(1940),
    [anon_sym_LR_DQUOTE] = ACTIONS(1940),
    [anon_sym_uR_DQUOTE] = ACTIONS(1940),
    [anon_sym_UR_DQUOTE] = ACTIONS(1940),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1940),
    [anon_sym_co_await] = ACTIONS(1938),
    [anon_sym_new] = ACTIONS(1938),
    [anon_sym_requires] = ACTIONS(1938),
    [sym_this] = ACTIONS(1938),
    [anon_sym___launch_bounds__] = ACTIONS(1938),
  },
  [435] = {
    [sym_identifier] = ACTIONS(1988),
    [aux_sym_preproc_include_token1] = ACTIONS(1988),
    [aux_sym_preproc_def_token1] = ACTIONS(1988),
    [aux_sym_preproc_if_token1] = ACTIONS(1988),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1988),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1988),
    [sym_preproc_directive] = ACTIONS(1988),
    [anon_sym_LPAREN2] = ACTIONS(1990),
    [anon_sym_BANG] = ACTIONS(1990),
    [anon_sym_TILDE] = ACTIONS(1990),
    [anon_sym_DASH] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(1990),
    [anon_sym_AMP_AMP] = ACTIONS(1990),
    [anon_sym_AMP] = ACTIONS(1988),
    [anon_sym_SEMI] = ACTIONS(1990),
    [anon_sym___extension__] = ACTIONS(1988),
    [anon_sym_typedef] = ACTIONS(1988),
    [anon_sym___device__] = ACTIONS(1988),
    [anon_sym___host__] = ACTIONS(1988),
    [anon_sym___global__] = ACTIONS(1988),
    [anon_sym___forceinline__] = ACTIONS(1988),
    [anon_sym___noinline__] = ACTIONS(1988),
    [anon_sym_extern] = ACTIONS(1988),
    [anon_sym___attribute__] = ACTIONS(1988),
    [anon_sym_COLON_COLON] = ACTIONS(1990),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1990),
    [anon_sym___declspec] = ACTIONS(1988),
    [anon_sym___based] = ACTIONS(1988),
    [anon_sym___cdecl] = ACTIONS(1988),
    [anon_sym___clrcall] = ACTIONS(1988),
    [anon_sym___stdcall] = ACTIONS(1988),
    [anon_sym___fastcall] = ACTIONS(1988),
    [anon_sym___thiscall] = ACTIONS(1988),
    [anon_sym___vectorcall] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1990),
    [anon_sym_RBRACE] = ACTIONS(1990),
    [anon_sym_signed] = ACTIONS(1988),
    [anon_sym_unsigned] = ACTIONS(1988),
    [anon_sym_long] = ACTIONS(1988),
    [anon_sym_short] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_static] = ACTIONS(1988),
    [anon_sym_register] = ACTIONS(1988),
    [anon_sym_inline] = ACTIONS(1988),
    [anon_sym___inline] = ACTIONS(1988),
    [anon_sym___inline__] = ACTIONS(1988),
    [anon_sym___forceinline] = ACTIONS(1988),
    [anon_sym_thread_local] = ACTIONS(1988),
    [anon_sym___thread] = ACTIONS(1988),
    [anon_sym_const] = ACTIONS(1988),
    [anon_sym_constexpr] = ACTIONS(1988),
    [anon_sym_volatile] = ACTIONS(1988),
    [anon_sym_restrict] = ACTIONS(1988),
    [anon_sym___restrict__] = ACTIONS(1988),
    [anon_sym__Atomic] = ACTIONS(1988),
    [anon_sym__Noreturn] = ACTIONS(1988),
    [anon_sym_noreturn] = ACTIONS(1988),
    [anon_sym_mutable] = ACTIONS(1988),
    [anon_sym_constinit] = ACTIONS(1988),
    [anon_sym_consteval] = ACTIONS(1988),
    [anon_sym___shared__] = ACTIONS(1988),
    [anon_sym___local__] = ACTIONS(1988),
    [anon_sym___constant__] = ACTIONS(1988),
    [anon_sym___managed__] = ACTIONS(1988),
    [anon_sym___grid_constant__] = ACTIONS(1988),
    [anon_sym_alignas] = ACTIONS(1988),
    [anon_sym__Alignas] = ACTIONS(1988),
    [sym_primitive_type] = ACTIONS(1988),
    [anon_sym_enum] = ACTIONS(1988),
    [anon_sym_class] = ACTIONS(1988),
    [anon_sym_struct] = ACTIONS(1988),
    [anon_sym_union] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_else] = ACTIONS(1988),
    [anon_sym_switch] = ACTIONS(1988),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_default] = ACTIONS(1988),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_do] = ACTIONS(1988),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_return] = ACTIONS(1988),
    [anon_sym_break] = ACTIONS(1988),
    [anon_sym_continue] = ACTIONS(1988),
    [anon_sym_goto] = ACTIONS(1988),
    [anon_sym___try] = ACTIONS(1988),
    [anon_sym___leave] = ACTIONS(1988),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_compl] = ACTIONS(1988),
    [anon_sym_DASH_DASH] = ACTIONS(1990),
    [anon_sym_PLUS_PLUS] = ACTIONS(1990),
    [anon_sym_sizeof] = ACTIONS(1988),
    [anon_sym___alignof__] = ACTIONS(1988),
    [anon_sym___alignof] = ACTIONS(1988),
    [anon_sym__alignof] = ACTIONS(1988),
    [anon_sym_alignof] = ACTIONS(1988),
    [anon_sym__Alignof] = ACTIONS(1988),
    [anon_sym_offsetof] = ACTIONS(1988),
    [anon_sym__Generic] = ACTIONS(1988),
    [anon_sym_asm] = ACTIONS(1988),
    [anon_sym___asm__] = ACTIONS(1988),
    [sym_number_literal] = ACTIONS(1990),
    [anon_sym_L_SQUOTE] = ACTIONS(1990),
    [anon_sym_u_SQUOTE] = ACTIONS(1990),
    [anon_sym_U_SQUOTE] = ACTIONS(1990),
    [anon_sym_u8_SQUOTE] = ACTIONS(1990),
    [anon_sym_SQUOTE] = ACTIONS(1990),
    [anon_sym_L_DQUOTE] = ACTIONS(1990),
    [anon_sym_u_DQUOTE] = ACTIONS(1990),
    [anon_sym_U_DQUOTE] = ACTIONS(1990),
    [anon_sym_u8_DQUOTE] = ACTIONS(1990),
    [anon_sym_DQUOTE] = ACTIONS(1990),
    [sym_true] = ACTIONS(1988),
    [sym_false] = ACTIONS(1988),
    [anon_sym_NULL] = ACTIONS(1988),
    [anon_sym_nullptr] = ACTIONS(1988),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1988),
    [anon_sym_decltype] = ACTIONS(1988),
    [sym_virtual] = ACTIONS(1988),
    [anon_sym_explicit] = ACTIONS(1988),
    [anon_sym_typename] = ACTIONS(1988),
    [anon_sym_template] = ACTIONS(1988),
    [anon_sym_operator] = ACTIONS(1988),
    [anon_sym_try] = ACTIONS(1988),
    [anon_sym_delete] = ACTIONS(1988),
    [anon_sym_throw] = ACTIONS(1988),
    [anon_sym_namespace] = ACTIONS(1988),
    [anon_sym_using] = ACTIONS(1988),
    [anon_sym_static_assert] = ACTIONS(1988),
    [anon_sym_concept] = ACTIONS(1988),
    [anon_sym_co_return] = ACTIONS(1988),
    [anon_sym_co_yield] = ACTIONS(1988),
    [anon_sym_R_DQUOTE] = ACTIONS(1990),
    [anon_sym_LR_DQUOTE] = ACTIONS(1990),
    [anon_sym_uR_DQUOTE] = ACTIONS(1990),
    [anon_sym_UR_DQUOTE] = ACTIONS(1990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1990),
    [anon_sym_co_await] = ACTIONS(1988),
    [anon_sym_new] = ACTIONS(1988),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1988),
    [anon_sym___launch_bounds__] = ACTIONS(1988),
  },
  [436] = {
    [sym_identifier] = ACTIONS(2012),
    [aux_sym_preproc_include_token1] = ACTIONS(2012),
    [aux_sym_preproc_def_token1] = ACTIONS(2012),
    [aux_sym_preproc_if_token1] = ACTIONS(2012),
    [aux_sym_preproc_if_token2] = ACTIONS(2012),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2012),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2012),
    [sym_preproc_directive] = ACTIONS(2012),
    [anon_sym_LPAREN2] = ACTIONS(2014),
    [anon_sym_BANG] = ACTIONS(2014),
    [anon_sym_TILDE] = ACTIONS(2014),
    [anon_sym_DASH] = ACTIONS(2012),
    [anon_sym_PLUS] = ACTIONS(2012),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_AMP_AMP] = ACTIONS(2014),
    [anon_sym_AMP] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2014),
    [anon_sym___extension__] = ACTIONS(2012),
    [anon_sym_typedef] = ACTIONS(2012),
    [anon_sym___device__] = ACTIONS(2012),
    [anon_sym___host__] = ACTIONS(2012),
    [anon_sym___global__] = ACTIONS(2012),
    [anon_sym___forceinline__] = ACTIONS(2012),
    [anon_sym___noinline__] = ACTIONS(2012),
    [anon_sym_extern] = ACTIONS(2012),
    [anon_sym___attribute__] = ACTIONS(2012),
    [anon_sym_COLON_COLON] = ACTIONS(2014),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2014),
    [anon_sym___declspec] = ACTIONS(2012),
    [anon_sym___based] = ACTIONS(2012),
    [anon_sym___cdecl] = ACTIONS(2012),
    [anon_sym___clrcall] = ACTIONS(2012),
    [anon_sym___stdcall] = ACTIONS(2012),
    [anon_sym___fastcall] = ACTIONS(2012),
    [anon_sym___thiscall] = ACTIONS(2012),
    [anon_sym___vectorcall] = ACTIONS(2012),
    [anon_sym_LBRACE] = ACTIONS(2014),
    [anon_sym_signed] = ACTIONS(2012),
    [anon_sym_unsigned] = ACTIONS(2012),
    [anon_sym_long] = ACTIONS(2012),
    [anon_sym_short] = ACTIONS(2012),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_static] = ACTIONS(2012),
    [anon_sym_register] = ACTIONS(2012),
    [anon_sym_inline] = ACTIONS(2012),
    [anon_sym___inline] = ACTIONS(2012),
    [anon_sym___inline__] = ACTIONS(2012),
    [anon_sym___forceinline] = ACTIONS(2012),
    [anon_sym_thread_local] = ACTIONS(2012),
    [anon_sym___thread] = ACTIONS(2012),
    [anon_sym_const] = ACTIONS(2012),
    [anon_sym_constexpr] = ACTIONS(2012),
    [anon_sym_volatile] = ACTIONS(2012),
    [anon_sym_restrict] = ACTIONS(2012),
    [anon_sym___restrict__] = ACTIONS(2012),
    [anon_sym__Atomic] = ACTIONS(2012),
    [anon_sym__Noreturn] = ACTIONS(2012),
    [anon_sym_noreturn] = ACTIONS(2012),
    [anon_sym_mutable] = ACTIONS(2012),
    [anon_sym_constinit] = ACTIONS(2012),
    [anon_sym_consteval] = ACTIONS(2012),
    [anon_sym___shared__] = ACTIONS(2012),
    [anon_sym___local__] = ACTIONS(2012),
    [anon_sym___constant__] = ACTIONS(2012),
    [anon_sym___managed__] = ACTIONS(2012),
    [anon_sym___grid_constant__] = ACTIONS(2012),
    [anon_sym_alignas] = ACTIONS(2012),
    [anon_sym__Alignas] = ACTIONS(2012),
    [sym_primitive_type] = ACTIONS(2012),
    [anon_sym_enum] = ACTIONS(2012),
    [anon_sym_class] = ACTIONS(2012),
    [anon_sym_struct] = ACTIONS(2012),
    [anon_sym_union] = ACTIONS(2012),
    [anon_sym_if] = ACTIONS(2012),
    [anon_sym_else] = ACTIONS(2012),
    [anon_sym_switch] = ACTIONS(2012),
    [anon_sym_case] = ACTIONS(2012),
    [anon_sym_default] = ACTIONS(2012),
    [anon_sym_while] = ACTIONS(2012),
    [anon_sym_do] = ACTIONS(2012),
    [anon_sym_for] = ACTIONS(2012),
    [anon_sym_return] = ACTIONS(2012),
    [anon_sym_break] = ACTIONS(2012),
    [anon_sym_continue] = ACTIONS(2012),
    [anon_sym_goto] = ACTIONS(2012),
    [anon_sym___try] = ACTIONS(2012),
    [anon_sym___leave] = ACTIONS(2012),
    [anon_sym_not] = ACTIONS(2012),
    [anon_sym_compl] = ACTIONS(2012),
    [anon_sym_DASH_DASH] = ACTIONS(2014),
    [anon_sym_PLUS_PLUS] = ACTIONS(2014),
    [anon_sym_sizeof] = ACTIONS(2012),
    [anon_sym___alignof__] = ACTIONS(2012),
    [anon_sym___alignof] = ACTIONS(2012),
    [anon_sym__alignof] = ACTIONS(2012),
    [anon_sym_alignof] = ACTIONS(2012),
    [anon_sym__Alignof] = ACTIONS(2012),
    [anon_sym_offsetof] = ACTIONS(2012),
    [anon_sym__Generic] = ACTIONS(2012),
    [anon_sym_asm] = ACTIONS(2012),
    [anon_sym___asm__] = ACTIONS(2012),
    [sym_number_literal] = ACTIONS(2014),
    [anon_sym_L_SQUOTE] = ACTIONS(2014),
    [anon_sym_u_SQUOTE] = ACTIONS(2014),
    [anon_sym_U_SQUOTE] = ACTIONS(2014),
    [anon_sym_u8_SQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2014),
    [anon_sym_L_DQUOTE] = ACTIONS(2014),
    [anon_sym_u_DQUOTE] = ACTIONS(2014),
    [anon_sym_U_DQUOTE] = ACTIONS(2014),
    [anon_sym_u8_DQUOTE] = ACTIONS(2014),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [sym_true] = ACTIONS(2012),
    [sym_false] = ACTIONS(2012),
    [anon_sym_NULL] = ACTIONS(2012),
    [anon_sym_nullptr] = ACTIONS(2012),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2012),
    [anon_sym_decltype] = ACTIONS(2012),
    [sym_virtual] = ACTIONS(2012),
    [anon_sym_explicit] = ACTIONS(2012),
    [anon_sym_typename] = ACTIONS(2012),
    [anon_sym_template] = ACTIONS(2012),
    [anon_sym_operator] = ACTIONS(2012),
    [anon_sym_try] = ACTIONS(2012),
    [anon_sym_delete] = ACTIONS(2012),
    [anon_sym_throw] = ACTIONS(2012),
    [anon_sym_namespace] = ACTIONS(2012),
    [anon_sym_using] = ACTIONS(2012),
    [anon_sym_static_assert] = ACTIONS(2012),
    [anon_sym_concept] = ACTIONS(2012),
    [anon_sym_co_return] = ACTIONS(2012),
    [anon_sym_co_yield] = ACTIONS(2012),
    [anon_sym_R_DQUOTE] = ACTIONS(2014),
    [anon_sym_LR_DQUOTE] = ACTIONS(2014),
    [anon_sym_uR_DQUOTE] = ACTIONS(2014),
    [anon_sym_UR_DQUOTE] = ACTIONS(2014),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2014),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2012),
    [anon_sym_requires] = ACTIONS(2012),
    [sym_this] = ACTIONS(2012),
    [anon_sym___launch_bounds__] = ACTIONS(2012),
  },
  [437] = {
    [sym_identifier] = ACTIONS(1992),
    [aux_sym_preproc_include_token1] = ACTIONS(1992),
    [aux_sym_preproc_def_token1] = ACTIONS(1992),
    [aux_sym_preproc_if_token1] = ACTIONS(1992),
    [aux_sym_preproc_if_token2] = ACTIONS(1992),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1992),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1992),
    [sym_preproc_directive] = ACTIONS(1992),
    [anon_sym_LPAREN2] = ACTIONS(1994),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1994),
    [anon_sym_AMP_AMP] = ACTIONS(1994),
    [anon_sym_AMP] = ACTIONS(1992),
    [anon_sym_SEMI] = ACTIONS(1994),
    [anon_sym___extension__] = ACTIONS(1992),
    [anon_sym_typedef] = ACTIONS(1992),
    [anon_sym___device__] = ACTIONS(1992),
    [anon_sym___host__] = ACTIONS(1992),
    [anon_sym___global__] = ACTIONS(1992),
    [anon_sym___forceinline__] = ACTIONS(1992),
    [anon_sym___noinline__] = ACTIONS(1992),
    [anon_sym_extern] = ACTIONS(1992),
    [anon_sym___attribute__] = ACTIONS(1992),
    [anon_sym_COLON_COLON] = ACTIONS(1994),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1994),
    [anon_sym___declspec] = ACTIONS(1992),
    [anon_sym___based] = ACTIONS(1992),
    [anon_sym___cdecl] = ACTIONS(1992),
    [anon_sym___clrcall] = ACTIONS(1992),
    [anon_sym___stdcall] = ACTIONS(1992),
    [anon_sym___fastcall] = ACTIONS(1992),
    [anon_sym___thiscall] = ACTIONS(1992),
    [anon_sym___vectorcall] = ACTIONS(1992),
    [anon_sym_LBRACE] = ACTIONS(1994),
    [anon_sym_signed] = ACTIONS(1992),
    [anon_sym_unsigned] = ACTIONS(1992),
    [anon_sym_long] = ACTIONS(1992),
    [anon_sym_short] = ACTIONS(1992),
    [anon_sym_LBRACK] = ACTIONS(1992),
    [anon_sym_static] = ACTIONS(1992),
    [anon_sym_register] = ACTIONS(1992),
    [anon_sym_inline] = ACTIONS(1992),
    [anon_sym___inline] = ACTIONS(1992),
    [anon_sym___inline__] = ACTIONS(1992),
    [anon_sym___forceinline] = ACTIONS(1992),
    [anon_sym_thread_local] = ACTIONS(1992),
    [anon_sym___thread] = ACTIONS(1992),
    [anon_sym_const] = ACTIONS(1992),
    [anon_sym_constexpr] = ACTIONS(1992),
    [anon_sym_volatile] = ACTIONS(1992),
    [anon_sym_restrict] = ACTIONS(1992),
    [anon_sym___restrict__] = ACTIONS(1992),
    [anon_sym__Atomic] = ACTIONS(1992),
    [anon_sym__Noreturn] = ACTIONS(1992),
    [anon_sym_noreturn] = ACTIONS(1992),
    [anon_sym_mutable] = ACTIONS(1992),
    [anon_sym_constinit] = ACTIONS(1992),
    [anon_sym_consteval] = ACTIONS(1992),
    [anon_sym___shared__] = ACTIONS(1992),
    [anon_sym___local__] = ACTIONS(1992),
    [anon_sym___constant__] = ACTIONS(1992),
    [anon_sym___managed__] = ACTIONS(1992),
    [anon_sym___grid_constant__] = ACTIONS(1992),
    [anon_sym_alignas] = ACTIONS(1992),
    [anon_sym__Alignas] = ACTIONS(1992),
    [sym_primitive_type] = ACTIONS(1992),
    [anon_sym_enum] = ACTIONS(1992),
    [anon_sym_class] = ACTIONS(1992),
    [anon_sym_struct] = ACTIONS(1992),
    [anon_sym_union] = ACTIONS(1992),
    [anon_sym_if] = ACTIONS(1992),
    [anon_sym_else] = ACTIONS(1992),
    [anon_sym_switch] = ACTIONS(1992),
    [anon_sym_case] = ACTIONS(1992),
    [anon_sym_default] = ACTIONS(1992),
    [anon_sym_while] = ACTIONS(1992),
    [anon_sym_do] = ACTIONS(1992),
    [anon_sym_for] = ACTIONS(1992),
    [anon_sym_return] = ACTIONS(1992),
    [anon_sym_break] = ACTIONS(1992),
    [anon_sym_continue] = ACTIONS(1992),
    [anon_sym_goto] = ACTIONS(1992),
    [anon_sym___try] = ACTIONS(1992),
    [anon_sym___leave] = ACTIONS(1992),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(1994),
    [anon_sym_PLUS_PLUS] = ACTIONS(1994),
    [anon_sym_sizeof] = ACTIONS(1992),
    [anon_sym___alignof__] = ACTIONS(1992),
    [anon_sym___alignof] = ACTIONS(1992),
    [anon_sym__alignof] = ACTIONS(1992),
    [anon_sym_alignof] = ACTIONS(1992),
    [anon_sym__Alignof] = ACTIONS(1992),
    [anon_sym_offsetof] = ACTIONS(1992),
    [anon_sym__Generic] = ACTIONS(1992),
    [anon_sym_asm] = ACTIONS(1992),
    [anon_sym___asm__] = ACTIONS(1992),
    [sym_number_literal] = ACTIONS(1994),
    [anon_sym_L_SQUOTE] = ACTIONS(1994),
    [anon_sym_u_SQUOTE] = ACTIONS(1994),
    [anon_sym_U_SQUOTE] = ACTIONS(1994),
    [anon_sym_u8_SQUOTE] = ACTIONS(1994),
    [anon_sym_SQUOTE] = ACTIONS(1994),
    [anon_sym_L_DQUOTE] = ACTIONS(1994),
    [anon_sym_u_DQUOTE] = ACTIONS(1994),
    [anon_sym_U_DQUOTE] = ACTIONS(1994),
    [anon_sym_u8_DQUOTE] = ACTIONS(1994),
    [anon_sym_DQUOTE] = ACTIONS(1994),
    [sym_true] = ACTIONS(1992),
    [sym_false] = ACTIONS(1992),
    [anon_sym_NULL] = ACTIONS(1992),
    [anon_sym_nullptr] = ACTIONS(1992),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1992),
    [anon_sym_decltype] = ACTIONS(1992),
    [sym_virtual] = ACTIONS(1992),
    [anon_sym_explicit] = ACTIONS(1992),
    [anon_sym_typename] = ACTIONS(1992),
    [anon_sym_template] = ACTIONS(1992),
    [anon_sym_operator] = ACTIONS(1992),
    [anon_sym_try] = ACTIONS(1992),
    [anon_sym_delete] = ACTIONS(1992),
    [anon_sym_throw] = ACTIONS(1992),
    [anon_sym_namespace] = ACTIONS(1992),
    [anon_sym_using] = ACTIONS(1992),
    [anon_sym_static_assert] = ACTIONS(1992),
    [anon_sym_concept] = ACTIONS(1992),
    [anon_sym_co_return] = ACTIONS(1992),
    [anon_sym_co_yield] = ACTIONS(1992),
    [anon_sym_R_DQUOTE] = ACTIONS(1994),
    [anon_sym_LR_DQUOTE] = ACTIONS(1994),
    [anon_sym_uR_DQUOTE] = ACTIONS(1994),
    [anon_sym_UR_DQUOTE] = ACTIONS(1994),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1994),
    [anon_sym_co_await] = ACTIONS(1992),
    [anon_sym_new] = ACTIONS(1992),
    [anon_sym_requires] = ACTIONS(1992),
    [sym_this] = ACTIONS(1992),
    [anon_sym___launch_bounds__] = ACTIONS(1992),
  },
  [438] = {
    [ts_builtin_sym_end] = ACTIONS(1966),
    [sym_identifier] = ACTIONS(1964),
    [aux_sym_preproc_include_token1] = ACTIONS(1964),
    [aux_sym_preproc_def_token1] = ACTIONS(1964),
    [aux_sym_preproc_if_token1] = ACTIONS(1964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1964),
    [sym_preproc_directive] = ACTIONS(1964),
    [anon_sym_LPAREN2] = ACTIONS(1966),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [anon_sym_DASH] = ACTIONS(1964),
    [anon_sym_PLUS] = ACTIONS(1964),
    [anon_sym_STAR] = ACTIONS(1966),
    [anon_sym_AMP_AMP] = ACTIONS(1966),
    [anon_sym_AMP] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym___extension__] = ACTIONS(1964),
    [anon_sym_typedef] = ACTIONS(1964),
    [anon_sym___device__] = ACTIONS(1964),
    [anon_sym___host__] = ACTIONS(1964),
    [anon_sym___global__] = ACTIONS(1964),
    [anon_sym___forceinline__] = ACTIONS(1964),
    [anon_sym___noinline__] = ACTIONS(1964),
    [anon_sym_extern] = ACTIONS(1964),
    [anon_sym___attribute__] = ACTIONS(1964),
    [anon_sym_COLON_COLON] = ACTIONS(1966),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1966),
    [anon_sym___declspec] = ACTIONS(1964),
    [anon_sym___based] = ACTIONS(1964),
    [anon_sym___cdecl] = ACTIONS(1964),
    [anon_sym___clrcall] = ACTIONS(1964),
    [anon_sym___stdcall] = ACTIONS(1964),
    [anon_sym___fastcall] = ACTIONS(1964),
    [anon_sym___thiscall] = ACTIONS(1964),
    [anon_sym___vectorcall] = ACTIONS(1964),
    [anon_sym_LBRACE] = ACTIONS(1966),
    [anon_sym_signed] = ACTIONS(1964),
    [anon_sym_unsigned] = ACTIONS(1964),
    [anon_sym_long] = ACTIONS(1964),
    [anon_sym_short] = ACTIONS(1964),
    [anon_sym_LBRACK] = ACTIONS(1964),
    [anon_sym_static] = ACTIONS(1964),
    [anon_sym_register] = ACTIONS(1964),
    [anon_sym_inline] = ACTIONS(1964),
    [anon_sym___inline] = ACTIONS(1964),
    [anon_sym___inline__] = ACTIONS(1964),
    [anon_sym___forceinline] = ACTIONS(1964),
    [anon_sym_thread_local] = ACTIONS(1964),
    [anon_sym___thread] = ACTIONS(1964),
    [anon_sym_const] = ACTIONS(1964),
    [anon_sym_constexpr] = ACTIONS(1964),
    [anon_sym_volatile] = ACTIONS(1964),
    [anon_sym_restrict] = ACTIONS(1964),
    [anon_sym___restrict__] = ACTIONS(1964),
    [anon_sym__Atomic] = ACTIONS(1964),
    [anon_sym__Noreturn] = ACTIONS(1964),
    [anon_sym_noreturn] = ACTIONS(1964),
    [anon_sym_mutable] = ACTIONS(1964),
    [anon_sym_constinit] = ACTIONS(1964),
    [anon_sym_consteval] = ACTIONS(1964),
    [anon_sym___shared__] = ACTIONS(1964),
    [anon_sym___local__] = ACTIONS(1964),
    [anon_sym___constant__] = ACTIONS(1964),
    [anon_sym___managed__] = ACTIONS(1964),
    [anon_sym___grid_constant__] = ACTIONS(1964),
    [anon_sym_alignas] = ACTIONS(1964),
    [anon_sym__Alignas] = ACTIONS(1964),
    [sym_primitive_type] = ACTIONS(1964),
    [anon_sym_enum] = ACTIONS(1964),
    [anon_sym_class] = ACTIONS(1964),
    [anon_sym_struct] = ACTIONS(1964),
    [anon_sym_union] = ACTIONS(1964),
    [anon_sym_if] = ACTIONS(1964),
    [anon_sym_else] = ACTIONS(1964),
    [anon_sym_switch] = ACTIONS(1964),
    [anon_sym_case] = ACTIONS(1964),
    [anon_sym_default] = ACTIONS(1964),
    [anon_sym_while] = ACTIONS(1964),
    [anon_sym_do] = ACTIONS(1964),
    [anon_sym_for] = ACTIONS(1964),
    [anon_sym_return] = ACTIONS(1964),
    [anon_sym_break] = ACTIONS(1964),
    [anon_sym_continue] = ACTIONS(1964),
    [anon_sym_goto] = ACTIONS(1964),
    [anon_sym___try] = ACTIONS(1964),
    [anon_sym___leave] = ACTIONS(1964),
    [anon_sym_not] = ACTIONS(1964),
    [anon_sym_compl] = ACTIONS(1964),
    [anon_sym_DASH_DASH] = ACTIONS(1966),
    [anon_sym_PLUS_PLUS] = ACTIONS(1966),
    [anon_sym_sizeof] = ACTIONS(1964),
    [anon_sym___alignof__] = ACTIONS(1964),
    [anon_sym___alignof] = ACTIONS(1964),
    [anon_sym__alignof] = ACTIONS(1964),
    [anon_sym_alignof] = ACTIONS(1964),
    [anon_sym__Alignof] = ACTIONS(1964),
    [anon_sym_offsetof] = ACTIONS(1964),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1964),
    [anon_sym___asm__] = ACTIONS(1964),
    [sym_number_literal] = ACTIONS(1966),
    [anon_sym_L_SQUOTE] = ACTIONS(1966),
    [anon_sym_u_SQUOTE] = ACTIONS(1966),
    [anon_sym_U_SQUOTE] = ACTIONS(1966),
    [anon_sym_u8_SQUOTE] = ACTIONS(1966),
    [anon_sym_SQUOTE] = ACTIONS(1966),
    [anon_sym_L_DQUOTE] = ACTIONS(1966),
    [anon_sym_u_DQUOTE] = ACTIONS(1966),
    [anon_sym_U_DQUOTE] = ACTIONS(1966),
    [anon_sym_u8_DQUOTE] = ACTIONS(1966),
    [anon_sym_DQUOTE] = ACTIONS(1966),
    [sym_true] = ACTIONS(1964),
    [sym_false] = ACTIONS(1964),
    [anon_sym_NULL] = ACTIONS(1964),
    [anon_sym_nullptr] = ACTIONS(1964),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1964),
    [anon_sym_decltype] = ACTIONS(1964),
    [sym_virtual] = ACTIONS(1964),
    [anon_sym_explicit] = ACTIONS(1964),
    [anon_sym_typename] = ACTIONS(1964),
    [anon_sym_template] = ACTIONS(1964),
    [anon_sym_operator] = ACTIONS(1964),
    [anon_sym_try] = ACTIONS(1964),
    [anon_sym_delete] = ACTIONS(1964),
    [anon_sym_throw] = ACTIONS(1964),
    [anon_sym_namespace] = ACTIONS(1964),
    [anon_sym_using] = ACTIONS(1964),
    [anon_sym_static_assert] = ACTIONS(1964),
    [anon_sym_concept] = ACTIONS(1964),
    [anon_sym_co_return] = ACTIONS(1964),
    [anon_sym_co_yield] = ACTIONS(1964),
    [anon_sym_R_DQUOTE] = ACTIONS(1966),
    [anon_sym_LR_DQUOTE] = ACTIONS(1966),
    [anon_sym_uR_DQUOTE] = ACTIONS(1966),
    [anon_sym_UR_DQUOTE] = ACTIONS(1966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1966),
    [anon_sym_co_await] = ACTIONS(1964),
    [anon_sym_new] = ACTIONS(1964),
    [anon_sym_requires] = ACTIONS(1964),
    [sym_this] = ACTIONS(1964),
    [anon_sym___launch_bounds__] = ACTIONS(1964),
  },
  [439] = {
    [sym_identifier] = ACTIONS(2000),
    [aux_sym_preproc_include_token1] = ACTIONS(2000),
    [aux_sym_preproc_def_token1] = ACTIONS(2000),
    [aux_sym_preproc_if_token1] = ACTIONS(2000),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2000),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2000),
    [sym_preproc_directive] = ACTIONS(2000),
    [anon_sym_LPAREN2] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2002),
    [anon_sym_TILDE] = ACTIONS(2002),
    [anon_sym_DASH] = ACTIONS(2000),
    [anon_sym_PLUS] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(2002),
    [anon_sym_AMP_AMP] = ACTIONS(2002),
    [anon_sym_AMP] = ACTIONS(2000),
    [anon_sym_SEMI] = ACTIONS(2002),
    [anon_sym___extension__] = ACTIONS(2000),
    [anon_sym_typedef] = ACTIONS(2000),
    [anon_sym___device__] = ACTIONS(2000),
    [anon_sym___host__] = ACTIONS(2000),
    [anon_sym___global__] = ACTIONS(2000),
    [anon_sym___forceinline__] = ACTIONS(2000),
    [anon_sym___noinline__] = ACTIONS(2000),
    [anon_sym_extern] = ACTIONS(2000),
    [anon_sym___attribute__] = ACTIONS(2000),
    [anon_sym_COLON_COLON] = ACTIONS(2002),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2002),
    [anon_sym___declspec] = ACTIONS(2000),
    [anon_sym___based] = ACTIONS(2000),
    [anon_sym___cdecl] = ACTIONS(2000),
    [anon_sym___clrcall] = ACTIONS(2000),
    [anon_sym___stdcall] = ACTIONS(2000),
    [anon_sym___fastcall] = ACTIONS(2000),
    [anon_sym___thiscall] = ACTIONS(2000),
    [anon_sym___vectorcall] = ACTIONS(2000),
    [anon_sym_LBRACE] = ACTIONS(2002),
    [anon_sym_RBRACE] = ACTIONS(2002),
    [anon_sym_signed] = ACTIONS(2000),
    [anon_sym_unsigned] = ACTIONS(2000),
    [anon_sym_long] = ACTIONS(2000),
    [anon_sym_short] = ACTIONS(2000),
    [anon_sym_LBRACK] = ACTIONS(2000),
    [anon_sym_static] = ACTIONS(2000),
    [anon_sym_register] = ACTIONS(2000),
    [anon_sym_inline] = ACTIONS(2000),
    [anon_sym___inline] = ACTIONS(2000),
    [anon_sym___inline__] = ACTIONS(2000),
    [anon_sym___forceinline] = ACTIONS(2000),
    [anon_sym_thread_local] = ACTIONS(2000),
    [anon_sym___thread] = ACTIONS(2000),
    [anon_sym_const] = ACTIONS(2000),
    [anon_sym_constexpr] = ACTIONS(2000),
    [anon_sym_volatile] = ACTIONS(2000),
    [anon_sym_restrict] = ACTIONS(2000),
    [anon_sym___restrict__] = ACTIONS(2000),
    [anon_sym__Atomic] = ACTIONS(2000),
    [anon_sym__Noreturn] = ACTIONS(2000),
    [anon_sym_noreturn] = ACTIONS(2000),
    [anon_sym_mutable] = ACTIONS(2000),
    [anon_sym_constinit] = ACTIONS(2000),
    [anon_sym_consteval] = ACTIONS(2000),
    [anon_sym___shared__] = ACTIONS(2000),
    [anon_sym___local__] = ACTIONS(2000),
    [anon_sym___constant__] = ACTIONS(2000),
    [anon_sym___managed__] = ACTIONS(2000),
    [anon_sym___grid_constant__] = ACTIONS(2000),
    [anon_sym_alignas] = ACTIONS(2000),
    [anon_sym__Alignas] = ACTIONS(2000),
    [sym_primitive_type] = ACTIONS(2000),
    [anon_sym_enum] = ACTIONS(2000),
    [anon_sym_class] = ACTIONS(2000),
    [anon_sym_struct] = ACTIONS(2000),
    [anon_sym_union] = ACTIONS(2000),
    [anon_sym_if] = ACTIONS(2000),
    [anon_sym_else] = ACTIONS(2000),
    [anon_sym_switch] = ACTIONS(2000),
    [anon_sym_case] = ACTIONS(2000),
    [anon_sym_default] = ACTIONS(2000),
    [anon_sym_while] = ACTIONS(2000),
    [anon_sym_do] = ACTIONS(2000),
    [anon_sym_for] = ACTIONS(2000),
    [anon_sym_return] = ACTIONS(2000),
    [anon_sym_break] = ACTIONS(2000),
    [anon_sym_continue] = ACTIONS(2000),
    [anon_sym_goto] = ACTIONS(2000),
    [anon_sym___try] = ACTIONS(2000),
    [anon_sym___leave] = ACTIONS(2000),
    [anon_sym_not] = ACTIONS(2000),
    [anon_sym_compl] = ACTIONS(2000),
    [anon_sym_DASH_DASH] = ACTIONS(2002),
    [anon_sym_PLUS_PLUS] = ACTIONS(2002),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(2000),
    [anon_sym___alignof] = ACTIONS(2000),
    [anon_sym__alignof] = ACTIONS(2000),
    [anon_sym_alignof] = ACTIONS(2000),
    [anon_sym__Alignof] = ACTIONS(2000),
    [anon_sym_offsetof] = ACTIONS(2000),
    [anon_sym__Generic] = ACTIONS(2000),
    [anon_sym_asm] = ACTIONS(2000),
    [anon_sym___asm__] = ACTIONS(2000),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2002),
    [anon_sym_u_SQUOTE] = ACTIONS(2002),
    [anon_sym_U_SQUOTE] = ACTIONS(2002),
    [anon_sym_u8_SQUOTE] = ACTIONS(2002),
    [anon_sym_SQUOTE] = ACTIONS(2002),
    [anon_sym_L_DQUOTE] = ACTIONS(2002),
    [anon_sym_u_DQUOTE] = ACTIONS(2002),
    [anon_sym_U_DQUOTE] = ACTIONS(2002),
    [anon_sym_u8_DQUOTE] = ACTIONS(2002),
    [anon_sym_DQUOTE] = ACTIONS(2002),
    [sym_true] = ACTIONS(2000),
    [sym_false] = ACTIONS(2000),
    [anon_sym_NULL] = ACTIONS(2000),
    [anon_sym_nullptr] = ACTIONS(2000),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2000),
    [anon_sym_decltype] = ACTIONS(2000),
    [sym_virtual] = ACTIONS(2000),
    [anon_sym_explicit] = ACTIONS(2000),
    [anon_sym_typename] = ACTIONS(2000),
    [anon_sym_template] = ACTIONS(2000),
    [anon_sym_operator] = ACTIONS(2000),
    [anon_sym_try] = ACTIONS(2000),
    [anon_sym_delete] = ACTIONS(2000),
    [anon_sym_throw] = ACTIONS(2000),
    [anon_sym_namespace] = ACTIONS(2000),
    [anon_sym_using] = ACTIONS(2000),
    [anon_sym_static_assert] = ACTIONS(2000),
    [anon_sym_concept] = ACTIONS(2000),
    [anon_sym_co_return] = ACTIONS(2000),
    [anon_sym_co_yield] = ACTIONS(2000),
    [anon_sym_R_DQUOTE] = ACTIONS(2002),
    [anon_sym_LR_DQUOTE] = ACTIONS(2002),
    [anon_sym_uR_DQUOTE] = ACTIONS(2002),
    [anon_sym_UR_DQUOTE] = ACTIONS(2002),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2002),
    [anon_sym_co_await] = ACTIONS(2000),
    [anon_sym_new] = ACTIONS(2000),
    [anon_sym_requires] = ACTIONS(2000),
    [sym_this] = ACTIONS(2000),
    [anon_sym___launch_bounds__] = ACTIONS(2000),
  },
  [440] = {
    [sym_type_qualifier] = STATE(3531),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4591),
    [sym_sized_type_specifier] = STATE(2599),
    [sym_enum_specifier] = STATE(2599),
    [sym_struct_specifier] = STATE(2599),
    [sym_union_specifier] = STATE(2599),
    [sym_expression] = STATE(4652),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_type_descriptor] = STATE(7183),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_placeholder_type_specifier] = STATE(2599),
    [sym_decltype_auto] = STATE(2598),
    [sym_decltype] = STATE(2477),
    [sym_class_specifier] = STATE(2599),
    [sym__class_name] = STATE(8015),
    [sym_dependent_type] = STATE(2599),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_type_parameter_pack_expansion] = STATE(7682),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5910),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [aux_sym__type_definition_type_repeat1] = STATE(3531),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2157),
    [sym_identifier] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2725),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2729),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2733),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2757),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2761),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_GT2] = ACTIONS(2763),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [441] = {
    [sym_type_qualifier] = STATE(3531),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4591),
    [sym_sized_type_specifier] = STATE(2599),
    [sym_enum_specifier] = STATE(2599),
    [sym_struct_specifier] = STATE(2599),
    [sym_union_specifier] = STATE(2599),
    [sym_expression] = STATE(4701),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_type_descriptor] = STATE(7241),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_placeholder_type_specifier] = STATE(2599),
    [sym_decltype_auto] = STATE(2598),
    [sym_decltype] = STATE(2477),
    [sym_class_specifier] = STATE(2599),
    [sym__class_name] = STATE(8015),
    [sym_dependent_type] = STATE(2599),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_type_parameter_pack_expansion] = STATE(7591),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5910),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [aux_sym__type_definition_type_repeat1] = STATE(3531),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2157),
    [sym_identifier] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2725),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2729),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2733),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2757),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2761),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_GT2] = ACTIONS(2775),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [442] = {
    [sym_identifier] = ACTIONS(2348),
    [aux_sym_preproc_include_token1] = ACTIONS(2348),
    [aux_sym_preproc_def_token1] = ACTIONS(2348),
    [aux_sym_preproc_if_token1] = ACTIONS(2348),
    [aux_sym_preproc_if_token2] = ACTIONS(2348),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2348),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2348),
    [sym_preproc_directive] = ACTIONS(2348),
    [anon_sym_LPAREN2] = ACTIONS(2350),
    [anon_sym_BANG] = ACTIONS(2350),
    [anon_sym_TILDE] = ACTIONS(2350),
    [anon_sym_DASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(2348),
    [anon_sym_STAR] = ACTIONS(2350),
    [anon_sym_AMP_AMP] = ACTIONS(2350),
    [anon_sym_AMP] = ACTIONS(2348),
    [anon_sym_SEMI] = ACTIONS(2350),
    [anon_sym___extension__] = ACTIONS(2348),
    [anon_sym_typedef] = ACTIONS(2348),
    [anon_sym___device__] = ACTIONS(2348),
    [anon_sym___host__] = ACTIONS(2348),
    [anon_sym___global__] = ACTIONS(2348),
    [anon_sym___forceinline__] = ACTIONS(2348),
    [anon_sym___noinline__] = ACTIONS(2348),
    [anon_sym_extern] = ACTIONS(2348),
    [anon_sym___attribute__] = ACTIONS(2348),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2350),
    [anon_sym___declspec] = ACTIONS(2348),
    [anon_sym___based] = ACTIONS(2348),
    [anon_sym___cdecl] = ACTIONS(2348),
    [anon_sym___clrcall] = ACTIONS(2348),
    [anon_sym___stdcall] = ACTIONS(2348),
    [anon_sym___fastcall] = ACTIONS(2348),
    [anon_sym___thiscall] = ACTIONS(2348),
    [anon_sym___vectorcall] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(2350),
    [anon_sym_signed] = ACTIONS(2348),
    [anon_sym_unsigned] = ACTIONS(2348),
    [anon_sym_long] = ACTIONS(2348),
    [anon_sym_short] = ACTIONS(2348),
    [anon_sym_LBRACK] = ACTIONS(2348),
    [anon_sym_static] = ACTIONS(2348),
    [anon_sym_register] = ACTIONS(2348),
    [anon_sym_inline] = ACTIONS(2348),
    [anon_sym___inline] = ACTIONS(2348),
    [anon_sym___inline__] = ACTIONS(2348),
    [anon_sym___forceinline] = ACTIONS(2348),
    [anon_sym_thread_local] = ACTIONS(2348),
    [anon_sym___thread] = ACTIONS(2348),
    [anon_sym_const] = ACTIONS(2348),
    [anon_sym_constexpr] = ACTIONS(2348),
    [anon_sym_volatile] = ACTIONS(2348),
    [anon_sym_restrict] = ACTIONS(2348),
    [anon_sym___restrict__] = ACTIONS(2348),
    [anon_sym__Atomic] = ACTIONS(2348),
    [anon_sym__Noreturn] = ACTIONS(2348),
    [anon_sym_noreturn] = ACTIONS(2348),
    [anon_sym_mutable] = ACTIONS(2348),
    [anon_sym_constinit] = ACTIONS(2348),
    [anon_sym_consteval] = ACTIONS(2348),
    [anon_sym___shared__] = ACTIONS(2348),
    [anon_sym___local__] = ACTIONS(2348),
    [anon_sym___constant__] = ACTIONS(2348),
    [anon_sym___managed__] = ACTIONS(2348),
    [anon_sym___grid_constant__] = ACTIONS(2348),
    [anon_sym_alignas] = ACTIONS(2348),
    [anon_sym__Alignas] = ACTIONS(2348),
    [sym_primitive_type] = ACTIONS(2348),
    [anon_sym_enum] = ACTIONS(2348),
    [anon_sym_class] = ACTIONS(2348),
    [anon_sym_struct] = ACTIONS(2348),
    [anon_sym_union] = ACTIONS(2348),
    [anon_sym_if] = ACTIONS(2348),
    [anon_sym_switch] = ACTIONS(2348),
    [anon_sym_case] = ACTIONS(2348),
    [anon_sym_default] = ACTIONS(2348),
    [anon_sym_while] = ACTIONS(2348),
    [anon_sym_do] = ACTIONS(2348),
    [anon_sym_for] = ACTIONS(2348),
    [anon_sym_return] = ACTIONS(2348),
    [anon_sym_break] = ACTIONS(2348),
    [anon_sym_continue] = ACTIONS(2348),
    [anon_sym_goto] = ACTIONS(2348),
    [anon_sym___try] = ACTIONS(2348),
    [anon_sym___leave] = ACTIONS(2348),
    [anon_sym_not] = ACTIONS(2348),
    [anon_sym_compl] = ACTIONS(2348),
    [anon_sym_DASH_DASH] = ACTIONS(2350),
    [anon_sym_PLUS_PLUS] = ACTIONS(2350),
    [anon_sym_sizeof] = ACTIONS(2348),
    [anon_sym___alignof__] = ACTIONS(2348),
    [anon_sym___alignof] = ACTIONS(2348),
    [anon_sym__alignof] = ACTIONS(2348),
    [anon_sym_alignof] = ACTIONS(2348),
    [anon_sym__Alignof] = ACTIONS(2348),
    [anon_sym_offsetof] = ACTIONS(2348),
    [anon_sym__Generic] = ACTIONS(2348),
    [anon_sym_asm] = ACTIONS(2348),
    [anon_sym___asm__] = ACTIONS(2348),
    [sym_number_literal] = ACTIONS(2350),
    [anon_sym_L_SQUOTE] = ACTIONS(2350),
    [anon_sym_u_SQUOTE] = ACTIONS(2350),
    [anon_sym_U_SQUOTE] = ACTIONS(2350),
    [anon_sym_u8_SQUOTE] = ACTIONS(2350),
    [anon_sym_SQUOTE] = ACTIONS(2350),
    [anon_sym_L_DQUOTE] = ACTIONS(2350),
    [anon_sym_u_DQUOTE] = ACTIONS(2350),
    [anon_sym_U_DQUOTE] = ACTIONS(2350),
    [anon_sym_u8_DQUOTE] = ACTIONS(2350),
    [anon_sym_DQUOTE] = ACTIONS(2350),
    [sym_true] = ACTIONS(2348),
    [sym_false] = ACTIONS(2348),
    [anon_sym_NULL] = ACTIONS(2348),
    [anon_sym_nullptr] = ACTIONS(2348),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2348),
    [anon_sym_decltype] = ACTIONS(2348),
    [sym_virtual] = ACTIONS(2348),
    [anon_sym_explicit] = ACTIONS(2348),
    [anon_sym_typename] = ACTIONS(2348),
    [anon_sym_template] = ACTIONS(2348),
    [anon_sym_operator] = ACTIONS(2348),
    [anon_sym_try] = ACTIONS(2348),
    [anon_sym_delete] = ACTIONS(2348),
    [anon_sym_throw] = ACTIONS(2348),
    [anon_sym_namespace] = ACTIONS(2348),
    [anon_sym_using] = ACTIONS(2348),
    [anon_sym_static_assert] = ACTIONS(2348),
    [anon_sym_concept] = ACTIONS(2348),
    [anon_sym_co_return] = ACTIONS(2348),
    [anon_sym_co_yield] = ACTIONS(2348),
    [anon_sym_R_DQUOTE] = ACTIONS(2350),
    [anon_sym_LR_DQUOTE] = ACTIONS(2350),
    [anon_sym_uR_DQUOTE] = ACTIONS(2350),
    [anon_sym_UR_DQUOTE] = ACTIONS(2350),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2350),
    [anon_sym_co_await] = ACTIONS(2348),
    [anon_sym_new] = ACTIONS(2348),
    [anon_sym_requires] = ACTIONS(2348),
    [sym_this] = ACTIONS(2348),
    [anon_sym___launch_bounds__] = ACTIONS(2348),
  },
  [443] = {
    [sym_identifier] = ACTIONS(2338),
    [aux_sym_preproc_include_token1] = ACTIONS(2338),
    [aux_sym_preproc_def_token1] = ACTIONS(2338),
    [aux_sym_preproc_if_token1] = ACTIONS(2338),
    [aux_sym_preproc_if_token2] = ACTIONS(2338),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2338),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2338),
    [sym_preproc_directive] = ACTIONS(2338),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2338),
    [anon_sym_PLUS] = ACTIONS(2338),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_AMP] = ACTIONS(2338),
    [anon_sym_SEMI] = ACTIONS(2340),
    [anon_sym___extension__] = ACTIONS(2338),
    [anon_sym_typedef] = ACTIONS(2338),
    [anon_sym___device__] = ACTIONS(2338),
    [anon_sym___host__] = ACTIONS(2338),
    [anon_sym___global__] = ACTIONS(2338),
    [anon_sym___forceinline__] = ACTIONS(2338),
    [anon_sym___noinline__] = ACTIONS(2338),
    [anon_sym_extern] = ACTIONS(2338),
    [anon_sym___attribute__] = ACTIONS(2338),
    [anon_sym_COLON_COLON] = ACTIONS(2340),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2340),
    [anon_sym___declspec] = ACTIONS(2338),
    [anon_sym___based] = ACTIONS(2338),
    [anon_sym___cdecl] = ACTIONS(2338),
    [anon_sym___clrcall] = ACTIONS(2338),
    [anon_sym___stdcall] = ACTIONS(2338),
    [anon_sym___fastcall] = ACTIONS(2338),
    [anon_sym___thiscall] = ACTIONS(2338),
    [anon_sym___vectorcall] = ACTIONS(2338),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_signed] = ACTIONS(2338),
    [anon_sym_unsigned] = ACTIONS(2338),
    [anon_sym_long] = ACTIONS(2338),
    [anon_sym_short] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2338),
    [anon_sym_static] = ACTIONS(2338),
    [anon_sym_register] = ACTIONS(2338),
    [anon_sym_inline] = ACTIONS(2338),
    [anon_sym___inline] = ACTIONS(2338),
    [anon_sym___inline__] = ACTIONS(2338),
    [anon_sym___forceinline] = ACTIONS(2338),
    [anon_sym_thread_local] = ACTIONS(2338),
    [anon_sym___thread] = ACTIONS(2338),
    [anon_sym_const] = ACTIONS(2338),
    [anon_sym_constexpr] = ACTIONS(2338),
    [anon_sym_volatile] = ACTIONS(2338),
    [anon_sym_restrict] = ACTIONS(2338),
    [anon_sym___restrict__] = ACTIONS(2338),
    [anon_sym__Atomic] = ACTIONS(2338),
    [anon_sym__Noreturn] = ACTIONS(2338),
    [anon_sym_noreturn] = ACTIONS(2338),
    [anon_sym_mutable] = ACTIONS(2338),
    [anon_sym_constinit] = ACTIONS(2338),
    [anon_sym_consteval] = ACTIONS(2338),
    [anon_sym___shared__] = ACTIONS(2338),
    [anon_sym___local__] = ACTIONS(2338),
    [anon_sym___constant__] = ACTIONS(2338),
    [anon_sym___managed__] = ACTIONS(2338),
    [anon_sym___grid_constant__] = ACTIONS(2338),
    [anon_sym_alignas] = ACTIONS(2338),
    [anon_sym__Alignas] = ACTIONS(2338),
    [sym_primitive_type] = ACTIONS(2338),
    [anon_sym_enum] = ACTIONS(2338),
    [anon_sym_class] = ACTIONS(2338),
    [anon_sym_struct] = ACTIONS(2338),
    [anon_sym_union] = ACTIONS(2338),
    [anon_sym_if] = ACTIONS(2338),
    [anon_sym_switch] = ACTIONS(2338),
    [anon_sym_case] = ACTIONS(2338),
    [anon_sym_default] = ACTIONS(2338),
    [anon_sym_while] = ACTIONS(2338),
    [anon_sym_do] = ACTIONS(2338),
    [anon_sym_for] = ACTIONS(2338),
    [anon_sym_return] = ACTIONS(2338),
    [anon_sym_break] = ACTIONS(2338),
    [anon_sym_continue] = ACTIONS(2338),
    [anon_sym_goto] = ACTIONS(2338),
    [anon_sym___try] = ACTIONS(2338),
    [anon_sym___leave] = ACTIONS(2338),
    [anon_sym_not] = ACTIONS(2338),
    [anon_sym_compl] = ACTIONS(2338),
    [anon_sym_DASH_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_PLUS] = ACTIONS(2340),
    [anon_sym_sizeof] = ACTIONS(2338),
    [anon_sym___alignof__] = ACTIONS(2338),
    [anon_sym___alignof] = ACTIONS(2338),
    [anon_sym__alignof] = ACTIONS(2338),
    [anon_sym_alignof] = ACTIONS(2338),
    [anon_sym__Alignof] = ACTIONS(2338),
    [anon_sym_offsetof] = ACTIONS(2338),
    [anon_sym__Generic] = ACTIONS(2338),
    [anon_sym_asm] = ACTIONS(2338),
    [anon_sym___asm__] = ACTIONS(2338),
    [sym_number_literal] = ACTIONS(2340),
    [anon_sym_L_SQUOTE] = ACTIONS(2340),
    [anon_sym_u_SQUOTE] = ACTIONS(2340),
    [anon_sym_U_SQUOTE] = ACTIONS(2340),
    [anon_sym_u8_SQUOTE] = ACTIONS(2340),
    [anon_sym_SQUOTE] = ACTIONS(2340),
    [anon_sym_L_DQUOTE] = ACTIONS(2340),
    [anon_sym_u_DQUOTE] = ACTIONS(2340),
    [anon_sym_U_DQUOTE] = ACTIONS(2340),
    [anon_sym_u8_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [sym_true] = ACTIONS(2338),
    [sym_false] = ACTIONS(2338),
    [anon_sym_NULL] = ACTIONS(2338),
    [anon_sym_nullptr] = ACTIONS(2338),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2338),
    [anon_sym_decltype] = ACTIONS(2338),
    [sym_virtual] = ACTIONS(2338),
    [anon_sym_explicit] = ACTIONS(2338),
    [anon_sym_typename] = ACTIONS(2338),
    [anon_sym_template] = ACTIONS(2338),
    [anon_sym_operator] = ACTIONS(2338),
    [anon_sym_try] = ACTIONS(2338),
    [anon_sym_delete] = ACTIONS(2338),
    [anon_sym_throw] = ACTIONS(2338),
    [anon_sym_namespace] = ACTIONS(2338),
    [anon_sym_using] = ACTIONS(2338),
    [anon_sym_static_assert] = ACTIONS(2338),
    [anon_sym_concept] = ACTIONS(2338),
    [anon_sym_co_return] = ACTIONS(2338),
    [anon_sym_co_yield] = ACTIONS(2338),
    [anon_sym_R_DQUOTE] = ACTIONS(2340),
    [anon_sym_LR_DQUOTE] = ACTIONS(2340),
    [anon_sym_uR_DQUOTE] = ACTIONS(2340),
    [anon_sym_UR_DQUOTE] = ACTIONS(2340),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2340),
    [anon_sym_co_await] = ACTIONS(2338),
    [anon_sym_new] = ACTIONS(2338),
    [anon_sym_requires] = ACTIONS(2338),
    [sym_this] = ACTIONS(2338),
    [anon_sym___launch_bounds__] = ACTIONS(2338),
  },
  [444] = {
    [sym_identifier] = ACTIONS(2166),
    [aux_sym_preproc_include_token1] = ACTIONS(2166),
    [aux_sym_preproc_def_token1] = ACTIONS(2166),
    [aux_sym_preproc_if_token1] = ACTIONS(2166),
    [aux_sym_preproc_if_token2] = ACTIONS(2166),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2166),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2166),
    [sym_preproc_directive] = ACTIONS(2166),
    [anon_sym_LPAREN2] = ACTIONS(2169),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2169),
    [anon_sym_DASH] = ACTIONS(2166),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_AMP_AMP] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2166),
    [anon_sym_SEMI] = ACTIONS(2169),
    [anon_sym___extension__] = ACTIONS(2166),
    [anon_sym_typedef] = ACTIONS(2166),
    [anon_sym___device__] = ACTIONS(2166),
    [anon_sym___host__] = ACTIONS(2166),
    [anon_sym___global__] = ACTIONS(2166),
    [anon_sym___forceinline__] = ACTIONS(2166),
    [anon_sym___noinline__] = ACTIONS(2166),
    [anon_sym_extern] = ACTIONS(2166),
    [anon_sym___attribute__] = ACTIONS(2166),
    [anon_sym_COLON_COLON] = ACTIONS(2169),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2169),
    [anon_sym___declspec] = ACTIONS(2166),
    [anon_sym___based] = ACTIONS(2166),
    [anon_sym___cdecl] = ACTIONS(2166),
    [anon_sym___clrcall] = ACTIONS(2166),
    [anon_sym___stdcall] = ACTIONS(2166),
    [anon_sym___fastcall] = ACTIONS(2166),
    [anon_sym___thiscall] = ACTIONS(2166),
    [anon_sym___vectorcall] = ACTIONS(2166),
    [anon_sym_LBRACE] = ACTIONS(2169),
    [anon_sym_signed] = ACTIONS(2166),
    [anon_sym_unsigned] = ACTIONS(2166),
    [anon_sym_long] = ACTIONS(2166),
    [anon_sym_short] = ACTIONS(2166),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [anon_sym_static] = ACTIONS(2166),
    [anon_sym_register] = ACTIONS(2166),
    [anon_sym_inline] = ACTIONS(2166),
    [anon_sym___inline] = ACTIONS(2166),
    [anon_sym___inline__] = ACTIONS(2166),
    [anon_sym___forceinline] = ACTIONS(2166),
    [anon_sym_thread_local] = ACTIONS(2166),
    [anon_sym___thread] = ACTIONS(2166),
    [anon_sym_const] = ACTIONS(2166),
    [anon_sym_constexpr] = ACTIONS(2166),
    [anon_sym_volatile] = ACTIONS(2166),
    [anon_sym_restrict] = ACTIONS(2166),
    [anon_sym___restrict__] = ACTIONS(2166),
    [anon_sym__Atomic] = ACTIONS(2166),
    [anon_sym__Noreturn] = ACTIONS(2166),
    [anon_sym_noreturn] = ACTIONS(2166),
    [anon_sym_mutable] = ACTIONS(2166),
    [anon_sym_constinit] = ACTIONS(2166),
    [anon_sym_consteval] = ACTIONS(2166),
    [anon_sym___shared__] = ACTIONS(2166),
    [anon_sym___local__] = ACTIONS(2166),
    [anon_sym___constant__] = ACTIONS(2166),
    [anon_sym___managed__] = ACTIONS(2166),
    [anon_sym___grid_constant__] = ACTIONS(2166),
    [anon_sym_alignas] = ACTIONS(2166),
    [anon_sym__Alignas] = ACTIONS(2166),
    [sym_primitive_type] = ACTIONS(2166),
    [anon_sym_enum] = ACTIONS(2166),
    [anon_sym_class] = ACTIONS(2166),
    [anon_sym_struct] = ACTIONS(2166),
    [anon_sym_union] = ACTIONS(2166),
    [anon_sym_if] = ACTIONS(2166),
    [anon_sym_switch] = ACTIONS(2166),
    [anon_sym_case] = ACTIONS(2166),
    [anon_sym_default] = ACTIONS(2166),
    [anon_sym_while] = ACTIONS(2166),
    [anon_sym_do] = ACTIONS(2166),
    [anon_sym_for] = ACTIONS(2166),
    [anon_sym_return] = ACTIONS(2166),
    [anon_sym_break] = ACTIONS(2166),
    [anon_sym_continue] = ACTIONS(2166),
    [anon_sym_goto] = ACTIONS(2166),
    [anon_sym___try] = ACTIONS(2166),
    [anon_sym___leave] = ACTIONS(2166),
    [anon_sym_not] = ACTIONS(2166),
    [anon_sym_compl] = ACTIONS(2166),
    [anon_sym_DASH_DASH] = ACTIONS(2169),
    [anon_sym_PLUS_PLUS] = ACTIONS(2169),
    [anon_sym_sizeof] = ACTIONS(2166),
    [anon_sym___alignof__] = ACTIONS(2166),
    [anon_sym___alignof] = ACTIONS(2166),
    [anon_sym__alignof] = ACTIONS(2166),
    [anon_sym_alignof] = ACTIONS(2166),
    [anon_sym__Alignof] = ACTIONS(2166),
    [anon_sym_offsetof] = ACTIONS(2166),
    [anon_sym__Generic] = ACTIONS(2166),
    [anon_sym_asm] = ACTIONS(2166),
    [anon_sym___asm__] = ACTIONS(2166),
    [sym_number_literal] = ACTIONS(2169),
    [anon_sym_L_SQUOTE] = ACTIONS(2169),
    [anon_sym_u_SQUOTE] = ACTIONS(2169),
    [anon_sym_U_SQUOTE] = ACTIONS(2169),
    [anon_sym_u8_SQUOTE] = ACTIONS(2169),
    [anon_sym_SQUOTE] = ACTIONS(2169),
    [anon_sym_L_DQUOTE] = ACTIONS(2169),
    [anon_sym_u_DQUOTE] = ACTIONS(2169),
    [anon_sym_U_DQUOTE] = ACTIONS(2169),
    [anon_sym_u8_DQUOTE] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2169),
    [sym_true] = ACTIONS(2166),
    [sym_false] = ACTIONS(2166),
    [anon_sym_NULL] = ACTIONS(2166),
    [anon_sym_nullptr] = ACTIONS(2166),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2166),
    [anon_sym_decltype] = ACTIONS(2166),
    [sym_virtual] = ACTIONS(2166),
    [anon_sym_explicit] = ACTIONS(2166),
    [anon_sym_typename] = ACTIONS(2166),
    [anon_sym_template] = ACTIONS(2166),
    [anon_sym_operator] = ACTIONS(2166),
    [anon_sym_try] = ACTIONS(2166),
    [anon_sym_delete] = ACTIONS(2166),
    [anon_sym_throw] = ACTIONS(2166),
    [anon_sym_namespace] = ACTIONS(2166),
    [anon_sym_using] = ACTIONS(2166),
    [anon_sym_static_assert] = ACTIONS(2166),
    [anon_sym_concept] = ACTIONS(2166),
    [anon_sym_co_return] = ACTIONS(2166),
    [anon_sym_co_yield] = ACTIONS(2166),
    [anon_sym_R_DQUOTE] = ACTIONS(2169),
    [anon_sym_LR_DQUOTE] = ACTIONS(2169),
    [anon_sym_uR_DQUOTE] = ACTIONS(2169),
    [anon_sym_UR_DQUOTE] = ACTIONS(2169),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2169),
    [anon_sym_co_await] = ACTIONS(2166),
    [anon_sym_new] = ACTIONS(2166),
    [anon_sym_requires] = ACTIONS(2166),
    [sym_this] = ACTIONS(2166),
    [anon_sym___launch_bounds__] = ACTIONS(2166),
  },
  [445] = {
    [sym_identifier] = ACTIONS(2400),
    [aux_sym_preproc_include_token1] = ACTIONS(2400),
    [aux_sym_preproc_def_token1] = ACTIONS(2400),
    [aux_sym_preproc_if_token1] = ACTIONS(2400),
    [aux_sym_preproc_if_token2] = ACTIONS(2400),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2400),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2400),
    [sym_preproc_directive] = ACTIONS(2400),
    [anon_sym_LPAREN2] = ACTIONS(2402),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_TILDE] = ACTIONS(2402),
    [anon_sym_DASH] = ACTIONS(2400),
    [anon_sym_PLUS] = ACTIONS(2400),
    [anon_sym_STAR] = ACTIONS(2402),
    [anon_sym_AMP_AMP] = ACTIONS(2402),
    [anon_sym_AMP] = ACTIONS(2400),
    [anon_sym_SEMI] = ACTIONS(2402),
    [anon_sym___extension__] = ACTIONS(2400),
    [anon_sym_typedef] = ACTIONS(2400),
    [anon_sym___device__] = ACTIONS(2400),
    [anon_sym___host__] = ACTIONS(2400),
    [anon_sym___global__] = ACTIONS(2400),
    [anon_sym___forceinline__] = ACTIONS(2400),
    [anon_sym___noinline__] = ACTIONS(2400),
    [anon_sym_extern] = ACTIONS(2400),
    [anon_sym___attribute__] = ACTIONS(2400),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2402),
    [anon_sym___declspec] = ACTIONS(2400),
    [anon_sym___based] = ACTIONS(2400),
    [anon_sym___cdecl] = ACTIONS(2400),
    [anon_sym___clrcall] = ACTIONS(2400),
    [anon_sym___stdcall] = ACTIONS(2400),
    [anon_sym___fastcall] = ACTIONS(2400),
    [anon_sym___thiscall] = ACTIONS(2400),
    [anon_sym___vectorcall] = ACTIONS(2400),
    [anon_sym_LBRACE] = ACTIONS(2402),
    [anon_sym_signed] = ACTIONS(2400),
    [anon_sym_unsigned] = ACTIONS(2400),
    [anon_sym_long] = ACTIONS(2400),
    [anon_sym_short] = ACTIONS(2400),
    [anon_sym_LBRACK] = ACTIONS(2400),
    [anon_sym_static] = ACTIONS(2400),
    [anon_sym_register] = ACTIONS(2400),
    [anon_sym_inline] = ACTIONS(2400),
    [anon_sym___inline] = ACTIONS(2400),
    [anon_sym___inline__] = ACTIONS(2400),
    [anon_sym___forceinline] = ACTIONS(2400),
    [anon_sym_thread_local] = ACTIONS(2400),
    [anon_sym___thread] = ACTIONS(2400),
    [anon_sym_const] = ACTIONS(2400),
    [anon_sym_constexpr] = ACTIONS(2400),
    [anon_sym_volatile] = ACTIONS(2400),
    [anon_sym_restrict] = ACTIONS(2400),
    [anon_sym___restrict__] = ACTIONS(2400),
    [anon_sym__Atomic] = ACTIONS(2400),
    [anon_sym__Noreturn] = ACTIONS(2400),
    [anon_sym_noreturn] = ACTIONS(2400),
    [anon_sym_mutable] = ACTIONS(2400),
    [anon_sym_constinit] = ACTIONS(2400),
    [anon_sym_consteval] = ACTIONS(2400),
    [anon_sym___shared__] = ACTIONS(2400),
    [anon_sym___local__] = ACTIONS(2400),
    [anon_sym___constant__] = ACTIONS(2400),
    [anon_sym___managed__] = ACTIONS(2400),
    [anon_sym___grid_constant__] = ACTIONS(2400),
    [anon_sym_alignas] = ACTIONS(2400),
    [anon_sym__Alignas] = ACTIONS(2400),
    [sym_primitive_type] = ACTIONS(2400),
    [anon_sym_enum] = ACTIONS(2400),
    [anon_sym_class] = ACTIONS(2400),
    [anon_sym_struct] = ACTIONS(2400),
    [anon_sym_union] = ACTIONS(2400),
    [anon_sym_if] = ACTIONS(2400),
    [anon_sym_switch] = ACTIONS(2400),
    [anon_sym_case] = ACTIONS(2400),
    [anon_sym_default] = ACTIONS(2400),
    [anon_sym_while] = ACTIONS(2400),
    [anon_sym_do] = ACTIONS(2400),
    [anon_sym_for] = ACTIONS(2400),
    [anon_sym_return] = ACTIONS(2400),
    [anon_sym_break] = ACTIONS(2400),
    [anon_sym_continue] = ACTIONS(2400),
    [anon_sym_goto] = ACTIONS(2400),
    [anon_sym___try] = ACTIONS(2400),
    [anon_sym___leave] = ACTIONS(2400),
    [anon_sym_not] = ACTIONS(2400),
    [anon_sym_compl] = ACTIONS(2400),
    [anon_sym_DASH_DASH] = ACTIONS(2402),
    [anon_sym_PLUS_PLUS] = ACTIONS(2402),
    [anon_sym_sizeof] = ACTIONS(2400),
    [anon_sym___alignof__] = ACTIONS(2400),
    [anon_sym___alignof] = ACTIONS(2400),
    [anon_sym__alignof] = ACTIONS(2400),
    [anon_sym_alignof] = ACTIONS(2400),
    [anon_sym__Alignof] = ACTIONS(2400),
    [anon_sym_offsetof] = ACTIONS(2400),
    [anon_sym__Generic] = ACTIONS(2400),
    [anon_sym_asm] = ACTIONS(2400),
    [anon_sym___asm__] = ACTIONS(2400),
    [sym_number_literal] = ACTIONS(2402),
    [anon_sym_L_SQUOTE] = ACTIONS(2402),
    [anon_sym_u_SQUOTE] = ACTIONS(2402),
    [anon_sym_U_SQUOTE] = ACTIONS(2402),
    [anon_sym_u8_SQUOTE] = ACTIONS(2402),
    [anon_sym_SQUOTE] = ACTIONS(2402),
    [anon_sym_L_DQUOTE] = ACTIONS(2402),
    [anon_sym_u_DQUOTE] = ACTIONS(2402),
    [anon_sym_U_DQUOTE] = ACTIONS(2402),
    [anon_sym_u8_DQUOTE] = ACTIONS(2402),
    [anon_sym_DQUOTE] = ACTIONS(2402),
    [sym_true] = ACTIONS(2400),
    [sym_false] = ACTIONS(2400),
    [anon_sym_NULL] = ACTIONS(2400),
    [anon_sym_nullptr] = ACTIONS(2400),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2400),
    [anon_sym_decltype] = ACTIONS(2400),
    [sym_virtual] = ACTIONS(2400),
    [anon_sym_explicit] = ACTIONS(2400),
    [anon_sym_typename] = ACTIONS(2400),
    [anon_sym_template] = ACTIONS(2400),
    [anon_sym_operator] = ACTIONS(2400),
    [anon_sym_try] = ACTIONS(2400),
    [anon_sym_delete] = ACTIONS(2400),
    [anon_sym_throw] = ACTIONS(2400),
    [anon_sym_namespace] = ACTIONS(2400),
    [anon_sym_using] = ACTIONS(2400),
    [anon_sym_static_assert] = ACTIONS(2400),
    [anon_sym_concept] = ACTIONS(2400),
    [anon_sym_co_return] = ACTIONS(2400),
    [anon_sym_co_yield] = ACTIONS(2400),
    [anon_sym_R_DQUOTE] = ACTIONS(2402),
    [anon_sym_LR_DQUOTE] = ACTIONS(2402),
    [anon_sym_uR_DQUOTE] = ACTIONS(2402),
    [anon_sym_UR_DQUOTE] = ACTIONS(2402),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2402),
    [anon_sym_co_await] = ACTIONS(2400),
    [anon_sym_new] = ACTIONS(2400),
    [anon_sym_requires] = ACTIONS(2400),
    [sym_this] = ACTIONS(2400),
    [anon_sym___launch_bounds__] = ACTIONS(2400),
  },
  [446] = {
    [sym_identifier] = ACTIONS(2465),
    [aux_sym_preproc_include_token1] = ACTIONS(2465),
    [aux_sym_preproc_def_token1] = ACTIONS(2465),
    [aux_sym_preproc_if_token1] = ACTIONS(2465),
    [aux_sym_preproc_if_token2] = ACTIONS(2465),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2465),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2465),
    [sym_preproc_directive] = ACTIONS(2465),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(2467),
    [anon_sym_TILDE] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(2465),
    [anon_sym_PLUS] = ACTIONS(2465),
    [anon_sym_STAR] = ACTIONS(2467),
    [anon_sym_AMP_AMP] = ACTIONS(2467),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym_SEMI] = ACTIONS(2467),
    [anon_sym___extension__] = ACTIONS(2465),
    [anon_sym_typedef] = ACTIONS(2465),
    [anon_sym___device__] = ACTIONS(2465),
    [anon_sym___host__] = ACTIONS(2465),
    [anon_sym___global__] = ACTIONS(2465),
    [anon_sym___forceinline__] = ACTIONS(2465),
    [anon_sym___noinline__] = ACTIONS(2465),
    [anon_sym_extern] = ACTIONS(2465),
    [anon_sym___attribute__] = ACTIONS(2465),
    [anon_sym_COLON_COLON] = ACTIONS(2467),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2467),
    [anon_sym___declspec] = ACTIONS(2465),
    [anon_sym___based] = ACTIONS(2465),
    [anon_sym___cdecl] = ACTIONS(2465),
    [anon_sym___clrcall] = ACTIONS(2465),
    [anon_sym___stdcall] = ACTIONS(2465),
    [anon_sym___fastcall] = ACTIONS(2465),
    [anon_sym___thiscall] = ACTIONS(2465),
    [anon_sym___vectorcall] = ACTIONS(2465),
    [anon_sym_LBRACE] = ACTIONS(2467),
    [anon_sym_signed] = ACTIONS(2465),
    [anon_sym_unsigned] = ACTIONS(2465),
    [anon_sym_long] = ACTIONS(2465),
    [anon_sym_short] = ACTIONS(2465),
    [anon_sym_LBRACK] = ACTIONS(2465),
    [anon_sym_static] = ACTIONS(2465),
    [anon_sym_register] = ACTIONS(2465),
    [anon_sym_inline] = ACTIONS(2465),
    [anon_sym___inline] = ACTIONS(2465),
    [anon_sym___inline__] = ACTIONS(2465),
    [anon_sym___forceinline] = ACTIONS(2465),
    [anon_sym_thread_local] = ACTIONS(2465),
    [anon_sym___thread] = ACTIONS(2465),
    [anon_sym_const] = ACTIONS(2465),
    [anon_sym_constexpr] = ACTIONS(2465),
    [anon_sym_volatile] = ACTIONS(2465),
    [anon_sym_restrict] = ACTIONS(2465),
    [anon_sym___restrict__] = ACTIONS(2465),
    [anon_sym__Atomic] = ACTIONS(2465),
    [anon_sym__Noreturn] = ACTIONS(2465),
    [anon_sym_noreturn] = ACTIONS(2465),
    [anon_sym_mutable] = ACTIONS(2465),
    [anon_sym_constinit] = ACTIONS(2465),
    [anon_sym_consteval] = ACTIONS(2465),
    [anon_sym___shared__] = ACTIONS(2465),
    [anon_sym___local__] = ACTIONS(2465),
    [anon_sym___constant__] = ACTIONS(2465),
    [anon_sym___managed__] = ACTIONS(2465),
    [anon_sym___grid_constant__] = ACTIONS(2465),
    [anon_sym_alignas] = ACTIONS(2465),
    [anon_sym__Alignas] = ACTIONS(2465),
    [sym_primitive_type] = ACTIONS(2465),
    [anon_sym_enum] = ACTIONS(2465),
    [anon_sym_class] = ACTIONS(2465),
    [anon_sym_struct] = ACTIONS(2465),
    [anon_sym_union] = ACTIONS(2465),
    [anon_sym_if] = ACTIONS(2465),
    [anon_sym_switch] = ACTIONS(2465),
    [anon_sym_case] = ACTIONS(2465),
    [anon_sym_default] = ACTIONS(2465),
    [anon_sym_while] = ACTIONS(2465),
    [anon_sym_do] = ACTIONS(2465),
    [anon_sym_for] = ACTIONS(2465),
    [anon_sym_return] = ACTIONS(2465),
    [anon_sym_break] = ACTIONS(2465),
    [anon_sym_continue] = ACTIONS(2465),
    [anon_sym_goto] = ACTIONS(2465),
    [anon_sym___try] = ACTIONS(2465),
    [anon_sym___leave] = ACTIONS(2465),
    [anon_sym_not] = ACTIONS(2465),
    [anon_sym_compl] = ACTIONS(2465),
    [anon_sym_DASH_DASH] = ACTIONS(2467),
    [anon_sym_PLUS_PLUS] = ACTIONS(2467),
    [anon_sym_sizeof] = ACTIONS(2465),
    [anon_sym___alignof__] = ACTIONS(2465),
    [anon_sym___alignof] = ACTIONS(2465),
    [anon_sym__alignof] = ACTIONS(2465),
    [anon_sym_alignof] = ACTIONS(2465),
    [anon_sym__Alignof] = ACTIONS(2465),
    [anon_sym_offsetof] = ACTIONS(2465),
    [anon_sym__Generic] = ACTIONS(2465),
    [anon_sym_asm] = ACTIONS(2465),
    [anon_sym___asm__] = ACTIONS(2465),
    [sym_number_literal] = ACTIONS(2467),
    [anon_sym_L_SQUOTE] = ACTIONS(2467),
    [anon_sym_u_SQUOTE] = ACTIONS(2467),
    [anon_sym_U_SQUOTE] = ACTIONS(2467),
    [anon_sym_u8_SQUOTE] = ACTIONS(2467),
    [anon_sym_SQUOTE] = ACTIONS(2467),
    [anon_sym_L_DQUOTE] = ACTIONS(2467),
    [anon_sym_u_DQUOTE] = ACTIONS(2467),
    [anon_sym_U_DQUOTE] = ACTIONS(2467),
    [anon_sym_u8_DQUOTE] = ACTIONS(2467),
    [anon_sym_DQUOTE] = ACTIONS(2467),
    [sym_true] = ACTIONS(2465),
    [sym_false] = ACTIONS(2465),
    [anon_sym_NULL] = ACTIONS(2465),
    [anon_sym_nullptr] = ACTIONS(2465),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2465),
    [anon_sym_decltype] = ACTIONS(2465),
    [sym_virtual] = ACTIONS(2465),
    [anon_sym_explicit] = ACTIONS(2465),
    [anon_sym_typename] = ACTIONS(2465),
    [anon_sym_template] = ACTIONS(2465),
    [anon_sym_operator] = ACTIONS(2465),
    [anon_sym_try] = ACTIONS(2465),
    [anon_sym_delete] = ACTIONS(2465),
    [anon_sym_throw] = ACTIONS(2465),
    [anon_sym_namespace] = ACTIONS(2465),
    [anon_sym_using] = ACTIONS(2465),
    [anon_sym_static_assert] = ACTIONS(2465),
    [anon_sym_concept] = ACTIONS(2465),
    [anon_sym_co_return] = ACTIONS(2465),
    [anon_sym_co_yield] = ACTIONS(2465),
    [anon_sym_R_DQUOTE] = ACTIONS(2467),
    [anon_sym_LR_DQUOTE] = ACTIONS(2467),
    [anon_sym_uR_DQUOTE] = ACTIONS(2467),
    [anon_sym_UR_DQUOTE] = ACTIONS(2467),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2467),
    [anon_sym_co_await] = ACTIONS(2465),
    [anon_sym_new] = ACTIONS(2465),
    [anon_sym_requires] = ACTIONS(2465),
    [sym_this] = ACTIONS(2465),
    [anon_sym___launch_bounds__] = ACTIONS(2465),
  },
  [447] = {
    [sym_identifier] = ACTIONS(2384),
    [aux_sym_preproc_include_token1] = ACTIONS(2384),
    [aux_sym_preproc_def_token1] = ACTIONS(2384),
    [aux_sym_preproc_if_token1] = ACTIONS(2384),
    [aux_sym_preproc_if_token2] = ACTIONS(2384),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2384),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2384),
    [sym_preproc_directive] = ACTIONS(2384),
    [anon_sym_LPAREN2] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2386),
    [anon_sym_TILDE] = ACTIONS(2386),
    [anon_sym_DASH] = ACTIONS(2384),
    [anon_sym_PLUS] = ACTIONS(2384),
    [anon_sym_STAR] = ACTIONS(2386),
    [anon_sym_AMP_AMP] = ACTIONS(2386),
    [anon_sym_AMP] = ACTIONS(2384),
    [anon_sym_SEMI] = ACTIONS(2386),
    [anon_sym___extension__] = ACTIONS(2384),
    [anon_sym_typedef] = ACTIONS(2384),
    [anon_sym___device__] = ACTIONS(2384),
    [anon_sym___host__] = ACTIONS(2384),
    [anon_sym___global__] = ACTIONS(2384),
    [anon_sym___forceinline__] = ACTIONS(2384),
    [anon_sym___noinline__] = ACTIONS(2384),
    [anon_sym_extern] = ACTIONS(2384),
    [anon_sym___attribute__] = ACTIONS(2384),
    [anon_sym_COLON_COLON] = ACTIONS(2386),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2386),
    [anon_sym___declspec] = ACTIONS(2384),
    [anon_sym___based] = ACTIONS(2384),
    [anon_sym___cdecl] = ACTIONS(2384),
    [anon_sym___clrcall] = ACTIONS(2384),
    [anon_sym___stdcall] = ACTIONS(2384),
    [anon_sym___fastcall] = ACTIONS(2384),
    [anon_sym___thiscall] = ACTIONS(2384),
    [anon_sym___vectorcall] = ACTIONS(2384),
    [anon_sym_LBRACE] = ACTIONS(2386),
    [anon_sym_signed] = ACTIONS(2384),
    [anon_sym_unsigned] = ACTIONS(2384),
    [anon_sym_long] = ACTIONS(2384),
    [anon_sym_short] = ACTIONS(2384),
    [anon_sym_LBRACK] = ACTIONS(2384),
    [anon_sym_static] = ACTIONS(2384),
    [anon_sym_register] = ACTIONS(2384),
    [anon_sym_inline] = ACTIONS(2384),
    [anon_sym___inline] = ACTIONS(2384),
    [anon_sym___inline__] = ACTIONS(2384),
    [anon_sym___forceinline] = ACTIONS(2384),
    [anon_sym_thread_local] = ACTIONS(2384),
    [anon_sym___thread] = ACTIONS(2384),
    [anon_sym_const] = ACTIONS(2384),
    [anon_sym_constexpr] = ACTIONS(2384),
    [anon_sym_volatile] = ACTIONS(2384),
    [anon_sym_restrict] = ACTIONS(2384),
    [anon_sym___restrict__] = ACTIONS(2384),
    [anon_sym__Atomic] = ACTIONS(2384),
    [anon_sym__Noreturn] = ACTIONS(2384),
    [anon_sym_noreturn] = ACTIONS(2384),
    [anon_sym_mutable] = ACTIONS(2384),
    [anon_sym_constinit] = ACTIONS(2384),
    [anon_sym_consteval] = ACTIONS(2384),
    [anon_sym___shared__] = ACTIONS(2384),
    [anon_sym___local__] = ACTIONS(2384),
    [anon_sym___constant__] = ACTIONS(2384),
    [anon_sym___managed__] = ACTIONS(2384),
    [anon_sym___grid_constant__] = ACTIONS(2384),
    [anon_sym_alignas] = ACTIONS(2384),
    [anon_sym__Alignas] = ACTIONS(2384),
    [sym_primitive_type] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2384),
    [anon_sym_class] = ACTIONS(2384),
    [anon_sym_struct] = ACTIONS(2384),
    [anon_sym_union] = ACTIONS(2384),
    [anon_sym_if] = ACTIONS(2384),
    [anon_sym_switch] = ACTIONS(2384),
    [anon_sym_case] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2384),
    [anon_sym_while] = ACTIONS(2384),
    [anon_sym_do] = ACTIONS(2384),
    [anon_sym_for] = ACTIONS(2384),
    [anon_sym_return] = ACTIONS(2384),
    [anon_sym_break] = ACTIONS(2384),
    [anon_sym_continue] = ACTIONS(2384),
    [anon_sym_goto] = ACTIONS(2384),
    [anon_sym___try] = ACTIONS(2384),
    [anon_sym___leave] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_compl] = ACTIONS(2384),
    [anon_sym_DASH_DASH] = ACTIONS(2386),
    [anon_sym_PLUS_PLUS] = ACTIONS(2386),
    [anon_sym_sizeof] = ACTIONS(2384),
    [anon_sym___alignof__] = ACTIONS(2384),
    [anon_sym___alignof] = ACTIONS(2384),
    [anon_sym__alignof] = ACTIONS(2384),
    [anon_sym_alignof] = ACTIONS(2384),
    [anon_sym__Alignof] = ACTIONS(2384),
    [anon_sym_offsetof] = ACTIONS(2384),
    [anon_sym__Generic] = ACTIONS(2384),
    [anon_sym_asm] = ACTIONS(2384),
    [anon_sym___asm__] = ACTIONS(2384),
    [sym_number_literal] = ACTIONS(2386),
    [anon_sym_L_SQUOTE] = ACTIONS(2386),
    [anon_sym_u_SQUOTE] = ACTIONS(2386),
    [anon_sym_U_SQUOTE] = ACTIONS(2386),
    [anon_sym_u8_SQUOTE] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2386),
    [anon_sym_L_DQUOTE] = ACTIONS(2386),
    [anon_sym_u_DQUOTE] = ACTIONS(2386),
    [anon_sym_U_DQUOTE] = ACTIONS(2386),
    [anon_sym_u8_DQUOTE] = ACTIONS(2386),
    [anon_sym_DQUOTE] = ACTIONS(2386),
    [sym_true] = ACTIONS(2384),
    [sym_false] = ACTIONS(2384),
    [anon_sym_NULL] = ACTIONS(2384),
    [anon_sym_nullptr] = ACTIONS(2384),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2384),
    [anon_sym_decltype] = ACTIONS(2384),
    [sym_virtual] = ACTIONS(2384),
    [anon_sym_explicit] = ACTIONS(2384),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(2384),
    [anon_sym_operator] = ACTIONS(2384),
    [anon_sym_try] = ACTIONS(2384),
    [anon_sym_delete] = ACTIONS(2384),
    [anon_sym_throw] = ACTIONS(2384),
    [anon_sym_namespace] = ACTIONS(2384),
    [anon_sym_using] = ACTIONS(2384),
    [anon_sym_static_assert] = ACTIONS(2384),
    [anon_sym_concept] = ACTIONS(2384),
    [anon_sym_co_return] = ACTIONS(2384),
    [anon_sym_co_yield] = ACTIONS(2384),
    [anon_sym_R_DQUOTE] = ACTIONS(2386),
    [anon_sym_LR_DQUOTE] = ACTIONS(2386),
    [anon_sym_uR_DQUOTE] = ACTIONS(2386),
    [anon_sym_UR_DQUOTE] = ACTIONS(2386),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2386),
    [anon_sym_co_await] = ACTIONS(2384),
    [anon_sym_new] = ACTIONS(2384),
    [anon_sym_requires] = ACTIONS(2384),
    [sym_this] = ACTIONS(2384),
    [anon_sym___launch_bounds__] = ACTIONS(2384),
  },
  [448] = {
    [sym_identifier] = ACTIONS(2384),
    [aux_sym_preproc_include_token1] = ACTIONS(2384),
    [aux_sym_preproc_def_token1] = ACTIONS(2384),
    [aux_sym_preproc_if_token1] = ACTIONS(2384),
    [aux_sym_preproc_if_token2] = ACTIONS(2384),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2384),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2384),
    [sym_preproc_directive] = ACTIONS(2384),
    [anon_sym_LPAREN2] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2386),
    [anon_sym_TILDE] = ACTIONS(2386),
    [anon_sym_DASH] = ACTIONS(2384),
    [anon_sym_PLUS] = ACTIONS(2384),
    [anon_sym_STAR] = ACTIONS(2386),
    [anon_sym_AMP_AMP] = ACTIONS(2386),
    [anon_sym_AMP] = ACTIONS(2384),
    [anon_sym_SEMI] = ACTIONS(2386),
    [anon_sym___extension__] = ACTIONS(2384),
    [anon_sym_typedef] = ACTIONS(2384),
    [anon_sym___device__] = ACTIONS(2384),
    [anon_sym___host__] = ACTIONS(2384),
    [anon_sym___global__] = ACTIONS(2384),
    [anon_sym___forceinline__] = ACTIONS(2384),
    [anon_sym___noinline__] = ACTIONS(2384),
    [anon_sym_extern] = ACTIONS(2384),
    [anon_sym___attribute__] = ACTIONS(2384),
    [anon_sym_COLON_COLON] = ACTIONS(2386),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2386),
    [anon_sym___declspec] = ACTIONS(2384),
    [anon_sym___based] = ACTIONS(2384),
    [anon_sym___cdecl] = ACTIONS(2384),
    [anon_sym___clrcall] = ACTIONS(2384),
    [anon_sym___stdcall] = ACTIONS(2384),
    [anon_sym___fastcall] = ACTIONS(2384),
    [anon_sym___thiscall] = ACTIONS(2384),
    [anon_sym___vectorcall] = ACTIONS(2384),
    [anon_sym_LBRACE] = ACTIONS(2386),
    [anon_sym_signed] = ACTIONS(2384),
    [anon_sym_unsigned] = ACTIONS(2384),
    [anon_sym_long] = ACTIONS(2384),
    [anon_sym_short] = ACTIONS(2384),
    [anon_sym_LBRACK] = ACTIONS(2384),
    [anon_sym_static] = ACTIONS(2384),
    [anon_sym_register] = ACTIONS(2384),
    [anon_sym_inline] = ACTIONS(2384),
    [anon_sym___inline] = ACTIONS(2384),
    [anon_sym___inline__] = ACTIONS(2384),
    [anon_sym___forceinline] = ACTIONS(2384),
    [anon_sym_thread_local] = ACTIONS(2384),
    [anon_sym___thread] = ACTIONS(2384),
    [anon_sym_const] = ACTIONS(2384),
    [anon_sym_constexpr] = ACTIONS(2384),
    [anon_sym_volatile] = ACTIONS(2384),
    [anon_sym_restrict] = ACTIONS(2384),
    [anon_sym___restrict__] = ACTIONS(2384),
    [anon_sym__Atomic] = ACTIONS(2384),
    [anon_sym__Noreturn] = ACTIONS(2384),
    [anon_sym_noreturn] = ACTIONS(2384),
    [anon_sym_mutable] = ACTIONS(2384),
    [anon_sym_constinit] = ACTIONS(2384),
    [anon_sym_consteval] = ACTIONS(2384),
    [anon_sym___shared__] = ACTIONS(2384),
    [anon_sym___local__] = ACTIONS(2384),
    [anon_sym___constant__] = ACTIONS(2384),
    [anon_sym___managed__] = ACTIONS(2384),
    [anon_sym___grid_constant__] = ACTIONS(2384),
    [anon_sym_alignas] = ACTIONS(2384),
    [anon_sym__Alignas] = ACTIONS(2384),
    [sym_primitive_type] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2384),
    [anon_sym_class] = ACTIONS(2384),
    [anon_sym_struct] = ACTIONS(2384),
    [anon_sym_union] = ACTIONS(2384),
    [anon_sym_if] = ACTIONS(2384),
    [anon_sym_switch] = ACTIONS(2384),
    [anon_sym_case] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2384),
    [anon_sym_while] = ACTIONS(2384),
    [anon_sym_do] = ACTIONS(2384),
    [anon_sym_for] = ACTIONS(2384),
    [anon_sym_return] = ACTIONS(2384),
    [anon_sym_break] = ACTIONS(2384),
    [anon_sym_continue] = ACTIONS(2384),
    [anon_sym_goto] = ACTIONS(2384),
    [anon_sym___try] = ACTIONS(2384),
    [anon_sym___leave] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_compl] = ACTIONS(2384),
    [anon_sym_DASH_DASH] = ACTIONS(2386),
    [anon_sym_PLUS_PLUS] = ACTIONS(2386),
    [anon_sym_sizeof] = ACTIONS(2384),
    [anon_sym___alignof__] = ACTIONS(2384),
    [anon_sym___alignof] = ACTIONS(2384),
    [anon_sym__alignof] = ACTIONS(2384),
    [anon_sym_alignof] = ACTIONS(2384),
    [anon_sym__Alignof] = ACTIONS(2384),
    [anon_sym_offsetof] = ACTIONS(2384),
    [anon_sym__Generic] = ACTIONS(2384),
    [anon_sym_asm] = ACTIONS(2384),
    [anon_sym___asm__] = ACTIONS(2384),
    [sym_number_literal] = ACTIONS(2386),
    [anon_sym_L_SQUOTE] = ACTIONS(2386),
    [anon_sym_u_SQUOTE] = ACTIONS(2386),
    [anon_sym_U_SQUOTE] = ACTIONS(2386),
    [anon_sym_u8_SQUOTE] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2386),
    [anon_sym_L_DQUOTE] = ACTIONS(2386),
    [anon_sym_u_DQUOTE] = ACTIONS(2386),
    [anon_sym_U_DQUOTE] = ACTIONS(2386),
    [anon_sym_u8_DQUOTE] = ACTIONS(2386),
    [anon_sym_DQUOTE] = ACTIONS(2386),
    [sym_true] = ACTIONS(2384),
    [sym_false] = ACTIONS(2384),
    [anon_sym_NULL] = ACTIONS(2384),
    [anon_sym_nullptr] = ACTIONS(2384),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2384),
    [anon_sym_decltype] = ACTIONS(2384),
    [sym_virtual] = ACTIONS(2384),
    [anon_sym_explicit] = ACTIONS(2384),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(2384),
    [anon_sym_operator] = ACTIONS(2384),
    [anon_sym_try] = ACTIONS(2384),
    [anon_sym_delete] = ACTIONS(2384),
    [anon_sym_throw] = ACTIONS(2384),
    [anon_sym_namespace] = ACTIONS(2384),
    [anon_sym_using] = ACTIONS(2384),
    [anon_sym_static_assert] = ACTIONS(2384),
    [anon_sym_concept] = ACTIONS(2384),
    [anon_sym_co_return] = ACTIONS(2384),
    [anon_sym_co_yield] = ACTIONS(2384),
    [anon_sym_R_DQUOTE] = ACTIONS(2386),
    [anon_sym_LR_DQUOTE] = ACTIONS(2386),
    [anon_sym_uR_DQUOTE] = ACTIONS(2386),
    [anon_sym_UR_DQUOTE] = ACTIONS(2386),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2386),
    [anon_sym_co_await] = ACTIONS(2384),
    [anon_sym_new] = ACTIONS(2384),
    [anon_sym_requires] = ACTIONS(2384),
    [sym_this] = ACTIONS(2384),
    [anon_sym___launch_bounds__] = ACTIONS(2384),
  },
  [449] = {
    [sym_identifier] = ACTIONS(2370),
    [aux_sym_preproc_include_token1] = ACTIONS(2370),
    [aux_sym_preproc_def_token1] = ACTIONS(2370),
    [aux_sym_preproc_if_token1] = ACTIONS(2370),
    [aux_sym_preproc_if_token2] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2370),
    [sym_preproc_directive] = ACTIONS(2370),
    [anon_sym_LPAREN2] = ACTIONS(2372),
    [anon_sym_BANG] = ACTIONS(2372),
    [anon_sym_TILDE] = ACTIONS(2372),
    [anon_sym_DASH] = ACTIONS(2370),
    [anon_sym_PLUS] = ACTIONS(2370),
    [anon_sym_STAR] = ACTIONS(2372),
    [anon_sym_AMP_AMP] = ACTIONS(2372),
    [anon_sym_AMP] = ACTIONS(2370),
    [anon_sym_SEMI] = ACTIONS(2372),
    [anon_sym___extension__] = ACTIONS(2370),
    [anon_sym_typedef] = ACTIONS(2370),
    [anon_sym___device__] = ACTIONS(2370),
    [anon_sym___host__] = ACTIONS(2370),
    [anon_sym___global__] = ACTIONS(2370),
    [anon_sym___forceinline__] = ACTIONS(2370),
    [anon_sym___noinline__] = ACTIONS(2370),
    [anon_sym_extern] = ACTIONS(2370),
    [anon_sym___attribute__] = ACTIONS(2370),
    [anon_sym_COLON_COLON] = ACTIONS(2372),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2372),
    [anon_sym___declspec] = ACTIONS(2370),
    [anon_sym___based] = ACTIONS(2370),
    [anon_sym___cdecl] = ACTIONS(2370),
    [anon_sym___clrcall] = ACTIONS(2370),
    [anon_sym___stdcall] = ACTIONS(2370),
    [anon_sym___fastcall] = ACTIONS(2370),
    [anon_sym___thiscall] = ACTIONS(2370),
    [anon_sym___vectorcall] = ACTIONS(2370),
    [anon_sym_LBRACE] = ACTIONS(2372),
    [anon_sym_signed] = ACTIONS(2370),
    [anon_sym_unsigned] = ACTIONS(2370),
    [anon_sym_long] = ACTIONS(2370),
    [anon_sym_short] = ACTIONS(2370),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_static] = ACTIONS(2370),
    [anon_sym_register] = ACTIONS(2370),
    [anon_sym_inline] = ACTIONS(2370),
    [anon_sym___inline] = ACTIONS(2370),
    [anon_sym___inline__] = ACTIONS(2370),
    [anon_sym___forceinline] = ACTIONS(2370),
    [anon_sym_thread_local] = ACTIONS(2370),
    [anon_sym___thread] = ACTIONS(2370),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_constexpr] = ACTIONS(2370),
    [anon_sym_volatile] = ACTIONS(2370),
    [anon_sym_restrict] = ACTIONS(2370),
    [anon_sym___restrict__] = ACTIONS(2370),
    [anon_sym__Atomic] = ACTIONS(2370),
    [anon_sym__Noreturn] = ACTIONS(2370),
    [anon_sym_noreturn] = ACTIONS(2370),
    [anon_sym_mutable] = ACTIONS(2370),
    [anon_sym_constinit] = ACTIONS(2370),
    [anon_sym_consteval] = ACTIONS(2370),
    [anon_sym___shared__] = ACTIONS(2370),
    [anon_sym___local__] = ACTIONS(2370),
    [anon_sym___constant__] = ACTIONS(2370),
    [anon_sym___managed__] = ACTIONS(2370),
    [anon_sym___grid_constant__] = ACTIONS(2370),
    [anon_sym_alignas] = ACTIONS(2370),
    [anon_sym__Alignas] = ACTIONS(2370),
    [sym_primitive_type] = ACTIONS(2370),
    [anon_sym_enum] = ACTIONS(2370),
    [anon_sym_class] = ACTIONS(2370),
    [anon_sym_struct] = ACTIONS(2370),
    [anon_sym_union] = ACTIONS(2370),
    [anon_sym_if] = ACTIONS(2370),
    [anon_sym_switch] = ACTIONS(2370),
    [anon_sym_case] = ACTIONS(2370),
    [anon_sym_default] = ACTIONS(2370),
    [anon_sym_while] = ACTIONS(2370),
    [anon_sym_do] = ACTIONS(2370),
    [anon_sym_for] = ACTIONS(2370),
    [anon_sym_return] = ACTIONS(2370),
    [anon_sym_break] = ACTIONS(2370),
    [anon_sym_continue] = ACTIONS(2370),
    [anon_sym_goto] = ACTIONS(2370),
    [anon_sym___try] = ACTIONS(2370),
    [anon_sym___leave] = ACTIONS(2370),
    [anon_sym_not] = ACTIONS(2370),
    [anon_sym_compl] = ACTIONS(2370),
    [anon_sym_DASH_DASH] = ACTIONS(2372),
    [anon_sym_PLUS_PLUS] = ACTIONS(2372),
    [anon_sym_sizeof] = ACTIONS(2370),
    [anon_sym___alignof__] = ACTIONS(2370),
    [anon_sym___alignof] = ACTIONS(2370),
    [anon_sym__alignof] = ACTIONS(2370),
    [anon_sym_alignof] = ACTIONS(2370),
    [anon_sym__Alignof] = ACTIONS(2370),
    [anon_sym_offsetof] = ACTIONS(2370),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2370),
    [anon_sym___asm__] = ACTIONS(2370),
    [sym_number_literal] = ACTIONS(2372),
    [anon_sym_L_SQUOTE] = ACTIONS(2372),
    [anon_sym_u_SQUOTE] = ACTIONS(2372),
    [anon_sym_U_SQUOTE] = ACTIONS(2372),
    [anon_sym_u8_SQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [anon_sym_L_DQUOTE] = ACTIONS(2372),
    [anon_sym_u_DQUOTE] = ACTIONS(2372),
    [anon_sym_U_DQUOTE] = ACTIONS(2372),
    [anon_sym_u8_DQUOTE] = ACTIONS(2372),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [sym_true] = ACTIONS(2370),
    [sym_false] = ACTIONS(2370),
    [anon_sym_NULL] = ACTIONS(2370),
    [anon_sym_nullptr] = ACTIONS(2370),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2370),
    [anon_sym_decltype] = ACTIONS(2370),
    [sym_virtual] = ACTIONS(2370),
    [anon_sym_explicit] = ACTIONS(2370),
    [anon_sym_typename] = ACTIONS(2370),
    [anon_sym_template] = ACTIONS(2370),
    [anon_sym_operator] = ACTIONS(2370),
    [anon_sym_try] = ACTIONS(2370),
    [anon_sym_delete] = ACTIONS(2370),
    [anon_sym_throw] = ACTIONS(2370),
    [anon_sym_namespace] = ACTIONS(2370),
    [anon_sym_using] = ACTIONS(2370),
    [anon_sym_static_assert] = ACTIONS(2370),
    [anon_sym_concept] = ACTIONS(2370),
    [anon_sym_co_return] = ACTIONS(2370),
    [anon_sym_co_yield] = ACTIONS(2370),
    [anon_sym_R_DQUOTE] = ACTIONS(2372),
    [anon_sym_LR_DQUOTE] = ACTIONS(2372),
    [anon_sym_uR_DQUOTE] = ACTIONS(2372),
    [anon_sym_UR_DQUOTE] = ACTIONS(2372),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2372),
    [anon_sym_co_await] = ACTIONS(2370),
    [anon_sym_new] = ACTIONS(2370),
    [anon_sym_requires] = ACTIONS(2370),
    [sym_this] = ACTIONS(2370),
    [anon_sym___launch_bounds__] = ACTIONS(2370),
  },
  [450] = {
    [sym_identifier] = ACTIONS(2370),
    [aux_sym_preproc_include_token1] = ACTIONS(2370),
    [aux_sym_preproc_def_token1] = ACTIONS(2370),
    [aux_sym_preproc_if_token1] = ACTIONS(2370),
    [aux_sym_preproc_if_token2] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2370),
    [sym_preproc_directive] = ACTIONS(2370),
    [anon_sym_LPAREN2] = ACTIONS(2372),
    [anon_sym_BANG] = ACTIONS(2372),
    [anon_sym_TILDE] = ACTIONS(2372),
    [anon_sym_DASH] = ACTIONS(2370),
    [anon_sym_PLUS] = ACTIONS(2370),
    [anon_sym_STAR] = ACTIONS(2372),
    [anon_sym_AMP_AMP] = ACTIONS(2372),
    [anon_sym_AMP] = ACTIONS(2370),
    [anon_sym_SEMI] = ACTIONS(2372),
    [anon_sym___extension__] = ACTIONS(2370),
    [anon_sym_typedef] = ACTIONS(2370),
    [anon_sym___device__] = ACTIONS(2370),
    [anon_sym___host__] = ACTIONS(2370),
    [anon_sym___global__] = ACTIONS(2370),
    [anon_sym___forceinline__] = ACTIONS(2370),
    [anon_sym___noinline__] = ACTIONS(2370),
    [anon_sym_extern] = ACTIONS(2370),
    [anon_sym___attribute__] = ACTIONS(2370),
    [anon_sym_COLON_COLON] = ACTIONS(2372),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2372),
    [anon_sym___declspec] = ACTIONS(2370),
    [anon_sym___based] = ACTIONS(2370),
    [anon_sym___cdecl] = ACTIONS(2370),
    [anon_sym___clrcall] = ACTIONS(2370),
    [anon_sym___stdcall] = ACTIONS(2370),
    [anon_sym___fastcall] = ACTIONS(2370),
    [anon_sym___thiscall] = ACTIONS(2370),
    [anon_sym___vectorcall] = ACTIONS(2370),
    [anon_sym_LBRACE] = ACTIONS(2372),
    [anon_sym_signed] = ACTIONS(2370),
    [anon_sym_unsigned] = ACTIONS(2370),
    [anon_sym_long] = ACTIONS(2370),
    [anon_sym_short] = ACTIONS(2370),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_static] = ACTIONS(2370),
    [anon_sym_register] = ACTIONS(2370),
    [anon_sym_inline] = ACTIONS(2370),
    [anon_sym___inline] = ACTIONS(2370),
    [anon_sym___inline__] = ACTIONS(2370),
    [anon_sym___forceinline] = ACTIONS(2370),
    [anon_sym_thread_local] = ACTIONS(2370),
    [anon_sym___thread] = ACTIONS(2370),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_constexpr] = ACTIONS(2370),
    [anon_sym_volatile] = ACTIONS(2370),
    [anon_sym_restrict] = ACTIONS(2370),
    [anon_sym___restrict__] = ACTIONS(2370),
    [anon_sym__Atomic] = ACTIONS(2370),
    [anon_sym__Noreturn] = ACTIONS(2370),
    [anon_sym_noreturn] = ACTIONS(2370),
    [anon_sym_mutable] = ACTIONS(2370),
    [anon_sym_constinit] = ACTIONS(2370),
    [anon_sym_consteval] = ACTIONS(2370),
    [anon_sym___shared__] = ACTIONS(2370),
    [anon_sym___local__] = ACTIONS(2370),
    [anon_sym___constant__] = ACTIONS(2370),
    [anon_sym___managed__] = ACTIONS(2370),
    [anon_sym___grid_constant__] = ACTIONS(2370),
    [anon_sym_alignas] = ACTIONS(2370),
    [anon_sym__Alignas] = ACTIONS(2370),
    [sym_primitive_type] = ACTIONS(2370),
    [anon_sym_enum] = ACTIONS(2370),
    [anon_sym_class] = ACTIONS(2370),
    [anon_sym_struct] = ACTIONS(2370),
    [anon_sym_union] = ACTIONS(2370),
    [anon_sym_if] = ACTIONS(2370),
    [anon_sym_switch] = ACTIONS(2370),
    [anon_sym_case] = ACTIONS(2370),
    [anon_sym_default] = ACTIONS(2370),
    [anon_sym_while] = ACTIONS(2370),
    [anon_sym_do] = ACTIONS(2370),
    [anon_sym_for] = ACTIONS(2370),
    [anon_sym_return] = ACTIONS(2370),
    [anon_sym_break] = ACTIONS(2370),
    [anon_sym_continue] = ACTIONS(2370),
    [anon_sym_goto] = ACTIONS(2370),
    [anon_sym___try] = ACTIONS(2370),
    [anon_sym___leave] = ACTIONS(2370),
    [anon_sym_not] = ACTIONS(2370),
    [anon_sym_compl] = ACTIONS(2370),
    [anon_sym_DASH_DASH] = ACTIONS(2372),
    [anon_sym_PLUS_PLUS] = ACTIONS(2372),
    [anon_sym_sizeof] = ACTIONS(2370),
    [anon_sym___alignof__] = ACTIONS(2370),
    [anon_sym___alignof] = ACTIONS(2370),
    [anon_sym__alignof] = ACTIONS(2370),
    [anon_sym_alignof] = ACTIONS(2370),
    [anon_sym__Alignof] = ACTIONS(2370),
    [anon_sym_offsetof] = ACTIONS(2370),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2370),
    [anon_sym___asm__] = ACTIONS(2370),
    [sym_number_literal] = ACTIONS(2372),
    [anon_sym_L_SQUOTE] = ACTIONS(2372),
    [anon_sym_u_SQUOTE] = ACTIONS(2372),
    [anon_sym_U_SQUOTE] = ACTIONS(2372),
    [anon_sym_u8_SQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [anon_sym_L_DQUOTE] = ACTIONS(2372),
    [anon_sym_u_DQUOTE] = ACTIONS(2372),
    [anon_sym_U_DQUOTE] = ACTIONS(2372),
    [anon_sym_u8_DQUOTE] = ACTIONS(2372),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [sym_true] = ACTIONS(2370),
    [sym_false] = ACTIONS(2370),
    [anon_sym_NULL] = ACTIONS(2370),
    [anon_sym_nullptr] = ACTIONS(2370),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2370),
    [anon_sym_decltype] = ACTIONS(2370),
    [sym_virtual] = ACTIONS(2370),
    [anon_sym_explicit] = ACTIONS(2370),
    [anon_sym_typename] = ACTIONS(2370),
    [anon_sym_template] = ACTIONS(2370),
    [anon_sym_operator] = ACTIONS(2370),
    [anon_sym_try] = ACTIONS(2370),
    [anon_sym_delete] = ACTIONS(2370),
    [anon_sym_throw] = ACTIONS(2370),
    [anon_sym_namespace] = ACTIONS(2370),
    [anon_sym_using] = ACTIONS(2370),
    [anon_sym_static_assert] = ACTIONS(2370),
    [anon_sym_concept] = ACTIONS(2370),
    [anon_sym_co_return] = ACTIONS(2370),
    [anon_sym_co_yield] = ACTIONS(2370),
    [anon_sym_R_DQUOTE] = ACTIONS(2372),
    [anon_sym_LR_DQUOTE] = ACTIONS(2372),
    [anon_sym_uR_DQUOTE] = ACTIONS(2372),
    [anon_sym_UR_DQUOTE] = ACTIONS(2372),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2372),
    [anon_sym_co_await] = ACTIONS(2370),
    [anon_sym_new] = ACTIONS(2370),
    [anon_sym_requires] = ACTIONS(2370),
    [sym_this] = ACTIONS(2370),
    [anon_sym___launch_bounds__] = ACTIONS(2370),
  },
  [451] = {
    [sym_attribute_declaration] = STATE(635),
    [sym_compound_statement] = STATE(439),
    [sym_attributed_statement] = STATE(439),
    [sym_statement] = STATE(428),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4704),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(8192),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [452] = {
    [sym_identifier] = ACTIONS(2362),
    [aux_sym_preproc_include_token1] = ACTIONS(2362),
    [aux_sym_preproc_def_token1] = ACTIONS(2362),
    [aux_sym_preproc_if_token1] = ACTIONS(2362),
    [aux_sym_preproc_if_token2] = ACTIONS(2362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2362),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2362),
    [sym_preproc_directive] = ACTIONS(2362),
    [anon_sym_LPAREN2] = ACTIONS(2364),
    [anon_sym_BANG] = ACTIONS(2364),
    [anon_sym_TILDE] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2362),
    [anon_sym_PLUS] = ACTIONS(2362),
    [anon_sym_STAR] = ACTIONS(2364),
    [anon_sym_AMP_AMP] = ACTIONS(2364),
    [anon_sym_AMP] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym___extension__] = ACTIONS(2362),
    [anon_sym_typedef] = ACTIONS(2362),
    [anon_sym___device__] = ACTIONS(2362),
    [anon_sym___host__] = ACTIONS(2362),
    [anon_sym___global__] = ACTIONS(2362),
    [anon_sym___forceinline__] = ACTIONS(2362),
    [anon_sym___noinline__] = ACTIONS(2362),
    [anon_sym_extern] = ACTIONS(2362),
    [anon_sym___attribute__] = ACTIONS(2362),
    [anon_sym_COLON_COLON] = ACTIONS(2364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2364),
    [anon_sym___declspec] = ACTIONS(2362),
    [anon_sym___based] = ACTIONS(2362),
    [anon_sym___cdecl] = ACTIONS(2362),
    [anon_sym___clrcall] = ACTIONS(2362),
    [anon_sym___stdcall] = ACTIONS(2362),
    [anon_sym___fastcall] = ACTIONS(2362),
    [anon_sym___thiscall] = ACTIONS(2362),
    [anon_sym___vectorcall] = ACTIONS(2362),
    [anon_sym_LBRACE] = ACTIONS(2364),
    [anon_sym_signed] = ACTIONS(2362),
    [anon_sym_unsigned] = ACTIONS(2362),
    [anon_sym_long] = ACTIONS(2362),
    [anon_sym_short] = ACTIONS(2362),
    [anon_sym_LBRACK] = ACTIONS(2362),
    [anon_sym_static] = ACTIONS(2362),
    [anon_sym_register] = ACTIONS(2362),
    [anon_sym_inline] = ACTIONS(2362),
    [anon_sym___inline] = ACTIONS(2362),
    [anon_sym___inline__] = ACTIONS(2362),
    [anon_sym___forceinline] = ACTIONS(2362),
    [anon_sym_thread_local] = ACTIONS(2362),
    [anon_sym___thread] = ACTIONS(2362),
    [anon_sym_const] = ACTIONS(2362),
    [anon_sym_constexpr] = ACTIONS(2362),
    [anon_sym_volatile] = ACTIONS(2362),
    [anon_sym_restrict] = ACTIONS(2362),
    [anon_sym___restrict__] = ACTIONS(2362),
    [anon_sym__Atomic] = ACTIONS(2362),
    [anon_sym__Noreturn] = ACTIONS(2362),
    [anon_sym_noreturn] = ACTIONS(2362),
    [anon_sym_mutable] = ACTIONS(2362),
    [anon_sym_constinit] = ACTIONS(2362),
    [anon_sym_consteval] = ACTIONS(2362),
    [anon_sym___shared__] = ACTIONS(2362),
    [anon_sym___local__] = ACTIONS(2362),
    [anon_sym___constant__] = ACTIONS(2362),
    [anon_sym___managed__] = ACTIONS(2362),
    [anon_sym___grid_constant__] = ACTIONS(2362),
    [anon_sym_alignas] = ACTIONS(2362),
    [anon_sym__Alignas] = ACTIONS(2362),
    [sym_primitive_type] = ACTIONS(2362),
    [anon_sym_enum] = ACTIONS(2362),
    [anon_sym_class] = ACTIONS(2362),
    [anon_sym_struct] = ACTIONS(2362),
    [anon_sym_union] = ACTIONS(2362),
    [anon_sym_if] = ACTIONS(2362),
    [anon_sym_switch] = ACTIONS(2362),
    [anon_sym_case] = ACTIONS(2362),
    [anon_sym_default] = ACTIONS(2362),
    [anon_sym_while] = ACTIONS(2362),
    [anon_sym_do] = ACTIONS(2362),
    [anon_sym_for] = ACTIONS(2362),
    [anon_sym_return] = ACTIONS(2362),
    [anon_sym_break] = ACTIONS(2362),
    [anon_sym_continue] = ACTIONS(2362),
    [anon_sym_goto] = ACTIONS(2362),
    [anon_sym___try] = ACTIONS(2362),
    [anon_sym___leave] = ACTIONS(2362),
    [anon_sym_not] = ACTIONS(2362),
    [anon_sym_compl] = ACTIONS(2362),
    [anon_sym_DASH_DASH] = ACTIONS(2364),
    [anon_sym_PLUS_PLUS] = ACTIONS(2364),
    [anon_sym_sizeof] = ACTIONS(2362),
    [anon_sym___alignof__] = ACTIONS(2362),
    [anon_sym___alignof] = ACTIONS(2362),
    [anon_sym__alignof] = ACTIONS(2362),
    [anon_sym_alignof] = ACTIONS(2362),
    [anon_sym__Alignof] = ACTIONS(2362),
    [anon_sym_offsetof] = ACTIONS(2362),
    [anon_sym__Generic] = ACTIONS(2362),
    [anon_sym_asm] = ACTIONS(2362),
    [anon_sym___asm__] = ACTIONS(2362),
    [sym_number_literal] = ACTIONS(2364),
    [anon_sym_L_SQUOTE] = ACTIONS(2364),
    [anon_sym_u_SQUOTE] = ACTIONS(2364),
    [anon_sym_U_SQUOTE] = ACTIONS(2364),
    [anon_sym_u8_SQUOTE] = ACTIONS(2364),
    [anon_sym_SQUOTE] = ACTIONS(2364),
    [anon_sym_L_DQUOTE] = ACTIONS(2364),
    [anon_sym_u_DQUOTE] = ACTIONS(2364),
    [anon_sym_U_DQUOTE] = ACTIONS(2364),
    [anon_sym_u8_DQUOTE] = ACTIONS(2364),
    [anon_sym_DQUOTE] = ACTIONS(2364),
    [sym_true] = ACTIONS(2362),
    [sym_false] = ACTIONS(2362),
    [anon_sym_NULL] = ACTIONS(2362),
    [anon_sym_nullptr] = ACTIONS(2362),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2362),
    [anon_sym_decltype] = ACTIONS(2362),
    [sym_virtual] = ACTIONS(2362),
    [anon_sym_explicit] = ACTIONS(2362),
    [anon_sym_typename] = ACTIONS(2362),
    [anon_sym_template] = ACTIONS(2362),
    [anon_sym_operator] = ACTIONS(2362),
    [anon_sym_try] = ACTIONS(2362),
    [anon_sym_delete] = ACTIONS(2362),
    [anon_sym_throw] = ACTIONS(2362),
    [anon_sym_namespace] = ACTIONS(2362),
    [anon_sym_using] = ACTIONS(2362),
    [anon_sym_static_assert] = ACTIONS(2362),
    [anon_sym_concept] = ACTIONS(2362),
    [anon_sym_co_return] = ACTIONS(2362),
    [anon_sym_co_yield] = ACTIONS(2362),
    [anon_sym_R_DQUOTE] = ACTIONS(2364),
    [anon_sym_LR_DQUOTE] = ACTIONS(2364),
    [anon_sym_uR_DQUOTE] = ACTIONS(2364),
    [anon_sym_UR_DQUOTE] = ACTIONS(2364),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2364),
    [anon_sym_co_await] = ACTIONS(2362),
    [anon_sym_new] = ACTIONS(2362),
    [anon_sym_requires] = ACTIONS(2362),
    [sym_this] = ACTIONS(2362),
    [anon_sym___launch_bounds__] = ACTIONS(2362),
  },
  [453] = {
    [sym_identifier] = ACTIONS(2227),
    [aux_sym_preproc_include_token1] = ACTIONS(2227),
    [aux_sym_preproc_def_token1] = ACTIONS(2227),
    [aux_sym_preproc_if_token1] = ACTIONS(2227),
    [aux_sym_preproc_if_token2] = ACTIONS(2227),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2227),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2227),
    [sym_preproc_directive] = ACTIONS(2227),
    [anon_sym_LPAREN2] = ACTIONS(2229),
    [anon_sym_BANG] = ACTIONS(2229),
    [anon_sym_TILDE] = ACTIONS(2229),
    [anon_sym_DASH] = ACTIONS(2227),
    [anon_sym_PLUS] = ACTIONS(2227),
    [anon_sym_STAR] = ACTIONS(2229),
    [anon_sym_AMP_AMP] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2227),
    [anon_sym_SEMI] = ACTIONS(2229),
    [anon_sym___extension__] = ACTIONS(2227),
    [anon_sym_typedef] = ACTIONS(2227),
    [anon_sym___device__] = ACTIONS(2227),
    [anon_sym___host__] = ACTIONS(2227),
    [anon_sym___global__] = ACTIONS(2227),
    [anon_sym___forceinline__] = ACTIONS(2227),
    [anon_sym___noinline__] = ACTIONS(2227),
    [anon_sym_extern] = ACTIONS(2227),
    [anon_sym___attribute__] = ACTIONS(2227),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2229),
    [anon_sym___declspec] = ACTIONS(2227),
    [anon_sym___based] = ACTIONS(2227),
    [anon_sym___cdecl] = ACTIONS(2227),
    [anon_sym___clrcall] = ACTIONS(2227),
    [anon_sym___stdcall] = ACTIONS(2227),
    [anon_sym___fastcall] = ACTIONS(2227),
    [anon_sym___thiscall] = ACTIONS(2227),
    [anon_sym___vectorcall] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(2229),
    [anon_sym_signed] = ACTIONS(2227),
    [anon_sym_unsigned] = ACTIONS(2227),
    [anon_sym_long] = ACTIONS(2227),
    [anon_sym_short] = ACTIONS(2227),
    [anon_sym_LBRACK] = ACTIONS(2227),
    [anon_sym_static] = ACTIONS(2227),
    [anon_sym_register] = ACTIONS(2227),
    [anon_sym_inline] = ACTIONS(2227),
    [anon_sym___inline] = ACTIONS(2227),
    [anon_sym___inline__] = ACTIONS(2227),
    [anon_sym___forceinline] = ACTIONS(2227),
    [anon_sym_thread_local] = ACTIONS(2227),
    [anon_sym___thread] = ACTIONS(2227),
    [anon_sym_const] = ACTIONS(2227),
    [anon_sym_constexpr] = ACTIONS(2227),
    [anon_sym_volatile] = ACTIONS(2227),
    [anon_sym_restrict] = ACTIONS(2227),
    [anon_sym___restrict__] = ACTIONS(2227),
    [anon_sym__Atomic] = ACTIONS(2227),
    [anon_sym__Noreturn] = ACTIONS(2227),
    [anon_sym_noreturn] = ACTIONS(2227),
    [anon_sym_mutable] = ACTIONS(2227),
    [anon_sym_constinit] = ACTIONS(2227),
    [anon_sym_consteval] = ACTIONS(2227),
    [anon_sym___shared__] = ACTIONS(2227),
    [anon_sym___local__] = ACTIONS(2227),
    [anon_sym___constant__] = ACTIONS(2227),
    [anon_sym___managed__] = ACTIONS(2227),
    [anon_sym___grid_constant__] = ACTIONS(2227),
    [anon_sym_alignas] = ACTIONS(2227),
    [anon_sym__Alignas] = ACTIONS(2227),
    [sym_primitive_type] = ACTIONS(2227),
    [anon_sym_enum] = ACTIONS(2227),
    [anon_sym_class] = ACTIONS(2227),
    [anon_sym_struct] = ACTIONS(2227),
    [anon_sym_union] = ACTIONS(2227),
    [anon_sym_if] = ACTIONS(2227),
    [anon_sym_switch] = ACTIONS(2227),
    [anon_sym_case] = ACTIONS(2227),
    [anon_sym_default] = ACTIONS(2227),
    [anon_sym_while] = ACTIONS(2227),
    [anon_sym_do] = ACTIONS(2227),
    [anon_sym_for] = ACTIONS(2227),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_break] = ACTIONS(2227),
    [anon_sym_continue] = ACTIONS(2227),
    [anon_sym_goto] = ACTIONS(2227),
    [anon_sym___try] = ACTIONS(2227),
    [anon_sym___leave] = ACTIONS(2227),
    [anon_sym_not] = ACTIONS(2227),
    [anon_sym_compl] = ACTIONS(2227),
    [anon_sym_DASH_DASH] = ACTIONS(2229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2229),
    [anon_sym_sizeof] = ACTIONS(2227),
    [anon_sym___alignof__] = ACTIONS(2227),
    [anon_sym___alignof] = ACTIONS(2227),
    [anon_sym__alignof] = ACTIONS(2227),
    [anon_sym_alignof] = ACTIONS(2227),
    [anon_sym__Alignof] = ACTIONS(2227),
    [anon_sym_offsetof] = ACTIONS(2227),
    [anon_sym__Generic] = ACTIONS(2227),
    [anon_sym_asm] = ACTIONS(2227),
    [anon_sym___asm__] = ACTIONS(2227),
    [sym_number_literal] = ACTIONS(2229),
    [anon_sym_L_SQUOTE] = ACTIONS(2229),
    [anon_sym_u_SQUOTE] = ACTIONS(2229),
    [anon_sym_U_SQUOTE] = ACTIONS(2229),
    [anon_sym_u8_SQUOTE] = ACTIONS(2229),
    [anon_sym_SQUOTE] = ACTIONS(2229),
    [anon_sym_L_DQUOTE] = ACTIONS(2229),
    [anon_sym_u_DQUOTE] = ACTIONS(2229),
    [anon_sym_U_DQUOTE] = ACTIONS(2229),
    [anon_sym_u8_DQUOTE] = ACTIONS(2229),
    [anon_sym_DQUOTE] = ACTIONS(2229),
    [sym_true] = ACTIONS(2227),
    [sym_false] = ACTIONS(2227),
    [anon_sym_NULL] = ACTIONS(2227),
    [anon_sym_nullptr] = ACTIONS(2227),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2227),
    [anon_sym_decltype] = ACTIONS(2227),
    [sym_virtual] = ACTIONS(2227),
    [anon_sym_explicit] = ACTIONS(2227),
    [anon_sym_typename] = ACTIONS(2227),
    [anon_sym_template] = ACTIONS(2227),
    [anon_sym_operator] = ACTIONS(2227),
    [anon_sym_try] = ACTIONS(2227),
    [anon_sym_delete] = ACTIONS(2227),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_namespace] = ACTIONS(2227),
    [anon_sym_using] = ACTIONS(2227),
    [anon_sym_static_assert] = ACTIONS(2227),
    [anon_sym_concept] = ACTIONS(2227),
    [anon_sym_co_return] = ACTIONS(2227),
    [anon_sym_co_yield] = ACTIONS(2227),
    [anon_sym_R_DQUOTE] = ACTIONS(2229),
    [anon_sym_LR_DQUOTE] = ACTIONS(2229),
    [anon_sym_uR_DQUOTE] = ACTIONS(2229),
    [anon_sym_UR_DQUOTE] = ACTIONS(2229),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2229),
    [anon_sym_co_await] = ACTIONS(2227),
    [anon_sym_new] = ACTIONS(2227),
    [anon_sym_requires] = ACTIONS(2227),
    [sym_this] = ACTIONS(2227),
    [anon_sym___launch_bounds__] = ACTIONS(2227),
  },
  [454] = {
    [sym_identifier] = ACTIONS(2215),
    [aux_sym_preproc_include_token1] = ACTIONS(2215),
    [aux_sym_preproc_def_token1] = ACTIONS(2215),
    [aux_sym_preproc_if_token1] = ACTIONS(2215),
    [aux_sym_preproc_if_token2] = ACTIONS(2215),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2215),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2215),
    [sym_preproc_directive] = ACTIONS(2215),
    [anon_sym_LPAREN2] = ACTIONS(2217),
    [anon_sym_BANG] = ACTIONS(2217),
    [anon_sym_TILDE] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2215),
    [anon_sym_PLUS] = ACTIONS(2215),
    [anon_sym_STAR] = ACTIONS(2217),
    [anon_sym_AMP_AMP] = ACTIONS(2217),
    [anon_sym_AMP] = ACTIONS(2215),
    [anon_sym_SEMI] = ACTIONS(2217),
    [anon_sym___extension__] = ACTIONS(2215),
    [anon_sym_typedef] = ACTIONS(2215),
    [anon_sym___device__] = ACTIONS(2215),
    [anon_sym___host__] = ACTIONS(2215),
    [anon_sym___global__] = ACTIONS(2215),
    [anon_sym___forceinline__] = ACTIONS(2215),
    [anon_sym___noinline__] = ACTIONS(2215),
    [anon_sym_extern] = ACTIONS(2215),
    [anon_sym___attribute__] = ACTIONS(2215),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2217),
    [anon_sym___declspec] = ACTIONS(2215),
    [anon_sym___based] = ACTIONS(2215),
    [anon_sym___cdecl] = ACTIONS(2215),
    [anon_sym___clrcall] = ACTIONS(2215),
    [anon_sym___stdcall] = ACTIONS(2215),
    [anon_sym___fastcall] = ACTIONS(2215),
    [anon_sym___thiscall] = ACTIONS(2215),
    [anon_sym___vectorcall] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_signed] = ACTIONS(2215),
    [anon_sym_unsigned] = ACTIONS(2215),
    [anon_sym_long] = ACTIONS(2215),
    [anon_sym_short] = ACTIONS(2215),
    [anon_sym_LBRACK] = ACTIONS(2215),
    [anon_sym_static] = ACTIONS(2215),
    [anon_sym_register] = ACTIONS(2215),
    [anon_sym_inline] = ACTIONS(2215),
    [anon_sym___inline] = ACTIONS(2215),
    [anon_sym___inline__] = ACTIONS(2215),
    [anon_sym___forceinline] = ACTIONS(2215),
    [anon_sym_thread_local] = ACTIONS(2215),
    [anon_sym___thread] = ACTIONS(2215),
    [anon_sym_const] = ACTIONS(2215),
    [anon_sym_constexpr] = ACTIONS(2215),
    [anon_sym_volatile] = ACTIONS(2215),
    [anon_sym_restrict] = ACTIONS(2215),
    [anon_sym___restrict__] = ACTIONS(2215),
    [anon_sym__Atomic] = ACTIONS(2215),
    [anon_sym__Noreturn] = ACTIONS(2215),
    [anon_sym_noreturn] = ACTIONS(2215),
    [anon_sym_mutable] = ACTIONS(2215),
    [anon_sym_constinit] = ACTIONS(2215),
    [anon_sym_consteval] = ACTIONS(2215),
    [anon_sym___shared__] = ACTIONS(2215),
    [anon_sym___local__] = ACTIONS(2215),
    [anon_sym___constant__] = ACTIONS(2215),
    [anon_sym___managed__] = ACTIONS(2215),
    [anon_sym___grid_constant__] = ACTIONS(2215),
    [anon_sym_alignas] = ACTIONS(2215),
    [anon_sym__Alignas] = ACTIONS(2215),
    [sym_primitive_type] = ACTIONS(2215),
    [anon_sym_enum] = ACTIONS(2215),
    [anon_sym_class] = ACTIONS(2215),
    [anon_sym_struct] = ACTIONS(2215),
    [anon_sym_union] = ACTIONS(2215),
    [anon_sym_if] = ACTIONS(2215),
    [anon_sym_switch] = ACTIONS(2215),
    [anon_sym_case] = ACTIONS(2215),
    [anon_sym_default] = ACTIONS(2215),
    [anon_sym_while] = ACTIONS(2215),
    [anon_sym_do] = ACTIONS(2215),
    [anon_sym_for] = ACTIONS(2215),
    [anon_sym_return] = ACTIONS(2215),
    [anon_sym_break] = ACTIONS(2215),
    [anon_sym_continue] = ACTIONS(2215),
    [anon_sym_goto] = ACTIONS(2215),
    [anon_sym___try] = ACTIONS(2215),
    [anon_sym___leave] = ACTIONS(2215),
    [anon_sym_not] = ACTIONS(2215),
    [anon_sym_compl] = ACTIONS(2215),
    [anon_sym_DASH_DASH] = ACTIONS(2217),
    [anon_sym_PLUS_PLUS] = ACTIONS(2217),
    [anon_sym_sizeof] = ACTIONS(2215),
    [anon_sym___alignof__] = ACTIONS(2215),
    [anon_sym___alignof] = ACTIONS(2215),
    [anon_sym__alignof] = ACTIONS(2215),
    [anon_sym_alignof] = ACTIONS(2215),
    [anon_sym__Alignof] = ACTIONS(2215),
    [anon_sym_offsetof] = ACTIONS(2215),
    [anon_sym__Generic] = ACTIONS(2215),
    [anon_sym_asm] = ACTIONS(2215),
    [anon_sym___asm__] = ACTIONS(2215),
    [sym_number_literal] = ACTIONS(2217),
    [anon_sym_L_SQUOTE] = ACTIONS(2217),
    [anon_sym_u_SQUOTE] = ACTIONS(2217),
    [anon_sym_U_SQUOTE] = ACTIONS(2217),
    [anon_sym_u8_SQUOTE] = ACTIONS(2217),
    [anon_sym_SQUOTE] = ACTIONS(2217),
    [anon_sym_L_DQUOTE] = ACTIONS(2217),
    [anon_sym_u_DQUOTE] = ACTIONS(2217),
    [anon_sym_U_DQUOTE] = ACTIONS(2217),
    [anon_sym_u8_DQUOTE] = ACTIONS(2217),
    [anon_sym_DQUOTE] = ACTIONS(2217),
    [sym_true] = ACTIONS(2215),
    [sym_false] = ACTIONS(2215),
    [anon_sym_NULL] = ACTIONS(2215),
    [anon_sym_nullptr] = ACTIONS(2215),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2215),
    [anon_sym_decltype] = ACTIONS(2215),
    [sym_virtual] = ACTIONS(2215),
    [anon_sym_explicit] = ACTIONS(2215),
    [anon_sym_typename] = ACTIONS(2215),
    [anon_sym_template] = ACTIONS(2215),
    [anon_sym_operator] = ACTIONS(2215),
    [anon_sym_try] = ACTIONS(2215),
    [anon_sym_delete] = ACTIONS(2215),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_namespace] = ACTIONS(2215),
    [anon_sym_using] = ACTIONS(2215),
    [anon_sym_static_assert] = ACTIONS(2215),
    [anon_sym_concept] = ACTIONS(2215),
    [anon_sym_co_return] = ACTIONS(2215),
    [anon_sym_co_yield] = ACTIONS(2215),
    [anon_sym_R_DQUOTE] = ACTIONS(2217),
    [anon_sym_LR_DQUOTE] = ACTIONS(2217),
    [anon_sym_uR_DQUOTE] = ACTIONS(2217),
    [anon_sym_UR_DQUOTE] = ACTIONS(2217),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2217),
    [anon_sym_co_await] = ACTIONS(2215),
    [anon_sym_new] = ACTIONS(2215),
    [anon_sym_requires] = ACTIONS(2215),
    [sym_this] = ACTIONS(2215),
    [anon_sym___launch_bounds__] = ACTIONS(2215),
  },
  [455] = {
    [sym_identifier] = ACTIONS(2080),
    [aux_sym_preproc_include_token1] = ACTIONS(2080),
    [aux_sym_preproc_def_token1] = ACTIONS(2080),
    [aux_sym_preproc_if_token1] = ACTIONS(2080),
    [aux_sym_preproc_if_token2] = ACTIONS(2080),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2080),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2080),
    [sym_preproc_directive] = ACTIONS(2080),
    [anon_sym_LPAREN2] = ACTIONS(2082),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_DASH] = ACTIONS(2080),
    [anon_sym_PLUS] = ACTIONS(2080),
    [anon_sym_STAR] = ACTIONS(2082),
    [anon_sym_AMP_AMP] = ACTIONS(2082),
    [anon_sym_AMP] = ACTIONS(2080),
    [anon_sym_SEMI] = ACTIONS(2082),
    [anon_sym___extension__] = ACTIONS(2080),
    [anon_sym_typedef] = ACTIONS(2080),
    [anon_sym___device__] = ACTIONS(2080),
    [anon_sym___host__] = ACTIONS(2080),
    [anon_sym___global__] = ACTIONS(2080),
    [anon_sym___forceinline__] = ACTIONS(2080),
    [anon_sym___noinline__] = ACTIONS(2080),
    [anon_sym_extern] = ACTIONS(2080),
    [anon_sym___attribute__] = ACTIONS(2080),
    [anon_sym_COLON_COLON] = ACTIONS(2082),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2082),
    [anon_sym___declspec] = ACTIONS(2080),
    [anon_sym___based] = ACTIONS(2080),
    [anon_sym___cdecl] = ACTIONS(2080),
    [anon_sym___clrcall] = ACTIONS(2080),
    [anon_sym___stdcall] = ACTIONS(2080),
    [anon_sym___fastcall] = ACTIONS(2080),
    [anon_sym___thiscall] = ACTIONS(2080),
    [anon_sym___vectorcall] = ACTIONS(2080),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_signed] = ACTIONS(2080),
    [anon_sym_unsigned] = ACTIONS(2080),
    [anon_sym_long] = ACTIONS(2080),
    [anon_sym_short] = ACTIONS(2080),
    [anon_sym_LBRACK] = ACTIONS(2080),
    [anon_sym_static] = ACTIONS(2080),
    [anon_sym_register] = ACTIONS(2080),
    [anon_sym_inline] = ACTIONS(2080),
    [anon_sym___inline] = ACTIONS(2080),
    [anon_sym___inline__] = ACTIONS(2080),
    [anon_sym___forceinline] = ACTIONS(2080),
    [anon_sym_thread_local] = ACTIONS(2080),
    [anon_sym___thread] = ACTIONS(2080),
    [anon_sym_const] = ACTIONS(2080),
    [anon_sym_constexpr] = ACTIONS(2080),
    [anon_sym_volatile] = ACTIONS(2080),
    [anon_sym_restrict] = ACTIONS(2080),
    [anon_sym___restrict__] = ACTIONS(2080),
    [anon_sym__Atomic] = ACTIONS(2080),
    [anon_sym__Noreturn] = ACTIONS(2080),
    [anon_sym_noreturn] = ACTIONS(2080),
    [anon_sym_mutable] = ACTIONS(2080),
    [anon_sym_constinit] = ACTIONS(2080),
    [anon_sym_consteval] = ACTIONS(2080),
    [anon_sym___shared__] = ACTIONS(2080),
    [anon_sym___local__] = ACTIONS(2080),
    [anon_sym___constant__] = ACTIONS(2080),
    [anon_sym___managed__] = ACTIONS(2080),
    [anon_sym___grid_constant__] = ACTIONS(2080),
    [anon_sym_alignas] = ACTIONS(2080),
    [anon_sym__Alignas] = ACTIONS(2080),
    [sym_primitive_type] = ACTIONS(2080),
    [anon_sym_enum] = ACTIONS(2080),
    [anon_sym_class] = ACTIONS(2080),
    [anon_sym_struct] = ACTIONS(2080),
    [anon_sym_union] = ACTIONS(2080),
    [anon_sym_if] = ACTIONS(2080),
    [anon_sym_switch] = ACTIONS(2080),
    [anon_sym_case] = ACTIONS(2080),
    [anon_sym_default] = ACTIONS(2080),
    [anon_sym_while] = ACTIONS(2080),
    [anon_sym_do] = ACTIONS(2080),
    [anon_sym_for] = ACTIONS(2080),
    [anon_sym_return] = ACTIONS(2080),
    [anon_sym_break] = ACTIONS(2080),
    [anon_sym_continue] = ACTIONS(2080),
    [anon_sym_goto] = ACTIONS(2080),
    [anon_sym___try] = ACTIONS(2080),
    [anon_sym___leave] = ACTIONS(2080),
    [anon_sym_not] = ACTIONS(2080),
    [anon_sym_compl] = ACTIONS(2080),
    [anon_sym_DASH_DASH] = ACTIONS(2082),
    [anon_sym_PLUS_PLUS] = ACTIONS(2082),
    [anon_sym_sizeof] = ACTIONS(2080),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2080),
    [anon_sym__Generic] = ACTIONS(2080),
    [anon_sym_asm] = ACTIONS(2080),
    [anon_sym___asm__] = ACTIONS(2080),
    [sym_number_literal] = ACTIONS(2082),
    [anon_sym_L_SQUOTE] = ACTIONS(2082),
    [anon_sym_u_SQUOTE] = ACTIONS(2082),
    [anon_sym_U_SQUOTE] = ACTIONS(2082),
    [anon_sym_u8_SQUOTE] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2082),
    [anon_sym_L_DQUOTE] = ACTIONS(2082),
    [anon_sym_u_DQUOTE] = ACTIONS(2082),
    [anon_sym_U_DQUOTE] = ACTIONS(2082),
    [anon_sym_u8_DQUOTE] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [sym_true] = ACTIONS(2080),
    [sym_false] = ACTIONS(2080),
    [anon_sym_NULL] = ACTIONS(2080),
    [anon_sym_nullptr] = ACTIONS(2080),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2080),
    [anon_sym_decltype] = ACTIONS(2080),
    [sym_virtual] = ACTIONS(2080),
    [anon_sym_explicit] = ACTIONS(2080),
    [anon_sym_typename] = ACTIONS(2080),
    [anon_sym_template] = ACTIONS(2080),
    [anon_sym_operator] = ACTIONS(2080),
    [anon_sym_try] = ACTIONS(2080),
    [anon_sym_delete] = ACTIONS(2080),
    [anon_sym_throw] = ACTIONS(2080),
    [anon_sym_namespace] = ACTIONS(2080),
    [anon_sym_using] = ACTIONS(2080),
    [anon_sym_static_assert] = ACTIONS(2080),
    [anon_sym_concept] = ACTIONS(2080),
    [anon_sym_co_return] = ACTIONS(2080),
    [anon_sym_co_yield] = ACTIONS(2080),
    [anon_sym_R_DQUOTE] = ACTIONS(2082),
    [anon_sym_LR_DQUOTE] = ACTIONS(2082),
    [anon_sym_uR_DQUOTE] = ACTIONS(2082),
    [anon_sym_UR_DQUOTE] = ACTIONS(2082),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2082),
    [anon_sym_co_await] = ACTIONS(2080),
    [anon_sym_new] = ACTIONS(2080),
    [anon_sym_requires] = ACTIONS(2080),
    [sym_this] = ACTIONS(2080),
    [anon_sym___launch_bounds__] = ACTIONS(2080),
  },
  [456] = {
    [sym_identifier] = ACTIONS(2500),
    [aux_sym_preproc_include_token1] = ACTIONS(2500),
    [aux_sym_preproc_def_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token2] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2500),
    [sym_preproc_directive] = ACTIONS(2500),
    [anon_sym_LPAREN2] = ACTIONS(2502),
    [anon_sym_BANG] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [anon_sym_DASH] = ACTIONS(2500),
    [anon_sym_PLUS] = ACTIONS(2500),
    [anon_sym_STAR] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_typedef] = ACTIONS(2500),
    [anon_sym___device__] = ACTIONS(2500),
    [anon_sym___host__] = ACTIONS(2500),
    [anon_sym___global__] = ACTIONS(2500),
    [anon_sym___forceinline__] = ACTIONS(2500),
    [anon_sym___noinline__] = ACTIONS(2500),
    [anon_sym_extern] = ACTIONS(2500),
    [anon_sym___attribute__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2502),
    [anon_sym___declspec] = ACTIONS(2500),
    [anon_sym___based] = ACTIONS(2500),
    [anon_sym___cdecl] = ACTIONS(2500),
    [anon_sym___clrcall] = ACTIONS(2500),
    [anon_sym___stdcall] = ACTIONS(2500),
    [anon_sym___fastcall] = ACTIONS(2500),
    [anon_sym___thiscall] = ACTIONS(2500),
    [anon_sym___vectorcall] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(2502),
    [anon_sym_signed] = ACTIONS(2500),
    [anon_sym_unsigned] = ACTIONS(2500),
    [anon_sym_long] = ACTIONS(2500),
    [anon_sym_short] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_static] = ACTIONS(2500),
    [anon_sym_register] = ACTIONS(2500),
    [anon_sym_inline] = ACTIONS(2500),
    [anon_sym___inline] = ACTIONS(2500),
    [anon_sym___inline__] = ACTIONS(2500),
    [anon_sym___forceinline] = ACTIONS(2500),
    [anon_sym_thread_local] = ACTIONS(2500),
    [anon_sym___thread] = ACTIONS(2500),
    [anon_sym_const] = ACTIONS(2500),
    [anon_sym_constexpr] = ACTIONS(2500),
    [anon_sym_volatile] = ACTIONS(2500),
    [anon_sym_restrict] = ACTIONS(2500),
    [anon_sym___restrict__] = ACTIONS(2500),
    [anon_sym__Atomic] = ACTIONS(2500),
    [anon_sym__Noreturn] = ACTIONS(2500),
    [anon_sym_noreturn] = ACTIONS(2500),
    [anon_sym_mutable] = ACTIONS(2500),
    [anon_sym_constinit] = ACTIONS(2500),
    [anon_sym_consteval] = ACTIONS(2500),
    [anon_sym___shared__] = ACTIONS(2500),
    [anon_sym___local__] = ACTIONS(2500),
    [anon_sym___constant__] = ACTIONS(2500),
    [anon_sym___managed__] = ACTIONS(2500),
    [anon_sym___grid_constant__] = ACTIONS(2500),
    [anon_sym_alignas] = ACTIONS(2500),
    [anon_sym__Alignas] = ACTIONS(2500),
    [sym_primitive_type] = ACTIONS(2500),
    [anon_sym_enum] = ACTIONS(2500),
    [anon_sym_class] = ACTIONS(2500),
    [anon_sym_struct] = ACTIONS(2500),
    [anon_sym_union] = ACTIONS(2500),
    [anon_sym_if] = ACTIONS(2500),
    [anon_sym_switch] = ACTIONS(2500),
    [anon_sym_case] = ACTIONS(2500),
    [anon_sym_default] = ACTIONS(2500),
    [anon_sym_while] = ACTIONS(2500),
    [anon_sym_do] = ACTIONS(2500),
    [anon_sym_for] = ACTIONS(2500),
    [anon_sym_return] = ACTIONS(2500),
    [anon_sym_break] = ACTIONS(2500),
    [anon_sym_continue] = ACTIONS(2500),
    [anon_sym_goto] = ACTIONS(2500),
    [anon_sym___try] = ACTIONS(2500),
    [anon_sym___leave] = ACTIONS(2500),
    [anon_sym_not] = ACTIONS(2500),
    [anon_sym_compl] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(2502),
    [anon_sym_PLUS_PLUS] = ACTIONS(2502),
    [anon_sym_sizeof] = ACTIONS(2500),
    [anon_sym___alignof__] = ACTIONS(2500),
    [anon_sym___alignof] = ACTIONS(2500),
    [anon_sym__alignof] = ACTIONS(2500),
    [anon_sym_alignof] = ACTIONS(2500),
    [anon_sym__Alignof] = ACTIONS(2500),
    [anon_sym_offsetof] = ACTIONS(2500),
    [anon_sym__Generic] = ACTIONS(2500),
    [anon_sym_asm] = ACTIONS(2500),
    [anon_sym___asm__] = ACTIONS(2500),
    [sym_number_literal] = ACTIONS(2502),
    [anon_sym_L_SQUOTE] = ACTIONS(2502),
    [anon_sym_u_SQUOTE] = ACTIONS(2502),
    [anon_sym_U_SQUOTE] = ACTIONS(2502),
    [anon_sym_u8_SQUOTE] = ACTIONS(2502),
    [anon_sym_SQUOTE] = ACTIONS(2502),
    [anon_sym_L_DQUOTE] = ACTIONS(2502),
    [anon_sym_u_DQUOTE] = ACTIONS(2502),
    [anon_sym_U_DQUOTE] = ACTIONS(2502),
    [anon_sym_u8_DQUOTE] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [sym_true] = ACTIONS(2500),
    [sym_false] = ACTIONS(2500),
    [anon_sym_NULL] = ACTIONS(2500),
    [anon_sym_nullptr] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2500),
    [anon_sym_decltype] = ACTIONS(2500),
    [sym_virtual] = ACTIONS(2500),
    [anon_sym_explicit] = ACTIONS(2500),
    [anon_sym_typename] = ACTIONS(2500),
    [anon_sym_template] = ACTIONS(2500),
    [anon_sym_operator] = ACTIONS(2500),
    [anon_sym_try] = ACTIONS(2500),
    [anon_sym_delete] = ACTIONS(2500),
    [anon_sym_throw] = ACTIONS(2500),
    [anon_sym_namespace] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_static_assert] = ACTIONS(2500),
    [anon_sym_concept] = ACTIONS(2500),
    [anon_sym_co_return] = ACTIONS(2500),
    [anon_sym_co_yield] = ACTIONS(2500),
    [anon_sym_R_DQUOTE] = ACTIONS(2502),
    [anon_sym_LR_DQUOTE] = ACTIONS(2502),
    [anon_sym_uR_DQUOTE] = ACTIONS(2502),
    [anon_sym_UR_DQUOTE] = ACTIONS(2502),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2502),
    [anon_sym_co_await] = ACTIONS(2500),
    [anon_sym_new] = ACTIONS(2500),
    [anon_sym_requires] = ACTIONS(2500),
    [sym_this] = ACTIONS(2500),
    [anon_sym___launch_bounds__] = ACTIONS(2500),
  },
  [457] = {
    [sym_identifier] = ACTIONS(2500),
    [aux_sym_preproc_include_token1] = ACTIONS(2500),
    [aux_sym_preproc_def_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token2] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2500),
    [sym_preproc_directive] = ACTIONS(2500),
    [anon_sym_LPAREN2] = ACTIONS(2502),
    [anon_sym_BANG] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [anon_sym_DASH] = ACTIONS(2500),
    [anon_sym_PLUS] = ACTIONS(2500),
    [anon_sym_STAR] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_typedef] = ACTIONS(2500),
    [anon_sym___device__] = ACTIONS(2500),
    [anon_sym___host__] = ACTIONS(2500),
    [anon_sym___global__] = ACTIONS(2500),
    [anon_sym___forceinline__] = ACTIONS(2500),
    [anon_sym___noinline__] = ACTIONS(2500),
    [anon_sym_extern] = ACTIONS(2500),
    [anon_sym___attribute__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2502),
    [anon_sym___declspec] = ACTIONS(2500),
    [anon_sym___based] = ACTIONS(2500),
    [anon_sym___cdecl] = ACTIONS(2500),
    [anon_sym___clrcall] = ACTIONS(2500),
    [anon_sym___stdcall] = ACTIONS(2500),
    [anon_sym___fastcall] = ACTIONS(2500),
    [anon_sym___thiscall] = ACTIONS(2500),
    [anon_sym___vectorcall] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(2502),
    [anon_sym_signed] = ACTIONS(2500),
    [anon_sym_unsigned] = ACTIONS(2500),
    [anon_sym_long] = ACTIONS(2500),
    [anon_sym_short] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_static] = ACTIONS(2500),
    [anon_sym_register] = ACTIONS(2500),
    [anon_sym_inline] = ACTIONS(2500),
    [anon_sym___inline] = ACTIONS(2500),
    [anon_sym___inline__] = ACTIONS(2500),
    [anon_sym___forceinline] = ACTIONS(2500),
    [anon_sym_thread_local] = ACTIONS(2500),
    [anon_sym___thread] = ACTIONS(2500),
    [anon_sym_const] = ACTIONS(2500),
    [anon_sym_constexpr] = ACTIONS(2500),
    [anon_sym_volatile] = ACTIONS(2500),
    [anon_sym_restrict] = ACTIONS(2500),
    [anon_sym___restrict__] = ACTIONS(2500),
    [anon_sym__Atomic] = ACTIONS(2500),
    [anon_sym__Noreturn] = ACTIONS(2500),
    [anon_sym_noreturn] = ACTIONS(2500),
    [anon_sym_mutable] = ACTIONS(2500),
    [anon_sym_constinit] = ACTIONS(2500),
    [anon_sym_consteval] = ACTIONS(2500),
    [anon_sym___shared__] = ACTIONS(2500),
    [anon_sym___local__] = ACTIONS(2500),
    [anon_sym___constant__] = ACTIONS(2500),
    [anon_sym___managed__] = ACTIONS(2500),
    [anon_sym___grid_constant__] = ACTIONS(2500),
    [anon_sym_alignas] = ACTIONS(2500),
    [anon_sym__Alignas] = ACTIONS(2500),
    [sym_primitive_type] = ACTIONS(2500),
    [anon_sym_enum] = ACTIONS(2500),
    [anon_sym_class] = ACTIONS(2500),
    [anon_sym_struct] = ACTIONS(2500),
    [anon_sym_union] = ACTIONS(2500),
    [anon_sym_if] = ACTIONS(2500),
    [anon_sym_switch] = ACTIONS(2500),
    [anon_sym_case] = ACTIONS(2500),
    [anon_sym_default] = ACTIONS(2500),
    [anon_sym_while] = ACTIONS(2500),
    [anon_sym_do] = ACTIONS(2500),
    [anon_sym_for] = ACTIONS(2500),
    [anon_sym_return] = ACTIONS(2500),
    [anon_sym_break] = ACTIONS(2500),
    [anon_sym_continue] = ACTIONS(2500),
    [anon_sym_goto] = ACTIONS(2500),
    [anon_sym___try] = ACTIONS(2500),
    [anon_sym___leave] = ACTIONS(2500),
    [anon_sym_not] = ACTIONS(2500),
    [anon_sym_compl] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(2502),
    [anon_sym_PLUS_PLUS] = ACTIONS(2502),
    [anon_sym_sizeof] = ACTIONS(2500),
    [anon_sym___alignof__] = ACTIONS(2500),
    [anon_sym___alignof] = ACTIONS(2500),
    [anon_sym__alignof] = ACTIONS(2500),
    [anon_sym_alignof] = ACTIONS(2500),
    [anon_sym__Alignof] = ACTIONS(2500),
    [anon_sym_offsetof] = ACTIONS(2500),
    [anon_sym__Generic] = ACTIONS(2500),
    [anon_sym_asm] = ACTIONS(2500),
    [anon_sym___asm__] = ACTIONS(2500),
    [sym_number_literal] = ACTIONS(2502),
    [anon_sym_L_SQUOTE] = ACTIONS(2502),
    [anon_sym_u_SQUOTE] = ACTIONS(2502),
    [anon_sym_U_SQUOTE] = ACTIONS(2502),
    [anon_sym_u8_SQUOTE] = ACTIONS(2502),
    [anon_sym_SQUOTE] = ACTIONS(2502),
    [anon_sym_L_DQUOTE] = ACTIONS(2502),
    [anon_sym_u_DQUOTE] = ACTIONS(2502),
    [anon_sym_U_DQUOTE] = ACTIONS(2502),
    [anon_sym_u8_DQUOTE] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [sym_true] = ACTIONS(2500),
    [sym_false] = ACTIONS(2500),
    [anon_sym_NULL] = ACTIONS(2500),
    [anon_sym_nullptr] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2500),
    [anon_sym_decltype] = ACTIONS(2500),
    [sym_virtual] = ACTIONS(2500),
    [anon_sym_explicit] = ACTIONS(2500),
    [anon_sym_typename] = ACTIONS(2500),
    [anon_sym_template] = ACTIONS(2500),
    [anon_sym_operator] = ACTIONS(2500),
    [anon_sym_try] = ACTIONS(2500),
    [anon_sym_delete] = ACTIONS(2500),
    [anon_sym_throw] = ACTIONS(2500),
    [anon_sym_namespace] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_static_assert] = ACTIONS(2500),
    [anon_sym_concept] = ACTIONS(2500),
    [anon_sym_co_return] = ACTIONS(2500),
    [anon_sym_co_yield] = ACTIONS(2500),
    [anon_sym_R_DQUOTE] = ACTIONS(2502),
    [anon_sym_LR_DQUOTE] = ACTIONS(2502),
    [anon_sym_uR_DQUOTE] = ACTIONS(2502),
    [anon_sym_UR_DQUOTE] = ACTIONS(2502),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2502),
    [anon_sym_co_await] = ACTIONS(2500),
    [anon_sym_new] = ACTIONS(2500),
    [anon_sym_requires] = ACTIONS(2500),
    [sym_this] = ACTIONS(2500),
    [anon_sym___launch_bounds__] = ACTIONS(2500),
  },
  [458] = {
    [sym_identifier] = ACTIONS(2469),
    [aux_sym_preproc_include_token1] = ACTIONS(2469),
    [aux_sym_preproc_def_token1] = ACTIONS(2469),
    [aux_sym_preproc_if_token1] = ACTIONS(2469),
    [aux_sym_preproc_if_token2] = ACTIONS(2469),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2469),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2469),
    [sym_preproc_directive] = ACTIONS(2469),
    [anon_sym_LPAREN2] = ACTIONS(2471),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_STAR] = ACTIONS(2471),
    [anon_sym_AMP_AMP] = ACTIONS(2471),
    [anon_sym_AMP] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym___extension__] = ACTIONS(2469),
    [anon_sym_typedef] = ACTIONS(2469),
    [anon_sym___device__] = ACTIONS(2469),
    [anon_sym___host__] = ACTIONS(2469),
    [anon_sym___global__] = ACTIONS(2469),
    [anon_sym___forceinline__] = ACTIONS(2469),
    [anon_sym___noinline__] = ACTIONS(2469),
    [anon_sym_extern] = ACTIONS(2469),
    [anon_sym___attribute__] = ACTIONS(2469),
    [anon_sym_COLON_COLON] = ACTIONS(2471),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2471),
    [anon_sym___declspec] = ACTIONS(2469),
    [anon_sym___based] = ACTIONS(2469),
    [anon_sym___cdecl] = ACTIONS(2469),
    [anon_sym___clrcall] = ACTIONS(2469),
    [anon_sym___stdcall] = ACTIONS(2469),
    [anon_sym___fastcall] = ACTIONS(2469),
    [anon_sym___thiscall] = ACTIONS(2469),
    [anon_sym___vectorcall] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_signed] = ACTIONS(2469),
    [anon_sym_unsigned] = ACTIONS(2469),
    [anon_sym_long] = ACTIONS(2469),
    [anon_sym_short] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_register] = ACTIONS(2469),
    [anon_sym_inline] = ACTIONS(2469),
    [anon_sym___inline] = ACTIONS(2469),
    [anon_sym___inline__] = ACTIONS(2469),
    [anon_sym___forceinline] = ACTIONS(2469),
    [anon_sym_thread_local] = ACTIONS(2469),
    [anon_sym___thread] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_constexpr] = ACTIONS(2469),
    [anon_sym_volatile] = ACTIONS(2469),
    [anon_sym_restrict] = ACTIONS(2469),
    [anon_sym___restrict__] = ACTIONS(2469),
    [anon_sym__Atomic] = ACTIONS(2469),
    [anon_sym__Noreturn] = ACTIONS(2469),
    [anon_sym_noreturn] = ACTIONS(2469),
    [anon_sym_mutable] = ACTIONS(2469),
    [anon_sym_constinit] = ACTIONS(2469),
    [anon_sym_consteval] = ACTIONS(2469),
    [anon_sym___shared__] = ACTIONS(2469),
    [anon_sym___local__] = ACTIONS(2469),
    [anon_sym___constant__] = ACTIONS(2469),
    [anon_sym___managed__] = ACTIONS(2469),
    [anon_sym___grid_constant__] = ACTIONS(2469),
    [anon_sym_alignas] = ACTIONS(2469),
    [anon_sym__Alignas] = ACTIONS(2469),
    [sym_primitive_type] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [anon_sym_class] = ACTIONS(2469),
    [anon_sym_struct] = ACTIONS(2469),
    [anon_sym_union] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_goto] = ACTIONS(2469),
    [anon_sym___try] = ACTIONS(2469),
    [anon_sym___leave] = ACTIONS(2469),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_compl] = ACTIONS(2469),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_sizeof] = ACTIONS(2469),
    [anon_sym___alignof__] = ACTIONS(2469),
    [anon_sym___alignof] = ACTIONS(2469),
    [anon_sym__alignof] = ACTIONS(2469),
    [anon_sym_alignof] = ACTIONS(2469),
    [anon_sym__Alignof] = ACTIONS(2469),
    [anon_sym_offsetof] = ACTIONS(2469),
    [anon_sym__Generic] = ACTIONS(2469),
    [anon_sym_asm] = ACTIONS(2469),
    [anon_sym___asm__] = ACTIONS(2469),
    [sym_number_literal] = ACTIONS(2471),
    [anon_sym_L_SQUOTE] = ACTIONS(2471),
    [anon_sym_u_SQUOTE] = ACTIONS(2471),
    [anon_sym_U_SQUOTE] = ACTIONS(2471),
    [anon_sym_u8_SQUOTE] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [anon_sym_L_DQUOTE] = ACTIONS(2471),
    [anon_sym_u_DQUOTE] = ACTIONS(2471),
    [anon_sym_U_DQUOTE] = ACTIONS(2471),
    [anon_sym_u8_DQUOTE] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [anon_sym_NULL] = ACTIONS(2469),
    [anon_sym_nullptr] = ACTIONS(2469),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2469),
    [anon_sym_decltype] = ACTIONS(2469),
    [sym_virtual] = ACTIONS(2469),
    [anon_sym_explicit] = ACTIONS(2469),
    [anon_sym_typename] = ACTIONS(2469),
    [anon_sym_template] = ACTIONS(2469),
    [anon_sym_operator] = ACTIONS(2469),
    [anon_sym_try] = ACTIONS(2469),
    [anon_sym_delete] = ACTIONS(2469),
    [anon_sym_throw] = ACTIONS(2469),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_using] = ACTIONS(2469),
    [anon_sym_static_assert] = ACTIONS(2469),
    [anon_sym_concept] = ACTIONS(2469),
    [anon_sym_co_return] = ACTIONS(2469),
    [anon_sym_co_yield] = ACTIONS(2469),
    [anon_sym_R_DQUOTE] = ACTIONS(2471),
    [anon_sym_LR_DQUOTE] = ACTIONS(2471),
    [anon_sym_uR_DQUOTE] = ACTIONS(2471),
    [anon_sym_UR_DQUOTE] = ACTIONS(2471),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2471),
    [anon_sym_co_await] = ACTIONS(2469),
    [anon_sym_new] = ACTIONS(2469),
    [anon_sym_requires] = ACTIONS(2469),
    [sym_this] = ACTIONS(2469),
    [anon_sym___launch_bounds__] = ACTIONS(2469),
  },
  [459] = {
    [sym_identifier] = ACTIONS(2352),
    [aux_sym_preproc_include_token1] = ACTIONS(2352),
    [aux_sym_preproc_def_token1] = ACTIONS(2352),
    [aux_sym_preproc_if_token1] = ACTIONS(2352),
    [aux_sym_preproc_if_token2] = ACTIONS(2352),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2352),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2352),
    [sym_preproc_directive] = ACTIONS(2352),
    [anon_sym_LPAREN2] = ACTIONS(2354),
    [anon_sym_BANG] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2354),
    [anon_sym_DASH] = ACTIONS(2352),
    [anon_sym_PLUS] = ACTIONS(2352),
    [anon_sym_STAR] = ACTIONS(2354),
    [anon_sym_AMP_AMP] = ACTIONS(2354),
    [anon_sym_AMP] = ACTIONS(2352),
    [anon_sym_SEMI] = ACTIONS(2354),
    [anon_sym___extension__] = ACTIONS(2352),
    [anon_sym_typedef] = ACTIONS(2352),
    [anon_sym___device__] = ACTIONS(2352),
    [anon_sym___host__] = ACTIONS(2352),
    [anon_sym___global__] = ACTIONS(2352),
    [anon_sym___forceinline__] = ACTIONS(2352),
    [anon_sym___noinline__] = ACTIONS(2352),
    [anon_sym_extern] = ACTIONS(2352),
    [anon_sym___attribute__] = ACTIONS(2352),
    [anon_sym_COLON_COLON] = ACTIONS(2354),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2354),
    [anon_sym___declspec] = ACTIONS(2352),
    [anon_sym___based] = ACTIONS(2352),
    [anon_sym___cdecl] = ACTIONS(2352),
    [anon_sym___clrcall] = ACTIONS(2352),
    [anon_sym___stdcall] = ACTIONS(2352),
    [anon_sym___fastcall] = ACTIONS(2352),
    [anon_sym___thiscall] = ACTIONS(2352),
    [anon_sym___vectorcall] = ACTIONS(2352),
    [anon_sym_LBRACE] = ACTIONS(2354),
    [anon_sym_signed] = ACTIONS(2352),
    [anon_sym_unsigned] = ACTIONS(2352),
    [anon_sym_long] = ACTIONS(2352),
    [anon_sym_short] = ACTIONS(2352),
    [anon_sym_LBRACK] = ACTIONS(2352),
    [anon_sym_static] = ACTIONS(2352),
    [anon_sym_register] = ACTIONS(2352),
    [anon_sym_inline] = ACTIONS(2352),
    [anon_sym___inline] = ACTIONS(2352),
    [anon_sym___inline__] = ACTIONS(2352),
    [anon_sym___forceinline] = ACTIONS(2352),
    [anon_sym_thread_local] = ACTIONS(2352),
    [anon_sym___thread] = ACTIONS(2352),
    [anon_sym_const] = ACTIONS(2352),
    [anon_sym_constexpr] = ACTIONS(2352),
    [anon_sym_volatile] = ACTIONS(2352),
    [anon_sym_restrict] = ACTIONS(2352),
    [anon_sym___restrict__] = ACTIONS(2352),
    [anon_sym__Atomic] = ACTIONS(2352),
    [anon_sym__Noreturn] = ACTIONS(2352),
    [anon_sym_noreturn] = ACTIONS(2352),
    [anon_sym_mutable] = ACTIONS(2352),
    [anon_sym_constinit] = ACTIONS(2352),
    [anon_sym_consteval] = ACTIONS(2352),
    [anon_sym___shared__] = ACTIONS(2352),
    [anon_sym___local__] = ACTIONS(2352),
    [anon_sym___constant__] = ACTIONS(2352),
    [anon_sym___managed__] = ACTIONS(2352),
    [anon_sym___grid_constant__] = ACTIONS(2352),
    [anon_sym_alignas] = ACTIONS(2352),
    [anon_sym__Alignas] = ACTIONS(2352),
    [sym_primitive_type] = ACTIONS(2352),
    [anon_sym_enum] = ACTIONS(2352),
    [anon_sym_class] = ACTIONS(2352),
    [anon_sym_struct] = ACTIONS(2352),
    [anon_sym_union] = ACTIONS(2352),
    [anon_sym_if] = ACTIONS(2352),
    [anon_sym_switch] = ACTIONS(2352),
    [anon_sym_case] = ACTIONS(2352),
    [anon_sym_default] = ACTIONS(2352),
    [anon_sym_while] = ACTIONS(2352),
    [anon_sym_do] = ACTIONS(2352),
    [anon_sym_for] = ACTIONS(2352),
    [anon_sym_return] = ACTIONS(2352),
    [anon_sym_break] = ACTIONS(2352),
    [anon_sym_continue] = ACTIONS(2352),
    [anon_sym_goto] = ACTIONS(2352),
    [anon_sym___try] = ACTIONS(2352),
    [anon_sym___leave] = ACTIONS(2352),
    [anon_sym_not] = ACTIONS(2352),
    [anon_sym_compl] = ACTIONS(2352),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_sizeof] = ACTIONS(2352),
    [anon_sym___alignof__] = ACTIONS(2352),
    [anon_sym___alignof] = ACTIONS(2352),
    [anon_sym__alignof] = ACTIONS(2352),
    [anon_sym_alignof] = ACTIONS(2352),
    [anon_sym__Alignof] = ACTIONS(2352),
    [anon_sym_offsetof] = ACTIONS(2352),
    [anon_sym__Generic] = ACTIONS(2352),
    [anon_sym_asm] = ACTIONS(2352),
    [anon_sym___asm__] = ACTIONS(2352),
    [sym_number_literal] = ACTIONS(2354),
    [anon_sym_L_SQUOTE] = ACTIONS(2354),
    [anon_sym_u_SQUOTE] = ACTIONS(2354),
    [anon_sym_U_SQUOTE] = ACTIONS(2354),
    [anon_sym_u8_SQUOTE] = ACTIONS(2354),
    [anon_sym_SQUOTE] = ACTIONS(2354),
    [anon_sym_L_DQUOTE] = ACTIONS(2354),
    [anon_sym_u_DQUOTE] = ACTIONS(2354),
    [anon_sym_U_DQUOTE] = ACTIONS(2354),
    [anon_sym_u8_DQUOTE] = ACTIONS(2354),
    [anon_sym_DQUOTE] = ACTIONS(2354),
    [sym_true] = ACTIONS(2352),
    [sym_false] = ACTIONS(2352),
    [anon_sym_NULL] = ACTIONS(2352),
    [anon_sym_nullptr] = ACTIONS(2352),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2352),
    [anon_sym_decltype] = ACTIONS(2352),
    [sym_virtual] = ACTIONS(2352),
    [anon_sym_explicit] = ACTIONS(2352),
    [anon_sym_typename] = ACTIONS(2352),
    [anon_sym_template] = ACTIONS(2352),
    [anon_sym_operator] = ACTIONS(2352),
    [anon_sym_try] = ACTIONS(2352),
    [anon_sym_delete] = ACTIONS(2352),
    [anon_sym_throw] = ACTIONS(2352),
    [anon_sym_namespace] = ACTIONS(2352),
    [anon_sym_using] = ACTIONS(2352),
    [anon_sym_static_assert] = ACTIONS(2352),
    [anon_sym_concept] = ACTIONS(2352),
    [anon_sym_co_return] = ACTIONS(2352),
    [anon_sym_co_yield] = ACTIONS(2352),
    [anon_sym_R_DQUOTE] = ACTIONS(2354),
    [anon_sym_LR_DQUOTE] = ACTIONS(2354),
    [anon_sym_uR_DQUOTE] = ACTIONS(2354),
    [anon_sym_UR_DQUOTE] = ACTIONS(2354),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2354),
    [anon_sym_co_await] = ACTIONS(2352),
    [anon_sym_new] = ACTIONS(2352),
    [anon_sym_requires] = ACTIONS(2352),
    [sym_this] = ACTIONS(2352),
    [anon_sym___launch_bounds__] = ACTIONS(2352),
  },
  [460] = {
    [sym_identifier] = ACTIONS(2284),
    [aux_sym_preproc_include_token1] = ACTIONS(2284),
    [aux_sym_preproc_def_token1] = ACTIONS(2284),
    [aux_sym_preproc_if_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2284),
    [sym_preproc_directive] = ACTIONS(2284),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_typedef] = ACTIONS(2284),
    [anon_sym___device__] = ACTIONS(2284),
    [anon_sym___host__] = ACTIONS(2284),
    [anon_sym___global__] = ACTIONS(2284),
    [anon_sym___forceinline__] = ACTIONS(2284),
    [anon_sym___noinline__] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2286),
    [anon_sym___declspec] = ACTIONS(2284),
    [anon_sym___based] = ACTIONS(2284),
    [anon_sym___cdecl] = ACTIONS(2284),
    [anon_sym___clrcall] = ACTIONS(2284),
    [anon_sym___stdcall] = ACTIONS(2284),
    [anon_sym___fastcall] = ACTIONS(2284),
    [anon_sym___thiscall] = ACTIONS(2284),
    [anon_sym___vectorcall] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_signed] = ACTIONS(2284),
    [anon_sym_unsigned] = ACTIONS(2284),
    [anon_sym_long] = ACTIONS(2284),
    [anon_sym_short] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym___inline] = ACTIONS(2284),
    [anon_sym___inline__] = ACTIONS(2284),
    [anon_sym___forceinline] = ACTIONS(2284),
    [anon_sym_thread_local] = ACTIONS(2284),
    [anon_sym___thread] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym___shared__] = ACTIONS(2284),
    [anon_sym___local__] = ACTIONS(2284),
    [anon_sym___constant__] = ACTIONS(2284),
    [anon_sym___managed__] = ACTIONS(2284),
    [anon_sym___grid_constant__] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [sym_primitive_type] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
    [anon_sym_class] = ACTIONS(2284),
    [anon_sym_struct] = ACTIONS(2284),
    [anon_sym_union] = ACTIONS(2284),
    [anon_sym_if] = ACTIONS(2284),
    [anon_sym_switch] = ACTIONS(2284),
    [anon_sym_case] = ACTIONS(2284),
    [anon_sym_default] = ACTIONS(2284),
    [anon_sym_while] = ACTIONS(2284),
    [anon_sym_do] = ACTIONS(2284),
    [anon_sym_for] = ACTIONS(2284),
    [anon_sym_return] = ACTIONS(2284),
    [anon_sym_break] = ACTIONS(2284),
    [anon_sym_continue] = ACTIONS(2284),
    [anon_sym_goto] = ACTIONS(2284),
    [anon_sym___try] = ACTIONS(2284),
    [anon_sym___leave] = ACTIONS(2284),
    [anon_sym_not] = ACTIONS(2284),
    [anon_sym_compl] = ACTIONS(2284),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_sizeof] = ACTIONS(2284),
    [anon_sym___alignof__] = ACTIONS(2284),
    [anon_sym___alignof] = ACTIONS(2284),
    [anon_sym__alignof] = ACTIONS(2284),
    [anon_sym_alignof] = ACTIONS(2284),
    [anon_sym__Alignof] = ACTIONS(2284),
    [anon_sym_offsetof] = ACTIONS(2284),
    [anon_sym__Generic] = ACTIONS(2284),
    [anon_sym_asm] = ACTIONS(2284),
    [anon_sym___asm__] = ACTIONS(2284),
    [sym_number_literal] = ACTIONS(2286),
    [anon_sym_L_SQUOTE] = ACTIONS(2286),
    [anon_sym_u_SQUOTE] = ACTIONS(2286),
    [anon_sym_U_SQUOTE] = ACTIONS(2286),
    [anon_sym_u8_SQUOTE] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [anon_sym_L_DQUOTE] = ACTIONS(2286),
    [anon_sym_u_DQUOTE] = ACTIONS(2286),
    [anon_sym_U_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8_DQUOTE] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [sym_true] = ACTIONS(2284),
    [sym_false] = ACTIONS(2284),
    [anon_sym_NULL] = ACTIONS(2284),
    [anon_sym_nullptr] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [sym_virtual] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_typename] = ACTIONS(2284),
    [anon_sym_template] = ACTIONS(2284),
    [anon_sym_operator] = ACTIONS(2284),
    [anon_sym_try] = ACTIONS(2284),
    [anon_sym_delete] = ACTIONS(2284),
    [anon_sym_throw] = ACTIONS(2284),
    [anon_sym_namespace] = ACTIONS(2284),
    [anon_sym_using] = ACTIONS(2284),
    [anon_sym_static_assert] = ACTIONS(2284),
    [anon_sym_concept] = ACTIONS(2284),
    [anon_sym_co_return] = ACTIONS(2284),
    [anon_sym_co_yield] = ACTIONS(2284),
    [anon_sym_R_DQUOTE] = ACTIONS(2286),
    [anon_sym_LR_DQUOTE] = ACTIONS(2286),
    [anon_sym_uR_DQUOTE] = ACTIONS(2286),
    [anon_sym_UR_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2286),
    [anon_sym_co_await] = ACTIONS(2284),
    [anon_sym_new] = ACTIONS(2284),
    [anon_sym_requires] = ACTIONS(2284),
    [sym_this] = ACTIONS(2284),
    [anon_sym___launch_bounds__] = ACTIONS(2284),
  },
  [461] = {
    [sym_identifier] = ACTIONS(2334),
    [aux_sym_preproc_include_token1] = ACTIONS(2334),
    [aux_sym_preproc_def_token1] = ACTIONS(2334),
    [aux_sym_preproc_if_token1] = ACTIONS(2334),
    [aux_sym_preproc_if_token2] = ACTIONS(2334),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2334),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2334),
    [sym_preproc_directive] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(2336),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [anon_sym_DASH] = ACTIONS(2334),
    [anon_sym_PLUS] = ACTIONS(2334),
    [anon_sym_STAR] = ACTIONS(2336),
    [anon_sym_AMP_AMP] = ACTIONS(2336),
    [anon_sym_AMP] = ACTIONS(2334),
    [anon_sym_SEMI] = ACTIONS(2336),
    [anon_sym___extension__] = ACTIONS(2334),
    [anon_sym_typedef] = ACTIONS(2334),
    [anon_sym___device__] = ACTIONS(2334),
    [anon_sym___host__] = ACTIONS(2334),
    [anon_sym___global__] = ACTIONS(2334),
    [anon_sym___forceinline__] = ACTIONS(2334),
    [anon_sym___noinline__] = ACTIONS(2334),
    [anon_sym_extern] = ACTIONS(2334),
    [anon_sym___attribute__] = ACTIONS(2334),
    [anon_sym_COLON_COLON] = ACTIONS(2336),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2336),
    [anon_sym___declspec] = ACTIONS(2334),
    [anon_sym___based] = ACTIONS(2334),
    [anon_sym___cdecl] = ACTIONS(2334),
    [anon_sym___clrcall] = ACTIONS(2334),
    [anon_sym___stdcall] = ACTIONS(2334),
    [anon_sym___fastcall] = ACTIONS(2334),
    [anon_sym___thiscall] = ACTIONS(2334),
    [anon_sym___vectorcall] = ACTIONS(2334),
    [anon_sym_LBRACE] = ACTIONS(2336),
    [anon_sym_signed] = ACTIONS(2334),
    [anon_sym_unsigned] = ACTIONS(2334),
    [anon_sym_long] = ACTIONS(2334),
    [anon_sym_short] = ACTIONS(2334),
    [anon_sym_LBRACK] = ACTIONS(2334),
    [anon_sym_static] = ACTIONS(2334),
    [anon_sym_register] = ACTIONS(2334),
    [anon_sym_inline] = ACTIONS(2334),
    [anon_sym___inline] = ACTIONS(2334),
    [anon_sym___inline__] = ACTIONS(2334),
    [anon_sym___forceinline] = ACTIONS(2334),
    [anon_sym_thread_local] = ACTIONS(2334),
    [anon_sym___thread] = ACTIONS(2334),
    [anon_sym_const] = ACTIONS(2334),
    [anon_sym_constexpr] = ACTIONS(2334),
    [anon_sym_volatile] = ACTIONS(2334),
    [anon_sym_restrict] = ACTIONS(2334),
    [anon_sym___restrict__] = ACTIONS(2334),
    [anon_sym__Atomic] = ACTIONS(2334),
    [anon_sym__Noreturn] = ACTIONS(2334),
    [anon_sym_noreturn] = ACTIONS(2334),
    [anon_sym_mutable] = ACTIONS(2334),
    [anon_sym_constinit] = ACTIONS(2334),
    [anon_sym_consteval] = ACTIONS(2334),
    [anon_sym___shared__] = ACTIONS(2334),
    [anon_sym___local__] = ACTIONS(2334),
    [anon_sym___constant__] = ACTIONS(2334),
    [anon_sym___managed__] = ACTIONS(2334),
    [anon_sym___grid_constant__] = ACTIONS(2334),
    [anon_sym_alignas] = ACTIONS(2334),
    [anon_sym__Alignas] = ACTIONS(2334),
    [sym_primitive_type] = ACTIONS(2334),
    [anon_sym_enum] = ACTIONS(2334),
    [anon_sym_class] = ACTIONS(2334),
    [anon_sym_struct] = ACTIONS(2334),
    [anon_sym_union] = ACTIONS(2334),
    [anon_sym_if] = ACTIONS(2334),
    [anon_sym_switch] = ACTIONS(2334),
    [anon_sym_case] = ACTIONS(2334),
    [anon_sym_default] = ACTIONS(2334),
    [anon_sym_while] = ACTIONS(2334),
    [anon_sym_do] = ACTIONS(2334),
    [anon_sym_for] = ACTIONS(2334),
    [anon_sym_return] = ACTIONS(2334),
    [anon_sym_break] = ACTIONS(2334),
    [anon_sym_continue] = ACTIONS(2334),
    [anon_sym_goto] = ACTIONS(2334),
    [anon_sym___try] = ACTIONS(2334),
    [anon_sym___leave] = ACTIONS(2334),
    [anon_sym_not] = ACTIONS(2334),
    [anon_sym_compl] = ACTIONS(2334),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_sizeof] = ACTIONS(2334),
    [anon_sym___alignof__] = ACTIONS(2334),
    [anon_sym___alignof] = ACTIONS(2334),
    [anon_sym__alignof] = ACTIONS(2334),
    [anon_sym_alignof] = ACTIONS(2334),
    [anon_sym__Alignof] = ACTIONS(2334),
    [anon_sym_offsetof] = ACTIONS(2334),
    [anon_sym__Generic] = ACTIONS(2334),
    [anon_sym_asm] = ACTIONS(2334),
    [anon_sym___asm__] = ACTIONS(2334),
    [sym_number_literal] = ACTIONS(2336),
    [anon_sym_L_SQUOTE] = ACTIONS(2336),
    [anon_sym_u_SQUOTE] = ACTIONS(2336),
    [anon_sym_U_SQUOTE] = ACTIONS(2336),
    [anon_sym_u8_SQUOTE] = ACTIONS(2336),
    [anon_sym_SQUOTE] = ACTIONS(2336),
    [anon_sym_L_DQUOTE] = ACTIONS(2336),
    [anon_sym_u_DQUOTE] = ACTIONS(2336),
    [anon_sym_U_DQUOTE] = ACTIONS(2336),
    [anon_sym_u8_DQUOTE] = ACTIONS(2336),
    [anon_sym_DQUOTE] = ACTIONS(2336),
    [sym_true] = ACTIONS(2334),
    [sym_false] = ACTIONS(2334),
    [anon_sym_NULL] = ACTIONS(2334),
    [anon_sym_nullptr] = ACTIONS(2334),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2334),
    [anon_sym_decltype] = ACTIONS(2334),
    [sym_virtual] = ACTIONS(2334),
    [anon_sym_explicit] = ACTIONS(2334),
    [anon_sym_typename] = ACTIONS(2334),
    [anon_sym_template] = ACTIONS(2334),
    [anon_sym_operator] = ACTIONS(2334),
    [anon_sym_try] = ACTIONS(2334),
    [anon_sym_delete] = ACTIONS(2334),
    [anon_sym_throw] = ACTIONS(2334),
    [anon_sym_namespace] = ACTIONS(2334),
    [anon_sym_using] = ACTIONS(2334),
    [anon_sym_static_assert] = ACTIONS(2334),
    [anon_sym_concept] = ACTIONS(2334),
    [anon_sym_co_return] = ACTIONS(2334),
    [anon_sym_co_yield] = ACTIONS(2334),
    [anon_sym_R_DQUOTE] = ACTIONS(2336),
    [anon_sym_LR_DQUOTE] = ACTIONS(2336),
    [anon_sym_uR_DQUOTE] = ACTIONS(2336),
    [anon_sym_UR_DQUOTE] = ACTIONS(2336),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2336),
    [anon_sym_co_await] = ACTIONS(2334),
    [anon_sym_new] = ACTIONS(2334),
    [anon_sym_requires] = ACTIONS(2334),
    [sym_this] = ACTIONS(2334),
    [anon_sym___launch_bounds__] = ACTIONS(2334),
  },
  [462] = {
    [sym_identifier] = ACTIONS(2330),
    [aux_sym_preproc_include_token1] = ACTIONS(2330),
    [aux_sym_preproc_def_token1] = ACTIONS(2330),
    [aux_sym_preproc_if_token1] = ACTIONS(2330),
    [aux_sym_preproc_if_token2] = ACTIONS(2330),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2330),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2330),
    [sym_preproc_directive] = ACTIONS(2330),
    [anon_sym_LPAREN2] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2332),
    [anon_sym_TILDE] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(2330),
    [anon_sym_STAR] = ACTIONS(2332),
    [anon_sym_AMP_AMP] = ACTIONS(2332),
    [anon_sym_AMP] = ACTIONS(2330),
    [anon_sym_SEMI] = ACTIONS(2332),
    [anon_sym___extension__] = ACTIONS(2330),
    [anon_sym_typedef] = ACTIONS(2330),
    [anon_sym___device__] = ACTIONS(2330),
    [anon_sym___host__] = ACTIONS(2330),
    [anon_sym___global__] = ACTIONS(2330),
    [anon_sym___forceinline__] = ACTIONS(2330),
    [anon_sym___noinline__] = ACTIONS(2330),
    [anon_sym_extern] = ACTIONS(2330),
    [anon_sym___attribute__] = ACTIONS(2330),
    [anon_sym_COLON_COLON] = ACTIONS(2332),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2332),
    [anon_sym___declspec] = ACTIONS(2330),
    [anon_sym___based] = ACTIONS(2330),
    [anon_sym___cdecl] = ACTIONS(2330),
    [anon_sym___clrcall] = ACTIONS(2330),
    [anon_sym___stdcall] = ACTIONS(2330),
    [anon_sym___fastcall] = ACTIONS(2330),
    [anon_sym___thiscall] = ACTIONS(2330),
    [anon_sym___vectorcall] = ACTIONS(2330),
    [anon_sym_LBRACE] = ACTIONS(2332),
    [anon_sym_signed] = ACTIONS(2330),
    [anon_sym_unsigned] = ACTIONS(2330),
    [anon_sym_long] = ACTIONS(2330),
    [anon_sym_short] = ACTIONS(2330),
    [anon_sym_LBRACK] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2330),
    [anon_sym_register] = ACTIONS(2330),
    [anon_sym_inline] = ACTIONS(2330),
    [anon_sym___inline] = ACTIONS(2330),
    [anon_sym___inline__] = ACTIONS(2330),
    [anon_sym___forceinline] = ACTIONS(2330),
    [anon_sym_thread_local] = ACTIONS(2330),
    [anon_sym___thread] = ACTIONS(2330),
    [anon_sym_const] = ACTIONS(2330),
    [anon_sym_constexpr] = ACTIONS(2330),
    [anon_sym_volatile] = ACTIONS(2330),
    [anon_sym_restrict] = ACTIONS(2330),
    [anon_sym___restrict__] = ACTIONS(2330),
    [anon_sym__Atomic] = ACTIONS(2330),
    [anon_sym__Noreturn] = ACTIONS(2330),
    [anon_sym_noreturn] = ACTIONS(2330),
    [anon_sym_mutable] = ACTIONS(2330),
    [anon_sym_constinit] = ACTIONS(2330),
    [anon_sym_consteval] = ACTIONS(2330),
    [anon_sym___shared__] = ACTIONS(2330),
    [anon_sym___local__] = ACTIONS(2330),
    [anon_sym___constant__] = ACTIONS(2330),
    [anon_sym___managed__] = ACTIONS(2330),
    [anon_sym___grid_constant__] = ACTIONS(2330),
    [anon_sym_alignas] = ACTIONS(2330),
    [anon_sym__Alignas] = ACTIONS(2330),
    [sym_primitive_type] = ACTIONS(2330),
    [anon_sym_enum] = ACTIONS(2330),
    [anon_sym_class] = ACTIONS(2330),
    [anon_sym_struct] = ACTIONS(2330),
    [anon_sym_union] = ACTIONS(2330),
    [anon_sym_if] = ACTIONS(2330),
    [anon_sym_switch] = ACTIONS(2330),
    [anon_sym_case] = ACTIONS(2330),
    [anon_sym_default] = ACTIONS(2330),
    [anon_sym_while] = ACTIONS(2330),
    [anon_sym_do] = ACTIONS(2330),
    [anon_sym_for] = ACTIONS(2330),
    [anon_sym_return] = ACTIONS(2330),
    [anon_sym_break] = ACTIONS(2330),
    [anon_sym_continue] = ACTIONS(2330),
    [anon_sym_goto] = ACTIONS(2330),
    [anon_sym___try] = ACTIONS(2330),
    [anon_sym___leave] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2330),
    [anon_sym_compl] = ACTIONS(2330),
    [anon_sym_DASH_DASH] = ACTIONS(2332),
    [anon_sym_PLUS_PLUS] = ACTIONS(2332),
    [anon_sym_sizeof] = ACTIONS(2330),
    [anon_sym___alignof__] = ACTIONS(2330),
    [anon_sym___alignof] = ACTIONS(2330),
    [anon_sym__alignof] = ACTIONS(2330),
    [anon_sym_alignof] = ACTIONS(2330),
    [anon_sym__Alignof] = ACTIONS(2330),
    [anon_sym_offsetof] = ACTIONS(2330),
    [anon_sym__Generic] = ACTIONS(2330),
    [anon_sym_asm] = ACTIONS(2330),
    [anon_sym___asm__] = ACTIONS(2330),
    [sym_number_literal] = ACTIONS(2332),
    [anon_sym_L_SQUOTE] = ACTIONS(2332),
    [anon_sym_u_SQUOTE] = ACTIONS(2332),
    [anon_sym_U_SQUOTE] = ACTIONS(2332),
    [anon_sym_u8_SQUOTE] = ACTIONS(2332),
    [anon_sym_SQUOTE] = ACTIONS(2332),
    [anon_sym_L_DQUOTE] = ACTIONS(2332),
    [anon_sym_u_DQUOTE] = ACTIONS(2332),
    [anon_sym_U_DQUOTE] = ACTIONS(2332),
    [anon_sym_u8_DQUOTE] = ACTIONS(2332),
    [anon_sym_DQUOTE] = ACTIONS(2332),
    [sym_true] = ACTIONS(2330),
    [sym_false] = ACTIONS(2330),
    [anon_sym_NULL] = ACTIONS(2330),
    [anon_sym_nullptr] = ACTIONS(2330),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2330),
    [anon_sym_decltype] = ACTIONS(2330),
    [sym_virtual] = ACTIONS(2330),
    [anon_sym_explicit] = ACTIONS(2330),
    [anon_sym_typename] = ACTIONS(2330),
    [anon_sym_template] = ACTIONS(2330),
    [anon_sym_operator] = ACTIONS(2330),
    [anon_sym_try] = ACTIONS(2330),
    [anon_sym_delete] = ACTIONS(2330),
    [anon_sym_throw] = ACTIONS(2330),
    [anon_sym_namespace] = ACTIONS(2330),
    [anon_sym_using] = ACTIONS(2330),
    [anon_sym_static_assert] = ACTIONS(2330),
    [anon_sym_concept] = ACTIONS(2330),
    [anon_sym_co_return] = ACTIONS(2330),
    [anon_sym_co_yield] = ACTIONS(2330),
    [anon_sym_R_DQUOTE] = ACTIONS(2332),
    [anon_sym_LR_DQUOTE] = ACTIONS(2332),
    [anon_sym_uR_DQUOTE] = ACTIONS(2332),
    [anon_sym_UR_DQUOTE] = ACTIONS(2332),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2332),
    [anon_sym_co_await] = ACTIONS(2330),
    [anon_sym_new] = ACTIONS(2330),
    [anon_sym_requires] = ACTIONS(2330),
    [sym_this] = ACTIONS(2330),
    [anon_sym___launch_bounds__] = ACTIONS(2330),
  },
  [463] = {
    [sym_identifier] = ACTIONS(2235),
    [aux_sym_preproc_include_token1] = ACTIONS(2235),
    [aux_sym_preproc_def_token1] = ACTIONS(2235),
    [aux_sym_preproc_if_token1] = ACTIONS(2235),
    [aux_sym_preproc_if_token2] = ACTIONS(2235),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2235),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2235),
    [sym_preproc_directive] = ACTIONS(2235),
    [anon_sym_LPAREN2] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2237),
    [anon_sym_TILDE] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_STAR] = ACTIONS(2237),
    [anon_sym_AMP_AMP] = ACTIONS(2237),
    [anon_sym_AMP] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2237),
    [anon_sym___extension__] = ACTIONS(2235),
    [anon_sym_typedef] = ACTIONS(2235),
    [anon_sym___device__] = ACTIONS(2235),
    [anon_sym___host__] = ACTIONS(2235),
    [anon_sym___global__] = ACTIONS(2235),
    [anon_sym___forceinline__] = ACTIONS(2235),
    [anon_sym___noinline__] = ACTIONS(2235),
    [anon_sym_extern] = ACTIONS(2235),
    [anon_sym___attribute__] = ACTIONS(2235),
    [anon_sym_COLON_COLON] = ACTIONS(2237),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2237),
    [anon_sym___declspec] = ACTIONS(2235),
    [anon_sym___based] = ACTIONS(2235),
    [anon_sym___cdecl] = ACTIONS(2235),
    [anon_sym___clrcall] = ACTIONS(2235),
    [anon_sym___stdcall] = ACTIONS(2235),
    [anon_sym___fastcall] = ACTIONS(2235),
    [anon_sym___thiscall] = ACTIONS(2235),
    [anon_sym___vectorcall] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2237),
    [anon_sym_signed] = ACTIONS(2235),
    [anon_sym_unsigned] = ACTIONS(2235),
    [anon_sym_long] = ACTIONS(2235),
    [anon_sym_short] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_static] = ACTIONS(2235),
    [anon_sym_register] = ACTIONS(2235),
    [anon_sym_inline] = ACTIONS(2235),
    [anon_sym___inline] = ACTIONS(2235),
    [anon_sym___inline__] = ACTIONS(2235),
    [anon_sym___forceinline] = ACTIONS(2235),
    [anon_sym_thread_local] = ACTIONS(2235),
    [anon_sym___thread] = ACTIONS(2235),
    [anon_sym_const] = ACTIONS(2235),
    [anon_sym_constexpr] = ACTIONS(2235),
    [anon_sym_volatile] = ACTIONS(2235),
    [anon_sym_restrict] = ACTIONS(2235),
    [anon_sym___restrict__] = ACTIONS(2235),
    [anon_sym__Atomic] = ACTIONS(2235),
    [anon_sym__Noreturn] = ACTIONS(2235),
    [anon_sym_noreturn] = ACTIONS(2235),
    [anon_sym_mutable] = ACTIONS(2235),
    [anon_sym_constinit] = ACTIONS(2235),
    [anon_sym_consteval] = ACTIONS(2235),
    [anon_sym___shared__] = ACTIONS(2235),
    [anon_sym___local__] = ACTIONS(2235),
    [anon_sym___constant__] = ACTIONS(2235),
    [anon_sym___managed__] = ACTIONS(2235),
    [anon_sym___grid_constant__] = ACTIONS(2235),
    [anon_sym_alignas] = ACTIONS(2235),
    [anon_sym__Alignas] = ACTIONS(2235),
    [sym_primitive_type] = ACTIONS(2235),
    [anon_sym_enum] = ACTIONS(2235),
    [anon_sym_class] = ACTIONS(2235),
    [anon_sym_struct] = ACTIONS(2235),
    [anon_sym_union] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_switch] = ACTIONS(2235),
    [anon_sym_case] = ACTIONS(2235),
    [anon_sym_default] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_for] = ACTIONS(2235),
    [anon_sym_return] = ACTIONS(2235),
    [anon_sym_break] = ACTIONS(2235),
    [anon_sym_continue] = ACTIONS(2235),
    [anon_sym_goto] = ACTIONS(2235),
    [anon_sym___try] = ACTIONS(2235),
    [anon_sym___leave] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2235),
    [anon_sym_compl] = ACTIONS(2235),
    [anon_sym_DASH_DASH] = ACTIONS(2237),
    [anon_sym_PLUS_PLUS] = ACTIONS(2237),
    [anon_sym_sizeof] = ACTIONS(2235),
    [anon_sym___alignof__] = ACTIONS(2235),
    [anon_sym___alignof] = ACTIONS(2235),
    [anon_sym__alignof] = ACTIONS(2235),
    [anon_sym_alignof] = ACTIONS(2235),
    [anon_sym__Alignof] = ACTIONS(2235),
    [anon_sym_offsetof] = ACTIONS(2235),
    [anon_sym__Generic] = ACTIONS(2235),
    [anon_sym_asm] = ACTIONS(2235),
    [anon_sym___asm__] = ACTIONS(2235),
    [sym_number_literal] = ACTIONS(2237),
    [anon_sym_L_SQUOTE] = ACTIONS(2237),
    [anon_sym_u_SQUOTE] = ACTIONS(2237),
    [anon_sym_U_SQUOTE] = ACTIONS(2237),
    [anon_sym_u8_SQUOTE] = ACTIONS(2237),
    [anon_sym_SQUOTE] = ACTIONS(2237),
    [anon_sym_L_DQUOTE] = ACTIONS(2237),
    [anon_sym_u_DQUOTE] = ACTIONS(2237),
    [anon_sym_U_DQUOTE] = ACTIONS(2237),
    [anon_sym_u8_DQUOTE] = ACTIONS(2237),
    [anon_sym_DQUOTE] = ACTIONS(2237),
    [sym_true] = ACTIONS(2235),
    [sym_false] = ACTIONS(2235),
    [anon_sym_NULL] = ACTIONS(2235),
    [anon_sym_nullptr] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2235),
    [anon_sym_decltype] = ACTIONS(2235),
    [sym_virtual] = ACTIONS(2235),
    [anon_sym_explicit] = ACTIONS(2235),
    [anon_sym_typename] = ACTIONS(2235),
    [anon_sym_template] = ACTIONS(2235),
    [anon_sym_operator] = ACTIONS(2235),
    [anon_sym_try] = ACTIONS(2235),
    [anon_sym_delete] = ACTIONS(2235),
    [anon_sym_throw] = ACTIONS(2235),
    [anon_sym_namespace] = ACTIONS(2235),
    [anon_sym_using] = ACTIONS(2235),
    [anon_sym_static_assert] = ACTIONS(2235),
    [anon_sym_concept] = ACTIONS(2235),
    [anon_sym_co_return] = ACTIONS(2235),
    [anon_sym_co_yield] = ACTIONS(2235),
    [anon_sym_R_DQUOTE] = ACTIONS(2237),
    [anon_sym_LR_DQUOTE] = ACTIONS(2237),
    [anon_sym_uR_DQUOTE] = ACTIONS(2237),
    [anon_sym_UR_DQUOTE] = ACTIONS(2237),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2237),
    [anon_sym_co_await] = ACTIONS(2235),
    [anon_sym_new] = ACTIONS(2235),
    [anon_sym_requires] = ACTIONS(2235),
    [sym_this] = ACTIONS(2235),
    [anon_sym___launch_bounds__] = ACTIONS(2235),
  },
  [464] = {
    [sym_identifier] = ACTIONS(2275),
    [aux_sym_preproc_include_token1] = ACTIONS(2275),
    [aux_sym_preproc_def_token1] = ACTIONS(2275),
    [aux_sym_preproc_if_token1] = ACTIONS(2275),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2275),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2275),
    [sym_preproc_directive] = ACTIONS(2275),
    [anon_sym_LPAREN2] = ACTIONS(2277),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [anon_sym_DASH] = ACTIONS(2275),
    [anon_sym_PLUS] = ACTIONS(2275),
    [anon_sym_STAR] = ACTIONS(2277),
    [anon_sym_AMP_AMP] = ACTIONS(2277),
    [anon_sym_AMP] = ACTIONS(2275),
    [anon_sym_SEMI] = ACTIONS(2277),
    [anon_sym___extension__] = ACTIONS(2275),
    [anon_sym_typedef] = ACTIONS(2275),
    [anon_sym___device__] = ACTIONS(2275),
    [anon_sym___host__] = ACTIONS(2275),
    [anon_sym___global__] = ACTIONS(2275),
    [anon_sym___forceinline__] = ACTIONS(2275),
    [anon_sym___noinline__] = ACTIONS(2275),
    [anon_sym_extern] = ACTIONS(2275),
    [anon_sym___attribute__] = ACTIONS(2275),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2277),
    [anon_sym___declspec] = ACTIONS(2275),
    [anon_sym___based] = ACTIONS(2275),
    [anon_sym___cdecl] = ACTIONS(2275),
    [anon_sym___clrcall] = ACTIONS(2275),
    [anon_sym___stdcall] = ACTIONS(2275),
    [anon_sym___fastcall] = ACTIONS(2275),
    [anon_sym___thiscall] = ACTIONS(2275),
    [anon_sym___vectorcall] = ACTIONS(2275),
    [anon_sym_LBRACE] = ACTIONS(2277),
    [anon_sym_RBRACE] = ACTIONS(2277),
    [anon_sym_signed] = ACTIONS(2275),
    [anon_sym_unsigned] = ACTIONS(2275),
    [anon_sym_long] = ACTIONS(2275),
    [anon_sym_short] = ACTIONS(2275),
    [anon_sym_LBRACK] = ACTIONS(2275),
    [anon_sym_static] = ACTIONS(2275),
    [anon_sym_register] = ACTIONS(2275),
    [anon_sym_inline] = ACTIONS(2275),
    [anon_sym___inline] = ACTIONS(2275),
    [anon_sym___inline__] = ACTIONS(2275),
    [anon_sym___forceinline] = ACTIONS(2275),
    [anon_sym_thread_local] = ACTIONS(2275),
    [anon_sym___thread] = ACTIONS(2275),
    [anon_sym_const] = ACTIONS(2275),
    [anon_sym_constexpr] = ACTIONS(2275),
    [anon_sym_volatile] = ACTIONS(2275),
    [anon_sym_restrict] = ACTIONS(2275),
    [anon_sym___restrict__] = ACTIONS(2275),
    [anon_sym__Atomic] = ACTIONS(2275),
    [anon_sym__Noreturn] = ACTIONS(2275),
    [anon_sym_noreturn] = ACTIONS(2275),
    [anon_sym_mutable] = ACTIONS(2275),
    [anon_sym_constinit] = ACTIONS(2275),
    [anon_sym_consteval] = ACTIONS(2275),
    [anon_sym___shared__] = ACTIONS(2275),
    [anon_sym___local__] = ACTIONS(2275),
    [anon_sym___constant__] = ACTIONS(2275),
    [anon_sym___managed__] = ACTIONS(2275),
    [anon_sym___grid_constant__] = ACTIONS(2275),
    [anon_sym_alignas] = ACTIONS(2275),
    [anon_sym__Alignas] = ACTIONS(2275),
    [sym_primitive_type] = ACTIONS(2275),
    [anon_sym_enum] = ACTIONS(2275),
    [anon_sym_class] = ACTIONS(2275),
    [anon_sym_struct] = ACTIONS(2275),
    [anon_sym_union] = ACTIONS(2275),
    [anon_sym_if] = ACTIONS(2275),
    [anon_sym_switch] = ACTIONS(2275),
    [anon_sym_case] = ACTIONS(2275),
    [anon_sym_default] = ACTIONS(2275),
    [anon_sym_while] = ACTIONS(2275),
    [anon_sym_do] = ACTIONS(2275),
    [anon_sym_for] = ACTIONS(2275),
    [anon_sym_return] = ACTIONS(2275),
    [anon_sym_break] = ACTIONS(2275),
    [anon_sym_continue] = ACTIONS(2275),
    [anon_sym_goto] = ACTIONS(2275),
    [anon_sym___try] = ACTIONS(2275),
    [anon_sym___leave] = ACTIONS(2275),
    [anon_sym_not] = ACTIONS(2275),
    [anon_sym_compl] = ACTIONS(2275),
    [anon_sym_DASH_DASH] = ACTIONS(2277),
    [anon_sym_PLUS_PLUS] = ACTIONS(2277),
    [anon_sym_sizeof] = ACTIONS(2275),
    [anon_sym___alignof__] = ACTIONS(2275),
    [anon_sym___alignof] = ACTIONS(2275),
    [anon_sym__alignof] = ACTIONS(2275),
    [anon_sym_alignof] = ACTIONS(2275),
    [anon_sym__Alignof] = ACTIONS(2275),
    [anon_sym_offsetof] = ACTIONS(2275),
    [anon_sym__Generic] = ACTIONS(2275),
    [anon_sym_asm] = ACTIONS(2275),
    [anon_sym___asm__] = ACTIONS(2275),
    [sym_number_literal] = ACTIONS(2277),
    [anon_sym_L_SQUOTE] = ACTIONS(2277),
    [anon_sym_u_SQUOTE] = ACTIONS(2277),
    [anon_sym_U_SQUOTE] = ACTIONS(2277),
    [anon_sym_u8_SQUOTE] = ACTIONS(2277),
    [anon_sym_SQUOTE] = ACTIONS(2277),
    [anon_sym_L_DQUOTE] = ACTIONS(2277),
    [anon_sym_u_DQUOTE] = ACTIONS(2277),
    [anon_sym_U_DQUOTE] = ACTIONS(2277),
    [anon_sym_u8_DQUOTE] = ACTIONS(2277),
    [anon_sym_DQUOTE] = ACTIONS(2277),
    [sym_true] = ACTIONS(2275),
    [sym_false] = ACTIONS(2275),
    [anon_sym_NULL] = ACTIONS(2275),
    [anon_sym_nullptr] = ACTIONS(2275),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2275),
    [anon_sym_decltype] = ACTIONS(2275),
    [sym_virtual] = ACTIONS(2275),
    [anon_sym_explicit] = ACTIONS(2275),
    [anon_sym_typename] = ACTIONS(2275),
    [anon_sym_template] = ACTIONS(2275),
    [anon_sym_operator] = ACTIONS(2275),
    [anon_sym_try] = ACTIONS(2275),
    [anon_sym_delete] = ACTIONS(2275),
    [anon_sym_throw] = ACTIONS(2275),
    [anon_sym_namespace] = ACTIONS(2275),
    [anon_sym_using] = ACTIONS(2275),
    [anon_sym_static_assert] = ACTIONS(2275),
    [anon_sym_concept] = ACTIONS(2275),
    [anon_sym_co_return] = ACTIONS(2275),
    [anon_sym_co_yield] = ACTIONS(2275),
    [anon_sym_R_DQUOTE] = ACTIONS(2277),
    [anon_sym_LR_DQUOTE] = ACTIONS(2277),
    [anon_sym_uR_DQUOTE] = ACTIONS(2277),
    [anon_sym_UR_DQUOTE] = ACTIONS(2277),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2277),
    [anon_sym_co_await] = ACTIONS(2275),
    [anon_sym_new] = ACTIONS(2275),
    [anon_sym_requires] = ACTIONS(2275),
    [sym_this] = ACTIONS(2275),
    [anon_sym___launch_bounds__] = ACTIONS(2275),
  },
  [465] = {
    [sym_identifier] = ACTIONS(2326),
    [aux_sym_preproc_include_token1] = ACTIONS(2326),
    [aux_sym_preproc_def_token1] = ACTIONS(2326),
    [aux_sym_preproc_if_token1] = ACTIONS(2326),
    [aux_sym_preproc_if_token2] = ACTIONS(2326),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2326),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2326),
    [sym_preproc_directive] = ACTIONS(2326),
    [anon_sym_LPAREN2] = ACTIONS(2328),
    [anon_sym_BANG] = ACTIONS(2328),
    [anon_sym_TILDE] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_STAR] = ACTIONS(2328),
    [anon_sym_AMP_AMP] = ACTIONS(2328),
    [anon_sym_AMP] = ACTIONS(2326),
    [anon_sym_SEMI] = ACTIONS(2328),
    [anon_sym___extension__] = ACTIONS(2326),
    [anon_sym_typedef] = ACTIONS(2326),
    [anon_sym___device__] = ACTIONS(2326),
    [anon_sym___host__] = ACTIONS(2326),
    [anon_sym___global__] = ACTIONS(2326),
    [anon_sym___forceinline__] = ACTIONS(2326),
    [anon_sym___noinline__] = ACTIONS(2326),
    [anon_sym_extern] = ACTIONS(2326),
    [anon_sym___attribute__] = ACTIONS(2326),
    [anon_sym_COLON_COLON] = ACTIONS(2328),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2328),
    [anon_sym___declspec] = ACTIONS(2326),
    [anon_sym___based] = ACTIONS(2326),
    [anon_sym___cdecl] = ACTIONS(2326),
    [anon_sym___clrcall] = ACTIONS(2326),
    [anon_sym___stdcall] = ACTIONS(2326),
    [anon_sym___fastcall] = ACTIONS(2326),
    [anon_sym___thiscall] = ACTIONS(2326),
    [anon_sym___vectorcall] = ACTIONS(2326),
    [anon_sym_LBRACE] = ACTIONS(2328),
    [anon_sym_signed] = ACTIONS(2326),
    [anon_sym_unsigned] = ACTIONS(2326),
    [anon_sym_long] = ACTIONS(2326),
    [anon_sym_short] = ACTIONS(2326),
    [anon_sym_LBRACK] = ACTIONS(2326),
    [anon_sym_static] = ACTIONS(2326),
    [anon_sym_register] = ACTIONS(2326),
    [anon_sym_inline] = ACTIONS(2326),
    [anon_sym___inline] = ACTIONS(2326),
    [anon_sym___inline__] = ACTIONS(2326),
    [anon_sym___forceinline] = ACTIONS(2326),
    [anon_sym_thread_local] = ACTIONS(2326),
    [anon_sym___thread] = ACTIONS(2326),
    [anon_sym_const] = ACTIONS(2326),
    [anon_sym_constexpr] = ACTIONS(2326),
    [anon_sym_volatile] = ACTIONS(2326),
    [anon_sym_restrict] = ACTIONS(2326),
    [anon_sym___restrict__] = ACTIONS(2326),
    [anon_sym__Atomic] = ACTIONS(2326),
    [anon_sym__Noreturn] = ACTIONS(2326),
    [anon_sym_noreturn] = ACTIONS(2326),
    [anon_sym_mutable] = ACTIONS(2326),
    [anon_sym_constinit] = ACTIONS(2326),
    [anon_sym_consteval] = ACTIONS(2326),
    [anon_sym___shared__] = ACTIONS(2326),
    [anon_sym___local__] = ACTIONS(2326),
    [anon_sym___constant__] = ACTIONS(2326),
    [anon_sym___managed__] = ACTIONS(2326),
    [anon_sym___grid_constant__] = ACTIONS(2326),
    [anon_sym_alignas] = ACTIONS(2326),
    [anon_sym__Alignas] = ACTIONS(2326),
    [sym_primitive_type] = ACTIONS(2326),
    [anon_sym_enum] = ACTIONS(2326),
    [anon_sym_class] = ACTIONS(2326),
    [anon_sym_struct] = ACTIONS(2326),
    [anon_sym_union] = ACTIONS(2326),
    [anon_sym_if] = ACTIONS(2326),
    [anon_sym_switch] = ACTIONS(2326),
    [anon_sym_case] = ACTIONS(2326),
    [anon_sym_default] = ACTIONS(2326),
    [anon_sym_while] = ACTIONS(2326),
    [anon_sym_do] = ACTIONS(2326),
    [anon_sym_for] = ACTIONS(2326),
    [anon_sym_return] = ACTIONS(2326),
    [anon_sym_break] = ACTIONS(2326),
    [anon_sym_continue] = ACTIONS(2326),
    [anon_sym_goto] = ACTIONS(2326),
    [anon_sym___try] = ACTIONS(2326),
    [anon_sym___leave] = ACTIONS(2326),
    [anon_sym_not] = ACTIONS(2326),
    [anon_sym_compl] = ACTIONS(2326),
    [anon_sym_DASH_DASH] = ACTIONS(2328),
    [anon_sym_PLUS_PLUS] = ACTIONS(2328),
    [anon_sym_sizeof] = ACTIONS(2326),
    [anon_sym___alignof__] = ACTIONS(2326),
    [anon_sym___alignof] = ACTIONS(2326),
    [anon_sym__alignof] = ACTIONS(2326),
    [anon_sym_alignof] = ACTIONS(2326),
    [anon_sym__Alignof] = ACTIONS(2326),
    [anon_sym_offsetof] = ACTIONS(2326),
    [anon_sym__Generic] = ACTIONS(2326),
    [anon_sym_asm] = ACTIONS(2326),
    [anon_sym___asm__] = ACTIONS(2326),
    [sym_number_literal] = ACTIONS(2328),
    [anon_sym_L_SQUOTE] = ACTIONS(2328),
    [anon_sym_u_SQUOTE] = ACTIONS(2328),
    [anon_sym_U_SQUOTE] = ACTIONS(2328),
    [anon_sym_u8_SQUOTE] = ACTIONS(2328),
    [anon_sym_SQUOTE] = ACTIONS(2328),
    [anon_sym_L_DQUOTE] = ACTIONS(2328),
    [anon_sym_u_DQUOTE] = ACTIONS(2328),
    [anon_sym_U_DQUOTE] = ACTIONS(2328),
    [anon_sym_u8_DQUOTE] = ACTIONS(2328),
    [anon_sym_DQUOTE] = ACTIONS(2328),
    [sym_true] = ACTIONS(2326),
    [sym_false] = ACTIONS(2326),
    [anon_sym_NULL] = ACTIONS(2326),
    [anon_sym_nullptr] = ACTIONS(2326),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2326),
    [anon_sym_decltype] = ACTIONS(2326),
    [sym_virtual] = ACTIONS(2326),
    [anon_sym_explicit] = ACTIONS(2326),
    [anon_sym_typename] = ACTIONS(2326),
    [anon_sym_template] = ACTIONS(2326),
    [anon_sym_operator] = ACTIONS(2326),
    [anon_sym_try] = ACTIONS(2326),
    [anon_sym_delete] = ACTIONS(2326),
    [anon_sym_throw] = ACTIONS(2326),
    [anon_sym_namespace] = ACTIONS(2326),
    [anon_sym_using] = ACTIONS(2326),
    [anon_sym_static_assert] = ACTIONS(2326),
    [anon_sym_concept] = ACTIONS(2326),
    [anon_sym_co_return] = ACTIONS(2326),
    [anon_sym_co_yield] = ACTIONS(2326),
    [anon_sym_R_DQUOTE] = ACTIONS(2328),
    [anon_sym_LR_DQUOTE] = ACTIONS(2328),
    [anon_sym_uR_DQUOTE] = ACTIONS(2328),
    [anon_sym_UR_DQUOTE] = ACTIONS(2328),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2328),
    [anon_sym_co_await] = ACTIONS(2326),
    [anon_sym_new] = ACTIONS(2326),
    [anon_sym_requires] = ACTIONS(2326),
    [sym_this] = ACTIONS(2326),
    [anon_sym___launch_bounds__] = ACTIONS(2326),
  },
  [466] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_include_token1] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2269),
    [anon_sym_BANG] = ACTIONS(2269),
    [anon_sym_TILDE] = ACTIONS(2269),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_STAR] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(2269),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym___device__] = ACTIONS(2267),
    [anon_sym___host__] = ACTIONS(2267),
    [anon_sym___global__] = ACTIONS(2267),
    [anon_sym___forceinline__] = ACTIONS(2267),
    [anon_sym___noinline__] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2269),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2269),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym___cdecl] = ACTIONS(2267),
    [anon_sym___clrcall] = ACTIONS(2267),
    [anon_sym___stdcall] = ACTIONS(2267),
    [anon_sym___fastcall] = ACTIONS(2267),
    [anon_sym___thiscall] = ACTIONS(2267),
    [anon_sym___vectorcall] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2269),
    [anon_sym_RBRACE] = ACTIONS(2269),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym___shared__] = ACTIONS(2267),
    [anon_sym___local__] = ACTIONS(2267),
    [anon_sym___constant__] = ACTIONS(2267),
    [anon_sym___managed__] = ACTIONS(2267),
    [anon_sym___grid_constant__] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym__Alignas] = ACTIONS(2267),
    [sym_primitive_type] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_switch] = ACTIONS(2267),
    [anon_sym_case] = ACTIONS(2267),
    [anon_sym_default] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_for] = ACTIONS(2267),
    [anon_sym_return] = ACTIONS(2267),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_continue] = ACTIONS(2267),
    [anon_sym_goto] = ACTIONS(2267),
    [anon_sym___try] = ACTIONS(2267),
    [anon_sym___leave] = ACTIONS(2267),
    [anon_sym_not] = ACTIONS(2267),
    [anon_sym_compl] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2269),
    [anon_sym_PLUS_PLUS] = ACTIONS(2269),
    [anon_sym_sizeof] = ACTIONS(2267),
    [anon_sym___alignof__] = ACTIONS(2267),
    [anon_sym___alignof] = ACTIONS(2267),
    [anon_sym__alignof] = ACTIONS(2267),
    [anon_sym_alignof] = ACTIONS(2267),
    [anon_sym__Alignof] = ACTIONS(2267),
    [anon_sym_offsetof] = ACTIONS(2267),
    [anon_sym__Generic] = ACTIONS(2267),
    [anon_sym_asm] = ACTIONS(2267),
    [anon_sym___asm__] = ACTIONS(2267),
    [sym_number_literal] = ACTIONS(2269),
    [anon_sym_L_SQUOTE] = ACTIONS(2269),
    [anon_sym_u_SQUOTE] = ACTIONS(2269),
    [anon_sym_U_SQUOTE] = ACTIONS(2269),
    [anon_sym_u8_SQUOTE] = ACTIONS(2269),
    [anon_sym_SQUOTE] = ACTIONS(2269),
    [anon_sym_L_DQUOTE] = ACTIONS(2269),
    [anon_sym_u_DQUOTE] = ACTIONS(2269),
    [anon_sym_U_DQUOTE] = ACTIONS(2269),
    [anon_sym_u8_DQUOTE] = ACTIONS(2269),
    [anon_sym_DQUOTE] = ACTIONS(2269),
    [sym_true] = ACTIONS(2267),
    [sym_false] = ACTIONS(2267),
    [anon_sym_NULL] = ACTIONS(2267),
    [anon_sym_nullptr] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [sym_virtual] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_try] = ACTIONS(2267),
    [anon_sym_delete] = ACTIONS(2267),
    [anon_sym_throw] = ACTIONS(2267),
    [anon_sym_namespace] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym_concept] = ACTIONS(2267),
    [anon_sym_co_return] = ACTIONS(2267),
    [anon_sym_co_yield] = ACTIONS(2267),
    [anon_sym_R_DQUOTE] = ACTIONS(2269),
    [anon_sym_LR_DQUOTE] = ACTIONS(2269),
    [anon_sym_uR_DQUOTE] = ACTIONS(2269),
    [anon_sym_UR_DQUOTE] = ACTIONS(2269),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2269),
    [anon_sym_co_await] = ACTIONS(2267),
    [anon_sym_new] = ACTIONS(2267),
    [anon_sym_requires] = ACTIONS(2267),
    [sym_this] = ACTIONS(2267),
    [anon_sym___launch_bounds__] = ACTIONS(2267),
  },
  [467] = {
    [sym_identifier] = ACTIONS(2094),
    [aux_sym_preproc_include_token1] = ACTIONS(2094),
    [aux_sym_preproc_def_token1] = ACTIONS(2094),
    [aux_sym_preproc_if_token1] = ACTIONS(2094),
    [aux_sym_preproc_if_token2] = ACTIONS(2094),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2094),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2094),
    [sym_preproc_directive] = ACTIONS(2094),
    [anon_sym_LPAREN2] = ACTIONS(2096),
    [anon_sym_BANG] = ACTIONS(2096),
    [anon_sym_TILDE] = ACTIONS(2096),
    [anon_sym_DASH] = ACTIONS(2094),
    [anon_sym_PLUS] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(2096),
    [anon_sym_AMP_AMP] = ACTIONS(2096),
    [anon_sym_AMP] = ACTIONS(2094),
    [anon_sym_SEMI] = ACTIONS(2096),
    [anon_sym___extension__] = ACTIONS(2094),
    [anon_sym_typedef] = ACTIONS(2094),
    [anon_sym___device__] = ACTIONS(2094),
    [anon_sym___host__] = ACTIONS(2094),
    [anon_sym___global__] = ACTIONS(2094),
    [anon_sym___forceinline__] = ACTIONS(2094),
    [anon_sym___noinline__] = ACTIONS(2094),
    [anon_sym_extern] = ACTIONS(2094),
    [anon_sym___attribute__] = ACTIONS(2094),
    [anon_sym_COLON_COLON] = ACTIONS(2096),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2096),
    [anon_sym___declspec] = ACTIONS(2094),
    [anon_sym___based] = ACTIONS(2094),
    [anon_sym___cdecl] = ACTIONS(2094),
    [anon_sym___clrcall] = ACTIONS(2094),
    [anon_sym___stdcall] = ACTIONS(2094),
    [anon_sym___fastcall] = ACTIONS(2094),
    [anon_sym___thiscall] = ACTIONS(2094),
    [anon_sym___vectorcall] = ACTIONS(2094),
    [anon_sym_LBRACE] = ACTIONS(2096),
    [anon_sym_signed] = ACTIONS(2094),
    [anon_sym_unsigned] = ACTIONS(2094),
    [anon_sym_long] = ACTIONS(2094),
    [anon_sym_short] = ACTIONS(2094),
    [anon_sym_LBRACK] = ACTIONS(2094),
    [anon_sym_static] = ACTIONS(2094),
    [anon_sym_register] = ACTIONS(2094),
    [anon_sym_inline] = ACTIONS(2094),
    [anon_sym___inline] = ACTIONS(2094),
    [anon_sym___inline__] = ACTIONS(2094),
    [anon_sym___forceinline] = ACTIONS(2094),
    [anon_sym_thread_local] = ACTIONS(2094),
    [anon_sym___thread] = ACTIONS(2094),
    [anon_sym_const] = ACTIONS(2094),
    [anon_sym_constexpr] = ACTIONS(2094),
    [anon_sym_volatile] = ACTIONS(2094),
    [anon_sym_restrict] = ACTIONS(2094),
    [anon_sym___restrict__] = ACTIONS(2094),
    [anon_sym__Atomic] = ACTIONS(2094),
    [anon_sym__Noreturn] = ACTIONS(2094),
    [anon_sym_noreturn] = ACTIONS(2094),
    [anon_sym_mutable] = ACTIONS(2094),
    [anon_sym_constinit] = ACTIONS(2094),
    [anon_sym_consteval] = ACTIONS(2094),
    [anon_sym___shared__] = ACTIONS(2094),
    [anon_sym___local__] = ACTIONS(2094),
    [anon_sym___constant__] = ACTIONS(2094),
    [anon_sym___managed__] = ACTIONS(2094),
    [anon_sym___grid_constant__] = ACTIONS(2094),
    [anon_sym_alignas] = ACTIONS(2094),
    [anon_sym__Alignas] = ACTIONS(2094),
    [sym_primitive_type] = ACTIONS(2094),
    [anon_sym_enum] = ACTIONS(2094),
    [anon_sym_class] = ACTIONS(2094),
    [anon_sym_struct] = ACTIONS(2094),
    [anon_sym_union] = ACTIONS(2094),
    [anon_sym_if] = ACTIONS(2094),
    [anon_sym_switch] = ACTIONS(2094),
    [anon_sym_case] = ACTIONS(2094),
    [anon_sym_default] = ACTIONS(2094),
    [anon_sym_while] = ACTIONS(2094),
    [anon_sym_do] = ACTIONS(2094),
    [anon_sym_for] = ACTIONS(2094),
    [anon_sym_return] = ACTIONS(2094),
    [anon_sym_break] = ACTIONS(2094),
    [anon_sym_continue] = ACTIONS(2094),
    [anon_sym_goto] = ACTIONS(2094),
    [anon_sym___try] = ACTIONS(2094),
    [anon_sym___leave] = ACTIONS(2094),
    [anon_sym_not] = ACTIONS(2094),
    [anon_sym_compl] = ACTIONS(2094),
    [anon_sym_DASH_DASH] = ACTIONS(2096),
    [anon_sym_PLUS_PLUS] = ACTIONS(2096),
    [anon_sym_sizeof] = ACTIONS(2094),
    [anon_sym___alignof__] = ACTIONS(2094),
    [anon_sym___alignof] = ACTIONS(2094),
    [anon_sym__alignof] = ACTIONS(2094),
    [anon_sym_alignof] = ACTIONS(2094),
    [anon_sym__Alignof] = ACTIONS(2094),
    [anon_sym_offsetof] = ACTIONS(2094),
    [anon_sym__Generic] = ACTIONS(2094),
    [anon_sym_asm] = ACTIONS(2094),
    [anon_sym___asm__] = ACTIONS(2094),
    [sym_number_literal] = ACTIONS(2096),
    [anon_sym_L_SQUOTE] = ACTIONS(2096),
    [anon_sym_u_SQUOTE] = ACTIONS(2096),
    [anon_sym_U_SQUOTE] = ACTIONS(2096),
    [anon_sym_u8_SQUOTE] = ACTIONS(2096),
    [anon_sym_SQUOTE] = ACTIONS(2096),
    [anon_sym_L_DQUOTE] = ACTIONS(2096),
    [anon_sym_u_DQUOTE] = ACTIONS(2096),
    [anon_sym_U_DQUOTE] = ACTIONS(2096),
    [anon_sym_u8_DQUOTE] = ACTIONS(2096),
    [anon_sym_DQUOTE] = ACTIONS(2096),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2094),
    [anon_sym_nullptr] = ACTIONS(2094),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2094),
    [anon_sym_decltype] = ACTIONS(2094),
    [sym_virtual] = ACTIONS(2094),
    [anon_sym_explicit] = ACTIONS(2094),
    [anon_sym_typename] = ACTIONS(2094),
    [anon_sym_template] = ACTIONS(2094),
    [anon_sym_operator] = ACTIONS(2094),
    [anon_sym_try] = ACTIONS(2094),
    [anon_sym_delete] = ACTIONS(2094),
    [anon_sym_throw] = ACTIONS(2094),
    [anon_sym_namespace] = ACTIONS(2094),
    [anon_sym_using] = ACTIONS(2094),
    [anon_sym_static_assert] = ACTIONS(2094),
    [anon_sym_concept] = ACTIONS(2094),
    [anon_sym_co_return] = ACTIONS(2094),
    [anon_sym_co_yield] = ACTIONS(2094),
    [anon_sym_R_DQUOTE] = ACTIONS(2096),
    [anon_sym_LR_DQUOTE] = ACTIONS(2096),
    [anon_sym_uR_DQUOTE] = ACTIONS(2096),
    [anon_sym_UR_DQUOTE] = ACTIONS(2096),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2096),
    [anon_sym_co_await] = ACTIONS(2094),
    [anon_sym_new] = ACTIONS(2094),
    [anon_sym_requires] = ACTIONS(2094),
    [sym_this] = ACTIONS(2094),
    [anon_sym___launch_bounds__] = ACTIONS(2094),
  },
  [468] = {
    [sym_identifier] = ACTIONS(2172),
    [aux_sym_preproc_include_token1] = ACTIONS(2172),
    [aux_sym_preproc_def_token1] = ACTIONS(2172),
    [aux_sym_preproc_if_token1] = ACTIONS(2172),
    [aux_sym_preproc_if_token2] = ACTIONS(2172),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2172),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2172),
    [sym_preproc_directive] = ACTIONS(2172),
    [anon_sym_LPAREN2] = ACTIONS(2174),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2174),
    [anon_sym_DASH] = ACTIONS(2172),
    [anon_sym_PLUS] = ACTIONS(2172),
    [anon_sym_STAR] = ACTIONS(2174),
    [anon_sym_AMP_AMP] = ACTIONS(2174),
    [anon_sym_AMP] = ACTIONS(2172),
    [anon_sym_SEMI] = ACTIONS(2174),
    [anon_sym___extension__] = ACTIONS(2172),
    [anon_sym_typedef] = ACTIONS(2172),
    [anon_sym___device__] = ACTIONS(2172),
    [anon_sym___host__] = ACTIONS(2172),
    [anon_sym___global__] = ACTIONS(2172),
    [anon_sym___forceinline__] = ACTIONS(2172),
    [anon_sym___noinline__] = ACTIONS(2172),
    [anon_sym_extern] = ACTIONS(2172),
    [anon_sym___attribute__] = ACTIONS(2172),
    [anon_sym_COLON_COLON] = ACTIONS(2174),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2174),
    [anon_sym___declspec] = ACTIONS(2172),
    [anon_sym___based] = ACTIONS(2172),
    [anon_sym___cdecl] = ACTIONS(2172),
    [anon_sym___clrcall] = ACTIONS(2172),
    [anon_sym___stdcall] = ACTIONS(2172),
    [anon_sym___fastcall] = ACTIONS(2172),
    [anon_sym___thiscall] = ACTIONS(2172),
    [anon_sym___vectorcall] = ACTIONS(2172),
    [anon_sym_LBRACE] = ACTIONS(2174),
    [anon_sym_signed] = ACTIONS(2172),
    [anon_sym_unsigned] = ACTIONS(2172),
    [anon_sym_long] = ACTIONS(2172),
    [anon_sym_short] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2172),
    [anon_sym_static] = ACTIONS(2172),
    [anon_sym_register] = ACTIONS(2172),
    [anon_sym_inline] = ACTIONS(2172),
    [anon_sym___inline] = ACTIONS(2172),
    [anon_sym___inline__] = ACTIONS(2172),
    [anon_sym___forceinline] = ACTIONS(2172),
    [anon_sym_thread_local] = ACTIONS(2172),
    [anon_sym___thread] = ACTIONS(2172),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_constexpr] = ACTIONS(2172),
    [anon_sym_volatile] = ACTIONS(2172),
    [anon_sym_restrict] = ACTIONS(2172),
    [anon_sym___restrict__] = ACTIONS(2172),
    [anon_sym__Atomic] = ACTIONS(2172),
    [anon_sym__Noreturn] = ACTIONS(2172),
    [anon_sym_noreturn] = ACTIONS(2172),
    [anon_sym_mutable] = ACTIONS(2172),
    [anon_sym_constinit] = ACTIONS(2172),
    [anon_sym_consteval] = ACTIONS(2172),
    [anon_sym___shared__] = ACTIONS(2172),
    [anon_sym___local__] = ACTIONS(2172),
    [anon_sym___constant__] = ACTIONS(2172),
    [anon_sym___managed__] = ACTIONS(2172),
    [anon_sym___grid_constant__] = ACTIONS(2172),
    [anon_sym_alignas] = ACTIONS(2172),
    [anon_sym__Alignas] = ACTIONS(2172),
    [sym_primitive_type] = ACTIONS(2172),
    [anon_sym_enum] = ACTIONS(2172),
    [anon_sym_class] = ACTIONS(2172),
    [anon_sym_struct] = ACTIONS(2172),
    [anon_sym_union] = ACTIONS(2172),
    [anon_sym_if] = ACTIONS(2172),
    [anon_sym_switch] = ACTIONS(2172),
    [anon_sym_case] = ACTIONS(2172),
    [anon_sym_default] = ACTIONS(2172),
    [anon_sym_while] = ACTIONS(2172),
    [anon_sym_do] = ACTIONS(2172),
    [anon_sym_for] = ACTIONS(2172),
    [anon_sym_return] = ACTIONS(2172),
    [anon_sym_break] = ACTIONS(2172),
    [anon_sym_continue] = ACTIONS(2172),
    [anon_sym_goto] = ACTIONS(2172),
    [anon_sym___try] = ACTIONS(2172),
    [anon_sym___leave] = ACTIONS(2172),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_compl] = ACTIONS(2172),
    [anon_sym_DASH_DASH] = ACTIONS(2174),
    [anon_sym_PLUS_PLUS] = ACTIONS(2174),
    [anon_sym_sizeof] = ACTIONS(2172),
    [anon_sym___alignof__] = ACTIONS(2172),
    [anon_sym___alignof] = ACTIONS(2172),
    [anon_sym__alignof] = ACTIONS(2172),
    [anon_sym_alignof] = ACTIONS(2172),
    [anon_sym__Alignof] = ACTIONS(2172),
    [anon_sym_offsetof] = ACTIONS(2172),
    [anon_sym__Generic] = ACTIONS(2172),
    [anon_sym_asm] = ACTIONS(2172),
    [anon_sym___asm__] = ACTIONS(2172),
    [sym_number_literal] = ACTIONS(2174),
    [anon_sym_L_SQUOTE] = ACTIONS(2174),
    [anon_sym_u_SQUOTE] = ACTIONS(2174),
    [anon_sym_U_SQUOTE] = ACTIONS(2174),
    [anon_sym_u8_SQUOTE] = ACTIONS(2174),
    [anon_sym_SQUOTE] = ACTIONS(2174),
    [anon_sym_L_DQUOTE] = ACTIONS(2174),
    [anon_sym_u_DQUOTE] = ACTIONS(2174),
    [anon_sym_U_DQUOTE] = ACTIONS(2174),
    [anon_sym_u8_DQUOTE] = ACTIONS(2174),
    [anon_sym_DQUOTE] = ACTIONS(2174),
    [sym_true] = ACTIONS(2172),
    [sym_false] = ACTIONS(2172),
    [anon_sym_NULL] = ACTIONS(2172),
    [anon_sym_nullptr] = ACTIONS(2172),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2172),
    [anon_sym_decltype] = ACTIONS(2172),
    [sym_virtual] = ACTIONS(2172),
    [anon_sym_explicit] = ACTIONS(2172),
    [anon_sym_typename] = ACTIONS(2172),
    [anon_sym_template] = ACTIONS(2172),
    [anon_sym_operator] = ACTIONS(2172),
    [anon_sym_try] = ACTIONS(2172),
    [anon_sym_delete] = ACTIONS(2172),
    [anon_sym_throw] = ACTIONS(2172),
    [anon_sym_namespace] = ACTIONS(2172),
    [anon_sym_using] = ACTIONS(2172),
    [anon_sym_static_assert] = ACTIONS(2172),
    [anon_sym_concept] = ACTIONS(2172),
    [anon_sym_co_return] = ACTIONS(2172),
    [anon_sym_co_yield] = ACTIONS(2172),
    [anon_sym_R_DQUOTE] = ACTIONS(2174),
    [anon_sym_LR_DQUOTE] = ACTIONS(2174),
    [anon_sym_uR_DQUOTE] = ACTIONS(2174),
    [anon_sym_UR_DQUOTE] = ACTIONS(2174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2174),
    [anon_sym_co_await] = ACTIONS(2172),
    [anon_sym_new] = ACTIONS(2172),
    [anon_sym_requires] = ACTIONS(2172),
    [sym_this] = ACTIONS(2172),
    [anon_sym___launch_bounds__] = ACTIONS(2172),
  },
  [469] = {
    [sym_identifier] = ACTIONS(2180),
    [aux_sym_preproc_include_token1] = ACTIONS(2180),
    [aux_sym_preproc_def_token1] = ACTIONS(2180),
    [aux_sym_preproc_if_token1] = ACTIONS(2180),
    [aux_sym_preproc_if_token2] = ACTIONS(2180),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2180),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2180),
    [sym_preproc_directive] = ACTIONS(2180),
    [anon_sym_LPAREN2] = ACTIONS(2182),
    [anon_sym_BANG] = ACTIONS(2182),
    [anon_sym_TILDE] = ACTIONS(2182),
    [anon_sym_DASH] = ACTIONS(2180),
    [anon_sym_PLUS] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(2182),
    [anon_sym_AMP_AMP] = ACTIONS(2182),
    [anon_sym_AMP] = ACTIONS(2180),
    [anon_sym_SEMI] = ACTIONS(2182),
    [anon_sym___extension__] = ACTIONS(2180),
    [anon_sym_typedef] = ACTIONS(2180),
    [anon_sym___device__] = ACTIONS(2180),
    [anon_sym___host__] = ACTIONS(2180),
    [anon_sym___global__] = ACTIONS(2180),
    [anon_sym___forceinline__] = ACTIONS(2180),
    [anon_sym___noinline__] = ACTIONS(2180),
    [anon_sym_extern] = ACTIONS(2180),
    [anon_sym___attribute__] = ACTIONS(2180),
    [anon_sym_COLON_COLON] = ACTIONS(2182),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2182),
    [anon_sym___declspec] = ACTIONS(2180),
    [anon_sym___based] = ACTIONS(2180),
    [anon_sym___cdecl] = ACTIONS(2180),
    [anon_sym___clrcall] = ACTIONS(2180),
    [anon_sym___stdcall] = ACTIONS(2180),
    [anon_sym___fastcall] = ACTIONS(2180),
    [anon_sym___thiscall] = ACTIONS(2180),
    [anon_sym___vectorcall] = ACTIONS(2180),
    [anon_sym_LBRACE] = ACTIONS(2182),
    [anon_sym_signed] = ACTIONS(2180),
    [anon_sym_unsigned] = ACTIONS(2180),
    [anon_sym_long] = ACTIONS(2180),
    [anon_sym_short] = ACTIONS(2180),
    [anon_sym_LBRACK] = ACTIONS(2180),
    [anon_sym_static] = ACTIONS(2180),
    [anon_sym_register] = ACTIONS(2180),
    [anon_sym_inline] = ACTIONS(2180),
    [anon_sym___inline] = ACTIONS(2180),
    [anon_sym___inline__] = ACTIONS(2180),
    [anon_sym___forceinline] = ACTIONS(2180),
    [anon_sym_thread_local] = ACTIONS(2180),
    [anon_sym___thread] = ACTIONS(2180),
    [anon_sym_const] = ACTIONS(2180),
    [anon_sym_constexpr] = ACTIONS(2180),
    [anon_sym_volatile] = ACTIONS(2180),
    [anon_sym_restrict] = ACTIONS(2180),
    [anon_sym___restrict__] = ACTIONS(2180),
    [anon_sym__Atomic] = ACTIONS(2180),
    [anon_sym__Noreturn] = ACTIONS(2180),
    [anon_sym_noreturn] = ACTIONS(2180),
    [anon_sym_mutable] = ACTIONS(2180),
    [anon_sym_constinit] = ACTIONS(2180),
    [anon_sym_consteval] = ACTIONS(2180),
    [anon_sym___shared__] = ACTIONS(2180),
    [anon_sym___local__] = ACTIONS(2180),
    [anon_sym___constant__] = ACTIONS(2180),
    [anon_sym___managed__] = ACTIONS(2180),
    [anon_sym___grid_constant__] = ACTIONS(2180),
    [anon_sym_alignas] = ACTIONS(2180),
    [anon_sym__Alignas] = ACTIONS(2180),
    [sym_primitive_type] = ACTIONS(2180),
    [anon_sym_enum] = ACTIONS(2180),
    [anon_sym_class] = ACTIONS(2180),
    [anon_sym_struct] = ACTIONS(2180),
    [anon_sym_union] = ACTIONS(2180),
    [anon_sym_if] = ACTIONS(2180),
    [anon_sym_switch] = ACTIONS(2180),
    [anon_sym_case] = ACTIONS(2180),
    [anon_sym_default] = ACTIONS(2180),
    [anon_sym_while] = ACTIONS(2180),
    [anon_sym_do] = ACTIONS(2180),
    [anon_sym_for] = ACTIONS(2180),
    [anon_sym_return] = ACTIONS(2180),
    [anon_sym_break] = ACTIONS(2180),
    [anon_sym_continue] = ACTIONS(2180),
    [anon_sym_goto] = ACTIONS(2180),
    [anon_sym___try] = ACTIONS(2180),
    [anon_sym___leave] = ACTIONS(2180),
    [anon_sym_not] = ACTIONS(2180),
    [anon_sym_compl] = ACTIONS(2180),
    [anon_sym_DASH_DASH] = ACTIONS(2182),
    [anon_sym_PLUS_PLUS] = ACTIONS(2182),
    [anon_sym_sizeof] = ACTIONS(2180),
    [anon_sym___alignof__] = ACTIONS(2180),
    [anon_sym___alignof] = ACTIONS(2180),
    [anon_sym__alignof] = ACTIONS(2180),
    [anon_sym_alignof] = ACTIONS(2180),
    [anon_sym__Alignof] = ACTIONS(2180),
    [anon_sym_offsetof] = ACTIONS(2180),
    [anon_sym__Generic] = ACTIONS(2180),
    [anon_sym_asm] = ACTIONS(2180),
    [anon_sym___asm__] = ACTIONS(2180),
    [sym_number_literal] = ACTIONS(2182),
    [anon_sym_L_SQUOTE] = ACTIONS(2182),
    [anon_sym_u_SQUOTE] = ACTIONS(2182),
    [anon_sym_U_SQUOTE] = ACTIONS(2182),
    [anon_sym_u8_SQUOTE] = ACTIONS(2182),
    [anon_sym_SQUOTE] = ACTIONS(2182),
    [anon_sym_L_DQUOTE] = ACTIONS(2182),
    [anon_sym_u_DQUOTE] = ACTIONS(2182),
    [anon_sym_U_DQUOTE] = ACTIONS(2182),
    [anon_sym_u8_DQUOTE] = ACTIONS(2182),
    [anon_sym_DQUOTE] = ACTIONS(2182),
    [sym_true] = ACTIONS(2180),
    [sym_false] = ACTIONS(2180),
    [anon_sym_NULL] = ACTIONS(2180),
    [anon_sym_nullptr] = ACTIONS(2180),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2180),
    [anon_sym_decltype] = ACTIONS(2180),
    [sym_virtual] = ACTIONS(2180),
    [anon_sym_explicit] = ACTIONS(2180),
    [anon_sym_typename] = ACTIONS(2180),
    [anon_sym_template] = ACTIONS(2180),
    [anon_sym_operator] = ACTIONS(2180),
    [anon_sym_try] = ACTIONS(2180),
    [anon_sym_delete] = ACTIONS(2180),
    [anon_sym_throw] = ACTIONS(2180),
    [anon_sym_namespace] = ACTIONS(2180),
    [anon_sym_using] = ACTIONS(2180),
    [anon_sym_static_assert] = ACTIONS(2180),
    [anon_sym_concept] = ACTIONS(2180),
    [anon_sym_co_return] = ACTIONS(2180),
    [anon_sym_co_yield] = ACTIONS(2180),
    [anon_sym_R_DQUOTE] = ACTIONS(2182),
    [anon_sym_LR_DQUOTE] = ACTIONS(2182),
    [anon_sym_uR_DQUOTE] = ACTIONS(2182),
    [anon_sym_UR_DQUOTE] = ACTIONS(2182),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2182),
    [anon_sym_co_await] = ACTIONS(2180),
    [anon_sym_new] = ACTIONS(2180),
    [anon_sym_requires] = ACTIONS(2180),
    [sym_this] = ACTIONS(2180),
    [anon_sym___launch_bounds__] = ACTIONS(2180),
  },
  [470] = {
    [sym_identifier] = ACTIONS(2191),
    [aux_sym_preproc_include_token1] = ACTIONS(2191),
    [aux_sym_preproc_def_token1] = ACTIONS(2191),
    [aux_sym_preproc_if_token1] = ACTIONS(2191),
    [aux_sym_preproc_if_token2] = ACTIONS(2191),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2191),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2191),
    [sym_preproc_directive] = ACTIONS(2191),
    [anon_sym_LPAREN2] = ACTIONS(2193),
    [anon_sym_BANG] = ACTIONS(2193),
    [anon_sym_TILDE] = ACTIONS(2193),
    [anon_sym_DASH] = ACTIONS(2191),
    [anon_sym_PLUS] = ACTIONS(2191),
    [anon_sym_STAR] = ACTIONS(2193),
    [anon_sym_AMP_AMP] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2191),
    [anon_sym_SEMI] = ACTIONS(2193),
    [anon_sym___extension__] = ACTIONS(2191),
    [anon_sym_typedef] = ACTIONS(2191),
    [anon_sym___device__] = ACTIONS(2191),
    [anon_sym___host__] = ACTIONS(2191),
    [anon_sym___global__] = ACTIONS(2191),
    [anon_sym___forceinline__] = ACTIONS(2191),
    [anon_sym___noinline__] = ACTIONS(2191),
    [anon_sym_extern] = ACTIONS(2191),
    [anon_sym___attribute__] = ACTIONS(2191),
    [anon_sym_COLON_COLON] = ACTIONS(2193),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2193),
    [anon_sym___declspec] = ACTIONS(2191),
    [anon_sym___based] = ACTIONS(2191),
    [anon_sym___cdecl] = ACTIONS(2191),
    [anon_sym___clrcall] = ACTIONS(2191),
    [anon_sym___stdcall] = ACTIONS(2191),
    [anon_sym___fastcall] = ACTIONS(2191),
    [anon_sym___thiscall] = ACTIONS(2191),
    [anon_sym___vectorcall] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2193),
    [anon_sym_signed] = ACTIONS(2191),
    [anon_sym_unsigned] = ACTIONS(2191),
    [anon_sym_long] = ACTIONS(2191),
    [anon_sym_short] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2191),
    [anon_sym_static] = ACTIONS(2191),
    [anon_sym_register] = ACTIONS(2191),
    [anon_sym_inline] = ACTIONS(2191),
    [anon_sym___inline] = ACTIONS(2191),
    [anon_sym___inline__] = ACTIONS(2191),
    [anon_sym___forceinline] = ACTIONS(2191),
    [anon_sym_thread_local] = ACTIONS(2191),
    [anon_sym___thread] = ACTIONS(2191),
    [anon_sym_const] = ACTIONS(2191),
    [anon_sym_constexpr] = ACTIONS(2191),
    [anon_sym_volatile] = ACTIONS(2191),
    [anon_sym_restrict] = ACTIONS(2191),
    [anon_sym___restrict__] = ACTIONS(2191),
    [anon_sym__Atomic] = ACTIONS(2191),
    [anon_sym__Noreturn] = ACTIONS(2191),
    [anon_sym_noreturn] = ACTIONS(2191),
    [anon_sym_mutable] = ACTIONS(2191),
    [anon_sym_constinit] = ACTIONS(2191),
    [anon_sym_consteval] = ACTIONS(2191),
    [anon_sym___shared__] = ACTIONS(2191),
    [anon_sym___local__] = ACTIONS(2191),
    [anon_sym___constant__] = ACTIONS(2191),
    [anon_sym___managed__] = ACTIONS(2191),
    [anon_sym___grid_constant__] = ACTIONS(2191),
    [anon_sym_alignas] = ACTIONS(2191),
    [anon_sym__Alignas] = ACTIONS(2191),
    [sym_primitive_type] = ACTIONS(2191),
    [anon_sym_enum] = ACTIONS(2191),
    [anon_sym_class] = ACTIONS(2191),
    [anon_sym_struct] = ACTIONS(2191),
    [anon_sym_union] = ACTIONS(2191),
    [anon_sym_if] = ACTIONS(2191),
    [anon_sym_switch] = ACTIONS(2191),
    [anon_sym_case] = ACTIONS(2191),
    [anon_sym_default] = ACTIONS(2191),
    [anon_sym_while] = ACTIONS(2191),
    [anon_sym_do] = ACTIONS(2191),
    [anon_sym_for] = ACTIONS(2191),
    [anon_sym_return] = ACTIONS(2191),
    [anon_sym_break] = ACTIONS(2191),
    [anon_sym_continue] = ACTIONS(2191),
    [anon_sym_goto] = ACTIONS(2191),
    [anon_sym___try] = ACTIONS(2191),
    [anon_sym___leave] = ACTIONS(2191),
    [anon_sym_not] = ACTIONS(2191),
    [anon_sym_compl] = ACTIONS(2191),
    [anon_sym_DASH_DASH] = ACTIONS(2193),
    [anon_sym_PLUS_PLUS] = ACTIONS(2193),
    [anon_sym_sizeof] = ACTIONS(2191),
    [anon_sym___alignof__] = ACTIONS(2191),
    [anon_sym___alignof] = ACTIONS(2191),
    [anon_sym__alignof] = ACTIONS(2191),
    [anon_sym_alignof] = ACTIONS(2191),
    [anon_sym__Alignof] = ACTIONS(2191),
    [anon_sym_offsetof] = ACTIONS(2191),
    [anon_sym__Generic] = ACTIONS(2191),
    [anon_sym_asm] = ACTIONS(2191),
    [anon_sym___asm__] = ACTIONS(2191),
    [sym_number_literal] = ACTIONS(2193),
    [anon_sym_L_SQUOTE] = ACTIONS(2193),
    [anon_sym_u_SQUOTE] = ACTIONS(2193),
    [anon_sym_U_SQUOTE] = ACTIONS(2193),
    [anon_sym_u8_SQUOTE] = ACTIONS(2193),
    [anon_sym_SQUOTE] = ACTIONS(2193),
    [anon_sym_L_DQUOTE] = ACTIONS(2193),
    [anon_sym_u_DQUOTE] = ACTIONS(2193),
    [anon_sym_U_DQUOTE] = ACTIONS(2193),
    [anon_sym_u8_DQUOTE] = ACTIONS(2193),
    [anon_sym_DQUOTE] = ACTIONS(2193),
    [sym_true] = ACTIONS(2191),
    [sym_false] = ACTIONS(2191),
    [anon_sym_NULL] = ACTIONS(2191),
    [anon_sym_nullptr] = ACTIONS(2191),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2191),
    [anon_sym_decltype] = ACTIONS(2191),
    [sym_virtual] = ACTIONS(2191),
    [anon_sym_explicit] = ACTIONS(2191),
    [anon_sym_typename] = ACTIONS(2191),
    [anon_sym_template] = ACTIONS(2191),
    [anon_sym_operator] = ACTIONS(2191),
    [anon_sym_try] = ACTIONS(2191),
    [anon_sym_delete] = ACTIONS(2191),
    [anon_sym_throw] = ACTIONS(2191),
    [anon_sym_namespace] = ACTIONS(2191),
    [anon_sym_using] = ACTIONS(2191),
    [anon_sym_static_assert] = ACTIONS(2191),
    [anon_sym_concept] = ACTIONS(2191),
    [anon_sym_co_return] = ACTIONS(2191),
    [anon_sym_co_yield] = ACTIONS(2191),
    [anon_sym_R_DQUOTE] = ACTIONS(2193),
    [anon_sym_LR_DQUOTE] = ACTIONS(2193),
    [anon_sym_uR_DQUOTE] = ACTIONS(2193),
    [anon_sym_UR_DQUOTE] = ACTIONS(2193),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2193),
    [anon_sym_co_await] = ACTIONS(2191),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_requires] = ACTIONS(2191),
    [sym_this] = ACTIONS(2191),
    [anon_sym___launch_bounds__] = ACTIONS(2191),
  },
  [471] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_include_token1] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2269),
    [anon_sym_BANG] = ACTIONS(2269),
    [anon_sym_TILDE] = ACTIONS(2269),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_STAR] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(2269),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym___device__] = ACTIONS(2267),
    [anon_sym___host__] = ACTIONS(2267),
    [anon_sym___global__] = ACTIONS(2267),
    [anon_sym___forceinline__] = ACTIONS(2267),
    [anon_sym___noinline__] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2269),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2269),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym___cdecl] = ACTIONS(2267),
    [anon_sym___clrcall] = ACTIONS(2267),
    [anon_sym___stdcall] = ACTIONS(2267),
    [anon_sym___fastcall] = ACTIONS(2267),
    [anon_sym___thiscall] = ACTIONS(2267),
    [anon_sym___vectorcall] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2269),
    [anon_sym_RBRACE] = ACTIONS(2269),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym___shared__] = ACTIONS(2267),
    [anon_sym___local__] = ACTIONS(2267),
    [anon_sym___constant__] = ACTIONS(2267),
    [anon_sym___managed__] = ACTIONS(2267),
    [anon_sym___grid_constant__] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym__Alignas] = ACTIONS(2267),
    [sym_primitive_type] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_switch] = ACTIONS(2267),
    [anon_sym_case] = ACTIONS(2267),
    [anon_sym_default] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_for] = ACTIONS(2267),
    [anon_sym_return] = ACTIONS(2267),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_continue] = ACTIONS(2267),
    [anon_sym_goto] = ACTIONS(2267),
    [anon_sym___try] = ACTIONS(2267),
    [anon_sym___leave] = ACTIONS(2267),
    [anon_sym_not] = ACTIONS(2267),
    [anon_sym_compl] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2269),
    [anon_sym_PLUS_PLUS] = ACTIONS(2269),
    [anon_sym_sizeof] = ACTIONS(2267),
    [anon_sym___alignof__] = ACTIONS(2267),
    [anon_sym___alignof] = ACTIONS(2267),
    [anon_sym__alignof] = ACTIONS(2267),
    [anon_sym_alignof] = ACTIONS(2267),
    [anon_sym__Alignof] = ACTIONS(2267),
    [anon_sym_offsetof] = ACTIONS(2267),
    [anon_sym__Generic] = ACTIONS(2267),
    [anon_sym_asm] = ACTIONS(2267),
    [anon_sym___asm__] = ACTIONS(2267),
    [sym_number_literal] = ACTIONS(2269),
    [anon_sym_L_SQUOTE] = ACTIONS(2269),
    [anon_sym_u_SQUOTE] = ACTIONS(2269),
    [anon_sym_U_SQUOTE] = ACTIONS(2269),
    [anon_sym_u8_SQUOTE] = ACTIONS(2269),
    [anon_sym_SQUOTE] = ACTIONS(2269),
    [anon_sym_L_DQUOTE] = ACTIONS(2269),
    [anon_sym_u_DQUOTE] = ACTIONS(2269),
    [anon_sym_U_DQUOTE] = ACTIONS(2269),
    [anon_sym_u8_DQUOTE] = ACTIONS(2269),
    [anon_sym_DQUOTE] = ACTIONS(2269),
    [sym_true] = ACTIONS(2267),
    [sym_false] = ACTIONS(2267),
    [anon_sym_NULL] = ACTIONS(2267),
    [anon_sym_nullptr] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [sym_virtual] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_try] = ACTIONS(2267),
    [anon_sym_delete] = ACTIONS(2267),
    [anon_sym_throw] = ACTIONS(2267),
    [anon_sym_namespace] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym_concept] = ACTIONS(2267),
    [anon_sym_co_return] = ACTIONS(2267),
    [anon_sym_co_yield] = ACTIONS(2267),
    [anon_sym_R_DQUOTE] = ACTIONS(2269),
    [anon_sym_LR_DQUOTE] = ACTIONS(2269),
    [anon_sym_uR_DQUOTE] = ACTIONS(2269),
    [anon_sym_UR_DQUOTE] = ACTIONS(2269),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2269),
    [anon_sym_co_await] = ACTIONS(2267),
    [anon_sym_new] = ACTIONS(2267),
    [anon_sym_requires] = ACTIONS(2267),
    [sym_this] = ACTIONS(2267),
    [anon_sym___launch_bounds__] = ACTIONS(2267),
  },
  [472] = {
    [sym_identifier] = ACTIONS(2203),
    [aux_sym_preproc_include_token1] = ACTIONS(2203),
    [aux_sym_preproc_def_token1] = ACTIONS(2203),
    [aux_sym_preproc_if_token1] = ACTIONS(2203),
    [aux_sym_preproc_if_token2] = ACTIONS(2203),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2203),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2203),
    [sym_preproc_directive] = ACTIONS(2203),
    [anon_sym_LPAREN2] = ACTIONS(2205),
    [anon_sym_BANG] = ACTIONS(2205),
    [anon_sym_TILDE] = ACTIONS(2205),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_AMP_AMP] = ACTIONS(2205),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_SEMI] = ACTIONS(2205),
    [anon_sym___extension__] = ACTIONS(2203),
    [anon_sym_typedef] = ACTIONS(2203),
    [anon_sym___device__] = ACTIONS(2203),
    [anon_sym___host__] = ACTIONS(2203),
    [anon_sym___global__] = ACTIONS(2203),
    [anon_sym___forceinline__] = ACTIONS(2203),
    [anon_sym___noinline__] = ACTIONS(2203),
    [anon_sym_extern] = ACTIONS(2203),
    [anon_sym___attribute__] = ACTIONS(2203),
    [anon_sym_COLON_COLON] = ACTIONS(2205),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2205),
    [anon_sym___declspec] = ACTIONS(2203),
    [anon_sym___based] = ACTIONS(2203),
    [anon_sym___cdecl] = ACTIONS(2203),
    [anon_sym___clrcall] = ACTIONS(2203),
    [anon_sym___stdcall] = ACTIONS(2203),
    [anon_sym___fastcall] = ACTIONS(2203),
    [anon_sym___thiscall] = ACTIONS(2203),
    [anon_sym___vectorcall] = ACTIONS(2203),
    [anon_sym_LBRACE] = ACTIONS(2205),
    [anon_sym_signed] = ACTIONS(2203),
    [anon_sym_unsigned] = ACTIONS(2203),
    [anon_sym_long] = ACTIONS(2203),
    [anon_sym_short] = ACTIONS(2203),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_static] = ACTIONS(2203),
    [anon_sym_register] = ACTIONS(2203),
    [anon_sym_inline] = ACTIONS(2203),
    [anon_sym___inline] = ACTIONS(2203),
    [anon_sym___inline__] = ACTIONS(2203),
    [anon_sym___forceinline] = ACTIONS(2203),
    [anon_sym_thread_local] = ACTIONS(2203),
    [anon_sym___thread] = ACTIONS(2203),
    [anon_sym_const] = ACTIONS(2203),
    [anon_sym_constexpr] = ACTIONS(2203),
    [anon_sym_volatile] = ACTIONS(2203),
    [anon_sym_restrict] = ACTIONS(2203),
    [anon_sym___restrict__] = ACTIONS(2203),
    [anon_sym__Atomic] = ACTIONS(2203),
    [anon_sym__Noreturn] = ACTIONS(2203),
    [anon_sym_noreturn] = ACTIONS(2203),
    [anon_sym_mutable] = ACTIONS(2203),
    [anon_sym_constinit] = ACTIONS(2203),
    [anon_sym_consteval] = ACTIONS(2203),
    [anon_sym___shared__] = ACTIONS(2203),
    [anon_sym___local__] = ACTIONS(2203),
    [anon_sym___constant__] = ACTIONS(2203),
    [anon_sym___managed__] = ACTIONS(2203),
    [anon_sym___grid_constant__] = ACTIONS(2203),
    [anon_sym_alignas] = ACTIONS(2203),
    [anon_sym__Alignas] = ACTIONS(2203),
    [sym_primitive_type] = ACTIONS(2203),
    [anon_sym_enum] = ACTIONS(2203),
    [anon_sym_class] = ACTIONS(2203),
    [anon_sym_struct] = ACTIONS(2203),
    [anon_sym_union] = ACTIONS(2203),
    [anon_sym_if] = ACTIONS(2203),
    [anon_sym_switch] = ACTIONS(2203),
    [anon_sym_case] = ACTIONS(2203),
    [anon_sym_default] = ACTIONS(2203),
    [anon_sym_while] = ACTIONS(2203),
    [anon_sym_do] = ACTIONS(2203),
    [anon_sym_for] = ACTIONS(2203),
    [anon_sym_return] = ACTIONS(2203),
    [anon_sym_break] = ACTIONS(2203),
    [anon_sym_continue] = ACTIONS(2203),
    [anon_sym_goto] = ACTIONS(2203),
    [anon_sym___try] = ACTIONS(2203),
    [anon_sym___leave] = ACTIONS(2203),
    [anon_sym_not] = ACTIONS(2203),
    [anon_sym_compl] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2205),
    [anon_sym_PLUS_PLUS] = ACTIONS(2205),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2203),
    [anon_sym___alignof] = ACTIONS(2203),
    [anon_sym__alignof] = ACTIONS(2203),
    [anon_sym_alignof] = ACTIONS(2203),
    [anon_sym__Alignof] = ACTIONS(2203),
    [anon_sym_offsetof] = ACTIONS(2203),
    [anon_sym__Generic] = ACTIONS(2203),
    [anon_sym_asm] = ACTIONS(2203),
    [anon_sym___asm__] = ACTIONS(2203),
    [sym_number_literal] = ACTIONS(2205),
    [anon_sym_L_SQUOTE] = ACTIONS(2205),
    [anon_sym_u_SQUOTE] = ACTIONS(2205),
    [anon_sym_U_SQUOTE] = ACTIONS(2205),
    [anon_sym_u8_SQUOTE] = ACTIONS(2205),
    [anon_sym_SQUOTE] = ACTIONS(2205),
    [anon_sym_L_DQUOTE] = ACTIONS(2205),
    [anon_sym_u_DQUOTE] = ACTIONS(2205),
    [anon_sym_U_DQUOTE] = ACTIONS(2205),
    [anon_sym_u8_DQUOTE] = ACTIONS(2205),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [sym_true] = ACTIONS(2203),
    [sym_false] = ACTIONS(2203),
    [anon_sym_NULL] = ACTIONS(2203),
    [anon_sym_nullptr] = ACTIONS(2203),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2203),
    [anon_sym_decltype] = ACTIONS(2203),
    [sym_virtual] = ACTIONS(2203),
    [anon_sym_explicit] = ACTIONS(2203),
    [anon_sym_typename] = ACTIONS(2203),
    [anon_sym_template] = ACTIONS(2203),
    [anon_sym_operator] = ACTIONS(2203),
    [anon_sym_try] = ACTIONS(2203),
    [anon_sym_delete] = ACTIONS(2203),
    [anon_sym_throw] = ACTIONS(2203),
    [anon_sym_namespace] = ACTIONS(2203),
    [anon_sym_using] = ACTIONS(2203),
    [anon_sym_static_assert] = ACTIONS(2203),
    [anon_sym_concept] = ACTIONS(2203),
    [anon_sym_co_return] = ACTIONS(2203),
    [anon_sym_co_yield] = ACTIONS(2203),
    [anon_sym_R_DQUOTE] = ACTIONS(2205),
    [anon_sym_LR_DQUOTE] = ACTIONS(2205),
    [anon_sym_uR_DQUOTE] = ACTIONS(2205),
    [anon_sym_UR_DQUOTE] = ACTIONS(2205),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2205),
    [anon_sym_co_await] = ACTIONS(2203),
    [anon_sym_new] = ACTIONS(2203),
    [anon_sym_requires] = ACTIONS(2203),
    [sym_this] = ACTIONS(2203),
    [anon_sym___launch_bounds__] = ACTIONS(2203),
  },
  [473] = {
    [sym_identifier] = ACTIONS(2154),
    [aux_sym_preproc_include_token1] = ACTIONS(2154),
    [aux_sym_preproc_def_token1] = ACTIONS(2154),
    [aux_sym_preproc_if_token1] = ACTIONS(2154),
    [aux_sym_preproc_if_token2] = ACTIONS(2154),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2154),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2154),
    [sym_preproc_directive] = ACTIONS(2154),
    [anon_sym_LPAREN2] = ACTIONS(2156),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [anon_sym_DASH] = ACTIONS(2154),
    [anon_sym_PLUS] = ACTIONS(2154),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_AMP_AMP] = ACTIONS(2156),
    [anon_sym_AMP] = ACTIONS(2154),
    [anon_sym_SEMI] = ACTIONS(2156),
    [anon_sym___extension__] = ACTIONS(2154),
    [anon_sym_typedef] = ACTIONS(2154),
    [anon_sym___device__] = ACTIONS(2154),
    [anon_sym___host__] = ACTIONS(2154),
    [anon_sym___global__] = ACTIONS(2154),
    [anon_sym___forceinline__] = ACTIONS(2154),
    [anon_sym___noinline__] = ACTIONS(2154),
    [anon_sym_extern] = ACTIONS(2154),
    [anon_sym___attribute__] = ACTIONS(2154),
    [anon_sym_COLON_COLON] = ACTIONS(2156),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2156),
    [anon_sym___declspec] = ACTIONS(2154),
    [anon_sym___based] = ACTIONS(2154),
    [anon_sym___cdecl] = ACTIONS(2154),
    [anon_sym___clrcall] = ACTIONS(2154),
    [anon_sym___stdcall] = ACTIONS(2154),
    [anon_sym___fastcall] = ACTIONS(2154),
    [anon_sym___thiscall] = ACTIONS(2154),
    [anon_sym___vectorcall] = ACTIONS(2154),
    [anon_sym_LBRACE] = ACTIONS(2156),
    [anon_sym_signed] = ACTIONS(2154),
    [anon_sym_unsigned] = ACTIONS(2154),
    [anon_sym_long] = ACTIONS(2154),
    [anon_sym_short] = ACTIONS(2154),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_static] = ACTIONS(2154),
    [anon_sym_register] = ACTIONS(2154),
    [anon_sym_inline] = ACTIONS(2154),
    [anon_sym___inline] = ACTIONS(2154),
    [anon_sym___inline__] = ACTIONS(2154),
    [anon_sym___forceinline] = ACTIONS(2154),
    [anon_sym_thread_local] = ACTIONS(2154),
    [anon_sym___thread] = ACTIONS(2154),
    [anon_sym_const] = ACTIONS(2154),
    [anon_sym_constexpr] = ACTIONS(2154),
    [anon_sym_volatile] = ACTIONS(2154),
    [anon_sym_restrict] = ACTIONS(2154),
    [anon_sym___restrict__] = ACTIONS(2154),
    [anon_sym__Atomic] = ACTIONS(2154),
    [anon_sym__Noreturn] = ACTIONS(2154),
    [anon_sym_noreturn] = ACTIONS(2154),
    [anon_sym_mutable] = ACTIONS(2154),
    [anon_sym_constinit] = ACTIONS(2154),
    [anon_sym_consteval] = ACTIONS(2154),
    [anon_sym___shared__] = ACTIONS(2154),
    [anon_sym___local__] = ACTIONS(2154),
    [anon_sym___constant__] = ACTIONS(2154),
    [anon_sym___managed__] = ACTIONS(2154),
    [anon_sym___grid_constant__] = ACTIONS(2154),
    [anon_sym_alignas] = ACTIONS(2154),
    [anon_sym__Alignas] = ACTIONS(2154),
    [sym_primitive_type] = ACTIONS(2154),
    [anon_sym_enum] = ACTIONS(2154),
    [anon_sym_class] = ACTIONS(2154),
    [anon_sym_struct] = ACTIONS(2154),
    [anon_sym_union] = ACTIONS(2154),
    [anon_sym_if] = ACTIONS(2154),
    [anon_sym_switch] = ACTIONS(2154),
    [anon_sym_case] = ACTIONS(2154),
    [anon_sym_default] = ACTIONS(2154),
    [anon_sym_while] = ACTIONS(2154),
    [anon_sym_do] = ACTIONS(2154),
    [anon_sym_for] = ACTIONS(2154),
    [anon_sym_return] = ACTIONS(2154),
    [anon_sym_break] = ACTIONS(2154),
    [anon_sym_continue] = ACTIONS(2154),
    [anon_sym_goto] = ACTIONS(2154),
    [anon_sym___try] = ACTIONS(2154),
    [anon_sym___leave] = ACTIONS(2154),
    [anon_sym_not] = ACTIONS(2154),
    [anon_sym_compl] = ACTIONS(2154),
    [anon_sym_DASH_DASH] = ACTIONS(2156),
    [anon_sym_PLUS_PLUS] = ACTIONS(2156),
    [anon_sym_sizeof] = ACTIONS(2154),
    [anon_sym___alignof__] = ACTIONS(2154),
    [anon_sym___alignof] = ACTIONS(2154),
    [anon_sym__alignof] = ACTIONS(2154),
    [anon_sym_alignof] = ACTIONS(2154),
    [anon_sym__Alignof] = ACTIONS(2154),
    [anon_sym_offsetof] = ACTIONS(2154),
    [anon_sym__Generic] = ACTIONS(2154),
    [anon_sym_asm] = ACTIONS(2154),
    [anon_sym___asm__] = ACTIONS(2154),
    [sym_number_literal] = ACTIONS(2156),
    [anon_sym_L_SQUOTE] = ACTIONS(2156),
    [anon_sym_u_SQUOTE] = ACTIONS(2156),
    [anon_sym_U_SQUOTE] = ACTIONS(2156),
    [anon_sym_u8_SQUOTE] = ACTIONS(2156),
    [anon_sym_SQUOTE] = ACTIONS(2156),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(2154),
    [sym_false] = ACTIONS(2154),
    [anon_sym_NULL] = ACTIONS(2154),
    [anon_sym_nullptr] = ACTIONS(2154),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2154),
    [anon_sym_decltype] = ACTIONS(2154),
    [sym_virtual] = ACTIONS(2154),
    [anon_sym_explicit] = ACTIONS(2154),
    [anon_sym_typename] = ACTIONS(2154),
    [anon_sym_template] = ACTIONS(2154),
    [anon_sym_operator] = ACTIONS(2154),
    [anon_sym_try] = ACTIONS(2154),
    [anon_sym_delete] = ACTIONS(2154),
    [anon_sym_throw] = ACTIONS(2154),
    [anon_sym_namespace] = ACTIONS(2154),
    [anon_sym_using] = ACTIONS(2154),
    [anon_sym_static_assert] = ACTIONS(2154),
    [anon_sym_concept] = ACTIONS(2154),
    [anon_sym_co_return] = ACTIONS(2154),
    [anon_sym_co_yield] = ACTIONS(2154),
    [anon_sym_R_DQUOTE] = ACTIONS(2156),
    [anon_sym_LR_DQUOTE] = ACTIONS(2156),
    [anon_sym_uR_DQUOTE] = ACTIONS(2156),
    [anon_sym_UR_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2156),
    [anon_sym_co_await] = ACTIONS(2154),
    [anon_sym_new] = ACTIONS(2154),
    [anon_sym_requires] = ACTIONS(2154),
    [sym_this] = ACTIONS(2154),
    [anon_sym___launch_bounds__] = ACTIONS(2154),
  },
  [474] = {
    [sym_identifier] = ACTIONS(2436),
    [aux_sym_preproc_include_token1] = ACTIONS(2436),
    [aux_sym_preproc_def_token1] = ACTIONS(2436),
    [aux_sym_preproc_if_token1] = ACTIONS(2436),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2436),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2436),
    [sym_preproc_directive] = ACTIONS(2436),
    [anon_sym_LPAREN2] = ACTIONS(2438),
    [anon_sym_BANG] = ACTIONS(2438),
    [anon_sym_TILDE] = ACTIONS(2438),
    [anon_sym_DASH] = ACTIONS(2436),
    [anon_sym_PLUS] = ACTIONS(2436),
    [anon_sym_STAR] = ACTIONS(2438),
    [anon_sym_AMP_AMP] = ACTIONS(2438),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym_SEMI] = ACTIONS(2438),
    [anon_sym___extension__] = ACTIONS(2436),
    [anon_sym_typedef] = ACTIONS(2436),
    [anon_sym___device__] = ACTIONS(2436),
    [anon_sym___host__] = ACTIONS(2436),
    [anon_sym___global__] = ACTIONS(2436),
    [anon_sym___forceinline__] = ACTIONS(2436),
    [anon_sym___noinline__] = ACTIONS(2436),
    [anon_sym_extern] = ACTIONS(2436),
    [anon_sym___attribute__] = ACTIONS(2436),
    [anon_sym_COLON_COLON] = ACTIONS(2438),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2438),
    [anon_sym___declspec] = ACTIONS(2436),
    [anon_sym___based] = ACTIONS(2436),
    [anon_sym___cdecl] = ACTIONS(2436),
    [anon_sym___clrcall] = ACTIONS(2436),
    [anon_sym___stdcall] = ACTIONS(2436),
    [anon_sym___fastcall] = ACTIONS(2436),
    [anon_sym___thiscall] = ACTIONS(2436),
    [anon_sym___vectorcall] = ACTIONS(2436),
    [anon_sym_LBRACE] = ACTIONS(2438),
    [anon_sym_RBRACE] = ACTIONS(2438),
    [anon_sym_signed] = ACTIONS(2436),
    [anon_sym_unsigned] = ACTIONS(2436),
    [anon_sym_long] = ACTIONS(2436),
    [anon_sym_short] = ACTIONS(2436),
    [anon_sym_LBRACK] = ACTIONS(2436),
    [anon_sym_static] = ACTIONS(2436),
    [anon_sym_register] = ACTIONS(2436),
    [anon_sym_inline] = ACTIONS(2436),
    [anon_sym___inline] = ACTIONS(2436),
    [anon_sym___inline__] = ACTIONS(2436),
    [anon_sym___forceinline] = ACTIONS(2436),
    [anon_sym_thread_local] = ACTIONS(2436),
    [anon_sym___thread] = ACTIONS(2436),
    [anon_sym_const] = ACTIONS(2436),
    [anon_sym_constexpr] = ACTIONS(2436),
    [anon_sym_volatile] = ACTIONS(2436),
    [anon_sym_restrict] = ACTIONS(2436),
    [anon_sym___restrict__] = ACTIONS(2436),
    [anon_sym__Atomic] = ACTIONS(2436),
    [anon_sym__Noreturn] = ACTIONS(2436),
    [anon_sym_noreturn] = ACTIONS(2436),
    [anon_sym_mutable] = ACTIONS(2436),
    [anon_sym_constinit] = ACTIONS(2436),
    [anon_sym_consteval] = ACTIONS(2436),
    [anon_sym___shared__] = ACTIONS(2436),
    [anon_sym___local__] = ACTIONS(2436),
    [anon_sym___constant__] = ACTIONS(2436),
    [anon_sym___managed__] = ACTIONS(2436),
    [anon_sym___grid_constant__] = ACTIONS(2436),
    [anon_sym_alignas] = ACTIONS(2436),
    [anon_sym__Alignas] = ACTIONS(2436),
    [sym_primitive_type] = ACTIONS(2436),
    [anon_sym_enum] = ACTIONS(2436),
    [anon_sym_class] = ACTIONS(2436),
    [anon_sym_struct] = ACTIONS(2436),
    [anon_sym_union] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(2436),
    [anon_sym_switch] = ACTIONS(2436),
    [anon_sym_case] = ACTIONS(2436),
    [anon_sym_default] = ACTIONS(2436),
    [anon_sym_while] = ACTIONS(2436),
    [anon_sym_do] = ACTIONS(2436),
    [anon_sym_for] = ACTIONS(2436),
    [anon_sym_return] = ACTIONS(2436),
    [anon_sym_break] = ACTIONS(2436),
    [anon_sym_continue] = ACTIONS(2436),
    [anon_sym_goto] = ACTIONS(2436),
    [anon_sym___try] = ACTIONS(2436),
    [anon_sym___leave] = ACTIONS(2436),
    [anon_sym_not] = ACTIONS(2436),
    [anon_sym_compl] = ACTIONS(2436),
    [anon_sym_DASH_DASH] = ACTIONS(2438),
    [anon_sym_PLUS_PLUS] = ACTIONS(2438),
    [anon_sym_sizeof] = ACTIONS(2436),
    [anon_sym___alignof__] = ACTIONS(2436),
    [anon_sym___alignof] = ACTIONS(2436),
    [anon_sym__alignof] = ACTIONS(2436),
    [anon_sym_alignof] = ACTIONS(2436),
    [anon_sym__Alignof] = ACTIONS(2436),
    [anon_sym_offsetof] = ACTIONS(2436),
    [anon_sym__Generic] = ACTIONS(2436),
    [anon_sym_asm] = ACTIONS(2436),
    [anon_sym___asm__] = ACTIONS(2436),
    [sym_number_literal] = ACTIONS(2438),
    [anon_sym_L_SQUOTE] = ACTIONS(2438),
    [anon_sym_u_SQUOTE] = ACTIONS(2438),
    [anon_sym_U_SQUOTE] = ACTIONS(2438),
    [anon_sym_u8_SQUOTE] = ACTIONS(2438),
    [anon_sym_SQUOTE] = ACTIONS(2438),
    [anon_sym_L_DQUOTE] = ACTIONS(2438),
    [anon_sym_u_DQUOTE] = ACTIONS(2438),
    [anon_sym_U_DQUOTE] = ACTIONS(2438),
    [anon_sym_u8_DQUOTE] = ACTIONS(2438),
    [anon_sym_DQUOTE] = ACTIONS(2438),
    [sym_true] = ACTIONS(2436),
    [sym_false] = ACTIONS(2436),
    [anon_sym_NULL] = ACTIONS(2436),
    [anon_sym_nullptr] = ACTIONS(2436),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2436),
    [anon_sym_decltype] = ACTIONS(2436),
    [sym_virtual] = ACTIONS(2436),
    [anon_sym_explicit] = ACTIONS(2436),
    [anon_sym_typename] = ACTIONS(2436),
    [anon_sym_template] = ACTIONS(2436),
    [anon_sym_operator] = ACTIONS(2436),
    [anon_sym_try] = ACTIONS(2436),
    [anon_sym_delete] = ACTIONS(2436),
    [anon_sym_throw] = ACTIONS(2436),
    [anon_sym_namespace] = ACTIONS(2436),
    [anon_sym_using] = ACTIONS(2436),
    [anon_sym_static_assert] = ACTIONS(2436),
    [anon_sym_concept] = ACTIONS(2436),
    [anon_sym_co_return] = ACTIONS(2436),
    [anon_sym_co_yield] = ACTIONS(2436),
    [anon_sym_R_DQUOTE] = ACTIONS(2438),
    [anon_sym_LR_DQUOTE] = ACTIONS(2438),
    [anon_sym_uR_DQUOTE] = ACTIONS(2438),
    [anon_sym_UR_DQUOTE] = ACTIONS(2438),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2438),
    [anon_sym_co_await] = ACTIONS(2436),
    [anon_sym_new] = ACTIONS(2436),
    [anon_sym_requires] = ACTIONS(2436),
    [sym_this] = ACTIONS(2436),
    [anon_sym___launch_bounds__] = ACTIONS(2436),
  },
  [475] = {
    [sym_identifier] = ACTIONS(2292),
    [aux_sym_preproc_include_token1] = ACTIONS(2292),
    [aux_sym_preproc_def_token1] = ACTIONS(2292),
    [aux_sym_preproc_if_token1] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2292),
    [sym_preproc_directive] = ACTIONS(2292),
    [anon_sym_LPAREN2] = ACTIONS(2294),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym___extension__] = ACTIONS(2292),
    [anon_sym_typedef] = ACTIONS(2292),
    [anon_sym___device__] = ACTIONS(2292),
    [anon_sym___host__] = ACTIONS(2292),
    [anon_sym___global__] = ACTIONS(2292),
    [anon_sym___forceinline__] = ACTIONS(2292),
    [anon_sym___noinline__] = ACTIONS(2292),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym___attribute__] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2294),
    [anon_sym___declspec] = ACTIONS(2292),
    [anon_sym___based] = ACTIONS(2292),
    [anon_sym___cdecl] = ACTIONS(2292),
    [anon_sym___clrcall] = ACTIONS(2292),
    [anon_sym___stdcall] = ACTIONS(2292),
    [anon_sym___fastcall] = ACTIONS(2292),
    [anon_sym___thiscall] = ACTIONS(2292),
    [anon_sym___vectorcall] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_RBRACE] = ACTIONS(2294),
    [anon_sym_signed] = ACTIONS(2292),
    [anon_sym_unsigned] = ACTIONS(2292),
    [anon_sym_long] = ACTIONS(2292),
    [anon_sym_short] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_register] = ACTIONS(2292),
    [anon_sym_inline] = ACTIONS(2292),
    [anon_sym___inline] = ACTIONS(2292),
    [anon_sym___inline__] = ACTIONS(2292),
    [anon_sym___forceinline] = ACTIONS(2292),
    [anon_sym_thread_local] = ACTIONS(2292),
    [anon_sym___thread] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym___restrict__] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym__Noreturn] = ACTIONS(2292),
    [anon_sym_noreturn] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_constinit] = ACTIONS(2292),
    [anon_sym_consteval] = ACTIONS(2292),
    [anon_sym___shared__] = ACTIONS(2292),
    [anon_sym___local__] = ACTIONS(2292),
    [anon_sym___constant__] = ACTIONS(2292),
    [anon_sym___managed__] = ACTIONS(2292),
    [anon_sym___grid_constant__] = ACTIONS(2292),
    [anon_sym_alignas] = ACTIONS(2292),
    [anon_sym__Alignas] = ACTIONS(2292),
    [sym_primitive_type] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_struct] = ACTIONS(2292),
    [anon_sym_union] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_case] = ACTIONS(2292),
    [anon_sym_default] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_goto] = ACTIONS(2292),
    [anon_sym___try] = ACTIONS(2292),
    [anon_sym___leave] = ACTIONS(2292),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_compl] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_sizeof] = ACTIONS(2292),
    [anon_sym___alignof__] = ACTIONS(2292),
    [anon_sym___alignof] = ACTIONS(2292),
    [anon_sym__alignof] = ACTIONS(2292),
    [anon_sym_alignof] = ACTIONS(2292),
    [anon_sym__Alignof] = ACTIONS(2292),
    [anon_sym_offsetof] = ACTIONS(2292),
    [anon_sym__Generic] = ACTIONS(2292),
    [anon_sym_asm] = ACTIONS(2292),
    [anon_sym___asm__] = ACTIONS(2292),
    [sym_number_literal] = ACTIONS(2294),
    [anon_sym_L_SQUOTE] = ACTIONS(2294),
    [anon_sym_u_SQUOTE] = ACTIONS(2294),
    [anon_sym_U_SQUOTE] = ACTIONS(2294),
    [anon_sym_u8_SQUOTE] = ACTIONS(2294),
    [anon_sym_SQUOTE] = ACTIONS(2294),
    [anon_sym_L_DQUOTE] = ACTIONS(2294),
    [anon_sym_u_DQUOTE] = ACTIONS(2294),
    [anon_sym_U_DQUOTE] = ACTIONS(2294),
    [anon_sym_u8_DQUOTE] = ACTIONS(2294),
    [anon_sym_DQUOTE] = ACTIONS(2294),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [anon_sym_NULL] = ACTIONS(2292),
    [anon_sym_nullptr] = ACTIONS(2292),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2292),
    [anon_sym_decltype] = ACTIONS(2292),
    [sym_virtual] = ACTIONS(2292),
    [anon_sym_explicit] = ACTIONS(2292),
    [anon_sym_typename] = ACTIONS(2292),
    [anon_sym_template] = ACTIONS(2292),
    [anon_sym_operator] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_delete] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_namespace] = ACTIONS(2292),
    [anon_sym_using] = ACTIONS(2292),
    [anon_sym_static_assert] = ACTIONS(2292),
    [anon_sym_concept] = ACTIONS(2292),
    [anon_sym_co_return] = ACTIONS(2292),
    [anon_sym_co_yield] = ACTIONS(2292),
    [anon_sym_R_DQUOTE] = ACTIONS(2294),
    [anon_sym_LR_DQUOTE] = ACTIONS(2294),
    [anon_sym_uR_DQUOTE] = ACTIONS(2294),
    [anon_sym_UR_DQUOTE] = ACTIONS(2294),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2294),
    [anon_sym_co_await] = ACTIONS(2292),
    [anon_sym_new] = ACTIONS(2292),
    [anon_sym_requires] = ACTIONS(2292),
    [sym_this] = ACTIONS(2292),
    [anon_sym___launch_bounds__] = ACTIONS(2292),
  },
  [476] = {
    [sym_identifier] = ACTIONS(2231),
    [aux_sym_preproc_include_token1] = ACTIONS(2231),
    [aux_sym_preproc_def_token1] = ACTIONS(2231),
    [aux_sym_preproc_if_token1] = ACTIONS(2231),
    [aux_sym_preproc_if_token2] = ACTIONS(2231),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2231),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2231),
    [sym_preproc_directive] = ACTIONS(2231),
    [anon_sym_LPAREN2] = ACTIONS(2233),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym_SEMI] = ACTIONS(2233),
    [anon_sym___extension__] = ACTIONS(2231),
    [anon_sym_typedef] = ACTIONS(2231),
    [anon_sym___device__] = ACTIONS(2231),
    [anon_sym___host__] = ACTIONS(2231),
    [anon_sym___global__] = ACTIONS(2231),
    [anon_sym___forceinline__] = ACTIONS(2231),
    [anon_sym___noinline__] = ACTIONS(2231),
    [anon_sym_extern] = ACTIONS(2231),
    [anon_sym___attribute__] = ACTIONS(2231),
    [anon_sym_COLON_COLON] = ACTIONS(2233),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2233),
    [anon_sym___declspec] = ACTIONS(2231),
    [anon_sym___based] = ACTIONS(2231),
    [anon_sym___cdecl] = ACTIONS(2231),
    [anon_sym___clrcall] = ACTIONS(2231),
    [anon_sym___stdcall] = ACTIONS(2231),
    [anon_sym___fastcall] = ACTIONS(2231),
    [anon_sym___thiscall] = ACTIONS(2231),
    [anon_sym___vectorcall] = ACTIONS(2231),
    [anon_sym_LBRACE] = ACTIONS(2233),
    [anon_sym_signed] = ACTIONS(2231),
    [anon_sym_unsigned] = ACTIONS(2231),
    [anon_sym_long] = ACTIONS(2231),
    [anon_sym_short] = ACTIONS(2231),
    [anon_sym_LBRACK] = ACTIONS(2231),
    [anon_sym_static] = ACTIONS(2231),
    [anon_sym_register] = ACTIONS(2231),
    [anon_sym_inline] = ACTIONS(2231),
    [anon_sym___inline] = ACTIONS(2231),
    [anon_sym___inline__] = ACTIONS(2231),
    [anon_sym___forceinline] = ACTIONS(2231),
    [anon_sym_thread_local] = ACTIONS(2231),
    [anon_sym___thread] = ACTIONS(2231),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_constexpr] = ACTIONS(2231),
    [anon_sym_volatile] = ACTIONS(2231),
    [anon_sym_restrict] = ACTIONS(2231),
    [anon_sym___restrict__] = ACTIONS(2231),
    [anon_sym__Atomic] = ACTIONS(2231),
    [anon_sym__Noreturn] = ACTIONS(2231),
    [anon_sym_noreturn] = ACTIONS(2231),
    [anon_sym_mutable] = ACTIONS(2231),
    [anon_sym_constinit] = ACTIONS(2231),
    [anon_sym_consteval] = ACTIONS(2231),
    [anon_sym___shared__] = ACTIONS(2231),
    [anon_sym___local__] = ACTIONS(2231),
    [anon_sym___constant__] = ACTIONS(2231),
    [anon_sym___managed__] = ACTIONS(2231),
    [anon_sym___grid_constant__] = ACTIONS(2231),
    [anon_sym_alignas] = ACTIONS(2231),
    [anon_sym__Alignas] = ACTIONS(2231),
    [sym_primitive_type] = ACTIONS(2231),
    [anon_sym_enum] = ACTIONS(2231),
    [anon_sym_class] = ACTIONS(2231),
    [anon_sym_struct] = ACTIONS(2231),
    [anon_sym_union] = ACTIONS(2231),
    [anon_sym_if] = ACTIONS(2231),
    [anon_sym_switch] = ACTIONS(2231),
    [anon_sym_case] = ACTIONS(2231),
    [anon_sym_default] = ACTIONS(2231),
    [anon_sym_while] = ACTIONS(2231),
    [anon_sym_do] = ACTIONS(2231),
    [anon_sym_for] = ACTIONS(2231),
    [anon_sym_return] = ACTIONS(2231),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_continue] = ACTIONS(2231),
    [anon_sym_goto] = ACTIONS(2231),
    [anon_sym___try] = ACTIONS(2231),
    [anon_sym___leave] = ACTIONS(2231),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_compl] = ACTIONS(2231),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_sizeof] = ACTIONS(2231),
    [anon_sym___alignof__] = ACTIONS(2231),
    [anon_sym___alignof] = ACTIONS(2231),
    [anon_sym__alignof] = ACTIONS(2231),
    [anon_sym_alignof] = ACTIONS(2231),
    [anon_sym__Alignof] = ACTIONS(2231),
    [anon_sym_offsetof] = ACTIONS(2231),
    [anon_sym__Generic] = ACTIONS(2231),
    [anon_sym_asm] = ACTIONS(2231),
    [anon_sym___asm__] = ACTIONS(2231),
    [sym_number_literal] = ACTIONS(2233),
    [anon_sym_L_SQUOTE] = ACTIONS(2233),
    [anon_sym_u_SQUOTE] = ACTIONS(2233),
    [anon_sym_U_SQUOTE] = ACTIONS(2233),
    [anon_sym_u8_SQUOTE] = ACTIONS(2233),
    [anon_sym_SQUOTE] = ACTIONS(2233),
    [anon_sym_L_DQUOTE] = ACTIONS(2233),
    [anon_sym_u_DQUOTE] = ACTIONS(2233),
    [anon_sym_U_DQUOTE] = ACTIONS(2233),
    [anon_sym_u8_DQUOTE] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(2233),
    [sym_true] = ACTIONS(2231),
    [sym_false] = ACTIONS(2231),
    [anon_sym_NULL] = ACTIONS(2231),
    [anon_sym_nullptr] = ACTIONS(2231),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2231),
    [anon_sym_decltype] = ACTIONS(2231),
    [sym_virtual] = ACTIONS(2231),
    [anon_sym_explicit] = ACTIONS(2231),
    [anon_sym_typename] = ACTIONS(2231),
    [anon_sym_template] = ACTIONS(2231),
    [anon_sym_operator] = ACTIONS(2231),
    [anon_sym_try] = ACTIONS(2231),
    [anon_sym_delete] = ACTIONS(2231),
    [anon_sym_throw] = ACTIONS(2231),
    [anon_sym_namespace] = ACTIONS(2231),
    [anon_sym_using] = ACTIONS(2231),
    [anon_sym_static_assert] = ACTIONS(2231),
    [anon_sym_concept] = ACTIONS(2231),
    [anon_sym_co_return] = ACTIONS(2231),
    [anon_sym_co_yield] = ACTIONS(2231),
    [anon_sym_R_DQUOTE] = ACTIONS(2233),
    [anon_sym_LR_DQUOTE] = ACTIONS(2233),
    [anon_sym_uR_DQUOTE] = ACTIONS(2233),
    [anon_sym_UR_DQUOTE] = ACTIONS(2233),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2233),
    [anon_sym_co_await] = ACTIONS(2231),
    [anon_sym_new] = ACTIONS(2231),
    [anon_sym_requires] = ACTIONS(2231),
    [sym_this] = ACTIONS(2231),
    [anon_sym___launch_bounds__] = ACTIONS(2231),
  },
  [477] = {
    [sym_identifier] = ACTIONS(2296),
    [aux_sym_preproc_include_token1] = ACTIONS(2296),
    [aux_sym_preproc_def_token1] = ACTIONS(2296),
    [aux_sym_preproc_if_token1] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2296),
    [sym_preproc_directive] = ACTIONS(2296),
    [anon_sym_LPAREN2] = ACTIONS(2298),
    [anon_sym_BANG] = ACTIONS(2298),
    [anon_sym_TILDE] = ACTIONS(2298),
    [anon_sym_DASH] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2296),
    [anon_sym_STAR] = ACTIONS(2298),
    [anon_sym_AMP_AMP] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(2298),
    [anon_sym___extension__] = ACTIONS(2296),
    [anon_sym_typedef] = ACTIONS(2296),
    [anon_sym___device__] = ACTIONS(2296),
    [anon_sym___host__] = ACTIONS(2296),
    [anon_sym___global__] = ACTIONS(2296),
    [anon_sym___forceinline__] = ACTIONS(2296),
    [anon_sym___noinline__] = ACTIONS(2296),
    [anon_sym_extern] = ACTIONS(2296),
    [anon_sym___attribute__] = ACTIONS(2296),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2298),
    [anon_sym___declspec] = ACTIONS(2296),
    [anon_sym___based] = ACTIONS(2296),
    [anon_sym___cdecl] = ACTIONS(2296),
    [anon_sym___clrcall] = ACTIONS(2296),
    [anon_sym___stdcall] = ACTIONS(2296),
    [anon_sym___fastcall] = ACTIONS(2296),
    [anon_sym___thiscall] = ACTIONS(2296),
    [anon_sym___vectorcall] = ACTIONS(2296),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_RBRACE] = ACTIONS(2298),
    [anon_sym_signed] = ACTIONS(2296),
    [anon_sym_unsigned] = ACTIONS(2296),
    [anon_sym_long] = ACTIONS(2296),
    [anon_sym_short] = ACTIONS(2296),
    [anon_sym_LBRACK] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_register] = ACTIONS(2296),
    [anon_sym_inline] = ACTIONS(2296),
    [anon_sym___inline] = ACTIONS(2296),
    [anon_sym___inline__] = ACTIONS(2296),
    [anon_sym___forceinline] = ACTIONS(2296),
    [anon_sym_thread_local] = ACTIONS(2296),
    [anon_sym___thread] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_constexpr] = ACTIONS(2296),
    [anon_sym_volatile] = ACTIONS(2296),
    [anon_sym_restrict] = ACTIONS(2296),
    [anon_sym___restrict__] = ACTIONS(2296),
    [anon_sym__Atomic] = ACTIONS(2296),
    [anon_sym__Noreturn] = ACTIONS(2296),
    [anon_sym_noreturn] = ACTIONS(2296),
    [anon_sym_mutable] = ACTIONS(2296),
    [anon_sym_constinit] = ACTIONS(2296),
    [anon_sym_consteval] = ACTIONS(2296),
    [anon_sym___shared__] = ACTIONS(2296),
    [anon_sym___local__] = ACTIONS(2296),
    [anon_sym___constant__] = ACTIONS(2296),
    [anon_sym___managed__] = ACTIONS(2296),
    [anon_sym___grid_constant__] = ACTIONS(2296),
    [anon_sym_alignas] = ACTIONS(2296),
    [anon_sym__Alignas] = ACTIONS(2296),
    [sym_primitive_type] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2296),
    [anon_sym_class] = ACTIONS(2296),
    [anon_sym_struct] = ACTIONS(2296),
    [anon_sym_union] = ACTIONS(2296),
    [anon_sym_if] = ACTIONS(2296),
    [anon_sym_switch] = ACTIONS(2296),
    [anon_sym_case] = ACTIONS(2296),
    [anon_sym_default] = ACTIONS(2296),
    [anon_sym_while] = ACTIONS(2296),
    [anon_sym_do] = ACTIONS(2296),
    [anon_sym_for] = ACTIONS(2296),
    [anon_sym_return] = ACTIONS(2296),
    [anon_sym_break] = ACTIONS(2296),
    [anon_sym_continue] = ACTIONS(2296),
    [anon_sym_goto] = ACTIONS(2296),
    [anon_sym___try] = ACTIONS(2296),
    [anon_sym___leave] = ACTIONS(2296),
    [anon_sym_not] = ACTIONS(2296),
    [anon_sym_compl] = ACTIONS(2296),
    [anon_sym_DASH_DASH] = ACTIONS(2298),
    [anon_sym_PLUS_PLUS] = ACTIONS(2298),
    [anon_sym_sizeof] = ACTIONS(2296),
    [anon_sym___alignof__] = ACTIONS(2296),
    [anon_sym___alignof] = ACTIONS(2296),
    [anon_sym__alignof] = ACTIONS(2296),
    [anon_sym_alignof] = ACTIONS(2296),
    [anon_sym__Alignof] = ACTIONS(2296),
    [anon_sym_offsetof] = ACTIONS(2296),
    [anon_sym__Generic] = ACTIONS(2296),
    [anon_sym_asm] = ACTIONS(2296),
    [anon_sym___asm__] = ACTIONS(2296),
    [sym_number_literal] = ACTIONS(2298),
    [anon_sym_L_SQUOTE] = ACTIONS(2298),
    [anon_sym_u_SQUOTE] = ACTIONS(2298),
    [anon_sym_U_SQUOTE] = ACTIONS(2298),
    [anon_sym_u8_SQUOTE] = ACTIONS(2298),
    [anon_sym_SQUOTE] = ACTIONS(2298),
    [anon_sym_L_DQUOTE] = ACTIONS(2298),
    [anon_sym_u_DQUOTE] = ACTIONS(2298),
    [anon_sym_U_DQUOTE] = ACTIONS(2298),
    [anon_sym_u8_DQUOTE] = ACTIONS(2298),
    [anon_sym_DQUOTE] = ACTIONS(2298),
    [sym_true] = ACTIONS(2296),
    [sym_false] = ACTIONS(2296),
    [anon_sym_NULL] = ACTIONS(2296),
    [anon_sym_nullptr] = ACTIONS(2296),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2296),
    [anon_sym_decltype] = ACTIONS(2296),
    [sym_virtual] = ACTIONS(2296),
    [anon_sym_explicit] = ACTIONS(2296),
    [anon_sym_typename] = ACTIONS(2296),
    [anon_sym_template] = ACTIONS(2296),
    [anon_sym_operator] = ACTIONS(2296),
    [anon_sym_try] = ACTIONS(2296),
    [anon_sym_delete] = ACTIONS(2296),
    [anon_sym_throw] = ACTIONS(2296),
    [anon_sym_namespace] = ACTIONS(2296),
    [anon_sym_using] = ACTIONS(2296),
    [anon_sym_static_assert] = ACTIONS(2296),
    [anon_sym_concept] = ACTIONS(2296),
    [anon_sym_co_return] = ACTIONS(2296),
    [anon_sym_co_yield] = ACTIONS(2296),
    [anon_sym_R_DQUOTE] = ACTIONS(2298),
    [anon_sym_LR_DQUOTE] = ACTIONS(2298),
    [anon_sym_uR_DQUOTE] = ACTIONS(2298),
    [anon_sym_UR_DQUOTE] = ACTIONS(2298),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2298),
    [anon_sym_co_await] = ACTIONS(2296),
    [anon_sym_new] = ACTIONS(2296),
    [anon_sym_requires] = ACTIONS(2296),
    [sym_this] = ACTIONS(2296),
    [anon_sym___launch_bounds__] = ACTIONS(2296),
  },
  [478] = {
    [sym_identifier] = ACTIONS(2255),
    [aux_sym_preproc_include_token1] = ACTIONS(2255),
    [aux_sym_preproc_def_token1] = ACTIONS(2255),
    [aux_sym_preproc_if_token1] = ACTIONS(2255),
    [aux_sym_preproc_if_token2] = ACTIONS(2255),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2255),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2255),
    [sym_preproc_directive] = ACTIONS(2255),
    [anon_sym_LPAREN2] = ACTIONS(2257),
    [anon_sym_BANG] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2257),
    [anon_sym_AMP_AMP] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2255),
    [anon_sym_SEMI] = ACTIONS(2257),
    [anon_sym___extension__] = ACTIONS(2255),
    [anon_sym_typedef] = ACTIONS(2255),
    [anon_sym___device__] = ACTIONS(2255),
    [anon_sym___host__] = ACTIONS(2255),
    [anon_sym___global__] = ACTIONS(2255),
    [anon_sym___forceinline__] = ACTIONS(2255),
    [anon_sym___noinline__] = ACTIONS(2255),
    [anon_sym_extern] = ACTIONS(2255),
    [anon_sym___attribute__] = ACTIONS(2255),
    [anon_sym_COLON_COLON] = ACTIONS(2257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2257),
    [anon_sym___declspec] = ACTIONS(2255),
    [anon_sym___based] = ACTIONS(2255),
    [anon_sym___cdecl] = ACTIONS(2255),
    [anon_sym___clrcall] = ACTIONS(2255),
    [anon_sym___stdcall] = ACTIONS(2255),
    [anon_sym___fastcall] = ACTIONS(2255),
    [anon_sym___thiscall] = ACTIONS(2255),
    [anon_sym___vectorcall] = ACTIONS(2255),
    [anon_sym_LBRACE] = ACTIONS(2257),
    [anon_sym_signed] = ACTIONS(2255),
    [anon_sym_unsigned] = ACTIONS(2255),
    [anon_sym_long] = ACTIONS(2255),
    [anon_sym_short] = ACTIONS(2255),
    [anon_sym_LBRACK] = ACTIONS(2255),
    [anon_sym_static] = ACTIONS(2255),
    [anon_sym_register] = ACTIONS(2255),
    [anon_sym_inline] = ACTIONS(2255),
    [anon_sym___inline] = ACTIONS(2255),
    [anon_sym___inline__] = ACTIONS(2255),
    [anon_sym___forceinline] = ACTIONS(2255),
    [anon_sym_thread_local] = ACTIONS(2255),
    [anon_sym___thread] = ACTIONS(2255),
    [anon_sym_const] = ACTIONS(2255),
    [anon_sym_constexpr] = ACTIONS(2255),
    [anon_sym_volatile] = ACTIONS(2255),
    [anon_sym_restrict] = ACTIONS(2255),
    [anon_sym___restrict__] = ACTIONS(2255),
    [anon_sym__Atomic] = ACTIONS(2255),
    [anon_sym__Noreturn] = ACTIONS(2255),
    [anon_sym_noreturn] = ACTIONS(2255),
    [anon_sym_mutable] = ACTIONS(2255),
    [anon_sym_constinit] = ACTIONS(2255),
    [anon_sym_consteval] = ACTIONS(2255),
    [anon_sym___shared__] = ACTIONS(2255),
    [anon_sym___local__] = ACTIONS(2255),
    [anon_sym___constant__] = ACTIONS(2255),
    [anon_sym___managed__] = ACTIONS(2255),
    [anon_sym___grid_constant__] = ACTIONS(2255),
    [anon_sym_alignas] = ACTIONS(2255),
    [anon_sym__Alignas] = ACTIONS(2255),
    [sym_primitive_type] = ACTIONS(2255),
    [anon_sym_enum] = ACTIONS(2255),
    [anon_sym_class] = ACTIONS(2255),
    [anon_sym_struct] = ACTIONS(2255),
    [anon_sym_union] = ACTIONS(2255),
    [anon_sym_if] = ACTIONS(2255),
    [anon_sym_switch] = ACTIONS(2255),
    [anon_sym_case] = ACTIONS(2255),
    [anon_sym_default] = ACTIONS(2255),
    [anon_sym_while] = ACTIONS(2255),
    [anon_sym_do] = ACTIONS(2255),
    [anon_sym_for] = ACTIONS(2255),
    [anon_sym_return] = ACTIONS(2255),
    [anon_sym_break] = ACTIONS(2255),
    [anon_sym_continue] = ACTIONS(2255),
    [anon_sym_goto] = ACTIONS(2255),
    [anon_sym___try] = ACTIONS(2255),
    [anon_sym___leave] = ACTIONS(2255),
    [anon_sym_not] = ACTIONS(2255),
    [anon_sym_compl] = ACTIONS(2255),
    [anon_sym_DASH_DASH] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2257),
    [anon_sym_sizeof] = ACTIONS(2255),
    [anon_sym___alignof__] = ACTIONS(2255),
    [anon_sym___alignof] = ACTIONS(2255),
    [anon_sym__alignof] = ACTIONS(2255),
    [anon_sym_alignof] = ACTIONS(2255),
    [anon_sym__Alignof] = ACTIONS(2255),
    [anon_sym_offsetof] = ACTIONS(2255),
    [anon_sym__Generic] = ACTIONS(2255),
    [anon_sym_asm] = ACTIONS(2255),
    [anon_sym___asm__] = ACTIONS(2255),
    [sym_number_literal] = ACTIONS(2257),
    [anon_sym_L_SQUOTE] = ACTIONS(2257),
    [anon_sym_u_SQUOTE] = ACTIONS(2257),
    [anon_sym_U_SQUOTE] = ACTIONS(2257),
    [anon_sym_u8_SQUOTE] = ACTIONS(2257),
    [anon_sym_SQUOTE] = ACTIONS(2257),
    [anon_sym_L_DQUOTE] = ACTIONS(2257),
    [anon_sym_u_DQUOTE] = ACTIONS(2257),
    [anon_sym_U_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8_DQUOTE] = ACTIONS(2257),
    [anon_sym_DQUOTE] = ACTIONS(2257),
    [sym_true] = ACTIONS(2255),
    [sym_false] = ACTIONS(2255),
    [anon_sym_NULL] = ACTIONS(2255),
    [anon_sym_nullptr] = ACTIONS(2255),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2255),
    [anon_sym_decltype] = ACTIONS(2255),
    [sym_virtual] = ACTIONS(2255),
    [anon_sym_explicit] = ACTIONS(2255),
    [anon_sym_typename] = ACTIONS(2255),
    [anon_sym_template] = ACTIONS(2255),
    [anon_sym_operator] = ACTIONS(2255),
    [anon_sym_try] = ACTIONS(2255),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_throw] = ACTIONS(2255),
    [anon_sym_namespace] = ACTIONS(2255),
    [anon_sym_using] = ACTIONS(2255),
    [anon_sym_static_assert] = ACTIONS(2255),
    [anon_sym_concept] = ACTIONS(2255),
    [anon_sym_co_return] = ACTIONS(2255),
    [anon_sym_co_yield] = ACTIONS(2255),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [anon_sym_co_await] = ACTIONS(2255),
    [anon_sym_new] = ACTIONS(2255),
    [anon_sym_requires] = ACTIONS(2255),
    [sym_this] = ACTIONS(2255),
    [anon_sym___launch_bounds__] = ACTIONS(2255),
  },
  [479] = {
    [sym_catch_clause] = STATE(282),
    [aux_sym_constructor_try_statement_repeat1] = STATE(282),
    [ts_builtin_sym_end] = ACTIONS(1922),
    [sym_identifier] = ACTIONS(1920),
    [aux_sym_preproc_include_token1] = ACTIONS(1920),
    [aux_sym_preproc_def_token1] = ACTIONS(1920),
    [aux_sym_preproc_if_token1] = ACTIONS(1920),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1920),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1920),
    [sym_preproc_directive] = ACTIONS(1920),
    [anon_sym_LPAREN2] = ACTIONS(1922),
    [anon_sym_BANG] = ACTIONS(1922),
    [anon_sym_TILDE] = ACTIONS(1922),
    [anon_sym_DASH] = ACTIONS(1920),
    [anon_sym_PLUS] = ACTIONS(1920),
    [anon_sym_STAR] = ACTIONS(1922),
    [anon_sym_AMP_AMP] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1920),
    [anon_sym___extension__] = ACTIONS(1920),
    [anon_sym_typedef] = ACTIONS(1920),
    [anon_sym___device__] = ACTIONS(1920),
    [anon_sym___host__] = ACTIONS(1920),
    [anon_sym___global__] = ACTIONS(1920),
    [anon_sym___forceinline__] = ACTIONS(1920),
    [anon_sym___noinline__] = ACTIONS(1920),
    [anon_sym_extern] = ACTIONS(1920),
    [anon_sym___attribute__] = ACTIONS(1920),
    [anon_sym_COLON_COLON] = ACTIONS(1922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1922),
    [anon_sym___declspec] = ACTIONS(1920),
    [anon_sym___based] = ACTIONS(1920),
    [anon_sym___cdecl] = ACTIONS(1920),
    [anon_sym___clrcall] = ACTIONS(1920),
    [anon_sym___stdcall] = ACTIONS(1920),
    [anon_sym___fastcall] = ACTIONS(1920),
    [anon_sym___thiscall] = ACTIONS(1920),
    [anon_sym___vectorcall] = ACTIONS(1920),
    [anon_sym_LBRACE] = ACTIONS(1922),
    [anon_sym_signed] = ACTIONS(1920),
    [anon_sym_unsigned] = ACTIONS(1920),
    [anon_sym_long] = ACTIONS(1920),
    [anon_sym_short] = ACTIONS(1920),
    [anon_sym_LBRACK] = ACTIONS(1920),
    [anon_sym_static] = ACTIONS(1920),
    [anon_sym_register] = ACTIONS(1920),
    [anon_sym_inline] = ACTIONS(1920),
    [anon_sym___inline] = ACTIONS(1920),
    [anon_sym___inline__] = ACTIONS(1920),
    [anon_sym___forceinline] = ACTIONS(1920),
    [anon_sym_thread_local] = ACTIONS(1920),
    [anon_sym___thread] = ACTIONS(1920),
    [anon_sym_const] = ACTIONS(1920),
    [anon_sym_constexpr] = ACTIONS(1920),
    [anon_sym_volatile] = ACTIONS(1920),
    [anon_sym_restrict] = ACTIONS(1920),
    [anon_sym___restrict__] = ACTIONS(1920),
    [anon_sym__Atomic] = ACTIONS(1920),
    [anon_sym__Noreturn] = ACTIONS(1920),
    [anon_sym_noreturn] = ACTIONS(1920),
    [anon_sym_mutable] = ACTIONS(1920),
    [anon_sym_constinit] = ACTIONS(1920),
    [anon_sym_consteval] = ACTIONS(1920),
    [anon_sym___shared__] = ACTIONS(1920),
    [anon_sym___local__] = ACTIONS(1920),
    [anon_sym___constant__] = ACTIONS(1920),
    [anon_sym___managed__] = ACTIONS(1920),
    [anon_sym___grid_constant__] = ACTIONS(1920),
    [anon_sym_alignas] = ACTIONS(1920),
    [anon_sym__Alignas] = ACTIONS(1920),
    [sym_primitive_type] = ACTIONS(1920),
    [anon_sym_enum] = ACTIONS(1920),
    [anon_sym_class] = ACTIONS(1920),
    [anon_sym_struct] = ACTIONS(1920),
    [anon_sym_union] = ACTIONS(1920),
    [anon_sym_if] = ACTIONS(1920),
    [anon_sym_switch] = ACTIONS(1920),
    [anon_sym_case] = ACTIONS(1920),
    [anon_sym_default] = ACTIONS(1920),
    [anon_sym_while] = ACTIONS(1920),
    [anon_sym_do] = ACTIONS(1920),
    [anon_sym_for] = ACTIONS(1920),
    [anon_sym_return] = ACTIONS(1920),
    [anon_sym_break] = ACTIONS(1920),
    [anon_sym_continue] = ACTIONS(1920),
    [anon_sym_goto] = ACTIONS(1920),
    [anon_sym_not] = ACTIONS(1920),
    [anon_sym_compl] = ACTIONS(1920),
    [anon_sym_DASH_DASH] = ACTIONS(1922),
    [anon_sym_PLUS_PLUS] = ACTIONS(1922),
    [anon_sym_sizeof] = ACTIONS(1920),
    [anon_sym___alignof__] = ACTIONS(1920),
    [anon_sym___alignof] = ACTIONS(1920),
    [anon_sym__alignof] = ACTIONS(1920),
    [anon_sym_alignof] = ACTIONS(1920),
    [anon_sym__Alignof] = ACTIONS(1920),
    [anon_sym_offsetof] = ACTIONS(1920),
    [anon_sym__Generic] = ACTIONS(1920),
    [anon_sym_asm] = ACTIONS(1920),
    [anon_sym___asm__] = ACTIONS(1920),
    [sym_number_literal] = ACTIONS(1922),
    [anon_sym_L_SQUOTE] = ACTIONS(1922),
    [anon_sym_u_SQUOTE] = ACTIONS(1922),
    [anon_sym_U_SQUOTE] = ACTIONS(1922),
    [anon_sym_u8_SQUOTE] = ACTIONS(1922),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [anon_sym_L_DQUOTE] = ACTIONS(1922),
    [anon_sym_u_DQUOTE] = ACTIONS(1922),
    [anon_sym_U_DQUOTE] = ACTIONS(1922),
    [anon_sym_u8_DQUOTE] = ACTIONS(1922),
    [anon_sym_DQUOTE] = ACTIONS(1922),
    [sym_true] = ACTIONS(1920),
    [sym_false] = ACTIONS(1920),
    [anon_sym_NULL] = ACTIONS(1920),
    [anon_sym_nullptr] = ACTIONS(1920),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1920),
    [anon_sym_decltype] = ACTIONS(1920),
    [sym_virtual] = ACTIONS(1920),
    [anon_sym_explicit] = ACTIONS(1920),
    [anon_sym_typename] = ACTIONS(1920),
    [anon_sym_template] = ACTIONS(1920),
    [anon_sym_operator] = ACTIONS(1920),
    [anon_sym_try] = ACTIONS(1920),
    [anon_sym_delete] = ACTIONS(1920),
    [anon_sym_throw] = ACTIONS(1920),
    [anon_sym_namespace] = ACTIONS(1920),
    [anon_sym_using] = ACTIONS(1920),
    [anon_sym_static_assert] = ACTIONS(1920),
    [anon_sym_concept] = ACTIONS(1920),
    [anon_sym_co_return] = ACTIONS(1920),
    [anon_sym_co_yield] = ACTIONS(1920),
    [anon_sym_catch] = ACTIONS(2320),
    [anon_sym_R_DQUOTE] = ACTIONS(1922),
    [anon_sym_LR_DQUOTE] = ACTIONS(1922),
    [anon_sym_uR_DQUOTE] = ACTIONS(1922),
    [anon_sym_UR_DQUOTE] = ACTIONS(1922),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1922),
    [anon_sym_co_await] = ACTIONS(1920),
    [anon_sym_new] = ACTIONS(1920),
    [anon_sym_requires] = ACTIONS(1920),
    [sym_this] = ACTIONS(1920),
    [anon_sym___launch_bounds__] = ACTIONS(1920),
  },
  [480] = {
    [sym_type_qualifier] = STATE(3531),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4591),
    [sym_sized_type_specifier] = STATE(2599),
    [sym_enum_specifier] = STATE(2599),
    [sym_struct_specifier] = STATE(2599),
    [sym_union_specifier] = STATE(2599),
    [sym_expression] = STATE(4726),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_type_descriptor] = STATE(7140),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_placeholder_type_specifier] = STATE(2599),
    [sym_decltype_auto] = STATE(2598),
    [sym_decltype] = STATE(2477),
    [sym_class_specifier] = STATE(2599),
    [sym__class_name] = STATE(8015),
    [sym_dependent_type] = STATE(2599),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_type_parameter_pack_expansion] = STATE(7760),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5910),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [aux_sym__type_definition_type_repeat1] = STATE(3531),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2157),
    [sym_identifier] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2725),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2729),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2733),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2757),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2761),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_GT2] = ACTIONS(2779),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [481] = {
    [sym_identifier] = ACTIONS(2316),
    [aux_sym_preproc_include_token1] = ACTIONS(2316),
    [aux_sym_preproc_def_token1] = ACTIONS(2316),
    [aux_sym_preproc_if_token1] = ACTIONS(2316),
    [aux_sym_preproc_if_token2] = ACTIONS(2316),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2316),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2316),
    [sym_preproc_directive] = ACTIONS(2316),
    [anon_sym_LPAREN2] = ACTIONS(2318),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2318),
    [anon_sym_DASH] = ACTIONS(2316),
    [anon_sym_PLUS] = ACTIONS(2316),
    [anon_sym_STAR] = ACTIONS(2318),
    [anon_sym_AMP_AMP] = ACTIONS(2318),
    [anon_sym_AMP] = ACTIONS(2316),
    [anon_sym_SEMI] = ACTIONS(2318),
    [anon_sym___extension__] = ACTIONS(2316),
    [anon_sym_typedef] = ACTIONS(2316),
    [anon_sym___device__] = ACTIONS(2316),
    [anon_sym___host__] = ACTIONS(2316),
    [anon_sym___global__] = ACTIONS(2316),
    [anon_sym___forceinline__] = ACTIONS(2316),
    [anon_sym___noinline__] = ACTIONS(2316),
    [anon_sym_extern] = ACTIONS(2316),
    [anon_sym___attribute__] = ACTIONS(2316),
    [anon_sym_COLON_COLON] = ACTIONS(2318),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2318),
    [anon_sym___declspec] = ACTIONS(2316),
    [anon_sym___based] = ACTIONS(2316),
    [anon_sym___cdecl] = ACTIONS(2316),
    [anon_sym___clrcall] = ACTIONS(2316),
    [anon_sym___stdcall] = ACTIONS(2316),
    [anon_sym___fastcall] = ACTIONS(2316),
    [anon_sym___thiscall] = ACTIONS(2316),
    [anon_sym___vectorcall] = ACTIONS(2316),
    [anon_sym_LBRACE] = ACTIONS(2318),
    [anon_sym_signed] = ACTIONS(2316),
    [anon_sym_unsigned] = ACTIONS(2316),
    [anon_sym_long] = ACTIONS(2316),
    [anon_sym_short] = ACTIONS(2316),
    [anon_sym_LBRACK] = ACTIONS(2316),
    [anon_sym_static] = ACTIONS(2316),
    [anon_sym_register] = ACTIONS(2316),
    [anon_sym_inline] = ACTIONS(2316),
    [anon_sym___inline] = ACTIONS(2316),
    [anon_sym___inline__] = ACTIONS(2316),
    [anon_sym___forceinline] = ACTIONS(2316),
    [anon_sym_thread_local] = ACTIONS(2316),
    [anon_sym___thread] = ACTIONS(2316),
    [anon_sym_const] = ACTIONS(2316),
    [anon_sym_constexpr] = ACTIONS(2316),
    [anon_sym_volatile] = ACTIONS(2316),
    [anon_sym_restrict] = ACTIONS(2316),
    [anon_sym___restrict__] = ACTIONS(2316),
    [anon_sym__Atomic] = ACTIONS(2316),
    [anon_sym__Noreturn] = ACTIONS(2316),
    [anon_sym_noreturn] = ACTIONS(2316),
    [anon_sym_mutable] = ACTIONS(2316),
    [anon_sym_constinit] = ACTIONS(2316),
    [anon_sym_consteval] = ACTIONS(2316),
    [anon_sym___shared__] = ACTIONS(2316),
    [anon_sym___local__] = ACTIONS(2316),
    [anon_sym___constant__] = ACTIONS(2316),
    [anon_sym___managed__] = ACTIONS(2316),
    [anon_sym___grid_constant__] = ACTIONS(2316),
    [anon_sym_alignas] = ACTIONS(2316),
    [anon_sym__Alignas] = ACTIONS(2316),
    [sym_primitive_type] = ACTIONS(2316),
    [anon_sym_enum] = ACTIONS(2316),
    [anon_sym_class] = ACTIONS(2316),
    [anon_sym_struct] = ACTIONS(2316),
    [anon_sym_union] = ACTIONS(2316),
    [anon_sym_if] = ACTIONS(2316),
    [anon_sym_switch] = ACTIONS(2316),
    [anon_sym_case] = ACTIONS(2316),
    [anon_sym_default] = ACTIONS(2316),
    [anon_sym_while] = ACTIONS(2316),
    [anon_sym_do] = ACTIONS(2316),
    [anon_sym_for] = ACTIONS(2316),
    [anon_sym_return] = ACTIONS(2316),
    [anon_sym_break] = ACTIONS(2316),
    [anon_sym_continue] = ACTIONS(2316),
    [anon_sym_goto] = ACTIONS(2316),
    [anon_sym___try] = ACTIONS(2316),
    [anon_sym___leave] = ACTIONS(2316),
    [anon_sym_not] = ACTIONS(2316),
    [anon_sym_compl] = ACTIONS(2316),
    [anon_sym_DASH_DASH] = ACTIONS(2318),
    [anon_sym_PLUS_PLUS] = ACTIONS(2318),
    [anon_sym_sizeof] = ACTIONS(2316),
    [anon_sym___alignof__] = ACTIONS(2316),
    [anon_sym___alignof] = ACTIONS(2316),
    [anon_sym__alignof] = ACTIONS(2316),
    [anon_sym_alignof] = ACTIONS(2316),
    [anon_sym__Alignof] = ACTIONS(2316),
    [anon_sym_offsetof] = ACTIONS(2316),
    [anon_sym__Generic] = ACTIONS(2316),
    [anon_sym_asm] = ACTIONS(2316),
    [anon_sym___asm__] = ACTIONS(2316),
    [sym_number_literal] = ACTIONS(2318),
    [anon_sym_L_SQUOTE] = ACTIONS(2318),
    [anon_sym_u_SQUOTE] = ACTIONS(2318),
    [anon_sym_U_SQUOTE] = ACTIONS(2318),
    [anon_sym_u8_SQUOTE] = ACTIONS(2318),
    [anon_sym_SQUOTE] = ACTIONS(2318),
    [anon_sym_L_DQUOTE] = ACTIONS(2318),
    [anon_sym_u_DQUOTE] = ACTIONS(2318),
    [anon_sym_U_DQUOTE] = ACTIONS(2318),
    [anon_sym_u8_DQUOTE] = ACTIONS(2318),
    [anon_sym_DQUOTE] = ACTIONS(2318),
    [sym_true] = ACTIONS(2316),
    [sym_false] = ACTIONS(2316),
    [anon_sym_NULL] = ACTIONS(2316),
    [anon_sym_nullptr] = ACTIONS(2316),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2316),
    [anon_sym_decltype] = ACTIONS(2316),
    [sym_virtual] = ACTIONS(2316),
    [anon_sym_explicit] = ACTIONS(2316),
    [anon_sym_typename] = ACTIONS(2316),
    [anon_sym_template] = ACTIONS(2316),
    [anon_sym_operator] = ACTIONS(2316),
    [anon_sym_try] = ACTIONS(2316),
    [anon_sym_delete] = ACTIONS(2316),
    [anon_sym_throw] = ACTIONS(2316),
    [anon_sym_namespace] = ACTIONS(2316),
    [anon_sym_using] = ACTIONS(2316),
    [anon_sym_static_assert] = ACTIONS(2316),
    [anon_sym_concept] = ACTIONS(2316),
    [anon_sym_co_return] = ACTIONS(2316),
    [anon_sym_co_yield] = ACTIONS(2316),
    [anon_sym_R_DQUOTE] = ACTIONS(2318),
    [anon_sym_LR_DQUOTE] = ACTIONS(2318),
    [anon_sym_uR_DQUOTE] = ACTIONS(2318),
    [anon_sym_UR_DQUOTE] = ACTIONS(2318),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2318),
    [anon_sym_co_await] = ACTIONS(2316),
    [anon_sym_new] = ACTIONS(2316),
    [anon_sym_requires] = ACTIONS(2316),
    [sym_this] = ACTIONS(2316),
    [anon_sym___launch_bounds__] = ACTIONS(2316),
  },
  [482] = {
    [sym_identifier] = ACTIONS(2312),
    [aux_sym_preproc_include_token1] = ACTIONS(2312),
    [aux_sym_preproc_def_token1] = ACTIONS(2312),
    [aux_sym_preproc_if_token1] = ACTIONS(2312),
    [aux_sym_preproc_if_token2] = ACTIONS(2312),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2312),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2312),
    [sym_preproc_directive] = ACTIONS(2312),
    [anon_sym_LPAREN2] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2314),
    [anon_sym_TILDE] = ACTIONS(2314),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_AMP_AMP] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(2314),
    [anon_sym___extension__] = ACTIONS(2312),
    [anon_sym_typedef] = ACTIONS(2312),
    [anon_sym___device__] = ACTIONS(2312),
    [anon_sym___host__] = ACTIONS(2312),
    [anon_sym___global__] = ACTIONS(2312),
    [anon_sym___forceinline__] = ACTIONS(2312),
    [anon_sym___noinline__] = ACTIONS(2312),
    [anon_sym_extern] = ACTIONS(2312),
    [anon_sym___attribute__] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2314),
    [anon_sym___declspec] = ACTIONS(2312),
    [anon_sym___based] = ACTIONS(2312),
    [anon_sym___cdecl] = ACTIONS(2312),
    [anon_sym___clrcall] = ACTIONS(2312),
    [anon_sym___stdcall] = ACTIONS(2312),
    [anon_sym___fastcall] = ACTIONS(2312),
    [anon_sym___thiscall] = ACTIONS(2312),
    [anon_sym___vectorcall] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_signed] = ACTIONS(2312),
    [anon_sym_unsigned] = ACTIONS(2312),
    [anon_sym_long] = ACTIONS(2312),
    [anon_sym_short] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_register] = ACTIONS(2312),
    [anon_sym_inline] = ACTIONS(2312),
    [anon_sym___inline] = ACTIONS(2312),
    [anon_sym___inline__] = ACTIONS(2312),
    [anon_sym___forceinline] = ACTIONS(2312),
    [anon_sym_thread_local] = ACTIONS(2312),
    [anon_sym___thread] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_constexpr] = ACTIONS(2312),
    [anon_sym_volatile] = ACTIONS(2312),
    [anon_sym_restrict] = ACTIONS(2312),
    [anon_sym___restrict__] = ACTIONS(2312),
    [anon_sym__Atomic] = ACTIONS(2312),
    [anon_sym__Noreturn] = ACTIONS(2312),
    [anon_sym_noreturn] = ACTIONS(2312),
    [anon_sym_mutable] = ACTIONS(2312),
    [anon_sym_constinit] = ACTIONS(2312),
    [anon_sym_consteval] = ACTIONS(2312),
    [anon_sym___shared__] = ACTIONS(2312),
    [anon_sym___local__] = ACTIONS(2312),
    [anon_sym___constant__] = ACTIONS(2312),
    [anon_sym___managed__] = ACTIONS(2312),
    [anon_sym___grid_constant__] = ACTIONS(2312),
    [anon_sym_alignas] = ACTIONS(2312),
    [anon_sym__Alignas] = ACTIONS(2312),
    [sym_primitive_type] = ACTIONS(2312),
    [anon_sym_enum] = ACTIONS(2312),
    [anon_sym_class] = ACTIONS(2312),
    [anon_sym_struct] = ACTIONS(2312),
    [anon_sym_union] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_switch] = ACTIONS(2312),
    [anon_sym_case] = ACTIONS(2312),
    [anon_sym_default] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_break] = ACTIONS(2312),
    [anon_sym_continue] = ACTIONS(2312),
    [anon_sym_goto] = ACTIONS(2312),
    [anon_sym___try] = ACTIONS(2312),
    [anon_sym___leave] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2312),
    [anon_sym_compl] = ACTIONS(2312),
    [anon_sym_DASH_DASH] = ACTIONS(2314),
    [anon_sym_PLUS_PLUS] = ACTIONS(2314),
    [anon_sym_sizeof] = ACTIONS(2312),
    [anon_sym___alignof__] = ACTIONS(2312),
    [anon_sym___alignof] = ACTIONS(2312),
    [anon_sym__alignof] = ACTIONS(2312),
    [anon_sym_alignof] = ACTIONS(2312),
    [anon_sym__Alignof] = ACTIONS(2312),
    [anon_sym_offsetof] = ACTIONS(2312),
    [anon_sym__Generic] = ACTIONS(2312),
    [anon_sym_asm] = ACTIONS(2312),
    [anon_sym___asm__] = ACTIONS(2312),
    [sym_number_literal] = ACTIONS(2314),
    [anon_sym_L_SQUOTE] = ACTIONS(2314),
    [anon_sym_u_SQUOTE] = ACTIONS(2314),
    [anon_sym_U_SQUOTE] = ACTIONS(2314),
    [anon_sym_u8_SQUOTE] = ACTIONS(2314),
    [anon_sym_SQUOTE] = ACTIONS(2314),
    [anon_sym_L_DQUOTE] = ACTIONS(2314),
    [anon_sym_u_DQUOTE] = ACTIONS(2314),
    [anon_sym_U_DQUOTE] = ACTIONS(2314),
    [anon_sym_u8_DQUOTE] = ACTIONS(2314),
    [anon_sym_DQUOTE] = ACTIONS(2314),
    [sym_true] = ACTIONS(2312),
    [sym_false] = ACTIONS(2312),
    [anon_sym_NULL] = ACTIONS(2312),
    [anon_sym_nullptr] = ACTIONS(2312),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2312),
    [anon_sym_decltype] = ACTIONS(2312),
    [sym_virtual] = ACTIONS(2312),
    [anon_sym_explicit] = ACTIONS(2312),
    [anon_sym_typename] = ACTIONS(2312),
    [anon_sym_template] = ACTIONS(2312),
    [anon_sym_operator] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_delete] = ACTIONS(2312),
    [anon_sym_throw] = ACTIONS(2312),
    [anon_sym_namespace] = ACTIONS(2312),
    [anon_sym_using] = ACTIONS(2312),
    [anon_sym_static_assert] = ACTIONS(2312),
    [anon_sym_concept] = ACTIONS(2312),
    [anon_sym_co_return] = ACTIONS(2312),
    [anon_sym_co_yield] = ACTIONS(2312),
    [anon_sym_R_DQUOTE] = ACTIONS(2314),
    [anon_sym_LR_DQUOTE] = ACTIONS(2314),
    [anon_sym_uR_DQUOTE] = ACTIONS(2314),
    [anon_sym_UR_DQUOTE] = ACTIONS(2314),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2314),
    [anon_sym_co_await] = ACTIONS(2312),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_requires] = ACTIONS(2312),
    [sym_this] = ACTIONS(2312),
    [anon_sym___launch_bounds__] = ACTIONS(2312),
  },
  [483] = {
    [sym_identifier] = ACTIONS(2300),
    [aux_sym_preproc_include_token1] = ACTIONS(2300),
    [aux_sym_preproc_def_token1] = ACTIONS(2300),
    [aux_sym_preproc_if_token1] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2300),
    [sym_preproc_directive] = ACTIONS(2300),
    [anon_sym_LPAREN2] = ACTIONS(2302),
    [anon_sym_BANG] = ACTIONS(2302),
    [anon_sym_TILDE] = ACTIONS(2302),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2302),
    [anon_sym_AMP_AMP] = ACTIONS(2302),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2302),
    [anon_sym___extension__] = ACTIONS(2300),
    [anon_sym_typedef] = ACTIONS(2300),
    [anon_sym___device__] = ACTIONS(2300),
    [anon_sym___host__] = ACTIONS(2300),
    [anon_sym___global__] = ACTIONS(2300),
    [anon_sym___forceinline__] = ACTIONS(2300),
    [anon_sym___noinline__] = ACTIONS(2300),
    [anon_sym_extern] = ACTIONS(2300),
    [anon_sym___attribute__] = ACTIONS(2300),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2302),
    [anon_sym___declspec] = ACTIONS(2300),
    [anon_sym___based] = ACTIONS(2300),
    [anon_sym___cdecl] = ACTIONS(2300),
    [anon_sym___clrcall] = ACTIONS(2300),
    [anon_sym___stdcall] = ACTIONS(2300),
    [anon_sym___fastcall] = ACTIONS(2300),
    [anon_sym___thiscall] = ACTIONS(2300),
    [anon_sym___vectorcall] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_RBRACE] = ACTIONS(2302),
    [anon_sym_signed] = ACTIONS(2300),
    [anon_sym_unsigned] = ACTIONS(2300),
    [anon_sym_long] = ACTIONS(2300),
    [anon_sym_short] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_register] = ACTIONS(2300),
    [anon_sym_inline] = ACTIONS(2300),
    [anon_sym___inline] = ACTIONS(2300),
    [anon_sym___inline__] = ACTIONS(2300),
    [anon_sym___forceinline] = ACTIONS(2300),
    [anon_sym_thread_local] = ACTIONS(2300),
    [anon_sym___thread] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_constexpr] = ACTIONS(2300),
    [anon_sym_volatile] = ACTIONS(2300),
    [anon_sym_restrict] = ACTIONS(2300),
    [anon_sym___restrict__] = ACTIONS(2300),
    [anon_sym__Atomic] = ACTIONS(2300),
    [anon_sym__Noreturn] = ACTIONS(2300),
    [anon_sym_noreturn] = ACTIONS(2300),
    [anon_sym_mutable] = ACTIONS(2300),
    [anon_sym_constinit] = ACTIONS(2300),
    [anon_sym_consteval] = ACTIONS(2300),
    [anon_sym___shared__] = ACTIONS(2300),
    [anon_sym___local__] = ACTIONS(2300),
    [anon_sym___constant__] = ACTIONS(2300),
    [anon_sym___managed__] = ACTIONS(2300),
    [anon_sym___grid_constant__] = ACTIONS(2300),
    [anon_sym_alignas] = ACTIONS(2300),
    [anon_sym__Alignas] = ACTIONS(2300),
    [sym_primitive_type] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_struct] = ACTIONS(2300),
    [anon_sym_union] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_case] = ACTIONS(2300),
    [anon_sym_default] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_goto] = ACTIONS(2300),
    [anon_sym___try] = ACTIONS(2300),
    [anon_sym___leave] = ACTIONS(2300),
    [anon_sym_not] = ACTIONS(2300),
    [anon_sym_compl] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2302),
    [anon_sym_PLUS_PLUS] = ACTIONS(2302),
    [anon_sym_sizeof] = ACTIONS(2300),
    [anon_sym___alignof__] = ACTIONS(2300),
    [anon_sym___alignof] = ACTIONS(2300),
    [anon_sym__alignof] = ACTIONS(2300),
    [anon_sym_alignof] = ACTIONS(2300),
    [anon_sym__Alignof] = ACTIONS(2300),
    [anon_sym_offsetof] = ACTIONS(2300),
    [anon_sym__Generic] = ACTIONS(2300),
    [anon_sym_asm] = ACTIONS(2300),
    [anon_sym___asm__] = ACTIONS(2300),
    [sym_number_literal] = ACTIONS(2302),
    [anon_sym_L_SQUOTE] = ACTIONS(2302),
    [anon_sym_u_SQUOTE] = ACTIONS(2302),
    [anon_sym_U_SQUOTE] = ACTIONS(2302),
    [anon_sym_u8_SQUOTE] = ACTIONS(2302),
    [anon_sym_SQUOTE] = ACTIONS(2302),
    [anon_sym_L_DQUOTE] = ACTIONS(2302),
    [anon_sym_u_DQUOTE] = ACTIONS(2302),
    [anon_sym_U_DQUOTE] = ACTIONS(2302),
    [anon_sym_u8_DQUOTE] = ACTIONS(2302),
    [anon_sym_DQUOTE] = ACTIONS(2302),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [anon_sym_NULL] = ACTIONS(2300),
    [anon_sym_nullptr] = ACTIONS(2300),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2300),
    [anon_sym_decltype] = ACTIONS(2300),
    [sym_virtual] = ACTIONS(2300),
    [anon_sym_explicit] = ACTIONS(2300),
    [anon_sym_typename] = ACTIONS(2300),
    [anon_sym_template] = ACTIONS(2300),
    [anon_sym_operator] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_delete] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_static_assert] = ACTIONS(2300),
    [anon_sym_concept] = ACTIONS(2300),
    [anon_sym_co_return] = ACTIONS(2300),
    [anon_sym_co_yield] = ACTIONS(2300),
    [anon_sym_R_DQUOTE] = ACTIONS(2302),
    [anon_sym_LR_DQUOTE] = ACTIONS(2302),
    [anon_sym_uR_DQUOTE] = ACTIONS(2302),
    [anon_sym_UR_DQUOTE] = ACTIONS(2302),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2302),
    [anon_sym_co_await] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_requires] = ACTIONS(2300),
    [sym_this] = ACTIONS(2300),
    [anon_sym___launch_bounds__] = ACTIONS(2300),
  },
  [484] = {
    [sym_identifier] = ACTIONS(2275),
    [aux_sym_preproc_include_token1] = ACTIONS(2275),
    [aux_sym_preproc_def_token1] = ACTIONS(2275),
    [aux_sym_preproc_if_token1] = ACTIONS(2275),
    [aux_sym_preproc_if_token2] = ACTIONS(2275),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2275),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2275),
    [sym_preproc_directive] = ACTIONS(2275),
    [anon_sym_LPAREN2] = ACTIONS(2277),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [anon_sym_DASH] = ACTIONS(2275),
    [anon_sym_PLUS] = ACTIONS(2275),
    [anon_sym_STAR] = ACTIONS(2277),
    [anon_sym_AMP_AMP] = ACTIONS(2277),
    [anon_sym_AMP] = ACTIONS(2275),
    [anon_sym_SEMI] = ACTIONS(2277),
    [anon_sym___extension__] = ACTIONS(2275),
    [anon_sym_typedef] = ACTIONS(2275),
    [anon_sym___device__] = ACTIONS(2275),
    [anon_sym___host__] = ACTIONS(2275),
    [anon_sym___global__] = ACTIONS(2275),
    [anon_sym___forceinline__] = ACTIONS(2275),
    [anon_sym___noinline__] = ACTIONS(2275),
    [anon_sym_extern] = ACTIONS(2275),
    [anon_sym___attribute__] = ACTIONS(2275),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2277),
    [anon_sym___declspec] = ACTIONS(2275),
    [anon_sym___based] = ACTIONS(2275),
    [anon_sym___cdecl] = ACTIONS(2275),
    [anon_sym___clrcall] = ACTIONS(2275),
    [anon_sym___stdcall] = ACTIONS(2275),
    [anon_sym___fastcall] = ACTIONS(2275),
    [anon_sym___thiscall] = ACTIONS(2275),
    [anon_sym___vectorcall] = ACTIONS(2275),
    [anon_sym_LBRACE] = ACTIONS(2277),
    [anon_sym_signed] = ACTIONS(2275),
    [anon_sym_unsigned] = ACTIONS(2275),
    [anon_sym_long] = ACTIONS(2275),
    [anon_sym_short] = ACTIONS(2275),
    [anon_sym_LBRACK] = ACTIONS(2275),
    [anon_sym_static] = ACTIONS(2275),
    [anon_sym_register] = ACTIONS(2275),
    [anon_sym_inline] = ACTIONS(2275),
    [anon_sym___inline] = ACTIONS(2275),
    [anon_sym___inline__] = ACTIONS(2275),
    [anon_sym___forceinline] = ACTIONS(2275),
    [anon_sym_thread_local] = ACTIONS(2275),
    [anon_sym___thread] = ACTIONS(2275),
    [anon_sym_const] = ACTIONS(2275),
    [anon_sym_constexpr] = ACTIONS(2275),
    [anon_sym_volatile] = ACTIONS(2275),
    [anon_sym_restrict] = ACTIONS(2275),
    [anon_sym___restrict__] = ACTIONS(2275),
    [anon_sym__Atomic] = ACTIONS(2275),
    [anon_sym__Noreturn] = ACTIONS(2275),
    [anon_sym_noreturn] = ACTIONS(2275),
    [anon_sym_mutable] = ACTIONS(2275),
    [anon_sym_constinit] = ACTIONS(2275),
    [anon_sym_consteval] = ACTIONS(2275),
    [anon_sym___shared__] = ACTIONS(2275),
    [anon_sym___local__] = ACTIONS(2275),
    [anon_sym___constant__] = ACTIONS(2275),
    [anon_sym___managed__] = ACTIONS(2275),
    [anon_sym___grid_constant__] = ACTIONS(2275),
    [anon_sym_alignas] = ACTIONS(2275),
    [anon_sym__Alignas] = ACTIONS(2275),
    [sym_primitive_type] = ACTIONS(2275),
    [anon_sym_enum] = ACTIONS(2275),
    [anon_sym_class] = ACTIONS(2275),
    [anon_sym_struct] = ACTIONS(2275),
    [anon_sym_union] = ACTIONS(2275),
    [anon_sym_if] = ACTIONS(2275),
    [anon_sym_switch] = ACTIONS(2275),
    [anon_sym_case] = ACTIONS(2275),
    [anon_sym_default] = ACTIONS(2275),
    [anon_sym_while] = ACTIONS(2275),
    [anon_sym_do] = ACTIONS(2275),
    [anon_sym_for] = ACTIONS(2275),
    [anon_sym_return] = ACTIONS(2275),
    [anon_sym_break] = ACTIONS(2275),
    [anon_sym_continue] = ACTIONS(2275),
    [anon_sym_goto] = ACTIONS(2275),
    [anon_sym___try] = ACTIONS(2275),
    [anon_sym___leave] = ACTIONS(2275),
    [anon_sym_not] = ACTIONS(2275),
    [anon_sym_compl] = ACTIONS(2275),
    [anon_sym_DASH_DASH] = ACTIONS(2277),
    [anon_sym_PLUS_PLUS] = ACTIONS(2277),
    [anon_sym_sizeof] = ACTIONS(2275),
    [anon_sym___alignof__] = ACTIONS(2275),
    [anon_sym___alignof] = ACTIONS(2275),
    [anon_sym__alignof] = ACTIONS(2275),
    [anon_sym_alignof] = ACTIONS(2275),
    [anon_sym__Alignof] = ACTIONS(2275),
    [anon_sym_offsetof] = ACTIONS(2275),
    [anon_sym__Generic] = ACTIONS(2275),
    [anon_sym_asm] = ACTIONS(2275),
    [anon_sym___asm__] = ACTIONS(2275),
    [sym_number_literal] = ACTIONS(2277),
    [anon_sym_L_SQUOTE] = ACTIONS(2277),
    [anon_sym_u_SQUOTE] = ACTIONS(2277),
    [anon_sym_U_SQUOTE] = ACTIONS(2277),
    [anon_sym_u8_SQUOTE] = ACTIONS(2277),
    [anon_sym_SQUOTE] = ACTIONS(2277),
    [anon_sym_L_DQUOTE] = ACTIONS(2277),
    [anon_sym_u_DQUOTE] = ACTIONS(2277),
    [anon_sym_U_DQUOTE] = ACTIONS(2277),
    [anon_sym_u8_DQUOTE] = ACTIONS(2277),
    [anon_sym_DQUOTE] = ACTIONS(2277),
    [sym_true] = ACTIONS(2275),
    [sym_false] = ACTIONS(2275),
    [anon_sym_NULL] = ACTIONS(2275),
    [anon_sym_nullptr] = ACTIONS(2275),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2275),
    [anon_sym_decltype] = ACTIONS(2275),
    [sym_virtual] = ACTIONS(2275),
    [anon_sym_explicit] = ACTIONS(2275),
    [anon_sym_typename] = ACTIONS(2275),
    [anon_sym_template] = ACTIONS(2275),
    [anon_sym_operator] = ACTIONS(2275),
    [anon_sym_try] = ACTIONS(2275),
    [anon_sym_delete] = ACTIONS(2275),
    [anon_sym_throw] = ACTIONS(2275),
    [anon_sym_namespace] = ACTIONS(2275),
    [anon_sym_using] = ACTIONS(2275),
    [anon_sym_static_assert] = ACTIONS(2275),
    [anon_sym_concept] = ACTIONS(2275),
    [anon_sym_co_return] = ACTIONS(2275),
    [anon_sym_co_yield] = ACTIONS(2275),
    [anon_sym_R_DQUOTE] = ACTIONS(2277),
    [anon_sym_LR_DQUOTE] = ACTIONS(2277),
    [anon_sym_uR_DQUOTE] = ACTIONS(2277),
    [anon_sym_UR_DQUOTE] = ACTIONS(2277),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2277),
    [anon_sym_co_await] = ACTIONS(2275),
    [anon_sym_new] = ACTIONS(2275),
    [anon_sym_requires] = ACTIONS(2275),
    [sym_this] = ACTIONS(2275),
    [anon_sym___launch_bounds__] = ACTIONS(2275),
  },
  [485] = {
    [sym_identifier] = ACTIONS(2308),
    [aux_sym_preproc_include_token1] = ACTIONS(2308),
    [aux_sym_preproc_def_token1] = ACTIONS(2308),
    [aux_sym_preproc_if_token1] = ACTIONS(2308),
    [aux_sym_preproc_if_token2] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2308),
    [sym_preproc_directive] = ACTIONS(2308),
    [anon_sym_LPAREN2] = ACTIONS(2310),
    [anon_sym_BANG] = ACTIONS(2310),
    [anon_sym_TILDE] = ACTIONS(2310),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2310),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym___extension__] = ACTIONS(2308),
    [anon_sym_typedef] = ACTIONS(2308),
    [anon_sym___device__] = ACTIONS(2308),
    [anon_sym___host__] = ACTIONS(2308),
    [anon_sym___global__] = ACTIONS(2308),
    [anon_sym___forceinline__] = ACTIONS(2308),
    [anon_sym___noinline__] = ACTIONS(2308),
    [anon_sym_extern] = ACTIONS(2308),
    [anon_sym___attribute__] = ACTIONS(2308),
    [anon_sym_COLON_COLON] = ACTIONS(2310),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2310),
    [anon_sym___declspec] = ACTIONS(2308),
    [anon_sym___based] = ACTIONS(2308),
    [anon_sym___cdecl] = ACTIONS(2308),
    [anon_sym___clrcall] = ACTIONS(2308),
    [anon_sym___stdcall] = ACTIONS(2308),
    [anon_sym___fastcall] = ACTIONS(2308),
    [anon_sym___thiscall] = ACTIONS(2308),
    [anon_sym___vectorcall] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_signed] = ACTIONS(2308),
    [anon_sym_unsigned] = ACTIONS(2308),
    [anon_sym_long] = ACTIONS(2308),
    [anon_sym_short] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_register] = ACTIONS(2308),
    [anon_sym_inline] = ACTIONS(2308),
    [anon_sym___inline] = ACTIONS(2308),
    [anon_sym___inline__] = ACTIONS(2308),
    [anon_sym___forceinline] = ACTIONS(2308),
    [anon_sym_thread_local] = ACTIONS(2308),
    [anon_sym___thread] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_constexpr] = ACTIONS(2308),
    [anon_sym_volatile] = ACTIONS(2308),
    [anon_sym_restrict] = ACTIONS(2308),
    [anon_sym___restrict__] = ACTIONS(2308),
    [anon_sym__Atomic] = ACTIONS(2308),
    [anon_sym__Noreturn] = ACTIONS(2308),
    [anon_sym_noreturn] = ACTIONS(2308),
    [anon_sym_mutable] = ACTIONS(2308),
    [anon_sym_constinit] = ACTIONS(2308),
    [anon_sym_consteval] = ACTIONS(2308),
    [anon_sym___shared__] = ACTIONS(2308),
    [anon_sym___local__] = ACTIONS(2308),
    [anon_sym___constant__] = ACTIONS(2308),
    [anon_sym___managed__] = ACTIONS(2308),
    [anon_sym___grid_constant__] = ACTIONS(2308),
    [anon_sym_alignas] = ACTIONS(2308),
    [anon_sym__Alignas] = ACTIONS(2308),
    [sym_primitive_type] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
    [anon_sym_class] = ACTIONS(2308),
    [anon_sym_struct] = ACTIONS(2308),
    [anon_sym_union] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_switch] = ACTIONS(2308),
    [anon_sym_case] = ACTIONS(2308),
    [anon_sym_default] = ACTIONS(2308),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_do] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_goto] = ACTIONS(2308),
    [anon_sym___try] = ACTIONS(2308),
    [anon_sym___leave] = ACTIONS(2308),
    [anon_sym_not] = ACTIONS(2308),
    [anon_sym_compl] = ACTIONS(2308),
    [anon_sym_DASH_DASH] = ACTIONS(2310),
    [anon_sym_PLUS_PLUS] = ACTIONS(2310),
    [anon_sym_sizeof] = ACTIONS(2308),
    [anon_sym___alignof__] = ACTIONS(2308),
    [anon_sym___alignof] = ACTIONS(2308),
    [anon_sym__alignof] = ACTIONS(2308),
    [anon_sym_alignof] = ACTIONS(2308),
    [anon_sym__Alignof] = ACTIONS(2308),
    [anon_sym_offsetof] = ACTIONS(2308),
    [anon_sym__Generic] = ACTIONS(2308),
    [anon_sym_asm] = ACTIONS(2308),
    [anon_sym___asm__] = ACTIONS(2308),
    [sym_number_literal] = ACTIONS(2310),
    [anon_sym_L_SQUOTE] = ACTIONS(2310),
    [anon_sym_u_SQUOTE] = ACTIONS(2310),
    [anon_sym_U_SQUOTE] = ACTIONS(2310),
    [anon_sym_u8_SQUOTE] = ACTIONS(2310),
    [anon_sym_SQUOTE] = ACTIONS(2310),
    [anon_sym_L_DQUOTE] = ACTIONS(2310),
    [anon_sym_u_DQUOTE] = ACTIONS(2310),
    [anon_sym_U_DQUOTE] = ACTIONS(2310),
    [anon_sym_u8_DQUOTE] = ACTIONS(2310),
    [anon_sym_DQUOTE] = ACTIONS(2310),
    [sym_true] = ACTIONS(2308),
    [sym_false] = ACTIONS(2308),
    [anon_sym_NULL] = ACTIONS(2308),
    [anon_sym_nullptr] = ACTIONS(2308),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2308),
    [anon_sym_decltype] = ACTIONS(2308),
    [sym_virtual] = ACTIONS(2308),
    [anon_sym_explicit] = ACTIONS(2308),
    [anon_sym_typename] = ACTIONS(2308),
    [anon_sym_template] = ACTIONS(2308),
    [anon_sym_operator] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [anon_sym_delete] = ACTIONS(2308),
    [anon_sym_throw] = ACTIONS(2308),
    [anon_sym_namespace] = ACTIONS(2308),
    [anon_sym_using] = ACTIONS(2308),
    [anon_sym_static_assert] = ACTIONS(2308),
    [anon_sym_concept] = ACTIONS(2308),
    [anon_sym_co_return] = ACTIONS(2308),
    [anon_sym_co_yield] = ACTIONS(2308),
    [anon_sym_R_DQUOTE] = ACTIONS(2310),
    [anon_sym_LR_DQUOTE] = ACTIONS(2310),
    [anon_sym_uR_DQUOTE] = ACTIONS(2310),
    [anon_sym_UR_DQUOTE] = ACTIONS(2310),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2310),
    [anon_sym_co_await] = ACTIONS(2308),
    [anon_sym_new] = ACTIONS(2308),
    [anon_sym_requires] = ACTIONS(2308),
    [sym_this] = ACTIONS(2308),
    [anon_sym___launch_bounds__] = ACTIONS(2308),
  },
  [486] = {
    [sym_identifier] = ACTIONS(2284),
    [aux_sym_preproc_include_token1] = ACTIONS(2284),
    [aux_sym_preproc_def_token1] = ACTIONS(2284),
    [aux_sym_preproc_if_token1] = ACTIONS(2284),
    [aux_sym_preproc_if_token2] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2284),
    [sym_preproc_directive] = ACTIONS(2284),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_typedef] = ACTIONS(2284),
    [anon_sym___device__] = ACTIONS(2284),
    [anon_sym___host__] = ACTIONS(2284),
    [anon_sym___global__] = ACTIONS(2284),
    [anon_sym___forceinline__] = ACTIONS(2284),
    [anon_sym___noinline__] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2286),
    [anon_sym___declspec] = ACTIONS(2284),
    [anon_sym___based] = ACTIONS(2284),
    [anon_sym___cdecl] = ACTIONS(2284),
    [anon_sym___clrcall] = ACTIONS(2284),
    [anon_sym___stdcall] = ACTIONS(2284),
    [anon_sym___fastcall] = ACTIONS(2284),
    [anon_sym___thiscall] = ACTIONS(2284),
    [anon_sym___vectorcall] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_signed] = ACTIONS(2284),
    [anon_sym_unsigned] = ACTIONS(2284),
    [anon_sym_long] = ACTIONS(2284),
    [anon_sym_short] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym___inline] = ACTIONS(2284),
    [anon_sym___inline__] = ACTIONS(2284),
    [anon_sym___forceinline] = ACTIONS(2284),
    [anon_sym_thread_local] = ACTIONS(2284),
    [anon_sym___thread] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym___shared__] = ACTIONS(2284),
    [anon_sym___local__] = ACTIONS(2284),
    [anon_sym___constant__] = ACTIONS(2284),
    [anon_sym___managed__] = ACTIONS(2284),
    [anon_sym___grid_constant__] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [sym_primitive_type] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
    [anon_sym_class] = ACTIONS(2284),
    [anon_sym_struct] = ACTIONS(2284),
    [anon_sym_union] = ACTIONS(2284),
    [anon_sym_if] = ACTIONS(2284),
    [anon_sym_switch] = ACTIONS(2284),
    [anon_sym_case] = ACTIONS(2284),
    [anon_sym_default] = ACTIONS(2284),
    [anon_sym_while] = ACTIONS(2284),
    [anon_sym_do] = ACTIONS(2284),
    [anon_sym_for] = ACTIONS(2284),
    [anon_sym_return] = ACTIONS(2284),
    [anon_sym_break] = ACTIONS(2284),
    [anon_sym_continue] = ACTIONS(2284),
    [anon_sym_goto] = ACTIONS(2284),
    [anon_sym___try] = ACTIONS(2284),
    [anon_sym___leave] = ACTIONS(2284),
    [anon_sym_not] = ACTIONS(2284),
    [anon_sym_compl] = ACTIONS(2284),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_sizeof] = ACTIONS(2284),
    [anon_sym___alignof__] = ACTIONS(2284),
    [anon_sym___alignof] = ACTIONS(2284),
    [anon_sym__alignof] = ACTIONS(2284),
    [anon_sym_alignof] = ACTIONS(2284),
    [anon_sym__Alignof] = ACTIONS(2284),
    [anon_sym_offsetof] = ACTIONS(2284),
    [anon_sym__Generic] = ACTIONS(2284),
    [anon_sym_asm] = ACTIONS(2284),
    [anon_sym___asm__] = ACTIONS(2284),
    [sym_number_literal] = ACTIONS(2286),
    [anon_sym_L_SQUOTE] = ACTIONS(2286),
    [anon_sym_u_SQUOTE] = ACTIONS(2286),
    [anon_sym_U_SQUOTE] = ACTIONS(2286),
    [anon_sym_u8_SQUOTE] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [anon_sym_L_DQUOTE] = ACTIONS(2286),
    [anon_sym_u_DQUOTE] = ACTIONS(2286),
    [anon_sym_U_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8_DQUOTE] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [sym_true] = ACTIONS(2284),
    [sym_false] = ACTIONS(2284),
    [anon_sym_NULL] = ACTIONS(2284),
    [anon_sym_nullptr] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [sym_virtual] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_typename] = ACTIONS(2284),
    [anon_sym_template] = ACTIONS(2284),
    [anon_sym_operator] = ACTIONS(2284),
    [anon_sym_try] = ACTIONS(2284),
    [anon_sym_delete] = ACTIONS(2284),
    [anon_sym_throw] = ACTIONS(2284),
    [anon_sym_namespace] = ACTIONS(2284),
    [anon_sym_using] = ACTIONS(2284),
    [anon_sym_static_assert] = ACTIONS(2284),
    [anon_sym_concept] = ACTIONS(2284),
    [anon_sym_co_return] = ACTIONS(2284),
    [anon_sym_co_yield] = ACTIONS(2284),
    [anon_sym_R_DQUOTE] = ACTIONS(2286),
    [anon_sym_LR_DQUOTE] = ACTIONS(2286),
    [anon_sym_uR_DQUOTE] = ACTIONS(2286),
    [anon_sym_UR_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2286),
    [anon_sym_co_await] = ACTIONS(2284),
    [anon_sym_new] = ACTIONS(2284),
    [anon_sym_requires] = ACTIONS(2284),
    [sym_this] = ACTIONS(2284),
    [anon_sym___launch_bounds__] = ACTIONS(2284),
  },
  [487] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_include_token1] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token2] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2269),
    [anon_sym_BANG] = ACTIONS(2269),
    [anon_sym_TILDE] = ACTIONS(2269),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_STAR] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(2269),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym___device__] = ACTIONS(2267),
    [anon_sym___host__] = ACTIONS(2267),
    [anon_sym___global__] = ACTIONS(2267),
    [anon_sym___forceinline__] = ACTIONS(2267),
    [anon_sym___noinline__] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2269),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2269),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym___cdecl] = ACTIONS(2267),
    [anon_sym___clrcall] = ACTIONS(2267),
    [anon_sym___stdcall] = ACTIONS(2267),
    [anon_sym___fastcall] = ACTIONS(2267),
    [anon_sym___thiscall] = ACTIONS(2267),
    [anon_sym___vectorcall] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2269),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym___shared__] = ACTIONS(2267),
    [anon_sym___local__] = ACTIONS(2267),
    [anon_sym___constant__] = ACTIONS(2267),
    [anon_sym___managed__] = ACTIONS(2267),
    [anon_sym___grid_constant__] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym__Alignas] = ACTIONS(2267),
    [sym_primitive_type] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_switch] = ACTIONS(2267),
    [anon_sym_case] = ACTIONS(2267),
    [anon_sym_default] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_for] = ACTIONS(2267),
    [anon_sym_return] = ACTIONS(2267),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_continue] = ACTIONS(2267),
    [anon_sym_goto] = ACTIONS(2267),
    [anon_sym___try] = ACTIONS(2267),
    [anon_sym___leave] = ACTIONS(2267),
    [anon_sym_not] = ACTIONS(2267),
    [anon_sym_compl] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2269),
    [anon_sym_PLUS_PLUS] = ACTIONS(2269),
    [anon_sym_sizeof] = ACTIONS(2267),
    [anon_sym___alignof__] = ACTIONS(2267),
    [anon_sym___alignof] = ACTIONS(2267),
    [anon_sym__alignof] = ACTIONS(2267),
    [anon_sym_alignof] = ACTIONS(2267),
    [anon_sym__Alignof] = ACTIONS(2267),
    [anon_sym_offsetof] = ACTIONS(2267),
    [anon_sym__Generic] = ACTIONS(2267),
    [anon_sym_asm] = ACTIONS(2267),
    [anon_sym___asm__] = ACTIONS(2267),
    [sym_number_literal] = ACTIONS(2269),
    [anon_sym_L_SQUOTE] = ACTIONS(2269),
    [anon_sym_u_SQUOTE] = ACTIONS(2269),
    [anon_sym_U_SQUOTE] = ACTIONS(2269),
    [anon_sym_u8_SQUOTE] = ACTIONS(2269),
    [anon_sym_SQUOTE] = ACTIONS(2269),
    [anon_sym_L_DQUOTE] = ACTIONS(2269),
    [anon_sym_u_DQUOTE] = ACTIONS(2269),
    [anon_sym_U_DQUOTE] = ACTIONS(2269),
    [anon_sym_u8_DQUOTE] = ACTIONS(2269),
    [anon_sym_DQUOTE] = ACTIONS(2269),
    [sym_true] = ACTIONS(2267),
    [sym_false] = ACTIONS(2267),
    [anon_sym_NULL] = ACTIONS(2267),
    [anon_sym_nullptr] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [sym_virtual] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_try] = ACTIONS(2267),
    [anon_sym_delete] = ACTIONS(2267),
    [anon_sym_throw] = ACTIONS(2267),
    [anon_sym_namespace] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym_concept] = ACTIONS(2267),
    [anon_sym_co_return] = ACTIONS(2267),
    [anon_sym_co_yield] = ACTIONS(2267),
    [anon_sym_R_DQUOTE] = ACTIONS(2269),
    [anon_sym_LR_DQUOTE] = ACTIONS(2269),
    [anon_sym_uR_DQUOTE] = ACTIONS(2269),
    [anon_sym_UR_DQUOTE] = ACTIONS(2269),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2269),
    [anon_sym_co_await] = ACTIONS(2267),
    [anon_sym_new] = ACTIONS(2267),
    [anon_sym_requires] = ACTIONS(2267),
    [sym_this] = ACTIONS(2267),
    [anon_sym___launch_bounds__] = ACTIONS(2267),
  },
  [488] = {
    [sym_identifier] = ACTIONS(2288),
    [aux_sym_preproc_include_token1] = ACTIONS(2288),
    [aux_sym_preproc_def_token1] = ACTIONS(2288),
    [aux_sym_preproc_if_token1] = ACTIONS(2288),
    [aux_sym_preproc_if_token2] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2288),
    [sym_preproc_directive] = ACTIONS(2288),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym_typedef] = ACTIONS(2288),
    [anon_sym___device__] = ACTIONS(2288),
    [anon_sym___host__] = ACTIONS(2288),
    [anon_sym___global__] = ACTIONS(2288),
    [anon_sym___forceinline__] = ACTIONS(2288),
    [anon_sym___noinline__] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2290),
    [anon_sym___declspec] = ACTIONS(2288),
    [anon_sym___based] = ACTIONS(2288),
    [anon_sym___cdecl] = ACTIONS(2288),
    [anon_sym___clrcall] = ACTIONS(2288),
    [anon_sym___stdcall] = ACTIONS(2288),
    [anon_sym___fastcall] = ACTIONS(2288),
    [anon_sym___thiscall] = ACTIONS(2288),
    [anon_sym___vectorcall] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_signed] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym___inline] = ACTIONS(2288),
    [anon_sym___inline__] = ACTIONS(2288),
    [anon_sym___forceinline] = ACTIONS(2288),
    [anon_sym_thread_local] = ACTIONS(2288),
    [anon_sym___thread] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym___shared__] = ACTIONS(2288),
    [anon_sym___local__] = ACTIONS(2288),
    [anon_sym___constant__] = ACTIONS(2288),
    [anon_sym___managed__] = ACTIONS(2288),
    [anon_sym___grid_constant__] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_goto] = ACTIONS(2288),
    [anon_sym___try] = ACTIONS(2288),
    [anon_sym___leave] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2288),
    [anon_sym_compl] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_sizeof] = ACTIONS(2288),
    [anon_sym___alignof__] = ACTIONS(2288),
    [anon_sym___alignof] = ACTIONS(2288),
    [anon_sym__alignof] = ACTIONS(2288),
    [anon_sym_alignof] = ACTIONS(2288),
    [anon_sym__Alignof] = ACTIONS(2288),
    [anon_sym_offsetof] = ACTIONS(2288),
    [anon_sym__Generic] = ACTIONS(2288),
    [anon_sym_asm] = ACTIONS(2288),
    [anon_sym___asm__] = ACTIONS(2288),
    [sym_number_literal] = ACTIONS(2290),
    [anon_sym_L_SQUOTE] = ACTIONS(2290),
    [anon_sym_u_SQUOTE] = ACTIONS(2290),
    [anon_sym_U_SQUOTE] = ACTIONS(2290),
    [anon_sym_u8_SQUOTE] = ACTIONS(2290),
    [anon_sym_SQUOTE] = ACTIONS(2290),
    [anon_sym_L_DQUOTE] = ACTIONS(2290),
    [anon_sym_u_DQUOTE] = ACTIONS(2290),
    [anon_sym_U_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8_DQUOTE] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [anon_sym_NULL] = ACTIONS(2288),
    [anon_sym_nullptr] = ACTIONS(2288),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [sym_virtual] = ACTIONS(2288),
    [anon_sym_explicit] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_operator] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_static_assert] = ACTIONS(2288),
    [anon_sym_concept] = ACTIONS(2288),
    [anon_sym_co_return] = ACTIONS(2288),
    [anon_sym_co_yield] = ACTIONS(2288),
    [anon_sym_R_DQUOTE] = ACTIONS(2290),
    [anon_sym_LR_DQUOTE] = ACTIONS(2290),
    [anon_sym_uR_DQUOTE] = ACTIONS(2290),
    [anon_sym_UR_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2290),
    [anon_sym_co_await] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_requires] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [anon_sym___launch_bounds__] = ACTIONS(2288),
  },
  [489] = {
    [sym_identifier] = ACTIONS(2292),
    [aux_sym_preproc_include_token1] = ACTIONS(2292),
    [aux_sym_preproc_def_token1] = ACTIONS(2292),
    [aux_sym_preproc_if_token1] = ACTIONS(2292),
    [aux_sym_preproc_if_token2] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2292),
    [sym_preproc_directive] = ACTIONS(2292),
    [anon_sym_LPAREN2] = ACTIONS(2294),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym___extension__] = ACTIONS(2292),
    [anon_sym_typedef] = ACTIONS(2292),
    [anon_sym___device__] = ACTIONS(2292),
    [anon_sym___host__] = ACTIONS(2292),
    [anon_sym___global__] = ACTIONS(2292),
    [anon_sym___forceinline__] = ACTIONS(2292),
    [anon_sym___noinline__] = ACTIONS(2292),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym___attribute__] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2294),
    [anon_sym___declspec] = ACTIONS(2292),
    [anon_sym___based] = ACTIONS(2292),
    [anon_sym___cdecl] = ACTIONS(2292),
    [anon_sym___clrcall] = ACTIONS(2292),
    [anon_sym___stdcall] = ACTIONS(2292),
    [anon_sym___fastcall] = ACTIONS(2292),
    [anon_sym___thiscall] = ACTIONS(2292),
    [anon_sym___vectorcall] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_signed] = ACTIONS(2292),
    [anon_sym_unsigned] = ACTIONS(2292),
    [anon_sym_long] = ACTIONS(2292),
    [anon_sym_short] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_register] = ACTIONS(2292),
    [anon_sym_inline] = ACTIONS(2292),
    [anon_sym___inline] = ACTIONS(2292),
    [anon_sym___inline__] = ACTIONS(2292),
    [anon_sym___forceinline] = ACTIONS(2292),
    [anon_sym_thread_local] = ACTIONS(2292),
    [anon_sym___thread] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym___restrict__] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym__Noreturn] = ACTIONS(2292),
    [anon_sym_noreturn] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_constinit] = ACTIONS(2292),
    [anon_sym_consteval] = ACTIONS(2292),
    [anon_sym___shared__] = ACTIONS(2292),
    [anon_sym___local__] = ACTIONS(2292),
    [anon_sym___constant__] = ACTIONS(2292),
    [anon_sym___managed__] = ACTIONS(2292),
    [anon_sym___grid_constant__] = ACTIONS(2292),
    [anon_sym_alignas] = ACTIONS(2292),
    [anon_sym__Alignas] = ACTIONS(2292),
    [sym_primitive_type] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_struct] = ACTIONS(2292),
    [anon_sym_union] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_case] = ACTIONS(2292),
    [anon_sym_default] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_goto] = ACTIONS(2292),
    [anon_sym___try] = ACTIONS(2292),
    [anon_sym___leave] = ACTIONS(2292),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_compl] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_sizeof] = ACTIONS(2292),
    [anon_sym___alignof__] = ACTIONS(2292),
    [anon_sym___alignof] = ACTIONS(2292),
    [anon_sym__alignof] = ACTIONS(2292),
    [anon_sym_alignof] = ACTIONS(2292),
    [anon_sym__Alignof] = ACTIONS(2292),
    [anon_sym_offsetof] = ACTIONS(2292),
    [anon_sym__Generic] = ACTIONS(2292),
    [anon_sym_asm] = ACTIONS(2292),
    [anon_sym___asm__] = ACTIONS(2292),
    [sym_number_literal] = ACTIONS(2294),
    [anon_sym_L_SQUOTE] = ACTIONS(2294),
    [anon_sym_u_SQUOTE] = ACTIONS(2294),
    [anon_sym_U_SQUOTE] = ACTIONS(2294),
    [anon_sym_u8_SQUOTE] = ACTIONS(2294),
    [anon_sym_SQUOTE] = ACTIONS(2294),
    [anon_sym_L_DQUOTE] = ACTIONS(2294),
    [anon_sym_u_DQUOTE] = ACTIONS(2294),
    [anon_sym_U_DQUOTE] = ACTIONS(2294),
    [anon_sym_u8_DQUOTE] = ACTIONS(2294),
    [anon_sym_DQUOTE] = ACTIONS(2294),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [anon_sym_NULL] = ACTIONS(2292),
    [anon_sym_nullptr] = ACTIONS(2292),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2292),
    [anon_sym_decltype] = ACTIONS(2292),
    [sym_virtual] = ACTIONS(2292),
    [anon_sym_explicit] = ACTIONS(2292),
    [anon_sym_typename] = ACTIONS(2292),
    [anon_sym_template] = ACTIONS(2292),
    [anon_sym_operator] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_delete] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_namespace] = ACTIONS(2292),
    [anon_sym_using] = ACTIONS(2292),
    [anon_sym_static_assert] = ACTIONS(2292),
    [anon_sym_concept] = ACTIONS(2292),
    [anon_sym_co_return] = ACTIONS(2292),
    [anon_sym_co_yield] = ACTIONS(2292),
    [anon_sym_R_DQUOTE] = ACTIONS(2294),
    [anon_sym_LR_DQUOTE] = ACTIONS(2294),
    [anon_sym_uR_DQUOTE] = ACTIONS(2294),
    [anon_sym_UR_DQUOTE] = ACTIONS(2294),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2294),
    [anon_sym_co_await] = ACTIONS(2292),
    [anon_sym_new] = ACTIONS(2292),
    [anon_sym_requires] = ACTIONS(2292),
    [sym_this] = ACTIONS(2292),
    [anon_sym___launch_bounds__] = ACTIONS(2292),
  },
  [490] = {
    [sym_identifier] = ACTIONS(2304),
    [aux_sym_preproc_include_token1] = ACTIONS(2304),
    [aux_sym_preproc_def_token1] = ACTIONS(2304),
    [aux_sym_preproc_if_token1] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2304),
    [sym_preproc_directive] = ACTIONS(2304),
    [anon_sym_LPAREN2] = ACTIONS(2306),
    [anon_sym_BANG] = ACTIONS(2306),
    [anon_sym_TILDE] = ACTIONS(2306),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2306),
    [anon_sym___extension__] = ACTIONS(2304),
    [anon_sym_typedef] = ACTIONS(2304),
    [anon_sym___device__] = ACTIONS(2304),
    [anon_sym___host__] = ACTIONS(2304),
    [anon_sym___global__] = ACTIONS(2304),
    [anon_sym___forceinline__] = ACTIONS(2304),
    [anon_sym___noinline__] = ACTIONS(2304),
    [anon_sym_extern] = ACTIONS(2304),
    [anon_sym___attribute__] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2306),
    [anon_sym___declspec] = ACTIONS(2304),
    [anon_sym___based] = ACTIONS(2304),
    [anon_sym___cdecl] = ACTIONS(2304),
    [anon_sym___clrcall] = ACTIONS(2304),
    [anon_sym___stdcall] = ACTIONS(2304),
    [anon_sym___fastcall] = ACTIONS(2304),
    [anon_sym___thiscall] = ACTIONS(2304),
    [anon_sym___vectorcall] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [anon_sym_signed] = ACTIONS(2304),
    [anon_sym_unsigned] = ACTIONS(2304),
    [anon_sym_long] = ACTIONS(2304),
    [anon_sym_short] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_register] = ACTIONS(2304),
    [anon_sym_inline] = ACTIONS(2304),
    [anon_sym___inline] = ACTIONS(2304),
    [anon_sym___inline__] = ACTIONS(2304),
    [anon_sym___forceinline] = ACTIONS(2304),
    [anon_sym_thread_local] = ACTIONS(2304),
    [anon_sym___thread] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_constexpr] = ACTIONS(2304),
    [anon_sym_volatile] = ACTIONS(2304),
    [anon_sym_restrict] = ACTIONS(2304),
    [anon_sym___restrict__] = ACTIONS(2304),
    [anon_sym__Atomic] = ACTIONS(2304),
    [anon_sym__Noreturn] = ACTIONS(2304),
    [anon_sym_noreturn] = ACTIONS(2304),
    [anon_sym_mutable] = ACTIONS(2304),
    [anon_sym_constinit] = ACTIONS(2304),
    [anon_sym_consteval] = ACTIONS(2304),
    [anon_sym___shared__] = ACTIONS(2304),
    [anon_sym___local__] = ACTIONS(2304),
    [anon_sym___constant__] = ACTIONS(2304),
    [anon_sym___managed__] = ACTIONS(2304),
    [anon_sym___grid_constant__] = ACTIONS(2304),
    [anon_sym_alignas] = ACTIONS(2304),
    [anon_sym__Alignas] = ACTIONS(2304),
    [sym_primitive_type] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_struct] = ACTIONS(2304),
    [anon_sym_union] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_case] = ACTIONS(2304),
    [anon_sym_default] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_goto] = ACTIONS(2304),
    [anon_sym___try] = ACTIONS(2304),
    [anon_sym___leave] = ACTIONS(2304),
    [anon_sym_not] = ACTIONS(2304),
    [anon_sym_compl] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_sizeof] = ACTIONS(2304),
    [anon_sym___alignof__] = ACTIONS(2304),
    [anon_sym___alignof] = ACTIONS(2304),
    [anon_sym__alignof] = ACTIONS(2304),
    [anon_sym_alignof] = ACTIONS(2304),
    [anon_sym__Alignof] = ACTIONS(2304),
    [anon_sym_offsetof] = ACTIONS(2304),
    [anon_sym__Generic] = ACTIONS(2304),
    [anon_sym_asm] = ACTIONS(2304),
    [anon_sym___asm__] = ACTIONS(2304),
    [sym_number_literal] = ACTIONS(2306),
    [anon_sym_L_SQUOTE] = ACTIONS(2306),
    [anon_sym_u_SQUOTE] = ACTIONS(2306),
    [anon_sym_U_SQUOTE] = ACTIONS(2306),
    [anon_sym_u8_SQUOTE] = ACTIONS(2306),
    [anon_sym_SQUOTE] = ACTIONS(2306),
    [anon_sym_L_DQUOTE] = ACTIONS(2306),
    [anon_sym_u_DQUOTE] = ACTIONS(2306),
    [anon_sym_U_DQUOTE] = ACTIONS(2306),
    [anon_sym_u8_DQUOTE] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [anon_sym_NULL] = ACTIONS(2304),
    [anon_sym_nullptr] = ACTIONS(2304),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2304),
    [anon_sym_decltype] = ACTIONS(2304),
    [sym_virtual] = ACTIONS(2304),
    [anon_sym_explicit] = ACTIONS(2304),
    [anon_sym_typename] = ACTIONS(2304),
    [anon_sym_template] = ACTIONS(2304),
    [anon_sym_operator] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_delete] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_namespace] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_static_assert] = ACTIONS(2304),
    [anon_sym_concept] = ACTIONS(2304),
    [anon_sym_co_return] = ACTIONS(2304),
    [anon_sym_co_yield] = ACTIONS(2304),
    [anon_sym_R_DQUOTE] = ACTIONS(2306),
    [anon_sym_LR_DQUOTE] = ACTIONS(2306),
    [anon_sym_uR_DQUOTE] = ACTIONS(2306),
    [anon_sym_UR_DQUOTE] = ACTIONS(2306),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2306),
    [anon_sym_co_await] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_requires] = ACTIONS(2304),
    [sym_this] = ACTIONS(2304),
    [anon_sym___launch_bounds__] = ACTIONS(2304),
  },
  [491] = {
    [sym_identifier] = ACTIONS(2296),
    [aux_sym_preproc_include_token1] = ACTIONS(2296),
    [aux_sym_preproc_def_token1] = ACTIONS(2296),
    [aux_sym_preproc_if_token1] = ACTIONS(2296),
    [aux_sym_preproc_if_token2] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2296),
    [sym_preproc_directive] = ACTIONS(2296),
    [anon_sym_LPAREN2] = ACTIONS(2298),
    [anon_sym_BANG] = ACTIONS(2298),
    [anon_sym_TILDE] = ACTIONS(2298),
    [anon_sym_DASH] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2296),
    [anon_sym_STAR] = ACTIONS(2298),
    [anon_sym_AMP_AMP] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(2298),
    [anon_sym___extension__] = ACTIONS(2296),
    [anon_sym_typedef] = ACTIONS(2296),
    [anon_sym___device__] = ACTIONS(2296),
    [anon_sym___host__] = ACTIONS(2296),
    [anon_sym___global__] = ACTIONS(2296),
    [anon_sym___forceinline__] = ACTIONS(2296),
    [anon_sym___noinline__] = ACTIONS(2296),
    [anon_sym_extern] = ACTIONS(2296),
    [anon_sym___attribute__] = ACTIONS(2296),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2298),
    [anon_sym___declspec] = ACTIONS(2296),
    [anon_sym___based] = ACTIONS(2296),
    [anon_sym___cdecl] = ACTIONS(2296),
    [anon_sym___clrcall] = ACTIONS(2296),
    [anon_sym___stdcall] = ACTIONS(2296),
    [anon_sym___fastcall] = ACTIONS(2296),
    [anon_sym___thiscall] = ACTIONS(2296),
    [anon_sym___vectorcall] = ACTIONS(2296),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_signed] = ACTIONS(2296),
    [anon_sym_unsigned] = ACTIONS(2296),
    [anon_sym_long] = ACTIONS(2296),
    [anon_sym_short] = ACTIONS(2296),
    [anon_sym_LBRACK] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_register] = ACTIONS(2296),
    [anon_sym_inline] = ACTIONS(2296),
    [anon_sym___inline] = ACTIONS(2296),
    [anon_sym___inline__] = ACTIONS(2296),
    [anon_sym___forceinline] = ACTIONS(2296),
    [anon_sym_thread_local] = ACTIONS(2296),
    [anon_sym___thread] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_constexpr] = ACTIONS(2296),
    [anon_sym_volatile] = ACTIONS(2296),
    [anon_sym_restrict] = ACTIONS(2296),
    [anon_sym___restrict__] = ACTIONS(2296),
    [anon_sym__Atomic] = ACTIONS(2296),
    [anon_sym__Noreturn] = ACTIONS(2296),
    [anon_sym_noreturn] = ACTIONS(2296),
    [anon_sym_mutable] = ACTIONS(2296),
    [anon_sym_constinit] = ACTIONS(2296),
    [anon_sym_consteval] = ACTIONS(2296),
    [anon_sym___shared__] = ACTIONS(2296),
    [anon_sym___local__] = ACTIONS(2296),
    [anon_sym___constant__] = ACTIONS(2296),
    [anon_sym___managed__] = ACTIONS(2296),
    [anon_sym___grid_constant__] = ACTIONS(2296),
    [anon_sym_alignas] = ACTIONS(2296),
    [anon_sym__Alignas] = ACTIONS(2296),
    [sym_primitive_type] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2296),
    [anon_sym_class] = ACTIONS(2296),
    [anon_sym_struct] = ACTIONS(2296),
    [anon_sym_union] = ACTIONS(2296),
    [anon_sym_if] = ACTIONS(2296),
    [anon_sym_switch] = ACTIONS(2296),
    [anon_sym_case] = ACTIONS(2296),
    [anon_sym_default] = ACTIONS(2296),
    [anon_sym_while] = ACTIONS(2296),
    [anon_sym_do] = ACTIONS(2296),
    [anon_sym_for] = ACTIONS(2296),
    [anon_sym_return] = ACTIONS(2296),
    [anon_sym_break] = ACTIONS(2296),
    [anon_sym_continue] = ACTIONS(2296),
    [anon_sym_goto] = ACTIONS(2296),
    [anon_sym___try] = ACTIONS(2296),
    [anon_sym___leave] = ACTIONS(2296),
    [anon_sym_not] = ACTIONS(2296),
    [anon_sym_compl] = ACTIONS(2296),
    [anon_sym_DASH_DASH] = ACTIONS(2298),
    [anon_sym_PLUS_PLUS] = ACTIONS(2298),
    [anon_sym_sizeof] = ACTIONS(2296),
    [anon_sym___alignof__] = ACTIONS(2296),
    [anon_sym___alignof] = ACTIONS(2296),
    [anon_sym__alignof] = ACTIONS(2296),
    [anon_sym_alignof] = ACTIONS(2296),
    [anon_sym__Alignof] = ACTIONS(2296),
    [anon_sym_offsetof] = ACTIONS(2296),
    [anon_sym__Generic] = ACTIONS(2296),
    [anon_sym_asm] = ACTIONS(2296),
    [anon_sym___asm__] = ACTIONS(2296),
    [sym_number_literal] = ACTIONS(2298),
    [anon_sym_L_SQUOTE] = ACTIONS(2298),
    [anon_sym_u_SQUOTE] = ACTIONS(2298),
    [anon_sym_U_SQUOTE] = ACTIONS(2298),
    [anon_sym_u8_SQUOTE] = ACTIONS(2298),
    [anon_sym_SQUOTE] = ACTIONS(2298),
    [anon_sym_L_DQUOTE] = ACTIONS(2298),
    [anon_sym_u_DQUOTE] = ACTIONS(2298),
    [anon_sym_U_DQUOTE] = ACTIONS(2298),
    [anon_sym_u8_DQUOTE] = ACTIONS(2298),
    [anon_sym_DQUOTE] = ACTIONS(2298),
    [sym_true] = ACTIONS(2296),
    [sym_false] = ACTIONS(2296),
    [anon_sym_NULL] = ACTIONS(2296),
    [anon_sym_nullptr] = ACTIONS(2296),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2296),
    [anon_sym_decltype] = ACTIONS(2296),
    [sym_virtual] = ACTIONS(2296),
    [anon_sym_explicit] = ACTIONS(2296),
    [anon_sym_typename] = ACTIONS(2296),
    [anon_sym_template] = ACTIONS(2296),
    [anon_sym_operator] = ACTIONS(2296),
    [anon_sym_try] = ACTIONS(2296),
    [anon_sym_delete] = ACTIONS(2296),
    [anon_sym_throw] = ACTIONS(2296),
    [anon_sym_namespace] = ACTIONS(2296),
    [anon_sym_using] = ACTIONS(2296),
    [anon_sym_static_assert] = ACTIONS(2296),
    [anon_sym_concept] = ACTIONS(2296),
    [anon_sym_co_return] = ACTIONS(2296),
    [anon_sym_co_yield] = ACTIONS(2296),
    [anon_sym_R_DQUOTE] = ACTIONS(2298),
    [anon_sym_LR_DQUOTE] = ACTIONS(2298),
    [anon_sym_uR_DQUOTE] = ACTIONS(2298),
    [anon_sym_UR_DQUOTE] = ACTIONS(2298),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2298),
    [anon_sym_co_await] = ACTIONS(2296),
    [anon_sym_new] = ACTIONS(2296),
    [anon_sym_requires] = ACTIONS(2296),
    [sym_this] = ACTIONS(2296),
    [anon_sym___launch_bounds__] = ACTIONS(2296),
  },
  [492] = {
    [sym_identifier] = ACTIONS(2300),
    [aux_sym_preproc_include_token1] = ACTIONS(2300),
    [aux_sym_preproc_def_token1] = ACTIONS(2300),
    [aux_sym_preproc_if_token1] = ACTIONS(2300),
    [aux_sym_preproc_if_token2] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2300),
    [sym_preproc_directive] = ACTIONS(2300),
    [anon_sym_LPAREN2] = ACTIONS(2302),
    [anon_sym_BANG] = ACTIONS(2302),
    [anon_sym_TILDE] = ACTIONS(2302),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2302),
    [anon_sym_AMP_AMP] = ACTIONS(2302),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2302),
    [anon_sym___extension__] = ACTIONS(2300),
    [anon_sym_typedef] = ACTIONS(2300),
    [anon_sym___device__] = ACTIONS(2300),
    [anon_sym___host__] = ACTIONS(2300),
    [anon_sym___global__] = ACTIONS(2300),
    [anon_sym___forceinline__] = ACTIONS(2300),
    [anon_sym___noinline__] = ACTIONS(2300),
    [anon_sym_extern] = ACTIONS(2300),
    [anon_sym___attribute__] = ACTIONS(2300),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2302),
    [anon_sym___declspec] = ACTIONS(2300),
    [anon_sym___based] = ACTIONS(2300),
    [anon_sym___cdecl] = ACTIONS(2300),
    [anon_sym___clrcall] = ACTIONS(2300),
    [anon_sym___stdcall] = ACTIONS(2300),
    [anon_sym___fastcall] = ACTIONS(2300),
    [anon_sym___thiscall] = ACTIONS(2300),
    [anon_sym___vectorcall] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_signed] = ACTIONS(2300),
    [anon_sym_unsigned] = ACTIONS(2300),
    [anon_sym_long] = ACTIONS(2300),
    [anon_sym_short] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_register] = ACTIONS(2300),
    [anon_sym_inline] = ACTIONS(2300),
    [anon_sym___inline] = ACTIONS(2300),
    [anon_sym___inline__] = ACTIONS(2300),
    [anon_sym___forceinline] = ACTIONS(2300),
    [anon_sym_thread_local] = ACTIONS(2300),
    [anon_sym___thread] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_constexpr] = ACTIONS(2300),
    [anon_sym_volatile] = ACTIONS(2300),
    [anon_sym_restrict] = ACTIONS(2300),
    [anon_sym___restrict__] = ACTIONS(2300),
    [anon_sym__Atomic] = ACTIONS(2300),
    [anon_sym__Noreturn] = ACTIONS(2300),
    [anon_sym_noreturn] = ACTIONS(2300),
    [anon_sym_mutable] = ACTIONS(2300),
    [anon_sym_constinit] = ACTIONS(2300),
    [anon_sym_consteval] = ACTIONS(2300),
    [anon_sym___shared__] = ACTIONS(2300),
    [anon_sym___local__] = ACTIONS(2300),
    [anon_sym___constant__] = ACTIONS(2300),
    [anon_sym___managed__] = ACTIONS(2300),
    [anon_sym___grid_constant__] = ACTIONS(2300),
    [anon_sym_alignas] = ACTIONS(2300),
    [anon_sym__Alignas] = ACTIONS(2300),
    [sym_primitive_type] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_struct] = ACTIONS(2300),
    [anon_sym_union] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_case] = ACTIONS(2300),
    [anon_sym_default] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_goto] = ACTIONS(2300),
    [anon_sym___try] = ACTIONS(2300),
    [anon_sym___leave] = ACTIONS(2300),
    [anon_sym_not] = ACTIONS(2300),
    [anon_sym_compl] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2302),
    [anon_sym_PLUS_PLUS] = ACTIONS(2302),
    [anon_sym_sizeof] = ACTIONS(2300),
    [anon_sym___alignof__] = ACTIONS(2300),
    [anon_sym___alignof] = ACTIONS(2300),
    [anon_sym__alignof] = ACTIONS(2300),
    [anon_sym_alignof] = ACTIONS(2300),
    [anon_sym__Alignof] = ACTIONS(2300),
    [anon_sym_offsetof] = ACTIONS(2300),
    [anon_sym__Generic] = ACTIONS(2300),
    [anon_sym_asm] = ACTIONS(2300),
    [anon_sym___asm__] = ACTIONS(2300),
    [sym_number_literal] = ACTIONS(2302),
    [anon_sym_L_SQUOTE] = ACTIONS(2302),
    [anon_sym_u_SQUOTE] = ACTIONS(2302),
    [anon_sym_U_SQUOTE] = ACTIONS(2302),
    [anon_sym_u8_SQUOTE] = ACTIONS(2302),
    [anon_sym_SQUOTE] = ACTIONS(2302),
    [anon_sym_L_DQUOTE] = ACTIONS(2302),
    [anon_sym_u_DQUOTE] = ACTIONS(2302),
    [anon_sym_U_DQUOTE] = ACTIONS(2302),
    [anon_sym_u8_DQUOTE] = ACTIONS(2302),
    [anon_sym_DQUOTE] = ACTIONS(2302),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [anon_sym_NULL] = ACTIONS(2300),
    [anon_sym_nullptr] = ACTIONS(2300),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2300),
    [anon_sym_decltype] = ACTIONS(2300),
    [sym_virtual] = ACTIONS(2300),
    [anon_sym_explicit] = ACTIONS(2300),
    [anon_sym_typename] = ACTIONS(2300),
    [anon_sym_template] = ACTIONS(2300),
    [anon_sym_operator] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_delete] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_static_assert] = ACTIONS(2300),
    [anon_sym_concept] = ACTIONS(2300),
    [anon_sym_co_return] = ACTIONS(2300),
    [anon_sym_co_yield] = ACTIONS(2300),
    [anon_sym_R_DQUOTE] = ACTIONS(2302),
    [anon_sym_LR_DQUOTE] = ACTIONS(2302),
    [anon_sym_uR_DQUOTE] = ACTIONS(2302),
    [anon_sym_UR_DQUOTE] = ACTIONS(2302),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2302),
    [anon_sym_co_await] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_requires] = ACTIONS(2300),
    [sym_this] = ACTIONS(2300),
    [anon_sym___launch_bounds__] = ACTIONS(2300),
  },
  [493] = {
    [sym_identifier] = ACTIONS(2304),
    [aux_sym_preproc_include_token1] = ACTIONS(2304),
    [aux_sym_preproc_def_token1] = ACTIONS(2304),
    [aux_sym_preproc_if_token1] = ACTIONS(2304),
    [aux_sym_preproc_if_token2] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2304),
    [sym_preproc_directive] = ACTIONS(2304),
    [anon_sym_LPAREN2] = ACTIONS(2306),
    [anon_sym_BANG] = ACTIONS(2306),
    [anon_sym_TILDE] = ACTIONS(2306),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2306),
    [anon_sym___extension__] = ACTIONS(2304),
    [anon_sym_typedef] = ACTIONS(2304),
    [anon_sym___device__] = ACTIONS(2304),
    [anon_sym___host__] = ACTIONS(2304),
    [anon_sym___global__] = ACTIONS(2304),
    [anon_sym___forceinline__] = ACTIONS(2304),
    [anon_sym___noinline__] = ACTIONS(2304),
    [anon_sym_extern] = ACTIONS(2304),
    [anon_sym___attribute__] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2306),
    [anon_sym___declspec] = ACTIONS(2304),
    [anon_sym___based] = ACTIONS(2304),
    [anon_sym___cdecl] = ACTIONS(2304),
    [anon_sym___clrcall] = ACTIONS(2304),
    [anon_sym___stdcall] = ACTIONS(2304),
    [anon_sym___fastcall] = ACTIONS(2304),
    [anon_sym___thiscall] = ACTIONS(2304),
    [anon_sym___vectorcall] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_signed] = ACTIONS(2304),
    [anon_sym_unsigned] = ACTIONS(2304),
    [anon_sym_long] = ACTIONS(2304),
    [anon_sym_short] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_register] = ACTIONS(2304),
    [anon_sym_inline] = ACTIONS(2304),
    [anon_sym___inline] = ACTIONS(2304),
    [anon_sym___inline__] = ACTIONS(2304),
    [anon_sym___forceinline] = ACTIONS(2304),
    [anon_sym_thread_local] = ACTIONS(2304),
    [anon_sym___thread] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_constexpr] = ACTIONS(2304),
    [anon_sym_volatile] = ACTIONS(2304),
    [anon_sym_restrict] = ACTIONS(2304),
    [anon_sym___restrict__] = ACTIONS(2304),
    [anon_sym__Atomic] = ACTIONS(2304),
    [anon_sym__Noreturn] = ACTIONS(2304),
    [anon_sym_noreturn] = ACTIONS(2304),
    [anon_sym_mutable] = ACTIONS(2304),
    [anon_sym_constinit] = ACTIONS(2304),
    [anon_sym_consteval] = ACTIONS(2304),
    [anon_sym___shared__] = ACTIONS(2304),
    [anon_sym___local__] = ACTIONS(2304),
    [anon_sym___constant__] = ACTIONS(2304),
    [anon_sym___managed__] = ACTIONS(2304),
    [anon_sym___grid_constant__] = ACTIONS(2304),
    [anon_sym_alignas] = ACTIONS(2304),
    [anon_sym__Alignas] = ACTIONS(2304),
    [sym_primitive_type] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_struct] = ACTIONS(2304),
    [anon_sym_union] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_case] = ACTIONS(2304),
    [anon_sym_default] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_goto] = ACTIONS(2304),
    [anon_sym___try] = ACTIONS(2304),
    [anon_sym___leave] = ACTIONS(2304),
    [anon_sym_not] = ACTIONS(2304),
    [anon_sym_compl] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_sizeof] = ACTIONS(2304),
    [anon_sym___alignof__] = ACTIONS(2304),
    [anon_sym___alignof] = ACTIONS(2304),
    [anon_sym__alignof] = ACTIONS(2304),
    [anon_sym_alignof] = ACTIONS(2304),
    [anon_sym__Alignof] = ACTIONS(2304),
    [anon_sym_offsetof] = ACTIONS(2304),
    [anon_sym__Generic] = ACTIONS(2304),
    [anon_sym_asm] = ACTIONS(2304),
    [anon_sym___asm__] = ACTIONS(2304),
    [sym_number_literal] = ACTIONS(2306),
    [anon_sym_L_SQUOTE] = ACTIONS(2306),
    [anon_sym_u_SQUOTE] = ACTIONS(2306),
    [anon_sym_U_SQUOTE] = ACTIONS(2306),
    [anon_sym_u8_SQUOTE] = ACTIONS(2306),
    [anon_sym_SQUOTE] = ACTIONS(2306),
    [anon_sym_L_DQUOTE] = ACTIONS(2306),
    [anon_sym_u_DQUOTE] = ACTIONS(2306),
    [anon_sym_U_DQUOTE] = ACTIONS(2306),
    [anon_sym_u8_DQUOTE] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [anon_sym_NULL] = ACTIONS(2304),
    [anon_sym_nullptr] = ACTIONS(2304),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2304),
    [anon_sym_decltype] = ACTIONS(2304),
    [sym_virtual] = ACTIONS(2304),
    [anon_sym_explicit] = ACTIONS(2304),
    [anon_sym_typename] = ACTIONS(2304),
    [anon_sym_template] = ACTIONS(2304),
    [anon_sym_operator] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_delete] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_namespace] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_static_assert] = ACTIONS(2304),
    [anon_sym_concept] = ACTIONS(2304),
    [anon_sym_co_return] = ACTIONS(2304),
    [anon_sym_co_yield] = ACTIONS(2304),
    [anon_sym_R_DQUOTE] = ACTIONS(2306),
    [anon_sym_LR_DQUOTE] = ACTIONS(2306),
    [anon_sym_uR_DQUOTE] = ACTIONS(2306),
    [anon_sym_UR_DQUOTE] = ACTIONS(2306),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2306),
    [anon_sym_co_await] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_requires] = ACTIONS(2304),
    [sym_this] = ACTIONS(2304),
    [anon_sym___launch_bounds__] = ACTIONS(2304),
  },
  [494] = {
    [sym_identifier] = ACTIONS(2255),
    [aux_sym_preproc_include_token1] = ACTIONS(2255),
    [aux_sym_preproc_def_token1] = ACTIONS(2255),
    [aux_sym_preproc_if_token1] = ACTIONS(2255),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2255),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2255),
    [sym_preproc_directive] = ACTIONS(2255),
    [anon_sym_LPAREN2] = ACTIONS(2257),
    [anon_sym_BANG] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2257),
    [anon_sym_AMP_AMP] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2255),
    [anon_sym_SEMI] = ACTIONS(2257),
    [anon_sym___extension__] = ACTIONS(2255),
    [anon_sym_typedef] = ACTIONS(2255),
    [anon_sym___device__] = ACTIONS(2255),
    [anon_sym___host__] = ACTIONS(2255),
    [anon_sym___global__] = ACTIONS(2255),
    [anon_sym___forceinline__] = ACTIONS(2255),
    [anon_sym___noinline__] = ACTIONS(2255),
    [anon_sym_extern] = ACTIONS(2255),
    [anon_sym___attribute__] = ACTIONS(2255),
    [anon_sym_COLON_COLON] = ACTIONS(2257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2257),
    [anon_sym___declspec] = ACTIONS(2255),
    [anon_sym___based] = ACTIONS(2255),
    [anon_sym___cdecl] = ACTIONS(2255),
    [anon_sym___clrcall] = ACTIONS(2255),
    [anon_sym___stdcall] = ACTIONS(2255),
    [anon_sym___fastcall] = ACTIONS(2255),
    [anon_sym___thiscall] = ACTIONS(2255),
    [anon_sym___vectorcall] = ACTIONS(2255),
    [anon_sym_LBRACE] = ACTIONS(2257),
    [anon_sym_RBRACE] = ACTIONS(2257),
    [anon_sym_signed] = ACTIONS(2255),
    [anon_sym_unsigned] = ACTIONS(2255),
    [anon_sym_long] = ACTIONS(2255),
    [anon_sym_short] = ACTIONS(2255),
    [anon_sym_LBRACK] = ACTIONS(2255),
    [anon_sym_static] = ACTIONS(2255),
    [anon_sym_register] = ACTIONS(2255),
    [anon_sym_inline] = ACTIONS(2255),
    [anon_sym___inline] = ACTIONS(2255),
    [anon_sym___inline__] = ACTIONS(2255),
    [anon_sym___forceinline] = ACTIONS(2255),
    [anon_sym_thread_local] = ACTIONS(2255),
    [anon_sym___thread] = ACTIONS(2255),
    [anon_sym_const] = ACTIONS(2255),
    [anon_sym_constexpr] = ACTIONS(2255),
    [anon_sym_volatile] = ACTIONS(2255),
    [anon_sym_restrict] = ACTIONS(2255),
    [anon_sym___restrict__] = ACTIONS(2255),
    [anon_sym__Atomic] = ACTIONS(2255),
    [anon_sym__Noreturn] = ACTIONS(2255),
    [anon_sym_noreturn] = ACTIONS(2255),
    [anon_sym_mutable] = ACTIONS(2255),
    [anon_sym_constinit] = ACTIONS(2255),
    [anon_sym_consteval] = ACTIONS(2255),
    [anon_sym___shared__] = ACTIONS(2255),
    [anon_sym___local__] = ACTIONS(2255),
    [anon_sym___constant__] = ACTIONS(2255),
    [anon_sym___managed__] = ACTIONS(2255),
    [anon_sym___grid_constant__] = ACTIONS(2255),
    [anon_sym_alignas] = ACTIONS(2255),
    [anon_sym__Alignas] = ACTIONS(2255),
    [sym_primitive_type] = ACTIONS(2255),
    [anon_sym_enum] = ACTIONS(2255),
    [anon_sym_class] = ACTIONS(2255),
    [anon_sym_struct] = ACTIONS(2255),
    [anon_sym_union] = ACTIONS(2255),
    [anon_sym_if] = ACTIONS(2255),
    [anon_sym_switch] = ACTIONS(2255),
    [anon_sym_case] = ACTIONS(2255),
    [anon_sym_default] = ACTIONS(2255),
    [anon_sym_while] = ACTIONS(2255),
    [anon_sym_do] = ACTIONS(2255),
    [anon_sym_for] = ACTIONS(2255),
    [anon_sym_return] = ACTIONS(2255),
    [anon_sym_break] = ACTIONS(2255),
    [anon_sym_continue] = ACTIONS(2255),
    [anon_sym_goto] = ACTIONS(2255),
    [anon_sym___try] = ACTIONS(2255),
    [anon_sym___leave] = ACTIONS(2255),
    [anon_sym_not] = ACTIONS(2255),
    [anon_sym_compl] = ACTIONS(2255),
    [anon_sym_DASH_DASH] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2257),
    [anon_sym_sizeof] = ACTIONS(2255),
    [anon_sym___alignof__] = ACTIONS(2255),
    [anon_sym___alignof] = ACTIONS(2255),
    [anon_sym__alignof] = ACTIONS(2255),
    [anon_sym_alignof] = ACTIONS(2255),
    [anon_sym__Alignof] = ACTIONS(2255),
    [anon_sym_offsetof] = ACTIONS(2255),
    [anon_sym__Generic] = ACTIONS(2255),
    [anon_sym_asm] = ACTIONS(2255),
    [anon_sym___asm__] = ACTIONS(2255),
    [sym_number_literal] = ACTIONS(2257),
    [anon_sym_L_SQUOTE] = ACTIONS(2257),
    [anon_sym_u_SQUOTE] = ACTIONS(2257),
    [anon_sym_U_SQUOTE] = ACTIONS(2257),
    [anon_sym_u8_SQUOTE] = ACTIONS(2257),
    [anon_sym_SQUOTE] = ACTIONS(2257),
    [anon_sym_L_DQUOTE] = ACTIONS(2257),
    [anon_sym_u_DQUOTE] = ACTIONS(2257),
    [anon_sym_U_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8_DQUOTE] = ACTIONS(2257),
    [anon_sym_DQUOTE] = ACTIONS(2257),
    [sym_true] = ACTIONS(2255),
    [sym_false] = ACTIONS(2255),
    [anon_sym_NULL] = ACTIONS(2255),
    [anon_sym_nullptr] = ACTIONS(2255),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2255),
    [anon_sym_decltype] = ACTIONS(2255),
    [sym_virtual] = ACTIONS(2255),
    [anon_sym_explicit] = ACTIONS(2255),
    [anon_sym_typename] = ACTIONS(2255),
    [anon_sym_template] = ACTIONS(2255),
    [anon_sym_operator] = ACTIONS(2255),
    [anon_sym_try] = ACTIONS(2255),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_throw] = ACTIONS(2255),
    [anon_sym_namespace] = ACTIONS(2255),
    [anon_sym_using] = ACTIONS(2255),
    [anon_sym_static_assert] = ACTIONS(2255),
    [anon_sym_concept] = ACTIONS(2255),
    [anon_sym_co_return] = ACTIONS(2255),
    [anon_sym_co_yield] = ACTIONS(2255),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [anon_sym_co_await] = ACTIONS(2255),
    [anon_sym_new] = ACTIONS(2255),
    [anon_sym_requires] = ACTIONS(2255),
    [sym_this] = ACTIONS(2255),
    [anon_sym___launch_bounds__] = ACTIONS(2255),
  },
  [495] = {
    [sym_identifier] = ACTIONS(2251),
    [aux_sym_preproc_include_token1] = ACTIONS(2251),
    [aux_sym_preproc_def_token1] = ACTIONS(2251),
    [aux_sym_preproc_if_token1] = ACTIONS(2251),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2251),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2251),
    [sym_preproc_directive] = ACTIONS(2251),
    [anon_sym_LPAREN2] = ACTIONS(2253),
    [anon_sym_BANG] = ACTIONS(2253),
    [anon_sym_TILDE] = ACTIONS(2253),
    [anon_sym_DASH] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2251),
    [anon_sym_STAR] = ACTIONS(2253),
    [anon_sym_AMP_AMP] = ACTIONS(2253),
    [anon_sym_AMP] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(2253),
    [anon_sym___extension__] = ACTIONS(2251),
    [anon_sym_typedef] = ACTIONS(2251),
    [anon_sym___device__] = ACTIONS(2251),
    [anon_sym___host__] = ACTIONS(2251),
    [anon_sym___global__] = ACTIONS(2251),
    [anon_sym___forceinline__] = ACTIONS(2251),
    [anon_sym___noinline__] = ACTIONS(2251),
    [anon_sym_extern] = ACTIONS(2251),
    [anon_sym___attribute__] = ACTIONS(2251),
    [anon_sym_COLON_COLON] = ACTIONS(2253),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2253),
    [anon_sym___declspec] = ACTIONS(2251),
    [anon_sym___based] = ACTIONS(2251),
    [anon_sym___cdecl] = ACTIONS(2251),
    [anon_sym___clrcall] = ACTIONS(2251),
    [anon_sym___stdcall] = ACTIONS(2251),
    [anon_sym___fastcall] = ACTIONS(2251),
    [anon_sym___thiscall] = ACTIONS(2251),
    [anon_sym___vectorcall] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(2253),
    [anon_sym_RBRACE] = ACTIONS(2253),
    [anon_sym_signed] = ACTIONS(2251),
    [anon_sym_unsigned] = ACTIONS(2251),
    [anon_sym_long] = ACTIONS(2251),
    [anon_sym_short] = ACTIONS(2251),
    [anon_sym_LBRACK] = ACTIONS(2251),
    [anon_sym_static] = ACTIONS(2251),
    [anon_sym_register] = ACTIONS(2251),
    [anon_sym_inline] = ACTIONS(2251),
    [anon_sym___inline] = ACTIONS(2251),
    [anon_sym___inline__] = ACTIONS(2251),
    [anon_sym___forceinline] = ACTIONS(2251),
    [anon_sym_thread_local] = ACTIONS(2251),
    [anon_sym___thread] = ACTIONS(2251),
    [anon_sym_const] = ACTIONS(2251),
    [anon_sym_constexpr] = ACTIONS(2251),
    [anon_sym_volatile] = ACTIONS(2251),
    [anon_sym_restrict] = ACTIONS(2251),
    [anon_sym___restrict__] = ACTIONS(2251),
    [anon_sym__Atomic] = ACTIONS(2251),
    [anon_sym__Noreturn] = ACTIONS(2251),
    [anon_sym_noreturn] = ACTIONS(2251),
    [anon_sym_mutable] = ACTIONS(2251),
    [anon_sym_constinit] = ACTIONS(2251),
    [anon_sym_consteval] = ACTIONS(2251),
    [anon_sym___shared__] = ACTIONS(2251),
    [anon_sym___local__] = ACTIONS(2251),
    [anon_sym___constant__] = ACTIONS(2251),
    [anon_sym___managed__] = ACTIONS(2251),
    [anon_sym___grid_constant__] = ACTIONS(2251),
    [anon_sym_alignas] = ACTIONS(2251),
    [anon_sym__Alignas] = ACTIONS(2251),
    [sym_primitive_type] = ACTIONS(2251),
    [anon_sym_enum] = ACTIONS(2251),
    [anon_sym_class] = ACTIONS(2251),
    [anon_sym_struct] = ACTIONS(2251),
    [anon_sym_union] = ACTIONS(2251),
    [anon_sym_if] = ACTIONS(2251),
    [anon_sym_switch] = ACTIONS(2251),
    [anon_sym_case] = ACTIONS(2251),
    [anon_sym_default] = ACTIONS(2251),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_do] = ACTIONS(2251),
    [anon_sym_for] = ACTIONS(2251),
    [anon_sym_return] = ACTIONS(2251),
    [anon_sym_break] = ACTIONS(2251),
    [anon_sym_continue] = ACTIONS(2251),
    [anon_sym_goto] = ACTIONS(2251),
    [anon_sym___try] = ACTIONS(2251),
    [anon_sym___leave] = ACTIONS(2251),
    [anon_sym_not] = ACTIONS(2251),
    [anon_sym_compl] = ACTIONS(2251),
    [anon_sym_DASH_DASH] = ACTIONS(2253),
    [anon_sym_PLUS_PLUS] = ACTIONS(2253),
    [anon_sym_sizeof] = ACTIONS(2251),
    [anon_sym___alignof__] = ACTIONS(2251),
    [anon_sym___alignof] = ACTIONS(2251),
    [anon_sym__alignof] = ACTIONS(2251),
    [anon_sym_alignof] = ACTIONS(2251),
    [anon_sym__Alignof] = ACTIONS(2251),
    [anon_sym_offsetof] = ACTIONS(2251),
    [anon_sym__Generic] = ACTIONS(2251),
    [anon_sym_asm] = ACTIONS(2251),
    [anon_sym___asm__] = ACTIONS(2251),
    [sym_number_literal] = ACTIONS(2253),
    [anon_sym_L_SQUOTE] = ACTIONS(2253),
    [anon_sym_u_SQUOTE] = ACTIONS(2253),
    [anon_sym_U_SQUOTE] = ACTIONS(2253),
    [anon_sym_u8_SQUOTE] = ACTIONS(2253),
    [anon_sym_SQUOTE] = ACTIONS(2253),
    [anon_sym_L_DQUOTE] = ACTIONS(2253),
    [anon_sym_u_DQUOTE] = ACTIONS(2253),
    [anon_sym_U_DQUOTE] = ACTIONS(2253),
    [anon_sym_u8_DQUOTE] = ACTIONS(2253),
    [anon_sym_DQUOTE] = ACTIONS(2253),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [anon_sym_NULL] = ACTIONS(2251),
    [anon_sym_nullptr] = ACTIONS(2251),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2251),
    [anon_sym_decltype] = ACTIONS(2251),
    [sym_virtual] = ACTIONS(2251),
    [anon_sym_explicit] = ACTIONS(2251),
    [anon_sym_typename] = ACTIONS(2251),
    [anon_sym_template] = ACTIONS(2251),
    [anon_sym_operator] = ACTIONS(2251),
    [anon_sym_try] = ACTIONS(2251),
    [anon_sym_delete] = ACTIONS(2251),
    [anon_sym_throw] = ACTIONS(2251),
    [anon_sym_namespace] = ACTIONS(2251),
    [anon_sym_using] = ACTIONS(2251),
    [anon_sym_static_assert] = ACTIONS(2251),
    [anon_sym_concept] = ACTIONS(2251),
    [anon_sym_co_return] = ACTIONS(2251),
    [anon_sym_co_yield] = ACTIONS(2251),
    [anon_sym_R_DQUOTE] = ACTIONS(2253),
    [anon_sym_LR_DQUOTE] = ACTIONS(2253),
    [anon_sym_uR_DQUOTE] = ACTIONS(2253),
    [anon_sym_UR_DQUOTE] = ACTIONS(2253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2253),
    [anon_sym_co_await] = ACTIONS(2251),
    [anon_sym_new] = ACTIONS(2251),
    [anon_sym_requires] = ACTIONS(2251),
    [sym_this] = ACTIONS(2251),
    [anon_sym___launch_bounds__] = ACTIONS(2251),
  },
  [496] = {
    [sym_identifier] = ACTIONS(2356),
    [aux_sym_preproc_include_token1] = ACTIONS(2356),
    [aux_sym_preproc_def_token1] = ACTIONS(2356),
    [aux_sym_preproc_if_token1] = ACTIONS(2356),
    [aux_sym_preproc_if_token2] = ACTIONS(2356),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2356),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2356),
    [sym_preproc_directive] = ACTIONS(2356),
    [anon_sym_LPAREN2] = ACTIONS(2358),
    [anon_sym_BANG] = ACTIONS(2358),
    [anon_sym_TILDE] = ACTIONS(2358),
    [anon_sym_DASH] = ACTIONS(2356),
    [anon_sym_PLUS] = ACTIONS(2356),
    [anon_sym_STAR] = ACTIONS(2358),
    [anon_sym_AMP_AMP] = ACTIONS(2358),
    [anon_sym_AMP] = ACTIONS(2356),
    [anon_sym_SEMI] = ACTIONS(2358),
    [anon_sym___extension__] = ACTIONS(2356),
    [anon_sym_typedef] = ACTIONS(2356),
    [anon_sym___device__] = ACTIONS(2356),
    [anon_sym___host__] = ACTIONS(2356),
    [anon_sym___global__] = ACTIONS(2356),
    [anon_sym___forceinline__] = ACTIONS(2356),
    [anon_sym___noinline__] = ACTIONS(2356),
    [anon_sym_extern] = ACTIONS(2356),
    [anon_sym___attribute__] = ACTIONS(2356),
    [anon_sym_COLON_COLON] = ACTIONS(2358),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2358),
    [anon_sym___declspec] = ACTIONS(2356),
    [anon_sym___based] = ACTIONS(2356),
    [anon_sym___cdecl] = ACTIONS(2356),
    [anon_sym___clrcall] = ACTIONS(2356),
    [anon_sym___stdcall] = ACTIONS(2356),
    [anon_sym___fastcall] = ACTIONS(2356),
    [anon_sym___thiscall] = ACTIONS(2356),
    [anon_sym___vectorcall] = ACTIONS(2356),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_signed] = ACTIONS(2356),
    [anon_sym_unsigned] = ACTIONS(2356),
    [anon_sym_long] = ACTIONS(2356),
    [anon_sym_short] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2356),
    [anon_sym_register] = ACTIONS(2356),
    [anon_sym_inline] = ACTIONS(2356),
    [anon_sym___inline] = ACTIONS(2356),
    [anon_sym___inline__] = ACTIONS(2356),
    [anon_sym___forceinline] = ACTIONS(2356),
    [anon_sym_thread_local] = ACTIONS(2356),
    [anon_sym___thread] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(2356),
    [anon_sym_constexpr] = ACTIONS(2356),
    [anon_sym_volatile] = ACTIONS(2356),
    [anon_sym_restrict] = ACTIONS(2356),
    [anon_sym___restrict__] = ACTIONS(2356),
    [anon_sym__Atomic] = ACTIONS(2356),
    [anon_sym__Noreturn] = ACTIONS(2356),
    [anon_sym_noreturn] = ACTIONS(2356),
    [anon_sym_mutable] = ACTIONS(2356),
    [anon_sym_constinit] = ACTIONS(2356),
    [anon_sym_consteval] = ACTIONS(2356),
    [anon_sym___shared__] = ACTIONS(2356),
    [anon_sym___local__] = ACTIONS(2356),
    [anon_sym___constant__] = ACTIONS(2356),
    [anon_sym___managed__] = ACTIONS(2356),
    [anon_sym___grid_constant__] = ACTIONS(2356),
    [anon_sym_alignas] = ACTIONS(2356),
    [anon_sym__Alignas] = ACTIONS(2356),
    [sym_primitive_type] = ACTIONS(2356),
    [anon_sym_enum] = ACTIONS(2356),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_struct] = ACTIONS(2356),
    [anon_sym_union] = ACTIONS(2356),
    [anon_sym_if] = ACTIONS(2356),
    [anon_sym_switch] = ACTIONS(2356),
    [anon_sym_case] = ACTIONS(2356),
    [anon_sym_default] = ACTIONS(2356),
    [anon_sym_while] = ACTIONS(2356),
    [anon_sym_do] = ACTIONS(2356),
    [anon_sym_for] = ACTIONS(2356),
    [anon_sym_return] = ACTIONS(2356),
    [anon_sym_break] = ACTIONS(2356),
    [anon_sym_continue] = ACTIONS(2356),
    [anon_sym_goto] = ACTIONS(2356),
    [anon_sym___try] = ACTIONS(2356),
    [anon_sym___leave] = ACTIONS(2356),
    [anon_sym_not] = ACTIONS(2356),
    [anon_sym_compl] = ACTIONS(2356),
    [anon_sym_DASH_DASH] = ACTIONS(2358),
    [anon_sym_PLUS_PLUS] = ACTIONS(2358),
    [anon_sym_sizeof] = ACTIONS(2356),
    [anon_sym___alignof__] = ACTIONS(2356),
    [anon_sym___alignof] = ACTIONS(2356),
    [anon_sym__alignof] = ACTIONS(2356),
    [anon_sym_alignof] = ACTIONS(2356),
    [anon_sym__Alignof] = ACTIONS(2356),
    [anon_sym_offsetof] = ACTIONS(2356),
    [anon_sym__Generic] = ACTIONS(2356),
    [anon_sym_asm] = ACTIONS(2356),
    [anon_sym___asm__] = ACTIONS(2356),
    [sym_number_literal] = ACTIONS(2358),
    [anon_sym_L_SQUOTE] = ACTIONS(2358),
    [anon_sym_u_SQUOTE] = ACTIONS(2358),
    [anon_sym_U_SQUOTE] = ACTIONS(2358),
    [anon_sym_u8_SQUOTE] = ACTIONS(2358),
    [anon_sym_SQUOTE] = ACTIONS(2358),
    [anon_sym_L_DQUOTE] = ACTIONS(2358),
    [anon_sym_u_DQUOTE] = ACTIONS(2358),
    [anon_sym_U_DQUOTE] = ACTIONS(2358),
    [anon_sym_u8_DQUOTE] = ACTIONS(2358),
    [anon_sym_DQUOTE] = ACTIONS(2358),
    [sym_true] = ACTIONS(2356),
    [sym_false] = ACTIONS(2356),
    [anon_sym_NULL] = ACTIONS(2356),
    [anon_sym_nullptr] = ACTIONS(2356),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2356),
    [anon_sym_decltype] = ACTIONS(2356),
    [sym_virtual] = ACTIONS(2356),
    [anon_sym_explicit] = ACTIONS(2356),
    [anon_sym_typename] = ACTIONS(2356),
    [anon_sym_template] = ACTIONS(2356),
    [anon_sym_operator] = ACTIONS(2356),
    [anon_sym_try] = ACTIONS(2356),
    [anon_sym_delete] = ACTIONS(2356),
    [anon_sym_throw] = ACTIONS(2356),
    [anon_sym_namespace] = ACTIONS(2356),
    [anon_sym_using] = ACTIONS(2356),
    [anon_sym_static_assert] = ACTIONS(2356),
    [anon_sym_concept] = ACTIONS(2356),
    [anon_sym_co_return] = ACTIONS(2356),
    [anon_sym_co_yield] = ACTIONS(2356),
    [anon_sym_R_DQUOTE] = ACTIONS(2358),
    [anon_sym_LR_DQUOTE] = ACTIONS(2358),
    [anon_sym_uR_DQUOTE] = ACTIONS(2358),
    [anon_sym_UR_DQUOTE] = ACTIONS(2358),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2358),
    [anon_sym_co_await] = ACTIONS(2356),
    [anon_sym_new] = ACTIONS(2356),
    [anon_sym_requires] = ACTIONS(2356),
    [sym_this] = ACTIONS(2356),
    [anon_sym___launch_bounds__] = ACTIONS(2356),
  },
  [497] = {
    [sym_identifier] = ACTIONS(2366),
    [aux_sym_preproc_include_token1] = ACTIONS(2366),
    [aux_sym_preproc_def_token1] = ACTIONS(2366),
    [aux_sym_preproc_if_token1] = ACTIONS(2366),
    [aux_sym_preproc_if_token2] = ACTIONS(2366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2366),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2366),
    [sym_preproc_directive] = ACTIONS(2366),
    [anon_sym_LPAREN2] = ACTIONS(2368),
    [anon_sym_BANG] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(2368),
    [anon_sym_DASH] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(2366),
    [anon_sym_STAR] = ACTIONS(2368),
    [anon_sym_AMP_AMP] = ACTIONS(2368),
    [anon_sym_AMP] = ACTIONS(2366),
    [anon_sym_SEMI] = ACTIONS(2368),
    [anon_sym___extension__] = ACTIONS(2366),
    [anon_sym_typedef] = ACTIONS(2366),
    [anon_sym___device__] = ACTIONS(2366),
    [anon_sym___host__] = ACTIONS(2366),
    [anon_sym___global__] = ACTIONS(2366),
    [anon_sym___forceinline__] = ACTIONS(2366),
    [anon_sym___noinline__] = ACTIONS(2366),
    [anon_sym_extern] = ACTIONS(2366),
    [anon_sym___attribute__] = ACTIONS(2366),
    [anon_sym_COLON_COLON] = ACTIONS(2368),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2368),
    [anon_sym___declspec] = ACTIONS(2366),
    [anon_sym___based] = ACTIONS(2366),
    [anon_sym___cdecl] = ACTIONS(2366),
    [anon_sym___clrcall] = ACTIONS(2366),
    [anon_sym___stdcall] = ACTIONS(2366),
    [anon_sym___fastcall] = ACTIONS(2366),
    [anon_sym___thiscall] = ACTIONS(2366),
    [anon_sym___vectorcall] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(2368),
    [anon_sym_signed] = ACTIONS(2366),
    [anon_sym_unsigned] = ACTIONS(2366),
    [anon_sym_long] = ACTIONS(2366),
    [anon_sym_short] = ACTIONS(2366),
    [anon_sym_LBRACK] = ACTIONS(2366),
    [anon_sym_static] = ACTIONS(2366),
    [anon_sym_register] = ACTIONS(2366),
    [anon_sym_inline] = ACTIONS(2366),
    [anon_sym___inline] = ACTIONS(2366),
    [anon_sym___inline__] = ACTIONS(2366),
    [anon_sym___forceinline] = ACTIONS(2366),
    [anon_sym_thread_local] = ACTIONS(2366),
    [anon_sym___thread] = ACTIONS(2366),
    [anon_sym_const] = ACTIONS(2366),
    [anon_sym_constexpr] = ACTIONS(2366),
    [anon_sym_volatile] = ACTIONS(2366),
    [anon_sym_restrict] = ACTIONS(2366),
    [anon_sym___restrict__] = ACTIONS(2366),
    [anon_sym__Atomic] = ACTIONS(2366),
    [anon_sym__Noreturn] = ACTIONS(2366),
    [anon_sym_noreturn] = ACTIONS(2366),
    [anon_sym_mutable] = ACTIONS(2366),
    [anon_sym_constinit] = ACTIONS(2366),
    [anon_sym_consteval] = ACTIONS(2366),
    [anon_sym___shared__] = ACTIONS(2366),
    [anon_sym___local__] = ACTIONS(2366),
    [anon_sym___constant__] = ACTIONS(2366),
    [anon_sym___managed__] = ACTIONS(2366),
    [anon_sym___grid_constant__] = ACTIONS(2366),
    [anon_sym_alignas] = ACTIONS(2366),
    [anon_sym__Alignas] = ACTIONS(2366),
    [sym_primitive_type] = ACTIONS(2366),
    [anon_sym_enum] = ACTIONS(2366),
    [anon_sym_class] = ACTIONS(2366),
    [anon_sym_struct] = ACTIONS(2366),
    [anon_sym_union] = ACTIONS(2366),
    [anon_sym_if] = ACTIONS(2366),
    [anon_sym_switch] = ACTIONS(2366),
    [anon_sym_case] = ACTIONS(2366),
    [anon_sym_default] = ACTIONS(2366),
    [anon_sym_while] = ACTIONS(2366),
    [anon_sym_do] = ACTIONS(2366),
    [anon_sym_for] = ACTIONS(2366),
    [anon_sym_return] = ACTIONS(2366),
    [anon_sym_break] = ACTIONS(2366),
    [anon_sym_continue] = ACTIONS(2366),
    [anon_sym_goto] = ACTIONS(2366),
    [anon_sym___try] = ACTIONS(2366),
    [anon_sym___leave] = ACTIONS(2366),
    [anon_sym_not] = ACTIONS(2366),
    [anon_sym_compl] = ACTIONS(2366),
    [anon_sym_DASH_DASH] = ACTIONS(2368),
    [anon_sym_PLUS_PLUS] = ACTIONS(2368),
    [anon_sym_sizeof] = ACTIONS(2366),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2366),
    [anon_sym__Generic] = ACTIONS(2366),
    [anon_sym_asm] = ACTIONS(2366),
    [anon_sym___asm__] = ACTIONS(2366),
    [sym_number_literal] = ACTIONS(2368),
    [anon_sym_L_SQUOTE] = ACTIONS(2368),
    [anon_sym_u_SQUOTE] = ACTIONS(2368),
    [anon_sym_U_SQUOTE] = ACTIONS(2368),
    [anon_sym_u8_SQUOTE] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(2368),
    [anon_sym_L_DQUOTE] = ACTIONS(2368),
    [anon_sym_u_DQUOTE] = ACTIONS(2368),
    [anon_sym_U_DQUOTE] = ACTIONS(2368),
    [anon_sym_u8_DQUOTE] = ACTIONS(2368),
    [anon_sym_DQUOTE] = ACTIONS(2368),
    [sym_true] = ACTIONS(2366),
    [sym_false] = ACTIONS(2366),
    [anon_sym_NULL] = ACTIONS(2366),
    [anon_sym_nullptr] = ACTIONS(2366),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2366),
    [anon_sym_decltype] = ACTIONS(2366),
    [sym_virtual] = ACTIONS(2366),
    [anon_sym_explicit] = ACTIONS(2366),
    [anon_sym_typename] = ACTIONS(2366),
    [anon_sym_template] = ACTIONS(2366),
    [anon_sym_operator] = ACTIONS(2366),
    [anon_sym_try] = ACTIONS(2366),
    [anon_sym_delete] = ACTIONS(2366),
    [anon_sym_throw] = ACTIONS(2366),
    [anon_sym_namespace] = ACTIONS(2366),
    [anon_sym_using] = ACTIONS(2366),
    [anon_sym_static_assert] = ACTIONS(2366),
    [anon_sym_concept] = ACTIONS(2366),
    [anon_sym_co_return] = ACTIONS(2366),
    [anon_sym_co_yield] = ACTIONS(2366),
    [anon_sym_R_DQUOTE] = ACTIONS(2368),
    [anon_sym_LR_DQUOTE] = ACTIONS(2368),
    [anon_sym_uR_DQUOTE] = ACTIONS(2368),
    [anon_sym_UR_DQUOTE] = ACTIONS(2368),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2368),
    [anon_sym_co_await] = ACTIONS(2366),
    [anon_sym_new] = ACTIONS(2366),
    [anon_sym_requires] = ACTIONS(2366),
    [sym_this] = ACTIONS(2366),
    [anon_sym___launch_bounds__] = ACTIONS(2366),
  },
  [498] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_include_token1] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token2] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2269),
    [anon_sym_BANG] = ACTIONS(2269),
    [anon_sym_TILDE] = ACTIONS(2269),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_STAR] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_SEMI] = ACTIONS(2269),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym___device__] = ACTIONS(2267),
    [anon_sym___host__] = ACTIONS(2267),
    [anon_sym___global__] = ACTIONS(2267),
    [anon_sym___forceinline__] = ACTIONS(2267),
    [anon_sym___noinline__] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2269),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2269),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym___cdecl] = ACTIONS(2267),
    [anon_sym___clrcall] = ACTIONS(2267),
    [anon_sym___stdcall] = ACTIONS(2267),
    [anon_sym___fastcall] = ACTIONS(2267),
    [anon_sym___thiscall] = ACTIONS(2267),
    [anon_sym___vectorcall] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2269),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym___shared__] = ACTIONS(2267),
    [anon_sym___local__] = ACTIONS(2267),
    [anon_sym___constant__] = ACTIONS(2267),
    [anon_sym___managed__] = ACTIONS(2267),
    [anon_sym___grid_constant__] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym__Alignas] = ACTIONS(2267),
    [sym_primitive_type] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_switch] = ACTIONS(2267),
    [anon_sym_case] = ACTIONS(2267),
    [anon_sym_default] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_for] = ACTIONS(2267),
    [anon_sym_return] = ACTIONS(2267),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_continue] = ACTIONS(2267),
    [anon_sym_goto] = ACTIONS(2267),
    [anon_sym___try] = ACTIONS(2267),
    [anon_sym___leave] = ACTIONS(2267),
    [anon_sym_not] = ACTIONS(2267),
    [anon_sym_compl] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2269),
    [anon_sym_PLUS_PLUS] = ACTIONS(2269),
    [anon_sym_sizeof] = ACTIONS(2267),
    [anon_sym___alignof__] = ACTIONS(2267),
    [anon_sym___alignof] = ACTIONS(2267),
    [anon_sym__alignof] = ACTIONS(2267),
    [anon_sym_alignof] = ACTIONS(2267),
    [anon_sym__Alignof] = ACTIONS(2267),
    [anon_sym_offsetof] = ACTIONS(2267),
    [anon_sym__Generic] = ACTIONS(2267),
    [anon_sym_asm] = ACTIONS(2267),
    [anon_sym___asm__] = ACTIONS(2267),
    [sym_number_literal] = ACTIONS(2269),
    [anon_sym_L_SQUOTE] = ACTIONS(2269),
    [anon_sym_u_SQUOTE] = ACTIONS(2269),
    [anon_sym_U_SQUOTE] = ACTIONS(2269),
    [anon_sym_u8_SQUOTE] = ACTIONS(2269),
    [anon_sym_SQUOTE] = ACTIONS(2269),
    [anon_sym_L_DQUOTE] = ACTIONS(2269),
    [anon_sym_u_DQUOTE] = ACTIONS(2269),
    [anon_sym_U_DQUOTE] = ACTIONS(2269),
    [anon_sym_u8_DQUOTE] = ACTIONS(2269),
    [anon_sym_DQUOTE] = ACTIONS(2269),
    [sym_true] = ACTIONS(2267),
    [sym_false] = ACTIONS(2267),
    [anon_sym_NULL] = ACTIONS(2267),
    [anon_sym_nullptr] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [sym_virtual] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_try] = ACTIONS(2267),
    [anon_sym_delete] = ACTIONS(2267),
    [anon_sym_throw] = ACTIONS(2267),
    [anon_sym_namespace] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym_concept] = ACTIONS(2267),
    [anon_sym_co_return] = ACTIONS(2267),
    [anon_sym_co_yield] = ACTIONS(2267),
    [anon_sym_R_DQUOTE] = ACTIONS(2269),
    [anon_sym_LR_DQUOTE] = ACTIONS(2269),
    [anon_sym_uR_DQUOTE] = ACTIONS(2269),
    [anon_sym_UR_DQUOTE] = ACTIONS(2269),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2269),
    [anon_sym_co_await] = ACTIONS(2267),
    [anon_sym_new] = ACTIONS(2267),
    [anon_sym_requires] = ACTIONS(2267),
    [sym_this] = ACTIONS(2267),
    [anon_sym___launch_bounds__] = ACTIONS(2267),
  },
  [499] = {
    [sym_identifier] = ACTIONS(2308),
    [aux_sym_preproc_include_token1] = ACTIONS(2308),
    [aux_sym_preproc_def_token1] = ACTIONS(2308),
    [aux_sym_preproc_if_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2308),
    [sym_preproc_directive] = ACTIONS(2308),
    [anon_sym_LPAREN2] = ACTIONS(2310),
    [anon_sym_BANG] = ACTIONS(2310),
    [anon_sym_TILDE] = ACTIONS(2310),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2310),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym___extension__] = ACTIONS(2308),
    [anon_sym_typedef] = ACTIONS(2308),
    [anon_sym___device__] = ACTIONS(2308),
    [anon_sym___host__] = ACTIONS(2308),
    [anon_sym___global__] = ACTIONS(2308),
    [anon_sym___forceinline__] = ACTIONS(2308),
    [anon_sym___noinline__] = ACTIONS(2308),
    [anon_sym_extern] = ACTIONS(2308),
    [anon_sym___attribute__] = ACTIONS(2308),
    [anon_sym_COLON_COLON] = ACTIONS(2310),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2310),
    [anon_sym___declspec] = ACTIONS(2308),
    [anon_sym___based] = ACTIONS(2308),
    [anon_sym___cdecl] = ACTIONS(2308),
    [anon_sym___clrcall] = ACTIONS(2308),
    [anon_sym___stdcall] = ACTIONS(2308),
    [anon_sym___fastcall] = ACTIONS(2308),
    [anon_sym___thiscall] = ACTIONS(2308),
    [anon_sym___vectorcall] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_RBRACE] = ACTIONS(2310),
    [anon_sym_signed] = ACTIONS(2308),
    [anon_sym_unsigned] = ACTIONS(2308),
    [anon_sym_long] = ACTIONS(2308),
    [anon_sym_short] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_register] = ACTIONS(2308),
    [anon_sym_inline] = ACTIONS(2308),
    [anon_sym___inline] = ACTIONS(2308),
    [anon_sym___inline__] = ACTIONS(2308),
    [anon_sym___forceinline] = ACTIONS(2308),
    [anon_sym_thread_local] = ACTIONS(2308),
    [anon_sym___thread] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_constexpr] = ACTIONS(2308),
    [anon_sym_volatile] = ACTIONS(2308),
    [anon_sym_restrict] = ACTIONS(2308),
    [anon_sym___restrict__] = ACTIONS(2308),
    [anon_sym__Atomic] = ACTIONS(2308),
    [anon_sym__Noreturn] = ACTIONS(2308),
    [anon_sym_noreturn] = ACTIONS(2308),
    [anon_sym_mutable] = ACTIONS(2308),
    [anon_sym_constinit] = ACTIONS(2308),
    [anon_sym_consteval] = ACTIONS(2308),
    [anon_sym___shared__] = ACTIONS(2308),
    [anon_sym___local__] = ACTIONS(2308),
    [anon_sym___constant__] = ACTIONS(2308),
    [anon_sym___managed__] = ACTIONS(2308),
    [anon_sym___grid_constant__] = ACTIONS(2308),
    [anon_sym_alignas] = ACTIONS(2308),
    [anon_sym__Alignas] = ACTIONS(2308),
    [sym_primitive_type] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
    [anon_sym_class] = ACTIONS(2308),
    [anon_sym_struct] = ACTIONS(2308),
    [anon_sym_union] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_switch] = ACTIONS(2308),
    [anon_sym_case] = ACTIONS(2308),
    [anon_sym_default] = ACTIONS(2308),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_do] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_goto] = ACTIONS(2308),
    [anon_sym___try] = ACTIONS(2308),
    [anon_sym___leave] = ACTIONS(2308),
    [anon_sym_not] = ACTIONS(2308),
    [anon_sym_compl] = ACTIONS(2308),
    [anon_sym_DASH_DASH] = ACTIONS(2310),
    [anon_sym_PLUS_PLUS] = ACTIONS(2310),
    [anon_sym_sizeof] = ACTIONS(2308),
    [anon_sym___alignof__] = ACTIONS(2308),
    [anon_sym___alignof] = ACTIONS(2308),
    [anon_sym__alignof] = ACTIONS(2308),
    [anon_sym_alignof] = ACTIONS(2308),
    [anon_sym__Alignof] = ACTIONS(2308),
    [anon_sym_offsetof] = ACTIONS(2308),
    [anon_sym__Generic] = ACTIONS(2308),
    [anon_sym_asm] = ACTIONS(2308),
    [anon_sym___asm__] = ACTIONS(2308),
    [sym_number_literal] = ACTIONS(2310),
    [anon_sym_L_SQUOTE] = ACTIONS(2310),
    [anon_sym_u_SQUOTE] = ACTIONS(2310),
    [anon_sym_U_SQUOTE] = ACTIONS(2310),
    [anon_sym_u8_SQUOTE] = ACTIONS(2310),
    [anon_sym_SQUOTE] = ACTIONS(2310),
    [anon_sym_L_DQUOTE] = ACTIONS(2310),
    [anon_sym_u_DQUOTE] = ACTIONS(2310),
    [anon_sym_U_DQUOTE] = ACTIONS(2310),
    [anon_sym_u8_DQUOTE] = ACTIONS(2310),
    [anon_sym_DQUOTE] = ACTIONS(2310),
    [sym_true] = ACTIONS(2308),
    [sym_false] = ACTIONS(2308),
    [anon_sym_NULL] = ACTIONS(2308),
    [anon_sym_nullptr] = ACTIONS(2308),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2308),
    [anon_sym_decltype] = ACTIONS(2308),
    [sym_virtual] = ACTIONS(2308),
    [anon_sym_explicit] = ACTIONS(2308),
    [anon_sym_typename] = ACTIONS(2308),
    [anon_sym_template] = ACTIONS(2308),
    [anon_sym_operator] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [anon_sym_delete] = ACTIONS(2308),
    [anon_sym_throw] = ACTIONS(2308),
    [anon_sym_namespace] = ACTIONS(2308),
    [anon_sym_using] = ACTIONS(2308),
    [anon_sym_static_assert] = ACTIONS(2308),
    [anon_sym_concept] = ACTIONS(2308),
    [anon_sym_co_return] = ACTIONS(2308),
    [anon_sym_co_yield] = ACTIONS(2308),
    [anon_sym_R_DQUOTE] = ACTIONS(2310),
    [anon_sym_LR_DQUOTE] = ACTIONS(2310),
    [anon_sym_uR_DQUOTE] = ACTIONS(2310),
    [anon_sym_UR_DQUOTE] = ACTIONS(2310),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2310),
    [anon_sym_co_await] = ACTIONS(2308),
    [anon_sym_new] = ACTIONS(2308),
    [anon_sym_requires] = ACTIONS(2308),
    [sym_this] = ACTIONS(2308),
    [anon_sym___launch_bounds__] = ACTIONS(2308),
  },
  [500] = {
    [sym_identifier] = ACTIONS(2251),
    [aux_sym_preproc_include_token1] = ACTIONS(2251),
    [aux_sym_preproc_def_token1] = ACTIONS(2251),
    [aux_sym_preproc_if_token1] = ACTIONS(2251),
    [aux_sym_preproc_if_token2] = ACTIONS(2251),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2251),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2251),
    [sym_preproc_directive] = ACTIONS(2251),
    [anon_sym_LPAREN2] = ACTIONS(2253),
    [anon_sym_BANG] = ACTIONS(2253),
    [anon_sym_TILDE] = ACTIONS(2253),
    [anon_sym_DASH] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2251),
    [anon_sym_STAR] = ACTIONS(2253),
    [anon_sym_AMP_AMP] = ACTIONS(2253),
    [anon_sym_AMP] = ACTIONS(2251),
    [anon_sym_SEMI] = ACTIONS(2253),
    [anon_sym___extension__] = ACTIONS(2251),
    [anon_sym_typedef] = ACTIONS(2251),
    [anon_sym___device__] = ACTIONS(2251),
    [anon_sym___host__] = ACTIONS(2251),
    [anon_sym___global__] = ACTIONS(2251),
    [anon_sym___forceinline__] = ACTIONS(2251),
    [anon_sym___noinline__] = ACTIONS(2251),
    [anon_sym_extern] = ACTIONS(2251),
    [anon_sym___attribute__] = ACTIONS(2251),
    [anon_sym_COLON_COLON] = ACTIONS(2253),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2253),
    [anon_sym___declspec] = ACTIONS(2251),
    [anon_sym___based] = ACTIONS(2251),
    [anon_sym___cdecl] = ACTIONS(2251),
    [anon_sym___clrcall] = ACTIONS(2251),
    [anon_sym___stdcall] = ACTIONS(2251),
    [anon_sym___fastcall] = ACTIONS(2251),
    [anon_sym___thiscall] = ACTIONS(2251),
    [anon_sym___vectorcall] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(2253),
    [anon_sym_signed] = ACTIONS(2251),
    [anon_sym_unsigned] = ACTIONS(2251),
    [anon_sym_long] = ACTIONS(2251),
    [anon_sym_short] = ACTIONS(2251),
    [anon_sym_LBRACK] = ACTIONS(2251),
    [anon_sym_static] = ACTIONS(2251),
    [anon_sym_register] = ACTIONS(2251),
    [anon_sym_inline] = ACTIONS(2251),
    [anon_sym___inline] = ACTIONS(2251),
    [anon_sym___inline__] = ACTIONS(2251),
    [anon_sym___forceinline] = ACTIONS(2251),
    [anon_sym_thread_local] = ACTIONS(2251),
    [anon_sym___thread] = ACTIONS(2251),
    [anon_sym_const] = ACTIONS(2251),
    [anon_sym_constexpr] = ACTIONS(2251),
    [anon_sym_volatile] = ACTIONS(2251),
    [anon_sym_restrict] = ACTIONS(2251),
    [anon_sym___restrict__] = ACTIONS(2251),
    [anon_sym__Atomic] = ACTIONS(2251),
    [anon_sym__Noreturn] = ACTIONS(2251),
    [anon_sym_noreturn] = ACTIONS(2251),
    [anon_sym_mutable] = ACTIONS(2251),
    [anon_sym_constinit] = ACTIONS(2251),
    [anon_sym_consteval] = ACTIONS(2251),
    [anon_sym___shared__] = ACTIONS(2251),
    [anon_sym___local__] = ACTIONS(2251),
    [anon_sym___constant__] = ACTIONS(2251),
    [anon_sym___managed__] = ACTIONS(2251),
    [anon_sym___grid_constant__] = ACTIONS(2251),
    [anon_sym_alignas] = ACTIONS(2251),
    [anon_sym__Alignas] = ACTIONS(2251),
    [sym_primitive_type] = ACTIONS(2251),
    [anon_sym_enum] = ACTIONS(2251),
    [anon_sym_class] = ACTIONS(2251),
    [anon_sym_struct] = ACTIONS(2251),
    [anon_sym_union] = ACTIONS(2251),
    [anon_sym_if] = ACTIONS(2251),
    [anon_sym_switch] = ACTIONS(2251),
    [anon_sym_case] = ACTIONS(2251),
    [anon_sym_default] = ACTIONS(2251),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_do] = ACTIONS(2251),
    [anon_sym_for] = ACTIONS(2251),
    [anon_sym_return] = ACTIONS(2251),
    [anon_sym_break] = ACTIONS(2251),
    [anon_sym_continue] = ACTIONS(2251),
    [anon_sym_goto] = ACTIONS(2251),
    [anon_sym___try] = ACTIONS(2251),
    [anon_sym___leave] = ACTIONS(2251),
    [anon_sym_not] = ACTIONS(2251),
    [anon_sym_compl] = ACTIONS(2251),
    [anon_sym_DASH_DASH] = ACTIONS(2253),
    [anon_sym_PLUS_PLUS] = ACTIONS(2253),
    [anon_sym_sizeof] = ACTIONS(2251),
    [anon_sym___alignof__] = ACTIONS(2251),
    [anon_sym___alignof] = ACTIONS(2251),
    [anon_sym__alignof] = ACTIONS(2251),
    [anon_sym_alignof] = ACTIONS(2251),
    [anon_sym__Alignof] = ACTIONS(2251),
    [anon_sym_offsetof] = ACTIONS(2251),
    [anon_sym__Generic] = ACTIONS(2251),
    [anon_sym_asm] = ACTIONS(2251),
    [anon_sym___asm__] = ACTIONS(2251),
    [sym_number_literal] = ACTIONS(2253),
    [anon_sym_L_SQUOTE] = ACTIONS(2253),
    [anon_sym_u_SQUOTE] = ACTIONS(2253),
    [anon_sym_U_SQUOTE] = ACTIONS(2253),
    [anon_sym_u8_SQUOTE] = ACTIONS(2253),
    [anon_sym_SQUOTE] = ACTIONS(2253),
    [anon_sym_L_DQUOTE] = ACTIONS(2253),
    [anon_sym_u_DQUOTE] = ACTIONS(2253),
    [anon_sym_U_DQUOTE] = ACTIONS(2253),
    [anon_sym_u8_DQUOTE] = ACTIONS(2253),
    [anon_sym_DQUOTE] = ACTIONS(2253),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [anon_sym_NULL] = ACTIONS(2251),
    [anon_sym_nullptr] = ACTIONS(2251),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2251),
    [anon_sym_decltype] = ACTIONS(2251),
    [sym_virtual] = ACTIONS(2251),
    [anon_sym_explicit] = ACTIONS(2251),
    [anon_sym_typename] = ACTIONS(2251),
    [anon_sym_template] = ACTIONS(2251),
    [anon_sym_operator] = ACTIONS(2251),
    [anon_sym_try] = ACTIONS(2251),
    [anon_sym_delete] = ACTIONS(2251),
    [anon_sym_throw] = ACTIONS(2251),
    [anon_sym_namespace] = ACTIONS(2251),
    [anon_sym_using] = ACTIONS(2251),
    [anon_sym_static_assert] = ACTIONS(2251),
    [anon_sym_concept] = ACTIONS(2251),
    [anon_sym_co_return] = ACTIONS(2251),
    [anon_sym_co_yield] = ACTIONS(2251),
    [anon_sym_R_DQUOTE] = ACTIONS(2253),
    [anon_sym_LR_DQUOTE] = ACTIONS(2253),
    [anon_sym_uR_DQUOTE] = ACTIONS(2253),
    [anon_sym_UR_DQUOTE] = ACTIONS(2253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2253),
    [anon_sym_co_await] = ACTIONS(2251),
    [anon_sym_new] = ACTIONS(2251),
    [anon_sym_requires] = ACTIONS(2251),
    [sym_this] = ACTIONS(2251),
    [anon_sym___launch_bounds__] = ACTIONS(2251),
  },
  [501] = {
    [sym_identifier] = ACTIONS(2388),
    [aux_sym_preproc_include_token1] = ACTIONS(2388),
    [aux_sym_preproc_def_token1] = ACTIONS(2388),
    [aux_sym_preproc_if_token1] = ACTIONS(2388),
    [aux_sym_preproc_if_token2] = ACTIONS(2388),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2388),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2388),
    [sym_preproc_directive] = ACTIONS(2388),
    [anon_sym_LPAREN2] = ACTIONS(2390),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [anon_sym_DASH] = ACTIONS(2388),
    [anon_sym_PLUS] = ACTIONS(2388),
    [anon_sym_STAR] = ACTIONS(2390),
    [anon_sym_AMP_AMP] = ACTIONS(2390),
    [anon_sym_AMP] = ACTIONS(2388),
    [anon_sym_SEMI] = ACTIONS(2390),
    [anon_sym___extension__] = ACTIONS(2388),
    [anon_sym_typedef] = ACTIONS(2388),
    [anon_sym___device__] = ACTIONS(2388),
    [anon_sym___host__] = ACTIONS(2388),
    [anon_sym___global__] = ACTIONS(2388),
    [anon_sym___forceinline__] = ACTIONS(2388),
    [anon_sym___noinline__] = ACTIONS(2388),
    [anon_sym_extern] = ACTIONS(2388),
    [anon_sym___attribute__] = ACTIONS(2388),
    [anon_sym_COLON_COLON] = ACTIONS(2390),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2390),
    [anon_sym___declspec] = ACTIONS(2388),
    [anon_sym___based] = ACTIONS(2388),
    [anon_sym___cdecl] = ACTIONS(2388),
    [anon_sym___clrcall] = ACTIONS(2388),
    [anon_sym___stdcall] = ACTIONS(2388),
    [anon_sym___fastcall] = ACTIONS(2388),
    [anon_sym___thiscall] = ACTIONS(2388),
    [anon_sym___vectorcall] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2390),
    [anon_sym_signed] = ACTIONS(2388),
    [anon_sym_unsigned] = ACTIONS(2388),
    [anon_sym_long] = ACTIONS(2388),
    [anon_sym_short] = ACTIONS(2388),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [anon_sym_static] = ACTIONS(2388),
    [anon_sym_register] = ACTIONS(2388),
    [anon_sym_inline] = ACTIONS(2388),
    [anon_sym___inline] = ACTIONS(2388),
    [anon_sym___inline__] = ACTIONS(2388),
    [anon_sym___forceinline] = ACTIONS(2388),
    [anon_sym_thread_local] = ACTIONS(2388),
    [anon_sym___thread] = ACTIONS(2388),
    [anon_sym_const] = ACTIONS(2388),
    [anon_sym_constexpr] = ACTIONS(2388),
    [anon_sym_volatile] = ACTIONS(2388),
    [anon_sym_restrict] = ACTIONS(2388),
    [anon_sym___restrict__] = ACTIONS(2388),
    [anon_sym__Atomic] = ACTIONS(2388),
    [anon_sym__Noreturn] = ACTIONS(2388),
    [anon_sym_noreturn] = ACTIONS(2388),
    [anon_sym_mutable] = ACTIONS(2388),
    [anon_sym_constinit] = ACTIONS(2388),
    [anon_sym_consteval] = ACTIONS(2388),
    [anon_sym___shared__] = ACTIONS(2388),
    [anon_sym___local__] = ACTIONS(2388),
    [anon_sym___constant__] = ACTIONS(2388),
    [anon_sym___managed__] = ACTIONS(2388),
    [anon_sym___grid_constant__] = ACTIONS(2388),
    [anon_sym_alignas] = ACTIONS(2388),
    [anon_sym__Alignas] = ACTIONS(2388),
    [sym_primitive_type] = ACTIONS(2388),
    [anon_sym_enum] = ACTIONS(2388),
    [anon_sym_class] = ACTIONS(2388),
    [anon_sym_struct] = ACTIONS(2388),
    [anon_sym_union] = ACTIONS(2388),
    [anon_sym_if] = ACTIONS(2388),
    [anon_sym_switch] = ACTIONS(2388),
    [anon_sym_case] = ACTIONS(2388),
    [anon_sym_default] = ACTIONS(2388),
    [anon_sym_while] = ACTIONS(2388),
    [anon_sym_do] = ACTIONS(2388),
    [anon_sym_for] = ACTIONS(2388),
    [anon_sym_return] = ACTIONS(2388),
    [anon_sym_break] = ACTIONS(2388),
    [anon_sym_continue] = ACTIONS(2388),
    [anon_sym_goto] = ACTIONS(2388),
    [anon_sym___try] = ACTIONS(2388),
    [anon_sym___leave] = ACTIONS(2388),
    [anon_sym_not] = ACTIONS(2388),
    [anon_sym_compl] = ACTIONS(2388),
    [anon_sym_DASH_DASH] = ACTIONS(2390),
    [anon_sym_PLUS_PLUS] = ACTIONS(2390),
    [anon_sym_sizeof] = ACTIONS(2388),
    [anon_sym___alignof__] = ACTIONS(2388),
    [anon_sym___alignof] = ACTIONS(2388),
    [anon_sym__alignof] = ACTIONS(2388),
    [anon_sym_alignof] = ACTIONS(2388),
    [anon_sym__Alignof] = ACTIONS(2388),
    [anon_sym_offsetof] = ACTIONS(2388),
    [anon_sym__Generic] = ACTIONS(2388),
    [anon_sym_asm] = ACTIONS(2388),
    [anon_sym___asm__] = ACTIONS(2388),
    [sym_number_literal] = ACTIONS(2390),
    [anon_sym_L_SQUOTE] = ACTIONS(2390),
    [anon_sym_u_SQUOTE] = ACTIONS(2390),
    [anon_sym_U_SQUOTE] = ACTIONS(2390),
    [anon_sym_u8_SQUOTE] = ACTIONS(2390),
    [anon_sym_SQUOTE] = ACTIONS(2390),
    [anon_sym_L_DQUOTE] = ACTIONS(2390),
    [anon_sym_u_DQUOTE] = ACTIONS(2390),
    [anon_sym_U_DQUOTE] = ACTIONS(2390),
    [anon_sym_u8_DQUOTE] = ACTIONS(2390),
    [anon_sym_DQUOTE] = ACTIONS(2390),
    [sym_true] = ACTIONS(2388),
    [sym_false] = ACTIONS(2388),
    [anon_sym_NULL] = ACTIONS(2388),
    [anon_sym_nullptr] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2388),
    [anon_sym_decltype] = ACTIONS(2388),
    [sym_virtual] = ACTIONS(2388),
    [anon_sym_explicit] = ACTIONS(2388),
    [anon_sym_typename] = ACTIONS(2388),
    [anon_sym_template] = ACTIONS(2388),
    [anon_sym_operator] = ACTIONS(2388),
    [anon_sym_try] = ACTIONS(2388),
    [anon_sym_delete] = ACTIONS(2388),
    [anon_sym_throw] = ACTIONS(2388),
    [anon_sym_namespace] = ACTIONS(2388),
    [anon_sym_using] = ACTIONS(2388),
    [anon_sym_static_assert] = ACTIONS(2388),
    [anon_sym_concept] = ACTIONS(2388),
    [anon_sym_co_return] = ACTIONS(2388),
    [anon_sym_co_yield] = ACTIONS(2388),
    [anon_sym_R_DQUOTE] = ACTIONS(2390),
    [anon_sym_LR_DQUOTE] = ACTIONS(2390),
    [anon_sym_uR_DQUOTE] = ACTIONS(2390),
    [anon_sym_UR_DQUOTE] = ACTIONS(2390),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2390),
    [anon_sym_co_await] = ACTIONS(2388),
    [anon_sym_new] = ACTIONS(2388),
    [anon_sym_requires] = ACTIONS(2388),
    [sym_this] = ACTIONS(2388),
    [anon_sym___launch_bounds__] = ACTIONS(2388),
  },
  [502] = {
    [sym_identifier] = ACTIONS(2392),
    [aux_sym_preproc_include_token1] = ACTIONS(2392),
    [aux_sym_preproc_def_token1] = ACTIONS(2392),
    [aux_sym_preproc_if_token1] = ACTIONS(2392),
    [aux_sym_preproc_if_token2] = ACTIONS(2392),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2392),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2392),
    [sym_preproc_directive] = ACTIONS(2392),
    [anon_sym_LPAREN2] = ACTIONS(2394),
    [anon_sym_BANG] = ACTIONS(2394),
    [anon_sym_TILDE] = ACTIONS(2394),
    [anon_sym_DASH] = ACTIONS(2392),
    [anon_sym_PLUS] = ACTIONS(2392),
    [anon_sym_STAR] = ACTIONS(2394),
    [anon_sym_AMP_AMP] = ACTIONS(2394),
    [anon_sym_AMP] = ACTIONS(2392),
    [anon_sym_SEMI] = ACTIONS(2394),
    [anon_sym___extension__] = ACTIONS(2392),
    [anon_sym_typedef] = ACTIONS(2392),
    [anon_sym___device__] = ACTIONS(2392),
    [anon_sym___host__] = ACTIONS(2392),
    [anon_sym___global__] = ACTIONS(2392),
    [anon_sym___forceinline__] = ACTIONS(2392),
    [anon_sym___noinline__] = ACTIONS(2392),
    [anon_sym_extern] = ACTIONS(2392),
    [anon_sym___attribute__] = ACTIONS(2392),
    [anon_sym_COLON_COLON] = ACTIONS(2394),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2394),
    [anon_sym___declspec] = ACTIONS(2392),
    [anon_sym___based] = ACTIONS(2392),
    [anon_sym___cdecl] = ACTIONS(2392),
    [anon_sym___clrcall] = ACTIONS(2392),
    [anon_sym___stdcall] = ACTIONS(2392),
    [anon_sym___fastcall] = ACTIONS(2392),
    [anon_sym___thiscall] = ACTIONS(2392),
    [anon_sym___vectorcall] = ACTIONS(2392),
    [anon_sym_LBRACE] = ACTIONS(2394),
    [anon_sym_signed] = ACTIONS(2392),
    [anon_sym_unsigned] = ACTIONS(2392),
    [anon_sym_long] = ACTIONS(2392),
    [anon_sym_short] = ACTIONS(2392),
    [anon_sym_LBRACK] = ACTIONS(2392),
    [anon_sym_static] = ACTIONS(2392),
    [anon_sym_register] = ACTIONS(2392),
    [anon_sym_inline] = ACTIONS(2392),
    [anon_sym___inline] = ACTIONS(2392),
    [anon_sym___inline__] = ACTIONS(2392),
    [anon_sym___forceinline] = ACTIONS(2392),
    [anon_sym_thread_local] = ACTIONS(2392),
    [anon_sym___thread] = ACTIONS(2392),
    [anon_sym_const] = ACTIONS(2392),
    [anon_sym_constexpr] = ACTIONS(2392),
    [anon_sym_volatile] = ACTIONS(2392),
    [anon_sym_restrict] = ACTIONS(2392),
    [anon_sym___restrict__] = ACTIONS(2392),
    [anon_sym__Atomic] = ACTIONS(2392),
    [anon_sym__Noreturn] = ACTIONS(2392),
    [anon_sym_noreturn] = ACTIONS(2392),
    [anon_sym_mutable] = ACTIONS(2392),
    [anon_sym_constinit] = ACTIONS(2392),
    [anon_sym_consteval] = ACTIONS(2392),
    [anon_sym___shared__] = ACTIONS(2392),
    [anon_sym___local__] = ACTIONS(2392),
    [anon_sym___constant__] = ACTIONS(2392),
    [anon_sym___managed__] = ACTIONS(2392),
    [anon_sym___grid_constant__] = ACTIONS(2392),
    [anon_sym_alignas] = ACTIONS(2392),
    [anon_sym__Alignas] = ACTIONS(2392),
    [sym_primitive_type] = ACTIONS(2392),
    [anon_sym_enum] = ACTIONS(2392),
    [anon_sym_class] = ACTIONS(2392),
    [anon_sym_struct] = ACTIONS(2392),
    [anon_sym_union] = ACTIONS(2392),
    [anon_sym_if] = ACTIONS(2392),
    [anon_sym_switch] = ACTIONS(2392),
    [anon_sym_case] = ACTIONS(2392),
    [anon_sym_default] = ACTIONS(2392),
    [anon_sym_while] = ACTIONS(2392),
    [anon_sym_do] = ACTIONS(2392),
    [anon_sym_for] = ACTIONS(2392),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_break] = ACTIONS(2392),
    [anon_sym_continue] = ACTIONS(2392),
    [anon_sym_goto] = ACTIONS(2392),
    [anon_sym___try] = ACTIONS(2392),
    [anon_sym___leave] = ACTIONS(2392),
    [anon_sym_not] = ACTIONS(2392),
    [anon_sym_compl] = ACTIONS(2392),
    [anon_sym_DASH_DASH] = ACTIONS(2394),
    [anon_sym_PLUS_PLUS] = ACTIONS(2394),
    [anon_sym_sizeof] = ACTIONS(2392),
    [anon_sym___alignof__] = ACTIONS(2392),
    [anon_sym___alignof] = ACTIONS(2392),
    [anon_sym__alignof] = ACTIONS(2392),
    [anon_sym_alignof] = ACTIONS(2392),
    [anon_sym__Alignof] = ACTIONS(2392),
    [anon_sym_offsetof] = ACTIONS(2392),
    [anon_sym__Generic] = ACTIONS(2392),
    [anon_sym_asm] = ACTIONS(2392),
    [anon_sym___asm__] = ACTIONS(2392),
    [sym_number_literal] = ACTIONS(2394),
    [anon_sym_L_SQUOTE] = ACTIONS(2394),
    [anon_sym_u_SQUOTE] = ACTIONS(2394),
    [anon_sym_U_SQUOTE] = ACTIONS(2394),
    [anon_sym_u8_SQUOTE] = ACTIONS(2394),
    [anon_sym_SQUOTE] = ACTIONS(2394),
    [anon_sym_L_DQUOTE] = ACTIONS(2394),
    [anon_sym_u_DQUOTE] = ACTIONS(2394),
    [anon_sym_U_DQUOTE] = ACTIONS(2394),
    [anon_sym_u8_DQUOTE] = ACTIONS(2394),
    [anon_sym_DQUOTE] = ACTIONS(2394),
    [sym_true] = ACTIONS(2392),
    [sym_false] = ACTIONS(2392),
    [anon_sym_NULL] = ACTIONS(2392),
    [anon_sym_nullptr] = ACTIONS(2392),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2392),
    [anon_sym_decltype] = ACTIONS(2392),
    [sym_virtual] = ACTIONS(2392),
    [anon_sym_explicit] = ACTIONS(2392),
    [anon_sym_typename] = ACTIONS(2392),
    [anon_sym_template] = ACTIONS(2392),
    [anon_sym_operator] = ACTIONS(2392),
    [anon_sym_try] = ACTIONS(2392),
    [anon_sym_delete] = ACTIONS(2392),
    [anon_sym_throw] = ACTIONS(2392),
    [anon_sym_namespace] = ACTIONS(2392),
    [anon_sym_using] = ACTIONS(2392),
    [anon_sym_static_assert] = ACTIONS(2392),
    [anon_sym_concept] = ACTIONS(2392),
    [anon_sym_co_return] = ACTIONS(2392),
    [anon_sym_co_yield] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2394),
    [anon_sym_LR_DQUOTE] = ACTIONS(2394),
    [anon_sym_uR_DQUOTE] = ACTIONS(2394),
    [anon_sym_UR_DQUOTE] = ACTIONS(2394),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2394),
    [anon_sym_co_await] = ACTIONS(2392),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2392),
    [sym_this] = ACTIONS(2392),
    [anon_sym___launch_bounds__] = ACTIONS(2392),
  },
  [503] = {
    [sym_identifier] = ACTIONS(2396),
    [aux_sym_preproc_include_token1] = ACTIONS(2396),
    [aux_sym_preproc_def_token1] = ACTIONS(2396),
    [aux_sym_preproc_if_token1] = ACTIONS(2396),
    [aux_sym_preproc_if_token2] = ACTIONS(2396),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2396),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2396),
    [sym_preproc_directive] = ACTIONS(2396),
    [anon_sym_LPAREN2] = ACTIONS(2398),
    [anon_sym_BANG] = ACTIONS(2398),
    [anon_sym_TILDE] = ACTIONS(2398),
    [anon_sym_DASH] = ACTIONS(2396),
    [anon_sym_PLUS] = ACTIONS(2396),
    [anon_sym_STAR] = ACTIONS(2398),
    [anon_sym_AMP_AMP] = ACTIONS(2398),
    [anon_sym_AMP] = ACTIONS(2396),
    [anon_sym_SEMI] = ACTIONS(2398),
    [anon_sym___extension__] = ACTIONS(2396),
    [anon_sym_typedef] = ACTIONS(2396),
    [anon_sym___device__] = ACTIONS(2396),
    [anon_sym___host__] = ACTIONS(2396),
    [anon_sym___global__] = ACTIONS(2396),
    [anon_sym___forceinline__] = ACTIONS(2396),
    [anon_sym___noinline__] = ACTIONS(2396),
    [anon_sym_extern] = ACTIONS(2396),
    [anon_sym___attribute__] = ACTIONS(2396),
    [anon_sym_COLON_COLON] = ACTIONS(2398),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2398),
    [anon_sym___declspec] = ACTIONS(2396),
    [anon_sym___based] = ACTIONS(2396),
    [anon_sym___cdecl] = ACTIONS(2396),
    [anon_sym___clrcall] = ACTIONS(2396),
    [anon_sym___stdcall] = ACTIONS(2396),
    [anon_sym___fastcall] = ACTIONS(2396),
    [anon_sym___thiscall] = ACTIONS(2396),
    [anon_sym___vectorcall] = ACTIONS(2396),
    [anon_sym_LBRACE] = ACTIONS(2398),
    [anon_sym_signed] = ACTIONS(2396),
    [anon_sym_unsigned] = ACTIONS(2396),
    [anon_sym_long] = ACTIONS(2396),
    [anon_sym_short] = ACTIONS(2396),
    [anon_sym_LBRACK] = ACTIONS(2396),
    [anon_sym_static] = ACTIONS(2396),
    [anon_sym_register] = ACTIONS(2396),
    [anon_sym_inline] = ACTIONS(2396),
    [anon_sym___inline] = ACTIONS(2396),
    [anon_sym___inline__] = ACTIONS(2396),
    [anon_sym___forceinline] = ACTIONS(2396),
    [anon_sym_thread_local] = ACTIONS(2396),
    [anon_sym___thread] = ACTIONS(2396),
    [anon_sym_const] = ACTIONS(2396),
    [anon_sym_constexpr] = ACTIONS(2396),
    [anon_sym_volatile] = ACTIONS(2396),
    [anon_sym_restrict] = ACTIONS(2396),
    [anon_sym___restrict__] = ACTIONS(2396),
    [anon_sym__Atomic] = ACTIONS(2396),
    [anon_sym__Noreturn] = ACTIONS(2396),
    [anon_sym_noreturn] = ACTIONS(2396),
    [anon_sym_mutable] = ACTIONS(2396),
    [anon_sym_constinit] = ACTIONS(2396),
    [anon_sym_consteval] = ACTIONS(2396),
    [anon_sym___shared__] = ACTIONS(2396),
    [anon_sym___local__] = ACTIONS(2396),
    [anon_sym___constant__] = ACTIONS(2396),
    [anon_sym___managed__] = ACTIONS(2396),
    [anon_sym___grid_constant__] = ACTIONS(2396),
    [anon_sym_alignas] = ACTIONS(2396),
    [anon_sym__Alignas] = ACTIONS(2396),
    [sym_primitive_type] = ACTIONS(2396),
    [anon_sym_enum] = ACTIONS(2396),
    [anon_sym_class] = ACTIONS(2396),
    [anon_sym_struct] = ACTIONS(2396),
    [anon_sym_union] = ACTIONS(2396),
    [anon_sym_if] = ACTIONS(2396),
    [anon_sym_switch] = ACTIONS(2396),
    [anon_sym_case] = ACTIONS(2396),
    [anon_sym_default] = ACTIONS(2396),
    [anon_sym_while] = ACTIONS(2396),
    [anon_sym_do] = ACTIONS(2396),
    [anon_sym_for] = ACTIONS(2396),
    [anon_sym_return] = ACTIONS(2396),
    [anon_sym_break] = ACTIONS(2396),
    [anon_sym_continue] = ACTIONS(2396),
    [anon_sym_goto] = ACTIONS(2396),
    [anon_sym___try] = ACTIONS(2396),
    [anon_sym___leave] = ACTIONS(2396),
    [anon_sym_not] = ACTIONS(2396),
    [anon_sym_compl] = ACTIONS(2396),
    [anon_sym_DASH_DASH] = ACTIONS(2398),
    [anon_sym_PLUS_PLUS] = ACTIONS(2398),
    [anon_sym_sizeof] = ACTIONS(2396),
    [anon_sym___alignof__] = ACTIONS(2396),
    [anon_sym___alignof] = ACTIONS(2396),
    [anon_sym__alignof] = ACTIONS(2396),
    [anon_sym_alignof] = ACTIONS(2396),
    [anon_sym__Alignof] = ACTIONS(2396),
    [anon_sym_offsetof] = ACTIONS(2396),
    [anon_sym__Generic] = ACTIONS(2396),
    [anon_sym_asm] = ACTIONS(2396),
    [anon_sym___asm__] = ACTIONS(2396),
    [sym_number_literal] = ACTIONS(2398),
    [anon_sym_L_SQUOTE] = ACTIONS(2398),
    [anon_sym_u_SQUOTE] = ACTIONS(2398),
    [anon_sym_U_SQUOTE] = ACTIONS(2398),
    [anon_sym_u8_SQUOTE] = ACTIONS(2398),
    [anon_sym_SQUOTE] = ACTIONS(2398),
    [anon_sym_L_DQUOTE] = ACTIONS(2398),
    [anon_sym_u_DQUOTE] = ACTIONS(2398),
    [anon_sym_U_DQUOTE] = ACTIONS(2398),
    [anon_sym_u8_DQUOTE] = ACTIONS(2398),
    [anon_sym_DQUOTE] = ACTIONS(2398),
    [sym_true] = ACTIONS(2396),
    [sym_false] = ACTIONS(2396),
    [anon_sym_NULL] = ACTIONS(2396),
    [anon_sym_nullptr] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2396),
    [anon_sym_decltype] = ACTIONS(2396),
    [sym_virtual] = ACTIONS(2396),
    [anon_sym_explicit] = ACTIONS(2396),
    [anon_sym_typename] = ACTIONS(2396),
    [anon_sym_template] = ACTIONS(2396),
    [anon_sym_operator] = ACTIONS(2396),
    [anon_sym_try] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_throw] = ACTIONS(2396),
    [anon_sym_namespace] = ACTIONS(2396),
    [anon_sym_using] = ACTIONS(2396),
    [anon_sym_static_assert] = ACTIONS(2396),
    [anon_sym_concept] = ACTIONS(2396),
    [anon_sym_co_return] = ACTIONS(2396),
    [anon_sym_co_yield] = ACTIONS(2396),
    [anon_sym_R_DQUOTE] = ACTIONS(2398),
    [anon_sym_LR_DQUOTE] = ACTIONS(2398),
    [anon_sym_uR_DQUOTE] = ACTIONS(2398),
    [anon_sym_UR_DQUOTE] = ACTIONS(2398),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2398),
    [anon_sym_co_await] = ACTIONS(2396),
    [anon_sym_new] = ACTIONS(2396),
    [anon_sym_requires] = ACTIONS(2396),
    [sym_this] = ACTIONS(2396),
    [anon_sym___launch_bounds__] = ACTIONS(2396),
  },
  [504] = {
    [sym_identifier] = ACTIONS(2247),
    [aux_sym_preproc_include_token1] = ACTIONS(2247),
    [aux_sym_preproc_def_token1] = ACTIONS(2247),
    [aux_sym_preproc_if_token1] = ACTIONS(2247),
    [aux_sym_preproc_if_token2] = ACTIONS(2247),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2247),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2247),
    [sym_preproc_directive] = ACTIONS(2247),
    [anon_sym_LPAREN2] = ACTIONS(2249),
    [anon_sym_BANG] = ACTIONS(2249),
    [anon_sym_TILDE] = ACTIONS(2249),
    [anon_sym_DASH] = ACTIONS(2247),
    [anon_sym_PLUS] = ACTIONS(2247),
    [anon_sym_STAR] = ACTIONS(2249),
    [anon_sym_AMP_AMP] = ACTIONS(2249),
    [anon_sym_AMP] = ACTIONS(2247),
    [anon_sym_SEMI] = ACTIONS(2249),
    [anon_sym___extension__] = ACTIONS(2247),
    [anon_sym_typedef] = ACTIONS(2247),
    [anon_sym___device__] = ACTIONS(2247),
    [anon_sym___host__] = ACTIONS(2247),
    [anon_sym___global__] = ACTIONS(2247),
    [anon_sym___forceinline__] = ACTIONS(2247),
    [anon_sym___noinline__] = ACTIONS(2247),
    [anon_sym_extern] = ACTIONS(2247),
    [anon_sym___attribute__] = ACTIONS(2247),
    [anon_sym_COLON_COLON] = ACTIONS(2249),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2249),
    [anon_sym___declspec] = ACTIONS(2247),
    [anon_sym___based] = ACTIONS(2247),
    [anon_sym___cdecl] = ACTIONS(2247),
    [anon_sym___clrcall] = ACTIONS(2247),
    [anon_sym___stdcall] = ACTIONS(2247),
    [anon_sym___fastcall] = ACTIONS(2247),
    [anon_sym___thiscall] = ACTIONS(2247),
    [anon_sym___vectorcall] = ACTIONS(2247),
    [anon_sym_LBRACE] = ACTIONS(2249),
    [anon_sym_signed] = ACTIONS(2247),
    [anon_sym_unsigned] = ACTIONS(2247),
    [anon_sym_long] = ACTIONS(2247),
    [anon_sym_short] = ACTIONS(2247),
    [anon_sym_LBRACK] = ACTIONS(2247),
    [anon_sym_static] = ACTIONS(2247),
    [anon_sym_register] = ACTIONS(2247),
    [anon_sym_inline] = ACTIONS(2247),
    [anon_sym___inline] = ACTIONS(2247),
    [anon_sym___inline__] = ACTIONS(2247),
    [anon_sym___forceinline] = ACTIONS(2247),
    [anon_sym_thread_local] = ACTIONS(2247),
    [anon_sym___thread] = ACTIONS(2247),
    [anon_sym_const] = ACTIONS(2247),
    [anon_sym_constexpr] = ACTIONS(2247),
    [anon_sym_volatile] = ACTIONS(2247),
    [anon_sym_restrict] = ACTIONS(2247),
    [anon_sym___restrict__] = ACTIONS(2247),
    [anon_sym__Atomic] = ACTIONS(2247),
    [anon_sym__Noreturn] = ACTIONS(2247),
    [anon_sym_noreturn] = ACTIONS(2247),
    [anon_sym_mutable] = ACTIONS(2247),
    [anon_sym_constinit] = ACTIONS(2247),
    [anon_sym_consteval] = ACTIONS(2247),
    [anon_sym___shared__] = ACTIONS(2247),
    [anon_sym___local__] = ACTIONS(2247),
    [anon_sym___constant__] = ACTIONS(2247),
    [anon_sym___managed__] = ACTIONS(2247),
    [anon_sym___grid_constant__] = ACTIONS(2247),
    [anon_sym_alignas] = ACTIONS(2247),
    [anon_sym__Alignas] = ACTIONS(2247),
    [sym_primitive_type] = ACTIONS(2247),
    [anon_sym_enum] = ACTIONS(2247),
    [anon_sym_class] = ACTIONS(2247),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_union] = ACTIONS(2247),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_switch] = ACTIONS(2247),
    [anon_sym_case] = ACTIONS(2247),
    [anon_sym_default] = ACTIONS(2247),
    [anon_sym_while] = ACTIONS(2247),
    [anon_sym_do] = ACTIONS(2247),
    [anon_sym_for] = ACTIONS(2247),
    [anon_sym_return] = ACTIONS(2247),
    [anon_sym_break] = ACTIONS(2247),
    [anon_sym_continue] = ACTIONS(2247),
    [anon_sym_goto] = ACTIONS(2247),
    [anon_sym___try] = ACTIONS(2247),
    [anon_sym___leave] = ACTIONS(2247),
    [anon_sym_not] = ACTIONS(2247),
    [anon_sym_compl] = ACTIONS(2247),
    [anon_sym_DASH_DASH] = ACTIONS(2249),
    [anon_sym_PLUS_PLUS] = ACTIONS(2249),
    [anon_sym_sizeof] = ACTIONS(2247),
    [anon_sym___alignof__] = ACTIONS(2247),
    [anon_sym___alignof] = ACTIONS(2247),
    [anon_sym__alignof] = ACTIONS(2247),
    [anon_sym_alignof] = ACTIONS(2247),
    [anon_sym__Alignof] = ACTIONS(2247),
    [anon_sym_offsetof] = ACTIONS(2247),
    [anon_sym__Generic] = ACTIONS(2247),
    [anon_sym_asm] = ACTIONS(2247),
    [anon_sym___asm__] = ACTIONS(2247),
    [sym_number_literal] = ACTIONS(2249),
    [anon_sym_L_SQUOTE] = ACTIONS(2249),
    [anon_sym_u_SQUOTE] = ACTIONS(2249),
    [anon_sym_U_SQUOTE] = ACTIONS(2249),
    [anon_sym_u8_SQUOTE] = ACTIONS(2249),
    [anon_sym_SQUOTE] = ACTIONS(2249),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_true] = ACTIONS(2247),
    [sym_false] = ACTIONS(2247),
    [anon_sym_NULL] = ACTIONS(2247),
    [anon_sym_nullptr] = ACTIONS(2247),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2247),
    [anon_sym_decltype] = ACTIONS(2247),
    [sym_virtual] = ACTIONS(2247),
    [anon_sym_explicit] = ACTIONS(2247),
    [anon_sym_typename] = ACTIONS(2247),
    [anon_sym_template] = ACTIONS(2247),
    [anon_sym_operator] = ACTIONS(2247),
    [anon_sym_try] = ACTIONS(2247),
    [anon_sym_delete] = ACTIONS(2247),
    [anon_sym_throw] = ACTIONS(2247),
    [anon_sym_namespace] = ACTIONS(2247),
    [anon_sym_using] = ACTIONS(2247),
    [anon_sym_static_assert] = ACTIONS(2247),
    [anon_sym_concept] = ACTIONS(2247),
    [anon_sym_co_return] = ACTIONS(2247),
    [anon_sym_co_yield] = ACTIONS(2247),
    [anon_sym_R_DQUOTE] = ACTIONS(2249),
    [anon_sym_LR_DQUOTE] = ACTIONS(2249),
    [anon_sym_uR_DQUOTE] = ACTIONS(2249),
    [anon_sym_UR_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2249),
    [anon_sym_co_await] = ACTIONS(2247),
    [anon_sym_new] = ACTIONS(2247),
    [anon_sym_requires] = ACTIONS(2247),
    [sym_this] = ACTIONS(2247),
    [anon_sym___launch_bounds__] = ACTIONS(2247),
  },
  [505] = {
    [sym_identifier] = ACTIONS(2461),
    [aux_sym_preproc_include_token1] = ACTIONS(2461),
    [aux_sym_preproc_def_token1] = ACTIONS(2461),
    [aux_sym_preproc_if_token1] = ACTIONS(2461),
    [aux_sym_preproc_if_token2] = ACTIONS(2461),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2461),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2461),
    [sym_preproc_directive] = ACTIONS(2461),
    [anon_sym_LPAREN2] = ACTIONS(2463),
    [anon_sym_BANG] = ACTIONS(2463),
    [anon_sym_TILDE] = ACTIONS(2463),
    [anon_sym_DASH] = ACTIONS(2461),
    [anon_sym_PLUS] = ACTIONS(2461),
    [anon_sym_STAR] = ACTIONS(2463),
    [anon_sym_AMP_AMP] = ACTIONS(2463),
    [anon_sym_AMP] = ACTIONS(2461),
    [anon_sym_SEMI] = ACTIONS(2463),
    [anon_sym___extension__] = ACTIONS(2461),
    [anon_sym_typedef] = ACTIONS(2461),
    [anon_sym___device__] = ACTIONS(2461),
    [anon_sym___host__] = ACTIONS(2461),
    [anon_sym___global__] = ACTIONS(2461),
    [anon_sym___forceinline__] = ACTIONS(2461),
    [anon_sym___noinline__] = ACTIONS(2461),
    [anon_sym_extern] = ACTIONS(2461),
    [anon_sym___attribute__] = ACTIONS(2461),
    [anon_sym_COLON_COLON] = ACTIONS(2463),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2463),
    [anon_sym___declspec] = ACTIONS(2461),
    [anon_sym___based] = ACTIONS(2461),
    [anon_sym___cdecl] = ACTIONS(2461),
    [anon_sym___clrcall] = ACTIONS(2461),
    [anon_sym___stdcall] = ACTIONS(2461),
    [anon_sym___fastcall] = ACTIONS(2461),
    [anon_sym___thiscall] = ACTIONS(2461),
    [anon_sym___vectorcall] = ACTIONS(2461),
    [anon_sym_LBRACE] = ACTIONS(2463),
    [anon_sym_signed] = ACTIONS(2461),
    [anon_sym_unsigned] = ACTIONS(2461),
    [anon_sym_long] = ACTIONS(2461),
    [anon_sym_short] = ACTIONS(2461),
    [anon_sym_LBRACK] = ACTIONS(2461),
    [anon_sym_static] = ACTIONS(2461),
    [anon_sym_register] = ACTIONS(2461),
    [anon_sym_inline] = ACTIONS(2461),
    [anon_sym___inline] = ACTIONS(2461),
    [anon_sym___inline__] = ACTIONS(2461),
    [anon_sym___forceinline] = ACTIONS(2461),
    [anon_sym_thread_local] = ACTIONS(2461),
    [anon_sym___thread] = ACTIONS(2461),
    [anon_sym_const] = ACTIONS(2461),
    [anon_sym_constexpr] = ACTIONS(2461),
    [anon_sym_volatile] = ACTIONS(2461),
    [anon_sym_restrict] = ACTIONS(2461),
    [anon_sym___restrict__] = ACTIONS(2461),
    [anon_sym__Atomic] = ACTIONS(2461),
    [anon_sym__Noreturn] = ACTIONS(2461),
    [anon_sym_noreturn] = ACTIONS(2461),
    [anon_sym_mutable] = ACTIONS(2461),
    [anon_sym_constinit] = ACTIONS(2461),
    [anon_sym_consteval] = ACTIONS(2461),
    [anon_sym___shared__] = ACTIONS(2461),
    [anon_sym___local__] = ACTIONS(2461),
    [anon_sym___constant__] = ACTIONS(2461),
    [anon_sym___managed__] = ACTIONS(2461),
    [anon_sym___grid_constant__] = ACTIONS(2461),
    [anon_sym_alignas] = ACTIONS(2461),
    [anon_sym__Alignas] = ACTIONS(2461),
    [sym_primitive_type] = ACTIONS(2461),
    [anon_sym_enum] = ACTIONS(2461),
    [anon_sym_class] = ACTIONS(2461),
    [anon_sym_struct] = ACTIONS(2461),
    [anon_sym_union] = ACTIONS(2461),
    [anon_sym_if] = ACTIONS(2461),
    [anon_sym_switch] = ACTIONS(2461),
    [anon_sym_case] = ACTIONS(2461),
    [anon_sym_default] = ACTIONS(2461),
    [anon_sym_while] = ACTIONS(2461),
    [anon_sym_do] = ACTIONS(2461),
    [anon_sym_for] = ACTIONS(2461),
    [anon_sym_return] = ACTIONS(2461),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_continue] = ACTIONS(2461),
    [anon_sym_goto] = ACTIONS(2461),
    [anon_sym___try] = ACTIONS(2461),
    [anon_sym___leave] = ACTIONS(2461),
    [anon_sym_not] = ACTIONS(2461),
    [anon_sym_compl] = ACTIONS(2461),
    [anon_sym_DASH_DASH] = ACTIONS(2463),
    [anon_sym_PLUS_PLUS] = ACTIONS(2463),
    [anon_sym_sizeof] = ACTIONS(2461),
    [anon_sym___alignof__] = ACTIONS(2461),
    [anon_sym___alignof] = ACTIONS(2461),
    [anon_sym__alignof] = ACTIONS(2461),
    [anon_sym_alignof] = ACTIONS(2461),
    [anon_sym__Alignof] = ACTIONS(2461),
    [anon_sym_offsetof] = ACTIONS(2461),
    [anon_sym__Generic] = ACTIONS(2461),
    [anon_sym_asm] = ACTIONS(2461),
    [anon_sym___asm__] = ACTIONS(2461),
    [sym_number_literal] = ACTIONS(2463),
    [anon_sym_L_SQUOTE] = ACTIONS(2463),
    [anon_sym_u_SQUOTE] = ACTIONS(2463),
    [anon_sym_U_SQUOTE] = ACTIONS(2463),
    [anon_sym_u8_SQUOTE] = ACTIONS(2463),
    [anon_sym_SQUOTE] = ACTIONS(2463),
    [anon_sym_L_DQUOTE] = ACTIONS(2463),
    [anon_sym_u_DQUOTE] = ACTIONS(2463),
    [anon_sym_U_DQUOTE] = ACTIONS(2463),
    [anon_sym_u8_DQUOTE] = ACTIONS(2463),
    [anon_sym_DQUOTE] = ACTIONS(2463),
    [sym_true] = ACTIONS(2461),
    [sym_false] = ACTIONS(2461),
    [anon_sym_NULL] = ACTIONS(2461),
    [anon_sym_nullptr] = ACTIONS(2461),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2461),
    [anon_sym_decltype] = ACTIONS(2461),
    [sym_virtual] = ACTIONS(2461),
    [anon_sym_explicit] = ACTIONS(2461),
    [anon_sym_typename] = ACTIONS(2461),
    [anon_sym_template] = ACTIONS(2461),
    [anon_sym_operator] = ACTIONS(2461),
    [anon_sym_try] = ACTIONS(2461),
    [anon_sym_delete] = ACTIONS(2461),
    [anon_sym_throw] = ACTIONS(2461),
    [anon_sym_namespace] = ACTIONS(2461),
    [anon_sym_using] = ACTIONS(2461),
    [anon_sym_static_assert] = ACTIONS(2461),
    [anon_sym_concept] = ACTIONS(2461),
    [anon_sym_co_return] = ACTIONS(2461),
    [anon_sym_co_yield] = ACTIONS(2461),
    [anon_sym_R_DQUOTE] = ACTIONS(2463),
    [anon_sym_LR_DQUOTE] = ACTIONS(2463),
    [anon_sym_uR_DQUOTE] = ACTIONS(2463),
    [anon_sym_UR_DQUOTE] = ACTIONS(2463),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2463),
    [anon_sym_co_await] = ACTIONS(2461),
    [anon_sym_new] = ACTIONS(2461),
    [anon_sym_requires] = ACTIONS(2461),
    [sym_this] = ACTIONS(2461),
    [anon_sym___launch_bounds__] = ACTIONS(2461),
  },
  [506] = {
    [sym_identifier] = ACTIONS(2312),
    [aux_sym_preproc_include_token1] = ACTIONS(2312),
    [aux_sym_preproc_def_token1] = ACTIONS(2312),
    [aux_sym_preproc_if_token1] = ACTIONS(2312),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2312),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2312),
    [sym_preproc_directive] = ACTIONS(2312),
    [anon_sym_LPAREN2] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2314),
    [anon_sym_TILDE] = ACTIONS(2314),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_AMP_AMP] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(2314),
    [anon_sym___extension__] = ACTIONS(2312),
    [anon_sym_typedef] = ACTIONS(2312),
    [anon_sym___device__] = ACTIONS(2312),
    [anon_sym___host__] = ACTIONS(2312),
    [anon_sym___global__] = ACTIONS(2312),
    [anon_sym___forceinline__] = ACTIONS(2312),
    [anon_sym___noinline__] = ACTIONS(2312),
    [anon_sym_extern] = ACTIONS(2312),
    [anon_sym___attribute__] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2314),
    [anon_sym___declspec] = ACTIONS(2312),
    [anon_sym___based] = ACTIONS(2312),
    [anon_sym___cdecl] = ACTIONS(2312),
    [anon_sym___clrcall] = ACTIONS(2312),
    [anon_sym___stdcall] = ACTIONS(2312),
    [anon_sym___fastcall] = ACTIONS(2312),
    [anon_sym___thiscall] = ACTIONS(2312),
    [anon_sym___vectorcall] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_RBRACE] = ACTIONS(2314),
    [anon_sym_signed] = ACTIONS(2312),
    [anon_sym_unsigned] = ACTIONS(2312),
    [anon_sym_long] = ACTIONS(2312),
    [anon_sym_short] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_register] = ACTIONS(2312),
    [anon_sym_inline] = ACTIONS(2312),
    [anon_sym___inline] = ACTIONS(2312),
    [anon_sym___inline__] = ACTIONS(2312),
    [anon_sym___forceinline] = ACTIONS(2312),
    [anon_sym_thread_local] = ACTIONS(2312),
    [anon_sym___thread] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_constexpr] = ACTIONS(2312),
    [anon_sym_volatile] = ACTIONS(2312),
    [anon_sym_restrict] = ACTIONS(2312),
    [anon_sym___restrict__] = ACTIONS(2312),
    [anon_sym__Atomic] = ACTIONS(2312),
    [anon_sym__Noreturn] = ACTIONS(2312),
    [anon_sym_noreturn] = ACTIONS(2312),
    [anon_sym_mutable] = ACTIONS(2312),
    [anon_sym_constinit] = ACTIONS(2312),
    [anon_sym_consteval] = ACTIONS(2312),
    [anon_sym___shared__] = ACTIONS(2312),
    [anon_sym___local__] = ACTIONS(2312),
    [anon_sym___constant__] = ACTIONS(2312),
    [anon_sym___managed__] = ACTIONS(2312),
    [anon_sym___grid_constant__] = ACTIONS(2312),
    [anon_sym_alignas] = ACTIONS(2312),
    [anon_sym__Alignas] = ACTIONS(2312),
    [sym_primitive_type] = ACTIONS(2312),
    [anon_sym_enum] = ACTIONS(2312),
    [anon_sym_class] = ACTIONS(2312),
    [anon_sym_struct] = ACTIONS(2312),
    [anon_sym_union] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_switch] = ACTIONS(2312),
    [anon_sym_case] = ACTIONS(2312),
    [anon_sym_default] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_break] = ACTIONS(2312),
    [anon_sym_continue] = ACTIONS(2312),
    [anon_sym_goto] = ACTIONS(2312),
    [anon_sym___try] = ACTIONS(2312),
    [anon_sym___leave] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2312),
    [anon_sym_compl] = ACTIONS(2312),
    [anon_sym_DASH_DASH] = ACTIONS(2314),
    [anon_sym_PLUS_PLUS] = ACTIONS(2314),
    [anon_sym_sizeof] = ACTIONS(2312),
    [anon_sym___alignof__] = ACTIONS(2312),
    [anon_sym___alignof] = ACTIONS(2312),
    [anon_sym__alignof] = ACTIONS(2312),
    [anon_sym_alignof] = ACTIONS(2312),
    [anon_sym__Alignof] = ACTIONS(2312),
    [anon_sym_offsetof] = ACTIONS(2312),
    [anon_sym__Generic] = ACTIONS(2312),
    [anon_sym_asm] = ACTIONS(2312),
    [anon_sym___asm__] = ACTIONS(2312),
    [sym_number_literal] = ACTIONS(2314),
    [anon_sym_L_SQUOTE] = ACTIONS(2314),
    [anon_sym_u_SQUOTE] = ACTIONS(2314),
    [anon_sym_U_SQUOTE] = ACTIONS(2314),
    [anon_sym_u8_SQUOTE] = ACTIONS(2314),
    [anon_sym_SQUOTE] = ACTIONS(2314),
    [anon_sym_L_DQUOTE] = ACTIONS(2314),
    [anon_sym_u_DQUOTE] = ACTIONS(2314),
    [anon_sym_U_DQUOTE] = ACTIONS(2314),
    [anon_sym_u8_DQUOTE] = ACTIONS(2314),
    [anon_sym_DQUOTE] = ACTIONS(2314),
    [sym_true] = ACTIONS(2312),
    [sym_false] = ACTIONS(2312),
    [anon_sym_NULL] = ACTIONS(2312),
    [anon_sym_nullptr] = ACTIONS(2312),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2312),
    [anon_sym_decltype] = ACTIONS(2312),
    [sym_virtual] = ACTIONS(2312),
    [anon_sym_explicit] = ACTIONS(2312),
    [anon_sym_typename] = ACTIONS(2312),
    [anon_sym_template] = ACTIONS(2312),
    [anon_sym_operator] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_delete] = ACTIONS(2312),
    [anon_sym_throw] = ACTIONS(2312),
    [anon_sym_namespace] = ACTIONS(2312),
    [anon_sym_using] = ACTIONS(2312),
    [anon_sym_static_assert] = ACTIONS(2312),
    [anon_sym_concept] = ACTIONS(2312),
    [anon_sym_co_return] = ACTIONS(2312),
    [anon_sym_co_yield] = ACTIONS(2312),
    [anon_sym_R_DQUOTE] = ACTIONS(2314),
    [anon_sym_LR_DQUOTE] = ACTIONS(2314),
    [anon_sym_uR_DQUOTE] = ACTIONS(2314),
    [anon_sym_UR_DQUOTE] = ACTIONS(2314),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2314),
    [anon_sym_co_await] = ACTIONS(2312),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_requires] = ACTIONS(2312),
    [sym_this] = ACTIONS(2312),
    [anon_sym___launch_bounds__] = ACTIONS(2312),
  },
  [507] = {
    [sym_identifier] = ACTIONS(2504),
    [aux_sym_preproc_include_token1] = ACTIONS(2504),
    [aux_sym_preproc_def_token1] = ACTIONS(2504),
    [aux_sym_preproc_if_token1] = ACTIONS(2504),
    [aux_sym_preproc_if_token2] = ACTIONS(2504),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2504),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2504),
    [sym_preproc_directive] = ACTIONS(2504),
    [anon_sym_LPAREN2] = ACTIONS(2506),
    [anon_sym_BANG] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2506),
    [anon_sym_DASH] = ACTIONS(2504),
    [anon_sym_PLUS] = ACTIONS(2504),
    [anon_sym_STAR] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2504),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym___extension__] = ACTIONS(2504),
    [anon_sym_typedef] = ACTIONS(2504),
    [anon_sym___device__] = ACTIONS(2504),
    [anon_sym___host__] = ACTIONS(2504),
    [anon_sym___global__] = ACTIONS(2504),
    [anon_sym___forceinline__] = ACTIONS(2504),
    [anon_sym___noinline__] = ACTIONS(2504),
    [anon_sym_extern] = ACTIONS(2504),
    [anon_sym___attribute__] = ACTIONS(2504),
    [anon_sym_COLON_COLON] = ACTIONS(2506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2506),
    [anon_sym___declspec] = ACTIONS(2504),
    [anon_sym___based] = ACTIONS(2504),
    [anon_sym___cdecl] = ACTIONS(2504),
    [anon_sym___clrcall] = ACTIONS(2504),
    [anon_sym___stdcall] = ACTIONS(2504),
    [anon_sym___fastcall] = ACTIONS(2504),
    [anon_sym___thiscall] = ACTIONS(2504),
    [anon_sym___vectorcall] = ACTIONS(2504),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_signed] = ACTIONS(2504),
    [anon_sym_unsigned] = ACTIONS(2504),
    [anon_sym_long] = ACTIONS(2504),
    [anon_sym_short] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(2504),
    [anon_sym_static] = ACTIONS(2504),
    [anon_sym_register] = ACTIONS(2504),
    [anon_sym_inline] = ACTIONS(2504),
    [anon_sym___inline] = ACTIONS(2504),
    [anon_sym___inline__] = ACTIONS(2504),
    [anon_sym___forceinline] = ACTIONS(2504),
    [anon_sym_thread_local] = ACTIONS(2504),
    [anon_sym___thread] = ACTIONS(2504),
    [anon_sym_const] = ACTIONS(2504),
    [anon_sym_constexpr] = ACTIONS(2504),
    [anon_sym_volatile] = ACTIONS(2504),
    [anon_sym_restrict] = ACTIONS(2504),
    [anon_sym___restrict__] = ACTIONS(2504),
    [anon_sym__Atomic] = ACTIONS(2504),
    [anon_sym__Noreturn] = ACTIONS(2504),
    [anon_sym_noreturn] = ACTIONS(2504),
    [anon_sym_mutable] = ACTIONS(2504),
    [anon_sym_constinit] = ACTIONS(2504),
    [anon_sym_consteval] = ACTIONS(2504),
    [anon_sym___shared__] = ACTIONS(2504),
    [anon_sym___local__] = ACTIONS(2504),
    [anon_sym___constant__] = ACTIONS(2504),
    [anon_sym___managed__] = ACTIONS(2504),
    [anon_sym___grid_constant__] = ACTIONS(2504),
    [anon_sym_alignas] = ACTIONS(2504),
    [anon_sym__Alignas] = ACTIONS(2504),
    [sym_primitive_type] = ACTIONS(2504),
    [anon_sym_enum] = ACTIONS(2504),
    [anon_sym_class] = ACTIONS(2504),
    [anon_sym_struct] = ACTIONS(2504),
    [anon_sym_union] = ACTIONS(2504),
    [anon_sym_if] = ACTIONS(2504),
    [anon_sym_switch] = ACTIONS(2504),
    [anon_sym_case] = ACTIONS(2504),
    [anon_sym_default] = ACTIONS(2504),
    [anon_sym_while] = ACTIONS(2504),
    [anon_sym_do] = ACTIONS(2504),
    [anon_sym_for] = ACTIONS(2504),
    [anon_sym_return] = ACTIONS(2504),
    [anon_sym_break] = ACTIONS(2504),
    [anon_sym_continue] = ACTIONS(2504),
    [anon_sym_goto] = ACTIONS(2504),
    [anon_sym___try] = ACTIONS(2504),
    [anon_sym___leave] = ACTIONS(2504),
    [anon_sym_not] = ACTIONS(2504),
    [anon_sym_compl] = ACTIONS(2504),
    [anon_sym_DASH_DASH] = ACTIONS(2506),
    [anon_sym_PLUS_PLUS] = ACTIONS(2506),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(2504),
    [anon_sym___alignof] = ACTIONS(2504),
    [anon_sym__alignof] = ACTIONS(2504),
    [anon_sym_alignof] = ACTIONS(2504),
    [anon_sym__Alignof] = ACTIONS(2504),
    [anon_sym_offsetof] = ACTIONS(2504),
    [anon_sym__Generic] = ACTIONS(2504),
    [anon_sym_asm] = ACTIONS(2504),
    [anon_sym___asm__] = ACTIONS(2504),
    [sym_number_literal] = ACTIONS(2506),
    [anon_sym_L_SQUOTE] = ACTIONS(2506),
    [anon_sym_u_SQUOTE] = ACTIONS(2506),
    [anon_sym_U_SQUOTE] = ACTIONS(2506),
    [anon_sym_u8_SQUOTE] = ACTIONS(2506),
    [anon_sym_SQUOTE] = ACTIONS(2506),
    [anon_sym_L_DQUOTE] = ACTIONS(2506),
    [anon_sym_u_DQUOTE] = ACTIONS(2506),
    [anon_sym_U_DQUOTE] = ACTIONS(2506),
    [anon_sym_u8_DQUOTE] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [sym_true] = ACTIONS(2504),
    [sym_false] = ACTIONS(2504),
    [anon_sym_NULL] = ACTIONS(2504),
    [anon_sym_nullptr] = ACTIONS(2504),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2504),
    [anon_sym_decltype] = ACTIONS(2504),
    [sym_virtual] = ACTIONS(2504),
    [anon_sym_explicit] = ACTIONS(2504),
    [anon_sym_typename] = ACTIONS(2504),
    [anon_sym_template] = ACTIONS(2504),
    [anon_sym_operator] = ACTIONS(2504),
    [anon_sym_try] = ACTIONS(2504),
    [anon_sym_delete] = ACTIONS(2504),
    [anon_sym_throw] = ACTIONS(2504),
    [anon_sym_namespace] = ACTIONS(2504),
    [anon_sym_using] = ACTIONS(2504),
    [anon_sym_static_assert] = ACTIONS(2504),
    [anon_sym_concept] = ACTIONS(2504),
    [anon_sym_co_return] = ACTIONS(2504),
    [anon_sym_co_yield] = ACTIONS(2504),
    [anon_sym_R_DQUOTE] = ACTIONS(2506),
    [anon_sym_LR_DQUOTE] = ACTIONS(2506),
    [anon_sym_uR_DQUOTE] = ACTIONS(2506),
    [anon_sym_UR_DQUOTE] = ACTIONS(2506),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2506),
    [anon_sym_co_await] = ACTIONS(2504),
    [anon_sym_new] = ACTIONS(2504),
    [anon_sym_requires] = ACTIONS(2504),
    [sym_this] = ACTIONS(2504),
    [anon_sym___launch_bounds__] = ACTIONS(2504),
  },
  [508] = {
    [sym_type_qualifier] = STATE(3531),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4591),
    [sym_sized_type_specifier] = STATE(2599),
    [sym_enum_specifier] = STATE(2599),
    [sym_struct_specifier] = STATE(2599),
    [sym_union_specifier] = STATE(2599),
    [sym_expression] = STATE(4674),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_type_descriptor] = STATE(7303),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_placeholder_type_specifier] = STATE(2599),
    [sym_decltype_auto] = STATE(2598),
    [sym_decltype] = STATE(2477),
    [sym_class_specifier] = STATE(2599),
    [sym__class_name] = STATE(8015),
    [sym_dependent_type] = STATE(2599),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_type_parameter_pack_expansion] = STATE(7500),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5910),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [aux_sym__type_definition_type_repeat1] = STATE(3531),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2157),
    [sym_identifier] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2725),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2729),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2733),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2757),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2761),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_GT2] = ACTIONS(2781),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [509] = {
    [sym_identifier] = ACTIONS(2247),
    [aux_sym_preproc_include_token1] = ACTIONS(2247),
    [aux_sym_preproc_def_token1] = ACTIONS(2247),
    [aux_sym_preproc_if_token1] = ACTIONS(2247),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2247),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2247),
    [sym_preproc_directive] = ACTIONS(2247),
    [anon_sym_LPAREN2] = ACTIONS(2249),
    [anon_sym_BANG] = ACTIONS(2249),
    [anon_sym_TILDE] = ACTIONS(2249),
    [anon_sym_DASH] = ACTIONS(2247),
    [anon_sym_PLUS] = ACTIONS(2247),
    [anon_sym_STAR] = ACTIONS(2249),
    [anon_sym_AMP_AMP] = ACTIONS(2249),
    [anon_sym_AMP] = ACTIONS(2247),
    [anon_sym_SEMI] = ACTIONS(2249),
    [anon_sym___extension__] = ACTIONS(2247),
    [anon_sym_typedef] = ACTIONS(2247),
    [anon_sym___device__] = ACTIONS(2247),
    [anon_sym___host__] = ACTIONS(2247),
    [anon_sym___global__] = ACTIONS(2247),
    [anon_sym___forceinline__] = ACTIONS(2247),
    [anon_sym___noinline__] = ACTIONS(2247),
    [anon_sym_extern] = ACTIONS(2247),
    [anon_sym___attribute__] = ACTIONS(2247),
    [anon_sym_COLON_COLON] = ACTIONS(2249),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2249),
    [anon_sym___declspec] = ACTIONS(2247),
    [anon_sym___based] = ACTIONS(2247),
    [anon_sym___cdecl] = ACTIONS(2247),
    [anon_sym___clrcall] = ACTIONS(2247),
    [anon_sym___stdcall] = ACTIONS(2247),
    [anon_sym___fastcall] = ACTIONS(2247),
    [anon_sym___thiscall] = ACTIONS(2247),
    [anon_sym___vectorcall] = ACTIONS(2247),
    [anon_sym_LBRACE] = ACTIONS(2249),
    [anon_sym_RBRACE] = ACTIONS(2249),
    [anon_sym_signed] = ACTIONS(2247),
    [anon_sym_unsigned] = ACTIONS(2247),
    [anon_sym_long] = ACTIONS(2247),
    [anon_sym_short] = ACTIONS(2247),
    [anon_sym_LBRACK] = ACTIONS(2247),
    [anon_sym_static] = ACTIONS(2247),
    [anon_sym_register] = ACTIONS(2247),
    [anon_sym_inline] = ACTIONS(2247),
    [anon_sym___inline] = ACTIONS(2247),
    [anon_sym___inline__] = ACTIONS(2247),
    [anon_sym___forceinline] = ACTIONS(2247),
    [anon_sym_thread_local] = ACTIONS(2247),
    [anon_sym___thread] = ACTIONS(2247),
    [anon_sym_const] = ACTIONS(2247),
    [anon_sym_constexpr] = ACTIONS(2247),
    [anon_sym_volatile] = ACTIONS(2247),
    [anon_sym_restrict] = ACTIONS(2247),
    [anon_sym___restrict__] = ACTIONS(2247),
    [anon_sym__Atomic] = ACTIONS(2247),
    [anon_sym__Noreturn] = ACTIONS(2247),
    [anon_sym_noreturn] = ACTIONS(2247),
    [anon_sym_mutable] = ACTIONS(2247),
    [anon_sym_constinit] = ACTIONS(2247),
    [anon_sym_consteval] = ACTIONS(2247),
    [anon_sym___shared__] = ACTIONS(2247),
    [anon_sym___local__] = ACTIONS(2247),
    [anon_sym___constant__] = ACTIONS(2247),
    [anon_sym___managed__] = ACTIONS(2247),
    [anon_sym___grid_constant__] = ACTIONS(2247),
    [anon_sym_alignas] = ACTIONS(2247),
    [anon_sym__Alignas] = ACTIONS(2247),
    [sym_primitive_type] = ACTIONS(2247),
    [anon_sym_enum] = ACTIONS(2247),
    [anon_sym_class] = ACTIONS(2247),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_union] = ACTIONS(2247),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_switch] = ACTIONS(2247),
    [anon_sym_case] = ACTIONS(2247),
    [anon_sym_default] = ACTIONS(2247),
    [anon_sym_while] = ACTIONS(2247),
    [anon_sym_do] = ACTIONS(2247),
    [anon_sym_for] = ACTIONS(2247),
    [anon_sym_return] = ACTIONS(2247),
    [anon_sym_break] = ACTIONS(2247),
    [anon_sym_continue] = ACTIONS(2247),
    [anon_sym_goto] = ACTIONS(2247),
    [anon_sym___try] = ACTIONS(2247),
    [anon_sym___leave] = ACTIONS(2247),
    [anon_sym_not] = ACTIONS(2247),
    [anon_sym_compl] = ACTIONS(2247),
    [anon_sym_DASH_DASH] = ACTIONS(2249),
    [anon_sym_PLUS_PLUS] = ACTIONS(2249),
    [anon_sym_sizeof] = ACTIONS(2247),
    [anon_sym___alignof__] = ACTIONS(2247),
    [anon_sym___alignof] = ACTIONS(2247),
    [anon_sym__alignof] = ACTIONS(2247),
    [anon_sym_alignof] = ACTIONS(2247),
    [anon_sym__Alignof] = ACTIONS(2247),
    [anon_sym_offsetof] = ACTIONS(2247),
    [anon_sym__Generic] = ACTIONS(2247),
    [anon_sym_asm] = ACTIONS(2247),
    [anon_sym___asm__] = ACTIONS(2247),
    [sym_number_literal] = ACTIONS(2249),
    [anon_sym_L_SQUOTE] = ACTIONS(2249),
    [anon_sym_u_SQUOTE] = ACTIONS(2249),
    [anon_sym_U_SQUOTE] = ACTIONS(2249),
    [anon_sym_u8_SQUOTE] = ACTIONS(2249),
    [anon_sym_SQUOTE] = ACTIONS(2249),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_true] = ACTIONS(2247),
    [sym_false] = ACTIONS(2247),
    [anon_sym_NULL] = ACTIONS(2247),
    [anon_sym_nullptr] = ACTIONS(2247),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2247),
    [anon_sym_decltype] = ACTIONS(2247),
    [sym_virtual] = ACTIONS(2247),
    [anon_sym_explicit] = ACTIONS(2247),
    [anon_sym_typename] = ACTIONS(2247),
    [anon_sym_template] = ACTIONS(2247),
    [anon_sym_operator] = ACTIONS(2247),
    [anon_sym_try] = ACTIONS(2247),
    [anon_sym_delete] = ACTIONS(2247),
    [anon_sym_throw] = ACTIONS(2247),
    [anon_sym_namespace] = ACTIONS(2247),
    [anon_sym_using] = ACTIONS(2247),
    [anon_sym_static_assert] = ACTIONS(2247),
    [anon_sym_concept] = ACTIONS(2247),
    [anon_sym_co_return] = ACTIONS(2247),
    [anon_sym_co_yield] = ACTIONS(2247),
    [anon_sym_R_DQUOTE] = ACTIONS(2249),
    [anon_sym_LR_DQUOTE] = ACTIONS(2249),
    [anon_sym_uR_DQUOTE] = ACTIONS(2249),
    [anon_sym_UR_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2249),
    [anon_sym_co_await] = ACTIONS(2247),
    [anon_sym_new] = ACTIONS(2247),
    [anon_sym_requires] = ACTIONS(2247),
    [sym_this] = ACTIONS(2247),
    [anon_sym___launch_bounds__] = ACTIONS(2247),
  },
  [510] = {
    [sym_identifier] = ACTIONS(2477),
    [aux_sym_preproc_include_token1] = ACTIONS(2477),
    [aux_sym_preproc_def_token1] = ACTIONS(2477),
    [aux_sym_preproc_if_token1] = ACTIONS(2477),
    [aux_sym_preproc_if_token2] = ACTIONS(2477),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2477),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2477),
    [sym_preproc_directive] = ACTIONS(2477),
    [anon_sym_LPAREN2] = ACTIONS(2479),
    [anon_sym_BANG] = ACTIONS(2479),
    [anon_sym_TILDE] = ACTIONS(2479),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_STAR] = ACTIONS(2479),
    [anon_sym_AMP_AMP] = ACTIONS(2479),
    [anon_sym_AMP] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(2479),
    [anon_sym___extension__] = ACTIONS(2477),
    [anon_sym_typedef] = ACTIONS(2477),
    [anon_sym___device__] = ACTIONS(2477),
    [anon_sym___host__] = ACTIONS(2477),
    [anon_sym___global__] = ACTIONS(2477),
    [anon_sym___forceinline__] = ACTIONS(2477),
    [anon_sym___noinline__] = ACTIONS(2477),
    [anon_sym_extern] = ACTIONS(2477),
    [anon_sym___attribute__] = ACTIONS(2477),
    [anon_sym_COLON_COLON] = ACTIONS(2479),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2479),
    [anon_sym___declspec] = ACTIONS(2477),
    [anon_sym___based] = ACTIONS(2477),
    [anon_sym___cdecl] = ACTIONS(2477),
    [anon_sym___clrcall] = ACTIONS(2477),
    [anon_sym___stdcall] = ACTIONS(2477),
    [anon_sym___fastcall] = ACTIONS(2477),
    [anon_sym___thiscall] = ACTIONS(2477),
    [anon_sym___vectorcall] = ACTIONS(2477),
    [anon_sym_LBRACE] = ACTIONS(2479),
    [anon_sym_signed] = ACTIONS(2477),
    [anon_sym_unsigned] = ACTIONS(2477),
    [anon_sym_long] = ACTIONS(2477),
    [anon_sym_short] = ACTIONS(2477),
    [anon_sym_LBRACK] = ACTIONS(2477),
    [anon_sym_static] = ACTIONS(2477),
    [anon_sym_register] = ACTIONS(2477),
    [anon_sym_inline] = ACTIONS(2477),
    [anon_sym___inline] = ACTIONS(2477),
    [anon_sym___inline__] = ACTIONS(2477),
    [anon_sym___forceinline] = ACTIONS(2477),
    [anon_sym_thread_local] = ACTIONS(2477),
    [anon_sym___thread] = ACTIONS(2477),
    [anon_sym_const] = ACTIONS(2477),
    [anon_sym_constexpr] = ACTIONS(2477),
    [anon_sym_volatile] = ACTIONS(2477),
    [anon_sym_restrict] = ACTIONS(2477),
    [anon_sym___restrict__] = ACTIONS(2477),
    [anon_sym__Atomic] = ACTIONS(2477),
    [anon_sym__Noreturn] = ACTIONS(2477),
    [anon_sym_noreturn] = ACTIONS(2477),
    [anon_sym_mutable] = ACTIONS(2477),
    [anon_sym_constinit] = ACTIONS(2477),
    [anon_sym_consteval] = ACTIONS(2477),
    [anon_sym___shared__] = ACTIONS(2477),
    [anon_sym___local__] = ACTIONS(2477),
    [anon_sym___constant__] = ACTIONS(2477),
    [anon_sym___managed__] = ACTIONS(2477),
    [anon_sym___grid_constant__] = ACTIONS(2477),
    [anon_sym_alignas] = ACTIONS(2477),
    [anon_sym__Alignas] = ACTIONS(2477),
    [sym_primitive_type] = ACTIONS(2477),
    [anon_sym_enum] = ACTIONS(2477),
    [anon_sym_class] = ACTIONS(2477),
    [anon_sym_struct] = ACTIONS(2477),
    [anon_sym_union] = ACTIONS(2477),
    [anon_sym_if] = ACTIONS(2477),
    [anon_sym_switch] = ACTIONS(2477),
    [anon_sym_case] = ACTIONS(2477),
    [anon_sym_default] = ACTIONS(2477),
    [anon_sym_while] = ACTIONS(2477),
    [anon_sym_do] = ACTIONS(2477),
    [anon_sym_for] = ACTIONS(2477),
    [anon_sym_return] = ACTIONS(2477),
    [anon_sym_break] = ACTIONS(2477),
    [anon_sym_continue] = ACTIONS(2477),
    [anon_sym_goto] = ACTIONS(2477),
    [anon_sym___try] = ACTIONS(2477),
    [anon_sym___leave] = ACTIONS(2477),
    [anon_sym_not] = ACTIONS(2477),
    [anon_sym_compl] = ACTIONS(2477),
    [anon_sym_DASH_DASH] = ACTIONS(2479),
    [anon_sym_PLUS_PLUS] = ACTIONS(2479),
    [anon_sym_sizeof] = ACTIONS(2477),
    [anon_sym___alignof__] = ACTIONS(2477),
    [anon_sym___alignof] = ACTIONS(2477),
    [anon_sym__alignof] = ACTIONS(2477),
    [anon_sym_alignof] = ACTIONS(2477),
    [anon_sym__Alignof] = ACTIONS(2477),
    [anon_sym_offsetof] = ACTIONS(2477),
    [anon_sym__Generic] = ACTIONS(2477),
    [anon_sym_asm] = ACTIONS(2477),
    [anon_sym___asm__] = ACTIONS(2477),
    [sym_number_literal] = ACTIONS(2479),
    [anon_sym_L_SQUOTE] = ACTIONS(2479),
    [anon_sym_u_SQUOTE] = ACTIONS(2479),
    [anon_sym_U_SQUOTE] = ACTIONS(2479),
    [anon_sym_u8_SQUOTE] = ACTIONS(2479),
    [anon_sym_SQUOTE] = ACTIONS(2479),
    [anon_sym_L_DQUOTE] = ACTIONS(2479),
    [anon_sym_u_DQUOTE] = ACTIONS(2479),
    [anon_sym_U_DQUOTE] = ACTIONS(2479),
    [anon_sym_u8_DQUOTE] = ACTIONS(2479),
    [anon_sym_DQUOTE] = ACTIONS(2479),
    [sym_true] = ACTIONS(2477),
    [sym_false] = ACTIONS(2477),
    [anon_sym_NULL] = ACTIONS(2477),
    [anon_sym_nullptr] = ACTIONS(2477),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2477),
    [anon_sym_decltype] = ACTIONS(2477),
    [sym_virtual] = ACTIONS(2477),
    [anon_sym_explicit] = ACTIONS(2477),
    [anon_sym_typename] = ACTIONS(2477),
    [anon_sym_template] = ACTIONS(2477),
    [anon_sym_operator] = ACTIONS(2477),
    [anon_sym_try] = ACTIONS(2477),
    [anon_sym_delete] = ACTIONS(2477),
    [anon_sym_throw] = ACTIONS(2477),
    [anon_sym_namespace] = ACTIONS(2477),
    [anon_sym_using] = ACTIONS(2477),
    [anon_sym_static_assert] = ACTIONS(2477),
    [anon_sym_concept] = ACTIONS(2477),
    [anon_sym_co_return] = ACTIONS(2477),
    [anon_sym_co_yield] = ACTIONS(2477),
    [anon_sym_R_DQUOTE] = ACTIONS(2479),
    [anon_sym_LR_DQUOTE] = ACTIONS(2479),
    [anon_sym_uR_DQUOTE] = ACTIONS(2479),
    [anon_sym_UR_DQUOTE] = ACTIONS(2479),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2479),
    [anon_sym_co_await] = ACTIONS(2477),
    [anon_sym_new] = ACTIONS(2477),
    [anon_sym_requires] = ACTIONS(2477),
    [sym_this] = ACTIONS(2477),
    [anon_sym___launch_bounds__] = ACTIONS(2477),
  },
  [511] = {
    [sym_identifier] = ACTIONS(2243),
    [aux_sym_preproc_include_token1] = ACTIONS(2243),
    [aux_sym_preproc_def_token1] = ACTIONS(2243),
    [aux_sym_preproc_if_token1] = ACTIONS(2243),
    [aux_sym_preproc_if_token2] = ACTIONS(2243),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2243),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2243),
    [sym_preproc_directive] = ACTIONS(2243),
    [anon_sym_LPAREN2] = ACTIONS(2245),
    [anon_sym_BANG] = ACTIONS(2245),
    [anon_sym_TILDE] = ACTIONS(2245),
    [anon_sym_DASH] = ACTIONS(2243),
    [anon_sym_PLUS] = ACTIONS(2243),
    [anon_sym_STAR] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2245),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_SEMI] = ACTIONS(2245),
    [anon_sym___extension__] = ACTIONS(2243),
    [anon_sym_typedef] = ACTIONS(2243),
    [anon_sym___device__] = ACTIONS(2243),
    [anon_sym___host__] = ACTIONS(2243),
    [anon_sym___global__] = ACTIONS(2243),
    [anon_sym___forceinline__] = ACTIONS(2243),
    [anon_sym___noinline__] = ACTIONS(2243),
    [anon_sym_extern] = ACTIONS(2243),
    [anon_sym___attribute__] = ACTIONS(2243),
    [anon_sym_COLON_COLON] = ACTIONS(2245),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2245),
    [anon_sym___declspec] = ACTIONS(2243),
    [anon_sym___based] = ACTIONS(2243),
    [anon_sym___cdecl] = ACTIONS(2243),
    [anon_sym___clrcall] = ACTIONS(2243),
    [anon_sym___stdcall] = ACTIONS(2243),
    [anon_sym___fastcall] = ACTIONS(2243),
    [anon_sym___thiscall] = ACTIONS(2243),
    [anon_sym___vectorcall] = ACTIONS(2243),
    [anon_sym_LBRACE] = ACTIONS(2245),
    [anon_sym_signed] = ACTIONS(2243),
    [anon_sym_unsigned] = ACTIONS(2243),
    [anon_sym_long] = ACTIONS(2243),
    [anon_sym_short] = ACTIONS(2243),
    [anon_sym_LBRACK] = ACTIONS(2243),
    [anon_sym_static] = ACTIONS(2243),
    [anon_sym_register] = ACTIONS(2243),
    [anon_sym_inline] = ACTIONS(2243),
    [anon_sym___inline] = ACTIONS(2243),
    [anon_sym___inline__] = ACTIONS(2243),
    [anon_sym___forceinline] = ACTIONS(2243),
    [anon_sym_thread_local] = ACTIONS(2243),
    [anon_sym___thread] = ACTIONS(2243),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2243),
    [anon_sym_volatile] = ACTIONS(2243),
    [anon_sym_restrict] = ACTIONS(2243),
    [anon_sym___restrict__] = ACTIONS(2243),
    [anon_sym__Atomic] = ACTIONS(2243),
    [anon_sym__Noreturn] = ACTIONS(2243),
    [anon_sym_noreturn] = ACTIONS(2243),
    [anon_sym_mutable] = ACTIONS(2243),
    [anon_sym_constinit] = ACTIONS(2243),
    [anon_sym_consteval] = ACTIONS(2243),
    [anon_sym___shared__] = ACTIONS(2243),
    [anon_sym___local__] = ACTIONS(2243),
    [anon_sym___constant__] = ACTIONS(2243),
    [anon_sym___managed__] = ACTIONS(2243),
    [anon_sym___grid_constant__] = ACTIONS(2243),
    [anon_sym_alignas] = ACTIONS(2243),
    [anon_sym__Alignas] = ACTIONS(2243),
    [sym_primitive_type] = ACTIONS(2243),
    [anon_sym_enum] = ACTIONS(2243),
    [anon_sym_class] = ACTIONS(2243),
    [anon_sym_struct] = ACTIONS(2243),
    [anon_sym_union] = ACTIONS(2243),
    [anon_sym_if] = ACTIONS(2243),
    [anon_sym_switch] = ACTIONS(2243),
    [anon_sym_case] = ACTIONS(2243),
    [anon_sym_default] = ACTIONS(2243),
    [anon_sym_while] = ACTIONS(2243),
    [anon_sym_do] = ACTIONS(2243),
    [anon_sym_for] = ACTIONS(2243),
    [anon_sym_return] = ACTIONS(2243),
    [anon_sym_break] = ACTIONS(2243),
    [anon_sym_continue] = ACTIONS(2243),
    [anon_sym_goto] = ACTIONS(2243),
    [anon_sym___try] = ACTIONS(2243),
    [anon_sym___leave] = ACTIONS(2243),
    [anon_sym_not] = ACTIONS(2243),
    [anon_sym_compl] = ACTIONS(2243),
    [anon_sym_DASH_DASH] = ACTIONS(2245),
    [anon_sym_PLUS_PLUS] = ACTIONS(2245),
    [anon_sym_sizeof] = ACTIONS(2243),
    [anon_sym___alignof__] = ACTIONS(2243),
    [anon_sym___alignof] = ACTIONS(2243),
    [anon_sym__alignof] = ACTIONS(2243),
    [anon_sym_alignof] = ACTIONS(2243),
    [anon_sym__Alignof] = ACTIONS(2243),
    [anon_sym_offsetof] = ACTIONS(2243),
    [anon_sym__Generic] = ACTIONS(2243),
    [anon_sym_asm] = ACTIONS(2243),
    [anon_sym___asm__] = ACTIONS(2243),
    [sym_number_literal] = ACTIONS(2245),
    [anon_sym_L_SQUOTE] = ACTIONS(2245),
    [anon_sym_u_SQUOTE] = ACTIONS(2245),
    [anon_sym_U_SQUOTE] = ACTIONS(2245),
    [anon_sym_u8_SQUOTE] = ACTIONS(2245),
    [anon_sym_SQUOTE] = ACTIONS(2245),
    [anon_sym_L_DQUOTE] = ACTIONS(2245),
    [anon_sym_u_DQUOTE] = ACTIONS(2245),
    [anon_sym_U_DQUOTE] = ACTIONS(2245),
    [anon_sym_u8_DQUOTE] = ACTIONS(2245),
    [anon_sym_DQUOTE] = ACTIONS(2245),
    [sym_true] = ACTIONS(2243),
    [sym_false] = ACTIONS(2243),
    [anon_sym_NULL] = ACTIONS(2243),
    [anon_sym_nullptr] = ACTIONS(2243),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2243),
    [anon_sym_decltype] = ACTIONS(2243),
    [sym_virtual] = ACTIONS(2243),
    [anon_sym_explicit] = ACTIONS(2243),
    [anon_sym_typename] = ACTIONS(2243),
    [anon_sym_template] = ACTIONS(2243),
    [anon_sym_operator] = ACTIONS(2243),
    [anon_sym_try] = ACTIONS(2243),
    [anon_sym_delete] = ACTIONS(2243),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_namespace] = ACTIONS(2243),
    [anon_sym_using] = ACTIONS(2243),
    [anon_sym_static_assert] = ACTIONS(2243),
    [anon_sym_concept] = ACTIONS(2243),
    [anon_sym_co_return] = ACTIONS(2243),
    [anon_sym_co_yield] = ACTIONS(2243),
    [anon_sym_R_DQUOTE] = ACTIONS(2245),
    [anon_sym_LR_DQUOTE] = ACTIONS(2245),
    [anon_sym_uR_DQUOTE] = ACTIONS(2245),
    [anon_sym_UR_DQUOTE] = ACTIONS(2245),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2245),
    [anon_sym_co_await] = ACTIONS(2243),
    [anon_sym_new] = ACTIONS(2243),
    [anon_sym_requires] = ACTIONS(2243),
    [sym_this] = ACTIONS(2243),
    [anon_sym___launch_bounds__] = ACTIONS(2243),
  },
  [512] = {
    [sym_identifier] = ACTIONS(2316),
    [aux_sym_preproc_include_token1] = ACTIONS(2316),
    [aux_sym_preproc_def_token1] = ACTIONS(2316),
    [aux_sym_preproc_if_token1] = ACTIONS(2316),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2316),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2316),
    [sym_preproc_directive] = ACTIONS(2316),
    [anon_sym_LPAREN2] = ACTIONS(2318),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2318),
    [anon_sym_DASH] = ACTIONS(2316),
    [anon_sym_PLUS] = ACTIONS(2316),
    [anon_sym_STAR] = ACTIONS(2318),
    [anon_sym_AMP_AMP] = ACTIONS(2318),
    [anon_sym_AMP] = ACTIONS(2316),
    [anon_sym_SEMI] = ACTIONS(2318),
    [anon_sym___extension__] = ACTIONS(2316),
    [anon_sym_typedef] = ACTIONS(2316),
    [anon_sym___device__] = ACTIONS(2316),
    [anon_sym___host__] = ACTIONS(2316),
    [anon_sym___global__] = ACTIONS(2316),
    [anon_sym___forceinline__] = ACTIONS(2316),
    [anon_sym___noinline__] = ACTIONS(2316),
    [anon_sym_extern] = ACTIONS(2316),
    [anon_sym___attribute__] = ACTIONS(2316),
    [anon_sym_COLON_COLON] = ACTIONS(2318),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2318),
    [anon_sym___declspec] = ACTIONS(2316),
    [anon_sym___based] = ACTIONS(2316),
    [anon_sym___cdecl] = ACTIONS(2316),
    [anon_sym___clrcall] = ACTIONS(2316),
    [anon_sym___stdcall] = ACTIONS(2316),
    [anon_sym___fastcall] = ACTIONS(2316),
    [anon_sym___thiscall] = ACTIONS(2316),
    [anon_sym___vectorcall] = ACTIONS(2316),
    [anon_sym_LBRACE] = ACTIONS(2318),
    [anon_sym_RBRACE] = ACTIONS(2318),
    [anon_sym_signed] = ACTIONS(2316),
    [anon_sym_unsigned] = ACTIONS(2316),
    [anon_sym_long] = ACTIONS(2316),
    [anon_sym_short] = ACTIONS(2316),
    [anon_sym_LBRACK] = ACTIONS(2316),
    [anon_sym_static] = ACTIONS(2316),
    [anon_sym_register] = ACTIONS(2316),
    [anon_sym_inline] = ACTIONS(2316),
    [anon_sym___inline] = ACTIONS(2316),
    [anon_sym___inline__] = ACTIONS(2316),
    [anon_sym___forceinline] = ACTIONS(2316),
    [anon_sym_thread_local] = ACTIONS(2316),
    [anon_sym___thread] = ACTIONS(2316),
    [anon_sym_const] = ACTIONS(2316),
    [anon_sym_constexpr] = ACTIONS(2316),
    [anon_sym_volatile] = ACTIONS(2316),
    [anon_sym_restrict] = ACTIONS(2316),
    [anon_sym___restrict__] = ACTIONS(2316),
    [anon_sym__Atomic] = ACTIONS(2316),
    [anon_sym__Noreturn] = ACTIONS(2316),
    [anon_sym_noreturn] = ACTIONS(2316),
    [anon_sym_mutable] = ACTIONS(2316),
    [anon_sym_constinit] = ACTIONS(2316),
    [anon_sym_consteval] = ACTIONS(2316),
    [anon_sym___shared__] = ACTIONS(2316),
    [anon_sym___local__] = ACTIONS(2316),
    [anon_sym___constant__] = ACTIONS(2316),
    [anon_sym___managed__] = ACTIONS(2316),
    [anon_sym___grid_constant__] = ACTIONS(2316),
    [anon_sym_alignas] = ACTIONS(2316),
    [anon_sym__Alignas] = ACTIONS(2316),
    [sym_primitive_type] = ACTIONS(2316),
    [anon_sym_enum] = ACTIONS(2316),
    [anon_sym_class] = ACTIONS(2316),
    [anon_sym_struct] = ACTIONS(2316),
    [anon_sym_union] = ACTIONS(2316),
    [anon_sym_if] = ACTIONS(2316),
    [anon_sym_switch] = ACTIONS(2316),
    [anon_sym_case] = ACTIONS(2316),
    [anon_sym_default] = ACTIONS(2316),
    [anon_sym_while] = ACTIONS(2316),
    [anon_sym_do] = ACTIONS(2316),
    [anon_sym_for] = ACTIONS(2316),
    [anon_sym_return] = ACTIONS(2316),
    [anon_sym_break] = ACTIONS(2316),
    [anon_sym_continue] = ACTIONS(2316),
    [anon_sym_goto] = ACTIONS(2316),
    [anon_sym___try] = ACTIONS(2316),
    [anon_sym___leave] = ACTIONS(2316),
    [anon_sym_not] = ACTIONS(2316),
    [anon_sym_compl] = ACTIONS(2316),
    [anon_sym_DASH_DASH] = ACTIONS(2318),
    [anon_sym_PLUS_PLUS] = ACTIONS(2318),
    [anon_sym_sizeof] = ACTIONS(2316),
    [anon_sym___alignof__] = ACTIONS(2316),
    [anon_sym___alignof] = ACTIONS(2316),
    [anon_sym__alignof] = ACTIONS(2316),
    [anon_sym_alignof] = ACTIONS(2316),
    [anon_sym__Alignof] = ACTIONS(2316),
    [anon_sym_offsetof] = ACTIONS(2316),
    [anon_sym__Generic] = ACTIONS(2316),
    [anon_sym_asm] = ACTIONS(2316),
    [anon_sym___asm__] = ACTIONS(2316),
    [sym_number_literal] = ACTIONS(2318),
    [anon_sym_L_SQUOTE] = ACTIONS(2318),
    [anon_sym_u_SQUOTE] = ACTIONS(2318),
    [anon_sym_U_SQUOTE] = ACTIONS(2318),
    [anon_sym_u8_SQUOTE] = ACTIONS(2318),
    [anon_sym_SQUOTE] = ACTIONS(2318),
    [anon_sym_L_DQUOTE] = ACTIONS(2318),
    [anon_sym_u_DQUOTE] = ACTIONS(2318),
    [anon_sym_U_DQUOTE] = ACTIONS(2318),
    [anon_sym_u8_DQUOTE] = ACTIONS(2318),
    [anon_sym_DQUOTE] = ACTIONS(2318),
    [sym_true] = ACTIONS(2316),
    [sym_false] = ACTIONS(2316),
    [anon_sym_NULL] = ACTIONS(2316),
    [anon_sym_nullptr] = ACTIONS(2316),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2316),
    [anon_sym_decltype] = ACTIONS(2316),
    [sym_virtual] = ACTIONS(2316),
    [anon_sym_explicit] = ACTIONS(2316),
    [anon_sym_typename] = ACTIONS(2316),
    [anon_sym_template] = ACTIONS(2316),
    [anon_sym_operator] = ACTIONS(2316),
    [anon_sym_try] = ACTIONS(2316),
    [anon_sym_delete] = ACTIONS(2316),
    [anon_sym_throw] = ACTIONS(2316),
    [anon_sym_namespace] = ACTIONS(2316),
    [anon_sym_using] = ACTIONS(2316),
    [anon_sym_static_assert] = ACTIONS(2316),
    [anon_sym_concept] = ACTIONS(2316),
    [anon_sym_co_return] = ACTIONS(2316),
    [anon_sym_co_yield] = ACTIONS(2316),
    [anon_sym_R_DQUOTE] = ACTIONS(2318),
    [anon_sym_LR_DQUOTE] = ACTIONS(2318),
    [anon_sym_uR_DQUOTE] = ACTIONS(2318),
    [anon_sym_UR_DQUOTE] = ACTIONS(2318),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2318),
    [anon_sym_co_await] = ACTIONS(2316),
    [anon_sym_new] = ACTIONS(2316),
    [anon_sym_requires] = ACTIONS(2316),
    [sym_this] = ACTIONS(2316),
    [anon_sym___launch_bounds__] = ACTIONS(2316),
  },
  [513] = {
    [sym_identifier] = ACTIONS(2221),
    [aux_sym_preproc_include_token1] = ACTIONS(2221),
    [aux_sym_preproc_def_token1] = ACTIONS(2221),
    [aux_sym_preproc_if_token1] = ACTIONS(2221),
    [aux_sym_preproc_if_token2] = ACTIONS(2221),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2221),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2221),
    [sym_preproc_directive] = ACTIONS(2221),
    [anon_sym_LPAREN2] = ACTIONS(2223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym___extension__] = ACTIONS(2221),
    [anon_sym_typedef] = ACTIONS(2221),
    [anon_sym___device__] = ACTIONS(2221),
    [anon_sym___host__] = ACTIONS(2221),
    [anon_sym___global__] = ACTIONS(2221),
    [anon_sym___forceinline__] = ACTIONS(2221),
    [anon_sym___noinline__] = ACTIONS(2221),
    [anon_sym_extern] = ACTIONS(2221),
    [anon_sym___attribute__] = ACTIONS(2221),
    [anon_sym_COLON_COLON] = ACTIONS(2223),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2223),
    [anon_sym___declspec] = ACTIONS(2221),
    [anon_sym___based] = ACTIONS(2221),
    [anon_sym___cdecl] = ACTIONS(2221),
    [anon_sym___clrcall] = ACTIONS(2221),
    [anon_sym___stdcall] = ACTIONS(2221),
    [anon_sym___fastcall] = ACTIONS(2221),
    [anon_sym___thiscall] = ACTIONS(2221),
    [anon_sym___vectorcall] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(2223),
    [anon_sym_signed] = ACTIONS(2221),
    [anon_sym_unsigned] = ACTIONS(2221),
    [anon_sym_long] = ACTIONS(2221),
    [anon_sym_short] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2221),
    [anon_sym_static] = ACTIONS(2221),
    [anon_sym_register] = ACTIONS(2221),
    [anon_sym_inline] = ACTIONS(2221),
    [anon_sym___inline] = ACTIONS(2221),
    [anon_sym___inline__] = ACTIONS(2221),
    [anon_sym___forceinline] = ACTIONS(2221),
    [anon_sym_thread_local] = ACTIONS(2221),
    [anon_sym___thread] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2221),
    [anon_sym_constexpr] = ACTIONS(2221),
    [anon_sym_volatile] = ACTIONS(2221),
    [anon_sym_restrict] = ACTIONS(2221),
    [anon_sym___restrict__] = ACTIONS(2221),
    [anon_sym__Atomic] = ACTIONS(2221),
    [anon_sym__Noreturn] = ACTIONS(2221),
    [anon_sym_noreturn] = ACTIONS(2221),
    [anon_sym_mutable] = ACTIONS(2221),
    [anon_sym_constinit] = ACTIONS(2221),
    [anon_sym_consteval] = ACTIONS(2221),
    [anon_sym___shared__] = ACTIONS(2221),
    [anon_sym___local__] = ACTIONS(2221),
    [anon_sym___constant__] = ACTIONS(2221),
    [anon_sym___managed__] = ACTIONS(2221),
    [anon_sym___grid_constant__] = ACTIONS(2221),
    [anon_sym_alignas] = ACTIONS(2221),
    [anon_sym__Alignas] = ACTIONS(2221),
    [sym_primitive_type] = ACTIONS(2221),
    [anon_sym_enum] = ACTIONS(2221),
    [anon_sym_class] = ACTIONS(2221),
    [anon_sym_struct] = ACTIONS(2221),
    [anon_sym_union] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_case] = ACTIONS(2221),
    [anon_sym_default] = ACTIONS(2221),
    [anon_sym_while] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2221),
    [anon_sym_for] = ACTIONS(2221),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_break] = ACTIONS(2221),
    [anon_sym_continue] = ACTIONS(2221),
    [anon_sym_goto] = ACTIONS(2221),
    [anon_sym___try] = ACTIONS(2221),
    [anon_sym___leave] = ACTIONS(2221),
    [anon_sym_not] = ACTIONS(2221),
    [anon_sym_compl] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_sizeof] = ACTIONS(2221),
    [anon_sym___alignof__] = ACTIONS(2221),
    [anon_sym___alignof] = ACTIONS(2221),
    [anon_sym__alignof] = ACTIONS(2221),
    [anon_sym_alignof] = ACTIONS(2221),
    [anon_sym__Alignof] = ACTIONS(2221),
    [anon_sym_offsetof] = ACTIONS(2221),
    [anon_sym__Generic] = ACTIONS(2221),
    [anon_sym_asm] = ACTIONS(2221),
    [anon_sym___asm__] = ACTIONS(2221),
    [sym_number_literal] = ACTIONS(2223),
    [anon_sym_L_SQUOTE] = ACTIONS(2223),
    [anon_sym_u_SQUOTE] = ACTIONS(2223),
    [anon_sym_U_SQUOTE] = ACTIONS(2223),
    [anon_sym_u8_SQUOTE] = ACTIONS(2223),
    [anon_sym_SQUOTE] = ACTIONS(2223),
    [anon_sym_L_DQUOTE] = ACTIONS(2223),
    [anon_sym_u_DQUOTE] = ACTIONS(2223),
    [anon_sym_U_DQUOTE] = ACTIONS(2223),
    [anon_sym_u8_DQUOTE] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2223),
    [sym_true] = ACTIONS(2221),
    [sym_false] = ACTIONS(2221),
    [anon_sym_NULL] = ACTIONS(2221),
    [anon_sym_nullptr] = ACTIONS(2221),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2221),
    [anon_sym_decltype] = ACTIONS(2221),
    [sym_virtual] = ACTIONS(2221),
    [anon_sym_explicit] = ACTIONS(2221),
    [anon_sym_typename] = ACTIONS(2221),
    [anon_sym_template] = ACTIONS(2221),
    [anon_sym_operator] = ACTIONS(2221),
    [anon_sym_try] = ACTIONS(2221),
    [anon_sym_delete] = ACTIONS(2221),
    [anon_sym_throw] = ACTIONS(2221),
    [anon_sym_namespace] = ACTIONS(2221),
    [anon_sym_using] = ACTIONS(2221),
    [anon_sym_static_assert] = ACTIONS(2221),
    [anon_sym_concept] = ACTIONS(2221),
    [anon_sym_co_return] = ACTIONS(2221),
    [anon_sym_co_yield] = ACTIONS(2221),
    [anon_sym_R_DQUOTE] = ACTIONS(2223),
    [anon_sym_LR_DQUOTE] = ACTIONS(2223),
    [anon_sym_uR_DQUOTE] = ACTIONS(2223),
    [anon_sym_UR_DQUOTE] = ACTIONS(2223),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2223),
    [anon_sym_co_await] = ACTIONS(2221),
    [anon_sym_new] = ACTIONS(2221),
    [anon_sym_requires] = ACTIONS(2221),
    [sym_this] = ACTIONS(2221),
    [anon_sym___launch_bounds__] = ACTIONS(2221),
  },
  [514] = {
    [sym_identifier] = ACTIONS(2409),
    [aux_sym_preproc_include_token1] = ACTIONS(2409),
    [aux_sym_preproc_def_token1] = ACTIONS(2409),
    [aux_sym_preproc_if_token1] = ACTIONS(2409),
    [aux_sym_preproc_if_token2] = ACTIONS(2409),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2409),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2409),
    [sym_preproc_directive] = ACTIONS(2409),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_BANG] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2409),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2409),
    [anon_sym_SEMI] = ACTIONS(2411),
    [anon_sym___extension__] = ACTIONS(2409),
    [anon_sym_typedef] = ACTIONS(2409),
    [anon_sym___device__] = ACTIONS(2409),
    [anon_sym___host__] = ACTIONS(2409),
    [anon_sym___global__] = ACTIONS(2409),
    [anon_sym___forceinline__] = ACTIONS(2409),
    [anon_sym___noinline__] = ACTIONS(2409),
    [anon_sym_extern] = ACTIONS(2409),
    [anon_sym___attribute__] = ACTIONS(2409),
    [anon_sym_COLON_COLON] = ACTIONS(2411),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2411),
    [anon_sym___declspec] = ACTIONS(2409),
    [anon_sym___based] = ACTIONS(2409),
    [anon_sym___cdecl] = ACTIONS(2409),
    [anon_sym___clrcall] = ACTIONS(2409),
    [anon_sym___stdcall] = ACTIONS(2409),
    [anon_sym___fastcall] = ACTIONS(2409),
    [anon_sym___thiscall] = ACTIONS(2409),
    [anon_sym___vectorcall] = ACTIONS(2409),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_signed] = ACTIONS(2409),
    [anon_sym_unsigned] = ACTIONS(2409),
    [anon_sym_long] = ACTIONS(2409),
    [anon_sym_short] = ACTIONS(2409),
    [anon_sym_LBRACK] = ACTIONS(2409),
    [anon_sym_static] = ACTIONS(2409),
    [anon_sym_register] = ACTIONS(2409),
    [anon_sym_inline] = ACTIONS(2409),
    [anon_sym___inline] = ACTIONS(2409),
    [anon_sym___inline__] = ACTIONS(2409),
    [anon_sym___forceinline] = ACTIONS(2409),
    [anon_sym_thread_local] = ACTIONS(2409),
    [anon_sym___thread] = ACTIONS(2409),
    [anon_sym_const] = ACTIONS(2409),
    [anon_sym_constexpr] = ACTIONS(2409),
    [anon_sym_volatile] = ACTIONS(2409),
    [anon_sym_restrict] = ACTIONS(2409),
    [anon_sym___restrict__] = ACTIONS(2409),
    [anon_sym__Atomic] = ACTIONS(2409),
    [anon_sym__Noreturn] = ACTIONS(2409),
    [anon_sym_noreturn] = ACTIONS(2409),
    [anon_sym_mutable] = ACTIONS(2409),
    [anon_sym_constinit] = ACTIONS(2409),
    [anon_sym_consteval] = ACTIONS(2409),
    [anon_sym___shared__] = ACTIONS(2409),
    [anon_sym___local__] = ACTIONS(2409),
    [anon_sym___constant__] = ACTIONS(2409),
    [anon_sym___managed__] = ACTIONS(2409),
    [anon_sym___grid_constant__] = ACTIONS(2409),
    [anon_sym_alignas] = ACTIONS(2409),
    [anon_sym__Alignas] = ACTIONS(2409),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2409),
    [anon_sym_class] = ACTIONS(2409),
    [anon_sym_struct] = ACTIONS(2409),
    [anon_sym_union] = ACTIONS(2409),
    [anon_sym_if] = ACTIONS(2409),
    [anon_sym_switch] = ACTIONS(2409),
    [anon_sym_case] = ACTIONS(2409),
    [anon_sym_default] = ACTIONS(2409),
    [anon_sym_while] = ACTIONS(2409),
    [anon_sym_do] = ACTIONS(2409),
    [anon_sym_for] = ACTIONS(2409),
    [anon_sym_return] = ACTIONS(2409),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_continue] = ACTIONS(2409),
    [anon_sym_goto] = ACTIONS(2409),
    [anon_sym___try] = ACTIONS(2409),
    [anon_sym___leave] = ACTIONS(2409),
    [anon_sym_not] = ACTIONS(2409),
    [anon_sym_compl] = ACTIONS(2409),
    [anon_sym_DASH_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_PLUS] = ACTIONS(2411),
    [anon_sym_sizeof] = ACTIONS(2409),
    [anon_sym___alignof__] = ACTIONS(2409),
    [anon_sym___alignof] = ACTIONS(2409),
    [anon_sym__alignof] = ACTIONS(2409),
    [anon_sym_alignof] = ACTIONS(2409),
    [anon_sym__Alignof] = ACTIONS(2409),
    [anon_sym_offsetof] = ACTIONS(2409),
    [anon_sym__Generic] = ACTIONS(2409),
    [anon_sym_asm] = ACTIONS(2409),
    [anon_sym___asm__] = ACTIONS(2409),
    [sym_number_literal] = ACTIONS(2411),
    [anon_sym_L_SQUOTE] = ACTIONS(2411),
    [anon_sym_u_SQUOTE] = ACTIONS(2411),
    [anon_sym_U_SQUOTE] = ACTIONS(2411),
    [anon_sym_u8_SQUOTE] = ACTIONS(2411),
    [anon_sym_SQUOTE] = ACTIONS(2411),
    [anon_sym_L_DQUOTE] = ACTIONS(2411),
    [anon_sym_u_DQUOTE] = ACTIONS(2411),
    [anon_sym_U_DQUOTE] = ACTIONS(2411),
    [anon_sym_u8_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [sym_true] = ACTIONS(2409),
    [sym_false] = ACTIONS(2409),
    [anon_sym_NULL] = ACTIONS(2409),
    [anon_sym_nullptr] = ACTIONS(2409),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2409),
    [anon_sym_decltype] = ACTIONS(2409),
    [sym_virtual] = ACTIONS(2409),
    [anon_sym_explicit] = ACTIONS(2409),
    [anon_sym_typename] = ACTIONS(2409),
    [anon_sym_template] = ACTIONS(2409),
    [anon_sym_operator] = ACTIONS(2409),
    [anon_sym_try] = ACTIONS(2409),
    [anon_sym_delete] = ACTIONS(2409),
    [anon_sym_throw] = ACTIONS(2409),
    [anon_sym_namespace] = ACTIONS(2409),
    [anon_sym_using] = ACTIONS(2409),
    [anon_sym_static_assert] = ACTIONS(2409),
    [anon_sym_concept] = ACTIONS(2409),
    [anon_sym_co_return] = ACTIONS(2409),
    [anon_sym_co_yield] = ACTIONS(2409),
    [anon_sym_R_DQUOTE] = ACTIONS(2411),
    [anon_sym_LR_DQUOTE] = ACTIONS(2411),
    [anon_sym_uR_DQUOTE] = ACTIONS(2411),
    [anon_sym_UR_DQUOTE] = ACTIONS(2411),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2411),
    [anon_sym_co_await] = ACTIONS(2409),
    [anon_sym_new] = ACTIONS(2409),
    [anon_sym_requires] = ACTIONS(2409),
    [sym_this] = ACTIONS(2409),
    [anon_sym___launch_bounds__] = ACTIONS(2409),
  },
  [515] = {
    [sym_identifier] = ACTIONS(2326),
    [aux_sym_preproc_include_token1] = ACTIONS(2326),
    [aux_sym_preproc_def_token1] = ACTIONS(2326),
    [aux_sym_preproc_if_token1] = ACTIONS(2326),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2326),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2326),
    [sym_preproc_directive] = ACTIONS(2326),
    [anon_sym_LPAREN2] = ACTIONS(2328),
    [anon_sym_BANG] = ACTIONS(2328),
    [anon_sym_TILDE] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_STAR] = ACTIONS(2328),
    [anon_sym_AMP_AMP] = ACTIONS(2328),
    [anon_sym_AMP] = ACTIONS(2326),
    [anon_sym_SEMI] = ACTIONS(2328),
    [anon_sym___extension__] = ACTIONS(2326),
    [anon_sym_typedef] = ACTIONS(2326),
    [anon_sym___device__] = ACTIONS(2326),
    [anon_sym___host__] = ACTIONS(2326),
    [anon_sym___global__] = ACTIONS(2326),
    [anon_sym___forceinline__] = ACTIONS(2326),
    [anon_sym___noinline__] = ACTIONS(2326),
    [anon_sym_extern] = ACTIONS(2326),
    [anon_sym___attribute__] = ACTIONS(2326),
    [anon_sym_COLON_COLON] = ACTIONS(2328),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2328),
    [anon_sym___declspec] = ACTIONS(2326),
    [anon_sym___based] = ACTIONS(2326),
    [anon_sym___cdecl] = ACTIONS(2326),
    [anon_sym___clrcall] = ACTIONS(2326),
    [anon_sym___stdcall] = ACTIONS(2326),
    [anon_sym___fastcall] = ACTIONS(2326),
    [anon_sym___thiscall] = ACTIONS(2326),
    [anon_sym___vectorcall] = ACTIONS(2326),
    [anon_sym_LBRACE] = ACTIONS(2328),
    [anon_sym_RBRACE] = ACTIONS(2328),
    [anon_sym_signed] = ACTIONS(2326),
    [anon_sym_unsigned] = ACTIONS(2326),
    [anon_sym_long] = ACTIONS(2326),
    [anon_sym_short] = ACTIONS(2326),
    [anon_sym_LBRACK] = ACTIONS(2326),
    [anon_sym_static] = ACTIONS(2326),
    [anon_sym_register] = ACTIONS(2326),
    [anon_sym_inline] = ACTIONS(2326),
    [anon_sym___inline] = ACTIONS(2326),
    [anon_sym___inline__] = ACTIONS(2326),
    [anon_sym___forceinline] = ACTIONS(2326),
    [anon_sym_thread_local] = ACTIONS(2326),
    [anon_sym___thread] = ACTIONS(2326),
    [anon_sym_const] = ACTIONS(2326),
    [anon_sym_constexpr] = ACTIONS(2326),
    [anon_sym_volatile] = ACTIONS(2326),
    [anon_sym_restrict] = ACTIONS(2326),
    [anon_sym___restrict__] = ACTIONS(2326),
    [anon_sym__Atomic] = ACTIONS(2326),
    [anon_sym__Noreturn] = ACTIONS(2326),
    [anon_sym_noreturn] = ACTIONS(2326),
    [anon_sym_mutable] = ACTIONS(2326),
    [anon_sym_constinit] = ACTIONS(2326),
    [anon_sym_consteval] = ACTIONS(2326),
    [anon_sym___shared__] = ACTIONS(2326),
    [anon_sym___local__] = ACTIONS(2326),
    [anon_sym___constant__] = ACTIONS(2326),
    [anon_sym___managed__] = ACTIONS(2326),
    [anon_sym___grid_constant__] = ACTIONS(2326),
    [anon_sym_alignas] = ACTIONS(2326),
    [anon_sym__Alignas] = ACTIONS(2326),
    [sym_primitive_type] = ACTIONS(2326),
    [anon_sym_enum] = ACTIONS(2326),
    [anon_sym_class] = ACTIONS(2326),
    [anon_sym_struct] = ACTIONS(2326),
    [anon_sym_union] = ACTIONS(2326),
    [anon_sym_if] = ACTIONS(2326),
    [anon_sym_switch] = ACTIONS(2326),
    [anon_sym_case] = ACTIONS(2326),
    [anon_sym_default] = ACTIONS(2326),
    [anon_sym_while] = ACTIONS(2326),
    [anon_sym_do] = ACTIONS(2326),
    [anon_sym_for] = ACTIONS(2326),
    [anon_sym_return] = ACTIONS(2326),
    [anon_sym_break] = ACTIONS(2326),
    [anon_sym_continue] = ACTIONS(2326),
    [anon_sym_goto] = ACTIONS(2326),
    [anon_sym___try] = ACTIONS(2326),
    [anon_sym___leave] = ACTIONS(2326),
    [anon_sym_not] = ACTIONS(2326),
    [anon_sym_compl] = ACTIONS(2326),
    [anon_sym_DASH_DASH] = ACTIONS(2328),
    [anon_sym_PLUS_PLUS] = ACTIONS(2328),
    [anon_sym_sizeof] = ACTIONS(2326),
    [anon_sym___alignof__] = ACTIONS(2326),
    [anon_sym___alignof] = ACTIONS(2326),
    [anon_sym__alignof] = ACTIONS(2326),
    [anon_sym_alignof] = ACTIONS(2326),
    [anon_sym__Alignof] = ACTIONS(2326),
    [anon_sym_offsetof] = ACTIONS(2326),
    [anon_sym__Generic] = ACTIONS(2326),
    [anon_sym_asm] = ACTIONS(2326),
    [anon_sym___asm__] = ACTIONS(2326),
    [sym_number_literal] = ACTIONS(2328),
    [anon_sym_L_SQUOTE] = ACTIONS(2328),
    [anon_sym_u_SQUOTE] = ACTIONS(2328),
    [anon_sym_U_SQUOTE] = ACTIONS(2328),
    [anon_sym_u8_SQUOTE] = ACTIONS(2328),
    [anon_sym_SQUOTE] = ACTIONS(2328),
    [anon_sym_L_DQUOTE] = ACTIONS(2328),
    [anon_sym_u_DQUOTE] = ACTIONS(2328),
    [anon_sym_U_DQUOTE] = ACTIONS(2328),
    [anon_sym_u8_DQUOTE] = ACTIONS(2328),
    [anon_sym_DQUOTE] = ACTIONS(2328),
    [sym_true] = ACTIONS(2326),
    [sym_false] = ACTIONS(2326),
    [anon_sym_NULL] = ACTIONS(2326),
    [anon_sym_nullptr] = ACTIONS(2326),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2326),
    [anon_sym_decltype] = ACTIONS(2326),
    [sym_virtual] = ACTIONS(2326),
    [anon_sym_explicit] = ACTIONS(2326),
    [anon_sym_typename] = ACTIONS(2326),
    [anon_sym_template] = ACTIONS(2326),
    [anon_sym_operator] = ACTIONS(2326),
    [anon_sym_try] = ACTIONS(2326),
    [anon_sym_delete] = ACTIONS(2326),
    [anon_sym_throw] = ACTIONS(2326),
    [anon_sym_namespace] = ACTIONS(2326),
    [anon_sym_using] = ACTIONS(2326),
    [anon_sym_static_assert] = ACTIONS(2326),
    [anon_sym_concept] = ACTIONS(2326),
    [anon_sym_co_return] = ACTIONS(2326),
    [anon_sym_co_yield] = ACTIONS(2326),
    [anon_sym_R_DQUOTE] = ACTIONS(2328),
    [anon_sym_LR_DQUOTE] = ACTIONS(2328),
    [anon_sym_uR_DQUOTE] = ACTIONS(2328),
    [anon_sym_UR_DQUOTE] = ACTIONS(2328),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2328),
    [anon_sym_co_await] = ACTIONS(2326),
    [anon_sym_new] = ACTIONS(2326),
    [anon_sym_requires] = ACTIONS(2326),
    [sym_this] = ACTIONS(2326),
    [anon_sym___launch_bounds__] = ACTIONS(2326),
  },
  [516] = {
    [sym_identifier] = ACTIONS(2243),
    [aux_sym_preproc_include_token1] = ACTIONS(2243),
    [aux_sym_preproc_def_token1] = ACTIONS(2243),
    [aux_sym_preproc_if_token1] = ACTIONS(2243),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2243),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2243),
    [sym_preproc_directive] = ACTIONS(2243),
    [anon_sym_LPAREN2] = ACTIONS(2245),
    [anon_sym_BANG] = ACTIONS(2245),
    [anon_sym_TILDE] = ACTIONS(2245),
    [anon_sym_DASH] = ACTIONS(2243),
    [anon_sym_PLUS] = ACTIONS(2243),
    [anon_sym_STAR] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2245),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_SEMI] = ACTIONS(2245),
    [anon_sym___extension__] = ACTIONS(2243),
    [anon_sym_typedef] = ACTIONS(2243),
    [anon_sym___device__] = ACTIONS(2243),
    [anon_sym___host__] = ACTIONS(2243),
    [anon_sym___global__] = ACTIONS(2243),
    [anon_sym___forceinline__] = ACTIONS(2243),
    [anon_sym___noinline__] = ACTIONS(2243),
    [anon_sym_extern] = ACTIONS(2243),
    [anon_sym___attribute__] = ACTIONS(2243),
    [anon_sym_COLON_COLON] = ACTIONS(2245),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2245),
    [anon_sym___declspec] = ACTIONS(2243),
    [anon_sym___based] = ACTIONS(2243),
    [anon_sym___cdecl] = ACTIONS(2243),
    [anon_sym___clrcall] = ACTIONS(2243),
    [anon_sym___stdcall] = ACTIONS(2243),
    [anon_sym___fastcall] = ACTIONS(2243),
    [anon_sym___thiscall] = ACTIONS(2243),
    [anon_sym___vectorcall] = ACTIONS(2243),
    [anon_sym_LBRACE] = ACTIONS(2245),
    [anon_sym_RBRACE] = ACTIONS(2245),
    [anon_sym_signed] = ACTIONS(2243),
    [anon_sym_unsigned] = ACTIONS(2243),
    [anon_sym_long] = ACTIONS(2243),
    [anon_sym_short] = ACTIONS(2243),
    [anon_sym_LBRACK] = ACTIONS(2243),
    [anon_sym_static] = ACTIONS(2243),
    [anon_sym_register] = ACTIONS(2243),
    [anon_sym_inline] = ACTIONS(2243),
    [anon_sym___inline] = ACTIONS(2243),
    [anon_sym___inline__] = ACTIONS(2243),
    [anon_sym___forceinline] = ACTIONS(2243),
    [anon_sym_thread_local] = ACTIONS(2243),
    [anon_sym___thread] = ACTIONS(2243),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2243),
    [anon_sym_volatile] = ACTIONS(2243),
    [anon_sym_restrict] = ACTIONS(2243),
    [anon_sym___restrict__] = ACTIONS(2243),
    [anon_sym__Atomic] = ACTIONS(2243),
    [anon_sym__Noreturn] = ACTIONS(2243),
    [anon_sym_noreturn] = ACTIONS(2243),
    [anon_sym_mutable] = ACTIONS(2243),
    [anon_sym_constinit] = ACTIONS(2243),
    [anon_sym_consteval] = ACTIONS(2243),
    [anon_sym___shared__] = ACTIONS(2243),
    [anon_sym___local__] = ACTIONS(2243),
    [anon_sym___constant__] = ACTIONS(2243),
    [anon_sym___managed__] = ACTIONS(2243),
    [anon_sym___grid_constant__] = ACTIONS(2243),
    [anon_sym_alignas] = ACTIONS(2243),
    [anon_sym__Alignas] = ACTIONS(2243),
    [sym_primitive_type] = ACTIONS(2243),
    [anon_sym_enum] = ACTIONS(2243),
    [anon_sym_class] = ACTIONS(2243),
    [anon_sym_struct] = ACTIONS(2243),
    [anon_sym_union] = ACTIONS(2243),
    [anon_sym_if] = ACTIONS(2243),
    [anon_sym_switch] = ACTIONS(2243),
    [anon_sym_case] = ACTIONS(2243),
    [anon_sym_default] = ACTIONS(2243),
    [anon_sym_while] = ACTIONS(2243),
    [anon_sym_do] = ACTIONS(2243),
    [anon_sym_for] = ACTIONS(2243),
    [anon_sym_return] = ACTIONS(2243),
    [anon_sym_break] = ACTIONS(2243),
    [anon_sym_continue] = ACTIONS(2243),
    [anon_sym_goto] = ACTIONS(2243),
    [anon_sym___try] = ACTIONS(2243),
    [anon_sym___leave] = ACTIONS(2243),
    [anon_sym_not] = ACTIONS(2243),
    [anon_sym_compl] = ACTIONS(2243),
    [anon_sym_DASH_DASH] = ACTIONS(2245),
    [anon_sym_PLUS_PLUS] = ACTIONS(2245),
    [anon_sym_sizeof] = ACTIONS(2243),
    [anon_sym___alignof__] = ACTIONS(2243),
    [anon_sym___alignof] = ACTIONS(2243),
    [anon_sym__alignof] = ACTIONS(2243),
    [anon_sym_alignof] = ACTIONS(2243),
    [anon_sym__Alignof] = ACTIONS(2243),
    [anon_sym_offsetof] = ACTIONS(2243),
    [anon_sym__Generic] = ACTIONS(2243),
    [anon_sym_asm] = ACTIONS(2243),
    [anon_sym___asm__] = ACTIONS(2243),
    [sym_number_literal] = ACTIONS(2245),
    [anon_sym_L_SQUOTE] = ACTIONS(2245),
    [anon_sym_u_SQUOTE] = ACTIONS(2245),
    [anon_sym_U_SQUOTE] = ACTIONS(2245),
    [anon_sym_u8_SQUOTE] = ACTIONS(2245),
    [anon_sym_SQUOTE] = ACTIONS(2245),
    [anon_sym_L_DQUOTE] = ACTIONS(2245),
    [anon_sym_u_DQUOTE] = ACTIONS(2245),
    [anon_sym_U_DQUOTE] = ACTIONS(2245),
    [anon_sym_u8_DQUOTE] = ACTIONS(2245),
    [anon_sym_DQUOTE] = ACTIONS(2245),
    [sym_true] = ACTIONS(2243),
    [sym_false] = ACTIONS(2243),
    [anon_sym_NULL] = ACTIONS(2243),
    [anon_sym_nullptr] = ACTIONS(2243),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2243),
    [anon_sym_decltype] = ACTIONS(2243),
    [sym_virtual] = ACTIONS(2243),
    [anon_sym_explicit] = ACTIONS(2243),
    [anon_sym_typename] = ACTIONS(2243),
    [anon_sym_template] = ACTIONS(2243),
    [anon_sym_operator] = ACTIONS(2243),
    [anon_sym_try] = ACTIONS(2243),
    [anon_sym_delete] = ACTIONS(2243),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_namespace] = ACTIONS(2243),
    [anon_sym_using] = ACTIONS(2243),
    [anon_sym_static_assert] = ACTIONS(2243),
    [anon_sym_concept] = ACTIONS(2243),
    [anon_sym_co_return] = ACTIONS(2243),
    [anon_sym_co_yield] = ACTIONS(2243),
    [anon_sym_R_DQUOTE] = ACTIONS(2245),
    [anon_sym_LR_DQUOTE] = ACTIONS(2245),
    [anon_sym_uR_DQUOTE] = ACTIONS(2245),
    [anon_sym_UR_DQUOTE] = ACTIONS(2245),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2245),
    [anon_sym_co_await] = ACTIONS(2243),
    [anon_sym_new] = ACTIONS(2243),
    [anon_sym_requires] = ACTIONS(2243),
    [sym_this] = ACTIONS(2243),
    [anon_sym___launch_bounds__] = ACTIONS(2243),
  },
  [517] = {
    [sym_identifier] = ACTIONS(2187),
    [aux_sym_preproc_include_token1] = ACTIONS(2187),
    [aux_sym_preproc_def_token1] = ACTIONS(2187),
    [aux_sym_preproc_if_token1] = ACTIONS(2187),
    [aux_sym_preproc_if_token2] = ACTIONS(2187),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2187),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2187),
    [sym_preproc_directive] = ACTIONS(2187),
    [anon_sym_LPAREN2] = ACTIONS(2189),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_AMP_AMP] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_SEMI] = ACTIONS(2189),
    [anon_sym___extension__] = ACTIONS(2187),
    [anon_sym_typedef] = ACTIONS(2187),
    [anon_sym___device__] = ACTIONS(2187),
    [anon_sym___host__] = ACTIONS(2187),
    [anon_sym___global__] = ACTIONS(2187),
    [anon_sym___forceinline__] = ACTIONS(2187),
    [anon_sym___noinline__] = ACTIONS(2187),
    [anon_sym_extern] = ACTIONS(2187),
    [anon_sym___attribute__] = ACTIONS(2187),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2189),
    [anon_sym___declspec] = ACTIONS(2187),
    [anon_sym___based] = ACTIONS(2187),
    [anon_sym___cdecl] = ACTIONS(2187),
    [anon_sym___clrcall] = ACTIONS(2187),
    [anon_sym___stdcall] = ACTIONS(2187),
    [anon_sym___fastcall] = ACTIONS(2187),
    [anon_sym___thiscall] = ACTIONS(2187),
    [anon_sym___vectorcall] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2189),
    [anon_sym_signed] = ACTIONS(2187),
    [anon_sym_unsigned] = ACTIONS(2187),
    [anon_sym_long] = ACTIONS(2187),
    [anon_sym_short] = ACTIONS(2187),
    [anon_sym_LBRACK] = ACTIONS(2187),
    [anon_sym_static] = ACTIONS(2187),
    [anon_sym_register] = ACTIONS(2187),
    [anon_sym_inline] = ACTIONS(2187),
    [anon_sym___inline] = ACTIONS(2187),
    [anon_sym___inline__] = ACTIONS(2187),
    [anon_sym___forceinline] = ACTIONS(2187),
    [anon_sym_thread_local] = ACTIONS(2187),
    [anon_sym___thread] = ACTIONS(2187),
    [anon_sym_const] = ACTIONS(2187),
    [anon_sym_constexpr] = ACTIONS(2187),
    [anon_sym_volatile] = ACTIONS(2187),
    [anon_sym_restrict] = ACTIONS(2187),
    [anon_sym___restrict__] = ACTIONS(2187),
    [anon_sym__Atomic] = ACTIONS(2187),
    [anon_sym__Noreturn] = ACTIONS(2187),
    [anon_sym_noreturn] = ACTIONS(2187),
    [anon_sym_mutable] = ACTIONS(2187),
    [anon_sym_constinit] = ACTIONS(2187),
    [anon_sym_consteval] = ACTIONS(2187),
    [anon_sym___shared__] = ACTIONS(2187),
    [anon_sym___local__] = ACTIONS(2187),
    [anon_sym___constant__] = ACTIONS(2187),
    [anon_sym___managed__] = ACTIONS(2187),
    [anon_sym___grid_constant__] = ACTIONS(2187),
    [anon_sym_alignas] = ACTIONS(2187),
    [anon_sym__Alignas] = ACTIONS(2187),
    [sym_primitive_type] = ACTIONS(2187),
    [anon_sym_enum] = ACTIONS(2187),
    [anon_sym_class] = ACTIONS(2187),
    [anon_sym_struct] = ACTIONS(2187),
    [anon_sym_union] = ACTIONS(2187),
    [anon_sym_if] = ACTIONS(2187),
    [anon_sym_switch] = ACTIONS(2187),
    [anon_sym_case] = ACTIONS(2187),
    [anon_sym_default] = ACTIONS(2187),
    [anon_sym_while] = ACTIONS(2187),
    [anon_sym_do] = ACTIONS(2187),
    [anon_sym_for] = ACTIONS(2187),
    [anon_sym_return] = ACTIONS(2187),
    [anon_sym_break] = ACTIONS(2187),
    [anon_sym_continue] = ACTIONS(2187),
    [anon_sym_goto] = ACTIONS(2187),
    [anon_sym___try] = ACTIONS(2187),
    [anon_sym___leave] = ACTIONS(2187),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_compl] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_sizeof] = ACTIONS(2187),
    [anon_sym___alignof__] = ACTIONS(2187),
    [anon_sym___alignof] = ACTIONS(2187),
    [anon_sym__alignof] = ACTIONS(2187),
    [anon_sym_alignof] = ACTIONS(2187),
    [anon_sym__Alignof] = ACTIONS(2187),
    [anon_sym_offsetof] = ACTIONS(2187),
    [anon_sym__Generic] = ACTIONS(2187),
    [anon_sym_asm] = ACTIONS(2187),
    [anon_sym___asm__] = ACTIONS(2187),
    [sym_number_literal] = ACTIONS(2189),
    [anon_sym_L_SQUOTE] = ACTIONS(2189),
    [anon_sym_u_SQUOTE] = ACTIONS(2189),
    [anon_sym_U_SQUOTE] = ACTIONS(2189),
    [anon_sym_u8_SQUOTE] = ACTIONS(2189),
    [anon_sym_SQUOTE] = ACTIONS(2189),
    [anon_sym_L_DQUOTE] = ACTIONS(2189),
    [anon_sym_u_DQUOTE] = ACTIONS(2189),
    [anon_sym_U_DQUOTE] = ACTIONS(2189),
    [anon_sym_u8_DQUOTE] = ACTIONS(2189),
    [anon_sym_DQUOTE] = ACTIONS(2189),
    [sym_true] = ACTIONS(2187),
    [sym_false] = ACTIONS(2187),
    [anon_sym_NULL] = ACTIONS(2187),
    [anon_sym_nullptr] = ACTIONS(2187),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2187),
    [anon_sym_decltype] = ACTIONS(2187),
    [sym_virtual] = ACTIONS(2187),
    [anon_sym_explicit] = ACTIONS(2187),
    [anon_sym_typename] = ACTIONS(2187),
    [anon_sym_template] = ACTIONS(2187),
    [anon_sym_operator] = ACTIONS(2187),
    [anon_sym_try] = ACTIONS(2187),
    [anon_sym_delete] = ACTIONS(2187),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_namespace] = ACTIONS(2187),
    [anon_sym_using] = ACTIONS(2187),
    [anon_sym_static_assert] = ACTIONS(2187),
    [anon_sym_concept] = ACTIONS(2187),
    [anon_sym_co_return] = ACTIONS(2187),
    [anon_sym_co_yield] = ACTIONS(2187),
    [anon_sym_R_DQUOTE] = ACTIONS(2189),
    [anon_sym_LR_DQUOTE] = ACTIONS(2189),
    [anon_sym_uR_DQUOTE] = ACTIONS(2189),
    [anon_sym_UR_DQUOTE] = ACTIONS(2189),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2189),
    [anon_sym_co_await] = ACTIONS(2187),
    [anon_sym_new] = ACTIONS(2187),
    [anon_sym_requires] = ACTIONS(2187),
    [sym_this] = ACTIONS(2187),
    [anon_sym___launch_bounds__] = ACTIONS(2187),
  },
  [518] = {
    [sym_identifier] = ACTIONS(2457),
    [aux_sym_preproc_include_token1] = ACTIONS(2457),
    [aux_sym_preproc_def_token1] = ACTIONS(2457),
    [aux_sym_preproc_if_token1] = ACTIONS(2457),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2457),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2457),
    [sym_preproc_directive] = ACTIONS(2457),
    [anon_sym_LPAREN2] = ACTIONS(2459),
    [anon_sym_BANG] = ACTIONS(2459),
    [anon_sym_TILDE] = ACTIONS(2459),
    [anon_sym_DASH] = ACTIONS(2457),
    [anon_sym_PLUS] = ACTIONS(2457),
    [anon_sym_STAR] = ACTIONS(2459),
    [anon_sym_AMP_AMP] = ACTIONS(2459),
    [anon_sym_AMP] = ACTIONS(2457),
    [anon_sym_SEMI] = ACTIONS(2459),
    [anon_sym___extension__] = ACTIONS(2457),
    [anon_sym_typedef] = ACTIONS(2457),
    [anon_sym___device__] = ACTIONS(2457),
    [anon_sym___host__] = ACTIONS(2457),
    [anon_sym___global__] = ACTIONS(2457),
    [anon_sym___forceinline__] = ACTIONS(2457),
    [anon_sym___noinline__] = ACTIONS(2457),
    [anon_sym_extern] = ACTIONS(2457),
    [anon_sym___attribute__] = ACTIONS(2457),
    [anon_sym_COLON_COLON] = ACTIONS(2459),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2459),
    [anon_sym___declspec] = ACTIONS(2457),
    [anon_sym___based] = ACTIONS(2457),
    [anon_sym___cdecl] = ACTIONS(2457),
    [anon_sym___clrcall] = ACTIONS(2457),
    [anon_sym___stdcall] = ACTIONS(2457),
    [anon_sym___fastcall] = ACTIONS(2457),
    [anon_sym___thiscall] = ACTIONS(2457),
    [anon_sym___vectorcall] = ACTIONS(2457),
    [anon_sym_LBRACE] = ACTIONS(2459),
    [anon_sym_RBRACE] = ACTIONS(2459),
    [anon_sym_signed] = ACTIONS(2457),
    [anon_sym_unsigned] = ACTIONS(2457),
    [anon_sym_long] = ACTIONS(2457),
    [anon_sym_short] = ACTIONS(2457),
    [anon_sym_LBRACK] = ACTIONS(2457),
    [anon_sym_static] = ACTIONS(2457),
    [anon_sym_register] = ACTIONS(2457),
    [anon_sym_inline] = ACTIONS(2457),
    [anon_sym___inline] = ACTIONS(2457),
    [anon_sym___inline__] = ACTIONS(2457),
    [anon_sym___forceinline] = ACTIONS(2457),
    [anon_sym_thread_local] = ACTIONS(2457),
    [anon_sym___thread] = ACTIONS(2457),
    [anon_sym_const] = ACTIONS(2457),
    [anon_sym_constexpr] = ACTIONS(2457),
    [anon_sym_volatile] = ACTIONS(2457),
    [anon_sym_restrict] = ACTIONS(2457),
    [anon_sym___restrict__] = ACTIONS(2457),
    [anon_sym__Atomic] = ACTIONS(2457),
    [anon_sym__Noreturn] = ACTIONS(2457),
    [anon_sym_noreturn] = ACTIONS(2457),
    [anon_sym_mutable] = ACTIONS(2457),
    [anon_sym_constinit] = ACTIONS(2457),
    [anon_sym_consteval] = ACTIONS(2457),
    [anon_sym___shared__] = ACTIONS(2457),
    [anon_sym___local__] = ACTIONS(2457),
    [anon_sym___constant__] = ACTIONS(2457),
    [anon_sym___managed__] = ACTIONS(2457),
    [anon_sym___grid_constant__] = ACTIONS(2457),
    [anon_sym_alignas] = ACTIONS(2457),
    [anon_sym__Alignas] = ACTIONS(2457),
    [sym_primitive_type] = ACTIONS(2457),
    [anon_sym_enum] = ACTIONS(2457),
    [anon_sym_class] = ACTIONS(2457),
    [anon_sym_struct] = ACTIONS(2457),
    [anon_sym_union] = ACTIONS(2457),
    [anon_sym_if] = ACTIONS(2457),
    [anon_sym_switch] = ACTIONS(2457),
    [anon_sym_case] = ACTIONS(2457),
    [anon_sym_default] = ACTIONS(2457),
    [anon_sym_while] = ACTIONS(2457),
    [anon_sym_do] = ACTIONS(2457),
    [anon_sym_for] = ACTIONS(2457),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_break] = ACTIONS(2457),
    [anon_sym_continue] = ACTIONS(2457),
    [anon_sym_goto] = ACTIONS(2457),
    [anon_sym___try] = ACTIONS(2457),
    [anon_sym___leave] = ACTIONS(2457),
    [anon_sym_not] = ACTIONS(2457),
    [anon_sym_compl] = ACTIONS(2457),
    [anon_sym_DASH_DASH] = ACTIONS(2459),
    [anon_sym_PLUS_PLUS] = ACTIONS(2459),
    [anon_sym_sizeof] = ACTIONS(2457),
    [anon_sym___alignof__] = ACTIONS(2457),
    [anon_sym___alignof] = ACTIONS(2457),
    [anon_sym__alignof] = ACTIONS(2457),
    [anon_sym_alignof] = ACTIONS(2457),
    [anon_sym__Alignof] = ACTIONS(2457),
    [anon_sym_offsetof] = ACTIONS(2457),
    [anon_sym__Generic] = ACTIONS(2457),
    [anon_sym_asm] = ACTIONS(2457),
    [anon_sym___asm__] = ACTIONS(2457),
    [sym_number_literal] = ACTIONS(2459),
    [anon_sym_L_SQUOTE] = ACTIONS(2459),
    [anon_sym_u_SQUOTE] = ACTIONS(2459),
    [anon_sym_U_SQUOTE] = ACTIONS(2459),
    [anon_sym_u8_SQUOTE] = ACTIONS(2459),
    [anon_sym_SQUOTE] = ACTIONS(2459),
    [anon_sym_L_DQUOTE] = ACTIONS(2459),
    [anon_sym_u_DQUOTE] = ACTIONS(2459),
    [anon_sym_U_DQUOTE] = ACTIONS(2459),
    [anon_sym_u8_DQUOTE] = ACTIONS(2459),
    [anon_sym_DQUOTE] = ACTIONS(2459),
    [sym_true] = ACTIONS(2457),
    [sym_false] = ACTIONS(2457),
    [anon_sym_NULL] = ACTIONS(2457),
    [anon_sym_nullptr] = ACTIONS(2457),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2457),
    [anon_sym_decltype] = ACTIONS(2457),
    [sym_virtual] = ACTIONS(2457),
    [anon_sym_explicit] = ACTIONS(2457),
    [anon_sym_typename] = ACTIONS(2457),
    [anon_sym_template] = ACTIONS(2457),
    [anon_sym_operator] = ACTIONS(2457),
    [anon_sym_try] = ACTIONS(2457),
    [anon_sym_delete] = ACTIONS(2457),
    [anon_sym_throw] = ACTIONS(2457),
    [anon_sym_namespace] = ACTIONS(2457),
    [anon_sym_using] = ACTIONS(2457),
    [anon_sym_static_assert] = ACTIONS(2457),
    [anon_sym_concept] = ACTIONS(2457),
    [anon_sym_co_return] = ACTIONS(2457),
    [anon_sym_co_yield] = ACTIONS(2457),
    [anon_sym_R_DQUOTE] = ACTIONS(2459),
    [anon_sym_LR_DQUOTE] = ACTIONS(2459),
    [anon_sym_uR_DQUOTE] = ACTIONS(2459),
    [anon_sym_UR_DQUOTE] = ACTIONS(2459),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2459),
    [anon_sym_co_await] = ACTIONS(2457),
    [anon_sym_new] = ACTIONS(2457),
    [anon_sym_requires] = ACTIONS(2457),
    [sym_this] = ACTIONS(2457),
    [anon_sym___launch_bounds__] = ACTIONS(2457),
  },
  [519] = {
    [sym_identifier] = ACTIONS(2330),
    [aux_sym_preproc_include_token1] = ACTIONS(2330),
    [aux_sym_preproc_def_token1] = ACTIONS(2330),
    [aux_sym_preproc_if_token1] = ACTIONS(2330),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2330),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2330),
    [sym_preproc_directive] = ACTIONS(2330),
    [anon_sym_LPAREN2] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2332),
    [anon_sym_TILDE] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(2330),
    [anon_sym_STAR] = ACTIONS(2332),
    [anon_sym_AMP_AMP] = ACTIONS(2332),
    [anon_sym_AMP] = ACTIONS(2330),
    [anon_sym_SEMI] = ACTIONS(2332),
    [anon_sym___extension__] = ACTIONS(2330),
    [anon_sym_typedef] = ACTIONS(2330),
    [anon_sym___device__] = ACTIONS(2330),
    [anon_sym___host__] = ACTIONS(2330),
    [anon_sym___global__] = ACTIONS(2330),
    [anon_sym___forceinline__] = ACTIONS(2330),
    [anon_sym___noinline__] = ACTIONS(2330),
    [anon_sym_extern] = ACTIONS(2330),
    [anon_sym___attribute__] = ACTIONS(2330),
    [anon_sym_COLON_COLON] = ACTIONS(2332),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2332),
    [anon_sym___declspec] = ACTIONS(2330),
    [anon_sym___based] = ACTIONS(2330),
    [anon_sym___cdecl] = ACTIONS(2330),
    [anon_sym___clrcall] = ACTIONS(2330),
    [anon_sym___stdcall] = ACTIONS(2330),
    [anon_sym___fastcall] = ACTIONS(2330),
    [anon_sym___thiscall] = ACTIONS(2330),
    [anon_sym___vectorcall] = ACTIONS(2330),
    [anon_sym_LBRACE] = ACTIONS(2332),
    [anon_sym_RBRACE] = ACTIONS(2332),
    [anon_sym_signed] = ACTIONS(2330),
    [anon_sym_unsigned] = ACTIONS(2330),
    [anon_sym_long] = ACTIONS(2330),
    [anon_sym_short] = ACTIONS(2330),
    [anon_sym_LBRACK] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2330),
    [anon_sym_register] = ACTIONS(2330),
    [anon_sym_inline] = ACTIONS(2330),
    [anon_sym___inline] = ACTIONS(2330),
    [anon_sym___inline__] = ACTIONS(2330),
    [anon_sym___forceinline] = ACTIONS(2330),
    [anon_sym_thread_local] = ACTIONS(2330),
    [anon_sym___thread] = ACTIONS(2330),
    [anon_sym_const] = ACTIONS(2330),
    [anon_sym_constexpr] = ACTIONS(2330),
    [anon_sym_volatile] = ACTIONS(2330),
    [anon_sym_restrict] = ACTIONS(2330),
    [anon_sym___restrict__] = ACTIONS(2330),
    [anon_sym__Atomic] = ACTIONS(2330),
    [anon_sym__Noreturn] = ACTIONS(2330),
    [anon_sym_noreturn] = ACTIONS(2330),
    [anon_sym_mutable] = ACTIONS(2330),
    [anon_sym_constinit] = ACTIONS(2330),
    [anon_sym_consteval] = ACTIONS(2330),
    [anon_sym___shared__] = ACTIONS(2330),
    [anon_sym___local__] = ACTIONS(2330),
    [anon_sym___constant__] = ACTIONS(2330),
    [anon_sym___managed__] = ACTIONS(2330),
    [anon_sym___grid_constant__] = ACTIONS(2330),
    [anon_sym_alignas] = ACTIONS(2330),
    [anon_sym__Alignas] = ACTIONS(2330),
    [sym_primitive_type] = ACTIONS(2330),
    [anon_sym_enum] = ACTIONS(2330),
    [anon_sym_class] = ACTIONS(2330),
    [anon_sym_struct] = ACTIONS(2330),
    [anon_sym_union] = ACTIONS(2330),
    [anon_sym_if] = ACTIONS(2330),
    [anon_sym_switch] = ACTIONS(2330),
    [anon_sym_case] = ACTIONS(2330),
    [anon_sym_default] = ACTIONS(2330),
    [anon_sym_while] = ACTIONS(2330),
    [anon_sym_do] = ACTIONS(2330),
    [anon_sym_for] = ACTIONS(2330),
    [anon_sym_return] = ACTIONS(2330),
    [anon_sym_break] = ACTIONS(2330),
    [anon_sym_continue] = ACTIONS(2330),
    [anon_sym_goto] = ACTIONS(2330),
    [anon_sym___try] = ACTIONS(2330),
    [anon_sym___leave] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2330),
    [anon_sym_compl] = ACTIONS(2330),
    [anon_sym_DASH_DASH] = ACTIONS(2332),
    [anon_sym_PLUS_PLUS] = ACTIONS(2332),
    [anon_sym_sizeof] = ACTIONS(2330),
    [anon_sym___alignof__] = ACTIONS(2330),
    [anon_sym___alignof] = ACTIONS(2330),
    [anon_sym__alignof] = ACTIONS(2330),
    [anon_sym_alignof] = ACTIONS(2330),
    [anon_sym__Alignof] = ACTIONS(2330),
    [anon_sym_offsetof] = ACTIONS(2330),
    [anon_sym__Generic] = ACTIONS(2330),
    [anon_sym_asm] = ACTIONS(2330),
    [anon_sym___asm__] = ACTIONS(2330),
    [sym_number_literal] = ACTIONS(2332),
    [anon_sym_L_SQUOTE] = ACTIONS(2332),
    [anon_sym_u_SQUOTE] = ACTIONS(2332),
    [anon_sym_U_SQUOTE] = ACTIONS(2332),
    [anon_sym_u8_SQUOTE] = ACTIONS(2332),
    [anon_sym_SQUOTE] = ACTIONS(2332),
    [anon_sym_L_DQUOTE] = ACTIONS(2332),
    [anon_sym_u_DQUOTE] = ACTIONS(2332),
    [anon_sym_U_DQUOTE] = ACTIONS(2332),
    [anon_sym_u8_DQUOTE] = ACTIONS(2332),
    [anon_sym_DQUOTE] = ACTIONS(2332),
    [sym_true] = ACTIONS(2330),
    [sym_false] = ACTIONS(2330),
    [anon_sym_NULL] = ACTIONS(2330),
    [anon_sym_nullptr] = ACTIONS(2330),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2330),
    [anon_sym_decltype] = ACTIONS(2330),
    [sym_virtual] = ACTIONS(2330),
    [anon_sym_explicit] = ACTIONS(2330),
    [anon_sym_typename] = ACTIONS(2330),
    [anon_sym_template] = ACTIONS(2330),
    [anon_sym_operator] = ACTIONS(2330),
    [anon_sym_try] = ACTIONS(2330),
    [anon_sym_delete] = ACTIONS(2330),
    [anon_sym_throw] = ACTIONS(2330),
    [anon_sym_namespace] = ACTIONS(2330),
    [anon_sym_using] = ACTIONS(2330),
    [anon_sym_static_assert] = ACTIONS(2330),
    [anon_sym_concept] = ACTIONS(2330),
    [anon_sym_co_return] = ACTIONS(2330),
    [anon_sym_co_yield] = ACTIONS(2330),
    [anon_sym_R_DQUOTE] = ACTIONS(2332),
    [anon_sym_LR_DQUOTE] = ACTIONS(2332),
    [anon_sym_uR_DQUOTE] = ACTIONS(2332),
    [anon_sym_UR_DQUOTE] = ACTIONS(2332),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2332),
    [anon_sym_co_await] = ACTIONS(2330),
    [anon_sym_new] = ACTIONS(2330),
    [anon_sym_requires] = ACTIONS(2330),
    [sym_this] = ACTIONS(2330),
    [anon_sym___launch_bounds__] = ACTIONS(2330),
  },
  [520] = {
    [sym_identifier] = ACTIONS(2334),
    [aux_sym_preproc_include_token1] = ACTIONS(2334),
    [aux_sym_preproc_def_token1] = ACTIONS(2334),
    [aux_sym_preproc_if_token1] = ACTIONS(2334),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2334),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2334),
    [sym_preproc_directive] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(2336),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [anon_sym_DASH] = ACTIONS(2334),
    [anon_sym_PLUS] = ACTIONS(2334),
    [anon_sym_STAR] = ACTIONS(2336),
    [anon_sym_AMP_AMP] = ACTIONS(2336),
    [anon_sym_AMP] = ACTIONS(2334),
    [anon_sym_SEMI] = ACTIONS(2336),
    [anon_sym___extension__] = ACTIONS(2334),
    [anon_sym_typedef] = ACTIONS(2334),
    [anon_sym___device__] = ACTIONS(2334),
    [anon_sym___host__] = ACTIONS(2334),
    [anon_sym___global__] = ACTIONS(2334),
    [anon_sym___forceinline__] = ACTIONS(2334),
    [anon_sym___noinline__] = ACTIONS(2334),
    [anon_sym_extern] = ACTIONS(2334),
    [anon_sym___attribute__] = ACTIONS(2334),
    [anon_sym_COLON_COLON] = ACTIONS(2336),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2336),
    [anon_sym___declspec] = ACTIONS(2334),
    [anon_sym___based] = ACTIONS(2334),
    [anon_sym___cdecl] = ACTIONS(2334),
    [anon_sym___clrcall] = ACTIONS(2334),
    [anon_sym___stdcall] = ACTIONS(2334),
    [anon_sym___fastcall] = ACTIONS(2334),
    [anon_sym___thiscall] = ACTIONS(2334),
    [anon_sym___vectorcall] = ACTIONS(2334),
    [anon_sym_LBRACE] = ACTIONS(2336),
    [anon_sym_RBRACE] = ACTIONS(2336),
    [anon_sym_signed] = ACTIONS(2334),
    [anon_sym_unsigned] = ACTIONS(2334),
    [anon_sym_long] = ACTIONS(2334),
    [anon_sym_short] = ACTIONS(2334),
    [anon_sym_LBRACK] = ACTIONS(2334),
    [anon_sym_static] = ACTIONS(2334),
    [anon_sym_register] = ACTIONS(2334),
    [anon_sym_inline] = ACTIONS(2334),
    [anon_sym___inline] = ACTIONS(2334),
    [anon_sym___inline__] = ACTIONS(2334),
    [anon_sym___forceinline] = ACTIONS(2334),
    [anon_sym_thread_local] = ACTIONS(2334),
    [anon_sym___thread] = ACTIONS(2334),
    [anon_sym_const] = ACTIONS(2334),
    [anon_sym_constexpr] = ACTIONS(2334),
    [anon_sym_volatile] = ACTIONS(2334),
    [anon_sym_restrict] = ACTIONS(2334),
    [anon_sym___restrict__] = ACTIONS(2334),
    [anon_sym__Atomic] = ACTIONS(2334),
    [anon_sym__Noreturn] = ACTIONS(2334),
    [anon_sym_noreturn] = ACTIONS(2334),
    [anon_sym_mutable] = ACTIONS(2334),
    [anon_sym_constinit] = ACTIONS(2334),
    [anon_sym_consteval] = ACTIONS(2334),
    [anon_sym___shared__] = ACTIONS(2334),
    [anon_sym___local__] = ACTIONS(2334),
    [anon_sym___constant__] = ACTIONS(2334),
    [anon_sym___managed__] = ACTIONS(2334),
    [anon_sym___grid_constant__] = ACTIONS(2334),
    [anon_sym_alignas] = ACTIONS(2334),
    [anon_sym__Alignas] = ACTIONS(2334),
    [sym_primitive_type] = ACTIONS(2334),
    [anon_sym_enum] = ACTIONS(2334),
    [anon_sym_class] = ACTIONS(2334),
    [anon_sym_struct] = ACTIONS(2334),
    [anon_sym_union] = ACTIONS(2334),
    [anon_sym_if] = ACTIONS(2334),
    [anon_sym_switch] = ACTIONS(2334),
    [anon_sym_case] = ACTIONS(2334),
    [anon_sym_default] = ACTIONS(2334),
    [anon_sym_while] = ACTIONS(2334),
    [anon_sym_do] = ACTIONS(2334),
    [anon_sym_for] = ACTIONS(2334),
    [anon_sym_return] = ACTIONS(2334),
    [anon_sym_break] = ACTIONS(2334),
    [anon_sym_continue] = ACTIONS(2334),
    [anon_sym_goto] = ACTIONS(2334),
    [anon_sym___try] = ACTIONS(2334),
    [anon_sym___leave] = ACTIONS(2334),
    [anon_sym_not] = ACTIONS(2334),
    [anon_sym_compl] = ACTIONS(2334),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_sizeof] = ACTIONS(2334),
    [anon_sym___alignof__] = ACTIONS(2334),
    [anon_sym___alignof] = ACTIONS(2334),
    [anon_sym__alignof] = ACTIONS(2334),
    [anon_sym_alignof] = ACTIONS(2334),
    [anon_sym__Alignof] = ACTIONS(2334),
    [anon_sym_offsetof] = ACTIONS(2334),
    [anon_sym__Generic] = ACTIONS(2334),
    [anon_sym_asm] = ACTIONS(2334),
    [anon_sym___asm__] = ACTIONS(2334),
    [sym_number_literal] = ACTIONS(2336),
    [anon_sym_L_SQUOTE] = ACTIONS(2336),
    [anon_sym_u_SQUOTE] = ACTIONS(2336),
    [anon_sym_U_SQUOTE] = ACTIONS(2336),
    [anon_sym_u8_SQUOTE] = ACTIONS(2336),
    [anon_sym_SQUOTE] = ACTIONS(2336),
    [anon_sym_L_DQUOTE] = ACTIONS(2336),
    [anon_sym_u_DQUOTE] = ACTIONS(2336),
    [anon_sym_U_DQUOTE] = ACTIONS(2336),
    [anon_sym_u8_DQUOTE] = ACTIONS(2336),
    [anon_sym_DQUOTE] = ACTIONS(2336),
    [sym_true] = ACTIONS(2334),
    [sym_false] = ACTIONS(2334),
    [anon_sym_NULL] = ACTIONS(2334),
    [anon_sym_nullptr] = ACTIONS(2334),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2334),
    [anon_sym_decltype] = ACTIONS(2334),
    [sym_virtual] = ACTIONS(2334),
    [anon_sym_explicit] = ACTIONS(2334),
    [anon_sym_typename] = ACTIONS(2334),
    [anon_sym_template] = ACTIONS(2334),
    [anon_sym_operator] = ACTIONS(2334),
    [anon_sym_try] = ACTIONS(2334),
    [anon_sym_delete] = ACTIONS(2334),
    [anon_sym_throw] = ACTIONS(2334),
    [anon_sym_namespace] = ACTIONS(2334),
    [anon_sym_using] = ACTIONS(2334),
    [anon_sym_static_assert] = ACTIONS(2334),
    [anon_sym_concept] = ACTIONS(2334),
    [anon_sym_co_return] = ACTIONS(2334),
    [anon_sym_co_yield] = ACTIONS(2334),
    [anon_sym_R_DQUOTE] = ACTIONS(2336),
    [anon_sym_LR_DQUOTE] = ACTIONS(2336),
    [anon_sym_uR_DQUOTE] = ACTIONS(2336),
    [anon_sym_UR_DQUOTE] = ACTIONS(2336),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2336),
    [anon_sym_co_await] = ACTIONS(2334),
    [anon_sym_new] = ACTIONS(2334),
    [anon_sym_requires] = ACTIONS(2334),
    [sym_this] = ACTIONS(2334),
    [anon_sym___launch_bounds__] = ACTIONS(2334),
  },
  [521] = {
    [sym_identifier] = ACTIONS(2473),
    [aux_sym_preproc_include_token1] = ACTIONS(2473),
    [aux_sym_preproc_def_token1] = ACTIONS(2473),
    [aux_sym_preproc_if_token1] = ACTIONS(2473),
    [aux_sym_preproc_if_token2] = ACTIONS(2473),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2473),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2473),
    [sym_preproc_directive] = ACTIONS(2473),
    [anon_sym_LPAREN2] = ACTIONS(2475),
    [anon_sym_BANG] = ACTIONS(2475),
    [anon_sym_TILDE] = ACTIONS(2475),
    [anon_sym_DASH] = ACTIONS(2473),
    [anon_sym_PLUS] = ACTIONS(2473),
    [anon_sym_STAR] = ACTIONS(2475),
    [anon_sym_AMP_AMP] = ACTIONS(2475),
    [anon_sym_AMP] = ACTIONS(2473),
    [anon_sym_SEMI] = ACTIONS(2475),
    [anon_sym___extension__] = ACTIONS(2473),
    [anon_sym_typedef] = ACTIONS(2473),
    [anon_sym___device__] = ACTIONS(2473),
    [anon_sym___host__] = ACTIONS(2473),
    [anon_sym___global__] = ACTIONS(2473),
    [anon_sym___forceinline__] = ACTIONS(2473),
    [anon_sym___noinline__] = ACTIONS(2473),
    [anon_sym_extern] = ACTIONS(2473),
    [anon_sym___attribute__] = ACTIONS(2473),
    [anon_sym_COLON_COLON] = ACTIONS(2475),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2475),
    [anon_sym___declspec] = ACTIONS(2473),
    [anon_sym___based] = ACTIONS(2473),
    [anon_sym___cdecl] = ACTIONS(2473),
    [anon_sym___clrcall] = ACTIONS(2473),
    [anon_sym___stdcall] = ACTIONS(2473),
    [anon_sym___fastcall] = ACTIONS(2473),
    [anon_sym___thiscall] = ACTIONS(2473),
    [anon_sym___vectorcall] = ACTIONS(2473),
    [anon_sym_LBRACE] = ACTIONS(2475),
    [anon_sym_signed] = ACTIONS(2473),
    [anon_sym_unsigned] = ACTIONS(2473),
    [anon_sym_long] = ACTIONS(2473),
    [anon_sym_short] = ACTIONS(2473),
    [anon_sym_LBRACK] = ACTIONS(2473),
    [anon_sym_static] = ACTIONS(2473),
    [anon_sym_register] = ACTIONS(2473),
    [anon_sym_inline] = ACTIONS(2473),
    [anon_sym___inline] = ACTIONS(2473),
    [anon_sym___inline__] = ACTIONS(2473),
    [anon_sym___forceinline] = ACTIONS(2473),
    [anon_sym_thread_local] = ACTIONS(2473),
    [anon_sym___thread] = ACTIONS(2473),
    [anon_sym_const] = ACTIONS(2473),
    [anon_sym_constexpr] = ACTIONS(2473),
    [anon_sym_volatile] = ACTIONS(2473),
    [anon_sym_restrict] = ACTIONS(2473),
    [anon_sym___restrict__] = ACTIONS(2473),
    [anon_sym__Atomic] = ACTIONS(2473),
    [anon_sym__Noreturn] = ACTIONS(2473),
    [anon_sym_noreturn] = ACTIONS(2473),
    [anon_sym_mutable] = ACTIONS(2473),
    [anon_sym_constinit] = ACTIONS(2473),
    [anon_sym_consteval] = ACTIONS(2473),
    [anon_sym___shared__] = ACTIONS(2473),
    [anon_sym___local__] = ACTIONS(2473),
    [anon_sym___constant__] = ACTIONS(2473),
    [anon_sym___managed__] = ACTIONS(2473),
    [anon_sym___grid_constant__] = ACTIONS(2473),
    [anon_sym_alignas] = ACTIONS(2473),
    [anon_sym__Alignas] = ACTIONS(2473),
    [sym_primitive_type] = ACTIONS(2473),
    [anon_sym_enum] = ACTIONS(2473),
    [anon_sym_class] = ACTIONS(2473),
    [anon_sym_struct] = ACTIONS(2473),
    [anon_sym_union] = ACTIONS(2473),
    [anon_sym_if] = ACTIONS(2473),
    [anon_sym_switch] = ACTIONS(2473),
    [anon_sym_case] = ACTIONS(2473),
    [anon_sym_default] = ACTIONS(2473),
    [anon_sym_while] = ACTIONS(2473),
    [anon_sym_do] = ACTIONS(2473),
    [anon_sym_for] = ACTIONS(2473),
    [anon_sym_return] = ACTIONS(2473),
    [anon_sym_break] = ACTIONS(2473),
    [anon_sym_continue] = ACTIONS(2473),
    [anon_sym_goto] = ACTIONS(2473),
    [anon_sym___try] = ACTIONS(2473),
    [anon_sym___leave] = ACTIONS(2473),
    [anon_sym_not] = ACTIONS(2473),
    [anon_sym_compl] = ACTIONS(2473),
    [anon_sym_DASH_DASH] = ACTIONS(2475),
    [anon_sym_PLUS_PLUS] = ACTIONS(2475),
    [anon_sym_sizeof] = ACTIONS(2473),
    [anon_sym___alignof__] = ACTIONS(2473),
    [anon_sym___alignof] = ACTIONS(2473),
    [anon_sym__alignof] = ACTIONS(2473),
    [anon_sym_alignof] = ACTIONS(2473),
    [anon_sym__Alignof] = ACTIONS(2473),
    [anon_sym_offsetof] = ACTIONS(2473),
    [anon_sym__Generic] = ACTIONS(2473),
    [anon_sym_asm] = ACTIONS(2473),
    [anon_sym___asm__] = ACTIONS(2473),
    [sym_number_literal] = ACTIONS(2475),
    [anon_sym_L_SQUOTE] = ACTIONS(2475),
    [anon_sym_u_SQUOTE] = ACTIONS(2475),
    [anon_sym_U_SQUOTE] = ACTIONS(2475),
    [anon_sym_u8_SQUOTE] = ACTIONS(2475),
    [anon_sym_SQUOTE] = ACTIONS(2475),
    [anon_sym_L_DQUOTE] = ACTIONS(2475),
    [anon_sym_u_DQUOTE] = ACTIONS(2475),
    [anon_sym_U_DQUOTE] = ACTIONS(2475),
    [anon_sym_u8_DQUOTE] = ACTIONS(2475),
    [anon_sym_DQUOTE] = ACTIONS(2475),
    [sym_true] = ACTIONS(2473),
    [sym_false] = ACTIONS(2473),
    [anon_sym_NULL] = ACTIONS(2473),
    [anon_sym_nullptr] = ACTIONS(2473),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2473),
    [anon_sym_decltype] = ACTIONS(2473),
    [sym_virtual] = ACTIONS(2473),
    [anon_sym_explicit] = ACTIONS(2473),
    [anon_sym_typename] = ACTIONS(2473),
    [anon_sym_template] = ACTIONS(2473),
    [anon_sym_operator] = ACTIONS(2473),
    [anon_sym_try] = ACTIONS(2473),
    [anon_sym_delete] = ACTIONS(2473),
    [anon_sym_throw] = ACTIONS(2473),
    [anon_sym_namespace] = ACTIONS(2473),
    [anon_sym_using] = ACTIONS(2473),
    [anon_sym_static_assert] = ACTIONS(2473),
    [anon_sym_concept] = ACTIONS(2473),
    [anon_sym_co_return] = ACTIONS(2473),
    [anon_sym_co_yield] = ACTIONS(2473),
    [anon_sym_R_DQUOTE] = ACTIONS(2475),
    [anon_sym_LR_DQUOTE] = ACTIONS(2475),
    [anon_sym_uR_DQUOTE] = ACTIONS(2475),
    [anon_sym_UR_DQUOTE] = ACTIONS(2475),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2475),
    [anon_sym_co_await] = ACTIONS(2473),
    [anon_sym_new] = ACTIONS(2473),
    [anon_sym_requires] = ACTIONS(2473),
    [sym_this] = ACTIONS(2473),
    [anon_sym___launch_bounds__] = ACTIONS(2473),
  },
  [522] = {
    [sym_identifier] = ACTIONS(2436),
    [aux_sym_preproc_include_token1] = ACTIONS(2436),
    [aux_sym_preproc_def_token1] = ACTIONS(2436),
    [aux_sym_preproc_if_token1] = ACTIONS(2436),
    [aux_sym_preproc_if_token2] = ACTIONS(2436),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2436),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2436),
    [sym_preproc_directive] = ACTIONS(2436),
    [anon_sym_LPAREN2] = ACTIONS(2438),
    [anon_sym_BANG] = ACTIONS(2438),
    [anon_sym_TILDE] = ACTIONS(2438),
    [anon_sym_DASH] = ACTIONS(2436),
    [anon_sym_PLUS] = ACTIONS(2436),
    [anon_sym_STAR] = ACTIONS(2438),
    [anon_sym_AMP_AMP] = ACTIONS(2438),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym_SEMI] = ACTIONS(2438),
    [anon_sym___extension__] = ACTIONS(2436),
    [anon_sym_typedef] = ACTIONS(2436),
    [anon_sym___device__] = ACTIONS(2436),
    [anon_sym___host__] = ACTIONS(2436),
    [anon_sym___global__] = ACTIONS(2436),
    [anon_sym___forceinline__] = ACTIONS(2436),
    [anon_sym___noinline__] = ACTIONS(2436),
    [anon_sym_extern] = ACTIONS(2436),
    [anon_sym___attribute__] = ACTIONS(2436),
    [anon_sym_COLON_COLON] = ACTIONS(2438),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2438),
    [anon_sym___declspec] = ACTIONS(2436),
    [anon_sym___based] = ACTIONS(2436),
    [anon_sym___cdecl] = ACTIONS(2436),
    [anon_sym___clrcall] = ACTIONS(2436),
    [anon_sym___stdcall] = ACTIONS(2436),
    [anon_sym___fastcall] = ACTIONS(2436),
    [anon_sym___thiscall] = ACTIONS(2436),
    [anon_sym___vectorcall] = ACTIONS(2436),
    [anon_sym_LBRACE] = ACTIONS(2438),
    [anon_sym_signed] = ACTIONS(2436),
    [anon_sym_unsigned] = ACTIONS(2436),
    [anon_sym_long] = ACTIONS(2436),
    [anon_sym_short] = ACTIONS(2436),
    [anon_sym_LBRACK] = ACTIONS(2436),
    [anon_sym_static] = ACTIONS(2436),
    [anon_sym_register] = ACTIONS(2436),
    [anon_sym_inline] = ACTIONS(2436),
    [anon_sym___inline] = ACTIONS(2436),
    [anon_sym___inline__] = ACTIONS(2436),
    [anon_sym___forceinline] = ACTIONS(2436),
    [anon_sym_thread_local] = ACTIONS(2436),
    [anon_sym___thread] = ACTIONS(2436),
    [anon_sym_const] = ACTIONS(2436),
    [anon_sym_constexpr] = ACTIONS(2436),
    [anon_sym_volatile] = ACTIONS(2436),
    [anon_sym_restrict] = ACTIONS(2436),
    [anon_sym___restrict__] = ACTIONS(2436),
    [anon_sym__Atomic] = ACTIONS(2436),
    [anon_sym__Noreturn] = ACTIONS(2436),
    [anon_sym_noreturn] = ACTIONS(2436),
    [anon_sym_mutable] = ACTIONS(2436),
    [anon_sym_constinit] = ACTIONS(2436),
    [anon_sym_consteval] = ACTIONS(2436),
    [anon_sym___shared__] = ACTIONS(2436),
    [anon_sym___local__] = ACTIONS(2436),
    [anon_sym___constant__] = ACTIONS(2436),
    [anon_sym___managed__] = ACTIONS(2436),
    [anon_sym___grid_constant__] = ACTIONS(2436),
    [anon_sym_alignas] = ACTIONS(2436),
    [anon_sym__Alignas] = ACTIONS(2436),
    [sym_primitive_type] = ACTIONS(2436),
    [anon_sym_enum] = ACTIONS(2436),
    [anon_sym_class] = ACTIONS(2436),
    [anon_sym_struct] = ACTIONS(2436),
    [anon_sym_union] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(2436),
    [anon_sym_switch] = ACTIONS(2436),
    [anon_sym_case] = ACTIONS(2436),
    [anon_sym_default] = ACTIONS(2436),
    [anon_sym_while] = ACTIONS(2436),
    [anon_sym_do] = ACTIONS(2436),
    [anon_sym_for] = ACTIONS(2436),
    [anon_sym_return] = ACTIONS(2436),
    [anon_sym_break] = ACTIONS(2436),
    [anon_sym_continue] = ACTIONS(2436),
    [anon_sym_goto] = ACTIONS(2436),
    [anon_sym___try] = ACTIONS(2436),
    [anon_sym___leave] = ACTIONS(2436),
    [anon_sym_not] = ACTIONS(2436),
    [anon_sym_compl] = ACTIONS(2436),
    [anon_sym_DASH_DASH] = ACTIONS(2438),
    [anon_sym_PLUS_PLUS] = ACTIONS(2438),
    [anon_sym_sizeof] = ACTIONS(2436),
    [anon_sym___alignof__] = ACTIONS(2436),
    [anon_sym___alignof] = ACTIONS(2436),
    [anon_sym__alignof] = ACTIONS(2436),
    [anon_sym_alignof] = ACTIONS(2436),
    [anon_sym__Alignof] = ACTIONS(2436),
    [anon_sym_offsetof] = ACTIONS(2436),
    [anon_sym__Generic] = ACTIONS(2436),
    [anon_sym_asm] = ACTIONS(2436),
    [anon_sym___asm__] = ACTIONS(2436),
    [sym_number_literal] = ACTIONS(2438),
    [anon_sym_L_SQUOTE] = ACTIONS(2438),
    [anon_sym_u_SQUOTE] = ACTIONS(2438),
    [anon_sym_U_SQUOTE] = ACTIONS(2438),
    [anon_sym_u8_SQUOTE] = ACTIONS(2438),
    [anon_sym_SQUOTE] = ACTIONS(2438),
    [anon_sym_L_DQUOTE] = ACTIONS(2438),
    [anon_sym_u_DQUOTE] = ACTIONS(2438),
    [anon_sym_U_DQUOTE] = ACTIONS(2438),
    [anon_sym_u8_DQUOTE] = ACTIONS(2438),
    [anon_sym_DQUOTE] = ACTIONS(2438),
    [sym_true] = ACTIONS(2436),
    [sym_false] = ACTIONS(2436),
    [anon_sym_NULL] = ACTIONS(2436),
    [anon_sym_nullptr] = ACTIONS(2436),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2436),
    [anon_sym_decltype] = ACTIONS(2436),
    [sym_virtual] = ACTIONS(2436),
    [anon_sym_explicit] = ACTIONS(2436),
    [anon_sym_typename] = ACTIONS(2436),
    [anon_sym_template] = ACTIONS(2436),
    [anon_sym_operator] = ACTIONS(2436),
    [anon_sym_try] = ACTIONS(2436),
    [anon_sym_delete] = ACTIONS(2436),
    [anon_sym_throw] = ACTIONS(2436),
    [anon_sym_namespace] = ACTIONS(2436),
    [anon_sym_using] = ACTIONS(2436),
    [anon_sym_static_assert] = ACTIONS(2436),
    [anon_sym_concept] = ACTIONS(2436),
    [anon_sym_co_return] = ACTIONS(2436),
    [anon_sym_co_yield] = ACTIONS(2436),
    [anon_sym_R_DQUOTE] = ACTIONS(2438),
    [anon_sym_LR_DQUOTE] = ACTIONS(2438),
    [anon_sym_uR_DQUOTE] = ACTIONS(2438),
    [anon_sym_UR_DQUOTE] = ACTIONS(2438),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2438),
    [anon_sym_co_await] = ACTIONS(2436),
    [anon_sym_new] = ACTIONS(2436),
    [anon_sym_requires] = ACTIONS(2436),
    [sym_this] = ACTIONS(2436),
    [anon_sym___launch_bounds__] = ACTIONS(2436),
  },
  [523] = {
    [sym_identifier] = ACTIONS(2231),
    [aux_sym_preproc_include_token1] = ACTIONS(2231),
    [aux_sym_preproc_def_token1] = ACTIONS(2231),
    [aux_sym_preproc_if_token1] = ACTIONS(2231),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2231),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2231),
    [sym_preproc_directive] = ACTIONS(2231),
    [anon_sym_LPAREN2] = ACTIONS(2233),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym_SEMI] = ACTIONS(2233),
    [anon_sym___extension__] = ACTIONS(2231),
    [anon_sym_typedef] = ACTIONS(2231),
    [anon_sym___device__] = ACTIONS(2231),
    [anon_sym___host__] = ACTIONS(2231),
    [anon_sym___global__] = ACTIONS(2231),
    [anon_sym___forceinline__] = ACTIONS(2231),
    [anon_sym___noinline__] = ACTIONS(2231),
    [anon_sym_extern] = ACTIONS(2231),
    [anon_sym___attribute__] = ACTIONS(2231),
    [anon_sym_COLON_COLON] = ACTIONS(2233),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2233),
    [anon_sym___declspec] = ACTIONS(2231),
    [anon_sym___based] = ACTIONS(2231),
    [anon_sym___cdecl] = ACTIONS(2231),
    [anon_sym___clrcall] = ACTIONS(2231),
    [anon_sym___stdcall] = ACTIONS(2231),
    [anon_sym___fastcall] = ACTIONS(2231),
    [anon_sym___thiscall] = ACTIONS(2231),
    [anon_sym___vectorcall] = ACTIONS(2231),
    [anon_sym_LBRACE] = ACTIONS(2233),
    [anon_sym_RBRACE] = ACTIONS(2233),
    [anon_sym_signed] = ACTIONS(2231),
    [anon_sym_unsigned] = ACTIONS(2231),
    [anon_sym_long] = ACTIONS(2231),
    [anon_sym_short] = ACTIONS(2231),
    [anon_sym_LBRACK] = ACTIONS(2231),
    [anon_sym_static] = ACTIONS(2231),
    [anon_sym_register] = ACTIONS(2231),
    [anon_sym_inline] = ACTIONS(2231),
    [anon_sym___inline] = ACTIONS(2231),
    [anon_sym___inline__] = ACTIONS(2231),
    [anon_sym___forceinline] = ACTIONS(2231),
    [anon_sym_thread_local] = ACTIONS(2231),
    [anon_sym___thread] = ACTIONS(2231),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_constexpr] = ACTIONS(2231),
    [anon_sym_volatile] = ACTIONS(2231),
    [anon_sym_restrict] = ACTIONS(2231),
    [anon_sym___restrict__] = ACTIONS(2231),
    [anon_sym__Atomic] = ACTIONS(2231),
    [anon_sym__Noreturn] = ACTIONS(2231),
    [anon_sym_noreturn] = ACTIONS(2231),
    [anon_sym_mutable] = ACTIONS(2231),
    [anon_sym_constinit] = ACTIONS(2231),
    [anon_sym_consteval] = ACTIONS(2231),
    [anon_sym___shared__] = ACTIONS(2231),
    [anon_sym___local__] = ACTIONS(2231),
    [anon_sym___constant__] = ACTIONS(2231),
    [anon_sym___managed__] = ACTIONS(2231),
    [anon_sym___grid_constant__] = ACTIONS(2231),
    [anon_sym_alignas] = ACTIONS(2231),
    [anon_sym__Alignas] = ACTIONS(2231),
    [sym_primitive_type] = ACTIONS(2231),
    [anon_sym_enum] = ACTIONS(2231),
    [anon_sym_class] = ACTIONS(2231),
    [anon_sym_struct] = ACTIONS(2231),
    [anon_sym_union] = ACTIONS(2231),
    [anon_sym_if] = ACTIONS(2231),
    [anon_sym_switch] = ACTIONS(2231),
    [anon_sym_case] = ACTIONS(2231),
    [anon_sym_default] = ACTIONS(2231),
    [anon_sym_while] = ACTIONS(2231),
    [anon_sym_do] = ACTIONS(2231),
    [anon_sym_for] = ACTIONS(2231),
    [anon_sym_return] = ACTIONS(2231),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_continue] = ACTIONS(2231),
    [anon_sym_goto] = ACTIONS(2231),
    [anon_sym___try] = ACTIONS(2231),
    [anon_sym___leave] = ACTIONS(2231),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_compl] = ACTIONS(2231),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_sizeof] = ACTIONS(2231),
    [anon_sym___alignof__] = ACTIONS(2231),
    [anon_sym___alignof] = ACTIONS(2231),
    [anon_sym__alignof] = ACTIONS(2231),
    [anon_sym_alignof] = ACTIONS(2231),
    [anon_sym__Alignof] = ACTIONS(2231),
    [anon_sym_offsetof] = ACTIONS(2231),
    [anon_sym__Generic] = ACTIONS(2231),
    [anon_sym_asm] = ACTIONS(2231),
    [anon_sym___asm__] = ACTIONS(2231),
    [sym_number_literal] = ACTIONS(2233),
    [anon_sym_L_SQUOTE] = ACTIONS(2233),
    [anon_sym_u_SQUOTE] = ACTIONS(2233),
    [anon_sym_U_SQUOTE] = ACTIONS(2233),
    [anon_sym_u8_SQUOTE] = ACTIONS(2233),
    [anon_sym_SQUOTE] = ACTIONS(2233),
    [anon_sym_L_DQUOTE] = ACTIONS(2233),
    [anon_sym_u_DQUOTE] = ACTIONS(2233),
    [anon_sym_U_DQUOTE] = ACTIONS(2233),
    [anon_sym_u8_DQUOTE] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(2233),
    [sym_true] = ACTIONS(2231),
    [sym_false] = ACTIONS(2231),
    [anon_sym_NULL] = ACTIONS(2231),
    [anon_sym_nullptr] = ACTIONS(2231),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2231),
    [anon_sym_decltype] = ACTIONS(2231),
    [sym_virtual] = ACTIONS(2231),
    [anon_sym_explicit] = ACTIONS(2231),
    [anon_sym_typename] = ACTIONS(2231),
    [anon_sym_template] = ACTIONS(2231),
    [anon_sym_operator] = ACTIONS(2231),
    [anon_sym_try] = ACTIONS(2231),
    [anon_sym_delete] = ACTIONS(2231),
    [anon_sym_throw] = ACTIONS(2231),
    [anon_sym_namespace] = ACTIONS(2231),
    [anon_sym_using] = ACTIONS(2231),
    [anon_sym_static_assert] = ACTIONS(2231),
    [anon_sym_concept] = ACTIONS(2231),
    [anon_sym_co_return] = ACTIONS(2231),
    [anon_sym_co_yield] = ACTIONS(2231),
    [anon_sym_R_DQUOTE] = ACTIONS(2233),
    [anon_sym_LR_DQUOTE] = ACTIONS(2233),
    [anon_sym_uR_DQUOTE] = ACTIONS(2233),
    [anon_sym_UR_DQUOTE] = ACTIONS(2233),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2233),
    [anon_sym_co_await] = ACTIONS(2231),
    [anon_sym_new] = ACTIONS(2231),
    [anon_sym_requires] = ACTIONS(2231),
    [sym_this] = ACTIONS(2231),
    [anon_sym___launch_bounds__] = ACTIONS(2231),
  },
  [524] = {
    [sym_type_qualifier] = STATE(3531),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4591),
    [sym_sized_type_specifier] = STATE(2599),
    [sym_enum_specifier] = STATE(2599),
    [sym_struct_specifier] = STATE(2599),
    [sym_union_specifier] = STATE(2599),
    [sym_expression] = STATE(4656),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_type_descriptor] = STATE(7354),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_placeholder_type_specifier] = STATE(2599),
    [sym_decltype_auto] = STATE(2598),
    [sym_decltype] = STATE(2477),
    [sym_class_specifier] = STATE(2599),
    [sym__class_name] = STATE(8015),
    [sym_dependent_type] = STATE(2599),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_type_parameter_pack_expansion] = STATE(7424),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5910),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [aux_sym__type_definition_type_repeat1] = STATE(3531),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2157),
    [sym_identifier] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2725),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2729),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2733),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2757),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2761),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_GT2] = ACTIONS(2783),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [525] = {
    [sym_identifier] = ACTIONS(2158),
    [aux_sym_preproc_include_token1] = ACTIONS(2158),
    [aux_sym_preproc_def_token1] = ACTIONS(2158),
    [aux_sym_preproc_if_token1] = ACTIONS(2158),
    [aux_sym_preproc_if_token2] = ACTIONS(2158),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2158),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2158),
    [sym_preproc_directive] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_STAR] = ACTIONS(2160),
    [anon_sym_AMP_AMP] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym___extension__] = ACTIONS(2158),
    [anon_sym_typedef] = ACTIONS(2158),
    [anon_sym___device__] = ACTIONS(2158),
    [anon_sym___host__] = ACTIONS(2158),
    [anon_sym___global__] = ACTIONS(2158),
    [anon_sym___forceinline__] = ACTIONS(2158),
    [anon_sym___noinline__] = ACTIONS(2158),
    [anon_sym_extern] = ACTIONS(2158),
    [anon_sym___attribute__] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2160),
    [anon_sym___declspec] = ACTIONS(2158),
    [anon_sym___based] = ACTIONS(2158),
    [anon_sym___cdecl] = ACTIONS(2158),
    [anon_sym___clrcall] = ACTIONS(2158),
    [anon_sym___stdcall] = ACTIONS(2158),
    [anon_sym___fastcall] = ACTIONS(2158),
    [anon_sym___thiscall] = ACTIONS(2158),
    [anon_sym___vectorcall] = ACTIONS(2158),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_signed] = ACTIONS(2158),
    [anon_sym_unsigned] = ACTIONS(2158),
    [anon_sym_long] = ACTIONS(2158),
    [anon_sym_short] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_static] = ACTIONS(2158),
    [anon_sym_register] = ACTIONS(2158),
    [anon_sym_inline] = ACTIONS(2158),
    [anon_sym___inline] = ACTIONS(2158),
    [anon_sym___inline__] = ACTIONS(2158),
    [anon_sym___forceinline] = ACTIONS(2158),
    [anon_sym_thread_local] = ACTIONS(2158),
    [anon_sym___thread] = ACTIONS(2158),
    [anon_sym_const] = ACTIONS(2158),
    [anon_sym_constexpr] = ACTIONS(2158),
    [anon_sym_volatile] = ACTIONS(2158),
    [anon_sym_restrict] = ACTIONS(2158),
    [anon_sym___restrict__] = ACTIONS(2158),
    [anon_sym__Atomic] = ACTIONS(2158),
    [anon_sym__Noreturn] = ACTIONS(2158),
    [anon_sym_noreturn] = ACTIONS(2158),
    [anon_sym_mutable] = ACTIONS(2158),
    [anon_sym_constinit] = ACTIONS(2158),
    [anon_sym_consteval] = ACTIONS(2158),
    [anon_sym___shared__] = ACTIONS(2158),
    [anon_sym___local__] = ACTIONS(2158),
    [anon_sym___constant__] = ACTIONS(2158),
    [anon_sym___managed__] = ACTIONS(2158),
    [anon_sym___grid_constant__] = ACTIONS(2158),
    [anon_sym_alignas] = ACTIONS(2158),
    [anon_sym__Alignas] = ACTIONS(2158),
    [sym_primitive_type] = ACTIONS(2158),
    [anon_sym_enum] = ACTIONS(2158),
    [anon_sym_class] = ACTIONS(2158),
    [anon_sym_struct] = ACTIONS(2158),
    [anon_sym_union] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_switch] = ACTIONS(2158),
    [anon_sym_case] = ACTIONS(2158),
    [anon_sym_default] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_break] = ACTIONS(2158),
    [anon_sym_continue] = ACTIONS(2158),
    [anon_sym_goto] = ACTIONS(2158),
    [anon_sym___try] = ACTIONS(2158),
    [anon_sym___leave] = ACTIONS(2158),
    [anon_sym_not] = ACTIONS(2158),
    [anon_sym_compl] = ACTIONS(2158),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_sizeof] = ACTIONS(2158),
    [anon_sym___alignof__] = ACTIONS(2158),
    [anon_sym___alignof] = ACTIONS(2158),
    [anon_sym__alignof] = ACTIONS(2158),
    [anon_sym_alignof] = ACTIONS(2158),
    [anon_sym__Alignof] = ACTIONS(2158),
    [anon_sym_offsetof] = ACTIONS(2158),
    [anon_sym__Generic] = ACTIONS(2158),
    [anon_sym_asm] = ACTIONS(2158),
    [anon_sym___asm__] = ACTIONS(2158),
    [sym_number_literal] = ACTIONS(2160),
    [anon_sym_L_SQUOTE] = ACTIONS(2160),
    [anon_sym_u_SQUOTE] = ACTIONS(2160),
    [anon_sym_U_SQUOTE] = ACTIONS(2160),
    [anon_sym_u8_SQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_L_DQUOTE] = ACTIONS(2160),
    [anon_sym_u_DQUOTE] = ACTIONS(2160),
    [anon_sym_U_DQUOTE] = ACTIONS(2160),
    [anon_sym_u8_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [sym_true] = ACTIONS(2158),
    [sym_false] = ACTIONS(2158),
    [anon_sym_NULL] = ACTIONS(2158),
    [anon_sym_nullptr] = ACTIONS(2158),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2158),
    [anon_sym_decltype] = ACTIONS(2158),
    [sym_virtual] = ACTIONS(2158),
    [anon_sym_explicit] = ACTIONS(2158),
    [anon_sym_typename] = ACTIONS(2158),
    [anon_sym_template] = ACTIONS(2158),
    [anon_sym_operator] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_delete] = ACTIONS(2158),
    [anon_sym_throw] = ACTIONS(2158),
    [anon_sym_namespace] = ACTIONS(2158),
    [anon_sym_using] = ACTIONS(2158),
    [anon_sym_static_assert] = ACTIONS(2158),
    [anon_sym_concept] = ACTIONS(2158),
    [anon_sym_co_return] = ACTIONS(2158),
    [anon_sym_co_yield] = ACTIONS(2158),
    [anon_sym_R_DQUOTE] = ACTIONS(2160),
    [anon_sym_LR_DQUOTE] = ACTIONS(2160),
    [anon_sym_uR_DQUOTE] = ACTIONS(2160),
    [anon_sym_UR_DQUOTE] = ACTIONS(2160),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2160),
    [anon_sym_co_await] = ACTIONS(2158),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_requires] = ACTIONS(2158),
    [sym_this] = ACTIONS(2158),
    [anon_sym___launch_bounds__] = ACTIONS(2158),
  },
  [526] = {
    [sym_identifier] = ACTIONS(2211),
    [aux_sym_preproc_include_token1] = ACTIONS(2211),
    [aux_sym_preproc_def_token1] = ACTIONS(2211),
    [aux_sym_preproc_if_token1] = ACTIONS(2211),
    [aux_sym_preproc_if_token2] = ACTIONS(2211),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2211),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2211),
    [sym_preproc_directive] = ACTIONS(2211),
    [anon_sym_LPAREN2] = ACTIONS(2213),
    [anon_sym_BANG] = ACTIONS(2213),
    [anon_sym_TILDE] = ACTIONS(2213),
    [anon_sym_DASH] = ACTIONS(2211),
    [anon_sym_PLUS] = ACTIONS(2211),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_AMP_AMP] = ACTIONS(2213),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_SEMI] = ACTIONS(2213),
    [anon_sym___extension__] = ACTIONS(2211),
    [anon_sym_typedef] = ACTIONS(2211),
    [anon_sym___device__] = ACTIONS(2211),
    [anon_sym___host__] = ACTIONS(2211),
    [anon_sym___global__] = ACTIONS(2211),
    [anon_sym___forceinline__] = ACTIONS(2211),
    [anon_sym___noinline__] = ACTIONS(2211),
    [anon_sym_extern] = ACTIONS(2211),
    [anon_sym___attribute__] = ACTIONS(2211),
    [anon_sym_COLON_COLON] = ACTIONS(2213),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2213),
    [anon_sym___declspec] = ACTIONS(2211),
    [anon_sym___based] = ACTIONS(2211),
    [anon_sym___cdecl] = ACTIONS(2211),
    [anon_sym___clrcall] = ACTIONS(2211),
    [anon_sym___stdcall] = ACTIONS(2211),
    [anon_sym___fastcall] = ACTIONS(2211),
    [anon_sym___thiscall] = ACTIONS(2211),
    [anon_sym___vectorcall] = ACTIONS(2211),
    [anon_sym_LBRACE] = ACTIONS(2213),
    [anon_sym_signed] = ACTIONS(2211),
    [anon_sym_unsigned] = ACTIONS(2211),
    [anon_sym_long] = ACTIONS(2211),
    [anon_sym_short] = ACTIONS(2211),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_static] = ACTIONS(2211),
    [anon_sym_register] = ACTIONS(2211),
    [anon_sym_inline] = ACTIONS(2211),
    [anon_sym___inline] = ACTIONS(2211),
    [anon_sym___inline__] = ACTIONS(2211),
    [anon_sym___forceinline] = ACTIONS(2211),
    [anon_sym_thread_local] = ACTIONS(2211),
    [anon_sym___thread] = ACTIONS(2211),
    [anon_sym_const] = ACTIONS(2211),
    [anon_sym_constexpr] = ACTIONS(2211),
    [anon_sym_volatile] = ACTIONS(2211),
    [anon_sym_restrict] = ACTIONS(2211),
    [anon_sym___restrict__] = ACTIONS(2211),
    [anon_sym__Atomic] = ACTIONS(2211),
    [anon_sym__Noreturn] = ACTIONS(2211),
    [anon_sym_noreturn] = ACTIONS(2211),
    [anon_sym_mutable] = ACTIONS(2211),
    [anon_sym_constinit] = ACTIONS(2211),
    [anon_sym_consteval] = ACTIONS(2211),
    [anon_sym___shared__] = ACTIONS(2211),
    [anon_sym___local__] = ACTIONS(2211),
    [anon_sym___constant__] = ACTIONS(2211),
    [anon_sym___managed__] = ACTIONS(2211),
    [anon_sym___grid_constant__] = ACTIONS(2211),
    [anon_sym_alignas] = ACTIONS(2211),
    [anon_sym__Alignas] = ACTIONS(2211),
    [sym_primitive_type] = ACTIONS(2211),
    [anon_sym_enum] = ACTIONS(2211),
    [anon_sym_class] = ACTIONS(2211),
    [anon_sym_struct] = ACTIONS(2211),
    [anon_sym_union] = ACTIONS(2211),
    [anon_sym_if] = ACTIONS(2211),
    [anon_sym_switch] = ACTIONS(2211),
    [anon_sym_case] = ACTIONS(2211),
    [anon_sym_default] = ACTIONS(2211),
    [anon_sym_while] = ACTIONS(2211),
    [anon_sym_do] = ACTIONS(2211),
    [anon_sym_for] = ACTIONS(2211),
    [anon_sym_return] = ACTIONS(2211),
    [anon_sym_break] = ACTIONS(2211),
    [anon_sym_continue] = ACTIONS(2211),
    [anon_sym_goto] = ACTIONS(2211),
    [anon_sym___try] = ACTIONS(2211),
    [anon_sym___leave] = ACTIONS(2211),
    [anon_sym_not] = ACTIONS(2211),
    [anon_sym_compl] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2213),
    [anon_sym_PLUS_PLUS] = ACTIONS(2213),
    [anon_sym_sizeof] = ACTIONS(2211),
    [anon_sym___alignof__] = ACTIONS(2211),
    [anon_sym___alignof] = ACTIONS(2211),
    [anon_sym__alignof] = ACTIONS(2211),
    [anon_sym_alignof] = ACTIONS(2211),
    [anon_sym__Alignof] = ACTIONS(2211),
    [anon_sym_offsetof] = ACTIONS(2211),
    [anon_sym__Generic] = ACTIONS(2211),
    [anon_sym_asm] = ACTIONS(2211),
    [anon_sym___asm__] = ACTIONS(2211),
    [sym_number_literal] = ACTIONS(2213),
    [anon_sym_L_SQUOTE] = ACTIONS(2213),
    [anon_sym_u_SQUOTE] = ACTIONS(2213),
    [anon_sym_U_SQUOTE] = ACTIONS(2213),
    [anon_sym_u8_SQUOTE] = ACTIONS(2213),
    [anon_sym_SQUOTE] = ACTIONS(2213),
    [anon_sym_L_DQUOTE] = ACTIONS(2213),
    [anon_sym_u_DQUOTE] = ACTIONS(2213),
    [anon_sym_U_DQUOTE] = ACTIONS(2213),
    [anon_sym_u8_DQUOTE] = ACTIONS(2213),
    [anon_sym_DQUOTE] = ACTIONS(2213),
    [sym_true] = ACTIONS(2211),
    [sym_false] = ACTIONS(2211),
    [anon_sym_NULL] = ACTIONS(2211),
    [anon_sym_nullptr] = ACTIONS(2211),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2211),
    [anon_sym_decltype] = ACTIONS(2211),
    [sym_virtual] = ACTIONS(2211),
    [anon_sym_explicit] = ACTIONS(2211),
    [anon_sym_typename] = ACTIONS(2211),
    [anon_sym_template] = ACTIONS(2211),
    [anon_sym_operator] = ACTIONS(2211),
    [anon_sym_try] = ACTIONS(2211),
    [anon_sym_delete] = ACTIONS(2211),
    [anon_sym_throw] = ACTIONS(2211),
    [anon_sym_namespace] = ACTIONS(2211),
    [anon_sym_using] = ACTIONS(2211),
    [anon_sym_static_assert] = ACTIONS(2211),
    [anon_sym_concept] = ACTIONS(2211),
    [anon_sym_co_return] = ACTIONS(2211),
    [anon_sym_co_yield] = ACTIONS(2211),
    [anon_sym_R_DQUOTE] = ACTIONS(2213),
    [anon_sym_LR_DQUOTE] = ACTIONS(2213),
    [anon_sym_uR_DQUOTE] = ACTIONS(2213),
    [anon_sym_UR_DQUOTE] = ACTIONS(2213),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2213),
    [anon_sym_co_await] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(2211),
    [anon_sym_requires] = ACTIONS(2211),
    [sym_this] = ACTIONS(2211),
    [anon_sym___launch_bounds__] = ACTIONS(2211),
  },
  [527] = {
    [sym_identifier] = ACTIONS(2259),
    [aux_sym_preproc_include_token1] = ACTIONS(2259),
    [aux_sym_preproc_def_token1] = ACTIONS(2259),
    [aux_sym_preproc_if_token1] = ACTIONS(2259),
    [aux_sym_preproc_if_token2] = ACTIONS(2259),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2259),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2259),
    [sym_preproc_directive] = ACTIONS(2259),
    [anon_sym_LPAREN2] = ACTIONS(2261),
    [anon_sym_BANG] = ACTIONS(2261),
    [anon_sym_TILDE] = ACTIONS(2261),
    [anon_sym_DASH] = ACTIONS(2259),
    [anon_sym_PLUS] = ACTIONS(2259),
    [anon_sym_STAR] = ACTIONS(2261),
    [anon_sym_AMP_AMP] = ACTIONS(2261),
    [anon_sym_AMP] = ACTIONS(2259),
    [anon_sym_SEMI] = ACTIONS(2261),
    [anon_sym___extension__] = ACTIONS(2259),
    [anon_sym_typedef] = ACTIONS(2259),
    [anon_sym___device__] = ACTIONS(2259),
    [anon_sym___host__] = ACTIONS(2259),
    [anon_sym___global__] = ACTIONS(2259),
    [anon_sym___forceinline__] = ACTIONS(2259),
    [anon_sym___noinline__] = ACTIONS(2259),
    [anon_sym_extern] = ACTIONS(2259),
    [anon_sym___attribute__] = ACTIONS(2259),
    [anon_sym_COLON_COLON] = ACTIONS(2261),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2261),
    [anon_sym___declspec] = ACTIONS(2259),
    [anon_sym___based] = ACTIONS(2259),
    [anon_sym___cdecl] = ACTIONS(2259),
    [anon_sym___clrcall] = ACTIONS(2259),
    [anon_sym___stdcall] = ACTIONS(2259),
    [anon_sym___fastcall] = ACTIONS(2259),
    [anon_sym___thiscall] = ACTIONS(2259),
    [anon_sym___vectorcall] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(2261),
    [anon_sym_signed] = ACTIONS(2259),
    [anon_sym_unsigned] = ACTIONS(2259),
    [anon_sym_long] = ACTIONS(2259),
    [anon_sym_short] = ACTIONS(2259),
    [anon_sym_LBRACK] = ACTIONS(2259),
    [anon_sym_static] = ACTIONS(2259),
    [anon_sym_register] = ACTIONS(2259),
    [anon_sym_inline] = ACTIONS(2259),
    [anon_sym___inline] = ACTIONS(2259),
    [anon_sym___inline__] = ACTIONS(2259),
    [anon_sym___forceinline] = ACTIONS(2259),
    [anon_sym_thread_local] = ACTIONS(2259),
    [anon_sym___thread] = ACTIONS(2259),
    [anon_sym_const] = ACTIONS(2259),
    [anon_sym_constexpr] = ACTIONS(2259),
    [anon_sym_volatile] = ACTIONS(2259),
    [anon_sym_restrict] = ACTIONS(2259),
    [anon_sym___restrict__] = ACTIONS(2259),
    [anon_sym__Atomic] = ACTIONS(2259),
    [anon_sym__Noreturn] = ACTIONS(2259),
    [anon_sym_noreturn] = ACTIONS(2259),
    [anon_sym_mutable] = ACTIONS(2259),
    [anon_sym_constinit] = ACTIONS(2259),
    [anon_sym_consteval] = ACTIONS(2259),
    [anon_sym___shared__] = ACTIONS(2259),
    [anon_sym___local__] = ACTIONS(2259),
    [anon_sym___constant__] = ACTIONS(2259),
    [anon_sym___managed__] = ACTIONS(2259),
    [anon_sym___grid_constant__] = ACTIONS(2259),
    [anon_sym_alignas] = ACTIONS(2259),
    [anon_sym__Alignas] = ACTIONS(2259),
    [sym_primitive_type] = ACTIONS(2259),
    [anon_sym_enum] = ACTIONS(2259),
    [anon_sym_class] = ACTIONS(2259),
    [anon_sym_struct] = ACTIONS(2259),
    [anon_sym_union] = ACTIONS(2259),
    [anon_sym_if] = ACTIONS(2259),
    [anon_sym_switch] = ACTIONS(2259),
    [anon_sym_case] = ACTIONS(2259),
    [anon_sym_default] = ACTIONS(2259),
    [anon_sym_while] = ACTIONS(2259),
    [anon_sym_do] = ACTIONS(2259),
    [anon_sym_for] = ACTIONS(2259),
    [anon_sym_return] = ACTIONS(2259),
    [anon_sym_break] = ACTIONS(2259),
    [anon_sym_continue] = ACTIONS(2259),
    [anon_sym_goto] = ACTIONS(2259),
    [anon_sym___try] = ACTIONS(2259),
    [anon_sym___leave] = ACTIONS(2259),
    [anon_sym_not] = ACTIONS(2259),
    [anon_sym_compl] = ACTIONS(2259),
    [anon_sym_DASH_DASH] = ACTIONS(2261),
    [anon_sym_PLUS_PLUS] = ACTIONS(2261),
    [anon_sym_sizeof] = ACTIONS(2259),
    [anon_sym___alignof__] = ACTIONS(2259),
    [anon_sym___alignof] = ACTIONS(2259),
    [anon_sym__alignof] = ACTIONS(2259),
    [anon_sym_alignof] = ACTIONS(2259),
    [anon_sym__Alignof] = ACTIONS(2259),
    [anon_sym_offsetof] = ACTIONS(2259),
    [anon_sym__Generic] = ACTIONS(2259),
    [anon_sym_asm] = ACTIONS(2259),
    [anon_sym___asm__] = ACTIONS(2259),
    [sym_number_literal] = ACTIONS(2261),
    [anon_sym_L_SQUOTE] = ACTIONS(2261),
    [anon_sym_u_SQUOTE] = ACTIONS(2261),
    [anon_sym_U_SQUOTE] = ACTIONS(2261),
    [anon_sym_u8_SQUOTE] = ACTIONS(2261),
    [anon_sym_SQUOTE] = ACTIONS(2261),
    [anon_sym_L_DQUOTE] = ACTIONS(2261),
    [anon_sym_u_DQUOTE] = ACTIONS(2261),
    [anon_sym_U_DQUOTE] = ACTIONS(2261),
    [anon_sym_u8_DQUOTE] = ACTIONS(2261),
    [anon_sym_DQUOTE] = ACTIONS(2261),
    [sym_true] = ACTIONS(2259),
    [sym_false] = ACTIONS(2259),
    [anon_sym_NULL] = ACTIONS(2259),
    [anon_sym_nullptr] = ACTIONS(2259),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2259),
    [anon_sym_decltype] = ACTIONS(2259),
    [sym_virtual] = ACTIONS(2259),
    [anon_sym_explicit] = ACTIONS(2259),
    [anon_sym_typename] = ACTIONS(2259),
    [anon_sym_template] = ACTIONS(2259),
    [anon_sym_operator] = ACTIONS(2259),
    [anon_sym_try] = ACTIONS(2259),
    [anon_sym_delete] = ACTIONS(2259),
    [anon_sym_throw] = ACTIONS(2259),
    [anon_sym_namespace] = ACTIONS(2259),
    [anon_sym_using] = ACTIONS(2259),
    [anon_sym_static_assert] = ACTIONS(2259),
    [anon_sym_concept] = ACTIONS(2259),
    [anon_sym_co_return] = ACTIONS(2259),
    [anon_sym_co_yield] = ACTIONS(2259),
    [anon_sym_R_DQUOTE] = ACTIONS(2261),
    [anon_sym_LR_DQUOTE] = ACTIONS(2261),
    [anon_sym_uR_DQUOTE] = ACTIONS(2261),
    [anon_sym_UR_DQUOTE] = ACTIONS(2261),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2261),
    [anon_sym_co_await] = ACTIONS(2259),
    [anon_sym_new] = ACTIONS(2259),
    [anon_sym_requires] = ACTIONS(2259),
    [sym_this] = ACTIONS(2259),
    [anon_sym___launch_bounds__] = ACTIONS(2259),
  },
  [528] = {
    [sym_type_qualifier] = STATE(3531),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4591),
    [sym_sized_type_specifier] = STATE(2599),
    [sym_enum_specifier] = STATE(2599),
    [sym_struct_specifier] = STATE(2599),
    [sym_union_specifier] = STATE(2599),
    [sym_expression] = STATE(4708),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_type_descriptor] = STATE(7339),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_placeholder_type_specifier] = STATE(2599),
    [sym_decltype_auto] = STATE(2598),
    [sym_decltype] = STATE(2477),
    [sym_class_specifier] = STATE(2599),
    [sym__class_name] = STATE(8015),
    [sym_dependent_type] = STATE(2599),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_type_parameter_pack_expansion] = STATE(7583),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5910),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [aux_sym__type_definition_type_repeat1] = STATE(3531),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2157),
    [sym_identifier] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2725),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2729),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2733),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2757),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2761),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_GT2] = ACTIONS(2785),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [529] = {
    [sym_identifier] = ACTIONS(2199),
    [aux_sym_preproc_include_token1] = ACTIONS(2199),
    [aux_sym_preproc_def_token1] = ACTIONS(2199),
    [aux_sym_preproc_if_token1] = ACTIONS(2199),
    [aux_sym_preproc_if_token2] = ACTIONS(2199),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2199),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2199),
    [sym_preproc_directive] = ACTIONS(2199),
    [anon_sym_LPAREN2] = ACTIONS(2201),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2201),
    [anon_sym_AMP_AMP] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2199),
    [anon_sym_SEMI] = ACTIONS(2201),
    [anon_sym___extension__] = ACTIONS(2199),
    [anon_sym_typedef] = ACTIONS(2199),
    [anon_sym___device__] = ACTIONS(2199),
    [anon_sym___host__] = ACTIONS(2199),
    [anon_sym___global__] = ACTIONS(2199),
    [anon_sym___forceinline__] = ACTIONS(2199),
    [anon_sym___noinline__] = ACTIONS(2199),
    [anon_sym_extern] = ACTIONS(2199),
    [anon_sym___attribute__] = ACTIONS(2199),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2201),
    [anon_sym___declspec] = ACTIONS(2199),
    [anon_sym___based] = ACTIONS(2199),
    [anon_sym___cdecl] = ACTIONS(2199),
    [anon_sym___clrcall] = ACTIONS(2199),
    [anon_sym___stdcall] = ACTIONS(2199),
    [anon_sym___fastcall] = ACTIONS(2199),
    [anon_sym___thiscall] = ACTIONS(2199),
    [anon_sym___vectorcall] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(2201),
    [anon_sym_signed] = ACTIONS(2199),
    [anon_sym_unsigned] = ACTIONS(2199),
    [anon_sym_long] = ACTIONS(2199),
    [anon_sym_short] = ACTIONS(2199),
    [anon_sym_LBRACK] = ACTIONS(2199),
    [anon_sym_static] = ACTIONS(2199),
    [anon_sym_register] = ACTIONS(2199),
    [anon_sym_inline] = ACTIONS(2199),
    [anon_sym___inline] = ACTIONS(2199),
    [anon_sym___inline__] = ACTIONS(2199),
    [anon_sym___forceinline] = ACTIONS(2199),
    [anon_sym_thread_local] = ACTIONS(2199),
    [anon_sym___thread] = ACTIONS(2199),
    [anon_sym_const] = ACTIONS(2199),
    [anon_sym_constexpr] = ACTIONS(2199),
    [anon_sym_volatile] = ACTIONS(2199),
    [anon_sym_restrict] = ACTIONS(2199),
    [anon_sym___restrict__] = ACTIONS(2199),
    [anon_sym__Atomic] = ACTIONS(2199),
    [anon_sym__Noreturn] = ACTIONS(2199),
    [anon_sym_noreturn] = ACTIONS(2199),
    [anon_sym_mutable] = ACTIONS(2199),
    [anon_sym_constinit] = ACTIONS(2199),
    [anon_sym_consteval] = ACTIONS(2199),
    [anon_sym___shared__] = ACTIONS(2199),
    [anon_sym___local__] = ACTIONS(2199),
    [anon_sym___constant__] = ACTIONS(2199),
    [anon_sym___managed__] = ACTIONS(2199),
    [anon_sym___grid_constant__] = ACTIONS(2199),
    [anon_sym_alignas] = ACTIONS(2199),
    [anon_sym__Alignas] = ACTIONS(2199),
    [sym_primitive_type] = ACTIONS(2199),
    [anon_sym_enum] = ACTIONS(2199),
    [anon_sym_class] = ACTIONS(2199),
    [anon_sym_struct] = ACTIONS(2199),
    [anon_sym_union] = ACTIONS(2199),
    [anon_sym_if] = ACTIONS(2199),
    [anon_sym_switch] = ACTIONS(2199),
    [anon_sym_case] = ACTIONS(2199),
    [anon_sym_default] = ACTIONS(2199),
    [anon_sym_while] = ACTIONS(2199),
    [anon_sym_do] = ACTIONS(2199),
    [anon_sym_for] = ACTIONS(2199),
    [anon_sym_return] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2199),
    [anon_sym_continue] = ACTIONS(2199),
    [anon_sym_goto] = ACTIONS(2199),
    [anon_sym___try] = ACTIONS(2199),
    [anon_sym___leave] = ACTIONS(2199),
    [anon_sym_not] = ACTIONS(2199),
    [anon_sym_compl] = ACTIONS(2199),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_sizeof] = ACTIONS(2199),
    [anon_sym___alignof__] = ACTIONS(2199),
    [anon_sym___alignof] = ACTIONS(2199),
    [anon_sym__alignof] = ACTIONS(2199),
    [anon_sym_alignof] = ACTIONS(2199),
    [anon_sym__Alignof] = ACTIONS(2199),
    [anon_sym_offsetof] = ACTIONS(2199),
    [anon_sym__Generic] = ACTIONS(2199),
    [anon_sym_asm] = ACTIONS(2199),
    [anon_sym___asm__] = ACTIONS(2199),
    [sym_number_literal] = ACTIONS(2201),
    [anon_sym_L_SQUOTE] = ACTIONS(2201),
    [anon_sym_u_SQUOTE] = ACTIONS(2201),
    [anon_sym_U_SQUOTE] = ACTIONS(2201),
    [anon_sym_u8_SQUOTE] = ACTIONS(2201),
    [anon_sym_SQUOTE] = ACTIONS(2201),
    [anon_sym_L_DQUOTE] = ACTIONS(2201),
    [anon_sym_u_DQUOTE] = ACTIONS(2201),
    [anon_sym_U_DQUOTE] = ACTIONS(2201),
    [anon_sym_u8_DQUOTE] = ACTIONS(2201),
    [anon_sym_DQUOTE] = ACTIONS(2201),
    [sym_true] = ACTIONS(2199),
    [sym_false] = ACTIONS(2199),
    [anon_sym_NULL] = ACTIONS(2199),
    [anon_sym_nullptr] = ACTIONS(2199),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2199),
    [anon_sym_decltype] = ACTIONS(2199),
    [sym_virtual] = ACTIONS(2199),
    [anon_sym_explicit] = ACTIONS(2199),
    [anon_sym_typename] = ACTIONS(2199),
    [anon_sym_template] = ACTIONS(2199),
    [anon_sym_operator] = ACTIONS(2199),
    [anon_sym_try] = ACTIONS(2199),
    [anon_sym_delete] = ACTIONS(2199),
    [anon_sym_throw] = ACTIONS(2199),
    [anon_sym_namespace] = ACTIONS(2199),
    [anon_sym_using] = ACTIONS(2199),
    [anon_sym_static_assert] = ACTIONS(2199),
    [anon_sym_concept] = ACTIONS(2199),
    [anon_sym_co_return] = ACTIONS(2199),
    [anon_sym_co_yield] = ACTIONS(2199),
    [anon_sym_R_DQUOTE] = ACTIONS(2201),
    [anon_sym_LR_DQUOTE] = ACTIONS(2201),
    [anon_sym_uR_DQUOTE] = ACTIONS(2201),
    [anon_sym_UR_DQUOTE] = ACTIONS(2201),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2201),
    [anon_sym_co_await] = ACTIONS(2199),
    [anon_sym_new] = ACTIONS(2199),
    [anon_sym_requires] = ACTIONS(2199),
    [sym_this] = ACTIONS(2199),
    [anon_sym___launch_bounds__] = ACTIONS(2199),
  },
  [530] = {
    [sym_identifier] = ACTIONS(2239),
    [aux_sym_preproc_include_token1] = ACTIONS(2239),
    [aux_sym_preproc_def_token1] = ACTIONS(2239),
    [aux_sym_preproc_if_token1] = ACTIONS(2239),
    [aux_sym_preproc_if_token2] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2239),
    [sym_preproc_directive] = ACTIONS(2239),
    [anon_sym_LPAREN2] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2239),
    [anon_sym_PLUS] = ACTIONS(2239),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_SEMI] = ACTIONS(2241),
    [anon_sym___extension__] = ACTIONS(2239),
    [anon_sym_typedef] = ACTIONS(2239),
    [anon_sym___device__] = ACTIONS(2239),
    [anon_sym___host__] = ACTIONS(2239),
    [anon_sym___global__] = ACTIONS(2239),
    [anon_sym___forceinline__] = ACTIONS(2239),
    [anon_sym___noinline__] = ACTIONS(2239),
    [anon_sym_extern] = ACTIONS(2239),
    [anon_sym___attribute__] = ACTIONS(2239),
    [anon_sym_COLON_COLON] = ACTIONS(2241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2241),
    [anon_sym___declspec] = ACTIONS(2239),
    [anon_sym___based] = ACTIONS(2239),
    [anon_sym___cdecl] = ACTIONS(2239),
    [anon_sym___clrcall] = ACTIONS(2239),
    [anon_sym___stdcall] = ACTIONS(2239),
    [anon_sym___fastcall] = ACTIONS(2239),
    [anon_sym___thiscall] = ACTIONS(2239),
    [anon_sym___vectorcall] = ACTIONS(2239),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_signed] = ACTIONS(2239),
    [anon_sym_unsigned] = ACTIONS(2239),
    [anon_sym_long] = ACTIONS(2239),
    [anon_sym_short] = ACTIONS(2239),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_static] = ACTIONS(2239),
    [anon_sym_register] = ACTIONS(2239),
    [anon_sym_inline] = ACTIONS(2239),
    [anon_sym___inline] = ACTIONS(2239),
    [anon_sym___inline__] = ACTIONS(2239),
    [anon_sym___forceinline] = ACTIONS(2239),
    [anon_sym_thread_local] = ACTIONS(2239),
    [anon_sym___thread] = ACTIONS(2239),
    [anon_sym_const] = ACTIONS(2239),
    [anon_sym_constexpr] = ACTIONS(2239),
    [anon_sym_volatile] = ACTIONS(2239),
    [anon_sym_restrict] = ACTIONS(2239),
    [anon_sym___restrict__] = ACTIONS(2239),
    [anon_sym__Atomic] = ACTIONS(2239),
    [anon_sym__Noreturn] = ACTIONS(2239),
    [anon_sym_noreturn] = ACTIONS(2239),
    [anon_sym_mutable] = ACTIONS(2239),
    [anon_sym_constinit] = ACTIONS(2239),
    [anon_sym_consteval] = ACTIONS(2239),
    [anon_sym___shared__] = ACTIONS(2239),
    [anon_sym___local__] = ACTIONS(2239),
    [anon_sym___constant__] = ACTIONS(2239),
    [anon_sym___managed__] = ACTIONS(2239),
    [anon_sym___grid_constant__] = ACTIONS(2239),
    [anon_sym_alignas] = ACTIONS(2239),
    [anon_sym__Alignas] = ACTIONS(2239),
    [sym_primitive_type] = ACTIONS(2239),
    [anon_sym_enum] = ACTIONS(2239),
    [anon_sym_class] = ACTIONS(2239),
    [anon_sym_struct] = ACTIONS(2239),
    [anon_sym_union] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(2239),
    [anon_sym_switch] = ACTIONS(2239),
    [anon_sym_case] = ACTIONS(2239),
    [anon_sym_default] = ACTIONS(2239),
    [anon_sym_while] = ACTIONS(2239),
    [anon_sym_do] = ACTIONS(2239),
    [anon_sym_for] = ACTIONS(2239),
    [anon_sym_return] = ACTIONS(2239),
    [anon_sym_break] = ACTIONS(2239),
    [anon_sym_continue] = ACTIONS(2239),
    [anon_sym_goto] = ACTIONS(2239),
    [anon_sym___try] = ACTIONS(2239),
    [anon_sym___leave] = ACTIONS(2239),
    [anon_sym_not] = ACTIONS(2239),
    [anon_sym_compl] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_sizeof] = ACTIONS(2239),
    [anon_sym___alignof__] = ACTIONS(2239),
    [anon_sym___alignof] = ACTIONS(2239),
    [anon_sym__alignof] = ACTIONS(2239),
    [anon_sym_alignof] = ACTIONS(2239),
    [anon_sym__Alignof] = ACTIONS(2239),
    [anon_sym_offsetof] = ACTIONS(2239),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2239),
    [anon_sym___asm__] = ACTIONS(2239),
    [sym_number_literal] = ACTIONS(2241),
    [anon_sym_L_SQUOTE] = ACTIONS(2241),
    [anon_sym_u_SQUOTE] = ACTIONS(2241),
    [anon_sym_U_SQUOTE] = ACTIONS(2241),
    [anon_sym_u8_SQUOTE] = ACTIONS(2241),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_L_DQUOTE] = ACTIONS(2241),
    [anon_sym_u_DQUOTE] = ACTIONS(2241),
    [anon_sym_U_DQUOTE] = ACTIONS(2241),
    [anon_sym_u8_DQUOTE] = ACTIONS(2241),
    [anon_sym_DQUOTE] = ACTIONS(2241),
    [sym_true] = ACTIONS(2239),
    [sym_false] = ACTIONS(2239),
    [anon_sym_NULL] = ACTIONS(2239),
    [anon_sym_nullptr] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2239),
    [anon_sym_decltype] = ACTIONS(2239),
    [sym_virtual] = ACTIONS(2239),
    [anon_sym_explicit] = ACTIONS(2239),
    [anon_sym_typename] = ACTIONS(2239),
    [anon_sym_template] = ACTIONS(2239),
    [anon_sym_operator] = ACTIONS(2239),
    [anon_sym_try] = ACTIONS(2239),
    [anon_sym_delete] = ACTIONS(2239),
    [anon_sym_throw] = ACTIONS(2239),
    [anon_sym_namespace] = ACTIONS(2239),
    [anon_sym_using] = ACTIONS(2239),
    [anon_sym_static_assert] = ACTIONS(2239),
    [anon_sym_concept] = ACTIONS(2239),
    [anon_sym_co_return] = ACTIONS(2239),
    [anon_sym_co_yield] = ACTIONS(2239),
    [anon_sym_R_DQUOTE] = ACTIONS(2241),
    [anon_sym_LR_DQUOTE] = ACTIONS(2241),
    [anon_sym_uR_DQUOTE] = ACTIONS(2241),
    [anon_sym_UR_DQUOTE] = ACTIONS(2241),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2241),
    [anon_sym_co_await] = ACTIONS(2239),
    [anon_sym_new] = ACTIONS(2239),
    [anon_sym_requires] = ACTIONS(2239),
    [sym_this] = ACTIONS(2239),
    [anon_sym___launch_bounds__] = ACTIONS(2239),
  },
  [531] = {
    [sym_identifier] = ACTIONS(2090),
    [aux_sym_preproc_include_token1] = ACTIONS(2090),
    [aux_sym_preproc_def_token1] = ACTIONS(2090),
    [aux_sym_preproc_if_token1] = ACTIONS(2090),
    [aux_sym_preproc_if_token2] = ACTIONS(2090),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2090),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2090),
    [sym_preproc_directive] = ACTIONS(2090),
    [anon_sym_LPAREN2] = ACTIONS(2092),
    [anon_sym_BANG] = ACTIONS(2092),
    [anon_sym_TILDE] = ACTIONS(2092),
    [anon_sym_DASH] = ACTIONS(2090),
    [anon_sym_PLUS] = ACTIONS(2090),
    [anon_sym_STAR] = ACTIONS(2092),
    [anon_sym_AMP_AMP] = ACTIONS(2092),
    [anon_sym_AMP] = ACTIONS(2090),
    [anon_sym_SEMI] = ACTIONS(2092),
    [anon_sym___extension__] = ACTIONS(2090),
    [anon_sym_typedef] = ACTIONS(2090),
    [anon_sym___device__] = ACTIONS(2090),
    [anon_sym___host__] = ACTIONS(2090),
    [anon_sym___global__] = ACTIONS(2090),
    [anon_sym___forceinline__] = ACTIONS(2090),
    [anon_sym___noinline__] = ACTIONS(2090),
    [anon_sym_extern] = ACTIONS(2090),
    [anon_sym___attribute__] = ACTIONS(2090),
    [anon_sym_COLON_COLON] = ACTIONS(2092),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2092),
    [anon_sym___declspec] = ACTIONS(2090),
    [anon_sym___based] = ACTIONS(2090),
    [anon_sym___cdecl] = ACTIONS(2090),
    [anon_sym___clrcall] = ACTIONS(2090),
    [anon_sym___stdcall] = ACTIONS(2090),
    [anon_sym___fastcall] = ACTIONS(2090),
    [anon_sym___thiscall] = ACTIONS(2090),
    [anon_sym___vectorcall] = ACTIONS(2090),
    [anon_sym_LBRACE] = ACTIONS(2092),
    [anon_sym_signed] = ACTIONS(2090),
    [anon_sym_unsigned] = ACTIONS(2090),
    [anon_sym_long] = ACTIONS(2090),
    [anon_sym_short] = ACTIONS(2090),
    [anon_sym_LBRACK] = ACTIONS(2090),
    [anon_sym_static] = ACTIONS(2090),
    [anon_sym_register] = ACTIONS(2090),
    [anon_sym_inline] = ACTIONS(2090),
    [anon_sym___inline] = ACTIONS(2090),
    [anon_sym___inline__] = ACTIONS(2090),
    [anon_sym___forceinline] = ACTIONS(2090),
    [anon_sym_thread_local] = ACTIONS(2090),
    [anon_sym___thread] = ACTIONS(2090),
    [anon_sym_const] = ACTIONS(2090),
    [anon_sym_constexpr] = ACTIONS(2090),
    [anon_sym_volatile] = ACTIONS(2090),
    [anon_sym_restrict] = ACTIONS(2090),
    [anon_sym___restrict__] = ACTIONS(2090),
    [anon_sym__Atomic] = ACTIONS(2090),
    [anon_sym__Noreturn] = ACTIONS(2090),
    [anon_sym_noreturn] = ACTIONS(2090),
    [anon_sym_mutable] = ACTIONS(2090),
    [anon_sym_constinit] = ACTIONS(2090),
    [anon_sym_consteval] = ACTIONS(2090),
    [anon_sym___shared__] = ACTIONS(2090),
    [anon_sym___local__] = ACTIONS(2090),
    [anon_sym___constant__] = ACTIONS(2090),
    [anon_sym___managed__] = ACTIONS(2090),
    [anon_sym___grid_constant__] = ACTIONS(2090),
    [anon_sym_alignas] = ACTIONS(2090),
    [anon_sym__Alignas] = ACTIONS(2090),
    [sym_primitive_type] = ACTIONS(2090),
    [anon_sym_enum] = ACTIONS(2090),
    [anon_sym_class] = ACTIONS(2090),
    [anon_sym_struct] = ACTIONS(2090),
    [anon_sym_union] = ACTIONS(2090),
    [anon_sym_if] = ACTIONS(2090),
    [anon_sym_switch] = ACTIONS(2090),
    [anon_sym_case] = ACTIONS(2090),
    [anon_sym_default] = ACTIONS(2090),
    [anon_sym_while] = ACTIONS(2090),
    [anon_sym_do] = ACTIONS(2090),
    [anon_sym_for] = ACTIONS(2090),
    [anon_sym_return] = ACTIONS(2090),
    [anon_sym_break] = ACTIONS(2090),
    [anon_sym_continue] = ACTIONS(2090),
    [anon_sym_goto] = ACTIONS(2090),
    [anon_sym___try] = ACTIONS(2090),
    [anon_sym___leave] = ACTIONS(2090),
    [anon_sym_not] = ACTIONS(2090),
    [anon_sym_compl] = ACTIONS(2090),
    [anon_sym_DASH_DASH] = ACTIONS(2092),
    [anon_sym_PLUS_PLUS] = ACTIONS(2092),
    [anon_sym_sizeof] = ACTIONS(2090),
    [anon_sym___alignof__] = ACTIONS(2090),
    [anon_sym___alignof] = ACTIONS(2090),
    [anon_sym__alignof] = ACTIONS(2090),
    [anon_sym_alignof] = ACTIONS(2090),
    [anon_sym__Alignof] = ACTIONS(2090),
    [anon_sym_offsetof] = ACTIONS(2090),
    [anon_sym__Generic] = ACTIONS(2090),
    [anon_sym_asm] = ACTIONS(2090),
    [anon_sym___asm__] = ACTIONS(2090),
    [sym_number_literal] = ACTIONS(2092),
    [anon_sym_L_SQUOTE] = ACTIONS(2092),
    [anon_sym_u_SQUOTE] = ACTIONS(2092),
    [anon_sym_U_SQUOTE] = ACTIONS(2092),
    [anon_sym_u8_SQUOTE] = ACTIONS(2092),
    [anon_sym_SQUOTE] = ACTIONS(2092),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2090),
    [sym_false] = ACTIONS(2090),
    [anon_sym_NULL] = ACTIONS(2090),
    [anon_sym_nullptr] = ACTIONS(2090),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2090),
    [anon_sym_decltype] = ACTIONS(2090),
    [sym_virtual] = ACTIONS(2090),
    [anon_sym_explicit] = ACTIONS(2090),
    [anon_sym_typename] = ACTIONS(2090),
    [anon_sym_template] = ACTIONS(2090),
    [anon_sym_operator] = ACTIONS(2090),
    [anon_sym_try] = ACTIONS(2090),
    [anon_sym_delete] = ACTIONS(2090),
    [anon_sym_throw] = ACTIONS(2090),
    [anon_sym_namespace] = ACTIONS(2090),
    [anon_sym_using] = ACTIONS(2090),
    [anon_sym_static_assert] = ACTIONS(2090),
    [anon_sym_concept] = ACTIONS(2090),
    [anon_sym_co_return] = ACTIONS(2090),
    [anon_sym_co_yield] = ACTIONS(2090),
    [anon_sym_R_DQUOTE] = ACTIONS(2092),
    [anon_sym_LR_DQUOTE] = ACTIONS(2092),
    [anon_sym_uR_DQUOTE] = ACTIONS(2092),
    [anon_sym_UR_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2092),
    [anon_sym_co_await] = ACTIONS(2090),
    [anon_sym_new] = ACTIONS(2090),
    [anon_sym_requires] = ACTIONS(2090),
    [sym_this] = ACTIONS(2090),
    [anon_sym___launch_bounds__] = ACTIONS(2090),
  },
  [532] = {
    [sym_identifier] = ACTIONS(2176),
    [aux_sym_preproc_include_token1] = ACTIONS(2176),
    [aux_sym_preproc_def_token1] = ACTIONS(2176),
    [aux_sym_preproc_if_token1] = ACTIONS(2176),
    [aux_sym_preproc_if_token2] = ACTIONS(2176),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2176),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2176),
    [sym_preproc_directive] = ACTIONS(2176),
    [anon_sym_LPAREN2] = ACTIONS(2178),
    [anon_sym_BANG] = ACTIONS(2178),
    [anon_sym_TILDE] = ACTIONS(2178),
    [anon_sym_DASH] = ACTIONS(2176),
    [anon_sym_PLUS] = ACTIONS(2176),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_AMP_AMP] = ACTIONS(2178),
    [anon_sym_AMP] = ACTIONS(2176),
    [anon_sym_SEMI] = ACTIONS(2178),
    [anon_sym___extension__] = ACTIONS(2176),
    [anon_sym_typedef] = ACTIONS(2176),
    [anon_sym___device__] = ACTIONS(2176),
    [anon_sym___host__] = ACTIONS(2176),
    [anon_sym___global__] = ACTIONS(2176),
    [anon_sym___forceinline__] = ACTIONS(2176),
    [anon_sym___noinline__] = ACTIONS(2176),
    [anon_sym_extern] = ACTIONS(2176),
    [anon_sym___attribute__] = ACTIONS(2176),
    [anon_sym_COLON_COLON] = ACTIONS(2178),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2178),
    [anon_sym___declspec] = ACTIONS(2176),
    [anon_sym___based] = ACTIONS(2176),
    [anon_sym___cdecl] = ACTIONS(2176),
    [anon_sym___clrcall] = ACTIONS(2176),
    [anon_sym___stdcall] = ACTIONS(2176),
    [anon_sym___fastcall] = ACTIONS(2176),
    [anon_sym___thiscall] = ACTIONS(2176),
    [anon_sym___vectorcall] = ACTIONS(2176),
    [anon_sym_LBRACE] = ACTIONS(2178),
    [anon_sym_signed] = ACTIONS(2176),
    [anon_sym_unsigned] = ACTIONS(2176),
    [anon_sym_long] = ACTIONS(2176),
    [anon_sym_short] = ACTIONS(2176),
    [anon_sym_LBRACK] = ACTIONS(2176),
    [anon_sym_static] = ACTIONS(2176),
    [anon_sym_register] = ACTIONS(2176),
    [anon_sym_inline] = ACTIONS(2176),
    [anon_sym___inline] = ACTIONS(2176),
    [anon_sym___inline__] = ACTIONS(2176),
    [anon_sym___forceinline] = ACTIONS(2176),
    [anon_sym_thread_local] = ACTIONS(2176),
    [anon_sym___thread] = ACTIONS(2176),
    [anon_sym_const] = ACTIONS(2176),
    [anon_sym_constexpr] = ACTIONS(2176),
    [anon_sym_volatile] = ACTIONS(2176),
    [anon_sym_restrict] = ACTIONS(2176),
    [anon_sym___restrict__] = ACTIONS(2176),
    [anon_sym__Atomic] = ACTIONS(2176),
    [anon_sym__Noreturn] = ACTIONS(2176),
    [anon_sym_noreturn] = ACTIONS(2176),
    [anon_sym_mutable] = ACTIONS(2176),
    [anon_sym_constinit] = ACTIONS(2176),
    [anon_sym_consteval] = ACTIONS(2176),
    [anon_sym___shared__] = ACTIONS(2176),
    [anon_sym___local__] = ACTIONS(2176),
    [anon_sym___constant__] = ACTIONS(2176),
    [anon_sym___managed__] = ACTIONS(2176),
    [anon_sym___grid_constant__] = ACTIONS(2176),
    [anon_sym_alignas] = ACTIONS(2176),
    [anon_sym__Alignas] = ACTIONS(2176),
    [sym_primitive_type] = ACTIONS(2176),
    [anon_sym_enum] = ACTIONS(2176),
    [anon_sym_class] = ACTIONS(2176),
    [anon_sym_struct] = ACTIONS(2176),
    [anon_sym_union] = ACTIONS(2176),
    [anon_sym_if] = ACTIONS(2176),
    [anon_sym_switch] = ACTIONS(2176),
    [anon_sym_case] = ACTIONS(2176),
    [anon_sym_default] = ACTIONS(2176),
    [anon_sym_while] = ACTIONS(2176),
    [anon_sym_do] = ACTIONS(2176),
    [anon_sym_for] = ACTIONS(2176),
    [anon_sym_return] = ACTIONS(2176),
    [anon_sym_break] = ACTIONS(2176),
    [anon_sym_continue] = ACTIONS(2176),
    [anon_sym_goto] = ACTIONS(2176),
    [anon_sym___try] = ACTIONS(2176),
    [anon_sym___leave] = ACTIONS(2176),
    [anon_sym_not] = ACTIONS(2176),
    [anon_sym_compl] = ACTIONS(2176),
    [anon_sym_DASH_DASH] = ACTIONS(2178),
    [anon_sym_PLUS_PLUS] = ACTIONS(2178),
    [anon_sym_sizeof] = ACTIONS(2176),
    [anon_sym___alignof__] = ACTIONS(2176),
    [anon_sym___alignof] = ACTIONS(2176),
    [anon_sym__alignof] = ACTIONS(2176),
    [anon_sym_alignof] = ACTIONS(2176),
    [anon_sym__Alignof] = ACTIONS(2176),
    [anon_sym_offsetof] = ACTIONS(2176),
    [anon_sym__Generic] = ACTIONS(2176),
    [anon_sym_asm] = ACTIONS(2176),
    [anon_sym___asm__] = ACTIONS(2176),
    [sym_number_literal] = ACTIONS(2178),
    [anon_sym_L_SQUOTE] = ACTIONS(2178),
    [anon_sym_u_SQUOTE] = ACTIONS(2178),
    [anon_sym_U_SQUOTE] = ACTIONS(2178),
    [anon_sym_u8_SQUOTE] = ACTIONS(2178),
    [anon_sym_SQUOTE] = ACTIONS(2178),
    [anon_sym_L_DQUOTE] = ACTIONS(2178),
    [anon_sym_u_DQUOTE] = ACTIONS(2178),
    [anon_sym_U_DQUOTE] = ACTIONS(2178),
    [anon_sym_u8_DQUOTE] = ACTIONS(2178),
    [anon_sym_DQUOTE] = ACTIONS(2178),
    [sym_true] = ACTIONS(2176),
    [sym_false] = ACTIONS(2176),
    [anon_sym_NULL] = ACTIONS(2176),
    [anon_sym_nullptr] = ACTIONS(2176),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2176),
    [anon_sym_decltype] = ACTIONS(2176),
    [sym_virtual] = ACTIONS(2176),
    [anon_sym_explicit] = ACTIONS(2176),
    [anon_sym_typename] = ACTIONS(2176),
    [anon_sym_template] = ACTIONS(2176),
    [anon_sym_operator] = ACTIONS(2176),
    [anon_sym_try] = ACTIONS(2176),
    [anon_sym_delete] = ACTIONS(2176),
    [anon_sym_throw] = ACTIONS(2176),
    [anon_sym_namespace] = ACTIONS(2176),
    [anon_sym_using] = ACTIONS(2176),
    [anon_sym_static_assert] = ACTIONS(2176),
    [anon_sym_concept] = ACTIONS(2176),
    [anon_sym_co_return] = ACTIONS(2176),
    [anon_sym_co_yield] = ACTIONS(2176),
    [anon_sym_R_DQUOTE] = ACTIONS(2178),
    [anon_sym_LR_DQUOTE] = ACTIONS(2178),
    [anon_sym_uR_DQUOTE] = ACTIONS(2178),
    [anon_sym_UR_DQUOTE] = ACTIONS(2178),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2178),
    [anon_sym_co_await] = ACTIONS(2176),
    [anon_sym_new] = ACTIONS(2176),
    [anon_sym_requires] = ACTIONS(2176),
    [sym_this] = ACTIONS(2176),
    [anon_sym___launch_bounds__] = ACTIONS(2176),
  },
  [533] = {
    [sym_type_qualifier] = STATE(3531),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4591),
    [sym_sized_type_specifier] = STATE(2599),
    [sym_enum_specifier] = STATE(2599),
    [sym_struct_specifier] = STATE(2599),
    [sym_union_specifier] = STATE(2599),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_type_descriptor] = STATE(7290),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_placeholder_type_specifier] = STATE(2599),
    [sym_decltype_auto] = STATE(2598),
    [sym_decltype] = STATE(2477),
    [sym_class_specifier] = STATE(2599),
    [sym__class_name] = STATE(8015),
    [sym_dependent_type] = STATE(2599),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_type_parameter_pack_expansion] = STATE(7521),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5910),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [aux_sym__type_definition_type_repeat1] = STATE(3531),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2157),
    [sym_identifier] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2725),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2729),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2733),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2757),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2761),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_GT2] = ACTIONS(2787),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [534] = {
    [sym_identifier] = ACTIONS(2162),
    [aux_sym_preproc_include_token1] = ACTIONS(2162),
    [aux_sym_preproc_def_token1] = ACTIONS(2162),
    [aux_sym_preproc_if_token1] = ACTIONS(2162),
    [aux_sym_preproc_if_token2] = ACTIONS(2162),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2162),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2162),
    [sym_preproc_directive] = ACTIONS(2162),
    [anon_sym_LPAREN2] = ACTIONS(2164),
    [anon_sym_BANG] = ACTIONS(2164),
    [anon_sym_TILDE] = ACTIONS(2164),
    [anon_sym_DASH] = ACTIONS(2162),
    [anon_sym_PLUS] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(2164),
    [anon_sym_AMP_AMP] = ACTIONS(2164),
    [anon_sym_AMP] = ACTIONS(2162),
    [anon_sym_SEMI] = ACTIONS(2164),
    [anon_sym___extension__] = ACTIONS(2162),
    [anon_sym_typedef] = ACTIONS(2162),
    [anon_sym___device__] = ACTIONS(2162),
    [anon_sym___host__] = ACTIONS(2162),
    [anon_sym___global__] = ACTIONS(2162),
    [anon_sym___forceinline__] = ACTIONS(2162),
    [anon_sym___noinline__] = ACTIONS(2162),
    [anon_sym_extern] = ACTIONS(2162),
    [anon_sym___attribute__] = ACTIONS(2162),
    [anon_sym_COLON_COLON] = ACTIONS(2164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2164),
    [anon_sym___declspec] = ACTIONS(2162),
    [anon_sym___based] = ACTIONS(2162),
    [anon_sym___cdecl] = ACTIONS(2162),
    [anon_sym___clrcall] = ACTIONS(2162),
    [anon_sym___stdcall] = ACTIONS(2162),
    [anon_sym___fastcall] = ACTIONS(2162),
    [anon_sym___thiscall] = ACTIONS(2162),
    [anon_sym___vectorcall] = ACTIONS(2162),
    [anon_sym_LBRACE] = ACTIONS(2164),
    [anon_sym_signed] = ACTIONS(2162),
    [anon_sym_unsigned] = ACTIONS(2162),
    [anon_sym_long] = ACTIONS(2162),
    [anon_sym_short] = ACTIONS(2162),
    [anon_sym_LBRACK] = ACTIONS(2162),
    [anon_sym_static] = ACTIONS(2162),
    [anon_sym_register] = ACTIONS(2162),
    [anon_sym_inline] = ACTIONS(2162),
    [anon_sym___inline] = ACTIONS(2162),
    [anon_sym___inline__] = ACTIONS(2162),
    [anon_sym___forceinline] = ACTIONS(2162),
    [anon_sym_thread_local] = ACTIONS(2162),
    [anon_sym___thread] = ACTIONS(2162),
    [anon_sym_const] = ACTIONS(2162),
    [anon_sym_constexpr] = ACTIONS(2162),
    [anon_sym_volatile] = ACTIONS(2162),
    [anon_sym_restrict] = ACTIONS(2162),
    [anon_sym___restrict__] = ACTIONS(2162),
    [anon_sym__Atomic] = ACTIONS(2162),
    [anon_sym__Noreturn] = ACTIONS(2162),
    [anon_sym_noreturn] = ACTIONS(2162),
    [anon_sym_mutable] = ACTIONS(2162),
    [anon_sym_constinit] = ACTIONS(2162),
    [anon_sym_consteval] = ACTIONS(2162),
    [anon_sym___shared__] = ACTIONS(2162),
    [anon_sym___local__] = ACTIONS(2162),
    [anon_sym___constant__] = ACTIONS(2162),
    [anon_sym___managed__] = ACTIONS(2162),
    [anon_sym___grid_constant__] = ACTIONS(2162),
    [anon_sym_alignas] = ACTIONS(2162),
    [anon_sym__Alignas] = ACTIONS(2162),
    [sym_primitive_type] = ACTIONS(2162),
    [anon_sym_enum] = ACTIONS(2162),
    [anon_sym_class] = ACTIONS(2162),
    [anon_sym_struct] = ACTIONS(2162),
    [anon_sym_union] = ACTIONS(2162),
    [anon_sym_if] = ACTIONS(2162),
    [anon_sym_switch] = ACTIONS(2162),
    [anon_sym_case] = ACTIONS(2162),
    [anon_sym_default] = ACTIONS(2162),
    [anon_sym_while] = ACTIONS(2162),
    [anon_sym_do] = ACTIONS(2162),
    [anon_sym_for] = ACTIONS(2162),
    [anon_sym_return] = ACTIONS(2162),
    [anon_sym_break] = ACTIONS(2162),
    [anon_sym_continue] = ACTIONS(2162),
    [anon_sym_goto] = ACTIONS(2162),
    [anon_sym___try] = ACTIONS(2162),
    [anon_sym___leave] = ACTIONS(2162),
    [anon_sym_not] = ACTIONS(2162),
    [anon_sym_compl] = ACTIONS(2162),
    [anon_sym_DASH_DASH] = ACTIONS(2164),
    [anon_sym_PLUS_PLUS] = ACTIONS(2164),
    [anon_sym_sizeof] = ACTIONS(2162),
    [anon_sym___alignof__] = ACTIONS(2162),
    [anon_sym___alignof] = ACTIONS(2162),
    [anon_sym__alignof] = ACTIONS(2162),
    [anon_sym_alignof] = ACTIONS(2162),
    [anon_sym__Alignof] = ACTIONS(2162),
    [anon_sym_offsetof] = ACTIONS(2162),
    [anon_sym__Generic] = ACTIONS(2162),
    [anon_sym_asm] = ACTIONS(2162),
    [anon_sym___asm__] = ACTIONS(2162),
    [sym_number_literal] = ACTIONS(2164),
    [anon_sym_L_SQUOTE] = ACTIONS(2164),
    [anon_sym_u_SQUOTE] = ACTIONS(2164),
    [anon_sym_U_SQUOTE] = ACTIONS(2164),
    [anon_sym_u8_SQUOTE] = ACTIONS(2164),
    [anon_sym_SQUOTE] = ACTIONS(2164),
    [anon_sym_L_DQUOTE] = ACTIONS(2164),
    [anon_sym_u_DQUOTE] = ACTIONS(2164),
    [anon_sym_U_DQUOTE] = ACTIONS(2164),
    [anon_sym_u8_DQUOTE] = ACTIONS(2164),
    [anon_sym_DQUOTE] = ACTIONS(2164),
    [sym_true] = ACTIONS(2162),
    [sym_false] = ACTIONS(2162),
    [anon_sym_NULL] = ACTIONS(2162),
    [anon_sym_nullptr] = ACTIONS(2162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2162),
    [anon_sym_decltype] = ACTIONS(2162),
    [sym_virtual] = ACTIONS(2162),
    [anon_sym_explicit] = ACTIONS(2162),
    [anon_sym_typename] = ACTIONS(2162),
    [anon_sym_template] = ACTIONS(2162),
    [anon_sym_operator] = ACTIONS(2162),
    [anon_sym_try] = ACTIONS(2162),
    [anon_sym_delete] = ACTIONS(2162),
    [anon_sym_throw] = ACTIONS(2162),
    [anon_sym_namespace] = ACTIONS(2162),
    [anon_sym_using] = ACTIONS(2162),
    [anon_sym_static_assert] = ACTIONS(2162),
    [anon_sym_concept] = ACTIONS(2162),
    [anon_sym_co_return] = ACTIONS(2162),
    [anon_sym_co_yield] = ACTIONS(2162),
    [anon_sym_R_DQUOTE] = ACTIONS(2164),
    [anon_sym_LR_DQUOTE] = ACTIONS(2164),
    [anon_sym_uR_DQUOTE] = ACTIONS(2164),
    [anon_sym_UR_DQUOTE] = ACTIONS(2164),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2164),
    [anon_sym_co_await] = ACTIONS(2162),
    [anon_sym_new] = ACTIONS(2162),
    [anon_sym_requires] = ACTIONS(2162),
    [sym_this] = ACTIONS(2162),
    [anon_sym___launch_bounds__] = ACTIONS(2162),
  },
  [535] = {
    [sym_identifier] = ACTIONS(2195),
    [aux_sym_preproc_include_token1] = ACTIONS(2195),
    [aux_sym_preproc_def_token1] = ACTIONS(2195),
    [aux_sym_preproc_if_token1] = ACTIONS(2195),
    [aux_sym_preproc_if_token2] = ACTIONS(2195),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2195),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2195),
    [sym_preproc_directive] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(2197),
    [anon_sym_BANG] = ACTIONS(2197),
    [anon_sym_TILDE] = ACTIONS(2197),
    [anon_sym_DASH] = ACTIONS(2195),
    [anon_sym_PLUS] = ACTIONS(2195),
    [anon_sym_STAR] = ACTIONS(2197),
    [anon_sym_AMP_AMP] = ACTIONS(2197),
    [anon_sym_AMP] = ACTIONS(2195),
    [anon_sym_SEMI] = ACTIONS(2197),
    [anon_sym___extension__] = ACTIONS(2195),
    [anon_sym_typedef] = ACTIONS(2195),
    [anon_sym___device__] = ACTIONS(2195),
    [anon_sym___host__] = ACTIONS(2195),
    [anon_sym___global__] = ACTIONS(2195),
    [anon_sym___forceinline__] = ACTIONS(2195),
    [anon_sym___noinline__] = ACTIONS(2195),
    [anon_sym_extern] = ACTIONS(2195),
    [anon_sym___attribute__] = ACTIONS(2195),
    [anon_sym_COLON_COLON] = ACTIONS(2197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2197),
    [anon_sym___declspec] = ACTIONS(2195),
    [anon_sym___based] = ACTIONS(2195),
    [anon_sym___cdecl] = ACTIONS(2195),
    [anon_sym___clrcall] = ACTIONS(2195),
    [anon_sym___stdcall] = ACTIONS(2195),
    [anon_sym___fastcall] = ACTIONS(2195),
    [anon_sym___thiscall] = ACTIONS(2195),
    [anon_sym___vectorcall] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(2197),
    [anon_sym_signed] = ACTIONS(2195),
    [anon_sym_unsigned] = ACTIONS(2195),
    [anon_sym_long] = ACTIONS(2195),
    [anon_sym_short] = ACTIONS(2195),
    [anon_sym_LBRACK] = ACTIONS(2195),
    [anon_sym_static] = ACTIONS(2195),
    [anon_sym_register] = ACTIONS(2195),
    [anon_sym_inline] = ACTIONS(2195),
    [anon_sym___inline] = ACTIONS(2195),
    [anon_sym___inline__] = ACTIONS(2195),
    [anon_sym___forceinline] = ACTIONS(2195),
    [anon_sym_thread_local] = ACTIONS(2195),
    [anon_sym___thread] = ACTIONS(2195),
    [anon_sym_const] = ACTIONS(2195),
    [anon_sym_constexpr] = ACTIONS(2195),
    [anon_sym_volatile] = ACTIONS(2195),
    [anon_sym_restrict] = ACTIONS(2195),
    [anon_sym___restrict__] = ACTIONS(2195),
    [anon_sym__Atomic] = ACTIONS(2195),
    [anon_sym__Noreturn] = ACTIONS(2195),
    [anon_sym_noreturn] = ACTIONS(2195),
    [anon_sym_mutable] = ACTIONS(2195),
    [anon_sym_constinit] = ACTIONS(2195),
    [anon_sym_consteval] = ACTIONS(2195),
    [anon_sym___shared__] = ACTIONS(2195),
    [anon_sym___local__] = ACTIONS(2195),
    [anon_sym___constant__] = ACTIONS(2195),
    [anon_sym___managed__] = ACTIONS(2195),
    [anon_sym___grid_constant__] = ACTIONS(2195),
    [anon_sym_alignas] = ACTIONS(2195),
    [anon_sym__Alignas] = ACTIONS(2195),
    [sym_primitive_type] = ACTIONS(2195),
    [anon_sym_enum] = ACTIONS(2195),
    [anon_sym_class] = ACTIONS(2195),
    [anon_sym_struct] = ACTIONS(2195),
    [anon_sym_union] = ACTIONS(2195),
    [anon_sym_if] = ACTIONS(2195),
    [anon_sym_switch] = ACTIONS(2195),
    [anon_sym_case] = ACTIONS(2195),
    [anon_sym_default] = ACTIONS(2195),
    [anon_sym_while] = ACTIONS(2195),
    [anon_sym_do] = ACTIONS(2195),
    [anon_sym_for] = ACTIONS(2195),
    [anon_sym_return] = ACTIONS(2195),
    [anon_sym_break] = ACTIONS(2195),
    [anon_sym_continue] = ACTIONS(2195),
    [anon_sym_goto] = ACTIONS(2195),
    [anon_sym___try] = ACTIONS(2195),
    [anon_sym___leave] = ACTIONS(2195),
    [anon_sym_not] = ACTIONS(2195),
    [anon_sym_compl] = ACTIONS(2195),
    [anon_sym_DASH_DASH] = ACTIONS(2197),
    [anon_sym_PLUS_PLUS] = ACTIONS(2197),
    [anon_sym_sizeof] = ACTIONS(2195),
    [anon_sym___alignof__] = ACTIONS(2195),
    [anon_sym___alignof] = ACTIONS(2195),
    [anon_sym__alignof] = ACTIONS(2195),
    [anon_sym_alignof] = ACTIONS(2195),
    [anon_sym__Alignof] = ACTIONS(2195),
    [anon_sym_offsetof] = ACTIONS(2195),
    [anon_sym__Generic] = ACTIONS(2195),
    [anon_sym_asm] = ACTIONS(2195),
    [anon_sym___asm__] = ACTIONS(2195),
    [sym_number_literal] = ACTIONS(2197),
    [anon_sym_L_SQUOTE] = ACTIONS(2197),
    [anon_sym_u_SQUOTE] = ACTIONS(2197),
    [anon_sym_U_SQUOTE] = ACTIONS(2197),
    [anon_sym_u8_SQUOTE] = ACTIONS(2197),
    [anon_sym_SQUOTE] = ACTIONS(2197),
    [anon_sym_L_DQUOTE] = ACTIONS(2197),
    [anon_sym_u_DQUOTE] = ACTIONS(2197),
    [anon_sym_U_DQUOTE] = ACTIONS(2197),
    [anon_sym_u8_DQUOTE] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(2197),
    [sym_true] = ACTIONS(2195),
    [sym_false] = ACTIONS(2195),
    [anon_sym_NULL] = ACTIONS(2195),
    [anon_sym_nullptr] = ACTIONS(2195),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2195),
    [anon_sym_decltype] = ACTIONS(2195),
    [sym_virtual] = ACTIONS(2195),
    [anon_sym_explicit] = ACTIONS(2195),
    [anon_sym_typename] = ACTIONS(2195),
    [anon_sym_template] = ACTIONS(2195),
    [anon_sym_operator] = ACTIONS(2195),
    [anon_sym_try] = ACTIONS(2195),
    [anon_sym_delete] = ACTIONS(2195),
    [anon_sym_throw] = ACTIONS(2195),
    [anon_sym_namespace] = ACTIONS(2195),
    [anon_sym_using] = ACTIONS(2195),
    [anon_sym_static_assert] = ACTIONS(2195),
    [anon_sym_concept] = ACTIONS(2195),
    [anon_sym_co_return] = ACTIONS(2195),
    [anon_sym_co_yield] = ACTIONS(2195),
    [anon_sym_R_DQUOTE] = ACTIONS(2197),
    [anon_sym_LR_DQUOTE] = ACTIONS(2197),
    [anon_sym_uR_DQUOTE] = ACTIONS(2197),
    [anon_sym_UR_DQUOTE] = ACTIONS(2197),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2197),
    [anon_sym_co_await] = ACTIONS(2195),
    [anon_sym_new] = ACTIONS(2195),
    [anon_sym_requires] = ACTIONS(2195),
    [sym_this] = ACTIONS(2195),
    [anon_sym___launch_bounds__] = ACTIONS(2195),
  },
  [536] = {
    [sym_identifier] = ACTIONS(2235),
    [aux_sym_preproc_include_token1] = ACTIONS(2235),
    [aux_sym_preproc_def_token1] = ACTIONS(2235),
    [aux_sym_preproc_if_token1] = ACTIONS(2235),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2235),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2235),
    [sym_preproc_directive] = ACTIONS(2235),
    [anon_sym_LPAREN2] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2237),
    [anon_sym_TILDE] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_STAR] = ACTIONS(2237),
    [anon_sym_AMP_AMP] = ACTIONS(2237),
    [anon_sym_AMP] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2237),
    [anon_sym___extension__] = ACTIONS(2235),
    [anon_sym_typedef] = ACTIONS(2235),
    [anon_sym___device__] = ACTIONS(2235),
    [anon_sym___host__] = ACTIONS(2235),
    [anon_sym___global__] = ACTIONS(2235),
    [anon_sym___forceinline__] = ACTIONS(2235),
    [anon_sym___noinline__] = ACTIONS(2235),
    [anon_sym_extern] = ACTIONS(2235),
    [anon_sym___attribute__] = ACTIONS(2235),
    [anon_sym_COLON_COLON] = ACTIONS(2237),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2237),
    [anon_sym___declspec] = ACTIONS(2235),
    [anon_sym___based] = ACTIONS(2235),
    [anon_sym___cdecl] = ACTIONS(2235),
    [anon_sym___clrcall] = ACTIONS(2235),
    [anon_sym___stdcall] = ACTIONS(2235),
    [anon_sym___fastcall] = ACTIONS(2235),
    [anon_sym___thiscall] = ACTIONS(2235),
    [anon_sym___vectorcall] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2237),
    [anon_sym_RBRACE] = ACTIONS(2237),
    [anon_sym_signed] = ACTIONS(2235),
    [anon_sym_unsigned] = ACTIONS(2235),
    [anon_sym_long] = ACTIONS(2235),
    [anon_sym_short] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_static] = ACTIONS(2235),
    [anon_sym_register] = ACTIONS(2235),
    [anon_sym_inline] = ACTIONS(2235),
    [anon_sym___inline] = ACTIONS(2235),
    [anon_sym___inline__] = ACTIONS(2235),
    [anon_sym___forceinline] = ACTIONS(2235),
    [anon_sym_thread_local] = ACTIONS(2235),
    [anon_sym___thread] = ACTIONS(2235),
    [anon_sym_const] = ACTIONS(2235),
    [anon_sym_constexpr] = ACTIONS(2235),
    [anon_sym_volatile] = ACTIONS(2235),
    [anon_sym_restrict] = ACTIONS(2235),
    [anon_sym___restrict__] = ACTIONS(2235),
    [anon_sym__Atomic] = ACTIONS(2235),
    [anon_sym__Noreturn] = ACTIONS(2235),
    [anon_sym_noreturn] = ACTIONS(2235),
    [anon_sym_mutable] = ACTIONS(2235),
    [anon_sym_constinit] = ACTIONS(2235),
    [anon_sym_consteval] = ACTIONS(2235),
    [anon_sym___shared__] = ACTIONS(2235),
    [anon_sym___local__] = ACTIONS(2235),
    [anon_sym___constant__] = ACTIONS(2235),
    [anon_sym___managed__] = ACTIONS(2235),
    [anon_sym___grid_constant__] = ACTIONS(2235),
    [anon_sym_alignas] = ACTIONS(2235),
    [anon_sym__Alignas] = ACTIONS(2235),
    [sym_primitive_type] = ACTIONS(2235),
    [anon_sym_enum] = ACTIONS(2235),
    [anon_sym_class] = ACTIONS(2235),
    [anon_sym_struct] = ACTIONS(2235),
    [anon_sym_union] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_switch] = ACTIONS(2235),
    [anon_sym_case] = ACTIONS(2235),
    [anon_sym_default] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_for] = ACTIONS(2235),
    [anon_sym_return] = ACTIONS(2235),
    [anon_sym_break] = ACTIONS(2235),
    [anon_sym_continue] = ACTIONS(2235),
    [anon_sym_goto] = ACTIONS(2235),
    [anon_sym___try] = ACTIONS(2235),
    [anon_sym___leave] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2235),
    [anon_sym_compl] = ACTIONS(2235),
    [anon_sym_DASH_DASH] = ACTIONS(2237),
    [anon_sym_PLUS_PLUS] = ACTIONS(2237),
    [anon_sym_sizeof] = ACTIONS(2235),
    [anon_sym___alignof__] = ACTIONS(2235),
    [anon_sym___alignof] = ACTIONS(2235),
    [anon_sym__alignof] = ACTIONS(2235),
    [anon_sym_alignof] = ACTIONS(2235),
    [anon_sym__Alignof] = ACTIONS(2235),
    [anon_sym_offsetof] = ACTIONS(2235),
    [anon_sym__Generic] = ACTIONS(2235),
    [anon_sym_asm] = ACTIONS(2235),
    [anon_sym___asm__] = ACTIONS(2235),
    [sym_number_literal] = ACTIONS(2237),
    [anon_sym_L_SQUOTE] = ACTIONS(2237),
    [anon_sym_u_SQUOTE] = ACTIONS(2237),
    [anon_sym_U_SQUOTE] = ACTIONS(2237),
    [anon_sym_u8_SQUOTE] = ACTIONS(2237),
    [anon_sym_SQUOTE] = ACTIONS(2237),
    [anon_sym_L_DQUOTE] = ACTIONS(2237),
    [anon_sym_u_DQUOTE] = ACTIONS(2237),
    [anon_sym_U_DQUOTE] = ACTIONS(2237),
    [anon_sym_u8_DQUOTE] = ACTIONS(2237),
    [anon_sym_DQUOTE] = ACTIONS(2237),
    [sym_true] = ACTIONS(2235),
    [sym_false] = ACTIONS(2235),
    [anon_sym_NULL] = ACTIONS(2235),
    [anon_sym_nullptr] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2235),
    [anon_sym_decltype] = ACTIONS(2235),
    [sym_virtual] = ACTIONS(2235),
    [anon_sym_explicit] = ACTIONS(2235),
    [anon_sym_typename] = ACTIONS(2235),
    [anon_sym_template] = ACTIONS(2235),
    [anon_sym_operator] = ACTIONS(2235),
    [anon_sym_try] = ACTIONS(2235),
    [anon_sym_delete] = ACTIONS(2235),
    [anon_sym_throw] = ACTIONS(2235),
    [anon_sym_namespace] = ACTIONS(2235),
    [anon_sym_using] = ACTIONS(2235),
    [anon_sym_static_assert] = ACTIONS(2235),
    [anon_sym_concept] = ACTIONS(2235),
    [anon_sym_co_return] = ACTIONS(2235),
    [anon_sym_co_yield] = ACTIONS(2235),
    [anon_sym_R_DQUOTE] = ACTIONS(2237),
    [anon_sym_LR_DQUOTE] = ACTIONS(2237),
    [anon_sym_uR_DQUOTE] = ACTIONS(2237),
    [anon_sym_UR_DQUOTE] = ACTIONS(2237),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2237),
    [anon_sym_co_await] = ACTIONS(2235),
    [anon_sym_new] = ACTIONS(2235),
    [anon_sym_requires] = ACTIONS(2235),
    [sym_this] = ACTIONS(2235),
    [anon_sym___launch_bounds__] = ACTIONS(2235),
  },
  [537] = {
    [sym_identifier] = ACTIONS(2271),
    [aux_sym_preproc_include_token1] = ACTIONS(2271),
    [aux_sym_preproc_def_token1] = ACTIONS(2271),
    [aux_sym_preproc_if_token1] = ACTIONS(2271),
    [aux_sym_preproc_if_token2] = ACTIONS(2271),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2271),
    [sym_preproc_directive] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2273),
    [anon_sym_TILDE] = ACTIONS(2273),
    [anon_sym_DASH] = ACTIONS(2271),
    [anon_sym_PLUS] = ACTIONS(2271),
    [anon_sym_STAR] = ACTIONS(2273),
    [anon_sym_AMP_AMP] = ACTIONS(2273),
    [anon_sym_AMP] = ACTIONS(2271),
    [anon_sym_SEMI] = ACTIONS(2273),
    [anon_sym___extension__] = ACTIONS(2271),
    [anon_sym_typedef] = ACTIONS(2271),
    [anon_sym___device__] = ACTIONS(2271),
    [anon_sym___host__] = ACTIONS(2271),
    [anon_sym___global__] = ACTIONS(2271),
    [anon_sym___forceinline__] = ACTIONS(2271),
    [anon_sym___noinline__] = ACTIONS(2271),
    [anon_sym_extern] = ACTIONS(2271),
    [anon_sym___attribute__] = ACTIONS(2271),
    [anon_sym_COLON_COLON] = ACTIONS(2273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2273),
    [anon_sym___declspec] = ACTIONS(2271),
    [anon_sym___based] = ACTIONS(2271),
    [anon_sym___cdecl] = ACTIONS(2271),
    [anon_sym___clrcall] = ACTIONS(2271),
    [anon_sym___stdcall] = ACTIONS(2271),
    [anon_sym___fastcall] = ACTIONS(2271),
    [anon_sym___thiscall] = ACTIONS(2271),
    [anon_sym___vectorcall] = ACTIONS(2271),
    [anon_sym_LBRACE] = ACTIONS(2273),
    [anon_sym_signed] = ACTIONS(2271),
    [anon_sym_unsigned] = ACTIONS(2271),
    [anon_sym_long] = ACTIONS(2271),
    [anon_sym_short] = ACTIONS(2271),
    [anon_sym_LBRACK] = ACTIONS(2271),
    [anon_sym_static] = ACTIONS(2271),
    [anon_sym_register] = ACTIONS(2271),
    [anon_sym_inline] = ACTIONS(2271),
    [anon_sym___inline] = ACTIONS(2271),
    [anon_sym___inline__] = ACTIONS(2271),
    [anon_sym___forceinline] = ACTIONS(2271),
    [anon_sym_thread_local] = ACTIONS(2271),
    [anon_sym___thread] = ACTIONS(2271),
    [anon_sym_const] = ACTIONS(2271),
    [anon_sym_constexpr] = ACTIONS(2271),
    [anon_sym_volatile] = ACTIONS(2271),
    [anon_sym_restrict] = ACTIONS(2271),
    [anon_sym___restrict__] = ACTIONS(2271),
    [anon_sym__Atomic] = ACTIONS(2271),
    [anon_sym__Noreturn] = ACTIONS(2271),
    [anon_sym_noreturn] = ACTIONS(2271),
    [anon_sym_mutable] = ACTIONS(2271),
    [anon_sym_constinit] = ACTIONS(2271),
    [anon_sym_consteval] = ACTIONS(2271),
    [anon_sym___shared__] = ACTIONS(2271),
    [anon_sym___local__] = ACTIONS(2271),
    [anon_sym___constant__] = ACTIONS(2271),
    [anon_sym___managed__] = ACTIONS(2271),
    [anon_sym___grid_constant__] = ACTIONS(2271),
    [anon_sym_alignas] = ACTIONS(2271),
    [anon_sym__Alignas] = ACTIONS(2271),
    [sym_primitive_type] = ACTIONS(2271),
    [anon_sym_enum] = ACTIONS(2271),
    [anon_sym_class] = ACTIONS(2271),
    [anon_sym_struct] = ACTIONS(2271),
    [anon_sym_union] = ACTIONS(2271),
    [anon_sym_if] = ACTIONS(2271),
    [anon_sym_switch] = ACTIONS(2271),
    [anon_sym_case] = ACTIONS(2271),
    [anon_sym_default] = ACTIONS(2271),
    [anon_sym_while] = ACTIONS(2271),
    [anon_sym_do] = ACTIONS(2271),
    [anon_sym_for] = ACTIONS(2271),
    [anon_sym_return] = ACTIONS(2271),
    [anon_sym_break] = ACTIONS(2271),
    [anon_sym_continue] = ACTIONS(2271),
    [anon_sym_goto] = ACTIONS(2271),
    [anon_sym___try] = ACTIONS(2271),
    [anon_sym___leave] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2271),
    [anon_sym_compl] = ACTIONS(2271),
    [anon_sym_DASH_DASH] = ACTIONS(2273),
    [anon_sym_PLUS_PLUS] = ACTIONS(2273),
    [anon_sym_sizeof] = ACTIONS(2271),
    [anon_sym___alignof__] = ACTIONS(2271),
    [anon_sym___alignof] = ACTIONS(2271),
    [anon_sym__alignof] = ACTIONS(2271),
    [anon_sym_alignof] = ACTIONS(2271),
    [anon_sym__Alignof] = ACTIONS(2271),
    [anon_sym_offsetof] = ACTIONS(2271),
    [anon_sym__Generic] = ACTIONS(2271),
    [anon_sym_asm] = ACTIONS(2271),
    [anon_sym___asm__] = ACTIONS(2271),
    [sym_number_literal] = ACTIONS(2273),
    [anon_sym_L_SQUOTE] = ACTIONS(2273),
    [anon_sym_u_SQUOTE] = ACTIONS(2273),
    [anon_sym_U_SQUOTE] = ACTIONS(2273),
    [anon_sym_u8_SQUOTE] = ACTIONS(2273),
    [anon_sym_SQUOTE] = ACTIONS(2273),
    [anon_sym_L_DQUOTE] = ACTIONS(2273),
    [anon_sym_u_DQUOTE] = ACTIONS(2273),
    [anon_sym_U_DQUOTE] = ACTIONS(2273),
    [anon_sym_u8_DQUOTE] = ACTIONS(2273),
    [anon_sym_DQUOTE] = ACTIONS(2273),
    [sym_true] = ACTIONS(2271),
    [sym_false] = ACTIONS(2271),
    [anon_sym_NULL] = ACTIONS(2271),
    [anon_sym_nullptr] = ACTIONS(2271),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2271),
    [anon_sym_decltype] = ACTIONS(2271),
    [sym_virtual] = ACTIONS(2271),
    [anon_sym_explicit] = ACTIONS(2271),
    [anon_sym_typename] = ACTIONS(2271),
    [anon_sym_template] = ACTIONS(2271),
    [anon_sym_operator] = ACTIONS(2271),
    [anon_sym_try] = ACTIONS(2271),
    [anon_sym_delete] = ACTIONS(2271),
    [anon_sym_throw] = ACTIONS(2271),
    [anon_sym_namespace] = ACTIONS(2271),
    [anon_sym_using] = ACTIONS(2271),
    [anon_sym_static_assert] = ACTIONS(2271),
    [anon_sym_concept] = ACTIONS(2271),
    [anon_sym_co_return] = ACTIONS(2271),
    [anon_sym_co_yield] = ACTIONS(2271),
    [anon_sym_R_DQUOTE] = ACTIONS(2273),
    [anon_sym_LR_DQUOTE] = ACTIONS(2273),
    [anon_sym_uR_DQUOTE] = ACTIONS(2273),
    [anon_sym_UR_DQUOTE] = ACTIONS(2273),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2273),
    [anon_sym_co_await] = ACTIONS(2271),
    [anon_sym_new] = ACTIONS(2271),
    [anon_sym_requires] = ACTIONS(2271),
    [sym_this] = ACTIONS(2271),
    [anon_sym___launch_bounds__] = ACTIONS(2271),
  },
  [538] = {
    [sym_identifier] = ACTIONS(2469),
    [aux_sym_preproc_include_token1] = ACTIONS(2469),
    [aux_sym_preproc_def_token1] = ACTIONS(2469),
    [aux_sym_preproc_if_token1] = ACTIONS(2469),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2469),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2469),
    [sym_preproc_directive] = ACTIONS(2469),
    [anon_sym_LPAREN2] = ACTIONS(2471),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_STAR] = ACTIONS(2471),
    [anon_sym_AMP_AMP] = ACTIONS(2471),
    [anon_sym_AMP] = ACTIONS(2469),
    [anon_sym_SEMI] = ACTIONS(2471),
    [anon_sym___extension__] = ACTIONS(2469),
    [anon_sym_typedef] = ACTIONS(2469),
    [anon_sym___device__] = ACTIONS(2469),
    [anon_sym___host__] = ACTIONS(2469),
    [anon_sym___global__] = ACTIONS(2469),
    [anon_sym___forceinline__] = ACTIONS(2469),
    [anon_sym___noinline__] = ACTIONS(2469),
    [anon_sym_extern] = ACTIONS(2469),
    [anon_sym___attribute__] = ACTIONS(2469),
    [anon_sym_COLON_COLON] = ACTIONS(2471),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2471),
    [anon_sym___declspec] = ACTIONS(2469),
    [anon_sym___based] = ACTIONS(2469),
    [anon_sym___cdecl] = ACTIONS(2469),
    [anon_sym___clrcall] = ACTIONS(2469),
    [anon_sym___stdcall] = ACTIONS(2469),
    [anon_sym___fastcall] = ACTIONS(2469),
    [anon_sym___thiscall] = ACTIONS(2469),
    [anon_sym___vectorcall] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_RBRACE] = ACTIONS(2471),
    [anon_sym_signed] = ACTIONS(2469),
    [anon_sym_unsigned] = ACTIONS(2469),
    [anon_sym_long] = ACTIONS(2469),
    [anon_sym_short] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_register] = ACTIONS(2469),
    [anon_sym_inline] = ACTIONS(2469),
    [anon_sym___inline] = ACTIONS(2469),
    [anon_sym___inline__] = ACTIONS(2469),
    [anon_sym___forceinline] = ACTIONS(2469),
    [anon_sym_thread_local] = ACTIONS(2469),
    [anon_sym___thread] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_constexpr] = ACTIONS(2469),
    [anon_sym_volatile] = ACTIONS(2469),
    [anon_sym_restrict] = ACTIONS(2469),
    [anon_sym___restrict__] = ACTIONS(2469),
    [anon_sym__Atomic] = ACTIONS(2469),
    [anon_sym__Noreturn] = ACTIONS(2469),
    [anon_sym_noreturn] = ACTIONS(2469),
    [anon_sym_mutable] = ACTIONS(2469),
    [anon_sym_constinit] = ACTIONS(2469),
    [anon_sym_consteval] = ACTIONS(2469),
    [anon_sym___shared__] = ACTIONS(2469),
    [anon_sym___local__] = ACTIONS(2469),
    [anon_sym___constant__] = ACTIONS(2469),
    [anon_sym___managed__] = ACTIONS(2469),
    [anon_sym___grid_constant__] = ACTIONS(2469),
    [anon_sym_alignas] = ACTIONS(2469),
    [anon_sym__Alignas] = ACTIONS(2469),
    [sym_primitive_type] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [anon_sym_class] = ACTIONS(2469),
    [anon_sym_struct] = ACTIONS(2469),
    [anon_sym_union] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_goto] = ACTIONS(2469),
    [anon_sym___try] = ACTIONS(2469),
    [anon_sym___leave] = ACTIONS(2469),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_compl] = ACTIONS(2469),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_sizeof] = ACTIONS(2469),
    [anon_sym___alignof__] = ACTIONS(2469),
    [anon_sym___alignof] = ACTIONS(2469),
    [anon_sym__alignof] = ACTIONS(2469),
    [anon_sym_alignof] = ACTIONS(2469),
    [anon_sym__Alignof] = ACTIONS(2469),
    [anon_sym_offsetof] = ACTIONS(2469),
    [anon_sym__Generic] = ACTIONS(2469),
    [anon_sym_asm] = ACTIONS(2469),
    [anon_sym___asm__] = ACTIONS(2469),
    [sym_number_literal] = ACTIONS(2471),
    [anon_sym_L_SQUOTE] = ACTIONS(2471),
    [anon_sym_u_SQUOTE] = ACTIONS(2471),
    [anon_sym_U_SQUOTE] = ACTIONS(2471),
    [anon_sym_u8_SQUOTE] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [anon_sym_L_DQUOTE] = ACTIONS(2471),
    [anon_sym_u_DQUOTE] = ACTIONS(2471),
    [anon_sym_U_DQUOTE] = ACTIONS(2471),
    [anon_sym_u8_DQUOTE] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [anon_sym_NULL] = ACTIONS(2469),
    [anon_sym_nullptr] = ACTIONS(2469),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2469),
    [anon_sym_decltype] = ACTIONS(2469),
    [sym_virtual] = ACTIONS(2469),
    [anon_sym_explicit] = ACTIONS(2469),
    [anon_sym_typename] = ACTIONS(2469),
    [anon_sym_template] = ACTIONS(2469),
    [anon_sym_operator] = ACTIONS(2469),
    [anon_sym_try] = ACTIONS(2469),
    [anon_sym_delete] = ACTIONS(2469),
    [anon_sym_throw] = ACTIONS(2469),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_using] = ACTIONS(2469),
    [anon_sym_static_assert] = ACTIONS(2469),
    [anon_sym_concept] = ACTIONS(2469),
    [anon_sym_co_return] = ACTIONS(2469),
    [anon_sym_co_yield] = ACTIONS(2469),
    [anon_sym_R_DQUOTE] = ACTIONS(2471),
    [anon_sym_LR_DQUOTE] = ACTIONS(2471),
    [anon_sym_uR_DQUOTE] = ACTIONS(2471),
    [anon_sym_UR_DQUOTE] = ACTIONS(2471),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2471),
    [anon_sym_co_await] = ACTIONS(2469),
    [anon_sym_new] = ACTIONS(2469),
    [anon_sym_requires] = ACTIONS(2469),
    [sym_this] = ACTIONS(2469),
    [anon_sym___launch_bounds__] = ACTIONS(2469),
  },
  [539] = {
    [sym_identifier] = ACTIONS(2221),
    [aux_sym_preproc_include_token1] = ACTIONS(2221),
    [aux_sym_preproc_def_token1] = ACTIONS(2221),
    [aux_sym_preproc_if_token1] = ACTIONS(2221),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2221),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2221),
    [sym_preproc_directive] = ACTIONS(2221),
    [anon_sym_LPAREN2] = ACTIONS(2223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym___extension__] = ACTIONS(2221),
    [anon_sym_typedef] = ACTIONS(2221),
    [anon_sym___device__] = ACTIONS(2221),
    [anon_sym___host__] = ACTIONS(2221),
    [anon_sym___global__] = ACTIONS(2221),
    [anon_sym___forceinline__] = ACTIONS(2221),
    [anon_sym___noinline__] = ACTIONS(2221),
    [anon_sym_extern] = ACTIONS(2221),
    [anon_sym___attribute__] = ACTIONS(2221),
    [anon_sym_COLON_COLON] = ACTIONS(2223),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2223),
    [anon_sym___declspec] = ACTIONS(2221),
    [anon_sym___based] = ACTIONS(2221),
    [anon_sym___cdecl] = ACTIONS(2221),
    [anon_sym___clrcall] = ACTIONS(2221),
    [anon_sym___stdcall] = ACTIONS(2221),
    [anon_sym___fastcall] = ACTIONS(2221),
    [anon_sym___thiscall] = ACTIONS(2221),
    [anon_sym___vectorcall] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(2223),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_signed] = ACTIONS(2221),
    [anon_sym_unsigned] = ACTIONS(2221),
    [anon_sym_long] = ACTIONS(2221),
    [anon_sym_short] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2221),
    [anon_sym_static] = ACTIONS(2221),
    [anon_sym_register] = ACTIONS(2221),
    [anon_sym_inline] = ACTIONS(2221),
    [anon_sym___inline] = ACTIONS(2221),
    [anon_sym___inline__] = ACTIONS(2221),
    [anon_sym___forceinline] = ACTIONS(2221),
    [anon_sym_thread_local] = ACTIONS(2221),
    [anon_sym___thread] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2221),
    [anon_sym_constexpr] = ACTIONS(2221),
    [anon_sym_volatile] = ACTIONS(2221),
    [anon_sym_restrict] = ACTIONS(2221),
    [anon_sym___restrict__] = ACTIONS(2221),
    [anon_sym__Atomic] = ACTIONS(2221),
    [anon_sym__Noreturn] = ACTIONS(2221),
    [anon_sym_noreturn] = ACTIONS(2221),
    [anon_sym_mutable] = ACTIONS(2221),
    [anon_sym_constinit] = ACTIONS(2221),
    [anon_sym_consteval] = ACTIONS(2221),
    [anon_sym___shared__] = ACTIONS(2221),
    [anon_sym___local__] = ACTIONS(2221),
    [anon_sym___constant__] = ACTIONS(2221),
    [anon_sym___managed__] = ACTIONS(2221),
    [anon_sym___grid_constant__] = ACTIONS(2221),
    [anon_sym_alignas] = ACTIONS(2221),
    [anon_sym__Alignas] = ACTIONS(2221),
    [sym_primitive_type] = ACTIONS(2221),
    [anon_sym_enum] = ACTIONS(2221),
    [anon_sym_class] = ACTIONS(2221),
    [anon_sym_struct] = ACTIONS(2221),
    [anon_sym_union] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_case] = ACTIONS(2221),
    [anon_sym_default] = ACTIONS(2221),
    [anon_sym_while] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2221),
    [anon_sym_for] = ACTIONS(2221),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_break] = ACTIONS(2221),
    [anon_sym_continue] = ACTIONS(2221),
    [anon_sym_goto] = ACTIONS(2221),
    [anon_sym___try] = ACTIONS(2221),
    [anon_sym___leave] = ACTIONS(2221),
    [anon_sym_not] = ACTIONS(2221),
    [anon_sym_compl] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_sizeof] = ACTIONS(2221),
    [anon_sym___alignof__] = ACTIONS(2221),
    [anon_sym___alignof] = ACTIONS(2221),
    [anon_sym__alignof] = ACTIONS(2221),
    [anon_sym_alignof] = ACTIONS(2221),
    [anon_sym__Alignof] = ACTIONS(2221),
    [anon_sym_offsetof] = ACTIONS(2221),
    [anon_sym__Generic] = ACTIONS(2221),
    [anon_sym_asm] = ACTIONS(2221),
    [anon_sym___asm__] = ACTIONS(2221),
    [sym_number_literal] = ACTIONS(2223),
    [anon_sym_L_SQUOTE] = ACTIONS(2223),
    [anon_sym_u_SQUOTE] = ACTIONS(2223),
    [anon_sym_U_SQUOTE] = ACTIONS(2223),
    [anon_sym_u8_SQUOTE] = ACTIONS(2223),
    [anon_sym_SQUOTE] = ACTIONS(2223),
    [anon_sym_L_DQUOTE] = ACTIONS(2223),
    [anon_sym_u_DQUOTE] = ACTIONS(2223),
    [anon_sym_U_DQUOTE] = ACTIONS(2223),
    [anon_sym_u8_DQUOTE] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2223),
    [sym_true] = ACTIONS(2221),
    [sym_false] = ACTIONS(2221),
    [anon_sym_NULL] = ACTIONS(2221),
    [anon_sym_nullptr] = ACTIONS(2221),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2221),
    [anon_sym_decltype] = ACTIONS(2221),
    [sym_virtual] = ACTIONS(2221),
    [anon_sym_explicit] = ACTIONS(2221),
    [anon_sym_typename] = ACTIONS(2221),
    [anon_sym_template] = ACTIONS(2221),
    [anon_sym_operator] = ACTIONS(2221),
    [anon_sym_try] = ACTIONS(2221),
    [anon_sym_delete] = ACTIONS(2221),
    [anon_sym_throw] = ACTIONS(2221),
    [anon_sym_namespace] = ACTIONS(2221),
    [anon_sym_using] = ACTIONS(2221),
    [anon_sym_static_assert] = ACTIONS(2221),
    [anon_sym_concept] = ACTIONS(2221),
    [anon_sym_co_return] = ACTIONS(2221),
    [anon_sym_co_yield] = ACTIONS(2221),
    [anon_sym_R_DQUOTE] = ACTIONS(2223),
    [anon_sym_LR_DQUOTE] = ACTIONS(2223),
    [anon_sym_uR_DQUOTE] = ACTIONS(2223),
    [anon_sym_UR_DQUOTE] = ACTIONS(2223),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2223),
    [anon_sym_co_await] = ACTIONS(2221),
    [anon_sym_new] = ACTIONS(2221),
    [anon_sym_requires] = ACTIONS(2221),
    [sym_this] = ACTIONS(2221),
    [anon_sym___launch_bounds__] = ACTIONS(2221),
  },
  [540] = {
    [sym_identifier] = ACTIONS(2473),
    [aux_sym_preproc_include_token1] = ACTIONS(2473),
    [aux_sym_preproc_def_token1] = ACTIONS(2473),
    [aux_sym_preproc_if_token1] = ACTIONS(2473),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2473),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2473),
    [sym_preproc_directive] = ACTIONS(2473),
    [anon_sym_LPAREN2] = ACTIONS(2475),
    [anon_sym_BANG] = ACTIONS(2475),
    [anon_sym_TILDE] = ACTIONS(2475),
    [anon_sym_DASH] = ACTIONS(2473),
    [anon_sym_PLUS] = ACTIONS(2473),
    [anon_sym_STAR] = ACTIONS(2475),
    [anon_sym_AMP_AMP] = ACTIONS(2475),
    [anon_sym_AMP] = ACTIONS(2473),
    [anon_sym_SEMI] = ACTIONS(2475),
    [anon_sym___extension__] = ACTIONS(2473),
    [anon_sym_typedef] = ACTIONS(2473),
    [anon_sym___device__] = ACTIONS(2473),
    [anon_sym___host__] = ACTIONS(2473),
    [anon_sym___global__] = ACTIONS(2473),
    [anon_sym___forceinline__] = ACTIONS(2473),
    [anon_sym___noinline__] = ACTIONS(2473),
    [anon_sym_extern] = ACTIONS(2473),
    [anon_sym___attribute__] = ACTIONS(2473),
    [anon_sym_COLON_COLON] = ACTIONS(2475),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2475),
    [anon_sym___declspec] = ACTIONS(2473),
    [anon_sym___based] = ACTIONS(2473),
    [anon_sym___cdecl] = ACTIONS(2473),
    [anon_sym___clrcall] = ACTIONS(2473),
    [anon_sym___stdcall] = ACTIONS(2473),
    [anon_sym___fastcall] = ACTIONS(2473),
    [anon_sym___thiscall] = ACTIONS(2473),
    [anon_sym___vectorcall] = ACTIONS(2473),
    [anon_sym_LBRACE] = ACTIONS(2475),
    [anon_sym_RBRACE] = ACTIONS(2475),
    [anon_sym_signed] = ACTIONS(2473),
    [anon_sym_unsigned] = ACTIONS(2473),
    [anon_sym_long] = ACTIONS(2473),
    [anon_sym_short] = ACTIONS(2473),
    [anon_sym_LBRACK] = ACTIONS(2473),
    [anon_sym_static] = ACTIONS(2473),
    [anon_sym_register] = ACTIONS(2473),
    [anon_sym_inline] = ACTIONS(2473),
    [anon_sym___inline] = ACTIONS(2473),
    [anon_sym___inline__] = ACTIONS(2473),
    [anon_sym___forceinline] = ACTIONS(2473),
    [anon_sym_thread_local] = ACTIONS(2473),
    [anon_sym___thread] = ACTIONS(2473),
    [anon_sym_const] = ACTIONS(2473),
    [anon_sym_constexpr] = ACTIONS(2473),
    [anon_sym_volatile] = ACTIONS(2473),
    [anon_sym_restrict] = ACTIONS(2473),
    [anon_sym___restrict__] = ACTIONS(2473),
    [anon_sym__Atomic] = ACTIONS(2473),
    [anon_sym__Noreturn] = ACTIONS(2473),
    [anon_sym_noreturn] = ACTIONS(2473),
    [anon_sym_mutable] = ACTIONS(2473),
    [anon_sym_constinit] = ACTIONS(2473),
    [anon_sym_consteval] = ACTIONS(2473),
    [anon_sym___shared__] = ACTIONS(2473),
    [anon_sym___local__] = ACTIONS(2473),
    [anon_sym___constant__] = ACTIONS(2473),
    [anon_sym___managed__] = ACTIONS(2473),
    [anon_sym___grid_constant__] = ACTIONS(2473),
    [anon_sym_alignas] = ACTIONS(2473),
    [anon_sym__Alignas] = ACTIONS(2473),
    [sym_primitive_type] = ACTIONS(2473),
    [anon_sym_enum] = ACTIONS(2473),
    [anon_sym_class] = ACTIONS(2473),
    [anon_sym_struct] = ACTIONS(2473),
    [anon_sym_union] = ACTIONS(2473),
    [anon_sym_if] = ACTIONS(2473),
    [anon_sym_switch] = ACTIONS(2473),
    [anon_sym_case] = ACTIONS(2473),
    [anon_sym_default] = ACTIONS(2473),
    [anon_sym_while] = ACTIONS(2473),
    [anon_sym_do] = ACTIONS(2473),
    [anon_sym_for] = ACTIONS(2473),
    [anon_sym_return] = ACTIONS(2473),
    [anon_sym_break] = ACTIONS(2473),
    [anon_sym_continue] = ACTIONS(2473),
    [anon_sym_goto] = ACTIONS(2473),
    [anon_sym___try] = ACTIONS(2473),
    [anon_sym___leave] = ACTIONS(2473),
    [anon_sym_not] = ACTIONS(2473),
    [anon_sym_compl] = ACTIONS(2473),
    [anon_sym_DASH_DASH] = ACTIONS(2475),
    [anon_sym_PLUS_PLUS] = ACTIONS(2475),
    [anon_sym_sizeof] = ACTIONS(2473),
    [anon_sym___alignof__] = ACTIONS(2473),
    [anon_sym___alignof] = ACTIONS(2473),
    [anon_sym__alignof] = ACTIONS(2473),
    [anon_sym_alignof] = ACTIONS(2473),
    [anon_sym__Alignof] = ACTIONS(2473),
    [anon_sym_offsetof] = ACTIONS(2473),
    [anon_sym__Generic] = ACTIONS(2473),
    [anon_sym_asm] = ACTIONS(2473),
    [anon_sym___asm__] = ACTIONS(2473),
    [sym_number_literal] = ACTIONS(2475),
    [anon_sym_L_SQUOTE] = ACTIONS(2475),
    [anon_sym_u_SQUOTE] = ACTIONS(2475),
    [anon_sym_U_SQUOTE] = ACTIONS(2475),
    [anon_sym_u8_SQUOTE] = ACTIONS(2475),
    [anon_sym_SQUOTE] = ACTIONS(2475),
    [anon_sym_L_DQUOTE] = ACTIONS(2475),
    [anon_sym_u_DQUOTE] = ACTIONS(2475),
    [anon_sym_U_DQUOTE] = ACTIONS(2475),
    [anon_sym_u8_DQUOTE] = ACTIONS(2475),
    [anon_sym_DQUOTE] = ACTIONS(2475),
    [sym_true] = ACTIONS(2473),
    [sym_false] = ACTIONS(2473),
    [anon_sym_NULL] = ACTIONS(2473),
    [anon_sym_nullptr] = ACTIONS(2473),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2473),
    [anon_sym_decltype] = ACTIONS(2473),
    [sym_virtual] = ACTIONS(2473),
    [anon_sym_explicit] = ACTIONS(2473),
    [anon_sym_typename] = ACTIONS(2473),
    [anon_sym_template] = ACTIONS(2473),
    [anon_sym_operator] = ACTIONS(2473),
    [anon_sym_try] = ACTIONS(2473),
    [anon_sym_delete] = ACTIONS(2473),
    [anon_sym_throw] = ACTIONS(2473),
    [anon_sym_namespace] = ACTIONS(2473),
    [anon_sym_using] = ACTIONS(2473),
    [anon_sym_static_assert] = ACTIONS(2473),
    [anon_sym_concept] = ACTIONS(2473),
    [anon_sym_co_return] = ACTIONS(2473),
    [anon_sym_co_yield] = ACTIONS(2473),
    [anon_sym_R_DQUOTE] = ACTIONS(2475),
    [anon_sym_LR_DQUOTE] = ACTIONS(2475),
    [anon_sym_uR_DQUOTE] = ACTIONS(2475),
    [anon_sym_UR_DQUOTE] = ACTIONS(2475),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2475),
    [anon_sym_co_await] = ACTIONS(2473),
    [anon_sym_new] = ACTIONS(2473),
    [anon_sym_requires] = ACTIONS(2473),
    [sym_this] = ACTIONS(2473),
    [anon_sym___launch_bounds__] = ACTIONS(2473),
  },
  [541] = {
    [sym_identifier] = ACTIONS(2271),
    [aux_sym_preproc_include_token1] = ACTIONS(2271),
    [aux_sym_preproc_def_token1] = ACTIONS(2271),
    [aux_sym_preproc_if_token1] = ACTIONS(2271),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2271),
    [sym_preproc_directive] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2273),
    [anon_sym_TILDE] = ACTIONS(2273),
    [anon_sym_DASH] = ACTIONS(2271),
    [anon_sym_PLUS] = ACTIONS(2271),
    [anon_sym_STAR] = ACTIONS(2273),
    [anon_sym_AMP_AMP] = ACTIONS(2273),
    [anon_sym_AMP] = ACTIONS(2271),
    [anon_sym_SEMI] = ACTIONS(2273),
    [anon_sym___extension__] = ACTIONS(2271),
    [anon_sym_typedef] = ACTIONS(2271),
    [anon_sym___device__] = ACTIONS(2271),
    [anon_sym___host__] = ACTIONS(2271),
    [anon_sym___global__] = ACTIONS(2271),
    [anon_sym___forceinline__] = ACTIONS(2271),
    [anon_sym___noinline__] = ACTIONS(2271),
    [anon_sym_extern] = ACTIONS(2271),
    [anon_sym___attribute__] = ACTIONS(2271),
    [anon_sym_COLON_COLON] = ACTIONS(2273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2273),
    [anon_sym___declspec] = ACTIONS(2271),
    [anon_sym___based] = ACTIONS(2271),
    [anon_sym___cdecl] = ACTIONS(2271),
    [anon_sym___clrcall] = ACTIONS(2271),
    [anon_sym___stdcall] = ACTIONS(2271),
    [anon_sym___fastcall] = ACTIONS(2271),
    [anon_sym___thiscall] = ACTIONS(2271),
    [anon_sym___vectorcall] = ACTIONS(2271),
    [anon_sym_LBRACE] = ACTIONS(2273),
    [anon_sym_RBRACE] = ACTIONS(2273),
    [anon_sym_signed] = ACTIONS(2271),
    [anon_sym_unsigned] = ACTIONS(2271),
    [anon_sym_long] = ACTIONS(2271),
    [anon_sym_short] = ACTIONS(2271),
    [anon_sym_LBRACK] = ACTIONS(2271),
    [anon_sym_static] = ACTIONS(2271),
    [anon_sym_register] = ACTIONS(2271),
    [anon_sym_inline] = ACTIONS(2271),
    [anon_sym___inline] = ACTIONS(2271),
    [anon_sym___inline__] = ACTIONS(2271),
    [anon_sym___forceinline] = ACTIONS(2271),
    [anon_sym_thread_local] = ACTIONS(2271),
    [anon_sym___thread] = ACTIONS(2271),
    [anon_sym_const] = ACTIONS(2271),
    [anon_sym_constexpr] = ACTIONS(2271),
    [anon_sym_volatile] = ACTIONS(2271),
    [anon_sym_restrict] = ACTIONS(2271),
    [anon_sym___restrict__] = ACTIONS(2271),
    [anon_sym__Atomic] = ACTIONS(2271),
    [anon_sym__Noreturn] = ACTIONS(2271),
    [anon_sym_noreturn] = ACTIONS(2271),
    [anon_sym_mutable] = ACTIONS(2271),
    [anon_sym_constinit] = ACTIONS(2271),
    [anon_sym_consteval] = ACTIONS(2271),
    [anon_sym___shared__] = ACTIONS(2271),
    [anon_sym___local__] = ACTIONS(2271),
    [anon_sym___constant__] = ACTIONS(2271),
    [anon_sym___managed__] = ACTIONS(2271),
    [anon_sym___grid_constant__] = ACTIONS(2271),
    [anon_sym_alignas] = ACTIONS(2271),
    [anon_sym__Alignas] = ACTIONS(2271),
    [sym_primitive_type] = ACTIONS(2271),
    [anon_sym_enum] = ACTIONS(2271),
    [anon_sym_class] = ACTIONS(2271),
    [anon_sym_struct] = ACTIONS(2271),
    [anon_sym_union] = ACTIONS(2271),
    [anon_sym_if] = ACTIONS(2271),
    [anon_sym_switch] = ACTIONS(2271),
    [anon_sym_case] = ACTIONS(2271),
    [anon_sym_default] = ACTIONS(2271),
    [anon_sym_while] = ACTIONS(2271),
    [anon_sym_do] = ACTIONS(2271),
    [anon_sym_for] = ACTIONS(2271),
    [anon_sym_return] = ACTIONS(2271),
    [anon_sym_break] = ACTIONS(2271),
    [anon_sym_continue] = ACTIONS(2271),
    [anon_sym_goto] = ACTIONS(2271),
    [anon_sym___try] = ACTIONS(2271),
    [anon_sym___leave] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2271),
    [anon_sym_compl] = ACTIONS(2271),
    [anon_sym_DASH_DASH] = ACTIONS(2273),
    [anon_sym_PLUS_PLUS] = ACTIONS(2273),
    [anon_sym_sizeof] = ACTIONS(2271),
    [anon_sym___alignof__] = ACTIONS(2271),
    [anon_sym___alignof] = ACTIONS(2271),
    [anon_sym__alignof] = ACTIONS(2271),
    [anon_sym_alignof] = ACTIONS(2271),
    [anon_sym__Alignof] = ACTIONS(2271),
    [anon_sym_offsetof] = ACTIONS(2271),
    [anon_sym__Generic] = ACTIONS(2271),
    [anon_sym_asm] = ACTIONS(2271),
    [anon_sym___asm__] = ACTIONS(2271),
    [sym_number_literal] = ACTIONS(2273),
    [anon_sym_L_SQUOTE] = ACTIONS(2273),
    [anon_sym_u_SQUOTE] = ACTIONS(2273),
    [anon_sym_U_SQUOTE] = ACTIONS(2273),
    [anon_sym_u8_SQUOTE] = ACTIONS(2273),
    [anon_sym_SQUOTE] = ACTIONS(2273),
    [anon_sym_L_DQUOTE] = ACTIONS(2273),
    [anon_sym_u_DQUOTE] = ACTIONS(2273),
    [anon_sym_U_DQUOTE] = ACTIONS(2273),
    [anon_sym_u8_DQUOTE] = ACTIONS(2273),
    [anon_sym_DQUOTE] = ACTIONS(2273),
    [sym_true] = ACTIONS(2271),
    [sym_false] = ACTIONS(2271),
    [anon_sym_NULL] = ACTIONS(2271),
    [anon_sym_nullptr] = ACTIONS(2271),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2271),
    [anon_sym_decltype] = ACTIONS(2271),
    [sym_virtual] = ACTIONS(2271),
    [anon_sym_explicit] = ACTIONS(2271),
    [anon_sym_typename] = ACTIONS(2271),
    [anon_sym_template] = ACTIONS(2271),
    [anon_sym_operator] = ACTIONS(2271),
    [anon_sym_try] = ACTIONS(2271),
    [anon_sym_delete] = ACTIONS(2271),
    [anon_sym_throw] = ACTIONS(2271),
    [anon_sym_namespace] = ACTIONS(2271),
    [anon_sym_using] = ACTIONS(2271),
    [anon_sym_static_assert] = ACTIONS(2271),
    [anon_sym_concept] = ACTIONS(2271),
    [anon_sym_co_return] = ACTIONS(2271),
    [anon_sym_co_yield] = ACTIONS(2271),
    [anon_sym_R_DQUOTE] = ACTIONS(2273),
    [anon_sym_LR_DQUOTE] = ACTIONS(2273),
    [anon_sym_uR_DQUOTE] = ACTIONS(2273),
    [anon_sym_UR_DQUOTE] = ACTIONS(2273),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2273),
    [anon_sym_co_await] = ACTIONS(2271),
    [anon_sym_new] = ACTIONS(2271),
    [anon_sym_requires] = ACTIONS(2271),
    [sym_this] = ACTIONS(2271),
    [anon_sym___launch_bounds__] = ACTIONS(2271),
  },
  [542] = {
    [sym_identifier] = ACTIONS(2500),
    [aux_sym_preproc_include_token1] = ACTIONS(2500),
    [aux_sym_preproc_def_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2500),
    [sym_preproc_directive] = ACTIONS(2500),
    [anon_sym_LPAREN2] = ACTIONS(2502),
    [anon_sym_BANG] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [anon_sym_DASH] = ACTIONS(2500),
    [anon_sym_PLUS] = ACTIONS(2500),
    [anon_sym_STAR] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_typedef] = ACTIONS(2500),
    [anon_sym___device__] = ACTIONS(2500),
    [anon_sym___host__] = ACTIONS(2500),
    [anon_sym___global__] = ACTIONS(2500),
    [anon_sym___forceinline__] = ACTIONS(2500),
    [anon_sym___noinline__] = ACTIONS(2500),
    [anon_sym_extern] = ACTIONS(2500),
    [anon_sym___attribute__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2502),
    [anon_sym___declspec] = ACTIONS(2500),
    [anon_sym___based] = ACTIONS(2500),
    [anon_sym___cdecl] = ACTIONS(2500),
    [anon_sym___clrcall] = ACTIONS(2500),
    [anon_sym___stdcall] = ACTIONS(2500),
    [anon_sym___fastcall] = ACTIONS(2500),
    [anon_sym___thiscall] = ACTIONS(2500),
    [anon_sym___vectorcall] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(2502),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_signed] = ACTIONS(2500),
    [anon_sym_unsigned] = ACTIONS(2500),
    [anon_sym_long] = ACTIONS(2500),
    [anon_sym_short] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_static] = ACTIONS(2500),
    [anon_sym_register] = ACTIONS(2500),
    [anon_sym_inline] = ACTIONS(2500),
    [anon_sym___inline] = ACTIONS(2500),
    [anon_sym___inline__] = ACTIONS(2500),
    [anon_sym___forceinline] = ACTIONS(2500),
    [anon_sym_thread_local] = ACTIONS(2500),
    [anon_sym___thread] = ACTIONS(2500),
    [anon_sym_const] = ACTIONS(2500),
    [anon_sym_constexpr] = ACTIONS(2500),
    [anon_sym_volatile] = ACTIONS(2500),
    [anon_sym_restrict] = ACTIONS(2500),
    [anon_sym___restrict__] = ACTIONS(2500),
    [anon_sym__Atomic] = ACTIONS(2500),
    [anon_sym__Noreturn] = ACTIONS(2500),
    [anon_sym_noreturn] = ACTIONS(2500),
    [anon_sym_mutable] = ACTIONS(2500),
    [anon_sym_constinit] = ACTIONS(2500),
    [anon_sym_consteval] = ACTIONS(2500),
    [anon_sym___shared__] = ACTIONS(2500),
    [anon_sym___local__] = ACTIONS(2500),
    [anon_sym___constant__] = ACTIONS(2500),
    [anon_sym___managed__] = ACTIONS(2500),
    [anon_sym___grid_constant__] = ACTIONS(2500),
    [anon_sym_alignas] = ACTIONS(2500),
    [anon_sym__Alignas] = ACTIONS(2500),
    [sym_primitive_type] = ACTIONS(2500),
    [anon_sym_enum] = ACTIONS(2500),
    [anon_sym_class] = ACTIONS(2500),
    [anon_sym_struct] = ACTIONS(2500),
    [anon_sym_union] = ACTIONS(2500),
    [anon_sym_if] = ACTIONS(2500),
    [anon_sym_switch] = ACTIONS(2500),
    [anon_sym_case] = ACTIONS(2500),
    [anon_sym_default] = ACTIONS(2500),
    [anon_sym_while] = ACTIONS(2500),
    [anon_sym_do] = ACTIONS(2500),
    [anon_sym_for] = ACTIONS(2500),
    [anon_sym_return] = ACTIONS(2500),
    [anon_sym_break] = ACTIONS(2500),
    [anon_sym_continue] = ACTIONS(2500),
    [anon_sym_goto] = ACTIONS(2500),
    [anon_sym___try] = ACTIONS(2500),
    [anon_sym___leave] = ACTIONS(2500),
    [anon_sym_not] = ACTIONS(2500),
    [anon_sym_compl] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(2502),
    [anon_sym_PLUS_PLUS] = ACTIONS(2502),
    [anon_sym_sizeof] = ACTIONS(2500),
    [anon_sym___alignof__] = ACTIONS(2500),
    [anon_sym___alignof] = ACTIONS(2500),
    [anon_sym__alignof] = ACTIONS(2500),
    [anon_sym_alignof] = ACTIONS(2500),
    [anon_sym__Alignof] = ACTIONS(2500),
    [anon_sym_offsetof] = ACTIONS(2500),
    [anon_sym__Generic] = ACTIONS(2500),
    [anon_sym_asm] = ACTIONS(2500),
    [anon_sym___asm__] = ACTIONS(2500),
    [sym_number_literal] = ACTIONS(2502),
    [anon_sym_L_SQUOTE] = ACTIONS(2502),
    [anon_sym_u_SQUOTE] = ACTIONS(2502),
    [anon_sym_U_SQUOTE] = ACTIONS(2502),
    [anon_sym_u8_SQUOTE] = ACTIONS(2502),
    [anon_sym_SQUOTE] = ACTIONS(2502),
    [anon_sym_L_DQUOTE] = ACTIONS(2502),
    [anon_sym_u_DQUOTE] = ACTIONS(2502),
    [anon_sym_U_DQUOTE] = ACTIONS(2502),
    [anon_sym_u8_DQUOTE] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [sym_true] = ACTIONS(2500),
    [sym_false] = ACTIONS(2500),
    [anon_sym_NULL] = ACTIONS(2500),
    [anon_sym_nullptr] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2500),
    [anon_sym_decltype] = ACTIONS(2500),
    [sym_virtual] = ACTIONS(2500),
    [anon_sym_explicit] = ACTIONS(2500),
    [anon_sym_typename] = ACTIONS(2500),
    [anon_sym_template] = ACTIONS(2500),
    [anon_sym_operator] = ACTIONS(2500),
    [anon_sym_try] = ACTIONS(2500),
    [anon_sym_delete] = ACTIONS(2500),
    [anon_sym_throw] = ACTIONS(2500),
    [anon_sym_namespace] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_static_assert] = ACTIONS(2500),
    [anon_sym_concept] = ACTIONS(2500),
    [anon_sym_co_return] = ACTIONS(2500),
    [anon_sym_co_yield] = ACTIONS(2500),
    [anon_sym_R_DQUOTE] = ACTIONS(2502),
    [anon_sym_LR_DQUOTE] = ACTIONS(2502),
    [anon_sym_uR_DQUOTE] = ACTIONS(2502),
    [anon_sym_UR_DQUOTE] = ACTIONS(2502),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2502),
    [anon_sym_co_await] = ACTIONS(2500),
    [anon_sym_new] = ACTIONS(2500),
    [anon_sym_requires] = ACTIONS(2500),
    [sym_this] = ACTIONS(2500),
    [anon_sym___launch_bounds__] = ACTIONS(2500),
  },
  [543] = {
    [sym_identifier] = ACTIONS(2500),
    [aux_sym_preproc_include_token1] = ACTIONS(2500),
    [aux_sym_preproc_def_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2500),
    [sym_preproc_directive] = ACTIONS(2500),
    [anon_sym_LPAREN2] = ACTIONS(2502),
    [anon_sym_BANG] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [anon_sym_DASH] = ACTIONS(2500),
    [anon_sym_PLUS] = ACTIONS(2500),
    [anon_sym_STAR] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_typedef] = ACTIONS(2500),
    [anon_sym___device__] = ACTIONS(2500),
    [anon_sym___host__] = ACTIONS(2500),
    [anon_sym___global__] = ACTIONS(2500),
    [anon_sym___forceinline__] = ACTIONS(2500),
    [anon_sym___noinline__] = ACTIONS(2500),
    [anon_sym_extern] = ACTIONS(2500),
    [anon_sym___attribute__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2502),
    [anon_sym___declspec] = ACTIONS(2500),
    [anon_sym___based] = ACTIONS(2500),
    [anon_sym___cdecl] = ACTIONS(2500),
    [anon_sym___clrcall] = ACTIONS(2500),
    [anon_sym___stdcall] = ACTIONS(2500),
    [anon_sym___fastcall] = ACTIONS(2500),
    [anon_sym___thiscall] = ACTIONS(2500),
    [anon_sym___vectorcall] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(2502),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_signed] = ACTIONS(2500),
    [anon_sym_unsigned] = ACTIONS(2500),
    [anon_sym_long] = ACTIONS(2500),
    [anon_sym_short] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_static] = ACTIONS(2500),
    [anon_sym_register] = ACTIONS(2500),
    [anon_sym_inline] = ACTIONS(2500),
    [anon_sym___inline] = ACTIONS(2500),
    [anon_sym___inline__] = ACTIONS(2500),
    [anon_sym___forceinline] = ACTIONS(2500),
    [anon_sym_thread_local] = ACTIONS(2500),
    [anon_sym___thread] = ACTIONS(2500),
    [anon_sym_const] = ACTIONS(2500),
    [anon_sym_constexpr] = ACTIONS(2500),
    [anon_sym_volatile] = ACTIONS(2500),
    [anon_sym_restrict] = ACTIONS(2500),
    [anon_sym___restrict__] = ACTIONS(2500),
    [anon_sym__Atomic] = ACTIONS(2500),
    [anon_sym__Noreturn] = ACTIONS(2500),
    [anon_sym_noreturn] = ACTIONS(2500),
    [anon_sym_mutable] = ACTIONS(2500),
    [anon_sym_constinit] = ACTIONS(2500),
    [anon_sym_consteval] = ACTIONS(2500),
    [anon_sym___shared__] = ACTIONS(2500),
    [anon_sym___local__] = ACTIONS(2500),
    [anon_sym___constant__] = ACTIONS(2500),
    [anon_sym___managed__] = ACTIONS(2500),
    [anon_sym___grid_constant__] = ACTIONS(2500),
    [anon_sym_alignas] = ACTIONS(2500),
    [anon_sym__Alignas] = ACTIONS(2500),
    [sym_primitive_type] = ACTIONS(2500),
    [anon_sym_enum] = ACTIONS(2500),
    [anon_sym_class] = ACTIONS(2500),
    [anon_sym_struct] = ACTIONS(2500),
    [anon_sym_union] = ACTIONS(2500),
    [anon_sym_if] = ACTIONS(2500),
    [anon_sym_switch] = ACTIONS(2500),
    [anon_sym_case] = ACTIONS(2500),
    [anon_sym_default] = ACTIONS(2500),
    [anon_sym_while] = ACTIONS(2500),
    [anon_sym_do] = ACTIONS(2500),
    [anon_sym_for] = ACTIONS(2500),
    [anon_sym_return] = ACTIONS(2500),
    [anon_sym_break] = ACTIONS(2500),
    [anon_sym_continue] = ACTIONS(2500),
    [anon_sym_goto] = ACTIONS(2500),
    [anon_sym___try] = ACTIONS(2500),
    [anon_sym___leave] = ACTIONS(2500),
    [anon_sym_not] = ACTIONS(2500),
    [anon_sym_compl] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(2502),
    [anon_sym_PLUS_PLUS] = ACTIONS(2502),
    [anon_sym_sizeof] = ACTIONS(2500),
    [anon_sym___alignof__] = ACTIONS(2500),
    [anon_sym___alignof] = ACTIONS(2500),
    [anon_sym__alignof] = ACTIONS(2500),
    [anon_sym_alignof] = ACTIONS(2500),
    [anon_sym__Alignof] = ACTIONS(2500),
    [anon_sym_offsetof] = ACTIONS(2500),
    [anon_sym__Generic] = ACTIONS(2500),
    [anon_sym_asm] = ACTIONS(2500),
    [anon_sym___asm__] = ACTIONS(2500),
    [sym_number_literal] = ACTIONS(2502),
    [anon_sym_L_SQUOTE] = ACTIONS(2502),
    [anon_sym_u_SQUOTE] = ACTIONS(2502),
    [anon_sym_U_SQUOTE] = ACTIONS(2502),
    [anon_sym_u8_SQUOTE] = ACTIONS(2502),
    [anon_sym_SQUOTE] = ACTIONS(2502),
    [anon_sym_L_DQUOTE] = ACTIONS(2502),
    [anon_sym_u_DQUOTE] = ACTIONS(2502),
    [anon_sym_U_DQUOTE] = ACTIONS(2502),
    [anon_sym_u8_DQUOTE] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [sym_true] = ACTIONS(2500),
    [sym_false] = ACTIONS(2500),
    [anon_sym_NULL] = ACTIONS(2500),
    [anon_sym_nullptr] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2500),
    [anon_sym_decltype] = ACTIONS(2500),
    [sym_virtual] = ACTIONS(2500),
    [anon_sym_explicit] = ACTIONS(2500),
    [anon_sym_typename] = ACTIONS(2500),
    [anon_sym_template] = ACTIONS(2500),
    [anon_sym_operator] = ACTIONS(2500),
    [anon_sym_try] = ACTIONS(2500),
    [anon_sym_delete] = ACTIONS(2500),
    [anon_sym_throw] = ACTIONS(2500),
    [anon_sym_namespace] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_static_assert] = ACTIONS(2500),
    [anon_sym_concept] = ACTIONS(2500),
    [anon_sym_co_return] = ACTIONS(2500),
    [anon_sym_co_yield] = ACTIONS(2500),
    [anon_sym_R_DQUOTE] = ACTIONS(2502),
    [anon_sym_LR_DQUOTE] = ACTIONS(2502),
    [anon_sym_uR_DQUOTE] = ACTIONS(2502),
    [anon_sym_UR_DQUOTE] = ACTIONS(2502),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2502),
    [anon_sym_co_await] = ACTIONS(2500),
    [anon_sym_new] = ACTIONS(2500),
    [anon_sym_requires] = ACTIONS(2500),
    [sym_this] = ACTIONS(2500),
    [anon_sym___launch_bounds__] = ACTIONS(2500),
  },
  [544] = {
    [sym_identifier] = ACTIONS(2080),
    [aux_sym_preproc_include_token1] = ACTIONS(2080),
    [aux_sym_preproc_def_token1] = ACTIONS(2080),
    [aux_sym_preproc_if_token1] = ACTIONS(2080),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2080),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2080),
    [sym_preproc_directive] = ACTIONS(2080),
    [anon_sym_LPAREN2] = ACTIONS(2082),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_DASH] = ACTIONS(2080),
    [anon_sym_PLUS] = ACTIONS(2080),
    [anon_sym_STAR] = ACTIONS(2082),
    [anon_sym_AMP_AMP] = ACTIONS(2082),
    [anon_sym_AMP] = ACTIONS(2080),
    [anon_sym_SEMI] = ACTIONS(2082),
    [anon_sym___extension__] = ACTIONS(2080),
    [anon_sym_typedef] = ACTIONS(2080),
    [anon_sym___device__] = ACTIONS(2080),
    [anon_sym___host__] = ACTIONS(2080),
    [anon_sym___global__] = ACTIONS(2080),
    [anon_sym___forceinline__] = ACTIONS(2080),
    [anon_sym___noinline__] = ACTIONS(2080),
    [anon_sym_extern] = ACTIONS(2080),
    [anon_sym___attribute__] = ACTIONS(2080),
    [anon_sym_COLON_COLON] = ACTIONS(2082),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2082),
    [anon_sym___declspec] = ACTIONS(2080),
    [anon_sym___based] = ACTIONS(2080),
    [anon_sym___cdecl] = ACTIONS(2080),
    [anon_sym___clrcall] = ACTIONS(2080),
    [anon_sym___stdcall] = ACTIONS(2080),
    [anon_sym___fastcall] = ACTIONS(2080),
    [anon_sym___thiscall] = ACTIONS(2080),
    [anon_sym___vectorcall] = ACTIONS(2080),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [anon_sym_signed] = ACTIONS(2080),
    [anon_sym_unsigned] = ACTIONS(2080),
    [anon_sym_long] = ACTIONS(2080),
    [anon_sym_short] = ACTIONS(2080),
    [anon_sym_LBRACK] = ACTIONS(2080),
    [anon_sym_static] = ACTIONS(2080),
    [anon_sym_register] = ACTIONS(2080),
    [anon_sym_inline] = ACTIONS(2080),
    [anon_sym___inline] = ACTIONS(2080),
    [anon_sym___inline__] = ACTIONS(2080),
    [anon_sym___forceinline] = ACTIONS(2080),
    [anon_sym_thread_local] = ACTIONS(2080),
    [anon_sym___thread] = ACTIONS(2080),
    [anon_sym_const] = ACTIONS(2080),
    [anon_sym_constexpr] = ACTIONS(2080),
    [anon_sym_volatile] = ACTIONS(2080),
    [anon_sym_restrict] = ACTIONS(2080),
    [anon_sym___restrict__] = ACTIONS(2080),
    [anon_sym__Atomic] = ACTIONS(2080),
    [anon_sym__Noreturn] = ACTIONS(2080),
    [anon_sym_noreturn] = ACTIONS(2080),
    [anon_sym_mutable] = ACTIONS(2080),
    [anon_sym_constinit] = ACTIONS(2080),
    [anon_sym_consteval] = ACTIONS(2080),
    [anon_sym___shared__] = ACTIONS(2080),
    [anon_sym___local__] = ACTIONS(2080),
    [anon_sym___constant__] = ACTIONS(2080),
    [anon_sym___managed__] = ACTIONS(2080),
    [anon_sym___grid_constant__] = ACTIONS(2080),
    [anon_sym_alignas] = ACTIONS(2080),
    [anon_sym__Alignas] = ACTIONS(2080),
    [sym_primitive_type] = ACTIONS(2080),
    [anon_sym_enum] = ACTIONS(2080),
    [anon_sym_class] = ACTIONS(2080),
    [anon_sym_struct] = ACTIONS(2080),
    [anon_sym_union] = ACTIONS(2080),
    [anon_sym_if] = ACTIONS(2080),
    [anon_sym_switch] = ACTIONS(2080),
    [anon_sym_case] = ACTIONS(2080),
    [anon_sym_default] = ACTIONS(2080),
    [anon_sym_while] = ACTIONS(2080),
    [anon_sym_do] = ACTIONS(2080),
    [anon_sym_for] = ACTIONS(2080),
    [anon_sym_return] = ACTIONS(2080),
    [anon_sym_break] = ACTIONS(2080),
    [anon_sym_continue] = ACTIONS(2080),
    [anon_sym_goto] = ACTIONS(2080),
    [anon_sym___try] = ACTIONS(2080),
    [anon_sym___leave] = ACTIONS(2080),
    [anon_sym_not] = ACTIONS(2080),
    [anon_sym_compl] = ACTIONS(2080),
    [anon_sym_DASH_DASH] = ACTIONS(2082),
    [anon_sym_PLUS_PLUS] = ACTIONS(2082),
    [anon_sym_sizeof] = ACTIONS(2080),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2080),
    [anon_sym__Generic] = ACTIONS(2080),
    [anon_sym_asm] = ACTIONS(2080),
    [anon_sym___asm__] = ACTIONS(2080),
    [sym_number_literal] = ACTIONS(2082),
    [anon_sym_L_SQUOTE] = ACTIONS(2082),
    [anon_sym_u_SQUOTE] = ACTIONS(2082),
    [anon_sym_U_SQUOTE] = ACTIONS(2082),
    [anon_sym_u8_SQUOTE] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2082),
    [anon_sym_L_DQUOTE] = ACTIONS(2082),
    [anon_sym_u_DQUOTE] = ACTIONS(2082),
    [anon_sym_U_DQUOTE] = ACTIONS(2082),
    [anon_sym_u8_DQUOTE] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [sym_true] = ACTIONS(2080),
    [sym_false] = ACTIONS(2080),
    [anon_sym_NULL] = ACTIONS(2080),
    [anon_sym_nullptr] = ACTIONS(2080),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2080),
    [anon_sym_decltype] = ACTIONS(2080),
    [sym_virtual] = ACTIONS(2080),
    [anon_sym_explicit] = ACTIONS(2080),
    [anon_sym_typename] = ACTIONS(2080),
    [anon_sym_template] = ACTIONS(2080),
    [anon_sym_operator] = ACTIONS(2080),
    [anon_sym_try] = ACTIONS(2080),
    [anon_sym_delete] = ACTIONS(2080),
    [anon_sym_throw] = ACTIONS(2080),
    [anon_sym_namespace] = ACTIONS(2080),
    [anon_sym_using] = ACTIONS(2080),
    [anon_sym_static_assert] = ACTIONS(2080),
    [anon_sym_concept] = ACTIONS(2080),
    [anon_sym_co_return] = ACTIONS(2080),
    [anon_sym_co_yield] = ACTIONS(2080),
    [anon_sym_R_DQUOTE] = ACTIONS(2082),
    [anon_sym_LR_DQUOTE] = ACTIONS(2082),
    [anon_sym_uR_DQUOTE] = ACTIONS(2082),
    [anon_sym_UR_DQUOTE] = ACTIONS(2082),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2082),
    [anon_sym_co_await] = ACTIONS(2080),
    [anon_sym_new] = ACTIONS(2080),
    [anon_sym_requires] = ACTIONS(2080),
    [sym_this] = ACTIONS(2080),
    [anon_sym___launch_bounds__] = ACTIONS(2080),
  },
  [545] = {
    [sym_expression] = STATE(3126),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_initializer_list] = STATE(3803),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2510),
    [anon_sym_RPAREN] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_BANG] = ACTIONS(1831),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2508),
    [anon_sym_STAR] = ACTIONS(2508),
    [anon_sym_SLASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_PIPE] = ACTIONS(2508),
    [anon_sym_CARET] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_EQ_EQ] = ACTIONS(2510),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_GT] = ACTIONS(2508),
    [anon_sym_GT_EQ] = ACTIONS(2510),
    [anon_sym_LT_EQ] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_LT_LT] = ACTIONS(2508),
    [anon_sym_GT_GT] = ACTIONS(2508),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_EQ] = ACTIONS(2508),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_STAR_EQ] = ACTIONS(2510),
    [anon_sym_SLASH_EQ] = ACTIONS(2510),
    [anon_sym_PERCENT_EQ] = ACTIONS(2510),
    [anon_sym_PLUS_EQ] = ACTIONS(2510),
    [anon_sym_DASH_EQ] = ACTIONS(2510),
    [anon_sym_LT_LT_EQ] = ACTIONS(2510),
    [anon_sym_GT_GT_EQ] = ACTIONS(2510),
    [anon_sym_AMP_EQ] = ACTIONS(2510),
    [anon_sym_CARET_EQ] = ACTIONS(2510),
    [anon_sym_PIPE_EQ] = ACTIONS(2510),
    [anon_sym_and_eq] = ACTIONS(2508),
    [anon_sym_or_eq] = ACTIONS(2508),
    [anon_sym_xor_eq] = ACTIONS(2508),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_LT_EQ_GT] = ACTIONS(2510),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_bitor] = ACTIONS(2508),
    [anon_sym_xor] = ACTIONS(2508),
    [anon_sym_bitand] = ACTIONS(2508),
    [anon_sym_not_eq] = ACTIONS(2508),
    [anon_sym_DASH_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_PLUS] = ACTIONS(2510),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [anon_sym_DOT] = ACTIONS(2508),
    [anon_sym_DOT_STAR] = ACTIONS(2510),
    [anon_sym_DASH_GT] = ACTIONS(2508),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2510),
    [sym_this] = ACTIONS(1873),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(2510),
  },
  [546] = {
    [sym_identifier] = ACTIONS(2259),
    [aux_sym_preproc_include_token1] = ACTIONS(2259),
    [aux_sym_preproc_def_token1] = ACTIONS(2259),
    [aux_sym_preproc_if_token1] = ACTIONS(2259),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2259),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2259),
    [sym_preproc_directive] = ACTIONS(2259),
    [anon_sym_LPAREN2] = ACTIONS(2261),
    [anon_sym_BANG] = ACTIONS(2261),
    [anon_sym_TILDE] = ACTIONS(2261),
    [anon_sym_DASH] = ACTIONS(2259),
    [anon_sym_PLUS] = ACTIONS(2259),
    [anon_sym_STAR] = ACTIONS(2261),
    [anon_sym_AMP_AMP] = ACTIONS(2261),
    [anon_sym_AMP] = ACTIONS(2259),
    [anon_sym_SEMI] = ACTIONS(2261),
    [anon_sym___extension__] = ACTIONS(2259),
    [anon_sym_typedef] = ACTIONS(2259),
    [anon_sym___device__] = ACTIONS(2259),
    [anon_sym___host__] = ACTIONS(2259),
    [anon_sym___global__] = ACTIONS(2259),
    [anon_sym___forceinline__] = ACTIONS(2259),
    [anon_sym___noinline__] = ACTIONS(2259),
    [anon_sym_extern] = ACTIONS(2259),
    [anon_sym___attribute__] = ACTIONS(2259),
    [anon_sym_COLON_COLON] = ACTIONS(2261),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2261),
    [anon_sym___declspec] = ACTIONS(2259),
    [anon_sym___based] = ACTIONS(2259),
    [anon_sym___cdecl] = ACTIONS(2259),
    [anon_sym___clrcall] = ACTIONS(2259),
    [anon_sym___stdcall] = ACTIONS(2259),
    [anon_sym___fastcall] = ACTIONS(2259),
    [anon_sym___thiscall] = ACTIONS(2259),
    [anon_sym___vectorcall] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(2261),
    [anon_sym_RBRACE] = ACTIONS(2261),
    [anon_sym_signed] = ACTIONS(2259),
    [anon_sym_unsigned] = ACTIONS(2259),
    [anon_sym_long] = ACTIONS(2259),
    [anon_sym_short] = ACTIONS(2259),
    [anon_sym_LBRACK] = ACTIONS(2259),
    [anon_sym_static] = ACTIONS(2259),
    [anon_sym_register] = ACTIONS(2259),
    [anon_sym_inline] = ACTIONS(2259),
    [anon_sym___inline] = ACTIONS(2259),
    [anon_sym___inline__] = ACTIONS(2259),
    [anon_sym___forceinline] = ACTIONS(2259),
    [anon_sym_thread_local] = ACTIONS(2259),
    [anon_sym___thread] = ACTIONS(2259),
    [anon_sym_const] = ACTIONS(2259),
    [anon_sym_constexpr] = ACTIONS(2259),
    [anon_sym_volatile] = ACTIONS(2259),
    [anon_sym_restrict] = ACTIONS(2259),
    [anon_sym___restrict__] = ACTIONS(2259),
    [anon_sym__Atomic] = ACTIONS(2259),
    [anon_sym__Noreturn] = ACTIONS(2259),
    [anon_sym_noreturn] = ACTIONS(2259),
    [anon_sym_mutable] = ACTIONS(2259),
    [anon_sym_constinit] = ACTIONS(2259),
    [anon_sym_consteval] = ACTIONS(2259),
    [anon_sym___shared__] = ACTIONS(2259),
    [anon_sym___local__] = ACTIONS(2259),
    [anon_sym___constant__] = ACTIONS(2259),
    [anon_sym___managed__] = ACTIONS(2259),
    [anon_sym___grid_constant__] = ACTIONS(2259),
    [anon_sym_alignas] = ACTIONS(2259),
    [anon_sym__Alignas] = ACTIONS(2259),
    [sym_primitive_type] = ACTIONS(2259),
    [anon_sym_enum] = ACTIONS(2259),
    [anon_sym_class] = ACTIONS(2259),
    [anon_sym_struct] = ACTIONS(2259),
    [anon_sym_union] = ACTIONS(2259),
    [anon_sym_if] = ACTIONS(2259),
    [anon_sym_switch] = ACTIONS(2259),
    [anon_sym_case] = ACTIONS(2259),
    [anon_sym_default] = ACTIONS(2259),
    [anon_sym_while] = ACTIONS(2259),
    [anon_sym_do] = ACTIONS(2259),
    [anon_sym_for] = ACTIONS(2259),
    [anon_sym_return] = ACTIONS(2259),
    [anon_sym_break] = ACTIONS(2259),
    [anon_sym_continue] = ACTIONS(2259),
    [anon_sym_goto] = ACTIONS(2259),
    [anon_sym___try] = ACTIONS(2259),
    [anon_sym___leave] = ACTIONS(2259),
    [anon_sym_not] = ACTIONS(2259),
    [anon_sym_compl] = ACTIONS(2259),
    [anon_sym_DASH_DASH] = ACTIONS(2261),
    [anon_sym_PLUS_PLUS] = ACTIONS(2261),
    [anon_sym_sizeof] = ACTIONS(2259),
    [anon_sym___alignof__] = ACTIONS(2259),
    [anon_sym___alignof] = ACTIONS(2259),
    [anon_sym__alignof] = ACTIONS(2259),
    [anon_sym_alignof] = ACTIONS(2259),
    [anon_sym__Alignof] = ACTIONS(2259),
    [anon_sym_offsetof] = ACTIONS(2259),
    [anon_sym__Generic] = ACTIONS(2259),
    [anon_sym_asm] = ACTIONS(2259),
    [anon_sym___asm__] = ACTIONS(2259),
    [sym_number_literal] = ACTIONS(2261),
    [anon_sym_L_SQUOTE] = ACTIONS(2261),
    [anon_sym_u_SQUOTE] = ACTIONS(2261),
    [anon_sym_U_SQUOTE] = ACTIONS(2261),
    [anon_sym_u8_SQUOTE] = ACTIONS(2261),
    [anon_sym_SQUOTE] = ACTIONS(2261),
    [anon_sym_L_DQUOTE] = ACTIONS(2261),
    [anon_sym_u_DQUOTE] = ACTIONS(2261),
    [anon_sym_U_DQUOTE] = ACTIONS(2261),
    [anon_sym_u8_DQUOTE] = ACTIONS(2261),
    [anon_sym_DQUOTE] = ACTIONS(2261),
    [sym_true] = ACTIONS(2259),
    [sym_false] = ACTIONS(2259),
    [anon_sym_NULL] = ACTIONS(2259),
    [anon_sym_nullptr] = ACTIONS(2259),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2259),
    [anon_sym_decltype] = ACTIONS(2259),
    [sym_virtual] = ACTIONS(2259),
    [anon_sym_explicit] = ACTIONS(2259),
    [anon_sym_typename] = ACTIONS(2259),
    [anon_sym_template] = ACTIONS(2259),
    [anon_sym_operator] = ACTIONS(2259),
    [anon_sym_try] = ACTIONS(2259),
    [anon_sym_delete] = ACTIONS(2259),
    [anon_sym_throw] = ACTIONS(2259),
    [anon_sym_namespace] = ACTIONS(2259),
    [anon_sym_using] = ACTIONS(2259),
    [anon_sym_static_assert] = ACTIONS(2259),
    [anon_sym_concept] = ACTIONS(2259),
    [anon_sym_co_return] = ACTIONS(2259),
    [anon_sym_co_yield] = ACTIONS(2259),
    [anon_sym_R_DQUOTE] = ACTIONS(2261),
    [anon_sym_LR_DQUOTE] = ACTIONS(2261),
    [anon_sym_uR_DQUOTE] = ACTIONS(2261),
    [anon_sym_UR_DQUOTE] = ACTIONS(2261),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2261),
    [anon_sym_co_await] = ACTIONS(2259),
    [anon_sym_new] = ACTIONS(2259),
    [anon_sym_requires] = ACTIONS(2259),
    [sym_this] = ACTIONS(2259),
    [anon_sym___launch_bounds__] = ACTIONS(2259),
  },
  [547] = {
    [sym_identifier] = ACTIONS(2352),
    [aux_sym_preproc_include_token1] = ACTIONS(2352),
    [aux_sym_preproc_def_token1] = ACTIONS(2352),
    [aux_sym_preproc_if_token1] = ACTIONS(2352),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2352),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2352),
    [sym_preproc_directive] = ACTIONS(2352),
    [anon_sym_LPAREN2] = ACTIONS(2354),
    [anon_sym_BANG] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2354),
    [anon_sym_DASH] = ACTIONS(2352),
    [anon_sym_PLUS] = ACTIONS(2352),
    [anon_sym_STAR] = ACTIONS(2354),
    [anon_sym_AMP_AMP] = ACTIONS(2354),
    [anon_sym_AMP] = ACTIONS(2352),
    [anon_sym_SEMI] = ACTIONS(2354),
    [anon_sym___extension__] = ACTIONS(2352),
    [anon_sym_typedef] = ACTIONS(2352),
    [anon_sym___device__] = ACTIONS(2352),
    [anon_sym___host__] = ACTIONS(2352),
    [anon_sym___global__] = ACTIONS(2352),
    [anon_sym___forceinline__] = ACTIONS(2352),
    [anon_sym___noinline__] = ACTIONS(2352),
    [anon_sym_extern] = ACTIONS(2352),
    [anon_sym___attribute__] = ACTIONS(2352),
    [anon_sym_COLON_COLON] = ACTIONS(2354),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2354),
    [anon_sym___declspec] = ACTIONS(2352),
    [anon_sym___based] = ACTIONS(2352),
    [anon_sym___cdecl] = ACTIONS(2352),
    [anon_sym___clrcall] = ACTIONS(2352),
    [anon_sym___stdcall] = ACTIONS(2352),
    [anon_sym___fastcall] = ACTIONS(2352),
    [anon_sym___thiscall] = ACTIONS(2352),
    [anon_sym___vectorcall] = ACTIONS(2352),
    [anon_sym_LBRACE] = ACTIONS(2354),
    [anon_sym_RBRACE] = ACTIONS(2354),
    [anon_sym_signed] = ACTIONS(2352),
    [anon_sym_unsigned] = ACTIONS(2352),
    [anon_sym_long] = ACTIONS(2352),
    [anon_sym_short] = ACTIONS(2352),
    [anon_sym_LBRACK] = ACTIONS(2352),
    [anon_sym_static] = ACTIONS(2352),
    [anon_sym_register] = ACTIONS(2352),
    [anon_sym_inline] = ACTIONS(2352),
    [anon_sym___inline] = ACTIONS(2352),
    [anon_sym___inline__] = ACTIONS(2352),
    [anon_sym___forceinline] = ACTIONS(2352),
    [anon_sym_thread_local] = ACTIONS(2352),
    [anon_sym___thread] = ACTIONS(2352),
    [anon_sym_const] = ACTIONS(2352),
    [anon_sym_constexpr] = ACTIONS(2352),
    [anon_sym_volatile] = ACTIONS(2352),
    [anon_sym_restrict] = ACTIONS(2352),
    [anon_sym___restrict__] = ACTIONS(2352),
    [anon_sym__Atomic] = ACTIONS(2352),
    [anon_sym__Noreturn] = ACTIONS(2352),
    [anon_sym_noreturn] = ACTIONS(2352),
    [anon_sym_mutable] = ACTIONS(2352),
    [anon_sym_constinit] = ACTIONS(2352),
    [anon_sym_consteval] = ACTIONS(2352),
    [anon_sym___shared__] = ACTIONS(2352),
    [anon_sym___local__] = ACTIONS(2352),
    [anon_sym___constant__] = ACTIONS(2352),
    [anon_sym___managed__] = ACTIONS(2352),
    [anon_sym___grid_constant__] = ACTIONS(2352),
    [anon_sym_alignas] = ACTIONS(2352),
    [anon_sym__Alignas] = ACTIONS(2352),
    [sym_primitive_type] = ACTIONS(2352),
    [anon_sym_enum] = ACTIONS(2352),
    [anon_sym_class] = ACTIONS(2352),
    [anon_sym_struct] = ACTIONS(2352),
    [anon_sym_union] = ACTIONS(2352),
    [anon_sym_if] = ACTIONS(2352),
    [anon_sym_switch] = ACTIONS(2352),
    [anon_sym_case] = ACTIONS(2352),
    [anon_sym_default] = ACTIONS(2352),
    [anon_sym_while] = ACTIONS(2352),
    [anon_sym_do] = ACTIONS(2352),
    [anon_sym_for] = ACTIONS(2352),
    [anon_sym_return] = ACTIONS(2352),
    [anon_sym_break] = ACTIONS(2352),
    [anon_sym_continue] = ACTIONS(2352),
    [anon_sym_goto] = ACTIONS(2352),
    [anon_sym___try] = ACTIONS(2352),
    [anon_sym___leave] = ACTIONS(2352),
    [anon_sym_not] = ACTIONS(2352),
    [anon_sym_compl] = ACTIONS(2352),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_sizeof] = ACTIONS(2352),
    [anon_sym___alignof__] = ACTIONS(2352),
    [anon_sym___alignof] = ACTIONS(2352),
    [anon_sym__alignof] = ACTIONS(2352),
    [anon_sym_alignof] = ACTIONS(2352),
    [anon_sym__Alignof] = ACTIONS(2352),
    [anon_sym_offsetof] = ACTIONS(2352),
    [anon_sym__Generic] = ACTIONS(2352),
    [anon_sym_asm] = ACTIONS(2352),
    [anon_sym___asm__] = ACTIONS(2352),
    [sym_number_literal] = ACTIONS(2354),
    [anon_sym_L_SQUOTE] = ACTIONS(2354),
    [anon_sym_u_SQUOTE] = ACTIONS(2354),
    [anon_sym_U_SQUOTE] = ACTIONS(2354),
    [anon_sym_u8_SQUOTE] = ACTIONS(2354),
    [anon_sym_SQUOTE] = ACTIONS(2354),
    [anon_sym_L_DQUOTE] = ACTIONS(2354),
    [anon_sym_u_DQUOTE] = ACTIONS(2354),
    [anon_sym_U_DQUOTE] = ACTIONS(2354),
    [anon_sym_u8_DQUOTE] = ACTIONS(2354),
    [anon_sym_DQUOTE] = ACTIONS(2354),
    [sym_true] = ACTIONS(2352),
    [sym_false] = ACTIONS(2352),
    [anon_sym_NULL] = ACTIONS(2352),
    [anon_sym_nullptr] = ACTIONS(2352),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2352),
    [anon_sym_decltype] = ACTIONS(2352),
    [sym_virtual] = ACTIONS(2352),
    [anon_sym_explicit] = ACTIONS(2352),
    [anon_sym_typename] = ACTIONS(2352),
    [anon_sym_template] = ACTIONS(2352),
    [anon_sym_operator] = ACTIONS(2352),
    [anon_sym_try] = ACTIONS(2352),
    [anon_sym_delete] = ACTIONS(2352),
    [anon_sym_throw] = ACTIONS(2352),
    [anon_sym_namespace] = ACTIONS(2352),
    [anon_sym_using] = ACTIONS(2352),
    [anon_sym_static_assert] = ACTIONS(2352),
    [anon_sym_concept] = ACTIONS(2352),
    [anon_sym_co_return] = ACTIONS(2352),
    [anon_sym_co_yield] = ACTIONS(2352),
    [anon_sym_R_DQUOTE] = ACTIONS(2354),
    [anon_sym_LR_DQUOTE] = ACTIONS(2354),
    [anon_sym_uR_DQUOTE] = ACTIONS(2354),
    [anon_sym_UR_DQUOTE] = ACTIONS(2354),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2354),
    [anon_sym_co_await] = ACTIONS(2352),
    [anon_sym_new] = ACTIONS(2352),
    [anon_sym_requires] = ACTIONS(2352),
    [sym_this] = ACTIONS(2352),
    [anon_sym___launch_bounds__] = ACTIONS(2352),
  },
  [548] = {
    [sym_type_qualifier] = STATE(3531),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4591),
    [sym_sized_type_specifier] = STATE(2599),
    [sym_enum_specifier] = STATE(2599),
    [sym_struct_specifier] = STATE(2599),
    [sym_union_specifier] = STATE(2599),
    [sym_expression] = STATE(4640),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_type_descriptor] = STATE(7115),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_placeholder_type_specifier] = STATE(2599),
    [sym_decltype_auto] = STATE(2598),
    [sym_decltype] = STATE(2477),
    [sym_class_specifier] = STATE(2599),
    [sym__class_name] = STATE(8015),
    [sym_dependent_type] = STATE(2599),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_type_parameter_pack_expansion] = STATE(7712),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5910),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [aux_sym__type_definition_type_repeat1] = STATE(3531),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2157),
    [sym_identifier] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2725),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2729),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2733),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2757),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2761),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_GT2] = ACTIONS(2795),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [549] = {
    [sym_identifier] = ACTIONS(2342),
    [aux_sym_preproc_include_token1] = ACTIONS(2342),
    [aux_sym_preproc_def_token1] = ACTIONS(2342),
    [aux_sym_preproc_if_token1] = ACTIONS(2342),
    [aux_sym_preproc_if_token2] = ACTIONS(2342),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2342),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2342),
    [sym_preproc_directive] = ACTIONS(2342),
    [anon_sym_LPAREN2] = ACTIONS(2344),
    [anon_sym_BANG] = ACTIONS(2344),
    [anon_sym_TILDE] = ACTIONS(2344),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2342),
    [anon_sym_SEMI] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2342),
    [anon_sym_typedef] = ACTIONS(2342),
    [anon_sym___device__] = ACTIONS(2342),
    [anon_sym___host__] = ACTIONS(2342),
    [anon_sym___global__] = ACTIONS(2342),
    [anon_sym___forceinline__] = ACTIONS(2342),
    [anon_sym___noinline__] = ACTIONS(2342),
    [anon_sym_extern] = ACTIONS(2342),
    [anon_sym___attribute__] = ACTIONS(2342),
    [anon_sym_COLON_COLON] = ACTIONS(2344),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2344),
    [anon_sym___declspec] = ACTIONS(2342),
    [anon_sym___based] = ACTIONS(2342),
    [anon_sym___cdecl] = ACTIONS(2342),
    [anon_sym___clrcall] = ACTIONS(2342),
    [anon_sym___stdcall] = ACTIONS(2342),
    [anon_sym___fastcall] = ACTIONS(2342),
    [anon_sym___thiscall] = ACTIONS(2342),
    [anon_sym___vectorcall] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2344),
    [anon_sym_signed] = ACTIONS(2342),
    [anon_sym_unsigned] = ACTIONS(2342),
    [anon_sym_long] = ACTIONS(2342),
    [anon_sym_short] = ACTIONS(2342),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_static] = ACTIONS(2342),
    [anon_sym_register] = ACTIONS(2342),
    [anon_sym_inline] = ACTIONS(2342),
    [anon_sym___inline] = ACTIONS(2342),
    [anon_sym___inline__] = ACTIONS(2342),
    [anon_sym___forceinline] = ACTIONS(2342),
    [anon_sym_thread_local] = ACTIONS(2342),
    [anon_sym___thread] = ACTIONS(2342),
    [anon_sym_const] = ACTIONS(2342),
    [anon_sym_constexpr] = ACTIONS(2342),
    [anon_sym_volatile] = ACTIONS(2342),
    [anon_sym_restrict] = ACTIONS(2342),
    [anon_sym___restrict__] = ACTIONS(2342),
    [anon_sym__Atomic] = ACTIONS(2342),
    [anon_sym__Noreturn] = ACTIONS(2342),
    [anon_sym_noreturn] = ACTIONS(2342),
    [anon_sym_mutable] = ACTIONS(2342),
    [anon_sym_constinit] = ACTIONS(2342),
    [anon_sym_consteval] = ACTIONS(2342),
    [anon_sym___shared__] = ACTIONS(2342),
    [anon_sym___local__] = ACTIONS(2342),
    [anon_sym___constant__] = ACTIONS(2342),
    [anon_sym___managed__] = ACTIONS(2342),
    [anon_sym___grid_constant__] = ACTIONS(2342),
    [anon_sym_alignas] = ACTIONS(2342),
    [anon_sym__Alignas] = ACTIONS(2342),
    [sym_primitive_type] = ACTIONS(2342),
    [anon_sym_enum] = ACTIONS(2342),
    [anon_sym_class] = ACTIONS(2342),
    [anon_sym_struct] = ACTIONS(2342),
    [anon_sym_union] = ACTIONS(2342),
    [anon_sym_if] = ACTIONS(2342),
    [anon_sym_switch] = ACTIONS(2342),
    [anon_sym_case] = ACTIONS(2342),
    [anon_sym_default] = ACTIONS(2342),
    [anon_sym_while] = ACTIONS(2342),
    [anon_sym_do] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2342),
    [anon_sym_return] = ACTIONS(2342),
    [anon_sym_break] = ACTIONS(2342),
    [anon_sym_continue] = ACTIONS(2342),
    [anon_sym_goto] = ACTIONS(2342),
    [anon_sym___try] = ACTIONS(2342),
    [anon_sym___leave] = ACTIONS(2342),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2344),
    [anon_sym_PLUS_PLUS] = ACTIONS(2344),
    [anon_sym_sizeof] = ACTIONS(2342),
    [anon_sym___alignof__] = ACTIONS(2342),
    [anon_sym___alignof] = ACTIONS(2342),
    [anon_sym__alignof] = ACTIONS(2342),
    [anon_sym_alignof] = ACTIONS(2342),
    [anon_sym__Alignof] = ACTIONS(2342),
    [anon_sym_offsetof] = ACTIONS(2342),
    [anon_sym__Generic] = ACTIONS(2342),
    [anon_sym_asm] = ACTIONS(2342),
    [anon_sym___asm__] = ACTIONS(2342),
    [sym_number_literal] = ACTIONS(2344),
    [anon_sym_L_SQUOTE] = ACTIONS(2344),
    [anon_sym_u_SQUOTE] = ACTIONS(2344),
    [anon_sym_U_SQUOTE] = ACTIONS(2344),
    [anon_sym_u8_SQUOTE] = ACTIONS(2344),
    [anon_sym_SQUOTE] = ACTIONS(2344),
    [anon_sym_L_DQUOTE] = ACTIONS(2344),
    [anon_sym_u_DQUOTE] = ACTIONS(2344),
    [anon_sym_U_DQUOTE] = ACTIONS(2344),
    [anon_sym_u8_DQUOTE] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [sym_true] = ACTIONS(2342),
    [sym_false] = ACTIONS(2342),
    [anon_sym_NULL] = ACTIONS(2342),
    [anon_sym_nullptr] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2342),
    [anon_sym_decltype] = ACTIONS(2342),
    [sym_virtual] = ACTIONS(2342),
    [anon_sym_explicit] = ACTIONS(2342),
    [anon_sym_typename] = ACTIONS(2342),
    [anon_sym_template] = ACTIONS(2342),
    [anon_sym_operator] = ACTIONS(2342),
    [anon_sym_try] = ACTIONS(2342),
    [anon_sym_delete] = ACTIONS(2342),
    [anon_sym_throw] = ACTIONS(2342),
    [anon_sym_namespace] = ACTIONS(2342),
    [anon_sym_using] = ACTIONS(2342),
    [anon_sym_static_assert] = ACTIONS(2342),
    [anon_sym_concept] = ACTIONS(2342),
    [anon_sym_co_return] = ACTIONS(2342),
    [anon_sym_co_yield] = ACTIONS(2342),
    [anon_sym_R_DQUOTE] = ACTIONS(2344),
    [anon_sym_LR_DQUOTE] = ACTIONS(2344),
    [anon_sym_uR_DQUOTE] = ACTIONS(2344),
    [anon_sym_UR_DQUOTE] = ACTIONS(2344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2344),
    [anon_sym_co_await] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2342),
    [anon_sym_requires] = ACTIONS(2342),
    [sym_this] = ACTIONS(2342),
    [anon_sym___launch_bounds__] = ACTIONS(2342),
  },
  [550] = {
    [sym_identifier] = ACTIONS(2090),
    [aux_sym_preproc_include_token1] = ACTIONS(2090),
    [aux_sym_preproc_def_token1] = ACTIONS(2090),
    [aux_sym_preproc_if_token1] = ACTIONS(2090),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2090),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2090),
    [sym_preproc_directive] = ACTIONS(2090),
    [anon_sym_LPAREN2] = ACTIONS(2092),
    [anon_sym_BANG] = ACTIONS(2092),
    [anon_sym_TILDE] = ACTIONS(2092),
    [anon_sym_DASH] = ACTIONS(2090),
    [anon_sym_PLUS] = ACTIONS(2090),
    [anon_sym_STAR] = ACTIONS(2092),
    [anon_sym_AMP_AMP] = ACTIONS(2092),
    [anon_sym_AMP] = ACTIONS(2090),
    [anon_sym_SEMI] = ACTIONS(2092),
    [anon_sym___extension__] = ACTIONS(2090),
    [anon_sym_typedef] = ACTIONS(2090),
    [anon_sym___device__] = ACTIONS(2090),
    [anon_sym___host__] = ACTIONS(2090),
    [anon_sym___global__] = ACTIONS(2090),
    [anon_sym___forceinline__] = ACTIONS(2090),
    [anon_sym___noinline__] = ACTIONS(2090),
    [anon_sym_extern] = ACTIONS(2090),
    [anon_sym___attribute__] = ACTIONS(2090),
    [anon_sym_COLON_COLON] = ACTIONS(2092),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2092),
    [anon_sym___declspec] = ACTIONS(2090),
    [anon_sym___based] = ACTIONS(2090),
    [anon_sym___cdecl] = ACTIONS(2090),
    [anon_sym___clrcall] = ACTIONS(2090),
    [anon_sym___stdcall] = ACTIONS(2090),
    [anon_sym___fastcall] = ACTIONS(2090),
    [anon_sym___thiscall] = ACTIONS(2090),
    [anon_sym___vectorcall] = ACTIONS(2090),
    [anon_sym_LBRACE] = ACTIONS(2092),
    [anon_sym_RBRACE] = ACTIONS(2092),
    [anon_sym_signed] = ACTIONS(2090),
    [anon_sym_unsigned] = ACTIONS(2090),
    [anon_sym_long] = ACTIONS(2090),
    [anon_sym_short] = ACTIONS(2090),
    [anon_sym_LBRACK] = ACTIONS(2090),
    [anon_sym_static] = ACTIONS(2090),
    [anon_sym_register] = ACTIONS(2090),
    [anon_sym_inline] = ACTIONS(2090),
    [anon_sym___inline] = ACTIONS(2090),
    [anon_sym___inline__] = ACTIONS(2090),
    [anon_sym___forceinline] = ACTIONS(2090),
    [anon_sym_thread_local] = ACTIONS(2090),
    [anon_sym___thread] = ACTIONS(2090),
    [anon_sym_const] = ACTIONS(2090),
    [anon_sym_constexpr] = ACTIONS(2090),
    [anon_sym_volatile] = ACTIONS(2090),
    [anon_sym_restrict] = ACTIONS(2090),
    [anon_sym___restrict__] = ACTIONS(2090),
    [anon_sym__Atomic] = ACTIONS(2090),
    [anon_sym__Noreturn] = ACTIONS(2090),
    [anon_sym_noreturn] = ACTIONS(2090),
    [anon_sym_mutable] = ACTIONS(2090),
    [anon_sym_constinit] = ACTIONS(2090),
    [anon_sym_consteval] = ACTIONS(2090),
    [anon_sym___shared__] = ACTIONS(2090),
    [anon_sym___local__] = ACTIONS(2090),
    [anon_sym___constant__] = ACTIONS(2090),
    [anon_sym___managed__] = ACTIONS(2090),
    [anon_sym___grid_constant__] = ACTIONS(2090),
    [anon_sym_alignas] = ACTIONS(2090),
    [anon_sym__Alignas] = ACTIONS(2090),
    [sym_primitive_type] = ACTIONS(2090),
    [anon_sym_enum] = ACTIONS(2090),
    [anon_sym_class] = ACTIONS(2090),
    [anon_sym_struct] = ACTIONS(2090),
    [anon_sym_union] = ACTIONS(2090),
    [anon_sym_if] = ACTIONS(2090),
    [anon_sym_switch] = ACTIONS(2090),
    [anon_sym_case] = ACTIONS(2090),
    [anon_sym_default] = ACTIONS(2090),
    [anon_sym_while] = ACTIONS(2090),
    [anon_sym_do] = ACTIONS(2090),
    [anon_sym_for] = ACTIONS(2090),
    [anon_sym_return] = ACTIONS(2090),
    [anon_sym_break] = ACTIONS(2090),
    [anon_sym_continue] = ACTIONS(2090),
    [anon_sym_goto] = ACTIONS(2090),
    [anon_sym___try] = ACTIONS(2090),
    [anon_sym___leave] = ACTIONS(2090),
    [anon_sym_not] = ACTIONS(2090),
    [anon_sym_compl] = ACTIONS(2090),
    [anon_sym_DASH_DASH] = ACTIONS(2092),
    [anon_sym_PLUS_PLUS] = ACTIONS(2092),
    [anon_sym_sizeof] = ACTIONS(2090),
    [anon_sym___alignof__] = ACTIONS(2090),
    [anon_sym___alignof] = ACTIONS(2090),
    [anon_sym__alignof] = ACTIONS(2090),
    [anon_sym_alignof] = ACTIONS(2090),
    [anon_sym__Alignof] = ACTIONS(2090),
    [anon_sym_offsetof] = ACTIONS(2090),
    [anon_sym__Generic] = ACTIONS(2090),
    [anon_sym_asm] = ACTIONS(2090),
    [anon_sym___asm__] = ACTIONS(2090),
    [sym_number_literal] = ACTIONS(2092),
    [anon_sym_L_SQUOTE] = ACTIONS(2092),
    [anon_sym_u_SQUOTE] = ACTIONS(2092),
    [anon_sym_U_SQUOTE] = ACTIONS(2092),
    [anon_sym_u8_SQUOTE] = ACTIONS(2092),
    [anon_sym_SQUOTE] = ACTIONS(2092),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2090),
    [sym_false] = ACTIONS(2090),
    [anon_sym_NULL] = ACTIONS(2090),
    [anon_sym_nullptr] = ACTIONS(2090),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2090),
    [anon_sym_decltype] = ACTIONS(2090),
    [sym_virtual] = ACTIONS(2090),
    [anon_sym_explicit] = ACTIONS(2090),
    [anon_sym_typename] = ACTIONS(2090),
    [anon_sym_template] = ACTIONS(2090),
    [anon_sym_operator] = ACTIONS(2090),
    [anon_sym_try] = ACTIONS(2090),
    [anon_sym_delete] = ACTIONS(2090),
    [anon_sym_throw] = ACTIONS(2090),
    [anon_sym_namespace] = ACTIONS(2090),
    [anon_sym_using] = ACTIONS(2090),
    [anon_sym_static_assert] = ACTIONS(2090),
    [anon_sym_concept] = ACTIONS(2090),
    [anon_sym_co_return] = ACTIONS(2090),
    [anon_sym_co_yield] = ACTIONS(2090),
    [anon_sym_R_DQUOTE] = ACTIONS(2092),
    [anon_sym_LR_DQUOTE] = ACTIONS(2092),
    [anon_sym_uR_DQUOTE] = ACTIONS(2092),
    [anon_sym_UR_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2092),
    [anon_sym_co_await] = ACTIONS(2090),
    [anon_sym_new] = ACTIONS(2090),
    [anon_sym_requires] = ACTIONS(2090),
    [sym_this] = ACTIONS(2090),
    [anon_sym___launch_bounds__] = ACTIONS(2090),
  },
  [551] = {
    [sym_identifier] = ACTIONS(2457),
    [aux_sym_preproc_include_token1] = ACTIONS(2457),
    [aux_sym_preproc_def_token1] = ACTIONS(2457),
    [aux_sym_preproc_if_token1] = ACTIONS(2457),
    [aux_sym_preproc_if_token2] = ACTIONS(2457),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2457),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2457),
    [sym_preproc_directive] = ACTIONS(2457),
    [anon_sym_LPAREN2] = ACTIONS(2459),
    [anon_sym_BANG] = ACTIONS(2459),
    [anon_sym_TILDE] = ACTIONS(2459),
    [anon_sym_DASH] = ACTIONS(2457),
    [anon_sym_PLUS] = ACTIONS(2457),
    [anon_sym_STAR] = ACTIONS(2459),
    [anon_sym_AMP_AMP] = ACTIONS(2459),
    [anon_sym_AMP] = ACTIONS(2457),
    [anon_sym_SEMI] = ACTIONS(2459),
    [anon_sym___extension__] = ACTIONS(2457),
    [anon_sym_typedef] = ACTIONS(2457),
    [anon_sym___device__] = ACTIONS(2457),
    [anon_sym___host__] = ACTIONS(2457),
    [anon_sym___global__] = ACTIONS(2457),
    [anon_sym___forceinline__] = ACTIONS(2457),
    [anon_sym___noinline__] = ACTIONS(2457),
    [anon_sym_extern] = ACTIONS(2457),
    [anon_sym___attribute__] = ACTIONS(2457),
    [anon_sym_COLON_COLON] = ACTIONS(2459),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2459),
    [anon_sym___declspec] = ACTIONS(2457),
    [anon_sym___based] = ACTIONS(2457),
    [anon_sym___cdecl] = ACTIONS(2457),
    [anon_sym___clrcall] = ACTIONS(2457),
    [anon_sym___stdcall] = ACTIONS(2457),
    [anon_sym___fastcall] = ACTIONS(2457),
    [anon_sym___thiscall] = ACTIONS(2457),
    [anon_sym___vectorcall] = ACTIONS(2457),
    [anon_sym_LBRACE] = ACTIONS(2459),
    [anon_sym_signed] = ACTIONS(2457),
    [anon_sym_unsigned] = ACTIONS(2457),
    [anon_sym_long] = ACTIONS(2457),
    [anon_sym_short] = ACTIONS(2457),
    [anon_sym_LBRACK] = ACTIONS(2457),
    [anon_sym_static] = ACTIONS(2457),
    [anon_sym_register] = ACTIONS(2457),
    [anon_sym_inline] = ACTIONS(2457),
    [anon_sym___inline] = ACTIONS(2457),
    [anon_sym___inline__] = ACTIONS(2457),
    [anon_sym___forceinline] = ACTIONS(2457),
    [anon_sym_thread_local] = ACTIONS(2457),
    [anon_sym___thread] = ACTIONS(2457),
    [anon_sym_const] = ACTIONS(2457),
    [anon_sym_constexpr] = ACTIONS(2457),
    [anon_sym_volatile] = ACTIONS(2457),
    [anon_sym_restrict] = ACTIONS(2457),
    [anon_sym___restrict__] = ACTIONS(2457),
    [anon_sym__Atomic] = ACTIONS(2457),
    [anon_sym__Noreturn] = ACTIONS(2457),
    [anon_sym_noreturn] = ACTIONS(2457),
    [anon_sym_mutable] = ACTIONS(2457),
    [anon_sym_constinit] = ACTIONS(2457),
    [anon_sym_consteval] = ACTIONS(2457),
    [anon_sym___shared__] = ACTIONS(2457),
    [anon_sym___local__] = ACTIONS(2457),
    [anon_sym___constant__] = ACTIONS(2457),
    [anon_sym___managed__] = ACTIONS(2457),
    [anon_sym___grid_constant__] = ACTIONS(2457),
    [anon_sym_alignas] = ACTIONS(2457),
    [anon_sym__Alignas] = ACTIONS(2457),
    [sym_primitive_type] = ACTIONS(2457),
    [anon_sym_enum] = ACTIONS(2457),
    [anon_sym_class] = ACTIONS(2457),
    [anon_sym_struct] = ACTIONS(2457),
    [anon_sym_union] = ACTIONS(2457),
    [anon_sym_if] = ACTIONS(2457),
    [anon_sym_switch] = ACTIONS(2457),
    [anon_sym_case] = ACTIONS(2457),
    [anon_sym_default] = ACTIONS(2457),
    [anon_sym_while] = ACTIONS(2457),
    [anon_sym_do] = ACTIONS(2457),
    [anon_sym_for] = ACTIONS(2457),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_break] = ACTIONS(2457),
    [anon_sym_continue] = ACTIONS(2457),
    [anon_sym_goto] = ACTIONS(2457),
    [anon_sym___try] = ACTIONS(2457),
    [anon_sym___leave] = ACTIONS(2457),
    [anon_sym_not] = ACTIONS(2457),
    [anon_sym_compl] = ACTIONS(2457),
    [anon_sym_DASH_DASH] = ACTIONS(2459),
    [anon_sym_PLUS_PLUS] = ACTIONS(2459),
    [anon_sym_sizeof] = ACTIONS(2457),
    [anon_sym___alignof__] = ACTIONS(2457),
    [anon_sym___alignof] = ACTIONS(2457),
    [anon_sym__alignof] = ACTIONS(2457),
    [anon_sym_alignof] = ACTIONS(2457),
    [anon_sym__Alignof] = ACTIONS(2457),
    [anon_sym_offsetof] = ACTIONS(2457),
    [anon_sym__Generic] = ACTIONS(2457),
    [anon_sym_asm] = ACTIONS(2457),
    [anon_sym___asm__] = ACTIONS(2457),
    [sym_number_literal] = ACTIONS(2459),
    [anon_sym_L_SQUOTE] = ACTIONS(2459),
    [anon_sym_u_SQUOTE] = ACTIONS(2459),
    [anon_sym_U_SQUOTE] = ACTIONS(2459),
    [anon_sym_u8_SQUOTE] = ACTIONS(2459),
    [anon_sym_SQUOTE] = ACTIONS(2459),
    [anon_sym_L_DQUOTE] = ACTIONS(2459),
    [anon_sym_u_DQUOTE] = ACTIONS(2459),
    [anon_sym_U_DQUOTE] = ACTIONS(2459),
    [anon_sym_u8_DQUOTE] = ACTIONS(2459),
    [anon_sym_DQUOTE] = ACTIONS(2459),
    [sym_true] = ACTIONS(2457),
    [sym_false] = ACTIONS(2457),
    [anon_sym_NULL] = ACTIONS(2457),
    [anon_sym_nullptr] = ACTIONS(2457),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2457),
    [anon_sym_decltype] = ACTIONS(2457),
    [sym_virtual] = ACTIONS(2457),
    [anon_sym_explicit] = ACTIONS(2457),
    [anon_sym_typename] = ACTIONS(2457),
    [anon_sym_template] = ACTIONS(2457),
    [anon_sym_operator] = ACTIONS(2457),
    [anon_sym_try] = ACTIONS(2457),
    [anon_sym_delete] = ACTIONS(2457),
    [anon_sym_throw] = ACTIONS(2457),
    [anon_sym_namespace] = ACTIONS(2457),
    [anon_sym_using] = ACTIONS(2457),
    [anon_sym_static_assert] = ACTIONS(2457),
    [anon_sym_concept] = ACTIONS(2457),
    [anon_sym_co_return] = ACTIONS(2457),
    [anon_sym_co_yield] = ACTIONS(2457),
    [anon_sym_R_DQUOTE] = ACTIONS(2459),
    [anon_sym_LR_DQUOTE] = ACTIONS(2459),
    [anon_sym_uR_DQUOTE] = ACTIONS(2459),
    [anon_sym_UR_DQUOTE] = ACTIONS(2459),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2459),
    [anon_sym_co_await] = ACTIONS(2457),
    [anon_sym_new] = ACTIONS(2457),
    [anon_sym_requires] = ACTIONS(2457),
    [sym_this] = ACTIONS(2457),
    [anon_sym___launch_bounds__] = ACTIONS(2457),
  },
  [552] = {
    [sym_identifier] = ACTIONS(2356),
    [aux_sym_preproc_include_token1] = ACTIONS(2356),
    [aux_sym_preproc_def_token1] = ACTIONS(2356),
    [aux_sym_preproc_if_token1] = ACTIONS(2356),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2356),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2356),
    [sym_preproc_directive] = ACTIONS(2356),
    [anon_sym_LPAREN2] = ACTIONS(2358),
    [anon_sym_BANG] = ACTIONS(2358),
    [anon_sym_TILDE] = ACTIONS(2358),
    [anon_sym_DASH] = ACTIONS(2356),
    [anon_sym_PLUS] = ACTIONS(2356),
    [anon_sym_STAR] = ACTIONS(2358),
    [anon_sym_AMP_AMP] = ACTIONS(2358),
    [anon_sym_AMP] = ACTIONS(2356),
    [anon_sym_SEMI] = ACTIONS(2358),
    [anon_sym___extension__] = ACTIONS(2356),
    [anon_sym_typedef] = ACTIONS(2356),
    [anon_sym___device__] = ACTIONS(2356),
    [anon_sym___host__] = ACTIONS(2356),
    [anon_sym___global__] = ACTIONS(2356),
    [anon_sym___forceinline__] = ACTIONS(2356),
    [anon_sym___noinline__] = ACTIONS(2356),
    [anon_sym_extern] = ACTIONS(2356),
    [anon_sym___attribute__] = ACTIONS(2356),
    [anon_sym_COLON_COLON] = ACTIONS(2358),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2358),
    [anon_sym___declspec] = ACTIONS(2356),
    [anon_sym___based] = ACTIONS(2356),
    [anon_sym___cdecl] = ACTIONS(2356),
    [anon_sym___clrcall] = ACTIONS(2356),
    [anon_sym___stdcall] = ACTIONS(2356),
    [anon_sym___fastcall] = ACTIONS(2356),
    [anon_sym___thiscall] = ACTIONS(2356),
    [anon_sym___vectorcall] = ACTIONS(2356),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_RBRACE] = ACTIONS(2358),
    [anon_sym_signed] = ACTIONS(2356),
    [anon_sym_unsigned] = ACTIONS(2356),
    [anon_sym_long] = ACTIONS(2356),
    [anon_sym_short] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2356),
    [anon_sym_register] = ACTIONS(2356),
    [anon_sym_inline] = ACTIONS(2356),
    [anon_sym___inline] = ACTIONS(2356),
    [anon_sym___inline__] = ACTIONS(2356),
    [anon_sym___forceinline] = ACTIONS(2356),
    [anon_sym_thread_local] = ACTIONS(2356),
    [anon_sym___thread] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(2356),
    [anon_sym_constexpr] = ACTIONS(2356),
    [anon_sym_volatile] = ACTIONS(2356),
    [anon_sym_restrict] = ACTIONS(2356),
    [anon_sym___restrict__] = ACTIONS(2356),
    [anon_sym__Atomic] = ACTIONS(2356),
    [anon_sym__Noreturn] = ACTIONS(2356),
    [anon_sym_noreturn] = ACTIONS(2356),
    [anon_sym_mutable] = ACTIONS(2356),
    [anon_sym_constinit] = ACTIONS(2356),
    [anon_sym_consteval] = ACTIONS(2356),
    [anon_sym___shared__] = ACTIONS(2356),
    [anon_sym___local__] = ACTIONS(2356),
    [anon_sym___constant__] = ACTIONS(2356),
    [anon_sym___managed__] = ACTIONS(2356),
    [anon_sym___grid_constant__] = ACTIONS(2356),
    [anon_sym_alignas] = ACTIONS(2356),
    [anon_sym__Alignas] = ACTIONS(2356),
    [sym_primitive_type] = ACTIONS(2356),
    [anon_sym_enum] = ACTIONS(2356),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_struct] = ACTIONS(2356),
    [anon_sym_union] = ACTIONS(2356),
    [anon_sym_if] = ACTIONS(2356),
    [anon_sym_switch] = ACTIONS(2356),
    [anon_sym_case] = ACTIONS(2356),
    [anon_sym_default] = ACTIONS(2356),
    [anon_sym_while] = ACTIONS(2356),
    [anon_sym_do] = ACTIONS(2356),
    [anon_sym_for] = ACTIONS(2356),
    [anon_sym_return] = ACTIONS(2356),
    [anon_sym_break] = ACTIONS(2356),
    [anon_sym_continue] = ACTIONS(2356),
    [anon_sym_goto] = ACTIONS(2356),
    [anon_sym___try] = ACTIONS(2356),
    [anon_sym___leave] = ACTIONS(2356),
    [anon_sym_not] = ACTIONS(2356),
    [anon_sym_compl] = ACTIONS(2356),
    [anon_sym_DASH_DASH] = ACTIONS(2358),
    [anon_sym_PLUS_PLUS] = ACTIONS(2358),
    [anon_sym_sizeof] = ACTIONS(2356),
    [anon_sym___alignof__] = ACTIONS(2356),
    [anon_sym___alignof] = ACTIONS(2356),
    [anon_sym__alignof] = ACTIONS(2356),
    [anon_sym_alignof] = ACTIONS(2356),
    [anon_sym__Alignof] = ACTIONS(2356),
    [anon_sym_offsetof] = ACTIONS(2356),
    [anon_sym__Generic] = ACTIONS(2356),
    [anon_sym_asm] = ACTIONS(2356),
    [anon_sym___asm__] = ACTIONS(2356),
    [sym_number_literal] = ACTIONS(2358),
    [anon_sym_L_SQUOTE] = ACTIONS(2358),
    [anon_sym_u_SQUOTE] = ACTIONS(2358),
    [anon_sym_U_SQUOTE] = ACTIONS(2358),
    [anon_sym_u8_SQUOTE] = ACTIONS(2358),
    [anon_sym_SQUOTE] = ACTIONS(2358),
    [anon_sym_L_DQUOTE] = ACTIONS(2358),
    [anon_sym_u_DQUOTE] = ACTIONS(2358),
    [anon_sym_U_DQUOTE] = ACTIONS(2358),
    [anon_sym_u8_DQUOTE] = ACTIONS(2358),
    [anon_sym_DQUOTE] = ACTIONS(2358),
    [sym_true] = ACTIONS(2356),
    [sym_false] = ACTIONS(2356),
    [anon_sym_NULL] = ACTIONS(2356),
    [anon_sym_nullptr] = ACTIONS(2356),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2356),
    [anon_sym_decltype] = ACTIONS(2356),
    [sym_virtual] = ACTIONS(2356),
    [anon_sym_explicit] = ACTIONS(2356),
    [anon_sym_typename] = ACTIONS(2356),
    [anon_sym_template] = ACTIONS(2356),
    [anon_sym_operator] = ACTIONS(2356),
    [anon_sym_try] = ACTIONS(2356),
    [anon_sym_delete] = ACTIONS(2356),
    [anon_sym_throw] = ACTIONS(2356),
    [anon_sym_namespace] = ACTIONS(2356),
    [anon_sym_using] = ACTIONS(2356),
    [anon_sym_static_assert] = ACTIONS(2356),
    [anon_sym_concept] = ACTIONS(2356),
    [anon_sym_co_return] = ACTIONS(2356),
    [anon_sym_co_yield] = ACTIONS(2356),
    [anon_sym_R_DQUOTE] = ACTIONS(2358),
    [anon_sym_LR_DQUOTE] = ACTIONS(2358),
    [anon_sym_uR_DQUOTE] = ACTIONS(2358),
    [anon_sym_UR_DQUOTE] = ACTIONS(2358),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2358),
    [anon_sym_co_await] = ACTIONS(2356),
    [anon_sym_new] = ACTIONS(2356),
    [anon_sym_requires] = ACTIONS(2356),
    [sym_this] = ACTIONS(2356),
    [anon_sym___launch_bounds__] = ACTIONS(2356),
  },
  [553] = {
    [sym_identifier] = ACTIONS(2362),
    [aux_sym_preproc_include_token1] = ACTIONS(2362),
    [aux_sym_preproc_def_token1] = ACTIONS(2362),
    [aux_sym_preproc_if_token1] = ACTIONS(2362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2362),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2362),
    [sym_preproc_directive] = ACTIONS(2362),
    [anon_sym_LPAREN2] = ACTIONS(2364),
    [anon_sym_BANG] = ACTIONS(2364),
    [anon_sym_TILDE] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2362),
    [anon_sym_PLUS] = ACTIONS(2362),
    [anon_sym_STAR] = ACTIONS(2364),
    [anon_sym_AMP_AMP] = ACTIONS(2364),
    [anon_sym_AMP] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym___extension__] = ACTIONS(2362),
    [anon_sym_typedef] = ACTIONS(2362),
    [anon_sym___device__] = ACTIONS(2362),
    [anon_sym___host__] = ACTIONS(2362),
    [anon_sym___global__] = ACTIONS(2362),
    [anon_sym___forceinline__] = ACTIONS(2362),
    [anon_sym___noinline__] = ACTIONS(2362),
    [anon_sym_extern] = ACTIONS(2362),
    [anon_sym___attribute__] = ACTIONS(2362),
    [anon_sym_COLON_COLON] = ACTIONS(2364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2364),
    [anon_sym___declspec] = ACTIONS(2362),
    [anon_sym___based] = ACTIONS(2362),
    [anon_sym___cdecl] = ACTIONS(2362),
    [anon_sym___clrcall] = ACTIONS(2362),
    [anon_sym___stdcall] = ACTIONS(2362),
    [anon_sym___fastcall] = ACTIONS(2362),
    [anon_sym___thiscall] = ACTIONS(2362),
    [anon_sym___vectorcall] = ACTIONS(2362),
    [anon_sym_LBRACE] = ACTIONS(2364),
    [anon_sym_RBRACE] = ACTIONS(2364),
    [anon_sym_signed] = ACTIONS(2362),
    [anon_sym_unsigned] = ACTIONS(2362),
    [anon_sym_long] = ACTIONS(2362),
    [anon_sym_short] = ACTIONS(2362),
    [anon_sym_LBRACK] = ACTIONS(2362),
    [anon_sym_static] = ACTIONS(2362),
    [anon_sym_register] = ACTIONS(2362),
    [anon_sym_inline] = ACTIONS(2362),
    [anon_sym___inline] = ACTIONS(2362),
    [anon_sym___inline__] = ACTIONS(2362),
    [anon_sym___forceinline] = ACTIONS(2362),
    [anon_sym_thread_local] = ACTIONS(2362),
    [anon_sym___thread] = ACTIONS(2362),
    [anon_sym_const] = ACTIONS(2362),
    [anon_sym_constexpr] = ACTIONS(2362),
    [anon_sym_volatile] = ACTIONS(2362),
    [anon_sym_restrict] = ACTIONS(2362),
    [anon_sym___restrict__] = ACTIONS(2362),
    [anon_sym__Atomic] = ACTIONS(2362),
    [anon_sym__Noreturn] = ACTIONS(2362),
    [anon_sym_noreturn] = ACTIONS(2362),
    [anon_sym_mutable] = ACTIONS(2362),
    [anon_sym_constinit] = ACTIONS(2362),
    [anon_sym_consteval] = ACTIONS(2362),
    [anon_sym___shared__] = ACTIONS(2362),
    [anon_sym___local__] = ACTIONS(2362),
    [anon_sym___constant__] = ACTIONS(2362),
    [anon_sym___managed__] = ACTIONS(2362),
    [anon_sym___grid_constant__] = ACTIONS(2362),
    [anon_sym_alignas] = ACTIONS(2362),
    [anon_sym__Alignas] = ACTIONS(2362),
    [sym_primitive_type] = ACTIONS(2362),
    [anon_sym_enum] = ACTIONS(2362),
    [anon_sym_class] = ACTIONS(2362),
    [anon_sym_struct] = ACTIONS(2362),
    [anon_sym_union] = ACTIONS(2362),
    [anon_sym_if] = ACTIONS(2362),
    [anon_sym_switch] = ACTIONS(2362),
    [anon_sym_case] = ACTIONS(2362),
    [anon_sym_default] = ACTIONS(2362),
    [anon_sym_while] = ACTIONS(2362),
    [anon_sym_do] = ACTIONS(2362),
    [anon_sym_for] = ACTIONS(2362),
    [anon_sym_return] = ACTIONS(2362),
    [anon_sym_break] = ACTIONS(2362),
    [anon_sym_continue] = ACTIONS(2362),
    [anon_sym_goto] = ACTIONS(2362),
    [anon_sym___try] = ACTIONS(2362),
    [anon_sym___leave] = ACTIONS(2362),
    [anon_sym_not] = ACTIONS(2362),
    [anon_sym_compl] = ACTIONS(2362),
    [anon_sym_DASH_DASH] = ACTIONS(2364),
    [anon_sym_PLUS_PLUS] = ACTIONS(2364),
    [anon_sym_sizeof] = ACTIONS(2362),
    [anon_sym___alignof__] = ACTIONS(2362),
    [anon_sym___alignof] = ACTIONS(2362),
    [anon_sym__alignof] = ACTIONS(2362),
    [anon_sym_alignof] = ACTIONS(2362),
    [anon_sym__Alignof] = ACTIONS(2362),
    [anon_sym_offsetof] = ACTIONS(2362),
    [anon_sym__Generic] = ACTIONS(2362),
    [anon_sym_asm] = ACTIONS(2362),
    [anon_sym___asm__] = ACTIONS(2362),
    [sym_number_literal] = ACTIONS(2364),
    [anon_sym_L_SQUOTE] = ACTIONS(2364),
    [anon_sym_u_SQUOTE] = ACTIONS(2364),
    [anon_sym_U_SQUOTE] = ACTIONS(2364),
    [anon_sym_u8_SQUOTE] = ACTIONS(2364),
    [anon_sym_SQUOTE] = ACTIONS(2364),
    [anon_sym_L_DQUOTE] = ACTIONS(2364),
    [anon_sym_u_DQUOTE] = ACTIONS(2364),
    [anon_sym_U_DQUOTE] = ACTIONS(2364),
    [anon_sym_u8_DQUOTE] = ACTIONS(2364),
    [anon_sym_DQUOTE] = ACTIONS(2364),
    [sym_true] = ACTIONS(2362),
    [sym_false] = ACTIONS(2362),
    [anon_sym_NULL] = ACTIONS(2362),
    [anon_sym_nullptr] = ACTIONS(2362),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2362),
    [anon_sym_decltype] = ACTIONS(2362),
    [sym_virtual] = ACTIONS(2362),
    [anon_sym_explicit] = ACTIONS(2362),
    [anon_sym_typename] = ACTIONS(2362),
    [anon_sym_template] = ACTIONS(2362),
    [anon_sym_operator] = ACTIONS(2362),
    [anon_sym_try] = ACTIONS(2362),
    [anon_sym_delete] = ACTIONS(2362),
    [anon_sym_throw] = ACTIONS(2362),
    [anon_sym_namespace] = ACTIONS(2362),
    [anon_sym_using] = ACTIONS(2362),
    [anon_sym_static_assert] = ACTIONS(2362),
    [anon_sym_concept] = ACTIONS(2362),
    [anon_sym_co_return] = ACTIONS(2362),
    [anon_sym_co_yield] = ACTIONS(2362),
    [anon_sym_R_DQUOTE] = ACTIONS(2364),
    [anon_sym_LR_DQUOTE] = ACTIONS(2364),
    [anon_sym_uR_DQUOTE] = ACTIONS(2364),
    [anon_sym_UR_DQUOTE] = ACTIONS(2364),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2364),
    [anon_sym_co_await] = ACTIONS(2362),
    [anon_sym_new] = ACTIONS(2362),
    [anon_sym_requires] = ACTIONS(2362),
    [sym_this] = ACTIONS(2362),
    [anon_sym___launch_bounds__] = ACTIONS(2362),
  },
  [554] = {
    [sym_identifier] = ACTIONS(2366),
    [aux_sym_preproc_include_token1] = ACTIONS(2366),
    [aux_sym_preproc_def_token1] = ACTIONS(2366),
    [aux_sym_preproc_if_token1] = ACTIONS(2366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2366),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2366),
    [sym_preproc_directive] = ACTIONS(2366),
    [anon_sym_LPAREN2] = ACTIONS(2368),
    [anon_sym_BANG] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(2368),
    [anon_sym_DASH] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(2366),
    [anon_sym_STAR] = ACTIONS(2368),
    [anon_sym_AMP_AMP] = ACTIONS(2368),
    [anon_sym_AMP] = ACTIONS(2366),
    [anon_sym_SEMI] = ACTIONS(2368),
    [anon_sym___extension__] = ACTIONS(2366),
    [anon_sym_typedef] = ACTIONS(2366),
    [anon_sym___device__] = ACTIONS(2366),
    [anon_sym___host__] = ACTIONS(2366),
    [anon_sym___global__] = ACTIONS(2366),
    [anon_sym___forceinline__] = ACTIONS(2366),
    [anon_sym___noinline__] = ACTIONS(2366),
    [anon_sym_extern] = ACTIONS(2366),
    [anon_sym___attribute__] = ACTIONS(2366),
    [anon_sym_COLON_COLON] = ACTIONS(2368),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2368),
    [anon_sym___declspec] = ACTIONS(2366),
    [anon_sym___based] = ACTIONS(2366),
    [anon_sym___cdecl] = ACTIONS(2366),
    [anon_sym___clrcall] = ACTIONS(2366),
    [anon_sym___stdcall] = ACTIONS(2366),
    [anon_sym___fastcall] = ACTIONS(2366),
    [anon_sym___thiscall] = ACTIONS(2366),
    [anon_sym___vectorcall] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(2368),
    [anon_sym_RBRACE] = ACTIONS(2368),
    [anon_sym_signed] = ACTIONS(2366),
    [anon_sym_unsigned] = ACTIONS(2366),
    [anon_sym_long] = ACTIONS(2366),
    [anon_sym_short] = ACTIONS(2366),
    [anon_sym_LBRACK] = ACTIONS(2366),
    [anon_sym_static] = ACTIONS(2366),
    [anon_sym_register] = ACTIONS(2366),
    [anon_sym_inline] = ACTIONS(2366),
    [anon_sym___inline] = ACTIONS(2366),
    [anon_sym___inline__] = ACTIONS(2366),
    [anon_sym___forceinline] = ACTIONS(2366),
    [anon_sym_thread_local] = ACTIONS(2366),
    [anon_sym___thread] = ACTIONS(2366),
    [anon_sym_const] = ACTIONS(2366),
    [anon_sym_constexpr] = ACTIONS(2366),
    [anon_sym_volatile] = ACTIONS(2366),
    [anon_sym_restrict] = ACTIONS(2366),
    [anon_sym___restrict__] = ACTIONS(2366),
    [anon_sym__Atomic] = ACTIONS(2366),
    [anon_sym__Noreturn] = ACTIONS(2366),
    [anon_sym_noreturn] = ACTIONS(2366),
    [anon_sym_mutable] = ACTIONS(2366),
    [anon_sym_constinit] = ACTIONS(2366),
    [anon_sym_consteval] = ACTIONS(2366),
    [anon_sym___shared__] = ACTIONS(2366),
    [anon_sym___local__] = ACTIONS(2366),
    [anon_sym___constant__] = ACTIONS(2366),
    [anon_sym___managed__] = ACTIONS(2366),
    [anon_sym___grid_constant__] = ACTIONS(2366),
    [anon_sym_alignas] = ACTIONS(2366),
    [anon_sym__Alignas] = ACTIONS(2366),
    [sym_primitive_type] = ACTIONS(2366),
    [anon_sym_enum] = ACTIONS(2366),
    [anon_sym_class] = ACTIONS(2366),
    [anon_sym_struct] = ACTIONS(2366),
    [anon_sym_union] = ACTIONS(2366),
    [anon_sym_if] = ACTIONS(2366),
    [anon_sym_switch] = ACTIONS(2366),
    [anon_sym_case] = ACTIONS(2366),
    [anon_sym_default] = ACTIONS(2366),
    [anon_sym_while] = ACTIONS(2366),
    [anon_sym_do] = ACTIONS(2366),
    [anon_sym_for] = ACTIONS(2366),
    [anon_sym_return] = ACTIONS(2366),
    [anon_sym_break] = ACTIONS(2366),
    [anon_sym_continue] = ACTIONS(2366),
    [anon_sym_goto] = ACTIONS(2366),
    [anon_sym___try] = ACTIONS(2366),
    [anon_sym___leave] = ACTIONS(2366),
    [anon_sym_not] = ACTIONS(2366),
    [anon_sym_compl] = ACTIONS(2366),
    [anon_sym_DASH_DASH] = ACTIONS(2368),
    [anon_sym_PLUS_PLUS] = ACTIONS(2368),
    [anon_sym_sizeof] = ACTIONS(2366),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2366),
    [anon_sym__Generic] = ACTIONS(2366),
    [anon_sym_asm] = ACTIONS(2366),
    [anon_sym___asm__] = ACTIONS(2366),
    [sym_number_literal] = ACTIONS(2368),
    [anon_sym_L_SQUOTE] = ACTIONS(2368),
    [anon_sym_u_SQUOTE] = ACTIONS(2368),
    [anon_sym_U_SQUOTE] = ACTIONS(2368),
    [anon_sym_u8_SQUOTE] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(2368),
    [anon_sym_L_DQUOTE] = ACTIONS(2368),
    [anon_sym_u_DQUOTE] = ACTIONS(2368),
    [anon_sym_U_DQUOTE] = ACTIONS(2368),
    [anon_sym_u8_DQUOTE] = ACTIONS(2368),
    [anon_sym_DQUOTE] = ACTIONS(2368),
    [sym_true] = ACTIONS(2366),
    [sym_false] = ACTIONS(2366),
    [anon_sym_NULL] = ACTIONS(2366),
    [anon_sym_nullptr] = ACTIONS(2366),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2366),
    [anon_sym_decltype] = ACTIONS(2366),
    [sym_virtual] = ACTIONS(2366),
    [anon_sym_explicit] = ACTIONS(2366),
    [anon_sym_typename] = ACTIONS(2366),
    [anon_sym_template] = ACTIONS(2366),
    [anon_sym_operator] = ACTIONS(2366),
    [anon_sym_try] = ACTIONS(2366),
    [anon_sym_delete] = ACTIONS(2366),
    [anon_sym_throw] = ACTIONS(2366),
    [anon_sym_namespace] = ACTIONS(2366),
    [anon_sym_using] = ACTIONS(2366),
    [anon_sym_static_assert] = ACTIONS(2366),
    [anon_sym_concept] = ACTIONS(2366),
    [anon_sym_co_return] = ACTIONS(2366),
    [anon_sym_co_yield] = ACTIONS(2366),
    [anon_sym_R_DQUOTE] = ACTIONS(2368),
    [anon_sym_LR_DQUOTE] = ACTIONS(2368),
    [anon_sym_uR_DQUOTE] = ACTIONS(2368),
    [anon_sym_UR_DQUOTE] = ACTIONS(2368),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2368),
    [anon_sym_co_await] = ACTIONS(2366),
    [anon_sym_new] = ACTIONS(2366),
    [anon_sym_requires] = ACTIONS(2366),
    [sym_this] = ACTIONS(2366),
    [anon_sym___launch_bounds__] = ACTIONS(2366),
  },
  [555] = {
    [sym_type_qualifier] = STATE(3531),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4591),
    [sym_sized_type_specifier] = STATE(2599),
    [sym_enum_specifier] = STATE(2599),
    [sym_struct_specifier] = STATE(2599),
    [sym_union_specifier] = STATE(2599),
    [sym_expression] = STATE(4621),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_type_descriptor] = STATE(7152),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_placeholder_type_specifier] = STATE(2599),
    [sym_decltype_auto] = STATE(2598),
    [sym_decltype] = STATE(2477),
    [sym_class_specifier] = STATE(2599),
    [sym__class_name] = STATE(8015),
    [sym_dependent_type] = STATE(2599),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_type_parameter_pack_expansion] = STATE(7669),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5910),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [aux_sym__type_definition_type_repeat1] = STATE(3531),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2157),
    [sym_identifier] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2725),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2729),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2733),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2757),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2761),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_GT2] = ACTIONS(2797),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [556] = {
    [sym_identifier] = ACTIONS(2239),
    [aux_sym_preproc_include_token1] = ACTIONS(2239),
    [aux_sym_preproc_def_token1] = ACTIONS(2239),
    [aux_sym_preproc_if_token1] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2239),
    [sym_preproc_directive] = ACTIONS(2239),
    [anon_sym_LPAREN2] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2239),
    [anon_sym_PLUS] = ACTIONS(2239),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym_SEMI] = ACTIONS(2241),
    [anon_sym___extension__] = ACTIONS(2239),
    [anon_sym_typedef] = ACTIONS(2239),
    [anon_sym___device__] = ACTIONS(2239),
    [anon_sym___host__] = ACTIONS(2239),
    [anon_sym___global__] = ACTIONS(2239),
    [anon_sym___forceinline__] = ACTIONS(2239),
    [anon_sym___noinline__] = ACTIONS(2239),
    [anon_sym_extern] = ACTIONS(2239),
    [anon_sym___attribute__] = ACTIONS(2239),
    [anon_sym_COLON_COLON] = ACTIONS(2241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2241),
    [anon_sym___declspec] = ACTIONS(2239),
    [anon_sym___based] = ACTIONS(2239),
    [anon_sym___cdecl] = ACTIONS(2239),
    [anon_sym___clrcall] = ACTIONS(2239),
    [anon_sym___stdcall] = ACTIONS(2239),
    [anon_sym___fastcall] = ACTIONS(2239),
    [anon_sym___thiscall] = ACTIONS(2239),
    [anon_sym___vectorcall] = ACTIONS(2239),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_RBRACE] = ACTIONS(2241),
    [anon_sym_signed] = ACTIONS(2239),
    [anon_sym_unsigned] = ACTIONS(2239),
    [anon_sym_long] = ACTIONS(2239),
    [anon_sym_short] = ACTIONS(2239),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_static] = ACTIONS(2239),
    [anon_sym_register] = ACTIONS(2239),
    [anon_sym_inline] = ACTIONS(2239),
    [anon_sym___inline] = ACTIONS(2239),
    [anon_sym___inline__] = ACTIONS(2239),
    [anon_sym___forceinline] = ACTIONS(2239),
    [anon_sym_thread_local] = ACTIONS(2239),
    [anon_sym___thread] = ACTIONS(2239),
    [anon_sym_const] = ACTIONS(2239),
    [anon_sym_constexpr] = ACTIONS(2239),
    [anon_sym_volatile] = ACTIONS(2239),
    [anon_sym_restrict] = ACTIONS(2239),
    [anon_sym___restrict__] = ACTIONS(2239),
    [anon_sym__Atomic] = ACTIONS(2239),
    [anon_sym__Noreturn] = ACTIONS(2239),
    [anon_sym_noreturn] = ACTIONS(2239),
    [anon_sym_mutable] = ACTIONS(2239),
    [anon_sym_constinit] = ACTIONS(2239),
    [anon_sym_consteval] = ACTIONS(2239),
    [anon_sym___shared__] = ACTIONS(2239),
    [anon_sym___local__] = ACTIONS(2239),
    [anon_sym___constant__] = ACTIONS(2239),
    [anon_sym___managed__] = ACTIONS(2239),
    [anon_sym___grid_constant__] = ACTIONS(2239),
    [anon_sym_alignas] = ACTIONS(2239),
    [anon_sym__Alignas] = ACTIONS(2239),
    [sym_primitive_type] = ACTIONS(2239),
    [anon_sym_enum] = ACTIONS(2239),
    [anon_sym_class] = ACTIONS(2239),
    [anon_sym_struct] = ACTIONS(2239),
    [anon_sym_union] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(2239),
    [anon_sym_switch] = ACTIONS(2239),
    [anon_sym_case] = ACTIONS(2239),
    [anon_sym_default] = ACTIONS(2239),
    [anon_sym_while] = ACTIONS(2239),
    [anon_sym_do] = ACTIONS(2239),
    [anon_sym_for] = ACTIONS(2239),
    [anon_sym_return] = ACTIONS(2239),
    [anon_sym_break] = ACTIONS(2239),
    [anon_sym_continue] = ACTIONS(2239),
    [anon_sym_goto] = ACTIONS(2239),
    [anon_sym___try] = ACTIONS(2239),
    [anon_sym___leave] = ACTIONS(2239),
    [anon_sym_not] = ACTIONS(2239),
    [anon_sym_compl] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_sizeof] = ACTIONS(2239),
    [anon_sym___alignof__] = ACTIONS(2239),
    [anon_sym___alignof] = ACTIONS(2239),
    [anon_sym__alignof] = ACTIONS(2239),
    [anon_sym_alignof] = ACTIONS(2239),
    [anon_sym__Alignof] = ACTIONS(2239),
    [anon_sym_offsetof] = ACTIONS(2239),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2239),
    [anon_sym___asm__] = ACTIONS(2239),
    [sym_number_literal] = ACTIONS(2241),
    [anon_sym_L_SQUOTE] = ACTIONS(2241),
    [anon_sym_u_SQUOTE] = ACTIONS(2241),
    [anon_sym_U_SQUOTE] = ACTIONS(2241),
    [anon_sym_u8_SQUOTE] = ACTIONS(2241),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_L_DQUOTE] = ACTIONS(2241),
    [anon_sym_u_DQUOTE] = ACTIONS(2241),
    [anon_sym_U_DQUOTE] = ACTIONS(2241),
    [anon_sym_u8_DQUOTE] = ACTIONS(2241),
    [anon_sym_DQUOTE] = ACTIONS(2241),
    [sym_true] = ACTIONS(2239),
    [sym_false] = ACTIONS(2239),
    [anon_sym_NULL] = ACTIONS(2239),
    [anon_sym_nullptr] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2239),
    [anon_sym_decltype] = ACTIONS(2239),
    [sym_virtual] = ACTIONS(2239),
    [anon_sym_explicit] = ACTIONS(2239),
    [anon_sym_typename] = ACTIONS(2239),
    [anon_sym_template] = ACTIONS(2239),
    [anon_sym_operator] = ACTIONS(2239),
    [anon_sym_try] = ACTIONS(2239),
    [anon_sym_delete] = ACTIONS(2239),
    [anon_sym_throw] = ACTIONS(2239),
    [anon_sym_namespace] = ACTIONS(2239),
    [anon_sym_using] = ACTIONS(2239),
    [anon_sym_static_assert] = ACTIONS(2239),
    [anon_sym_concept] = ACTIONS(2239),
    [anon_sym_co_return] = ACTIONS(2239),
    [anon_sym_co_yield] = ACTIONS(2239),
    [anon_sym_R_DQUOTE] = ACTIONS(2241),
    [anon_sym_LR_DQUOTE] = ACTIONS(2241),
    [anon_sym_uR_DQUOTE] = ACTIONS(2241),
    [anon_sym_UR_DQUOTE] = ACTIONS(2241),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2241),
    [anon_sym_co_await] = ACTIONS(2239),
    [anon_sym_new] = ACTIONS(2239),
    [anon_sym_requires] = ACTIONS(2239),
    [sym_this] = ACTIONS(2239),
    [anon_sym___launch_bounds__] = ACTIONS(2239),
  },
  [557] = {
    [sym_identifier] = ACTIONS(2409),
    [aux_sym_preproc_include_token1] = ACTIONS(2409),
    [aux_sym_preproc_def_token1] = ACTIONS(2409),
    [aux_sym_preproc_if_token1] = ACTIONS(2409),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2409),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2409),
    [sym_preproc_directive] = ACTIONS(2409),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_BANG] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2409),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2409),
    [anon_sym_SEMI] = ACTIONS(2411),
    [anon_sym___extension__] = ACTIONS(2409),
    [anon_sym_typedef] = ACTIONS(2409),
    [anon_sym___device__] = ACTIONS(2409),
    [anon_sym___host__] = ACTIONS(2409),
    [anon_sym___global__] = ACTIONS(2409),
    [anon_sym___forceinline__] = ACTIONS(2409),
    [anon_sym___noinline__] = ACTIONS(2409),
    [anon_sym_extern] = ACTIONS(2409),
    [anon_sym___attribute__] = ACTIONS(2409),
    [anon_sym_COLON_COLON] = ACTIONS(2411),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2411),
    [anon_sym___declspec] = ACTIONS(2409),
    [anon_sym___based] = ACTIONS(2409),
    [anon_sym___cdecl] = ACTIONS(2409),
    [anon_sym___clrcall] = ACTIONS(2409),
    [anon_sym___stdcall] = ACTIONS(2409),
    [anon_sym___fastcall] = ACTIONS(2409),
    [anon_sym___thiscall] = ACTIONS(2409),
    [anon_sym___vectorcall] = ACTIONS(2409),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_RBRACE] = ACTIONS(2411),
    [anon_sym_signed] = ACTIONS(2409),
    [anon_sym_unsigned] = ACTIONS(2409),
    [anon_sym_long] = ACTIONS(2409),
    [anon_sym_short] = ACTIONS(2409),
    [anon_sym_LBRACK] = ACTIONS(2409),
    [anon_sym_static] = ACTIONS(2409),
    [anon_sym_register] = ACTIONS(2409),
    [anon_sym_inline] = ACTIONS(2409),
    [anon_sym___inline] = ACTIONS(2409),
    [anon_sym___inline__] = ACTIONS(2409),
    [anon_sym___forceinline] = ACTIONS(2409),
    [anon_sym_thread_local] = ACTIONS(2409),
    [anon_sym___thread] = ACTIONS(2409),
    [anon_sym_const] = ACTIONS(2409),
    [anon_sym_constexpr] = ACTIONS(2409),
    [anon_sym_volatile] = ACTIONS(2409),
    [anon_sym_restrict] = ACTIONS(2409),
    [anon_sym___restrict__] = ACTIONS(2409),
    [anon_sym__Atomic] = ACTIONS(2409),
    [anon_sym__Noreturn] = ACTIONS(2409),
    [anon_sym_noreturn] = ACTIONS(2409),
    [anon_sym_mutable] = ACTIONS(2409),
    [anon_sym_constinit] = ACTIONS(2409),
    [anon_sym_consteval] = ACTIONS(2409),
    [anon_sym___shared__] = ACTIONS(2409),
    [anon_sym___local__] = ACTIONS(2409),
    [anon_sym___constant__] = ACTIONS(2409),
    [anon_sym___managed__] = ACTIONS(2409),
    [anon_sym___grid_constant__] = ACTIONS(2409),
    [anon_sym_alignas] = ACTIONS(2409),
    [anon_sym__Alignas] = ACTIONS(2409),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2409),
    [anon_sym_class] = ACTIONS(2409),
    [anon_sym_struct] = ACTIONS(2409),
    [anon_sym_union] = ACTIONS(2409),
    [anon_sym_if] = ACTIONS(2409),
    [anon_sym_switch] = ACTIONS(2409),
    [anon_sym_case] = ACTIONS(2409),
    [anon_sym_default] = ACTIONS(2409),
    [anon_sym_while] = ACTIONS(2409),
    [anon_sym_do] = ACTIONS(2409),
    [anon_sym_for] = ACTIONS(2409),
    [anon_sym_return] = ACTIONS(2409),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_continue] = ACTIONS(2409),
    [anon_sym_goto] = ACTIONS(2409),
    [anon_sym___try] = ACTIONS(2409),
    [anon_sym___leave] = ACTIONS(2409),
    [anon_sym_not] = ACTIONS(2409),
    [anon_sym_compl] = ACTIONS(2409),
    [anon_sym_DASH_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_PLUS] = ACTIONS(2411),
    [anon_sym_sizeof] = ACTIONS(2409),
    [anon_sym___alignof__] = ACTIONS(2409),
    [anon_sym___alignof] = ACTIONS(2409),
    [anon_sym__alignof] = ACTIONS(2409),
    [anon_sym_alignof] = ACTIONS(2409),
    [anon_sym__Alignof] = ACTIONS(2409),
    [anon_sym_offsetof] = ACTIONS(2409),
    [anon_sym__Generic] = ACTIONS(2409),
    [anon_sym_asm] = ACTIONS(2409),
    [anon_sym___asm__] = ACTIONS(2409),
    [sym_number_literal] = ACTIONS(2411),
    [anon_sym_L_SQUOTE] = ACTIONS(2411),
    [anon_sym_u_SQUOTE] = ACTIONS(2411),
    [anon_sym_U_SQUOTE] = ACTIONS(2411),
    [anon_sym_u8_SQUOTE] = ACTIONS(2411),
    [anon_sym_SQUOTE] = ACTIONS(2411),
    [anon_sym_L_DQUOTE] = ACTIONS(2411),
    [anon_sym_u_DQUOTE] = ACTIONS(2411),
    [anon_sym_U_DQUOTE] = ACTIONS(2411),
    [anon_sym_u8_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [sym_true] = ACTIONS(2409),
    [sym_false] = ACTIONS(2409),
    [anon_sym_NULL] = ACTIONS(2409),
    [anon_sym_nullptr] = ACTIONS(2409),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2409),
    [anon_sym_decltype] = ACTIONS(2409),
    [sym_virtual] = ACTIONS(2409),
    [anon_sym_explicit] = ACTIONS(2409),
    [anon_sym_typename] = ACTIONS(2409),
    [anon_sym_template] = ACTIONS(2409),
    [anon_sym_operator] = ACTIONS(2409),
    [anon_sym_try] = ACTIONS(2409),
    [anon_sym_delete] = ACTIONS(2409),
    [anon_sym_throw] = ACTIONS(2409),
    [anon_sym_namespace] = ACTIONS(2409),
    [anon_sym_using] = ACTIONS(2409),
    [anon_sym_static_assert] = ACTIONS(2409),
    [anon_sym_concept] = ACTIONS(2409),
    [anon_sym_co_return] = ACTIONS(2409),
    [anon_sym_co_yield] = ACTIONS(2409),
    [anon_sym_R_DQUOTE] = ACTIONS(2411),
    [anon_sym_LR_DQUOTE] = ACTIONS(2411),
    [anon_sym_uR_DQUOTE] = ACTIONS(2411),
    [anon_sym_UR_DQUOTE] = ACTIONS(2411),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2411),
    [anon_sym_co_await] = ACTIONS(2409),
    [anon_sym_new] = ACTIONS(2409),
    [anon_sym_requires] = ACTIONS(2409),
    [sym_this] = ACTIONS(2409),
    [anon_sym___launch_bounds__] = ACTIONS(2409),
  },
  [558] = {
    [sym_expression] = STATE(2499),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_initializer_list] = STATE(2690),
    [sym_char_literal] = STATE(3517),
    [sym_concatenated_string] = STATE(3520),
    [sym_string_literal] = STATE(2431),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2428),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_BANG] = ACTIONS(2801),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2508),
    [anon_sym_STAR] = ACTIONS(2508),
    [anon_sym_SLASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_PIPE] = ACTIONS(2508),
    [anon_sym_CARET] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_EQ_EQ] = ACTIONS(2510),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_GT] = ACTIONS(2508),
    [anon_sym_GT_EQ] = ACTIONS(2510),
    [anon_sym_LT_EQ] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_LT_LT] = ACTIONS(2508),
    [anon_sym_GT_GT] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2510),
    [anon_sym___attribute__] = ACTIONS(2508),
    [anon_sym_COLON_COLON] = ACTIONS(2805),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_EQ] = ACTIONS(2508),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_STAR_EQ] = ACTIONS(2510),
    [anon_sym_SLASH_EQ] = ACTIONS(2510),
    [anon_sym_PERCENT_EQ] = ACTIONS(2510),
    [anon_sym_PLUS_EQ] = ACTIONS(2510),
    [anon_sym_DASH_EQ] = ACTIONS(2510),
    [anon_sym_LT_LT_EQ] = ACTIONS(2510),
    [anon_sym_GT_GT_EQ] = ACTIONS(2510),
    [anon_sym_AMP_EQ] = ACTIONS(2510),
    [anon_sym_CARET_EQ] = ACTIONS(2510),
    [anon_sym_PIPE_EQ] = ACTIONS(2510),
    [anon_sym_and_eq] = ACTIONS(2508),
    [anon_sym_or_eq] = ACTIONS(2508),
    [anon_sym_xor_eq] = ACTIONS(2508),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_compl] = ACTIONS(2801),
    [anon_sym_LT_EQ_GT] = ACTIONS(2510),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_bitor] = ACTIONS(2508),
    [anon_sym_xor] = ACTIONS(2508),
    [anon_sym_bitand] = ACTIONS(2508),
    [anon_sym_not_eq] = ACTIONS(2508),
    [anon_sym_DASH_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_PLUS] = ACTIONS(2510),
    [anon_sym_sizeof] = ACTIONS(2807),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [anon_sym_DOT] = ACTIONS(2508),
    [anon_sym_DOT_STAR] = ACTIONS(2510),
    [anon_sym_DASH_GT] = ACTIONS(2510),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2813),
    [anon_sym_u_DQUOTE] = ACTIONS(2813),
    [anon_sym_U_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8_DQUOTE] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2817),
    [anon_sym_LR_DQUOTE] = ACTIONS(2817),
    [anon_sym_uR_DQUOTE] = ACTIONS(2817),
    [anon_sym_UR_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2817),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(2510),
  },
  [559] = {
    [sym_identifier] = ACTIONS(2376),
    [aux_sym_preproc_include_token1] = ACTIONS(2376),
    [aux_sym_preproc_def_token1] = ACTIONS(2376),
    [aux_sym_preproc_if_token1] = ACTIONS(2376),
    [aux_sym_preproc_if_token2] = ACTIONS(2376),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2376),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2376),
    [sym_preproc_directive] = ACTIONS(2376),
    [anon_sym_LPAREN2] = ACTIONS(2378),
    [anon_sym_BANG] = ACTIONS(2378),
    [anon_sym_TILDE] = ACTIONS(2378),
    [anon_sym_DASH] = ACTIONS(2376),
    [anon_sym_PLUS] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(2378),
    [anon_sym_AMP_AMP] = ACTIONS(2378),
    [anon_sym_AMP] = ACTIONS(2376),
    [anon_sym_SEMI] = ACTIONS(2378),
    [anon_sym___extension__] = ACTIONS(2376),
    [anon_sym_typedef] = ACTIONS(2376),
    [anon_sym___device__] = ACTIONS(2376),
    [anon_sym___host__] = ACTIONS(2376),
    [anon_sym___global__] = ACTIONS(2376),
    [anon_sym___forceinline__] = ACTIONS(2376),
    [anon_sym___noinline__] = ACTIONS(2376),
    [anon_sym_extern] = ACTIONS(2376),
    [anon_sym___attribute__] = ACTIONS(2376),
    [anon_sym_COLON_COLON] = ACTIONS(2378),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2378),
    [anon_sym___declspec] = ACTIONS(2376),
    [anon_sym___based] = ACTIONS(2376),
    [anon_sym___cdecl] = ACTIONS(2376),
    [anon_sym___clrcall] = ACTIONS(2376),
    [anon_sym___stdcall] = ACTIONS(2376),
    [anon_sym___fastcall] = ACTIONS(2376),
    [anon_sym___thiscall] = ACTIONS(2376),
    [anon_sym___vectorcall] = ACTIONS(2376),
    [anon_sym_LBRACE] = ACTIONS(2378),
    [anon_sym_signed] = ACTIONS(2376),
    [anon_sym_unsigned] = ACTIONS(2376),
    [anon_sym_long] = ACTIONS(2376),
    [anon_sym_short] = ACTIONS(2376),
    [anon_sym_LBRACK] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2376),
    [anon_sym_register] = ACTIONS(2376),
    [anon_sym_inline] = ACTIONS(2376),
    [anon_sym___inline] = ACTIONS(2376),
    [anon_sym___inline__] = ACTIONS(2376),
    [anon_sym___forceinline] = ACTIONS(2376),
    [anon_sym_thread_local] = ACTIONS(2376),
    [anon_sym___thread] = ACTIONS(2376),
    [anon_sym_const] = ACTIONS(2376),
    [anon_sym_constexpr] = ACTIONS(2376),
    [anon_sym_volatile] = ACTIONS(2376),
    [anon_sym_restrict] = ACTIONS(2376),
    [anon_sym___restrict__] = ACTIONS(2376),
    [anon_sym__Atomic] = ACTIONS(2376),
    [anon_sym__Noreturn] = ACTIONS(2376),
    [anon_sym_noreturn] = ACTIONS(2376),
    [anon_sym_mutable] = ACTIONS(2376),
    [anon_sym_constinit] = ACTIONS(2376),
    [anon_sym_consteval] = ACTIONS(2376),
    [anon_sym___shared__] = ACTIONS(2376),
    [anon_sym___local__] = ACTIONS(2376),
    [anon_sym___constant__] = ACTIONS(2376),
    [anon_sym___managed__] = ACTIONS(2376),
    [anon_sym___grid_constant__] = ACTIONS(2376),
    [anon_sym_alignas] = ACTIONS(2376),
    [anon_sym__Alignas] = ACTIONS(2376),
    [sym_primitive_type] = ACTIONS(2376),
    [anon_sym_enum] = ACTIONS(2376),
    [anon_sym_class] = ACTIONS(2376),
    [anon_sym_struct] = ACTIONS(2376),
    [anon_sym_union] = ACTIONS(2376),
    [anon_sym_if] = ACTIONS(2376),
    [anon_sym_switch] = ACTIONS(2376),
    [anon_sym_case] = ACTIONS(2376),
    [anon_sym_default] = ACTIONS(2376),
    [anon_sym_while] = ACTIONS(2376),
    [anon_sym_do] = ACTIONS(2376),
    [anon_sym_for] = ACTIONS(2376),
    [anon_sym_return] = ACTIONS(2376),
    [anon_sym_break] = ACTIONS(2376),
    [anon_sym_continue] = ACTIONS(2376),
    [anon_sym_goto] = ACTIONS(2376),
    [anon_sym___try] = ACTIONS(2376),
    [anon_sym___leave] = ACTIONS(2376),
    [anon_sym_not] = ACTIONS(2376),
    [anon_sym_compl] = ACTIONS(2376),
    [anon_sym_DASH_DASH] = ACTIONS(2378),
    [anon_sym_PLUS_PLUS] = ACTIONS(2378),
    [anon_sym_sizeof] = ACTIONS(2376),
    [anon_sym___alignof__] = ACTIONS(2376),
    [anon_sym___alignof] = ACTIONS(2376),
    [anon_sym__alignof] = ACTIONS(2376),
    [anon_sym_alignof] = ACTIONS(2376),
    [anon_sym__Alignof] = ACTIONS(2376),
    [anon_sym_offsetof] = ACTIONS(2376),
    [anon_sym__Generic] = ACTIONS(2376),
    [anon_sym_asm] = ACTIONS(2376),
    [anon_sym___asm__] = ACTIONS(2376),
    [sym_number_literal] = ACTIONS(2378),
    [anon_sym_L_SQUOTE] = ACTIONS(2378),
    [anon_sym_u_SQUOTE] = ACTIONS(2378),
    [anon_sym_U_SQUOTE] = ACTIONS(2378),
    [anon_sym_u8_SQUOTE] = ACTIONS(2378),
    [anon_sym_SQUOTE] = ACTIONS(2378),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2376),
    [sym_false] = ACTIONS(2376),
    [anon_sym_NULL] = ACTIONS(2376),
    [anon_sym_nullptr] = ACTIONS(2376),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2376),
    [anon_sym_decltype] = ACTIONS(2376),
    [sym_virtual] = ACTIONS(2376),
    [anon_sym_explicit] = ACTIONS(2376),
    [anon_sym_typename] = ACTIONS(2376),
    [anon_sym_template] = ACTIONS(2376),
    [anon_sym_operator] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2376),
    [anon_sym_delete] = ACTIONS(2376),
    [anon_sym_throw] = ACTIONS(2376),
    [anon_sym_namespace] = ACTIONS(2376),
    [anon_sym_using] = ACTIONS(2376),
    [anon_sym_static_assert] = ACTIONS(2376),
    [anon_sym_concept] = ACTIONS(2376),
    [anon_sym_co_return] = ACTIONS(2376),
    [anon_sym_co_yield] = ACTIONS(2376),
    [anon_sym_R_DQUOTE] = ACTIONS(2378),
    [anon_sym_LR_DQUOTE] = ACTIONS(2378),
    [anon_sym_uR_DQUOTE] = ACTIONS(2378),
    [anon_sym_UR_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2378),
    [anon_sym_co_await] = ACTIONS(2376),
    [anon_sym_new] = ACTIONS(2376),
    [anon_sym_requires] = ACTIONS(2376),
    [sym_this] = ACTIONS(2376),
    [anon_sym___launch_bounds__] = ACTIONS(2376),
  },
  [560] = {
    [sym_identifier] = ACTIONS(2370),
    [aux_sym_preproc_include_token1] = ACTIONS(2370),
    [aux_sym_preproc_def_token1] = ACTIONS(2370),
    [aux_sym_preproc_if_token1] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2370),
    [sym_preproc_directive] = ACTIONS(2370),
    [anon_sym_LPAREN2] = ACTIONS(2372),
    [anon_sym_BANG] = ACTIONS(2372),
    [anon_sym_TILDE] = ACTIONS(2372),
    [anon_sym_DASH] = ACTIONS(2370),
    [anon_sym_PLUS] = ACTIONS(2370),
    [anon_sym_STAR] = ACTIONS(2372),
    [anon_sym_AMP_AMP] = ACTIONS(2372),
    [anon_sym_AMP] = ACTIONS(2370),
    [anon_sym_SEMI] = ACTIONS(2372),
    [anon_sym___extension__] = ACTIONS(2370),
    [anon_sym_typedef] = ACTIONS(2370),
    [anon_sym___device__] = ACTIONS(2370),
    [anon_sym___host__] = ACTIONS(2370),
    [anon_sym___global__] = ACTIONS(2370),
    [anon_sym___forceinline__] = ACTIONS(2370),
    [anon_sym___noinline__] = ACTIONS(2370),
    [anon_sym_extern] = ACTIONS(2370),
    [anon_sym___attribute__] = ACTIONS(2370),
    [anon_sym_COLON_COLON] = ACTIONS(2372),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2372),
    [anon_sym___declspec] = ACTIONS(2370),
    [anon_sym___based] = ACTIONS(2370),
    [anon_sym___cdecl] = ACTIONS(2370),
    [anon_sym___clrcall] = ACTIONS(2370),
    [anon_sym___stdcall] = ACTIONS(2370),
    [anon_sym___fastcall] = ACTIONS(2370),
    [anon_sym___thiscall] = ACTIONS(2370),
    [anon_sym___vectorcall] = ACTIONS(2370),
    [anon_sym_LBRACE] = ACTIONS(2372),
    [anon_sym_RBRACE] = ACTIONS(2372),
    [anon_sym_signed] = ACTIONS(2370),
    [anon_sym_unsigned] = ACTIONS(2370),
    [anon_sym_long] = ACTIONS(2370),
    [anon_sym_short] = ACTIONS(2370),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_static] = ACTIONS(2370),
    [anon_sym_register] = ACTIONS(2370),
    [anon_sym_inline] = ACTIONS(2370),
    [anon_sym___inline] = ACTIONS(2370),
    [anon_sym___inline__] = ACTIONS(2370),
    [anon_sym___forceinline] = ACTIONS(2370),
    [anon_sym_thread_local] = ACTIONS(2370),
    [anon_sym___thread] = ACTIONS(2370),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_constexpr] = ACTIONS(2370),
    [anon_sym_volatile] = ACTIONS(2370),
    [anon_sym_restrict] = ACTIONS(2370),
    [anon_sym___restrict__] = ACTIONS(2370),
    [anon_sym__Atomic] = ACTIONS(2370),
    [anon_sym__Noreturn] = ACTIONS(2370),
    [anon_sym_noreturn] = ACTIONS(2370),
    [anon_sym_mutable] = ACTIONS(2370),
    [anon_sym_constinit] = ACTIONS(2370),
    [anon_sym_consteval] = ACTIONS(2370),
    [anon_sym___shared__] = ACTIONS(2370),
    [anon_sym___local__] = ACTIONS(2370),
    [anon_sym___constant__] = ACTIONS(2370),
    [anon_sym___managed__] = ACTIONS(2370),
    [anon_sym___grid_constant__] = ACTIONS(2370),
    [anon_sym_alignas] = ACTIONS(2370),
    [anon_sym__Alignas] = ACTIONS(2370),
    [sym_primitive_type] = ACTIONS(2370),
    [anon_sym_enum] = ACTIONS(2370),
    [anon_sym_class] = ACTIONS(2370),
    [anon_sym_struct] = ACTIONS(2370),
    [anon_sym_union] = ACTIONS(2370),
    [anon_sym_if] = ACTIONS(2370),
    [anon_sym_switch] = ACTIONS(2370),
    [anon_sym_case] = ACTIONS(2370),
    [anon_sym_default] = ACTIONS(2370),
    [anon_sym_while] = ACTIONS(2370),
    [anon_sym_do] = ACTIONS(2370),
    [anon_sym_for] = ACTIONS(2370),
    [anon_sym_return] = ACTIONS(2370),
    [anon_sym_break] = ACTIONS(2370),
    [anon_sym_continue] = ACTIONS(2370),
    [anon_sym_goto] = ACTIONS(2370),
    [anon_sym___try] = ACTIONS(2370),
    [anon_sym___leave] = ACTIONS(2370),
    [anon_sym_not] = ACTIONS(2370),
    [anon_sym_compl] = ACTIONS(2370),
    [anon_sym_DASH_DASH] = ACTIONS(2372),
    [anon_sym_PLUS_PLUS] = ACTIONS(2372),
    [anon_sym_sizeof] = ACTIONS(2370),
    [anon_sym___alignof__] = ACTIONS(2370),
    [anon_sym___alignof] = ACTIONS(2370),
    [anon_sym__alignof] = ACTIONS(2370),
    [anon_sym_alignof] = ACTIONS(2370),
    [anon_sym__Alignof] = ACTIONS(2370),
    [anon_sym_offsetof] = ACTIONS(2370),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2370),
    [anon_sym___asm__] = ACTIONS(2370),
    [sym_number_literal] = ACTIONS(2372),
    [anon_sym_L_SQUOTE] = ACTIONS(2372),
    [anon_sym_u_SQUOTE] = ACTIONS(2372),
    [anon_sym_U_SQUOTE] = ACTIONS(2372),
    [anon_sym_u8_SQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [anon_sym_L_DQUOTE] = ACTIONS(2372),
    [anon_sym_u_DQUOTE] = ACTIONS(2372),
    [anon_sym_U_DQUOTE] = ACTIONS(2372),
    [anon_sym_u8_DQUOTE] = ACTIONS(2372),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [sym_true] = ACTIONS(2370),
    [sym_false] = ACTIONS(2370),
    [anon_sym_NULL] = ACTIONS(2370),
    [anon_sym_nullptr] = ACTIONS(2370),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2370),
    [anon_sym_decltype] = ACTIONS(2370),
    [sym_virtual] = ACTIONS(2370),
    [anon_sym_explicit] = ACTIONS(2370),
    [anon_sym_typename] = ACTIONS(2370),
    [anon_sym_template] = ACTIONS(2370),
    [anon_sym_operator] = ACTIONS(2370),
    [anon_sym_try] = ACTIONS(2370),
    [anon_sym_delete] = ACTIONS(2370),
    [anon_sym_throw] = ACTIONS(2370),
    [anon_sym_namespace] = ACTIONS(2370),
    [anon_sym_using] = ACTIONS(2370),
    [anon_sym_static_assert] = ACTIONS(2370),
    [anon_sym_concept] = ACTIONS(2370),
    [anon_sym_co_return] = ACTIONS(2370),
    [anon_sym_co_yield] = ACTIONS(2370),
    [anon_sym_R_DQUOTE] = ACTIONS(2372),
    [anon_sym_LR_DQUOTE] = ACTIONS(2372),
    [anon_sym_uR_DQUOTE] = ACTIONS(2372),
    [anon_sym_UR_DQUOTE] = ACTIONS(2372),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2372),
    [anon_sym_co_await] = ACTIONS(2370),
    [anon_sym_new] = ACTIONS(2370),
    [anon_sym_requires] = ACTIONS(2370),
    [sym_this] = ACTIONS(2370),
    [anon_sym___launch_bounds__] = ACTIONS(2370),
  },
  [561] = {
    [sym_identifier] = ACTIONS(2195),
    [aux_sym_preproc_include_token1] = ACTIONS(2195),
    [aux_sym_preproc_def_token1] = ACTIONS(2195),
    [aux_sym_preproc_if_token1] = ACTIONS(2195),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2195),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2195),
    [sym_preproc_directive] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(2197),
    [anon_sym_BANG] = ACTIONS(2197),
    [anon_sym_TILDE] = ACTIONS(2197),
    [anon_sym_DASH] = ACTIONS(2195),
    [anon_sym_PLUS] = ACTIONS(2195),
    [anon_sym_STAR] = ACTIONS(2197),
    [anon_sym_AMP_AMP] = ACTIONS(2197),
    [anon_sym_AMP] = ACTIONS(2195),
    [anon_sym_SEMI] = ACTIONS(2197),
    [anon_sym___extension__] = ACTIONS(2195),
    [anon_sym_typedef] = ACTIONS(2195),
    [anon_sym___device__] = ACTIONS(2195),
    [anon_sym___host__] = ACTIONS(2195),
    [anon_sym___global__] = ACTIONS(2195),
    [anon_sym___forceinline__] = ACTIONS(2195),
    [anon_sym___noinline__] = ACTIONS(2195),
    [anon_sym_extern] = ACTIONS(2195),
    [anon_sym___attribute__] = ACTIONS(2195),
    [anon_sym_COLON_COLON] = ACTIONS(2197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2197),
    [anon_sym___declspec] = ACTIONS(2195),
    [anon_sym___based] = ACTIONS(2195),
    [anon_sym___cdecl] = ACTIONS(2195),
    [anon_sym___clrcall] = ACTIONS(2195),
    [anon_sym___stdcall] = ACTIONS(2195),
    [anon_sym___fastcall] = ACTIONS(2195),
    [anon_sym___thiscall] = ACTIONS(2195),
    [anon_sym___vectorcall] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(2197),
    [anon_sym_RBRACE] = ACTIONS(2197),
    [anon_sym_signed] = ACTIONS(2195),
    [anon_sym_unsigned] = ACTIONS(2195),
    [anon_sym_long] = ACTIONS(2195),
    [anon_sym_short] = ACTIONS(2195),
    [anon_sym_LBRACK] = ACTIONS(2195),
    [anon_sym_static] = ACTIONS(2195),
    [anon_sym_register] = ACTIONS(2195),
    [anon_sym_inline] = ACTIONS(2195),
    [anon_sym___inline] = ACTIONS(2195),
    [anon_sym___inline__] = ACTIONS(2195),
    [anon_sym___forceinline] = ACTIONS(2195),
    [anon_sym_thread_local] = ACTIONS(2195),
    [anon_sym___thread] = ACTIONS(2195),
    [anon_sym_const] = ACTIONS(2195),
    [anon_sym_constexpr] = ACTIONS(2195),
    [anon_sym_volatile] = ACTIONS(2195),
    [anon_sym_restrict] = ACTIONS(2195),
    [anon_sym___restrict__] = ACTIONS(2195),
    [anon_sym__Atomic] = ACTIONS(2195),
    [anon_sym__Noreturn] = ACTIONS(2195),
    [anon_sym_noreturn] = ACTIONS(2195),
    [anon_sym_mutable] = ACTIONS(2195),
    [anon_sym_constinit] = ACTIONS(2195),
    [anon_sym_consteval] = ACTIONS(2195),
    [anon_sym___shared__] = ACTIONS(2195),
    [anon_sym___local__] = ACTIONS(2195),
    [anon_sym___constant__] = ACTIONS(2195),
    [anon_sym___managed__] = ACTIONS(2195),
    [anon_sym___grid_constant__] = ACTIONS(2195),
    [anon_sym_alignas] = ACTIONS(2195),
    [anon_sym__Alignas] = ACTIONS(2195),
    [sym_primitive_type] = ACTIONS(2195),
    [anon_sym_enum] = ACTIONS(2195),
    [anon_sym_class] = ACTIONS(2195),
    [anon_sym_struct] = ACTIONS(2195),
    [anon_sym_union] = ACTIONS(2195),
    [anon_sym_if] = ACTIONS(2195),
    [anon_sym_switch] = ACTIONS(2195),
    [anon_sym_case] = ACTIONS(2195),
    [anon_sym_default] = ACTIONS(2195),
    [anon_sym_while] = ACTIONS(2195),
    [anon_sym_do] = ACTIONS(2195),
    [anon_sym_for] = ACTIONS(2195),
    [anon_sym_return] = ACTIONS(2195),
    [anon_sym_break] = ACTIONS(2195),
    [anon_sym_continue] = ACTIONS(2195),
    [anon_sym_goto] = ACTIONS(2195),
    [anon_sym___try] = ACTIONS(2195),
    [anon_sym___leave] = ACTIONS(2195),
    [anon_sym_not] = ACTIONS(2195),
    [anon_sym_compl] = ACTIONS(2195),
    [anon_sym_DASH_DASH] = ACTIONS(2197),
    [anon_sym_PLUS_PLUS] = ACTIONS(2197),
    [anon_sym_sizeof] = ACTIONS(2195),
    [anon_sym___alignof__] = ACTIONS(2195),
    [anon_sym___alignof] = ACTIONS(2195),
    [anon_sym__alignof] = ACTIONS(2195),
    [anon_sym_alignof] = ACTIONS(2195),
    [anon_sym__Alignof] = ACTIONS(2195),
    [anon_sym_offsetof] = ACTIONS(2195),
    [anon_sym__Generic] = ACTIONS(2195),
    [anon_sym_asm] = ACTIONS(2195),
    [anon_sym___asm__] = ACTIONS(2195),
    [sym_number_literal] = ACTIONS(2197),
    [anon_sym_L_SQUOTE] = ACTIONS(2197),
    [anon_sym_u_SQUOTE] = ACTIONS(2197),
    [anon_sym_U_SQUOTE] = ACTIONS(2197),
    [anon_sym_u8_SQUOTE] = ACTIONS(2197),
    [anon_sym_SQUOTE] = ACTIONS(2197),
    [anon_sym_L_DQUOTE] = ACTIONS(2197),
    [anon_sym_u_DQUOTE] = ACTIONS(2197),
    [anon_sym_U_DQUOTE] = ACTIONS(2197),
    [anon_sym_u8_DQUOTE] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(2197),
    [sym_true] = ACTIONS(2195),
    [sym_false] = ACTIONS(2195),
    [anon_sym_NULL] = ACTIONS(2195),
    [anon_sym_nullptr] = ACTIONS(2195),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2195),
    [anon_sym_decltype] = ACTIONS(2195),
    [sym_virtual] = ACTIONS(2195),
    [anon_sym_explicit] = ACTIONS(2195),
    [anon_sym_typename] = ACTIONS(2195),
    [anon_sym_template] = ACTIONS(2195),
    [anon_sym_operator] = ACTIONS(2195),
    [anon_sym_try] = ACTIONS(2195),
    [anon_sym_delete] = ACTIONS(2195),
    [anon_sym_throw] = ACTIONS(2195),
    [anon_sym_namespace] = ACTIONS(2195),
    [anon_sym_using] = ACTIONS(2195),
    [anon_sym_static_assert] = ACTIONS(2195),
    [anon_sym_concept] = ACTIONS(2195),
    [anon_sym_co_return] = ACTIONS(2195),
    [anon_sym_co_yield] = ACTIONS(2195),
    [anon_sym_R_DQUOTE] = ACTIONS(2197),
    [anon_sym_LR_DQUOTE] = ACTIONS(2197),
    [anon_sym_uR_DQUOTE] = ACTIONS(2197),
    [anon_sym_UR_DQUOTE] = ACTIONS(2197),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2197),
    [anon_sym_co_await] = ACTIONS(2195),
    [anon_sym_new] = ACTIONS(2195),
    [anon_sym_requires] = ACTIONS(2195),
    [sym_this] = ACTIONS(2195),
    [anon_sym___launch_bounds__] = ACTIONS(2195),
  },
  [562] = {
    [sym_identifier] = ACTIONS(2162),
    [aux_sym_preproc_include_token1] = ACTIONS(2162),
    [aux_sym_preproc_def_token1] = ACTIONS(2162),
    [aux_sym_preproc_if_token1] = ACTIONS(2162),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2162),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2162),
    [sym_preproc_directive] = ACTIONS(2162),
    [anon_sym_LPAREN2] = ACTIONS(2164),
    [anon_sym_BANG] = ACTIONS(2164),
    [anon_sym_TILDE] = ACTIONS(2164),
    [anon_sym_DASH] = ACTIONS(2162),
    [anon_sym_PLUS] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(2164),
    [anon_sym_AMP_AMP] = ACTIONS(2164),
    [anon_sym_AMP] = ACTIONS(2162),
    [anon_sym_SEMI] = ACTIONS(2164),
    [anon_sym___extension__] = ACTIONS(2162),
    [anon_sym_typedef] = ACTIONS(2162),
    [anon_sym___device__] = ACTIONS(2162),
    [anon_sym___host__] = ACTIONS(2162),
    [anon_sym___global__] = ACTIONS(2162),
    [anon_sym___forceinline__] = ACTIONS(2162),
    [anon_sym___noinline__] = ACTIONS(2162),
    [anon_sym_extern] = ACTIONS(2162),
    [anon_sym___attribute__] = ACTIONS(2162),
    [anon_sym_COLON_COLON] = ACTIONS(2164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2164),
    [anon_sym___declspec] = ACTIONS(2162),
    [anon_sym___based] = ACTIONS(2162),
    [anon_sym___cdecl] = ACTIONS(2162),
    [anon_sym___clrcall] = ACTIONS(2162),
    [anon_sym___stdcall] = ACTIONS(2162),
    [anon_sym___fastcall] = ACTIONS(2162),
    [anon_sym___thiscall] = ACTIONS(2162),
    [anon_sym___vectorcall] = ACTIONS(2162),
    [anon_sym_LBRACE] = ACTIONS(2164),
    [anon_sym_RBRACE] = ACTIONS(2164),
    [anon_sym_signed] = ACTIONS(2162),
    [anon_sym_unsigned] = ACTIONS(2162),
    [anon_sym_long] = ACTIONS(2162),
    [anon_sym_short] = ACTIONS(2162),
    [anon_sym_LBRACK] = ACTIONS(2162),
    [anon_sym_static] = ACTIONS(2162),
    [anon_sym_register] = ACTIONS(2162),
    [anon_sym_inline] = ACTIONS(2162),
    [anon_sym___inline] = ACTIONS(2162),
    [anon_sym___inline__] = ACTIONS(2162),
    [anon_sym___forceinline] = ACTIONS(2162),
    [anon_sym_thread_local] = ACTIONS(2162),
    [anon_sym___thread] = ACTIONS(2162),
    [anon_sym_const] = ACTIONS(2162),
    [anon_sym_constexpr] = ACTIONS(2162),
    [anon_sym_volatile] = ACTIONS(2162),
    [anon_sym_restrict] = ACTIONS(2162),
    [anon_sym___restrict__] = ACTIONS(2162),
    [anon_sym__Atomic] = ACTIONS(2162),
    [anon_sym__Noreturn] = ACTIONS(2162),
    [anon_sym_noreturn] = ACTIONS(2162),
    [anon_sym_mutable] = ACTIONS(2162),
    [anon_sym_constinit] = ACTIONS(2162),
    [anon_sym_consteval] = ACTIONS(2162),
    [anon_sym___shared__] = ACTIONS(2162),
    [anon_sym___local__] = ACTIONS(2162),
    [anon_sym___constant__] = ACTIONS(2162),
    [anon_sym___managed__] = ACTIONS(2162),
    [anon_sym___grid_constant__] = ACTIONS(2162),
    [anon_sym_alignas] = ACTIONS(2162),
    [anon_sym__Alignas] = ACTIONS(2162),
    [sym_primitive_type] = ACTIONS(2162),
    [anon_sym_enum] = ACTIONS(2162),
    [anon_sym_class] = ACTIONS(2162),
    [anon_sym_struct] = ACTIONS(2162),
    [anon_sym_union] = ACTIONS(2162),
    [anon_sym_if] = ACTIONS(2162),
    [anon_sym_switch] = ACTIONS(2162),
    [anon_sym_case] = ACTIONS(2162),
    [anon_sym_default] = ACTIONS(2162),
    [anon_sym_while] = ACTIONS(2162),
    [anon_sym_do] = ACTIONS(2162),
    [anon_sym_for] = ACTIONS(2162),
    [anon_sym_return] = ACTIONS(2162),
    [anon_sym_break] = ACTIONS(2162),
    [anon_sym_continue] = ACTIONS(2162),
    [anon_sym_goto] = ACTIONS(2162),
    [anon_sym___try] = ACTIONS(2162),
    [anon_sym___leave] = ACTIONS(2162),
    [anon_sym_not] = ACTIONS(2162),
    [anon_sym_compl] = ACTIONS(2162),
    [anon_sym_DASH_DASH] = ACTIONS(2164),
    [anon_sym_PLUS_PLUS] = ACTIONS(2164),
    [anon_sym_sizeof] = ACTIONS(2162),
    [anon_sym___alignof__] = ACTIONS(2162),
    [anon_sym___alignof] = ACTIONS(2162),
    [anon_sym__alignof] = ACTIONS(2162),
    [anon_sym_alignof] = ACTIONS(2162),
    [anon_sym__Alignof] = ACTIONS(2162),
    [anon_sym_offsetof] = ACTIONS(2162),
    [anon_sym__Generic] = ACTIONS(2162),
    [anon_sym_asm] = ACTIONS(2162),
    [anon_sym___asm__] = ACTIONS(2162),
    [sym_number_literal] = ACTIONS(2164),
    [anon_sym_L_SQUOTE] = ACTIONS(2164),
    [anon_sym_u_SQUOTE] = ACTIONS(2164),
    [anon_sym_U_SQUOTE] = ACTIONS(2164),
    [anon_sym_u8_SQUOTE] = ACTIONS(2164),
    [anon_sym_SQUOTE] = ACTIONS(2164),
    [anon_sym_L_DQUOTE] = ACTIONS(2164),
    [anon_sym_u_DQUOTE] = ACTIONS(2164),
    [anon_sym_U_DQUOTE] = ACTIONS(2164),
    [anon_sym_u8_DQUOTE] = ACTIONS(2164),
    [anon_sym_DQUOTE] = ACTIONS(2164),
    [sym_true] = ACTIONS(2162),
    [sym_false] = ACTIONS(2162),
    [anon_sym_NULL] = ACTIONS(2162),
    [anon_sym_nullptr] = ACTIONS(2162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2162),
    [anon_sym_decltype] = ACTIONS(2162),
    [sym_virtual] = ACTIONS(2162),
    [anon_sym_explicit] = ACTIONS(2162),
    [anon_sym_typename] = ACTIONS(2162),
    [anon_sym_template] = ACTIONS(2162),
    [anon_sym_operator] = ACTIONS(2162),
    [anon_sym_try] = ACTIONS(2162),
    [anon_sym_delete] = ACTIONS(2162),
    [anon_sym_throw] = ACTIONS(2162),
    [anon_sym_namespace] = ACTIONS(2162),
    [anon_sym_using] = ACTIONS(2162),
    [anon_sym_static_assert] = ACTIONS(2162),
    [anon_sym_concept] = ACTIONS(2162),
    [anon_sym_co_return] = ACTIONS(2162),
    [anon_sym_co_yield] = ACTIONS(2162),
    [anon_sym_R_DQUOTE] = ACTIONS(2164),
    [anon_sym_LR_DQUOTE] = ACTIONS(2164),
    [anon_sym_uR_DQUOTE] = ACTIONS(2164),
    [anon_sym_UR_DQUOTE] = ACTIONS(2164),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2164),
    [anon_sym_co_await] = ACTIONS(2162),
    [anon_sym_new] = ACTIONS(2162),
    [anon_sym_requires] = ACTIONS(2162),
    [sym_this] = ACTIONS(2162),
    [anon_sym___launch_bounds__] = ACTIONS(2162),
  },
  [563] = {
    [sym_identifier] = ACTIONS(2342),
    [aux_sym_preproc_include_token1] = ACTIONS(2342),
    [aux_sym_preproc_def_token1] = ACTIONS(2342),
    [aux_sym_preproc_if_token1] = ACTIONS(2342),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2342),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2342),
    [sym_preproc_directive] = ACTIONS(2342),
    [anon_sym_LPAREN2] = ACTIONS(2344),
    [anon_sym_BANG] = ACTIONS(2344),
    [anon_sym_TILDE] = ACTIONS(2344),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2342),
    [anon_sym_SEMI] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2342),
    [anon_sym_typedef] = ACTIONS(2342),
    [anon_sym___device__] = ACTIONS(2342),
    [anon_sym___host__] = ACTIONS(2342),
    [anon_sym___global__] = ACTIONS(2342),
    [anon_sym___forceinline__] = ACTIONS(2342),
    [anon_sym___noinline__] = ACTIONS(2342),
    [anon_sym_extern] = ACTIONS(2342),
    [anon_sym___attribute__] = ACTIONS(2342),
    [anon_sym_COLON_COLON] = ACTIONS(2344),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2344),
    [anon_sym___declspec] = ACTIONS(2342),
    [anon_sym___based] = ACTIONS(2342),
    [anon_sym___cdecl] = ACTIONS(2342),
    [anon_sym___clrcall] = ACTIONS(2342),
    [anon_sym___stdcall] = ACTIONS(2342),
    [anon_sym___fastcall] = ACTIONS(2342),
    [anon_sym___thiscall] = ACTIONS(2342),
    [anon_sym___vectorcall] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2344),
    [anon_sym_RBRACE] = ACTIONS(2344),
    [anon_sym_signed] = ACTIONS(2342),
    [anon_sym_unsigned] = ACTIONS(2342),
    [anon_sym_long] = ACTIONS(2342),
    [anon_sym_short] = ACTIONS(2342),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_static] = ACTIONS(2342),
    [anon_sym_register] = ACTIONS(2342),
    [anon_sym_inline] = ACTIONS(2342),
    [anon_sym___inline] = ACTIONS(2342),
    [anon_sym___inline__] = ACTIONS(2342),
    [anon_sym___forceinline] = ACTIONS(2342),
    [anon_sym_thread_local] = ACTIONS(2342),
    [anon_sym___thread] = ACTIONS(2342),
    [anon_sym_const] = ACTIONS(2342),
    [anon_sym_constexpr] = ACTIONS(2342),
    [anon_sym_volatile] = ACTIONS(2342),
    [anon_sym_restrict] = ACTIONS(2342),
    [anon_sym___restrict__] = ACTIONS(2342),
    [anon_sym__Atomic] = ACTIONS(2342),
    [anon_sym__Noreturn] = ACTIONS(2342),
    [anon_sym_noreturn] = ACTIONS(2342),
    [anon_sym_mutable] = ACTIONS(2342),
    [anon_sym_constinit] = ACTIONS(2342),
    [anon_sym_consteval] = ACTIONS(2342),
    [anon_sym___shared__] = ACTIONS(2342),
    [anon_sym___local__] = ACTIONS(2342),
    [anon_sym___constant__] = ACTIONS(2342),
    [anon_sym___managed__] = ACTIONS(2342),
    [anon_sym___grid_constant__] = ACTIONS(2342),
    [anon_sym_alignas] = ACTIONS(2342),
    [anon_sym__Alignas] = ACTIONS(2342),
    [sym_primitive_type] = ACTIONS(2342),
    [anon_sym_enum] = ACTIONS(2342),
    [anon_sym_class] = ACTIONS(2342),
    [anon_sym_struct] = ACTIONS(2342),
    [anon_sym_union] = ACTIONS(2342),
    [anon_sym_if] = ACTIONS(2342),
    [anon_sym_switch] = ACTIONS(2342),
    [anon_sym_case] = ACTIONS(2342),
    [anon_sym_default] = ACTIONS(2342),
    [anon_sym_while] = ACTIONS(2342),
    [anon_sym_do] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2342),
    [anon_sym_return] = ACTIONS(2342),
    [anon_sym_break] = ACTIONS(2342),
    [anon_sym_continue] = ACTIONS(2342),
    [anon_sym_goto] = ACTIONS(2342),
    [anon_sym___try] = ACTIONS(2342),
    [anon_sym___leave] = ACTIONS(2342),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2344),
    [anon_sym_PLUS_PLUS] = ACTIONS(2344),
    [anon_sym_sizeof] = ACTIONS(2342),
    [anon_sym___alignof__] = ACTIONS(2342),
    [anon_sym___alignof] = ACTIONS(2342),
    [anon_sym__alignof] = ACTIONS(2342),
    [anon_sym_alignof] = ACTIONS(2342),
    [anon_sym__Alignof] = ACTIONS(2342),
    [anon_sym_offsetof] = ACTIONS(2342),
    [anon_sym__Generic] = ACTIONS(2342),
    [anon_sym_asm] = ACTIONS(2342),
    [anon_sym___asm__] = ACTIONS(2342),
    [sym_number_literal] = ACTIONS(2344),
    [anon_sym_L_SQUOTE] = ACTIONS(2344),
    [anon_sym_u_SQUOTE] = ACTIONS(2344),
    [anon_sym_U_SQUOTE] = ACTIONS(2344),
    [anon_sym_u8_SQUOTE] = ACTIONS(2344),
    [anon_sym_SQUOTE] = ACTIONS(2344),
    [anon_sym_L_DQUOTE] = ACTIONS(2344),
    [anon_sym_u_DQUOTE] = ACTIONS(2344),
    [anon_sym_U_DQUOTE] = ACTIONS(2344),
    [anon_sym_u8_DQUOTE] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [sym_true] = ACTIONS(2342),
    [sym_false] = ACTIONS(2342),
    [anon_sym_NULL] = ACTIONS(2342),
    [anon_sym_nullptr] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2342),
    [anon_sym_decltype] = ACTIONS(2342),
    [sym_virtual] = ACTIONS(2342),
    [anon_sym_explicit] = ACTIONS(2342),
    [anon_sym_typename] = ACTIONS(2342),
    [anon_sym_template] = ACTIONS(2342),
    [anon_sym_operator] = ACTIONS(2342),
    [anon_sym_try] = ACTIONS(2342),
    [anon_sym_delete] = ACTIONS(2342),
    [anon_sym_throw] = ACTIONS(2342),
    [anon_sym_namespace] = ACTIONS(2342),
    [anon_sym_using] = ACTIONS(2342),
    [anon_sym_static_assert] = ACTIONS(2342),
    [anon_sym_concept] = ACTIONS(2342),
    [anon_sym_co_return] = ACTIONS(2342),
    [anon_sym_co_yield] = ACTIONS(2342),
    [anon_sym_R_DQUOTE] = ACTIONS(2344),
    [anon_sym_LR_DQUOTE] = ACTIONS(2344),
    [anon_sym_uR_DQUOTE] = ACTIONS(2344),
    [anon_sym_UR_DQUOTE] = ACTIONS(2344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2344),
    [anon_sym_co_await] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2342),
    [anon_sym_requires] = ACTIONS(2342),
    [sym_this] = ACTIONS(2342),
    [anon_sym___launch_bounds__] = ACTIONS(2342),
  },
  [564] = {
    [sym_type_qualifier] = STATE(3531),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4591),
    [sym_sized_type_specifier] = STATE(2599),
    [sym_enum_specifier] = STATE(2599),
    [sym_struct_specifier] = STATE(2599),
    [sym_union_specifier] = STATE(2599),
    [sym_expression] = STATE(4646),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_type_descriptor] = STATE(7138),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_placeholder_type_specifier] = STATE(2599),
    [sym_decltype_auto] = STATE(2598),
    [sym_decltype] = STATE(2477),
    [sym_class_specifier] = STATE(2599),
    [sym__class_name] = STATE(8015),
    [sym_dependent_type] = STATE(2599),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_type_parameter_pack_expansion] = STATE(7703),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5910),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [aux_sym__type_definition_type_repeat1] = STATE(3531),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2157),
    [sym_identifier] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2725),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2729),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2733),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2757),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2761),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_GT2] = ACTIONS(2821),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [565] = {
    [sym_identifier] = ACTIONS(2370),
    [aux_sym_preproc_include_token1] = ACTIONS(2370),
    [aux_sym_preproc_def_token1] = ACTIONS(2370),
    [aux_sym_preproc_if_token1] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2370),
    [sym_preproc_directive] = ACTIONS(2370),
    [anon_sym_LPAREN2] = ACTIONS(2372),
    [anon_sym_BANG] = ACTIONS(2372),
    [anon_sym_TILDE] = ACTIONS(2372),
    [anon_sym_DASH] = ACTIONS(2370),
    [anon_sym_PLUS] = ACTIONS(2370),
    [anon_sym_STAR] = ACTIONS(2372),
    [anon_sym_AMP_AMP] = ACTIONS(2372),
    [anon_sym_AMP] = ACTIONS(2370),
    [anon_sym_SEMI] = ACTIONS(2372),
    [anon_sym___extension__] = ACTIONS(2370),
    [anon_sym_typedef] = ACTIONS(2370),
    [anon_sym___device__] = ACTIONS(2370),
    [anon_sym___host__] = ACTIONS(2370),
    [anon_sym___global__] = ACTIONS(2370),
    [anon_sym___forceinline__] = ACTIONS(2370),
    [anon_sym___noinline__] = ACTIONS(2370),
    [anon_sym_extern] = ACTIONS(2370),
    [anon_sym___attribute__] = ACTIONS(2370),
    [anon_sym_COLON_COLON] = ACTIONS(2372),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2372),
    [anon_sym___declspec] = ACTIONS(2370),
    [anon_sym___based] = ACTIONS(2370),
    [anon_sym___cdecl] = ACTIONS(2370),
    [anon_sym___clrcall] = ACTIONS(2370),
    [anon_sym___stdcall] = ACTIONS(2370),
    [anon_sym___fastcall] = ACTIONS(2370),
    [anon_sym___thiscall] = ACTIONS(2370),
    [anon_sym___vectorcall] = ACTIONS(2370),
    [anon_sym_LBRACE] = ACTIONS(2372),
    [anon_sym_RBRACE] = ACTIONS(2372),
    [anon_sym_signed] = ACTIONS(2370),
    [anon_sym_unsigned] = ACTIONS(2370),
    [anon_sym_long] = ACTIONS(2370),
    [anon_sym_short] = ACTIONS(2370),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_static] = ACTIONS(2370),
    [anon_sym_register] = ACTIONS(2370),
    [anon_sym_inline] = ACTIONS(2370),
    [anon_sym___inline] = ACTIONS(2370),
    [anon_sym___inline__] = ACTIONS(2370),
    [anon_sym___forceinline] = ACTIONS(2370),
    [anon_sym_thread_local] = ACTIONS(2370),
    [anon_sym___thread] = ACTIONS(2370),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_constexpr] = ACTIONS(2370),
    [anon_sym_volatile] = ACTIONS(2370),
    [anon_sym_restrict] = ACTIONS(2370),
    [anon_sym___restrict__] = ACTIONS(2370),
    [anon_sym__Atomic] = ACTIONS(2370),
    [anon_sym__Noreturn] = ACTIONS(2370),
    [anon_sym_noreturn] = ACTIONS(2370),
    [anon_sym_mutable] = ACTIONS(2370),
    [anon_sym_constinit] = ACTIONS(2370),
    [anon_sym_consteval] = ACTIONS(2370),
    [anon_sym___shared__] = ACTIONS(2370),
    [anon_sym___local__] = ACTIONS(2370),
    [anon_sym___constant__] = ACTIONS(2370),
    [anon_sym___managed__] = ACTIONS(2370),
    [anon_sym___grid_constant__] = ACTIONS(2370),
    [anon_sym_alignas] = ACTIONS(2370),
    [anon_sym__Alignas] = ACTIONS(2370),
    [sym_primitive_type] = ACTIONS(2370),
    [anon_sym_enum] = ACTIONS(2370),
    [anon_sym_class] = ACTIONS(2370),
    [anon_sym_struct] = ACTIONS(2370),
    [anon_sym_union] = ACTIONS(2370),
    [anon_sym_if] = ACTIONS(2370),
    [anon_sym_switch] = ACTIONS(2370),
    [anon_sym_case] = ACTIONS(2370),
    [anon_sym_default] = ACTIONS(2370),
    [anon_sym_while] = ACTIONS(2370),
    [anon_sym_do] = ACTIONS(2370),
    [anon_sym_for] = ACTIONS(2370),
    [anon_sym_return] = ACTIONS(2370),
    [anon_sym_break] = ACTIONS(2370),
    [anon_sym_continue] = ACTIONS(2370),
    [anon_sym_goto] = ACTIONS(2370),
    [anon_sym___try] = ACTIONS(2370),
    [anon_sym___leave] = ACTIONS(2370),
    [anon_sym_not] = ACTIONS(2370),
    [anon_sym_compl] = ACTIONS(2370),
    [anon_sym_DASH_DASH] = ACTIONS(2372),
    [anon_sym_PLUS_PLUS] = ACTIONS(2372),
    [anon_sym_sizeof] = ACTIONS(2370),
    [anon_sym___alignof__] = ACTIONS(2370),
    [anon_sym___alignof] = ACTIONS(2370),
    [anon_sym__alignof] = ACTIONS(2370),
    [anon_sym_alignof] = ACTIONS(2370),
    [anon_sym__Alignof] = ACTIONS(2370),
    [anon_sym_offsetof] = ACTIONS(2370),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2370),
    [anon_sym___asm__] = ACTIONS(2370),
    [sym_number_literal] = ACTIONS(2372),
    [anon_sym_L_SQUOTE] = ACTIONS(2372),
    [anon_sym_u_SQUOTE] = ACTIONS(2372),
    [anon_sym_U_SQUOTE] = ACTIONS(2372),
    [anon_sym_u8_SQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [anon_sym_L_DQUOTE] = ACTIONS(2372),
    [anon_sym_u_DQUOTE] = ACTIONS(2372),
    [anon_sym_U_DQUOTE] = ACTIONS(2372),
    [anon_sym_u8_DQUOTE] = ACTIONS(2372),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [sym_true] = ACTIONS(2370),
    [sym_false] = ACTIONS(2370),
    [anon_sym_NULL] = ACTIONS(2370),
    [anon_sym_nullptr] = ACTIONS(2370),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2370),
    [anon_sym_decltype] = ACTIONS(2370),
    [sym_virtual] = ACTIONS(2370),
    [anon_sym_explicit] = ACTIONS(2370),
    [anon_sym_typename] = ACTIONS(2370),
    [anon_sym_template] = ACTIONS(2370),
    [anon_sym_operator] = ACTIONS(2370),
    [anon_sym_try] = ACTIONS(2370),
    [anon_sym_delete] = ACTIONS(2370),
    [anon_sym_throw] = ACTIONS(2370),
    [anon_sym_namespace] = ACTIONS(2370),
    [anon_sym_using] = ACTIONS(2370),
    [anon_sym_static_assert] = ACTIONS(2370),
    [anon_sym_concept] = ACTIONS(2370),
    [anon_sym_co_return] = ACTIONS(2370),
    [anon_sym_co_yield] = ACTIONS(2370),
    [anon_sym_R_DQUOTE] = ACTIONS(2372),
    [anon_sym_LR_DQUOTE] = ACTIONS(2372),
    [anon_sym_uR_DQUOTE] = ACTIONS(2372),
    [anon_sym_UR_DQUOTE] = ACTIONS(2372),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2372),
    [anon_sym_co_await] = ACTIONS(2370),
    [anon_sym_new] = ACTIONS(2370),
    [anon_sym_requires] = ACTIONS(2370),
    [sym_this] = ACTIONS(2370),
    [anon_sym___launch_bounds__] = ACTIONS(2370),
  },
  [566] = {
    [sym_identifier] = ACTIONS(2166),
    [aux_sym_preproc_include_token1] = ACTIONS(2166),
    [aux_sym_preproc_def_token1] = ACTIONS(2166),
    [aux_sym_preproc_if_token1] = ACTIONS(2166),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2166),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2166),
    [sym_preproc_directive] = ACTIONS(2166),
    [anon_sym_LPAREN2] = ACTIONS(2169),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2169),
    [anon_sym_DASH] = ACTIONS(2166),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_AMP_AMP] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2166),
    [anon_sym_SEMI] = ACTIONS(2169),
    [anon_sym___extension__] = ACTIONS(2166),
    [anon_sym_typedef] = ACTIONS(2166),
    [anon_sym___device__] = ACTIONS(2166),
    [anon_sym___host__] = ACTIONS(2166),
    [anon_sym___global__] = ACTIONS(2166),
    [anon_sym___forceinline__] = ACTIONS(2166),
    [anon_sym___noinline__] = ACTIONS(2166),
    [anon_sym_extern] = ACTIONS(2166),
    [anon_sym___attribute__] = ACTIONS(2166),
    [anon_sym_COLON_COLON] = ACTIONS(2169),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2169),
    [anon_sym___declspec] = ACTIONS(2166),
    [anon_sym___based] = ACTIONS(2166),
    [anon_sym___cdecl] = ACTIONS(2166),
    [anon_sym___clrcall] = ACTIONS(2166),
    [anon_sym___stdcall] = ACTIONS(2166),
    [anon_sym___fastcall] = ACTIONS(2166),
    [anon_sym___thiscall] = ACTIONS(2166),
    [anon_sym___vectorcall] = ACTIONS(2166),
    [anon_sym_LBRACE] = ACTIONS(2169),
    [anon_sym_RBRACE] = ACTIONS(2169),
    [anon_sym_signed] = ACTIONS(2166),
    [anon_sym_unsigned] = ACTIONS(2166),
    [anon_sym_long] = ACTIONS(2166),
    [anon_sym_short] = ACTIONS(2166),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [anon_sym_static] = ACTIONS(2166),
    [anon_sym_register] = ACTIONS(2166),
    [anon_sym_inline] = ACTIONS(2166),
    [anon_sym___inline] = ACTIONS(2166),
    [anon_sym___inline__] = ACTIONS(2166),
    [anon_sym___forceinline] = ACTIONS(2166),
    [anon_sym_thread_local] = ACTIONS(2166),
    [anon_sym___thread] = ACTIONS(2166),
    [anon_sym_const] = ACTIONS(2166),
    [anon_sym_constexpr] = ACTIONS(2166),
    [anon_sym_volatile] = ACTIONS(2166),
    [anon_sym_restrict] = ACTIONS(2166),
    [anon_sym___restrict__] = ACTIONS(2166),
    [anon_sym__Atomic] = ACTIONS(2166),
    [anon_sym__Noreturn] = ACTIONS(2166),
    [anon_sym_noreturn] = ACTIONS(2166),
    [anon_sym_mutable] = ACTIONS(2166),
    [anon_sym_constinit] = ACTIONS(2166),
    [anon_sym_consteval] = ACTIONS(2166),
    [anon_sym___shared__] = ACTIONS(2166),
    [anon_sym___local__] = ACTIONS(2166),
    [anon_sym___constant__] = ACTIONS(2166),
    [anon_sym___managed__] = ACTIONS(2166),
    [anon_sym___grid_constant__] = ACTIONS(2166),
    [anon_sym_alignas] = ACTIONS(2166),
    [anon_sym__Alignas] = ACTIONS(2166),
    [sym_primitive_type] = ACTIONS(2166),
    [anon_sym_enum] = ACTIONS(2166),
    [anon_sym_class] = ACTIONS(2166),
    [anon_sym_struct] = ACTIONS(2166),
    [anon_sym_union] = ACTIONS(2166),
    [anon_sym_if] = ACTIONS(2166),
    [anon_sym_switch] = ACTIONS(2166),
    [anon_sym_case] = ACTIONS(2166),
    [anon_sym_default] = ACTIONS(2166),
    [anon_sym_while] = ACTIONS(2166),
    [anon_sym_do] = ACTIONS(2166),
    [anon_sym_for] = ACTIONS(2166),
    [anon_sym_return] = ACTIONS(2166),
    [anon_sym_break] = ACTIONS(2166),
    [anon_sym_continue] = ACTIONS(2166),
    [anon_sym_goto] = ACTIONS(2166),
    [anon_sym___try] = ACTIONS(2166),
    [anon_sym___leave] = ACTIONS(2166),
    [anon_sym_not] = ACTIONS(2166),
    [anon_sym_compl] = ACTIONS(2166),
    [anon_sym_DASH_DASH] = ACTIONS(2169),
    [anon_sym_PLUS_PLUS] = ACTIONS(2169),
    [anon_sym_sizeof] = ACTIONS(2166),
    [anon_sym___alignof__] = ACTIONS(2166),
    [anon_sym___alignof] = ACTIONS(2166),
    [anon_sym__alignof] = ACTIONS(2166),
    [anon_sym_alignof] = ACTIONS(2166),
    [anon_sym__Alignof] = ACTIONS(2166),
    [anon_sym_offsetof] = ACTIONS(2166),
    [anon_sym__Generic] = ACTIONS(2166),
    [anon_sym_asm] = ACTIONS(2166),
    [anon_sym___asm__] = ACTIONS(2166),
    [sym_number_literal] = ACTIONS(2169),
    [anon_sym_L_SQUOTE] = ACTIONS(2169),
    [anon_sym_u_SQUOTE] = ACTIONS(2169),
    [anon_sym_U_SQUOTE] = ACTIONS(2169),
    [anon_sym_u8_SQUOTE] = ACTIONS(2169),
    [anon_sym_SQUOTE] = ACTIONS(2169),
    [anon_sym_L_DQUOTE] = ACTIONS(2169),
    [anon_sym_u_DQUOTE] = ACTIONS(2169),
    [anon_sym_U_DQUOTE] = ACTIONS(2169),
    [anon_sym_u8_DQUOTE] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2169),
    [sym_true] = ACTIONS(2166),
    [sym_false] = ACTIONS(2166),
    [anon_sym_NULL] = ACTIONS(2166),
    [anon_sym_nullptr] = ACTIONS(2166),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2166),
    [anon_sym_decltype] = ACTIONS(2166),
    [sym_virtual] = ACTIONS(2166),
    [anon_sym_explicit] = ACTIONS(2166),
    [anon_sym_typename] = ACTIONS(2166),
    [anon_sym_template] = ACTIONS(2166),
    [anon_sym_operator] = ACTIONS(2166),
    [anon_sym_try] = ACTIONS(2166),
    [anon_sym_delete] = ACTIONS(2166),
    [anon_sym_throw] = ACTIONS(2166),
    [anon_sym_namespace] = ACTIONS(2166),
    [anon_sym_using] = ACTIONS(2166),
    [anon_sym_static_assert] = ACTIONS(2166),
    [anon_sym_concept] = ACTIONS(2166),
    [anon_sym_co_return] = ACTIONS(2166),
    [anon_sym_co_yield] = ACTIONS(2166),
    [anon_sym_R_DQUOTE] = ACTIONS(2169),
    [anon_sym_LR_DQUOTE] = ACTIONS(2169),
    [anon_sym_uR_DQUOTE] = ACTIONS(2169),
    [anon_sym_UR_DQUOTE] = ACTIONS(2169),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2169),
    [anon_sym_co_await] = ACTIONS(2166),
    [anon_sym_new] = ACTIONS(2166),
    [anon_sym_requires] = ACTIONS(2166),
    [sym_this] = ACTIONS(2166),
    [anon_sym___launch_bounds__] = ACTIONS(2166),
  },
  [567] = {
    [sym_identifier] = ACTIONS(2384),
    [aux_sym_preproc_include_token1] = ACTIONS(2384),
    [aux_sym_preproc_def_token1] = ACTIONS(2384),
    [aux_sym_preproc_if_token1] = ACTIONS(2384),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2384),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2384),
    [sym_preproc_directive] = ACTIONS(2384),
    [anon_sym_LPAREN2] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2386),
    [anon_sym_TILDE] = ACTIONS(2386),
    [anon_sym_DASH] = ACTIONS(2384),
    [anon_sym_PLUS] = ACTIONS(2384),
    [anon_sym_STAR] = ACTIONS(2386),
    [anon_sym_AMP_AMP] = ACTIONS(2386),
    [anon_sym_AMP] = ACTIONS(2384),
    [anon_sym_SEMI] = ACTIONS(2386),
    [anon_sym___extension__] = ACTIONS(2384),
    [anon_sym_typedef] = ACTIONS(2384),
    [anon_sym___device__] = ACTIONS(2384),
    [anon_sym___host__] = ACTIONS(2384),
    [anon_sym___global__] = ACTIONS(2384),
    [anon_sym___forceinline__] = ACTIONS(2384),
    [anon_sym___noinline__] = ACTIONS(2384),
    [anon_sym_extern] = ACTIONS(2384),
    [anon_sym___attribute__] = ACTIONS(2384),
    [anon_sym_COLON_COLON] = ACTIONS(2386),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2386),
    [anon_sym___declspec] = ACTIONS(2384),
    [anon_sym___based] = ACTIONS(2384),
    [anon_sym___cdecl] = ACTIONS(2384),
    [anon_sym___clrcall] = ACTIONS(2384),
    [anon_sym___stdcall] = ACTIONS(2384),
    [anon_sym___fastcall] = ACTIONS(2384),
    [anon_sym___thiscall] = ACTIONS(2384),
    [anon_sym___vectorcall] = ACTIONS(2384),
    [anon_sym_LBRACE] = ACTIONS(2386),
    [anon_sym_RBRACE] = ACTIONS(2386),
    [anon_sym_signed] = ACTIONS(2384),
    [anon_sym_unsigned] = ACTIONS(2384),
    [anon_sym_long] = ACTIONS(2384),
    [anon_sym_short] = ACTIONS(2384),
    [anon_sym_LBRACK] = ACTIONS(2384),
    [anon_sym_static] = ACTIONS(2384),
    [anon_sym_register] = ACTIONS(2384),
    [anon_sym_inline] = ACTIONS(2384),
    [anon_sym___inline] = ACTIONS(2384),
    [anon_sym___inline__] = ACTIONS(2384),
    [anon_sym___forceinline] = ACTIONS(2384),
    [anon_sym_thread_local] = ACTIONS(2384),
    [anon_sym___thread] = ACTIONS(2384),
    [anon_sym_const] = ACTIONS(2384),
    [anon_sym_constexpr] = ACTIONS(2384),
    [anon_sym_volatile] = ACTIONS(2384),
    [anon_sym_restrict] = ACTIONS(2384),
    [anon_sym___restrict__] = ACTIONS(2384),
    [anon_sym__Atomic] = ACTIONS(2384),
    [anon_sym__Noreturn] = ACTIONS(2384),
    [anon_sym_noreturn] = ACTIONS(2384),
    [anon_sym_mutable] = ACTIONS(2384),
    [anon_sym_constinit] = ACTIONS(2384),
    [anon_sym_consteval] = ACTIONS(2384),
    [anon_sym___shared__] = ACTIONS(2384),
    [anon_sym___local__] = ACTIONS(2384),
    [anon_sym___constant__] = ACTIONS(2384),
    [anon_sym___managed__] = ACTIONS(2384),
    [anon_sym___grid_constant__] = ACTIONS(2384),
    [anon_sym_alignas] = ACTIONS(2384),
    [anon_sym__Alignas] = ACTIONS(2384),
    [sym_primitive_type] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2384),
    [anon_sym_class] = ACTIONS(2384),
    [anon_sym_struct] = ACTIONS(2384),
    [anon_sym_union] = ACTIONS(2384),
    [anon_sym_if] = ACTIONS(2384),
    [anon_sym_switch] = ACTIONS(2384),
    [anon_sym_case] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2384),
    [anon_sym_while] = ACTIONS(2384),
    [anon_sym_do] = ACTIONS(2384),
    [anon_sym_for] = ACTIONS(2384),
    [anon_sym_return] = ACTIONS(2384),
    [anon_sym_break] = ACTIONS(2384),
    [anon_sym_continue] = ACTIONS(2384),
    [anon_sym_goto] = ACTIONS(2384),
    [anon_sym___try] = ACTIONS(2384),
    [anon_sym___leave] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_compl] = ACTIONS(2384),
    [anon_sym_DASH_DASH] = ACTIONS(2386),
    [anon_sym_PLUS_PLUS] = ACTIONS(2386),
    [anon_sym_sizeof] = ACTIONS(2384),
    [anon_sym___alignof__] = ACTIONS(2384),
    [anon_sym___alignof] = ACTIONS(2384),
    [anon_sym__alignof] = ACTIONS(2384),
    [anon_sym_alignof] = ACTIONS(2384),
    [anon_sym__Alignof] = ACTIONS(2384),
    [anon_sym_offsetof] = ACTIONS(2384),
    [anon_sym__Generic] = ACTIONS(2384),
    [anon_sym_asm] = ACTIONS(2384),
    [anon_sym___asm__] = ACTIONS(2384),
    [sym_number_literal] = ACTIONS(2386),
    [anon_sym_L_SQUOTE] = ACTIONS(2386),
    [anon_sym_u_SQUOTE] = ACTIONS(2386),
    [anon_sym_U_SQUOTE] = ACTIONS(2386),
    [anon_sym_u8_SQUOTE] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2386),
    [anon_sym_L_DQUOTE] = ACTIONS(2386),
    [anon_sym_u_DQUOTE] = ACTIONS(2386),
    [anon_sym_U_DQUOTE] = ACTIONS(2386),
    [anon_sym_u8_DQUOTE] = ACTIONS(2386),
    [anon_sym_DQUOTE] = ACTIONS(2386),
    [sym_true] = ACTIONS(2384),
    [sym_false] = ACTIONS(2384),
    [anon_sym_NULL] = ACTIONS(2384),
    [anon_sym_nullptr] = ACTIONS(2384),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2384),
    [anon_sym_decltype] = ACTIONS(2384),
    [sym_virtual] = ACTIONS(2384),
    [anon_sym_explicit] = ACTIONS(2384),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(2384),
    [anon_sym_operator] = ACTIONS(2384),
    [anon_sym_try] = ACTIONS(2384),
    [anon_sym_delete] = ACTIONS(2384),
    [anon_sym_throw] = ACTIONS(2384),
    [anon_sym_namespace] = ACTIONS(2384),
    [anon_sym_using] = ACTIONS(2384),
    [anon_sym_static_assert] = ACTIONS(2384),
    [anon_sym_concept] = ACTIONS(2384),
    [anon_sym_co_return] = ACTIONS(2384),
    [anon_sym_co_yield] = ACTIONS(2384),
    [anon_sym_R_DQUOTE] = ACTIONS(2386),
    [anon_sym_LR_DQUOTE] = ACTIONS(2386),
    [anon_sym_uR_DQUOTE] = ACTIONS(2386),
    [anon_sym_UR_DQUOTE] = ACTIONS(2386),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2386),
    [anon_sym_co_await] = ACTIONS(2384),
    [anon_sym_new] = ACTIONS(2384),
    [anon_sym_requires] = ACTIONS(2384),
    [sym_this] = ACTIONS(2384),
    [anon_sym___launch_bounds__] = ACTIONS(2384),
  },
  [568] = {
    [sym_identifier] = ACTIONS(2384),
    [aux_sym_preproc_include_token1] = ACTIONS(2384),
    [aux_sym_preproc_def_token1] = ACTIONS(2384),
    [aux_sym_preproc_if_token1] = ACTIONS(2384),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2384),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2384),
    [sym_preproc_directive] = ACTIONS(2384),
    [anon_sym_LPAREN2] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2386),
    [anon_sym_TILDE] = ACTIONS(2386),
    [anon_sym_DASH] = ACTIONS(2384),
    [anon_sym_PLUS] = ACTIONS(2384),
    [anon_sym_STAR] = ACTIONS(2386),
    [anon_sym_AMP_AMP] = ACTIONS(2386),
    [anon_sym_AMP] = ACTIONS(2384),
    [anon_sym_SEMI] = ACTIONS(2386),
    [anon_sym___extension__] = ACTIONS(2384),
    [anon_sym_typedef] = ACTIONS(2384),
    [anon_sym___device__] = ACTIONS(2384),
    [anon_sym___host__] = ACTIONS(2384),
    [anon_sym___global__] = ACTIONS(2384),
    [anon_sym___forceinline__] = ACTIONS(2384),
    [anon_sym___noinline__] = ACTIONS(2384),
    [anon_sym_extern] = ACTIONS(2384),
    [anon_sym___attribute__] = ACTIONS(2384),
    [anon_sym_COLON_COLON] = ACTIONS(2386),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2386),
    [anon_sym___declspec] = ACTIONS(2384),
    [anon_sym___based] = ACTIONS(2384),
    [anon_sym___cdecl] = ACTIONS(2384),
    [anon_sym___clrcall] = ACTIONS(2384),
    [anon_sym___stdcall] = ACTIONS(2384),
    [anon_sym___fastcall] = ACTIONS(2384),
    [anon_sym___thiscall] = ACTIONS(2384),
    [anon_sym___vectorcall] = ACTIONS(2384),
    [anon_sym_LBRACE] = ACTIONS(2386),
    [anon_sym_RBRACE] = ACTIONS(2386),
    [anon_sym_signed] = ACTIONS(2384),
    [anon_sym_unsigned] = ACTIONS(2384),
    [anon_sym_long] = ACTIONS(2384),
    [anon_sym_short] = ACTIONS(2384),
    [anon_sym_LBRACK] = ACTIONS(2384),
    [anon_sym_static] = ACTIONS(2384),
    [anon_sym_register] = ACTIONS(2384),
    [anon_sym_inline] = ACTIONS(2384),
    [anon_sym___inline] = ACTIONS(2384),
    [anon_sym___inline__] = ACTIONS(2384),
    [anon_sym___forceinline] = ACTIONS(2384),
    [anon_sym_thread_local] = ACTIONS(2384),
    [anon_sym___thread] = ACTIONS(2384),
    [anon_sym_const] = ACTIONS(2384),
    [anon_sym_constexpr] = ACTIONS(2384),
    [anon_sym_volatile] = ACTIONS(2384),
    [anon_sym_restrict] = ACTIONS(2384),
    [anon_sym___restrict__] = ACTIONS(2384),
    [anon_sym__Atomic] = ACTIONS(2384),
    [anon_sym__Noreturn] = ACTIONS(2384),
    [anon_sym_noreturn] = ACTIONS(2384),
    [anon_sym_mutable] = ACTIONS(2384),
    [anon_sym_constinit] = ACTIONS(2384),
    [anon_sym_consteval] = ACTIONS(2384),
    [anon_sym___shared__] = ACTIONS(2384),
    [anon_sym___local__] = ACTIONS(2384),
    [anon_sym___constant__] = ACTIONS(2384),
    [anon_sym___managed__] = ACTIONS(2384),
    [anon_sym___grid_constant__] = ACTIONS(2384),
    [anon_sym_alignas] = ACTIONS(2384),
    [anon_sym__Alignas] = ACTIONS(2384),
    [sym_primitive_type] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2384),
    [anon_sym_class] = ACTIONS(2384),
    [anon_sym_struct] = ACTIONS(2384),
    [anon_sym_union] = ACTIONS(2384),
    [anon_sym_if] = ACTIONS(2384),
    [anon_sym_switch] = ACTIONS(2384),
    [anon_sym_case] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2384),
    [anon_sym_while] = ACTIONS(2384),
    [anon_sym_do] = ACTIONS(2384),
    [anon_sym_for] = ACTIONS(2384),
    [anon_sym_return] = ACTIONS(2384),
    [anon_sym_break] = ACTIONS(2384),
    [anon_sym_continue] = ACTIONS(2384),
    [anon_sym_goto] = ACTIONS(2384),
    [anon_sym___try] = ACTIONS(2384),
    [anon_sym___leave] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_compl] = ACTIONS(2384),
    [anon_sym_DASH_DASH] = ACTIONS(2386),
    [anon_sym_PLUS_PLUS] = ACTIONS(2386),
    [anon_sym_sizeof] = ACTIONS(2384),
    [anon_sym___alignof__] = ACTIONS(2384),
    [anon_sym___alignof] = ACTIONS(2384),
    [anon_sym__alignof] = ACTIONS(2384),
    [anon_sym_alignof] = ACTIONS(2384),
    [anon_sym__Alignof] = ACTIONS(2384),
    [anon_sym_offsetof] = ACTIONS(2384),
    [anon_sym__Generic] = ACTIONS(2384),
    [anon_sym_asm] = ACTIONS(2384),
    [anon_sym___asm__] = ACTIONS(2384),
    [sym_number_literal] = ACTIONS(2386),
    [anon_sym_L_SQUOTE] = ACTIONS(2386),
    [anon_sym_u_SQUOTE] = ACTIONS(2386),
    [anon_sym_U_SQUOTE] = ACTIONS(2386),
    [anon_sym_u8_SQUOTE] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2386),
    [anon_sym_L_DQUOTE] = ACTIONS(2386),
    [anon_sym_u_DQUOTE] = ACTIONS(2386),
    [anon_sym_U_DQUOTE] = ACTIONS(2386),
    [anon_sym_u8_DQUOTE] = ACTIONS(2386),
    [anon_sym_DQUOTE] = ACTIONS(2386),
    [sym_true] = ACTIONS(2384),
    [sym_false] = ACTIONS(2384),
    [anon_sym_NULL] = ACTIONS(2384),
    [anon_sym_nullptr] = ACTIONS(2384),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2384),
    [anon_sym_decltype] = ACTIONS(2384),
    [sym_virtual] = ACTIONS(2384),
    [anon_sym_explicit] = ACTIONS(2384),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(2384),
    [anon_sym_operator] = ACTIONS(2384),
    [anon_sym_try] = ACTIONS(2384),
    [anon_sym_delete] = ACTIONS(2384),
    [anon_sym_throw] = ACTIONS(2384),
    [anon_sym_namespace] = ACTIONS(2384),
    [anon_sym_using] = ACTIONS(2384),
    [anon_sym_static_assert] = ACTIONS(2384),
    [anon_sym_concept] = ACTIONS(2384),
    [anon_sym_co_return] = ACTIONS(2384),
    [anon_sym_co_yield] = ACTIONS(2384),
    [anon_sym_R_DQUOTE] = ACTIONS(2386),
    [anon_sym_LR_DQUOTE] = ACTIONS(2386),
    [anon_sym_uR_DQUOTE] = ACTIONS(2386),
    [anon_sym_UR_DQUOTE] = ACTIONS(2386),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2386),
    [anon_sym_co_await] = ACTIONS(2384),
    [anon_sym_new] = ACTIONS(2384),
    [anon_sym_requires] = ACTIONS(2384),
    [sym_this] = ACTIONS(2384),
    [anon_sym___launch_bounds__] = ACTIONS(2384),
  },
  [569] = {
    [sym_type_qualifier] = STATE(3531),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4591),
    [sym_sized_type_specifier] = STATE(2599),
    [sym_enum_specifier] = STATE(2599),
    [sym_struct_specifier] = STATE(2599),
    [sym_union_specifier] = STATE(2599),
    [sym_expression] = STATE(4694),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_type_descriptor] = STATE(7200),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_placeholder_type_specifier] = STATE(2599),
    [sym_decltype_auto] = STATE(2598),
    [sym_decltype] = STATE(2477),
    [sym_class_specifier] = STATE(2599),
    [sym__class_name] = STATE(8015),
    [sym_dependent_type] = STATE(2599),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_type_parameter_pack_expansion] = STATE(7650),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5910),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [aux_sym__type_definition_type_repeat1] = STATE(3531),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2157),
    [sym_identifier] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2725),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2729),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2733),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2757),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2761),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_GT2] = ACTIONS(2823),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [570] = {
    [sym_identifier] = ACTIONS(2215),
    [aux_sym_preproc_include_token1] = ACTIONS(2215),
    [aux_sym_preproc_def_token1] = ACTIONS(2215),
    [aux_sym_preproc_if_token1] = ACTIONS(2215),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2215),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2215),
    [sym_preproc_directive] = ACTIONS(2215),
    [anon_sym_LPAREN2] = ACTIONS(2217),
    [anon_sym_BANG] = ACTIONS(2217),
    [anon_sym_TILDE] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2215),
    [anon_sym_PLUS] = ACTIONS(2215),
    [anon_sym_STAR] = ACTIONS(2217),
    [anon_sym_AMP_AMP] = ACTIONS(2217),
    [anon_sym_AMP] = ACTIONS(2215),
    [anon_sym_SEMI] = ACTIONS(2217),
    [anon_sym___extension__] = ACTIONS(2215),
    [anon_sym_typedef] = ACTIONS(2215),
    [anon_sym___device__] = ACTIONS(2215),
    [anon_sym___host__] = ACTIONS(2215),
    [anon_sym___global__] = ACTIONS(2215),
    [anon_sym___forceinline__] = ACTIONS(2215),
    [anon_sym___noinline__] = ACTIONS(2215),
    [anon_sym_extern] = ACTIONS(2215),
    [anon_sym___attribute__] = ACTIONS(2215),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2217),
    [anon_sym___declspec] = ACTIONS(2215),
    [anon_sym___based] = ACTIONS(2215),
    [anon_sym___cdecl] = ACTIONS(2215),
    [anon_sym___clrcall] = ACTIONS(2215),
    [anon_sym___stdcall] = ACTIONS(2215),
    [anon_sym___fastcall] = ACTIONS(2215),
    [anon_sym___thiscall] = ACTIONS(2215),
    [anon_sym___vectorcall] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_RBRACE] = ACTIONS(2217),
    [anon_sym_signed] = ACTIONS(2215),
    [anon_sym_unsigned] = ACTIONS(2215),
    [anon_sym_long] = ACTIONS(2215),
    [anon_sym_short] = ACTIONS(2215),
    [anon_sym_LBRACK] = ACTIONS(2215),
    [anon_sym_static] = ACTIONS(2215),
    [anon_sym_register] = ACTIONS(2215),
    [anon_sym_inline] = ACTIONS(2215),
    [anon_sym___inline] = ACTIONS(2215),
    [anon_sym___inline__] = ACTIONS(2215),
    [anon_sym___forceinline] = ACTIONS(2215),
    [anon_sym_thread_local] = ACTIONS(2215),
    [anon_sym___thread] = ACTIONS(2215),
    [anon_sym_const] = ACTIONS(2215),
    [anon_sym_constexpr] = ACTIONS(2215),
    [anon_sym_volatile] = ACTIONS(2215),
    [anon_sym_restrict] = ACTIONS(2215),
    [anon_sym___restrict__] = ACTIONS(2215),
    [anon_sym__Atomic] = ACTIONS(2215),
    [anon_sym__Noreturn] = ACTIONS(2215),
    [anon_sym_noreturn] = ACTIONS(2215),
    [anon_sym_mutable] = ACTIONS(2215),
    [anon_sym_constinit] = ACTIONS(2215),
    [anon_sym_consteval] = ACTIONS(2215),
    [anon_sym___shared__] = ACTIONS(2215),
    [anon_sym___local__] = ACTIONS(2215),
    [anon_sym___constant__] = ACTIONS(2215),
    [anon_sym___managed__] = ACTIONS(2215),
    [anon_sym___grid_constant__] = ACTIONS(2215),
    [anon_sym_alignas] = ACTIONS(2215),
    [anon_sym__Alignas] = ACTIONS(2215),
    [sym_primitive_type] = ACTIONS(2215),
    [anon_sym_enum] = ACTIONS(2215),
    [anon_sym_class] = ACTIONS(2215),
    [anon_sym_struct] = ACTIONS(2215),
    [anon_sym_union] = ACTIONS(2215),
    [anon_sym_if] = ACTIONS(2215),
    [anon_sym_switch] = ACTIONS(2215),
    [anon_sym_case] = ACTIONS(2215),
    [anon_sym_default] = ACTIONS(2215),
    [anon_sym_while] = ACTIONS(2215),
    [anon_sym_do] = ACTIONS(2215),
    [anon_sym_for] = ACTIONS(2215),
    [anon_sym_return] = ACTIONS(2215),
    [anon_sym_break] = ACTIONS(2215),
    [anon_sym_continue] = ACTIONS(2215),
    [anon_sym_goto] = ACTIONS(2215),
    [anon_sym___try] = ACTIONS(2215),
    [anon_sym___leave] = ACTIONS(2215),
    [anon_sym_not] = ACTIONS(2215),
    [anon_sym_compl] = ACTIONS(2215),
    [anon_sym_DASH_DASH] = ACTIONS(2217),
    [anon_sym_PLUS_PLUS] = ACTIONS(2217),
    [anon_sym_sizeof] = ACTIONS(2215),
    [anon_sym___alignof__] = ACTIONS(2215),
    [anon_sym___alignof] = ACTIONS(2215),
    [anon_sym__alignof] = ACTIONS(2215),
    [anon_sym_alignof] = ACTIONS(2215),
    [anon_sym__Alignof] = ACTIONS(2215),
    [anon_sym_offsetof] = ACTIONS(2215),
    [anon_sym__Generic] = ACTIONS(2215),
    [anon_sym_asm] = ACTIONS(2215),
    [anon_sym___asm__] = ACTIONS(2215),
    [sym_number_literal] = ACTIONS(2217),
    [anon_sym_L_SQUOTE] = ACTIONS(2217),
    [anon_sym_u_SQUOTE] = ACTIONS(2217),
    [anon_sym_U_SQUOTE] = ACTIONS(2217),
    [anon_sym_u8_SQUOTE] = ACTIONS(2217),
    [anon_sym_SQUOTE] = ACTIONS(2217),
    [anon_sym_L_DQUOTE] = ACTIONS(2217),
    [anon_sym_u_DQUOTE] = ACTIONS(2217),
    [anon_sym_U_DQUOTE] = ACTIONS(2217),
    [anon_sym_u8_DQUOTE] = ACTIONS(2217),
    [anon_sym_DQUOTE] = ACTIONS(2217),
    [sym_true] = ACTIONS(2215),
    [sym_false] = ACTIONS(2215),
    [anon_sym_NULL] = ACTIONS(2215),
    [anon_sym_nullptr] = ACTIONS(2215),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2215),
    [anon_sym_decltype] = ACTIONS(2215),
    [sym_virtual] = ACTIONS(2215),
    [anon_sym_explicit] = ACTIONS(2215),
    [anon_sym_typename] = ACTIONS(2215),
    [anon_sym_template] = ACTIONS(2215),
    [anon_sym_operator] = ACTIONS(2215),
    [anon_sym_try] = ACTIONS(2215),
    [anon_sym_delete] = ACTIONS(2215),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_namespace] = ACTIONS(2215),
    [anon_sym_using] = ACTIONS(2215),
    [anon_sym_static_assert] = ACTIONS(2215),
    [anon_sym_concept] = ACTIONS(2215),
    [anon_sym_co_return] = ACTIONS(2215),
    [anon_sym_co_yield] = ACTIONS(2215),
    [anon_sym_R_DQUOTE] = ACTIONS(2217),
    [anon_sym_LR_DQUOTE] = ACTIONS(2217),
    [anon_sym_uR_DQUOTE] = ACTIONS(2217),
    [anon_sym_UR_DQUOTE] = ACTIONS(2217),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2217),
    [anon_sym_co_await] = ACTIONS(2215),
    [anon_sym_new] = ACTIONS(2215),
    [anon_sym_requires] = ACTIONS(2215),
    [sym_this] = ACTIONS(2215),
    [anon_sym___launch_bounds__] = ACTIONS(2215),
  },
  [571] = {
    [sym_identifier] = ACTIONS(2094),
    [aux_sym_preproc_include_token1] = ACTIONS(2094),
    [aux_sym_preproc_def_token1] = ACTIONS(2094),
    [aux_sym_preproc_if_token1] = ACTIONS(2094),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2094),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2094),
    [sym_preproc_directive] = ACTIONS(2094),
    [anon_sym_LPAREN2] = ACTIONS(2096),
    [anon_sym_BANG] = ACTIONS(2096),
    [anon_sym_TILDE] = ACTIONS(2096),
    [anon_sym_DASH] = ACTIONS(2094),
    [anon_sym_PLUS] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(2096),
    [anon_sym_AMP_AMP] = ACTIONS(2096),
    [anon_sym_AMP] = ACTIONS(2094),
    [anon_sym_SEMI] = ACTIONS(2096),
    [anon_sym___extension__] = ACTIONS(2094),
    [anon_sym_typedef] = ACTIONS(2094),
    [anon_sym___device__] = ACTIONS(2094),
    [anon_sym___host__] = ACTIONS(2094),
    [anon_sym___global__] = ACTIONS(2094),
    [anon_sym___forceinline__] = ACTIONS(2094),
    [anon_sym___noinline__] = ACTIONS(2094),
    [anon_sym_extern] = ACTIONS(2094),
    [anon_sym___attribute__] = ACTIONS(2094),
    [anon_sym_COLON_COLON] = ACTIONS(2096),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2096),
    [anon_sym___declspec] = ACTIONS(2094),
    [anon_sym___based] = ACTIONS(2094),
    [anon_sym___cdecl] = ACTIONS(2094),
    [anon_sym___clrcall] = ACTIONS(2094),
    [anon_sym___stdcall] = ACTIONS(2094),
    [anon_sym___fastcall] = ACTIONS(2094),
    [anon_sym___thiscall] = ACTIONS(2094),
    [anon_sym___vectorcall] = ACTIONS(2094),
    [anon_sym_LBRACE] = ACTIONS(2096),
    [anon_sym_RBRACE] = ACTIONS(2096),
    [anon_sym_signed] = ACTIONS(2094),
    [anon_sym_unsigned] = ACTIONS(2094),
    [anon_sym_long] = ACTIONS(2094),
    [anon_sym_short] = ACTIONS(2094),
    [anon_sym_LBRACK] = ACTIONS(2094),
    [anon_sym_static] = ACTIONS(2094),
    [anon_sym_register] = ACTIONS(2094),
    [anon_sym_inline] = ACTIONS(2094),
    [anon_sym___inline] = ACTIONS(2094),
    [anon_sym___inline__] = ACTIONS(2094),
    [anon_sym___forceinline] = ACTIONS(2094),
    [anon_sym_thread_local] = ACTIONS(2094),
    [anon_sym___thread] = ACTIONS(2094),
    [anon_sym_const] = ACTIONS(2094),
    [anon_sym_constexpr] = ACTIONS(2094),
    [anon_sym_volatile] = ACTIONS(2094),
    [anon_sym_restrict] = ACTIONS(2094),
    [anon_sym___restrict__] = ACTIONS(2094),
    [anon_sym__Atomic] = ACTIONS(2094),
    [anon_sym__Noreturn] = ACTIONS(2094),
    [anon_sym_noreturn] = ACTIONS(2094),
    [anon_sym_mutable] = ACTIONS(2094),
    [anon_sym_constinit] = ACTIONS(2094),
    [anon_sym_consteval] = ACTIONS(2094),
    [anon_sym___shared__] = ACTIONS(2094),
    [anon_sym___local__] = ACTIONS(2094),
    [anon_sym___constant__] = ACTIONS(2094),
    [anon_sym___managed__] = ACTIONS(2094),
    [anon_sym___grid_constant__] = ACTIONS(2094),
    [anon_sym_alignas] = ACTIONS(2094),
    [anon_sym__Alignas] = ACTIONS(2094),
    [sym_primitive_type] = ACTIONS(2094),
    [anon_sym_enum] = ACTIONS(2094),
    [anon_sym_class] = ACTIONS(2094),
    [anon_sym_struct] = ACTIONS(2094),
    [anon_sym_union] = ACTIONS(2094),
    [anon_sym_if] = ACTIONS(2094),
    [anon_sym_switch] = ACTIONS(2094),
    [anon_sym_case] = ACTIONS(2094),
    [anon_sym_default] = ACTIONS(2094),
    [anon_sym_while] = ACTIONS(2094),
    [anon_sym_do] = ACTIONS(2094),
    [anon_sym_for] = ACTIONS(2094),
    [anon_sym_return] = ACTIONS(2094),
    [anon_sym_break] = ACTIONS(2094),
    [anon_sym_continue] = ACTIONS(2094),
    [anon_sym_goto] = ACTIONS(2094),
    [anon_sym___try] = ACTIONS(2094),
    [anon_sym___leave] = ACTIONS(2094),
    [anon_sym_not] = ACTIONS(2094),
    [anon_sym_compl] = ACTIONS(2094),
    [anon_sym_DASH_DASH] = ACTIONS(2096),
    [anon_sym_PLUS_PLUS] = ACTIONS(2096),
    [anon_sym_sizeof] = ACTIONS(2094),
    [anon_sym___alignof__] = ACTIONS(2094),
    [anon_sym___alignof] = ACTIONS(2094),
    [anon_sym__alignof] = ACTIONS(2094),
    [anon_sym_alignof] = ACTIONS(2094),
    [anon_sym__Alignof] = ACTIONS(2094),
    [anon_sym_offsetof] = ACTIONS(2094),
    [anon_sym__Generic] = ACTIONS(2094),
    [anon_sym_asm] = ACTIONS(2094),
    [anon_sym___asm__] = ACTIONS(2094),
    [sym_number_literal] = ACTIONS(2096),
    [anon_sym_L_SQUOTE] = ACTIONS(2096),
    [anon_sym_u_SQUOTE] = ACTIONS(2096),
    [anon_sym_U_SQUOTE] = ACTIONS(2096),
    [anon_sym_u8_SQUOTE] = ACTIONS(2096),
    [anon_sym_SQUOTE] = ACTIONS(2096),
    [anon_sym_L_DQUOTE] = ACTIONS(2096),
    [anon_sym_u_DQUOTE] = ACTIONS(2096),
    [anon_sym_U_DQUOTE] = ACTIONS(2096),
    [anon_sym_u8_DQUOTE] = ACTIONS(2096),
    [anon_sym_DQUOTE] = ACTIONS(2096),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2094),
    [anon_sym_nullptr] = ACTIONS(2094),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2094),
    [anon_sym_decltype] = ACTIONS(2094),
    [sym_virtual] = ACTIONS(2094),
    [anon_sym_explicit] = ACTIONS(2094),
    [anon_sym_typename] = ACTIONS(2094),
    [anon_sym_template] = ACTIONS(2094),
    [anon_sym_operator] = ACTIONS(2094),
    [anon_sym_try] = ACTIONS(2094),
    [anon_sym_delete] = ACTIONS(2094),
    [anon_sym_throw] = ACTIONS(2094),
    [anon_sym_namespace] = ACTIONS(2094),
    [anon_sym_using] = ACTIONS(2094),
    [anon_sym_static_assert] = ACTIONS(2094),
    [anon_sym_concept] = ACTIONS(2094),
    [anon_sym_co_return] = ACTIONS(2094),
    [anon_sym_co_yield] = ACTIONS(2094),
    [anon_sym_R_DQUOTE] = ACTIONS(2096),
    [anon_sym_LR_DQUOTE] = ACTIONS(2096),
    [anon_sym_uR_DQUOTE] = ACTIONS(2096),
    [anon_sym_UR_DQUOTE] = ACTIONS(2096),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2096),
    [anon_sym_co_await] = ACTIONS(2094),
    [anon_sym_new] = ACTIONS(2094),
    [anon_sym_requires] = ACTIONS(2094),
    [sym_this] = ACTIONS(2094),
    [anon_sym___launch_bounds__] = ACTIONS(2094),
  },
  [572] = {
    [sym_type_qualifier] = STATE(3531),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4591),
    [sym_sized_type_specifier] = STATE(2599),
    [sym_enum_specifier] = STATE(2599),
    [sym_struct_specifier] = STATE(2599),
    [sym_union_specifier] = STATE(2599),
    [sym_expression] = STATE(4626),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_type_descriptor] = STATE(7327),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_placeholder_type_specifier] = STATE(2599),
    [sym_decltype_auto] = STATE(2598),
    [sym_decltype] = STATE(2477),
    [sym_class_specifier] = STATE(2599),
    [sym__class_name] = STATE(8015),
    [sym_dependent_type] = STATE(2599),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_type_parameter_pack_expansion] = STATE(7467),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5910),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [aux_sym__type_definition_type_repeat1] = STATE(3531),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2157),
    [sym_identifier] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2725),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2729),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2733),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2757),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2761),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_GT2] = ACTIONS(2825),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [573] = {
    [sym_identifier] = ACTIONS(2388),
    [aux_sym_preproc_include_token1] = ACTIONS(2388),
    [aux_sym_preproc_def_token1] = ACTIONS(2388),
    [aux_sym_preproc_if_token1] = ACTIONS(2388),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2388),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2388),
    [sym_preproc_directive] = ACTIONS(2388),
    [anon_sym_LPAREN2] = ACTIONS(2390),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [anon_sym_DASH] = ACTIONS(2388),
    [anon_sym_PLUS] = ACTIONS(2388),
    [anon_sym_STAR] = ACTIONS(2390),
    [anon_sym_AMP_AMP] = ACTIONS(2390),
    [anon_sym_AMP] = ACTIONS(2388),
    [anon_sym_SEMI] = ACTIONS(2390),
    [anon_sym___extension__] = ACTIONS(2388),
    [anon_sym_typedef] = ACTIONS(2388),
    [anon_sym___device__] = ACTIONS(2388),
    [anon_sym___host__] = ACTIONS(2388),
    [anon_sym___global__] = ACTIONS(2388),
    [anon_sym___forceinline__] = ACTIONS(2388),
    [anon_sym___noinline__] = ACTIONS(2388),
    [anon_sym_extern] = ACTIONS(2388),
    [anon_sym___attribute__] = ACTIONS(2388),
    [anon_sym_COLON_COLON] = ACTIONS(2390),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2390),
    [anon_sym___declspec] = ACTIONS(2388),
    [anon_sym___based] = ACTIONS(2388),
    [anon_sym___cdecl] = ACTIONS(2388),
    [anon_sym___clrcall] = ACTIONS(2388),
    [anon_sym___stdcall] = ACTIONS(2388),
    [anon_sym___fastcall] = ACTIONS(2388),
    [anon_sym___thiscall] = ACTIONS(2388),
    [anon_sym___vectorcall] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2390),
    [anon_sym_RBRACE] = ACTIONS(2390),
    [anon_sym_signed] = ACTIONS(2388),
    [anon_sym_unsigned] = ACTIONS(2388),
    [anon_sym_long] = ACTIONS(2388),
    [anon_sym_short] = ACTIONS(2388),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [anon_sym_static] = ACTIONS(2388),
    [anon_sym_register] = ACTIONS(2388),
    [anon_sym_inline] = ACTIONS(2388),
    [anon_sym___inline] = ACTIONS(2388),
    [anon_sym___inline__] = ACTIONS(2388),
    [anon_sym___forceinline] = ACTIONS(2388),
    [anon_sym_thread_local] = ACTIONS(2388),
    [anon_sym___thread] = ACTIONS(2388),
    [anon_sym_const] = ACTIONS(2388),
    [anon_sym_constexpr] = ACTIONS(2388),
    [anon_sym_volatile] = ACTIONS(2388),
    [anon_sym_restrict] = ACTIONS(2388),
    [anon_sym___restrict__] = ACTIONS(2388),
    [anon_sym__Atomic] = ACTIONS(2388),
    [anon_sym__Noreturn] = ACTIONS(2388),
    [anon_sym_noreturn] = ACTIONS(2388),
    [anon_sym_mutable] = ACTIONS(2388),
    [anon_sym_constinit] = ACTIONS(2388),
    [anon_sym_consteval] = ACTIONS(2388),
    [anon_sym___shared__] = ACTIONS(2388),
    [anon_sym___local__] = ACTIONS(2388),
    [anon_sym___constant__] = ACTIONS(2388),
    [anon_sym___managed__] = ACTIONS(2388),
    [anon_sym___grid_constant__] = ACTIONS(2388),
    [anon_sym_alignas] = ACTIONS(2388),
    [anon_sym__Alignas] = ACTIONS(2388),
    [sym_primitive_type] = ACTIONS(2388),
    [anon_sym_enum] = ACTIONS(2388),
    [anon_sym_class] = ACTIONS(2388),
    [anon_sym_struct] = ACTIONS(2388),
    [anon_sym_union] = ACTIONS(2388),
    [anon_sym_if] = ACTIONS(2388),
    [anon_sym_switch] = ACTIONS(2388),
    [anon_sym_case] = ACTIONS(2388),
    [anon_sym_default] = ACTIONS(2388),
    [anon_sym_while] = ACTIONS(2388),
    [anon_sym_do] = ACTIONS(2388),
    [anon_sym_for] = ACTIONS(2388),
    [anon_sym_return] = ACTIONS(2388),
    [anon_sym_break] = ACTIONS(2388),
    [anon_sym_continue] = ACTIONS(2388),
    [anon_sym_goto] = ACTIONS(2388),
    [anon_sym___try] = ACTIONS(2388),
    [anon_sym___leave] = ACTIONS(2388),
    [anon_sym_not] = ACTIONS(2388),
    [anon_sym_compl] = ACTIONS(2388),
    [anon_sym_DASH_DASH] = ACTIONS(2390),
    [anon_sym_PLUS_PLUS] = ACTIONS(2390),
    [anon_sym_sizeof] = ACTIONS(2388),
    [anon_sym___alignof__] = ACTIONS(2388),
    [anon_sym___alignof] = ACTIONS(2388),
    [anon_sym__alignof] = ACTIONS(2388),
    [anon_sym_alignof] = ACTIONS(2388),
    [anon_sym__Alignof] = ACTIONS(2388),
    [anon_sym_offsetof] = ACTIONS(2388),
    [anon_sym__Generic] = ACTIONS(2388),
    [anon_sym_asm] = ACTIONS(2388),
    [anon_sym___asm__] = ACTIONS(2388),
    [sym_number_literal] = ACTIONS(2390),
    [anon_sym_L_SQUOTE] = ACTIONS(2390),
    [anon_sym_u_SQUOTE] = ACTIONS(2390),
    [anon_sym_U_SQUOTE] = ACTIONS(2390),
    [anon_sym_u8_SQUOTE] = ACTIONS(2390),
    [anon_sym_SQUOTE] = ACTIONS(2390),
    [anon_sym_L_DQUOTE] = ACTIONS(2390),
    [anon_sym_u_DQUOTE] = ACTIONS(2390),
    [anon_sym_U_DQUOTE] = ACTIONS(2390),
    [anon_sym_u8_DQUOTE] = ACTIONS(2390),
    [anon_sym_DQUOTE] = ACTIONS(2390),
    [sym_true] = ACTIONS(2388),
    [sym_false] = ACTIONS(2388),
    [anon_sym_NULL] = ACTIONS(2388),
    [anon_sym_nullptr] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2388),
    [anon_sym_decltype] = ACTIONS(2388),
    [sym_virtual] = ACTIONS(2388),
    [anon_sym_explicit] = ACTIONS(2388),
    [anon_sym_typename] = ACTIONS(2388),
    [anon_sym_template] = ACTIONS(2388),
    [anon_sym_operator] = ACTIONS(2388),
    [anon_sym_try] = ACTIONS(2388),
    [anon_sym_delete] = ACTIONS(2388),
    [anon_sym_throw] = ACTIONS(2388),
    [anon_sym_namespace] = ACTIONS(2388),
    [anon_sym_using] = ACTIONS(2388),
    [anon_sym_static_assert] = ACTIONS(2388),
    [anon_sym_concept] = ACTIONS(2388),
    [anon_sym_co_return] = ACTIONS(2388),
    [anon_sym_co_yield] = ACTIONS(2388),
    [anon_sym_R_DQUOTE] = ACTIONS(2390),
    [anon_sym_LR_DQUOTE] = ACTIONS(2390),
    [anon_sym_uR_DQUOTE] = ACTIONS(2390),
    [anon_sym_UR_DQUOTE] = ACTIONS(2390),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2390),
    [anon_sym_co_await] = ACTIONS(2388),
    [anon_sym_new] = ACTIONS(2388),
    [anon_sym_requires] = ACTIONS(2388),
    [sym_this] = ACTIONS(2388),
    [anon_sym___launch_bounds__] = ACTIONS(2388),
  },
  [574] = {
    [sym_identifier] = ACTIONS(2227),
    [aux_sym_preproc_include_token1] = ACTIONS(2227),
    [aux_sym_preproc_def_token1] = ACTIONS(2227),
    [aux_sym_preproc_if_token1] = ACTIONS(2227),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2227),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2227),
    [sym_preproc_directive] = ACTIONS(2227),
    [anon_sym_LPAREN2] = ACTIONS(2229),
    [anon_sym_BANG] = ACTIONS(2229),
    [anon_sym_TILDE] = ACTIONS(2229),
    [anon_sym_DASH] = ACTIONS(2227),
    [anon_sym_PLUS] = ACTIONS(2227),
    [anon_sym_STAR] = ACTIONS(2229),
    [anon_sym_AMP_AMP] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2227),
    [anon_sym_SEMI] = ACTIONS(2229),
    [anon_sym___extension__] = ACTIONS(2227),
    [anon_sym_typedef] = ACTIONS(2227),
    [anon_sym___device__] = ACTIONS(2227),
    [anon_sym___host__] = ACTIONS(2227),
    [anon_sym___global__] = ACTIONS(2227),
    [anon_sym___forceinline__] = ACTIONS(2227),
    [anon_sym___noinline__] = ACTIONS(2227),
    [anon_sym_extern] = ACTIONS(2227),
    [anon_sym___attribute__] = ACTIONS(2227),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2229),
    [anon_sym___declspec] = ACTIONS(2227),
    [anon_sym___based] = ACTIONS(2227),
    [anon_sym___cdecl] = ACTIONS(2227),
    [anon_sym___clrcall] = ACTIONS(2227),
    [anon_sym___stdcall] = ACTIONS(2227),
    [anon_sym___fastcall] = ACTIONS(2227),
    [anon_sym___thiscall] = ACTIONS(2227),
    [anon_sym___vectorcall] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(2229),
    [anon_sym_RBRACE] = ACTIONS(2229),
    [anon_sym_signed] = ACTIONS(2227),
    [anon_sym_unsigned] = ACTIONS(2227),
    [anon_sym_long] = ACTIONS(2227),
    [anon_sym_short] = ACTIONS(2227),
    [anon_sym_LBRACK] = ACTIONS(2227),
    [anon_sym_static] = ACTIONS(2227),
    [anon_sym_register] = ACTIONS(2227),
    [anon_sym_inline] = ACTIONS(2227),
    [anon_sym___inline] = ACTIONS(2227),
    [anon_sym___inline__] = ACTIONS(2227),
    [anon_sym___forceinline] = ACTIONS(2227),
    [anon_sym_thread_local] = ACTIONS(2227),
    [anon_sym___thread] = ACTIONS(2227),
    [anon_sym_const] = ACTIONS(2227),
    [anon_sym_constexpr] = ACTIONS(2227),
    [anon_sym_volatile] = ACTIONS(2227),
    [anon_sym_restrict] = ACTIONS(2227),
    [anon_sym___restrict__] = ACTIONS(2227),
    [anon_sym__Atomic] = ACTIONS(2227),
    [anon_sym__Noreturn] = ACTIONS(2227),
    [anon_sym_noreturn] = ACTIONS(2227),
    [anon_sym_mutable] = ACTIONS(2227),
    [anon_sym_constinit] = ACTIONS(2227),
    [anon_sym_consteval] = ACTIONS(2227),
    [anon_sym___shared__] = ACTIONS(2227),
    [anon_sym___local__] = ACTIONS(2227),
    [anon_sym___constant__] = ACTIONS(2227),
    [anon_sym___managed__] = ACTIONS(2227),
    [anon_sym___grid_constant__] = ACTIONS(2227),
    [anon_sym_alignas] = ACTIONS(2227),
    [anon_sym__Alignas] = ACTIONS(2227),
    [sym_primitive_type] = ACTIONS(2227),
    [anon_sym_enum] = ACTIONS(2227),
    [anon_sym_class] = ACTIONS(2227),
    [anon_sym_struct] = ACTIONS(2227),
    [anon_sym_union] = ACTIONS(2227),
    [anon_sym_if] = ACTIONS(2227),
    [anon_sym_switch] = ACTIONS(2227),
    [anon_sym_case] = ACTIONS(2227),
    [anon_sym_default] = ACTIONS(2227),
    [anon_sym_while] = ACTIONS(2227),
    [anon_sym_do] = ACTIONS(2227),
    [anon_sym_for] = ACTIONS(2227),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_break] = ACTIONS(2227),
    [anon_sym_continue] = ACTIONS(2227),
    [anon_sym_goto] = ACTIONS(2227),
    [anon_sym___try] = ACTIONS(2227),
    [anon_sym___leave] = ACTIONS(2227),
    [anon_sym_not] = ACTIONS(2227),
    [anon_sym_compl] = ACTIONS(2227),
    [anon_sym_DASH_DASH] = ACTIONS(2229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2229),
    [anon_sym_sizeof] = ACTIONS(2227),
    [anon_sym___alignof__] = ACTIONS(2227),
    [anon_sym___alignof] = ACTIONS(2227),
    [anon_sym__alignof] = ACTIONS(2227),
    [anon_sym_alignof] = ACTIONS(2227),
    [anon_sym__Alignof] = ACTIONS(2227),
    [anon_sym_offsetof] = ACTIONS(2227),
    [anon_sym__Generic] = ACTIONS(2227),
    [anon_sym_asm] = ACTIONS(2227),
    [anon_sym___asm__] = ACTIONS(2227),
    [sym_number_literal] = ACTIONS(2229),
    [anon_sym_L_SQUOTE] = ACTIONS(2229),
    [anon_sym_u_SQUOTE] = ACTIONS(2229),
    [anon_sym_U_SQUOTE] = ACTIONS(2229),
    [anon_sym_u8_SQUOTE] = ACTIONS(2229),
    [anon_sym_SQUOTE] = ACTIONS(2229),
    [anon_sym_L_DQUOTE] = ACTIONS(2229),
    [anon_sym_u_DQUOTE] = ACTIONS(2229),
    [anon_sym_U_DQUOTE] = ACTIONS(2229),
    [anon_sym_u8_DQUOTE] = ACTIONS(2229),
    [anon_sym_DQUOTE] = ACTIONS(2229),
    [sym_true] = ACTIONS(2227),
    [sym_false] = ACTIONS(2227),
    [anon_sym_NULL] = ACTIONS(2227),
    [anon_sym_nullptr] = ACTIONS(2227),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2227),
    [anon_sym_decltype] = ACTIONS(2227),
    [sym_virtual] = ACTIONS(2227),
    [anon_sym_explicit] = ACTIONS(2227),
    [anon_sym_typename] = ACTIONS(2227),
    [anon_sym_template] = ACTIONS(2227),
    [anon_sym_operator] = ACTIONS(2227),
    [anon_sym_try] = ACTIONS(2227),
    [anon_sym_delete] = ACTIONS(2227),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_namespace] = ACTIONS(2227),
    [anon_sym_using] = ACTIONS(2227),
    [anon_sym_static_assert] = ACTIONS(2227),
    [anon_sym_concept] = ACTIONS(2227),
    [anon_sym_co_return] = ACTIONS(2227),
    [anon_sym_co_yield] = ACTIONS(2227),
    [anon_sym_R_DQUOTE] = ACTIONS(2229),
    [anon_sym_LR_DQUOTE] = ACTIONS(2229),
    [anon_sym_uR_DQUOTE] = ACTIONS(2229),
    [anon_sym_UR_DQUOTE] = ACTIONS(2229),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2229),
    [anon_sym_co_await] = ACTIONS(2227),
    [anon_sym_new] = ACTIONS(2227),
    [anon_sym_requires] = ACTIONS(2227),
    [sym_this] = ACTIONS(2227),
    [anon_sym___launch_bounds__] = ACTIONS(2227),
  },
  [575] = {
    [sym_type_qualifier] = STATE(3531),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4591),
    [sym_sized_type_specifier] = STATE(2599),
    [sym_enum_specifier] = STATE(2599),
    [sym_struct_specifier] = STATE(2599),
    [sym_union_specifier] = STATE(2599),
    [sym_expression] = STATE(4645),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_type_descriptor] = STATE(7345),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_placeholder_type_specifier] = STATE(2599),
    [sym_decltype_auto] = STATE(2598),
    [sym_decltype] = STATE(2477),
    [sym_class_specifier] = STATE(2599),
    [sym__class_name] = STATE(8015),
    [sym_dependent_type] = STATE(2599),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_type_parameter_pack_expansion] = STATE(7411),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5910),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [aux_sym__type_definition_type_repeat1] = STATE(3531),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2157),
    [sym_identifier] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2725),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2729),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2733),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2757),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2761),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_GT2] = ACTIONS(2827),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [576] = {
    [sym_identifier] = ACTIONS(2172),
    [aux_sym_preproc_include_token1] = ACTIONS(2172),
    [aux_sym_preproc_def_token1] = ACTIONS(2172),
    [aux_sym_preproc_if_token1] = ACTIONS(2172),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2172),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2172),
    [sym_preproc_directive] = ACTIONS(2172),
    [anon_sym_LPAREN2] = ACTIONS(2174),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2174),
    [anon_sym_DASH] = ACTIONS(2172),
    [anon_sym_PLUS] = ACTIONS(2172),
    [anon_sym_STAR] = ACTIONS(2174),
    [anon_sym_AMP_AMP] = ACTIONS(2174),
    [anon_sym_AMP] = ACTIONS(2172),
    [anon_sym_SEMI] = ACTIONS(2174),
    [anon_sym___extension__] = ACTIONS(2172),
    [anon_sym_typedef] = ACTIONS(2172),
    [anon_sym___device__] = ACTIONS(2172),
    [anon_sym___host__] = ACTIONS(2172),
    [anon_sym___global__] = ACTIONS(2172),
    [anon_sym___forceinline__] = ACTIONS(2172),
    [anon_sym___noinline__] = ACTIONS(2172),
    [anon_sym_extern] = ACTIONS(2172),
    [anon_sym___attribute__] = ACTIONS(2172),
    [anon_sym_COLON_COLON] = ACTIONS(2174),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2174),
    [anon_sym___declspec] = ACTIONS(2172),
    [anon_sym___based] = ACTIONS(2172),
    [anon_sym___cdecl] = ACTIONS(2172),
    [anon_sym___clrcall] = ACTIONS(2172),
    [anon_sym___stdcall] = ACTIONS(2172),
    [anon_sym___fastcall] = ACTIONS(2172),
    [anon_sym___thiscall] = ACTIONS(2172),
    [anon_sym___vectorcall] = ACTIONS(2172),
    [anon_sym_LBRACE] = ACTIONS(2174),
    [anon_sym_RBRACE] = ACTIONS(2174),
    [anon_sym_signed] = ACTIONS(2172),
    [anon_sym_unsigned] = ACTIONS(2172),
    [anon_sym_long] = ACTIONS(2172),
    [anon_sym_short] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2172),
    [anon_sym_static] = ACTIONS(2172),
    [anon_sym_register] = ACTIONS(2172),
    [anon_sym_inline] = ACTIONS(2172),
    [anon_sym___inline] = ACTIONS(2172),
    [anon_sym___inline__] = ACTIONS(2172),
    [anon_sym___forceinline] = ACTIONS(2172),
    [anon_sym_thread_local] = ACTIONS(2172),
    [anon_sym___thread] = ACTIONS(2172),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_constexpr] = ACTIONS(2172),
    [anon_sym_volatile] = ACTIONS(2172),
    [anon_sym_restrict] = ACTIONS(2172),
    [anon_sym___restrict__] = ACTIONS(2172),
    [anon_sym__Atomic] = ACTIONS(2172),
    [anon_sym__Noreturn] = ACTIONS(2172),
    [anon_sym_noreturn] = ACTIONS(2172),
    [anon_sym_mutable] = ACTIONS(2172),
    [anon_sym_constinit] = ACTIONS(2172),
    [anon_sym_consteval] = ACTIONS(2172),
    [anon_sym___shared__] = ACTIONS(2172),
    [anon_sym___local__] = ACTIONS(2172),
    [anon_sym___constant__] = ACTIONS(2172),
    [anon_sym___managed__] = ACTIONS(2172),
    [anon_sym___grid_constant__] = ACTIONS(2172),
    [anon_sym_alignas] = ACTIONS(2172),
    [anon_sym__Alignas] = ACTIONS(2172),
    [sym_primitive_type] = ACTIONS(2172),
    [anon_sym_enum] = ACTIONS(2172),
    [anon_sym_class] = ACTIONS(2172),
    [anon_sym_struct] = ACTIONS(2172),
    [anon_sym_union] = ACTIONS(2172),
    [anon_sym_if] = ACTIONS(2172),
    [anon_sym_switch] = ACTIONS(2172),
    [anon_sym_case] = ACTIONS(2172),
    [anon_sym_default] = ACTIONS(2172),
    [anon_sym_while] = ACTIONS(2172),
    [anon_sym_do] = ACTIONS(2172),
    [anon_sym_for] = ACTIONS(2172),
    [anon_sym_return] = ACTIONS(2172),
    [anon_sym_break] = ACTIONS(2172),
    [anon_sym_continue] = ACTIONS(2172),
    [anon_sym_goto] = ACTIONS(2172),
    [anon_sym___try] = ACTIONS(2172),
    [anon_sym___leave] = ACTIONS(2172),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_compl] = ACTIONS(2172),
    [anon_sym_DASH_DASH] = ACTIONS(2174),
    [anon_sym_PLUS_PLUS] = ACTIONS(2174),
    [anon_sym_sizeof] = ACTIONS(2172),
    [anon_sym___alignof__] = ACTIONS(2172),
    [anon_sym___alignof] = ACTIONS(2172),
    [anon_sym__alignof] = ACTIONS(2172),
    [anon_sym_alignof] = ACTIONS(2172),
    [anon_sym__Alignof] = ACTIONS(2172),
    [anon_sym_offsetof] = ACTIONS(2172),
    [anon_sym__Generic] = ACTIONS(2172),
    [anon_sym_asm] = ACTIONS(2172),
    [anon_sym___asm__] = ACTIONS(2172),
    [sym_number_literal] = ACTIONS(2174),
    [anon_sym_L_SQUOTE] = ACTIONS(2174),
    [anon_sym_u_SQUOTE] = ACTIONS(2174),
    [anon_sym_U_SQUOTE] = ACTIONS(2174),
    [anon_sym_u8_SQUOTE] = ACTIONS(2174),
    [anon_sym_SQUOTE] = ACTIONS(2174),
    [anon_sym_L_DQUOTE] = ACTIONS(2174),
    [anon_sym_u_DQUOTE] = ACTIONS(2174),
    [anon_sym_U_DQUOTE] = ACTIONS(2174),
    [anon_sym_u8_DQUOTE] = ACTIONS(2174),
    [anon_sym_DQUOTE] = ACTIONS(2174),
    [sym_true] = ACTIONS(2172),
    [sym_false] = ACTIONS(2172),
    [anon_sym_NULL] = ACTIONS(2172),
    [anon_sym_nullptr] = ACTIONS(2172),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2172),
    [anon_sym_decltype] = ACTIONS(2172),
    [sym_virtual] = ACTIONS(2172),
    [anon_sym_explicit] = ACTIONS(2172),
    [anon_sym_typename] = ACTIONS(2172),
    [anon_sym_template] = ACTIONS(2172),
    [anon_sym_operator] = ACTIONS(2172),
    [anon_sym_try] = ACTIONS(2172),
    [anon_sym_delete] = ACTIONS(2172),
    [anon_sym_throw] = ACTIONS(2172),
    [anon_sym_namespace] = ACTIONS(2172),
    [anon_sym_using] = ACTIONS(2172),
    [anon_sym_static_assert] = ACTIONS(2172),
    [anon_sym_concept] = ACTIONS(2172),
    [anon_sym_co_return] = ACTIONS(2172),
    [anon_sym_co_yield] = ACTIONS(2172),
    [anon_sym_R_DQUOTE] = ACTIONS(2174),
    [anon_sym_LR_DQUOTE] = ACTIONS(2174),
    [anon_sym_uR_DQUOTE] = ACTIONS(2174),
    [anon_sym_UR_DQUOTE] = ACTIONS(2174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2174),
    [anon_sym_co_await] = ACTIONS(2172),
    [anon_sym_new] = ACTIONS(2172),
    [anon_sym_requires] = ACTIONS(2172),
    [sym_this] = ACTIONS(2172),
    [anon_sym___launch_bounds__] = ACTIONS(2172),
  },
  [577] = {
    [ts_builtin_sym_end] = ACTIONS(1899),
    [sym_identifier] = ACTIONS(1901),
    [aux_sym_preproc_include_token1] = ACTIONS(1901),
    [aux_sym_preproc_def_token1] = ACTIONS(1901),
    [anon_sym_COMMA] = ACTIONS(1962),
    [anon_sym_RPAREN] = ACTIONS(1962),
    [aux_sym_preproc_if_token1] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1901),
    [sym_preproc_directive] = ACTIONS(1901),
    [anon_sym_LPAREN2] = ACTIONS(1899),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_DASH] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1901),
    [anon_sym_STAR] = ACTIONS(1899),
    [anon_sym_AMP_AMP] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1901),
    [anon_sym_SEMI] = ACTIONS(1962),
    [anon_sym___extension__] = ACTIONS(1901),
    [anon_sym_typedef] = ACTIONS(1901),
    [anon_sym___device__] = ACTIONS(1901),
    [anon_sym___host__] = ACTIONS(1901),
    [anon_sym___global__] = ACTIONS(1901),
    [anon_sym___forceinline__] = ACTIONS(1901),
    [anon_sym___noinline__] = ACTIONS(1901),
    [anon_sym_extern] = ACTIONS(1901),
    [anon_sym___attribute__] = ACTIONS(1901),
    [anon_sym_COLON_COLON] = ACTIONS(1899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1899),
    [anon_sym___declspec] = ACTIONS(1901),
    [anon_sym___based] = ACTIONS(1901),
    [anon_sym___cdecl] = ACTIONS(1901),
    [anon_sym___clrcall] = ACTIONS(1901),
    [anon_sym___stdcall] = ACTIONS(1901),
    [anon_sym___fastcall] = ACTIONS(1901),
    [anon_sym___thiscall] = ACTIONS(1901),
    [anon_sym___vectorcall] = ACTIONS(1901),
    [anon_sym_LBRACE] = ACTIONS(1899),
    [anon_sym_signed] = ACTIONS(1901),
    [anon_sym_unsigned] = ACTIONS(1901),
    [anon_sym_long] = ACTIONS(1901),
    [anon_sym_short] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1901),
    [anon_sym_static] = ACTIONS(1901),
    [anon_sym_register] = ACTIONS(1901),
    [anon_sym_inline] = ACTIONS(1901),
    [anon_sym___inline] = ACTIONS(1901),
    [anon_sym___inline__] = ACTIONS(1901),
    [anon_sym___forceinline] = ACTIONS(1901),
    [anon_sym_thread_local] = ACTIONS(1901),
    [anon_sym___thread] = ACTIONS(1901),
    [anon_sym_const] = ACTIONS(1901),
    [anon_sym_constexpr] = ACTIONS(1901),
    [anon_sym_volatile] = ACTIONS(1901),
    [anon_sym_restrict] = ACTIONS(1901),
    [anon_sym___restrict__] = ACTIONS(1901),
    [anon_sym__Atomic] = ACTIONS(1901),
    [anon_sym__Noreturn] = ACTIONS(1901),
    [anon_sym_noreturn] = ACTIONS(1901),
    [anon_sym_mutable] = ACTIONS(1901),
    [anon_sym_constinit] = ACTIONS(1901),
    [anon_sym_consteval] = ACTIONS(1901),
    [anon_sym___shared__] = ACTIONS(1901),
    [anon_sym___local__] = ACTIONS(1901),
    [anon_sym___constant__] = ACTIONS(1901),
    [anon_sym___managed__] = ACTIONS(1901),
    [anon_sym___grid_constant__] = ACTIONS(1901),
    [anon_sym_alignas] = ACTIONS(1901),
    [anon_sym__Alignas] = ACTIONS(1901),
    [sym_primitive_type] = ACTIONS(1901),
    [anon_sym_enum] = ACTIONS(1901),
    [anon_sym_class] = ACTIONS(1901),
    [anon_sym_struct] = ACTIONS(1901),
    [anon_sym_union] = ACTIONS(1901),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_switch] = ACTIONS(1901),
    [anon_sym_case] = ACTIONS(1901),
    [anon_sym_default] = ACTIONS(1901),
    [anon_sym_while] = ACTIONS(1901),
    [anon_sym_do] = ACTIONS(1901),
    [anon_sym_for] = ACTIONS(1901),
    [anon_sym_return] = ACTIONS(1901),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_continue] = ACTIONS(1901),
    [anon_sym_goto] = ACTIONS(1901),
    [anon_sym_not] = ACTIONS(1901),
    [anon_sym_compl] = ACTIONS(1901),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_sizeof] = ACTIONS(1901),
    [anon_sym___alignof__] = ACTIONS(1901),
    [anon_sym___alignof] = ACTIONS(1901),
    [anon_sym__alignof] = ACTIONS(1901),
    [anon_sym_alignof] = ACTIONS(1901),
    [anon_sym__Alignof] = ACTIONS(1901),
    [anon_sym_offsetof] = ACTIONS(1901),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1901),
    [anon_sym___asm__] = ACTIONS(1901),
    [sym_number_literal] = ACTIONS(1899),
    [anon_sym_L_SQUOTE] = ACTIONS(1899),
    [anon_sym_u_SQUOTE] = ACTIONS(1899),
    [anon_sym_U_SQUOTE] = ACTIONS(1899),
    [anon_sym_u8_SQUOTE] = ACTIONS(1899),
    [anon_sym_SQUOTE] = ACTIONS(1899),
    [anon_sym_L_DQUOTE] = ACTIONS(1899),
    [anon_sym_u_DQUOTE] = ACTIONS(1899),
    [anon_sym_U_DQUOTE] = ACTIONS(1899),
    [anon_sym_u8_DQUOTE] = ACTIONS(1899),
    [anon_sym_DQUOTE] = ACTIONS(1899),
    [sym_true] = ACTIONS(1901),
    [sym_false] = ACTIONS(1901),
    [anon_sym_NULL] = ACTIONS(1901),
    [anon_sym_nullptr] = ACTIONS(1901),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1901),
    [anon_sym_decltype] = ACTIONS(1901),
    [sym_virtual] = ACTIONS(1901),
    [anon_sym_explicit] = ACTIONS(1901),
    [anon_sym_typename] = ACTIONS(1901),
    [anon_sym_template] = ACTIONS(1901),
    [anon_sym_operator] = ACTIONS(1901),
    [anon_sym_try] = ACTIONS(1901),
    [anon_sym_delete] = ACTIONS(1901),
    [anon_sym_throw] = ACTIONS(1901),
    [anon_sym_namespace] = ACTIONS(1901),
    [anon_sym_using] = ACTIONS(1901),
    [anon_sym_static_assert] = ACTIONS(1901),
    [anon_sym_concept] = ACTIONS(1901),
    [anon_sym_co_return] = ACTIONS(1901),
    [anon_sym_co_yield] = ACTIONS(1901),
    [anon_sym_R_DQUOTE] = ACTIONS(1899),
    [anon_sym_LR_DQUOTE] = ACTIONS(1899),
    [anon_sym_uR_DQUOTE] = ACTIONS(1899),
    [anon_sym_UR_DQUOTE] = ACTIONS(1899),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1899),
    [anon_sym_co_await] = ACTIONS(1901),
    [anon_sym_new] = ACTIONS(1901),
    [anon_sym_requires] = ACTIONS(1901),
    [sym_this] = ACTIONS(1901),
    [anon_sym___launch_bounds__] = ACTIONS(1901),
  },
  [578] = {
    [sym_identifier] = ACTIONS(2176),
    [aux_sym_preproc_include_token1] = ACTIONS(2176),
    [aux_sym_preproc_def_token1] = ACTIONS(2176),
    [aux_sym_preproc_if_token1] = ACTIONS(2176),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2176),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2176),
    [sym_preproc_directive] = ACTIONS(2176),
    [anon_sym_LPAREN2] = ACTIONS(2178),
    [anon_sym_BANG] = ACTIONS(2178),
    [anon_sym_TILDE] = ACTIONS(2178),
    [anon_sym_DASH] = ACTIONS(2176),
    [anon_sym_PLUS] = ACTIONS(2176),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_AMP_AMP] = ACTIONS(2178),
    [anon_sym_AMP] = ACTIONS(2176),
    [anon_sym_SEMI] = ACTIONS(2178),
    [anon_sym___extension__] = ACTIONS(2176),
    [anon_sym_typedef] = ACTIONS(2176),
    [anon_sym___device__] = ACTIONS(2176),
    [anon_sym___host__] = ACTIONS(2176),
    [anon_sym___global__] = ACTIONS(2176),
    [anon_sym___forceinline__] = ACTIONS(2176),
    [anon_sym___noinline__] = ACTIONS(2176),
    [anon_sym_extern] = ACTIONS(2176),
    [anon_sym___attribute__] = ACTIONS(2176),
    [anon_sym_COLON_COLON] = ACTIONS(2178),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2178),
    [anon_sym___declspec] = ACTIONS(2176),
    [anon_sym___based] = ACTIONS(2176),
    [anon_sym___cdecl] = ACTIONS(2176),
    [anon_sym___clrcall] = ACTIONS(2176),
    [anon_sym___stdcall] = ACTIONS(2176),
    [anon_sym___fastcall] = ACTIONS(2176),
    [anon_sym___thiscall] = ACTIONS(2176),
    [anon_sym___vectorcall] = ACTIONS(2176),
    [anon_sym_LBRACE] = ACTIONS(2178),
    [anon_sym_RBRACE] = ACTIONS(2178),
    [anon_sym_signed] = ACTIONS(2176),
    [anon_sym_unsigned] = ACTIONS(2176),
    [anon_sym_long] = ACTIONS(2176),
    [anon_sym_short] = ACTIONS(2176),
    [anon_sym_LBRACK] = ACTIONS(2176),
    [anon_sym_static] = ACTIONS(2176),
    [anon_sym_register] = ACTIONS(2176),
    [anon_sym_inline] = ACTIONS(2176),
    [anon_sym___inline] = ACTIONS(2176),
    [anon_sym___inline__] = ACTIONS(2176),
    [anon_sym___forceinline] = ACTIONS(2176),
    [anon_sym_thread_local] = ACTIONS(2176),
    [anon_sym___thread] = ACTIONS(2176),
    [anon_sym_const] = ACTIONS(2176),
    [anon_sym_constexpr] = ACTIONS(2176),
    [anon_sym_volatile] = ACTIONS(2176),
    [anon_sym_restrict] = ACTIONS(2176),
    [anon_sym___restrict__] = ACTIONS(2176),
    [anon_sym__Atomic] = ACTIONS(2176),
    [anon_sym__Noreturn] = ACTIONS(2176),
    [anon_sym_noreturn] = ACTIONS(2176),
    [anon_sym_mutable] = ACTIONS(2176),
    [anon_sym_constinit] = ACTIONS(2176),
    [anon_sym_consteval] = ACTIONS(2176),
    [anon_sym___shared__] = ACTIONS(2176),
    [anon_sym___local__] = ACTIONS(2176),
    [anon_sym___constant__] = ACTIONS(2176),
    [anon_sym___managed__] = ACTIONS(2176),
    [anon_sym___grid_constant__] = ACTIONS(2176),
    [anon_sym_alignas] = ACTIONS(2176),
    [anon_sym__Alignas] = ACTIONS(2176),
    [sym_primitive_type] = ACTIONS(2176),
    [anon_sym_enum] = ACTIONS(2176),
    [anon_sym_class] = ACTIONS(2176),
    [anon_sym_struct] = ACTIONS(2176),
    [anon_sym_union] = ACTIONS(2176),
    [anon_sym_if] = ACTIONS(2176),
    [anon_sym_switch] = ACTIONS(2176),
    [anon_sym_case] = ACTIONS(2176),
    [anon_sym_default] = ACTIONS(2176),
    [anon_sym_while] = ACTIONS(2176),
    [anon_sym_do] = ACTIONS(2176),
    [anon_sym_for] = ACTIONS(2176),
    [anon_sym_return] = ACTIONS(2176),
    [anon_sym_break] = ACTIONS(2176),
    [anon_sym_continue] = ACTIONS(2176),
    [anon_sym_goto] = ACTIONS(2176),
    [anon_sym___try] = ACTIONS(2176),
    [anon_sym___leave] = ACTIONS(2176),
    [anon_sym_not] = ACTIONS(2176),
    [anon_sym_compl] = ACTIONS(2176),
    [anon_sym_DASH_DASH] = ACTIONS(2178),
    [anon_sym_PLUS_PLUS] = ACTIONS(2178),
    [anon_sym_sizeof] = ACTIONS(2176),
    [anon_sym___alignof__] = ACTIONS(2176),
    [anon_sym___alignof] = ACTIONS(2176),
    [anon_sym__alignof] = ACTIONS(2176),
    [anon_sym_alignof] = ACTIONS(2176),
    [anon_sym__Alignof] = ACTIONS(2176),
    [anon_sym_offsetof] = ACTIONS(2176),
    [anon_sym__Generic] = ACTIONS(2176),
    [anon_sym_asm] = ACTIONS(2176),
    [anon_sym___asm__] = ACTIONS(2176),
    [sym_number_literal] = ACTIONS(2178),
    [anon_sym_L_SQUOTE] = ACTIONS(2178),
    [anon_sym_u_SQUOTE] = ACTIONS(2178),
    [anon_sym_U_SQUOTE] = ACTIONS(2178),
    [anon_sym_u8_SQUOTE] = ACTIONS(2178),
    [anon_sym_SQUOTE] = ACTIONS(2178),
    [anon_sym_L_DQUOTE] = ACTIONS(2178),
    [anon_sym_u_DQUOTE] = ACTIONS(2178),
    [anon_sym_U_DQUOTE] = ACTIONS(2178),
    [anon_sym_u8_DQUOTE] = ACTIONS(2178),
    [anon_sym_DQUOTE] = ACTIONS(2178),
    [sym_true] = ACTIONS(2176),
    [sym_false] = ACTIONS(2176),
    [anon_sym_NULL] = ACTIONS(2176),
    [anon_sym_nullptr] = ACTIONS(2176),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2176),
    [anon_sym_decltype] = ACTIONS(2176),
    [sym_virtual] = ACTIONS(2176),
    [anon_sym_explicit] = ACTIONS(2176),
    [anon_sym_typename] = ACTIONS(2176),
    [anon_sym_template] = ACTIONS(2176),
    [anon_sym_operator] = ACTIONS(2176),
    [anon_sym_try] = ACTIONS(2176),
    [anon_sym_delete] = ACTIONS(2176),
    [anon_sym_throw] = ACTIONS(2176),
    [anon_sym_namespace] = ACTIONS(2176),
    [anon_sym_using] = ACTIONS(2176),
    [anon_sym_static_assert] = ACTIONS(2176),
    [anon_sym_concept] = ACTIONS(2176),
    [anon_sym_co_return] = ACTIONS(2176),
    [anon_sym_co_yield] = ACTIONS(2176),
    [anon_sym_R_DQUOTE] = ACTIONS(2178),
    [anon_sym_LR_DQUOTE] = ACTIONS(2178),
    [anon_sym_uR_DQUOTE] = ACTIONS(2178),
    [anon_sym_UR_DQUOTE] = ACTIONS(2178),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2178),
    [anon_sym_co_await] = ACTIONS(2176),
    [anon_sym_new] = ACTIONS(2176),
    [anon_sym_requires] = ACTIONS(2176),
    [sym_this] = ACTIONS(2176),
    [anon_sym___launch_bounds__] = ACTIONS(2176),
  },
  [579] = {
    [sym_identifier] = ACTIONS(2392),
    [aux_sym_preproc_include_token1] = ACTIONS(2392),
    [aux_sym_preproc_def_token1] = ACTIONS(2392),
    [aux_sym_preproc_if_token1] = ACTIONS(2392),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2392),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2392),
    [sym_preproc_directive] = ACTIONS(2392),
    [anon_sym_LPAREN2] = ACTIONS(2394),
    [anon_sym_BANG] = ACTIONS(2394),
    [anon_sym_TILDE] = ACTIONS(2394),
    [anon_sym_DASH] = ACTIONS(2392),
    [anon_sym_PLUS] = ACTIONS(2392),
    [anon_sym_STAR] = ACTIONS(2394),
    [anon_sym_AMP_AMP] = ACTIONS(2394),
    [anon_sym_AMP] = ACTIONS(2392),
    [anon_sym_SEMI] = ACTIONS(2394),
    [anon_sym___extension__] = ACTIONS(2392),
    [anon_sym_typedef] = ACTIONS(2392),
    [anon_sym___device__] = ACTIONS(2392),
    [anon_sym___host__] = ACTIONS(2392),
    [anon_sym___global__] = ACTIONS(2392),
    [anon_sym___forceinline__] = ACTIONS(2392),
    [anon_sym___noinline__] = ACTIONS(2392),
    [anon_sym_extern] = ACTIONS(2392),
    [anon_sym___attribute__] = ACTIONS(2392),
    [anon_sym_COLON_COLON] = ACTIONS(2394),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2394),
    [anon_sym___declspec] = ACTIONS(2392),
    [anon_sym___based] = ACTIONS(2392),
    [anon_sym___cdecl] = ACTIONS(2392),
    [anon_sym___clrcall] = ACTIONS(2392),
    [anon_sym___stdcall] = ACTIONS(2392),
    [anon_sym___fastcall] = ACTIONS(2392),
    [anon_sym___thiscall] = ACTIONS(2392),
    [anon_sym___vectorcall] = ACTIONS(2392),
    [anon_sym_LBRACE] = ACTIONS(2394),
    [anon_sym_RBRACE] = ACTIONS(2394),
    [anon_sym_signed] = ACTIONS(2392),
    [anon_sym_unsigned] = ACTIONS(2392),
    [anon_sym_long] = ACTIONS(2392),
    [anon_sym_short] = ACTIONS(2392),
    [anon_sym_LBRACK] = ACTIONS(2392),
    [anon_sym_static] = ACTIONS(2392),
    [anon_sym_register] = ACTIONS(2392),
    [anon_sym_inline] = ACTIONS(2392),
    [anon_sym___inline] = ACTIONS(2392),
    [anon_sym___inline__] = ACTIONS(2392),
    [anon_sym___forceinline] = ACTIONS(2392),
    [anon_sym_thread_local] = ACTIONS(2392),
    [anon_sym___thread] = ACTIONS(2392),
    [anon_sym_const] = ACTIONS(2392),
    [anon_sym_constexpr] = ACTIONS(2392),
    [anon_sym_volatile] = ACTIONS(2392),
    [anon_sym_restrict] = ACTIONS(2392),
    [anon_sym___restrict__] = ACTIONS(2392),
    [anon_sym__Atomic] = ACTIONS(2392),
    [anon_sym__Noreturn] = ACTIONS(2392),
    [anon_sym_noreturn] = ACTIONS(2392),
    [anon_sym_mutable] = ACTIONS(2392),
    [anon_sym_constinit] = ACTIONS(2392),
    [anon_sym_consteval] = ACTIONS(2392),
    [anon_sym___shared__] = ACTIONS(2392),
    [anon_sym___local__] = ACTIONS(2392),
    [anon_sym___constant__] = ACTIONS(2392),
    [anon_sym___managed__] = ACTIONS(2392),
    [anon_sym___grid_constant__] = ACTIONS(2392),
    [anon_sym_alignas] = ACTIONS(2392),
    [anon_sym__Alignas] = ACTIONS(2392),
    [sym_primitive_type] = ACTIONS(2392),
    [anon_sym_enum] = ACTIONS(2392),
    [anon_sym_class] = ACTIONS(2392),
    [anon_sym_struct] = ACTIONS(2392),
    [anon_sym_union] = ACTIONS(2392),
    [anon_sym_if] = ACTIONS(2392),
    [anon_sym_switch] = ACTIONS(2392),
    [anon_sym_case] = ACTIONS(2392),
    [anon_sym_default] = ACTIONS(2392),
    [anon_sym_while] = ACTIONS(2392),
    [anon_sym_do] = ACTIONS(2392),
    [anon_sym_for] = ACTIONS(2392),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_break] = ACTIONS(2392),
    [anon_sym_continue] = ACTIONS(2392),
    [anon_sym_goto] = ACTIONS(2392),
    [anon_sym___try] = ACTIONS(2392),
    [anon_sym___leave] = ACTIONS(2392),
    [anon_sym_not] = ACTIONS(2392),
    [anon_sym_compl] = ACTIONS(2392),
    [anon_sym_DASH_DASH] = ACTIONS(2394),
    [anon_sym_PLUS_PLUS] = ACTIONS(2394),
    [anon_sym_sizeof] = ACTIONS(2392),
    [anon_sym___alignof__] = ACTIONS(2392),
    [anon_sym___alignof] = ACTIONS(2392),
    [anon_sym__alignof] = ACTIONS(2392),
    [anon_sym_alignof] = ACTIONS(2392),
    [anon_sym__Alignof] = ACTIONS(2392),
    [anon_sym_offsetof] = ACTIONS(2392),
    [anon_sym__Generic] = ACTIONS(2392),
    [anon_sym_asm] = ACTIONS(2392),
    [anon_sym___asm__] = ACTIONS(2392),
    [sym_number_literal] = ACTIONS(2394),
    [anon_sym_L_SQUOTE] = ACTIONS(2394),
    [anon_sym_u_SQUOTE] = ACTIONS(2394),
    [anon_sym_U_SQUOTE] = ACTIONS(2394),
    [anon_sym_u8_SQUOTE] = ACTIONS(2394),
    [anon_sym_SQUOTE] = ACTIONS(2394),
    [anon_sym_L_DQUOTE] = ACTIONS(2394),
    [anon_sym_u_DQUOTE] = ACTIONS(2394),
    [anon_sym_U_DQUOTE] = ACTIONS(2394),
    [anon_sym_u8_DQUOTE] = ACTIONS(2394),
    [anon_sym_DQUOTE] = ACTIONS(2394),
    [sym_true] = ACTIONS(2392),
    [sym_false] = ACTIONS(2392),
    [anon_sym_NULL] = ACTIONS(2392),
    [anon_sym_nullptr] = ACTIONS(2392),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2392),
    [anon_sym_decltype] = ACTIONS(2392),
    [sym_virtual] = ACTIONS(2392),
    [anon_sym_explicit] = ACTIONS(2392),
    [anon_sym_typename] = ACTIONS(2392),
    [anon_sym_template] = ACTIONS(2392),
    [anon_sym_operator] = ACTIONS(2392),
    [anon_sym_try] = ACTIONS(2392),
    [anon_sym_delete] = ACTIONS(2392),
    [anon_sym_throw] = ACTIONS(2392),
    [anon_sym_namespace] = ACTIONS(2392),
    [anon_sym_using] = ACTIONS(2392),
    [anon_sym_static_assert] = ACTIONS(2392),
    [anon_sym_concept] = ACTIONS(2392),
    [anon_sym_co_return] = ACTIONS(2392),
    [anon_sym_co_yield] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2394),
    [anon_sym_LR_DQUOTE] = ACTIONS(2394),
    [anon_sym_uR_DQUOTE] = ACTIONS(2394),
    [anon_sym_UR_DQUOTE] = ACTIONS(2394),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2394),
    [anon_sym_co_await] = ACTIONS(2392),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2392),
    [sym_this] = ACTIONS(2392),
    [anon_sym___launch_bounds__] = ACTIONS(2392),
  },
  [580] = {
    [sym_identifier] = ACTIONS(2180),
    [aux_sym_preproc_include_token1] = ACTIONS(2180),
    [aux_sym_preproc_def_token1] = ACTIONS(2180),
    [aux_sym_preproc_if_token1] = ACTIONS(2180),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2180),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2180),
    [sym_preproc_directive] = ACTIONS(2180),
    [anon_sym_LPAREN2] = ACTIONS(2182),
    [anon_sym_BANG] = ACTIONS(2182),
    [anon_sym_TILDE] = ACTIONS(2182),
    [anon_sym_DASH] = ACTIONS(2180),
    [anon_sym_PLUS] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(2182),
    [anon_sym_AMP_AMP] = ACTIONS(2182),
    [anon_sym_AMP] = ACTIONS(2180),
    [anon_sym_SEMI] = ACTIONS(2182),
    [anon_sym___extension__] = ACTIONS(2180),
    [anon_sym_typedef] = ACTIONS(2180),
    [anon_sym___device__] = ACTIONS(2180),
    [anon_sym___host__] = ACTIONS(2180),
    [anon_sym___global__] = ACTIONS(2180),
    [anon_sym___forceinline__] = ACTIONS(2180),
    [anon_sym___noinline__] = ACTIONS(2180),
    [anon_sym_extern] = ACTIONS(2180),
    [anon_sym___attribute__] = ACTIONS(2180),
    [anon_sym_COLON_COLON] = ACTIONS(2182),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2182),
    [anon_sym___declspec] = ACTIONS(2180),
    [anon_sym___based] = ACTIONS(2180),
    [anon_sym___cdecl] = ACTIONS(2180),
    [anon_sym___clrcall] = ACTIONS(2180),
    [anon_sym___stdcall] = ACTIONS(2180),
    [anon_sym___fastcall] = ACTIONS(2180),
    [anon_sym___thiscall] = ACTIONS(2180),
    [anon_sym___vectorcall] = ACTIONS(2180),
    [anon_sym_LBRACE] = ACTIONS(2182),
    [anon_sym_RBRACE] = ACTIONS(2182),
    [anon_sym_signed] = ACTIONS(2180),
    [anon_sym_unsigned] = ACTIONS(2180),
    [anon_sym_long] = ACTIONS(2180),
    [anon_sym_short] = ACTIONS(2180),
    [anon_sym_LBRACK] = ACTIONS(2180),
    [anon_sym_static] = ACTIONS(2180),
    [anon_sym_register] = ACTIONS(2180),
    [anon_sym_inline] = ACTIONS(2180),
    [anon_sym___inline] = ACTIONS(2180),
    [anon_sym___inline__] = ACTIONS(2180),
    [anon_sym___forceinline] = ACTIONS(2180),
    [anon_sym_thread_local] = ACTIONS(2180),
    [anon_sym___thread] = ACTIONS(2180),
    [anon_sym_const] = ACTIONS(2180),
    [anon_sym_constexpr] = ACTIONS(2180),
    [anon_sym_volatile] = ACTIONS(2180),
    [anon_sym_restrict] = ACTIONS(2180),
    [anon_sym___restrict__] = ACTIONS(2180),
    [anon_sym__Atomic] = ACTIONS(2180),
    [anon_sym__Noreturn] = ACTIONS(2180),
    [anon_sym_noreturn] = ACTIONS(2180),
    [anon_sym_mutable] = ACTIONS(2180),
    [anon_sym_constinit] = ACTIONS(2180),
    [anon_sym_consteval] = ACTIONS(2180),
    [anon_sym___shared__] = ACTIONS(2180),
    [anon_sym___local__] = ACTIONS(2180),
    [anon_sym___constant__] = ACTIONS(2180),
    [anon_sym___managed__] = ACTIONS(2180),
    [anon_sym___grid_constant__] = ACTIONS(2180),
    [anon_sym_alignas] = ACTIONS(2180),
    [anon_sym__Alignas] = ACTIONS(2180),
    [sym_primitive_type] = ACTIONS(2180),
    [anon_sym_enum] = ACTIONS(2180),
    [anon_sym_class] = ACTIONS(2180),
    [anon_sym_struct] = ACTIONS(2180),
    [anon_sym_union] = ACTIONS(2180),
    [anon_sym_if] = ACTIONS(2180),
    [anon_sym_switch] = ACTIONS(2180),
    [anon_sym_case] = ACTIONS(2180),
    [anon_sym_default] = ACTIONS(2180),
    [anon_sym_while] = ACTIONS(2180),
    [anon_sym_do] = ACTIONS(2180),
    [anon_sym_for] = ACTIONS(2180),
    [anon_sym_return] = ACTIONS(2180),
    [anon_sym_break] = ACTIONS(2180),
    [anon_sym_continue] = ACTIONS(2180),
    [anon_sym_goto] = ACTIONS(2180),
    [anon_sym___try] = ACTIONS(2180),
    [anon_sym___leave] = ACTIONS(2180),
    [anon_sym_not] = ACTIONS(2180),
    [anon_sym_compl] = ACTIONS(2180),
    [anon_sym_DASH_DASH] = ACTIONS(2182),
    [anon_sym_PLUS_PLUS] = ACTIONS(2182),
    [anon_sym_sizeof] = ACTIONS(2180),
    [anon_sym___alignof__] = ACTIONS(2180),
    [anon_sym___alignof] = ACTIONS(2180),
    [anon_sym__alignof] = ACTIONS(2180),
    [anon_sym_alignof] = ACTIONS(2180),
    [anon_sym__Alignof] = ACTIONS(2180),
    [anon_sym_offsetof] = ACTIONS(2180),
    [anon_sym__Generic] = ACTIONS(2180),
    [anon_sym_asm] = ACTIONS(2180),
    [anon_sym___asm__] = ACTIONS(2180),
    [sym_number_literal] = ACTIONS(2182),
    [anon_sym_L_SQUOTE] = ACTIONS(2182),
    [anon_sym_u_SQUOTE] = ACTIONS(2182),
    [anon_sym_U_SQUOTE] = ACTIONS(2182),
    [anon_sym_u8_SQUOTE] = ACTIONS(2182),
    [anon_sym_SQUOTE] = ACTIONS(2182),
    [anon_sym_L_DQUOTE] = ACTIONS(2182),
    [anon_sym_u_DQUOTE] = ACTIONS(2182),
    [anon_sym_U_DQUOTE] = ACTIONS(2182),
    [anon_sym_u8_DQUOTE] = ACTIONS(2182),
    [anon_sym_DQUOTE] = ACTIONS(2182),
    [sym_true] = ACTIONS(2180),
    [sym_false] = ACTIONS(2180),
    [anon_sym_NULL] = ACTIONS(2180),
    [anon_sym_nullptr] = ACTIONS(2180),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2180),
    [anon_sym_decltype] = ACTIONS(2180),
    [sym_virtual] = ACTIONS(2180),
    [anon_sym_explicit] = ACTIONS(2180),
    [anon_sym_typename] = ACTIONS(2180),
    [anon_sym_template] = ACTIONS(2180),
    [anon_sym_operator] = ACTIONS(2180),
    [anon_sym_try] = ACTIONS(2180),
    [anon_sym_delete] = ACTIONS(2180),
    [anon_sym_throw] = ACTIONS(2180),
    [anon_sym_namespace] = ACTIONS(2180),
    [anon_sym_using] = ACTIONS(2180),
    [anon_sym_static_assert] = ACTIONS(2180),
    [anon_sym_concept] = ACTIONS(2180),
    [anon_sym_co_return] = ACTIONS(2180),
    [anon_sym_co_yield] = ACTIONS(2180),
    [anon_sym_R_DQUOTE] = ACTIONS(2182),
    [anon_sym_LR_DQUOTE] = ACTIONS(2182),
    [anon_sym_uR_DQUOTE] = ACTIONS(2182),
    [anon_sym_UR_DQUOTE] = ACTIONS(2182),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2182),
    [anon_sym_co_await] = ACTIONS(2180),
    [anon_sym_new] = ACTIONS(2180),
    [anon_sym_requires] = ACTIONS(2180),
    [sym_this] = ACTIONS(2180),
    [anon_sym___launch_bounds__] = ACTIONS(2180),
  },
  [581] = {
    [sym_identifier] = ACTIONS(2187),
    [aux_sym_preproc_include_token1] = ACTIONS(2187),
    [aux_sym_preproc_def_token1] = ACTIONS(2187),
    [aux_sym_preproc_if_token1] = ACTIONS(2187),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2187),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2187),
    [sym_preproc_directive] = ACTIONS(2187),
    [anon_sym_LPAREN2] = ACTIONS(2189),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_AMP_AMP] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_SEMI] = ACTIONS(2189),
    [anon_sym___extension__] = ACTIONS(2187),
    [anon_sym_typedef] = ACTIONS(2187),
    [anon_sym___device__] = ACTIONS(2187),
    [anon_sym___host__] = ACTIONS(2187),
    [anon_sym___global__] = ACTIONS(2187),
    [anon_sym___forceinline__] = ACTIONS(2187),
    [anon_sym___noinline__] = ACTIONS(2187),
    [anon_sym_extern] = ACTIONS(2187),
    [anon_sym___attribute__] = ACTIONS(2187),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2189),
    [anon_sym___declspec] = ACTIONS(2187),
    [anon_sym___based] = ACTIONS(2187),
    [anon_sym___cdecl] = ACTIONS(2187),
    [anon_sym___clrcall] = ACTIONS(2187),
    [anon_sym___stdcall] = ACTIONS(2187),
    [anon_sym___fastcall] = ACTIONS(2187),
    [anon_sym___thiscall] = ACTIONS(2187),
    [anon_sym___vectorcall] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2189),
    [anon_sym_RBRACE] = ACTIONS(2189),
    [anon_sym_signed] = ACTIONS(2187),
    [anon_sym_unsigned] = ACTIONS(2187),
    [anon_sym_long] = ACTIONS(2187),
    [anon_sym_short] = ACTIONS(2187),
    [anon_sym_LBRACK] = ACTIONS(2187),
    [anon_sym_static] = ACTIONS(2187),
    [anon_sym_register] = ACTIONS(2187),
    [anon_sym_inline] = ACTIONS(2187),
    [anon_sym___inline] = ACTIONS(2187),
    [anon_sym___inline__] = ACTIONS(2187),
    [anon_sym___forceinline] = ACTIONS(2187),
    [anon_sym_thread_local] = ACTIONS(2187),
    [anon_sym___thread] = ACTIONS(2187),
    [anon_sym_const] = ACTIONS(2187),
    [anon_sym_constexpr] = ACTIONS(2187),
    [anon_sym_volatile] = ACTIONS(2187),
    [anon_sym_restrict] = ACTIONS(2187),
    [anon_sym___restrict__] = ACTIONS(2187),
    [anon_sym__Atomic] = ACTIONS(2187),
    [anon_sym__Noreturn] = ACTIONS(2187),
    [anon_sym_noreturn] = ACTIONS(2187),
    [anon_sym_mutable] = ACTIONS(2187),
    [anon_sym_constinit] = ACTIONS(2187),
    [anon_sym_consteval] = ACTIONS(2187),
    [anon_sym___shared__] = ACTIONS(2187),
    [anon_sym___local__] = ACTIONS(2187),
    [anon_sym___constant__] = ACTIONS(2187),
    [anon_sym___managed__] = ACTIONS(2187),
    [anon_sym___grid_constant__] = ACTIONS(2187),
    [anon_sym_alignas] = ACTIONS(2187),
    [anon_sym__Alignas] = ACTIONS(2187),
    [sym_primitive_type] = ACTIONS(2187),
    [anon_sym_enum] = ACTIONS(2187),
    [anon_sym_class] = ACTIONS(2187),
    [anon_sym_struct] = ACTIONS(2187),
    [anon_sym_union] = ACTIONS(2187),
    [anon_sym_if] = ACTIONS(2187),
    [anon_sym_switch] = ACTIONS(2187),
    [anon_sym_case] = ACTIONS(2187),
    [anon_sym_default] = ACTIONS(2187),
    [anon_sym_while] = ACTIONS(2187),
    [anon_sym_do] = ACTIONS(2187),
    [anon_sym_for] = ACTIONS(2187),
    [anon_sym_return] = ACTIONS(2187),
    [anon_sym_break] = ACTIONS(2187),
    [anon_sym_continue] = ACTIONS(2187),
    [anon_sym_goto] = ACTIONS(2187),
    [anon_sym___try] = ACTIONS(2187),
    [anon_sym___leave] = ACTIONS(2187),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_compl] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_sizeof] = ACTIONS(2187),
    [anon_sym___alignof__] = ACTIONS(2187),
    [anon_sym___alignof] = ACTIONS(2187),
    [anon_sym__alignof] = ACTIONS(2187),
    [anon_sym_alignof] = ACTIONS(2187),
    [anon_sym__Alignof] = ACTIONS(2187),
    [anon_sym_offsetof] = ACTIONS(2187),
    [anon_sym__Generic] = ACTIONS(2187),
    [anon_sym_asm] = ACTIONS(2187),
    [anon_sym___asm__] = ACTIONS(2187),
    [sym_number_literal] = ACTIONS(2189),
    [anon_sym_L_SQUOTE] = ACTIONS(2189),
    [anon_sym_u_SQUOTE] = ACTIONS(2189),
    [anon_sym_U_SQUOTE] = ACTIONS(2189),
    [anon_sym_u8_SQUOTE] = ACTIONS(2189),
    [anon_sym_SQUOTE] = ACTIONS(2189),
    [anon_sym_L_DQUOTE] = ACTIONS(2189),
    [anon_sym_u_DQUOTE] = ACTIONS(2189),
    [anon_sym_U_DQUOTE] = ACTIONS(2189),
    [anon_sym_u8_DQUOTE] = ACTIONS(2189),
    [anon_sym_DQUOTE] = ACTIONS(2189),
    [sym_true] = ACTIONS(2187),
    [sym_false] = ACTIONS(2187),
    [anon_sym_NULL] = ACTIONS(2187),
    [anon_sym_nullptr] = ACTIONS(2187),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2187),
    [anon_sym_decltype] = ACTIONS(2187),
    [sym_virtual] = ACTIONS(2187),
    [anon_sym_explicit] = ACTIONS(2187),
    [anon_sym_typename] = ACTIONS(2187),
    [anon_sym_template] = ACTIONS(2187),
    [anon_sym_operator] = ACTIONS(2187),
    [anon_sym_try] = ACTIONS(2187),
    [anon_sym_delete] = ACTIONS(2187),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_namespace] = ACTIONS(2187),
    [anon_sym_using] = ACTIONS(2187),
    [anon_sym_static_assert] = ACTIONS(2187),
    [anon_sym_concept] = ACTIONS(2187),
    [anon_sym_co_return] = ACTIONS(2187),
    [anon_sym_co_yield] = ACTIONS(2187),
    [anon_sym_R_DQUOTE] = ACTIONS(2189),
    [anon_sym_LR_DQUOTE] = ACTIONS(2189),
    [anon_sym_uR_DQUOTE] = ACTIONS(2189),
    [anon_sym_UR_DQUOTE] = ACTIONS(2189),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2189),
    [anon_sym_co_await] = ACTIONS(2187),
    [anon_sym_new] = ACTIONS(2187),
    [anon_sym_requires] = ACTIONS(2187),
    [sym_this] = ACTIONS(2187),
    [anon_sym___launch_bounds__] = ACTIONS(2187),
  },
  [582] = {
    [sym_identifier] = ACTIONS(2396),
    [aux_sym_preproc_include_token1] = ACTIONS(2396),
    [aux_sym_preproc_def_token1] = ACTIONS(2396),
    [aux_sym_preproc_if_token1] = ACTIONS(2396),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2396),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2396),
    [sym_preproc_directive] = ACTIONS(2396),
    [anon_sym_LPAREN2] = ACTIONS(2398),
    [anon_sym_BANG] = ACTIONS(2398),
    [anon_sym_TILDE] = ACTIONS(2398),
    [anon_sym_DASH] = ACTIONS(2396),
    [anon_sym_PLUS] = ACTIONS(2396),
    [anon_sym_STAR] = ACTIONS(2398),
    [anon_sym_AMP_AMP] = ACTIONS(2398),
    [anon_sym_AMP] = ACTIONS(2396),
    [anon_sym_SEMI] = ACTIONS(2398),
    [anon_sym___extension__] = ACTIONS(2396),
    [anon_sym_typedef] = ACTIONS(2396),
    [anon_sym___device__] = ACTIONS(2396),
    [anon_sym___host__] = ACTIONS(2396),
    [anon_sym___global__] = ACTIONS(2396),
    [anon_sym___forceinline__] = ACTIONS(2396),
    [anon_sym___noinline__] = ACTIONS(2396),
    [anon_sym_extern] = ACTIONS(2396),
    [anon_sym___attribute__] = ACTIONS(2396),
    [anon_sym_COLON_COLON] = ACTIONS(2398),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2398),
    [anon_sym___declspec] = ACTIONS(2396),
    [anon_sym___based] = ACTIONS(2396),
    [anon_sym___cdecl] = ACTIONS(2396),
    [anon_sym___clrcall] = ACTIONS(2396),
    [anon_sym___stdcall] = ACTIONS(2396),
    [anon_sym___fastcall] = ACTIONS(2396),
    [anon_sym___thiscall] = ACTIONS(2396),
    [anon_sym___vectorcall] = ACTIONS(2396),
    [anon_sym_LBRACE] = ACTIONS(2398),
    [anon_sym_RBRACE] = ACTIONS(2398),
    [anon_sym_signed] = ACTIONS(2396),
    [anon_sym_unsigned] = ACTIONS(2396),
    [anon_sym_long] = ACTIONS(2396),
    [anon_sym_short] = ACTIONS(2396),
    [anon_sym_LBRACK] = ACTIONS(2396),
    [anon_sym_static] = ACTIONS(2396),
    [anon_sym_register] = ACTIONS(2396),
    [anon_sym_inline] = ACTIONS(2396),
    [anon_sym___inline] = ACTIONS(2396),
    [anon_sym___inline__] = ACTIONS(2396),
    [anon_sym___forceinline] = ACTIONS(2396),
    [anon_sym_thread_local] = ACTIONS(2396),
    [anon_sym___thread] = ACTIONS(2396),
    [anon_sym_const] = ACTIONS(2396),
    [anon_sym_constexpr] = ACTIONS(2396),
    [anon_sym_volatile] = ACTIONS(2396),
    [anon_sym_restrict] = ACTIONS(2396),
    [anon_sym___restrict__] = ACTIONS(2396),
    [anon_sym__Atomic] = ACTIONS(2396),
    [anon_sym__Noreturn] = ACTIONS(2396),
    [anon_sym_noreturn] = ACTIONS(2396),
    [anon_sym_mutable] = ACTIONS(2396),
    [anon_sym_constinit] = ACTIONS(2396),
    [anon_sym_consteval] = ACTIONS(2396),
    [anon_sym___shared__] = ACTIONS(2396),
    [anon_sym___local__] = ACTIONS(2396),
    [anon_sym___constant__] = ACTIONS(2396),
    [anon_sym___managed__] = ACTIONS(2396),
    [anon_sym___grid_constant__] = ACTIONS(2396),
    [anon_sym_alignas] = ACTIONS(2396),
    [anon_sym__Alignas] = ACTIONS(2396),
    [sym_primitive_type] = ACTIONS(2396),
    [anon_sym_enum] = ACTIONS(2396),
    [anon_sym_class] = ACTIONS(2396),
    [anon_sym_struct] = ACTIONS(2396),
    [anon_sym_union] = ACTIONS(2396),
    [anon_sym_if] = ACTIONS(2396),
    [anon_sym_switch] = ACTIONS(2396),
    [anon_sym_case] = ACTIONS(2396),
    [anon_sym_default] = ACTIONS(2396),
    [anon_sym_while] = ACTIONS(2396),
    [anon_sym_do] = ACTIONS(2396),
    [anon_sym_for] = ACTIONS(2396),
    [anon_sym_return] = ACTIONS(2396),
    [anon_sym_break] = ACTIONS(2396),
    [anon_sym_continue] = ACTIONS(2396),
    [anon_sym_goto] = ACTIONS(2396),
    [anon_sym___try] = ACTIONS(2396),
    [anon_sym___leave] = ACTIONS(2396),
    [anon_sym_not] = ACTIONS(2396),
    [anon_sym_compl] = ACTIONS(2396),
    [anon_sym_DASH_DASH] = ACTIONS(2398),
    [anon_sym_PLUS_PLUS] = ACTIONS(2398),
    [anon_sym_sizeof] = ACTIONS(2396),
    [anon_sym___alignof__] = ACTIONS(2396),
    [anon_sym___alignof] = ACTIONS(2396),
    [anon_sym__alignof] = ACTIONS(2396),
    [anon_sym_alignof] = ACTIONS(2396),
    [anon_sym__Alignof] = ACTIONS(2396),
    [anon_sym_offsetof] = ACTIONS(2396),
    [anon_sym__Generic] = ACTIONS(2396),
    [anon_sym_asm] = ACTIONS(2396),
    [anon_sym___asm__] = ACTIONS(2396),
    [sym_number_literal] = ACTIONS(2398),
    [anon_sym_L_SQUOTE] = ACTIONS(2398),
    [anon_sym_u_SQUOTE] = ACTIONS(2398),
    [anon_sym_U_SQUOTE] = ACTIONS(2398),
    [anon_sym_u8_SQUOTE] = ACTIONS(2398),
    [anon_sym_SQUOTE] = ACTIONS(2398),
    [anon_sym_L_DQUOTE] = ACTIONS(2398),
    [anon_sym_u_DQUOTE] = ACTIONS(2398),
    [anon_sym_U_DQUOTE] = ACTIONS(2398),
    [anon_sym_u8_DQUOTE] = ACTIONS(2398),
    [anon_sym_DQUOTE] = ACTIONS(2398),
    [sym_true] = ACTIONS(2396),
    [sym_false] = ACTIONS(2396),
    [anon_sym_NULL] = ACTIONS(2396),
    [anon_sym_nullptr] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2396),
    [anon_sym_decltype] = ACTIONS(2396),
    [sym_virtual] = ACTIONS(2396),
    [anon_sym_explicit] = ACTIONS(2396),
    [anon_sym_typename] = ACTIONS(2396),
    [anon_sym_template] = ACTIONS(2396),
    [anon_sym_operator] = ACTIONS(2396),
    [anon_sym_try] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_throw] = ACTIONS(2396),
    [anon_sym_namespace] = ACTIONS(2396),
    [anon_sym_using] = ACTIONS(2396),
    [anon_sym_static_assert] = ACTIONS(2396),
    [anon_sym_concept] = ACTIONS(2396),
    [anon_sym_co_return] = ACTIONS(2396),
    [anon_sym_co_yield] = ACTIONS(2396),
    [anon_sym_R_DQUOTE] = ACTIONS(2398),
    [anon_sym_LR_DQUOTE] = ACTIONS(2398),
    [anon_sym_uR_DQUOTE] = ACTIONS(2398),
    [anon_sym_UR_DQUOTE] = ACTIONS(2398),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2398),
    [anon_sym_co_await] = ACTIONS(2396),
    [anon_sym_new] = ACTIONS(2396),
    [anon_sym_requires] = ACTIONS(2396),
    [sym_this] = ACTIONS(2396),
    [anon_sym___launch_bounds__] = ACTIONS(2396),
  },
  [583] = {
    [sym_type_qualifier] = STATE(3531),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4591),
    [sym_sized_type_specifier] = STATE(2599),
    [sym_enum_specifier] = STATE(2599),
    [sym_struct_specifier] = STATE(2599),
    [sym_union_specifier] = STATE(2599),
    [sym_expression] = STATE(4623),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_type_descriptor] = STATE(7171),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_placeholder_type_specifier] = STATE(2599),
    [sym_decltype_auto] = STATE(2598),
    [sym_decltype] = STATE(2477),
    [sym_class_specifier] = STATE(2599),
    [sym__class_name] = STATE(8015),
    [sym_dependent_type] = STATE(2599),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_type_parameter_pack_expansion] = STATE(7705),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5910),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [aux_sym__type_definition_type_repeat1] = STATE(3531),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2157),
    [sym_identifier] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2725),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2729),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2733),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2757),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2761),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_GT2] = ACTIONS(2829),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [584] = {
    [sym_identifier] = ACTIONS(2191),
    [aux_sym_preproc_include_token1] = ACTIONS(2191),
    [aux_sym_preproc_def_token1] = ACTIONS(2191),
    [aux_sym_preproc_if_token1] = ACTIONS(2191),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2191),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2191),
    [sym_preproc_directive] = ACTIONS(2191),
    [anon_sym_LPAREN2] = ACTIONS(2193),
    [anon_sym_BANG] = ACTIONS(2193),
    [anon_sym_TILDE] = ACTIONS(2193),
    [anon_sym_DASH] = ACTIONS(2191),
    [anon_sym_PLUS] = ACTIONS(2191),
    [anon_sym_STAR] = ACTIONS(2193),
    [anon_sym_AMP_AMP] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2191),
    [anon_sym_SEMI] = ACTIONS(2193),
    [anon_sym___extension__] = ACTIONS(2191),
    [anon_sym_typedef] = ACTIONS(2191),
    [anon_sym___device__] = ACTIONS(2191),
    [anon_sym___host__] = ACTIONS(2191),
    [anon_sym___global__] = ACTIONS(2191),
    [anon_sym___forceinline__] = ACTIONS(2191),
    [anon_sym___noinline__] = ACTIONS(2191),
    [anon_sym_extern] = ACTIONS(2191),
    [anon_sym___attribute__] = ACTIONS(2191),
    [anon_sym_COLON_COLON] = ACTIONS(2193),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2193),
    [anon_sym___declspec] = ACTIONS(2191),
    [anon_sym___based] = ACTIONS(2191),
    [anon_sym___cdecl] = ACTIONS(2191),
    [anon_sym___clrcall] = ACTIONS(2191),
    [anon_sym___stdcall] = ACTIONS(2191),
    [anon_sym___fastcall] = ACTIONS(2191),
    [anon_sym___thiscall] = ACTIONS(2191),
    [anon_sym___vectorcall] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2193),
    [anon_sym_RBRACE] = ACTIONS(2193),
    [anon_sym_signed] = ACTIONS(2191),
    [anon_sym_unsigned] = ACTIONS(2191),
    [anon_sym_long] = ACTIONS(2191),
    [anon_sym_short] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2191),
    [anon_sym_static] = ACTIONS(2191),
    [anon_sym_register] = ACTIONS(2191),
    [anon_sym_inline] = ACTIONS(2191),
    [anon_sym___inline] = ACTIONS(2191),
    [anon_sym___inline__] = ACTIONS(2191),
    [anon_sym___forceinline] = ACTIONS(2191),
    [anon_sym_thread_local] = ACTIONS(2191),
    [anon_sym___thread] = ACTIONS(2191),
    [anon_sym_const] = ACTIONS(2191),
    [anon_sym_constexpr] = ACTIONS(2191),
    [anon_sym_volatile] = ACTIONS(2191),
    [anon_sym_restrict] = ACTIONS(2191),
    [anon_sym___restrict__] = ACTIONS(2191),
    [anon_sym__Atomic] = ACTIONS(2191),
    [anon_sym__Noreturn] = ACTIONS(2191),
    [anon_sym_noreturn] = ACTIONS(2191),
    [anon_sym_mutable] = ACTIONS(2191),
    [anon_sym_constinit] = ACTIONS(2191),
    [anon_sym_consteval] = ACTIONS(2191),
    [anon_sym___shared__] = ACTIONS(2191),
    [anon_sym___local__] = ACTIONS(2191),
    [anon_sym___constant__] = ACTIONS(2191),
    [anon_sym___managed__] = ACTIONS(2191),
    [anon_sym___grid_constant__] = ACTIONS(2191),
    [anon_sym_alignas] = ACTIONS(2191),
    [anon_sym__Alignas] = ACTIONS(2191),
    [sym_primitive_type] = ACTIONS(2191),
    [anon_sym_enum] = ACTIONS(2191),
    [anon_sym_class] = ACTIONS(2191),
    [anon_sym_struct] = ACTIONS(2191),
    [anon_sym_union] = ACTIONS(2191),
    [anon_sym_if] = ACTIONS(2191),
    [anon_sym_switch] = ACTIONS(2191),
    [anon_sym_case] = ACTIONS(2191),
    [anon_sym_default] = ACTIONS(2191),
    [anon_sym_while] = ACTIONS(2191),
    [anon_sym_do] = ACTIONS(2191),
    [anon_sym_for] = ACTIONS(2191),
    [anon_sym_return] = ACTIONS(2191),
    [anon_sym_break] = ACTIONS(2191),
    [anon_sym_continue] = ACTIONS(2191),
    [anon_sym_goto] = ACTIONS(2191),
    [anon_sym___try] = ACTIONS(2191),
    [anon_sym___leave] = ACTIONS(2191),
    [anon_sym_not] = ACTIONS(2191),
    [anon_sym_compl] = ACTIONS(2191),
    [anon_sym_DASH_DASH] = ACTIONS(2193),
    [anon_sym_PLUS_PLUS] = ACTIONS(2193),
    [anon_sym_sizeof] = ACTIONS(2191),
    [anon_sym___alignof__] = ACTIONS(2191),
    [anon_sym___alignof] = ACTIONS(2191),
    [anon_sym__alignof] = ACTIONS(2191),
    [anon_sym_alignof] = ACTIONS(2191),
    [anon_sym__Alignof] = ACTIONS(2191),
    [anon_sym_offsetof] = ACTIONS(2191),
    [anon_sym__Generic] = ACTIONS(2191),
    [anon_sym_asm] = ACTIONS(2191),
    [anon_sym___asm__] = ACTIONS(2191),
    [sym_number_literal] = ACTIONS(2193),
    [anon_sym_L_SQUOTE] = ACTIONS(2193),
    [anon_sym_u_SQUOTE] = ACTIONS(2193),
    [anon_sym_U_SQUOTE] = ACTIONS(2193),
    [anon_sym_u8_SQUOTE] = ACTIONS(2193),
    [anon_sym_SQUOTE] = ACTIONS(2193),
    [anon_sym_L_DQUOTE] = ACTIONS(2193),
    [anon_sym_u_DQUOTE] = ACTIONS(2193),
    [anon_sym_U_DQUOTE] = ACTIONS(2193),
    [anon_sym_u8_DQUOTE] = ACTIONS(2193),
    [anon_sym_DQUOTE] = ACTIONS(2193),
    [sym_true] = ACTIONS(2191),
    [sym_false] = ACTIONS(2191),
    [anon_sym_NULL] = ACTIONS(2191),
    [anon_sym_nullptr] = ACTIONS(2191),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2191),
    [anon_sym_decltype] = ACTIONS(2191),
    [sym_virtual] = ACTIONS(2191),
    [anon_sym_explicit] = ACTIONS(2191),
    [anon_sym_typename] = ACTIONS(2191),
    [anon_sym_template] = ACTIONS(2191),
    [anon_sym_operator] = ACTIONS(2191),
    [anon_sym_try] = ACTIONS(2191),
    [anon_sym_delete] = ACTIONS(2191),
    [anon_sym_throw] = ACTIONS(2191),
    [anon_sym_namespace] = ACTIONS(2191),
    [anon_sym_using] = ACTIONS(2191),
    [anon_sym_static_assert] = ACTIONS(2191),
    [anon_sym_concept] = ACTIONS(2191),
    [anon_sym_co_return] = ACTIONS(2191),
    [anon_sym_co_yield] = ACTIONS(2191),
    [anon_sym_R_DQUOTE] = ACTIONS(2193),
    [anon_sym_LR_DQUOTE] = ACTIONS(2193),
    [anon_sym_uR_DQUOTE] = ACTIONS(2193),
    [anon_sym_UR_DQUOTE] = ACTIONS(2193),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2193),
    [anon_sym_co_await] = ACTIONS(2191),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_requires] = ACTIONS(2191),
    [sym_this] = ACTIONS(2191),
    [anon_sym___launch_bounds__] = ACTIONS(2191),
  },
  [585] = {
    [sym_identifier] = ACTIONS(2461),
    [aux_sym_preproc_include_token1] = ACTIONS(2461),
    [aux_sym_preproc_def_token1] = ACTIONS(2461),
    [aux_sym_preproc_if_token1] = ACTIONS(2461),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2461),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2461),
    [sym_preproc_directive] = ACTIONS(2461),
    [anon_sym_LPAREN2] = ACTIONS(2463),
    [anon_sym_BANG] = ACTIONS(2463),
    [anon_sym_TILDE] = ACTIONS(2463),
    [anon_sym_DASH] = ACTIONS(2461),
    [anon_sym_PLUS] = ACTIONS(2461),
    [anon_sym_STAR] = ACTIONS(2463),
    [anon_sym_AMP_AMP] = ACTIONS(2463),
    [anon_sym_AMP] = ACTIONS(2461),
    [anon_sym_SEMI] = ACTIONS(2463),
    [anon_sym___extension__] = ACTIONS(2461),
    [anon_sym_typedef] = ACTIONS(2461),
    [anon_sym___device__] = ACTIONS(2461),
    [anon_sym___host__] = ACTIONS(2461),
    [anon_sym___global__] = ACTIONS(2461),
    [anon_sym___forceinline__] = ACTIONS(2461),
    [anon_sym___noinline__] = ACTIONS(2461),
    [anon_sym_extern] = ACTIONS(2461),
    [anon_sym___attribute__] = ACTIONS(2461),
    [anon_sym_COLON_COLON] = ACTIONS(2463),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2463),
    [anon_sym___declspec] = ACTIONS(2461),
    [anon_sym___based] = ACTIONS(2461),
    [anon_sym___cdecl] = ACTIONS(2461),
    [anon_sym___clrcall] = ACTIONS(2461),
    [anon_sym___stdcall] = ACTIONS(2461),
    [anon_sym___fastcall] = ACTIONS(2461),
    [anon_sym___thiscall] = ACTIONS(2461),
    [anon_sym___vectorcall] = ACTIONS(2461),
    [anon_sym_LBRACE] = ACTIONS(2463),
    [anon_sym_RBRACE] = ACTIONS(2463),
    [anon_sym_signed] = ACTIONS(2461),
    [anon_sym_unsigned] = ACTIONS(2461),
    [anon_sym_long] = ACTIONS(2461),
    [anon_sym_short] = ACTIONS(2461),
    [anon_sym_LBRACK] = ACTIONS(2461),
    [anon_sym_static] = ACTIONS(2461),
    [anon_sym_register] = ACTIONS(2461),
    [anon_sym_inline] = ACTIONS(2461),
    [anon_sym___inline] = ACTIONS(2461),
    [anon_sym___inline__] = ACTIONS(2461),
    [anon_sym___forceinline] = ACTIONS(2461),
    [anon_sym_thread_local] = ACTIONS(2461),
    [anon_sym___thread] = ACTIONS(2461),
    [anon_sym_const] = ACTIONS(2461),
    [anon_sym_constexpr] = ACTIONS(2461),
    [anon_sym_volatile] = ACTIONS(2461),
    [anon_sym_restrict] = ACTIONS(2461),
    [anon_sym___restrict__] = ACTIONS(2461),
    [anon_sym__Atomic] = ACTIONS(2461),
    [anon_sym__Noreturn] = ACTIONS(2461),
    [anon_sym_noreturn] = ACTIONS(2461),
    [anon_sym_mutable] = ACTIONS(2461),
    [anon_sym_constinit] = ACTIONS(2461),
    [anon_sym_consteval] = ACTIONS(2461),
    [anon_sym___shared__] = ACTIONS(2461),
    [anon_sym___local__] = ACTIONS(2461),
    [anon_sym___constant__] = ACTIONS(2461),
    [anon_sym___managed__] = ACTIONS(2461),
    [anon_sym___grid_constant__] = ACTIONS(2461),
    [anon_sym_alignas] = ACTIONS(2461),
    [anon_sym__Alignas] = ACTIONS(2461),
    [sym_primitive_type] = ACTIONS(2461),
    [anon_sym_enum] = ACTIONS(2461),
    [anon_sym_class] = ACTIONS(2461),
    [anon_sym_struct] = ACTIONS(2461),
    [anon_sym_union] = ACTIONS(2461),
    [anon_sym_if] = ACTIONS(2461),
    [anon_sym_switch] = ACTIONS(2461),
    [anon_sym_case] = ACTIONS(2461),
    [anon_sym_default] = ACTIONS(2461),
    [anon_sym_while] = ACTIONS(2461),
    [anon_sym_do] = ACTIONS(2461),
    [anon_sym_for] = ACTIONS(2461),
    [anon_sym_return] = ACTIONS(2461),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_continue] = ACTIONS(2461),
    [anon_sym_goto] = ACTIONS(2461),
    [anon_sym___try] = ACTIONS(2461),
    [anon_sym___leave] = ACTIONS(2461),
    [anon_sym_not] = ACTIONS(2461),
    [anon_sym_compl] = ACTIONS(2461),
    [anon_sym_DASH_DASH] = ACTIONS(2463),
    [anon_sym_PLUS_PLUS] = ACTIONS(2463),
    [anon_sym_sizeof] = ACTIONS(2461),
    [anon_sym___alignof__] = ACTIONS(2461),
    [anon_sym___alignof] = ACTIONS(2461),
    [anon_sym__alignof] = ACTIONS(2461),
    [anon_sym_alignof] = ACTIONS(2461),
    [anon_sym__Alignof] = ACTIONS(2461),
    [anon_sym_offsetof] = ACTIONS(2461),
    [anon_sym__Generic] = ACTIONS(2461),
    [anon_sym_asm] = ACTIONS(2461),
    [anon_sym___asm__] = ACTIONS(2461),
    [sym_number_literal] = ACTIONS(2463),
    [anon_sym_L_SQUOTE] = ACTIONS(2463),
    [anon_sym_u_SQUOTE] = ACTIONS(2463),
    [anon_sym_U_SQUOTE] = ACTIONS(2463),
    [anon_sym_u8_SQUOTE] = ACTIONS(2463),
    [anon_sym_SQUOTE] = ACTIONS(2463),
    [anon_sym_L_DQUOTE] = ACTIONS(2463),
    [anon_sym_u_DQUOTE] = ACTIONS(2463),
    [anon_sym_U_DQUOTE] = ACTIONS(2463),
    [anon_sym_u8_DQUOTE] = ACTIONS(2463),
    [anon_sym_DQUOTE] = ACTIONS(2463),
    [sym_true] = ACTIONS(2461),
    [sym_false] = ACTIONS(2461),
    [anon_sym_NULL] = ACTIONS(2461),
    [anon_sym_nullptr] = ACTIONS(2461),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2461),
    [anon_sym_decltype] = ACTIONS(2461),
    [sym_virtual] = ACTIONS(2461),
    [anon_sym_explicit] = ACTIONS(2461),
    [anon_sym_typename] = ACTIONS(2461),
    [anon_sym_template] = ACTIONS(2461),
    [anon_sym_operator] = ACTIONS(2461),
    [anon_sym_try] = ACTIONS(2461),
    [anon_sym_delete] = ACTIONS(2461),
    [anon_sym_throw] = ACTIONS(2461),
    [anon_sym_namespace] = ACTIONS(2461),
    [anon_sym_using] = ACTIONS(2461),
    [anon_sym_static_assert] = ACTIONS(2461),
    [anon_sym_concept] = ACTIONS(2461),
    [anon_sym_co_return] = ACTIONS(2461),
    [anon_sym_co_yield] = ACTIONS(2461),
    [anon_sym_R_DQUOTE] = ACTIONS(2463),
    [anon_sym_LR_DQUOTE] = ACTIONS(2463),
    [anon_sym_uR_DQUOTE] = ACTIONS(2463),
    [anon_sym_UR_DQUOTE] = ACTIONS(2463),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2463),
    [anon_sym_co_await] = ACTIONS(2461),
    [anon_sym_new] = ACTIONS(2461),
    [anon_sym_requires] = ACTIONS(2461),
    [sym_this] = ACTIONS(2461),
    [anon_sym___launch_bounds__] = ACTIONS(2461),
  },
  [586] = {
    [sym_catch_clause] = STATE(282),
    [aux_sym_constructor_try_statement_repeat1] = STATE(282),
    [ts_builtin_sym_end] = ACTIONS(1918),
    [sym_identifier] = ACTIONS(1916),
    [aux_sym_preproc_include_token1] = ACTIONS(1916),
    [aux_sym_preproc_def_token1] = ACTIONS(1916),
    [aux_sym_preproc_if_token1] = ACTIONS(1916),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1916),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1916),
    [sym_preproc_directive] = ACTIONS(1916),
    [anon_sym_LPAREN2] = ACTIONS(1918),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [anon_sym_DASH] = ACTIONS(1916),
    [anon_sym_PLUS] = ACTIONS(1916),
    [anon_sym_STAR] = ACTIONS(1918),
    [anon_sym_AMP_AMP] = ACTIONS(1918),
    [anon_sym_AMP] = ACTIONS(1916),
    [anon_sym___extension__] = ACTIONS(1916),
    [anon_sym_typedef] = ACTIONS(1916),
    [anon_sym___device__] = ACTIONS(1916),
    [anon_sym___host__] = ACTIONS(1916),
    [anon_sym___global__] = ACTIONS(1916),
    [anon_sym___forceinline__] = ACTIONS(1916),
    [anon_sym___noinline__] = ACTIONS(1916),
    [anon_sym_extern] = ACTIONS(1916),
    [anon_sym___attribute__] = ACTIONS(1916),
    [anon_sym_COLON_COLON] = ACTIONS(1918),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1918),
    [anon_sym___declspec] = ACTIONS(1916),
    [anon_sym___based] = ACTIONS(1916),
    [anon_sym___cdecl] = ACTIONS(1916),
    [anon_sym___clrcall] = ACTIONS(1916),
    [anon_sym___stdcall] = ACTIONS(1916),
    [anon_sym___fastcall] = ACTIONS(1916),
    [anon_sym___thiscall] = ACTIONS(1916),
    [anon_sym___vectorcall] = ACTIONS(1916),
    [anon_sym_LBRACE] = ACTIONS(1918),
    [anon_sym_signed] = ACTIONS(1916),
    [anon_sym_unsigned] = ACTIONS(1916),
    [anon_sym_long] = ACTIONS(1916),
    [anon_sym_short] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1916),
    [anon_sym_static] = ACTIONS(1916),
    [anon_sym_register] = ACTIONS(1916),
    [anon_sym_inline] = ACTIONS(1916),
    [anon_sym___inline] = ACTIONS(1916),
    [anon_sym___inline__] = ACTIONS(1916),
    [anon_sym___forceinline] = ACTIONS(1916),
    [anon_sym_thread_local] = ACTIONS(1916),
    [anon_sym___thread] = ACTIONS(1916),
    [anon_sym_const] = ACTIONS(1916),
    [anon_sym_constexpr] = ACTIONS(1916),
    [anon_sym_volatile] = ACTIONS(1916),
    [anon_sym_restrict] = ACTIONS(1916),
    [anon_sym___restrict__] = ACTIONS(1916),
    [anon_sym__Atomic] = ACTIONS(1916),
    [anon_sym__Noreturn] = ACTIONS(1916),
    [anon_sym_noreturn] = ACTIONS(1916),
    [anon_sym_mutable] = ACTIONS(1916),
    [anon_sym_constinit] = ACTIONS(1916),
    [anon_sym_consteval] = ACTIONS(1916),
    [anon_sym___shared__] = ACTIONS(1916),
    [anon_sym___local__] = ACTIONS(1916),
    [anon_sym___constant__] = ACTIONS(1916),
    [anon_sym___managed__] = ACTIONS(1916),
    [anon_sym___grid_constant__] = ACTIONS(1916),
    [anon_sym_alignas] = ACTIONS(1916),
    [anon_sym__Alignas] = ACTIONS(1916),
    [sym_primitive_type] = ACTIONS(1916),
    [anon_sym_enum] = ACTIONS(1916),
    [anon_sym_class] = ACTIONS(1916),
    [anon_sym_struct] = ACTIONS(1916),
    [anon_sym_union] = ACTIONS(1916),
    [anon_sym_if] = ACTIONS(1916),
    [anon_sym_switch] = ACTIONS(1916),
    [anon_sym_case] = ACTIONS(1916),
    [anon_sym_default] = ACTIONS(1916),
    [anon_sym_while] = ACTIONS(1916),
    [anon_sym_do] = ACTIONS(1916),
    [anon_sym_for] = ACTIONS(1916),
    [anon_sym_return] = ACTIONS(1916),
    [anon_sym_break] = ACTIONS(1916),
    [anon_sym_continue] = ACTIONS(1916),
    [anon_sym_goto] = ACTIONS(1916),
    [anon_sym_not] = ACTIONS(1916),
    [anon_sym_compl] = ACTIONS(1916),
    [anon_sym_DASH_DASH] = ACTIONS(1918),
    [anon_sym_PLUS_PLUS] = ACTIONS(1918),
    [anon_sym_sizeof] = ACTIONS(1916),
    [anon_sym___alignof__] = ACTIONS(1916),
    [anon_sym___alignof] = ACTIONS(1916),
    [anon_sym__alignof] = ACTIONS(1916),
    [anon_sym_alignof] = ACTIONS(1916),
    [anon_sym__Alignof] = ACTIONS(1916),
    [anon_sym_offsetof] = ACTIONS(1916),
    [anon_sym__Generic] = ACTIONS(1916),
    [anon_sym_asm] = ACTIONS(1916),
    [anon_sym___asm__] = ACTIONS(1916),
    [sym_number_literal] = ACTIONS(1918),
    [anon_sym_L_SQUOTE] = ACTIONS(1918),
    [anon_sym_u_SQUOTE] = ACTIONS(1918),
    [anon_sym_U_SQUOTE] = ACTIONS(1918),
    [anon_sym_u8_SQUOTE] = ACTIONS(1918),
    [anon_sym_SQUOTE] = ACTIONS(1918),
    [anon_sym_L_DQUOTE] = ACTIONS(1918),
    [anon_sym_u_DQUOTE] = ACTIONS(1918),
    [anon_sym_U_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8_DQUOTE] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1918),
    [sym_true] = ACTIONS(1916),
    [sym_false] = ACTIONS(1916),
    [anon_sym_NULL] = ACTIONS(1916),
    [anon_sym_nullptr] = ACTIONS(1916),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1916),
    [anon_sym_decltype] = ACTIONS(1916),
    [sym_virtual] = ACTIONS(1916),
    [anon_sym_explicit] = ACTIONS(1916),
    [anon_sym_typename] = ACTIONS(1916),
    [anon_sym_template] = ACTIONS(1916),
    [anon_sym_operator] = ACTIONS(1916),
    [anon_sym_try] = ACTIONS(1916),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_throw] = ACTIONS(1916),
    [anon_sym_namespace] = ACTIONS(1916),
    [anon_sym_using] = ACTIONS(1916),
    [anon_sym_static_assert] = ACTIONS(1916),
    [anon_sym_concept] = ACTIONS(1916),
    [anon_sym_co_return] = ACTIONS(1916),
    [anon_sym_co_yield] = ACTIONS(1916),
    [anon_sym_catch] = ACTIONS(2320),
    [anon_sym_R_DQUOTE] = ACTIONS(1918),
    [anon_sym_LR_DQUOTE] = ACTIONS(1918),
    [anon_sym_uR_DQUOTE] = ACTIONS(1918),
    [anon_sym_UR_DQUOTE] = ACTIONS(1918),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1918),
    [anon_sym_co_await] = ACTIONS(1916),
    [anon_sym_new] = ACTIONS(1916),
    [anon_sym_requires] = ACTIONS(1916),
    [sym_this] = ACTIONS(1916),
    [anon_sym___launch_bounds__] = ACTIONS(1916),
  },
  [587] = {
    [sym_identifier] = ACTIONS(2504),
    [aux_sym_preproc_include_token1] = ACTIONS(2504),
    [aux_sym_preproc_def_token1] = ACTIONS(2504),
    [aux_sym_preproc_if_token1] = ACTIONS(2504),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2504),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2504),
    [sym_preproc_directive] = ACTIONS(2504),
    [anon_sym_LPAREN2] = ACTIONS(2506),
    [anon_sym_BANG] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2506),
    [anon_sym_DASH] = ACTIONS(2504),
    [anon_sym_PLUS] = ACTIONS(2504),
    [anon_sym_STAR] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2504),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym___extension__] = ACTIONS(2504),
    [anon_sym_typedef] = ACTIONS(2504),
    [anon_sym___device__] = ACTIONS(2504),
    [anon_sym___host__] = ACTIONS(2504),
    [anon_sym___global__] = ACTIONS(2504),
    [anon_sym___forceinline__] = ACTIONS(2504),
    [anon_sym___noinline__] = ACTIONS(2504),
    [anon_sym_extern] = ACTIONS(2504),
    [anon_sym___attribute__] = ACTIONS(2504),
    [anon_sym_COLON_COLON] = ACTIONS(2506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2506),
    [anon_sym___declspec] = ACTIONS(2504),
    [anon_sym___based] = ACTIONS(2504),
    [anon_sym___cdecl] = ACTIONS(2504),
    [anon_sym___clrcall] = ACTIONS(2504),
    [anon_sym___stdcall] = ACTIONS(2504),
    [anon_sym___fastcall] = ACTIONS(2504),
    [anon_sym___thiscall] = ACTIONS(2504),
    [anon_sym___vectorcall] = ACTIONS(2504),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_RBRACE] = ACTIONS(2506),
    [anon_sym_signed] = ACTIONS(2504),
    [anon_sym_unsigned] = ACTIONS(2504),
    [anon_sym_long] = ACTIONS(2504),
    [anon_sym_short] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(2504),
    [anon_sym_static] = ACTIONS(2504),
    [anon_sym_register] = ACTIONS(2504),
    [anon_sym_inline] = ACTIONS(2504),
    [anon_sym___inline] = ACTIONS(2504),
    [anon_sym___inline__] = ACTIONS(2504),
    [anon_sym___forceinline] = ACTIONS(2504),
    [anon_sym_thread_local] = ACTIONS(2504),
    [anon_sym___thread] = ACTIONS(2504),
    [anon_sym_const] = ACTIONS(2504),
    [anon_sym_constexpr] = ACTIONS(2504),
    [anon_sym_volatile] = ACTIONS(2504),
    [anon_sym_restrict] = ACTIONS(2504),
    [anon_sym___restrict__] = ACTIONS(2504),
    [anon_sym__Atomic] = ACTIONS(2504),
    [anon_sym__Noreturn] = ACTIONS(2504),
    [anon_sym_noreturn] = ACTIONS(2504),
    [anon_sym_mutable] = ACTIONS(2504),
    [anon_sym_constinit] = ACTIONS(2504),
    [anon_sym_consteval] = ACTIONS(2504),
    [anon_sym___shared__] = ACTIONS(2504),
    [anon_sym___local__] = ACTIONS(2504),
    [anon_sym___constant__] = ACTIONS(2504),
    [anon_sym___managed__] = ACTIONS(2504),
    [anon_sym___grid_constant__] = ACTIONS(2504),
    [anon_sym_alignas] = ACTIONS(2504),
    [anon_sym__Alignas] = ACTIONS(2504),
    [sym_primitive_type] = ACTIONS(2504),
    [anon_sym_enum] = ACTIONS(2504),
    [anon_sym_class] = ACTIONS(2504),
    [anon_sym_struct] = ACTIONS(2504),
    [anon_sym_union] = ACTIONS(2504),
    [anon_sym_if] = ACTIONS(2504),
    [anon_sym_switch] = ACTIONS(2504),
    [anon_sym_case] = ACTIONS(2504),
    [anon_sym_default] = ACTIONS(2504),
    [anon_sym_while] = ACTIONS(2504),
    [anon_sym_do] = ACTIONS(2504),
    [anon_sym_for] = ACTIONS(2504),
    [anon_sym_return] = ACTIONS(2504),
    [anon_sym_break] = ACTIONS(2504),
    [anon_sym_continue] = ACTIONS(2504),
    [anon_sym_goto] = ACTIONS(2504),
    [anon_sym___try] = ACTIONS(2504),
    [anon_sym___leave] = ACTIONS(2504),
    [anon_sym_not] = ACTIONS(2504),
    [anon_sym_compl] = ACTIONS(2504),
    [anon_sym_DASH_DASH] = ACTIONS(2506),
    [anon_sym_PLUS_PLUS] = ACTIONS(2506),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(2504),
    [anon_sym___alignof] = ACTIONS(2504),
    [anon_sym__alignof] = ACTIONS(2504),
    [anon_sym_alignof] = ACTIONS(2504),
    [anon_sym__Alignof] = ACTIONS(2504),
    [anon_sym_offsetof] = ACTIONS(2504),
    [anon_sym__Generic] = ACTIONS(2504),
    [anon_sym_asm] = ACTIONS(2504),
    [anon_sym___asm__] = ACTIONS(2504),
    [sym_number_literal] = ACTIONS(2506),
    [anon_sym_L_SQUOTE] = ACTIONS(2506),
    [anon_sym_u_SQUOTE] = ACTIONS(2506),
    [anon_sym_U_SQUOTE] = ACTIONS(2506),
    [anon_sym_u8_SQUOTE] = ACTIONS(2506),
    [anon_sym_SQUOTE] = ACTIONS(2506),
    [anon_sym_L_DQUOTE] = ACTIONS(2506),
    [anon_sym_u_DQUOTE] = ACTIONS(2506),
    [anon_sym_U_DQUOTE] = ACTIONS(2506),
    [anon_sym_u8_DQUOTE] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [sym_true] = ACTIONS(2504),
    [sym_false] = ACTIONS(2504),
    [anon_sym_NULL] = ACTIONS(2504),
    [anon_sym_nullptr] = ACTIONS(2504),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2504),
    [anon_sym_decltype] = ACTIONS(2504),
    [sym_virtual] = ACTIONS(2504),
    [anon_sym_explicit] = ACTIONS(2504),
    [anon_sym_typename] = ACTIONS(2504),
    [anon_sym_template] = ACTIONS(2504),
    [anon_sym_operator] = ACTIONS(2504),
    [anon_sym_try] = ACTIONS(2504),
    [anon_sym_delete] = ACTIONS(2504),
    [anon_sym_throw] = ACTIONS(2504),
    [anon_sym_namespace] = ACTIONS(2504),
    [anon_sym_using] = ACTIONS(2504),
    [anon_sym_static_assert] = ACTIONS(2504),
    [anon_sym_concept] = ACTIONS(2504),
    [anon_sym_co_return] = ACTIONS(2504),
    [anon_sym_co_yield] = ACTIONS(2504),
    [anon_sym_R_DQUOTE] = ACTIONS(2506),
    [anon_sym_LR_DQUOTE] = ACTIONS(2506),
    [anon_sym_uR_DQUOTE] = ACTIONS(2506),
    [anon_sym_UR_DQUOTE] = ACTIONS(2506),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2506),
    [anon_sym_co_await] = ACTIONS(2504),
    [anon_sym_new] = ACTIONS(2504),
    [anon_sym_requires] = ACTIONS(2504),
    [sym_this] = ACTIONS(2504),
    [anon_sym___launch_bounds__] = ACTIONS(2504),
  },
  [588] = {
    [sym_identifier] = ACTIONS(2158),
    [aux_sym_preproc_include_token1] = ACTIONS(2158),
    [aux_sym_preproc_def_token1] = ACTIONS(2158),
    [aux_sym_preproc_if_token1] = ACTIONS(2158),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2158),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2158),
    [sym_preproc_directive] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_STAR] = ACTIONS(2160),
    [anon_sym_AMP_AMP] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym___extension__] = ACTIONS(2158),
    [anon_sym_typedef] = ACTIONS(2158),
    [anon_sym___device__] = ACTIONS(2158),
    [anon_sym___host__] = ACTIONS(2158),
    [anon_sym___global__] = ACTIONS(2158),
    [anon_sym___forceinline__] = ACTIONS(2158),
    [anon_sym___noinline__] = ACTIONS(2158),
    [anon_sym_extern] = ACTIONS(2158),
    [anon_sym___attribute__] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2160),
    [anon_sym___declspec] = ACTIONS(2158),
    [anon_sym___based] = ACTIONS(2158),
    [anon_sym___cdecl] = ACTIONS(2158),
    [anon_sym___clrcall] = ACTIONS(2158),
    [anon_sym___stdcall] = ACTIONS(2158),
    [anon_sym___fastcall] = ACTIONS(2158),
    [anon_sym___thiscall] = ACTIONS(2158),
    [anon_sym___vectorcall] = ACTIONS(2158),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_signed] = ACTIONS(2158),
    [anon_sym_unsigned] = ACTIONS(2158),
    [anon_sym_long] = ACTIONS(2158),
    [anon_sym_short] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_static] = ACTIONS(2158),
    [anon_sym_register] = ACTIONS(2158),
    [anon_sym_inline] = ACTIONS(2158),
    [anon_sym___inline] = ACTIONS(2158),
    [anon_sym___inline__] = ACTIONS(2158),
    [anon_sym___forceinline] = ACTIONS(2158),
    [anon_sym_thread_local] = ACTIONS(2158),
    [anon_sym___thread] = ACTIONS(2158),
    [anon_sym_const] = ACTIONS(2158),
    [anon_sym_constexpr] = ACTIONS(2158),
    [anon_sym_volatile] = ACTIONS(2158),
    [anon_sym_restrict] = ACTIONS(2158),
    [anon_sym___restrict__] = ACTIONS(2158),
    [anon_sym__Atomic] = ACTIONS(2158),
    [anon_sym__Noreturn] = ACTIONS(2158),
    [anon_sym_noreturn] = ACTIONS(2158),
    [anon_sym_mutable] = ACTIONS(2158),
    [anon_sym_constinit] = ACTIONS(2158),
    [anon_sym_consteval] = ACTIONS(2158),
    [anon_sym___shared__] = ACTIONS(2158),
    [anon_sym___local__] = ACTIONS(2158),
    [anon_sym___constant__] = ACTIONS(2158),
    [anon_sym___managed__] = ACTIONS(2158),
    [anon_sym___grid_constant__] = ACTIONS(2158),
    [anon_sym_alignas] = ACTIONS(2158),
    [anon_sym__Alignas] = ACTIONS(2158),
    [sym_primitive_type] = ACTIONS(2158),
    [anon_sym_enum] = ACTIONS(2158),
    [anon_sym_class] = ACTIONS(2158),
    [anon_sym_struct] = ACTIONS(2158),
    [anon_sym_union] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_switch] = ACTIONS(2158),
    [anon_sym_case] = ACTIONS(2158),
    [anon_sym_default] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_break] = ACTIONS(2158),
    [anon_sym_continue] = ACTIONS(2158),
    [anon_sym_goto] = ACTIONS(2158),
    [anon_sym___try] = ACTIONS(2158),
    [anon_sym___leave] = ACTIONS(2158),
    [anon_sym_not] = ACTIONS(2158),
    [anon_sym_compl] = ACTIONS(2158),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_sizeof] = ACTIONS(2158),
    [anon_sym___alignof__] = ACTIONS(2158),
    [anon_sym___alignof] = ACTIONS(2158),
    [anon_sym__alignof] = ACTIONS(2158),
    [anon_sym_alignof] = ACTIONS(2158),
    [anon_sym__Alignof] = ACTIONS(2158),
    [anon_sym_offsetof] = ACTIONS(2158),
    [anon_sym__Generic] = ACTIONS(2158),
    [anon_sym_asm] = ACTIONS(2158),
    [anon_sym___asm__] = ACTIONS(2158),
    [sym_number_literal] = ACTIONS(2160),
    [anon_sym_L_SQUOTE] = ACTIONS(2160),
    [anon_sym_u_SQUOTE] = ACTIONS(2160),
    [anon_sym_U_SQUOTE] = ACTIONS(2160),
    [anon_sym_u8_SQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_L_DQUOTE] = ACTIONS(2160),
    [anon_sym_u_DQUOTE] = ACTIONS(2160),
    [anon_sym_U_DQUOTE] = ACTIONS(2160),
    [anon_sym_u8_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [sym_true] = ACTIONS(2158),
    [sym_false] = ACTIONS(2158),
    [anon_sym_NULL] = ACTIONS(2158),
    [anon_sym_nullptr] = ACTIONS(2158),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2158),
    [anon_sym_decltype] = ACTIONS(2158),
    [sym_virtual] = ACTIONS(2158),
    [anon_sym_explicit] = ACTIONS(2158),
    [anon_sym_typename] = ACTIONS(2158),
    [anon_sym_template] = ACTIONS(2158),
    [anon_sym_operator] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_delete] = ACTIONS(2158),
    [anon_sym_throw] = ACTIONS(2158),
    [anon_sym_namespace] = ACTIONS(2158),
    [anon_sym_using] = ACTIONS(2158),
    [anon_sym_static_assert] = ACTIONS(2158),
    [anon_sym_concept] = ACTIONS(2158),
    [anon_sym_co_return] = ACTIONS(2158),
    [anon_sym_co_yield] = ACTIONS(2158),
    [anon_sym_R_DQUOTE] = ACTIONS(2160),
    [anon_sym_LR_DQUOTE] = ACTIONS(2160),
    [anon_sym_uR_DQUOTE] = ACTIONS(2160),
    [anon_sym_UR_DQUOTE] = ACTIONS(2160),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2160),
    [anon_sym_co_await] = ACTIONS(2158),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_requires] = ACTIONS(2158),
    [sym_this] = ACTIONS(2158),
    [anon_sym___launch_bounds__] = ACTIONS(2158),
  },
  [589] = {
    [sym_type_qualifier] = STATE(3531),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4591),
    [sym_sized_type_specifier] = STATE(2599),
    [sym_enum_specifier] = STATE(2599),
    [sym_struct_specifier] = STATE(2599),
    [sym_union_specifier] = STATE(2599),
    [sym_expression] = STATE(4644),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_type_descriptor] = STATE(7160),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_placeholder_type_specifier] = STATE(2599),
    [sym_decltype_auto] = STATE(2598),
    [sym_decltype] = STATE(2477),
    [sym_class_specifier] = STATE(2599),
    [sym__class_name] = STATE(8015),
    [sym_dependent_type] = STATE(2599),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_type_parameter_pack_expansion] = STATE(7727),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5910),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [aux_sym__type_definition_type_repeat1] = STATE(3531),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2157),
    [sym_identifier] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2725),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2729),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2733),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2757),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2761),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_GT2] = ACTIONS(2831),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [590] = {
    [sym_type_qualifier] = STATE(3531),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4591),
    [sym_sized_type_specifier] = STATE(2599),
    [sym_enum_specifier] = STATE(2599),
    [sym_struct_specifier] = STATE(2599),
    [sym_union_specifier] = STATE(2599),
    [sym_expression] = STATE(4686),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_type_descriptor] = STATE(7108),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_placeholder_type_specifier] = STATE(2599),
    [sym_decltype_auto] = STATE(2598),
    [sym_decltype] = STATE(2477),
    [sym_class_specifier] = STATE(2599),
    [sym__class_name] = STATE(8015),
    [sym_dependent_type] = STATE(2599),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_type_parameter_pack_expansion] = STATE(7808),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5910),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [aux_sym__type_definition_type_repeat1] = STATE(3531),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2157),
    [sym_identifier] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2725),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2729),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2733),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2757),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2761),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_GT2] = ACTIONS(2833),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [591] = {
    [sym_identifier] = ACTIONS(2477),
    [aux_sym_preproc_include_token1] = ACTIONS(2477),
    [aux_sym_preproc_def_token1] = ACTIONS(2477),
    [aux_sym_preproc_if_token1] = ACTIONS(2477),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2477),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2477),
    [sym_preproc_directive] = ACTIONS(2477),
    [anon_sym_LPAREN2] = ACTIONS(2479),
    [anon_sym_BANG] = ACTIONS(2479),
    [anon_sym_TILDE] = ACTIONS(2479),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_STAR] = ACTIONS(2479),
    [anon_sym_AMP_AMP] = ACTIONS(2479),
    [anon_sym_AMP] = ACTIONS(2477),
    [anon_sym_SEMI] = ACTIONS(2479),
    [anon_sym___extension__] = ACTIONS(2477),
    [anon_sym_typedef] = ACTIONS(2477),
    [anon_sym___device__] = ACTIONS(2477),
    [anon_sym___host__] = ACTIONS(2477),
    [anon_sym___global__] = ACTIONS(2477),
    [anon_sym___forceinline__] = ACTIONS(2477),
    [anon_sym___noinline__] = ACTIONS(2477),
    [anon_sym_extern] = ACTIONS(2477),
    [anon_sym___attribute__] = ACTIONS(2477),
    [anon_sym_COLON_COLON] = ACTIONS(2479),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2479),
    [anon_sym___declspec] = ACTIONS(2477),
    [anon_sym___based] = ACTIONS(2477),
    [anon_sym___cdecl] = ACTIONS(2477),
    [anon_sym___clrcall] = ACTIONS(2477),
    [anon_sym___stdcall] = ACTIONS(2477),
    [anon_sym___fastcall] = ACTIONS(2477),
    [anon_sym___thiscall] = ACTIONS(2477),
    [anon_sym___vectorcall] = ACTIONS(2477),
    [anon_sym_LBRACE] = ACTIONS(2479),
    [anon_sym_RBRACE] = ACTIONS(2479),
    [anon_sym_signed] = ACTIONS(2477),
    [anon_sym_unsigned] = ACTIONS(2477),
    [anon_sym_long] = ACTIONS(2477),
    [anon_sym_short] = ACTIONS(2477),
    [anon_sym_LBRACK] = ACTIONS(2477),
    [anon_sym_static] = ACTIONS(2477),
    [anon_sym_register] = ACTIONS(2477),
    [anon_sym_inline] = ACTIONS(2477),
    [anon_sym___inline] = ACTIONS(2477),
    [anon_sym___inline__] = ACTIONS(2477),
    [anon_sym___forceinline] = ACTIONS(2477),
    [anon_sym_thread_local] = ACTIONS(2477),
    [anon_sym___thread] = ACTIONS(2477),
    [anon_sym_const] = ACTIONS(2477),
    [anon_sym_constexpr] = ACTIONS(2477),
    [anon_sym_volatile] = ACTIONS(2477),
    [anon_sym_restrict] = ACTIONS(2477),
    [anon_sym___restrict__] = ACTIONS(2477),
    [anon_sym__Atomic] = ACTIONS(2477),
    [anon_sym__Noreturn] = ACTIONS(2477),
    [anon_sym_noreturn] = ACTIONS(2477),
    [anon_sym_mutable] = ACTIONS(2477),
    [anon_sym_constinit] = ACTIONS(2477),
    [anon_sym_consteval] = ACTIONS(2477),
    [anon_sym___shared__] = ACTIONS(2477),
    [anon_sym___local__] = ACTIONS(2477),
    [anon_sym___constant__] = ACTIONS(2477),
    [anon_sym___managed__] = ACTIONS(2477),
    [anon_sym___grid_constant__] = ACTIONS(2477),
    [anon_sym_alignas] = ACTIONS(2477),
    [anon_sym__Alignas] = ACTIONS(2477),
    [sym_primitive_type] = ACTIONS(2477),
    [anon_sym_enum] = ACTIONS(2477),
    [anon_sym_class] = ACTIONS(2477),
    [anon_sym_struct] = ACTIONS(2477),
    [anon_sym_union] = ACTIONS(2477),
    [anon_sym_if] = ACTIONS(2477),
    [anon_sym_switch] = ACTIONS(2477),
    [anon_sym_case] = ACTIONS(2477),
    [anon_sym_default] = ACTIONS(2477),
    [anon_sym_while] = ACTIONS(2477),
    [anon_sym_do] = ACTIONS(2477),
    [anon_sym_for] = ACTIONS(2477),
    [anon_sym_return] = ACTIONS(2477),
    [anon_sym_break] = ACTIONS(2477),
    [anon_sym_continue] = ACTIONS(2477),
    [anon_sym_goto] = ACTIONS(2477),
    [anon_sym___try] = ACTIONS(2477),
    [anon_sym___leave] = ACTIONS(2477),
    [anon_sym_not] = ACTIONS(2477),
    [anon_sym_compl] = ACTIONS(2477),
    [anon_sym_DASH_DASH] = ACTIONS(2479),
    [anon_sym_PLUS_PLUS] = ACTIONS(2479),
    [anon_sym_sizeof] = ACTIONS(2477),
    [anon_sym___alignof__] = ACTIONS(2477),
    [anon_sym___alignof] = ACTIONS(2477),
    [anon_sym__alignof] = ACTIONS(2477),
    [anon_sym_alignof] = ACTIONS(2477),
    [anon_sym__Alignof] = ACTIONS(2477),
    [anon_sym_offsetof] = ACTIONS(2477),
    [anon_sym__Generic] = ACTIONS(2477),
    [anon_sym_asm] = ACTIONS(2477),
    [anon_sym___asm__] = ACTIONS(2477),
    [sym_number_literal] = ACTIONS(2479),
    [anon_sym_L_SQUOTE] = ACTIONS(2479),
    [anon_sym_u_SQUOTE] = ACTIONS(2479),
    [anon_sym_U_SQUOTE] = ACTIONS(2479),
    [anon_sym_u8_SQUOTE] = ACTIONS(2479),
    [anon_sym_SQUOTE] = ACTIONS(2479),
    [anon_sym_L_DQUOTE] = ACTIONS(2479),
    [anon_sym_u_DQUOTE] = ACTIONS(2479),
    [anon_sym_U_DQUOTE] = ACTIONS(2479),
    [anon_sym_u8_DQUOTE] = ACTIONS(2479),
    [anon_sym_DQUOTE] = ACTIONS(2479),
    [sym_true] = ACTIONS(2477),
    [sym_false] = ACTIONS(2477),
    [anon_sym_NULL] = ACTIONS(2477),
    [anon_sym_nullptr] = ACTIONS(2477),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2477),
    [anon_sym_decltype] = ACTIONS(2477),
    [sym_virtual] = ACTIONS(2477),
    [anon_sym_explicit] = ACTIONS(2477),
    [anon_sym_typename] = ACTIONS(2477),
    [anon_sym_template] = ACTIONS(2477),
    [anon_sym_operator] = ACTIONS(2477),
    [anon_sym_try] = ACTIONS(2477),
    [anon_sym_delete] = ACTIONS(2477),
    [anon_sym_throw] = ACTIONS(2477),
    [anon_sym_namespace] = ACTIONS(2477),
    [anon_sym_using] = ACTIONS(2477),
    [anon_sym_static_assert] = ACTIONS(2477),
    [anon_sym_concept] = ACTIONS(2477),
    [anon_sym_co_return] = ACTIONS(2477),
    [anon_sym_co_yield] = ACTIONS(2477),
    [anon_sym_R_DQUOTE] = ACTIONS(2479),
    [anon_sym_LR_DQUOTE] = ACTIONS(2479),
    [anon_sym_uR_DQUOTE] = ACTIONS(2479),
    [anon_sym_UR_DQUOTE] = ACTIONS(2479),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2479),
    [anon_sym_co_await] = ACTIONS(2477),
    [anon_sym_new] = ACTIONS(2477),
    [anon_sym_requires] = ACTIONS(2477),
    [sym_this] = ACTIONS(2477),
    [anon_sym___launch_bounds__] = ACTIONS(2477),
  },
  [592] = {
    [sym_identifier] = ACTIONS(2288),
    [aux_sym_preproc_include_token1] = ACTIONS(2288),
    [aux_sym_preproc_def_token1] = ACTIONS(2288),
    [aux_sym_preproc_if_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2288),
    [sym_preproc_directive] = ACTIONS(2288),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym_typedef] = ACTIONS(2288),
    [anon_sym___device__] = ACTIONS(2288),
    [anon_sym___host__] = ACTIONS(2288),
    [anon_sym___global__] = ACTIONS(2288),
    [anon_sym___forceinline__] = ACTIONS(2288),
    [anon_sym___noinline__] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2290),
    [anon_sym___declspec] = ACTIONS(2288),
    [anon_sym___based] = ACTIONS(2288),
    [anon_sym___cdecl] = ACTIONS(2288),
    [anon_sym___clrcall] = ACTIONS(2288),
    [anon_sym___stdcall] = ACTIONS(2288),
    [anon_sym___fastcall] = ACTIONS(2288),
    [anon_sym___thiscall] = ACTIONS(2288),
    [anon_sym___vectorcall] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_RBRACE] = ACTIONS(2290),
    [anon_sym_signed] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym___inline] = ACTIONS(2288),
    [anon_sym___inline__] = ACTIONS(2288),
    [anon_sym___forceinline] = ACTIONS(2288),
    [anon_sym_thread_local] = ACTIONS(2288),
    [anon_sym___thread] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym___shared__] = ACTIONS(2288),
    [anon_sym___local__] = ACTIONS(2288),
    [anon_sym___constant__] = ACTIONS(2288),
    [anon_sym___managed__] = ACTIONS(2288),
    [anon_sym___grid_constant__] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_goto] = ACTIONS(2288),
    [anon_sym___try] = ACTIONS(2288),
    [anon_sym___leave] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2288),
    [anon_sym_compl] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_sizeof] = ACTIONS(2288),
    [anon_sym___alignof__] = ACTIONS(2288),
    [anon_sym___alignof] = ACTIONS(2288),
    [anon_sym__alignof] = ACTIONS(2288),
    [anon_sym_alignof] = ACTIONS(2288),
    [anon_sym__Alignof] = ACTIONS(2288),
    [anon_sym_offsetof] = ACTIONS(2288),
    [anon_sym__Generic] = ACTIONS(2288),
    [anon_sym_asm] = ACTIONS(2288),
    [anon_sym___asm__] = ACTIONS(2288),
    [sym_number_literal] = ACTIONS(2290),
    [anon_sym_L_SQUOTE] = ACTIONS(2290),
    [anon_sym_u_SQUOTE] = ACTIONS(2290),
    [anon_sym_U_SQUOTE] = ACTIONS(2290),
    [anon_sym_u8_SQUOTE] = ACTIONS(2290),
    [anon_sym_SQUOTE] = ACTIONS(2290),
    [anon_sym_L_DQUOTE] = ACTIONS(2290),
    [anon_sym_u_DQUOTE] = ACTIONS(2290),
    [anon_sym_U_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8_DQUOTE] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [anon_sym_NULL] = ACTIONS(2288),
    [anon_sym_nullptr] = ACTIONS(2288),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [sym_virtual] = ACTIONS(2288),
    [anon_sym_explicit] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_operator] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_static_assert] = ACTIONS(2288),
    [anon_sym_concept] = ACTIONS(2288),
    [anon_sym_co_return] = ACTIONS(2288),
    [anon_sym_co_yield] = ACTIONS(2288),
    [anon_sym_R_DQUOTE] = ACTIONS(2290),
    [anon_sym_LR_DQUOTE] = ACTIONS(2290),
    [anon_sym_uR_DQUOTE] = ACTIONS(2290),
    [anon_sym_UR_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2290),
    [anon_sym_co_await] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_requires] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [anon_sym___launch_bounds__] = ACTIONS(2288),
  },
  [593] = {
    [sym_identifier] = ACTIONS(2154),
    [aux_sym_preproc_include_token1] = ACTIONS(2154),
    [aux_sym_preproc_def_token1] = ACTIONS(2154),
    [aux_sym_preproc_if_token1] = ACTIONS(2154),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2154),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2154),
    [sym_preproc_directive] = ACTIONS(2154),
    [anon_sym_LPAREN2] = ACTIONS(2156),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [anon_sym_DASH] = ACTIONS(2154),
    [anon_sym_PLUS] = ACTIONS(2154),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_AMP_AMP] = ACTIONS(2156),
    [anon_sym_AMP] = ACTIONS(2154),
    [anon_sym_SEMI] = ACTIONS(2156),
    [anon_sym___extension__] = ACTIONS(2154),
    [anon_sym_typedef] = ACTIONS(2154),
    [anon_sym___device__] = ACTIONS(2154),
    [anon_sym___host__] = ACTIONS(2154),
    [anon_sym___global__] = ACTIONS(2154),
    [anon_sym___forceinline__] = ACTIONS(2154),
    [anon_sym___noinline__] = ACTIONS(2154),
    [anon_sym_extern] = ACTIONS(2154),
    [anon_sym___attribute__] = ACTIONS(2154),
    [anon_sym_COLON_COLON] = ACTIONS(2156),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2156),
    [anon_sym___declspec] = ACTIONS(2154),
    [anon_sym___based] = ACTIONS(2154),
    [anon_sym___cdecl] = ACTIONS(2154),
    [anon_sym___clrcall] = ACTIONS(2154),
    [anon_sym___stdcall] = ACTIONS(2154),
    [anon_sym___fastcall] = ACTIONS(2154),
    [anon_sym___thiscall] = ACTIONS(2154),
    [anon_sym___vectorcall] = ACTIONS(2154),
    [anon_sym_LBRACE] = ACTIONS(2156),
    [anon_sym_RBRACE] = ACTIONS(2156),
    [anon_sym_signed] = ACTIONS(2154),
    [anon_sym_unsigned] = ACTIONS(2154),
    [anon_sym_long] = ACTIONS(2154),
    [anon_sym_short] = ACTIONS(2154),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_static] = ACTIONS(2154),
    [anon_sym_register] = ACTIONS(2154),
    [anon_sym_inline] = ACTIONS(2154),
    [anon_sym___inline] = ACTIONS(2154),
    [anon_sym___inline__] = ACTIONS(2154),
    [anon_sym___forceinline] = ACTIONS(2154),
    [anon_sym_thread_local] = ACTIONS(2154),
    [anon_sym___thread] = ACTIONS(2154),
    [anon_sym_const] = ACTIONS(2154),
    [anon_sym_constexpr] = ACTIONS(2154),
    [anon_sym_volatile] = ACTIONS(2154),
    [anon_sym_restrict] = ACTIONS(2154),
    [anon_sym___restrict__] = ACTIONS(2154),
    [anon_sym__Atomic] = ACTIONS(2154),
    [anon_sym__Noreturn] = ACTIONS(2154),
    [anon_sym_noreturn] = ACTIONS(2154),
    [anon_sym_mutable] = ACTIONS(2154),
    [anon_sym_constinit] = ACTIONS(2154),
    [anon_sym_consteval] = ACTIONS(2154),
    [anon_sym___shared__] = ACTIONS(2154),
    [anon_sym___local__] = ACTIONS(2154),
    [anon_sym___constant__] = ACTIONS(2154),
    [anon_sym___managed__] = ACTIONS(2154),
    [anon_sym___grid_constant__] = ACTIONS(2154),
    [anon_sym_alignas] = ACTIONS(2154),
    [anon_sym__Alignas] = ACTIONS(2154),
    [sym_primitive_type] = ACTIONS(2154),
    [anon_sym_enum] = ACTIONS(2154),
    [anon_sym_class] = ACTIONS(2154),
    [anon_sym_struct] = ACTIONS(2154),
    [anon_sym_union] = ACTIONS(2154),
    [anon_sym_if] = ACTIONS(2154),
    [anon_sym_switch] = ACTIONS(2154),
    [anon_sym_case] = ACTIONS(2154),
    [anon_sym_default] = ACTIONS(2154),
    [anon_sym_while] = ACTIONS(2154),
    [anon_sym_do] = ACTIONS(2154),
    [anon_sym_for] = ACTIONS(2154),
    [anon_sym_return] = ACTIONS(2154),
    [anon_sym_break] = ACTIONS(2154),
    [anon_sym_continue] = ACTIONS(2154),
    [anon_sym_goto] = ACTIONS(2154),
    [anon_sym___try] = ACTIONS(2154),
    [anon_sym___leave] = ACTIONS(2154),
    [anon_sym_not] = ACTIONS(2154),
    [anon_sym_compl] = ACTIONS(2154),
    [anon_sym_DASH_DASH] = ACTIONS(2156),
    [anon_sym_PLUS_PLUS] = ACTIONS(2156),
    [anon_sym_sizeof] = ACTIONS(2154),
    [anon_sym___alignof__] = ACTIONS(2154),
    [anon_sym___alignof] = ACTIONS(2154),
    [anon_sym__alignof] = ACTIONS(2154),
    [anon_sym_alignof] = ACTIONS(2154),
    [anon_sym__Alignof] = ACTIONS(2154),
    [anon_sym_offsetof] = ACTIONS(2154),
    [anon_sym__Generic] = ACTIONS(2154),
    [anon_sym_asm] = ACTIONS(2154),
    [anon_sym___asm__] = ACTIONS(2154),
    [sym_number_literal] = ACTIONS(2156),
    [anon_sym_L_SQUOTE] = ACTIONS(2156),
    [anon_sym_u_SQUOTE] = ACTIONS(2156),
    [anon_sym_U_SQUOTE] = ACTIONS(2156),
    [anon_sym_u8_SQUOTE] = ACTIONS(2156),
    [anon_sym_SQUOTE] = ACTIONS(2156),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(2154),
    [sym_false] = ACTIONS(2154),
    [anon_sym_NULL] = ACTIONS(2154),
    [anon_sym_nullptr] = ACTIONS(2154),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2154),
    [anon_sym_decltype] = ACTIONS(2154),
    [sym_virtual] = ACTIONS(2154),
    [anon_sym_explicit] = ACTIONS(2154),
    [anon_sym_typename] = ACTIONS(2154),
    [anon_sym_template] = ACTIONS(2154),
    [anon_sym_operator] = ACTIONS(2154),
    [anon_sym_try] = ACTIONS(2154),
    [anon_sym_delete] = ACTIONS(2154),
    [anon_sym_throw] = ACTIONS(2154),
    [anon_sym_namespace] = ACTIONS(2154),
    [anon_sym_using] = ACTIONS(2154),
    [anon_sym_static_assert] = ACTIONS(2154),
    [anon_sym_concept] = ACTIONS(2154),
    [anon_sym_co_return] = ACTIONS(2154),
    [anon_sym_co_yield] = ACTIONS(2154),
    [anon_sym_R_DQUOTE] = ACTIONS(2156),
    [anon_sym_LR_DQUOTE] = ACTIONS(2156),
    [anon_sym_uR_DQUOTE] = ACTIONS(2156),
    [anon_sym_UR_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2156),
    [anon_sym_co_await] = ACTIONS(2154),
    [anon_sym_new] = ACTIONS(2154),
    [anon_sym_requires] = ACTIONS(2154),
    [sym_this] = ACTIONS(2154),
    [anon_sym___launch_bounds__] = ACTIONS(2154),
  },
  [594] = {
    [sym_type_qualifier] = STATE(3531),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4591),
    [sym_sized_type_specifier] = STATE(2599),
    [sym_enum_specifier] = STATE(2599),
    [sym_struct_specifier] = STATE(2599),
    [sym_union_specifier] = STATE(2599),
    [sym_expression] = STATE(4649),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_type_descriptor] = STATE(7150),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_placeholder_type_specifier] = STATE(2599),
    [sym_decltype_auto] = STATE(2598),
    [sym_decltype] = STATE(2477),
    [sym_class_specifier] = STATE(2599),
    [sym__class_name] = STATE(8015),
    [sym_dependent_type] = STATE(2599),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_type_parameter_pack_expansion] = STATE(7748),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5910),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [aux_sym__type_definition_type_repeat1] = STATE(3531),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2157),
    [sym_identifier] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2725),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2729),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2733),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2757),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2761),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_GT2] = ACTIONS(2835),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [595] = {
    [sym_identifier] = ACTIONS(2338),
    [aux_sym_preproc_include_token1] = ACTIONS(2338),
    [aux_sym_preproc_def_token1] = ACTIONS(2338),
    [aux_sym_preproc_if_token1] = ACTIONS(2338),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2338),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2338),
    [sym_preproc_directive] = ACTIONS(2338),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2338),
    [anon_sym_PLUS] = ACTIONS(2338),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_AMP] = ACTIONS(2338),
    [anon_sym_SEMI] = ACTIONS(2340),
    [anon_sym___extension__] = ACTIONS(2338),
    [anon_sym_typedef] = ACTIONS(2338),
    [anon_sym___device__] = ACTIONS(2338),
    [anon_sym___host__] = ACTIONS(2338),
    [anon_sym___global__] = ACTIONS(2338),
    [anon_sym___forceinline__] = ACTIONS(2338),
    [anon_sym___noinline__] = ACTIONS(2338),
    [anon_sym_extern] = ACTIONS(2338),
    [anon_sym___attribute__] = ACTIONS(2338),
    [anon_sym_COLON_COLON] = ACTIONS(2340),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2340),
    [anon_sym___declspec] = ACTIONS(2338),
    [anon_sym___based] = ACTIONS(2338),
    [anon_sym___cdecl] = ACTIONS(2338),
    [anon_sym___clrcall] = ACTIONS(2338),
    [anon_sym___stdcall] = ACTIONS(2338),
    [anon_sym___fastcall] = ACTIONS(2338),
    [anon_sym___thiscall] = ACTIONS(2338),
    [anon_sym___vectorcall] = ACTIONS(2338),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_RBRACE] = ACTIONS(2340),
    [anon_sym_signed] = ACTIONS(2338),
    [anon_sym_unsigned] = ACTIONS(2338),
    [anon_sym_long] = ACTIONS(2338),
    [anon_sym_short] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2338),
    [anon_sym_static] = ACTIONS(2338),
    [anon_sym_register] = ACTIONS(2338),
    [anon_sym_inline] = ACTIONS(2338),
    [anon_sym___inline] = ACTIONS(2338),
    [anon_sym___inline__] = ACTIONS(2338),
    [anon_sym___forceinline] = ACTIONS(2338),
    [anon_sym_thread_local] = ACTIONS(2338),
    [anon_sym___thread] = ACTIONS(2338),
    [anon_sym_const] = ACTIONS(2338),
    [anon_sym_constexpr] = ACTIONS(2338),
    [anon_sym_volatile] = ACTIONS(2338),
    [anon_sym_restrict] = ACTIONS(2338),
    [anon_sym___restrict__] = ACTIONS(2338),
    [anon_sym__Atomic] = ACTIONS(2338),
    [anon_sym__Noreturn] = ACTIONS(2338),
    [anon_sym_noreturn] = ACTIONS(2338),
    [anon_sym_mutable] = ACTIONS(2338),
    [anon_sym_constinit] = ACTIONS(2338),
    [anon_sym_consteval] = ACTIONS(2338),
    [anon_sym___shared__] = ACTIONS(2338),
    [anon_sym___local__] = ACTIONS(2338),
    [anon_sym___constant__] = ACTIONS(2338),
    [anon_sym___managed__] = ACTIONS(2338),
    [anon_sym___grid_constant__] = ACTIONS(2338),
    [anon_sym_alignas] = ACTIONS(2338),
    [anon_sym__Alignas] = ACTIONS(2338),
    [sym_primitive_type] = ACTIONS(2338),
    [anon_sym_enum] = ACTIONS(2338),
    [anon_sym_class] = ACTIONS(2338),
    [anon_sym_struct] = ACTIONS(2338),
    [anon_sym_union] = ACTIONS(2338),
    [anon_sym_if] = ACTIONS(2338),
    [anon_sym_switch] = ACTIONS(2338),
    [anon_sym_case] = ACTIONS(2338),
    [anon_sym_default] = ACTIONS(2338),
    [anon_sym_while] = ACTIONS(2338),
    [anon_sym_do] = ACTIONS(2338),
    [anon_sym_for] = ACTIONS(2338),
    [anon_sym_return] = ACTIONS(2338),
    [anon_sym_break] = ACTIONS(2338),
    [anon_sym_continue] = ACTIONS(2338),
    [anon_sym_goto] = ACTIONS(2338),
    [anon_sym___try] = ACTIONS(2338),
    [anon_sym___leave] = ACTIONS(2338),
    [anon_sym_not] = ACTIONS(2338),
    [anon_sym_compl] = ACTIONS(2338),
    [anon_sym_DASH_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_PLUS] = ACTIONS(2340),
    [anon_sym_sizeof] = ACTIONS(2338),
    [anon_sym___alignof__] = ACTIONS(2338),
    [anon_sym___alignof] = ACTIONS(2338),
    [anon_sym__alignof] = ACTIONS(2338),
    [anon_sym_alignof] = ACTIONS(2338),
    [anon_sym__Alignof] = ACTIONS(2338),
    [anon_sym_offsetof] = ACTIONS(2338),
    [anon_sym__Generic] = ACTIONS(2338),
    [anon_sym_asm] = ACTIONS(2338),
    [anon_sym___asm__] = ACTIONS(2338),
    [sym_number_literal] = ACTIONS(2340),
    [anon_sym_L_SQUOTE] = ACTIONS(2340),
    [anon_sym_u_SQUOTE] = ACTIONS(2340),
    [anon_sym_U_SQUOTE] = ACTIONS(2340),
    [anon_sym_u8_SQUOTE] = ACTIONS(2340),
    [anon_sym_SQUOTE] = ACTIONS(2340),
    [anon_sym_L_DQUOTE] = ACTIONS(2340),
    [anon_sym_u_DQUOTE] = ACTIONS(2340),
    [anon_sym_U_DQUOTE] = ACTIONS(2340),
    [anon_sym_u8_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [sym_true] = ACTIONS(2338),
    [sym_false] = ACTIONS(2338),
    [anon_sym_NULL] = ACTIONS(2338),
    [anon_sym_nullptr] = ACTIONS(2338),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2338),
    [anon_sym_decltype] = ACTIONS(2338),
    [sym_virtual] = ACTIONS(2338),
    [anon_sym_explicit] = ACTIONS(2338),
    [anon_sym_typename] = ACTIONS(2338),
    [anon_sym_template] = ACTIONS(2338),
    [anon_sym_operator] = ACTIONS(2338),
    [anon_sym_try] = ACTIONS(2338),
    [anon_sym_delete] = ACTIONS(2338),
    [anon_sym_throw] = ACTIONS(2338),
    [anon_sym_namespace] = ACTIONS(2338),
    [anon_sym_using] = ACTIONS(2338),
    [anon_sym_static_assert] = ACTIONS(2338),
    [anon_sym_concept] = ACTIONS(2338),
    [anon_sym_co_return] = ACTIONS(2338),
    [anon_sym_co_yield] = ACTIONS(2338),
    [anon_sym_R_DQUOTE] = ACTIONS(2340),
    [anon_sym_LR_DQUOTE] = ACTIONS(2340),
    [anon_sym_uR_DQUOTE] = ACTIONS(2340),
    [anon_sym_UR_DQUOTE] = ACTIONS(2340),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2340),
    [anon_sym_co_await] = ACTIONS(2338),
    [anon_sym_new] = ACTIONS(2338),
    [anon_sym_requires] = ACTIONS(2338),
    [sym_this] = ACTIONS(2338),
    [anon_sym___launch_bounds__] = ACTIONS(2338),
  },
  [596] = {
    [sym_identifier] = ACTIONS(2211),
    [aux_sym_preproc_include_token1] = ACTIONS(2211),
    [aux_sym_preproc_def_token1] = ACTIONS(2211),
    [aux_sym_preproc_if_token1] = ACTIONS(2211),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2211),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2211),
    [sym_preproc_directive] = ACTIONS(2211),
    [anon_sym_LPAREN2] = ACTIONS(2213),
    [anon_sym_BANG] = ACTIONS(2213),
    [anon_sym_TILDE] = ACTIONS(2213),
    [anon_sym_DASH] = ACTIONS(2211),
    [anon_sym_PLUS] = ACTIONS(2211),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_AMP_AMP] = ACTIONS(2213),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_SEMI] = ACTIONS(2213),
    [anon_sym___extension__] = ACTIONS(2211),
    [anon_sym_typedef] = ACTIONS(2211),
    [anon_sym___device__] = ACTIONS(2211),
    [anon_sym___host__] = ACTIONS(2211),
    [anon_sym___global__] = ACTIONS(2211),
    [anon_sym___forceinline__] = ACTIONS(2211),
    [anon_sym___noinline__] = ACTIONS(2211),
    [anon_sym_extern] = ACTIONS(2211),
    [anon_sym___attribute__] = ACTIONS(2211),
    [anon_sym_COLON_COLON] = ACTIONS(2213),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2213),
    [anon_sym___declspec] = ACTIONS(2211),
    [anon_sym___based] = ACTIONS(2211),
    [anon_sym___cdecl] = ACTIONS(2211),
    [anon_sym___clrcall] = ACTIONS(2211),
    [anon_sym___stdcall] = ACTIONS(2211),
    [anon_sym___fastcall] = ACTIONS(2211),
    [anon_sym___thiscall] = ACTIONS(2211),
    [anon_sym___vectorcall] = ACTIONS(2211),
    [anon_sym_LBRACE] = ACTIONS(2213),
    [anon_sym_RBRACE] = ACTIONS(2213),
    [anon_sym_signed] = ACTIONS(2211),
    [anon_sym_unsigned] = ACTIONS(2211),
    [anon_sym_long] = ACTIONS(2211),
    [anon_sym_short] = ACTIONS(2211),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_static] = ACTIONS(2211),
    [anon_sym_register] = ACTIONS(2211),
    [anon_sym_inline] = ACTIONS(2211),
    [anon_sym___inline] = ACTIONS(2211),
    [anon_sym___inline__] = ACTIONS(2211),
    [anon_sym___forceinline] = ACTIONS(2211),
    [anon_sym_thread_local] = ACTIONS(2211),
    [anon_sym___thread] = ACTIONS(2211),
    [anon_sym_const] = ACTIONS(2211),
    [anon_sym_constexpr] = ACTIONS(2211),
    [anon_sym_volatile] = ACTIONS(2211),
    [anon_sym_restrict] = ACTIONS(2211),
    [anon_sym___restrict__] = ACTIONS(2211),
    [anon_sym__Atomic] = ACTIONS(2211),
    [anon_sym__Noreturn] = ACTIONS(2211),
    [anon_sym_noreturn] = ACTIONS(2211),
    [anon_sym_mutable] = ACTIONS(2211),
    [anon_sym_constinit] = ACTIONS(2211),
    [anon_sym_consteval] = ACTIONS(2211),
    [anon_sym___shared__] = ACTIONS(2211),
    [anon_sym___local__] = ACTIONS(2211),
    [anon_sym___constant__] = ACTIONS(2211),
    [anon_sym___managed__] = ACTIONS(2211),
    [anon_sym___grid_constant__] = ACTIONS(2211),
    [anon_sym_alignas] = ACTIONS(2211),
    [anon_sym__Alignas] = ACTIONS(2211),
    [sym_primitive_type] = ACTIONS(2211),
    [anon_sym_enum] = ACTIONS(2211),
    [anon_sym_class] = ACTIONS(2211),
    [anon_sym_struct] = ACTIONS(2211),
    [anon_sym_union] = ACTIONS(2211),
    [anon_sym_if] = ACTIONS(2211),
    [anon_sym_switch] = ACTIONS(2211),
    [anon_sym_case] = ACTIONS(2211),
    [anon_sym_default] = ACTIONS(2211),
    [anon_sym_while] = ACTIONS(2211),
    [anon_sym_do] = ACTIONS(2211),
    [anon_sym_for] = ACTIONS(2211),
    [anon_sym_return] = ACTIONS(2211),
    [anon_sym_break] = ACTIONS(2211),
    [anon_sym_continue] = ACTIONS(2211),
    [anon_sym_goto] = ACTIONS(2211),
    [anon_sym___try] = ACTIONS(2211),
    [anon_sym___leave] = ACTIONS(2211),
    [anon_sym_not] = ACTIONS(2211),
    [anon_sym_compl] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2213),
    [anon_sym_PLUS_PLUS] = ACTIONS(2213),
    [anon_sym_sizeof] = ACTIONS(2211),
    [anon_sym___alignof__] = ACTIONS(2211),
    [anon_sym___alignof] = ACTIONS(2211),
    [anon_sym__alignof] = ACTIONS(2211),
    [anon_sym_alignof] = ACTIONS(2211),
    [anon_sym__Alignof] = ACTIONS(2211),
    [anon_sym_offsetof] = ACTIONS(2211),
    [anon_sym__Generic] = ACTIONS(2211),
    [anon_sym_asm] = ACTIONS(2211),
    [anon_sym___asm__] = ACTIONS(2211),
    [sym_number_literal] = ACTIONS(2213),
    [anon_sym_L_SQUOTE] = ACTIONS(2213),
    [anon_sym_u_SQUOTE] = ACTIONS(2213),
    [anon_sym_U_SQUOTE] = ACTIONS(2213),
    [anon_sym_u8_SQUOTE] = ACTIONS(2213),
    [anon_sym_SQUOTE] = ACTIONS(2213),
    [anon_sym_L_DQUOTE] = ACTIONS(2213),
    [anon_sym_u_DQUOTE] = ACTIONS(2213),
    [anon_sym_U_DQUOTE] = ACTIONS(2213),
    [anon_sym_u8_DQUOTE] = ACTIONS(2213),
    [anon_sym_DQUOTE] = ACTIONS(2213),
    [sym_true] = ACTIONS(2211),
    [sym_false] = ACTIONS(2211),
    [anon_sym_NULL] = ACTIONS(2211),
    [anon_sym_nullptr] = ACTIONS(2211),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2211),
    [anon_sym_decltype] = ACTIONS(2211),
    [sym_virtual] = ACTIONS(2211),
    [anon_sym_explicit] = ACTIONS(2211),
    [anon_sym_typename] = ACTIONS(2211),
    [anon_sym_template] = ACTIONS(2211),
    [anon_sym_operator] = ACTIONS(2211),
    [anon_sym_try] = ACTIONS(2211),
    [anon_sym_delete] = ACTIONS(2211),
    [anon_sym_throw] = ACTIONS(2211),
    [anon_sym_namespace] = ACTIONS(2211),
    [anon_sym_using] = ACTIONS(2211),
    [anon_sym_static_assert] = ACTIONS(2211),
    [anon_sym_concept] = ACTIONS(2211),
    [anon_sym_co_return] = ACTIONS(2211),
    [anon_sym_co_yield] = ACTIONS(2211),
    [anon_sym_R_DQUOTE] = ACTIONS(2213),
    [anon_sym_LR_DQUOTE] = ACTIONS(2213),
    [anon_sym_uR_DQUOTE] = ACTIONS(2213),
    [anon_sym_UR_DQUOTE] = ACTIONS(2213),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2213),
    [anon_sym_co_await] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(2211),
    [anon_sym_requires] = ACTIONS(2211),
    [sym_this] = ACTIONS(2211),
    [anon_sym___launch_bounds__] = ACTIONS(2211),
  },
  [597] = {
    [sym_identifier] = ACTIONS(2400),
    [aux_sym_preproc_include_token1] = ACTIONS(2400),
    [aux_sym_preproc_def_token1] = ACTIONS(2400),
    [aux_sym_preproc_if_token1] = ACTIONS(2400),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2400),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2400),
    [sym_preproc_directive] = ACTIONS(2400),
    [anon_sym_LPAREN2] = ACTIONS(2402),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_TILDE] = ACTIONS(2402),
    [anon_sym_DASH] = ACTIONS(2400),
    [anon_sym_PLUS] = ACTIONS(2400),
    [anon_sym_STAR] = ACTIONS(2402),
    [anon_sym_AMP_AMP] = ACTIONS(2402),
    [anon_sym_AMP] = ACTIONS(2400),
    [anon_sym_SEMI] = ACTIONS(2402),
    [anon_sym___extension__] = ACTIONS(2400),
    [anon_sym_typedef] = ACTIONS(2400),
    [anon_sym___device__] = ACTIONS(2400),
    [anon_sym___host__] = ACTIONS(2400),
    [anon_sym___global__] = ACTIONS(2400),
    [anon_sym___forceinline__] = ACTIONS(2400),
    [anon_sym___noinline__] = ACTIONS(2400),
    [anon_sym_extern] = ACTIONS(2400),
    [anon_sym___attribute__] = ACTIONS(2400),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2402),
    [anon_sym___declspec] = ACTIONS(2400),
    [anon_sym___based] = ACTIONS(2400),
    [anon_sym___cdecl] = ACTIONS(2400),
    [anon_sym___clrcall] = ACTIONS(2400),
    [anon_sym___stdcall] = ACTIONS(2400),
    [anon_sym___fastcall] = ACTIONS(2400),
    [anon_sym___thiscall] = ACTIONS(2400),
    [anon_sym___vectorcall] = ACTIONS(2400),
    [anon_sym_LBRACE] = ACTIONS(2402),
    [anon_sym_RBRACE] = ACTIONS(2402),
    [anon_sym_signed] = ACTIONS(2400),
    [anon_sym_unsigned] = ACTIONS(2400),
    [anon_sym_long] = ACTIONS(2400),
    [anon_sym_short] = ACTIONS(2400),
    [anon_sym_LBRACK] = ACTIONS(2400),
    [anon_sym_static] = ACTIONS(2400),
    [anon_sym_register] = ACTIONS(2400),
    [anon_sym_inline] = ACTIONS(2400),
    [anon_sym___inline] = ACTIONS(2400),
    [anon_sym___inline__] = ACTIONS(2400),
    [anon_sym___forceinline] = ACTIONS(2400),
    [anon_sym_thread_local] = ACTIONS(2400),
    [anon_sym___thread] = ACTIONS(2400),
    [anon_sym_const] = ACTIONS(2400),
    [anon_sym_constexpr] = ACTIONS(2400),
    [anon_sym_volatile] = ACTIONS(2400),
    [anon_sym_restrict] = ACTIONS(2400),
    [anon_sym___restrict__] = ACTIONS(2400),
    [anon_sym__Atomic] = ACTIONS(2400),
    [anon_sym__Noreturn] = ACTIONS(2400),
    [anon_sym_noreturn] = ACTIONS(2400),
    [anon_sym_mutable] = ACTIONS(2400),
    [anon_sym_constinit] = ACTIONS(2400),
    [anon_sym_consteval] = ACTIONS(2400),
    [anon_sym___shared__] = ACTIONS(2400),
    [anon_sym___local__] = ACTIONS(2400),
    [anon_sym___constant__] = ACTIONS(2400),
    [anon_sym___managed__] = ACTIONS(2400),
    [anon_sym___grid_constant__] = ACTIONS(2400),
    [anon_sym_alignas] = ACTIONS(2400),
    [anon_sym__Alignas] = ACTIONS(2400),
    [sym_primitive_type] = ACTIONS(2400),
    [anon_sym_enum] = ACTIONS(2400),
    [anon_sym_class] = ACTIONS(2400),
    [anon_sym_struct] = ACTIONS(2400),
    [anon_sym_union] = ACTIONS(2400),
    [anon_sym_if] = ACTIONS(2400),
    [anon_sym_switch] = ACTIONS(2400),
    [anon_sym_case] = ACTIONS(2400),
    [anon_sym_default] = ACTIONS(2400),
    [anon_sym_while] = ACTIONS(2400),
    [anon_sym_do] = ACTIONS(2400),
    [anon_sym_for] = ACTIONS(2400),
    [anon_sym_return] = ACTIONS(2400),
    [anon_sym_break] = ACTIONS(2400),
    [anon_sym_continue] = ACTIONS(2400),
    [anon_sym_goto] = ACTIONS(2400),
    [anon_sym___try] = ACTIONS(2400),
    [anon_sym___leave] = ACTIONS(2400),
    [anon_sym_not] = ACTIONS(2400),
    [anon_sym_compl] = ACTIONS(2400),
    [anon_sym_DASH_DASH] = ACTIONS(2402),
    [anon_sym_PLUS_PLUS] = ACTIONS(2402),
    [anon_sym_sizeof] = ACTIONS(2400),
    [anon_sym___alignof__] = ACTIONS(2400),
    [anon_sym___alignof] = ACTIONS(2400),
    [anon_sym__alignof] = ACTIONS(2400),
    [anon_sym_alignof] = ACTIONS(2400),
    [anon_sym__Alignof] = ACTIONS(2400),
    [anon_sym_offsetof] = ACTIONS(2400),
    [anon_sym__Generic] = ACTIONS(2400),
    [anon_sym_asm] = ACTIONS(2400),
    [anon_sym___asm__] = ACTIONS(2400),
    [sym_number_literal] = ACTIONS(2402),
    [anon_sym_L_SQUOTE] = ACTIONS(2402),
    [anon_sym_u_SQUOTE] = ACTIONS(2402),
    [anon_sym_U_SQUOTE] = ACTIONS(2402),
    [anon_sym_u8_SQUOTE] = ACTIONS(2402),
    [anon_sym_SQUOTE] = ACTIONS(2402),
    [anon_sym_L_DQUOTE] = ACTIONS(2402),
    [anon_sym_u_DQUOTE] = ACTIONS(2402),
    [anon_sym_U_DQUOTE] = ACTIONS(2402),
    [anon_sym_u8_DQUOTE] = ACTIONS(2402),
    [anon_sym_DQUOTE] = ACTIONS(2402),
    [sym_true] = ACTIONS(2400),
    [sym_false] = ACTIONS(2400),
    [anon_sym_NULL] = ACTIONS(2400),
    [anon_sym_nullptr] = ACTIONS(2400),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2400),
    [anon_sym_decltype] = ACTIONS(2400),
    [sym_virtual] = ACTIONS(2400),
    [anon_sym_explicit] = ACTIONS(2400),
    [anon_sym_typename] = ACTIONS(2400),
    [anon_sym_template] = ACTIONS(2400),
    [anon_sym_operator] = ACTIONS(2400),
    [anon_sym_try] = ACTIONS(2400),
    [anon_sym_delete] = ACTIONS(2400),
    [anon_sym_throw] = ACTIONS(2400),
    [anon_sym_namespace] = ACTIONS(2400),
    [anon_sym_using] = ACTIONS(2400),
    [anon_sym_static_assert] = ACTIONS(2400),
    [anon_sym_concept] = ACTIONS(2400),
    [anon_sym_co_return] = ACTIONS(2400),
    [anon_sym_co_yield] = ACTIONS(2400),
    [anon_sym_R_DQUOTE] = ACTIONS(2402),
    [anon_sym_LR_DQUOTE] = ACTIONS(2402),
    [anon_sym_uR_DQUOTE] = ACTIONS(2402),
    [anon_sym_UR_DQUOTE] = ACTIONS(2402),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2402),
    [anon_sym_co_await] = ACTIONS(2400),
    [anon_sym_new] = ACTIONS(2400),
    [anon_sym_requires] = ACTIONS(2400),
    [sym_this] = ACTIONS(2400),
    [anon_sym___launch_bounds__] = ACTIONS(2400),
  },
  [598] = {
    [sym_identifier] = ACTIONS(2203),
    [aux_sym_preproc_include_token1] = ACTIONS(2203),
    [aux_sym_preproc_def_token1] = ACTIONS(2203),
    [aux_sym_preproc_if_token1] = ACTIONS(2203),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2203),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2203),
    [sym_preproc_directive] = ACTIONS(2203),
    [anon_sym_LPAREN2] = ACTIONS(2205),
    [anon_sym_BANG] = ACTIONS(2205),
    [anon_sym_TILDE] = ACTIONS(2205),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_AMP_AMP] = ACTIONS(2205),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym_SEMI] = ACTIONS(2205),
    [anon_sym___extension__] = ACTIONS(2203),
    [anon_sym_typedef] = ACTIONS(2203),
    [anon_sym___device__] = ACTIONS(2203),
    [anon_sym___host__] = ACTIONS(2203),
    [anon_sym___global__] = ACTIONS(2203),
    [anon_sym___forceinline__] = ACTIONS(2203),
    [anon_sym___noinline__] = ACTIONS(2203),
    [anon_sym_extern] = ACTIONS(2203),
    [anon_sym___attribute__] = ACTIONS(2203),
    [anon_sym_COLON_COLON] = ACTIONS(2205),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2205),
    [anon_sym___declspec] = ACTIONS(2203),
    [anon_sym___based] = ACTIONS(2203),
    [anon_sym___cdecl] = ACTIONS(2203),
    [anon_sym___clrcall] = ACTIONS(2203),
    [anon_sym___stdcall] = ACTIONS(2203),
    [anon_sym___fastcall] = ACTIONS(2203),
    [anon_sym___thiscall] = ACTIONS(2203),
    [anon_sym___vectorcall] = ACTIONS(2203),
    [anon_sym_LBRACE] = ACTIONS(2205),
    [anon_sym_RBRACE] = ACTIONS(2205),
    [anon_sym_signed] = ACTIONS(2203),
    [anon_sym_unsigned] = ACTIONS(2203),
    [anon_sym_long] = ACTIONS(2203),
    [anon_sym_short] = ACTIONS(2203),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_static] = ACTIONS(2203),
    [anon_sym_register] = ACTIONS(2203),
    [anon_sym_inline] = ACTIONS(2203),
    [anon_sym___inline] = ACTIONS(2203),
    [anon_sym___inline__] = ACTIONS(2203),
    [anon_sym___forceinline] = ACTIONS(2203),
    [anon_sym_thread_local] = ACTIONS(2203),
    [anon_sym___thread] = ACTIONS(2203),
    [anon_sym_const] = ACTIONS(2203),
    [anon_sym_constexpr] = ACTIONS(2203),
    [anon_sym_volatile] = ACTIONS(2203),
    [anon_sym_restrict] = ACTIONS(2203),
    [anon_sym___restrict__] = ACTIONS(2203),
    [anon_sym__Atomic] = ACTIONS(2203),
    [anon_sym__Noreturn] = ACTIONS(2203),
    [anon_sym_noreturn] = ACTIONS(2203),
    [anon_sym_mutable] = ACTIONS(2203),
    [anon_sym_constinit] = ACTIONS(2203),
    [anon_sym_consteval] = ACTIONS(2203),
    [anon_sym___shared__] = ACTIONS(2203),
    [anon_sym___local__] = ACTIONS(2203),
    [anon_sym___constant__] = ACTIONS(2203),
    [anon_sym___managed__] = ACTIONS(2203),
    [anon_sym___grid_constant__] = ACTIONS(2203),
    [anon_sym_alignas] = ACTIONS(2203),
    [anon_sym__Alignas] = ACTIONS(2203),
    [sym_primitive_type] = ACTIONS(2203),
    [anon_sym_enum] = ACTIONS(2203),
    [anon_sym_class] = ACTIONS(2203),
    [anon_sym_struct] = ACTIONS(2203),
    [anon_sym_union] = ACTIONS(2203),
    [anon_sym_if] = ACTIONS(2203),
    [anon_sym_switch] = ACTIONS(2203),
    [anon_sym_case] = ACTIONS(2203),
    [anon_sym_default] = ACTIONS(2203),
    [anon_sym_while] = ACTIONS(2203),
    [anon_sym_do] = ACTIONS(2203),
    [anon_sym_for] = ACTIONS(2203),
    [anon_sym_return] = ACTIONS(2203),
    [anon_sym_break] = ACTIONS(2203),
    [anon_sym_continue] = ACTIONS(2203),
    [anon_sym_goto] = ACTIONS(2203),
    [anon_sym___try] = ACTIONS(2203),
    [anon_sym___leave] = ACTIONS(2203),
    [anon_sym_not] = ACTIONS(2203),
    [anon_sym_compl] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2205),
    [anon_sym_PLUS_PLUS] = ACTIONS(2205),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2203),
    [anon_sym___alignof] = ACTIONS(2203),
    [anon_sym__alignof] = ACTIONS(2203),
    [anon_sym_alignof] = ACTIONS(2203),
    [anon_sym__Alignof] = ACTIONS(2203),
    [anon_sym_offsetof] = ACTIONS(2203),
    [anon_sym__Generic] = ACTIONS(2203),
    [anon_sym_asm] = ACTIONS(2203),
    [anon_sym___asm__] = ACTIONS(2203),
    [sym_number_literal] = ACTIONS(2205),
    [anon_sym_L_SQUOTE] = ACTIONS(2205),
    [anon_sym_u_SQUOTE] = ACTIONS(2205),
    [anon_sym_U_SQUOTE] = ACTIONS(2205),
    [anon_sym_u8_SQUOTE] = ACTIONS(2205),
    [anon_sym_SQUOTE] = ACTIONS(2205),
    [anon_sym_L_DQUOTE] = ACTIONS(2205),
    [anon_sym_u_DQUOTE] = ACTIONS(2205),
    [anon_sym_U_DQUOTE] = ACTIONS(2205),
    [anon_sym_u8_DQUOTE] = ACTIONS(2205),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [sym_true] = ACTIONS(2203),
    [sym_false] = ACTIONS(2203),
    [anon_sym_NULL] = ACTIONS(2203),
    [anon_sym_nullptr] = ACTIONS(2203),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2203),
    [anon_sym_decltype] = ACTIONS(2203),
    [sym_virtual] = ACTIONS(2203),
    [anon_sym_explicit] = ACTIONS(2203),
    [anon_sym_typename] = ACTIONS(2203),
    [anon_sym_template] = ACTIONS(2203),
    [anon_sym_operator] = ACTIONS(2203),
    [anon_sym_try] = ACTIONS(2203),
    [anon_sym_delete] = ACTIONS(2203),
    [anon_sym_throw] = ACTIONS(2203),
    [anon_sym_namespace] = ACTIONS(2203),
    [anon_sym_using] = ACTIONS(2203),
    [anon_sym_static_assert] = ACTIONS(2203),
    [anon_sym_concept] = ACTIONS(2203),
    [anon_sym_co_return] = ACTIONS(2203),
    [anon_sym_co_yield] = ACTIONS(2203),
    [anon_sym_R_DQUOTE] = ACTIONS(2205),
    [anon_sym_LR_DQUOTE] = ACTIONS(2205),
    [anon_sym_uR_DQUOTE] = ACTIONS(2205),
    [anon_sym_UR_DQUOTE] = ACTIONS(2205),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2205),
    [anon_sym_co_await] = ACTIONS(2203),
    [anon_sym_new] = ACTIONS(2203),
    [anon_sym_requires] = ACTIONS(2203),
    [sym_this] = ACTIONS(2203),
    [anon_sym___launch_bounds__] = ACTIONS(2203),
  },
  [599] = {
    [sym_identifier] = ACTIONS(2376),
    [aux_sym_preproc_include_token1] = ACTIONS(2376),
    [aux_sym_preproc_def_token1] = ACTIONS(2376),
    [aux_sym_preproc_if_token1] = ACTIONS(2376),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2376),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2376),
    [sym_preproc_directive] = ACTIONS(2376),
    [anon_sym_LPAREN2] = ACTIONS(2378),
    [anon_sym_BANG] = ACTIONS(2378),
    [anon_sym_TILDE] = ACTIONS(2378),
    [anon_sym_DASH] = ACTIONS(2376),
    [anon_sym_PLUS] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(2378),
    [anon_sym_AMP_AMP] = ACTIONS(2378),
    [anon_sym_AMP] = ACTIONS(2376),
    [anon_sym_SEMI] = ACTIONS(2378),
    [anon_sym___extension__] = ACTIONS(2376),
    [anon_sym_typedef] = ACTIONS(2376),
    [anon_sym___device__] = ACTIONS(2376),
    [anon_sym___host__] = ACTIONS(2376),
    [anon_sym___global__] = ACTIONS(2376),
    [anon_sym___forceinline__] = ACTIONS(2376),
    [anon_sym___noinline__] = ACTIONS(2376),
    [anon_sym_extern] = ACTIONS(2376),
    [anon_sym___attribute__] = ACTIONS(2376),
    [anon_sym_COLON_COLON] = ACTIONS(2378),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2378),
    [anon_sym___declspec] = ACTIONS(2376),
    [anon_sym___based] = ACTIONS(2376),
    [anon_sym___cdecl] = ACTIONS(2376),
    [anon_sym___clrcall] = ACTIONS(2376),
    [anon_sym___stdcall] = ACTIONS(2376),
    [anon_sym___fastcall] = ACTIONS(2376),
    [anon_sym___thiscall] = ACTIONS(2376),
    [anon_sym___vectorcall] = ACTIONS(2376),
    [anon_sym_LBRACE] = ACTIONS(2378),
    [anon_sym_RBRACE] = ACTIONS(2378),
    [anon_sym_signed] = ACTIONS(2376),
    [anon_sym_unsigned] = ACTIONS(2376),
    [anon_sym_long] = ACTIONS(2376),
    [anon_sym_short] = ACTIONS(2376),
    [anon_sym_LBRACK] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2376),
    [anon_sym_register] = ACTIONS(2376),
    [anon_sym_inline] = ACTIONS(2376),
    [anon_sym___inline] = ACTIONS(2376),
    [anon_sym___inline__] = ACTIONS(2376),
    [anon_sym___forceinline] = ACTIONS(2376),
    [anon_sym_thread_local] = ACTIONS(2376),
    [anon_sym___thread] = ACTIONS(2376),
    [anon_sym_const] = ACTIONS(2376),
    [anon_sym_constexpr] = ACTIONS(2376),
    [anon_sym_volatile] = ACTIONS(2376),
    [anon_sym_restrict] = ACTIONS(2376),
    [anon_sym___restrict__] = ACTIONS(2376),
    [anon_sym__Atomic] = ACTIONS(2376),
    [anon_sym__Noreturn] = ACTIONS(2376),
    [anon_sym_noreturn] = ACTIONS(2376),
    [anon_sym_mutable] = ACTIONS(2376),
    [anon_sym_constinit] = ACTIONS(2376),
    [anon_sym_consteval] = ACTIONS(2376),
    [anon_sym___shared__] = ACTIONS(2376),
    [anon_sym___local__] = ACTIONS(2376),
    [anon_sym___constant__] = ACTIONS(2376),
    [anon_sym___managed__] = ACTIONS(2376),
    [anon_sym___grid_constant__] = ACTIONS(2376),
    [anon_sym_alignas] = ACTIONS(2376),
    [anon_sym__Alignas] = ACTIONS(2376),
    [sym_primitive_type] = ACTIONS(2376),
    [anon_sym_enum] = ACTIONS(2376),
    [anon_sym_class] = ACTIONS(2376),
    [anon_sym_struct] = ACTIONS(2376),
    [anon_sym_union] = ACTIONS(2376),
    [anon_sym_if] = ACTIONS(2376),
    [anon_sym_switch] = ACTIONS(2376),
    [anon_sym_case] = ACTIONS(2376),
    [anon_sym_default] = ACTIONS(2376),
    [anon_sym_while] = ACTIONS(2376),
    [anon_sym_do] = ACTIONS(2376),
    [anon_sym_for] = ACTIONS(2376),
    [anon_sym_return] = ACTIONS(2376),
    [anon_sym_break] = ACTIONS(2376),
    [anon_sym_continue] = ACTIONS(2376),
    [anon_sym_goto] = ACTIONS(2376),
    [anon_sym___try] = ACTIONS(2376),
    [anon_sym___leave] = ACTIONS(2376),
    [anon_sym_not] = ACTIONS(2376),
    [anon_sym_compl] = ACTIONS(2376),
    [anon_sym_DASH_DASH] = ACTIONS(2378),
    [anon_sym_PLUS_PLUS] = ACTIONS(2378),
    [anon_sym_sizeof] = ACTIONS(2376),
    [anon_sym___alignof__] = ACTIONS(2376),
    [anon_sym___alignof] = ACTIONS(2376),
    [anon_sym__alignof] = ACTIONS(2376),
    [anon_sym_alignof] = ACTIONS(2376),
    [anon_sym__Alignof] = ACTIONS(2376),
    [anon_sym_offsetof] = ACTIONS(2376),
    [anon_sym__Generic] = ACTIONS(2376),
    [anon_sym_asm] = ACTIONS(2376),
    [anon_sym___asm__] = ACTIONS(2376),
    [sym_number_literal] = ACTIONS(2378),
    [anon_sym_L_SQUOTE] = ACTIONS(2378),
    [anon_sym_u_SQUOTE] = ACTIONS(2378),
    [anon_sym_U_SQUOTE] = ACTIONS(2378),
    [anon_sym_u8_SQUOTE] = ACTIONS(2378),
    [anon_sym_SQUOTE] = ACTIONS(2378),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2376),
    [sym_false] = ACTIONS(2376),
    [anon_sym_NULL] = ACTIONS(2376),
    [anon_sym_nullptr] = ACTIONS(2376),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2376),
    [anon_sym_decltype] = ACTIONS(2376),
    [sym_virtual] = ACTIONS(2376),
    [anon_sym_explicit] = ACTIONS(2376),
    [anon_sym_typename] = ACTIONS(2376),
    [anon_sym_template] = ACTIONS(2376),
    [anon_sym_operator] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2376),
    [anon_sym_delete] = ACTIONS(2376),
    [anon_sym_throw] = ACTIONS(2376),
    [anon_sym_namespace] = ACTIONS(2376),
    [anon_sym_using] = ACTIONS(2376),
    [anon_sym_static_assert] = ACTIONS(2376),
    [anon_sym_concept] = ACTIONS(2376),
    [anon_sym_co_return] = ACTIONS(2376),
    [anon_sym_co_yield] = ACTIONS(2376),
    [anon_sym_R_DQUOTE] = ACTIONS(2378),
    [anon_sym_LR_DQUOTE] = ACTIONS(2378),
    [anon_sym_uR_DQUOTE] = ACTIONS(2378),
    [anon_sym_UR_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2378),
    [anon_sym_co_await] = ACTIONS(2376),
    [anon_sym_new] = ACTIONS(2376),
    [anon_sym_requires] = ACTIONS(2376),
    [sym_this] = ACTIONS(2376),
    [anon_sym___launch_bounds__] = ACTIONS(2376),
  },
  [600] = {
    [sym_type_qualifier] = STATE(3531),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4591),
    [sym_sized_type_specifier] = STATE(2599),
    [sym_enum_specifier] = STATE(2599),
    [sym_struct_specifier] = STATE(2599),
    [sym_union_specifier] = STATE(2599),
    [sym_expression] = STATE(4659),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_type_descriptor] = STATE(7136),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_placeholder_type_specifier] = STATE(2599),
    [sym_decltype_auto] = STATE(2598),
    [sym_decltype] = STATE(2477),
    [sym_class_specifier] = STATE(2599),
    [sym__class_name] = STATE(8015),
    [sym_dependent_type] = STATE(2599),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_type_parameter_pack_expansion] = STATE(7768),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5910),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [aux_sym__type_definition_type_repeat1] = STATE(3531),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2157),
    [sym_identifier] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2725),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2729),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2733),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2757),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2761),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_GT2] = ACTIONS(2837),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [601] = {
    [sym_identifier] = ACTIONS(2199),
    [aux_sym_preproc_include_token1] = ACTIONS(2199),
    [aux_sym_preproc_def_token1] = ACTIONS(2199),
    [aux_sym_preproc_if_token1] = ACTIONS(2199),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2199),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2199),
    [sym_preproc_directive] = ACTIONS(2199),
    [anon_sym_LPAREN2] = ACTIONS(2201),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2201),
    [anon_sym_AMP_AMP] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2199),
    [anon_sym_SEMI] = ACTIONS(2201),
    [anon_sym___extension__] = ACTIONS(2199),
    [anon_sym_typedef] = ACTIONS(2199),
    [anon_sym___device__] = ACTIONS(2199),
    [anon_sym___host__] = ACTIONS(2199),
    [anon_sym___global__] = ACTIONS(2199),
    [anon_sym___forceinline__] = ACTIONS(2199),
    [anon_sym___noinline__] = ACTIONS(2199),
    [anon_sym_extern] = ACTIONS(2199),
    [anon_sym___attribute__] = ACTIONS(2199),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2201),
    [anon_sym___declspec] = ACTIONS(2199),
    [anon_sym___based] = ACTIONS(2199),
    [anon_sym___cdecl] = ACTIONS(2199),
    [anon_sym___clrcall] = ACTIONS(2199),
    [anon_sym___stdcall] = ACTIONS(2199),
    [anon_sym___fastcall] = ACTIONS(2199),
    [anon_sym___thiscall] = ACTIONS(2199),
    [anon_sym___vectorcall] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(2201),
    [anon_sym_RBRACE] = ACTIONS(2201),
    [anon_sym_signed] = ACTIONS(2199),
    [anon_sym_unsigned] = ACTIONS(2199),
    [anon_sym_long] = ACTIONS(2199),
    [anon_sym_short] = ACTIONS(2199),
    [anon_sym_LBRACK] = ACTIONS(2199),
    [anon_sym_static] = ACTIONS(2199),
    [anon_sym_register] = ACTIONS(2199),
    [anon_sym_inline] = ACTIONS(2199),
    [anon_sym___inline] = ACTIONS(2199),
    [anon_sym___inline__] = ACTIONS(2199),
    [anon_sym___forceinline] = ACTIONS(2199),
    [anon_sym_thread_local] = ACTIONS(2199),
    [anon_sym___thread] = ACTIONS(2199),
    [anon_sym_const] = ACTIONS(2199),
    [anon_sym_constexpr] = ACTIONS(2199),
    [anon_sym_volatile] = ACTIONS(2199),
    [anon_sym_restrict] = ACTIONS(2199),
    [anon_sym___restrict__] = ACTIONS(2199),
    [anon_sym__Atomic] = ACTIONS(2199),
    [anon_sym__Noreturn] = ACTIONS(2199),
    [anon_sym_noreturn] = ACTIONS(2199),
    [anon_sym_mutable] = ACTIONS(2199),
    [anon_sym_constinit] = ACTIONS(2199),
    [anon_sym_consteval] = ACTIONS(2199),
    [anon_sym___shared__] = ACTIONS(2199),
    [anon_sym___local__] = ACTIONS(2199),
    [anon_sym___constant__] = ACTIONS(2199),
    [anon_sym___managed__] = ACTIONS(2199),
    [anon_sym___grid_constant__] = ACTIONS(2199),
    [anon_sym_alignas] = ACTIONS(2199),
    [anon_sym__Alignas] = ACTIONS(2199),
    [sym_primitive_type] = ACTIONS(2199),
    [anon_sym_enum] = ACTIONS(2199),
    [anon_sym_class] = ACTIONS(2199),
    [anon_sym_struct] = ACTIONS(2199),
    [anon_sym_union] = ACTIONS(2199),
    [anon_sym_if] = ACTIONS(2199),
    [anon_sym_switch] = ACTIONS(2199),
    [anon_sym_case] = ACTIONS(2199),
    [anon_sym_default] = ACTIONS(2199),
    [anon_sym_while] = ACTIONS(2199),
    [anon_sym_do] = ACTIONS(2199),
    [anon_sym_for] = ACTIONS(2199),
    [anon_sym_return] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2199),
    [anon_sym_continue] = ACTIONS(2199),
    [anon_sym_goto] = ACTIONS(2199),
    [anon_sym___try] = ACTIONS(2199),
    [anon_sym___leave] = ACTIONS(2199),
    [anon_sym_not] = ACTIONS(2199),
    [anon_sym_compl] = ACTIONS(2199),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_sizeof] = ACTIONS(2199),
    [anon_sym___alignof__] = ACTIONS(2199),
    [anon_sym___alignof] = ACTIONS(2199),
    [anon_sym__alignof] = ACTIONS(2199),
    [anon_sym_alignof] = ACTIONS(2199),
    [anon_sym__Alignof] = ACTIONS(2199),
    [anon_sym_offsetof] = ACTIONS(2199),
    [anon_sym__Generic] = ACTIONS(2199),
    [anon_sym_asm] = ACTIONS(2199),
    [anon_sym___asm__] = ACTIONS(2199),
    [sym_number_literal] = ACTIONS(2201),
    [anon_sym_L_SQUOTE] = ACTIONS(2201),
    [anon_sym_u_SQUOTE] = ACTIONS(2201),
    [anon_sym_U_SQUOTE] = ACTIONS(2201),
    [anon_sym_u8_SQUOTE] = ACTIONS(2201),
    [anon_sym_SQUOTE] = ACTIONS(2201),
    [anon_sym_L_DQUOTE] = ACTIONS(2201),
    [anon_sym_u_DQUOTE] = ACTIONS(2201),
    [anon_sym_U_DQUOTE] = ACTIONS(2201),
    [anon_sym_u8_DQUOTE] = ACTIONS(2201),
    [anon_sym_DQUOTE] = ACTIONS(2201),
    [sym_true] = ACTIONS(2199),
    [sym_false] = ACTIONS(2199),
    [anon_sym_NULL] = ACTIONS(2199),
    [anon_sym_nullptr] = ACTIONS(2199),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2199),
    [anon_sym_decltype] = ACTIONS(2199),
    [sym_virtual] = ACTIONS(2199),
    [anon_sym_explicit] = ACTIONS(2199),
    [anon_sym_typename] = ACTIONS(2199),
    [anon_sym_template] = ACTIONS(2199),
    [anon_sym_operator] = ACTIONS(2199),
    [anon_sym_try] = ACTIONS(2199),
    [anon_sym_delete] = ACTIONS(2199),
    [anon_sym_throw] = ACTIONS(2199),
    [anon_sym_namespace] = ACTIONS(2199),
    [anon_sym_using] = ACTIONS(2199),
    [anon_sym_static_assert] = ACTIONS(2199),
    [anon_sym_concept] = ACTIONS(2199),
    [anon_sym_co_return] = ACTIONS(2199),
    [anon_sym_co_yield] = ACTIONS(2199),
    [anon_sym_R_DQUOTE] = ACTIONS(2201),
    [anon_sym_LR_DQUOTE] = ACTIONS(2201),
    [anon_sym_uR_DQUOTE] = ACTIONS(2201),
    [anon_sym_UR_DQUOTE] = ACTIONS(2201),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2201),
    [anon_sym_co_await] = ACTIONS(2199),
    [anon_sym_new] = ACTIONS(2199),
    [anon_sym_requires] = ACTIONS(2199),
    [sym_this] = ACTIONS(2199),
    [anon_sym___launch_bounds__] = ACTIONS(2199),
  },
  [602] = {
    [sym_identifier] = ACTIONS(2465),
    [aux_sym_preproc_include_token1] = ACTIONS(2465),
    [aux_sym_preproc_def_token1] = ACTIONS(2465),
    [aux_sym_preproc_if_token1] = ACTIONS(2465),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2465),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2465),
    [sym_preproc_directive] = ACTIONS(2465),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(2467),
    [anon_sym_TILDE] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(2465),
    [anon_sym_PLUS] = ACTIONS(2465),
    [anon_sym_STAR] = ACTIONS(2467),
    [anon_sym_AMP_AMP] = ACTIONS(2467),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym_SEMI] = ACTIONS(2467),
    [anon_sym___extension__] = ACTIONS(2465),
    [anon_sym_typedef] = ACTIONS(2465),
    [anon_sym___device__] = ACTIONS(2465),
    [anon_sym___host__] = ACTIONS(2465),
    [anon_sym___global__] = ACTIONS(2465),
    [anon_sym___forceinline__] = ACTIONS(2465),
    [anon_sym___noinline__] = ACTIONS(2465),
    [anon_sym_extern] = ACTIONS(2465),
    [anon_sym___attribute__] = ACTIONS(2465),
    [anon_sym_COLON_COLON] = ACTIONS(2467),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2467),
    [anon_sym___declspec] = ACTIONS(2465),
    [anon_sym___based] = ACTIONS(2465),
    [anon_sym___cdecl] = ACTIONS(2465),
    [anon_sym___clrcall] = ACTIONS(2465),
    [anon_sym___stdcall] = ACTIONS(2465),
    [anon_sym___fastcall] = ACTIONS(2465),
    [anon_sym___thiscall] = ACTIONS(2465),
    [anon_sym___vectorcall] = ACTIONS(2465),
    [anon_sym_LBRACE] = ACTIONS(2467),
    [anon_sym_RBRACE] = ACTIONS(2467),
    [anon_sym_signed] = ACTIONS(2465),
    [anon_sym_unsigned] = ACTIONS(2465),
    [anon_sym_long] = ACTIONS(2465),
    [anon_sym_short] = ACTIONS(2465),
    [anon_sym_LBRACK] = ACTIONS(2465),
    [anon_sym_static] = ACTIONS(2465),
    [anon_sym_register] = ACTIONS(2465),
    [anon_sym_inline] = ACTIONS(2465),
    [anon_sym___inline] = ACTIONS(2465),
    [anon_sym___inline__] = ACTIONS(2465),
    [anon_sym___forceinline] = ACTIONS(2465),
    [anon_sym_thread_local] = ACTIONS(2465),
    [anon_sym___thread] = ACTIONS(2465),
    [anon_sym_const] = ACTIONS(2465),
    [anon_sym_constexpr] = ACTIONS(2465),
    [anon_sym_volatile] = ACTIONS(2465),
    [anon_sym_restrict] = ACTIONS(2465),
    [anon_sym___restrict__] = ACTIONS(2465),
    [anon_sym__Atomic] = ACTIONS(2465),
    [anon_sym__Noreturn] = ACTIONS(2465),
    [anon_sym_noreturn] = ACTIONS(2465),
    [anon_sym_mutable] = ACTIONS(2465),
    [anon_sym_constinit] = ACTIONS(2465),
    [anon_sym_consteval] = ACTIONS(2465),
    [anon_sym___shared__] = ACTIONS(2465),
    [anon_sym___local__] = ACTIONS(2465),
    [anon_sym___constant__] = ACTIONS(2465),
    [anon_sym___managed__] = ACTIONS(2465),
    [anon_sym___grid_constant__] = ACTIONS(2465),
    [anon_sym_alignas] = ACTIONS(2465),
    [anon_sym__Alignas] = ACTIONS(2465),
    [sym_primitive_type] = ACTIONS(2465),
    [anon_sym_enum] = ACTIONS(2465),
    [anon_sym_class] = ACTIONS(2465),
    [anon_sym_struct] = ACTIONS(2465),
    [anon_sym_union] = ACTIONS(2465),
    [anon_sym_if] = ACTIONS(2465),
    [anon_sym_switch] = ACTIONS(2465),
    [anon_sym_case] = ACTIONS(2465),
    [anon_sym_default] = ACTIONS(2465),
    [anon_sym_while] = ACTIONS(2465),
    [anon_sym_do] = ACTIONS(2465),
    [anon_sym_for] = ACTIONS(2465),
    [anon_sym_return] = ACTIONS(2465),
    [anon_sym_break] = ACTIONS(2465),
    [anon_sym_continue] = ACTIONS(2465),
    [anon_sym_goto] = ACTIONS(2465),
    [anon_sym___try] = ACTIONS(2465),
    [anon_sym___leave] = ACTIONS(2465),
    [anon_sym_not] = ACTIONS(2465),
    [anon_sym_compl] = ACTIONS(2465),
    [anon_sym_DASH_DASH] = ACTIONS(2467),
    [anon_sym_PLUS_PLUS] = ACTIONS(2467),
    [anon_sym_sizeof] = ACTIONS(2465),
    [anon_sym___alignof__] = ACTIONS(2465),
    [anon_sym___alignof] = ACTIONS(2465),
    [anon_sym__alignof] = ACTIONS(2465),
    [anon_sym_alignof] = ACTIONS(2465),
    [anon_sym__Alignof] = ACTIONS(2465),
    [anon_sym_offsetof] = ACTIONS(2465),
    [anon_sym__Generic] = ACTIONS(2465),
    [anon_sym_asm] = ACTIONS(2465),
    [anon_sym___asm__] = ACTIONS(2465),
    [sym_number_literal] = ACTIONS(2467),
    [anon_sym_L_SQUOTE] = ACTIONS(2467),
    [anon_sym_u_SQUOTE] = ACTIONS(2467),
    [anon_sym_U_SQUOTE] = ACTIONS(2467),
    [anon_sym_u8_SQUOTE] = ACTIONS(2467),
    [anon_sym_SQUOTE] = ACTIONS(2467),
    [anon_sym_L_DQUOTE] = ACTIONS(2467),
    [anon_sym_u_DQUOTE] = ACTIONS(2467),
    [anon_sym_U_DQUOTE] = ACTIONS(2467),
    [anon_sym_u8_DQUOTE] = ACTIONS(2467),
    [anon_sym_DQUOTE] = ACTIONS(2467),
    [sym_true] = ACTIONS(2465),
    [sym_false] = ACTIONS(2465),
    [anon_sym_NULL] = ACTIONS(2465),
    [anon_sym_nullptr] = ACTIONS(2465),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2465),
    [anon_sym_decltype] = ACTIONS(2465),
    [sym_virtual] = ACTIONS(2465),
    [anon_sym_explicit] = ACTIONS(2465),
    [anon_sym_typename] = ACTIONS(2465),
    [anon_sym_template] = ACTIONS(2465),
    [anon_sym_operator] = ACTIONS(2465),
    [anon_sym_try] = ACTIONS(2465),
    [anon_sym_delete] = ACTIONS(2465),
    [anon_sym_throw] = ACTIONS(2465),
    [anon_sym_namespace] = ACTIONS(2465),
    [anon_sym_using] = ACTIONS(2465),
    [anon_sym_static_assert] = ACTIONS(2465),
    [anon_sym_concept] = ACTIONS(2465),
    [anon_sym_co_return] = ACTIONS(2465),
    [anon_sym_co_yield] = ACTIONS(2465),
    [anon_sym_R_DQUOTE] = ACTIONS(2467),
    [anon_sym_LR_DQUOTE] = ACTIONS(2467),
    [anon_sym_uR_DQUOTE] = ACTIONS(2467),
    [anon_sym_UR_DQUOTE] = ACTIONS(2467),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2467),
    [anon_sym_co_await] = ACTIONS(2465),
    [anon_sym_new] = ACTIONS(2465),
    [anon_sym_requires] = ACTIONS(2465),
    [sym_this] = ACTIONS(2465),
    [anon_sym___launch_bounds__] = ACTIONS(2465),
  },
  [603] = {
    [sym_identifier] = ACTIONS(2348),
    [aux_sym_preproc_include_token1] = ACTIONS(2348),
    [aux_sym_preproc_def_token1] = ACTIONS(2348),
    [aux_sym_preproc_if_token1] = ACTIONS(2348),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2348),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2348),
    [sym_preproc_directive] = ACTIONS(2348),
    [anon_sym_LPAREN2] = ACTIONS(2350),
    [anon_sym_BANG] = ACTIONS(2350),
    [anon_sym_TILDE] = ACTIONS(2350),
    [anon_sym_DASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(2348),
    [anon_sym_STAR] = ACTIONS(2350),
    [anon_sym_AMP_AMP] = ACTIONS(2350),
    [anon_sym_AMP] = ACTIONS(2348),
    [anon_sym_SEMI] = ACTIONS(2350),
    [anon_sym___extension__] = ACTIONS(2348),
    [anon_sym_typedef] = ACTIONS(2348),
    [anon_sym___device__] = ACTIONS(2348),
    [anon_sym___host__] = ACTIONS(2348),
    [anon_sym___global__] = ACTIONS(2348),
    [anon_sym___forceinline__] = ACTIONS(2348),
    [anon_sym___noinline__] = ACTIONS(2348),
    [anon_sym_extern] = ACTIONS(2348),
    [anon_sym___attribute__] = ACTIONS(2348),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2350),
    [anon_sym___declspec] = ACTIONS(2348),
    [anon_sym___based] = ACTIONS(2348),
    [anon_sym___cdecl] = ACTIONS(2348),
    [anon_sym___clrcall] = ACTIONS(2348),
    [anon_sym___stdcall] = ACTIONS(2348),
    [anon_sym___fastcall] = ACTIONS(2348),
    [anon_sym___thiscall] = ACTIONS(2348),
    [anon_sym___vectorcall] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(2350),
    [anon_sym_RBRACE] = ACTIONS(2350),
    [anon_sym_signed] = ACTIONS(2348),
    [anon_sym_unsigned] = ACTIONS(2348),
    [anon_sym_long] = ACTIONS(2348),
    [anon_sym_short] = ACTIONS(2348),
    [anon_sym_LBRACK] = ACTIONS(2348),
    [anon_sym_static] = ACTIONS(2348),
    [anon_sym_register] = ACTIONS(2348),
    [anon_sym_inline] = ACTIONS(2348),
    [anon_sym___inline] = ACTIONS(2348),
    [anon_sym___inline__] = ACTIONS(2348),
    [anon_sym___forceinline] = ACTIONS(2348),
    [anon_sym_thread_local] = ACTIONS(2348),
    [anon_sym___thread] = ACTIONS(2348),
    [anon_sym_const] = ACTIONS(2348),
    [anon_sym_constexpr] = ACTIONS(2348),
    [anon_sym_volatile] = ACTIONS(2348),
    [anon_sym_restrict] = ACTIONS(2348),
    [anon_sym___restrict__] = ACTIONS(2348),
    [anon_sym__Atomic] = ACTIONS(2348),
    [anon_sym__Noreturn] = ACTIONS(2348),
    [anon_sym_noreturn] = ACTIONS(2348),
    [anon_sym_mutable] = ACTIONS(2348),
    [anon_sym_constinit] = ACTIONS(2348),
    [anon_sym_consteval] = ACTIONS(2348),
    [anon_sym___shared__] = ACTIONS(2348),
    [anon_sym___local__] = ACTIONS(2348),
    [anon_sym___constant__] = ACTIONS(2348),
    [anon_sym___managed__] = ACTIONS(2348),
    [anon_sym___grid_constant__] = ACTIONS(2348),
    [anon_sym_alignas] = ACTIONS(2348),
    [anon_sym__Alignas] = ACTIONS(2348),
    [sym_primitive_type] = ACTIONS(2348),
    [anon_sym_enum] = ACTIONS(2348),
    [anon_sym_class] = ACTIONS(2348),
    [anon_sym_struct] = ACTIONS(2348),
    [anon_sym_union] = ACTIONS(2348),
    [anon_sym_if] = ACTIONS(2348),
    [anon_sym_switch] = ACTIONS(2348),
    [anon_sym_case] = ACTIONS(2348),
    [anon_sym_default] = ACTIONS(2348),
    [anon_sym_while] = ACTIONS(2348),
    [anon_sym_do] = ACTIONS(2348),
    [anon_sym_for] = ACTIONS(2348),
    [anon_sym_return] = ACTIONS(2348),
    [anon_sym_break] = ACTIONS(2348),
    [anon_sym_continue] = ACTIONS(2348),
    [anon_sym_goto] = ACTIONS(2348),
    [anon_sym___try] = ACTIONS(2348),
    [anon_sym___leave] = ACTIONS(2348),
    [anon_sym_not] = ACTIONS(2348),
    [anon_sym_compl] = ACTIONS(2348),
    [anon_sym_DASH_DASH] = ACTIONS(2350),
    [anon_sym_PLUS_PLUS] = ACTIONS(2350),
    [anon_sym_sizeof] = ACTIONS(2348),
    [anon_sym___alignof__] = ACTIONS(2348),
    [anon_sym___alignof] = ACTIONS(2348),
    [anon_sym__alignof] = ACTIONS(2348),
    [anon_sym_alignof] = ACTIONS(2348),
    [anon_sym__Alignof] = ACTIONS(2348),
    [anon_sym_offsetof] = ACTIONS(2348),
    [anon_sym__Generic] = ACTIONS(2348),
    [anon_sym_asm] = ACTIONS(2348),
    [anon_sym___asm__] = ACTIONS(2348),
    [sym_number_literal] = ACTIONS(2350),
    [anon_sym_L_SQUOTE] = ACTIONS(2350),
    [anon_sym_u_SQUOTE] = ACTIONS(2350),
    [anon_sym_U_SQUOTE] = ACTIONS(2350),
    [anon_sym_u8_SQUOTE] = ACTIONS(2350),
    [anon_sym_SQUOTE] = ACTIONS(2350),
    [anon_sym_L_DQUOTE] = ACTIONS(2350),
    [anon_sym_u_DQUOTE] = ACTIONS(2350),
    [anon_sym_U_DQUOTE] = ACTIONS(2350),
    [anon_sym_u8_DQUOTE] = ACTIONS(2350),
    [anon_sym_DQUOTE] = ACTIONS(2350),
    [sym_true] = ACTIONS(2348),
    [sym_false] = ACTIONS(2348),
    [anon_sym_NULL] = ACTIONS(2348),
    [anon_sym_nullptr] = ACTIONS(2348),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2348),
    [anon_sym_decltype] = ACTIONS(2348),
    [sym_virtual] = ACTIONS(2348),
    [anon_sym_explicit] = ACTIONS(2348),
    [anon_sym_typename] = ACTIONS(2348),
    [anon_sym_template] = ACTIONS(2348),
    [anon_sym_operator] = ACTIONS(2348),
    [anon_sym_try] = ACTIONS(2348),
    [anon_sym_delete] = ACTIONS(2348),
    [anon_sym_throw] = ACTIONS(2348),
    [anon_sym_namespace] = ACTIONS(2348),
    [anon_sym_using] = ACTIONS(2348),
    [anon_sym_static_assert] = ACTIONS(2348),
    [anon_sym_concept] = ACTIONS(2348),
    [anon_sym_co_return] = ACTIONS(2348),
    [anon_sym_co_yield] = ACTIONS(2348),
    [anon_sym_R_DQUOTE] = ACTIONS(2350),
    [anon_sym_LR_DQUOTE] = ACTIONS(2350),
    [anon_sym_uR_DQUOTE] = ACTIONS(2350),
    [anon_sym_UR_DQUOTE] = ACTIONS(2350),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2350),
    [anon_sym_co_await] = ACTIONS(2348),
    [anon_sym_new] = ACTIONS(2348),
    [anon_sym_requires] = ACTIONS(2348),
    [sym_this] = ACTIONS(2348),
    [anon_sym___launch_bounds__] = ACTIONS(2348),
  },
  [604] = {
    [sym_type_qualifier] = STATE(3531),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4591),
    [sym_sized_type_specifier] = STATE(2599),
    [sym_enum_specifier] = STATE(2599),
    [sym_struct_specifier] = STATE(2599),
    [sym_union_specifier] = STATE(2599),
    [sym_expression] = STATE(4672),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_type_descriptor] = STATE(7123),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_placeholder_type_specifier] = STATE(2599),
    [sym_decltype_auto] = STATE(2598),
    [sym_decltype] = STATE(2477),
    [sym_class_specifier] = STATE(2599),
    [sym__class_name] = STATE(8015),
    [sym_dependent_type] = STATE(2599),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_type_parameter_pack_expansion] = STATE(7788),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5910),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [aux_sym__type_definition_type_repeat1] = STATE(3531),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2157),
    [sym_identifier] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2725),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2729),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2733),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2757),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2761),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_GT2] = ACTIONS(2839),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [605] = {
    [sym_attribute_declaration] = STATE(622),
    [sym_compound_statement] = STATE(351),
    [sym_attributed_statement] = STATE(351),
    [sym_statement] = STATE(389),
    [sym_labeled_statement] = STATE(351),
    [sym_expression_statement] = STATE(351),
    [sym_if_statement] = STATE(351),
    [sym_switch_statement] = STATE(351),
    [sym_case_statement] = STATE(351),
    [sym_while_statement] = STATE(351),
    [sym_do_statement] = STATE(351),
    [sym_for_statement] = STATE(351),
    [sym_return_statement] = STATE(351),
    [sym_break_statement] = STATE(351),
    [sym_continue_statement] = STATE(351),
    [sym_goto_statement] = STATE(351),
    [sym_seh_try_statement] = STATE(351),
    [sym_seh_leave_statement] = STATE(351),
    [sym_expression] = STATE(4855),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8338),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(351),
    [sym_co_return_statement] = STATE(351),
    [sym_co_yield_statement] = STATE(351),
    [sym_throw_statement] = STATE(351),
    [sym_try_statement] = STATE(351),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(622),
    [sym_identifier] = ACTIONS(2841),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(651),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(663),
    [anon_sym_switch] = ACTIONS(665),
    [anon_sym_case] = ACTIONS(667),
    [anon_sym_default] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_do] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(677),
    [anon_sym_break] = ACTIONS(679),
    [anon_sym_continue] = ACTIONS(681),
    [anon_sym_goto] = ACTIONS(683),
    [anon_sym___try] = ACTIONS(685),
    [anon_sym___leave] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(691),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_co_return] = ACTIONS(703),
    [anon_sym_co_yield] = ACTIONS(705),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [606] = {
    [sym_attribute_declaration] = STATE(668),
    [sym_compound_statement] = STATE(423),
    [sym_attributed_statement] = STATE(423),
    [sym_statement] = STATE(380),
    [sym_labeled_statement] = STATE(423),
    [sym_expression_statement] = STATE(423),
    [sym_if_statement] = STATE(423),
    [sym_switch_statement] = STATE(423),
    [sym_case_statement] = STATE(423),
    [sym_while_statement] = STATE(423),
    [sym_do_statement] = STATE(423),
    [sym_for_statement] = STATE(423),
    [sym_return_statement] = STATE(423),
    [sym_break_statement] = STATE(423),
    [sym_continue_statement] = STATE(423),
    [sym_goto_statement] = STATE(423),
    [sym_seh_try_statement] = STATE(423),
    [sym_seh_leave_statement] = STATE(423),
    [sym_expression] = STATE(4913),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8497),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(423),
    [sym_co_return_statement] = STATE(423),
    [sym_co_yield_statement] = STATE(423),
    [sym_throw_statement] = STATE(423),
    [sym_try_statement] = STATE(423),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(668),
    [sym_identifier] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1571),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(81),
    [anon_sym_default] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(1573),
    [anon_sym___leave] = ACTIONS(1575),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [607] = {
    [sym_attribute_declaration] = STATE(666),
    [sym_compound_statement] = STATE(160),
    [sym_attributed_statement] = STATE(160),
    [sym_statement] = STATE(163),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [sym_identifier] = ACTIONS(2845),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [608] = {
    [sym_attribute_declaration] = STATE(666),
    [sym_compound_statement] = STATE(160),
    [sym_attributed_statement] = STATE(160),
    [sym_statement] = STATE(140),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [sym_identifier] = ACTIONS(2845),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [609] = {
    [sym_attribute_declaration] = STATE(606),
    [sym_compound_statement] = STATE(423),
    [sym_attributed_statement] = STATE(423),
    [sym_statement] = STATE(320),
    [sym_labeled_statement] = STATE(423),
    [sym_expression_statement] = STATE(423),
    [sym_if_statement] = STATE(423),
    [sym_switch_statement] = STATE(423),
    [sym_case_statement] = STATE(423),
    [sym_while_statement] = STATE(423),
    [sym_do_statement] = STATE(423),
    [sym_for_statement] = STATE(423),
    [sym_return_statement] = STATE(423),
    [sym_break_statement] = STATE(423),
    [sym_continue_statement] = STATE(423),
    [sym_goto_statement] = STATE(423),
    [sym_seh_try_statement] = STATE(423),
    [sym_seh_leave_statement] = STATE(423),
    [sym_expression] = STATE(4913),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8497),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(423),
    [sym_co_return_statement] = STATE(423),
    [sym_co_yield_statement] = STATE(423),
    [sym_throw_statement] = STATE(423),
    [sym_try_statement] = STATE(423),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(606),
    [sym_identifier] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1571),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(81),
    [anon_sym_default] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(1573),
    [anon_sym___leave] = ACTIONS(1575),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [610] = {
    [sym_attribute_declaration] = STATE(634),
    [sym_compound_statement] = STATE(439),
    [sym_attributed_statement] = STATE(439),
    [sym_statement] = STATE(7428),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(634),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(2849),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(2851),
    [anon_sym_default] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(2857),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(2859),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [611] = {
    [sym_attribute_declaration] = STATE(634),
    [sym_compound_statement] = STATE(439),
    [sym_attributed_statement] = STATE(439),
    [sym_statement] = STATE(349),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(634),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(2849),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(2851),
    [anon_sym_default] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(2857),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(2859),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [612] = {
    [sym_attribute_declaration] = STATE(634),
    [sym_compound_statement] = STATE(439),
    [sym_attributed_statement] = STATE(439),
    [sym_statement] = STATE(382),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(634),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(2849),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(2851),
    [anon_sym_default] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(2857),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(2859),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [613] = {
    [sym_attribute_declaration] = STATE(613),
    [sym_compound_statement] = STATE(439),
    [sym_attributed_statement] = STATE(439),
    [sym_statement] = STATE(379),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(613),
    [sym_identifier] = ACTIONS(2861),
    [anon_sym_LPAREN2] = ACTIONS(2864),
    [anon_sym_BANG] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2870),
    [anon_sym_PLUS] = ACTIONS(2870),
    [anon_sym_STAR] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_SEMI] = ACTIONS(2876),
    [anon_sym_COLON_COLON] = ACTIONS(2879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2882),
    [anon_sym_LBRACE] = ACTIONS(2885),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [sym_primitive_type] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(2894),
    [anon_sym_switch] = ACTIONS(2897),
    [anon_sym_case] = ACTIONS(2900),
    [anon_sym_default] = ACTIONS(2903),
    [anon_sym_while] = ACTIONS(2906),
    [anon_sym_do] = ACTIONS(2909),
    [anon_sym_for] = ACTIONS(2912),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_break] = ACTIONS(2918),
    [anon_sym_continue] = ACTIONS(2921),
    [anon_sym_goto] = ACTIONS(2924),
    [anon_sym___try] = ACTIONS(2927),
    [anon_sym___leave] = ACTIONS(2930),
    [anon_sym_not] = ACTIONS(2870),
    [anon_sym_compl] = ACTIONS(2870),
    [anon_sym_DASH_DASH] = ACTIONS(2933),
    [anon_sym_PLUS_PLUS] = ACTIONS(2933),
    [anon_sym_sizeof] = ACTIONS(2936),
    [anon_sym___alignof__] = ACTIONS(2939),
    [anon_sym___alignof] = ACTIONS(2939),
    [anon_sym__alignof] = ACTIONS(2939),
    [anon_sym_alignof] = ACTIONS(2939),
    [anon_sym__Alignof] = ACTIONS(2939),
    [anon_sym_offsetof] = ACTIONS(2942),
    [anon_sym__Generic] = ACTIONS(2945),
    [anon_sym_asm] = ACTIONS(2948),
    [anon_sym___asm__] = ACTIONS(2948),
    [sym_number_literal] = ACTIONS(2951),
    [anon_sym_L_SQUOTE] = ACTIONS(2954),
    [anon_sym_u_SQUOTE] = ACTIONS(2954),
    [anon_sym_U_SQUOTE] = ACTIONS(2954),
    [anon_sym_u8_SQUOTE] = ACTIONS(2954),
    [anon_sym_SQUOTE] = ACTIONS(2954),
    [anon_sym_L_DQUOTE] = ACTIONS(2957),
    [anon_sym_u_DQUOTE] = ACTIONS(2957),
    [anon_sym_U_DQUOTE] = ACTIONS(2957),
    [anon_sym_u8_DQUOTE] = ACTIONS(2957),
    [anon_sym_DQUOTE] = ACTIONS(2957),
    [sym_true] = ACTIONS(2960),
    [sym_false] = ACTIONS(2960),
    [anon_sym_NULL] = ACTIONS(2963),
    [anon_sym_nullptr] = ACTIONS(2963),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2966),
    [anon_sym_template] = ACTIONS(2969),
    [anon_sym_try] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2975),
    [anon_sym_throw] = ACTIONS(2978),
    [anon_sym_co_return] = ACTIONS(2981),
    [anon_sym_co_yield] = ACTIONS(2984),
    [anon_sym_R_DQUOTE] = ACTIONS(2987),
    [anon_sym_LR_DQUOTE] = ACTIONS(2987),
    [anon_sym_uR_DQUOTE] = ACTIONS(2987),
    [anon_sym_UR_DQUOTE] = ACTIONS(2987),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2987),
    [anon_sym_co_await] = ACTIONS(2990),
    [anon_sym_new] = ACTIONS(2993),
    [anon_sym_requires] = ACTIONS(2996),
    [sym_this] = ACTIONS(2960),
  },
  [614] = {
    [sym_attribute_declaration] = STATE(606),
    [sym_compound_statement] = STATE(423),
    [sym_attributed_statement] = STATE(423),
    [sym_statement] = STATE(368),
    [sym_labeled_statement] = STATE(423),
    [sym_expression_statement] = STATE(423),
    [sym_if_statement] = STATE(423),
    [sym_switch_statement] = STATE(423),
    [sym_case_statement] = STATE(423),
    [sym_while_statement] = STATE(423),
    [sym_do_statement] = STATE(423),
    [sym_for_statement] = STATE(423),
    [sym_return_statement] = STATE(423),
    [sym_break_statement] = STATE(423),
    [sym_continue_statement] = STATE(423),
    [sym_goto_statement] = STATE(423),
    [sym_seh_try_statement] = STATE(423),
    [sym_seh_leave_statement] = STATE(423),
    [sym_expression] = STATE(4913),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8497),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(423),
    [sym_co_return_statement] = STATE(423),
    [sym_co_yield_statement] = STATE(423),
    [sym_throw_statement] = STATE(423),
    [sym_try_statement] = STATE(423),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(606),
    [sym_identifier] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1571),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(81),
    [anon_sym_default] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(1573),
    [anon_sym___leave] = ACTIONS(1575),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [615] = {
    [sym_attribute_declaration] = STATE(635),
    [sym_compound_statement] = STATE(439),
    [sym_attributed_statement] = STATE(439),
    [sym_statement] = STATE(331),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [616] = {
    [sym_attribute_declaration] = STATE(665),
    [sym_compound_statement] = STATE(876),
    [sym_attributed_statement] = STATE(876),
    [sym_statement] = STATE(860),
    [sym_labeled_statement] = STATE(876),
    [sym_expression_statement] = STATE(876),
    [sym_if_statement] = STATE(876),
    [sym_switch_statement] = STATE(876),
    [sym_case_statement] = STATE(876),
    [sym_while_statement] = STATE(876),
    [sym_do_statement] = STATE(876),
    [sym_for_statement] = STATE(876),
    [sym_return_statement] = STATE(876),
    [sym_break_statement] = STATE(876),
    [sym_continue_statement] = STATE(876),
    [sym_goto_statement] = STATE(876),
    [sym_seh_try_statement] = STATE(876),
    [sym_seh_leave_statement] = STATE(876),
    [sym_expression] = STATE(4739),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8303),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(876),
    [sym_co_return_statement] = STATE(876),
    [sym_co_yield_statement] = STATE(876),
    [sym_throw_statement] = STATE(876),
    [sym_try_statement] = STATE(876),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(665),
    [sym_identifier] = ACTIONS(2999),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1639),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(1647),
    [anon_sym_switch] = ACTIONS(1649),
    [anon_sym_case] = ACTIONS(2851),
    [anon_sym_default] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(1651),
    [anon_sym_do] = ACTIONS(1653),
    [anon_sym_for] = ACTIONS(1655),
    [anon_sym_return] = ACTIONS(1657),
    [anon_sym_break] = ACTIONS(1659),
    [anon_sym_continue] = ACTIONS(1661),
    [anon_sym_goto] = ACTIONS(1663),
    [anon_sym___try] = ACTIONS(1665),
    [anon_sym___leave] = ACTIONS(1667),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(1669),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_co_return] = ACTIONS(1673),
    [anon_sym_co_yield] = ACTIONS(1675),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [617] = {
    [sym_attribute_declaration] = STATE(665),
    [sym_compound_statement] = STATE(876),
    [sym_attributed_statement] = STATE(876),
    [sym_statement] = STATE(838),
    [sym_labeled_statement] = STATE(876),
    [sym_expression_statement] = STATE(876),
    [sym_if_statement] = STATE(876),
    [sym_switch_statement] = STATE(876),
    [sym_case_statement] = STATE(876),
    [sym_while_statement] = STATE(876),
    [sym_do_statement] = STATE(876),
    [sym_for_statement] = STATE(876),
    [sym_return_statement] = STATE(876),
    [sym_break_statement] = STATE(876),
    [sym_continue_statement] = STATE(876),
    [sym_goto_statement] = STATE(876),
    [sym_seh_try_statement] = STATE(876),
    [sym_seh_leave_statement] = STATE(876),
    [sym_expression] = STATE(4739),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8303),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(876),
    [sym_co_return_statement] = STATE(876),
    [sym_co_yield_statement] = STATE(876),
    [sym_throw_statement] = STATE(876),
    [sym_try_statement] = STATE(876),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(665),
    [sym_identifier] = ACTIONS(2999),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1639),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(1647),
    [anon_sym_switch] = ACTIONS(1649),
    [anon_sym_case] = ACTIONS(2851),
    [anon_sym_default] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(1651),
    [anon_sym_do] = ACTIONS(1653),
    [anon_sym_for] = ACTIONS(1655),
    [anon_sym_return] = ACTIONS(1657),
    [anon_sym_break] = ACTIONS(1659),
    [anon_sym_continue] = ACTIONS(1661),
    [anon_sym_goto] = ACTIONS(1663),
    [anon_sym___try] = ACTIONS(1665),
    [anon_sym___leave] = ACTIONS(1667),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(1669),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_co_return] = ACTIONS(1673),
    [anon_sym_co_yield] = ACTIONS(1675),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [618] = {
    [sym_attribute_declaration] = STATE(634),
    [sym_compound_statement] = STATE(439),
    [sym_attributed_statement] = STATE(439),
    [sym_statement] = STATE(8422),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(634),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(2849),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(2851),
    [anon_sym_default] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(2857),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(2859),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [619] = {
    [sym_attribute_declaration] = STATE(619),
    [sym_compound_statement] = STATE(439),
    [sym_attributed_statement] = STATE(439),
    [sym_statement] = STATE(380),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(619),
    [sym_identifier] = ACTIONS(3001),
    [anon_sym_LPAREN2] = ACTIONS(2864),
    [anon_sym_BANG] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2870),
    [anon_sym_PLUS] = ACTIONS(2870),
    [anon_sym_STAR] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_SEMI] = ACTIONS(2876),
    [anon_sym_COLON_COLON] = ACTIONS(2879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2882),
    [anon_sym_LBRACE] = ACTIONS(3004),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [sym_primitive_type] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(3007),
    [anon_sym_switch] = ACTIONS(3010),
    [anon_sym_case] = ACTIONS(3013),
    [anon_sym_default] = ACTIONS(3016),
    [anon_sym_while] = ACTIONS(3019),
    [anon_sym_do] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(3025),
    [anon_sym_return] = ACTIONS(3028),
    [anon_sym_break] = ACTIONS(3031),
    [anon_sym_continue] = ACTIONS(3034),
    [anon_sym_goto] = ACTIONS(3037),
    [anon_sym___try] = ACTIONS(3040),
    [anon_sym___leave] = ACTIONS(2930),
    [anon_sym_not] = ACTIONS(2870),
    [anon_sym_compl] = ACTIONS(2870),
    [anon_sym_DASH_DASH] = ACTIONS(2933),
    [anon_sym_PLUS_PLUS] = ACTIONS(2933),
    [anon_sym_sizeof] = ACTIONS(2936),
    [anon_sym___alignof__] = ACTIONS(2939),
    [anon_sym___alignof] = ACTIONS(2939),
    [anon_sym__alignof] = ACTIONS(2939),
    [anon_sym_alignof] = ACTIONS(2939),
    [anon_sym__Alignof] = ACTIONS(2939),
    [anon_sym_offsetof] = ACTIONS(2942),
    [anon_sym__Generic] = ACTIONS(2945),
    [anon_sym_asm] = ACTIONS(2948),
    [anon_sym___asm__] = ACTIONS(2948),
    [sym_number_literal] = ACTIONS(2951),
    [anon_sym_L_SQUOTE] = ACTIONS(2954),
    [anon_sym_u_SQUOTE] = ACTIONS(2954),
    [anon_sym_U_SQUOTE] = ACTIONS(2954),
    [anon_sym_u8_SQUOTE] = ACTIONS(2954),
    [anon_sym_SQUOTE] = ACTIONS(2954),
    [anon_sym_L_DQUOTE] = ACTIONS(2957),
    [anon_sym_u_DQUOTE] = ACTIONS(2957),
    [anon_sym_U_DQUOTE] = ACTIONS(2957),
    [anon_sym_u8_DQUOTE] = ACTIONS(2957),
    [anon_sym_DQUOTE] = ACTIONS(2957),
    [sym_true] = ACTIONS(2960),
    [sym_false] = ACTIONS(2960),
    [anon_sym_NULL] = ACTIONS(2963),
    [anon_sym_nullptr] = ACTIONS(2963),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2966),
    [anon_sym_template] = ACTIONS(2969),
    [anon_sym_try] = ACTIONS(3043),
    [anon_sym_delete] = ACTIONS(2975),
    [anon_sym_throw] = ACTIONS(3046),
    [anon_sym_co_return] = ACTIONS(3049),
    [anon_sym_co_yield] = ACTIONS(3052),
    [anon_sym_R_DQUOTE] = ACTIONS(2987),
    [anon_sym_LR_DQUOTE] = ACTIONS(2987),
    [anon_sym_uR_DQUOTE] = ACTIONS(2987),
    [anon_sym_UR_DQUOTE] = ACTIONS(2987),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2987),
    [anon_sym_co_await] = ACTIONS(2990),
    [anon_sym_new] = ACTIONS(2993),
    [anon_sym_requires] = ACTIONS(2996),
    [sym_this] = ACTIONS(2960),
  },
  [620] = {
    [sym_attribute_declaration] = STATE(620),
    [sym_compound_statement] = STATE(160),
    [sym_attributed_statement] = STATE(160),
    [sym_statement] = STATE(169),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(620),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_LPAREN2] = ACTIONS(2864),
    [anon_sym_BANG] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2870),
    [anon_sym_PLUS] = ACTIONS(2870),
    [anon_sym_STAR] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_SEMI] = ACTIONS(3058),
    [anon_sym_COLON_COLON] = ACTIONS(2879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2882),
    [anon_sym_LBRACE] = ACTIONS(3061),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [sym_primitive_type] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(3064),
    [anon_sym_switch] = ACTIONS(3067),
    [anon_sym_case] = ACTIONS(3070),
    [anon_sym_default] = ACTIONS(3073),
    [anon_sym_while] = ACTIONS(3076),
    [anon_sym_do] = ACTIONS(3079),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3085),
    [anon_sym_break] = ACTIONS(3088),
    [anon_sym_continue] = ACTIONS(3091),
    [anon_sym_goto] = ACTIONS(3094),
    [anon_sym___try] = ACTIONS(3097),
    [anon_sym___leave] = ACTIONS(3100),
    [anon_sym_not] = ACTIONS(2870),
    [anon_sym_compl] = ACTIONS(2870),
    [anon_sym_DASH_DASH] = ACTIONS(2933),
    [anon_sym_PLUS_PLUS] = ACTIONS(2933),
    [anon_sym_sizeof] = ACTIONS(2936),
    [anon_sym___alignof__] = ACTIONS(2939),
    [anon_sym___alignof] = ACTIONS(2939),
    [anon_sym__alignof] = ACTIONS(2939),
    [anon_sym_alignof] = ACTIONS(2939),
    [anon_sym__Alignof] = ACTIONS(2939),
    [anon_sym_offsetof] = ACTIONS(2942),
    [anon_sym__Generic] = ACTIONS(2945),
    [anon_sym_asm] = ACTIONS(2948),
    [anon_sym___asm__] = ACTIONS(2948),
    [sym_number_literal] = ACTIONS(2951),
    [anon_sym_L_SQUOTE] = ACTIONS(2954),
    [anon_sym_u_SQUOTE] = ACTIONS(2954),
    [anon_sym_U_SQUOTE] = ACTIONS(2954),
    [anon_sym_u8_SQUOTE] = ACTIONS(2954),
    [anon_sym_SQUOTE] = ACTIONS(2954),
    [anon_sym_L_DQUOTE] = ACTIONS(2957),
    [anon_sym_u_DQUOTE] = ACTIONS(2957),
    [anon_sym_U_DQUOTE] = ACTIONS(2957),
    [anon_sym_u8_DQUOTE] = ACTIONS(2957),
    [anon_sym_DQUOTE] = ACTIONS(2957),
    [sym_true] = ACTIONS(2960),
    [sym_false] = ACTIONS(2960),
    [anon_sym_NULL] = ACTIONS(2963),
    [anon_sym_nullptr] = ACTIONS(2963),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2966),
    [anon_sym_template] = ACTIONS(2969),
    [anon_sym_try] = ACTIONS(3103),
    [anon_sym_delete] = ACTIONS(2975),
    [anon_sym_throw] = ACTIONS(3106),
    [anon_sym_co_return] = ACTIONS(3109),
    [anon_sym_co_yield] = ACTIONS(3112),
    [anon_sym_R_DQUOTE] = ACTIONS(2987),
    [anon_sym_LR_DQUOTE] = ACTIONS(2987),
    [anon_sym_uR_DQUOTE] = ACTIONS(2987),
    [anon_sym_UR_DQUOTE] = ACTIONS(2987),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2987),
    [anon_sym_co_await] = ACTIONS(2990),
    [anon_sym_new] = ACTIONS(2993),
    [anon_sym_requires] = ACTIONS(2996),
    [sym_this] = ACTIONS(2960),
  },
  [621] = {
    [sym_attribute_declaration] = STATE(634),
    [sym_compound_statement] = STATE(439),
    [sym_attributed_statement] = STATE(439),
    [sym_statement] = STATE(7625),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(634),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(2849),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(2851),
    [anon_sym_default] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(2857),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(2859),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [622] = {
    [sym_attribute_declaration] = STATE(654),
    [sym_compound_statement] = STATE(351),
    [sym_attributed_statement] = STATE(351),
    [sym_statement] = STATE(371),
    [sym_labeled_statement] = STATE(351),
    [sym_expression_statement] = STATE(351),
    [sym_if_statement] = STATE(351),
    [sym_switch_statement] = STATE(351),
    [sym_case_statement] = STATE(351),
    [sym_while_statement] = STATE(351),
    [sym_do_statement] = STATE(351),
    [sym_for_statement] = STATE(351),
    [sym_return_statement] = STATE(351),
    [sym_break_statement] = STATE(351),
    [sym_continue_statement] = STATE(351),
    [sym_goto_statement] = STATE(351),
    [sym_seh_try_statement] = STATE(351),
    [sym_seh_leave_statement] = STATE(351),
    [sym_expression] = STATE(4855),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8338),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(351),
    [sym_co_return_statement] = STATE(351),
    [sym_co_yield_statement] = STATE(351),
    [sym_throw_statement] = STATE(351),
    [sym_try_statement] = STATE(351),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(654),
    [sym_identifier] = ACTIONS(2841),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(651),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(663),
    [anon_sym_switch] = ACTIONS(665),
    [anon_sym_case] = ACTIONS(667),
    [anon_sym_default] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_do] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(677),
    [anon_sym_break] = ACTIONS(679),
    [anon_sym_continue] = ACTIONS(681),
    [anon_sym_goto] = ACTIONS(683),
    [anon_sym___try] = ACTIONS(685),
    [anon_sym___leave] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(691),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_co_return] = ACTIONS(703),
    [anon_sym_co_yield] = ACTIONS(705),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [623] = {
    [sym_attribute_declaration] = STATE(634),
    [sym_compound_statement] = STATE(439),
    [sym_attributed_statement] = STATE(439),
    [sym_statement] = STATE(368),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(634),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(2849),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(2851),
    [anon_sym_default] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(2857),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(2859),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [624] = {
    [sym_attribute_declaration] = STATE(634),
    [sym_compound_statement] = STATE(439),
    [sym_attributed_statement] = STATE(439),
    [sym_statement] = STATE(365),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(634),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(2849),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(2851),
    [anon_sym_default] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(2857),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(2859),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [625] = {
    [sym_attribute_declaration] = STATE(665),
    [sym_compound_statement] = STATE(876),
    [sym_attributed_statement] = STATE(876),
    [sym_statement] = STATE(836),
    [sym_labeled_statement] = STATE(876),
    [sym_expression_statement] = STATE(876),
    [sym_if_statement] = STATE(876),
    [sym_switch_statement] = STATE(876),
    [sym_case_statement] = STATE(876),
    [sym_while_statement] = STATE(876),
    [sym_do_statement] = STATE(876),
    [sym_for_statement] = STATE(876),
    [sym_return_statement] = STATE(876),
    [sym_break_statement] = STATE(876),
    [sym_continue_statement] = STATE(876),
    [sym_goto_statement] = STATE(876),
    [sym_seh_try_statement] = STATE(876),
    [sym_seh_leave_statement] = STATE(876),
    [sym_expression] = STATE(4739),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8303),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(876),
    [sym_co_return_statement] = STATE(876),
    [sym_co_yield_statement] = STATE(876),
    [sym_throw_statement] = STATE(876),
    [sym_try_statement] = STATE(876),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(665),
    [sym_identifier] = ACTIONS(2999),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1639),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(1647),
    [anon_sym_switch] = ACTIONS(1649),
    [anon_sym_case] = ACTIONS(2851),
    [anon_sym_default] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(1651),
    [anon_sym_do] = ACTIONS(1653),
    [anon_sym_for] = ACTIONS(1655),
    [anon_sym_return] = ACTIONS(1657),
    [anon_sym_break] = ACTIONS(1659),
    [anon_sym_continue] = ACTIONS(1661),
    [anon_sym_goto] = ACTIONS(1663),
    [anon_sym___try] = ACTIONS(1665),
    [anon_sym___leave] = ACTIONS(1667),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(1669),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_co_return] = ACTIONS(1673),
    [anon_sym_co_yield] = ACTIONS(1675),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [626] = {
    [sym_attribute_declaration] = STATE(666),
    [sym_compound_statement] = STATE(160),
    [sym_attributed_statement] = STATE(160),
    [sym_statement] = STATE(161),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [sym_identifier] = ACTIONS(2845),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [627] = {
    [sym_attribute_declaration] = STATE(634),
    [sym_compound_statement] = STATE(439),
    [sym_attributed_statement] = STATE(439),
    [sym_statement] = STATE(364),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(634),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(2849),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(2851),
    [anon_sym_default] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(2857),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(2859),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [628] = {
    [sym_attribute_declaration] = STATE(635),
    [sym_compound_statement] = STATE(439),
    [sym_attributed_statement] = STATE(439),
    [sym_statement] = STATE(315),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [629] = {
    [ts_builtin_sym_end] = ACTIONS(2237),
    [sym_identifier] = ACTIONS(2235),
    [aux_sym_preproc_include_token1] = ACTIONS(2235),
    [aux_sym_preproc_def_token1] = ACTIONS(2235),
    [anon_sym_COMMA] = ACTIONS(2237),
    [aux_sym_preproc_if_token1] = ACTIONS(2235),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2235),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2235),
    [sym_preproc_directive] = ACTIONS(2235),
    [anon_sym_LPAREN2] = ACTIONS(2237),
    [anon_sym_BANG] = ACTIONS(2237),
    [anon_sym_TILDE] = ACTIONS(2237),
    [anon_sym_DASH] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_STAR] = ACTIONS(2237),
    [anon_sym_AMP_AMP] = ACTIONS(2237),
    [anon_sym_AMP] = ACTIONS(2235),
    [anon_sym___extension__] = ACTIONS(2235),
    [anon_sym_typedef] = ACTIONS(2235),
    [anon_sym___device__] = ACTIONS(2235),
    [anon_sym___host__] = ACTIONS(2235),
    [anon_sym___global__] = ACTIONS(2235),
    [anon_sym___forceinline__] = ACTIONS(2235),
    [anon_sym___noinline__] = ACTIONS(2235),
    [anon_sym_extern] = ACTIONS(2235),
    [anon_sym___attribute__] = ACTIONS(2235),
    [anon_sym_COLON_COLON] = ACTIONS(2237),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2237),
    [anon_sym___declspec] = ACTIONS(2235),
    [anon_sym___based] = ACTIONS(2235),
    [anon_sym___cdecl] = ACTIONS(2235),
    [anon_sym___clrcall] = ACTIONS(2235),
    [anon_sym___stdcall] = ACTIONS(2235),
    [anon_sym___fastcall] = ACTIONS(2235),
    [anon_sym___thiscall] = ACTIONS(2235),
    [anon_sym___vectorcall] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2237),
    [anon_sym_RBRACE] = ACTIONS(2237),
    [anon_sym_signed] = ACTIONS(2235),
    [anon_sym_unsigned] = ACTIONS(2235),
    [anon_sym_long] = ACTIONS(2235),
    [anon_sym_short] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_static] = ACTIONS(2235),
    [anon_sym_register] = ACTIONS(2235),
    [anon_sym_inline] = ACTIONS(2235),
    [anon_sym___inline] = ACTIONS(2235),
    [anon_sym___inline__] = ACTIONS(2235),
    [anon_sym___forceinline] = ACTIONS(2235),
    [anon_sym_thread_local] = ACTIONS(2235),
    [anon_sym___thread] = ACTIONS(2235),
    [anon_sym_const] = ACTIONS(2235),
    [anon_sym_constexpr] = ACTIONS(2235),
    [anon_sym_volatile] = ACTIONS(2235),
    [anon_sym_restrict] = ACTIONS(2235),
    [anon_sym___restrict__] = ACTIONS(2235),
    [anon_sym__Atomic] = ACTIONS(2235),
    [anon_sym__Noreturn] = ACTIONS(2235),
    [anon_sym_noreturn] = ACTIONS(2235),
    [anon_sym_mutable] = ACTIONS(2235),
    [anon_sym_constinit] = ACTIONS(2235),
    [anon_sym_consteval] = ACTIONS(2235),
    [anon_sym___shared__] = ACTIONS(2235),
    [anon_sym___local__] = ACTIONS(2235),
    [anon_sym___constant__] = ACTIONS(2235),
    [anon_sym___managed__] = ACTIONS(2235),
    [anon_sym___grid_constant__] = ACTIONS(2235),
    [anon_sym_alignas] = ACTIONS(2235),
    [anon_sym__Alignas] = ACTIONS(2235),
    [sym_primitive_type] = ACTIONS(2235),
    [anon_sym_enum] = ACTIONS(2235),
    [anon_sym_class] = ACTIONS(2235),
    [anon_sym_struct] = ACTIONS(2235),
    [anon_sym_union] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_switch] = ACTIONS(2235),
    [anon_sym_case] = ACTIONS(2235),
    [anon_sym_default] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_for] = ACTIONS(2235),
    [anon_sym_return] = ACTIONS(2235),
    [anon_sym_break] = ACTIONS(2235),
    [anon_sym_continue] = ACTIONS(2235),
    [anon_sym_goto] = ACTIONS(2235),
    [anon_sym_not] = ACTIONS(2235),
    [anon_sym_compl] = ACTIONS(2235),
    [anon_sym_DASH_DASH] = ACTIONS(2237),
    [anon_sym_PLUS_PLUS] = ACTIONS(2237),
    [anon_sym_sizeof] = ACTIONS(2235),
    [anon_sym___alignof__] = ACTIONS(2235),
    [anon_sym___alignof] = ACTIONS(2235),
    [anon_sym__alignof] = ACTIONS(2235),
    [anon_sym_alignof] = ACTIONS(2235),
    [anon_sym__Alignof] = ACTIONS(2235),
    [anon_sym_offsetof] = ACTIONS(2235),
    [anon_sym__Generic] = ACTIONS(2235),
    [anon_sym_asm] = ACTIONS(2235),
    [anon_sym___asm__] = ACTIONS(2235),
    [sym_number_literal] = ACTIONS(2237),
    [anon_sym_L_SQUOTE] = ACTIONS(2237),
    [anon_sym_u_SQUOTE] = ACTIONS(2237),
    [anon_sym_U_SQUOTE] = ACTIONS(2237),
    [anon_sym_u8_SQUOTE] = ACTIONS(2237),
    [anon_sym_SQUOTE] = ACTIONS(2237),
    [anon_sym_L_DQUOTE] = ACTIONS(2237),
    [anon_sym_u_DQUOTE] = ACTIONS(2237),
    [anon_sym_U_DQUOTE] = ACTIONS(2237),
    [anon_sym_u8_DQUOTE] = ACTIONS(2237),
    [anon_sym_DQUOTE] = ACTIONS(2237),
    [sym_true] = ACTIONS(2235),
    [sym_false] = ACTIONS(2235),
    [anon_sym_NULL] = ACTIONS(2235),
    [anon_sym_nullptr] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2235),
    [anon_sym_decltype] = ACTIONS(2235),
    [sym_virtual] = ACTIONS(2235),
    [anon_sym_explicit] = ACTIONS(2235),
    [anon_sym_typename] = ACTIONS(2235),
    [anon_sym_template] = ACTIONS(2235),
    [anon_sym_operator] = ACTIONS(2235),
    [anon_sym_try] = ACTIONS(2235),
    [anon_sym_delete] = ACTIONS(2235),
    [anon_sym_throw] = ACTIONS(2235),
    [anon_sym_namespace] = ACTIONS(2235),
    [anon_sym_using] = ACTIONS(2235),
    [anon_sym_static_assert] = ACTIONS(2235),
    [anon_sym_concept] = ACTIONS(2235),
    [anon_sym_co_return] = ACTIONS(2235),
    [anon_sym_co_yield] = ACTIONS(2235),
    [anon_sym_R_DQUOTE] = ACTIONS(2237),
    [anon_sym_LR_DQUOTE] = ACTIONS(2237),
    [anon_sym_uR_DQUOTE] = ACTIONS(2237),
    [anon_sym_UR_DQUOTE] = ACTIONS(2237),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2237),
    [anon_sym_co_await] = ACTIONS(2235),
    [anon_sym_new] = ACTIONS(2235),
    [anon_sym_requires] = ACTIONS(2235),
    [sym_this] = ACTIONS(2235),
    [anon_sym___launch_bounds__] = ACTIONS(2235),
  },
  [630] = {
    [sym_attribute_declaration] = STATE(666),
    [sym_compound_statement] = STATE(160),
    [sym_attributed_statement] = STATE(160),
    [sym_statement] = STATE(179),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [sym_identifier] = ACTIONS(2845),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [631] = {
    [sym_attribute_declaration] = STATE(606),
    [sym_compound_statement] = STATE(423),
    [sym_attributed_statement] = STATE(423),
    [sym_statement] = STATE(382),
    [sym_labeled_statement] = STATE(423),
    [sym_expression_statement] = STATE(423),
    [sym_if_statement] = STATE(423),
    [sym_switch_statement] = STATE(423),
    [sym_case_statement] = STATE(423),
    [sym_while_statement] = STATE(423),
    [sym_do_statement] = STATE(423),
    [sym_for_statement] = STATE(423),
    [sym_return_statement] = STATE(423),
    [sym_break_statement] = STATE(423),
    [sym_continue_statement] = STATE(423),
    [sym_goto_statement] = STATE(423),
    [sym_seh_try_statement] = STATE(423),
    [sym_seh_leave_statement] = STATE(423),
    [sym_expression] = STATE(4913),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8497),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(423),
    [sym_co_return_statement] = STATE(423),
    [sym_co_yield_statement] = STATE(423),
    [sym_throw_statement] = STATE(423),
    [sym_try_statement] = STATE(423),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(606),
    [sym_identifier] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1571),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(81),
    [anon_sym_default] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(1573),
    [anon_sym___leave] = ACTIONS(1575),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [632] = {
    [sym_attribute_declaration] = STATE(666),
    [sym_compound_statement] = STATE(160),
    [sym_attributed_statement] = STATE(160),
    [sym_statement] = STATE(139),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [sym_identifier] = ACTIONS(2845),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [633] = {
    [sym_attribute_declaration] = STATE(633),
    [sym_compound_statement] = STATE(876),
    [sym_attributed_statement] = STATE(876),
    [sym_statement] = STATE(877),
    [sym_labeled_statement] = STATE(876),
    [sym_expression_statement] = STATE(876),
    [sym_if_statement] = STATE(876),
    [sym_switch_statement] = STATE(876),
    [sym_case_statement] = STATE(876),
    [sym_while_statement] = STATE(876),
    [sym_do_statement] = STATE(876),
    [sym_for_statement] = STATE(876),
    [sym_return_statement] = STATE(876),
    [sym_break_statement] = STATE(876),
    [sym_continue_statement] = STATE(876),
    [sym_goto_statement] = STATE(876),
    [sym_seh_try_statement] = STATE(876),
    [sym_seh_leave_statement] = STATE(876),
    [sym_expression] = STATE(4739),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8303),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(876),
    [sym_co_return_statement] = STATE(876),
    [sym_co_yield_statement] = STATE(876),
    [sym_throw_statement] = STATE(876),
    [sym_try_statement] = STATE(876),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(633),
    [sym_identifier] = ACTIONS(3115),
    [anon_sym_LPAREN2] = ACTIONS(2864),
    [anon_sym_BANG] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2870),
    [anon_sym_PLUS] = ACTIONS(2870),
    [anon_sym_STAR] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_SEMI] = ACTIONS(3118),
    [anon_sym_COLON_COLON] = ACTIONS(2879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2882),
    [anon_sym_LBRACE] = ACTIONS(3121),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [sym_primitive_type] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(3124),
    [anon_sym_switch] = ACTIONS(3127),
    [anon_sym_case] = ACTIONS(3013),
    [anon_sym_default] = ACTIONS(3016),
    [anon_sym_while] = ACTIONS(3130),
    [anon_sym_do] = ACTIONS(3133),
    [anon_sym_for] = ACTIONS(3136),
    [anon_sym_return] = ACTIONS(3139),
    [anon_sym_break] = ACTIONS(3142),
    [anon_sym_continue] = ACTIONS(3145),
    [anon_sym_goto] = ACTIONS(3148),
    [anon_sym___try] = ACTIONS(3151),
    [anon_sym___leave] = ACTIONS(3154),
    [anon_sym_not] = ACTIONS(2870),
    [anon_sym_compl] = ACTIONS(2870),
    [anon_sym_DASH_DASH] = ACTIONS(2933),
    [anon_sym_PLUS_PLUS] = ACTIONS(2933),
    [anon_sym_sizeof] = ACTIONS(2936),
    [anon_sym___alignof__] = ACTIONS(2939),
    [anon_sym___alignof] = ACTIONS(2939),
    [anon_sym__alignof] = ACTIONS(2939),
    [anon_sym_alignof] = ACTIONS(2939),
    [anon_sym__Alignof] = ACTIONS(2939),
    [anon_sym_offsetof] = ACTIONS(2942),
    [anon_sym__Generic] = ACTIONS(2945),
    [anon_sym_asm] = ACTIONS(2948),
    [anon_sym___asm__] = ACTIONS(2948),
    [sym_number_literal] = ACTIONS(2951),
    [anon_sym_L_SQUOTE] = ACTIONS(2954),
    [anon_sym_u_SQUOTE] = ACTIONS(2954),
    [anon_sym_U_SQUOTE] = ACTIONS(2954),
    [anon_sym_u8_SQUOTE] = ACTIONS(2954),
    [anon_sym_SQUOTE] = ACTIONS(2954),
    [anon_sym_L_DQUOTE] = ACTIONS(2957),
    [anon_sym_u_DQUOTE] = ACTIONS(2957),
    [anon_sym_U_DQUOTE] = ACTIONS(2957),
    [anon_sym_u8_DQUOTE] = ACTIONS(2957),
    [anon_sym_DQUOTE] = ACTIONS(2957),
    [sym_true] = ACTIONS(2960),
    [sym_false] = ACTIONS(2960),
    [anon_sym_NULL] = ACTIONS(2963),
    [anon_sym_nullptr] = ACTIONS(2963),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2966),
    [anon_sym_template] = ACTIONS(2969),
    [anon_sym_try] = ACTIONS(3157),
    [anon_sym_delete] = ACTIONS(2975),
    [anon_sym_throw] = ACTIONS(3160),
    [anon_sym_co_return] = ACTIONS(3163),
    [anon_sym_co_yield] = ACTIONS(3166),
    [anon_sym_R_DQUOTE] = ACTIONS(2987),
    [anon_sym_LR_DQUOTE] = ACTIONS(2987),
    [anon_sym_uR_DQUOTE] = ACTIONS(2987),
    [anon_sym_UR_DQUOTE] = ACTIONS(2987),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2987),
    [anon_sym_co_await] = ACTIONS(2990),
    [anon_sym_new] = ACTIONS(2993),
    [anon_sym_requires] = ACTIONS(2996),
    [sym_this] = ACTIONS(2960),
  },
  [634] = {
    [sym_attribute_declaration] = STATE(619),
    [sym_compound_statement] = STATE(439),
    [sym_attributed_statement] = STATE(439),
    [sym_statement] = STATE(380),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(619),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(2849),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(2851),
    [anon_sym_default] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(2857),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(2859),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [635] = {
    [sym_attribute_declaration] = STATE(613),
    [sym_compound_statement] = STATE(439),
    [sym_attributed_statement] = STATE(439),
    [sym_statement] = STATE(379),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(613),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [636] = {
    [sym_attribute_declaration] = STATE(634),
    [sym_compound_statement] = STATE(439),
    [sym_attributed_statement] = STATE(439),
    [sym_statement] = STATE(8627),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(634),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(2849),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(2851),
    [anon_sym_default] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(2857),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(2859),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [637] = {
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_unaligned_ptr_modifier] = STATE(4253),
    [sym_ms_pointer_modifier] = STATE(2783),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6598),
    [sym_array_declarator] = STATE(6598),
    [sym_type_qualifier] = STATE(3611),
    [sym_alignas_qualifier] = STATE(4511),
    [sym_expression] = STATE(3094),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3575),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5981),
    [sym_qualified_identifier] = STATE(3569),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [aux_sym__type_definition_type_repeat1] = STATE(3611),
    [aux_sym_pointer_declarator_repeat1] = STATE(2783),
    [sym_identifier] = ACTIONS(3169),
    [anon_sym_LPAREN2] = ACTIONS(1825),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1829),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1833),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym___extension__] = ACTIONS(3171),
    [anon_sym___global__] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym___based] = ACTIONS(49),
    [sym_ms_restrict_modifier] = ACTIONS(3173),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3173),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3173),
    [anon_sym__unaligned] = ACTIONS(3175),
    [anon_sym___unaligned] = ACTIONS(3175),
    [anon_sym_LBRACK] = ACTIONS(1843),
    [anon_sym_const] = ACTIONS(3171),
    [anon_sym_constexpr] = ACTIONS(3171),
    [anon_sym_volatile] = ACTIONS(3171),
    [anon_sym_restrict] = ACTIONS(3171),
    [anon_sym___restrict__] = ACTIONS(3171),
    [anon_sym__Atomic] = ACTIONS(3171),
    [anon_sym__Noreturn] = ACTIONS(3171),
    [anon_sym_noreturn] = ACTIONS(3171),
    [anon_sym_mutable] = ACTIONS(3171),
    [anon_sym_constinit] = ACTIONS(3171),
    [anon_sym_consteval] = ACTIONS(3171),
    [anon_sym___shared__] = ACTIONS(3171),
    [anon_sym___local__] = ACTIONS(3171),
    [anon_sym___constant__] = ACTIONS(3171),
    [anon_sym___managed__] = ACTIONS(3171),
    [anon_sym___grid_constant__] = ACTIONS(3171),
    [anon_sym_alignas] = ACTIONS(3177),
    [anon_sym__Alignas] = ACTIONS(3177),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [638] = {
    [sym_expression] = STATE(3268),
    [sym__string] = STATE(3860),
    [sym_conditional_expression] = STATE(3860),
    [sym_assignment_expression] = STATE(3860),
    [sym_pointer_expression] = STATE(3861),
    [sym_unary_expression] = STATE(3860),
    [sym_binary_expression] = STATE(3860),
    [sym_update_expression] = STATE(3860),
    [sym_cast_expression] = STATE(3860),
    [sym_sizeof_expression] = STATE(3860),
    [sym_alignof_expression] = STATE(3860),
    [sym_offsetof_expression] = STATE(3860),
    [sym_generic_expression] = STATE(3860),
    [sym_subscript_expression] = STATE(3861),
    [sym_call_expression] = STATE(3861),
    [sym_gnu_asm_expression] = STATE(3860),
    [sym_field_expression] = STATE(3861),
    [sym_compound_literal_expression] = STATE(3860),
    [sym_parenthesized_expression] = STATE(3861),
    [sym_initializer_list] = STATE(3969),
    [sym_char_literal] = STATE(3831),
    [sym_concatenated_string] = STATE(3833),
    [sym_string_literal] = STATE(2490),
    [sym_null] = STATE(3860),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7980),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3860),
    [sym_raw_string_literal] = STATE(2516),
    [sym_co_await_expression] = STATE(3860),
    [sym_new_expression] = STATE(3860),
    [sym_delete_expression] = STATE(3860),
    [sym_requires_clause] = STATE(3860),
    [sym_requires_expression] = STATE(3860),
    [sym_lambda_expression] = STATE(3860),
    [sym_lambda_capture_specifier] = STATE(6189),
    [sym_fold_expression] = STATE(3860),
    [sym_parameter_pack_expansion] = STATE(3860),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3861),
    [sym_qualified_type_identifier] = STATE(7980),
    [sym_user_defined_literal] = STATE(3861),
    [sym_kernel_call_expression] = STATE(3851),
    [sym_identifier] = ACTIONS(3179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_BANG] = ACTIONS(3181),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2508),
    [anon_sym_STAR] = ACTIONS(2508),
    [anon_sym_SLASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_PIPE] = ACTIONS(2508),
    [anon_sym_CARET] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_EQ_EQ] = ACTIONS(2510),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_GT] = ACTIONS(2508),
    [anon_sym_GT_EQ] = ACTIONS(2510),
    [anon_sym_LT_EQ] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_LT_LT] = ACTIONS(2508),
    [anon_sym_GT_GT] = ACTIONS(2508),
    [anon_sym_COLON_COLON] = ACTIONS(3185),
    [anon_sym_LBRACE] = ACTIONS(3187),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_EQ] = ACTIONS(2508),
    [sym_primitive_type] = ACTIONS(3189),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_STAR_EQ] = ACTIONS(2510),
    [anon_sym_SLASH_EQ] = ACTIONS(2510),
    [anon_sym_PERCENT_EQ] = ACTIONS(2510),
    [anon_sym_PLUS_EQ] = ACTIONS(2510),
    [anon_sym_DASH_EQ] = ACTIONS(2510),
    [anon_sym_LT_LT_EQ] = ACTIONS(2510),
    [anon_sym_GT_GT_EQ] = ACTIONS(2510),
    [anon_sym_AMP_EQ] = ACTIONS(2510),
    [anon_sym_CARET_EQ] = ACTIONS(2510),
    [anon_sym_PIPE_EQ] = ACTIONS(2510),
    [anon_sym_and_eq] = ACTIONS(2508),
    [anon_sym_or_eq] = ACTIONS(2508),
    [anon_sym_xor_eq] = ACTIONS(2508),
    [anon_sym_not] = ACTIONS(3181),
    [anon_sym_compl] = ACTIONS(3181),
    [anon_sym_LT_EQ_GT] = ACTIONS(2510),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_bitor] = ACTIONS(2508),
    [anon_sym_xor] = ACTIONS(2508),
    [anon_sym_bitand] = ACTIONS(2508),
    [anon_sym_not_eq] = ACTIONS(2508),
    [anon_sym_DASH_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_PLUS] = ACTIONS(2510),
    [anon_sym_sizeof] = ACTIONS(3191),
    [anon_sym___alignof__] = ACTIONS(3193),
    [anon_sym___alignof] = ACTIONS(3193),
    [anon_sym__alignof] = ACTIONS(3193),
    [anon_sym_alignof] = ACTIONS(3193),
    [anon_sym__Alignof] = ACTIONS(3193),
    [anon_sym_offsetof] = ACTIONS(3195),
    [anon_sym__Generic] = ACTIONS(3197),
    [anon_sym_asm] = ACTIONS(3199),
    [anon_sym___asm__] = ACTIONS(3199),
    [anon_sym_DOT] = ACTIONS(2508),
    [anon_sym_DOT_STAR] = ACTIONS(2510),
    [anon_sym_DASH_GT] = ACTIONS(2510),
    [sym_number_literal] = ACTIONS(3201),
    [anon_sym_L_SQUOTE] = ACTIONS(3203),
    [anon_sym_u_SQUOTE] = ACTIONS(3203),
    [anon_sym_U_SQUOTE] = ACTIONS(3203),
    [anon_sym_u8_SQUOTE] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [anon_sym_L_DQUOTE] = ACTIONS(3205),
    [anon_sym_u_DQUOTE] = ACTIONS(3205),
    [anon_sym_U_DQUOTE] = ACTIONS(3205),
    [anon_sym_u8_DQUOTE] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [anon_sym_NULL] = ACTIONS(3209),
    [anon_sym_nullptr] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_R_DQUOTE] = ACTIONS(3213),
    [anon_sym_LR_DQUOTE] = ACTIONS(3213),
    [anon_sym_uR_DQUOTE] = ACTIONS(3213),
    [anon_sym_UR_DQUOTE] = ACTIONS(3213),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3213),
    [anon_sym_co_await] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_requires] = ACTIONS(3219),
    [sym_this] = ACTIONS(3207),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(2510),
    [aux_sym_kernel_call_syntax_token2] = ACTIONS(2510),
  },
  [639] = {
    [sym_attribute_declaration] = STATE(635),
    [sym_compound_statement] = STATE(439),
    [sym_attributed_statement] = STATE(439),
    [sym_statement] = STATE(428),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [640] = {
    [sym_attribute_declaration] = STATE(622),
    [sym_compound_statement] = STATE(351),
    [sym_attributed_statement] = STATE(351),
    [sym_statement] = STATE(318),
    [sym_labeled_statement] = STATE(351),
    [sym_expression_statement] = STATE(351),
    [sym_if_statement] = STATE(351),
    [sym_switch_statement] = STATE(351),
    [sym_case_statement] = STATE(351),
    [sym_while_statement] = STATE(351),
    [sym_do_statement] = STATE(351),
    [sym_for_statement] = STATE(351),
    [sym_return_statement] = STATE(351),
    [sym_break_statement] = STATE(351),
    [sym_continue_statement] = STATE(351),
    [sym_goto_statement] = STATE(351),
    [sym_seh_try_statement] = STATE(351),
    [sym_seh_leave_statement] = STATE(351),
    [sym_expression] = STATE(4855),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8338),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(351),
    [sym_co_return_statement] = STATE(351),
    [sym_co_yield_statement] = STATE(351),
    [sym_throw_statement] = STATE(351),
    [sym_try_statement] = STATE(351),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(622),
    [sym_identifier] = ACTIONS(2841),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(651),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(663),
    [anon_sym_switch] = ACTIONS(665),
    [anon_sym_case] = ACTIONS(667),
    [anon_sym_default] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_do] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(677),
    [anon_sym_break] = ACTIONS(679),
    [anon_sym_continue] = ACTIONS(681),
    [anon_sym_goto] = ACTIONS(683),
    [anon_sym___try] = ACTIONS(685),
    [anon_sym___leave] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(691),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_co_return] = ACTIONS(703),
    [anon_sym_co_yield] = ACTIONS(705),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [641] = {
    [sym_attribute_declaration] = STATE(666),
    [sym_compound_statement] = STATE(160),
    [sym_attributed_statement] = STATE(160),
    [sym_statement] = STATE(170),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [sym_identifier] = ACTIONS(2845),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [642] = {
    [sym_attribute_declaration] = STATE(666),
    [sym_compound_statement] = STATE(160),
    [sym_attributed_statement] = STATE(160),
    [sym_statement] = STATE(173),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(666),
    [sym_identifier] = ACTIONS(2845),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [643] = {
    [sym_attribute_declaration] = STATE(665),
    [sym_compound_statement] = STATE(876),
    [sym_attributed_statement] = STATE(876),
    [sym_statement] = STATE(863),
    [sym_labeled_statement] = STATE(876),
    [sym_expression_statement] = STATE(876),
    [sym_if_statement] = STATE(876),
    [sym_switch_statement] = STATE(876),
    [sym_case_statement] = STATE(876),
    [sym_while_statement] = STATE(876),
    [sym_do_statement] = STATE(876),
    [sym_for_statement] = STATE(876),
    [sym_return_statement] = STATE(876),
    [sym_break_statement] = STATE(876),
    [sym_continue_statement] = STATE(876),
    [sym_goto_statement] = STATE(876),
    [sym_seh_try_statement] = STATE(876),
    [sym_seh_leave_statement] = STATE(876),
    [sym_expression] = STATE(4739),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8303),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(876),
    [sym_co_return_statement] = STATE(876),
    [sym_co_yield_statement] = STATE(876),
    [sym_throw_statement] = STATE(876),
    [sym_try_statement] = STATE(876),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(665),
    [sym_identifier] = ACTIONS(2999),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1639),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(1647),
    [anon_sym_switch] = ACTIONS(1649),
    [anon_sym_case] = ACTIONS(2851),
    [anon_sym_default] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(1651),
    [anon_sym_do] = ACTIONS(1653),
    [anon_sym_for] = ACTIONS(1655),
    [anon_sym_return] = ACTIONS(1657),
    [anon_sym_break] = ACTIONS(1659),
    [anon_sym_continue] = ACTIONS(1661),
    [anon_sym_goto] = ACTIONS(1663),
    [anon_sym___try] = ACTIONS(1665),
    [anon_sym___leave] = ACTIONS(1667),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(1669),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_co_return] = ACTIONS(1673),
    [anon_sym_co_yield] = ACTIONS(1675),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [644] = {
    [sym_attribute_declaration] = STATE(622),
    [sym_compound_statement] = STATE(351),
    [sym_attributed_statement] = STATE(351),
    [sym_statement] = STATE(392),
    [sym_labeled_statement] = STATE(351),
    [sym_expression_statement] = STATE(351),
    [sym_if_statement] = STATE(351),
    [sym_switch_statement] = STATE(351),
    [sym_case_statement] = STATE(351),
    [sym_while_statement] = STATE(351),
    [sym_do_statement] = STATE(351),
    [sym_for_statement] = STATE(351),
    [sym_return_statement] = STATE(351),
    [sym_break_statement] = STATE(351),
    [sym_continue_statement] = STATE(351),
    [sym_goto_statement] = STATE(351),
    [sym_seh_try_statement] = STATE(351),
    [sym_seh_leave_statement] = STATE(351),
    [sym_expression] = STATE(4855),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8338),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(351),
    [sym_co_return_statement] = STATE(351),
    [sym_co_yield_statement] = STATE(351),
    [sym_throw_statement] = STATE(351),
    [sym_try_statement] = STATE(351),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(622),
    [sym_identifier] = ACTIONS(2841),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(651),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(663),
    [anon_sym_switch] = ACTIONS(665),
    [anon_sym_case] = ACTIONS(667),
    [anon_sym_default] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_do] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(677),
    [anon_sym_break] = ACTIONS(679),
    [anon_sym_continue] = ACTIONS(681),
    [anon_sym_goto] = ACTIONS(683),
    [anon_sym___try] = ACTIONS(685),
    [anon_sym___leave] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(691),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_co_return] = ACTIONS(703),
    [anon_sym_co_yield] = ACTIONS(705),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [645] = {
    [sym_attribute_declaration] = STATE(665),
    [sym_compound_statement] = STATE(876),
    [sym_attributed_statement] = STATE(876),
    [sym_statement] = STATE(855),
    [sym_labeled_statement] = STATE(876),
    [sym_expression_statement] = STATE(876),
    [sym_if_statement] = STATE(876),
    [sym_switch_statement] = STATE(876),
    [sym_case_statement] = STATE(876),
    [sym_while_statement] = STATE(876),
    [sym_do_statement] = STATE(876),
    [sym_for_statement] = STATE(876),
    [sym_return_statement] = STATE(876),
    [sym_break_statement] = STATE(876),
    [sym_continue_statement] = STATE(876),
    [sym_goto_statement] = STATE(876),
    [sym_seh_try_statement] = STATE(876),
    [sym_seh_leave_statement] = STATE(876),
    [sym_expression] = STATE(4739),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8303),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(876),
    [sym_co_return_statement] = STATE(876),
    [sym_co_yield_statement] = STATE(876),
    [sym_throw_statement] = STATE(876),
    [sym_try_statement] = STATE(876),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(665),
    [sym_identifier] = ACTIONS(2999),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1639),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(1647),
    [anon_sym_switch] = ACTIONS(1649),
    [anon_sym_case] = ACTIONS(2851),
    [anon_sym_default] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(1651),
    [anon_sym_do] = ACTIONS(1653),
    [anon_sym_for] = ACTIONS(1655),
    [anon_sym_return] = ACTIONS(1657),
    [anon_sym_break] = ACTIONS(1659),
    [anon_sym_continue] = ACTIONS(1661),
    [anon_sym_goto] = ACTIONS(1663),
    [anon_sym___try] = ACTIONS(1665),
    [anon_sym___leave] = ACTIONS(1667),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(1669),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_co_return] = ACTIONS(1673),
    [anon_sym_co_yield] = ACTIONS(1675),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [646] = {
    [sym_attribute_declaration] = STATE(606),
    [sym_compound_statement] = STATE(423),
    [sym_attributed_statement] = STATE(423),
    [sym_statement] = STATE(365),
    [sym_labeled_statement] = STATE(423),
    [sym_expression_statement] = STATE(423),
    [sym_if_statement] = STATE(423),
    [sym_switch_statement] = STATE(423),
    [sym_case_statement] = STATE(423),
    [sym_while_statement] = STATE(423),
    [sym_do_statement] = STATE(423),
    [sym_for_statement] = STATE(423),
    [sym_return_statement] = STATE(423),
    [sym_break_statement] = STATE(423),
    [sym_continue_statement] = STATE(423),
    [sym_goto_statement] = STATE(423),
    [sym_seh_try_statement] = STATE(423),
    [sym_seh_leave_statement] = STATE(423),
    [sym_expression] = STATE(4913),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8497),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(423),
    [sym_co_return_statement] = STATE(423),
    [sym_co_yield_statement] = STATE(423),
    [sym_throw_statement] = STATE(423),
    [sym_try_statement] = STATE(423),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(606),
    [sym_identifier] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1571),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(81),
    [anon_sym_default] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(1573),
    [anon_sym___leave] = ACTIONS(1575),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [647] = {
    [sym_attribute_declaration] = STATE(606),
    [sym_compound_statement] = STATE(423),
    [sym_attributed_statement] = STATE(423),
    [sym_statement] = STATE(364),
    [sym_labeled_statement] = STATE(423),
    [sym_expression_statement] = STATE(423),
    [sym_if_statement] = STATE(423),
    [sym_switch_statement] = STATE(423),
    [sym_case_statement] = STATE(423),
    [sym_while_statement] = STATE(423),
    [sym_do_statement] = STATE(423),
    [sym_for_statement] = STATE(423),
    [sym_return_statement] = STATE(423),
    [sym_break_statement] = STATE(423),
    [sym_continue_statement] = STATE(423),
    [sym_goto_statement] = STATE(423),
    [sym_seh_try_statement] = STATE(423),
    [sym_seh_leave_statement] = STATE(423),
    [sym_expression] = STATE(4913),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8497),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(423),
    [sym_co_return_statement] = STATE(423),
    [sym_co_yield_statement] = STATE(423),
    [sym_throw_statement] = STATE(423),
    [sym_try_statement] = STATE(423),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(606),
    [sym_identifier] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1571),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(81),
    [anon_sym_default] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(1573),
    [anon_sym___leave] = ACTIONS(1575),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [648] = {
    [sym_attribute_declaration] = STATE(635),
    [sym_compound_statement] = STATE(439),
    [sym_attributed_statement] = STATE(439),
    [sym_statement] = STATE(377),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [649] = {
    [sym_attribute_declaration] = STATE(634),
    [sym_compound_statement] = STATE(439),
    [sym_attributed_statement] = STATE(439),
    [sym_statement] = STATE(8819),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(634),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(2849),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(2851),
    [anon_sym_default] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(2857),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(2859),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [650] = {
    [sym_type_qualifier] = STATE(3531),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4591),
    [sym_sized_type_specifier] = STATE(2599),
    [sym_enum_specifier] = STATE(2599),
    [sym_struct_specifier] = STATE(2599),
    [sym_union_specifier] = STATE(2599),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_type_descriptor] = STATE(7574),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_placeholder_type_specifier] = STATE(2599),
    [sym_decltype_auto] = STATE(2598),
    [sym_decltype] = STATE(2477),
    [sym_class_specifier] = STATE(2599),
    [sym__class_name] = STATE(8015),
    [sym_dependent_type] = STATE(2599),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_type_parameter_pack_expansion] = STATE(8003),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5910),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [aux_sym__type_definition_type_repeat1] = STATE(3531),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2157),
    [sym_identifier] = ACTIONS(2711),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2725),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2729),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2733),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2757),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2761),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [651] = {
    [sym_attribute_declaration] = STATE(665),
    [sym_compound_statement] = STATE(876),
    [sym_attributed_statement] = STATE(876),
    [sym_statement] = STATE(861),
    [sym_labeled_statement] = STATE(876),
    [sym_expression_statement] = STATE(876),
    [sym_if_statement] = STATE(876),
    [sym_switch_statement] = STATE(876),
    [sym_case_statement] = STATE(876),
    [sym_while_statement] = STATE(876),
    [sym_do_statement] = STATE(876),
    [sym_for_statement] = STATE(876),
    [sym_return_statement] = STATE(876),
    [sym_break_statement] = STATE(876),
    [sym_continue_statement] = STATE(876),
    [sym_goto_statement] = STATE(876),
    [sym_seh_try_statement] = STATE(876),
    [sym_seh_leave_statement] = STATE(876),
    [sym_expression] = STATE(4739),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8303),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(876),
    [sym_co_return_statement] = STATE(876),
    [sym_co_yield_statement] = STATE(876),
    [sym_throw_statement] = STATE(876),
    [sym_try_statement] = STATE(876),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(665),
    [sym_identifier] = ACTIONS(2999),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1639),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(1647),
    [anon_sym_switch] = ACTIONS(1649),
    [anon_sym_case] = ACTIONS(2851),
    [anon_sym_default] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(1651),
    [anon_sym_do] = ACTIONS(1653),
    [anon_sym_for] = ACTIONS(1655),
    [anon_sym_return] = ACTIONS(1657),
    [anon_sym_break] = ACTIONS(1659),
    [anon_sym_continue] = ACTIONS(1661),
    [anon_sym_goto] = ACTIONS(1663),
    [anon_sym___try] = ACTIONS(1665),
    [anon_sym___leave] = ACTIONS(1667),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(1669),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_co_return] = ACTIONS(1673),
    [anon_sym_co_yield] = ACTIONS(1675),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [652] = {
    [sym_attribute_declaration] = STATE(665),
    [sym_compound_statement] = STATE(876),
    [sym_attributed_statement] = STATE(876),
    [sym_statement] = STATE(820),
    [sym_labeled_statement] = STATE(876),
    [sym_expression_statement] = STATE(876),
    [sym_if_statement] = STATE(876),
    [sym_switch_statement] = STATE(876),
    [sym_case_statement] = STATE(876),
    [sym_while_statement] = STATE(876),
    [sym_do_statement] = STATE(876),
    [sym_for_statement] = STATE(876),
    [sym_return_statement] = STATE(876),
    [sym_break_statement] = STATE(876),
    [sym_continue_statement] = STATE(876),
    [sym_goto_statement] = STATE(876),
    [sym_seh_try_statement] = STATE(876),
    [sym_seh_leave_statement] = STATE(876),
    [sym_expression] = STATE(4739),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8303),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(876),
    [sym_co_return_statement] = STATE(876),
    [sym_co_yield_statement] = STATE(876),
    [sym_throw_statement] = STATE(876),
    [sym_try_statement] = STATE(876),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(665),
    [sym_identifier] = ACTIONS(2999),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1639),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(1647),
    [anon_sym_switch] = ACTIONS(1649),
    [anon_sym_case] = ACTIONS(2851),
    [anon_sym_default] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(1651),
    [anon_sym_do] = ACTIONS(1653),
    [anon_sym_for] = ACTIONS(1655),
    [anon_sym_return] = ACTIONS(1657),
    [anon_sym_break] = ACTIONS(1659),
    [anon_sym_continue] = ACTIONS(1661),
    [anon_sym_goto] = ACTIONS(1663),
    [anon_sym___try] = ACTIONS(1665),
    [anon_sym___leave] = ACTIONS(1667),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(1669),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_co_return] = ACTIONS(1673),
    [anon_sym_co_yield] = ACTIONS(1675),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [653] = {
    [sym_attribute_declaration] = STATE(634),
    [sym_compound_statement] = STATE(439),
    [sym_attributed_statement] = STATE(439),
    [sym_statement] = STATE(8849),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(634),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(2849),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(2851),
    [anon_sym_default] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(2857),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(2859),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [654] = {
    [sym_attribute_declaration] = STATE(654),
    [sym_compound_statement] = STATE(351),
    [sym_attributed_statement] = STATE(351),
    [sym_statement] = STATE(371),
    [sym_labeled_statement] = STATE(351),
    [sym_expression_statement] = STATE(351),
    [sym_if_statement] = STATE(351),
    [sym_switch_statement] = STATE(351),
    [sym_case_statement] = STATE(351),
    [sym_while_statement] = STATE(351),
    [sym_do_statement] = STATE(351),
    [sym_for_statement] = STATE(351),
    [sym_return_statement] = STATE(351),
    [sym_break_statement] = STATE(351),
    [sym_continue_statement] = STATE(351),
    [sym_goto_statement] = STATE(351),
    [sym_seh_try_statement] = STATE(351),
    [sym_seh_leave_statement] = STATE(351),
    [sym_expression] = STATE(4855),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8338),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(351),
    [sym_co_return_statement] = STATE(351),
    [sym_co_yield_statement] = STATE(351),
    [sym_throw_statement] = STATE(351),
    [sym_try_statement] = STATE(351),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(654),
    [sym_identifier] = ACTIONS(3221),
    [anon_sym_LPAREN2] = ACTIONS(2864),
    [anon_sym_BANG] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2870),
    [anon_sym_PLUS] = ACTIONS(2870),
    [anon_sym_STAR] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_SEMI] = ACTIONS(3224),
    [anon_sym_COLON_COLON] = ACTIONS(2879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2882),
    [anon_sym_LBRACE] = ACTIONS(3227),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [sym_primitive_type] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(3230),
    [anon_sym_switch] = ACTIONS(3233),
    [anon_sym_case] = ACTIONS(3236),
    [anon_sym_default] = ACTIONS(3239),
    [anon_sym_while] = ACTIONS(3242),
    [anon_sym_do] = ACTIONS(3245),
    [anon_sym_for] = ACTIONS(3248),
    [anon_sym_return] = ACTIONS(3251),
    [anon_sym_break] = ACTIONS(3254),
    [anon_sym_continue] = ACTIONS(3257),
    [anon_sym_goto] = ACTIONS(3260),
    [anon_sym___try] = ACTIONS(3263),
    [anon_sym___leave] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(2870),
    [anon_sym_compl] = ACTIONS(2870),
    [anon_sym_DASH_DASH] = ACTIONS(2933),
    [anon_sym_PLUS_PLUS] = ACTIONS(2933),
    [anon_sym_sizeof] = ACTIONS(2936),
    [anon_sym___alignof__] = ACTIONS(2939),
    [anon_sym___alignof] = ACTIONS(2939),
    [anon_sym__alignof] = ACTIONS(2939),
    [anon_sym_alignof] = ACTIONS(2939),
    [anon_sym__Alignof] = ACTIONS(2939),
    [anon_sym_offsetof] = ACTIONS(2942),
    [anon_sym__Generic] = ACTIONS(2945),
    [anon_sym_asm] = ACTIONS(2948),
    [anon_sym___asm__] = ACTIONS(2948),
    [sym_number_literal] = ACTIONS(2951),
    [anon_sym_L_SQUOTE] = ACTIONS(2954),
    [anon_sym_u_SQUOTE] = ACTIONS(2954),
    [anon_sym_U_SQUOTE] = ACTIONS(2954),
    [anon_sym_u8_SQUOTE] = ACTIONS(2954),
    [anon_sym_SQUOTE] = ACTIONS(2954),
    [anon_sym_L_DQUOTE] = ACTIONS(2957),
    [anon_sym_u_DQUOTE] = ACTIONS(2957),
    [anon_sym_U_DQUOTE] = ACTIONS(2957),
    [anon_sym_u8_DQUOTE] = ACTIONS(2957),
    [anon_sym_DQUOTE] = ACTIONS(2957),
    [sym_true] = ACTIONS(2960),
    [sym_false] = ACTIONS(2960),
    [anon_sym_NULL] = ACTIONS(2963),
    [anon_sym_nullptr] = ACTIONS(2963),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2966),
    [anon_sym_template] = ACTIONS(2969),
    [anon_sym_try] = ACTIONS(3269),
    [anon_sym_delete] = ACTIONS(2975),
    [anon_sym_throw] = ACTIONS(3272),
    [anon_sym_co_return] = ACTIONS(3275),
    [anon_sym_co_yield] = ACTIONS(3278),
    [anon_sym_R_DQUOTE] = ACTIONS(2987),
    [anon_sym_LR_DQUOTE] = ACTIONS(2987),
    [anon_sym_uR_DQUOTE] = ACTIONS(2987),
    [anon_sym_UR_DQUOTE] = ACTIONS(2987),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2987),
    [anon_sym_co_await] = ACTIONS(2990),
    [anon_sym_new] = ACTIONS(2993),
    [anon_sym_requires] = ACTIONS(2996),
    [sym_this] = ACTIONS(2960),
  },
  [655] = {
    [sym_attribute_declaration] = STATE(634),
    [sym_compound_statement] = STATE(439),
    [sym_attributed_statement] = STATE(439),
    [sym_statement] = STATE(8871),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(634),
    [sym_identifier] = ACTIONS(2847),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(2849),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(2851),
    [anon_sym_default] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(2855),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(2857),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(2859),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [656] = {
    [sym_expression] = STATE(3371),
    [sym__string] = STATE(3926),
    [sym_conditional_expression] = STATE(3926),
    [sym_assignment_expression] = STATE(3926),
    [sym_pointer_expression] = STATE(3934),
    [sym_unary_expression] = STATE(3926),
    [sym_binary_expression] = STATE(3926),
    [sym_update_expression] = STATE(3926),
    [sym_cast_expression] = STATE(3926),
    [sym_sizeof_expression] = STATE(3926),
    [sym_alignof_expression] = STATE(3926),
    [sym_offsetof_expression] = STATE(3926),
    [sym_generic_expression] = STATE(3926),
    [sym_subscript_expression] = STATE(3934),
    [sym_call_expression] = STATE(3934),
    [sym_gnu_asm_expression] = STATE(3926),
    [sym_field_expression] = STATE(3934),
    [sym_compound_literal_expression] = STATE(3926),
    [sym_parenthesized_expression] = STATE(3934),
    [sym_initializer_list] = STATE(3942),
    [sym_char_literal] = STATE(3755),
    [sym_concatenated_string] = STATE(3759),
    [sym_string_literal] = STATE(2463),
    [sym_null] = STATE(3926),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7876),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3926),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3926),
    [sym_new_expression] = STATE(3926),
    [sym_delete_expression] = STATE(3926),
    [sym_requires_clause] = STATE(3926),
    [sym_requires_expression] = STATE(3926),
    [sym_lambda_expression] = STATE(3926),
    [sym_lambda_capture_specifier] = STATE(6169),
    [sym_fold_expression] = STATE(3926),
    [sym_parameter_pack_expansion] = STATE(3926),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3934),
    [sym_qualified_type_identifier] = STATE(7876),
    [sym_user_defined_literal] = STATE(3934),
    [sym_kernel_call_expression] = STATE(3930),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2508),
    [anon_sym_STAR] = ACTIONS(2508),
    [anon_sym_SLASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_PIPE] = ACTIONS(2508),
    [anon_sym_CARET] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_EQ_EQ] = ACTIONS(2510),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_GT] = ACTIONS(2508),
    [anon_sym_GT_EQ] = ACTIONS(2508),
    [anon_sym_LT_EQ] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_LT_LT] = ACTIONS(2508),
    [anon_sym_GT_GT] = ACTIONS(2508),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_EQ] = ACTIONS(2508),
    [sym_primitive_type] = ACTIONS(3291),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_STAR_EQ] = ACTIONS(2510),
    [anon_sym_SLASH_EQ] = ACTIONS(2510),
    [anon_sym_PERCENT_EQ] = ACTIONS(2510),
    [anon_sym_PLUS_EQ] = ACTIONS(2510),
    [anon_sym_DASH_EQ] = ACTIONS(2510),
    [anon_sym_LT_LT_EQ] = ACTIONS(2510),
    [anon_sym_GT_GT_EQ] = ACTIONS(2508),
    [anon_sym_AMP_EQ] = ACTIONS(2510),
    [anon_sym_CARET_EQ] = ACTIONS(2510),
    [anon_sym_PIPE_EQ] = ACTIONS(2510),
    [anon_sym_and_eq] = ACTIONS(2508),
    [anon_sym_or_eq] = ACTIONS(2508),
    [anon_sym_xor_eq] = ACTIONS(2508),
    [anon_sym_not] = ACTIONS(3283),
    [anon_sym_compl] = ACTIONS(3283),
    [anon_sym_LT_EQ_GT] = ACTIONS(2510),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_bitor] = ACTIONS(2508),
    [anon_sym_xor] = ACTIONS(2508),
    [anon_sym_bitand] = ACTIONS(2508),
    [anon_sym_not_eq] = ACTIONS(2508),
    [anon_sym_DASH_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_PLUS] = ACTIONS(2510),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3295),
    [anon_sym___alignof] = ACTIONS(3295),
    [anon_sym__alignof] = ACTIONS(3295),
    [anon_sym_alignof] = ACTIONS(3295),
    [anon_sym__Alignof] = ACTIONS(3295),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3299),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [anon_sym_DOT] = ACTIONS(2508),
    [anon_sym_DOT_STAR] = ACTIONS(2510),
    [anon_sym_DASH_GT] = ACTIONS(2510),
    [sym_number_literal] = ACTIONS(3303),
    [anon_sym_L_SQUOTE] = ACTIONS(3305),
    [anon_sym_u_SQUOTE] = ACTIONS(3305),
    [anon_sym_U_SQUOTE] = ACTIONS(3305),
    [anon_sym_u8_SQUOTE] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_L_DQUOTE] = ACTIONS(3307),
    [anon_sym_u_DQUOTE] = ACTIONS(3307),
    [anon_sym_U_DQUOTE] = ACTIONS(3307),
    [anon_sym_u8_DQUOTE] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [anon_sym_NULL] = ACTIONS(3311),
    [anon_sym_nullptr] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_GT2] = ACTIONS(2510),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_R_DQUOTE] = ACTIONS(3315),
    [anon_sym_LR_DQUOTE] = ACTIONS(3315),
    [anon_sym_uR_DQUOTE] = ACTIONS(3315),
    [anon_sym_UR_DQUOTE] = ACTIONS(3315),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3315),
    [anon_sym_co_await] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_requires] = ACTIONS(3321),
    [sym_this] = ACTIONS(3309),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(2510),
  },
  [657] = {
    [sym_attribute_declaration] = STATE(635),
    [sym_compound_statement] = STATE(439),
    [sym_attributed_statement] = STATE(439),
    [sym_statement] = STATE(312),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [658] = {
    [sym_attribute_declaration] = STATE(606),
    [sym_compound_statement] = STATE(423),
    [sym_attributed_statement] = STATE(423),
    [sym_statement] = STATE(349),
    [sym_labeled_statement] = STATE(423),
    [sym_expression_statement] = STATE(423),
    [sym_if_statement] = STATE(423),
    [sym_switch_statement] = STATE(423),
    [sym_case_statement] = STATE(423),
    [sym_while_statement] = STATE(423),
    [sym_do_statement] = STATE(423),
    [sym_for_statement] = STATE(423),
    [sym_return_statement] = STATE(423),
    [sym_break_statement] = STATE(423),
    [sym_continue_statement] = STATE(423),
    [sym_goto_statement] = STATE(423),
    [sym_seh_try_statement] = STATE(423),
    [sym_seh_leave_statement] = STATE(423),
    [sym_expression] = STATE(4913),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8497),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(423),
    [sym_co_return_statement] = STATE(423),
    [sym_co_yield_statement] = STATE(423),
    [sym_throw_statement] = STATE(423),
    [sym_try_statement] = STATE(423),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(606),
    [sym_identifier] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1571),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(81),
    [anon_sym_default] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(1573),
    [anon_sym___leave] = ACTIONS(1575),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [659] = {
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_unaligned_ptr_modifier] = STATE(4253),
    [sym_ms_pointer_modifier] = STATE(2783),
    [sym__declarator] = STATE(6744),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6598),
    [sym_array_declarator] = STATE(6598),
    [sym_type_qualifier] = STATE(3611),
    [sym_alignas_qualifier] = STATE(4511),
    [sym_expression] = STATE(2471),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3535),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5915),
    [sym_qualified_identifier] = STATE(3525),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [aux_sym__type_definition_type_repeat1] = STATE(3611),
    [aux_sym_pointer_declarator_repeat1] = STATE(2783),
    [sym_identifier] = ACTIONS(3323),
    [anon_sym_LPAREN2] = ACTIONS(3325),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(3327),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(3171),
    [anon_sym___global__] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym___based] = ACTIONS(49),
    [sym_ms_restrict_modifier] = ACTIONS(3173),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3173),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3173),
    [anon_sym__unaligned] = ACTIONS(3175),
    [anon_sym___unaligned] = ACTIONS(3175),
    [anon_sym_LBRACK] = ACTIONS(1843),
    [anon_sym_const] = ACTIONS(3171),
    [anon_sym_constexpr] = ACTIONS(3171),
    [anon_sym_volatile] = ACTIONS(3171),
    [anon_sym_restrict] = ACTIONS(3171),
    [anon_sym___restrict__] = ACTIONS(3171),
    [anon_sym__Atomic] = ACTIONS(3171),
    [anon_sym__Noreturn] = ACTIONS(3171),
    [anon_sym_noreturn] = ACTIONS(3171),
    [anon_sym_mutable] = ACTIONS(3171),
    [anon_sym_constinit] = ACTIONS(3171),
    [anon_sym_consteval] = ACTIONS(3171),
    [anon_sym___shared__] = ACTIONS(3171),
    [anon_sym___local__] = ACTIONS(3171),
    [anon_sym___constant__] = ACTIONS(3171),
    [anon_sym___managed__] = ACTIONS(3171),
    [anon_sym___grid_constant__] = ACTIONS(3171),
    [anon_sym_alignas] = ACTIONS(3177),
    [anon_sym__Alignas] = ACTIONS(3177),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [660] = {
    [sym_attribute_declaration] = STATE(622),
    [sym_compound_statement] = STATE(351),
    [sym_attributed_statement] = STATE(351),
    [sym_statement] = STATE(322),
    [sym_labeled_statement] = STATE(351),
    [sym_expression_statement] = STATE(351),
    [sym_if_statement] = STATE(351),
    [sym_switch_statement] = STATE(351),
    [sym_case_statement] = STATE(351),
    [sym_while_statement] = STATE(351),
    [sym_do_statement] = STATE(351),
    [sym_for_statement] = STATE(351),
    [sym_return_statement] = STATE(351),
    [sym_break_statement] = STATE(351),
    [sym_continue_statement] = STATE(351),
    [sym_goto_statement] = STATE(351),
    [sym_seh_try_statement] = STATE(351),
    [sym_seh_leave_statement] = STATE(351),
    [sym_expression] = STATE(4855),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8338),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(351),
    [sym_co_return_statement] = STATE(351),
    [sym_co_yield_statement] = STATE(351),
    [sym_throw_statement] = STATE(351),
    [sym_try_statement] = STATE(351),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(622),
    [sym_identifier] = ACTIONS(2841),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(651),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(663),
    [anon_sym_switch] = ACTIONS(665),
    [anon_sym_case] = ACTIONS(667),
    [anon_sym_default] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_do] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(677),
    [anon_sym_break] = ACTIONS(679),
    [anon_sym_continue] = ACTIONS(681),
    [anon_sym_goto] = ACTIONS(683),
    [anon_sym___try] = ACTIONS(685),
    [anon_sym___leave] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(691),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_co_return] = ACTIONS(703),
    [anon_sym_co_yield] = ACTIONS(705),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [661] = {
    [sym_attribute_declaration] = STATE(606),
    [sym_compound_statement] = STATE(423),
    [sym_attributed_statement] = STATE(423),
    [sym_statement] = STATE(311),
    [sym_labeled_statement] = STATE(423),
    [sym_expression_statement] = STATE(423),
    [sym_if_statement] = STATE(423),
    [sym_switch_statement] = STATE(423),
    [sym_case_statement] = STATE(423),
    [sym_while_statement] = STATE(423),
    [sym_do_statement] = STATE(423),
    [sym_for_statement] = STATE(423),
    [sym_return_statement] = STATE(423),
    [sym_break_statement] = STATE(423),
    [sym_continue_statement] = STATE(423),
    [sym_goto_statement] = STATE(423),
    [sym_seh_try_statement] = STATE(423),
    [sym_seh_leave_statement] = STATE(423),
    [sym_expression] = STATE(4913),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8497),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(423),
    [sym_co_return_statement] = STATE(423),
    [sym_co_yield_statement] = STATE(423),
    [sym_throw_statement] = STATE(423),
    [sym_try_statement] = STATE(423),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(606),
    [sym_identifier] = ACTIONS(2843),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1571),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_switch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(81),
    [anon_sym_default] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_do] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_break] = ACTIONS(93),
    [anon_sym_continue] = ACTIONS(95),
    [anon_sym_goto] = ACTIONS(97),
    [anon_sym___try] = ACTIONS(1573),
    [anon_sym___leave] = ACTIONS(1575),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(133),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(137),
    [anon_sym_co_return] = ACTIONS(147),
    [anon_sym_co_yield] = ACTIONS(149),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [662] = {
    [sym_attribute_declaration] = STATE(635),
    [sym_compound_statement] = STATE(439),
    [sym_attributed_statement] = STATE(439),
    [sym_statement] = STATE(375),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [663] = {
    [sym_expression] = STATE(3486),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_initializer_list] = STATE(2690),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_BANG] = ACTIONS(3331),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2508),
    [anon_sym_STAR] = ACTIONS(2508),
    [anon_sym_SLASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_PIPE] = ACTIONS(2508),
    [anon_sym_CARET] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_EQ_EQ] = ACTIONS(2510),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_GT] = ACTIONS(2508),
    [anon_sym_GT_EQ] = ACTIONS(2510),
    [anon_sym_LT_EQ] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_LT_LT] = ACTIONS(2508),
    [anon_sym_GT_GT] = ACTIONS(2508),
    [anon_sym_COLON_COLON] = ACTIONS(3335),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_EQ] = ACTIONS(2508),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_STAR_EQ] = ACTIONS(2510),
    [anon_sym_SLASH_EQ] = ACTIONS(2510),
    [anon_sym_PERCENT_EQ] = ACTIONS(2510),
    [anon_sym_PLUS_EQ] = ACTIONS(2510),
    [anon_sym_DASH_EQ] = ACTIONS(2510),
    [anon_sym_LT_LT_EQ] = ACTIONS(2510),
    [anon_sym_GT_GT_EQ] = ACTIONS(2510),
    [anon_sym_AMP_EQ] = ACTIONS(2510),
    [anon_sym_CARET_EQ] = ACTIONS(2510),
    [anon_sym_PIPE_EQ] = ACTIONS(2510),
    [anon_sym_and_eq] = ACTIONS(2508),
    [anon_sym_or_eq] = ACTIONS(2508),
    [anon_sym_xor_eq] = ACTIONS(2508),
    [anon_sym_not] = ACTIONS(3331),
    [anon_sym_compl] = ACTIONS(3331),
    [anon_sym_LT_EQ_GT] = ACTIONS(2510),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_bitor] = ACTIONS(2508),
    [anon_sym_xor] = ACTIONS(2508),
    [anon_sym_bitand] = ACTIONS(2508),
    [anon_sym_not_eq] = ACTIONS(2508),
    [anon_sym_DASH_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_PLUS] = ACTIONS(2510),
    [anon_sym_sizeof] = ACTIONS(3337),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [anon_sym_DOT] = ACTIONS(2508),
    [anon_sym_DOT_STAR] = ACTIONS(2510),
    [anon_sym_DASH_GT] = ACTIONS(2510),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3339),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(2510),
  },
  [664] = {
    [sym_attribute_declaration] = STATE(635),
    [sym_compound_statement] = STATE(439),
    [sym_attributed_statement] = STATE(439),
    [sym_statement] = STATE(362),
    [sym_labeled_statement] = STATE(439),
    [sym_expression_statement] = STATE(439),
    [sym_if_statement] = STATE(439),
    [sym_switch_statement] = STATE(439),
    [sym_case_statement] = STATE(439),
    [sym_while_statement] = STATE(439),
    [sym_do_statement] = STATE(439),
    [sym_for_statement] = STATE(439),
    [sym_return_statement] = STATE(439),
    [sym_break_statement] = STATE(439),
    [sym_continue_statement] = STATE(439),
    [sym_goto_statement] = STATE(439),
    [sym_seh_try_statement] = STATE(439),
    [sym_seh_leave_statement] = STATE(439),
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8259),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(439),
    [sym_co_return_statement] = STATE(439),
    [sym_co_yield_statement] = STATE(439),
    [sym_throw_statement] = STATE(439),
    [sym_try_statement] = STATE(439),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(635),
    [sym_identifier] = ACTIONS(2777),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(619),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [665] = {
    [sym_attribute_declaration] = STATE(633),
    [sym_compound_statement] = STATE(876),
    [sym_attributed_statement] = STATE(876),
    [sym_statement] = STATE(877),
    [sym_labeled_statement] = STATE(876),
    [sym_expression_statement] = STATE(876),
    [sym_if_statement] = STATE(876),
    [sym_switch_statement] = STATE(876),
    [sym_case_statement] = STATE(876),
    [sym_while_statement] = STATE(876),
    [sym_do_statement] = STATE(876),
    [sym_for_statement] = STATE(876),
    [sym_return_statement] = STATE(876),
    [sym_break_statement] = STATE(876),
    [sym_continue_statement] = STATE(876),
    [sym_goto_statement] = STATE(876),
    [sym_seh_try_statement] = STATE(876),
    [sym_seh_leave_statement] = STATE(876),
    [sym_expression] = STATE(4739),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8303),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(876),
    [sym_co_return_statement] = STATE(876),
    [sym_co_yield_statement] = STATE(876),
    [sym_throw_statement] = STATE(876),
    [sym_try_statement] = STATE(876),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(633),
    [sym_identifier] = ACTIONS(2999),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(1639),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(1647),
    [anon_sym_switch] = ACTIONS(1649),
    [anon_sym_case] = ACTIONS(2851),
    [anon_sym_default] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(1651),
    [anon_sym_do] = ACTIONS(1653),
    [anon_sym_for] = ACTIONS(1655),
    [anon_sym_return] = ACTIONS(1657),
    [anon_sym_break] = ACTIONS(1659),
    [anon_sym_continue] = ACTIONS(1661),
    [anon_sym_goto] = ACTIONS(1663),
    [anon_sym___try] = ACTIONS(1665),
    [anon_sym___leave] = ACTIONS(1667),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(1669),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(1671),
    [anon_sym_co_return] = ACTIONS(1673),
    [anon_sym_co_yield] = ACTIONS(1675),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [666] = {
    [sym_attribute_declaration] = STATE(620),
    [sym_compound_statement] = STATE(160),
    [sym_attributed_statement] = STATE(160),
    [sym_statement] = STATE(169),
    [sym_labeled_statement] = STATE(160),
    [sym_expression_statement] = STATE(160),
    [sym_if_statement] = STATE(160),
    [sym_switch_statement] = STATE(160),
    [sym_case_statement] = STATE(160),
    [sym_while_statement] = STATE(160),
    [sym_do_statement] = STATE(160),
    [sym_for_statement] = STATE(160),
    [sym_return_statement] = STATE(160),
    [sym_break_statement] = STATE(160),
    [sym_continue_statement] = STATE(160),
    [sym_goto_statement] = STATE(160),
    [sym_seh_try_statement] = STATE(160),
    [sym_seh_leave_statement] = STATE(160),
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(160),
    [sym_co_return_statement] = STATE(160),
    [sym_co_yield_statement] = STATE(160),
    [sym_throw_statement] = STATE(160),
    [sym_try_statement] = STATE(160),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(620),
    [sym_identifier] = ACTIONS(2845),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [667] = {
    [sym_attribute_declaration] = STATE(622),
    [sym_compound_statement] = STATE(351),
    [sym_attributed_statement] = STATE(351),
    [sym_statement] = STATE(436),
    [sym_labeled_statement] = STATE(351),
    [sym_expression_statement] = STATE(351),
    [sym_if_statement] = STATE(351),
    [sym_switch_statement] = STATE(351),
    [sym_case_statement] = STATE(351),
    [sym_while_statement] = STATE(351),
    [sym_do_statement] = STATE(351),
    [sym_for_statement] = STATE(351),
    [sym_return_statement] = STATE(351),
    [sym_break_statement] = STATE(351),
    [sym_continue_statement] = STATE(351),
    [sym_goto_statement] = STATE(351),
    [sym_seh_try_statement] = STATE(351),
    [sym_seh_leave_statement] = STATE(351),
    [sym_expression] = STATE(4855),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8338),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(351),
    [sym_co_return_statement] = STATE(351),
    [sym_co_yield_statement] = STATE(351),
    [sym_throw_statement] = STATE(351),
    [sym_try_statement] = STATE(351),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(622),
    [sym_identifier] = ACTIONS(2841),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(651),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(663),
    [anon_sym_switch] = ACTIONS(665),
    [anon_sym_case] = ACTIONS(667),
    [anon_sym_default] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_do] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(677),
    [anon_sym_break] = ACTIONS(679),
    [anon_sym_continue] = ACTIONS(681),
    [anon_sym_goto] = ACTIONS(683),
    [anon_sym___try] = ACTIONS(685),
    [anon_sym___leave] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(691),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_co_return] = ACTIONS(703),
    [anon_sym_co_yield] = ACTIONS(705),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [668] = {
    [sym_attribute_declaration] = STATE(668),
    [sym_compound_statement] = STATE(423),
    [sym_attributed_statement] = STATE(423),
    [sym_statement] = STATE(380),
    [sym_labeled_statement] = STATE(423),
    [sym_expression_statement] = STATE(423),
    [sym_if_statement] = STATE(423),
    [sym_switch_statement] = STATE(423),
    [sym_case_statement] = STATE(423),
    [sym_while_statement] = STATE(423),
    [sym_do_statement] = STATE(423),
    [sym_for_statement] = STATE(423),
    [sym_return_statement] = STATE(423),
    [sym_break_statement] = STATE(423),
    [sym_continue_statement] = STATE(423),
    [sym_goto_statement] = STATE(423),
    [sym_seh_try_statement] = STATE(423),
    [sym_seh_leave_statement] = STATE(423),
    [sym_expression] = STATE(4913),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8497),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(423),
    [sym_co_return_statement] = STATE(423),
    [sym_co_yield_statement] = STATE(423),
    [sym_throw_statement] = STATE(423),
    [sym_try_statement] = STATE(423),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(668),
    [sym_identifier] = ACTIONS(3343),
    [anon_sym_LPAREN2] = ACTIONS(2864),
    [anon_sym_BANG] = ACTIONS(2867),
    [anon_sym_TILDE] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2870),
    [anon_sym_PLUS] = ACTIONS(2870),
    [anon_sym_STAR] = ACTIONS(2873),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym_COLON_COLON] = ACTIONS(2879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2882),
    [anon_sym_LBRACE] = ACTIONS(3004),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [sym_primitive_type] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(3349),
    [anon_sym_switch] = ACTIONS(3010),
    [anon_sym_case] = ACTIONS(3352),
    [anon_sym_default] = ACTIONS(3355),
    [anon_sym_while] = ACTIONS(3358),
    [anon_sym_do] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3028),
    [anon_sym_break] = ACTIONS(3031),
    [anon_sym_continue] = ACTIONS(3034),
    [anon_sym_goto] = ACTIONS(3037),
    [anon_sym___try] = ACTIONS(3364),
    [anon_sym___leave] = ACTIONS(3367),
    [anon_sym_not] = ACTIONS(2870),
    [anon_sym_compl] = ACTIONS(2870),
    [anon_sym_DASH_DASH] = ACTIONS(2933),
    [anon_sym_PLUS_PLUS] = ACTIONS(2933),
    [anon_sym_sizeof] = ACTIONS(2936),
    [anon_sym___alignof__] = ACTIONS(2939),
    [anon_sym___alignof] = ACTIONS(2939),
    [anon_sym__alignof] = ACTIONS(2939),
    [anon_sym_alignof] = ACTIONS(2939),
    [anon_sym__Alignof] = ACTIONS(2939),
    [anon_sym_offsetof] = ACTIONS(2942),
    [anon_sym__Generic] = ACTIONS(2945),
    [anon_sym_asm] = ACTIONS(2948),
    [anon_sym___asm__] = ACTIONS(2948),
    [sym_number_literal] = ACTIONS(2951),
    [anon_sym_L_SQUOTE] = ACTIONS(2954),
    [anon_sym_u_SQUOTE] = ACTIONS(2954),
    [anon_sym_U_SQUOTE] = ACTIONS(2954),
    [anon_sym_u8_SQUOTE] = ACTIONS(2954),
    [anon_sym_SQUOTE] = ACTIONS(2954),
    [anon_sym_L_DQUOTE] = ACTIONS(2957),
    [anon_sym_u_DQUOTE] = ACTIONS(2957),
    [anon_sym_U_DQUOTE] = ACTIONS(2957),
    [anon_sym_u8_DQUOTE] = ACTIONS(2957),
    [anon_sym_DQUOTE] = ACTIONS(2957),
    [sym_true] = ACTIONS(2960),
    [sym_false] = ACTIONS(2960),
    [anon_sym_NULL] = ACTIONS(2963),
    [anon_sym_nullptr] = ACTIONS(2963),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2966),
    [anon_sym_template] = ACTIONS(2969),
    [anon_sym_try] = ACTIONS(3043),
    [anon_sym_delete] = ACTIONS(2975),
    [anon_sym_throw] = ACTIONS(3046),
    [anon_sym_co_return] = ACTIONS(3049),
    [anon_sym_co_yield] = ACTIONS(3052),
    [anon_sym_R_DQUOTE] = ACTIONS(2987),
    [anon_sym_LR_DQUOTE] = ACTIONS(2987),
    [anon_sym_uR_DQUOTE] = ACTIONS(2987),
    [anon_sym_UR_DQUOTE] = ACTIONS(2987),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2987),
    [anon_sym_co_await] = ACTIONS(2990),
    [anon_sym_new] = ACTIONS(2993),
    [anon_sym_requires] = ACTIONS(2996),
    [sym_this] = ACTIONS(2960),
  },
  [669] = {
    [ts_builtin_sym_end] = ACTIONS(2156),
    [sym_identifier] = ACTIONS(2154),
    [aux_sym_preproc_include_token1] = ACTIONS(2154),
    [aux_sym_preproc_def_token1] = ACTIONS(2154),
    [anon_sym_COMMA] = ACTIONS(2156),
    [aux_sym_preproc_if_token1] = ACTIONS(2154),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2154),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2154),
    [sym_preproc_directive] = ACTIONS(2154),
    [anon_sym_LPAREN2] = ACTIONS(2156),
    [anon_sym_BANG] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [anon_sym_DASH] = ACTIONS(2154),
    [anon_sym_PLUS] = ACTIONS(2154),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_AMP_AMP] = ACTIONS(2156),
    [anon_sym_AMP] = ACTIONS(2154),
    [anon_sym___extension__] = ACTIONS(2154),
    [anon_sym_typedef] = ACTIONS(2154),
    [anon_sym___device__] = ACTIONS(2154),
    [anon_sym___host__] = ACTIONS(2154),
    [anon_sym___global__] = ACTIONS(2154),
    [anon_sym___forceinline__] = ACTIONS(2154),
    [anon_sym___noinline__] = ACTIONS(2154),
    [anon_sym_extern] = ACTIONS(2154),
    [anon_sym___attribute__] = ACTIONS(2154),
    [anon_sym_COLON_COLON] = ACTIONS(2156),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2156),
    [anon_sym___declspec] = ACTIONS(2154),
    [anon_sym___based] = ACTIONS(2154),
    [anon_sym___cdecl] = ACTIONS(2154),
    [anon_sym___clrcall] = ACTIONS(2154),
    [anon_sym___stdcall] = ACTIONS(2154),
    [anon_sym___fastcall] = ACTIONS(2154),
    [anon_sym___thiscall] = ACTIONS(2154),
    [anon_sym___vectorcall] = ACTIONS(2154),
    [anon_sym_LBRACE] = ACTIONS(2156),
    [anon_sym_RBRACE] = ACTIONS(2156),
    [anon_sym_signed] = ACTIONS(2154),
    [anon_sym_unsigned] = ACTIONS(2154),
    [anon_sym_long] = ACTIONS(2154),
    [anon_sym_short] = ACTIONS(2154),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_static] = ACTIONS(2154),
    [anon_sym_register] = ACTIONS(2154),
    [anon_sym_inline] = ACTIONS(2154),
    [anon_sym___inline] = ACTIONS(2154),
    [anon_sym___inline__] = ACTIONS(2154),
    [anon_sym___forceinline] = ACTIONS(2154),
    [anon_sym_thread_local] = ACTIONS(2154),
    [anon_sym___thread] = ACTIONS(2154),
    [anon_sym_const] = ACTIONS(2154),
    [anon_sym_constexpr] = ACTIONS(2154),
    [anon_sym_volatile] = ACTIONS(2154),
    [anon_sym_restrict] = ACTIONS(2154),
    [anon_sym___restrict__] = ACTIONS(2154),
    [anon_sym__Atomic] = ACTIONS(2154),
    [anon_sym__Noreturn] = ACTIONS(2154),
    [anon_sym_noreturn] = ACTIONS(2154),
    [anon_sym_mutable] = ACTIONS(2154),
    [anon_sym_constinit] = ACTIONS(2154),
    [anon_sym_consteval] = ACTIONS(2154),
    [anon_sym___shared__] = ACTIONS(2154),
    [anon_sym___local__] = ACTIONS(2154),
    [anon_sym___constant__] = ACTIONS(2154),
    [anon_sym___managed__] = ACTIONS(2154),
    [anon_sym___grid_constant__] = ACTIONS(2154),
    [anon_sym_alignas] = ACTIONS(2154),
    [anon_sym__Alignas] = ACTIONS(2154),
    [sym_primitive_type] = ACTIONS(2154),
    [anon_sym_enum] = ACTIONS(2154),
    [anon_sym_class] = ACTIONS(2154),
    [anon_sym_struct] = ACTIONS(2154),
    [anon_sym_union] = ACTIONS(2154),
    [anon_sym_if] = ACTIONS(2154),
    [anon_sym_switch] = ACTIONS(2154),
    [anon_sym_case] = ACTIONS(2154),
    [anon_sym_default] = ACTIONS(2154),
    [anon_sym_while] = ACTIONS(2154),
    [anon_sym_do] = ACTIONS(2154),
    [anon_sym_for] = ACTIONS(2154),
    [anon_sym_return] = ACTIONS(2154),
    [anon_sym_break] = ACTIONS(2154),
    [anon_sym_continue] = ACTIONS(2154),
    [anon_sym_goto] = ACTIONS(2154),
    [anon_sym_not] = ACTIONS(2154),
    [anon_sym_compl] = ACTIONS(2154),
    [anon_sym_DASH_DASH] = ACTIONS(2156),
    [anon_sym_PLUS_PLUS] = ACTIONS(2156),
    [anon_sym_sizeof] = ACTIONS(2154),
    [anon_sym___alignof__] = ACTIONS(2154),
    [anon_sym___alignof] = ACTIONS(2154),
    [anon_sym__alignof] = ACTIONS(2154),
    [anon_sym_alignof] = ACTIONS(2154),
    [anon_sym__Alignof] = ACTIONS(2154),
    [anon_sym_offsetof] = ACTIONS(2154),
    [anon_sym__Generic] = ACTIONS(2154),
    [anon_sym_asm] = ACTIONS(2154),
    [anon_sym___asm__] = ACTIONS(2154),
    [sym_number_literal] = ACTIONS(2156),
    [anon_sym_L_SQUOTE] = ACTIONS(2156),
    [anon_sym_u_SQUOTE] = ACTIONS(2156),
    [anon_sym_U_SQUOTE] = ACTIONS(2156),
    [anon_sym_u8_SQUOTE] = ACTIONS(2156),
    [anon_sym_SQUOTE] = ACTIONS(2156),
    [anon_sym_L_DQUOTE] = ACTIONS(2156),
    [anon_sym_u_DQUOTE] = ACTIONS(2156),
    [anon_sym_U_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8_DQUOTE] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(2156),
    [sym_true] = ACTIONS(2154),
    [sym_false] = ACTIONS(2154),
    [anon_sym_NULL] = ACTIONS(2154),
    [anon_sym_nullptr] = ACTIONS(2154),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2154),
    [anon_sym_decltype] = ACTIONS(2154),
    [sym_virtual] = ACTIONS(2154),
    [anon_sym_explicit] = ACTIONS(2154),
    [anon_sym_typename] = ACTIONS(2154),
    [anon_sym_template] = ACTIONS(2154),
    [anon_sym_operator] = ACTIONS(2154),
    [anon_sym_try] = ACTIONS(2154),
    [anon_sym_delete] = ACTIONS(2154),
    [anon_sym_throw] = ACTIONS(2154),
    [anon_sym_namespace] = ACTIONS(2154),
    [anon_sym_using] = ACTIONS(2154),
    [anon_sym_static_assert] = ACTIONS(2154),
    [anon_sym_concept] = ACTIONS(2154),
    [anon_sym_co_return] = ACTIONS(2154),
    [anon_sym_co_yield] = ACTIONS(2154),
    [anon_sym_R_DQUOTE] = ACTIONS(2156),
    [anon_sym_LR_DQUOTE] = ACTIONS(2156),
    [anon_sym_uR_DQUOTE] = ACTIONS(2156),
    [anon_sym_UR_DQUOTE] = ACTIONS(2156),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2156),
    [anon_sym_co_await] = ACTIONS(2154),
    [anon_sym_new] = ACTIONS(2154),
    [anon_sym_requires] = ACTIONS(2154),
    [sym_this] = ACTIONS(2154),
    [anon_sym___launch_bounds__] = ACTIONS(2154),
  },
  [670] = {
    [sym_attribute_declaration] = STATE(622),
    [sym_compound_statement] = STATE(351),
    [sym_attributed_statement] = STATE(351),
    [sym_statement] = STATE(433),
    [sym_labeled_statement] = STATE(351),
    [sym_expression_statement] = STATE(351),
    [sym_if_statement] = STATE(351),
    [sym_switch_statement] = STATE(351),
    [sym_case_statement] = STATE(351),
    [sym_while_statement] = STATE(351),
    [sym_do_statement] = STATE(351),
    [sym_for_statement] = STATE(351),
    [sym_return_statement] = STATE(351),
    [sym_break_statement] = STATE(351),
    [sym_continue_statement] = STATE(351),
    [sym_goto_statement] = STATE(351),
    [sym_seh_try_statement] = STATE(351),
    [sym_seh_leave_statement] = STATE(351),
    [sym_expression] = STATE(4855),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8338),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(351),
    [sym_co_return_statement] = STATE(351),
    [sym_co_yield_statement] = STATE(351),
    [sym_throw_statement] = STATE(351),
    [sym_try_statement] = STATE(351),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(622),
    [sym_identifier] = ACTIONS(2841),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(651),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(663),
    [anon_sym_switch] = ACTIONS(665),
    [anon_sym_case] = ACTIONS(667),
    [anon_sym_default] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_do] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(677),
    [anon_sym_break] = ACTIONS(679),
    [anon_sym_continue] = ACTIONS(681),
    [anon_sym_goto] = ACTIONS(683),
    [anon_sym___try] = ACTIONS(685),
    [anon_sym___leave] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(691),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_co_return] = ACTIONS(703),
    [anon_sym_co_yield] = ACTIONS(705),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [671] = {
    [sym_attribute_declaration] = STATE(622),
    [sym_compound_statement] = STATE(351),
    [sym_attributed_statement] = STATE(351),
    [sym_statement] = STATE(432),
    [sym_labeled_statement] = STATE(351),
    [sym_expression_statement] = STATE(351),
    [sym_if_statement] = STATE(351),
    [sym_switch_statement] = STATE(351),
    [sym_case_statement] = STATE(351),
    [sym_while_statement] = STATE(351),
    [sym_do_statement] = STATE(351),
    [sym_for_statement] = STATE(351),
    [sym_return_statement] = STATE(351),
    [sym_break_statement] = STATE(351),
    [sym_continue_statement] = STATE(351),
    [sym_goto_statement] = STATE(351),
    [sym_seh_try_statement] = STATE(351),
    [sym_seh_leave_statement] = STATE(351),
    [sym_expression] = STATE(4855),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8338),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_for_range_loop] = STATE(351),
    [sym_co_return_statement] = STATE(351),
    [sym_co_yield_statement] = STATE(351),
    [sym_throw_statement] = STATE(351),
    [sym_try_statement] = STATE(351),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_attributed_declarator_repeat1] = STATE(622),
    [sym_identifier] = ACTIONS(2841),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(651),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1240),
    [anon_sym_LBRACE] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(663),
    [anon_sym_switch] = ACTIONS(665),
    [anon_sym_case] = ACTIONS(667),
    [anon_sym_default] = ACTIONS(669),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_do] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(677),
    [anon_sym_break] = ACTIONS(679),
    [anon_sym_continue] = ACTIONS(681),
    [anon_sym_goto] = ACTIONS(683),
    [anon_sym___try] = ACTIONS(685),
    [anon_sym___leave] = ACTIONS(687),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(691),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_co_return] = ACTIONS(703),
    [anon_sym_co_yield] = ACTIONS(705),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [672] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(5096),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_type_descriptor] = STATE(8630),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5914),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(3370),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(3372),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [673] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(5007),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_type_descriptor] = STATE(8262),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5914),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(3370),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(3372),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [674] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(5131),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_type_descriptor] = STATE(8347),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5914),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(3370),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(3372),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [675] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(5133),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_type_descriptor] = STATE(8319),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5914),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(3370),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(3372),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [676] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(5082),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_type_descriptor] = STATE(8688),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5914),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(3370),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(3372),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [677] = {
    [sym_type_qualifier] = STATE(3568),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(4587),
    [sym_sized_type_specifier] = STATE(2024),
    [sym_enum_specifier] = STATE(2024),
    [sym_struct_specifier] = STATE(2024),
    [sym_union_specifier] = STATE(2024),
    [sym_expression] = STATE(5035),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_type_descriptor] = STATE(8915),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_placeholder_type_specifier] = STATE(2024),
    [sym_decltype_auto] = STATE(2021),
    [sym_decltype] = STATE(1859),
    [sym_class_specifier] = STATE(2024),
    [sym__class_name] = STATE(8005),
    [sym_dependent_type] = STATE(2024),
    [sym_template_type] = STATE(5385),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5914),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(5397),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym__type_definition_type_repeat1] = STATE(3568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2048),
    [sym_identifier] = ACTIONS(3370),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___global__] = ACTIONS(63),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_signed] = ACTIONS(1841),
    [anon_sym_unsigned] = ACTIONS(1841),
    [anon_sym_long] = ACTIONS(1841),
    [anon_sym_short] = ACTIONS(1841),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(3372),
    [anon_sym_enum] = ACTIONS(1847),
    [anon_sym_class] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1851),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1877),
    [anon_sym_decltype] = ACTIONS(1879),
    [anon_sym_typename] = ACTIONS(1881),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [678] = {
    [sym_preproc_def] = STATE(701),
    [sym_preproc_function_def] = STATE(701),
    [sym_preproc_call] = STATE(701),
    [sym_preproc_if_in_field_declaration_list] = STATE(701),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(701),
    [sym_type_definition] = STATE(701),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5894),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6463),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(701),
    [sym_field_declaration] = STATE(701),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1708),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(701),
    [sym_operator_cast] = STATE(6999),
    [sym_inline_method_definition] = STATE(701),
    [sym__constructor_specifiers] = STATE(1708),
    [sym_operator_cast_definition] = STATE(701),
    [sym_operator_cast_declaration] = STATE(701),
    [sym_constructor_or_destructor_definition] = STATE(701),
    [sym_constructor_or_destructor_declaration] = STATE(701),
    [sym_friend_declaration] = STATE(701),
    [sym_access_specifier] = STATE(8255),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(701),
    [sym_alias_declaration] = STATE(701),
    [sym_static_assert_declaration] = STATE(701),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6999),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(701),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1708),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3376),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3378),
    [sym_preproc_directive] = ACTIONS(3380),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(3382),
    [anon_sym_typedef] = ACTIONS(3384),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3386),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3390),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(3392),
    [anon_sym_static_assert] = ACTIONS(3394),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [679] = {
    [ts_builtin_sym_end] = ACTIONS(2506),
    [sym_identifier] = ACTIONS(2504),
    [aux_sym_preproc_include_token1] = ACTIONS(2504),
    [aux_sym_preproc_def_token1] = ACTIONS(2504),
    [aux_sym_preproc_if_token1] = ACTIONS(2504),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2504),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2504),
    [sym_preproc_directive] = ACTIONS(2504),
    [anon_sym_LPAREN2] = ACTIONS(2506),
    [anon_sym_BANG] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2506),
    [anon_sym_DASH] = ACTIONS(2504),
    [anon_sym_PLUS] = ACTIONS(2504),
    [anon_sym_STAR] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2504),
    [anon_sym___extension__] = ACTIONS(2504),
    [anon_sym_typedef] = ACTIONS(2504),
    [anon_sym___device__] = ACTIONS(2504),
    [anon_sym___host__] = ACTIONS(2504),
    [anon_sym___global__] = ACTIONS(2504),
    [anon_sym___forceinline__] = ACTIONS(2504),
    [anon_sym___noinline__] = ACTIONS(2504),
    [anon_sym_extern] = ACTIONS(2504),
    [anon_sym___attribute__] = ACTIONS(2504),
    [anon_sym_COLON_COLON] = ACTIONS(2506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2506),
    [anon_sym___declspec] = ACTIONS(2504),
    [anon_sym___based] = ACTIONS(2504),
    [anon_sym___cdecl] = ACTIONS(2504),
    [anon_sym___clrcall] = ACTIONS(2504),
    [anon_sym___stdcall] = ACTIONS(2504),
    [anon_sym___fastcall] = ACTIONS(2504),
    [anon_sym___thiscall] = ACTIONS(2504),
    [anon_sym___vectorcall] = ACTIONS(2504),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_signed] = ACTIONS(2504),
    [anon_sym_unsigned] = ACTIONS(2504),
    [anon_sym_long] = ACTIONS(2504),
    [anon_sym_short] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(2504),
    [anon_sym_static] = ACTIONS(2504),
    [anon_sym_register] = ACTIONS(2504),
    [anon_sym_inline] = ACTIONS(2504),
    [anon_sym___inline] = ACTIONS(2504),
    [anon_sym___inline__] = ACTIONS(2504),
    [anon_sym___forceinline] = ACTIONS(2504),
    [anon_sym_thread_local] = ACTIONS(2504),
    [anon_sym___thread] = ACTIONS(2504),
    [anon_sym_const] = ACTIONS(2504),
    [anon_sym_constexpr] = ACTIONS(2504),
    [anon_sym_volatile] = ACTIONS(2504),
    [anon_sym_restrict] = ACTIONS(2504),
    [anon_sym___restrict__] = ACTIONS(2504),
    [anon_sym__Atomic] = ACTIONS(2504),
    [anon_sym__Noreturn] = ACTIONS(2504),
    [anon_sym_noreturn] = ACTIONS(2504),
    [anon_sym_mutable] = ACTIONS(2504),
    [anon_sym_constinit] = ACTIONS(2504),
    [anon_sym_consteval] = ACTIONS(2504),
    [anon_sym___shared__] = ACTIONS(2504),
    [anon_sym___local__] = ACTIONS(2504),
    [anon_sym___constant__] = ACTIONS(2504),
    [anon_sym___managed__] = ACTIONS(2504),
    [anon_sym___grid_constant__] = ACTIONS(2504),
    [anon_sym_alignas] = ACTIONS(2504),
    [anon_sym__Alignas] = ACTIONS(2504),
    [sym_primitive_type] = ACTIONS(2504),
    [anon_sym_enum] = ACTIONS(2504),
    [anon_sym_class] = ACTIONS(2504),
    [anon_sym_struct] = ACTIONS(2504),
    [anon_sym_union] = ACTIONS(2504),
    [anon_sym_if] = ACTIONS(2504),
    [anon_sym_switch] = ACTIONS(2504),
    [anon_sym_case] = ACTIONS(2504),
    [anon_sym_default] = ACTIONS(2504),
    [anon_sym_while] = ACTIONS(2504),
    [anon_sym_do] = ACTIONS(2504),
    [anon_sym_for] = ACTIONS(2504),
    [anon_sym_return] = ACTIONS(2504),
    [anon_sym_break] = ACTIONS(2504),
    [anon_sym_continue] = ACTIONS(2504),
    [anon_sym_goto] = ACTIONS(2504),
    [anon_sym_not] = ACTIONS(2504),
    [anon_sym_compl] = ACTIONS(2504),
    [anon_sym_DASH_DASH] = ACTIONS(2506),
    [anon_sym_PLUS_PLUS] = ACTIONS(2506),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(2504),
    [anon_sym___alignof] = ACTIONS(2504),
    [anon_sym__alignof] = ACTIONS(2504),
    [anon_sym_alignof] = ACTIONS(2504),
    [anon_sym__Alignof] = ACTIONS(2504),
    [anon_sym_offsetof] = ACTIONS(2504),
    [anon_sym__Generic] = ACTIONS(2504),
    [anon_sym_asm] = ACTIONS(2504),
    [anon_sym___asm__] = ACTIONS(2504),
    [sym_number_literal] = ACTIONS(2506),
    [anon_sym_L_SQUOTE] = ACTIONS(2506),
    [anon_sym_u_SQUOTE] = ACTIONS(2506),
    [anon_sym_U_SQUOTE] = ACTIONS(2506),
    [anon_sym_u8_SQUOTE] = ACTIONS(2506),
    [anon_sym_SQUOTE] = ACTIONS(2506),
    [anon_sym_L_DQUOTE] = ACTIONS(2506),
    [anon_sym_u_DQUOTE] = ACTIONS(2506),
    [anon_sym_U_DQUOTE] = ACTIONS(2506),
    [anon_sym_u8_DQUOTE] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [sym_true] = ACTIONS(2504),
    [sym_false] = ACTIONS(2504),
    [anon_sym_NULL] = ACTIONS(2504),
    [anon_sym_nullptr] = ACTIONS(2504),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2504),
    [anon_sym_decltype] = ACTIONS(2504),
    [sym_virtual] = ACTIONS(2504),
    [anon_sym_explicit] = ACTIONS(2504),
    [anon_sym_typename] = ACTIONS(2504),
    [anon_sym_template] = ACTIONS(2504),
    [anon_sym_operator] = ACTIONS(2504),
    [anon_sym_try] = ACTIONS(2504),
    [anon_sym_delete] = ACTIONS(2504),
    [anon_sym_throw] = ACTIONS(2504),
    [anon_sym_namespace] = ACTIONS(2504),
    [anon_sym_using] = ACTIONS(2504),
    [anon_sym_static_assert] = ACTIONS(2504),
    [anon_sym_concept] = ACTIONS(2504),
    [anon_sym_co_return] = ACTIONS(2504),
    [anon_sym_co_yield] = ACTIONS(2504),
    [anon_sym_R_DQUOTE] = ACTIONS(2506),
    [anon_sym_LR_DQUOTE] = ACTIONS(2506),
    [anon_sym_uR_DQUOTE] = ACTIONS(2506),
    [anon_sym_UR_DQUOTE] = ACTIONS(2506),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2506),
    [anon_sym_co_await] = ACTIONS(2504),
    [anon_sym_new] = ACTIONS(2504),
    [anon_sym_requires] = ACTIONS(2504),
    [sym_this] = ACTIONS(2504),
    [anon_sym___launch_bounds__] = ACTIONS(2504),
  },
  [680] = {
    [sym_preproc_def] = STATE(701),
    [sym_preproc_function_def] = STATE(701),
    [sym_preproc_call] = STATE(701),
    [sym_preproc_if_in_field_declaration_list] = STATE(701),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(701),
    [sym_type_definition] = STATE(701),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5894),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6463),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(701),
    [sym_field_declaration] = STATE(701),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1708),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(701),
    [sym_operator_cast] = STATE(6999),
    [sym_inline_method_definition] = STATE(701),
    [sym__constructor_specifiers] = STATE(1708),
    [sym_operator_cast_definition] = STATE(701),
    [sym_operator_cast_declaration] = STATE(701),
    [sym_constructor_or_destructor_definition] = STATE(701),
    [sym_constructor_or_destructor_declaration] = STATE(701),
    [sym_friend_declaration] = STATE(701),
    [sym_access_specifier] = STATE(8255),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(701),
    [sym_alias_declaration] = STATE(701),
    [sym_static_assert_declaration] = STATE(701),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6999),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(701),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1708),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3376),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3378),
    [sym_preproc_directive] = ACTIONS(3380),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(3382),
    [anon_sym_typedef] = ACTIONS(3384),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3396),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3390),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(3392),
    [anon_sym_static_assert] = ACTIONS(3394),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [681] = {
    [ts_builtin_sym_end] = ACTIONS(2358),
    [sym_identifier] = ACTIONS(2356),
    [aux_sym_preproc_include_token1] = ACTIONS(2356),
    [aux_sym_preproc_def_token1] = ACTIONS(2356),
    [aux_sym_preproc_if_token1] = ACTIONS(2356),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2356),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2356),
    [sym_preproc_directive] = ACTIONS(2356),
    [anon_sym_LPAREN2] = ACTIONS(2358),
    [anon_sym_BANG] = ACTIONS(2358),
    [anon_sym_TILDE] = ACTIONS(2358),
    [anon_sym_DASH] = ACTIONS(2356),
    [anon_sym_PLUS] = ACTIONS(2356),
    [anon_sym_STAR] = ACTIONS(2358),
    [anon_sym_AMP_AMP] = ACTIONS(2358),
    [anon_sym_AMP] = ACTIONS(2356),
    [anon_sym___extension__] = ACTIONS(2356),
    [anon_sym_typedef] = ACTIONS(2356),
    [anon_sym___device__] = ACTIONS(2356),
    [anon_sym___host__] = ACTIONS(2356),
    [anon_sym___global__] = ACTIONS(2356),
    [anon_sym___forceinline__] = ACTIONS(2356),
    [anon_sym___noinline__] = ACTIONS(2356),
    [anon_sym_extern] = ACTIONS(2356),
    [anon_sym___attribute__] = ACTIONS(2356),
    [anon_sym_COLON_COLON] = ACTIONS(2358),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2358),
    [anon_sym___declspec] = ACTIONS(2356),
    [anon_sym___based] = ACTIONS(2356),
    [anon_sym___cdecl] = ACTIONS(2356),
    [anon_sym___clrcall] = ACTIONS(2356),
    [anon_sym___stdcall] = ACTIONS(2356),
    [anon_sym___fastcall] = ACTIONS(2356),
    [anon_sym___thiscall] = ACTIONS(2356),
    [anon_sym___vectorcall] = ACTIONS(2356),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_signed] = ACTIONS(2356),
    [anon_sym_unsigned] = ACTIONS(2356),
    [anon_sym_long] = ACTIONS(2356),
    [anon_sym_short] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2356),
    [anon_sym_register] = ACTIONS(2356),
    [anon_sym_inline] = ACTIONS(2356),
    [anon_sym___inline] = ACTIONS(2356),
    [anon_sym___inline__] = ACTIONS(2356),
    [anon_sym___forceinline] = ACTIONS(2356),
    [anon_sym_thread_local] = ACTIONS(2356),
    [anon_sym___thread] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(2356),
    [anon_sym_constexpr] = ACTIONS(2356),
    [anon_sym_volatile] = ACTIONS(2356),
    [anon_sym_restrict] = ACTIONS(2356),
    [anon_sym___restrict__] = ACTIONS(2356),
    [anon_sym__Atomic] = ACTIONS(2356),
    [anon_sym__Noreturn] = ACTIONS(2356),
    [anon_sym_noreturn] = ACTIONS(2356),
    [anon_sym_mutable] = ACTIONS(2356),
    [anon_sym_constinit] = ACTIONS(2356),
    [anon_sym_consteval] = ACTIONS(2356),
    [anon_sym___shared__] = ACTIONS(2356),
    [anon_sym___local__] = ACTIONS(2356),
    [anon_sym___constant__] = ACTIONS(2356),
    [anon_sym___managed__] = ACTIONS(2356),
    [anon_sym___grid_constant__] = ACTIONS(2356),
    [anon_sym_alignas] = ACTIONS(2356),
    [anon_sym__Alignas] = ACTIONS(2356),
    [sym_primitive_type] = ACTIONS(2356),
    [anon_sym_enum] = ACTIONS(2356),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_struct] = ACTIONS(2356),
    [anon_sym_union] = ACTIONS(2356),
    [anon_sym_if] = ACTIONS(2356),
    [anon_sym_switch] = ACTIONS(2356),
    [anon_sym_case] = ACTIONS(2356),
    [anon_sym_default] = ACTIONS(2356),
    [anon_sym_while] = ACTIONS(2356),
    [anon_sym_do] = ACTIONS(2356),
    [anon_sym_for] = ACTIONS(2356),
    [anon_sym_return] = ACTIONS(2356),
    [anon_sym_break] = ACTIONS(2356),
    [anon_sym_continue] = ACTIONS(2356),
    [anon_sym_goto] = ACTIONS(2356),
    [anon_sym_not] = ACTIONS(2356),
    [anon_sym_compl] = ACTIONS(2356),
    [anon_sym_DASH_DASH] = ACTIONS(2358),
    [anon_sym_PLUS_PLUS] = ACTIONS(2358),
    [anon_sym_sizeof] = ACTIONS(2356),
    [anon_sym___alignof__] = ACTIONS(2356),
    [anon_sym___alignof] = ACTIONS(2356),
    [anon_sym__alignof] = ACTIONS(2356),
    [anon_sym_alignof] = ACTIONS(2356),
    [anon_sym__Alignof] = ACTIONS(2356),
    [anon_sym_offsetof] = ACTIONS(2356),
    [anon_sym__Generic] = ACTIONS(2356),
    [anon_sym_asm] = ACTIONS(2356),
    [anon_sym___asm__] = ACTIONS(2356),
    [sym_number_literal] = ACTIONS(2358),
    [anon_sym_L_SQUOTE] = ACTIONS(2358),
    [anon_sym_u_SQUOTE] = ACTIONS(2358),
    [anon_sym_U_SQUOTE] = ACTIONS(2358),
    [anon_sym_u8_SQUOTE] = ACTIONS(2358),
    [anon_sym_SQUOTE] = ACTIONS(2358),
    [anon_sym_L_DQUOTE] = ACTIONS(2358),
    [anon_sym_u_DQUOTE] = ACTIONS(2358),
    [anon_sym_U_DQUOTE] = ACTIONS(2358),
    [anon_sym_u8_DQUOTE] = ACTIONS(2358),
    [anon_sym_DQUOTE] = ACTIONS(2358),
    [sym_true] = ACTIONS(2356),
    [sym_false] = ACTIONS(2356),
    [anon_sym_NULL] = ACTIONS(2356),
    [anon_sym_nullptr] = ACTIONS(2356),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2356),
    [anon_sym_decltype] = ACTIONS(2356),
    [sym_virtual] = ACTIONS(2356),
    [anon_sym_explicit] = ACTIONS(2356),
    [anon_sym_typename] = ACTIONS(2356),
    [anon_sym_template] = ACTIONS(2356),
    [anon_sym_operator] = ACTIONS(2356),
    [anon_sym_try] = ACTIONS(2356),
    [anon_sym_delete] = ACTIONS(2356),
    [anon_sym_throw] = ACTIONS(2356),
    [anon_sym_namespace] = ACTIONS(2356),
    [anon_sym_using] = ACTIONS(2356),
    [anon_sym_static_assert] = ACTIONS(2356),
    [anon_sym_concept] = ACTIONS(2356),
    [anon_sym_co_return] = ACTIONS(2356),
    [anon_sym_co_yield] = ACTIONS(2356),
    [anon_sym_R_DQUOTE] = ACTIONS(2358),
    [anon_sym_LR_DQUOTE] = ACTIONS(2358),
    [anon_sym_uR_DQUOTE] = ACTIONS(2358),
    [anon_sym_UR_DQUOTE] = ACTIONS(2358),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2358),
    [anon_sym_co_await] = ACTIONS(2356),
    [anon_sym_new] = ACTIONS(2356),
    [anon_sym_requires] = ACTIONS(2356),
    [sym_this] = ACTIONS(2356),
    [anon_sym___launch_bounds__] = ACTIONS(2356),
  },
  [682] = {
    [sym_preproc_def] = STATE(706),
    [sym_preproc_function_def] = STATE(706),
    [sym_preproc_call] = STATE(706),
    [sym_preproc_if_in_field_declaration_list] = STATE(706),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(706),
    [sym_type_definition] = STATE(706),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5894),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6463),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(706),
    [sym_field_declaration] = STATE(706),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1708),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(706),
    [sym_operator_cast] = STATE(6999),
    [sym_inline_method_definition] = STATE(706),
    [sym__constructor_specifiers] = STATE(1708),
    [sym_operator_cast_definition] = STATE(706),
    [sym_operator_cast_declaration] = STATE(706),
    [sym_constructor_or_destructor_definition] = STATE(706),
    [sym_constructor_or_destructor_declaration] = STATE(706),
    [sym_friend_declaration] = STATE(706),
    [sym_access_specifier] = STATE(8255),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(706),
    [sym_alias_declaration] = STATE(706),
    [sym_static_assert_declaration] = STATE(706),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6999),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(706),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1708),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3376),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3378),
    [sym_preproc_directive] = ACTIONS(3380),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(3382),
    [anon_sym_typedef] = ACTIONS(3384),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3398),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3390),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(3392),
    [anon_sym_static_assert] = ACTIONS(3394),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [683] = {
    [ts_builtin_sym_end] = ACTIONS(2438),
    [sym_identifier] = ACTIONS(2436),
    [aux_sym_preproc_include_token1] = ACTIONS(2436),
    [aux_sym_preproc_def_token1] = ACTIONS(2436),
    [aux_sym_preproc_if_token1] = ACTIONS(2436),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2436),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2436),
    [sym_preproc_directive] = ACTIONS(2436),
    [anon_sym_LPAREN2] = ACTIONS(2438),
    [anon_sym_BANG] = ACTIONS(2438),
    [anon_sym_TILDE] = ACTIONS(2438),
    [anon_sym_DASH] = ACTIONS(2436),
    [anon_sym_PLUS] = ACTIONS(2436),
    [anon_sym_STAR] = ACTIONS(2438),
    [anon_sym_AMP_AMP] = ACTIONS(2438),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym___extension__] = ACTIONS(2436),
    [anon_sym_typedef] = ACTIONS(2436),
    [anon_sym___device__] = ACTIONS(2436),
    [anon_sym___host__] = ACTIONS(2436),
    [anon_sym___global__] = ACTIONS(2436),
    [anon_sym___forceinline__] = ACTIONS(2436),
    [anon_sym___noinline__] = ACTIONS(2436),
    [anon_sym_extern] = ACTIONS(2436),
    [anon_sym___attribute__] = ACTIONS(2436),
    [anon_sym_COLON_COLON] = ACTIONS(2438),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2438),
    [anon_sym___declspec] = ACTIONS(2436),
    [anon_sym___based] = ACTIONS(2436),
    [anon_sym___cdecl] = ACTIONS(2436),
    [anon_sym___clrcall] = ACTIONS(2436),
    [anon_sym___stdcall] = ACTIONS(2436),
    [anon_sym___fastcall] = ACTIONS(2436),
    [anon_sym___thiscall] = ACTIONS(2436),
    [anon_sym___vectorcall] = ACTIONS(2436),
    [anon_sym_LBRACE] = ACTIONS(2438),
    [anon_sym_signed] = ACTIONS(2436),
    [anon_sym_unsigned] = ACTIONS(2436),
    [anon_sym_long] = ACTIONS(2436),
    [anon_sym_short] = ACTIONS(2436),
    [anon_sym_LBRACK] = ACTIONS(2436),
    [anon_sym_static] = ACTIONS(2436),
    [anon_sym_register] = ACTIONS(2436),
    [anon_sym_inline] = ACTIONS(2436),
    [anon_sym___inline] = ACTIONS(2436),
    [anon_sym___inline__] = ACTIONS(2436),
    [anon_sym___forceinline] = ACTIONS(2436),
    [anon_sym_thread_local] = ACTIONS(2436),
    [anon_sym___thread] = ACTIONS(2436),
    [anon_sym_const] = ACTIONS(2436),
    [anon_sym_constexpr] = ACTIONS(2436),
    [anon_sym_volatile] = ACTIONS(2436),
    [anon_sym_restrict] = ACTIONS(2436),
    [anon_sym___restrict__] = ACTIONS(2436),
    [anon_sym__Atomic] = ACTIONS(2436),
    [anon_sym__Noreturn] = ACTIONS(2436),
    [anon_sym_noreturn] = ACTIONS(2436),
    [anon_sym_mutable] = ACTIONS(2436),
    [anon_sym_constinit] = ACTIONS(2436),
    [anon_sym_consteval] = ACTIONS(2436),
    [anon_sym___shared__] = ACTIONS(2436),
    [anon_sym___local__] = ACTIONS(2436),
    [anon_sym___constant__] = ACTIONS(2436),
    [anon_sym___managed__] = ACTIONS(2436),
    [anon_sym___grid_constant__] = ACTIONS(2436),
    [anon_sym_alignas] = ACTIONS(2436),
    [anon_sym__Alignas] = ACTIONS(2436),
    [sym_primitive_type] = ACTIONS(2436),
    [anon_sym_enum] = ACTIONS(2436),
    [anon_sym_class] = ACTIONS(2436),
    [anon_sym_struct] = ACTIONS(2436),
    [anon_sym_union] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(2436),
    [anon_sym_switch] = ACTIONS(2436),
    [anon_sym_case] = ACTIONS(2436),
    [anon_sym_default] = ACTIONS(2436),
    [anon_sym_while] = ACTIONS(2436),
    [anon_sym_do] = ACTIONS(2436),
    [anon_sym_for] = ACTIONS(2436),
    [anon_sym_return] = ACTIONS(2436),
    [anon_sym_break] = ACTIONS(2436),
    [anon_sym_continue] = ACTIONS(2436),
    [anon_sym_goto] = ACTIONS(2436),
    [anon_sym_not] = ACTIONS(2436),
    [anon_sym_compl] = ACTIONS(2436),
    [anon_sym_DASH_DASH] = ACTIONS(2438),
    [anon_sym_PLUS_PLUS] = ACTIONS(2438),
    [anon_sym_sizeof] = ACTIONS(2436),
    [anon_sym___alignof__] = ACTIONS(2436),
    [anon_sym___alignof] = ACTIONS(2436),
    [anon_sym__alignof] = ACTIONS(2436),
    [anon_sym_alignof] = ACTIONS(2436),
    [anon_sym__Alignof] = ACTIONS(2436),
    [anon_sym_offsetof] = ACTIONS(2436),
    [anon_sym__Generic] = ACTIONS(2436),
    [anon_sym_asm] = ACTIONS(2436),
    [anon_sym___asm__] = ACTIONS(2436),
    [sym_number_literal] = ACTIONS(2438),
    [anon_sym_L_SQUOTE] = ACTIONS(2438),
    [anon_sym_u_SQUOTE] = ACTIONS(2438),
    [anon_sym_U_SQUOTE] = ACTIONS(2438),
    [anon_sym_u8_SQUOTE] = ACTIONS(2438),
    [anon_sym_SQUOTE] = ACTIONS(2438),
    [anon_sym_L_DQUOTE] = ACTIONS(2438),
    [anon_sym_u_DQUOTE] = ACTIONS(2438),
    [anon_sym_U_DQUOTE] = ACTIONS(2438),
    [anon_sym_u8_DQUOTE] = ACTIONS(2438),
    [anon_sym_DQUOTE] = ACTIONS(2438),
    [sym_true] = ACTIONS(2436),
    [sym_false] = ACTIONS(2436),
    [anon_sym_NULL] = ACTIONS(2436),
    [anon_sym_nullptr] = ACTIONS(2436),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2436),
    [anon_sym_decltype] = ACTIONS(2436),
    [sym_virtual] = ACTIONS(2436),
    [anon_sym_explicit] = ACTIONS(2436),
    [anon_sym_typename] = ACTIONS(2436),
    [anon_sym_template] = ACTIONS(2436),
    [anon_sym_operator] = ACTIONS(2436),
    [anon_sym_try] = ACTIONS(2436),
    [anon_sym_delete] = ACTIONS(2436),
    [anon_sym_throw] = ACTIONS(2436),
    [anon_sym_namespace] = ACTIONS(2436),
    [anon_sym_using] = ACTIONS(2436),
    [anon_sym_static_assert] = ACTIONS(2436),
    [anon_sym_concept] = ACTIONS(2436),
    [anon_sym_co_return] = ACTIONS(2436),
    [anon_sym_co_yield] = ACTIONS(2436),
    [anon_sym_R_DQUOTE] = ACTIONS(2438),
    [anon_sym_LR_DQUOTE] = ACTIONS(2438),
    [anon_sym_uR_DQUOTE] = ACTIONS(2438),
    [anon_sym_UR_DQUOTE] = ACTIONS(2438),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2438),
    [anon_sym_co_await] = ACTIONS(2436),
    [anon_sym_new] = ACTIONS(2436),
    [anon_sym_requires] = ACTIONS(2436),
    [sym_this] = ACTIONS(2436),
    [anon_sym___launch_bounds__] = ACTIONS(2436),
  },
  [684] = {
    [ts_builtin_sym_end] = ACTIONS(2354),
    [sym_identifier] = ACTIONS(2352),
    [aux_sym_preproc_include_token1] = ACTIONS(2352),
    [aux_sym_preproc_def_token1] = ACTIONS(2352),
    [aux_sym_preproc_if_token1] = ACTIONS(2352),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2352),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2352),
    [sym_preproc_directive] = ACTIONS(2352),
    [anon_sym_LPAREN2] = ACTIONS(2354),
    [anon_sym_BANG] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2354),
    [anon_sym_DASH] = ACTIONS(2352),
    [anon_sym_PLUS] = ACTIONS(2352),
    [anon_sym_STAR] = ACTIONS(2354),
    [anon_sym_AMP_AMP] = ACTIONS(2354),
    [anon_sym_AMP] = ACTIONS(2352),
    [anon_sym___extension__] = ACTIONS(2352),
    [anon_sym_typedef] = ACTIONS(2352),
    [anon_sym___device__] = ACTIONS(2352),
    [anon_sym___host__] = ACTIONS(2352),
    [anon_sym___global__] = ACTIONS(2352),
    [anon_sym___forceinline__] = ACTIONS(2352),
    [anon_sym___noinline__] = ACTIONS(2352),
    [anon_sym_extern] = ACTIONS(2352),
    [anon_sym___attribute__] = ACTIONS(2352),
    [anon_sym_COLON_COLON] = ACTIONS(2354),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2354),
    [anon_sym___declspec] = ACTIONS(2352),
    [anon_sym___based] = ACTIONS(2352),
    [anon_sym___cdecl] = ACTIONS(2352),
    [anon_sym___clrcall] = ACTIONS(2352),
    [anon_sym___stdcall] = ACTIONS(2352),
    [anon_sym___fastcall] = ACTIONS(2352),
    [anon_sym___thiscall] = ACTIONS(2352),
    [anon_sym___vectorcall] = ACTIONS(2352),
    [anon_sym_LBRACE] = ACTIONS(2354),
    [anon_sym_signed] = ACTIONS(2352),
    [anon_sym_unsigned] = ACTIONS(2352),
    [anon_sym_long] = ACTIONS(2352),
    [anon_sym_short] = ACTIONS(2352),
    [anon_sym_LBRACK] = ACTIONS(2352),
    [anon_sym_static] = ACTIONS(2352),
    [anon_sym_register] = ACTIONS(2352),
    [anon_sym_inline] = ACTIONS(2352),
    [anon_sym___inline] = ACTIONS(2352),
    [anon_sym___inline__] = ACTIONS(2352),
    [anon_sym___forceinline] = ACTIONS(2352),
    [anon_sym_thread_local] = ACTIONS(2352),
    [anon_sym___thread] = ACTIONS(2352),
    [anon_sym_const] = ACTIONS(2352),
    [anon_sym_constexpr] = ACTIONS(2352),
    [anon_sym_volatile] = ACTIONS(2352),
    [anon_sym_restrict] = ACTIONS(2352),
    [anon_sym___restrict__] = ACTIONS(2352),
    [anon_sym__Atomic] = ACTIONS(2352),
    [anon_sym__Noreturn] = ACTIONS(2352),
    [anon_sym_noreturn] = ACTIONS(2352),
    [anon_sym_mutable] = ACTIONS(2352),
    [anon_sym_constinit] = ACTIONS(2352),
    [anon_sym_consteval] = ACTIONS(2352),
    [anon_sym___shared__] = ACTIONS(2352),
    [anon_sym___local__] = ACTIONS(2352),
    [anon_sym___constant__] = ACTIONS(2352),
    [anon_sym___managed__] = ACTIONS(2352),
    [anon_sym___grid_constant__] = ACTIONS(2352),
    [anon_sym_alignas] = ACTIONS(2352),
    [anon_sym__Alignas] = ACTIONS(2352),
    [sym_primitive_type] = ACTIONS(2352),
    [anon_sym_enum] = ACTIONS(2352),
    [anon_sym_class] = ACTIONS(2352),
    [anon_sym_struct] = ACTIONS(2352),
    [anon_sym_union] = ACTIONS(2352),
    [anon_sym_if] = ACTIONS(2352),
    [anon_sym_switch] = ACTIONS(2352),
    [anon_sym_case] = ACTIONS(2352),
    [anon_sym_default] = ACTIONS(2352),
    [anon_sym_while] = ACTIONS(2352),
    [anon_sym_do] = ACTIONS(2352),
    [anon_sym_for] = ACTIONS(2352),
    [anon_sym_return] = ACTIONS(2352),
    [anon_sym_break] = ACTIONS(2352),
    [anon_sym_continue] = ACTIONS(2352),
    [anon_sym_goto] = ACTIONS(2352),
    [anon_sym_not] = ACTIONS(2352),
    [anon_sym_compl] = ACTIONS(2352),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_sizeof] = ACTIONS(2352),
    [anon_sym___alignof__] = ACTIONS(2352),
    [anon_sym___alignof] = ACTIONS(2352),
    [anon_sym__alignof] = ACTIONS(2352),
    [anon_sym_alignof] = ACTIONS(2352),
    [anon_sym__Alignof] = ACTIONS(2352),
    [anon_sym_offsetof] = ACTIONS(2352),
    [anon_sym__Generic] = ACTIONS(2352),
    [anon_sym_asm] = ACTIONS(2352),
    [anon_sym___asm__] = ACTIONS(2352),
    [sym_number_literal] = ACTIONS(2354),
    [anon_sym_L_SQUOTE] = ACTIONS(2354),
    [anon_sym_u_SQUOTE] = ACTIONS(2354),
    [anon_sym_U_SQUOTE] = ACTIONS(2354),
    [anon_sym_u8_SQUOTE] = ACTIONS(2354),
    [anon_sym_SQUOTE] = ACTIONS(2354),
    [anon_sym_L_DQUOTE] = ACTIONS(2354),
    [anon_sym_u_DQUOTE] = ACTIONS(2354),
    [anon_sym_U_DQUOTE] = ACTIONS(2354),
    [anon_sym_u8_DQUOTE] = ACTIONS(2354),
    [anon_sym_DQUOTE] = ACTIONS(2354),
    [sym_true] = ACTIONS(2352),
    [sym_false] = ACTIONS(2352),
    [anon_sym_NULL] = ACTIONS(2352),
    [anon_sym_nullptr] = ACTIONS(2352),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2352),
    [anon_sym_decltype] = ACTIONS(2352),
    [sym_virtual] = ACTIONS(2352),
    [anon_sym_explicit] = ACTIONS(2352),
    [anon_sym_typename] = ACTIONS(2352),
    [anon_sym_template] = ACTIONS(2352),
    [anon_sym_operator] = ACTIONS(2352),
    [anon_sym_try] = ACTIONS(2352),
    [anon_sym_delete] = ACTIONS(2352),
    [anon_sym_throw] = ACTIONS(2352),
    [anon_sym_namespace] = ACTIONS(2352),
    [anon_sym_using] = ACTIONS(2352),
    [anon_sym_static_assert] = ACTIONS(2352),
    [anon_sym_concept] = ACTIONS(2352),
    [anon_sym_co_return] = ACTIONS(2352),
    [anon_sym_co_yield] = ACTIONS(2352),
    [anon_sym_R_DQUOTE] = ACTIONS(2354),
    [anon_sym_LR_DQUOTE] = ACTIONS(2354),
    [anon_sym_uR_DQUOTE] = ACTIONS(2354),
    [anon_sym_UR_DQUOTE] = ACTIONS(2354),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2354),
    [anon_sym_co_await] = ACTIONS(2352),
    [anon_sym_new] = ACTIONS(2352),
    [anon_sym_requires] = ACTIONS(2352),
    [sym_this] = ACTIONS(2352),
    [anon_sym___launch_bounds__] = ACTIONS(2352),
  },
  [685] = {
    [ts_builtin_sym_end] = ACTIONS(2314),
    [sym_identifier] = ACTIONS(2312),
    [aux_sym_preproc_include_token1] = ACTIONS(2312),
    [aux_sym_preproc_def_token1] = ACTIONS(2312),
    [aux_sym_preproc_if_token1] = ACTIONS(2312),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2312),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2312),
    [sym_preproc_directive] = ACTIONS(2312),
    [anon_sym_LPAREN2] = ACTIONS(2314),
    [anon_sym_BANG] = ACTIONS(2314),
    [anon_sym_TILDE] = ACTIONS(2314),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_AMP_AMP] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym___extension__] = ACTIONS(2312),
    [anon_sym_typedef] = ACTIONS(2312),
    [anon_sym___device__] = ACTIONS(2312),
    [anon_sym___host__] = ACTIONS(2312),
    [anon_sym___global__] = ACTIONS(2312),
    [anon_sym___forceinline__] = ACTIONS(2312),
    [anon_sym___noinline__] = ACTIONS(2312),
    [anon_sym_extern] = ACTIONS(2312),
    [anon_sym___attribute__] = ACTIONS(2312),
    [anon_sym_COLON_COLON] = ACTIONS(2314),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2314),
    [anon_sym___declspec] = ACTIONS(2312),
    [anon_sym___based] = ACTIONS(2312),
    [anon_sym___cdecl] = ACTIONS(2312),
    [anon_sym___clrcall] = ACTIONS(2312),
    [anon_sym___stdcall] = ACTIONS(2312),
    [anon_sym___fastcall] = ACTIONS(2312),
    [anon_sym___thiscall] = ACTIONS(2312),
    [anon_sym___vectorcall] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_signed] = ACTIONS(2312),
    [anon_sym_unsigned] = ACTIONS(2312),
    [anon_sym_long] = ACTIONS(2312),
    [anon_sym_short] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2312),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_register] = ACTIONS(2312),
    [anon_sym_inline] = ACTIONS(2312),
    [anon_sym___inline] = ACTIONS(2312),
    [anon_sym___inline__] = ACTIONS(2312),
    [anon_sym___forceinline] = ACTIONS(2312),
    [anon_sym_thread_local] = ACTIONS(2312),
    [anon_sym___thread] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_constexpr] = ACTIONS(2312),
    [anon_sym_volatile] = ACTIONS(2312),
    [anon_sym_restrict] = ACTIONS(2312),
    [anon_sym___restrict__] = ACTIONS(2312),
    [anon_sym__Atomic] = ACTIONS(2312),
    [anon_sym__Noreturn] = ACTIONS(2312),
    [anon_sym_noreturn] = ACTIONS(2312),
    [anon_sym_mutable] = ACTIONS(2312),
    [anon_sym_constinit] = ACTIONS(2312),
    [anon_sym_consteval] = ACTIONS(2312),
    [anon_sym___shared__] = ACTIONS(2312),
    [anon_sym___local__] = ACTIONS(2312),
    [anon_sym___constant__] = ACTIONS(2312),
    [anon_sym___managed__] = ACTIONS(2312),
    [anon_sym___grid_constant__] = ACTIONS(2312),
    [anon_sym_alignas] = ACTIONS(2312),
    [anon_sym__Alignas] = ACTIONS(2312),
    [sym_primitive_type] = ACTIONS(2312),
    [anon_sym_enum] = ACTIONS(2312),
    [anon_sym_class] = ACTIONS(2312),
    [anon_sym_struct] = ACTIONS(2312),
    [anon_sym_union] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_switch] = ACTIONS(2312),
    [anon_sym_case] = ACTIONS(2312),
    [anon_sym_default] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_break] = ACTIONS(2312),
    [anon_sym_continue] = ACTIONS(2312),
    [anon_sym_goto] = ACTIONS(2312),
    [anon_sym_not] = ACTIONS(2312),
    [anon_sym_compl] = ACTIONS(2312),
    [anon_sym_DASH_DASH] = ACTIONS(2314),
    [anon_sym_PLUS_PLUS] = ACTIONS(2314),
    [anon_sym_sizeof] = ACTIONS(2312),
    [anon_sym___alignof__] = ACTIONS(2312),
    [anon_sym___alignof] = ACTIONS(2312),
    [anon_sym__alignof] = ACTIONS(2312),
    [anon_sym_alignof] = ACTIONS(2312),
    [anon_sym__Alignof] = ACTIONS(2312),
    [anon_sym_offsetof] = ACTIONS(2312),
    [anon_sym__Generic] = ACTIONS(2312),
    [anon_sym_asm] = ACTIONS(2312),
    [anon_sym___asm__] = ACTIONS(2312),
    [sym_number_literal] = ACTIONS(2314),
    [anon_sym_L_SQUOTE] = ACTIONS(2314),
    [anon_sym_u_SQUOTE] = ACTIONS(2314),
    [anon_sym_U_SQUOTE] = ACTIONS(2314),
    [anon_sym_u8_SQUOTE] = ACTIONS(2314),
    [anon_sym_SQUOTE] = ACTIONS(2314),
    [anon_sym_L_DQUOTE] = ACTIONS(2314),
    [anon_sym_u_DQUOTE] = ACTIONS(2314),
    [anon_sym_U_DQUOTE] = ACTIONS(2314),
    [anon_sym_u8_DQUOTE] = ACTIONS(2314),
    [anon_sym_DQUOTE] = ACTIONS(2314),
    [sym_true] = ACTIONS(2312),
    [sym_false] = ACTIONS(2312),
    [anon_sym_NULL] = ACTIONS(2312),
    [anon_sym_nullptr] = ACTIONS(2312),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2312),
    [anon_sym_decltype] = ACTIONS(2312),
    [sym_virtual] = ACTIONS(2312),
    [anon_sym_explicit] = ACTIONS(2312),
    [anon_sym_typename] = ACTIONS(2312),
    [anon_sym_template] = ACTIONS(2312),
    [anon_sym_operator] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_delete] = ACTIONS(2312),
    [anon_sym_throw] = ACTIONS(2312),
    [anon_sym_namespace] = ACTIONS(2312),
    [anon_sym_using] = ACTIONS(2312),
    [anon_sym_static_assert] = ACTIONS(2312),
    [anon_sym_concept] = ACTIONS(2312),
    [anon_sym_co_return] = ACTIONS(2312),
    [anon_sym_co_yield] = ACTIONS(2312),
    [anon_sym_R_DQUOTE] = ACTIONS(2314),
    [anon_sym_LR_DQUOTE] = ACTIONS(2314),
    [anon_sym_uR_DQUOTE] = ACTIONS(2314),
    [anon_sym_UR_DQUOTE] = ACTIONS(2314),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2314),
    [anon_sym_co_await] = ACTIONS(2312),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_requires] = ACTIONS(2312),
    [sym_this] = ACTIONS(2312),
    [anon_sym___launch_bounds__] = ACTIONS(2312),
  },
  [686] = {
    [sym_preproc_def] = STATE(705),
    [sym_preproc_function_def] = STATE(705),
    [sym_preproc_call] = STATE(705),
    [sym_preproc_if_in_field_declaration_list] = STATE(705),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(705),
    [sym_type_definition] = STATE(705),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5894),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6463),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(705),
    [sym_field_declaration] = STATE(705),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1708),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(705),
    [sym_operator_cast] = STATE(6999),
    [sym_inline_method_definition] = STATE(705),
    [sym__constructor_specifiers] = STATE(1708),
    [sym_operator_cast_definition] = STATE(705),
    [sym_operator_cast_declaration] = STATE(705),
    [sym_constructor_or_destructor_definition] = STATE(705),
    [sym_constructor_or_destructor_declaration] = STATE(705),
    [sym_friend_declaration] = STATE(705),
    [sym_access_specifier] = STATE(8255),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(705),
    [sym_alias_declaration] = STATE(705),
    [sym_static_assert_declaration] = STATE(705),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6999),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(705),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1708),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3376),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3378),
    [sym_preproc_directive] = ACTIONS(3380),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(3382),
    [anon_sym_typedef] = ACTIONS(3384),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3400),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3390),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(3392),
    [anon_sym_static_assert] = ACTIONS(3394),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [687] = {
    [ts_builtin_sym_end] = ACTIONS(2318),
    [sym_identifier] = ACTIONS(2316),
    [aux_sym_preproc_include_token1] = ACTIONS(2316),
    [aux_sym_preproc_def_token1] = ACTIONS(2316),
    [aux_sym_preproc_if_token1] = ACTIONS(2316),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2316),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2316),
    [sym_preproc_directive] = ACTIONS(2316),
    [anon_sym_LPAREN2] = ACTIONS(2318),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2318),
    [anon_sym_DASH] = ACTIONS(2316),
    [anon_sym_PLUS] = ACTIONS(2316),
    [anon_sym_STAR] = ACTIONS(2318),
    [anon_sym_AMP_AMP] = ACTIONS(2318),
    [anon_sym_AMP] = ACTIONS(2316),
    [anon_sym___extension__] = ACTIONS(2316),
    [anon_sym_typedef] = ACTIONS(2316),
    [anon_sym___device__] = ACTIONS(2316),
    [anon_sym___host__] = ACTIONS(2316),
    [anon_sym___global__] = ACTIONS(2316),
    [anon_sym___forceinline__] = ACTIONS(2316),
    [anon_sym___noinline__] = ACTIONS(2316),
    [anon_sym_extern] = ACTIONS(2316),
    [anon_sym___attribute__] = ACTIONS(2316),
    [anon_sym_COLON_COLON] = ACTIONS(2318),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2318),
    [anon_sym___declspec] = ACTIONS(2316),
    [anon_sym___based] = ACTIONS(2316),
    [anon_sym___cdecl] = ACTIONS(2316),
    [anon_sym___clrcall] = ACTIONS(2316),
    [anon_sym___stdcall] = ACTIONS(2316),
    [anon_sym___fastcall] = ACTIONS(2316),
    [anon_sym___thiscall] = ACTIONS(2316),
    [anon_sym___vectorcall] = ACTIONS(2316),
    [anon_sym_LBRACE] = ACTIONS(2318),
    [anon_sym_signed] = ACTIONS(2316),
    [anon_sym_unsigned] = ACTIONS(2316),
    [anon_sym_long] = ACTIONS(2316),
    [anon_sym_short] = ACTIONS(2316),
    [anon_sym_LBRACK] = ACTIONS(2316),
    [anon_sym_static] = ACTIONS(2316),
    [anon_sym_register] = ACTIONS(2316),
    [anon_sym_inline] = ACTIONS(2316),
    [anon_sym___inline] = ACTIONS(2316),
    [anon_sym___inline__] = ACTIONS(2316),
    [anon_sym___forceinline] = ACTIONS(2316),
    [anon_sym_thread_local] = ACTIONS(2316),
    [anon_sym___thread] = ACTIONS(2316),
    [anon_sym_const] = ACTIONS(2316),
    [anon_sym_constexpr] = ACTIONS(2316),
    [anon_sym_volatile] = ACTIONS(2316),
    [anon_sym_restrict] = ACTIONS(2316),
    [anon_sym___restrict__] = ACTIONS(2316),
    [anon_sym__Atomic] = ACTIONS(2316),
    [anon_sym__Noreturn] = ACTIONS(2316),
    [anon_sym_noreturn] = ACTIONS(2316),
    [anon_sym_mutable] = ACTIONS(2316),
    [anon_sym_constinit] = ACTIONS(2316),
    [anon_sym_consteval] = ACTIONS(2316),
    [anon_sym___shared__] = ACTIONS(2316),
    [anon_sym___local__] = ACTIONS(2316),
    [anon_sym___constant__] = ACTIONS(2316),
    [anon_sym___managed__] = ACTIONS(2316),
    [anon_sym___grid_constant__] = ACTIONS(2316),
    [anon_sym_alignas] = ACTIONS(2316),
    [anon_sym__Alignas] = ACTIONS(2316),
    [sym_primitive_type] = ACTIONS(2316),
    [anon_sym_enum] = ACTIONS(2316),
    [anon_sym_class] = ACTIONS(2316),
    [anon_sym_struct] = ACTIONS(2316),
    [anon_sym_union] = ACTIONS(2316),
    [anon_sym_if] = ACTIONS(2316),
    [anon_sym_switch] = ACTIONS(2316),
    [anon_sym_case] = ACTIONS(2316),
    [anon_sym_default] = ACTIONS(2316),
    [anon_sym_while] = ACTIONS(2316),
    [anon_sym_do] = ACTIONS(2316),
    [anon_sym_for] = ACTIONS(2316),
    [anon_sym_return] = ACTIONS(2316),
    [anon_sym_break] = ACTIONS(2316),
    [anon_sym_continue] = ACTIONS(2316),
    [anon_sym_goto] = ACTIONS(2316),
    [anon_sym_not] = ACTIONS(2316),
    [anon_sym_compl] = ACTIONS(2316),
    [anon_sym_DASH_DASH] = ACTIONS(2318),
    [anon_sym_PLUS_PLUS] = ACTIONS(2318),
    [anon_sym_sizeof] = ACTIONS(2316),
    [anon_sym___alignof__] = ACTIONS(2316),
    [anon_sym___alignof] = ACTIONS(2316),
    [anon_sym__alignof] = ACTIONS(2316),
    [anon_sym_alignof] = ACTIONS(2316),
    [anon_sym__Alignof] = ACTIONS(2316),
    [anon_sym_offsetof] = ACTIONS(2316),
    [anon_sym__Generic] = ACTIONS(2316),
    [anon_sym_asm] = ACTIONS(2316),
    [anon_sym___asm__] = ACTIONS(2316),
    [sym_number_literal] = ACTIONS(2318),
    [anon_sym_L_SQUOTE] = ACTIONS(2318),
    [anon_sym_u_SQUOTE] = ACTIONS(2318),
    [anon_sym_U_SQUOTE] = ACTIONS(2318),
    [anon_sym_u8_SQUOTE] = ACTIONS(2318),
    [anon_sym_SQUOTE] = ACTIONS(2318),
    [anon_sym_L_DQUOTE] = ACTIONS(2318),
    [anon_sym_u_DQUOTE] = ACTIONS(2318),
    [anon_sym_U_DQUOTE] = ACTIONS(2318),
    [anon_sym_u8_DQUOTE] = ACTIONS(2318),
    [anon_sym_DQUOTE] = ACTIONS(2318),
    [sym_true] = ACTIONS(2316),
    [sym_false] = ACTIONS(2316),
    [anon_sym_NULL] = ACTIONS(2316),
    [anon_sym_nullptr] = ACTIONS(2316),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2316),
    [anon_sym_decltype] = ACTIONS(2316),
    [sym_virtual] = ACTIONS(2316),
    [anon_sym_explicit] = ACTIONS(2316),
    [anon_sym_typename] = ACTIONS(2316),
    [anon_sym_template] = ACTIONS(2316),
    [anon_sym_operator] = ACTIONS(2316),
    [anon_sym_try] = ACTIONS(2316),
    [anon_sym_delete] = ACTIONS(2316),
    [anon_sym_throw] = ACTIONS(2316),
    [anon_sym_namespace] = ACTIONS(2316),
    [anon_sym_using] = ACTIONS(2316),
    [anon_sym_static_assert] = ACTIONS(2316),
    [anon_sym_concept] = ACTIONS(2316),
    [anon_sym_co_return] = ACTIONS(2316),
    [anon_sym_co_yield] = ACTIONS(2316),
    [anon_sym_R_DQUOTE] = ACTIONS(2318),
    [anon_sym_LR_DQUOTE] = ACTIONS(2318),
    [anon_sym_uR_DQUOTE] = ACTIONS(2318),
    [anon_sym_UR_DQUOTE] = ACTIONS(2318),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2318),
    [anon_sym_co_await] = ACTIONS(2316),
    [anon_sym_new] = ACTIONS(2316),
    [anon_sym_requires] = ACTIONS(2316),
    [sym_this] = ACTIONS(2316),
    [anon_sym___launch_bounds__] = ACTIONS(2316),
  },
  [688] = {
    [ts_builtin_sym_end] = ACTIONS(2364),
    [sym_identifier] = ACTIONS(2362),
    [aux_sym_preproc_include_token1] = ACTIONS(2362),
    [aux_sym_preproc_def_token1] = ACTIONS(2362),
    [aux_sym_preproc_if_token1] = ACTIONS(2362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2362),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2362),
    [sym_preproc_directive] = ACTIONS(2362),
    [anon_sym_LPAREN2] = ACTIONS(2364),
    [anon_sym_BANG] = ACTIONS(2364),
    [anon_sym_TILDE] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2362),
    [anon_sym_PLUS] = ACTIONS(2362),
    [anon_sym_STAR] = ACTIONS(2364),
    [anon_sym_AMP_AMP] = ACTIONS(2364),
    [anon_sym_AMP] = ACTIONS(2362),
    [anon_sym___extension__] = ACTIONS(2362),
    [anon_sym_typedef] = ACTIONS(2362),
    [anon_sym___device__] = ACTIONS(2362),
    [anon_sym___host__] = ACTIONS(2362),
    [anon_sym___global__] = ACTIONS(2362),
    [anon_sym___forceinline__] = ACTIONS(2362),
    [anon_sym___noinline__] = ACTIONS(2362),
    [anon_sym_extern] = ACTIONS(2362),
    [anon_sym___attribute__] = ACTIONS(2362),
    [anon_sym_COLON_COLON] = ACTIONS(2364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2364),
    [anon_sym___declspec] = ACTIONS(2362),
    [anon_sym___based] = ACTIONS(2362),
    [anon_sym___cdecl] = ACTIONS(2362),
    [anon_sym___clrcall] = ACTIONS(2362),
    [anon_sym___stdcall] = ACTIONS(2362),
    [anon_sym___fastcall] = ACTIONS(2362),
    [anon_sym___thiscall] = ACTIONS(2362),
    [anon_sym___vectorcall] = ACTIONS(2362),
    [anon_sym_LBRACE] = ACTIONS(2364),
    [anon_sym_signed] = ACTIONS(2362),
    [anon_sym_unsigned] = ACTIONS(2362),
    [anon_sym_long] = ACTIONS(2362),
    [anon_sym_short] = ACTIONS(2362),
    [anon_sym_LBRACK] = ACTIONS(2362),
    [anon_sym_static] = ACTIONS(2362),
    [anon_sym_register] = ACTIONS(2362),
    [anon_sym_inline] = ACTIONS(2362),
    [anon_sym___inline] = ACTIONS(2362),
    [anon_sym___inline__] = ACTIONS(2362),
    [anon_sym___forceinline] = ACTIONS(2362),
    [anon_sym_thread_local] = ACTIONS(2362),
    [anon_sym___thread] = ACTIONS(2362),
    [anon_sym_const] = ACTIONS(2362),
    [anon_sym_constexpr] = ACTIONS(2362),
    [anon_sym_volatile] = ACTIONS(2362),
    [anon_sym_restrict] = ACTIONS(2362),
    [anon_sym___restrict__] = ACTIONS(2362),
    [anon_sym__Atomic] = ACTIONS(2362),
    [anon_sym__Noreturn] = ACTIONS(2362),
    [anon_sym_noreturn] = ACTIONS(2362),
    [anon_sym_mutable] = ACTIONS(2362),
    [anon_sym_constinit] = ACTIONS(2362),
    [anon_sym_consteval] = ACTIONS(2362),
    [anon_sym___shared__] = ACTIONS(2362),
    [anon_sym___local__] = ACTIONS(2362),
    [anon_sym___constant__] = ACTIONS(2362),
    [anon_sym___managed__] = ACTIONS(2362),
    [anon_sym___grid_constant__] = ACTIONS(2362),
    [anon_sym_alignas] = ACTIONS(2362),
    [anon_sym__Alignas] = ACTIONS(2362),
    [sym_primitive_type] = ACTIONS(2362),
    [anon_sym_enum] = ACTIONS(2362),
    [anon_sym_class] = ACTIONS(2362),
    [anon_sym_struct] = ACTIONS(2362),
    [anon_sym_union] = ACTIONS(2362),
    [anon_sym_if] = ACTIONS(2362),
    [anon_sym_switch] = ACTIONS(2362),
    [anon_sym_case] = ACTIONS(2362),
    [anon_sym_default] = ACTIONS(2362),
    [anon_sym_while] = ACTIONS(2362),
    [anon_sym_do] = ACTIONS(2362),
    [anon_sym_for] = ACTIONS(2362),
    [anon_sym_return] = ACTIONS(2362),
    [anon_sym_break] = ACTIONS(2362),
    [anon_sym_continue] = ACTIONS(2362),
    [anon_sym_goto] = ACTIONS(2362),
    [anon_sym_not] = ACTIONS(2362),
    [anon_sym_compl] = ACTIONS(2362),
    [anon_sym_DASH_DASH] = ACTIONS(2364),
    [anon_sym_PLUS_PLUS] = ACTIONS(2364),
    [anon_sym_sizeof] = ACTIONS(2362),
    [anon_sym___alignof__] = ACTIONS(2362),
    [anon_sym___alignof] = ACTIONS(2362),
    [anon_sym__alignof] = ACTIONS(2362),
    [anon_sym_alignof] = ACTIONS(2362),
    [anon_sym__Alignof] = ACTIONS(2362),
    [anon_sym_offsetof] = ACTIONS(2362),
    [anon_sym__Generic] = ACTIONS(2362),
    [anon_sym_asm] = ACTIONS(2362),
    [anon_sym___asm__] = ACTIONS(2362),
    [sym_number_literal] = ACTIONS(2364),
    [anon_sym_L_SQUOTE] = ACTIONS(2364),
    [anon_sym_u_SQUOTE] = ACTIONS(2364),
    [anon_sym_U_SQUOTE] = ACTIONS(2364),
    [anon_sym_u8_SQUOTE] = ACTIONS(2364),
    [anon_sym_SQUOTE] = ACTIONS(2364),
    [anon_sym_L_DQUOTE] = ACTIONS(2364),
    [anon_sym_u_DQUOTE] = ACTIONS(2364),
    [anon_sym_U_DQUOTE] = ACTIONS(2364),
    [anon_sym_u8_DQUOTE] = ACTIONS(2364),
    [anon_sym_DQUOTE] = ACTIONS(2364),
    [sym_true] = ACTIONS(2362),
    [sym_false] = ACTIONS(2362),
    [anon_sym_NULL] = ACTIONS(2362),
    [anon_sym_nullptr] = ACTIONS(2362),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2362),
    [anon_sym_decltype] = ACTIONS(2362),
    [sym_virtual] = ACTIONS(2362),
    [anon_sym_explicit] = ACTIONS(2362),
    [anon_sym_typename] = ACTIONS(2362),
    [anon_sym_template] = ACTIONS(2362),
    [anon_sym_operator] = ACTIONS(2362),
    [anon_sym_try] = ACTIONS(2362),
    [anon_sym_delete] = ACTIONS(2362),
    [anon_sym_throw] = ACTIONS(2362),
    [anon_sym_namespace] = ACTIONS(2362),
    [anon_sym_using] = ACTIONS(2362),
    [anon_sym_static_assert] = ACTIONS(2362),
    [anon_sym_concept] = ACTIONS(2362),
    [anon_sym_co_return] = ACTIONS(2362),
    [anon_sym_co_yield] = ACTIONS(2362),
    [anon_sym_R_DQUOTE] = ACTIONS(2364),
    [anon_sym_LR_DQUOTE] = ACTIONS(2364),
    [anon_sym_uR_DQUOTE] = ACTIONS(2364),
    [anon_sym_UR_DQUOTE] = ACTIONS(2364),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2364),
    [anon_sym_co_await] = ACTIONS(2362),
    [anon_sym_new] = ACTIONS(2362),
    [anon_sym_requires] = ACTIONS(2362),
    [sym_this] = ACTIONS(2362),
    [anon_sym___launch_bounds__] = ACTIONS(2362),
  },
  [689] = {
    [ts_builtin_sym_end] = ACTIONS(2201),
    [sym_identifier] = ACTIONS(2199),
    [aux_sym_preproc_include_token1] = ACTIONS(2199),
    [aux_sym_preproc_def_token1] = ACTIONS(2199),
    [aux_sym_preproc_if_token1] = ACTIONS(2199),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2199),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2199),
    [sym_preproc_directive] = ACTIONS(2199),
    [anon_sym_LPAREN2] = ACTIONS(2201),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2199),
    [anon_sym_PLUS] = ACTIONS(2199),
    [anon_sym_STAR] = ACTIONS(2201),
    [anon_sym_AMP_AMP] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2199),
    [anon_sym___extension__] = ACTIONS(2199),
    [anon_sym_typedef] = ACTIONS(2199),
    [anon_sym___device__] = ACTIONS(2199),
    [anon_sym___host__] = ACTIONS(2199),
    [anon_sym___global__] = ACTIONS(2199),
    [anon_sym___forceinline__] = ACTIONS(2199),
    [anon_sym___noinline__] = ACTIONS(2199),
    [anon_sym_extern] = ACTIONS(2199),
    [anon_sym___attribute__] = ACTIONS(2199),
    [anon_sym_COLON_COLON] = ACTIONS(2201),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2201),
    [anon_sym___declspec] = ACTIONS(2199),
    [anon_sym___based] = ACTIONS(2199),
    [anon_sym___cdecl] = ACTIONS(2199),
    [anon_sym___clrcall] = ACTIONS(2199),
    [anon_sym___stdcall] = ACTIONS(2199),
    [anon_sym___fastcall] = ACTIONS(2199),
    [anon_sym___thiscall] = ACTIONS(2199),
    [anon_sym___vectorcall] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(2201),
    [anon_sym_signed] = ACTIONS(2199),
    [anon_sym_unsigned] = ACTIONS(2199),
    [anon_sym_long] = ACTIONS(2199),
    [anon_sym_short] = ACTIONS(2199),
    [anon_sym_LBRACK] = ACTIONS(2199),
    [anon_sym_static] = ACTIONS(2199),
    [anon_sym_register] = ACTIONS(2199),
    [anon_sym_inline] = ACTIONS(2199),
    [anon_sym___inline] = ACTIONS(2199),
    [anon_sym___inline__] = ACTIONS(2199),
    [anon_sym___forceinline] = ACTIONS(2199),
    [anon_sym_thread_local] = ACTIONS(2199),
    [anon_sym___thread] = ACTIONS(2199),
    [anon_sym_const] = ACTIONS(2199),
    [anon_sym_constexpr] = ACTIONS(2199),
    [anon_sym_volatile] = ACTIONS(2199),
    [anon_sym_restrict] = ACTIONS(2199),
    [anon_sym___restrict__] = ACTIONS(2199),
    [anon_sym__Atomic] = ACTIONS(2199),
    [anon_sym__Noreturn] = ACTIONS(2199),
    [anon_sym_noreturn] = ACTIONS(2199),
    [anon_sym_mutable] = ACTIONS(2199),
    [anon_sym_constinit] = ACTIONS(2199),
    [anon_sym_consteval] = ACTIONS(2199),
    [anon_sym___shared__] = ACTIONS(2199),
    [anon_sym___local__] = ACTIONS(2199),
    [anon_sym___constant__] = ACTIONS(2199),
    [anon_sym___managed__] = ACTIONS(2199),
    [anon_sym___grid_constant__] = ACTIONS(2199),
    [anon_sym_alignas] = ACTIONS(2199),
    [anon_sym__Alignas] = ACTIONS(2199),
    [sym_primitive_type] = ACTIONS(2199),
    [anon_sym_enum] = ACTIONS(2199),
    [anon_sym_class] = ACTIONS(2199),
    [anon_sym_struct] = ACTIONS(2199),
    [anon_sym_union] = ACTIONS(2199),
    [anon_sym_if] = ACTIONS(2199),
    [anon_sym_switch] = ACTIONS(2199),
    [anon_sym_case] = ACTIONS(2199),
    [anon_sym_default] = ACTIONS(2199),
    [anon_sym_while] = ACTIONS(2199),
    [anon_sym_do] = ACTIONS(2199),
    [anon_sym_for] = ACTIONS(2199),
    [anon_sym_return] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2199),
    [anon_sym_continue] = ACTIONS(2199),
    [anon_sym_goto] = ACTIONS(2199),
    [anon_sym_not] = ACTIONS(2199),
    [anon_sym_compl] = ACTIONS(2199),
    [anon_sym_DASH_DASH] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2201),
    [anon_sym_sizeof] = ACTIONS(2199),
    [anon_sym___alignof__] = ACTIONS(2199),
    [anon_sym___alignof] = ACTIONS(2199),
    [anon_sym__alignof] = ACTIONS(2199),
    [anon_sym_alignof] = ACTIONS(2199),
    [anon_sym__Alignof] = ACTIONS(2199),
    [anon_sym_offsetof] = ACTIONS(2199),
    [anon_sym__Generic] = ACTIONS(2199),
    [anon_sym_asm] = ACTIONS(2199),
    [anon_sym___asm__] = ACTIONS(2199),
    [sym_number_literal] = ACTIONS(2201),
    [anon_sym_L_SQUOTE] = ACTIONS(2201),
    [anon_sym_u_SQUOTE] = ACTIONS(2201),
    [anon_sym_U_SQUOTE] = ACTIONS(2201),
    [anon_sym_u8_SQUOTE] = ACTIONS(2201),
    [anon_sym_SQUOTE] = ACTIONS(2201),
    [anon_sym_L_DQUOTE] = ACTIONS(2201),
    [anon_sym_u_DQUOTE] = ACTIONS(2201),
    [anon_sym_U_DQUOTE] = ACTIONS(2201),
    [anon_sym_u8_DQUOTE] = ACTIONS(2201),
    [anon_sym_DQUOTE] = ACTIONS(2201),
    [sym_true] = ACTIONS(2199),
    [sym_false] = ACTIONS(2199),
    [anon_sym_NULL] = ACTIONS(2199),
    [anon_sym_nullptr] = ACTIONS(2199),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2199),
    [anon_sym_decltype] = ACTIONS(2199),
    [sym_virtual] = ACTIONS(2199),
    [anon_sym_explicit] = ACTIONS(2199),
    [anon_sym_typename] = ACTIONS(2199),
    [anon_sym_template] = ACTIONS(2199),
    [anon_sym_operator] = ACTIONS(2199),
    [anon_sym_try] = ACTIONS(2199),
    [anon_sym_delete] = ACTIONS(2199),
    [anon_sym_throw] = ACTIONS(2199),
    [anon_sym_namespace] = ACTIONS(2199),
    [anon_sym_using] = ACTIONS(2199),
    [anon_sym_static_assert] = ACTIONS(2199),
    [anon_sym_concept] = ACTIONS(2199),
    [anon_sym_co_return] = ACTIONS(2199),
    [anon_sym_co_yield] = ACTIONS(2199),
    [anon_sym_R_DQUOTE] = ACTIONS(2201),
    [anon_sym_LR_DQUOTE] = ACTIONS(2201),
    [anon_sym_uR_DQUOTE] = ACTIONS(2201),
    [anon_sym_UR_DQUOTE] = ACTIONS(2201),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2201),
    [anon_sym_co_await] = ACTIONS(2199),
    [anon_sym_new] = ACTIONS(2199),
    [anon_sym_requires] = ACTIONS(2199),
    [sym_this] = ACTIONS(2199),
    [anon_sym___launch_bounds__] = ACTIONS(2199),
  },
  [690] = {
    [sym_preproc_def] = STATE(701),
    [sym_preproc_function_def] = STATE(701),
    [sym_preproc_call] = STATE(701),
    [sym_preproc_if_in_field_declaration_list] = STATE(701),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(701),
    [sym_type_definition] = STATE(701),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5894),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6463),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(701),
    [sym_field_declaration] = STATE(701),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1708),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(701),
    [sym_operator_cast] = STATE(6999),
    [sym_inline_method_definition] = STATE(701),
    [sym__constructor_specifiers] = STATE(1708),
    [sym_operator_cast_definition] = STATE(701),
    [sym_operator_cast_declaration] = STATE(701),
    [sym_constructor_or_destructor_definition] = STATE(701),
    [sym_constructor_or_destructor_declaration] = STATE(701),
    [sym_friend_declaration] = STATE(701),
    [sym_access_specifier] = STATE(8255),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(701),
    [sym_alias_declaration] = STATE(701),
    [sym_static_assert_declaration] = STATE(701),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6999),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(701),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1708),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3376),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3378),
    [sym_preproc_directive] = ACTIONS(3380),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(3382),
    [anon_sym_typedef] = ACTIONS(3384),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3402),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3390),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(3392),
    [anon_sym_static_assert] = ACTIONS(3394),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [691] = {
    [ts_builtin_sym_end] = ACTIONS(3404),
    [sym_identifier] = ACTIONS(3407),
    [aux_sym_preproc_include_token1] = ACTIONS(3407),
    [aux_sym_preproc_def_token1] = ACTIONS(3407),
    [aux_sym_preproc_if_token1] = ACTIONS(3407),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3407),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3407),
    [sym_preproc_directive] = ACTIONS(3407),
    [anon_sym_LPAREN2] = ACTIONS(3404),
    [anon_sym_BANG] = ACTIONS(3404),
    [anon_sym_TILDE] = ACTIONS(3404),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3404),
    [anon_sym_AMP_AMP] = ACTIONS(3404),
    [anon_sym_AMP] = ACTIONS(3407),
    [anon_sym___extension__] = ACTIONS(3407),
    [anon_sym_typedef] = ACTIONS(3407),
    [anon_sym___device__] = ACTIONS(3407),
    [anon_sym___host__] = ACTIONS(3407),
    [anon_sym___global__] = ACTIONS(3407),
    [anon_sym___forceinline__] = ACTIONS(3407),
    [anon_sym___noinline__] = ACTIONS(3407),
    [anon_sym_extern] = ACTIONS(3407),
    [anon_sym___attribute__] = ACTIONS(3407),
    [anon_sym_COLON_COLON] = ACTIONS(3404),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3404),
    [anon_sym___declspec] = ACTIONS(3407),
    [anon_sym___based] = ACTIONS(3407),
    [anon_sym___cdecl] = ACTIONS(3407),
    [anon_sym___clrcall] = ACTIONS(3407),
    [anon_sym___stdcall] = ACTIONS(3407),
    [anon_sym___fastcall] = ACTIONS(3407),
    [anon_sym___thiscall] = ACTIONS(3407),
    [anon_sym___vectorcall] = ACTIONS(3407),
    [anon_sym_LBRACE] = ACTIONS(3404),
    [anon_sym_signed] = ACTIONS(3407),
    [anon_sym_unsigned] = ACTIONS(3407),
    [anon_sym_long] = ACTIONS(3407),
    [anon_sym_short] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_register] = ACTIONS(3407),
    [anon_sym_inline] = ACTIONS(3407),
    [anon_sym___inline] = ACTIONS(3407),
    [anon_sym___inline__] = ACTIONS(3407),
    [anon_sym___forceinline] = ACTIONS(3407),
    [anon_sym_thread_local] = ACTIONS(3407),
    [anon_sym___thread] = ACTIONS(3407),
    [anon_sym_const] = ACTIONS(3407),
    [anon_sym_constexpr] = ACTIONS(3407),
    [anon_sym_volatile] = ACTIONS(3407),
    [anon_sym_restrict] = ACTIONS(3407),
    [anon_sym___restrict__] = ACTIONS(3407),
    [anon_sym__Atomic] = ACTIONS(3407),
    [anon_sym__Noreturn] = ACTIONS(3407),
    [anon_sym_noreturn] = ACTIONS(3407),
    [anon_sym_mutable] = ACTIONS(3407),
    [anon_sym_constinit] = ACTIONS(3407),
    [anon_sym_consteval] = ACTIONS(3407),
    [anon_sym___shared__] = ACTIONS(3407),
    [anon_sym___local__] = ACTIONS(3407),
    [anon_sym___constant__] = ACTIONS(3407),
    [anon_sym___managed__] = ACTIONS(3407),
    [anon_sym___grid_constant__] = ACTIONS(3407),
    [anon_sym_alignas] = ACTIONS(3407),
    [anon_sym__Alignas] = ACTIONS(3407),
    [sym_primitive_type] = ACTIONS(3407),
    [anon_sym_enum] = ACTIONS(3407),
    [anon_sym_class] = ACTIONS(3407),
    [anon_sym_struct] = ACTIONS(3407),
    [anon_sym_union] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_switch] = ACTIONS(3407),
    [anon_sym_case] = ACTIONS(3407),
    [anon_sym_default] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_break] = ACTIONS(3407),
    [anon_sym_continue] = ACTIONS(3407),
    [anon_sym_goto] = ACTIONS(3407),
    [anon_sym_not] = ACTIONS(3407),
    [anon_sym_compl] = ACTIONS(3407),
    [anon_sym_DASH_DASH] = ACTIONS(3404),
    [anon_sym_PLUS_PLUS] = ACTIONS(3404),
    [anon_sym_sizeof] = ACTIONS(3407),
    [anon_sym___alignof__] = ACTIONS(3407),
    [anon_sym___alignof] = ACTIONS(3407),
    [anon_sym__alignof] = ACTIONS(3407),
    [anon_sym_alignof] = ACTIONS(3407),
    [anon_sym__Alignof] = ACTIONS(3407),
    [anon_sym_offsetof] = ACTIONS(3407),
    [anon_sym__Generic] = ACTIONS(3407),
    [anon_sym_asm] = ACTIONS(3407),
    [anon_sym___asm__] = ACTIONS(3407),
    [sym_number_literal] = ACTIONS(3404),
    [anon_sym_L_SQUOTE] = ACTIONS(3404),
    [anon_sym_u_SQUOTE] = ACTIONS(3404),
    [anon_sym_U_SQUOTE] = ACTIONS(3404),
    [anon_sym_u8_SQUOTE] = ACTIONS(3404),
    [anon_sym_SQUOTE] = ACTIONS(3404),
    [anon_sym_L_DQUOTE] = ACTIONS(3404),
    [anon_sym_u_DQUOTE] = ACTIONS(3404),
    [anon_sym_U_DQUOTE] = ACTIONS(3404),
    [anon_sym_u8_DQUOTE] = ACTIONS(3404),
    [anon_sym_DQUOTE] = ACTIONS(3404),
    [sym_true] = ACTIONS(3407),
    [sym_false] = ACTIONS(3407),
    [anon_sym_NULL] = ACTIONS(3407),
    [anon_sym_nullptr] = ACTIONS(3407),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3407),
    [anon_sym_decltype] = ACTIONS(3407),
    [sym_virtual] = ACTIONS(3407),
    [anon_sym_explicit] = ACTIONS(3407),
    [anon_sym_typename] = ACTIONS(3407),
    [anon_sym_template] = ACTIONS(3407),
    [anon_sym_operator] = ACTIONS(3407),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_delete] = ACTIONS(3407),
    [anon_sym_throw] = ACTIONS(3407),
    [anon_sym_namespace] = ACTIONS(3407),
    [anon_sym_using] = ACTIONS(3407),
    [anon_sym_static_assert] = ACTIONS(3407),
    [anon_sym_concept] = ACTIONS(3407),
    [anon_sym_co_return] = ACTIONS(3407),
    [anon_sym_co_yield] = ACTIONS(3407),
    [anon_sym_R_DQUOTE] = ACTIONS(3404),
    [anon_sym_LR_DQUOTE] = ACTIONS(3404),
    [anon_sym_uR_DQUOTE] = ACTIONS(3404),
    [anon_sym_UR_DQUOTE] = ACTIONS(3404),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3404),
    [anon_sym_co_await] = ACTIONS(3407),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_requires] = ACTIONS(3407),
    [sym_this] = ACTIONS(3407),
    [anon_sym___launch_bounds__] = ACTIONS(3407),
  },
  [692] = {
    [ts_builtin_sym_end] = ACTIONS(2261),
    [sym_identifier] = ACTIONS(2259),
    [aux_sym_preproc_include_token1] = ACTIONS(2259),
    [aux_sym_preproc_def_token1] = ACTIONS(2259),
    [aux_sym_preproc_if_token1] = ACTIONS(2259),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2259),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2259),
    [sym_preproc_directive] = ACTIONS(2259),
    [anon_sym_LPAREN2] = ACTIONS(2261),
    [anon_sym_BANG] = ACTIONS(2261),
    [anon_sym_TILDE] = ACTIONS(2261),
    [anon_sym_DASH] = ACTIONS(2259),
    [anon_sym_PLUS] = ACTIONS(2259),
    [anon_sym_STAR] = ACTIONS(2261),
    [anon_sym_AMP_AMP] = ACTIONS(2261),
    [anon_sym_AMP] = ACTIONS(2259),
    [anon_sym___extension__] = ACTIONS(2259),
    [anon_sym_typedef] = ACTIONS(2259),
    [anon_sym___device__] = ACTIONS(2259),
    [anon_sym___host__] = ACTIONS(2259),
    [anon_sym___global__] = ACTIONS(2259),
    [anon_sym___forceinline__] = ACTIONS(2259),
    [anon_sym___noinline__] = ACTIONS(2259),
    [anon_sym_extern] = ACTIONS(2259),
    [anon_sym___attribute__] = ACTIONS(2259),
    [anon_sym_COLON_COLON] = ACTIONS(2261),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2261),
    [anon_sym___declspec] = ACTIONS(2259),
    [anon_sym___based] = ACTIONS(2259),
    [anon_sym___cdecl] = ACTIONS(2259),
    [anon_sym___clrcall] = ACTIONS(2259),
    [anon_sym___stdcall] = ACTIONS(2259),
    [anon_sym___fastcall] = ACTIONS(2259),
    [anon_sym___thiscall] = ACTIONS(2259),
    [anon_sym___vectorcall] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(2261),
    [anon_sym_signed] = ACTIONS(2259),
    [anon_sym_unsigned] = ACTIONS(2259),
    [anon_sym_long] = ACTIONS(2259),
    [anon_sym_short] = ACTIONS(2259),
    [anon_sym_LBRACK] = ACTIONS(2259),
    [anon_sym_static] = ACTIONS(2259),
    [anon_sym_register] = ACTIONS(2259),
    [anon_sym_inline] = ACTIONS(2259),
    [anon_sym___inline] = ACTIONS(2259),
    [anon_sym___inline__] = ACTIONS(2259),
    [anon_sym___forceinline] = ACTIONS(2259),
    [anon_sym_thread_local] = ACTIONS(2259),
    [anon_sym___thread] = ACTIONS(2259),
    [anon_sym_const] = ACTIONS(2259),
    [anon_sym_constexpr] = ACTIONS(2259),
    [anon_sym_volatile] = ACTIONS(2259),
    [anon_sym_restrict] = ACTIONS(2259),
    [anon_sym___restrict__] = ACTIONS(2259),
    [anon_sym__Atomic] = ACTIONS(2259),
    [anon_sym__Noreturn] = ACTIONS(2259),
    [anon_sym_noreturn] = ACTIONS(2259),
    [anon_sym_mutable] = ACTIONS(2259),
    [anon_sym_constinit] = ACTIONS(2259),
    [anon_sym_consteval] = ACTIONS(2259),
    [anon_sym___shared__] = ACTIONS(2259),
    [anon_sym___local__] = ACTIONS(2259),
    [anon_sym___constant__] = ACTIONS(2259),
    [anon_sym___managed__] = ACTIONS(2259),
    [anon_sym___grid_constant__] = ACTIONS(2259),
    [anon_sym_alignas] = ACTIONS(2259),
    [anon_sym__Alignas] = ACTIONS(2259),
    [sym_primitive_type] = ACTIONS(2259),
    [anon_sym_enum] = ACTIONS(2259),
    [anon_sym_class] = ACTIONS(2259),
    [anon_sym_struct] = ACTIONS(2259),
    [anon_sym_union] = ACTIONS(2259),
    [anon_sym_if] = ACTIONS(2259),
    [anon_sym_switch] = ACTIONS(2259),
    [anon_sym_case] = ACTIONS(2259),
    [anon_sym_default] = ACTIONS(2259),
    [anon_sym_while] = ACTIONS(2259),
    [anon_sym_do] = ACTIONS(2259),
    [anon_sym_for] = ACTIONS(2259),
    [anon_sym_return] = ACTIONS(2259),
    [anon_sym_break] = ACTIONS(2259),
    [anon_sym_continue] = ACTIONS(2259),
    [anon_sym_goto] = ACTIONS(2259),
    [anon_sym_not] = ACTIONS(2259),
    [anon_sym_compl] = ACTIONS(2259),
    [anon_sym_DASH_DASH] = ACTIONS(2261),
    [anon_sym_PLUS_PLUS] = ACTIONS(2261),
    [anon_sym_sizeof] = ACTIONS(2259),
    [anon_sym___alignof__] = ACTIONS(2259),
    [anon_sym___alignof] = ACTIONS(2259),
    [anon_sym__alignof] = ACTIONS(2259),
    [anon_sym_alignof] = ACTIONS(2259),
    [anon_sym__Alignof] = ACTIONS(2259),
    [anon_sym_offsetof] = ACTIONS(2259),
    [anon_sym__Generic] = ACTIONS(2259),
    [anon_sym_asm] = ACTIONS(2259),
    [anon_sym___asm__] = ACTIONS(2259),
    [sym_number_literal] = ACTIONS(2261),
    [anon_sym_L_SQUOTE] = ACTIONS(2261),
    [anon_sym_u_SQUOTE] = ACTIONS(2261),
    [anon_sym_U_SQUOTE] = ACTIONS(2261),
    [anon_sym_u8_SQUOTE] = ACTIONS(2261),
    [anon_sym_SQUOTE] = ACTIONS(2261),
    [anon_sym_L_DQUOTE] = ACTIONS(2261),
    [anon_sym_u_DQUOTE] = ACTIONS(2261),
    [anon_sym_U_DQUOTE] = ACTIONS(2261),
    [anon_sym_u8_DQUOTE] = ACTIONS(2261),
    [anon_sym_DQUOTE] = ACTIONS(2261),
    [sym_true] = ACTIONS(2259),
    [sym_false] = ACTIONS(2259),
    [anon_sym_NULL] = ACTIONS(2259),
    [anon_sym_nullptr] = ACTIONS(2259),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2259),
    [anon_sym_decltype] = ACTIONS(2259),
    [sym_virtual] = ACTIONS(2259),
    [anon_sym_explicit] = ACTIONS(2259),
    [anon_sym_typename] = ACTIONS(2259),
    [anon_sym_template] = ACTIONS(2259),
    [anon_sym_operator] = ACTIONS(2259),
    [anon_sym_try] = ACTIONS(2259),
    [anon_sym_delete] = ACTIONS(2259),
    [anon_sym_throw] = ACTIONS(2259),
    [anon_sym_namespace] = ACTIONS(2259),
    [anon_sym_using] = ACTIONS(2259),
    [anon_sym_static_assert] = ACTIONS(2259),
    [anon_sym_concept] = ACTIONS(2259),
    [anon_sym_co_return] = ACTIONS(2259),
    [anon_sym_co_yield] = ACTIONS(2259),
    [anon_sym_R_DQUOTE] = ACTIONS(2261),
    [anon_sym_LR_DQUOTE] = ACTIONS(2261),
    [anon_sym_uR_DQUOTE] = ACTIONS(2261),
    [anon_sym_UR_DQUOTE] = ACTIONS(2261),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2261),
    [anon_sym_co_await] = ACTIONS(2259),
    [anon_sym_new] = ACTIONS(2259),
    [anon_sym_requires] = ACTIONS(2259),
    [sym_this] = ACTIONS(2259),
    [anon_sym___launch_bounds__] = ACTIONS(2259),
  },
  [693] = {
    [ts_builtin_sym_end] = ACTIONS(2241),
    [sym_identifier] = ACTIONS(2239),
    [aux_sym_preproc_include_token1] = ACTIONS(2239),
    [aux_sym_preproc_def_token1] = ACTIONS(2239),
    [aux_sym_preproc_if_token1] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2239),
    [sym_preproc_directive] = ACTIONS(2239),
    [anon_sym_LPAREN2] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2239),
    [anon_sym_PLUS] = ACTIONS(2239),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym___extension__] = ACTIONS(2239),
    [anon_sym_typedef] = ACTIONS(2239),
    [anon_sym___device__] = ACTIONS(2239),
    [anon_sym___host__] = ACTIONS(2239),
    [anon_sym___global__] = ACTIONS(2239),
    [anon_sym___forceinline__] = ACTIONS(2239),
    [anon_sym___noinline__] = ACTIONS(2239),
    [anon_sym_extern] = ACTIONS(2239),
    [anon_sym___attribute__] = ACTIONS(2239),
    [anon_sym_COLON_COLON] = ACTIONS(2241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2241),
    [anon_sym___declspec] = ACTIONS(2239),
    [anon_sym___based] = ACTIONS(2239),
    [anon_sym___cdecl] = ACTIONS(2239),
    [anon_sym___clrcall] = ACTIONS(2239),
    [anon_sym___stdcall] = ACTIONS(2239),
    [anon_sym___fastcall] = ACTIONS(2239),
    [anon_sym___thiscall] = ACTIONS(2239),
    [anon_sym___vectorcall] = ACTIONS(2239),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_signed] = ACTIONS(2239),
    [anon_sym_unsigned] = ACTIONS(2239),
    [anon_sym_long] = ACTIONS(2239),
    [anon_sym_short] = ACTIONS(2239),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_static] = ACTIONS(2239),
    [anon_sym_register] = ACTIONS(2239),
    [anon_sym_inline] = ACTIONS(2239),
    [anon_sym___inline] = ACTIONS(2239),
    [anon_sym___inline__] = ACTIONS(2239),
    [anon_sym___forceinline] = ACTIONS(2239),
    [anon_sym_thread_local] = ACTIONS(2239),
    [anon_sym___thread] = ACTIONS(2239),
    [anon_sym_const] = ACTIONS(2239),
    [anon_sym_constexpr] = ACTIONS(2239),
    [anon_sym_volatile] = ACTIONS(2239),
    [anon_sym_restrict] = ACTIONS(2239),
    [anon_sym___restrict__] = ACTIONS(2239),
    [anon_sym__Atomic] = ACTIONS(2239),
    [anon_sym__Noreturn] = ACTIONS(2239),
    [anon_sym_noreturn] = ACTIONS(2239),
    [anon_sym_mutable] = ACTIONS(2239),
    [anon_sym_constinit] = ACTIONS(2239),
    [anon_sym_consteval] = ACTIONS(2239),
    [anon_sym___shared__] = ACTIONS(2239),
    [anon_sym___local__] = ACTIONS(2239),
    [anon_sym___constant__] = ACTIONS(2239),
    [anon_sym___managed__] = ACTIONS(2239),
    [anon_sym___grid_constant__] = ACTIONS(2239),
    [anon_sym_alignas] = ACTIONS(2239),
    [anon_sym__Alignas] = ACTIONS(2239),
    [sym_primitive_type] = ACTIONS(2239),
    [anon_sym_enum] = ACTIONS(2239),
    [anon_sym_class] = ACTIONS(2239),
    [anon_sym_struct] = ACTIONS(2239),
    [anon_sym_union] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(2239),
    [anon_sym_switch] = ACTIONS(2239),
    [anon_sym_case] = ACTIONS(2239),
    [anon_sym_default] = ACTIONS(2239),
    [anon_sym_while] = ACTIONS(2239),
    [anon_sym_do] = ACTIONS(2239),
    [anon_sym_for] = ACTIONS(2239),
    [anon_sym_return] = ACTIONS(2239),
    [anon_sym_break] = ACTIONS(2239),
    [anon_sym_continue] = ACTIONS(2239),
    [anon_sym_goto] = ACTIONS(2239),
    [anon_sym_not] = ACTIONS(2239),
    [anon_sym_compl] = ACTIONS(2239),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_sizeof] = ACTIONS(2239),
    [anon_sym___alignof__] = ACTIONS(2239),
    [anon_sym___alignof] = ACTIONS(2239),
    [anon_sym__alignof] = ACTIONS(2239),
    [anon_sym_alignof] = ACTIONS(2239),
    [anon_sym__Alignof] = ACTIONS(2239),
    [anon_sym_offsetof] = ACTIONS(2239),
    [anon_sym__Generic] = ACTIONS(2239),
    [anon_sym_asm] = ACTIONS(2239),
    [anon_sym___asm__] = ACTIONS(2239),
    [sym_number_literal] = ACTIONS(2241),
    [anon_sym_L_SQUOTE] = ACTIONS(2241),
    [anon_sym_u_SQUOTE] = ACTIONS(2241),
    [anon_sym_U_SQUOTE] = ACTIONS(2241),
    [anon_sym_u8_SQUOTE] = ACTIONS(2241),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_L_DQUOTE] = ACTIONS(2241),
    [anon_sym_u_DQUOTE] = ACTIONS(2241),
    [anon_sym_U_DQUOTE] = ACTIONS(2241),
    [anon_sym_u8_DQUOTE] = ACTIONS(2241),
    [anon_sym_DQUOTE] = ACTIONS(2241),
    [sym_true] = ACTIONS(2239),
    [sym_false] = ACTIONS(2239),
    [anon_sym_NULL] = ACTIONS(2239),
    [anon_sym_nullptr] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2239),
    [anon_sym_decltype] = ACTIONS(2239),
    [sym_virtual] = ACTIONS(2239),
    [anon_sym_explicit] = ACTIONS(2239),
    [anon_sym_typename] = ACTIONS(2239),
    [anon_sym_template] = ACTIONS(2239),
    [anon_sym_operator] = ACTIONS(2239),
    [anon_sym_try] = ACTIONS(2239),
    [anon_sym_delete] = ACTIONS(2239),
    [anon_sym_throw] = ACTIONS(2239),
    [anon_sym_namespace] = ACTIONS(2239),
    [anon_sym_using] = ACTIONS(2239),
    [anon_sym_static_assert] = ACTIONS(2239),
    [anon_sym_concept] = ACTIONS(2239),
    [anon_sym_co_return] = ACTIONS(2239),
    [anon_sym_co_yield] = ACTIONS(2239),
    [anon_sym_R_DQUOTE] = ACTIONS(2241),
    [anon_sym_LR_DQUOTE] = ACTIONS(2241),
    [anon_sym_uR_DQUOTE] = ACTIONS(2241),
    [anon_sym_UR_DQUOTE] = ACTIONS(2241),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2241),
    [anon_sym_co_await] = ACTIONS(2239),
    [anon_sym_new] = ACTIONS(2239),
    [anon_sym_requires] = ACTIONS(2239),
    [sym_this] = ACTIONS(2239),
    [anon_sym___launch_bounds__] = ACTIONS(2239),
  },
  [694] = {
    [ts_builtin_sym_end] = ACTIONS(2269),
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_include_token1] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2269),
    [anon_sym_BANG] = ACTIONS(2269),
    [anon_sym_TILDE] = ACTIONS(2269),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_STAR] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym___device__] = ACTIONS(2267),
    [anon_sym___host__] = ACTIONS(2267),
    [anon_sym___global__] = ACTIONS(2267),
    [anon_sym___forceinline__] = ACTIONS(2267),
    [anon_sym___noinline__] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2269),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2269),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym___cdecl] = ACTIONS(2267),
    [anon_sym___clrcall] = ACTIONS(2267),
    [anon_sym___stdcall] = ACTIONS(2267),
    [anon_sym___fastcall] = ACTIONS(2267),
    [anon_sym___thiscall] = ACTIONS(2267),
    [anon_sym___vectorcall] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2269),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym___shared__] = ACTIONS(2267),
    [anon_sym___local__] = ACTIONS(2267),
    [anon_sym___constant__] = ACTIONS(2267),
    [anon_sym___managed__] = ACTIONS(2267),
    [anon_sym___grid_constant__] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym__Alignas] = ACTIONS(2267),
    [sym_primitive_type] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_switch] = ACTIONS(2267),
    [anon_sym_case] = ACTIONS(2267),
    [anon_sym_default] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_for] = ACTIONS(2267),
    [anon_sym_return] = ACTIONS(2267),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_continue] = ACTIONS(2267),
    [anon_sym_goto] = ACTIONS(2267),
    [anon_sym_not] = ACTIONS(2267),
    [anon_sym_compl] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2269),
    [anon_sym_PLUS_PLUS] = ACTIONS(2269),
    [anon_sym_sizeof] = ACTIONS(2267),
    [anon_sym___alignof__] = ACTIONS(2267),
    [anon_sym___alignof] = ACTIONS(2267),
    [anon_sym__alignof] = ACTIONS(2267),
    [anon_sym_alignof] = ACTIONS(2267),
    [anon_sym__Alignof] = ACTIONS(2267),
    [anon_sym_offsetof] = ACTIONS(2267),
    [anon_sym__Generic] = ACTIONS(2267),
    [anon_sym_asm] = ACTIONS(2267),
    [anon_sym___asm__] = ACTIONS(2267),
    [sym_number_literal] = ACTIONS(2269),
    [anon_sym_L_SQUOTE] = ACTIONS(2269),
    [anon_sym_u_SQUOTE] = ACTIONS(2269),
    [anon_sym_U_SQUOTE] = ACTIONS(2269),
    [anon_sym_u8_SQUOTE] = ACTIONS(2269),
    [anon_sym_SQUOTE] = ACTIONS(2269),
    [anon_sym_L_DQUOTE] = ACTIONS(2269),
    [anon_sym_u_DQUOTE] = ACTIONS(2269),
    [anon_sym_U_DQUOTE] = ACTIONS(2269),
    [anon_sym_u8_DQUOTE] = ACTIONS(2269),
    [anon_sym_DQUOTE] = ACTIONS(2269),
    [sym_true] = ACTIONS(2267),
    [sym_false] = ACTIONS(2267),
    [anon_sym_NULL] = ACTIONS(2267),
    [anon_sym_nullptr] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [sym_virtual] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_try] = ACTIONS(2267),
    [anon_sym_delete] = ACTIONS(2267),
    [anon_sym_throw] = ACTIONS(2267),
    [anon_sym_namespace] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym_concept] = ACTIONS(2267),
    [anon_sym_co_return] = ACTIONS(2267),
    [anon_sym_co_yield] = ACTIONS(2267),
    [anon_sym_R_DQUOTE] = ACTIONS(2269),
    [anon_sym_LR_DQUOTE] = ACTIONS(2269),
    [anon_sym_uR_DQUOTE] = ACTIONS(2269),
    [anon_sym_UR_DQUOTE] = ACTIONS(2269),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2269),
    [anon_sym_co_await] = ACTIONS(2267),
    [anon_sym_new] = ACTIONS(2267),
    [anon_sym_requires] = ACTIONS(2267),
    [sym_this] = ACTIONS(2267),
    [anon_sym___launch_bounds__] = ACTIONS(2267),
  },
  [695] = {
    [sym_preproc_def] = STATE(701),
    [sym_preproc_function_def] = STATE(701),
    [sym_preproc_call] = STATE(701),
    [sym_preproc_if_in_field_declaration_list] = STATE(701),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(701),
    [sym_type_definition] = STATE(701),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5894),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6463),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(701),
    [sym_field_declaration] = STATE(701),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1708),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(701),
    [sym_operator_cast] = STATE(6999),
    [sym_inline_method_definition] = STATE(701),
    [sym__constructor_specifiers] = STATE(1708),
    [sym_operator_cast_definition] = STATE(701),
    [sym_operator_cast_declaration] = STATE(701),
    [sym_constructor_or_destructor_definition] = STATE(701),
    [sym_constructor_or_destructor_declaration] = STATE(701),
    [sym_friend_declaration] = STATE(701),
    [sym_access_specifier] = STATE(8255),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(701),
    [sym_alias_declaration] = STATE(701),
    [sym_static_assert_declaration] = STATE(701),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6999),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(701),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1708),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3376),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3378),
    [sym_preproc_directive] = ACTIONS(3380),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(3382),
    [anon_sym_typedef] = ACTIONS(3384),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3410),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3390),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(3392),
    [anon_sym_static_assert] = ACTIONS(3394),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [696] = {
    [ts_builtin_sym_end] = ACTIONS(2189),
    [sym_identifier] = ACTIONS(2187),
    [aux_sym_preproc_include_token1] = ACTIONS(2187),
    [aux_sym_preproc_def_token1] = ACTIONS(2187),
    [aux_sym_preproc_if_token1] = ACTIONS(2187),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2187),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2187),
    [sym_preproc_directive] = ACTIONS(2187),
    [anon_sym_LPAREN2] = ACTIONS(2189),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2189),
    [anon_sym_AMP_AMP] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym___extension__] = ACTIONS(2187),
    [anon_sym_typedef] = ACTIONS(2187),
    [anon_sym___device__] = ACTIONS(2187),
    [anon_sym___host__] = ACTIONS(2187),
    [anon_sym___global__] = ACTIONS(2187),
    [anon_sym___forceinline__] = ACTIONS(2187),
    [anon_sym___noinline__] = ACTIONS(2187),
    [anon_sym_extern] = ACTIONS(2187),
    [anon_sym___attribute__] = ACTIONS(2187),
    [anon_sym_COLON_COLON] = ACTIONS(2189),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2189),
    [anon_sym___declspec] = ACTIONS(2187),
    [anon_sym___based] = ACTIONS(2187),
    [anon_sym___cdecl] = ACTIONS(2187),
    [anon_sym___clrcall] = ACTIONS(2187),
    [anon_sym___stdcall] = ACTIONS(2187),
    [anon_sym___fastcall] = ACTIONS(2187),
    [anon_sym___thiscall] = ACTIONS(2187),
    [anon_sym___vectorcall] = ACTIONS(2187),
    [anon_sym_LBRACE] = ACTIONS(2189),
    [anon_sym_signed] = ACTIONS(2187),
    [anon_sym_unsigned] = ACTIONS(2187),
    [anon_sym_long] = ACTIONS(2187),
    [anon_sym_short] = ACTIONS(2187),
    [anon_sym_LBRACK] = ACTIONS(2187),
    [anon_sym_static] = ACTIONS(2187),
    [anon_sym_register] = ACTIONS(2187),
    [anon_sym_inline] = ACTIONS(2187),
    [anon_sym___inline] = ACTIONS(2187),
    [anon_sym___inline__] = ACTIONS(2187),
    [anon_sym___forceinline] = ACTIONS(2187),
    [anon_sym_thread_local] = ACTIONS(2187),
    [anon_sym___thread] = ACTIONS(2187),
    [anon_sym_const] = ACTIONS(2187),
    [anon_sym_constexpr] = ACTIONS(2187),
    [anon_sym_volatile] = ACTIONS(2187),
    [anon_sym_restrict] = ACTIONS(2187),
    [anon_sym___restrict__] = ACTIONS(2187),
    [anon_sym__Atomic] = ACTIONS(2187),
    [anon_sym__Noreturn] = ACTIONS(2187),
    [anon_sym_noreturn] = ACTIONS(2187),
    [anon_sym_mutable] = ACTIONS(2187),
    [anon_sym_constinit] = ACTIONS(2187),
    [anon_sym_consteval] = ACTIONS(2187),
    [anon_sym___shared__] = ACTIONS(2187),
    [anon_sym___local__] = ACTIONS(2187),
    [anon_sym___constant__] = ACTIONS(2187),
    [anon_sym___managed__] = ACTIONS(2187),
    [anon_sym___grid_constant__] = ACTIONS(2187),
    [anon_sym_alignas] = ACTIONS(2187),
    [anon_sym__Alignas] = ACTIONS(2187),
    [sym_primitive_type] = ACTIONS(2187),
    [anon_sym_enum] = ACTIONS(2187),
    [anon_sym_class] = ACTIONS(2187),
    [anon_sym_struct] = ACTIONS(2187),
    [anon_sym_union] = ACTIONS(2187),
    [anon_sym_if] = ACTIONS(2187),
    [anon_sym_switch] = ACTIONS(2187),
    [anon_sym_case] = ACTIONS(2187),
    [anon_sym_default] = ACTIONS(2187),
    [anon_sym_while] = ACTIONS(2187),
    [anon_sym_do] = ACTIONS(2187),
    [anon_sym_for] = ACTIONS(2187),
    [anon_sym_return] = ACTIONS(2187),
    [anon_sym_break] = ACTIONS(2187),
    [anon_sym_continue] = ACTIONS(2187),
    [anon_sym_goto] = ACTIONS(2187),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_compl] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_sizeof] = ACTIONS(2187),
    [anon_sym___alignof__] = ACTIONS(2187),
    [anon_sym___alignof] = ACTIONS(2187),
    [anon_sym__alignof] = ACTIONS(2187),
    [anon_sym_alignof] = ACTIONS(2187),
    [anon_sym__Alignof] = ACTIONS(2187),
    [anon_sym_offsetof] = ACTIONS(2187),
    [anon_sym__Generic] = ACTIONS(2187),
    [anon_sym_asm] = ACTIONS(2187),
    [anon_sym___asm__] = ACTIONS(2187),
    [sym_number_literal] = ACTIONS(2189),
    [anon_sym_L_SQUOTE] = ACTIONS(2189),
    [anon_sym_u_SQUOTE] = ACTIONS(2189),
    [anon_sym_U_SQUOTE] = ACTIONS(2189),
    [anon_sym_u8_SQUOTE] = ACTIONS(2189),
    [anon_sym_SQUOTE] = ACTIONS(2189),
    [anon_sym_L_DQUOTE] = ACTIONS(2189),
    [anon_sym_u_DQUOTE] = ACTIONS(2189),
    [anon_sym_U_DQUOTE] = ACTIONS(2189),
    [anon_sym_u8_DQUOTE] = ACTIONS(2189),
    [anon_sym_DQUOTE] = ACTIONS(2189),
    [sym_true] = ACTIONS(2187),
    [sym_false] = ACTIONS(2187),
    [anon_sym_NULL] = ACTIONS(2187),
    [anon_sym_nullptr] = ACTIONS(2187),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2187),
    [anon_sym_decltype] = ACTIONS(2187),
    [sym_virtual] = ACTIONS(2187),
    [anon_sym_explicit] = ACTIONS(2187),
    [anon_sym_typename] = ACTIONS(2187),
    [anon_sym_template] = ACTIONS(2187),
    [anon_sym_operator] = ACTIONS(2187),
    [anon_sym_try] = ACTIONS(2187),
    [anon_sym_delete] = ACTIONS(2187),
    [anon_sym_throw] = ACTIONS(2187),
    [anon_sym_namespace] = ACTIONS(2187),
    [anon_sym_using] = ACTIONS(2187),
    [anon_sym_static_assert] = ACTIONS(2187),
    [anon_sym_concept] = ACTIONS(2187),
    [anon_sym_co_return] = ACTIONS(2187),
    [anon_sym_co_yield] = ACTIONS(2187),
    [anon_sym_R_DQUOTE] = ACTIONS(2189),
    [anon_sym_LR_DQUOTE] = ACTIONS(2189),
    [anon_sym_uR_DQUOTE] = ACTIONS(2189),
    [anon_sym_UR_DQUOTE] = ACTIONS(2189),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2189),
    [anon_sym_co_await] = ACTIONS(2187),
    [anon_sym_new] = ACTIONS(2187),
    [anon_sym_requires] = ACTIONS(2187),
    [sym_this] = ACTIONS(2187),
    [anon_sym___launch_bounds__] = ACTIONS(2187),
  },
  [697] = {
    [ts_builtin_sym_end] = ACTIONS(2269),
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_include_token1] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2269),
    [anon_sym_BANG] = ACTIONS(2269),
    [anon_sym_TILDE] = ACTIONS(2269),
    [anon_sym_DASH] = ACTIONS(2267),
    [anon_sym_PLUS] = ACTIONS(2267),
    [anon_sym_STAR] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym___device__] = ACTIONS(2267),
    [anon_sym___host__] = ACTIONS(2267),
    [anon_sym___global__] = ACTIONS(2267),
    [anon_sym___forceinline__] = ACTIONS(2267),
    [anon_sym___noinline__] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2269),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2269),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym___cdecl] = ACTIONS(2267),
    [anon_sym___clrcall] = ACTIONS(2267),
    [anon_sym___stdcall] = ACTIONS(2267),
    [anon_sym___fastcall] = ACTIONS(2267),
    [anon_sym___thiscall] = ACTIONS(2267),
    [anon_sym___vectorcall] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(2269),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym___shared__] = ACTIONS(2267),
    [anon_sym___local__] = ACTIONS(2267),
    [anon_sym___constant__] = ACTIONS(2267),
    [anon_sym___managed__] = ACTIONS(2267),
    [anon_sym___grid_constant__] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym__Alignas] = ACTIONS(2267),
    [sym_primitive_type] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [anon_sym_if] = ACTIONS(2267),
    [anon_sym_switch] = ACTIONS(2267),
    [anon_sym_case] = ACTIONS(2267),
    [anon_sym_default] = ACTIONS(2267),
    [anon_sym_while] = ACTIONS(2267),
    [anon_sym_do] = ACTIONS(2267),
    [anon_sym_for] = ACTIONS(2267),
    [anon_sym_return] = ACTIONS(2267),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_continue] = ACTIONS(2267),
    [anon_sym_goto] = ACTIONS(2267),
    [anon_sym_not] = ACTIONS(2267),
    [anon_sym_compl] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2269),
    [anon_sym_PLUS_PLUS] = ACTIONS(2269),
    [anon_sym_sizeof] = ACTIONS(2267),
    [anon_sym___alignof__] = ACTIONS(2267),
    [anon_sym___alignof] = ACTIONS(2267),
    [anon_sym__alignof] = ACTIONS(2267),
    [anon_sym_alignof] = ACTIONS(2267),
    [anon_sym__Alignof] = ACTIONS(2267),
    [anon_sym_offsetof] = ACTIONS(2267),
    [anon_sym__Generic] = ACTIONS(2267),
    [anon_sym_asm] = ACTIONS(2267),
    [anon_sym___asm__] = ACTIONS(2267),
    [sym_number_literal] = ACTIONS(2269),
    [anon_sym_L_SQUOTE] = ACTIONS(2269),
    [anon_sym_u_SQUOTE] = ACTIONS(2269),
    [anon_sym_U_SQUOTE] = ACTIONS(2269),
    [anon_sym_u8_SQUOTE] = ACTIONS(2269),
    [anon_sym_SQUOTE] = ACTIONS(2269),
    [anon_sym_L_DQUOTE] = ACTIONS(2269),
    [anon_sym_u_DQUOTE] = ACTIONS(2269),
    [anon_sym_U_DQUOTE] = ACTIONS(2269),
    [anon_sym_u8_DQUOTE] = ACTIONS(2269),
    [anon_sym_DQUOTE] = ACTIONS(2269),
    [sym_true] = ACTIONS(2267),
    [sym_false] = ACTIONS(2267),
    [anon_sym_NULL] = ACTIONS(2267),
    [anon_sym_nullptr] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [sym_virtual] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_try] = ACTIONS(2267),
    [anon_sym_delete] = ACTIONS(2267),
    [anon_sym_throw] = ACTIONS(2267),
    [anon_sym_namespace] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym_concept] = ACTIONS(2267),
    [anon_sym_co_return] = ACTIONS(2267),
    [anon_sym_co_yield] = ACTIONS(2267),
    [anon_sym_R_DQUOTE] = ACTIONS(2269),
    [anon_sym_LR_DQUOTE] = ACTIONS(2269),
    [anon_sym_uR_DQUOTE] = ACTIONS(2269),
    [anon_sym_UR_DQUOTE] = ACTIONS(2269),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2269),
    [anon_sym_co_await] = ACTIONS(2267),
    [anon_sym_new] = ACTIONS(2267),
    [anon_sym_requires] = ACTIONS(2267),
    [sym_this] = ACTIONS(2267),
    [anon_sym___launch_bounds__] = ACTIONS(2267),
  },
  [698] = {
    [ts_builtin_sym_end] = ACTIONS(2193),
    [sym_identifier] = ACTIONS(2191),
    [aux_sym_preproc_include_token1] = ACTIONS(2191),
    [aux_sym_preproc_def_token1] = ACTIONS(2191),
    [aux_sym_preproc_if_token1] = ACTIONS(2191),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2191),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2191),
    [sym_preproc_directive] = ACTIONS(2191),
    [anon_sym_LPAREN2] = ACTIONS(2193),
    [anon_sym_BANG] = ACTIONS(2193),
    [anon_sym_TILDE] = ACTIONS(2193),
    [anon_sym_DASH] = ACTIONS(2191),
    [anon_sym_PLUS] = ACTIONS(2191),
    [anon_sym_STAR] = ACTIONS(2193),
    [anon_sym_AMP_AMP] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2191),
    [anon_sym___extension__] = ACTIONS(2191),
    [anon_sym_typedef] = ACTIONS(2191),
    [anon_sym___device__] = ACTIONS(2191),
    [anon_sym___host__] = ACTIONS(2191),
    [anon_sym___global__] = ACTIONS(2191),
    [anon_sym___forceinline__] = ACTIONS(2191),
    [anon_sym___noinline__] = ACTIONS(2191),
    [anon_sym_extern] = ACTIONS(2191),
    [anon_sym___attribute__] = ACTIONS(2191),
    [anon_sym_COLON_COLON] = ACTIONS(2193),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2193),
    [anon_sym___declspec] = ACTIONS(2191),
    [anon_sym___based] = ACTIONS(2191),
    [anon_sym___cdecl] = ACTIONS(2191),
    [anon_sym___clrcall] = ACTIONS(2191),
    [anon_sym___stdcall] = ACTIONS(2191),
    [anon_sym___fastcall] = ACTIONS(2191),
    [anon_sym___thiscall] = ACTIONS(2191),
    [anon_sym___vectorcall] = ACTIONS(2191),
    [anon_sym_LBRACE] = ACTIONS(2193),
    [anon_sym_signed] = ACTIONS(2191),
    [anon_sym_unsigned] = ACTIONS(2191),
    [anon_sym_long] = ACTIONS(2191),
    [anon_sym_short] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2191),
    [anon_sym_static] = ACTIONS(2191),
    [anon_sym_register] = ACTIONS(2191),
    [anon_sym_inline] = ACTIONS(2191),
    [anon_sym___inline] = ACTIONS(2191),
    [anon_sym___inline__] = ACTIONS(2191),
    [anon_sym___forceinline] = ACTIONS(2191),
    [anon_sym_thread_local] = ACTIONS(2191),
    [anon_sym___thread] = ACTIONS(2191),
    [anon_sym_const] = ACTIONS(2191),
    [anon_sym_constexpr] = ACTIONS(2191),
    [anon_sym_volatile] = ACTIONS(2191),
    [anon_sym_restrict] = ACTIONS(2191),
    [anon_sym___restrict__] = ACTIONS(2191),
    [anon_sym__Atomic] = ACTIONS(2191),
    [anon_sym__Noreturn] = ACTIONS(2191),
    [anon_sym_noreturn] = ACTIONS(2191),
    [anon_sym_mutable] = ACTIONS(2191),
    [anon_sym_constinit] = ACTIONS(2191),
    [anon_sym_consteval] = ACTIONS(2191),
    [anon_sym___shared__] = ACTIONS(2191),
    [anon_sym___local__] = ACTIONS(2191),
    [anon_sym___constant__] = ACTIONS(2191),
    [anon_sym___managed__] = ACTIONS(2191),
    [anon_sym___grid_constant__] = ACTIONS(2191),
    [anon_sym_alignas] = ACTIONS(2191),
    [anon_sym__Alignas] = ACTIONS(2191),
    [sym_primitive_type] = ACTIONS(2191),
    [anon_sym_enum] = ACTIONS(2191),
    [anon_sym_class] = ACTIONS(2191),
    [anon_sym_struct] = ACTIONS(2191),
    [anon_sym_union] = ACTIONS(2191),
    [anon_sym_if] = ACTIONS(2191),
    [anon_sym_switch] = ACTIONS(2191),
    [anon_sym_case] = ACTIONS(2191),
    [anon_sym_default] = ACTIONS(2191),
    [anon_sym_while] = ACTIONS(2191),
    [anon_sym_do] = ACTIONS(2191),
    [anon_sym_for] = ACTIONS(2191),
    [anon_sym_return] = ACTIONS(2191),
    [anon_sym_break] = ACTIONS(2191),
    [anon_sym_continue] = ACTIONS(2191),
    [anon_sym_goto] = ACTIONS(2191),
    [anon_sym_not] = ACTIONS(2191),
    [anon_sym_compl] = ACTIONS(2191),
    [anon_sym_DASH_DASH] = ACTIONS(2193),
    [anon_sym_PLUS_PLUS] = ACTIONS(2193),
    [anon_sym_sizeof] = ACTIONS(2191),
    [anon_sym___alignof__] = ACTIONS(2191),
    [anon_sym___alignof] = ACTIONS(2191),
    [anon_sym__alignof] = ACTIONS(2191),
    [anon_sym_alignof] = ACTIONS(2191),
    [anon_sym__Alignof] = ACTIONS(2191),
    [anon_sym_offsetof] = ACTIONS(2191),
    [anon_sym__Generic] = ACTIONS(2191),
    [anon_sym_asm] = ACTIONS(2191),
    [anon_sym___asm__] = ACTIONS(2191),
    [sym_number_literal] = ACTIONS(2193),
    [anon_sym_L_SQUOTE] = ACTIONS(2193),
    [anon_sym_u_SQUOTE] = ACTIONS(2193),
    [anon_sym_U_SQUOTE] = ACTIONS(2193),
    [anon_sym_u8_SQUOTE] = ACTIONS(2193),
    [anon_sym_SQUOTE] = ACTIONS(2193),
    [anon_sym_L_DQUOTE] = ACTIONS(2193),
    [anon_sym_u_DQUOTE] = ACTIONS(2193),
    [anon_sym_U_DQUOTE] = ACTIONS(2193),
    [anon_sym_u8_DQUOTE] = ACTIONS(2193),
    [anon_sym_DQUOTE] = ACTIONS(2193),
    [sym_true] = ACTIONS(2191),
    [sym_false] = ACTIONS(2191),
    [anon_sym_NULL] = ACTIONS(2191),
    [anon_sym_nullptr] = ACTIONS(2191),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2191),
    [anon_sym_decltype] = ACTIONS(2191),
    [sym_virtual] = ACTIONS(2191),
    [anon_sym_explicit] = ACTIONS(2191),
    [anon_sym_typename] = ACTIONS(2191),
    [anon_sym_template] = ACTIONS(2191),
    [anon_sym_operator] = ACTIONS(2191),
    [anon_sym_try] = ACTIONS(2191),
    [anon_sym_delete] = ACTIONS(2191),
    [anon_sym_throw] = ACTIONS(2191),
    [anon_sym_namespace] = ACTIONS(2191),
    [anon_sym_using] = ACTIONS(2191),
    [anon_sym_static_assert] = ACTIONS(2191),
    [anon_sym_concept] = ACTIONS(2191),
    [anon_sym_co_return] = ACTIONS(2191),
    [anon_sym_co_yield] = ACTIONS(2191),
    [anon_sym_R_DQUOTE] = ACTIONS(2193),
    [anon_sym_LR_DQUOTE] = ACTIONS(2193),
    [anon_sym_uR_DQUOTE] = ACTIONS(2193),
    [anon_sym_UR_DQUOTE] = ACTIONS(2193),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2193),
    [anon_sym_co_await] = ACTIONS(2191),
    [anon_sym_new] = ACTIONS(2191),
    [anon_sym_requires] = ACTIONS(2191),
    [sym_this] = ACTIONS(2191),
    [anon_sym___launch_bounds__] = ACTIONS(2191),
  },
  [699] = {
    [ts_builtin_sym_end] = ACTIONS(2310),
    [sym_identifier] = ACTIONS(2308),
    [aux_sym_preproc_include_token1] = ACTIONS(2308),
    [aux_sym_preproc_def_token1] = ACTIONS(2308),
    [aux_sym_preproc_if_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2308),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2308),
    [sym_preproc_directive] = ACTIONS(2308),
    [anon_sym_LPAREN2] = ACTIONS(2310),
    [anon_sym_BANG] = ACTIONS(2310),
    [anon_sym_TILDE] = ACTIONS(2310),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2310),
    [anon_sym_AMP_AMP] = ACTIONS(2310),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym___extension__] = ACTIONS(2308),
    [anon_sym_typedef] = ACTIONS(2308),
    [anon_sym___device__] = ACTIONS(2308),
    [anon_sym___host__] = ACTIONS(2308),
    [anon_sym___global__] = ACTIONS(2308),
    [anon_sym___forceinline__] = ACTIONS(2308),
    [anon_sym___noinline__] = ACTIONS(2308),
    [anon_sym_extern] = ACTIONS(2308),
    [anon_sym___attribute__] = ACTIONS(2308),
    [anon_sym_COLON_COLON] = ACTIONS(2310),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2310),
    [anon_sym___declspec] = ACTIONS(2308),
    [anon_sym___based] = ACTIONS(2308),
    [anon_sym___cdecl] = ACTIONS(2308),
    [anon_sym___clrcall] = ACTIONS(2308),
    [anon_sym___stdcall] = ACTIONS(2308),
    [anon_sym___fastcall] = ACTIONS(2308),
    [anon_sym___thiscall] = ACTIONS(2308),
    [anon_sym___vectorcall] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_signed] = ACTIONS(2308),
    [anon_sym_unsigned] = ACTIONS(2308),
    [anon_sym_long] = ACTIONS(2308),
    [anon_sym_short] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_register] = ACTIONS(2308),
    [anon_sym_inline] = ACTIONS(2308),
    [anon_sym___inline] = ACTIONS(2308),
    [anon_sym___inline__] = ACTIONS(2308),
    [anon_sym___forceinline] = ACTIONS(2308),
    [anon_sym_thread_local] = ACTIONS(2308),
    [anon_sym___thread] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_constexpr] = ACTIONS(2308),
    [anon_sym_volatile] = ACTIONS(2308),
    [anon_sym_restrict] = ACTIONS(2308),
    [anon_sym___restrict__] = ACTIONS(2308),
    [anon_sym__Atomic] = ACTIONS(2308),
    [anon_sym__Noreturn] = ACTIONS(2308),
    [anon_sym_noreturn] = ACTIONS(2308),
    [anon_sym_mutable] = ACTIONS(2308),
    [anon_sym_constinit] = ACTIONS(2308),
    [anon_sym_consteval] = ACTIONS(2308),
    [anon_sym___shared__] = ACTIONS(2308),
    [anon_sym___local__] = ACTIONS(2308),
    [anon_sym___constant__] = ACTIONS(2308),
    [anon_sym___managed__] = ACTIONS(2308),
    [anon_sym___grid_constant__] = ACTIONS(2308),
    [anon_sym_alignas] = ACTIONS(2308),
    [anon_sym__Alignas] = ACTIONS(2308),
    [sym_primitive_type] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
    [anon_sym_class] = ACTIONS(2308),
    [anon_sym_struct] = ACTIONS(2308),
    [anon_sym_union] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_switch] = ACTIONS(2308),
    [anon_sym_case] = ACTIONS(2308),
    [anon_sym_default] = ACTIONS(2308),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_do] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_goto] = ACTIONS(2308),
    [anon_sym_not] = ACTIONS(2308),
    [anon_sym_compl] = ACTIONS(2308),
    [anon_sym_DASH_DASH] = ACTIONS(2310),
    [anon_sym_PLUS_PLUS] = ACTIONS(2310),
    [anon_sym_sizeof] = ACTIONS(2308),
    [anon_sym___alignof__] = ACTIONS(2308),
    [anon_sym___alignof] = ACTIONS(2308),
    [anon_sym__alignof] = ACTIONS(2308),
    [anon_sym_alignof] = ACTIONS(2308),
    [anon_sym__Alignof] = ACTIONS(2308),
    [anon_sym_offsetof] = ACTIONS(2308),
    [anon_sym__Generic] = ACTIONS(2308),
    [anon_sym_asm] = ACTIONS(2308),
    [anon_sym___asm__] = ACTIONS(2308),
    [sym_number_literal] = ACTIONS(2310),
    [anon_sym_L_SQUOTE] = ACTIONS(2310),
    [anon_sym_u_SQUOTE] = ACTIONS(2310),
    [anon_sym_U_SQUOTE] = ACTIONS(2310),
    [anon_sym_u8_SQUOTE] = ACTIONS(2310),
    [anon_sym_SQUOTE] = ACTIONS(2310),
    [anon_sym_L_DQUOTE] = ACTIONS(2310),
    [anon_sym_u_DQUOTE] = ACTIONS(2310),
    [anon_sym_U_DQUOTE] = ACTIONS(2310),
    [anon_sym_u8_DQUOTE] = ACTIONS(2310),
    [anon_sym_DQUOTE] = ACTIONS(2310),
    [sym_true] = ACTIONS(2308),
    [sym_false] = ACTIONS(2308),
    [anon_sym_NULL] = ACTIONS(2308),
    [anon_sym_nullptr] = ACTIONS(2308),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2308),
    [anon_sym_decltype] = ACTIONS(2308),
    [sym_virtual] = ACTIONS(2308),
    [anon_sym_explicit] = ACTIONS(2308),
    [anon_sym_typename] = ACTIONS(2308),
    [anon_sym_template] = ACTIONS(2308),
    [anon_sym_operator] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [anon_sym_delete] = ACTIONS(2308),
    [anon_sym_throw] = ACTIONS(2308),
    [anon_sym_namespace] = ACTIONS(2308),
    [anon_sym_using] = ACTIONS(2308),
    [anon_sym_static_assert] = ACTIONS(2308),
    [anon_sym_concept] = ACTIONS(2308),
    [anon_sym_co_return] = ACTIONS(2308),
    [anon_sym_co_yield] = ACTIONS(2308),
    [anon_sym_R_DQUOTE] = ACTIONS(2310),
    [anon_sym_LR_DQUOTE] = ACTIONS(2310),
    [anon_sym_uR_DQUOTE] = ACTIONS(2310),
    [anon_sym_UR_DQUOTE] = ACTIONS(2310),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2310),
    [anon_sym_co_await] = ACTIONS(2308),
    [anon_sym_new] = ACTIONS(2308),
    [anon_sym_requires] = ACTIONS(2308),
    [sym_this] = ACTIONS(2308),
    [anon_sym___launch_bounds__] = ACTIONS(2308),
  },
  [700] = {
    [ts_builtin_sym_end] = ACTIONS(2205),
    [sym_identifier] = ACTIONS(2203),
    [aux_sym_preproc_include_token1] = ACTIONS(2203),
    [aux_sym_preproc_def_token1] = ACTIONS(2203),
    [aux_sym_preproc_if_token1] = ACTIONS(2203),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2203),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2203),
    [sym_preproc_directive] = ACTIONS(2203),
    [anon_sym_LPAREN2] = ACTIONS(2205),
    [anon_sym_BANG] = ACTIONS(2205),
    [anon_sym_TILDE] = ACTIONS(2205),
    [anon_sym_DASH] = ACTIONS(2203),
    [anon_sym_PLUS] = ACTIONS(2203),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_AMP_AMP] = ACTIONS(2205),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym___extension__] = ACTIONS(2203),
    [anon_sym_typedef] = ACTIONS(2203),
    [anon_sym___device__] = ACTIONS(2203),
    [anon_sym___host__] = ACTIONS(2203),
    [anon_sym___global__] = ACTIONS(2203),
    [anon_sym___forceinline__] = ACTIONS(2203),
    [anon_sym___noinline__] = ACTIONS(2203),
    [anon_sym_extern] = ACTIONS(2203),
    [anon_sym___attribute__] = ACTIONS(2203),
    [anon_sym_COLON_COLON] = ACTIONS(2205),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2205),
    [anon_sym___declspec] = ACTIONS(2203),
    [anon_sym___based] = ACTIONS(2203),
    [anon_sym___cdecl] = ACTIONS(2203),
    [anon_sym___clrcall] = ACTIONS(2203),
    [anon_sym___stdcall] = ACTIONS(2203),
    [anon_sym___fastcall] = ACTIONS(2203),
    [anon_sym___thiscall] = ACTIONS(2203),
    [anon_sym___vectorcall] = ACTIONS(2203),
    [anon_sym_LBRACE] = ACTIONS(2205),
    [anon_sym_signed] = ACTIONS(2203),
    [anon_sym_unsigned] = ACTIONS(2203),
    [anon_sym_long] = ACTIONS(2203),
    [anon_sym_short] = ACTIONS(2203),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_static] = ACTIONS(2203),
    [anon_sym_register] = ACTIONS(2203),
    [anon_sym_inline] = ACTIONS(2203),
    [anon_sym___inline] = ACTIONS(2203),
    [anon_sym___inline__] = ACTIONS(2203),
    [anon_sym___forceinline] = ACTIONS(2203),
    [anon_sym_thread_local] = ACTIONS(2203),
    [anon_sym___thread] = ACTIONS(2203),
    [anon_sym_const] = ACTIONS(2203),
    [anon_sym_constexpr] = ACTIONS(2203),
    [anon_sym_volatile] = ACTIONS(2203),
    [anon_sym_restrict] = ACTIONS(2203),
    [anon_sym___restrict__] = ACTIONS(2203),
    [anon_sym__Atomic] = ACTIONS(2203),
    [anon_sym__Noreturn] = ACTIONS(2203),
    [anon_sym_noreturn] = ACTIONS(2203),
    [anon_sym_mutable] = ACTIONS(2203),
    [anon_sym_constinit] = ACTIONS(2203),
    [anon_sym_consteval] = ACTIONS(2203),
    [anon_sym___shared__] = ACTIONS(2203),
    [anon_sym___local__] = ACTIONS(2203),
    [anon_sym___constant__] = ACTIONS(2203),
    [anon_sym___managed__] = ACTIONS(2203),
    [anon_sym___grid_constant__] = ACTIONS(2203),
    [anon_sym_alignas] = ACTIONS(2203),
    [anon_sym__Alignas] = ACTIONS(2203),
    [sym_primitive_type] = ACTIONS(2203),
    [anon_sym_enum] = ACTIONS(2203),
    [anon_sym_class] = ACTIONS(2203),
    [anon_sym_struct] = ACTIONS(2203),
    [anon_sym_union] = ACTIONS(2203),
    [anon_sym_if] = ACTIONS(2203),
    [anon_sym_switch] = ACTIONS(2203),
    [anon_sym_case] = ACTIONS(2203),
    [anon_sym_default] = ACTIONS(2203),
    [anon_sym_while] = ACTIONS(2203),
    [anon_sym_do] = ACTIONS(2203),
    [anon_sym_for] = ACTIONS(2203),
    [anon_sym_return] = ACTIONS(2203),
    [anon_sym_break] = ACTIONS(2203),
    [anon_sym_continue] = ACTIONS(2203),
    [anon_sym_goto] = ACTIONS(2203),
    [anon_sym_not] = ACTIONS(2203),
    [anon_sym_compl] = ACTIONS(2203),
    [anon_sym_DASH_DASH] = ACTIONS(2205),
    [anon_sym_PLUS_PLUS] = ACTIONS(2205),
    [anon_sym_sizeof] = ACTIONS(2203),
    [anon_sym___alignof__] = ACTIONS(2203),
    [anon_sym___alignof] = ACTIONS(2203),
    [anon_sym__alignof] = ACTIONS(2203),
    [anon_sym_alignof] = ACTIONS(2203),
    [anon_sym__Alignof] = ACTIONS(2203),
    [anon_sym_offsetof] = ACTIONS(2203),
    [anon_sym__Generic] = ACTIONS(2203),
    [anon_sym_asm] = ACTIONS(2203),
    [anon_sym___asm__] = ACTIONS(2203),
    [sym_number_literal] = ACTIONS(2205),
    [anon_sym_L_SQUOTE] = ACTIONS(2205),
    [anon_sym_u_SQUOTE] = ACTIONS(2205),
    [anon_sym_U_SQUOTE] = ACTIONS(2205),
    [anon_sym_u8_SQUOTE] = ACTIONS(2205),
    [anon_sym_SQUOTE] = ACTIONS(2205),
    [anon_sym_L_DQUOTE] = ACTIONS(2205),
    [anon_sym_u_DQUOTE] = ACTIONS(2205),
    [anon_sym_U_DQUOTE] = ACTIONS(2205),
    [anon_sym_u8_DQUOTE] = ACTIONS(2205),
    [anon_sym_DQUOTE] = ACTIONS(2205),
    [sym_true] = ACTIONS(2203),
    [sym_false] = ACTIONS(2203),
    [anon_sym_NULL] = ACTIONS(2203),
    [anon_sym_nullptr] = ACTIONS(2203),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2203),
    [anon_sym_decltype] = ACTIONS(2203),
    [sym_virtual] = ACTIONS(2203),
    [anon_sym_explicit] = ACTIONS(2203),
    [anon_sym_typename] = ACTIONS(2203),
    [anon_sym_template] = ACTIONS(2203),
    [anon_sym_operator] = ACTIONS(2203),
    [anon_sym_try] = ACTIONS(2203),
    [anon_sym_delete] = ACTIONS(2203),
    [anon_sym_throw] = ACTIONS(2203),
    [anon_sym_namespace] = ACTIONS(2203),
    [anon_sym_using] = ACTIONS(2203),
    [anon_sym_static_assert] = ACTIONS(2203),
    [anon_sym_concept] = ACTIONS(2203),
    [anon_sym_co_return] = ACTIONS(2203),
    [anon_sym_co_yield] = ACTIONS(2203),
    [anon_sym_R_DQUOTE] = ACTIONS(2205),
    [anon_sym_LR_DQUOTE] = ACTIONS(2205),
    [anon_sym_uR_DQUOTE] = ACTIONS(2205),
    [anon_sym_UR_DQUOTE] = ACTIONS(2205),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2205),
    [anon_sym_co_await] = ACTIONS(2203),
    [anon_sym_new] = ACTIONS(2203),
    [anon_sym_requires] = ACTIONS(2203),
    [sym_this] = ACTIONS(2203),
    [anon_sym___launch_bounds__] = ACTIONS(2203),
  },
  [701] = {
    [sym_preproc_def] = STATE(701),
    [sym_preproc_function_def] = STATE(701),
    [sym_preproc_call] = STATE(701),
    [sym_preproc_if_in_field_declaration_list] = STATE(701),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(701),
    [sym_type_definition] = STATE(701),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5894),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6463),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(701),
    [sym_field_declaration] = STATE(701),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1708),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(701),
    [sym_operator_cast] = STATE(6999),
    [sym_inline_method_definition] = STATE(701),
    [sym__constructor_specifiers] = STATE(1708),
    [sym_operator_cast_definition] = STATE(701),
    [sym_operator_cast_declaration] = STATE(701),
    [sym_constructor_or_destructor_definition] = STATE(701),
    [sym_constructor_or_destructor_declaration] = STATE(701),
    [sym_friend_declaration] = STATE(701),
    [sym_access_specifier] = STATE(8255),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(701),
    [sym_alias_declaration] = STATE(701),
    [sym_static_assert_declaration] = STATE(701),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6999),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(701),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1708),
    [sym_identifier] = ACTIONS(2592),
    [aux_sym_preproc_def_token1] = ACTIONS(3412),
    [aux_sym_preproc_if_token1] = ACTIONS(3415),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3418),
    [sym_preproc_directive] = ACTIONS(3421),
    [anon_sym_LPAREN2] = ACTIONS(2609),
    [anon_sym_TILDE] = ACTIONS(2612),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_AMP_AMP] = ACTIONS(2618),
    [anon_sym_AMP] = ACTIONS(2621),
    [anon_sym___extension__] = ACTIONS(3424),
    [anon_sym_typedef] = ACTIONS(3427),
    [anon_sym___device__] = ACTIONS(2630),
    [anon_sym___host__] = ACTIONS(2630),
    [anon_sym___global__] = ACTIONS(2630),
    [anon_sym___forceinline__] = ACTIONS(2630),
    [anon_sym___noinline__] = ACTIONS(2630),
    [anon_sym_extern] = ACTIONS(2633),
    [anon_sym___attribute__] = ACTIONS(2636),
    [anon_sym_COLON_COLON] = ACTIONS(2639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2642),
    [anon_sym___declspec] = ACTIONS(2645),
    [anon_sym___based] = ACTIONS(2648),
    [anon_sym_RBRACE] = ACTIONS(3430),
    [anon_sym_signed] = ACTIONS(2651),
    [anon_sym_unsigned] = ACTIONS(2651),
    [anon_sym_long] = ACTIONS(2651),
    [anon_sym_short] = ACTIONS(2651),
    [anon_sym_LBRACK] = ACTIONS(2654),
    [anon_sym_static] = ACTIONS(2633),
    [anon_sym_register] = ACTIONS(2633),
    [anon_sym_inline] = ACTIONS(2633),
    [anon_sym___inline] = ACTIONS(2633),
    [anon_sym___inline__] = ACTIONS(2633),
    [anon_sym___forceinline] = ACTIONS(2633),
    [anon_sym_thread_local] = ACTIONS(2633),
    [anon_sym___thread] = ACTIONS(2633),
    [anon_sym_const] = ACTIONS(2657),
    [anon_sym_constexpr] = ACTIONS(2657),
    [anon_sym_volatile] = ACTIONS(2657),
    [anon_sym_restrict] = ACTIONS(2657),
    [anon_sym___restrict__] = ACTIONS(2657),
    [anon_sym__Atomic] = ACTIONS(2657),
    [anon_sym__Noreturn] = ACTIONS(2657),
    [anon_sym_noreturn] = ACTIONS(2657),
    [anon_sym_mutable] = ACTIONS(2657),
    [anon_sym_constinit] = ACTIONS(2657),
    [anon_sym_consteval] = ACTIONS(2657),
    [anon_sym___shared__] = ACTIONS(2657),
    [anon_sym___local__] = ACTIONS(2657),
    [anon_sym___constant__] = ACTIONS(2657),
    [anon_sym___managed__] = ACTIONS(2657),
    [anon_sym___grid_constant__] = ACTIONS(2657),
    [anon_sym_alignas] = ACTIONS(2660),
    [anon_sym__Alignas] = ACTIONS(2660),
    [sym_primitive_type] = ACTIONS(2663),
    [anon_sym_enum] = ACTIONS(2666),
    [anon_sym_class] = ACTIONS(2669),
    [anon_sym_struct] = ACTIONS(2672),
    [anon_sym_union] = ACTIONS(2675),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2678),
    [anon_sym_decltype] = ACTIONS(2681),
    [sym_virtual] = ACTIONS(2630),
    [anon_sym_explicit] = ACTIONS(2684),
    [anon_sym_typename] = ACTIONS(2687),
    [anon_sym_template] = ACTIONS(3432),
    [anon_sym_operator] = ACTIONS(2693),
    [anon_sym_friend] = ACTIONS(3435),
    [anon_sym_public] = ACTIONS(2699),
    [anon_sym_private] = ACTIONS(2699),
    [anon_sym_protected] = ACTIONS(2699),
    [anon_sym_using] = ACTIONS(3438),
    [anon_sym_static_assert] = ACTIONS(3441),
    [anon_sym___launch_bounds__] = ACTIONS(2708),
  },
  [702] = {
    [ts_builtin_sym_end] = ACTIONS(2372),
    [sym_identifier] = ACTIONS(2370),
    [aux_sym_preproc_include_token1] = ACTIONS(2370),
    [aux_sym_preproc_def_token1] = ACTIONS(2370),
    [aux_sym_preproc_if_token1] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2370),
    [sym_preproc_directive] = ACTIONS(2370),
    [anon_sym_LPAREN2] = ACTIONS(2372),
    [anon_sym_BANG] = ACTIONS(2372),
    [anon_sym_TILDE] = ACTIONS(2372),
    [anon_sym_DASH] = ACTIONS(2370),
    [anon_sym_PLUS] = ACTIONS(2370),
    [anon_sym_STAR] = ACTIONS(2372),
    [anon_sym_AMP_AMP] = ACTIONS(2372),
    [anon_sym_AMP] = ACTIONS(2370),
    [anon_sym___extension__] = ACTIONS(2370),
    [anon_sym_typedef] = ACTIONS(2370),
    [anon_sym___device__] = ACTIONS(2370),
    [anon_sym___host__] = ACTIONS(2370),
    [anon_sym___global__] = ACTIONS(2370),
    [anon_sym___forceinline__] = ACTIONS(2370),
    [anon_sym___noinline__] = ACTIONS(2370),
    [anon_sym_extern] = ACTIONS(2370),
    [anon_sym___attribute__] = ACTIONS(2370),
    [anon_sym_COLON_COLON] = ACTIONS(2372),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2372),
    [anon_sym___declspec] = ACTIONS(2370),
    [anon_sym___based] = ACTIONS(2370),
    [anon_sym___cdecl] = ACTIONS(2370),
    [anon_sym___clrcall] = ACTIONS(2370),
    [anon_sym___stdcall] = ACTIONS(2370),
    [anon_sym___fastcall] = ACTIONS(2370),
    [anon_sym___thiscall] = ACTIONS(2370),
    [anon_sym___vectorcall] = ACTIONS(2370),
    [anon_sym_LBRACE] = ACTIONS(2372),
    [anon_sym_signed] = ACTIONS(2370),
    [anon_sym_unsigned] = ACTIONS(2370),
    [anon_sym_long] = ACTIONS(2370),
    [anon_sym_short] = ACTIONS(2370),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_static] = ACTIONS(2370),
    [anon_sym_register] = ACTIONS(2370),
    [anon_sym_inline] = ACTIONS(2370),
    [anon_sym___inline] = ACTIONS(2370),
    [anon_sym___inline__] = ACTIONS(2370),
    [anon_sym___forceinline] = ACTIONS(2370),
    [anon_sym_thread_local] = ACTIONS(2370),
    [anon_sym___thread] = ACTIONS(2370),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_constexpr] = ACTIONS(2370),
    [anon_sym_volatile] = ACTIONS(2370),
    [anon_sym_restrict] = ACTIONS(2370),
    [anon_sym___restrict__] = ACTIONS(2370),
    [anon_sym__Atomic] = ACTIONS(2370),
    [anon_sym__Noreturn] = ACTIONS(2370),
    [anon_sym_noreturn] = ACTIONS(2370),
    [anon_sym_mutable] = ACTIONS(2370),
    [anon_sym_constinit] = ACTIONS(2370),
    [anon_sym_consteval] = ACTIONS(2370),
    [anon_sym___shared__] = ACTIONS(2370),
    [anon_sym___local__] = ACTIONS(2370),
    [anon_sym___constant__] = ACTIONS(2370),
    [anon_sym___managed__] = ACTIONS(2370),
    [anon_sym___grid_constant__] = ACTIONS(2370),
    [anon_sym_alignas] = ACTIONS(2370),
    [anon_sym__Alignas] = ACTIONS(2370),
    [sym_primitive_type] = ACTIONS(2370),
    [anon_sym_enum] = ACTIONS(2370),
    [anon_sym_class] = ACTIONS(2370),
    [anon_sym_struct] = ACTIONS(2370),
    [anon_sym_union] = ACTIONS(2370),
    [anon_sym_if] = ACTIONS(2370),
    [anon_sym_switch] = ACTIONS(2370),
    [anon_sym_case] = ACTIONS(2370),
    [anon_sym_default] = ACTIONS(2370),
    [anon_sym_while] = ACTIONS(2370),
    [anon_sym_do] = ACTIONS(2370),
    [anon_sym_for] = ACTIONS(2370),
    [anon_sym_return] = ACTIONS(2370),
    [anon_sym_break] = ACTIONS(2370),
    [anon_sym_continue] = ACTIONS(2370),
    [anon_sym_goto] = ACTIONS(2370),
    [anon_sym_not] = ACTIONS(2370),
    [anon_sym_compl] = ACTIONS(2370),
    [anon_sym_DASH_DASH] = ACTIONS(2372),
    [anon_sym_PLUS_PLUS] = ACTIONS(2372),
    [anon_sym_sizeof] = ACTIONS(2370),
    [anon_sym___alignof__] = ACTIONS(2370),
    [anon_sym___alignof] = ACTIONS(2370),
    [anon_sym__alignof] = ACTIONS(2370),
    [anon_sym_alignof] = ACTIONS(2370),
    [anon_sym__Alignof] = ACTIONS(2370),
    [anon_sym_offsetof] = ACTIONS(2370),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2370),
    [anon_sym___asm__] = ACTIONS(2370),
    [sym_number_literal] = ACTIONS(2372),
    [anon_sym_L_SQUOTE] = ACTIONS(2372),
    [anon_sym_u_SQUOTE] = ACTIONS(2372),
    [anon_sym_U_SQUOTE] = ACTIONS(2372),
    [anon_sym_u8_SQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [anon_sym_L_DQUOTE] = ACTIONS(2372),
    [anon_sym_u_DQUOTE] = ACTIONS(2372),
    [anon_sym_U_DQUOTE] = ACTIONS(2372),
    [anon_sym_u8_DQUOTE] = ACTIONS(2372),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [sym_true] = ACTIONS(2370),
    [sym_false] = ACTIONS(2370),
    [anon_sym_NULL] = ACTIONS(2370),
    [anon_sym_nullptr] = ACTIONS(2370),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2370),
    [anon_sym_decltype] = ACTIONS(2370),
    [sym_virtual] = ACTIONS(2370),
    [anon_sym_explicit] = ACTIONS(2370),
    [anon_sym_typename] = ACTIONS(2370),
    [anon_sym_template] = ACTIONS(2370),
    [anon_sym_operator] = ACTIONS(2370),
    [anon_sym_try] = ACTIONS(2370),
    [anon_sym_delete] = ACTIONS(2370),
    [anon_sym_throw] = ACTIONS(2370),
    [anon_sym_namespace] = ACTIONS(2370),
    [anon_sym_using] = ACTIONS(2370),
    [anon_sym_static_assert] = ACTIONS(2370),
    [anon_sym_concept] = ACTIONS(2370),
    [anon_sym_co_return] = ACTIONS(2370),
    [anon_sym_co_yield] = ACTIONS(2370),
    [anon_sym_R_DQUOTE] = ACTIONS(2372),
    [anon_sym_LR_DQUOTE] = ACTIONS(2372),
    [anon_sym_uR_DQUOTE] = ACTIONS(2372),
    [anon_sym_UR_DQUOTE] = ACTIONS(2372),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2372),
    [anon_sym_co_await] = ACTIONS(2370),
    [anon_sym_new] = ACTIONS(2370),
    [anon_sym_requires] = ACTIONS(2370),
    [sym_this] = ACTIONS(2370),
    [anon_sym___launch_bounds__] = ACTIONS(2370),
  },
  [703] = {
    [ts_builtin_sym_end] = ACTIONS(2372),
    [sym_identifier] = ACTIONS(2370),
    [aux_sym_preproc_include_token1] = ACTIONS(2370),
    [aux_sym_preproc_def_token1] = ACTIONS(2370),
    [aux_sym_preproc_if_token1] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2370),
    [sym_preproc_directive] = ACTIONS(2370),
    [anon_sym_LPAREN2] = ACTIONS(2372),
    [anon_sym_BANG] = ACTIONS(2372),
    [anon_sym_TILDE] = ACTIONS(2372),
    [anon_sym_DASH] = ACTIONS(2370),
    [anon_sym_PLUS] = ACTIONS(2370),
    [anon_sym_STAR] = ACTIONS(2372),
    [anon_sym_AMP_AMP] = ACTIONS(2372),
    [anon_sym_AMP] = ACTIONS(2370),
    [anon_sym___extension__] = ACTIONS(2370),
    [anon_sym_typedef] = ACTIONS(2370),
    [anon_sym___device__] = ACTIONS(2370),
    [anon_sym___host__] = ACTIONS(2370),
    [anon_sym___global__] = ACTIONS(2370),
    [anon_sym___forceinline__] = ACTIONS(2370),
    [anon_sym___noinline__] = ACTIONS(2370),
    [anon_sym_extern] = ACTIONS(2370),
    [anon_sym___attribute__] = ACTIONS(2370),
    [anon_sym_COLON_COLON] = ACTIONS(2372),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2372),
    [anon_sym___declspec] = ACTIONS(2370),
    [anon_sym___based] = ACTIONS(2370),
    [anon_sym___cdecl] = ACTIONS(2370),
    [anon_sym___clrcall] = ACTIONS(2370),
    [anon_sym___stdcall] = ACTIONS(2370),
    [anon_sym___fastcall] = ACTIONS(2370),
    [anon_sym___thiscall] = ACTIONS(2370),
    [anon_sym___vectorcall] = ACTIONS(2370),
    [anon_sym_LBRACE] = ACTIONS(2372),
    [anon_sym_signed] = ACTIONS(2370),
    [anon_sym_unsigned] = ACTIONS(2370),
    [anon_sym_long] = ACTIONS(2370),
    [anon_sym_short] = ACTIONS(2370),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_static] = ACTIONS(2370),
    [anon_sym_register] = ACTIONS(2370),
    [anon_sym_inline] = ACTIONS(2370),
    [anon_sym___inline] = ACTIONS(2370),
    [anon_sym___inline__] = ACTIONS(2370),
    [anon_sym___forceinline] = ACTIONS(2370),
    [anon_sym_thread_local] = ACTIONS(2370),
    [anon_sym___thread] = ACTIONS(2370),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_constexpr] = ACTIONS(2370),
    [anon_sym_volatile] = ACTIONS(2370),
    [anon_sym_restrict] = ACTIONS(2370),
    [anon_sym___restrict__] = ACTIONS(2370),
    [anon_sym__Atomic] = ACTIONS(2370),
    [anon_sym__Noreturn] = ACTIONS(2370),
    [anon_sym_noreturn] = ACTIONS(2370),
    [anon_sym_mutable] = ACTIONS(2370),
    [anon_sym_constinit] = ACTIONS(2370),
    [anon_sym_consteval] = ACTIONS(2370),
    [anon_sym___shared__] = ACTIONS(2370),
    [anon_sym___local__] = ACTIONS(2370),
    [anon_sym___constant__] = ACTIONS(2370),
    [anon_sym___managed__] = ACTIONS(2370),
    [anon_sym___grid_constant__] = ACTIONS(2370),
    [anon_sym_alignas] = ACTIONS(2370),
    [anon_sym__Alignas] = ACTIONS(2370),
    [sym_primitive_type] = ACTIONS(2370),
    [anon_sym_enum] = ACTIONS(2370),
    [anon_sym_class] = ACTIONS(2370),
    [anon_sym_struct] = ACTIONS(2370),
    [anon_sym_union] = ACTIONS(2370),
    [anon_sym_if] = ACTIONS(2370),
    [anon_sym_switch] = ACTIONS(2370),
    [anon_sym_case] = ACTIONS(2370),
    [anon_sym_default] = ACTIONS(2370),
    [anon_sym_while] = ACTIONS(2370),
    [anon_sym_do] = ACTIONS(2370),
    [anon_sym_for] = ACTIONS(2370),
    [anon_sym_return] = ACTIONS(2370),
    [anon_sym_break] = ACTIONS(2370),
    [anon_sym_continue] = ACTIONS(2370),
    [anon_sym_goto] = ACTIONS(2370),
    [anon_sym_not] = ACTIONS(2370),
    [anon_sym_compl] = ACTIONS(2370),
    [anon_sym_DASH_DASH] = ACTIONS(2372),
    [anon_sym_PLUS_PLUS] = ACTIONS(2372),
    [anon_sym_sizeof] = ACTIONS(2370),
    [anon_sym___alignof__] = ACTIONS(2370),
    [anon_sym___alignof] = ACTIONS(2370),
    [anon_sym__alignof] = ACTIONS(2370),
    [anon_sym_alignof] = ACTIONS(2370),
    [anon_sym__Alignof] = ACTIONS(2370),
    [anon_sym_offsetof] = ACTIONS(2370),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2370),
    [anon_sym___asm__] = ACTIONS(2370),
    [sym_number_literal] = ACTIONS(2372),
    [anon_sym_L_SQUOTE] = ACTIONS(2372),
    [anon_sym_u_SQUOTE] = ACTIONS(2372),
    [anon_sym_U_SQUOTE] = ACTIONS(2372),
    [anon_sym_u8_SQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [anon_sym_L_DQUOTE] = ACTIONS(2372),
    [anon_sym_u_DQUOTE] = ACTIONS(2372),
    [anon_sym_U_DQUOTE] = ACTIONS(2372),
    [anon_sym_u8_DQUOTE] = ACTIONS(2372),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [sym_true] = ACTIONS(2370),
    [sym_false] = ACTIONS(2370),
    [anon_sym_NULL] = ACTIONS(2370),
    [anon_sym_nullptr] = ACTIONS(2370),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2370),
    [anon_sym_decltype] = ACTIONS(2370),
    [sym_virtual] = ACTIONS(2370),
    [anon_sym_explicit] = ACTIONS(2370),
    [anon_sym_typename] = ACTIONS(2370),
    [anon_sym_template] = ACTIONS(2370),
    [anon_sym_operator] = ACTIONS(2370),
    [anon_sym_try] = ACTIONS(2370),
    [anon_sym_delete] = ACTIONS(2370),
    [anon_sym_throw] = ACTIONS(2370),
    [anon_sym_namespace] = ACTIONS(2370),
    [anon_sym_using] = ACTIONS(2370),
    [anon_sym_static_assert] = ACTIONS(2370),
    [anon_sym_concept] = ACTIONS(2370),
    [anon_sym_co_return] = ACTIONS(2370),
    [anon_sym_co_yield] = ACTIONS(2370),
    [anon_sym_R_DQUOTE] = ACTIONS(2372),
    [anon_sym_LR_DQUOTE] = ACTIONS(2372),
    [anon_sym_uR_DQUOTE] = ACTIONS(2372),
    [anon_sym_UR_DQUOTE] = ACTIONS(2372),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2372),
    [anon_sym_co_await] = ACTIONS(2370),
    [anon_sym_new] = ACTIONS(2370),
    [anon_sym_requires] = ACTIONS(2370),
    [sym_this] = ACTIONS(2370),
    [anon_sym___launch_bounds__] = ACTIONS(2370),
  },
  [704] = {
    [ts_builtin_sym_end] = ACTIONS(2182),
    [sym_identifier] = ACTIONS(2180),
    [aux_sym_preproc_include_token1] = ACTIONS(2180),
    [aux_sym_preproc_def_token1] = ACTIONS(2180),
    [aux_sym_preproc_if_token1] = ACTIONS(2180),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2180),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2180),
    [sym_preproc_directive] = ACTIONS(2180),
    [anon_sym_LPAREN2] = ACTIONS(2182),
    [anon_sym_BANG] = ACTIONS(2182),
    [anon_sym_TILDE] = ACTIONS(2182),
    [anon_sym_DASH] = ACTIONS(2180),
    [anon_sym_PLUS] = ACTIONS(2180),
    [anon_sym_STAR] = ACTIONS(2182),
    [anon_sym_AMP_AMP] = ACTIONS(2182),
    [anon_sym_AMP] = ACTIONS(2180),
    [anon_sym___extension__] = ACTIONS(2180),
    [anon_sym_typedef] = ACTIONS(2180),
    [anon_sym___device__] = ACTIONS(2180),
    [anon_sym___host__] = ACTIONS(2180),
    [anon_sym___global__] = ACTIONS(2180),
    [anon_sym___forceinline__] = ACTIONS(2180),
    [anon_sym___noinline__] = ACTIONS(2180),
    [anon_sym_extern] = ACTIONS(2180),
    [anon_sym___attribute__] = ACTIONS(2180),
    [anon_sym_COLON_COLON] = ACTIONS(2182),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2182),
    [anon_sym___declspec] = ACTIONS(2180),
    [anon_sym___based] = ACTIONS(2180),
    [anon_sym___cdecl] = ACTIONS(2180),
    [anon_sym___clrcall] = ACTIONS(2180),
    [anon_sym___stdcall] = ACTIONS(2180),
    [anon_sym___fastcall] = ACTIONS(2180),
    [anon_sym___thiscall] = ACTIONS(2180),
    [anon_sym___vectorcall] = ACTIONS(2180),
    [anon_sym_LBRACE] = ACTIONS(2182),
    [anon_sym_signed] = ACTIONS(2180),
    [anon_sym_unsigned] = ACTIONS(2180),
    [anon_sym_long] = ACTIONS(2180),
    [anon_sym_short] = ACTIONS(2180),
    [anon_sym_LBRACK] = ACTIONS(2180),
    [anon_sym_static] = ACTIONS(2180),
    [anon_sym_register] = ACTIONS(2180),
    [anon_sym_inline] = ACTIONS(2180),
    [anon_sym___inline] = ACTIONS(2180),
    [anon_sym___inline__] = ACTIONS(2180),
    [anon_sym___forceinline] = ACTIONS(2180),
    [anon_sym_thread_local] = ACTIONS(2180),
    [anon_sym___thread] = ACTIONS(2180),
    [anon_sym_const] = ACTIONS(2180),
    [anon_sym_constexpr] = ACTIONS(2180),
    [anon_sym_volatile] = ACTIONS(2180),
    [anon_sym_restrict] = ACTIONS(2180),
    [anon_sym___restrict__] = ACTIONS(2180),
    [anon_sym__Atomic] = ACTIONS(2180),
    [anon_sym__Noreturn] = ACTIONS(2180),
    [anon_sym_noreturn] = ACTIONS(2180),
    [anon_sym_mutable] = ACTIONS(2180),
    [anon_sym_constinit] = ACTIONS(2180),
    [anon_sym_consteval] = ACTIONS(2180),
    [anon_sym___shared__] = ACTIONS(2180),
    [anon_sym___local__] = ACTIONS(2180),
    [anon_sym___constant__] = ACTIONS(2180),
    [anon_sym___managed__] = ACTIONS(2180),
    [anon_sym___grid_constant__] = ACTIONS(2180),
    [anon_sym_alignas] = ACTIONS(2180),
    [anon_sym__Alignas] = ACTIONS(2180),
    [sym_primitive_type] = ACTIONS(2180),
    [anon_sym_enum] = ACTIONS(2180),
    [anon_sym_class] = ACTIONS(2180),
    [anon_sym_struct] = ACTIONS(2180),
    [anon_sym_union] = ACTIONS(2180),
    [anon_sym_if] = ACTIONS(2180),
    [anon_sym_switch] = ACTIONS(2180),
    [anon_sym_case] = ACTIONS(2180),
    [anon_sym_default] = ACTIONS(2180),
    [anon_sym_while] = ACTIONS(2180),
    [anon_sym_do] = ACTIONS(2180),
    [anon_sym_for] = ACTIONS(2180),
    [anon_sym_return] = ACTIONS(2180),
    [anon_sym_break] = ACTIONS(2180),
    [anon_sym_continue] = ACTIONS(2180),
    [anon_sym_goto] = ACTIONS(2180),
    [anon_sym_not] = ACTIONS(2180),
    [anon_sym_compl] = ACTIONS(2180),
    [anon_sym_DASH_DASH] = ACTIONS(2182),
    [anon_sym_PLUS_PLUS] = ACTIONS(2182),
    [anon_sym_sizeof] = ACTIONS(2180),
    [anon_sym___alignof__] = ACTIONS(2180),
    [anon_sym___alignof] = ACTIONS(2180),
    [anon_sym__alignof] = ACTIONS(2180),
    [anon_sym_alignof] = ACTIONS(2180),
    [anon_sym__Alignof] = ACTIONS(2180),
    [anon_sym_offsetof] = ACTIONS(2180),
    [anon_sym__Generic] = ACTIONS(2180),
    [anon_sym_asm] = ACTIONS(2180),
    [anon_sym___asm__] = ACTIONS(2180),
    [sym_number_literal] = ACTIONS(2182),
    [anon_sym_L_SQUOTE] = ACTIONS(2182),
    [anon_sym_u_SQUOTE] = ACTIONS(2182),
    [anon_sym_U_SQUOTE] = ACTIONS(2182),
    [anon_sym_u8_SQUOTE] = ACTIONS(2182),
    [anon_sym_SQUOTE] = ACTIONS(2182),
    [anon_sym_L_DQUOTE] = ACTIONS(2182),
    [anon_sym_u_DQUOTE] = ACTIONS(2182),
    [anon_sym_U_DQUOTE] = ACTIONS(2182),
    [anon_sym_u8_DQUOTE] = ACTIONS(2182),
    [anon_sym_DQUOTE] = ACTIONS(2182),
    [sym_true] = ACTIONS(2180),
    [sym_false] = ACTIONS(2180),
    [anon_sym_NULL] = ACTIONS(2180),
    [anon_sym_nullptr] = ACTIONS(2180),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2180),
    [anon_sym_decltype] = ACTIONS(2180),
    [sym_virtual] = ACTIONS(2180),
    [anon_sym_explicit] = ACTIONS(2180),
    [anon_sym_typename] = ACTIONS(2180),
    [anon_sym_template] = ACTIONS(2180),
    [anon_sym_operator] = ACTIONS(2180),
    [anon_sym_try] = ACTIONS(2180),
    [anon_sym_delete] = ACTIONS(2180),
    [anon_sym_throw] = ACTIONS(2180),
    [anon_sym_namespace] = ACTIONS(2180),
    [anon_sym_using] = ACTIONS(2180),
    [anon_sym_static_assert] = ACTIONS(2180),
    [anon_sym_concept] = ACTIONS(2180),
    [anon_sym_co_return] = ACTIONS(2180),
    [anon_sym_co_yield] = ACTIONS(2180),
    [anon_sym_R_DQUOTE] = ACTIONS(2182),
    [anon_sym_LR_DQUOTE] = ACTIONS(2182),
    [anon_sym_uR_DQUOTE] = ACTIONS(2182),
    [anon_sym_UR_DQUOTE] = ACTIONS(2182),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2182),
    [anon_sym_co_await] = ACTIONS(2180),
    [anon_sym_new] = ACTIONS(2180),
    [anon_sym_requires] = ACTIONS(2180),
    [sym_this] = ACTIONS(2180),
    [anon_sym___launch_bounds__] = ACTIONS(2180),
  },
  [705] = {
    [sym_preproc_def] = STATE(701),
    [sym_preproc_function_def] = STATE(701),
    [sym_preproc_call] = STATE(701),
    [sym_preproc_if_in_field_declaration_list] = STATE(701),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(701),
    [sym_type_definition] = STATE(701),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5894),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6463),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(701),
    [sym_field_declaration] = STATE(701),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1708),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(701),
    [sym_operator_cast] = STATE(6999),
    [sym_inline_method_definition] = STATE(701),
    [sym__constructor_specifiers] = STATE(1708),
    [sym_operator_cast_definition] = STATE(701),
    [sym_operator_cast_declaration] = STATE(701),
    [sym_constructor_or_destructor_definition] = STATE(701),
    [sym_constructor_or_destructor_declaration] = STATE(701),
    [sym_friend_declaration] = STATE(701),
    [sym_access_specifier] = STATE(8255),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(701),
    [sym_alias_declaration] = STATE(701),
    [sym_static_assert_declaration] = STATE(701),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6999),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(701),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1708),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3376),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3378),
    [sym_preproc_directive] = ACTIONS(3380),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(3382),
    [anon_sym_typedef] = ACTIONS(3384),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3444),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3390),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(3392),
    [anon_sym_static_assert] = ACTIONS(3394),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [706] = {
    [sym_preproc_def] = STATE(701),
    [sym_preproc_function_def] = STATE(701),
    [sym_preproc_call] = STATE(701),
    [sym_preproc_if_in_field_declaration_list] = STATE(701),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(701),
    [sym_type_definition] = STATE(701),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5894),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6463),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(701),
    [sym_field_declaration] = STATE(701),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1708),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(701),
    [sym_operator_cast] = STATE(6999),
    [sym_inline_method_definition] = STATE(701),
    [sym__constructor_specifiers] = STATE(1708),
    [sym_operator_cast_definition] = STATE(701),
    [sym_operator_cast_declaration] = STATE(701),
    [sym_constructor_or_destructor_definition] = STATE(701),
    [sym_constructor_or_destructor_declaration] = STATE(701),
    [sym_friend_declaration] = STATE(701),
    [sym_access_specifier] = STATE(8255),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(701),
    [sym_alias_declaration] = STATE(701),
    [sym_static_assert_declaration] = STATE(701),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6999),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(701),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1708),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3376),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3378),
    [sym_preproc_directive] = ACTIONS(3380),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(3382),
    [anon_sym_typedef] = ACTIONS(3384),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3446),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3390),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(3392),
    [anon_sym_static_assert] = ACTIONS(3394),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [707] = {
    [ts_builtin_sym_end] = ACTIONS(2386),
    [sym_identifier] = ACTIONS(2384),
    [aux_sym_preproc_include_token1] = ACTIONS(2384),
    [aux_sym_preproc_def_token1] = ACTIONS(2384),
    [aux_sym_preproc_if_token1] = ACTIONS(2384),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2384),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2384),
    [sym_preproc_directive] = ACTIONS(2384),
    [anon_sym_LPAREN2] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2386),
    [anon_sym_TILDE] = ACTIONS(2386),
    [anon_sym_DASH] = ACTIONS(2384),
    [anon_sym_PLUS] = ACTIONS(2384),
    [anon_sym_STAR] = ACTIONS(2386),
    [anon_sym_AMP_AMP] = ACTIONS(2386),
    [anon_sym_AMP] = ACTIONS(2384),
    [anon_sym___extension__] = ACTIONS(2384),
    [anon_sym_typedef] = ACTIONS(2384),
    [anon_sym___device__] = ACTIONS(2384),
    [anon_sym___host__] = ACTIONS(2384),
    [anon_sym___global__] = ACTIONS(2384),
    [anon_sym___forceinline__] = ACTIONS(2384),
    [anon_sym___noinline__] = ACTIONS(2384),
    [anon_sym_extern] = ACTIONS(2384),
    [anon_sym___attribute__] = ACTIONS(2384),
    [anon_sym_COLON_COLON] = ACTIONS(2386),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2386),
    [anon_sym___declspec] = ACTIONS(2384),
    [anon_sym___based] = ACTIONS(2384),
    [anon_sym___cdecl] = ACTIONS(2384),
    [anon_sym___clrcall] = ACTIONS(2384),
    [anon_sym___stdcall] = ACTIONS(2384),
    [anon_sym___fastcall] = ACTIONS(2384),
    [anon_sym___thiscall] = ACTIONS(2384),
    [anon_sym___vectorcall] = ACTIONS(2384),
    [anon_sym_LBRACE] = ACTIONS(2386),
    [anon_sym_signed] = ACTIONS(2384),
    [anon_sym_unsigned] = ACTIONS(2384),
    [anon_sym_long] = ACTIONS(2384),
    [anon_sym_short] = ACTIONS(2384),
    [anon_sym_LBRACK] = ACTIONS(2384),
    [anon_sym_static] = ACTIONS(2384),
    [anon_sym_register] = ACTIONS(2384),
    [anon_sym_inline] = ACTIONS(2384),
    [anon_sym___inline] = ACTIONS(2384),
    [anon_sym___inline__] = ACTIONS(2384),
    [anon_sym___forceinline] = ACTIONS(2384),
    [anon_sym_thread_local] = ACTIONS(2384),
    [anon_sym___thread] = ACTIONS(2384),
    [anon_sym_const] = ACTIONS(2384),
    [anon_sym_constexpr] = ACTIONS(2384),
    [anon_sym_volatile] = ACTIONS(2384),
    [anon_sym_restrict] = ACTIONS(2384),
    [anon_sym___restrict__] = ACTIONS(2384),
    [anon_sym__Atomic] = ACTIONS(2384),
    [anon_sym__Noreturn] = ACTIONS(2384),
    [anon_sym_noreturn] = ACTIONS(2384),
    [anon_sym_mutable] = ACTIONS(2384),
    [anon_sym_constinit] = ACTIONS(2384),
    [anon_sym_consteval] = ACTIONS(2384),
    [anon_sym___shared__] = ACTIONS(2384),
    [anon_sym___local__] = ACTIONS(2384),
    [anon_sym___constant__] = ACTIONS(2384),
    [anon_sym___managed__] = ACTIONS(2384),
    [anon_sym___grid_constant__] = ACTIONS(2384),
    [anon_sym_alignas] = ACTIONS(2384),
    [anon_sym__Alignas] = ACTIONS(2384),
    [sym_primitive_type] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2384),
    [anon_sym_class] = ACTIONS(2384),
    [anon_sym_struct] = ACTIONS(2384),
    [anon_sym_union] = ACTIONS(2384),
    [anon_sym_if] = ACTIONS(2384),
    [anon_sym_switch] = ACTIONS(2384),
    [anon_sym_case] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2384),
    [anon_sym_while] = ACTIONS(2384),
    [anon_sym_do] = ACTIONS(2384),
    [anon_sym_for] = ACTIONS(2384),
    [anon_sym_return] = ACTIONS(2384),
    [anon_sym_break] = ACTIONS(2384),
    [anon_sym_continue] = ACTIONS(2384),
    [anon_sym_goto] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_compl] = ACTIONS(2384),
    [anon_sym_DASH_DASH] = ACTIONS(2386),
    [anon_sym_PLUS_PLUS] = ACTIONS(2386),
    [anon_sym_sizeof] = ACTIONS(2384),
    [anon_sym___alignof__] = ACTIONS(2384),
    [anon_sym___alignof] = ACTIONS(2384),
    [anon_sym__alignof] = ACTIONS(2384),
    [anon_sym_alignof] = ACTIONS(2384),
    [anon_sym__Alignof] = ACTIONS(2384),
    [anon_sym_offsetof] = ACTIONS(2384),
    [anon_sym__Generic] = ACTIONS(2384),
    [anon_sym_asm] = ACTIONS(2384),
    [anon_sym___asm__] = ACTIONS(2384),
    [sym_number_literal] = ACTIONS(2386),
    [anon_sym_L_SQUOTE] = ACTIONS(2386),
    [anon_sym_u_SQUOTE] = ACTIONS(2386),
    [anon_sym_U_SQUOTE] = ACTIONS(2386),
    [anon_sym_u8_SQUOTE] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2386),
    [anon_sym_L_DQUOTE] = ACTIONS(2386),
    [anon_sym_u_DQUOTE] = ACTIONS(2386),
    [anon_sym_U_DQUOTE] = ACTIONS(2386),
    [anon_sym_u8_DQUOTE] = ACTIONS(2386),
    [anon_sym_DQUOTE] = ACTIONS(2386),
    [sym_true] = ACTIONS(2384),
    [sym_false] = ACTIONS(2384),
    [anon_sym_NULL] = ACTIONS(2384),
    [anon_sym_nullptr] = ACTIONS(2384),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2384),
    [anon_sym_decltype] = ACTIONS(2384),
    [sym_virtual] = ACTIONS(2384),
    [anon_sym_explicit] = ACTIONS(2384),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(2384),
    [anon_sym_operator] = ACTIONS(2384),
    [anon_sym_try] = ACTIONS(2384),
    [anon_sym_delete] = ACTIONS(2384),
    [anon_sym_throw] = ACTIONS(2384),
    [anon_sym_namespace] = ACTIONS(2384),
    [anon_sym_using] = ACTIONS(2384),
    [anon_sym_static_assert] = ACTIONS(2384),
    [anon_sym_concept] = ACTIONS(2384),
    [anon_sym_co_return] = ACTIONS(2384),
    [anon_sym_co_yield] = ACTIONS(2384),
    [anon_sym_R_DQUOTE] = ACTIONS(2386),
    [anon_sym_LR_DQUOTE] = ACTIONS(2386),
    [anon_sym_uR_DQUOTE] = ACTIONS(2386),
    [anon_sym_UR_DQUOTE] = ACTIONS(2386),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2386),
    [anon_sym_co_await] = ACTIONS(2384),
    [anon_sym_new] = ACTIONS(2384),
    [anon_sym_requires] = ACTIONS(2384),
    [sym_this] = ACTIONS(2384),
    [anon_sym___launch_bounds__] = ACTIONS(2384),
  },
  [708] = {
    [ts_builtin_sym_end] = ACTIONS(2092),
    [sym_identifier] = ACTIONS(2090),
    [aux_sym_preproc_include_token1] = ACTIONS(2090),
    [aux_sym_preproc_def_token1] = ACTIONS(2090),
    [aux_sym_preproc_if_token1] = ACTIONS(2090),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2090),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2090),
    [sym_preproc_directive] = ACTIONS(2090),
    [anon_sym_LPAREN2] = ACTIONS(2092),
    [anon_sym_BANG] = ACTIONS(2092),
    [anon_sym_TILDE] = ACTIONS(2092),
    [anon_sym_DASH] = ACTIONS(2090),
    [anon_sym_PLUS] = ACTIONS(2090),
    [anon_sym_STAR] = ACTIONS(2092),
    [anon_sym_AMP_AMP] = ACTIONS(2092),
    [anon_sym_AMP] = ACTIONS(2090),
    [anon_sym___extension__] = ACTIONS(2090),
    [anon_sym_typedef] = ACTIONS(2090),
    [anon_sym___device__] = ACTIONS(2090),
    [anon_sym___host__] = ACTIONS(2090),
    [anon_sym___global__] = ACTIONS(2090),
    [anon_sym___forceinline__] = ACTIONS(2090),
    [anon_sym___noinline__] = ACTIONS(2090),
    [anon_sym_extern] = ACTIONS(2090),
    [anon_sym___attribute__] = ACTIONS(2090),
    [anon_sym_COLON_COLON] = ACTIONS(2092),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2092),
    [anon_sym___declspec] = ACTIONS(2090),
    [anon_sym___based] = ACTIONS(2090),
    [anon_sym___cdecl] = ACTIONS(2090),
    [anon_sym___clrcall] = ACTIONS(2090),
    [anon_sym___stdcall] = ACTIONS(2090),
    [anon_sym___fastcall] = ACTIONS(2090),
    [anon_sym___thiscall] = ACTIONS(2090),
    [anon_sym___vectorcall] = ACTIONS(2090),
    [anon_sym_LBRACE] = ACTIONS(2092),
    [anon_sym_signed] = ACTIONS(2090),
    [anon_sym_unsigned] = ACTIONS(2090),
    [anon_sym_long] = ACTIONS(2090),
    [anon_sym_short] = ACTIONS(2090),
    [anon_sym_LBRACK] = ACTIONS(2090),
    [anon_sym_static] = ACTIONS(2090),
    [anon_sym_register] = ACTIONS(2090),
    [anon_sym_inline] = ACTIONS(2090),
    [anon_sym___inline] = ACTIONS(2090),
    [anon_sym___inline__] = ACTIONS(2090),
    [anon_sym___forceinline] = ACTIONS(2090),
    [anon_sym_thread_local] = ACTIONS(2090),
    [anon_sym___thread] = ACTIONS(2090),
    [anon_sym_const] = ACTIONS(2090),
    [anon_sym_constexpr] = ACTIONS(2090),
    [anon_sym_volatile] = ACTIONS(2090),
    [anon_sym_restrict] = ACTIONS(2090),
    [anon_sym___restrict__] = ACTIONS(2090),
    [anon_sym__Atomic] = ACTIONS(2090),
    [anon_sym__Noreturn] = ACTIONS(2090),
    [anon_sym_noreturn] = ACTIONS(2090),
    [anon_sym_mutable] = ACTIONS(2090),
    [anon_sym_constinit] = ACTIONS(2090),
    [anon_sym_consteval] = ACTIONS(2090),
    [anon_sym___shared__] = ACTIONS(2090),
    [anon_sym___local__] = ACTIONS(2090),
    [anon_sym___constant__] = ACTIONS(2090),
    [anon_sym___managed__] = ACTIONS(2090),
    [anon_sym___grid_constant__] = ACTIONS(2090),
    [anon_sym_alignas] = ACTIONS(2090),
    [anon_sym__Alignas] = ACTIONS(2090),
    [sym_primitive_type] = ACTIONS(2090),
    [anon_sym_enum] = ACTIONS(2090),
    [anon_sym_class] = ACTIONS(2090),
    [anon_sym_struct] = ACTIONS(2090),
    [anon_sym_union] = ACTIONS(2090),
    [anon_sym_if] = ACTIONS(2090),
    [anon_sym_switch] = ACTIONS(2090),
    [anon_sym_case] = ACTIONS(2090),
    [anon_sym_default] = ACTIONS(2090),
    [anon_sym_while] = ACTIONS(2090),
    [anon_sym_do] = ACTIONS(2090),
    [anon_sym_for] = ACTIONS(2090),
    [anon_sym_return] = ACTIONS(2090),
    [anon_sym_break] = ACTIONS(2090),
    [anon_sym_continue] = ACTIONS(2090),
    [anon_sym_goto] = ACTIONS(2090),
    [anon_sym_not] = ACTIONS(2090),
    [anon_sym_compl] = ACTIONS(2090),
    [anon_sym_DASH_DASH] = ACTIONS(2092),
    [anon_sym_PLUS_PLUS] = ACTIONS(2092),
    [anon_sym_sizeof] = ACTIONS(2090),
    [anon_sym___alignof__] = ACTIONS(2090),
    [anon_sym___alignof] = ACTIONS(2090),
    [anon_sym__alignof] = ACTIONS(2090),
    [anon_sym_alignof] = ACTIONS(2090),
    [anon_sym__Alignof] = ACTIONS(2090),
    [anon_sym_offsetof] = ACTIONS(2090),
    [anon_sym__Generic] = ACTIONS(2090),
    [anon_sym_asm] = ACTIONS(2090),
    [anon_sym___asm__] = ACTIONS(2090),
    [sym_number_literal] = ACTIONS(2092),
    [anon_sym_L_SQUOTE] = ACTIONS(2092),
    [anon_sym_u_SQUOTE] = ACTIONS(2092),
    [anon_sym_U_SQUOTE] = ACTIONS(2092),
    [anon_sym_u8_SQUOTE] = ACTIONS(2092),
    [anon_sym_SQUOTE] = ACTIONS(2092),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2090),
    [sym_false] = ACTIONS(2090),
    [anon_sym_NULL] = ACTIONS(2090),
    [anon_sym_nullptr] = ACTIONS(2090),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2090),
    [anon_sym_decltype] = ACTIONS(2090),
    [sym_virtual] = ACTIONS(2090),
    [anon_sym_explicit] = ACTIONS(2090),
    [anon_sym_typename] = ACTIONS(2090),
    [anon_sym_template] = ACTIONS(2090),
    [anon_sym_operator] = ACTIONS(2090),
    [anon_sym_try] = ACTIONS(2090),
    [anon_sym_delete] = ACTIONS(2090),
    [anon_sym_throw] = ACTIONS(2090),
    [anon_sym_namespace] = ACTIONS(2090),
    [anon_sym_using] = ACTIONS(2090),
    [anon_sym_static_assert] = ACTIONS(2090),
    [anon_sym_concept] = ACTIONS(2090),
    [anon_sym_co_return] = ACTIONS(2090),
    [anon_sym_co_yield] = ACTIONS(2090),
    [anon_sym_R_DQUOTE] = ACTIONS(2092),
    [anon_sym_LR_DQUOTE] = ACTIONS(2092),
    [anon_sym_uR_DQUOTE] = ACTIONS(2092),
    [anon_sym_UR_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2092),
    [anon_sym_co_await] = ACTIONS(2090),
    [anon_sym_new] = ACTIONS(2090),
    [anon_sym_requires] = ACTIONS(2090),
    [sym_this] = ACTIONS(2090),
    [anon_sym___launch_bounds__] = ACTIONS(2090),
  },
  [709] = {
    [ts_builtin_sym_end] = ACTIONS(2306),
    [sym_identifier] = ACTIONS(2304),
    [aux_sym_preproc_include_token1] = ACTIONS(2304),
    [aux_sym_preproc_def_token1] = ACTIONS(2304),
    [aux_sym_preproc_if_token1] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2304),
    [sym_preproc_directive] = ACTIONS(2304),
    [anon_sym_LPAREN2] = ACTIONS(2306),
    [anon_sym_BANG] = ACTIONS(2306),
    [anon_sym_TILDE] = ACTIONS(2306),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym___extension__] = ACTIONS(2304),
    [anon_sym_typedef] = ACTIONS(2304),
    [anon_sym___device__] = ACTIONS(2304),
    [anon_sym___host__] = ACTIONS(2304),
    [anon_sym___global__] = ACTIONS(2304),
    [anon_sym___forceinline__] = ACTIONS(2304),
    [anon_sym___noinline__] = ACTIONS(2304),
    [anon_sym_extern] = ACTIONS(2304),
    [anon_sym___attribute__] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2306),
    [anon_sym___declspec] = ACTIONS(2304),
    [anon_sym___based] = ACTIONS(2304),
    [anon_sym___cdecl] = ACTIONS(2304),
    [anon_sym___clrcall] = ACTIONS(2304),
    [anon_sym___stdcall] = ACTIONS(2304),
    [anon_sym___fastcall] = ACTIONS(2304),
    [anon_sym___thiscall] = ACTIONS(2304),
    [anon_sym___vectorcall] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_signed] = ACTIONS(2304),
    [anon_sym_unsigned] = ACTIONS(2304),
    [anon_sym_long] = ACTIONS(2304),
    [anon_sym_short] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_register] = ACTIONS(2304),
    [anon_sym_inline] = ACTIONS(2304),
    [anon_sym___inline] = ACTIONS(2304),
    [anon_sym___inline__] = ACTIONS(2304),
    [anon_sym___forceinline] = ACTIONS(2304),
    [anon_sym_thread_local] = ACTIONS(2304),
    [anon_sym___thread] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_constexpr] = ACTIONS(2304),
    [anon_sym_volatile] = ACTIONS(2304),
    [anon_sym_restrict] = ACTIONS(2304),
    [anon_sym___restrict__] = ACTIONS(2304),
    [anon_sym__Atomic] = ACTIONS(2304),
    [anon_sym__Noreturn] = ACTIONS(2304),
    [anon_sym_noreturn] = ACTIONS(2304),
    [anon_sym_mutable] = ACTIONS(2304),
    [anon_sym_constinit] = ACTIONS(2304),
    [anon_sym_consteval] = ACTIONS(2304),
    [anon_sym___shared__] = ACTIONS(2304),
    [anon_sym___local__] = ACTIONS(2304),
    [anon_sym___constant__] = ACTIONS(2304),
    [anon_sym___managed__] = ACTIONS(2304),
    [anon_sym___grid_constant__] = ACTIONS(2304),
    [anon_sym_alignas] = ACTIONS(2304),
    [anon_sym__Alignas] = ACTIONS(2304),
    [sym_primitive_type] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_struct] = ACTIONS(2304),
    [anon_sym_union] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_case] = ACTIONS(2304),
    [anon_sym_default] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_goto] = ACTIONS(2304),
    [anon_sym_not] = ACTIONS(2304),
    [anon_sym_compl] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_sizeof] = ACTIONS(2304),
    [anon_sym___alignof__] = ACTIONS(2304),
    [anon_sym___alignof] = ACTIONS(2304),
    [anon_sym__alignof] = ACTIONS(2304),
    [anon_sym_alignof] = ACTIONS(2304),
    [anon_sym__Alignof] = ACTIONS(2304),
    [anon_sym_offsetof] = ACTIONS(2304),
    [anon_sym__Generic] = ACTIONS(2304),
    [anon_sym_asm] = ACTIONS(2304),
    [anon_sym___asm__] = ACTIONS(2304),
    [sym_number_literal] = ACTIONS(2306),
    [anon_sym_L_SQUOTE] = ACTIONS(2306),
    [anon_sym_u_SQUOTE] = ACTIONS(2306),
    [anon_sym_U_SQUOTE] = ACTIONS(2306),
    [anon_sym_u8_SQUOTE] = ACTIONS(2306),
    [anon_sym_SQUOTE] = ACTIONS(2306),
    [anon_sym_L_DQUOTE] = ACTIONS(2306),
    [anon_sym_u_DQUOTE] = ACTIONS(2306),
    [anon_sym_U_DQUOTE] = ACTIONS(2306),
    [anon_sym_u8_DQUOTE] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [anon_sym_NULL] = ACTIONS(2304),
    [anon_sym_nullptr] = ACTIONS(2304),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2304),
    [anon_sym_decltype] = ACTIONS(2304),
    [sym_virtual] = ACTIONS(2304),
    [anon_sym_explicit] = ACTIONS(2304),
    [anon_sym_typename] = ACTIONS(2304),
    [anon_sym_template] = ACTIONS(2304),
    [anon_sym_operator] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_delete] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_namespace] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_static_assert] = ACTIONS(2304),
    [anon_sym_concept] = ACTIONS(2304),
    [anon_sym_co_return] = ACTIONS(2304),
    [anon_sym_co_yield] = ACTIONS(2304),
    [anon_sym_R_DQUOTE] = ACTIONS(2306),
    [anon_sym_LR_DQUOTE] = ACTIONS(2306),
    [anon_sym_uR_DQUOTE] = ACTIONS(2306),
    [anon_sym_UR_DQUOTE] = ACTIONS(2306),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2306),
    [anon_sym_co_await] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_requires] = ACTIONS(2304),
    [sym_this] = ACTIONS(2304),
    [anon_sym___launch_bounds__] = ACTIONS(2304),
  },
  [710] = {
    [ts_builtin_sym_end] = ACTIONS(2302),
    [sym_identifier] = ACTIONS(2300),
    [aux_sym_preproc_include_token1] = ACTIONS(2300),
    [aux_sym_preproc_def_token1] = ACTIONS(2300),
    [aux_sym_preproc_if_token1] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2300),
    [sym_preproc_directive] = ACTIONS(2300),
    [anon_sym_LPAREN2] = ACTIONS(2302),
    [anon_sym_BANG] = ACTIONS(2302),
    [anon_sym_TILDE] = ACTIONS(2302),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2302),
    [anon_sym_AMP_AMP] = ACTIONS(2302),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym___extension__] = ACTIONS(2300),
    [anon_sym_typedef] = ACTIONS(2300),
    [anon_sym___device__] = ACTIONS(2300),
    [anon_sym___host__] = ACTIONS(2300),
    [anon_sym___global__] = ACTIONS(2300),
    [anon_sym___forceinline__] = ACTIONS(2300),
    [anon_sym___noinline__] = ACTIONS(2300),
    [anon_sym_extern] = ACTIONS(2300),
    [anon_sym___attribute__] = ACTIONS(2300),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2302),
    [anon_sym___declspec] = ACTIONS(2300),
    [anon_sym___based] = ACTIONS(2300),
    [anon_sym___cdecl] = ACTIONS(2300),
    [anon_sym___clrcall] = ACTIONS(2300),
    [anon_sym___stdcall] = ACTIONS(2300),
    [anon_sym___fastcall] = ACTIONS(2300),
    [anon_sym___thiscall] = ACTIONS(2300),
    [anon_sym___vectorcall] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_signed] = ACTIONS(2300),
    [anon_sym_unsigned] = ACTIONS(2300),
    [anon_sym_long] = ACTIONS(2300),
    [anon_sym_short] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_register] = ACTIONS(2300),
    [anon_sym_inline] = ACTIONS(2300),
    [anon_sym___inline] = ACTIONS(2300),
    [anon_sym___inline__] = ACTIONS(2300),
    [anon_sym___forceinline] = ACTIONS(2300),
    [anon_sym_thread_local] = ACTIONS(2300),
    [anon_sym___thread] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_constexpr] = ACTIONS(2300),
    [anon_sym_volatile] = ACTIONS(2300),
    [anon_sym_restrict] = ACTIONS(2300),
    [anon_sym___restrict__] = ACTIONS(2300),
    [anon_sym__Atomic] = ACTIONS(2300),
    [anon_sym__Noreturn] = ACTIONS(2300),
    [anon_sym_noreturn] = ACTIONS(2300),
    [anon_sym_mutable] = ACTIONS(2300),
    [anon_sym_constinit] = ACTIONS(2300),
    [anon_sym_consteval] = ACTIONS(2300),
    [anon_sym___shared__] = ACTIONS(2300),
    [anon_sym___local__] = ACTIONS(2300),
    [anon_sym___constant__] = ACTIONS(2300),
    [anon_sym___managed__] = ACTIONS(2300),
    [anon_sym___grid_constant__] = ACTIONS(2300),
    [anon_sym_alignas] = ACTIONS(2300),
    [anon_sym__Alignas] = ACTIONS(2300),
    [sym_primitive_type] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_struct] = ACTIONS(2300),
    [anon_sym_union] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_case] = ACTIONS(2300),
    [anon_sym_default] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_goto] = ACTIONS(2300),
    [anon_sym_not] = ACTIONS(2300),
    [anon_sym_compl] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2302),
    [anon_sym_PLUS_PLUS] = ACTIONS(2302),
    [anon_sym_sizeof] = ACTIONS(2300),
    [anon_sym___alignof__] = ACTIONS(2300),
    [anon_sym___alignof] = ACTIONS(2300),
    [anon_sym__alignof] = ACTIONS(2300),
    [anon_sym_alignof] = ACTIONS(2300),
    [anon_sym__Alignof] = ACTIONS(2300),
    [anon_sym_offsetof] = ACTIONS(2300),
    [anon_sym__Generic] = ACTIONS(2300),
    [anon_sym_asm] = ACTIONS(2300),
    [anon_sym___asm__] = ACTIONS(2300),
    [sym_number_literal] = ACTIONS(2302),
    [anon_sym_L_SQUOTE] = ACTIONS(2302),
    [anon_sym_u_SQUOTE] = ACTIONS(2302),
    [anon_sym_U_SQUOTE] = ACTIONS(2302),
    [anon_sym_u8_SQUOTE] = ACTIONS(2302),
    [anon_sym_SQUOTE] = ACTIONS(2302),
    [anon_sym_L_DQUOTE] = ACTIONS(2302),
    [anon_sym_u_DQUOTE] = ACTIONS(2302),
    [anon_sym_U_DQUOTE] = ACTIONS(2302),
    [anon_sym_u8_DQUOTE] = ACTIONS(2302),
    [anon_sym_DQUOTE] = ACTIONS(2302),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [anon_sym_NULL] = ACTIONS(2300),
    [anon_sym_nullptr] = ACTIONS(2300),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2300),
    [anon_sym_decltype] = ACTIONS(2300),
    [sym_virtual] = ACTIONS(2300),
    [anon_sym_explicit] = ACTIONS(2300),
    [anon_sym_typename] = ACTIONS(2300),
    [anon_sym_template] = ACTIONS(2300),
    [anon_sym_operator] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_delete] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_static_assert] = ACTIONS(2300),
    [anon_sym_concept] = ACTIONS(2300),
    [anon_sym_co_return] = ACTIONS(2300),
    [anon_sym_co_yield] = ACTIONS(2300),
    [anon_sym_R_DQUOTE] = ACTIONS(2302),
    [anon_sym_LR_DQUOTE] = ACTIONS(2302),
    [anon_sym_uR_DQUOTE] = ACTIONS(2302),
    [anon_sym_UR_DQUOTE] = ACTIONS(2302),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2302),
    [anon_sym_co_await] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_requires] = ACTIONS(2300),
    [sym_this] = ACTIONS(2300),
    [anon_sym___launch_bounds__] = ACTIONS(2300),
  },
  [711] = {
    [ts_builtin_sym_end] = ACTIONS(2459),
    [sym_identifier] = ACTIONS(2457),
    [aux_sym_preproc_include_token1] = ACTIONS(2457),
    [aux_sym_preproc_def_token1] = ACTIONS(2457),
    [aux_sym_preproc_if_token1] = ACTIONS(2457),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2457),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2457),
    [sym_preproc_directive] = ACTIONS(2457),
    [anon_sym_LPAREN2] = ACTIONS(2459),
    [anon_sym_BANG] = ACTIONS(2459),
    [anon_sym_TILDE] = ACTIONS(2459),
    [anon_sym_DASH] = ACTIONS(2457),
    [anon_sym_PLUS] = ACTIONS(2457),
    [anon_sym_STAR] = ACTIONS(2459),
    [anon_sym_AMP_AMP] = ACTIONS(2459),
    [anon_sym_AMP] = ACTIONS(2457),
    [anon_sym___extension__] = ACTIONS(2457),
    [anon_sym_typedef] = ACTIONS(2457),
    [anon_sym___device__] = ACTIONS(2457),
    [anon_sym___host__] = ACTIONS(2457),
    [anon_sym___global__] = ACTIONS(2457),
    [anon_sym___forceinline__] = ACTIONS(2457),
    [anon_sym___noinline__] = ACTIONS(2457),
    [anon_sym_extern] = ACTIONS(2457),
    [anon_sym___attribute__] = ACTIONS(2457),
    [anon_sym_COLON_COLON] = ACTIONS(2459),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2459),
    [anon_sym___declspec] = ACTIONS(2457),
    [anon_sym___based] = ACTIONS(2457),
    [anon_sym___cdecl] = ACTIONS(2457),
    [anon_sym___clrcall] = ACTIONS(2457),
    [anon_sym___stdcall] = ACTIONS(2457),
    [anon_sym___fastcall] = ACTIONS(2457),
    [anon_sym___thiscall] = ACTIONS(2457),
    [anon_sym___vectorcall] = ACTIONS(2457),
    [anon_sym_LBRACE] = ACTIONS(2459),
    [anon_sym_signed] = ACTIONS(2457),
    [anon_sym_unsigned] = ACTIONS(2457),
    [anon_sym_long] = ACTIONS(2457),
    [anon_sym_short] = ACTIONS(2457),
    [anon_sym_LBRACK] = ACTIONS(2457),
    [anon_sym_static] = ACTIONS(2457),
    [anon_sym_register] = ACTIONS(2457),
    [anon_sym_inline] = ACTIONS(2457),
    [anon_sym___inline] = ACTIONS(2457),
    [anon_sym___inline__] = ACTIONS(2457),
    [anon_sym___forceinline] = ACTIONS(2457),
    [anon_sym_thread_local] = ACTIONS(2457),
    [anon_sym___thread] = ACTIONS(2457),
    [anon_sym_const] = ACTIONS(2457),
    [anon_sym_constexpr] = ACTIONS(2457),
    [anon_sym_volatile] = ACTIONS(2457),
    [anon_sym_restrict] = ACTIONS(2457),
    [anon_sym___restrict__] = ACTIONS(2457),
    [anon_sym__Atomic] = ACTIONS(2457),
    [anon_sym__Noreturn] = ACTIONS(2457),
    [anon_sym_noreturn] = ACTIONS(2457),
    [anon_sym_mutable] = ACTIONS(2457),
    [anon_sym_constinit] = ACTIONS(2457),
    [anon_sym_consteval] = ACTIONS(2457),
    [anon_sym___shared__] = ACTIONS(2457),
    [anon_sym___local__] = ACTIONS(2457),
    [anon_sym___constant__] = ACTIONS(2457),
    [anon_sym___managed__] = ACTIONS(2457),
    [anon_sym___grid_constant__] = ACTIONS(2457),
    [anon_sym_alignas] = ACTIONS(2457),
    [anon_sym__Alignas] = ACTIONS(2457),
    [sym_primitive_type] = ACTIONS(2457),
    [anon_sym_enum] = ACTIONS(2457),
    [anon_sym_class] = ACTIONS(2457),
    [anon_sym_struct] = ACTIONS(2457),
    [anon_sym_union] = ACTIONS(2457),
    [anon_sym_if] = ACTIONS(2457),
    [anon_sym_switch] = ACTIONS(2457),
    [anon_sym_case] = ACTIONS(2457),
    [anon_sym_default] = ACTIONS(2457),
    [anon_sym_while] = ACTIONS(2457),
    [anon_sym_do] = ACTIONS(2457),
    [anon_sym_for] = ACTIONS(2457),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_break] = ACTIONS(2457),
    [anon_sym_continue] = ACTIONS(2457),
    [anon_sym_goto] = ACTIONS(2457),
    [anon_sym_not] = ACTIONS(2457),
    [anon_sym_compl] = ACTIONS(2457),
    [anon_sym_DASH_DASH] = ACTIONS(2459),
    [anon_sym_PLUS_PLUS] = ACTIONS(2459),
    [anon_sym_sizeof] = ACTIONS(2457),
    [anon_sym___alignof__] = ACTIONS(2457),
    [anon_sym___alignof] = ACTIONS(2457),
    [anon_sym__alignof] = ACTIONS(2457),
    [anon_sym_alignof] = ACTIONS(2457),
    [anon_sym__Alignof] = ACTIONS(2457),
    [anon_sym_offsetof] = ACTIONS(2457),
    [anon_sym__Generic] = ACTIONS(2457),
    [anon_sym_asm] = ACTIONS(2457),
    [anon_sym___asm__] = ACTIONS(2457),
    [sym_number_literal] = ACTIONS(2459),
    [anon_sym_L_SQUOTE] = ACTIONS(2459),
    [anon_sym_u_SQUOTE] = ACTIONS(2459),
    [anon_sym_U_SQUOTE] = ACTIONS(2459),
    [anon_sym_u8_SQUOTE] = ACTIONS(2459),
    [anon_sym_SQUOTE] = ACTIONS(2459),
    [anon_sym_L_DQUOTE] = ACTIONS(2459),
    [anon_sym_u_DQUOTE] = ACTIONS(2459),
    [anon_sym_U_DQUOTE] = ACTIONS(2459),
    [anon_sym_u8_DQUOTE] = ACTIONS(2459),
    [anon_sym_DQUOTE] = ACTIONS(2459),
    [sym_true] = ACTIONS(2457),
    [sym_false] = ACTIONS(2457),
    [anon_sym_NULL] = ACTIONS(2457),
    [anon_sym_nullptr] = ACTIONS(2457),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2457),
    [anon_sym_decltype] = ACTIONS(2457),
    [sym_virtual] = ACTIONS(2457),
    [anon_sym_explicit] = ACTIONS(2457),
    [anon_sym_typename] = ACTIONS(2457),
    [anon_sym_template] = ACTIONS(2457),
    [anon_sym_operator] = ACTIONS(2457),
    [anon_sym_try] = ACTIONS(2457),
    [anon_sym_delete] = ACTIONS(2457),
    [anon_sym_throw] = ACTIONS(2457),
    [anon_sym_namespace] = ACTIONS(2457),
    [anon_sym_using] = ACTIONS(2457),
    [anon_sym_static_assert] = ACTIONS(2457),
    [anon_sym_concept] = ACTIONS(2457),
    [anon_sym_co_return] = ACTIONS(2457),
    [anon_sym_co_yield] = ACTIONS(2457),
    [anon_sym_R_DQUOTE] = ACTIONS(2459),
    [anon_sym_LR_DQUOTE] = ACTIONS(2459),
    [anon_sym_uR_DQUOTE] = ACTIONS(2459),
    [anon_sym_UR_DQUOTE] = ACTIONS(2459),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2459),
    [anon_sym_co_await] = ACTIONS(2457),
    [anon_sym_new] = ACTIONS(2457),
    [anon_sym_requires] = ACTIONS(2457),
    [sym_this] = ACTIONS(2457),
    [anon_sym___launch_bounds__] = ACTIONS(2457),
  },
  [712] = {
    [ts_builtin_sym_end] = ACTIONS(2164),
    [sym_identifier] = ACTIONS(2162),
    [aux_sym_preproc_include_token1] = ACTIONS(2162),
    [aux_sym_preproc_def_token1] = ACTIONS(2162),
    [aux_sym_preproc_if_token1] = ACTIONS(2162),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2162),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2162),
    [sym_preproc_directive] = ACTIONS(2162),
    [anon_sym_LPAREN2] = ACTIONS(2164),
    [anon_sym_BANG] = ACTIONS(2164),
    [anon_sym_TILDE] = ACTIONS(2164),
    [anon_sym_DASH] = ACTIONS(2162),
    [anon_sym_PLUS] = ACTIONS(2162),
    [anon_sym_STAR] = ACTIONS(2164),
    [anon_sym_AMP_AMP] = ACTIONS(2164),
    [anon_sym_AMP] = ACTIONS(2162),
    [anon_sym___extension__] = ACTIONS(2162),
    [anon_sym_typedef] = ACTIONS(2162),
    [anon_sym___device__] = ACTIONS(2162),
    [anon_sym___host__] = ACTIONS(2162),
    [anon_sym___global__] = ACTIONS(2162),
    [anon_sym___forceinline__] = ACTIONS(2162),
    [anon_sym___noinline__] = ACTIONS(2162),
    [anon_sym_extern] = ACTIONS(2162),
    [anon_sym___attribute__] = ACTIONS(2162),
    [anon_sym_COLON_COLON] = ACTIONS(2164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2164),
    [anon_sym___declspec] = ACTIONS(2162),
    [anon_sym___based] = ACTIONS(2162),
    [anon_sym___cdecl] = ACTIONS(2162),
    [anon_sym___clrcall] = ACTIONS(2162),
    [anon_sym___stdcall] = ACTIONS(2162),
    [anon_sym___fastcall] = ACTIONS(2162),
    [anon_sym___thiscall] = ACTIONS(2162),
    [anon_sym___vectorcall] = ACTIONS(2162),
    [anon_sym_LBRACE] = ACTIONS(2164),
    [anon_sym_signed] = ACTIONS(2162),
    [anon_sym_unsigned] = ACTIONS(2162),
    [anon_sym_long] = ACTIONS(2162),
    [anon_sym_short] = ACTIONS(2162),
    [anon_sym_LBRACK] = ACTIONS(2162),
    [anon_sym_static] = ACTIONS(2162),
    [anon_sym_register] = ACTIONS(2162),
    [anon_sym_inline] = ACTIONS(2162),
    [anon_sym___inline] = ACTIONS(2162),
    [anon_sym___inline__] = ACTIONS(2162),
    [anon_sym___forceinline] = ACTIONS(2162),
    [anon_sym_thread_local] = ACTIONS(2162),
    [anon_sym___thread] = ACTIONS(2162),
    [anon_sym_const] = ACTIONS(2162),
    [anon_sym_constexpr] = ACTIONS(2162),
    [anon_sym_volatile] = ACTIONS(2162),
    [anon_sym_restrict] = ACTIONS(2162),
    [anon_sym___restrict__] = ACTIONS(2162),
    [anon_sym__Atomic] = ACTIONS(2162),
    [anon_sym__Noreturn] = ACTIONS(2162),
    [anon_sym_noreturn] = ACTIONS(2162),
    [anon_sym_mutable] = ACTIONS(2162),
    [anon_sym_constinit] = ACTIONS(2162),
    [anon_sym_consteval] = ACTIONS(2162),
    [anon_sym___shared__] = ACTIONS(2162),
    [anon_sym___local__] = ACTIONS(2162),
    [anon_sym___constant__] = ACTIONS(2162),
    [anon_sym___managed__] = ACTIONS(2162),
    [anon_sym___grid_constant__] = ACTIONS(2162),
    [anon_sym_alignas] = ACTIONS(2162),
    [anon_sym__Alignas] = ACTIONS(2162),
    [sym_primitive_type] = ACTIONS(2162),
    [anon_sym_enum] = ACTIONS(2162),
    [anon_sym_class] = ACTIONS(2162),
    [anon_sym_struct] = ACTIONS(2162),
    [anon_sym_union] = ACTIONS(2162),
    [anon_sym_if] = ACTIONS(2162),
    [anon_sym_switch] = ACTIONS(2162),
    [anon_sym_case] = ACTIONS(2162),
    [anon_sym_default] = ACTIONS(2162),
    [anon_sym_while] = ACTIONS(2162),
    [anon_sym_do] = ACTIONS(2162),
    [anon_sym_for] = ACTIONS(2162),
    [anon_sym_return] = ACTIONS(2162),
    [anon_sym_break] = ACTIONS(2162),
    [anon_sym_continue] = ACTIONS(2162),
    [anon_sym_goto] = ACTIONS(2162),
    [anon_sym_not] = ACTIONS(2162),
    [anon_sym_compl] = ACTIONS(2162),
    [anon_sym_DASH_DASH] = ACTIONS(2164),
    [anon_sym_PLUS_PLUS] = ACTIONS(2164),
    [anon_sym_sizeof] = ACTIONS(2162),
    [anon_sym___alignof__] = ACTIONS(2162),
    [anon_sym___alignof] = ACTIONS(2162),
    [anon_sym__alignof] = ACTIONS(2162),
    [anon_sym_alignof] = ACTIONS(2162),
    [anon_sym__Alignof] = ACTIONS(2162),
    [anon_sym_offsetof] = ACTIONS(2162),
    [anon_sym__Generic] = ACTIONS(2162),
    [anon_sym_asm] = ACTIONS(2162),
    [anon_sym___asm__] = ACTIONS(2162),
    [sym_number_literal] = ACTIONS(2164),
    [anon_sym_L_SQUOTE] = ACTIONS(2164),
    [anon_sym_u_SQUOTE] = ACTIONS(2164),
    [anon_sym_U_SQUOTE] = ACTIONS(2164),
    [anon_sym_u8_SQUOTE] = ACTIONS(2164),
    [anon_sym_SQUOTE] = ACTIONS(2164),
    [anon_sym_L_DQUOTE] = ACTIONS(2164),
    [anon_sym_u_DQUOTE] = ACTIONS(2164),
    [anon_sym_U_DQUOTE] = ACTIONS(2164),
    [anon_sym_u8_DQUOTE] = ACTIONS(2164),
    [anon_sym_DQUOTE] = ACTIONS(2164),
    [sym_true] = ACTIONS(2162),
    [sym_false] = ACTIONS(2162),
    [anon_sym_NULL] = ACTIONS(2162),
    [anon_sym_nullptr] = ACTIONS(2162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2162),
    [anon_sym_decltype] = ACTIONS(2162),
    [sym_virtual] = ACTIONS(2162),
    [anon_sym_explicit] = ACTIONS(2162),
    [anon_sym_typename] = ACTIONS(2162),
    [anon_sym_template] = ACTIONS(2162),
    [anon_sym_operator] = ACTIONS(2162),
    [anon_sym_try] = ACTIONS(2162),
    [anon_sym_delete] = ACTIONS(2162),
    [anon_sym_throw] = ACTIONS(2162),
    [anon_sym_namespace] = ACTIONS(2162),
    [anon_sym_using] = ACTIONS(2162),
    [anon_sym_static_assert] = ACTIONS(2162),
    [anon_sym_concept] = ACTIONS(2162),
    [anon_sym_co_return] = ACTIONS(2162),
    [anon_sym_co_yield] = ACTIONS(2162),
    [anon_sym_R_DQUOTE] = ACTIONS(2164),
    [anon_sym_LR_DQUOTE] = ACTIONS(2164),
    [anon_sym_uR_DQUOTE] = ACTIONS(2164),
    [anon_sym_UR_DQUOTE] = ACTIONS(2164),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2164),
    [anon_sym_co_await] = ACTIONS(2162),
    [anon_sym_new] = ACTIONS(2162),
    [anon_sym_requires] = ACTIONS(2162),
    [sym_this] = ACTIONS(2162),
    [anon_sym___launch_bounds__] = ACTIONS(2162),
  },
  [713] = {
    [sym_preproc_def] = STATE(701),
    [sym_preproc_function_def] = STATE(701),
    [sym_preproc_call] = STATE(701),
    [sym_preproc_if_in_field_declaration_list] = STATE(701),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(701),
    [sym_type_definition] = STATE(701),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5894),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6463),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(701),
    [sym_field_declaration] = STATE(701),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1708),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(701),
    [sym_operator_cast] = STATE(6999),
    [sym_inline_method_definition] = STATE(701),
    [sym__constructor_specifiers] = STATE(1708),
    [sym_operator_cast_definition] = STATE(701),
    [sym_operator_cast_declaration] = STATE(701),
    [sym_constructor_or_destructor_definition] = STATE(701),
    [sym_constructor_or_destructor_declaration] = STATE(701),
    [sym_friend_declaration] = STATE(701),
    [sym_access_specifier] = STATE(8255),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(701),
    [sym_alias_declaration] = STATE(701),
    [sym_static_assert_declaration] = STATE(701),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6999),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(701),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1708),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3376),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3378),
    [sym_preproc_directive] = ACTIONS(3380),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(3382),
    [anon_sym_typedef] = ACTIONS(3384),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3448),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3390),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(3392),
    [anon_sym_static_assert] = ACTIONS(3394),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [714] = {
    [ts_builtin_sym_end] = ACTIONS(2386),
    [sym_identifier] = ACTIONS(2384),
    [aux_sym_preproc_include_token1] = ACTIONS(2384),
    [aux_sym_preproc_def_token1] = ACTIONS(2384),
    [aux_sym_preproc_if_token1] = ACTIONS(2384),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2384),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2384),
    [sym_preproc_directive] = ACTIONS(2384),
    [anon_sym_LPAREN2] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2386),
    [anon_sym_TILDE] = ACTIONS(2386),
    [anon_sym_DASH] = ACTIONS(2384),
    [anon_sym_PLUS] = ACTIONS(2384),
    [anon_sym_STAR] = ACTIONS(2386),
    [anon_sym_AMP_AMP] = ACTIONS(2386),
    [anon_sym_AMP] = ACTIONS(2384),
    [anon_sym___extension__] = ACTIONS(2384),
    [anon_sym_typedef] = ACTIONS(2384),
    [anon_sym___device__] = ACTIONS(2384),
    [anon_sym___host__] = ACTIONS(2384),
    [anon_sym___global__] = ACTIONS(2384),
    [anon_sym___forceinline__] = ACTIONS(2384),
    [anon_sym___noinline__] = ACTIONS(2384),
    [anon_sym_extern] = ACTIONS(2384),
    [anon_sym___attribute__] = ACTIONS(2384),
    [anon_sym_COLON_COLON] = ACTIONS(2386),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2386),
    [anon_sym___declspec] = ACTIONS(2384),
    [anon_sym___based] = ACTIONS(2384),
    [anon_sym___cdecl] = ACTIONS(2384),
    [anon_sym___clrcall] = ACTIONS(2384),
    [anon_sym___stdcall] = ACTIONS(2384),
    [anon_sym___fastcall] = ACTIONS(2384),
    [anon_sym___thiscall] = ACTIONS(2384),
    [anon_sym___vectorcall] = ACTIONS(2384),
    [anon_sym_LBRACE] = ACTIONS(2386),
    [anon_sym_signed] = ACTIONS(2384),
    [anon_sym_unsigned] = ACTIONS(2384),
    [anon_sym_long] = ACTIONS(2384),
    [anon_sym_short] = ACTIONS(2384),
    [anon_sym_LBRACK] = ACTIONS(2384),
    [anon_sym_static] = ACTIONS(2384),
    [anon_sym_register] = ACTIONS(2384),
    [anon_sym_inline] = ACTIONS(2384),
    [anon_sym___inline] = ACTIONS(2384),
    [anon_sym___inline__] = ACTIONS(2384),
    [anon_sym___forceinline] = ACTIONS(2384),
    [anon_sym_thread_local] = ACTIONS(2384),
    [anon_sym___thread] = ACTIONS(2384),
    [anon_sym_const] = ACTIONS(2384),
    [anon_sym_constexpr] = ACTIONS(2384),
    [anon_sym_volatile] = ACTIONS(2384),
    [anon_sym_restrict] = ACTIONS(2384),
    [anon_sym___restrict__] = ACTIONS(2384),
    [anon_sym__Atomic] = ACTIONS(2384),
    [anon_sym__Noreturn] = ACTIONS(2384),
    [anon_sym_noreturn] = ACTIONS(2384),
    [anon_sym_mutable] = ACTIONS(2384),
    [anon_sym_constinit] = ACTIONS(2384),
    [anon_sym_consteval] = ACTIONS(2384),
    [anon_sym___shared__] = ACTIONS(2384),
    [anon_sym___local__] = ACTIONS(2384),
    [anon_sym___constant__] = ACTIONS(2384),
    [anon_sym___managed__] = ACTIONS(2384),
    [anon_sym___grid_constant__] = ACTIONS(2384),
    [anon_sym_alignas] = ACTIONS(2384),
    [anon_sym__Alignas] = ACTIONS(2384),
    [sym_primitive_type] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2384),
    [anon_sym_class] = ACTIONS(2384),
    [anon_sym_struct] = ACTIONS(2384),
    [anon_sym_union] = ACTIONS(2384),
    [anon_sym_if] = ACTIONS(2384),
    [anon_sym_switch] = ACTIONS(2384),
    [anon_sym_case] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2384),
    [anon_sym_while] = ACTIONS(2384),
    [anon_sym_do] = ACTIONS(2384),
    [anon_sym_for] = ACTIONS(2384),
    [anon_sym_return] = ACTIONS(2384),
    [anon_sym_break] = ACTIONS(2384),
    [anon_sym_continue] = ACTIONS(2384),
    [anon_sym_goto] = ACTIONS(2384),
    [anon_sym_not] = ACTIONS(2384),
    [anon_sym_compl] = ACTIONS(2384),
    [anon_sym_DASH_DASH] = ACTIONS(2386),
    [anon_sym_PLUS_PLUS] = ACTIONS(2386),
    [anon_sym_sizeof] = ACTIONS(2384),
    [anon_sym___alignof__] = ACTIONS(2384),
    [anon_sym___alignof] = ACTIONS(2384),
    [anon_sym__alignof] = ACTIONS(2384),
    [anon_sym_alignof] = ACTIONS(2384),
    [anon_sym__Alignof] = ACTIONS(2384),
    [anon_sym_offsetof] = ACTIONS(2384),
    [anon_sym__Generic] = ACTIONS(2384),
    [anon_sym_asm] = ACTIONS(2384),
    [anon_sym___asm__] = ACTIONS(2384),
    [sym_number_literal] = ACTIONS(2386),
    [anon_sym_L_SQUOTE] = ACTIONS(2386),
    [anon_sym_u_SQUOTE] = ACTIONS(2386),
    [anon_sym_U_SQUOTE] = ACTIONS(2386),
    [anon_sym_u8_SQUOTE] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2386),
    [anon_sym_L_DQUOTE] = ACTIONS(2386),
    [anon_sym_u_DQUOTE] = ACTIONS(2386),
    [anon_sym_U_DQUOTE] = ACTIONS(2386),
    [anon_sym_u8_DQUOTE] = ACTIONS(2386),
    [anon_sym_DQUOTE] = ACTIONS(2386),
    [sym_true] = ACTIONS(2384),
    [sym_false] = ACTIONS(2384),
    [anon_sym_NULL] = ACTIONS(2384),
    [anon_sym_nullptr] = ACTIONS(2384),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2384),
    [anon_sym_decltype] = ACTIONS(2384),
    [sym_virtual] = ACTIONS(2384),
    [anon_sym_explicit] = ACTIONS(2384),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(2384),
    [anon_sym_operator] = ACTIONS(2384),
    [anon_sym_try] = ACTIONS(2384),
    [anon_sym_delete] = ACTIONS(2384),
    [anon_sym_throw] = ACTIONS(2384),
    [anon_sym_namespace] = ACTIONS(2384),
    [anon_sym_using] = ACTIONS(2384),
    [anon_sym_static_assert] = ACTIONS(2384),
    [anon_sym_concept] = ACTIONS(2384),
    [anon_sym_co_return] = ACTIONS(2384),
    [anon_sym_co_yield] = ACTIONS(2384),
    [anon_sym_R_DQUOTE] = ACTIONS(2386),
    [anon_sym_LR_DQUOTE] = ACTIONS(2386),
    [anon_sym_uR_DQUOTE] = ACTIONS(2386),
    [anon_sym_UR_DQUOTE] = ACTIONS(2386),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2386),
    [anon_sym_co_await] = ACTIONS(2384),
    [anon_sym_new] = ACTIONS(2384),
    [anon_sym_requires] = ACTIONS(2384),
    [sym_this] = ACTIONS(2384),
    [anon_sym___launch_bounds__] = ACTIONS(2384),
  },
  [715] = {
    [sym_preproc_def] = STATE(695),
    [sym_preproc_function_def] = STATE(695),
    [sym_preproc_call] = STATE(695),
    [sym_preproc_if_in_field_declaration_list] = STATE(695),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(695),
    [sym_type_definition] = STATE(695),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5894),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6463),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(695),
    [sym_field_declaration] = STATE(695),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1708),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(695),
    [sym_operator_cast] = STATE(6999),
    [sym_inline_method_definition] = STATE(695),
    [sym__constructor_specifiers] = STATE(1708),
    [sym_operator_cast_definition] = STATE(695),
    [sym_operator_cast_declaration] = STATE(695),
    [sym_constructor_or_destructor_definition] = STATE(695),
    [sym_constructor_or_destructor_declaration] = STATE(695),
    [sym_friend_declaration] = STATE(695),
    [sym_access_specifier] = STATE(8255),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(695),
    [sym_alias_declaration] = STATE(695),
    [sym_static_assert_declaration] = STATE(695),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6999),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(695),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1708),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3376),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3378),
    [sym_preproc_directive] = ACTIONS(3380),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(3382),
    [anon_sym_typedef] = ACTIONS(3384),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3450),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3390),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(3392),
    [anon_sym_static_assert] = ACTIONS(3394),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [716] = {
    [sym_expression] = STATE(3807),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_initializer_list] = STATE(4185),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2510),
    [anon_sym_RPAREN] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_BANG] = ACTIONS(1761),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2508),
    [anon_sym_STAR] = ACTIONS(2508),
    [anon_sym_SLASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2508),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_PIPE] = ACTIONS(2508),
    [anon_sym_CARET] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_EQ_EQ] = ACTIONS(2510),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_GT] = ACTIONS(2508),
    [anon_sym_GT_EQ] = ACTIONS(2510),
    [anon_sym_LT_EQ] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_LT_LT] = ACTIONS(2508),
    [anon_sym_GT_GT] = ACTIONS(2508),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACE] = ACTIONS(3454),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_EQ] = ACTIONS(2508),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_STAR_EQ] = ACTIONS(2510),
    [anon_sym_SLASH_EQ] = ACTIONS(2510),
    [anon_sym_PERCENT_EQ] = ACTIONS(2510),
    [anon_sym_PLUS_EQ] = ACTIONS(2510),
    [anon_sym_DASH_EQ] = ACTIONS(2510),
    [anon_sym_LT_LT_EQ] = ACTIONS(2510),
    [anon_sym_GT_GT_EQ] = ACTIONS(2510),
    [anon_sym_AMP_EQ] = ACTIONS(2510),
    [anon_sym_CARET_EQ] = ACTIONS(2510),
    [anon_sym_PIPE_EQ] = ACTIONS(2510),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_LT_EQ_GT] = ACTIONS(2510),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_bitor] = ACTIONS(2508),
    [anon_sym_xor] = ACTIONS(2508),
    [anon_sym_bitand] = ACTIONS(2508),
    [anon_sym_not_eq] = ACTIONS(2508),
    [anon_sym_DASH_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_PLUS] = ACTIONS(2510),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [anon_sym_DOT] = ACTIONS(2508),
    [anon_sym_DOT_STAR] = ACTIONS(2510),
    [anon_sym_DASH_GT] = ACTIONS(2508),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2510),
    [sym_this] = ACTIONS(1797),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(2510),
  },
  [717] = {
    [ts_builtin_sym_end] = ACTIONS(2160),
    [sym_identifier] = ACTIONS(2158),
    [aux_sym_preproc_include_token1] = ACTIONS(2158),
    [aux_sym_preproc_def_token1] = ACTIONS(2158),
    [aux_sym_preproc_if_token1] = ACTIONS(2158),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2158),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2158),
    [sym_preproc_directive] = ACTIONS(2158),
    [anon_sym_LPAREN2] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_PLUS] = ACTIONS(2158),
    [anon_sym_STAR] = ACTIONS(2160),
    [anon_sym_AMP_AMP] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2158),
    [anon_sym___extension__] = ACTIONS(2158),
    [anon_sym_typedef] = ACTIONS(2158),
    [anon_sym___device__] = ACTIONS(2158),
    [anon_sym___host__] = ACTIONS(2158),
    [anon_sym___global__] = ACTIONS(2158),
    [anon_sym___forceinline__] = ACTIONS(2158),
    [anon_sym___noinline__] = ACTIONS(2158),
    [anon_sym_extern] = ACTIONS(2158),
    [anon_sym___attribute__] = ACTIONS(2158),
    [anon_sym_COLON_COLON] = ACTIONS(2160),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2160),
    [anon_sym___declspec] = ACTIONS(2158),
    [anon_sym___based] = ACTIONS(2158),
    [anon_sym___cdecl] = ACTIONS(2158),
    [anon_sym___clrcall] = ACTIONS(2158),
    [anon_sym___stdcall] = ACTIONS(2158),
    [anon_sym___fastcall] = ACTIONS(2158),
    [anon_sym___thiscall] = ACTIONS(2158),
    [anon_sym___vectorcall] = ACTIONS(2158),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_signed] = ACTIONS(2158),
    [anon_sym_unsigned] = ACTIONS(2158),
    [anon_sym_long] = ACTIONS(2158),
    [anon_sym_short] = ACTIONS(2158),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_static] = ACTIONS(2158),
    [anon_sym_register] = ACTIONS(2158),
    [anon_sym_inline] = ACTIONS(2158),
    [anon_sym___inline] = ACTIONS(2158),
    [anon_sym___inline__] = ACTIONS(2158),
    [anon_sym___forceinline] = ACTIONS(2158),
    [anon_sym_thread_local] = ACTIONS(2158),
    [anon_sym___thread] = ACTIONS(2158),
    [anon_sym_const] = ACTIONS(2158),
    [anon_sym_constexpr] = ACTIONS(2158),
    [anon_sym_volatile] = ACTIONS(2158),
    [anon_sym_restrict] = ACTIONS(2158),
    [anon_sym___restrict__] = ACTIONS(2158),
    [anon_sym__Atomic] = ACTIONS(2158),
    [anon_sym__Noreturn] = ACTIONS(2158),
    [anon_sym_noreturn] = ACTIONS(2158),
    [anon_sym_mutable] = ACTIONS(2158),
    [anon_sym_constinit] = ACTIONS(2158),
    [anon_sym_consteval] = ACTIONS(2158),
    [anon_sym___shared__] = ACTIONS(2158),
    [anon_sym___local__] = ACTIONS(2158),
    [anon_sym___constant__] = ACTIONS(2158),
    [anon_sym___managed__] = ACTIONS(2158),
    [anon_sym___grid_constant__] = ACTIONS(2158),
    [anon_sym_alignas] = ACTIONS(2158),
    [anon_sym__Alignas] = ACTIONS(2158),
    [sym_primitive_type] = ACTIONS(2158),
    [anon_sym_enum] = ACTIONS(2158),
    [anon_sym_class] = ACTIONS(2158),
    [anon_sym_struct] = ACTIONS(2158),
    [anon_sym_union] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(2158),
    [anon_sym_switch] = ACTIONS(2158),
    [anon_sym_case] = ACTIONS(2158),
    [anon_sym_default] = ACTIONS(2158),
    [anon_sym_while] = ACTIONS(2158),
    [anon_sym_do] = ACTIONS(2158),
    [anon_sym_for] = ACTIONS(2158),
    [anon_sym_return] = ACTIONS(2158),
    [anon_sym_break] = ACTIONS(2158),
    [anon_sym_continue] = ACTIONS(2158),
    [anon_sym_goto] = ACTIONS(2158),
    [anon_sym_not] = ACTIONS(2158),
    [anon_sym_compl] = ACTIONS(2158),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_sizeof] = ACTIONS(2158),
    [anon_sym___alignof__] = ACTIONS(2158),
    [anon_sym___alignof] = ACTIONS(2158),
    [anon_sym__alignof] = ACTIONS(2158),
    [anon_sym_alignof] = ACTIONS(2158),
    [anon_sym__Alignof] = ACTIONS(2158),
    [anon_sym_offsetof] = ACTIONS(2158),
    [anon_sym__Generic] = ACTIONS(2158),
    [anon_sym_asm] = ACTIONS(2158),
    [anon_sym___asm__] = ACTIONS(2158),
    [sym_number_literal] = ACTIONS(2160),
    [anon_sym_L_SQUOTE] = ACTIONS(2160),
    [anon_sym_u_SQUOTE] = ACTIONS(2160),
    [anon_sym_U_SQUOTE] = ACTIONS(2160),
    [anon_sym_u8_SQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_L_DQUOTE] = ACTIONS(2160),
    [anon_sym_u_DQUOTE] = ACTIONS(2160),
    [anon_sym_U_DQUOTE] = ACTIONS(2160),
    [anon_sym_u8_DQUOTE] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [sym_true] = ACTIONS(2158),
    [sym_false] = ACTIONS(2158),
    [anon_sym_NULL] = ACTIONS(2158),
    [anon_sym_nullptr] = ACTIONS(2158),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2158),
    [anon_sym_decltype] = ACTIONS(2158),
    [sym_virtual] = ACTIONS(2158),
    [anon_sym_explicit] = ACTIONS(2158),
    [anon_sym_typename] = ACTIONS(2158),
    [anon_sym_template] = ACTIONS(2158),
    [anon_sym_operator] = ACTIONS(2158),
    [anon_sym_try] = ACTIONS(2158),
    [anon_sym_delete] = ACTIONS(2158),
    [anon_sym_throw] = ACTIONS(2158),
    [anon_sym_namespace] = ACTIONS(2158),
    [anon_sym_using] = ACTIONS(2158),
    [anon_sym_static_assert] = ACTIONS(2158),
    [anon_sym_concept] = ACTIONS(2158),
    [anon_sym_co_return] = ACTIONS(2158),
    [anon_sym_co_yield] = ACTIONS(2158),
    [anon_sym_R_DQUOTE] = ACTIONS(2160),
    [anon_sym_LR_DQUOTE] = ACTIONS(2160),
    [anon_sym_uR_DQUOTE] = ACTIONS(2160),
    [anon_sym_UR_DQUOTE] = ACTIONS(2160),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2160),
    [anon_sym_co_await] = ACTIONS(2158),
    [anon_sym_new] = ACTIONS(2158),
    [anon_sym_requires] = ACTIONS(2158),
    [sym_this] = ACTIONS(2158),
    [anon_sym___launch_bounds__] = ACTIONS(2158),
  },
  [718] = {
    [ts_builtin_sym_end] = ACTIONS(2257),
    [sym_identifier] = ACTIONS(2255),
    [aux_sym_preproc_include_token1] = ACTIONS(2255),
    [aux_sym_preproc_def_token1] = ACTIONS(2255),
    [aux_sym_preproc_if_token1] = ACTIONS(2255),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2255),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2255),
    [sym_preproc_directive] = ACTIONS(2255),
    [anon_sym_LPAREN2] = ACTIONS(2257),
    [anon_sym_BANG] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_DASH] = ACTIONS(2255),
    [anon_sym_PLUS] = ACTIONS(2255),
    [anon_sym_STAR] = ACTIONS(2257),
    [anon_sym_AMP_AMP] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2255),
    [anon_sym___extension__] = ACTIONS(2255),
    [anon_sym_typedef] = ACTIONS(2255),
    [anon_sym___device__] = ACTIONS(2255),
    [anon_sym___host__] = ACTIONS(2255),
    [anon_sym___global__] = ACTIONS(2255),
    [anon_sym___forceinline__] = ACTIONS(2255),
    [anon_sym___noinline__] = ACTIONS(2255),
    [anon_sym_extern] = ACTIONS(2255),
    [anon_sym___attribute__] = ACTIONS(2255),
    [anon_sym_COLON_COLON] = ACTIONS(2257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2257),
    [anon_sym___declspec] = ACTIONS(2255),
    [anon_sym___based] = ACTIONS(2255),
    [anon_sym___cdecl] = ACTIONS(2255),
    [anon_sym___clrcall] = ACTIONS(2255),
    [anon_sym___stdcall] = ACTIONS(2255),
    [anon_sym___fastcall] = ACTIONS(2255),
    [anon_sym___thiscall] = ACTIONS(2255),
    [anon_sym___vectorcall] = ACTIONS(2255),
    [anon_sym_LBRACE] = ACTIONS(2257),
    [anon_sym_signed] = ACTIONS(2255),
    [anon_sym_unsigned] = ACTIONS(2255),
    [anon_sym_long] = ACTIONS(2255),
    [anon_sym_short] = ACTIONS(2255),
    [anon_sym_LBRACK] = ACTIONS(2255),
    [anon_sym_static] = ACTIONS(2255),
    [anon_sym_register] = ACTIONS(2255),
    [anon_sym_inline] = ACTIONS(2255),
    [anon_sym___inline] = ACTIONS(2255),
    [anon_sym___inline__] = ACTIONS(2255),
    [anon_sym___forceinline] = ACTIONS(2255),
    [anon_sym_thread_local] = ACTIONS(2255),
    [anon_sym___thread] = ACTIONS(2255),
    [anon_sym_const] = ACTIONS(2255),
    [anon_sym_constexpr] = ACTIONS(2255),
    [anon_sym_volatile] = ACTIONS(2255),
    [anon_sym_restrict] = ACTIONS(2255),
    [anon_sym___restrict__] = ACTIONS(2255),
    [anon_sym__Atomic] = ACTIONS(2255),
    [anon_sym__Noreturn] = ACTIONS(2255),
    [anon_sym_noreturn] = ACTIONS(2255),
    [anon_sym_mutable] = ACTIONS(2255),
    [anon_sym_constinit] = ACTIONS(2255),
    [anon_sym_consteval] = ACTIONS(2255),
    [anon_sym___shared__] = ACTIONS(2255),
    [anon_sym___local__] = ACTIONS(2255),
    [anon_sym___constant__] = ACTIONS(2255),
    [anon_sym___managed__] = ACTIONS(2255),
    [anon_sym___grid_constant__] = ACTIONS(2255),
    [anon_sym_alignas] = ACTIONS(2255),
    [anon_sym__Alignas] = ACTIONS(2255),
    [sym_primitive_type] = ACTIONS(2255),
    [anon_sym_enum] = ACTIONS(2255),
    [anon_sym_class] = ACTIONS(2255),
    [anon_sym_struct] = ACTIONS(2255),
    [anon_sym_union] = ACTIONS(2255),
    [anon_sym_if] = ACTIONS(2255),
    [anon_sym_switch] = ACTIONS(2255),
    [anon_sym_case] = ACTIONS(2255),
    [anon_sym_default] = ACTIONS(2255),
    [anon_sym_while] = ACTIONS(2255),
    [anon_sym_do] = ACTIONS(2255),
    [anon_sym_for] = ACTIONS(2255),
    [anon_sym_return] = ACTIONS(2255),
    [anon_sym_break] = ACTIONS(2255),
    [anon_sym_continue] = ACTIONS(2255),
    [anon_sym_goto] = ACTIONS(2255),
    [anon_sym_not] = ACTIONS(2255),
    [anon_sym_compl] = ACTIONS(2255),
    [anon_sym_DASH_DASH] = ACTIONS(2257),
    [anon_sym_PLUS_PLUS] = ACTIONS(2257),
    [anon_sym_sizeof] = ACTIONS(2255),
    [anon_sym___alignof__] = ACTIONS(2255),
    [anon_sym___alignof] = ACTIONS(2255),
    [anon_sym__alignof] = ACTIONS(2255),
    [anon_sym_alignof] = ACTIONS(2255),
    [anon_sym__Alignof] = ACTIONS(2255),
    [anon_sym_offsetof] = ACTIONS(2255),
    [anon_sym__Generic] = ACTIONS(2255),
    [anon_sym_asm] = ACTIONS(2255),
    [anon_sym___asm__] = ACTIONS(2255),
    [sym_number_literal] = ACTIONS(2257),
    [anon_sym_L_SQUOTE] = ACTIONS(2257),
    [anon_sym_u_SQUOTE] = ACTIONS(2257),
    [anon_sym_U_SQUOTE] = ACTIONS(2257),
    [anon_sym_u8_SQUOTE] = ACTIONS(2257),
    [anon_sym_SQUOTE] = ACTIONS(2257),
    [anon_sym_L_DQUOTE] = ACTIONS(2257),
    [anon_sym_u_DQUOTE] = ACTIONS(2257),
    [anon_sym_U_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8_DQUOTE] = ACTIONS(2257),
    [anon_sym_DQUOTE] = ACTIONS(2257),
    [sym_true] = ACTIONS(2255),
    [sym_false] = ACTIONS(2255),
    [anon_sym_NULL] = ACTIONS(2255),
    [anon_sym_nullptr] = ACTIONS(2255),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2255),
    [anon_sym_decltype] = ACTIONS(2255),
    [sym_virtual] = ACTIONS(2255),
    [anon_sym_explicit] = ACTIONS(2255),
    [anon_sym_typename] = ACTIONS(2255),
    [anon_sym_template] = ACTIONS(2255),
    [anon_sym_operator] = ACTIONS(2255),
    [anon_sym_try] = ACTIONS(2255),
    [anon_sym_delete] = ACTIONS(2255),
    [anon_sym_throw] = ACTIONS(2255),
    [anon_sym_namespace] = ACTIONS(2255),
    [anon_sym_using] = ACTIONS(2255),
    [anon_sym_static_assert] = ACTIONS(2255),
    [anon_sym_concept] = ACTIONS(2255),
    [anon_sym_co_return] = ACTIONS(2255),
    [anon_sym_co_yield] = ACTIONS(2255),
    [anon_sym_R_DQUOTE] = ACTIONS(2257),
    [anon_sym_LR_DQUOTE] = ACTIONS(2257),
    [anon_sym_uR_DQUOTE] = ACTIONS(2257),
    [anon_sym_UR_DQUOTE] = ACTIONS(2257),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2257),
    [anon_sym_co_await] = ACTIONS(2255),
    [anon_sym_new] = ACTIONS(2255),
    [anon_sym_requires] = ACTIONS(2255),
    [sym_this] = ACTIONS(2255),
    [anon_sym___launch_bounds__] = ACTIONS(2255),
  },
  [719] = {
    [sym_preproc_def] = STATE(701),
    [sym_preproc_function_def] = STATE(701),
    [sym_preproc_call] = STATE(701),
    [sym_preproc_if_in_field_declaration_list] = STATE(701),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(701),
    [sym_type_definition] = STATE(701),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5894),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6463),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(701),
    [sym_field_declaration] = STATE(701),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1708),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(701),
    [sym_operator_cast] = STATE(6999),
    [sym_inline_method_definition] = STATE(701),
    [sym__constructor_specifiers] = STATE(1708),
    [sym_operator_cast_definition] = STATE(701),
    [sym_operator_cast_declaration] = STATE(701),
    [sym_constructor_or_destructor_definition] = STATE(701),
    [sym_constructor_or_destructor_declaration] = STATE(701),
    [sym_friend_declaration] = STATE(701),
    [sym_access_specifier] = STATE(8255),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(701),
    [sym_alias_declaration] = STATE(701),
    [sym_static_assert_declaration] = STATE(701),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6999),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(701),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1708),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3376),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3378),
    [sym_preproc_directive] = ACTIONS(3380),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(3382),
    [anon_sym_typedef] = ACTIONS(3384),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3458),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3390),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(3392),
    [anon_sym_static_assert] = ACTIONS(3394),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [720] = {
    [ts_builtin_sym_end] = ACTIONS(2390),
    [sym_identifier] = ACTIONS(2388),
    [aux_sym_preproc_include_token1] = ACTIONS(2388),
    [aux_sym_preproc_def_token1] = ACTIONS(2388),
    [aux_sym_preproc_if_token1] = ACTIONS(2388),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2388),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2388),
    [sym_preproc_directive] = ACTIONS(2388),
    [anon_sym_LPAREN2] = ACTIONS(2390),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [anon_sym_DASH] = ACTIONS(2388),
    [anon_sym_PLUS] = ACTIONS(2388),
    [anon_sym_STAR] = ACTIONS(2390),
    [anon_sym_AMP_AMP] = ACTIONS(2390),
    [anon_sym_AMP] = ACTIONS(2388),
    [anon_sym___extension__] = ACTIONS(2388),
    [anon_sym_typedef] = ACTIONS(2388),
    [anon_sym___device__] = ACTIONS(2388),
    [anon_sym___host__] = ACTIONS(2388),
    [anon_sym___global__] = ACTIONS(2388),
    [anon_sym___forceinline__] = ACTIONS(2388),
    [anon_sym___noinline__] = ACTIONS(2388),
    [anon_sym_extern] = ACTIONS(2388),
    [anon_sym___attribute__] = ACTIONS(2388),
    [anon_sym_COLON_COLON] = ACTIONS(2390),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2390),
    [anon_sym___declspec] = ACTIONS(2388),
    [anon_sym___based] = ACTIONS(2388),
    [anon_sym___cdecl] = ACTIONS(2388),
    [anon_sym___clrcall] = ACTIONS(2388),
    [anon_sym___stdcall] = ACTIONS(2388),
    [anon_sym___fastcall] = ACTIONS(2388),
    [anon_sym___thiscall] = ACTIONS(2388),
    [anon_sym___vectorcall] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2390),
    [anon_sym_signed] = ACTIONS(2388),
    [anon_sym_unsigned] = ACTIONS(2388),
    [anon_sym_long] = ACTIONS(2388),
    [anon_sym_short] = ACTIONS(2388),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [anon_sym_static] = ACTIONS(2388),
    [anon_sym_register] = ACTIONS(2388),
    [anon_sym_inline] = ACTIONS(2388),
    [anon_sym___inline] = ACTIONS(2388),
    [anon_sym___inline__] = ACTIONS(2388),
    [anon_sym___forceinline] = ACTIONS(2388),
    [anon_sym_thread_local] = ACTIONS(2388),
    [anon_sym___thread] = ACTIONS(2388),
    [anon_sym_const] = ACTIONS(2388),
    [anon_sym_constexpr] = ACTIONS(2388),
    [anon_sym_volatile] = ACTIONS(2388),
    [anon_sym_restrict] = ACTIONS(2388),
    [anon_sym___restrict__] = ACTIONS(2388),
    [anon_sym__Atomic] = ACTIONS(2388),
    [anon_sym__Noreturn] = ACTIONS(2388),
    [anon_sym_noreturn] = ACTIONS(2388),
    [anon_sym_mutable] = ACTIONS(2388),
    [anon_sym_constinit] = ACTIONS(2388),
    [anon_sym_consteval] = ACTIONS(2388),
    [anon_sym___shared__] = ACTIONS(2388),
    [anon_sym___local__] = ACTIONS(2388),
    [anon_sym___constant__] = ACTIONS(2388),
    [anon_sym___managed__] = ACTIONS(2388),
    [anon_sym___grid_constant__] = ACTIONS(2388),
    [anon_sym_alignas] = ACTIONS(2388),
    [anon_sym__Alignas] = ACTIONS(2388),
    [sym_primitive_type] = ACTIONS(2388),
    [anon_sym_enum] = ACTIONS(2388),
    [anon_sym_class] = ACTIONS(2388),
    [anon_sym_struct] = ACTIONS(2388),
    [anon_sym_union] = ACTIONS(2388),
    [anon_sym_if] = ACTIONS(2388),
    [anon_sym_switch] = ACTIONS(2388),
    [anon_sym_case] = ACTIONS(2388),
    [anon_sym_default] = ACTIONS(2388),
    [anon_sym_while] = ACTIONS(2388),
    [anon_sym_do] = ACTIONS(2388),
    [anon_sym_for] = ACTIONS(2388),
    [anon_sym_return] = ACTIONS(2388),
    [anon_sym_break] = ACTIONS(2388),
    [anon_sym_continue] = ACTIONS(2388),
    [anon_sym_goto] = ACTIONS(2388),
    [anon_sym_not] = ACTIONS(2388),
    [anon_sym_compl] = ACTIONS(2388),
    [anon_sym_DASH_DASH] = ACTIONS(2390),
    [anon_sym_PLUS_PLUS] = ACTIONS(2390),
    [anon_sym_sizeof] = ACTIONS(2388),
    [anon_sym___alignof__] = ACTIONS(2388),
    [anon_sym___alignof] = ACTIONS(2388),
    [anon_sym__alignof] = ACTIONS(2388),
    [anon_sym_alignof] = ACTIONS(2388),
    [anon_sym__Alignof] = ACTIONS(2388),
    [anon_sym_offsetof] = ACTIONS(2388),
    [anon_sym__Generic] = ACTIONS(2388),
    [anon_sym_asm] = ACTIONS(2388),
    [anon_sym___asm__] = ACTIONS(2388),
    [sym_number_literal] = ACTIONS(2390),
    [anon_sym_L_SQUOTE] = ACTIONS(2390),
    [anon_sym_u_SQUOTE] = ACTIONS(2390),
    [anon_sym_U_SQUOTE] = ACTIONS(2390),
    [anon_sym_u8_SQUOTE] = ACTIONS(2390),
    [anon_sym_SQUOTE] = ACTIONS(2390),
    [anon_sym_L_DQUOTE] = ACTIONS(2390),
    [anon_sym_u_DQUOTE] = ACTIONS(2390),
    [anon_sym_U_DQUOTE] = ACTIONS(2390),
    [anon_sym_u8_DQUOTE] = ACTIONS(2390),
    [anon_sym_DQUOTE] = ACTIONS(2390),
    [sym_true] = ACTIONS(2388),
    [sym_false] = ACTIONS(2388),
    [anon_sym_NULL] = ACTIONS(2388),
    [anon_sym_nullptr] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2388),
    [anon_sym_decltype] = ACTIONS(2388),
    [sym_virtual] = ACTIONS(2388),
    [anon_sym_explicit] = ACTIONS(2388),
    [anon_sym_typename] = ACTIONS(2388),
    [anon_sym_template] = ACTIONS(2388),
    [anon_sym_operator] = ACTIONS(2388),
    [anon_sym_try] = ACTIONS(2388),
    [anon_sym_delete] = ACTIONS(2388),
    [anon_sym_throw] = ACTIONS(2388),
    [anon_sym_namespace] = ACTIONS(2388),
    [anon_sym_using] = ACTIONS(2388),
    [anon_sym_static_assert] = ACTIONS(2388),
    [anon_sym_concept] = ACTIONS(2388),
    [anon_sym_co_return] = ACTIONS(2388),
    [anon_sym_co_yield] = ACTIONS(2388),
    [anon_sym_R_DQUOTE] = ACTIONS(2390),
    [anon_sym_LR_DQUOTE] = ACTIONS(2390),
    [anon_sym_uR_DQUOTE] = ACTIONS(2390),
    [anon_sym_UR_DQUOTE] = ACTIONS(2390),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2390),
    [anon_sym_co_await] = ACTIONS(2388),
    [anon_sym_new] = ACTIONS(2388),
    [anon_sym_requires] = ACTIONS(2388),
    [sym_this] = ACTIONS(2388),
    [anon_sym___launch_bounds__] = ACTIONS(2388),
  },
  [721] = {
    [ts_builtin_sym_end] = ACTIONS(2394),
    [sym_identifier] = ACTIONS(2392),
    [aux_sym_preproc_include_token1] = ACTIONS(2392),
    [aux_sym_preproc_def_token1] = ACTIONS(2392),
    [aux_sym_preproc_if_token1] = ACTIONS(2392),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2392),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2392),
    [sym_preproc_directive] = ACTIONS(2392),
    [anon_sym_LPAREN2] = ACTIONS(2394),
    [anon_sym_BANG] = ACTIONS(2394),
    [anon_sym_TILDE] = ACTIONS(2394),
    [anon_sym_DASH] = ACTIONS(2392),
    [anon_sym_PLUS] = ACTIONS(2392),
    [anon_sym_STAR] = ACTIONS(2394),
    [anon_sym_AMP_AMP] = ACTIONS(2394),
    [anon_sym_AMP] = ACTIONS(2392),
    [anon_sym___extension__] = ACTIONS(2392),
    [anon_sym_typedef] = ACTIONS(2392),
    [anon_sym___device__] = ACTIONS(2392),
    [anon_sym___host__] = ACTIONS(2392),
    [anon_sym___global__] = ACTIONS(2392),
    [anon_sym___forceinline__] = ACTIONS(2392),
    [anon_sym___noinline__] = ACTIONS(2392),
    [anon_sym_extern] = ACTIONS(2392),
    [anon_sym___attribute__] = ACTIONS(2392),
    [anon_sym_COLON_COLON] = ACTIONS(2394),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2394),
    [anon_sym___declspec] = ACTIONS(2392),
    [anon_sym___based] = ACTIONS(2392),
    [anon_sym___cdecl] = ACTIONS(2392),
    [anon_sym___clrcall] = ACTIONS(2392),
    [anon_sym___stdcall] = ACTIONS(2392),
    [anon_sym___fastcall] = ACTIONS(2392),
    [anon_sym___thiscall] = ACTIONS(2392),
    [anon_sym___vectorcall] = ACTIONS(2392),
    [anon_sym_LBRACE] = ACTIONS(2394),
    [anon_sym_signed] = ACTIONS(2392),
    [anon_sym_unsigned] = ACTIONS(2392),
    [anon_sym_long] = ACTIONS(2392),
    [anon_sym_short] = ACTIONS(2392),
    [anon_sym_LBRACK] = ACTIONS(2392),
    [anon_sym_static] = ACTIONS(2392),
    [anon_sym_register] = ACTIONS(2392),
    [anon_sym_inline] = ACTIONS(2392),
    [anon_sym___inline] = ACTIONS(2392),
    [anon_sym___inline__] = ACTIONS(2392),
    [anon_sym___forceinline] = ACTIONS(2392),
    [anon_sym_thread_local] = ACTIONS(2392),
    [anon_sym___thread] = ACTIONS(2392),
    [anon_sym_const] = ACTIONS(2392),
    [anon_sym_constexpr] = ACTIONS(2392),
    [anon_sym_volatile] = ACTIONS(2392),
    [anon_sym_restrict] = ACTIONS(2392),
    [anon_sym___restrict__] = ACTIONS(2392),
    [anon_sym__Atomic] = ACTIONS(2392),
    [anon_sym__Noreturn] = ACTIONS(2392),
    [anon_sym_noreturn] = ACTIONS(2392),
    [anon_sym_mutable] = ACTIONS(2392),
    [anon_sym_constinit] = ACTIONS(2392),
    [anon_sym_consteval] = ACTIONS(2392),
    [anon_sym___shared__] = ACTIONS(2392),
    [anon_sym___local__] = ACTIONS(2392),
    [anon_sym___constant__] = ACTIONS(2392),
    [anon_sym___managed__] = ACTIONS(2392),
    [anon_sym___grid_constant__] = ACTIONS(2392),
    [anon_sym_alignas] = ACTIONS(2392),
    [anon_sym__Alignas] = ACTIONS(2392),
    [sym_primitive_type] = ACTIONS(2392),
    [anon_sym_enum] = ACTIONS(2392),
    [anon_sym_class] = ACTIONS(2392),
    [anon_sym_struct] = ACTIONS(2392),
    [anon_sym_union] = ACTIONS(2392),
    [anon_sym_if] = ACTIONS(2392),
    [anon_sym_switch] = ACTIONS(2392),
    [anon_sym_case] = ACTIONS(2392),
    [anon_sym_default] = ACTIONS(2392),
    [anon_sym_while] = ACTIONS(2392),
    [anon_sym_do] = ACTIONS(2392),
    [anon_sym_for] = ACTIONS(2392),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_break] = ACTIONS(2392),
    [anon_sym_continue] = ACTIONS(2392),
    [anon_sym_goto] = ACTIONS(2392),
    [anon_sym_not] = ACTIONS(2392),
    [anon_sym_compl] = ACTIONS(2392),
    [anon_sym_DASH_DASH] = ACTIONS(2394),
    [anon_sym_PLUS_PLUS] = ACTIONS(2394),
    [anon_sym_sizeof] = ACTIONS(2392),
    [anon_sym___alignof__] = ACTIONS(2392),
    [anon_sym___alignof] = ACTIONS(2392),
    [anon_sym__alignof] = ACTIONS(2392),
    [anon_sym_alignof] = ACTIONS(2392),
    [anon_sym__Alignof] = ACTIONS(2392),
    [anon_sym_offsetof] = ACTIONS(2392),
    [anon_sym__Generic] = ACTIONS(2392),
    [anon_sym_asm] = ACTIONS(2392),
    [anon_sym___asm__] = ACTIONS(2392),
    [sym_number_literal] = ACTIONS(2394),
    [anon_sym_L_SQUOTE] = ACTIONS(2394),
    [anon_sym_u_SQUOTE] = ACTIONS(2394),
    [anon_sym_U_SQUOTE] = ACTIONS(2394),
    [anon_sym_u8_SQUOTE] = ACTIONS(2394),
    [anon_sym_SQUOTE] = ACTIONS(2394),
    [anon_sym_L_DQUOTE] = ACTIONS(2394),
    [anon_sym_u_DQUOTE] = ACTIONS(2394),
    [anon_sym_U_DQUOTE] = ACTIONS(2394),
    [anon_sym_u8_DQUOTE] = ACTIONS(2394),
    [anon_sym_DQUOTE] = ACTIONS(2394),
    [sym_true] = ACTIONS(2392),
    [sym_false] = ACTIONS(2392),
    [anon_sym_NULL] = ACTIONS(2392),
    [anon_sym_nullptr] = ACTIONS(2392),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2392),
    [anon_sym_decltype] = ACTIONS(2392),
    [sym_virtual] = ACTIONS(2392),
    [anon_sym_explicit] = ACTIONS(2392),
    [anon_sym_typename] = ACTIONS(2392),
    [anon_sym_template] = ACTIONS(2392),
    [anon_sym_operator] = ACTIONS(2392),
    [anon_sym_try] = ACTIONS(2392),
    [anon_sym_delete] = ACTIONS(2392),
    [anon_sym_throw] = ACTIONS(2392),
    [anon_sym_namespace] = ACTIONS(2392),
    [anon_sym_using] = ACTIONS(2392),
    [anon_sym_static_assert] = ACTIONS(2392),
    [anon_sym_concept] = ACTIONS(2392),
    [anon_sym_co_return] = ACTIONS(2392),
    [anon_sym_co_yield] = ACTIONS(2392),
    [anon_sym_R_DQUOTE] = ACTIONS(2394),
    [anon_sym_LR_DQUOTE] = ACTIONS(2394),
    [anon_sym_uR_DQUOTE] = ACTIONS(2394),
    [anon_sym_UR_DQUOTE] = ACTIONS(2394),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2394),
    [anon_sym_co_await] = ACTIONS(2392),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_requires] = ACTIONS(2392),
    [sym_this] = ACTIONS(2392),
    [anon_sym___launch_bounds__] = ACTIONS(2392),
  },
  [722] = {
    [ts_builtin_sym_end] = ACTIONS(2273),
    [sym_identifier] = ACTIONS(2271),
    [aux_sym_preproc_include_token1] = ACTIONS(2271),
    [aux_sym_preproc_def_token1] = ACTIONS(2271),
    [aux_sym_preproc_if_token1] = ACTIONS(2271),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2271),
    [sym_preproc_directive] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2273),
    [anon_sym_TILDE] = ACTIONS(2273),
    [anon_sym_DASH] = ACTIONS(2271),
    [anon_sym_PLUS] = ACTIONS(2271),
    [anon_sym_STAR] = ACTIONS(2273),
    [anon_sym_AMP_AMP] = ACTIONS(2273),
    [anon_sym_AMP] = ACTIONS(2271),
    [anon_sym___extension__] = ACTIONS(2271),
    [anon_sym_typedef] = ACTIONS(2271),
    [anon_sym___device__] = ACTIONS(2271),
    [anon_sym___host__] = ACTIONS(2271),
    [anon_sym___global__] = ACTIONS(2271),
    [anon_sym___forceinline__] = ACTIONS(2271),
    [anon_sym___noinline__] = ACTIONS(2271),
    [anon_sym_extern] = ACTIONS(2271),
    [anon_sym___attribute__] = ACTIONS(2271),
    [anon_sym_COLON_COLON] = ACTIONS(2273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2273),
    [anon_sym___declspec] = ACTIONS(2271),
    [anon_sym___based] = ACTIONS(2271),
    [anon_sym___cdecl] = ACTIONS(2271),
    [anon_sym___clrcall] = ACTIONS(2271),
    [anon_sym___stdcall] = ACTIONS(2271),
    [anon_sym___fastcall] = ACTIONS(2271),
    [anon_sym___thiscall] = ACTIONS(2271),
    [anon_sym___vectorcall] = ACTIONS(2271),
    [anon_sym_LBRACE] = ACTIONS(2273),
    [anon_sym_signed] = ACTIONS(2271),
    [anon_sym_unsigned] = ACTIONS(2271),
    [anon_sym_long] = ACTIONS(2271),
    [anon_sym_short] = ACTIONS(2271),
    [anon_sym_LBRACK] = ACTIONS(2271),
    [anon_sym_static] = ACTIONS(2271),
    [anon_sym_register] = ACTIONS(2271),
    [anon_sym_inline] = ACTIONS(2271),
    [anon_sym___inline] = ACTIONS(2271),
    [anon_sym___inline__] = ACTIONS(2271),
    [anon_sym___forceinline] = ACTIONS(2271),
    [anon_sym_thread_local] = ACTIONS(2271),
    [anon_sym___thread] = ACTIONS(2271),
    [anon_sym_const] = ACTIONS(2271),
    [anon_sym_constexpr] = ACTIONS(2271),
    [anon_sym_volatile] = ACTIONS(2271),
    [anon_sym_restrict] = ACTIONS(2271),
    [anon_sym___restrict__] = ACTIONS(2271),
    [anon_sym__Atomic] = ACTIONS(2271),
    [anon_sym__Noreturn] = ACTIONS(2271),
    [anon_sym_noreturn] = ACTIONS(2271),
    [anon_sym_mutable] = ACTIONS(2271),
    [anon_sym_constinit] = ACTIONS(2271),
    [anon_sym_consteval] = ACTIONS(2271),
    [anon_sym___shared__] = ACTIONS(2271),
    [anon_sym___local__] = ACTIONS(2271),
    [anon_sym___constant__] = ACTIONS(2271),
    [anon_sym___managed__] = ACTIONS(2271),
    [anon_sym___grid_constant__] = ACTIONS(2271),
    [anon_sym_alignas] = ACTIONS(2271),
    [anon_sym__Alignas] = ACTIONS(2271),
    [sym_primitive_type] = ACTIONS(2271),
    [anon_sym_enum] = ACTIONS(2271),
    [anon_sym_class] = ACTIONS(2271),
    [anon_sym_struct] = ACTIONS(2271),
    [anon_sym_union] = ACTIONS(2271),
    [anon_sym_if] = ACTIONS(2271),
    [anon_sym_switch] = ACTIONS(2271),
    [anon_sym_case] = ACTIONS(2271),
    [anon_sym_default] = ACTIONS(2271),
    [anon_sym_while] = ACTIONS(2271),
    [anon_sym_do] = ACTIONS(2271),
    [anon_sym_for] = ACTIONS(2271),
    [anon_sym_return] = ACTIONS(2271),
    [anon_sym_break] = ACTIONS(2271),
    [anon_sym_continue] = ACTIONS(2271),
    [anon_sym_goto] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2271),
    [anon_sym_compl] = ACTIONS(2271),
    [anon_sym_DASH_DASH] = ACTIONS(2273),
    [anon_sym_PLUS_PLUS] = ACTIONS(2273),
    [anon_sym_sizeof] = ACTIONS(2271),
    [anon_sym___alignof__] = ACTIONS(2271),
    [anon_sym___alignof] = ACTIONS(2271),
    [anon_sym__alignof] = ACTIONS(2271),
    [anon_sym_alignof] = ACTIONS(2271),
    [anon_sym__Alignof] = ACTIONS(2271),
    [anon_sym_offsetof] = ACTIONS(2271),
    [anon_sym__Generic] = ACTIONS(2271),
    [anon_sym_asm] = ACTIONS(2271),
    [anon_sym___asm__] = ACTIONS(2271),
    [sym_number_literal] = ACTIONS(2273),
    [anon_sym_L_SQUOTE] = ACTIONS(2273),
    [anon_sym_u_SQUOTE] = ACTIONS(2273),
    [anon_sym_U_SQUOTE] = ACTIONS(2273),
    [anon_sym_u8_SQUOTE] = ACTIONS(2273),
    [anon_sym_SQUOTE] = ACTIONS(2273),
    [anon_sym_L_DQUOTE] = ACTIONS(2273),
    [anon_sym_u_DQUOTE] = ACTIONS(2273),
    [anon_sym_U_DQUOTE] = ACTIONS(2273),
    [anon_sym_u8_DQUOTE] = ACTIONS(2273),
    [anon_sym_DQUOTE] = ACTIONS(2273),
    [sym_true] = ACTIONS(2271),
    [sym_false] = ACTIONS(2271),
    [anon_sym_NULL] = ACTIONS(2271),
    [anon_sym_nullptr] = ACTIONS(2271),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2271),
    [anon_sym_decltype] = ACTIONS(2271),
    [sym_virtual] = ACTIONS(2271),
    [anon_sym_explicit] = ACTIONS(2271),
    [anon_sym_typename] = ACTIONS(2271),
    [anon_sym_template] = ACTIONS(2271),
    [anon_sym_operator] = ACTIONS(2271),
    [anon_sym_try] = ACTIONS(2271),
    [anon_sym_delete] = ACTIONS(2271),
    [anon_sym_throw] = ACTIONS(2271),
    [anon_sym_namespace] = ACTIONS(2271),
    [anon_sym_using] = ACTIONS(2271),
    [anon_sym_static_assert] = ACTIONS(2271),
    [anon_sym_concept] = ACTIONS(2271),
    [anon_sym_co_return] = ACTIONS(2271),
    [anon_sym_co_yield] = ACTIONS(2271),
    [anon_sym_R_DQUOTE] = ACTIONS(2273),
    [anon_sym_LR_DQUOTE] = ACTIONS(2273),
    [anon_sym_uR_DQUOTE] = ACTIONS(2273),
    [anon_sym_UR_DQUOTE] = ACTIONS(2273),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2273),
    [anon_sym_co_await] = ACTIONS(2271),
    [anon_sym_new] = ACTIONS(2271),
    [anon_sym_requires] = ACTIONS(2271),
    [sym_this] = ACTIONS(2271),
    [anon_sym___launch_bounds__] = ACTIONS(2271),
  },
  [723] = {
    [ts_builtin_sym_end] = ACTIONS(2229),
    [sym_identifier] = ACTIONS(2227),
    [aux_sym_preproc_include_token1] = ACTIONS(2227),
    [aux_sym_preproc_def_token1] = ACTIONS(2227),
    [aux_sym_preproc_if_token1] = ACTIONS(2227),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2227),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2227),
    [sym_preproc_directive] = ACTIONS(2227),
    [anon_sym_LPAREN2] = ACTIONS(2229),
    [anon_sym_BANG] = ACTIONS(2229),
    [anon_sym_TILDE] = ACTIONS(2229),
    [anon_sym_DASH] = ACTIONS(2227),
    [anon_sym_PLUS] = ACTIONS(2227),
    [anon_sym_STAR] = ACTIONS(2229),
    [anon_sym_AMP_AMP] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2227),
    [anon_sym___extension__] = ACTIONS(2227),
    [anon_sym_typedef] = ACTIONS(2227),
    [anon_sym___device__] = ACTIONS(2227),
    [anon_sym___host__] = ACTIONS(2227),
    [anon_sym___global__] = ACTIONS(2227),
    [anon_sym___forceinline__] = ACTIONS(2227),
    [anon_sym___noinline__] = ACTIONS(2227),
    [anon_sym_extern] = ACTIONS(2227),
    [anon_sym___attribute__] = ACTIONS(2227),
    [anon_sym_COLON_COLON] = ACTIONS(2229),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2229),
    [anon_sym___declspec] = ACTIONS(2227),
    [anon_sym___based] = ACTIONS(2227),
    [anon_sym___cdecl] = ACTIONS(2227),
    [anon_sym___clrcall] = ACTIONS(2227),
    [anon_sym___stdcall] = ACTIONS(2227),
    [anon_sym___fastcall] = ACTIONS(2227),
    [anon_sym___thiscall] = ACTIONS(2227),
    [anon_sym___vectorcall] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(2229),
    [anon_sym_signed] = ACTIONS(2227),
    [anon_sym_unsigned] = ACTIONS(2227),
    [anon_sym_long] = ACTIONS(2227),
    [anon_sym_short] = ACTIONS(2227),
    [anon_sym_LBRACK] = ACTIONS(2227),
    [anon_sym_static] = ACTIONS(2227),
    [anon_sym_register] = ACTIONS(2227),
    [anon_sym_inline] = ACTIONS(2227),
    [anon_sym___inline] = ACTIONS(2227),
    [anon_sym___inline__] = ACTIONS(2227),
    [anon_sym___forceinline] = ACTIONS(2227),
    [anon_sym_thread_local] = ACTIONS(2227),
    [anon_sym___thread] = ACTIONS(2227),
    [anon_sym_const] = ACTIONS(2227),
    [anon_sym_constexpr] = ACTIONS(2227),
    [anon_sym_volatile] = ACTIONS(2227),
    [anon_sym_restrict] = ACTIONS(2227),
    [anon_sym___restrict__] = ACTIONS(2227),
    [anon_sym__Atomic] = ACTIONS(2227),
    [anon_sym__Noreturn] = ACTIONS(2227),
    [anon_sym_noreturn] = ACTIONS(2227),
    [anon_sym_mutable] = ACTIONS(2227),
    [anon_sym_constinit] = ACTIONS(2227),
    [anon_sym_consteval] = ACTIONS(2227),
    [anon_sym___shared__] = ACTIONS(2227),
    [anon_sym___local__] = ACTIONS(2227),
    [anon_sym___constant__] = ACTIONS(2227),
    [anon_sym___managed__] = ACTIONS(2227),
    [anon_sym___grid_constant__] = ACTIONS(2227),
    [anon_sym_alignas] = ACTIONS(2227),
    [anon_sym__Alignas] = ACTIONS(2227),
    [sym_primitive_type] = ACTIONS(2227),
    [anon_sym_enum] = ACTIONS(2227),
    [anon_sym_class] = ACTIONS(2227),
    [anon_sym_struct] = ACTIONS(2227),
    [anon_sym_union] = ACTIONS(2227),
    [anon_sym_if] = ACTIONS(2227),
    [anon_sym_switch] = ACTIONS(2227),
    [anon_sym_case] = ACTIONS(2227),
    [anon_sym_default] = ACTIONS(2227),
    [anon_sym_while] = ACTIONS(2227),
    [anon_sym_do] = ACTIONS(2227),
    [anon_sym_for] = ACTIONS(2227),
    [anon_sym_return] = ACTIONS(2227),
    [anon_sym_break] = ACTIONS(2227),
    [anon_sym_continue] = ACTIONS(2227),
    [anon_sym_goto] = ACTIONS(2227),
    [anon_sym_not] = ACTIONS(2227),
    [anon_sym_compl] = ACTIONS(2227),
    [anon_sym_DASH_DASH] = ACTIONS(2229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2229),
    [anon_sym_sizeof] = ACTIONS(2227),
    [anon_sym___alignof__] = ACTIONS(2227),
    [anon_sym___alignof] = ACTIONS(2227),
    [anon_sym__alignof] = ACTIONS(2227),
    [anon_sym_alignof] = ACTIONS(2227),
    [anon_sym__Alignof] = ACTIONS(2227),
    [anon_sym_offsetof] = ACTIONS(2227),
    [anon_sym__Generic] = ACTIONS(2227),
    [anon_sym_asm] = ACTIONS(2227),
    [anon_sym___asm__] = ACTIONS(2227),
    [sym_number_literal] = ACTIONS(2229),
    [anon_sym_L_SQUOTE] = ACTIONS(2229),
    [anon_sym_u_SQUOTE] = ACTIONS(2229),
    [anon_sym_U_SQUOTE] = ACTIONS(2229),
    [anon_sym_u8_SQUOTE] = ACTIONS(2229),
    [anon_sym_SQUOTE] = ACTIONS(2229),
    [anon_sym_L_DQUOTE] = ACTIONS(2229),
    [anon_sym_u_DQUOTE] = ACTIONS(2229),
    [anon_sym_U_DQUOTE] = ACTIONS(2229),
    [anon_sym_u8_DQUOTE] = ACTIONS(2229),
    [anon_sym_DQUOTE] = ACTIONS(2229),
    [sym_true] = ACTIONS(2227),
    [sym_false] = ACTIONS(2227),
    [anon_sym_NULL] = ACTIONS(2227),
    [anon_sym_nullptr] = ACTIONS(2227),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2227),
    [anon_sym_decltype] = ACTIONS(2227),
    [sym_virtual] = ACTIONS(2227),
    [anon_sym_explicit] = ACTIONS(2227),
    [anon_sym_typename] = ACTIONS(2227),
    [anon_sym_template] = ACTIONS(2227),
    [anon_sym_operator] = ACTIONS(2227),
    [anon_sym_try] = ACTIONS(2227),
    [anon_sym_delete] = ACTIONS(2227),
    [anon_sym_throw] = ACTIONS(2227),
    [anon_sym_namespace] = ACTIONS(2227),
    [anon_sym_using] = ACTIONS(2227),
    [anon_sym_static_assert] = ACTIONS(2227),
    [anon_sym_concept] = ACTIONS(2227),
    [anon_sym_co_return] = ACTIONS(2227),
    [anon_sym_co_yield] = ACTIONS(2227),
    [anon_sym_R_DQUOTE] = ACTIONS(2229),
    [anon_sym_LR_DQUOTE] = ACTIONS(2229),
    [anon_sym_uR_DQUOTE] = ACTIONS(2229),
    [anon_sym_UR_DQUOTE] = ACTIONS(2229),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2229),
    [anon_sym_co_await] = ACTIONS(2227),
    [anon_sym_new] = ACTIONS(2227),
    [anon_sym_requires] = ACTIONS(2227),
    [sym_this] = ACTIONS(2227),
    [anon_sym___launch_bounds__] = ACTIONS(2227),
  },
  [724] = {
    [ts_builtin_sym_end] = ACTIONS(2398),
    [sym_identifier] = ACTIONS(2396),
    [aux_sym_preproc_include_token1] = ACTIONS(2396),
    [aux_sym_preproc_def_token1] = ACTIONS(2396),
    [aux_sym_preproc_if_token1] = ACTIONS(2396),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2396),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2396),
    [sym_preproc_directive] = ACTIONS(2396),
    [anon_sym_LPAREN2] = ACTIONS(2398),
    [anon_sym_BANG] = ACTIONS(2398),
    [anon_sym_TILDE] = ACTIONS(2398),
    [anon_sym_DASH] = ACTIONS(2396),
    [anon_sym_PLUS] = ACTIONS(2396),
    [anon_sym_STAR] = ACTIONS(2398),
    [anon_sym_AMP_AMP] = ACTIONS(2398),
    [anon_sym_AMP] = ACTIONS(2396),
    [anon_sym___extension__] = ACTIONS(2396),
    [anon_sym_typedef] = ACTIONS(2396),
    [anon_sym___device__] = ACTIONS(2396),
    [anon_sym___host__] = ACTIONS(2396),
    [anon_sym___global__] = ACTIONS(2396),
    [anon_sym___forceinline__] = ACTIONS(2396),
    [anon_sym___noinline__] = ACTIONS(2396),
    [anon_sym_extern] = ACTIONS(2396),
    [anon_sym___attribute__] = ACTIONS(2396),
    [anon_sym_COLON_COLON] = ACTIONS(2398),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2398),
    [anon_sym___declspec] = ACTIONS(2396),
    [anon_sym___based] = ACTIONS(2396),
    [anon_sym___cdecl] = ACTIONS(2396),
    [anon_sym___clrcall] = ACTIONS(2396),
    [anon_sym___stdcall] = ACTIONS(2396),
    [anon_sym___fastcall] = ACTIONS(2396),
    [anon_sym___thiscall] = ACTIONS(2396),
    [anon_sym___vectorcall] = ACTIONS(2396),
    [anon_sym_LBRACE] = ACTIONS(2398),
    [anon_sym_signed] = ACTIONS(2396),
    [anon_sym_unsigned] = ACTIONS(2396),
    [anon_sym_long] = ACTIONS(2396),
    [anon_sym_short] = ACTIONS(2396),
    [anon_sym_LBRACK] = ACTIONS(2396),
    [anon_sym_static] = ACTIONS(2396),
    [anon_sym_register] = ACTIONS(2396),
    [anon_sym_inline] = ACTIONS(2396),
    [anon_sym___inline] = ACTIONS(2396),
    [anon_sym___inline__] = ACTIONS(2396),
    [anon_sym___forceinline] = ACTIONS(2396),
    [anon_sym_thread_local] = ACTIONS(2396),
    [anon_sym___thread] = ACTIONS(2396),
    [anon_sym_const] = ACTIONS(2396),
    [anon_sym_constexpr] = ACTIONS(2396),
    [anon_sym_volatile] = ACTIONS(2396),
    [anon_sym_restrict] = ACTIONS(2396),
    [anon_sym___restrict__] = ACTIONS(2396),
    [anon_sym__Atomic] = ACTIONS(2396),
    [anon_sym__Noreturn] = ACTIONS(2396),
    [anon_sym_noreturn] = ACTIONS(2396),
    [anon_sym_mutable] = ACTIONS(2396),
    [anon_sym_constinit] = ACTIONS(2396),
    [anon_sym_consteval] = ACTIONS(2396),
    [anon_sym___shared__] = ACTIONS(2396),
    [anon_sym___local__] = ACTIONS(2396),
    [anon_sym___constant__] = ACTIONS(2396),
    [anon_sym___managed__] = ACTIONS(2396),
    [anon_sym___grid_constant__] = ACTIONS(2396),
    [anon_sym_alignas] = ACTIONS(2396),
    [anon_sym__Alignas] = ACTIONS(2396),
    [sym_primitive_type] = ACTIONS(2396),
    [anon_sym_enum] = ACTIONS(2396),
    [anon_sym_class] = ACTIONS(2396),
    [anon_sym_struct] = ACTIONS(2396),
    [anon_sym_union] = ACTIONS(2396),
    [anon_sym_if] = ACTIONS(2396),
    [anon_sym_switch] = ACTIONS(2396),
    [anon_sym_case] = ACTIONS(2396),
    [anon_sym_default] = ACTIONS(2396),
    [anon_sym_while] = ACTIONS(2396),
    [anon_sym_do] = ACTIONS(2396),
    [anon_sym_for] = ACTIONS(2396),
    [anon_sym_return] = ACTIONS(2396),
    [anon_sym_break] = ACTIONS(2396),
    [anon_sym_continue] = ACTIONS(2396),
    [anon_sym_goto] = ACTIONS(2396),
    [anon_sym_not] = ACTIONS(2396),
    [anon_sym_compl] = ACTIONS(2396),
    [anon_sym_DASH_DASH] = ACTIONS(2398),
    [anon_sym_PLUS_PLUS] = ACTIONS(2398),
    [anon_sym_sizeof] = ACTIONS(2396),
    [anon_sym___alignof__] = ACTIONS(2396),
    [anon_sym___alignof] = ACTIONS(2396),
    [anon_sym__alignof] = ACTIONS(2396),
    [anon_sym_alignof] = ACTIONS(2396),
    [anon_sym__Alignof] = ACTIONS(2396),
    [anon_sym_offsetof] = ACTIONS(2396),
    [anon_sym__Generic] = ACTIONS(2396),
    [anon_sym_asm] = ACTIONS(2396),
    [anon_sym___asm__] = ACTIONS(2396),
    [sym_number_literal] = ACTIONS(2398),
    [anon_sym_L_SQUOTE] = ACTIONS(2398),
    [anon_sym_u_SQUOTE] = ACTIONS(2398),
    [anon_sym_U_SQUOTE] = ACTIONS(2398),
    [anon_sym_u8_SQUOTE] = ACTIONS(2398),
    [anon_sym_SQUOTE] = ACTIONS(2398),
    [anon_sym_L_DQUOTE] = ACTIONS(2398),
    [anon_sym_u_DQUOTE] = ACTIONS(2398),
    [anon_sym_U_DQUOTE] = ACTIONS(2398),
    [anon_sym_u8_DQUOTE] = ACTIONS(2398),
    [anon_sym_DQUOTE] = ACTIONS(2398),
    [sym_true] = ACTIONS(2396),
    [sym_false] = ACTIONS(2396),
    [anon_sym_NULL] = ACTIONS(2396),
    [anon_sym_nullptr] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2396),
    [anon_sym_decltype] = ACTIONS(2396),
    [sym_virtual] = ACTIONS(2396),
    [anon_sym_explicit] = ACTIONS(2396),
    [anon_sym_typename] = ACTIONS(2396),
    [anon_sym_template] = ACTIONS(2396),
    [anon_sym_operator] = ACTIONS(2396),
    [anon_sym_try] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_throw] = ACTIONS(2396),
    [anon_sym_namespace] = ACTIONS(2396),
    [anon_sym_using] = ACTIONS(2396),
    [anon_sym_static_assert] = ACTIONS(2396),
    [anon_sym_concept] = ACTIONS(2396),
    [anon_sym_co_return] = ACTIONS(2396),
    [anon_sym_co_yield] = ACTIONS(2396),
    [anon_sym_R_DQUOTE] = ACTIONS(2398),
    [anon_sym_LR_DQUOTE] = ACTIONS(2398),
    [anon_sym_uR_DQUOTE] = ACTIONS(2398),
    [anon_sym_UR_DQUOTE] = ACTIONS(2398),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2398),
    [anon_sym_co_await] = ACTIONS(2396),
    [anon_sym_new] = ACTIONS(2396),
    [anon_sym_requires] = ACTIONS(2396),
    [sym_this] = ACTIONS(2396),
    [anon_sym___launch_bounds__] = ACTIONS(2396),
  },
  [725] = {
    [ts_builtin_sym_end] = ACTIONS(2217),
    [sym_identifier] = ACTIONS(2215),
    [aux_sym_preproc_include_token1] = ACTIONS(2215),
    [aux_sym_preproc_def_token1] = ACTIONS(2215),
    [aux_sym_preproc_if_token1] = ACTIONS(2215),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2215),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2215),
    [sym_preproc_directive] = ACTIONS(2215),
    [anon_sym_LPAREN2] = ACTIONS(2217),
    [anon_sym_BANG] = ACTIONS(2217),
    [anon_sym_TILDE] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2215),
    [anon_sym_PLUS] = ACTIONS(2215),
    [anon_sym_STAR] = ACTIONS(2217),
    [anon_sym_AMP_AMP] = ACTIONS(2217),
    [anon_sym_AMP] = ACTIONS(2215),
    [anon_sym___extension__] = ACTIONS(2215),
    [anon_sym_typedef] = ACTIONS(2215),
    [anon_sym___device__] = ACTIONS(2215),
    [anon_sym___host__] = ACTIONS(2215),
    [anon_sym___global__] = ACTIONS(2215),
    [anon_sym___forceinline__] = ACTIONS(2215),
    [anon_sym___noinline__] = ACTIONS(2215),
    [anon_sym_extern] = ACTIONS(2215),
    [anon_sym___attribute__] = ACTIONS(2215),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2217),
    [anon_sym___declspec] = ACTIONS(2215),
    [anon_sym___based] = ACTIONS(2215),
    [anon_sym___cdecl] = ACTIONS(2215),
    [anon_sym___clrcall] = ACTIONS(2215),
    [anon_sym___stdcall] = ACTIONS(2215),
    [anon_sym___fastcall] = ACTIONS(2215),
    [anon_sym___thiscall] = ACTIONS(2215),
    [anon_sym___vectorcall] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_signed] = ACTIONS(2215),
    [anon_sym_unsigned] = ACTIONS(2215),
    [anon_sym_long] = ACTIONS(2215),
    [anon_sym_short] = ACTIONS(2215),
    [anon_sym_LBRACK] = ACTIONS(2215),
    [anon_sym_static] = ACTIONS(2215),
    [anon_sym_register] = ACTIONS(2215),
    [anon_sym_inline] = ACTIONS(2215),
    [anon_sym___inline] = ACTIONS(2215),
    [anon_sym___inline__] = ACTIONS(2215),
    [anon_sym___forceinline] = ACTIONS(2215),
    [anon_sym_thread_local] = ACTIONS(2215),
    [anon_sym___thread] = ACTIONS(2215),
    [anon_sym_const] = ACTIONS(2215),
    [anon_sym_constexpr] = ACTIONS(2215),
    [anon_sym_volatile] = ACTIONS(2215),
    [anon_sym_restrict] = ACTIONS(2215),
    [anon_sym___restrict__] = ACTIONS(2215),
    [anon_sym__Atomic] = ACTIONS(2215),
    [anon_sym__Noreturn] = ACTIONS(2215),
    [anon_sym_noreturn] = ACTIONS(2215),
    [anon_sym_mutable] = ACTIONS(2215),
    [anon_sym_constinit] = ACTIONS(2215),
    [anon_sym_consteval] = ACTIONS(2215),
    [anon_sym___shared__] = ACTIONS(2215),
    [anon_sym___local__] = ACTIONS(2215),
    [anon_sym___constant__] = ACTIONS(2215),
    [anon_sym___managed__] = ACTIONS(2215),
    [anon_sym___grid_constant__] = ACTIONS(2215),
    [anon_sym_alignas] = ACTIONS(2215),
    [anon_sym__Alignas] = ACTIONS(2215),
    [sym_primitive_type] = ACTIONS(2215),
    [anon_sym_enum] = ACTIONS(2215),
    [anon_sym_class] = ACTIONS(2215),
    [anon_sym_struct] = ACTIONS(2215),
    [anon_sym_union] = ACTIONS(2215),
    [anon_sym_if] = ACTIONS(2215),
    [anon_sym_switch] = ACTIONS(2215),
    [anon_sym_case] = ACTIONS(2215),
    [anon_sym_default] = ACTIONS(2215),
    [anon_sym_while] = ACTIONS(2215),
    [anon_sym_do] = ACTIONS(2215),
    [anon_sym_for] = ACTIONS(2215),
    [anon_sym_return] = ACTIONS(2215),
    [anon_sym_break] = ACTIONS(2215),
    [anon_sym_continue] = ACTIONS(2215),
    [anon_sym_goto] = ACTIONS(2215),
    [anon_sym_not] = ACTIONS(2215),
    [anon_sym_compl] = ACTIONS(2215),
    [anon_sym_DASH_DASH] = ACTIONS(2217),
    [anon_sym_PLUS_PLUS] = ACTIONS(2217),
    [anon_sym_sizeof] = ACTIONS(2215),
    [anon_sym___alignof__] = ACTIONS(2215),
    [anon_sym___alignof] = ACTIONS(2215),
    [anon_sym__alignof] = ACTIONS(2215),
    [anon_sym_alignof] = ACTIONS(2215),
    [anon_sym__Alignof] = ACTIONS(2215),
    [anon_sym_offsetof] = ACTIONS(2215),
    [anon_sym__Generic] = ACTIONS(2215),
    [anon_sym_asm] = ACTIONS(2215),
    [anon_sym___asm__] = ACTIONS(2215),
    [sym_number_literal] = ACTIONS(2217),
    [anon_sym_L_SQUOTE] = ACTIONS(2217),
    [anon_sym_u_SQUOTE] = ACTIONS(2217),
    [anon_sym_U_SQUOTE] = ACTIONS(2217),
    [anon_sym_u8_SQUOTE] = ACTIONS(2217),
    [anon_sym_SQUOTE] = ACTIONS(2217),
    [anon_sym_L_DQUOTE] = ACTIONS(2217),
    [anon_sym_u_DQUOTE] = ACTIONS(2217),
    [anon_sym_U_DQUOTE] = ACTIONS(2217),
    [anon_sym_u8_DQUOTE] = ACTIONS(2217),
    [anon_sym_DQUOTE] = ACTIONS(2217),
    [sym_true] = ACTIONS(2215),
    [sym_false] = ACTIONS(2215),
    [anon_sym_NULL] = ACTIONS(2215),
    [anon_sym_nullptr] = ACTIONS(2215),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2215),
    [anon_sym_decltype] = ACTIONS(2215),
    [sym_virtual] = ACTIONS(2215),
    [anon_sym_explicit] = ACTIONS(2215),
    [anon_sym_typename] = ACTIONS(2215),
    [anon_sym_template] = ACTIONS(2215),
    [anon_sym_operator] = ACTIONS(2215),
    [anon_sym_try] = ACTIONS(2215),
    [anon_sym_delete] = ACTIONS(2215),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_namespace] = ACTIONS(2215),
    [anon_sym_using] = ACTIONS(2215),
    [anon_sym_static_assert] = ACTIONS(2215),
    [anon_sym_concept] = ACTIONS(2215),
    [anon_sym_co_return] = ACTIONS(2215),
    [anon_sym_co_yield] = ACTIONS(2215),
    [anon_sym_R_DQUOTE] = ACTIONS(2217),
    [anon_sym_LR_DQUOTE] = ACTIONS(2217),
    [anon_sym_uR_DQUOTE] = ACTIONS(2217),
    [anon_sym_UR_DQUOTE] = ACTIONS(2217),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2217),
    [anon_sym_co_await] = ACTIONS(2215),
    [anon_sym_new] = ACTIONS(2215),
    [anon_sym_requires] = ACTIONS(2215),
    [sym_this] = ACTIONS(2215),
    [anon_sym___launch_bounds__] = ACTIONS(2215),
  },
  [726] = {
    [sym_preproc_def] = STATE(701),
    [sym_preproc_function_def] = STATE(701),
    [sym_preproc_call] = STATE(701),
    [sym_preproc_if_in_field_declaration_list] = STATE(701),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(701),
    [sym_type_definition] = STATE(701),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5894),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6463),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(701),
    [sym_field_declaration] = STATE(701),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1708),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(701),
    [sym_operator_cast] = STATE(6999),
    [sym_inline_method_definition] = STATE(701),
    [sym__constructor_specifiers] = STATE(1708),
    [sym_operator_cast_definition] = STATE(701),
    [sym_operator_cast_declaration] = STATE(701),
    [sym_constructor_or_destructor_definition] = STATE(701),
    [sym_constructor_or_destructor_declaration] = STATE(701),
    [sym_friend_declaration] = STATE(701),
    [sym_access_specifier] = STATE(8255),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(701),
    [sym_alias_declaration] = STATE(701),
    [sym_static_assert_declaration] = STATE(701),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6999),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(701),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1708),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3376),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3378),
    [sym_preproc_directive] = ACTIONS(3380),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(3382),
    [anon_sym_typedef] = ACTIONS(3384),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3460),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3390),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(3392),
    [anon_sym_static_assert] = ACTIONS(3394),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [727] = {
    [sym_preproc_def] = STATE(748),
    [sym_preproc_function_def] = STATE(748),
    [sym_preproc_call] = STATE(748),
    [sym_preproc_if_in_field_declaration_list] = STATE(748),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(748),
    [sym_type_definition] = STATE(748),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5894),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6463),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(748),
    [sym_field_declaration] = STATE(748),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1708),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(748),
    [sym_operator_cast] = STATE(6999),
    [sym_inline_method_definition] = STATE(748),
    [sym__constructor_specifiers] = STATE(1708),
    [sym_operator_cast_definition] = STATE(748),
    [sym_operator_cast_declaration] = STATE(748),
    [sym_constructor_or_destructor_definition] = STATE(748),
    [sym_constructor_or_destructor_declaration] = STATE(748),
    [sym_friend_declaration] = STATE(748),
    [sym_access_specifier] = STATE(8255),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(748),
    [sym_alias_declaration] = STATE(748),
    [sym_static_assert_declaration] = STATE(748),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6999),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(748),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1708),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3376),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3378),
    [sym_preproc_directive] = ACTIONS(3380),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(3382),
    [anon_sym_typedef] = ACTIONS(3384),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3462),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3390),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(3392),
    [anon_sym_static_assert] = ACTIONS(3394),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [728] = {
    [ts_builtin_sym_end] = ACTIONS(2253),
    [sym_identifier] = ACTIONS(2251),
    [aux_sym_preproc_include_token1] = ACTIONS(2251),
    [aux_sym_preproc_def_token1] = ACTIONS(2251),
    [aux_sym_preproc_if_token1] = ACTIONS(2251),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2251),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2251),
    [sym_preproc_directive] = ACTIONS(2251),
    [anon_sym_LPAREN2] = ACTIONS(2253),
    [anon_sym_BANG] = ACTIONS(2253),
    [anon_sym_TILDE] = ACTIONS(2253),
    [anon_sym_DASH] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2251),
    [anon_sym_STAR] = ACTIONS(2253),
    [anon_sym_AMP_AMP] = ACTIONS(2253),
    [anon_sym_AMP] = ACTIONS(2251),
    [anon_sym___extension__] = ACTIONS(2251),
    [anon_sym_typedef] = ACTIONS(2251),
    [anon_sym___device__] = ACTIONS(2251),
    [anon_sym___host__] = ACTIONS(2251),
    [anon_sym___global__] = ACTIONS(2251),
    [anon_sym___forceinline__] = ACTIONS(2251),
    [anon_sym___noinline__] = ACTIONS(2251),
    [anon_sym_extern] = ACTIONS(2251),
    [anon_sym___attribute__] = ACTIONS(2251),
    [anon_sym_COLON_COLON] = ACTIONS(2253),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2253),
    [anon_sym___declspec] = ACTIONS(2251),
    [anon_sym___based] = ACTIONS(2251),
    [anon_sym___cdecl] = ACTIONS(2251),
    [anon_sym___clrcall] = ACTIONS(2251),
    [anon_sym___stdcall] = ACTIONS(2251),
    [anon_sym___fastcall] = ACTIONS(2251),
    [anon_sym___thiscall] = ACTIONS(2251),
    [anon_sym___vectorcall] = ACTIONS(2251),
    [anon_sym_LBRACE] = ACTIONS(2253),
    [anon_sym_signed] = ACTIONS(2251),
    [anon_sym_unsigned] = ACTIONS(2251),
    [anon_sym_long] = ACTIONS(2251),
    [anon_sym_short] = ACTIONS(2251),
    [anon_sym_LBRACK] = ACTIONS(2251),
    [anon_sym_static] = ACTIONS(2251),
    [anon_sym_register] = ACTIONS(2251),
    [anon_sym_inline] = ACTIONS(2251),
    [anon_sym___inline] = ACTIONS(2251),
    [anon_sym___inline__] = ACTIONS(2251),
    [anon_sym___forceinline] = ACTIONS(2251),
    [anon_sym_thread_local] = ACTIONS(2251),
    [anon_sym___thread] = ACTIONS(2251),
    [anon_sym_const] = ACTIONS(2251),
    [anon_sym_constexpr] = ACTIONS(2251),
    [anon_sym_volatile] = ACTIONS(2251),
    [anon_sym_restrict] = ACTIONS(2251),
    [anon_sym___restrict__] = ACTIONS(2251),
    [anon_sym__Atomic] = ACTIONS(2251),
    [anon_sym__Noreturn] = ACTIONS(2251),
    [anon_sym_noreturn] = ACTIONS(2251),
    [anon_sym_mutable] = ACTIONS(2251),
    [anon_sym_constinit] = ACTIONS(2251),
    [anon_sym_consteval] = ACTIONS(2251),
    [anon_sym___shared__] = ACTIONS(2251),
    [anon_sym___local__] = ACTIONS(2251),
    [anon_sym___constant__] = ACTIONS(2251),
    [anon_sym___managed__] = ACTIONS(2251),
    [anon_sym___grid_constant__] = ACTIONS(2251),
    [anon_sym_alignas] = ACTIONS(2251),
    [anon_sym__Alignas] = ACTIONS(2251),
    [sym_primitive_type] = ACTIONS(2251),
    [anon_sym_enum] = ACTIONS(2251),
    [anon_sym_class] = ACTIONS(2251),
    [anon_sym_struct] = ACTIONS(2251),
    [anon_sym_union] = ACTIONS(2251),
    [anon_sym_if] = ACTIONS(2251),
    [anon_sym_switch] = ACTIONS(2251),
    [anon_sym_case] = ACTIONS(2251),
    [anon_sym_default] = ACTIONS(2251),
    [anon_sym_while] = ACTIONS(2251),
    [anon_sym_do] = ACTIONS(2251),
    [anon_sym_for] = ACTIONS(2251),
    [anon_sym_return] = ACTIONS(2251),
    [anon_sym_break] = ACTIONS(2251),
    [anon_sym_continue] = ACTIONS(2251),
    [anon_sym_goto] = ACTIONS(2251),
    [anon_sym_not] = ACTIONS(2251),
    [anon_sym_compl] = ACTIONS(2251),
    [anon_sym_DASH_DASH] = ACTIONS(2253),
    [anon_sym_PLUS_PLUS] = ACTIONS(2253),
    [anon_sym_sizeof] = ACTIONS(2251),
    [anon_sym___alignof__] = ACTIONS(2251),
    [anon_sym___alignof] = ACTIONS(2251),
    [anon_sym__alignof] = ACTIONS(2251),
    [anon_sym_alignof] = ACTIONS(2251),
    [anon_sym__Alignof] = ACTIONS(2251),
    [anon_sym_offsetof] = ACTIONS(2251),
    [anon_sym__Generic] = ACTIONS(2251),
    [anon_sym_asm] = ACTIONS(2251),
    [anon_sym___asm__] = ACTIONS(2251),
    [sym_number_literal] = ACTIONS(2253),
    [anon_sym_L_SQUOTE] = ACTIONS(2253),
    [anon_sym_u_SQUOTE] = ACTIONS(2253),
    [anon_sym_U_SQUOTE] = ACTIONS(2253),
    [anon_sym_u8_SQUOTE] = ACTIONS(2253),
    [anon_sym_SQUOTE] = ACTIONS(2253),
    [anon_sym_L_DQUOTE] = ACTIONS(2253),
    [anon_sym_u_DQUOTE] = ACTIONS(2253),
    [anon_sym_U_DQUOTE] = ACTIONS(2253),
    [anon_sym_u8_DQUOTE] = ACTIONS(2253),
    [anon_sym_DQUOTE] = ACTIONS(2253),
    [sym_true] = ACTIONS(2251),
    [sym_false] = ACTIONS(2251),
    [anon_sym_NULL] = ACTIONS(2251),
    [anon_sym_nullptr] = ACTIONS(2251),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2251),
    [anon_sym_decltype] = ACTIONS(2251),
    [sym_virtual] = ACTIONS(2251),
    [anon_sym_explicit] = ACTIONS(2251),
    [anon_sym_typename] = ACTIONS(2251),
    [anon_sym_template] = ACTIONS(2251),
    [anon_sym_operator] = ACTIONS(2251),
    [anon_sym_try] = ACTIONS(2251),
    [anon_sym_delete] = ACTIONS(2251),
    [anon_sym_throw] = ACTIONS(2251),
    [anon_sym_namespace] = ACTIONS(2251),
    [anon_sym_using] = ACTIONS(2251),
    [anon_sym_static_assert] = ACTIONS(2251),
    [anon_sym_concept] = ACTIONS(2251),
    [anon_sym_co_return] = ACTIONS(2251),
    [anon_sym_co_yield] = ACTIONS(2251),
    [anon_sym_R_DQUOTE] = ACTIONS(2253),
    [anon_sym_LR_DQUOTE] = ACTIONS(2253),
    [anon_sym_uR_DQUOTE] = ACTIONS(2253),
    [anon_sym_UR_DQUOTE] = ACTIONS(2253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2253),
    [anon_sym_co_await] = ACTIONS(2251),
    [anon_sym_new] = ACTIONS(2251),
    [anon_sym_requires] = ACTIONS(2251),
    [sym_this] = ACTIONS(2251),
    [anon_sym___launch_bounds__] = ACTIONS(2251),
  },
  [729] = {
    [ts_builtin_sym_end] = ACTIONS(2344),
    [sym_identifier] = ACTIONS(2342),
    [aux_sym_preproc_include_token1] = ACTIONS(2342),
    [aux_sym_preproc_def_token1] = ACTIONS(2342),
    [aux_sym_preproc_if_token1] = ACTIONS(2342),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2342),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2342),
    [sym_preproc_directive] = ACTIONS(2342),
    [anon_sym_LPAREN2] = ACTIONS(2344),
    [anon_sym_BANG] = ACTIONS(2344),
    [anon_sym_TILDE] = ACTIONS(2344),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2342),
    [anon_sym___extension__] = ACTIONS(2342),
    [anon_sym_typedef] = ACTIONS(2342),
    [anon_sym___device__] = ACTIONS(2342),
    [anon_sym___host__] = ACTIONS(2342),
    [anon_sym___global__] = ACTIONS(2342),
    [anon_sym___forceinline__] = ACTIONS(2342),
    [anon_sym___noinline__] = ACTIONS(2342),
    [anon_sym_extern] = ACTIONS(2342),
    [anon_sym___attribute__] = ACTIONS(2342),
    [anon_sym_COLON_COLON] = ACTIONS(2344),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2344),
    [anon_sym___declspec] = ACTIONS(2342),
    [anon_sym___based] = ACTIONS(2342),
    [anon_sym___cdecl] = ACTIONS(2342),
    [anon_sym___clrcall] = ACTIONS(2342),
    [anon_sym___stdcall] = ACTIONS(2342),
    [anon_sym___fastcall] = ACTIONS(2342),
    [anon_sym___thiscall] = ACTIONS(2342),
    [anon_sym___vectorcall] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2344),
    [anon_sym_signed] = ACTIONS(2342),
    [anon_sym_unsigned] = ACTIONS(2342),
    [anon_sym_long] = ACTIONS(2342),
    [anon_sym_short] = ACTIONS(2342),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_static] = ACTIONS(2342),
    [anon_sym_register] = ACTIONS(2342),
    [anon_sym_inline] = ACTIONS(2342),
    [anon_sym___inline] = ACTIONS(2342),
    [anon_sym___inline__] = ACTIONS(2342),
    [anon_sym___forceinline] = ACTIONS(2342),
    [anon_sym_thread_local] = ACTIONS(2342),
    [anon_sym___thread] = ACTIONS(2342),
    [anon_sym_const] = ACTIONS(2342),
    [anon_sym_constexpr] = ACTIONS(2342),
    [anon_sym_volatile] = ACTIONS(2342),
    [anon_sym_restrict] = ACTIONS(2342),
    [anon_sym___restrict__] = ACTIONS(2342),
    [anon_sym__Atomic] = ACTIONS(2342),
    [anon_sym__Noreturn] = ACTIONS(2342),
    [anon_sym_noreturn] = ACTIONS(2342),
    [anon_sym_mutable] = ACTIONS(2342),
    [anon_sym_constinit] = ACTIONS(2342),
    [anon_sym_consteval] = ACTIONS(2342),
    [anon_sym___shared__] = ACTIONS(2342),
    [anon_sym___local__] = ACTIONS(2342),
    [anon_sym___constant__] = ACTIONS(2342),
    [anon_sym___managed__] = ACTIONS(2342),
    [anon_sym___grid_constant__] = ACTIONS(2342),
    [anon_sym_alignas] = ACTIONS(2342),
    [anon_sym__Alignas] = ACTIONS(2342),
    [sym_primitive_type] = ACTIONS(2342),
    [anon_sym_enum] = ACTIONS(2342),
    [anon_sym_class] = ACTIONS(2342),
    [anon_sym_struct] = ACTIONS(2342),
    [anon_sym_union] = ACTIONS(2342),
    [anon_sym_if] = ACTIONS(2342),
    [anon_sym_switch] = ACTIONS(2342),
    [anon_sym_case] = ACTIONS(2342),
    [anon_sym_default] = ACTIONS(2342),
    [anon_sym_while] = ACTIONS(2342),
    [anon_sym_do] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2342),
    [anon_sym_return] = ACTIONS(2342),
    [anon_sym_break] = ACTIONS(2342),
    [anon_sym_continue] = ACTIONS(2342),
    [anon_sym_goto] = ACTIONS(2342),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2344),
    [anon_sym_PLUS_PLUS] = ACTIONS(2344),
    [anon_sym_sizeof] = ACTIONS(2342),
    [anon_sym___alignof__] = ACTIONS(2342),
    [anon_sym___alignof] = ACTIONS(2342),
    [anon_sym__alignof] = ACTIONS(2342),
    [anon_sym_alignof] = ACTIONS(2342),
    [anon_sym__Alignof] = ACTIONS(2342),
    [anon_sym_offsetof] = ACTIONS(2342),
    [anon_sym__Generic] = ACTIONS(2342),
    [anon_sym_asm] = ACTIONS(2342),
    [anon_sym___asm__] = ACTIONS(2342),
    [sym_number_literal] = ACTIONS(2344),
    [anon_sym_L_SQUOTE] = ACTIONS(2344),
    [anon_sym_u_SQUOTE] = ACTIONS(2344),
    [anon_sym_U_SQUOTE] = ACTIONS(2344),
    [anon_sym_u8_SQUOTE] = ACTIONS(2344),
    [anon_sym_SQUOTE] = ACTIONS(2344),
    [anon_sym_L_DQUOTE] = ACTIONS(2344),
    [anon_sym_u_DQUOTE] = ACTIONS(2344),
    [anon_sym_U_DQUOTE] = ACTIONS(2344),
    [anon_sym_u8_DQUOTE] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [sym_true] = ACTIONS(2342),
    [sym_false] = ACTIONS(2342),
    [anon_sym_NULL] = ACTIONS(2342),
    [anon_sym_nullptr] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2342),
    [anon_sym_decltype] = ACTIONS(2342),
    [sym_virtual] = ACTIONS(2342),
    [anon_sym_explicit] = ACTIONS(2342),
    [anon_sym_typename] = ACTIONS(2342),
    [anon_sym_template] = ACTIONS(2342),
    [anon_sym_operator] = ACTIONS(2342),
    [anon_sym_try] = ACTIONS(2342),
    [anon_sym_delete] = ACTIONS(2342),
    [anon_sym_throw] = ACTIONS(2342),
    [anon_sym_namespace] = ACTIONS(2342),
    [anon_sym_using] = ACTIONS(2342),
    [anon_sym_static_assert] = ACTIONS(2342),
    [anon_sym_concept] = ACTIONS(2342),
    [anon_sym_co_return] = ACTIONS(2342),
    [anon_sym_co_yield] = ACTIONS(2342),
    [anon_sym_R_DQUOTE] = ACTIONS(2344),
    [anon_sym_LR_DQUOTE] = ACTIONS(2344),
    [anon_sym_uR_DQUOTE] = ACTIONS(2344),
    [anon_sym_UR_DQUOTE] = ACTIONS(2344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2344),
    [anon_sym_co_await] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2342),
    [anon_sym_requires] = ACTIONS(2342),
    [sym_this] = ACTIONS(2342),
    [anon_sym___launch_bounds__] = ACTIONS(2342),
  },
  [730] = {
    [ts_builtin_sym_end] = ACTIONS(2336),
    [sym_identifier] = ACTIONS(2334),
    [aux_sym_preproc_include_token1] = ACTIONS(2334),
    [aux_sym_preproc_def_token1] = ACTIONS(2334),
    [aux_sym_preproc_if_token1] = ACTIONS(2334),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2334),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2334),
    [sym_preproc_directive] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(2336),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [anon_sym_DASH] = ACTIONS(2334),
    [anon_sym_PLUS] = ACTIONS(2334),
    [anon_sym_STAR] = ACTIONS(2336),
    [anon_sym_AMP_AMP] = ACTIONS(2336),
    [anon_sym_AMP] = ACTIONS(2334),
    [anon_sym___extension__] = ACTIONS(2334),
    [anon_sym_typedef] = ACTIONS(2334),
    [anon_sym___device__] = ACTIONS(2334),
    [anon_sym___host__] = ACTIONS(2334),
    [anon_sym___global__] = ACTIONS(2334),
    [anon_sym___forceinline__] = ACTIONS(2334),
    [anon_sym___noinline__] = ACTIONS(2334),
    [anon_sym_extern] = ACTIONS(2334),
    [anon_sym___attribute__] = ACTIONS(2334),
    [anon_sym_COLON_COLON] = ACTIONS(2336),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2336),
    [anon_sym___declspec] = ACTIONS(2334),
    [anon_sym___based] = ACTIONS(2334),
    [anon_sym___cdecl] = ACTIONS(2334),
    [anon_sym___clrcall] = ACTIONS(2334),
    [anon_sym___stdcall] = ACTIONS(2334),
    [anon_sym___fastcall] = ACTIONS(2334),
    [anon_sym___thiscall] = ACTIONS(2334),
    [anon_sym___vectorcall] = ACTIONS(2334),
    [anon_sym_LBRACE] = ACTIONS(2336),
    [anon_sym_signed] = ACTIONS(2334),
    [anon_sym_unsigned] = ACTIONS(2334),
    [anon_sym_long] = ACTIONS(2334),
    [anon_sym_short] = ACTIONS(2334),
    [anon_sym_LBRACK] = ACTIONS(2334),
    [anon_sym_static] = ACTIONS(2334),
    [anon_sym_register] = ACTIONS(2334),
    [anon_sym_inline] = ACTIONS(2334),
    [anon_sym___inline] = ACTIONS(2334),
    [anon_sym___inline__] = ACTIONS(2334),
    [anon_sym___forceinline] = ACTIONS(2334),
    [anon_sym_thread_local] = ACTIONS(2334),
    [anon_sym___thread] = ACTIONS(2334),
    [anon_sym_const] = ACTIONS(2334),
    [anon_sym_constexpr] = ACTIONS(2334),
    [anon_sym_volatile] = ACTIONS(2334),
    [anon_sym_restrict] = ACTIONS(2334),
    [anon_sym___restrict__] = ACTIONS(2334),
    [anon_sym__Atomic] = ACTIONS(2334),
    [anon_sym__Noreturn] = ACTIONS(2334),
    [anon_sym_noreturn] = ACTIONS(2334),
    [anon_sym_mutable] = ACTIONS(2334),
    [anon_sym_constinit] = ACTIONS(2334),
    [anon_sym_consteval] = ACTIONS(2334),
    [anon_sym___shared__] = ACTIONS(2334),
    [anon_sym___local__] = ACTIONS(2334),
    [anon_sym___constant__] = ACTIONS(2334),
    [anon_sym___managed__] = ACTIONS(2334),
    [anon_sym___grid_constant__] = ACTIONS(2334),
    [anon_sym_alignas] = ACTIONS(2334),
    [anon_sym__Alignas] = ACTIONS(2334),
    [sym_primitive_type] = ACTIONS(2334),
    [anon_sym_enum] = ACTIONS(2334),
    [anon_sym_class] = ACTIONS(2334),
    [anon_sym_struct] = ACTIONS(2334),
    [anon_sym_union] = ACTIONS(2334),
    [anon_sym_if] = ACTIONS(2334),
    [anon_sym_switch] = ACTIONS(2334),
    [anon_sym_case] = ACTIONS(2334),
    [anon_sym_default] = ACTIONS(2334),
    [anon_sym_while] = ACTIONS(2334),
    [anon_sym_do] = ACTIONS(2334),
    [anon_sym_for] = ACTIONS(2334),
    [anon_sym_return] = ACTIONS(2334),
    [anon_sym_break] = ACTIONS(2334),
    [anon_sym_continue] = ACTIONS(2334),
    [anon_sym_goto] = ACTIONS(2334),
    [anon_sym_not] = ACTIONS(2334),
    [anon_sym_compl] = ACTIONS(2334),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_sizeof] = ACTIONS(2334),
    [anon_sym___alignof__] = ACTIONS(2334),
    [anon_sym___alignof] = ACTIONS(2334),
    [anon_sym__alignof] = ACTIONS(2334),
    [anon_sym_alignof] = ACTIONS(2334),
    [anon_sym__Alignof] = ACTIONS(2334),
    [anon_sym_offsetof] = ACTIONS(2334),
    [anon_sym__Generic] = ACTIONS(2334),
    [anon_sym_asm] = ACTIONS(2334),
    [anon_sym___asm__] = ACTIONS(2334),
    [sym_number_literal] = ACTIONS(2336),
    [anon_sym_L_SQUOTE] = ACTIONS(2336),
    [anon_sym_u_SQUOTE] = ACTIONS(2336),
    [anon_sym_U_SQUOTE] = ACTIONS(2336),
    [anon_sym_u8_SQUOTE] = ACTIONS(2336),
    [anon_sym_SQUOTE] = ACTIONS(2336),
    [anon_sym_L_DQUOTE] = ACTIONS(2336),
    [anon_sym_u_DQUOTE] = ACTIONS(2336),
    [anon_sym_U_DQUOTE] = ACTIONS(2336),
    [anon_sym_u8_DQUOTE] = ACTIONS(2336),
    [anon_sym_DQUOTE] = ACTIONS(2336),
    [sym_true] = ACTIONS(2334),
    [sym_false] = ACTIONS(2334),
    [anon_sym_NULL] = ACTIONS(2334),
    [anon_sym_nullptr] = ACTIONS(2334),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2334),
    [anon_sym_decltype] = ACTIONS(2334),
    [sym_virtual] = ACTIONS(2334),
    [anon_sym_explicit] = ACTIONS(2334),
    [anon_sym_typename] = ACTIONS(2334),
    [anon_sym_template] = ACTIONS(2334),
    [anon_sym_operator] = ACTIONS(2334),
    [anon_sym_try] = ACTIONS(2334),
    [anon_sym_delete] = ACTIONS(2334),
    [anon_sym_throw] = ACTIONS(2334),
    [anon_sym_namespace] = ACTIONS(2334),
    [anon_sym_using] = ACTIONS(2334),
    [anon_sym_static_assert] = ACTIONS(2334),
    [anon_sym_concept] = ACTIONS(2334),
    [anon_sym_co_return] = ACTIONS(2334),
    [anon_sym_co_yield] = ACTIONS(2334),
    [anon_sym_R_DQUOTE] = ACTIONS(2336),
    [anon_sym_LR_DQUOTE] = ACTIONS(2336),
    [anon_sym_uR_DQUOTE] = ACTIONS(2336),
    [anon_sym_UR_DQUOTE] = ACTIONS(2336),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2336),
    [anon_sym_co_await] = ACTIONS(2334),
    [anon_sym_new] = ACTIONS(2334),
    [anon_sym_requires] = ACTIONS(2334),
    [sym_this] = ACTIONS(2334),
    [anon_sym___launch_bounds__] = ACTIONS(2334),
  },
  [731] = {
    [ts_builtin_sym_end] = ACTIONS(2463),
    [sym_identifier] = ACTIONS(2461),
    [aux_sym_preproc_include_token1] = ACTIONS(2461),
    [aux_sym_preproc_def_token1] = ACTIONS(2461),
    [aux_sym_preproc_if_token1] = ACTIONS(2461),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2461),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2461),
    [sym_preproc_directive] = ACTIONS(2461),
    [anon_sym_LPAREN2] = ACTIONS(2463),
    [anon_sym_BANG] = ACTIONS(2463),
    [anon_sym_TILDE] = ACTIONS(2463),
    [anon_sym_DASH] = ACTIONS(2461),
    [anon_sym_PLUS] = ACTIONS(2461),
    [anon_sym_STAR] = ACTIONS(2463),
    [anon_sym_AMP_AMP] = ACTIONS(2463),
    [anon_sym_AMP] = ACTIONS(2461),
    [anon_sym___extension__] = ACTIONS(2461),
    [anon_sym_typedef] = ACTIONS(2461),
    [anon_sym___device__] = ACTIONS(2461),
    [anon_sym___host__] = ACTIONS(2461),
    [anon_sym___global__] = ACTIONS(2461),
    [anon_sym___forceinline__] = ACTIONS(2461),
    [anon_sym___noinline__] = ACTIONS(2461),
    [anon_sym_extern] = ACTIONS(2461),
    [anon_sym___attribute__] = ACTIONS(2461),
    [anon_sym_COLON_COLON] = ACTIONS(2463),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2463),
    [anon_sym___declspec] = ACTIONS(2461),
    [anon_sym___based] = ACTIONS(2461),
    [anon_sym___cdecl] = ACTIONS(2461),
    [anon_sym___clrcall] = ACTIONS(2461),
    [anon_sym___stdcall] = ACTIONS(2461),
    [anon_sym___fastcall] = ACTIONS(2461),
    [anon_sym___thiscall] = ACTIONS(2461),
    [anon_sym___vectorcall] = ACTIONS(2461),
    [anon_sym_LBRACE] = ACTIONS(2463),
    [anon_sym_signed] = ACTIONS(2461),
    [anon_sym_unsigned] = ACTIONS(2461),
    [anon_sym_long] = ACTIONS(2461),
    [anon_sym_short] = ACTIONS(2461),
    [anon_sym_LBRACK] = ACTIONS(2461),
    [anon_sym_static] = ACTIONS(2461),
    [anon_sym_register] = ACTIONS(2461),
    [anon_sym_inline] = ACTIONS(2461),
    [anon_sym___inline] = ACTIONS(2461),
    [anon_sym___inline__] = ACTIONS(2461),
    [anon_sym___forceinline] = ACTIONS(2461),
    [anon_sym_thread_local] = ACTIONS(2461),
    [anon_sym___thread] = ACTIONS(2461),
    [anon_sym_const] = ACTIONS(2461),
    [anon_sym_constexpr] = ACTIONS(2461),
    [anon_sym_volatile] = ACTIONS(2461),
    [anon_sym_restrict] = ACTIONS(2461),
    [anon_sym___restrict__] = ACTIONS(2461),
    [anon_sym__Atomic] = ACTIONS(2461),
    [anon_sym__Noreturn] = ACTIONS(2461),
    [anon_sym_noreturn] = ACTIONS(2461),
    [anon_sym_mutable] = ACTIONS(2461),
    [anon_sym_constinit] = ACTIONS(2461),
    [anon_sym_consteval] = ACTIONS(2461),
    [anon_sym___shared__] = ACTIONS(2461),
    [anon_sym___local__] = ACTIONS(2461),
    [anon_sym___constant__] = ACTIONS(2461),
    [anon_sym___managed__] = ACTIONS(2461),
    [anon_sym___grid_constant__] = ACTIONS(2461),
    [anon_sym_alignas] = ACTIONS(2461),
    [anon_sym__Alignas] = ACTIONS(2461),
    [sym_primitive_type] = ACTIONS(2461),
    [anon_sym_enum] = ACTIONS(2461),
    [anon_sym_class] = ACTIONS(2461),
    [anon_sym_struct] = ACTIONS(2461),
    [anon_sym_union] = ACTIONS(2461),
    [anon_sym_if] = ACTIONS(2461),
    [anon_sym_switch] = ACTIONS(2461),
    [anon_sym_case] = ACTIONS(2461),
    [anon_sym_default] = ACTIONS(2461),
    [anon_sym_while] = ACTIONS(2461),
    [anon_sym_do] = ACTIONS(2461),
    [anon_sym_for] = ACTIONS(2461),
    [anon_sym_return] = ACTIONS(2461),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_continue] = ACTIONS(2461),
    [anon_sym_goto] = ACTIONS(2461),
    [anon_sym_not] = ACTIONS(2461),
    [anon_sym_compl] = ACTIONS(2461),
    [anon_sym_DASH_DASH] = ACTIONS(2463),
    [anon_sym_PLUS_PLUS] = ACTIONS(2463),
    [anon_sym_sizeof] = ACTIONS(2461),
    [anon_sym___alignof__] = ACTIONS(2461),
    [anon_sym___alignof] = ACTIONS(2461),
    [anon_sym__alignof] = ACTIONS(2461),
    [anon_sym_alignof] = ACTIONS(2461),
    [anon_sym__Alignof] = ACTIONS(2461),
    [anon_sym_offsetof] = ACTIONS(2461),
    [anon_sym__Generic] = ACTIONS(2461),
    [anon_sym_asm] = ACTIONS(2461),
    [anon_sym___asm__] = ACTIONS(2461),
    [sym_number_literal] = ACTIONS(2463),
    [anon_sym_L_SQUOTE] = ACTIONS(2463),
    [anon_sym_u_SQUOTE] = ACTIONS(2463),
    [anon_sym_U_SQUOTE] = ACTIONS(2463),
    [anon_sym_u8_SQUOTE] = ACTIONS(2463),
    [anon_sym_SQUOTE] = ACTIONS(2463),
    [anon_sym_L_DQUOTE] = ACTIONS(2463),
    [anon_sym_u_DQUOTE] = ACTIONS(2463),
    [anon_sym_U_DQUOTE] = ACTIONS(2463),
    [anon_sym_u8_DQUOTE] = ACTIONS(2463),
    [anon_sym_DQUOTE] = ACTIONS(2463),
    [sym_true] = ACTIONS(2461),
    [sym_false] = ACTIONS(2461),
    [anon_sym_NULL] = ACTIONS(2461),
    [anon_sym_nullptr] = ACTIONS(2461),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2461),
    [anon_sym_decltype] = ACTIONS(2461),
    [sym_virtual] = ACTIONS(2461),
    [anon_sym_explicit] = ACTIONS(2461),
    [anon_sym_typename] = ACTIONS(2461),
    [anon_sym_template] = ACTIONS(2461),
    [anon_sym_operator] = ACTIONS(2461),
    [anon_sym_try] = ACTIONS(2461),
    [anon_sym_delete] = ACTIONS(2461),
    [anon_sym_throw] = ACTIONS(2461),
    [anon_sym_namespace] = ACTIONS(2461),
    [anon_sym_using] = ACTIONS(2461),
    [anon_sym_static_assert] = ACTIONS(2461),
    [anon_sym_concept] = ACTIONS(2461),
    [anon_sym_co_return] = ACTIONS(2461),
    [anon_sym_co_yield] = ACTIONS(2461),
    [anon_sym_R_DQUOTE] = ACTIONS(2463),
    [anon_sym_LR_DQUOTE] = ACTIONS(2463),
    [anon_sym_uR_DQUOTE] = ACTIONS(2463),
    [anon_sym_UR_DQUOTE] = ACTIONS(2463),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2463),
    [anon_sym_co_await] = ACTIONS(2461),
    [anon_sym_new] = ACTIONS(2461),
    [anon_sym_requires] = ACTIONS(2461),
    [sym_this] = ACTIONS(2461),
    [anon_sym___launch_bounds__] = ACTIONS(2461),
  },
  [732] = {
    [ts_builtin_sym_end] = ACTIONS(2249),
    [sym_identifier] = ACTIONS(2247),
    [aux_sym_preproc_include_token1] = ACTIONS(2247),
    [aux_sym_preproc_def_token1] = ACTIONS(2247),
    [aux_sym_preproc_if_token1] = ACTIONS(2247),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2247),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2247),
    [sym_preproc_directive] = ACTIONS(2247),
    [anon_sym_LPAREN2] = ACTIONS(2249),
    [anon_sym_BANG] = ACTIONS(2249),
    [anon_sym_TILDE] = ACTIONS(2249),
    [anon_sym_DASH] = ACTIONS(2247),
    [anon_sym_PLUS] = ACTIONS(2247),
    [anon_sym_STAR] = ACTIONS(2249),
    [anon_sym_AMP_AMP] = ACTIONS(2249),
    [anon_sym_AMP] = ACTIONS(2247),
    [anon_sym___extension__] = ACTIONS(2247),
    [anon_sym_typedef] = ACTIONS(2247),
    [anon_sym___device__] = ACTIONS(2247),
    [anon_sym___host__] = ACTIONS(2247),
    [anon_sym___global__] = ACTIONS(2247),
    [anon_sym___forceinline__] = ACTIONS(2247),
    [anon_sym___noinline__] = ACTIONS(2247),
    [anon_sym_extern] = ACTIONS(2247),
    [anon_sym___attribute__] = ACTIONS(2247),
    [anon_sym_COLON_COLON] = ACTIONS(2249),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2249),
    [anon_sym___declspec] = ACTIONS(2247),
    [anon_sym___based] = ACTIONS(2247),
    [anon_sym___cdecl] = ACTIONS(2247),
    [anon_sym___clrcall] = ACTIONS(2247),
    [anon_sym___stdcall] = ACTIONS(2247),
    [anon_sym___fastcall] = ACTIONS(2247),
    [anon_sym___thiscall] = ACTIONS(2247),
    [anon_sym___vectorcall] = ACTIONS(2247),
    [anon_sym_LBRACE] = ACTIONS(2249),
    [anon_sym_signed] = ACTIONS(2247),
    [anon_sym_unsigned] = ACTIONS(2247),
    [anon_sym_long] = ACTIONS(2247),
    [anon_sym_short] = ACTIONS(2247),
    [anon_sym_LBRACK] = ACTIONS(2247),
    [anon_sym_static] = ACTIONS(2247),
    [anon_sym_register] = ACTIONS(2247),
    [anon_sym_inline] = ACTIONS(2247),
    [anon_sym___inline] = ACTIONS(2247),
    [anon_sym___inline__] = ACTIONS(2247),
    [anon_sym___forceinline] = ACTIONS(2247),
    [anon_sym_thread_local] = ACTIONS(2247),
    [anon_sym___thread] = ACTIONS(2247),
    [anon_sym_const] = ACTIONS(2247),
    [anon_sym_constexpr] = ACTIONS(2247),
    [anon_sym_volatile] = ACTIONS(2247),
    [anon_sym_restrict] = ACTIONS(2247),
    [anon_sym___restrict__] = ACTIONS(2247),
    [anon_sym__Atomic] = ACTIONS(2247),
    [anon_sym__Noreturn] = ACTIONS(2247),
    [anon_sym_noreturn] = ACTIONS(2247),
    [anon_sym_mutable] = ACTIONS(2247),
    [anon_sym_constinit] = ACTIONS(2247),
    [anon_sym_consteval] = ACTIONS(2247),
    [anon_sym___shared__] = ACTIONS(2247),
    [anon_sym___local__] = ACTIONS(2247),
    [anon_sym___constant__] = ACTIONS(2247),
    [anon_sym___managed__] = ACTIONS(2247),
    [anon_sym___grid_constant__] = ACTIONS(2247),
    [anon_sym_alignas] = ACTIONS(2247),
    [anon_sym__Alignas] = ACTIONS(2247),
    [sym_primitive_type] = ACTIONS(2247),
    [anon_sym_enum] = ACTIONS(2247),
    [anon_sym_class] = ACTIONS(2247),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_union] = ACTIONS(2247),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_switch] = ACTIONS(2247),
    [anon_sym_case] = ACTIONS(2247),
    [anon_sym_default] = ACTIONS(2247),
    [anon_sym_while] = ACTIONS(2247),
    [anon_sym_do] = ACTIONS(2247),
    [anon_sym_for] = ACTIONS(2247),
    [anon_sym_return] = ACTIONS(2247),
    [anon_sym_break] = ACTIONS(2247),
    [anon_sym_continue] = ACTIONS(2247),
    [anon_sym_goto] = ACTIONS(2247),
    [anon_sym_not] = ACTIONS(2247),
    [anon_sym_compl] = ACTIONS(2247),
    [anon_sym_DASH_DASH] = ACTIONS(2249),
    [anon_sym_PLUS_PLUS] = ACTIONS(2249),
    [anon_sym_sizeof] = ACTIONS(2247),
    [anon_sym___alignof__] = ACTIONS(2247),
    [anon_sym___alignof] = ACTIONS(2247),
    [anon_sym__alignof] = ACTIONS(2247),
    [anon_sym_alignof] = ACTIONS(2247),
    [anon_sym__Alignof] = ACTIONS(2247),
    [anon_sym_offsetof] = ACTIONS(2247),
    [anon_sym__Generic] = ACTIONS(2247),
    [anon_sym_asm] = ACTIONS(2247),
    [anon_sym___asm__] = ACTIONS(2247),
    [sym_number_literal] = ACTIONS(2249),
    [anon_sym_L_SQUOTE] = ACTIONS(2249),
    [anon_sym_u_SQUOTE] = ACTIONS(2249),
    [anon_sym_U_SQUOTE] = ACTIONS(2249),
    [anon_sym_u8_SQUOTE] = ACTIONS(2249),
    [anon_sym_SQUOTE] = ACTIONS(2249),
    [anon_sym_L_DQUOTE] = ACTIONS(2249),
    [anon_sym_u_DQUOTE] = ACTIONS(2249),
    [anon_sym_U_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8_DQUOTE] = ACTIONS(2249),
    [anon_sym_DQUOTE] = ACTIONS(2249),
    [sym_true] = ACTIONS(2247),
    [sym_false] = ACTIONS(2247),
    [anon_sym_NULL] = ACTIONS(2247),
    [anon_sym_nullptr] = ACTIONS(2247),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2247),
    [anon_sym_decltype] = ACTIONS(2247),
    [sym_virtual] = ACTIONS(2247),
    [anon_sym_explicit] = ACTIONS(2247),
    [anon_sym_typename] = ACTIONS(2247),
    [anon_sym_template] = ACTIONS(2247),
    [anon_sym_operator] = ACTIONS(2247),
    [anon_sym_try] = ACTIONS(2247),
    [anon_sym_delete] = ACTIONS(2247),
    [anon_sym_throw] = ACTIONS(2247),
    [anon_sym_namespace] = ACTIONS(2247),
    [anon_sym_using] = ACTIONS(2247),
    [anon_sym_static_assert] = ACTIONS(2247),
    [anon_sym_concept] = ACTIONS(2247),
    [anon_sym_co_return] = ACTIONS(2247),
    [anon_sym_co_yield] = ACTIONS(2247),
    [anon_sym_R_DQUOTE] = ACTIONS(2249),
    [anon_sym_LR_DQUOTE] = ACTIONS(2249),
    [anon_sym_uR_DQUOTE] = ACTIONS(2249),
    [anon_sym_UR_DQUOTE] = ACTIONS(2249),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2249),
    [anon_sym_co_await] = ACTIONS(2247),
    [anon_sym_new] = ACTIONS(2247),
    [anon_sym_requires] = ACTIONS(2247),
    [sym_this] = ACTIONS(2247),
    [anon_sym___launch_bounds__] = ACTIONS(2247),
  },
  [733] = {
    [ts_builtin_sym_end] = ACTIONS(2332),
    [sym_identifier] = ACTIONS(2330),
    [aux_sym_preproc_include_token1] = ACTIONS(2330),
    [aux_sym_preproc_def_token1] = ACTIONS(2330),
    [aux_sym_preproc_if_token1] = ACTIONS(2330),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2330),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2330),
    [sym_preproc_directive] = ACTIONS(2330),
    [anon_sym_LPAREN2] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2332),
    [anon_sym_TILDE] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(2330),
    [anon_sym_STAR] = ACTIONS(2332),
    [anon_sym_AMP_AMP] = ACTIONS(2332),
    [anon_sym_AMP] = ACTIONS(2330),
    [anon_sym___extension__] = ACTIONS(2330),
    [anon_sym_typedef] = ACTIONS(2330),
    [anon_sym___device__] = ACTIONS(2330),
    [anon_sym___host__] = ACTIONS(2330),
    [anon_sym___global__] = ACTIONS(2330),
    [anon_sym___forceinline__] = ACTIONS(2330),
    [anon_sym___noinline__] = ACTIONS(2330),
    [anon_sym_extern] = ACTIONS(2330),
    [anon_sym___attribute__] = ACTIONS(2330),
    [anon_sym_COLON_COLON] = ACTIONS(2332),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2332),
    [anon_sym___declspec] = ACTIONS(2330),
    [anon_sym___based] = ACTIONS(2330),
    [anon_sym___cdecl] = ACTIONS(2330),
    [anon_sym___clrcall] = ACTIONS(2330),
    [anon_sym___stdcall] = ACTIONS(2330),
    [anon_sym___fastcall] = ACTIONS(2330),
    [anon_sym___thiscall] = ACTIONS(2330),
    [anon_sym___vectorcall] = ACTIONS(2330),
    [anon_sym_LBRACE] = ACTIONS(2332),
    [anon_sym_signed] = ACTIONS(2330),
    [anon_sym_unsigned] = ACTIONS(2330),
    [anon_sym_long] = ACTIONS(2330),
    [anon_sym_short] = ACTIONS(2330),
    [anon_sym_LBRACK] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2330),
    [anon_sym_register] = ACTIONS(2330),
    [anon_sym_inline] = ACTIONS(2330),
    [anon_sym___inline] = ACTIONS(2330),
    [anon_sym___inline__] = ACTIONS(2330),
    [anon_sym___forceinline] = ACTIONS(2330),
    [anon_sym_thread_local] = ACTIONS(2330),
    [anon_sym___thread] = ACTIONS(2330),
    [anon_sym_const] = ACTIONS(2330),
    [anon_sym_constexpr] = ACTIONS(2330),
    [anon_sym_volatile] = ACTIONS(2330),
    [anon_sym_restrict] = ACTIONS(2330),
    [anon_sym___restrict__] = ACTIONS(2330),
    [anon_sym__Atomic] = ACTIONS(2330),
    [anon_sym__Noreturn] = ACTIONS(2330),
    [anon_sym_noreturn] = ACTIONS(2330),
    [anon_sym_mutable] = ACTIONS(2330),
    [anon_sym_constinit] = ACTIONS(2330),
    [anon_sym_consteval] = ACTIONS(2330),
    [anon_sym___shared__] = ACTIONS(2330),
    [anon_sym___local__] = ACTIONS(2330),
    [anon_sym___constant__] = ACTIONS(2330),
    [anon_sym___managed__] = ACTIONS(2330),
    [anon_sym___grid_constant__] = ACTIONS(2330),
    [anon_sym_alignas] = ACTIONS(2330),
    [anon_sym__Alignas] = ACTIONS(2330),
    [sym_primitive_type] = ACTIONS(2330),
    [anon_sym_enum] = ACTIONS(2330),
    [anon_sym_class] = ACTIONS(2330),
    [anon_sym_struct] = ACTIONS(2330),
    [anon_sym_union] = ACTIONS(2330),
    [anon_sym_if] = ACTIONS(2330),
    [anon_sym_switch] = ACTIONS(2330),
    [anon_sym_case] = ACTIONS(2330),
    [anon_sym_default] = ACTIONS(2330),
    [anon_sym_while] = ACTIONS(2330),
    [anon_sym_do] = ACTIONS(2330),
    [anon_sym_for] = ACTIONS(2330),
    [anon_sym_return] = ACTIONS(2330),
    [anon_sym_break] = ACTIONS(2330),
    [anon_sym_continue] = ACTIONS(2330),
    [anon_sym_goto] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2330),
    [anon_sym_compl] = ACTIONS(2330),
    [anon_sym_DASH_DASH] = ACTIONS(2332),
    [anon_sym_PLUS_PLUS] = ACTIONS(2332),
    [anon_sym_sizeof] = ACTIONS(2330),
    [anon_sym___alignof__] = ACTIONS(2330),
    [anon_sym___alignof] = ACTIONS(2330),
    [anon_sym__alignof] = ACTIONS(2330),
    [anon_sym_alignof] = ACTIONS(2330),
    [anon_sym__Alignof] = ACTIONS(2330),
    [anon_sym_offsetof] = ACTIONS(2330),
    [anon_sym__Generic] = ACTIONS(2330),
    [anon_sym_asm] = ACTIONS(2330),
    [anon_sym___asm__] = ACTIONS(2330),
    [sym_number_literal] = ACTIONS(2332),
    [anon_sym_L_SQUOTE] = ACTIONS(2332),
    [anon_sym_u_SQUOTE] = ACTIONS(2332),
    [anon_sym_U_SQUOTE] = ACTIONS(2332),
    [anon_sym_u8_SQUOTE] = ACTIONS(2332),
    [anon_sym_SQUOTE] = ACTIONS(2332),
    [anon_sym_L_DQUOTE] = ACTIONS(2332),
    [anon_sym_u_DQUOTE] = ACTIONS(2332),
    [anon_sym_U_DQUOTE] = ACTIONS(2332),
    [anon_sym_u8_DQUOTE] = ACTIONS(2332),
    [anon_sym_DQUOTE] = ACTIONS(2332),
    [sym_true] = ACTIONS(2330),
    [sym_false] = ACTIONS(2330),
    [anon_sym_NULL] = ACTIONS(2330),
    [anon_sym_nullptr] = ACTIONS(2330),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2330),
    [anon_sym_decltype] = ACTIONS(2330),
    [sym_virtual] = ACTIONS(2330),
    [anon_sym_explicit] = ACTIONS(2330),
    [anon_sym_typename] = ACTIONS(2330),
    [anon_sym_template] = ACTIONS(2330),
    [anon_sym_operator] = ACTIONS(2330),
    [anon_sym_try] = ACTIONS(2330),
    [anon_sym_delete] = ACTIONS(2330),
    [anon_sym_throw] = ACTIONS(2330),
    [anon_sym_namespace] = ACTIONS(2330),
    [anon_sym_using] = ACTIONS(2330),
    [anon_sym_static_assert] = ACTIONS(2330),
    [anon_sym_concept] = ACTIONS(2330),
    [anon_sym_co_return] = ACTIONS(2330),
    [anon_sym_co_yield] = ACTIONS(2330),
    [anon_sym_R_DQUOTE] = ACTIONS(2332),
    [anon_sym_LR_DQUOTE] = ACTIONS(2332),
    [anon_sym_uR_DQUOTE] = ACTIONS(2332),
    [anon_sym_UR_DQUOTE] = ACTIONS(2332),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2332),
    [anon_sym_co_await] = ACTIONS(2330),
    [anon_sym_new] = ACTIONS(2330),
    [anon_sym_requires] = ACTIONS(2330),
    [sym_this] = ACTIONS(2330),
    [anon_sym___launch_bounds__] = ACTIONS(2330),
  },
  [734] = {
    [sym_preproc_def] = STATE(763),
    [sym_preproc_function_def] = STATE(763),
    [sym_preproc_call] = STATE(763),
    [sym_preproc_if_in_field_declaration_list] = STATE(763),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(763),
    [sym_type_definition] = STATE(763),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5980),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6420),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(763),
    [sym_field_declaration] = STATE(763),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1703),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(763),
    [sym_operator_cast] = STATE(6989),
    [sym_inline_method_definition] = STATE(763),
    [sym__constructor_specifiers] = STATE(1703),
    [sym_operator_cast_definition] = STATE(763),
    [sym_operator_cast_declaration] = STATE(763),
    [sym_constructor_or_destructor_definition] = STATE(763),
    [sym_constructor_or_destructor_declaration] = STATE(763),
    [sym_friend_declaration] = STATE(763),
    [sym_access_specifier] = STATE(8657),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(763),
    [sym_alias_declaration] = STATE(763),
    [sym_static_assert_declaration] = STATE(763),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6989),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(763),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1703),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(3464),
    [aux_sym_preproc_if_token1] = ACTIONS(3466),
    [aux_sym_preproc_if_token2] = ACTIONS(3468),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3470),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3470),
    [sym_preproc_directive] = ACTIONS(3472),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(3474),
    [anon_sym_typedef] = ACTIONS(3476),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(3478),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3480),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(3482),
    [anon_sym_static_assert] = ACTIONS(3484),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [735] = {
    [ts_builtin_sym_end] = ACTIONS(2277),
    [sym_identifier] = ACTIONS(2275),
    [aux_sym_preproc_include_token1] = ACTIONS(2275),
    [aux_sym_preproc_def_token1] = ACTIONS(2275),
    [aux_sym_preproc_if_token1] = ACTIONS(2275),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2275),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2275),
    [sym_preproc_directive] = ACTIONS(2275),
    [anon_sym_LPAREN2] = ACTIONS(2277),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [anon_sym_DASH] = ACTIONS(2275),
    [anon_sym_PLUS] = ACTIONS(2275),
    [anon_sym_STAR] = ACTIONS(2277),
    [anon_sym_AMP_AMP] = ACTIONS(2277),
    [anon_sym_AMP] = ACTIONS(2275),
    [anon_sym___extension__] = ACTIONS(2275),
    [anon_sym_typedef] = ACTIONS(2275),
    [anon_sym___device__] = ACTIONS(2275),
    [anon_sym___host__] = ACTIONS(2275),
    [anon_sym___global__] = ACTIONS(2275),
    [anon_sym___forceinline__] = ACTIONS(2275),
    [anon_sym___noinline__] = ACTIONS(2275),
    [anon_sym_extern] = ACTIONS(2275),
    [anon_sym___attribute__] = ACTIONS(2275),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2277),
    [anon_sym___declspec] = ACTIONS(2275),
    [anon_sym___based] = ACTIONS(2275),
    [anon_sym___cdecl] = ACTIONS(2275),
    [anon_sym___clrcall] = ACTIONS(2275),
    [anon_sym___stdcall] = ACTIONS(2275),
    [anon_sym___fastcall] = ACTIONS(2275),
    [anon_sym___thiscall] = ACTIONS(2275),
    [anon_sym___vectorcall] = ACTIONS(2275),
    [anon_sym_LBRACE] = ACTIONS(2277),
    [anon_sym_signed] = ACTIONS(2275),
    [anon_sym_unsigned] = ACTIONS(2275),
    [anon_sym_long] = ACTIONS(2275),
    [anon_sym_short] = ACTIONS(2275),
    [anon_sym_LBRACK] = ACTIONS(2275),
    [anon_sym_static] = ACTIONS(2275),
    [anon_sym_register] = ACTIONS(2275),
    [anon_sym_inline] = ACTIONS(2275),
    [anon_sym___inline] = ACTIONS(2275),
    [anon_sym___inline__] = ACTIONS(2275),
    [anon_sym___forceinline] = ACTIONS(2275),
    [anon_sym_thread_local] = ACTIONS(2275),
    [anon_sym___thread] = ACTIONS(2275),
    [anon_sym_const] = ACTIONS(2275),
    [anon_sym_constexpr] = ACTIONS(2275),
    [anon_sym_volatile] = ACTIONS(2275),
    [anon_sym_restrict] = ACTIONS(2275),
    [anon_sym___restrict__] = ACTIONS(2275),
    [anon_sym__Atomic] = ACTIONS(2275),
    [anon_sym__Noreturn] = ACTIONS(2275),
    [anon_sym_noreturn] = ACTIONS(2275),
    [anon_sym_mutable] = ACTIONS(2275),
    [anon_sym_constinit] = ACTIONS(2275),
    [anon_sym_consteval] = ACTIONS(2275),
    [anon_sym___shared__] = ACTIONS(2275),
    [anon_sym___local__] = ACTIONS(2275),
    [anon_sym___constant__] = ACTIONS(2275),
    [anon_sym___managed__] = ACTIONS(2275),
    [anon_sym___grid_constant__] = ACTIONS(2275),
    [anon_sym_alignas] = ACTIONS(2275),
    [anon_sym__Alignas] = ACTIONS(2275),
    [sym_primitive_type] = ACTIONS(2275),
    [anon_sym_enum] = ACTIONS(2275),
    [anon_sym_class] = ACTIONS(2275),
    [anon_sym_struct] = ACTIONS(2275),
    [anon_sym_union] = ACTIONS(2275),
    [anon_sym_if] = ACTIONS(2275),
    [anon_sym_switch] = ACTIONS(2275),
    [anon_sym_case] = ACTIONS(2275),
    [anon_sym_default] = ACTIONS(2275),
    [anon_sym_while] = ACTIONS(2275),
    [anon_sym_do] = ACTIONS(2275),
    [anon_sym_for] = ACTIONS(2275),
    [anon_sym_return] = ACTIONS(2275),
    [anon_sym_break] = ACTIONS(2275),
    [anon_sym_continue] = ACTIONS(2275),
    [anon_sym_goto] = ACTIONS(2275),
    [anon_sym_not] = ACTIONS(2275),
    [anon_sym_compl] = ACTIONS(2275),
    [anon_sym_DASH_DASH] = ACTIONS(2277),
    [anon_sym_PLUS_PLUS] = ACTIONS(2277),
    [anon_sym_sizeof] = ACTIONS(2275),
    [anon_sym___alignof__] = ACTIONS(2275),
    [anon_sym___alignof] = ACTIONS(2275),
    [anon_sym__alignof] = ACTIONS(2275),
    [anon_sym_alignof] = ACTIONS(2275),
    [anon_sym__Alignof] = ACTIONS(2275),
    [anon_sym_offsetof] = ACTIONS(2275),
    [anon_sym__Generic] = ACTIONS(2275),
    [anon_sym_asm] = ACTIONS(2275),
    [anon_sym___asm__] = ACTIONS(2275),
    [sym_number_literal] = ACTIONS(2277),
    [anon_sym_L_SQUOTE] = ACTIONS(2277),
    [anon_sym_u_SQUOTE] = ACTIONS(2277),
    [anon_sym_U_SQUOTE] = ACTIONS(2277),
    [anon_sym_u8_SQUOTE] = ACTIONS(2277),
    [anon_sym_SQUOTE] = ACTIONS(2277),
    [anon_sym_L_DQUOTE] = ACTIONS(2277),
    [anon_sym_u_DQUOTE] = ACTIONS(2277),
    [anon_sym_U_DQUOTE] = ACTIONS(2277),
    [anon_sym_u8_DQUOTE] = ACTIONS(2277),
    [anon_sym_DQUOTE] = ACTIONS(2277),
    [sym_true] = ACTIONS(2275),
    [sym_false] = ACTIONS(2275),
    [anon_sym_NULL] = ACTIONS(2275),
    [anon_sym_nullptr] = ACTIONS(2275),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2275),
    [anon_sym_decltype] = ACTIONS(2275),
    [sym_virtual] = ACTIONS(2275),
    [anon_sym_explicit] = ACTIONS(2275),
    [anon_sym_typename] = ACTIONS(2275),
    [anon_sym_template] = ACTIONS(2275),
    [anon_sym_operator] = ACTIONS(2275),
    [anon_sym_try] = ACTIONS(2275),
    [anon_sym_delete] = ACTIONS(2275),
    [anon_sym_throw] = ACTIONS(2275),
    [anon_sym_namespace] = ACTIONS(2275),
    [anon_sym_using] = ACTIONS(2275),
    [anon_sym_static_assert] = ACTIONS(2275),
    [anon_sym_concept] = ACTIONS(2275),
    [anon_sym_co_return] = ACTIONS(2275),
    [anon_sym_co_yield] = ACTIONS(2275),
    [anon_sym_R_DQUOTE] = ACTIONS(2277),
    [anon_sym_LR_DQUOTE] = ACTIONS(2277),
    [anon_sym_uR_DQUOTE] = ACTIONS(2277),
    [anon_sym_UR_DQUOTE] = ACTIONS(2277),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2277),
    [anon_sym_co_await] = ACTIONS(2275),
    [anon_sym_new] = ACTIONS(2275),
    [anon_sym_requires] = ACTIONS(2275),
    [sym_this] = ACTIONS(2275),
    [anon_sym___launch_bounds__] = ACTIONS(2275),
  },
  [736] = {
    [ts_builtin_sym_end] = ACTIONS(2328),
    [sym_identifier] = ACTIONS(2326),
    [aux_sym_preproc_include_token1] = ACTIONS(2326),
    [aux_sym_preproc_def_token1] = ACTIONS(2326),
    [aux_sym_preproc_if_token1] = ACTIONS(2326),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2326),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2326),
    [sym_preproc_directive] = ACTIONS(2326),
    [anon_sym_LPAREN2] = ACTIONS(2328),
    [anon_sym_BANG] = ACTIONS(2328),
    [anon_sym_TILDE] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_STAR] = ACTIONS(2328),
    [anon_sym_AMP_AMP] = ACTIONS(2328),
    [anon_sym_AMP] = ACTIONS(2326),
    [anon_sym___extension__] = ACTIONS(2326),
    [anon_sym_typedef] = ACTIONS(2326),
    [anon_sym___device__] = ACTIONS(2326),
    [anon_sym___host__] = ACTIONS(2326),
    [anon_sym___global__] = ACTIONS(2326),
    [anon_sym___forceinline__] = ACTIONS(2326),
    [anon_sym___noinline__] = ACTIONS(2326),
    [anon_sym_extern] = ACTIONS(2326),
    [anon_sym___attribute__] = ACTIONS(2326),
    [anon_sym_COLON_COLON] = ACTIONS(2328),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2328),
    [anon_sym___declspec] = ACTIONS(2326),
    [anon_sym___based] = ACTIONS(2326),
    [anon_sym___cdecl] = ACTIONS(2326),
    [anon_sym___clrcall] = ACTIONS(2326),
    [anon_sym___stdcall] = ACTIONS(2326),
    [anon_sym___fastcall] = ACTIONS(2326),
    [anon_sym___thiscall] = ACTIONS(2326),
    [anon_sym___vectorcall] = ACTIONS(2326),
    [anon_sym_LBRACE] = ACTIONS(2328),
    [anon_sym_signed] = ACTIONS(2326),
    [anon_sym_unsigned] = ACTIONS(2326),
    [anon_sym_long] = ACTIONS(2326),
    [anon_sym_short] = ACTIONS(2326),
    [anon_sym_LBRACK] = ACTIONS(2326),
    [anon_sym_static] = ACTIONS(2326),
    [anon_sym_register] = ACTIONS(2326),
    [anon_sym_inline] = ACTIONS(2326),
    [anon_sym___inline] = ACTIONS(2326),
    [anon_sym___inline__] = ACTIONS(2326),
    [anon_sym___forceinline] = ACTIONS(2326),
    [anon_sym_thread_local] = ACTIONS(2326),
    [anon_sym___thread] = ACTIONS(2326),
    [anon_sym_const] = ACTIONS(2326),
    [anon_sym_constexpr] = ACTIONS(2326),
    [anon_sym_volatile] = ACTIONS(2326),
    [anon_sym_restrict] = ACTIONS(2326),
    [anon_sym___restrict__] = ACTIONS(2326),
    [anon_sym__Atomic] = ACTIONS(2326),
    [anon_sym__Noreturn] = ACTIONS(2326),
    [anon_sym_noreturn] = ACTIONS(2326),
    [anon_sym_mutable] = ACTIONS(2326),
    [anon_sym_constinit] = ACTIONS(2326),
    [anon_sym_consteval] = ACTIONS(2326),
    [anon_sym___shared__] = ACTIONS(2326),
    [anon_sym___local__] = ACTIONS(2326),
    [anon_sym___constant__] = ACTIONS(2326),
    [anon_sym___managed__] = ACTIONS(2326),
    [anon_sym___grid_constant__] = ACTIONS(2326),
    [anon_sym_alignas] = ACTIONS(2326),
    [anon_sym__Alignas] = ACTIONS(2326),
    [sym_primitive_type] = ACTIONS(2326),
    [anon_sym_enum] = ACTIONS(2326),
    [anon_sym_class] = ACTIONS(2326),
    [anon_sym_struct] = ACTIONS(2326),
    [anon_sym_union] = ACTIONS(2326),
    [anon_sym_if] = ACTIONS(2326),
    [anon_sym_switch] = ACTIONS(2326),
    [anon_sym_case] = ACTIONS(2326),
    [anon_sym_default] = ACTIONS(2326),
    [anon_sym_while] = ACTIONS(2326),
    [anon_sym_do] = ACTIONS(2326),
    [anon_sym_for] = ACTIONS(2326),
    [anon_sym_return] = ACTIONS(2326),
    [anon_sym_break] = ACTIONS(2326),
    [anon_sym_continue] = ACTIONS(2326),
    [anon_sym_goto] = ACTIONS(2326),
    [anon_sym_not] = ACTIONS(2326),
    [anon_sym_compl] = ACTIONS(2326),
    [anon_sym_DASH_DASH] = ACTIONS(2328),
    [anon_sym_PLUS_PLUS] = ACTIONS(2328),
    [anon_sym_sizeof] = ACTIONS(2326),
    [anon_sym___alignof__] = ACTIONS(2326),
    [anon_sym___alignof] = ACTIONS(2326),
    [anon_sym__alignof] = ACTIONS(2326),
    [anon_sym_alignof] = ACTIONS(2326),
    [anon_sym__Alignof] = ACTIONS(2326),
    [anon_sym_offsetof] = ACTIONS(2326),
    [anon_sym__Generic] = ACTIONS(2326),
    [anon_sym_asm] = ACTIONS(2326),
    [anon_sym___asm__] = ACTIONS(2326),
    [sym_number_literal] = ACTIONS(2328),
    [anon_sym_L_SQUOTE] = ACTIONS(2328),
    [anon_sym_u_SQUOTE] = ACTIONS(2328),
    [anon_sym_U_SQUOTE] = ACTIONS(2328),
    [anon_sym_u8_SQUOTE] = ACTIONS(2328),
    [anon_sym_SQUOTE] = ACTIONS(2328),
    [anon_sym_L_DQUOTE] = ACTIONS(2328),
    [anon_sym_u_DQUOTE] = ACTIONS(2328),
    [anon_sym_U_DQUOTE] = ACTIONS(2328),
    [anon_sym_u8_DQUOTE] = ACTIONS(2328),
    [anon_sym_DQUOTE] = ACTIONS(2328),
    [sym_true] = ACTIONS(2326),
    [sym_false] = ACTIONS(2326),
    [anon_sym_NULL] = ACTIONS(2326),
    [anon_sym_nullptr] = ACTIONS(2326),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2326),
    [anon_sym_decltype] = ACTIONS(2326),
    [sym_virtual] = ACTIONS(2326),
    [anon_sym_explicit] = ACTIONS(2326),
    [anon_sym_typename] = ACTIONS(2326),
    [anon_sym_template] = ACTIONS(2326),
    [anon_sym_operator] = ACTIONS(2326),
    [anon_sym_try] = ACTIONS(2326),
    [anon_sym_delete] = ACTIONS(2326),
    [anon_sym_throw] = ACTIONS(2326),
    [anon_sym_namespace] = ACTIONS(2326),
    [anon_sym_using] = ACTIONS(2326),
    [anon_sym_static_assert] = ACTIONS(2326),
    [anon_sym_concept] = ACTIONS(2326),
    [anon_sym_co_return] = ACTIONS(2326),
    [anon_sym_co_yield] = ACTIONS(2326),
    [anon_sym_R_DQUOTE] = ACTIONS(2328),
    [anon_sym_LR_DQUOTE] = ACTIONS(2328),
    [anon_sym_uR_DQUOTE] = ACTIONS(2328),
    [anon_sym_UR_DQUOTE] = ACTIONS(2328),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2328),
    [anon_sym_co_await] = ACTIONS(2326),
    [anon_sym_new] = ACTIONS(2326),
    [anon_sym_requires] = ACTIONS(2326),
    [sym_this] = ACTIONS(2326),
    [anon_sym___launch_bounds__] = ACTIONS(2326),
  },
  [737] = {
    [ts_builtin_sym_end] = ACTIONS(2298),
    [sym_identifier] = ACTIONS(2296),
    [aux_sym_preproc_include_token1] = ACTIONS(2296),
    [aux_sym_preproc_def_token1] = ACTIONS(2296),
    [aux_sym_preproc_if_token1] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2296),
    [sym_preproc_directive] = ACTIONS(2296),
    [anon_sym_LPAREN2] = ACTIONS(2298),
    [anon_sym_BANG] = ACTIONS(2298),
    [anon_sym_TILDE] = ACTIONS(2298),
    [anon_sym_DASH] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2296),
    [anon_sym_STAR] = ACTIONS(2298),
    [anon_sym_AMP_AMP] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym___extension__] = ACTIONS(2296),
    [anon_sym_typedef] = ACTIONS(2296),
    [anon_sym___device__] = ACTIONS(2296),
    [anon_sym___host__] = ACTIONS(2296),
    [anon_sym___global__] = ACTIONS(2296),
    [anon_sym___forceinline__] = ACTIONS(2296),
    [anon_sym___noinline__] = ACTIONS(2296),
    [anon_sym_extern] = ACTIONS(2296),
    [anon_sym___attribute__] = ACTIONS(2296),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2298),
    [anon_sym___declspec] = ACTIONS(2296),
    [anon_sym___based] = ACTIONS(2296),
    [anon_sym___cdecl] = ACTIONS(2296),
    [anon_sym___clrcall] = ACTIONS(2296),
    [anon_sym___stdcall] = ACTIONS(2296),
    [anon_sym___fastcall] = ACTIONS(2296),
    [anon_sym___thiscall] = ACTIONS(2296),
    [anon_sym___vectorcall] = ACTIONS(2296),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_signed] = ACTIONS(2296),
    [anon_sym_unsigned] = ACTIONS(2296),
    [anon_sym_long] = ACTIONS(2296),
    [anon_sym_short] = ACTIONS(2296),
    [anon_sym_LBRACK] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_register] = ACTIONS(2296),
    [anon_sym_inline] = ACTIONS(2296),
    [anon_sym___inline] = ACTIONS(2296),
    [anon_sym___inline__] = ACTIONS(2296),
    [anon_sym___forceinline] = ACTIONS(2296),
    [anon_sym_thread_local] = ACTIONS(2296),
    [anon_sym___thread] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_constexpr] = ACTIONS(2296),
    [anon_sym_volatile] = ACTIONS(2296),
    [anon_sym_restrict] = ACTIONS(2296),
    [anon_sym___restrict__] = ACTIONS(2296),
    [anon_sym__Atomic] = ACTIONS(2296),
    [anon_sym__Noreturn] = ACTIONS(2296),
    [anon_sym_noreturn] = ACTIONS(2296),
    [anon_sym_mutable] = ACTIONS(2296),
    [anon_sym_constinit] = ACTIONS(2296),
    [anon_sym_consteval] = ACTIONS(2296),
    [anon_sym___shared__] = ACTIONS(2296),
    [anon_sym___local__] = ACTIONS(2296),
    [anon_sym___constant__] = ACTIONS(2296),
    [anon_sym___managed__] = ACTIONS(2296),
    [anon_sym___grid_constant__] = ACTIONS(2296),
    [anon_sym_alignas] = ACTIONS(2296),
    [anon_sym__Alignas] = ACTIONS(2296),
    [sym_primitive_type] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2296),
    [anon_sym_class] = ACTIONS(2296),
    [anon_sym_struct] = ACTIONS(2296),
    [anon_sym_union] = ACTIONS(2296),
    [anon_sym_if] = ACTIONS(2296),
    [anon_sym_switch] = ACTIONS(2296),
    [anon_sym_case] = ACTIONS(2296),
    [anon_sym_default] = ACTIONS(2296),
    [anon_sym_while] = ACTIONS(2296),
    [anon_sym_do] = ACTIONS(2296),
    [anon_sym_for] = ACTIONS(2296),
    [anon_sym_return] = ACTIONS(2296),
    [anon_sym_break] = ACTIONS(2296),
    [anon_sym_continue] = ACTIONS(2296),
    [anon_sym_goto] = ACTIONS(2296),
    [anon_sym_not] = ACTIONS(2296),
    [anon_sym_compl] = ACTIONS(2296),
    [anon_sym_DASH_DASH] = ACTIONS(2298),
    [anon_sym_PLUS_PLUS] = ACTIONS(2298),
    [anon_sym_sizeof] = ACTIONS(2296),
    [anon_sym___alignof__] = ACTIONS(2296),
    [anon_sym___alignof] = ACTIONS(2296),
    [anon_sym__alignof] = ACTIONS(2296),
    [anon_sym_alignof] = ACTIONS(2296),
    [anon_sym__Alignof] = ACTIONS(2296),
    [anon_sym_offsetof] = ACTIONS(2296),
    [anon_sym__Generic] = ACTIONS(2296),
    [anon_sym_asm] = ACTIONS(2296),
    [anon_sym___asm__] = ACTIONS(2296),
    [sym_number_literal] = ACTIONS(2298),
    [anon_sym_L_SQUOTE] = ACTIONS(2298),
    [anon_sym_u_SQUOTE] = ACTIONS(2298),
    [anon_sym_U_SQUOTE] = ACTIONS(2298),
    [anon_sym_u8_SQUOTE] = ACTIONS(2298),
    [anon_sym_SQUOTE] = ACTIONS(2298),
    [anon_sym_L_DQUOTE] = ACTIONS(2298),
    [anon_sym_u_DQUOTE] = ACTIONS(2298),
    [anon_sym_U_DQUOTE] = ACTIONS(2298),
    [anon_sym_u8_DQUOTE] = ACTIONS(2298),
    [anon_sym_DQUOTE] = ACTIONS(2298),
    [sym_true] = ACTIONS(2296),
    [sym_false] = ACTIONS(2296),
    [anon_sym_NULL] = ACTIONS(2296),
    [anon_sym_nullptr] = ACTIONS(2296),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2296),
    [anon_sym_decltype] = ACTIONS(2296),
    [sym_virtual] = ACTIONS(2296),
    [anon_sym_explicit] = ACTIONS(2296),
    [anon_sym_typename] = ACTIONS(2296),
    [anon_sym_template] = ACTIONS(2296),
    [anon_sym_operator] = ACTIONS(2296),
    [anon_sym_try] = ACTIONS(2296),
    [anon_sym_delete] = ACTIONS(2296),
    [anon_sym_throw] = ACTIONS(2296),
    [anon_sym_namespace] = ACTIONS(2296),
    [anon_sym_using] = ACTIONS(2296),
    [anon_sym_static_assert] = ACTIONS(2296),
    [anon_sym_concept] = ACTIONS(2296),
    [anon_sym_co_return] = ACTIONS(2296),
    [anon_sym_co_yield] = ACTIONS(2296),
    [anon_sym_R_DQUOTE] = ACTIONS(2298),
    [anon_sym_LR_DQUOTE] = ACTIONS(2298),
    [anon_sym_uR_DQUOTE] = ACTIONS(2298),
    [anon_sym_UR_DQUOTE] = ACTIONS(2298),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2298),
    [anon_sym_co_await] = ACTIONS(2296),
    [anon_sym_new] = ACTIONS(2296),
    [anon_sym_requires] = ACTIONS(2296),
    [sym_this] = ACTIONS(2296),
    [anon_sym___launch_bounds__] = ACTIONS(2296),
  },
  [738] = {
    [ts_builtin_sym_end] = ACTIONS(2411),
    [sym_identifier] = ACTIONS(2409),
    [aux_sym_preproc_include_token1] = ACTIONS(2409),
    [aux_sym_preproc_def_token1] = ACTIONS(2409),
    [aux_sym_preproc_if_token1] = ACTIONS(2409),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2409),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2409),
    [sym_preproc_directive] = ACTIONS(2409),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_BANG] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2409),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2409),
    [anon_sym___extension__] = ACTIONS(2409),
    [anon_sym_typedef] = ACTIONS(2409),
    [anon_sym___device__] = ACTIONS(2409),
    [anon_sym___host__] = ACTIONS(2409),
    [anon_sym___global__] = ACTIONS(2409),
    [anon_sym___forceinline__] = ACTIONS(2409),
    [anon_sym___noinline__] = ACTIONS(2409),
    [anon_sym_extern] = ACTIONS(2409),
    [anon_sym___attribute__] = ACTIONS(2409),
    [anon_sym_COLON_COLON] = ACTIONS(2411),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2411),
    [anon_sym___declspec] = ACTIONS(2409),
    [anon_sym___based] = ACTIONS(2409),
    [anon_sym___cdecl] = ACTIONS(2409),
    [anon_sym___clrcall] = ACTIONS(2409),
    [anon_sym___stdcall] = ACTIONS(2409),
    [anon_sym___fastcall] = ACTIONS(2409),
    [anon_sym___thiscall] = ACTIONS(2409),
    [anon_sym___vectorcall] = ACTIONS(2409),
    [anon_sym_LBRACE] = ACTIONS(2411),
    [anon_sym_signed] = ACTIONS(2409),
    [anon_sym_unsigned] = ACTIONS(2409),
    [anon_sym_long] = ACTIONS(2409),
    [anon_sym_short] = ACTIONS(2409),
    [anon_sym_LBRACK] = ACTIONS(2409),
    [anon_sym_static] = ACTIONS(2409),
    [anon_sym_register] = ACTIONS(2409),
    [anon_sym_inline] = ACTIONS(2409),
    [anon_sym___inline] = ACTIONS(2409),
    [anon_sym___inline__] = ACTIONS(2409),
    [anon_sym___forceinline] = ACTIONS(2409),
    [anon_sym_thread_local] = ACTIONS(2409),
    [anon_sym___thread] = ACTIONS(2409),
    [anon_sym_const] = ACTIONS(2409),
    [anon_sym_constexpr] = ACTIONS(2409),
    [anon_sym_volatile] = ACTIONS(2409),
    [anon_sym_restrict] = ACTIONS(2409),
    [anon_sym___restrict__] = ACTIONS(2409),
    [anon_sym__Atomic] = ACTIONS(2409),
    [anon_sym__Noreturn] = ACTIONS(2409),
    [anon_sym_noreturn] = ACTIONS(2409),
    [anon_sym_mutable] = ACTIONS(2409),
    [anon_sym_constinit] = ACTIONS(2409),
    [anon_sym_consteval] = ACTIONS(2409),
    [anon_sym___shared__] = ACTIONS(2409),
    [anon_sym___local__] = ACTIONS(2409),
    [anon_sym___constant__] = ACTIONS(2409),
    [anon_sym___managed__] = ACTIONS(2409),
    [anon_sym___grid_constant__] = ACTIONS(2409),
    [anon_sym_alignas] = ACTIONS(2409),
    [anon_sym__Alignas] = ACTIONS(2409),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2409),
    [anon_sym_class] = ACTIONS(2409),
    [anon_sym_struct] = ACTIONS(2409),
    [anon_sym_union] = ACTIONS(2409),
    [anon_sym_if] = ACTIONS(2409),
    [anon_sym_switch] = ACTIONS(2409),
    [anon_sym_case] = ACTIONS(2409),
    [anon_sym_default] = ACTIONS(2409),
    [anon_sym_while] = ACTIONS(2409),
    [anon_sym_do] = ACTIONS(2409),
    [anon_sym_for] = ACTIONS(2409),
    [anon_sym_return] = ACTIONS(2409),
    [anon_sym_break] = ACTIONS(2409),
    [anon_sym_continue] = ACTIONS(2409),
    [anon_sym_goto] = ACTIONS(2409),
    [anon_sym_not] = ACTIONS(2409),
    [anon_sym_compl] = ACTIONS(2409),
    [anon_sym_DASH_DASH] = ACTIONS(2411),
    [anon_sym_PLUS_PLUS] = ACTIONS(2411),
    [anon_sym_sizeof] = ACTIONS(2409),
    [anon_sym___alignof__] = ACTIONS(2409),
    [anon_sym___alignof] = ACTIONS(2409),
    [anon_sym__alignof] = ACTIONS(2409),
    [anon_sym_alignof] = ACTIONS(2409),
    [anon_sym__Alignof] = ACTIONS(2409),
    [anon_sym_offsetof] = ACTIONS(2409),
    [anon_sym__Generic] = ACTIONS(2409),
    [anon_sym_asm] = ACTIONS(2409),
    [anon_sym___asm__] = ACTIONS(2409),
    [sym_number_literal] = ACTIONS(2411),
    [anon_sym_L_SQUOTE] = ACTIONS(2411),
    [anon_sym_u_SQUOTE] = ACTIONS(2411),
    [anon_sym_U_SQUOTE] = ACTIONS(2411),
    [anon_sym_u8_SQUOTE] = ACTIONS(2411),
    [anon_sym_SQUOTE] = ACTIONS(2411),
    [anon_sym_L_DQUOTE] = ACTIONS(2411),
    [anon_sym_u_DQUOTE] = ACTIONS(2411),
    [anon_sym_U_DQUOTE] = ACTIONS(2411),
    [anon_sym_u8_DQUOTE] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [sym_true] = ACTIONS(2409),
    [sym_false] = ACTIONS(2409),
    [anon_sym_NULL] = ACTIONS(2409),
    [anon_sym_nullptr] = ACTIONS(2409),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2409),
    [anon_sym_decltype] = ACTIONS(2409),
    [sym_virtual] = ACTIONS(2409),
    [anon_sym_explicit] = ACTIONS(2409),
    [anon_sym_typename] = ACTIONS(2409),
    [anon_sym_template] = ACTIONS(2409),
    [anon_sym_operator] = ACTIONS(2409),
    [anon_sym_try] = ACTIONS(2409),
    [anon_sym_delete] = ACTIONS(2409),
    [anon_sym_throw] = ACTIONS(2409),
    [anon_sym_namespace] = ACTIONS(2409),
    [anon_sym_using] = ACTIONS(2409),
    [anon_sym_static_assert] = ACTIONS(2409),
    [anon_sym_concept] = ACTIONS(2409),
    [anon_sym_co_return] = ACTIONS(2409),
    [anon_sym_co_yield] = ACTIONS(2409),
    [anon_sym_R_DQUOTE] = ACTIONS(2411),
    [anon_sym_LR_DQUOTE] = ACTIONS(2411),
    [anon_sym_uR_DQUOTE] = ACTIONS(2411),
    [anon_sym_UR_DQUOTE] = ACTIONS(2411),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2411),
    [anon_sym_co_await] = ACTIONS(2409),
    [anon_sym_new] = ACTIONS(2409),
    [anon_sym_requires] = ACTIONS(2409),
    [sym_this] = ACTIONS(2409),
    [anon_sym___launch_bounds__] = ACTIONS(2409),
  },
  [739] = {
    [sym_preproc_def] = STATE(678),
    [sym_preproc_function_def] = STATE(678),
    [sym_preproc_call] = STATE(678),
    [sym_preproc_if_in_field_declaration_list] = STATE(678),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(678),
    [sym_type_definition] = STATE(678),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5894),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6463),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(678),
    [sym_field_declaration] = STATE(678),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1708),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(678),
    [sym_operator_cast] = STATE(6999),
    [sym_inline_method_definition] = STATE(678),
    [sym__constructor_specifiers] = STATE(1708),
    [sym_operator_cast_definition] = STATE(678),
    [sym_operator_cast_declaration] = STATE(678),
    [sym_constructor_or_destructor_definition] = STATE(678),
    [sym_constructor_or_destructor_declaration] = STATE(678),
    [sym_friend_declaration] = STATE(678),
    [sym_access_specifier] = STATE(8255),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(678),
    [sym_alias_declaration] = STATE(678),
    [sym_static_assert_declaration] = STATE(678),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6999),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(678),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1708),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3376),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3378),
    [sym_preproc_directive] = ACTIONS(3380),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(3382),
    [anon_sym_typedef] = ACTIONS(3384),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3486),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3390),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(3392),
    [anon_sym_static_assert] = ACTIONS(3394),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [740] = {
    [ts_builtin_sym_end] = ACTIONS(2294),
    [sym_identifier] = ACTIONS(2292),
    [aux_sym_preproc_include_token1] = ACTIONS(2292),
    [aux_sym_preproc_def_token1] = ACTIONS(2292),
    [aux_sym_preproc_if_token1] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2292),
    [sym_preproc_directive] = ACTIONS(2292),
    [anon_sym_LPAREN2] = ACTIONS(2294),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym___extension__] = ACTIONS(2292),
    [anon_sym_typedef] = ACTIONS(2292),
    [anon_sym___device__] = ACTIONS(2292),
    [anon_sym___host__] = ACTIONS(2292),
    [anon_sym___global__] = ACTIONS(2292),
    [anon_sym___forceinline__] = ACTIONS(2292),
    [anon_sym___noinline__] = ACTIONS(2292),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym___attribute__] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2294),
    [anon_sym___declspec] = ACTIONS(2292),
    [anon_sym___based] = ACTIONS(2292),
    [anon_sym___cdecl] = ACTIONS(2292),
    [anon_sym___clrcall] = ACTIONS(2292),
    [anon_sym___stdcall] = ACTIONS(2292),
    [anon_sym___fastcall] = ACTIONS(2292),
    [anon_sym___thiscall] = ACTIONS(2292),
    [anon_sym___vectorcall] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_signed] = ACTIONS(2292),
    [anon_sym_unsigned] = ACTIONS(2292),
    [anon_sym_long] = ACTIONS(2292),
    [anon_sym_short] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_register] = ACTIONS(2292),
    [anon_sym_inline] = ACTIONS(2292),
    [anon_sym___inline] = ACTIONS(2292),
    [anon_sym___inline__] = ACTIONS(2292),
    [anon_sym___forceinline] = ACTIONS(2292),
    [anon_sym_thread_local] = ACTIONS(2292),
    [anon_sym___thread] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym___restrict__] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym__Noreturn] = ACTIONS(2292),
    [anon_sym_noreturn] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_constinit] = ACTIONS(2292),
    [anon_sym_consteval] = ACTIONS(2292),
    [anon_sym___shared__] = ACTIONS(2292),
    [anon_sym___local__] = ACTIONS(2292),
    [anon_sym___constant__] = ACTIONS(2292),
    [anon_sym___managed__] = ACTIONS(2292),
    [anon_sym___grid_constant__] = ACTIONS(2292),
    [anon_sym_alignas] = ACTIONS(2292),
    [anon_sym__Alignas] = ACTIONS(2292),
    [sym_primitive_type] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_struct] = ACTIONS(2292),
    [anon_sym_union] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_case] = ACTIONS(2292),
    [anon_sym_default] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_goto] = ACTIONS(2292),
    [anon_sym_not] = ACTIONS(2292),
    [anon_sym_compl] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_sizeof] = ACTIONS(2292),
    [anon_sym___alignof__] = ACTIONS(2292),
    [anon_sym___alignof] = ACTIONS(2292),
    [anon_sym__alignof] = ACTIONS(2292),
    [anon_sym_alignof] = ACTIONS(2292),
    [anon_sym__Alignof] = ACTIONS(2292),
    [anon_sym_offsetof] = ACTIONS(2292),
    [anon_sym__Generic] = ACTIONS(2292),
    [anon_sym_asm] = ACTIONS(2292),
    [anon_sym___asm__] = ACTIONS(2292),
    [sym_number_literal] = ACTIONS(2294),
    [anon_sym_L_SQUOTE] = ACTIONS(2294),
    [anon_sym_u_SQUOTE] = ACTIONS(2294),
    [anon_sym_U_SQUOTE] = ACTIONS(2294),
    [anon_sym_u8_SQUOTE] = ACTIONS(2294),
    [anon_sym_SQUOTE] = ACTIONS(2294),
    [anon_sym_L_DQUOTE] = ACTIONS(2294),
    [anon_sym_u_DQUOTE] = ACTIONS(2294),
    [anon_sym_U_DQUOTE] = ACTIONS(2294),
    [anon_sym_u8_DQUOTE] = ACTIONS(2294),
    [anon_sym_DQUOTE] = ACTIONS(2294),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [anon_sym_NULL] = ACTIONS(2292),
    [anon_sym_nullptr] = ACTIONS(2292),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2292),
    [anon_sym_decltype] = ACTIONS(2292),
    [sym_virtual] = ACTIONS(2292),
    [anon_sym_explicit] = ACTIONS(2292),
    [anon_sym_typename] = ACTIONS(2292),
    [anon_sym_template] = ACTIONS(2292),
    [anon_sym_operator] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_delete] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_namespace] = ACTIONS(2292),
    [anon_sym_using] = ACTIONS(2292),
    [anon_sym_static_assert] = ACTIONS(2292),
    [anon_sym_concept] = ACTIONS(2292),
    [anon_sym_co_return] = ACTIONS(2292),
    [anon_sym_co_yield] = ACTIONS(2292),
    [anon_sym_R_DQUOTE] = ACTIONS(2294),
    [anon_sym_LR_DQUOTE] = ACTIONS(2294),
    [anon_sym_uR_DQUOTE] = ACTIONS(2294),
    [anon_sym_UR_DQUOTE] = ACTIONS(2294),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2294),
    [anon_sym_co_await] = ACTIONS(2292),
    [anon_sym_new] = ACTIONS(2292),
    [anon_sym_requires] = ACTIONS(2292),
    [sym_this] = ACTIONS(2292),
    [anon_sym___launch_bounds__] = ACTIONS(2292),
  },
  [741] = {
    [sym_preproc_def] = STATE(713),
    [sym_preproc_function_def] = STATE(713),
    [sym_preproc_call] = STATE(713),
    [sym_preproc_if_in_field_declaration_list] = STATE(713),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(713),
    [sym_type_definition] = STATE(713),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5894),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6463),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(713),
    [sym_field_declaration] = STATE(713),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1708),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(713),
    [sym_operator_cast] = STATE(6999),
    [sym_inline_method_definition] = STATE(713),
    [sym__constructor_specifiers] = STATE(1708),
    [sym_operator_cast_definition] = STATE(713),
    [sym_operator_cast_declaration] = STATE(713),
    [sym_constructor_or_destructor_definition] = STATE(713),
    [sym_constructor_or_destructor_declaration] = STATE(713),
    [sym_friend_declaration] = STATE(713),
    [sym_access_specifier] = STATE(8255),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(713),
    [sym_alias_declaration] = STATE(713),
    [sym_static_assert_declaration] = STATE(713),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6999),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(713),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1708),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3376),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3378),
    [sym_preproc_directive] = ACTIONS(3380),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(3382),
    [anon_sym_typedef] = ACTIONS(3384),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3488),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3390),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(3392),
    [anon_sym_static_assert] = ACTIONS(3394),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [742] = {
    [sym_preproc_def] = STATE(719),
    [sym_preproc_function_def] = STATE(719),
    [sym_preproc_call] = STATE(719),
    [sym_preproc_if_in_field_declaration_list] = STATE(719),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(719),
    [sym_type_definition] = STATE(719),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5894),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6463),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(719),
    [sym_field_declaration] = STATE(719),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1708),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(719),
    [sym_operator_cast] = STATE(6999),
    [sym_inline_method_definition] = STATE(719),
    [sym__constructor_specifiers] = STATE(1708),
    [sym_operator_cast_definition] = STATE(719),
    [sym_operator_cast_declaration] = STATE(719),
    [sym_constructor_or_destructor_definition] = STATE(719),
    [sym_constructor_or_destructor_declaration] = STATE(719),
    [sym_friend_declaration] = STATE(719),
    [sym_access_specifier] = STATE(8255),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(719),
    [sym_alias_declaration] = STATE(719),
    [sym_static_assert_declaration] = STATE(719),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6999),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(719),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1708),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3376),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3378),
    [sym_preproc_directive] = ACTIONS(3380),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(3382),
    [anon_sym_typedef] = ACTIONS(3384),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3490),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3390),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(3392),
    [anon_sym_static_assert] = ACTIONS(3394),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [743] = {
    [ts_builtin_sym_end] = ACTIONS(2290),
    [sym_identifier] = ACTIONS(2288),
    [aux_sym_preproc_include_token1] = ACTIONS(2288),
    [aux_sym_preproc_def_token1] = ACTIONS(2288),
    [aux_sym_preproc_if_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2288),
    [sym_preproc_directive] = ACTIONS(2288),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym_typedef] = ACTIONS(2288),
    [anon_sym___device__] = ACTIONS(2288),
    [anon_sym___host__] = ACTIONS(2288),
    [anon_sym___global__] = ACTIONS(2288),
    [anon_sym___forceinline__] = ACTIONS(2288),
    [anon_sym___noinline__] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2290),
    [anon_sym___declspec] = ACTIONS(2288),
    [anon_sym___based] = ACTIONS(2288),
    [anon_sym___cdecl] = ACTIONS(2288),
    [anon_sym___clrcall] = ACTIONS(2288),
    [anon_sym___stdcall] = ACTIONS(2288),
    [anon_sym___fastcall] = ACTIONS(2288),
    [anon_sym___thiscall] = ACTIONS(2288),
    [anon_sym___vectorcall] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_signed] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym___inline] = ACTIONS(2288),
    [anon_sym___inline__] = ACTIONS(2288),
    [anon_sym___forceinline] = ACTIONS(2288),
    [anon_sym_thread_local] = ACTIONS(2288),
    [anon_sym___thread] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym___shared__] = ACTIONS(2288),
    [anon_sym___local__] = ACTIONS(2288),
    [anon_sym___constant__] = ACTIONS(2288),
    [anon_sym___managed__] = ACTIONS(2288),
    [anon_sym___grid_constant__] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_goto] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2288),
    [anon_sym_compl] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_sizeof] = ACTIONS(2288),
    [anon_sym___alignof__] = ACTIONS(2288),
    [anon_sym___alignof] = ACTIONS(2288),
    [anon_sym__alignof] = ACTIONS(2288),
    [anon_sym_alignof] = ACTIONS(2288),
    [anon_sym__Alignof] = ACTIONS(2288),
    [anon_sym_offsetof] = ACTIONS(2288),
    [anon_sym__Generic] = ACTIONS(2288),
    [anon_sym_asm] = ACTIONS(2288),
    [anon_sym___asm__] = ACTIONS(2288),
    [sym_number_literal] = ACTIONS(2290),
    [anon_sym_L_SQUOTE] = ACTIONS(2290),
    [anon_sym_u_SQUOTE] = ACTIONS(2290),
    [anon_sym_U_SQUOTE] = ACTIONS(2290),
    [anon_sym_u8_SQUOTE] = ACTIONS(2290),
    [anon_sym_SQUOTE] = ACTIONS(2290),
    [anon_sym_L_DQUOTE] = ACTIONS(2290),
    [anon_sym_u_DQUOTE] = ACTIONS(2290),
    [anon_sym_U_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8_DQUOTE] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [anon_sym_NULL] = ACTIONS(2288),
    [anon_sym_nullptr] = ACTIONS(2288),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [sym_virtual] = ACTIONS(2288),
    [anon_sym_explicit] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_operator] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_static_assert] = ACTIONS(2288),
    [anon_sym_concept] = ACTIONS(2288),
    [anon_sym_co_return] = ACTIONS(2288),
    [anon_sym_co_yield] = ACTIONS(2288),
    [anon_sym_R_DQUOTE] = ACTIONS(2290),
    [anon_sym_LR_DQUOTE] = ACTIONS(2290),
    [anon_sym_uR_DQUOTE] = ACTIONS(2290),
    [anon_sym_UR_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2290),
    [anon_sym_co_await] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_requires] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [anon_sym___launch_bounds__] = ACTIONS(2288),
  },
  [744] = {
    [sym_preproc_def] = STATE(680),
    [sym_preproc_function_def] = STATE(680),
    [sym_preproc_call] = STATE(680),
    [sym_preproc_if_in_field_declaration_list] = STATE(680),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(680),
    [sym_type_definition] = STATE(680),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5894),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6463),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(680),
    [sym_field_declaration] = STATE(680),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1708),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(680),
    [sym_operator_cast] = STATE(6999),
    [sym_inline_method_definition] = STATE(680),
    [sym__constructor_specifiers] = STATE(1708),
    [sym_operator_cast_definition] = STATE(680),
    [sym_operator_cast_declaration] = STATE(680),
    [sym_constructor_or_destructor_definition] = STATE(680),
    [sym_constructor_or_destructor_declaration] = STATE(680),
    [sym_friend_declaration] = STATE(680),
    [sym_access_specifier] = STATE(8255),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(680),
    [sym_alias_declaration] = STATE(680),
    [sym_static_assert_declaration] = STATE(680),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6999),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(680),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1708),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3376),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3378),
    [sym_preproc_directive] = ACTIONS(3380),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(3382),
    [anon_sym_typedef] = ACTIONS(3384),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3492),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3390),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(3392),
    [anon_sym_static_assert] = ACTIONS(3394),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [745] = {
    [ts_builtin_sym_end] = ACTIONS(2082),
    [sym_identifier] = ACTIONS(2080),
    [aux_sym_preproc_include_token1] = ACTIONS(2080),
    [aux_sym_preproc_def_token1] = ACTIONS(2080),
    [aux_sym_preproc_if_token1] = ACTIONS(2080),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2080),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2080),
    [sym_preproc_directive] = ACTIONS(2080),
    [anon_sym_LPAREN2] = ACTIONS(2082),
    [anon_sym_BANG] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_DASH] = ACTIONS(2080),
    [anon_sym_PLUS] = ACTIONS(2080),
    [anon_sym_STAR] = ACTIONS(2082),
    [anon_sym_AMP_AMP] = ACTIONS(2082),
    [anon_sym_AMP] = ACTIONS(2080),
    [anon_sym___extension__] = ACTIONS(2080),
    [anon_sym_typedef] = ACTIONS(2080),
    [anon_sym___device__] = ACTIONS(2080),
    [anon_sym___host__] = ACTIONS(2080),
    [anon_sym___global__] = ACTIONS(2080),
    [anon_sym___forceinline__] = ACTIONS(2080),
    [anon_sym___noinline__] = ACTIONS(2080),
    [anon_sym_extern] = ACTIONS(2080),
    [anon_sym___attribute__] = ACTIONS(2080),
    [anon_sym_COLON_COLON] = ACTIONS(2082),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2082),
    [anon_sym___declspec] = ACTIONS(2080),
    [anon_sym___based] = ACTIONS(2080),
    [anon_sym___cdecl] = ACTIONS(2080),
    [anon_sym___clrcall] = ACTIONS(2080),
    [anon_sym___stdcall] = ACTIONS(2080),
    [anon_sym___fastcall] = ACTIONS(2080),
    [anon_sym___thiscall] = ACTIONS(2080),
    [anon_sym___vectorcall] = ACTIONS(2080),
    [anon_sym_LBRACE] = ACTIONS(2082),
    [anon_sym_signed] = ACTIONS(2080),
    [anon_sym_unsigned] = ACTIONS(2080),
    [anon_sym_long] = ACTIONS(2080),
    [anon_sym_short] = ACTIONS(2080),
    [anon_sym_LBRACK] = ACTIONS(2080),
    [anon_sym_static] = ACTIONS(2080),
    [anon_sym_register] = ACTIONS(2080),
    [anon_sym_inline] = ACTIONS(2080),
    [anon_sym___inline] = ACTIONS(2080),
    [anon_sym___inline__] = ACTIONS(2080),
    [anon_sym___forceinline] = ACTIONS(2080),
    [anon_sym_thread_local] = ACTIONS(2080),
    [anon_sym___thread] = ACTIONS(2080),
    [anon_sym_const] = ACTIONS(2080),
    [anon_sym_constexpr] = ACTIONS(2080),
    [anon_sym_volatile] = ACTIONS(2080),
    [anon_sym_restrict] = ACTIONS(2080),
    [anon_sym___restrict__] = ACTIONS(2080),
    [anon_sym__Atomic] = ACTIONS(2080),
    [anon_sym__Noreturn] = ACTIONS(2080),
    [anon_sym_noreturn] = ACTIONS(2080),
    [anon_sym_mutable] = ACTIONS(2080),
    [anon_sym_constinit] = ACTIONS(2080),
    [anon_sym_consteval] = ACTIONS(2080),
    [anon_sym___shared__] = ACTIONS(2080),
    [anon_sym___local__] = ACTIONS(2080),
    [anon_sym___constant__] = ACTIONS(2080),
    [anon_sym___managed__] = ACTIONS(2080),
    [anon_sym___grid_constant__] = ACTIONS(2080),
    [anon_sym_alignas] = ACTIONS(2080),
    [anon_sym__Alignas] = ACTIONS(2080),
    [sym_primitive_type] = ACTIONS(2080),
    [anon_sym_enum] = ACTIONS(2080),
    [anon_sym_class] = ACTIONS(2080),
    [anon_sym_struct] = ACTIONS(2080),
    [anon_sym_union] = ACTIONS(2080),
    [anon_sym_if] = ACTIONS(2080),
    [anon_sym_switch] = ACTIONS(2080),
    [anon_sym_case] = ACTIONS(2080),
    [anon_sym_default] = ACTIONS(2080),
    [anon_sym_while] = ACTIONS(2080),
    [anon_sym_do] = ACTIONS(2080),
    [anon_sym_for] = ACTIONS(2080),
    [anon_sym_return] = ACTIONS(2080),
    [anon_sym_break] = ACTIONS(2080),
    [anon_sym_continue] = ACTIONS(2080),
    [anon_sym_goto] = ACTIONS(2080),
    [anon_sym_not] = ACTIONS(2080),
    [anon_sym_compl] = ACTIONS(2080),
    [anon_sym_DASH_DASH] = ACTIONS(2082),
    [anon_sym_PLUS_PLUS] = ACTIONS(2082),
    [anon_sym_sizeof] = ACTIONS(2080),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2080),
    [anon_sym__Generic] = ACTIONS(2080),
    [anon_sym_asm] = ACTIONS(2080),
    [anon_sym___asm__] = ACTIONS(2080),
    [sym_number_literal] = ACTIONS(2082),
    [anon_sym_L_SQUOTE] = ACTIONS(2082),
    [anon_sym_u_SQUOTE] = ACTIONS(2082),
    [anon_sym_U_SQUOTE] = ACTIONS(2082),
    [anon_sym_u8_SQUOTE] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2082),
    [anon_sym_L_DQUOTE] = ACTIONS(2082),
    [anon_sym_u_DQUOTE] = ACTIONS(2082),
    [anon_sym_U_DQUOTE] = ACTIONS(2082),
    [anon_sym_u8_DQUOTE] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(2082),
    [sym_true] = ACTIONS(2080),
    [sym_false] = ACTIONS(2080),
    [anon_sym_NULL] = ACTIONS(2080),
    [anon_sym_nullptr] = ACTIONS(2080),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2080),
    [anon_sym_decltype] = ACTIONS(2080),
    [sym_virtual] = ACTIONS(2080),
    [anon_sym_explicit] = ACTIONS(2080),
    [anon_sym_typename] = ACTIONS(2080),
    [anon_sym_template] = ACTIONS(2080),
    [anon_sym_operator] = ACTIONS(2080),
    [anon_sym_try] = ACTIONS(2080),
    [anon_sym_delete] = ACTIONS(2080),
    [anon_sym_throw] = ACTIONS(2080),
    [anon_sym_namespace] = ACTIONS(2080),
    [anon_sym_using] = ACTIONS(2080),
    [anon_sym_static_assert] = ACTIONS(2080),
    [anon_sym_concept] = ACTIONS(2080),
    [anon_sym_co_return] = ACTIONS(2080),
    [anon_sym_co_yield] = ACTIONS(2080),
    [anon_sym_R_DQUOTE] = ACTIONS(2082),
    [anon_sym_LR_DQUOTE] = ACTIONS(2082),
    [anon_sym_uR_DQUOTE] = ACTIONS(2082),
    [anon_sym_UR_DQUOTE] = ACTIONS(2082),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2082),
    [anon_sym_co_await] = ACTIONS(2080),
    [anon_sym_new] = ACTIONS(2080),
    [anon_sym_requires] = ACTIONS(2080),
    [sym_this] = ACTIONS(2080),
    [anon_sym___launch_bounds__] = ACTIONS(2080),
  },
  [746] = {
    [ts_builtin_sym_end] = ACTIONS(2286),
    [sym_identifier] = ACTIONS(2284),
    [aux_sym_preproc_include_token1] = ACTIONS(2284),
    [aux_sym_preproc_def_token1] = ACTIONS(2284),
    [aux_sym_preproc_if_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2284),
    [sym_preproc_directive] = ACTIONS(2284),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_typedef] = ACTIONS(2284),
    [anon_sym___device__] = ACTIONS(2284),
    [anon_sym___host__] = ACTIONS(2284),
    [anon_sym___global__] = ACTIONS(2284),
    [anon_sym___forceinline__] = ACTIONS(2284),
    [anon_sym___noinline__] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2286),
    [anon_sym___declspec] = ACTIONS(2284),
    [anon_sym___based] = ACTIONS(2284),
    [anon_sym___cdecl] = ACTIONS(2284),
    [anon_sym___clrcall] = ACTIONS(2284),
    [anon_sym___stdcall] = ACTIONS(2284),
    [anon_sym___fastcall] = ACTIONS(2284),
    [anon_sym___thiscall] = ACTIONS(2284),
    [anon_sym___vectorcall] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_signed] = ACTIONS(2284),
    [anon_sym_unsigned] = ACTIONS(2284),
    [anon_sym_long] = ACTIONS(2284),
    [anon_sym_short] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym___inline] = ACTIONS(2284),
    [anon_sym___inline__] = ACTIONS(2284),
    [anon_sym___forceinline] = ACTIONS(2284),
    [anon_sym_thread_local] = ACTIONS(2284),
    [anon_sym___thread] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym___shared__] = ACTIONS(2284),
    [anon_sym___local__] = ACTIONS(2284),
    [anon_sym___constant__] = ACTIONS(2284),
    [anon_sym___managed__] = ACTIONS(2284),
    [anon_sym___grid_constant__] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [sym_primitive_type] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
    [anon_sym_class] = ACTIONS(2284),
    [anon_sym_struct] = ACTIONS(2284),
    [anon_sym_union] = ACTIONS(2284),
    [anon_sym_if] = ACTIONS(2284),
    [anon_sym_switch] = ACTIONS(2284),
    [anon_sym_case] = ACTIONS(2284),
    [anon_sym_default] = ACTIONS(2284),
    [anon_sym_while] = ACTIONS(2284),
    [anon_sym_do] = ACTIONS(2284),
    [anon_sym_for] = ACTIONS(2284),
    [anon_sym_return] = ACTIONS(2284),
    [anon_sym_break] = ACTIONS(2284),
    [anon_sym_continue] = ACTIONS(2284),
    [anon_sym_goto] = ACTIONS(2284),
    [anon_sym_not] = ACTIONS(2284),
    [anon_sym_compl] = ACTIONS(2284),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_sizeof] = ACTIONS(2284),
    [anon_sym___alignof__] = ACTIONS(2284),
    [anon_sym___alignof] = ACTIONS(2284),
    [anon_sym__alignof] = ACTIONS(2284),
    [anon_sym_alignof] = ACTIONS(2284),
    [anon_sym__Alignof] = ACTIONS(2284),
    [anon_sym_offsetof] = ACTIONS(2284),
    [anon_sym__Generic] = ACTIONS(2284),
    [anon_sym_asm] = ACTIONS(2284),
    [anon_sym___asm__] = ACTIONS(2284),
    [sym_number_literal] = ACTIONS(2286),
    [anon_sym_L_SQUOTE] = ACTIONS(2286),
    [anon_sym_u_SQUOTE] = ACTIONS(2286),
    [anon_sym_U_SQUOTE] = ACTIONS(2286),
    [anon_sym_u8_SQUOTE] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [anon_sym_L_DQUOTE] = ACTIONS(2286),
    [anon_sym_u_DQUOTE] = ACTIONS(2286),
    [anon_sym_U_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8_DQUOTE] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [sym_true] = ACTIONS(2284),
    [sym_false] = ACTIONS(2284),
    [anon_sym_NULL] = ACTIONS(2284),
    [anon_sym_nullptr] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [sym_virtual] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_typename] = ACTIONS(2284),
    [anon_sym_template] = ACTIONS(2284),
    [anon_sym_operator] = ACTIONS(2284),
    [anon_sym_try] = ACTIONS(2284),
    [anon_sym_delete] = ACTIONS(2284),
    [anon_sym_throw] = ACTIONS(2284),
    [anon_sym_namespace] = ACTIONS(2284),
    [anon_sym_using] = ACTIONS(2284),
    [anon_sym_static_assert] = ACTIONS(2284),
    [anon_sym_concept] = ACTIONS(2284),
    [anon_sym_co_return] = ACTIONS(2284),
    [anon_sym_co_yield] = ACTIONS(2284),
    [anon_sym_R_DQUOTE] = ACTIONS(2286),
    [anon_sym_LR_DQUOTE] = ACTIONS(2286),
    [anon_sym_uR_DQUOTE] = ACTIONS(2286),
    [anon_sym_UR_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2286),
    [anon_sym_co_await] = ACTIONS(2284),
    [anon_sym_new] = ACTIONS(2284),
    [anon_sym_requires] = ACTIONS(2284),
    [sym_this] = ACTIONS(2284),
    [anon_sym___launch_bounds__] = ACTIONS(2284),
  },
  [747] = {
    [sym_preproc_def] = STATE(769),
    [sym_preproc_function_def] = STATE(769),
    [sym_preproc_call] = STATE(769),
    [sym_preproc_if_in_field_declaration_list] = STATE(769),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(769),
    [sym_type_definition] = STATE(769),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5894),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6463),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(769),
    [sym_field_declaration] = STATE(769),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1708),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(769),
    [sym_operator_cast] = STATE(6999),
    [sym_inline_method_definition] = STATE(769),
    [sym__constructor_specifiers] = STATE(1708),
    [sym_operator_cast_definition] = STATE(769),
    [sym_operator_cast_declaration] = STATE(769),
    [sym_constructor_or_destructor_definition] = STATE(769),
    [sym_constructor_or_destructor_declaration] = STATE(769),
    [sym_friend_declaration] = STATE(769),
    [sym_access_specifier] = STATE(8255),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(769),
    [sym_alias_declaration] = STATE(769),
    [sym_static_assert_declaration] = STATE(769),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6999),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(769),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1708),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3376),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3378),
    [sym_preproc_directive] = ACTIONS(3380),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(3382),
    [anon_sym_typedef] = ACTIONS(3384),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3494),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3390),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(3392),
    [anon_sym_static_assert] = ACTIONS(3394),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [748] = {
    [sym_preproc_def] = STATE(701),
    [sym_preproc_function_def] = STATE(701),
    [sym_preproc_call] = STATE(701),
    [sym_preproc_if_in_field_declaration_list] = STATE(701),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(701),
    [sym_type_definition] = STATE(701),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5894),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6463),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(701),
    [sym_field_declaration] = STATE(701),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1708),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(701),
    [sym_operator_cast] = STATE(6999),
    [sym_inline_method_definition] = STATE(701),
    [sym__constructor_specifiers] = STATE(1708),
    [sym_operator_cast_definition] = STATE(701),
    [sym_operator_cast_declaration] = STATE(701),
    [sym_constructor_or_destructor_definition] = STATE(701),
    [sym_constructor_or_destructor_declaration] = STATE(701),
    [sym_friend_declaration] = STATE(701),
    [sym_access_specifier] = STATE(8255),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(701),
    [sym_alias_declaration] = STATE(701),
    [sym_static_assert_declaration] = STATE(701),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6999),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(701),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1708),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3376),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3378),
    [sym_preproc_directive] = ACTIONS(3380),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(3382),
    [anon_sym_typedef] = ACTIONS(3384),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3496),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3390),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(3392),
    [anon_sym_static_assert] = ACTIONS(3394),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [749] = {
    [ts_builtin_sym_end] = ACTIONS(2368),
    [sym_identifier] = ACTIONS(2366),
    [aux_sym_preproc_include_token1] = ACTIONS(2366),
    [aux_sym_preproc_def_token1] = ACTIONS(2366),
    [aux_sym_preproc_if_token1] = ACTIONS(2366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2366),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2366),
    [sym_preproc_directive] = ACTIONS(2366),
    [anon_sym_LPAREN2] = ACTIONS(2368),
    [anon_sym_BANG] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(2368),
    [anon_sym_DASH] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(2366),
    [anon_sym_STAR] = ACTIONS(2368),
    [anon_sym_AMP_AMP] = ACTIONS(2368),
    [anon_sym_AMP] = ACTIONS(2366),
    [anon_sym___extension__] = ACTIONS(2366),
    [anon_sym_typedef] = ACTIONS(2366),
    [anon_sym___device__] = ACTIONS(2366),
    [anon_sym___host__] = ACTIONS(2366),
    [anon_sym___global__] = ACTIONS(2366),
    [anon_sym___forceinline__] = ACTIONS(2366),
    [anon_sym___noinline__] = ACTIONS(2366),
    [anon_sym_extern] = ACTIONS(2366),
    [anon_sym___attribute__] = ACTIONS(2366),
    [anon_sym_COLON_COLON] = ACTIONS(2368),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2368),
    [anon_sym___declspec] = ACTIONS(2366),
    [anon_sym___based] = ACTIONS(2366),
    [anon_sym___cdecl] = ACTIONS(2366),
    [anon_sym___clrcall] = ACTIONS(2366),
    [anon_sym___stdcall] = ACTIONS(2366),
    [anon_sym___fastcall] = ACTIONS(2366),
    [anon_sym___thiscall] = ACTIONS(2366),
    [anon_sym___vectorcall] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(2368),
    [anon_sym_signed] = ACTIONS(2366),
    [anon_sym_unsigned] = ACTIONS(2366),
    [anon_sym_long] = ACTIONS(2366),
    [anon_sym_short] = ACTIONS(2366),
    [anon_sym_LBRACK] = ACTIONS(2366),
    [anon_sym_static] = ACTIONS(2366),
    [anon_sym_register] = ACTIONS(2366),
    [anon_sym_inline] = ACTIONS(2366),
    [anon_sym___inline] = ACTIONS(2366),
    [anon_sym___inline__] = ACTIONS(2366),
    [anon_sym___forceinline] = ACTIONS(2366),
    [anon_sym_thread_local] = ACTIONS(2366),
    [anon_sym___thread] = ACTIONS(2366),
    [anon_sym_const] = ACTIONS(2366),
    [anon_sym_constexpr] = ACTIONS(2366),
    [anon_sym_volatile] = ACTIONS(2366),
    [anon_sym_restrict] = ACTIONS(2366),
    [anon_sym___restrict__] = ACTIONS(2366),
    [anon_sym__Atomic] = ACTIONS(2366),
    [anon_sym__Noreturn] = ACTIONS(2366),
    [anon_sym_noreturn] = ACTIONS(2366),
    [anon_sym_mutable] = ACTIONS(2366),
    [anon_sym_constinit] = ACTIONS(2366),
    [anon_sym_consteval] = ACTIONS(2366),
    [anon_sym___shared__] = ACTIONS(2366),
    [anon_sym___local__] = ACTIONS(2366),
    [anon_sym___constant__] = ACTIONS(2366),
    [anon_sym___managed__] = ACTIONS(2366),
    [anon_sym___grid_constant__] = ACTIONS(2366),
    [anon_sym_alignas] = ACTIONS(2366),
    [anon_sym__Alignas] = ACTIONS(2366),
    [sym_primitive_type] = ACTIONS(2366),
    [anon_sym_enum] = ACTIONS(2366),
    [anon_sym_class] = ACTIONS(2366),
    [anon_sym_struct] = ACTIONS(2366),
    [anon_sym_union] = ACTIONS(2366),
    [anon_sym_if] = ACTIONS(2366),
    [anon_sym_switch] = ACTIONS(2366),
    [anon_sym_case] = ACTIONS(2366),
    [anon_sym_default] = ACTIONS(2366),
    [anon_sym_while] = ACTIONS(2366),
    [anon_sym_do] = ACTIONS(2366),
    [anon_sym_for] = ACTIONS(2366),
    [anon_sym_return] = ACTIONS(2366),
    [anon_sym_break] = ACTIONS(2366),
    [anon_sym_continue] = ACTIONS(2366),
    [anon_sym_goto] = ACTIONS(2366),
    [anon_sym_not] = ACTIONS(2366),
    [anon_sym_compl] = ACTIONS(2366),
    [anon_sym_DASH_DASH] = ACTIONS(2368),
    [anon_sym_PLUS_PLUS] = ACTIONS(2368),
    [anon_sym_sizeof] = ACTIONS(2366),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2366),
    [anon_sym__Generic] = ACTIONS(2366),
    [anon_sym_asm] = ACTIONS(2366),
    [anon_sym___asm__] = ACTIONS(2366),
    [sym_number_literal] = ACTIONS(2368),
    [anon_sym_L_SQUOTE] = ACTIONS(2368),
    [anon_sym_u_SQUOTE] = ACTIONS(2368),
    [anon_sym_U_SQUOTE] = ACTIONS(2368),
    [anon_sym_u8_SQUOTE] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(2368),
    [anon_sym_L_DQUOTE] = ACTIONS(2368),
    [anon_sym_u_DQUOTE] = ACTIONS(2368),
    [anon_sym_U_DQUOTE] = ACTIONS(2368),
    [anon_sym_u8_DQUOTE] = ACTIONS(2368),
    [anon_sym_DQUOTE] = ACTIONS(2368),
    [sym_true] = ACTIONS(2366),
    [sym_false] = ACTIONS(2366),
    [anon_sym_NULL] = ACTIONS(2366),
    [anon_sym_nullptr] = ACTIONS(2366),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2366),
    [anon_sym_decltype] = ACTIONS(2366),
    [sym_virtual] = ACTIONS(2366),
    [anon_sym_explicit] = ACTIONS(2366),
    [anon_sym_typename] = ACTIONS(2366),
    [anon_sym_template] = ACTIONS(2366),
    [anon_sym_operator] = ACTIONS(2366),
    [anon_sym_try] = ACTIONS(2366),
    [anon_sym_delete] = ACTIONS(2366),
    [anon_sym_throw] = ACTIONS(2366),
    [anon_sym_namespace] = ACTIONS(2366),
    [anon_sym_using] = ACTIONS(2366),
    [anon_sym_static_assert] = ACTIONS(2366),
    [anon_sym_concept] = ACTIONS(2366),
    [anon_sym_co_return] = ACTIONS(2366),
    [anon_sym_co_yield] = ACTIONS(2366),
    [anon_sym_R_DQUOTE] = ACTIONS(2368),
    [anon_sym_LR_DQUOTE] = ACTIONS(2368),
    [anon_sym_uR_DQUOTE] = ACTIONS(2368),
    [anon_sym_UR_DQUOTE] = ACTIONS(2368),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2368),
    [anon_sym_co_await] = ACTIONS(2366),
    [anon_sym_new] = ACTIONS(2366),
    [anon_sym_requires] = ACTIONS(2366),
    [sym_this] = ACTIONS(2366),
    [anon_sym___launch_bounds__] = ACTIONS(2366),
  },
  [750] = {
    [ts_builtin_sym_end] = ACTIONS(2479),
    [sym_identifier] = ACTIONS(2477),
    [aux_sym_preproc_include_token1] = ACTIONS(2477),
    [aux_sym_preproc_def_token1] = ACTIONS(2477),
    [aux_sym_preproc_if_token1] = ACTIONS(2477),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2477),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2477),
    [sym_preproc_directive] = ACTIONS(2477),
    [anon_sym_LPAREN2] = ACTIONS(2479),
    [anon_sym_BANG] = ACTIONS(2479),
    [anon_sym_TILDE] = ACTIONS(2479),
    [anon_sym_DASH] = ACTIONS(2477),
    [anon_sym_PLUS] = ACTIONS(2477),
    [anon_sym_STAR] = ACTIONS(2479),
    [anon_sym_AMP_AMP] = ACTIONS(2479),
    [anon_sym_AMP] = ACTIONS(2477),
    [anon_sym___extension__] = ACTIONS(2477),
    [anon_sym_typedef] = ACTIONS(2477),
    [anon_sym___device__] = ACTIONS(2477),
    [anon_sym___host__] = ACTIONS(2477),
    [anon_sym___global__] = ACTIONS(2477),
    [anon_sym___forceinline__] = ACTIONS(2477),
    [anon_sym___noinline__] = ACTIONS(2477),
    [anon_sym_extern] = ACTIONS(2477),
    [anon_sym___attribute__] = ACTIONS(2477),
    [anon_sym_COLON_COLON] = ACTIONS(2479),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2479),
    [anon_sym___declspec] = ACTIONS(2477),
    [anon_sym___based] = ACTIONS(2477),
    [anon_sym___cdecl] = ACTIONS(2477),
    [anon_sym___clrcall] = ACTIONS(2477),
    [anon_sym___stdcall] = ACTIONS(2477),
    [anon_sym___fastcall] = ACTIONS(2477),
    [anon_sym___thiscall] = ACTIONS(2477),
    [anon_sym___vectorcall] = ACTIONS(2477),
    [anon_sym_LBRACE] = ACTIONS(2479),
    [anon_sym_signed] = ACTIONS(2477),
    [anon_sym_unsigned] = ACTIONS(2477),
    [anon_sym_long] = ACTIONS(2477),
    [anon_sym_short] = ACTIONS(2477),
    [anon_sym_LBRACK] = ACTIONS(2477),
    [anon_sym_static] = ACTIONS(2477),
    [anon_sym_register] = ACTIONS(2477),
    [anon_sym_inline] = ACTIONS(2477),
    [anon_sym___inline] = ACTIONS(2477),
    [anon_sym___inline__] = ACTIONS(2477),
    [anon_sym___forceinline] = ACTIONS(2477),
    [anon_sym_thread_local] = ACTIONS(2477),
    [anon_sym___thread] = ACTIONS(2477),
    [anon_sym_const] = ACTIONS(2477),
    [anon_sym_constexpr] = ACTIONS(2477),
    [anon_sym_volatile] = ACTIONS(2477),
    [anon_sym_restrict] = ACTIONS(2477),
    [anon_sym___restrict__] = ACTIONS(2477),
    [anon_sym__Atomic] = ACTIONS(2477),
    [anon_sym__Noreturn] = ACTIONS(2477),
    [anon_sym_noreturn] = ACTIONS(2477),
    [anon_sym_mutable] = ACTIONS(2477),
    [anon_sym_constinit] = ACTIONS(2477),
    [anon_sym_consteval] = ACTIONS(2477),
    [anon_sym___shared__] = ACTIONS(2477),
    [anon_sym___local__] = ACTIONS(2477),
    [anon_sym___constant__] = ACTIONS(2477),
    [anon_sym___managed__] = ACTIONS(2477),
    [anon_sym___grid_constant__] = ACTIONS(2477),
    [anon_sym_alignas] = ACTIONS(2477),
    [anon_sym__Alignas] = ACTIONS(2477),
    [sym_primitive_type] = ACTIONS(2477),
    [anon_sym_enum] = ACTIONS(2477),
    [anon_sym_class] = ACTIONS(2477),
    [anon_sym_struct] = ACTIONS(2477),
    [anon_sym_union] = ACTIONS(2477),
    [anon_sym_if] = ACTIONS(2477),
    [anon_sym_switch] = ACTIONS(2477),
    [anon_sym_case] = ACTIONS(2477),
    [anon_sym_default] = ACTIONS(2477),
    [anon_sym_while] = ACTIONS(2477),
    [anon_sym_do] = ACTIONS(2477),
    [anon_sym_for] = ACTIONS(2477),
    [anon_sym_return] = ACTIONS(2477),
    [anon_sym_break] = ACTIONS(2477),
    [anon_sym_continue] = ACTIONS(2477),
    [anon_sym_goto] = ACTIONS(2477),
    [anon_sym_not] = ACTIONS(2477),
    [anon_sym_compl] = ACTIONS(2477),
    [anon_sym_DASH_DASH] = ACTIONS(2479),
    [anon_sym_PLUS_PLUS] = ACTIONS(2479),
    [anon_sym_sizeof] = ACTIONS(2477),
    [anon_sym___alignof__] = ACTIONS(2477),
    [anon_sym___alignof] = ACTIONS(2477),
    [anon_sym__alignof] = ACTIONS(2477),
    [anon_sym_alignof] = ACTIONS(2477),
    [anon_sym__Alignof] = ACTIONS(2477),
    [anon_sym_offsetof] = ACTIONS(2477),
    [anon_sym__Generic] = ACTIONS(2477),
    [anon_sym_asm] = ACTIONS(2477),
    [anon_sym___asm__] = ACTIONS(2477),
    [sym_number_literal] = ACTIONS(2479),
    [anon_sym_L_SQUOTE] = ACTIONS(2479),
    [anon_sym_u_SQUOTE] = ACTIONS(2479),
    [anon_sym_U_SQUOTE] = ACTIONS(2479),
    [anon_sym_u8_SQUOTE] = ACTIONS(2479),
    [anon_sym_SQUOTE] = ACTIONS(2479),
    [anon_sym_L_DQUOTE] = ACTIONS(2479),
    [anon_sym_u_DQUOTE] = ACTIONS(2479),
    [anon_sym_U_DQUOTE] = ACTIONS(2479),
    [anon_sym_u8_DQUOTE] = ACTIONS(2479),
    [anon_sym_DQUOTE] = ACTIONS(2479),
    [sym_true] = ACTIONS(2477),
    [sym_false] = ACTIONS(2477),
    [anon_sym_NULL] = ACTIONS(2477),
    [anon_sym_nullptr] = ACTIONS(2477),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2477),
    [anon_sym_decltype] = ACTIONS(2477),
    [sym_virtual] = ACTIONS(2477),
    [anon_sym_explicit] = ACTIONS(2477),
    [anon_sym_typename] = ACTIONS(2477),
    [anon_sym_template] = ACTIONS(2477),
    [anon_sym_operator] = ACTIONS(2477),
    [anon_sym_try] = ACTIONS(2477),
    [anon_sym_delete] = ACTIONS(2477),
    [anon_sym_throw] = ACTIONS(2477),
    [anon_sym_namespace] = ACTIONS(2477),
    [anon_sym_using] = ACTIONS(2477),
    [anon_sym_static_assert] = ACTIONS(2477),
    [anon_sym_concept] = ACTIONS(2477),
    [anon_sym_co_return] = ACTIONS(2477),
    [anon_sym_co_yield] = ACTIONS(2477),
    [anon_sym_R_DQUOTE] = ACTIONS(2479),
    [anon_sym_LR_DQUOTE] = ACTIONS(2479),
    [anon_sym_uR_DQUOTE] = ACTIONS(2479),
    [anon_sym_UR_DQUOTE] = ACTIONS(2479),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2479),
    [anon_sym_co_await] = ACTIONS(2477),
    [anon_sym_new] = ACTIONS(2477),
    [anon_sym_requires] = ACTIONS(2477),
    [sym_this] = ACTIONS(2477),
    [anon_sym___launch_bounds__] = ACTIONS(2477),
  },
  [751] = {
    [ts_builtin_sym_end] = ACTIONS(2245),
    [sym_identifier] = ACTIONS(2243),
    [aux_sym_preproc_include_token1] = ACTIONS(2243),
    [aux_sym_preproc_def_token1] = ACTIONS(2243),
    [aux_sym_preproc_if_token1] = ACTIONS(2243),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2243),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2243),
    [sym_preproc_directive] = ACTIONS(2243),
    [anon_sym_LPAREN2] = ACTIONS(2245),
    [anon_sym_BANG] = ACTIONS(2245),
    [anon_sym_TILDE] = ACTIONS(2245),
    [anon_sym_DASH] = ACTIONS(2243),
    [anon_sym_PLUS] = ACTIONS(2243),
    [anon_sym_STAR] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2245),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym___extension__] = ACTIONS(2243),
    [anon_sym_typedef] = ACTIONS(2243),
    [anon_sym___device__] = ACTIONS(2243),
    [anon_sym___host__] = ACTIONS(2243),
    [anon_sym___global__] = ACTIONS(2243),
    [anon_sym___forceinline__] = ACTIONS(2243),
    [anon_sym___noinline__] = ACTIONS(2243),
    [anon_sym_extern] = ACTIONS(2243),
    [anon_sym___attribute__] = ACTIONS(2243),
    [anon_sym_COLON_COLON] = ACTIONS(2245),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2245),
    [anon_sym___declspec] = ACTIONS(2243),
    [anon_sym___based] = ACTIONS(2243),
    [anon_sym___cdecl] = ACTIONS(2243),
    [anon_sym___clrcall] = ACTIONS(2243),
    [anon_sym___stdcall] = ACTIONS(2243),
    [anon_sym___fastcall] = ACTIONS(2243),
    [anon_sym___thiscall] = ACTIONS(2243),
    [anon_sym___vectorcall] = ACTIONS(2243),
    [anon_sym_LBRACE] = ACTIONS(2245),
    [anon_sym_signed] = ACTIONS(2243),
    [anon_sym_unsigned] = ACTIONS(2243),
    [anon_sym_long] = ACTIONS(2243),
    [anon_sym_short] = ACTIONS(2243),
    [anon_sym_LBRACK] = ACTIONS(2243),
    [anon_sym_static] = ACTIONS(2243),
    [anon_sym_register] = ACTIONS(2243),
    [anon_sym_inline] = ACTIONS(2243),
    [anon_sym___inline] = ACTIONS(2243),
    [anon_sym___inline__] = ACTIONS(2243),
    [anon_sym___forceinline] = ACTIONS(2243),
    [anon_sym_thread_local] = ACTIONS(2243),
    [anon_sym___thread] = ACTIONS(2243),
    [anon_sym_const] = ACTIONS(2243),
    [anon_sym_constexpr] = ACTIONS(2243),
    [anon_sym_volatile] = ACTIONS(2243),
    [anon_sym_restrict] = ACTIONS(2243),
    [anon_sym___restrict__] = ACTIONS(2243),
    [anon_sym__Atomic] = ACTIONS(2243),
    [anon_sym__Noreturn] = ACTIONS(2243),
    [anon_sym_noreturn] = ACTIONS(2243),
    [anon_sym_mutable] = ACTIONS(2243),
    [anon_sym_constinit] = ACTIONS(2243),
    [anon_sym_consteval] = ACTIONS(2243),
    [anon_sym___shared__] = ACTIONS(2243),
    [anon_sym___local__] = ACTIONS(2243),
    [anon_sym___constant__] = ACTIONS(2243),
    [anon_sym___managed__] = ACTIONS(2243),
    [anon_sym___grid_constant__] = ACTIONS(2243),
    [anon_sym_alignas] = ACTIONS(2243),
    [anon_sym__Alignas] = ACTIONS(2243),
    [sym_primitive_type] = ACTIONS(2243),
    [anon_sym_enum] = ACTIONS(2243),
    [anon_sym_class] = ACTIONS(2243),
    [anon_sym_struct] = ACTIONS(2243),
    [anon_sym_union] = ACTIONS(2243),
    [anon_sym_if] = ACTIONS(2243),
    [anon_sym_switch] = ACTIONS(2243),
    [anon_sym_case] = ACTIONS(2243),
    [anon_sym_default] = ACTIONS(2243),
    [anon_sym_while] = ACTIONS(2243),
    [anon_sym_do] = ACTIONS(2243),
    [anon_sym_for] = ACTIONS(2243),
    [anon_sym_return] = ACTIONS(2243),
    [anon_sym_break] = ACTIONS(2243),
    [anon_sym_continue] = ACTIONS(2243),
    [anon_sym_goto] = ACTIONS(2243),
    [anon_sym_not] = ACTIONS(2243),
    [anon_sym_compl] = ACTIONS(2243),
    [anon_sym_DASH_DASH] = ACTIONS(2245),
    [anon_sym_PLUS_PLUS] = ACTIONS(2245),
    [anon_sym_sizeof] = ACTIONS(2243),
    [anon_sym___alignof__] = ACTIONS(2243),
    [anon_sym___alignof] = ACTIONS(2243),
    [anon_sym__alignof] = ACTIONS(2243),
    [anon_sym_alignof] = ACTIONS(2243),
    [anon_sym__Alignof] = ACTIONS(2243),
    [anon_sym_offsetof] = ACTIONS(2243),
    [anon_sym__Generic] = ACTIONS(2243),
    [anon_sym_asm] = ACTIONS(2243),
    [anon_sym___asm__] = ACTIONS(2243),
    [sym_number_literal] = ACTIONS(2245),
    [anon_sym_L_SQUOTE] = ACTIONS(2245),
    [anon_sym_u_SQUOTE] = ACTIONS(2245),
    [anon_sym_U_SQUOTE] = ACTIONS(2245),
    [anon_sym_u8_SQUOTE] = ACTIONS(2245),
    [anon_sym_SQUOTE] = ACTIONS(2245),
    [anon_sym_L_DQUOTE] = ACTIONS(2245),
    [anon_sym_u_DQUOTE] = ACTIONS(2245),
    [anon_sym_U_DQUOTE] = ACTIONS(2245),
    [anon_sym_u8_DQUOTE] = ACTIONS(2245),
    [anon_sym_DQUOTE] = ACTIONS(2245),
    [sym_true] = ACTIONS(2243),
    [sym_false] = ACTIONS(2243),
    [anon_sym_NULL] = ACTIONS(2243),
    [anon_sym_nullptr] = ACTIONS(2243),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2243),
    [anon_sym_decltype] = ACTIONS(2243),
    [sym_virtual] = ACTIONS(2243),
    [anon_sym_explicit] = ACTIONS(2243),
    [anon_sym_typename] = ACTIONS(2243),
    [anon_sym_template] = ACTIONS(2243),
    [anon_sym_operator] = ACTIONS(2243),
    [anon_sym_try] = ACTIONS(2243),
    [anon_sym_delete] = ACTIONS(2243),
    [anon_sym_throw] = ACTIONS(2243),
    [anon_sym_namespace] = ACTIONS(2243),
    [anon_sym_using] = ACTIONS(2243),
    [anon_sym_static_assert] = ACTIONS(2243),
    [anon_sym_concept] = ACTIONS(2243),
    [anon_sym_co_return] = ACTIONS(2243),
    [anon_sym_co_yield] = ACTIONS(2243),
    [anon_sym_R_DQUOTE] = ACTIONS(2245),
    [anon_sym_LR_DQUOTE] = ACTIONS(2245),
    [anon_sym_uR_DQUOTE] = ACTIONS(2245),
    [anon_sym_UR_DQUOTE] = ACTIONS(2245),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2245),
    [anon_sym_co_await] = ACTIONS(2243),
    [anon_sym_new] = ACTIONS(2243),
    [anon_sym_requires] = ACTIONS(2243),
    [sym_this] = ACTIONS(2243),
    [anon_sym___launch_bounds__] = ACTIONS(2243),
  },
  [752] = {
    [sym_preproc_def] = STATE(690),
    [sym_preproc_function_def] = STATE(690),
    [sym_preproc_call] = STATE(690),
    [sym_preproc_if_in_field_declaration_list] = STATE(690),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(690),
    [sym_type_definition] = STATE(690),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5894),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6463),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(690),
    [sym_field_declaration] = STATE(690),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1708),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(690),
    [sym_operator_cast] = STATE(6999),
    [sym_inline_method_definition] = STATE(690),
    [sym__constructor_specifiers] = STATE(1708),
    [sym_operator_cast_definition] = STATE(690),
    [sym_operator_cast_declaration] = STATE(690),
    [sym_constructor_or_destructor_definition] = STATE(690),
    [sym_constructor_or_destructor_declaration] = STATE(690),
    [sym_friend_declaration] = STATE(690),
    [sym_access_specifier] = STATE(8255),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(690),
    [sym_alias_declaration] = STATE(690),
    [sym_static_assert_declaration] = STATE(690),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6999),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(690),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1708),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3376),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3378),
    [sym_preproc_directive] = ACTIONS(3380),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(3382),
    [anon_sym_typedef] = ACTIONS(3384),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3498),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3390),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(3392),
    [anon_sym_static_assert] = ACTIONS(3394),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [753] = {
    [ts_builtin_sym_end] = ACTIONS(2471),
    [sym_identifier] = ACTIONS(2469),
    [aux_sym_preproc_include_token1] = ACTIONS(2469),
    [aux_sym_preproc_def_token1] = ACTIONS(2469),
    [aux_sym_preproc_if_token1] = ACTIONS(2469),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2469),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2469),
    [sym_preproc_directive] = ACTIONS(2469),
    [anon_sym_LPAREN2] = ACTIONS(2471),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_TILDE] = ACTIONS(2471),
    [anon_sym_DASH] = ACTIONS(2469),
    [anon_sym_PLUS] = ACTIONS(2469),
    [anon_sym_STAR] = ACTIONS(2471),
    [anon_sym_AMP_AMP] = ACTIONS(2471),
    [anon_sym_AMP] = ACTIONS(2469),
    [anon_sym___extension__] = ACTIONS(2469),
    [anon_sym_typedef] = ACTIONS(2469),
    [anon_sym___device__] = ACTIONS(2469),
    [anon_sym___host__] = ACTIONS(2469),
    [anon_sym___global__] = ACTIONS(2469),
    [anon_sym___forceinline__] = ACTIONS(2469),
    [anon_sym___noinline__] = ACTIONS(2469),
    [anon_sym_extern] = ACTIONS(2469),
    [anon_sym___attribute__] = ACTIONS(2469),
    [anon_sym_COLON_COLON] = ACTIONS(2471),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2471),
    [anon_sym___declspec] = ACTIONS(2469),
    [anon_sym___based] = ACTIONS(2469),
    [anon_sym___cdecl] = ACTIONS(2469),
    [anon_sym___clrcall] = ACTIONS(2469),
    [anon_sym___stdcall] = ACTIONS(2469),
    [anon_sym___fastcall] = ACTIONS(2469),
    [anon_sym___thiscall] = ACTIONS(2469),
    [anon_sym___vectorcall] = ACTIONS(2469),
    [anon_sym_LBRACE] = ACTIONS(2471),
    [anon_sym_signed] = ACTIONS(2469),
    [anon_sym_unsigned] = ACTIONS(2469),
    [anon_sym_long] = ACTIONS(2469),
    [anon_sym_short] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2469),
    [anon_sym_static] = ACTIONS(2469),
    [anon_sym_register] = ACTIONS(2469),
    [anon_sym_inline] = ACTIONS(2469),
    [anon_sym___inline] = ACTIONS(2469),
    [anon_sym___inline__] = ACTIONS(2469),
    [anon_sym___forceinline] = ACTIONS(2469),
    [anon_sym_thread_local] = ACTIONS(2469),
    [anon_sym___thread] = ACTIONS(2469),
    [anon_sym_const] = ACTIONS(2469),
    [anon_sym_constexpr] = ACTIONS(2469),
    [anon_sym_volatile] = ACTIONS(2469),
    [anon_sym_restrict] = ACTIONS(2469),
    [anon_sym___restrict__] = ACTIONS(2469),
    [anon_sym__Atomic] = ACTIONS(2469),
    [anon_sym__Noreturn] = ACTIONS(2469),
    [anon_sym_noreturn] = ACTIONS(2469),
    [anon_sym_mutable] = ACTIONS(2469),
    [anon_sym_constinit] = ACTIONS(2469),
    [anon_sym_consteval] = ACTIONS(2469),
    [anon_sym___shared__] = ACTIONS(2469),
    [anon_sym___local__] = ACTIONS(2469),
    [anon_sym___constant__] = ACTIONS(2469),
    [anon_sym___managed__] = ACTIONS(2469),
    [anon_sym___grid_constant__] = ACTIONS(2469),
    [anon_sym_alignas] = ACTIONS(2469),
    [anon_sym__Alignas] = ACTIONS(2469),
    [sym_primitive_type] = ACTIONS(2469),
    [anon_sym_enum] = ACTIONS(2469),
    [anon_sym_class] = ACTIONS(2469),
    [anon_sym_struct] = ACTIONS(2469),
    [anon_sym_union] = ACTIONS(2469),
    [anon_sym_if] = ACTIONS(2469),
    [anon_sym_switch] = ACTIONS(2469),
    [anon_sym_case] = ACTIONS(2469),
    [anon_sym_default] = ACTIONS(2469),
    [anon_sym_while] = ACTIONS(2469),
    [anon_sym_do] = ACTIONS(2469),
    [anon_sym_for] = ACTIONS(2469),
    [anon_sym_return] = ACTIONS(2469),
    [anon_sym_break] = ACTIONS(2469),
    [anon_sym_continue] = ACTIONS(2469),
    [anon_sym_goto] = ACTIONS(2469),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_compl] = ACTIONS(2469),
    [anon_sym_DASH_DASH] = ACTIONS(2471),
    [anon_sym_PLUS_PLUS] = ACTIONS(2471),
    [anon_sym_sizeof] = ACTIONS(2469),
    [anon_sym___alignof__] = ACTIONS(2469),
    [anon_sym___alignof] = ACTIONS(2469),
    [anon_sym__alignof] = ACTIONS(2469),
    [anon_sym_alignof] = ACTIONS(2469),
    [anon_sym__Alignof] = ACTIONS(2469),
    [anon_sym_offsetof] = ACTIONS(2469),
    [anon_sym__Generic] = ACTIONS(2469),
    [anon_sym_asm] = ACTIONS(2469),
    [anon_sym___asm__] = ACTIONS(2469),
    [sym_number_literal] = ACTIONS(2471),
    [anon_sym_L_SQUOTE] = ACTIONS(2471),
    [anon_sym_u_SQUOTE] = ACTIONS(2471),
    [anon_sym_U_SQUOTE] = ACTIONS(2471),
    [anon_sym_u8_SQUOTE] = ACTIONS(2471),
    [anon_sym_SQUOTE] = ACTIONS(2471),
    [anon_sym_L_DQUOTE] = ACTIONS(2471),
    [anon_sym_u_DQUOTE] = ACTIONS(2471),
    [anon_sym_U_DQUOTE] = ACTIONS(2471),
    [anon_sym_u8_DQUOTE] = ACTIONS(2471),
    [anon_sym_DQUOTE] = ACTIONS(2471),
    [sym_true] = ACTIONS(2469),
    [sym_false] = ACTIONS(2469),
    [anon_sym_NULL] = ACTIONS(2469),
    [anon_sym_nullptr] = ACTIONS(2469),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2469),
    [anon_sym_decltype] = ACTIONS(2469),
    [sym_virtual] = ACTIONS(2469),
    [anon_sym_explicit] = ACTIONS(2469),
    [anon_sym_typename] = ACTIONS(2469),
    [anon_sym_template] = ACTIONS(2469),
    [anon_sym_operator] = ACTIONS(2469),
    [anon_sym_try] = ACTIONS(2469),
    [anon_sym_delete] = ACTIONS(2469),
    [anon_sym_throw] = ACTIONS(2469),
    [anon_sym_namespace] = ACTIONS(2469),
    [anon_sym_using] = ACTIONS(2469),
    [anon_sym_static_assert] = ACTIONS(2469),
    [anon_sym_concept] = ACTIONS(2469),
    [anon_sym_co_return] = ACTIONS(2469),
    [anon_sym_co_yield] = ACTIONS(2469),
    [anon_sym_R_DQUOTE] = ACTIONS(2471),
    [anon_sym_LR_DQUOTE] = ACTIONS(2471),
    [anon_sym_uR_DQUOTE] = ACTIONS(2471),
    [anon_sym_UR_DQUOTE] = ACTIONS(2471),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2471),
    [anon_sym_co_await] = ACTIONS(2469),
    [anon_sym_new] = ACTIONS(2469),
    [anon_sym_requires] = ACTIONS(2469),
    [sym_this] = ACTIONS(2469),
    [anon_sym___launch_bounds__] = ACTIONS(2469),
  },
  [754] = {
    [ts_builtin_sym_end] = ACTIONS(2178),
    [sym_identifier] = ACTIONS(2176),
    [aux_sym_preproc_include_token1] = ACTIONS(2176),
    [aux_sym_preproc_def_token1] = ACTIONS(2176),
    [aux_sym_preproc_if_token1] = ACTIONS(2176),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2176),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2176),
    [sym_preproc_directive] = ACTIONS(2176),
    [anon_sym_LPAREN2] = ACTIONS(2178),
    [anon_sym_BANG] = ACTIONS(2178),
    [anon_sym_TILDE] = ACTIONS(2178),
    [anon_sym_DASH] = ACTIONS(2176),
    [anon_sym_PLUS] = ACTIONS(2176),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_AMP_AMP] = ACTIONS(2178),
    [anon_sym_AMP] = ACTIONS(2176),
    [anon_sym___extension__] = ACTIONS(2176),
    [anon_sym_typedef] = ACTIONS(2176),
    [anon_sym___device__] = ACTIONS(2176),
    [anon_sym___host__] = ACTIONS(2176),
    [anon_sym___global__] = ACTIONS(2176),
    [anon_sym___forceinline__] = ACTIONS(2176),
    [anon_sym___noinline__] = ACTIONS(2176),
    [anon_sym_extern] = ACTIONS(2176),
    [anon_sym___attribute__] = ACTIONS(2176),
    [anon_sym_COLON_COLON] = ACTIONS(2178),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2178),
    [anon_sym___declspec] = ACTIONS(2176),
    [anon_sym___based] = ACTIONS(2176),
    [anon_sym___cdecl] = ACTIONS(2176),
    [anon_sym___clrcall] = ACTIONS(2176),
    [anon_sym___stdcall] = ACTIONS(2176),
    [anon_sym___fastcall] = ACTIONS(2176),
    [anon_sym___thiscall] = ACTIONS(2176),
    [anon_sym___vectorcall] = ACTIONS(2176),
    [anon_sym_LBRACE] = ACTIONS(2178),
    [anon_sym_signed] = ACTIONS(2176),
    [anon_sym_unsigned] = ACTIONS(2176),
    [anon_sym_long] = ACTIONS(2176),
    [anon_sym_short] = ACTIONS(2176),
    [anon_sym_LBRACK] = ACTIONS(2176),
    [anon_sym_static] = ACTIONS(2176),
    [anon_sym_register] = ACTIONS(2176),
    [anon_sym_inline] = ACTIONS(2176),
    [anon_sym___inline] = ACTIONS(2176),
    [anon_sym___inline__] = ACTIONS(2176),
    [anon_sym___forceinline] = ACTIONS(2176),
    [anon_sym_thread_local] = ACTIONS(2176),
    [anon_sym___thread] = ACTIONS(2176),
    [anon_sym_const] = ACTIONS(2176),
    [anon_sym_constexpr] = ACTIONS(2176),
    [anon_sym_volatile] = ACTIONS(2176),
    [anon_sym_restrict] = ACTIONS(2176),
    [anon_sym___restrict__] = ACTIONS(2176),
    [anon_sym__Atomic] = ACTIONS(2176),
    [anon_sym__Noreturn] = ACTIONS(2176),
    [anon_sym_noreturn] = ACTIONS(2176),
    [anon_sym_mutable] = ACTIONS(2176),
    [anon_sym_constinit] = ACTIONS(2176),
    [anon_sym_consteval] = ACTIONS(2176),
    [anon_sym___shared__] = ACTIONS(2176),
    [anon_sym___local__] = ACTIONS(2176),
    [anon_sym___constant__] = ACTIONS(2176),
    [anon_sym___managed__] = ACTIONS(2176),
    [anon_sym___grid_constant__] = ACTIONS(2176),
    [anon_sym_alignas] = ACTIONS(2176),
    [anon_sym__Alignas] = ACTIONS(2176),
    [sym_primitive_type] = ACTIONS(2176),
    [anon_sym_enum] = ACTIONS(2176),
    [anon_sym_class] = ACTIONS(2176),
    [anon_sym_struct] = ACTIONS(2176),
    [anon_sym_union] = ACTIONS(2176),
    [anon_sym_if] = ACTIONS(2176),
    [anon_sym_switch] = ACTIONS(2176),
    [anon_sym_case] = ACTIONS(2176),
    [anon_sym_default] = ACTIONS(2176),
    [anon_sym_while] = ACTIONS(2176),
    [anon_sym_do] = ACTIONS(2176),
    [anon_sym_for] = ACTIONS(2176),
    [anon_sym_return] = ACTIONS(2176),
    [anon_sym_break] = ACTIONS(2176),
    [anon_sym_continue] = ACTIONS(2176),
    [anon_sym_goto] = ACTIONS(2176),
    [anon_sym_not] = ACTIONS(2176),
    [anon_sym_compl] = ACTIONS(2176),
    [anon_sym_DASH_DASH] = ACTIONS(2178),
    [anon_sym_PLUS_PLUS] = ACTIONS(2178),
    [anon_sym_sizeof] = ACTIONS(2176),
    [anon_sym___alignof__] = ACTIONS(2176),
    [anon_sym___alignof] = ACTIONS(2176),
    [anon_sym__alignof] = ACTIONS(2176),
    [anon_sym_alignof] = ACTIONS(2176),
    [anon_sym__Alignof] = ACTIONS(2176),
    [anon_sym_offsetof] = ACTIONS(2176),
    [anon_sym__Generic] = ACTIONS(2176),
    [anon_sym_asm] = ACTIONS(2176),
    [anon_sym___asm__] = ACTIONS(2176),
    [sym_number_literal] = ACTIONS(2178),
    [anon_sym_L_SQUOTE] = ACTIONS(2178),
    [anon_sym_u_SQUOTE] = ACTIONS(2178),
    [anon_sym_U_SQUOTE] = ACTIONS(2178),
    [anon_sym_u8_SQUOTE] = ACTIONS(2178),
    [anon_sym_SQUOTE] = ACTIONS(2178),
    [anon_sym_L_DQUOTE] = ACTIONS(2178),
    [anon_sym_u_DQUOTE] = ACTIONS(2178),
    [anon_sym_U_DQUOTE] = ACTIONS(2178),
    [anon_sym_u8_DQUOTE] = ACTIONS(2178),
    [anon_sym_DQUOTE] = ACTIONS(2178),
    [sym_true] = ACTIONS(2176),
    [sym_false] = ACTIONS(2176),
    [anon_sym_NULL] = ACTIONS(2176),
    [anon_sym_nullptr] = ACTIONS(2176),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2176),
    [anon_sym_decltype] = ACTIONS(2176),
    [sym_virtual] = ACTIONS(2176),
    [anon_sym_explicit] = ACTIONS(2176),
    [anon_sym_typename] = ACTIONS(2176),
    [anon_sym_template] = ACTIONS(2176),
    [anon_sym_operator] = ACTIONS(2176),
    [anon_sym_try] = ACTIONS(2176),
    [anon_sym_delete] = ACTIONS(2176),
    [anon_sym_throw] = ACTIONS(2176),
    [anon_sym_namespace] = ACTIONS(2176),
    [anon_sym_using] = ACTIONS(2176),
    [anon_sym_static_assert] = ACTIONS(2176),
    [anon_sym_concept] = ACTIONS(2176),
    [anon_sym_co_return] = ACTIONS(2176),
    [anon_sym_co_yield] = ACTIONS(2176),
    [anon_sym_R_DQUOTE] = ACTIONS(2178),
    [anon_sym_LR_DQUOTE] = ACTIONS(2178),
    [anon_sym_uR_DQUOTE] = ACTIONS(2178),
    [anon_sym_UR_DQUOTE] = ACTIONS(2178),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2178),
    [anon_sym_co_await] = ACTIONS(2176),
    [anon_sym_new] = ACTIONS(2176),
    [anon_sym_requires] = ACTIONS(2176),
    [sym_this] = ACTIONS(2176),
    [anon_sym___launch_bounds__] = ACTIONS(2176),
  },
  [755] = {
    [ts_builtin_sym_end] = ACTIONS(2467),
    [sym_identifier] = ACTIONS(2465),
    [aux_sym_preproc_include_token1] = ACTIONS(2465),
    [aux_sym_preproc_def_token1] = ACTIONS(2465),
    [aux_sym_preproc_if_token1] = ACTIONS(2465),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2465),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2465),
    [sym_preproc_directive] = ACTIONS(2465),
    [anon_sym_LPAREN2] = ACTIONS(2467),
    [anon_sym_BANG] = ACTIONS(2467),
    [anon_sym_TILDE] = ACTIONS(2467),
    [anon_sym_DASH] = ACTIONS(2465),
    [anon_sym_PLUS] = ACTIONS(2465),
    [anon_sym_STAR] = ACTIONS(2467),
    [anon_sym_AMP_AMP] = ACTIONS(2467),
    [anon_sym_AMP] = ACTIONS(2465),
    [anon_sym___extension__] = ACTIONS(2465),
    [anon_sym_typedef] = ACTIONS(2465),
    [anon_sym___device__] = ACTIONS(2465),
    [anon_sym___host__] = ACTIONS(2465),
    [anon_sym___global__] = ACTIONS(2465),
    [anon_sym___forceinline__] = ACTIONS(2465),
    [anon_sym___noinline__] = ACTIONS(2465),
    [anon_sym_extern] = ACTIONS(2465),
    [anon_sym___attribute__] = ACTIONS(2465),
    [anon_sym_COLON_COLON] = ACTIONS(2467),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2467),
    [anon_sym___declspec] = ACTIONS(2465),
    [anon_sym___based] = ACTIONS(2465),
    [anon_sym___cdecl] = ACTIONS(2465),
    [anon_sym___clrcall] = ACTIONS(2465),
    [anon_sym___stdcall] = ACTIONS(2465),
    [anon_sym___fastcall] = ACTIONS(2465),
    [anon_sym___thiscall] = ACTIONS(2465),
    [anon_sym___vectorcall] = ACTIONS(2465),
    [anon_sym_LBRACE] = ACTIONS(2467),
    [anon_sym_signed] = ACTIONS(2465),
    [anon_sym_unsigned] = ACTIONS(2465),
    [anon_sym_long] = ACTIONS(2465),
    [anon_sym_short] = ACTIONS(2465),
    [anon_sym_LBRACK] = ACTIONS(2465),
    [anon_sym_static] = ACTIONS(2465),
    [anon_sym_register] = ACTIONS(2465),
    [anon_sym_inline] = ACTIONS(2465),
    [anon_sym___inline] = ACTIONS(2465),
    [anon_sym___inline__] = ACTIONS(2465),
    [anon_sym___forceinline] = ACTIONS(2465),
    [anon_sym_thread_local] = ACTIONS(2465),
    [anon_sym___thread] = ACTIONS(2465),
    [anon_sym_const] = ACTIONS(2465),
    [anon_sym_constexpr] = ACTIONS(2465),
    [anon_sym_volatile] = ACTIONS(2465),
    [anon_sym_restrict] = ACTIONS(2465),
    [anon_sym___restrict__] = ACTIONS(2465),
    [anon_sym__Atomic] = ACTIONS(2465),
    [anon_sym__Noreturn] = ACTIONS(2465),
    [anon_sym_noreturn] = ACTIONS(2465),
    [anon_sym_mutable] = ACTIONS(2465),
    [anon_sym_constinit] = ACTIONS(2465),
    [anon_sym_consteval] = ACTIONS(2465),
    [anon_sym___shared__] = ACTIONS(2465),
    [anon_sym___local__] = ACTIONS(2465),
    [anon_sym___constant__] = ACTIONS(2465),
    [anon_sym___managed__] = ACTIONS(2465),
    [anon_sym___grid_constant__] = ACTIONS(2465),
    [anon_sym_alignas] = ACTIONS(2465),
    [anon_sym__Alignas] = ACTIONS(2465),
    [sym_primitive_type] = ACTIONS(2465),
    [anon_sym_enum] = ACTIONS(2465),
    [anon_sym_class] = ACTIONS(2465),
    [anon_sym_struct] = ACTIONS(2465),
    [anon_sym_union] = ACTIONS(2465),
    [anon_sym_if] = ACTIONS(2465),
    [anon_sym_switch] = ACTIONS(2465),
    [anon_sym_case] = ACTIONS(2465),
    [anon_sym_default] = ACTIONS(2465),
    [anon_sym_while] = ACTIONS(2465),
    [anon_sym_do] = ACTIONS(2465),
    [anon_sym_for] = ACTIONS(2465),
    [anon_sym_return] = ACTIONS(2465),
    [anon_sym_break] = ACTIONS(2465),
    [anon_sym_continue] = ACTIONS(2465),
    [anon_sym_goto] = ACTIONS(2465),
    [anon_sym_not] = ACTIONS(2465),
    [anon_sym_compl] = ACTIONS(2465),
    [anon_sym_DASH_DASH] = ACTIONS(2467),
    [anon_sym_PLUS_PLUS] = ACTIONS(2467),
    [anon_sym_sizeof] = ACTIONS(2465),
    [anon_sym___alignof__] = ACTIONS(2465),
    [anon_sym___alignof] = ACTIONS(2465),
    [anon_sym__alignof] = ACTIONS(2465),
    [anon_sym_alignof] = ACTIONS(2465),
    [anon_sym__Alignof] = ACTIONS(2465),
    [anon_sym_offsetof] = ACTIONS(2465),
    [anon_sym__Generic] = ACTIONS(2465),
    [anon_sym_asm] = ACTIONS(2465),
    [anon_sym___asm__] = ACTIONS(2465),
    [sym_number_literal] = ACTIONS(2467),
    [anon_sym_L_SQUOTE] = ACTIONS(2467),
    [anon_sym_u_SQUOTE] = ACTIONS(2467),
    [anon_sym_U_SQUOTE] = ACTIONS(2467),
    [anon_sym_u8_SQUOTE] = ACTIONS(2467),
    [anon_sym_SQUOTE] = ACTIONS(2467),
    [anon_sym_L_DQUOTE] = ACTIONS(2467),
    [anon_sym_u_DQUOTE] = ACTIONS(2467),
    [anon_sym_U_DQUOTE] = ACTIONS(2467),
    [anon_sym_u8_DQUOTE] = ACTIONS(2467),
    [anon_sym_DQUOTE] = ACTIONS(2467),
    [sym_true] = ACTIONS(2465),
    [sym_false] = ACTIONS(2465),
    [anon_sym_NULL] = ACTIONS(2465),
    [anon_sym_nullptr] = ACTIONS(2465),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2465),
    [anon_sym_decltype] = ACTIONS(2465),
    [sym_virtual] = ACTIONS(2465),
    [anon_sym_explicit] = ACTIONS(2465),
    [anon_sym_typename] = ACTIONS(2465),
    [anon_sym_template] = ACTIONS(2465),
    [anon_sym_operator] = ACTIONS(2465),
    [anon_sym_try] = ACTIONS(2465),
    [anon_sym_delete] = ACTIONS(2465),
    [anon_sym_throw] = ACTIONS(2465),
    [anon_sym_namespace] = ACTIONS(2465),
    [anon_sym_using] = ACTIONS(2465),
    [anon_sym_static_assert] = ACTIONS(2465),
    [anon_sym_concept] = ACTIONS(2465),
    [anon_sym_co_return] = ACTIONS(2465),
    [anon_sym_co_yield] = ACTIONS(2465),
    [anon_sym_R_DQUOTE] = ACTIONS(2467),
    [anon_sym_LR_DQUOTE] = ACTIONS(2467),
    [anon_sym_uR_DQUOTE] = ACTIONS(2467),
    [anon_sym_UR_DQUOTE] = ACTIONS(2467),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2467),
    [anon_sym_co_await] = ACTIONS(2465),
    [anon_sym_new] = ACTIONS(2465),
    [anon_sym_requires] = ACTIONS(2465),
    [sym_this] = ACTIONS(2465),
    [anon_sym___launch_bounds__] = ACTIONS(2465),
  },
  [756] = {
    [ts_builtin_sym_end] = ACTIONS(3500),
    [sym_identifier] = ACTIONS(3502),
    [aux_sym_preproc_include_token1] = ACTIONS(3502),
    [aux_sym_preproc_def_token1] = ACTIONS(3502),
    [aux_sym_preproc_if_token1] = ACTIONS(3502),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3502),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3502),
    [sym_preproc_directive] = ACTIONS(3502),
    [anon_sym_LPAREN2] = ACTIONS(3500),
    [anon_sym_BANG] = ACTIONS(3500),
    [anon_sym_TILDE] = ACTIONS(3500),
    [anon_sym_DASH] = ACTIONS(3502),
    [anon_sym_PLUS] = ACTIONS(3502),
    [anon_sym_STAR] = ACTIONS(3500),
    [anon_sym_AMP_AMP] = ACTIONS(3500),
    [anon_sym_AMP] = ACTIONS(3502),
    [anon_sym___extension__] = ACTIONS(3502),
    [anon_sym_typedef] = ACTIONS(3502),
    [anon_sym___device__] = ACTIONS(3502),
    [anon_sym___host__] = ACTIONS(3502),
    [anon_sym___global__] = ACTIONS(3502),
    [anon_sym___forceinline__] = ACTIONS(3502),
    [anon_sym___noinline__] = ACTIONS(3502),
    [anon_sym_extern] = ACTIONS(3502),
    [anon_sym___attribute__] = ACTIONS(3502),
    [anon_sym_COLON_COLON] = ACTIONS(3500),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3500),
    [anon_sym___declspec] = ACTIONS(3502),
    [anon_sym___based] = ACTIONS(3502),
    [anon_sym___cdecl] = ACTIONS(3502),
    [anon_sym___clrcall] = ACTIONS(3502),
    [anon_sym___stdcall] = ACTIONS(3502),
    [anon_sym___fastcall] = ACTIONS(3502),
    [anon_sym___thiscall] = ACTIONS(3502),
    [anon_sym___vectorcall] = ACTIONS(3502),
    [anon_sym_LBRACE] = ACTIONS(3500),
    [anon_sym_signed] = ACTIONS(3502),
    [anon_sym_unsigned] = ACTIONS(3502),
    [anon_sym_long] = ACTIONS(3502),
    [anon_sym_short] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(3502),
    [anon_sym_static] = ACTIONS(3502),
    [anon_sym_register] = ACTIONS(3502),
    [anon_sym_inline] = ACTIONS(3502),
    [anon_sym___inline] = ACTIONS(3502),
    [anon_sym___inline__] = ACTIONS(3502),
    [anon_sym___forceinline] = ACTIONS(3502),
    [anon_sym_thread_local] = ACTIONS(3502),
    [anon_sym___thread] = ACTIONS(3502),
    [anon_sym_const] = ACTIONS(3502),
    [anon_sym_constexpr] = ACTIONS(3502),
    [anon_sym_volatile] = ACTIONS(3502),
    [anon_sym_restrict] = ACTIONS(3502),
    [anon_sym___restrict__] = ACTIONS(3502),
    [anon_sym__Atomic] = ACTIONS(3502),
    [anon_sym__Noreturn] = ACTIONS(3502),
    [anon_sym_noreturn] = ACTIONS(3502),
    [anon_sym_mutable] = ACTIONS(3502),
    [anon_sym_constinit] = ACTIONS(3502),
    [anon_sym_consteval] = ACTIONS(3502),
    [anon_sym___shared__] = ACTIONS(3502),
    [anon_sym___local__] = ACTIONS(3502),
    [anon_sym___constant__] = ACTIONS(3502),
    [anon_sym___managed__] = ACTIONS(3502),
    [anon_sym___grid_constant__] = ACTIONS(3502),
    [anon_sym_alignas] = ACTIONS(3502),
    [anon_sym__Alignas] = ACTIONS(3502),
    [sym_primitive_type] = ACTIONS(3502),
    [anon_sym_enum] = ACTIONS(3502),
    [anon_sym_class] = ACTIONS(3502),
    [anon_sym_struct] = ACTIONS(3502),
    [anon_sym_union] = ACTIONS(3502),
    [anon_sym_if] = ACTIONS(3502),
    [anon_sym_switch] = ACTIONS(3502),
    [anon_sym_case] = ACTIONS(3502),
    [anon_sym_default] = ACTIONS(3502),
    [anon_sym_while] = ACTIONS(3502),
    [anon_sym_do] = ACTIONS(3502),
    [anon_sym_for] = ACTIONS(3502),
    [anon_sym_return] = ACTIONS(3502),
    [anon_sym_break] = ACTIONS(3502),
    [anon_sym_continue] = ACTIONS(3502),
    [anon_sym_goto] = ACTIONS(3502),
    [anon_sym_not] = ACTIONS(3502),
    [anon_sym_compl] = ACTIONS(3502),
    [anon_sym_DASH_DASH] = ACTIONS(3500),
    [anon_sym_PLUS_PLUS] = ACTIONS(3500),
    [anon_sym_sizeof] = ACTIONS(3502),
    [anon_sym___alignof__] = ACTIONS(3502),
    [anon_sym___alignof] = ACTIONS(3502),
    [anon_sym__alignof] = ACTIONS(3502),
    [anon_sym_alignof] = ACTIONS(3502),
    [anon_sym__Alignof] = ACTIONS(3502),
    [anon_sym_offsetof] = ACTIONS(3502),
    [anon_sym__Generic] = ACTIONS(3502),
    [anon_sym_asm] = ACTIONS(3502),
    [anon_sym___asm__] = ACTIONS(3502),
    [sym_number_literal] = ACTIONS(3500),
    [anon_sym_L_SQUOTE] = ACTIONS(3500),
    [anon_sym_u_SQUOTE] = ACTIONS(3500),
    [anon_sym_U_SQUOTE] = ACTIONS(3500),
    [anon_sym_u8_SQUOTE] = ACTIONS(3500),
    [anon_sym_SQUOTE] = ACTIONS(3500),
    [anon_sym_L_DQUOTE] = ACTIONS(3500),
    [anon_sym_u_DQUOTE] = ACTIONS(3500),
    [anon_sym_U_DQUOTE] = ACTIONS(3500),
    [anon_sym_u8_DQUOTE] = ACTIONS(3500),
    [anon_sym_DQUOTE] = ACTIONS(3500),
    [sym_true] = ACTIONS(3502),
    [sym_false] = ACTIONS(3502),
    [anon_sym_NULL] = ACTIONS(3502),
    [anon_sym_nullptr] = ACTIONS(3502),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3502),
    [anon_sym_decltype] = ACTIONS(3502),
    [sym_virtual] = ACTIONS(3502),
    [anon_sym_explicit] = ACTIONS(3502),
    [anon_sym_typename] = ACTIONS(3502),
    [anon_sym_template] = ACTIONS(3502),
    [anon_sym_operator] = ACTIONS(3502),
    [anon_sym_try] = ACTIONS(3502),
    [anon_sym_delete] = ACTIONS(3502),
    [anon_sym_throw] = ACTIONS(3502),
    [anon_sym_namespace] = ACTIONS(3502),
    [anon_sym_using] = ACTIONS(3502),
    [anon_sym_static_assert] = ACTIONS(3502),
    [anon_sym_concept] = ACTIONS(3502),
    [anon_sym_co_return] = ACTIONS(3502),
    [anon_sym_co_yield] = ACTIONS(3502),
    [anon_sym_R_DQUOTE] = ACTIONS(3500),
    [anon_sym_LR_DQUOTE] = ACTIONS(3500),
    [anon_sym_uR_DQUOTE] = ACTIONS(3500),
    [anon_sym_UR_DQUOTE] = ACTIONS(3500),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3500),
    [anon_sym_co_await] = ACTIONS(3502),
    [anon_sym_new] = ACTIONS(3502),
    [anon_sym_requires] = ACTIONS(3502),
    [sym_this] = ACTIONS(3502),
    [anon_sym___launch_bounds__] = ACTIONS(3502),
  },
  [757] = {
    [ts_builtin_sym_end] = ACTIONS(2174),
    [sym_identifier] = ACTIONS(2172),
    [aux_sym_preproc_include_token1] = ACTIONS(2172),
    [aux_sym_preproc_def_token1] = ACTIONS(2172),
    [aux_sym_preproc_if_token1] = ACTIONS(2172),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2172),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2172),
    [sym_preproc_directive] = ACTIONS(2172),
    [anon_sym_LPAREN2] = ACTIONS(2174),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2174),
    [anon_sym_DASH] = ACTIONS(2172),
    [anon_sym_PLUS] = ACTIONS(2172),
    [anon_sym_STAR] = ACTIONS(2174),
    [anon_sym_AMP_AMP] = ACTIONS(2174),
    [anon_sym_AMP] = ACTIONS(2172),
    [anon_sym___extension__] = ACTIONS(2172),
    [anon_sym_typedef] = ACTIONS(2172),
    [anon_sym___device__] = ACTIONS(2172),
    [anon_sym___host__] = ACTIONS(2172),
    [anon_sym___global__] = ACTIONS(2172),
    [anon_sym___forceinline__] = ACTIONS(2172),
    [anon_sym___noinline__] = ACTIONS(2172),
    [anon_sym_extern] = ACTIONS(2172),
    [anon_sym___attribute__] = ACTIONS(2172),
    [anon_sym_COLON_COLON] = ACTIONS(2174),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2174),
    [anon_sym___declspec] = ACTIONS(2172),
    [anon_sym___based] = ACTIONS(2172),
    [anon_sym___cdecl] = ACTIONS(2172),
    [anon_sym___clrcall] = ACTIONS(2172),
    [anon_sym___stdcall] = ACTIONS(2172),
    [anon_sym___fastcall] = ACTIONS(2172),
    [anon_sym___thiscall] = ACTIONS(2172),
    [anon_sym___vectorcall] = ACTIONS(2172),
    [anon_sym_LBRACE] = ACTIONS(2174),
    [anon_sym_signed] = ACTIONS(2172),
    [anon_sym_unsigned] = ACTIONS(2172),
    [anon_sym_long] = ACTIONS(2172),
    [anon_sym_short] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2172),
    [anon_sym_static] = ACTIONS(2172),
    [anon_sym_register] = ACTIONS(2172),
    [anon_sym_inline] = ACTIONS(2172),
    [anon_sym___inline] = ACTIONS(2172),
    [anon_sym___inline__] = ACTIONS(2172),
    [anon_sym___forceinline] = ACTIONS(2172),
    [anon_sym_thread_local] = ACTIONS(2172),
    [anon_sym___thread] = ACTIONS(2172),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_constexpr] = ACTIONS(2172),
    [anon_sym_volatile] = ACTIONS(2172),
    [anon_sym_restrict] = ACTIONS(2172),
    [anon_sym___restrict__] = ACTIONS(2172),
    [anon_sym__Atomic] = ACTIONS(2172),
    [anon_sym__Noreturn] = ACTIONS(2172),
    [anon_sym_noreturn] = ACTIONS(2172),
    [anon_sym_mutable] = ACTIONS(2172),
    [anon_sym_constinit] = ACTIONS(2172),
    [anon_sym_consteval] = ACTIONS(2172),
    [anon_sym___shared__] = ACTIONS(2172),
    [anon_sym___local__] = ACTIONS(2172),
    [anon_sym___constant__] = ACTIONS(2172),
    [anon_sym___managed__] = ACTIONS(2172),
    [anon_sym___grid_constant__] = ACTIONS(2172),
    [anon_sym_alignas] = ACTIONS(2172),
    [anon_sym__Alignas] = ACTIONS(2172),
    [sym_primitive_type] = ACTIONS(2172),
    [anon_sym_enum] = ACTIONS(2172),
    [anon_sym_class] = ACTIONS(2172),
    [anon_sym_struct] = ACTIONS(2172),
    [anon_sym_union] = ACTIONS(2172),
    [anon_sym_if] = ACTIONS(2172),
    [anon_sym_switch] = ACTIONS(2172),
    [anon_sym_case] = ACTIONS(2172),
    [anon_sym_default] = ACTIONS(2172),
    [anon_sym_while] = ACTIONS(2172),
    [anon_sym_do] = ACTIONS(2172),
    [anon_sym_for] = ACTIONS(2172),
    [anon_sym_return] = ACTIONS(2172),
    [anon_sym_break] = ACTIONS(2172),
    [anon_sym_continue] = ACTIONS(2172),
    [anon_sym_goto] = ACTIONS(2172),
    [anon_sym_not] = ACTIONS(2172),
    [anon_sym_compl] = ACTIONS(2172),
    [anon_sym_DASH_DASH] = ACTIONS(2174),
    [anon_sym_PLUS_PLUS] = ACTIONS(2174),
    [anon_sym_sizeof] = ACTIONS(2172),
    [anon_sym___alignof__] = ACTIONS(2172),
    [anon_sym___alignof] = ACTIONS(2172),
    [anon_sym__alignof] = ACTIONS(2172),
    [anon_sym_alignof] = ACTIONS(2172),
    [anon_sym__Alignof] = ACTIONS(2172),
    [anon_sym_offsetof] = ACTIONS(2172),
    [anon_sym__Generic] = ACTIONS(2172),
    [anon_sym_asm] = ACTIONS(2172),
    [anon_sym___asm__] = ACTIONS(2172),
    [sym_number_literal] = ACTIONS(2174),
    [anon_sym_L_SQUOTE] = ACTIONS(2174),
    [anon_sym_u_SQUOTE] = ACTIONS(2174),
    [anon_sym_U_SQUOTE] = ACTIONS(2174),
    [anon_sym_u8_SQUOTE] = ACTIONS(2174),
    [anon_sym_SQUOTE] = ACTIONS(2174),
    [anon_sym_L_DQUOTE] = ACTIONS(2174),
    [anon_sym_u_DQUOTE] = ACTIONS(2174),
    [anon_sym_U_DQUOTE] = ACTIONS(2174),
    [anon_sym_u8_DQUOTE] = ACTIONS(2174),
    [anon_sym_DQUOTE] = ACTIONS(2174),
    [sym_true] = ACTIONS(2172),
    [sym_false] = ACTIONS(2172),
    [anon_sym_NULL] = ACTIONS(2172),
    [anon_sym_nullptr] = ACTIONS(2172),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2172),
    [anon_sym_decltype] = ACTIONS(2172),
    [sym_virtual] = ACTIONS(2172),
    [anon_sym_explicit] = ACTIONS(2172),
    [anon_sym_typename] = ACTIONS(2172),
    [anon_sym_template] = ACTIONS(2172),
    [anon_sym_operator] = ACTIONS(2172),
    [anon_sym_try] = ACTIONS(2172),
    [anon_sym_delete] = ACTIONS(2172),
    [anon_sym_throw] = ACTIONS(2172),
    [anon_sym_namespace] = ACTIONS(2172),
    [anon_sym_using] = ACTIONS(2172),
    [anon_sym_static_assert] = ACTIONS(2172),
    [anon_sym_concept] = ACTIONS(2172),
    [anon_sym_co_return] = ACTIONS(2172),
    [anon_sym_co_yield] = ACTIONS(2172),
    [anon_sym_R_DQUOTE] = ACTIONS(2174),
    [anon_sym_LR_DQUOTE] = ACTIONS(2174),
    [anon_sym_uR_DQUOTE] = ACTIONS(2174),
    [anon_sym_UR_DQUOTE] = ACTIONS(2174),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2174),
    [anon_sym_co_await] = ACTIONS(2172),
    [anon_sym_new] = ACTIONS(2172),
    [anon_sym_requires] = ACTIONS(2172),
    [sym_this] = ACTIONS(2172),
    [anon_sym___launch_bounds__] = ACTIONS(2172),
  },
  [758] = {
    [ts_builtin_sym_end] = ACTIONS(2233),
    [sym_identifier] = ACTIONS(2231),
    [aux_sym_preproc_include_token1] = ACTIONS(2231),
    [aux_sym_preproc_def_token1] = ACTIONS(2231),
    [aux_sym_preproc_if_token1] = ACTIONS(2231),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2231),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2231),
    [sym_preproc_directive] = ACTIONS(2231),
    [anon_sym_LPAREN2] = ACTIONS(2233),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym___extension__] = ACTIONS(2231),
    [anon_sym_typedef] = ACTIONS(2231),
    [anon_sym___device__] = ACTIONS(2231),
    [anon_sym___host__] = ACTIONS(2231),
    [anon_sym___global__] = ACTIONS(2231),
    [anon_sym___forceinline__] = ACTIONS(2231),
    [anon_sym___noinline__] = ACTIONS(2231),
    [anon_sym_extern] = ACTIONS(2231),
    [anon_sym___attribute__] = ACTIONS(2231),
    [anon_sym_COLON_COLON] = ACTIONS(2233),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2233),
    [anon_sym___declspec] = ACTIONS(2231),
    [anon_sym___based] = ACTIONS(2231),
    [anon_sym___cdecl] = ACTIONS(2231),
    [anon_sym___clrcall] = ACTIONS(2231),
    [anon_sym___stdcall] = ACTIONS(2231),
    [anon_sym___fastcall] = ACTIONS(2231),
    [anon_sym___thiscall] = ACTIONS(2231),
    [anon_sym___vectorcall] = ACTIONS(2231),
    [anon_sym_LBRACE] = ACTIONS(2233),
    [anon_sym_signed] = ACTIONS(2231),
    [anon_sym_unsigned] = ACTIONS(2231),
    [anon_sym_long] = ACTIONS(2231),
    [anon_sym_short] = ACTIONS(2231),
    [anon_sym_LBRACK] = ACTIONS(2231),
    [anon_sym_static] = ACTIONS(2231),
    [anon_sym_register] = ACTIONS(2231),
    [anon_sym_inline] = ACTIONS(2231),
    [anon_sym___inline] = ACTIONS(2231),
    [anon_sym___inline__] = ACTIONS(2231),
    [anon_sym___forceinline] = ACTIONS(2231),
    [anon_sym_thread_local] = ACTIONS(2231),
    [anon_sym___thread] = ACTIONS(2231),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_constexpr] = ACTIONS(2231),
    [anon_sym_volatile] = ACTIONS(2231),
    [anon_sym_restrict] = ACTIONS(2231),
    [anon_sym___restrict__] = ACTIONS(2231),
    [anon_sym__Atomic] = ACTIONS(2231),
    [anon_sym__Noreturn] = ACTIONS(2231),
    [anon_sym_noreturn] = ACTIONS(2231),
    [anon_sym_mutable] = ACTIONS(2231),
    [anon_sym_constinit] = ACTIONS(2231),
    [anon_sym_consteval] = ACTIONS(2231),
    [anon_sym___shared__] = ACTIONS(2231),
    [anon_sym___local__] = ACTIONS(2231),
    [anon_sym___constant__] = ACTIONS(2231),
    [anon_sym___managed__] = ACTIONS(2231),
    [anon_sym___grid_constant__] = ACTIONS(2231),
    [anon_sym_alignas] = ACTIONS(2231),
    [anon_sym__Alignas] = ACTIONS(2231),
    [sym_primitive_type] = ACTIONS(2231),
    [anon_sym_enum] = ACTIONS(2231),
    [anon_sym_class] = ACTIONS(2231),
    [anon_sym_struct] = ACTIONS(2231),
    [anon_sym_union] = ACTIONS(2231),
    [anon_sym_if] = ACTIONS(2231),
    [anon_sym_switch] = ACTIONS(2231),
    [anon_sym_case] = ACTIONS(2231),
    [anon_sym_default] = ACTIONS(2231),
    [anon_sym_while] = ACTIONS(2231),
    [anon_sym_do] = ACTIONS(2231),
    [anon_sym_for] = ACTIONS(2231),
    [anon_sym_return] = ACTIONS(2231),
    [anon_sym_break] = ACTIONS(2231),
    [anon_sym_continue] = ACTIONS(2231),
    [anon_sym_goto] = ACTIONS(2231),
    [anon_sym_not] = ACTIONS(2231),
    [anon_sym_compl] = ACTIONS(2231),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_sizeof] = ACTIONS(2231),
    [anon_sym___alignof__] = ACTIONS(2231),
    [anon_sym___alignof] = ACTIONS(2231),
    [anon_sym__alignof] = ACTIONS(2231),
    [anon_sym_alignof] = ACTIONS(2231),
    [anon_sym__Alignof] = ACTIONS(2231),
    [anon_sym_offsetof] = ACTIONS(2231),
    [anon_sym__Generic] = ACTIONS(2231),
    [anon_sym_asm] = ACTIONS(2231),
    [anon_sym___asm__] = ACTIONS(2231),
    [sym_number_literal] = ACTIONS(2233),
    [anon_sym_L_SQUOTE] = ACTIONS(2233),
    [anon_sym_u_SQUOTE] = ACTIONS(2233),
    [anon_sym_U_SQUOTE] = ACTIONS(2233),
    [anon_sym_u8_SQUOTE] = ACTIONS(2233),
    [anon_sym_SQUOTE] = ACTIONS(2233),
    [anon_sym_L_DQUOTE] = ACTIONS(2233),
    [anon_sym_u_DQUOTE] = ACTIONS(2233),
    [anon_sym_U_DQUOTE] = ACTIONS(2233),
    [anon_sym_u8_DQUOTE] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(2233),
    [sym_true] = ACTIONS(2231),
    [sym_false] = ACTIONS(2231),
    [anon_sym_NULL] = ACTIONS(2231),
    [anon_sym_nullptr] = ACTIONS(2231),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2231),
    [anon_sym_decltype] = ACTIONS(2231),
    [sym_virtual] = ACTIONS(2231),
    [anon_sym_explicit] = ACTIONS(2231),
    [anon_sym_typename] = ACTIONS(2231),
    [anon_sym_template] = ACTIONS(2231),
    [anon_sym_operator] = ACTIONS(2231),
    [anon_sym_try] = ACTIONS(2231),
    [anon_sym_delete] = ACTIONS(2231),
    [anon_sym_throw] = ACTIONS(2231),
    [anon_sym_namespace] = ACTIONS(2231),
    [anon_sym_using] = ACTIONS(2231),
    [anon_sym_static_assert] = ACTIONS(2231),
    [anon_sym_concept] = ACTIONS(2231),
    [anon_sym_co_return] = ACTIONS(2231),
    [anon_sym_co_yield] = ACTIONS(2231),
    [anon_sym_R_DQUOTE] = ACTIONS(2233),
    [anon_sym_LR_DQUOTE] = ACTIONS(2233),
    [anon_sym_uR_DQUOTE] = ACTIONS(2233),
    [anon_sym_UR_DQUOTE] = ACTIONS(2233),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2233),
    [anon_sym_co_await] = ACTIONS(2231),
    [anon_sym_new] = ACTIONS(2231),
    [anon_sym_requires] = ACTIONS(2231),
    [sym_this] = ACTIONS(2231),
    [anon_sym___launch_bounds__] = ACTIONS(2231),
  },
  [759] = {
    [ts_builtin_sym_end] = ACTIONS(2475),
    [sym_identifier] = ACTIONS(2473),
    [aux_sym_preproc_include_token1] = ACTIONS(2473),
    [aux_sym_preproc_def_token1] = ACTIONS(2473),
    [aux_sym_preproc_if_token1] = ACTIONS(2473),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2473),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2473),
    [sym_preproc_directive] = ACTIONS(2473),
    [anon_sym_LPAREN2] = ACTIONS(2475),
    [anon_sym_BANG] = ACTIONS(2475),
    [anon_sym_TILDE] = ACTIONS(2475),
    [anon_sym_DASH] = ACTIONS(2473),
    [anon_sym_PLUS] = ACTIONS(2473),
    [anon_sym_STAR] = ACTIONS(2475),
    [anon_sym_AMP_AMP] = ACTIONS(2475),
    [anon_sym_AMP] = ACTIONS(2473),
    [anon_sym___extension__] = ACTIONS(2473),
    [anon_sym_typedef] = ACTIONS(2473),
    [anon_sym___device__] = ACTIONS(2473),
    [anon_sym___host__] = ACTIONS(2473),
    [anon_sym___global__] = ACTIONS(2473),
    [anon_sym___forceinline__] = ACTIONS(2473),
    [anon_sym___noinline__] = ACTIONS(2473),
    [anon_sym_extern] = ACTIONS(2473),
    [anon_sym___attribute__] = ACTIONS(2473),
    [anon_sym_COLON_COLON] = ACTIONS(2475),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2475),
    [anon_sym___declspec] = ACTIONS(2473),
    [anon_sym___based] = ACTIONS(2473),
    [anon_sym___cdecl] = ACTIONS(2473),
    [anon_sym___clrcall] = ACTIONS(2473),
    [anon_sym___stdcall] = ACTIONS(2473),
    [anon_sym___fastcall] = ACTIONS(2473),
    [anon_sym___thiscall] = ACTIONS(2473),
    [anon_sym___vectorcall] = ACTIONS(2473),
    [anon_sym_LBRACE] = ACTIONS(2475),
    [anon_sym_signed] = ACTIONS(2473),
    [anon_sym_unsigned] = ACTIONS(2473),
    [anon_sym_long] = ACTIONS(2473),
    [anon_sym_short] = ACTIONS(2473),
    [anon_sym_LBRACK] = ACTIONS(2473),
    [anon_sym_static] = ACTIONS(2473),
    [anon_sym_register] = ACTIONS(2473),
    [anon_sym_inline] = ACTIONS(2473),
    [anon_sym___inline] = ACTIONS(2473),
    [anon_sym___inline__] = ACTIONS(2473),
    [anon_sym___forceinline] = ACTIONS(2473),
    [anon_sym_thread_local] = ACTIONS(2473),
    [anon_sym___thread] = ACTIONS(2473),
    [anon_sym_const] = ACTIONS(2473),
    [anon_sym_constexpr] = ACTIONS(2473),
    [anon_sym_volatile] = ACTIONS(2473),
    [anon_sym_restrict] = ACTIONS(2473),
    [anon_sym___restrict__] = ACTIONS(2473),
    [anon_sym__Atomic] = ACTIONS(2473),
    [anon_sym__Noreturn] = ACTIONS(2473),
    [anon_sym_noreturn] = ACTIONS(2473),
    [anon_sym_mutable] = ACTIONS(2473),
    [anon_sym_constinit] = ACTIONS(2473),
    [anon_sym_consteval] = ACTIONS(2473),
    [anon_sym___shared__] = ACTIONS(2473),
    [anon_sym___local__] = ACTIONS(2473),
    [anon_sym___constant__] = ACTIONS(2473),
    [anon_sym___managed__] = ACTIONS(2473),
    [anon_sym___grid_constant__] = ACTIONS(2473),
    [anon_sym_alignas] = ACTIONS(2473),
    [anon_sym__Alignas] = ACTIONS(2473),
    [sym_primitive_type] = ACTIONS(2473),
    [anon_sym_enum] = ACTIONS(2473),
    [anon_sym_class] = ACTIONS(2473),
    [anon_sym_struct] = ACTIONS(2473),
    [anon_sym_union] = ACTIONS(2473),
    [anon_sym_if] = ACTIONS(2473),
    [anon_sym_switch] = ACTIONS(2473),
    [anon_sym_case] = ACTIONS(2473),
    [anon_sym_default] = ACTIONS(2473),
    [anon_sym_while] = ACTIONS(2473),
    [anon_sym_do] = ACTIONS(2473),
    [anon_sym_for] = ACTIONS(2473),
    [anon_sym_return] = ACTIONS(2473),
    [anon_sym_break] = ACTIONS(2473),
    [anon_sym_continue] = ACTIONS(2473),
    [anon_sym_goto] = ACTIONS(2473),
    [anon_sym_not] = ACTIONS(2473),
    [anon_sym_compl] = ACTIONS(2473),
    [anon_sym_DASH_DASH] = ACTIONS(2475),
    [anon_sym_PLUS_PLUS] = ACTIONS(2475),
    [anon_sym_sizeof] = ACTIONS(2473),
    [anon_sym___alignof__] = ACTIONS(2473),
    [anon_sym___alignof] = ACTIONS(2473),
    [anon_sym__alignof] = ACTIONS(2473),
    [anon_sym_alignof] = ACTIONS(2473),
    [anon_sym__Alignof] = ACTIONS(2473),
    [anon_sym_offsetof] = ACTIONS(2473),
    [anon_sym__Generic] = ACTIONS(2473),
    [anon_sym_asm] = ACTIONS(2473),
    [anon_sym___asm__] = ACTIONS(2473),
    [sym_number_literal] = ACTIONS(2475),
    [anon_sym_L_SQUOTE] = ACTIONS(2475),
    [anon_sym_u_SQUOTE] = ACTIONS(2475),
    [anon_sym_U_SQUOTE] = ACTIONS(2475),
    [anon_sym_u8_SQUOTE] = ACTIONS(2475),
    [anon_sym_SQUOTE] = ACTIONS(2475),
    [anon_sym_L_DQUOTE] = ACTIONS(2475),
    [anon_sym_u_DQUOTE] = ACTIONS(2475),
    [anon_sym_U_DQUOTE] = ACTIONS(2475),
    [anon_sym_u8_DQUOTE] = ACTIONS(2475),
    [anon_sym_DQUOTE] = ACTIONS(2475),
    [sym_true] = ACTIONS(2473),
    [sym_false] = ACTIONS(2473),
    [anon_sym_NULL] = ACTIONS(2473),
    [anon_sym_nullptr] = ACTIONS(2473),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2473),
    [anon_sym_decltype] = ACTIONS(2473),
    [sym_virtual] = ACTIONS(2473),
    [anon_sym_explicit] = ACTIONS(2473),
    [anon_sym_typename] = ACTIONS(2473),
    [anon_sym_template] = ACTIONS(2473),
    [anon_sym_operator] = ACTIONS(2473),
    [anon_sym_try] = ACTIONS(2473),
    [anon_sym_delete] = ACTIONS(2473),
    [anon_sym_throw] = ACTIONS(2473),
    [anon_sym_namespace] = ACTIONS(2473),
    [anon_sym_using] = ACTIONS(2473),
    [anon_sym_static_assert] = ACTIONS(2473),
    [anon_sym_concept] = ACTIONS(2473),
    [anon_sym_co_return] = ACTIONS(2473),
    [anon_sym_co_yield] = ACTIONS(2473),
    [anon_sym_R_DQUOTE] = ACTIONS(2475),
    [anon_sym_LR_DQUOTE] = ACTIONS(2475),
    [anon_sym_uR_DQUOTE] = ACTIONS(2475),
    [anon_sym_UR_DQUOTE] = ACTIONS(2475),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2475),
    [anon_sym_co_await] = ACTIONS(2473),
    [anon_sym_new] = ACTIONS(2473),
    [anon_sym_requires] = ACTIONS(2473),
    [sym_this] = ACTIONS(2473),
    [anon_sym___launch_bounds__] = ACTIONS(2473),
  },
  [760] = {
    [ts_builtin_sym_end] = ACTIONS(2223),
    [sym_identifier] = ACTIONS(2221),
    [aux_sym_preproc_include_token1] = ACTIONS(2221),
    [aux_sym_preproc_def_token1] = ACTIONS(2221),
    [aux_sym_preproc_if_token1] = ACTIONS(2221),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2221),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2221),
    [sym_preproc_directive] = ACTIONS(2221),
    [anon_sym_LPAREN2] = ACTIONS(2223),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_TILDE] = ACTIONS(2223),
    [anon_sym_DASH] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym___extension__] = ACTIONS(2221),
    [anon_sym_typedef] = ACTIONS(2221),
    [anon_sym___device__] = ACTIONS(2221),
    [anon_sym___host__] = ACTIONS(2221),
    [anon_sym___global__] = ACTIONS(2221),
    [anon_sym___forceinline__] = ACTIONS(2221),
    [anon_sym___noinline__] = ACTIONS(2221),
    [anon_sym_extern] = ACTIONS(2221),
    [anon_sym___attribute__] = ACTIONS(2221),
    [anon_sym_COLON_COLON] = ACTIONS(2223),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2223),
    [anon_sym___declspec] = ACTIONS(2221),
    [anon_sym___based] = ACTIONS(2221),
    [anon_sym___cdecl] = ACTIONS(2221),
    [anon_sym___clrcall] = ACTIONS(2221),
    [anon_sym___stdcall] = ACTIONS(2221),
    [anon_sym___fastcall] = ACTIONS(2221),
    [anon_sym___thiscall] = ACTIONS(2221),
    [anon_sym___vectorcall] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(2223),
    [anon_sym_signed] = ACTIONS(2221),
    [anon_sym_unsigned] = ACTIONS(2221),
    [anon_sym_long] = ACTIONS(2221),
    [anon_sym_short] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(2221),
    [anon_sym_static] = ACTIONS(2221),
    [anon_sym_register] = ACTIONS(2221),
    [anon_sym_inline] = ACTIONS(2221),
    [anon_sym___inline] = ACTIONS(2221),
    [anon_sym___inline__] = ACTIONS(2221),
    [anon_sym___forceinline] = ACTIONS(2221),
    [anon_sym_thread_local] = ACTIONS(2221),
    [anon_sym___thread] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2221),
    [anon_sym_constexpr] = ACTIONS(2221),
    [anon_sym_volatile] = ACTIONS(2221),
    [anon_sym_restrict] = ACTIONS(2221),
    [anon_sym___restrict__] = ACTIONS(2221),
    [anon_sym__Atomic] = ACTIONS(2221),
    [anon_sym__Noreturn] = ACTIONS(2221),
    [anon_sym_noreturn] = ACTIONS(2221),
    [anon_sym_mutable] = ACTIONS(2221),
    [anon_sym_constinit] = ACTIONS(2221),
    [anon_sym_consteval] = ACTIONS(2221),
    [anon_sym___shared__] = ACTIONS(2221),
    [anon_sym___local__] = ACTIONS(2221),
    [anon_sym___constant__] = ACTIONS(2221),
    [anon_sym___managed__] = ACTIONS(2221),
    [anon_sym___grid_constant__] = ACTIONS(2221),
    [anon_sym_alignas] = ACTIONS(2221),
    [anon_sym__Alignas] = ACTIONS(2221),
    [sym_primitive_type] = ACTIONS(2221),
    [anon_sym_enum] = ACTIONS(2221),
    [anon_sym_class] = ACTIONS(2221),
    [anon_sym_struct] = ACTIONS(2221),
    [anon_sym_union] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2221),
    [anon_sym_switch] = ACTIONS(2221),
    [anon_sym_case] = ACTIONS(2221),
    [anon_sym_default] = ACTIONS(2221),
    [anon_sym_while] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2221),
    [anon_sym_for] = ACTIONS(2221),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_break] = ACTIONS(2221),
    [anon_sym_continue] = ACTIONS(2221),
    [anon_sym_goto] = ACTIONS(2221),
    [anon_sym_not] = ACTIONS(2221),
    [anon_sym_compl] = ACTIONS(2221),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_sizeof] = ACTIONS(2221),
    [anon_sym___alignof__] = ACTIONS(2221),
    [anon_sym___alignof] = ACTIONS(2221),
    [anon_sym__alignof] = ACTIONS(2221),
    [anon_sym_alignof] = ACTIONS(2221),
    [anon_sym__Alignof] = ACTIONS(2221),
    [anon_sym_offsetof] = ACTIONS(2221),
    [anon_sym__Generic] = ACTIONS(2221),
    [anon_sym_asm] = ACTIONS(2221),
    [anon_sym___asm__] = ACTIONS(2221),
    [sym_number_literal] = ACTIONS(2223),
    [anon_sym_L_SQUOTE] = ACTIONS(2223),
    [anon_sym_u_SQUOTE] = ACTIONS(2223),
    [anon_sym_U_SQUOTE] = ACTIONS(2223),
    [anon_sym_u8_SQUOTE] = ACTIONS(2223),
    [anon_sym_SQUOTE] = ACTIONS(2223),
    [anon_sym_L_DQUOTE] = ACTIONS(2223),
    [anon_sym_u_DQUOTE] = ACTIONS(2223),
    [anon_sym_U_DQUOTE] = ACTIONS(2223),
    [anon_sym_u8_DQUOTE] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2223),
    [sym_true] = ACTIONS(2221),
    [sym_false] = ACTIONS(2221),
    [anon_sym_NULL] = ACTIONS(2221),
    [anon_sym_nullptr] = ACTIONS(2221),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2221),
    [anon_sym_decltype] = ACTIONS(2221),
    [sym_virtual] = ACTIONS(2221),
    [anon_sym_explicit] = ACTIONS(2221),
    [anon_sym_typename] = ACTIONS(2221),
    [anon_sym_template] = ACTIONS(2221),
    [anon_sym_operator] = ACTIONS(2221),
    [anon_sym_try] = ACTIONS(2221),
    [anon_sym_delete] = ACTIONS(2221),
    [anon_sym_throw] = ACTIONS(2221),
    [anon_sym_namespace] = ACTIONS(2221),
    [anon_sym_using] = ACTIONS(2221),
    [anon_sym_static_assert] = ACTIONS(2221),
    [anon_sym_concept] = ACTIONS(2221),
    [anon_sym_co_return] = ACTIONS(2221),
    [anon_sym_co_yield] = ACTIONS(2221),
    [anon_sym_R_DQUOTE] = ACTIONS(2223),
    [anon_sym_LR_DQUOTE] = ACTIONS(2223),
    [anon_sym_uR_DQUOTE] = ACTIONS(2223),
    [anon_sym_UR_DQUOTE] = ACTIONS(2223),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2223),
    [anon_sym_co_await] = ACTIONS(2221),
    [anon_sym_new] = ACTIONS(2221),
    [anon_sym_requires] = ACTIONS(2221),
    [sym_this] = ACTIONS(2221),
    [anon_sym___launch_bounds__] = ACTIONS(2221),
  },
  [761] = {
    [sym_preproc_def] = STATE(726),
    [sym_preproc_function_def] = STATE(726),
    [sym_preproc_call] = STATE(726),
    [sym_preproc_if_in_field_declaration_list] = STATE(726),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(726),
    [sym_type_definition] = STATE(726),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5894),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6463),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(726),
    [sym_field_declaration] = STATE(726),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1708),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(726),
    [sym_operator_cast] = STATE(6999),
    [sym_inline_method_definition] = STATE(726),
    [sym__constructor_specifiers] = STATE(1708),
    [sym_operator_cast_definition] = STATE(726),
    [sym_operator_cast_declaration] = STATE(726),
    [sym_constructor_or_destructor_definition] = STATE(726),
    [sym_constructor_or_destructor_declaration] = STATE(726),
    [sym_friend_declaration] = STATE(726),
    [sym_access_specifier] = STATE(8255),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(726),
    [sym_alias_declaration] = STATE(726),
    [sym_static_assert_declaration] = STATE(726),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6999),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(726),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1708),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3376),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3378),
    [sym_preproc_directive] = ACTIONS(3380),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(3382),
    [anon_sym_typedef] = ACTIONS(3384),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3504),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3390),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(3392),
    [anon_sym_static_assert] = ACTIONS(3394),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [762] = {
    [ts_builtin_sym_end] = ACTIONS(2402),
    [sym_identifier] = ACTIONS(2400),
    [aux_sym_preproc_include_token1] = ACTIONS(2400),
    [aux_sym_preproc_def_token1] = ACTIONS(2400),
    [aux_sym_preproc_if_token1] = ACTIONS(2400),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2400),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2400),
    [sym_preproc_directive] = ACTIONS(2400),
    [anon_sym_LPAREN2] = ACTIONS(2402),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_TILDE] = ACTIONS(2402),
    [anon_sym_DASH] = ACTIONS(2400),
    [anon_sym_PLUS] = ACTIONS(2400),
    [anon_sym_STAR] = ACTIONS(2402),
    [anon_sym_AMP_AMP] = ACTIONS(2402),
    [anon_sym_AMP] = ACTIONS(2400),
    [anon_sym___extension__] = ACTIONS(2400),
    [anon_sym_typedef] = ACTIONS(2400),
    [anon_sym___device__] = ACTIONS(2400),
    [anon_sym___host__] = ACTIONS(2400),
    [anon_sym___global__] = ACTIONS(2400),
    [anon_sym___forceinline__] = ACTIONS(2400),
    [anon_sym___noinline__] = ACTIONS(2400),
    [anon_sym_extern] = ACTIONS(2400),
    [anon_sym___attribute__] = ACTIONS(2400),
    [anon_sym_COLON_COLON] = ACTIONS(2402),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2402),
    [anon_sym___declspec] = ACTIONS(2400),
    [anon_sym___based] = ACTIONS(2400),
    [anon_sym___cdecl] = ACTIONS(2400),
    [anon_sym___clrcall] = ACTIONS(2400),
    [anon_sym___stdcall] = ACTIONS(2400),
    [anon_sym___fastcall] = ACTIONS(2400),
    [anon_sym___thiscall] = ACTIONS(2400),
    [anon_sym___vectorcall] = ACTIONS(2400),
    [anon_sym_LBRACE] = ACTIONS(2402),
    [anon_sym_signed] = ACTIONS(2400),
    [anon_sym_unsigned] = ACTIONS(2400),
    [anon_sym_long] = ACTIONS(2400),
    [anon_sym_short] = ACTIONS(2400),
    [anon_sym_LBRACK] = ACTIONS(2400),
    [anon_sym_static] = ACTIONS(2400),
    [anon_sym_register] = ACTIONS(2400),
    [anon_sym_inline] = ACTIONS(2400),
    [anon_sym___inline] = ACTIONS(2400),
    [anon_sym___inline__] = ACTIONS(2400),
    [anon_sym___forceinline] = ACTIONS(2400),
    [anon_sym_thread_local] = ACTIONS(2400),
    [anon_sym___thread] = ACTIONS(2400),
    [anon_sym_const] = ACTIONS(2400),
    [anon_sym_constexpr] = ACTIONS(2400),
    [anon_sym_volatile] = ACTIONS(2400),
    [anon_sym_restrict] = ACTIONS(2400),
    [anon_sym___restrict__] = ACTIONS(2400),
    [anon_sym__Atomic] = ACTIONS(2400),
    [anon_sym__Noreturn] = ACTIONS(2400),
    [anon_sym_noreturn] = ACTIONS(2400),
    [anon_sym_mutable] = ACTIONS(2400),
    [anon_sym_constinit] = ACTIONS(2400),
    [anon_sym_consteval] = ACTIONS(2400),
    [anon_sym___shared__] = ACTIONS(2400),
    [anon_sym___local__] = ACTIONS(2400),
    [anon_sym___constant__] = ACTIONS(2400),
    [anon_sym___managed__] = ACTIONS(2400),
    [anon_sym___grid_constant__] = ACTIONS(2400),
    [anon_sym_alignas] = ACTIONS(2400),
    [anon_sym__Alignas] = ACTIONS(2400),
    [sym_primitive_type] = ACTIONS(2400),
    [anon_sym_enum] = ACTIONS(2400),
    [anon_sym_class] = ACTIONS(2400),
    [anon_sym_struct] = ACTIONS(2400),
    [anon_sym_union] = ACTIONS(2400),
    [anon_sym_if] = ACTIONS(2400),
    [anon_sym_switch] = ACTIONS(2400),
    [anon_sym_case] = ACTIONS(2400),
    [anon_sym_default] = ACTIONS(2400),
    [anon_sym_while] = ACTIONS(2400),
    [anon_sym_do] = ACTIONS(2400),
    [anon_sym_for] = ACTIONS(2400),
    [anon_sym_return] = ACTIONS(2400),
    [anon_sym_break] = ACTIONS(2400),
    [anon_sym_continue] = ACTIONS(2400),
    [anon_sym_goto] = ACTIONS(2400),
    [anon_sym_not] = ACTIONS(2400),
    [anon_sym_compl] = ACTIONS(2400),
    [anon_sym_DASH_DASH] = ACTIONS(2402),
    [anon_sym_PLUS_PLUS] = ACTIONS(2402),
    [anon_sym_sizeof] = ACTIONS(2400),
    [anon_sym___alignof__] = ACTIONS(2400),
    [anon_sym___alignof] = ACTIONS(2400),
    [anon_sym__alignof] = ACTIONS(2400),
    [anon_sym_alignof] = ACTIONS(2400),
    [anon_sym__Alignof] = ACTIONS(2400),
    [anon_sym_offsetof] = ACTIONS(2400),
    [anon_sym__Generic] = ACTIONS(2400),
    [anon_sym_asm] = ACTIONS(2400),
    [anon_sym___asm__] = ACTIONS(2400),
    [sym_number_literal] = ACTIONS(2402),
    [anon_sym_L_SQUOTE] = ACTIONS(2402),
    [anon_sym_u_SQUOTE] = ACTIONS(2402),
    [anon_sym_U_SQUOTE] = ACTIONS(2402),
    [anon_sym_u8_SQUOTE] = ACTIONS(2402),
    [anon_sym_SQUOTE] = ACTIONS(2402),
    [anon_sym_L_DQUOTE] = ACTIONS(2402),
    [anon_sym_u_DQUOTE] = ACTIONS(2402),
    [anon_sym_U_DQUOTE] = ACTIONS(2402),
    [anon_sym_u8_DQUOTE] = ACTIONS(2402),
    [anon_sym_DQUOTE] = ACTIONS(2402),
    [sym_true] = ACTIONS(2400),
    [sym_false] = ACTIONS(2400),
    [anon_sym_NULL] = ACTIONS(2400),
    [anon_sym_nullptr] = ACTIONS(2400),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2400),
    [anon_sym_decltype] = ACTIONS(2400),
    [sym_virtual] = ACTIONS(2400),
    [anon_sym_explicit] = ACTIONS(2400),
    [anon_sym_typename] = ACTIONS(2400),
    [anon_sym_template] = ACTIONS(2400),
    [anon_sym_operator] = ACTIONS(2400),
    [anon_sym_try] = ACTIONS(2400),
    [anon_sym_delete] = ACTIONS(2400),
    [anon_sym_throw] = ACTIONS(2400),
    [anon_sym_namespace] = ACTIONS(2400),
    [anon_sym_using] = ACTIONS(2400),
    [anon_sym_static_assert] = ACTIONS(2400),
    [anon_sym_concept] = ACTIONS(2400),
    [anon_sym_co_return] = ACTIONS(2400),
    [anon_sym_co_yield] = ACTIONS(2400),
    [anon_sym_R_DQUOTE] = ACTIONS(2402),
    [anon_sym_LR_DQUOTE] = ACTIONS(2402),
    [anon_sym_uR_DQUOTE] = ACTIONS(2402),
    [anon_sym_UR_DQUOTE] = ACTIONS(2402),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2402),
    [anon_sym_co_await] = ACTIONS(2400),
    [anon_sym_new] = ACTIONS(2400),
    [anon_sym_requires] = ACTIONS(2400),
    [sym_this] = ACTIONS(2400),
    [anon_sym___launch_bounds__] = ACTIONS(2400),
  },
  [763] = {
    [sym_preproc_def] = STATE(763),
    [sym_preproc_function_def] = STATE(763),
    [sym_preproc_call] = STATE(763),
    [sym_preproc_if_in_field_declaration_list] = STATE(763),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(763),
    [sym_type_definition] = STATE(763),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5980),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6420),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(763),
    [sym_field_declaration] = STATE(763),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1703),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(763),
    [sym_operator_cast] = STATE(6989),
    [sym_inline_method_definition] = STATE(763),
    [sym__constructor_specifiers] = STATE(1703),
    [sym_operator_cast_definition] = STATE(763),
    [sym_operator_cast_declaration] = STATE(763),
    [sym_constructor_or_destructor_definition] = STATE(763),
    [sym_constructor_or_destructor_declaration] = STATE(763),
    [sym_friend_declaration] = STATE(763),
    [sym_access_specifier] = STATE(8657),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(763),
    [sym_alias_declaration] = STATE(763),
    [sym_static_assert_declaration] = STATE(763),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6989),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(763),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1703),
    [sym_identifier] = ACTIONS(2592),
    [aux_sym_preproc_def_token1] = ACTIONS(3506),
    [aux_sym_preproc_if_token1] = ACTIONS(3509),
    [aux_sym_preproc_if_token2] = ACTIONS(2601),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3512),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3512),
    [sym_preproc_directive] = ACTIONS(3515),
    [anon_sym_LPAREN2] = ACTIONS(2609),
    [anon_sym_TILDE] = ACTIONS(2612),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_AMP_AMP] = ACTIONS(2618),
    [anon_sym_AMP] = ACTIONS(2621),
    [anon_sym___extension__] = ACTIONS(3518),
    [anon_sym_typedef] = ACTIONS(3521),
    [anon_sym___device__] = ACTIONS(2630),
    [anon_sym___host__] = ACTIONS(2630),
    [anon_sym___global__] = ACTIONS(2630),
    [anon_sym___forceinline__] = ACTIONS(2630),
    [anon_sym___noinline__] = ACTIONS(2630),
    [anon_sym_extern] = ACTIONS(2633),
    [anon_sym___attribute__] = ACTIONS(2636),
    [anon_sym_COLON_COLON] = ACTIONS(2639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2642),
    [anon_sym___declspec] = ACTIONS(2645),
    [anon_sym___based] = ACTIONS(2648),
    [anon_sym_signed] = ACTIONS(2651),
    [anon_sym_unsigned] = ACTIONS(2651),
    [anon_sym_long] = ACTIONS(2651),
    [anon_sym_short] = ACTIONS(2651),
    [anon_sym_LBRACK] = ACTIONS(2654),
    [anon_sym_static] = ACTIONS(2633),
    [anon_sym_register] = ACTIONS(2633),
    [anon_sym_inline] = ACTIONS(2633),
    [anon_sym___inline] = ACTIONS(2633),
    [anon_sym___inline__] = ACTIONS(2633),
    [anon_sym___forceinline] = ACTIONS(2633),
    [anon_sym_thread_local] = ACTIONS(2633),
    [anon_sym___thread] = ACTIONS(2633),
    [anon_sym_const] = ACTIONS(2657),
    [anon_sym_constexpr] = ACTIONS(2657),
    [anon_sym_volatile] = ACTIONS(2657),
    [anon_sym_restrict] = ACTIONS(2657),
    [anon_sym___restrict__] = ACTIONS(2657),
    [anon_sym__Atomic] = ACTIONS(2657),
    [anon_sym__Noreturn] = ACTIONS(2657),
    [anon_sym_noreturn] = ACTIONS(2657),
    [anon_sym_mutable] = ACTIONS(2657),
    [anon_sym_constinit] = ACTIONS(2657),
    [anon_sym_consteval] = ACTIONS(2657),
    [anon_sym___shared__] = ACTIONS(2657),
    [anon_sym___local__] = ACTIONS(2657),
    [anon_sym___constant__] = ACTIONS(2657),
    [anon_sym___managed__] = ACTIONS(2657),
    [anon_sym___grid_constant__] = ACTIONS(2657),
    [anon_sym_alignas] = ACTIONS(2660),
    [anon_sym__Alignas] = ACTIONS(2660),
    [sym_primitive_type] = ACTIONS(2663),
    [anon_sym_enum] = ACTIONS(2666),
    [anon_sym_class] = ACTIONS(2669),
    [anon_sym_struct] = ACTIONS(2672),
    [anon_sym_union] = ACTIONS(2675),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2678),
    [anon_sym_decltype] = ACTIONS(2681),
    [sym_virtual] = ACTIONS(2630),
    [anon_sym_explicit] = ACTIONS(2684),
    [anon_sym_typename] = ACTIONS(2687),
    [anon_sym_template] = ACTIONS(3524),
    [anon_sym_operator] = ACTIONS(2693),
    [anon_sym_friend] = ACTIONS(3527),
    [anon_sym_public] = ACTIONS(2699),
    [anon_sym_private] = ACTIONS(2699),
    [anon_sym_protected] = ACTIONS(2699),
    [anon_sym_using] = ACTIONS(3530),
    [anon_sym_static_assert] = ACTIONS(3533),
    [anon_sym___launch_bounds__] = ACTIONS(2708),
  },
  [764] = {
    [ts_builtin_sym_end] = ACTIONS(2378),
    [sym_identifier] = ACTIONS(2376),
    [aux_sym_preproc_include_token1] = ACTIONS(2376),
    [aux_sym_preproc_def_token1] = ACTIONS(2376),
    [aux_sym_preproc_if_token1] = ACTIONS(2376),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2376),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2376),
    [sym_preproc_directive] = ACTIONS(2376),
    [anon_sym_LPAREN2] = ACTIONS(2378),
    [anon_sym_BANG] = ACTIONS(2378),
    [anon_sym_TILDE] = ACTIONS(2378),
    [anon_sym_DASH] = ACTIONS(2376),
    [anon_sym_PLUS] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(2378),
    [anon_sym_AMP_AMP] = ACTIONS(2378),
    [anon_sym_AMP] = ACTIONS(2376),
    [anon_sym___extension__] = ACTIONS(2376),
    [anon_sym_typedef] = ACTIONS(2376),
    [anon_sym___device__] = ACTIONS(2376),
    [anon_sym___host__] = ACTIONS(2376),
    [anon_sym___global__] = ACTIONS(2376),
    [anon_sym___forceinline__] = ACTIONS(2376),
    [anon_sym___noinline__] = ACTIONS(2376),
    [anon_sym_extern] = ACTIONS(2376),
    [anon_sym___attribute__] = ACTIONS(2376),
    [anon_sym_COLON_COLON] = ACTIONS(2378),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2378),
    [anon_sym___declspec] = ACTIONS(2376),
    [anon_sym___based] = ACTIONS(2376),
    [anon_sym___cdecl] = ACTIONS(2376),
    [anon_sym___clrcall] = ACTIONS(2376),
    [anon_sym___stdcall] = ACTIONS(2376),
    [anon_sym___fastcall] = ACTIONS(2376),
    [anon_sym___thiscall] = ACTIONS(2376),
    [anon_sym___vectorcall] = ACTIONS(2376),
    [anon_sym_LBRACE] = ACTIONS(2378),
    [anon_sym_signed] = ACTIONS(2376),
    [anon_sym_unsigned] = ACTIONS(2376),
    [anon_sym_long] = ACTIONS(2376),
    [anon_sym_short] = ACTIONS(2376),
    [anon_sym_LBRACK] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2376),
    [anon_sym_register] = ACTIONS(2376),
    [anon_sym_inline] = ACTIONS(2376),
    [anon_sym___inline] = ACTIONS(2376),
    [anon_sym___inline__] = ACTIONS(2376),
    [anon_sym___forceinline] = ACTIONS(2376),
    [anon_sym_thread_local] = ACTIONS(2376),
    [anon_sym___thread] = ACTIONS(2376),
    [anon_sym_const] = ACTIONS(2376),
    [anon_sym_constexpr] = ACTIONS(2376),
    [anon_sym_volatile] = ACTIONS(2376),
    [anon_sym_restrict] = ACTIONS(2376),
    [anon_sym___restrict__] = ACTIONS(2376),
    [anon_sym__Atomic] = ACTIONS(2376),
    [anon_sym__Noreturn] = ACTIONS(2376),
    [anon_sym_noreturn] = ACTIONS(2376),
    [anon_sym_mutable] = ACTIONS(2376),
    [anon_sym_constinit] = ACTIONS(2376),
    [anon_sym_consteval] = ACTIONS(2376),
    [anon_sym___shared__] = ACTIONS(2376),
    [anon_sym___local__] = ACTIONS(2376),
    [anon_sym___constant__] = ACTIONS(2376),
    [anon_sym___managed__] = ACTIONS(2376),
    [anon_sym___grid_constant__] = ACTIONS(2376),
    [anon_sym_alignas] = ACTIONS(2376),
    [anon_sym__Alignas] = ACTIONS(2376),
    [sym_primitive_type] = ACTIONS(2376),
    [anon_sym_enum] = ACTIONS(2376),
    [anon_sym_class] = ACTIONS(2376),
    [anon_sym_struct] = ACTIONS(2376),
    [anon_sym_union] = ACTIONS(2376),
    [anon_sym_if] = ACTIONS(2376),
    [anon_sym_switch] = ACTIONS(2376),
    [anon_sym_case] = ACTIONS(2376),
    [anon_sym_default] = ACTIONS(2376),
    [anon_sym_while] = ACTIONS(2376),
    [anon_sym_do] = ACTIONS(2376),
    [anon_sym_for] = ACTIONS(2376),
    [anon_sym_return] = ACTIONS(2376),
    [anon_sym_break] = ACTIONS(2376),
    [anon_sym_continue] = ACTIONS(2376),
    [anon_sym_goto] = ACTIONS(2376),
    [anon_sym_not] = ACTIONS(2376),
    [anon_sym_compl] = ACTIONS(2376),
    [anon_sym_DASH_DASH] = ACTIONS(2378),
    [anon_sym_PLUS_PLUS] = ACTIONS(2378),
    [anon_sym_sizeof] = ACTIONS(2376),
    [anon_sym___alignof__] = ACTIONS(2376),
    [anon_sym___alignof] = ACTIONS(2376),
    [anon_sym__alignof] = ACTIONS(2376),
    [anon_sym_alignof] = ACTIONS(2376),
    [anon_sym__Alignof] = ACTIONS(2376),
    [anon_sym_offsetof] = ACTIONS(2376),
    [anon_sym__Generic] = ACTIONS(2376),
    [anon_sym_asm] = ACTIONS(2376),
    [anon_sym___asm__] = ACTIONS(2376),
    [sym_number_literal] = ACTIONS(2378),
    [anon_sym_L_SQUOTE] = ACTIONS(2378),
    [anon_sym_u_SQUOTE] = ACTIONS(2378),
    [anon_sym_U_SQUOTE] = ACTIONS(2378),
    [anon_sym_u8_SQUOTE] = ACTIONS(2378),
    [anon_sym_SQUOTE] = ACTIONS(2378),
    [anon_sym_L_DQUOTE] = ACTIONS(2378),
    [anon_sym_u_DQUOTE] = ACTIONS(2378),
    [anon_sym_U_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [sym_true] = ACTIONS(2376),
    [sym_false] = ACTIONS(2376),
    [anon_sym_NULL] = ACTIONS(2376),
    [anon_sym_nullptr] = ACTIONS(2376),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2376),
    [anon_sym_decltype] = ACTIONS(2376),
    [sym_virtual] = ACTIONS(2376),
    [anon_sym_explicit] = ACTIONS(2376),
    [anon_sym_typename] = ACTIONS(2376),
    [anon_sym_template] = ACTIONS(2376),
    [anon_sym_operator] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2376),
    [anon_sym_delete] = ACTIONS(2376),
    [anon_sym_throw] = ACTIONS(2376),
    [anon_sym_namespace] = ACTIONS(2376),
    [anon_sym_using] = ACTIONS(2376),
    [anon_sym_static_assert] = ACTIONS(2376),
    [anon_sym_concept] = ACTIONS(2376),
    [anon_sym_co_return] = ACTIONS(2376),
    [anon_sym_co_yield] = ACTIONS(2376),
    [anon_sym_R_DQUOTE] = ACTIONS(2378),
    [anon_sym_LR_DQUOTE] = ACTIONS(2378),
    [anon_sym_uR_DQUOTE] = ACTIONS(2378),
    [anon_sym_UR_DQUOTE] = ACTIONS(2378),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2378),
    [anon_sym_co_await] = ACTIONS(2376),
    [anon_sym_new] = ACTIONS(2376),
    [anon_sym_requires] = ACTIONS(2376),
    [sym_this] = ACTIONS(2376),
    [anon_sym___launch_bounds__] = ACTIONS(2376),
  },
  [765] = {
    [ts_builtin_sym_end] = ACTIONS(2096),
    [sym_identifier] = ACTIONS(2094),
    [aux_sym_preproc_include_token1] = ACTIONS(2094),
    [aux_sym_preproc_def_token1] = ACTIONS(2094),
    [aux_sym_preproc_if_token1] = ACTIONS(2094),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2094),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2094),
    [sym_preproc_directive] = ACTIONS(2094),
    [anon_sym_LPAREN2] = ACTIONS(2096),
    [anon_sym_BANG] = ACTIONS(2096),
    [anon_sym_TILDE] = ACTIONS(2096),
    [anon_sym_DASH] = ACTIONS(2094),
    [anon_sym_PLUS] = ACTIONS(2094),
    [anon_sym_STAR] = ACTIONS(2096),
    [anon_sym_AMP_AMP] = ACTIONS(2096),
    [anon_sym_AMP] = ACTIONS(2094),
    [anon_sym___extension__] = ACTIONS(2094),
    [anon_sym_typedef] = ACTIONS(2094),
    [anon_sym___device__] = ACTIONS(2094),
    [anon_sym___host__] = ACTIONS(2094),
    [anon_sym___global__] = ACTIONS(2094),
    [anon_sym___forceinline__] = ACTIONS(2094),
    [anon_sym___noinline__] = ACTIONS(2094),
    [anon_sym_extern] = ACTIONS(2094),
    [anon_sym___attribute__] = ACTIONS(2094),
    [anon_sym_COLON_COLON] = ACTIONS(2096),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2096),
    [anon_sym___declspec] = ACTIONS(2094),
    [anon_sym___based] = ACTIONS(2094),
    [anon_sym___cdecl] = ACTIONS(2094),
    [anon_sym___clrcall] = ACTIONS(2094),
    [anon_sym___stdcall] = ACTIONS(2094),
    [anon_sym___fastcall] = ACTIONS(2094),
    [anon_sym___thiscall] = ACTIONS(2094),
    [anon_sym___vectorcall] = ACTIONS(2094),
    [anon_sym_LBRACE] = ACTIONS(2096),
    [anon_sym_signed] = ACTIONS(2094),
    [anon_sym_unsigned] = ACTIONS(2094),
    [anon_sym_long] = ACTIONS(2094),
    [anon_sym_short] = ACTIONS(2094),
    [anon_sym_LBRACK] = ACTIONS(2094),
    [anon_sym_static] = ACTIONS(2094),
    [anon_sym_register] = ACTIONS(2094),
    [anon_sym_inline] = ACTIONS(2094),
    [anon_sym___inline] = ACTIONS(2094),
    [anon_sym___inline__] = ACTIONS(2094),
    [anon_sym___forceinline] = ACTIONS(2094),
    [anon_sym_thread_local] = ACTIONS(2094),
    [anon_sym___thread] = ACTIONS(2094),
    [anon_sym_const] = ACTIONS(2094),
    [anon_sym_constexpr] = ACTIONS(2094),
    [anon_sym_volatile] = ACTIONS(2094),
    [anon_sym_restrict] = ACTIONS(2094),
    [anon_sym___restrict__] = ACTIONS(2094),
    [anon_sym__Atomic] = ACTIONS(2094),
    [anon_sym__Noreturn] = ACTIONS(2094),
    [anon_sym_noreturn] = ACTIONS(2094),
    [anon_sym_mutable] = ACTIONS(2094),
    [anon_sym_constinit] = ACTIONS(2094),
    [anon_sym_consteval] = ACTIONS(2094),
    [anon_sym___shared__] = ACTIONS(2094),
    [anon_sym___local__] = ACTIONS(2094),
    [anon_sym___constant__] = ACTIONS(2094),
    [anon_sym___managed__] = ACTIONS(2094),
    [anon_sym___grid_constant__] = ACTIONS(2094),
    [anon_sym_alignas] = ACTIONS(2094),
    [anon_sym__Alignas] = ACTIONS(2094),
    [sym_primitive_type] = ACTIONS(2094),
    [anon_sym_enum] = ACTIONS(2094),
    [anon_sym_class] = ACTIONS(2094),
    [anon_sym_struct] = ACTIONS(2094),
    [anon_sym_union] = ACTIONS(2094),
    [anon_sym_if] = ACTIONS(2094),
    [anon_sym_switch] = ACTIONS(2094),
    [anon_sym_case] = ACTIONS(2094),
    [anon_sym_default] = ACTIONS(2094),
    [anon_sym_while] = ACTIONS(2094),
    [anon_sym_do] = ACTIONS(2094),
    [anon_sym_for] = ACTIONS(2094),
    [anon_sym_return] = ACTIONS(2094),
    [anon_sym_break] = ACTIONS(2094),
    [anon_sym_continue] = ACTIONS(2094),
    [anon_sym_goto] = ACTIONS(2094),
    [anon_sym_not] = ACTIONS(2094),
    [anon_sym_compl] = ACTIONS(2094),
    [anon_sym_DASH_DASH] = ACTIONS(2096),
    [anon_sym_PLUS_PLUS] = ACTIONS(2096),
    [anon_sym_sizeof] = ACTIONS(2094),
    [anon_sym___alignof__] = ACTIONS(2094),
    [anon_sym___alignof] = ACTIONS(2094),
    [anon_sym__alignof] = ACTIONS(2094),
    [anon_sym_alignof] = ACTIONS(2094),
    [anon_sym__Alignof] = ACTIONS(2094),
    [anon_sym_offsetof] = ACTIONS(2094),
    [anon_sym__Generic] = ACTIONS(2094),
    [anon_sym_asm] = ACTIONS(2094),
    [anon_sym___asm__] = ACTIONS(2094),
    [sym_number_literal] = ACTIONS(2096),
    [anon_sym_L_SQUOTE] = ACTIONS(2096),
    [anon_sym_u_SQUOTE] = ACTIONS(2096),
    [anon_sym_U_SQUOTE] = ACTIONS(2096),
    [anon_sym_u8_SQUOTE] = ACTIONS(2096),
    [anon_sym_SQUOTE] = ACTIONS(2096),
    [anon_sym_L_DQUOTE] = ACTIONS(2096),
    [anon_sym_u_DQUOTE] = ACTIONS(2096),
    [anon_sym_U_DQUOTE] = ACTIONS(2096),
    [anon_sym_u8_DQUOTE] = ACTIONS(2096),
    [anon_sym_DQUOTE] = ACTIONS(2096),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2094),
    [anon_sym_nullptr] = ACTIONS(2094),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2094),
    [anon_sym_decltype] = ACTIONS(2094),
    [sym_virtual] = ACTIONS(2094),
    [anon_sym_explicit] = ACTIONS(2094),
    [anon_sym_typename] = ACTIONS(2094),
    [anon_sym_template] = ACTIONS(2094),
    [anon_sym_operator] = ACTIONS(2094),
    [anon_sym_try] = ACTIONS(2094),
    [anon_sym_delete] = ACTIONS(2094),
    [anon_sym_throw] = ACTIONS(2094),
    [anon_sym_namespace] = ACTIONS(2094),
    [anon_sym_using] = ACTIONS(2094),
    [anon_sym_static_assert] = ACTIONS(2094),
    [anon_sym_concept] = ACTIONS(2094),
    [anon_sym_co_return] = ACTIONS(2094),
    [anon_sym_co_yield] = ACTIONS(2094),
    [anon_sym_R_DQUOTE] = ACTIONS(2096),
    [anon_sym_LR_DQUOTE] = ACTIONS(2096),
    [anon_sym_uR_DQUOTE] = ACTIONS(2096),
    [anon_sym_UR_DQUOTE] = ACTIONS(2096),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2096),
    [anon_sym_co_await] = ACTIONS(2094),
    [anon_sym_new] = ACTIONS(2094),
    [anon_sym_requires] = ACTIONS(2094),
    [sym_this] = ACTIONS(2094),
    [anon_sym___launch_bounds__] = ACTIONS(2094),
  },
  [766] = {
    [ts_builtin_sym_end] = ACTIONS(2350),
    [sym_identifier] = ACTIONS(2348),
    [aux_sym_preproc_include_token1] = ACTIONS(2348),
    [aux_sym_preproc_def_token1] = ACTIONS(2348),
    [aux_sym_preproc_if_token1] = ACTIONS(2348),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2348),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2348),
    [sym_preproc_directive] = ACTIONS(2348),
    [anon_sym_LPAREN2] = ACTIONS(2350),
    [anon_sym_BANG] = ACTIONS(2350),
    [anon_sym_TILDE] = ACTIONS(2350),
    [anon_sym_DASH] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(2348),
    [anon_sym_STAR] = ACTIONS(2350),
    [anon_sym_AMP_AMP] = ACTIONS(2350),
    [anon_sym_AMP] = ACTIONS(2348),
    [anon_sym___extension__] = ACTIONS(2348),
    [anon_sym_typedef] = ACTIONS(2348),
    [anon_sym___device__] = ACTIONS(2348),
    [anon_sym___host__] = ACTIONS(2348),
    [anon_sym___global__] = ACTIONS(2348),
    [anon_sym___forceinline__] = ACTIONS(2348),
    [anon_sym___noinline__] = ACTIONS(2348),
    [anon_sym_extern] = ACTIONS(2348),
    [anon_sym___attribute__] = ACTIONS(2348),
    [anon_sym_COLON_COLON] = ACTIONS(2350),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2350),
    [anon_sym___declspec] = ACTIONS(2348),
    [anon_sym___based] = ACTIONS(2348),
    [anon_sym___cdecl] = ACTIONS(2348),
    [anon_sym___clrcall] = ACTIONS(2348),
    [anon_sym___stdcall] = ACTIONS(2348),
    [anon_sym___fastcall] = ACTIONS(2348),
    [anon_sym___thiscall] = ACTIONS(2348),
    [anon_sym___vectorcall] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(2350),
    [anon_sym_signed] = ACTIONS(2348),
    [anon_sym_unsigned] = ACTIONS(2348),
    [anon_sym_long] = ACTIONS(2348),
    [anon_sym_short] = ACTIONS(2348),
    [anon_sym_LBRACK] = ACTIONS(2348),
    [anon_sym_static] = ACTIONS(2348),
    [anon_sym_register] = ACTIONS(2348),
    [anon_sym_inline] = ACTIONS(2348),
    [anon_sym___inline] = ACTIONS(2348),
    [anon_sym___inline__] = ACTIONS(2348),
    [anon_sym___forceinline] = ACTIONS(2348),
    [anon_sym_thread_local] = ACTIONS(2348),
    [anon_sym___thread] = ACTIONS(2348),
    [anon_sym_const] = ACTIONS(2348),
    [anon_sym_constexpr] = ACTIONS(2348),
    [anon_sym_volatile] = ACTIONS(2348),
    [anon_sym_restrict] = ACTIONS(2348),
    [anon_sym___restrict__] = ACTIONS(2348),
    [anon_sym__Atomic] = ACTIONS(2348),
    [anon_sym__Noreturn] = ACTIONS(2348),
    [anon_sym_noreturn] = ACTIONS(2348),
    [anon_sym_mutable] = ACTIONS(2348),
    [anon_sym_constinit] = ACTIONS(2348),
    [anon_sym_consteval] = ACTIONS(2348),
    [anon_sym___shared__] = ACTIONS(2348),
    [anon_sym___local__] = ACTIONS(2348),
    [anon_sym___constant__] = ACTIONS(2348),
    [anon_sym___managed__] = ACTIONS(2348),
    [anon_sym___grid_constant__] = ACTIONS(2348),
    [anon_sym_alignas] = ACTIONS(2348),
    [anon_sym__Alignas] = ACTIONS(2348),
    [sym_primitive_type] = ACTIONS(2348),
    [anon_sym_enum] = ACTIONS(2348),
    [anon_sym_class] = ACTIONS(2348),
    [anon_sym_struct] = ACTIONS(2348),
    [anon_sym_union] = ACTIONS(2348),
    [anon_sym_if] = ACTIONS(2348),
    [anon_sym_switch] = ACTIONS(2348),
    [anon_sym_case] = ACTIONS(2348),
    [anon_sym_default] = ACTIONS(2348),
    [anon_sym_while] = ACTIONS(2348),
    [anon_sym_do] = ACTIONS(2348),
    [anon_sym_for] = ACTIONS(2348),
    [anon_sym_return] = ACTIONS(2348),
    [anon_sym_break] = ACTIONS(2348),
    [anon_sym_continue] = ACTIONS(2348),
    [anon_sym_goto] = ACTIONS(2348),
    [anon_sym_not] = ACTIONS(2348),
    [anon_sym_compl] = ACTIONS(2348),
    [anon_sym_DASH_DASH] = ACTIONS(2350),
    [anon_sym_PLUS_PLUS] = ACTIONS(2350),
    [anon_sym_sizeof] = ACTIONS(2348),
    [anon_sym___alignof__] = ACTIONS(2348),
    [anon_sym___alignof] = ACTIONS(2348),
    [anon_sym__alignof] = ACTIONS(2348),
    [anon_sym_alignof] = ACTIONS(2348),
    [anon_sym__Alignof] = ACTIONS(2348),
    [anon_sym_offsetof] = ACTIONS(2348),
    [anon_sym__Generic] = ACTIONS(2348),
    [anon_sym_asm] = ACTIONS(2348),
    [anon_sym___asm__] = ACTIONS(2348),
    [sym_number_literal] = ACTIONS(2350),
    [anon_sym_L_SQUOTE] = ACTIONS(2350),
    [anon_sym_u_SQUOTE] = ACTIONS(2350),
    [anon_sym_U_SQUOTE] = ACTIONS(2350),
    [anon_sym_u8_SQUOTE] = ACTIONS(2350),
    [anon_sym_SQUOTE] = ACTIONS(2350),
    [anon_sym_L_DQUOTE] = ACTIONS(2350),
    [anon_sym_u_DQUOTE] = ACTIONS(2350),
    [anon_sym_U_DQUOTE] = ACTIONS(2350),
    [anon_sym_u8_DQUOTE] = ACTIONS(2350),
    [anon_sym_DQUOTE] = ACTIONS(2350),
    [sym_true] = ACTIONS(2348),
    [sym_false] = ACTIONS(2348),
    [anon_sym_NULL] = ACTIONS(2348),
    [anon_sym_nullptr] = ACTIONS(2348),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2348),
    [anon_sym_decltype] = ACTIONS(2348),
    [sym_virtual] = ACTIONS(2348),
    [anon_sym_explicit] = ACTIONS(2348),
    [anon_sym_typename] = ACTIONS(2348),
    [anon_sym_template] = ACTIONS(2348),
    [anon_sym_operator] = ACTIONS(2348),
    [anon_sym_try] = ACTIONS(2348),
    [anon_sym_delete] = ACTIONS(2348),
    [anon_sym_throw] = ACTIONS(2348),
    [anon_sym_namespace] = ACTIONS(2348),
    [anon_sym_using] = ACTIONS(2348),
    [anon_sym_static_assert] = ACTIONS(2348),
    [anon_sym_concept] = ACTIONS(2348),
    [anon_sym_co_return] = ACTIONS(2348),
    [anon_sym_co_yield] = ACTIONS(2348),
    [anon_sym_R_DQUOTE] = ACTIONS(2350),
    [anon_sym_LR_DQUOTE] = ACTIONS(2350),
    [anon_sym_uR_DQUOTE] = ACTIONS(2350),
    [anon_sym_UR_DQUOTE] = ACTIONS(2350),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2350),
    [anon_sym_co_await] = ACTIONS(2348),
    [anon_sym_new] = ACTIONS(2348),
    [anon_sym_requires] = ACTIONS(2348),
    [sym_this] = ACTIONS(2348),
    [anon_sym___launch_bounds__] = ACTIONS(2348),
  },
  [767] = {
    [ts_builtin_sym_end] = ACTIONS(2197),
    [sym_identifier] = ACTIONS(2195),
    [aux_sym_preproc_include_token1] = ACTIONS(2195),
    [aux_sym_preproc_def_token1] = ACTIONS(2195),
    [aux_sym_preproc_if_token1] = ACTIONS(2195),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2195),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2195),
    [sym_preproc_directive] = ACTIONS(2195),
    [anon_sym_LPAREN2] = ACTIONS(2197),
    [anon_sym_BANG] = ACTIONS(2197),
    [anon_sym_TILDE] = ACTIONS(2197),
    [anon_sym_DASH] = ACTIONS(2195),
    [anon_sym_PLUS] = ACTIONS(2195),
    [anon_sym_STAR] = ACTIONS(2197),
    [anon_sym_AMP_AMP] = ACTIONS(2197),
    [anon_sym_AMP] = ACTIONS(2195),
    [anon_sym___extension__] = ACTIONS(2195),
    [anon_sym_typedef] = ACTIONS(2195),
    [anon_sym___device__] = ACTIONS(2195),
    [anon_sym___host__] = ACTIONS(2195),
    [anon_sym___global__] = ACTIONS(2195),
    [anon_sym___forceinline__] = ACTIONS(2195),
    [anon_sym___noinline__] = ACTIONS(2195),
    [anon_sym_extern] = ACTIONS(2195),
    [anon_sym___attribute__] = ACTIONS(2195),
    [anon_sym_COLON_COLON] = ACTIONS(2197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2197),
    [anon_sym___declspec] = ACTIONS(2195),
    [anon_sym___based] = ACTIONS(2195),
    [anon_sym___cdecl] = ACTIONS(2195),
    [anon_sym___clrcall] = ACTIONS(2195),
    [anon_sym___stdcall] = ACTIONS(2195),
    [anon_sym___fastcall] = ACTIONS(2195),
    [anon_sym___thiscall] = ACTIONS(2195),
    [anon_sym___vectorcall] = ACTIONS(2195),
    [anon_sym_LBRACE] = ACTIONS(2197),
    [anon_sym_signed] = ACTIONS(2195),
    [anon_sym_unsigned] = ACTIONS(2195),
    [anon_sym_long] = ACTIONS(2195),
    [anon_sym_short] = ACTIONS(2195),
    [anon_sym_LBRACK] = ACTIONS(2195),
    [anon_sym_static] = ACTIONS(2195),
    [anon_sym_register] = ACTIONS(2195),
    [anon_sym_inline] = ACTIONS(2195),
    [anon_sym___inline] = ACTIONS(2195),
    [anon_sym___inline__] = ACTIONS(2195),
    [anon_sym___forceinline] = ACTIONS(2195),
    [anon_sym_thread_local] = ACTIONS(2195),
    [anon_sym___thread] = ACTIONS(2195),
    [anon_sym_const] = ACTIONS(2195),
    [anon_sym_constexpr] = ACTIONS(2195),
    [anon_sym_volatile] = ACTIONS(2195),
    [anon_sym_restrict] = ACTIONS(2195),
    [anon_sym___restrict__] = ACTIONS(2195),
    [anon_sym__Atomic] = ACTIONS(2195),
    [anon_sym__Noreturn] = ACTIONS(2195),
    [anon_sym_noreturn] = ACTIONS(2195),
    [anon_sym_mutable] = ACTIONS(2195),
    [anon_sym_constinit] = ACTIONS(2195),
    [anon_sym_consteval] = ACTIONS(2195),
    [anon_sym___shared__] = ACTIONS(2195),
    [anon_sym___local__] = ACTIONS(2195),
    [anon_sym___constant__] = ACTIONS(2195),
    [anon_sym___managed__] = ACTIONS(2195),
    [anon_sym___grid_constant__] = ACTIONS(2195),
    [anon_sym_alignas] = ACTIONS(2195),
    [anon_sym__Alignas] = ACTIONS(2195),
    [sym_primitive_type] = ACTIONS(2195),
    [anon_sym_enum] = ACTIONS(2195),
    [anon_sym_class] = ACTIONS(2195),
    [anon_sym_struct] = ACTIONS(2195),
    [anon_sym_union] = ACTIONS(2195),
    [anon_sym_if] = ACTIONS(2195),
    [anon_sym_switch] = ACTIONS(2195),
    [anon_sym_case] = ACTIONS(2195),
    [anon_sym_default] = ACTIONS(2195),
    [anon_sym_while] = ACTIONS(2195),
    [anon_sym_do] = ACTIONS(2195),
    [anon_sym_for] = ACTIONS(2195),
    [anon_sym_return] = ACTIONS(2195),
    [anon_sym_break] = ACTIONS(2195),
    [anon_sym_continue] = ACTIONS(2195),
    [anon_sym_goto] = ACTIONS(2195),
    [anon_sym_not] = ACTIONS(2195),
    [anon_sym_compl] = ACTIONS(2195),
    [anon_sym_DASH_DASH] = ACTIONS(2197),
    [anon_sym_PLUS_PLUS] = ACTIONS(2197),
    [anon_sym_sizeof] = ACTIONS(2195),
    [anon_sym___alignof__] = ACTIONS(2195),
    [anon_sym___alignof] = ACTIONS(2195),
    [anon_sym__alignof] = ACTIONS(2195),
    [anon_sym_alignof] = ACTIONS(2195),
    [anon_sym__Alignof] = ACTIONS(2195),
    [anon_sym_offsetof] = ACTIONS(2195),
    [anon_sym__Generic] = ACTIONS(2195),
    [anon_sym_asm] = ACTIONS(2195),
    [anon_sym___asm__] = ACTIONS(2195),
    [sym_number_literal] = ACTIONS(2197),
    [anon_sym_L_SQUOTE] = ACTIONS(2197),
    [anon_sym_u_SQUOTE] = ACTIONS(2197),
    [anon_sym_U_SQUOTE] = ACTIONS(2197),
    [anon_sym_u8_SQUOTE] = ACTIONS(2197),
    [anon_sym_SQUOTE] = ACTIONS(2197),
    [anon_sym_L_DQUOTE] = ACTIONS(2197),
    [anon_sym_u_DQUOTE] = ACTIONS(2197),
    [anon_sym_U_DQUOTE] = ACTIONS(2197),
    [anon_sym_u8_DQUOTE] = ACTIONS(2197),
    [anon_sym_DQUOTE] = ACTIONS(2197),
    [sym_true] = ACTIONS(2195),
    [sym_false] = ACTIONS(2195),
    [anon_sym_NULL] = ACTIONS(2195),
    [anon_sym_nullptr] = ACTIONS(2195),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2195),
    [anon_sym_decltype] = ACTIONS(2195),
    [sym_virtual] = ACTIONS(2195),
    [anon_sym_explicit] = ACTIONS(2195),
    [anon_sym_typename] = ACTIONS(2195),
    [anon_sym_template] = ACTIONS(2195),
    [anon_sym_operator] = ACTIONS(2195),
    [anon_sym_try] = ACTIONS(2195),
    [anon_sym_delete] = ACTIONS(2195),
    [anon_sym_throw] = ACTIONS(2195),
    [anon_sym_namespace] = ACTIONS(2195),
    [anon_sym_using] = ACTIONS(2195),
    [anon_sym_static_assert] = ACTIONS(2195),
    [anon_sym_concept] = ACTIONS(2195),
    [anon_sym_co_return] = ACTIONS(2195),
    [anon_sym_co_yield] = ACTIONS(2195),
    [anon_sym_R_DQUOTE] = ACTIONS(2197),
    [anon_sym_LR_DQUOTE] = ACTIONS(2197),
    [anon_sym_uR_DQUOTE] = ACTIONS(2197),
    [anon_sym_UR_DQUOTE] = ACTIONS(2197),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2197),
    [anon_sym_co_await] = ACTIONS(2195),
    [anon_sym_new] = ACTIONS(2195),
    [anon_sym_requires] = ACTIONS(2195),
    [sym_this] = ACTIONS(2195),
    [anon_sym___launch_bounds__] = ACTIONS(2195),
  },
  [768] = {
    [ts_builtin_sym_end] = ACTIONS(2340),
    [sym_identifier] = ACTIONS(2338),
    [aux_sym_preproc_include_token1] = ACTIONS(2338),
    [aux_sym_preproc_def_token1] = ACTIONS(2338),
    [aux_sym_preproc_if_token1] = ACTIONS(2338),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2338),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2338),
    [sym_preproc_directive] = ACTIONS(2338),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2338),
    [anon_sym_PLUS] = ACTIONS(2338),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_AMP] = ACTIONS(2338),
    [anon_sym___extension__] = ACTIONS(2338),
    [anon_sym_typedef] = ACTIONS(2338),
    [anon_sym___device__] = ACTIONS(2338),
    [anon_sym___host__] = ACTIONS(2338),
    [anon_sym___global__] = ACTIONS(2338),
    [anon_sym___forceinline__] = ACTIONS(2338),
    [anon_sym___noinline__] = ACTIONS(2338),
    [anon_sym_extern] = ACTIONS(2338),
    [anon_sym___attribute__] = ACTIONS(2338),
    [anon_sym_COLON_COLON] = ACTIONS(2340),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2340),
    [anon_sym___declspec] = ACTIONS(2338),
    [anon_sym___based] = ACTIONS(2338),
    [anon_sym___cdecl] = ACTIONS(2338),
    [anon_sym___clrcall] = ACTIONS(2338),
    [anon_sym___stdcall] = ACTIONS(2338),
    [anon_sym___fastcall] = ACTIONS(2338),
    [anon_sym___thiscall] = ACTIONS(2338),
    [anon_sym___vectorcall] = ACTIONS(2338),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_signed] = ACTIONS(2338),
    [anon_sym_unsigned] = ACTIONS(2338),
    [anon_sym_long] = ACTIONS(2338),
    [anon_sym_short] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2338),
    [anon_sym_static] = ACTIONS(2338),
    [anon_sym_register] = ACTIONS(2338),
    [anon_sym_inline] = ACTIONS(2338),
    [anon_sym___inline] = ACTIONS(2338),
    [anon_sym___inline__] = ACTIONS(2338),
    [anon_sym___forceinline] = ACTIONS(2338),
    [anon_sym_thread_local] = ACTIONS(2338),
    [anon_sym___thread] = ACTIONS(2338),
    [anon_sym_const] = ACTIONS(2338),
    [anon_sym_constexpr] = ACTIONS(2338),
    [anon_sym_volatile] = ACTIONS(2338),
    [anon_sym_restrict] = ACTIONS(2338),
    [anon_sym___restrict__] = ACTIONS(2338),
    [anon_sym__Atomic] = ACTIONS(2338),
    [anon_sym__Noreturn] = ACTIONS(2338),
    [anon_sym_noreturn] = ACTIONS(2338),
    [anon_sym_mutable] = ACTIONS(2338),
    [anon_sym_constinit] = ACTIONS(2338),
    [anon_sym_consteval] = ACTIONS(2338),
    [anon_sym___shared__] = ACTIONS(2338),
    [anon_sym___local__] = ACTIONS(2338),
    [anon_sym___constant__] = ACTIONS(2338),
    [anon_sym___managed__] = ACTIONS(2338),
    [anon_sym___grid_constant__] = ACTIONS(2338),
    [anon_sym_alignas] = ACTIONS(2338),
    [anon_sym__Alignas] = ACTIONS(2338),
    [sym_primitive_type] = ACTIONS(2338),
    [anon_sym_enum] = ACTIONS(2338),
    [anon_sym_class] = ACTIONS(2338),
    [anon_sym_struct] = ACTIONS(2338),
    [anon_sym_union] = ACTIONS(2338),
    [anon_sym_if] = ACTIONS(2338),
    [anon_sym_switch] = ACTIONS(2338),
    [anon_sym_case] = ACTIONS(2338),
    [anon_sym_default] = ACTIONS(2338),
    [anon_sym_while] = ACTIONS(2338),
    [anon_sym_do] = ACTIONS(2338),
    [anon_sym_for] = ACTIONS(2338),
    [anon_sym_return] = ACTIONS(2338),
    [anon_sym_break] = ACTIONS(2338),
    [anon_sym_continue] = ACTIONS(2338),
    [anon_sym_goto] = ACTIONS(2338),
    [anon_sym_not] = ACTIONS(2338),
    [anon_sym_compl] = ACTIONS(2338),
    [anon_sym_DASH_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_PLUS] = ACTIONS(2340),
    [anon_sym_sizeof] = ACTIONS(2338),
    [anon_sym___alignof__] = ACTIONS(2338),
    [anon_sym___alignof] = ACTIONS(2338),
    [anon_sym__alignof] = ACTIONS(2338),
    [anon_sym_alignof] = ACTIONS(2338),
    [anon_sym__Alignof] = ACTIONS(2338),
    [anon_sym_offsetof] = ACTIONS(2338),
    [anon_sym__Generic] = ACTIONS(2338),
    [anon_sym_asm] = ACTIONS(2338),
    [anon_sym___asm__] = ACTIONS(2338),
    [sym_number_literal] = ACTIONS(2340),
    [anon_sym_L_SQUOTE] = ACTIONS(2340),
    [anon_sym_u_SQUOTE] = ACTIONS(2340),
    [anon_sym_U_SQUOTE] = ACTIONS(2340),
    [anon_sym_u8_SQUOTE] = ACTIONS(2340),
    [anon_sym_SQUOTE] = ACTIONS(2340),
    [anon_sym_L_DQUOTE] = ACTIONS(2340),
    [anon_sym_u_DQUOTE] = ACTIONS(2340),
    [anon_sym_U_DQUOTE] = ACTIONS(2340),
    [anon_sym_u8_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [sym_true] = ACTIONS(2338),
    [sym_false] = ACTIONS(2338),
    [anon_sym_NULL] = ACTIONS(2338),
    [anon_sym_nullptr] = ACTIONS(2338),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2338),
    [anon_sym_decltype] = ACTIONS(2338),
    [sym_virtual] = ACTIONS(2338),
    [anon_sym_explicit] = ACTIONS(2338),
    [anon_sym_typename] = ACTIONS(2338),
    [anon_sym_template] = ACTIONS(2338),
    [anon_sym_operator] = ACTIONS(2338),
    [anon_sym_try] = ACTIONS(2338),
    [anon_sym_delete] = ACTIONS(2338),
    [anon_sym_throw] = ACTIONS(2338),
    [anon_sym_namespace] = ACTIONS(2338),
    [anon_sym_using] = ACTIONS(2338),
    [anon_sym_static_assert] = ACTIONS(2338),
    [anon_sym_concept] = ACTIONS(2338),
    [anon_sym_co_return] = ACTIONS(2338),
    [anon_sym_co_yield] = ACTIONS(2338),
    [anon_sym_R_DQUOTE] = ACTIONS(2340),
    [anon_sym_LR_DQUOTE] = ACTIONS(2340),
    [anon_sym_uR_DQUOTE] = ACTIONS(2340),
    [anon_sym_UR_DQUOTE] = ACTIONS(2340),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2340),
    [anon_sym_co_await] = ACTIONS(2338),
    [anon_sym_new] = ACTIONS(2338),
    [anon_sym_requires] = ACTIONS(2338),
    [sym_this] = ACTIONS(2338),
    [anon_sym___launch_bounds__] = ACTIONS(2338),
  },
  [769] = {
    [sym_preproc_def] = STATE(701),
    [sym_preproc_function_def] = STATE(701),
    [sym_preproc_call] = STATE(701),
    [sym_preproc_if_in_field_declaration_list] = STATE(701),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(701),
    [sym_type_definition] = STATE(701),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5894),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6463),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(701),
    [sym_field_declaration] = STATE(701),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1708),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(701),
    [sym_operator_cast] = STATE(6999),
    [sym_inline_method_definition] = STATE(701),
    [sym__constructor_specifiers] = STATE(1708),
    [sym_operator_cast_definition] = STATE(701),
    [sym_operator_cast_declaration] = STATE(701),
    [sym_constructor_or_destructor_definition] = STATE(701),
    [sym_constructor_or_destructor_declaration] = STATE(701),
    [sym_friend_declaration] = STATE(701),
    [sym_access_specifier] = STATE(8255),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(701),
    [sym_alias_declaration] = STATE(701),
    [sym_static_assert_declaration] = STATE(701),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6999),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(701),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1708),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3376),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3378),
    [sym_preproc_directive] = ACTIONS(3380),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(3382),
    [anon_sym_typedef] = ACTIONS(3384),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3536),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3390),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(3392),
    [anon_sym_static_assert] = ACTIONS(3394),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [770] = {
    [ts_builtin_sym_end] = ACTIONS(2213),
    [sym_identifier] = ACTIONS(2211),
    [aux_sym_preproc_include_token1] = ACTIONS(2211),
    [aux_sym_preproc_def_token1] = ACTIONS(2211),
    [aux_sym_preproc_if_token1] = ACTIONS(2211),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2211),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2211),
    [sym_preproc_directive] = ACTIONS(2211),
    [anon_sym_LPAREN2] = ACTIONS(2213),
    [anon_sym_BANG] = ACTIONS(2213),
    [anon_sym_TILDE] = ACTIONS(2213),
    [anon_sym_DASH] = ACTIONS(2211),
    [anon_sym_PLUS] = ACTIONS(2211),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_AMP_AMP] = ACTIONS(2213),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym___extension__] = ACTIONS(2211),
    [anon_sym_typedef] = ACTIONS(2211),
    [anon_sym___device__] = ACTIONS(2211),
    [anon_sym___host__] = ACTIONS(2211),
    [anon_sym___global__] = ACTIONS(2211),
    [anon_sym___forceinline__] = ACTIONS(2211),
    [anon_sym___noinline__] = ACTIONS(2211),
    [anon_sym_extern] = ACTIONS(2211),
    [anon_sym___attribute__] = ACTIONS(2211),
    [anon_sym_COLON_COLON] = ACTIONS(2213),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2213),
    [anon_sym___declspec] = ACTIONS(2211),
    [anon_sym___based] = ACTIONS(2211),
    [anon_sym___cdecl] = ACTIONS(2211),
    [anon_sym___clrcall] = ACTIONS(2211),
    [anon_sym___stdcall] = ACTIONS(2211),
    [anon_sym___fastcall] = ACTIONS(2211),
    [anon_sym___thiscall] = ACTIONS(2211),
    [anon_sym___vectorcall] = ACTIONS(2211),
    [anon_sym_LBRACE] = ACTIONS(2213),
    [anon_sym_signed] = ACTIONS(2211),
    [anon_sym_unsigned] = ACTIONS(2211),
    [anon_sym_long] = ACTIONS(2211),
    [anon_sym_short] = ACTIONS(2211),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_static] = ACTIONS(2211),
    [anon_sym_register] = ACTIONS(2211),
    [anon_sym_inline] = ACTIONS(2211),
    [anon_sym___inline] = ACTIONS(2211),
    [anon_sym___inline__] = ACTIONS(2211),
    [anon_sym___forceinline] = ACTIONS(2211),
    [anon_sym_thread_local] = ACTIONS(2211),
    [anon_sym___thread] = ACTIONS(2211),
    [anon_sym_const] = ACTIONS(2211),
    [anon_sym_constexpr] = ACTIONS(2211),
    [anon_sym_volatile] = ACTIONS(2211),
    [anon_sym_restrict] = ACTIONS(2211),
    [anon_sym___restrict__] = ACTIONS(2211),
    [anon_sym__Atomic] = ACTIONS(2211),
    [anon_sym__Noreturn] = ACTIONS(2211),
    [anon_sym_noreturn] = ACTIONS(2211),
    [anon_sym_mutable] = ACTIONS(2211),
    [anon_sym_constinit] = ACTIONS(2211),
    [anon_sym_consteval] = ACTIONS(2211),
    [anon_sym___shared__] = ACTIONS(2211),
    [anon_sym___local__] = ACTIONS(2211),
    [anon_sym___constant__] = ACTIONS(2211),
    [anon_sym___managed__] = ACTIONS(2211),
    [anon_sym___grid_constant__] = ACTIONS(2211),
    [anon_sym_alignas] = ACTIONS(2211),
    [anon_sym__Alignas] = ACTIONS(2211),
    [sym_primitive_type] = ACTIONS(2211),
    [anon_sym_enum] = ACTIONS(2211),
    [anon_sym_class] = ACTIONS(2211),
    [anon_sym_struct] = ACTIONS(2211),
    [anon_sym_union] = ACTIONS(2211),
    [anon_sym_if] = ACTIONS(2211),
    [anon_sym_switch] = ACTIONS(2211),
    [anon_sym_case] = ACTIONS(2211),
    [anon_sym_default] = ACTIONS(2211),
    [anon_sym_while] = ACTIONS(2211),
    [anon_sym_do] = ACTIONS(2211),
    [anon_sym_for] = ACTIONS(2211),
    [anon_sym_return] = ACTIONS(2211),
    [anon_sym_break] = ACTIONS(2211),
    [anon_sym_continue] = ACTIONS(2211),
    [anon_sym_goto] = ACTIONS(2211),
    [anon_sym_not] = ACTIONS(2211),
    [anon_sym_compl] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2213),
    [anon_sym_PLUS_PLUS] = ACTIONS(2213),
    [anon_sym_sizeof] = ACTIONS(2211),
    [anon_sym___alignof__] = ACTIONS(2211),
    [anon_sym___alignof] = ACTIONS(2211),
    [anon_sym__alignof] = ACTIONS(2211),
    [anon_sym_alignof] = ACTIONS(2211),
    [anon_sym__Alignof] = ACTIONS(2211),
    [anon_sym_offsetof] = ACTIONS(2211),
    [anon_sym__Generic] = ACTIONS(2211),
    [anon_sym_asm] = ACTIONS(2211),
    [anon_sym___asm__] = ACTIONS(2211),
    [sym_number_literal] = ACTIONS(2213),
    [anon_sym_L_SQUOTE] = ACTIONS(2213),
    [anon_sym_u_SQUOTE] = ACTIONS(2213),
    [anon_sym_U_SQUOTE] = ACTIONS(2213),
    [anon_sym_u8_SQUOTE] = ACTIONS(2213),
    [anon_sym_SQUOTE] = ACTIONS(2213),
    [anon_sym_L_DQUOTE] = ACTIONS(2213),
    [anon_sym_u_DQUOTE] = ACTIONS(2213),
    [anon_sym_U_DQUOTE] = ACTIONS(2213),
    [anon_sym_u8_DQUOTE] = ACTIONS(2213),
    [anon_sym_DQUOTE] = ACTIONS(2213),
    [sym_true] = ACTIONS(2211),
    [sym_false] = ACTIONS(2211),
    [anon_sym_NULL] = ACTIONS(2211),
    [anon_sym_nullptr] = ACTIONS(2211),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2211),
    [anon_sym_decltype] = ACTIONS(2211),
    [sym_virtual] = ACTIONS(2211),
    [anon_sym_explicit] = ACTIONS(2211),
    [anon_sym_typename] = ACTIONS(2211),
    [anon_sym_template] = ACTIONS(2211),
    [anon_sym_operator] = ACTIONS(2211),
    [anon_sym_try] = ACTIONS(2211),
    [anon_sym_delete] = ACTIONS(2211),
    [anon_sym_throw] = ACTIONS(2211),
    [anon_sym_namespace] = ACTIONS(2211),
    [anon_sym_using] = ACTIONS(2211),
    [anon_sym_static_assert] = ACTIONS(2211),
    [anon_sym_concept] = ACTIONS(2211),
    [anon_sym_co_return] = ACTIONS(2211),
    [anon_sym_co_yield] = ACTIONS(2211),
    [anon_sym_R_DQUOTE] = ACTIONS(2213),
    [anon_sym_LR_DQUOTE] = ACTIONS(2213),
    [anon_sym_uR_DQUOTE] = ACTIONS(2213),
    [anon_sym_UR_DQUOTE] = ACTIONS(2213),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2213),
    [anon_sym_co_await] = ACTIONS(2211),
    [anon_sym_new] = ACTIONS(2211),
    [anon_sym_requires] = ACTIONS(2211),
    [sym_this] = ACTIONS(2211),
    [anon_sym___launch_bounds__] = ACTIONS(2211),
  },
  [771] = {
    [ts_builtin_sym_end] = ACTIONS(2502),
    [sym_identifier] = ACTIONS(2500),
    [aux_sym_preproc_include_token1] = ACTIONS(2500),
    [aux_sym_preproc_def_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2500),
    [sym_preproc_directive] = ACTIONS(2500),
    [anon_sym_LPAREN2] = ACTIONS(2502),
    [anon_sym_BANG] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [anon_sym_DASH] = ACTIONS(2500),
    [anon_sym_PLUS] = ACTIONS(2500),
    [anon_sym_STAR] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2500),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_typedef] = ACTIONS(2500),
    [anon_sym___device__] = ACTIONS(2500),
    [anon_sym___host__] = ACTIONS(2500),
    [anon_sym___global__] = ACTIONS(2500),
    [anon_sym___forceinline__] = ACTIONS(2500),
    [anon_sym___noinline__] = ACTIONS(2500),
    [anon_sym_extern] = ACTIONS(2500),
    [anon_sym___attribute__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2502),
    [anon_sym___declspec] = ACTIONS(2500),
    [anon_sym___based] = ACTIONS(2500),
    [anon_sym___cdecl] = ACTIONS(2500),
    [anon_sym___clrcall] = ACTIONS(2500),
    [anon_sym___stdcall] = ACTIONS(2500),
    [anon_sym___fastcall] = ACTIONS(2500),
    [anon_sym___thiscall] = ACTIONS(2500),
    [anon_sym___vectorcall] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(2502),
    [anon_sym_signed] = ACTIONS(2500),
    [anon_sym_unsigned] = ACTIONS(2500),
    [anon_sym_long] = ACTIONS(2500),
    [anon_sym_short] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_static] = ACTIONS(2500),
    [anon_sym_register] = ACTIONS(2500),
    [anon_sym_inline] = ACTIONS(2500),
    [anon_sym___inline] = ACTIONS(2500),
    [anon_sym___inline__] = ACTIONS(2500),
    [anon_sym___forceinline] = ACTIONS(2500),
    [anon_sym_thread_local] = ACTIONS(2500),
    [anon_sym___thread] = ACTIONS(2500),
    [anon_sym_const] = ACTIONS(2500),
    [anon_sym_constexpr] = ACTIONS(2500),
    [anon_sym_volatile] = ACTIONS(2500),
    [anon_sym_restrict] = ACTIONS(2500),
    [anon_sym___restrict__] = ACTIONS(2500),
    [anon_sym__Atomic] = ACTIONS(2500),
    [anon_sym__Noreturn] = ACTIONS(2500),
    [anon_sym_noreturn] = ACTIONS(2500),
    [anon_sym_mutable] = ACTIONS(2500),
    [anon_sym_constinit] = ACTIONS(2500),
    [anon_sym_consteval] = ACTIONS(2500),
    [anon_sym___shared__] = ACTIONS(2500),
    [anon_sym___local__] = ACTIONS(2500),
    [anon_sym___constant__] = ACTIONS(2500),
    [anon_sym___managed__] = ACTIONS(2500),
    [anon_sym___grid_constant__] = ACTIONS(2500),
    [anon_sym_alignas] = ACTIONS(2500),
    [anon_sym__Alignas] = ACTIONS(2500),
    [sym_primitive_type] = ACTIONS(2500),
    [anon_sym_enum] = ACTIONS(2500),
    [anon_sym_class] = ACTIONS(2500),
    [anon_sym_struct] = ACTIONS(2500),
    [anon_sym_union] = ACTIONS(2500),
    [anon_sym_if] = ACTIONS(2500),
    [anon_sym_switch] = ACTIONS(2500),
    [anon_sym_case] = ACTIONS(2500),
    [anon_sym_default] = ACTIONS(2500),
    [anon_sym_while] = ACTIONS(2500),
    [anon_sym_do] = ACTIONS(2500),
    [anon_sym_for] = ACTIONS(2500),
    [anon_sym_return] = ACTIONS(2500),
    [anon_sym_break] = ACTIONS(2500),
    [anon_sym_continue] = ACTIONS(2500),
    [anon_sym_goto] = ACTIONS(2500),
    [anon_sym_not] = ACTIONS(2500),
    [anon_sym_compl] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(2502),
    [anon_sym_PLUS_PLUS] = ACTIONS(2502),
    [anon_sym_sizeof] = ACTIONS(2500),
    [anon_sym___alignof__] = ACTIONS(2500),
    [anon_sym___alignof] = ACTIONS(2500),
    [anon_sym__alignof] = ACTIONS(2500),
    [anon_sym_alignof] = ACTIONS(2500),
    [anon_sym__Alignof] = ACTIONS(2500),
    [anon_sym_offsetof] = ACTIONS(2500),
    [anon_sym__Generic] = ACTIONS(2500),
    [anon_sym_asm] = ACTIONS(2500),
    [anon_sym___asm__] = ACTIONS(2500),
    [sym_number_literal] = ACTIONS(2502),
    [anon_sym_L_SQUOTE] = ACTIONS(2502),
    [anon_sym_u_SQUOTE] = ACTIONS(2502),
    [anon_sym_U_SQUOTE] = ACTIONS(2502),
    [anon_sym_u8_SQUOTE] = ACTIONS(2502),
    [anon_sym_SQUOTE] = ACTIONS(2502),
    [anon_sym_L_DQUOTE] = ACTIONS(2502),
    [anon_sym_u_DQUOTE] = ACTIONS(2502),
    [anon_sym_U_DQUOTE] = ACTIONS(2502),
    [anon_sym_u8_DQUOTE] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [sym_true] = ACTIONS(2500),
    [sym_false] = ACTIONS(2500),
    [anon_sym_NULL] = ACTIONS(2500),
    [anon_sym_nullptr] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2500),
    [anon_sym_decltype] = ACTIONS(2500),
    [sym_virtual] = ACTIONS(2500),
    [anon_sym_explicit] = ACTIONS(2500),
    [anon_sym_typename] = ACTIONS(2500),
    [anon_sym_template] = ACTIONS(2500),
    [anon_sym_operator] = ACTIONS(2500),
    [anon_sym_try] = ACTIONS(2500),
    [anon_sym_delete] = ACTIONS(2500),
    [anon_sym_throw] = ACTIONS(2500),
    [anon_sym_namespace] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_static_assert] = ACTIONS(2500),
    [anon_sym_concept] = ACTIONS(2500),
    [anon_sym_co_return] = ACTIONS(2500),
    [anon_sym_co_yield] = ACTIONS(2500),
    [anon_sym_R_DQUOTE] = ACTIONS(2502),
    [anon_sym_LR_DQUOTE] = ACTIONS(2502),
    [anon_sym_uR_DQUOTE] = ACTIONS(2502),
    [anon_sym_UR_DQUOTE] = ACTIONS(2502),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2502),
    [anon_sym_co_await] = ACTIONS(2500),
    [anon_sym_new] = ACTIONS(2500),
    [anon_sym_requires] = ACTIONS(2500),
    [sym_this] = ACTIONS(2500),
    [anon_sym___launch_bounds__] = ACTIONS(2500),
  },
  [772] = {
    [sym_preproc_def] = STATE(701),
    [sym_preproc_function_def] = STATE(701),
    [sym_preproc_call] = STATE(701),
    [sym_preproc_if_in_field_declaration_list] = STATE(701),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(701),
    [sym_type_definition] = STATE(701),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5894),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6463),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(701),
    [sym_field_declaration] = STATE(701),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1708),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(701),
    [sym_operator_cast] = STATE(6999),
    [sym_inline_method_definition] = STATE(701),
    [sym__constructor_specifiers] = STATE(1708),
    [sym_operator_cast_definition] = STATE(701),
    [sym_operator_cast_declaration] = STATE(701),
    [sym_constructor_or_destructor_definition] = STATE(701),
    [sym_constructor_or_destructor_declaration] = STATE(701),
    [sym_friend_declaration] = STATE(701),
    [sym_access_specifier] = STATE(8255),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(701),
    [sym_alias_declaration] = STATE(701),
    [sym_static_assert_declaration] = STATE(701),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6999),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(701),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1708),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3376),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3378),
    [sym_preproc_directive] = ACTIONS(3380),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(3382),
    [anon_sym_typedef] = ACTIONS(3384),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3538),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3390),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(3392),
    [anon_sym_static_assert] = ACTIONS(3394),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [773] = {
    [sym_preproc_def] = STATE(772),
    [sym_preproc_function_def] = STATE(772),
    [sym_preproc_call] = STATE(772),
    [sym_preproc_if_in_field_declaration_list] = STATE(772),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(772),
    [sym_type_definition] = STATE(772),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5894),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6463),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(772),
    [sym_field_declaration] = STATE(772),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1708),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(772),
    [sym_operator_cast] = STATE(6999),
    [sym_inline_method_definition] = STATE(772),
    [sym__constructor_specifiers] = STATE(1708),
    [sym_operator_cast_definition] = STATE(772),
    [sym_operator_cast_declaration] = STATE(772),
    [sym_constructor_or_destructor_definition] = STATE(772),
    [sym_constructor_or_destructor_declaration] = STATE(772),
    [sym_friend_declaration] = STATE(772),
    [sym_access_specifier] = STATE(8255),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(772),
    [sym_alias_declaration] = STATE(772),
    [sym_static_assert_declaration] = STATE(772),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6999),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(772),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1708),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(3374),
    [aux_sym_preproc_if_token1] = ACTIONS(3376),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3378),
    [sym_preproc_directive] = ACTIONS(3380),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(3382),
    [anon_sym_typedef] = ACTIONS(3384),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_RBRACE] = ACTIONS(3540),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3390),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(3392),
    [anon_sym_static_assert] = ACTIONS(3394),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [774] = {
    [sym_preproc_def] = STATE(734),
    [sym_preproc_function_def] = STATE(734),
    [sym_preproc_call] = STATE(734),
    [sym_preproc_if_in_field_declaration_list] = STATE(734),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(734),
    [sym_type_definition] = STATE(734),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5980),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6420),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__field_declaration_list_item] = STATE(734),
    [sym_field_declaration] = STATE(734),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1703),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(734),
    [sym_operator_cast] = STATE(6989),
    [sym_inline_method_definition] = STATE(734),
    [sym__constructor_specifiers] = STATE(1703),
    [sym_operator_cast_definition] = STATE(734),
    [sym_operator_cast_declaration] = STATE(734),
    [sym_constructor_or_destructor_definition] = STATE(734),
    [sym_constructor_or_destructor_declaration] = STATE(734),
    [sym_friend_declaration] = STATE(734),
    [sym_access_specifier] = STATE(8657),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_using_declaration] = STATE(734),
    [sym_alias_declaration] = STATE(734),
    [sym_static_assert_declaration] = STATE(734),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5751),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6989),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(734),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1839),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1703),
    [sym_identifier] = ACTIONS(2098),
    [aux_sym_preproc_def_token1] = ACTIONS(3464),
    [aux_sym_preproc_if_token1] = ACTIONS(3466),
    [aux_sym_preproc_if_token2] = ACTIONS(3542),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3470),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3470),
    [sym_preproc_directive] = ACTIONS(3472),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(3474),
    [anon_sym_typedef] = ACTIONS(3476),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(3478),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3480),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_using] = ACTIONS(3482),
    [anon_sym_static_assert] = ACTIONS(3484),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [775] = {
    [ts_builtin_sym_end] = ACTIONS(2502),
    [sym_identifier] = ACTIONS(2500),
    [aux_sym_preproc_include_token1] = ACTIONS(2500),
    [aux_sym_preproc_def_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2500),
    [sym_preproc_directive] = ACTIONS(2500),
    [anon_sym_LPAREN2] = ACTIONS(2502),
    [anon_sym_BANG] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [anon_sym_DASH] = ACTIONS(2500),
    [anon_sym_PLUS] = ACTIONS(2500),
    [anon_sym_STAR] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2500),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_typedef] = ACTIONS(2500),
    [anon_sym___device__] = ACTIONS(2500),
    [anon_sym___host__] = ACTIONS(2500),
    [anon_sym___global__] = ACTIONS(2500),
    [anon_sym___forceinline__] = ACTIONS(2500),
    [anon_sym___noinline__] = ACTIONS(2500),
    [anon_sym_extern] = ACTIONS(2500),
    [anon_sym___attribute__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2502),
    [anon_sym___declspec] = ACTIONS(2500),
    [anon_sym___based] = ACTIONS(2500),
    [anon_sym___cdecl] = ACTIONS(2500),
    [anon_sym___clrcall] = ACTIONS(2500),
    [anon_sym___stdcall] = ACTIONS(2500),
    [anon_sym___fastcall] = ACTIONS(2500),
    [anon_sym___thiscall] = ACTIONS(2500),
    [anon_sym___vectorcall] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(2502),
    [anon_sym_signed] = ACTIONS(2500),
    [anon_sym_unsigned] = ACTIONS(2500),
    [anon_sym_long] = ACTIONS(2500),
    [anon_sym_short] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_static] = ACTIONS(2500),
    [anon_sym_register] = ACTIONS(2500),
    [anon_sym_inline] = ACTIONS(2500),
    [anon_sym___inline] = ACTIONS(2500),
    [anon_sym___inline__] = ACTIONS(2500),
    [anon_sym___forceinline] = ACTIONS(2500),
    [anon_sym_thread_local] = ACTIONS(2500),
    [anon_sym___thread] = ACTIONS(2500),
    [anon_sym_const] = ACTIONS(2500),
    [anon_sym_constexpr] = ACTIONS(2500),
    [anon_sym_volatile] = ACTIONS(2500),
    [anon_sym_restrict] = ACTIONS(2500),
    [anon_sym___restrict__] = ACTIONS(2500),
    [anon_sym__Atomic] = ACTIONS(2500),
    [anon_sym__Noreturn] = ACTIONS(2500),
    [anon_sym_noreturn] = ACTIONS(2500),
    [anon_sym_mutable] = ACTIONS(2500),
    [anon_sym_constinit] = ACTIONS(2500),
    [anon_sym_consteval] = ACTIONS(2500),
    [anon_sym___shared__] = ACTIONS(2500),
    [anon_sym___local__] = ACTIONS(2500),
    [anon_sym___constant__] = ACTIONS(2500),
    [anon_sym___managed__] = ACTIONS(2500),
    [anon_sym___grid_constant__] = ACTIONS(2500),
    [anon_sym_alignas] = ACTIONS(2500),
    [anon_sym__Alignas] = ACTIONS(2500),
    [sym_primitive_type] = ACTIONS(2500),
    [anon_sym_enum] = ACTIONS(2500),
    [anon_sym_class] = ACTIONS(2500),
    [anon_sym_struct] = ACTIONS(2500),
    [anon_sym_union] = ACTIONS(2500),
    [anon_sym_if] = ACTIONS(2500),
    [anon_sym_switch] = ACTIONS(2500),
    [anon_sym_case] = ACTIONS(2500),
    [anon_sym_default] = ACTIONS(2500),
    [anon_sym_while] = ACTIONS(2500),
    [anon_sym_do] = ACTIONS(2500),
    [anon_sym_for] = ACTIONS(2500),
    [anon_sym_return] = ACTIONS(2500),
    [anon_sym_break] = ACTIONS(2500),
    [anon_sym_continue] = ACTIONS(2500),
    [anon_sym_goto] = ACTIONS(2500),
    [anon_sym_not] = ACTIONS(2500),
    [anon_sym_compl] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(2502),
    [anon_sym_PLUS_PLUS] = ACTIONS(2502),
    [anon_sym_sizeof] = ACTIONS(2500),
    [anon_sym___alignof__] = ACTIONS(2500),
    [anon_sym___alignof] = ACTIONS(2500),
    [anon_sym__alignof] = ACTIONS(2500),
    [anon_sym_alignof] = ACTIONS(2500),
    [anon_sym__Alignof] = ACTIONS(2500),
    [anon_sym_offsetof] = ACTIONS(2500),
    [anon_sym__Generic] = ACTIONS(2500),
    [anon_sym_asm] = ACTIONS(2500),
    [anon_sym___asm__] = ACTIONS(2500),
    [sym_number_literal] = ACTIONS(2502),
    [anon_sym_L_SQUOTE] = ACTIONS(2502),
    [anon_sym_u_SQUOTE] = ACTIONS(2502),
    [anon_sym_U_SQUOTE] = ACTIONS(2502),
    [anon_sym_u8_SQUOTE] = ACTIONS(2502),
    [anon_sym_SQUOTE] = ACTIONS(2502),
    [anon_sym_L_DQUOTE] = ACTIONS(2502),
    [anon_sym_u_DQUOTE] = ACTIONS(2502),
    [anon_sym_U_DQUOTE] = ACTIONS(2502),
    [anon_sym_u8_DQUOTE] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [sym_true] = ACTIONS(2500),
    [sym_false] = ACTIONS(2500),
    [anon_sym_NULL] = ACTIONS(2500),
    [anon_sym_nullptr] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2500),
    [anon_sym_decltype] = ACTIONS(2500),
    [sym_virtual] = ACTIONS(2500),
    [anon_sym_explicit] = ACTIONS(2500),
    [anon_sym_typename] = ACTIONS(2500),
    [anon_sym_template] = ACTIONS(2500),
    [anon_sym_operator] = ACTIONS(2500),
    [anon_sym_try] = ACTIONS(2500),
    [anon_sym_delete] = ACTIONS(2500),
    [anon_sym_throw] = ACTIONS(2500),
    [anon_sym_namespace] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_static_assert] = ACTIONS(2500),
    [anon_sym_concept] = ACTIONS(2500),
    [anon_sym_co_return] = ACTIONS(2500),
    [anon_sym_co_yield] = ACTIONS(2500),
    [anon_sym_R_DQUOTE] = ACTIONS(2502),
    [anon_sym_LR_DQUOTE] = ACTIONS(2502),
    [anon_sym_uR_DQUOTE] = ACTIONS(2502),
    [anon_sym_UR_DQUOTE] = ACTIONS(2502),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2502),
    [anon_sym_co_await] = ACTIONS(2500),
    [anon_sym_new] = ACTIONS(2500),
    [anon_sym_requires] = ACTIONS(2500),
    [sym_this] = ACTIONS(2500),
    [anon_sym___launch_bounds__] = ACTIONS(2500),
  },
  [776] = {
    [sym__declaration_modifiers] = STATE(1840),
    [sym__declaration_specifiers] = STATE(6529),
    [sym_attribute_specifier] = STATE(1840),
    [sym_attribute_declaration] = STATE(1840),
    [sym_ms_declspec_modifier] = STATE(1840),
    [sym_storage_class_specifier] = STATE(1840),
    [sym_type_qualifier] = STATE(1840),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(3112),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6810),
    [sym_qualified_type_identifier] = STATE(2441),
    [sym_launch_bounds] = STATE(1840),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1840),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2507),
    [sym_identifier] = ACTIONS(3544),
    [anon_sym_COMMA] = ACTIONS(3546),
    [anon_sym_BANG] = ACTIONS(3548),
    [anon_sym_TILDE] = ACTIONS(3546),
    [anon_sym_DASH] = ACTIONS(3548),
    [anon_sym_PLUS] = ACTIONS(3548),
    [anon_sym_STAR] = ACTIONS(3548),
    [anon_sym_SLASH] = ACTIONS(3548),
    [anon_sym_PERCENT] = ACTIONS(3548),
    [anon_sym_PIPE_PIPE] = ACTIONS(3546),
    [anon_sym_AMP_AMP] = ACTIONS(3546),
    [anon_sym_PIPE] = ACTIONS(3548),
    [anon_sym_CARET] = ACTIONS(3548),
    [anon_sym_AMP] = ACTIONS(3548),
    [anon_sym_EQ_EQ] = ACTIONS(3546),
    [anon_sym_BANG_EQ] = ACTIONS(3546),
    [anon_sym_GT] = ACTIONS(3548),
    [anon_sym_GT_EQ] = ACTIONS(3546),
    [anon_sym_LT_EQ] = ACTIONS(3548),
    [anon_sym_LT] = ACTIONS(3548),
    [anon_sym_LT_LT] = ACTIONS(3548),
    [anon_sym_GT_GT] = ACTIONS(3548),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(3550),
    [anon_sym___host__] = ACTIONS(3550),
    [anon_sym___global__] = ACTIONS(3550),
    [anon_sym___forceinline__] = ACTIONS(3550),
    [anon_sym___noinline__] = ACTIONS(3550),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3552),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(3554),
    [anon_sym_unsigned] = ACTIONS(3554),
    [anon_sym_long] = ACTIONS(3554),
    [anon_sym_short] = ACTIONS(3554),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_EQ] = ACTIONS(3548),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(3556),
    [anon_sym_enum] = ACTIONS(3558),
    [anon_sym_class] = ACTIONS(3560),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3564),
    [anon_sym_STAR_EQ] = ACTIONS(3546),
    [anon_sym_SLASH_EQ] = ACTIONS(3546),
    [anon_sym_PERCENT_EQ] = ACTIONS(3546),
    [anon_sym_PLUS_EQ] = ACTIONS(3546),
    [anon_sym_DASH_EQ] = ACTIONS(3546),
    [anon_sym_LT_LT_EQ] = ACTIONS(3546),
    [anon_sym_GT_GT_EQ] = ACTIONS(3546),
    [anon_sym_AMP_EQ] = ACTIONS(3546),
    [anon_sym_CARET_EQ] = ACTIONS(3546),
    [anon_sym_PIPE_EQ] = ACTIONS(3546),
    [anon_sym_and_eq] = ACTIONS(3548),
    [anon_sym_or_eq] = ACTIONS(3548),
    [anon_sym_xor_eq] = ACTIONS(3548),
    [anon_sym_not] = ACTIONS(3548),
    [anon_sym_compl] = ACTIONS(3548),
    [anon_sym_LT_EQ_GT] = ACTIONS(3546),
    [anon_sym_or] = ACTIONS(3548),
    [anon_sym_and] = ACTIONS(3548),
    [anon_sym_bitor] = ACTIONS(3548),
    [anon_sym_xor] = ACTIONS(3548),
    [anon_sym_bitand] = ACTIONS(3548),
    [anon_sym_not_eq] = ACTIONS(3548),
    [anon_sym_DASH_DASH] = ACTIONS(3546),
    [anon_sym_PLUS_PLUS] = ACTIONS(3546),
    [anon_sym_DASH_GT] = ACTIONS(3548),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(3550),
    [anon_sym_typename] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3568),
    [anon_sym_co_await] = ACTIONS(3548),
    [anon_sym_new] = ACTIONS(3568),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3546),
    [anon_sym_LPAREN_RPAREN] = ACTIONS(3546),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3546),
    [anon_sym_DQUOTE_DQUOTE] = ACTIONS(3570),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [777] = {
    [sym__declaration_modifiers] = STATE(1840),
    [sym__declaration_specifiers] = STATE(6529),
    [sym_attribute_specifier] = STATE(1840),
    [sym_attribute_declaration] = STATE(1840),
    [sym_ms_declspec_modifier] = STATE(1840),
    [sym_storage_class_specifier] = STATE(1840),
    [sym_type_qualifier] = STATE(1840),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(3112),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6810),
    [sym_qualified_type_identifier] = STATE(2441),
    [sym_launch_bounds] = STATE(1840),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1840),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2507),
    [sym_identifier] = ACTIONS(3544),
    [anon_sym_COMMA] = ACTIONS(3572),
    [anon_sym_BANG] = ACTIONS(3574),
    [anon_sym_TILDE] = ACTIONS(3572),
    [anon_sym_DASH] = ACTIONS(3574),
    [anon_sym_PLUS] = ACTIONS(3574),
    [anon_sym_STAR] = ACTIONS(3574),
    [anon_sym_SLASH] = ACTIONS(3574),
    [anon_sym_PERCENT] = ACTIONS(3574),
    [anon_sym_PIPE_PIPE] = ACTIONS(3572),
    [anon_sym_AMP_AMP] = ACTIONS(3572),
    [anon_sym_PIPE] = ACTIONS(3574),
    [anon_sym_CARET] = ACTIONS(3574),
    [anon_sym_AMP] = ACTIONS(3574),
    [anon_sym_EQ_EQ] = ACTIONS(3572),
    [anon_sym_BANG_EQ] = ACTIONS(3572),
    [anon_sym_GT] = ACTIONS(3574),
    [anon_sym_GT_EQ] = ACTIONS(3572),
    [anon_sym_LT_EQ] = ACTIONS(3574),
    [anon_sym_LT] = ACTIONS(3574),
    [anon_sym_LT_LT] = ACTIONS(3574),
    [anon_sym_GT_GT] = ACTIONS(3574),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(3550),
    [anon_sym___host__] = ACTIONS(3550),
    [anon_sym___global__] = ACTIONS(3550),
    [anon_sym___forceinline__] = ACTIONS(3550),
    [anon_sym___noinline__] = ACTIONS(3550),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3552),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(3554),
    [anon_sym_unsigned] = ACTIONS(3554),
    [anon_sym_long] = ACTIONS(3554),
    [anon_sym_short] = ACTIONS(3554),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_EQ] = ACTIONS(3574),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(3556),
    [anon_sym_enum] = ACTIONS(3558),
    [anon_sym_class] = ACTIONS(3560),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3564),
    [anon_sym_STAR_EQ] = ACTIONS(3572),
    [anon_sym_SLASH_EQ] = ACTIONS(3572),
    [anon_sym_PERCENT_EQ] = ACTIONS(3572),
    [anon_sym_PLUS_EQ] = ACTIONS(3572),
    [anon_sym_DASH_EQ] = ACTIONS(3572),
    [anon_sym_LT_LT_EQ] = ACTIONS(3572),
    [anon_sym_GT_GT_EQ] = ACTIONS(3572),
    [anon_sym_AMP_EQ] = ACTIONS(3572),
    [anon_sym_CARET_EQ] = ACTIONS(3572),
    [anon_sym_PIPE_EQ] = ACTIONS(3572),
    [anon_sym_and_eq] = ACTIONS(3574),
    [anon_sym_or_eq] = ACTIONS(3574),
    [anon_sym_xor_eq] = ACTIONS(3574),
    [anon_sym_not] = ACTIONS(3574),
    [anon_sym_compl] = ACTIONS(3574),
    [anon_sym_LT_EQ_GT] = ACTIONS(3572),
    [anon_sym_or] = ACTIONS(3574),
    [anon_sym_and] = ACTIONS(3574),
    [anon_sym_bitor] = ACTIONS(3574),
    [anon_sym_xor] = ACTIONS(3574),
    [anon_sym_bitand] = ACTIONS(3574),
    [anon_sym_not_eq] = ACTIONS(3574),
    [anon_sym_DASH_DASH] = ACTIONS(3572),
    [anon_sym_PLUS_PLUS] = ACTIONS(3572),
    [anon_sym_DASH_GT] = ACTIONS(3574),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(3550),
    [anon_sym_typename] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3576),
    [anon_sym_co_await] = ACTIONS(3574),
    [anon_sym_new] = ACTIONS(3576),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3572),
    [anon_sym_LPAREN_RPAREN] = ACTIONS(3572),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3572),
    [anon_sym_DQUOTE_DQUOTE] = ACTIONS(3578),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [778] = {
    [sym_expression] = STATE(4339),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3068),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3068),
    [sym_call_expression] = STATE(3068),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3068),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3068),
    [sym_initializer_list] = STATE(4246),
    [sym_char_literal] = STATE(4482),
    [sym_concatenated_string] = STATE(4479),
    [sym_string_literal] = STATE(3097),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3096),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3068),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3068),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2508),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2510),
    [aux_sym_preproc_if_token2] = ACTIONS(2510),
    [aux_sym_preproc_else_token1] = ACTIONS(2510),
    [aux_sym_preproc_elif_token1] = ACTIONS(2508),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2510),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_BANG] = ACTIONS(3580),
    [anon_sym_TILDE] = ACTIONS(3582),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2508),
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_SLASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2510),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_PIPE] = ACTIONS(2508),
    [anon_sym_CARET] = ACTIONS(2510),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_EQ_EQ] = ACTIONS(2510),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_GT] = ACTIONS(2508),
    [anon_sym_GT_EQ] = ACTIONS(2510),
    [anon_sym_LT_EQ] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_LT_LT] = ACTIONS(2508),
    [anon_sym_GT_GT] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_compl] = ACTIONS(3580),
    [anon_sym_LT_EQ_GT] = ACTIONS(2510),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_bitor] = ACTIONS(2508),
    [anon_sym_xor] = ACTIONS(2508),
    [anon_sym_bitand] = ACTIONS(2508),
    [anon_sym_not_eq] = ACTIONS(2508),
    [anon_sym_DASH_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_PLUS] = ACTIONS(2510),
    [anon_sym_sizeof] = ACTIONS(3588),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(2508),
    [anon_sym_DOT_STAR] = ACTIONS(2510),
    [anon_sym_DASH_GT] = ACTIONS(2510),
    [sym_number_literal] = ACTIONS(3590),
    [anon_sym_L_SQUOTE] = ACTIONS(3592),
    [anon_sym_u_SQUOTE] = ACTIONS(3592),
    [anon_sym_U_SQUOTE] = ACTIONS(3592),
    [anon_sym_u8_SQUOTE] = ACTIONS(3592),
    [anon_sym_SQUOTE] = ACTIONS(3592),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3596),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [anon_sym_co_await] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_requires] = ACTIONS(3604),
    [sym_this] = ACTIONS(221),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(2510),
  },
  [779] = {
    [sym_function_definition] = STATE(523),
    [sym_declaration] = STATE(523),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6421),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__empty_declaration] = STATE(523),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1705),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(523),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1705),
    [sym_operator_cast_definition] = STATE(523),
    [sym_operator_cast_declaration] = STATE(523),
    [sym_constructor_or_destructor_definition] = STATE(523),
    [sym_constructor_or_destructor_declaration] = STATE(523),
    [sym_friend_declaration] = STATE(523),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_alias_declaration] = STATE(523),
    [sym_concept_definition] = STATE(523),
    [sym_requires_clause] = STATE(792),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5744),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1705),
    [sym_identifier] = ACTIONS(3606),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(3610),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3612),
    [anon_sym_using] = ACTIONS(3614),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_requires] = ACTIONS(3616),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [780] = {
    [sym_function_definition] = STATE(1923),
    [sym_declaration] = STATE(1923),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5320),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1819),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6420),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2283),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__empty_declaration] = STATE(1923),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1703),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(1923),
    [sym_operator_cast] = STATE(6989),
    [sym__constructor_specifiers] = STATE(1703),
    [sym_operator_cast_definition] = STATE(1923),
    [sym_operator_cast_declaration] = STATE(1923),
    [sym_constructor_or_destructor_definition] = STATE(1923),
    [sym_constructor_or_destructor_declaration] = STATE(1923),
    [sym_friend_declaration] = STATE(1923),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_alias_declaration] = STATE(1923),
    [sym_concept_definition] = STATE(1923),
    [sym_requires_clause] = STATE(800),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5744),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6989),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1703),
    [sym_identifier] = ACTIONS(3606),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(3478),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3480),
    [anon_sym_using] = ACTIONS(3618),
    [anon_sym_concept] = ACTIONS(3620),
    [anon_sym_requires] = ACTIONS(3616),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [781] = {
    [sym_function_definition] = STATE(2010),
    [sym_declaration] = STATE(2010),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5200),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1821),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6463),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2277),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__empty_declaration] = STATE(2010),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1708),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(2010),
    [sym_operator_cast] = STATE(6999),
    [sym__constructor_specifiers] = STATE(1708),
    [sym_operator_cast_definition] = STATE(2010),
    [sym_operator_cast_declaration] = STATE(2010),
    [sym_constructor_or_destructor_definition] = STATE(2010),
    [sym_constructor_or_destructor_declaration] = STATE(2010),
    [sym_friend_declaration] = STATE(2010),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_alias_declaration] = STATE(2010),
    [sym_concept_definition] = STATE(2010),
    [sym_requires_clause] = STATE(790),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5744),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6999),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1708),
    [sym_identifier] = ACTIONS(3606),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3390),
    [anon_sym_using] = ACTIONS(3622),
    [anon_sym_concept] = ACTIONS(3624),
    [anon_sym_requires] = ACTIONS(3616),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [782] = {
    [sym_function_definition] = STATE(207),
    [sym_declaration] = STATE(207),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5266),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1824),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6397),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2275),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__empty_declaration] = STATE(207),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1697),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(207),
    [sym_operator_cast] = STATE(6995),
    [sym__constructor_specifiers] = STATE(1697),
    [sym_operator_cast_definition] = STATE(207),
    [sym_operator_cast_declaration] = STATE(207),
    [sym_constructor_or_destructor_definition] = STATE(207),
    [sym_constructor_or_destructor_declaration] = STATE(207),
    [sym_friend_declaration] = STATE(207),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_alias_declaration] = STATE(207),
    [sym_concept_definition] = STATE(207),
    [sym_requires_clause] = STATE(797),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5744),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6995),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1697),
    [sym_identifier] = ACTIONS(3606),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(3626),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3628),
    [anon_sym_using] = ACTIONS(3630),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_requires] = ACTIONS(3616),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [783] = {
    [sym_function_definition] = STATE(1814),
    [sym_declaration] = STATE(1814),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5258),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1820),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6464),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2256),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__empty_declaration] = STATE(1814),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1701),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(1814),
    [sym_operator_cast] = STATE(6994),
    [sym__constructor_specifiers] = STATE(1701),
    [sym_operator_cast_definition] = STATE(1814),
    [sym_operator_cast_declaration] = STATE(1814),
    [sym_constructor_or_destructor_definition] = STATE(1814),
    [sym_constructor_or_destructor_declaration] = STATE(1814),
    [sym_friend_declaration] = STATE(1814),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_alias_declaration] = STATE(1814),
    [sym_concept_definition] = STATE(1814),
    [sym_requires_clause] = STATE(795),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5744),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6994),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1701),
    [sym_identifier] = ACTIONS(3606),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(2144),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2146),
    [anon_sym_using] = ACTIONS(3632),
    [anon_sym_concept] = ACTIONS(3634),
    [anon_sym_requires] = ACTIONS(3616),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [784] = {
    [sym_function_definition] = STATE(758),
    [sym_declaration] = STATE(758),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5203),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1822),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6411),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2248),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__empty_declaration] = STATE(758),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1699),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(758),
    [sym_operator_cast] = STATE(7006),
    [sym__constructor_specifiers] = STATE(1699),
    [sym_operator_cast_definition] = STATE(758),
    [sym_operator_cast_declaration] = STATE(758),
    [sym_constructor_or_destructor_definition] = STATE(758),
    [sym_constructor_or_destructor_declaration] = STATE(758),
    [sym_friend_declaration] = STATE(758),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_alias_declaration] = STATE(758),
    [sym_concept_definition] = STATE(758),
    [sym_requires_clause] = STATE(791),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5744),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(7006),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1699),
    [sym_identifier] = ACTIONS(3606),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(3636),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3638),
    [anon_sym_using] = ACTIONS(3640),
    [anon_sym_concept] = ACTIONS(145),
    [anon_sym_requires] = ACTIONS(3616),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [785] = {
    [sym_function_definition] = STATE(476),
    [sym_declaration] = STATE(476),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5201),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1837),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6394),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2274),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__empty_declaration] = STATE(476),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1702),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(476),
    [sym_operator_cast] = STATE(7017),
    [sym__constructor_specifiers] = STATE(1702),
    [sym_operator_cast_definition] = STATE(476),
    [sym_operator_cast_declaration] = STATE(476),
    [sym_constructor_or_destructor_definition] = STATE(476),
    [sym_constructor_or_destructor_declaration] = STATE(476),
    [sym_friend_declaration] = STATE(476),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_alias_declaration] = STATE(476),
    [sym_concept_definition] = STATE(476),
    [sym_requires_clause] = STATE(796),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5744),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(7017),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1702),
    [sym_identifier] = ACTIONS(3606),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(3642),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3644),
    [anon_sym_using] = ACTIONS(3646),
    [anon_sym_concept] = ACTIONS(701),
    [anon_sym_requires] = ACTIONS(3616),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [786] = {
    [sym_expression] = STATE(4535),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(4246),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2510),
    [anon_sym_RPAREN] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2508),
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_SLASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2510),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_PIPE] = ACTIONS(2508),
    [anon_sym_CARET] = ACTIONS(2510),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_EQ_EQ] = ACTIONS(2510),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_GT] = ACTIONS(2508),
    [anon_sym_GT_EQ] = ACTIONS(2510),
    [anon_sym_LT_EQ] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_LT_LT] = ACTIONS(2508),
    [anon_sym_GT_GT] = ACTIONS(2510),
    [anon_sym_SEMI] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_LT_EQ_GT] = ACTIONS(2510),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_bitor] = ACTIONS(2508),
    [anon_sym_xor] = ACTIONS(2508),
    [anon_sym_bitand] = ACTIONS(2508),
    [anon_sym_not_eq] = ACTIONS(2508),
    [anon_sym_DASH_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_PLUS] = ACTIONS(2510),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(2508),
    [anon_sym_DOT_STAR] = ACTIONS(2510),
    [anon_sym_DASH_GT] = ACTIONS(2510),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(2510),
  },
  [787] = {
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_COMMA] = ACTIONS(3650),
    [anon_sym_RPAREN] = ACTIONS(3650),
    [anon_sym_LPAREN2] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3648),
    [anon_sym_PLUS] = ACTIONS(3648),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_AMP_AMP] = ACTIONS(3650),
    [anon_sym_AMP] = ACTIONS(3648),
    [anon_sym_SEMI] = ACTIONS(3650),
    [anon_sym___extension__] = ACTIONS(3648),
    [anon_sym___device__] = ACTIONS(3648),
    [anon_sym___host__] = ACTIONS(3648),
    [anon_sym___global__] = ACTIONS(3648),
    [anon_sym___forceinline__] = ACTIONS(3648),
    [anon_sym___noinline__] = ACTIONS(3648),
    [anon_sym_extern] = ACTIONS(3648),
    [anon_sym___attribute__] = ACTIONS(3648),
    [anon_sym_COLON_COLON] = ACTIONS(3650),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3650),
    [anon_sym___declspec] = ACTIONS(3648),
    [anon_sym___based] = ACTIONS(3648),
    [anon_sym_LBRACE] = ACTIONS(3650),
    [anon_sym_signed] = ACTIONS(3648),
    [anon_sym_unsigned] = ACTIONS(3648),
    [anon_sym_long] = ACTIONS(3648),
    [anon_sym_short] = ACTIONS(3648),
    [anon_sym_LBRACK] = ACTIONS(3648),
    [anon_sym_static] = ACTIONS(3648),
    [anon_sym_EQ] = ACTIONS(3650),
    [anon_sym_register] = ACTIONS(3648),
    [anon_sym_inline] = ACTIONS(3648),
    [anon_sym___inline] = ACTIONS(3648),
    [anon_sym___inline__] = ACTIONS(3648),
    [anon_sym___forceinline] = ACTIONS(3648),
    [anon_sym_thread_local] = ACTIONS(3648),
    [anon_sym___thread] = ACTIONS(3648),
    [anon_sym_const] = ACTIONS(3648),
    [anon_sym_constexpr] = ACTIONS(3648),
    [anon_sym_volatile] = ACTIONS(3648),
    [anon_sym_restrict] = ACTIONS(3648),
    [anon_sym___restrict__] = ACTIONS(3648),
    [anon_sym__Atomic] = ACTIONS(3648),
    [anon_sym__Noreturn] = ACTIONS(3648),
    [anon_sym_noreturn] = ACTIONS(3648),
    [anon_sym_mutable] = ACTIONS(3648),
    [anon_sym_constinit] = ACTIONS(3648),
    [anon_sym_consteval] = ACTIONS(3648),
    [anon_sym___shared__] = ACTIONS(3648),
    [anon_sym___local__] = ACTIONS(3648),
    [anon_sym___constant__] = ACTIONS(3648),
    [anon_sym___managed__] = ACTIONS(3648),
    [anon_sym___grid_constant__] = ACTIONS(3648),
    [anon_sym_alignas] = ACTIONS(3648),
    [anon_sym__Alignas] = ACTIONS(3648),
    [sym_primitive_type] = ACTIONS(3648),
    [anon_sym_enum] = ACTIONS(3648),
    [anon_sym_class] = ACTIONS(3648),
    [anon_sym_struct] = ACTIONS(3648),
    [anon_sym_union] = ACTIONS(3648),
    [anon_sym_if] = ACTIONS(3648),
    [anon_sym_switch] = ACTIONS(3648),
    [anon_sym_case] = ACTIONS(3648),
    [anon_sym_default] = ACTIONS(3648),
    [anon_sym_while] = ACTIONS(3648),
    [anon_sym_do] = ACTIONS(3648),
    [anon_sym_for] = ACTIONS(3648),
    [anon_sym_return] = ACTIONS(3648),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_continue] = ACTIONS(3648),
    [anon_sym_goto] = ACTIONS(3648),
    [anon_sym___try] = ACTIONS(3648),
    [anon_sym___leave] = ACTIONS(3648),
    [anon_sym_not] = ACTIONS(3648),
    [anon_sym_compl] = ACTIONS(3648),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_sizeof] = ACTIONS(3648),
    [anon_sym___alignof__] = ACTIONS(3648),
    [anon_sym___alignof] = ACTIONS(3648),
    [anon_sym__alignof] = ACTIONS(3648),
    [anon_sym_alignof] = ACTIONS(3648),
    [anon_sym__Alignof] = ACTIONS(3648),
    [anon_sym_offsetof] = ACTIONS(3648),
    [anon_sym__Generic] = ACTIONS(3648),
    [anon_sym_asm] = ACTIONS(3648),
    [anon_sym___asm__] = ACTIONS(3648),
    [sym_number_literal] = ACTIONS(3650),
    [anon_sym_L_SQUOTE] = ACTIONS(3650),
    [anon_sym_u_SQUOTE] = ACTIONS(3650),
    [anon_sym_U_SQUOTE] = ACTIONS(3650),
    [anon_sym_u8_SQUOTE] = ACTIONS(3650),
    [anon_sym_SQUOTE] = ACTIONS(3650),
    [anon_sym_L_DQUOTE] = ACTIONS(3650),
    [anon_sym_u_DQUOTE] = ACTIONS(3650),
    [anon_sym_U_DQUOTE] = ACTIONS(3650),
    [anon_sym_u8_DQUOTE] = ACTIONS(3650),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [sym_true] = ACTIONS(3648),
    [sym_false] = ACTIONS(3648),
    [anon_sym_NULL] = ACTIONS(3648),
    [anon_sym_nullptr] = ACTIONS(3648),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3648),
    [anon_sym_decltype] = ACTIONS(3648),
    [sym_virtual] = ACTIONS(3648),
    [anon_sym_explicit] = ACTIONS(3648),
    [anon_sym_typename] = ACTIONS(3648),
    [anon_sym_template] = ACTIONS(3648),
    [anon_sym_GT2] = ACTIONS(3650),
    [anon_sym_operator] = ACTIONS(3648),
    [anon_sym_try] = ACTIONS(3648),
    [anon_sym_delete] = ACTIONS(3648),
    [anon_sym_throw] = ACTIONS(3648),
    [anon_sym_co_return] = ACTIONS(3648),
    [anon_sym_co_yield] = ACTIONS(3648),
    [anon_sym_R_DQUOTE] = ACTIONS(3650),
    [anon_sym_LR_DQUOTE] = ACTIONS(3650),
    [anon_sym_uR_DQUOTE] = ACTIONS(3650),
    [anon_sym_UR_DQUOTE] = ACTIONS(3650),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3650),
    [anon_sym_co_await] = ACTIONS(3648),
    [anon_sym_new] = ACTIONS(3648),
    [anon_sym_requires] = ACTIONS(3648),
    [sym_this] = ACTIONS(3648),
    [anon_sym___launch_bounds__] = ACTIONS(3648),
  },
  [788] = {
    [sym_identifier] = ACTIONS(3652),
    [anon_sym_COMMA] = ACTIONS(3654),
    [anon_sym_RPAREN] = ACTIONS(3654),
    [anon_sym_LPAREN2] = ACTIONS(3654),
    [anon_sym_BANG] = ACTIONS(3654),
    [anon_sym_TILDE] = ACTIONS(3654),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_AMP_AMP] = ACTIONS(3654),
    [anon_sym_AMP] = ACTIONS(3652),
    [anon_sym_SEMI] = ACTIONS(3654),
    [anon_sym___extension__] = ACTIONS(3652),
    [anon_sym___device__] = ACTIONS(3652),
    [anon_sym___host__] = ACTIONS(3652),
    [anon_sym___global__] = ACTIONS(3652),
    [anon_sym___forceinline__] = ACTIONS(3652),
    [anon_sym___noinline__] = ACTIONS(3652),
    [anon_sym_extern] = ACTIONS(3652),
    [anon_sym___attribute__] = ACTIONS(3652),
    [anon_sym_COLON_COLON] = ACTIONS(3654),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3654),
    [anon_sym___declspec] = ACTIONS(3652),
    [anon_sym___based] = ACTIONS(3652),
    [anon_sym_LBRACE] = ACTIONS(3654),
    [anon_sym_signed] = ACTIONS(3652),
    [anon_sym_unsigned] = ACTIONS(3652),
    [anon_sym_long] = ACTIONS(3652),
    [anon_sym_short] = ACTIONS(3652),
    [anon_sym_LBRACK] = ACTIONS(3652),
    [anon_sym_static] = ACTIONS(3652),
    [anon_sym_EQ] = ACTIONS(3654),
    [anon_sym_register] = ACTIONS(3652),
    [anon_sym_inline] = ACTIONS(3652),
    [anon_sym___inline] = ACTIONS(3652),
    [anon_sym___inline__] = ACTIONS(3652),
    [anon_sym___forceinline] = ACTIONS(3652),
    [anon_sym_thread_local] = ACTIONS(3652),
    [anon_sym___thread] = ACTIONS(3652),
    [anon_sym_const] = ACTIONS(3652),
    [anon_sym_constexpr] = ACTIONS(3652),
    [anon_sym_volatile] = ACTIONS(3652),
    [anon_sym_restrict] = ACTIONS(3652),
    [anon_sym___restrict__] = ACTIONS(3652),
    [anon_sym__Atomic] = ACTIONS(3652),
    [anon_sym__Noreturn] = ACTIONS(3652),
    [anon_sym_noreturn] = ACTIONS(3652),
    [anon_sym_mutable] = ACTIONS(3652),
    [anon_sym_constinit] = ACTIONS(3652),
    [anon_sym_consteval] = ACTIONS(3652),
    [anon_sym___shared__] = ACTIONS(3652),
    [anon_sym___local__] = ACTIONS(3652),
    [anon_sym___constant__] = ACTIONS(3652),
    [anon_sym___managed__] = ACTIONS(3652),
    [anon_sym___grid_constant__] = ACTIONS(3652),
    [anon_sym_alignas] = ACTIONS(3652),
    [anon_sym__Alignas] = ACTIONS(3652),
    [sym_primitive_type] = ACTIONS(3652),
    [anon_sym_enum] = ACTIONS(3652),
    [anon_sym_class] = ACTIONS(3652),
    [anon_sym_struct] = ACTIONS(3652),
    [anon_sym_union] = ACTIONS(3652),
    [anon_sym_if] = ACTIONS(3652),
    [anon_sym_switch] = ACTIONS(3652),
    [anon_sym_case] = ACTIONS(3652),
    [anon_sym_default] = ACTIONS(3652),
    [anon_sym_while] = ACTIONS(3652),
    [anon_sym_do] = ACTIONS(3652),
    [anon_sym_for] = ACTIONS(3652),
    [anon_sym_return] = ACTIONS(3652),
    [anon_sym_break] = ACTIONS(3652),
    [anon_sym_continue] = ACTIONS(3652),
    [anon_sym_goto] = ACTIONS(3652),
    [anon_sym___try] = ACTIONS(3652),
    [anon_sym___leave] = ACTIONS(3652),
    [anon_sym_not] = ACTIONS(3652),
    [anon_sym_compl] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3654),
    [anon_sym_PLUS_PLUS] = ACTIONS(3654),
    [anon_sym_sizeof] = ACTIONS(3652),
    [anon_sym___alignof__] = ACTIONS(3652),
    [anon_sym___alignof] = ACTIONS(3652),
    [anon_sym__alignof] = ACTIONS(3652),
    [anon_sym_alignof] = ACTIONS(3652),
    [anon_sym__Alignof] = ACTIONS(3652),
    [anon_sym_offsetof] = ACTIONS(3652),
    [anon_sym__Generic] = ACTIONS(3652),
    [anon_sym_asm] = ACTIONS(3652),
    [anon_sym___asm__] = ACTIONS(3652),
    [sym_number_literal] = ACTIONS(3654),
    [anon_sym_L_SQUOTE] = ACTIONS(3654),
    [anon_sym_u_SQUOTE] = ACTIONS(3654),
    [anon_sym_U_SQUOTE] = ACTIONS(3654),
    [anon_sym_u8_SQUOTE] = ACTIONS(3654),
    [anon_sym_SQUOTE] = ACTIONS(3654),
    [anon_sym_L_DQUOTE] = ACTIONS(3654),
    [anon_sym_u_DQUOTE] = ACTIONS(3654),
    [anon_sym_U_DQUOTE] = ACTIONS(3654),
    [anon_sym_u8_DQUOTE] = ACTIONS(3654),
    [anon_sym_DQUOTE] = ACTIONS(3654),
    [sym_true] = ACTIONS(3652),
    [sym_false] = ACTIONS(3652),
    [anon_sym_NULL] = ACTIONS(3652),
    [anon_sym_nullptr] = ACTIONS(3652),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3652),
    [anon_sym_decltype] = ACTIONS(3652),
    [sym_virtual] = ACTIONS(3652),
    [anon_sym_explicit] = ACTIONS(3652),
    [anon_sym_typename] = ACTIONS(3652),
    [anon_sym_template] = ACTIONS(3652),
    [anon_sym_GT2] = ACTIONS(3654),
    [anon_sym_operator] = ACTIONS(3652),
    [anon_sym_try] = ACTIONS(3652),
    [anon_sym_delete] = ACTIONS(3652),
    [anon_sym_throw] = ACTIONS(3652),
    [anon_sym_co_return] = ACTIONS(3652),
    [anon_sym_co_yield] = ACTIONS(3652),
    [anon_sym_R_DQUOTE] = ACTIONS(3654),
    [anon_sym_LR_DQUOTE] = ACTIONS(3654),
    [anon_sym_uR_DQUOTE] = ACTIONS(3654),
    [anon_sym_UR_DQUOTE] = ACTIONS(3654),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3654),
    [anon_sym_co_await] = ACTIONS(3652),
    [anon_sym_new] = ACTIONS(3652),
    [anon_sym_requires] = ACTIONS(3652),
    [sym_this] = ACTIONS(3652),
    [anon_sym___launch_bounds__] = ACTIONS(3652),
  },
  [789] = {
    [sym_expression] = STATE(4535),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_initializer_list] = STATE(4246),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2508),
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_SLASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2510),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_PIPE] = ACTIONS(2508),
    [anon_sym_CARET] = ACTIONS(2510),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_EQ_EQ] = ACTIONS(2510),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_GT] = ACTIONS(2508),
    [anon_sym_GT_EQ] = ACTIONS(2510),
    [anon_sym_LT_EQ] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_LT_LT] = ACTIONS(2508),
    [anon_sym_GT_GT] = ACTIONS(2510),
    [anon_sym_SEMI] = ACTIONS(2510),
    [anon_sym___attribute__] = ACTIONS(2508),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_LT_EQ_GT] = ACTIONS(2510),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_bitor] = ACTIONS(2508),
    [anon_sym_xor] = ACTIONS(2508),
    [anon_sym_bitand] = ACTIONS(2508),
    [anon_sym_not_eq] = ACTIONS(2508),
    [anon_sym_DASH_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_PLUS] = ACTIONS(2510),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(2508),
    [anon_sym_DOT_STAR] = ACTIONS(2510),
    [anon_sym_DASH_GT] = ACTIONS(2510),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(2510),
  },
  [790] = {
    [sym_function_definition] = STATE(2040),
    [sym_declaration] = STATE(2040),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5200),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1821),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6463),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2277),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__empty_declaration] = STATE(2040),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1708),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(2040),
    [sym_operator_cast] = STATE(6999),
    [sym__constructor_specifiers] = STATE(1708),
    [sym_operator_cast_definition] = STATE(2040),
    [sym_operator_cast_declaration] = STATE(2040),
    [sym_constructor_or_destructor_definition] = STATE(2040),
    [sym_constructor_or_destructor_declaration] = STATE(2040),
    [sym_friend_declaration] = STATE(2040),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_alias_declaration] = STATE(2040),
    [sym_concept_definition] = STATE(2040),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5744),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6999),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1708),
    [sym_identifier] = ACTIONS(3606),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(3388),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3390),
    [anon_sym_using] = ACTIONS(3622),
    [anon_sym_concept] = ACTIONS(3624),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [791] = {
    [sym_function_definition] = STATE(681),
    [sym_declaration] = STATE(681),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5203),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1822),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6411),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2248),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__empty_declaration] = STATE(681),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1699),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(681),
    [sym_operator_cast] = STATE(7006),
    [sym__constructor_specifiers] = STATE(1699),
    [sym_operator_cast_definition] = STATE(681),
    [sym_operator_cast_declaration] = STATE(681),
    [sym_constructor_or_destructor_definition] = STATE(681),
    [sym_constructor_or_destructor_declaration] = STATE(681),
    [sym_friend_declaration] = STATE(681),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_alias_declaration] = STATE(681),
    [sym_concept_definition] = STATE(681),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5744),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(7006),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1699),
    [sym_identifier] = ACTIONS(3606),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(3636),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3638),
    [anon_sym_using] = ACTIONS(3640),
    [anon_sym_concept] = ACTIONS(145),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [792] = {
    [sym_function_definition] = STATE(552),
    [sym_declaration] = STATE(552),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1835),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6421),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2278),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__empty_declaration] = STATE(552),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1705),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(552),
    [sym_operator_cast] = STATE(7000),
    [sym__constructor_specifiers] = STATE(1705),
    [sym_operator_cast_definition] = STATE(552),
    [sym_operator_cast_declaration] = STATE(552),
    [sym_constructor_or_destructor_definition] = STATE(552),
    [sym_constructor_or_destructor_declaration] = STATE(552),
    [sym_friend_declaration] = STATE(552),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_alias_declaration] = STATE(552),
    [sym_concept_definition] = STATE(552),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5744),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(7000),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1705),
    [sym_identifier] = ACTIONS(3606),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(3610),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3612),
    [anon_sym_using] = ACTIONS(3614),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [793] = {
    [sym_expression] = STATE(4339),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_initializer_list] = STATE(4246),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_BANG] = ACTIONS(3680),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2508),
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_SLASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2510),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_PIPE] = ACTIONS(2508),
    [anon_sym_CARET] = ACTIONS(2510),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_EQ_EQ] = ACTIONS(2510),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_GT] = ACTIONS(2508),
    [anon_sym_GT_EQ] = ACTIONS(2510),
    [anon_sym_LT_EQ] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_LT_LT] = ACTIONS(2508),
    [anon_sym_GT_GT] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_RBRACK] = ACTIONS(2510),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_LT_EQ_GT] = ACTIONS(2510),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_bitor] = ACTIONS(2508),
    [anon_sym_xor] = ACTIONS(2508),
    [anon_sym_bitand] = ACTIONS(2508),
    [anon_sym_not_eq] = ACTIONS(2508),
    [anon_sym_DASH_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_PLUS] = ACTIONS(2510),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(2508),
    [anon_sym_DOT_STAR] = ACTIONS(2510),
    [anon_sym_DASH_GT] = ACTIONS(2510),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(2510),
  },
  [794] = {
    [sym_expression] = STATE(4925),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_initializer_list] = STATE(4246),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_BANG] = ACTIONS(3696),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2508),
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_SLASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2510),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_PIPE] = ACTIONS(2508),
    [anon_sym_CARET] = ACTIONS(2510),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_EQ_EQ] = ACTIONS(2510),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_GT] = ACTIONS(2508),
    [anon_sym_GT_EQ] = ACTIONS(2510),
    [anon_sym_LT_EQ] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_LT_LT] = ACTIONS(2508),
    [anon_sym_GT_GT] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_COLON] = ACTIONS(2508),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_LT_EQ_GT] = ACTIONS(2510),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_bitor] = ACTIONS(2508),
    [anon_sym_xor] = ACTIONS(2508),
    [anon_sym_bitand] = ACTIONS(2508),
    [anon_sym_not_eq] = ACTIONS(2508),
    [anon_sym_DASH_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_PLUS] = ACTIONS(2510),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(2508),
    [anon_sym_DOT_STAR] = ACTIONS(2510),
    [anon_sym_DASH_GT] = ACTIONS(2510),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(2510),
  },
  [795] = {
    [sym_function_definition] = STATE(1800),
    [sym_declaration] = STATE(1800),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5258),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1820),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6464),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2256),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__empty_declaration] = STATE(1800),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1701),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(1800),
    [sym_operator_cast] = STATE(6994),
    [sym__constructor_specifiers] = STATE(1701),
    [sym_operator_cast_definition] = STATE(1800),
    [sym_operator_cast_declaration] = STATE(1800),
    [sym_constructor_or_destructor_definition] = STATE(1800),
    [sym_constructor_or_destructor_declaration] = STATE(1800),
    [sym_friend_declaration] = STATE(1800),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_alias_declaration] = STATE(1800),
    [sym_concept_definition] = STATE(1800),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5744),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6994),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1701),
    [sym_identifier] = ACTIONS(3606),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(2144),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(2146),
    [anon_sym_using] = ACTIONS(3632),
    [anon_sym_concept] = ACTIONS(3634),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [796] = {
    [sym_function_definition] = STATE(496),
    [sym_declaration] = STATE(496),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5201),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1837),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6394),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2274),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__empty_declaration] = STATE(496),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1702),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(496),
    [sym_operator_cast] = STATE(7017),
    [sym__constructor_specifiers] = STATE(1702),
    [sym_operator_cast_definition] = STATE(496),
    [sym_operator_cast_declaration] = STATE(496),
    [sym_constructor_or_destructor_definition] = STATE(496),
    [sym_constructor_or_destructor_declaration] = STATE(496),
    [sym_friend_declaration] = STATE(496),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_alias_declaration] = STATE(496),
    [sym_concept_definition] = STATE(496),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5744),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(7017),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1702),
    [sym_identifier] = ACTIONS(3606),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(3642),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3644),
    [anon_sym_using] = ACTIONS(3646),
    [anon_sym_concept] = ACTIONS(701),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [797] = {
    [sym_function_definition] = STATE(260),
    [sym_declaration] = STATE(260),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5266),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1824),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6397),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2275),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__empty_declaration] = STATE(260),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1697),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(260),
    [sym_operator_cast] = STATE(6995),
    [sym__constructor_specifiers] = STATE(1697),
    [sym_operator_cast_definition] = STATE(260),
    [sym_operator_cast_declaration] = STATE(260),
    [sym_constructor_or_destructor_definition] = STATE(260),
    [sym_constructor_or_destructor_declaration] = STATE(260),
    [sym_friend_declaration] = STATE(260),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_alias_declaration] = STATE(260),
    [sym_concept_definition] = STATE(260),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5744),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6995),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1697),
    [sym_identifier] = ACTIONS(3606),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(3626),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3628),
    [anon_sym_using] = ACTIONS(3630),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [798] = {
    [sym_expression] = STATE(4805),
    [sym__string] = STATE(5255),
    [sym_conditional_expression] = STATE(5255),
    [sym_assignment_expression] = STATE(5255),
    [sym_pointer_expression] = STATE(3988),
    [sym_unary_expression] = STATE(5255),
    [sym_binary_expression] = STATE(5255),
    [sym_update_expression] = STATE(5255),
    [sym_cast_expression] = STATE(5255),
    [sym_sizeof_expression] = STATE(5255),
    [sym_alignof_expression] = STATE(5255),
    [sym_offsetof_expression] = STATE(5255),
    [sym_generic_expression] = STATE(5255),
    [sym_subscript_expression] = STATE(3988),
    [sym_call_expression] = STATE(3988),
    [sym_gnu_asm_expression] = STATE(5255),
    [sym_field_expression] = STATE(3988),
    [sym_compound_literal_expression] = STATE(5255),
    [sym_parenthesized_expression] = STATE(3988),
    [sym_initializer_list] = STATE(5301),
    [sym_char_literal] = STATE(5164),
    [sym_concatenated_string] = STATE(5162),
    [sym_string_literal] = STATE(4081),
    [sym_null] = STATE(5255),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5255),
    [sym_raw_string_literal] = STATE(4060),
    [sym_co_await_expression] = STATE(5255),
    [sym_new_expression] = STATE(5255),
    [sym_delete_expression] = STATE(5255),
    [sym_requires_clause] = STATE(5255),
    [sym_requires_expression] = STATE(5255),
    [sym_lambda_expression] = STATE(5255),
    [sym_lambda_capture_specifier] = STATE(6164),
    [sym_fold_expression] = STATE(5255),
    [sym_parameter_pack_expansion] = STATE(5255),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3988),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3988),
    [sym_kernel_call_expression] = STATE(5260),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_BANG] = ACTIONS(3710),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2508),
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_SLASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2510),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_PIPE] = ACTIONS(2508),
    [anon_sym_CARET] = ACTIONS(2510),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_EQ_EQ] = ACTIONS(2510),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_GT] = ACTIONS(2508),
    [anon_sym_GT_EQ] = ACTIONS(2510),
    [anon_sym_LT_EQ] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_LT_LT] = ACTIONS(2508),
    [anon_sym_GT_GT] = ACTIONS(2508),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_LBRACE] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [sym_primitive_type] = ACTIONS(3718),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_LT_EQ_GT] = ACTIONS(2510),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_bitor] = ACTIONS(2508),
    [anon_sym_xor] = ACTIONS(2508),
    [anon_sym_bitand] = ACTIONS(2508),
    [anon_sym_not_eq] = ACTIONS(2508),
    [anon_sym_DASH_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_PLUS] = ACTIONS(2510),
    [anon_sym_sizeof] = ACTIONS(3720),
    [anon_sym___alignof__] = ACTIONS(3722),
    [anon_sym___alignof] = ACTIONS(3722),
    [anon_sym__alignof] = ACTIONS(3722),
    [anon_sym_alignof] = ACTIONS(3722),
    [anon_sym__Alignof] = ACTIONS(3722),
    [anon_sym_offsetof] = ACTIONS(3724),
    [anon_sym__Generic] = ACTIONS(3726),
    [anon_sym_asm] = ACTIONS(3728),
    [anon_sym___asm__] = ACTIONS(3728),
    [anon_sym_DOT] = ACTIONS(2508),
    [anon_sym_DOT_STAR] = ACTIONS(2510),
    [anon_sym_DASH_GT] = ACTIONS(2510),
    [sym_number_literal] = ACTIONS(3730),
    [anon_sym_L_SQUOTE] = ACTIONS(3732),
    [anon_sym_u_SQUOTE] = ACTIONS(3732),
    [anon_sym_U_SQUOTE] = ACTIONS(3732),
    [anon_sym_u8_SQUOTE] = ACTIONS(3732),
    [anon_sym_SQUOTE] = ACTIONS(3732),
    [anon_sym_L_DQUOTE] = ACTIONS(3734),
    [anon_sym_u_DQUOTE] = ACTIONS(3734),
    [anon_sym_U_DQUOTE] = ACTIONS(3734),
    [anon_sym_u8_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [sym_true] = ACTIONS(3736),
    [sym_false] = ACTIONS(3736),
    [anon_sym_NULL] = ACTIONS(3738),
    [anon_sym_nullptr] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3740),
    [anon_sym_R_DQUOTE] = ACTIONS(3742),
    [anon_sym_LR_DQUOTE] = ACTIONS(3742),
    [anon_sym_uR_DQUOTE] = ACTIONS(3742),
    [anon_sym_UR_DQUOTE] = ACTIONS(3742),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3742),
    [anon_sym_co_await] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3748),
    [sym_this] = ACTIONS(3736),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(2510),
    [aux_sym_kernel_call_syntax_token2] = ACTIONS(2510),
  },
  [799] = {
    [sym_expression] = STATE(4796),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_initializer_list] = STATE(5236),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8015),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(8015),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_BANG] = ACTIONS(2717),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2508),
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_SLASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2510),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_PIPE] = ACTIONS(2508),
    [anon_sym_CARET] = ACTIONS(2510),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_EQ_EQ] = ACTIONS(2510),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_GT] = ACTIONS(2508),
    [anon_sym_GT_EQ] = ACTIONS(2508),
    [anon_sym_LT_EQ] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_LT_LT] = ACTIONS(2508),
    [anon_sym_GT_GT] = ACTIONS(2508),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACE] = ACTIONS(3752),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [sym_primitive_type] = ACTIONS(3754),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_LT_EQ_GT] = ACTIONS(2510),
    [anon_sym_or] = ACTIONS(2508),
    [anon_sym_and] = ACTIONS(2508),
    [anon_sym_bitor] = ACTIONS(2508),
    [anon_sym_xor] = ACTIONS(2508),
    [anon_sym_bitand] = ACTIONS(2508),
    [anon_sym_not_eq] = ACTIONS(2508),
    [anon_sym_DASH_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_PLUS] = ACTIONS(2510),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [anon_sym_DOT] = ACTIONS(2508),
    [anon_sym_DOT_STAR] = ACTIONS(2510),
    [anon_sym_DASH_GT] = ACTIONS(2510),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_GT2] = ACTIONS(2510),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(2510),
  },
  [800] = {
    [sym_function_definition] = STATE(1965),
    [sym_declaration] = STATE(1965),
    [sym__declaration_modifiers] = STATE(2618),
    [sym__declaration_specifiers] = STATE(5320),
    [sym_attribute_specifier] = STATE(2618),
    [sym_attribute_declaration] = STATE(2618),
    [sym_ms_declspec_modifier] = STATE(2618),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(1819),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6420),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2618),
    [sym_type_qualifier] = STATE(2618),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2283),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym__empty_declaration] = STATE(1965),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_explicit_function_specifier] = STATE(1703),
    [sym_dependent_type] = STATE(2200),
    [sym_template_declaration] = STATE(1965),
    [sym_operator_cast] = STATE(6989),
    [sym__constructor_specifiers] = STATE(1703),
    [sym_operator_cast_definition] = STATE(1965),
    [sym_operator_cast_declaration] = STATE(1965),
    [sym_constructor_or_destructor_definition] = STATE(1965),
    [sym_constructor_or_destructor_declaration] = STATE(1965),
    [sym_friend_declaration] = STATE(1965),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_alias_declaration] = STATE(1965),
    [sym_concept_definition] = STATE(1965),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5744),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_qualified_operator_cast_identifier] = STATE(6989),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2618),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1703),
    [sym_identifier] = ACTIONS(3606),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(37),
    [anon_sym___host__] = ACTIONS(37),
    [anon_sym___global__] = ACTIONS(37),
    [anon_sym___forceinline__] = ACTIONS(37),
    [anon_sym___noinline__] = ACTIONS(37),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3608),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(37),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(3478),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym_friend] = ACTIONS(3480),
    [anon_sym_using] = ACTIONS(3618),
    [anon_sym_concept] = ACTIONS(3620),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [801] = {
    [sym_string_literal] = STATE(2752),
    [sym_template_argument_list] = STATE(1644),
    [sym_raw_string_literal] = STATE(2752),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(3756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3760),
    [anon_sym_TILDE] = ACTIONS(3764),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3768),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3771),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(3774),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym___extension__] = ACTIONS(3756),
    [anon_sym___device__] = ACTIONS(3756),
    [anon_sym___host__] = ACTIONS(3756),
    [anon_sym___global__] = ACTIONS(3756),
    [anon_sym___forceinline__] = ACTIONS(3756),
    [anon_sym___noinline__] = ACTIONS(3756),
    [anon_sym_extern] = ACTIONS(3756),
    [anon_sym___attribute__] = ACTIONS(3756),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3779),
    [anon_sym___declspec] = ACTIONS(3756),
    [anon_sym___based] = ACTIONS(3756),
    [anon_sym___cdecl] = ACTIONS(3756),
    [anon_sym___clrcall] = ACTIONS(3756),
    [anon_sym___stdcall] = ACTIONS(3756),
    [anon_sym___fastcall] = ACTIONS(3756),
    [anon_sym___thiscall] = ACTIONS(3756),
    [anon_sym___vectorcall] = ACTIONS(3756),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_RBRACE] = ACTIONS(3758),
    [anon_sym_signed] = ACTIONS(3784),
    [anon_sym_unsigned] = ACTIONS(3784),
    [anon_sym_long] = ACTIONS(3784),
    [anon_sym_short] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3786),
    [anon_sym_static] = ACTIONS(3756),
    [anon_sym_EQ] = ACTIONS(3790),
    [anon_sym_register] = ACTIONS(3756),
    [anon_sym_inline] = ACTIONS(3756),
    [anon_sym___inline] = ACTIONS(3756),
    [anon_sym___inline__] = ACTIONS(3756),
    [anon_sym___forceinline] = ACTIONS(3756),
    [anon_sym_thread_local] = ACTIONS(3756),
    [anon_sym___thread] = ACTIONS(3756),
    [anon_sym_const] = ACTIONS(3756),
    [anon_sym_constexpr] = ACTIONS(3756),
    [anon_sym_volatile] = ACTIONS(3756),
    [anon_sym_restrict] = ACTIONS(3756),
    [anon_sym___restrict__] = ACTIONS(3756),
    [anon_sym__Atomic] = ACTIONS(3756),
    [anon_sym__Noreturn] = ACTIONS(3756),
    [anon_sym_noreturn] = ACTIONS(3756),
    [anon_sym_mutable] = ACTIONS(3756),
    [anon_sym_constinit] = ACTIONS(3756),
    [anon_sym_consteval] = ACTIONS(3756),
    [anon_sym___shared__] = ACTIONS(3756),
    [anon_sym___local__] = ACTIONS(3756),
    [anon_sym___constant__] = ACTIONS(3756),
    [anon_sym___managed__] = ACTIONS(3756),
    [anon_sym___grid_constant__] = ACTIONS(3756),
    [anon_sym_alignas] = ACTIONS(3756),
    [anon_sym__Alignas] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3792),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3794),
    [anon_sym_SLASH_EQ] = ACTIONS(3794),
    [anon_sym_PERCENT_EQ] = ACTIONS(3794),
    [anon_sym_PLUS_EQ] = ACTIONS(3794),
    [anon_sym_DASH_EQ] = ACTIONS(3794),
    [anon_sym_LT_LT_EQ] = ACTIONS(3794),
    [anon_sym_GT_GT_EQ] = ACTIONS(3794),
    [anon_sym_AMP_EQ] = ACTIONS(3794),
    [anon_sym_CARET_EQ] = ACTIONS(3794),
    [anon_sym_PIPE_EQ] = ACTIONS(3794),
    [anon_sym_and_eq] = ACTIONS(3790),
    [anon_sym_or_eq] = ACTIONS(3790),
    [anon_sym_xor_eq] = ACTIONS(3790),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3766),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3766),
    [anon_sym_not_eq] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3756),
    [anon_sym_decltype] = ACTIONS(3756),
    [sym_virtual] = ACTIONS(3756),
    [anon_sym_template] = ACTIONS(3756),
    [anon_sym_operator] = ACTIONS(3756),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
    [anon_sym___launch_bounds__] = ACTIONS(3756),
  },
  [802] = {
    [sym_expression] = STATE(5044),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3796),
    [anon_sym_COMMA] = ACTIONS(3796),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3680),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_SLASH] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3796),
    [anon_sym_PIPE_PIPE] = ACTIONS(3796),
    [anon_sym_AMP_AMP] = ACTIONS(3796),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_CARET] = ACTIONS(3796),
    [anon_sym_AMP] = ACTIONS(1236),
    [anon_sym_EQ_EQ] = ACTIONS(3796),
    [anon_sym_BANG_EQ] = ACTIONS(3796),
    [anon_sym_GT] = ACTIONS(3800),
    [anon_sym_GT_EQ] = ACTIONS(3796),
    [anon_sym_LT_EQ] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3800),
    [anon_sym_LT_LT] = ACTIONS(3800),
    [anon_sym_GT_GT] = ACTIONS(3796),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(3796),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_QMARK] = ACTIONS(3796),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_LT_EQ_GT] = ACTIONS(3796),
    [anon_sym_or] = ACTIONS(3800),
    [anon_sym_and] = ACTIONS(3800),
    [anon_sym_bitor] = ACTIONS(3800),
    [anon_sym_xor] = ACTIONS(3800),
    [anon_sym_bitand] = ACTIONS(3800),
    [anon_sym_not_eq] = ACTIONS(3800),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_DOT_STAR] = ACTIONS(3796),
    [anon_sym_DASH_GT] = ACTIONS(3796),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3796),
  },
  [803] = {
    [sym_identifier] = ACTIONS(3804),
    [anon_sym_LPAREN2] = ACTIONS(3807),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3807),
    [anon_sym_DASH] = ACTIONS(3812),
    [anon_sym_PLUS] = ACTIONS(3812),
    [anon_sym_STAR] = ACTIONS(3807),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(3804),
    [anon_sym_SEMI] = ACTIONS(3810),
    [anon_sym___extension__] = ACTIONS(3816),
    [anon_sym___device__] = ACTIONS(3816),
    [anon_sym___host__] = ACTIONS(3816),
    [anon_sym___global__] = ACTIONS(3816),
    [anon_sym___forceinline__] = ACTIONS(3816),
    [anon_sym___noinline__] = ACTIONS(3816),
    [anon_sym_extern] = ACTIONS(3816),
    [anon_sym___attribute__] = ACTIONS(3816),
    [anon_sym_COLON_COLON] = ACTIONS(3807),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3807),
    [anon_sym___declspec] = ACTIONS(3816),
    [anon_sym___based] = ACTIONS(3816),
    [anon_sym_LBRACE] = ACTIONS(3810),
    [anon_sym_signed] = ACTIONS(3816),
    [anon_sym_unsigned] = ACTIONS(3816),
    [anon_sym_long] = ACTIONS(3816),
    [anon_sym_short] = ACTIONS(3816),
    [anon_sym_LBRACK] = ACTIONS(3804),
    [anon_sym_static] = ACTIONS(3816),
    [anon_sym_register] = ACTIONS(3816),
    [anon_sym_inline] = ACTIONS(3816),
    [anon_sym___inline] = ACTIONS(3816),
    [anon_sym___inline__] = ACTIONS(3816),
    [anon_sym___forceinline] = ACTIONS(3816),
    [anon_sym_thread_local] = ACTIONS(3816),
    [anon_sym___thread] = ACTIONS(3816),
    [anon_sym_const] = ACTIONS(3816),
    [anon_sym_constexpr] = ACTIONS(3816),
    [anon_sym_volatile] = ACTIONS(3816),
    [anon_sym_restrict] = ACTIONS(3816),
    [anon_sym___restrict__] = ACTIONS(3816),
    [anon_sym__Atomic] = ACTIONS(3816),
    [anon_sym__Noreturn] = ACTIONS(3816),
    [anon_sym_noreturn] = ACTIONS(3816),
    [anon_sym_mutable] = ACTIONS(3816),
    [anon_sym_constinit] = ACTIONS(3816),
    [anon_sym_consteval] = ACTIONS(3816),
    [anon_sym___shared__] = ACTIONS(3816),
    [anon_sym___local__] = ACTIONS(3816),
    [anon_sym___constant__] = ACTIONS(3816),
    [anon_sym___managed__] = ACTIONS(3816),
    [anon_sym___grid_constant__] = ACTIONS(3816),
    [anon_sym_alignas] = ACTIONS(3816),
    [anon_sym__Alignas] = ACTIONS(3816),
    [sym_primitive_type] = ACTIONS(3804),
    [anon_sym_enum] = ACTIONS(3816),
    [anon_sym_class] = ACTIONS(3816),
    [anon_sym_struct] = ACTIONS(3816),
    [anon_sym_union] = ACTIONS(3816),
    [anon_sym_if] = ACTIONS(3812),
    [anon_sym_switch] = ACTIONS(3812),
    [anon_sym_case] = ACTIONS(3812),
    [anon_sym_default] = ACTIONS(3812),
    [anon_sym_while] = ACTIONS(3812),
    [anon_sym_do] = ACTIONS(3812),
    [anon_sym_for] = ACTIONS(3812),
    [anon_sym_return] = ACTIONS(3812),
    [anon_sym_break] = ACTIONS(3812),
    [anon_sym_continue] = ACTIONS(3812),
    [anon_sym_goto] = ACTIONS(3812),
    [anon_sym___try] = ACTIONS(3812),
    [anon_sym___leave] = ACTIONS(3812),
    [anon_sym_not] = ACTIONS(3812),
    [anon_sym_compl] = ACTIONS(3812),
    [anon_sym_DASH_DASH] = ACTIONS(3810),
    [anon_sym_PLUS_PLUS] = ACTIONS(3810),
    [anon_sym_sizeof] = ACTIONS(3812),
    [anon_sym___alignof__] = ACTIONS(3812),
    [anon_sym___alignof] = ACTIONS(3812),
    [anon_sym__alignof] = ACTIONS(3812),
    [anon_sym_alignof] = ACTIONS(3812),
    [anon_sym__Alignof] = ACTIONS(3812),
    [anon_sym_offsetof] = ACTIONS(3812),
    [anon_sym__Generic] = ACTIONS(3812),
    [anon_sym_asm] = ACTIONS(3812),
    [anon_sym___asm__] = ACTIONS(3812),
    [sym_number_literal] = ACTIONS(3810),
    [anon_sym_L_SQUOTE] = ACTIONS(3810),
    [anon_sym_u_SQUOTE] = ACTIONS(3810),
    [anon_sym_U_SQUOTE] = ACTIONS(3810),
    [anon_sym_u8_SQUOTE] = ACTIONS(3810),
    [anon_sym_SQUOTE] = ACTIONS(3810),
    [anon_sym_L_DQUOTE] = ACTIONS(3810),
    [anon_sym_u_DQUOTE] = ACTIONS(3810),
    [anon_sym_U_DQUOTE] = ACTIONS(3810),
    [anon_sym_u8_DQUOTE] = ACTIONS(3810),
    [anon_sym_DQUOTE] = ACTIONS(3810),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [anon_sym_NULL] = ACTIONS(3812),
    [anon_sym_nullptr] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3816),
    [anon_sym_decltype] = ACTIONS(3804),
    [sym_virtual] = ACTIONS(3816),
    [anon_sym_explicit] = ACTIONS(3816),
    [anon_sym_typename] = ACTIONS(3816),
    [anon_sym_template] = ACTIONS(3804),
    [anon_sym_operator] = ACTIONS(3816),
    [anon_sym_try] = ACTIONS(3812),
    [anon_sym_delete] = ACTIONS(3812),
    [anon_sym_throw] = ACTIONS(3812),
    [anon_sym_co_return] = ACTIONS(3812),
    [anon_sym_co_yield] = ACTIONS(3812),
    [anon_sym_R_DQUOTE] = ACTIONS(3810),
    [anon_sym_LR_DQUOTE] = ACTIONS(3810),
    [anon_sym_uR_DQUOTE] = ACTIONS(3810),
    [anon_sym_UR_DQUOTE] = ACTIONS(3810),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3810),
    [anon_sym_co_await] = ACTIONS(3812),
    [anon_sym_new] = ACTIONS(3812),
    [anon_sym_requires] = ACTIONS(3812),
    [sym_this] = ACTIONS(3812),
    [anon_sym___launch_bounds__] = ACTIONS(3816),
  },
  [804] = {
    [sym_string_literal] = STATE(2752),
    [sym_template_argument_list] = STATE(1644),
    [sym_raw_string_literal] = STATE(2752),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(3756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3760),
    [anon_sym_TILDE] = ACTIONS(3764),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3768),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3771),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(3774),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym___extension__] = ACTIONS(3756),
    [anon_sym___device__] = ACTIONS(3756),
    [anon_sym___host__] = ACTIONS(3756),
    [anon_sym___global__] = ACTIONS(3756),
    [anon_sym___forceinline__] = ACTIONS(3756),
    [anon_sym___noinline__] = ACTIONS(3756),
    [anon_sym_extern] = ACTIONS(3756),
    [anon_sym___attribute__] = ACTIONS(3756),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3779),
    [anon_sym___declspec] = ACTIONS(3756),
    [anon_sym___based] = ACTIONS(3756),
    [anon_sym___cdecl] = ACTIONS(3756),
    [anon_sym___clrcall] = ACTIONS(3756),
    [anon_sym___stdcall] = ACTIONS(3756),
    [anon_sym___fastcall] = ACTIONS(3756),
    [anon_sym___thiscall] = ACTIONS(3756),
    [anon_sym___vectorcall] = ACTIONS(3756),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_signed] = ACTIONS(3784),
    [anon_sym_unsigned] = ACTIONS(3784),
    [anon_sym_long] = ACTIONS(3784),
    [anon_sym_short] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3786),
    [anon_sym_static] = ACTIONS(3756),
    [anon_sym_EQ] = ACTIONS(3790),
    [anon_sym_register] = ACTIONS(3756),
    [anon_sym_inline] = ACTIONS(3756),
    [anon_sym___inline] = ACTIONS(3756),
    [anon_sym___inline__] = ACTIONS(3756),
    [anon_sym___forceinline] = ACTIONS(3756),
    [anon_sym_thread_local] = ACTIONS(3756),
    [anon_sym___thread] = ACTIONS(3756),
    [anon_sym_const] = ACTIONS(3756),
    [anon_sym_constexpr] = ACTIONS(3756),
    [anon_sym_volatile] = ACTIONS(3756),
    [anon_sym_restrict] = ACTIONS(3756),
    [anon_sym___restrict__] = ACTIONS(3756),
    [anon_sym__Atomic] = ACTIONS(3756),
    [anon_sym__Noreturn] = ACTIONS(3756),
    [anon_sym_noreturn] = ACTIONS(3756),
    [anon_sym_mutable] = ACTIONS(3756),
    [anon_sym_constinit] = ACTIONS(3756),
    [anon_sym_consteval] = ACTIONS(3756),
    [anon_sym___shared__] = ACTIONS(3756),
    [anon_sym___local__] = ACTIONS(3756),
    [anon_sym___constant__] = ACTIONS(3756),
    [anon_sym___managed__] = ACTIONS(3756),
    [anon_sym___grid_constant__] = ACTIONS(3756),
    [anon_sym_alignas] = ACTIONS(3756),
    [anon_sym__Alignas] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3818),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3794),
    [anon_sym_SLASH_EQ] = ACTIONS(3794),
    [anon_sym_PERCENT_EQ] = ACTIONS(3794),
    [anon_sym_PLUS_EQ] = ACTIONS(3794),
    [anon_sym_DASH_EQ] = ACTIONS(3794),
    [anon_sym_LT_LT_EQ] = ACTIONS(3794),
    [anon_sym_GT_GT_EQ] = ACTIONS(3794),
    [anon_sym_AMP_EQ] = ACTIONS(3794),
    [anon_sym_CARET_EQ] = ACTIONS(3794),
    [anon_sym_PIPE_EQ] = ACTIONS(3794),
    [anon_sym_and_eq] = ACTIONS(3790),
    [anon_sym_or_eq] = ACTIONS(3790),
    [anon_sym_xor_eq] = ACTIONS(3790),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3766),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3766),
    [anon_sym_not_eq] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3756),
    [anon_sym_decltype] = ACTIONS(3756),
    [sym_virtual] = ACTIONS(3756),
    [anon_sym_template] = ACTIONS(3756),
    [anon_sym_operator] = ACTIONS(3756),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
    [anon_sym___launch_bounds__] = ACTIONS(3756),
  },
  [805] = {
    [sym_string_literal] = STATE(2752),
    [sym_template_argument_list] = STATE(1644),
    [sym_raw_string_literal] = STATE(2752),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(3756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3760),
    [anon_sym_TILDE] = ACTIONS(3764),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3768),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3771),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(3774),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym___extension__] = ACTIONS(3756),
    [anon_sym___device__] = ACTIONS(3756),
    [anon_sym___host__] = ACTIONS(3756),
    [anon_sym___global__] = ACTIONS(3756),
    [anon_sym___forceinline__] = ACTIONS(3756),
    [anon_sym___noinline__] = ACTIONS(3756),
    [anon_sym_extern] = ACTIONS(3756),
    [anon_sym___attribute__] = ACTIONS(3756),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3779),
    [anon_sym___declspec] = ACTIONS(3756),
    [anon_sym___based] = ACTIONS(3756),
    [anon_sym___cdecl] = ACTIONS(3756),
    [anon_sym___clrcall] = ACTIONS(3756),
    [anon_sym___stdcall] = ACTIONS(3756),
    [anon_sym___fastcall] = ACTIONS(3756),
    [anon_sym___thiscall] = ACTIONS(3756),
    [anon_sym___vectorcall] = ACTIONS(3756),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_signed] = ACTIONS(3784),
    [anon_sym_unsigned] = ACTIONS(3784),
    [anon_sym_long] = ACTIONS(3784),
    [anon_sym_short] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3786),
    [anon_sym_static] = ACTIONS(3756),
    [anon_sym_EQ] = ACTIONS(3790),
    [anon_sym_register] = ACTIONS(3756),
    [anon_sym_inline] = ACTIONS(3756),
    [anon_sym___inline] = ACTIONS(3756),
    [anon_sym___inline__] = ACTIONS(3756),
    [anon_sym___forceinline] = ACTIONS(3756),
    [anon_sym_thread_local] = ACTIONS(3756),
    [anon_sym___thread] = ACTIONS(3756),
    [anon_sym_const] = ACTIONS(3756),
    [anon_sym_constexpr] = ACTIONS(3756),
    [anon_sym_volatile] = ACTIONS(3756),
    [anon_sym_restrict] = ACTIONS(3756),
    [anon_sym___restrict__] = ACTIONS(3756),
    [anon_sym__Atomic] = ACTIONS(3756),
    [anon_sym__Noreturn] = ACTIONS(3756),
    [anon_sym_noreturn] = ACTIONS(3756),
    [anon_sym_mutable] = ACTIONS(3756),
    [anon_sym_constinit] = ACTIONS(3756),
    [anon_sym_consteval] = ACTIONS(3756),
    [anon_sym___shared__] = ACTIONS(3756),
    [anon_sym___local__] = ACTIONS(3756),
    [anon_sym___constant__] = ACTIONS(3756),
    [anon_sym___managed__] = ACTIONS(3756),
    [anon_sym___grid_constant__] = ACTIONS(3756),
    [anon_sym_alignas] = ACTIONS(3756),
    [anon_sym__Alignas] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3820),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3794),
    [anon_sym_SLASH_EQ] = ACTIONS(3794),
    [anon_sym_PERCENT_EQ] = ACTIONS(3794),
    [anon_sym_PLUS_EQ] = ACTIONS(3794),
    [anon_sym_DASH_EQ] = ACTIONS(3794),
    [anon_sym_LT_LT_EQ] = ACTIONS(3794),
    [anon_sym_GT_GT_EQ] = ACTIONS(3794),
    [anon_sym_AMP_EQ] = ACTIONS(3794),
    [anon_sym_CARET_EQ] = ACTIONS(3794),
    [anon_sym_PIPE_EQ] = ACTIONS(3794),
    [anon_sym_and_eq] = ACTIONS(3790),
    [anon_sym_or_eq] = ACTIONS(3790),
    [anon_sym_xor_eq] = ACTIONS(3790),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3766),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3766),
    [anon_sym_not_eq] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3756),
    [anon_sym_decltype] = ACTIONS(3756),
    [sym_virtual] = ACTIONS(3756),
    [anon_sym_template] = ACTIONS(3756),
    [anon_sym_operator] = ACTIONS(3756),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
    [anon_sym___launch_bounds__] = ACTIONS(3756),
  },
  [806] = {
    [sym_string_literal] = STATE(2752),
    [sym_template_argument_list] = STATE(1644),
    [sym_raw_string_literal] = STATE(2752),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(3756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3760),
    [anon_sym_TILDE] = ACTIONS(3764),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3768),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3771),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(3774),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3771),
    [anon_sym___extension__] = ACTIONS(3756),
    [anon_sym___device__] = ACTIONS(3756),
    [anon_sym___host__] = ACTIONS(3756),
    [anon_sym___global__] = ACTIONS(3756),
    [anon_sym___forceinline__] = ACTIONS(3756),
    [anon_sym___noinline__] = ACTIONS(3756),
    [anon_sym_extern] = ACTIONS(3756),
    [anon_sym___attribute__] = ACTIONS(3756),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3779),
    [anon_sym___declspec] = ACTIONS(3756),
    [anon_sym___based] = ACTIONS(3756),
    [anon_sym___cdecl] = ACTIONS(3756),
    [anon_sym___clrcall] = ACTIONS(3756),
    [anon_sym___stdcall] = ACTIONS(3756),
    [anon_sym___fastcall] = ACTIONS(3756),
    [anon_sym___thiscall] = ACTIONS(3756),
    [anon_sym___vectorcall] = ACTIONS(3756),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_signed] = ACTIONS(3784),
    [anon_sym_unsigned] = ACTIONS(3784),
    [anon_sym_long] = ACTIONS(3784),
    [anon_sym_short] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3786),
    [anon_sym_static] = ACTIONS(3756),
    [anon_sym_EQ] = ACTIONS(3790),
    [anon_sym_register] = ACTIONS(3756),
    [anon_sym_inline] = ACTIONS(3756),
    [anon_sym___inline] = ACTIONS(3756),
    [anon_sym___inline__] = ACTIONS(3756),
    [anon_sym___forceinline] = ACTIONS(3756),
    [anon_sym_thread_local] = ACTIONS(3756),
    [anon_sym___thread] = ACTIONS(3756),
    [anon_sym_const] = ACTIONS(3756),
    [anon_sym_constexpr] = ACTIONS(3756),
    [anon_sym_volatile] = ACTIONS(3756),
    [anon_sym_restrict] = ACTIONS(3756),
    [anon_sym___restrict__] = ACTIONS(3756),
    [anon_sym__Atomic] = ACTIONS(3756),
    [anon_sym__Noreturn] = ACTIONS(3756),
    [anon_sym_noreturn] = ACTIONS(3756),
    [anon_sym_mutable] = ACTIONS(3756),
    [anon_sym_constinit] = ACTIONS(3756),
    [anon_sym_consteval] = ACTIONS(3756),
    [anon_sym___shared__] = ACTIONS(3756),
    [anon_sym___local__] = ACTIONS(3756),
    [anon_sym___constant__] = ACTIONS(3756),
    [anon_sym___managed__] = ACTIONS(3756),
    [anon_sym___grid_constant__] = ACTIONS(3756),
    [anon_sym_alignas] = ACTIONS(3756),
    [anon_sym__Alignas] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3822),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3794),
    [anon_sym_SLASH_EQ] = ACTIONS(3794),
    [anon_sym_PERCENT_EQ] = ACTIONS(3794),
    [anon_sym_PLUS_EQ] = ACTIONS(3794),
    [anon_sym_DASH_EQ] = ACTIONS(3794),
    [anon_sym_LT_LT_EQ] = ACTIONS(3794),
    [anon_sym_GT_GT_EQ] = ACTIONS(3794),
    [anon_sym_AMP_EQ] = ACTIONS(3794),
    [anon_sym_CARET_EQ] = ACTIONS(3794),
    [anon_sym_PIPE_EQ] = ACTIONS(3794),
    [anon_sym_and_eq] = ACTIONS(3790),
    [anon_sym_or_eq] = ACTIONS(3790),
    [anon_sym_xor_eq] = ACTIONS(3790),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3766),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3766),
    [anon_sym_not_eq] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3756),
    [anon_sym_decltype] = ACTIONS(3756),
    [sym_virtual] = ACTIONS(3756),
    [anon_sym_template] = ACTIONS(3756),
    [anon_sym_operator] = ACTIONS(3756),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
    [anon_sym___launch_bounds__] = ACTIONS(3756),
  },
  [807] = {
    [sym_catch_clause] = STATE(809),
    [aux_sym_constructor_try_statement_repeat1] = STATE(809),
    [sym_identifier] = ACTIONS(1903),
    [anon_sym_LPAREN2] = ACTIONS(1905),
    [anon_sym_BANG] = ACTIONS(1905),
    [anon_sym_TILDE] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(1903),
    [anon_sym_PLUS] = ACTIONS(1903),
    [anon_sym_STAR] = ACTIONS(1905),
    [anon_sym_AMP] = ACTIONS(1905),
    [anon_sym_SEMI] = ACTIONS(1905),
    [anon_sym___extension__] = ACTIONS(1903),
    [anon_sym_typedef] = ACTIONS(1903),
    [anon_sym___device__] = ACTIONS(1903),
    [anon_sym___host__] = ACTIONS(1903),
    [anon_sym___global__] = ACTIONS(1903),
    [anon_sym___forceinline__] = ACTIONS(1903),
    [anon_sym___noinline__] = ACTIONS(1903),
    [anon_sym_extern] = ACTIONS(1903),
    [anon_sym___attribute__] = ACTIONS(1903),
    [anon_sym_COLON_COLON] = ACTIONS(1905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1905),
    [anon_sym___declspec] = ACTIONS(1903),
    [anon_sym_LBRACE] = ACTIONS(1905),
    [anon_sym_signed] = ACTIONS(1903),
    [anon_sym_unsigned] = ACTIONS(1903),
    [anon_sym_long] = ACTIONS(1903),
    [anon_sym_short] = ACTIONS(1903),
    [anon_sym_LBRACK] = ACTIONS(1903),
    [anon_sym_static] = ACTIONS(1903),
    [anon_sym_register] = ACTIONS(1903),
    [anon_sym_inline] = ACTIONS(1903),
    [anon_sym___inline] = ACTIONS(1903),
    [anon_sym___inline__] = ACTIONS(1903),
    [anon_sym___forceinline] = ACTIONS(1903),
    [anon_sym_thread_local] = ACTIONS(1903),
    [anon_sym___thread] = ACTIONS(1903),
    [anon_sym_const] = ACTIONS(1903),
    [anon_sym_constexpr] = ACTIONS(1903),
    [anon_sym_volatile] = ACTIONS(1903),
    [anon_sym_restrict] = ACTIONS(1903),
    [anon_sym___restrict__] = ACTIONS(1903),
    [anon_sym__Atomic] = ACTIONS(1903),
    [anon_sym__Noreturn] = ACTIONS(1903),
    [anon_sym_noreturn] = ACTIONS(1903),
    [anon_sym_mutable] = ACTIONS(1903),
    [anon_sym_constinit] = ACTIONS(1903),
    [anon_sym_consteval] = ACTIONS(1903),
    [anon_sym___shared__] = ACTIONS(1903),
    [anon_sym___local__] = ACTIONS(1903),
    [anon_sym___constant__] = ACTIONS(1903),
    [anon_sym___managed__] = ACTIONS(1903),
    [anon_sym___grid_constant__] = ACTIONS(1903),
    [anon_sym_alignas] = ACTIONS(1903),
    [anon_sym__Alignas] = ACTIONS(1903),
    [sym_primitive_type] = ACTIONS(1903),
    [anon_sym_enum] = ACTIONS(1903),
    [anon_sym_class] = ACTIONS(1903),
    [anon_sym_struct] = ACTIONS(1903),
    [anon_sym_union] = ACTIONS(1903),
    [anon_sym_if] = ACTIONS(1903),
    [anon_sym_else] = ACTIONS(1903),
    [anon_sym_switch] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1903),
    [anon_sym_do] = ACTIONS(1903),
    [anon_sym_for] = ACTIONS(1903),
    [anon_sym_return] = ACTIONS(1903),
    [anon_sym_break] = ACTIONS(1903),
    [anon_sym_continue] = ACTIONS(1903),
    [anon_sym_goto] = ACTIONS(1903),
    [anon_sym___try] = ACTIONS(1903),
    [anon_sym___leave] = ACTIONS(1903),
    [anon_sym_not] = ACTIONS(1903),
    [anon_sym_compl] = ACTIONS(1903),
    [anon_sym_DASH_DASH] = ACTIONS(1905),
    [anon_sym_PLUS_PLUS] = ACTIONS(1905),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1903),
    [anon_sym___alignof] = ACTIONS(1903),
    [anon_sym__alignof] = ACTIONS(1903),
    [anon_sym_alignof] = ACTIONS(1903),
    [anon_sym__Alignof] = ACTIONS(1903),
    [anon_sym_offsetof] = ACTIONS(1903),
    [anon_sym__Generic] = ACTIONS(1903),
    [anon_sym_asm] = ACTIONS(1903),
    [anon_sym___asm__] = ACTIONS(1903),
    [sym_number_literal] = ACTIONS(1905),
    [anon_sym_L_SQUOTE] = ACTIONS(1905),
    [anon_sym_u_SQUOTE] = ACTIONS(1905),
    [anon_sym_U_SQUOTE] = ACTIONS(1905),
    [anon_sym_u8_SQUOTE] = ACTIONS(1905),
    [anon_sym_SQUOTE] = ACTIONS(1905),
    [anon_sym_L_DQUOTE] = ACTIONS(1905),
    [anon_sym_u_DQUOTE] = ACTIONS(1905),
    [anon_sym_U_DQUOTE] = ACTIONS(1905),
    [anon_sym_u8_DQUOTE] = ACTIONS(1905),
    [anon_sym_DQUOTE] = ACTIONS(1905),
    [sym_true] = ACTIONS(1903),
    [sym_false] = ACTIONS(1903),
    [anon_sym_NULL] = ACTIONS(1903),
    [anon_sym_nullptr] = ACTIONS(1903),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1903),
    [anon_sym_decltype] = ACTIONS(1903),
    [sym_virtual] = ACTIONS(1903),
    [anon_sym_typename] = ACTIONS(1903),
    [anon_sym_template] = ACTIONS(1903),
    [anon_sym_try] = ACTIONS(1903),
    [anon_sym_delete] = ACTIONS(1903),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_co_return] = ACTIONS(1903),
    [anon_sym_co_yield] = ACTIONS(1903),
    [anon_sym_catch] = ACTIONS(3824),
    [anon_sym_R_DQUOTE] = ACTIONS(1905),
    [anon_sym_LR_DQUOTE] = ACTIONS(1905),
    [anon_sym_uR_DQUOTE] = ACTIONS(1905),
    [anon_sym_UR_DQUOTE] = ACTIONS(1905),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1905),
    [anon_sym_co_await] = ACTIONS(1903),
    [anon_sym_new] = ACTIONS(1903),
    [anon_sym_requires] = ACTIONS(1903),
    [sym_this] = ACTIONS(1903),
    [anon_sym___launch_bounds__] = ACTIONS(1903),
  },
  [808] = {
    [sym_string_literal] = STATE(2752),
    [sym_template_argument_list] = STATE(1644),
    [sym_raw_string_literal] = STATE(2752),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(3756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3760),
    [anon_sym_TILDE] = ACTIONS(3764),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3768),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3771),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(3774),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3826),
    [anon_sym___extension__] = ACTIONS(3756),
    [anon_sym___device__] = ACTIONS(3756),
    [anon_sym___host__] = ACTIONS(3756),
    [anon_sym___global__] = ACTIONS(3756),
    [anon_sym___forceinline__] = ACTIONS(3756),
    [anon_sym___noinline__] = ACTIONS(3756),
    [anon_sym_extern] = ACTIONS(3756),
    [anon_sym___attribute__] = ACTIONS(3756),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3779),
    [anon_sym___declspec] = ACTIONS(3756),
    [anon_sym___based] = ACTIONS(3756),
    [anon_sym___cdecl] = ACTIONS(3756),
    [anon_sym___clrcall] = ACTIONS(3756),
    [anon_sym___stdcall] = ACTIONS(3756),
    [anon_sym___fastcall] = ACTIONS(3756),
    [anon_sym___thiscall] = ACTIONS(3756),
    [anon_sym___vectorcall] = ACTIONS(3756),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_signed] = ACTIONS(3784),
    [anon_sym_unsigned] = ACTIONS(3784),
    [anon_sym_long] = ACTIONS(3784),
    [anon_sym_short] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3786),
    [anon_sym_static] = ACTIONS(3756),
    [anon_sym_EQ] = ACTIONS(3790),
    [anon_sym_register] = ACTIONS(3756),
    [anon_sym_inline] = ACTIONS(3756),
    [anon_sym___inline] = ACTIONS(3756),
    [anon_sym___inline__] = ACTIONS(3756),
    [anon_sym___forceinline] = ACTIONS(3756),
    [anon_sym_thread_local] = ACTIONS(3756),
    [anon_sym___thread] = ACTIONS(3756),
    [anon_sym_const] = ACTIONS(3756),
    [anon_sym_constexpr] = ACTIONS(3756),
    [anon_sym_volatile] = ACTIONS(3756),
    [anon_sym_restrict] = ACTIONS(3756),
    [anon_sym___restrict__] = ACTIONS(3756),
    [anon_sym__Atomic] = ACTIONS(3756),
    [anon_sym__Noreturn] = ACTIONS(3756),
    [anon_sym_noreturn] = ACTIONS(3756),
    [anon_sym_mutable] = ACTIONS(3756),
    [anon_sym_constinit] = ACTIONS(3756),
    [anon_sym_consteval] = ACTIONS(3756),
    [anon_sym___shared__] = ACTIONS(3756),
    [anon_sym___local__] = ACTIONS(3756),
    [anon_sym___constant__] = ACTIONS(3756),
    [anon_sym___managed__] = ACTIONS(3756),
    [anon_sym___grid_constant__] = ACTIONS(3756),
    [anon_sym_alignas] = ACTIONS(3756),
    [anon_sym__Alignas] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3828),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3794),
    [anon_sym_SLASH_EQ] = ACTIONS(3794),
    [anon_sym_PERCENT_EQ] = ACTIONS(3794),
    [anon_sym_PLUS_EQ] = ACTIONS(3794),
    [anon_sym_DASH_EQ] = ACTIONS(3794),
    [anon_sym_LT_LT_EQ] = ACTIONS(3794),
    [anon_sym_GT_GT_EQ] = ACTIONS(3794),
    [anon_sym_AMP_EQ] = ACTIONS(3794),
    [anon_sym_CARET_EQ] = ACTIONS(3794),
    [anon_sym_PIPE_EQ] = ACTIONS(3794),
    [anon_sym_and_eq] = ACTIONS(3790),
    [anon_sym_or_eq] = ACTIONS(3790),
    [anon_sym_xor_eq] = ACTIONS(3790),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3766),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3766),
    [anon_sym_not_eq] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3756),
    [anon_sym_decltype] = ACTIONS(3756),
    [sym_virtual] = ACTIONS(3756),
    [anon_sym_template] = ACTIONS(3756),
    [anon_sym_operator] = ACTIONS(3756),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
    [anon_sym___launch_bounds__] = ACTIONS(3756),
  },
  [809] = {
    [sym_catch_clause] = STATE(809),
    [aux_sym_constructor_try_statement_repeat1] = STATE(809),
    [sym_identifier] = ACTIONS(1909),
    [anon_sym_LPAREN2] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_SEMI] = ACTIONS(1911),
    [anon_sym___extension__] = ACTIONS(1909),
    [anon_sym_typedef] = ACTIONS(1909),
    [anon_sym___device__] = ACTIONS(1909),
    [anon_sym___host__] = ACTIONS(1909),
    [anon_sym___global__] = ACTIONS(1909),
    [anon_sym___forceinline__] = ACTIONS(1909),
    [anon_sym___noinline__] = ACTIONS(1909),
    [anon_sym_extern] = ACTIONS(1909),
    [anon_sym___attribute__] = ACTIONS(1909),
    [anon_sym_COLON_COLON] = ACTIONS(1911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1911),
    [anon_sym___declspec] = ACTIONS(1909),
    [anon_sym_LBRACE] = ACTIONS(1911),
    [anon_sym_signed] = ACTIONS(1909),
    [anon_sym_unsigned] = ACTIONS(1909),
    [anon_sym_long] = ACTIONS(1909),
    [anon_sym_short] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_static] = ACTIONS(1909),
    [anon_sym_register] = ACTIONS(1909),
    [anon_sym_inline] = ACTIONS(1909),
    [anon_sym___inline] = ACTIONS(1909),
    [anon_sym___inline__] = ACTIONS(1909),
    [anon_sym___forceinline] = ACTIONS(1909),
    [anon_sym_thread_local] = ACTIONS(1909),
    [anon_sym___thread] = ACTIONS(1909),
    [anon_sym_const] = ACTIONS(1909),
    [anon_sym_constexpr] = ACTIONS(1909),
    [anon_sym_volatile] = ACTIONS(1909),
    [anon_sym_restrict] = ACTIONS(1909),
    [anon_sym___restrict__] = ACTIONS(1909),
    [anon_sym__Atomic] = ACTIONS(1909),
    [anon_sym__Noreturn] = ACTIONS(1909),
    [anon_sym_noreturn] = ACTIONS(1909),
    [anon_sym_mutable] = ACTIONS(1909),
    [anon_sym_constinit] = ACTIONS(1909),
    [anon_sym_consteval] = ACTIONS(1909),
    [anon_sym___shared__] = ACTIONS(1909),
    [anon_sym___local__] = ACTIONS(1909),
    [anon_sym___constant__] = ACTIONS(1909),
    [anon_sym___managed__] = ACTIONS(1909),
    [anon_sym___grid_constant__] = ACTIONS(1909),
    [anon_sym_alignas] = ACTIONS(1909),
    [anon_sym__Alignas] = ACTIONS(1909),
    [sym_primitive_type] = ACTIONS(1909),
    [anon_sym_enum] = ACTIONS(1909),
    [anon_sym_class] = ACTIONS(1909),
    [anon_sym_struct] = ACTIONS(1909),
    [anon_sym_union] = ACTIONS(1909),
    [anon_sym_if] = ACTIONS(1909),
    [anon_sym_else] = ACTIONS(1909),
    [anon_sym_switch] = ACTIONS(1909),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_do] = ACTIONS(1909),
    [anon_sym_for] = ACTIONS(1909),
    [anon_sym_return] = ACTIONS(1909),
    [anon_sym_break] = ACTIONS(1909),
    [anon_sym_continue] = ACTIONS(1909),
    [anon_sym_goto] = ACTIONS(1909),
    [anon_sym___try] = ACTIONS(1909),
    [anon_sym___leave] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1909),
    [anon_sym_compl] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_sizeof] = ACTIONS(1909),
    [anon_sym___alignof__] = ACTIONS(1909),
    [anon_sym___alignof] = ACTIONS(1909),
    [anon_sym__alignof] = ACTIONS(1909),
    [anon_sym_alignof] = ACTIONS(1909),
    [anon_sym__Alignof] = ACTIONS(1909),
    [anon_sym_offsetof] = ACTIONS(1909),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1909),
    [anon_sym___asm__] = ACTIONS(1909),
    [sym_number_literal] = ACTIONS(1911),
    [anon_sym_L_SQUOTE] = ACTIONS(1911),
    [anon_sym_u_SQUOTE] = ACTIONS(1911),
    [anon_sym_U_SQUOTE] = ACTIONS(1911),
    [anon_sym_u8_SQUOTE] = ACTIONS(1911),
    [anon_sym_SQUOTE] = ACTIONS(1911),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1909),
    [sym_false] = ACTIONS(1909),
    [anon_sym_NULL] = ACTIONS(1909),
    [anon_sym_nullptr] = ACTIONS(1909),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1909),
    [anon_sym_decltype] = ACTIONS(1909),
    [sym_virtual] = ACTIONS(1909),
    [anon_sym_typename] = ACTIONS(1909),
    [anon_sym_template] = ACTIONS(1909),
    [anon_sym_try] = ACTIONS(1909),
    [anon_sym_delete] = ACTIONS(1909),
    [anon_sym_throw] = ACTIONS(1909),
    [anon_sym_co_return] = ACTIONS(1909),
    [anon_sym_co_yield] = ACTIONS(1909),
    [anon_sym_catch] = ACTIONS(3830),
    [anon_sym_R_DQUOTE] = ACTIONS(1911),
    [anon_sym_LR_DQUOTE] = ACTIONS(1911),
    [anon_sym_uR_DQUOTE] = ACTIONS(1911),
    [anon_sym_UR_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1911),
    [anon_sym_co_await] = ACTIONS(1909),
    [anon_sym_new] = ACTIONS(1909),
    [anon_sym_requires] = ACTIONS(1909),
    [sym_this] = ACTIONS(1909),
    [anon_sym___launch_bounds__] = ACTIONS(1909),
  },
  [810] = {
    [sym_type_qualifier] = STATE(832),
    [sym_alignas_qualifier] = STATE(2108),
    [sym_expression] = STATE(5055),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_array_declarator_repeat1] = STATE(832),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(3833),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(3835),
    [anon_sym___global__] = ACTIONS(3835),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_static] = ACTIONS(3837),
    [anon_sym_RBRACK] = ACTIONS(3839),
    [anon_sym_const] = ACTIONS(3835),
    [anon_sym_constexpr] = ACTIONS(3835),
    [anon_sym_volatile] = ACTIONS(3835),
    [anon_sym_restrict] = ACTIONS(3835),
    [anon_sym___restrict__] = ACTIONS(3835),
    [anon_sym__Atomic] = ACTIONS(3835),
    [anon_sym__Noreturn] = ACTIONS(3835),
    [anon_sym_noreturn] = ACTIONS(3835),
    [anon_sym_mutable] = ACTIONS(3835),
    [anon_sym_constinit] = ACTIONS(3835),
    [anon_sym_consteval] = ACTIONS(3835),
    [anon_sym___shared__] = ACTIONS(3835),
    [anon_sym___local__] = ACTIONS(3835),
    [anon_sym___constant__] = ACTIONS(3835),
    [anon_sym___managed__] = ACTIONS(3835),
    [anon_sym___grid_constant__] = ACTIONS(3835),
    [anon_sym_alignas] = ACTIONS(3841),
    [anon_sym__Alignas] = ACTIONS(3841),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [811] = {
    [sym_type_qualifier] = STATE(830),
    [sym_alignas_qualifier] = STATE(2108),
    [sym_expression] = STATE(5011),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_array_declarator_repeat1] = STATE(830),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(3843),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(3835),
    [anon_sym___global__] = ACTIONS(3835),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_static] = ACTIONS(3845),
    [anon_sym_RBRACK] = ACTIONS(3847),
    [anon_sym_const] = ACTIONS(3835),
    [anon_sym_constexpr] = ACTIONS(3835),
    [anon_sym_volatile] = ACTIONS(3835),
    [anon_sym_restrict] = ACTIONS(3835),
    [anon_sym___restrict__] = ACTIONS(3835),
    [anon_sym__Atomic] = ACTIONS(3835),
    [anon_sym__Noreturn] = ACTIONS(3835),
    [anon_sym_noreturn] = ACTIONS(3835),
    [anon_sym_mutable] = ACTIONS(3835),
    [anon_sym_constinit] = ACTIONS(3835),
    [anon_sym_consteval] = ACTIONS(3835),
    [anon_sym___shared__] = ACTIONS(3835),
    [anon_sym___local__] = ACTIONS(3835),
    [anon_sym___constant__] = ACTIONS(3835),
    [anon_sym___managed__] = ACTIONS(3835),
    [anon_sym___grid_constant__] = ACTIONS(3835),
    [anon_sym_alignas] = ACTIONS(3841),
    [anon_sym__Alignas] = ACTIONS(3841),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [812] = {
    [sym_type_qualifier] = STATE(1846),
    [sym_alignas_qualifier] = STATE(2108),
    [sym_expression] = STATE(5116),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_array_declarator_repeat1] = STATE(1846),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(3849),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(3835),
    [anon_sym___global__] = ACTIONS(3835),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_static] = ACTIONS(3851),
    [anon_sym_RBRACK] = ACTIONS(3853),
    [anon_sym_const] = ACTIONS(3835),
    [anon_sym_constexpr] = ACTIONS(3835),
    [anon_sym_volatile] = ACTIONS(3835),
    [anon_sym_restrict] = ACTIONS(3835),
    [anon_sym___restrict__] = ACTIONS(3835),
    [anon_sym__Atomic] = ACTIONS(3835),
    [anon_sym__Noreturn] = ACTIONS(3835),
    [anon_sym_noreturn] = ACTIONS(3835),
    [anon_sym_mutable] = ACTIONS(3835),
    [anon_sym_constinit] = ACTIONS(3835),
    [anon_sym_consteval] = ACTIONS(3835),
    [anon_sym___shared__] = ACTIONS(3835),
    [anon_sym___local__] = ACTIONS(3835),
    [anon_sym___constant__] = ACTIONS(3835),
    [anon_sym___managed__] = ACTIONS(3835),
    [anon_sym___grid_constant__] = ACTIONS(3835),
    [anon_sym_alignas] = ACTIONS(3841),
    [anon_sym__Alignas] = ACTIONS(3841),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [813] = {
    [sym_type_qualifier] = STATE(822),
    [sym_alignas_qualifier] = STATE(2108),
    [sym_expression] = STATE(5123),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_array_declarator_repeat1] = STATE(822),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(3855),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(3835),
    [anon_sym___global__] = ACTIONS(3835),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_static] = ACTIONS(3857),
    [anon_sym_RBRACK] = ACTIONS(3859),
    [anon_sym_const] = ACTIONS(3835),
    [anon_sym_constexpr] = ACTIONS(3835),
    [anon_sym_volatile] = ACTIONS(3835),
    [anon_sym_restrict] = ACTIONS(3835),
    [anon_sym___restrict__] = ACTIONS(3835),
    [anon_sym__Atomic] = ACTIONS(3835),
    [anon_sym__Noreturn] = ACTIONS(3835),
    [anon_sym_noreturn] = ACTIONS(3835),
    [anon_sym_mutable] = ACTIONS(3835),
    [anon_sym_constinit] = ACTIONS(3835),
    [anon_sym_consteval] = ACTIONS(3835),
    [anon_sym___shared__] = ACTIONS(3835),
    [anon_sym___local__] = ACTIONS(3835),
    [anon_sym___constant__] = ACTIONS(3835),
    [anon_sym___managed__] = ACTIONS(3835),
    [anon_sym___grid_constant__] = ACTIONS(3835),
    [anon_sym_alignas] = ACTIONS(3841),
    [anon_sym__Alignas] = ACTIONS(3841),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [814] = {
    [sym_type_qualifier] = STATE(821),
    [sym_alignas_qualifier] = STATE(2108),
    [sym_expression] = STATE(5125),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_array_declarator_repeat1] = STATE(821),
    [sym_identifier] = ACTIONS(3861),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(3863),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(3835),
    [anon_sym___global__] = ACTIONS(3835),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_static] = ACTIONS(3865),
    [anon_sym_RBRACK] = ACTIONS(3867),
    [anon_sym_const] = ACTIONS(3835),
    [anon_sym_constexpr] = ACTIONS(3835),
    [anon_sym_volatile] = ACTIONS(3835),
    [anon_sym_restrict] = ACTIONS(3835),
    [anon_sym___restrict__] = ACTIONS(3835),
    [anon_sym__Atomic] = ACTIONS(3835),
    [anon_sym__Noreturn] = ACTIONS(3835),
    [anon_sym_noreturn] = ACTIONS(3835),
    [anon_sym_mutable] = ACTIONS(3835),
    [anon_sym_constinit] = ACTIONS(3835),
    [anon_sym_consteval] = ACTIONS(3835),
    [anon_sym___shared__] = ACTIONS(3835),
    [anon_sym___local__] = ACTIONS(3835),
    [anon_sym___constant__] = ACTIONS(3835),
    [anon_sym___managed__] = ACTIONS(3835),
    [anon_sym___grid_constant__] = ACTIONS(3835),
    [anon_sym_alignas] = ACTIONS(3841),
    [anon_sym__Alignas] = ACTIONS(3841),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [815] = {
    [sym_type_qualifier] = STATE(812),
    [sym_alignas_qualifier] = STATE(2108),
    [sym_expression] = STATE(5101),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_array_declarator_repeat1] = STATE(812),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(3869),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(3835),
    [anon_sym___global__] = ACTIONS(3835),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_static] = ACTIONS(3871),
    [anon_sym_RBRACK] = ACTIONS(3873),
    [anon_sym_const] = ACTIONS(3835),
    [anon_sym_constexpr] = ACTIONS(3835),
    [anon_sym_volatile] = ACTIONS(3835),
    [anon_sym_restrict] = ACTIONS(3835),
    [anon_sym___restrict__] = ACTIONS(3835),
    [anon_sym__Atomic] = ACTIONS(3835),
    [anon_sym__Noreturn] = ACTIONS(3835),
    [anon_sym_noreturn] = ACTIONS(3835),
    [anon_sym_mutable] = ACTIONS(3835),
    [anon_sym_constinit] = ACTIONS(3835),
    [anon_sym_consteval] = ACTIONS(3835),
    [anon_sym___shared__] = ACTIONS(3835),
    [anon_sym___local__] = ACTIONS(3835),
    [anon_sym___constant__] = ACTIONS(3835),
    [anon_sym___managed__] = ACTIONS(3835),
    [anon_sym___grid_constant__] = ACTIONS(3835),
    [anon_sym_alignas] = ACTIONS(3841),
    [anon_sym__Alignas] = ACTIONS(3841),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [816] = {
    [sym_type_qualifier] = STATE(818),
    [sym_alignas_qualifier] = STATE(2108),
    [sym_expression] = STATE(5025),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_array_declarator_repeat1] = STATE(818),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(3875),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(3835),
    [anon_sym___global__] = ACTIONS(3835),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_static] = ACTIONS(3877),
    [anon_sym_RBRACK] = ACTIONS(3879),
    [anon_sym_const] = ACTIONS(3835),
    [anon_sym_constexpr] = ACTIONS(3835),
    [anon_sym_volatile] = ACTIONS(3835),
    [anon_sym_restrict] = ACTIONS(3835),
    [anon_sym___restrict__] = ACTIONS(3835),
    [anon_sym__Atomic] = ACTIONS(3835),
    [anon_sym__Noreturn] = ACTIONS(3835),
    [anon_sym_noreturn] = ACTIONS(3835),
    [anon_sym_mutable] = ACTIONS(3835),
    [anon_sym_constinit] = ACTIONS(3835),
    [anon_sym_consteval] = ACTIONS(3835),
    [anon_sym___shared__] = ACTIONS(3835),
    [anon_sym___local__] = ACTIONS(3835),
    [anon_sym___constant__] = ACTIONS(3835),
    [anon_sym___managed__] = ACTIONS(3835),
    [anon_sym___grid_constant__] = ACTIONS(3835),
    [anon_sym_alignas] = ACTIONS(3841),
    [anon_sym__Alignas] = ACTIONS(3841),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [817] = {
    [sym_identifier] = ACTIONS(1924),
    [anon_sym_LPAREN2] = ACTIONS(1926),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [anon_sym_DASH] = ACTIONS(1924),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_STAR] = ACTIONS(1926),
    [anon_sym_AMP] = ACTIONS(1926),
    [anon_sym_SEMI] = ACTIONS(1926),
    [anon_sym___extension__] = ACTIONS(1924),
    [anon_sym_typedef] = ACTIONS(1924),
    [anon_sym___device__] = ACTIONS(1924),
    [anon_sym___host__] = ACTIONS(1924),
    [anon_sym___global__] = ACTIONS(1924),
    [anon_sym___forceinline__] = ACTIONS(1924),
    [anon_sym___noinline__] = ACTIONS(1924),
    [anon_sym_extern] = ACTIONS(1924),
    [anon_sym___attribute__] = ACTIONS(1924),
    [anon_sym_COLON_COLON] = ACTIONS(1926),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1926),
    [anon_sym___declspec] = ACTIONS(1924),
    [anon_sym_LBRACE] = ACTIONS(1926),
    [anon_sym_signed] = ACTIONS(1924),
    [anon_sym_unsigned] = ACTIONS(1924),
    [anon_sym_long] = ACTIONS(1924),
    [anon_sym_short] = ACTIONS(1924),
    [anon_sym_LBRACK] = ACTIONS(1924),
    [anon_sym_static] = ACTIONS(1924),
    [anon_sym_register] = ACTIONS(1924),
    [anon_sym_inline] = ACTIONS(1924),
    [anon_sym___inline] = ACTIONS(1924),
    [anon_sym___inline__] = ACTIONS(1924),
    [anon_sym___forceinline] = ACTIONS(1924),
    [anon_sym_thread_local] = ACTIONS(1924),
    [anon_sym___thread] = ACTIONS(1924),
    [anon_sym_const] = ACTIONS(1924),
    [anon_sym_constexpr] = ACTIONS(1924),
    [anon_sym_volatile] = ACTIONS(1924),
    [anon_sym_restrict] = ACTIONS(1924),
    [anon_sym___restrict__] = ACTIONS(1924),
    [anon_sym__Atomic] = ACTIONS(1924),
    [anon_sym__Noreturn] = ACTIONS(1924),
    [anon_sym_noreturn] = ACTIONS(1924),
    [anon_sym_mutable] = ACTIONS(1924),
    [anon_sym_constinit] = ACTIONS(1924),
    [anon_sym_consteval] = ACTIONS(1924),
    [anon_sym___shared__] = ACTIONS(1924),
    [anon_sym___local__] = ACTIONS(1924),
    [anon_sym___constant__] = ACTIONS(1924),
    [anon_sym___managed__] = ACTIONS(1924),
    [anon_sym___grid_constant__] = ACTIONS(1924),
    [anon_sym_alignas] = ACTIONS(1924),
    [anon_sym__Alignas] = ACTIONS(1924),
    [sym_primitive_type] = ACTIONS(1924),
    [anon_sym_enum] = ACTIONS(1924),
    [anon_sym_class] = ACTIONS(1924),
    [anon_sym_struct] = ACTIONS(1924),
    [anon_sym_union] = ACTIONS(1924),
    [anon_sym_if] = ACTIONS(1924),
    [anon_sym_else] = ACTIONS(1924),
    [anon_sym_switch] = ACTIONS(1924),
    [anon_sym_while] = ACTIONS(1924),
    [anon_sym_do] = ACTIONS(1924),
    [anon_sym_for] = ACTIONS(1924),
    [anon_sym_return] = ACTIONS(1924),
    [anon_sym_break] = ACTIONS(1924),
    [anon_sym_continue] = ACTIONS(1924),
    [anon_sym_goto] = ACTIONS(1924),
    [anon_sym___try] = ACTIONS(1924),
    [anon_sym___leave] = ACTIONS(1924),
    [anon_sym_not] = ACTIONS(1924),
    [anon_sym_compl] = ACTIONS(1924),
    [anon_sym_DASH_DASH] = ACTIONS(1926),
    [anon_sym_PLUS_PLUS] = ACTIONS(1926),
    [anon_sym_sizeof] = ACTIONS(1924),
    [anon_sym___alignof__] = ACTIONS(1924),
    [anon_sym___alignof] = ACTIONS(1924),
    [anon_sym__alignof] = ACTIONS(1924),
    [anon_sym_alignof] = ACTIONS(1924),
    [anon_sym__Alignof] = ACTIONS(1924),
    [anon_sym_offsetof] = ACTIONS(1924),
    [anon_sym__Generic] = ACTIONS(1924),
    [anon_sym_asm] = ACTIONS(1924),
    [anon_sym___asm__] = ACTIONS(1924),
    [sym_number_literal] = ACTIONS(1926),
    [anon_sym_L_SQUOTE] = ACTIONS(1926),
    [anon_sym_u_SQUOTE] = ACTIONS(1926),
    [anon_sym_U_SQUOTE] = ACTIONS(1926),
    [anon_sym_u8_SQUOTE] = ACTIONS(1926),
    [anon_sym_SQUOTE] = ACTIONS(1926),
    [anon_sym_L_DQUOTE] = ACTIONS(1926),
    [anon_sym_u_DQUOTE] = ACTIONS(1926),
    [anon_sym_U_DQUOTE] = ACTIONS(1926),
    [anon_sym_u8_DQUOTE] = ACTIONS(1926),
    [anon_sym_DQUOTE] = ACTIONS(1926),
    [sym_true] = ACTIONS(1924),
    [sym_false] = ACTIONS(1924),
    [anon_sym_NULL] = ACTIONS(1924),
    [anon_sym_nullptr] = ACTIONS(1924),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1924),
    [anon_sym_decltype] = ACTIONS(1924),
    [sym_virtual] = ACTIONS(1924),
    [anon_sym_typename] = ACTIONS(1924),
    [anon_sym_template] = ACTIONS(1924),
    [anon_sym_try] = ACTIONS(1924),
    [anon_sym_delete] = ACTIONS(1924),
    [anon_sym_throw] = ACTIONS(1924),
    [anon_sym_co_return] = ACTIONS(1924),
    [anon_sym_co_yield] = ACTIONS(1924),
    [anon_sym_catch] = ACTIONS(1924),
    [anon_sym_R_DQUOTE] = ACTIONS(1926),
    [anon_sym_LR_DQUOTE] = ACTIONS(1926),
    [anon_sym_uR_DQUOTE] = ACTIONS(1926),
    [anon_sym_UR_DQUOTE] = ACTIONS(1926),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1926),
    [anon_sym_co_await] = ACTIONS(1924),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_requires] = ACTIONS(1924),
    [sym_this] = ACTIONS(1924),
    [anon_sym___launch_bounds__] = ACTIONS(1924),
  },
  [818] = {
    [sym_type_qualifier] = STATE(1846),
    [sym_alignas_qualifier] = STATE(2108),
    [sym_expression] = STATE(5061),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_array_declarator_repeat1] = STATE(1846),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(3881),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(3835),
    [anon_sym___global__] = ACTIONS(3835),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_static] = ACTIONS(3851),
    [anon_sym_RBRACK] = ACTIONS(3883),
    [anon_sym_const] = ACTIONS(3835),
    [anon_sym_constexpr] = ACTIONS(3835),
    [anon_sym_volatile] = ACTIONS(3835),
    [anon_sym_restrict] = ACTIONS(3835),
    [anon_sym___restrict__] = ACTIONS(3835),
    [anon_sym__Atomic] = ACTIONS(3835),
    [anon_sym__Noreturn] = ACTIONS(3835),
    [anon_sym_noreturn] = ACTIONS(3835),
    [anon_sym_mutable] = ACTIONS(3835),
    [anon_sym_constinit] = ACTIONS(3835),
    [anon_sym_consteval] = ACTIONS(3835),
    [anon_sym___shared__] = ACTIONS(3835),
    [anon_sym___local__] = ACTIONS(3835),
    [anon_sym___constant__] = ACTIONS(3835),
    [anon_sym___managed__] = ACTIONS(3835),
    [anon_sym___grid_constant__] = ACTIONS(3835),
    [anon_sym_alignas] = ACTIONS(3841),
    [anon_sym__Alignas] = ACTIONS(3841),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [819] = {
    [sym_type_qualifier] = STATE(825),
    [sym_alignas_qualifier] = STATE(2108),
    [sym_expression] = STATE(5027),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_array_declarator_repeat1] = STATE(825),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(3835),
    [anon_sym___global__] = ACTIONS(3835),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_static] = ACTIONS(3887),
    [anon_sym_RBRACK] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3835),
    [anon_sym_constexpr] = ACTIONS(3835),
    [anon_sym_volatile] = ACTIONS(3835),
    [anon_sym_restrict] = ACTIONS(3835),
    [anon_sym___restrict__] = ACTIONS(3835),
    [anon_sym__Atomic] = ACTIONS(3835),
    [anon_sym__Noreturn] = ACTIONS(3835),
    [anon_sym_noreturn] = ACTIONS(3835),
    [anon_sym_mutable] = ACTIONS(3835),
    [anon_sym_constinit] = ACTIONS(3835),
    [anon_sym_consteval] = ACTIONS(3835),
    [anon_sym___shared__] = ACTIONS(3835),
    [anon_sym___local__] = ACTIONS(3835),
    [anon_sym___constant__] = ACTIONS(3835),
    [anon_sym___managed__] = ACTIONS(3835),
    [anon_sym___grid_constant__] = ACTIONS(3835),
    [anon_sym_alignas] = ACTIONS(3841),
    [anon_sym__Alignas] = ACTIONS(3841),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [820] = {
    [sym_else_clause] = STATE(842),
    [sym_identifier] = ACTIONS(1928),
    [anon_sym_LPAREN2] = ACTIONS(1930),
    [anon_sym_BANG] = ACTIONS(1930),
    [anon_sym_TILDE] = ACTIONS(1930),
    [anon_sym_DASH] = ACTIONS(1928),
    [anon_sym_PLUS] = ACTIONS(1928),
    [anon_sym_STAR] = ACTIONS(1930),
    [anon_sym_AMP] = ACTIONS(1930),
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym___extension__] = ACTIONS(1928),
    [anon_sym_typedef] = ACTIONS(1928),
    [anon_sym___device__] = ACTIONS(1928),
    [anon_sym___host__] = ACTIONS(1928),
    [anon_sym___global__] = ACTIONS(1928),
    [anon_sym___forceinline__] = ACTIONS(1928),
    [anon_sym___noinline__] = ACTIONS(1928),
    [anon_sym_extern] = ACTIONS(1928),
    [anon_sym___attribute__] = ACTIONS(1928),
    [anon_sym_COLON_COLON] = ACTIONS(1930),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1930),
    [anon_sym___declspec] = ACTIONS(1928),
    [anon_sym_LBRACE] = ACTIONS(1930),
    [anon_sym_signed] = ACTIONS(1928),
    [anon_sym_unsigned] = ACTIONS(1928),
    [anon_sym_long] = ACTIONS(1928),
    [anon_sym_short] = ACTIONS(1928),
    [anon_sym_LBRACK] = ACTIONS(1928),
    [anon_sym_static] = ACTIONS(1928),
    [anon_sym_register] = ACTIONS(1928),
    [anon_sym_inline] = ACTIONS(1928),
    [anon_sym___inline] = ACTIONS(1928),
    [anon_sym___inline__] = ACTIONS(1928),
    [anon_sym___forceinline] = ACTIONS(1928),
    [anon_sym_thread_local] = ACTIONS(1928),
    [anon_sym___thread] = ACTIONS(1928),
    [anon_sym_const] = ACTIONS(1928),
    [anon_sym_constexpr] = ACTIONS(1928),
    [anon_sym_volatile] = ACTIONS(1928),
    [anon_sym_restrict] = ACTIONS(1928),
    [anon_sym___restrict__] = ACTIONS(1928),
    [anon_sym__Atomic] = ACTIONS(1928),
    [anon_sym__Noreturn] = ACTIONS(1928),
    [anon_sym_noreturn] = ACTIONS(1928),
    [anon_sym_mutable] = ACTIONS(1928),
    [anon_sym_constinit] = ACTIONS(1928),
    [anon_sym_consteval] = ACTIONS(1928),
    [anon_sym___shared__] = ACTIONS(1928),
    [anon_sym___local__] = ACTIONS(1928),
    [anon_sym___constant__] = ACTIONS(1928),
    [anon_sym___managed__] = ACTIONS(1928),
    [anon_sym___grid_constant__] = ACTIONS(1928),
    [anon_sym_alignas] = ACTIONS(1928),
    [anon_sym__Alignas] = ACTIONS(1928),
    [sym_primitive_type] = ACTIONS(1928),
    [anon_sym_enum] = ACTIONS(1928),
    [anon_sym_class] = ACTIONS(1928),
    [anon_sym_struct] = ACTIONS(1928),
    [anon_sym_union] = ACTIONS(1928),
    [anon_sym_if] = ACTIONS(1928),
    [anon_sym_else] = ACTIONS(3891),
    [anon_sym_switch] = ACTIONS(1928),
    [anon_sym_while] = ACTIONS(1928),
    [anon_sym_do] = ACTIONS(1928),
    [anon_sym_for] = ACTIONS(1928),
    [anon_sym_return] = ACTIONS(1928),
    [anon_sym_break] = ACTIONS(1928),
    [anon_sym_continue] = ACTIONS(1928),
    [anon_sym_goto] = ACTIONS(1928),
    [anon_sym___try] = ACTIONS(1928),
    [anon_sym___leave] = ACTIONS(1928),
    [anon_sym_not] = ACTIONS(1928),
    [anon_sym_compl] = ACTIONS(1928),
    [anon_sym_DASH_DASH] = ACTIONS(1930),
    [anon_sym_PLUS_PLUS] = ACTIONS(1930),
    [anon_sym_sizeof] = ACTIONS(1928),
    [anon_sym___alignof__] = ACTIONS(1928),
    [anon_sym___alignof] = ACTIONS(1928),
    [anon_sym__alignof] = ACTIONS(1928),
    [anon_sym_alignof] = ACTIONS(1928),
    [anon_sym__Alignof] = ACTIONS(1928),
    [anon_sym_offsetof] = ACTIONS(1928),
    [anon_sym__Generic] = ACTIONS(1928),
    [anon_sym_asm] = ACTIONS(1928),
    [anon_sym___asm__] = ACTIONS(1928),
    [sym_number_literal] = ACTIONS(1930),
    [anon_sym_L_SQUOTE] = ACTIONS(1930),
    [anon_sym_u_SQUOTE] = ACTIONS(1930),
    [anon_sym_U_SQUOTE] = ACTIONS(1930),
    [anon_sym_u8_SQUOTE] = ACTIONS(1930),
    [anon_sym_SQUOTE] = ACTIONS(1930),
    [anon_sym_L_DQUOTE] = ACTIONS(1930),
    [anon_sym_u_DQUOTE] = ACTIONS(1930),
    [anon_sym_U_DQUOTE] = ACTIONS(1930),
    [anon_sym_u8_DQUOTE] = ACTIONS(1930),
    [anon_sym_DQUOTE] = ACTIONS(1930),
    [sym_true] = ACTIONS(1928),
    [sym_false] = ACTIONS(1928),
    [anon_sym_NULL] = ACTIONS(1928),
    [anon_sym_nullptr] = ACTIONS(1928),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1928),
    [anon_sym_decltype] = ACTIONS(1928),
    [sym_virtual] = ACTIONS(1928),
    [anon_sym_typename] = ACTIONS(1928),
    [anon_sym_template] = ACTIONS(1928),
    [anon_sym_try] = ACTIONS(1928),
    [anon_sym_delete] = ACTIONS(1928),
    [anon_sym_throw] = ACTIONS(1928),
    [anon_sym_co_return] = ACTIONS(1928),
    [anon_sym_co_yield] = ACTIONS(1928),
    [anon_sym_R_DQUOTE] = ACTIONS(1930),
    [anon_sym_LR_DQUOTE] = ACTIONS(1930),
    [anon_sym_uR_DQUOTE] = ACTIONS(1930),
    [anon_sym_UR_DQUOTE] = ACTIONS(1930),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1930),
    [anon_sym_co_await] = ACTIONS(1928),
    [anon_sym_new] = ACTIONS(1928),
    [anon_sym_requires] = ACTIONS(1928),
    [sym_this] = ACTIONS(1928),
    [anon_sym___launch_bounds__] = ACTIONS(1928),
  },
  [821] = {
    [sym_type_qualifier] = STATE(1846),
    [sym_alignas_qualifier] = STATE(2108),
    [sym_expression] = STATE(5127),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_array_declarator_repeat1] = STATE(1846),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(3893),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(3835),
    [anon_sym___global__] = ACTIONS(3835),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_static] = ACTIONS(3851),
    [anon_sym_RBRACK] = ACTIONS(3895),
    [anon_sym_const] = ACTIONS(3835),
    [anon_sym_constexpr] = ACTIONS(3835),
    [anon_sym_volatile] = ACTIONS(3835),
    [anon_sym_restrict] = ACTIONS(3835),
    [anon_sym___restrict__] = ACTIONS(3835),
    [anon_sym__Atomic] = ACTIONS(3835),
    [anon_sym__Noreturn] = ACTIONS(3835),
    [anon_sym_noreturn] = ACTIONS(3835),
    [anon_sym_mutable] = ACTIONS(3835),
    [anon_sym_constinit] = ACTIONS(3835),
    [anon_sym_consteval] = ACTIONS(3835),
    [anon_sym___shared__] = ACTIONS(3835),
    [anon_sym___local__] = ACTIONS(3835),
    [anon_sym___constant__] = ACTIONS(3835),
    [anon_sym___managed__] = ACTIONS(3835),
    [anon_sym___grid_constant__] = ACTIONS(3835),
    [anon_sym_alignas] = ACTIONS(3841),
    [anon_sym__Alignas] = ACTIONS(3841),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [822] = {
    [sym_type_qualifier] = STATE(1846),
    [sym_alignas_qualifier] = STATE(2108),
    [sym_expression] = STATE(5129),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_array_declarator_repeat1] = STATE(1846),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(3835),
    [anon_sym___global__] = ACTIONS(3835),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_static] = ACTIONS(3851),
    [anon_sym_RBRACK] = ACTIONS(3899),
    [anon_sym_const] = ACTIONS(3835),
    [anon_sym_constexpr] = ACTIONS(3835),
    [anon_sym_volatile] = ACTIONS(3835),
    [anon_sym_restrict] = ACTIONS(3835),
    [anon_sym___restrict__] = ACTIONS(3835),
    [anon_sym__Atomic] = ACTIONS(3835),
    [anon_sym__Noreturn] = ACTIONS(3835),
    [anon_sym_noreturn] = ACTIONS(3835),
    [anon_sym_mutable] = ACTIONS(3835),
    [anon_sym_constinit] = ACTIONS(3835),
    [anon_sym_consteval] = ACTIONS(3835),
    [anon_sym___shared__] = ACTIONS(3835),
    [anon_sym___local__] = ACTIONS(3835),
    [anon_sym___constant__] = ACTIONS(3835),
    [anon_sym___managed__] = ACTIONS(3835),
    [anon_sym___grid_constant__] = ACTIONS(3835),
    [anon_sym_alignas] = ACTIONS(3841),
    [anon_sym__Alignas] = ACTIONS(3841),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [823] = {
    [sym_identifier] = ACTIONS(1901),
    [anon_sym_LPAREN2] = ACTIONS(1899),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_DASH] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1901),
    [anon_sym_STAR] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_SEMI] = ACTIONS(1899),
    [anon_sym___extension__] = ACTIONS(1901),
    [anon_sym_typedef] = ACTIONS(1901),
    [anon_sym___device__] = ACTIONS(1901),
    [anon_sym___host__] = ACTIONS(1901),
    [anon_sym___global__] = ACTIONS(1901),
    [anon_sym___forceinline__] = ACTIONS(1901),
    [anon_sym___noinline__] = ACTIONS(1901),
    [anon_sym_extern] = ACTIONS(1901),
    [anon_sym___attribute__] = ACTIONS(1901),
    [anon_sym_COLON_COLON] = ACTIONS(1899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1899),
    [anon_sym___declspec] = ACTIONS(1901),
    [anon_sym_LBRACE] = ACTIONS(1899),
    [anon_sym_signed] = ACTIONS(1901),
    [anon_sym_unsigned] = ACTIONS(1901),
    [anon_sym_long] = ACTIONS(1901),
    [anon_sym_short] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1901),
    [anon_sym_static] = ACTIONS(1901),
    [anon_sym_register] = ACTIONS(1901),
    [anon_sym_inline] = ACTIONS(1901),
    [anon_sym___inline] = ACTIONS(1901),
    [anon_sym___inline__] = ACTIONS(1901),
    [anon_sym___forceinline] = ACTIONS(1901),
    [anon_sym_thread_local] = ACTIONS(1901),
    [anon_sym___thread] = ACTIONS(1901),
    [anon_sym_const] = ACTIONS(1901),
    [anon_sym_constexpr] = ACTIONS(1901),
    [anon_sym_volatile] = ACTIONS(1901),
    [anon_sym_restrict] = ACTIONS(1901),
    [anon_sym___restrict__] = ACTIONS(1901),
    [anon_sym__Atomic] = ACTIONS(1901),
    [anon_sym__Noreturn] = ACTIONS(1901),
    [anon_sym_noreturn] = ACTIONS(1901),
    [anon_sym_mutable] = ACTIONS(1901),
    [anon_sym_constinit] = ACTIONS(1901),
    [anon_sym_consteval] = ACTIONS(1901),
    [anon_sym___shared__] = ACTIONS(1901),
    [anon_sym___local__] = ACTIONS(1901),
    [anon_sym___constant__] = ACTIONS(1901),
    [anon_sym___managed__] = ACTIONS(1901),
    [anon_sym___grid_constant__] = ACTIONS(1901),
    [anon_sym_alignas] = ACTIONS(1901),
    [anon_sym__Alignas] = ACTIONS(1901),
    [sym_primitive_type] = ACTIONS(1901),
    [anon_sym_enum] = ACTIONS(1901),
    [anon_sym_class] = ACTIONS(1901),
    [anon_sym_struct] = ACTIONS(1901),
    [anon_sym_union] = ACTIONS(1901),
    [anon_sym_if] = ACTIONS(1901),
    [anon_sym_else] = ACTIONS(1901),
    [anon_sym_switch] = ACTIONS(1901),
    [anon_sym_while] = ACTIONS(1901),
    [anon_sym_do] = ACTIONS(1901),
    [anon_sym_for] = ACTIONS(1901),
    [anon_sym_return] = ACTIONS(1901),
    [anon_sym_break] = ACTIONS(1901),
    [anon_sym_continue] = ACTIONS(1901),
    [anon_sym_goto] = ACTIONS(1901),
    [anon_sym___try] = ACTIONS(1901),
    [anon_sym___leave] = ACTIONS(1901),
    [anon_sym_not] = ACTIONS(1901),
    [anon_sym_compl] = ACTIONS(1901),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_sizeof] = ACTIONS(1901),
    [anon_sym___alignof__] = ACTIONS(1901),
    [anon_sym___alignof] = ACTIONS(1901),
    [anon_sym__alignof] = ACTIONS(1901),
    [anon_sym_alignof] = ACTIONS(1901),
    [anon_sym__Alignof] = ACTIONS(1901),
    [anon_sym_offsetof] = ACTIONS(1901),
    [anon_sym__Generic] = ACTIONS(1901),
    [anon_sym_asm] = ACTIONS(1901),
    [anon_sym___asm__] = ACTIONS(1901),
    [sym_number_literal] = ACTIONS(1899),
    [anon_sym_L_SQUOTE] = ACTIONS(1899),
    [anon_sym_u_SQUOTE] = ACTIONS(1899),
    [anon_sym_U_SQUOTE] = ACTIONS(1899),
    [anon_sym_u8_SQUOTE] = ACTIONS(1899),
    [anon_sym_SQUOTE] = ACTIONS(1899),
    [anon_sym_L_DQUOTE] = ACTIONS(1899),
    [anon_sym_u_DQUOTE] = ACTIONS(1899),
    [anon_sym_U_DQUOTE] = ACTIONS(1899),
    [anon_sym_u8_DQUOTE] = ACTIONS(1899),
    [anon_sym_DQUOTE] = ACTIONS(1899),
    [sym_true] = ACTIONS(1901),
    [sym_false] = ACTIONS(1901),
    [anon_sym_NULL] = ACTIONS(1901),
    [anon_sym_nullptr] = ACTIONS(1901),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1901),
    [anon_sym_decltype] = ACTIONS(1901),
    [sym_virtual] = ACTIONS(1901),
    [anon_sym_typename] = ACTIONS(1901),
    [anon_sym_template] = ACTIONS(1901),
    [anon_sym_try] = ACTIONS(1901),
    [anon_sym_delete] = ACTIONS(1901),
    [anon_sym_throw] = ACTIONS(1901),
    [anon_sym_co_return] = ACTIONS(1901),
    [anon_sym_co_yield] = ACTIONS(1901),
    [anon_sym_catch] = ACTIONS(1901),
    [anon_sym_R_DQUOTE] = ACTIONS(1899),
    [anon_sym_LR_DQUOTE] = ACTIONS(1899),
    [anon_sym_uR_DQUOTE] = ACTIONS(1899),
    [anon_sym_UR_DQUOTE] = ACTIONS(1899),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1899),
    [anon_sym_co_await] = ACTIONS(1901),
    [anon_sym_new] = ACTIONS(1901),
    [anon_sym_requires] = ACTIONS(1901),
    [sym_this] = ACTIONS(1901),
    [anon_sym___launch_bounds__] = ACTIONS(1901),
  },
  [824] = {
    [sym_type_qualifier] = STATE(828),
    [sym_alignas_qualifier] = STATE(2108),
    [sym_expression] = STATE(5121),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_array_declarator_repeat1] = STATE(828),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(3835),
    [anon_sym___global__] = ACTIONS(3835),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_static] = ACTIONS(3903),
    [anon_sym_RBRACK] = ACTIONS(3905),
    [anon_sym_const] = ACTIONS(3835),
    [anon_sym_constexpr] = ACTIONS(3835),
    [anon_sym_volatile] = ACTIONS(3835),
    [anon_sym_restrict] = ACTIONS(3835),
    [anon_sym___restrict__] = ACTIONS(3835),
    [anon_sym__Atomic] = ACTIONS(3835),
    [anon_sym__Noreturn] = ACTIONS(3835),
    [anon_sym_noreturn] = ACTIONS(3835),
    [anon_sym_mutable] = ACTIONS(3835),
    [anon_sym_constinit] = ACTIONS(3835),
    [anon_sym_consteval] = ACTIONS(3835),
    [anon_sym___shared__] = ACTIONS(3835),
    [anon_sym___local__] = ACTIONS(3835),
    [anon_sym___constant__] = ACTIONS(3835),
    [anon_sym___managed__] = ACTIONS(3835),
    [anon_sym___grid_constant__] = ACTIONS(3835),
    [anon_sym_alignas] = ACTIONS(3841),
    [anon_sym__Alignas] = ACTIONS(3841),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [825] = {
    [sym_type_qualifier] = STATE(1846),
    [sym_alignas_qualifier] = STATE(2108),
    [sym_expression] = STATE(5079),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_array_declarator_repeat1] = STATE(1846),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(3907),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(3835),
    [anon_sym___global__] = ACTIONS(3835),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_static] = ACTIONS(3851),
    [anon_sym_RBRACK] = ACTIONS(3909),
    [anon_sym_const] = ACTIONS(3835),
    [anon_sym_constexpr] = ACTIONS(3835),
    [anon_sym_volatile] = ACTIONS(3835),
    [anon_sym_restrict] = ACTIONS(3835),
    [anon_sym___restrict__] = ACTIONS(3835),
    [anon_sym__Atomic] = ACTIONS(3835),
    [anon_sym__Noreturn] = ACTIONS(3835),
    [anon_sym_noreturn] = ACTIONS(3835),
    [anon_sym_mutable] = ACTIONS(3835),
    [anon_sym_constinit] = ACTIONS(3835),
    [anon_sym_consteval] = ACTIONS(3835),
    [anon_sym___shared__] = ACTIONS(3835),
    [anon_sym___local__] = ACTIONS(3835),
    [anon_sym___constant__] = ACTIONS(3835),
    [anon_sym___managed__] = ACTIONS(3835),
    [anon_sym___grid_constant__] = ACTIONS(3835),
    [anon_sym_alignas] = ACTIONS(3841),
    [anon_sym__Alignas] = ACTIONS(3841),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [826] = {
    [sym_type_qualifier] = STATE(821),
    [sym_alignas_qualifier] = STATE(2108),
    [sym_expression] = STATE(5125),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_array_declarator_repeat1] = STATE(821),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(3863),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(3835),
    [anon_sym___global__] = ACTIONS(3835),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_static] = ACTIONS(3865),
    [anon_sym_RBRACK] = ACTIONS(3867),
    [anon_sym_const] = ACTIONS(3835),
    [anon_sym_constexpr] = ACTIONS(3835),
    [anon_sym_volatile] = ACTIONS(3835),
    [anon_sym_restrict] = ACTIONS(3835),
    [anon_sym___restrict__] = ACTIONS(3835),
    [anon_sym__Atomic] = ACTIONS(3835),
    [anon_sym__Noreturn] = ACTIONS(3835),
    [anon_sym_noreturn] = ACTIONS(3835),
    [anon_sym_mutable] = ACTIONS(3835),
    [anon_sym_constinit] = ACTIONS(3835),
    [anon_sym_consteval] = ACTIONS(3835),
    [anon_sym___shared__] = ACTIONS(3835),
    [anon_sym___local__] = ACTIONS(3835),
    [anon_sym___constant__] = ACTIONS(3835),
    [anon_sym___managed__] = ACTIONS(3835),
    [anon_sym___grid_constant__] = ACTIONS(3835),
    [anon_sym_alignas] = ACTIONS(3841),
    [anon_sym__Alignas] = ACTIONS(3841),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [827] = {
    [sym_identifier] = ACTIONS(1897),
    [anon_sym_LPAREN2] = ACTIONS(1895),
    [anon_sym_BANG] = ACTIONS(1895),
    [anon_sym_TILDE] = ACTIONS(1895),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_AMP] = ACTIONS(1895),
    [anon_sym_SEMI] = ACTIONS(1895),
    [anon_sym___extension__] = ACTIONS(1897),
    [anon_sym_typedef] = ACTIONS(1897),
    [anon_sym___device__] = ACTIONS(1897),
    [anon_sym___host__] = ACTIONS(1897),
    [anon_sym___global__] = ACTIONS(1897),
    [anon_sym___forceinline__] = ACTIONS(1897),
    [anon_sym___noinline__] = ACTIONS(1897),
    [anon_sym_extern] = ACTIONS(1897),
    [anon_sym___attribute__] = ACTIONS(1897),
    [anon_sym_COLON_COLON] = ACTIONS(1895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1895),
    [anon_sym___declspec] = ACTIONS(1897),
    [anon_sym_LBRACE] = ACTIONS(1895),
    [anon_sym_signed] = ACTIONS(1897),
    [anon_sym_unsigned] = ACTIONS(1897),
    [anon_sym_long] = ACTIONS(1897),
    [anon_sym_short] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1897),
    [anon_sym_static] = ACTIONS(1897),
    [anon_sym_register] = ACTIONS(1897),
    [anon_sym_inline] = ACTIONS(1897),
    [anon_sym___inline] = ACTIONS(1897),
    [anon_sym___inline__] = ACTIONS(1897),
    [anon_sym___forceinline] = ACTIONS(1897),
    [anon_sym_thread_local] = ACTIONS(1897),
    [anon_sym___thread] = ACTIONS(1897),
    [anon_sym_const] = ACTIONS(1897),
    [anon_sym_constexpr] = ACTIONS(1897),
    [anon_sym_volatile] = ACTIONS(1897),
    [anon_sym_restrict] = ACTIONS(1897),
    [anon_sym___restrict__] = ACTIONS(1897),
    [anon_sym__Atomic] = ACTIONS(1897),
    [anon_sym__Noreturn] = ACTIONS(1897),
    [anon_sym_noreturn] = ACTIONS(1897),
    [anon_sym_mutable] = ACTIONS(1897),
    [anon_sym_constinit] = ACTIONS(1897),
    [anon_sym_consteval] = ACTIONS(1897),
    [anon_sym___shared__] = ACTIONS(1897),
    [anon_sym___local__] = ACTIONS(1897),
    [anon_sym___constant__] = ACTIONS(1897),
    [anon_sym___managed__] = ACTIONS(1897),
    [anon_sym___grid_constant__] = ACTIONS(1897),
    [anon_sym_alignas] = ACTIONS(1897),
    [anon_sym__Alignas] = ACTIONS(1897),
    [sym_primitive_type] = ACTIONS(1897),
    [anon_sym_enum] = ACTIONS(1897),
    [anon_sym_class] = ACTIONS(1897),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1897),
    [anon_sym_if] = ACTIONS(1897),
    [anon_sym_else] = ACTIONS(1897),
    [anon_sym_switch] = ACTIONS(1897),
    [anon_sym_while] = ACTIONS(1897),
    [anon_sym_do] = ACTIONS(1897),
    [anon_sym_for] = ACTIONS(1897),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_continue] = ACTIONS(1897),
    [anon_sym_goto] = ACTIONS(1897),
    [anon_sym___try] = ACTIONS(1897),
    [anon_sym___leave] = ACTIONS(1897),
    [anon_sym_not] = ACTIONS(1897),
    [anon_sym_compl] = ACTIONS(1897),
    [anon_sym_DASH_DASH] = ACTIONS(1895),
    [anon_sym_PLUS_PLUS] = ACTIONS(1895),
    [anon_sym_sizeof] = ACTIONS(1897),
    [anon_sym___alignof__] = ACTIONS(1897),
    [anon_sym___alignof] = ACTIONS(1897),
    [anon_sym__alignof] = ACTIONS(1897),
    [anon_sym_alignof] = ACTIONS(1897),
    [anon_sym__Alignof] = ACTIONS(1897),
    [anon_sym_offsetof] = ACTIONS(1897),
    [anon_sym__Generic] = ACTIONS(1897),
    [anon_sym_asm] = ACTIONS(1897),
    [anon_sym___asm__] = ACTIONS(1897),
    [sym_number_literal] = ACTIONS(1895),
    [anon_sym_L_SQUOTE] = ACTIONS(1895),
    [anon_sym_u_SQUOTE] = ACTIONS(1895),
    [anon_sym_U_SQUOTE] = ACTIONS(1895),
    [anon_sym_u8_SQUOTE] = ACTIONS(1895),
    [anon_sym_SQUOTE] = ACTIONS(1895),
    [anon_sym_L_DQUOTE] = ACTIONS(1895),
    [anon_sym_u_DQUOTE] = ACTIONS(1895),
    [anon_sym_U_DQUOTE] = ACTIONS(1895),
    [anon_sym_u8_DQUOTE] = ACTIONS(1895),
    [anon_sym_DQUOTE] = ACTIONS(1895),
    [sym_true] = ACTIONS(1897),
    [sym_false] = ACTIONS(1897),
    [anon_sym_NULL] = ACTIONS(1897),
    [anon_sym_nullptr] = ACTIONS(1897),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1897),
    [anon_sym_decltype] = ACTIONS(1897),
    [sym_virtual] = ACTIONS(1897),
    [anon_sym_typename] = ACTIONS(1897),
    [anon_sym_template] = ACTIONS(1897),
    [anon_sym_try] = ACTIONS(1897),
    [anon_sym_delete] = ACTIONS(1897),
    [anon_sym_throw] = ACTIONS(1897),
    [anon_sym_co_return] = ACTIONS(1897),
    [anon_sym_co_yield] = ACTIONS(1897),
    [anon_sym_catch] = ACTIONS(1897),
    [anon_sym_R_DQUOTE] = ACTIONS(1895),
    [anon_sym_LR_DQUOTE] = ACTIONS(1895),
    [anon_sym_uR_DQUOTE] = ACTIONS(1895),
    [anon_sym_UR_DQUOTE] = ACTIONS(1895),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1895),
    [anon_sym_co_await] = ACTIONS(1897),
    [anon_sym_new] = ACTIONS(1897),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1897),
    [anon_sym___launch_bounds__] = ACTIONS(1897),
  },
  [828] = {
    [sym_type_qualifier] = STATE(1846),
    [sym_alignas_qualifier] = STATE(2108),
    [sym_expression] = STATE(5034),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_array_declarator_repeat1] = STATE(1846),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(3911),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(3835),
    [anon_sym___global__] = ACTIONS(3835),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_static] = ACTIONS(3851),
    [anon_sym_RBRACK] = ACTIONS(3913),
    [anon_sym_const] = ACTIONS(3835),
    [anon_sym_constexpr] = ACTIONS(3835),
    [anon_sym_volatile] = ACTIONS(3835),
    [anon_sym_restrict] = ACTIONS(3835),
    [anon_sym___restrict__] = ACTIONS(3835),
    [anon_sym__Atomic] = ACTIONS(3835),
    [anon_sym__Noreturn] = ACTIONS(3835),
    [anon_sym_noreturn] = ACTIONS(3835),
    [anon_sym_mutable] = ACTIONS(3835),
    [anon_sym_constinit] = ACTIONS(3835),
    [anon_sym_consteval] = ACTIONS(3835),
    [anon_sym___shared__] = ACTIONS(3835),
    [anon_sym___local__] = ACTIONS(3835),
    [anon_sym___constant__] = ACTIONS(3835),
    [anon_sym___managed__] = ACTIONS(3835),
    [anon_sym___grid_constant__] = ACTIONS(3835),
    [anon_sym_alignas] = ACTIONS(3841),
    [anon_sym__Alignas] = ACTIONS(3841),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [829] = {
    [sym_type_qualifier] = STATE(833),
    [sym_alignas_qualifier] = STATE(2108),
    [sym_expression] = STATE(5080),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_array_declarator_repeat1] = STATE(833),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(3915),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(3835),
    [anon_sym___global__] = ACTIONS(3835),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_static] = ACTIONS(3917),
    [anon_sym_RBRACK] = ACTIONS(3919),
    [anon_sym_const] = ACTIONS(3835),
    [anon_sym_constexpr] = ACTIONS(3835),
    [anon_sym_volatile] = ACTIONS(3835),
    [anon_sym_restrict] = ACTIONS(3835),
    [anon_sym___restrict__] = ACTIONS(3835),
    [anon_sym__Atomic] = ACTIONS(3835),
    [anon_sym__Noreturn] = ACTIONS(3835),
    [anon_sym_noreturn] = ACTIONS(3835),
    [anon_sym_mutable] = ACTIONS(3835),
    [anon_sym_constinit] = ACTIONS(3835),
    [anon_sym_consteval] = ACTIONS(3835),
    [anon_sym___shared__] = ACTIONS(3835),
    [anon_sym___local__] = ACTIONS(3835),
    [anon_sym___constant__] = ACTIONS(3835),
    [anon_sym___managed__] = ACTIONS(3835),
    [anon_sym___grid_constant__] = ACTIONS(3835),
    [anon_sym_alignas] = ACTIONS(3841),
    [anon_sym__Alignas] = ACTIONS(3841),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [830] = {
    [sym_type_qualifier] = STATE(1846),
    [sym_alignas_qualifier] = STATE(2108),
    [sym_expression] = STATE(5004),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_array_declarator_repeat1] = STATE(1846),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(3921),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(3835),
    [anon_sym___global__] = ACTIONS(3835),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_static] = ACTIONS(3851),
    [anon_sym_RBRACK] = ACTIONS(3923),
    [anon_sym_const] = ACTIONS(3835),
    [anon_sym_constexpr] = ACTIONS(3835),
    [anon_sym_volatile] = ACTIONS(3835),
    [anon_sym_restrict] = ACTIONS(3835),
    [anon_sym___restrict__] = ACTIONS(3835),
    [anon_sym__Atomic] = ACTIONS(3835),
    [anon_sym__Noreturn] = ACTIONS(3835),
    [anon_sym_noreturn] = ACTIONS(3835),
    [anon_sym_mutable] = ACTIONS(3835),
    [anon_sym_constinit] = ACTIONS(3835),
    [anon_sym_consteval] = ACTIONS(3835),
    [anon_sym___shared__] = ACTIONS(3835),
    [anon_sym___local__] = ACTIONS(3835),
    [anon_sym___constant__] = ACTIONS(3835),
    [anon_sym___managed__] = ACTIONS(3835),
    [anon_sym___grid_constant__] = ACTIONS(3835),
    [anon_sym_alignas] = ACTIONS(3841),
    [anon_sym__Alignas] = ACTIONS(3841),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [831] = {
    [sym_type_qualifier] = STATE(1846),
    [sym_alignas_qualifier] = STATE(2108),
    [sym_expression] = STATE(5114),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_array_declarator_repeat1] = STATE(1846),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(3925),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(3835),
    [anon_sym___global__] = ACTIONS(3835),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_static] = ACTIONS(3851),
    [anon_sym_RBRACK] = ACTIONS(3927),
    [anon_sym_const] = ACTIONS(3835),
    [anon_sym_constexpr] = ACTIONS(3835),
    [anon_sym_volatile] = ACTIONS(3835),
    [anon_sym_restrict] = ACTIONS(3835),
    [anon_sym___restrict__] = ACTIONS(3835),
    [anon_sym__Atomic] = ACTIONS(3835),
    [anon_sym__Noreturn] = ACTIONS(3835),
    [anon_sym_noreturn] = ACTIONS(3835),
    [anon_sym_mutable] = ACTIONS(3835),
    [anon_sym_constinit] = ACTIONS(3835),
    [anon_sym_consteval] = ACTIONS(3835),
    [anon_sym___shared__] = ACTIONS(3835),
    [anon_sym___local__] = ACTIONS(3835),
    [anon_sym___constant__] = ACTIONS(3835),
    [anon_sym___managed__] = ACTIONS(3835),
    [anon_sym___grid_constant__] = ACTIONS(3835),
    [anon_sym_alignas] = ACTIONS(3841),
    [anon_sym__Alignas] = ACTIONS(3841),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [832] = {
    [sym_type_qualifier] = STATE(1846),
    [sym_alignas_qualifier] = STATE(2108),
    [sym_expression] = STATE(5095),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_array_declarator_repeat1] = STATE(1846),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(3835),
    [anon_sym___global__] = ACTIONS(3835),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_static] = ACTIONS(3851),
    [anon_sym_RBRACK] = ACTIONS(3931),
    [anon_sym_const] = ACTIONS(3835),
    [anon_sym_constexpr] = ACTIONS(3835),
    [anon_sym_volatile] = ACTIONS(3835),
    [anon_sym_restrict] = ACTIONS(3835),
    [anon_sym___restrict__] = ACTIONS(3835),
    [anon_sym__Atomic] = ACTIONS(3835),
    [anon_sym__Noreturn] = ACTIONS(3835),
    [anon_sym_noreturn] = ACTIONS(3835),
    [anon_sym_mutable] = ACTIONS(3835),
    [anon_sym_constinit] = ACTIONS(3835),
    [anon_sym_consteval] = ACTIONS(3835),
    [anon_sym___shared__] = ACTIONS(3835),
    [anon_sym___local__] = ACTIONS(3835),
    [anon_sym___constant__] = ACTIONS(3835),
    [anon_sym___managed__] = ACTIONS(3835),
    [anon_sym___grid_constant__] = ACTIONS(3835),
    [anon_sym_alignas] = ACTIONS(3841),
    [anon_sym__Alignas] = ACTIONS(3841),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [833] = {
    [sym_type_qualifier] = STATE(1846),
    [sym_alignas_qualifier] = STATE(2108),
    [sym_expression] = STATE(5112),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_array_declarator_repeat1] = STATE(1846),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(3933),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(3835),
    [anon_sym___global__] = ACTIONS(3835),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_static] = ACTIONS(3851),
    [anon_sym_RBRACK] = ACTIONS(3935),
    [anon_sym_const] = ACTIONS(3835),
    [anon_sym_constexpr] = ACTIONS(3835),
    [anon_sym_volatile] = ACTIONS(3835),
    [anon_sym_restrict] = ACTIONS(3835),
    [anon_sym___restrict__] = ACTIONS(3835),
    [anon_sym__Atomic] = ACTIONS(3835),
    [anon_sym__Noreturn] = ACTIONS(3835),
    [anon_sym_noreturn] = ACTIONS(3835),
    [anon_sym_mutable] = ACTIONS(3835),
    [anon_sym_constinit] = ACTIONS(3835),
    [anon_sym_consteval] = ACTIONS(3835),
    [anon_sym___shared__] = ACTIONS(3835),
    [anon_sym___local__] = ACTIONS(3835),
    [anon_sym___constant__] = ACTIONS(3835),
    [anon_sym___managed__] = ACTIONS(3835),
    [anon_sym___grid_constant__] = ACTIONS(3835),
    [anon_sym_alignas] = ACTIONS(3841),
    [anon_sym__Alignas] = ACTIONS(3841),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [834] = {
    [sym_type_qualifier] = STATE(831),
    [sym_alignas_qualifier] = STATE(2108),
    [sym_expression] = STATE(5090),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_array_declarator_repeat1] = STATE(831),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(3937),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(3835),
    [anon_sym___global__] = ACTIONS(3835),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_static] = ACTIONS(3939),
    [anon_sym_RBRACK] = ACTIONS(3941),
    [anon_sym_const] = ACTIONS(3835),
    [anon_sym_constexpr] = ACTIONS(3835),
    [anon_sym_volatile] = ACTIONS(3835),
    [anon_sym_restrict] = ACTIONS(3835),
    [anon_sym___restrict__] = ACTIONS(3835),
    [anon_sym__Atomic] = ACTIONS(3835),
    [anon_sym__Noreturn] = ACTIONS(3835),
    [anon_sym_noreturn] = ACTIONS(3835),
    [anon_sym_mutable] = ACTIONS(3835),
    [anon_sym_constinit] = ACTIONS(3835),
    [anon_sym_consteval] = ACTIONS(3835),
    [anon_sym___shared__] = ACTIONS(3835),
    [anon_sym___local__] = ACTIONS(3835),
    [anon_sym___constant__] = ACTIONS(3835),
    [anon_sym___managed__] = ACTIONS(3835),
    [anon_sym___grid_constant__] = ACTIONS(3835),
    [anon_sym_alignas] = ACTIONS(3841),
    [anon_sym__Alignas] = ACTIONS(3841),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [835] = {
    [sym_type_qualifier] = STATE(837),
    [sym_alignas_qualifier] = STATE(2108),
    [sym_expression] = STATE(5014),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_array_declarator_repeat1] = STATE(837),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(3943),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(3835),
    [anon_sym___global__] = ACTIONS(3835),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_static] = ACTIONS(3945),
    [anon_sym_RBRACK] = ACTIONS(3947),
    [anon_sym_const] = ACTIONS(3835),
    [anon_sym_constexpr] = ACTIONS(3835),
    [anon_sym_volatile] = ACTIONS(3835),
    [anon_sym_restrict] = ACTIONS(3835),
    [anon_sym___restrict__] = ACTIONS(3835),
    [anon_sym__Atomic] = ACTIONS(3835),
    [anon_sym__Noreturn] = ACTIONS(3835),
    [anon_sym_noreturn] = ACTIONS(3835),
    [anon_sym_mutable] = ACTIONS(3835),
    [anon_sym_constinit] = ACTIONS(3835),
    [anon_sym_consteval] = ACTIONS(3835),
    [anon_sym___shared__] = ACTIONS(3835),
    [anon_sym___local__] = ACTIONS(3835),
    [anon_sym___constant__] = ACTIONS(3835),
    [anon_sym___managed__] = ACTIONS(3835),
    [anon_sym___grid_constant__] = ACTIONS(3835),
    [anon_sym_alignas] = ACTIONS(3841),
    [anon_sym__Alignas] = ACTIONS(3841),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [836] = {
    [sym_else_clause] = STATE(849),
    [sym_identifier] = ACTIONS(1934),
    [anon_sym_LPAREN2] = ACTIONS(1936),
    [anon_sym_BANG] = ACTIONS(1936),
    [anon_sym_TILDE] = ACTIONS(1936),
    [anon_sym_DASH] = ACTIONS(1934),
    [anon_sym_PLUS] = ACTIONS(1934),
    [anon_sym_STAR] = ACTIONS(1936),
    [anon_sym_AMP] = ACTIONS(1936),
    [anon_sym_SEMI] = ACTIONS(1936),
    [anon_sym___extension__] = ACTIONS(1934),
    [anon_sym_typedef] = ACTIONS(1934),
    [anon_sym___device__] = ACTIONS(1934),
    [anon_sym___host__] = ACTIONS(1934),
    [anon_sym___global__] = ACTIONS(1934),
    [anon_sym___forceinline__] = ACTIONS(1934),
    [anon_sym___noinline__] = ACTIONS(1934),
    [anon_sym_extern] = ACTIONS(1934),
    [anon_sym___attribute__] = ACTIONS(1934),
    [anon_sym_COLON_COLON] = ACTIONS(1936),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1936),
    [anon_sym___declspec] = ACTIONS(1934),
    [anon_sym_LBRACE] = ACTIONS(1936),
    [anon_sym_signed] = ACTIONS(1934),
    [anon_sym_unsigned] = ACTIONS(1934),
    [anon_sym_long] = ACTIONS(1934),
    [anon_sym_short] = ACTIONS(1934),
    [anon_sym_LBRACK] = ACTIONS(1934),
    [anon_sym_static] = ACTIONS(1934),
    [anon_sym_register] = ACTIONS(1934),
    [anon_sym_inline] = ACTIONS(1934),
    [anon_sym___inline] = ACTIONS(1934),
    [anon_sym___inline__] = ACTIONS(1934),
    [anon_sym___forceinline] = ACTIONS(1934),
    [anon_sym_thread_local] = ACTIONS(1934),
    [anon_sym___thread] = ACTIONS(1934),
    [anon_sym_const] = ACTIONS(1934),
    [anon_sym_constexpr] = ACTIONS(1934),
    [anon_sym_volatile] = ACTIONS(1934),
    [anon_sym_restrict] = ACTIONS(1934),
    [anon_sym___restrict__] = ACTIONS(1934),
    [anon_sym__Atomic] = ACTIONS(1934),
    [anon_sym__Noreturn] = ACTIONS(1934),
    [anon_sym_noreturn] = ACTIONS(1934),
    [anon_sym_mutable] = ACTIONS(1934),
    [anon_sym_constinit] = ACTIONS(1934),
    [anon_sym_consteval] = ACTIONS(1934),
    [anon_sym___shared__] = ACTIONS(1934),
    [anon_sym___local__] = ACTIONS(1934),
    [anon_sym___constant__] = ACTIONS(1934),
    [anon_sym___managed__] = ACTIONS(1934),
    [anon_sym___grid_constant__] = ACTIONS(1934),
    [anon_sym_alignas] = ACTIONS(1934),
    [anon_sym__Alignas] = ACTIONS(1934),
    [sym_primitive_type] = ACTIONS(1934),
    [anon_sym_enum] = ACTIONS(1934),
    [anon_sym_class] = ACTIONS(1934),
    [anon_sym_struct] = ACTIONS(1934),
    [anon_sym_union] = ACTIONS(1934),
    [anon_sym_if] = ACTIONS(1934),
    [anon_sym_else] = ACTIONS(3891),
    [anon_sym_switch] = ACTIONS(1934),
    [anon_sym_while] = ACTIONS(1934),
    [anon_sym_do] = ACTIONS(1934),
    [anon_sym_for] = ACTIONS(1934),
    [anon_sym_return] = ACTIONS(1934),
    [anon_sym_break] = ACTIONS(1934),
    [anon_sym_continue] = ACTIONS(1934),
    [anon_sym_goto] = ACTIONS(1934),
    [anon_sym___try] = ACTIONS(1934),
    [anon_sym___leave] = ACTIONS(1934),
    [anon_sym_not] = ACTIONS(1934),
    [anon_sym_compl] = ACTIONS(1934),
    [anon_sym_DASH_DASH] = ACTIONS(1936),
    [anon_sym_PLUS_PLUS] = ACTIONS(1936),
    [anon_sym_sizeof] = ACTIONS(1934),
    [anon_sym___alignof__] = ACTIONS(1934),
    [anon_sym___alignof] = ACTIONS(1934),
    [anon_sym__alignof] = ACTIONS(1934),
    [anon_sym_alignof] = ACTIONS(1934),
    [anon_sym__Alignof] = ACTIONS(1934),
    [anon_sym_offsetof] = ACTIONS(1934),
    [anon_sym__Generic] = ACTIONS(1934),
    [anon_sym_asm] = ACTIONS(1934),
    [anon_sym___asm__] = ACTIONS(1934),
    [sym_number_literal] = ACTIONS(1936),
    [anon_sym_L_SQUOTE] = ACTIONS(1936),
    [anon_sym_u_SQUOTE] = ACTIONS(1936),
    [anon_sym_U_SQUOTE] = ACTIONS(1936),
    [anon_sym_u8_SQUOTE] = ACTIONS(1936),
    [anon_sym_SQUOTE] = ACTIONS(1936),
    [anon_sym_L_DQUOTE] = ACTIONS(1936),
    [anon_sym_u_DQUOTE] = ACTIONS(1936),
    [anon_sym_U_DQUOTE] = ACTIONS(1936),
    [anon_sym_u8_DQUOTE] = ACTIONS(1936),
    [anon_sym_DQUOTE] = ACTIONS(1936),
    [sym_true] = ACTIONS(1934),
    [sym_false] = ACTIONS(1934),
    [anon_sym_NULL] = ACTIONS(1934),
    [anon_sym_nullptr] = ACTIONS(1934),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1934),
    [anon_sym_decltype] = ACTIONS(1934),
    [sym_virtual] = ACTIONS(1934),
    [anon_sym_typename] = ACTIONS(1934),
    [anon_sym_template] = ACTIONS(1934),
    [anon_sym_try] = ACTIONS(1934),
    [anon_sym_delete] = ACTIONS(1934),
    [anon_sym_throw] = ACTIONS(1934),
    [anon_sym_co_return] = ACTIONS(1934),
    [anon_sym_co_yield] = ACTIONS(1934),
    [anon_sym_R_DQUOTE] = ACTIONS(1936),
    [anon_sym_LR_DQUOTE] = ACTIONS(1936),
    [anon_sym_uR_DQUOTE] = ACTIONS(1936),
    [anon_sym_UR_DQUOTE] = ACTIONS(1936),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1936),
    [anon_sym_co_await] = ACTIONS(1934),
    [anon_sym_new] = ACTIONS(1934),
    [anon_sym_requires] = ACTIONS(1934),
    [sym_this] = ACTIONS(1934),
    [anon_sym___launch_bounds__] = ACTIONS(1934),
  },
  [837] = {
    [sym_type_qualifier] = STATE(1846),
    [sym_alignas_qualifier] = STATE(2108),
    [sym_expression] = STATE(5111),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_array_declarator_repeat1] = STATE(1846),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(3949),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(3835),
    [anon_sym___global__] = ACTIONS(3835),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_static] = ACTIONS(3851),
    [anon_sym_RBRACK] = ACTIONS(3951),
    [anon_sym_const] = ACTIONS(3835),
    [anon_sym_constexpr] = ACTIONS(3835),
    [anon_sym_volatile] = ACTIONS(3835),
    [anon_sym_restrict] = ACTIONS(3835),
    [anon_sym___restrict__] = ACTIONS(3835),
    [anon_sym__Atomic] = ACTIONS(3835),
    [anon_sym__Noreturn] = ACTIONS(3835),
    [anon_sym_noreturn] = ACTIONS(3835),
    [anon_sym_mutable] = ACTIONS(3835),
    [anon_sym_constinit] = ACTIONS(3835),
    [anon_sym_consteval] = ACTIONS(3835),
    [anon_sym___shared__] = ACTIONS(3835),
    [anon_sym___local__] = ACTIONS(3835),
    [anon_sym___constant__] = ACTIONS(3835),
    [anon_sym___managed__] = ACTIONS(3835),
    [anon_sym___grid_constant__] = ACTIONS(3835),
    [anon_sym_alignas] = ACTIONS(3841),
    [anon_sym__Alignas] = ACTIONS(3841),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [838] = {
    [sym_identifier] = ACTIONS(2012),
    [anon_sym_LPAREN2] = ACTIONS(2014),
    [anon_sym_BANG] = ACTIONS(2014),
    [anon_sym_TILDE] = ACTIONS(2014),
    [anon_sym_DASH] = ACTIONS(2012),
    [anon_sym_PLUS] = ACTIONS(2012),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_AMP] = ACTIONS(2014),
    [anon_sym_SEMI] = ACTIONS(2014),
    [anon_sym___extension__] = ACTIONS(2012),
    [anon_sym_typedef] = ACTIONS(2012),
    [anon_sym___device__] = ACTIONS(2012),
    [anon_sym___host__] = ACTIONS(2012),
    [anon_sym___global__] = ACTIONS(2012),
    [anon_sym___forceinline__] = ACTIONS(2012),
    [anon_sym___noinline__] = ACTIONS(2012),
    [anon_sym_extern] = ACTIONS(2012),
    [anon_sym___attribute__] = ACTIONS(2012),
    [anon_sym_COLON_COLON] = ACTIONS(2014),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2014),
    [anon_sym___declspec] = ACTIONS(2012),
    [anon_sym_LBRACE] = ACTIONS(2014),
    [anon_sym_signed] = ACTIONS(2012),
    [anon_sym_unsigned] = ACTIONS(2012),
    [anon_sym_long] = ACTIONS(2012),
    [anon_sym_short] = ACTIONS(2012),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_static] = ACTIONS(2012),
    [anon_sym_register] = ACTIONS(2012),
    [anon_sym_inline] = ACTIONS(2012),
    [anon_sym___inline] = ACTIONS(2012),
    [anon_sym___inline__] = ACTIONS(2012),
    [anon_sym___forceinline] = ACTIONS(2012),
    [anon_sym_thread_local] = ACTIONS(2012),
    [anon_sym___thread] = ACTIONS(2012),
    [anon_sym_const] = ACTIONS(2012),
    [anon_sym_constexpr] = ACTIONS(2012),
    [anon_sym_volatile] = ACTIONS(2012),
    [anon_sym_restrict] = ACTIONS(2012),
    [anon_sym___restrict__] = ACTIONS(2012),
    [anon_sym__Atomic] = ACTIONS(2012),
    [anon_sym__Noreturn] = ACTIONS(2012),
    [anon_sym_noreturn] = ACTIONS(2012),
    [anon_sym_mutable] = ACTIONS(2012),
    [anon_sym_constinit] = ACTIONS(2012),
    [anon_sym_consteval] = ACTIONS(2012),
    [anon_sym___shared__] = ACTIONS(2012),
    [anon_sym___local__] = ACTIONS(2012),
    [anon_sym___constant__] = ACTIONS(2012),
    [anon_sym___managed__] = ACTIONS(2012),
    [anon_sym___grid_constant__] = ACTIONS(2012),
    [anon_sym_alignas] = ACTIONS(2012),
    [anon_sym__Alignas] = ACTIONS(2012),
    [sym_primitive_type] = ACTIONS(2012),
    [anon_sym_enum] = ACTIONS(2012),
    [anon_sym_class] = ACTIONS(2012),
    [anon_sym_struct] = ACTIONS(2012),
    [anon_sym_union] = ACTIONS(2012),
    [anon_sym_if] = ACTIONS(2012),
    [anon_sym_else] = ACTIONS(2012),
    [anon_sym_switch] = ACTIONS(2012),
    [anon_sym_while] = ACTIONS(2012),
    [anon_sym_do] = ACTIONS(2012),
    [anon_sym_for] = ACTIONS(2012),
    [anon_sym_return] = ACTIONS(2012),
    [anon_sym_break] = ACTIONS(2012),
    [anon_sym_continue] = ACTIONS(2012),
    [anon_sym_goto] = ACTIONS(2012),
    [anon_sym___try] = ACTIONS(2012),
    [anon_sym___leave] = ACTIONS(2012),
    [anon_sym_not] = ACTIONS(2012),
    [anon_sym_compl] = ACTIONS(2012),
    [anon_sym_DASH_DASH] = ACTIONS(2014),
    [anon_sym_PLUS_PLUS] = ACTIONS(2014),
    [anon_sym_sizeof] = ACTIONS(2012),
    [anon_sym___alignof__] = ACTIONS(2012),
    [anon_sym___alignof] = ACTIONS(2012),
    [anon_sym__alignof] = ACTIONS(2012),
    [anon_sym_alignof] = ACTIONS(2012),
    [anon_sym__Alignof] = ACTIONS(2012),
    [anon_sym_offsetof] = ACTIONS(2012),
    [anon_sym__Generic] = ACTIONS(2012),
    [anon_sym_asm] = ACTIONS(2012),
    [anon_sym___asm__] = ACTIONS(2012),
    [sym_number_literal] = ACTIONS(2014),
    [anon_sym_L_SQUOTE] = ACTIONS(2014),
    [anon_sym_u_SQUOTE] = ACTIONS(2014),
    [anon_sym_U_SQUOTE] = ACTIONS(2014),
    [anon_sym_u8_SQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2014),
    [anon_sym_L_DQUOTE] = ACTIONS(2014),
    [anon_sym_u_DQUOTE] = ACTIONS(2014),
    [anon_sym_U_DQUOTE] = ACTIONS(2014),
    [anon_sym_u8_DQUOTE] = ACTIONS(2014),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [sym_true] = ACTIONS(2012),
    [sym_false] = ACTIONS(2012),
    [anon_sym_NULL] = ACTIONS(2012),
    [anon_sym_nullptr] = ACTIONS(2012),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2012),
    [anon_sym_decltype] = ACTIONS(2012),
    [sym_virtual] = ACTIONS(2012),
    [anon_sym_typename] = ACTIONS(2012),
    [anon_sym_template] = ACTIONS(2012),
    [anon_sym_try] = ACTIONS(2012),
    [anon_sym_delete] = ACTIONS(2012),
    [anon_sym_throw] = ACTIONS(2012),
    [anon_sym_co_return] = ACTIONS(2012),
    [anon_sym_co_yield] = ACTIONS(2012),
    [anon_sym_R_DQUOTE] = ACTIONS(2014),
    [anon_sym_LR_DQUOTE] = ACTIONS(2014),
    [anon_sym_uR_DQUOTE] = ACTIONS(2014),
    [anon_sym_UR_DQUOTE] = ACTIONS(2014),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2014),
    [anon_sym_co_await] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2012),
    [anon_sym_requires] = ACTIONS(2012),
    [sym_this] = ACTIONS(2012),
    [anon_sym___launch_bounds__] = ACTIONS(2012),
  },
  [839] = {
    [sym_identifier] = ACTIONS(1938),
    [anon_sym_LPAREN2] = ACTIONS(1940),
    [anon_sym_BANG] = ACTIONS(1940),
    [anon_sym_TILDE] = ACTIONS(1940),
    [anon_sym_DASH] = ACTIONS(1938),
    [anon_sym_PLUS] = ACTIONS(1938),
    [anon_sym_STAR] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_SEMI] = ACTIONS(1940),
    [anon_sym___extension__] = ACTIONS(1938),
    [anon_sym_typedef] = ACTIONS(1938),
    [anon_sym___device__] = ACTIONS(1938),
    [anon_sym___host__] = ACTIONS(1938),
    [anon_sym___global__] = ACTIONS(1938),
    [anon_sym___forceinline__] = ACTIONS(1938),
    [anon_sym___noinline__] = ACTIONS(1938),
    [anon_sym_extern] = ACTIONS(1938),
    [anon_sym___attribute__] = ACTIONS(1938),
    [anon_sym_COLON_COLON] = ACTIONS(1940),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1940),
    [anon_sym___declspec] = ACTIONS(1938),
    [anon_sym_LBRACE] = ACTIONS(1940),
    [anon_sym_signed] = ACTIONS(1938),
    [anon_sym_unsigned] = ACTIONS(1938),
    [anon_sym_long] = ACTIONS(1938),
    [anon_sym_short] = ACTIONS(1938),
    [anon_sym_LBRACK] = ACTIONS(1938),
    [anon_sym_static] = ACTIONS(1938),
    [anon_sym_register] = ACTIONS(1938),
    [anon_sym_inline] = ACTIONS(1938),
    [anon_sym___inline] = ACTIONS(1938),
    [anon_sym___inline__] = ACTIONS(1938),
    [anon_sym___forceinline] = ACTIONS(1938),
    [anon_sym_thread_local] = ACTIONS(1938),
    [anon_sym___thread] = ACTIONS(1938),
    [anon_sym_const] = ACTIONS(1938),
    [anon_sym_constexpr] = ACTIONS(1938),
    [anon_sym_volatile] = ACTIONS(1938),
    [anon_sym_restrict] = ACTIONS(1938),
    [anon_sym___restrict__] = ACTIONS(1938),
    [anon_sym__Atomic] = ACTIONS(1938),
    [anon_sym__Noreturn] = ACTIONS(1938),
    [anon_sym_noreturn] = ACTIONS(1938),
    [anon_sym_mutable] = ACTIONS(1938),
    [anon_sym_constinit] = ACTIONS(1938),
    [anon_sym_consteval] = ACTIONS(1938),
    [anon_sym___shared__] = ACTIONS(1938),
    [anon_sym___local__] = ACTIONS(1938),
    [anon_sym___constant__] = ACTIONS(1938),
    [anon_sym___managed__] = ACTIONS(1938),
    [anon_sym___grid_constant__] = ACTIONS(1938),
    [anon_sym_alignas] = ACTIONS(1938),
    [anon_sym__Alignas] = ACTIONS(1938),
    [sym_primitive_type] = ACTIONS(1938),
    [anon_sym_enum] = ACTIONS(1938),
    [anon_sym_class] = ACTIONS(1938),
    [anon_sym_struct] = ACTIONS(1938),
    [anon_sym_union] = ACTIONS(1938),
    [anon_sym_if] = ACTIONS(1938),
    [anon_sym_else] = ACTIONS(1938),
    [anon_sym_switch] = ACTIONS(1938),
    [anon_sym_while] = ACTIONS(1938),
    [anon_sym_do] = ACTIONS(1938),
    [anon_sym_for] = ACTIONS(1938),
    [anon_sym_return] = ACTIONS(1938),
    [anon_sym_break] = ACTIONS(1938),
    [anon_sym_continue] = ACTIONS(1938),
    [anon_sym_goto] = ACTIONS(1938),
    [anon_sym___try] = ACTIONS(1938),
    [anon_sym___leave] = ACTIONS(1938),
    [anon_sym_not] = ACTIONS(1938),
    [anon_sym_compl] = ACTIONS(1938),
    [anon_sym_DASH_DASH] = ACTIONS(1940),
    [anon_sym_PLUS_PLUS] = ACTIONS(1940),
    [anon_sym_sizeof] = ACTIONS(1938),
    [anon_sym___alignof__] = ACTIONS(1938),
    [anon_sym___alignof] = ACTIONS(1938),
    [anon_sym__alignof] = ACTIONS(1938),
    [anon_sym_alignof] = ACTIONS(1938),
    [anon_sym__Alignof] = ACTIONS(1938),
    [anon_sym_offsetof] = ACTIONS(1938),
    [anon_sym__Generic] = ACTIONS(1938),
    [anon_sym_asm] = ACTIONS(1938),
    [anon_sym___asm__] = ACTIONS(1938),
    [sym_number_literal] = ACTIONS(1940),
    [anon_sym_L_SQUOTE] = ACTIONS(1940),
    [anon_sym_u_SQUOTE] = ACTIONS(1940),
    [anon_sym_U_SQUOTE] = ACTIONS(1940),
    [anon_sym_u8_SQUOTE] = ACTIONS(1940),
    [anon_sym_SQUOTE] = ACTIONS(1940),
    [anon_sym_L_DQUOTE] = ACTIONS(1940),
    [anon_sym_u_DQUOTE] = ACTIONS(1940),
    [anon_sym_U_DQUOTE] = ACTIONS(1940),
    [anon_sym_u8_DQUOTE] = ACTIONS(1940),
    [anon_sym_DQUOTE] = ACTIONS(1940),
    [sym_true] = ACTIONS(1938),
    [sym_false] = ACTIONS(1938),
    [anon_sym_NULL] = ACTIONS(1938),
    [anon_sym_nullptr] = ACTIONS(1938),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1938),
    [anon_sym_decltype] = ACTIONS(1938),
    [sym_virtual] = ACTIONS(1938),
    [anon_sym_typename] = ACTIONS(1938),
    [anon_sym_template] = ACTIONS(1938),
    [anon_sym_try] = ACTIONS(1938),
    [anon_sym_delete] = ACTIONS(1938),
    [anon_sym_throw] = ACTIONS(1938),
    [anon_sym_co_return] = ACTIONS(1938),
    [anon_sym_co_yield] = ACTIONS(1938),
    [anon_sym_R_DQUOTE] = ACTIONS(1940),
    [anon_sym_LR_DQUOTE] = ACTIONS(1940),
    [anon_sym_uR_DQUOTE] = ACTIONS(1940),
    [anon_sym_UR_DQUOTE] = ACTIONS(1940),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1940),
    [anon_sym_co_await] = ACTIONS(1938),
    [anon_sym_new] = ACTIONS(1938),
    [anon_sym_requires] = ACTIONS(1938),
    [sym_this] = ACTIONS(1938),
    [anon_sym___launch_bounds__] = ACTIONS(1938),
  },
  [840] = {
    [sym_identifier] = ACTIONS(1980),
    [anon_sym_LPAREN2] = ACTIONS(1982),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_AMP] = ACTIONS(1982),
    [anon_sym_SEMI] = ACTIONS(1982),
    [anon_sym___extension__] = ACTIONS(1980),
    [anon_sym_typedef] = ACTIONS(1980),
    [anon_sym___device__] = ACTIONS(1980),
    [anon_sym___host__] = ACTIONS(1980),
    [anon_sym___global__] = ACTIONS(1980),
    [anon_sym___forceinline__] = ACTIONS(1980),
    [anon_sym___noinline__] = ACTIONS(1980),
    [anon_sym_extern] = ACTIONS(1980),
    [anon_sym___attribute__] = ACTIONS(1980),
    [anon_sym_COLON_COLON] = ACTIONS(1982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1982),
    [anon_sym___declspec] = ACTIONS(1980),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_signed] = ACTIONS(1980),
    [anon_sym_unsigned] = ACTIONS(1980),
    [anon_sym_long] = ACTIONS(1980),
    [anon_sym_short] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_static] = ACTIONS(1980),
    [anon_sym_register] = ACTIONS(1980),
    [anon_sym_inline] = ACTIONS(1980),
    [anon_sym___inline] = ACTIONS(1980),
    [anon_sym___inline__] = ACTIONS(1980),
    [anon_sym___forceinline] = ACTIONS(1980),
    [anon_sym_thread_local] = ACTIONS(1980),
    [anon_sym___thread] = ACTIONS(1980),
    [anon_sym_const] = ACTIONS(1980),
    [anon_sym_constexpr] = ACTIONS(1980),
    [anon_sym_volatile] = ACTIONS(1980),
    [anon_sym_restrict] = ACTIONS(1980),
    [anon_sym___restrict__] = ACTIONS(1980),
    [anon_sym__Atomic] = ACTIONS(1980),
    [anon_sym__Noreturn] = ACTIONS(1980),
    [anon_sym_noreturn] = ACTIONS(1980),
    [anon_sym_mutable] = ACTIONS(1980),
    [anon_sym_constinit] = ACTIONS(1980),
    [anon_sym_consteval] = ACTIONS(1980),
    [anon_sym___shared__] = ACTIONS(1980),
    [anon_sym___local__] = ACTIONS(1980),
    [anon_sym___constant__] = ACTIONS(1980),
    [anon_sym___managed__] = ACTIONS(1980),
    [anon_sym___grid_constant__] = ACTIONS(1980),
    [anon_sym_alignas] = ACTIONS(1980),
    [anon_sym__Alignas] = ACTIONS(1980),
    [sym_primitive_type] = ACTIONS(1980),
    [anon_sym_enum] = ACTIONS(1980),
    [anon_sym_class] = ACTIONS(1980),
    [anon_sym_struct] = ACTIONS(1980),
    [anon_sym_union] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_else] = ACTIONS(1980),
    [anon_sym_switch] = ACTIONS(1980),
    [anon_sym_while] = ACTIONS(1980),
    [anon_sym_do] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_return] = ACTIONS(1980),
    [anon_sym_break] = ACTIONS(1980),
    [anon_sym_continue] = ACTIONS(1980),
    [anon_sym_goto] = ACTIONS(1980),
    [anon_sym___try] = ACTIONS(1980),
    [anon_sym___leave] = ACTIONS(1980),
    [anon_sym_not] = ACTIONS(1980),
    [anon_sym_compl] = ACTIONS(1980),
    [anon_sym_DASH_DASH] = ACTIONS(1982),
    [anon_sym_PLUS_PLUS] = ACTIONS(1982),
    [anon_sym_sizeof] = ACTIONS(1980),
    [anon_sym___alignof__] = ACTIONS(1980),
    [anon_sym___alignof] = ACTIONS(1980),
    [anon_sym__alignof] = ACTIONS(1980),
    [anon_sym_alignof] = ACTIONS(1980),
    [anon_sym__Alignof] = ACTIONS(1980),
    [anon_sym_offsetof] = ACTIONS(1980),
    [anon_sym__Generic] = ACTIONS(1980),
    [anon_sym_asm] = ACTIONS(1980),
    [anon_sym___asm__] = ACTIONS(1980),
    [sym_number_literal] = ACTIONS(1982),
    [anon_sym_L_SQUOTE] = ACTIONS(1982),
    [anon_sym_u_SQUOTE] = ACTIONS(1982),
    [anon_sym_U_SQUOTE] = ACTIONS(1982),
    [anon_sym_u8_SQUOTE] = ACTIONS(1982),
    [anon_sym_SQUOTE] = ACTIONS(1982),
    [anon_sym_L_DQUOTE] = ACTIONS(1982),
    [anon_sym_u_DQUOTE] = ACTIONS(1982),
    [anon_sym_U_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8_DQUOTE] = ACTIONS(1982),
    [anon_sym_DQUOTE] = ACTIONS(1982),
    [sym_true] = ACTIONS(1980),
    [sym_false] = ACTIONS(1980),
    [anon_sym_NULL] = ACTIONS(1980),
    [anon_sym_nullptr] = ACTIONS(1980),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1980),
    [anon_sym_decltype] = ACTIONS(1980),
    [sym_virtual] = ACTIONS(1980),
    [anon_sym_typename] = ACTIONS(1980),
    [anon_sym_template] = ACTIONS(1980),
    [anon_sym_try] = ACTIONS(1980),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_throw] = ACTIONS(1980),
    [anon_sym_co_return] = ACTIONS(1980),
    [anon_sym_co_yield] = ACTIONS(1980),
    [anon_sym_R_DQUOTE] = ACTIONS(1982),
    [anon_sym_LR_DQUOTE] = ACTIONS(1982),
    [anon_sym_uR_DQUOTE] = ACTIONS(1982),
    [anon_sym_UR_DQUOTE] = ACTIONS(1982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1982),
    [anon_sym_co_await] = ACTIONS(1980),
    [anon_sym_new] = ACTIONS(1980),
    [anon_sym_requires] = ACTIONS(1980),
    [sym_this] = ACTIONS(1980),
    [anon_sym___launch_bounds__] = ACTIONS(1980),
  },
  [841] = {
    [sym_identifier] = ACTIONS(1976),
    [anon_sym_LPAREN2] = ACTIONS(1978),
    [anon_sym_BANG] = ACTIONS(1978),
    [anon_sym_TILDE] = ACTIONS(1978),
    [anon_sym_DASH] = ACTIONS(1976),
    [anon_sym_PLUS] = ACTIONS(1976),
    [anon_sym_STAR] = ACTIONS(1978),
    [anon_sym_AMP] = ACTIONS(1978),
    [anon_sym_SEMI] = ACTIONS(1978),
    [anon_sym___extension__] = ACTIONS(1976),
    [anon_sym_typedef] = ACTIONS(1976),
    [anon_sym___device__] = ACTIONS(1976),
    [anon_sym___host__] = ACTIONS(1976),
    [anon_sym___global__] = ACTIONS(1976),
    [anon_sym___forceinline__] = ACTIONS(1976),
    [anon_sym___noinline__] = ACTIONS(1976),
    [anon_sym_extern] = ACTIONS(1976),
    [anon_sym___attribute__] = ACTIONS(1976),
    [anon_sym_COLON_COLON] = ACTIONS(1978),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1978),
    [anon_sym___declspec] = ACTIONS(1976),
    [anon_sym_LBRACE] = ACTIONS(1978),
    [anon_sym_signed] = ACTIONS(1976),
    [anon_sym_unsigned] = ACTIONS(1976),
    [anon_sym_long] = ACTIONS(1976),
    [anon_sym_short] = ACTIONS(1976),
    [anon_sym_LBRACK] = ACTIONS(1976),
    [anon_sym_static] = ACTIONS(1976),
    [anon_sym_register] = ACTIONS(1976),
    [anon_sym_inline] = ACTIONS(1976),
    [anon_sym___inline] = ACTIONS(1976),
    [anon_sym___inline__] = ACTIONS(1976),
    [anon_sym___forceinline] = ACTIONS(1976),
    [anon_sym_thread_local] = ACTIONS(1976),
    [anon_sym___thread] = ACTIONS(1976),
    [anon_sym_const] = ACTIONS(1976),
    [anon_sym_constexpr] = ACTIONS(1976),
    [anon_sym_volatile] = ACTIONS(1976),
    [anon_sym_restrict] = ACTIONS(1976),
    [anon_sym___restrict__] = ACTIONS(1976),
    [anon_sym__Atomic] = ACTIONS(1976),
    [anon_sym__Noreturn] = ACTIONS(1976),
    [anon_sym_noreturn] = ACTIONS(1976),
    [anon_sym_mutable] = ACTIONS(1976),
    [anon_sym_constinit] = ACTIONS(1976),
    [anon_sym_consteval] = ACTIONS(1976),
    [anon_sym___shared__] = ACTIONS(1976),
    [anon_sym___local__] = ACTIONS(1976),
    [anon_sym___constant__] = ACTIONS(1976),
    [anon_sym___managed__] = ACTIONS(1976),
    [anon_sym___grid_constant__] = ACTIONS(1976),
    [anon_sym_alignas] = ACTIONS(1976),
    [anon_sym__Alignas] = ACTIONS(1976),
    [sym_primitive_type] = ACTIONS(1976),
    [anon_sym_enum] = ACTIONS(1976),
    [anon_sym_class] = ACTIONS(1976),
    [anon_sym_struct] = ACTIONS(1976),
    [anon_sym_union] = ACTIONS(1976),
    [anon_sym_if] = ACTIONS(1976),
    [anon_sym_else] = ACTIONS(1976),
    [anon_sym_switch] = ACTIONS(1976),
    [anon_sym_while] = ACTIONS(1976),
    [anon_sym_do] = ACTIONS(1976),
    [anon_sym_for] = ACTIONS(1976),
    [anon_sym_return] = ACTIONS(1976),
    [anon_sym_break] = ACTIONS(1976),
    [anon_sym_continue] = ACTIONS(1976),
    [anon_sym_goto] = ACTIONS(1976),
    [anon_sym___try] = ACTIONS(1976),
    [anon_sym___leave] = ACTIONS(1976),
    [anon_sym_not] = ACTIONS(1976),
    [anon_sym_compl] = ACTIONS(1976),
    [anon_sym_DASH_DASH] = ACTIONS(1978),
    [anon_sym_PLUS_PLUS] = ACTIONS(1978),
    [anon_sym_sizeof] = ACTIONS(1976),
    [anon_sym___alignof__] = ACTIONS(1976),
    [anon_sym___alignof] = ACTIONS(1976),
    [anon_sym__alignof] = ACTIONS(1976),
    [anon_sym_alignof] = ACTIONS(1976),
    [anon_sym__Alignof] = ACTIONS(1976),
    [anon_sym_offsetof] = ACTIONS(1976),
    [anon_sym__Generic] = ACTIONS(1976),
    [anon_sym_asm] = ACTIONS(1976),
    [anon_sym___asm__] = ACTIONS(1976),
    [sym_number_literal] = ACTIONS(1978),
    [anon_sym_L_SQUOTE] = ACTIONS(1978),
    [anon_sym_u_SQUOTE] = ACTIONS(1978),
    [anon_sym_U_SQUOTE] = ACTIONS(1978),
    [anon_sym_u8_SQUOTE] = ACTIONS(1978),
    [anon_sym_SQUOTE] = ACTIONS(1978),
    [anon_sym_L_DQUOTE] = ACTIONS(1978),
    [anon_sym_u_DQUOTE] = ACTIONS(1978),
    [anon_sym_U_DQUOTE] = ACTIONS(1978),
    [anon_sym_u8_DQUOTE] = ACTIONS(1978),
    [anon_sym_DQUOTE] = ACTIONS(1978),
    [sym_true] = ACTIONS(1976),
    [sym_false] = ACTIONS(1976),
    [anon_sym_NULL] = ACTIONS(1976),
    [anon_sym_nullptr] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1976),
    [anon_sym_decltype] = ACTIONS(1976),
    [sym_virtual] = ACTIONS(1976),
    [anon_sym_typename] = ACTIONS(1976),
    [anon_sym_template] = ACTIONS(1976),
    [anon_sym_try] = ACTIONS(1976),
    [anon_sym_delete] = ACTIONS(1976),
    [anon_sym_throw] = ACTIONS(1976),
    [anon_sym_co_return] = ACTIONS(1976),
    [anon_sym_co_yield] = ACTIONS(1976),
    [anon_sym_R_DQUOTE] = ACTIONS(1978),
    [anon_sym_LR_DQUOTE] = ACTIONS(1978),
    [anon_sym_uR_DQUOTE] = ACTIONS(1978),
    [anon_sym_UR_DQUOTE] = ACTIONS(1978),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1978),
    [anon_sym_co_await] = ACTIONS(1976),
    [anon_sym_new] = ACTIONS(1976),
    [anon_sym_requires] = ACTIONS(1976),
    [sym_this] = ACTIONS(1976),
    [anon_sym___launch_bounds__] = ACTIONS(1976),
  },
  [842] = {
    [sym_identifier] = ACTIONS(1958),
    [anon_sym_LPAREN2] = ACTIONS(1960),
    [anon_sym_BANG] = ACTIONS(1960),
    [anon_sym_TILDE] = ACTIONS(1960),
    [anon_sym_DASH] = ACTIONS(1958),
    [anon_sym_PLUS] = ACTIONS(1958),
    [anon_sym_STAR] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_SEMI] = ACTIONS(1960),
    [anon_sym___extension__] = ACTIONS(1958),
    [anon_sym_typedef] = ACTIONS(1958),
    [anon_sym___device__] = ACTIONS(1958),
    [anon_sym___host__] = ACTIONS(1958),
    [anon_sym___global__] = ACTIONS(1958),
    [anon_sym___forceinline__] = ACTIONS(1958),
    [anon_sym___noinline__] = ACTIONS(1958),
    [anon_sym_extern] = ACTIONS(1958),
    [anon_sym___attribute__] = ACTIONS(1958),
    [anon_sym_COLON_COLON] = ACTIONS(1960),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1960),
    [anon_sym___declspec] = ACTIONS(1958),
    [anon_sym_LBRACE] = ACTIONS(1960),
    [anon_sym_signed] = ACTIONS(1958),
    [anon_sym_unsigned] = ACTIONS(1958),
    [anon_sym_long] = ACTIONS(1958),
    [anon_sym_short] = ACTIONS(1958),
    [anon_sym_LBRACK] = ACTIONS(1958),
    [anon_sym_static] = ACTIONS(1958),
    [anon_sym_register] = ACTIONS(1958),
    [anon_sym_inline] = ACTIONS(1958),
    [anon_sym___inline] = ACTIONS(1958),
    [anon_sym___inline__] = ACTIONS(1958),
    [anon_sym___forceinline] = ACTIONS(1958),
    [anon_sym_thread_local] = ACTIONS(1958),
    [anon_sym___thread] = ACTIONS(1958),
    [anon_sym_const] = ACTIONS(1958),
    [anon_sym_constexpr] = ACTIONS(1958),
    [anon_sym_volatile] = ACTIONS(1958),
    [anon_sym_restrict] = ACTIONS(1958),
    [anon_sym___restrict__] = ACTIONS(1958),
    [anon_sym__Atomic] = ACTIONS(1958),
    [anon_sym__Noreturn] = ACTIONS(1958),
    [anon_sym_noreturn] = ACTIONS(1958),
    [anon_sym_mutable] = ACTIONS(1958),
    [anon_sym_constinit] = ACTIONS(1958),
    [anon_sym_consteval] = ACTIONS(1958),
    [anon_sym___shared__] = ACTIONS(1958),
    [anon_sym___local__] = ACTIONS(1958),
    [anon_sym___constant__] = ACTIONS(1958),
    [anon_sym___managed__] = ACTIONS(1958),
    [anon_sym___grid_constant__] = ACTIONS(1958),
    [anon_sym_alignas] = ACTIONS(1958),
    [anon_sym__Alignas] = ACTIONS(1958),
    [sym_primitive_type] = ACTIONS(1958),
    [anon_sym_enum] = ACTIONS(1958),
    [anon_sym_class] = ACTIONS(1958),
    [anon_sym_struct] = ACTIONS(1958),
    [anon_sym_union] = ACTIONS(1958),
    [anon_sym_if] = ACTIONS(1958),
    [anon_sym_else] = ACTIONS(1958),
    [anon_sym_switch] = ACTIONS(1958),
    [anon_sym_while] = ACTIONS(1958),
    [anon_sym_do] = ACTIONS(1958),
    [anon_sym_for] = ACTIONS(1958),
    [anon_sym_return] = ACTIONS(1958),
    [anon_sym_break] = ACTIONS(1958),
    [anon_sym_continue] = ACTIONS(1958),
    [anon_sym_goto] = ACTIONS(1958),
    [anon_sym___try] = ACTIONS(1958),
    [anon_sym___leave] = ACTIONS(1958),
    [anon_sym_not] = ACTIONS(1958),
    [anon_sym_compl] = ACTIONS(1958),
    [anon_sym_DASH_DASH] = ACTIONS(1960),
    [anon_sym_PLUS_PLUS] = ACTIONS(1960),
    [anon_sym_sizeof] = ACTIONS(1958),
    [anon_sym___alignof__] = ACTIONS(1958),
    [anon_sym___alignof] = ACTIONS(1958),
    [anon_sym__alignof] = ACTIONS(1958),
    [anon_sym_alignof] = ACTIONS(1958),
    [anon_sym__Alignof] = ACTIONS(1958),
    [anon_sym_offsetof] = ACTIONS(1958),
    [anon_sym__Generic] = ACTIONS(1958),
    [anon_sym_asm] = ACTIONS(1958),
    [anon_sym___asm__] = ACTIONS(1958),
    [sym_number_literal] = ACTIONS(1960),
    [anon_sym_L_SQUOTE] = ACTIONS(1960),
    [anon_sym_u_SQUOTE] = ACTIONS(1960),
    [anon_sym_U_SQUOTE] = ACTIONS(1960),
    [anon_sym_u8_SQUOTE] = ACTIONS(1960),
    [anon_sym_SQUOTE] = ACTIONS(1960),
    [anon_sym_L_DQUOTE] = ACTIONS(1960),
    [anon_sym_u_DQUOTE] = ACTIONS(1960),
    [anon_sym_U_DQUOTE] = ACTIONS(1960),
    [anon_sym_u8_DQUOTE] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1960),
    [sym_true] = ACTIONS(1958),
    [sym_false] = ACTIONS(1958),
    [anon_sym_NULL] = ACTIONS(1958),
    [anon_sym_nullptr] = ACTIONS(1958),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1958),
    [anon_sym_decltype] = ACTIONS(1958),
    [sym_virtual] = ACTIONS(1958),
    [anon_sym_typename] = ACTIONS(1958),
    [anon_sym_template] = ACTIONS(1958),
    [anon_sym_try] = ACTIONS(1958),
    [anon_sym_delete] = ACTIONS(1958),
    [anon_sym_throw] = ACTIONS(1958),
    [anon_sym_co_return] = ACTIONS(1958),
    [anon_sym_co_yield] = ACTIONS(1958),
    [anon_sym_R_DQUOTE] = ACTIONS(1960),
    [anon_sym_LR_DQUOTE] = ACTIONS(1960),
    [anon_sym_uR_DQUOTE] = ACTIONS(1960),
    [anon_sym_UR_DQUOTE] = ACTIONS(1960),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1960),
    [anon_sym_co_await] = ACTIONS(1958),
    [anon_sym_new] = ACTIONS(1958),
    [anon_sym_requires] = ACTIONS(1958),
    [sym_this] = ACTIONS(1958),
    [anon_sym___launch_bounds__] = ACTIONS(1958),
  },
  [843] = {
    [sym_identifier] = ACTIONS(1964),
    [anon_sym_LPAREN2] = ACTIONS(1966),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [anon_sym_DASH] = ACTIONS(1964),
    [anon_sym_PLUS] = ACTIONS(1964),
    [anon_sym_STAR] = ACTIONS(1966),
    [anon_sym_AMP] = ACTIONS(1966),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym___extension__] = ACTIONS(1964),
    [anon_sym_typedef] = ACTIONS(1964),
    [anon_sym___device__] = ACTIONS(1964),
    [anon_sym___host__] = ACTIONS(1964),
    [anon_sym___global__] = ACTIONS(1964),
    [anon_sym___forceinline__] = ACTIONS(1964),
    [anon_sym___noinline__] = ACTIONS(1964),
    [anon_sym_extern] = ACTIONS(1964),
    [anon_sym___attribute__] = ACTIONS(1964),
    [anon_sym_COLON_COLON] = ACTIONS(1966),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1966),
    [anon_sym___declspec] = ACTIONS(1964),
    [anon_sym_LBRACE] = ACTIONS(1966),
    [anon_sym_signed] = ACTIONS(1964),
    [anon_sym_unsigned] = ACTIONS(1964),
    [anon_sym_long] = ACTIONS(1964),
    [anon_sym_short] = ACTIONS(1964),
    [anon_sym_LBRACK] = ACTIONS(1964),
    [anon_sym_static] = ACTIONS(1964),
    [anon_sym_register] = ACTIONS(1964),
    [anon_sym_inline] = ACTIONS(1964),
    [anon_sym___inline] = ACTIONS(1964),
    [anon_sym___inline__] = ACTIONS(1964),
    [anon_sym___forceinline] = ACTIONS(1964),
    [anon_sym_thread_local] = ACTIONS(1964),
    [anon_sym___thread] = ACTIONS(1964),
    [anon_sym_const] = ACTIONS(1964),
    [anon_sym_constexpr] = ACTIONS(1964),
    [anon_sym_volatile] = ACTIONS(1964),
    [anon_sym_restrict] = ACTIONS(1964),
    [anon_sym___restrict__] = ACTIONS(1964),
    [anon_sym__Atomic] = ACTIONS(1964),
    [anon_sym__Noreturn] = ACTIONS(1964),
    [anon_sym_noreturn] = ACTIONS(1964),
    [anon_sym_mutable] = ACTIONS(1964),
    [anon_sym_constinit] = ACTIONS(1964),
    [anon_sym_consteval] = ACTIONS(1964),
    [anon_sym___shared__] = ACTIONS(1964),
    [anon_sym___local__] = ACTIONS(1964),
    [anon_sym___constant__] = ACTIONS(1964),
    [anon_sym___managed__] = ACTIONS(1964),
    [anon_sym___grid_constant__] = ACTIONS(1964),
    [anon_sym_alignas] = ACTIONS(1964),
    [anon_sym__Alignas] = ACTIONS(1964),
    [sym_primitive_type] = ACTIONS(1964),
    [anon_sym_enum] = ACTIONS(1964),
    [anon_sym_class] = ACTIONS(1964),
    [anon_sym_struct] = ACTIONS(1964),
    [anon_sym_union] = ACTIONS(1964),
    [anon_sym_if] = ACTIONS(1964),
    [anon_sym_else] = ACTIONS(1964),
    [anon_sym_switch] = ACTIONS(1964),
    [anon_sym_while] = ACTIONS(1964),
    [anon_sym_do] = ACTIONS(1964),
    [anon_sym_for] = ACTIONS(1964),
    [anon_sym_return] = ACTIONS(1964),
    [anon_sym_break] = ACTIONS(1964),
    [anon_sym_continue] = ACTIONS(1964),
    [anon_sym_goto] = ACTIONS(1964),
    [anon_sym___try] = ACTIONS(1964),
    [anon_sym___leave] = ACTIONS(1964),
    [anon_sym_not] = ACTIONS(1964),
    [anon_sym_compl] = ACTIONS(1964),
    [anon_sym_DASH_DASH] = ACTIONS(1966),
    [anon_sym_PLUS_PLUS] = ACTIONS(1966),
    [anon_sym_sizeof] = ACTIONS(1964),
    [anon_sym___alignof__] = ACTIONS(1964),
    [anon_sym___alignof] = ACTIONS(1964),
    [anon_sym__alignof] = ACTIONS(1964),
    [anon_sym_alignof] = ACTIONS(1964),
    [anon_sym__Alignof] = ACTIONS(1964),
    [anon_sym_offsetof] = ACTIONS(1964),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1964),
    [anon_sym___asm__] = ACTIONS(1964),
    [sym_number_literal] = ACTIONS(1966),
    [anon_sym_L_SQUOTE] = ACTIONS(1966),
    [anon_sym_u_SQUOTE] = ACTIONS(1966),
    [anon_sym_U_SQUOTE] = ACTIONS(1966),
    [anon_sym_u8_SQUOTE] = ACTIONS(1966),
    [anon_sym_SQUOTE] = ACTIONS(1966),
    [anon_sym_L_DQUOTE] = ACTIONS(1966),
    [anon_sym_u_DQUOTE] = ACTIONS(1966),
    [anon_sym_U_DQUOTE] = ACTIONS(1966),
    [anon_sym_u8_DQUOTE] = ACTIONS(1966),
    [anon_sym_DQUOTE] = ACTIONS(1966),
    [sym_true] = ACTIONS(1964),
    [sym_false] = ACTIONS(1964),
    [anon_sym_NULL] = ACTIONS(1964),
    [anon_sym_nullptr] = ACTIONS(1964),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1964),
    [anon_sym_decltype] = ACTIONS(1964),
    [sym_virtual] = ACTIONS(1964),
    [anon_sym_typename] = ACTIONS(1964),
    [anon_sym_template] = ACTIONS(1964),
    [anon_sym_try] = ACTIONS(1964),
    [anon_sym_delete] = ACTIONS(1964),
    [anon_sym_throw] = ACTIONS(1964),
    [anon_sym_co_return] = ACTIONS(1964),
    [anon_sym_co_yield] = ACTIONS(1964),
    [anon_sym_R_DQUOTE] = ACTIONS(1966),
    [anon_sym_LR_DQUOTE] = ACTIONS(1966),
    [anon_sym_uR_DQUOTE] = ACTIONS(1966),
    [anon_sym_UR_DQUOTE] = ACTIONS(1966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1966),
    [anon_sym_co_await] = ACTIONS(1964),
    [anon_sym_new] = ACTIONS(1964),
    [anon_sym_requires] = ACTIONS(1964),
    [sym_this] = ACTIONS(1964),
    [anon_sym___launch_bounds__] = ACTIONS(1964),
  },
  [844] = {
    [sym_identifier] = ACTIONS(1964),
    [anon_sym_LPAREN2] = ACTIONS(1966),
    [anon_sym_BANG] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [anon_sym_DASH] = ACTIONS(1964),
    [anon_sym_PLUS] = ACTIONS(1964),
    [anon_sym_STAR] = ACTIONS(1966),
    [anon_sym_AMP] = ACTIONS(1966),
    [anon_sym_SEMI] = ACTIONS(1966),
    [anon_sym___extension__] = ACTIONS(1964),
    [anon_sym_typedef] = ACTIONS(1964),
    [anon_sym___device__] = ACTIONS(1964),
    [anon_sym___host__] = ACTIONS(1964),
    [anon_sym___global__] = ACTIONS(1964),
    [anon_sym___forceinline__] = ACTIONS(1964),
    [anon_sym___noinline__] = ACTIONS(1964),
    [anon_sym_extern] = ACTIONS(1964),
    [anon_sym___attribute__] = ACTIONS(1964),
    [anon_sym_COLON_COLON] = ACTIONS(1966),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1966),
    [anon_sym___declspec] = ACTIONS(1964),
    [anon_sym_LBRACE] = ACTIONS(1966),
    [anon_sym_signed] = ACTIONS(1964),
    [anon_sym_unsigned] = ACTIONS(1964),
    [anon_sym_long] = ACTIONS(1964),
    [anon_sym_short] = ACTIONS(1964),
    [anon_sym_LBRACK] = ACTIONS(1964),
    [anon_sym_static] = ACTIONS(1964),
    [anon_sym_register] = ACTIONS(1964),
    [anon_sym_inline] = ACTIONS(1964),
    [anon_sym___inline] = ACTIONS(1964),
    [anon_sym___inline__] = ACTIONS(1964),
    [anon_sym___forceinline] = ACTIONS(1964),
    [anon_sym_thread_local] = ACTIONS(1964),
    [anon_sym___thread] = ACTIONS(1964),
    [anon_sym_const] = ACTIONS(1964),
    [anon_sym_constexpr] = ACTIONS(1964),
    [anon_sym_volatile] = ACTIONS(1964),
    [anon_sym_restrict] = ACTIONS(1964),
    [anon_sym___restrict__] = ACTIONS(1964),
    [anon_sym__Atomic] = ACTIONS(1964),
    [anon_sym__Noreturn] = ACTIONS(1964),
    [anon_sym_noreturn] = ACTIONS(1964),
    [anon_sym_mutable] = ACTIONS(1964),
    [anon_sym_constinit] = ACTIONS(1964),
    [anon_sym_consteval] = ACTIONS(1964),
    [anon_sym___shared__] = ACTIONS(1964),
    [anon_sym___local__] = ACTIONS(1964),
    [anon_sym___constant__] = ACTIONS(1964),
    [anon_sym___managed__] = ACTIONS(1964),
    [anon_sym___grid_constant__] = ACTIONS(1964),
    [anon_sym_alignas] = ACTIONS(1964),
    [anon_sym__Alignas] = ACTIONS(1964),
    [sym_primitive_type] = ACTIONS(1964),
    [anon_sym_enum] = ACTIONS(1964),
    [anon_sym_class] = ACTIONS(1964),
    [anon_sym_struct] = ACTIONS(1964),
    [anon_sym_union] = ACTIONS(1964),
    [anon_sym_if] = ACTIONS(1964),
    [anon_sym_else] = ACTIONS(1964),
    [anon_sym_switch] = ACTIONS(1964),
    [anon_sym_while] = ACTIONS(1964),
    [anon_sym_do] = ACTIONS(1964),
    [anon_sym_for] = ACTIONS(1964),
    [anon_sym_return] = ACTIONS(1964),
    [anon_sym_break] = ACTIONS(1964),
    [anon_sym_continue] = ACTIONS(1964),
    [anon_sym_goto] = ACTIONS(1964),
    [anon_sym___try] = ACTIONS(1964),
    [anon_sym___leave] = ACTIONS(1964),
    [anon_sym_not] = ACTIONS(1964),
    [anon_sym_compl] = ACTIONS(1964),
    [anon_sym_DASH_DASH] = ACTIONS(1966),
    [anon_sym_PLUS_PLUS] = ACTIONS(1966),
    [anon_sym_sizeof] = ACTIONS(1964),
    [anon_sym___alignof__] = ACTIONS(1964),
    [anon_sym___alignof] = ACTIONS(1964),
    [anon_sym__alignof] = ACTIONS(1964),
    [anon_sym_alignof] = ACTIONS(1964),
    [anon_sym__Alignof] = ACTIONS(1964),
    [anon_sym_offsetof] = ACTIONS(1964),
    [anon_sym__Generic] = ACTIONS(1964),
    [anon_sym_asm] = ACTIONS(1964),
    [anon_sym___asm__] = ACTIONS(1964),
    [sym_number_literal] = ACTIONS(1966),
    [anon_sym_L_SQUOTE] = ACTIONS(1966),
    [anon_sym_u_SQUOTE] = ACTIONS(1966),
    [anon_sym_U_SQUOTE] = ACTIONS(1966),
    [anon_sym_u8_SQUOTE] = ACTIONS(1966),
    [anon_sym_SQUOTE] = ACTIONS(1966),
    [anon_sym_L_DQUOTE] = ACTIONS(1966),
    [anon_sym_u_DQUOTE] = ACTIONS(1966),
    [anon_sym_U_DQUOTE] = ACTIONS(1966),
    [anon_sym_u8_DQUOTE] = ACTIONS(1966),
    [anon_sym_DQUOTE] = ACTIONS(1966),
    [sym_true] = ACTIONS(1964),
    [sym_false] = ACTIONS(1964),
    [anon_sym_NULL] = ACTIONS(1964),
    [anon_sym_nullptr] = ACTIONS(1964),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1964),
    [anon_sym_decltype] = ACTIONS(1964),
    [sym_virtual] = ACTIONS(1964),
    [anon_sym_typename] = ACTIONS(1964),
    [anon_sym_template] = ACTIONS(1964),
    [anon_sym_try] = ACTIONS(1964),
    [anon_sym_delete] = ACTIONS(1964),
    [anon_sym_throw] = ACTIONS(1964),
    [anon_sym_co_return] = ACTIONS(1964),
    [anon_sym_co_yield] = ACTIONS(1964),
    [anon_sym_R_DQUOTE] = ACTIONS(1966),
    [anon_sym_LR_DQUOTE] = ACTIONS(1966),
    [anon_sym_uR_DQUOTE] = ACTIONS(1966),
    [anon_sym_UR_DQUOTE] = ACTIONS(1966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1966),
    [anon_sym_co_await] = ACTIONS(1964),
    [anon_sym_new] = ACTIONS(1964),
    [anon_sym_requires] = ACTIONS(1964),
    [sym_this] = ACTIONS(1964),
    [anon_sym___launch_bounds__] = ACTIONS(1964),
  },
  [845] = {
    [sym_identifier] = ACTIONS(1946),
    [anon_sym_LPAREN2] = ACTIONS(1948),
    [anon_sym_BANG] = ACTIONS(1948),
    [anon_sym_TILDE] = ACTIONS(1948),
    [anon_sym_DASH] = ACTIONS(1946),
    [anon_sym_PLUS] = ACTIONS(1946),
    [anon_sym_STAR] = ACTIONS(1948),
    [anon_sym_AMP] = ACTIONS(1948),
    [anon_sym_SEMI] = ACTIONS(1948),
    [anon_sym___extension__] = ACTIONS(1946),
    [anon_sym_typedef] = ACTIONS(1946),
    [anon_sym___device__] = ACTIONS(1946),
    [anon_sym___host__] = ACTIONS(1946),
    [anon_sym___global__] = ACTIONS(1946),
    [anon_sym___forceinline__] = ACTIONS(1946),
    [anon_sym___noinline__] = ACTIONS(1946),
    [anon_sym_extern] = ACTIONS(1946),
    [anon_sym___attribute__] = ACTIONS(1946),
    [anon_sym_COLON_COLON] = ACTIONS(1948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1948),
    [anon_sym___declspec] = ACTIONS(1946),
    [anon_sym_LBRACE] = ACTIONS(1948),
    [anon_sym_signed] = ACTIONS(1946),
    [anon_sym_unsigned] = ACTIONS(1946),
    [anon_sym_long] = ACTIONS(1946),
    [anon_sym_short] = ACTIONS(1946),
    [anon_sym_LBRACK] = ACTIONS(1946),
    [anon_sym_static] = ACTIONS(1946),
    [anon_sym_register] = ACTIONS(1946),
    [anon_sym_inline] = ACTIONS(1946),
    [anon_sym___inline] = ACTIONS(1946),
    [anon_sym___inline__] = ACTIONS(1946),
    [anon_sym___forceinline] = ACTIONS(1946),
    [anon_sym_thread_local] = ACTIONS(1946),
    [anon_sym___thread] = ACTIONS(1946),
    [anon_sym_const] = ACTIONS(1946),
    [anon_sym_constexpr] = ACTIONS(1946),
    [anon_sym_volatile] = ACTIONS(1946),
    [anon_sym_restrict] = ACTIONS(1946),
    [anon_sym___restrict__] = ACTIONS(1946),
    [anon_sym__Atomic] = ACTIONS(1946),
    [anon_sym__Noreturn] = ACTIONS(1946),
    [anon_sym_noreturn] = ACTIONS(1946),
    [anon_sym_mutable] = ACTIONS(1946),
    [anon_sym_constinit] = ACTIONS(1946),
    [anon_sym_consteval] = ACTIONS(1946),
    [anon_sym___shared__] = ACTIONS(1946),
    [anon_sym___local__] = ACTIONS(1946),
    [anon_sym___constant__] = ACTIONS(1946),
    [anon_sym___managed__] = ACTIONS(1946),
    [anon_sym___grid_constant__] = ACTIONS(1946),
    [anon_sym_alignas] = ACTIONS(1946),
    [anon_sym__Alignas] = ACTIONS(1946),
    [sym_primitive_type] = ACTIONS(1946),
    [anon_sym_enum] = ACTIONS(1946),
    [anon_sym_class] = ACTIONS(1946),
    [anon_sym_struct] = ACTIONS(1946),
    [anon_sym_union] = ACTIONS(1946),
    [anon_sym_if] = ACTIONS(1946),
    [anon_sym_else] = ACTIONS(1946),
    [anon_sym_switch] = ACTIONS(1946),
    [anon_sym_while] = ACTIONS(1946),
    [anon_sym_do] = ACTIONS(1946),
    [anon_sym_for] = ACTIONS(1946),
    [anon_sym_return] = ACTIONS(1946),
    [anon_sym_break] = ACTIONS(1946),
    [anon_sym_continue] = ACTIONS(1946),
    [anon_sym_goto] = ACTIONS(1946),
    [anon_sym___try] = ACTIONS(1946),
    [anon_sym___leave] = ACTIONS(1946),
    [anon_sym_not] = ACTIONS(1946),
    [anon_sym_compl] = ACTIONS(1946),
    [anon_sym_DASH_DASH] = ACTIONS(1948),
    [anon_sym_PLUS_PLUS] = ACTIONS(1948),
    [anon_sym_sizeof] = ACTIONS(1946),
    [anon_sym___alignof__] = ACTIONS(1946),
    [anon_sym___alignof] = ACTIONS(1946),
    [anon_sym__alignof] = ACTIONS(1946),
    [anon_sym_alignof] = ACTIONS(1946),
    [anon_sym__Alignof] = ACTIONS(1946),
    [anon_sym_offsetof] = ACTIONS(1946),
    [anon_sym__Generic] = ACTIONS(1946),
    [anon_sym_asm] = ACTIONS(1946),
    [anon_sym___asm__] = ACTIONS(1946),
    [sym_number_literal] = ACTIONS(1948),
    [anon_sym_L_SQUOTE] = ACTIONS(1948),
    [anon_sym_u_SQUOTE] = ACTIONS(1948),
    [anon_sym_U_SQUOTE] = ACTIONS(1948),
    [anon_sym_u8_SQUOTE] = ACTIONS(1948),
    [anon_sym_SQUOTE] = ACTIONS(1948),
    [anon_sym_L_DQUOTE] = ACTIONS(1948),
    [anon_sym_u_DQUOTE] = ACTIONS(1948),
    [anon_sym_U_DQUOTE] = ACTIONS(1948),
    [anon_sym_u8_DQUOTE] = ACTIONS(1948),
    [anon_sym_DQUOTE] = ACTIONS(1948),
    [sym_true] = ACTIONS(1946),
    [sym_false] = ACTIONS(1946),
    [anon_sym_NULL] = ACTIONS(1946),
    [anon_sym_nullptr] = ACTIONS(1946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1946),
    [anon_sym_decltype] = ACTIONS(1946),
    [sym_virtual] = ACTIONS(1946),
    [anon_sym_typename] = ACTIONS(1946),
    [anon_sym_template] = ACTIONS(1946),
    [anon_sym_try] = ACTIONS(1946),
    [anon_sym_delete] = ACTIONS(1946),
    [anon_sym_throw] = ACTIONS(1946),
    [anon_sym_co_return] = ACTIONS(1946),
    [anon_sym_co_yield] = ACTIONS(1946),
    [anon_sym_R_DQUOTE] = ACTIONS(1948),
    [anon_sym_LR_DQUOTE] = ACTIONS(1948),
    [anon_sym_uR_DQUOTE] = ACTIONS(1948),
    [anon_sym_UR_DQUOTE] = ACTIONS(1948),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1948),
    [anon_sym_co_await] = ACTIONS(1946),
    [anon_sym_new] = ACTIONS(1946),
    [anon_sym_requires] = ACTIONS(1946),
    [sym_this] = ACTIONS(1946),
    [anon_sym___launch_bounds__] = ACTIONS(1946),
  },
  [846] = {
    [sym_identifier] = ACTIONS(1950),
    [anon_sym_LPAREN2] = ACTIONS(1952),
    [anon_sym_BANG] = ACTIONS(1952),
    [anon_sym_TILDE] = ACTIONS(1952),
    [anon_sym_DASH] = ACTIONS(1950),
    [anon_sym_PLUS] = ACTIONS(1950),
    [anon_sym_STAR] = ACTIONS(1952),
    [anon_sym_AMP] = ACTIONS(1952),
    [anon_sym_SEMI] = ACTIONS(1952),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_typedef] = ACTIONS(1950),
    [anon_sym___device__] = ACTIONS(1950),
    [anon_sym___host__] = ACTIONS(1950),
    [anon_sym___global__] = ACTIONS(1950),
    [anon_sym___forceinline__] = ACTIONS(1950),
    [anon_sym___noinline__] = ACTIONS(1950),
    [anon_sym_extern] = ACTIONS(1950),
    [anon_sym___attribute__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1952),
    [anon_sym___declspec] = ACTIONS(1950),
    [anon_sym_LBRACE] = ACTIONS(1952),
    [anon_sym_signed] = ACTIONS(1950),
    [anon_sym_unsigned] = ACTIONS(1950),
    [anon_sym_long] = ACTIONS(1950),
    [anon_sym_short] = ACTIONS(1950),
    [anon_sym_LBRACK] = ACTIONS(1950),
    [anon_sym_static] = ACTIONS(1950),
    [anon_sym_register] = ACTIONS(1950),
    [anon_sym_inline] = ACTIONS(1950),
    [anon_sym___inline] = ACTIONS(1950),
    [anon_sym___inline__] = ACTIONS(1950),
    [anon_sym___forceinline] = ACTIONS(1950),
    [anon_sym_thread_local] = ACTIONS(1950),
    [anon_sym___thread] = ACTIONS(1950),
    [anon_sym_const] = ACTIONS(1950),
    [anon_sym_constexpr] = ACTIONS(1950),
    [anon_sym_volatile] = ACTIONS(1950),
    [anon_sym_restrict] = ACTIONS(1950),
    [anon_sym___restrict__] = ACTIONS(1950),
    [anon_sym__Atomic] = ACTIONS(1950),
    [anon_sym__Noreturn] = ACTIONS(1950),
    [anon_sym_noreturn] = ACTIONS(1950),
    [anon_sym_mutable] = ACTIONS(1950),
    [anon_sym_constinit] = ACTIONS(1950),
    [anon_sym_consteval] = ACTIONS(1950),
    [anon_sym___shared__] = ACTIONS(1950),
    [anon_sym___local__] = ACTIONS(1950),
    [anon_sym___constant__] = ACTIONS(1950),
    [anon_sym___managed__] = ACTIONS(1950),
    [anon_sym___grid_constant__] = ACTIONS(1950),
    [anon_sym_alignas] = ACTIONS(1950),
    [anon_sym__Alignas] = ACTIONS(1950),
    [sym_primitive_type] = ACTIONS(1950),
    [anon_sym_enum] = ACTIONS(1950),
    [anon_sym_class] = ACTIONS(1950),
    [anon_sym_struct] = ACTIONS(1950),
    [anon_sym_union] = ACTIONS(1950),
    [anon_sym_if] = ACTIONS(1950),
    [anon_sym_else] = ACTIONS(1950),
    [anon_sym_switch] = ACTIONS(1950),
    [anon_sym_while] = ACTIONS(1950),
    [anon_sym_do] = ACTIONS(1950),
    [anon_sym_for] = ACTIONS(1950),
    [anon_sym_return] = ACTIONS(1950),
    [anon_sym_break] = ACTIONS(1950),
    [anon_sym_continue] = ACTIONS(1950),
    [anon_sym_goto] = ACTIONS(1950),
    [anon_sym___try] = ACTIONS(1950),
    [anon_sym___leave] = ACTIONS(1950),
    [anon_sym_not] = ACTIONS(1950),
    [anon_sym_compl] = ACTIONS(1950),
    [anon_sym_DASH_DASH] = ACTIONS(1952),
    [anon_sym_PLUS_PLUS] = ACTIONS(1952),
    [anon_sym_sizeof] = ACTIONS(1950),
    [anon_sym___alignof__] = ACTIONS(1950),
    [anon_sym___alignof] = ACTIONS(1950),
    [anon_sym__alignof] = ACTIONS(1950),
    [anon_sym_alignof] = ACTIONS(1950),
    [anon_sym__Alignof] = ACTIONS(1950),
    [anon_sym_offsetof] = ACTIONS(1950),
    [anon_sym__Generic] = ACTIONS(1950),
    [anon_sym_asm] = ACTIONS(1950),
    [anon_sym___asm__] = ACTIONS(1950),
    [sym_number_literal] = ACTIONS(1952),
    [anon_sym_L_SQUOTE] = ACTIONS(1952),
    [anon_sym_u_SQUOTE] = ACTIONS(1952),
    [anon_sym_U_SQUOTE] = ACTIONS(1952),
    [anon_sym_u8_SQUOTE] = ACTIONS(1952),
    [anon_sym_SQUOTE] = ACTIONS(1952),
    [anon_sym_L_DQUOTE] = ACTIONS(1952),
    [anon_sym_u_DQUOTE] = ACTIONS(1952),
    [anon_sym_U_DQUOTE] = ACTIONS(1952),
    [anon_sym_u8_DQUOTE] = ACTIONS(1952),
    [anon_sym_DQUOTE] = ACTIONS(1952),
    [sym_true] = ACTIONS(1950),
    [sym_false] = ACTIONS(1950),
    [anon_sym_NULL] = ACTIONS(1950),
    [anon_sym_nullptr] = ACTIONS(1950),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1950),
    [anon_sym_decltype] = ACTIONS(1950),
    [sym_virtual] = ACTIONS(1950),
    [anon_sym_typename] = ACTIONS(1950),
    [anon_sym_template] = ACTIONS(1950),
    [anon_sym_try] = ACTIONS(1950),
    [anon_sym_delete] = ACTIONS(1950),
    [anon_sym_throw] = ACTIONS(1950),
    [anon_sym_co_return] = ACTIONS(1950),
    [anon_sym_co_yield] = ACTIONS(1950),
    [anon_sym_R_DQUOTE] = ACTIONS(1952),
    [anon_sym_LR_DQUOTE] = ACTIONS(1952),
    [anon_sym_uR_DQUOTE] = ACTIONS(1952),
    [anon_sym_UR_DQUOTE] = ACTIONS(1952),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1952),
    [anon_sym_co_await] = ACTIONS(1950),
    [anon_sym_new] = ACTIONS(1950),
    [anon_sym_requires] = ACTIONS(1950),
    [sym_this] = ACTIONS(1950),
    [anon_sym___launch_bounds__] = ACTIONS(1950),
  },
  [847] = {
    [sym__declaration_modifiers] = STATE(1847),
    [sym__declaration_specifiers] = STATE(4480),
    [sym_attribute_specifier] = STATE(1847),
    [sym_attribute_declaration] = STATE(1847),
    [sym_ms_declspec_modifier] = STATE(1847),
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_call_modifier] = STATE(5204),
    [sym__declarator] = STATE(6903),
    [sym__abstract_declarator] = STATE(7027),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_abstract_parenthesized_declarator] = STATE(6430),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_abstract_pointer_declarator] = STATE(6430),
    [sym_function_declarator] = STATE(6598),
    [sym_abstract_function_declarator] = STATE(6430),
    [sym_array_declarator] = STATE(6598),
    [sym_abstract_array_declarator] = STATE(6430),
    [sym_storage_class_specifier] = STATE(1847),
    [sym_type_qualifier] = STATE(1847),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_parameter_list] = STATE(2989),
    [sym_parameter_declaration] = STATE(7423),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_optional_parameter_declaration] = STATE(7423),
    [sym_variadic_parameter_declaration] = STATE(7423),
    [sym_reference_declarator] = STATE(6598),
    [sym_abstract_reference_declarator] = STATE(6430),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym__function_declarator_seq] = STATE(6416),
    [sym_template_type] = STATE(2154),
    [sym_template_function] = STATE(6598),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5949),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(1847),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1847),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(3953),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1815),
    [anon_sym_RPAREN] = ACTIONS(3955),
    [anon_sym_LPAREN2] = ACTIONS(3957),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(3959),
    [anon_sym_AMP_AMP] = ACTIONS(3961),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1765),
    [anon_sym___host__] = ACTIONS(1765),
    [anon_sym___global__] = ACTIONS(1765),
    [anon_sym___forceinline__] = ACTIONS(1765),
    [anon_sym___noinline__] = ACTIONS(1765),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3965),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(1839),
    [anon_sym___clrcall] = ACTIONS(1839),
    [anon_sym___stdcall] = ACTIONS(1839),
    [anon_sym___fastcall] = ACTIONS(1839),
    [anon_sym___thiscall] = ACTIONS(1839),
    [anon_sym___vectorcall] = ACTIONS(1839),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(3967),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(1771),
    [anon_sym_class] = ACTIONS(1773),
    [anon_sym_struct] = ACTIONS(1775),
    [anon_sym_union] = ACTIONS(1777),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1765),
    [anon_sym_typename] = ACTIONS(1801),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1883),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [848] = {
    [sym_identifier] = ACTIONS(1996),
    [anon_sym_LPAREN2] = ACTIONS(1998),
    [anon_sym_BANG] = ACTIONS(1998),
    [anon_sym_TILDE] = ACTIONS(1998),
    [anon_sym_DASH] = ACTIONS(1996),
    [anon_sym_PLUS] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(1998),
    [anon_sym_AMP] = ACTIONS(1998),
    [anon_sym_SEMI] = ACTIONS(1998),
    [anon_sym___extension__] = ACTIONS(1996),
    [anon_sym_typedef] = ACTIONS(1996),
    [anon_sym___device__] = ACTIONS(1996),
    [anon_sym___host__] = ACTIONS(1996),
    [anon_sym___global__] = ACTIONS(1996),
    [anon_sym___forceinline__] = ACTIONS(1996),
    [anon_sym___noinline__] = ACTIONS(1996),
    [anon_sym_extern] = ACTIONS(1996),
    [anon_sym___attribute__] = ACTIONS(1996),
    [anon_sym_COLON_COLON] = ACTIONS(1998),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1998),
    [anon_sym___declspec] = ACTIONS(1996),
    [anon_sym_LBRACE] = ACTIONS(1998),
    [anon_sym_signed] = ACTIONS(1996),
    [anon_sym_unsigned] = ACTIONS(1996),
    [anon_sym_long] = ACTIONS(1996),
    [anon_sym_short] = ACTIONS(1996),
    [anon_sym_LBRACK] = ACTIONS(1996),
    [anon_sym_static] = ACTIONS(1996),
    [anon_sym_register] = ACTIONS(1996),
    [anon_sym_inline] = ACTIONS(1996),
    [anon_sym___inline] = ACTIONS(1996),
    [anon_sym___inline__] = ACTIONS(1996),
    [anon_sym___forceinline] = ACTIONS(1996),
    [anon_sym_thread_local] = ACTIONS(1996),
    [anon_sym___thread] = ACTIONS(1996),
    [anon_sym_const] = ACTIONS(1996),
    [anon_sym_constexpr] = ACTIONS(1996),
    [anon_sym_volatile] = ACTIONS(1996),
    [anon_sym_restrict] = ACTIONS(1996),
    [anon_sym___restrict__] = ACTIONS(1996),
    [anon_sym__Atomic] = ACTIONS(1996),
    [anon_sym__Noreturn] = ACTIONS(1996),
    [anon_sym_noreturn] = ACTIONS(1996),
    [anon_sym_mutable] = ACTIONS(1996),
    [anon_sym_constinit] = ACTIONS(1996),
    [anon_sym_consteval] = ACTIONS(1996),
    [anon_sym___shared__] = ACTIONS(1996),
    [anon_sym___local__] = ACTIONS(1996),
    [anon_sym___constant__] = ACTIONS(1996),
    [anon_sym___managed__] = ACTIONS(1996),
    [anon_sym___grid_constant__] = ACTIONS(1996),
    [anon_sym_alignas] = ACTIONS(1996),
    [anon_sym__Alignas] = ACTIONS(1996),
    [sym_primitive_type] = ACTIONS(1996),
    [anon_sym_enum] = ACTIONS(1996),
    [anon_sym_class] = ACTIONS(1996),
    [anon_sym_struct] = ACTIONS(1996),
    [anon_sym_union] = ACTIONS(1996),
    [anon_sym_if] = ACTIONS(1996),
    [anon_sym_else] = ACTIONS(1996),
    [anon_sym_switch] = ACTIONS(1996),
    [anon_sym_while] = ACTIONS(1996),
    [anon_sym_do] = ACTIONS(1996),
    [anon_sym_for] = ACTIONS(1996),
    [anon_sym_return] = ACTIONS(1996),
    [anon_sym_break] = ACTIONS(1996),
    [anon_sym_continue] = ACTIONS(1996),
    [anon_sym_goto] = ACTIONS(1996),
    [anon_sym___try] = ACTIONS(1996),
    [anon_sym___leave] = ACTIONS(1996),
    [anon_sym_not] = ACTIONS(1996),
    [anon_sym_compl] = ACTIONS(1996),
    [anon_sym_DASH_DASH] = ACTIONS(1998),
    [anon_sym_PLUS_PLUS] = ACTIONS(1998),
    [anon_sym_sizeof] = ACTIONS(1996),
    [anon_sym___alignof__] = ACTIONS(1996),
    [anon_sym___alignof] = ACTIONS(1996),
    [anon_sym__alignof] = ACTIONS(1996),
    [anon_sym_alignof] = ACTIONS(1996),
    [anon_sym__Alignof] = ACTIONS(1996),
    [anon_sym_offsetof] = ACTIONS(1996),
    [anon_sym__Generic] = ACTIONS(1996),
    [anon_sym_asm] = ACTIONS(1996),
    [anon_sym___asm__] = ACTIONS(1996),
    [sym_number_literal] = ACTIONS(1998),
    [anon_sym_L_SQUOTE] = ACTIONS(1998),
    [anon_sym_u_SQUOTE] = ACTIONS(1998),
    [anon_sym_U_SQUOTE] = ACTIONS(1998),
    [anon_sym_u8_SQUOTE] = ACTIONS(1998),
    [anon_sym_SQUOTE] = ACTIONS(1998),
    [anon_sym_L_DQUOTE] = ACTIONS(1998),
    [anon_sym_u_DQUOTE] = ACTIONS(1998),
    [anon_sym_U_DQUOTE] = ACTIONS(1998),
    [anon_sym_u8_DQUOTE] = ACTIONS(1998),
    [anon_sym_DQUOTE] = ACTIONS(1998),
    [sym_true] = ACTIONS(1996),
    [sym_false] = ACTIONS(1996),
    [anon_sym_NULL] = ACTIONS(1996),
    [anon_sym_nullptr] = ACTIONS(1996),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1996),
    [anon_sym_decltype] = ACTIONS(1996),
    [sym_virtual] = ACTIONS(1996),
    [anon_sym_typename] = ACTIONS(1996),
    [anon_sym_template] = ACTIONS(1996),
    [anon_sym_try] = ACTIONS(1996),
    [anon_sym_delete] = ACTIONS(1996),
    [anon_sym_throw] = ACTIONS(1996),
    [anon_sym_co_return] = ACTIONS(1996),
    [anon_sym_co_yield] = ACTIONS(1996),
    [anon_sym_R_DQUOTE] = ACTIONS(1998),
    [anon_sym_LR_DQUOTE] = ACTIONS(1998),
    [anon_sym_uR_DQUOTE] = ACTIONS(1998),
    [anon_sym_UR_DQUOTE] = ACTIONS(1998),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1998),
    [anon_sym_co_await] = ACTIONS(1996),
    [anon_sym_new] = ACTIONS(1996),
    [anon_sym_requires] = ACTIONS(1996),
    [sym_this] = ACTIONS(1996),
    [anon_sym___launch_bounds__] = ACTIONS(1996),
  },
  [849] = {
    [sym_identifier] = ACTIONS(1992),
    [anon_sym_LPAREN2] = ACTIONS(1994),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1994),
    [anon_sym_AMP] = ACTIONS(1994),
    [anon_sym_SEMI] = ACTIONS(1994),
    [anon_sym___extension__] = ACTIONS(1992),
    [anon_sym_typedef] = ACTIONS(1992),
    [anon_sym___device__] = ACTIONS(1992),
    [anon_sym___host__] = ACTIONS(1992),
    [anon_sym___global__] = ACTIONS(1992),
    [anon_sym___forceinline__] = ACTIONS(1992),
    [anon_sym___noinline__] = ACTIONS(1992),
    [anon_sym_extern] = ACTIONS(1992),
    [anon_sym___attribute__] = ACTIONS(1992),
    [anon_sym_COLON_COLON] = ACTIONS(1994),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1994),
    [anon_sym___declspec] = ACTIONS(1992),
    [anon_sym_LBRACE] = ACTIONS(1994),
    [anon_sym_signed] = ACTIONS(1992),
    [anon_sym_unsigned] = ACTIONS(1992),
    [anon_sym_long] = ACTIONS(1992),
    [anon_sym_short] = ACTIONS(1992),
    [anon_sym_LBRACK] = ACTIONS(1992),
    [anon_sym_static] = ACTIONS(1992),
    [anon_sym_register] = ACTIONS(1992),
    [anon_sym_inline] = ACTIONS(1992),
    [anon_sym___inline] = ACTIONS(1992),
    [anon_sym___inline__] = ACTIONS(1992),
    [anon_sym___forceinline] = ACTIONS(1992),
    [anon_sym_thread_local] = ACTIONS(1992),
    [anon_sym___thread] = ACTIONS(1992),
    [anon_sym_const] = ACTIONS(1992),
    [anon_sym_constexpr] = ACTIONS(1992),
    [anon_sym_volatile] = ACTIONS(1992),
    [anon_sym_restrict] = ACTIONS(1992),
    [anon_sym___restrict__] = ACTIONS(1992),
    [anon_sym__Atomic] = ACTIONS(1992),
    [anon_sym__Noreturn] = ACTIONS(1992),
    [anon_sym_noreturn] = ACTIONS(1992),
    [anon_sym_mutable] = ACTIONS(1992),
    [anon_sym_constinit] = ACTIONS(1992),
    [anon_sym_consteval] = ACTIONS(1992),
    [anon_sym___shared__] = ACTIONS(1992),
    [anon_sym___local__] = ACTIONS(1992),
    [anon_sym___constant__] = ACTIONS(1992),
    [anon_sym___managed__] = ACTIONS(1992),
    [anon_sym___grid_constant__] = ACTIONS(1992),
    [anon_sym_alignas] = ACTIONS(1992),
    [anon_sym__Alignas] = ACTIONS(1992),
    [sym_primitive_type] = ACTIONS(1992),
    [anon_sym_enum] = ACTIONS(1992),
    [anon_sym_class] = ACTIONS(1992),
    [anon_sym_struct] = ACTIONS(1992),
    [anon_sym_union] = ACTIONS(1992),
    [anon_sym_if] = ACTIONS(1992),
    [anon_sym_else] = ACTIONS(1992),
    [anon_sym_switch] = ACTIONS(1992),
    [anon_sym_while] = ACTIONS(1992),
    [anon_sym_do] = ACTIONS(1992),
    [anon_sym_for] = ACTIONS(1992),
    [anon_sym_return] = ACTIONS(1992),
    [anon_sym_break] = ACTIONS(1992),
    [anon_sym_continue] = ACTIONS(1992),
    [anon_sym_goto] = ACTIONS(1992),
    [anon_sym___try] = ACTIONS(1992),
    [anon_sym___leave] = ACTIONS(1992),
    [anon_sym_not] = ACTIONS(1992),
    [anon_sym_compl] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(1994),
    [anon_sym_PLUS_PLUS] = ACTIONS(1994),
    [anon_sym_sizeof] = ACTIONS(1992),
    [anon_sym___alignof__] = ACTIONS(1992),
    [anon_sym___alignof] = ACTIONS(1992),
    [anon_sym__alignof] = ACTIONS(1992),
    [anon_sym_alignof] = ACTIONS(1992),
    [anon_sym__Alignof] = ACTIONS(1992),
    [anon_sym_offsetof] = ACTIONS(1992),
    [anon_sym__Generic] = ACTIONS(1992),
    [anon_sym_asm] = ACTIONS(1992),
    [anon_sym___asm__] = ACTIONS(1992),
    [sym_number_literal] = ACTIONS(1994),
    [anon_sym_L_SQUOTE] = ACTIONS(1994),
    [anon_sym_u_SQUOTE] = ACTIONS(1994),
    [anon_sym_U_SQUOTE] = ACTIONS(1994),
    [anon_sym_u8_SQUOTE] = ACTIONS(1994),
    [anon_sym_SQUOTE] = ACTIONS(1994),
    [anon_sym_L_DQUOTE] = ACTIONS(1994),
    [anon_sym_u_DQUOTE] = ACTIONS(1994),
    [anon_sym_U_DQUOTE] = ACTIONS(1994),
    [anon_sym_u8_DQUOTE] = ACTIONS(1994),
    [anon_sym_DQUOTE] = ACTIONS(1994),
    [sym_true] = ACTIONS(1992),
    [sym_false] = ACTIONS(1992),
    [anon_sym_NULL] = ACTIONS(1992),
    [anon_sym_nullptr] = ACTIONS(1992),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1992),
    [anon_sym_decltype] = ACTIONS(1992),
    [sym_virtual] = ACTIONS(1992),
    [anon_sym_typename] = ACTIONS(1992),
    [anon_sym_template] = ACTIONS(1992),
    [anon_sym_try] = ACTIONS(1992),
    [anon_sym_delete] = ACTIONS(1992),
    [anon_sym_throw] = ACTIONS(1992),
    [anon_sym_co_return] = ACTIONS(1992),
    [anon_sym_co_yield] = ACTIONS(1992),
    [anon_sym_R_DQUOTE] = ACTIONS(1994),
    [anon_sym_LR_DQUOTE] = ACTIONS(1994),
    [anon_sym_uR_DQUOTE] = ACTIONS(1994),
    [anon_sym_UR_DQUOTE] = ACTIONS(1994),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1994),
    [anon_sym_co_await] = ACTIONS(1992),
    [anon_sym_new] = ACTIONS(1992),
    [anon_sym_requires] = ACTIONS(1992),
    [sym_this] = ACTIONS(1992),
    [anon_sym___launch_bounds__] = ACTIONS(1992),
  },
  [850] = {
    [sym_identifier] = ACTIONS(1968),
    [anon_sym_LPAREN2] = ACTIONS(1970),
    [anon_sym_BANG] = ACTIONS(1970),
    [anon_sym_TILDE] = ACTIONS(1970),
    [anon_sym_DASH] = ACTIONS(1968),
    [anon_sym_PLUS] = ACTIONS(1968),
    [anon_sym_STAR] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(1970),
    [anon_sym_SEMI] = ACTIONS(1970),
    [anon_sym___extension__] = ACTIONS(1968),
    [anon_sym_typedef] = ACTIONS(1968),
    [anon_sym___device__] = ACTIONS(1968),
    [anon_sym___host__] = ACTIONS(1968),
    [anon_sym___global__] = ACTIONS(1968),
    [anon_sym___forceinline__] = ACTIONS(1968),
    [anon_sym___noinline__] = ACTIONS(1968),
    [anon_sym_extern] = ACTIONS(1968),
    [anon_sym___attribute__] = ACTIONS(1968),
    [anon_sym_COLON_COLON] = ACTIONS(1970),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1970),
    [anon_sym___declspec] = ACTIONS(1968),
    [anon_sym_LBRACE] = ACTIONS(1970),
    [anon_sym_signed] = ACTIONS(1968),
    [anon_sym_unsigned] = ACTIONS(1968),
    [anon_sym_long] = ACTIONS(1968),
    [anon_sym_short] = ACTIONS(1968),
    [anon_sym_LBRACK] = ACTIONS(1968),
    [anon_sym_static] = ACTIONS(1968),
    [anon_sym_register] = ACTIONS(1968),
    [anon_sym_inline] = ACTIONS(1968),
    [anon_sym___inline] = ACTIONS(1968),
    [anon_sym___inline__] = ACTIONS(1968),
    [anon_sym___forceinline] = ACTIONS(1968),
    [anon_sym_thread_local] = ACTIONS(1968),
    [anon_sym___thread] = ACTIONS(1968),
    [anon_sym_const] = ACTIONS(1968),
    [anon_sym_constexpr] = ACTIONS(1968),
    [anon_sym_volatile] = ACTIONS(1968),
    [anon_sym_restrict] = ACTIONS(1968),
    [anon_sym___restrict__] = ACTIONS(1968),
    [anon_sym__Atomic] = ACTIONS(1968),
    [anon_sym__Noreturn] = ACTIONS(1968),
    [anon_sym_noreturn] = ACTIONS(1968),
    [anon_sym_mutable] = ACTIONS(1968),
    [anon_sym_constinit] = ACTIONS(1968),
    [anon_sym_consteval] = ACTIONS(1968),
    [anon_sym___shared__] = ACTIONS(1968),
    [anon_sym___local__] = ACTIONS(1968),
    [anon_sym___constant__] = ACTIONS(1968),
    [anon_sym___managed__] = ACTIONS(1968),
    [anon_sym___grid_constant__] = ACTIONS(1968),
    [anon_sym_alignas] = ACTIONS(1968),
    [anon_sym__Alignas] = ACTIONS(1968),
    [sym_primitive_type] = ACTIONS(1968),
    [anon_sym_enum] = ACTIONS(1968),
    [anon_sym_class] = ACTIONS(1968),
    [anon_sym_struct] = ACTIONS(1968),
    [anon_sym_union] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1968),
    [anon_sym_else] = ACTIONS(1968),
    [anon_sym_switch] = ACTIONS(1968),
    [anon_sym_while] = ACTIONS(1968),
    [anon_sym_do] = ACTIONS(1968),
    [anon_sym_for] = ACTIONS(1968),
    [anon_sym_return] = ACTIONS(1968),
    [anon_sym_break] = ACTIONS(1968),
    [anon_sym_continue] = ACTIONS(1968),
    [anon_sym_goto] = ACTIONS(1968),
    [anon_sym___try] = ACTIONS(1968),
    [anon_sym___leave] = ACTIONS(1968),
    [anon_sym_not] = ACTIONS(1968),
    [anon_sym_compl] = ACTIONS(1968),
    [anon_sym_DASH_DASH] = ACTIONS(1970),
    [anon_sym_PLUS_PLUS] = ACTIONS(1970),
    [anon_sym_sizeof] = ACTIONS(1968),
    [anon_sym___alignof__] = ACTIONS(1968),
    [anon_sym___alignof] = ACTIONS(1968),
    [anon_sym__alignof] = ACTIONS(1968),
    [anon_sym_alignof] = ACTIONS(1968),
    [anon_sym__Alignof] = ACTIONS(1968),
    [anon_sym_offsetof] = ACTIONS(1968),
    [anon_sym__Generic] = ACTIONS(1968),
    [anon_sym_asm] = ACTIONS(1968),
    [anon_sym___asm__] = ACTIONS(1968),
    [sym_number_literal] = ACTIONS(1970),
    [anon_sym_L_SQUOTE] = ACTIONS(1970),
    [anon_sym_u_SQUOTE] = ACTIONS(1970),
    [anon_sym_U_SQUOTE] = ACTIONS(1970),
    [anon_sym_u8_SQUOTE] = ACTIONS(1970),
    [anon_sym_SQUOTE] = ACTIONS(1970),
    [anon_sym_L_DQUOTE] = ACTIONS(1970),
    [anon_sym_u_DQUOTE] = ACTIONS(1970),
    [anon_sym_U_DQUOTE] = ACTIONS(1970),
    [anon_sym_u8_DQUOTE] = ACTIONS(1970),
    [anon_sym_DQUOTE] = ACTIONS(1970),
    [sym_true] = ACTIONS(1968),
    [sym_false] = ACTIONS(1968),
    [anon_sym_NULL] = ACTIONS(1968),
    [anon_sym_nullptr] = ACTIONS(1968),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1968),
    [anon_sym_decltype] = ACTIONS(1968),
    [sym_virtual] = ACTIONS(1968),
    [anon_sym_typename] = ACTIONS(1968),
    [anon_sym_template] = ACTIONS(1968),
    [anon_sym_try] = ACTIONS(1968),
    [anon_sym_delete] = ACTIONS(1968),
    [anon_sym_throw] = ACTIONS(1968),
    [anon_sym_co_return] = ACTIONS(1968),
    [anon_sym_co_yield] = ACTIONS(1968),
    [anon_sym_R_DQUOTE] = ACTIONS(1970),
    [anon_sym_LR_DQUOTE] = ACTIONS(1970),
    [anon_sym_uR_DQUOTE] = ACTIONS(1970),
    [anon_sym_UR_DQUOTE] = ACTIONS(1970),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1970),
    [anon_sym_co_await] = ACTIONS(1968),
    [anon_sym_new] = ACTIONS(1968),
    [anon_sym_requires] = ACTIONS(1968),
    [sym_this] = ACTIONS(1968),
    [anon_sym___launch_bounds__] = ACTIONS(1968),
  },
  [851] = {
    [sym_identifier] = ACTIONS(1972),
    [anon_sym_LPAREN2] = ACTIONS(1974),
    [anon_sym_BANG] = ACTIONS(1974),
    [anon_sym_TILDE] = ACTIONS(1974),
    [anon_sym_DASH] = ACTIONS(1972),
    [anon_sym_PLUS] = ACTIONS(1972),
    [anon_sym_STAR] = ACTIONS(1974),
    [anon_sym_AMP] = ACTIONS(1974),
    [anon_sym_SEMI] = ACTIONS(1974),
    [anon_sym___extension__] = ACTIONS(1972),
    [anon_sym_typedef] = ACTIONS(1972),
    [anon_sym___device__] = ACTIONS(1972),
    [anon_sym___host__] = ACTIONS(1972),
    [anon_sym___global__] = ACTIONS(1972),
    [anon_sym___forceinline__] = ACTIONS(1972),
    [anon_sym___noinline__] = ACTIONS(1972),
    [anon_sym_extern] = ACTIONS(1972),
    [anon_sym___attribute__] = ACTIONS(1972),
    [anon_sym_COLON_COLON] = ACTIONS(1974),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1974),
    [anon_sym___declspec] = ACTIONS(1972),
    [anon_sym_LBRACE] = ACTIONS(1974),
    [anon_sym_signed] = ACTIONS(1972),
    [anon_sym_unsigned] = ACTIONS(1972),
    [anon_sym_long] = ACTIONS(1972),
    [anon_sym_short] = ACTIONS(1972),
    [anon_sym_LBRACK] = ACTIONS(1972),
    [anon_sym_static] = ACTIONS(1972),
    [anon_sym_register] = ACTIONS(1972),
    [anon_sym_inline] = ACTIONS(1972),
    [anon_sym___inline] = ACTIONS(1972),
    [anon_sym___inline__] = ACTIONS(1972),
    [anon_sym___forceinline] = ACTIONS(1972),
    [anon_sym_thread_local] = ACTIONS(1972),
    [anon_sym___thread] = ACTIONS(1972),
    [anon_sym_const] = ACTIONS(1972),
    [anon_sym_constexpr] = ACTIONS(1972),
    [anon_sym_volatile] = ACTIONS(1972),
    [anon_sym_restrict] = ACTIONS(1972),
    [anon_sym___restrict__] = ACTIONS(1972),
    [anon_sym__Atomic] = ACTIONS(1972),
    [anon_sym__Noreturn] = ACTIONS(1972),
    [anon_sym_noreturn] = ACTIONS(1972),
    [anon_sym_mutable] = ACTIONS(1972),
    [anon_sym_constinit] = ACTIONS(1972),
    [anon_sym_consteval] = ACTIONS(1972),
    [anon_sym___shared__] = ACTIONS(1972),
    [anon_sym___local__] = ACTIONS(1972),
    [anon_sym___constant__] = ACTIONS(1972),
    [anon_sym___managed__] = ACTIONS(1972),
    [anon_sym___grid_constant__] = ACTIONS(1972),
    [anon_sym_alignas] = ACTIONS(1972),
    [anon_sym__Alignas] = ACTIONS(1972),
    [sym_primitive_type] = ACTIONS(1972),
    [anon_sym_enum] = ACTIONS(1972),
    [anon_sym_class] = ACTIONS(1972),
    [anon_sym_struct] = ACTIONS(1972),
    [anon_sym_union] = ACTIONS(1972),
    [anon_sym_if] = ACTIONS(1972),
    [anon_sym_else] = ACTIONS(1972),
    [anon_sym_switch] = ACTIONS(1972),
    [anon_sym_while] = ACTIONS(1972),
    [anon_sym_do] = ACTIONS(1972),
    [anon_sym_for] = ACTIONS(1972),
    [anon_sym_return] = ACTIONS(1972),
    [anon_sym_break] = ACTIONS(1972),
    [anon_sym_continue] = ACTIONS(1972),
    [anon_sym_goto] = ACTIONS(1972),
    [anon_sym___try] = ACTIONS(1972),
    [anon_sym___leave] = ACTIONS(1972),
    [anon_sym_not] = ACTIONS(1972),
    [anon_sym_compl] = ACTIONS(1972),
    [anon_sym_DASH_DASH] = ACTIONS(1974),
    [anon_sym_PLUS_PLUS] = ACTIONS(1974),
    [anon_sym_sizeof] = ACTIONS(1972),
    [anon_sym___alignof__] = ACTIONS(1972),
    [anon_sym___alignof] = ACTIONS(1972),
    [anon_sym__alignof] = ACTIONS(1972),
    [anon_sym_alignof] = ACTIONS(1972),
    [anon_sym__Alignof] = ACTIONS(1972),
    [anon_sym_offsetof] = ACTIONS(1972),
    [anon_sym__Generic] = ACTIONS(1972),
    [anon_sym_asm] = ACTIONS(1972),
    [anon_sym___asm__] = ACTIONS(1972),
    [sym_number_literal] = ACTIONS(1974),
    [anon_sym_L_SQUOTE] = ACTIONS(1974),
    [anon_sym_u_SQUOTE] = ACTIONS(1974),
    [anon_sym_U_SQUOTE] = ACTIONS(1974),
    [anon_sym_u8_SQUOTE] = ACTIONS(1974),
    [anon_sym_SQUOTE] = ACTIONS(1974),
    [anon_sym_L_DQUOTE] = ACTIONS(1974),
    [anon_sym_u_DQUOTE] = ACTIONS(1974),
    [anon_sym_U_DQUOTE] = ACTIONS(1974),
    [anon_sym_u8_DQUOTE] = ACTIONS(1974),
    [anon_sym_DQUOTE] = ACTIONS(1974),
    [sym_true] = ACTIONS(1972),
    [sym_false] = ACTIONS(1972),
    [anon_sym_NULL] = ACTIONS(1972),
    [anon_sym_nullptr] = ACTIONS(1972),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1972),
    [anon_sym_decltype] = ACTIONS(1972),
    [sym_virtual] = ACTIONS(1972),
    [anon_sym_typename] = ACTIONS(1972),
    [anon_sym_template] = ACTIONS(1972),
    [anon_sym_try] = ACTIONS(1972),
    [anon_sym_delete] = ACTIONS(1972),
    [anon_sym_throw] = ACTIONS(1972),
    [anon_sym_co_return] = ACTIONS(1972),
    [anon_sym_co_yield] = ACTIONS(1972),
    [anon_sym_R_DQUOTE] = ACTIONS(1974),
    [anon_sym_LR_DQUOTE] = ACTIONS(1974),
    [anon_sym_uR_DQUOTE] = ACTIONS(1974),
    [anon_sym_UR_DQUOTE] = ACTIONS(1974),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1974),
    [anon_sym_co_await] = ACTIONS(1972),
    [anon_sym_new] = ACTIONS(1972),
    [anon_sym_requires] = ACTIONS(1972),
    [sym_this] = ACTIONS(1972),
    [anon_sym___launch_bounds__] = ACTIONS(1972),
  },
  [852] = {
    [sym_identifier] = ACTIONS(1984),
    [anon_sym_LPAREN2] = ACTIONS(1986),
    [anon_sym_BANG] = ACTIONS(1986),
    [anon_sym_TILDE] = ACTIONS(1986),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_AMP] = ACTIONS(1986),
    [anon_sym_SEMI] = ACTIONS(1986),
    [anon_sym___extension__] = ACTIONS(1984),
    [anon_sym_typedef] = ACTIONS(1984),
    [anon_sym___device__] = ACTIONS(1984),
    [anon_sym___host__] = ACTIONS(1984),
    [anon_sym___global__] = ACTIONS(1984),
    [anon_sym___forceinline__] = ACTIONS(1984),
    [anon_sym___noinline__] = ACTIONS(1984),
    [anon_sym_extern] = ACTIONS(1984),
    [anon_sym___attribute__] = ACTIONS(1984),
    [anon_sym_COLON_COLON] = ACTIONS(1986),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1986),
    [anon_sym___declspec] = ACTIONS(1984),
    [anon_sym_LBRACE] = ACTIONS(1986),
    [anon_sym_signed] = ACTIONS(1984),
    [anon_sym_unsigned] = ACTIONS(1984),
    [anon_sym_long] = ACTIONS(1984),
    [anon_sym_short] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_static] = ACTIONS(1984),
    [anon_sym_register] = ACTIONS(1984),
    [anon_sym_inline] = ACTIONS(1984),
    [anon_sym___inline] = ACTIONS(1984),
    [anon_sym___inline__] = ACTIONS(1984),
    [anon_sym___forceinline] = ACTIONS(1984),
    [anon_sym_thread_local] = ACTIONS(1984),
    [anon_sym___thread] = ACTIONS(1984),
    [anon_sym_const] = ACTIONS(1984),
    [anon_sym_constexpr] = ACTIONS(1984),
    [anon_sym_volatile] = ACTIONS(1984),
    [anon_sym_restrict] = ACTIONS(1984),
    [anon_sym___restrict__] = ACTIONS(1984),
    [anon_sym__Atomic] = ACTIONS(1984),
    [anon_sym__Noreturn] = ACTIONS(1984),
    [anon_sym_noreturn] = ACTIONS(1984),
    [anon_sym_mutable] = ACTIONS(1984),
    [anon_sym_constinit] = ACTIONS(1984),
    [anon_sym_consteval] = ACTIONS(1984),
    [anon_sym___shared__] = ACTIONS(1984),
    [anon_sym___local__] = ACTIONS(1984),
    [anon_sym___constant__] = ACTIONS(1984),
    [anon_sym___managed__] = ACTIONS(1984),
    [anon_sym___grid_constant__] = ACTIONS(1984),
    [anon_sym_alignas] = ACTIONS(1984),
    [anon_sym__Alignas] = ACTIONS(1984),
    [sym_primitive_type] = ACTIONS(1984),
    [anon_sym_enum] = ACTIONS(1984),
    [anon_sym_class] = ACTIONS(1984),
    [anon_sym_struct] = ACTIONS(1984),
    [anon_sym_union] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_else] = ACTIONS(1984),
    [anon_sym_switch] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1984),
    [anon_sym_do] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_return] = ACTIONS(1984),
    [anon_sym_break] = ACTIONS(1984),
    [anon_sym_continue] = ACTIONS(1984),
    [anon_sym_goto] = ACTIONS(1984),
    [anon_sym___try] = ACTIONS(1984),
    [anon_sym___leave] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_compl] = ACTIONS(1984),
    [anon_sym_DASH_DASH] = ACTIONS(1986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1986),
    [anon_sym_sizeof] = ACTIONS(1984),
    [anon_sym___alignof__] = ACTIONS(1984),
    [anon_sym___alignof] = ACTIONS(1984),
    [anon_sym__alignof] = ACTIONS(1984),
    [anon_sym_alignof] = ACTIONS(1984),
    [anon_sym__Alignof] = ACTIONS(1984),
    [anon_sym_offsetof] = ACTIONS(1984),
    [anon_sym__Generic] = ACTIONS(1984),
    [anon_sym_asm] = ACTIONS(1984),
    [anon_sym___asm__] = ACTIONS(1984),
    [sym_number_literal] = ACTIONS(1986),
    [anon_sym_L_SQUOTE] = ACTIONS(1986),
    [anon_sym_u_SQUOTE] = ACTIONS(1986),
    [anon_sym_U_SQUOTE] = ACTIONS(1986),
    [anon_sym_u8_SQUOTE] = ACTIONS(1986),
    [anon_sym_SQUOTE] = ACTIONS(1986),
    [anon_sym_L_DQUOTE] = ACTIONS(1986),
    [anon_sym_u_DQUOTE] = ACTIONS(1986),
    [anon_sym_U_DQUOTE] = ACTIONS(1986),
    [anon_sym_u8_DQUOTE] = ACTIONS(1986),
    [anon_sym_DQUOTE] = ACTIONS(1986),
    [sym_true] = ACTIONS(1984),
    [sym_false] = ACTIONS(1984),
    [anon_sym_NULL] = ACTIONS(1984),
    [anon_sym_nullptr] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1984),
    [anon_sym_decltype] = ACTIONS(1984),
    [sym_virtual] = ACTIONS(1984),
    [anon_sym_typename] = ACTIONS(1984),
    [anon_sym_template] = ACTIONS(1984),
    [anon_sym_try] = ACTIONS(1984),
    [anon_sym_delete] = ACTIONS(1984),
    [anon_sym_throw] = ACTIONS(1984),
    [anon_sym_co_return] = ACTIONS(1984),
    [anon_sym_co_yield] = ACTIONS(1984),
    [anon_sym_R_DQUOTE] = ACTIONS(1986),
    [anon_sym_LR_DQUOTE] = ACTIONS(1986),
    [anon_sym_uR_DQUOTE] = ACTIONS(1986),
    [anon_sym_UR_DQUOTE] = ACTIONS(1986),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1986),
    [anon_sym_co_await] = ACTIONS(1984),
    [anon_sym_new] = ACTIONS(1984),
    [anon_sym_requires] = ACTIONS(1984),
    [sym_this] = ACTIONS(1984),
    [anon_sym___launch_bounds__] = ACTIONS(1984),
  },
  [853] = {
    [sym_identifier] = ACTIONS(1954),
    [anon_sym_LPAREN2] = ACTIONS(1956),
    [anon_sym_BANG] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [anon_sym_DASH] = ACTIONS(1954),
    [anon_sym_PLUS] = ACTIONS(1954),
    [anon_sym_STAR] = ACTIONS(1956),
    [anon_sym_AMP] = ACTIONS(1956),
    [anon_sym_SEMI] = ACTIONS(1956),
    [anon_sym___extension__] = ACTIONS(1954),
    [anon_sym_typedef] = ACTIONS(1954),
    [anon_sym___device__] = ACTIONS(1954),
    [anon_sym___host__] = ACTIONS(1954),
    [anon_sym___global__] = ACTIONS(1954),
    [anon_sym___forceinline__] = ACTIONS(1954),
    [anon_sym___noinline__] = ACTIONS(1954),
    [anon_sym_extern] = ACTIONS(1954),
    [anon_sym___attribute__] = ACTIONS(1954),
    [anon_sym_COLON_COLON] = ACTIONS(1956),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1956),
    [anon_sym___declspec] = ACTIONS(1954),
    [anon_sym_LBRACE] = ACTIONS(1956),
    [anon_sym_signed] = ACTIONS(1954),
    [anon_sym_unsigned] = ACTIONS(1954),
    [anon_sym_long] = ACTIONS(1954),
    [anon_sym_short] = ACTIONS(1954),
    [anon_sym_LBRACK] = ACTIONS(1954),
    [anon_sym_static] = ACTIONS(1954),
    [anon_sym_register] = ACTIONS(1954),
    [anon_sym_inline] = ACTIONS(1954),
    [anon_sym___inline] = ACTIONS(1954),
    [anon_sym___inline__] = ACTIONS(1954),
    [anon_sym___forceinline] = ACTIONS(1954),
    [anon_sym_thread_local] = ACTIONS(1954),
    [anon_sym___thread] = ACTIONS(1954),
    [anon_sym_const] = ACTIONS(1954),
    [anon_sym_constexpr] = ACTIONS(1954),
    [anon_sym_volatile] = ACTIONS(1954),
    [anon_sym_restrict] = ACTIONS(1954),
    [anon_sym___restrict__] = ACTIONS(1954),
    [anon_sym__Atomic] = ACTIONS(1954),
    [anon_sym__Noreturn] = ACTIONS(1954),
    [anon_sym_noreturn] = ACTIONS(1954),
    [anon_sym_mutable] = ACTIONS(1954),
    [anon_sym_constinit] = ACTIONS(1954),
    [anon_sym_consteval] = ACTIONS(1954),
    [anon_sym___shared__] = ACTIONS(1954),
    [anon_sym___local__] = ACTIONS(1954),
    [anon_sym___constant__] = ACTIONS(1954),
    [anon_sym___managed__] = ACTIONS(1954),
    [anon_sym___grid_constant__] = ACTIONS(1954),
    [anon_sym_alignas] = ACTIONS(1954),
    [anon_sym__Alignas] = ACTIONS(1954),
    [sym_primitive_type] = ACTIONS(1954),
    [anon_sym_enum] = ACTIONS(1954),
    [anon_sym_class] = ACTIONS(1954),
    [anon_sym_struct] = ACTIONS(1954),
    [anon_sym_union] = ACTIONS(1954),
    [anon_sym_if] = ACTIONS(1954),
    [anon_sym_else] = ACTIONS(1954),
    [anon_sym_switch] = ACTIONS(1954),
    [anon_sym_while] = ACTIONS(1954),
    [anon_sym_do] = ACTIONS(1954),
    [anon_sym_for] = ACTIONS(1954),
    [anon_sym_return] = ACTIONS(1954),
    [anon_sym_break] = ACTIONS(1954),
    [anon_sym_continue] = ACTIONS(1954),
    [anon_sym_goto] = ACTIONS(1954),
    [anon_sym___try] = ACTIONS(1954),
    [anon_sym___leave] = ACTIONS(1954),
    [anon_sym_not] = ACTIONS(1954),
    [anon_sym_compl] = ACTIONS(1954),
    [anon_sym_DASH_DASH] = ACTIONS(1956),
    [anon_sym_PLUS_PLUS] = ACTIONS(1956),
    [anon_sym_sizeof] = ACTIONS(1954),
    [anon_sym___alignof__] = ACTIONS(1954),
    [anon_sym___alignof] = ACTIONS(1954),
    [anon_sym__alignof] = ACTIONS(1954),
    [anon_sym_alignof] = ACTIONS(1954),
    [anon_sym__Alignof] = ACTIONS(1954),
    [anon_sym_offsetof] = ACTIONS(1954),
    [anon_sym__Generic] = ACTIONS(1954),
    [anon_sym_asm] = ACTIONS(1954),
    [anon_sym___asm__] = ACTIONS(1954),
    [sym_number_literal] = ACTIONS(1956),
    [anon_sym_L_SQUOTE] = ACTIONS(1956),
    [anon_sym_u_SQUOTE] = ACTIONS(1956),
    [anon_sym_U_SQUOTE] = ACTIONS(1956),
    [anon_sym_u8_SQUOTE] = ACTIONS(1956),
    [anon_sym_SQUOTE] = ACTIONS(1956),
    [anon_sym_L_DQUOTE] = ACTIONS(1956),
    [anon_sym_u_DQUOTE] = ACTIONS(1956),
    [anon_sym_U_DQUOTE] = ACTIONS(1956),
    [anon_sym_u8_DQUOTE] = ACTIONS(1956),
    [anon_sym_DQUOTE] = ACTIONS(1956),
    [sym_true] = ACTIONS(1954),
    [sym_false] = ACTIONS(1954),
    [anon_sym_NULL] = ACTIONS(1954),
    [anon_sym_nullptr] = ACTIONS(1954),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1954),
    [anon_sym_decltype] = ACTIONS(1954),
    [sym_virtual] = ACTIONS(1954),
    [anon_sym_typename] = ACTIONS(1954),
    [anon_sym_template] = ACTIONS(1954),
    [anon_sym_try] = ACTIONS(1954),
    [anon_sym_delete] = ACTIONS(1954),
    [anon_sym_throw] = ACTIONS(1954),
    [anon_sym_co_return] = ACTIONS(1954),
    [anon_sym_co_yield] = ACTIONS(1954),
    [anon_sym_R_DQUOTE] = ACTIONS(1956),
    [anon_sym_LR_DQUOTE] = ACTIONS(1956),
    [anon_sym_uR_DQUOTE] = ACTIONS(1956),
    [anon_sym_UR_DQUOTE] = ACTIONS(1956),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1956),
    [anon_sym_co_await] = ACTIONS(1954),
    [anon_sym_new] = ACTIONS(1954),
    [anon_sym_requires] = ACTIONS(1954),
    [sym_this] = ACTIONS(1954),
    [anon_sym___launch_bounds__] = ACTIONS(1954),
  },
  [854] = {
    [sym_identifier] = ACTIONS(1942),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(1944),
    [anon_sym_TILDE] = ACTIONS(1944),
    [anon_sym_DASH] = ACTIONS(1942),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1944),
    [anon_sym_SEMI] = ACTIONS(1944),
    [anon_sym___extension__] = ACTIONS(1942),
    [anon_sym_typedef] = ACTIONS(1942),
    [anon_sym___device__] = ACTIONS(1942),
    [anon_sym___host__] = ACTIONS(1942),
    [anon_sym___global__] = ACTIONS(1942),
    [anon_sym___forceinline__] = ACTIONS(1942),
    [anon_sym___noinline__] = ACTIONS(1942),
    [anon_sym_extern] = ACTIONS(1942),
    [anon_sym___attribute__] = ACTIONS(1942),
    [anon_sym_COLON_COLON] = ACTIONS(1944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1944),
    [anon_sym___declspec] = ACTIONS(1942),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_signed] = ACTIONS(1942),
    [anon_sym_unsigned] = ACTIONS(1942),
    [anon_sym_long] = ACTIONS(1942),
    [anon_sym_short] = ACTIONS(1942),
    [anon_sym_LBRACK] = ACTIONS(1942),
    [anon_sym_static] = ACTIONS(1942),
    [anon_sym_register] = ACTIONS(1942),
    [anon_sym_inline] = ACTIONS(1942),
    [anon_sym___inline] = ACTIONS(1942),
    [anon_sym___inline__] = ACTIONS(1942),
    [anon_sym___forceinline] = ACTIONS(1942),
    [anon_sym_thread_local] = ACTIONS(1942),
    [anon_sym___thread] = ACTIONS(1942),
    [anon_sym_const] = ACTIONS(1942),
    [anon_sym_constexpr] = ACTIONS(1942),
    [anon_sym_volatile] = ACTIONS(1942),
    [anon_sym_restrict] = ACTIONS(1942),
    [anon_sym___restrict__] = ACTIONS(1942),
    [anon_sym__Atomic] = ACTIONS(1942),
    [anon_sym__Noreturn] = ACTIONS(1942),
    [anon_sym_noreturn] = ACTIONS(1942),
    [anon_sym_mutable] = ACTIONS(1942),
    [anon_sym_constinit] = ACTIONS(1942),
    [anon_sym_consteval] = ACTIONS(1942),
    [anon_sym___shared__] = ACTIONS(1942),
    [anon_sym___local__] = ACTIONS(1942),
    [anon_sym___constant__] = ACTIONS(1942),
    [anon_sym___managed__] = ACTIONS(1942),
    [anon_sym___grid_constant__] = ACTIONS(1942),
    [anon_sym_alignas] = ACTIONS(1942),
    [anon_sym__Alignas] = ACTIONS(1942),
    [sym_primitive_type] = ACTIONS(1942),
    [anon_sym_enum] = ACTIONS(1942),
    [anon_sym_class] = ACTIONS(1942),
    [anon_sym_struct] = ACTIONS(1942),
    [anon_sym_union] = ACTIONS(1942),
    [anon_sym_if] = ACTIONS(1942),
    [anon_sym_else] = ACTIONS(1942),
    [anon_sym_switch] = ACTIONS(1942),
    [anon_sym_while] = ACTIONS(1942),
    [anon_sym_do] = ACTIONS(1942),
    [anon_sym_for] = ACTIONS(1942),
    [anon_sym_return] = ACTIONS(1942),
    [anon_sym_break] = ACTIONS(1942),
    [anon_sym_continue] = ACTIONS(1942),
    [anon_sym_goto] = ACTIONS(1942),
    [anon_sym___try] = ACTIONS(1942),
    [anon_sym___leave] = ACTIONS(1942),
    [anon_sym_not] = ACTIONS(1942),
    [anon_sym_compl] = ACTIONS(1942),
    [anon_sym_DASH_DASH] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1944),
    [anon_sym_sizeof] = ACTIONS(1942),
    [anon_sym___alignof__] = ACTIONS(1942),
    [anon_sym___alignof] = ACTIONS(1942),
    [anon_sym__alignof] = ACTIONS(1942),
    [anon_sym_alignof] = ACTIONS(1942),
    [anon_sym__Alignof] = ACTIONS(1942),
    [anon_sym_offsetof] = ACTIONS(1942),
    [anon_sym__Generic] = ACTIONS(1942),
    [anon_sym_asm] = ACTIONS(1942),
    [anon_sym___asm__] = ACTIONS(1942),
    [sym_number_literal] = ACTIONS(1944),
    [anon_sym_L_SQUOTE] = ACTIONS(1944),
    [anon_sym_u_SQUOTE] = ACTIONS(1944),
    [anon_sym_U_SQUOTE] = ACTIONS(1944),
    [anon_sym_u8_SQUOTE] = ACTIONS(1944),
    [anon_sym_SQUOTE] = ACTIONS(1944),
    [anon_sym_L_DQUOTE] = ACTIONS(1944),
    [anon_sym_u_DQUOTE] = ACTIONS(1944),
    [anon_sym_U_DQUOTE] = ACTIONS(1944),
    [anon_sym_u8_DQUOTE] = ACTIONS(1944),
    [anon_sym_DQUOTE] = ACTIONS(1944),
    [sym_true] = ACTIONS(1942),
    [sym_false] = ACTIONS(1942),
    [anon_sym_NULL] = ACTIONS(1942),
    [anon_sym_nullptr] = ACTIONS(1942),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1942),
    [anon_sym_decltype] = ACTIONS(1942),
    [sym_virtual] = ACTIONS(1942),
    [anon_sym_typename] = ACTIONS(1942),
    [anon_sym_template] = ACTIONS(1942),
    [anon_sym_try] = ACTIONS(1942),
    [anon_sym_delete] = ACTIONS(1942),
    [anon_sym_throw] = ACTIONS(1942),
    [anon_sym_co_return] = ACTIONS(1942),
    [anon_sym_co_yield] = ACTIONS(1942),
    [anon_sym_R_DQUOTE] = ACTIONS(1944),
    [anon_sym_LR_DQUOTE] = ACTIONS(1944),
    [anon_sym_uR_DQUOTE] = ACTIONS(1944),
    [anon_sym_UR_DQUOTE] = ACTIONS(1944),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1944),
    [anon_sym_co_await] = ACTIONS(1942),
    [anon_sym_new] = ACTIONS(1942),
    [anon_sym_requires] = ACTIONS(1942),
    [sym_this] = ACTIONS(1942),
    [anon_sym___launch_bounds__] = ACTIONS(1942),
  },
  [855] = {
    [sym_identifier] = ACTIONS(2004),
    [anon_sym_LPAREN2] = ACTIONS(2006),
    [anon_sym_BANG] = ACTIONS(2006),
    [anon_sym_TILDE] = ACTIONS(2006),
    [anon_sym_DASH] = ACTIONS(2004),
    [anon_sym_PLUS] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(2006),
    [anon_sym_AMP] = ACTIONS(2006),
    [anon_sym_SEMI] = ACTIONS(2006),
    [anon_sym___extension__] = ACTIONS(2004),
    [anon_sym_typedef] = ACTIONS(2004),
    [anon_sym___device__] = ACTIONS(2004),
    [anon_sym___host__] = ACTIONS(2004),
    [anon_sym___global__] = ACTIONS(2004),
    [anon_sym___forceinline__] = ACTIONS(2004),
    [anon_sym___noinline__] = ACTIONS(2004),
    [anon_sym_extern] = ACTIONS(2004),
    [anon_sym___attribute__] = ACTIONS(2004),
    [anon_sym_COLON_COLON] = ACTIONS(2006),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2006),
    [anon_sym___declspec] = ACTIONS(2004),
    [anon_sym_LBRACE] = ACTIONS(2006),
    [anon_sym_signed] = ACTIONS(2004),
    [anon_sym_unsigned] = ACTIONS(2004),
    [anon_sym_long] = ACTIONS(2004),
    [anon_sym_short] = ACTIONS(2004),
    [anon_sym_LBRACK] = ACTIONS(2004),
    [anon_sym_static] = ACTIONS(2004),
    [anon_sym_register] = ACTIONS(2004),
    [anon_sym_inline] = ACTIONS(2004),
    [anon_sym___inline] = ACTIONS(2004),
    [anon_sym___inline__] = ACTIONS(2004),
    [anon_sym___forceinline] = ACTIONS(2004),
    [anon_sym_thread_local] = ACTIONS(2004),
    [anon_sym___thread] = ACTIONS(2004),
    [anon_sym_const] = ACTIONS(2004),
    [anon_sym_constexpr] = ACTIONS(2004),
    [anon_sym_volatile] = ACTIONS(2004),
    [anon_sym_restrict] = ACTIONS(2004),
    [anon_sym___restrict__] = ACTIONS(2004),
    [anon_sym__Atomic] = ACTIONS(2004),
    [anon_sym__Noreturn] = ACTIONS(2004),
    [anon_sym_noreturn] = ACTIONS(2004),
    [anon_sym_mutable] = ACTIONS(2004),
    [anon_sym_constinit] = ACTIONS(2004),
    [anon_sym_consteval] = ACTIONS(2004),
    [anon_sym___shared__] = ACTIONS(2004),
    [anon_sym___local__] = ACTIONS(2004),
    [anon_sym___constant__] = ACTIONS(2004),
    [anon_sym___managed__] = ACTIONS(2004),
    [anon_sym___grid_constant__] = ACTIONS(2004),
    [anon_sym_alignas] = ACTIONS(2004),
    [anon_sym__Alignas] = ACTIONS(2004),
    [sym_primitive_type] = ACTIONS(2004),
    [anon_sym_enum] = ACTIONS(2004),
    [anon_sym_class] = ACTIONS(2004),
    [anon_sym_struct] = ACTIONS(2004),
    [anon_sym_union] = ACTIONS(2004),
    [anon_sym_if] = ACTIONS(2004),
    [anon_sym_else] = ACTIONS(2004),
    [anon_sym_switch] = ACTIONS(2004),
    [anon_sym_while] = ACTIONS(2004),
    [anon_sym_do] = ACTIONS(2004),
    [anon_sym_for] = ACTIONS(2004),
    [anon_sym_return] = ACTIONS(2004),
    [anon_sym_break] = ACTIONS(2004),
    [anon_sym_continue] = ACTIONS(2004),
    [anon_sym_goto] = ACTIONS(2004),
    [anon_sym___try] = ACTIONS(2004),
    [anon_sym___leave] = ACTIONS(2004),
    [anon_sym_not] = ACTIONS(2004),
    [anon_sym_compl] = ACTIONS(2004),
    [anon_sym_DASH_DASH] = ACTIONS(2006),
    [anon_sym_PLUS_PLUS] = ACTIONS(2006),
    [anon_sym_sizeof] = ACTIONS(2004),
    [anon_sym___alignof__] = ACTIONS(2004),
    [anon_sym___alignof] = ACTIONS(2004),
    [anon_sym__alignof] = ACTIONS(2004),
    [anon_sym_alignof] = ACTIONS(2004),
    [anon_sym__Alignof] = ACTIONS(2004),
    [anon_sym_offsetof] = ACTIONS(2004),
    [anon_sym__Generic] = ACTIONS(2004),
    [anon_sym_asm] = ACTIONS(2004),
    [anon_sym___asm__] = ACTIONS(2004),
    [sym_number_literal] = ACTIONS(2006),
    [anon_sym_L_SQUOTE] = ACTIONS(2006),
    [anon_sym_u_SQUOTE] = ACTIONS(2006),
    [anon_sym_U_SQUOTE] = ACTIONS(2006),
    [anon_sym_u8_SQUOTE] = ACTIONS(2006),
    [anon_sym_SQUOTE] = ACTIONS(2006),
    [anon_sym_L_DQUOTE] = ACTIONS(2006),
    [anon_sym_u_DQUOTE] = ACTIONS(2006),
    [anon_sym_U_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8_DQUOTE] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [sym_true] = ACTIONS(2004),
    [sym_false] = ACTIONS(2004),
    [anon_sym_NULL] = ACTIONS(2004),
    [anon_sym_nullptr] = ACTIONS(2004),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2004),
    [anon_sym_decltype] = ACTIONS(2004),
    [sym_virtual] = ACTIONS(2004),
    [anon_sym_typename] = ACTIONS(2004),
    [anon_sym_template] = ACTIONS(2004),
    [anon_sym_try] = ACTIONS(2004),
    [anon_sym_delete] = ACTIONS(2004),
    [anon_sym_throw] = ACTIONS(2004),
    [anon_sym_co_return] = ACTIONS(2004),
    [anon_sym_co_yield] = ACTIONS(2004),
    [anon_sym_R_DQUOTE] = ACTIONS(2006),
    [anon_sym_LR_DQUOTE] = ACTIONS(2006),
    [anon_sym_uR_DQUOTE] = ACTIONS(2006),
    [anon_sym_UR_DQUOTE] = ACTIONS(2006),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2006),
    [anon_sym_co_await] = ACTIONS(2004),
    [anon_sym_new] = ACTIONS(2004),
    [anon_sym_requires] = ACTIONS(2004),
    [sym_this] = ACTIONS(2004),
    [anon_sym___launch_bounds__] = ACTIONS(2004),
  },
  [856] = {
    [sym_identifier] = ACTIONS(2008),
    [anon_sym_LPAREN2] = ACTIONS(2010),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_TILDE] = ACTIONS(2010),
    [anon_sym_DASH] = ACTIONS(2008),
    [anon_sym_PLUS] = ACTIONS(2008),
    [anon_sym_STAR] = ACTIONS(2010),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_SEMI] = ACTIONS(2010),
    [anon_sym___extension__] = ACTIONS(2008),
    [anon_sym_typedef] = ACTIONS(2008),
    [anon_sym___device__] = ACTIONS(2008),
    [anon_sym___host__] = ACTIONS(2008),
    [anon_sym___global__] = ACTIONS(2008),
    [anon_sym___forceinline__] = ACTIONS(2008),
    [anon_sym___noinline__] = ACTIONS(2008),
    [anon_sym_extern] = ACTIONS(2008),
    [anon_sym___attribute__] = ACTIONS(2008),
    [anon_sym_COLON_COLON] = ACTIONS(2010),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2010),
    [anon_sym___declspec] = ACTIONS(2008),
    [anon_sym_LBRACE] = ACTIONS(2010),
    [anon_sym_signed] = ACTIONS(2008),
    [anon_sym_unsigned] = ACTIONS(2008),
    [anon_sym_long] = ACTIONS(2008),
    [anon_sym_short] = ACTIONS(2008),
    [anon_sym_LBRACK] = ACTIONS(2008),
    [anon_sym_static] = ACTIONS(2008),
    [anon_sym_register] = ACTIONS(2008),
    [anon_sym_inline] = ACTIONS(2008),
    [anon_sym___inline] = ACTIONS(2008),
    [anon_sym___inline__] = ACTIONS(2008),
    [anon_sym___forceinline] = ACTIONS(2008),
    [anon_sym_thread_local] = ACTIONS(2008),
    [anon_sym___thread] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(2008),
    [anon_sym_constexpr] = ACTIONS(2008),
    [anon_sym_volatile] = ACTIONS(2008),
    [anon_sym_restrict] = ACTIONS(2008),
    [anon_sym___restrict__] = ACTIONS(2008),
    [anon_sym__Atomic] = ACTIONS(2008),
    [anon_sym__Noreturn] = ACTIONS(2008),
    [anon_sym_noreturn] = ACTIONS(2008),
    [anon_sym_mutable] = ACTIONS(2008),
    [anon_sym_constinit] = ACTIONS(2008),
    [anon_sym_consteval] = ACTIONS(2008),
    [anon_sym___shared__] = ACTIONS(2008),
    [anon_sym___local__] = ACTIONS(2008),
    [anon_sym___constant__] = ACTIONS(2008),
    [anon_sym___managed__] = ACTIONS(2008),
    [anon_sym___grid_constant__] = ACTIONS(2008),
    [anon_sym_alignas] = ACTIONS(2008),
    [anon_sym__Alignas] = ACTIONS(2008),
    [sym_primitive_type] = ACTIONS(2008),
    [anon_sym_enum] = ACTIONS(2008),
    [anon_sym_class] = ACTIONS(2008),
    [anon_sym_struct] = ACTIONS(2008),
    [anon_sym_union] = ACTIONS(2008),
    [anon_sym_if] = ACTIONS(2008),
    [anon_sym_else] = ACTIONS(2008),
    [anon_sym_switch] = ACTIONS(2008),
    [anon_sym_while] = ACTIONS(2008),
    [anon_sym_do] = ACTIONS(2008),
    [anon_sym_for] = ACTIONS(2008),
    [anon_sym_return] = ACTIONS(2008),
    [anon_sym_break] = ACTIONS(2008),
    [anon_sym_continue] = ACTIONS(2008),
    [anon_sym_goto] = ACTIONS(2008),
    [anon_sym___try] = ACTIONS(2008),
    [anon_sym___leave] = ACTIONS(2008),
    [anon_sym_not] = ACTIONS(2008),
    [anon_sym_compl] = ACTIONS(2008),
    [anon_sym_DASH_DASH] = ACTIONS(2010),
    [anon_sym_PLUS_PLUS] = ACTIONS(2010),
    [anon_sym_sizeof] = ACTIONS(2008),
    [anon_sym___alignof__] = ACTIONS(2008),
    [anon_sym___alignof] = ACTIONS(2008),
    [anon_sym__alignof] = ACTIONS(2008),
    [anon_sym_alignof] = ACTIONS(2008),
    [anon_sym__Alignof] = ACTIONS(2008),
    [anon_sym_offsetof] = ACTIONS(2008),
    [anon_sym__Generic] = ACTIONS(2008),
    [anon_sym_asm] = ACTIONS(2008),
    [anon_sym___asm__] = ACTIONS(2008),
    [sym_number_literal] = ACTIONS(2010),
    [anon_sym_L_SQUOTE] = ACTIONS(2010),
    [anon_sym_u_SQUOTE] = ACTIONS(2010),
    [anon_sym_U_SQUOTE] = ACTIONS(2010),
    [anon_sym_u8_SQUOTE] = ACTIONS(2010),
    [anon_sym_SQUOTE] = ACTIONS(2010),
    [anon_sym_L_DQUOTE] = ACTIONS(2010),
    [anon_sym_u_DQUOTE] = ACTIONS(2010),
    [anon_sym_U_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8_DQUOTE] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [sym_true] = ACTIONS(2008),
    [sym_false] = ACTIONS(2008),
    [anon_sym_NULL] = ACTIONS(2008),
    [anon_sym_nullptr] = ACTIONS(2008),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2008),
    [anon_sym_decltype] = ACTIONS(2008),
    [sym_virtual] = ACTIONS(2008),
    [anon_sym_typename] = ACTIONS(2008),
    [anon_sym_template] = ACTIONS(2008),
    [anon_sym_try] = ACTIONS(2008),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_throw] = ACTIONS(2008),
    [anon_sym_co_return] = ACTIONS(2008),
    [anon_sym_co_yield] = ACTIONS(2008),
    [anon_sym_R_DQUOTE] = ACTIONS(2010),
    [anon_sym_LR_DQUOTE] = ACTIONS(2010),
    [anon_sym_uR_DQUOTE] = ACTIONS(2010),
    [anon_sym_UR_DQUOTE] = ACTIONS(2010),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2010),
    [anon_sym_co_await] = ACTIONS(2008),
    [anon_sym_new] = ACTIONS(2008),
    [anon_sym_requires] = ACTIONS(2008),
    [sym_this] = ACTIONS(2008),
    [anon_sym___launch_bounds__] = ACTIONS(2008),
  },
  [857] = {
    [sym_identifier] = ACTIONS(1942),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_BANG] = ACTIONS(1944),
    [anon_sym_TILDE] = ACTIONS(1944),
    [anon_sym_DASH] = ACTIONS(1942),
    [anon_sym_PLUS] = ACTIONS(1942),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1944),
    [anon_sym_SEMI] = ACTIONS(1944),
    [anon_sym___extension__] = ACTIONS(1942),
    [anon_sym_typedef] = ACTIONS(1942),
    [anon_sym___device__] = ACTIONS(1942),
    [anon_sym___host__] = ACTIONS(1942),
    [anon_sym___global__] = ACTIONS(1942),
    [anon_sym___forceinline__] = ACTIONS(1942),
    [anon_sym___noinline__] = ACTIONS(1942),
    [anon_sym_extern] = ACTIONS(1942),
    [anon_sym___attribute__] = ACTIONS(1942),
    [anon_sym_COLON_COLON] = ACTIONS(1944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1944),
    [anon_sym___declspec] = ACTIONS(1942),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_signed] = ACTIONS(1942),
    [anon_sym_unsigned] = ACTIONS(1942),
    [anon_sym_long] = ACTIONS(1942),
    [anon_sym_short] = ACTIONS(1942),
    [anon_sym_LBRACK] = ACTIONS(1942),
    [anon_sym_static] = ACTIONS(1942),
    [anon_sym_register] = ACTIONS(1942),
    [anon_sym_inline] = ACTIONS(1942),
    [anon_sym___inline] = ACTIONS(1942),
    [anon_sym___inline__] = ACTIONS(1942),
    [anon_sym___forceinline] = ACTIONS(1942),
    [anon_sym_thread_local] = ACTIONS(1942),
    [anon_sym___thread] = ACTIONS(1942),
    [anon_sym_const] = ACTIONS(1942),
    [anon_sym_constexpr] = ACTIONS(1942),
    [anon_sym_volatile] = ACTIONS(1942),
    [anon_sym_restrict] = ACTIONS(1942),
    [anon_sym___restrict__] = ACTIONS(1942),
    [anon_sym__Atomic] = ACTIONS(1942),
    [anon_sym__Noreturn] = ACTIONS(1942),
    [anon_sym_noreturn] = ACTIONS(1942),
    [anon_sym_mutable] = ACTIONS(1942),
    [anon_sym_constinit] = ACTIONS(1942),
    [anon_sym_consteval] = ACTIONS(1942),
    [anon_sym___shared__] = ACTIONS(1942),
    [anon_sym___local__] = ACTIONS(1942),
    [anon_sym___constant__] = ACTIONS(1942),
    [anon_sym___managed__] = ACTIONS(1942),
    [anon_sym___grid_constant__] = ACTIONS(1942),
    [anon_sym_alignas] = ACTIONS(1942),
    [anon_sym__Alignas] = ACTIONS(1942),
    [sym_primitive_type] = ACTIONS(1942),
    [anon_sym_enum] = ACTIONS(1942),
    [anon_sym_class] = ACTIONS(1942),
    [anon_sym_struct] = ACTIONS(1942),
    [anon_sym_union] = ACTIONS(1942),
    [anon_sym_if] = ACTIONS(1942),
    [anon_sym_else] = ACTIONS(1942),
    [anon_sym_switch] = ACTIONS(1942),
    [anon_sym_while] = ACTIONS(1942),
    [anon_sym_do] = ACTIONS(1942),
    [anon_sym_for] = ACTIONS(1942),
    [anon_sym_return] = ACTIONS(1942),
    [anon_sym_break] = ACTIONS(1942),
    [anon_sym_continue] = ACTIONS(1942),
    [anon_sym_goto] = ACTIONS(1942),
    [anon_sym___try] = ACTIONS(1942),
    [anon_sym___leave] = ACTIONS(1942),
    [anon_sym_not] = ACTIONS(1942),
    [anon_sym_compl] = ACTIONS(1942),
    [anon_sym_DASH_DASH] = ACTIONS(1944),
    [anon_sym_PLUS_PLUS] = ACTIONS(1944),
    [anon_sym_sizeof] = ACTIONS(1942),
    [anon_sym___alignof__] = ACTIONS(1942),
    [anon_sym___alignof] = ACTIONS(1942),
    [anon_sym__alignof] = ACTIONS(1942),
    [anon_sym_alignof] = ACTIONS(1942),
    [anon_sym__Alignof] = ACTIONS(1942),
    [anon_sym_offsetof] = ACTIONS(1942),
    [anon_sym__Generic] = ACTIONS(1942),
    [anon_sym_asm] = ACTIONS(1942),
    [anon_sym___asm__] = ACTIONS(1942),
    [sym_number_literal] = ACTIONS(1944),
    [anon_sym_L_SQUOTE] = ACTIONS(1944),
    [anon_sym_u_SQUOTE] = ACTIONS(1944),
    [anon_sym_U_SQUOTE] = ACTIONS(1944),
    [anon_sym_u8_SQUOTE] = ACTIONS(1944),
    [anon_sym_SQUOTE] = ACTIONS(1944),
    [anon_sym_L_DQUOTE] = ACTIONS(1944),
    [anon_sym_u_DQUOTE] = ACTIONS(1944),
    [anon_sym_U_DQUOTE] = ACTIONS(1944),
    [anon_sym_u8_DQUOTE] = ACTIONS(1944),
    [anon_sym_DQUOTE] = ACTIONS(1944),
    [sym_true] = ACTIONS(1942),
    [sym_false] = ACTIONS(1942),
    [anon_sym_NULL] = ACTIONS(1942),
    [anon_sym_nullptr] = ACTIONS(1942),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1942),
    [anon_sym_decltype] = ACTIONS(1942),
    [sym_virtual] = ACTIONS(1942),
    [anon_sym_typename] = ACTIONS(1942),
    [anon_sym_template] = ACTIONS(1942),
    [anon_sym_try] = ACTIONS(1942),
    [anon_sym_delete] = ACTIONS(1942),
    [anon_sym_throw] = ACTIONS(1942),
    [anon_sym_co_return] = ACTIONS(1942),
    [anon_sym_co_yield] = ACTIONS(1942),
    [anon_sym_R_DQUOTE] = ACTIONS(1944),
    [anon_sym_LR_DQUOTE] = ACTIONS(1944),
    [anon_sym_uR_DQUOTE] = ACTIONS(1944),
    [anon_sym_UR_DQUOTE] = ACTIONS(1944),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1944),
    [anon_sym_co_await] = ACTIONS(1942),
    [anon_sym_new] = ACTIONS(1942),
    [anon_sym_requires] = ACTIONS(1942),
    [sym_this] = ACTIONS(1942),
    [anon_sym___launch_bounds__] = ACTIONS(1942),
  },
  [858] = {
    [sym_identifier] = ACTIONS(2072),
    [anon_sym_LPAREN2] = ACTIONS(2074),
    [anon_sym_BANG] = ACTIONS(2074),
    [anon_sym_TILDE] = ACTIONS(2074),
    [anon_sym_DASH] = ACTIONS(2072),
    [anon_sym_PLUS] = ACTIONS(2072),
    [anon_sym_STAR] = ACTIONS(2074),
    [anon_sym_AMP] = ACTIONS(2074),
    [anon_sym_SEMI] = ACTIONS(2074),
    [anon_sym___extension__] = ACTIONS(2072),
    [anon_sym_typedef] = ACTIONS(2072),
    [anon_sym___device__] = ACTIONS(2072),
    [anon_sym___host__] = ACTIONS(2072),
    [anon_sym___global__] = ACTIONS(2072),
    [anon_sym___forceinline__] = ACTIONS(2072),
    [anon_sym___noinline__] = ACTIONS(2072),
    [anon_sym_extern] = ACTIONS(2072),
    [anon_sym___attribute__] = ACTIONS(2072),
    [anon_sym_COLON_COLON] = ACTIONS(2074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2074),
    [anon_sym___declspec] = ACTIONS(2072),
    [anon_sym_LBRACE] = ACTIONS(2074),
    [anon_sym_signed] = ACTIONS(2072),
    [anon_sym_unsigned] = ACTIONS(2072),
    [anon_sym_long] = ACTIONS(2072),
    [anon_sym_short] = ACTIONS(2072),
    [anon_sym_LBRACK] = ACTIONS(2072),
    [anon_sym_static] = ACTIONS(2072),
    [anon_sym_register] = ACTIONS(2072),
    [anon_sym_inline] = ACTIONS(2072),
    [anon_sym___inline] = ACTIONS(2072),
    [anon_sym___inline__] = ACTIONS(2072),
    [anon_sym___forceinline] = ACTIONS(2072),
    [anon_sym_thread_local] = ACTIONS(2072),
    [anon_sym___thread] = ACTIONS(2072),
    [anon_sym_const] = ACTIONS(2072),
    [anon_sym_constexpr] = ACTIONS(2072),
    [anon_sym_volatile] = ACTIONS(2072),
    [anon_sym_restrict] = ACTIONS(2072),
    [anon_sym___restrict__] = ACTIONS(2072),
    [anon_sym__Atomic] = ACTIONS(2072),
    [anon_sym__Noreturn] = ACTIONS(2072),
    [anon_sym_noreturn] = ACTIONS(2072),
    [anon_sym_mutable] = ACTIONS(2072),
    [anon_sym_constinit] = ACTIONS(2072),
    [anon_sym_consteval] = ACTIONS(2072),
    [anon_sym___shared__] = ACTIONS(2072),
    [anon_sym___local__] = ACTIONS(2072),
    [anon_sym___constant__] = ACTIONS(2072),
    [anon_sym___managed__] = ACTIONS(2072),
    [anon_sym___grid_constant__] = ACTIONS(2072),
    [anon_sym_alignas] = ACTIONS(2072),
    [anon_sym__Alignas] = ACTIONS(2072),
    [sym_primitive_type] = ACTIONS(2072),
    [anon_sym_enum] = ACTIONS(2072),
    [anon_sym_class] = ACTIONS(2072),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2072),
    [anon_sym_if] = ACTIONS(2072),
    [anon_sym_else] = ACTIONS(2072),
    [anon_sym_switch] = ACTIONS(2072),
    [anon_sym_while] = ACTIONS(2072),
    [anon_sym_do] = ACTIONS(2072),
    [anon_sym_for] = ACTIONS(2072),
    [anon_sym_return] = ACTIONS(2072),
    [anon_sym_break] = ACTIONS(2072),
    [anon_sym_continue] = ACTIONS(2072),
    [anon_sym_goto] = ACTIONS(2072),
    [anon_sym___try] = ACTIONS(2072),
    [anon_sym___leave] = ACTIONS(2072),
    [anon_sym_not] = ACTIONS(2072),
    [anon_sym_compl] = ACTIONS(2072),
    [anon_sym_DASH_DASH] = ACTIONS(2074),
    [anon_sym_PLUS_PLUS] = ACTIONS(2074),
    [anon_sym_sizeof] = ACTIONS(2072),
    [anon_sym___alignof__] = ACTIONS(2072),
    [anon_sym___alignof] = ACTIONS(2072),
    [anon_sym__alignof] = ACTIONS(2072),
    [anon_sym_alignof] = ACTIONS(2072),
    [anon_sym__Alignof] = ACTIONS(2072),
    [anon_sym_offsetof] = ACTIONS(2072),
    [anon_sym__Generic] = ACTIONS(2072),
    [anon_sym_asm] = ACTIONS(2072),
    [anon_sym___asm__] = ACTIONS(2072),
    [sym_number_literal] = ACTIONS(2074),
    [anon_sym_L_SQUOTE] = ACTIONS(2074),
    [anon_sym_u_SQUOTE] = ACTIONS(2074),
    [anon_sym_U_SQUOTE] = ACTIONS(2074),
    [anon_sym_u8_SQUOTE] = ACTIONS(2074),
    [anon_sym_SQUOTE] = ACTIONS(2074),
    [anon_sym_L_DQUOTE] = ACTIONS(2074),
    [anon_sym_u_DQUOTE] = ACTIONS(2074),
    [anon_sym_U_DQUOTE] = ACTIONS(2074),
    [anon_sym_u8_DQUOTE] = ACTIONS(2074),
    [anon_sym_DQUOTE] = ACTIONS(2074),
    [sym_true] = ACTIONS(2072),
    [sym_false] = ACTIONS(2072),
    [anon_sym_NULL] = ACTIONS(2072),
    [anon_sym_nullptr] = ACTIONS(2072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2072),
    [anon_sym_decltype] = ACTIONS(2072),
    [sym_virtual] = ACTIONS(2072),
    [anon_sym_typename] = ACTIONS(2072),
    [anon_sym_template] = ACTIONS(2072),
    [anon_sym_try] = ACTIONS(2072),
    [anon_sym_delete] = ACTIONS(2072),
    [anon_sym_throw] = ACTIONS(2072),
    [anon_sym_co_return] = ACTIONS(2072),
    [anon_sym_co_yield] = ACTIONS(2072),
    [anon_sym_R_DQUOTE] = ACTIONS(2074),
    [anon_sym_LR_DQUOTE] = ACTIONS(2074),
    [anon_sym_uR_DQUOTE] = ACTIONS(2074),
    [anon_sym_UR_DQUOTE] = ACTIONS(2074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2074),
    [anon_sym_co_await] = ACTIONS(2072),
    [anon_sym_new] = ACTIONS(2072),
    [anon_sym_requires] = ACTIONS(2072),
    [sym_this] = ACTIONS(2072),
    [anon_sym___launch_bounds__] = ACTIONS(2072),
  },
  [859] = {
    [sym_identifier] = ACTIONS(1988),
    [anon_sym_LPAREN2] = ACTIONS(1990),
    [anon_sym_BANG] = ACTIONS(1990),
    [anon_sym_TILDE] = ACTIONS(1990),
    [anon_sym_DASH] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(1990),
    [anon_sym_AMP] = ACTIONS(1990),
    [anon_sym_SEMI] = ACTIONS(1990),
    [anon_sym___extension__] = ACTIONS(1988),
    [anon_sym_typedef] = ACTIONS(1988),
    [anon_sym___device__] = ACTIONS(1988),
    [anon_sym___host__] = ACTIONS(1988),
    [anon_sym___global__] = ACTIONS(1988),
    [anon_sym___forceinline__] = ACTIONS(1988),
    [anon_sym___noinline__] = ACTIONS(1988),
    [anon_sym_extern] = ACTIONS(1988),
    [anon_sym___attribute__] = ACTIONS(1988),
    [anon_sym_COLON_COLON] = ACTIONS(1990),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1990),
    [anon_sym___declspec] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1990),
    [anon_sym_signed] = ACTIONS(1988),
    [anon_sym_unsigned] = ACTIONS(1988),
    [anon_sym_long] = ACTIONS(1988),
    [anon_sym_short] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [anon_sym_static] = ACTIONS(1988),
    [anon_sym_register] = ACTIONS(1988),
    [anon_sym_inline] = ACTIONS(1988),
    [anon_sym___inline] = ACTIONS(1988),
    [anon_sym___inline__] = ACTIONS(1988),
    [anon_sym___forceinline] = ACTIONS(1988),
    [anon_sym_thread_local] = ACTIONS(1988),
    [anon_sym___thread] = ACTIONS(1988),
    [anon_sym_const] = ACTIONS(1988),
    [anon_sym_constexpr] = ACTIONS(1988),
    [anon_sym_volatile] = ACTIONS(1988),
    [anon_sym_restrict] = ACTIONS(1988),
    [anon_sym___restrict__] = ACTIONS(1988),
    [anon_sym__Atomic] = ACTIONS(1988),
    [anon_sym__Noreturn] = ACTIONS(1988),
    [anon_sym_noreturn] = ACTIONS(1988),
    [anon_sym_mutable] = ACTIONS(1988),
    [anon_sym_constinit] = ACTIONS(1988),
    [anon_sym_consteval] = ACTIONS(1988),
    [anon_sym___shared__] = ACTIONS(1988),
    [anon_sym___local__] = ACTIONS(1988),
    [anon_sym___constant__] = ACTIONS(1988),
    [anon_sym___managed__] = ACTIONS(1988),
    [anon_sym___grid_constant__] = ACTIONS(1988),
    [anon_sym_alignas] = ACTIONS(1988),
    [anon_sym__Alignas] = ACTIONS(1988),
    [sym_primitive_type] = ACTIONS(1988),
    [anon_sym_enum] = ACTIONS(1988),
    [anon_sym_class] = ACTIONS(1988),
    [anon_sym_struct] = ACTIONS(1988),
    [anon_sym_union] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_else] = ACTIONS(1988),
    [anon_sym_switch] = ACTIONS(1988),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_do] = ACTIONS(1988),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_return] = ACTIONS(1988),
    [anon_sym_break] = ACTIONS(1988),
    [anon_sym_continue] = ACTIONS(1988),
    [anon_sym_goto] = ACTIONS(1988),
    [anon_sym___try] = ACTIONS(1988),
    [anon_sym___leave] = ACTIONS(1988),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_compl] = ACTIONS(1988),
    [anon_sym_DASH_DASH] = ACTIONS(1990),
    [anon_sym_PLUS_PLUS] = ACTIONS(1990),
    [anon_sym_sizeof] = ACTIONS(1988),
    [anon_sym___alignof__] = ACTIONS(1988),
    [anon_sym___alignof] = ACTIONS(1988),
    [anon_sym__alignof] = ACTIONS(1988),
    [anon_sym_alignof] = ACTIONS(1988),
    [anon_sym__Alignof] = ACTIONS(1988),
    [anon_sym_offsetof] = ACTIONS(1988),
    [anon_sym__Generic] = ACTIONS(1988),
    [anon_sym_asm] = ACTIONS(1988),
    [anon_sym___asm__] = ACTIONS(1988),
    [sym_number_literal] = ACTIONS(1990),
    [anon_sym_L_SQUOTE] = ACTIONS(1990),
    [anon_sym_u_SQUOTE] = ACTIONS(1990),
    [anon_sym_U_SQUOTE] = ACTIONS(1990),
    [anon_sym_u8_SQUOTE] = ACTIONS(1990),
    [anon_sym_SQUOTE] = ACTIONS(1990),
    [anon_sym_L_DQUOTE] = ACTIONS(1990),
    [anon_sym_u_DQUOTE] = ACTIONS(1990),
    [anon_sym_U_DQUOTE] = ACTIONS(1990),
    [anon_sym_u8_DQUOTE] = ACTIONS(1990),
    [anon_sym_DQUOTE] = ACTIONS(1990),
    [sym_true] = ACTIONS(1988),
    [sym_false] = ACTIONS(1988),
    [anon_sym_NULL] = ACTIONS(1988),
    [anon_sym_nullptr] = ACTIONS(1988),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1988),
    [anon_sym_decltype] = ACTIONS(1988),
    [sym_virtual] = ACTIONS(1988),
    [anon_sym_typename] = ACTIONS(1988),
    [anon_sym_template] = ACTIONS(1988),
    [anon_sym_try] = ACTIONS(1988),
    [anon_sym_delete] = ACTIONS(1988),
    [anon_sym_throw] = ACTIONS(1988),
    [anon_sym_co_return] = ACTIONS(1988),
    [anon_sym_co_yield] = ACTIONS(1988),
    [anon_sym_R_DQUOTE] = ACTIONS(1990),
    [anon_sym_LR_DQUOTE] = ACTIONS(1990),
    [anon_sym_uR_DQUOTE] = ACTIONS(1990),
    [anon_sym_UR_DQUOTE] = ACTIONS(1990),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1990),
    [anon_sym_co_await] = ACTIONS(1988),
    [anon_sym_new] = ACTIONS(1988),
    [anon_sym_requires] = ACTIONS(1988),
    [sym_this] = ACTIONS(1988),
    [anon_sym___launch_bounds__] = ACTIONS(1988),
  },
  [860] = {
    [sym_identifier] = ACTIONS(2040),
    [anon_sym_LPAREN2] = ACTIONS(2042),
    [anon_sym_BANG] = ACTIONS(2042),
    [anon_sym_TILDE] = ACTIONS(2042),
    [anon_sym_DASH] = ACTIONS(2040),
    [anon_sym_PLUS] = ACTIONS(2040),
    [anon_sym_STAR] = ACTIONS(2042),
    [anon_sym_AMP] = ACTIONS(2042),
    [anon_sym_SEMI] = ACTIONS(2042),
    [anon_sym___extension__] = ACTIONS(2040),
    [anon_sym_typedef] = ACTIONS(2040),
    [anon_sym___device__] = ACTIONS(2040),
    [anon_sym___host__] = ACTIONS(2040),
    [anon_sym___global__] = ACTIONS(2040),
    [anon_sym___forceinline__] = ACTIONS(2040),
    [anon_sym___noinline__] = ACTIONS(2040),
    [anon_sym_extern] = ACTIONS(2040),
    [anon_sym___attribute__] = ACTIONS(2040),
    [anon_sym_COLON_COLON] = ACTIONS(2042),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2042),
    [anon_sym___declspec] = ACTIONS(2040),
    [anon_sym_LBRACE] = ACTIONS(2042),
    [anon_sym_signed] = ACTIONS(2040),
    [anon_sym_unsigned] = ACTIONS(2040),
    [anon_sym_long] = ACTIONS(2040),
    [anon_sym_short] = ACTIONS(2040),
    [anon_sym_LBRACK] = ACTIONS(2040),
    [anon_sym_static] = ACTIONS(2040),
    [anon_sym_register] = ACTIONS(2040),
    [anon_sym_inline] = ACTIONS(2040),
    [anon_sym___inline] = ACTIONS(2040),
    [anon_sym___inline__] = ACTIONS(2040),
    [anon_sym___forceinline] = ACTIONS(2040),
    [anon_sym_thread_local] = ACTIONS(2040),
    [anon_sym___thread] = ACTIONS(2040),
    [anon_sym_const] = ACTIONS(2040),
    [anon_sym_constexpr] = ACTIONS(2040),
    [anon_sym_volatile] = ACTIONS(2040),
    [anon_sym_restrict] = ACTIONS(2040),
    [anon_sym___restrict__] = ACTIONS(2040),
    [anon_sym__Atomic] = ACTIONS(2040),
    [anon_sym__Noreturn] = ACTIONS(2040),
    [anon_sym_noreturn] = ACTIONS(2040),
    [anon_sym_mutable] = ACTIONS(2040),
    [anon_sym_constinit] = ACTIONS(2040),
    [anon_sym_consteval] = ACTIONS(2040),
    [anon_sym___shared__] = ACTIONS(2040),
    [anon_sym___local__] = ACTIONS(2040),
    [anon_sym___constant__] = ACTIONS(2040),
    [anon_sym___managed__] = ACTIONS(2040),
    [anon_sym___grid_constant__] = ACTIONS(2040),
    [anon_sym_alignas] = ACTIONS(2040),
    [anon_sym__Alignas] = ACTIONS(2040),
    [sym_primitive_type] = ACTIONS(2040),
    [anon_sym_enum] = ACTIONS(2040),
    [anon_sym_class] = ACTIONS(2040),
    [anon_sym_struct] = ACTIONS(2040),
    [anon_sym_union] = ACTIONS(2040),
    [anon_sym_if] = ACTIONS(2040),
    [anon_sym_else] = ACTIONS(2040),
    [anon_sym_switch] = ACTIONS(2040),
    [anon_sym_while] = ACTIONS(2040),
    [anon_sym_do] = ACTIONS(2040),
    [anon_sym_for] = ACTIONS(2040),
    [anon_sym_return] = ACTIONS(2040),
    [anon_sym_break] = ACTIONS(2040),
    [anon_sym_continue] = ACTIONS(2040),
    [anon_sym_goto] = ACTIONS(2040),
    [anon_sym___try] = ACTIONS(2040),
    [anon_sym___leave] = ACTIONS(2040),
    [anon_sym_not] = ACTIONS(2040),
    [anon_sym_compl] = ACTIONS(2040),
    [anon_sym_DASH_DASH] = ACTIONS(2042),
    [anon_sym_PLUS_PLUS] = ACTIONS(2042),
    [anon_sym_sizeof] = ACTIONS(2040),
    [anon_sym___alignof__] = ACTIONS(2040),
    [anon_sym___alignof] = ACTIONS(2040),
    [anon_sym__alignof] = ACTIONS(2040),
    [anon_sym_alignof] = ACTIONS(2040),
    [anon_sym__Alignof] = ACTIONS(2040),
    [anon_sym_offsetof] = ACTIONS(2040),
    [anon_sym__Generic] = ACTIONS(2040),
    [anon_sym_asm] = ACTIONS(2040),
    [anon_sym___asm__] = ACTIONS(2040),
    [sym_number_literal] = ACTIONS(2042),
    [anon_sym_L_SQUOTE] = ACTIONS(2042),
    [anon_sym_u_SQUOTE] = ACTIONS(2042),
    [anon_sym_U_SQUOTE] = ACTIONS(2042),
    [anon_sym_u8_SQUOTE] = ACTIONS(2042),
    [anon_sym_SQUOTE] = ACTIONS(2042),
    [anon_sym_L_DQUOTE] = ACTIONS(2042),
    [anon_sym_u_DQUOTE] = ACTIONS(2042),
    [anon_sym_U_DQUOTE] = ACTIONS(2042),
    [anon_sym_u8_DQUOTE] = ACTIONS(2042),
    [anon_sym_DQUOTE] = ACTIONS(2042),
    [sym_true] = ACTIONS(2040),
    [sym_false] = ACTIONS(2040),
    [anon_sym_NULL] = ACTIONS(2040),
    [anon_sym_nullptr] = ACTIONS(2040),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2040),
    [anon_sym_decltype] = ACTIONS(2040),
    [sym_virtual] = ACTIONS(2040),
    [anon_sym_typename] = ACTIONS(2040),
    [anon_sym_template] = ACTIONS(2040),
    [anon_sym_try] = ACTIONS(2040),
    [anon_sym_delete] = ACTIONS(2040),
    [anon_sym_throw] = ACTIONS(2040),
    [anon_sym_co_return] = ACTIONS(2040),
    [anon_sym_co_yield] = ACTIONS(2040),
    [anon_sym_R_DQUOTE] = ACTIONS(2042),
    [anon_sym_LR_DQUOTE] = ACTIONS(2042),
    [anon_sym_uR_DQUOTE] = ACTIONS(2042),
    [anon_sym_UR_DQUOTE] = ACTIONS(2042),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2042),
    [anon_sym_co_await] = ACTIONS(2040),
    [anon_sym_new] = ACTIONS(2040),
    [anon_sym_requires] = ACTIONS(2040),
    [sym_this] = ACTIONS(2040),
    [anon_sym___launch_bounds__] = ACTIONS(2040),
  },
  [861] = {
    [sym_identifier] = ACTIONS(2076),
    [anon_sym_LPAREN2] = ACTIONS(2078),
    [anon_sym_BANG] = ACTIONS(2078),
    [anon_sym_TILDE] = ACTIONS(2078),
    [anon_sym_DASH] = ACTIONS(2076),
    [anon_sym_PLUS] = ACTIONS(2076),
    [anon_sym_STAR] = ACTIONS(2078),
    [anon_sym_AMP] = ACTIONS(2078),
    [anon_sym_SEMI] = ACTIONS(2078),
    [anon_sym___extension__] = ACTIONS(2076),
    [anon_sym_typedef] = ACTIONS(2076),
    [anon_sym___device__] = ACTIONS(2076),
    [anon_sym___host__] = ACTIONS(2076),
    [anon_sym___global__] = ACTIONS(2076),
    [anon_sym___forceinline__] = ACTIONS(2076),
    [anon_sym___noinline__] = ACTIONS(2076),
    [anon_sym_extern] = ACTIONS(2076),
    [anon_sym___attribute__] = ACTIONS(2076),
    [anon_sym_COLON_COLON] = ACTIONS(2078),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2078),
    [anon_sym___declspec] = ACTIONS(2076),
    [anon_sym_LBRACE] = ACTIONS(2078),
    [anon_sym_signed] = ACTIONS(2076),
    [anon_sym_unsigned] = ACTIONS(2076),
    [anon_sym_long] = ACTIONS(2076),
    [anon_sym_short] = ACTIONS(2076),
    [anon_sym_LBRACK] = ACTIONS(2076),
    [anon_sym_static] = ACTIONS(2076),
    [anon_sym_register] = ACTIONS(2076),
    [anon_sym_inline] = ACTIONS(2076),
    [anon_sym___inline] = ACTIONS(2076),
    [anon_sym___inline__] = ACTIONS(2076),
    [anon_sym___forceinline] = ACTIONS(2076),
    [anon_sym_thread_local] = ACTIONS(2076),
    [anon_sym___thread] = ACTIONS(2076),
    [anon_sym_const] = ACTIONS(2076),
    [anon_sym_constexpr] = ACTIONS(2076),
    [anon_sym_volatile] = ACTIONS(2076),
    [anon_sym_restrict] = ACTIONS(2076),
    [anon_sym___restrict__] = ACTIONS(2076),
    [anon_sym__Atomic] = ACTIONS(2076),
    [anon_sym__Noreturn] = ACTIONS(2076),
    [anon_sym_noreturn] = ACTIONS(2076),
    [anon_sym_mutable] = ACTIONS(2076),
    [anon_sym_constinit] = ACTIONS(2076),
    [anon_sym_consteval] = ACTIONS(2076),
    [anon_sym___shared__] = ACTIONS(2076),
    [anon_sym___local__] = ACTIONS(2076),
    [anon_sym___constant__] = ACTIONS(2076),
    [anon_sym___managed__] = ACTIONS(2076),
    [anon_sym___grid_constant__] = ACTIONS(2076),
    [anon_sym_alignas] = ACTIONS(2076),
    [anon_sym__Alignas] = ACTIONS(2076),
    [sym_primitive_type] = ACTIONS(2076),
    [anon_sym_enum] = ACTIONS(2076),
    [anon_sym_class] = ACTIONS(2076),
    [anon_sym_struct] = ACTIONS(2076),
    [anon_sym_union] = ACTIONS(2076),
    [anon_sym_if] = ACTIONS(2076),
    [anon_sym_else] = ACTIONS(2076),
    [anon_sym_switch] = ACTIONS(2076),
    [anon_sym_while] = ACTIONS(2076),
    [anon_sym_do] = ACTIONS(2076),
    [anon_sym_for] = ACTIONS(2076),
    [anon_sym_return] = ACTIONS(2076),
    [anon_sym_break] = ACTIONS(2076),
    [anon_sym_continue] = ACTIONS(2076),
    [anon_sym_goto] = ACTIONS(2076),
    [anon_sym___try] = ACTIONS(2076),
    [anon_sym___leave] = ACTIONS(2076),
    [anon_sym_not] = ACTIONS(2076),
    [anon_sym_compl] = ACTIONS(2076),
    [anon_sym_DASH_DASH] = ACTIONS(2078),
    [anon_sym_PLUS_PLUS] = ACTIONS(2078),
    [anon_sym_sizeof] = ACTIONS(2076),
    [anon_sym___alignof__] = ACTIONS(2076),
    [anon_sym___alignof] = ACTIONS(2076),
    [anon_sym__alignof] = ACTIONS(2076),
    [anon_sym_alignof] = ACTIONS(2076),
    [anon_sym__Alignof] = ACTIONS(2076),
    [anon_sym_offsetof] = ACTIONS(2076),
    [anon_sym__Generic] = ACTIONS(2076),
    [anon_sym_asm] = ACTIONS(2076),
    [anon_sym___asm__] = ACTIONS(2076),
    [sym_number_literal] = ACTIONS(2078),
    [anon_sym_L_SQUOTE] = ACTIONS(2078),
    [anon_sym_u_SQUOTE] = ACTIONS(2078),
    [anon_sym_U_SQUOTE] = ACTIONS(2078),
    [anon_sym_u8_SQUOTE] = ACTIONS(2078),
    [anon_sym_SQUOTE] = ACTIONS(2078),
    [anon_sym_L_DQUOTE] = ACTIONS(2078),
    [anon_sym_u_DQUOTE] = ACTIONS(2078),
    [anon_sym_U_DQUOTE] = ACTIONS(2078),
    [anon_sym_u8_DQUOTE] = ACTIONS(2078),
    [anon_sym_DQUOTE] = ACTIONS(2078),
    [sym_true] = ACTIONS(2076),
    [sym_false] = ACTIONS(2076),
    [anon_sym_NULL] = ACTIONS(2076),
    [anon_sym_nullptr] = ACTIONS(2076),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2076),
    [anon_sym_decltype] = ACTIONS(2076),
    [sym_virtual] = ACTIONS(2076),
    [anon_sym_typename] = ACTIONS(2076),
    [anon_sym_template] = ACTIONS(2076),
    [anon_sym_try] = ACTIONS(2076),
    [anon_sym_delete] = ACTIONS(2076),
    [anon_sym_throw] = ACTIONS(2076),
    [anon_sym_co_return] = ACTIONS(2076),
    [anon_sym_co_yield] = ACTIONS(2076),
    [anon_sym_R_DQUOTE] = ACTIONS(2078),
    [anon_sym_LR_DQUOTE] = ACTIONS(2078),
    [anon_sym_uR_DQUOTE] = ACTIONS(2078),
    [anon_sym_UR_DQUOTE] = ACTIONS(2078),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2078),
    [anon_sym_co_await] = ACTIONS(2076),
    [anon_sym_new] = ACTIONS(2076),
    [anon_sym_requires] = ACTIONS(2076),
    [sym_this] = ACTIONS(2076),
    [anon_sym___launch_bounds__] = ACTIONS(2076),
  },
  [862] = {
    [sym_identifier] = ACTIONS(2064),
    [anon_sym_LPAREN2] = ACTIONS(2066),
    [anon_sym_BANG] = ACTIONS(2066),
    [anon_sym_TILDE] = ACTIONS(2066),
    [anon_sym_DASH] = ACTIONS(2064),
    [anon_sym_PLUS] = ACTIONS(2064),
    [anon_sym_STAR] = ACTIONS(2066),
    [anon_sym_AMP] = ACTIONS(2066),
    [anon_sym_SEMI] = ACTIONS(2066),
    [anon_sym___extension__] = ACTIONS(2064),
    [anon_sym_typedef] = ACTIONS(2064),
    [anon_sym___device__] = ACTIONS(2064),
    [anon_sym___host__] = ACTIONS(2064),
    [anon_sym___global__] = ACTIONS(2064),
    [anon_sym___forceinline__] = ACTIONS(2064),
    [anon_sym___noinline__] = ACTIONS(2064),
    [anon_sym_extern] = ACTIONS(2064),
    [anon_sym___attribute__] = ACTIONS(2064),
    [anon_sym_COLON_COLON] = ACTIONS(2066),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2066),
    [anon_sym___declspec] = ACTIONS(2064),
    [anon_sym_LBRACE] = ACTIONS(2066),
    [anon_sym_signed] = ACTIONS(2064),
    [anon_sym_unsigned] = ACTIONS(2064),
    [anon_sym_long] = ACTIONS(2064),
    [anon_sym_short] = ACTIONS(2064),
    [anon_sym_LBRACK] = ACTIONS(2064),
    [anon_sym_static] = ACTIONS(2064),
    [anon_sym_register] = ACTIONS(2064),
    [anon_sym_inline] = ACTIONS(2064),
    [anon_sym___inline] = ACTIONS(2064),
    [anon_sym___inline__] = ACTIONS(2064),
    [anon_sym___forceinline] = ACTIONS(2064),
    [anon_sym_thread_local] = ACTIONS(2064),
    [anon_sym___thread] = ACTIONS(2064),
    [anon_sym_const] = ACTIONS(2064),
    [anon_sym_constexpr] = ACTIONS(2064),
    [anon_sym_volatile] = ACTIONS(2064),
    [anon_sym_restrict] = ACTIONS(2064),
    [anon_sym___restrict__] = ACTIONS(2064),
    [anon_sym__Atomic] = ACTIONS(2064),
    [anon_sym__Noreturn] = ACTIONS(2064),
    [anon_sym_noreturn] = ACTIONS(2064),
    [anon_sym_mutable] = ACTIONS(2064),
    [anon_sym_constinit] = ACTIONS(2064),
    [anon_sym_consteval] = ACTIONS(2064),
    [anon_sym___shared__] = ACTIONS(2064),
    [anon_sym___local__] = ACTIONS(2064),
    [anon_sym___constant__] = ACTIONS(2064),
    [anon_sym___managed__] = ACTIONS(2064),
    [anon_sym___grid_constant__] = ACTIONS(2064),
    [anon_sym_alignas] = ACTIONS(2064),
    [anon_sym__Alignas] = ACTIONS(2064),
    [sym_primitive_type] = ACTIONS(2064),
    [anon_sym_enum] = ACTIONS(2064),
    [anon_sym_class] = ACTIONS(2064),
    [anon_sym_struct] = ACTIONS(2064),
    [anon_sym_union] = ACTIONS(2064),
    [anon_sym_if] = ACTIONS(2064),
    [anon_sym_else] = ACTIONS(2064),
    [anon_sym_switch] = ACTIONS(2064),
    [anon_sym_while] = ACTIONS(2064),
    [anon_sym_do] = ACTIONS(2064),
    [anon_sym_for] = ACTIONS(2064),
    [anon_sym_return] = ACTIONS(2064),
    [anon_sym_break] = ACTIONS(2064),
    [anon_sym_continue] = ACTIONS(2064),
    [anon_sym_goto] = ACTIONS(2064),
    [anon_sym___try] = ACTIONS(2064),
    [anon_sym___leave] = ACTIONS(2064),
    [anon_sym_not] = ACTIONS(2064),
    [anon_sym_compl] = ACTIONS(2064),
    [anon_sym_DASH_DASH] = ACTIONS(2066),
    [anon_sym_PLUS_PLUS] = ACTIONS(2066),
    [anon_sym_sizeof] = ACTIONS(2064),
    [anon_sym___alignof__] = ACTIONS(2064),
    [anon_sym___alignof] = ACTIONS(2064),
    [anon_sym__alignof] = ACTIONS(2064),
    [anon_sym_alignof] = ACTIONS(2064),
    [anon_sym__Alignof] = ACTIONS(2064),
    [anon_sym_offsetof] = ACTIONS(2064),
    [anon_sym__Generic] = ACTIONS(2064),
    [anon_sym_asm] = ACTIONS(2064),
    [anon_sym___asm__] = ACTIONS(2064),
    [sym_number_literal] = ACTIONS(2066),
    [anon_sym_L_SQUOTE] = ACTIONS(2066),
    [anon_sym_u_SQUOTE] = ACTIONS(2066),
    [anon_sym_U_SQUOTE] = ACTIONS(2066),
    [anon_sym_u8_SQUOTE] = ACTIONS(2066),
    [anon_sym_SQUOTE] = ACTIONS(2066),
    [anon_sym_L_DQUOTE] = ACTIONS(2066),
    [anon_sym_u_DQUOTE] = ACTIONS(2066),
    [anon_sym_U_DQUOTE] = ACTIONS(2066),
    [anon_sym_u8_DQUOTE] = ACTIONS(2066),
    [anon_sym_DQUOTE] = ACTIONS(2066),
    [sym_true] = ACTIONS(2064),
    [sym_false] = ACTIONS(2064),
    [anon_sym_NULL] = ACTIONS(2064),
    [anon_sym_nullptr] = ACTIONS(2064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2064),
    [anon_sym_decltype] = ACTIONS(2064),
    [sym_virtual] = ACTIONS(2064),
    [anon_sym_typename] = ACTIONS(2064),
    [anon_sym_template] = ACTIONS(2064),
    [anon_sym_try] = ACTIONS(2064),
    [anon_sym_delete] = ACTIONS(2064),
    [anon_sym_throw] = ACTIONS(2064),
    [anon_sym_co_return] = ACTIONS(2064),
    [anon_sym_co_yield] = ACTIONS(2064),
    [anon_sym_R_DQUOTE] = ACTIONS(2066),
    [anon_sym_LR_DQUOTE] = ACTIONS(2066),
    [anon_sym_uR_DQUOTE] = ACTIONS(2066),
    [anon_sym_UR_DQUOTE] = ACTIONS(2066),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2066),
    [anon_sym_co_await] = ACTIONS(2064),
    [anon_sym_new] = ACTIONS(2064),
    [anon_sym_requires] = ACTIONS(2064),
    [sym_this] = ACTIONS(2064),
    [anon_sym___launch_bounds__] = ACTIONS(2064),
  },
  [863] = {
    [sym_identifier] = ACTIONS(2052),
    [anon_sym_LPAREN2] = ACTIONS(2054),
    [anon_sym_BANG] = ACTIONS(2054),
    [anon_sym_TILDE] = ACTIONS(2054),
    [anon_sym_DASH] = ACTIONS(2052),
    [anon_sym_PLUS] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(2054),
    [anon_sym_AMP] = ACTIONS(2054),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym___extension__] = ACTIONS(2052),
    [anon_sym_typedef] = ACTIONS(2052),
    [anon_sym___device__] = ACTIONS(2052),
    [anon_sym___host__] = ACTIONS(2052),
    [anon_sym___global__] = ACTIONS(2052),
    [anon_sym___forceinline__] = ACTIONS(2052),
    [anon_sym___noinline__] = ACTIONS(2052),
    [anon_sym_extern] = ACTIONS(2052),
    [anon_sym___attribute__] = ACTIONS(2052),
    [anon_sym_COLON_COLON] = ACTIONS(2054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2054),
    [anon_sym___declspec] = ACTIONS(2052),
    [anon_sym_LBRACE] = ACTIONS(2054),
    [anon_sym_signed] = ACTIONS(2052),
    [anon_sym_unsigned] = ACTIONS(2052),
    [anon_sym_long] = ACTIONS(2052),
    [anon_sym_short] = ACTIONS(2052),
    [anon_sym_LBRACK] = ACTIONS(2052),
    [anon_sym_static] = ACTIONS(2052),
    [anon_sym_register] = ACTIONS(2052),
    [anon_sym_inline] = ACTIONS(2052),
    [anon_sym___inline] = ACTIONS(2052),
    [anon_sym___inline__] = ACTIONS(2052),
    [anon_sym___forceinline] = ACTIONS(2052),
    [anon_sym_thread_local] = ACTIONS(2052),
    [anon_sym___thread] = ACTIONS(2052),
    [anon_sym_const] = ACTIONS(2052),
    [anon_sym_constexpr] = ACTIONS(2052),
    [anon_sym_volatile] = ACTIONS(2052),
    [anon_sym_restrict] = ACTIONS(2052),
    [anon_sym___restrict__] = ACTIONS(2052),
    [anon_sym__Atomic] = ACTIONS(2052),
    [anon_sym__Noreturn] = ACTIONS(2052),
    [anon_sym_noreturn] = ACTIONS(2052),
    [anon_sym_mutable] = ACTIONS(2052),
    [anon_sym_constinit] = ACTIONS(2052),
    [anon_sym_consteval] = ACTIONS(2052),
    [anon_sym___shared__] = ACTIONS(2052),
    [anon_sym___local__] = ACTIONS(2052),
    [anon_sym___constant__] = ACTIONS(2052),
    [anon_sym___managed__] = ACTIONS(2052),
    [anon_sym___grid_constant__] = ACTIONS(2052),
    [anon_sym_alignas] = ACTIONS(2052),
    [anon_sym__Alignas] = ACTIONS(2052),
    [sym_primitive_type] = ACTIONS(2052),
    [anon_sym_enum] = ACTIONS(2052),
    [anon_sym_class] = ACTIONS(2052),
    [anon_sym_struct] = ACTIONS(2052),
    [anon_sym_union] = ACTIONS(2052),
    [anon_sym_if] = ACTIONS(2052),
    [anon_sym_else] = ACTIONS(2052),
    [anon_sym_switch] = ACTIONS(2052),
    [anon_sym_while] = ACTIONS(2052),
    [anon_sym_do] = ACTIONS(2052),
    [anon_sym_for] = ACTIONS(2052),
    [anon_sym_return] = ACTIONS(2052),
    [anon_sym_break] = ACTIONS(2052),
    [anon_sym_continue] = ACTIONS(2052),
    [anon_sym_goto] = ACTIONS(2052),
    [anon_sym___try] = ACTIONS(2052),
    [anon_sym___leave] = ACTIONS(2052),
    [anon_sym_not] = ACTIONS(2052),
    [anon_sym_compl] = ACTIONS(2052),
    [anon_sym_DASH_DASH] = ACTIONS(2054),
    [anon_sym_PLUS_PLUS] = ACTIONS(2054),
    [anon_sym_sizeof] = ACTIONS(2052),
    [anon_sym___alignof__] = ACTIONS(2052),
    [anon_sym___alignof] = ACTIONS(2052),
    [anon_sym__alignof] = ACTIONS(2052),
    [anon_sym_alignof] = ACTIONS(2052),
    [anon_sym__Alignof] = ACTIONS(2052),
    [anon_sym_offsetof] = ACTIONS(2052),
    [anon_sym__Generic] = ACTIONS(2052),
    [anon_sym_asm] = ACTIONS(2052),
    [anon_sym___asm__] = ACTIONS(2052),
    [sym_number_literal] = ACTIONS(2054),
    [anon_sym_L_SQUOTE] = ACTIONS(2054),
    [anon_sym_u_SQUOTE] = ACTIONS(2054),
    [anon_sym_U_SQUOTE] = ACTIONS(2054),
    [anon_sym_u8_SQUOTE] = ACTIONS(2054),
    [anon_sym_SQUOTE] = ACTIONS(2054),
    [anon_sym_L_DQUOTE] = ACTIONS(2054),
    [anon_sym_u_DQUOTE] = ACTIONS(2054),
    [anon_sym_U_DQUOTE] = ACTIONS(2054),
    [anon_sym_u8_DQUOTE] = ACTIONS(2054),
    [anon_sym_DQUOTE] = ACTIONS(2054),
    [sym_true] = ACTIONS(2052),
    [sym_false] = ACTIONS(2052),
    [anon_sym_NULL] = ACTIONS(2052),
    [anon_sym_nullptr] = ACTIONS(2052),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2052),
    [anon_sym_decltype] = ACTIONS(2052),
    [sym_virtual] = ACTIONS(2052),
    [anon_sym_typename] = ACTIONS(2052),
    [anon_sym_template] = ACTIONS(2052),
    [anon_sym_try] = ACTIONS(2052),
    [anon_sym_delete] = ACTIONS(2052),
    [anon_sym_throw] = ACTIONS(2052),
    [anon_sym_co_return] = ACTIONS(2052),
    [anon_sym_co_yield] = ACTIONS(2052),
    [anon_sym_R_DQUOTE] = ACTIONS(2054),
    [anon_sym_LR_DQUOTE] = ACTIONS(2054),
    [anon_sym_uR_DQUOTE] = ACTIONS(2054),
    [anon_sym_UR_DQUOTE] = ACTIONS(2054),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2054),
    [anon_sym_co_await] = ACTIONS(2052),
    [anon_sym_new] = ACTIONS(2052),
    [anon_sym_requires] = ACTIONS(2052),
    [sym_this] = ACTIONS(2052),
    [anon_sym___launch_bounds__] = ACTIONS(2052),
  },
  [864] = {
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_LPAREN2] = ACTIONS(2018),
    [anon_sym_BANG] = ACTIONS(2018),
    [anon_sym_TILDE] = ACTIONS(2018),
    [anon_sym_DASH] = ACTIONS(2016),
    [anon_sym_PLUS] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(2018),
    [anon_sym_AMP] = ACTIONS(2018),
    [anon_sym_SEMI] = ACTIONS(2018),
    [anon_sym___extension__] = ACTIONS(2016),
    [anon_sym_typedef] = ACTIONS(2016),
    [anon_sym___device__] = ACTIONS(2016),
    [anon_sym___host__] = ACTIONS(2016),
    [anon_sym___global__] = ACTIONS(2016),
    [anon_sym___forceinline__] = ACTIONS(2016),
    [anon_sym___noinline__] = ACTIONS(2016),
    [anon_sym_extern] = ACTIONS(2016),
    [anon_sym___attribute__] = ACTIONS(2016),
    [anon_sym_COLON_COLON] = ACTIONS(2018),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2018),
    [anon_sym___declspec] = ACTIONS(2016),
    [anon_sym_LBRACE] = ACTIONS(2018),
    [anon_sym_signed] = ACTIONS(2016),
    [anon_sym_unsigned] = ACTIONS(2016),
    [anon_sym_long] = ACTIONS(2016),
    [anon_sym_short] = ACTIONS(2016),
    [anon_sym_LBRACK] = ACTIONS(2016),
    [anon_sym_static] = ACTIONS(2016),
    [anon_sym_register] = ACTIONS(2016),
    [anon_sym_inline] = ACTIONS(2016),
    [anon_sym___inline] = ACTIONS(2016),
    [anon_sym___inline__] = ACTIONS(2016),
    [anon_sym___forceinline] = ACTIONS(2016),
    [anon_sym_thread_local] = ACTIONS(2016),
    [anon_sym___thread] = ACTIONS(2016),
    [anon_sym_const] = ACTIONS(2016),
    [anon_sym_constexpr] = ACTIONS(2016),
    [anon_sym_volatile] = ACTIONS(2016),
    [anon_sym_restrict] = ACTIONS(2016),
    [anon_sym___restrict__] = ACTIONS(2016),
    [anon_sym__Atomic] = ACTIONS(2016),
    [anon_sym__Noreturn] = ACTIONS(2016),
    [anon_sym_noreturn] = ACTIONS(2016),
    [anon_sym_mutable] = ACTIONS(2016),
    [anon_sym_constinit] = ACTIONS(2016),
    [anon_sym_consteval] = ACTIONS(2016),
    [anon_sym___shared__] = ACTIONS(2016),
    [anon_sym___local__] = ACTIONS(2016),
    [anon_sym___constant__] = ACTIONS(2016),
    [anon_sym___managed__] = ACTIONS(2016),
    [anon_sym___grid_constant__] = ACTIONS(2016),
    [anon_sym_alignas] = ACTIONS(2016),
    [anon_sym__Alignas] = ACTIONS(2016),
    [sym_primitive_type] = ACTIONS(2016),
    [anon_sym_enum] = ACTIONS(2016),
    [anon_sym_class] = ACTIONS(2016),
    [anon_sym_struct] = ACTIONS(2016),
    [anon_sym_union] = ACTIONS(2016),
    [anon_sym_if] = ACTIONS(2016),
    [anon_sym_else] = ACTIONS(2016),
    [anon_sym_switch] = ACTIONS(2016),
    [anon_sym_while] = ACTIONS(2016),
    [anon_sym_do] = ACTIONS(2016),
    [anon_sym_for] = ACTIONS(2016),
    [anon_sym_return] = ACTIONS(2016),
    [anon_sym_break] = ACTIONS(2016),
    [anon_sym_continue] = ACTIONS(2016),
    [anon_sym_goto] = ACTIONS(2016),
    [anon_sym___try] = ACTIONS(2016),
    [anon_sym___leave] = ACTIONS(2016),
    [anon_sym_not] = ACTIONS(2016),
    [anon_sym_compl] = ACTIONS(2016),
    [anon_sym_DASH_DASH] = ACTIONS(2018),
    [anon_sym_PLUS_PLUS] = ACTIONS(2018),
    [anon_sym_sizeof] = ACTIONS(2016),
    [anon_sym___alignof__] = ACTIONS(2016),
    [anon_sym___alignof] = ACTIONS(2016),
    [anon_sym__alignof] = ACTIONS(2016),
    [anon_sym_alignof] = ACTIONS(2016),
    [anon_sym__Alignof] = ACTIONS(2016),
    [anon_sym_offsetof] = ACTIONS(2016),
    [anon_sym__Generic] = ACTIONS(2016),
    [anon_sym_asm] = ACTIONS(2016),
    [anon_sym___asm__] = ACTIONS(2016),
    [sym_number_literal] = ACTIONS(2018),
    [anon_sym_L_SQUOTE] = ACTIONS(2018),
    [anon_sym_u_SQUOTE] = ACTIONS(2018),
    [anon_sym_U_SQUOTE] = ACTIONS(2018),
    [anon_sym_u8_SQUOTE] = ACTIONS(2018),
    [anon_sym_SQUOTE] = ACTIONS(2018),
    [anon_sym_L_DQUOTE] = ACTIONS(2018),
    [anon_sym_u_DQUOTE] = ACTIONS(2018),
    [anon_sym_U_DQUOTE] = ACTIONS(2018),
    [anon_sym_u8_DQUOTE] = ACTIONS(2018),
    [anon_sym_DQUOTE] = ACTIONS(2018),
    [sym_true] = ACTIONS(2016),
    [sym_false] = ACTIONS(2016),
    [anon_sym_NULL] = ACTIONS(2016),
    [anon_sym_nullptr] = ACTIONS(2016),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2016),
    [anon_sym_decltype] = ACTIONS(2016),
    [sym_virtual] = ACTIONS(2016),
    [anon_sym_typename] = ACTIONS(2016),
    [anon_sym_template] = ACTIONS(2016),
    [anon_sym_try] = ACTIONS(2016),
    [anon_sym_delete] = ACTIONS(2016),
    [anon_sym_throw] = ACTIONS(2016),
    [anon_sym_co_return] = ACTIONS(2016),
    [anon_sym_co_yield] = ACTIONS(2016),
    [anon_sym_R_DQUOTE] = ACTIONS(2018),
    [anon_sym_LR_DQUOTE] = ACTIONS(2018),
    [anon_sym_uR_DQUOTE] = ACTIONS(2018),
    [anon_sym_UR_DQUOTE] = ACTIONS(2018),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2018),
    [anon_sym_co_await] = ACTIONS(2016),
    [anon_sym_new] = ACTIONS(2016),
    [anon_sym_requires] = ACTIONS(2016),
    [sym_this] = ACTIONS(2016),
    [anon_sym___launch_bounds__] = ACTIONS(2016),
  },
  [865] = {
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_LPAREN2] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3648),
    [anon_sym_PLUS] = ACTIONS(3648),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_SEMI] = ACTIONS(3650),
    [anon_sym___extension__] = ACTIONS(3648),
    [anon_sym___device__] = ACTIONS(3648),
    [anon_sym___host__] = ACTIONS(3648),
    [anon_sym___global__] = ACTIONS(3648),
    [anon_sym___forceinline__] = ACTIONS(3648),
    [anon_sym___noinline__] = ACTIONS(3648),
    [anon_sym_extern] = ACTIONS(3648),
    [anon_sym___attribute__] = ACTIONS(3648),
    [anon_sym_COLON_COLON] = ACTIONS(3650),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3650),
    [anon_sym___declspec] = ACTIONS(3648),
    [anon_sym_LBRACE] = ACTIONS(3650),
    [anon_sym_signed] = ACTIONS(3648),
    [anon_sym_unsigned] = ACTIONS(3648),
    [anon_sym_long] = ACTIONS(3648),
    [anon_sym_short] = ACTIONS(3648),
    [anon_sym_LBRACK] = ACTIONS(3648),
    [anon_sym_static] = ACTIONS(3648),
    [anon_sym_register] = ACTIONS(3648),
    [anon_sym_inline] = ACTIONS(3648),
    [anon_sym___inline] = ACTIONS(3648),
    [anon_sym___inline__] = ACTIONS(3648),
    [anon_sym___forceinline] = ACTIONS(3648),
    [anon_sym_thread_local] = ACTIONS(3648),
    [anon_sym___thread] = ACTIONS(3648),
    [anon_sym_const] = ACTIONS(3648),
    [anon_sym_constexpr] = ACTIONS(3648),
    [anon_sym_volatile] = ACTIONS(3648),
    [anon_sym_restrict] = ACTIONS(3648),
    [anon_sym___restrict__] = ACTIONS(3648),
    [anon_sym__Atomic] = ACTIONS(3648),
    [anon_sym__Noreturn] = ACTIONS(3648),
    [anon_sym_noreturn] = ACTIONS(3648),
    [anon_sym_mutable] = ACTIONS(3648),
    [anon_sym_constinit] = ACTIONS(3648),
    [anon_sym_consteval] = ACTIONS(3648),
    [anon_sym___shared__] = ACTIONS(3648),
    [anon_sym___local__] = ACTIONS(3648),
    [anon_sym___constant__] = ACTIONS(3648),
    [anon_sym___managed__] = ACTIONS(3648),
    [anon_sym___grid_constant__] = ACTIONS(3648),
    [anon_sym_alignas] = ACTIONS(3648),
    [anon_sym__Alignas] = ACTIONS(3648),
    [sym_primitive_type] = ACTIONS(3648),
    [anon_sym_enum] = ACTIONS(3648),
    [anon_sym_class] = ACTIONS(3648),
    [anon_sym_struct] = ACTIONS(3648),
    [anon_sym_union] = ACTIONS(3648),
    [anon_sym_if] = ACTIONS(3648),
    [anon_sym_switch] = ACTIONS(3648),
    [anon_sym_case] = ACTIONS(3648),
    [anon_sym_default] = ACTIONS(3648),
    [anon_sym_while] = ACTIONS(3648),
    [anon_sym_do] = ACTIONS(3648),
    [anon_sym_for] = ACTIONS(3648),
    [anon_sym_return] = ACTIONS(3648),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_continue] = ACTIONS(3648),
    [anon_sym_goto] = ACTIONS(3648),
    [anon_sym___try] = ACTIONS(3648),
    [anon_sym___leave] = ACTIONS(3648),
    [anon_sym_not] = ACTIONS(3648),
    [anon_sym_compl] = ACTIONS(3648),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_sizeof] = ACTIONS(3648),
    [anon_sym___alignof__] = ACTIONS(3648),
    [anon_sym___alignof] = ACTIONS(3648),
    [anon_sym__alignof] = ACTIONS(3648),
    [anon_sym_alignof] = ACTIONS(3648),
    [anon_sym__Alignof] = ACTIONS(3648),
    [anon_sym_offsetof] = ACTIONS(3648),
    [anon_sym__Generic] = ACTIONS(3648),
    [anon_sym_asm] = ACTIONS(3648),
    [anon_sym___asm__] = ACTIONS(3648),
    [sym_number_literal] = ACTIONS(3650),
    [anon_sym_L_SQUOTE] = ACTIONS(3650),
    [anon_sym_u_SQUOTE] = ACTIONS(3650),
    [anon_sym_U_SQUOTE] = ACTIONS(3650),
    [anon_sym_u8_SQUOTE] = ACTIONS(3650),
    [anon_sym_SQUOTE] = ACTIONS(3650),
    [anon_sym_L_DQUOTE] = ACTIONS(3650),
    [anon_sym_u_DQUOTE] = ACTIONS(3650),
    [anon_sym_U_DQUOTE] = ACTIONS(3650),
    [anon_sym_u8_DQUOTE] = ACTIONS(3650),
    [anon_sym_DQUOTE] = ACTIONS(3650),
    [sym_true] = ACTIONS(3648),
    [sym_false] = ACTIONS(3648),
    [anon_sym_NULL] = ACTIONS(3648),
    [anon_sym_nullptr] = ACTIONS(3648),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3648),
    [anon_sym_decltype] = ACTIONS(3648),
    [sym_virtual] = ACTIONS(3648),
    [anon_sym_typename] = ACTIONS(3648),
    [anon_sym_template] = ACTIONS(3648),
    [anon_sym_try] = ACTIONS(3648),
    [anon_sym_delete] = ACTIONS(3648),
    [anon_sym_throw] = ACTIONS(3648),
    [anon_sym_co_return] = ACTIONS(3648),
    [anon_sym_co_yield] = ACTIONS(3648),
    [anon_sym_R_DQUOTE] = ACTIONS(3650),
    [anon_sym_LR_DQUOTE] = ACTIONS(3650),
    [anon_sym_uR_DQUOTE] = ACTIONS(3650),
    [anon_sym_UR_DQUOTE] = ACTIONS(3650),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3650),
    [anon_sym_co_await] = ACTIONS(3648),
    [anon_sym_new] = ACTIONS(3648),
    [anon_sym_requires] = ACTIONS(3648),
    [sym_this] = ACTIONS(3648),
    [anon_sym___launch_bounds__] = ACTIONS(3648),
  },
  [866] = {
    [sym_identifier] = ACTIONS(2020),
    [anon_sym_LPAREN2] = ACTIONS(2022),
    [anon_sym_BANG] = ACTIONS(2022),
    [anon_sym_TILDE] = ACTIONS(2022),
    [anon_sym_DASH] = ACTIONS(2020),
    [anon_sym_PLUS] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(2022),
    [anon_sym_AMP] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2022),
    [anon_sym___extension__] = ACTIONS(2020),
    [anon_sym_typedef] = ACTIONS(2020),
    [anon_sym___device__] = ACTIONS(2020),
    [anon_sym___host__] = ACTIONS(2020),
    [anon_sym___global__] = ACTIONS(2020),
    [anon_sym___forceinline__] = ACTIONS(2020),
    [anon_sym___noinline__] = ACTIONS(2020),
    [anon_sym_extern] = ACTIONS(2020),
    [anon_sym___attribute__] = ACTIONS(2020),
    [anon_sym_COLON_COLON] = ACTIONS(2022),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2022),
    [anon_sym___declspec] = ACTIONS(2020),
    [anon_sym_LBRACE] = ACTIONS(2022),
    [anon_sym_signed] = ACTIONS(2020),
    [anon_sym_unsigned] = ACTIONS(2020),
    [anon_sym_long] = ACTIONS(2020),
    [anon_sym_short] = ACTIONS(2020),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(2020),
    [anon_sym_register] = ACTIONS(2020),
    [anon_sym_inline] = ACTIONS(2020),
    [anon_sym___inline] = ACTIONS(2020),
    [anon_sym___inline__] = ACTIONS(2020),
    [anon_sym___forceinline] = ACTIONS(2020),
    [anon_sym_thread_local] = ACTIONS(2020),
    [anon_sym___thread] = ACTIONS(2020),
    [anon_sym_const] = ACTIONS(2020),
    [anon_sym_constexpr] = ACTIONS(2020),
    [anon_sym_volatile] = ACTIONS(2020),
    [anon_sym_restrict] = ACTIONS(2020),
    [anon_sym___restrict__] = ACTIONS(2020),
    [anon_sym__Atomic] = ACTIONS(2020),
    [anon_sym__Noreturn] = ACTIONS(2020),
    [anon_sym_noreturn] = ACTIONS(2020),
    [anon_sym_mutable] = ACTIONS(2020),
    [anon_sym_constinit] = ACTIONS(2020),
    [anon_sym_consteval] = ACTIONS(2020),
    [anon_sym___shared__] = ACTIONS(2020),
    [anon_sym___local__] = ACTIONS(2020),
    [anon_sym___constant__] = ACTIONS(2020),
    [anon_sym___managed__] = ACTIONS(2020),
    [anon_sym___grid_constant__] = ACTIONS(2020),
    [anon_sym_alignas] = ACTIONS(2020),
    [anon_sym__Alignas] = ACTIONS(2020),
    [sym_primitive_type] = ACTIONS(2020),
    [anon_sym_enum] = ACTIONS(2020),
    [anon_sym_class] = ACTIONS(2020),
    [anon_sym_struct] = ACTIONS(2020),
    [anon_sym_union] = ACTIONS(2020),
    [anon_sym_if] = ACTIONS(2020),
    [anon_sym_else] = ACTIONS(2020),
    [anon_sym_switch] = ACTIONS(2020),
    [anon_sym_while] = ACTIONS(2020),
    [anon_sym_do] = ACTIONS(2020),
    [anon_sym_for] = ACTIONS(2020),
    [anon_sym_return] = ACTIONS(2020),
    [anon_sym_break] = ACTIONS(2020),
    [anon_sym_continue] = ACTIONS(2020),
    [anon_sym_goto] = ACTIONS(2020),
    [anon_sym___try] = ACTIONS(2020),
    [anon_sym___leave] = ACTIONS(2020),
    [anon_sym_not] = ACTIONS(2020),
    [anon_sym_compl] = ACTIONS(2020),
    [anon_sym_DASH_DASH] = ACTIONS(2022),
    [anon_sym_PLUS_PLUS] = ACTIONS(2022),
    [anon_sym_sizeof] = ACTIONS(2020),
    [anon_sym___alignof__] = ACTIONS(2020),
    [anon_sym___alignof] = ACTIONS(2020),
    [anon_sym__alignof] = ACTIONS(2020),
    [anon_sym_alignof] = ACTIONS(2020),
    [anon_sym__Alignof] = ACTIONS(2020),
    [anon_sym_offsetof] = ACTIONS(2020),
    [anon_sym__Generic] = ACTIONS(2020),
    [anon_sym_asm] = ACTIONS(2020),
    [anon_sym___asm__] = ACTIONS(2020),
    [sym_number_literal] = ACTIONS(2022),
    [anon_sym_L_SQUOTE] = ACTIONS(2022),
    [anon_sym_u_SQUOTE] = ACTIONS(2022),
    [anon_sym_U_SQUOTE] = ACTIONS(2022),
    [anon_sym_u8_SQUOTE] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(2022),
    [anon_sym_L_DQUOTE] = ACTIONS(2022),
    [anon_sym_u_DQUOTE] = ACTIONS(2022),
    [anon_sym_U_DQUOTE] = ACTIONS(2022),
    [anon_sym_u8_DQUOTE] = ACTIONS(2022),
    [anon_sym_DQUOTE] = ACTIONS(2022),
    [sym_true] = ACTIONS(2020),
    [sym_false] = ACTIONS(2020),
    [anon_sym_NULL] = ACTIONS(2020),
    [anon_sym_nullptr] = ACTIONS(2020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2020),
    [anon_sym_decltype] = ACTIONS(2020),
    [sym_virtual] = ACTIONS(2020),
    [anon_sym_typename] = ACTIONS(2020),
    [anon_sym_template] = ACTIONS(2020),
    [anon_sym_try] = ACTIONS(2020),
    [anon_sym_delete] = ACTIONS(2020),
    [anon_sym_throw] = ACTIONS(2020),
    [anon_sym_co_return] = ACTIONS(2020),
    [anon_sym_co_yield] = ACTIONS(2020),
    [anon_sym_R_DQUOTE] = ACTIONS(2022),
    [anon_sym_LR_DQUOTE] = ACTIONS(2022),
    [anon_sym_uR_DQUOTE] = ACTIONS(2022),
    [anon_sym_UR_DQUOTE] = ACTIONS(2022),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2022),
    [anon_sym_co_await] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(2020),
    [anon_sym_requires] = ACTIONS(2020),
    [sym_this] = ACTIONS(2020),
    [anon_sym___launch_bounds__] = ACTIONS(2020),
  },
  [867] = {
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_LPAREN2] = ACTIONS(2062),
    [anon_sym_BANG] = ACTIONS(2062),
    [anon_sym_TILDE] = ACTIONS(2062),
    [anon_sym_DASH] = ACTIONS(2060),
    [anon_sym_PLUS] = ACTIONS(2060),
    [anon_sym_STAR] = ACTIONS(2062),
    [anon_sym_AMP] = ACTIONS(2062),
    [anon_sym_SEMI] = ACTIONS(2062),
    [anon_sym___extension__] = ACTIONS(2060),
    [anon_sym_typedef] = ACTIONS(2060),
    [anon_sym___device__] = ACTIONS(2060),
    [anon_sym___host__] = ACTIONS(2060),
    [anon_sym___global__] = ACTIONS(2060),
    [anon_sym___forceinline__] = ACTIONS(2060),
    [anon_sym___noinline__] = ACTIONS(2060),
    [anon_sym_extern] = ACTIONS(2060),
    [anon_sym___attribute__] = ACTIONS(2060),
    [anon_sym_COLON_COLON] = ACTIONS(2062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2062),
    [anon_sym___declspec] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(2062),
    [anon_sym_signed] = ACTIONS(2060),
    [anon_sym_unsigned] = ACTIONS(2060),
    [anon_sym_long] = ACTIONS(2060),
    [anon_sym_short] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2060),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_register] = ACTIONS(2060),
    [anon_sym_inline] = ACTIONS(2060),
    [anon_sym___inline] = ACTIONS(2060),
    [anon_sym___inline__] = ACTIONS(2060),
    [anon_sym___forceinline] = ACTIONS(2060),
    [anon_sym_thread_local] = ACTIONS(2060),
    [anon_sym___thread] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_constexpr] = ACTIONS(2060),
    [anon_sym_volatile] = ACTIONS(2060),
    [anon_sym_restrict] = ACTIONS(2060),
    [anon_sym___restrict__] = ACTIONS(2060),
    [anon_sym__Atomic] = ACTIONS(2060),
    [anon_sym__Noreturn] = ACTIONS(2060),
    [anon_sym_noreturn] = ACTIONS(2060),
    [anon_sym_mutable] = ACTIONS(2060),
    [anon_sym_constinit] = ACTIONS(2060),
    [anon_sym_consteval] = ACTIONS(2060),
    [anon_sym___shared__] = ACTIONS(2060),
    [anon_sym___local__] = ACTIONS(2060),
    [anon_sym___constant__] = ACTIONS(2060),
    [anon_sym___managed__] = ACTIONS(2060),
    [anon_sym___grid_constant__] = ACTIONS(2060),
    [anon_sym_alignas] = ACTIONS(2060),
    [anon_sym__Alignas] = ACTIONS(2060),
    [sym_primitive_type] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_struct] = ACTIONS(2060),
    [anon_sym_union] = ACTIONS(2060),
    [anon_sym_if] = ACTIONS(2060),
    [anon_sym_else] = ACTIONS(2060),
    [anon_sym_switch] = ACTIONS(2060),
    [anon_sym_while] = ACTIONS(2060),
    [anon_sym_do] = ACTIONS(2060),
    [anon_sym_for] = ACTIONS(2060),
    [anon_sym_return] = ACTIONS(2060),
    [anon_sym_break] = ACTIONS(2060),
    [anon_sym_continue] = ACTIONS(2060),
    [anon_sym_goto] = ACTIONS(2060),
    [anon_sym___try] = ACTIONS(2060),
    [anon_sym___leave] = ACTIONS(2060),
    [anon_sym_not] = ACTIONS(2060),
    [anon_sym_compl] = ACTIONS(2060),
    [anon_sym_DASH_DASH] = ACTIONS(2062),
    [anon_sym_PLUS_PLUS] = ACTIONS(2062),
    [anon_sym_sizeof] = ACTIONS(2060),
    [anon_sym___alignof__] = ACTIONS(2060),
    [anon_sym___alignof] = ACTIONS(2060),
    [anon_sym__alignof] = ACTIONS(2060),
    [anon_sym_alignof] = ACTIONS(2060),
    [anon_sym__Alignof] = ACTIONS(2060),
    [anon_sym_offsetof] = ACTIONS(2060),
    [anon_sym__Generic] = ACTIONS(2060),
    [anon_sym_asm] = ACTIONS(2060),
    [anon_sym___asm__] = ACTIONS(2060),
    [sym_number_literal] = ACTIONS(2062),
    [anon_sym_L_SQUOTE] = ACTIONS(2062),
    [anon_sym_u_SQUOTE] = ACTIONS(2062),
    [anon_sym_U_SQUOTE] = ACTIONS(2062),
    [anon_sym_u8_SQUOTE] = ACTIONS(2062),
    [anon_sym_SQUOTE] = ACTIONS(2062),
    [anon_sym_L_DQUOTE] = ACTIONS(2062),
    [anon_sym_u_DQUOTE] = ACTIONS(2062),
    [anon_sym_U_DQUOTE] = ACTIONS(2062),
    [anon_sym_u8_DQUOTE] = ACTIONS(2062),
    [anon_sym_DQUOTE] = ACTIONS(2062),
    [sym_true] = ACTIONS(2060),
    [sym_false] = ACTIONS(2060),
    [anon_sym_NULL] = ACTIONS(2060),
    [anon_sym_nullptr] = ACTIONS(2060),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2060),
    [anon_sym_decltype] = ACTIONS(2060),
    [sym_virtual] = ACTIONS(2060),
    [anon_sym_typename] = ACTIONS(2060),
    [anon_sym_template] = ACTIONS(2060),
    [anon_sym_try] = ACTIONS(2060),
    [anon_sym_delete] = ACTIONS(2060),
    [anon_sym_throw] = ACTIONS(2060),
    [anon_sym_co_return] = ACTIONS(2060),
    [anon_sym_co_yield] = ACTIONS(2060),
    [anon_sym_R_DQUOTE] = ACTIONS(2062),
    [anon_sym_LR_DQUOTE] = ACTIONS(2062),
    [anon_sym_uR_DQUOTE] = ACTIONS(2062),
    [anon_sym_UR_DQUOTE] = ACTIONS(2062),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2062),
    [anon_sym_co_await] = ACTIONS(2060),
    [anon_sym_new] = ACTIONS(2060),
    [anon_sym_requires] = ACTIONS(2060),
    [sym_this] = ACTIONS(2060),
    [anon_sym___launch_bounds__] = ACTIONS(2060),
  },
  [868] = {
    [sym_identifier] = ACTIONS(2024),
    [anon_sym_LPAREN2] = ACTIONS(2026),
    [anon_sym_BANG] = ACTIONS(2026),
    [anon_sym_TILDE] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2024),
    [anon_sym_PLUS] = ACTIONS(2024),
    [anon_sym_STAR] = ACTIONS(2026),
    [anon_sym_AMP] = ACTIONS(2026),
    [anon_sym_SEMI] = ACTIONS(2026),
    [anon_sym___extension__] = ACTIONS(2024),
    [anon_sym_typedef] = ACTIONS(2024),
    [anon_sym___device__] = ACTIONS(2024),
    [anon_sym___host__] = ACTIONS(2024),
    [anon_sym___global__] = ACTIONS(2024),
    [anon_sym___forceinline__] = ACTIONS(2024),
    [anon_sym___noinline__] = ACTIONS(2024),
    [anon_sym_extern] = ACTIONS(2024),
    [anon_sym___attribute__] = ACTIONS(2024),
    [anon_sym_COLON_COLON] = ACTIONS(2026),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2026),
    [anon_sym___declspec] = ACTIONS(2024),
    [anon_sym_LBRACE] = ACTIONS(2026),
    [anon_sym_signed] = ACTIONS(2024),
    [anon_sym_unsigned] = ACTIONS(2024),
    [anon_sym_long] = ACTIONS(2024),
    [anon_sym_short] = ACTIONS(2024),
    [anon_sym_LBRACK] = ACTIONS(2024),
    [anon_sym_static] = ACTIONS(2024),
    [anon_sym_register] = ACTIONS(2024),
    [anon_sym_inline] = ACTIONS(2024),
    [anon_sym___inline] = ACTIONS(2024),
    [anon_sym___inline__] = ACTIONS(2024),
    [anon_sym___forceinline] = ACTIONS(2024),
    [anon_sym_thread_local] = ACTIONS(2024),
    [anon_sym___thread] = ACTIONS(2024),
    [anon_sym_const] = ACTIONS(2024),
    [anon_sym_constexpr] = ACTIONS(2024),
    [anon_sym_volatile] = ACTIONS(2024),
    [anon_sym_restrict] = ACTIONS(2024),
    [anon_sym___restrict__] = ACTIONS(2024),
    [anon_sym__Atomic] = ACTIONS(2024),
    [anon_sym__Noreturn] = ACTIONS(2024),
    [anon_sym_noreturn] = ACTIONS(2024),
    [anon_sym_mutable] = ACTIONS(2024),
    [anon_sym_constinit] = ACTIONS(2024),
    [anon_sym_consteval] = ACTIONS(2024),
    [anon_sym___shared__] = ACTIONS(2024),
    [anon_sym___local__] = ACTIONS(2024),
    [anon_sym___constant__] = ACTIONS(2024),
    [anon_sym___managed__] = ACTIONS(2024),
    [anon_sym___grid_constant__] = ACTIONS(2024),
    [anon_sym_alignas] = ACTIONS(2024),
    [anon_sym__Alignas] = ACTIONS(2024),
    [sym_primitive_type] = ACTIONS(2024),
    [anon_sym_enum] = ACTIONS(2024),
    [anon_sym_class] = ACTIONS(2024),
    [anon_sym_struct] = ACTIONS(2024),
    [anon_sym_union] = ACTIONS(2024),
    [anon_sym_if] = ACTIONS(2024),
    [anon_sym_else] = ACTIONS(2024),
    [anon_sym_switch] = ACTIONS(2024),
    [anon_sym_while] = ACTIONS(2024),
    [anon_sym_do] = ACTIONS(2024),
    [anon_sym_for] = ACTIONS(2024),
    [anon_sym_return] = ACTIONS(2024),
    [anon_sym_break] = ACTIONS(2024),
    [anon_sym_continue] = ACTIONS(2024),
    [anon_sym_goto] = ACTIONS(2024),
    [anon_sym___try] = ACTIONS(2024),
    [anon_sym___leave] = ACTIONS(2024),
    [anon_sym_not] = ACTIONS(2024),
    [anon_sym_compl] = ACTIONS(2024),
    [anon_sym_DASH_DASH] = ACTIONS(2026),
    [anon_sym_PLUS_PLUS] = ACTIONS(2026),
    [anon_sym_sizeof] = ACTIONS(2024),
    [anon_sym___alignof__] = ACTIONS(2024),
    [anon_sym___alignof] = ACTIONS(2024),
    [anon_sym__alignof] = ACTIONS(2024),
    [anon_sym_alignof] = ACTIONS(2024),
    [anon_sym__Alignof] = ACTIONS(2024),
    [anon_sym_offsetof] = ACTIONS(2024),
    [anon_sym__Generic] = ACTIONS(2024),
    [anon_sym_asm] = ACTIONS(2024),
    [anon_sym___asm__] = ACTIONS(2024),
    [sym_number_literal] = ACTIONS(2026),
    [anon_sym_L_SQUOTE] = ACTIONS(2026),
    [anon_sym_u_SQUOTE] = ACTIONS(2026),
    [anon_sym_U_SQUOTE] = ACTIONS(2026),
    [anon_sym_u8_SQUOTE] = ACTIONS(2026),
    [anon_sym_SQUOTE] = ACTIONS(2026),
    [anon_sym_L_DQUOTE] = ACTIONS(2026),
    [anon_sym_u_DQUOTE] = ACTIONS(2026),
    [anon_sym_U_DQUOTE] = ACTIONS(2026),
    [anon_sym_u8_DQUOTE] = ACTIONS(2026),
    [anon_sym_DQUOTE] = ACTIONS(2026),
    [sym_true] = ACTIONS(2024),
    [sym_false] = ACTIONS(2024),
    [anon_sym_NULL] = ACTIONS(2024),
    [anon_sym_nullptr] = ACTIONS(2024),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2024),
    [anon_sym_decltype] = ACTIONS(2024),
    [sym_virtual] = ACTIONS(2024),
    [anon_sym_typename] = ACTIONS(2024),
    [anon_sym_template] = ACTIONS(2024),
    [anon_sym_try] = ACTIONS(2024),
    [anon_sym_delete] = ACTIONS(2024),
    [anon_sym_throw] = ACTIONS(2024),
    [anon_sym_co_return] = ACTIONS(2024),
    [anon_sym_co_yield] = ACTIONS(2024),
    [anon_sym_R_DQUOTE] = ACTIONS(2026),
    [anon_sym_LR_DQUOTE] = ACTIONS(2026),
    [anon_sym_uR_DQUOTE] = ACTIONS(2026),
    [anon_sym_UR_DQUOTE] = ACTIONS(2026),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2026),
    [anon_sym_co_await] = ACTIONS(2024),
    [anon_sym_new] = ACTIONS(2024),
    [anon_sym_requires] = ACTIONS(2024),
    [sym_this] = ACTIONS(2024),
    [anon_sym___launch_bounds__] = ACTIONS(2024),
  },
  [869] = {
    [sym_identifier] = ACTIONS(2056),
    [anon_sym_LPAREN2] = ACTIONS(2058),
    [anon_sym_BANG] = ACTIONS(2058),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_DASH] = ACTIONS(2056),
    [anon_sym_PLUS] = ACTIONS(2056),
    [anon_sym_STAR] = ACTIONS(2058),
    [anon_sym_AMP] = ACTIONS(2058),
    [anon_sym_SEMI] = ACTIONS(2058),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_typedef] = ACTIONS(2056),
    [anon_sym___device__] = ACTIONS(2056),
    [anon_sym___host__] = ACTIONS(2056),
    [anon_sym___global__] = ACTIONS(2056),
    [anon_sym___forceinline__] = ACTIONS(2056),
    [anon_sym___noinline__] = ACTIONS(2056),
    [anon_sym_extern] = ACTIONS(2056),
    [anon_sym___attribute__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2058),
    [anon_sym___declspec] = ACTIONS(2056),
    [anon_sym_LBRACE] = ACTIONS(2058),
    [anon_sym_signed] = ACTIONS(2056),
    [anon_sym_unsigned] = ACTIONS(2056),
    [anon_sym_long] = ACTIONS(2056),
    [anon_sym_short] = ACTIONS(2056),
    [anon_sym_LBRACK] = ACTIONS(2056),
    [anon_sym_static] = ACTIONS(2056),
    [anon_sym_register] = ACTIONS(2056),
    [anon_sym_inline] = ACTIONS(2056),
    [anon_sym___inline] = ACTIONS(2056),
    [anon_sym___inline__] = ACTIONS(2056),
    [anon_sym___forceinline] = ACTIONS(2056),
    [anon_sym_thread_local] = ACTIONS(2056),
    [anon_sym___thread] = ACTIONS(2056),
    [anon_sym_const] = ACTIONS(2056),
    [anon_sym_constexpr] = ACTIONS(2056),
    [anon_sym_volatile] = ACTIONS(2056),
    [anon_sym_restrict] = ACTIONS(2056),
    [anon_sym___restrict__] = ACTIONS(2056),
    [anon_sym__Atomic] = ACTIONS(2056),
    [anon_sym__Noreturn] = ACTIONS(2056),
    [anon_sym_noreturn] = ACTIONS(2056),
    [anon_sym_mutable] = ACTIONS(2056),
    [anon_sym_constinit] = ACTIONS(2056),
    [anon_sym_consteval] = ACTIONS(2056),
    [anon_sym___shared__] = ACTIONS(2056),
    [anon_sym___local__] = ACTIONS(2056),
    [anon_sym___constant__] = ACTIONS(2056),
    [anon_sym___managed__] = ACTIONS(2056),
    [anon_sym___grid_constant__] = ACTIONS(2056),
    [anon_sym_alignas] = ACTIONS(2056),
    [anon_sym__Alignas] = ACTIONS(2056),
    [sym_primitive_type] = ACTIONS(2056),
    [anon_sym_enum] = ACTIONS(2056),
    [anon_sym_class] = ACTIONS(2056),
    [anon_sym_struct] = ACTIONS(2056),
    [anon_sym_union] = ACTIONS(2056),
    [anon_sym_if] = ACTIONS(2056),
    [anon_sym_else] = ACTIONS(2056),
    [anon_sym_switch] = ACTIONS(2056),
    [anon_sym_while] = ACTIONS(2056),
    [anon_sym_do] = ACTIONS(2056),
    [anon_sym_for] = ACTIONS(2056),
    [anon_sym_return] = ACTIONS(2056),
    [anon_sym_break] = ACTIONS(2056),
    [anon_sym_continue] = ACTIONS(2056),
    [anon_sym_goto] = ACTIONS(2056),
    [anon_sym___try] = ACTIONS(2056),
    [anon_sym___leave] = ACTIONS(2056),
    [anon_sym_not] = ACTIONS(2056),
    [anon_sym_compl] = ACTIONS(2056),
    [anon_sym_DASH_DASH] = ACTIONS(2058),
    [anon_sym_PLUS_PLUS] = ACTIONS(2058),
    [anon_sym_sizeof] = ACTIONS(2056),
    [anon_sym___alignof__] = ACTIONS(2056),
    [anon_sym___alignof] = ACTIONS(2056),
    [anon_sym__alignof] = ACTIONS(2056),
    [anon_sym_alignof] = ACTIONS(2056),
    [anon_sym__Alignof] = ACTIONS(2056),
    [anon_sym_offsetof] = ACTIONS(2056),
    [anon_sym__Generic] = ACTIONS(2056),
    [anon_sym_asm] = ACTIONS(2056),
    [anon_sym___asm__] = ACTIONS(2056),
    [sym_number_literal] = ACTIONS(2058),
    [anon_sym_L_SQUOTE] = ACTIONS(2058),
    [anon_sym_u_SQUOTE] = ACTIONS(2058),
    [anon_sym_U_SQUOTE] = ACTIONS(2058),
    [anon_sym_u8_SQUOTE] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [anon_sym_L_DQUOTE] = ACTIONS(2058),
    [anon_sym_u_DQUOTE] = ACTIONS(2058),
    [anon_sym_U_DQUOTE] = ACTIONS(2058),
    [anon_sym_u8_DQUOTE] = ACTIONS(2058),
    [anon_sym_DQUOTE] = ACTIONS(2058),
    [sym_true] = ACTIONS(2056),
    [sym_false] = ACTIONS(2056),
    [anon_sym_NULL] = ACTIONS(2056),
    [anon_sym_nullptr] = ACTIONS(2056),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2056),
    [anon_sym_decltype] = ACTIONS(2056),
    [sym_virtual] = ACTIONS(2056),
    [anon_sym_typename] = ACTIONS(2056),
    [anon_sym_template] = ACTIONS(2056),
    [anon_sym_try] = ACTIONS(2056),
    [anon_sym_delete] = ACTIONS(2056),
    [anon_sym_throw] = ACTIONS(2056),
    [anon_sym_co_return] = ACTIONS(2056),
    [anon_sym_co_yield] = ACTIONS(2056),
    [anon_sym_R_DQUOTE] = ACTIONS(2058),
    [anon_sym_LR_DQUOTE] = ACTIONS(2058),
    [anon_sym_uR_DQUOTE] = ACTIONS(2058),
    [anon_sym_UR_DQUOTE] = ACTIONS(2058),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2058),
    [anon_sym_co_await] = ACTIONS(2056),
    [anon_sym_new] = ACTIONS(2056),
    [anon_sym_requires] = ACTIONS(2056),
    [sym_this] = ACTIONS(2056),
    [anon_sym___launch_bounds__] = ACTIONS(2056),
  },
  [870] = {
    [sym_identifier] = ACTIONS(2048),
    [anon_sym_LPAREN2] = ACTIONS(2050),
    [anon_sym_BANG] = ACTIONS(2050),
    [anon_sym_TILDE] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2048),
    [anon_sym_PLUS] = ACTIONS(2048),
    [anon_sym_STAR] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_SEMI] = ACTIONS(2050),
    [anon_sym___extension__] = ACTIONS(2048),
    [anon_sym_typedef] = ACTIONS(2048),
    [anon_sym___device__] = ACTIONS(2048),
    [anon_sym___host__] = ACTIONS(2048),
    [anon_sym___global__] = ACTIONS(2048),
    [anon_sym___forceinline__] = ACTIONS(2048),
    [anon_sym___noinline__] = ACTIONS(2048),
    [anon_sym_extern] = ACTIONS(2048),
    [anon_sym___attribute__] = ACTIONS(2048),
    [anon_sym_COLON_COLON] = ACTIONS(2050),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2050),
    [anon_sym___declspec] = ACTIONS(2048),
    [anon_sym_LBRACE] = ACTIONS(2050),
    [anon_sym_signed] = ACTIONS(2048),
    [anon_sym_unsigned] = ACTIONS(2048),
    [anon_sym_long] = ACTIONS(2048),
    [anon_sym_short] = ACTIONS(2048),
    [anon_sym_LBRACK] = ACTIONS(2048),
    [anon_sym_static] = ACTIONS(2048),
    [anon_sym_register] = ACTIONS(2048),
    [anon_sym_inline] = ACTIONS(2048),
    [anon_sym___inline] = ACTIONS(2048),
    [anon_sym___inline__] = ACTIONS(2048),
    [anon_sym___forceinline] = ACTIONS(2048),
    [anon_sym_thread_local] = ACTIONS(2048),
    [anon_sym___thread] = ACTIONS(2048),
    [anon_sym_const] = ACTIONS(2048),
    [anon_sym_constexpr] = ACTIONS(2048),
    [anon_sym_volatile] = ACTIONS(2048),
    [anon_sym_restrict] = ACTIONS(2048),
    [anon_sym___restrict__] = ACTIONS(2048),
    [anon_sym__Atomic] = ACTIONS(2048),
    [anon_sym__Noreturn] = ACTIONS(2048),
    [anon_sym_noreturn] = ACTIONS(2048),
    [anon_sym_mutable] = ACTIONS(2048),
    [anon_sym_constinit] = ACTIONS(2048),
    [anon_sym_consteval] = ACTIONS(2048),
    [anon_sym___shared__] = ACTIONS(2048),
    [anon_sym___local__] = ACTIONS(2048),
    [anon_sym___constant__] = ACTIONS(2048),
    [anon_sym___managed__] = ACTIONS(2048),
    [anon_sym___grid_constant__] = ACTIONS(2048),
    [anon_sym_alignas] = ACTIONS(2048),
    [anon_sym__Alignas] = ACTIONS(2048),
    [sym_primitive_type] = ACTIONS(2048),
    [anon_sym_enum] = ACTIONS(2048),
    [anon_sym_class] = ACTIONS(2048),
    [anon_sym_struct] = ACTIONS(2048),
    [anon_sym_union] = ACTIONS(2048),
    [anon_sym_if] = ACTIONS(2048),
    [anon_sym_else] = ACTIONS(2048),
    [anon_sym_switch] = ACTIONS(2048),
    [anon_sym_while] = ACTIONS(2048),
    [anon_sym_do] = ACTIONS(2048),
    [anon_sym_for] = ACTIONS(2048),
    [anon_sym_return] = ACTIONS(2048),
    [anon_sym_break] = ACTIONS(2048),
    [anon_sym_continue] = ACTIONS(2048),
    [anon_sym_goto] = ACTIONS(2048),
    [anon_sym___try] = ACTIONS(2048),
    [anon_sym___leave] = ACTIONS(2048),
    [anon_sym_not] = ACTIONS(2048),
    [anon_sym_compl] = ACTIONS(2048),
    [anon_sym_DASH_DASH] = ACTIONS(2050),
    [anon_sym_PLUS_PLUS] = ACTIONS(2050),
    [anon_sym_sizeof] = ACTIONS(2048),
    [anon_sym___alignof__] = ACTIONS(2048),
    [anon_sym___alignof] = ACTIONS(2048),
    [anon_sym__alignof] = ACTIONS(2048),
    [anon_sym_alignof] = ACTIONS(2048),
    [anon_sym__Alignof] = ACTIONS(2048),
    [anon_sym_offsetof] = ACTIONS(2048),
    [anon_sym__Generic] = ACTIONS(2048),
    [anon_sym_asm] = ACTIONS(2048),
    [anon_sym___asm__] = ACTIONS(2048),
    [sym_number_literal] = ACTIONS(2050),
    [anon_sym_L_SQUOTE] = ACTIONS(2050),
    [anon_sym_u_SQUOTE] = ACTIONS(2050),
    [anon_sym_U_SQUOTE] = ACTIONS(2050),
    [anon_sym_u8_SQUOTE] = ACTIONS(2050),
    [anon_sym_SQUOTE] = ACTIONS(2050),
    [anon_sym_L_DQUOTE] = ACTIONS(2050),
    [anon_sym_u_DQUOTE] = ACTIONS(2050),
    [anon_sym_U_DQUOTE] = ACTIONS(2050),
    [anon_sym_u8_DQUOTE] = ACTIONS(2050),
    [anon_sym_DQUOTE] = ACTIONS(2050),
    [sym_true] = ACTIONS(2048),
    [sym_false] = ACTIONS(2048),
    [anon_sym_NULL] = ACTIONS(2048),
    [anon_sym_nullptr] = ACTIONS(2048),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2048),
    [anon_sym_decltype] = ACTIONS(2048),
    [sym_virtual] = ACTIONS(2048),
    [anon_sym_typename] = ACTIONS(2048),
    [anon_sym_template] = ACTIONS(2048),
    [anon_sym_try] = ACTIONS(2048),
    [anon_sym_delete] = ACTIONS(2048),
    [anon_sym_throw] = ACTIONS(2048),
    [anon_sym_co_return] = ACTIONS(2048),
    [anon_sym_co_yield] = ACTIONS(2048),
    [anon_sym_R_DQUOTE] = ACTIONS(2050),
    [anon_sym_LR_DQUOTE] = ACTIONS(2050),
    [anon_sym_uR_DQUOTE] = ACTIONS(2050),
    [anon_sym_UR_DQUOTE] = ACTIONS(2050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2050),
    [anon_sym_co_await] = ACTIONS(2048),
    [anon_sym_new] = ACTIONS(2048),
    [anon_sym_requires] = ACTIONS(2048),
    [sym_this] = ACTIONS(2048),
    [anon_sym___launch_bounds__] = ACTIONS(2048),
  },
  [871] = {
    [sym_identifier] = ACTIONS(2028),
    [anon_sym_LPAREN2] = ACTIONS(2030),
    [anon_sym_BANG] = ACTIONS(2030),
    [anon_sym_TILDE] = ACTIONS(2030),
    [anon_sym_DASH] = ACTIONS(2028),
    [anon_sym_PLUS] = ACTIONS(2028),
    [anon_sym_STAR] = ACTIONS(2030),
    [anon_sym_AMP] = ACTIONS(2030),
    [anon_sym_SEMI] = ACTIONS(2030),
    [anon_sym___extension__] = ACTIONS(2028),
    [anon_sym_typedef] = ACTIONS(2028),
    [anon_sym___device__] = ACTIONS(2028),
    [anon_sym___host__] = ACTIONS(2028),
    [anon_sym___global__] = ACTIONS(2028),
    [anon_sym___forceinline__] = ACTIONS(2028),
    [anon_sym___noinline__] = ACTIONS(2028),
    [anon_sym_extern] = ACTIONS(2028),
    [anon_sym___attribute__] = ACTIONS(2028),
    [anon_sym_COLON_COLON] = ACTIONS(2030),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2030),
    [anon_sym___declspec] = ACTIONS(2028),
    [anon_sym_LBRACE] = ACTIONS(2030),
    [anon_sym_signed] = ACTIONS(2028),
    [anon_sym_unsigned] = ACTIONS(2028),
    [anon_sym_long] = ACTIONS(2028),
    [anon_sym_short] = ACTIONS(2028),
    [anon_sym_LBRACK] = ACTIONS(2028),
    [anon_sym_static] = ACTIONS(2028),
    [anon_sym_register] = ACTIONS(2028),
    [anon_sym_inline] = ACTIONS(2028),
    [anon_sym___inline] = ACTIONS(2028),
    [anon_sym___inline__] = ACTIONS(2028),
    [anon_sym___forceinline] = ACTIONS(2028),
    [anon_sym_thread_local] = ACTIONS(2028),
    [anon_sym___thread] = ACTIONS(2028),
    [anon_sym_const] = ACTIONS(2028),
    [anon_sym_constexpr] = ACTIONS(2028),
    [anon_sym_volatile] = ACTIONS(2028),
    [anon_sym_restrict] = ACTIONS(2028),
    [anon_sym___restrict__] = ACTIONS(2028),
    [anon_sym__Atomic] = ACTIONS(2028),
    [anon_sym__Noreturn] = ACTIONS(2028),
    [anon_sym_noreturn] = ACTIONS(2028),
    [anon_sym_mutable] = ACTIONS(2028),
    [anon_sym_constinit] = ACTIONS(2028),
    [anon_sym_consteval] = ACTIONS(2028),
    [anon_sym___shared__] = ACTIONS(2028),
    [anon_sym___local__] = ACTIONS(2028),
    [anon_sym___constant__] = ACTIONS(2028),
    [anon_sym___managed__] = ACTIONS(2028),
    [anon_sym___grid_constant__] = ACTIONS(2028),
    [anon_sym_alignas] = ACTIONS(2028),
    [anon_sym__Alignas] = ACTIONS(2028),
    [sym_primitive_type] = ACTIONS(2028),
    [anon_sym_enum] = ACTIONS(2028),
    [anon_sym_class] = ACTIONS(2028),
    [anon_sym_struct] = ACTIONS(2028),
    [anon_sym_union] = ACTIONS(2028),
    [anon_sym_if] = ACTIONS(2028),
    [anon_sym_else] = ACTIONS(2028),
    [anon_sym_switch] = ACTIONS(2028),
    [anon_sym_while] = ACTIONS(2028),
    [anon_sym_do] = ACTIONS(2028),
    [anon_sym_for] = ACTIONS(2028),
    [anon_sym_return] = ACTIONS(2028),
    [anon_sym_break] = ACTIONS(2028),
    [anon_sym_continue] = ACTIONS(2028),
    [anon_sym_goto] = ACTIONS(2028),
    [anon_sym___try] = ACTIONS(2028),
    [anon_sym___leave] = ACTIONS(2028),
    [anon_sym_not] = ACTIONS(2028),
    [anon_sym_compl] = ACTIONS(2028),
    [anon_sym_DASH_DASH] = ACTIONS(2030),
    [anon_sym_PLUS_PLUS] = ACTIONS(2030),
    [anon_sym_sizeof] = ACTIONS(2028),
    [anon_sym___alignof__] = ACTIONS(2028),
    [anon_sym___alignof] = ACTIONS(2028),
    [anon_sym__alignof] = ACTIONS(2028),
    [anon_sym_alignof] = ACTIONS(2028),
    [anon_sym__Alignof] = ACTIONS(2028),
    [anon_sym_offsetof] = ACTIONS(2028),
    [anon_sym__Generic] = ACTIONS(2028),
    [anon_sym_asm] = ACTIONS(2028),
    [anon_sym___asm__] = ACTIONS(2028),
    [sym_number_literal] = ACTIONS(2030),
    [anon_sym_L_SQUOTE] = ACTIONS(2030),
    [anon_sym_u_SQUOTE] = ACTIONS(2030),
    [anon_sym_U_SQUOTE] = ACTIONS(2030),
    [anon_sym_u8_SQUOTE] = ACTIONS(2030),
    [anon_sym_SQUOTE] = ACTIONS(2030),
    [anon_sym_L_DQUOTE] = ACTIONS(2030),
    [anon_sym_u_DQUOTE] = ACTIONS(2030),
    [anon_sym_U_DQUOTE] = ACTIONS(2030),
    [anon_sym_u8_DQUOTE] = ACTIONS(2030),
    [anon_sym_DQUOTE] = ACTIONS(2030),
    [sym_true] = ACTIONS(2028),
    [sym_false] = ACTIONS(2028),
    [anon_sym_NULL] = ACTIONS(2028),
    [anon_sym_nullptr] = ACTIONS(2028),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2028),
    [anon_sym_decltype] = ACTIONS(2028),
    [sym_virtual] = ACTIONS(2028),
    [anon_sym_typename] = ACTIONS(2028),
    [anon_sym_template] = ACTIONS(2028),
    [anon_sym_try] = ACTIONS(2028),
    [anon_sym_delete] = ACTIONS(2028),
    [anon_sym_throw] = ACTIONS(2028),
    [anon_sym_co_return] = ACTIONS(2028),
    [anon_sym_co_yield] = ACTIONS(2028),
    [anon_sym_R_DQUOTE] = ACTIONS(2030),
    [anon_sym_LR_DQUOTE] = ACTIONS(2030),
    [anon_sym_uR_DQUOTE] = ACTIONS(2030),
    [anon_sym_UR_DQUOTE] = ACTIONS(2030),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2030),
    [anon_sym_co_await] = ACTIONS(2028),
    [anon_sym_new] = ACTIONS(2028),
    [anon_sym_requires] = ACTIONS(2028),
    [sym_this] = ACTIONS(2028),
    [anon_sym___launch_bounds__] = ACTIONS(2028),
  },
  [872] = {
    [sym_identifier] = ACTIONS(3652),
    [anon_sym_LPAREN2] = ACTIONS(3654),
    [anon_sym_BANG] = ACTIONS(3654),
    [anon_sym_TILDE] = ACTIONS(3654),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_AMP] = ACTIONS(3654),
    [anon_sym_SEMI] = ACTIONS(3654),
    [anon_sym___extension__] = ACTIONS(3652),
    [anon_sym___device__] = ACTIONS(3652),
    [anon_sym___host__] = ACTIONS(3652),
    [anon_sym___global__] = ACTIONS(3652),
    [anon_sym___forceinline__] = ACTIONS(3652),
    [anon_sym___noinline__] = ACTIONS(3652),
    [anon_sym_extern] = ACTIONS(3652),
    [anon_sym___attribute__] = ACTIONS(3652),
    [anon_sym_COLON_COLON] = ACTIONS(3654),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3654),
    [anon_sym___declspec] = ACTIONS(3652),
    [anon_sym_LBRACE] = ACTIONS(3654),
    [anon_sym_signed] = ACTIONS(3652),
    [anon_sym_unsigned] = ACTIONS(3652),
    [anon_sym_long] = ACTIONS(3652),
    [anon_sym_short] = ACTIONS(3652),
    [anon_sym_LBRACK] = ACTIONS(3652),
    [anon_sym_static] = ACTIONS(3652),
    [anon_sym_register] = ACTIONS(3652),
    [anon_sym_inline] = ACTIONS(3652),
    [anon_sym___inline] = ACTIONS(3652),
    [anon_sym___inline__] = ACTIONS(3652),
    [anon_sym___forceinline] = ACTIONS(3652),
    [anon_sym_thread_local] = ACTIONS(3652),
    [anon_sym___thread] = ACTIONS(3652),
    [anon_sym_const] = ACTIONS(3652),
    [anon_sym_constexpr] = ACTIONS(3652),
    [anon_sym_volatile] = ACTIONS(3652),
    [anon_sym_restrict] = ACTIONS(3652),
    [anon_sym___restrict__] = ACTIONS(3652),
    [anon_sym__Atomic] = ACTIONS(3652),
    [anon_sym__Noreturn] = ACTIONS(3652),
    [anon_sym_noreturn] = ACTIONS(3652),
    [anon_sym_mutable] = ACTIONS(3652),
    [anon_sym_constinit] = ACTIONS(3652),
    [anon_sym_consteval] = ACTIONS(3652),
    [anon_sym___shared__] = ACTIONS(3652),
    [anon_sym___local__] = ACTIONS(3652),
    [anon_sym___constant__] = ACTIONS(3652),
    [anon_sym___managed__] = ACTIONS(3652),
    [anon_sym___grid_constant__] = ACTIONS(3652),
    [anon_sym_alignas] = ACTIONS(3652),
    [anon_sym__Alignas] = ACTIONS(3652),
    [sym_primitive_type] = ACTIONS(3652),
    [anon_sym_enum] = ACTIONS(3652),
    [anon_sym_class] = ACTIONS(3652),
    [anon_sym_struct] = ACTIONS(3652),
    [anon_sym_union] = ACTIONS(3652),
    [anon_sym_if] = ACTIONS(3652),
    [anon_sym_switch] = ACTIONS(3652),
    [anon_sym_case] = ACTIONS(3652),
    [anon_sym_default] = ACTIONS(3652),
    [anon_sym_while] = ACTIONS(3652),
    [anon_sym_do] = ACTIONS(3652),
    [anon_sym_for] = ACTIONS(3652),
    [anon_sym_return] = ACTIONS(3652),
    [anon_sym_break] = ACTIONS(3652),
    [anon_sym_continue] = ACTIONS(3652),
    [anon_sym_goto] = ACTIONS(3652),
    [anon_sym___try] = ACTIONS(3652),
    [anon_sym___leave] = ACTIONS(3652),
    [anon_sym_not] = ACTIONS(3652),
    [anon_sym_compl] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3654),
    [anon_sym_PLUS_PLUS] = ACTIONS(3654),
    [anon_sym_sizeof] = ACTIONS(3652),
    [anon_sym___alignof__] = ACTIONS(3652),
    [anon_sym___alignof] = ACTIONS(3652),
    [anon_sym__alignof] = ACTIONS(3652),
    [anon_sym_alignof] = ACTIONS(3652),
    [anon_sym__Alignof] = ACTIONS(3652),
    [anon_sym_offsetof] = ACTIONS(3652),
    [anon_sym__Generic] = ACTIONS(3652),
    [anon_sym_asm] = ACTIONS(3652),
    [anon_sym___asm__] = ACTIONS(3652),
    [sym_number_literal] = ACTIONS(3654),
    [anon_sym_L_SQUOTE] = ACTIONS(3654),
    [anon_sym_u_SQUOTE] = ACTIONS(3654),
    [anon_sym_U_SQUOTE] = ACTIONS(3654),
    [anon_sym_u8_SQUOTE] = ACTIONS(3654),
    [anon_sym_SQUOTE] = ACTIONS(3654),
    [anon_sym_L_DQUOTE] = ACTIONS(3654),
    [anon_sym_u_DQUOTE] = ACTIONS(3654),
    [anon_sym_U_DQUOTE] = ACTIONS(3654),
    [anon_sym_u8_DQUOTE] = ACTIONS(3654),
    [anon_sym_DQUOTE] = ACTIONS(3654),
    [sym_true] = ACTIONS(3652),
    [sym_false] = ACTIONS(3652),
    [anon_sym_NULL] = ACTIONS(3652),
    [anon_sym_nullptr] = ACTIONS(3652),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3652),
    [anon_sym_decltype] = ACTIONS(3652),
    [sym_virtual] = ACTIONS(3652),
    [anon_sym_typename] = ACTIONS(3652),
    [anon_sym_template] = ACTIONS(3652),
    [anon_sym_try] = ACTIONS(3652),
    [anon_sym_delete] = ACTIONS(3652),
    [anon_sym_throw] = ACTIONS(3652),
    [anon_sym_co_return] = ACTIONS(3652),
    [anon_sym_co_yield] = ACTIONS(3652),
    [anon_sym_R_DQUOTE] = ACTIONS(3654),
    [anon_sym_LR_DQUOTE] = ACTIONS(3654),
    [anon_sym_uR_DQUOTE] = ACTIONS(3654),
    [anon_sym_UR_DQUOTE] = ACTIONS(3654),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3654),
    [anon_sym_co_await] = ACTIONS(3652),
    [anon_sym_new] = ACTIONS(3652),
    [anon_sym_requires] = ACTIONS(3652),
    [sym_this] = ACTIONS(3652),
    [anon_sym___launch_bounds__] = ACTIONS(3652),
  },
  [873] = {
    [sym_identifier] = ACTIONS(3804),
    [anon_sym_LPAREN2] = ACTIONS(3810),
    [anon_sym_BANG] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3810),
    [anon_sym_DASH] = ACTIONS(3812),
    [anon_sym_PLUS] = ACTIONS(3812),
    [anon_sym_STAR] = ACTIONS(3810),
    [anon_sym_AMP] = ACTIONS(3810),
    [anon_sym_SEMI] = ACTIONS(3810),
    [anon_sym___extension__] = ACTIONS(3816),
    [anon_sym___device__] = ACTIONS(3816),
    [anon_sym___host__] = ACTIONS(3816),
    [anon_sym___global__] = ACTIONS(3816),
    [anon_sym___forceinline__] = ACTIONS(3816),
    [anon_sym___noinline__] = ACTIONS(3816),
    [anon_sym_extern] = ACTIONS(3816),
    [anon_sym___attribute__] = ACTIONS(3816),
    [anon_sym_COLON_COLON] = ACTIONS(3807),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3807),
    [anon_sym___declspec] = ACTIONS(3816),
    [anon_sym_LBRACE] = ACTIONS(3810),
    [anon_sym_signed] = ACTIONS(3816),
    [anon_sym_unsigned] = ACTIONS(3816),
    [anon_sym_long] = ACTIONS(3816),
    [anon_sym_short] = ACTIONS(3816),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3816),
    [anon_sym_register] = ACTIONS(3816),
    [anon_sym_inline] = ACTIONS(3816),
    [anon_sym___inline] = ACTIONS(3816),
    [anon_sym___inline__] = ACTIONS(3816),
    [anon_sym___forceinline] = ACTIONS(3816),
    [anon_sym_thread_local] = ACTIONS(3816),
    [anon_sym___thread] = ACTIONS(3816),
    [anon_sym_const] = ACTIONS(3816),
    [anon_sym_constexpr] = ACTIONS(3816),
    [anon_sym_volatile] = ACTIONS(3816),
    [anon_sym_restrict] = ACTIONS(3816),
    [anon_sym___restrict__] = ACTIONS(3816),
    [anon_sym__Atomic] = ACTIONS(3816),
    [anon_sym__Noreturn] = ACTIONS(3816),
    [anon_sym_noreturn] = ACTIONS(3816),
    [anon_sym_mutable] = ACTIONS(3816),
    [anon_sym_constinit] = ACTIONS(3816),
    [anon_sym_consteval] = ACTIONS(3816),
    [anon_sym___shared__] = ACTIONS(3816),
    [anon_sym___local__] = ACTIONS(3816),
    [anon_sym___constant__] = ACTIONS(3816),
    [anon_sym___managed__] = ACTIONS(3816),
    [anon_sym___grid_constant__] = ACTIONS(3816),
    [anon_sym_alignas] = ACTIONS(3816),
    [anon_sym__Alignas] = ACTIONS(3816),
    [sym_primitive_type] = ACTIONS(3804),
    [anon_sym_enum] = ACTIONS(3816),
    [anon_sym_class] = ACTIONS(3816),
    [anon_sym_struct] = ACTIONS(3816),
    [anon_sym_union] = ACTIONS(3816),
    [anon_sym_if] = ACTIONS(3812),
    [anon_sym_switch] = ACTIONS(3812),
    [anon_sym_case] = ACTIONS(3812),
    [anon_sym_default] = ACTIONS(3812),
    [anon_sym_while] = ACTIONS(3812),
    [anon_sym_do] = ACTIONS(3812),
    [anon_sym_for] = ACTIONS(3812),
    [anon_sym_return] = ACTIONS(3812),
    [anon_sym_break] = ACTIONS(3812),
    [anon_sym_continue] = ACTIONS(3812),
    [anon_sym_goto] = ACTIONS(3812),
    [anon_sym___try] = ACTIONS(3812),
    [anon_sym___leave] = ACTIONS(3812),
    [anon_sym_not] = ACTIONS(3812),
    [anon_sym_compl] = ACTIONS(3812),
    [anon_sym_DASH_DASH] = ACTIONS(3810),
    [anon_sym_PLUS_PLUS] = ACTIONS(3810),
    [anon_sym_sizeof] = ACTIONS(3812),
    [anon_sym___alignof__] = ACTIONS(3812),
    [anon_sym___alignof] = ACTIONS(3812),
    [anon_sym__alignof] = ACTIONS(3812),
    [anon_sym_alignof] = ACTIONS(3812),
    [anon_sym__Alignof] = ACTIONS(3812),
    [anon_sym_offsetof] = ACTIONS(3812),
    [anon_sym__Generic] = ACTIONS(3812),
    [anon_sym_asm] = ACTIONS(3812),
    [anon_sym___asm__] = ACTIONS(3812),
    [sym_number_literal] = ACTIONS(3810),
    [anon_sym_L_SQUOTE] = ACTIONS(3810),
    [anon_sym_u_SQUOTE] = ACTIONS(3810),
    [anon_sym_U_SQUOTE] = ACTIONS(3810),
    [anon_sym_u8_SQUOTE] = ACTIONS(3810),
    [anon_sym_SQUOTE] = ACTIONS(3810),
    [anon_sym_L_DQUOTE] = ACTIONS(3810),
    [anon_sym_u_DQUOTE] = ACTIONS(3810),
    [anon_sym_U_DQUOTE] = ACTIONS(3810),
    [anon_sym_u8_DQUOTE] = ACTIONS(3810),
    [anon_sym_DQUOTE] = ACTIONS(3810),
    [sym_true] = ACTIONS(3812),
    [sym_false] = ACTIONS(3812),
    [anon_sym_NULL] = ACTIONS(3812),
    [anon_sym_nullptr] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3816),
    [anon_sym_decltype] = ACTIONS(3804),
    [sym_virtual] = ACTIONS(3816),
    [anon_sym_typename] = ACTIONS(3816),
    [anon_sym_template] = ACTIONS(3804),
    [anon_sym_try] = ACTIONS(3812),
    [anon_sym_delete] = ACTIONS(3812),
    [anon_sym_throw] = ACTIONS(3812),
    [anon_sym_co_return] = ACTIONS(3812),
    [anon_sym_co_yield] = ACTIONS(3812),
    [anon_sym_R_DQUOTE] = ACTIONS(3810),
    [anon_sym_LR_DQUOTE] = ACTIONS(3810),
    [anon_sym_uR_DQUOTE] = ACTIONS(3810),
    [anon_sym_UR_DQUOTE] = ACTIONS(3810),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3810),
    [anon_sym_co_await] = ACTIONS(3812),
    [anon_sym_new] = ACTIONS(3812),
    [anon_sym_requires] = ACTIONS(3812),
    [sym_this] = ACTIONS(3812),
    [anon_sym___launch_bounds__] = ACTIONS(3816),
  },
  [874] = {
    [sym_identifier] = ACTIONS(2032),
    [anon_sym_LPAREN2] = ACTIONS(2034),
    [anon_sym_BANG] = ACTIONS(2034),
    [anon_sym_TILDE] = ACTIONS(2034),
    [anon_sym_DASH] = ACTIONS(2032),
    [anon_sym_PLUS] = ACTIONS(2032),
    [anon_sym_STAR] = ACTIONS(2034),
    [anon_sym_AMP] = ACTIONS(2034),
    [anon_sym_SEMI] = ACTIONS(2034),
    [anon_sym___extension__] = ACTIONS(2032),
    [anon_sym_typedef] = ACTIONS(2032),
    [anon_sym___device__] = ACTIONS(2032),
    [anon_sym___host__] = ACTIONS(2032),
    [anon_sym___global__] = ACTIONS(2032),
    [anon_sym___forceinline__] = ACTIONS(2032),
    [anon_sym___noinline__] = ACTIONS(2032),
    [anon_sym_extern] = ACTIONS(2032),
    [anon_sym___attribute__] = ACTIONS(2032),
    [anon_sym_COLON_COLON] = ACTIONS(2034),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2034),
    [anon_sym___declspec] = ACTIONS(2032),
    [anon_sym_LBRACE] = ACTIONS(2034),
    [anon_sym_signed] = ACTIONS(2032),
    [anon_sym_unsigned] = ACTIONS(2032),
    [anon_sym_long] = ACTIONS(2032),
    [anon_sym_short] = ACTIONS(2032),
    [anon_sym_LBRACK] = ACTIONS(2032),
    [anon_sym_static] = ACTIONS(2032),
    [anon_sym_register] = ACTIONS(2032),
    [anon_sym_inline] = ACTIONS(2032),
    [anon_sym___inline] = ACTIONS(2032),
    [anon_sym___inline__] = ACTIONS(2032),
    [anon_sym___forceinline] = ACTIONS(2032),
    [anon_sym_thread_local] = ACTIONS(2032),
    [anon_sym___thread] = ACTIONS(2032),
    [anon_sym_const] = ACTIONS(2032),
    [anon_sym_constexpr] = ACTIONS(2032),
    [anon_sym_volatile] = ACTIONS(2032),
    [anon_sym_restrict] = ACTIONS(2032),
    [anon_sym___restrict__] = ACTIONS(2032),
    [anon_sym__Atomic] = ACTIONS(2032),
    [anon_sym__Noreturn] = ACTIONS(2032),
    [anon_sym_noreturn] = ACTIONS(2032),
    [anon_sym_mutable] = ACTIONS(2032),
    [anon_sym_constinit] = ACTIONS(2032),
    [anon_sym_consteval] = ACTIONS(2032),
    [anon_sym___shared__] = ACTIONS(2032),
    [anon_sym___local__] = ACTIONS(2032),
    [anon_sym___constant__] = ACTIONS(2032),
    [anon_sym___managed__] = ACTIONS(2032),
    [anon_sym___grid_constant__] = ACTIONS(2032),
    [anon_sym_alignas] = ACTIONS(2032),
    [anon_sym__Alignas] = ACTIONS(2032),
    [sym_primitive_type] = ACTIONS(2032),
    [anon_sym_enum] = ACTIONS(2032),
    [anon_sym_class] = ACTIONS(2032),
    [anon_sym_struct] = ACTIONS(2032),
    [anon_sym_union] = ACTIONS(2032),
    [anon_sym_if] = ACTIONS(2032),
    [anon_sym_else] = ACTIONS(2032),
    [anon_sym_switch] = ACTIONS(2032),
    [anon_sym_while] = ACTIONS(2032),
    [anon_sym_do] = ACTIONS(2032),
    [anon_sym_for] = ACTIONS(2032),
    [anon_sym_return] = ACTIONS(2032),
    [anon_sym_break] = ACTIONS(2032),
    [anon_sym_continue] = ACTIONS(2032),
    [anon_sym_goto] = ACTIONS(2032),
    [anon_sym___try] = ACTIONS(2032),
    [anon_sym___leave] = ACTIONS(2032),
    [anon_sym_not] = ACTIONS(2032),
    [anon_sym_compl] = ACTIONS(2032),
    [anon_sym_DASH_DASH] = ACTIONS(2034),
    [anon_sym_PLUS_PLUS] = ACTIONS(2034),
    [anon_sym_sizeof] = ACTIONS(2032),
    [anon_sym___alignof__] = ACTIONS(2032),
    [anon_sym___alignof] = ACTIONS(2032),
    [anon_sym__alignof] = ACTIONS(2032),
    [anon_sym_alignof] = ACTIONS(2032),
    [anon_sym__Alignof] = ACTIONS(2032),
    [anon_sym_offsetof] = ACTIONS(2032),
    [anon_sym__Generic] = ACTIONS(2032),
    [anon_sym_asm] = ACTIONS(2032),
    [anon_sym___asm__] = ACTIONS(2032),
    [sym_number_literal] = ACTIONS(2034),
    [anon_sym_L_SQUOTE] = ACTIONS(2034),
    [anon_sym_u_SQUOTE] = ACTIONS(2034),
    [anon_sym_U_SQUOTE] = ACTIONS(2034),
    [anon_sym_u8_SQUOTE] = ACTIONS(2034),
    [anon_sym_SQUOTE] = ACTIONS(2034),
    [anon_sym_L_DQUOTE] = ACTIONS(2034),
    [anon_sym_u_DQUOTE] = ACTIONS(2034),
    [anon_sym_U_DQUOTE] = ACTIONS(2034),
    [anon_sym_u8_DQUOTE] = ACTIONS(2034),
    [anon_sym_DQUOTE] = ACTIONS(2034),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [anon_sym_NULL] = ACTIONS(2032),
    [anon_sym_nullptr] = ACTIONS(2032),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2032),
    [anon_sym_decltype] = ACTIONS(2032),
    [sym_virtual] = ACTIONS(2032),
    [anon_sym_typename] = ACTIONS(2032),
    [anon_sym_template] = ACTIONS(2032),
    [anon_sym_try] = ACTIONS(2032),
    [anon_sym_delete] = ACTIONS(2032),
    [anon_sym_throw] = ACTIONS(2032),
    [anon_sym_co_return] = ACTIONS(2032),
    [anon_sym_co_yield] = ACTIONS(2032),
    [anon_sym_R_DQUOTE] = ACTIONS(2034),
    [anon_sym_LR_DQUOTE] = ACTIONS(2034),
    [anon_sym_uR_DQUOTE] = ACTIONS(2034),
    [anon_sym_UR_DQUOTE] = ACTIONS(2034),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2034),
    [anon_sym_co_await] = ACTIONS(2032),
    [anon_sym_new] = ACTIONS(2032),
    [anon_sym_requires] = ACTIONS(2032),
    [sym_this] = ACTIONS(2032),
    [anon_sym___launch_bounds__] = ACTIONS(2032),
  },
  [875] = {
    [sym_identifier] = ACTIONS(2044),
    [anon_sym_LPAREN2] = ACTIONS(2046),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2044),
    [anon_sym_PLUS] = ACTIONS(2044),
    [anon_sym_STAR] = ACTIONS(2046),
    [anon_sym_AMP] = ACTIONS(2046),
    [anon_sym_SEMI] = ACTIONS(2046),
    [anon_sym___extension__] = ACTIONS(2044),
    [anon_sym_typedef] = ACTIONS(2044),
    [anon_sym___device__] = ACTIONS(2044),
    [anon_sym___host__] = ACTIONS(2044),
    [anon_sym___global__] = ACTIONS(2044),
    [anon_sym___forceinline__] = ACTIONS(2044),
    [anon_sym___noinline__] = ACTIONS(2044),
    [anon_sym_extern] = ACTIONS(2044),
    [anon_sym___attribute__] = ACTIONS(2044),
    [anon_sym_COLON_COLON] = ACTIONS(2046),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2046),
    [anon_sym___declspec] = ACTIONS(2044),
    [anon_sym_LBRACE] = ACTIONS(2046),
    [anon_sym_signed] = ACTIONS(2044),
    [anon_sym_unsigned] = ACTIONS(2044),
    [anon_sym_long] = ACTIONS(2044),
    [anon_sym_short] = ACTIONS(2044),
    [anon_sym_LBRACK] = ACTIONS(2044),
    [anon_sym_static] = ACTIONS(2044),
    [anon_sym_register] = ACTIONS(2044),
    [anon_sym_inline] = ACTIONS(2044),
    [anon_sym___inline] = ACTIONS(2044),
    [anon_sym___inline__] = ACTIONS(2044),
    [anon_sym___forceinline] = ACTIONS(2044),
    [anon_sym_thread_local] = ACTIONS(2044),
    [anon_sym___thread] = ACTIONS(2044),
    [anon_sym_const] = ACTIONS(2044),
    [anon_sym_constexpr] = ACTIONS(2044),
    [anon_sym_volatile] = ACTIONS(2044),
    [anon_sym_restrict] = ACTIONS(2044),
    [anon_sym___restrict__] = ACTIONS(2044),
    [anon_sym__Atomic] = ACTIONS(2044),
    [anon_sym__Noreturn] = ACTIONS(2044),
    [anon_sym_noreturn] = ACTIONS(2044),
    [anon_sym_mutable] = ACTIONS(2044),
    [anon_sym_constinit] = ACTIONS(2044),
    [anon_sym_consteval] = ACTIONS(2044),
    [anon_sym___shared__] = ACTIONS(2044),
    [anon_sym___local__] = ACTIONS(2044),
    [anon_sym___constant__] = ACTIONS(2044),
    [anon_sym___managed__] = ACTIONS(2044),
    [anon_sym___grid_constant__] = ACTIONS(2044),
    [anon_sym_alignas] = ACTIONS(2044),
    [anon_sym__Alignas] = ACTIONS(2044),
    [sym_primitive_type] = ACTIONS(2044),
    [anon_sym_enum] = ACTIONS(2044),
    [anon_sym_class] = ACTIONS(2044),
    [anon_sym_struct] = ACTIONS(2044),
    [anon_sym_union] = ACTIONS(2044),
    [anon_sym_if] = ACTIONS(2044),
    [anon_sym_else] = ACTIONS(2044),
    [anon_sym_switch] = ACTIONS(2044),
    [anon_sym_while] = ACTIONS(2044),
    [anon_sym_do] = ACTIONS(2044),
    [anon_sym_for] = ACTIONS(2044),
    [anon_sym_return] = ACTIONS(2044),
    [anon_sym_break] = ACTIONS(2044),
    [anon_sym_continue] = ACTIONS(2044),
    [anon_sym_goto] = ACTIONS(2044),
    [anon_sym___try] = ACTIONS(2044),
    [anon_sym___leave] = ACTIONS(2044),
    [anon_sym_not] = ACTIONS(2044),
    [anon_sym_compl] = ACTIONS(2044),
    [anon_sym_DASH_DASH] = ACTIONS(2046),
    [anon_sym_PLUS_PLUS] = ACTIONS(2046),
    [anon_sym_sizeof] = ACTIONS(2044),
    [anon_sym___alignof__] = ACTIONS(2044),
    [anon_sym___alignof] = ACTIONS(2044),
    [anon_sym__alignof] = ACTIONS(2044),
    [anon_sym_alignof] = ACTIONS(2044),
    [anon_sym__Alignof] = ACTIONS(2044),
    [anon_sym_offsetof] = ACTIONS(2044),
    [anon_sym__Generic] = ACTIONS(2044),
    [anon_sym_asm] = ACTIONS(2044),
    [anon_sym___asm__] = ACTIONS(2044),
    [sym_number_literal] = ACTIONS(2046),
    [anon_sym_L_SQUOTE] = ACTIONS(2046),
    [anon_sym_u_SQUOTE] = ACTIONS(2046),
    [anon_sym_U_SQUOTE] = ACTIONS(2046),
    [anon_sym_u8_SQUOTE] = ACTIONS(2046),
    [anon_sym_SQUOTE] = ACTIONS(2046),
    [anon_sym_L_DQUOTE] = ACTIONS(2046),
    [anon_sym_u_DQUOTE] = ACTIONS(2046),
    [anon_sym_U_DQUOTE] = ACTIONS(2046),
    [anon_sym_u8_DQUOTE] = ACTIONS(2046),
    [anon_sym_DQUOTE] = ACTIONS(2046),
    [sym_true] = ACTIONS(2044),
    [sym_false] = ACTIONS(2044),
    [anon_sym_NULL] = ACTIONS(2044),
    [anon_sym_nullptr] = ACTIONS(2044),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2044),
    [anon_sym_decltype] = ACTIONS(2044),
    [sym_virtual] = ACTIONS(2044),
    [anon_sym_typename] = ACTIONS(2044),
    [anon_sym_template] = ACTIONS(2044),
    [anon_sym_try] = ACTIONS(2044),
    [anon_sym_delete] = ACTIONS(2044),
    [anon_sym_throw] = ACTIONS(2044),
    [anon_sym_co_return] = ACTIONS(2044),
    [anon_sym_co_yield] = ACTIONS(2044),
    [anon_sym_R_DQUOTE] = ACTIONS(2046),
    [anon_sym_LR_DQUOTE] = ACTIONS(2046),
    [anon_sym_uR_DQUOTE] = ACTIONS(2046),
    [anon_sym_UR_DQUOTE] = ACTIONS(2046),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2046),
    [anon_sym_co_await] = ACTIONS(2044),
    [anon_sym_new] = ACTIONS(2044),
    [anon_sym_requires] = ACTIONS(2044),
    [sym_this] = ACTIONS(2044),
    [anon_sym___launch_bounds__] = ACTIONS(2044),
  },
  [876] = {
    [sym_identifier] = ACTIONS(2000),
    [anon_sym_LPAREN2] = ACTIONS(2002),
    [anon_sym_BANG] = ACTIONS(2002),
    [anon_sym_TILDE] = ACTIONS(2002),
    [anon_sym_DASH] = ACTIONS(2000),
    [anon_sym_PLUS] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(2002),
    [anon_sym_AMP] = ACTIONS(2002),
    [anon_sym_SEMI] = ACTIONS(2002),
    [anon_sym___extension__] = ACTIONS(2000),
    [anon_sym_typedef] = ACTIONS(2000),
    [anon_sym___device__] = ACTIONS(2000),
    [anon_sym___host__] = ACTIONS(2000),
    [anon_sym___global__] = ACTIONS(2000),
    [anon_sym___forceinline__] = ACTIONS(2000),
    [anon_sym___noinline__] = ACTIONS(2000),
    [anon_sym_extern] = ACTIONS(2000),
    [anon_sym___attribute__] = ACTIONS(2000),
    [anon_sym_COLON_COLON] = ACTIONS(2002),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2002),
    [anon_sym___declspec] = ACTIONS(2000),
    [anon_sym_LBRACE] = ACTIONS(2002),
    [anon_sym_signed] = ACTIONS(2000),
    [anon_sym_unsigned] = ACTIONS(2000),
    [anon_sym_long] = ACTIONS(2000),
    [anon_sym_short] = ACTIONS(2000),
    [anon_sym_LBRACK] = ACTIONS(2000),
    [anon_sym_static] = ACTIONS(2000),
    [anon_sym_register] = ACTIONS(2000),
    [anon_sym_inline] = ACTIONS(2000),
    [anon_sym___inline] = ACTIONS(2000),
    [anon_sym___inline__] = ACTIONS(2000),
    [anon_sym___forceinline] = ACTIONS(2000),
    [anon_sym_thread_local] = ACTIONS(2000),
    [anon_sym___thread] = ACTIONS(2000),
    [anon_sym_const] = ACTIONS(2000),
    [anon_sym_constexpr] = ACTIONS(2000),
    [anon_sym_volatile] = ACTIONS(2000),
    [anon_sym_restrict] = ACTIONS(2000),
    [anon_sym___restrict__] = ACTIONS(2000),
    [anon_sym__Atomic] = ACTIONS(2000),
    [anon_sym__Noreturn] = ACTIONS(2000),
    [anon_sym_noreturn] = ACTIONS(2000),
    [anon_sym_mutable] = ACTIONS(2000),
    [anon_sym_constinit] = ACTIONS(2000),
    [anon_sym_consteval] = ACTIONS(2000),
    [anon_sym___shared__] = ACTIONS(2000),
    [anon_sym___local__] = ACTIONS(2000),
    [anon_sym___constant__] = ACTIONS(2000),
    [anon_sym___managed__] = ACTIONS(2000),
    [anon_sym___grid_constant__] = ACTIONS(2000),
    [anon_sym_alignas] = ACTIONS(2000),
    [anon_sym__Alignas] = ACTIONS(2000),
    [sym_primitive_type] = ACTIONS(2000),
    [anon_sym_enum] = ACTIONS(2000),
    [anon_sym_class] = ACTIONS(2000),
    [anon_sym_struct] = ACTIONS(2000),
    [anon_sym_union] = ACTIONS(2000),
    [anon_sym_if] = ACTIONS(2000),
    [anon_sym_else] = ACTIONS(2000),
    [anon_sym_switch] = ACTIONS(2000),
    [anon_sym_while] = ACTIONS(2000),
    [anon_sym_do] = ACTIONS(2000),
    [anon_sym_for] = ACTIONS(2000),
    [anon_sym_return] = ACTIONS(2000),
    [anon_sym_break] = ACTIONS(2000),
    [anon_sym_continue] = ACTIONS(2000),
    [anon_sym_goto] = ACTIONS(2000),
    [anon_sym___try] = ACTIONS(2000),
    [anon_sym___leave] = ACTIONS(2000),
    [anon_sym_not] = ACTIONS(2000),
    [anon_sym_compl] = ACTIONS(2000),
    [anon_sym_DASH_DASH] = ACTIONS(2002),
    [anon_sym_PLUS_PLUS] = ACTIONS(2002),
    [anon_sym_sizeof] = ACTIONS(2000),
    [anon_sym___alignof__] = ACTIONS(2000),
    [anon_sym___alignof] = ACTIONS(2000),
    [anon_sym__alignof] = ACTIONS(2000),
    [anon_sym_alignof] = ACTIONS(2000),
    [anon_sym__Alignof] = ACTIONS(2000),
    [anon_sym_offsetof] = ACTIONS(2000),
    [anon_sym__Generic] = ACTIONS(2000),
    [anon_sym_asm] = ACTIONS(2000),
    [anon_sym___asm__] = ACTIONS(2000),
    [sym_number_literal] = ACTIONS(2002),
    [anon_sym_L_SQUOTE] = ACTIONS(2002),
    [anon_sym_u_SQUOTE] = ACTIONS(2002),
    [anon_sym_U_SQUOTE] = ACTIONS(2002),
    [anon_sym_u8_SQUOTE] = ACTIONS(2002),
    [anon_sym_SQUOTE] = ACTIONS(2002),
    [anon_sym_L_DQUOTE] = ACTIONS(2002),
    [anon_sym_u_DQUOTE] = ACTIONS(2002),
    [anon_sym_U_DQUOTE] = ACTIONS(2002),
    [anon_sym_u8_DQUOTE] = ACTIONS(2002),
    [anon_sym_DQUOTE] = ACTIONS(2002),
    [sym_true] = ACTIONS(2000),
    [sym_false] = ACTIONS(2000),
    [anon_sym_NULL] = ACTIONS(2000),
    [anon_sym_nullptr] = ACTIONS(2000),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2000),
    [anon_sym_decltype] = ACTIONS(2000),
    [sym_virtual] = ACTIONS(2000),
    [anon_sym_typename] = ACTIONS(2000),
    [anon_sym_template] = ACTIONS(2000),
    [anon_sym_try] = ACTIONS(2000),
    [anon_sym_delete] = ACTIONS(2000),
    [anon_sym_throw] = ACTIONS(2000),
    [anon_sym_co_return] = ACTIONS(2000),
    [anon_sym_co_yield] = ACTIONS(2000),
    [anon_sym_R_DQUOTE] = ACTIONS(2002),
    [anon_sym_LR_DQUOTE] = ACTIONS(2002),
    [anon_sym_uR_DQUOTE] = ACTIONS(2002),
    [anon_sym_UR_DQUOTE] = ACTIONS(2002),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2002),
    [anon_sym_co_await] = ACTIONS(2000),
    [anon_sym_new] = ACTIONS(2000),
    [anon_sym_requires] = ACTIONS(2000),
    [sym_this] = ACTIONS(2000),
    [anon_sym___launch_bounds__] = ACTIONS(2000),
  },
  [877] = {
    [sym_identifier] = ACTIONS(2036),
    [anon_sym_LPAREN2] = ACTIONS(2038),
    [anon_sym_BANG] = ACTIONS(2038),
    [anon_sym_TILDE] = ACTIONS(2038),
    [anon_sym_DASH] = ACTIONS(2036),
    [anon_sym_PLUS] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(2038),
    [anon_sym_AMP] = ACTIONS(2038),
    [anon_sym_SEMI] = ACTIONS(2038),
    [anon_sym___extension__] = ACTIONS(2036),
    [anon_sym_typedef] = ACTIONS(2036),
    [anon_sym___device__] = ACTIONS(2036),
    [anon_sym___host__] = ACTIONS(2036),
    [anon_sym___global__] = ACTIONS(2036),
    [anon_sym___forceinline__] = ACTIONS(2036),
    [anon_sym___noinline__] = ACTIONS(2036),
    [anon_sym_extern] = ACTIONS(2036),
    [anon_sym___attribute__] = ACTIONS(2036),
    [anon_sym_COLON_COLON] = ACTIONS(2038),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2038),
    [anon_sym___declspec] = ACTIONS(2036),
    [anon_sym_LBRACE] = ACTIONS(2038),
    [anon_sym_signed] = ACTIONS(2036),
    [anon_sym_unsigned] = ACTIONS(2036),
    [anon_sym_long] = ACTIONS(2036),
    [anon_sym_short] = ACTIONS(2036),
    [anon_sym_LBRACK] = ACTIONS(2036),
    [anon_sym_static] = ACTIONS(2036),
    [anon_sym_register] = ACTIONS(2036),
    [anon_sym_inline] = ACTIONS(2036),
    [anon_sym___inline] = ACTIONS(2036),
    [anon_sym___inline__] = ACTIONS(2036),
    [anon_sym___forceinline] = ACTIONS(2036),
    [anon_sym_thread_local] = ACTIONS(2036),
    [anon_sym___thread] = ACTIONS(2036),
    [anon_sym_const] = ACTIONS(2036),
    [anon_sym_constexpr] = ACTIONS(2036),
    [anon_sym_volatile] = ACTIONS(2036),
    [anon_sym_restrict] = ACTIONS(2036),
    [anon_sym___restrict__] = ACTIONS(2036),
    [anon_sym__Atomic] = ACTIONS(2036),
    [anon_sym__Noreturn] = ACTIONS(2036),
    [anon_sym_noreturn] = ACTIONS(2036),
    [anon_sym_mutable] = ACTIONS(2036),
    [anon_sym_constinit] = ACTIONS(2036),
    [anon_sym_consteval] = ACTIONS(2036),
    [anon_sym___shared__] = ACTIONS(2036),
    [anon_sym___local__] = ACTIONS(2036),
    [anon_sym___constant__] = ACTIONS(2036),
    [anon_sym___managed__] = ACTIONS(2036),
    [anon_sym___grid_constant__] = ACTIONS(2036),
    [anon_sym_alignas] = ACTIONS(2036),
    [anon_sym__Alignas] = ACTIONS(2036),
    [sym_primitive_type] = ACTIONS(2036),
    [anon_sym_enum] = ACTIONS(2036),
    [anon_sym_class] = ACTIONS(2036),
    [anon_sym_struct] = ACTIONS(2036),
    [anon_sym_union] = ACTIONS(2036),
    [anon_sym_if] = ACTIONS(2036),
    [anon_sym_else] = ACTIONS(2036),
    [anon_sym_switch] = ACTIONS(2036),
    [anon_sym_while] = ACTIONS(2036),
    [anon_sym_do] = ACTIONS(2036),
    [anon_sym_for] = ACTIONS(2036),
    [anon_sym_return] = ACTIONS(2036),
    [anon_sym_break] = ACTIONS(2036),
    [anon_sym_continue] = ACTIONS(2036),
    [anon_sym_goto] = ACTIONS(2036),
    [anon_sym___try] = ACTIONS(2036),
    [anon_sym___leave] = ACTIONS(2036),
    [anon_sym_not] = ACTIONS(2036),
    [anon_sym_compl] = ACTIONS(2036),
    [anon_sym_DASH_DASH] = ACTIONS(2038),
    [anon_sym_PLUS_PLUS] = ACTIONS(2038),
    [anon_sym_sizeof] = ACTIONS(2036),
    [anon_sym___alignof__] = ACTIONS(2036),
    [anon_sym___alignof] = ACTIONS(2036),
    [anon_sym__alignof] = ACTIONS(2036),
    [anon_sym_alignof] = ACTIONS(2036),
    [anon_sym__Alignof] = ACTIONS(2036),
    [anon_sym_offsetof] = ACTIONS(2036),
    [anon_sym__Generic] = ACTIONS(2036),
    [anon_sym_asm] = ACTIONS(2036),
    [anon_sym___asm__] = ACTIONS(2036),
    [sym_number_literal] = ACTIONS(2038),
    [anon_sym_L_SQUOTE] = ACTIONS(2038),
    [anon_sym_u_SQUOTE] = ACTIONS(2038),
    [anon_sym_U_SQUOTE] = ACTIONS(2038),
    [anon_sym_u8_SQUOTE] = ACTIONS(2038),
    [anon_sym_SQUOTE] = ACTIONS(2038),
    [anon_sym_L_DQUOTE] = ACTIONS(2038),
    [anon_sym_u_DQUOTE] = ACTIONS(2038),
    [anon_sym_U_DQUOTE] = ACTIONS(2038),
    [anon_sym_u8_DQUOTE] = ACTIONS(2038),
    [anon_sym_DQUOTE] = ACTIONS(2038),
    [sym_true] = ACTIONS(2036),
    [sym_false] = ACTIONS(2036),
    [anon_sym_NULL] = ACTIONS(2036),
    [anon_sym_nullptr] = ACTIONS(2036),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2036),
    [anon_sym_decltype] = ACTIONS(2036),
    [sym_virtual] = ACTIONS(2036),
    [anon_sym_typename] = ACTIONS(2036),
    [anon_sym_template] = ACTIONS(2036),
    [anon_sym_try] = ACTIONS(2036),
    [anon_sym_delete] = ACTIONS(2036),
    [anon_sym_throw] = ACTIONS(2036),
    [anon_sym_co_return] = ACTIONS(2036),
    [anon_sym_co_yield] = ACTIONS(2036),
    [anon_sym_R_DQUOTE] = ACTIONS(2038),
    [anon_sym_LR_DQUOTE] = ACTIONS(2038),
    [anon_sym_uR_DQUOTE] = ACTIONS(2038),
    [anon_sym_UR_DQUOTE] = ACTIONS(2038),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2038),
    [anon_sym_co_await] = ACTIONS(2036),
    [anon_sym_new] = ACTIONS(2036),
    [anon_sym_requires] = ACTIONS(2036),
    [sym_this] = ACTIONS(2036),
    [anon_sym___launch_bounds__] = ACTIONS(2036),
  },
  [878] = {
    [sym_identifier] = ACTIONS(2068),
    [anon_sym_LPAREN2] = ACTIONS(2070),
    [anon_sym_BANG] = ACTIONS(2070),
    [anon_sym_TILDE] = ACTIONS(2070),
    [anon_sym_DASH] = ACTIONS(2068),
    [anon_sym_PLUS] = ACTIONS(2068),
    [anon_sym_STAR] = ACTIONS(2070),
    [anon_sym_AMP] = ACTIONS(2070),
    [anon_sym_SEMI] = ACTIONS(2070),
    [anon_sym___extension__] = ACTIONS(2068),
    [anon_sym_typedef] = ACTIONS(2068),
    [anon_sym___device__] = ACTIONS(2068),
    [anon_sym___host__] = ACTIONS(2068),
    [anon_sym___global__] = ACTIONS(2068),
    [anon_sym___forceinline__] = ACTIONS(2068),
    [anon_sym___noinline__] = ACTIONS(2068),
    [anon_sym_extern] = ACTIONS(2068),
    [anon_sym___attribute__] = ACTIONS(2068),
    [anon_sym_COLON_COLON] = ACTIONS(2070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2070),
    [anon_sym___declspec] = ACTIONS(2068),
    [anon_sym_LBRACE] = ACTIONS(2070),
    [anon_sym_signed] = ACTIONS(2068),
    [anon_sym_unsigned] = ACTIONS(2068),
    [anon_sym_long] = ACTIONS(2068),
    [anon_sym_short] = ACTIONS(2068),
    [anon_sym_LBRACK] = ACTIONS(2068),
    [anon_sym_static] = ACTIONS(2068),
    [anon_sym_register] = ACTIONS(2068),
    [anon_sym_inline] = ACTIONS(2068),
    [anon_sym___inline] = ACTIONS(2068),
    [anon_sym___inline__] = ACTIONS(2068),
    [anon_sym___forceinline] = ACTIONS(2068),
    [anon_sym_thread_local] = ACTIONS(2068),
    [anon_sym___thread] = ACTIONS(2068),
    [anon_sym_const] = ACTIONS(2068),
    [anon_sym_constexpr] = ACTIONS(2068),
    [anon_sym_volatile] = ACTIONS(2068),
    [anon_sym_restrict] = ACTIONS(2068),
    [anon_sym___restrict__] = ACTIONS(2068),
    [anon_sym__Atomic] = ACTIONS(2068),
    [anon_sym__Noreturn] = ACTIONS(2068),
    [anon_sym_noreturn] = ACTIONS(2068),
    [anon_sym_mutable] = ACTIONS(2068),
    [anon_sym_constinit] = ACTIONS(2068),
    [anon_sym_consteval] = ACTIONS(2068),
    [anon_sym___shared__] = ACTIONS(2068),
    [anon_sym___local__] = ACTIONS(2068),
    [anon_sym___constant__] = ACTIONS(2068),
    [anon_sym___managed__] = ACTIONS(2068),
    [anon_sym___grid_constant__] = ACTIONS(2068),
    [anon_sym_alignas] = ACTIONS(2068),
    [anon_sym__Alignas] = ACTIONS(2068),
    [sym_primitive_type] = ACTIONS(2068),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2068),
    [anon_sym_struct] = ACTIONS(2068),
    [anon_sym_union] = ACTIONS(2068),
    [anon_sym_if] = ACTIONS(2068),
    [anon_sym_else] = ACTIONS(2068),
    [anon_sym_switch] = ACTIONS(2068),
    [anon_sym_while] = ACTIONS(2068),
    [anon_sym_do] = ACTIONS(2068),
    [anon_sym_for] = ACTIONS(2068),
    [anon_sym_return] = ACTIONS(2068),
    [anon_sym_break] = ACTIONS(2068),
    [anon_sym_continue] = ACTIONS(2068),
    [anon_sym_goto] = ACTIONS(2068),
    [anon_sym___try] = ACTIONS(2068),
    [anon_sym___leave] = ACTIONS(2068),
    [anon_sym_not] = ACTIONS(2068),
    [anon_sym_compl] = ACTIONS(2068),
    [anon_sym_DASH_DASH] = ACTIONS(2070),
    [anon_sym_PLUS_PLUS] = ACTIONS(2070),
    [anon_sym_sizeof] = ACTIONS(2068),
    [anon_sym___alignof__] = ACTIONS(2068),
    [anon_sym___alignof] = ACTIONS(2068),
    [anon_sym__alignof] = ACTIONS(2068),
    [anon_sym_alignof] = ACTIONS(2068),
    [anon_sym__Alignof] = ACTIONS(2068),
    [anon_sym_offsetof] = ACTIONS(2068),
    [anon_sym__Generic] = ACTIONS(2068),
    [anon_sym_asm] = ACTIONS(2068),
    [anon_sym___asm__] = ACTIONS(2068),
    [sym_number_literal] = ACTIONS(2070),
    [anon_sym_L_SQUOTE] = ACTIONS(2070),
    [anon_sym_u_SQUOTE] = ACTIONS(2070),
    [anon_sym_U_SQUOTE] = ACTIONS(2070),
    [anon_sym_u8_SQUOTE] = ACTIONS(2070),
    [anon_sym_SQUOTE] = ACTIONS(2070),
    [anon_sym_L_DQUOTE] = ACTIONS(2070),
    [anon_sym_u_DQUOTE] = ACTIONS(2070),
    [anon_sym_U_DQUOTE] = ACTIONS(2070),
    [anon_sym_u8_DQUOTE] = ACTIONS(2070),
    [anon_sym_DQUOTE] = ACTIONS(2070),
    [sym_true] = ACTIONS(2068),
    [sym_false] = ACTIONS(2068),
    [anon_sym_NULL] = ACTIONS(2068),
    [anon_sym_nullptr] = ACTIONS(2068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2068),
    [anon_sym_decltype] = ACTIONS(2068),
    [sym_virtual] = ACTIONS(2068),
    [anon_sym_typename] = ACTIONS(2068),
    [anon_sym_template] = ACTIONS(2068),
    [anon_sym_try] = ACTIONS(2068),
    [anon_sym_delete] = ACTIONS(2068),
    [anon_sym_throw] = ACTIONS(2068),
    [anon_sym_co_return] = ACTIONS(2068),
    [anon_sym_co_yield] = ACTIONS(2068),
    [anon_sym_R_DQUOTE] = ACTIONS(2070),
    [anon_sym_LR_DQUOTE] = ACTIONS(2070),
    [anon_sym_uR_DQUOTE] = ACTIONS(2070),
    [anon_sym_UR_DQUOTE] = ACTIONS(2070),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2070),
    [anon_sym_co_await] = ACTIONS(2068),
    [anon_sym_new] = ACTIONS(2068),
    [anon_sym_requires] = ACTIONS(2068),
    [sym_this] = ACTIONS(2068),
    [anon_sym___launch_bounds__] = ACTIONS(2068),
  },
  [879] = {
    [sym_string_literal] = STATE(2752),
    [sym_template_argument_list] = STATE(1681),
    [sym_raw_string_literal] = STATE(2752),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(3756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3771),
    [anon_sym_TILDE] = ACTIONS(3764),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3768),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3771),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(3774),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3758),
    [anon_sym___extension__] = ACTIONS(3756),
    [anon_sym___device__] = ACTIONS(3756),
    [anon_sym___host__] = ACTIONS(3756),
    [anon_sym___global__] = ACTIONS(3756),
    [anon_sym___forceinline__] = ACTIONS(3756),
    [anon_sym___noinline__] = ACTIONS(3756),
    [anon_sym_extern] = ACTIONS(3756),
    [anon_sym___attribute__] = ACTIONS(3756),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3764),
    [anon_sym___declspec] = ACTIONS(3756),
    [anon_sym___based] = ACTIONS(3756),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_signed] = ACTIONS(3784),
    [anon_sym_unsigned] = ACTIONS(3784),
    [anon_sym_long] = ACTIONS(3784),
    [anon_sym_short] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3768),
    [anon_sym_static] = ACTIONS(3756),
    [anon_sym_EQ] = ACTIONS(3790),
    [anon_sym_register] = ACTIONS(3756),
    [anon_sym_inline] = ACTIONS(3756),
    [anon_sym___inline] = ACTIONS(3756),
    [anon_sym___inline__] = ACTIONS(3756),
    [anon_sym___forceinline] = ACTIONS(3756),
    [anon_sym_thread_local] = ACTIONS(3756),
    [anon_sym___thread] = ACTIONS(3756),
    [anon_sym_const] = ACTIONS(3756),
    [anon_sym_constexpr] = ACTIONS(3756),
    [anon_sym_volatile] = ACTIONS(3756),
    [anon_sym_restrict] = ACTIONS(3756),
    [anon_sym___restrict__] = ACTIONS(3756),
    [anon_sym__Atomic] = ACTIONS(3756),
    [anon_sym__Noreturn] = ACTIONS(3756),
    [anon_sym_noreturn] = ACTIONS(3756),
    [anon_sym_mutable] = ACTIONS(3756),
    [anon_sym_constinit] = ACTIONS(3756),
    [anon_sym_consteval] = ACTIONS(3756),
    [anon_sym___shared__] = ACTIONS(3756),
    [anon_sym___local__] = ACTIONS(3756),
    [anon_sym___constant__] = ACTIONS(3756),
    [anon_sym___managed__] = ACTIONS(3756),
    [anon_sym___grid_constant__] = ACTIONS(3756),
    [anon_sym_alignas] = ACTIONS(3756),
    [anon_sym__Alignas] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3969),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3794),
    [anon_sym_SLASH_EQ] = ACTIONS(3794),
    [anon_sym_PERCENT_EQ] = ACTIONS(3794),
    [anon_sym_PLUS_EQ] = ACTIONS(3794),
    [anon_sym_DASH_EQ] = ACTIONS(3794),
    [anon_sym_LT_LT_EQ] = ACTIONS(3794),
    [anon_sym_GT_GT_EQ] = ACTIONS(3794),
    [anon_sym_AMP_EQ] = ACTIONS(3794),
    [anon_sym_CARET_EQ] = ACTIONS(3794),
    [anon_sym_PIPE_EQ] = ACTIONS(3794),
    [anon_sym_and_eq] = ACTIONS(3790),
    [anon_sym_or_eq] = ACTIONS(3790),
    [anon_sym_xor_eq] = ACTIONS(3790),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3766),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3766),
    [anon_sym_not_eq] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3756),
    [anon_sym_decltype] = ACTIONS(3756),
    [sym_virtual] = ACTIONS(3756),
    [anon_sym_template] = ACTIONS(3756),
    [anon_sym_operator] = ACTIONS(3756),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
    [anon_sym___launch_bounds__] = ACTIONS(3756),
  },
  [880] = {
    [sym_string_literal] = STATE(2752),
    [sym_template_argument_list] = STATE(1681),
    [sym_raw_string_literal] = STATE(2752),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(3756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3771),
    [anon_sym_TILDE] = ACTIONS(3764),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3768),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3771),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(3774),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3758),
    [anon_sym___extension__] = ACTIONS(3756),
    [anon_sym___device__] = ACTIONS(3756),
    [anon_sym___host__] = ACTIONS(3756),
    [anon_sym___global__] = ACTIONS(3756),
    [anon_sym___forceinline__] = ACTIONS(3756),
    [anon_sym___noinline__] = ACTIONS(3756),
    [anon_sym_extern] = ACTIONS(3756),
    [anon_sym___attribute__] = ACTIONS(3756),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3764),
    [anon_sym___declspec] = ACTIONS(3756),
    [anon_sym___based] = ACTIONS(3756),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_signed] = ACTIONS(3784),
    [anon_sym_unsigned] = ACTIONS(3784),
    [anon_sym_long] = ACTIONS(3784),
    [anon_sym_short] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3768),
    [anon_sym_static] = ACTIONS(3756),
    [anon_sym_EQ] = ACTIONS(3790),
    [anon_sym_register] = ACTIONS(3756),
    [anon_sym_inline] = ACTIONS(3756),
    [anon_sym___inline] = ACTIONS(3756),
    [anon_sym___inline__] = ACTIONS(3756),
    [anon_sym___forceinline] = ACTIONS(3756),
    [anon_sym_thread_local] = ACTIONS(3756),
    [anon_sym___thread] = ACTIONS(3756),
    [anon_sym_const] = ACTIONS(3756),
    [anon_sym_constexpr] = ACTIONS(3756),
    [anon_sym_volatile] = ACTIONS(3756),
    [anon_sym_restrict] = ACTIONS(3756),
    [anon_sym___restrict__] = ACTIONS(3756),
    [anon_sym__Atomic] = ACTIONS(3756),
    [anon_sym__Noreturn] = ACTIONS(3756),
    [anon_sym_noreturn] = ACTIONS(3756),
    [anon_sym_mutable] = ACTIONS(3756),
    [anon_sym_constinit] = ACTIONS(3756),
    [anon_sym_consteval] = ACTIONS(3756),
    [anon_sym___shared__] = ACTIONS(3756),
    [anon_sym___local__] = ACTIONS(3756),
    [anon_sym___constant__] = ACTIONS(3756),
    [anon_sym___managed__] = ACTIONS(3756),
    [anon_sym___grid_constant__] = ACTIONS(3756),
    [anon_sym_alignas] = ACTIONS(3756),
    [anon_sym__Alignas] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3818),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3794),
    [anon_sym_SLASH_EQ] = ACTIONS(3794),
    [anon_sym_PERCENT_EQ] = ACTIONS(3794),
    [anon_sym_PLUS_EQ] = ACTIONS(3794),
    [anon_sym_DASH_EQ] = ACTIONS(3794),
    [anon_sym_LT_LT_EQ] = ACTIONS(3794),
    [anon_sym_GT_GT_EQ] = ACTIONS(3794),
    [anon_sym_AMP_EQ] = ACTIONS(3794),
    [anon_sym_CARET_EQ] = ACTIONS(3794),
    [anon_sym_PIPE_EQ] = ACTIONS(3794),
    [anon_sym_and_eq] = ACTIONS(3790),
    [anon_sym_or_eq] = ACTIONS(3790),
    [anon_sym_xor_eq] = ACTIONS(3790),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3766),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3766),
    [anon_sym_not_eq] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3756),
    [anon_sym_decltype] = ACTIONS(3756),
    [sym_virtual] = ACTIONS(3756),
    [anon_sym_template] = ACTIONS(3756),
    [anon_sym_operator] = ACTIONS(3756),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
    [anon_sym___launch_bounds__] = ACTIONS(3756),
  },
  [881] = {
    [sym_string_literal] = STATE(2752),
    [sym_template_argument_list] = STATE(1681),
    [sym_raw_string_literal] = STATE(2752),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(3756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3771),
    [anon_sym_TILDE] = ACTIONS(3764),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3768),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3771),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(3774),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3758),
    [anon_sym___extension__] = ACTIONS(3756),
    [anon_sym___device__] = ACTIONS(3756),
    [anon_sym___host__] = ACTIONS(3756),
    [anon_sym___global__] = ACTIONS(3756),
    [anon_sym___forceinline__] = ACTIONS(3756),
    [anon_sym___noinline__] = ACTIONS(3756),
    [anon_sym_extern] = ACTIONS(3756),
    [anon_sym___attribute__] = ACTIONS(3756),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3764),
    [anon_sym___declspec] = ACTIONS(3756),
    [anon_sym___based] = ACTIONS(3756),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_signed] = ACTIONS(3784),
    [anon_sym_unsigned] = ACTIONS(3784),
    [anon_sym_long] = ACTIONS(3784),
    [anon_sym_short] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3768),
    [anon_sym_static] = ACTIONS(3756),
    [anon_sym_EQ] = ACTIONS(3790),
    [anon_sym_register] = ACTIONS(3756),
    [anon_sym_inline] = ACTIONS(3756),
    [anon_sym___inline] = ACTIONS(3756),
    [anon_sym___inline__] = ACTIONS(3756),
    [anon_sym___forceinline] = ACTIONS(3756),
    [anon_sym_thread_local] = ACTIONS(3756),
    [anon_sym___thread] = ACTIONS(3756),
    [anon_sym_const] = ACTIONS(3756),
    [anon_sym_constexpr] = ACTIONS(3756),
    [anon_sym_volatile] = ACTIONS(3756),
    [anon_sym_restrict] = ACTIONS(3756),
    [anon_sym___restrict__] = ACTIONS(3756),
    [anon_sym__Atomic] = ACTIONS(3756),
    [anon_sym__Noreturn] = ACTIONS(3756),
    [anon_sym_noreturn] = ACTIONS(3756),
    [anon_sym_mutable] = ACTIONS(3756),
    [anon_sym_constinit] = ACTIONS(3756),
    [anon_sym_consteval] = ACTIONS(3756),
    [anon_sym___shared__] = ACTIONS(3756),
    [anon_sym___local__] = ACTIONS(3756),
    [anon_sym___constant__] = ACTIONS(3756),
    [anon_sym___managed__] = ACTIONS(3756),
    [anon_sym___grid_constant__] = ACTIONS(3756),
    [anon_sym_alignas] = ACTIONS(3756),
    [anon_sym__Alignas] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3820),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3794),
    [anon_sym_SLASH_EQ] = ACTIONS(3794),
    [anon_sym_PERCENT_EQ] = ACTIONS(3794),
    [anon_sym_PLUS_EQ] = ACTIONS(3794),
    [anon_sym_DASH_EQ] = ACTIONS(3794),
    [anon_sym_LT_LT_EQ] = ACTIONS(3794),
    [anon_sym_GT_GT_EQ] = ACTIONS(3794),
    [anon_sym_AMP_EQ] = ACTIONS(3794),
    [anon_sym_CARET_EQ] = ACTIONS(3794),
    [anon_sym_PIPE_EQ] = ACTIONS(3794),
    [anon_sym_and_eq] = ACTIONS(3790),
    [anon_sym_or_eq] = ACTIONS(3790),
    [anon_sym_xor_eq] = ACTIONS(3790),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3766),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3766),
    [anon_sym_not_eq] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3756),
    [anon_sym_decltype] = ACTIONS(3756),
    [sym_virtual] = ACTIONS(3756),
    [anon_sym_template] = ACTIONS(3756),
    [anon_sym_operator] = ACTIONS(3756),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
    [anon_sym___launch_bounds__] = ACTIONS(3756),
  },
  [882] = {
    [sym_string_literal] = STATE(2752),
    [sym_template_argument_list] = STATE(1681),
    [sym_raw_string_literal] = STATE(2752),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(3756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_RPAREN] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3771),
    [anon_sym_TILDE] = ACTIONS(3764),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3768),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3771),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(3774),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3758),
    [anon_sym___extension__] = ACTIONS(3756),
    [anon_sym___device__] = ACTIONS(3756),
    [anon_sym___host__] = ACTIONS(3756),
    [anon_sym___global__] = ACTIONS(3756),
    [anon_sym___forceinline__] = ACTIONS(3756),
    [anon_sym___noinline__] = ACTIONS(3756),
    [anon_sym_extern] = ACTIONS(3756),
    [anon_sym___attribute__] = ACTIONS(3756),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3764),
    [anon_sym___declspec] = ACTIONS(3756),
    [anon_sym___based] = ACTIONS(3756),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_signed] = ACTIONS(3784),
    [anon_sym_unsigned] = ACTIONS(3784),
    [anon_sym_long] = ACTIONS(3784),
    [anon_sym_short] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3768),
    [anon_sym_static] = ACTIONS(3756),
    [anon_sym_EQ] = ACTIONS(3790),
    [anon_sym_register] = ACTIONS(3756),
    [anon_sym_inline] = ACTIONS(3756),
    [anon_sym___inline] = ACTIONS(3756),
    [anon_sym___inline__] = ACTIONS(3756),
    [anon_sym___forceinline] = ACTIONS(3756),
    [anon_sym_thread_local] = ACTIONS(3756),
    [anon_sym___thread] = ACTIONS(3756),
    [anon_sym_const] = ACTIONS(3756),
    [anon_sym_constexpr] = ACTIONS(3756),
    [anon_sym_volatile] = ACTIONS(3756),
    [anon_sym_restrict] = ACTIONS(3756),
    [anon_sym___restrict__] = ACTIONS(3756),
    [anon_sym__Atomic] = ACTIONS(3756),
    [anon_sym__Noreturn] = ACTIONS(3756),
    [anon_sym_noreturn] = ACTIONS(3756),
    [anon_sym_mutable] = ACTIONS(3756),
    [anon_sym_constinit] = ACTIONS(3756),
    [anon_sym_consteval] = ACTIONS(3756),
    [anon_sym___shared__] = ACTIONS(3756),
    [anon_sym___local__] = ACTIONS(3756),
    [anon_sym___constant__] = ACTIONS(3756),
    [anon_sym___managed__] = ACTIONS(3756),
    [anon_sym___grid_constant__] = ACTIONS(3756),
    [anon_sym_alignas] = ACTIONS(3756),
    [anon_sym__Alignas] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3794),
    [anon_sym_SLASH_EQ] = ACTIONS(3794),
    [anon_sym_PERCENT_EQ] = ACTIONS(3794),
    [anon_sym_PLUS_EQ] = ACTIONS(3794),
    [anon_sym_DASH_EQ] = ACTIONS(3794),
    [anon_sym_LT_LT_EQ] = ACTIONS(3794),
    [anon_sym_GT_GT_EQ] = ACTIONS(3794),
    [anon_sym_AMP_EQ] = ACTIONS(3794),
    [anon_sym_CARET_EQ] = ACTIONS(3794),
    [anon_sym_PIPE_EQ] = ACTIONS(3794),
    [anon_sym_and_eq] = ACTIONS(3790),
    [anon_sym_or_eq] = ACTIONS(3790),
    [anon_sym_xor_eq] = ACTIONS(3790),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3766),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3766),
    [anon_sym_not_eq] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3756),
    [anon_sym_decltype] = ACTIONS(3756),
    [sym_virtual] = ACTIONS(3756),
    [anon_sym_template] = ACTIONS(3756),
    [anon_sym_operator] = ACTIONS(3756),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
    [anon_sym___launch_bounds__] = ACTIONS(3756),
  },
  [883] = {
    [sym_string_literal] = STATE(2752),
    [sym_template_argument_list] = STATE(1681),
    [sym_raw_string_literal] = STATE(2752),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(3756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3771),
    [anon_sym_TILDE] = ACTIONS(3764),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3768),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3771),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(3774),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3758),
    [anon_sym___extension__] = ACTIONS(3756),
    [anon_sym___device__] = ACTIONS(3756),
    [anon_sym___host__] = ACTIONS(3756),
    [anon_sym___global__] = ACTIONS(3756),
    [anon_sym___forceinline__] = ACTIONS(3756),
    [anon_sym___noinline__] = ACTIONS(3756),
    [anon_sym_extern] = ACTIONS(3756),
    [anon_sym___attribute__] = ACTIONS(3756),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3764),
    [anon_sym___declspec] = ACTIONS(3756),
    [anon_sym___based] = ACTIONS(3756),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_signed] = ACTIONS(3784),
    [anon_sym_unsigned] = ACTIONS(3784),
    [anon_sym_long] = ACTIONS(3784),
    [anon_sym_short] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3768),
    [anon_sym_static] = ACTIONS(3756),
    [anon_sym_EQ] = ACTIONS(3790),
    [anon_sym_register] = ACTIONS(3756),
    [anon_sym_inline] = ACTIONS(3756),
    [anon_sym___inline] = ACTIONS(3756),
    [anon_sym___inline__] = ACTIONS(3756),
    [anon_sym___forceinline] = ACTIONS(3756),
    [anon_sym_thread_local] = ACTIONS(3756),
    [anon_sym___thread] = ACTIONS(3756),
    [anon_sym_const] = ACTIONS(3756),
    [anon_sym_constexpr] = ACTIONS(3756),
    [anon_sym_volatile] = ACTIONS(3756),
    [anon_sym_restrict] = ACTIONS(3756),
    [anon_sym___restrict__] = ACTIONS(3756),
    [anon_sym__Atomic] = ACTIONS(3756),
    [anon_sym__Noreturn] = ACTIONS(3756),
    [anon_sym_noreturn] = ACTIONS(3756),
    [anon_sym_mutable] = ACTIONS(3756),
    [anon_sym_constinit] = ACTIONS(3756),
    [anon_sym_consteval] = ACTIONS(3756),
    [anon_sym___shared__] = ACTIONS(3756),
    [anon_sym___local__] = ACTIONS(3756),
    [anon_sym___constant__] = ACTIONS(3756),
    [anon_sym___managed__] = ACTIONS(3756),
    [anon_sym___grid_constant__] = ACTIONS(3756),
    [anon_sym_alignas] = ACTIONS(3756),
    [anon_sym__Alignas] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3828),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3794),
    [anon_sym_SLASH_EQ] = ACTIONS(3794),
    [anon_sym_PERCENT_EQ] = ACTIONS(3794),
    [anon_sym_PLUS_EQ] = ACTIONS(3794),
    [anon_sym_DASH_EQ] = ACTIONS(3794),
    [anon_sym_LT_LT_EQ] = ACTIONS(3794),
    [anon_sym_GT_GT_EQ] = ACTIONS(3794),
    [anon_sym_AMP_EQ] = ACTIONS(3794),
    [anon_sym_CARET_EQ] = ACTIONS(3794),
    [anon_sym_PIPE_EQ] = ACTIONS(3794),
    [anon_sym_and_eq] = ACTIONS(3790),
    [anon_sym_or_eq] = ACTIONS(3790),
    [anon_sym_xor_eq] = ACTIONS(3790),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3766),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3766),
    [anon_sym_not_eq] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3756),
    [anon_sym_decltype] = ACTIONS(3756),
    [sym_virtual] = ACTIONS(3756),
    [anon_sym_template] = ACTIONS(3756),
    [anon_sym_operator] = ACTIONS(3756),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
    [anon_sym___launch_bounds__] = ACTIONS(3756),
  },
  [884] = {
    [sym_string_literal] = STATE(2752),
    [sym_template_argument_list] = STATE(1681),
    [sym_raw_string_literal] = STATE(2752),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(3756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3771),
    [anon_sym_TILDE] = ACTIONS(3764),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3768),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3771),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(3774),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3758),
    [anon_sym___extension__] = ACTIONS(3756),
    [anon_sym___device__] = ACTIONS(3756),
    [anon_sym___host__] = ACTIONS(3756),
    [anon_sym___global__] = ACTIONS(3756),
    [anon_sym___forceinline__] = ACTIONS(3756),
    [anon_sym___noinline__] = ACTIONS(3756),
    [anon_sym_extern] = ACTIONS(3756),
    [anon_sym___attribute__] = ACTIONS(3756),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3764),
    [anon_sym___declspec] = ACTIONS(3756),
    [anon_sym___based] = ACTIONS(3756),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_signed] = ACTIONS(3784),
    [anon_sym_unsigned] = ACTIONS(3784),
    [anon_sym_long] = ACTIONS(3784),
    [anon_sym_short] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3768),
    [anon_sym_static] = ACTIONS(3756),
    [anon_sym_EQ] = ACTIONS(3790),
    [anon_sym_register] = ACTIONS(3756),
    [anon_sym_inline] = ACTIONS(3756),
    [anon_sym___inline] = ACTIONS(3756),
    [anon_sym___inline__] = ACTIONS(3756),
    [anon_sym___forceinline] = ACTIONS(3756),
    [anon_sym_thread_local] = ACTIONS(3756),
    [anon_sym___thread] = ACTIONS(3756),
    [anon_sym_const] = ACTIONS(3756),
    [anon_sym_constexpr] = ACTIONS(3756),
    [anon_sym_volatile] = ACTIONS(3756),
    [anon_sym_restrict] = ACTIONS(3756),
    [anon_sym___restrict__] = ACTIONS(3756),
    [anon_sym__Atomic] = ACTIONS(3756),
    [anon_sym__Noreturn] = ACTIONS(3756),
    [anon_sym_noreturn] = ACTIONS(3756),
    [anon_sym_mutable] = ACTIONS(3756),
    [anon_sym_constinit] = ACTIONS(3756),
    [anon_sym_consteval] = ACTIONS(3756),
    [anon_sym___shared__] = ACTIONS(3756),
    [anon_sym___local__] = ACTIONS(3756),
    [anon_sym___constant__] = ACTIONS(3756),
    [anon_sym___managed__] = ACTIONS(3756),
    [anon_sym___grid_constant__] = ACTIONS(3756),
    [anon_sym_alignas] = ACTIONS(3756),
    [anon_sym__Alignas] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3822),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3794),
    [anon_sym_SLASH_EQ] = ACTIONS(3794),
    [anon_sym_PERCENT_EQ] = ACTIONS(3794),
    [anon_sym_PLUS_EQ] = ACTIONS(3794),
    [anon_sym_DASH_EQ] = ACTIONS(3794),
    [anon_sym_LT_LT_EQ] = ACTIONS(3794),
    [anon_sym_GT_GT_EQ] = ACTIONS(3794),
    [anon_sym_AMP_EQ] = ACTIONS(3794),
    [anon_sym_CARET_EQ] = ACTIONS(3794),
    [anon_sym_PIPE_EQ] = ACTIONS(3794),
    [anon_sym_and_eq] = ACTIONS(3790),
    [anon_sym_or_eq] = ACTIONS(3790),
    [anon_sym_xor_eq] = ACTIONS(3790),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3766),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3766),
    [anon_sym_not_eq] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3756),
    [anon_sym_decltype] = ACTIONS(3756),
    [sym_virtual] = ACTIONS(3756),
    [anon_sym_template] = ACTIONS(3756),
    [anon_sym_operator] = ACTIONS(3756),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
    [anon_sym___launch_bounds__] = ACTIONS(3756),
  },
  [885] = {
    [sym_string_literal] = STATE(2519),
    [sym_template_argument_list] = STATE(1149),
    [sym_raw_string_literal] = STATE(2519),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(3756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3771),
    [anon_sym_COMMA] = ACTIONS(3771),
    [anon_sym_RPAREN] = ACTIONS(3771),
    [anon_sym_LPAREN2] = ACTIONS(3771),
    [anon_sym_TILDE] = ACTIONS(3764),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3768),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3771),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(3971),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym___extension__] = ACTIONS(3756),
    [anon_sym___device__] = ACTIONS(3756),
    [anon_sym___host__] = ACTIONS(3756),
    [anon_sym___global__] = ACTIONS(3756),
    [anon_sym___forceinline__] = ACTIONS(3756),
    [anon_sym___noinline__] = ACTIONS(3756),
    [anon_sym_extern] = ACTIONS(3756),
    [anon_sym___attribute__] = ACTIONS(3756),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3764),
    [anon_sym___declspec] = ACTIONS(3756),
    [anon_sym___based] = ACTIONS(3756),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_signed] = ACTIONS(3784),
    [anon_sym_unsigned] = ACTIONS(3784),
    [anon_sym_long] = ACTIONS(3784),
    [anon_sym_short] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3768),
    [anon_sym_static] = ACTIONS(3756),
    [anon_sym_EQ] = ACTIONS(3768),
    [anon_sym_register] = ACTIONS(3756),
    [anon_sym_inline] = ACTIONS(3756),
    [anon_sym___inline] = ACTIONS(3756),
    [anon_sym___inline__] = ACTIONS(3756),
    [anon_sym___forceinline] = ACTIONS(3756),
    [anon_sym_thread_local] = ACTIONS(3756),
    [anon_sym___thread] = ACTIONS(3756),
    [anon_sym_const] = ACTIONS(3756),
    [anon_sym_constexpr] = ACTIONS(3756),
    [anon_sym_volatile] = ACTIONS(3756),
    [anon_sym_restrict] = ACTIONS(3756),
    [anon_sym___restrict__] = ACTIONS(3756),
    [anon_sym__Atomic] = ACTIONS(3756),
    [anon_sym__Noreturn] = ACTIONS(3756),
    [anon_sym_noreturn] = ACTIONS(3756),
    [anon_sym_mutable] = ACTIONS(3756),
    [anon_sym_constinit] = ACTIONS(3756),
    [anon_sym_consteval] = ACTIONS(3756),
    [anon_sym___shared__] = ACTIONS(3756),
    [anon_sym___local__] = ACTIONS(3756),
    [anon_sym___constant__] = ACTIONS(3756),
    [anon_sym___managed__] = ACTIONS(3756),
    [anon_sym___grid_constant__] = ACTIONS(3756),
    [anon_sym_alignas] = ACTIONS(3756),
    [anon_sym__Alignas] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3758),
    [anon_sym_SLASH_EQ] = ACTIONS(3758),
    [anon_sym_PERCENT_EQ] = ACTIONS(3758),
    [anon_sym_PLUS_EQ] = ACTIONS(3758),
    [anon_sym_DASH_EQ] = ACTIONS(3758),
    [anon_sym_LT_LT_EQ] = ACTIONS(3758),
    [anon_sym_GT_GT_EQ] = ACTIONS(3758),
    [anon_sym_AMP_EQ] = ACTIONS(3758),
    [anon_sym_CARET_EQ] = ACTIONS(3758),
    [anon_sym_PIPE_EQ] = ACTIONS(3758),
    [anon_sym_and_eq] = ACTIONS(3974),
    [anon_sym_or_eq] = ACTIONS(3974),
    [anon_sym_xor_eq] = ACTIONS(3974),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3766),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3766),
    [anon_sym_not_eq] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3766),
    [anon_sym_L_DQUOTE] = ACTIONS(3976),
    [anon_sym_u_DQUOTE] = ACTIONS(3976),
    [anon_sym_U_DQUOTE] = ACTIONS(3976),
    [anon_sym_u8_DQUOTE] = ACTIONS(3976),
    [anon_sym_DQUOTE] = ACTIONS(3976),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3756),
    [anon_sym_decltype] = ACTIONS(3756),
    [sym_virtual] = ACTIONS(3756),
    [anon_sym_template] = ACTIONS(3756),
    [anon_sym_operator] = ACTIONS(3756),
    [anon_sym_R_DQUOTE] = ACTIONS(3978),
    [anon_sym_LR_DQUOTE] = ACTIONS(3978),
    [anon_sym_uR_DQUOTE] = ACTIONS(3978),
    [anon_sym_UR_DQUOTE] = ACTIONS(3978),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3978),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3758),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
    [anon_sym___launch_bounds__] = ACTIONS(3756),
  },
  [886] = {
    [sym_string_literal] = STATE(2752),
    [sym_template_argument_list] = STATE(1682),
    [sym_raw_string_literal] = STATE(2752),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(3756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3771),
    [anon_sym_COMMA] = ACTIONS(3771),
    [anon_sym_RPAREN] = ACTIONS(3771),
    [anon_sym_LPAREN2] = ACTIONS(3771),
    [anon_sym_TILDE] = ACTIONS(3764),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3768),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3771),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(3774),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym___extension__] = ACTIONS(3756),
    [anon_sym___device__] = ACTIONS(3756),
    [anon_sym___host__] = ACTIONS(3756),
    [anon_sym___global__] = ACTIONS(3756),
    [anon_sym___forceinline__] = ACTIONS(3756),
    [anon_sym___noinline__] = ACTIONS(3756),
    [anon_sym_extern] = ACTIONS(3756),
    [anon_sym___attribute__] = ACTIONS(3756),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3764),
    [anon_sym___declspec] = ACTIONS(3756),
    [anon_sym___based] = ACTIONS(3756),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_signed] = ACTIONS(3784),
    [anon_sym_unsigned] = ACTIONS(3784),
    [anon_sym_long] = ACTIONS(3784),
    [anon_sym_short] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3768),
    [anon_sym_static] = ACTIONS(3756),
    [anon_sym_EQ] = ACTIONS(3756),
    [anon_sym_register] = ACTIONS(3756),
    [anon_sym_inline] = ACTIONS(3756),
    [anon_sym___inline] = ACTIONS(3756),
    [anon_sym___inline__] = ACTIONS(3756),
    [anon_sym___forceinline] = ACTIONS(3756),
    [anon_sym_thread_local] = ACTIONS(3756),
    [anon_sym___thread] = ACTIONS(3756),
    [anon_sym_const] = ACTIONS(3756),
    [anon_sym_constexpr] = ACTIONS(3756),
    [anon_sym_volatile] = ACTIONS(3756),
    [anon_sym_restrict] = ACTIONS(3756),
    [anon_sym___restrict__] = ACTIONS(3756),
    [anon_sym__Atomic] = ACTIONS(3756),
    [anon_sym__Noreturn] = ACTIONS(3756),
    [anon_sym_noreturn] = ACTIONS(3756),
    [anon_sym_mutable] = ACTIONS(3756),
    [anon_sym_constinit] = ACTIONS(3756),
    [anon_sym_consteval] = ACTIONS(3756),
    [anon_sym___shared__] = ACTIONS(3756),
    [anon_sym___local__] = ACTIONS(3756),
    [anon_sym___constant__] = ACTIONS(3756),
    [anon_sym___managed__] = ACTIONS(3756),
    [anon_sym___grid_constant__] = ACTIONS(3756),
    [anon_sym_alignas] = ACTIONS(3756),
    [anon_sym__Alignas] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3794),
    [anon_sym_SLASH_EQ] = ACTIONS(3794),
    [anon_sym_PERCENT_EQ] = ACTIONS(3794),
    [anon_sym_PLUS_EQ] = ACTIONS(3794),
    [anon_sym_DASH_EQ] = ACTIONS(3794),
    [anon_sym_LT_LT_EQ] = ACTIONS(3794),
    [anon_sym_GT_GT_EQ] = ACTIONS(3794),
    [anon_sym_AMP_EQ] = ACTIONS(3794),
    [anon_sym_CARET_EQ] = ACTIONS(3794),
    [anon_sym_PIPE_EQ] = ACTIONS(3794),
    [anon_sym_and_eq] = ACTIONS(3790),
    [anon_sym_or_eq] = ACTIONS(3790),
    [anon_sym_xor_eq] = ACTIONS(3790),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3766),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3766),
    [anon_sym_not_eq] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3756),
    [anon_sym_decltype] = ACTIONS(3756),
    [sym_virtual] = ACTIONS(3756),
    [anon_sym_template] = ACTIONS(3756),
    [anon_sym_operator] = ACTIONS(3756),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
    [anon_sym___launch_bounds__] = ACTIONS(3756),
  },
  [887] = {
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6688),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6598),
    [sym_array_declarator] = STATE(6598),
    [sym_expression] = STATE(2471),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3535),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5915),
    [sym_qualified_identifier] = STATE(3525),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(3323),
    [anon_sym_LPAREN2] = ACTIONS(3325),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(3327),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(1843),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [888] = {
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6688),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6598),
    [sym_array_declarator] = STATE(6598),
    [sym_expression] = STATE(3094),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3575),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5981),
    [sym_qualified_identifier] = STATE(3569),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_operator_name] = STATE(6598),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(3169),
    [anon_sym_LPAREN2] = ACTIONS(1825),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1829),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1833),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(1843),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1883),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [889] = {
    [sym_identifier] = ACTIONS(3980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3982),
    [anon_sym_COMMA] = ACTIONS(3982),
    [anon_sym_RPAREN] = ACTIONS(3982),
    [anon_sym_LPAREN2] = ACTIONS(3982),
    [anon_sym_TILDE] = ACTIONS(3982),
    [anon_sym_DASH] = ACTIONS(3980),
    [anon_sym_PLUS] = ACTIONS(3980),
    [anon_sym_STAR] = ACTIONS(3980),
    [anon_sym_SLASH] = ACTIONS(3980),
    [anon_sym_PERCENT] = ACTIONS(3980),
    [anon_sym_PIPE_PIPE] = ACTIONS(3982),
    [anon_sym_AMP_AMP] = ACTIONS(3982),
    [anon_sym_PIPE] = ACTIONS(3980),
    [anon_sym_CARET] = ACTIONS(3980),
    [anon_sym_AMP] = ACTIONS(3980),
    [anon_sym_EQ_EQ] = ACTIONS(3982),
    [anon_sym_BANG_EQ] = ACTIONS(3982),
    [anon_sym_GT] = ACTIONS(3980),
    [anon_sym_GT_EQ] = ACTIONS(3982),
    [anon_sym_LT_EQ] = ACTIONS(3980),
    [anon_sym_LT] = ACTIONS(3980),
    [anon_sym_LT_LT] = ACTIONS(3980),
    [anon_sym_GT_GT] = ACTIONS(3980),
    [anon_sym_SEMI] = ACTIONS(3982),
    [anon_sym___extension__] = ACTIONS(3980),
    [anon_sym___device__] = ACTIONS(3980),
    [anon_sym___host__] = ACTIONS(3980),
    [anon_sym___global__] = ACTIONS(3980),
    [anon_sym___forceinline__] = ACTIONS(3980),
    [anon_sym___noinline__] = ACTIONS(3980),
    [anon_sym_extern] = ACTIONS(3980),
    [anon_sym___attribute__] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3982),
    [anon_sym___declspec] = ACTIONS(3980),
    [anon_sym___based] = ACTIONS(3980),
    [anon_sym___cdecl] = ACTIONS(3980),
    [anon_sym___clrcall] = ACTIONS(3980),
    [anon_sym___stdcall] = ACTIONS(3980),
    [anon_sym___fastcall] = ACTIONS(3980),
    [anon_sym___thiscall] = ACTIONS(3980),
    [anon_sym___vectorcall] = ACTIONS(3980),
    [anon_sym_LBRACE] = ACTIONS(3982),
    [anon_sym_RBRACE] = ACTIONS(3982),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_static] = ACTIONS(3980),
    [anon_sym_EQ] = ACTIONS(3980),
    [anon_sym_register] = ACTIONS(3980),
    [anon_sym_inline] = ACTIONS(3980),
    [anon_sym___inline] = ACTIONS(3980),
    [anon_sym___inline__] = ACTIONS(3980),
    [anon_sym___forceinline] = ACTIONS(3980),
    [anon_sym_thread_local] = ACTIONS(3980),
    [anon_sym___thread] = ACTIONS(3980),
    [anon_sym_const] = ACTIONS(3980),
    [anon_sym_constexpr] = ACTIONS(3980),
    [anon_sym_volatile] = ACTIONS(3980),
    [anon_sym_restrict] = ACTIONS(3980),
    [anon_sym___restrict__] = ACTIONS(3980),
    [anon_sym__Atomic] = ACTIONS(3980),
    [anon_sym__Noreturn] = ACTIONS(3980),
    [anon_sym_noreturn] = ACTIONS(3980),
    [anon_sym_mutable] = ACTIONS(3980),
    [anon_sym_constinit] = ACTIONS(3980),
    [anon_sym_consteval] = ACTIONS(3980),
    [anon_sym___shared__] = ACTIONS(3980),
    [anon_sym___local__] = ACTIONS(3980),
    [anon_sym___constant__] = ACTIONS(3980),
    [anon_sym___managed__] = ACTIONS(3980),
    [anon_sym___grid_constant__] = ACTIONS(3980),
    [anon_sym_alignas] = ACTIONS(3980),
    [anon_sym__Alignas] = ACTIONS(3980),
    [anon_sym_QMARK] = ACTIONS(3982),
    [anon_sym_STAR_EQ] = ACTIONS(3982),
    [anon_sym_SLASH_EQ] = ACTIONS(3982),
    [anon_sym_PERCENT_EQ] = ACTIONS(3982),
    [anon_sym_PLUS_EQ] = ACTIONS(3982),
    [anon_sym_DASH_EQ] = ACTIONS(3982),
    [anon_sym_LT_LT_EQ] = ACTIONS(3982),
    [anon_sym_GT_GT_EQ] = ACTIONS(3982),
    [anon_sym_AMP_EQ] = ACTIONS(3982),
    [anon_sym_CARET_EQ] = ACTIONS(3982),
    [anon_sym_PIPE_EQ] = ACTIONS(3982),
    [anon_sym_and_eq] = ACTIONS(3980),
    [anon_sym_or_eq] = ACTIONS(3980),
    [anon_sym_xor_eq] = ACTIONS(3980),
    [anon_sym_LT_EQ_GT] = ACTIONS(3982),
    [anon_sym_or] = ACTIONS(3980),
    [anon_sym_and] = ACTIONS(3980),
    [anon_sym_bitor] = ACTIONS(3980),
    [anon_sym_xor] = ACTIONS(3980),
    [anon_sym_bitand] = ACTIONS(3980),
    [anon_sym_not_eq] = ACTIONS(3980),
    [anon_sym_DASH_DASH] = ACTIONS(3982),
    [anon_sym_PLUS_PLUS] = ACTIONS(3982),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_DOT_STAR] = ACTIONS(3982),
    [anon_sym_DASH_GT] = ACTIONS(3982),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3980),
    [anon_sym_decltype] = ACTIONS(3980),
    [sym_virtual] = ACTIONS(3980),
    [anon_sym_template] = ACTIONS(3980),
    [anon_sym_operator] = ACTIONS(3980),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3982),
    [anon_sym___launch_bounds__] = ACTIONS(3980),
  },
  [890] = {
    [sym_identifier] = ACTIONS(3984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3986),
    [anon_sym_COMMA] = ACTIONS(3986),
    [anon_sym_RPAREN] = ACTIONS(3986),
    [anon_sym_LPAREN2] = ACTIONS(3986),
    [anon_sym_TILDE] = ACTIONS(3986),
    [anon_sym_DASH] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(3984),
    [anon_sym_SLASH] = ACTIONS(3984),
    [anon_sym_PERCENT] = ACTIONS(3984),
    [anon_sym_PIPE_PIPE] = ACTIONS(3986),
    [anon_sym_AMP_AMP] = ACTIONS(3986),
    [anon_sym_PIPE] = ACTIONS(3984),
    [anon_sym_CARET] = ACTIONS(3984),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_EQ_EQ] = ACTIONS(3986),
    [anon_sym_BANG_EQ] = ACTIONS(3986),
    [anon_sym_GT] = ACTIONS(3984),
    [anon_sym_GT_EQ] = ACTIONS(3986),
    [anon_sym_LT_EQ] = ACTIONS(3984),
    [anon_sym_LT] = ACTIONS(3984),
    [anon_sym_LT_LT] = ACTIONS(3984),
    [anon_sym_GT_GT] = ACTIONS(3984),
    [anon_sym_SEMI] = ACTIONS(3986),
    [anon_sym___extension__] = ACTIONS(3984),
    [anon_sym___device__] = ACTIONS(3984),
    [anon_sym___host__] = ACTIONS(3984),
    [anon_sym___global__] = ACTIONS(3984),
    [anon_sym___forceinline__] = ACTIONS(3984),
    [anon_sym___noinline__] = ACTIONS(3984),
    [anon_sym_extern] = ACTIONS(3984),
    [anon_sym___attribute__] = ACTIONS(3984),
    [anon_sym_COLON_COLON] = ACTIONS(3986),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3986),
    [anon_sym___declspec] = ACTIONS(3984),
    [anon_sym___based] = ACTIONS(3984),
    [anon_sym___cdecl] = ACTIONS(3984),
    [anon_sym___clrcall] = ACTIONS(3984),
    [anon_sym___stdcall] = ACTIONS(3984),
    [anon_sym___fastcall] = ACTIONS(3984),
    [anon_sym___thiscall] = ACTIONS(3984),
    [anon_sym___vectorcall] = ACTIONS(3984),
    [anon_sym_LBRACE] = ACTIONS(3986),
    [anon_sym_RBRACE] = ACTIONS(3986),
    [anon_sym_LBRACK] = ACTIONS(3984),
    [anon_sym_static] = ACTIONS(3984),
    [anon_sym_EQ] = ACTIONS(3984),
    [anon_sym_register] = ACTIONS(3984),
    [anon_sym_inline] = ACTIONS(3984),
    [anon_sym___inline] = ACTIONS(3984),
    [anon_sym___inline__] = ACTIONS(3984),
    [anon_sym___forceinline] = ACTIONS(3984),
    [anon_sym_thread_local] = ACTIONS(3984),
    [anon_sym___thread] = ACTIONS(3984),
    [anon_sym_const] = ACTIONS(3984),
    [anon_sym_constexpr] = ACTIONS(3984),
    [anon_sym_volatile] = ACTIONS(3984),
    [anon_sym_restrict] = ACTIONS(3984),
    [anon_sym___restrict__] = ACTIONS(3984),
    [anon_sym__Atomic] = ACTIONS(3984),
    [anon_sym__Noreturn] = ACTIONS(3984),
    [anon_sym_noreturn] = ACTIONS(3984),
    [anon_sym_mutable] = ACTIONS(3984),
    [anon_sym_constinit] = ACTIONS(3984),
    [anon_sym_consteval] = ACTIONS(3984),
    [anon_sym___shared__] = ACTIONS(3984),
    [anon_sym___local__] = ACTIONS(3984),
    [anon_sym___constant__] = ACTIONS(3984),
    [anon_sym___managed__] = ACTIONS(3984),
    [anon_sym___grid_constant__] = ACTIONS(3984),
    [anon_sym_alignas] = ACTIONS(3984),
    [anon_sym__Alignas] = ACTIONS(3984),
    [anon_sym_QMARK] = ACTIONS(3986),
    [anon_sym_STAR_EQ] = ACTIONS(3986),
    [anon_sym_SLASH_EQ] = ACTIONS(3986),
    [anon_sym_PERCENT_EQ] = ACTIONS(3986),
    [anon_sym_PLUS_EQ] = ACTIONS(3986),
    [anon_sym_DASH_EQ] = ACTIONS(3986),
    [anon_sym_LT_LT_EQ] = ACTIONS(3986),
    [anon_sym_GT_GT_EQ] = ACTIONS(3986),
    [anon_sym_AMP_EQ] = ACTIONS(3986),
    [anon_sym_CARET_EQ] = ACTIONS(3986),
    [anon_sym_PIPE_EQ] = ACTIONS(3986),
    [anon_sym_and_eq] = ACTIONS(3984),
    [anon_sym_or_eq] = ACTIONS(3984),
    [anon_sym_xor_eq] = ACTIONS(3984),
    [anon_sym_LT_EQ_GT] = ACTIONS(3986),
    [anon_sym_or] = ACTIONS(3984),
    [anon_sym_and] = ACTIONS(3984),
    [anon_sym_bitor] = ACTIONS(3984),
    [anon_sym_xor] = ACTIONS(3984),
    [anon_sym_bitand] = ACTIONS(3984),
    [anon_sym_not_eq] = ACTIONS(3984),
    [anon_sym_DASH_DASH] = ACTIONS(3986),
    [anon_sym_PLUS_PLUS] = ACTIONS(3986),
    [anon_sym_DOT] = ACTIONS(3984),
    [anon_sym_DOT_STAR] = ACTIONS(3986),
    [anon_sym_DASH_GT] = ACTIONS(3986),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3984),
    [anon_sym_decltype] = ACTIONS(3984),
    [sym_virtual] = ACTIONS(3984),
    [anon_sym_template] = ACTIONS(3984),
    [anon_sym_operator] = ACTIONS(3984),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3986),
    [anon_sym___launch_bounds__] = ACTIONS(3984),
  },
  [891] = {
    [sym_identifier] = ACTIONS(3988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3990),
    [anon_sym_COMMA] = ACTIONS(3990),
    [anon_sym_RPAREN] = ACTIONS(3990),
    [anon_sym_LPAREN2] = ACTIONS(3990),
    [anon_sym_TILDE] = ACTIONS(3990),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_STAR] = ACTIONS(3988),
    [anon_sym_SLASH] = ACTIONS(3988),
    [anon_sym_PERCENT] = ACTIONS(3988),
    [anon_sym_PIPE_PIPE] = ACTIONS(3990),
    [anon_sym_AMP_AMP] = ACTIONS(3990),
    [anon_sym_PIPE] = ACTIONS(3988),
    [anon_sym_CARET] = ACTIONS(3988),
    [anon_sym_AMP] = ACTIONS(3988),
    [anon_sym_EQ_EQ] = ACTIONS(3990),
    [anon_sym_BANG_EQ] = ACTIONS(3990),
    [anon_sym_GT] = ACTIONS(3988),
    [anon_sym_GT_EQ] = ACTIONS(3990),
    [anon_sym_LT_EQ] = ACTIONS(3988),
    [anon_sym_LT] = ACTIONS(3988),
    [anon_sym_LT_LT] = ACTIONS(3988),
    [anon_sym_GT_GT] = ACTIONS(3988),
    [anon_sym_SEMI] = ACTIONS(3990),
    [anon_sym___extension__] = ACTIONS(3988),
    [anon_sym___device__] = ACTIONS(3988),
    [anon_sym___host__] = ACTIONS(3988),
    [anon_sym___global__] = ACTIONS(3988),
    [anon_sym___forceinline__] = ACTIONS(3988),
    [anon_sym___noinline__] = ACTIONS(3988),
    [anon_sym_extern] = ACTIONS(3988),
    [anon_sym___attribute__] = ACTIONS(3988),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3990),
    [anon_sym___declspec] = ACTIONS(3988),
    [anon_sym___based] = ACTIONS(3988),
    [anon_sym___cdecl] = ACTIONS(3988),
    [anon_sym___clrcall] = ACTIONS(3988),
    [anon_sym___stdcall] = ACTIONS(3988),
    [anon_sym___fastcall] = ACTIONS(3988),
    [anon_sym___thiscall] = ACTIONS(3988),
    [anon_sym___vectorcall] = ACTIONS(3988),
    [anon_sym_LBRACE] = ACTIONS(3990),
    [anon_sym_RBRACE] = ACTIONS(3990),
    [anon_sym_LBRACK] = ACTIONS(3988),
    [anon_sym_static] = ACTIONS(3988),
    [anon_sym_EQ] = ACTIONS(3988),
    [anon_sym_register] = ACTIONS(3988),
    [anon_sym_inline] = ACTIONS(3988),
    [anon_sym___inline] = ACTIONS(3988),
    [anon_sym___inline__] = ACTIONS(3988),
    [anon_sym___forceinline] = ACTIONS(3988),
    [anon_sym_thread_local] = ACTIONS(3988),
    [anon_sym___thread] = ACTIONS(3988),
    [anon_sym_const] = ACTIONS(3988),
    [anon_sym_constexpr] = ACTIONS(3988),
    [anon_sym_volatile] = ACTIONS(3988),
    [anon_sym_restrict] = ACTIONS(3988),
    [anon_sym___restrict__] = ACTIONS(3988),
    [anon_sym__Atomic] = ACTIONS(3988),
    [anon_sym__Noreturn] = ACTIONS(3988),
    [anon_sym_noreturn] = ACTIONS(3988),
    [anon_sym_mutable] = ACTIONS(3988),
    [anon_sym_constinit] = ACTIONS(3988),
    [anon_sym_consteval] = ACTIONS(3988),
    [anon_sym___shared__] = ACTIONS(3988),
    [anon_sym___local__] = ACTIONS(3988),
    [anon_sym___constant__] = ACTIONS(3988),
    [anon_sym___managed__] = ACTIONS(3988),
    [anon_sym___grid_constant__] = ACTIONS(3988),
    [anon_sym_alignas] = ACTIONS(3988),
    [anon_sym__Alignas] = ACTIONS(3988),
    [anon_sym_QMARK] = ACTIONS(3990),
    [anon_sym_STAR_EQ] = ACTIONS(3990),
    [anon_sym_SLASH_EQ] = ACTIONS(3990),
    [anon_sym_PERCENT_EQ] = ACTIONS(3990),
    [anon_sym_PLUS_EQ] = ACTIONS(3990),
    [anon_sym_DASH_EQ] = ACTIONS(3990),
    [anon_sym_LT_LT_EQ] = ACTIONS(3990),
    [anon_sym_GT_GT_EQ] = ACTIONS(3990),
    [anon_sym_AMP_EQ] = ACTIONS(3990),
    [anon_sym_CARET_EQ] = ACTIONS(3990),
    [anon_sym_PIPE_EQ] = ACTIONS(3990),
    [anon_sym_and_eq] = ACTIONS(3988),
    [anon_sym_or_eq] = ACTIONS(3988),
    [anon_sym_xor_eq] = ACTIONS(3988),
    [anon_sym_LT_EQ_GT] = ACTIONS(3990),
    [anon_sym_or] = ACTIONS(3988),
    [anon_sym_and] = ACTIONS(3988),
    [anon_sym_bitor] = ACTIONS(3988),
    [anon_sym_xor] = ACTIONS(3988),
    [anon_sym_bitand] = ACTIONS(3988),
    [anon_sym_not_eq] = ACTIONS(3988),
    [anon_sym_DASH_DASH] = ACTIONS(3990),
    [anon_sym_PLUS_PLUS] = ACTIONS(3990),
    [anon_sym_DOT] = ACTIONS(3988),
    [anon_sym_DOT_STAR] = ACTIONS(3990),
    [anon_sym_DASH_GT] = ACTIONS(3990),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3988),
    [anon_sym_decltype] = ACTIONS(3988),
    [sym_virtual] = ACTIONS(3988),
    [anon_sym_template] = ACTIONS(3988),
    [anon_sym_operator] = ACTIONS(3988),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3990),
    [anon_sym___launch_bounds__] = ACTIONS(3988),
  },
  [892] = {
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3994),
    [anon_sym_COMMA] = ACTIONS(3994),
    [anon_sym_RPAREN] = ACTIONS(3994),
    [anon_sym_LPAREN2] = ACTIONS(3994),
    [anon_sym_TILDE] = ACTIONS(3994),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_STAR] = ACTIONS(3992),
    [anon_sym_SLASH] = ACTIONS(3992),
    [anon_sym_PERCENT] = ACTIONS(3992),
    [anon_sym_PIPE_PIPE] = ACTIONS(3994),
    [anon_sym_AMP_AMP] = ACTIONS(3994),
    [anon_sym_PIPE] = ACTIONS(3992),
    [anon_sym_CARET] = ACTIONS(3992),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym_EQ_EQ] = ACTIONS(3994),
    [anon_sym_BANG_EQ] = ACTIONS(3994),
    [anon_sym_GT] = ACTIONS(3992),
    [anon_sym_GT_EQ] = ACTIONS(3994),
    [anon_sym_LT_EQ] = ACTIONS(3992),
    [anon_sym_LT] = ACTIONS(3992),
    [anon_sym_LT_LT] = ACTIONS(3992),
    [anon_sym_GT_GT] = ACTIONS(3992),
    [anon_sym_SEMI] = ACTIONS(3994),
    [anon_sym___extension__] = ACTIONS(3992),
    [anon_sym___device__] = ACTIONS(3992),
    [anon_sym___host__] = ACTIONS(3992),
    [anon_sym___global__] = ACTIONS(3992),
    [anon_sym___forceinline__] = ACTIONS(3992),
    [anon_sym___noinline__] = ACTIONS(3992),
    [anon_sym_extern] = ACTIONS(3992),
    [anon_sym___attribute__] = ACTIONS(3992),
    [anon_sym_COLON_COLON] = ACTIONS(3994),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3994),
    [anon_sym___declspec] = ACTIONS(3992),
    [anon_sym___based] = ACTIONS(3992),
    [anon_sym___cdecl] = ACTIONS(3992),
    [anon_sym___clrcall] = ACTIONS(3992),
    [anon_sym___stdcall] = ACTIONS(3992),
    [anon_sym___fastcall] = ACTIONS(3992),
    [anon_sym___thiscall] = ACTIONS(3992),
    [anon_sym___vectorcall] = ACTIONS(3992),
    [anon_sym_LBRACE] = ACTIONS(3994),
    [anon_sym_RBRACE] = ACTIONS(3994),
    [anon_sym_LBRACK] = ACTIONS(3992),
    [anon_sym_static] = ACTIONS(3992),
    [anon_sym_EQ] = ACTIONS(3992),
    [anon_sym_register] = ACTIONS(3992),
    [anon_sym_inline] = ACTIONS(3992),
    [anon_sym___inline] = ACTIONS(3992),
    [anon_sym___inline__] = ACTIONS(3992),
    [anon_sym___forceinline] = ACTIONS(3992),
    [anon_sym_thread_local] = ACTIONS(3992),
    [anon_sym___thread] = ACTIONS(3992),
    [anon_sym_const] = ACTIONS(3992),
    [anon_sym_constexpr] = ACTIONS(3992),
    [anon_sym_volatile] = ACTIONS(3992),
    [anon_sym_restrict] = ACTIONS(3992),
    [anon_sym___restrict__] = ACTIONS(3992),
    [anon_sym__Atomic] = ACTIONS(3992),
    [anon_sym__Noreturn] = ACTIONS(3992),
    [anon_sym_noreturn] = ACTIONS(3992),
    [anon_sym_mutable] = ACTIONS(3992),
    [anon_sym_constinit] = ACTIONS(3992),
    [anon_sym_consteval] = ACTIONS(3992),
    [anon_sym___shared__] = ACTIONS(3992),
    [anon_sym___local__] = ACTIONS(3992),
    [anon_sym___constant__] = ACTIONS(3992),
    [anon_sym___managed__] = ACTIONS(3992),
    [anon_sym___grid_constant__] = ACTIONS(3992),
    [anon_sym_alignas] = ACTIONS(3992),
    [anon_sym__Alignas] = ACTIONS(3992),
    [anon_sym_QMARK] = ACTIONS(3994),
    [anon_sym_STAR_EQ] = ACTIONS(3994),
    [anon_sym_SLASH_EQ] = ACTIONS(3994),
    [anon_sym_PERCENT_EQ] = ACTIONS(3994),
    [anon_sym_PLUS_EQ] = ACTIONS(3994),
    [anon_sym_DASH_EQ] = ACTIONS(3994),
    [anon_sym_LT_LT_EQ] = ACTIONS(3994),
    [anon_sym_GT_GT_EQ] = ACTIONS(3994),
    [anon_sym_AMP_EQ] = ACTIONS(3994),
    [anon_sym_CARET_EQ] = ACTIONS(3994),
    [anon_sym_PIPE_EQ] = ACTIONS(3994),
    [anon_sym_and_eq] = ACTIONS(3992),
    [anon_sym_or_eq] = ACTIONS(3992),
    [anon_sym_xor_eq] = ACTIONS(3992),
    [anon_sym_LT_EQ_GT] = ACTIONS(3994),
    [anon_sym_or] = ACTIONS(3992),
    [anon_sym_and] = ACTIONS(3992),
    [anon_sym_bitor] = ACTIONS(3992),
    [anon_sym_xor] = ACTIONS(3992),
    [anon_sym_bitand] = ACTIONS(3992),
    [anon_sym_not_eq] = ACTIONS(3992),
    [anon_sym_DASH_DASH] = ACTIONS(3994),
    [anon_sym_PLUS_PLUS] = ACTIONS(3994),
    [anon_sym_DOT] = ACTIONS(3992),
    [anon_sym_DOT_STAR] = ACTIONS(3994),
    [anon_sym_DASH_GT] = ACTIONS(3994),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3992),
    [anon_sym_decltype] = ACTIONS(3992),
    [sym_virtual] = ACTIONS(3992),
    [anon_sym_template] = ACTIONS(3992),
    [anon_sym_operator] = ACTIONS(3992),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3994),
    [anon_sym___launch_bounds__] = ACTIONS(3992),
  },
  [893] = {
    [sym_identifier] = ACTIONS(3996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3998),
    [anon_sym_COMMA] = ACTIONS(3998),
    [anon_sym_RPAREN] = ACTIONS(3998),
    [anon_sym_LPAREN2] = ACTIONS(3998),
    [anon_sym_TILDE] = ACTIONS(3998),
    [anon_sym_DASH] = ACTIONS(3996),
    [anon_sym_PLUS] = ACTIONS(3996),
    [anon_sym_STAR] = ACTIONS(3996),
    [anon_sym_SLASH] = ACTIONS(3996),
    [anon_sym_PERCENT] = ACTIONS(3996),
    [anon_sym_PIPE_PIPE] = ACTIONS(3998),
    [anon_sym_AMP_AMP] = ACTIONS(3998),
    [anon_sym_PIPE] = ACTIONS(3996),
    [anon_sym_CARET] = ACTIONS(3996),
    [anon_sym_AMP] = ACTIONS(3996),
    [anon_sym_EQ_EQ] = ACTIONS(3998),
    [anon_sym_BANG_EQ] = ACTIONS(3998),
    [anon_sym_GT] = ACTIONS(3996),
    [anon_sym_GT_EQ] = ACTIONS(3998),
    [anon_sym_LT_EQ] = ACTIONS(3996),
    [anon_sym_LT] = ACTIONS(3996),
    [anon_sym_LT_LT] = ACTIONS(3996),
    [anon_sym_GT_GT] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(3998),
    [anon_sym___extension__] = ACTIONS(3996),
    [anon_sym___device__] = ACTIONS(3996),
    [anon_sym___host__] = ACTIONS(3996),
    [anon_sym___global__] = ACTIONS(3996),
    [anon_sym___forceinline__] = ACTIONS(3996),
    [anon_sym___noinline__] = ACTIONS(3996),
    [anon_sym_extern] = ACTIONS(3996),
    [anon_sym___attribute__] = ACTIONS(3996),
    [anon_sym_COLON_COLON] = ACTIONS(3998),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3998),
    [anon_sym___declspec] = ACTIONS(3996),
    [anon_sym___based] = ACTIONS(3996),
    [anon_sym___cdecl] = ACTIONS(3996),
    [anon_sym___clrcall] = ACTIONS(3996),
    [anon_sym___stdcall] = ACTIONS(3996),
    [anon_sym___fastcall] = ACTIONS(3996),
    [anon_sym___thiscall] = ACTIONS(3996),
    [anon_sym___vectorcall] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(3998),
    [anon_sym_RBRACE] = ACTIONS(3998),
    [anon_sym_LBRACK] = ACTIONS(3996),
    [anon_sym_static] = ACTIONS(3996),
    [anon_sym_EQ] = ACTIONS(3996),
    [anon_sym_register] = ACTIONS(3996),
    [anon_sym_inline] = ACTIONS(3996),
    [anon_sym___inline] = ACTIONS(3996),
    [anon_sym___inline__] = ACTIONS(3996),
    [anon_sym___forceinline] = ACTIONS(3996),
    [anon_sym_thread_local] = ACTIONS(3996),
    [anon_sym___thread] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3996),
    [anon_sym_constexpr] = ACTIONS(3996),
    [anon_sym_volatile] = ACTIONS(3996),
    [anon_sym_restrict] = ACTIONS(3996),
    [anon_sym___restrict__] = ACTIONS(3996),
    [anon_sym__Atomic] = ACTIONS(3996),
    [anon_sym__Noreturn] = ACTIONS(3996),
    [anon_sym_noreturn] = ACTIONS(3996),
    [anon_sym_mutable] = ACTIONS(3996),
    [anon_sym_constinit] = ACTIONS(3996),
    [anon_sym_consteval] = ACTIONS(3996),
    [anon_sym___shared__] = ACTIONS(3996),
    [anon_sym___local__] = ACTIONS(3996),
    [anon_sym___constant__] = ACTIONS(3996),
    [anon_sym___managed__] = ACTIONS(3996),
    [anon_sym___grid_constant__] = ACTIONS(3996),
    [anon_sym_alignas] = ACTIONS(3996),
    [anon_sym__Alignas] = ACTIONS(3996),
    [anon_sym_QMARK] = ACTIONS(3998),
    [anon_sym_STAR_EQ] = ACTIONS(3998),
    [anon_sym_SLASH_EQ] = ACTIONS(3998),
    [anon_sym_PERCENT_EQ] = ACTIONS(3998),
    [anon_sym_PLUS_EQ] = ACTIONS(3998),
    [anon_sym_DASH_EQ] = ACTIONS(3998),
    [anon_sym_LT_LT_EQ] = ACTIONS(3998),
    [anon_sym_GT_GT_EQ] = ACTIONS(3998),
    [anon_sym_AMP_EQ] = ACTIONS(3998),
    [anon_sym_CARET_EQ] = ACTIONS(3998),
    [anon_sym_PIPE_EQ] = ACTIONS(3998),
    [anon_sym_and_eq] = ACTIONS(3996),
    [anon_sym_or_eq] = ACTIONS(3996),
    [anon_sym_xor_eq] = ACTIONS(3996),
    [anon_sym_LT_EQ_GT] = ACTIONS(3998),
    [anon_sym_or] = ACTIONS(3996),
    [anon_sym_and] = ACTIONS(3996),
    [anon_sym_bitor] = ACTIONS(3996),
    [anon_sym_xor] = ACTIONS(3996),
    [anon_sym_bitand] = ACTIONS(3996),
    [anon_sym_not_eq] = ACTIONS(3996),
    [anon_sym_DASH_DASH] = ACTIONS(3998),
    [anon_sym_PLUS_PLUS] = ACTIONS(3998),
    [anon_sym_DOT] = ACTIONS(3996),
    [anon_sym_DOT_STAR] = ACTIONS(3998),
    [anon_sym_DASH_GT] = ACTIONS(3998),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3996),
    [anon_sym_decltype] = ACTIONS(3996),
    [sym_virtual] = ACTIONS(3996),
    [anon_sym_template] = ACTIONS(3996),
    [anon_sym_operator] = ACTIONS(3996),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3998),
    [anon_sym___launch_bounds__] = ACTIONS(3996),
  },
  [894] = {
    [sym_template_argument_list] = STATE(906),
    [sym_identifier] = ACTIONS(4000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4002),
    [anon_sym_COMMA] = ACTIONS(4002),
    [anon_sym_LPAREN2] = ACTIONS(4004),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4009),
    [anon_sym_PLUS] = ACTIONS(4009),
    [anon_sym_STAR] = ACTIONS(4011),
    [anon_sym_SLASH] = ACTIONS(4009),
    [anon_sym_PERCENT] = ACTIONS(4009),
    [anon_sym_PIPE_PIPE] = ACTIONS(4002),
    [anon_sym_AMP_AMP] = ACTIONS(4004),
    [anon_sym_PIPE] = ACTIONS(4009),
    [anon_sym_CARET] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4011),
    [anon_sym_EQ_EQ] = ACTIONS(4002),
    [anon_sym_BANG_EQ] = ACTIONS(4002),
    [anon_sym_GT] = ACTIONS(4009),
    [anon_sym_GT_EQ] = ACTIONS(4002),
    [anon_sym_LT_EQ] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(4014),
    [anon_sym_LT_LT] = ACTIONS(4009),
    [anon_sym_GT_GT] = ACTIONS(4009),
    [anon_sym_SEMI] = ACTIONS(4004),
    [anon_sym___extension__] = ACTIONS(4000),
    [anon_sym___device__] = ACTIONS(4000),
    [anon_sym___host__] = ACTIONS(4000),
    [anon_sym___global__] = ACTIONS(4000),
    [anon_sym___forceinline__] = ACTIONS(4000),
    [anon_sym___noinline__] = ACTIONS(4000),
    [anon_sym_extern] = ACTIONS(4000),
    [anon_sym___attribute__] = ACTIONS(4000),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4004),
    [anon_sym___declspec] = ACTIONS(4000),
    [anon_sym___based] = ACTIONS(4000),
    [anon_sym___cdecl] = ACTIONS(4000),
    [anon_sym___clrcall] = ACTIONS(4000),
    [anon_sym___stdcall] = ACTIONS(4000),
    [anon_sym___fastcall] = ACTIONS(4000),
    [anon_sym___thiscall] = ACTIONS(4000),
    [anon_sym___vectorcall] = ACTIONS(4000),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_RBRACE] = ACTIONS(4002),
    [anon_sym_LBRACK] = ACTIONS(4011),
    [anon_sym_static] = ACTIONS(4000),
    [anon_sym_EQ] = ACTIONS(4009),
    [anon_sym_register] = ACTIONS(4000),
    [anon_sym_inline] = ACTIONS(4000),
    [anon_sym___inline] = ACTIONS(4000),
    [anon_sym___inline__] = ACTIONS(4000),
    [anon_sym___forceinline] = ACTIONS(4000),
    [anon_sym_thread_local] = ACTIONS(4000),
    [anon_sym___thread] = ACTIONS(4000),
    [anon_sym_const] = ACTIONS(4000),
    [anon_sym_constexpr] = ACTIONS(4000),
    [anon_sym_volatile] = ACTIONS(4000),
    [anon_sym_restrict] = ACTIONS(4000),
    [anon_sym___restrict__] = ACTIONS(4000),
    [anon_sym__Atomic] = ACTIONS(4000),
    [anon_sym__Noreturn] = ACTIONS(4000),
    [anon_sym_noreturn] = ACTIONS(4000),
    [anon_sym_mutable] = ACTIONS(4000),
    [anon_sym_constinit] = ACTIONS(4000),
    [anon_sym_consteval] = ACTIONS(4000),
    [anon_sym___shared__] = ACTIONS(4000),
    [anon_sym___local__] = ACTIONS(4000),
    [anon_sym___constant__] = ACTIONS(4000),
    [anon_sym___managed__] = ACTIONS(4000),
    [anon_sym___grid_constant__] = ACTIONS(4000),
    [anon_sym_alignas] = ACTIONS(4000),
    [anon_sym__Alignas] = ACTIONS(4000),
    [anon_sym_QMARK] = ACTIONS(4002),
    [anon_sym_STAR_EQ] = ACTIONS(4002),
    [anon_sym_SLASH_EQ] = ACTIONS(4002),
    [anon_sym_PERCENT_EQ] = ACTIONS(4002),
    [anon_sym_PLUS_EQ] = ACTIONS(4002),
    [anon_sym_DASH_EQ] = ACTIONS(4002),
    [anon_sym_LT_LT_EQ] = ACTIONS(4002),
    [anon_sym_GT_GT_EQ] = ACTIONS(4002),
    [anon_sym_AMP_EQ] = ACTIONS(4002),
    [anon_sym_CARET_EQ] = ACTIONS(4002),
    [anon_sym_PIPE_EQ] = ACTIONS(4002),
    [anon_sym_and_eq] = ACTIONS(4009),
    [anon_sym_or_eq] = ACTIONS(4009),
    [anon_sym_xor_eq] = ACTIONS(4009),
    [anon_sym_LT_EQ_GT] = ACTIONS(4002),
    [anon_sym_or] = ACTIONS(4009),
    [anon_sym_and] = ACTIONS(4009),
    [anon_sym_bitor] = ACTIONS(4009),
    [anon_sym_xor] = ACTIONS(4009),
    [anon_sym_bitand] = ACTIONS(4009),
    [anon_sym_not_eq] = ACTIONS(4009),
    [anon_sym_DASH_DASH] = ACTIONS(4002),
    [anon_sym_PLUS_PLUS] = ACTIONS(4002),
    [anon_sym_DOT] = ACTIONS(4009),
    [anon_sym_DOT_STAR] = ACTIONS(4002),
    [anon_sym_DASH_GT] = ACTIONS(4002),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4000),
    [anon_sym_decltype] = ACTIONS(4000),
    [sym_virtual] = ACTIONS(4000),
    [anon_sym_template] = ACTIONS(4000),
    [anon_sym_operator] = ACTIONS(4000),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4002),
    [anon_sym___launch_bounds__] = ACTIONS(4000),
  },
  [895] = {
    [sym_identifier] = ACTIONS(4017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4019),
    [anon_sym_COMMA] = ACTIONS(4019),
    [anon_sym_RPAREN] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(4019),
    [anon_sym_TILDE] = ACTIONS(4019),
    [anon_sym_DASH] = ACTIONS(4017),
    [anon_sym_PLUS] = ACTIONS(4017),
    [anon_sym_STAR] = ACTIONS(4017),
    [anon_sym_SLASH] = ACTIONS(4017),
    [anon_sym_PERCENT] = ACTIONS(4017),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE] = ACTIONS(4017),
    [anon_sym_CARET] = ACTIONS(4017),
    [anon_sym_AMP] = ACTIONS(4017),
    [anon_sym_EQ_EQ] = ACTIONS(4019),
    [anon_sym_BANG_EQ] = ACTIONS(4019),
    [anon_sym_GT] = ACTIONS(4017),
    [anon_sym_GT_EQ] = ACTIONS(4019),
    [anon_sym_LT_EQ] = ACTIONS(4017),
    [anon_sym_LT] = ACTIONS(4017),
    [anon_sym_LT_LT] = ACTIONS(4017),
    [anon_sym_GT_GT] = ACTIONS(4017),
    [anon_sym_SEMI] = ACTIONS(4019),
    [anon_sym___extension__] = ACTIONS(4017),
    [anon_sym___device__] = ACTIONS(4017),
    [anon_sym___host__] = ACTIONS(4017),
    [anon_sym___global__] = ACTIONS(4017),
    [anon_sym___forceinline__] = ACTIONS(4017),
    [anon_sym___noinline__] = ACTIONS(4017),
    [anon_sym_extern] = ACTIONS(4017),
    [anon_sym___attribute__] = ACTIONS(4017),
    [anon_sym_COLON_COLON] = ACTIONS(4019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4019),
    [anon_sym___declspec] = ACTIONS(4017),
    [anon_sym___based] = ACTIONS(4017),
    [anon_sym___cdecl] = ACTIONS(4017),
    [anon_sym___clrcall] = ACTIONS(4017),
    [anon_sym___stdcall] = ACTIONS(4017),
    [anon_sym___fastcall] = ACTIONS(4017),
    [anon_sym___thiscall] = ACTIONS(4017),
    [anon_sym___vectorcall] = ACTIONS(4017),
    [anon_sym_LBRACE] = ACTIONS(4019),
    [anon_sym_RBRACE] = ACTIONS(4019),
    [anon_sym_LBRACK] = ACTIONS(4017),
    [anon_sym_static] = ACTIONS(4017),
    [anon_sym_EQ] = ACTIONS(4017),
    [anon_sym_register] = ACTIONS(4017),
    [anon_sym_inline] = ACTIONS(4017),
    [anon_sym___inline] = ACTIONS(4017),
    [anon_sym___inline__] = ACTIONS(4017),
    [anon_sym___forceinline] = ACTIONS(4017),
    [anon_sym_thread_local] = ACTIONS(4017),
    [anon_sym___thread] = ACTIONS(4017),
    [anon_sym_const] = ACTIONS(4017),
    [anon_sym_constexpr] = ACTIONS(4017),
    [anon_sym_volatile] = ACTIONS(4017),
    [anon_sym_restrict] = ACTIONS(4017),
    [anon_sym___restrict__] = ACTIONS(4017),
    [anon_sym__Atomic] = ACTIONS(4017),
    [anon_sym__Noreturn] = ACTIONS(4017),
    [anon_sym_noreturn] = ACTIONS(4017),
    [anon_sym_mutable] = ACTIONS(4017),
    [anon_sym_constinit] = ACTIONS(4017),
    [anon_sym_consteval] = ACTIONS(4017),
    [anon_sym___shared__] = ACTIONS(4017),
    [anon_sym___local__] = ACTIONS(4017),
    [anon_sym___constant__] = ACTIONS(4017),
    [anon_sym___managed__] = ACTIONS(4017),
    [anon_sym___grid_constant__] = ACTIONS(4017),
    [anon_sym_alignas] = ACTIONS(4017),
    [anon_sym__Alignas] = ACTIONS(4017),
    [anon_sym_QMARK] = ACTIONS(4019),
    [anon_sym_STAR_EQ] = ACTIONS(4019),
    [anon_sym_SLASH_EQ] = ACTIONS(4019),
    [anon_sym_PERCENT_EQ] = ACTIONS(4019),
    [anon_sym_PLUS_EQ] = ACTIONS(4019),
    [anon_sym_DASH_EQ] = ACTIONS(4019),
    [anon_sym_LT_LT_EQ] = ACTIONS(4019),
    [anon_sym_GT_GT_EQ] = ACTIONS(4019),
    [anon_sym_AMP_EQ] = ACTIONS(4019),
    [anon_sym_CARET_EQ] = ACTIONS(4019),
    [anon_sym_PIPE_EQ] = ACTIONS(4019),
    [anon_sym_and_eq] = ACTIONS(4017),
    [anon_sym_or_eq] = ACTIONS(4017),
    [anon_sym_xor_eq] = ACTIONS(4017),
    [anon_sym_LT_EQ_GT] = ACTIONS(4019),
    [anon_sym_or] = ACTIONS(4017),
    [anon_sym_and] = ACTIONS(4017),
    [anon_sym_bitor] = ACTIONS(4017),
    [anon_sym_xor] = ACTIONS(4017),
    [anon_sym_bitand] = ACTIONS(4017),
    [anon_sym_not_eq] = ACTIONS(4017),
    [anon_sym_DASH_DASH] = ACTIONS(4019),
    [anon_sym_PLUS_PLUS] = ACTIONS(4019),
    [anon_sym_DOT] = ACTIONS(4017),
    [anon_sym_DOT_STAR] = ACTIONS(4019),
    [anon_sym_DASH_GT] = ACTIONS(4019),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4017),
    [anon_sym_decltype] = ACTIONS(4017),
    [sym_virtual] = ACTIONS(4017),
    [anon_sym_template] = ACTIONS(4017),
    [anon_sym_operator] = ACTIONS(4017),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4019),
    [anon_sym___launch_bounds__] = ACTIONS(4017),
  },
  [896] = {
    [sym_identifier] = ACTIONS(4021),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_RPAREN] = ACTIONS(4023),
    [anon_sym_LPAREN2] = ACTIONS(4023),
    [anon_sym_TILDE] = ACTIONS(4023),
    [anon_sym_DASH] = ACTIONS(4021),
    [anon_sym_PLUS] = ACTIONS(4021),
    [anon_sym_STAR] = ACTIONS(4021),
    [anon_sym_SLASH] = ACTIONS(4021),
    [anon_sym_PERCENT] = ACTIONS(4021),
    [anon_sym_PIPE_PIPE] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4023),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_CARET] = ACTIONS(4021),
    [anon_sym_AMP] = ACTIONS(4021),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4021),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4021),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym___extension__] = ACTIONS(4021),
    [anon_sym___device__] = ACTIONS(4021),
    [anon_sym___host__] = ACTIONS(4021),
    [anon_sym___global__] = ACTIONS(4021),
    [anon_sym___forceinline__] = ACTIONS(4021),
    [anon_sym___noinline__] = ACTIONS(4021),
    [anon_sym_extern] = ACTIONS(4021),
    [anon_sym___attribute__] = ACTIONS(4021),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4023),
    [anon_sym___declspec] = ACTIONS(4021),
    [anon_sym___based] = ACTIONS(4021),
    [anon_sym___cdecl] = ACTIONS(4021),
    [anon_sym___clrcall] = ACTIONS(4021),
    [anon_sym___stdcall] = ACTIONS(4021),
    [anon_sym___fastcall] = ACTIONS(4021),
    [anon_sym___thiscall] = ACTIONS(4021),
    [anon_sym___vectorcall] = ACTIONS(4021),
    [anon_sym_LBRACE] = ACTIONS(4023),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_LBRACK] = ACTIONS(4021),
    [anon_sym_static] = ACTIONS(4021),
    [anon_sym_EQ] = ACTIONS(4021),
    [anon_sym_register] = ACTIONS(4021),
    [anon_sym_inline] = ACTIONS(4021),
    [anon_sym___inline] = ACTIONS(4021),
    [anon_sym___inline__] = ACTIONS(4021),
    [anon_sym___forceinline] = ACTIONS(4021),
    [anon_sym_thread_local] = ACTIONS(4021),
    [anon_sym___thread] = ACTIONS(4021),
    [anon_sym_const] = ACTIONS(4021),
    [anon_sym_constexpr] = ACTIONS(4021),
    [anon_sym_volatile] = ACTIONS(4021),
    [anon_sym_restrict] = ACTIONS(4021),
    [anon_sym___restrict__] = ACTIONS(4021),
    [anon_sym__Atomic] = ACTIONS(4021),
    [anon_sym__Noreturn] = ACTIONS(4021),
    [anon_sym_noreturn] = ACTIONS(4021),
    [anon_sym_mutable] = ACTIONS(4021),
    [anon_sym_constinit] = ACTIONS(4021),
    [anon_sym_consteval] = ACTIONS(4021),
    [anon_sym___shared__] = ACTIONS(4021),
    [anon_sym___local__] = ACTIONS(4021),
    [anon_sym___constant__] = ACTIONS(4021),
    [anon_sym___managed__] = ACTIONS(4021),
    [anon_sym___grid_constant__] = ACTIONS(4021),
    [anon_sym_alignas] = ACTIONS(4021),
    [anon_sym__Alignas] = ACTIONS(4021),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_and_eq] = ACTIONS(4021),
    [anon_sym_or_eq] = ACTIONS(4021),
    [anon_sym_xor_eq] = ACTIONS(4021),
    [anon_sym_LT_EQ_GT] = ACTIONS(4023),
    [anon_sym_or] = ACTIONS(4021),
    [anon_sym_and] = ACTIONS(4021),
    [anon_sym_bitor] = ACTIONS(4021),
    [anon_sym_xor] = ACTIONS(4021),
    [anon_sym_bitand] = ACTIONS(4021),
    [anon_sym_not_eq] = ACTIONS(4021),
    [anon_sym_DASH_DASH] = ACTIONS(4023),
    [anon_sym_PLUS_PLUS] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4021),
    [anon_sym_DOT_STAR] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4021),
    [anon_sym_decltype] = ACTIONS(4021),
    [sym_virtual] = ACTIONS(4021),
    [anon_sym_template] = ACTIONS(4021),
    [anon_sym_operator] = ACTIONS(4021),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4023),
    [anon_sym___launch_bounds__] = ACTIONS(4021),
  },
  [897] = {
    [sym_expression_statement] = STATE(3051),
    [sym_expression] = STATE(4818),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8770),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_type_requirement] = STATE(897),
    [sym_compound_requirement] = STATE(897),
    [sym__requirement] = STATE(897),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_requirement_seq_repeat1] = STATE(897),
    [sym_identifier] = ACTIONS(4025),
    [anon_sym_LPAREN2] = ACTIONS(4028),
    [anon_sym_BANG] = ACTIONS(4031),
    [anon_sym_TILDE] = ACTIONS(4031),
    [anon_sym_DASH] = ACTIONS(4034),
    [anon_sym_PLUS] = ACTIONS(4034),
    [anon_sym_STAR] = ACTIONS(4037),
    [anon_sym_AMP] = ACTIONS(4037),
    [anon_sym_SEMI] = ACTIONS(4040),
    [anon_sym_COLON_COLON] = ACTIONS(4043),
    [anon_sym_LBRACE] = ACTIONS(4046),
    [anon_sym_RBRACE] = ACTIONS(4049),
    [anon_sym_LBRACK] = ACTIONS(4051),
    [sym_primitive_type] = ACTIONS(4054),
    [anon_sym_not] = ACTIONS(4034),
    [anon_sym_compl] = ACTIONS(4034),
    [anon_sym_DASH_DASH] = ACTIONS(4057),
    [anon_sym_PLUS_PLUS] = ACTIONS(4057),
    [anon_sym_sizeof] = ACTIONS(4060),
    [anon_sym___alignof__] = ACTIONS(4063),
    [anon_sym___alignof] = ACTIONS(4063),
    [anon_sym__alignof] = ACTIONS(4063),
    [anon_sym_alignof] = ACTIONS(4063),
    [anon_sym__Alignof] = ACTIONS(4063),
    [anon_sym_offsetof] = ACTIONS(4066),
    [anon_sym__Generic] = ACTIONS(4069),
    [anon_sym_asm] = ACTIONS(4072),
    [anon_sym___asm__] = ACTIONS(4072),
    [sym_number_literal] = ACTIONS(4075),
    [anon_sym_L_SQUOTE] = ACTIONS(4078),
    [anon_sym_u_SQUOTE] = ACTIONS(4078),
    [anon_sym_U_SQUOTE] = ACTIONS(4078),
    [anon_sym_u8_SQUOTE] = ACTIONS(4078),
    [anon_sym_SQUOTE] = ACTIONS(4078),
    [anon_sym_L_DQUOTE] = ACTIONS(4081),
    [anon_sym_u_DQUOTE] = ACTIONS(4081),
    [anon_sym_U_DQUOTE] = ACTIONS(4081),
    [anon_sym_u8_DQUOTE] = ACTIONS(4081),
    [anon_sym_DQUOTE] = ACTIONS(4081),
    [sym_true] = ACTIONS(4084),
    [sym_false] = ACTIONS(4084),
    [anon_sym_NULL] = ACTIONS(4087),
    [anon_sym_nullptr] = ACTIONS(4087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4090),
    [anon_sym_typename] = ACTIONS(4093),
    [anon_sym_template] = ACTIONS(4096),
    [anon_sym_delete] = ACTIONS(4099),
    [anon_sym_R_DQUOTE] = ACTIONS(4102),
    [anon_sym_LR_DQUOTE] = ACTIONS(4102),
    [anon_sym_uR_DQUOTE] = ACTIONS(4102),
    [anon_sym_UR_DQUOTE] = ACTIONS(4102),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4102),
    [anon_sym_co_await] = ACTIONS(4105),
    [anon_sym_new] = ACTIONS(4108),
    [anon_sym_requires] = ACTIONS(4111),
    [sym_this] = ACTIONS(4084),
  },
  [898] = {
    [sym_expression_statement] = STATE(3051),
    [sym_expression] = STATE(4818),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8770),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_type_requirement] = STATE(897),
    [sym_compound_requirement] = STATE(897),
    [sym__requirement] = STATE(897),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_requirement_seq_repeat1] = STATE(897),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4114),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4116),
    [anon_sym_RBRACE] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_typename] = ACTIONS(4120),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [899] = {
    [sym_expression_statement] = STATE(3051),
    [sym_expression] = STATE(4818),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8770),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_type_requirement] = STATE(897),
    [sym_compound_requirement] = STATE(897),
    [sym__requirement] = STATE(897),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_requirement_seq_repeat1] = STATE(897),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4114),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4116),
    [anon_sym_RBRACE] = ACTIONS(4122),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_typename] = ACTIONS(4120),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [900] = {
    [sym_expression] = STATE(4653),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7753),
    [sym_initializer_pair] = STATE(7753),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_COMMA] = ACTIONS(4126),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(4128),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [901] = {
    [sym_expression_statement] = STATE(3051),
    [sym_expression] = STATE(4818),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8770),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_type_requirement] = STATE(925),
    [sym_compound_requirement] = STATE(925),
    [sym__requirement] = STATE(925),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_requirement_seq_repeat1] = STATE(925),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4114),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4116),
    [anon_sym_RBRACE] = ACTIONS(4132),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_typename] = ACTIONS(4120),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [902] = {
    [sym_expression_statement] = STATE(3051),
    [sym_expression] = STATE(4818),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8770),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_type_requirement] = STATE(897),
    [sym_compound_requirement] = STATE(897),
    [sym__requirement] = STATE(897),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_requirement_seq_repeat1] = STATE(897),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4114),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4116),
    [anon_sym_RBRACE] = ACTIONS(4134),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_typename] = ACTIONS(4120),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [903] = {
    [sym_expression_statement] = STATE(3051),
    [sym_expression] = STATE(4818),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8770),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_type_requirement] = STATE(929),
    [sym_compound_requirement] = STATE(929),
    [sym__requirement] = STATE(929),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_requirement_seq_repeat1] = STATE(929),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4114),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4116),
    [anon_sym_RBRACE] = ACTIONS(4136),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_typename] = ACTIONS(4120),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [904] = {
    [sym_expression_statement] = STATE(3051),
    [sym_expression] = STATE(4818),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8770),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_type_requirement] = STATE(897),
    [sym_compound_requirement] = STATE(897),
    [sym__requirement] = STATE(897),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_requirement_seq_repeat1] = STATE(897),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4114),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4116),
    [anon_sym_RBRACE] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_typename] = ACTIONS(4120),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [905] = {
    [sym_expression_statement] = STATE(3051),
    [sym_expression] = STATE(4818),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8770),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_type_requirement] = STATE(924),
    [sym_compound_requirement] = STATE(924),
    [sym__requirement] = STATE(924),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_requirement_seq_repeat1] = STATE(924),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4114),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4116),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_typename] = ACTIONS(4120),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [906] = {
    [sym_identifier] = ACTIONS(4142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4144),
    [anon_sym_COMMA] = ACTIONS(4144),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_TILDE] = ACTIONS(4149),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_STAR] = ACTIONS(4153),
    [anon_sym_SLASH] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4151),
    [anon_sym_CARET] = ACTIONS(4151),
    [anon_sym_AMP] = ACTIONS(4153),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT] = ACTIONS(4151),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4151),
    [anon_sym_LT] = ACTIONS(4151),
    [anon_sym_LT_LT] = ACTIONS(4151),
    [anon_sym_GT_GT] = ACTIONS(4151),
    [anon_sym_SEMI] = ACTIONS(4146),
    [anon_sym___extension__] = ACTIONS(4142),
    [anon_sym___device__] = ACTIONS(4142),
    [anon_sym___host__] = ACTIONS(4142),
    [anon_sym___global__] = ACTIONS(4142),
    [anon_sym___forceinline__] = ACTIONS(4142),
    [anon_sym___noinline__] = ACTIONS(4142),
    [anon_sym_extern] = ACTIONS(4142),
    [anon_sym___attribute__] = ACTIONS(4142),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4146),
    [anon_sym___declspec] = ACTIONS(4142),
    [anon_sym___based] = ACTIONS(4142),
    [anon_sym___cdecl] = ACTIONS(4142),
    [anon_sym___clrcall] = ACTIONS(4142),
    [anon_sym___stdcall] = ACTIONS(4142),
    [anon_sym___fastcall] = ACTIONS(4142),
    [anon_sym___thiscall] = ACTIONS(4142),
    [anon_sym___vectorcall] = ACTIONS(4142),
    [anon_sym_LBRACE] = ACTIONS(4149),
    [anon_sym_RBRACE] = ACTIONS(4144),
    [anon_sym_LBRACK] = ACTIONS(4153),
    [anon_sym_static] = ACTIONS(4142),
    [anon_sym_EQ] = ACTIONS(4151),
    [anon_sym_register] = ACTIONS(4142),
    [anon_sym_inline] = ACTIONS(4142),
    [anon_sym___inline] = ACTIONS(4142),
    [anon_sym___inline__] = ACTIONS(4142),
    [anon_sym___forceinline] = ACTIONS(4142),
    [anon_sym_thread_local] = ACTIONS(4142),
    [anon_sym___thread] = ACTIONS(4142),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_constexpr] = ACTIONS(4142),
    [anon_sym_volatile] = ACTIONS(4142),
    [anon_sym_restrict] = ACTIONS(4142),
    [anon_sym___restrict__] = ACTIONS(4142),
    [anon_sym__Atomic] = ACTIONS(4142),
    [anon_sym__Noreturn] = ACTIONS(4142),
    [anon_sym_noreturn] = ACTIONS(4142),
    [anon_sym_mutable] = ACTIONS(4142),
    [anon_sym_constinit] = ACTIONS(4142),
    [anon_sym_consteval] = ACTIONS(4142),
    [anon_sym___shared__] = ACTIONS(4142),
    [anon_sym___local__] = ACTIONS(4142),
    [anon_sym___constant__] = ACTIONS(4142),
    [anon_sym___managed__] = ACTIONS(4142),
    [anon_sym___grid_constant__] = ACTIONS(4142),
    [anon_sym_alignas] = ACTIONS(4142),
    [anon_sym__Alignas] = ACTIONS(4142),
    [anon_sym_QMARK] = ACTIONS(4144),
    [anon_sym_STAR_EQ] = ACTIONS(4144),
    [anon_sym_SLASH_EQ] = ACTIONS(4144),
    [anon_sym_PERCENT_EQ] = ACTIONS(4144),
    [anon_sym_PLUS_EQ] = ACTIONS(4144),
    [anon_sym_DASH_EQ] = ACTIONS(4144),
    [anon_sym_LT_LT_EQ] = ACTIONS(4144),
    [anon_sym_GT_GT_EQ] = ACTIONS(4144),
    [anon_sym_AMP_EQ] = ACTIONS(4144),
    [anon_sym_CARET_EQ] = ACTIONS(4144),
    [anon_sym_PIPE_EQ] = ACTIONS(4144),
    [anon_sym_and_eq] = ACTIONS(4151),
    [anon_sym_or_eq] = ACTIONS(4151),
    [anon_sym_xor_eq] = ACTIONS(4151),
    [anon_sym_LT_EQ_GT] = ACTIONS(4144),
    [anon_sym_or] = ACTIONS(4151),
    [anon_sym_and] = ACTIONS(4151),
    [anon_sym_bitor] = ACTIONS(4151),
    [anon_sym_xor] = ACTIONS(4151),
    [anon_sym_bitand] = ACTIONS(4151),
    [anon_sym_not_eq] = ACTIONS(4151),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_DOT_STAR] = ACTIONS(4144),
    [anon_sym_DASH_GT] = ACTIONS(4144),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4142),
    [anon_sym_decltype] = ACTIONS(4142),
    [sym_virtual] = ACTIONS(4142),
    [anon_sym_template] = ACTIONS(4142),
    [anon_sym_operator] = ACTIONS(4142),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4144),
    [anon_sym___launch_bounds__] = ACTIONS(4142),
  },
  [907] = {
    [sym_expression] = STATE(4713),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7556),
    [sym_initializer_pair] = STATE(7556),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_COMMA] = ACTIONS(4156),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [908] = {
    [sym_expression_statement] = STATE(3051),
    [sym_expression] = STATE(4818),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8770),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_type_requirement] = STATE(897),
    [sym_compound_requirement] = STATE(897),
    [sym__requirement] = STATE(897),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_requirement_seq_repeat1] = STATE(897),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4114),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4116),
    [anon_sym_RBRACE] = ACTIONS(4160),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_typename] = ACTIONS(4120),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [909] = {
    [sym_expression] = STATE(4635),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7476),
    [sym_initializer_pair] = STATE(7476),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_COMMA] = ACTIONS(4162),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [910] = {
    [sym_expression_statement] = STATE(3051),
    [sym_expression] = STATE(4818),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8770),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_type_requirement] = STATE(926),
    [sym_compound_requirement] = STATE(926),
    [sym__requirement] = STATE(926),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_requirement_seq_repeat1] = STATE(926),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4114),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4116),
    [anon_sym_RBRACE] = ACTIONS(4166),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_typename] = ACTIONS(4120),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [911] = {
    [sym_expression] = STATE(4723),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7479),
    [sym_initializer_pair] = STATE(7479),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_COMMA] = ACTIONS(167),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(4168),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [912] = {
    [sym_expression_statement] = STATE(3051),
    [sym_expression] = STATE(4818),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8770),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_type_requirement] = STATE(899),
    [sym_compound_requirement] = STATE(899),
    [sym__requirement] = STATE(899),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_requirement_seq_repeat1] = STATE(899),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4114),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4116),
    [anon_sym_RBRACE] = ACTIONS(4170),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_typename] = ACTIONS(4120),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [913] = {
    [sym_expression] = STATE(4677),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7487),
    [sym_initializer_pair] = STATE(7487),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_COMMA] = ACTIONS(4172),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(4174),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [914] = {
    [sym_expression_statement] = STATE(3051),
    [sym_expression] = STATE(4818),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8770),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_type_requirement] = STATE(902),
    [sym_compound_requirement] = STATE(902),
    [sym__requirement] = STATE(902),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_requirement_seq_repeat1] = STATE(902),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4114),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4116),
    [anon_sym_RBRACE] = ACTIONS(4176),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_typename] = ACTIONS(4120),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [915] = {
    [sym_expression] = STATE(4703),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(7509),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7845),
    [sym_initializer_pair] = STATE(7845),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(4178),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [916] = {
    [sym_expression_statement] = STATE(3051),
    [sym_expression] = STATE(4818),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8770),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_type_requirement] = STATE(897),
    [sym_compound_requirement] = STATE(897),
    [sym__requirement] = STATE(897),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_requirement_seq_repeat1] = STATE(897),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4114),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4116),
    [anon_sym_RBRACE] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_typename] = ACTIONS(4120),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [917] = {
    [sym_expression_statement] = STATE(3051),
    [sym_expression] = STATE(4818),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8770),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_type_requirement] = STATE(908),
    [sym_compound_requirement] = STATE(908),
    [sym__requirement] = STATE(908),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_requirement_seq_repeat1] = STATE(908),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4114),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4116),
    [anon_sym_RBRACE] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_typename] = ACTIONS(4120),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [918] = {
    [sym_expression_statement] = STATE(3051),
    [sym_expression] = STATE(4818),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8770),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_type_requirement] = STATE(904),
    [sym_compound_requirement] = STATE(904),
    [sym__requirement] = STATE(904),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_requirement_seq_repeat1] = STATE(904),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4114),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4116),
    [anon_sym_RBRACE] = ACTIONS(4184),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_typename] = ACTIONS(4120),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [919] = {
    [sym_expression_statement] = STATE(3051),
    [sym_expression] = STATE(4818),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8770),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_type_requirement] = STATE(897),
    [sym_compound_requirement] = STATE(897),
    [sym__requirement] = STATE(897),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_requirement_seq_repeat1] = STATE(897),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4114),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4116),
    [anon_sym_RBRACE] = ACTIONS(4186),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_typename] = ACTIONS(4120),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [920] = {
    [sym_expression] = STATE(4634),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7686),
    [sym_initializer_pair] = STATE(7686),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_COMMA] = ACTIONS(4188),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(4190),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [921] = {
    [sym_expression_statement] = STATE(3051),
    [sym_expression] = STATE(4818),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8770),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_type_requirement] = STATE(919),
    [sym_compound_requirement] = STATE(919),
    [sym__requirement] = STATE(919),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_requirement_seq_repeat1] = STATE(919),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4114),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4116),
    [anon_sym_RBRACE] = ACTIONS(4192),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_typename] = ACTIONS(4120),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [922] = {
    [sym_expression] = STATE(4670),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7520),
    [sym_initializer_pair] = STATE(7520),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_COMMA] = ACTIONS(4194),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(4196),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [923] = {
    [sym_expression_statement] = STATE(3051),
    [sym_expression] = STATE(4818),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8770),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_type_requirement] = STATE(916),
    [sym_compound_requirement] = STATE(916),
    [sym__requirement] = STATE(916),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_requirement_seq_repeat1] = STATE(916),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4114),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4116),
    [anon_sym_RBRACE] = ACTIONS(4198),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_typename] = ACTIONS(4120),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [924] = {
    [sym_expression_statement] = STATE(3051),
    [sym_expression] = STATE(4818),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8770),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_type_requirement] = STATE(897),
    [sym_compound_requirement] = STATE(897),
    [sym__requirement] = STATE(897),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_requirement_seq_repeat1] = STATE(897),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4114),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4116),
    [anon_sym_RBRACE] = ACTIONS(4200),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_typename] = ACTIONS(4120),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [925] = {
    [sym_expression_statement] = STATE(3051),
    [sym_expression] = STATE(4818),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8770),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_type_requirement] = STATE(897),
    [sym_compound_requirement] = STATE(897),
    [sym__requirement] = STATE(897),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_requirement_seq_repeat1] = STATE(897),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4114),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4116),
    [anon_sym_RBRACE] = ACTIONS(4202),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_typename] = ACTIONS(4120),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [926] = {
    [sym_expression_statement] = STATE(3051),
    [sym_expression] = STATE(4818),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8770),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_type_requirement] = STATE(897),
    [sym_compound_requirement] = STATE(897),
    [sym__requirement] = STATE(897),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_requirement_seq_repeat1] = STATE(897),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4114),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4116),
    [anon_sym_RBRACE] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_typename] = ACTIONS(4120),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [927] = {
    [sym_expression_statement] = STATE(3051),
    [sym_expression] = STATE(4818),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8770),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_type_requirement] = STATE(898),
    [sym_compound_requirement] = STATE(898),
    [sym__requirement] = STATE(898),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_requirement_seq_repeat1] = STATE(898),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4114),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4116),
    [anon_sym_RBRACE] = ACTIONS(4206),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_typename] = ACTIONS(4120),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [928] = {
    [sym_expression] = STATE(4727),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7783),
    [sym_initializer_pair] = STATE(7783),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_COMMA] = ACTIONS(4208),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(4210),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [929] = {
    [sym_expression_statement] = STATE(3051),
    [sym_expression] = STATE(4818),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8770),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_type_requirement] = STATE(897),
    [sym_compound_requirement] = STATE(897),
    [sym__requirement] = STATE(897),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_requirement_seq_repeat1] = STATE(897),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4114),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4116),
    [anon_sym_RBRACE] = ACTIONS(4212),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_typename] = ACTIONS(4120),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [930] = {
    [sym_expression] = STATE(4928),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7845),
    [sym_initializer_pair] = STATE(7845),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(4214),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [931] = {
    [sym_expression] = STATE(4928),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7845),
    [sym_initializer_pair] = STATE(7845),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(4216),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [932] = {
    [sym_expression] = STATE(4928),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7845),
    [sym_initializer_pair] = STATE(7845),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(4218),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [933] = {
    [sym_expression] = STATE(4928),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7845),
    [sym_initializer_pair] = STATE(7845),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(4220),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [934] = {
    [sym_expression] = STATE(4928),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7845),
    [sym_initializer_pair] = STATE(7845),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(4222),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [935] = {
    [sym_expression] = STATE(4928),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7845),
    [sym_initializer_pair] = STATE(7845),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(4224),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [936] = {
    [sym_expression] = STATE(4928),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7845),
    [sym_initializer_pair] = STATE(7845),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(4226),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [937] = {
    [sym_expression] = STATE(4928),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7845),
    [sym_initializer_pair] = STATE(7845),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [938] = {
    [sym_expression] = STATE(4928),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7845),
    [sym_initializer_pair] = STATE(7845),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(4230),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [939] = {
    [sym_expression] = STATE(4928),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7845),
    [sym_initializer_pair] = STATE(7845),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(4178),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [940] = {
    [sym_expression] = STATE(4928),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7845),
    [sym_initializer_pair] = STATE(7845),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [941] = {
    [sym_expression] = STATE(4928),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7845),
    [sym_initializer_pair] = STATE(7845),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(4234),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [942] = {
    [sym_expression] = STATE(4928),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7845),
    [sym_initializer_pair] = STATE(7845),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(4236),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [943] = {
    [sym_expression] = STATE(4928),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7845),
    [sym_initializer_pair] = STATE(7845),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(4238),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [944] = {
    [sym_expression] = STATE(4928),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7845),
    [sym_initializer_pair] = STATE(7845),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(4240),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [945] = {
    [sym_expression] = STATE(4928),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7845),
    [sym_initializer_pair] = STATE(7845),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(4242),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [946] = {
    [sym_expression] = STATE(4928),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7845),
    [sym_initializer_pair] = STATE(7845),
    [sym_subscript_designator] = STATE(6941),
    [sym_subscript_range_designator] = STATE(6941),
    [sym_field_designator] = STATE(6941),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [aux_sym_initializer_pair_repeat1] = STATE(6941),
    [sym_identifier] = ACTIONS(4124),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [947] = {
    [sym__declaration_modifiers] = STATE(1847),
    [sym__declaration_specifiers] = STATE(4480),
    [sym_attribute_specifier] = STATE(1847),
    [sym_attribute_declaration] = STATE(1847),
    [sym_ms_declspec_modifier] = STATE(1847),
    [sym_ms_call_modifier] = STATE(6562),
    [sym__abstract_declarator] = STATE(7024),
    [sym_abstract_parenthesized_declarator] = STATE(6430),
    [sym_abstract_pointer_declarator] = STATE(6430),
    [sym_abstract_function_declarator] = STATE(6430),
    [sym_abstract_array_declarator] = STATE(6430),
    [sym_storage_class_specifier] = STATE(1847),
    [sym_type_qualifier] = STATE(1847),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_parameter_list] = STATE(2989),
    [sym_parameter_declaration] = STATE(7423),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_optional_parameter_declaration] = STATE(7423),
    [sym_variadic_parameter_declaration] = STATE(7423),
    [sym_abstract_reference_declarator] = STATE(6430),
    [sym__function_declarator_seq] = STATE(6416),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6858),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_launch_bounds] = STATE(1847),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1847),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1815),
    [anon_sym_RPAREN] = ACTIONS(3955),
    [anon_sym_LPAREN2] = ACTIONS(4246),
    [anon_sym_STAR] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4250),
    [anon_sym_AMP] = ACTIONS(4252),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1765),
    [anon_sym___host__] = ACTIONS(1765),
    [anon_sym___global__] = ACTIONS(1765),
    [anon_sym___forceinline__] = ACTIONS(1765),
    [anon_sym___noinline__] = ACTIONS(1765),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(1839),
    [anon_sym___clrcall] = ACTIONS(1839),
    [anon_sym___stdcall] = ACTIONS(1839),
    [anon_sym___fastcall] = ACTIONS(1839),
    [anon_sym___thiscall] = ACTIONS(1839),
    [anon_sym___vectorcall] = ACTIONS(1839),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(4256),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(1771),
    [anon_sym_class] = ACTIONS(1773),
    [anon_sym_struct] = ACTIONS(1775),
    [anon_sym_union] = ACTIONS(1777),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1765),
    [anon_sym_typename] = ACTIONS(1801),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [948] = {
    [sym__declaration_modifiers] = STATE(1847),
    [sym__declaration_specifiers] = STATE(4480),
    [sym_attribute_specifier] = STATE(1847),
    [sym_attribute_declaration] = STATE(1847),
    [sym_ms_declspec_modifier] = STATE(1847),
    [sym_ms_call_modifier] = STATE(6596),
    [sym__abstract_declarator] = STATE(7027),
    [sym_abstract_parenthesized_declarator] = STATE(6430),
    [sym_abstract_pointer_declarator] = STATE(6430),
    [sym_abstract_function_declarator] = STATE(6430),
    [sym_abstract_array_declarator] = STATE(6430),
    [sym_storage_class_specifier] = STATE(1847),
    [sym_type_qualifier] = STATE(1847),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_parameter_list] = STATE(2989),
    [sym_parameter_declaration] = STATE(7423),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_optional_parameter_declaration] = STATE(7423),
    [sym_variadic_parameter_declaration] = STATE(7423),
    [sym_abstract_reference_declarator] = STATE(6430),
    [sym__function_declarator_seq] = STATE(6416),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6858),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_launch_bounds] = STATE(1847),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1847),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1815),
    [anon_sym_RPAREN] = ACTIONS(3955),
    [anon_sym_LPAREN2] = ACTIONS(4246),
    [anon_sym_STAR] = ACTIONS(4248),
    [anon_sym_AMP_AMP] = ACTIONS(4250),
    [anon_sym_AMP] = ACTIONS(4252),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1765),
    [anon_sym___host__] = ACTIONS(1765),
    [anon_sym___global__] = ACTIONS(1765),
    [anon_sym___forceinline__] = ACTIONS(1765),
    [anon_sym___noinline__] = ACTIONS(1765),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(1839),
    [anon_sym___clrcall] = ACTIONS(1839),
    [anon_sym___stdcall] = ACTIONS(1839),
    [anon_sym___fastcall] = ACTIONS(1839),
    [anon_sym___thiscall] = ACTIONS(1839),
    [anon_sym___vectorcall] = ACTIONS(1839),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(4256),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(1771),
    [anon_sym_class] = ACTIONS(1773),
    [anon_sym_struct] = ACTIONS(1775),
    [anon_sym_union] = ACTIONS(1777),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1765),
    [anon_sym_typename] = ACTIONS(1801),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [949] = {
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5590),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6886),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6598),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_template_parameter_list] = STATE(782),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(3953),
    [sym_template_function] = STATE(6598),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4258),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym_LT] = ACTIONS(4260),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4262),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1883),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [950] = {
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5610),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6873),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6598),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_template_parameter_list] = STATE(784),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(3953),
    [sym_template_function] = STATE(6598),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4258),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym_LT] = ACTIONS(4260),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4262),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1883),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [951] = {
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5618),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6893),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6598),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_template_parameter_list] = STATE(779),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(3953),
    [sym_template_function] = STATE(6598),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4258),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym_LT] = ACTIONS(4260),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4262),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1883),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [952] = {
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5612),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6910),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6598),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_template_parameter_list] = STATE(785),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(3953),
    [sym_template_function] = STATE(6598),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4258),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym_LT] = ACTIONS(4260),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4262),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1883),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [953] = {
    [sym_compound_statement] = STATE(7414),
    [sym_expression] = STATE(4651),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7414),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_RPAREN] = ACTIONS(4264),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(4266),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [954] = {
    [sym_template_argument_list] = STATE(991),
    [sym_identifier] = ACTIONS(4000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4004),
    [anon_sym_COMMA] = ACTIONS(4004),
    [anon_sym_RPAREN] = ACTIONS(4004),
    [anon_sym_LPAREN2] = ACTIONS(4004),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4009),
    [anon_sym_PLUS] = ACTIONS(4009),
    [anon_sym_STAR] = ACTIONS(4011),
    [anon_sym_SLASH] = ACTIONS(4009),
    [anon_sym_PERCENT] = ACTIONS(4009),
    [anon_sym_PIPE_PIPE] = ACTIONS(4002),
    [anon_sym_AMP_AMP] = ACTIONS(4004),
    [anon_sym_PIPE] = ACTIONS(4009),
    [anon_sym_CARET] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4011),
    [anon_sym_EQ_EQ] = ACTIONS(4002),
    [anon_sym_BANG_EQ] = ACTIONS(4002),
    [anon_sym_GT] = ACTIONS(4009),
    [anon_sym_GT_EQ] = ACTIONS(4002),
    [anon_sym_LT_EQ] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(4268),
    [anon_sym_LT_LT] = ACTIONS(4009),
    [anon_sym_GT_GT] = ACTIONS(4009),
    [anon_sym___extension__] = ACTIONS(4000),
    [anon_sym___device__] = ACTIONS(4000),
    [anon_sym___host__] = ACTIONS(4000),
    [anon_sym___global__] = ACTIONS(4000),
    [anon_sym___forceinline__] = ACTIONS(4000),
    [anon_sym___noinline__] = ACTIONS(4000),
    [anon_sym_extern] = ACTIONS(4000),
    [anon_sym___attribute__] = ACTIONS(4000),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4007),
    [anon_sym___declspec] = ACTIONS(4000),
    [anon_sym___based] = ACTIONS(4000),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4011),
    [anon_sym_static] = ACTIONS(4000),
    [anon_sym_EQ] = ACTIONS(4011),
    [anon_sym_register] = ACTIONS(4000),
    [anon_sym_inline] = ACTIONS(4000),
    [anon_sym___inline] = ACTIONS(4000),
    [anon_sym___inline__] = ACTIONS(4000),
    [anon_sym___forceinline] = ACTIONS(4000),
    [anon_sym_thread_local] = ACTIONS(4000),
    [anon_sym___thread] = ACTIONS(4000),
    [anon_sym_const] = ACTIONS(4000),
    [anon_sym_constexpr] = ACTIONS(4000),
    [anon_sym_volatile] = ACTIONS(4000),
    [anon_sym_restrict] = ACTIONS(4000),
    [anon_sym___restrict__] = ACTIONS(4000),
    [anon_sym__Atomic] = ACTIONS(4000),
    [anon_sym__Noreturn] = ACTIONS(4000),
    [anon_sym_noreturn] = ACTIONS(4000),
    [anon_sym_mutable] = ACTIONS(4000),
    [anon_sym_constinit] = ACTIONS(4000),
    [anon_sym_consteval] = ACTIONS(4000),
    [anon_sym___shared__] = ACTIONS(4000),
    [anon_sym___local__] = ACTIONS(4000),
    [anon_sym___constant__] = ACTIONS(4000),
    [anon_sym___managed__] = ACTIONS(4000),
    [anon_sym___grid_constant__] = ACTIONS(4000),
    [anon_sym_alignas] = ACTIONS(4000),
    [anon_sym__Alignas] = ACTIONS(4000),
    [anon_sym_QMARK] = ACTIONS(4002),
    [anon_sym_STAR_EQ] = ACTIONS(4002),
    [anon_sym_SLASH_EQ] = ACTIONS(4002),
    [anon_sym_PERCENT_EQ] = ACTIONS(4002),
    [anon_sym_PLUS_EQ] = ACTIONS(4002),
    [anon_sym_DASH_EQ] = ACTIONS(4002),
    [anon_sym_LT_LT_EQ] = ACTIONS(4002),
    [anon_sym_GT_GT_EQ] = ACTIONS(4002),
    [anon_sym_AMP_EQ] = ACTIONS(4002),
    [anon_sym_CARET_EQ] = ACTIONS(4002),
    [anon_sym_PIPE_EQ] = ACTIONS(4002),
    [anon_sym_and_eq] = ACTIONS(4009),
    [anon_sym_or_eq] = ACTIONS(4009),
    [anon_sym_xor_eq] = ACTIONS(4009),
    [anon_sym_LT_EQ_GT] = ACTIONS(4002),
    [anon_sym_or] = ACTIONS(4009),
    [anon_sym_and] = ACTIONS(4009),
    [anon_sym_bitor] = ACTIONS(4009),
    [anon_sym_xor] = ACTIONS(4009),
    [anon_sym_bitand] = ACTIONS(4009),
    [anon_sym_not_eq] = ACTIONS(4009),
    [anon_sym_DASH_DASH] = ACTIONS(4002),
    [anon_sym_PLUS_PLUS] = ACTIONS(4002),
    [anon_sym_DOT] = ACTIONS(4009),
    [anon_sym_DOT_STAR] = ACTIONS(4002),
    [anon_sym_DASH_GT] = ACTIONS(4009),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4000),
    [anon_sym_decltype] = ACTIONS(4000),
    [sym_virtual] = ACTIONS(4000),
    [anon_sym_template] = ACTIONS(4000),
    [anon_sym_operator] = ACTIONS(4000),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4002),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4002),
    [anon_sym___launch_bounds__] = ACTIONS(4000),
  },
  [955] = {
    [sym_compound_statement] = STATE(7550),
    [sym_expression] = STATE(4716),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7550),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_RPAREN] = ACTIONS(4271),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(4273),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [956] = {
    [sym_compound_statement] = STATE(7761),
    [sym_expression] = STATE(4667),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7761),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_RPAREN] = ACTIONS(4275),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(4277),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [957] = {
    [sym_compound_statement] = STATE(7477),
    [sym_expression] = STATE(4638),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7477),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_RPAREN] = ACTIONS(4279),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(4281),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [958] = {
    [sym_compound_statement] = STATE(7530),
    [sym_expression] = STATE(4658),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7530),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_RPAREN] = ACTIONS(4283),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(4285),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [959] = {
    [sym_compound_statement] = STATE(7796),
    [sym_expression] = STATE(4724),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7796),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_RPAREN] = ACTIONS(4287),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(4289),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [960] = {
    [sym_template_argument_list] = STATE(990),
    [sym_identifier] = ACTIONS(4000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4002),
    [anon_sym_COMMA] = ACTIONS(4002),
    [anon_sym_RPAREN] = ACTIONS(4002),
    [anon_sym_LPAREN2] = ACTIONS(4004),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4009),
    [anon_sym_PLUS] = ACTIONS(4009),
    [anon_sym_STAR] = ACTIONS(4011),
    [anon_sym_SLASH] = ACTIONS(4009),
    [anon_sym_PERCENT] = ACTIONS(4009),
    [anon_sym_PIPE_PIPE] = ACTIONS(4002),
    [anon_sym_AMP_AMP] = ACTIONS(4004),
    [anon_sym_PIPE] = ACTIONS(4009),
    [anon_sym_CARET] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4011),
    [anon_sym_EQ_EQ] = ACTIONS(4002),
    [anon_sym_BANG_EQ] = ACTIONS(4002),
    [anon_sym_GT] = ACTIONS(4009),
    [anon_sym_GT_EQ] = ACTIONS(4002),
    [anon_sym_LT_EQ] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(4014),
    [anon_sym_LT_LT] = ACTIONS(4009),
    [anon_sym_GT_GT] = ACTIONS(4009),
    [anon_sym_SEMI] = ACTIONS(4002),
    [anon_sym___extension__] = ACTIONS(4000),
    [anon_sym___device__] = ACTIONS(4000),
    [anon_sym___host__] = ACTIONS(4000),
    [anon_sym___global__] = ACTIONS(4000),
    [anon_sym___forceinline__] = ACTIONS(4000),
    [anon_sym___noinline__] = ACTIONS(4000),
    [anon_sym_extern] = ACTIONS(4000),
    [anon_sym___attribute__] = ACTIONS(4000),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4007),
    [anon_sym___declspec] = ACTIONS(4000),
    [anon_sym___based] = ACTIONS(4000),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4011),
    [anon_sym_static] = ACTIONS(4000),
    [anon_sym_EQ] = ACTIONS(4009),
    [anon_sym_register] = ACTIONS(4000),
    [anon_sym_inline] = ACTIONS(4000),
    [anon_sym___inline] = ACTIONS(4000),
    [anon_sym___inline__] = ACTIONS(4000),
    [anon_sym___forceinline] = ACTIONS(4000),
    [anon_sym_thread_local] = ACTIONS(4000),
    [anon_sym___thread] = ACTIONS(4000),
    [anon_sym_const] = ACTIONS(4000),
    [anon_sym_constexpr] = ACTIONS(4000),
    [anon_sym_volatile] = ACTIONS(4000),
    [anon_sym_restrict] = ACTIONS(4000),
    [anon_sym___restrict__] = ACTIONS(4000),
    [anon_sym__Atomic] = ACTIONS(4000),
    [anon_sym__Noreturn] = ACTIONS(4000),
    [anon_sym_noreturn] = ACTIONS(4000),
    [anon_sym_mutable] = ACTIONS(4000),
    [anon_sym_constinit] = ACTIONS(4000),
    [anon_sym_consteval] = ACTIONS(4000),
    [anon_sym___shared__] = ACTIONS(4000),
    [anon_sym___local__] = ACTIONS(4000),
    [anon_sym___constant__] = ACTIONS(4000),
    [anon_sym___managed__] = ACTIONS(4000),
    [anon_sym___grid_constant__] = ACTIONS(4000),
    [anon_sym_alignas] = ACTIONS(4000),
    [anon_sym__Alignas] = ACTIONS(4000),
    [anon_sym_QMARK] = ACTIONS(4002),
    [anon_sym_STAR_EQ] = ACTIONS(4002),
    [anon_sym_SLASH_EQ] = ACTIONS(4002),
    [anon_sym_PERCENT_EQ] = ACTIONS(4002),
    [anon_sym_PLUS_EQ] = ACTIONS(4002),
    [anon_sym_DASH_EQ] = ACTIONS(4002),
    [anon_sym_LT_LT_EQ] = ACTIONS(4002),
    [anon_sym_GT_GT_EQ] = ACTIONS(4002),
    [anon_sym_AMP_EQ] = ACTIONS(4002),
    [anon_sym_CARET_EQ] = ACTIONS(4002),
    [anon_sym_PIPE_EQ] = ACTIONS(4002),
    [anon_sym_and_eq] = ACTIONS(4009),
    [anon_sym_or_eq] = ACTIONS(4009),
    [anon_sym_xor_eq] = ACTIONS(4009),
    [anon_sym_LT_EQ_GT] = ACTIONS(4002),
    [anon_sym_or] = ACTIONS(4009),
    [anon_sym_and] = ACTIONS(4009),
    [anon_sym_bitor] = ACTIONS(4009),
    [anon_sym_xor] = ACTIONS(4009),
    [anon_sym_bitand] = ACTIONS(4009),
    [anon_sym_not_eq] = ACTIONS(4009),
    [anon_sym_DASH_DASH] = ACTIONS(4002),
    [anon_sym_PLUS_PLUS] = ACTIONS(4002),
    [anon_sym_DOT] = ACTIONS(4009),
    [anon_sym_DOT_STAR] = ACTIONS(4002),
    [anon_sym_DASH_GT] = ACTIONS(4002),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4000),
    [anon_sym_decltype] = ACTIONS(4000),
    [sym_virtual] = ACTIONS(4000),
    [anon_sym_template] = ACTIONS(4000),
    [anon_sym_operator] = ACTIONS(4000),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4002),
    [anon_sym___launch_bounds__] = ACTIONS(4000),
  },
  [961] = {
    [sym_compound_statement] = STATE(7587),
    [sym_expression] = STATE(4700),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7587),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_RPAREN] = ACTIONS(4291),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(4293),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [962] = {
    [sym_identifier] = ACTIONS(2457),
    [anon_sym_LPAREN2] = ACTIONS(2459),
    [anon_sym_BANG] = ACTIONS(2459),
    [anon_sym_TILDE] = ACTIONS(2459),
    [anon_sym_DASH] = ACTIONS(2457),
    [anon_sym_PLUS] = ACTIONS(2457),
    [anon_sym_STAR] = ACTIONS(2459),
    [anon_sym_AMP] = ACTIONS(2459),
    [anon_sym___extension__] = ACTIONS(2457),
    [anon_sym___device__] = ACTIONS(2457),
    [anon_sym___host__] = ACTIONS(2457),
    [anon_sym___global__] = ACTIONS(2457),
    [anon_sym___forceinline__] = ACTIONS(2457),
    [anon_sym___noinline__] = ACTIONS(2457),
    [anon_sym_extern] = ACTIONS(2457),
    [anon_sym___attribute__] = ACTIONS(2457),
    [anon_sym_COLON_COLON] = ACTIONS(2459),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2459),
    [anon_sym___declspec] = ACTIONS(2457),
    [anon_sym_signed] = ACTIONS(2457),
    [anon_sym_unsigned] = ACTIONS(2457),
    [anon_sym_long] = ACTIONS(2457),
    [anon_sym_short] = ACTIONS(2457),
    [anon_sym_LBRACK] = ACTIONS(2457),
    [anon_sym_static] = ACTIONS(2457),
    [anon_sym_register] = ACTIONS(2457),
    [anon_sym_inline] = ACTIONS(2457),
    [anon_sym___inline] = ACTIONS(2457),
    [anon_sym___inline__] = ACTIONS(2457),
    [anon_sym___forceinline] = ACTIONS(2457),
    [anon_sym_thread_local] = ACTIONS(2457),
    [anon_sym___thread] = ACTIONS(2457),
    [anon_sym_const] = ACTIONS(2457),
    [anon_sym_constexpr] = ACTIONS(2457),
    [anon_sym_volatile] = ACTIONS(2457),
    [anon_sym_restrict] = ACTIONS(2457),
    [anon_sym___restrict__] = ACTIONS(2457),
    [anon_sym__Atomic] = ACTIONS(2457),
    [anon_sym__Noreturn] = ACTIONS(2457),
    [anon_sym_noreturn] = ACTIONS(2457),
    [anon_sym_mutable] = ACTIONS(2457),
    [anon_sym_constinit] = ACTIONS(2457),
    [anon_sym_consteval] = ACTIONS(2457),
    [anon_sym___shared__] = ACTIONS(2457),
    [anon_sym___local__] = ACTIONS(2457),
    [anon_sym___constant__] = ACTIONS(2457),
    [anon_sym___managed__] = ACTIONS(2457),
    [anon_sym___grid_constant__] = ACTIONS(2457),
    [anon_sym_alignas] = ACTIONS(2457),
    [anon_sym__Alignas] = ACTIONS(2457),
    [sym_primitive_type] = ACTIONS(2457),
    [anon_sym_enum] = ACTIONS(2457),
    [anon_sym_class] = ACTIONS(2457),
    [anon_sym_struct] = ACTIONS(2457),
    [anon_sym_union] = ACTIONS(2457),
    [anon_sym_not] = ACTIONS(2457),
    [anon_sym_compl] = ACTIONS(2457),
    [anon_sym_DASH_DASH] = ACTIONS(2459),
    [anon_sym_PLUS_PLUS] = ACTIONS(2459),
    [anon_sym_sizeof] = ACTIONS(2457),
    [anon_sym___alignof__] = ACTIONS(2457),
    [anon_sym___alignof] = ACTIONS(2457),
    [anon_sym__alignof] = ACTIONS(2457),
    [anon_sym_alignof] = ACTIONS(2457),
    [anon_sym__Alignof] = ACTIONS(2457),
    [anon_sym_offsetof] = ACTIONS(2457),
    [anon_sym__Generic] = ACTIONS(2457),
    [anon_sym_asm] = ACTIONS(2457),
    [anon_sym___asm__] = ACTIONS(2457),
    [sym_number_literal] = ACTIONS(2459),
    [anon_sym_L_SQUOTE] = ACTIONS(2459),
    [anon_sym_u_SQUOTE] = ACTIONS(2459),
    [anon_sym_U_SQUOTE] = ACTIONS(2459),
    [anon_sym_u8_SQUOTE] = ACTIONS(2459),
    [anon_sym_SQUOTE] = ACTIONS(2459),
    [anon_sym_L_DQUOTE] = ACTIONS(2459),
    [anon_sym_u_DQUOTE] = ACTIONS(2459),
    [anon_sym_U_DQUOTE] = ACTIONS(2459),
    [anon_sym_u8_DQUOTE] = ACTIONS(2459),
    [anon_sym_DQUOTE] = ACTIONS(2459),
    [sym_true] = ACTIONS(2457),
    [sym_false] = ACTIONS(2457),
    [anon_sym_NULL] = ACTIONS(2457),
    [anon_sym_nullptr] = ACTIONS(2457),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2457),
    [anon_sym_decltype] = ACTIONS(2457),
    [sym_virtual] = ACTIONS(2457),
    [anon_sym_typename] = ACTIONS(2457),
    [anon_sym_template] = ACTIONS(2457),
    [anon_sym_delete] = ACTIONS(2457),
    [anon_sym_R_DQUOTE] = ACTIONS(2459),
    [anon_sym_LR_DQUOTE] = ACTIONS(2459),
    [anon_sym_uR_DQUOTE] = ACTIONS(2459),
    [anon_sym_UR_DQUOTE] = ACTIONS(2459),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2459),
    [anon_sym_co_await] = ACTIONS(2457),
    [anon_sym_new] = ACTIONS(2457),
    [anon_sym_requires] = ACTIONS(2457),
    [sym_this] = ACTIONS(2457),
    [anon_sym___launch_bounds__] = ACTIONS(2457),
  },
  [963] = {
    [sym_identifier] = ACTIONS(2420),
    [anon_sym_LPAREN2] = ACTIONS(2425),
    [anon_sym_BANG] = ACTIONS(2425),
    [anon_sym_TILDE] = ACTIONS(2425),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_STAR] = ACTIONS(2425),
    [anon_sym_AMP] = ACTIONS(2425),
    [anon_sym___extension__] = ACTIONS(2420),
    [anon_sym___device__] = ACTIONS(2420),
    [anon_sym___host__] = ACTIONS(2420),
    [anon_sym___global__] = ACTIONS(2420),
    [anon_sym___forceinline__] = ACTIONS(2420),
    [anon_sym___noinline__] = ACTIONS(2420),
    [anon_sym_extern] = ACTIONS(2420),
    [anon_sym___attribute__] = ACTIONS(2420),
    [anon_sym_COLON_COLON] = ACTIONS(2425),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2425),
    [anon_sym___declspec] = ACTIONS(2420),
    [anon_sym_signed] = ACTIONS(2420),
    [anon_sym_unsigned] = ACTIONS(2420),
    [anon_sym_long] = ACTIONS(2420),
    [anon_sym_short] = ACTIONS(2420),
    [anon_sym_LBRACK] = ACTIONS(2420),
    [anon_sym_static] = ACTIONS(2420),
    [anon_sym_register] = ACTIONS(2420),
    [anon_sym_inline] = ACTIONS(2420),
    [anon_sym___inline] = ACTIONS(2420),
    [anon_sym___inline__] = ACTIONS(2420),
    [anon_sym___forceinline] = ACTIONS(2420),
    [anon_sym_thread_local] = ACTIONS(2420),
    [anon_sym___thread] = ACTIONS(2420),
    [anon_sym_const] = ACTIONS(2420),
    [anon_sym_constexpr] = ACTIONS(2420),
    [anon_sym_volatile] = ACTIONS(2420),
    [anon_sym_restrict] = ACTIONS(2420),
    [anon_sym___restrict__] = ACTIONS(2420),
    [anon_sym__Atomic] = ACTIONS(2420),
    [anon_sym__Noreturn] = ACTIONS(2420),
    [anon_sym_noreturn] = ACTIONS(2420),
    [anon_sym_mutable] = ACTIONS(2420),
    [anon_sym_constinit] = ACTIONS(2420),
    [anon_sym_consteval] = ACTIONS(2420),
    [anon_sym___shared__] = ACTIONS(2420),
    [anon_sym___local__] = ACTIONS(2420),
    [anon_sym___constant__] = ACTIONS(2420),
    [anon_sym___managed__] = ACTIONS(2420),
    [anon_sym___grid_constant__] = ACTIONS(2420),
    [anon_sym_alignas] = ACTIONS(2420),
    [anon_sym__Alignas] = ACTIONS(2420),
    [sym_primitive_type] = ACTIONS(2420),
    [anon_sym_enum] = ACTIONS(2420),
    [anon_sym_class] = ACTIONS(2420),
    [anon_sym_struct] = ACTIONS(2420),
    [anon_sym_union] = ACTIONS(2420),
    [anon_sym_not] = ACTIONS(2420),
    [anon_sym_compl] = ACTIONS(2420),
    [anon_sym_DASH_DASH] = ACTIONS(2425),
    [anon_sym_PLUS_PLUS] = ACTIONS(2425),
    [anon_sym_sizeof] = ACTIONS(2420),
    [anon_sym___alignof__] = ACTIONS(2420),
    [anon_sym___alignof] = ACTIONS(2420),
    [anon_sym__alignof] = ACTIONS(2420),
    [anon_sym_alignof] = ACTIONS(2420),
    [anon_sym__Alignof] = ACTIONS(2420),
    [anon_sym_offsetof] = ACTIONS(2420),
    [anon_sym__Generic] = ACTIONS(2420),
    [anon_sym_asm] = ACTIONS(2420),
    [anon_sym___asm__] = ACTIONS(2420),
    [sym_number_literal] = ACTIONS(2425),
    [anon_sym_L_SQUOTE] = ACTIONS(2425),
    [anon_sym_u_SQUOTE] = ACTIONS(2425),
    [anon_sym_U_SQUOTE] = ACTIONS(2425),
    [anon_sym_u8_SQUOTE] = ACTIONS(2425),
    [anon_sym_SQUOTE] = ACTIONS(2425),
    [anon_sym_L_DQUOTE] = ACTIONS(2425),
    [anon_sym_u_DQUOTE] = ACTIONS(2425),
    [anon_sym_U_DQUOTE] = ACTIONS(2425),
    [anon_sym_u8_DQUOTE] = ACTIONS(2425),
    [anon_sym_DQUOTE] = ACTIONS(2425),
    [sym_true] = ACTIONS(2420),
    [sym_false] = ACTIONS(2420),
    [anon_sym_NULL] = ACTIONS(2420),
    [anon_sym_nullptr] = ACTIONS(2420),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2420),
    [anon_sym_decltype] = ACTIONS(2420),
    [sym_virtual] = ACTIONS(2420),
    [anon_sym_typename] = ACTIONS(2420),
    [anon_sym_template] = ACTIONS(2420),
    [anon_sym_delete] = ACTIONS(2420),
    [anon_sym_R_DQUOTE] = ACTIONS(2425),
    [anon_sym_LR_DQUOTE] = ACTIONS(2425),
    [anon_sym_uR_DQUOTE] = ACTIONS(2425),
    [anon_sym_UR_DQUOTE] = ACTIONS(2425),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2425),
    [anon_sym_co_await] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2420),
    [anon_sym_requires] = ACTIONS(2420),
    [sym_this] = ACTIONS(2420),
    [anon_sym___launch_bounds__] = ACTIONS(2420),
  },
  [964] = {
    [sym_compound_statement] = STATE(7674),
    [sym_expression] = STATE(4631),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7674),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_RPAREN] = ACTIONS(4295),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(4297),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [965] = {
    [sym_identifier] = ACTIONS(2342),
    [anon_sym_LPAREN2] = ACTIONS(2344),
    [anon_sym_BANG] = ACTIONS(2344),
    [anon_sym_TILDE] = ACTIONS(2344),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2342),
    [anon_sym___device__] = ACTIONS(2342),
    [anon_sym___host__] = ACTIONS(2342),
    [anon_sym___global__] = ACTIONS(2342),
    [anon_sym___forceinline__] = ACTIONS(2342),
    [anon_sym___noinline__] = ACTIONS(2342),
    [anon_sym_extern] = ACTIONS(2342),
    [anon_sym___attribute__] = ACTIONS(2342),
    [anon_sym_COLON_COLON] = ACTIONS(2344),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2344),
    [anon_sym___declspec] = ACTIONS(2342),
    [anon_sym_signed] = ACTIONS(2342),
    [anon_sym_unsigned] = ACTIONS(2342),
    [anon_sym_long] = ACTIONS(2342),
    [anon_sym_short] = ACTIONS(2342),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_static] = ACTIONS(2342),
    [anon_sym_register] = ACTIONS(2342),
    [anon_sym_inline] = ACTIONS(2342),
    [anon_sym___inline] = ACTIONS(2342),
    [anon_sym___inline__] = ACTIONS(2342),
    [anon_sym___forceinline] = ACTIONS(2342),
    [anon_sym_thread_local] = ACTIONS(2342),
    [anon_sym___thread] = ACTIONS(2342),
    [anon_sym_const] = ACTIONS(2342),
    [anon_sym_constexpr] = ACTIONS(2342),
    [anon_sym_volatile] = ACTIONS(2342),
    [anon_sym_restrict] = ACTIONS(2342),
    [anon_sym___restrict__] = ACTIONS(2342),
    [anon_sym__Atomic] = ACTIONS(2342),
    [anon_sym__Noreturn] = ACTIONS(2342),
    [anon_sym_noreturn] = ACTIONS(2342),
    [anon_sym_mutable] = ACTIONS(2342),
    [anon_sym_constinit] = ACTIONS(2342),
    [anon_sym_consteval] = ACTIONS(2342),
    [anon_sym___shared__] = ACTIONS(2342),
    [anon_sym___local__] = ACTIONS(2342),
    [anon_sym___constant__] = ACTIONS(2342),
    [anon_sym___managed__] = ACTIONS(2342),
    [anon_sym___grid_constant__] = ACTIONS(2342),
    [anon_sym_alignas] = ACTIONS(2342),
    [anon_sym__Alignas] = ACTIONS(2342),
    [sym_primitive_type] = ACTIONS(2342),
    [anon_sym_enum] = ACTIONS(2342),
    [anon_sym_class] = ACTIONS(2342),
    [anon_sym_struct] = ACTIONS(2342),
    [anon_sym_union] = ACTIONS(2342),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2344),
    [anon_sym_PLUS_PLUS] = ACTIONS(2344),
    [anon_sym_sizeof] = ACTIONS(2342),
    [anon_sym___alignof__] = ACTIONS(2342),
    [anon_sym___alignof] = ACTIONS(2342),
    [anon_sym__alignof] = ACTIONS(2342),
    [anon_sym_alignof] = ACTIONS(2342),
    [anon_sym__Alignof] = ACTIONS(2342),
    [anon_sym_offsetof] = ACTIONS(2342),
    [anon_sym__Generic] = ACTIONS(2342),
    [anon_sym_asm] = ACTIONS(2342),
    [anon_sym___asm__] = ACTIONS(2342),
    [sym_number_literal] = ACTIONS(2344),
    [anon_sym_L_SQUOTE] = ACTIONS(2344),
    [anon_sym_u_SQUOTE] = ACTIONS(2344),
    [anon_sym_U_SQUOTE] = ACTIONS(2344),
    [anon_sym_u8_SQUOTE] = ACTIONS(2344),
    [anon_sym_SQUOTE] = ACTIONS(2344),
    [anon_sym_L_DQUOTE] = ACTIONS(2344),
    [anon_sym_u_DQUOTE] = ACTIONS(2344),
    [anon_sym_U_DQUOTE] = ACTIONS(2344),
    [anon_sym_u8_DQUOTE] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [sym_true] = ACTIONS(2342),
    [sym_false] = ACTIONS(2342),
    [anon_sym_NULL] = ACTIONS(2342),
    [anon_sym_nullptr] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2342),
    [anon_sym_decltype] = ACTIONS(2342),
    [sym_virtual] = ACTIONS(2342),
    [anon_sym_typename] = ACTIONS(2342),
    [anon_sym_template] = ACTIONS(2342),
    [anon_sym_delete] = ACTIONS(2342),
    [anon_sym_R_DQUOTE] = ACTIONS(2344),
    [anon_sym_LR_DQUOTE] = ACTIONS(2344),
    [anon_sym_uR_DQUOTE] = ACTIONS(2344),
    [anon_sym_UR_DQUOTE] = ACTIONS(2344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2344),
    [anon_sym_co_await] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2342),
    [anon_sym_requires] = ACTIONS(2342),
    [sym_this] = ACTIONS(2342),
    [anon_sym___launch_bounds__] = ACTIONS(2342),
  },
  [966] = {
    [sym_compound_statement] = STATE(7523),
    [sym_expression] = STATE(4679),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7523),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_RPAREN] = ACTIONS(4299),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(4301),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [967] = {
    [sym_compound_statement] = STATE(8184),
    [sym_expression] = STATE(4838),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(8184),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym___extension__] = ACTIONS(4303),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [968] = {
    [sym_expression] = STATE(3450),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym__unary_left_fold] = STATE(8768),
    [sym__unary_right_fold] = STATE(8883),
    [sym__binary_fold] = STATE(8783),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [969] = {
    [sym_expression] = STATE(3386),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym__unary_left_fold] = STATE(8983),
    [sym__unary_right_fold] = STATE(8982),
    [sym__binary_fold] = STATE(8978),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [970] = {
    [sym_expression] = STATE(3355),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym__unary_left_fold] = STATE(8518),
    [sym__unary_right_fold] = STATE(8523),
    [sym__binary_fold] = STATE(8524),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [971] = {
    [sym_expression] = STATE(4891),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8322),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(8322),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4305),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [972] = {
    [sym_identifier] = ACTIONS(3980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3982),
    [anon_sym_COMMA] = ACTIONS(3982),
    [anon_sym_RPAREN] = ACTIONS(3982),
    [anon_sym_LPAREN2] = ACTIONS(3982),
    [anon_sym_TILDE] = ACTIONS(3982),
    [anon_sym_DASH] = ACTIONS(3980),
    [anon_sym_PLUS] = ACTIONS(3980),
    [anon_sym_STAR] = ACTIONS(3980),
    [anon_sym_SLASH] = ACTIONS(3980),
    [anon_sym_PERCENT] = ACTIONS(3980),
    [anon_sym_PIPE_PIPE] = ACTIONS(3982),
    [anon_sym_AMP_AMP] = ACTIONS(3982),
    [anon_sym_PIPE] = ACTIONS(3980),
    [anon_sym_CARET] = ACTIONS(3980),
    [anon_sym_AMP] = ACTIONS(3980),
    [anon_sym_EQ_EQ] = ACTIONS(3982),
    [anon_sym_BANG_EQ] = ACTIONS(3982),
    [anon_sym_GT] = ACTIONS(3980),
    [anon_sym_GT_EQ] = ACTIONS(3982),
    [anon_sym_LT_EQ] = ACTIONS(3980),
    [anon_sym_LT] = ACTIONS(3980),
    [anon_sym_LT_LT] = ACTIONS(3980),
    [anon_sym_GT_GT] = ACTIONS(3980),
    [anon_sym___extension__] = ACTIONS(3980),
    [anon_sym___device__] = ACTIONS(3980),
    [anon_sym___host__] = ACTIONS(3980),
    [anon_sym___global__] = ACTIONS(3980),
    [anon_sym___forceinline__] = ACTIONS(3980),
    [anon_sym___noinline__] = ACTIONS(3980),
    [anon_sym_extern] = ACTIONS(3980),
    [anon_sym___attribute__] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3982),
    [anon_sym___declspec] = ACTIONS(3980),
    [anon_sym___based] = ACTIONS(3980),
    [anon_sym_LBRACE] = ACTIONS(3982),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_static] = ACTIONS(3980),
    [anon_sym_EQ] = ACTIONS(3980),
    [anon_sym_register] = ACTIONS(3980),
    [anon_sym_inline] = ACTIONS(3980),
    [anon_sym___inline] = ACTIONS(3980),
    [anon_sym___inline__] = ACTIONS(3980),
    [anon_sym___forceinline] = ACTIONS(3980),
    [anon_sym_thread_local] = ACTIONS(3980),
    [anon_sym___thread] = ACTIONS(3980),
    [anon_sym_const] = ACTIONS(3980),
    [anon_sym_constexpr] = ACTIONS(3980),
    [anon_sym_volatile] = ACTIONS(3980),
    [anon_sym_restrict] = ACTIONS(3980),
    [anon_sym___restrict__] = ACTIONS(3980),
    [anon_sym__Atomic] = ACTIONS(3980),
    [anon_sym__Noreturn] = ACTIONS(3980),
    [anon_sym_noreturn] = ACTIONS(3980),
    [anon_sym_mutable] = ACTIONS(3980),
    [anon_sym_constinit] = ACTIONS(3980),
    [anon_sym_consteval] = ACTIONS(3980),
    [anon_sym___shared__] = ACTIONS(3980),
    [anon_sym___local__] = ACTIONS(3980),
    [anon_sym___constant__] = ACTIONS(3980),
    [anon_sym___managed__] = ACTIONS(3980),
    [anon_sym___grid_constant__] = ACTIONS(3980),
    [anon_sym_alignas] = ACTIONS(3980),
    [anon_sym__Alignas] = ACTIONS(3980),
    [anon_sym_QMARK] = ACTIONS(3982),
    [anon_sym_STAR_EQ] = ACTIONS(3982),
    [anon_sym_SLASH_EQ] = ACTIONS(3982),
    [anon_sym_PERCENT_EQ] = ACTIONS(3982),
    [anon_sym_PLUS_EQ] = ACTIONS(3982),
    [anon_sym_DASH_EQ] = ACTIONS(3982),
    [anon_sym_LT_LT_EQ] = ACTIONS(3982),
    [anon_sym_GT_GT_EQ] = ACTIONS(3982),
    [anon_sym_AMP_EQ] = ACTIONS(3982),
    [anon_sym_CARET_EQ] = ACTIONS(3982),
    [anon_sym_PIPE_EQ] = ACTIONS(3982),
    [anon_sym_and_eq] = ACTIONS(3980),
    [anon_sym_or_eq] = ACTIONS(3980),
    [anon_sym_xor_eq] = ACTIONS(3980),
    [anon_sym_LT_EQ_GT] = ACTIONS(3982),
    [anon_sym_or] = ACTIONS(3980),
    [anon_sym_and] = ACTIONS(3980),
    [anon_sym_bitor] = ACTIONS(3980),
    [anon_sym_xor] = ACTIONS(3980),
    [anon_sym_bitand] = ACTIONS(3980),
    [anon_sym_not_eq] = ACTIONS(3980),
    [anon_sym_DASH_DASH] = ACTIONS(3982),
    [anon_sym_PLUS_PLUS] = ACTIONS(3982),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_DOT_STAR] = ACTIONS(3982),
    [anon_sym_DASH_GT] = ACTIONS(3980),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3980),
    [anon_sym_decltype] = ACTIONS(3980),
    [sym_virtual] = ACTIONS(3980),
    [anon_sym_template] = ACTIONS(3980),
    [anon_sym_operator] = ACTIONS(3980),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3982),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3982),
    [anon_sym___launch_bounds__] = ACTIONS(3980),
  },
  [973] = {
    [sym_expression] = STATE(3362),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym__unary_left_fold] = STATE(8494),
    [sym__unary_right_fold] = STATE(8496),
    [sym__binary_fold] = STATE(8504),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [974] = {
    [sym_expression] = STATE(4533),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_initializer_list] = STATE(7060),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_default] = ACTIONS(4311),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4315),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(4317),
    [anon_sym_0] = ACTIONS(4319),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [975] = {
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3994),
    [anon_sym_COMMA] = ACTIONS(3994),
    [anon_sym_RPAREN] = ACTIONS(3994),
    [anon_sym_LPAREN2] = ACTIONS(3994),
    [anon_sym_TILDE] = ACTIONS(3994),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_STAR] = ACTIONS(3992),
    [anon_sym_SLASH] = ACTIONS(3992),
    [anon_sym_PERCENT] = ACTIONS(3992),
    [anon_sym_PIPE_PIPE] = ACTIONS(3994),
    [anon_sym_AMP_AMP] = ACTIONS(3994),
    [anon_sym_PIPE] = ACTIONS(3992),
    [anon_sym_CARET] = ACTIONS(3992),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym_EQ_EQ] = ACTIONS(3994),
    [anon_sym_BANG_EQ] = ACTIONS(3994),
    [anon_sym_GT] = ACTIONS(3992),
    [anon_sym_GT_EQ] = ACTIONS(3994),
    [anon_sym_LT_EQ] = ACTIONS(3992),
    [anon_sym_LT] = ACTIONS(3992),
    [anon_sym_LT_LT] = ACTIONS(3992),
    [anon_sym_GT_GT] = ACTIONS(3992),
    [anon_sym___extension__] = ACTIONS(3992),
    [anon_sym___device__] = ACTIONS(3992),
    [anon_sym___host__] = ACTIONS(3992),
    [anon_sym___global__] = ACTIONS(3992),
    [anon_sym___forceinline__] = ACTIONS(3992),
    [anon_sym___noinline__] = ACTIONS(3992),
    [anon_sym_extern] = ACTIONS(3992),
    [anon_sym___attribute__] = ACTIONS(3992),
    [anon_sym_COLON_COLON] = ACTIONS(3994),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3994),
    [anon_sym___declspec] = ACTIONS(3992),
    [anon_sym___based] = ACTIONS(3992),
    [anon_sym_LBRACE] = ACTIONS(3994),
    [anon_sym_LBRACK] = ACTIONS(3992),
    [anon_sym_static] = ACTIONS(3992),
    [anon_sym_EQ] = ACTIONS(3992),
    [anon_sym_register] = ACTIONS(3992),
    [anon_sym_inline] = ACTIONS(3992),
    [anon_sym___inline] = ACTIONS(3992),
    [anon_sym___inline__] = ACTIONS(3992),
    [anon_sym___forceinline] = ACTIONS(3992),
    [anon_sym_thread_local] = ACTIONS(3992),
    [anon_sym___thread] = ACTIONS(3992),
    [anon_sym_const] = ACTIONS(3992),
    [anon_sym_constexpr] = ACTIONS(3992),
    [anon_sym_volatile] = ACTIONS(3992),
    [anon_sym_restrict] = ACTIONS(3992),
    [anon_sym___restrict__] = ACTIONS(3992),
    [anon_sym__Atomic] = ACTIONS(3992),
    [anon_sym__Noreturn] = ACTIONS(3992),
    [anon_sym_noreturn] = ACTIONS(3992),
    [anon_sym_mutable] = ACTIONS(3992),
    [anon_sym_constinit] = ACTIONS(3992),
    [anon_sym_consteval] = ACTIONS(3992),
    [anon_sym___shared__] = ACTIONS(3992),
    [anon_sym___local__] = ACTIONS(3992),
    [anon_sym___constant__] = ACTIONS(3992),
    [anon_sym___managed__] = ACTIONS(3992),
    [anon_sym___grid_constant__] = ACTIONS(3992),
    [anon_sym_alignas] = ACTIONS(3992),
    [anon_sym__Alignas] = ACTIONS(3992),
    [anon_sym_QMARK] = ACTIONS(3994),
    [anon_sym_STAR_EQ] = ACTIONS(3994),
    [anon_sym_SLASH_EQ] = ACTIONS(3994),
    [anon_sym_PERCENT_EQ] = ACTIONS(3994),
    [anon_sym_PLUS_EQ] = ACTIONS(3994),
    [anon_sym_DASH_EQ] = ACTIONS(3994),
    [anon_sym_LT_LT_EQ] = ACTIONS(3994),
    [anon_sym_GT_GT_EQ] = ACTIONS(3994),
    [anon_sym_AMP_EQ] = ACTIONS(3994),
    [anon_sym_CARET_EQ] = ACTIONS(3994),
    [anon_sym_PIPE_EQ] = ACTIONS(3994),
    [anon_sym_and_eq] = ACTIONS(3992),
    [anon_sym_or_eq] = ACTIONS(3992),
    [anon_sym_xor_eq] = ACTIONS(3992),
    [anon_sym_LT_EQ_GT] = ACTIONS(3994),
    [anon_sym_or] = ACTIONS(3992),
    [anon_sym_and] = ACTIONS(3992),
    [anon_sym_bitor] = ACTIONS(3992),
    [anon_sym_xor] = ACTIONS(3992),
    [anon_sym_bitand] = ACTIONS(3992),
    [anon_sym_not_eq] = ACTIONS(3992),
    [anon_sym_DASH_DASH] = ACTIONS(3994),
    [anon_sym_PLUS_PLUS] = ACTIONS(3994),
    [anon_sym_DOT] = ACTIONS(3992),
    [anon_sym_DOT_STAR] = ACTIONS(3994),
    [anon_sym_DASH_GT] = ACTIONS(3992),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3992),
    [anon_sym_decltype] = ACTIONS(3992),
    [sym_virtual] = ACTIONS(3992),
    [anon_sym_template] = ACTIONS(3992),
    [anon_sym_operator] = ACTIONS(3992),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3994),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3994),
    [anon_sym___launch_bounds__] = ACTIONS(3992),
  },
  [976] = {
    [sym_expression] = STATE(4801),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8754),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(8754),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4321),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [977] = {
    [sym_identifier] = ACTIONS(4021),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_RPAREN] = ACTIONS(4023),
    [anon_sym_LPAREN2] = ACTIONS(4023),
    [anon_sym_TILDE] = ACTIONS(4023),
    [anon_sym_DASH] = ACTIONS(4021),
    [anon_sym_PLUS] = ACTIONS(4021),
    [anon_sym_STAR] = ACTIONS(4021),
    [anon_sym_SLASH] = ACTIONS(4021),
    [anon_sym_PERCENT] = ACTIONS(4021),
    [anon_sym_PIPE_PIPE] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4023),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_CARET] = ACTIONS(4021),
    [anon_sym_AMP] = ACTIONS(4021),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4021),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4021),
    [anon_sym___extension__] = ACTIONS(4021),
    [anon_sym___device__] = ACTIONS(4021),
    [anon_sym___host__] = ACTIONS(4021),
    [anon_sym___global__] = ACTIONS(4021),
    [anon_sym___forceinline__] = ACTIONS(4021),
    [anon_sym___noinline__] = ACTIONS(4021),
    [anon_sym_extern] = ACTIONS(4021),
    [anon_sym___attribute__] = ACTIONS(4021),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4023),
    [anon_sym___declspec] = ACTIONS(4021),
    [anon_sym___based] = ACTIONS(4021),
    [anon_sym_LBRACE] = ACTIONS(4023),
    [anon_sym_LBRACK] = ACTIONS(4021),
    [anon_sym_static] = ACTIONS(4021),
    [anon_sym_EQ] = ACTIONS(4021),
    [anon_sym_register] = ACTIONS(4021),
    [anon_sym_inline] = ACTIONS(4021),
    [anon_sym___inline] = ACTIONS(4021),
    [anon_sym___inline__] = ACTIONS(4021),
    [anon_sym___forceinline] = ACTIONS(4021),
    [anon_sym_thread_local] = ACTIONS(4021),
    [anon_sym___thread] = ACTIONS(4021),
    [anon_sym_const] = ACTIONS(4021),
    [anon_sym_constexpr] = ACTIONS(4021),
    [anon_sym_volatile] = ACTIONS(4021),
    [anon_sym_restrict] = ACTIONS(4021),
    [anon_sym___restrict__] = ACTIONS(4021),
    [anon_sym__Atomic] = ACTIONS(4021),
    [anon_sym__Noreturn] = ACTIONS(4021),
    [anon_sym_noreturn] = ACTIONS(4021),
    [anon_sym_mutable] = ACTIONS(4021),
    [anon_sym_constinit] = ACTIONS(4021),
    [anon_sym_consteval] = ACTIONS(4021),
    [anon_sym___shared__] = ACTIONS(4021),
    [anon_sym___local__] = ACTIONS(4021),
    [anon_sym___constant__] = ACTIONS(4021),
    [anon_sym___managed__] = ACTIONS(4021),
    [anon_sym___grid_constant__] = ACTIONS(4021),
    [anon_sym_alignas] = ACTIONS(4021),
    [anon_sym__Alignas] = ACTIONS(4021),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_and_eq] = ACTIONS(4021),
    [anon_sym_or_eq] = ACTIONS(4021),
    [anon_sym_xor_eq] = ACTIONS(4021),
    [anon_sym_LT_EQ_GT] = ACTIONS(4023),
    [anon_sym_or] = ACTIONS(4021),
    [anon_sym_and] = ACTIONS(4021),
    [anon_sym_bitor] = ACTIONS(4021),
    [anon_sym_xor] = ACTIONS(4021),
    [anon_sym_bitand] = ACTIONS(4021),
    [anon_sym_not_eq] = ACTIONS(4021),
    [anon_sym_DASH_DASH] = ACTIONS(4023),
    [anon_sym_PLUS_PLUS] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4021),
    [anon_sym_DOT_STAR] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4021),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4021),
    [anon_sym_decltype] = ACTIONS(4021),
    [sym_virtual] = ACTIONS(4021),
    [anon_sym_template] = ACTIONS(4021),
    [anon_sym_operator] = ACTIONS(4021),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4023),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4023),
    [anon_sym___launch_bounds__] = ACTIONS(4021),
  },
  [978] = {
    [sym_expression] = STATE(3238),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym__unary_left_fold] = STATE(8509),
    [sym__unary_right_fold] = STATE(8507),
    [sym__binary_fold] = STATE(8501),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [979] = {
    [sym_identifier] = ACTIONS(4017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4019),
    [anon_sym_COMMA] = ACTIONS(4019),
    [anon_sym_RPAREN] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(4019),
    [anon_sym_TILDE] = ACTIONS(4019),
    [anon_sym_DASH] = ACTIONS(4017),
    [anon_sym_PLUS] = ACTIONS(4017),
    [anon_sym_STAR] = ACTIONS(4017),
    [anon_sym_SLASH] = ACTIONS(4017),
    [anon_sym_PERCENT] = ACTIONS(4017),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE] = ACTIONS(4017),
    [anon_sym_CARET] = ACTIONS(4017),
    [anon_sym_AMP] = ACTIONS(4017),
    [anon_sym_EQ_EQ] = ACTIONS(4019),
    [anon_sym_BANG_EQ] = ACTIONS(4019),
    [anon_sym_GT] = ACTIONS(4017),
    [anon_sym_GT_EQ] = ACTIONS(4019),
    [anon_sym_LT_EQ] = ACTIONS(4017),
    [anon_sym_LT] = ACTIONS(4017),
    [anon_sym_LT_LT] = ACTIONS(4017),
    [anon_sym_GT_GT] = ACTIONS(4017),
    [anon_sym___extension__] = ACTIONS(4017),
    [anon_sym___device__] = ACTIONS(4017),
    [anon_sym___host__] = ACTIONS(4017),
    [anon_sym___global__] = ACTIONS(4017),
    [anon_sym___forceinline__] = ACTIONS(4017),
    [anon_sym___noinline__] = ACTIONS(4017),
    [anon_sym_extern] = ACTIONS(4017),
    [anon_sym___attribute__] = ACTIONS(4017),
    [anon_sym_COLON_COLON] = ACTIONS(4019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4019),
    [anon_sym___declspec] = ACTIONS(4017),
    [anon_sym___based] = ACTIONS(4017),
    [anon_sym_LBRACE] = ACTIONS(4019),
    [anon_sym_LBRACK] = ACTIONS(4017),
    [anon_sym_static] = ACTIONS(4017),
    [anon_sym_EQ] = ACTIONS(4017),
    [anon_sym_register] = ACTIONS(4017),
    [anon_sym_inline] = ACTIONS(4017),
    [anon_sym___inline] = ACTIONS(4017),
    [anon_sym___inline__] = ACTIONS(4017),
    [anon_sym___forceinline] = ACTIONS(4017),
    [anon_sym_thread_local] = ACTIONS(4017),
    [anon_sym___thread] = ACTIONS(4017),
    [anon_sym_const] = ACTIONS(4017),
    [anon_sym_constexpr] = ACTIONS(4017),
    [anon_sym_volatile] = ACTIONS(4017),
    [anon_sym_restrict] = ACTIONS(4017),
    [anon_sym___restrict__] = ACTIONS(4017),
    [anon_sym__Atomic] = ACTIONS(4017),
    [anon_sym__Noreturn] = ACTIONS(4017),
    [anon_sym_noreturn] = ACTIONS(4017),
    [anon_sym_mutable] = ACTIONS(4017),
    [anon_sym_constinit] = ACTIONS(4017),
    [anon_sym_consteval] = ACTIONS(4017),
    [anon_sym___shared__] = ACTIONS(4017),
    [anon_sym___local__] = ACTIONS(4017),
    [anon_sym___constant__] = ACTIONS(4017),
    [anon_sym___managed__] = ACTIONS(4017),
    [anon_sym___grid_constant__] = ACTIONS(4017),
    [anon_sym_alignas] = ACTIONS(4017),
    [anon_sym__Alignas] = ACTIONS(4017),
    [anon_sym_QMARK] = ACTIONS(4019),
    [anon_sym_STAR_EQ] = ACTIONS(4019),
    [anon_sym_SLASH_EQ] = ACTIONS(4019),
    [anon_sym_PERCENT_EQ] = ACTIONS(4019),
    [anon_sym_PLUS_EQ] = ACTIONS(4019),
    [anon_sym_DASH_EQ] = ACTIONS(4019),
    [anon_sym_LT_LT_EQ] = ACTIONS(4019),
    [anon_sym_GT_GT_EQ] = ACTIONS(4019),
    [anon_sym_AMP_EQ] = ACTIONS(4019),
    [anon_sym_CARET_EQ] = ACTIONS(4019),
    [anon_sym_PIPE_EQ] = ACTIONS(4019),
    [anon_sym_and_eq] = ACTIONS(4017),
    [anon_sym_or_eq] = ACTIONS(4017),
    [anon_sym_xor_eq] = ACTIONS(4017),
    [anon_sym_LT_EQ_GT] = ACTIONS(4019),
    [anon_sym_or] = ACTIONS(4017),
    [anon_sym_and] = ACTIONS(4017),
    [anon_sym_bitor] = ACTIONS(4017),
    [anon_sym_xor] = ACTIONS(4017),
    [anon_sym_bitand] = ACTIONS(4017),
    [anon_sym_not_eq] = ACTIONS(4017),
    [anon_sym_DASH_DASH] = ACTIONS(4019),
    [anon_sym_PLUS_PLUS] = ACTIONS(4019),
    [anon_sym_DOT] = ACTIONS(4017),
    [anon_sym_DOT_STAR] = ACTIONS(4019),
    [anon_sym_DASH_GT] = ACTIONS(4017),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4017),
    [anon_sym_decltype] = ACTIONS(4017),
    [sym_virtual] = ACTIONS(4017),
    [anon_sym_template] = ACTIONS(4017),
    [anon_sym_operator] = ACTIONS(4017),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4019),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4019),
    [anon_sym___launch_bounds__] = ACTIONS(4017),
  },
  [980] = {
    [sym_identifier] = ACTIONS(3984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3986),
    [anon_sym_COMMA] = ACTIONS(3986),
    [anon_sym_RPAREN] = ACTIONS(3986),
    [anon_sym_LPAREN2] = ACTIONS(3986),
    [anon_sym_TILDE] = ACTIONS(3986),
    [anon_sym_DASH] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(3984),
    [anon_sym_SLASH] = ACTIONS(3984),
    [anon_sym_PERCENT] = ACTIONS(3984),
    [anon_sym_PIPE_PIPE] = ACTIONS(3986),
    [anon_sym_AMP_AMP] = ACTIONS(3986),
    [anon_sym_PIPE] = ACTIONS(3984),
    [anon_sym_CARET] = ACTIONS(3984),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_EQ_EQ] = ACTIONS(3986),
    [anon_sym_BANG_EQ] = ACTIONS(3986),
    [anon_sym_GT] = ACTIONS(3984),
    [anon_sym_GT_EQ] = ACTIONS(3986),
    [anon_sym_LT_EQ] = ACTIONS(3984),
    [anon_sym_LT] = ACTIONS(3984),
    [anon_sym_LT_LT] = ACTIONS(3984),
    [anon_sym_GT_GT] = ACTIONS(3984),
    [anon_sym___extension__] = ACTIONS(3984),
    [anon_sym___device__] = ACTIONS(3984),
    [anon_sym___host__] = ACTIONS(3984),
    [anon_sym___global__] = ACTIONS(3984),
    [anon_sym___forceinline__] = ACTIONS(3984),
    [anon_sym___noinline__] = ACTIONS(3984),
    [anon_sym_extern] = ACTIONS(3984),
    [anon_sym___attribute__] = ACTIONS(3984),
    [anon_sym_COLON_COLON] = ACTIONS(3986),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3986),
    [anon_sym___declspec] = ACTIONS(3984),
    [anon_sym___based] = ACTIONS(3984),
    [anon_sym_LBRACE] = ACTIONS(3986),
    [anon_sym_LBRACK] = ACTIONS(3984),
    [anon_sym_static] = ACTIONS(3984),
    [anon_sym_EQ] = ACTIONS(3984),
    [anon_sym_register] = ACTIONS(3984),
    [anon_sym_inline] = ACTIONS(3984),
    [anon_sym___inline] = ACTIONS(3984),
    [anon_sym___inline__] = ACTIONS(3984),
    [anon_sym___forceinline] = ACTIONS(3984),
    [anon_sym_thread_local] = ACTIONS(3984),
    [anon_sym___thread] = ACTIONS(3984),
    [anon_sym_const] = ACTIONS(3984),
    [anon_sym_constexpr] = ACTIONS(3984),
    [anon_sym_volatile] = ACTIONS(3984),
    [anon_sym_restrict] = ACTIONS(3984),
    [anon_sym___restrict__] = ACTIONS(3984),
    [anon_sym__Atomic] = ACTIONS(3984),
    [anon_sym__Noreturn] = ACTIONS(3984),
    [anon_sym_noreturn] = ACTIONS(3984),
    [anon_sym_mutable] = ACTIONS(3984),
    [anon_sym_constinit] = ACTIONS(3984),
    [anon_sym_consteval] = ACTIONS(3984),
    [anon_sym___shared__] = ACTIONS(3984),
    [anon_sym___local__] = ACTIONS(3984),
    [anon_sym___constant__] = ACTIONS(3984),
    [anon_sym___managed__] = ACTIONS(3984),
    [anon_sym___grid_constant__] = ACTIONS(3984),
    [anon_sym_alignas] = ACTIONS(3984),
    [anon_sym__Alignas] = ACTIONS(3984),
    [anon_sym_QMARK] = ACTIONS(3986),
    [anon_sym_STAR_EQ] = ACTIONS(3986),
    [anon_sym_SLASH_EQ] = ACTIONS(3986),
    [anon_sym_PERCENT_EQ] = ACTIONS(3986),
    [anon_sym_PLUS_EQ] = ACTIONS(3986),
    [anon_sym_DASH_EQ] = ACTIONS(3986),
    [anon_sym_LT_LT_EQ] = ACTIONS(3986),
    [anon_sym_GT_GT_EQ] = ACTIONS(3986),
    [anon_sym_AMP_EQ] = ACTIONS(3986),
    [anon_sym_CARET_EQ] = ACTIONS(3986),
    [anon_sym_PIPE_EQ] = ACTIONS(3986),
    [anon_sym_and_eq] = ACTIONS(3984),
    [anon_sym_or_eq] = ACTIONS(3984),
    [anon_sym_xor_eq] = ACTIONS(3984),
    [anon_sym_LT_EQ_GT] = ACTIONS(3986),
    [anon_sym_or] = ACTIONS(3984),
    [anon_sym_and] = ACTIONS(3984),
    [anon_sym_bitor] = ACTIONS(3984),
    [anon_sym_xor] = ACTIONS(3984),
    [anon_sym_bitand] = ACTIONS(3984),
    [anon_sym_not_eq] = ACTIONS(3984),
    [anon_sym_DASH_DASH] = ACTIONS(3986),
    [anon_sym_PLUS_PLUS] = ACTIONS(3986),
    [anon_sym_DOT] = ACTIONS(3984),
    [anon_sym_DOT_STAR] = ACTIONS(3986),
    [anon_sym_DASH_GT] = ACTIONS(3984),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3984),
    [anon_sym_decltype] = ACTIONS(3984),
    [sym_virtual] = ACTIONS(3984),
    [anon_sym_template] = ACTIONS(3984),
    [anon_sym_operator] = ACTIONS(3984),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3986),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3986),
    [anon_sym___launch_bounds__] = ACTIONS(3984),
  },
  [981] = {
    [sym_expression] = STATE(4529),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_initializer_list] = STATE(7072),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_default] = ACTIONS(4323),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4315),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(4325),
    [anon_sym_0] = ACTIONS(4327),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [982] = {
    [sym_expression] = STATE(3262),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym__unary_left_fold] = STATE(8299),
    [sym__unary_right_fold] = STATE(8308),
    [sym__binary_fold] = STATE(8312),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [983] = {
    [sym_expression] = STATE(3278),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym__unary_left_fold] = STATE(8784),
    [sym__unary_right_fold] = STATE(8731),
    [sym__binary_fold] = STATE(8781),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [984] = {
    [sym_identifier] = ACTIONS(3988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3990),
    [anon_sym_COMMA] = ACTIONS(3990),
    [anon_sym_RPAREN] = ACTIONS(3990),
    [anon_sym_LPAREN2] = ACTIONS(3990),
    [anon_sym_TILDE] = ACTIONS(3990),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_STAR] = ACTIONS(3988),
    [anon_sym_SLASH] = ACTIONS(3988),
    [anon_sym_PERCENT] = ACTIONS(3988),
    [anon_sym_PIPE_PIPE] = ACTIONS(3990),
    [anon_sym_AMP_AMP] = ACTIONS(3990),
    [anon_sym_PIPE] = ACTIONS(3988),
    [anon_sym_CARET] = ACTIONS(3988),
    [anon_sym_AMP] = ACTIONS(3988),
    [anon_sym_EQ_EQ] = ACTIONS(3990),
    [anon_sym_BANG_EQ] = ACTIONS(3990),
    [anon_sym_GT] = ACTIONS(3988),
    [anon_sym_GT_EQ] = ACTIONS(3990),
    [anon_sym_LT_EQ] = ACTIONS(3988),
    [anon_sym_LT] = ACTIONS(3988),
    [anon_sym_LT_LT] = ACTIONS(3988),
    [anon_sym_GT_GT] = ACTIONS(3988),
    [anon_sym___extension__] = ACTIONS(3988),
    [anon_sym___device__] = ACTIONS(3988),
    [anon_sym___host__] = ACTIONS(3988),
    [anon_sym___global__] = ACTIONS(3988),
    [anon_sym___forceinline__] = ACTIONS(3988),
    [anon_sym___noinline__] = ACTIONS(3988),
    [anon_sym_extern] = ACTIONS(3988),
    [anon_sym___attribute__] = ACTIONS(3988),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3990),
    [anon_sym___declspec] = ACTIONS(3988),
    [anon_sym___based] = ACTIONS(3988),
    [anon_sym_LBRACE] = ACTIONS(3990),
    [anon_sym_LBRACK] = ACTIONS(3988),
    [anon_sym_static] = ACTIONS(3988),
    [anon_sym_EQ] = ACTIONS(3988),
    [anon_sym_register] = ACTIONS(3988),
    [anon_sym_inline] = ACTIONS(3988),
    [anon_sym___inline] = ACTIONS(3988),
    [anon_sym___inline__] = ACTIONS(3988),
    [anon_sym___forceinline] = ACTIONS(3988),
    [anon_sym_thread_local] = ACTIONS(3988),
    [anon_sym___thread] = ACTIONS(3988),
    [anon_sym_const] = ACTIONS(3988),
    [anon_sym_constexpr] = ACTIONS(3988),
    [anon_sym_volatile] = ACTIONS(3988),
    [anon_sym_restrict] = ACTIONS(3988),
    [anon_sym___restrict__] = ACTIONS(3988),
    [anon_sym__Atomic] = ACTIONS(3988),
    [anon_sym__Noreturn] = ACTIONS(3988),
    [anon_sym_noreturn] = ACTIONS(3988),
    [anon_sym_mutable] = ACTIONS(3988),
    [anon_sym_constinit] = ACTIONS(3988),
    [anon_sym_consteval] = ACTIONS(3988),
    [anon_sym___shared__] = ACTIONS(3988),
    [anon_sym___local__] = ACTIONS(3988),
    [anon_sym___constant__] = ACTIONS(3988),
    [anon_sym___managed__] = ACTIONS(3988),
    [anon_sym___grid_constant__] = ACTIONS(3988),
    [anon_sym_alignas] = ACTIONS(3988),
    [anon_sym__Alignas] = ACTIONS(3988),
    [anon_sym_QMARK] = ACTIONS(3990),
    [anon_sym_STAR_EQ] = ACTIONS(3990),
    [anon_sym_SLASH_EQ] = ACTIONS(3990),
    [anon_sym_PERCENT_EQ] = ACTIONS(3990),
    [anon_sym_PLUS_EQ] = ACTIONS(3990),
    [anon_sym_DASH_EQ] = ACTIONS(3990),
    [anon_sym_LT_LT_EQ] = ACTIONS(3990),
    [anon_sym_GT_GT_EQ] = ACTIONS(3990),
    [anon_sym_AMP_EQ] = ACTIONS(3990),
    [anon_sym_CARET_EQ] = ACTIONS(3990),
    [anon_sym_PIPE_EQ] = ACTIONS(3990),
    [anon_sym_and_eq] = ACTIONS(3988),
    [anon_sym_or_eq] = ACTIONS(3988),
    [anon_sym_xor_eq] = ACTIONS(3988),
    [anon_sym_LT_EQ_GT] = ACTIONS(3990),
    [anon_sym_or] = ACTIONS(3988),
    [anon_sym_and] = ACTIONS(3988),
    [anon_sym_bitor] = ACTIONS(3988),
    [anon_sym_xor] = ACTIONS(3988),
    [anon_sym_bitand] = ACTIONS(3988),
    [anon_sym_not_eq] = ACTIONS(3988),
    [anon_sym_DASH_DASH] = ACTIONS(3990),
    [anon_sym_PLUS_PLUS] = ACTIONS(3990),
    [anon_sym_DOT] = ACTIONS(3988),
    [anon_sym_DOT_STAR] = ACTIONS(3990),
    [anon_sym_DASH_GT] = ACTIONS(3988),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3988),
    [anon_sym_decltype] = ACTIONS(3988),
    [sym_virtual] = ACTIONS(3988),
    [anon_sym_template] = ACTIONS(3988),
    [anon_sym_operator] = ACTIONS(3988),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3990),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3990),
    [anon_sym___launch_bounds__] = ACTIONS(3988),
  },
  [985] = {
    [sym_expression] = STATE(4509),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_initializer_list] = STATE(7064),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_default] = ACTIONS(4329),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(4315),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(4331),
    [anon_sym_0] = ACTIONS(4333),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [986] = {
    [sym_expression] = STATE(3294),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym__unary_left_fold] = STATE(9095),
    [sym__unary_right_fold] = STATE(9093),
    [sym__binary_fold] = STATE(9091),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [987] = {
    [sym_expression] = STATE(3344),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym__unary_left_fold] = STATE(8282),
    [sym__unary_right_fold] = STATE(8283),
    [sym__binary_fold] = STATE(8289),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [988] = {
    [sym_template_argument_list] = STATE(1012),
    [sym_identifier] = ACTIONS(4000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4004),
    [anon_sym_COMMA] = ACTIONS(4004),
    [anon_sym_RPAREN] = ACTIONS(4004),
    [anon_sym_LPAREN2] = ACTIONS(4004),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4009),
    [anon_sym_PLUS] = ACTIONS(4009),
    [anon_sym_STAR] = ACTIONS(4011),
    [anon_sym_SLASH] = ACTIONS(4009),
    [anon_sym_PERCENT] = ACTIONS(4009),
    [anon_sym_PIPE_PIPE] = ACTIONS(4002),
    [anon_sym_AMP_AMP] = ACTIONS(4004),
    [anon_sym_PIPE] = ACTIONS(4009),
    [anon_sym_CARET] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4011),
    [anon_sym_EQ_EQ] = ACTIONS(4002),
    [anon_sym_BANG_EQ] = ACTIONS(4002),
    [anon_sym_GT] = ACTIONS(4009),
    [anon_sym_GT_EQ] = ACTIONS(4002),
    [anon_sym_LT_EQ] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(4014),
    [anon_sym_LT_LT] = ACTIONS(4009),
    [anon_sym_GT_GT] = ACTIONS(4009),
    [anon_sym___extension__] = ACTIONS(4000),
    [anon_sym___device__] = ACTIONS(4000),
    [anon_sym___host__] = ACTIONS(4000),
    [anon_sym___global__] = ACTIONS(4000),
    [anon_sym___forceinline__] = ACTIONS(4000),
    [anon_sym___noinline__] = ACTIONS(4000),
    [anon_sym_extern] = ACTIONS(4000),
    [anon_sym___attribute__] = ACTIONS(4000),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4007),
    [anon_sym___declspec] = ACTIONS(4000),
    [anon_sym___based] = ACTIONS(4000),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4011),
    [anon_sym_static] = ACTIONS(4000),
    [anon_sym_EQ] = ACTIONS(4011),
    [anon_sym_register] = ACTIONS(4000),
    [anon_sym_inline] = ACTIONS(4000),
    [anon_sym___inline] = ACTIONS(4000),
    [anon_sym___inline__] = ACTIONS(4000),
    [anon_sym___forceinline] = ACTIONS(4000),
    [anon_sym_thread_local] = ACTIONS(4000),
    [anon_sym___thread] = ACTIONS(4000),
    [anon_sym_const] = ACTIONS(4000),
    [anon_sym_constexpr] = ACTIONS(4000),
    [anon_sym_volatile] = ACTIONS(4000),
    [anon_sym_restrict] = ACTIONS(4000),
    [anon_sym___restrict__] = ACTIONS(4000),
    [anon_sym__Atomic] = ACTIONS(4000),
    [anon_sym__Noreturn] = ACTIONS(4000),
    [anon_sym_noreturn] = ACTIONS(4000),
    [anon_sym_mutable] = ACTIONS(4000),
    [anon_sym_constinit] = ACTIONS(4000),
    [anon_sym_consteval] = ACTIONS(4000),
    [anon_sym___shared__] = ACTIONS(4000),
    [anon_sym___local__] = ACTIONS(4000),
    [anon_sym___constant__] = ACTIONS(4000),
    [anon_sym___managed__] = ACTIONS(4000),
    [anon_sym___grid_constant__] = ACTIONS(4000),
    [anon_sym_alignas] = ACTIONS(4000),
    [anon_sym__Alignas] = ACTIONS(4000),
    [anon_sym_QMARK] = ACTIONS(4002),
    [anon_sym_STAR_EQ] = ACTIONS(4002),
    [anon_sym_SLASH_EQ] = ACTIONS(4002),
    [anon_sym_PERCENT_EQ] = ACTIONS(4002),
    [anon_sym_PLUS_EQ] = ACTIONS(4002),
    [anon_sym_DASH_EQ] = ACTIONS(4002),
    [anon_sym_LT_LT_EQ] = ACTIONS(4002),
    [anon_sym_GT_GT_EQ] = ACTIONS(4002),
    [anon_sym_AMP_EQ] = ACTIONS(4002),
    [anon_sym_CARET_EQ] = ACTIONS(4002),
    [anon_sym_PIPE_EQ] = ACTIONS(4002),
    [anon_sym_and_eq] = ACTIONS(4009),
    [anon_sym_or_eq] = ACTIONS(4009),
    [anon_sym_xor_eq] = ACTIONS(4009),
    [anon_sym_LT_EQ_GT] = ACTIONS(4002),
    [anon_sym_or] = ACTIONS(4009),
    [anon_sym_and] = ACTIONS(4009),
    [anon_sym_bitor] = ACTIONS(4009),
    [anon_sym_xor] = ACTIONS(4009),
    [anon_sym_bitand] = ACTIONS(4009),
    [anon_sym_not_eq] = ACTIONS(4009),
    [anon_sym_DASH_DASH] = ACTIONS(4002),
    [anon_sym_PLUS_PLUS] = ACTIONS(4002),
    [anon_sym_DOT] = ACTIONS(4009),
    [anon_sym_DOT_STAR] = ACTIONS(4002),
    [anon_sym_DASH_GT] = ACTIONS(4002),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4000),
    [anon_sym_decltype] = ACTIONS(4000),
    [sym_virtual] = ACTIONS(4000),
    [anon_sym_template] = ACTIONS(4000),
    [anon_sym_operator] = ACTIONS(4000),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4002),
    [anon_sym___launch_bounds__] = ACTIONS(4000),
  },
  [989] = {
    [sym_expression] = STATE(3214),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym__unary_left_fold] = STATE(8360),
    [sym__unary_right_fold] = STATE(8359),
    [sym__binary_fold] = STATE(8354),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [990] = {
    [sym_identifier] = ACTIONS(4142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4144),
    [anon_sym_COMMA] = ACTIONS(4144),
    [anon_sym_RPAREN] = ACTIONS(4144),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_TILDE] = ACTIONS(4149),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_STAR] = ACTIONS(4153),
    [anon_sym_SLASH] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4151),
    [anon_sym_CARET] = ACTIONS(4151),
    [anon_sym_AMP] = ACTIONS(4153),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT] = ACTIONS(4151),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4151),
    [anon_sym_LT] = ACTIONS(4151),
    [anon_sym_LT_LT] = ACTIONS(4151),
    [anon_sym_GT_GT] = ACTIONS(4151),
    [anon_sym_SEMI] = ACTIONS(4144),
    [anon_sym___extension__] = ACTIONS(4142),
    [anon_sym___device__] = ACTIONS(4142),
    [anon_sym___host__] = ACTIONS(4142),
    [anon_sym___global__] = ACTIONS(4142),
    [anon_sym___forceinline__] = ACTIONS(4142),
    [anon_sym___noinline__] = ACTIONS(4142),
    [anon_sym_extern] = ACTIONS(4142),
    [anon_sym___attribute__] = ACTIONS(4142),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4149),
    [anon_sym___declspec] = ACTIONS(4142),
    [anon_sym___based] = ACTIONS(4142),
    [anon_sym_LBRACE] = ACTIONS(4149),
    [anon_sym_LBRACK] = ACTIONS(4153),
    [anon_sym_static] = ACTIONS(4142),
    [anon_sym_EQ] = ACTIONS(4151),
    [anon_sym_register] = ACTIONS(4142),
    [anon_sym_inline] = ACTIONS(4142),
    [anon_sym___inline] = ACTIONS(4142),
    [anon_sym___inline__] = ACTIONS(4142),
    [anon_sym___forceinline] = ACTIONS(4142),
    [anon_sym_thread_local] = ACTIONS(4142),
    [anon_sym___thread] = ACTIONS(4142),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_constexpr] = ACTIONS(4142),
    [anon_sym_volatile] = ACTIONS(4142),
    [anon_sym_restrict] = ACTIONS(4142),
    [anon_sym___restrict__] = ACTIONS(4142),
    [anon_sym__Atomic] = ACTIONS(4142),
    [anon_sym__Noreturn] = ACTIONS(4142),
    [anon_sym_noreturn] = ACTIONS(4142),
    [anon_sym_mutable] = ACTIONS(4142),
    [anon_sym_constinit] = ACTIONS(4142),
    [anon_sym_consteval] = ACTIONS(4142),
    [anon_sym___shared__] = ACTIONS(4142),
    [anon_sym___local__] = ACTIONS(4142),
    [anon_sym___constant__] = ACTIONS(4142),
    [anon_sym___managed__] = ACTIONS(4142),
    [anon_sym___grid_constant__] = ACTIONS(4142),
    [anon_sym_alignas] = ACTIONS(4142),
    [anon_sym__Alignas] = ACTIONS(4142),
    [anon_sym_QMARK] = ACTIONS(4144),
    [anon_sym_STAR_EQ] = ACTIONS(4144),
    [anon_sym_SLASH_EQ] = ACTIONS(4144),
    [anon_sym_PERCENT_EQ] = ACTIONS(4144),
    [anon_sym_PLUS_EQ] = ACTIONS(4144),
    [anon_sym_DASH_EQ] = ACTIONS(4144),
    [anon_sym_LT_LT_EQ] = ACTIONS(4144),
    [anon_sym_GT_GT_EQ] = ACTIONS(4144),
    [anon_sym_AMP_EQ] = ACTIONS(4144),
    [anon_sym_CARET_EQ] = ACTIONS(4144),
    [anon_sym_PIPE_EQ] = ACTIONS(4144),
    [anon_sym_and_eq] = ACTIONS(4151),
    [anon_sym_or_eq] = ACTIONS(4151),
    [anon_sym_xor_eq] = ACTIONS(4151),
    [anon_sym_LT_EQ_GT] = ACTIONS(4144),
    [anon_sym_or] = ACTIONS(4151),
    [anon_sym_and] = ACTIONS(4151),
    [anon_sym_bitor] = ACTIONS(4151),
    [anon_sym_xor] = ACTIONS(4151),
    [anon_sym_bitand] = ACTIONS(4151),
    [anon_sym_not_eq] = ACTIONS(4151),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_DOT_STAR] = ACTIONS(4144),
    [anon_sym_DASH_GT] = ACTIONS(4144),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4142),
    [anon_sym_decltype] = ACTIONS(4142),
    [sym_virtual] = ACTIONS(4142),
    [anon_sym_template] = ACTIONS(4142),
    [anon_sym_operator] = ACTIONS(4142),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4144),
    [anon_sym___launch_bounds__] = ACTIONS(4142),
  },
  [991] = {
    [sym_identifier] = ACTIONS(4142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_RPAREN] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_TILDE] = ACTIONS(4149),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_STAR] = ACTIONS(4153),
    [anon_sym_SLASH] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4151),
    [anon_sym_CARET] = ACTIONS(4151),
    [anon_sym_AMP] = ACTIONS(4153),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT] = ACTIONS(4151),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4151),
    [anon_sym_LT] = ACTIONS(4151),
    [anon_sym_LT_LT] = ACTIONS(4151),
    [anon_sym_GT_GT] = ACTIONS(4151),
    [anon_sym___extension__] = ACTIONS(4142),
    [anon_sym___device__] = ACTIONS(4142),
    [anon_sym___host__] = ACTIONS(4142),
    [anon_sym___global__] = ACTIONS(4142),
    [anon_sym___forceinline__] = ACTIONS(4142),
    [anon_sym___noinline__] = ACTIONS(4142),
    [anon_sym_extern] = ACTIONS(4142),
    [anon_sym___attribute__] = ACTIONS(4142),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4149),
    [anon_sym___declspec] = ACTIONS(4142),
    [anon_sym___based] = ACTIONS(4142),
    [anon_sym_LBRACE] = ACTIONS(4149),
    [anon_sym_LBRACK] = ACTIONS(4153),
    [anon_sym_static] = ACTIONS(4142),
    [anon_sym_EQ] = ACTIONS(4153),
    [anon_sym_register] = ACTIONS(4142),
    [anon_sym_inline] = ACTIONS(4142),
    [anon_sym___inline] = ACTIONS(4142),
    [anon_sym___inline__] = ACTIONS(4142),
    [anon_sym___forceinline] = ACTIONS(4142),
    [anon_sym_thread_local] = ACTIONS(4142),
    [anon_sym___thread] = ACTIONS(4142),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_constexpr] = ACTIONS(4142),
    [anon_sym_volatile] = ACTIONS(4142),
    [anon_sym_restrict] = ACTIONS(4142),
    [anon_sym___restrict__] = ACTIONS(4142),
    [anon_sym__Atomic] = ACTIONS(4142),
    [anon_sym__Noreturn] = ACTIONS(4142),
    [anon_sym_noreturn] = ACTIONS(4142),
    [anon_sym_mutable] = ACTIONS(4142),
    [anon_sym_constinit] = ACTIONS(4142),
    [anon_sym_consteval] = ACTIONS(4142),
    [anon_sym___shared__] = ACTIONS(4142),
    [anon_sym___local__] = ACTIONS(4142),
    [anon_sym___constant__] = ACTIONS(4142),
    [anon_sym___managed__] = ACTIONS(4142),
    [anon_sym___grid_constant__] = ACTIONS(4142),
    [anon_sym_alignas] = ACTIONS(4142),
    [anon_sym__Alignas] = ACTIONS(4142),
    [anon_sym_QMARK] = ACTIONS(4144),
    [anon_sym_STAR_EQ] = ACTIONS(4144),
    [anon_sym_SLASH_EQ] = ACTIONS(4144),
    [anon_sym_PERCENT_EQ] = ACTIONS(4144),
    [anon_sym_PLUS_EQ] = ACTIONS(4144),
    [anon_sym_DASH_EQ] = ACTIONS(4144),
    [anon_sym_LT_LT_EQ] = ACTIONS(4144),
    [anon_sym_GT_GT_EQ] = ACTIONS(4144),
    [anon_sym_AMP_EQ] = ACTIONS(4144),
    [anon_sym_CARET_EQ] = ACTIONS(4144),
    [anon_sym_PIPE_EQ] = ACTIONS(4144),
    [anon_sym_and_eq] = ACTIONS(4151),
    [anon_sym_or_eq] = ACTIONS(4151),
    [anon_sym_xor_eq] = ACTIONS(4151),
    [anon_sym_LT_EQ_GT] = ACTIONS(4144),
    [anon_sym_or] = ACTIONS(4151),
    [anon_sym_and] = ACTIONS(4151),
    [anon_sym_bitor] = ACTIONS(4151),
    [anon_sym_xor] = ACTIONS(4151),
    [anon_sym_bitand] = ACTIONS(4151),
    [anon_sym_not_eq] = ACTIONS(4151),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_DOT_STAR] = ACTIONS(4144),
    [anon_sym_DASH_GT] = ACTIONS(4151),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4142),
    [anon_sym_decltype] = ACTIONS(4142),
    [sym_virtual] = ACTIONS(4142),
    [anon_sym_template] = ACTIONS(4142),
    [anon_sym_operator] = ACTIONS(4142),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4144),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4144),
    [anon_sym___launch_bounds__] = ACTIONS(4142),
  },
  [992] = {
    [sym_expression] = STATE(4824),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8373),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(8373),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4335),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [993] = {
    [sym_expression] = STATE(3368),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym__unary_left_fold] = STATE(8813),
    [sym__unary_right_fold] = STATE(8812),
    [sym__binary_fold] = STATE(8808),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [994] = {
    [sym_expression] = STATE(4797),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8435),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(8435),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4337),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [995] = {
    [sym_expression] = STATE(4985),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8663),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(8663),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4339),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [996] = {
    [sym_identifier] = ACTIONS(3996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3998),
    [anon_sym_COMMA] = ACTIONS(3998),
    [anon_sym_RPAREN] = ACTIONS(3998),
    [anon_sym_LPAREN2] = ACTIONS(3998),
    [anon_sym_TILDE] = ACTIONS(3998),
    [anon_sym_DASH] = ACTIONS(3996),
    [anon_sym_PLUS] = ACTIONS(3996),
    [anon_sym_STAR] = ACTIONS(3996),
    [anon_sym_SLASH] = ACTIONS(3996),
    [anon_sym_PERCENT] = ACTIONS(3996),
    [anon_sym_PIPE_PIPE] = ACTIONS(3998),
    [anon_sym_AMP_AMP] = ACTIONS(3998),
    [anon_sym_PIPE] = ACTIONS(3996),
    [anon_sym_CARET] = ACTIONS(3996),
    [anon_sym_AMP] = ACTIONS(3996),
    [anon_sym_EQ_EQ] = ACTIONS(3998),
    [anon_sym_BANG_EQ] = ACTIONS(3998),
    [anon_sym_GT] = ACTIONS(3996),
    [anon_sym_GT_EQ] = ACTIONS(3998),
    [anon_sym_LT_EQ] = ACTIONS(3996),
    [anon_sym_LT] = ACTIONS(3996),
    [anon_sym_LT_LT] = ACTIONS(3996),
    [anon_sym_GT_GT] = ACTIONS(3996),
    [anon_sym___extension__] = ACTIONS(3996),
    [anon_sym___device__] = ACTIONS(3996),
    [anon_sym___host__] = ACTIONS(3996),
    [anon_sym___global__] = ACTIONS(3996),
    [anon_sym___forceinline__] = ACTIONS(3996),
    [anon_sym___noinline__] = ACTIONS(3996),
    [anon_sym_extern] = ACTIONS(3996),
    [anon_sym___attribute__] = ACTIONS(3996),
    [anon_sym_COLON_COLON] = ACTIONS(3998),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3998),
    [anon_sym___declspec] = ACTIONS(3996),
    [anon_sym___based] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(3998),
    [anon_sym_LBRACK] = ACTIONS(3996),
    [anon_sym_static] = ACTIONS(3996),
    [anon_sym_EQ] = ACTIONS(3996),
    [anon_sym_register] = ACTIONS(3996),
    [anon_sym_inline] = ACTIONS(3996),
    [anon_sym___inline] = ACTIONS(3996),
    [anon_sym___inline__] = ACTIONS(3996),
    [anon_sym___forceinline] = ACTIONS(3996),
    [anon_sym_thread_local] = ACTIONS(3996),
    [anon_sym___thread] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3996),
    [anon_sym_constexpr] = ACTIONS(3996),
    [anon_sym_volatile] = ACTIONS(3996),
    [anon_sym_restrict] = ACTIONS(3996),
    [anon_sym___restrict__] = ACTIONS(3996),
    [anon_sym__Atomic] = ACTIONS(3996),
    [anon_sym__Noreturn] = ACTIONS(3996),
    [anon_sym_noreturn] = ACTIONS(3996),
    [anon_sym_mutable] = ACTIONS(3996),
    [anon_sym_constinit] = ACTIONS(3996),
    [anon_sym_consteval] = ACTIONS(3996),
    [anon_sym___shared__] = ACTIONS(3996),
    [anon_sym___local__] = ACTIONS(3996),
    [anon_sym___constant__] = ACTIONS(3996),
    [anon_sym___managed__] = ACTIONS(3996),
    [anon_sym___grid_constant__] = ACTIONS(3996),
    [anon_sym_alignas] = ACTIONS(3996),
    [anon_sym__Alignas] = ACTIONS(3996),
    [anon_sym_QMARK] = ACTIONS(3998),
    [anon_sym_STAR_EQ] = ACTIONS(3998),
    [anon_sym_SLASH_EQ] = ACTIONS(3998),
    [anon_sym_PERCENT_EQ] = ACTIONS(3998),
    [anon_sym_PLUS_EQ] = ACTIONS(3998),
    [anon_sym_DASH_EQ] = ACTIONS(3998),
    [anon_sym_LT_LT_EQ] = ACTIONS(3998),
    [anon_sym_GT_GT_EQ] = ACTIONS(3998),
    [anon_sym_AMP_EQ] = ACTIONS(3998),
    [anon_sym_CARET_EQ] = ACTIONS(3998),
    [anon_sym_PIPE_EQ] = ACTIONS(3998),
    [anon_sym_and_eq] = ACTIONS(3996),
    [anon_sym_or_eq] = ACTIONS(3996),
    [anon_sym_xor_eq] = ACTIONS(3996),
    [anon_sym_LT_EQ_GT] = ACTIONS(3998),
    [anon_sym_or] = ACTIONS(3996),
    [anon_sym_and] = ACTIONS(3996),
    [anon_sym_bitor] = ACTIONS(3996),
    [anon_sym_xor] = ACTIONS(3996),
    [anon_sym_bitand] = ACTIONS(3996),
    [anon_sym_not_eq] = ACTIONS(3996),
    [anon_sym_DASH_DASH] = ACTIONS(3998),
    [anon_sym_PLUS_PLUS] = ACTIONS(3998),
    [anon_sym_DOT] = ACTIONS(3996),
    [anon_sym_DOT_STAR] = ACTIONS(3998),
    [anon_sym_DASH_GT] = ACTIONS(3996),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3996),
    [anon_sym_decltype] = ACTIONS(3996),
    [sym_virtual] = ACTIONS(3996),
    [anon_sym_template] = ACTIONS(3996),
    [anon_sym_operator] = ACTIONS(3996),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3998),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3998),
    [anon_sym___launch_bounds__] = ACTIONS(3996),
  },
  [997] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4343),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [998] = {
    [sym_expression] = STATE(3343),
    [sym__string] = STATE(3926),
    [sym_conditional_expression] = STATE(3926),
    [sym_assignment_expression] = STATE(3926),
    [sym_pointer_expression] = STATE(3934),
    [sym_unary_expression] = STATE(3926),
    [sym_binary_expression] = STATE(3926),
    [sym_update_expression] = STATE(3926),
    [sym_cast_expression] = STATE(3926),
    [sym_sizeof_expression] = STATE(3926),
    [sym_alignof_expression] = STATE(3926),
    [sym_offsetof_expression] = STATE(3926),
    [sym_generic_expression] = STATE(3926),
    [sym_subscript_expression] = STATE(3934),
    [sym_call_expression] = STATE(3934),
    [sym_gnu_asm_expression] = STATE(3926),
    [sym_field_expression] = STATE(3934),
    [sym_compound_literal_expression] = STATE(3926),
    [sym_parenthesized_expression] = STATE(3934),
    [sym_char_literal] = STATE(3755),
    [sym_concatenated_string] = STATE(3759),
    [sym_string_literal] = STATE(2463),
    [sym_null] = STATE(3926),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7876),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3926),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3926),
    [sym_new_expression] = STATE(3926),
    [sym_delete_expression] = STATE(3926),
    [sym_requires_clause] = STATE(3926),
    [sym_requires_expression] = STATE(3926),
    [sym_lambda_expression] = STATE(3926),
    [sym_lambda_capture_specifier] = STATE(6169),
    [sym_fold_expression] = STATE(3926),
    [sym_parameter_pack_expansion] = STATE(3926),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3934),
    [sym_qualified_type_identifier] = STATE(7876),
    [sym_user_defined_literal] = STATE(3934),
    [sym_kernel_call_expression] = STATE(3930),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(3291),
    [anon_sym_not] = ACTIONS(3283),
    [anon_sym_compl] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(4351),
    [anon_sym_PLUS_PLUS] = ACTIONS(4351),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3295),
    [anon_sym___alignof] = ACTIONS(3295),
    [anon_sym__alignof] = ACTIONS(3295),
    [anon_sym_alignof] = ACTIONS(3295),
    [anon_sym__Alignof] = ACTIONS(3295),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3299),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [sym_number_literal] = ACTIONS(3303),
    [anon_sym_L_SQUOTE] = ACTIONS(3305),
    [anon_sym_u_SQUOTE] = ACTIONS(3305),
    [anon_sym_U_SQUOTE] = ACTIONS(3305),
    [anon_sym_u8_SQUOTE] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_L_DQUOTE] = ACTIONS(3307),
    [anon_sym_u_DQUOTE] = ACTIONS(3307),
    [anon_sym_U_DQUOTE] = ACTIONS(3307),
    [anon_sym_u8_DQUOTE] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [anon_sym_NULL] = ACTIONS(3311),
    [anon_sym_nullptr] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_R_DQUOTE] = ACTIONS(3315),
    [anon_sym_LR_DQUOTE] = ACTIONS(3315),
    [anon_sym_uR_DQUOTE] = ACTIONS(3315),
    [anon_sym_UR_DQUOTE] = ACTIONS(3315),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3315),
    [anon_sym_co_await] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_requires] = ACTIONS(3321),
    [sym_this] = ACTIONS(3309),
  },
  [999] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4353),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1000] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4355),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1001] = {
    [sym_expression] = STATE(3241),
    [sym__string] = STATE(3860),
    [sym_conditional_expression] = STATE(3860),
    [sym_assignment_expression] = STATE(3860),
    [sym_pointer_expression] = STATE(3861),
    [sym_unary_expression] = STATE(3860),
    [sym_binary_expression] = STATE(3860),
    [sym_update_expression] = STATE(3860),
    [sym_cast_expression] = STATE(3860),
    [sym_sizeof_expression] = STATE(3860),
    [sym_alignof_expression] = STATE(3860),
    [sym_offsetof_expression] = STATE(3860),
    [sym_generic_expression] = STATE(3860),
    [sym_subscript_expression] = STATE(3861),
    [sym_call_expression] = STATE(3861),
    [sym_gnu_asm_expression] = STATE(3860),
    [sym_field_expression] = STATE(3861),
    [sym_compound_literal_expression] = STATE(3860),
    [sym_parenthesized_expression] = STATE(3861),
    [sym_char_literal] = STATE(3831),
    [sym_concatenated_string] = STATE(3833),
    [sym_string_literal] = STATE(2490),
    [sym_null] = STATE(3860),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7980),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3860),
    [sym_raw_string_literal] = STATE(2516),
    [sym_co_await_expression] = STATE(3860),
    [sym_new_expression] = STATE(3860),
    [sym_delete_expression] = STATE(3860),
    [sym_requires_clause] = STATE(3860),
    [sym_requires_expression] = STATE(3860),
    [sym_lambda_expression] = STATE(3860),
    [sym_lambda_capture_specifier] = STATE(6189),
    [sym_fold_expression] = STATE(3860),
    [sym_parameter_pack_expansion] = STATE(3860),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3861),
    [sym_qualified_type_identifier] = STATE(7980),
    [sym_user_defined_literal] = STATE(3861),
    [sym_kernel_call_expression] = STATE(3851),
    [sym_identifier] = ACTIONS(3179),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(3185),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(3189),
    [anon_sym_not] = ACTIONS(3181),
    [anon_sym_compl] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(4357),
    [anon_sym_PLUS_PLUS] = ACTIONS(4357),
    [anon_sym_sizeof] = ACTIONS(3191),
    [anon_sym___alignof__] = ACTIONS(3193),
    [anon_sym___alignof] = ACTIONS(3193),
    [anon_sym__alignof] = ACTIONS(3193),
    [anon_sym_alignof] = ACTIONS(3193),
    [anon_sym__Alignof] = ACTIONS(3193),
    [anon_sym_offsetof] = ACTIONS(3195),
    [anon_sym__Generic] = ACTIONS(3197),
    [anon_sym_asm] = ACTIONS(3199),
    [anon_sym___asm__] = ACTIONS(3199),
    [sym_number_literal] = ACTIONS(3201),
    [anon_sym_L_SQUOTE] = ACTIONS(3203),
    [anon_sym_u_SQUOTE] = ACTIONS(3203),
    [anon_sym_U_SQUOTE] = ACTIONS(3203),
    [anon_sym_u8_SQUOTE] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [anon_sym_L_DQUOTE] = ACTIONS(3205),
    [anon_sym_u_DQUOTE] = ACTIONS(3205),
    [anon_sym_U_DQUOTE] = ACTIONS(3205),
    [anon_sym_u8_DQUOTE] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [anon_sym_NULL] = ACTIONS(3209),
    [anon_sym_nullptr] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_R_DQUOTE] = ACTIONS(3213),
    [anon_sym_LR_DQUOTE] = ACTIONS(3213),
    [anon_sym_uR_DQUOTE] = ACTIONS(3213),
    [anon_sym_UR_DQUOTE] = ACTIONS(3213),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3213),
    [anon_sym_co_await] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_requires] = ACTIONS(3219),
    [sym_this] = ACTIONS(3207),
  },
  [1002] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4359),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1003] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(4361),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4363),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1004] = {
    [sym_expression] = STATE(3467),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(3335),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(3331),
    [anon_sym_compl] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(4365),
    [anon_sym_PLUS_PLUS] = ACTIONS(4365),
    [anon_sym_sizeof] = ACTIONS(3337),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3339),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1005] = {
    [sym_expression] = STATE(2983),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1006] = {
    [sym_expression] = STATE(3479),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(3335),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(3331),
    [anon_sym_compl] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(4365),
    [anon_sym_PLUS_PLUS] = ACTIONS(4365),
    [anon_sym_sizeof] = ACTIONS(3337),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3339),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1007] = {
    [sym_expression] = STATE(4540),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1008] = {
    [sym_expression] = STATE(4889),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8015),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(8015),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(3754),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [1009] = {
    [sym_expression] = STATE(4637),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1010] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4367),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1011] = {
    [sym_expression] = STATE(3724),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1012] = {
    [sym_identifier] = ACTIONS(4142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_RPAREN] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_TILDE] = ACTIONS(4149),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_STAR] = ACTIONS(4153),
    [anon_sym_SLASH] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4151),
    [anon_sym_CARET] = ACTIONS(4151),
    [anon_sym_AMP] = ACTIONS(4153),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT] = ACTIONS(4151),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4151),
    [anon_sym_LT] = ACTIONS(4151),
    [anon_sym_LT_LT] = ACTIONS(4151),
    [anon_sym_GT_GT] = ACTIONS(4151),
    [anon_sym___extension__] = ACTIONS(4142),
    [anon_sym___device__] = ACTIONS(4142),
    [anon_sym___host__] = ACTIONS(4142),
    [anon_sym___global__] = ACTIONS(4142),
    [anon_sym___forceinline__] = ACTIONS(4142),
    [anon_sym___noinline__] = ACTIONS(4142),
    [anon_sym_extern] = ACTIONS(4142),
    [anon_sym___attribute__] = ACTIONS(4142),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4149),
    [anon_sym___declspec] = ACTIONS(4142),
    [anon_sym___based] = ACTIONS(4142),
    [anon_sym_LBRACE] = ACTIONS(4149),
    [anon_sym_LBRACK] = ACTIONS(4153),
    [anon_sym_static] = ACTIONS(4142),
    [anon_sym_EQ] = ACTIONS(4153),
    [anon_sym_register] = ACTIONS(4142),
    [anon_sym_inline] = ACTIONS(4142),
    [anon_sym___inline] = ACTIONS(4142),
    [anon_sym___inline__] = ACTIONS(4142),
    [anon_sym___forceinline] = ACTIONS(4142),
    [anon_sym_thread_local] = ACTIONS(4142),
    [anon_sym___thread] = ACTIONS(4142),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_constexpr] = ACTIONS(4142),
    [anon_sym_volatile] = ACTIONS(4142),
    [anon_sym_restrict] = ACTIONS(4142),
    [anon_sym___restrict__] = ACTIONS(4142),
    [anon_sym__Atomic] = ACTIONS(4142),
    [anon_sym__Noreturn] = ACTIONS(4142),
    [anon_sym_noreturn] = ACTIONS(4142),
    [anon_sym_mutable] = ACTIONS(4142),
    [anon_sym_constinit] = ACTIONS(4142),
    [anon_sym_consteval] = ACTIONS(4142),
    [anon_sym___shared__] = ACTIONS(4142),
    [anon_sym___local__] = ACTIONS(4142),
    [anon_sym___constant__] = ACTIONS(4142),
    [anon_sym___managed__] = ACTIONS(4142),
    [anon_sym___grid_constant__] = ACTIONS(4142),
    [anon_sym_alignas] = ACTIONS(4142),
    [anon_sym__Alignas] = ACTIONS(4142),
    [anon_sym_QMARK] = ACTIONS(4144),
    [anon_sym_STAR_EQ] = ACTIONS(4144),
    [anon_sym_SLASH_EQ] = ACTIONS(4144),
    [anon_sym_PERCENT_EQ] = ACTIONS(4144),
    [anon_sym_PLUS_EQ] = ACTIONS(4144),
    [anon_sym_DASH_EQ] = ACTIONS(4144),
    [anon_sym_LT_LT_EQ] = ACTIONS(4144),
    [anon_sym_GT_GT_EQ] = ACTIONS(4144),
    [anon_sym_AMP_EQ] = ACTIONS(4144),
    [anon_sym_CARET_EQ] = ACTIONS(4144),
    [anon_sym_PIPE_EQ] = ACTIONS(4144),
    [anon_sym_and_eq] = ACTIONS(4151),
    [anon_sym_or_eq] = ACTIONS(4151),
    [anon_sym_xor_eq] = ACTIONS(4151),
    [anon_sym_LT_EQ_GT] = ACTIONS(4144),
    [anon_sym_or] = ACTIONS(4151),
    [anon_sym_and] = ACTIONS(4151),
    [anon_sym_bitor] = ACTIONS(4151),
    [anon_sym_xor] = ACTIONS(4151),
    [anon_sym_bitand] = ACTIONS(4151),
    [anon_sym_not_eq] = ACTIONS(4151),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_DOT_STAR] = ACTIONS(4144),
    [anon_sym_DASH_GT] = ACTIONS(4144),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4142),
    [anon_sym_decltype] = ACTIONS(4142),
    [sym_virtual] = ACTIONS(4142),
    [anon_sym_template] = ACTIONS(4142),
    [anon_sym_operator] = ACTIONS(4142),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4144),
    [anon_sym___launch_bounds__] = ACTIONS(4142),
  },
  [1013] = {
    [sym_expression] = STATE(4949),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8015),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(8015),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(3754),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [1014] = {
    [sym_expression] = STATE(4627),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_initializer_list] = STATE(7622),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4369),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1015] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4371),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1016] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4373),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1017] = {
    [sym_expression] = STATE(4661),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1018] = {
    [sym_expression] = STATE(5039),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(8750),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4375),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1019] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4378),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1020] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4380),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1021] = {
    [sym_expression] = STATE(5039),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(8750),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4382),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1022] = {
    [sym_expression] = STATE(5039),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(8750),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4385),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1023] = {
    [sym_expression] = STATE(5039),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(8750),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4388),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1024] = {
    [sym_expression] = STATE(5039),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(8750),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4391),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1025] = {
    [sym_expression] = STATE(5039),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(8750),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4394),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1026] = {
    [sym_expression] = STATE(5039),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(8750),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4397),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1027] = {
    [sym_expression] = STATE(4737),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1028] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4400),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1029] = {
    [sym_expression] = STATE(4944),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1030] = {
    [sym_expression] = STATE(5039),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(8750),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4402),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1031] = {
    [sym_identifier] = ACTIONS(4017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4019),
    [anon_sym_COMMA] = ACTIONS(4019),
    [anon_sym_RPAREN] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(4019),
    [anon_sym_TILDE] = ACTIONS(4019),
    [anon_sym_DASH] = ACTIONS(4017),
    [anon_sym_PLUS] = ACTIONS(4017),
    [anon_sym_STAR] = ACTIONS(4019),
    [anon_sym_SLASH] = ACTIONS(4017),
    [anon_sym_PERCENT] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE] = ACTIONS(4017),
    [anon_sym_CARET] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4017),
    [anon_sym_EQ_EQ] = ACTIONS(4019),
    [anon_sym_BANG_EQ] = ACTIONS(4019),
    [anon_sym_GT] = ACTIONS(4017),
    [anon_sym_GT_EQ] = ACTIONS(4019),
    [anon_sym_LT_EQ] = ACTIONS(4017),
    [anon_sym_LT] = ACTIONS(4017),
    [anon_sym_LT_LT] = ACTIONS(4017),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4019),
    [anon_sym___extension__] = ACTIONS(4017),
    [anon_sym___device__] = ACTIONS(4017),
    [anon_sym___host__] = ACTIONS(4017),
    [anon_sym___global__] = ACTIONS(4017),
    [anon_sym___forceinline__] = ACTIONS(4017),
    [anon_sym___noinline__] = ACTIONS(4017),
    [anon_sym_extern] = ACTIONS(4017),
    [anon_sym___attribute__] = ACTIONS(4017),
    [anon_sym_COLON_COLON] = ACTIONS(4019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4019),
    [anon_sym___declspec] = ACTIONS(4017),
    [anon_sym___based] = ACTIONS(4017),
    [anon_sym___cdecl] = ACTIONS(4017),
    [anon_sym___clrcall] = ACTIONS(4017),
    [anon_sym___stdcall] = ACTIONS(4017),
    [anon_sym___fastcall] = ACTIONS(4017),
    [anon_sym___thiscall] = ACTIONS(4017),
    [anon_sym___vectorcall] = ACTIONS(4017),
    [anon_sym_LBRACE] = ACTIONS(4019),
    [anon_sym_RBRACE] = ACTIONS(4019),
    [anon_sym_LBRACK] = ACTIONS(4017),
    [anon_sym_static] = ACTIONS(4017),
    [anon_sym_EQ] = ACTIONS(4017),
    [anon_sym_register] = ACTIONS(4017),
    [anon_sym_inline] = ACTIONS(4017),
    [anon_sym___inline] = ACTIONS(4017),
    [anon_sym___inline__] = ACTIONS(4017),
    [anon_sym___forceinline] = ACTIONS(4017),
    [anon_sym_thread_local] = ACTIONS(4017),
    [anon_sym___thread] = ACTIONS(4017),
    [anon_sym_const] = ACTIONS(4017),
    [anon_sym_constexpr] = ACTIONS(4017),
    [anon_sym_volatile] = ACTIONS(4017),
    [anon_sym_restrict] = ACTIONS(4017),
    [anon_sym___restrict__] = ACTIONS(4017),
    [anon_sym__Atomic] = ACTIONS(4017),
    [anon_sym__Noreturn] = ACTIONS(4017),
    [anon_sym_noreturn] = ACTIONS(4017),
    [anon_sym_mutable] = ACTIONS(4017),
    [anon_sym_constinit] = ACTIONS(4017),
    [anon_sym_consteval] = ACTIONS(4017),
    [anon_sym___shared__] = ACTIONS(4017),
    [anon_sym___local__] = ACTIONS(4017),
    [anon_sym___constant__] = ACTIONS(4017),
    [anon_sym___managed__] = ACTIONS(4017),
    [anon_sym___grid_constant__] = ACTIONS(4017),
    [anon_sym_alignas] = ACTIONS(4017),
    [anon_sym__Alignas] = ACTIONS(4017),
    [anon_sym_COLON] = ACTIONS(4017),
    [anon_sym_QMARK] = ACTIONS(4019),
    [anon_sym_LT_EQ_GT] = ACTIONS(4019),
    [anon_sym_or] = ACTIONS(4017),
    [anon_sym_and] = ACTIONS(4017),
    [anon_sym_bitor] = ACTIONS(4017),
    [anon_sym_xor] = ACTIONS(4017),
    [anon_sym_bitand] = ACTIONS(4017),
    [anon_sym_not_eq] = ACTIONS(4017),
    [anon_sym_DASH_DASH] = ACTIONS(4019),
    [anon_sym_PLUS_PLUS] = ACTIONS(4019),
    [anon_sym_DOT] = ACTIONS(4017),
    [anon_sym_DOT_STAR] = ACTIONS(4019),
    [anon_sym_DASH_GT] = ACTIONS(4019),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4017),
    [anon_sym_decltype] = ACTIONS(4017),
    [anon_sym_final] = ACTIONS(4017),
    [anon_sym_override] = ACTIONS(4017),
    [sym_virtual] = ACTIONS(4017),
    [anon_sym_template] = ACTIONS(4017),
    [anon_sym_operator] = ACTIONS(4017),
    [anon_sym_try] = ACTIONS(4017),
    [anon_sym_requires] = ACTIONS(4017),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4019),
    [anon_sym___launch_bounds__] = ACTIONS(4017),
  },
  [1032] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4405),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1033] = {
    [sym_expression] = STATE(2947),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1034] = {
    [sym_identifier] = ACTIONS(4021),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_RPAREN] = ACTIONS(4023),
    [anon_sym_LPAREN2] = ACTIONS(4023),
    [anon_sym_TILDE] = ACTIONS(4023),
    [anon_sym_DASH] = ACTIONS(4021),
    [anon_sym_PLUS] = ACTIONS(4021),
    [anon_sym_STAR] = ACTIONS(4023),
    [anon_sym_SLASH] = ACTIONS(4021),
    [anon_sym_PERCENT] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4023),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_CARET] = ACTIONS(4023),
    [anon_sym_AMP] = ACTIONS(4021),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4021),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4023),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym___extension__] = ACTIONS(4021),
    [anon_sym___device__] = ACTIONS(4021),
    [anon_sym___host__] = ACTIONS(4021),
    [anon_sym___global__] = ACTIONS(4021),
    [anon_sym___forceinline__] = ACTIONS(4021),
    [anon_sym___noinline__] = ACTIONS(4021),
    [anon_sym_extern] = ACTIONS(4021),
    [anon_sym___attribute__] = ACTIONS(4021),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4023),
    [anon_sym___declspec] = ACTIONS(4021),
    [anon_sym___based] = ACTIONS(4021),
    [anon_sym___cdecl] = ACTIONS(4021),
    [anon_sym___clrcall] = ACTIONS(4021),
    [anon_sym___stdcall] = ACTIONS(4021),
    [anon_sym___fastcall] = ACTIONS(4021),
    [anon_sym___thiscall] = ACTIONS(4021),
    [anon_sym___vectorcall] = ACTIONS(4021),
    [anon_sym_LBRACE] = ACTIONS(4023),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_LBRACK] = ACTIONS(4021),
    [anon_sym_static] = ACTIONS(4021),
    [anon_sym_EQ] = ACTIONS(4021),
    [anon_sym_register] = ACTIONS(4021),
    [anon_sym_inline] = ACTIONS(4021),
    [anon_sym___inline] = ACTIONS(4021),
    [anon_sym___inline__] = ACTIONS(4021),
    [anon_sym___forceinline] = ACTIONS(4021),
    [anon_sym_thread_local] = ACTIONS(4021),
    [anon_sym___thread] = ACTIONS(4021),
    [anon_sym_const] = ACTIONS(4021),
    [anon_sym_constexpr] = ACTIONS(4021),
    [anon_sym_volatile] = ACTIONS(4021),
    [anon_sym_restrict] = ACTIONS(4021),
    [anon_sym___restrict__] = ACTIONS(4021),
    [anon_sym__Atomic] = ACTIONS(4021),
    [anon_sym__Noreturn] = ACTIONS(4021),
    [anon_sym_noreturn] = ACTIONS(4021),
    [anon_sym_mutable] = ACTIONS(4021),
    [anon_sym_constinit] = ACTIONS(4021),
    [anon_sym_consteval] = ACTIONS(4021),
    [anon_sym___shared__] = ACTIONS(4021),
    [anon_sym___local__] = ACTIONS(4021),
    [anon_sym___constant__] = ACTIONS(4021),
    [anon_sym___managed__] = ACTIONS(4021),
    [anon_sym___grid_constant__] = ACTIONS(4021),
    [anon_sym_alignas] = ACTIONS(4021),
    [anon_sym__Alignas] = ACTIONS(4021),
    [anon_sym_COLON] = ACTIONS(4021),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_LT_EQ_GT] = ACTIONS(4023),
    [anon_sym_or] = ACTIONS(4021),
    [anon_sym_and] = ACTIONS(4021),
    [anon_sym_bitor] = ACTIONS(4021),
    [anon_sym_xor] = ACTIONS(4021),
    [anon_sym_bitand] = ACTIONS(4021),
    [anon_sym_not_eq] = ACTIONS(4021),
    [anon_sym_DASH_DASH] = ACTIONS(4023),
    [anon_sym_PLUS_PLUS] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4021),
    [anon_sym_DOT_STAR] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4021),
    [anon_sym_decltype] = ACTIONS(4021),
    [anon_sym_final] = ACTIONS(4021),
    [anon_sym_override] = ACTIONS(4021),
    [sym_virtual] = ACTIONS(4021),
    [anon_sym_template] = ACTIONS(4021),
    [anon_sym_operator] = ACTIONS(4021),
    [anon_sym_try] = ACTIONS(4021),
    [anon_sym_requires] = ACTIONS(4021),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4023),
    [anon_sym___launch_bounds__] = ACTIONS(4021),
  },
  [1035] = {
    [sym_expression] = STATE(5039),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(8750),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4407),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1036] = {
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3994),
    [anon_sym_COMMA] = ACTIONS(3994),
    [anon_sym_RPAREN] = ACTIONS(3994),
    [anon_sym_LPAREN2] = ACTIONS(3994),
    [anon_sym_TILDE] = ACTIONS(3994),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_STAR] = ACTIONS(3994),
    [anon_sym_SLASH] = ACTIONS(3992),
    [anon_sym_PERCENT] = ACTIONS(3994),
    [anon_sym_PIPE_PIPE] = ACTIONS(3994),
    [anon_sym_AMP_AMP] = ACTIONS(3994),
    [anon_sym_PIPE] = ACTIONS(3992),
    [anon_sym_CARET] = ACTIONS(3994),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym_EQ_EQ] = ACTIONS(3994),
    [anon_sym_BANG_EQ] = ACTIONS(3994),
    [anon_sym_GT] = ACTIONS(3992),
    [anon_sym_GT_EQ] = ACTIONS(3994),
    [anon_sym_LT_EQ] = ACTIONS(3992),
    [anon_sym_LT] = ACTIONS(3992),
    [anon_sym_LT_LT] = ACTIONS(3992),
    [anon_sym_GT_GT] = ACTIONS(3994),
    [anon_sym_SEMI] = ACTIONS(3994),
    [anon_sym___extension__] = ACTIONS(3992),
    [anon_sym___device__] = ACTIONS(3992),
    [anon_sym___host__] = ACTIONS(3992),
    [anon_sym___global__] = ACTIONS(3992),
    [anon_sym___forceinline__] = ACTIONS(3992),
    [anon_sym___noinline__] = ACTIONS(3992),
    [anon_sym_extern] = ACTIONS(3992),
    [anon_sym___attribute__] = ACTIONS(3992),
    [anon_sym_COLON_COLON] = ACTIONS(3994),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3994),
    [anon_sym___declspec] = ACTIONS(3992),
    [anon_sym___based] = ACTIONS(3992),
    [anon_sym___cdecl] = ACTIONS(3992),
    [anon_sym___clrcall] = ACTIONS(3992),
    [anon_sym___stdcall] = ACTIONS(3992),
    [anon_sym___fastcall] = ACTIONS(3992),
    [anon_sym___thiscall] = ACTIONS(3992),
    [anon_sym___vectorcall] = ACTIONS(3992),
    [anon_sym_LBRACE] = ACTIONS(3994),
    [anon_sym_RBRACE] = ACTIONS(3994),
    [anon_sym_LBRACK] = ACTIONS(3992),
    [anon_sym_static] = ACTIONS(3992),
    [anon_sym_EQ] = ACTIONS(3992),
    [anon_sym_register] = ACTIONS(3992),
    [anon_sym_inline] = ACTIONS(3992),
    [anon_sym___inline] = ACTIONS(3992),
    [anon_sym___inline__] = ACTIONS(3992),
    [anon_sym___forceinline] = ACTIONS(3992),
    [anon_sym_thread_local] = ACTIONS(3992),
    [anon_sym___thread] = ACTIONS(3992),
    [anon_sym_const] = ACTIONS(3992),
    [anon_sym_constexpr] = ACTIONS(3992),
    [anon_sym_volatile] = ACTIONS(3992),
    [anon_sym_restrict] = ACTIONS(3992),
    [anon_sym___restrict__] = ACTIONS(3992),
    [anon_sym__Atomic] = ACTIONS(3992),
    [anon_sym__Noreturn] = ACTIONS(3992),
    [anon_sym_noreturn] = ACTIONS(3992),
    [anon_sym_mutable] = ACTIONS(3992),
    [anon_sym_constinit] = ACTIONS(3992),
    [anon_sym_consteval] = ACTIONS(3992),
    [anon_sym___shared__] = ACTIONS(3992),
    [anon_sym___local__] = ACTIONS(3992),
    [anon_sym___constant__] = ACTIONS(3992),
    [anon_sym___managed__] = ACTIONS(3992),
    [anon_sym___grid_constant__] = ACTIONS(3992),
    [anon_sym_alignas] = ACTIONS(3992),
    [anon_sym__Alignas] = ACTIONS(3992),
    [anon_sym_COLON] = ACTIONS(3992),
    [anon_sym_QMARK] = ACTIONS(3994),
    [anon_sym_LT_EQ_GT] = ACTIONS(3994),
    [anon_sym_or] = ACTIONS(3992),
    [anon_sym_and] = ACTIONS(3992),
    [anon_sym_bitor] = ACTIONS(3992),
    [anon_sym_xor] = ACTIONS(3992),
    [anon_sym_bitand] = ACTIONS(3992),
    [anon_sym_not_eq] = ACTIONS(3992),
    [anon_sym_DASH_DASH] = ACTIONS(3994),
    [anon_sym_PLUS_PLUS] = ACTIONS(3994),
    [anon_sym_DOT] = ACTIONS(3992),
    [anon_sym_DOT_STAR] = ACTIONS(3994),
    [anon_sym_DASH_GT] = ACTIONS(3994),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3992),
    [anon_sym_decltype] = ACTIONS(3992),
    [anon_sym_final] = ACTIONS(3992),
    [anon_sym_override] = ACTIONS(3992),
    [sym_virtual] = ACTIONS(3992),
    [anon_sym_template] = ACTIONS(3992),
    [anon_sym_operator] = ACTIONS(3992),
    [anon_sym_try] = ACTIONS(3992),
    [anon_sym_requires] = ACTIONS(3992),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3994),
    [anon_sym___launch_bounds__] = ACTIONS(3992),
  },
  [1037] = {
    [sym_expression] = STATE(3339),
    [sym__string] = STATE(3926),
    [sym_conditional_expression] = STATE(3926),
    [sym_assignment_expression] = STATE(3926),
    [sym_pointer_expression] = STATE(3934),
    [sym_unary_expression] = STATE(3926),
    [sym_binary_expression] = STATE(3926),
    [sym_update_expression] = STATE(3926),
    [sym_cast_expression] = STATE(3926),
    [sym_sizeof_expression] = STATE(3926),
    [sym_alignof_expression] = STATE(3926),
    [sym_offsetof_expression] = STATE(3926),
    [sym_generic_expression] = STATE(3926),
    [sym_subscript_expression] = STATE(3934),
    [sym_call_expression] = STATE(3934),
    [sym_gnu_asm_expression] = STATE(3926),
    [sym_field_expression] = STATE(3934),
    [sym_compound_literal_expression] = STATE(3926),
    [sym_parenthesized_expression] = STATE(3934),
    [sym_char_literal] = STATE(3755),
    [sym_concatenated_string] = STATE(3759),
    [sym_string_literal] = STATE(2463),
    [sym_null] = STATE(3926),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7876),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3926),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3926),
    [sym_new_expression] = STATE(3926),
    [sym_delete_expression] = STATE(3926),
    [sym_requires_clause] = STATE(3926),
    [sym_requires_expression] = STATE(3926),
    [sym_lambda_expression] = STATE(3926),
    [sym_lambda_capture_specifier] = STATE(6169),
    [sym_fold_expression] = STATE(3926),
    [sym_parameter_pack_expansion] = STATE(3926),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3934),
    [sym_qualified_type_identifier] = STATE(7876),
    [sym_user_defined_literal] = STATE(3934),
    [sym_kernel_call_expression] = STATE(3930),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(3291),
    [anon_sym_not] = ACTIONS(3283),
    [anon_sym_compl] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(4351),
    [anon_sym_PLUS_PLUS] = ACTIONS(4351),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3295),
    [anon_sym___alignof] = ACTIONS(3295),
    [anon_sym__alignof] = ACTIONS(3295),
    [anon_sym_alignof] = ACTIONS(3295),
    [anon_sym__Alignof] = ACTIONS(3295),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3299),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [sym_number_literal] = ACTIONS(3303),
    [anon_sym_L_SQUOTE] = ACTIONS(3305),
    [anon_sym_u_SQUOTE] = ACTIONS(3305),
    [anon_sym_U_SQUOTE] = ACTIONS(3305),
    [anon_sym_u8_SQUOTE] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_L_DQUOTE] = ACTIONS(3307),
    [anon_sym_u_DQUOTE] = ACTIONS(3307),
    [anon_sym_U_DQUOTE] = ACTIONS(3307),
    [anon_sym_u8_DQUOTE] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [anon_sym_NULL] = ACTIONS(3311),
    [anon_sym_nullptr] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_R_DQUOTE] = ACTIONS(3315),
    [anon_sym_LR_DQUOTE] = ACTIONS(3315),
    [anon_sym_uR_DQUOTE] = ACTIONS(3315),
    [anon_sym_UR_DQUOTE] = ACTIONS(3315),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3315),
    [anon_sym_co_await] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_requires] = ACTIONS(3321),
    [sym_this] = ACTIONS(3309),
  },
  [1038] = {
    [sym_expression] = STATE(5039),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(8750),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4410),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1039] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4413),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1040] = {
    [sym_expression] = STATE(4369),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3068),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3068),
    [sym_call_expression] = STATE(3068),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3068),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3068),
    [sym_char_literal] = STATE(4482),
    [sym_concatenated_string] = STATE(4479),
    [sym_string_literal] = STATE(3097),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3096),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3068),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3068),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(4415),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(3582),
    [anon_sym_TILDE] = ACTIONS(3582),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_compl] = ACTIONS(3580),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(3588),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3590),
    [anon_sym_L_SQUOTE] = ACTIONS(3592),
    [anon_sym_u_SQUOTE] = ACTIONS(3592),
    [anon_sym_U_SQUOTE] = ACTIONS(3592),
    [anon_sym_u8_SQUOTE] = ACTIONS(3592),
    [anon_sym_SQUOTE] = ACTIONS(3592),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3596),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [anon_sym_co_await] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_requires] = ACTIONS(3604),
    [sym_this] = ACTIONS(221),
  },
  [1041] = {
    [sym_expression] = STATE(3826),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1042] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4419),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1043] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4421),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1044] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4423),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1045] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4425),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1046] = {
    [sym_expression] = STATE(4733),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_initializer_list] = STATE(7619),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4427),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1047] = {
    [sym_expression] = STATE(3122),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1048] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4429),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1049] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4431),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1050] = {
    [sym_expression] = STATE(4668),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_initializer_list] = STATE(7764),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4433),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1051] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4435),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1052] = {
    [sym_expression] = STATE(4900),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1053] = {
    [sym_expression] = STATE(4912),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1054] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4439),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1055] = {
    [sym_expression] = STATE(3151),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1056] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4441),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1057] = {
    [sym_expression] = STATE(4715),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(4361),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4363),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1058] = {
    [sym_expression] = STATE(4715),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4363),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1059] = {
    [sym_expression] = STATE(2855),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(2940),
    [sym_concatenated_string] = STATE(3000),
    [sym_string_literal] = STATE(2241),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2239),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2512),
    [anon_sym_compl] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_sizeof] = ACTIONS(2522),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2532),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [anon_sym_co_await] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1060] = {
    [sym_expression] = STATE(5039),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(8750),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4445),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1061] = {
    [sym_expression] = STATE(3110),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3517),
    [sym_concatenated_string] = STATE(3520),
    [sym_string_literal] = STATE(2431),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2428),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(2805),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_compl] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(4448),
    [anon_sym_PLUS_PLUS] = ACTIONS(4448),
    [anon_sym_sizeof] = ACTIONS(2807),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2813),
    [anon_sym_u_DQUOTE] = ACTIONS(2813),
    [anon_sym_U_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8_DQUOTE] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2817),
    [anon_sym_LR_DQUOTE] = ACTIONS(2817),
    [anon_sym_uR_DQUOTE] = ACTIONS(2817),
    [anon_sym_UR_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2817),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1062] = {
    [sym_identifier] = ACTIONS(3988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3990),
    [anon_sym_COMMA] = ACTIONS(3990),
    [anon_sym_RPAREN] = ACTIONS(3990),
    [anon_sym_LPAREN2] = ACTIONS(3990),
    [anon_sym_TILDE] = ACTIONS(3990),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_STAR] = ACTIONS(3990),
    [anon_sym_SLASH] = ACTIONS(3988),
    [anon_sym_PERCENT] = ACTIONS(3990),
    [anon_sym_PIPE_PIPE] = ACTIONS(3990),
    [anon_sym_AMP_AMP] = ACTIONS(3990),
    [anon_sym_PIPE] = ACTIONS(3988),
    [anon_sym_CARET] = ACTIONS(3990),
    [anon_sym_AMP] = ACTIONS(3988),
    [anon_sym_EQ_EQ] = ACTIONS(3990),
    [anon_sym_BANG_EQ] = ACTIONS(3990),
    [anon_sym_GT] = ACTIONS(3988),
    [anon_sym_GT_EQ] = ACTIONS(3990),
    [anon_sym_LT_EQ] = ACTIONS(3988),
    [anon_sym_LT] = ACTIONS(3988),
    [anon_sym_LT_LT] = ACTIONS(3988),
    [anon_sym_GT_GT] = ACTIONS(3990),
    [anon_sym_SEMI] = ACTIONS(3990),
    [anon_sym___extension__] = ACTIONS(3988),
    [anon_sym___device__] = ACTIONS(3988),
    [anon_sym___host__] = ACTIONS(3988),
    [anon_sym___global__] = ACTIONS(3988),
    [anon_sym___forceinline__] = ACTIONS(3988),
    [anon_sym___noinline__] = ACTIONS(3988),
    [anon_sym_extern] = ACTIONS(3988),
    [anon_sym___attribute__] = ACTIONS(3988),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3990),
    [anon_sym___declspec] = ACTIONS(3988),
    [anon_sym___based] = ACTIONS(3988),
    [anon_sym___cdecl] = ACTIONS(3988),
    [anon_sym___clrcall] = ACTIONS(3988),
    [anon_sym___stdcall] = ACTIONS(3988),
    [anon_sym___fastcall] = ACTIONS(3988),
    [anon_sym___thiscall] = ACTIONS(3988),
    [anon_sym___vectorcall] = ACTIONS(3988),
    [anon_sym_LBRACE] = ACTIONS(3990),
    [anon_sym_RBRACE] = ACTIONS(3990),
    [anon_sym_LBRACK] = ACTIONS(3988),
    [anon_sym_static] = ACTIONS(3988),
    [anon_sym_EQ] = ACTIONS(3988),
    [anon_sym_register] = ACTIONS(3988),
    [anon_sym_inline] = ACTIONS(3988),
    [anon_sym___inline] = ACTIONS(3988),
    [anon_sym___inline__] = ACTIONS(3988),
    [anon_sym___forceinline] = ACTIONS(3988),
    [anon_sym_thread_local] = ACTIONS(3988),
    [anon_sym___thread] = ACTIONS(3988),
    [anon_sym_const] = ACTIONS(3988),
    [anon_sym_constexpr] = ACTIONS(3988),
    [anon_sym_volatile] = ACTIONS(3988),
    [anon_sym_restrict] = ACTIONS(3988),
    [anon_sym___restrict__] = ACTIONS(3988),
    [anon_sym__Atomic] = ACTIONS(3988),
    [anon_sym__Noreturn] = ACTIONS(3988),
    [anon_sym_noreturn] = ACTIONS(3988),
    [anon_sym_mutable] = ACTIONS(3988),
    [anon_sym_constinit] = ACTIONS(3988),
    [anon_sym_consteval] = ACTIONS(3988),
    [anon_sym___shared__] = ACTIONS(3988),
    [anon_sym___local__] = ACTIONS(3988),
    [anon_sym___constant__] = ACTIONS(3988),
    [anon_sym___managed__] = ACTIONS(3988),
    [anon_sym___grid_constant__] = ACTIONS(3988),
    [anon_sym_alignas] = ACTIONS(3988),
    [anon_sym__Alignas] = ACTIONS(3988),
    [anon_sym_COLON] = ACTIONS(3988),
    [anon_sym_QMARK] = ACTIONS(3990),
    [anon_sym_LT_EQ_GT] = ACTIONS(3990),
    [anon_sym_or] = ACTIONS(3988),
    [anon_sym_and] = ACTIONS(3988),
    [anon_sym_bitor] = ACTIONS(3988),
    [anon_sym_xor] = ACTIONS(3988),
    [anon_sym_bitand] = ACTIONS(3988),
    [anon_sym_not_eq] = ACTIONS(3988),
    [anon_sym_DASH_DASH] = ACTIONS(3990),
    [anon_sym_PLUS_PLUS] = ACTIONS(3990),
    [anon_sym_DOT] = ACTIONS(3988),
    [anon_sym_DOT_STAR] = ACTIONS(3990),
    [anon_sym_DASH_GT] = ACTIONS(3990),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3988),
    [anon_sym_decltype] = ACTIONS(3988),
    [anon_sym_final] = ACTIONS(3988),
    [anon_sym_override] = ACTIONS(3988),
    [sym_virtual] = ACTIONS(3988),
    [anon_sym_template] = ACTIONS(3988),
    [anon_sym_operator] = ACTIONS(3988),
    [anon_sym_try] = ACTIONS(3988),
    [anon_sym_requires] = ACTIONS(3988),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3990),
    [anon_sym___launch_bounds__] = ACTIONS(3988),
  },
  [1063] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4450),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1064] = {
    [sym_expression] = STATE(3121),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3517),
    [sym_concatenated_string] = STATE(3520),
    [sym_string_literal] = STATE(2431),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2428),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(2805),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_compl] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(4448),
    [anon_sym_PLUS_PLUS] = ACTIONS(4448),
    [anon_sym_sizeof] = ACTIONS(2807),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2813),
    [anon_sym_u_DQUOTE] = ACTIONS(2813),
    [anon_sym_U_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8_DQUOTE] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2817),
    [anon_sym_LR_DQUOTE] = ACTIONS(2817),
    [anon_sym_uR_DQUOTE] = ACTIONS(2817),
    [anon_sym_UR_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2817),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1065] = {
    [sym_expression] = STATE(4976),
    [sym__string] = STATE(5255),
    [sym_conditional_expression] = STATE(5255),
    [sym_assignment_expression] = STATE(5255),
    [sym_pointer_expression] = STATE(3988),
    [sym_unary_expression] = STATE(5255),
    [sym_binary_expression] = STATE(5255),
    [sym_update_expression] = STATE(5255),
    [sym_cast_expression] = STATE(5255),
    [sym_sizeof_expression] = STATE(5255),
    [sym_alignof_expression] = STATE(5255),
    [sym_offsetof_expression] = STATE(5255),
    [sym_generic_expression] = STATE(5255),
    [sym_subscript_expression] = STATE(3988),
    [sym_call_expression] = STATE(3988),
    [sym_gnu_asm_expression] = STATE(5255),
    [sym_field_expression] = STATE(3988),
    [sym_compound_literal_expression] = STATE(5255),
    [sym_parenthesized_expression] = STATE(3988),
    [sym_char_literal] = STATE(5164),
    [sym_concatenated_string] = STATE(5162),
    [sym_string_literal] = STATE(4081),
    [sym_null] = STATE(5255),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5255),
    [sym_raw_string_literal] = STATE(4060),
    [sym_co_await_expression] = STATE(5255),
    [sym_new_expression] = STATE(5255),
    [sym_delete_expression] = STATE(5255),
    [sym_requires_clause] = STATE(5255),
    [sym_requires_expression] = STATE(5255),
    [sym_lambda_expression] = STATE(5255),
    [sym_lambda_capture_specifier] = STATE(6164),
    [sym_fold_expression] = STATE(5255),
    [sym_parameter_pack_expansion] = STATE(5255),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3988),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3988),
    [sym_kernel_call_expression] = STATE(5260),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(3718),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4452),
    [anon_sym_PLUS_PLUS] = ACTIONS(4452),
    [anon_sym_sizeof] = ACTIONS(3720),
    [anon_sym___alignof__] = ACTIONS(3722),
    [anon_sym___alignof] = ACTIONS(3722),
    [anon_sym__alignof] = ACTIONS(3722),
    [anon_sym_alignof] = ACTIONS(3722),
    [anon_sym__Alignof] = ACTIONS(3722),
    [anon_sym_offsetof] = ACTIONS(3724),
    [anon_sym__Generic] = ACTIONS(3726),
    [anon_sym_asm] = ACTIONS(3728),
    [anon_sym___asm__] = ACTIONS(3728),
    [sym_number_literal] = ACTIONS(3730),
    [anon_sym_L_SQUOTE] = ACTIONS(3732),
    [anon_sym_u_SQUOTE] = ACTIONS(3732),
    [anon_sym_U_SQUOTE] = ACTIONS(3732),
    [anon_sym_u8_SQUOTE] = ACTIONS(3732),
    [anon_sym_SQUOTE] = ACTIONS(3732),
    [anon_sym_L_DQUOTE] = ACTIONS(3734),
    [anon_sym_u_DQUOTE] = ACTIONS(3734),
    [anon_sym_U_DQUOTE] = ACTIONS(3734),
    [anon_sym_u8_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [sym_true] = ACTIONS(3736),
    [sym_false] = ACTIONS(3736),
    [anon_sym_NULL] = ACTIONS(3738),
    [anon_sym_nullptr] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3740),
    [anon_sym_R_DQUOTE] = ACTIONS(3742),
    [anon_sym_LR_DQUOTE] = ACTIONS(3742),
    [anon_sym_uR_DQUOTE] = ACTIONS(3742),
    [anon_sym_UR_DQUOTE] = ACTIONS(3742),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3742),
    [anon_sym_co_await] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3748),
    [sym_this] = ACTIONS(3736),
  },
  [1066] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4454),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1067] = {
    [sym_expression] = STATE(4962),
    [sym__string] = STATE(5255),
    [sym_conditional_expression] = STATE(5255),
    [sym_assignment_expression] = STATE(5255),
    [sym_pointer_expression] = STATE(3988),
    [sym_unary_expression] = STATE(5255),
    [sym_binary_expression] = STATE(5255),
    [sym_update_expression] = STATE(5255),
    [sym_cast_expression] = STATE(5255),
    [sym_sizeof_expression] = STATE(5255),
    [sym_alignof_expression] = STATE(5255),
    [sym_offsetof_expression] = STATE(5255),
    [sym_generic_expression] = STATE(5255),
    [sym_subscript_expression] = STATE(3988),
    [sym_call_expression] = STATE(3988),
    [sym_gnu_asm_expression] = STATE(5255),
    [sym_field_expression] = STATE(3988),
    [sym_compound_literal_expression] = STATE(5255),
    [sym_parenthesized_expression] = STATE(3988),
    [sym_char_literal] = STATE(5164),
    [sym_concatenated_string] = STATE(5162),
    [sym_string_literal] = STATE(4081),
    [sym_null] = STATE(5255),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5255),
    [sym_raw_string_literal] = STATE(4060),
    [sym_co_await_expression] = STATE(5255),
    [sym_new_expression] = STATE(5255),
    [sym_delete_expression] = STATE(5255),
    [sym_requires_clause] = STATE(5255),
    [sym_requires_expression] = STATE(5255),
    [sym_lambda_expression] = STATE(5255),
    [sym_lambda_capture_specifier] = STATE(6164),
    [sym_fold_expression] = STATE(5255),
    [sym_parameter_pack_expansion] = STATE(5255),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3988),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3988),
    [sym_kernel_call_expression] = STATE(5260),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(3718),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4452),
    [anon_sym_PLUS_PLUS] = ACTIONS(4452),
    [anon_sym_sizeof] = ACTIONS(3720),
    [anon_sym___alignof__] = ACTIONS(3722),
    [anon_sym___alignof] = ACTIONS(3722),
    [anon_sym__alignof] = ACTIONS(3722),
    [anon_sym_alignof] = ACTIONS(3722),
    [anon_sym__Alignof] = ACTIONS(3722),
    [anon_sym_offsetof] = ACTIONS(3724),
    [anon_sym__Generic] = ACTIONS(3726),
    [anon_sym_asm] = ACTIONS(3728),
    [anon_sym___asm__] = ACTIONS(3728),
    [sym_number_literal] = ACTIONS(3730),
    [anon_sym_L_SQUOTE] = ACTIONS(3732),
    [anon_sym_u_SQUOTE] = ACTIONS(3732),
    [anon_sym_U_SQUOTE] = ACTIONS(3732),
    [anon_sym_u8_SQUOTE] = ACTIONS(3732),
    [anon_sym_SQUOTE] = ACTIONS(3732),
    [anon_sym_L_DQUOTE] = ACTIONS(3734),
    [anon_sym_u_DQUOTE] = ACTIONS(3734),
    [anon_sym_U_DQUOTE] = ACTIONS(3734),
    [anon_sym_u8_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [sym_true] = ACTIONS(3736),
    [sym_false] = ACTIONS(3736),
    [anon_sym_NULL] = ACTIONS(3738),
    [anon_sym_nullptr] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3740),
    [anon_sym_R_DQUOTE] = ACTIONS(3742),
    [anon_sym_LR_DQUOTE] = ACTIONS(3742),
    [anon_sym_uR_DQUOTE] = ACTIONS(3742),
    [anon_sym_UR_DQUOTE] = ACTIONS(3742),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3742),
    [anon_sym_co_await] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3748),
    [sym_this] = ACTIONS(3736),
  },
  [1068] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4456),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1069] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4458),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1070] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4460),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1071] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4462),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1072] = {
    [sym_expression] = STATE(3230),
    [sym__string] = STATE(3860),
    [sym_conditional_expression] = STATE(3860),
    [sym_assignment_expression] = STATE(3860),
    [sym_pointer_expression] = STATE(3861),
    [sym_unary_expression] = STATE(3860),
    [sym_binary_expression] = STATE(3860),
    [sym_update_expression] = STATE(3860),
    [sym_cast_expression] = STATE(3860),
    [sym_sizeof_expression] = STATE(3860),
    [sym_alignof_expression] = STATE(3860),
    [sym_offsetof_expression] = STATE(3860),
    [sym_generic_expression] = STATE(3860),
    [sym_subscript_expression] = STATE(3861),
    [sym_call_expression] = STATE(3861),
    [sym_gnu_asm_expression] = STATE(3860),
    [sym_field_expression] = STATE(3861),
    [sym_compound_literal_expression] = STATE(3860),
    [sym_parenthesized_expression] = STATE(3861),
    [sym_char_literal] = STATE(3831),
    [sym_concatenated_string] = STATE(3833),
    [sym_string_literal] = STATE(2490),
    [sym_null] = STATE(3860),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7980),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3860),
    [sym_raw_string_literal] = STATE(2516),
    [sym_co_await_expression] = STATE(3860),
    [sym_new_expression] = STATE(3860),
    [sym_delete_expression] = STATE(3860),
    [sym_requires_clause] = STATE(3860),
    [sym_requires_expression] = STATE(3860),
    [sym_lambda_expression] = STATE(3860),
    [sym_lambda_capture_specifier] = STATE(6189),
    [sym_fold_expression] = STATE(3860),
    [sym_parameter_pack_expansion] = STATE(3860),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3861),
    [sym_qualified_type_identifier] = STATE(7980),
    [sym_user_defined_literal] = STATE(3861),
    [sym_kernel_call_expression] = STATE(3851),
    [sym_identifier] = ACTIONS(3179),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(3185),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(3189),
    [anon_sym_not] = ACTIONS(3181),
    [anon_sym_compl] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(4357),
    [anon_sym_PLUS_PLUS] = ACTIONS(4357),
    [anon_sym_sizeof] = ACTIONS(3191),
    [anon_sym___alignof__] = ACTIONS(3193),
    [anon_sym___alignof] = ACTIONS(3193),
    [anon_sym__alignof] = ACTIONS(3193),
    [anon_sym_alignof] = ACTIONS(3193),
    [anon_sym__Alignof] = ACTIONS(3193),
    [anon_sym_offsetof] = ACTIONS(3195),
    [anon_sym__Generic] = ACTIONS(3197),
    [anon_sym_asm] = ACTIONS(3199),
    [anon_sym___asm__] = ACTIONS(3199),
    [sym_number_literal] = ACTIONS(3201),
    [anon_sym_L_SQUOTE] = ACTIONS(3203),
    [anon_sym_u_SQUOTE] = ACTIONS(3203),
    [anon_sym_U_SQUOTE] = ACTIONS(3203),
    [anon_sym_u8_SQUOTE] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [anon_sym_L_DQUOTE] = ACTIONS(3205),
    [anon_sym_u_DQUOTE] = ACTIONS(3205),
    [anon_sym_U_DQUOTE] = ACTIONS(3205),
    [anon_sym_u8_DQUOTE] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [anon_sym_NULL] = ACTIONS(3209),
    [anon_sym_nullptr] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_R_DQUOTE] = ACTIONS(3213),
    [anon_sym_LR_DQUOTE] = ACTIONS(3213),
    [anon_sym_uR_DQUOTE] = ACTIONS(3213),
    [anon_sym_UR_DQUOTE] = ACTIONS(3213),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3213),
    [anon_sym_co_await] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_requires] = ACTIONS(3219),
    [sym_this] = ACTIONS(3207),
  },
  [1073] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4464),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1074] = {
    [sym_identifier] = ACTIONS(3996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3998),
    [anon_sym_COMMA] = ACTIONS(3998),
    [anon_sym_RPAREN] = ACTIONS(3998),
    [anon_sym_LPAREN2] = ACTIONS(3998),
    [anon_sym_TILDE] = ACTIONS(3998),
    [anon_sym_DASH] = ACTIONS(3996),
    [anon_sym_PLUS] = ACTIONS(3996),
    [anon_sym_STAR] = ACTIONS(3998),
    [anon_sym_SLASH] = ACTIONS(3996),
    [anon_sym_PERCENT] = ACTIONS(3998),
    [anon_sym_PIPE_PIPE] = ACTIONS(3998),
    [anon_sym_AMP_AMP] = ACTIONS(3998),
    [anon_sym_PIPE] = ACTIONS(3996),
    [anon_sym_CARET] = ACTIONS(3998),
    [anon_sym_AMP] = ACTIONS(3996),
    [anon_sym_EQ_EQ] = ACTIONS(3998),
    [anon_sym_BANG_EQ] = ACTIONS(3998),
    [anon_sym_GT] = ACTIONS(3996),
    [anon_sym_GT_EQ] = ACTIONS(3998),
    [anon_sym_LT_EQ] = ACTIONS(3996),
    [anon_sym_LT] = ACTIONS(3996),
    [anon_sym_LT_LT] = ACTIONS(3996),
    [anon_sym_GT_GT] = ACTIONS(3998),
    [anon_sym_SEMI] = ACTIONS(3998),
    [anon_sym___extension__] = ACTIONS(3996),
    [anon_sym___device__] = ACTIONS(3996),
    [anon_sym___host__] = ACTIONS(3996),
    [anon_sym___global__] = ACTIONS(3996),
    [anon_sym___forceinline__] = ACTIONS(3996),
    [anon_sym___noinline__] = ACTIONS(3996),
    [anon_sym_extern] = ACTIONS(3996),
    [anon_sym___attribute__] = ACTIONS(3996),
    [anon_sym_COLON_COLON] = ACTIONS(3998),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3998),
    [anon_sym___declspec] = ACTIONS(3996),
    [anon_sym___based] = ACTIONS(3996),
    [anon_sym___cdecl] = ACTIONS(3996),
    [anon_sym___clrcall] = ACTIONS(3996),
    [anon_sym___stdcall] = ACTIONS(3996),
    [anon_sym___fastcall] = ACTIONS(3996),
    [anon_sym___thiscall] = ACTIONS(3996),
    [anon_sym___vectorcall] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(3998),
    [anon_sym_RBRACE] = ACTIONS(3998),
    [anon_sym_LBRACK] = ACTIONS(3996),
    [anon_sym_static] = ACTIONS(3996),
    [anon_sym_EQ] = ACTIONS(3996),
    [anon_sym_register] = ACTIONS(3996),
    [anon_sym_inline] = ACTIONS(3996),
    [anon_sym___inline] = ACTIONS(3996),
    [anon_sym___inline__] = ACTIONS(3996),
    [anon_sym___forceinline] = ACTIONS(3996),
    [anon_sym_thread_local] = ACTIONS(3996),
    [anon_sym___thread] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3996),
    [anon_sym_constexpr] = ACTIONS(3996),
    [anon_sym_volatile] = ACTIONS(3996),
    [anon_sym_restrict] = ACTIONS(3996),
    [anon_sym___restrict__] = ACTIONS(3996),
    [anon_sym__Atomic] = ACTIONS(3996),
    [anon_sym__Noreturn] = ACTIONS(3996),
    [anon_sym_noreturn] = ACTIONS(3996),
    [anon_sym_mutable] = ACTIONS(3996),
    [anon_sym_constinit] = ACTIONS(3996),
    [anon_sym_consteval] = ACTIONS(3996),
    [anon_sym___shared__] = ACTIONS(3996),
    [anon_sym___local__] = ACTIONS(3996),
    [anon_sym___constant__] = ACTIONS(3996),
    [anon_sym___managed__] = ACTIONS(3996),
    [anon_sym___grid_constant__] = ACTIONS(3996),
    [anon_sym_alignas] = ACTIONS(3996),
    [anon_sym__Alignas] = ACTIONS(3996),
    [anon_sym_COLON] = ACTIONS(3996),
    [anon_sym_QMARK] = ACTIONS(3998),
    [anon_sym_LT_EQ_GT] = ACTIONS(3998),
    [anon_sym_or] = ACTIONS(3996),
    [anon_sym_and] = ACTIONS(3996),
    [anon_sym_bitor] = ACTIONS(3996),
    [anon_sym_xor] = ACTIONS(3996),
    [anon_sym_bitand] = ACTIONS(3996),
    [anon_sym_not_eq] = ACTIONS(3996),
    [anon_sym_DASH_DASH] = ACTIONS(3998),
    [anon_sym_PLUS_PLUS] = ACTIONS(3998),
    [anon_sym_DOT] = ACTIONS(3996),
    [anon_sym_DOT_STAR] = ACTIONS(3998),
    [anon_sym_DASH_GT] = ACTIONS(3998),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3996),
    [anon_sym_decltype] = ACTIONS(3996),
    [anon_sym_final] = ACTIONS(3996),
    [anon_sym_override] = ACTIONS(3996),
    [sym_virtual] = ACTIONS(3996),
    [anon_sym_template] = ACTIONS(3996),
    [anon_sym_operator] = ACTIONS(3996),
    [anon_sym_try] = ACTIONS(3996),
    [anon_sym_requires] = ACTIONS(3996),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3998),
    [anon_sym___launch_bounds__] = ACTIONS(3996),
  },
  [1075] = {
    [sym_identifier] = ACTIONS(3980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3982),
    [anon_sym_COMMA] = ACTIONS(3982),
    [anon_sym_RPAREN] = ACTIONS(3982),
    [anon_sym_LPAREN2] = ACTIONS(3982),
    [anon_sym_TILDE] = ACTIONS(3982),
    [anon_sym_DASH] = ACTIONS(3980),
    [anon_sym_PLUS] = ACTIONS(3980),
    [anon_sym_STAR] = ACTIONS(3982),
    [anon_sym_SLASH] = ACTIONS(3980),
    [anon_sym_PERCENT] = ACTIONS(3982),
    [anon_sym_PIPE_PIPE] = ACTIONS(3982),
    [anon_sym_AMP_AMP] = ACTIONS(3982),
    [anon_sym_PIPE] = ACTIONS(3980),
    [anon_sym_CARET] = ACTIONS(3982),
    [anon_sym_AMP] = ACTIONS(3980),
    [anon_sym_EQ_EQ] = ACTIONS(3982),
    [anon_sym_BANG_EQ] = ACTIONS(3982),
    [anon_sym_GT] = ACTIONS(3980),
    [anon_sym_GT_EQ] = ACTIONS(3982),
    [anon_sym_LT_EQ] = ACTIONS(3980),
    [anon_sym_LT] = ACTIONS(3980),
    [anon_sym_LT_LT] = ACTIONS(3980),
    [anon_sym_GT_GT] = ACTIONS(3982),
    [anon_sym_SEMI] = ACTIONS(3982),
    [anon_sym___extension__] = ACTIONS(3980),
    [anon_sym___device__] = ACTIONS(3980),
    [anon_sym___host__] = ACTIONS(3980),
    [anon_sym___global__] = ACTIONS(3980),
    [anon_sym___forceinline__] = ACTIONS(3980),
    [anon_sym___noinline__] = ACTIONS(3980),
    [anon_sym_extern] = ACTIONS(3980),
    [anon_sym___attribute__] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3982),
    [anon_sym___declspec] = ACTIONS(3980),
    [anon_sym___based] = ACTIONS(3980),
    [anon_sym___cdecl] = ACTIONS(3980),
    [anon_sym___clrcall] = ACTIONS(3980),
    [anon_sym___stdcall] = ACTIONS(3980),
    [anon_sym___fastcall] = ACTIONS(3980),
    [anon_sym___thiscall] = ACTIONS(3980),
    [anon_sym___vectorcall] = ACTIONS(3980),
    [anon_sym_LBRACE] = ACTIONS(3982),
    [anon_sym_RBRACE] = ACTIONS(3982),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_static] = ACTIONS(3980),
    [anon_sym_EQ] = ACTIONS(3980),
    [anon_sym_register] = ACTIONS(3980),
    [anon_sym_inline] = ACTIONS(3980),
    [anon_sym___inline] = ACTIONS(3980),
    [anon_sym___inline__] = ACTIONS(3980),
    [anon_sym___forceinline] = ACTIONS(3980),
    [anon_sym_thread_local] = ACTIONS(3980),
    [anon_sym___thread] = ACTIONS(3980),
    [anon_sym_const] = ACTIONS(3980),
    [anon_sym_constexpr] = ACTIONS(3980),
    [anon_sym_volatile] = ACTIONS(3980),
    [anon_sym_restrict] = ACTIONS(3980),
    [anon_sym___restrict__] = ACTIONS(3980),
    [anon_sym__Atomic] = ACTIONS(3980),
    [anon_sym__Noreturn] = ACTIONS(3980),
    [anon_sym_noreturn] = ACTIONS(3980),
    [anon_sym_mutable] = ACTIONS(3980),
    [anon_sym_constinit] = ACTIONS(3980),
    [anon_sym_consteval] = ACTIONS(3980),
    [anon_sym___shared__] = ACTIONS(3980),
    [anon_sym___local__] = ACTIONS(3980),
    [anon_sym___constant__] = ACTIONS(3980),
    [anon_sym___managed__] = ACTIONS(3980),
    [anon_sym___grid_constant__] = ACTIONS(3980),
    [anon_sym_alignas] = ACTIONS(3980),
    [anon_sym__Alignas] = ACTIONS(3980),
    [anon_sym_COLON] = ACTIONS(3980),
    [anon_sym_QMARK] = ACTIONS(3982),
    [anon_sym_LT_EQ_GT] = ACTIONS(3982),
    [anon_sym_or] = ACTIONS(3980),
    [anon_sym_and] = ACTIONS(3980),
    [anon_sym_bitor] = ACTIONS(3980),
    [anon_sym_xor] = ACTIONS(3980),
    [anon_sym_bitand] = ACTIONS(3980),
    [anon_sym_not_eq] = ACTIONS(3980),
    [anon_sym_DASH_DASH] = ACTIONS(3982),
    [anon_sym_PLUS_PLUS] = ACTIONS(3982),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_DOT_STAR] = ACTIONS(3982),
    [anon_sym_DASH_GT] = ACTIONS(3982),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3980),
    [anon_sym_decltype] = ACTIONS(3980),
    [anon_sym_final] = ACTIONS(3980),
    [anon_sym_override] = ACTIONS(3980),
    [sym_virtual] = ACTIONS(3980),
    [anon_sym_template] = ACTIONS(3980),
    [anon_sym_operator] = ACTIONS(3980),
    [anon_sym_try] = ACTIONS(3980),
    [anon_sym_requires] = ACTIONS(3980),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3982),
    [anon_sym___launch_bounds__] = ACTIONS(3980),
  },
  [1076] = {
    [sym_identifier] = ACTIONS(3984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3986),
    [anon_sym_COMMA] = ACTIONS(3986),
    [anon_sym_RPAREN] = ACTIONS(3986),
    [anon_sym_LPAREN2] = ACTIONS(3986),
    [anon_sym_TILDE] = ACTIONS(3986),
    [anon_sym_DASH] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(3986),
    [anon_sym_SLASH] = ACTIONS(3984),
    [anon_sym_PERCENT] = ACTIONS(3986),
    [anon_sym_PIPE_PIPE] = ACTIONS(3986),
    [anon_sym_AMP_AMP] = ACTIONS(3986),
    [anon_sym_PIPE] = ACTIONS(3984),
    [anon_sym_CARET] = ACTIONS(3986),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_EQ_EQ] = ACTIONS(3986),
    [anon_sym_BANG_EQ] = ACTIONS(3986),
    [anon_sym_GT] = ACTIONS(3984),
    [anon_sym_GT_EQ] = ACTIONS(3986),
    [anon_sym_LT_EQ] = ACTIONS(3984),
    [anon_sym_LT] = ACTIONS(3984),
    [anon_sym_LT_LT] = ACTIONS(3984),
    [anon_sym_GT_GT] = ACTIONS(3986),
    [anon_sym_SEMI] = ACTIONS(3986),
    [anon_sym___extension__] = ACTIONS(3984),
    [anon_sym___device__] = ACTIONS(3984),
    [anon_sym___host__] = ACTIONS(3984),
    [anon_sym___global__] = ACTIONS(3984),
    [anon_sym___forceinline__] = ACTIONS(3984),
    [anon_sym___noinline__] = ACTIONS(3984),
    [anon_sym_extern] = ACTIONS(3984),
    [anon_sym___attribute__] = ACTIONS(3984),
    [anon_sym_COLON_COLON] = ACTIONS(3986),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3986),
    [anon_sym___declspec] = ACTIONS(3984),
    [anon_sym___based] = ACTIONS(3984),
    [anon_sym___cdecl] = ACTIONS(3984),
    [anon_sym___clrcall] = ACTIONS(3984),
    [anon_sym___stdcall] = ACTIONS(3984),
    [anon_sym___fastcall] = ACTIONS(3984),
    [anon_sym___thiscall] = ACTIONS(3984),
    [anon_sym___vectorcall] = ACTIONS(3984),
    [anon_sym_LBRACE] = ACTIONS(3986),
    [anon_sym_RBRACE] = ACTIONS(3986),
    [anon_sym_LBRACK] = ACTIONS(3984),
    [anon_sym_static] = ACTIONS(3984),
    [anon_sym_EQ] = ACTIONS(3984),
    [anon_sym_register] = ACTIONS(3984),
    [anon_sym_inline] = ACTIONS(3984),
    [anon_sym___inline] = ACTIONS(3984),
    [anon_sym___inline__] = ACTIONS(3984),
    [anon_sym___forceinline] = ACTIONS(3984),
    [anon_sym_thread_local] = ACTIONS(3984),
    [anon_sym___thread] = ACTIONS(3984),
    [anon_sym_const] = ACTIONS(3984),
    [anon_sym_constexpr] = ACTIONS(3984),
    [anon_sym_volatile] = ACTIONS(3984),
    [anon_sym_restrict] = ACTIONS(3984),
    [anon_sym___restrict__] = ACTIONS(3984),
    [anon_sym__Atomic] = ACTIONS(3984),
    [anon_sym__Noreturn] = ACTIONS(3984),
    [anon_sym_noreturn] = ACTIONS(3984),
    [anon_sym_mutable] = ACTIONS(3984),
    [anon_sym_constinit] = ACTIONS(3984),
    [anon_sym_consteval] = ACTIONS(3984),
    [anon_sym___shared__] = ACTIONS(3984),
    [anon_sym___local__] = ACTIONS(3984),
    [anon_sym___constant__] = ACTIONS(3984),
    [anon_sym___managed__] = ACTIONS(3984),
    [anon_sym___grid_constant__] = ACTIONS(3984),
    [anon_sym_alignas] = ACTIONS(3984),
    [anon_sym__Alignas] = ACTIONS(3984),
    [anon_sym_COLON] = ACTIONS(3984),
    [anon_sym_QMARK] = ACTIONS(3986),
    [anon_sym_LT_EQ_GT] = ACTIONS(3986),
    [anon_sym_or] = ACTIONS(3984),
    [anon_sym_and] = ACTIONS(3984),
    [anon_sym_bitor] = ACTIONS(3984),
    [anon_sym_xor] = ACTIONS(3984),
    [anon_sym_bitand] = ACTIONS(3984),
    [anon_sym_not_eq] = ACTIONS(3984),
    [anon_sym_DASH_DASH] = ACTIONS(3986),
    [anon_sym_PLUS_PLUS] = ACTIONS(3986),
    [anon_sym_DOT] = ACTIONS(3984),
    [anon_sym_DOT_STAR] = ACTIONS(3986),
    [anon_sym_DASH_GT] = ACTIONS(3986),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3984),
    [anon_sym_decltype] = ACTIONS(3984),
    [anon_sym_final] = ACTIONS(3984),
    [anon_sym_override] = ACTIONS(3984),
    [sym_virtual] = ACTIONS(3984),
    [anon_sym_template] = ACTIONS(3984),
    [anon_sym_operator] = ACTIONS(3984),
    [anon_sym_try] = ACTIONS(3984),
    [anon_sym_requires] = ACTIONS(3984),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3986),
    [anon_sym___launch_bounds__] = ACTIONS(3984),
  },
  [1077] = {
    [sym_expression] = STATE(4574),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1078] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4466),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1079] = {
    [sym_expression] = STATE(4717),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_initializer_list] = STATE(7613),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4468),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1080] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4470),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1081] = {
    [sym_expression] = STATE(4442),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3068),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3068),
    [sym_call_expression] = STATE(3068),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3068),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3068),
    [sym_char_literal] = STATE(4482),
    [sym_concatenated_string] = STATE(4479),
    [sym_string_literal] = STATE(3097),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3096),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3068),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3068),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(4415),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(3582),
    [anon_sym_TILDE] = ACTIONS(3582),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_compl] = ACTIONS(3580),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(3588),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3590),
    [anon_sym_L_SQUOTE] = ACTIONS(3592),
    [anon_sym_u_SQUOTE] = ACTIONS(3592),
    [anon_sym_U_SQUOTE] = ACTIONS(3592),
    [anon_sym_u8_SQUOTE] = ACTIONS(3592),
    [anon_sym_SQUOTE] = ACTIONS(3592),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3596),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [anon_sym_co_await] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_requires] = ACTIONS(3604),
    [sym_this] = ACTIONS(221),
  },
  [1082] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_lambda_default_capture] = STATE(8128),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(4341),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4363),
    [anon_sym_EQ] = ACTIONS(4345),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1083] = {
    [sym_expression] = STATE(2859),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(2940),
    [sym_concatenated_string] = STATE(3000),
    [sym_string_literal] = STATE(2241),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2239),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4347),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_LBRACE] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(4347),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2512),
    [anon_sym_compl] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_sizeof] = ACTIONS(2522),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2532),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [anon_sym_co_await] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1084] = {
    [sym_expression] = STATE(4660),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(8109),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1085] = {
    [sym_expression] = STATE(2499),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_initializer_list] = STATE(2690),
    [sym_char_literal] = STATE(2940),
    [sym_concatenated_string] = STATE(3000),
    [sym_string_literal] = STATE(2241),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2239),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4472),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2512),
    [anon_sym_compl] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_sizeof] = ACTIONS(2522),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2532),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [anon_sym_co_await] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1086] = {
    [sym_expression] = STATE(4814),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_COLON] = ACTIONS(4480),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1087] = {
    [sym_expression] = STATE(4760),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8398),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_COLON] = ACTIONS(4482),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1088] = {
    [sym_expression] = STATE(4535),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(4246),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1089] = {
    [sym_expression] = STATE(3635),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_initializer_list] = STATE(4129),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACE] = ACTIONS(3454),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1090] = {
    [sym_expression] = STATE(5130),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(8802),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1091] = {
    [sym_expression] = STATE(4743),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8761),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_RPAREN] = ACTIONS(4484),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1092] = {
    [sym_expression] = STATE(4862),
    [sym__string] = STATE(5255),
    [sym_conditional_expression] = STATE(5255),
    [sym_assignment_expression] = STATE(5255),
    [sym_pointer_expression] = STATE(3988),
    [sym_unary_expression] = STATE(5255),
    [sym_binary_expression] = STATE(5255),
    [sym_update_expression] = STATE(5255),
    [sym_cast_expression] = STATE(5255),
    [sym_sizeof_expression] = STATE(5255),
    [sym_alignof_expression] = STATE(5255),
    [sym_offsetof_expression] = STATE(5255),
    [sym_generic_expression] = STATE(5255),
    [sym_subscript_expression] = STATE(3988),
    [sym_call_expression] = STATE(3988),
    [sym_gnu_asm_expression] = STATE(5255),
    [sym_field_expression] = STATE(3988),
    [sym_compound_literal_expression] = STATE(5255),
    [sym_parenthesized_expression] = STATE(3988),
    [sym_initializer_list] = STATE(5245),
    [sym_char_literal] = STATE(5164),
    [sym_concatenated_string] = STATE(5162),
    [sym_string_literal] = STATE(4081),
    [sym_null] = STATE(5255),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5255),
    [sym_raw_string_literal] = STATE(4060),
    [sym_co_await_expression] = STATE(5255),
    [sym_new_expression] = STATE(5255),
    [sym_delete_expression] = STATE(5255),
    [sym_requires_clause] = STATE(5255),
    [sym_requires_expression] = STATE(5255),
    [sym_lambda_expression] = STATE(5255),
    [sym_lambda_capture_specifier] = STATE(6164),
    [sym_fold_expression] = STATE(5255),
    [sym_parameter_pack_expansion] = STATE(5255),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3988),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3988),
    [sym_kernel_call_expression] = STATE(5260),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4486),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_LBRACE] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3718),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4452),
    [anon_sym_PLUS_PLUS] = ACTIONS(4452),
    [anon_sym_sizeof] = ACTIONS(3720),
    [anon_sym___alignof__] = ACTIONS(3722),
    [anon_sym___alignof] = ACTIONS(3722),
    [anon_sym__alignof] = ACTIONS(3722),
    [anon_sym_alignof] = ACTIONS(3722),
    [anon_sym__Alignof] = ACTIONS(3722),
    [anon_sym_offsetof] = ACTIONS(3724),
    [anon_sym__Generic] = ACTIONS(3726),
    [anon_sym_asm] = ACTIONS(3728),
    [anon_sym___asm__] = ACTIONS(3728),
    [sym_number_literal] = ACTIONS(3730),
    [anon_sym_L_SQUOTE] = ACTIONS(3732),
    [anon_sym_u_SQUOTE] = ACTIONS(3732),
    [anon_sym_U_SQUOTE] = ACTIONS(3732),
    [anon_sym_u8_SQUOTE] = ACTIONS(3732),
    [anon_sym_SQUOTE] = ACTIONS(3732),
    [anon_sym_L_DQUOTE] = ACTIONS(3734),
    [anon_sym_u_DQUOTE] = ACTIONS(3734),
    [anon_sym_U_DQUOTE] = ACTIONS(3734),
    [anon_sym_u8_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [sym_true] = ACTIONS(3736),
    [sym_false] = ACTIONS(3736),
    [anon_sym_NULL] = ACTIONS(3738),
    [anon_sym_nullptr] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3740),
    [anon_sym_R_DQUOTE] = ACTIONS(3742),
    [anon_sym_LR_DQUOTE] = ACTIONS(3742),
    [anon_sym_uR_DQUOTE] = ACTIONS(3742),
    [anon_sym_UR_DQUOTE] = ACTIONS(3742),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3742),
    [anon_sym_co_await] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3748),
    [sym_this] = ACTIONS(3736),
  },
  [1093] = {
    [sym_expression] = STATE(4805),
    [sym__string] = STATE(5255),
    [sym_conditional_expression] = STATE(5255),
    [sym_assignment_expression] = STATE(5255),
    [sym_pointer_expression] = STATE(3988),
    [sym_unary_expression] = STATE(5255),
    [sym_binary_expression] = STATE(5255),
    [sym_update_expression] = STATE(5255),
    [sym_cast_expression] = STATE(5255),
    [sym_sizeof_expression] = STATE(5255),
    [sym_alignof_expression] = STATE(5255),
    [sym_offsetof_expression] = STATE(5255),
    [sym_generic_expression] = STATE(5255),
    [sym_subscript_expression] = STATE(3988),
    [sym_call_expression] = STATE(3988),
    [sym_gnu_asm_expression] = STATE(5255),
    [sym_field_expression] = STATE(3988),
    [sym_compound_literal_expression] = STATE(5255),
    [sym_parenthesized_expression] = STATE(3988),
    [sym_initializer_list] = STATE(5301),
    [sym_char_literal] = STATE(5164),
    [sym_concatenated_string] = STATE(5162),
    [sym_string_literal] = STATE(4081),
    [sym_null] = STATE(5255),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5255),
    [sym_raw_string_literal] = STATE(4060),
    [sym_co_await_expression] = STATE(5255),
    [sym_new_expression] = STATE(5255),
    [sym_delete_expression] = STATE(5255),
    [sym_requires_clause] = STATE(5255),
    [sym_requires_expression] = STATE(5255),
    [sym_lambda_expression] = STATE(5255),
    [sym_lambda_capture_specifier] = STATE(6164),
    [sym_fold_expression] = STATE(5255),
    [sym_parameter_pack_expansion] = STATE(5255),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3988),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3988),
    [sym_kernel_call_expression] = STATE(5260),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4486),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_LBRACE] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3718),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4452),
    [anon_sym_PLUS_PLUS] = ACTIONS(4452),
    [anon_sym_sizeof] = ACTIONS(3720),
    [anon_sym___alignof__] = ACTIONS(3722),
    [anon_sym___alignof] = ACTIONS(3722),
    [anon_sym__alignof] = ACTIONS(3722),
    [anon_sym_alignof] = ACTIONS(3722),
    [anon_sym__Alignof] = ACTIONS(3722),
    [anon_sym_offsetof] = ACTIONS(3724),
    [anon_sym__Generic] = ACTIONS(3726),
    [anon_sym_asm] = ACTIONS(3728),
    [anon_sym___asm__] = ACTIONS(3728),
    [sym_number_literal] = ACTIONS(3730),
    [anon_sym_L_SQUOTE] = ACTIONS(3732),
    [anon_sym_u_SQUOTE] = ACTIONS(3732),
    [anon_sym_U_SQUOTE] = ACTIONS(3732),
    [anon_sym_u8_SQUOTE] = ACTIONS(3732),
    [anon_sym_SQUOTE] = ACTIONS(3732),
    [anon_sym_L_DQUOTE] = ACTIONS(3734),
    [anon_sym_u_DQUOTE] = ACTIONS(3734),
    [anon_sym_U_DQUOTE] = ACTIONS(3734),
    [anon_sym_u8_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [sym_true] = ACTIONS(3736),
    [sym_false] = ACTIONS(3736),
    [anon_sym_NULL] = ACTIONS(3738),
    [anon_sym_nullptr] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3740),
    [anon_sym_R_DQUOTE] = ACTIONS(3742),
    [anon_sym_LR_DQUOTE] = ACTIONS(3742),
    [anon_sym_uR_DQUOTE] = ACTIONS(3742),
    [anon_sym_UR_DQUOTE] = ACTIONS(3742),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3742),
    [anon_sym_co_await] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3748),
    [sym_this] = ACTIONS(3736),
  },
  [1094] = {
    [sym_expression] = STATE(2499),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_initializer_list] = STATE(2690),
    [sym_char_literal] = STATE(3517),
    [sym_concatenated_string] = STATE(3520),
    [sym_string_literal] = STATE(2431),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2428),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(4490),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(2805),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_compl] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(4448),
    [anon_sym_PLUS_PLUS] = ACTIONS(4448),
    [anon_sym_sizeof] = ACTIONS(2807),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2813),
    [anon_sym_u_DQUOTE] = ACTIONS(2813),
    [anon_sym_U_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8_DQUOTE] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2817),
    [anon_sym_LR_DQUOTE] = ACTIONS(2817),
    [anon_sym_uR_DQUOTE] = ACTIONS(2817),
    [anon_sym_UR_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2817),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1095] = {
    [sym_expression] = STATE(4828),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(9018),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_COLON] = ACTIONS(4492),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1096] = {
    [sym_expression] = STATE(4994),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8654),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_COLON] = ACTIONS(4494),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1097] = {
    [sym_expression] = STATE(4629),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_initializer_list] = STATE(4255),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1098] = {
    [sym_expression] = STATE(4856),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8869),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_COLON] = ACTIONS(4496),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1099] = {
    [sym_expression] = STATE(4958),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_initializer_list] = STATE(4255),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1100] = {
    [sym_expression] = STATE(4788),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8655),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_COLON] = ACTIONS(4498),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1101] = {
    [sym_expression] = STATE(4800),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(8109),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1102] = {
    [sym_expression] = STATE(4888),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8618),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_COLON] = ACTIONS(4500),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1103] = {
    [sym_expression] = STATE(3807),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_initializer_list] = STATE(4185),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACE] = ACTIONS(3454),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1104] = {
    [sym_expression] = STATE(4655),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_initializer_list] = STATE(7480),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1105] = {
    [sym_expression] = STATE(4780),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_initializer_list] = STATE(5237),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8015),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(8015),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACE] = ACTIONS(3752),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3754),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [1106] = {
    [sym_expression] = STATE(4925),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_initializer_list] = STATE(4246),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1107] = {
    [sym_expression] = STATE(4748),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8691),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_RPAREN] = ACTIONS(4502),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1108] = {
    [sym_expression] = STATE(4996),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8197),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_COLON] = ACTIONS(4504),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1109] = {
    [sym_expression] = STATE(5108),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(8681),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1110] = {
    [sym_expression] = STATE(4339),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3068),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3068),
    [sym_call_expression] = STATE(3068),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3068),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3068),
    [sym_initializer_list] = STATE(4246),
    [sym_char_literal] = STATE(4482),
    [sym_concatenated_string] = STATE(4479),
    [sym_string_literal] = STATE(3097),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3096),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3068),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3068),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(4415),
    [anon_sym_LPAREN2] = ACTIONS(4506),
    [anon_sym_BANG] = ACTIONS(3582),
    [anon_sym_TILDE] = ACTIONS(3582),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_compl] = ACTIONS(3580),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(3588),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3590),
    [anon_sym_L_SQUOTE] = ACTIONS(3592),
    [anon_sym_u_SQUOTE] = ACTIONS(3592),
    [anon_sym_U_SQUOTE] = ACTIONS(3592),
    [anon_sym_u8_SQUOTE] = ACTIONS(3592),
    [anon_sym_SQUOTE] = ACTIONS(3592),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3596),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [anon_sym_co_await] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_requires] = ACTIONS(3604),
    [sym_this] = ACTIONS(221),
  },
  [1111] = {
    [sym_expression] = STATE(4742),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8736),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_COLON] = ACTIONS(4508),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1112] = {
    [sym_expression] = STATE(4849),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8680),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_RPAREN] = ACTIONS(4510),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1113] = {
    [sym_expression] = STATE(2499),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_initializer_list] = STATE(2690),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1114] = {
    [sym_expression] = STATE(2471),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_COMMA] = ACTIONS(4514),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4514),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1115] = {
    [sym_expression] = STATE(4929),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8835),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_COLON] = ACTIONS(4516),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1116] = {
    [sym_expression] = STATE(3371),
    [sym__string] = STATE(3926),
    [sym_conditional_expression] = STATE(3926),
    [sym_assignment_expression] = STATE(3926),
    [sym_pointer_expression] = STATE(3934),
    [sym_unary_expression] = STATE(3926),
    [sym_binary_expression] = STATE(3926),
    [sym_update_expression] = STATE(3926),
    [sym_cast_expression] = STATE(3926),
    [sym_sizeof_expression] = STATE(3926),
    [sym_alignof_expression] = STATE(3926),
    [sym_offsetof_expression] = STATE(3926),
    [sym_generic_expression] = STATE(3926),
    [sym_subscript_expression] = STATE(3934),
    [sym_call_expression] = STATE(3934),
    [sym_gnu_asm_expression] = STATE(3926),
    [sym_field_expression] = STATE(3934),
    [sym_compound_literal_expression] = STATE(3926),
    [sym_parenthesized_expression] = STATE(3934),
    [sym_initializer_list] = STATE(3942),
    [sym_char_literal] = STATE(3755),
    [sym_concatenated_string] = STATE(3759),
    [sym_string_literal] = STATE(2463),
    [sym_null] = STATE(3926),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7876),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3926),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3926),
    [sym_new_expression] = STATE(3926),
    [sym_delete_expression] = STATE(3926),
    [sym_requires_clause] = STATE(3926),
    [sym_requires_expression] = STATE(3926),
    [sym_lambda_expression] = STATE(3926),
    [sym_lambda_capture_specifier] = STATE(6169),
    [sym_fold_expression] = STATE(3926),
    [sym_parameter_pack_expansion] = STATE(3926),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3934),
    [sym_qualified_type_identifier] = STATE(7876),
    [sym_user_defined_literal] = STATE(3934),
    [sym_kernel_call_expression] = STATE(3930),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(4518),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3291),
    [anon_sym_not] = ACTIONS(3283),
    [anon_sym_compl] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(4351),
    [anon_sym_PLUS_PLUS] = ACTIONS(4351),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3295),
    [anon_sym___alignof] = ACTIONS(3295),
    [anon_sym__alignof] = ACTIONS(3295),
    [anon_sym_alignof] = ACTIONS(3295),
    [anon_sym__Alignof] = ACTIONS(3295),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3299),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [sym_number_literal] = ACTIONS(3303),
    [anon_sym_L_SQUOTE] = ACTIONS(3305),
    [anon_sym_u_SQUOTE] = ACTIONS(3305),
    [anon_sym_U_SQUOTE] = ACTIONS(3305),
    [anon_sym_u8_SQUOTE] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_L_DQUOTE] = ACTIONS(3307),
    [anon_sym_u_DQUOTE] = ACTIONS(3307),
    [anon_sym_U_DQUOTE] = ACTIONS(3307),
    [anon_sym_u8_DQUOTE] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [anon_sym_NULL] = ACTIONS(3311),
    [anon_sym_nullptr] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_R_DQUOTE] = ACTIONS(3315),
    [anon_sym_LR_DQUOTE] = ACTIONS(3315),
    [anon_sym_uR_DQUOTE] = ACTIONS(3315),
    [anon_sym_UR_DQUOTE] = ACTIONS(3315),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3315),
    [anon_sym_co_await] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_requires] = ACTIONS(3321),
    [sym_this] = ACTIONS(3309),
  },
  [1117] = {
    [sym_expression] = STATE(4860),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8679),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_RPAREN] = ACTIONS(4520),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1118] = {
    [sym_expression] = STATE(4937),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8247),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_COLON] = ACTIONS(4522),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1119] = {
    [sym_expression] = STATE(3126),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_initializer_list] = STATE(3803),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1120] = {
    [sym_expression] = STATE(4956),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(8192),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1121] = {
    [sym_expression] = STATE(5039),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(8750),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1122] = {
    [sym_expression] = STATE(4987),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(9028),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_COLON] = ACTIONS(4524),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1123] = {
    [sym_expression] = STATE(4904),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(9044),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_COLON] = ACTIONS(4526),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1124] = {
    [sym_expression] = STATE(4796),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_initializer_list] = STATE(5236),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8015),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(8015),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACE] = ACTIONS(3752),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3754),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [1125] = {
    [sym_expression] = STATE(4954),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_initializer_list] = STATE(4255),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1126] = {
    [sym_expression] = STATE(4535),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_initializer_list] = STATE(4246),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1127] = {
    [sym_expression] = STATE(4868),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_initializer_list] = STATE(7903),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1128] = {
    [sym_expression] = STATE(4857),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(8174),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1129] = {
    [sym_expression] = STATE(4917),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8326),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_RPAREN] = ACTIONS(4528),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1130] = {
    [sym_expression] = STATE(4867),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8930),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_COLON] = ACTIONS(4530),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1131] = {
    [sym_expression] = STATE(4918),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8325),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_RPAREN] = ACTIONS(4532),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1132] = {
    [sym_expression] = STATE(4339),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_initializer_list] = STATE(4246),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1133] = {
    [sym_expression] = STATE(4730),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(7509),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4534),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1134] = {
    [sym_expression] = STATE(4866),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(8400),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_COLON] = ACTIONS(4537),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1135] = {
    [sym_expression] = STATE(3477),
    [sym__string] = STATE(2628),
    [sym_comma_expression] = STATE(8499),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym__assignment_expression_lhs] = STATE(8481),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1136] = {
    [sym_expression] = STATE(3486),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_initializer_list] = STATE(2690),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4539),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3335),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(3331),
    [anon_sym_compl] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(4365),
    [anon_sym_PLUS_PLUS] = ACTIONS(4365),
    [anon_sym_sizeof] = ACTIONS(3337),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3339),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1137] = {
    [sym_expression] = STATE(4427),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3068),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3068),
    [sym_call_expression] = STATE(3068),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3068),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3068),
    [sym_initializer_list] = STATE(4255),
    [sym_char_literal] = STATE(4482),
    [sym_concatenated_string] = STATE(4479),
    [sym_string_literal] = STATE(3097),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3096),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3068),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3068),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(4415),
    [anon_sym_LPAREN2] = ACTIONS(4506),
    [anon_sym_BANG] = ACTIONS(3582),
    [anon_sym_TILDE] = ACTIONS(3582),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_compl] = ACTIONS(3580),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(3588),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3590),
    [anon_sym_L_SQUOTE] = ACTIONS(3592),
    [anon_sym_u_SQUOTE] = ACTIONS(3592),
    [anon_sym_U_SQUOTE] = ACTIONS(3592),
    [anon_sym_u8_SQUOTE] = ACTIONS(3592),
    [anon_sym_SQUOTE] = ACTIONS(3592),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3596),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [anon_sym_co_await] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_requires] = ACTIONS(3604),
    [sym_this] = ACTIONS(221),
  },
  [1138] = {
    [sym_expression] = STATE(3268),
    [sym__string] = STATE(3860),
    [sym_conditional_expression] = STATE(3860),
    [sym_assignment_expression] = STATE(3860),
    [sym_pointer_expression] = STATE(3861),
    [sym_unary_expression] = STATE(3860),
    [sym_binary_expression] = STATE(3860),
    [sym_update_expression] = STATE(3860),
    [sym_cast_expression] = STATE(3860),
    [sym_sizeof_expression] = STATE(3860),
    [sym_alignof_expression] = STATE(3860),
    [sym_offsetof_expression] = STATE(3860),
    [sym_generic_expression] = STATE(3860),
    [sym_subscript_expression] = STATE(3861),
    [sym_call_expression] = STATE(3861),
    [sym_gnu_asm_expression] = STATE(3860),
    [sym_field_expression] = STATE(3861),
    [sym_compound_literal_expression] = STATE(3860),
    [sym_parenthesized_expression] = STATE(3861),
    [sym_initializer_list] = STATE(3969),
    [sym_char_literal] = STATE(3831),
    [sym_concatenated_string] = STATE(3833),
    [sym_string_literal] = STATE(2490),
    [sym_null] = STATE(3860),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7980),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3860),
    [sym_raw_string_literal] = STATE(2516),
    [sym_co_await_expression] = STATE(3860),
    [sym_new_expression] = STATE(3860),
    [sym_delete_expression] = STATE(3860),
    [sym_requires_clause] = STATE(3860),
    [sym_requires_expression] = STATE(3860),
    [sym_lambda_expression] = STATE(3860),
    [sym_lambda_capture_specifier] = STATE(6189),
    [sym_fold_expression] = STATE(3860),
    [sym_parameter_pack_expansion] = STATE(3860),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3861),
    [sym_qualified_type_identifier] = STATE(7980),
    [sym_user_defined_literal] = STATE(3861),
    [sym_kernel_call_expression] = STATE(3851),
    [sym_identifier] = ACTIONS(3179),
    [anon_sym_LPAREN2] = ACTIONS(4541),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3185),
    [anon_sym_LBRACE] = ACTIONS(3187),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3189),
    [anon_sym_not] = ACTIONS(3181),
    [anon_sym_compl] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(4357),
    [anon_sym_PLUS_PLUS] = ACTIONS(4357),
    [anon_sym_sizeof] = ACTIONS(3191),
    [anon_sym___alignof__] = ACTIONS(3193),
    [anon_sym___alignof] = ACTIONS(3193),
    [anon_sym__alignof] = ACTIONS(3193),
    [anon_sym_alignof] = ACTIONS(3193),
    [anon_sym__Alignof] = ACTIONS(3193),
    [anon_sym_offsetof] = ACTIONS(3195),
    [anon_sym__Generic] = ACTIONS(3197),
    [anon_sym_asm] = ACTIONS(3199),
    [anon_sym___asm__] = ACTIONS(3199),
    [sym_number_literal] = ACTIONS(3201),
    [anon_sym_L_SQUOTE] = ACTIONS(3203),
    [anon_sym_u_SQUOTE] = ACTIONS(3203),
    [anon_sym_U_SQUOTE] = ACTIONS(3203),
    [anon_sym_u8_SQUOTE] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [anon_sym_L_DQUOTE] = ACTIONS(3205),
    [anon_sym_u_DQUOTE] = ACTIONS(3205),
    [anon_sym_U_DQUOTE] = ACTIONS(3205),
    [anon_sym_u8_DQUOTE] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [anon_sym_NULL] = ACTIONS(3209),
    [anon_sym_nullptr] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_R_DQUOTE] = ACTIONS(3213),
    [anon_sym_LR_DQUOTE] = ACTIONS(3213),
    [anon_sym_uR_DQUOTE] = ACTIONS(3213),
    [anon_sym_UR_DQUOTE] = ACTIONS(3213),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3213),
    [anon_sym_co_await] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_requires] = ACTIONS(3219),
    [sym_this] = ACTIONS(3207),
  },
  [1139] = {
    [sym_expression] = STATE(4612),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(4255),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1140] = {
    [sym_expression] = STATE(4654),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_SEMI] = ACTIONS(4543),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(4545),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1141] = {
    [sym_expression] = STATE(3427),
    [sym__string] = STATE(3926),
    [sym_conditional_expression] = STATE(3926),
    [sym_assignment_expression] = STATE(3926),
    [sym_pointer_expression] = STATE(3934),
    [sym_unary_expression] = STATE(3926),
    [sym_binary_expression] = STATE(3926),
    [sym_update_expression] = STATE(3926),
    [sym_cast_expression] = STATE(3926),
    [sym_sizeof_expression] = STATE(3926),
    [sym_alignof_expression] = STATE(3926),
    [sym_offsetof_expression] = STATE(3926),
    [sym_generic_expression] = STATE(3926),
    [sym_subscript_expression] = STATE(3934),
    [sym_call_expression] = STATE(3934),
    [sym_gnu_asm_expression] = STATE(3926),
    [sym_field_expression] = STATE(3934),
    [sym_compound_literal_expression] = STATE(3926),
    [sym_parenthesized_expression] = STATE(3934),
    [sym_char_literal] = STATE(3755),
    [sym_concatenated_string] = STATE(3759),
    [sym_string_literal] = STATE(2463),
    [sym_null] = STATE(3926),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7876),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3926),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3926),
    [sym_new_expression] = STATE(3926),
    [sym_delete_expression] = STATE(3926),
    [sym_requires_clause] = STATE(3926),
    [sym_requires_expression] = STATE(3926),
    [sym_lambda_expression] = STATE(3926),
    [sym_lambda_capture_specifier] = STATE(6169),
    [sym_fold_expression] = STATE(3926),
    [sym_parameter_pack_expansion] = STATE(3926),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3934),
    [sym_qualified_type_identifier] = STATE(7876),
    [sym_user_defined_literal] = STATE(3934),
    [sym_kernel_call_expression] = STATE(3930),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4547),
    [anon_sym_LPAREN2] = ACTIONS(4549),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3291),
    [anon_sym_not] = ACTIONS(3283),
    [anon_sym_compl] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(4351),
    [anon_sym_PLUS_PLUS] = ACTIONS(4351),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3295),
    [anon_sym___alignof] = ACTIONS(3295),
    [anon_sym__alignof] = ACTIONS(3295),
    [anon_sym_alignof] = ACTIONS(3295),
    [anon_sym__Alignof] = ACTIONS(3295),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3299),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [sym_number_literal] = ACTIONS(3303),
    [anon_sym_L_SQUOTE] = ACTIONS(3305),
    [anon_sym_u_SQUOTE] = ACTIONS(3305),
    [anon_sym_U_SQUOTE] = ACTIONS(3305),
    [anon_sym_u8_SQUOTE] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_L_DQUOTE] = ACTIONS(3307),
    [anon_sym_u_DQUOTE] = ACTIONS(3307),
    [anon_sym_U_DQUOTE] = ACTIONS(3307),
    [anon_sym_u8_DQUOTE] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [anon_sym_NULL] = ACTIONS(3311),
    [anon_sym_nullptr] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_R_DQUOTE] = ACTIONS(3315),
    [anon_sym_LR_DQUOTE] = ACTIONS(3315),
    [anon_sym_uR_DQUOTE] = ACTIONS(3315),
    [anon_sym_UR_DQUOTE] = ACTIONS(3315),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3315),
    [anon_sym_co_await] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_requires] = ACTIONS(3321),
    [sym_this] = ACTIONS(3309),
  },
  [1142] = {
    [sym_expression] = STATE(2471),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4551),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1143] = {
    [sym_expression] = STATE(5069),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4553),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1144] = {
    [sym_expression] = STATE(3108),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4555),
    [anon_sym_LPAREN2] = ACTIONS(4557),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1145] = {
    [sym_expression] = STATE(2471),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4559),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1146] = {
    [sym_expression] = STATE(2471),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4561),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1147] = {
    [sym_expression] = STATE(5013),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4563),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1148] = {
    [sym_expression] = STATE(2471),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4565),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1149] = {
    [sym_identifier] = ACTIONS(4142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_RPAREN] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_TILDE] = ACTIONS(4149),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_STAR] = ACTIONS(4153),
    [anon_sym_SLASH] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4151),
    [anon_sym_CARET] = ACTIONS(4151),
    [anon_sym_AMP] = ACTIONS(4153),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT] = ACTIONS(4151),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4151),
    [anon_sym_LT] = ACTIONS(4151),
    [anon_sym_LT_LT] = ACTIONS(4151),
    [anon_sym_GT_GT] = ACTIONS(4151),
    [anon_sym___extension__] = ACTIONS(4142),
    [anon_sym___device__] = ACTIONS(4142),
    [anon_sym___host__] = ACTIONS(4142),
    [anon_sym___global__] = ACTIONS(4142),
    [anon_sym___forceinline__] = ACTIONS(4142),
    [anon_sym___noinline__] = ACTIONS(4142),
    [anon_sym_extern] = ACTIONS(4142),
    [anon_sym___attribute__] = ACTIONS(4142),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4149),
    [anon_sym___declspec] = ACTIONS(4142),
    [anon_sym___based] = ACTIONS(4142),
    [anon_sym_LBRACE] = ACTIONS(4149),
    [anon_sym_LBRACK] = ACTIONS(4153),
    [anon_sym_static] = ACTIONS(4142),
    [anon_sym_EQ] = ACTIONS(4153),
    [anon_sym_register] = ACTIONS(4142),
    [anon_sym_inline] = ACTIONS(4142),
    [anon_sym___inline] = ACTIONS(4142),
    [anon_sym___inline__] = ACTIONS(4142),
    [anon_sym___forceinline] = ACTIONS(4142),
    [anon_sym_thread_local] = ACTIONS(4142),
    [anon_sym___thread] = ACTIONS(4142),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_constexpr] = ACTIONS(4142),
    [anon_sym_volatile] = ACTIONS(4142),
    [anon_sym_restrict] = ACTIONS(4142),
    [anon_sym___restrict__] = ACTIONS(4142),
    [anon_sym__Atomic] = ACTIONS(4142),
    [anon_sym__Noreturn] = ACTIONS(4142),
    [anon_sym_noreturn] = ACTIONS(4142),
    [anon_sym_mutable] = ACTIONS(4142),
    [anon_sym_constinit] = ACTIONS(4142),
    [anon_sym_consteval] = ACTIONS(4142),
    [anon_sym___shared__] = ACTIONS(4142),
    [anon_sym___local__] = ACTIONS(4142),
    [anon_sym___constant__] = ACTIONS(4142),
    [anon_sym___managed__] = ACTIONS(4142),
    [anon_sym___grid_constant__] = ACTIONS(4142),
    [anon_sym_alignas] = ACTIONS(4142),
    [anon_sym__Alignas] = ACTIONS(4142),
    [anon_sym_QMARK] = ACTIONS(4144),
    [anon_sym_STAR_EQ] = ACTIONS(4144),
    [anon_sym_SLASH_EQ] = ACTIONS(4144),
    [anon_sym_PERCENT_EQ] = ACTIONS(4144),
    [anon_sym_PLUS_EQ] = ACTIONS(4144),
    [anon_sym_DASH_EQ] = ACTIONS(4144),
    [anon_sym_LT_LT_EQ] = ACTIONS(4144),
    [anon_sym_GT_GT_EQ] = ACTIONS(4144),
    [anon_sym_AMP_EQ] = ACTIONS(4144),
    [anon_sym_CARET_EQ] = ACTIONS(4144),
    [anon_sym_PIPE_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ_GT] = ACTIONS(4144),
    [anon_sym_or] = ACTIONS(4151),
    [anon_sym_and] = ACTIONS(4151),
    [anon_sym_bitor] = ACTIONS(4151),
    [anon_sym_xor] = ACTIONS(4151),
    [anon_sym_bitand] = ACTIONS(4151),
    [anon_sym_not_eq] = ACTIONS(4151),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_DOT_STAR] = ACTIONS(4144),
    [anon_sym_DASH_GT] = ACTIONS(4151),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4142),
    [anon_sym_decltype] = ACTIONS(4142),
    [sym_virtual] = ACTIONS(4142),
    [anon_sym_template] = ACTIONS(4142),
    [anon_sym_operator] = ACTIONS(4142),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4144),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4144),
    [anon_sym___launch_bounds__] = ACTIONS(4142),
  },
  [1150] = {
    [sym_expression] = STATE(4735),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(7509),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1151] = {
    [sym_expression] = STATE(5075),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4567),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1152] = {
    [sym_expression] = STATE(2471),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4569),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1153] = {
    [sym_expression] = STATE(5097),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_RPAREN] = ACTIONS(4571),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1154] = {
    [sym_expression] = STATE(5077),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4573),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1155] = {
    [sym_expression] = STATE(5073),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4575),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1156] = {
    [sym_expression] = STATE(5000),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4577),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1157] = {
    [sym_expression] = STATE(2471),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4579),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1158] = {
    [sym_identifier] = ACTIONS(3984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3986),
    [anon_sym_COMMA] = ACTIONS(3986),
    [anon_sym_RPAREN] = ACTIONS(3986),
    [anon_sym_LPAREN2] = ACTIONS(3986),
    [anon_sym_TILDE] = ACTIONS(3986),
    [anon_sym_DASH] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(3984),
    [anon_sym_SLASH] = ACTIONS(3984),
    [anon_sym_PERCENT] = ACTIONS(3984),
    [anon_sym_PIPE_PIPE] = ACTIONS(3986),
    [anon_sym_AMP_AMP] = ACTIONS(3986),
    [anon_sym_PIPE] = ACTIONS(3984),
    [anon_sym_CARET] = ACTIONS(3984),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_EQ_EQ] = ACTIONS(3986),
    [anon_sym_BANG_EQ] = ACTIONS(3986),
    [anon_sym_GT] = ACTIONS(3984),
    [anon_sym_GT_EQ] = ACTIONS(3986),
    [anon_sym_LT_EQ] = ACTIONS(3984),
    [anon_sym_LT] = ACTIONS(3984),
    [anon_sym_LT_LT] = ACTIONS(3984),
    [anon_sym_GT_GT] = ACTIONS(3984),
    [anon_sym___extension__] = ACTIONS(3984),
    [anon_sym___device__] = ACTIONS(3984),
    [anon_sym___host__] = ACTIONS(3984),
    [anon_sym___global__] = ACTIONS(3984),
    [anon_sym___forceinline__] = ACTIONS(3984),
    [anon_sym___noinline__] = ACTIONS(3984),
    [anon_sym_extern] = ACTIONS(3984),
    [anon_sym___attribute__] = ACTIONS(3984),
    [anon_sym_COLON_COLON] = ACTIONS(3986),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3986),
    [anon_sym___declspec] = ACTIONS(3984),
    [anon_sym___based] = ACTIONS(3984),
    [anon_sym_LBRACE] = ACTIONS(3986),
    [anon_sym_LBRACK] = ACTIONS(3984),
    [anon_sym_static] = ACTIONS(3984),
    [anon_sym_EQ] = ACTIONS(3984),
    [anon_sym_register] = ACTIONS(3984),
    [anon_sym_inline] = ACTIONS(3984),
    [anon_sym___inline] = ACTIONS(3984),
    [anon_sym___inline__] = ACTIONS(3984),
    [anon_sym___forceinline] = ACTIONS(3984),
    [anon_sym_thread_local] = ACTIONS(3984),
    [anon_sym___thread] = ACTIONS(3984),
    [anon_sym_const] = ACTIONS(3984),
    [anon_sym_constexpr] = ACTIONS(3984),
    [anon_sym_volatile] = ACTIONS(3984),
    [anon_sym_restrict] = ACTIONS(3984),
    [anon_sym___restrict__] = ACTIONS(3984),
    [anon_sym__Atomic] = ACTIONS(3984),
    [anon_sym__Noreturn] = ACTIONS(3984),
    [anon_sym_noreturn] = ACTIONS(3984),
    [anon_sym_mutable] = ACTIONS(3984),
    [anon_sym_constinit] = ACTIONS(3984),
    [anon_sym_consteval] = ACTIONS(3984),
    [anon_sym___shared__] = ACTIONS(3984),
    [anon_sym___local__] = ACTIONS(3984),
    [anon_sym___constant__] = ACTIONS(3984),
    [anon_sym___managed__] = ACTIONS(3984),
    [anon_sym___grid_constant__] = ACTIONS(3984),
    [anon_sym_alignas] = ACTIONS(3984),
    [anon_sym__Alignas] = ACTIONS(3984),
    [anon_sym_QMARK] = ACTIONS(3986),
    [anon_sym_STAR_EQ] = ACTIONS(3986),
    [anon_sym_SLASH_EQ] = ACTIONS(3986),
    [anon_sym_PERCENT_EQ] = ACTIONS(3986),
    [anon_sym_PLUS_EQ] = ACTIONS(3986),
    [anon_sym_DASH_EQ] = ACTIONS(3986),
    [anon_sym_LT_LT_EQ] = ACTIONS(3986),
    [anon_sym_GT_GT_EQ] = ACTIONS(3986),
    [anon_sym_AMP_EQ] = ACTIONS(3986),
    [anon_sym_CARET_EQ] = ACTIONS(3986),
    [anon_sym_PIPE_EQ] = ACTIONS(3986),
    [anon_sym_LT_EQ_GT] = ACTIONS(3986),
    [anon_sym_or] = ACTIONS(3984),
    [anon_sym_and] = ACTIONS(3984),
    [anon_sym_bitor] = ACTIONS(3984),
    [anon_sym_xor] = ACTIONS(3984),
    [anon_sym_bitand] = ACTIONS(3984),
    [anon_sym_not_eq] = ACTIONS(3984),
    [anon_sym_DASH_DASH] = ACTIONS(3986),
    [anon_sym_PLUS_PLUS] = ACTIONS(3986),
    [anon_sym_DOT] = ACTIONS(3984),
    [anon_sym_DOT_STAR] = ACTIONS(3986),
    [anon_sym_DASH_GT] = ACTIONS(3984),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3984),
    [anon_sym_decltype] = ACTIONS(3984),
    [sym_virtual] = ACTIONS(3984),
    [anon_sym_template] = ACTIONS(3984),
    [anon_sym_operator] = ACTIONS(3984),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3986),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3986),
    [anon_sym___launch_bounds__] = ACTIONS(3984),
  },
  [1159] = {
    [sym_expression] = STATE(2471),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4581),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1160] = {
    [sym_expression] = STATE(5149),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4583),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1161] = {
    [sym_expression] = STATE(5148),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4585),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1162] = {
    [sym_expression] = STATE(2504),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(2940),
    [sym_concatenated_string] = STATE(3000),
    [sym_string_literal] = STATE(2241),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2239),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4587),
    [anon_sym_LPAREN2] = ACTIONS(4589),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2512),
    [anon_sym_compl] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_sizeof] = ACTIONS(2522),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2532),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [anon_sym_co_await] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1163] = {
    [sym_expression] = STATE(2471),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4591),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1164] = {
    [sym_expression] = STATE(2504),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4587),
    [anon_sym_LPAREN2] = ACTIONS(4593),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1165] = {
    [sym_identifier] = ACTIONS(3980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3982),
    [anon_sym_COMMA] = ACTIONS(3982),
    [anon_sym_RPAREN] = ACTIONS(3982),
    [anon_sym_LPAREN2] = ACTIONS(3982),
    [anon_sym_TILDE] = ACTIONS(3982),
    [anon_sym_DASH] = ACTIONS(3980),
    [anon_sym_PLUS] = ACTIONS(3980),
    [anon_sym_STAR] = ACTIONS(3980),
    [anon_sym_SLASH] = ACTIONS(3980),
    [anon_sym_PERCENT] = ACTIONS(3980),
    [anon_sym_PIPE_PIPE] = ACTIONS(3982),
    [anon_sym_AMP_AMP] = ACTIONS(3982),
    [anon_sym_PIPE] = ACTIONS(3980),
    [anon_sym_CARET] = ACTIONS(3980),
    [anon_sym_AMP] = ACTIONS(3980),
    [anon_sym_EQ_EQ] = ACTIONS(3982),
    [anon_sym_BANG_EQ] = ACTIONS(3982),
    [anon_sym_GT] = ACTIONS(3980),
    [anon_sym_GT_EQ] = ACTIONS(3982),
    [anon_sym_LT_EQ] = ACTIONS(3980),
    [anon_sym_LT] = ACTIONS(3980),
    [anon_sym_LT_LT] = ACTIONS(3980),
    [anon_sym_GT_GT] = ACTIONS(3980),
    [anon_sym___extension__] = ACTIONS(3980),
    [anon_sym___device__] = ACTIONS(3980),
    [anon_sym___host__] = ACTIONS(3980),
    [anon_sym___global__] = ACTIONS(3980),
    [anon_sym___forceinline__] = ACTIONS(3980),
    [anon_sym___noinline__] = ACTIONS(3980),
    [anon_sym_extern] = ACTIONS(3980),
    [anon_sym___attribute__] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3982),
    [anon_sym___declspec] = ACTIONS(3980),
    [anon_sym___based] = ACTIONS(3980),
    [anon_sym_LBRACE] = ACTIONS(3982),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_static] = ACTIONS(3980),
    [anon_sym_EQ] = ACTIONS(3980),
    [anon_sym_register] = ACTIONS(3980),
    [anon_sym_inline] = ACTIONS(3980),
    [anon_sym___inline] = ACTIONS(3980),
    [anon_sym___inline__] = ACTIONS(3980),
    [anon_sym___forceinline] = ACTIONS(3980),
    [anon_sym_thread_local] = ACTIONS(3980),
    [anon_sym___thread] = ACTIONS(3980),
    [anon_sym_const] = ACTIONS(3980),
    [anon_sym_constexpr] = ACTIONS(3980),
    [anon_sym_volatile] = ACTIONS(3980),
    [anon_sym_restrict] = ACTIONS(3980),
    [anon_sym___restrict__] = ACTIONS(3980),
    [anon_sym__Atomic] = ACTIONS(3980),
    [anon_sym__Noreturn] = ACTIONS(3980),
    [anon_sym_noreturn] = ACTIONS(3980),
    [anon_sym_mutable] = ACTIONS(3980),
    [anon_sym_constinit] = ACTIONS(3980),
    [anon_sym_consteval] = ACTIONS(3980),
    [anon_sym___shared__] = ACTIONS(3980),
    [anon_sym___local__] = ACTIONS(3980),
    [anon_sym___constant__] = ACTIONS(3980),
    [anon_sym___managed__] = ACTIONS(3980),
    [anon_sym___grid_constant__] = ACTIONS(3980),
    [anon_sym_alignas] = ACTIONS(3980),
    [anon_sym__Alignas] = ACTIONS(3980),
    [anon_sym_QMARK] = ACTIONS(3982),
    [anon_sym_STAR_EQ] = ACTIONS(3982),
    [anon_sym_SLASH_EQ] = ACTIONS(3982),
    [anon_sym_PERCENT_EQ] = ACTIONS(3982),
    [anon_sym_PLUS_EQ] = ACTIONS(3982),
    [anon_sym_DASH_EQ] = ACTIONS(3982),
    [anon_sym_LT_LT_EQ] = ACTIONS(3982),
    [anon_sym_GT_GT_EQ] = ACTIONS(3982),
    [anon_sym_AMP_EQ] = ACTIONS(3982),
    [anon_sym_CARET_EQ] = ACTIONS(3982),
    [anon_sym_PIPE_EQ] = ACTIONS(3982),
    [anon_sym_LT_EQ_GT] = ACTIONS(3982),
    [anon_sym_or] = ACTIONS(3980),
    [anon_sym_and] = ACTIONS(3980),
    [anon_sym_bitor] = ACTIONS(3980),
    [anon_sym_xor] = ACTIONS(3980),
    [anon_sym_bitand] = ACTIONS(3980),
    [anon_sym_not_eq] = ACTIONS(3980),
    [anon_sym_DASH_DASH] = ACTIONS(3982),
    [anon_sym_PLUS_PLUS] = ACTIONS(3982),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_DOT_STAR] = ACTIONS(3982),
    [anon_sym_DASH_GT] = ACTIONS(3980),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3980),
    [anon_sym_decltype] = ACTIONS(3980),
    [sym_virtual] = ACTIONS(3980),
    [anon_sym_template] = ACTIONS(3980),
    [anon_sym_operator] = ACTIONS(3980),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3982),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3982),
    [anon_sym___launch_bounds__] = ACTIONS(3980),
  },
  [1166] = {
    [sym_expression] = STATE(2471),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4595),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1167] = {
    [sym_identifier] = ACTIONS(3996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3998),
    [anon_sym_COMMA] = ACTIONS(3998),
    [anon_sym_RPAREN] = ACTIONS(3998),
    [anon_sym_LPAREN2] = ACTIONS(3998),
    [anon_sym_TILDE] = ACTIONS(3998),
    [anon_sym_DASH] = ACTIONS(3996),
    [anon_sym_PLUS] = ACTIONS(3996),
    [anon_sym_STAR] = ACTIONS(3996),
    [anon_sym_SLASH] = ACTIONS(3996),
    [anon_sym_PERCENT] = ACTIONS(3996),
    [anon_sym_PIPE_PIPE] = ACTIONS(3998),
    [anon_sym_AMP_AMP] = ACTIONS(3998),
    [anon_sym_PIPE] = ACTIONS(3996),
    [anon_sym_CARET] = ACTIONS(3996),
    [anon_sym_AMP] = ACTIONS(3996),
    [anon_sym_EQ_EQ] = ACTIONS(3998),
    [anon_sym_BANG_EQ] = ACTIONS(3998),
    [anon_sym_GT] = ACTIONS(3996),
    [anon_sym_GT_EQ] = ACTIONS(3998),
    [anon_sym_LT_EQ] = ACTIONS(3996),
    [anon_sym_LT] = ACTIONS(3996),
    [anon_sym_LT_LT] = ACTIONS(3996),
    [anon_sym_GT_GT] = ACTIONS(3996),
    [anon_sym___extension__] = ACTIONS(3996),
    [anon_sym___device__] = ACTIONS(3996),
    [anon_sym___host__] = ACTIONS(3996),
    [anon_sym___global__] = ACTIONS(3996),
    [anon_sym___forceinline__] = ACTIONS(3996),
    [anon_sym___noinline__] = ACTIONS(3996),
    [anon_sym_extern] = ACTIONS(3996),
    [anon_sym___attribute__] = ACTIONS(3996),
    [anon_sym_COLON_COLON] = ACTIONS(3998),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3998),
    [anon_sym___declspec] = ACTIONS(3996),
    [anon_sym___based] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(3998),
    [anon_sym_LBRACK] = ACTIONS(3996),
    [anon_sym_static] = ACTIONS(3996),
    [anon_sym_EQ] = ACTIONS(3996),
    [anon_sym_register] = ACTIONS(3996),
    [anon_sym_inline] = ACTIONS(3996),
    [anon_sym___inline] = ACTIONS(3996),
    [anon_sym___inline__] = ACTIONS(3996),
    [anon_sym___forceinline] = ACTIONS(3996),
    [anon_sym_thread_local] = ACTIONS(3996),
    [anon_sym___thread] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3996),
    [anon_sym_constexpr] = ACTIONS(3996),
    [anon_sym_volatile] = ACTIONS(3996),
    [anon_sym_restrict] = ACTIONS(3996),
    [anon_sym___restrict__] = ACTIONS(3996),
    [anon_sym__Atomic] = ACTIONS(3996),
    [anon_sym__Noreturn] = ACTIONS(3996),
    [anon_sym_noreturn] = ACTIONS(3996),
    [anon_sym_mutable] = ACTIONS(3996),
    [anon_sym_constinit] = ACTIONS(3996),
    [anon_sym_consteval] = ACTIONS(3996),
    [anon_sym___shared__] = ACTIONS(3996),
    [anon_sym___local__] = ACTIONS(3996),
    [anon_sym___constant__] = ACTIONS(3996),
    [anon_sym___managed__] = ACTIONS(3996),
    [anon_sym___grid_constant__] = ACTIONS(3996),
    [anon_sym_alignas] = ACTIONS(3996),
    [anon_sym__Alignas] = ACTIONS(3996),
    [anon_sym_QMARK] = ACTIONS(3998),
    [anon_sym_STAR_EQ] = ACTIONS(3998),
    [anon_sym_SLASH_EQ] = ACTIONS(3998),
    [anon_sym_PERCENT_EQ] = ACTIONS(3998),
    [anon_sym_PLUS_EQ] = ACTIONS(3998),
    [anon_sym_DASH_EQ] = ACTIONS(3998),
    [anon_sym_LT_LT_EQ] = ACTIONS(3998),
    [anon_sym_GT_GT_EQ] = ACTIONS(3998),
    [anon_sym_AMP_EQ] = ACTIONS(3998),
    [anon_sym_CARET_EQ] = ACTIONS(3998),
    [anon_sym_PIPE_EQ] = ACTIONS(3998),
    [anon_sym_LT_EQ_GT] = ACTIONS(3998),
    [anon_sym_or] = ACTIONS(3996),
    [anon_sym_and] = ACTIONS(3996),
    [anon_sym_bitor] = ACTIONS(3996),
    [anon_sym_xor] = ACTIONS(3996),
    [anon_sym_bitand] = ACTIONS(3996),
    [anon_sym_not_eq] = ACTIONS(3996),
    [anon_sym_DASH_DASH] = ACTIONS(3998),
    [anon_sym_PLUS_PLUS] = ACTIONS(3998),
    [anon_sym_DOT] = ACTIONS(3996),
    [anon_sym_DOT_STAR] = ACTIONS(3998),
    [anon_sym_DASH_GT] = ACTIONS(3996),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3996),
    [anon_sym_decltype] = ACTIONS(3996),
    [sym_virtual] = ACTIONS(3996),
    [anon_sym_template] = ACTIONS(3996),
    [anon_sym_operator] = ACTIONS(3996),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3998),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3998),
    [anon_sym___launch_bounds__] = ACTIONS(3996),
  },
  [1168] = {
    [sym_expression] = STATE(4654),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_SEMI] = ACTIONS(4597),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(4545),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1169] = {
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3994),
    [anon_sym_COMMA] = ACTIONS(3994),
    [anon_sym_RPAREN] = ACTIONS(3994),
    [anon_sym_LPAREN2] = ACTIONS(3994),
    [anon_sym_TILDE] = ACTIONS(3994),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_STAR] = ACTIONS(3992),
    [anon_sym_SLASH] = ACTIONS(3992),
    [anon_sym_PERCENT] = ACTIONS(3992),
    [anon_sym_PIPE_PIPE] = ACTIONS(3994),
    [anon_sym_AMP_AMP] = ACTIONS(3994),
    [anon_sym_PIPE] = ACTIONS(3992),
    [anon_sym_CARET] = ACTIONS(3992),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym_EQ_EQ] = ACTIONS(3994),
    [anon_sym_BANG_EQ] = ACTIONS(3994),
    [anon_sym_GT] = ACTIONS(3992),
    [anon_sym_GT_EQ] = ACTIONS(3994),
    [anon_sym_LT_EQ] = ACTIONS(3992),
    [anon_sym_LT] = ACTIONS(3992),
    [anon_sym_LT_LT] = ACTIONS(3992),
    [anon_sym_GT_GT] = ACTIONS(3992),
    [anon_sym___extension__] = ACTIONS(3992),
    [anon_sym___device__] = ACTIONS(3992),
    [anon_sym___host__] = ACTIONS(3992),
    [anon_sym___global__] = ACTIONS(3992),
    [anon_sym___forceinline__] = ACTIONS(3992),
    [anon_sym___noinline__] = ACTIONS(3992),
    [anon_sym_extern] = ACTIONS(3992),
    [anon_sym___attribute__] = ACTIONS(3992),
    [anon_sym_COLON_COLON] = ACTIONS(3994),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3994),
    [anon_sym___declspec] = ACTIONS(3992),
    [anon_sym___based] = ACTIONS(3992),
    [anon_sym_LBRACE] = ACTIONS(3994),
    [anon_sym_LBRACK] = ACTIONS(3992),
    [anon_sym_static] = ACTIONS(3992),
    [anon_sym_EQ] = ACTIONS(3992),
    [anon_sym_register] = ACTIONS(3992),
    [anon_sym_inline] = ACTIONS(3992),
    [anon_sym___inline] = ACTIONS(3992),
    [anon_sym___inline__] = ACTIONS(3992),
    [anon_sym___forceinline] = ACTIONS(3992),
    [anon_sym_thread_local] = ACTIONS(3992),
    [anon_sym___thread] = ACTIONS(3992),
    [anon_sym_const] = ACTIONS(3992),
    [anon_sym_constexpr] = ACTIONS(3992),
    [anon_sym_volatile] = ACTIONS(3992),
    [anon_sym_restrict] = ACTIONS(3992),
    [anon_sym___restrict__] = ACTIONS(3992),
    [anon_sym__Atomic] = ACTIONS(3992),
    [anon_sym__Noreturn] = ACTIONS(3992),
    [anon_sym_noreturn] = ACTIONS(3992),
    [anon_sym_mutable] = ACTIONS(3992),
    [anon_sym_constinit] = ACTIONS(3992),
    [anon_sym_consteval] = ACTIONS(3992),
    [anon_sym___shared__] = ACTIONS(3992),
    [anon_sym___local__] = ACTIONS(3992),
    [anon_sym___constant__] = ACTIONS(3992),
    [anon_sym___managed__] = ACTIONS(3992),
    [anon_sym___grid_constant__] = ACTIONS(3992),
    [anon_sym_alignas] = ACTIONS(3992),
    [anon_sym__Alignas] = ACTIONS(3992),
    [anon_sym_QMARK] = ACTIONS(3994),
    [anon_sym_STAR_EQ] = ACTIONS(3994),
    [anon_sym_SLASH_EQ] = ACTIONS(3994),
    [anon_sym_PERCENT_EQ] = ACTIONS(3994),
    [anon_sym_PLUS_EQ] = ACTIONS(3994),
    [anon_sym_DASH_EQ] = ACTIONS(3994),
    [anon_sym_LT_LT_EQ] = ACTIONS(3994),
    [anon_sym_GT_GT_EQ] = ACTIONS(3994),
    [anon_sym_AMP_EQ] = ACTIONS(3994),
    [anon_sym_CARET_EQ] = ACTIONS(3994),
    [anon_sym_PIPE_EQ] = ACTIONS(3994),
    [anon_sym_LT_EQ_GT] = ACTIONS(3994),
    [anon_sym_or] = ACTIONS(3992),
    [anon_sym_and] = ACTIONS(3992),
    [anon_sym_bitor] = ACTIONS(3992),
    [anon_sym_xor] = ACTIONS(3992),
    [anon_sym_bitand] = ACTIONS(3992),
    [anon_sym_not_eq] = ACTIONS(3992),
    [anon_sym_DASH_DASH] = ACTIONS(3994),
    [anon_sym_PLUS_PLUS] = ACTIONS(3994),
    [anon_sym_DOT] = ACTIONS(3992),
    [anon_sym_DOT_STAR] = ACTIONS(3994),
    [anon_sym_DASH_GT] = ACTIONS(3992),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3992),
    [anon_sym_decltype] = ACTIONS(3992),
    [sym_virtual] = ACTIONS(3992),
    [anon_sym_template] = ACTIONS(3992),
    [anon_sym_operator] = ACTIONS(3992),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3994),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3994),
    [anon_sym___launch_bounds__] = ACTIONS(3992),
  },
  [1170] = {
    [sym_expression] = STATE(5092),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4599),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1171] = {
    [sym_identifier] = ACTIONS(4021),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_RPAREN] = ACTIONS(4023),
    [anon_sym_LPAREN2] = ACTIONS(4023),
    [anon_sym_TILDE] = ACTIONS(4023),
    [anon_sym_DASH] = ACTIONS(4021),
    [anon_sym_PLUS] = ACTIONS(4021),
    [anon_sym_STAR] = ACTIONS(4021),
    [anon_sym_SLASH] = ACTIONS(4021),
    [anon_sym_PERCENT] = ACTIONS(4021),
    [anon_sym_PIPE_PIPE] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4023),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_CARET] = ACTIONS(4021),
    [anon_sym_AMP] = ACTIONS(4021),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4021),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4021),
    [anon_sym___extension__] = ACTIONS(4021),
    [anon_sym___device__] = ACTIONS(4021),
    [anon_sym___host__] = ACTIONS(4021),
    [anon_sym___global__] = ACTIONS(4021),
    [anon_sym___forceinline__] = ACTIONS(4021),
    [anon_sym___noinline__] = ACTIONS(4021),
    [anon_sym_extern] = ACTIONS(4021),
    [anon_sym___attribute__] = ACTIONS(4021),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4023),
    [anon_sym___declspec] = ACTIONS(4021),
    [anon_sym___based] = ACTIONS(4021),
    [anon_sym_LBRACE] = ACTIONS(4023),
    [anon_sym_LBRACK] = ACTIONS(4021),
    [anon_sym_static] = ACTIONS(4021),
    [anon_sym_EQ] = ACTIONS(4021),
    [anon_sym_register] = ACTIONS(4021),
    [anon_sym_inline] = ACTIONS(4021),
    [anon_sym___inline] = ACTIONS(4021),
    [anon_sym___inline__] = ACTIONS(4021),
    [anon_sym___forceinline] = ACTIONS(4021),
    [anon_sym_thread_local] = ACTIONS(4021),
    [anon_sym___thread] = ACTIONS(4021),
    [anon_sym_const] = ACTIONS(4021),
    [anon_sym_constexpr] = ACTIONS(4021),
    [anon_sym_volatile] = ACTIONS(4021),
    [anon_sym_restrict] = ACTIONS(4021),
    [anon_sym___restrict__] = ACTIONS(4021),
    [anon_sym__Atomic] = ACTIONS(4021),
    [anon_sym__Noreturn] = ACTIONS(4021),
    [anon_sym_noreturn] = ACTIONS(4021),
    [anon_sym_mutable] = ACTIONS(4021),
    [anon_sym_constinit] = ACTIONS(4021),
    [anon_sym_consteval] = ACTIONS(4021),
    [anon_sym___shared__] = ACTIONS(4021),
    [anon_sym___local__] = ACTIONS(4021),
    [anon_sym___constant__] = ACTIONS(4021),
    [anon_sym___managed__] = ACTIONS(4021),
    [anon_sym___grid_constant__] = ACTIONS(4021),
    [anon_sym_alignas] = ACTIONS(4021),
    [anon_sym__Alignas] = ACTIONS(4021),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ_GT] = ACTIONS(4023),
    [anon_sym_or] = ACTIONS(4021),
    [anon_sym_and] = ACTIONS(4021),
    [anon_sym_bitor] = ACTIONS(4021),
    [anon_sym_xor] = ACTIONS(4021),
    [anon_sym_bitand] = ACTIONS(4021),
    [anon_sym_not_eq] = ACTIONS(4021),
    [anon_sym_DASH_DASH] = ACTIONS(4023),
    [anon_sym_PLUS_PLUS] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4021),
    [anon_sym_DOT_STAR] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4021),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4021),
    [anon_sym_decltype] = ACTIONS(4021),
    [sym_virtual] = ACTIONS(4021),
    [anon_sym_template] = ACTIONS(4021),
    [anon_sym_operator] = ACTIONS(4021),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4023),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4023),
    [anon_sym___launch_bounds__] = ACTIONS(4021),
  },
  [1172] = {
    [sym_identifier] = ACTIONS(4017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4019),
    [anon_sym_COMMA] = ACTIONS(4019),
    [anon_sym_RPAREN] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(4019),
    [anon_sym_TILDE] = ACTIONS(4019),
    [anon_sym_DASH] = ACTIONS(4017),
    [anon_sym_PLUS] = ACTIONS(4017),
    [anon_sym_STAR] = ACTIONS(4017),
    [anon_sym_SLASH] = ACTIONS(4017),
    [anon_sym_PERCENT] = ACTIONS(4017),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE] = ACTIONS(4017),
    [anon_sym_CARET] = ACTIONS(4017),
    [anon_sym_AMP] = ACTIONS(4017),
    [anon_sym_EQ_EQ] = ACTIONS(4019),
    [anon_sym_BANG_EQ] = ACTIONS(4019),
    [anon_sym_GT] = ACTIONS(4017),
    [anon_sym_GT_EQ] = ACTIONS(4019),
    [anon_sym_LT_EQ] = ACTIONS(4017),
    [anon_sym_LT] = ACTIONS(4017),
    [anon_sym_LT_LT] = ACTIONS(4017),
    [anon_sym_GT_GT] = ACTIONS(4017),
    [anon_sym___extension__] = ACTIONS(4017),
    [anon_sym___device__] = ACTIONS(4017),
    [anon_sym___host__] = ACTIONS(4017),
    [anon_sym___global__] = ACTIONS(4017),
    [anon_sym___forceinline__] = ACTIONS(4017),
    [anon_sym___noinline__] = ACTIONS(4017),
    [anon_sym_extern] = ACTIONS(4017),
    [anon_sym___attribute__] = ACTIONS(4017),
    [anon_sym_COLON_COLON] = ACTIONS(4019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4019),
    [anon_sym___declspec] = ACTIONS(4017),
    [anon_sym___based] = ACTIONS(4017),
    [anon_sym_LBRACE] = ACTIONS(4019),
    [anon_sym_LBRACK] = ACTIONS(4017),
    [anon_sym_static] = ACTIONS(4017),
    [anon_sym_EQ] = ACTIONS(4017),
    [anon_sym_register] = ACTIONS(4017),
    [anon_sym_inline] = ACTIONS(4017),
    [anon_sym___inline] = ACTIONS(4017),
    [anon_sym___inline__] = ACTIONS(4017),
    [anon_sym___forceinline] = ACTIONS(4017),
    [anon_sym_thread_local] = ACTIONS(4017),
    [anon_sym___thread] = ACTIONS(4017),
    [anon_sym_const] = ACTIONS(4017),
    [anon_sym_constexpr] = ACTIONS(4017),
    [anon_sym_volatile] = ACTIONS(4017),
    [anon_sym_restrict] = ACTIONS(4017),
    [anon_sym___restrict__] = ACTIONS(4017),
    [anon_sym__Atomic] = ACTIONS(4017),
    [anon_sym__Noreturn] = ACTIONS(4017),
    [anon_sym_noreturn] = ACTIONS(4017),
    [anon_sym_mutable] = ACTIONS(4017),
    [anon_sym_constinit] = ACTIONS(4017),
    [anon_sym_consteval] = ACTIONS(4017),
    [anon_sym___shared__] = ACTIONS(4017),
    [anon_sym___local__] = ACTIONS(4017),
    [anon_sym___constant__] = ACTIONS(4017),
    [anon_sym___managed__] = ACTIONS(4017),
    [anon_sym___grid_constant__] = ACTIONS(4017),
    [anon_sym_alignas] = ACTIONS(4017),
    [anon_sym__Alignas] = ACTIONS(4017),
    [anon_sym_QMARK] = ACTIONS(4019),
    [anon_sym_STAR_EQ] = ACTIONS(4019),
    [anon_sym_SLASH_EQ] = ACTIONS(4019),
    [anon_sym_PERCENT_EQ] = ACTIONS(4019),
    [anon_sym_PLUS_EQ] = ACTIONS(4019),
    [anon_sym_DASH_EQ] = ACTIONS(4019),
    [anon_sym_LT_LT_EQ] = ACTIONS(4019),
    [anon_sym_GT_GT_EQ] = ACTIONS(4019),
    [anon_sym_AMP_EQ] = ACTIONS(4019),
    [anon_sym_CARET_EQ] = ACTIONS(4019),
    [anon_sym_PIPE_EQ] = ACTIONS(4019),
    [anon_sym_LT_EQ_GT] = ACTIONS(4019),
    [anon_sym_or] = ACTIONS(4017),
    [anon_sym_and] = ACTIONS(4017),
    [anon_sym_bitor] = ACTIONS(4017),
    [anon_sym_xor] = ACTIONS(4017),
    [anon_sym_bitand] = ACTIONS(4017),
    [anon_sym_not_eq] = ACTIONS(4017),
    [anon_sym_DASH_DASH] = ACTIONS(4019),
    [anon_sym_PLUS_PLUS] = ACTIONS(4019),
    [anon_sym_DOT] = ACTIONS(4017),
    [anon_sym_DOT_STAR] = ACTIONS(4019),
    [anon_sym_DASH_GT] = ACTIONS(4017),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4017),
    [anon_sym_decltype] = ACTIONS(4017),
    [sym_virtual] = ACTIONS(4017),
    [anon_sym_template] = ACTIONS(4017),
    [anon_sym_operator] = ACTIONS(4017),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4019),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4019),
    [anon_sym___launch_bounds__] = ACTIONS(4017),
  },
  [1173] = {
    [sym_expression] = STATE(5017),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4601),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1174] = {
    [sym_identifier] = ACTIONS(3988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3990),
    [anon_sym_COMMA] = ACTIONS(3990),
    [anon_sym_RPAREN] = ACTIONS(3990),
    [anon_sym_LPAREN2] = ACTIONS(3990),
    [anon_sym_TILDE] = ACTIONS(3990),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_STAR] = ACTIONS(3988),
    [anon_sym_SLASH] = ACTIONS(3988),
    [anon_sym_PERCENT] = ACTIONS(3988),
    [anon_sym_PIPE_PIPE] = ACTIONS(3990),
    [anon_sym_AMP_AMP] = ACTIONS(3990),
    [anon_sym_PIPE] = ACTIONS(3988),
    [anon_sym_CARET] = ACTIONS(3988),
    [anon_sym_AMP] = ACTIONS(3988),
    [anon_sym_EQ_EQ] = ACTIONS(3990),
    [anon_sym_BANG_EQ] = ACTIONS(3990),
    [anon_sym_GT] = ACTIONS(3988),
    [anon_sym_GT_EQ] = ACTIONS(3990),
    [anon_sym_LT_EQ] = ACTIONS(3988),
    [anon_sym_LT] = ACTIONS(3988),
    [anon_sym_LT_LT] = ACTIONS(3988),
    [anon_sym_GT_GT] = ACTIONS(3988),
    [anon_sym___extension__] = ACTIONS(3988),
    [anon_sym___device__] = ACTIONS(3988),
    [anon_sym___host__] = ACTIONS(3988),
    [anon_sym___global__] = ACTIONS(3988),
    [anon_sym___forceinline__] = ACTIONS(3988),
    [anon_sym___noinline__] = ACTIONS(3988),
    [anon_sym_extern] = ACTIONS(3988),
    [anon_sym___attribute__] = ACTIONS(3988),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3990),
    [anon_sym___declspec] = ACTIONS(3988),
    [anon_sym___based] = ACTIONS(3988),
    [anon_sym_LBRACE] = ACTIONS(3990),
    [anon_sym_LBRACK] = ACTIONS(3988),
    [anon_sym_static] = ACTIONS(3988),
    [anon_sym_EQ] = ACTIONS(3988),
    [anon_sym_register] = ACTIONS(3988),
    [anon_sym_inline] = ACTIONS(3988),
    [anon_sym___inline] = ACTIONS(3988),
    [anon_sym___inline__] = ACTIONS(3988),
    [anon_sym___forceinline] = ACTIONS(3988),
    [anon_sym_thread_local] = ACTIONS(3988),
    [anon_sym___thread] = ACTIONS(3988),
    [anon_sym_const] = ACTIONS(3988),
    [anon_sym_constexpr] = ACTIONS(3988),
    [anon_sym_volatile] = ACTIONS(3988),
    [anon_sym_restrict] = ACTIONS(3988),
    [anon_sym___restrict__] = ACTIONS(3988),
    [anon_sym__Atomic] = ACTIONS(3988),
    [anon_sym__Noreturn] = ACTIONS(3988),
    [anon_sym_noreturn] = ACTIONS(3988),
    [anon_sym_mutable] = ACTIONS(3988),
    [anon_sym_constinit] = ACTIONS(3988),
    [anon_sym_consteval] = ACTIONS(3988),
    [anon_sym___shared__] = ACTIONS(3988),
    [anon_sym___local__] = ACTIONS(3988),
    [anon_sym___constant__] = ACTIONS(3988),
    [anon_sym___managed__] = ACTIONS(3988),
    [anon_sym___grid_constant__] = ACTIONS(3988),
    [anon_sym_alignas] = ACTIONS(3988),
    [anon_sym__Alignas] = ACTIONS(3988),
    [anon_sym_QMARK] = ACTIONS(3990),
    [anon_sym_STAR_EQ] = ACTIONS(3990),
    [anon_sym_SLASH_EQ] = ACTIONS(3990),
    [anon_sym_PERCENT_EQ] = ACTIONS(3990),
    [anon_sym_PLUS_EQ] = ACTIONS(3990),
    [anon_sym_DASH_EQ] = ACTIONS(3990),
    [anon_sym_LT_LT_EQ] = ACTIONS(3990),
    [anon_sym_GT_GT_EQ] = ACTIONS(3990),
    [anon_sym_AMP_EQ] = ACTIONS(3990),
    [anon_sym_CARET_EQ] = ACTIONS(3990),
    [anon_sym_PIPE_EQ] = ACTIONS(3990),
    [anon_sym_LT_EQ_GT] = ACTIONS(3990),
    [anon_sym_or] = ACTIONS(3988),
    [anon_sym_and] = ACTIONS(3988),
    [anon_sym_bitor] = ACTIONS(3988),
    [anon_sym_xor] = ACTIONS(3988),
    [anon_sym_bitand] = ACTIONS(3988),
    [anon_sym_not_eq] = ACTIONS(3988),
    [anon_sym_DASH_DASH] = ACTIONS(3990),
    [anon_sym_PLUS_PLUS] = ACTIONS(3990),
    [anon_sym_DOT] = ACTIONS(3988),
    [anon_sym_DOT_STAR] = ACTIONS(3990),
    [anon_sym_DASH_GT] = ACTIONS(3988),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3988),
    [anon_sym_decltype] = ACTIONS(3988),
    [sym_virtual] = ACTIONS(3988),
    [anon_sym_template] = ACTIONS(3988),
    [anon_sym_operator] = ACTIONS(3988),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3990),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3990),
    [anon_sym___launch_bounds__] = ACTIONS(3988),
  },
  [1175] = {
    [sym_expression] = STATE(5124),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4603),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1176] = {
    [sym_expression] = STATE(5087),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4605),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1177] = {
    [sym_expression] = STATE(5069),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4607),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1178] = {
    [sym_expression] = STATE(5062),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4609),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1179] = {
    [sym_expression] = STATE(5089),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4611),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1180] = {
    [sym_expression] = STATE(3761),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4613),
    [anon_sym_LPAREN2] = ACTIONS(4615),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1181] = {
    [sym_expression] = STATE(5058),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4617),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1182] = {
    [sym_expression] = STATE(2471),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4619),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1183] = {
    [sym_expression] = STATE(5029),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4621),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1184] = {
    [sym_expression] = STATE(2504),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3517),
    [sym_concatenated_string] = STATE(3520),
    [sym_string_literal] = STATE(2431),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2428),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4587),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_compl] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(4448),
    [anon_sym_PLUS_PLUS] = ACTIONS(4448),
    [anon_sym_sizeof] = ACTIONS(2807),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2813),
    [anon_sym_u_DQUOTE] = ACTIONS(2813),
    [anon_sym_U_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8_DQUOTE] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2817),
    [anon_sym_LR_DQUOTE] = ACTIONS(2817),
    [anon_sym_uR_DQUOTE] = ACTIONS(2817),
    [anon_sym_UR_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2817),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1185] = {
    [sym_expression] = STATE(4730),
    [sym__string] = STATE(4266),
    [sym_comma_expression] = STATE(7509),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1186] = {
    [sym_expression] = STATE(2471),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4625),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1187] = {
    [sym_expression] = STATE(5024),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4627),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1188] = {
    [sym_expression] = STATE(4792),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8015),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(8015),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4629),
    [anon_sym_LPAREN2] = ACTIONS(4631),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3754),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [1189] = {
    [sym_expression] = STATE(5038),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4633),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1190] = {
    [sym_expression] = STATE(5059),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4635),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1191] = {
    [sym_expression] = STATE(4326),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4637),
    [anon_sym_LPAREN2] = ACTIONS(4639),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1192] = {
    [sym_expression] = STATE(2471),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4641),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1193] = {
    [sym_expression] = STATE(3422),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4587),
    [anon_sym_LPAREN2] = ACTIONS(4643),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(3331),
    [anon_sym_compl] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(4365),
    [anon_sym_PLUS_PLUS] = ACTIONS(4365),
    [anon_sym_sizeof] = ACTIONS(3337),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3339),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1194] = {
    [sym_expression] = STATE(4861),
    [sym__string] = STATE(5255),
    [sym_conditional_expression] = STATE(5255),
    [sym_assignment_expression] = STATE(5255),
    [sym_pointer_expression] = STATE(3988),
    [sym_unary_expression] = STATE(5255),
    [sym_binary_expression] = STATE(5255),
    [sym_update_expression] = STATE(5255),
    [sym_cast_expression] = STATE(5255),
    [sym_sizeof_expression] = STATE(5255),
    [sym_alignof_expression] = STATE(5255),
    [sym_offsetof_expression] = STATE(5255),
    [sym_generic_expression] = STATE(5255),
    [sym_subscript_expression] = STATE(3988),
    [sym_call_expression] = STATE(3988),
    [sym_gnu_asm_expression] = STATE(5255),
    [sym_field_expression] = STATE(3988),
    [sym_compound_literal_expression] = STATE(5255),
    [sym_parenthesized_expression] = STATE(3988),
    [sym_char_literal] = STATE(5164),
    [sym_concatenated_string] = STATE(5162),
    [sym_string_literal] = STATE(4081),
    [sym_null] = STATE(5255),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5255),
    [sym_raw_string_literal] = STATE(4060),
    [sym_co_await_expression] = STATE(5255),
    [sym_new_expression] = STATE(5255),
    [sym_delete_expression] = STATE(5255),
    [sym_requires_clause] = STATE(5255),
    [sym_requires_expression] = STATE(5255),
    [sym_lambda_expression] = STATE(5255),
    [sym_lambda_capture_specifier] = STATE(6164),
    [sym_fold_expression] = STATE(5255),
    [sym_parameter_pack_expansion] = STATE(5255),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3988),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3988),
    [sym_kernel_call_expression] = STATE(5260),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4645),
    [anon_sym_LPAREN2] = ACTIONS(4647),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3718),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4452),
    [anon_sym_PLUS_PLUS] = ACTIONS(4452),
    [anon_sym_sizeof] = ACTIONS(3720),
    [anon_sym___alignof__] = ACTIONS(3722),
    [anon_sym___alignof] = ACTIONS(3722),
    [anon_sym__alignof] = ACTIONS(3722),
    [anon_sym_alignof] = ACTIONS(3722),
    [anon_sym__Alignof] = ACTIONS(3722),
    [anon_sym_offsetof] = ACTIONS(3724),
    [anon_sym__Generic] = ACTIONS(3726),
    [anon_sym_asm] = ACTIONS(3728),
    [anon_sym___asm__] = ACTIONS(3728),
    [sym_number_literal] = ACTIONS(3730),
    [anon_sym_L_SQUOTE] = ACTIONS(3732),
    [anon_sym_u_SQUOTE] = ACTIONS(3732),
    [anon_sym_U_SQUOTE] = ACTIONS(3732),
    [anon_sym_u8_SQUOTE] = ACTIONS(3732),
    [anon_sym_SQUOTE] = ACTIONS(3732),
    [anon_sym_L_DQUOTE] = ACTIONS(3734),
    [anon_sym_u_DQUOTE] = ACTIONS(3734),
    [anon_sym_U_DQUOTE] = ACTIONS(3734),
    [anon_sym_u8_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [sym_true] = ACTIONS(3736),
    [sym_false] = ACTIONS(3736),
    [anon_sym_NULL] = ACTIONS(3738),
    [anon_sym_nullptr] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3740),
    [anon_sym_R_DQUOTE] = ACTIONS(3742),
    [anon_sym_LR_DQUOTE] = ACTIONS(3742),
    [anon_sym_uR_DQUOTE] = ACTIONS(3742),
    [anon_sym_UR_DQUOTE] = ACTIONS(3742),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3742),
    [anon_sym_co_await] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3748),
    [sym_this] = ACTIONS(3736),
  },
  [1195] = {
    [sym_expression] = STATE(4326),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3068),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3068),
    [sym_call_expression] = STATE(3068),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3068),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3068),
    [sym_char_literal] = STATE(4482),
    [sym_concatenated_string] = STATE(4479),
    [sym_string_literal] = STATE(3097),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3096),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3068),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3068),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(4415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4637),
    [anon_sym_LPAREN2] = ACTIONS(4649),
    [anon_sym_BANG] = ACTIONS(3582),
    [anon_sym_TILDE] = ACTIONS(3582),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(3584),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_compl] = ACTIONS(3580),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(3588),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3590),
    [anon_sym_L_SQUOTE] = ACTIONS(3592),
    [anon_sym_u_SQUOTE] = ACTIONS(3592),
    [anon_sym_U_SQUOTE] = ACTIONS(3592),
    [anon_sym_u8_SQUOTE] = ACTIONS(3592),
    [anon_sym_SQUOTE] = ACTIONS(3592),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3596),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [anon_sym_co_await] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_requires] = ACTIONS(3604),
    [sym_this] = ACTIONS(221),
  },
  [1196] = {
    [sym_expression] = STATE(2471),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4651),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1197] = {
    [sym_expression] = STATE(4784),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4637),
    [anon_sym_LPAREN2] = ACTIONS(4653),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1198] = {
    [sym_expression] = STATE(3141),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4655),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1199] = {
    [sym_expression] = STATE(3190),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4658),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1200] = {
    [sym_expression] = STATE(3194),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4661),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1201] = {
    [sym_expression] = STATE(2471),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4664),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1202] = {
    [sym_expression] = STATE(3207),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4666),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1203] = {
    [sym_expression] = STATE(3204),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4669),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1204] = {
    [sym_expression] = STATE(5094),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4672),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1205] = {
    [sym_expression] = STATE(3202),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4674),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1206] = {
    [sym_expression] = STATE(5117),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_SEMI] = ACTIONS(4677),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1207] = {
    [sym_expression] = STATE(4517),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4637),
    [anon_sym_LPAREN2] = ACTIONS(4679),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1208] = {
    [sym_expression] = STATE(3707),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4655),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1209] = {
    [sym_expression] = STATE(3705),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4658),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1210] = {
    [sym_expression] = STATE(3588),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4661),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1211] = {
    [sym_expression] = STATE(3688),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4666),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1212] = {
    [sym_expression] = STATE(3687),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4669),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1213] = {
    [sym_expression] = STATE(3685),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4674),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1214] = {
    [sym_expression] = STATE(3712),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4681),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1215] = {
    [sym_expression] = STATE(3712),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4684),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1216] = {
    [sym_expression] = STATE(3710),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4687),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1217] = {
    [sym_expression] = STATE(3710),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4690),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1218] = {
    [sym_expression] = STATE(3710),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4693),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1219] = {
    [sym_expression] = STATE(3710),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4696),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1220] = {
    [sym_expression] = STATE(3707),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4699),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1221] = {
    [sym_expression] = STATE(3707),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4702),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1222] = {
    [sym_expression] = STATE(3705),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4705),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1223] = {
    [sym_expression] = STATE(3588),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4708),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1224] = {
    [sym_expression] = STATE(3688),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4711),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1225] = {
    [sym_expression] = STATE(4517),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4637),
    [anon_sym_LPAREN2] = ACTIONS(4714),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1226] = {
    [sym_expression] = STATE(3687),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4716),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1227] = {
    [sym_expression] = STATE(3175),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4681),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1228] = {
    [sym_expression] = STATE(3175),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4684),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1229] = {
    [sym_expression] = STATE(3176),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4687),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1230] = {
    [sym_expression] = STATE(3176),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4690),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1231] = {
    [sym_expression] = STATE(3176),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4693),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1232] = {
    [sym_expression] = STATE(2471),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4719),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1233] = {
    [sym_expression] = STATE(3176),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4696),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1234] = {
    [sym_expression] = STATE(3141),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4699),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1235] = {
    [sym_expression] = STATE(4654),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_SEMI] = ACTIONS(4721),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(4545),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1236] = {
    [sym_expression] = STATE(3141),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4702),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1237] = {
    [sym_expression] = STATE(3190),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4705),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1238] = {
    [sym_expression] = STATE(2471),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4723),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1239] = {
    [sym_expression] = STATE(2471),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4725),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1240] = {
    [sym_expression] = STATE(3685),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4727),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1241] = {
    [sym_expression] = STATE(3194),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4708),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1242] = {
    [sym_expression] = STATE(3207),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4711),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1243] = {
    [sym_expression] = STATE(3204),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4716),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1244] = {
    [sym_expression] = STATE(3202),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4727),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1245] = {
    [sym_expression] = STATE(3197),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4730),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1246] = {
    [sym_expression] = STATE(3682),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4730),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1247] = {
    [sym_expression] = STATE(2471),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4733),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1248] = {
    [sym_expression] = STATE(2471),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4735),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1249] = {
    [sym_expression] = STATE(2471),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4737),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1250] = {
    [sym_expression] = STATE(3197),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4739),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1251] = {
    [sym_expression] = STATE(3197),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4742),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1252] = {
    [sym_expression] = STATE(3196),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4745),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1253] = {
    [sym_expression] = STATE(3196),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4748),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1254] = {
    [sym_expression] = STATE(3682),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4739),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1255] = {
    [sym_expression] = STATE(3682),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4742),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1256] = {
    [sym_expression] = STATE(3679),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4745),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1257] = {
    [sym_expression] = STATE(3679),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4748),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1258] = {
    [sym_expression] = STATE(3308),
    [sym__string] = STATE(3860),
    [sym_conditional_expression] = STATE(3860),
    [sym_assignment_expression] = STATE(3860),
    [sym_pointer_expression] = STATE(3861),
    [sym_unary_expression] = STATE(3860),
    [sym_binary_expression] = STATE(3860),
    [sym_update_expression] = STATE(3860),
    [sym_cast_expression] = STATE(3860),
    [sym_sizeof_expression] = STATE(3860),
    [sym_alignof_expression] = STATE(3860),
    [sym_offsetof_expression] = STATE(3860),
    [sym_generic_expression] = STATE(3860),
    [sym_subscript_expression] = STATE(3861),
    [sym_call_expression] = STATE(3861),
    [sym_gnu_asm_expression] = STATE(3860),
    [sym_field_expression] = STATE(3861),
    [sym_compound_literal_expression] = STATE(3860),
    [sym_parenthesized_expression] = STATE(3861),
    [sym_char_literal] = STATE(3831),
    [sym_concatenated_string] = STATE(3833),
    [sym_string_literal] = STATE(2490),
    [sym_null] = STATE(3860),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7980),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3860),
    [sym_raw_string_literal] = STATE(2516),
    [sym_co_await_expression] = STATE(3860),
    [sym_new_expression] = STATE(3860),
    [sym_delete_expression] = STATE(3860),
    [sym_requires_clause] = STATE(3860),
    [sym_requires_expression] = STATE(3860),
    [sym_lambda_expression] = STATE(3860),
    [sym_lambda_capture_specifier] = STATE(6189),
    [sym_fold_expression] = STATE(3860),
    [sym_parameter_pack_expansion] = STATE(3860),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3861),
    [sym_qualified_type_identifier] = STATE(7980),
    [sym_user_defined_literal] = STATE(3861),
    [sym_kernel_call_expression] = STATE(3851),
    [sym_identifier] = ACTIONS(3179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4751),
    [anon_sym_LPAREN2] = ACTIONS(4753),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3185),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3189),
    [anon_sym_not] = ACTIONS(3181),
    [anon_sym_compl] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(4357),
    [anon_sym_PLUS_PLUS] = ACTIONS(4357),
    [anon_sym_sizeof] = ACTIONS(3191),
    [anon_sym___alignof__] = ACTIONS(3193),
    [anon_sym___alignof] = ACTIONS(3193),
    [anon_sym__alignof] = ACTIONS(3193),
    [anon_sym_alignof] = ACTIONS(3193),
    [anon_sym__Alignof] = ACTIONS(3193),
    [anon_sym_offsetof] = ACTIONS(3195),
    [anon_sym__Generic] = ACTIONS(3197),
    [anon_sym_asm] = ACTIONS(3199),
    [anon_sym___asm__] = ACTIONS(3199),
    [sym_number_literal] = ACTIONS(3201),
    [anon_sym_L_SQUOTE] = ACTIONS(3203),
    [anon_sym_u_SQUOTE] = ACTIONS(3203),
    [anon_sym_U_SQUOTE] = ACTIONS(3203),
    [anon_sym_u8_SQUOTE] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [anon_sym_L_DQUOTE] = ACTIONS(3205),
    [anon_sym_u_DQUOTE] = ACTIONS(3205),
    [anon_sym_U_DQUOTE] = ACTIONS(3205),
    [anon_sym_u8_DQUOTE] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [anon_sym_NULL] = ACTIONS(3209),
    [anon_sym_nullptr] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_R_DQUOTE] = ACTIONS(3213),
    [anon_sym_LR_DQUOTE] = ACTIONS(3213),
    [anon_sym_uR_DQUOTE] = ACTIONS(3213),
    [anon_sym_UR_DQUOTE] = ACTIONS(3213),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3213),
    [anon_sym_co_await] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_requires] = ACTIONS(3219),
    [sym_this] = ACTIONS(3207),
  },
  [1259] = {
    [sym_expression] = STATE(2471),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4755),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1260] = {
    [sym_expression] = STATE(2471),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(4757),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1261] = {
    [sym_expression] = STATE(4564),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1262] = {
    [sym_expression] = STATE(3207),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1263] = {
    [sym_expression] = STATE(5137),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1264] = {
    [sym_expression] = STATE(2867),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(2940),
    [sym_concatenated_string] = STATE(3000),
    [sym_string_literal] = STATE(2241),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2239),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4472),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2512),
    [anon_sym_compl] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_sizeof] = ACTIONS(2522),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2532),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [anon_sym_co_await] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1265] = {
    [sym_expression] = STATE(2861),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(2940),
    [sym_concatenated_string] = STATE(3000),
    [sym_string_literal] = STATE(2241),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2239),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4472),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2512),
    [anon_sym_compl] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_sizeof] = ACTIONS(2522),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2532),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [anon_sym_co_await] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1266] = {
    [sym_expression] = STATE(2860),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(2940),
    [sym_concatenated_string] = STATE(3000),
    [sym_string_literal] = STATE(2241),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2239),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4472),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2512),
    [anon_sym_compl] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_sizeof] = ACTIONS(2522),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2532),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [anon_sym_co_await] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1267] = {
    [sym_expression] = STATE(2857),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(2940),
    [sym_concatenated_string] = STATE(3000),
    [sym_string_literal] = STATE(2241),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2239),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4472),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2512),
    [anon_sym_compl] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_sizeof] = ACTIONS(2522),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2532),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [anon_sym_co_await] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1268] = {
    [sym_expression] = STATE(4802),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8015),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(8015),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3754),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [1269] = {
    [sym_expression] = STATE(4417),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3068),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3068),
    [sym_call_expression] = STATE(3068),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3068),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3068),
    [sym_char_literal] = STATE(4482),
    [sym_concatenated_string] = STATE(4479),
    [sym_string_literal] = STATE(3097),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3096),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3068),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3068),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(4415),
    [anon_sym_LPAREN2] = ACTIONS(4506),
    [anon_sym_BANG] = ACTIONS(3582),
    [anon_sym_TILDE] = ACTIONS(3582),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(3584),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_compl] = ACTIONS(3580),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(3588),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3590),
    [anon_sym_L_SQUOTE] = ACTIONS(3592),
    [anon_sym_u_SQUOTE] = ACTIONS(3592),
    [anon_sym_U_SQUOTE] = ACTIONS(3592),
    [anon_sym_u8_SQUOTE] = ACTIONS(3592),
    [anon_sym_SQUOTE] = ACTIONS(3592),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3596),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [anon_sym_co_await] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_requires] = ACTIONS(3604),
    [sym_this] = ACTIONS(221),
  },
  [1270] = {
    [sym_expression] = STATE(3381),
    [sym__string] = STATE(3926),
    [sym_conditional_expression] = STATE(3926),
    [sym_assignment_expression] = STATE(3926),
    [sym_pointer_expression] = STATE(3934),
    [sym_unary_expression] = STATE(3926),
    [sym_binary_expression] = STATE(3926),
    [sym_update_expression] = STATE(3926),
    [sym_cast_expression] = STATE(3926),
    [sym_sizeof_expression] = STATE(3926),
    [sym_alignof_expression] = STATE(3926),
    [sym_offsetof_expression] = STATE(3926),
    [sym_generic_expression] = STATE(3926),
    [sym_subscript_expression] = STATE(3934),
    [sym_call_expression] = STATE(3934),
    [sym_gnu_asm_expression] = STATE(3926),
    [sym_field_expression] = STATE(3934),
    [sym_compound_literal_expression] = STATE(3926),
    [sym_parenthesized_expression] = STATE(3934),
    [sym_char_literal] = STATE(3755),
    [sym_concatenated_string] = STATE(3759),
    [sym_string_literal] = STATE(2463),
    [sym_null] = STATE(3926),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7876),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3926),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3926),
    [sym_new_expression] = STATE(3926),
    [sym_delete_expression] = STATE(3926),
    [sym_requires_clause] = STATE(3926),
    [sym_requires_expression] = STATE(3926),
    [sym_lambda_expression] = STATE(3926),
    [sym_lambda_capture_specifier] = STATE(6169),
    [sym_fold_expression] = STATE(3926),
    [sym_parameter_pack_expansion] = STATE(3926),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3934),
    [sym_qualified_type_identifier] = STATE(7876),
    [sym_user_defined_literal] = STATE(3934),
    [sym_kernel_call_expression] = STATE(3930),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(4518),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3291),
    [anon_sym_not] = ACTIONS(3283),
    [anon_sym_compl] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(4351),
    [anon_sym_PLUS_PLUS] = ACTIONS(4351),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3295),
    [anon_sym___alignof] = ACTIONS(3295),
    [anon_sym__alignof] = ACTIONS(3295),
    [anon_sym_alignof] = ACTIONS(3295),
    [anon_sym__Alignof] = ACTIONS(3295),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3299),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [sym_number_literal] = ACTIONS(3303),
    [anon_sym_L_SQUOTE] = ACTIONS(3305),
    [anon_sym_u_SQUOTE] = ACTIONS(3305),
    [anon_sym_U_SQUOTE] = ACTIONS(3305),
    [anon_sym_u8_SQUOTE] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_L_DQUOTE] = ACTIONS(3307),
    [anon_sym_u_DQUOTE] = ACTIONS(3307),
    [anon_sym_U_DQUOTE] = ACTIONS(3307),
    [anon_sym_u8_DQUOTE] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [anon_sym_NULL] = ACTIONS(3311),
    [anon_sym_nullptr] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_R_DQUOTE] = ACTIONS(3315),
    [anon_sym_LR_DQUOTE] = ACTIONS(3315),
    [anon_sym_uR_DQUOTE] = ACTIONS(3315),
    [anon_sym_UR_DQUOTE] = ACTIONS(3315),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3315),
    [anon_sym_co_await] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_requires] = ACTIONS(3321),
    [sym_this] = ACTIONS(3309),
  },
  [1271] = {
    [sym_expression] = STATE(3314),
    [sym__string] = STATE(3860),
    [sym_conditional_expression] = STATE(3860),
    [sym_assignment_expression] = STATE(3860),
    [sym_pointer_expression] = STATE(3861),
    [sym_unary_expression] = STATE(3860),
    [sym_binary_expression] = STATE(3860),
    [sym_update_expression] = STATE(3860),
    [sym_cast_expression] = STATE(3860),
    [sym_sizeof_expression] = STATE(3860),
    [sym_alignof_expression] = STATE(3860),
    [sym_offsetof_expression] = STATE(3860),
    [sym_generic_expression] = STATE(3860),
    [sym_subscript_expression] = STATE(3861),
    [sym_call_expression] = STATE(3861),
    [sym_gnu_asm_expression] = STATE(3860),
    [sym_field_expression] = STATE(3861),
    [sym_compound_literal_expression] = STATE(3860),
    [sym_parenthesized_expression] = STATE(3861),
    [sym_char_literal] = STATE(3831),
    [sym_concatenated_string] = STATE(3833),
    [sym_string_literal] = STATE(2490),
    [sym_null] = STATE(3860),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7980),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3860),
    [sym_raw_string_literal] = STATE(2516),
    [sym_co_await_expression] = STATE(3860),
    [sym_new_expression] = STATE(3860),
    [sym_delete_expression] = STATE(3860),
    [sym_requires_clause] = STATE(3860),
    [sym_requires_expression] = STATE(3860),
    [sym_lambda_expression] = STATE(3860),
    [sym_lambda_capture_specifier] = STATE(6189),
    [sym_fold_expression] = STATE(3860),
    [sym_parameter_pack_expansion] = STATE(3860),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3861),
    [sym_qualified_type_identifier] = STATE(7980),
    [sym_user_defined_literal] = STATE(3861),
    [sym_kernel_call_expression] = STATE(3851),
    [sym_identifier] = ACTIONS(3179),
    [anon_sym_LPAREN2] = ACTIONS(4541),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3185),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3189),
    [anon_sym_not] = ACTIONS(3181),
    [anon_sym_compl] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(4357),
    [anon_sym_PLUS_PLUS] = ACTIONS(4357),
    [anon_sym_sizeof] = ACTIONS(3191),
    [anon_sym___alignof__] = ACTIONS(3193),
    [anon_sym___alignof] = ACTIONS(3193),
    [anon_sym__alignof] = ACTIONS(3193),
    [anon_sym_alignof] = ACTIONS(3193),
    [anon_sym__Alignof] = ACTIONS(3193),
    [anon_sym_offsetof] = ACTIONS(3195),
    [anon_sym__Generic] = ACTIONS(3197),
    [anon_sym_asm] = ACTIONS(3199),
    [anon_sym___asm__] = ACTIONS(3199),
    [sym_number_literal] = ACTIONS(3201),
    [anon_sym_L_SQUOTE] = ACTIONS(3203),
    [anon_sym_u_SQUOTE] = ACTIONS(3203),
    [anon_sym_U_SQUOTE] = ACTIONS(3203),
    [anon_sym_u8_SQUOTE] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [anon_sym_L_DQUOTE] = ACTIONS(3205),
    [anon_sym_u_DQUOTE] = ACTIONS(3205),
    [anon_sym_U_DQUOTE] = ACTIONS(3205),
    [anon_sym_u8_DQUOTE] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [anon_sym_NULL] = ACTIONS(3209),
    [anon_sym_nullptr] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_R_DQUOTE] = ACTIONS(3213),
    [anon_sym_LR_DQUOTE] = ACTIONS(3213),
    [anon_sym_uR_DQUOTE] = ACTIONS(3213),
    [anon_sym_UR_DQUOTE] = ACTIONS(3213),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3213),
    [anon_sym_co_await] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_requires] = ACTIONS(3219),
    [sym_this] = ACTIONS(3207),
  },
  [1272] = {
    [sym_expression] = STATE(3382),
    [sym__string] = STATE(3926),
    [sym_conditional_expression] = STATE(3926),
    [sym_assignment_expression] = STATE(3926),
    [sym_pointer_expression] = STATE(3934),
    [sym_unary_expression] = STATE(3926),
    [sym_binary_expression] = STATE(3926),
    [sym_update_expression] = STATE(3926),
    [sym_cast_expression] = STATE(3926),
    [sym_sizeof_expression] = STATE(3926),
    [sym_alignof_expression] = STATE(3926),
    [sym_offsetof_expression] = STATE(3926),
    [sym_generic_expression] = STATE(3926),
    [sym_subscript_expression] = STATE(3934),
    [sym_call_expression] = STATE(3934),
    [sym_gnu_asm_expression] = STATE(3926),
    [sym_field_expression] = STATE(3934),
    [sym_compound_literal_expression] = STATE(3926),
    [sym_parenthesized_expression] = STATE(3934),
    [sym_char_literal] = STATE(3755),
    [sym_concatenated_string] = STATE(3759),
    [sym_string_literal] = STATE(2463),
    [sym_null] = STATE(3926),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7876),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3926),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3926),
    [sym_new_expression] = STATE(3926),
    [sym_delete_expression] = STATE(3926),
    [sym_requires_clause] = STATE(3926),
    [sym_requires_expression] = STATE(3926),
    [sym_lambda_expression] = STATE(3926),
    [sym_lambda_capture_specifier] = STATE(6169),
    [sym_fold_expression] = STATE(3926),
    [sym_parameter_pack_expansion] = STATE(3926),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3934),
    [sym_qualified_type_identifier] = STATE(7876),
    [sym_user_defined_literal] = STATE(3934),
    [sym_kernel_call_expression] = STATE(3930),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(4518),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3291),
    [anon_sym_not] = ACTIONS(3283),
    [anon_sym_compl] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(4351),
    [anon_sym_PLUS_PLUS] = ACTIONS(4351),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3295),
    [anon_sym___alignof] = ACTIONS(3295),
    [anon_sym__alignof] = ACTIONS(3295),
    [anon_sym_alignof] = ACTIONS(3295),
    [anon_sym__Alignof] = ACTIONS(3295),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3299),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [sym_number_literal] = ACTIONS(3303),
    [anon_sym_L_SQUOTE] = ACTIONS(3305),
    [anon_sym_u_SQUOTE] = ACTIONS(3305),
    [anon_sym_U_SQUOTE] = ACTIONS(3305),
    [anon_sym_u8_SQUOTE] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_L_DQUOTE] = ACTIONS(3307),
    [anon_sym_u_DQUOTE] = ACTIONS(3307),
    [anon_sym_U_DQUOTE] = ACTIONS(3307),
    [anon_sym_u8_DQUOTE] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [anon_sym_NULL] = ACTIONS(3311),
    [anon_sym_nullptr] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_R_DQUOTE] = ACTIONS(3315),
    [anon_sym_LR_DQUOTE] = ACTIONS(3315),
    [anon_sym_uR_DQUOTE] = ACTIONS(3315),
    [anon_sym_UR_DQUOTE] = ACTIONS(3315),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3315),
    [anon_sym_co_await] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_requires] = ACTIONS(3321),
    [sym_this] = ACTIONS(3309),
  },
  [1273] = {
    [sym_expression] = STATE(3309),
    [sym__string] = STATE(3860),
    [sym_conditional_expression] = STATE(3860),
    [sym_assignment_expression] = STATE(3860),
    [sym_pointer_expression] = STATE(3861),
    [sym_unary_expression] = STATE(3860),
    [sym_binary_expression] = STATE(3860),
    [sym_update_expression] = STATE(3860),
    [sym_cast_expression] = STATE(3860),
    [sym_sizeof_expression] = STATE(3860),
    [sym_alignof_expression] = STATE(3860),
    [sym_offsetof_expression] = STATE(3860),
    [sym_generic_expression] = STATE(3860),
    [sym_subscript_expression] = STATE(3861),
    [sym_call_expression] = STATE(3861),
    [sym_gnu_asm_expression] = STATE(3860),
    [sym_field_expression] = STATE(3861),
    [sym_compound_literal_expression] = STATE(3860),
    [sym_parenthesized_expression] = STATE(3861),
    [sym_char_literal] = STATE(3831),
    [sym_concatenated_string] = STATE(3833),
    [sym_string_literal] = STATE(2490),
    [sym_null] = STATE(3860),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7980),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3860),
    [sym_raw_string_literal] = STATE(2516),
    [sym_co_await_expression] = STATE(3860),
    [sym_new_expression] = STATE(3860),
    [sym_delete_expression] = STATE(3860),
    [sym_requires_clause] = STATE(3860),
    [sym_requires_expression] = STATE(3860),
    [sym_lambda_expression] = STATE(3860),
    [sym_lambda_capture_specifier] = STATE(6189),
    [sym_fold_expression] = STATE(3860),
    [sym_parameter_pack_expansion] = STATE(3860),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3861),
    [sym_qualified_type_identifier] = STATE(7980),
    [sym_user_defined_literal] = STATE(3861),
    [sym_kernel_call_expression] = STATE(3851),
    [sym_identifier] = ACTIONS(3179),
    [anon_sym_LPAREN2] = ACTIONS(4541),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3185),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3189),
    [anon_sym_not] = ACTIONS(3181),
    [anon_sym_compl] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(4357),
    [anon_sym_PLUS_PLUS] = ACTIONS(4357),
    [anon_sym_sizeof] = ACTIONS(3191),
    [anon_sym___alignof__] = ACTIONS(3193),
    [anon_sym___alignof] = ACTIONS(3193),
    [anon_sym__alignof] = ACTIONS(3193),
    [anon_sym_alignof] = ACTIONS(3193),
    [anon_sym__Alignof] = ACTIONS(3193),
    [anon_sym_offsetof] = ACTIONS(3195),
    [anon_sym__Generic] = ACTIONS(3197),
    [anon_sym_asm] = ACTIONS(3199),
    [anon_sym___asm__] = ACTIONS(3199),
    [sym_number_literal] = ACTIONS(3201),
    [anon_sym_L_SQUOTE] = ACTIONS(3203),
    [anon_sym_u_SQUOTE] = ACTIONS(3203),
    [anon_sym_U_SQUOTE] = ACTIONS(3203),
    [anon_sym_u8_SQUOTE] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [anon_sym_L_DQUOTE] = ACTIONS(3205),
    [anon_sym_u_DQUOTE] = ACTIONS(3205),
    [anon_sym_U_DQUOTE] = ACTIONS(3205),
    [anon_sym_u8_DQUOTE] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [anon_sym_NULL] = ACTIONS(3209),
    [anon_sym_nullptr] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_R_DQUOTE] = ACTIONS(3213),
    [anon_sym_LR_DQUOTE] = ACTIONS(3213),
    [anon_sym_uR_DQUOTE] = ACTIONS(3213),
    [anon_sym_UR_DQUOTE] = ACTIONS(3213),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3213),
    [anon_sym_co_await] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_requires] = ACTIONS(3219),
    [sym_this] = ACTIONS(3207),
  },
  [1274] = {
    [sym_expression] = STATE(2480),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(2940),
    [sym_concatenated_string] = STATE(3000),
    [sym_string_literal] = STATE(2241),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2239),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4472),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2512),
    [anon_sym_compl] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_sizeof] = ACTIONS(2522),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2532),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [anon_sym_co_await] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1275] = {
    [sym_expression] = STATE(3383),
    [sym__string] = STATE(3926),
    [sym_conditional_expression] = STATE(3926),
    [sym_assignment_expression] = STATE(3926),
    [sym_pointer_expression] = STATE(3934),
    [sym_unary_expression] = STATE(3926),
    [sym_binary_expression] = STATE(3926),
    [sym_update_expression] = STATE(3926),
    [sym_cast_expression] = STATE(3926),
    [sym_sizeof_expression] = STATE(3926),
    [sym_alignof_expression] = STATE(3926),
    [sym_offsetof_expression] = STATE(3926),
    [sym_generic_expression] = STATE(3926),
    [sym_subscript_expression] = STATE(3934),
    [sym_call_expression] = STATE(3934),
    [sym_gnu_asm_expression] = STATE(3926),
    [sym_field_expression] = STATE(3934),
    [sym_compound_literal_expression] = STATE(3926),
    [sym_parenthesized_expression] = STATE(3934),
    [sym_char_literal] = STATE(3755),
    [sym_concatenated_string] = STATE(3759),
    [sym_string_literal] = STATE(2463),
    [sym_null] = STATE(3926),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7876),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3926),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3926),
    [sym_new_expression] = STATE(3926),
    [sym_delete_expression] = STATE(3926),
    [sym_requires_clause] = STATE(3926),
    [sym_requires_expression] = STATE(3926),
    [sym_lambda_expression] = STATE(3926),
    [sym_lambda_capture_specifier] = STATE(6169),
    [sym_fold_expression] = STATE(3926),
    [sym_parameter_pack_expansion] = STATE(3926),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3934),
    [sym_qualified_type_identifier] = STATE(7876),
    [sym_user_defined_literal] = STATE(3934),
    [sym_kernel_call_expression] = STATE(3930),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(4518),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3291),
    [anon_sym_not] = ACTIONS(3283),
    [anon_sym_compl] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(4351),
    [anon_sym_PLUS_PLUS] = ACTIONS(4351),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3295),
    [anon_sym___alignof] = ACTIONS(3295),
    [anon_sym__alignof] = ACTIONS(3295),
    [anon_sym_alignof] = ACTIONS(3295),
    [anon_sym__Alignof] = ACTIONS(3295),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3299),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [sym_number_literal] = ACTIONS(3303),
    [anon_sym_L_SQUOTE] = ACTIONS(3305),
    [anon_sym_u_SQUOTE] = ACTIONS(3305),
    [anon_sym_U_SQUOTE] = ACTIONS(3305),
    [anon_sym_u8_SQUOTE] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_L_DQUOTE] = ACTIONS(3307),
    [anon_sym_u_DQUOTE] = ACTIONS(3307),
    [anon_sym_U_DQUOTE] = ACTIONS(3307),
    [anon_sym_u8_DQUOTE] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [anon_sym_NULL] = ACTIONS(3311),
    [anon_sym_nullptr] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_R_DQUOTE] = ACTIONS(3315),
    [anon_sym_LR_DQUOTE] = ACTIONS(3315),
    [anon_sym_uR_DQUOTE] = ACTIONS(3315),
    [anon_sym_UR_DQUOTE] = ACTIONS(3315),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3315),
    [anon_sym_co_await] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_requires] = ACTIONS(3321),
    [sym_this] = ACTIONS(3309),
  },
  [1276] = {
    [sym_expression] = STATE(3384),
    [sym__string] = STATE(3926),
    [sym_conditional_expression] = STATE(3926),
    [sym_assignment_expression] = STATE(3926),
    [sym_pointer_expression] = STATE(3934),
    [sym_unary_expression] = STATE(3926),
    [sym_binary_expression] = STATE(3926),
    [sym_update_expression] = STATE(3926),
    [sym_cast_expression] = STATE(3926),
    [sym_sizeof_expression] = STATE(3926),
    [sym_alignof_expression] = STATE(3926),
    [sym_offsetof_expression] = STATE(3926),
    [sym_generic_expression] = STATE(3926),
    [sym_subscript_expression] = STATE(3934),
    [sym_call_expression] = STATE(3934),
    [sym_gnu_asm_expression] = STATE(3926),
    [sym_field_expression] = STATE(3934),
    [sym_compound_literal_expression] = STATE(3926),
    [sym_parenthesized_expression] = STATE(3934),
    [sym_char_literal] = STATE(3755),
    [sym_concatenated_string] = STATE(3759),
    [sym_string_literal] = STATE(2463),
    [sym_null] = STATE(3926),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7876),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3926),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3926),
    [sym_new_expression] = STATE(3926),
    [sym_delete_expression] = STATE(3926),
    [sym_requires_clause] = STATE(3926),
    [sym_requires_expression] = STATE(3926),
    [sym_lambda_expression] = STATE(3926),
    [sym_lambda_capture_specifier] = STATE(6169),
    [sym_fold_expression] = STATE(3926),
    [sym_parameter_pack_expansion] = STATE(3926),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3934),
    [sym_qualified_type_identifier] = STATE(7876),
    [sym_user_defined_literal] = STATE(3934),
    [sym_kernel_call_expression] = STATE(3930),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(4518),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3291),
    [anon_sym_not] = ACTIONS(3283),
    [anon_sym_compl] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(4351),
    [anon_sym_PLUS_PLUS] = ACTIONS(4351),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3295),
    [anon_sym___alignof] = ACTIONS(3295),
    [anon_sym__alignof] = ACTIONS(3295),
    [anon_sym_alignof] = ACTIONS(3295),
    [anon_sym__Alignof] = ACTIONS(3295),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3299),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [sym_number_literal] = ACTIONS(3303),
    [anon_sym_L_SQUOTE] = ACTIONS(3305),
    [anon_sym_u_SQUOTE] = ACTIONS(3305),
    [anon_sym_U_SQUOTE] = ACTIONS(3305),
    [anon_sym_u8_SQUOTE] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_L_DQUOTE] = ACTIONS(3307),
    [anon_sym_u_DQUOTE] = ACTIONS(3307),
    [anon_sym_U_DQUOTE] = ACTIONS(3307),
    [anon_sym_u8_DQUOTE] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [anon_sym_NULL] = ACTIONS(3311),
    [anon_sym_nullptr] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_R_DQUOTE] = ACTIONS(3315),
    [anon_sym_LR_DQUOTE] = ACTIONS(3315),
    [anon_sym_uR_DQUOTE] = ACTIONS(3315),
    [anon_sym_UR_DQUOTE] = ACTIONS(3315),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3315),
    [anon_sym_co_await] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_requires] = ACTIONS(3321),
    [sym_this] = ACTIONS(3309),
  },
  [1277] = {
    [sym_expression] = STATE(4633),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1278] = {
    [sym_expression] = STATE(4696),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1279] = {
    [sym_expression] = STATE(2865),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(2940),
    [sym_concatenated_string] = STATE(3000),
    [sym_string_literal] = STATE(2241),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2239),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4472),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2512),
    [anon_sym_compl] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_sizeof] = ACTIONS(2522),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2532),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [anon_sym_co_await] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1280] = {
    [sym_expression] = STATE(2864),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(2940),
    [sym_concatenated_string] = STATE(3000),
    [sym_string_literal] = STATE(2241),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2239),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4472),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2512),
    [anon_sym_compl] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_sizeof] = ACTIONS(2522),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2532),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [anon_sym_co_await] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1281] = {
    [sym_expression] = STATE(2863),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(2940),
    [sym_concatenated_string] = STATE(3000),
    [sym_string_literal] = STATE(2241),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2239),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4472),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2512),
    [anon_sym_compl] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_sizeof] = ACTIONS(2522),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2532),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [anon_sym_co_await] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1282] = {
    [sym_expression] = STATE(3792),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(4759),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1283] = {
    [sym_expression] = STATE(2852),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(2940),
    [sym_concatenated_string] = STATE(3000),
    [sym_string_literal] = STATE(2241),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2239),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4472),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2512),
    [anon_sym_compl] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_sizeof] = ACTIONS(2522),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2532),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [anon_sym_co_await] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1284] = {
    [sym_expression] = STATE(3380),
    [sym__string] = STATE(3926),
    [sym_conditional_expression] = STATE(3926),
    [sym_assignment_expression] = STATE(3926),
    [sym_pointer_expression] = STATE(3934),
    [sym_unary_expression] = STATE(3926),
    [sym_binary_expression] = STATE(3926),
    [sym_update_expression] = STATE(3926),
    [sym_cast_expression] = STATE(3926),
    [sym_sizeof_expression] = STATE(3926),
    [sym_alignof_expression] = STATE(3926),
    [sym_offsetof_expression] = STATE(3926),
    [sym_generic_expression] = STATE(3926),
    [sym_subscript_expression] = STATE(3934),
    [sym_call_expression] = STATE(3934),
    [sym_gnu_asm_expression] = STATE(3926),
    [sym_field_expression] = STATE(3934),
    [sym_compound_literal_expression] = STATE(3926),
    [sym_parenthesized_expression] = STATE(3934),
    [sym_char_literal] = STATE(3755),
    [sym_concatenated_string] = STATE(3759),
    [sym_string_literal] = STATE(2463),
    [sym_null] = STATE(3926),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7876),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3926),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3926),
    [sym_new_expression] = STATE(3926),
    [sym_delete_expression] = STATE(3926),
    [sym_requires_clause] = STATE(3926),
    [sym_requires_expression] = STATE(3926),
    [sym_lambda_expression] = STATE(3926),
    [sym_lambda_capture_specifier] = STATE(6169),
    [sym_fold_expression] = STATE(3926),
    [sym_parameter_pack_expansion] = STATE(3926),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3934),
    [sym_qualified_type_identifier] = STATE(7876),
    [sym_user_defined_literal] = STATE(3934),
    [sym_kernel_call_expression] = STATE(3930),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(4518),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3291),
    [anon_sym_not] = ACTIONS(3283),
    [anon_sym_compl] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(4351),
    [anon_sym_PLUS_PLUS] = ACTIONS(4351),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3295),
    [anon_sym___alignof] = ACTIONS(3295),
    [anon_sym__alignof] = ACTIONS(3295),
    [anon_sym_alignof] = ACTIONS(3295),
    [anon_sym__Alignof] = ACTIONS(3295),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3299),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [sym_number_literal] = ACTIONS(3303),
    [anon_sym_L_SQUOTE] = ACTIONS(3305),
    [anon_sym_u_SQUOTE] = ACTIONS(3305),
    [anon_sym_U_SQUOTE] = ACTIONS(3305),
    [anon_sym_u8_SQUOTE] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_L_DQUOTE] = ACTIONS(3307),
    [anon_sym_u_DQUOTE] = ACTIONS(3307),
    [anon_sym_U_DQUOTE] = ACTIONS(3307),
    [anon_sym_u8_DQUOTE] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [anon_sym_NULL] = ACTIONS(3311),
    [anon_sym_nullptr] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_R_DQUOTE] = ACTIONS(3315),
    [anon_sym_LR_DQUOTE] = ACTIONS(3315),
    [anon_sym_uR_DQUOTE] = ACTIONS(3315),
    [anon_sym_UR_DQUOTE] = ACTIONS(3315),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3315),
    [anon_sym_co_await] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_requires] = ACTIONS(3321),
    [sym_this] = ACTIONS(3309),
  },
  [1285] = {
    [sym_expression] = STATE(4650),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1286] = {
    [sym_expression] = STATE(3385),
    [sym__string] = STATE(3926),
    [sym_conditional_expression] = STATE(3926),
    [sym_assignment_expression] = STATE(3926),
    [sym_pointer_expression] = STATE(3934),
    [sym_unary_expression] = STATE(3926),
    [sym_binary_expression] = STATE(3926),
    [sym_update_expression] = STATE(3926),
    [sym_cast_expression] = STATE(3926),
    [sym_sizeof_expression] = STATE(3926),
    [sym_alignof_expression] = STATE(3926),
    [sym_offsetof_expression] = STATE(3926),
    [sym_generic_expression] = STATE(3926),
    [sym_subscript_expression] = STATE(3934),
    [sym_call_expression] = STATE(3934),
    [sym_gnu_asm_expression] = STATE(3926),
    [sym_field_expression] = STATE(3934),
    [sym_compound_literal_expression] = STATE(3926),
    [sym_parenthesized_expression] = STATE(3934),
    [sym_char_literal] = STATE(3755),
    [sym_concatenated_string] = STATE(3759),
    [sym_string_literal] = STATE(2463),
    [sym_null] = STATE(3926),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7876),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3926),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3926),
    [sym_new_expression] = STATE(3926),
    [sym_delete_expression] = STATE(3926),
    [sym_requires_clause] = STATE(3926),
    [sym_requires_expression] = STATE(3926),
    [sym_lambda_expression] = STATE(3926),
    [sym_lambda_capture_specifier] = STATE(6169),
    [sym_fold_expression] = STATE(3926),
    [sym_parameter_pack_expansion] = STATE(3926),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3934),
    [sym_qualified_type_identifier] = STATE(7876),
    [sym_user_defined_literal] = STATE(3934),
    [sym_kernel_call_expression] = STATE(3930),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(4518),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3291),
    [anon_sym_not] = ACTIONS(3283),
    [anon_sym_compl] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(4351),
    [anon_sym_PLUS_PLUS] = ACTIONS(4351),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3295),
    [anon_sym___alignof] = ACTIONS(3295),
    [anon_sym__alignof] = ACTIONS(3295),
    [anon_sym_alignof] = ACTIONS(3295),
    [anon_sym__Alignof] = ACTIONS(3295),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3299),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [sym_number_literal] = ACTIONS(3303),
    [anon_sym_L_SQUOTE] = ACTIONS(3305),
    [anon_sym_u_SQUOTE] = ACTIONS(3305),
    [anon_sym_U_SQUOTE] = ACTIONS(3305),
    [anon_sym_u8_SQUOTE] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_L_DQUOTE] = ACTIONS(3307),
    [anon_sym_u_DQUOTE] = ACTIONS(3307),
    [anon_sym_U_DQUOTE] = ACTIONS(3307),
    [anon_sym_u8_DQUOTE] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [anon_sym_NULL] = ACTIONS(3311),
    [anon_sym_nullptr] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_R_DQUOTE] = ACTIONS(3315),
    [anon_sym_LR_DQUOTE] = ACTIONS(3315),
    [anon_sym_uR_DQUOTE] = ACTIONS(3315),
    [anon_sym_UR_DQUOTE] = ACTIONS(3315),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3315),
    [anon_sym_co_await] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_requires] = ACTIONS(3321),
    [sym_this] = ACTIONS(3309),
  },
  [1287] = {
    [sym_expression] = STATE(3387),
    [sym__string] = STATE(3926),
    [sym_conditional_expression] = STATE(3926),
    [sym_assignment_expression] = STATE(3926),
    [sym_pointer_expression] = STATE(3934),
    [sym_unary_expression] = STATE(3926),
    [sym_binary_expression] = STATE(3926),
    [sym_update_expression] = STATE(3926),
    [sym_cast_expression] = STATE(3926),
    [sym_sizeof_expression] = STATE(3926),
    [sym_alignof_expression] = STATE(3926),
    [sym_offsetof_expression] = STATE(3926),
    [sym_generic_expression] = STATE(3926),
    [sym_subscript_expression] = STATE(3934),
    [sym_call_expression] = STATE(3934),
    [sym_gnu_asm_expression] = STATE(3926),
    [sym_field_expression] = STATE(3934),
    [sym_compound_literal_expression] = STATE(3926),
    [sym_parenthesized_expression] = STATE(3934),
    [sym_char_literal] = STATE(3755),
    [sym_concatenated_string] = STATE(3759),
    [sym_string_literal] = STATE(2463),
    [sym_null] = STATE(3926),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7876),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3926),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3926),
    [sym_new_expression] = STATE(3926),
    [sym_delete_expression] = STATE(3926),
    [sym_requires_clause] = STATE(3926),
    [sym_requires_expression] = STATE(3926),
    [sym_lambda_expression] = STATE(3926),
    [sym_lambda_capture_specifier] = STATE(6169),
    [sym_fold_expression] = STATE(3926),
    [sym_parameter_pack_expansion] = STATE(3926),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3934),
    [sym_qualified_type_identifier] = STATE(7876),
    [sym_user_defined_literal] = STATE(3934),
    [sym_kernel_call_expression] = STATE(3930),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(4518),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3291),
    [anon_sym_not] = ACTIONS(3283),
    [anon_sym_compl] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(4351),
    [anon_sym_PLUS_PLUS] = ACTIONS(4351),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3295),
    [anon_sym___alignof] = ACTIONS(3295),
    [anon_sym__alignof] = ACTIONS(3295),
    [anon_sym_alignof] = ACTIONS(3295),
    [anon_sym__Alignof] = ACTIONS(3295),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3299),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [sym_number_literal] = ACTIONS(3303),
    [anon_sym_L_SQUOTE] = ACTIONS(3305),
    [anon_sym_u_SQUOTE] = ACTIONS(3305),
    [anon_sym_U_SQUOTE] = ACTIONS(3305),
    [anon_sym_u8_SQUOTE] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_L_DQUOTE] = ACTIONS(3307),
    [anon_sym_u_DQUOTE] = ACTIONS(3307),
    [anon_sym_U_DQUOTE] = ACTIONS(3307),
    [anon_sym_u8_DQUOTE] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [anon_sym_NULL] = ACTIONS(3311),
    [anon_sym_nullptr] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_R_DQUOTE] = ACTIONS(3315),
    [anon_sym_LR_DQUOTE] = ACTIONS(3315),
    [anon_sym_uR_DQUOTE] = ACTIONS(3315),
    [anon_sym_UR_DQUOTE] = ACTIONS(3315),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3315),
    [anon_sym_co_await] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_requires] = ACTIONS(3321),
    [sym_this] = ACTIONS(3309),
  },
  [1288] = {
    [sym_expression] = STATE(3379),
    [sym__string] = STATE(3926),
    [sym_conditional_expression] = STATE(3926),
    [sym_assignment_expression] = STATE(3926),
    [sym_pointer_expression] = STATE(3934),
    [sym_unary_expression] = STATE(3926),
    [sym_binary_expression] = STATE(3926),
    [sym_update_expression] = STATE(3926),
    [sym_cast_expression] = STATE(3926),
    [sym_sizeof_expression] = STATE(3926),
    [sym_alignof_expression] = STATE(3926),
    [sym_offsetof_expression] = STATE(3926),
    [sym_generic_expression] = STATE(3926),
    [sym_subscript_expression] = STATE(3934),
    [sym_call_expression] = STATE(3934),
    [sym_gnu_asm_expression] = STATE(3926),
    [sym_field_expression] = STATE(3934),
    [sym_compound_literal_expression] = STATE(3926),
    [sym_parenthesized_expression] = STATE(3934),
    [sym_char_literal] = STATE(3755),
    [sym_concatenated_string] = STATE(3759),
    [sym_string_literal] = STATE(2463),
    [sym_null] = STATE(3926),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7876),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3926),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3926),
    [sym_new_expression] = STATE(3926),
    [sym_delete_expression] = STATE(3926),
    [sym_requires_clause] = STATE(3926),
    [sym_requires_expression] = STATE(3926),
    [sym_lambda_expression] = STATE(3926),
    [sym_lambda_capture_specifier] = STATE(6169),
    [sym_fold_expression] = STATE(3926),
    [sym_parameter_pack_expansion] = STATE(3926),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3934),
    [sym_qualified_type_identifier] = STATE(7876),
    [sym_user_defined_literal] = STATE(3934),
    [sym_kernel_call_expression] = STATE(3930),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(4518),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3291),
    [anon_sym_not] = ACTIONS(3283),
    [anon_sym_compl] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(4351),
    [anon_sym_PLUS_PLUS] = ACTIONS(4351),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3295),
    [anon_sym___alignof] = ACTIONS(3295),
    [anon_sym__alignof] = ACTIONS(3295),
    [anon_sym_alignof] = ACTIONS(3295),
    [anon_sym__Alignof] = ACTIONS(3295),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3299),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [sym_number_literal] = ACTIONS(3303),
    [anon_sym_L_SQUOTE] = ACTIONS(3305),
    [anon_sym_u_SQUOTE] = ACTIONS(3305),
    [anon_sym_U_SQUOTE] = ACTIONS(3305),
    [anon_sym_u8_SQUOTE] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_L_DQUOTE] = ACTIONS(3307),
    [anon_sym_u_DQUOTE] = ACTIONS(3307),
    [anon_sym_U_DQUOTE] = ACTIONS(3307),
    [anon_sym_u8_DQUOTE] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [anon_sym_NULL] = ACTIONS(3311),
    [anon_sym_nullptr] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_R_DQUOTE] = ACTIONS(3315),
    [anon_sym_LR_DQUOTE] = ACTIONS(3315),
    [anon_sym_uR_DQUOTE] = ACTIONS(3315),
    [anon_sym_UR_DQUOTE] = ACTIONS(3315),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3315),
    [anon_sym_co_await] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_requires] = ACTIONS(3321),
    [sym_this] = ACTIONS(3309),
  },
  [1289] = {
    [sym_expression] = STATE(3378),
    [sym__string] = STATE(3926),
    [sym_conditional_expression] = STATE(3926),
    [sym_assignment_expression] = STATE(3926),
    [sym_pointer_expression] = STATE(3934),
    [sym_unary_expression] = STATE(3926),
    [sym_binary_expression] = STATE(3926),
    [sym_update_expression] = STATE(3926),
    [sym_cast_expression] = STATE(3926),
    [sym_sizeof_expression] = STATE(3926),
    [sym_alignof_expression] = STATE(3926),
    [sym_offsetof_expression] = STATE(3926),
    [sym_generic_expression] = STATE(3926),
    [sym_subscript_expression] = STATE(3934),
    [sym_call_expression] = STATE(3934),
    [sym_gnu_asm_expression] = STATE(3926),
    [sym_field_expression] = STATE(3934),
    [sym_compound_literal_expression] = STATE(3926),
    [sym_parenthesized_expression] = STATE(3934),
    [sym_char_literal] = STATE(3755),
    [sym_concatenated_string] = STATE(3759),
    [sym_string_literal] = STATE(2463),
    [sym_null] = STATE(3926),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7876),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3926),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3926),
    [sym_new_expression] = STATE(3926),
    [sym_delete_expression] = STATE(3926),
    [sym_requires_clause] = STATE(3926),
    [sym_requires_expression] = STATE(3926),
    [sym_lambda_expression] = STATE(3926),
    [sym_lambda_capture_specifier] = STATE(6169),
    [sym_fold_expression] = STATE(3926),
    [sym_parameter_pack_expansion] = STATE(3926),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3934),
    [sym_qualified_type_identifier] = STATE(7876),
    [sym_user_defined_literal] = STATE(3934),
    [sym_kernel_call_expression] = STATE(3930),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(4518),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3291),
    [anon_sym_not] = ACTIONS(3283),
    [anon_sym_compl] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(4351),
    [anon_sym_PLUS_PLUS] = ACTIONS(4351),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3295),
    [anon_sym___alignof] = ACTIONS(3295),
    [anon_sym__alignof] = ACTIONS(3295),
    [anon_sym_alignof] = ACTIONS(3295),
    [anon_sym__Alignof] = ACTIONS(3295),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3299),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [sym_number_literal] = ACTIONS(3303),
    [anon_sym_L_SQUOTE] = ACTIONS(3305),
    [anon_sym_u_SQUOTE] = ACTIONS(3305),
    [anon_sym_U_SQUOTE] = ACTIONS(3305),
    [anon_sym_u8_SQUOTE] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_L_DQUOTE] = ACTIONS(3307),
    [anon_sym_u_DQUOTE] = ACTIONS(3307),
    [anon_sym_U_DQUOTE] = ACTIONS(3307),
    [anon_sym_u8_DQUOTE] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [anon_sym_NULL] = ACTIONS(3311),
    [anon_sym_nullptr] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_R_DQUOTE] = ACTIONS(3315),
    [anon_sym_LR_DQUOTE] = ACTIONS(3315),
    [anon_sym_uR_DQUOTE] = ACTIONS(3315),
    [anon_sym_UR_DQUOTE] = ACTIONS(3315),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3315),
    [anon_sym_co_await] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_requires] = ACTIONS(3321),
    [sym_this] = ACTIONS(3309),
  },
  [1290] = {
    [sym_expression] = STATE(5009),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1291] = {
    [sym_expression] = STATE(5015),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1292] = {
    [sym_expression] = STATE(4922),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8015),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(8015),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3754),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [1293] = {
    [sym_expression] = STATE(5143),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1294] = {
    [sym_expression] = STATE(4530),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1295] = {
    [sym_expression] = STATE(3377),
    [sym__string] = STATE(3926),
    [sym_conditional_expression] = STATE(3926),
    [sym_assignment_expression] = STATE(3926),
    [sym_pointer_expression] = STATE(3934),
    [sym_unary_expression] = STATE(3926),
    [sym_binary_expression] = STATE(3926),
    [sym_update_expression] = STATE(3926),
    [sym_cast_expression] = STATE(3926),
    [sym_sizeof_expression] = STATE(3926),
    [sym_alignof_expression] = STATE(3926),
    [sym_offsetof_expression] = STATE(3926),
    [sym_generic_expression] = STATE(3926),
    [sym_subscript_expression] = STATE(3934),
    [sym_call_expression] = STATE(3934),
    [sym_gnu_asm_expression] = STATE(3926),
    [sym_field_expression] = STATE(3934),
    [sym_compound_literal_expression] = STATE(3926),
    [sym_parenthesized_expression] = STATE(3934),
    [sym_char_literal] = STATE(3755),
    [sym_concatenated_string] = STATE(3759),
    [sym_string_literal] = STATE(2463),
    [sym_null] = STATE(3926),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7876),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3926),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3926),
    [sym_new_expression] = STATE(3926),
    [sym_delete_expression] = STATE(3926),
    [sym_requires_clause] = STATE(3926),
    [sym_requires_expression] = STATE(3926),
    [sym_lambda_expression] = STATE(3926),
    [sym_lambda_capture_specifier] = STATE(6169),
    [sym_fold_expression] = STATE(3926),
    [sym_parameter_pack_expansion] = STATE(3926),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3934),
    [sym_qualified_type_identifier] = STATE(7876),
    [sym_user_defined_literal] = STATE(3934),
    [sym_kernel_call_expression] = STATE(3930),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(4518),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3291),
    [anon_sym_not] = ACTIONS(3283),
    [anon_sym_compl] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(4351),
    [anon_sym_PLUS_PLUS] = ACTIONS(4351),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3295),
    [anon_sym___alignof] = ACTIONS(3295),
    [anon_sym__alignof] = ACTIONS(3295),
    [anon_sym_alignof] = ACTIONS(3295),
    [anon_sym__Alignof] = ACTIONS(3295),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3299),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [sym_number_literal] = ACTIONS(3303),
    [anon_sym_L_SQUOTE] = ACTIONS(3305),
    [anon_sym_u_SQUOTE] = ACTIONS(3305),
    [anon_sym_U_SQUOTE] = ACTIONS(3305),
    [anon_sym_u8_SQUOTE] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_L_DQUOTE] = ACTIONS(3307),
    [anon_sym_u_DQUOTE] = ACTIONS(3307),
    [anon_sym_U_DQUOTE] = ACTIONS(3307),
    [anon_sym_u8_DQUOTE] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [anon_sym_NULL] = ACTIONS(3311),
    [anon_sym_nullptr] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_R_DQUOTE] = ACTIONS(3315),
    [anon_sym_LR_DQUOTE] = ACTIONS(3315),
    [anon_sym_uR_DQUOTE] = ACTIONS(3315),
    [anon_sym_UR_DQUOTE] = ACTIONS(3315),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3315),
    [anon_sym_co_await] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_requires] = ACTIONS(3321),
    [sym_this] = ACTIONS(3309),
  },
  [1296] = {
    [sym_expression] = STATE(4853),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8015),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(8015),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3754),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [1297] = {
    [sym_expression] = STATE(4851),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8015),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(8015),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3754),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [1298] = {
    [sym_expression] = STATE(4770),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8015),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(8015),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3754),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [1299] = {
    [sym_expression] = STATE(5041),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1300] = {
    [sym_expression] = STATE(5139),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1301] = {
    [sym_expression] = STATE(3708),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1302] = {
    [sym_expression] = STATE(4831),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8015),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(8015),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3754),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [1303] = {
    [sym_expression] = STATE(4768),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1304] = {
    [sym_expression] = STATE(3760),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1305] = {
    [sym_expression] = STATE(4747),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8015),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(8015),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3754),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [1306] = {
    [sym_expression] = STATE(3712),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1307] = {
    [sym_expression] = STATE(3710),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1308] = {
    [sym_expression] = STATE(4705),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1309] = {
    [sym_expression] = STATE(4898),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8015),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(8015),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3754),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [1310] = {
    [sym_expression] = STATE(3707),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1311] = {
    [sym_expression] = STATE(4971),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8015),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(8015),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3754),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [1312] = {
    [sym_expression] = STATE(3705),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1313] = {
    [sym_expression] = STATE(3588),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1314] = {
    [sym_expression] = STATE(4498),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1315] = {
    [sym_expression] = STATE(3688),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1316] = {
    [sym_expression] = STATE(3687),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1317] = {
    [sym_expression] = STATE(4960),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8015),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(8015),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3754),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [1318] = {
    [sym_expression] = STATE(4732),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1319] = {
    [sym_expression] = STATE(4328),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3068),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3068),
    [sym_call_expression] = STATE(3068),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3068),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3068),
    [sym_char_literal] = STATE(4482),
    [sym_concatenated_string] = STATE(4479),
    [sym_string_literal] = STATE(3097),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3096),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3068),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3068),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(4415),
    [anon_sym_LPAREN2] = ACTIONS(4506),
    [anon_sym_BANG] = ACTIONS(3582),
    [anon_sym_TILDE] = ACTIONS(3582),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(3584),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_compl] = ACTIONS(3580),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(3588),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3590),
    [anon_sym_L_SQUOTE] = ACTIONS(3592),
    [anon_sym_u_SQUOTE] = ACTIONS(3592),
    [anon_sym_U_SQUOTE] = ACTIONS(3592),
    [anon_sym_u8_SQUOTE] = ACTIONS(3592),
    [anon_sym_SQUOTE] = ACTIONS(3592),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3596),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [anon_sym_co_await] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_requires] = ACTIONS(3604),
    [sym_this] = ACTIONS(221),
  },
  [1320] = {
    [sym_expression] = STATE(4845),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1321] = {
    [sym_expression] = STATE(3685),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1322] = {
    [sym_expression] = STATE(3682),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1323] = {
    [sym_expression] = STATE(4320),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3068),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3068),
    [sym_call_expression] = STATE(3068),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3068),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3068),
    [sym_char_literal] = STATE(4482),
    [sym_concatenated_string] = STATE(4479),
    [sym_string_literal] = STATE(3097),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3096),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3068),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3068),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(4415),
    [anon_sym_LPAREN2] = ACTIONS(4506),
    [anon_sym_BANG] = ACTIONS(3582),
    [anon_sym_TILDE] = ACTIONS(3582),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(3584),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_compl] = ACTIONS(3580),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(3588),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3590),
    [anon_sym_L_SQUOTE] = ACTIONS(3592),
    [anon_sym_u_SQUOTE] = ACTIONS(3592),
    [anon_sym_U_SQUOTE] = ACTIONS(3592),
    [anon_sym_u8_SQUOTE] = ACTIONS(3592),
    [anon_sym_SQUOTE] = ACTIONS(3592),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3596),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [anon_sym_co_await] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_requires] = ACTIONS(3604),
    [sym_this] = ACTIONS(221),
  },
  [1324] = {
    [sym_expression] = STATE(3679),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1325] = {
    [sym_expression] = STATE(3804),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1326] = {
    [sym_expression] = STATE(4993),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8015),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(8015),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3754),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [1327] = {
    [sym_expression] = STATE(4986),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8015),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(8015),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3754),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [1328] = {
    [sym_expression] = STATE(4729),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1329] = {
    [sym_expression] = STATE(4725),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1330] = {
    [sym_expression] = STATE(3598),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(4761),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1331] = {
    [sym_expression] = STATE(4722),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1332] = {
    [sym_expression] = STATE(4936),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8015),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(8015),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3754),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [1333] = {
    [sym_expression] = STATE(4712),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1334] = {
    [sym_expression] = STATE(4391),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3068),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3068),
    [sym_call_expression] = STATE(3068),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3068),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3068),
    [sym_char_literal] = STATE(4482),
    [sym_concatenated_string] = STATE(4479),
    [sym_string_literal] = STATE(3097),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3096),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3068),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3068),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(4415),
    [anon_sym_LPAREN2] = ACTIONS(4506),
    [anon_sym_BANG] = ACTIONS(3582),
    [anon_sym_TILDE] = ACTIONS(3582),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(3584),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_compl] = ACTIONS(3580),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(3588),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3590),
    [anon_sym_L_SQUOTE] = ACTIONS(3592),
    [anon_sym_u_SQUOTE] = ACTIONS(3592),
    [anon_sym_U_SQUOTE] = ACTIONS(3592),
    [anon_sym_u8_SQUOTE] = ACTIONS(3592),
    [anon_sym_SQUOTE] = ACTIONS(3592),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3596),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [anon_sym_co_await] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_requires] = ACTIONS(3604),
    [sym_this] = ACTIONS(221),
  },
  [1335] = {
    [sym_expression] = STATE(3120),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1336] = {
    [sym_expression] = STATE(4710),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1337] = {
    [sym_expression] = STATE(4826),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8015),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(8015),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACK] = ACTIONS(4763),
    [sym_primitive_type] = ACTIONS(3754),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [1338] = {
    [sym_expression] = STATE(4821),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8015),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(8015),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3754),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [1339] = {
    [sym_expression] = STATE(5045),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1340] = {
    [sym_expression] = STATE(4795),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8015),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(8015),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACK] = ACTIONS(4765),
    [sym_primitive_type] = ACTIONS(3754),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [1341] = {
    [sym_expression] = STATE(4709),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1342] = {
    [sym_expression] = STATE(4707),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1343] = {
    [sym_expression] = STATE(4353),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1344] = {
    [sym_expression] = STATE(3161),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3517),
    [sym_concatenated_string] = STATE(3520),
    [sym_string_literal] = STATE(2431),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2428),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(4490),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(4767),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_compl] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(4448),
    [anon_sym_PLUS_PLUS] = ACTIONS(4448),
    [anon_sym_sizeof] = ACTIONS(2807),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2813),
    [anon_sym_u_DQUOTE] = ACTIONS(2813),
    [anon_sym_U_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8_DQUOTE] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2817),
    [anon_sym_LR_DQUOTE] = ACTIONS(2817),
    [anon_sym_uR_DQUOTE] = ACTIONS(2817),
    [anon_sym_UR_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2817),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1345] = {
    [sym_expression] = STATE(2497),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3517),
    [sym_concatenated_string] = STATE(3520),
    [sym_string_literal] = STATE(2431),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2428),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(4490),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_compl] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(4448),
    [anon_sym_PLUS_PLUS] = ACTIONS(4448),
    [anon_sym_sizeof] = ACTIONS(2807),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2813),
    [anon_sym_u_DQUOTE] = ACTIONS(2813),
    [anon_sym_U_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8_DQUOTE] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2817),
    [anon_sym_LR_DQUOTE] = ACTIONS(2817),
    [anon_sym_uR_DQUOTE] = ACTIONS(2817),
    [anon_sym_UR_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2817),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1346] = {
    [sym_expression] = STATE(2888),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(2940),
    [sym_concatenated_string] = STATE(3000),
    [sym_string_literal] = STATE(2241),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2239),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4472),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(4769),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2512),
    [anon_sym_compl] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_sizeof] = ACTIONS(2522),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2532),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [anon_sym_co_await] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1347] = {
    [sym_expression] = STATE(2482),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3517),
    [sym_concatenated_string] = STATE(3520),
    [sym_string_literal] = STATE(2431),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2428),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(4490),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_compl] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(4448),
    [anon_sym_PLUS_PLUS] = ACTIONS(4448),
    [anon_sym_sizeof] = ACTIONS(2807),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2813),
    [anon_sym_u_DQUOTE] = ACTIONS(2813),
    [anon_sym_U_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8_DQUOTE] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2817),
    [anon_sym_LR_DQUOTE] = ACTIONS(2817),
    [anon_sym_uR_DQUOTE] = ACTIONS(2817),
    [anon_sym_UR_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2817),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1348] = {
    [sym_expression] = STATE(4698),
    [sym__string] = STATE(5255),
    [sym_conditional_expression] = STATE(5255),
    [sym_assignment_expression] = STATE(5255),
    [sym_pointer_expression] = STATE(3988),
    [sym_unary_expression] = STATE(5255),
    [sym_binary_expression] = STATE(5255),
    [sym_update_expression] = STATE(5255),
    [sym_cast_expression] = STATE(5255),
    [sym_sizeof_expression] = STATE(5255),
    [sym_alignof_expression] = STATE(5255),
    [sym_offsetof_expression] = STATE(5255),
    [sym_generic_expression] = STATE(5255),
    [sym_subscript_expression] = STATE(3988),
    [sym_call_expression] = STATE(3988),
    [sym_gnu_asm_expression] = STATE(5255),
    [sym_field_expression] = STATE(3988),
    [sym_compound_literal_expression] = STATE(5255),
    [sym_parenthesized_expression] = STATE(3988),
    [sym_char_literal] = STATE(5164),
    [sym_concatenated_string] = STATE(5162),
    [sym_string_literal] = STATE(4081),
    [sym_null] = STATE(5255),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5255),
    [sym_raw_string_literal] = STATE(4060),
    [sym_co_await_expression] = STATE(5255),
    [sym_new_expression] = STATE(5255),
    [sym_delete_expression] = STATE(5255),
    [sym_requires_clause] = STATE(5255),
    [sym_requires_expression] = STATE(5255),
    [sym_lambda_expression] = STATE(5255),
    [sym_lambda_capture_specifier] = STATE(6164),
    [sym_fold_expression] = STATE(5255),
    [sym_parameter_pack_expansion] = STATE(5255),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3988),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3988),
    [sym_kernel_call_expression] = STATE(5260),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4486),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3718),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4452),
    [anon_sym_PLUS_PLUS] = ACTIONS(4452),
    [anon_sym_sizeof] = ACTIONS(3720),
    [anon_sym___alignof__] = ACTIONS(3722),
    [anon_sym___alignof] = ACTIONS(3722),
    [anon_sym__alignof] = ACTIONS(3722),
    [anon_sym_alignof] = ACTIONS(3722),
    [anon_sym__Alignof] = ACTIONS(3722),
    [anon_sym_offsetof] = ACTIONS(3724),
    [anon_sym__Generic] = ACTIONS(3726),
    [anon_sym_asm] = ACTIONS(3728),
    [anon_sym___asm__] = ACTIONS(3728),
    [sym_number_literal] = ACTIONS(3730),
    [anon_sym_L_SQUOTE] = ACTIONS(3732),
    [anon_sym_u_SQUOTE] = ACTIONS(3732),
    [anon_sym_U_SQUOTE] = ACTIONS(3732),
    [anon_sym_u8_SQUOTE] = ACTIONS(3732),
    [anon_sym_SQUOTE] = ACTIONS(3732),
    [anon_sym_L_DQUOTE] = ACTIONS(3734),
    [anon_sym_u_DQUOTE] = ACTIONS(3734),
    [anon_sym_U_DQUOTE] = ACTIONS(3734),
    [anon_sym_u8_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [sym_true] = ACTIONS(3736),
    [sym_false] = ACTIONS(3736),
    [anon_sym_NULL] = ACTIONS(3738),
    [anon_sym_nullptr] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3740),
    [anon_sym_R_DQUOTE] = ACTIONS(3742),
    [anon_sym_LR_DQUOTE] = ACTIONS(3742),
    [anon_sym_uR_DQUOTE] = ACTIONS(3742),
    [anon_sym_UR_DQUOTE] = ACTIONS(3742),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3742),
    [anon_sym_co_await] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3748),
    [sym_this] = ACTIONS(3736),
  },
  [1349] = {
    [sym_expression] = STATE(2505),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3517),
    [sym_concatenated_string] = STATE(3520),
    [sym_string_literal] = STATE(2431),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2428),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(4490),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_compl] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(4448),
    [anon_sym_PLUS_PLUS] = ACTIONS(4448),
    [anon_sym_sizeof] = ACTIONS(2807),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2813),
    [anon_sym_u_DQUOTE] = ACTIONS(2813),
    [anon_sym_U_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8_DQUOTE] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2817),
    [anon_sym_LR_DQUOTE] = ACTIONS(2817),
    [anon_sym_uR_DQUOTE] = ACTIONS(2817),
    [anon_sym_UR_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2817),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1350] = {
    [sym_expression] = STATE(4523),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1351] = {
    [sym_expression] = STATE(4544),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1352] = {
    [sym_expression] = STATE(4630),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1353] = {
    [sym_expression] = STATE(3118),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(4771),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1354] = {
    [sym_expression] = STATE(4562),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1355] = {
    [sym_expression] = STATE(4939),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8015),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(8015),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3754),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [1356] = {
    [sym_expression] = STATE(4769),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8015),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(8015),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3754),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [1357] = {
    [sym_expression] = STATE(4563),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1358] = {
    [sym_expression] = STATE(3233),
    [sym__string] = STATE(3860),
    [sym_conditional_expression] = STATE(3860),
    [sym_assignment_expression] = STATE(3860),
    [sym_pointer_expression] = STATE(3861),
    [sym_unary_expression] = STATE(3860),
    [sym_binary_expression] = STATE(3860),
    [sym_update_expression] = STATE(3860),
    [sym_cast_expression] = STATE(3860),
    [sym_sizeof_expression] = STATE(3860),
    [sym_alignof_expression] = STATE(3860),
    [sym_offsetof_expression] = STATE(3860),
    [sym_generic_expression] = STATE(3860),
    [sym_subscript_expression] = STATE(3861),
    [sym_call_expression] = STATE(3861),
    [sym_gnu_asm_expression] = STATE(3860),
    [sym_field_expression] = STATE(3861),
    [sym_compound_literal_expression] = STATE(3860),
    [sym_parenthesized_expression] = STATE(3861),
    [sym_char_literal] = STATE(3831),
    [sym_concatenated_string] = STATE(3833),
    [sym_string_literal] = STATE(2490),
    [sym_null] = STATE(3860),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7980),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3860),
    [sym_raw_string_literal] = STATE(2516),
    [sym_co_await_expression] = STATE(3860),
    [sym_new_expression] = STATE(3860),
    [sym_delete_expression] = STATE(3860),
    [sym_requires_clause] = STATE(3860),
    [sym_requires_expression] = STATE(3860),
    [sym_lambda_expression] = STATE(3860),
    [sym_lambda_capture_specifier] = STATE(6189),
    [sym_fold_expression] = STATE(3860),
    [sym_parameter_pack_expansion] = STATE(3860),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3861),
    [sym_qualified_type_identifier] = STATE(7980),
    [sym_user_defined_literal] = STATE(3861),
    [sym_kernel_call_expression] = STATE(3851),
    [sym_identifier] = ACTIONS(3179),
    [anon_sym_LPAREN2] = ACTIONS(4541),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3185),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3189),
    [anon_sym_not] = ACTIONS(3181),
    [anon_sym_compl] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(4357),
    [anon_sym_PLUS_PLUS] = ACTIONS(4357),
    [anon_sym_sizeof] = ACTIONS(3191),
    [anon_sym___alignof__] = ACTIONS(3193),
    [anon_sym___alignof] = ACTIONS(3193),
    [anon_sym__alignof] = ACTIONS(3193),
    [anon_sym_alignof] = ACTIONS(3193),
    [anon_sym__Alignof] = ACTIONS(3193),
    [anon_sym_offsetof] = ACTIONS(3195),
    [anon_sym__Generic] = ACTIONS(3197),
    [anon_sym_asm] = ACTIONS(3199),
    [anon_sym___asm__] = ACTIONS(3199),
    [sym_number_literal] = ACTIONS(3201),
    [anon_sym_L_SQUOTE] = ACTIONS(3203),
    [anon_sym_u_SQUOTE] = ACTIONS(3203),
    [anon_sym_U_SQUOTE] = ACTIONS(3203),
    [anon_sym_u8_SQUOTE] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [anon_sym_L_DQUOTE] = ACTIONS(3205),
    [anon_sym_u_DQUOTE] = ACTIONS(3205),
    [anon_sym_U_DQUOTE] = ACTIONS(3205),
    [anon_sym_u8_DQUOTE] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [anon_sym_NULL] = ACTIONS(3209),
    [anon_sym_nullptr] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_R_DQUOTE] = ACTIONS(3213),
    [anon_sym_LR_DQUOTE] = ACTIONS(3213),
    [anon_sym_uR_DQUOTE] = ACTIONS(3213),
    [anon_sym_UR_DQUOTE] = ACTIONS(3213),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3213),
    [anon_sym_co_await] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_requires] = ACTIONS(3219),
    [sym_this] = ACTIONS(3207),
  },
  [1359] = {
    [sym_expression] = STATE(4566),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1360] = {
    [sym_expression] = STATE(4567),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1361] = {
    [sym_expression] = STATE(2866),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(2940),
    [sym_concatenated_string] = STATE(3000),
    [sym_string_literal] = STATE(2241),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2239),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4472),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2512),
    [anon_sym_compl] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_sizeof] = ACTIONS(2522),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2532),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [anon_sym_co_await] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1362] = {
    [sym_expression] = STATE(5019),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1363] = {
    [sym_expression] = STATE(3725),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1364] = {
    [sym_expression] = STATE(4570),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1365] = {
    [sym_expression] = STATE(4571),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1366] = {
    [sym_expression] = STATE(4572),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1367] = {
    [sym_expression] = STATE(2856),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(2940),
    [sym_concatenated_string] = STATE(3000),
    [sym_string_literal] = STATE(2241),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2239),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4472),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2512),
    [anon_sym_compl] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_sizeof] = ACTIONS(2522),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2532),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [anon_sym_co_await] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1368] = {
    [sym_expression] = STATE(5104),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1369] = {
    [sym_expression] = STATE(4523),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1370] = {
    [sym_expression] = STATE(4575),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1371] = {
    [sym_expression] = STATE(5020),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1372] = {
    [sym_expression] = STATE(2854),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(2940),
    [sym_concatenated_string] = STATE(3000),
    [sym_string_literal] = STATE(2241),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2239),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4472),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2512),
    [anon_sym_compl] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_sizeof] = ACTIONS(2522),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2532),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [anon_sym_co_await] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1373] = {
    [sym_expression] = STATE(2482),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1374] = {
    [sym_expression] = STATE(2482),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(4773),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1375] = {
    [sym_expression] = STATE(4498),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1376] = {
    [sym_expression] = STATE(2505),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1377] = {
    [sym_expression] = STATE(2471),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(2940),
    [sym_concatenated_string] = STATE(3000),
    [sym_string_literal] = STATE(2241),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2239),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4472),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2512),
    [anon_sym_compl] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_sizeof] = ACTIONS(2522),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2532),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [anon_sym_co_await] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1378] = {
    [sym_expression] = STATE(2482),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(2940),
    [sym_concatenated_string] = STATE(3000),
    [sym_string_literal] = STATE(2241),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2239),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4472),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2512),
    [anon_sym_compl] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_sizeof] = ACTIONS(2522),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2532),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [anon_sym_co_await] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1379] = {
    [sym_expression] = STATE(2505),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(2940),
    [sym_concatenated_string] = STATE(3000),
    [sym_string_literal] = STATE(2241),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2239),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4472),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2512),
    [anon_sym_compl] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_sizeof] = ACTIONS(2522),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2532),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [anon_sym_co_await] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1380] = {
    [sym_expression] = STATE(4671),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(4775),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1381] = {
    [sym_expression] = STATE(4447),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3068),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3068),
    [sym_call_expression] = STATE(3068),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3068),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3068),
    [sym_char_literal] = STATE(4482),
    [sym_concatenated_string] = STATE(4479),
    [sym_string_literal] = STATE(3097),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3096),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3068),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3068),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(4415),
    [anon_sym_LPAREN2] = ACTIONS(4506),
    [anon_sym_BANG] = ACTIONS(3582),
    [anon_sym_TILDE] = ACTIONS(3582),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(3584),
    [anon_sym_LBRACK] = ACTIONS(4777),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_compl] = ACTIONS(3580),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(3588),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3590),
    [anon_sym_L_SQUOTE] = ACTIONS(3592),
    [anon_sym_u_SQUOTE] = ACTIONS(3592),
    [anon_sym_U_SQUOTE] = ACTIONS(3592),
    [anon_sym_u8_SQUOTE] = ACTIONS(3592),
    [anon_sym_SQUOTE] = ACTIONS(3592),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3596),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [anon_sym_co_await] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_requires] = ACTIONS(3604),
    [sym_this] = ACTIONS(221),
  },
  [1382] = {
    [sym_expression] = STATE(4498),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(4779),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1383] = {
    [sym_expression] = STATE(5069),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1384] = {
    [sym_expression] = STATE(5026),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1385] = {
    [sym_expression] = STATE(4340),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3068),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3068),
    [sym_call_expression] = STATE(3068),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3068),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3068),
    [sym_char_literal] = STATE(4482),
    [sym_concatenated_string] = STATE(4479),
    [sym_string_literal] = STATE(3097),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3096),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3068),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3068),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(4415),
    [anon_sym_LPAREN2] = ACTIONS(4506),
    [anon_sym_BANG] = ACTIONS(3582),
    [anon_sym_TILDE] = ACTIONS(3582),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(3584),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_compl] = ACTIONS(3580),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(3588),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3590),
    [anon_sym_L_SQUOTE] = ACTIONS(3592),
    [anon_sym_u_SQUOTE] = ACTIONS(3592),
    [anon_sym_U_SQUOTE] = ACTIONS(3592),
    [anon_sym_u8_SQUOTE] = ACTIONS(3592),
    [anon_sym_SQUOTE] = ACTIONS(3592),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3596),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [anon_sym_co_await] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_requires] = ACTIONS(3604),
    [sym_this] = ACTIONS(221),
  },
  [1386] = {
    [sym_expression] = STATE(3323),
    [sym__string] = STATE(3926),
    [sym_conditional_expression] = STATE(3926),
    [sym_assignment_expression] = STATE(3926),
    [sym_pointer_expression] = STATE(3934),
    [sym_unary_expression] = STATE(3926),
    [sym_binary_expression] = STATE(3926),
    [sym_update_expression] = STATE(3926),
    [sym_cast_expression] = STATE(3926),
    [sym_sizeof_expression] = STATE(3926),
    [sym_alignof_expression] = STATE(3926),
    [sym_offsetof_expression] = STATE(3926),
    [sym_generic_expression] = STATE(3926),
    [sym_subscript_expression] = STATE(3934),
    [sym_call_expression] = STATE(3934),
    [sym_gnu_asm_expression] = STATE(3926),
    [sym_field_expression] = STATE(3934),
    [sym_compound_literal_expression] = STATE(3926),
    [sym_parenthesized_expression] = STATE(3934),
    [sym_char_literal] = STATE(3755),
    [sym_concatenated_string] = STATE(3759),
    [sym_string_literal] = STATE(2463),
    [sym_null] = STATE(3926),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7876),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3926),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3926),
    [sym_new_expression] = STATE(3926),
    [sym_delete_expression] = STATE(3926),
    [sym_requires_clause] = STATE(3926),
    [sym_requires_expression] = STATE(3926),
    [sym_lambda_expression] = STATE(3926),
    [sym_lambda_capture_specifier] = STATE(6169),
    [sym_fold_expression] = STATE(3926),
    [sym_parameter_pack_expansion] = STATE(3926),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3934),
    [sym_qualified_type_identifier] = STATE(7876),
    [sym_user_defined_literal] = STATE(3934),
    [sym_kernel_call_expression] = STATE(3930),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(4518),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3291),
    [anon_sym_not] = ACTIONS(3283),
    [anon_sym_compl] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(4351),
    [anon_sym_PLUS_PLUS] = ACTIONS(4351),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3295),
    [anon_sym___alignof] = ACTIONS(3295),
    [anon_sym__alignof] = ACTIONS(3295),
    [anon_sym_alignof] = ACTIONS(3295),
    [anon_sym__Alignof] = ACTIONS(3295),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3299),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [sym_number_literal] = ACTIONS(3303),
    [anon_sym_L_SQUOTE] = ACTIONS(3305),
    [anon_sym_u_SQUOTE] = ACTIONS(3305),
    [anon_sym_U_SQUOTE] = ACTIONS(3305),
    [anon_sym_u8_SQUOTE] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_L_DQUOTE] = ACTIONS(3307),
    [anon_sym_u_DQUOTE] = ACTIONS(3307),
    [anon_sym_U_DQUOTE] = ACTIONS(3307),
    [anon_sym_u8_DQUOTE] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [anon_sym_NULL] = ACTIONS(3311),
    [anon_sym_nullptr] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_R_DQUOTE] = ACTIONS(3315),
    [anon_sym_LR_DQUOTE] = ACTIONS(3315),
    [anon_sym_uR_DQUOTE] = ACTIONS(3315),
    [anon_sym_UR_DQUOTE] = ACTIONS(3315),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3315),
    [anon_sym_co_await] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_requires] = ACTIONS(3321),
    [sym_this] = ACTIONS(3309),
  },
  [1387] = {
    [sym_expression] = STATE(4940),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1388] = {
    [sym_expression] = STATE(2851),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(2940),
    [sym_concatenated_string] = STATE(3000),
    [sym_string_literal] = STATE(2241),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2239),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4472),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(4781),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2512),
    [anon_sym_compl] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_sizeof] = ACTIONS(2522),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2532),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [anon_sym_co_await] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1389] = {
    [sym_expression] = STATE(2961),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1390] = {
    [sym_expression] = STATE(4839),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1391] = {
    [sym_expression] = STATE(3417),
    [sym__string] = STATE(3860),
    [sym_conditional_expression] = STATE(3860),
    [sym_assignment_expression] = STATE(3860),
    [sym_pointer_expression] = STATE(3861),
    [sym_unary_expression] = STATE(3860),
    [sym_binary_expression] = STATE(3860),
    [sym_update_expression] = STATE(3860),
    [sym_cast_expression] = STATE(3860),
    [sym_sizeof_expression] = STATE(3860),
    [sym_alignof_expression] = STATE(3860),
    [sym_offsetof_expression] = STATE(3860),
    [sym_generic_expression] = STATE(3860),
    [sym_subscript_expression] = STATE(3861),
    [sym_call_expression] = STATE(3861),
    [sym_gnu_asm_expression] = STATE(3860),
    [sym_field_expression] = STATE(3861),
    [sym_compound_literal_expression] = STATE(3860),
    [sym_parenthesized_expression] = STATE(3861),
    [sym_char_literal] = STATE(3831),
    [sym_concatenated_string] = STATE(3833),
    [sym_string_literal] = STATE(2490),
    [sym_null] = STATE(3860),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7980),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3860),
    [sym_raw_string_literal] = STATE(2516),
    [sym_co_await_expression] = STATE(3860),
    [sym_new_expression] = STATE(3860),
    [sym_delete_expression] = STATE(3860),
    [sym_requires_clause] = STATE(3860),
    [sym_requires_expression] = STATE(3860),
    [sym_lambda_expression] = STATE(3860),
    [sym_lambda_capture_specifier] = STATE(6189),
    [sym_fold_expression] = STATE(3860),
    [sym_parameter_pack_expansion] = STATE(3860),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3861),
    [sym_qualified_type_identifier] = STATE(7980),
    [sym_user_defined_literal] = STATE(3861),
    [sym_kernel_call_expression] = STATE(3851),
    [sym_identifier] = ACTIONS(3179),
    [anon_sym_LPAREN2] = ACTIONS(4541),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3185),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3189),
    [anon_sym_not] = ACTIONS(3181),
    [anon_sym_compl] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(4357),
    [anon_sym_PLUS_PLUS] = ACTIONS(4357),
    [anon_sym_sizeof] = ACTIONS(3191),
    [anon_sym___alignof__] = ACTIONS(3193),
    [anon_sym___alignof] = ACTIONS(3193),
    [anon_sym__alignof] = ACTIONS(3193),
    [anon_sym_alignof] = ACTIONS(3193),
    [anon_sym__Alignof] = ACTIONS(3193),
    [anon_sym_offsetof] = ACTIONS(3195),
    [anon_sym__Generic] = ACTIONS(3197),
    [anon_sym_asm] = ACTIONS(3199),
    [anon_sym___asm__] = ACTIONS(3199),
    [sym_number_literal] = ACTIONS(3201),
    [anon_sym_L_SQUOTE] = ACTIONS(3203),
    [anon_sym_u_SQUOTE] = ACTIONS(3203),
    [anon_sym_U_SQUOTE] = ACTIONS(3203),
    [anon_sym_u8_SQUOTE] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [anon_sym_L_DQUOTE] = ACTIONS(3205),
    [anon_sym_u_DQUOTE] = ACTIONS(3205),
    [anon_sym_U_DQUOTE] = ACTIONS(3205),
    [anon_sym_u8_DQUOTE] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [anon_sym_NULL] = ACTIONS(3209),
    [anon_sym_nullptr] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_R_DQUOTE] = ACTIONS(3213),
    [anon_sym_LR_DQUOTE] = ACTIONS(3213),
    [anon_sym_uR_DQUOTE] = ACTIONS(3213),
    [anon_sym_UR_DQUOTE] = ACTIONS(3213),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3213),
    [anon_sym_co_await] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_requires] = ACTIONS(3219),
    [sym_this] = ACTIONS(3207),
  },
  [1392] = {
    [sym_expression] = STATE(5085),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1393] = {
    [sym_expression] = STATE(3173),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(4783),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1394] = {
    [sym_expression] = STATE(3094),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1395] = {
    [sym_expression] = STATE(5072),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1396] = {
    [sym_expression] = STATE(5032),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1397] = {
    [sym_expression] = STATE(4854),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(4785),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1398] = {
    [sym_expression] = STATE(4487),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1399] = {
    [sym_expression] = STATE(4602),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1400] = {
    [sym_expression] = STATE(4654),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3591),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3591),
    [sym_call_expression] = STATE(3591),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3591),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3591),
    [sym_char_literal] = STATE(5012),
    [sym_concatenated_string] = STATE(5010),
    [sym_string_literal] = STATE(3855),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3938),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3591),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3591),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3656),
    [anon_sym_LPAREN2] = ACTIONS(4307),
    [anon_sym_BANG] = ACTIONS(3660),
    [anon_sym_TILDE] = ACTIONS(3660),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(4545),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3658),
    [anon_sym_compl] = ACTIONS(3658),
    [anon_sym_DASH_DASH] = ACTIONS(4313),
    [anon_sym_PLUS_PLUS] = ACTIONS(4313),
    [anon_sym_sizeof] = ACTIONS(3664),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3666),
    [anon_sym_L_SQUOTE] = ACTIONS(3668),
    [anon_sym_u_SQUOTE] = ACTIONS(3668),
    [anon_sym_U_SQUOTE] = ACTIONS(3668),
    [anon_sym_u8_SQUOTE] = ACTIONS(3668),
    [anon_sym_SQUOTE] = ACTIONS(3668),
    [anon_sym_L_DQUOTE] = ACTIONS(3670),
    [anon_sym_u_DQUOTE] = ACTIONS(3670),
    [anon_sym_U_DQUOTE] = ACTIONS(3670),
    [anon_sym_u8_DQUOTE] = ACTIONS(3670),
    [anon_sym_DQUOTE] = ACTIONS(3670),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3672),
    [anon_sym_R_DQUOTE] = ACTIONS(3674),
    [anon_sym_LR_DQUOTE] = ACTIONS(3674),
    [anon_sym_uR_DQUOTE] = ACTIONS(3674),
    [anon_sym_UR_DQUOTE] = ACTIONS(3674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3674),
    [anon_sym_co_await] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1401] = {
    [sym_expression] = STATE(5100),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1402] = {
    [sym_expression] = STATE(3466),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4539),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(3331),
    [anon_sym_compl] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(4365),
    [anon_sym_PLUS_PLUS] = ACTIONS(4365),
    [anon_sym_sizeof] = ACTIONS(3337),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3339),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1403] = {
    [sym_expression] = STATE(4989),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1404] = {
    [sym_expression] = STATE(5068),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1405] = {
    [sym_expression] = STATE(3473),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4539),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(3331),
    [anon_sym_compl] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(4365),
    [anon_sym_PLUS_PLUS] = ACTIONS(4365),
    [anon_sym_sizeof] = ACTIONS(3337),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3339),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1406] = {
    [sym_expression] = STATE(4906),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1407] = {
    [sym_expression] = STATE(3269),
    [sym__string] = STATE(3860),
    [sym_conditional_expression] = STATE(3860),
    [sym_assignment_expression] = STATE(3860),
    [sym_pointer_expression] = STATE(3861),
    [sym_unary_expression] = STATE(3860),
    [sym_binary_expression] = STATE(3860),
    [sym_update_expression] = STATE(3860),
    [sym_cast_expression] = STATE(3860),
    [sym_sizeof_expression] = STATE(3860),
    [sym_alignof_expression] = STATE(3860),
    [sym_offsetof_expression] = STATE(3860),
    [sym_generic_expression] = STATE(3860),
    [sym_subscript_expression] = STATE(3861),
    [sym_call_expression] = STATE(3861),
    [sym_gnu_asm_expression] = STATE(3860),
    [sym_field_expression] = STATE(3861),
    [sym_compound_literal_expression] = STATE(3860),
    [sym_parenthesized_expression] = STATE(3861),
    [sym_char_literal] = STATE(3831),
    [sym_concatenated_string] = STATE(3833),
    [sym_string_literal] = STATE(2490),
    [sym_null] = STATE(3860),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7980),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3860),
    [sym_raw_string_literal] = STATE(2516),
    [sym_co_await_expression] = STATE(3860),
    [sym_new_expression] = STATE(3860),
    [sym_delete_expression] = STATE(3860),
    [sym_requires_clause] = STATE(3860),
    [sym_requires_expression] = STATE(3860),
    [sym_lambda_expression] = STATE(3860),
    [sym_lambda_capture_specifier] = STATE(6189),
    [sym_fold_expression] = STATE(3860),
    [sym_parameter_pack_expansion] = STATE(3860),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3861),
    [sym_qualified_type_identifier] = STATE(7980),
    [sym_user_defined_literal] = STATE(3861),
    [sym_kernel_call_expression] = STATE(3851),
    [sym_identifier] = ACTIONS(3179),
    [anon_sym_LPAREN2] = ACTIONS(4541),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3185),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3189),
    [anon_sym_not] = ACTIONS(3181),
    [anon_sym_compl] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(4357),
    [anon_sym_PLUS_PLUS] = ACTIONS(4357),
    [anon_sym_sizeof] = ACTIONS(3191),
    [anon_sym___alignof__] = ACTIONS(3193),
    [anon_sym___alignof] = ACTIONS(3193),
    [anon_sym__alignof] = ACTIONS(3193),
    [anon_sym_alignof] = ACTIONS(3193),
    [anon_sym__Alignof] = ACTIONS(3193),
    [anon_sym_offsetof] = ACTIONS(3195),
    [anon_sym__Generic] = ACTIONS(3197),
    [anon_sym_asm] = ACTIONS(3199),
    [anon_sym___asm__] = ACTIONS(3199),
    [sym_number_literal] = ACTIONS(3201),
    [anon_sym_L_SQUOTE] = ACTIONS(3203),
    [anon_sym_u_SQUOTE] = ACTIONS(3203),
    [anon_sym_U_SQUOTE] = ACTIONS(3203),
    [anon_sym_u8_SQUOTE] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [anon_sym_L_DQUOTE] = ACTIONS(3205),
    [anon_sym_u_DQUOTE] = ACTIONS(3205),
    [anon_sym_U_DQUOTE] = ACTIONS(3205),
    [anon_sym_u8_DQUOTE] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [anon_sym_NULL] = ACTIONS(3209),
    [anon_sym_nullptr] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_R_DQUOTE] = ACTIONS(3213),
    [anon_sym_LR_DQUOTE] = ACTIONS(3213),
    [anon_sym_uR_DQUOTE] = ACTIONS(3213),
    [anon_sym_UR_DQUOTE] = ACTIONS(3213),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3213),
    [anon_sym_co_await] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_requires] = ACTIONS(3219),
    [sym_this] = ACTIONS(3207),
  },
  [1408] = {
    [sym_expression] = STATE(3011),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1409] = {
    [sym_expression] = STATE(3103),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1410] = {
    [sym_expression] = STATE(4916),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1411] = {
    [sym_expression] = STATE(3751),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1412] = {
    [sym_expression] = STATE(4736),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1413] = {
    [sym_expression] = STATE(4406),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3068),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3068),
    [sym_call_expression] = STATE(3068),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3068),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3068),
    [sym_char_literal] = STATE(4482),
    [sym_concatenated_string] = STATE(4479),
    [sym_string_literal] = STATE(3097),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3096),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3068),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3068),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(4415),
    [anon_sym_LPAREN2] = ACTIONS(4506),
    [anon_sym_BANG] = ACTIONS(3582),
    [anon_sym_TILDE] = ACTIONS(3582),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(3584),
    [anon_sym_LBRACK] = ACTIONS(4787),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_compl] = ACTIONS(3580),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(3588),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3590),
    [anon_sym_L_SQUOTE] = ACTIONS(3592),
    [anon_sym_u_SQUOTE] = ACTIONS(3592),
    [anon_sym_U_SQUOTE] = ACTIONS(3592),
    [anon_sym_u8_SQUOTE] = ACTIONS(3592),
    [anon_sym_SQUOTE] = ACTIONS(3592),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3596),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [anon_sym_co_await] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_requires] = ACTIONS(3604),
    [sym_this] = ACTIONS(221),
  },
  [1414] = {
    [sym_expression] = STATE(4934),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1415] = {
    [sym_expression] = STATE(4953),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1416] = {
    [sym_expression] = STATE(4963),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1417] = {
    [sym_expression] = STATE(3428),
    [sym__string] = STATE(3926),
    [sym_conditional_expression] = STATE(3926),
    [sym_assignment_expression] = STATE(3926),
    [sym_pointer_expression] = STATE(3934),
    [sym_unary_expression] = STATE(3926),
    [sym_binary_expression] = STATE(3926),
    [sym_update_expression] = STATE(3926),
    [sym_cast_expression] = STATE(3926),
    [sym_sizeof_expression] = STATE(3926),
    [sym_alignof_expression] = STATE(3926),
    [sym_offsetof_expression] = STATE(3926),
    [sym_generic_expression] = STATE(3926),
    [sym_subscript_expression] = STATE(3934),
    [sym_call_expression] = STATE(3934),
    [sym_gnu_asm_expression] = STATE(3926),
    [sym_field_expression] = STATE(3934),
    [sym_compound_literal_expression] = STATE(3926),
    [sym_parenthesized_expression] = STATE(3934),
    [sym_char_literal] = STATE(3755),
    [sym_concatenated_string] = STATE(3759),
    [sym_string_literal] = STATE(2463),
    [sym_null] = STATE(3926),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7876),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3926),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3926),
    [sym_new_expression] = STATE(3926),
    [sym_delete_expression] = STATE(3926),
    [sym_requires_clause] = STATE(3926),
    [sym_requires_expression] = STATE(3926),
    [sym_lambda_expression] = STATE(3926),
    [sym_lambda_capture_specifier] = STATE(6169),
    [sym_fold_expression] = STATE(3926),
    [sym_parameter_pack_expansion] = STATE(3926),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3934),
    [sym_qualified_type_identifier] = STATE(7876),
    [sym_user_defined_literal] = STATE(3934),
    [sym_kernel_call_expression] = STATE(3930),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(4518),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3291),
    [anon_sym_not] = ACTIONS(3283),
    [anon_sym_compl] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(4351),
    [anon_sym_PLUS_PLUS] = ACTIONS(4351),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3295),
    [anon_sym___alignof] = ACTIONS(3295),
    [anon_sym__alignof] = ACTIONS(3295),
    [anon_sym_alignof] = ACTIONS(3295),
    [anon_sym__Alignof] = ACTIONS(3295),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3299),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [sym_number_literal] = ACTIONS(3303),
    [anon_sym_L_SQUOTE] = ACTIONS(3305),
    [anon_sym_u_SQUOTE] = ACTIONS(3305),
    [anon_sym_U_SQUOTE] = ACTIONS(3305),
    [anon_sym_u8_SQUOTE] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_L_DQUOTE] = ACTIONS(3307),
    [anon_sym_u_DQUOTE] = ACTIONS(3307),
    [anon_sym_U_DQUOTE] = ACTIONS(3307),
    [anon_sym_u8_DQUOTE] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [anon_sym_NULL] = ACTIONS(3311),
    [anon_sym_nullptr] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_R_DQUOTE] = ACTIONS(3315),
    [anon_sym_LR_DQUOTE] = ACTIONS(3315),
    [anon_sym_uR_DQUOTE] = ACTIONS(3315),
    [anon_sym_UR_DQUOTE] = ACTIONS(3315),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3315),
    [anon_sym_co_await] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_requires] = ACTIONS(3321),
    [sym_this] = ACTIONS(3309),
  },
  [1418] = {
    [sym_expression] = STATE(3445),
    [sym__string] = STATE(3926),
    [sym_conditional_expression] = STATE(3926),
    [sym_assignment_expression] = STATE(3926),
    [sym_pointer_expression] = STATE(3934),
    [sym_unary_expression] = STATE(3926),
    [sym_binary_expression] = STATE(3926),
    [sym_update_expression] = STATE(3926),
    [sym_cast_expression] = STATE(3926),
    [sym_sizeof_expression] = STATE(3926),
    [sym_alignof_expression] = STATE(3926),
    [sym_offsetof_expression] = STATE(3926),
    [sym_generic_expression] = STATE(3926),
    [sym_subscript_expression] = STATE(3934),
    [sym_call_expression] = STATE(3934),
    [sym_gnu_asm_expression] = STATE(3926),
    [sym_field_expression] = STATE(3934),
    [sym_compound_literal_expression] = STATE(3926),
    [sym_parenthesized_expression] = STATE(3934),
    [sym_char_literal] = STATE(3755),
    [sym_concatenated_string] = STATE(3759),
    [sym_string_literal] = STATE(2463),
    [sym_null] = STATE(3926),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7876),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3926),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3926),
    [sym_new_expression] = STATE(3926),
    [sym_delete_expression] = STATE(3926),
    [sym_requires_clause] = STATE(3926),
    [sym_requires_expression] = STATE(3926),
    [sym_lambda_expression] = STATE(3926),
    [sym_lambda_capture_specifier] = STATE(6169),
    [sym_fold_expression] = STATE(3926),
    [sym_parameter_pack_expansion] = STATE(3926),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3934),
    [sym_qualified_type_identifier] = STATE(7876),
    [sym_user_defined_literal] = STATE(3934),
    [sym_kernel_call_expression] = STATE(3930),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(4518),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3291),
    [anon_sym_not] = ACTIONS(3283),
    [anon_sym_compl] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(4351),
    [anon_sym_PLUS_PLUS] = ACTIONS(4351),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3295),
    [anon_sym___alignof] = ACTIONS(3295),
    [anon_sym__alignof] = ACTIONS(3295),
    [anon_sym_alignof] = ACTIONS(3295),
    [anon_sym__Alignof] = ACTIONS(3295),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3299),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [sym_number_literal] = ACTIONS(3303),
    [anon_sym_L_SQUOTE] = ACTIONS(3305),
    [anon_sym_u_SQUOTE] = ACTIONS(3305),
    [anon_sym_U_SQUOTE] = ACTIONS(3305),
    [anon_sym_u8_SQUOTE] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_L_DQUOTE] = ACTIONS(3307),
    [anon_sym_u_DQUOTE] = ACTIONS(3307),
    [anon_sym_U_DQUOTE] = ACTIONS(3307),
    [anon_sym_u8_DQUOTE] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [anon_sym_NULL] = ACTIONS(3311),
    [anon_sym_nullptr] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_R_DQUOTE] = ACTIONS(3315),
    [anon_sym_LR_DQUOTE] = ACTIONS(3315),
    [anon_sym_uR_DQUOTE] = ACTIONS(3315),
    [anon_sym_UR_DQUOTE] = ACTIONS(3315),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3315),
    [anon_sym_co_await] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_requires] = ACTIONS(3321),
    [sym_this] = ACTIONS(3309),
  },
  [1419] = {
    [sym_expression] = STATE(4966),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1420] = {
    [sym_expression] = STATE(4978),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1421] = {
    [sym_expression] = STATE(4982),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1422] = {
    [sym_expression] = STATE(3140),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3517),
    [sym_concatenated_string] = STATE(3520),
    [sym_string_literal] = STATE(2431),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2428),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(4490),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_compl] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(4448),
    [anon_sym_PLUS_PLUS] = ACTIONS(4448),
    [anon_sym_sizeof] = ACTIONS(2807),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2813),
    [anon_sym_u_DQUOTE] = ACTIONS(2813),
    [anon_sym_U_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8_DQUOTE] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2817),
    [anon_sym_LR_DQUOTE] = ACTIONS(2817),
    [anon_sym_uR_DQUOTE] = ACTIONS(2817),
    [anon_sym_UR_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2817),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1423] = {
    [sym_expression] = STATE(3164),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3517),
    [sym_concatenated_string] = STATE(3520),
    [sym_string_literal] = STATE(2431),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2428),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(4490),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_compl] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(4448),
    [anon_sym_PLUS_PLUS] = ACTIONS(4448),
    [anon_sym_sizeof] = ACTIONS(2807),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2813),
    [anon_sym_u_DQUOTE] = ACTIONS(2813),
    [anon_sym_U_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8_DQUOTE] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2817),
    [anon_sym_LR_DQUOTE] = ACTIONS(2817),
    [anon_sym_uR_DQUOTE] = ACTIONS(2817),
    [anon_sym_UR_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2817),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1424] = {
    [sym_expression] = STATE(3128),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3517),
    [sym_concatenated_string] = STATE(3520),
    [sym_string_literal] = STATE(2431),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2428),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(4490),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_compl] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(4448),
    [anon_sym_PLUS_PLUS] = ACTIONS(4448),
    [anon_sym_sizeof] = ACTIONS(2807),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2813),
    [anon_sym_u_DQUOTE] = ACTIONS(2813),
    [anon_sym_U_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8_DQUOTE] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2817),
    [anon_sym_LR_DQUOTE] = ACTIONS(2817),
    [anon_sym_uR_DQUOTE] = ACTIONS(2817),
    [anon_sym_UR_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2817),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1425] = {
    [sym_expression] = STATE(5126),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1426] = {
    [sym_expression] = STATE(4990),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1427] = {
    [sym_expression] = STATE(4871),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1428] = {
    [sym_expression] = STATE(5033),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1429] = {
    [sym_expression] = STATE(2480),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1430] = {
    [sym_expression] = STATE(3090),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(4789),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1431] = {
    [sym_expression] = STATE(3090),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1432] = {
    [sym_expression] = STATE(2988),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1433] = {
    [sym_expression] = STATE(4684),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1434] = {
    [sym_expression] = STATE(3130),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3517),
    [sym_concatenated_string] = STATE(3520),
    [sym_string_literal] = STATE(2431),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2428),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(4490),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_compl] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(4448),
    [anon_sym_PLUS_PLUS] = ACTIONS(4448),
    [anon_sym_sizeof] = ACTIONS(2807),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2813),
    [anon_sym_u_DQUOTE] = ACTIONS(2813),
    [anon_sym_U_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8_DQUOTE] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2817),
    [anon_sym_LR_DQUOTE] = ACTIONS(2817),
    [anon_sym_uR_DQUOTE] = ACTIONS(2817),
    [anon_sym_UR_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2817),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1435] = {
    [sym_expression] = STATE(2969),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1436] = {
    [sym_expression] = STATE(2945),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1437] = {
    [sym_expression] = STATE(5066),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1438] = {
    [sym_expression] = STATE(2973),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1439] = {
    [sym_expression] = STATE(5067),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1440] = {
    [sym_expression] = STATE(4905),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1441] = {
    [sym_expression] = STATE(5084),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1442] = {
    [sym_expression] = STATE(3131),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3517),
    [sym_concatenated_string] = STATE(3520),
    [sym_string_literal] = STATE(2431),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2428),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(4490),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_compl] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(4448),
    [anon_sym_PLUS_PLUS] = ACTIONS(4448),
    [anon_sym_sizeof] = ACTIONS(2807),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2813),
    [anon_sym_u_DQUOTE] = ACTIONS(2813),
    [anon_sym_U_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8_DQUOTE] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2817),
    [anon_sym_LR_DQUOTE] = ACTIONS(2817),
    [anon_sym_uR_DQUOTE] = ACTIONS(2817),
    [anon_sym_UR_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2817),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1443] = {
    [sym_expression] = STATE(4565),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1444] = {
    [sym_expression] = STATE(2943),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1445] = {
    [sym_expression] = STATE(5107),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1446] = {
    [sym_expression] = STATE(4825),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1447] = {
    [sym_expression] = STATE(4446),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3068),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3068),
    [sym_call_expression] = STATE(3068),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3068),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3068),
    [sym_char_literal] = STATE(4482),
    [sym_concatenated_string] = STATE(4479),
    [sym_string_literal] = STATE(3097),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3096),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3068),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3068),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(4415),
    [anon_sym_LPAREN2] = ACTIONS(4506),
    [anon_sym_BANG] = ACTIONS(3582),
    [anon_sym_TILDE] = ACTIONS(3582),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(3584),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_compl] = ACTIONS(3580),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(3588),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3590),
    [anon_sym_L_SQUOTE] = ACTIONS(3592),
    [anon_sym_u_SQUOTE] = ACTIONS(3592),
    [anon_sym_U_SQUOTE] = ACTIONS(3592),
    [anon_sym_u8_SQUOTE] = ACTIONS(3592),
    [anon_sym_SQUOTE] = ACTIONS(3592),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3596),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [anon_sym_co_await] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_requires] = ACTIONS(3604),
    [sym_this] = ACTIONS(221),
  },
  [1448] = {
    [sym_expression] = STATE(4720),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1449] = {
    [sym_expression] = STATE(4353),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3068),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3068),
    [sym_call_expression] = STATE(3068),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3068),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3068),
    [sym_char_literal] = STATE(4482),
    [sym_concatenated_string] = STATE(4479),
    [sym_string_literal] = STATE(3097),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3096),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3068),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3068),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(4415),
    [anon_sym_LPAREN2] = ACTIONS(4506),
    [anon_sym_BANG] = ACTIONS(3582),
    [anon_sym_TILDE] = ACTIONS(3582),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(3584),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_compl] = ACTIONS(3580),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(3588),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3590),
    [anon_sym_L_SQUOTE] = ACTIONS(3592),
    [anon_sym_u_SQUOTE] = ACTIONS(3592),
    [anon_sym_U_SQUOTE] = ACTIONS(3592),
    [anon_sym_u8_SQUOTE] = ACTIONS(3592),
    [anon_sym_SQUOTE] = ACTIONS(3592),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3596),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [anon_sym_co_await] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_requires] = ACTIONS(3604),
    [sym_this] = ACTIONS(221),
  },
  [1450] = {
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3068),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3068),
    [sym_call_expression] = STATE(3068),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3068),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3068),
    [sym_char_literal] = STATE(4482),
    [sym_concatenated_string] = STATE(4479),
    [sym_string_literal] = STATE(3097),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3096),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3068),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3068),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(4415),
    [anon_sym_LPAREN2] = ACTIONS(4506),
    [anon_sym_BANG] = ACTIONS(3582),
    [anon_sym_TILDE] = ACTIONS(3582),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(3584),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_compl] = ACTIONS(3580),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(3588),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3590),
    [anon_sym_L_SQUOTE] = ACTIONS(3592),
    [anon_sym_u_SQUOTE] = ACTIONS(3592),
    [anon_sym_U_SQUOTE] = ACTIONS(3592),
    [anon_sym_u8_SQUOTE] = ACTIONS(3592),
    [anon_sym_SQUOTE] = ACTIONS(3592),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3596),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [anon_sym_co_await] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_requires] = ACTIONS(3604),
    [sym_this] = ACTIONS(221),
  },
  [1451] = {
    [sym_expression] = STATE(5140),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1452] = {
    [sym_expression] = STATE(4366),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3068),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3068),
    [sym_call_expression] = STATE(3068),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3068),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3068),
    [sym_char_literal] = STATE(4482),
    [sym_concatenated_string] = STATE(4479),
    [sym_string_literal] = STATE(3097),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3096),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3068),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3068),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(4415),
    [anon_sym_LPAREN2] = ACTIONS(4506),
    [anon_sym_BANG] = ACTIONS(3582),
    [anon_sym_TILDE] = ACTIONS(3582),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(3584),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_compl] = ACTIONS(3580),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(3588),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3590),
    [anon_sym_L_SQUOTE] = ACTIONS(3592),
    [anon_sym_u_SQUOTE] = ACTIONS(3592),
    [anon_sym_U_SQUOTE] = ACTIONS(3592),
    [anon_sym_u8_SQUOTE] = ACTIONS(3592),
    [anon_sym_SQUOTE] = ACTIONS(3592),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3596),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [anon_sym_co_await] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_requires] = ACTIONS(3604),
    [sym_this] = ACTIONS(221),
  },
  [1453] = {
    [sym_expression] = STATE(2942),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1454] = {
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3068),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3068),
    [sym_call_expression] = STATE(3068),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3068),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3068),
    [sym_char_literal] = STATE(4482),
    [sym_concatenated_string] = STATE(4479),
    [sym_string_literal] = STATE(3097),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3096),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3068),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3068),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(4415),
    [anon_sym_LPAREN2] = ACTIONS(4506),
    [anon_sym_BANG] = ACTIONS(3582),
    [anon_sym_TILDE] = ACTIONS(3582),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(3584),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_compl] = ACTIONS(3580),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(3588),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3590),
    [anon_sym_L_SQUOTE] = ACTIONS(3592),
    [anon_sym_u_SQUOTE] = ACTIONS(3592),
    [anon_sym_U_SQUOTE] = ACTIONS(3592),
    [anon_sym_u8_SQUOTE] = ACTIONS(3592),
    [anon_sym_SQUOTE] = ACTIONS(3592),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3596),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [anon_sym_co_await] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_requires] = ACTIONS(3604),
    [sym_this] = ACTIONS(221),
  },
  [1455] = {
    [sym_expression] = STATE(5147),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1456] = {
    [sym_expression] = STATE(2954),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1457] = {
    [sym_expression] = STATE(2959),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1458] = {
    [sym_expression] = STATE(4775),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8015),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(8015),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3754),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [1459] = {
    [sym_expression] = STATE(3132),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3517),
    [sym_concatenated_string] = STATE(3520),
    [sym_string_literal] = STATE(2431),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2428),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(4490),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_compl] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(4448),
    [anon_sym_PLUS_PLUS] = ACTIONS(4448),
    [anon_sym_sizeof] = ACTIONS(2807),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2813),
    [anon_sym_u_DQUOTE] = ACTIONS(2813),
    [anon_sym_U_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8_DQUOTE] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2817),
    [anon_sym_LR_DQUOTE] = ACTIONS(2817),
    [anon_sym_uR_DQUOTE] = ACTIONS(2817),
    [anon_sym_UR_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2817),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1460] = {
    [sym_expression] = STATE(4379),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3068),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3068),
    [sym_call_expression] = STATE(3068),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3068),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3068),
    [sym_char_literal] = STATE(4482),
    [sym_concatenated_string] = STATE(4479),
    [sym_string_literal] = STATE(3097),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3096),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3068),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3068),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(4415),
    [anon_sym_LPAREN2] = ACTIONS(4506),
    [anon_sym_BANG] = ACTIONS(3582),
    [anon_sym_TILDE] = ACTIONS(3582),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(3584),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_compl] = ACTIONS(3580),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(3588),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3590),
    [anon_sym_L_SQUOTE] = ACTIONS(3592),
    [anon_sym_u_SQUOTE] = ACTIONS(3592),
    [anon_sym_U_SQUOTE] = ACTIONS(3592),
    [anon_sym_u8_SQUOTE] = ACTIONS(3592),
    [anon_sym_SQUOTE] = ACTIONS(3592),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3596),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [anon_sym_co_await] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_requires] = ACTIONS(3604),
    [sym_this] = ACTIONS(221),
  },
  [1461] = {
    [sym_expression] = STATE(5057),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1462] = {
    [sym_expression] = STATE(3133),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3517),
    [sym_concatenated_string] = STATE(3520),
    [sym_string_literal] = STATE(2431),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2428),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(4490),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_compl] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(4448),
    [anon_sym_PLUS_PLUS] = ACTIONS(4448),
    [anon_sym_sizeof] = ACTIONS(2807),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2813),
    [anon_sym_u_DQUOTE] = ACTIONS(2813),
    [anon_sym_U_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8_DQUOTE] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2817),
    [anon_sym_LR_DQUOTE] = ACTIONS(2817),
    [anon_sym_uR_DQUOTE] = ACTIONS(2817),
    [anon_sym_UR_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2817),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1463] = {
    [sym_expression] = STATE(4681),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1464] = {
    [sym_expression] = STATE(3135),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3517),
    [sym_concatenated_string] = STATE(3520),
    [sym_string_literal] = STATE(2431),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2428),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(4490),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_compl] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(4448),
    [anon_sym_PLUS_PLUS] = ACTIONS(4448),
    [anon_sym_sizeof] = ACTIONS(2807),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2813),
    [anon_sym_u_DQUOTE] = ACTIONS(2813),
    [anon_sym_U_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8_DQUOTE] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2817),
    [anon_sym_LR_DQUOTE] = ACTIONS(2817),
    [anon_sym_uR_DQUOTE] = ACTIONS(2817),
    [anon_sym_UR_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2817),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1465] = {
    [sym_expression] = STATE(2963),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1466] = {
    [sym_expression] = STATE(5023),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1467] = {
    [sym_expression] = STATE(5021),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1468] = {
    [sym_expression] = STATE(2480),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3517),
    [sym_concatenated_string] = STATE(3520),
    [sym_string_literal] = STATE(2431),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2428),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(4490),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_compl] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(4448),
    [anon_sym_PLUS_PLUS] = ACTIONS(4448),
    [anon_sym_sizeof] = ACTIONS(2807),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2813),
    [anon_sym_u_DQUOTE] = ACTIONS(2813),
    [anon_sym_U_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8_DQUOTE] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2817),
    [anon_sym_LR_DQUOTE] = ACTIONS(2817),
    [anon_sym_uR_DQUOTE] = ACTIONS(2817),
    [anon_sym_UR_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2817),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1469] = {
    [sym_expression] = STATE(5018),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1470] = {
    [sym_expression] = STATE(4751),
    [sym__string] = STATE(5255),
    [sym_conditional_expression] = STATE(5255),
    [sym_assignment_expression] = STATE(5255),
    [sym_pointer_expression] = STATE(3988),
    [sym_unary_expression] = STATE(5255),
    [sym_binary_expression] = STATE(5255),
    [sym_update_expression] = STATE(5255),
    [sym_cast_expression] = STATE(5255),
    [sym_sizeof_expression] = STATE(5255),
    [sym_alignof_expression] = STATE(5255),
    [sym_offsetof_expression] = STATE(5255),
    [sym_generic_expression] = STATE(5255),
    [sym_subscript_expression] = STATE(3988),
    [sym_call_expression] = STATE(3988),
    [sym_gnu_asm_expression] = STATE(5255),
    [sym_field_expression] = STATE(3988),
    [sym_compound_literal_expression] = STATE(5255),
    [sym_parenthesized_expression] = STATE(3988),
    [sym_char_literal] = STATE(5164),
    [sym_concatenated_string] = STATE(5162),
    [sym_string_literal] = STATE(4081),
    [sym_null] = STATE(5255),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5255),
    [sym_raw_string_literal] = STATE(4060),
    [sym_co_await_expression] = STATE(5255),
    [sym_new_expression] = STATE(5255),
    [sym_delete_expression] = STATE(5255),
    [sym_requires_clause] = STATE(5255),
    [sym_requires_expression] = STATE(5255),
    [sym_lambda_expression] = STATE(5255),
    [sym_lambda_capture_specifier] = STATE(6164),
    [sym_fold_expression] = STATE(5255),
    [sym_parameter_pack_expansion] = STATE(5255),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3988),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3988),
    [sym_kernel_call_expression] = STATE(5260),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4486),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3718),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4452),
    [anon_sym_PLUS_PLUS] = ACTIONS(4452),
    [anon_sym_sizeof] = ACTIONS(3720),
    [anon_sym___alignof__] = ACTIONS(3722),
    [anon_sym___alignof] = ACTIONS(3722),
    [anon_sym__alignof] = ACTIONS(3722),
    [anon_sym_alignof] = ACTIONS(3722),
    [anon_sym__Alignof] = ACTIONS(3722),
    [anon_sym_offsetof] = ACTIONS(3724),
    [anon_sym__Generic] = ACTIONS(3726),
    [anon_sym_asm] = ACTIONS(3728),
    [anon_sym___asm__] = ACTIONS(3728),
    [sym_number_literal] = ACTIONS(3730),
    [anon_sym_L_SQUOTE] = ACTIONS(3732),
    [anon_sym_u_SQUOTE] = ACTIONS(3732),
    [anon_sym_U_SQUOTE] = ACTIONS(3732),
    [anon_sym_u8_SQUOTE] = ACTIONS(3732),
    [anon_sym_SQUOTE] = ACTIONS(3732),
    [anon_sym_L_DQUOTE] = ACTIONS(3734),
    [anon_sym_u_DQUOTE] = ACTIONS(3734),
    [anon_sym_U_DQUOTE] = ACTIONS(3734),
    [anon_sym_u8_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [sym_true] = ACTIONS(3736),
    [sym_false] = ACTIONS(3736),
    [anon_sym_NULL] = ACTIONS(3738),
    [anon_sym_nullptr] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3740),
    [anon_sym_R_DQUOTE] = ACTIONS(3742),
    [anon_sym_LR_DQUOTE] = ACTIONS(3742),
    [anon_sym_uR_DQUOTE] = ACTIONS(3742),
    [anon_sym_UR_DQUOTE] = ACTIONS(3742),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3742),
    [anon_sym_co_await] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3748),
    [sym_this] = ACTIONS(3736),
  },
  [1471] = {
    [sym_expression] = STATE(4413),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3068),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3068),
    [sym_call_expression] = STATE(3068),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3068),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3068),
    [sym_char_literal] = STATE(4482),
    [sym_concatenated_string] = STATE(4479),
    [sym_string_literal] = STATE(3097),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3096),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3068),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3068),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(4415),
    [anon_sym_LPAREN2] = ACTIONS(4506),
    [anon_sym_BANG] = ACTIONS(3582),
    [anon_sym_TILDE] = ACTIONS(3582),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(3584),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_compl] = ACTIONS(3580),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(3588),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3590),
    [anon_sym_L_SQUOTE] = ACTIONS(3592),
    [anon_sym_u_SQUOTE] = ACTIONS(3592),
    [anon_sym_U_SQUOTE] = ACTIONS(3592),
    [anon_sym_u8_SQUOTE] = ACTIONS(3592),
    [anon_sym_SQUOTE] = ACTIONS(3592),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3596),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [anon_sym_co_await] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_requires] = ACTIONS(3604),
    [sym_this] = ACTIONS(221),
  },
  [1472] = {
    [sym_expression] = STATE(4425),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3068),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3068),
    [sym_call_expression] = STATE(3068),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3068),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3068),
    [sym_char_literal] = STATE(4482),
    [sym_concatenated_string] = STATE(4479),
    [sym_string_literal] = STATE(3097),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3096),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3068),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3068),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(4415),
    [anon_sym_LPAREN2] = ACTIONS(4506),
    [anon_sym_BANG] = ACTIONS(3582),
    [anon_sym_TILDE] = ACTIONS(3582),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(3584),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_compl] = ACTIONS(3580),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(3588),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3590),
    [anon_sym_L_SQUOTE] = ACTIONS(3592),
    [anon_sym_u_SQUOTE] = ACTIONS(3592),
    [anon_sym_U_SQUOTE] = ACTIONS(3592),
    [anon_sym_u8_SQUOTE] = ACTIONS(3592),
    [anon_sym_SQUOTE] = ACTIONS(3592),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3596),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [anon_sym_co_await] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_requires] = ACTIONS(3604),
    [sym_this] = ACTIONS(221),
  },
  [1473] = {
    [sym_expression] = STATE(3087),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3517),
    [sym_concatenated_string] = STATE(3520),
    [sym_string_literal] = STATE(2431),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2428),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(4490),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_compl] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(4448),
    [anon_sym_PLUS_PLUS] = ACTIONS(4448),
    [anon_sym_sizeof] = ACTIONS(2807),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2813),
    [anon_sym_u_DQUOTE] = ACTIONS(2813),
    [anon_sym_U_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8_DQUOTE] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2817),
    [anon_sym_LR_DQUOTE] = ACTIONS(2817),
    [anon_sym_uR_DQUOTE] = ACTIONS(2817),
    [anon_sym_UR_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2817),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1474] = {
    [sym_expression] = STATE(4355),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3068),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3068),
    [sym_call_expression] = STATE(3068),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3068),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3068),
    [sym_char_literal] = STATE(4482),
    [sym_concatenated_string] = STATE(4479),
    [sym_string_literal] = STATE(3097),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3096),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3068),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3068),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(4415),
    [anon_sym_LPAREN2] = ACTIONS(4506),
    [anon_sym_BANG] = ACTIONS(3582),
    [anon_sym_TILDE] = ACTIONS(3582),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(3584),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_compl] = ACTIONS(3580),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(3588),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3590),
    [anon_sym_L_SQUOTE] = ACTIONS(3592),
    [anon_sym_u_SQUOTE] = ACTIONS(3592),
    [anon_sym_U_SQUOTE] = ACTIONS(3592),
    [anon_sym_u8_SQUOTE] = ACTIONS(3592),
    [anon_sym_SQUOTE] = ACTIONS(3592),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3596),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [anon_sym_co_await] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_requires] = ACTIONS(3604),
    [sym_this] = ACTIONS(221),
  },
  [1475] = {
    [sym_expression] = STATE(3172),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1476] = {
    [sym_expression] = STATE(3487),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4539),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(3331),
    [anon_sym_compl] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(4365),
    [anon_sym_PLUS_PLUS] = ACTIONS(4365),
    [anon_sym_sizeof] = ACTIONS(3337),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3339),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1477] = {
    [sym_expression] = STATE(4624),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1478] = {
    [sym_expression] = STATE(4357),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3068),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3068),
    [sym_call_expression] = STATE(3068),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3068),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3068),
    [sym_char_literal] = STATE(4482),
    [sym_concatenated_string] = STATE(4479),
    [sym_string_literal] = STATE(3097),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3096),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3068),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3068),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(4415),
    [anon_sym_LPAREN2] = ACTIONS(4506),
    [anon_sym_BANG] = ACTIONS(3582),
    [anon_sym_TILDE] = ACTIONS(3582),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(3584),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_compl] = ACTIONS(3580),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(3588),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3590),
    [anon_sym_L_SQUOTE] = ACTIONS(3592),
    [anon_sym_u_SQUOTE] = ACTIONS(3592),
    [anon_sym_U_SQUOTE] = ACTIONS(3592),
    [anon_sym_u8_SQUOTE] = ACTIONS(3592),
    [anon_sym_SQUOTE] = ACTIONS(3592),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3596),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [anon_sym_co_await] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_requires] = ACTIONS(3604),
    [sym_this] = ACTIONS(221),
  },
  [1479] = {
    [sym_expression] = STATE(5048),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1480] = {
    [sym_expression] = STATE(3456),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4539),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(4791),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(3331),
    [anon_sym_compl] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(4365),
    [anon_sym_PLUS_PLUS] = ACTIONS(4365),
    [anon_sym_sizeof] = ACTIONS(3337),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3339),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1481] = {
    [sym_expression] = STATE(5064),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1482] = {
    [sym_expression] = STATE(3441),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4539),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(3331),
    [anon_sym_compl] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(4365),
    [anon_sym_PLUS_PLUS] = ACTIONS(4365),
    [anon_sym_sizeof] = ACTIONS(3337),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3339),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1483] = {
    [sym_expression] = STATE(4605),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4793),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1484] = {
    [sym_expression] = STATE(2980),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1485] = {
    [sym_expression] = STATE(3175),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1486] = {
    [sym_expression] = STATE(3176),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1487] = {
    [sym_expression] = STATE(3141),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1488] = {
    [sym_expression] = STATE(3190),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1489] = {
    [sym_expression] = STATE(3438),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4539),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(4795),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(3331),
    [anon_sym_compl] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(4365),
    [anon_sym_PLUS_PLUS] = ACTIONS(4365),
    [anon_sym_sizeof] = ACTIONS(3337),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3339),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1490] = {
    [sym_expression] = STATE(3194),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1491] = {
    [sym_expression] = STATE(2862),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(2940),
    [sym_concatenated_string] = STATE(3000),
    [sym_string_literal] = STATE(2241),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2239),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4472),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2512),
    [anon_sym_compl] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_sizeof] = ACTIONS(2522),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2532),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [anon_sym_co_await] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1492] = {
    [sym_expression] = STATE(3633),
    [sym__string] = STATE(4146),
    [sym_conditional_expression] = STATE(4146),
    [sym_assignment_expression] = STATE(4146),
    [sym_pointer_expression] = STATE(3702),
    [sym_unary_expression] = STATE(4146),
    [sym_binary_expression] = STATE(4146),
    [sym_update_expression] = STATE(4146),
    [sym_cast_expression] = STATE(4146),
    [sym_sizeof_expression] = STATE(4146),
    [sym_alignof_expression] = STATE(4146),
    [sym_offsetof_expression] = STATE(4146),
    [sym_generic_expression] = STATE(4146),
    [sym_subscript_expression] = STATE(3702),
    [sym_call_expression] = STATE(3702),
    [sym_gnu_asm_expression] = STATE(4146),
    [sym_field_expression] = STATE(3702),
    [sym_compound_literal_expression] = STATE(4146),
    [sym_parenthesized_expression] = STATE(3702),
    [sym_char_literal] = STATE(4065),
    [sym_concatenated_string] = STATE(4064),
    [sym_string_literal] = STATE(2667),
    [sym_null] = STATE(4146),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7992),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4146),
    [sym_raw_string_literal] = STATE(2677),
    [sym_co_await_expression] = STATE(4146),
    [sym_new_expression] = STATE(4146),
    [sym_delete_expression] = STATE(4146),
    [sym_requires_clause] = STATE(4146),
    [sym_requires_expression] = STATE(4146),
    [sym_lambda_expression] = STATE(4146),
    [sym_lambda_capture_specifier] = STATE(6183),
    [sym_fold_expression] = STATE(4146),
    [sym_parameter_pack_expansion] = STATE(4146),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3702),
    [sym_qualified_type_identifier] = STATE(7992),
    [sym_user_defined_literal] = STATE(3702),
    [sym_kernel_call_expression] = STATE(4148),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_LPAREN2] = ACTIONS(1757),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_TILDE] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3456),
    [anon_sym_not] = ACTIONS(1761),
    [anon_sym_compl] = ACTIONS(1761),
    [anon_sym_DASH_DASH] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1779),
    [anon_sym_sizeof] = ACTIONS(1781),
    [anon_sym___alignof__] = ACTIONS(1783),
    [anon_sym___alignof] = ACTIONS(1783),
    [anon_sym__alignof] = ACTIONS(1783),
    [anon_sym_alignof] = ACTIONS(1783),
    [anon_sym__Alignof] = ACTIONS(1783),
    [anon_sym_offsetof] = ACTIONS(1785),
    [anon_sym__Generic] = ACTIONS(1787),
    [anon_sym_asm] = ACTIONS(1789),
    [anon_sym___asm__] = ACTIONS(1789),
    [sym_number_literal] = ACTIONS(1791),
    [anon_sym_L_SQUOTE] = ACTIONS(1793),
    [anon_sym_u_SQUOTE] = ACTIONS(1793),
    [anon_sym_U_SQUOTE] = ACTIONS(1793),
    [anon_sym_u8_SQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_L_DQUOTE] = ACTIONS(1795),
    [anon_sym_u_DQUOTE] = ACTIONS(1795),
    [anon_sym_U_DQUOTE] = ACTIONS(1795),
    [anon_sym_u8_DQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_true] = ACTIONS(1797),
    [sym_false] = ACTIONS(1797),
    [anon_sym_NULL] = ACTIONS(1799),
    [anon_sym_nullptr] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1803),
    [anon_sym_R_DQUOTE] = ACTIONS(1805),
    [anon_sym_LR_DQUOTE] = ACTIONS(1805),
    [anon_sym_uR_DQUOTE] = ACTIONS(1805),
    [anon_sym_UR_DQUOTE] = ACTIONS(1805),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1805),
    [anon_sym_co_await] = ACTIONS(1807),
    [anon_sym_new] = ACTIONS(1809),
    [anon_sym_requires] = ACTIONS(1811),
    [sym_this] = ACTIONS(1797),
  },
  [1493] = {
    [sym_expression] = STATE(4625),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1494] = {
    [sym_expression] = STATE(3204),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1495] = {
    [sym_expression] = STATE(3202),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1496] = {
    [sym_expression] = STATE(3197),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1497] = {
    [sym_expression] = STATE(3196),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1498] = {
    [sym_expression] = STATE(3454),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4539),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(3331),
    [anon_sym_compl] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(4365),
    [anon_sym_PLUS_PLUS] = ACTIONS(4365),
    [anon_sym_sizeof] = ACTIONS(3337),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3339),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1499] = {
    [sym_expression] = STATE(3109),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3517),
    [sym_concatenated_string] = STATE(3520),
    [sym_string_literal] = STATE(2431),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2428),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(4490),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_compl] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(4448),
    [anon_sym_PLUS_PLUS] = ACTIONS(4448),
    [anon_sym_sizeof] = ACTIONS(2807),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2813),
    [anon_sym_u_DQUOTE] = ACTIONS(2813),
    [anon_sym_U_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8_DQUOTE] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2817),
    [anon_sym_LR_DQUOTE] = ACTIONS(2817),
    [anon_sym_uR_DQUOTE] = ACTIONS(2817),
    [anon_sym_UR_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2817),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1500] = {
    [sym_expression] = STATE(5103),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1501] = {
    [sym_expression] = STATE(4691),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1502] = {
    [sym_expression] = STATE(3485),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4539),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(3331),
    [anon_sym_compl] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(4365),
    [anon_sym_PLUS_PLUS] = ACTIONS(4365),
    [anon_sym_sizeof] = ACTIONS(3337),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3339),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1503] = {
    [sym_expression] = STATE(5115),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1504] = {
    [sym_expression] = STATE(5119),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1505] = {
    [sym_expression] = STATE(5122),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1506] = {
    [sym_expression] = STATE(5135),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1507] = {
    [sym_expression] = STATE(4714),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1508] = {
    [sym_expression] = STATE(5118),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1509] = {
    [sym_expression] = STATE(5086),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1510] = {
    [sym_expression] = STATE(3297),
    [sym__string] = STATE(3860),
    [sym_conditional_expression] = STATE(3860),
    [sym_assignment_expression] = STATE(3860),
    [sym_pointer_expression] = STATE(3861),
    [sym_unary_expression] = STATE(3860),
    [sym_binary_expression] = STATE(3860),
    [sym_update_expression] = STATE(3860),
    [sym_cast_expression] = STATE(3860),
    [sym_sizeof_expression] = STATE(3860),
    [sym_alignof_expression] = STATE(3860),
    [sym_offsetof_expression] = STATE(3860),
    [sym_generic_expression] = STATE(3860),
    [sym_subscript_expression] = STATE(3861),
    [sym_call_expression] = STATE(3861),
    [sym_gnu_asm_expression] = STATE(3860),
    [sym_field_expression] = STATE(3861),
    [sym_compound_literal_expression] = STATE(3860),
    [sym_parenthesized_expression] = STATE(3861),
    [sym_char_literal] = STATE(3831),
    [sym_concatenated_string] = STATE(3833),
    [sym_string_literal] = STATE(2490),
    [sym_null] = STATE(3860),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7980),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3860),
    [sym_raw_string_literal] = STATE(2516),
    [sym_co_await_expression] = STATE(3860),
    [sym_new_expression] = STATE(3860),
    [sym_delete_expression] = STATE(3860),
    [sym_requires_clause] = STATE(3860),
    [sym_requires_expression] = STATE(3860),
    [sym_lambda_expression] = STATE(3860),
    [sym_lambda_capture_specifier] = STATE(6189),
    [sym_fold_expression] = STATE(3860),
    [sym_parameter_pack_expansion] = STATE(3860),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3861),
    [sym_qualified_type_identifier] = STATE(7980),
    [sym_user_defined_literal] = STATE(3861),
    [sym_kernel_call_expression] = STATE(3851),
    [sym_identifier] = ACTIONS(3179),
    [anon_sym_LPAREN2] = ACTIONS(4541),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3185),
    [anon_sym_LBRACK] = ACTIONS(4797),
    [sym_primitive_type] = ACTIONS(3189),
    [anon_sym_not] = ACTIONS(3181),
    [anon_sym_compl] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(4357),
    [anon_sym_PLUS_PLUS] = ACTIONS(4357),
    [anon_sym_sizeof] = ACTIONS(3191),
    [anon_sym___alignof__] = ACTIONS(3193),
    [anon_sym___alignof] = ACTIONS(3193),
    [anon_sym__alignof] = ACTIONS(3193),
    [anon_sym_alignof] = ACTIONS(3193),
    [anon_sym__Alignof] = ACTIONS(3193),
    [anon_sym_offsetof] = ACTIONS(3195),
    [anon_sym__Generic] = ACTIONS(3197),
    [anon_sym_asm] = ACTIONS(3199),
    [anon_sym___asm__] = ACTIONS(3199),
    [sym_number_literal] = ACTIONS(3201),
    [anon_sym_L_SQUOTE] = ACTIONS(3203),
    [anon_sym_u_SQUOTE] = ACTIONS(3203),
    [anon_sym_U_SQUOTE] = ACTIONS(3203),
    [anon_sym_u8_SQUOTE] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [anon_sym_L_DQUOTE] = ACTIONS(3205),
    [anon_sym_u_DQUOTE] = ACTIONS(3205),
    [anon_sym_U_DQUOTE] = ACTIONS(3205),
    [anon_sym_u8_DQUOTE] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [anon_sym_NULL] = ACTIONS(3209),
    [anon_sym_nullptr] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_R_DQUOTE] = ACTIONS(3213),
    [anon_sym_LR_DQUOTE] = ACTIONS(3213),
    [anon_sym_uR_DQUOTE] = ACTIONS(3213),
    [anon_sym_UR_DQUOTE] = ACTIONS(3213),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3213),
    [anon_sym_co_await] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_requires] = ACTIONS(3219),
    [sym_this] = ACTIONS(3207),
  },
  [1511] = {
    [sym_expression] = STATE(2952),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(4799),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1512] = {
    [sym_expression] = STATE(5031),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1513] = {
    [sym_expression] = STATE(2497),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1514] = {
    [sym_expression] = STATE(2968),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(4801),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1515] = {
    [sym_expression] = STATE(4641),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1516] = {
    [sym_expression] = STATE(3304),
    [sym__string] = STATE(3860),
    [sym_conditional_expression] = STATE(3860),
    [sym_assignment_expression] = STATE(3860),
    [sym_pointer_expression] = STATE(3861),
    [sym_unary_expression] = STATE(3860),
    [sym_binary_expression] = STATE(3860),
    [sym_update_expression] = STATE(3860),
    [sym_cast_expression] = STATE(3860),
    [sym_sizeof_expression] = STATE(3860),
    [sym_alignof_expression] = STATE(3860),
    [sym_offsetof_expression] = STATE(3860),
    [sym_generic_expression] = STATE(3860),
    [sym_subscript_expression] = STATE(3861),
    [sym_call_expression] = STATE(3861),
    [sym_gnu_asm_expression] = STATE(3860),
    [sym_field_expression] = STATE(3861),
    [sym_compound_literal_expression] = STATE(3860),
    [sym_parenthesized_expression] = STATE(3861),
    [sym_char_literal] = STATE(3831),
    [sym_concatenated_string] = STATE(3833),
    [sym_string_literal] = STATE(2490),
    [sym_null] = STATE(3860),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7980),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3860),
    [sym_raw_string_literal] = STATE(2516),
    [sym_co_await_expression] = STATE(3860),
    [sym_new_expression] = STATE(3860),
    [sym_delete_expression] = STATE(3860),
    [sym_requires_clause] = STATE(3860),
    [sym_requires_expression] = STATE(3860),
    [sym_lambda_expression] = STATE(3860),
    [sym_lambda_capture_specifier] = STATE(6189),
    [sym_fold_expression] = STATE(3860),
    [sym_parameter_pack_expansion] = STATE(3860),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3861),
    [sym_qualified_type_identifier] = STATE(7980),
    [sym_user_defined_literal] = STATE(3861),
    [sym_kernel_call_expression] = STATE(3851),
    [sym_identifier] = ACTIONS(3179),
    [anon_sym_LPAREN2] = ACTIONS(4541),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3185),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3189),
    [anon_sym_not] = ACTIONS(3181),
    [anon_sym_compl] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(4357),
    [anon_sym_PLUS_PLUS] = ACTIONS(4357),
    [anon_sym_sizeof] = ACTIONS(3191),
    [anon_sym___alignof__] = ACTIONS(3193),
    [anon_sym___alignof] = ACTIONS(3193),
    [anon_sym__alignof] = ACTIONS(3193),
    [anon_sym_alignof] = ACTIONS(3193),
    [anon_sym__Alignof] = ACTIONS(3193),
    [anon_sym_offsetof] = ACTIONS(3195),
    [anon_sym__Generic] = ACTIONS(3197),
    [anon_sym_asm] = ACTIONS(3199),
    [anon_sym___asm__] = ACTIONS(3199),
    [sym_number_literal] = ACTIONS(3201),
    [anon_sym_L_SQUOTE] = ACTIONS(3203),
    [anon_sym_u_SQUOTE] = ACTIONS(3203),
    [anon_sym_U_SQUOTE] = ACTIONS(3203),
    [anon_sym_u8_SQUOTE] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [anon_sym_L_DQUOTE] = ACTIONS(3205),
    [anon_sym_u_DQUOTE] = ACTIONS(3205),
    [anon_sym_U_DQUOTE] = ACTIONS(3205),
    [anon_sym_u8_DQUOTE] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [anon_sym_NULL] = ACTIONS(3209),
    [anon_sym_nullptr] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_R_DQUOTE] = ACTIONS(3213),
    [anon_sym_LR_DQUOTE] = ACTIONS(3213),
    [anon_sym_uR_DQUOTE] = ACTIONS(3213),
    [anon_sym_UR_DQUOTE] = ACTIONS(3213),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3213),
    [anon_sym_co_await] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_requires] = ACTIONS(3219),
    [sym_this] = ACTIONS(3207),
  },
  [1517] = {
    [sym_expression] = STATE(5134),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1518] = {
    [sym_expression] = STATE(5054),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1519] = {
    [sym_expression] = STATE(3305),
    [sym__string] = STATE(3860),
    [sym_conditional_expression] = STATE(3860),
    [sym_assignment_expression] = STATE(3860),
    [sym_pointer_expression] = STATE(3861),
    [sym_unary_expression] = STATE(3860),
    [sym_binary_expression] = STATE(3860),
    [sym_update_expression] = STATE(3860),
    [sym_cast_expression] = STATE(3860),
    [sym_sizeof_expression] = STATE(3860),
    [sym_alignof_expression] = STATE(3860),
    [sym_offsetof_expression] = STATE(3860),
    [sym_generic_expression] = STATE(3860),
    [sym_subscript_expression] = STATE(3861),
    [sym_call_expression] = STATE(3861),
    [sym_gnu_asm_expression] = STATE(3860),
    [sym_field_expression] = STATE(3861),
    [sym_compound_literal_expression] = STATE(3860),
    [sym_parenthesized_expression] = STATE(3861),
    [sym_char_literal] = STATE(3831),
    [sym_concatenated_string] = STATE(3833),
    [sym_string_literal] = STATE(2490),
    [sym_null] = STATE(3860),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7980),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3860),
    [sym_raw_string_literal] = STATE(2516),
    [sym_co_await_expression] = STATE(3860),
    [sym_new_expression] = STATE(3860),
    [sym_delete_expression] = STATE(3860),
    [sym_requires_clause] = STATE(3860),
    [sym_requires_expression] = STATE(3860),
    [sym_lambda_expression] = STATE(3860),
    [sym_lambda_capture_specifier] = STATE(6189),
    [sym_fold_expression] = STATE(3860),
    [sym_parameter_pack_expansion] = STATE(3860),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3861),
    [sym_qualified_type_identifier] = STATE(7980),
    [sym_user_defined_literal] = STATE(3861),
    [sym_kernel_call_expression] = STATE(3851),
    [sym_identifier] = ACTIONS(3179),
    [anon_sym_LPAREN2] = ACTIONS(4541),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3185),
    [anon_sym_LBRACK] = ACTIONS(4803),
    [sym_primitive_type] = ACTIONS(3189),
    [anon_sym_not] = ACTIONS(3181),
    [anon_sym_compl] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(4357),
    [anon_sym_PLUS_PLUS] = ACTIONS(4357),
    [anon_sym_sizeof] = ACTIONS(3191),
    [anon_sym___alignof__] = ACTIONS(3193),
    [anon_sym___alignof] = ACTIONS(3193),
    [anon_sym__alignof] = ACTIONS(3193),
    [anon_sym_alignof] = ACTIONS(3193),
    [anon_sym__Alignof] = ACTIONS(3193),
    [anon_sym_offsetof] = ACTIONS(3195),
    [anon_sym__Generic] = ACTIONS(3197),
    [anon_sym_asm] = ACTIONS(3199),
    [anon_sym___asm__] = ACTIONS(3199),
    [sym_number_literal] = ACTIONS(3201),
    [anon_sym_L_SQUOTE] = ACTIONS(3203),
    [anon_sym_u_SQUOTE] = ACTIONS(3203),
    [anon_sym_U_SQUOTE] = ACTIONS(3203),
    [anon_sym_u8_SQUOTE] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [anon_sym_L_DQUOTE] = ACTIONS(3205),
    [anon_sym_u_DQUOTE] = ACTIONS(3205),
    [anon_sym_U_DQUOTE] = ACTIONS(3205),
    [anon_sym_u8_DQUOTE] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [anon_sym_NULL] = ACTIONS(3209),
    [anon_sym_nullptr] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_R_DQUOTE] = ACTIONS(3213),
    [anon_sym_LR_DQUOTE] = ACTIONS(3213),
    [anon_sym_uR_DQUOTE] = ACTIONS(3213),
    [anon_sym_UR_DQUOTE] = ACTIONS(3213),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3213),
    [anon_sym_co_await] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_requires] = ACTIONS(3219),
    [sym_this] = ACTIONS(3207),
  },
  [1520] = {
    [sym_expression] = STATE(5078),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1521] = {
    [sym_expression] = STATE(5088),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1522] = {
    [sym_expression] = STATE(3115),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3517),
    [sym_concatenated_string] = STATE(3520),
    [sym_string_literal] = STATE(2431),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2428),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(4490),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_compl] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(4448),
    [anon_sym_PLUS_PLUS] = ACTIONS(4448),
    [anon_sym_sizeof] = ACTIONS(2807),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2813),
    [anon_sym_u_DQUOTE] = ACTIONS(2813),
    [anon_sym_U_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8_DQUOTE] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2817),
    [anon_sym_LR_DQUOTE] = ACTIONS(2817),
    [anon_sym_uR_DQUOTE] = ACTIONS(2817),
    [anon_sym_UR_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2817),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1523] = {
    [sym_expression] = STATE(4673),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1524] = {
    [sym_expression] = STATE(3139),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3517),
    [sym_concatenated_string] = STATE(3520),
    [sym_string_literal] = STATE(2431),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2428),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(4490),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_compl] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(4448),
    [anon_sym_PLUS_PLUS] = ACTIONS(4448),
    [anon_sym_sizeof] = ACTIONS(2807),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2813),
    [anon_sym_u_DQUOTE] = ACTIONS(2813),
    [anon_sym_U_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8_DQUOTE] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2817),
    [anon_sym_LR_DQUOTE] = ACTIONS(2817),
    [anon_sym_uR_DQUOTE] = ACTIONS(2817),
    [anon_sym_UR_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2817),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1525] = {
    [sym_expression] = STATE(5113),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1526] = {
    [sym_expression] = STATE(4690),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1527] = {
    [sym_expression] = STATE(5120),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1528] = {
    [sym_expression] = STATE(3142),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3517),
    [sym_concatenated_string] = STATE(3520),
    [sym_string_literal] = STATE(2431),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2428),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(4490),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(4805),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_compl] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(4448),
    [anon_sym_PLUS_PLUS] = ACTIONS(4448),
    [anon_sym_sizeof] = ACTIONS(2807),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2813),
    [anon_sym_u_DQUOTE] = ACTIONS(2813),
    [anon_sym_U_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8_DQUOTE] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2817),
    [anon_sym_LR_DQUOTE] = ACTIONS(2817),
    [anon_sym_uR_DQUOTE] = ACTIONS(2817),
    [anon_sym_UR_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2817),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1529] = {
    [sym_expression] = STATE(3281),
    [sym__string] = STATE(3860),
    [sym_conditional_expression] = STATE(3860),
    [sym_assignment_expression] = STATE(3860),
    [sym_pointer_expression] = STATE(3861),
    [sym_unary_expression] = STATE(3860),
    [sym_binary_expression] = STATE(3860),
    [sym_update_expression] = STATE(3860),
    [sym_cast_expression] = STATE(3860),
    [sym_sizeof_expression] = STATE(3860),
    [sym_alignof_expression] = STATE(3860),
    [sym_offsetof_expression] = STATE(3860),
    [sym_generic_expression] = STATE(3860),
    [sym_subscript_expression] = STATE(3861),
    [sym_call_expression] = STATE(3861),
    [sym_gnu_asm_expression] = STATE(3860),
    [sym_field_expression] = STATE(3861),
    [sym_compound_literal_expression] = STATE(3860),
    [sym_parenthesized_expression] = STATE(3861),
    [sym_char_literal] = STATE(3831),
    [sym_concatenated_string] = STATE(3833),
    [sym_string_literal] = STATE(2490),
    [sym_null] = STATE(3860),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7980),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3860),
    [sym_raw_string_literal] = STATE(2516),
    [sym_co_await_expression] = STATE(3860),
    [sym_new_expression] = STATE(3860),
    [sym_delete_expression] = STATE(3860),
    [sym_requires_clause] = STATE(3860),
    [sym_requires_expression] = STATE(3860),
    [sym_lambda_expression] = STATE(3860),
    [sym_lambda_capture_specifier] = STATE(6189),
    [sym_fold_expression] = STATE(3860),
    [sym_parameter_pack_expansion] = STATE(3860),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3861),
    [sym_qualified_type_identifier] = STATE(7980),
    [sym_user_defined_literal] = STATE(3861),
    [sym_kernel_call_expression] = STATE(3851),
    [sym_identifier] = ACTIONS(3179),
    [anon_sym_LPAREN2] = ACTIONS(4541),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3185),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3189),
    [anon_sym_not] = ACTIONS(3181),
    [anon_sym_compl] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(4357),
    [anon_sym_PLUS_PLUS] = ACTIONS(4357),
    [anon_sym_sizeof] = ACTIONS(3191),
    [anon_sym___alignof__] = ACTIONS(3193),
    [anon_sym___alignof] = ACTIONS(3193),
    [anon_sym__alignof] = ACTIONS(3193),
    [anon_sym_alignof] = ACTIONS(3193),
    [anon_sym__Alignof] = ACTIONS(3193),
    [anon_sym_offsetof] = ACTIONS(3195),
    [anon_sym__Generic] = ACTIONS(3197),
    [anon_sym_asm] = ACTIONS(3199),
    [anon_sym___asm__] = ACTIONS(3199),
    [sym_number_literal] = ACTIONS(3201),
    [anon_sym_L_SQUOTE] = ACTIONS(3203),
    [anon_sym_u_SQUOTE] = ACTIONS(3203),
    [anon_sym_U_SQUOTE] = ACTIONS(3203),
    [anon_sym_u8_SQUOTE] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [anon_sym_L_DQUOTE] = ACTIONS(3205),
    [anon_sym_u_DQUOTE] = ACTIONS(3205),
    [anon_sym_U_DQUOTE] = ACTIONS(3205),
    [anon_sym_u8_DQUOTE] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [anon_sym_NULL] = ACTIONS(3209),
    [anon_sym_nullptr] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_R_DQUOTE] = ACTIONS(3213),
    [anon_sym_LR_DQUOTE] = ACTIONS(3213),
    [anon_sym_uR_DQUOTE] = ACTIONS(3213),
    [anon_sym_UR_DQUOTE] = ACTIONS(3213),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3213),
    [anon_sym_co_await] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_requires] = ACTIONS(3219),
    [sym_this] = ACTIONS(3207),
  },
  [1530] = {
    [sym_expression] = STATE(4706),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1531] = {
    [sym_expression] = STATE(5110),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1532] = {
    [sym_expression] = STATE(5109),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1533] = {
    [sym_expression] = STATE(3279),
    [sym__string] = STATE(3860),
    [sym_conditional_expression] = STATE(3860),
    [sym_assignment_expression] = STATE(3860),
    [sym_pointer_expression] = STATE(3861),
    [sym_unary_expression] = STATE(3860),
    [sym_binary_expression] = STATE(3860),
    [sym_update_expression] = STATE(3860),
    [sym_cast_expression] = STATE(3860),
    [sym_sizeof_expression] = STATE(3860),
    [sym_alignof_expression] = STATE(3860),
    [sym_offsetof_expression] = STATE(3860),
    [sym_generic_expression] = STATE(3860),
    [sym_subscript_expression] = STATE(3861),
    [sym_call_expression] = STATE(3861),
    [sym_gnu_asm_expression] = STATE(3860),
    [sym_field_expression] = STATE(3861),
    [sym_compound_literal_expression] = STATE(3860),
    [sym_parenthesized_expression] = STATE(3861),
    [sym_char_literal] = STATE(3831),
    [sym_concatenated_string] = STATE(3833),
    [sym_string_literal] = STATE(2490),
    [sym_null] = STATE(3860),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7980),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3860),
    [sym_raw_string_literal] = STATE(2516),
    [sym_co_await_expression] = STATE(3860),
    [sym_new_expression] = STATE(3860),
    [sym_delete_expression] = STATE(3860),
    [sym_requires_clause] = STATE(3860),
    [sym_requires_expression] = STATE(3860),
    [sym_lambda_expression] = STATE(3860),
    [sym_lambda_capture_specifier] = STATE(6189),
    [sym_fold_expression] = STATE(3860),
    [sym_parameter_pack_expansion] = STATE(3860),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3861),
    [sym_qualified_type_identifier] = STATE(7980),
    [sym_user_defined_literal] = STATE(3861),
    [sym_kernel_call_expression] = STATE(3851),
    [sym_identifier] = ACTIONS(3179),
    [anon_sym_LPAREN2] = ACTIONS(4541),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3185),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3189),
    [anon_sym_not] = ACTIONS(3181),
    [anon_sym_compl] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(4357),
    [anon_sym_PLUS_PLUS] = ACTIONS(4357),
    [anon_sym_sizeof] = ACTIONS(3191),
    [anon_sym___alignof__] = ACTIONS(3193),
    [anon_sym___alignof] = ACTIONS(3193),
    [anon_sym__alignof] = ACTIONS(3193),
    [anon_sym_alignof] = ACTIONS(3193),
    [anon_sym__Alignof] = ACTIONS(3193),
    [anon_sym_offsetof] = ACTIONS(3195),
    [anon_sym__Generic] = ACTIONS(3197),
    [anon_sym_asm] = ACTIONS(3199),
    [anon_sym___asm__] = ACTIONS(3199),
    [sym_number_literal] = ACTIONS(3201),
    [anon_sym_L_SQUOTE] = ACTIONS(3203),
    [anon_sym_u_SQUOTE] = ACTIONS(3203),
    [anon_sym_U_SQUOTE] = ACTIONS(3203),
    [anon_sym_u8_SQUOTE] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [anon_sym_L_DQUOTE] = ACTIONS(3205),
    [anon_sym_u_DQUOTE] = ACTIONS(3205),
    [anon_sym_U_DQUOTE] = ACTIONS(3205),
    [anon_sym_u8_DQUOTE] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [anon_sym_NULL] = ACTIONS(3209),
    [anon_sym_nullptr] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_R_DQUOTE] = ACTIONS(3213),
    [anon_sym_LR_DQUOTE] = ACTIONS(3213),
    [anon_sym_uR_DQUOTE] = ACTIONS(3213),
    [anon_sym_UR_DQUOTE] = ACTIONS(3213),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3213),
    [anon_sym_co_await] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_requires] = ACTIONS(3219),
    [sym_this] = ACTIONS(3207),
  },
  [1534] = {
    [sym_expression] = STATE(2471),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1535] = {
    [sym_expression] = STATE(5105),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1536] = {
    [sym_expression] = STATE(2471),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3517),
    [sym_concatenated_string] = STATE(3520),
    [sym_string_literal] = STATE(2431),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2428),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(4490),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(4309),
    [anon_sym_AMP] = ACTIONS(4309),
    [anon_sym_COLON_COLON] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_compl] = ACTIONS(2801),
    [anon_sym_DASH_DASH] = ACTIONS(4448),
    [anon_sym_PLUS_PLUS] = ACTIONS(4448),
    [anon_sym_sizeof] = ACTIONS(2807),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2809),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2813),
    [anon_sym_u_DQUOTE] = ACTIONS(2813),
    [anon_sym_U_DQUOTE] = ACTIONS(2813),
    [anon_sym_u8_DQUOTE] = ACTIONS(2813),
    [anon_sym_DQUOTE] = ACTIONS(2813),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2817),
    [anon_sym_LR_DQUOTE] = ACTIONS(2817),
    [anon_sym_uR_DQUOTE] = ACTIONS(2817),
    [anon_sym_UR_DQUOTE] = ACTIONS(2817),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2817),
    [anon_sym_co_await] = ACTIONS(2819),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1537] = {
    [sym_expression] = STATE(4881),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1538] = {
    [sym_expression] = STATE(4880),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1539] = {
    [sym_expression] = STATE(4361),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3068),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3068),
    [sym_call_expression] = STATE(3068),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3068),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3068),
    [sym_char_literal] = STATE(4482),
    [sym_concatenated_string] = STATE(4479),
    [sym_string_literal] = STATE(3097),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3096),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3068),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3068),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(4415),
    [anon_sym_LPAREN2] = ACTIONS(4506),
    [anon_sym_BANG] = ACTIONS(3582),
    [anon_sym_TILDE] = ACTIONS(3582),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(3584),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_compl] = ACTIONS(3580),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(3588),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3590),
    [anon_sym_L_SQUOTE] = ACTIONS(3592),
    [anon_sym_u_SQUOTE] = ACTIONS(3592),
    [anon_sym_U_SQUOTE] = ACTIONS(3592),
    [anon_sym_u8_SQUOTE] = ACTIONS(3592),
    [anon_sym_SQUOTE] = ACTIONS(3592),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3596),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [anon_sym_co_await] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_requires] = ACTIONS(3604),
    [sym_this] = ACTIONS(221),
  },
  [1540] = {
    [sym_expression] = STATE(3277),
    [sym__string] = STATE(3860),
    [sym_conditional_expression] = STATE(3860),
    [sym_assignment_expression] = STATE(3860),
    [sym_pointer_expression] = STATE(3861),
    [sym_unary_expression] = STATE(3860),
    [sym_binary_expression] = STATE(3860),
    [sym_update_expression] = STATE(3860),
    [sym_cast_expression] = STATE(3860),
    [sym_sizeof_expression] = STATE(3860),
    [sym_alignof_expression] = STATE(3860),
    [sym_offsetof_expression] = STATE(3860),
    [sym_generic_expression] = STATE(3860),
    [sym_subscript_expression] = STATE(3861),
    [sym_call_expression] = STATE(3861),
    [sym_gnu_asm_expression] = STATE(3860),
    [sym_field_expression] = STATE(3861),
    [sym_compound_literal_expression] = STATE(3860),
    [sym_parenthesized_expression] = STATE(3861),
    [sym_char_literal] = STATE(3831),
    [sym_concatenated_string] = STATE(3833),
    [sym_string_literal] = STATE(2490),
    [sym_null] = STATE(3860),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7980),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3860),
    [sym_raw_string_literal] = STATE(2516),
    [sym_co_await_expression] = STATE(3860),
    [sym_new_expression] = STATE(3860),
    [sym_delete_expression] = STATE(3860),
    [sym_requires_clause] = STATE(3860),
    [sym_requires_expression] = STATE(3860),
    [sym_lambda_expression] = STATE(3860),
    [sym_lambda_capture_specifier] = STATE(6189),
    [sym_fold_expression] = STATE(3860),
    [sym_parameter_pack_expansion] = STATE(3860),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3861),
    [sym_qualified_type_identifier] = STATE(7980),
    [sym_user_defined_literal] = STATE(3861),
    [sym_kernel_call_expression] = STATE(3851),
    [sym_identifier] = ACTIONS(3179),
    [anon_sym_LPAREN2] = ACTIONS(4541),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3185),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3189),
    [anon_sym_not] = ACTIONS(3181),
    [anon_sym_compl] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(4357),
    [anon_sym_PLUS_PLUS] = ACTIONS(4357),
    [anon_sym_sizeof] = ACTIONS(3191),
    [anon_sym___alignof__] = ACTIONS(3193),
    [anon_sym___alignof] = ACTIONS(3193),
    [anon_sym__alignof] = ACTIONS(3193),
    [anon_sym_alignof] = ACTIONS(3193),
    [anon_sym__Alignof] = ACTIONS(3193),
    [anon_sym_offsetof] = ACTIONS(3195),
    [anon_sym__Generic] = ACTIONS(3197),
    [anon_sym_asm] = ACTIONS(3199),
    [anon_sym___asm__] = ACTIONS(3199),
    [sym_number_literal] = ACTIONS(3201),
    [anon_sym_L_SQUOTE] = ACTIONS(3203),
    [anon_sym_u_SQUOTE] = ACTIONS(3203),
    [anon_sym_U_SQUOTE] = ACTIONS(3203),
    [anon_sym_u8_SQUOTE] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [anon_sym_L_DQUOTE] = ACTIONS(3205),
    [anon_sym_u_DQUOTE] = ACTIONS(3205),
    [anon_sym_U_DQUOTE] = ACTIONS(3205),
    [anon_sym_u8_DQUOTE] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [anon_sym_NULL] = ACTIONS(3209),
    [anon_sym_nullptr] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_R_DQUOTE] = ACTIONS(3213),
    [anon_sym_LR_DQUOTE] = ACTIONS(3213),
    [anon_sym_uR_DQUOTE] = ACTIONS(3213),
    [anon_sym_UR_DQUOTE] = ACTIONS(3213),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3213),
    [anon_sym_co_await] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_requires] = ACTIONS(3219),
    [sym_this] = ACTIONS(3207),
  },
  [1541] = {
    [sym_expression] = STATE(5099),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1542] = {
    [sym_expression] = STATE(4665),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1543] = {
    [sym_expression] = STATE(3276),
    [sym__string] = STATE(3860),
    [sym_conditional_expression] = STATE(3860),
    [sym_assignment_expression] = STATE(3860),
    [sym_pointer_expression] = STATE(3861),
    [sym_unary_expression] = STATE(3860),
    [sym_binary_expression] = STATE(3860),
    [sym_update_expression] = STATE(3860),
    [sym_cast_expression] = STATE(3860),
    [sym_sizeof_expression] = STATE(3860),
    [sym_alignof_expression] = STATE(3860),
    [sym_offsetof_expression] = STATE(3860),
    [sym_generic_expression] = STATE(3860),
    [sym_subscript_expression] = STATE(3861),
    [sym_call_expression] = STATE(3861),
    [sym_gnu_asm_expression] = STATE(3860),
    [sym_field_expression] = STATE(3861),
    [sym_compound_literal_expression] = STATE(3860),
    [sym_parenthesized_expression] = STATE(3861),
    [sym_char_literal] = STATE(3831),
    [sym_concatenated_string] = STATE(3833),
    [sym_string_literal] = STATE(2490),
    [sym_null] = STATE(3860),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7980),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3860),
    [sym_raw_string_literal] = STATE(2516),
    [sym_co_await_expression] = STATE(3860),
    [sym_new_expression] = STATE(3860),
    [sym_delete_expression] = STATE(3860),
    [sym_requires_clause] = STATE(3860),
    [sym_requires_expression] = STATE(3860),
    [sym_lambda_expression] = STATE(3860),
    [sym_lambda_capture_specifier] = STATE(6189),
    [sym_fold_expression] = STATE(3860),
    [sym_parameter_pack_expansion] = STATE(3860),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3861),
    [sym_qualified_type_identifier] = STATE(7980),
    [sym_user_defined_literal] = STATE(3861),
    [sym_kernel_call_expression] = STATE(3851),
    [sym_identifier] = ACTIONS(3179),
    [anon_sym_LPAREN2] = ACTIONS(4541),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3185),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3189),
    [anon_sym_not] = ACTIONS(3181),
    [anon_sym_compl] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(4357),
    [anon_sym_PLUS_PLUS] = ACTIONS(4357),
    [anon_sym_sizeof] = ACTIONS(3191),
    [anon_sym___alignof__] = ACTIONS(3193),
    [anon_sym___alignof] = ACTIONS(3193),
    [anon_sym__alignof] = ACTIONS(3193),
    [anon_sym_alignof] = ACTIONS(3193),
    [anon_sym__Alignof] = ACTIONS(3193),
    [anon_sym_offsetof] = ACTIONS(3195),
    [anon_sym__Generic] = ACTIONS(3197),
    [anon_sym_asm] = ACTIONS(3199),
    [anon_sym___asm__] = ACTIONS(3199),
    [sym_number_literal] = ACTIONS(3201),
    [anon_sym_L_SQUOTE] = ACTIONS(3203),
    [anon_sym_u_SQUOTE] = ACTIONS(3203),
    [anon_sym_U_SQUOTE] = ACTIONS(3203),
    [anon_sym_u8_SQUOTE] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [anon_sym_L_DQUOTE] = ACTIONS(3205),
    [anon_sym_u_DQUOTE] = ACTIONS(3205),
    [anon_sym_U_DQUOTE] = ACTIONS(3205),
    [anon_sym_u8_DQUOTE] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [anon_sym_NULL] = ACTIONS(3209),
    [anon_sym_nullptr] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_R_DQUOTE] = ACTIONS(3213),
    [anon_sym_LR_DQUOTE] = ACTIONS(3213),
    [anon_sym_uR_DQUOTE] = ACTIONS(3213),
    [anon_sym_UR_DQUOTE] = ACTIONS(3213),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3213),
    [anon_sym_co_await] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_requires] = ACTIONS(3219),
    [sym_this] = ACTIONS(3207),
  },
  [1544] = {
    [sym_expression] = STATE(5056),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1545] = {
    [sym_expression] = STATE(4693),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1546] = {
    [sym_expression] = STATE(5052),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1547] = {
    [sym_expression] = STATE(4909),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1548] = {
    [sym_expression] = STATE(3219),
    [sym__string] = STATE(3860),
    [sym_conditional_expression] = STATE(3860),
    [sym_assignment_expression] = STATE(3860),
    [sym_pointer_expression] = STATE(3861),
    [sym_unary_expression] = STATE(3860),
    [sym_binary_expression] = STATE(3860),
    [sym_update_expression] = STATE(3860),
    [sym_cast_expression] = STATE(3860),
    [sym_sizeof_expression] = STATE(3860),
    [sym_alignof_expression] = STATE(3860),
    [sym_offsetof_expression] = STATE(3860),
    [sym_generic_expression] = STATE(3860),
    [sym_subscript_expression] = STATE(3861),
    [sym_call_expression] = STATE(3861),
    [sym_gnu_asm_expression] = STATE(3860),
    [sym_field_expression] = STATE(3861),
    [sym_compound_literal_expression] = STATE(3860),
    [sym_parenthesized_expression] = STATE(3861),
    [sym_char_literal] = STATE(3831),
    [sym_concatenated_string] = STATE(3833),
    [sym_string_literal] = STATE(2490),
    [sym_null] = STATE(3860),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7980),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3860),
    [sym_raw_string_literal] = STATE(2516),
    [sym_co_await_expression] = STATE(3860),
    [sym_new_expression] = STATE(3860),
    [sym_delete_expression] = STATE(3860),
    [sym_requires_clause] = STATE(3860),
    [sym_requires_expression] = STATE(3860),
    [sym_lambda_expression] = STATE(3860),
    [sym_lambda_capture_specifier] = STATE(6189),
    [sym_fold_expression] = STATE(3860),
    [sym_parameter_pack_expansion] = STATE(3860),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3861),
    [sym_qualified_type_identifier] = STATE(7980),
    [sym_user_defined_literal] = STATE(3861),
    [sym_kernel_call_expression] = STATE(3851),
    [sym_identifier] = ACTIONS(3179),
    [anon_sym_LPAREN2] = ACTIONS(4541),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3185),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3189),
    [anon_sym_not] = ACTIONS(3181),
    [anon_sym_compl] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(4357),
    [anon_sym_PLUS_PLUS] = ACTIONS(4357),
    [anon_sym_sizeof] = ACTIONS(3191),
    [anon_sym___alignof__] = ACTIONS(3193),
    [anon_sym___alignof] = ACTIONS(3193),
    [anon_sym__alignof] = ACTIONS(3193),
    [anon_sym_alignof] = ACTIONS(3193),
    [anon_sym__Alignof] = ACTIONS(3193),
    [anon_sym_offsetof] = ACTIONS(3195),
    [anon_sym__Generic] = ACTIONS(3197),
    [anon_sym_asm] = ACTIONS(3199),
    [anon_sym___asm__] = ACTIONS(3199),
    [sym_number_literal] = ACTIONS(3201),
    [anon_sym_L_SQUOTE] = ACTIONS(3203),
    [anon_sym_u_SQUOTE] = ACTIONS(3203),
    [anon_sym_U_SQUOTE] = ACTIONS(3203),
    [anon_sym_u8_SQUOTE] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [anon_sym_L_DQUOTE] = ACTIONS(3205),
    [anon_sym_u_DQUOTE] = ACTIONS(3205),
    [anon_sym_U_DQUOTE] = ACTIONS(3205),
    [anon_sym_u8_DQUOTE] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [anon_sym_NULL] = ACTIONS(3209),
    [anon_sym_nullptr] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_R_DQUOTE] = ACTIONS(3213),
    [anon_sym_LR_DQUOTE] = ACTIONS(3213),
    [anon_sym_uR_DQUOTE] = ACTIONS(3213),
    [anon_sym_UR_DQUOTE] = ACTIONS(3213),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3213),
    [anon_sym_co_await] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_requires] = ACTIONS(3219),
    [sym_this] = ACTIONS(3207),
  },
  [1549] = {
    [sym_expression] = STATE(5142),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1550] = {
    [sym_expression] = STATE(5049),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1551] = {
    [sym_expression] = STATE(5046),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1552] = {
    [sym_expression] = STATE(4448),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3068),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3068),
    [sym_call_expression] = STATE(3068),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3068),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3068),
    [sym_char_literal] = STATE(4482),
    [sym_concatenated_string] = STATE(4479),
    [sym_string_literal] = STATE(3097),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3096),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3068),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3068),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(4415),
    [anon_sym_LPAREN2] = ACTIONS(4506),
    [anon_sym_BANG] = ACTIONS(3582),
    [anon_sym_TILDE] = ACTIONS(3582),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(3584),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3580),
    [anon_sym_compl] = ACTIONS(3580),
    [anon_sym_DASH_DASH] = ACTIONS(4417),
    [anon_sym_PLUS_PLUS] = ACTIONS(4417),
    [anon_sym_sizeof] = ACTIONS(3588),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(3590),
    [anon_sym_L_SQUOTE] = ACTIONS(3592),
    [anon_sym_u_SQUOTE] = ACTIONS(3592),
    [anon_sym_U_SQUOTE] = ACTIONS(3592),
    [anon_sym_u8_SQUOTE] = ACTIONS(3592),
    [anon_sym_SQUOTE] = ACTIONS(3592),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3596),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [anon_sym_co_await] = ACTIONS(3600),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_requires] = ACTIONS(3604),
    [sym_this] = ACTIONS(221),
  },
  [1553] = {
    [sym_expression] = STATE(4688),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1554] = {
    [sym_expression] = STATE(4948),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1555] = {
    [sym_expression] = STATE(4643),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1556] = {
    [sym_expression] = STATE(5005),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1557] = {
    [sym_expression] = STATE(3275),
    [sym__string] = STATE(3860),
    [sym_conditional_expression] = STATE(3860),
    [sym_assignment_expression] = STATE(3860),
    [sym_pointer_expression] = STATE(3861),
    [sym_unary_expression] = STATE(3860),
    [sym_binary_expression] = STATE(3860),
    [sym_update_expression] = STATE(3860),
    [sym_cast_expression] = STATE(3860),
    [sym_sizeof_expression] = STATE(3860),
    [sym_alignof_expression] = STATE(3860),
    [sym_offsetof_expression] = STATE(3860),
    [sym_generic_expression] = STATE(3860),
    [sym_subscript_expression] = STATE(3861),
    [sym_call_expression] = STATE(3861),
    [sym_gnu_asm_expression] = STATE(3860),
    [sym_field_expression] = STATE(3861),
    [sym_compound_literal_expression] = STATE(3860),
    [sym_parenthesized_expression] = STATE(3861),
    [sym_char_literal] = STATE(3831),
    [sym_concatenated_string] = STATE(3833),
    [sym_string_literal] = STATE(2490),
    [sym_null] = STATE(3860),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7980),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3860),
    [sym_raw_string_literal] = STATE(2516),
    [sym_co_await_expression] = STATE(3860),
    [sym_new_expression] = STATE(3860),
    [sym_delete_expression] = STATE(3860),
    [sym_requires_clause] = STATE(3860),
    [sym_requires_expression] = STATE(3860),
    [sym_lambda_expression] = STATE(3860),
    [sym_lambda_capture_specifier] = STATE(6189),
    [sym_fold_expression] = STATE(3860),
    [sym_parameter_pack_expansion] = STATE(3860),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3861),
    [sym_qualified_type_identifier] = STATE(7980),
    [sym_user_defined_literal] = STATE(3861),
    [sym_kernel_call_expression] = STATE(3851),
    [sym_identifier] = ACTIONS(3179),
    [anon_sym_LPAREN2] = ACTIONS(4541),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3185),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3189),
    [anon_sym_not] = ACTIONS(3181),
    [anon_sym_compl] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(4357),
    [anon_sym_PLUS_PLUS] = ACTIONS(4357),
    [anon_sym_sizeof] = ACTIONS(3191),
    [anon_sym___alignof__] = ACTIONS(3193),
    [anon_sym___alignof] = ACTIONS(3193),
    [anon_sym__alignof] = ACTIONS(3193),
    [anon_sym_alignof] = ACTIONS(3193),
    [anon_sym__Alignof] = ACTIONS(3193),
    [anon_sym_offsetof] = ACTIONS(3195),
    [anon_sym__Generic] = ACTIONS(3197),
    [anon_sym_asm] = ACTIONS(3199),
    [anon_sym___asm__] = ACTIONS(3199),
    [sym_number_literal] = ACTIONS(3201),
    [anon_sym_L_SQUOTE] = ACTIONS(3203),
    [anon_sym_u_SQUOTE] = ACTIONS(3203),
    [anon_sym_U_SQUOTE] = ACTIONS(3203),
    [anon_sym_u8_SQUOTE] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [anon_sym_L_DQUOTE] = ACTIONS(3205),
    [anon_sym_u_DQUOTE] = ACTIONS(3205),
    [anon_sym_U_DQUOTE] = ACTIONS(3205),
    [anon_sym_u8_DQUOTE] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [anon_sym_NULL] = ACTIONS(3209),
    [anon_sym_nullptr] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_R_DQUOTE] = ACTIONS(3213),
    [anon_sym_LR_DQUOTE] = ACTIONS(3213),
    [anon_sym_uR_DQUOTE] = ACTIONS(3213),
    [anon_sym_UR_DQUOTE] = ACTIONS(3213),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3213),
    [anon_sym_co_await] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_requires] = ACTIONS(3219),
    [sym_this] = ACTIONS(3207),
  },
  [1558] = {
    [sym_expression] = STATE(4669),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1559] = {
    [sym_expression] = STATE(4663),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1560] = {
    [sym_expression] = STATE(4666),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1561] = {
    [sym_expression] = STATE(3105),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1562] = {
    [sym_string_literal] = STATE(2291),
    [sym_template_argument_list] = STATE(1831),
    [sym_raw_string_literal] = STATE(2291),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2132),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_RPAREN] = ACTIONS(3760),
    [anon_sym_LPAREN2] = ACTIONS(3760),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3768),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3771),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(4807),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym___extension__] = ACTIONS(3764),
    [anon_sym___global__] = ACTIONS(3764),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4810),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_signed] = ACTIONS(4812),
    [anon_sym_unsigned] = ACTIONS(4812),
    [anon_sym_long] = ACTIONS(4812),
    [anon_sym_short] = ACTIONS(4812),
    [anon_sym_LBRACK] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(3766),
    [anon_sym_const] = ACTIONS(3756),
    [anon_sym_constexpr] = ACTIONS(3764),
    [anon_sym_volatile] = ACTIONS(3764),
    [anon_sym_restrict] = ACTIONS(3764),
    [anon_sym___restrict__] = ACTIONS(3764),
    [anon_sym__Atomic] = ACTIONS(3764),
    [anon_sym__Noreturn] = ACTIONS(3764),
    [anon_sym_noreturn] = ACTIONS(3764),
    [anon_sym_mutable] = ACTIONS(3764),
    [anon_sym_constinit] = ACTIONS(3764),
    [anon_sym_consteval] = ACTIONS(3764),
    [anon_sym___shared__] = ACTIONS(3764),
    [anon_sym___local__] = ACTIONS(3764),
    [anon_sym___constant__] = ACTIONS(3764),
    [anon_sym___managed__] = ACTIONS(3764),
    [anon_sym___grid_constant__] = ACTIONS(3764),
    [anon_sym_alignas] = ACTIONS(3764),
    [anon_sym__Alignas] = ACTIONS(3764),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3758),
    [anon_sym_SLASH_EQ] = ACTIONS(3758),
    [anon_sym_PERCENT_EQ] = ACTIONS(3758),
    [anon_sym_PLUS_EQ] = ACTIONS(3758),
    [anon_sym_DASH_EQ] = ACTIONS(3758),
    [anon_sym_LT_LT_EQ] = ACTIONS(3758),
    [anon_sym_GT_GT_EQ] = ACTIONS(3758),
    [anon_sym_AMP_EQ] = ACTIONS(3758),
    [anon_sym_CARET_EQ] = ACTIONS(3758),
    [anon_sym_PIPE_EQ] = ACTIONS(3758),
    [anon_sym_and_eq] = ACTIONS(3758),
    [anon_sym_or_eq] = ACTIONS(3758),
    [anon_sym_xor_eq] = ACTIONS(3758),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3766),
    [anon_sym_L_DQUOTE] = ACTIONS(4814),
    [anon_sym_u_DQUOTE] = ACTIONS(4814),
    [anon_sym_U_DQUOTE] = ACTIONS(4814),
    [anon_sym_u8_DQUOTE] = ACTIONS(4814),
    [anon_sym_DQUOTE] = ACTIONS(4814),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3764),
    [anon_sym_decltype] = ACTIONS(3764),
    [anon_sym_R_DQUOTE] = ACTIONS(4816),
    [anon_sym_LR_DQUOTE] = ACTIONS(4816),
    [anon_sym_uR_DQUOTE] = ACTIONS(4816),
    [anon_sym_UR_DQUOTE] = ACTIONS(4816),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4816),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3758),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [1563] = {
    [sym_expression] = STATE(3484),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4539),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(3331),
    [anon_sym_compl] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(4365),
    [anon_sym_PLUS_PLUS] = ACTIONS(4365),
    [anon_sym_sizeof] = ACTIONS(3337),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3339),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1564] = {
    [sym_expression] = STATE(4992),
    [sym__string] = STATE(5255),
    [sym_conditional_expression] = STATE(5255),
    [sym_assignment_expression] = STATE(5255),
    [sym_pointer_expression] = STATE(3988),
    [sym_unary_expression] = STATE(5255),
    [sym_binary_expression] = STATE(5255),
    [sym_update_expression] = STATE(5255),
    [sym_cast_expression] = STATE(5255),
    [sym_sizeof_expression] = STATE(5255),
    [sym_alignof_expression] = STATE(5255),
    [sym_offsetof_expression] = STATE(5255),
    [sym_generic_expression] = STATE(5255),
    [sym_subscript_expression] = STATE(3988),
    [sym_call_expression] = STATE(3988),
    [sym_gnu_asm_expression] = STATE(5255),
    [sym_field_expression] = STATE(3988),
    [sym_compound_literal_expression] = STATE(5255),
    [sym_parenthesized_expression] = STATE(3988),
    [sym_char_literal] = STATE(5164),
    [sym_concatenated_string] = STATE(5162),
    [sym_string_literal] = STATE(4081),
    [sym_null] = STATE(5255),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5255),
    [sym_raw_string_literal] = STATE(4060),
    [sym_co_await_expression] = STATE(5255),
    [sym_new_expression] = STATE(5255),
    [sym_delete_expression] = STATE(5255),
    [sym_requires_clause] = STATE(5255),
    [sym_requires_expression] = STATE(5255),
    [sym_lambda_expression] = STATE(5255),
    [sym_lambda_capture_specifier] = STATE(6164),
    [sym_fold_expression] = STATE(5255),
    [sym_parameter_pack_expansion] = STATE(5255),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3988),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3988),
    [sym_kernel_call_expression] = STATE(5260),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4486),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_LBRACK] = ACTIONS(4818),
    [sym_primitive_type] = ACTIONS(3718),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4452),
    [anon_sym_PLUS_PLUS] = ACTIONS(4452),
    [anon_sym_sizeof] = ACTIONS(3720),
    [anon_sym___alignof__] = ACTIONS(3722),
    [anon_sym___alignof] = ACTIONS(3722),
    [anon_sym__alignof] = ACTIONS(3722),
    [anon_sym_alignof] = ACTIONS(3722),
    [anon_sym__Alignof] = ACTIONS(3722),
    [anon_sym_offsetof] = ACTIONS(3724),
    [anon_sym__Generic] = ACTIONS(3726),
    [anon_sym_asm] = ACTIONS(3728),
    [anon_sym___asm__] = ACTIONS(3728),
    [sym_number_literal] = ACTIONS(3730),
    [anon_sym_L_SQUOTE] = ACTIONS(3732),
    [anon_sym_u_SQUOTE] = ACTIONS(3732),
    [anon_sym_U_SQUOTE] = ACTIONS(3732),
    [anon_sym_u8_SQUOTE] = ACTIONS(3732),
    [anon_sym_SQUOTE] = ACTIONS(3732),
    [anon_sym_L_DQUOTE] = ACTIONS(3734),
    [anon_sym_u_DQUOTE] = ACTIONS(3734),
    [anon_sym_U_DQUOTE] = ACTIONS(3734),
    [anon_sym_u8_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [sym_true] = ACTIONS(3736),
    [sym_false] = ACTIONS(3736),
    [anon_sym_NULL] = ACTIONS(3738),
    [anon_sym_nullptr] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3740),
    [anon_sym_R_DQUOTE] = ACTIONS(3742),
    [anon_sym_LR_DQUOTE] = ACTIONS(3742),
    [anon_sym_uR_DQUOTE] = ACTIONS(3742),
    [anon_sym_UR_DQUOTE] = ACTIONS(3742),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3742),
    [anon_sym_co_await] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3748),
    [sym_this] = ACTIONS(3736),
  },
  [1565] = {
    [sym_expression] = STATE(4877),
    [sym__string] = STATE(5255),
    [sym_conditional_expression] = STATE(5255),
    [sym_assignment_expression] = STATE(5255),
    [sym_pointer_expression] = STATE(3988),
    [sym_unary_expression] = STATE(5255),
    [sym_binary_expression] = STATE(5255),
    [sym_update_expression] = STATE(5255),
    [sym_cast_expression] = STATE(5255),
    [sym_sizeof_expression] = STATE(5255),
    [sym_alignof_expression] = STATE(5255),
    [sym_offsetof_expression] = STATE(5255),
    [sym_generic_expression] = STATE(5255),
    [sym_subscript_expression] = STATE(3988),
    [sym_call_expression] = STATE(3988),
    [sym_gnu_asm_expression] = STATE(5255),
    [sym_field_expression] = STATE(3988),
    [sym_compound_literal_expression] = STATE(5255),
    [sym_parenthesized_expression] = STATE(3988),
    [sym_char_literal] = STATE(5164),
    [sym_concatenated_string] = STATE(5162),
    [sym_string_literal] = STATE(4081),
    [sym_null] = STATE(5255),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5255),
    [sym_raw_string_literal] = STATE(4060),
    [sym_co_await_expression] = STATE(5255),
    [sym_new_expression] = STATE(5255),
    [sym_delete_expression] = STATE(5255),
    [sym_requires_clause] = STATE(5255),
    [sym_requires_expression] = STATE(5255),
    [sym_lambda_expression] = STATE(5255),
    [sym_lambda_capture_specifier] = STATE(6164),
    [sym_fold_expression] = STATE(5255),
    [sym_parameter_pack_expansion] = STATE(5255),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3988),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3988),
    [sym_kernel_call_expression] = STATE(5260),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4486),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3718),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4452),
    [anon_sym_PLUS_PLUS] = ACTIONS(4452),
    [anon_sym_sizeof] = ACTIONS(3720),
    [anon_sym___alignof__] = ACTIONS(3722),
    [anon_sym___alignof] = ACTIONS(3722),
    [anon_sym__alignof] = ACTIONS(3722),
    [anon_sym_alignof] = ACTIONS(3722),
    [anon_sym__Alignof] = ACTIONS(3722),
    [anon_sym_offsetof] = ACTIONS(3724),
    [anon_sym__Generic] = ACTIONS(3726),
    [anon_sym_asm] = ACTIONS(3728),
    [anon_sym___asm__] = ACTIONS(3728),
    [sym_number_literal] = ACTIONS(3730),
    [anon_sym_L_SQUOTE] = ACTIONS(3732),
    [anon_sym_u_SQUOTE] = ACTIONS(3732),
    [anon_sym_U_SQUOTE] = ACTIONS(3732),
    [anon_sym_u8_SQUOTE] = ACTIONS(3732),
    [anon_sym_SQUOTE] = ACTIONS(3732),
    [anon_sym_L_DQUOTE] = ACTIONS(3734),
    [anon_sym_u_DQUOTE] = ACTIONS(3734),
    [anon_sym_U_DQUOTE] = ACTIONS(3734),
    [anon_sym_u8_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [sym_true] = ACTIONS(3736),
    [sym_false] = ACTIONS(3736),
    [anon_sym_NULL] = ACTIONS(3738),
    [anon_sym_nullptr] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3740),
    [anon_sym_R_DQUOTE] = ACTIONS(3742),
    [anon_sym_LR_DQUOTE] = ACTIONS(3742),
    [anon_sym_uR_DQUOTE] = ACTIONS(3742),
    [anon_sym_UR_DQUOTE] = ACTIONS(3742),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3742),
    [anon_sym_co_await] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3748),
    [sym_this] = ACTIONS(3736),
  },
  [1566] = {
    [sym_expression] = STATE(4834),
    [sym__string] = STATE(5255),
    [sym_conditional_expression] = STATE(5255),
    [sym_assignment_expression] = STATE(5255),
    [sym_pointer_expression] = STATE(3988),
    [sym_unary_expression] = STATE(5255),
    [sym_binary_expression] = STATE(5255),
    [sym_update_expression] = STATE(5255),
    [sym_cast_expression] = STATE(5255),
    [sym_sizeof_expression] = STATE(5255),
    [sym_alignof_expression] = STATE(5255),
    [sym_offsetof_expression] = STATE(5255),
    [sym_generic_expression] = STATE(5255),
    [sym_subscript_expression] = STATE(3988),
    [sym_call_expression] = STATE(3988),
    [sym_gnu_asm_expression] = STATE(5255),
    [sym_field_expression] = STATE(3988),
    [sym_compound_literal_expression] = STATE(5255),
    [sym_parenthesized_expression] = STATE(3988),
    [sym_char_literal] = STATE(5164),
    [sym_concatenated_string] = STATE(5162),
    [sym_string_literal] = STATE(4081),
    [sym_null] = STATE(5255),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5255),
    [sym_raw_string_literal] = STATE(4060),
    [sym_co_await_expression] = STATE(5255),
    [sym_new_expression] = STATE(5255),
    [sym_delete_expression] = STATE(5255),
    [sym_requires_clause] = STATE(5255),
    [sym_requires_expression] = STATE(5255),
    [sym_lambda_expression] = STATE(5255),
    [sym_lambda_capture_specifier] = STATE(6164),
    [sym_fold_expression] = STATE(5255),
    [sym_parameter_pack_expansion] = STATE(5255),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3988),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3988),
    [sym_kernel_call_expression] = STATE(5260),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4486),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_LBRACK] = ACTIONS(4820),
    [sym_primitive_type] = ACTIONS(3718),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4452),
    [anon_sym_PLUS_PLUS] = ACTIONS(4452),
    [anon_sym_sizeof] = ACTIONS(3720),
    [anon_sym___alignof__] = ACTIONS(3722),
    [anon_sym___alignof] = ACTIONS(3722),
    [anon_sym__alignof] = ACTIONS(3722),
    [anon_sym_alignof] = ACTIONS(3722),
    [anon_sym__Alignof] = ACTIONS(3722),
    [anon_sym_offsetof] = ACTIONS(3724),
    [anon_sym__Generic] = ACTIONS(3726),
    [anon_sym_asm] = ACTIONS(3728),
    [anon_sym___asm__] = ACTIONS(3728),
    [sym_number_literal] = ACTIONS(3730),
    [anon_sym_L_SQUOTE] = ACTIONS(3732),
    [anon_sym_u_SQUOTE] = ACTIONS(3732),
    [anon_sym_U_SQUOTE] = ACTIONS(3732),
    [anon_sym_u8_SQUOTE] = ACTIONS(3732),
    [anon_sym_SQUOTE] = ACTIONS(3732),
    [anon_sym_L_DQUOTE] = ACTIONS(3734),
    [anon_sym_u_DQUOTE] = ACTIONS(3734),
    [anon_sym_U_DQUOTE] = ACTIONS(3734),
    [anon_sym_u8_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [sym_true] = ACTIONS(3736),
    [sym_false] = ACTIONS(3736),
    [anon_sym_NULL] = ACTIONS(3738),
    [anon_sym_nullptr] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3740),
    [anon_sym_R_DQUOTE] = ACTIONS(3742),
    [anon_sym_LR_DQUOTE] = ACTIONS(3742),
    [anon_sym_uR_DQUOTE] = ACTIONS(3742),
    [anon_sym_UR_DQUOTE] = ACTIONS(3742),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3742),
    [anon_sym_co_await] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3748),
    [sym_this] = ACTIONS(3736),
  },
  [1567] = {
    [sym_expression] = STATE(4771),
    [sym__string] = STATE(5255),
    [sym_conditional_expression] = STATE(5255),
    [sym_assignment_expression] = STATE(5255),
    [sym_pointer_expression] = STATE(3988),
    [sym_unary_expression] = STATE(5255),
    [sym_binary_expression] = STATE(5255),
    [sym_update_expression] = STATE(5255),
    [sym_cast_expression] = STATE(5255),
    [sym_sizeof_expression] = STATE(5255),
    [sym_alignof_expression] = STATE(5255),
    [sym_offsetof_expression] = STATE(5255),
    [sym_generic_expression] = STATE(5255),
    [sym_subscript_expression] = STATE(3988),
    [sym_call_expression] = STATE(3988),
    [sym_gnu_asm_expression] = STATE(5255),
    [sym_field_expression] = STATE(3988),
    [sym_compound_literal_expression] = STATE(5255),
    [sym_parenthesized_expression] = STATE(3988),
    [sym_char_literal] = STATE(5164),
    [sym_concatenated_string] = STATE(5162),
    [sym_string_literal] = STATE(4081),
    [sym_null] = STATE(5255),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5255),
    [sym_raw_string_literal] = STATE(4060),
    [sym_co_await_expression] = STATE(5255),
    [sym_new_expression] = STATE(5255),
    [sym_delete_expression] = STATE(5255),
    [sym_requires_clause] = STATE(5255),
    [sym_requires_expression] = STATE(5255),
    [sym_lambda_expression] = STATE(5255),
    [sym_lambda_capture_specifier] = STATE(6164),
    [sym_fold_expression] = STATE(5255),
    [sym_parameter_pack_expansion] = STATE(5255),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3988),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3988),
    [sym_kernel_call_expression] = STATE(5260),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4486),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3718),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4452),
    [anon_sym_PLUS_PLUS] = ACTIONS(4452),
    [anon_sym_sizeof] = ACTIONS(3720),
    [anon_sym___alignof__] = ACTIONS(3722),
    [anon_sym___alignof] = ACTIONS(3722),
    [anon_sym__alignof] = ACTIONS(3722),
    [anon_sym_alignof] = ACTIONS(3722),
    [anon_sym__Alignof] = ACTIONS(3722),
    [anon_sym_offsetof] = ACTIONS(3724),
    [anon_sym__Generic] = ACTIONS(3726),
    [anon_sym_asm] = ACTIONS(3728),
    [anon_sym___asm__] = ACTIONS(3728),
    [sym_number_literal] = ACTIONS(3730),
    [anon_sym_L_SQUOTE] = ACTIONS(3732),
    [anon_sym_u_SQUOTE] = ACTIONS(3732),
    [anon_sym_U_SQUOTE] = ACTIONS(3732),
    [anon_sym_u8_SQUOTE] = ACTIONS(3732),
    [anon_sym_SQUOTE] = ACTIONS(3732),
    [anon_sym_L_DQUOTE] = ACTIONS(3734),
    [anon_sym_u_DQUOTE] = ACTIONS(3734),
    [anon_sym_U_DQUOTE] = ACTIONS(3734),
    [anon_sym_u8_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [sym_true] = ACTIONS(3736),
    [sym_false] = ACTIONS(3736),
    [anon_sym_NULL] = ACTIONS(3738),
    [anon_sym_nullptr] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3740),
    [anon_sym_R_DQUOTE] = ACTIONS(3742),
    [anon_sym_LR_DQUOTE] = ACTIONS(3742),
    [anon_sym_uR_DQUOTE] = ACTIONS(3742),
    [anon_sym_UR_DQUOTE] = ACTIONS(3742),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3742),
    [anon_sym_co_await] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3748),
    [sym_this] = ACTIONS(3736),
  },
  [1568] = {
    [sym_expression] = STATE(4328),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1569] = {
    [sym_expression] = STATE(4320),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1570] = {
    [sym_expression] = STATE(3274),
    [sym__string] = STATE(3860),
    [sym_conditional_expression] = STATE(3860),
    [sym_assignment_expression] = STATE(3860),
    [sym_pointer_expression] = STATE(3861),
    [sym_unary_expression] = STATE(3860),
    [sym_binary_expression] = STATE(3860),
    [sym_update_expression] = STATE(3860),
    [sym_cast_expression] = STATE(3860),
    [sym_sizeof_expression] = STATE(3860),
    [sym_alignof_expression] = STATE(3860),
    [sym_offsetof_expression] = STATE(3860),
    [sym_generic_expression] = STATE(3860),
    [sym_subscript_expression] = STATE(3861),
    [sym_call_expression] = STATE(3861),
    [sym_gnu_asm_expression] = STATE(3860),
    [sym_field_expression] = STATE(3861),
    [sym_compound_literal_expression] = STATE(3860),
    [sym_parenthesized_expression] = STATE(3861),
    [sym_char_literal] = STATE(3831),
    [sym_concatenated_string] = STATE(3833),
    [sym_string_literal] = STATE(2490),
    [sym_null] = STATE(3860),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7980),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3860),
    [sym_raw_string_literal] = STATE(2516),
    [sym_co_await_expression] = STATE(3860),
    [sym_new_expression] = STATE(3860),
    [sym_delete_expression] = STATE(3860),
    [sym_requires_clause] = STATE(3860),
    [sym_requires_expression] = STATE(3860),
    [sym_lambda_expression] = STATE(3860),
    [sym_lambda_capture_specifier] = STATE(6189),
    [sym_fold_expression] = STATE(3860),
    [sym_parameter_pack_expansion] = STATE(3860),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3861),
    [sym_qualified_type_identifier] = STATE(7980),
    [sym_user_defined_literal] = STATE(3861),
    [sym_kernel_call_expression] = STATE(3851),
    [sym_identifier] = ACTIONS(3179),
    [anon_sym_LPAREN2] = ACTIONS(4541),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3185),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3189),
    [anon_sym_not] = ACTIONS(3181),
    [anon_sym_compl] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(4357),
    [anon_sym_PLUS_PLUS] = ACTIONS(4357),
    [anon_sym_sizeof] = ACTIONS(3191),
    [anon_sym___alignof__] = ACTIONS(3193),
    [anon_sym___alignof] = ACTIONS(3193),
    [anon_sym__alignof] = ACTIONS(3193),
    [anon_sym_alignof] = ACTIONS(3193),
    [anon_sym__Alignof] = ACTIONS(3193),
    [anon_sym_offsetof] = ACTIONS(3195),
    [anon_sym__Generic] = ACTIONS(3197),
    [anon_sym_asm] = ACTIONS(3199),
    [anon_sym___asm__] = ACTIONS(3199),
    [sym_number_literal] = ACTIONS(3201),
    [anon_sym_L_SQUOTE] = ACTIONS(3203),
    [anon_sym_u_SQUOTE] = ACTIONS(3203),
    [anon_sym_U_SQUOTE] = ACTIONS(3203),
    [anon_sym_u8_SQUOTE] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [anon_sym_L_DQUOTE] = ACTIONS(3205),
    [anon_sym_u_DQUOTE] = ACTIONS(3205),
    [anon_sym_U_DQUOTE] = ACTIONS(3205),
    [anon_sym_u8_DQUOTE] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [anon_sym_NULL] = ACTIONS(3209),
    [anon_sym_nullptr] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_R_DQUOTE] = ACTIONS(3213),
    [anon_sym_LR_DQUOTE] = ACTIONS(3213),
    [anon_sym_uR_DQUOTE] = ACTIONS(3213),
    [anon_sym_UR_DQUOTE] = ACTIONS(3213),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3213),
    [anon_sym_co_await] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_requires] = ACTIONS(3219),
    [sym_this] = ACTIONS(3207),
  },
  [1571] = {
    [sym_expression] = STATE(4827),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(4822),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1572] = {
    [sym_expression] = STATE(4340),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3857),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3857),
    [sym_call_expression] = STATE(3857),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3857),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3857),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3857),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3857),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3678),
    [anon_sym_LPAREN2] = ACTIONS(3798),
    [anon_sym_BANG] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3682),
    [anon_sym_DASH] = ACTIONS(3680),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(3684),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3680),
    [anon_sym_compl] = ACTIONS(3680),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3686),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3688),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3690),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1573] = {
    [sym_expression] = STATE(3324),
    [sym__string] = STATE(3926),
    [sym_conditional_expression] = STATE(3926),
    [sym_assignment_expression] = STATE(3926),
    [sym_pointer_expression] = STATE(3934),
    [sym_unary_expression] = STATE(3926),
    [sym_binary_expression] = STATE(3926),
    [sym_update_expression] = STATE(3926),
    [sym_cast_expression] = STATE(3926),
    [sym_sizeof_expression] = STATE(3926),
    [sym_alignof_expression] = STATE(3926),
    [sym_offsetof_expression] = STATE(3926),
    [sym_generic_expression] = STATE(3926),
    [sym_subscript_expression] = STATE(3934),
    [sym_call_expression] = STATE(3934),
    [sym_gnu_asm_expression] = STATE(3926),
    [sym_field_expression] = STATE(3934),
    [sym_compound_literal_expression] = STATE(3926),
    [sym_parenthesized_expression] = STATE(3934),
    [sym_char_literal] = STATE(3755),
    [sym_concatenated_string] = STATE(3759),
    [sym_string_literal] = STATE(2463),
    [sym_null] = STATE(3926),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7876),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3926),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3926),
    [sym_new_expression] = STATE(3926),
    [sym_delete_expression] = STATE(3926),
    [sym_requires_clause] = STATE(3926),
    [sym_requires_expression] = STATE(3926),
    [sym_lambda_expression] = STATE(3926),
    [sym_lambda_capture_specifier] = STATE(6169),
    [sym_fold_expression] = STATE(3926),
    [sym_parameter_pack_expansion] = STATE(3926),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3934),
    [sym_qualified_type_identifier] = STATE(7876),
    [sym_user_defined_literal] = STATE(3934),
    [sym_kernel_call_expression] = STATE(3930),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(4518),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3291),
    [anon_sym_not] = ACTIONS(3283),
    [anon_sym_compl] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(4351),
    [anon_sym_PLUS_PLUS] = ACTIONS(4351),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3295),
    [anon_sym___alignof] = ACTIONS(3295),
    [anon_sym__alignof] = ACTIONS(3295),
    [anon_sym_alignof] = ACTIONS(3295),
    [anon_sym__Alignof] = ACTIONS(3295),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3299),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [sym_number_literal] = ACTIONS(3303),
    [anon_sym_L_SQUOTE] = ACTIONS(3305),
    [anon_sym_u_SQUOTE] = ACTIONS(3305),
    [anon_sym_U_SQUOTE] = ACTIONS(3305),
    [anon_sym_u8_SQUOTE] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_L_DQUOTE] = ACTIONS(3307),
    [anon_sym_u_DQUOTE] = ACTIONS(3307),
    [anon_sym_U_DQUOTE] = ACTIONS(3307),
    [anon_sym_u8_DQUOTE] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [anon_sym_NULL] = ACTIONS(3311),
    [anon_sym_nullptr] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_R_DQUOTE] = ACTIONS(3315),
    [anon_sym_LR_DQUOTE] = ACTIONS(3315),
    [anon_sym_uR_DQUOTE] = ACTIONS(3315),
    [anon_sym_UR_DQUOTE] = ACTIONS(3315),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3315),
    [anon_sym_co_await] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_requires] = ACTIONS(3321),
    [sym_this] = ACTIONS(3309),
  },
  [1574] = {
    [sym_expression] = STATE(3273),
    [sym__string] = STATE(3860),
    [sym_conditional_expression] = STATE(3860),
    [sym_assignment_expression] = STATE(3860),
    [sym_pointer_expression] = STATE(3861),
    [sym_unary_expression] = STATE(3860),
    [sym_binary_expression] = STATE(3860),
    [sym_update_expression] = STATE(3860),
    [sym_cast_expression] = STATE(3860),
    [sym_sizeof_expression] = STATE(3860),
    [sym_alignof_expression] = STATE(3860),
    [sym_offsetof_expression] = STATE(3860),
    [sym_generic_expression] = STATE(3860),
    [sym_subscript_expression] = STATE(3861),
    [sym_call_expression] = STATE(3861),
    [sym_gnu_asm_expression] = STATE(3860),
    [sym_field_expression] = STATE(3861),
    [sym_compound_literal_expression] = STATE(3860),
    [sym_parenthesized_expression] = STATE(3861),
    [sym_char_literal] = STATE(3831),
    [sym_concatenated_string] = STATE(3833),
    [sym_string_literal] = STATE(2490),
    [sym_null] = STATE(3860),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7980),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3860),
    [sym_raw_string_literal] = STATE(2516),
    [sym_co_await_expression] = STATE(3860),
    [sym_new_expression] = STATE(3860),
    [sym_delete_expression] = STATE(3860),
    [sym_requires_clause] = STATE(3860),
    [sym_requires_expression] = STATE(3860),
    [sym_lambda_expression] = STATE(3860),
    [sym_lambda_capture_specifier] = STATE(6189),
    [sym_fold_expression] = STATE(3860),
    [sym_parameter_pack_expansion] = STATE(3860),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3861),
    [sym_qualified_type_identifier] = STATE(7980),
    [sym_user_defined_literal] = STATE(3861),
    [sym_kernel_call_expression] = STATE(3851),
    [sym_identifier] = ACTIONS(3179),
    [anon_sym_LPAREN2] = ACTIONS(4541),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3185),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3189),
    [anon_sym_not] = ACTIONS(3181),
    [anon_sym_compl] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(4357),
    [anon_sym_PLUS_PLUS] = ACTIONS(4357),
    [anon_sym_sizeof] = ACTIONS(3191),
    [anon_sym___alignof__] = ACTIONS(3193),
    [anon_sym___alignof] = ACTIONS(3193),
    [anon_sym__alignof] = ACTIONS(3193),
    [anon_sym_alignof] = ACTIONS(3193),
    [anon_sym__Alignof] = ACTIONS(3193),
    [anon_sym_offsetof] = ACTIONS(3195),
    [anon_sym__Generic] = ACTIONS(3197),
    [anon_sym_asm] = ACTIONS(3199),
    [anon_sym___asm__] = ACTIONS(3199),
    [sym_number_literal] = ACTIONS(3201),
    [anon_sym_L_SQUOTE] = ACTIONS(3203),
    [anon_sym_u_SQUOTE] = ACTIONS(3203),
    [anon_sym_U_SQUOTE] = ACTIONS(3203),
    [anon_sym_u8_SQUOTE] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [anon_sym_L_DQUOTE] = ACTIONS(3205),
    [anon_sym_u_DQUOTE] = ACTIONS(3205),
    [anon_sym_U_DQUOTE] = ACTIONS(3205),
    [anon_sym_u8_DQUOTE] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [anon_sym_NULL] = ACTIONS(3209),
    [anon_sym_nullptr] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_R_DQUOTE] = ACTIONS(3213),
    [anon_sym_LR_DQUOTE] = ACTIONS(3213),
    [anon_sym_uR_DQUOTE] = ACTIONS(3213),
    [anon_sym_UR_DQUOTE] = ACTIONS(3213),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3213),
    [anon_sym_co_await] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_requires] = ACTIONS(3219),
    [sym_this] = ACTIONS(3207),
  },
  [1575] = {
    [sym_expression] = STATE(4754),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1576] = {
    [sym_expression] = STATE(3272),
    [sym__string] = STATE(3860),
    [sym_conditional_expression] = STATE(3860),
    [sym_assignment_expression] = STATE(3860),
    [sym_pointer_expression] = STATE(3861),
    [sym_unary_expression] = STATE(3860),
    [sym_binary_expression] = STATE(3860),
    [sym_update_expression] = STATE(3860),
    [sym_cast_expression] = STATE(3860),
    [sym_sizeof_expression] = STATE(3860),
    [sym_alignof_expression] = STATE(3860),
    [sym_offsetof_expression] = STATE(3860),
    [sym_generic_expression] = STATE(3860),
    [sym_subscript_expression] = STATE(3861),
    [sym_call_expression] = STATE(3861),
    [sym_gnu_asm_expression] = STATE(3860),
    [sym_field_expression] = STATE(3861),
    [sym_compound_literal_expression] = STATE(3860),
    [sym_parenthesized_expression] = STATE(3861),
    [sym_char_literal] = STATE(3831),
    [sym_concatenated_string] = STATE(3833),
    [sym_string_literal] = STATE(2490),
    [sym_null] = STATE(3860),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7980),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3860),
    [sym_raw_string_literal] = STATE(2516),
    [sym_co_await_expression] = STATE(3860),
    [sym_new_expression] = STATE(3860),
    [sym_delete_expression] = STATE(3860),
    [sym_requires_clause] = STATE(3860),
    [sym_requires_expression] = STATE(3860),
    [sym_lambda_expression] = STATE(3860),
    [sym_lambda_capture_specifier] = STATE(6189),
    [sym_fold_expression] = STATE(3860),
    [sym_parameter_pack_expansion] = STATE(3860),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3861),
    [sym_qualified_type_identifier] = STATE(7980),
    [sym_user_defined_literal] = STATE(3861),
    [sym_kernel_call_expression] = STATE(3851),
    [sym_identifier] = ACTIONS(3179),
    [anon_sym_LPAREN2] = ACTIONS(4541),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3185),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3189),
    [anon_sym_not] = ACTIONS(3181),
    [anon_sym_compl] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(4357),
    [anon_sym_PLUS_PLUS] = ACTIONS(4357),
    [anon_sym_sizeof] = ACTIONS(3191),
    [anon_sym___alignof__] = ACTIONS(3193),
    [anon_sym___alignof] = ACTIONS(3193),
    [anon_sym__alignof] = ACTIONS(3193),
    [anon_sym_alignof] = ACTIONS(3193),
    [anon_sym__Alignof] = ACTIONS(3193),
    [anon_sym_offsetof] = ACTIONS(3195),
    [anon_sym__Generic] = ACTIONS(3197),
    [anon_sym_asm] = ACTIONS(3199),
    [anon_sym___asm__] = ACTIONS(3199),
    [sym_number_literal] = ACTIONS(3201),
    [anon_sym_L_SQUOTE] = ACTIONS(3203),
    [anon_sym_u_SQUOTE] = ACTIONS(3203),
    [anon_sym_U_SQUOTE] = ACTIONS(3203),
    [anon_sym_u8_SQUOTE] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [anon_sym_L_DQUOTE] = ACTIONS(3205),
    [anon_sym_u_DQUOTE] = ACTIONS(3205),
    [anon_sym_U_DQUOTE] = ACTIONS(3205),
    [anon_sym_u8_DQUOTE] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [anon_sym_NULL] = ACTIONS(3209),
    [anon_sym_nullptr] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_R_DQUOTE] = ACTIONS(3213),
    [anon_sym_LR_DQUOTE] = ACTIONS(3213),
    [anon_sym_uR_DQUOTE] = ACTIONS(3213),
    [anon_sym_UR_DQUOTE] = ACTIONS(3213),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3213),
    [anon_sym_co_await] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_requires] = ACTIONS(3219),
    [sym_this] = ACTIONS(3207),
  },
  [1577] = {
    [sym_expression] = STATE(3271),
    [sym__string] = STATE(3860),
    [sym_conditional_expression] = STATE(3860),
    [sym_assignment_expression] = STATE(3860),
    [sym_pointer_expression] = STATE(3861),
    [sym_unary_expression] = STATE(3860),
    [sym_binary_expression] = STATE(3860),
    [sym_update_expression] = STATE(3860),
    [sym_cast_expression] = STATE(3860),
    [sym_sizeof_expression] = STATE(3860),
    [sym_alignof_expression] = STATE(3860),
    [sym_offsetof_expression] = STATE(3860),
    [sym_generic_expression] = STATE(3860),
    [sym_subscript_expression] = STATE(3861),
    [sym_call_expression] = STATE(3861),
    [sym_gnu_asm_expression] = STATE(3860),
    [sym_field_expression] = STATE(3861),
    [sym_compound_literal_expression] = STATE(3860),
    [sym_parenthesized_expression] = STATE(3861),
    [sym_char_literal] = STATE(3831),
    [sym_concatenated_string] = STATE(3833),
    [sym_string_literal] = STATE(2490),
    [sym_null] = STATE(3860),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7980),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3860),
    [sym_raw_string_literal] = STATE(2516),
    [sym_co_await_expression] = STATE(3860),
    [sym_new_expression] = STATE(3860),
    [sym_delete_expression] = STATE(3860),
    [sym_requires_clause] = STATE(3860),
    [sym_requires_expression] = STATE(3860),
    [sym_lambda_expression] = STATE(3860),
    [sym_lambda_capture_specifier] = STATE(6189),
    [sym_fold_expression] = STATE(3860),
    [sym_parameter_pack_expansion] = STATE(3860),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3861),
    [sym_qualified_type_identifier] = STATE(7980),
    [sym_user_defined_literal] = STATE(3861),
    [sym_kernel_call_expression] = STATE(3851),
    [sym_identifier] = ACTIONS(3179),
    [anon_sym_LPAREN2] = ACTIONS(4541),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3185),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3189),
    [anon_sym_not] = ACTIONS(3181),
    [anon_sym_compl] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(4357),
    [anon_sym_PLUS_PLUS] = ACTIONS(4357),
    [anon_sym_sizeof] = ACTIONS(3191),
    [anon_sym___alignof__] = ACTIONS(3193),
    [anon_sym___alignof] = ACTIONS(3193),
    [anon_sym__alignof] = ACTIONS(3193),
    [anon_sym_alignof] = ACTIONS(3193),
    [anon_sym__Alignof] = ACTIONS(3193),
    [anon_sym_offsetof] = ACTIONS(3195),
    [anon_sym__Generic] = ACTIONS(3197),
    [anon_sym_asm] = ACTIONS(3199),
    [anon_sym___asm__] = ACTIONS(3199),
    [sym_number_literal] = ACTIONS(3201),
    [anon_sym_L_SQUOTE] = ACTIONS(3203),
    [anon_sym_u_SQUOTE] = ACTIONS(3203),
    [anon_sym_U_SQUOTE] = ACTIONS(3203),
    [anon_sym_u8_SQUOTE] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [anon_sym_L_DQUOTE] = ACTIONS(3205),
    [anon_sym_u_DQUOTE] = ACTIONS(3205),
    [anon_sym_U_DQUOTE] = ACTIONS(3205),
    [anon_sym_u8_DQUOTE] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [anon_sym_NULL] = ACTIONS(3209),
    [anon_sym_nullptr] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_R_DQUOTE] = ACTIONS(3213),
    [anon_sym_LR_DQUOTE] = ACTIONS(3213),
    [anon_sym_uR_DQUOTE] = ACTIONS(3213),
    [anon_sym_UR_DQUOTE] = ACTIONS(3213),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3213),
    [anon_sym_co_await] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_requires] = ACTIONS(3219),
    [sym_this] = ACTIONS(3207),
  },
  [1578] = {
    [sym_expression] = STATE(4749),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1579] = {
    [sym_expression] = STATE(4791),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8015),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(8015),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3754),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [1580] = {
    [sym_expression] = STATE(4991),
    [sym__string] = STATE(5255),
    [sym_conditional_expression] = STATE(5255),
    [sym_assignment_expression] = STATE(5255),
    [sym_pointer_expression] = STATE(3988),
    [sym_unary_expression] = STATE(5255),
    [sym_binary_expression] = STATE(5255),
    [sym_update_expression] = STATE(5255),
    [sym_cast_expression] = STATE(5255),
    [sym_sizeof_expression] = STATE(5255),
    [sym_alignof_expression] = STATE(5255),
    [sym_offsetof_expression] = STATE(5255),
    [sym_generic_expression] = STATE(5255),
    [sym_subscript_expression] = STATE(3988),
    [sym_call_expression] = STATE(3988),
    [sym_gnu_asm_expression] = STATE(5255),
    [sym_field_expression] = STATE(3988),
    [sym_compound_literal_expression] = STATE(5255),
    [sym_parenthesized_expression] = STATE(3988),
    [sym_char_literal] = STATE(5164),
    [sym_concatenated_string] = STATE(5162),
    [sym_string_literal] = STATE(4081),
    [sym_null] = STATE(5255),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5255),
    [sym_raw_string_literal] = STATE(4060),
    [sym_co_await_expression] = STATE(5255),
    [sym_new_expression] = STATE(5255),
    [sym_delete_expression] = STATE(5255),
    [sym_requires_clause] = STATE(5255),
    [sym_requires_expression] = STATE(5255),
    [sym_lambda_expression] = STATE(5255),
    [sym_lambda_capture_specifier] = STATE(6164),
    [sym_fold_expression] = STATE(5255),
    [sym_parameter_pack_expansion] = STATE(5255),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3988),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3988),
    [sym_kernel_call_expression] = STATE(5260),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4486),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3718),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4452),
    [anon_sym_PLUS_PLUS] = ACTIONS(4452),
    [anon_sym_sizeof] = ACTIONS(3720),
    [anon_sym___alignof__] = ACTIONS(3722),
    [anon_sym___alignof] = ACTIONS(3722),
    [anon_sym__alignof] = ACTIONS(3722),
    [anon_sym_alignof] = ACTIONS(3722),
    [anon_sym__Alignof] = ACTIONS(3722),
    [anon_sym_offsetof] = ACTIONS(3724),
    [anon_sym__Generic] = ACTIONS(3726),
    [anon_sym_asm] = ACTIONS(3728),
    [anon_sym___asm__] = ACTIONS(3728),
    [sym_number_literal] = ACTIONS(3730),
    [anon_sym_L_SQUOTE] = ACTIONS(3732),
    [anon_sym_u_SQUOTE] = ACTIONS(3732),
    [anon_sym_U_SQUOTE] = ACTIONS(3732),
    [anon_sym_u8_SQUOTE] = ACTIONS(3732),
    [anon_sym_SQUOTE] = ACTIONS(3732),
    [anon_sym_L_DQUOTE] = ACTIONS(3734),
    [anon_sym_u_DQUOTE] = ACTIONS(3734),
    [anon_sym_U_DQUOTE] = ACTIONS(3734),
    [anon_sym_u8_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [sym_true] = ACTIONS(3736),
    [sym_false] = ACTIONS(3736),
    [anon_sym_NULL] = ACTIONS(3738),
    [anon_sym_nullptr] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3740),
    [anon_sym_R_DQUOTE] = ACTIONS(3742),
    [anon_sym_LR_DQUOTE] = ACTIONS(3742),
    [anon_sym_uR_DQUOTE] = ACTIONS(3742),
    [anon_sym_UR_DQUOTE] = ACTIONS(3742),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3742),
    [anon_sym_co_await] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3748),
    [sym_this] = ACTIONS(3736),
  },
  [1581] = {
    [sym_expression] = STATE(3341),
    [sym__string] = STATE(3926),
    [sym_conditional_expression] = STATE(3926),
    [sym_assignment_expression] = STATE(3926),
    [sym_pointer_expression] = STATE(3934),
    [sym_unary_expression] = STATE(3926),
    [sym_binary_expression] = STATE(3926),
    [sym_update_expression] = STATE(3926),
    [sym_cast_expression] = STATE(3926),
    [sym_sizeof_expression] = STATE(3926),
    [sym_alignof_expression] = STATE(3926),
    [sym_offsetof_expression] = STATE(3926),
    [sym_generic_expression] = STATE(3926),
    [sym_subscript_expression] = STATE(3934),
    [sym_call_expression] = STATE(3934),
    [sym_gnu_asm_expression] = STATE(3926),
    [sym_field_expression] = STATE(3934),
    [sym_compound_literal_expression] = STATE(3926),
    [sym_parenthesized_expression] = STATE(3934),
    [sym_char_literal] = STATE(3755),
    [sym_concatenated_string] = STATE(3759),
    [sym_string_literal] = STATE(2463),
    [sym_null] = STATE(3926),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7876),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3926),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3926),
    [sym_new_expression] = STATE(3926),
    [sym_delete_expression] = STATE(3926),
    [sym_requires_clause] = STATE(3926),
    [sym_requires_expression] = STATE(3926),
    [sym_lambda_expression] = STATE(3926),
    [sym_lambda_capture_specifier] = STATE(6169),
    [sym_fold_expression] = STATE(3926),
    [sym_parameter_pack_expansion] = STATE(3926),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3934),
    [sym_qualified_type_identifier] = STATE(7876),
    [sym_user_defined_literal] = STATE(3934),
    [sym_kernel_call_expression] = STATE(3930),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(4518),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3291),
    [anon_sym_not] = ACTIONS(3283),
    [anon_sym_compl] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(4351),
    [anon_sym_PLUS_PLUS] = ACTIONS(4351),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3295),
    [anon_sym___alignof] = ACTIONS(3295),
    [anon_sym__alignof] = ACTIONS(3295),
    [anon_sym_alignof] = ACTIONS(3295),
    [anon_sym__Alignof] = ACTIONS(3295),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3299),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [sym_number_literal] = ACTIONS(3303),
    [anon_sym_L_SQUOTE] = ACTIONS(3305),
    [anon_sym_u_SQUOTE] = ACTIONS(3305),
    [anon_sym_U_SQUOTE] = ACTIONS(3305),
    [anon_sym_u8_SQUOTE] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_L_DQUOTE] = ACTIONS(3307),
    [anon_sym_u_DQUOTE] = ACTIONS(3307),
    [anon_sym_U_DQUOTE] = ACTIONS(3307),
    [anon_sym_u8_DQUOTE] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [anon_sym_NULL] = ACTIONS(3311),
    [anon_sym_nullptr] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_R_DQUOTE] = ACTIONS(3315),
    [anon_sym_LR_DQUOTE] = ACTIONS(3315),
    [anon_sym_uR_DQUOTE] = ACTIONS(3315),
    [anon_sym_UR_DQUOTE] = ACTIONS(3315),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3315),
    [anon_sym_co_await] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_requires] = ACTIONS(3321),
    [sym_this] = ACTIONS(3309),
  },
  [1582] = {
    [sym_expression] = STATE(4746),
    [sym__string] = STATE(5255),
    [sym_conditional_expression] = STATE(5255),
    [sym_assignment_expression] = STATE(5255),
    [sym_pointer_expression] = STATE(3988),
    [sym_unary_expression] = STATE(5255),
    [sym_binary_expression] = STATE(5255),
    [sym_update_expression] = STATE(5255),
    [sym_cast_expression] = STATE(5255),
    [sym_sizeof_expression] = STATE(5255),
    [sym_alignof_expression] = STATE(5255),
    [sym_offsetof_expression] = STATE(5255),
    [sym_generic_expression] = STATE(5255),
    [sym_subscript_expression] = STATE(3988),
    [sym_call_expression] = STATE(3988),
    [sym_gnu_asm_expression] = STATE(5255),
    [sym_field_expression] = STATE(3988),
    [sym_compound_literal_expression] = STATE(5255),
    [sym_parenthesized_expression] = STATE(3988),
    [sym_char_literal] = STATE(5164),
    [sym_concatenated_string] = STATE(5162),
    [sym_string_literal] = STATE(4081),
    [sym_null] = STATE(5255),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5255),
    [sym_raw_string_literal] = STATE(4060),
    [sym_co_await_expression] = STATE(5255),
    [sym_new_expression] = STATE(5255),
    [sym_delete_expression] = STATE(5255),
    [sym_requires_clause] = STATE(5255),
    [sym_requires_expression] = STATE(5255),
    [sym_lambda_expression] = STATE(5255),
    [sym_lambda_capture_specifier] = STATE(6164),
    [sym_fold_expression] = STATE(5255),
    [sym_parameter_pack_expansion] = STATE(5255),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3988),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3988),
    [sym_kernel_call_expression] = STATE(5260),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4486),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3718),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4452),
    [anon_sym_PLUS_PLUS] = ACTIONS(4452),
    [anon_sym_sizeof] = ACTIONS(3720),
    [anon_sym___alignof__] = ACTIONS(3722),
    [anon_sym___alignof] = ACTIONS(3722),
    [anon_sym__alignof] = ACTIONS(3722),
    [anon_sym_alignof] = ACTIONS(3722),
    [anon_sym__Alignof] = ACTIONS(3722),
    [anon_sym_offsetof] = ACTIONS(3724),
    [anon_sym__Generic] = ACTIONS(3726),
    [anon_sym_asm] = ACTIONS(3728),
    [anon_sym___asm__] = ACTIONS(3728),
    [sym_number_literal] = ACTIONS(3730),
    [anon_sym_L_SQUOTE] = ACTIONS(3732),
    [anon_sym_u_SQUOTE] = ACTIONS(3732),
    [anon_sym_U_SQUOTE] = ACTIONS(3732),
    [anon_sym_u8_SQUOTE] = ACTIONS(3732),
    [anon_sym_SQUOTE] = ACTIONS(3732),
    [anon_sym_L_DQUOTE] = ACTIONS(3734),
    [anon_sym_u_DQUOTE] = ACTIONS(3734),
    [anon_sym_U_DQUOTE] = ACTIONS(3734),
    [anon_sym_u8_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [sym_true] = ACTIONS(3736),
    [sym_false] = ACTIONS(3736),
    [anon_sym_NULL] = ACTIONS(3738),
    [anon_sym_nullptr] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3740),
    [anon_sym_R_DQUOTE] = ACTIONS(3742),
    [anon_sym_LR_DQUOTE] = ACTIONS(3742),
    [anon_sym_uR_DQUOTE] = ACTIONS(3742),
    [anon_sym_UR_DQUOTE] = ACTIONS(3742),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3742),
    [anon_sym_co_await] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3748),
    [sym_this] = ACTIONS(3736),
  },
  [1583] = {
    [sym_expression] = STATE(3416),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4539),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(3331),
    [anon_sym_compl] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(4365),
    [anon_sym_PLUS_PLUS] = ACTIONS(4365),
    [anon_sym_sizeof] = ACTIONS(3337),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3339),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1584] = {
    [sym_expression] = STATE(3418),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4539),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(3331),
    [anon_sym_compl] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(4365),
    [anon_sym_PLUS_PLUS] = ACTIONS(4365),
    [anon_sym_sizeof] = ACTIONS(3337),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3339),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1585] = {
    [sym_expression] = STATE(3270),
    [sym__string] = STATE(3860),
    [sym_conditional_expression] = STATE(3860),
    [sym_assignment_expression] = STATE(3860),
    [sym_pointer_expression] = STATE(3861),
    [sym_unary_expression] = STATE(3860),
    [sym_binary_expression] = STATE(3860),
    [sym_update_expression] = STATE(3860),
    [sym_cast_expression] = STATE(3860),
    [sym_sizeof_expression] = STATE(3860),
    [sym_alignof_expression] = STATE(3860),
    [sym_offsetof_expression] = STATE(3860),
    [sym_generic_expression] = STATE(3860),
    [sym_subscript_expression] = STATE(3861),
    [sym_call_expression] = STATE(3861),
    [sym_gnu_asm_expression] = STATE(3860),
    [sym_field_expression] = STATE(3861),
    [sym_compound_literal_expression] = STATE(3860),
    [sym_parenthesized_expression] = STATE(3861),
    [sym_char_literal] = STATE(3831),
    [sym_concatenated_string] = STATE(3833),
    [sym_string_literal] = STATE(2490),
    [sym_null] = STATE(3860),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7980),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3860),
    [sym_raw_string_literal] = STATE(2516),
    [sym_co_await_expression] = STATE(3860),
    [sym_new_expression] = STATE(3860),
    [sym_delete_expression] = STATE(3860),
    [sym_requires_clause] = STATE(3860),
    [sym_requires_expression] = STATE(3860),
    [sym_lambda_expression] = STATE(3860),
    [sym_lambda_capture_specifier] = STATE(6189),
    [sym_fold_expression] = STATE(3860),
    [sym_parameter_pack_expansion] = STATE(3860),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3861),
    [sym_qualified_type_identifier] = STATE(7980),
    [sym_user_defined_literal] = STATE(3861),
    [sym_kernel_call_expression] = STATE(3851),
    [sym_identifier] = ACTIONS(3179),
    [anon_sym_LPAREN2] = ACTIONS(4541),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3181),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3185),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3189),
    [anon_sym_not] = ACTIONS(3181),
    [anon_sym_compl] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(4357),
    [anon_sym_PLUS_PLUS] = ACTIONS(4357),
    [anon_sym_sizeof] = ACTIONS(3191),
    [anon_sym___alignof__] = ACTIONS(3193),
    [anon_sym___alignof] = ACTIONS(3193),
    [anon_sym__alignof] = ACTIONS(3193),
    [anon_sym_alignof] = ACTIONS(3193),
    [anon_sym__Alignof] = ACTIONS(3193),
    [anon_sym_offsetof] = ACTIONS(3195),
    [anon_sym__Generic] = ACTIONS(3197),
    [anon_sym_asm] = ACTIONS(3199),
    [anon_sym___asm__] = ACTIONS(3199),
    [sym_number_literal] = ACTIONS(3201),
    [anon_sym_L_SQUOTE] = ACTIONS(3203),
    [anon_sym_u_SQUOTE] = ACTIONS(3203),
    [anon_sym_U_SQUOTE] = ACTIONS(3203),
    [anon_sym_u8_SQUOTE] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [anon_sym_L_DQUOTE] = ACTIONS(3205),
    [anon_sym_u_DQUOTE] = ACTIONS(3205),
    [anon_sym_U_DQUOTE] = ACTIONS(3205),
    [anon_sym_u8_DQUOTE] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3205),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [anon_sym_NULL] = ACTIONS(3209),
    [anon_sym_nullptr] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_R_DQUOTE] = ACTIONS(3213),
    [anon_sym_LR_DQUOTE] = ACTIONS(3213),
    [anon_sym_uR_DQUOTE] = ACTIONS(3213),
    [anon_sym_UR_DQUOTE] = ACTIONS(3213),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3213),
    [anon_sym_co_await] = ACTIONS(3215),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_requires] = ACTIONS(3219),
    [sym_this] = ACTIONS(3207),
  },
  [1586] = {
    [sym_expression] = STATE(4961),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(4824),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1587] = {
    [sym_expression] = STATE(3482),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4539),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(3331),
    [anon_sym_compl] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(4365),
    [anon_sym_PLUS_PLUS] = ACTIONS(4365),
    [anon_sym_sizeof] = ACTIONS(3337),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3339),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1588] = {
    [sym_expression] = STATE(4957),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1589] = {
    [sym_expression] = STATE(4952),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1590] = {
    [sym_expression] = STATE(4951),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1591] = {
    [sym_expression] = STATE(4950),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1592] = {
    [sym_expression] = STATE(5006),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1593] = {
    [sym_expression] = STATE(2497),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(2940),
    [sym_concatenated_string] = STATE(3000),
    [sym_string_literal] = STATE(2241),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2239),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4472),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(4474),
    [anon_sym_AMP] = ACTIONS(4474),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2512),
    [anon_sym_compl] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_sizeof] = ACTIONS(2522),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2532),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [anon_sym_co_await] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1594] = {
    [sym_expression] = STATE(3481),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4539),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(3331),
    [anon_sym_compl] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(4365),
    [anon_sym_PLUS_PLUS] = ACTIONS(4365),
    [anon_sym_sizeof] = ACTIONS(3337),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3339),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1595] = {
    [sym_expression] = STATE(4946),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1596] = {
    [sym_expression] = STATE(4752),
    [sym__string] = STATE(5255),
    [sym_conditional_expression] = STATE(5255),
    [sym_assignment_expression] = STATE(5255),
    [sym_pointer_expression] = STATE(3988),
    [sym_unary_expression] = STATE(5255),
    [sym_binary_expression] = STATE(5255),
    [sym_update_expression] = STATE(5255),
    [sym_cast_expression] = STATE(5255),
    [sym_sizeof_expression] = STATE(5255),
    [sym_alignof_expression] = STATE(5255),
    [sym_offsetof_expression] = STATE(5255),
    [sym_generic_expression] = STATE(5255),
    [sym_subscript_expression] = STATE(3988),
    [sym_call_expression] = STATE(3988),
    [sym_gnu_asm_expression] = STATE(5255),
    [sym_field_expression] = STATE(3988),
    [sym_compound_literal_expression] = STATE(5255),
    [sym_parenthesized_expression] = STATE(3988),
    [sym_char_literal] = STATE(5164),
    [sym_concatenated_string] = STATE(5162),
    [sym_string_literal] = STATE(4081),
    [sym_null] = STATE(5255),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5255),
    [sym_raw_string_literal] = STATE(4060),
    [sym_co_await_expression] = STATE(5255),
    [sym_new_expression] = STATE(5255),
    [sym_delete_expression] = STATE(5255),
    [sym_requires_clause] = STATE(5255),
    [sym_requires_expression] = STATE(5255),
    [sym_lambda_expression] = STATE(5255),
    [sym_lambda_capture_specifier] = STATE(6164),
    [sym_fold_expression] = STATE(5255),
    [sym_parameter_pack_expansion] = STATE(5255),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3988),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3988),
    [sym_kernel_call_expression] = STATE(5260),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4486),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3718),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4452),
    [anon_sym_PLUS_PLUS] = ACTIONS(4452),
    [anon_sym_sizeof] = ACTIONS(3720),
    [anon_sym___alignof__] = ACTIONS(3722),
    [anon_sym___alignof] = ACTIONS(3722),
    [anon_sym__alignof] = ACTIONS(3722),
    [anon_sym_alignof] = ACTIONS(3722),
    [anon_sym__Alignof] = ACTIONS(3722),
    [anon_sym_offsetof] = ACTIONS(3724),
    [anon_sym__Generic] = ACTIONS(3726),
    [anon_sym_asm] = ACTIONS(3728),
    [anon_sym___asm__] = ACTIONS(3728),
    [sym_number_literal] = ACTIONS(3730),
    [anon_sym_L_SQUOTE] = ACTIONS(3732),
    [anon_sym_u_SQUOTE] = ACTIONS(3732),
    [anon_sym_U_SQUOTE] = ACTIONS(3732),
    [anon_sym_u8_SQUOTE] = ACTIONS(3732),
    [anon_sym_SQUOTE] = ACTIONS(3732),
    [anon_sym_L_DQUOTE] = ACTIONS(3734),
    [anon_sym_u_DQUOTE] = ACTIONS(3734),
    [anon_sym_U_DQUOTE] = ACTIONS(3734),
    [anon_sym_u8_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [sym_true] = ACTIONS(3736),
    [sym_false] = ACTIONS(3736),
    [anon_sym_NULL] = ACTIONS(3738),
    [anon_sym_nullptr] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3740),
    [anon_sym_R_DQUOTE] = ACTIONS(3742),
    [anon_sym_LR_DQUOTE] = ACTIONS(3742),
    [anon_sym_uR_DQUOTE] = ACTIONS(3742),
    [anon_sym_UR_DQUOTE] = ACTIONS(3742),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3742),
    [anon_sym_co_await] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3748),
    [sym_this] = ACTIONS(3736),
  },
  [1597] = {
    [sym_expression] = STATE(4767),
    [sym__string] = STATE(5255),
    [sym_conditional_expression] = STATE(5255),
    [sym_assignment_expression] = STATE(5255),
    [sym_pointer_expression] = STATE(3988),
    [sym_unary_expression] = STATE(5255),
    [sym_binary_expression] = STATE(5255),
    [sym_update_expression] = STATE(5255),
    [sym_cast_expression] = STATE(5255),
    [sym_sizeof_expression] = STATE(5255),
    [sym_alignof_expression] = STATE(5255),
    [sym_offsetof_expression] = STATE(5255),
    [sym_generic_expression] = STATE(5255),
    [sym_subscript_expression] = STATE(3988),
    [sym_call_expression] = STATE(3988),
    [sym_gnu_asm_expression] = STATE(5255),
    [sym_field_expression] = STATE(3988),
    [sym_compound_literal_expression] = STATE(5255),
    [sym_parenthesized_expression] = STATE(3988),
    [sym_char_literal] = STATE(5164),
    [sym_concatenated_string] = STATE(5162),
    [sym_string_literal] = STATE(4081),
    [sym_null] = STATE(5255),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5255),
    [sym_raw_string_literal] = STATE(4060),
    [sym_co_await_expression] = STATE(5255),
    [sym_new_expression] = STATE(5255),
    [sym_delete_expression] = STATE(5255),
    [sym_requires_clause] = STATE(5255),
    [sym_requires_expression] = STATE(5255),
    [sym_lambda_expression] = STATE(5255),
    [sym_lambda_capture_specifier] = STATE(6164),
    [sym_fold_expression] = STATE(5255),
    [sym_parameter_pack_expansion] = STATE(5255),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3988),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3988),
    [sym_kernel_call_expression] = STATE(5260),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4486),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3718),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4452),
    [anon_sym_PLUS_PLUS] = ACTIONS(4452),
    [anon_sym_sizeof] = ACTIONS(3720),
    [anon_sym___alignof__] = ACTIONS(3722),
    [anon_sym___alignof] = ACTIONS(3722),
    [anon_sym__alignof] = ACTIONS(3722),
    [anon_sym_alignof] = ACTIONS(3722),
    [anon_sym__Alignof] = ACTIONS(3722),
    [anon_sym_offsetof] = ACTIONS(3724),
    [anon_sym__Generic] = ACTIONS(3726),
    [anon_sym_asm] = ACTIONS(3728),
    [anon_sym___asm__] = ACTIONS(3728),
    [sym_number_literal] = ACTIONS(3730),
    [anon_sym_L_SQUOTE] = ACTIONS(3732),
    [anon_sym_u_SQUOTE] = ACTIONS(3732),
    [anon_sym_U_SQUOTE] = ACTIONS(3732),
    [anon_sym_u8_SQUOTE] = ACTIONS(3732),
    [anon_sym_SQUOTE] = ACTIONS(3732),
    [anon_sym_L_DQUOTE] = ACTIONS(3734),
    [anon_sym_u_DQUOTE] = ACTIONS(3734),
    [anon_sym_U_DQUOTE] = ACTIONS(3734),
    [anon_sym_u8_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [sym_true] = ACTIONS(3736),
    [sym_false] = ACTIONS(3736),
    [anon_sym_NULL] = ACTIONS(3738),
    [anon_sym_nullptr] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3740),
    [anon_sym_R_DQUOTE] = ACTIONS(3742),
    [anon_sym_LR_DQUOTE] = ACTIONS(3742),
    [anon_sym_uR_DQUOTE] = ACTIONS(3742),
    [anon_sym_UR_DQUOTE] = ACTIONS(3742),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3742),
    [anon_sym_co_await] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3748),
    [sym_this] = ACTIONS(3736),
  },
  [1598] = {
    [sym_expression] = STATE(4945),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1599] = {
    [sym_expression] = STATE(4943),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1600] = {
    [sym_expression] = STATE(4938),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1601] = {
    [sym_expression] = STATE(4911),
    [sym__string] = STATE(5255),
    [sym_conditional_expression] = STATE(5255),
    [sym_assignment_expression] = STATE(5255),
    [sym_pointer_expression] = STATE(3988),
    [sym_unary_expression] = STATE(5255),
    [sym_binary_expression] = STATE(5255),
    [sym_update_expression] = STATE(5255),
    [sym_cast_expression] = STATE(5255),
    [sym_sizeof_expression] = STATE(5255),
    [sym_alignof_expression] = STATE(5255),
    [sym_offsetof_expression] = STATE(5255),
    [sym_generic_expression] = STATE(5255),
    [sym_subscript_expression] = STATE(3988),
    [sym_call_expression] = STATE(3988),
    [sym_gnu_asm_expression] = STATE(5255),
    [sym_field_expression] = STATE(3988),
    [sym_compound_literal_expression] = STATE(5255),
    [sym_parenthesized_expression] = STATE(3988),
    [sym_char_literal] = STATE(5164),
    [sym_concatenated_string] = STATE(5162),
    [sym_string_literal] = STATE(4081),
    [sym_null] = STATE(5255),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5255),
    [sym_raw_string_literal] = STATE(4060),
    [sym_co_await_expression] = STATE(5255),
    [sym_new_expression] = STATE(5255),
    [sym_delete_expression] = STATE(5255),
    [sym_requires_clause] = STATE(5255),
    [sym_requires_expression] = STATE(5255),
    [sym_lambda_expression] = STATE(5255),
    [sym_lambda_capture_specifier] = STATE(6164),
    [sym_fold_expression] = STATE(5255),
    [sym_parameter_pack_expansion] = STATE(5255),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3988),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3988),
    [sym_kernel_call_expression] = STATE(5260),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4486),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3718),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4452),
    [anon_sym_PLUS_PLUS] = ACTIONS(4452),
    [anon_sym_sizeof] = ACTIONS(3720),
    [anon_sym___alignof__] = ACTIONS(3722),
    [anon_sym___alignof] = ACTIONS(3722),
    [anon_sym__alignof] = ACTIONS(3722),
    [anon_sym_alignof] = ACTIONS(3722),
    [anon_sym__Alignof] = ACTIONS(3722),
    [anon_sym_offsetof] = ACTIONS(3724),
    [anon_sym__Generic] = ACTIONS(3726),
    [anon_sym_asm] = ACTIONS(3728),
    [anon_sym___asm__] = ACTIONS(3728),
    [sym_number_literal] = ACTIONS(3730),
    [anon_sym_L_SQUOTE] = ACTIONS(3732),
    [anon_sym_u_SQUOTE] = ACTIONS(3732),
    [anon_sym_U_SQUOTE] = ACTIONS(3732),
    [anon_sym_u8_SQUOTE] = ACTIONS(3732),
    [anon_sym_SQUOTE] = ACTIONS(3732),
    [anon_sym_L_DQUOTE] = ACTIONS(3734),
    [anon_sym_u_DQUOTE] = ACTIONS(3734),
    [anon_sym_U_DQUOTE] = ACTIONS(3734),
    [anon_sym_u8_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [sym_true] = ACTIONS(3736),
    [sym_false] = ACTIONS(3736),
    [anon_sym_NULL] = ACTIONS(3738),
    [anon_sym_nullptr] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3740),
    [anon_sym_R_DQUOTE] = ACTIONS(3742),
    [anon_sym_LR_DQUOTE] = ACTIONS(3742),
    [anon_sym_uR_DQUOTE] = ACTIONS(3742),
    [anon_sym_UR_DQUOTE] = ACTIONS(3742),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3742),
    [anon_sym_co_await] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3748),
    [sym_this] = ACTIONS(3736),
  },
  [1602] = {
    [sym_expression] = STATE(3475),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4539),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(3331),
    [anon_sym_compl] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(4365),
    [anon_sym_PLUS_PLUS] = ACTIONS(4365),
    [anon_sym_sizeof] = ACTIONS(3337),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3339),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1603] = {
    [sym_expression] = STATE(4930),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1604] = {
    [sym_expression] = STATE(4926),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1605] = {
    [sym_expression] = STATE(3469),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4539),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(3331),
    [anon_sym_compl] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(4365),
    [anon_sym_PLUS_PLUS] = ACTIONS(4365),
    [anon_sym_sizeof] = ACTIONS(3337),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3339),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1606] = {
    [sym_expression] = STATE(4923),
    [sym__string] = STATE(5255),
    [sym_conditional_expression] = STATE(5255),
    [sym_assignment_expression] = STATE(5255),
    [sym_pointer_expression] = STATE(3988),
    [sym_unary_expression] = STATE(5255),
    [sym_binary_expression] = STATE(5255),
    [sym_update_expression] = STATE(5255),
    [sym_cast_expression] = STATE(5255),
    [sym_sizeof_expression] = STATE(5255),
    [sym_alignof_expression] = STATE(5255),
    [sym_offsetof_expression] = STATE(5255),
    [sym_generic_expression] = STATE(5255),
    [sym_subscript_expression] = STATE(3988),
    [sym_call_expression] = STATE(3988),
    [sym_gnu_asm_expression] = STATE(5255),
    [sym_field_expression] = STATE(3988),
    [sym_compound_literal_expression] = STATE(5255),
    [sym_parenthesized_expression] = STATE(3988),
    [sym_char_literal] = STATE(5164),
    [sym_concatenated_string] = STATE(5162),
    [sym_string_literal] = STATE(4081),
    [sym_null] = STATE(5255),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5255),
    [sym_raw_string_literal] = STATE(4060),
    [sym_co_await_expression] = STATE(5255),
    [sym_new_expression] = STATE(5255),
    [sym_delete_expression] = STATE(5255),
    [sym_requires_clause] = STATE(5255),
    [sym_requires_expression] = STATE(5255),
    [sym_lambda_expression] = STATE(5255),
    [sym_lambda_capture_specifier] = STATE(6164),
    [sym_fold_expression] = STATE(5255),
    [sym_parameter_pack_expansion] = STATE(5255),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3988),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3988),
    [sym_kernel_call_expression] = STATE(5260),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4486),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3718),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4452),
    [anon_sym_PLUS_PLUS] = ACTIONS(4452),
    [anon_sym_sizeof] = ACTIONS(3720),
    [anon_sym___alignof__] = ACTIONS(3722),
    [anon_sym___alignof] = ACTIONS(3722),
    [anon_sym__alignof] = ACTIONS(3722),
    [anon_sym_alignof] = ACTIONS(3722),
    [anon_sym__Alignof] = ACTIONS(3722),
    [anon_sym_offsetof] = ACTIONS(3724),
    [anon_sym__Generic] = ACTIONS(3726),
    [anon_sym_asm] = ACTIONS(3728),
    [anon_sym___asm__] = ACTIONS(3728),
    [sym_number_literal] = ACTIONS(3730),
    [anon_sym_L_SQUOTE] = ACTIONS(3732),
    [anon_sym_u_SQUOTE] = ACTIONS(3732),
    [anon_sym_U_SQUOTE] = ACTIONS(3732),
    [anon_sym_u8_SQUOTE] = ACTIONS(3732),
    [anon_sym_SQUOTE] = ACTIONS(3732),
    [anon_sym_L_DQUOTE] = ACTIONS(3734),
    [anon_sym_u_DQUOTE] = ACTIONS(3734),
    [anon_sym_U_DQUOTE] = ACTIONS(3734),
    [anon_sym_u8_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [sym_true] = ACTIONS(3736),
    [sym_false] = ACTIONS(3736),
    [anon_sym_NULL] = ACTIONS(3738),
    [anon_sym_nullptr] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3740),
    [anon_sym_R_DQUOTE] = ACTIONS(3742),
    [anon_sym_LR_DQUOTE] = ACTIONS(3742),
    [anon_sym_uR_DQUOTE] = ACTIONS(3742),
    [anon_sym_UR_DQUOTE] = ACTIONS(3742),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3742),
    [anon_sym_co_await] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3748),
    [sym_this] = ACTIONS(3736),
  },
  [1607] = {
    [sym_expression] = STATE(4757),
    [sym__string] = STATE(5255),
    [sym_conditional_expression] = STATE(5255),
    [sym_assignment_expression] = STATE(5255),
    [sym_pointer_expression] = STATE(3988),
    [sym_unary_expression] = STATE(5255),
    [sym_binary_expression] = STATE(5255),
    [sym_update_expression] = STATE(5255),
    [sym_cast_expression] = STATE(5255),
    [sym_sizeof_expression] = STATE(5255),
    [sym_alignof_expression] = STATE(5255),
    [sym_offsetof_expression] = STATE(5255),
    [sym_generic_expression] = STATE(5255),
    [sym_subscript_expression] = STATE(3988),
    [sym_call_expression] = STATE(3988),
    [sym_gnu_asm_expression] = STATE(5255),
    [sym_field_expression] = STATE(3988),
    [sym_compound_literal_expression] = STATE(5255),
    [sym_parenthesized_expression] = STATE(3988),
    [sym_char_literal] = STATE(5164),
    [sym_concatenated_string] = STATE(5162),
    [sym_string_literal] = STATE(4081),
    [sym_null] = STATE(5255),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5255),
    [sym_raw_string_literal] = STATE(4060),
    [sym_co_await_expression] = STATE(5255),
    [sym_new_expression] = STATE(5255),
    [sym_delete_expression] = STATE(5255),
    [sym_requires_clause] = STATE(5255),
    [sym_requires_expression] = STATE(5255),
    [sym_lambda_expression] = STATE(5255),
    [sym_lambda_capture_specifier] = STATE(6164),
    [sym_fold_expression] = STATE(5255),
    [sym_parameter_pack_expansion] = STATE(5255),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3988),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3988),
    [sym_kernel_call_expression] = STATE(5260),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4486),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3718),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4452),
    [anon_sym_PLUS_PLUS] = ACTIONS(4452),
    [anon_sym_sizeof] = ACTIONS(3720),
    [anon_sym___alignof__] = ACTIONS(3722),
    [anon_sym___alignof] = ACTIONS(3722),
    [anon_sym__alignof] = ACTIONS(3722),
    [anon_sym_alignof] = ACTIONS(3722),
    [anon_sym__Alignof] = ACTIONS(3722),
    [anon_sym_offsetof] = ACTIONS(3724),
    [anon_sym__Generic] = ACTIONS(3726),
    [anon_sym_asm] = ACTIONS(3728),
    [anon_sym___asm__] = ACTIONS(3728),
    [sym_number_literal] = ACTIONS(3730),
    [anon_sym_L_SQUOTE] = ACTIONS(3732),
    [anon_sym_u_SQUOTE] = ACTIONS(3732),
    [anon_sym_U_SQUOTE] = ACTIONS(3732),
    [anon_sym_u8_SQUOTE] = ACTIONS(3732),
    [anon_sym_SQUOTE] = ACTIONS(3732),
    [anon_sym_L_DQUOTE] = ACTIONS(3734),
    [anon_sym_u_DQUOTE] = ACTIONS(3734),
    [anon_sym_U_DQUOTE] = ACTIONS(3734),
    [anon_sym_u8_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [sym_true] = ACTIONS(3736),
    [sym_false] = ACTIONS(3736),
    [anon_sym_NULL] = ACTIONS(3738),
    [anon_sym_nullptr] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3740),
    [anon_sym_R_DQUOTE] = ACTIONS(3742),
    [anon_sym_LR_DQUOTE] = ACTIONS(3742),
    [anon_sym_uR_DQUOTE] = ACTIONS(3742),
    [anon_sym_UR_DQUOTE] = ACTIONS(3742),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3742),
    [anon_sym_co_await] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3748),
    [sym_this] = ACTIONS(3736),
  },
  [1608] = {
    [sym_expression] = STATE(4910),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1609] = {
    [sym_expression] = STATE(3465),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4539),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(3331),
    [anon_sym_compl] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(4365),
    [anon_sym_PLUS_PLUS] = ACTIONS(4365),
    [anon_sym_sizeof] = ACTIONS(3337),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3339),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1610] = {
    [sym_expression] = STATE(4899),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1611] = {
    [sym_expression] = STATE(4941),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1612] = {
    [sym_expression] = STATE(4933),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1613] = {
    [sym_expression] = STATE(3183),
    [sym__string] = STATE(3719),
    [sym_conditional_expression] = STATE(3719),
    [sym_assignment_expression] = STATE(3719),
    [sym_pointer_expression] = STATE(3686),
    [sym_unary_expression] = STATE(3719),
    [sym_binary_expression] = STATE(3719),
    [sym_update_expression] = STATE(3719),
    [sym_cast_expression] = STATE(3719),
    [sym_sizeof_expression] = STATE(3719),
    [sym_alignof_expression] = STATE(3719),
    [sym_offsetof_expression] = STATE(3719),
    [sym_generic_expression] = STATE(3719),
    [sym_subscript_expression] = STATE(3686),
    [sym_call_expression] = STATE(3686),
    [sym_gnu_asm_expression] = STATE(3719),
    [sym_field_expression] = STATE(3686),
    [sym_compound_literal_expression] = STATE(3719),
    [sym_parenthesized_expression] = STATE(3686),
    [sym_char_literal] = STATE(3582),
    [sym_concatenated_string] = STATE(3540),
    [sym_string_literal] = STATE(2397),
    [sym_null] = STATE(3719),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7868),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3719),
    [sym_raw_string_literal] = STATE(2449),
    [sym_co_await_expression] = STATE(3719),
    [sym_new_expression] = STATE(3719),
    [sym_delete_expression] = STATE(3719),
    [sym_requires_clause] = STATE(3719),
    [sym_requires_expression] = STATE(3719),
    [sym_lambda_expression] = STATE(3719),
    [sym_lambda_capture_specifier] = STATE(6157),
    [sym_fold_expression] = STATE(3719),
    [sym_parameter_pack_expansion] = STATE(3719),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5905),
    [sym_qualified_identifier] = STATE(3686),
    [sym_qualified_type_identifier] = STATE(7868),
    [sym_user_defined_literal] = STATE(3686),
    [sym_kernel_call_expression] = STATE(3630),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_LPAREN2] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2793),
    [anon_sym_not] = ACTIONS(1831),
    [anon_sym_compl] = ACTIONS(1831),
    [anon_sym_DASH_DASH] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1855),
    [anon_sym_sizeof] = ACTIONS(1857),
    [anon_sym___alignof__] = ACTIONS(1859),
    [anon_sym___alignof] = ACTIONS(1859),
    [anon_sym__alignof] = ACTIONS(1859),
    [anon_sym_alignof] = ACTIONS(1859),
    [anon_sym__Alignof] = ACTIONS(1859),
    [anon_sym_offsetof] = ACTIONS(1861),
    [anon_sym__Generic] = ACTIONS(1863),
    [anon_sym_asm] = ACTIONS(1865),
    [anon_sym___asm__] = ACTIONS(1865),
    [sym_number_literal] = ACTIONS(1867),
    [anon_sym_L_SQUOTE] = ACTIONS(1869),
    [anon_sym_u_SQUOTE] = ACTIONS(1869),
    [anon_sym_U_SQUOTE] = ACTIONS(1869),
    [anon_sym_u8_SQUOTE] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_L_DQUOTE] = ACTIONS(1871),
    [anon_sym_u_DQUOTE] = ACTIONS(1871),
    [anon_sym_U_DQUOTE] = ACTIONS(1871),
    [anon_sym_u8_DQUOTE] = ACTIONS(1871),
    [anon_sym_DQUOTE] = ACTIONS(1871),
    [sym_true] = ACTIONS(1873),
    [sym_false] = ACTIONS(1873),
    [anon_sym_NULL] = ACTIONS(1875),
    [anon_sym_nullptr] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(1885),
    [anon_sym_R_DQUOTE] = ACTIONS(1887),
    [anon_sym_LR_DQUOTE] = ACTIONS(1887),
    [anon_sym_uR_DQUOTE] = ACTIONS(1887),
    [anon_sym_UR_DQUOTE] = ACTIONS(1887),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1887),
    [anon_sym_co_await] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1891),
    [anon_sym_requires] = ACTIONS(1893),
    [sym_this] = ACTIONS(1873),
  },
  [1614] = {
    [sym_expression] = STATE(4766),
    [sym__string] = STATE(5255),
    [sym_conditional_expression] = STATE(5255),
    [sym_assignment_expression] = STATE(5255),
    [sym_pointer_expression] = STATE(3988),
    [sym_unary_expression] = STATE(5255),
    [sym_binary_expression] = STATE(5255),
    [sym_update_expression] = STATE(5255),
    [sym_cast_expression] = STATE(5255),
    [sym_sizeof_expression] = STATE(5255),
    [sym_alignof_expression] = STATE(5255),
    [sym_offsetof_expression] = STATE(5255),
    [sym_generic_expression] = STATE(5255),
    [sym_subscript_expression] = STATE(3988),
    [sym_call_expression] = STATE(3988),
    [sym_gnu_asm_expression] = STATE(5255),
    [sym_field_expression] = STATE(3988),
    [sym_compound_literal_expression] = STATE(5255),
    [sym_parenthesized_expression] = STATE(3988),
    [sym_char_literal] = STATE(5164),
    [sym_concatenated_string] = STATE(5162),
    [sym_string_literal] = STATE(4081),
    [sym_null] = STATE(5255),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5255),
    [sym_raw_string_literal] = STATE(4060),
    [sym_co_await_expression] = STATE(5255),
    [sym_new_expression] = STATE(5255),
    [sym_delete_expression] = STATE(5255),
    [sym_requires_clause] = STATE(5255),
    [sym_requires_expression] = STATE(5255),
    [sym_lambda_expression] = STATE(5255),
    [sym_lambda_capture_specifier] = STATE(6164),
    [sym_fold_expression] = STATE(5255),
    [sym_parameter_pack_expansion] = STATE(5255),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3988),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3988),
    [sym_kernel_call_expression] = STATE(5260),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4486),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3718),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4452),
    [anon_sym_PLUS_PLUS] = ACTIONS(4452),
    [anon_sym_sizeof] = ACTIONS(3720),
    [anon_sym___alignof__] = ACTIONS(3722),
    [anon_sym___alignof] = ACTIONS(3722),
    [anon_sym__alignof] = ACTIONS(3722),
    [anon_sym_alignof] = ACTIONS(3722),
    [anon_sym__Alignof] = ACTIONS(3722),
    [anon_sym_offsetof] = ACTIONS(3724),
    [anon_sym__Generic] = ACTIONS(3726),
    [anon_sym_asm] = ACTIONS(3728),
    [anon_sym___asm__] = ACTIONS(3728),
    [sym_number_literal] = ACTIONS(3730),
    [anon_sym_L_SQUOTE] = ACTIONS(3732),
    [anon_sym_u_SQUOTE] = ACTIONS(3732),
    [anon_sym_U_SQUOTE] = ACTIONS(3732),
    [anon_sym_u8_SQUOTE] = ACTIONS(3732),
    [anon_sym_SQUOTE] = ACTIONS(3732),
    [anon_sym_L_DQUOTE] = ACTIONS(3734),
    [anon_sym_u_DQUOTE] = ACTIONS(3734),
    [anon_sym_U_DQUOTE] = ACTIONS(3734),
    [anon_sym_u8_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [sym_true] = ACTIONS(3736),
    [sym_false] = ACTIONS(3736),
    [anon_sym_NULL] = ACTIONS(3738),
    [anon_sym_nullptr] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3740),
    [anon_sym_R_DQUOTE] = ACTIONS(3742),
    [anon_sym_LR_DQUOTE] = ACTIONS(3742),
    [anon_sym_uR_DQUOTE] = ACTIONS(3742),
    [anon_sym_UR_DQUOTE] = ACTIONS(3742),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3742),
    [anon_sym_co_await] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3748),
    [sym_this] = ACTIONS(3736),
  },
  [1615] = {
    [sym_expression] = STATE(4487),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1616] = {
    [sym_expression] = STATE(4783),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(4826),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1617] = {
    [sym_expression] = STATE(5093),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1618] = {
    [sym_expression] = STATE(4832),
    [sym__string] = STATE(5255),
    [sym_conditional_expression] = STATE(5255),
    [sym_assignment_expression] = STATE(5255),
    [sym_pointer_expression] = STATE(3988),
    [sym_unary_expression] = STATE(5255),
    [sym_binary_expression] = STATE(5255),
    [sym_update_expression] = STATE(5255),
    [sym_cast_expression] = STATE(5255),
    [sym_sizeof_expression] = STATE(5255),
    [sym_alignof_expression] = STATE(5255),
    [sym_offsetof_expression] = STATE(5255),
    [sym_generic_expression] = STATE(5255),
    [sym_subscript_expression] = STATE(3988),
    [sym_call_expression] = STATE(3988),
    [sym_gnu_asm_expression] = STATE(5255),
    [sym_field_expression] = STATE(3988),
    [sym_compound_literal_expression] = STATE(5255),
    [sym_parenthesized_expression] = STATE(3988),
    [sym_char_literal] = STATE(5164),
    [sym_concatenated_string] = STATE(5162),
    [sym_string_literal] = STATE(4081),
    [sym_null] = STATE(5255),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5255),
    [sym_raw_string_literal] = STATE(4060),
    [sym_co_await_expression] = STATE(5255),
    [sym_new_expression] = STATE(5255),
    [sym_delete_expression] = STATE(5255),
    [sym_requires_clause] = STATE(5255),
    [sym_requires_expression] = STATE(5255),
    [sym_lambda_expression] = STATE(5255),
    [sym_lambda_capture_specifier] = STATE(6164),
    [sym_fold_expression] = STATE(5255),
    [sym_parameter_pack_expansion] = STATE(5255),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3988),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3988),
    [sym_kernel_call_expression] = STATE(5260),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4486),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3718),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4452),
    [anon_sym_PLUS_PLUS] = ACTIONS(4452),
    [anon_sym_sizeof] = ACTIONS(3720),
    [anon_sym___alignof__] = ACTIONS(3722),
    [anon_sym___alignof] = ACTIONS(3722),
    [anon_sym__alignof] = ACTIONS(3722),
    [anon_sym_alignof] = ACTIONS(3722),
    [anon_sym__Alignof] = ACTIONS(3722),
    [anon_sym_offsetof] = ACTIONS(3724),
    [anon_sym__Generic] = ACTIONS(3726),
    [anon_sym_asm] = ACTIONS(3728),
    [anon_sym___asm__] = ACTIONS(3728),
    [sym_number_literal] = ACTIONS(3730),
    [anon_sym_L_SQUOTE] = ACTIONS(3732),
    [anon_sym_u_SQUOTE] = ACTIONS(3732),
    [anon_sym_U_SQUOTE] = ACTIONS(3732),
    [anon_sym_u8_SQUOTE] = ACTIONS(3732),
    [anon_sym_SQUOTE] = ACTIONS(3732),
    [anon_sym_L_DQUOTE] = ACTIONS(3734),
    [anon_sym_u_DQUOTE] = ACTIONS(3734),
    [anon_sym_U_DQUOTE] = ACTIONS(3734),
    [anon_sym_u8_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [sym_true] = ACTIONS(3736),
    [sym_false] = ACTIONS(3736),
    [anon_sym_NULL] = ACTIONS(3738),
    [anon_sym_nullptr] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3740),
    [anon_sym_R_DQUOTE] = ACTIONS(3742),
    [anon_sym_LR_DQUOTE] = ACTIONS(3742),
    [anon_sym_uR_DQUOTE] = ACTIONS(3742),
    [anon_sym_UR_DQUOTE] = ACTIONS(3742),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3742),
    [anon_sym_co_await] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3748),
    [sym_this] = ACTIONS(3736),
  },
  [1619] = {
    [sym_expression] = STATE(4779),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3896),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3896),
    [sym_call_expression] = STATE(3896),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3896),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3896),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3896),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3896),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_LPAREN2] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_DASH] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(3696),
    [anon_sym_compl] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(4437),
    [anon_sym_PLUS_PLUS] = ACTIONS(4437),
    [anon_sym_sizeof] = ACTIONS(3702),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3704),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3692),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1620] = {
    [sym_expression] = STATE(3424),
    [sym__string] = STATE(3926),
    [sym_conditional_expression] = STATE(3926),
    [sym_assignment_expression] = STATE(3926),
    [sym_pointer_expression] = STATE(3934),
    [sym_unary_expression] = STATE(3926),
    [sym_binary_expression] = STATE(3926),
    [sym_update_expression] = STATE(3926),
    [sym_cast_expression] = STATE(3926),
    [sym_sizeof_expression] = STATE(3926),
    [sym_alignof_expression] = STATE(3926),
    [sym_offsetof_expression] = STATE(3926),
    [sym_generic_expression] = STATE(3926),
    [sym_subscript_expression] = STATE(3934),
    [sym_call_expression] = STATE(3934),
    [sym_gnu_asm_expression] = STATE(3926),
    [sym_field_expression] = STATE(3934),
    [sym_compound_literal_expression] = STATE(3926),
    [sym_parenthesized_expression] = STATE(3934),
    [sym_char_literal] = STATE(3755),
    [sym_concatenated_string] = STATE(3759),
    [sym_string_literal] = STATE(2463),
    [sym_null] = STATE(3926),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7876),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3926),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3926),
    [sym_new_expression] = STATE(3926),
    [sym_delete_expression] = STATE(3926),
    [sym_requires_clause] = STATE(3926),
    [sym_requires_expression] = STATE(3926),
    [sym_lambda_expression] = STATE(3926),
    [sym_lambda_capture_specifier] = STATE(6169),
    [sym_fold_expression] = STATE(3926),
    [sym_parameter_pack_expansion] = STATE(3926),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3934),
    [sym_qualified_type_identifier] = STATE(7876),
    [sym_user_defined_literal] = STATE(3934),
    [sym_kernel_call_expression] = STATE(3930),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(4518),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(4828),
    [sym_primitive_type] = ACTIONS(3291),
    [anon_sym_not] = ACTIONS(3283),
    [anon_sym_compl] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(4351),
    [anon_sym_PLUS_PLUS] = ACTIONS(4351),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3295),
    [anon_sym___alignof] = ACTIONS(3295),
    [anon_sym__alignof] = ACTIONS(3295),
    [anon_sym_alignof] = ACTIONS(3295),
    [anon_sym__Alignof] = ACTIONS(3295),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3299),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [sym_number_literal] = ACTIONS(3303),
    [anon_sym_L_SQUOTE] = ACTIONS(3305),
    [anon_sym_u_SQUOTE] = ACTIONS(3305),
    [anon_sym_U_SQUOTE] = ACTIONS(3305),
    [anon_sym_u8_SQUOTE] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_L_DQUOTE] = ACTIONS(3307),
    [anon_sym_u_DQUOTE] = ACTIONS(3307),
    [anon_sym_U_DQUOTE] = ACTIONS(3307),
    [anon_sym_u8_DQUOTE] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [anon_sym_NULL] = ACTIONS(3311),
    [anon_sym_nullptr] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_R_DQUOTE] = ACTIONS(3315),
    [anon_sym_LR_DQUOTE] = ACTIONS(3315),
    [anon_sym_uR_DQUOTE] = ACTIONS(3315),
    [anon_sym_UR_DQUOTE] = ACTIONS(3315),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3315),
    [anon_sym_co_await] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_requires] = ACTIONS(3321),
    [sym_this] = ACTIONS(3309),
  },
  [1621] = {
    [sym_expression] = STATE(4589),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(4830),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1622] = {
    [sym_expression] = STATE(4789),
    [sym__string] = STATE(5174),
    [sym_conditional_expression] = STATE(5174),
    [sym_assignment_expression] = STATE(5174),
    [sym_pointer_expression] = STATE(3993),
    [sym_unary_expression] = STATE(5174),
    [sym_binary_expression] = STATE(5174),
    [sym_update_expression] = STATE(5174),
    [sym_cast_expression] = STATE(5174),
    [sym_sizeof_expression] = STATE(5174),
    [sym_alignof_expression] = STATE(5174),
    [sym_offsetof_expression] = STATE(5174),
    [sym_generic_expression] = STATE(5174),
    [sym_subscript_expression] = STATE(3993),
    [sym_call_expression] = STATE(3993),
    [sym_gnu_asm_expression] = STATE(5174),
    [sym_field_expression] = STATE(3993),
    [sym_compound_literal_expression] = STATE(5174),
    [sym_parenthesized_expression] = STATE(3993),
    [sym_char_literal] = STATE(5160),
    [sym_concatenated_string] = STATE(5163),
    [sym_string_literal] = STATE(4057),
    [sym_null] = STATE(5174),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8015),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5174),
    [sym_raw_string_literal] = STATE(4061),
    [sym_co_await_expression] = STATE(5174),
    [sym_new_expression] = STATE(5174),
    [sym_delete_expression] = STATE(5174),
    [sym_requires_clause] = STATE(5174),
    [sym_requires_expression] = STATE(5174),
    [sym_lambda_expression] = STATE(5174),
    [sym_lambda_capture_specifier] = STATE(6195),
    [sym_fold_expression] = STATE(5174),
    [sym_parameter_pack_expansion] = STATE(5174),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3993),
    [sym_qualified_type_identifier] = STATE(8015),
    [sym_user_defined_literal] = STATE(3993),
    [sym_kernel_call_expression] = STATE(5172),
    [sym_identifier] = ACTIONS(3750),
    [anon_sym_LPAREN2] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(2721),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3754),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2735),
    [anon_sym_PLUS_PLUS] = ACTIONS(2735),
    [anon_sym_sizeof] = ACTIONS(2737),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2741),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2745),
    [anon_sym___asm__] = ACTIONS(2745),
    [sym_number_literal] = ACTIONS(2747),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2751),
    [anon_sym_u_DQUOTE] = ACTIONS(2751),
    [anon_sym_U_DQUOTE] = ACTIONS(2751),
    [anon_sym_u8_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [sym_true] = ACTIONS(2753),
    [sym_false] = ACTIONS(2753),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(2765),
    [anon_sym_R_DQUOTE] = ACTIONS(2767),
    [anon_sym_LR_DQUOTE] = ACTIONS(2767),
    [anon_sym_uR_DQUOTE] = ACTIONS(2767),
    [anon_sym_UR_DQUOTE] = ACTIONS(2767),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2767),
    [anon_sym_co_await] = ACTIONS(2769),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2773),
    [sym_this] = ACTIONS(2753),
  },
  [1623] = {
    [sym_expression] = STATE(4758),
    [sym__string] = STATE(5255),
    [sym_conditional_expression] = STATE(5255),
    [sym_assignment_expression] = STATE(5255),
    [sym_pointer_expression] = STATE(3988),
    [sym_unary_expression] = STATE(5255),
    [sym_binary_expression] = STATE(5255),
    [sym_update_expression] = STATE(5255),
    [sym_cast_expression] = STATE(5255),
    [sym_sizeof_expression] = STATE(5255),
    [sym_alignof_expression] = STATE(5255),
    [sym_offsetof_expression] = STATE(5255),
    [sym_generic_expression] = STATE(5255),
    [sym_subscript_expression] = STATE(3988),
    [sym_call_expression] = STATE(3988),
    [sym_gnu_asm_expression] = STATE(5255),
    [sym_field_expression] = STATE(3988),
    [sym_compound_literal_expression] = STATE(5255),
    [sym_parenthesized_expression] = STATE(3988),
    [sym_char_literal] = STATE(5164),
    [sym_concatenated_string] = STATE(5162),
    [sym_string_literal] = STATE(4081),
    [sym_null] = STATE(5255),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5255),
    [sym_raw_string_literal] = STATE(4060),
    [sym_co_await_expression] = STATE(5255),
    [sym_new_expression] = STATE(5255),
    [sym_delete_expression] = STATE(5255),
    [sym_requires_clause] = STATE(5255),
    [sym_requires_expression] = STATE(5255),
    [sym_lambda_expression] = STATE(5255),
    [sym_lambda_capture_specifier] = STATE(6164),
    [sym_fold_expression] = STATE(5255),
    [sym_parameter_pack_expansion] = STATE(5255),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3988),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3988),
    [sym_kernel_call_expression] = STATE(5260),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4486),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3718),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4452),
    [anon_sym_PLUS_PLUS] = ACTIONS(4452),
    [anon_sym_sizeof] = ACTIONS(3720),
    [anon_sym___alignof__] = ACTIONS(3722),
    [anon_sym___alignof] = ACTIONS(3722),
    [anon_sym__alignof] = ACTIONS(3722),
    [anon_sym_alignof] = ACTIONS(3722),
    [anon_sym__Alignof] = ACTIONS(3722),
    [anon_sym_offsetof] = ACTIONS(3724),
    [anon_sym__Generic] = ACTIONS(3726),
    [anon_sym_asm] = ACTIONS(3728),
    [anon_sym___asm__] = ACTIONS(3728),
    [sym_number_literal] = ACTIONS(3730),
    [anon_sym_L_SQUOTE] = ACTIONS(3732),
    [anon_sym_u_SQUOTE] = ACTIONS(3732),
    [anon_sym_U_SQUOTE] = ACTIONS(3732),
    [anon_sym_u8_SQUOTE] = ACTIONS(3732),
    [anon_sym_SQUOTE] = ACTIONS(3732),
    [anon_sym_L_DQUOTE] = ACTIONS(3734),
    [anon_sym_u_DQUOTE] = ACTIONS(3734),
    [anon_sym_U_DQUOTE] = ACTIONS(3734),
    [anon_sym_u8_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [sym_true] = ACTIONS(3736),
    [sym_false] = ACTIONS(3736),
    [anon_sym_NULL] = ACTIONS(3738),
    [anon_sym_nullptr] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3740),
    [anon_sym_R_DQUOTE] = ACTIONS(3742),
    [anon_sym_LR_DQUOTE] = ACTIONS(3742),
    [anon_sym_uR_DQUOTE] = ACTIONS(3742),
    [anon_sym_UR_DQUOTE] = ACTIONS(3742),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3742),
    [anon_sym_co_await] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3748),
    [sym_this] = ACTIONS(3736),
  },
  [1624] = {
    [sym_expression] = STATE(4759),
    [sym__string] = STATE(5255),
    [sym_conditional_expression] = STATE(5255),
    [sym_assignment_expression] = STATE(5255),
    [sym_pointer_expression] = STATE(3988),
    [sym_unary_expression] = STATE(5255),
    [sym_binary_expression] = STATE(5255),
    [sym_update_expression] = STATE(5255),
    [sym_cast_expression] = STATE(5255),
    [sym_sizeof_expression] = STATE(5255),
    [sym_alignof_expression] = STATE(5255),
    [sym_offsetof_expression] = STATE(5255),
    [sym_generic_expression] = STATE(5255),
    [sym_subscript_expression] = STATE(3988),
    [sym_call_expression] = STATE(3988),
    [sym_gnu_asm_expression] = STATE(5255),
    [sym_field_expression] = STATE(3988),
    [sym_compound_literal_expression] = STATE(5255),
    [sym_parenthesized_expression] = STATE(3988),
    [sym_char_literal] = STATE(5164),
    [sym_concatenated_string] = STATE(5162),
    [sym_string_literal] = STATE(4081),
    [sym_null] = STATE(5255),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5255),
    [sym_raw_string_literal] = STATE(4060),
    [sym_co_await_expression] = STATE(5255),
    [sym_new_expression] = STATE(5255),
    [sym_delete_expression] = STATE(5255),
    [sym_requires_clause] = STATE(5255),
    [sym_requires_expression] = STATE(5255),
    [sym_lambda_expression] = STATE(5255),
    [sym_lambda_capture_specifier] = STATE(6164),
    [sym_fold_expression] = STATE(5255),
    [sym_parameter_pack_expansion] = STATE(5255),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3988),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3988),
    [sym_kernel_call_expression] = STATE(5260),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4486),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3718),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4452),
    [anon_sym_PLUS_PLUS] = ACTIONS(4452),
    [anon_sym_sizeof] = ACTIONS(3720),
    [anon_sym___alignof__] = ACTIONS(3722),
    [anon_sym___alignof] = ACTIONS(3722),
    [anon_sym__alignof] = ACTIONS(3722),
    [anon_sym_alignof] = ACTIONS(3722),
    [anon_sym__Alignof] = ACTIONS(3722),
    [anon_sym_offsetof] = ACTIONS(3724),
    [anon_sym__Generic] = ACTIONS(3726),
    [anon_sym_asm] = ACTIONS(3728),
    [anon_sym___asm__] = ACTIONS(3728),
    [sym_number_literal] = ACTIONS(3730),
    [anon_sym_L_SQUOTE] = ACTIONS(3732),
    [anon_sym_u_SQUOTE] = ACTIONS(3732),
    [anon_sym_U_SQUOTE] = ACTIONS(3732),
    [anon_sym_u8_SQUOTE] = ACTIONS(3732),
    [anon_sym_SQUOTE] = ACTIONS(3732),
    [anon_sym_L_DQUOTE] = ACTIONS(3734),
    [anon_sym_u_DQUOTE] = ACTIONS(3734),
    [anon_sym_U_DQUOTE] = ACTIONS(3734),
    [anon_sym_u8_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [sym_true] = ACTIONS(3736),
    [sym_false] = ACTIONS(3736),
    [anon_sym_NULL] = ACTIONS(3738),
    [anon_sym_nullptr] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3740),
    [anon_sym_R_DQUOTE] = ACTIONS(3742),
    [anon_sym_LR_DQUOTE] = ACTIONS(3742),
    [anon_sym_uR_DQUOTE] = ACTIONS(3742),
    [anon_sym_UR_DQUOTE] = ACTIONS(3742),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3742),
    [anon_sym_co_await] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3748),
    [sym_this] = ACTIONS(3736),
  },
  [1625] = {
    [sym_expression] = STATE(4864),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1626] = {
    [sym_expression] = STATE(3423),
    [sym__string] = STATE(3926),
    [sym_conditional_expression] = STATE(3926),
    [sym_assignment_expression] = STATE(3926),
    [sym_pointer_expression] = STATE(3934),
    [sym_unary_expression] = STATE(3926),
    [sym_binary_expression] = STATE(3926),
    [sym_update_expression] = STATE(3926),
    [sym_cast_expression] = STATE(3926),
    [sym_sizeof_expression] = STATE(3926),
    [sym_alignof_expression] = STATE(3926),
    [sym_offsetof_expression] = STATE(3926),
    [sym_generic_expression] = STATE(3926),
    [sym_subscript_expression] = STATE(3934),
    [sym_call_expression] = STATE(3934),
    [sym_gnu_asm_expression] = STATE(3926),
    [sym_field_expression] = STATE(3934),
    [sym_compound_literal_expression] = STATE(3926),
    [sym_parenthesized_expression] = STATE(3934),
    [sym_char_literal] = STATE(3755),
    [sym_concatenated_string] = STATE(3759),
    [sym_string_literal] = STATE(2463),
    [sym_null] = STATE(3926),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7876),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3926),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3926),
    [sym_new_expression] = STATE(3926),
    [sym_delete_expression] = STATE(3926),
    [sym_requires_clause] = STATE(3926),
    [sym_requires_expression] = STATE(3926),
    [sym_lambda_expression] = STATE(3926),
    [sym_lambda_capture_specifier] = STATE(6169),
    [sym_fold_expression] = STATE(3926),
    [sym_parameter_pack_expansion] = STATE(3926),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3934),
    [sym_qualified_type_identifier] = STATE(7876),
    [sym_user_defined_literal] = STATE(3934),
    [sym_kernel_call_expression] = STATE(3930),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(4518),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3291),
    [anon_sym_not] = ACTIONS(3283),
    [anon_sym_compl] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(4351),
    [anon_sym_PLUS_PLUS] = ACTIONS(4351),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3295),
    [anon_sym___alignof] = ACTIONS(3295),
    [anon_sym__alignof] = ACTIONS(3295),
    [anon_sym_alignof] = ACTIONS(3295),
    [anon_sym__Alignof] = ACTIONS(3295),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3299),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [sym_number_literal] = ACTIONS(3303),
    [anon_sym_L_SQUOTE] = ACTIONS(3305),
    [anon_sym_u_SQUOTE] = ACTIONS(3305),
    [anon_sym_U_SQUOTE] = ACTIONS(3305),
    [anon_sym_u8_SQUOTE] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_L_DQUOTE] = ACTIONS(3307),
    [anon_sym_u_DQUOTE] = ACTIONS(3307),
    [anon_sym_U_DQUOTE] = ACTIONS(3307),
    [anon_sym_u8_DQUOTE] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [anon_sym_NULL] = ACTIONS(3311),
    [anon_sym_nullptr] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_R_DQUOTE] = ACTIONS(3315),
    [anon_sym_LR_DQUOTE] = ACTIONS(3315),
    [anon_sym_uR_DQUOTE] = ACTIONS(3315),
    [anon_sym_UR_DQUOTE] = ACTIONS(3315),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3315),
    [anon_sym_co_await] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_requires] = ACTIONS(3321),
    [sym_this] = ACTIONS(3309),
  },
  [1627] = {
    [sym_expression] = STATE(3414),
    [sym__string] = STATE(3926),
    [sym_conditional_expression] = STATE(3926),
    [sym_assignment_expression] = STATE(3926),
    [sym_pointer_expression] = STATE(3934),
    [sym_unary_expression] = STATE(3926),
    [sym_binary_expression] = STATE(3926),
    [sym_update_expression] = STATE(3926),
    [sym_cast_expression] = STATE(3926),
    [sym_sizeof_expression] = STATE(3926),
    [sym_alignof_expression] = STATE(3926),
    [sym_offsetof_expression] = STATE(3926),
    [sym_generic_expression] = STATE(3926),
    [sym_subscript_expression] = STATE(3934),
    [sym_call_expression] = STATE(3934),
    [sym_gnu_asm_expression] = STATE(3926),
    [sym_field_expression] = STATE(3934),
    [sym_compound_literal_expression] = STATE(3926),
    [sym_parenthesized_expression] = STATE(3934),
    [sym_char_literal] = STATE(3755),
    [sym_concatenated_string] = STATE(3759),
    [sym_string_literal] = STATE(2463),
    [sym_null] = STATE(3926),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7876),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3926),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3926),
    [sym_new_expression] = STATE(3926),
    [sym_delete_expression] = STATE(3926),
    [sym_requires_clause] = STATE(3926),
    [sym_requires_expression] = STATE(3926),
    [sym_lambda_expression] = STATE(3926),
    [sym_lambda_capture_specifier] = STATE(6169),
    [sym_fold_expression] = STATE(3926),
    [sym_parameter_pack_expansion] = STATE(3926),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3934),
    [sym_qualified_type_identifier] = STATE(7876),
    [sym_user_defined_literal] = STATE(3934),
    [sym_kernel_call_expression] = STATE(3930),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(4518),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(4832),
    [sym_primitive_type] = ACTIONS(3291),
    [anon_sym_not] = ACTIONS(3283),
    [anon_sym_compl] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(4351),
    [anon_sym_PLUS_PLUS] = ACTIONS(4351),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3295),
    [anon_sym___alignof] = ACTIONS(3295),
    [anon_sym__alignof] = ACTIONS(3295),
    [anon_sym_alignof] = ACTIONS(3295),
    [anon_sym__Alignof] = ACTIONS(3295),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3299),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [sym_number_literal] = ACTIONS(3303),
    [anon_sym_L_SQUOTE] = ACTIONS(3305),
    [anon_sym_u_SQUOTE] = ACTIONS(3305),
    [anon_sym_U_SQUOTE] = ACTIONS(3305),
    [anon_sym_u8_SQUOTE] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_L_DQUOTE] = ACTIONS(3307),
    [anon_sym_u_DQUOTE] = ACTIONS(3307),
    [anon_sym_U_DQUOTE] = ACTIONS(3307),
    [anon_sym_u8_DQUOTE] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [anon_sym_NULL] = ACTIONS(3311),
    [anon_sym_nullptr] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_R_DQUOTE] = ACTIONS(3315),
    [anon_sym_LR_DQUOTE] = ACTIONS(3315),
    [anon_sym_uR_DQUOTE] = ACTIONS(3315),
    [anon_sym_UR_DQUOTE] = ACTIONS(3315),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3315),
    [anon_sym_co_await] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_requires] = ACTIONS(3321),
    [sym_this] = ACTIONS(3309),
  },
  [1628] = {
    [sym_expression] = STATE(4975),
    [sym__string] = STATE(5255),
    [sym_conditional_expression] = STATE(5255),
    [sym_assignment_expression] = STATE(5255),
    [sym_pointer_expression] = STATE(3988),
    [sym_unary_expression] = STATE(5255),
    [sym_binary_expression] = STATE(5255),
    [sym_update_expression] = STATE(5255),
    [sym_cast_expression] = STATE(5255),
    [sym_sizeof_expression] = STATE(5255),
    [sym_alignof_expression] = STATE(5255),
    [sym_offsetof_expression] = STATE(5255),
    [sym_generic_expression] = STATE(5255),
    [sym_subscript_expression] = STATE(3988),
    [sym_call_expression] = STATE(3988),
    [sym_gnu_asm_expression] = STATE(5255),
    [sym_field_expression] = STATE(3988),
    [sym_compound_literal_expression] = STATE(5255),
    [sym_parenthesized_expression] = STATE(3988),
    [sym_char_literal] = STATE(5164),
    [sym_concatenated_string] = STATE(5162),
    [sym_string_literal] = STATE(4081),
    [sym_null] = STATE(5255),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5255),
    [sym_raw_string_literal] = STATE(4060),
    [sym_co_await_expression] = STATE(5255),
    [sym_new_expression] = STATE(5255),
    [sym_delete_expression] = STATE(5255),
    [sym_requires_clause] = STATE(5255),
    [sym_requires_expression] = STATE(5255),
    [sym_lambda_expression] = STATE(5255),
    [sym_lambda_capture_specifier] = STATE(6164),
    [sym_fold_expression] = STATE(5255),
    [sym_parameter_pack_expansion] = STATE(5255),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3988),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3988),
    [sym_kernel_call_expression] = STATE(5260),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4486),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3718),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4452),
    [anon_sym_PLUS_PLUS] = ACTIONS(4452),
    [anon_sym_sizeof] = ACTIONS(3720),
    [anon_sym___alignof__] = ACTIONS(3722),
    [anon_sym___alignof] = ACTIONS(3722),
    [anon_sym__alignof] = ACTIONS(3722),
    [anon_sym_alignof] = ACTIONS(3722),
    [anon_sym__Alignof] = ACTIONS(3722),
    [anon_sym_offsetof] = ACTIONS(3724),
    [anon_sym__Generic] = ACTIONS(3726),
    [anon_sym_asm] = ACTIONS(3728),
    [anon_sym___asm__] = ACTIONS(3728),
    [sym_number_literal] = ACTIONS(3730),
    [anon_sym_L_SQUOTE] = ACTIONS(3732),
    [anon_sym_u_SQUOTE] = ACTIONS(3732),
    [anon_sym_U_SQUOTE] = ACTIONS(3732),
    [anon_sym_u8_SQUOTE] = ACTIONS(3732),
    [anon_sym_SQUOTE] = ACTIONS(3732),
    [anon_sym_L_DQUOTE] = ACTIONS(3734),
    [anon_sym_u_DQUOTE] = ACTIONS(3734),
    [anon_sym_U_DQUOTE] = ACTIONS(3734),
    [anon_sym_u8_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [sym_true] = ACTIONS(3736),
    [sym_false] = ACTIONS(3736),
    [anon_sym_NULL] = ACTIONS(3738),
    [anon_sym_nullptr] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3740),
    [anon_sym_R_DQUOTE] = ACTIONS(3742),
    [anon_sym_LR_DQUOTE] = ACTIONS(3742),
    [anon_sym_uR_DQUOTE] = ACTIONS(3742),
    [anon_sym_UR_DQUOTE] = ACTIONS(3742),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3742),
    [anon_sym_co_await] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3748),
    [sym_this] = ACTIONS(3736),
  },
  [1629] = {
    [sym_expression] = STATE(4761),
    [sym__string] = STATE(5255),
    [sym_conditional_expression] = STATE(5255),
    [sym_assignment_expression] = STATE(5255),
    [sym_pointer_expression] = STATE(3988),
    [sym_unary_expression] = STATE(5255),
    [sym_binary_expression] = STATE(5255),
    [sym_update_expression] = STATE(5255),
    [sym_cast_expression] = STATE(5255),
    [sym_sizeof_expression] = STATE(5255),
    [sym_alignof_expression] = STATE(5255),
    [sym_offsetof_expression] = STATE(5255),
    [sym_generic_expression] = STATE(5255),
    [sym_subscript_expression] = STATE(3988),
    [sym_call_expression] = STATE(3988),
    [sym_gnu_asm_expression] = STATE(5255),
    [sym_field_expression] = STATE(3988),
    [sym_compound_literal_expression] = STATE(5255),
    [sym_parenthesized_expression] = STATE(3988),
    [sym_char_literal] = STATE(5164),
    [sym_concatenated_string] = STATE(5162),
    [sym_string_literal] = STATE(4081),
    [sym_null] = STATE(5255),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5255),
    [sym_raw_string_literal] = STATE(4060),
    [sym_co_await_expression] = STATE(5255),
    [sym_new_expression] = STATE(5255),
    [sym_delete_expression] = STATE(5255),
    [sym_requires_clause] = STATE(5255),
    [sym_requires_expression] = STATE(5255),
    [sym_lambda_expression] = STATE(5255),
    [sym_lambda_capture_specifier] = STATE(6164),
    [sym_fold_expression] = STATE(5255),
    [sym_parameter_pack_expansion] = STATE(5255),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3988),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3988),
    [sym_kernel_call_expression] = STATE(5260),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4486),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3718),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4452),
    [anon_sym_PLUS_PLUS] = ACTIONS(4452),
    [anon_sym_sizeof] = ACTIONS(3720),
    [anon_sym___alignof__] = ACTIONS(3722),
    [anon_sym___alignof] = ACTIONS(3722),
    [anon_sym__alignof] = ACTIONS(3722),
    [anon_sym_alignof] = ACTIONS(3722),
    [anon_sym__Alignof] = ACTIONS(3722),
    [anon_sym_offsetof] = ACTIONS(3724),
    [anon_sym__Generic] = ACTIONS(3726),
    [anon_sym_asm] = ACTIONS(3728),
    [anon_sym___asm__] = ACTIONS(3728),
    [sym_number_literal] = ACTIONS(3730),
    [anon_sym_L_SQUOTE] = ACTIONS(3732),
    [anon_sym_u_SQUOTE] = ACTIONS(3732),
    [anon_sym_U_SQUOTE] = ACTIONS(3732),
    [anon_sym_u8_SQUOTE] = ACTIONS(3732),
    [anon_sym_SQUOTE] = ACTIONS(3732),
    [anon_sym_L_DQUOTE] = ACTIONS(3734),
    [anon_sym_u_DQUOTE] = ACTIONS(3734),
    [anon_sym_U_DQUOTE] = ACTIONS(3734),
    [anon_sym_u8_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [sym_true] = ACTIONS(3736),
    [sym_false] = ACTIONS(3736),
    [anon_sym_NULL] = ACTIONS(3738),
    [anon_sym_nullptr] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3740),
    [anon_sym_R_DQUOTE] = ACTIONS(3742),
    [anon_sym_LR_DQUOTE] = ACTIONS(3742),
    [anon_sym_uR_DQUOTE] = ACTIONS(3742),
    [anon_sym_UR_DQUOTE] = ACTIONS(3742),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3742),
    [anon_sym_co_await] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3748),
    [sym_this] = ACTIONS(3736),
  },
  [1630] = {
    [sym_expression] = STATE(4785),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1631] = {
    [sym_expression] = STATE(4765),
    [sym__string] = STATE(5255),
    [sym_conditional_expression] = STATE(5255),
    [sym_assignment_expression] = STATE(5255),
    [sym_pointer_expression] = STATE(3988),
    [sym_unary_expression] = STATE(5255),
    [sym_binary_expression] = STATE(5255),
    [sym_update_expression] = STATE(5255),
    [sym_cast_expression] = STATE(5255),
    [sym_sizeof_expression] = STATE(5255),
    [sym_alignof_expression] = STATE(5255),
    [sym_offsetof_expression] = STATE(5255),
    [sym_generic_expression] = STATE(5255),
    [sym_subscript_expression] = STATE(3988),
    [sym_call_expression] = STATE(3988),
    [sym_gnu_asm_expression] = STATE(5255),
    [sym_field_expression] = STATE(3988),
    [sym_compound_literal_expression] = STATE(5255),
    [sym_parenthesized_expression] = STATE(3988),
    [sym_char_literal] = STATE(5164),
    [sym_concatenated_string] = STATE(5162),
    [sym_string_literal] = STATE(4081),
    [sym_null] = STATE(5255),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(5255),
    [sym_raw_string_literal] = STATE(4060),
    [sym_co_await_expression] = STATE(5255),
    [sym_new_expression] = STATE(5255),
    [sym_delete_expression] = STATE(5255),
    [sym_requires_clause] = STATE(5255),
    [sym_requires_expression] = STATE(5255),
    [sym_lambda_expression] = STATE(5255),
    [sym_lambda_capture_specifier] = STATE(6164),
    [sym_fold_expression] = STATE(5255),
    [sym_parameter_pack_expansion] = STATE(5255),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5936),
    [sym_qualified_identifier] = STATE(3988),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3988),
    [sym_kernel_call_expression] = STATE(5260),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4486),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_COLON_COLON] = ACTIONS(3714),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3718),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4452),
    [anon_sym_PLUS_PLUS] = ACTIONS(4452),
    [anon_sym_sizeof] = ACTIONS(3720),
    [anon_sym___alignof__] = ACTIONS(3722),
    [anon_sym___alignof] = ACTIONS(3722),
    [anon_sym__alignof] = ACTIONS(3722),
    [anon_sym_alignof] = ACTIONS(3722),
    [anon_sym__Alignof] = ACTIONS(3722),
    [anon_sym_offsetof] = ACTIONS(3724),
    [anon_sym__Generic] = ACTIONS(3726),
    [anon_sym_asm] = ACTIONS(3728),
    [anon_sym___asm__] = ACTIONS(3728),
    [sym_number_literal] = ACTIONS(3730),
    [anon_sym_L_SQUOTE] = ACTIONS(3732),
    [anon_sym_u_SQUOTE] = ACTIONS(3732),
    [anon_sym_U_SQUOTE] = ACTIONS(3732),
    [anon_sym_u8_SQUOTE] = ACTIONS(3732),
    [anon_sym_SQUOTE] = ACTIONS(3732),
    [anon_sym_L_DQUOTE] = ACTIONS(3734),
    [anon_sym_u_DQUOTE] = ACTIONS(3734),
    [anon_sym_U_DQUOTE] = ACTIONS(3734),
    [anon_sym_u8_DQUOTE] = ACTIONS(3734),
    [anon_sym_DQUOTE] = ACTIONS(3734),
    [sym_true] = ACTIONS(3736),
    [sym_false] = ACTIONS(3736),
    [anon_sym_NULL] = ACTIONS(3738),
    [anon_sym_nullptr] = ACTIONS(3738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3740),
    [anon_sym_R_DQUOTE] = ACTIONS(3742),
    [anon_sym_LR_DQUOTE] = ACTIONS(3742),
    [anon_sym_uR_DQUOTE] = ACTIONS(3742),
    [anon_sym_UR_DQUOTE] = ACTIONS(3742),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3742),
    [anon_sym_co_await] = ACTIONS(3744),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_requires] = ACTIONS(3748),
    [sym_this] = ACTIONS(3736),
  },
  [1632] = {
    [sym_expression] = STATE(4823),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1633] = {
    [sym_expression] = STATE(4859),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1634] = {
    [sym_expression] = STATE(4753),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1635] = {
    [sym_expression] = STATE(5050),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1636] = {
    [sym_expression] = STATE(3245),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4539),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(3331),
    [anon_sym_compl] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(4365),
    [anon_sym_PLUS_PLUS] = ACTIONS(4365),
    [anon_sym_sizeof] = ACTIONS(3337),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3339),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1637] = {
    [sym_expression] = STATE(4530),
    [sym__string] = STATE(4266),
    [sym_conditional_expression] = STATE(4266),
    [sym_assignment_expression] = STATE(4266),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4266),
    [sym_binary_expression] = STATE(4266),
    [sym_update_expression] = STATE(4266),
    [sym_cast_expression] = STATE(4266),
    [sym_sizeof_expression] = STATE(4266),
    [sym_alignof_expression] = STATE(4266),
    [sym_offsetof_expression] = STATE(4266),
    [sym_generic_expression] = STATE(4266),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4266),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4266),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4613),
    [sym_concatenated_string] = STATE(4554),
    [sym_string_literal] = STATE(3410),
    [sym_null] = STATE(4266),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8005),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(4266),
    [sym_raw_string_literal] = STATE(3401),
    [sym_co_await_expression] = STATE(4266),
    [sym_new_expression] = STATE(4266),
    [sym_delete_expression] = STATE(4266),
    [sym_requires_clause] = STATE(4266),
    [sym_requires_expression] = STATE(4266),
    [sym_lambda_expression] = STATE(4266),
    [sym_lambda_capture_specifier] = STATE(6182),
    [sym_fold_expression] = STATE(4266),
    [sym_parameter_pack_expansion] = STATE(4266),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8005),
    [sym_user_defined_literal] = STATE(3538),
    [sym_kernel_call_expression] = STATE(4260),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1232),
    [anon_sym_AMP] = ACTIONS(1232),
    [anon_sym_COLON_COLON] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2590),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_sizeof] = ACTIONS(101),
    [anon_sym___alignof__] = ACTIONS(103),
    [anon_sym___alignof] = ACTIONS(103),
    [anon_sym__alignof] = ACTIONS(103),
    [anon_sym_alignof] = ACTIONS(103),
    [anon_sym__Alignof] = ACTIONS(103),
    [anon_sym_offsetof] = ACTIONS(105),
    [anon_sym__Generic] = ACTIONS(107),
    [anon_sym_asm] = ACTIONS(109),
    [anon_sym___asm__] = ACTIONS(109),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(113),
    [anon_sym_u_SQUOTE] = ACTIONS(113),
    [anon_sym_U_SQUOTE] = ACTIONS(113),
    [anon_sym_u8_SQUOTE] = ACTIONS(113),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [anon_sym_L_DQUOTE] = ACTIONS(115),
    [anon_sym_u_DQUOTE] = ACTIONS(115),
    [anon_sym_U_DQUOTE] = ACTIONS(115),
    [anon_sym_u8_DQUOTE] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(119),
    [anon_sym_nullptr] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(135),
    [anon_sym_R_DQUOTE] = ACTIONS(151),
    [anon_sym_LR_DQUOTE] = ACTIONS(151),
    [anon_sym_uR_DQUOTE] = ACTIONS(151),
    [anon_sym_UR_DQUOTE] = ACTIONS(151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(151),
    [anon_sym_co_await] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(155),
    [anon_sym_requires] = ACTIONS(157),
    [sym_this] = ACTIONS(221),
  },
  [1638] = {
    [sym_expression] = STATE(3462),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4539),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(3331),
    [anon_sym_compl] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(4365),
    [anon_sym_PLUS_PLUS] = ACTIONS(4365),
    [anon_sym_sizeof] = ACTIONS(3337),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3339),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1639] = {
    [sym_expression] = STATE(3464),
    [sym__string] = STATE(2628),
    [sym_conditional_expression] = STATE(2628),
    [sym_assignment_expression] = STATE(2628),
    [sym_pointer_expression] = STATE(2636),
    [sym_unary_expression] = STATE(2628),
    [sym_binary_expression] = STATE(2628),
    [sym_update_expression] = STATE(2628),
    [sym_cast_expression] = STATE(2628),
    [sym_sizeof_expression] = STATE(2628),
    [sym_alignof_expression] = STATE(2628),
    [sym_offsetof_expression] = STATE(2628),
    [sym_generic_expression] = STATE(2628),
    [sym_subscript_expression] = STATE(2636),
    [sym_call_expression] = STATE(2636),
    [sym_gnu_asm_expression] = STATE(2628),
    [sym_field_expression] = STATE(2636),
    [sym_compound_literal_expression] = STATE(2628),
    [sym_parenthesized_expression] = STATE(2636),
    [sym_char_literal] = STATE(3046),
    [sym_concatenated_string] = STATE(3057),
    [sym_string_literal] = STATE(2255),
    [sym_null] = STATE(2628),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(8097),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(2628),
    [sym_raw_string_literal] = STATE(2279),
    [sym_co_await_expression] = STATE(2628),
    [sym_new_expression] = STATE(2628),
    [sym_delete_expression] = STATE(2628),
    [sym_requires_clause] = STATE(2628),
    [sym_requires_expression] = STATE(2628),
    [sym_lambda_expression] = STATE(2628),
    [sym_lambda_capture_specifier] = STATE(6215),
    [sym_fold_expression] = STATE(2628),
    [sym_parameter_pack_expansion] = STATE(2628),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5891),
    [sym_qualified_identifier] = STATE(2636),
    [sym_qualified_type_identifier] = STATE(8097),
    [sym_user_defined_literal] = STATE(2636),
    [sym_kernel_call_expression] = STATE(2632),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_LPAREN2] = ACTIONS(4539),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(4478),
    [anon_sym_AMP] = ACTIONS(4478),
    [anon_sym_COLON_COLON] = ACTIONS(3335),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(3331),
    [anon_sym_compl] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(4365),
    [anon_sym_PLUS_PLUS] = ACTIONS(4365),
    [anon_sym_sizeof] = ACTIONS(3337),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2526),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2530),
    [anon_sym___asm__] = ACTIONS(2530),
    [sym_number_literal] = ACTIONS(2568),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2572),
    [anon_sym_u_DQUOTE] = ACTIONS(2572),
    [anon_sym_U_DQUOTE] = ACTIONS(2572),
    [anon_sym_u8_DQUOTE] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3339),
    [anon_sym_R_DQUOTE] = ACTIONS(2576),
    [anon_sym_LR_DQUOTE] = ACTIONS(2576),
    [anon_sym_uR_DQUOTE] = ACTIONS(2576),
    [anon_sym_UR_DQUOTE] = ACTIONS(2576),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2576),
    [anon_sym_co_await] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2538),
  },
  [1640] = {
    [sym_expression] = STATE(3376),
    [sym__string] = STATE(3926),
    [sym_conditional_expression] = STATE(3926),
    [sym_assignment_expression] = STATE(3926),
    [sym_pointer_expression] = STATE(3934),
    [sym_unary_expression] = STATE(3926),
    [sym_binary_expression] = STATE(3926),
    [sym_update_expression] = STATE(3926),
    [sym_cast_expression] = STATE(3926),
    [sym_sizeof_expression] = STATE(3926),
    [sym_alignof_expression] = STATE(3926),
    [sym_offsetof_expression] = STATE(3926),
    [sym_generic_expression] = STATE(3926),
    [sym_subscript_expression] = STATE(3934),
    [sym_call_expression] = STATE(3934),
    [sym_gnu_asm_expression] = STATE(3926),
    [sym_field_expression] = STATE(3934),
    [sym_compound_literal_expression] = STATE(3926),
    [sym_parenthesized_expression] = STATE(3934),
    [sym_char_literal] = STATE(3755),
    [sym_concatenated_string] = STATE(3759),
    [sym_string_literal] = STATE(2463),
    [sym_null] = STATE(3926),
    [sym_decltype] = STATE(8628),
    [sym__class_name] = STATE(7876),
    [sym_template_type] = STATE(2113),
    [sym_template_function] = STATE(3926),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3926),
    [sym_new_expression] = STATE(3926),
    [sym_delete_expression] = STATE(3926),
    [sym_requires_clause] = STATE(3926),
    [sym_requires_expression] = STATE(3926),
    [sym_lambda_expression] = STATE(3926),
    [sym_lambda_capture_specifier] = STATE(6169),
    [sym_fold_expression] = STATE(3926),
    [sym_parameter_pack_expansion] = STATE(3926),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5941),
    [sym_qualified_identifier] = STATE(3934),
    [sym_qualified_type_identifier] = STATE(7876),
    [sym_user_defined_literal] = STATE(3934),
    [sym_kernel_call_expression] = STATE(3930),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_LPAREN2] = ACTIONS(4518),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_COLON_COLON] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [sym_primitive_type] = ACTIONS(3291),
    [anon_sym_not] = ACTIONS(3283),
    [anon_sym_compl] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(4351),
    [anon_sym_PLUS_PLUS] = ACTIONS(4351),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym___alignof__] = ACTIONS(3295),
    [anon_sym___alignof] = ACTIONS(3295),
    [anon_sym__alignof] = ACTIONS(3295),
    [anon_sym_alignof] = ACTIONS(3295),
    [anon_sym__Alignof] = ACTIONS(3295),
    [anon_sym_offsetof] = ACTIONS(3297),
    [anon_sym__Generic] = ACTIONS(3299),
    [anon_sym_asm] = ACTIONS(3301),
    [anon_sym___asm__] = ACTIONS(3301),
    [sym_number_literal] = ACTIONS(3303),
    [anon_sym_L_SQUOTE] = ACTIONS(3305),
    [anon_sym_u_SQUOTE] = ACTIONS(3305),
    [anon_sym_U_SQUOTE] = ACTIONS(3305),
    [anon_sym_u8_SQUOTE] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_L_DQUOTE] = ACTIONS(3307),
    [anon_sym_u_DQUOTE] = ACTIONS(3307),
    [anon_sym_U_DQUOTE] = ACTIONS(3307),
    [anon_sym_u8_DQUOTE] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [anon_sym_NULL] = ACTIONS(3311),
    [anon_sym_nullptr] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_delete] = ACTIONS(3313),
    [anon_sym_R_DQUOTE] = ACTIONS(3315),
    [anon_sym_LR_DQUOTE] = ACTIONS(3315),
    [anon_sym_uR_DQUOTE] = ACTIONS(3315),
    [anon_sym_UR_DQUOTE] = ACTIONS(3315),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3315),
    [anon_sym_co_await] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_requires] = ACTIONS(3321),
    [sym_this] = ACTIONS(3309),
  },
  [1641] = {
    [sym_string_literal] = STATE(2291),
    [sym_template_argument_list] = STATE(1852),
    [sym_raw_string_literal] = STATE(2291),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2132),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_RPAREN] = ACTIONS(3771),
    [anon_sym_LPAREN2] = ACTIONS(3771),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3768),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3771),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(4834),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym___extension__] = ACTIONS(3764),
    [anon_sym___global__] = ACTIONS(3764),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_signed] = ACTIONS(4812),
    [anon_sym_unsigned] = ACTIONS(4812),
    [anon_sym_long] = ACTIONS(4812),
    [anon_sym_short] = ACTIONS(4812),
    [anon_sym_LBRACK] = ACTIONS(3771),
    [anon_sym_EQ] = ACTIONS(3766),
    [anon_sym_const] = ACTIONS(3756),
    [anon_sym_constexpr] = ACTIONS(3764),
    [anon_sym_volatile] = ACTIONS(3764),
    [anon_sym_restrict] = ACTIONS(3764),
    [anon_sym___restrict__] = ACTIONS(3764),
    [anon_sym__Atomic] = ACTIONS(3764),
    [anon_sym__Noreturn] = ACTIONS(3764),
    [anon_sym_noreturn] = ACTIONS(3764),
    [anon_sym_mutable] = ACTIONS(3764),
    [anon_sym_constinit] = ACTIONS(3764),
    [anon_sym_consteval] = ACTIONS(3764),
    [anon_sym___shared__] = ACTIONS(3764),
    [anon_sym___local__] = ACTIONS(3764),
    [anon_sym___constant__] = ACTIONS(3764),
    [anon_sym___managed__] = ACTIONS(3764),
    [anon_sym___grid_constant__] = ACTIONS(3764),
    [anon_sym_alignas] = ACTIONS(3764),
    [anon_sym__Alignas] = ACTIONS(3764),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3758),
    [anon_sym_SLASH_EQ] = ACTIONS(3758),
    [anon_sym_PERCENT_EQ] = ACTIONS(3758),
    [anon_sym_PLUS_EQ] = ACTIONS(3758),
    [anon_sym_DASH_EQ] = ACTIONS(3758),
    [anon_sym_LT_LT_EQ] = ACTIONS(3758),
    [anon_sym_GT_GT_EQ] = ACTIONS(3758),
    [anon_sym_AMP_EQ] = ACTIONS(3758),
    [anon_sym_CARET_EQ] = ACTIONS(3758),
    [anon_sym_PIPE_EQ] = ACTIONS(3758),
    [anon_sym_and_eq] = ACTIONS(3758),
    [anon_sym_or_eq] = ACTIONS(3758),
    [anon_sym_xor_eq] = ACTIONS(3758),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3766),
    [anon_sym_L_DQUOTE] = ACTIONS(4814),
    [anon_sym_u_DQUOTE] = ACTIONS(4814),
    [anon_sym_U_DQUOTE] = ACTIONS(4814),
    [anon_sym_u8_DQUOTE] = ACTIONS(4814),
    [anon_sym_DQUOTE] = ACTIONS(4814),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3764),
    [anon_sym_decltype] = ACTIONS(3764),
    [anon_sym_R_DQUOTE] = ACTIONS(4816),
    [anon_sym_LR_DQUOTE] = ACTIONS(4816),
    [anon_sym_uR_DQUOTE] = ACTIONS(4816),
    [anon_sym_UR_DQUOTE] = ACTIONS(4816),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4816),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3758),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [1642] = {
    [sym_string_literal] = STATE(3772),
    [sym_template_argument_list] = STATE(2747),
    [sym_raw_string_literal] = STATE(3772),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2230),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3771),
    [anon_sym_COMMA] = ACTIONS(3771),
    [anon_sym_LPAREN2] = ACTIONS(3771),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3768),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3771),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3766),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(4837),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym___extension__] = ACTIONS(3764),
    [anon_sym___global__] = ACTIONS(3764),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_signed] = ACTIONS(4840),
    [anon_sym_unsigned] = ACTIONS(4840),
    [anon_sym_long] = ACTIONS(4840),
    [anon_sym_short] = ACTIONS(4840),
    [anon_sym_LBRACK] = ACTIONS(3771),
    [anon_sym_EQ] = ACTIONS(4842),
    [anon_sym_const] = ACTIONS(3756),
    [anon_sym_constexpr] = ACTIONS(3764),
    [anon_sym_volatile] = ACTIONS(3764),
    [anon_sym_restrict] = ACTIONS(3764),
    [anon_sym___restrict__] = ACTIONS(3764),
    [anon_sym__Atomic] = ACTIONS(3764),
    [anon_sym__Noreturn] = ACTIONS(3764),
    [anon_sym_noreturn] = ACTIONS(3764),
    [anon_sym_mutable] = ACTIONS(3764),
    [anon_sym_constinit] = ACTIONS(3764),
    [anon_sym_consteval] = ACTIONS(3764),
    [anon_sym___shared__] = ACTIONS(3764),
    [anon_sym___local__] = ACTIONS(3764),
    [anon_sym___constant__] = ACTIONS(3764),
    [anon_sym___managed__] = ACTIONS(3764),
    [anon_sym___grid_constant__] = ACTIONS(3764),
    [anon_sym_alignas] = ACTIONS(3764),
    [anon_sym__Alignas] = ACTIONS(3764),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(4844),
    [anon_sym_SLASH_EQ] = ACTIONS(4844),
    [anon_sym_PERCENT_EQ] = ACTIONS(4844),
    [anon_sym_PLUS_EQ] = ACTIONS(4844),
    [anon_sym_DASH_EQ] = ACTIONS(4844),
    [anon_sym_LT_LT_EQ] = ACTIONS(4844),
    [anon_sym_GT_GT_EQ] = ACTIONS(4842),
    [anon_sym_AMP_EQ] = ACTIONS(4844),
    [anon_sym_CARET_EQ] = ACTIONS(4844),
    [anon_sym_PIPE_EQ] = ACTIONS(4844),
    [anon_sym_and_eq] = ACTIONS(4844),
    [anon_sym_or_eq] = ACTIONS(4844),
    [anon_sym_xor_eq] = ACTIONS(4844),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(4846),
    [anon_sym_u_DQUOTE] = ACTIONS(4846),
    [anon_sym_U_DQUOTE] = ACTIONS(4846),
    [anon_sym_u8_DQUOTE] = ACTIONS(4846),
    [anon_sym_DQUOTE] = ACTIONS(4846),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3764),
    [anon_sym_decltype] = ACTIONS(3764),
    [anon_sym_GT2] = ACTIONS(3771),
    [anon_sym_R_DQUOTE] = ACTIONS(4848),
    [anon_sym_LR_DQUOTE] = ACTIONS(4848),
    [anon_sym_uR_DQUOTE] = ACTIONS(4848),
    [anon_sym_UR_DQUOTE] = ACTIONS(4848),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4848),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [1643] = {
    [sym_string_literal] = STATE(2752),
    [sym_template_argument_list] = STATE(2813),
    [sym_raw_string_literal] = STATE(2752),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2132),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_RPAREN] = ACTIONS(3771),
    [anon_sym_LPAREN2] = ACTIONS(3771),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3768),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3771),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(4850),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym___extension__] = ACTIONS(3764),
    [anon_sym___global__] = ACTIONS(3764),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_signed] = ACTIONS(4812),
    [anon_sym_unsigned] = ACTIONS(4812),
    [anon_sym_long] = ACTIONS(4812),
    [anon_sym_short] = ACTIONS(4812),
    [anon_sym_LBRACK] = ACTIONS(3771),
    [anon_sym_EQ] = ACTIONS(3790),
    [anon_sym_const] = ACTIONS(3756),
    [anon_sym_constexpr] = ACTIONS(3764),
    [anon_sym_volatile] = ACTIONS(3764),
    [anon_sym_restrict] = ACTIONS(3764),
    [anon_sym___restrict__] = ACTIONS(3764),
    [anon_sym__Atomic] = ACTIONS(3764),
    [anon_sym__Noreturn] = ACTIONS(3764),
    [anon_sym_noreturn] = ACTIONS(3764),
    [anon_sym_mutable] = ACTIONS(3764),
    [anon_sym_constinit] = ACTIONS(3764),
    [anon_sym_consteval] = ACTIONS(3764),
    [anon_sym___shared__] = ACTIONS(3764),
    [anon_sym___local__] = ACTIONS(3764),
    [anon_sym___constant__] = ACTIONS(3764),
    [anon_sym___managed__] = ACTIONS(3764),
    [anon_sym___grid_constant__] = ACTIONS(3764),
    [anon_sym_alignas] = ACTIONS(3764),
    [anon_sym__Alignas] = ACTIONS(3764),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3794),
    [anon_sym_SLASH_EQ] = ACTIONS(3794),
    [anon_sym_PERCENT_EQ] = ACTIONS(3794),
    [anon_sym_PLUS_EQ] = ACTIONS(3794),
    [anon_sym_DASH_EQ] = ACTIONS(3794),
    [anon_sym_LT_LT_EQ] = ACTIONS(3794),
    [anon_sym_GT_GT_EQ] = ACTIONS(3794),
    [anon_sym_AMP_EQ] = ACTIONS(3794),
    [anon_sym_CARET_EQ] = ACTIONS(3794),
    [anon_sym_PIPE_EQ] = ACTIONS(3794),
    [anon_sym_and_eq] = ACTIONS(3794),
    [anon_sym_or_eq] = ACTIONS(3794),
    [anon_sym_xor_eq] = ACTIONS(3794),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3764),
    [anon_sym_decltype] = ACTIONS(3764),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [1644] = {
    [sym_identifier] = ACTIONS(4142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4144),
    [anon_sym_COMMA] = ACTIONS(4144),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_TILDE] = ACTIONS(4149),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_STAR] = ACTIONS(4146),
    [anon_sym_SLASH] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4151),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_AMP] = ACTIONS(4153),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT] = ACTIONS(4151),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4151),
    [anon_sym_LT] = ACTIONS(4151),
    [anon_sym_LT_LT] = ACTIONS(4151),
    [anon_sym_GT_GT] = ACTIONS(4144),
    [anon_sym_SEMI] = ACTIONS(4146),
    [anon_sym___extension__] = ACTIONS(4142),
    [anon_sym___device__] = ACTIONS(4142),
    [anon_sym___host__] = ACTIONS(4142),
    [anon_sym___global__] = ACTIONS(4142),
    [anon_sym___forceinline__] = ACTIONS(4142),
    [anon_sym___noinline__] = ACTIONS(4142),
    [anon_sym_extern] = ACTIONS(4142),
    [anon_sym___attribute__] = ACTIONS(4142),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4146),
    [anon_sym___declspec] = ACTIONS(4142),
    [anon_sym___based] = ACTIONS(4142),
    [anon_sym___cdecl] = ACTIONS(4142),
    [anon_sym___clrcall] = ACTIONS(4142),
    [anon_sym___stdcall] = ACTIONS(4142),
    [anon_sym___fastcall] = ACTIONS(4142),
    [anon_sym___thiscall] = ACTIONS(4142),
    [anon_sym___vectorcall] = ACTIONS(4142),
    [anon_sym_LBRACE] = ACTIONS(4149),
    [anon_sym_RBRACE] = ACTIONS(4144),
    [anon_sym_LBRACK] = ACTIONS(4153),
    [anon_sym_static] = ACTIONS(4142),
    [anon_sym_register] = ACTIONS(4142),
    [anon_sym_inline] = ACTIONS(4142),
    [anon_sym___inline] = ACTIONS(4142),
    [anon_sym___inline__] = ACTIONS(4142),
    [anon_sym___forceinline] = ACTIONS(4142),
    [anon_sym_thread_local] = ACTIONS(4142),
    [anon_sym___thread] = ACTIONS(4142),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_constexpr] = ACTIONS(4142),
    [anon_sym_volatile] = ACTIONS(4142),
    [anon_sym_restrict] = ACTIONS(4142),
    [anon_sym___restrict__] = ACTIONS(4142),
    [anon_sym__Atomic] = ACTIONS(4142),
    [anon_sym__Noreturn] = ACTIONS(4142),
    [anon_sym_noreturn] = ACTIONS(4142),
    [anon_sym_mutable] = ACTIONS(4142),
    [anon_sym_constinit] = ACTIONS(4142),
    [anon_sym_consteval] = ACTIONS(4142),
    [anon_sym___shared__] = ACTIONS(4142),
    [anon_sym___local__] = ACTIONS(4142),
    [anon_sym___constant__] = ACTIONS(4142),
    [anon_sym___managed__] = ACTIONS(4142),
    [anon_sym___grid_constant__] = ACTIONS(4142),
    [anon_sym_alignas] = ACTIONS(4142),
    [anon_sym__Alignas] = ACTIONS(4142),
    [anon_sym_QMARK] = ACTIONS(4144),
    [anon_sym_LT_EQ_GT] = ACTIONS(4144),
    [anon_sym_or] = ACTIONS(4151),
    [anon_sym_and] = ACTIONS(4151),
    [anon_sym_bitor] = ACTIONS(4151),
    [anon_sym_xor] = ACTIONS(4151),
    [anon_sym_bitand] = ACTIONS(4151),
    [anon_sym_not_eq] = ACTIONS(4151),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_DOT_STAR] = ACTIONS(4144),
    [anon_sym_DASH_GT] = ACTIONS(4144),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4142),
    [anon_sym_decltype] = ACTIONS(4142),
    [sym_virtual] = ACTIONS(4142),
    [anon_sym_template] = ACTIONS(4142),
    [anon_sym_operator] = ACTIONS(4142),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4144),
    [anon_sym___launch_bounds__] = ACTIONS(4142),
  },
  [1645] = {
    [sym_function_definition] = STATE(588),
    [sym_declaration] = STATE(588),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_ms_call_modifier] = STATE(1835),
    [sym_declaration_list] = STATE(588),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6816),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4853),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(4857),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1646] = {
    [sym_function_definition] = STATE(717),
    [sym_declaration] = STATE(717),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5203),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_ms_call_modifier] = STATE(1822),
    [sym_declaration_list] = STATE(717),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6816),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4853),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(4859),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1647] = {
    [sym_function_definition] = STATE(525),
    [sym_declaration] = STATE(525),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5201),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_ms_call_modifier] = STATE(1837),
    [sym_declaration_list] = STATE(525),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6816),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4853),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(4861),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1648] = {
    [sym_function_definition] = STATE(186),
    [sym_declaration] = STATE(186),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5266),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_ms_call_modifier] = STATE(1824),
    [sym_declaration_list] = STATE(186),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6816),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4853),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(4863),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1649] = {
    [sym_function_definition] = STATE(546),
    [sym_declaration] = STATE(546),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5230),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_ms_call_modifier] = STATE(1835),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8836),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2929),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6816),
    [sym_qualified_type_identifier] = STATE(2925),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(4867),
    [anon_sym_struct] = ACTIONS(4869),
    [anon_sym_union] = ACTIONS(4871),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1650] = {
    [sym_identifier] = ACTIONS(3984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3986),
    [anon_sym_COMMA] = ACTIONS(3986),
    [anon_sym_RPAREN] = ACTIONS(3986),
    [aux_sym_preproc_if_token2] = ACTIONS(3986),
    [aux_sym_preproc_else_token1] = ACTIONS(3986),
    [aux_sym_preproc_elif_token1] = ACTIONS(3984),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3986),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3986),
    [anon_sym_LPAREN2] = ACTIONS(3986),
    [anon_sym_DASH] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(3984),
    [anon_sym_SLASH] = ACTIONS(3984),
    [anon_sym_PERCENT] = ACTIONS(3984),
    [anon_sym_PIPE_PIPE] = ACTIONS(3986),
    [anon_sym_AMP_AMP] = ACTIONS(3986),
    [anon_sym_PIPE] = ACTIONS(3984),
    [anon_sym_CARET] = ACTIONS(3984),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_EQ_EQ] = ACTIONS(3986),
    [anon_sym_BANG_EQ] = ACTIONS(3986),
    [anon_sym_GT] = ACTIONS(3984),
    [anon_sym_GT_EQ] = ACTIONS(3986),
    [anon_sym_LT_EQ] = ACTIONS(3984),
    [anon_sym_LT] = ACTIONS(3984),
    [anon_sym_LT_LT] = ACTIONS(3984),
    [anon_sym_GT_GT] = ACTIONS(3984),
    [anon_sym_SEMI] = ACTIONS(3986),
    [anon_sym___extension__] = ACTIONS(3984),
    [anon_sym___global__] = ACTIONS(3984),
    [anon_sym___attribute__] = ACTIONS(3984),
    [anon_sym_COLON_COLON] = ACTIONS(3986),
    [anon_sym_LBRACE] = ACTIONS(3986),
    [anon_sym_RBRACE] = ACTIONS(3986),
    [anon_sym_LBRACK] = ACTIONS(3986),
    [anon_sym_RBRACK] = ACTIONS(3986),
    [anon_sym_EQ] = ACTIONS(3984),
    [anon_sym_const] = ACTIONS(3984),
    [anon_sym_constexpr] = ACTIONS(3984),
    [anon_sym_volatile] = ACTIONS(3984),
    [anon_sym_restrict] = ACTIONS(3984),
    [anon_sym___restrict__] = ACTIONS(3984),
    [anon_sym__Atomic] = ACTIONS(3984),
    [anon_sym__Noreturn] = ACTIONS(3984),
    [anon_sym_noreturn] = ACTIONS(3984),
    [anon_sym_mutable] = ACTIONS(3984),
    [anon_sym_constinit] = ACTIONS(3984),
    [anon_sym_consteval] = ACTIONS(3984),
    [anon_sym___shared__] = ACTIONS(3984),
    [anon_sym___local__] = ACTIONS(3984),
    [anon_sym___constant__] = ACTIONS(3984),
    [anon_sym___managed__] = ACTIONS(3984),
    [anon_sym___grid_constant__] = ACTIONS(3984),
    [anon_sym_alignas] = ACTIONS(3984),
    [anon_sym__Alignas] = ACTIONS(3984),
    [anon_sym_COLON] = ACTIONS(3984),
    [anon_sym_QMARK] = ACTIONS(3986),
    [anon_sym_STAR_EQ] = ACTIONS(3986),
    [anon_sym_SLASH_EQ] = ACTIONS(3986),
    [anon_sym_PERCENT_EQ] = ACTIONS(3986),
    [anon_sym_PLUS_EQ] = ACTIONS(3986),
    [anon_sym_DASH_EQ] = ACTIONS(3986),
    [anon_sym_LT_LT_EQ] = ACTIONS(3986),
    [anon_sym_GT_GT_EQ] = ACTIONS(3986),
    [anon_sym_AMP_EQ] = ACTIONS(3986),
    [anon_sym_CARET_EQ] = ACTIONS(3986),
    [anon_sym_PIPE_EQ] = ACTIONS(3986),
    [anon_sym_and_eq] = ACTIONS(3984),
    [anon_sym_or_eq] = ACTIONS(3984),
    [anon_sym_xor_eq] = ACTIONS(3984),
    [anon_sym_LT_EQ_GT] = ACTIONS(3986),
    [anon_sym_or] = ACTIONS(3984),
    [anon_sym_and] = ACTIONS(3984),
    [anon_sym_bitor] = ACTIONS(3984),
    [anon_sym_xor] = ACTIONS(3984),
    [anon_sym_bitand] = ACTIONS(3984),
    [anon_sym_not_eq] = ACTIONS(3984),
    [anon_sym_DASH_DASH] = ACTIONS(3986),
    [anon_sym_PLUS_PLUS] = ACTIONS(3986),
    [anon_sym_DOT] = ACTIONS(3984),
    [anon_sym_DOT_STAR] = ACTIONS(3986),
    [anon_sym_DASH_GT] = ACTIONS(3986),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3984),
    [anon_sym_decltype] = ACTIONS(3984),
    [anon_sym_final] = ACTIONS(3984),
    [anon_sym_override] = ACTIONS(3984),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3986),
  },
  [1651] = {
    [sym_identifier] = ACTIONS(4142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4149),
    [anon_sym_COMMA] = ACTIONS(4149),
    [anon_sym_RPAREN] = ACTIONS(4149),
    [anon_sym_LPAREN2] = ACTIONS(4149),
    [anon_sym_TILDE] = ACTIONS(4149),
    [anon_sym_STAR] = ACTIONS(4149),
    [anon_sym_PIPE_PIPE] = ACTIONS(4149),
    [anon_sym_AMP_AMP] = ACTIONS(4149),
    [anon_sym_AMP] = ACTIONS(4142),
    [anon_sym_SEMI] = ACTIONS(4149),
    [anon_sym___extension__] = ACTIONS(4142),
    [anon_sym___device__] = ACTIONS(4142),
    [anon_sym___host__] = ACTIONS(4142),
    [anon_sym___global__] = ACTIONS(4142),
    [anon_sym___forceinline__] = ACTIONS(4142),
    [anon_sym___noinline__] = ACTIONS(4142),
    [anon_sym_extern] = ACTIONS(4142),
    [anon_sym___attribute__] = ACTIONS(4142),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4149),
    [anon_sym___declspec] = ACTIONS(4142),
    [anon_sym___based] = ACTIONS(4142),
    [anon_sym___cdecl] = ACTIONS(4142),
    [anon_sym___clrcall] = ACTIONS(4142),
    [anon_sym___stdcall] = ACTIONS(4142),
    [anon_sym___fastcall] = ACTIONS(4142),
    [anon_sym___thiscall] = ACTIONS(4142),
    [anon_sym___vectorcall] = ACTIONS(4142),
    [anon_sym_LBRACE] = ACTIONS(4149),
    [anon_sym_signed] = ACTIONS(4142),
    [anon_sym_unsigned] = ACTIONS(4142),
    [anon_sym_long] = ACTIONS(4142),
    [anon_sym_short] = ACTIONS(4142),
    [anon_sym_LBRACK] = ACTIONS(4142),
    [anon_sym_static] = ACTIONS(4142),
    [anon_sym_EQ] = ACTIONS(4149),
    [anon_sym_register] = ACTIONS(4142),
    [anon_sym_inline] = ACTIONS(4142),
    [anon_sym___inline] = ACTIONS(4142),
    [anon_sym___inline__] = ACTIONS(4142),
    [anon_sym___forceinline] = ACTIONS(4142),
    [anon_sym_thread_local] = ACTIONS(4142),
    [anon_sym___thread] = ACTIONS(4142),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_constexpr] = ACTIONS(4142),
    [anon_sym_volatile] = ACTIONS(4142),
    [anon_sym_restrict] = ACTIONS(4142),
    [anon_sym___restrict__] = ACTIONS(4142),
    [anon_sym__Atomic] = ACTIONS(4142),
    [anon_sym__Noreturn] = ACTIONS(4142),
    [anon_sym_noreturn] = ACTIONS(4142),
    [anon_sym_mutable] = ACTIONS(4142),
    [anon_sym_constinit] = ACTIONS(4142),
    [anon_sym_consteval] = ACTIONS(4142),
    [anon_sym___shared__] = ACTIONS(4142),
    [anon_sym___local__] = ACTIONS(4142),
    [anon_sym___constant__] = ACTIONS(4142),
    [anon_sym___managed__] = ACTIONS(4142),
    [anon_sym___grid_constant__] = ACTIONS(4142),
    [anon_sym_alignas] = ACTIONS(4142),
    [anon_sym__Alignas] = ACTIONS(4142),
    [sym_primitive_type] = ACTIONS(4142),
    [anon_sym_enum] = ACTIONS(4142),
    [anon_sym_class] = ACTIONS(4142),
    [anon_sym_struct] = ACTIONS(4142),
    [anon_sym_union] = ACTIONS(4142),
    [anon_sym_COLON] = ACTIONS(4142),
    [anon_sym_or] = ACTIONS(4142),
    [anon_sym_and] = ACTIONS(4142),
    [anon_sym_asm] = ACTIONS(4142),
    [anon_sym___asm__] = ACTIONS(4142),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4142),
    [anon_sym_decltype] = ACTIONS(4142),
    [anon_sym_final] = ACTIONS(4142),
    [anon_sym_override] = ACTIONS(4142),
    [sym_virtual] = ACTIONS(4142),
    [anon_sym_explicit] = ACTIONS(4142),
    [anon_sym_typename] = ACTIONS(4142),
    [anon_sym_template] = ACTIONS(4142),
    [anon_sym_GT2] = ACTIONS(4149),
    [anon_sym_operator] = ACTIONS(4142),
    [anon_sym_try] = ACTIONS(4142),
    [anon_sym_friend] = ACTIONS(4142),
    [anon_sym_using] = ACTIONS(4142),
    [anon_sym_concept] = ACTIONS(4142),
    [anon_sym_requires] = ACTIONS(4142),
    [anon_sym___launch_bounds__] = ACTIONS(4142),
  },
  [1652] = {
    [sym_function_definition] = STATE(1754),
    [sym_declaration] = STATE(1754),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5258),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_ms_call_modifier] = STATE(1820),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8203),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2929),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6816),
    [sym_qualified_type_identifier] = STATE(2925),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(4873),
    [anon_sym_struct] = ACTIONS(4875),
    [anon_sym_union] = ACTIONS(4877),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1653] = {
    [sym_function_definition] = STATE(1963),
    [sym_declaration] = STATE(1963),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5320),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_ms_call_modifier] = STATE(1819),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8769),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2929),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6816),
    [sym_qualified_type_identifier] = STATE(2925),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(4879),
    [anon_sym_struct] = ACTIONS(4881),
    [anon_sym_union] = ACTIONS(4883),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1654] = {
    [sym_identifier] = ACTIONS(3988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3990),
    [anon_sym_COMMA] = ACTIONS(3990),
    [anon_sym_RPAREN] = ACTIONS(3990),
    [aux_sym_preproc_if_token2] = ACTIONS(3990),
    [aux_sym_preproc_else_token1] = ACTIONS(3990),
    [aux_sym_preproc_elif_token1] = ACTIONS(3988),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3990),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3990),
    [anon_sym_LPAREN2] = ACTIONS(3990),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_STAR] = ACTIONS(3988),
    [anon_sym_SLASH] = ACTIONS(3988),
    [anon_sym_PERCENT] = ACTIONS(3988),
    [anon_sym_PIPE_PIPE] = ACTIONS(3990),
    [anon_sym_AMP_AMP] = ACTIONS(3990),
    [anon_sym_PIPE] = ACTIONS(3988),
    [anon_sym_CARET] = ACTIONS(3988),
    [anon_sym_AMP] = ACTIONS(3988),
    [anon_sym_EQ_EQ] = ACTIONS(3990),
    [anon_sym_BANG_EQ] = ACTIONS(3990),
    [anon_sym_GT] = ACTIONS(3988),
    [anon_sym_GT_EQ] = ACTIONS(3990),
    [anon_sym_LT_EQ] = ACTIONS(3988),
    [anon_sym_LT] = ACTIONS(3988),
    [anon_sym_LT_LT] = ACTIONS(3988),
    [anon_sym_GT_GT] = ACTIONS(3988),
    [anon_sym_SEMI] = ACTIONS(3990),
    [anon_sym___extension__] = ACTIONS(3988),
    [anon_sym___global__] = ACTIONS(3988),
    [anon_sym___attribute__] = ACTIONS(3988),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [anon_sym_LBRACE] = ACTIONS(3990),
    [anon_sym_RBRACE] = ACTIONS(3990),
    [anon_sym_LBRACK] = ACTIONS(3990),
    [anon_sym_RBRACK] = ACTIONS(3990),
    [anon_sym_EQ] = ACTIONS(3988),
    [anon_sym_const] = ACTIONS(3988),
    [anon_sym_constexpr] = ACTIONS(3988),
    [anon_sym_volatile] = ACTIONS(3988),
    [anon_sym_restrict] = ACTIONS(3988),
    [anon_sym___restrict__] = ACTIONS(3988),
    [anon_sym__Atomic] = ACTIONS(3988),
    [anon_sym__Noreturn] = ACTIONS(3988),
    [anon_sym_noreturn] = ACTIONS(3988),
    [anon_sym_mutable] = ACTIONS(3988),
    [anon_sym_constinit] = ACTIONS(3988),
    [anon_sym_consteval] = ACTIONS(3988),
    [anon_sym___shared__] = ACTIONS(3988),
    [anon_sym___local__] = ACTIONS(3988),
    [anon_sym___constant__] = ACTIONS(3988),
    [anon_sym___managed__] = ACTIONS(3988),
    [anon_sym___grid_constant__] = ACTIONS(3988),
    [anon_sym_alignas] = ACTIONS(3988),
    [anon_sym__Alignas] = ACTIONS(3988),
    [anon_sym_COLON] = ACTIONS(3988),
    [anon_sym_QMARK] = ACTIONS(3990),
    [anon_sym_STAR_EQ] = ACTIONS(3990),
    [anon_sym_SLASH_EQ] = ACTIONS(3990),
    [anon_sym_PERCENT_EQ] = ACTIONS(3990),
    [anon_sym_PLUS_EQ] = ACTIONS(3990),
    [anon_sym_DASH_EQ] = ACTIONS(3990),
    [anon_sym_LT_LT_EQ] = ACTIONS(3990),
    [anon_sym_GT_GT_EQ] = ACTIONS(3990),
    [anon_sym_AMP_EQ] = ACTIONS(3990),
    [anon_sym_CARET_EQ] = ACTIONS(3990),
    [anon_sym_PIPE_EQ] = ACTIONS(3990),
    [anon_sym_and_eq] = ACTIONS(3988),
    [anon_sym_or_eq] = ACTIONS(3988),
    [anon_sym_xor_eq] = ACTIONS(3988),
    [anon_sym_LT_EQ_GT] = ACTIONS(3990),
    [anon_sym_or] = ACTIONS(3988),
    [anon_sym_and] = ACTIONS(3988),
    [anon_sym_bitor] = ACTIONS(3988),
    [anon_sym_xor] = ACTIONS(3988),
    [anon_sym_bitand] = ACTIONS(3988),
    [anon_sym_not_eq] = ACTIONS(3988),
    [anon_sym_DASH_DASH] = ACTIONS(3990),
    [anon_sym_PLUS_PLUS] = ACTIONS(3990),
    [anon_sym_DOT] = ACTIONS(3988),
    [anon_sym_DOT_STAR] = ACTIONS(3990),
    [anon_sym_DASH_GT] = ACTIONS(3990),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3988),
    [anon_sym_decltype] = ACTIONS(3988),
    [anon_sym_final] = ACTIONS(3988),
    [anon_sym_override] = ACTIONS(3988),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3990),
  },
  [1655] = {
    [sym_function_definition] = STATE(692),
    [sym_declaration] = STATE(692),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5203),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_ms_call_modifier] = STATE(1822),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8746),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2929),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6816),
    [sym_qualified_type_identifier] = STATE(2925),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(4885),
    [anon_sym_struct] = ACTIONS(4887),
    [anon_sym_union] = ACTIONS(4889),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1656] = {
    [sym_function_definition] = STATE(527),
    [sym_declaration] = STATE(527),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5201),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_ms_call_modifier] = STATE(1837),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8423),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2929),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6816),
    [sym_qualified_type_identifier] = STATE(2925),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(4891),
    [anon_sym_struct] = ACTIONS(4893),
    [anon_sym_union] = ACTIONS(4895),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1657] = {
    [sym_function_definition] = STATE(2060),
    [sym_declaration] = STATE(2060),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5200),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_ms_call_modifier] = STATE(1821),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8409),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2929),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6816),
    [sym_qualified_type_identifier] = STATE(2925),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(4897),
    [anon_sym_struct] = ACTIONS(4899),
    [anon_sym_union] = ACTIONS(4901),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1658] = {
    [sym_identifier] = ACTIONS(4017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4019),
    [anon_sym_COMMA] = ACTIONS(4019),
    [anon_sym_RPAREN] = ACTIONS(4019),
    [aux_sym_preproc_if_token2] = ACTIONS(4019),
    [aux_sym_preproc_else_token1] = ACTIONS(4019),
    [aux_sym_preproc_elif_token1] = ACTIONS(4017),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4019),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(4019),
    [anon_sym_DASH] = ACTIONS(4017),
    [anon_sym_PLUS] = ACTIONS(4017),
    [anon_sym_STAR] = ACTIONS(4017),
    [anon_sym_SLASH] = ACTIONS(4017),
    [anon_sym_PERCENT] = ACTIONS(4017),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE] = ACTIONS(4017),
    [anon_sym_CARET] = ACTIONS(4017),
    [anon_sym_AMP] = ACTIONS(4017),
    [anon_sym_EQ_EQ] = ACTIONS(4019),
    [anon_sym_BANG_EQ] = ACTIONS(4019),
    [anon_sym_GT] = ACTIONS(4017),
    [anon_sym_GT_EQ] = ACTIONS(4019),
    [anon_sym_LT_EQ] = ACTIONS(4017),
    [anon_sym_LT] = ACTIONS(4017),
    [anon_sym_LT_LT] = ACTIONS(4017),
    [anon_sym_GT_GT] = ACTIONS(4017),
    [anon_sym_SEMI] = ACTIONS(4019),
    [anon_sym___extension__] = ACTIONS(4017),
    [anon_sym___global__] = ACTIONS(4017),
    [anon_sym___attribute__] = ACTIONS(4017),
    [anon_sym_COLON_COLON] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4019),
    [anon_sym_RBRACE] = ACTIONS(4019),
    [anon_sym_LBRACK] = ACTIONS(4019),
    [anon_sym_RBRACK] = ACTIONS(4019),
    [anon_sym_EQ] = ACTIONS(4017),
    [anon_sym_const] = ACTIONS(4017),
    [anon_sym_constexpr] = ACTIONS(4017),
    [anon_sym_volatile] = ACTIONS(4017),
    [anon_sym_restrict] = ACTIONS(4017),
    [anon_sym___restrict__] = ACTIONS(4017),
    [anon_sym__Atomic] = ACTIONS(4017),
    [anon_sym__Noreturn] = ACTIONS(4017),
    [anon_sym_noreturn] = ACTIONS(4017),
    [anon_sym_mutable] = ACTIONS(4017),
    [anon_sym_constinit] = ACTIONS(4017),
    [anon_sym_consteval] = ACTIONS(4017),
    [anon_sym___shared__] = ACTIONS(4017),
    [anon_sym___local__] = ACTIONS(4017),
    [anon_sym___constant__] = ACTIONS(4017),
    [anon_sym___managed__] = ACTIONS(4017),
    [anon_sym___grid_constant__] = ACTIONS(4017),
    [anon_sym_alignas] = ACTIONS(4017),
    [anon_sym__Alignas] = ACTIONS(4017),
    [anon_sym_COLON] = ACTIONS(4017),
    [anon_sym_QMARK] = ACTIONS(4019),
    [anon_sym_STAR_EQ] = ACTIONS(4019),
    [anon_sym_SLASH_EQ] = ACTIONS(4019),
    [anon_sym_PERCENT_EQ] = ACTIONS(4019),
    [anon_sym_PLUS_EQ] = ACTIONS(4019),
    [anon_sym_DASH_EQ] = ACTIONS(4019),
    [anon_sym_LT_LT_EQ] = ACTIONS(4019),
    [anon_sym_GT_GT_EQ] = ACTIONS(4019),
    [anon_sym_AMP_EQ] = ACTIONS(4019),
    [anon_sym_CARET_EQ] = ACTIONS(4019),
    [anon_sym_PIPE_EQ] = ACTIONS(4019),
    [anon_sym_and_eq] = ACTIONS(4017),
    [anon_sym_or_eq] = ACTIONS(4017),
    [anon_sym_xor_eq] = ACTIONS(4017),
    [anon_sym_LT_EQ_GT] = ACTIONS(4019),
    [anon_sym_or] = ACTIONS(4017),
    [anon_sym_and] = ACTIONS(4017),
    [anon_sym_bitor] = ACTIONS(4017),
    [anon_sym_xor] = ACTIONS(4017),
    [anon_sym_bitand] = ACTIONS(4017),
    [anon_sym_not_eq] = ACTIONS(4017),
    [anon_sym_DASH_DASH] = ACTIONS(4019),
    [anon_sym_PLUS_PLUS] = ACTIONS(4019),
    [anon_sym_DOT] = ACTIONS(4017),
    [anon_sym_DOT_STAR] = ACTIONS(4019),
    [anon_sym_DASH_GT] = ACTIONS(4019),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4017),
    [anon_sym_decltype] = ACTIONS(4017),
    [anon_sym_final] = ACTIONS(4017),
    [anon_sym_override] = ACTIONS(4017),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4019),
  },
  [1659] = {
    [sym_identifier] = ACTIONS(4021),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_RPAREN] = ACTIONS(4023),
    [aux_sym_preproc_if_token2] = ACTIONS(4023),
    [aux_sym_preproc_else_token1] = ACTIONS(4023),
    [aux_sym_preproc_elif_token1] = ACTIONS(4021),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4023),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4023),
    [anon_sym_LPAREN2] = ACTIONS(4023),
    [anon_sym_DASH] = ACTIONS(4021),
    [anon_sym_PLUS] = ACTIONS(4021),
    [anon_sym_STAR] = ACTIONS(4021),
    [anon_sym_SLASH] = ACTIONS(4021),
    [anon_sym_PERCENT] = ACTIONS(4021),
    [anon_sym_PIPE_PIPE] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4023),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_CARET] = ACTIONS(4021),
    [anon_sym_AMP] = ACTIONS(4021),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4021),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4021),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym___extension__] = ACTIONS(4021),
    [anon_sym___global__] = ACTIONS(4021),
    [anon_sym___attribute__] = ACTIONS(4021),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_LBRACE] = ACTIONS(4023),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_RBRACK] = ACTIONS(4023),
    [anon_sym_EQ] = ACTIONS(4021),
    [anon_sym_const] = ACTIONS(4021),
    [anon_sym_constexpr] = ACTIONS(4021),
    [anon_sym_volatile] = ACTIONS(4021),
    [anon_sym_restrict] = ACTIONS(4021),
    [anon_sym___restrict__] = ACTIONS(4021),
    [anon_sym__Atomic] = ACTIONS(4021),
    [anon_sym__Noreturn] = ACTIONS(4021),
    [anon_sym_noreturn] = ACTIONS(4021),
    [anon_sym_mutable] = ACTIONS(4021),
    [anon_sym_constinit] = ACTIONS(4021),
    [anon_sym_consteval] = ACTIONS(4021),
    [anon_sym___shared__] = ACTIONS(4021),
    [anon_sym___local__] = ACTIONS(4021),
    [anon_sym___constant__] = ACTIONS(4021),
    [anon_sym___managed__] = ACTIONS(4021),
    [anon_sym___grid_constant__] = ACTIONS(4021),
    [anon_sym_alignas] = ACTIONS(4021),
    [anon_sym__Alignas] = ACTIONS(4021),
    [anon_sym_COLON] = ACTIONS(4021),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_and_eq] = ACTIONS(4021),
    [anon_sym_or_eq] = ACTIONS(4021),
    [anon_sym_xor_eq] = ACTIONS(4021),
    [anon_sym_LT_EQ_GT] = ACTIONS(4023),
    [anon_sym_or] = ACTIONS(4021),
    [anon_sym_and] = ACTIONS(4021),
    [anon_sym_bitor] = ACTIONS(4021),
    [anon_sym_xor] = ACTIONS(4021),
    [anon_sym_bitand] = ACTIONS(4021),
    [anon_sym_not_eq] = ACTIONS(4021),
    [anon_sym_DASH_DASH] = ACTIONS(4023),
    [anon_sym_PLUS_PLUS] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4021),
    [anon_sym_DOT_STAR] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4021),
    [anon_sym_decltype] = ACTIONS(4021),
    [anon_sym_final] = ACTIONS(4021),
    [anon_sym_override] = ACTIONS(4021),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4023),
  },
  [1660] = {
    [sym_function_definition] = STATE(216),
    [sym_declaration] = STATE(216),
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5266),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_ms_call_modifier] = STATE(1824),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym__class_name] = STATE(8544),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2929),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6816),
    [sym_qualified_type_identifier] = STATE(2925),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym___cdecl] = ACTIONS(51),
    [anon_sym___clrcall] = ACTIONS(51),
    [anon_sym___stdcall] = ACTIONS(51),
    [anon_sym___fastcall] = ACTIONS(51),
    [anon_sym___thiscall] = ACTIONS(51),
    [anon_sym___vectorcall] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(4903),
    [anon_sym_struct] = ACTIONS(4905),
    [anon_sym_union] = ACTIONS(4907),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1661] = {
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3994),
    [anon_sym_COMMA] = ACTIONS(3994),
    [anon_sym_RPAREN] = ACTIONS(3994),
    [aux_sym_preproc_if_token2] = ACTIONS(3994),
    [aux_sym_preproc_else_token1] = ACTIONS(3994),
    [aux_sym_preproc_elif_token1] = ACTIONS(3992),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3994),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3994),
    [anon_sym_LPAREN2] = ACTIONS(3994),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_STAR] = ACTIONS(3992),
    [anon_sym_SLASH] = ACTIONS(3992),
    [anon_sym_PERCENT] = ACTIONS(3992),
    [anon_sym_PIPE_PIPE] = ACTIONS(3994),
    [anon_sym_AMP_AMP] = ACTIONS(3994),
    [anon_sym_PIPE] = ACTIONS(3992),
    [anon_sym_CARET] = ACTIONS(3992),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym_EQ_EQ] = ACTIONS(3994),
    [anon_sym_BANG_EQ] = ACTIONS(3994),
    [anon_sym_GT] = ACTIONS(3992),
    [anon_sym_GT_EQ] = ACTIONS(3994),
    [anon_sym_LT_EQ] = ACTIONS(3992),
    [anon_sym_LT] = ACTIONS(3992),
    [anon_sym_LT_LT] = ACTIONS(3992),
    [anon_sym_GT_GT] = ACTIONS(3992),
    [anon_sym_SEMI] = ACTIONS(3994),
    [anon_sym___extension__] = ACTIONS(3992),
    [anon_sym___global__] = ACTIONS(3992),
    [anon_sym___attribute__] = ACTIONS(3992),
    [anon_sym_COLON_COLON] = ACTIONS(3994),
    [anon_sym_LBRACE] = ACTIONS(3994),
    [anon_sym_RBRACE] = ACTIONS(3994),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_RBRACK] = ACTIONS(3994),
    [anon_sym_EQ] = ACTIONS(3992),
    [anon_sym_const] = ACTIONS(3992),
    [anon_sym_constexpr] = ACTIONS(3992),
    [anon_sym_volatile] = ACTIONS(3992),
    [anon_sym_restrict] = ACTIONS(3992),
    [anon_sym___restrict__] = ACTIONS(3992),
    [anon_sym__Atomic] = ACTIONS(3992),
    [anon_sym__Noreturn] = ACTIONS(3992),
    [anon_sym_noreturn] = ACTIONS(3992),
    [anon_sym_mutable] = ACTIONS(3992),
    [anon_sym_constinit] = ACTIONS(3992),
    [anon_sym_consteval] = ACTIONS(3992),
    [anon_sym___shared__] = ACTIONS(3992),
    [anon_sym___local__] = ACTIONS(3992),
    [anon_sym___constant__] = ACTIONS(3992),
    [anon_sym___managed__] = ACTIONS(3992),
    [anon_sym___grid_constant__] = ACTIONS(3992),
    [anon_sym_alignas] = ACTIONS(3992),
    [anon_sym__Alignas] = ACTIONS(3992),
    [anon_sym_COLON] = ACTIONS(3992),
    [anon_sym_QMARK] = ACTIONS(3994),
    [anon_sym_STAR_EQ] = ACTIONS(3994),
    [anon_sym_SLASH_EQ] = ACTIONS(3994),
    [anon_sym_PERCENT_EQ] = ACTIONS(3994),
    [anon_sym_PLUS_EQ] = ACTIONS(3994),
    [anon_sym_DASH_EQ] = ACTIONS(3994),
    [anon_sym_LT_LT_EQ] = ACTIONS(3994),
    [anon_sym_GT_GT_EQ] = ACTIONS(3994),
    [anon_sym_AMP_EQ] = ACTIONS(3994),
    [anon_sym_CARET_EQ] = ACTIONS(3994),
    [anon_sym_PIPE_EQ] = ACTIONS(3994),
    [anon_sym_and_eq] = ACTIONS(3992),
    [anon_sym_or_eq] = ACTIONS(3992),
    [anon_sym_xor_eq] = ACTIONS(3992),
    [anon_sym_LT_EQ_GT] = ACTIONS(3994),
    [anon_sym_or] = ACTIONS(3992),
    [anon_sym_and] = ACTIONS(3992),
    [anon_sym_bitor] = ACTIONS(3992),
    [anon_sym_xor] = ACTIONS(3992),
    [anon_sym_bitand] = ACTIONS(3992),
    [anon_sym_not_eq] = ACTIONS(3992),
    [anon_sym_DASH_DASH] = ACTIONS(3994),
    [anon_sym_PLUS_PLUS] = ACTIONS(3994),
    [anon_sym_DOT] = ACTIONS(3992),
    [anon_sym_DOT_STAR] = ACTIONS(3994),
    [anon_sym_DASH_GT] = ACTIONS(3994),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3992),
    [anon_sym_decltype] = ACTIONS(3992),
    [anon_sym_final] = ACTIONS(3992),
    [anon_sym_override] = ACTIONS(3992),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3994),
  },
  [1662] = {
    [sym_identifier] = ACTIONS(3980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3982),
    [anon_sym_COMMA] = ACTIONS(3982),
    [anon_sym_RPAREN] = ACTIONS(3982),
    [aux_sym_preproc_if_token2] = ACTIONS(3982),
    [aux_sym_preproc_else_token1] = ACTIONS(3982),
    [aux_sym_preproc_elif_token1] = ACTIONS(3980),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3982),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3982),
    [anon_sym_LPAREN2] = ACTIONS(3982),
    [anon_sym_DASH] = ACTIONS(3980),
    [anon_sym_PLUS] = ACTIONS(3980),
    [anon_sym_STAR] = ACTIONS(3980),
    [anon_sym_SLASH] = ACTIONS(3980),
    [anon_sym_PERCENT] = ACTIONS(3980),
    [anon_sym_PIPE_PIPE] = ACTIONS(3982),
    [anon_sym_AMP_AMP] = ACTIONS(3982),
    [anon_sym_PIPE] = ACTIONS(3980),
    [anon_sym_CARET] = ACTIONS(3980),
    [anon_sym_AMP] = ACTIONS(3980),
    [anon_sym_EQ_EQ] = ACTIONS(3982),
    [anon_sym_BANG_EQ] = ACTIONS(3982),
    [anon_sym_GT] = ACTIONS(3980),
    [anon_sym_GT_EQ] = ACTIONS(3982),
    [anon_sym_LT_EQ] = ACTIONS(3980),
    [anon_sym_LT] = ACTIONS(3980),
    [anon_sym_LT_LT] = ACTIONS(3980),
    [anon_sym_GT_GT] = ACTIONS(3980),
    [anon_sym_SEMI] = ACTIONS(3982),
    [anon_sym___extension__] = ACTIONS(3980),
    [anon_sym___global__] = ACTIONS(3980),
    [anon_sym___attribute__] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(3982),
    [anon_sym_RBRACE] = ACTIONS(3982),
    [anon_sym_LBRACK] = ACTIONS(3982),
    [anon_sym_RBRACK] = ACTIONS(3982),
    [anon_sym_EQ] = ACTIONS(3980),
    [anon_sym_const] = ACTIONS(3980),
    [anon_sym_constexpr] = ACTIONS(3980),
    [anon_sym_volatile] = ACTIONS(3980),
    [anon_sym_restrict] = ACTIONS(3980),
    [anon_sym___restrict__] = ACTIONS(3980),
    [anon_sym__Atomic] = ACTIONS(3980),
    [anon_sym__Noreturn] = ACTIONS(3980),
    [anon_sym_noreturn] = ACTIONS(3980),
    [anon_sym_mutable] = ACTIONS(3980),
    [anon_sym_constinit] = ACTIONS(3980),
    [anon_sym_consteval] = ACTIONS(3980),
    [anon_sym___shared__] = ACTIONS(3980),
    [anon_sym___local__] = ACTIONS(3980),
    [anon_sym___constant__] = ACTIONS(3980),
    [anon_sym___managed__] = ACTIONS(3980),
    [anon_sym___grid_constant__] = ACTIONS(3980),
    [anon_sym_alignas] = ACTIONS(3980),
    [anon_sym__Alignas] = ACTIONS(3980),
    [anon_sym_COLON] = ACTIONS(3980),
    [anon_sym_QMARK] = ACTIONS(3982),
    [anon_sym_STAR_EQ] = ACTIONS(3982),
    [anon_sym_SLASH_EQ] = ACTIONS(3982),
    [anon_sym_PERCENT_EQ] = ACTIONS(3982),
    [anon_sym_PLUS_EQ] = ACTIONS(3982),
    [anon_sym_DASH_EQ] = ACTIONS(3982),
    [anon_sym_LT_LT_EQ] = ACTIONS(3982),
    [anon_sym_GT_GT_EQ] = ACTIONS(3982),
    [anon_sym_AMP_EQ] = ACTIONS(3982),
    [anon_sym_CARET_EQ] = ACTIONS(3982),
    [anon_sym_PIPE_EQ] = ACTIONS(3982),
    [anon_sym_and_eq] = ACTIONS(3980),
    [anon_sym_or_eq] = ACTIONS(3980),
    [anon_sym_xor_eq] = ACTIONS(3980),
    [anon_sym_LT_EQ_GT] = ACTIONS(3982),
    [anon_sym_or] = ACTIONS(3980),
    [anon_sym_and] = ACTIONS(3980),
    [anon_sym_bitor] = ACTIONS(3980),
    [anon_sym_xor] = ACTIONS(3980),
    [anon_sym_bitand] = ACTIONS(3980),
    [anon_sym_not_eq] = ACTIONS(3980),
    [anon_sym_DASH_DASH] = ACTIONS(3982),
    [anon_sym_PLUS_PLUS] = ACTIONS(3982),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_DOT_STAR] = ACTIONS(3982),
    [anon_sym_DASH_GT] = ACTIONS(3982),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3980),
    [anon_sym_decltype] = ACTIONS(3980),
    [anon_sym_final] = ACTIONS(3980),
    [anon_sym_override] = ACTIONS(3980),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3982),
  },
  [1663] = {
    [sym_identifier] = ACTIONS(3996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3998),
    [anon_sym_COMMA] = ACTIONS(3998),
    [anon_sym_RPAREN] = ACTIONS(3998),
    [aux_sym_preproc_if_token2] = ACTIONS(3998),
    [aux_sym_preproc_else_token1] = ACTIONS(3998),
    [aux_sym_preproc_elif_token1] = ACTIONS(3996),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3998),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3998),
    [anon_sym_LPAREN2] = ACTIONS(3998),
    [anon_sym_DASH] = ACTIONS(3996),
    [anon_sym_PLUS] = ACTIONS(3996),
    [anon_sym_STAR] = ACTIONS(3996),
    [anon_sym_SLASH] = ACTIONS(3996),
    [anon_sym_PERCENT] = ACTIONS(3996),
    [anon_sym_PIPE_PIPE] = ACTIONS(3998),
    [anon_sym_AMP_AMP] = ACTIONS(3998),
    [anon_sym_PIPE] = ACTIONS(3996),
    [anon_sym_CARET] = ACTIONS(3996),
    [anon_sym_AMP] = ACTIONS(3996),
    [anon_sym_EQ_EQ] = ACTIONS(3998),
    [anon_sym_BANG_EQ] = ACTIONS(3998),
    [anon_sym_GT] = ACTIONS(3996),
    [anon_sym_GT_EQ] = ACTIONS(3998),
    [anon_sym_LT_EQ] = ACTIONS(3996),
    [anon_sym_LT] = ACTIONS(3996),
    [anon_sym_LT_LT] = ACTIONS(3996),
    [anon_sym_GT_GT] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(3998),
    [anon_sym___extension__] = ACTIONS(3996),
    [anon_sym___global__] = ACTIONS(3996),
    [anon_sym___attribute__] = ACTIONS(3996),
    [anon_sym_COLON_COLON] = ACTIONS(3998),
    [anon_sym_LBRACE] = ACTIONS(3998),
    [anon_sym_RBRACE] = ACTIONS(3998),
    [anon_sym_LBRACK] = ACTIONS(3998),
    [anon_sym_RBRACK] = ACTIONS(3998),
    [anon_sym_EQ] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3996),
    [anon_sym_constexpr] = ACTIONS(3996),
    [anon_sym_volatile] = ACTIONS(3996),
    [anon_sym_restrict] = ACTIONS(3996),
    [anon_sym___restrict__] = ACTIONS(3996),
    [anon_sym__Atomic] = ACTIONS(3996),
    [anon_sym__Noreturn] = ACTIONS(3996),
    [anon_sym_noreturn] = ACTIONS(3996),
    [anon_sym_mutable] = ACTIONS(3996),
    [anon_sym_constinit] = ACTIONS(3996),
    [anon_sym_consteval] = ACTIONS(3996),
    [anon_sym___shared__] = ACTIONS(3996),
    [anon_sym___local__] = ACTIONS(3996),
    [anon_sym___constant__] = ACTIONS(3996),
    [anon_sym___managed__] = ACTIONS(3996),
    [anon_sym___grid_constant__] = ACTIONS(3996),
    [anon_sym_alignas] = ACTIONS(3996),
    [anon_sym__Alignas] = ACTIONS(3996),
    [anon_sym_COLON] = ACTIONS(3996),
    [anon_sym_QMARK] = ACTIONS(3998),
    [anon_sym_STAR_EQ] = ACTIONS(3998),
    [anon_sym_SLASH_EQ] = ACTIONS(3998),
    [anon_sym_PERCENT_EQ] = ACTIONS(3998),
    [anon_sym_PLUS_EQ] = ACTIONS(3998),
    [anon_sym_DASH_EQ] = ACTIONS(3998),
    [anon_sym_LT_LT_EQ] = ACTIONS(3998),
    [anon_sym_GT_GT_EQ] = ACTIONS(3998),
    [anon_sym_AMP_EQ] = ACTIONS(3998),
    [anon_sym_CARET_EQ] = ACTIONS(3998),
    [anon_sym_PIPE_EQ] = ACTIONS(3998),
    [anon_sym_and_eq] = ACTIONS(3996),
    [anon_sym_or_eq] = ACTIONS(3996),
    [anon_sym_xor_eq] = ACTIONS(3996),
    [anon_sym_LT_EQ_GT] = ACTIONS(3998),
    [anon_sym_or] = ACTIONS(3996),
    [anon_sym_and] = ACTIONS(3996),
    [anon_sym_bitor] = ACTIONS(3996),
    [anon_sym_xor] = ACTIONS(3996),
    [anon_sym_bitand] = ACTIONS(3996),
    [anon_sym_not_eq] = ACTIONS(3996),
    [anon_sym_DASH_DASH] = ACTIONS(3998),
    [anon_sym_PLUS_PLUS] = ACTIONS(3998),
    [anon_sym_DOT] = ACTIONS(3996),
    [anon_sym_DOT_STAR] = ACTIONS(3998),
    [anon_sym_DASH_GT] = ACTIONS(3998),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3996),
    [anon_sym_decltype] = ACTIONS(3996),
    [anon_sym_final] = ACTIONS(3996),
    [anon_sym_override] = ACTIONS(3996),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3998),
  },
  [1664] = {
    [sym_identifier] = ACTIONS(4909),
    [anon_sym_COMMA] = ACTIONS(4911),
    [anon_sym_RPAREN] = ACTIONS(4911),
    [anon_sym_LPAREN2] = ACTIONS(4911),
    [anon_sym_TILDE] = ACTIONS(4911),
    [anon_sym_STAR] = ACTIONS(4911),
    [anon_sym_PIPE_PIPE] = ACTIONS(4911),
    [anon_sym_AMP_AMP] = ACTIONS(4911),
    [anon_sym_AMP] = ACTIONS(4909),
    [anon_sym_SEMI] = ACTIONS(4911),
    [anon_sym___extension__] = ACTIONS(4909),
    [anon_sym___device__] = ACTIONS(4909),
    [anon_sym___host__] = ACTIONS(4909),
    [anon_sym___global__] = ACTIONS(4909),
    [anon_sym___forceinline__] = ACTIONS(4909),
    [anon_sym___noinline__] = ACTIONS(4909),
    [anon_sym_extern] = ACTIONS(4909),
    [anon_sym___attribute__] = ACTIONS(4909),
    [anon_sym_COLON_COLON] = ACTIONS(4911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4911),
    [anon_sym___declspec] = ACTIONS(4909),
    [anon_sym___based] = ACTIONS(4909),
    [anon_sym___cdecl] = ACTIONS(4909),
    [anon_sym___clrcall] = ACTIONS(4909),
    [anon_sym___stdcall] = ACTIONS(4909),
    [anon_sym___fastcall] = ACTIONS(4909),
    [anon_sym___thiscall] = ACTIONS(4909),
    [anon_sym___vectorcall] = ACTIONS(4909),
    [anon_sym_LBRACE] = ACTIONS(4911),
    [anon_sym_signed] = ACTIONS(4909),
    [anon_sym_unsigned] = ACTIONS(4909),
    [anon_sym_long] = ACTIONS(4909),
    [anon_sym_short] = ACTIONS(4909),
    [anon_sym_LBRACK] = ACTIONS(4909),
    [anon_sym_static] = ACTIONS(4909),
    [anon_sym_EQ] = ACTIONS(4911),
    [anon_sym_register] = ACTIONS(4909),
    [anon_sym_inline] = ACTIONS(4909),
    [anon_sym___inline] = ACTIONS(4909),
    [anon_sym___inline__] = ACTIONS(4909),
    [anon_sym___forceinline] = ACTIONS(4909),
    [anon_sym_thread_local] = ACTIONS(4909),
    [anon_sym___thread] = ACTIONS(4909),
    [anon_sym_const] = ACTIONS(4909),
    [anon_sym_constexpr] = ACTIONS(4909),
    [anon_sym_volatile] = ACTIONS(4909),
    [anon_sym_restrict] = ACTIONS(4909),
    [anon_sym___restrict__] = ACTIONS(4909),
    [anon_sym__Atomic] = ACTIONS(4909),
    [anon_sym__Noreturn] = ACTIONS(4909),
    [anon_sym_noreturn] = ACTIONS(4909),
    [anon_sym_mutable] = ACTIONS(4909),
    [anon_sym_constinit] = ACTIONS(4909),
    [anon_sym_consteval] = ACTIONS(4909),
    [anon_sym___shared__] = ACTIONS(4909),
    [anon_sym___local__] = ACTIONS(4909),
    [anon_sym___constant__] = ACTIONS(4909),
    [anon_sym___managed__] = ACTIONS(4909),
    [anon_sym___grid_constant__] = ACTIONS(4909),
    [anon_sym_alignas] = ACTIONS(4909),
    [anon_sym__Alignas] = ACTIONS(4909),
    [sym_primitive_type] = ACTIONS(4909),
    [anon_sym_enum] = ACTIONS(4909),
    [anon_sym_class] = ACTIONS(4909),
    [anon_sym_struct] = ACTIONS(4909),
    [anon_sym_union] = ACTIONS(4909),
    [anon_sym_or] = ACTIONS(4909),
    [anon_sym_and] = ACTIONS(4909),
    [anon_sym_asm] = ACTIONS(4909),
    [anon_sym___asm__] = ACTIONS(4909),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4909),
    [anon_sym_decltype] = ACTIONS(4909),
    [anon_sym_final] = ACTIONS(4909),
    [anon_sym_override] = ACTIONS(4909),
    [sym_virtual] = ACTIONS(4909),
    [anon_sym_explicit] = ACTIONS(4909),
    [anon_sym_typename] = ACTIONS(4909),
    [anon_sym_template] = ACTIONS(4909),
    [anon_sym_GT2] = ACTIONS(4911),
    [anon_sym_operator] = ACTIONS(4909),
    [anon_sym_try] = ACTIONS(4909),
    [anon_sym_friend] = ACTIONS(4909),
    [anon_sym_using] = ACTIONS(4909),
    [anon_sym_concept] = ACTIONS(4909),
    [anon_sym_requires] = ACTIONS(4909),
    [anon_sym___launch_bounds__] = ACTIONS(4909),
  },
  [1665] = {
    [sym_identifier] = ACTIONS(4913),
    [anon_sym_COMMA] = ACTIONS(4915),
    [anon_sym_RPAREN] = ACTIONS(4915),
    [anon_sym_LPAREN2] = ACTIONS(4915),
    [anon_sym_TILDE] = ACTIONS(4915),
    [anon_sym_STAR] = ACTIONS(4915),
    [anon_sym_PIPE_PIPE] = ACTIONS(4915),
    [anon_sym_AMP_AMP] = ACTIONS(4915),
    [anon_sym_AMP] = ACTIONS(4913),
    [anon_sym_SEMI] = ACTIONS(4915),
    [anon_sym___extension__] = ACTIONS(4913),
    [anon_sym___device__] = ACTIONS(4913),
    [anon_sym___host__] = ACTIONS(4913),
    [anon_sym___global__] = ACTIONS(4913),
    [anon_sym___forceinline__] = ACTIONS(4913),
    [anon_sym___noinline__] = ACTIONS(4913),
    [anon_sym_extern] = ACTIONS(4913),
    [anon_sym___attribute__] = ACTIONS(4913),
    [anon_sym_COLON_COLON] = ACTIONS(4915),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4915),
    [anon_sym___declspec] = ACTIONS(4913),
    [anon_sym___based] = ACTIONS(4913),
    [anon_sym___cdecl] = ACTIONS(4913),
    [anon_sym___clrcall] = ACTIONS(4913),
    [anon_sym___stdcall] = ACTIONS(4913),
    [anon_sym___fastcall] = ACTIONS(4913),
    [anon_sym___thiscall] = ACTIONS(4913),
    [anon_sym___vectorcall] = ACTIONS(4913),
    [anon_sym_LBRACE] = ACTIONS(4915),
    [anon_sym_signed] = ACTIONS(4913),
    [anon_sym_unsigned] = ACTIONS(4913),
    [anon_sym_long] = ACTIONS(4913),
    [anon_sym_short] = ACTIONS(4913),
    [anon_sym_LBRACK] = ACTIONS(4913),
    [anon_sym_static] = ACTIONS(4913),
    [anon_sym_EQ] = ACTIONS(4915),
    [anon_sym_register] = ACTIONS(4913),
    [anon_sym_inline] = ACTIONS(4913),
    [anon_sym___inline] = ACTIONS(4913),
    [anon_sym___inline__] = ACTIONS(4913),
    [anon_sym___forceinline] = ACTIONS(4913),
    [anon_sym_thread_local] = ACTIONS(4913),
    [anon_sym___thread] = ACTIONS(4913),
    [anon_sym_const] = ACTIONS(4913),
    [anon_sym_constexpr] = ACTIONS(4913),
    [anon_sym_volatile] = ACTIONS(4913),
    [anon_sym_restrict] = ACTIONS(4913),
    [anon_sym___restrict__] = ACTIONS(4913),
    [anon_sym__Atomic] = ACTIONS(4913),
    [anon_sym__Noreturn] = ACTIONS(4913),
    [anon_sym_noreturn] = ACTIONS(4913),
    [anon_sym_mutable] = ACTIONS(4913),
    [anon_sym_constinit] = ACTIONS(4913),
    [anon_sym_consteval] = ACTIONS(4913),
    [anon_sym___shared__] = ACTIONS(4913),
    [anon_sym___local__] = ACTIONS(4913),
    [anon_sym___constant__] = ACTIONS(4913),
    [anon_sym___managed__] = ACTIONS(4913),
    [anon_sym___grid_constant__] = ACTIONS(4913),
    [anon_sym_alignas] = ACTIONS(4913),
    [anon_sym__Alignas] = ACTIONS(4913),
    [sym_primitive_type] = ACTIONS(4913),
    [anon_sym_enum] = ACTIONS(4913),
    [anon_sym_class] = ACTIONS(4913),
    [anon_sym_struct] = ACTIONS(4913),
    [anon_sym_union] = ACTIONS(4913),
    [anon_sym_or] = ACTIONS(4913),
    [anon_sym_and] = ACTIONS(4913),
    [anon_sym_asm] = ACTIONS(4913),
    [anon_sym___asm__] = ACTIONS(4913),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4913),
    [anon_sym_decltype] = ACTIONS(4913),
    [anon_sym_final] = ACTIONS(4913),
    [anon_sym_override] = ACTIONS(4913),
    [sym_virtual] = ACTIONS(4913),
    [anon_sym_explicit] = ACTIONS(4913),
    [anon_sym_typename] = ACTIONS(4913),
    [anon_sym_template] = ACTIONS(4913),
    [anon_sym_GT2] = ACTIONS(4915),
    [anon_sym_operator] = ACTIONS(4913),
    [anon_sym_try] = ACTIONS(4913),
    [anon_sym_friend] = ACTIONS(4913),
    [anon_sym_using] = ACTIONS(4913),
    [anon_sym_concept] = ACTIONS(4913),
    [anon_sym_requires] = ACTIONS(4913),
    [anon_sym___launch_bounds__] = ACTIONS(4913),
  },
  [1666] = {
    [sym_identifier] = ACTIONS(4917),
    [anon_sym_COMMA] = ACTIONS(4919),
    [anon_sym_RPAREN] = ACTIONS(4919),
    [anon_sym_LPAREN2] = ACTIONS(4919),
    [anon_sym_TILDE] = ACTIONS(4919),
    [anon_sym_STAR] = ACTIONS(4919),
    [anon_sym_PIPE_PIPE] = ACTIONS(4919),
    [anon_sym_AMP_AMP] = ACTIONS(4919),
    [anon_sym_AMP] = ACTIONS(4917),
    [anon_sym_SEMI] = ACTIONS(4919),
    [anon_sym___extension__] = ACTIONS(4917),
    [anon_sym___device__] = ACTIONS(4917),
    [anon_sym___host__] = ACTIONS(4917),
    [anon_sym___global__] = ACTIONS(4917),
    [anon_sym___forceinline__] = ACTIONS(4917),
    [anon_sym___noinline__] = ACTIONS(4917),
    [anon_sym_extern] = ACTIONS(4917),
    [anon_sym___attribute__] = ACTIONS(4917),
    [anon_sym_COLON_COLON] = ACTIONS(4919),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4919),
    [anon_sym___declspec] = ACTIONS(4917),
    [anon_sym___based] = ACTIONS(4917),
    [anon_sym___cdecl] = ACTIONS(4917),
    [anon_sym___clrcall] = ACTIONS(4917),
    [anon_sym___stdcall] = ACTIONS(4917),
    [anon_sym___fastcall] = ACTIONS(4917),
    [anon_sym___thiscall] = ACTIONS(4917),
    [anon_sym___vectorcall] = ACTIONS(4917),
    [anon_sym_LBRACE] = ACTIONS(4919),
    [anon_sym_signed] = ACTIONS(4917),
    [anon_sym_unsigned] = ACTIONS(4917),
    [anon_sym_long] = ACTIONS(4917),
    [anon_sym_short] = ACTIONS(4917),
    [anon_sym_LBRACK] = ACTIONS(4917),
    [anon_sym_static] = ACTIONS(4917),
    [anon_sym_EQ] = ACTIONS(4919),
    [anon_sym_register] = ACTIONS(4917),
    [anon_sym_inline] = ACTIONS(4917),
    [anon_sym___inline] = ACTIONS(4917),
    [anon_sym___inline__] = ACTIONS(4917),
    [anon_sym___forceinline] = ACTIONS(4917),
    [anon_sym_thread_local] = ACTIONS(4917),
    [anon_sym___thread] = ACTIONS(4917),
    [anon_sym_const] = ACTIONS(4917),
    [anon_sym_constexpr] = ACTIONS(4917),
    [anon_sym_volatile] = ACTIONS(4917),
    [anon_sym_restrict] = ACTIONS(4917),
    [anon_sym___restrict__] = ACTIONS(4917),
    [anon_sym__Atomic] = ACTIONS(4917),
    [anon_sym__Noreturn] = ACTIONS(4917),
    [anon_sym_noreturn] = ACTIONS(4917),
    [anon_sym_mutable] = ACTIONS(4917),
    [anon_sym_constinit] = ACTIONS(4917),
    [anon_sym_consteval] = ACTIONS(4917),
    [anon_sym___shared__] = ACTIONS(4917),
    [anon_sym___local__] = ACTIONS(4917),
    [anon_sym___constant__] = ACTIONS(4917),
    [anon_sym___managed__] = ACTIONS(4917),
    [anon_sym___grid_constant__] = ACTIONS(4917),
    [anon_sym_alignas] = ACTIONS(4917),
    [anon_sym__Alignas] = ACTIONS(4917),
    [sym_primitive_type] = ACTIONS(4917),
    [anon_sym_enum] = ACTIONS(4917),
    [anon_sym_class] = ACTIONS(4917),
    [anon_sym_struct] = ACTIONS(4917),
    [anon_sym_union] = ACTIONS(4917),
    [anon_sym_or] = ACTIONS(4917),
    [anon_sym_and] = ACTIONS(4917),
    [anon_sym_asm] = ACTIONS(4917),
    [anon_sym___asm__] = ACTIONS(4917),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4917),
    [anon_sym_decltype] = ACTIONS(4917),
    [anon_sym_final] = ACTIONS(4917),
    [anon_sym_override] = ACTIONS(4917),
    [sym_virtual] = ACTIONS(4917),
    [anon_sym_explicit] = ACTIONS(4917),
    [anon_sym_typename] = ACTIONS(4917),
    [anon_sym_template] = ACTIONS(4917),
    [anon_sym_GT2] = ACTIONS(4919),
    [anon_sym_operator] = ACTIONS(4917),
    [anon_sym_try] = ACTIONS(4917),
    [anon_sym_friend] = ACTIONS(4917),
    [anon_sym_using] = ACTIONS(4917),
    [anon_sym_concept] = ACTIONS(4917),
    [anon_sym_requires] = ACTIONS(4917),
    [anon_sym___launch_bounds__] = ACTIONS(4917),
  },
  [1667] = {
    [sym_identifier] = ACTIONS(4921),
    [anon_sym_COMMA] = ACTIONS(4923),
    [anon_sym_RPAREN] = ACTIONS(4923),
    [anon_sym_LPAREN2] = ACTIONS(4923),
    [anon_sym_TILDE] = ACTIONS(4923),
    [anon_sym_STAR] = ACTIONS(4923),
    [anon_sym_PIPE_PIPE] = ACTIONS(4923),
    [anon_sym_AMP_AMP] = ACTIONS(4923),
    [anon_sym_AMP] = ACTIONS(4921),
    [anon_sym_SEMI] = ACTIONS(4923),
    [anon_sym___extension__] = ACTIONS(4921),
    [anon_sym___device__] = ACTIONS(4921),
    [anon_sym___host__] = ACTIONS(4921),
    [anon_sym___global__] = ACTIONS(4921),
    [anon_sym___forceinline__] = ACTIONS(4921),
    [anon_sym___noinline__] = ACTIONS(4921),
    [anon_sym_extern] = ACTIONS(4921),
    [anon_sym___attribute__] = ACTIONS(4921),
    [anon_sym_COLON_COLON] = ACTIONS(4923),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4923),
    [anon_sym___declspec] = ACTIONS(4921),
    [anon_sym___based] = ACTIONS(4921),
    [anon_sym___cdecl] = ACTIONS(4921),
    [anon_sym___clrcall] = ACTIONS(4921),
    [anon_sym___stdcall] = ACTIONS(4921),
    [anon_sym___fastcall] = ACTIONS(4921),
    [anon_sym___thiscall] = ACTIONS(4921),
    [anon_sym___vectorcall] = ACTIONS(4921),
    [anon_sym_LBRACE] = ACTIONS(4923),
    [anon_sym_signed] = ACTIONS(4921),
    [anon_sym_unsigned] = ACTIONS(4921),
    [anon_sym_long] = ACTIONS(4921),
    [anon_sym_short] = ACTIONS(4921),
    [anon_sym_LBRACK] = ACTIONS(4921),
    [anon_sym_static] = ACTIONS(4921),
    [anon_sym_EQ] = ACTIONS(4923),
    [anon_sym_register] = ACTIONS(4921),
    [anon_sym_inline] = ACTIONS(4921),
    [anon_sym___inline] = ACTIONS(4921),
    [anon_sym___inline__] = ACTIONS(4921),
    [anon_sym___forceinline] = ACTIONS(4921),
    [anon_sym_thread_local] = ACTIONS(4921),
    [anon_sym___thread] = ACTIONS(4921),
    [anon_sym_const] = ACTIONS(4921),
    [anon_sym_constexpr] = ACTIONS(4921),
    [anon_sym_volatile] = ACTIONS(4921),
    [anon_sym_restrict] = ACTIONS(4921),
    [anon_sym___restrict__] = ACTIONS(4921),
    [anon_sym__Atomic] = ACTIONS(4921),
    [anon_sym__Noreturn] = ACTIONS(4921),
    [anon_sym_noreturn] = ACTIONS(4921),
    [anon_sym_mutable] = ACTIONS(4921),
    [anon_sym_constinit] = ACTIONS(4921),
    [anon_sym_consteval] = ACTIONS(4921),
    [anon_sym___shared__] = ACTIONS(4921),
    [anon_sym___local__] = ACTIONS(4921),
    [anon_sym___constant__] = ACTIONS(4921),
    [anon_sym___managed__] = ACTIONS(4921),
    [anon_sym___grid_constant__] = ACTIONS(4921),
    [anon_sym_alignas] = ACTIONS(4921),
    [anon_sym__Alignas] = ACTIONS(4921),
    [sym_primitive_type] = ACTIONS(4921),
    [anon_sym_enum] = ACTIONS(4921),
    [anon_sym_class] = ACTIONS(4921),
    [anon_sym_struct] = ACTIONS(4921),
    [anon_sym_union] = ACTIONS(4921),
    [anon_sym_or] = ACTIONS(4921),
    [anon_sym_and] = ACTIONS(4921),
    [anon_sym_asm] = ACTIONS(4921),
    [anon_sym___asm__] = ACTIONS(4921),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4921),
    [anon_sym_decltype] = ACTIONS(4921),
    [anon_sym_final] = ACTIONS(4921),
    [anon_sym_override] = ACTIONS(4921),
    [sym_virtual] = ACTIONS(4921),
    [anon_sym_explicit] = ACTIONS(4921),
    [anon_sym_typename] = ACTIONS(4921),
    [anon_sym_template] = ACTIONS(4921),
    [anon_sym_GT2] = ACTIONS(4923),
    [anon_sym_operator] = ACTIONS(4921),
    [anon_sym_try] = ACTIONS(4921),
    [anon_sym_friend] = ACTIONS(4921),
    [anon_sym_using] = ACTIONS(4921),
    [anon_sym_concept] = ACTIONS(4921),
    [anon_sym_requires] = ACTIONS(4921),
    [anon_sym___launch_bounds__] = ACTIONS(4921),
  },
  [1668] = {
    [sym_identifier] = ACTIONS(4925),
    [anon_sym_COMMA] = ACTIONS(4927),
    [anon_sym_RPAREN] = ACTIONS(4927),
    [anon_sym_LPAREN2] = ACTIONS(4927),
    [anon_sym_TILDE] = ACTIONS(4927),
    [anon_sym_STAR] = ACTIONS(4927),
    [anon_sym_PIPE_PIPE] = ACTIONS(4927),
    [anon_sym_AMP_AMP] = ACTIONS(4927),
    [anon_sym_AMP] = ACTIONS(4925),
    [anon_sym_SEMI] = ACTIONS(4927),
    [anon_sym___extension__] = ACTIONS(4925),
    [anon_sym___device__] = ACTIONS(4925),
    [anon_sym___host__] = ACTIONS(4925),
    [anon_sym___global__] = ACTIONS(4925),
    [anon_sym___forceinline__] = ACTIONS(4925),
    [anon_sym___noinline__] = ACTIONS(4925),
    [anon_sym_extern] = ACTIONS(4925),
    [anon_sym___attribute__] = ACTIONS(4925),
    [anon_sym_COLON_COLON] = ACTIONS(4927),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4927),
    [anon_sym___declspec] = ACTIONS(4925),
    [anon_sym___based] = ACTIONS(4925),
    [anon_sym___cdecl] = ACTIONS(4925),
    [anon_sym___clrcall] = ACTIONS(4925),
    [anon_sym___stdcall] = ACTIONS(4925),
    [anon_sym___fastcall] = ACTIONS(4925),
    [anon_sym___thiscall] = ACTIONS(4925),
    [anon_sym___vectorcall] = ACTIONS(4925),
    [anon_sym_LBRACE] = ACTIONS(4927),
    [anon_sym_signed] = ACTIONS(4925),
    [anon_sym_unsigned] = ACTIONS(4925),
    [anon_sym_long] = ACTIONS(4925),
    [anon_sym_short] = ACTIONS(4925),
    [anon_sym_LBRACK] = ACTIONS(4925),
    [anon_sym_static] = ACTIONS(4925),
    [anon_sym_EQ] = ACTIONS(4927),
    [anon_sym_register] = ACTIONS(4925),
    [anon_sym_inline] = ACTIONS(4925),
    [anon_sym___inline] = ACTIONS(4925),
    [anon_sym___inline__] = ACTIONS(4925),
    [anon_sym___forceinline] = ACTIONS(4925),
    [anon_sym_thread_local] = ACTIONS(4925),
    [anon_sym___thread] = ACTIONS(4925),
    [anon_sym_const] = ACTIONS(4925),
    [anon_sym_constexpr] = ACTIONS(4925),
    [anon_sym_volatile] = ACTIONS(4925),
    [anon_sym_restrict] = ACTIONS(4925),
    [anon_sym___restrict__] = ACTIONS(4925),
    [anon_sym__Atomic] = ACTIONS(4925),
    [anon_sym__Noreturn] = ACTIONS(4925),
    [anon_sym_noreturn] = ACTIONS(4925),
    [anon_sym_mutable] = ACTIONS(4925),
    [anon_sym_constinit] = ACTIONS(4925),
    [anon_sym_consteval] = ACTIONS(4925),
    [anon_sym___shared__] = ACTIONS(4925),
    [anon_sym___local__] = ACTIONS(4925),
    [anon_sym___constant__] = ACTIONS(4925),
    [anon_sym___managed__] = ACTIONS(4925),
    [anon_sym___grid_constant__] = ACTIONS(4925),
    [anon_sym_alignas] = ACTIONS(4925),
    [anon_sym__Alignas] = ACTIONS(4925),
    [sym_primitive_type] = ACTIONS(4925),
    [anon_sym_enum] = ACTIONS(4925),
    [anon_sym_class] = ACTIONS(4925),
    [anon_sym_struct] = ACTIONS(4925),
    [anon_sym_union] = ACTIONS(4925),
    [anon_sym_or] = ACTIONS(4925),
    [anon_sym_and] = ACTIONS(4925),
    [anon_sym_asm] = ACTIONS(4925),
    [anon_sym___asm__] = ACTIONS(4925),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4925),
    [anon_sym_decltype] = ACTIONS(4925),
    [anon_sym_final] = ACTIONS(4925),
    [anon_sym_override] = ACTIONS(4925),
    [sym_virtual] = ACTIONS(4925),
    [anon_sym_explicit] = ACTIONS(4925),
    [anon_sym_typename] = ACTIONS(4925),
    [anon_sym_template] = ACTIONS(4925),
    [anon_sym_GT2] = ACTIONS(4927),
    [anon_sym_operator] = ACTIONS(4925),
    [anon_sym_try] = ACTIONS(4925),
    [anon_sym_friend] = ACTIONS(4925),
    [anon_sym_using] = ACTIONS(4925),
    [anon_sym_concept] = ACTIONS(4925),
    [anon_sym_requires] = ACTIONS(4925),
    [anon_sym___launch_bounds__] = ACTIONS(4925),
  },
  [1669] = {
    [sym_identifier] = ACTIONS(4929),
    [anon_sym_COMMA] = ACTIONS(4931),
    [anon_sym_RPAREN] = ACTIONS(4931),
    [anon_sym_LPAREN2] = ACTIONS(4931),
    [anon_sym_TILDE] = ACTIONS(4931),
    [anon_sym_STAR] = ACTIONS(4931),
    [anon_sym_PIPE_PIPE] = ACTIONS(4931),
    [anon_sym_AMP_AMP] = ACTIONS(4931),
    [anon_sym_AMP] = ACTIONS(4929),
    [anon_sym_SEMI] = ACTIONS(4931),
    [anon_sym___extension__] = ACTIONS(4929),
    [anon_sym___device__] = ACTIONS(4929),
    [anon_sym___host__] = ACTIONS(4929),
    [anon_sym___global__] = ACTIONS(4929),
    [anon_sym___forceinline__] = ACTIONS(4929),
    [anon_sym___noinline__] = ACTIONS(4929),
    [anon_sym_extern] = ACTIONS(4929),
    [anon_sym___attribute__] = ACTIONS(4929),
    [anon_sym_COLON_COLON] = ACTIONS(4931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4931),
    [anon_sym___declspec] = ACTIONS(4929),
    [anon_sym___based] = ACTIONS(4929),
    [anon_sym___cdecl] = ACTIONS(4929),
    [anon_sym___clrcall] = ACTIONS(4929),
    [anon_sym___stdcall] = ACTIONS(4929),
    [anon_sym___fastcall] = ACTIONS(4929),
    [anon_sym___thiscall] = ACTIONS(4929),
    [anon_sym___vectorcall] = ACTIONS(4929),
    [anon_sym_LBRACE] = ACTIONS(4931),
    [anon_sym_signed] = ACTIONS(4929),
    [anon_sym_unsigned] = ACTIONS(4929),
    [anon_sym_long] = ACTIONS(4929),
    [anon_sym_short] = ACTIONS(4929),
    [anon_sym_LBRACK] = ACTIONS(4929),
    [anon_sym_static] = ACTIONS(4929),
    [anon_sym_EQ] = ACTIONS(4931),
    [anon_sym_register] = ACTIONS(4929),
    [anon_sym_inline] = ACTIONS(4929),
    [anon_sym___inline] = ACTIONS(4929),
    [anon_sym___inline__] = ACTIONS(4929),
    [anon_sym___forceinline] = ACTIONS(4929),
    [anon_sym_thread_local] = ACTIONS(4929),
    [anon_sym___thread] = ACTIONS(4929),
    [anon_sym_const] = ACTIONS(4929),
    [anon_sym_constexpr] = ACTIONS(4929),
    [anon_sym_volatile] = ACTIONS(4929),
    [anon_sym_restrict] = ACTIONS(4929),
    [anon_sym___restrict__] = ACTIONS(4929),
    [anon_sym__Atomic] = ACTIONS(4929),
    [anon_sym__Noreturn] = ACTIONS(4929),
    [anon_sym_noreturn] = ACTIONS(4929),
    [anon_sym_mutable] = ACTIONS(4929),
    [anon_sym_constinit] = ACTIONS(4929),
    [anon_sym_consteval] = ACTIONS(4929),
    [anon_sym___shared__] = ACTIONS(4929),
    [anon_sym___local__] = ACTIONS(4929),
    [anon_sym___constant__] = ACTIONS(4929),
    [anon_sym___managed__] = ACTIONS(4929),
    [anon_sym___grid_constant__] = ACTIONS(4929),
    [anon_sym_alignas] = ACTIONS(4929),
    [anon_sym__Alignas] = ACTIONS(4929),
    [sym_primitive_type] = ACTIONS(4929),
    [anon_sym_enum] = ACTIONS(4929),
    [anon_sym_class] = ACTIONS(4929),
    [anon_sym_struct] = ACTIONS(4929),
    [anon_sym_union] = ACTIONS(4929),
    [anon_sym_or] = ACTIONS(4929),
    [anon_sym_and] = ACTIONS(4929),
    [anon_sym_asm] = ACTIONS(4929),
    [anon_sym___asm__] = ACTIONS(4929),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4929),
    [anon_sym_decltype] = ACTIONS(4929),
    [anon_sym_final] = ACTIONS(4929),
    [anon_sym_override] = ACTIONS(4929),
    [sym_virtual] = ACTIONS(4929),
    [anon_sym_explicit] = ACTIONS(4929),
    [anon_sym_typename] = ACTIONS(4929),
    [anon_sym_template] = ACTIONS(4929),
    [anon_sym_GT2] = ACTIONS(4931),
    [anon_sym_operator] = ACTIONS(4929),
    [anon_sym_try] = ACTIONS(4929),
    [anon_sym_friend] = ACTIONS(4929),
    [anon_sym_using] = ACTIONS(4929),
    [anon_sym_concept] = ACTIONS(4929),
    [anon_sym_requires] = ACTIONS(4929),
    [anon_sym___launch_bounds__] = ACTIONS(4929),
  },
  [1670] = {
    [sym_identifier] = ACTIONS(4933),
    [anon_sym_COMMA] = ACTIONS(4935),
    [anon_sym_RPAREN] = ACTIONS(4935),
    [anon_sym_LPAREN2] = ACTIONS(4935),
    [anon_sym_TILDE] = ACTIONS(4935),
    [anon_sym_STAR] = ACTIONS(4935),
    [anon_sym_PIPE_PIPE] = ACTIONS(4935),
    [anon_sym_AMP_AMP] = ACTIONS(4935),
    [anon_sym_AMP] = ACTIONS(4933),
    [anon_sym_SEMI] = ACTIONS(4935),
    [anon_sym___extension__] = ACTIONS(4933),
    [anon_sym___device__] = ACTIONS(4933),
    [anon_sym___host__] = ACTIONS(4933),
    [anon_sym___global__] = ACTIONS(4933),
    [anon_sym___forceinline__] = ACTIONS(4933),
    [anon_sym___noinline__] = ACTIONS(4933),
    [anon_sym_extern] = ACTIONS(4933),
    [anon_sym___attribute__] = ACTIONS(4933),
    [anon_sym_COLON_COLON] = ACTIONS(4935),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4935),
    [anon_sym___declspec] = ACTIONS(4933),
    [anon_sym___based] = ACTIONS(4933),
    [anon_sym___cdecl] = ACTIONS(4933),
    [anon_sym___clrcall] = ACTIONS(4933),
    [anon_sym___stdcall] = ACTIONS(4933),
    [anon_sym___fastcall] = ACTIONS(4933),
    [anon_sym___thiscall] = ACTIONS(4933),
    [anon_sym___vectorcall] = ACTIONS(4933),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [anon_sym_signed] = ACTIONS(4933),
    [anon_sym_unsigned] = ACTIONS(4933),
    [anon_sym_long] = ACTIONS(4933),
    [anon_sym_short] = ACTIONS(4933),
    [anon_sym_LBRACK] = ACTIONS(4933),
    [anon_sym_static] = ACTIONS(4933),
    [anon_sym_EQ] = ACTIONS(4935),
    [anon_sym_register] = ACTIONS(4933),
    [anon_sym_inline] = ACTIONS(4933),
    [anon_sym___inline] = ACTIONS(4933),
    [anon_sym___inline__] = ACTIONS(4933),
    [anon_sym___forceinline] = ACTIONS(4933),
    [anon_sym_thread_local] = ACTIONS(4933),
    [anon_sym___thread] = ACTIONS(4933),
    [anon_sym_const] = ACTIONS(4933),
    [anon_sym_constexpr] = ACTIONS(4933),
    [anon_sym_volatile] = ACTIONS(4933),
    [anon_sym_restrict] = ACTIONS(4933),
    [anon_sym___restrict__] = ACTIONS(4933),
    [anon_sym__Atomic] = ACTIONS(4933),
    [anon_sym__Noreturn] = ACTIONS(4933),
    [anon_sym_noreturn] = ACTIONS(4933),
    [anon_sym_mutable] = ACTIONS(4933),
    [anon_sym_constinit] = ACTIONS(4933),
    [anon_sym_consteval] = ACTIONS(4933),
    [anon_sym___shared__] = ACTIONS(4933),
    [anon_sym___local__] = ACTIONS(4933),
    [anon_sym___constant__] = ACTIONS(4933),
    [anon_sym___managed__] = ACTIONS(4933),
    [anon_sym___grid_constant__] = ACTIONS(4933),
    [anon_sym_alignas] = ACTIONS(4933),
    [anon_sym__Alignas] = ACTIONS(4933),
    [sym_primitive_type] = ACTIONS(4933),
    [anon_sym_enum] = ACTIONS(4933),
    [anon_sym_class] = ACTIONS(4933),
    [anon_sym_struct] = ACTIONS(4933),
    [anon_sym_union] = ACTIONS(4933),
    [anon_sym_or] = ACTIONS(4933),
    [anon_sym_and] = ACTIONS(4933),
    [anon_sym_asm] = ACTIONS(4933),
    [anon_sym___asm__] = ACTIONS(4933),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4933),
    [anon_sym_decltype] = ACTIONS(4933),
    [anon_sym_final] = ACTIONS(4933),
    [anon_sym_override] = ACTIONS(4933),
    [sym_virtual] = ACTIONS(4933),
    [anon_sym_explicit] = ACTIONS(4933),
    [anon_sym_typename] = ACTIONS(4933),
    [anon_sym_template] = ACTIONS(4933),
    [anon_sym_GT2] = ACTIONS(4935),
    [anon_sym_operator] = ACTIONS(4933),
    [anon_sym_try] = ACTIONS(4933),
    [anon_sym_friend] = ACTIONS(4933),
    [anon_sym_using] = ACTIONS(4933),
    [anon_sym_concept] = ACTIONS(4933),
    [anon_sym_requires] = ACTIONS(4933),
    [anon_sym___launch_bounds__] = ACTIONS(4933),
  },
  [1671] = {
    [sym_identifier] = ACTIONS(4937),
    [anon_sym_COMMA] = ACTIONS(4939),
    [anon_sym_RPAREN] = ACTIONS(4939),
    [anon_sym_LPAREN2] = ACTIONS(4939),
    [anon_sym_TILDE] = ACTIONS(4939),
    [anon_sym_STAR] = ACTIONS(4939),
    [anon_sym_PIPE_PIPE] = ACTIONS(4939),
    [anon_sym_AMP_AMP] = ACTIONS(4939),
    [anon_sym_AMP] = ACTIONS(4937),
    [anon_sym_SEMI] = ACTIONS(4939),
    [anon_sym___extension__] = ACTIONS(4937),
    [anon_sym___device__] = ACTIONS(4937),
    [anon_sym___host__] = ACTIONS(4937),
    [anon_sym___global__] = ACTIONS(4937),
    [anon_sym___forceinline__] = ACTIONS(4937),
    [anon_sym___noinline__] = ACTIONS(4937),
    [anon_sym_extern] = ACTIONS(4937),
    [anon_sym___attribute__] = ACTIONS(4937),
    [anon_sym_COLON_COLON] = ACTIONS(4939),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4939),
    [anon_sym___declspec] = ACTIONS(4937),
    [anon_sym___based] = ACTIONS(4937),
    [anon_sym___cdecl] = ACTIONS(4937),
    [anon_sym___clrcall] = ACTIONS(4937),
    [anon_sym___stdcall] = ACTIONS(4937),
    [anon_sym___fastcall] = ACTIONS(4937),
    [anon_sym___thiscall] = ACTIONS(4937),
    [anon_sym___vectorcall] = ACTIONS(4937),
    [anon_sym_LBRACE] = ACTIONS(4939),
    [anon_sym_signed] = ACTIONS(4937),
    [anon_sym_unsigned] = ACTIONS(4937),
    [anon_sym_long] = ACTIONS(4937),
    [anon_sym_short] = ACTIONS(4937),
    [anon_sym_LBRACK] = ACTIONS(4937),
    [anon_sym_static] = ACTIONS(4937),
    [anon_sym_EQ] = ACTIONS(4939),
    [anon_sym_register] = ACTIONS(4937),
    [anon_sym_inline] = ACTIONS(4937),
    [anon_sym___inline] = ACTIONS(4937),
    [anon_sym___inline__] = ACTIONS(4937),
    [anon_sym___forceinline] = ACTIONS(4937),
    [anon_sym_thread_local] = ACTIONS(4937),
    [anon_sym___thread] = ACTIONS(4937),
    [anon_sym_const] = ACTIONS(4937),
    [anon_sym_constexpr] = ACTIONS(4937),
    [anon_sym_volatile] = ACTIONS(4937),
    [anon_sym_restrict] = ACTIONS(4937),
    [anon_sym___restrict__] = ACTIONS(4937),
    [anon_sym__Atomic] = ACTIONS(4937),
    [anon_sym__Noreturn] = ACTIONS(4937),
    [anon_sym_noreturn] = ACTIONS(4937),
    [anon_sym_mutable] = ACTIONS(4937),
    [anon_sym_constinit] = ACTIONS(4937),
    [anon_sym_consteval] = ACTIONS(4937),
    [anon_sym___shared__] = ACTIONS(4937),
    [anon_sym___local__] = ACTIONS(4937),
    [anon_sym___constant__] = ACTIONS(4937),
    [anon_sym___managed__] = ACTIONS(4937),
    [anon_sym___grid_constant__] = ACTIONS(4937),
    [anon_sym_alignas] = ACTIONS(4937),
    [anon_sym__Alignas] = ACTIONS(4937),
    [sym_primitive_type] = ACTIONS(4937),
    [anon_sym_enum] = ACTIONS(4937),
    [anon_sym_class] = ACTIONS(4937),
    [anon_sym_struct] = ACTIONS(4937),
    [anon_sym_union] = ACTIONS(4937),
    [anon_sym_or] = ACTIONS(4937),
    [anon_sym_and] = ACTIONS(4937),
    [anon_sym_asm] = ACTIONS(4937),
    [anon_sym___asm__] = ACTIONS(4937),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4937),
    [anon_sym_decltype] = ACTIONS(4937),
    [anon_sym_final] = ACTIONS(4937),
    [anon_sym_override] = ACTIONS(4937),
    [sym_virtual] = ACTIONS(4937),
    [anon_sym_explicit] = ACTIONS(4937),
    [anon_sym_typename] = ACTIONS(4937),
    [anon_sym_template] = ACTIONS(4937),
    [anon_sym_GT2] = ACTIONS(4939),
    [anon_sym_operator] = ACTIONS(4937),
    [anon_sym_try] = ACTIONS(4937),
    [anon_sym_friend] = ACTIONS(4937),
    [anon_sym_using] = ACTIONS(4937),
    [anon_sym_concept] = ACTIONS(4937),
    [anon_sym_requires] = ACTIONS(4937),
    [anon_sym___launch_bounds__] = ACTIONS(4937),
  },
  [1672] = {
    [sym_identifier] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(4943),
    [anon_sym_RPAREN] = ACTIONS(4943),
    [anon_sym_LPAREN2] = ACTIONS(4943),
    [anon_sym_TILDE] = ACTIONS(4943),
    [anon_sym_STAR] = ACTIONS(4943),
    [anon_sym_PIPE_PIPE] = ACTIONS(4943),
    [anon_sym_AMP_AMP] = ACTIONS(4943),
    [anon_sym_AMP] = ACTIONS(4941),
    [anon_sym_SEMI] = ACTIONS(4943),
    [anon_sym___extension__] = ACTIONS(4941),
    [anon_sym___device__] = ACTIONS(4941),
    [anon_sym___host__] = ACTIONS(4941),
    [anon_sym___global__] = ACTIONS(4941),
    [anon_sym___forceinline__] = ACTIONS(4941),
    [anon_sym___noinline__] = ACTIONS(4941),
    [anon_sym_extern] = ACTIONS(4941),
    [anon_sym___attribute__] = ACTIONS(4941),
    [anon_sym_COLON_COLON] = ACTIONS(4943),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4943),
    [anon_sym___declspec] = ACTIONS(4941),
    [anon_sym___based] = ACTIONS(4941),
    [anon_sym___cdecl] = ACTIONS(4941),
    [anon_sym___clrcall] = ACTIONS(4941),
    [anon_sym___stdcall] = ACTIONS(4941),
    [anon_sym___fastcall] = ACTIONS(4941),
    [anon_sym___thiscall] = ACTIONS(4941),
    [anon_sym___vectorcall] = ACTIONS(4941),
    [anon_sym_LBRACE] = ACTIONS(4943),
    [anon_sym_signed] = ACTIONS(4941),
    [anon_sym_unsigned] = ACTIONS(4941),
    [anon_sym_long] = ACTIONS(4941),
    [anon_sym_short] = ACTIONS(4941),
    [anon_sym_LBRACK] = ACTIONS(4941),
    [anon_sym_static] = ACTIONS(4941),
    [anon_sym_EQ] = ACTIONS(4943),
    [anon_sym_register] = ACTIONS(4941),
    [anon_sym_inline] = ACTIONS(4941),
    [anon_sym___inline] = ACTIONS(4941),
    [anon_sym___inline__] = ACTIONS(4941),
    [anon_sym___forceinline] = ACTIONS(4941),
    [anon_sym_thread_local] = ACTIONS(4941),
    [anon_sym___thread] = ACTIONS(4941),
    [anon_sym_const] = ACTIONS(4941),
    [anon_sym_constexpr] = ACTIONS(4941),
    [anon_sym_volatile] = ACTIONS(4941),
    [anon_sym_restrict] = ACTIONS(4941),
    [anon_sym___restrict__] = ACTIONS(4941),
    [anon_sym__Atomic] = ACTIONS(4941),
    [anon_sym__Noreturn] = ACTIONS(4941),
    [anon_sym_noreturn] = ACTIONS(4941),
    [anon_sym_mutable] = ACTIONS(4941),
    [anon_sym_constinit] = ACTIONS(4941),
    [anon_sym_consteval] = ACTIONS(4941),
    [anon_sym___shared__] = ACTIONS(4941),
    [anon_sym___local__] = ACTIONS(4941),
    [anon_sym___constant__] = ACTIONS(4941),
    [anon_sym___managed__] = ACTIONS(4941),
    [anon_sym___grid_constant__] = ACTIONS(4941),
    [anon_sym_alignas] = ACTIONS(4941),
    [anon_sym__Alignas] = ACTIONS(4941),
    [sym_primitive_type] = ACTIONS(4941),
    [anon_sym_enum] = ACTIONS(4941),
    [anon_sym_class] = ACTIONS(4941),
    [anon_sym_struct] = ACTIONS(4941),
    [anon_sym_union] = ACTIONS(4941),
    [anon_sym_or] = ACTIONS(4941),
    [anon_sym_and] = ACTIONS(4941),
    [anon_sym_asm] = ACTIONS(4941),
    [anon_sym___asm__] = ACTIONS(4941),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4941),
    [anon_sym_decltype] = ACTIONS(4941),
    [anon_sym_final] = ACTIONS(4941),
    [anon_sym_override] = ACTIONS(4941),
    [sym_virtual] = ACTIONS(4941),
    [anon_sym_explicit] = ACTIONS(4941),
    [anon_sym_typename] = ACTIONS(4941),
    [anon_sym_template] = ACTIONS(4941),
    [anon_sym_GT2] = ACTIONS(4943),
    [anon_sym_operator] = ACTIONS(4941),
    [anon_sym_try] = ACTIONS(4941),
    [anon_sym_friend] = ACTIONS(4941),
    [anon_sym_using] = ACTIONS(4941),
    [anon_sym_concept] = ACTIONS(4941),
    [anon_sym_requires] = ACTIONS(4941),
    [anon_sym___launch_bounds__] = ACTIONS(4941),
  },
  [1673] = {
    [sym_identifier] = ACTIONS(4945),
    [anon_sym_COMMA] = ACTIONS(4947),
    [anon_sym_RPAREN] = ACTIONS(4947),
    [anon_sym_LPAREN2] = ACTIONS(4947),
    [anon_sym_TILDE] = ACTIONS(4947),
    [anon_sym_STAR] = ACTIONS(4947),
    [anon_sym_PIPE_PIPE] = ACTIONS(4947),
    [anon_sym_AMP_AMP] = ACTIONS(4947),
    [anon_sym_AMP] = ACTIONS(4945),
    [anon_sym_SEMI] = ACTIONS(4947),
    [anon_sym___extension__] = ACTIONS(4945),
    [anon_sym___device__] = ACTIONS(4945),
    [anon_sym___host__] = ACTIONS(4945),
    [anon_sym___global__] = ACTIONS(4945),
    [anon_sym___forceinline__] = ACTIONS(4945),
    [anon_sym___noinline__] = ACTIONS(4945),
    [anon_sym_extern] = ACTIONS(4945),
    [anon_sym___attribute__] = ACTIONS(4945),
    [anon_sym_COLON_COLON] = ACTIONS(4947),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4947),
    [anon_sym___declspec] = ACTIONS(4945),
    [anon_sym___based] = ACTIONS(4945),
    [anon_sym___cdecl] = ACTIONS(4945),
    [anon_sym___clrcall] = ACTIONS(4945),
    [anon_sym___stdcall] = ACTIONS(4945),
    [anon_sym___fastcall] = ACTIONS(4945),
    [anon_sym___thiscall] = ACTIONS(4945),
    [anon_sym___vectorcall] = ACTIONS(4945),
    [anon_sym_LBRACE] = ACTIONS(4947),
    [anon_sym_signed] = ACTIONS(4945),
    [anon_sym_unsigned] = ACTIONS(4945),
    [anon_sym_long] = ACTIONS(4945),
    [anon_sym_short] = ACTIONS(4945),
    [anon_sym_LBRACK] = ACTIONS(4945),
    [anon_sym_static] = ACTIONS(4945),
    [anon_sym_EQ] = ACTIONS(4947),
    [anon_sym_register] = ACTIONS(4945),
    [anon_sym_inline] = ACTIONS(4945),
    [anon_sym___inline] = ACTIONS(4945),
    [anon_sym___inline__] = ACTIONS(4945),
    [anon_sym___forceinline] = ACTIONS(4945),
    [anon_sym_thread_local] = ACTIONS(4945),
    [anon_sym___thread] = ACTIONS(4945),
    [anon_sym_const] = ACTIONS(4945),
    [anon_sym_constexpr] = ACTIONS(4945),
    [anon_sym_volatile] = ACTIONS(4945),
    [anon_sym_restrict] = ACTIONS(4945),
    [anon_sym___restrict__] = ACTIONS(4945),
    [anon_sym__Atomic] = ACTIONS(4945),
    [anon_sym__Noreturn] = ACTIONS(4945),
    [anon_sym_noreturn] = ACTIONS(4945),
    [anon_sym_mutable] = ACTIONS(4945),
    [anon_sym_constinit] = ACTIONS(4945),
    [anon_sym_consteval] = ACTIONS(4945),
    [anon_sym___shared__] = ACTIONS(4945),
    [anon_sym___local__] = ACTIONS(4945),
    [anon_sym___constant__] = ACTIONS(4945),
    [anon_sym___managed__] = ACTIONS(4945),
    [anon_sym___grid_constant__] = ACTIONS(4945),
    [anon_sym_alignas] = ACTIONS(4945),
    [anon_sym__Alignas] = ACTIONS(4945),
    [sym_primitive_type] = ACTIONS(4945),
    [anon_sym_enum] = ACTIONS(4945),
    [anon_sym_class] = ACTIONS(4945),
    [anon_sym_struct] = ACTIONS(4945),
    [anon_sym_union] = ACTIONS(4945),
    [anon_sym_or] = ACTIONS(4945),
    [anon_sym_and] = ACTIONS(4945),
    [anon_sym_asm] = ACTIONS(4945),
    [anon_sym___asm__] = ACTIONS(4945),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4945),
    [anon_sym_decltype] = ACTIONS(4945),
    [anon_sym_final] = ACTIONS(4945),
    [anon_sym_override] = ACTIONS(4945),
    [sym_virtual] = ACTIONS(4945),
    [anon_sym_explicit] = ACTIONS(4945),
    [anon_sym_typename] = ACTIONS(4945),
    [anon_sym_template] = ACTIONS(4945),
    [anon_sym_GT2] = ACTIONS(4947),
    [anon_sym_operator] = ACTIONS(4945),
    [anon_sym_try] = ACTIONS(4945),
    [anon_sym_friend] = ACTIONS(4945),
    [anon_sym_using] = ACTIONS(4945),
    [anon_sym_concept] = ACTIONS(4945),
    [anon_sym_requires] = ACTIONS(4945),
    [anon_sym___launch_bounds__] = ACTIONS(4945),
  },
  [1674] = {
    [sym_identifier] = ACTIONS(4949),
    [anon_sym_COMMA] = ACTIONS(4951),
    [anon_sym_RPAREN] = ACTIONS(4951),
    [anon_sym_LPAREN2] = ACTIONS(4951),
    [anon_sym_TILDE] = ACTIONS(4951),
    [anon_sym_STAR] = ACTIONS(4951),
    [anon_sym_PIPE_PIPE] = ACTIONS(4951),
    [anon_sym_AMP_AMP] = ACTIONS(4951),
    [anon_sym_AMP] = ACTIONS(4949),
    [anon_sym_SEMI] = ACTIONS(4951),
    [anon_sym___extension__] = ACTIONS(4949),
    [anon_sym___device__] = ACTIONS(4949),
    [anon_sym___host__] = ACTIONS(4949),
    [anon_sym___global__] = ACTIONS(4949),
    [anon_sym___forceinline__] = ACTIONS(4949),
    [anon_sym___noinline__] = ACTIONS(4949),
    [anon_sym_extern] = ACTIONS(4949),
    [anon_sym___attribute__] = ACTIONS(4949),
    [anon_sym_COLON_COLON] = ACTIONS(4951),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4951),
    [anon_sym___declspec] = ACTIONS(4949),
    [anon_sym___based] = ACTIONS(4949),
    [anon_sym___cdecl] = ACTIONS(4949),
    [anon_sym___clrcall] = ACTIONS(4949),
    [anon_sym___stdcall] = ACTIONS(4949),
    [anon_sym___fastcall] = ACTIONS(4949),
    [anon_sym___thiscall] = ACTIONS(4949),
    [anon_sym___vectorcall] = ACTIONS(4949),
    [anon_sym_LBRACE] = ACTIONS(4951),
    [anon_sym_signed] = ACTIONS(4949),
    [anon_sym_unsigned] = ACTIONS(4949),
    [anon_sym_long] = ACTIONS(4949),
    [anon_sym_short] = ACTIONS(4949),
    [anon_sym_LBRACK] = ACTIONS(4949),
    [anon_sym_static] = ACTIONS(4949),
    [anon_sym_EQ] = ACTIONS(4951),
    [anon_sym_register] = ACTIONS(4949),
    [anon_sym_inline] = ACTIONS(4949),
    [anon_sym___inline] = ACTIONS(4949),
    [anon_sym___inline__] = ACTIONS(4949),
    [anon_sym___forceinline] = ACTIONS(4949),
    [anon_sym_thread_local] = ACTIONS(4949),
    [anon_sym___thread] = ACTIONS(4949),
    [anon_sym_const] = ACTIONS(4949),
    [anon_sym_constexpr] = ACTIONS(4949),
    [anon_sym_volatile] = ACTIONS(4949),
    [anon_sym_restrict] = ACTIONS(4949),
    [anon_sym___restrict__] = ACTIONS(4949),
    [anon_sym__Atomic] = ACTIONS(4949),
    [anon_sym__Noreturn] = ACTIONS(4949),
    [anon_sym_noreturn] = ACTIONS(4949),
    [anon_sym_mutable] = ACTIONS(4949),
    [anon_sym_constinit] = ACTIONS(4949),
    [anon_sym_consteval] = ACTIONS(4949),
    [anon_sym___shared__] = ACTIONS(4949),
    [anon_sym___local__] = ACTIONS(4949),
    [anon_sym___constant__] = ACTIONS(4949),
    [anon_sym___managed__] = ACTIONS(4949),
    [anon_sym___grid_constant__] = ACTIONS(4949),
    [anon_sym_alignas] = ACTIONS(4949),
    [anon_sym__Alignas] = ACTIONS(4949),
    [sym_primitive_type] = ACTIONS(4949),
    [anon_sym_enum] = ACTIONS(4949),
    [anon_sym_class] = ACTIONS(4949),
    [anon_sym_struct] = ACTIONS(4949),
    [anon_sym_union] = ACTIONS(4949),
    [anon_sym_or] = ACTIONS(4949),
    [anon_sym_and] = ACTIONS(4949),
    [anon_sym_asm] = ACTIONS(4949),
    [anon_sym___asm__] = ACTIONS(4949),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4949),
    [anon_sym_decltype] = ACTIONS(4949),
    [anon_sym_final] = ACTIONS(4949),
    [anon_sym_override] = ACTIONS(4949),
    [sym_virtual] = ACTIONS(4949),
    [anon_sym_explicit] = ACTIONS(4949),
    [anon_sym_typename] = ACTIONS(4949),
    [anon_sym_template] = ACTIONS(4949),
    [anon_sym_GT2] = ACTIONS(4951),
    [anon_sym_operator] = ACTIONS(4949),
    [anon_sym_try] = ACTIONS(4949),
    [anon_sym_friend] = ACTIONS(4949),
    [anon_sym_using] = ACTIONS(4949),
    [anon_sym_concept] = ACTIONS(4949),
    [anon_sym_requires] = ACTIONS(4949),
    [anon_sym___launch_bounds__] = ACTIONS(4949),
  },
  [1675] = {
    [sym_identifier] = ACTIONS(4945),
    [anon_sym_COMMA] = ACTIONS(4947),
    [anon_sym_RPAREN] = ACTIONS(4947),
    [anon_sym_LPAREN2] = ACTIONS(4947),
    [anon_sym_TILDE] = ACTIONS(4947),
    [anon_sym_STAR] = ACTIONS(4947),
    [anon_sym_PIPE_PIPE] = ACTIONS(4947),
    [anon_sym_AMP_AMP] = ACTIONS(4947),
    [anon_sym_AMP] = ACTIONS(4945),
    [anon_sym_SEMI] = ACTIONS(4947),
    [anon_sym___extension__] = ACTIONS(4945),
    [anon_sym___device__] = ACTIONS(4945),
    [anon_sym___host__] = ACTIONS(4945),
    [anon_sym___global__] = ACTIONS(4945),
    [anon_sym___forceinline__] = ACTIONS(4945),
    [anon_sym___noinline__] = ACTIONS(4945),
    [anon_sym_extern] = ACTIONS(4945),
    [anon_sym___attribute__] = ACTIONS(4945),
    [anon_sym_COLON_COLON] = ACTIONS(4947),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4947),
    [anon_sym___declspec] = ACTIONS(4945),
    [anon_sym___based] = ACTIONS(4945),
    [anon_sym___cdecl] = ACTIONS(4945),
    [anon_sym___clrcall] = ACTIONS(4945),
    [anon_sym___stdcall] = ACTIONS(4945),
    [anon_sym___fastcall] = ACTIONS(4945),
    [anon_sym___thiscall] = ACTIONS(4945),
    [anon_sym___vectorcall] = ACTIONS(4945),
    [anon_sym_LBRACE] = ACTIONS(4947),
    [anon_sym_signed] = ACTIONS(4945),
    [anon_sym_unsigned] = ACTIONS(4945),
    [anon_sym_long] = ACTIONS(4945),
    [anon_sym_short] = ACTIONS(4945),
    [anon_sym_LBRACK] = ACTIONS(4945),
    [anon_sym_static] = ACTIONS(4945),
    [anon_sym_EQ] = ACTIONS(4947),
    [anon_sym_register] = ACTIONS(4945),
    [anon_sym_inline] = ACTIONS(4945),
    [anon_sym___inline] = ACTIONS(4945),
    [anon_sym___inline__] = ACTIONS(4945),
    [anon_sym___forceinline] = ACTIONS(4945),
    [anon_sym_thread_local] = ACTIONS(4945),
    [anon_sym___thread] = ACTIONS(4945),
    [anon_sym_const] = ACTIONS(4945),
    [anon_sym_constexpr] = ACTIONS(4945),
    [anon_sym_volatile] = ACTIONS(4945),
    [anon_sym_restrict] = ACTIONS(4945),
    [anon_sym___restrict__] = ACTIONS(4945),
    [anon_sym__Atomic] = ACTIONS(4945),
    [anon_sym__Noreturn] = ACTIONS(4945),
    [anon_sym_noreturn] = ACTIONS(4945),
    [anon_sym_mutable] = ACTIONS(4945),
    [anon_sym_constinit] = ACTIONS(4945),
    [anon_sym_consteval] = ACTIONS(4945),
    [anon_sym___shared__] = ACTIONS(4945),
    [anon_sym___local__] = ACTIONS(4945),
    [anon_sym___constant__] = ACTIONS(4945),
    [anon_sym___managed__] = ACTIONS(4945),
    [anon_sym___grid_constant__] = ACTIONS(4945),
    [anon_sym_alignas] = ACTIONS(4945),
    [anon_sym__Alignas] = ACTIONS(4945),
    [sym_primitive_type] = ACTIONS(4945),
    [anon_sym_enum] = ACTIONS(4945),
    [anon_sym_class] = ACTIONS(4945),
    [anon_sym_struct] = ACTIONS(4945),
    [anon_sym_union] = ACTIONS(4945),
    [anon_sym_or] = ACTIONS(4945),
    [anon_sym_and] = ACTIONS(4945),
    [anon_sym_asm] = ACTIONS(4945),
    [anon_sym___asm__] = ACTIONS(4945),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4945),
    [anon_sym_decltype] = ACTIONS(4945),
    [anon_sym_final] = ACTIONS(4945),
    [anon_sym_override] = ACTIONS(4945),
    [sym_virtual] = ACTIONS(4945),
    [anon_sym_explicit] = ACTIONS(4945),
    [anon_sym_typename] = ACTIONS(4945),
    [anon_sym_template] = ACTIONS(4945),
    [anon_sym_GT2] = ACTIONS(4947),
    [anon_sym_operator] = ACTIONS(4945),
    [anon_sym_try] = ACTIONS(4945),
    [anon_sym_friend] = ACTIONS(4945),
    [anon_sym_using] = ACTIONS(4945),
    [anon_sym_concept] = ACTIONS(4945),
    [anon_sym_requires] = ACTIONS(4945),
    [anon_sym___launch_bounds__] = ACTIONS(4945),
  },
  [1676] = {
    [sym_identifier] = ACTIONS(4953),
    [anon_sym_COMMA] = ACTIONS(4955),
    [anon_sym_RPAREN] = ACTIONS(4955),
    [anon_sym_LPAREN2] = ACTIONS(4955),
    [anon_sym_TILDE] = ACTIONS(4955),
    [anon_sym_STAR] = ACTIONS(4955),
    [anon_sym_PIPE_PIPE] = ACTIONS(4955),
    [anon_sym_AMP_AMP] = ACTIONS(4955),
    [anon_sym_AMP] = ACTIONS(4953),
    [anon_sym_SEMI] = ACTIONS(4955),
    [anon_sym___extension__] = ACTIONS(4953),
    [anon_sym___device__] = ACTIONS(4953),
    [anon_sym___host__] = ACTIONS(4953),
    [anon_sym___global__] = ACTIONS(4953),
    [anon_sym___forceinline__] = ACTIONS(4953),
    [anon_sym___noinline__] = ACTIONS(4953),
    [anon_sym_extern] = ACTIONS(4953),
    [anon_sym___attribute__] = ACTIONS(4953),
    [anon_sym_COLON_COLON] = ACTIONS(4955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4955),
    [anon_sym___declspec] = ACTIONS(4953),
    [anon_sym___based] = ACTIONS(4953),
    [anon_sym___cdecl] = ACTIONS(4953),
    [anon_sym___clrcall] = ACTIONS(4953),
    [anon_sym___stdcall] = ACTIONS(4953),
    [anon_sym___fastcall] = ACTIONS(4953),
    [anon_sym___thiscall] = ACTIONS(4953),
    [anon_sym___vectorcall] = ACTIONS(4953),
    [anon_sym_LBRACE] = ACTIONS(4955),
    [anon_sym_signed] = ACTIONS(4953),
    [anon_sym_unsigned] = ACTIONS(4953),
    [anon_sym_long] = ACTIONS(4953),
    [anon_sym_short] = ACTIONS(4953),
    [anon_sym_LBRACK] = ACTIONS(4953),
    [anon_sym_static] = ACTIONS(4953),
    [anon_sym_EQ] = ACTIONS(4955),
    [anon_sym_register] = ACTIONS(4953),
    [anon_sym_inline] = ACTIONS(4953),
    [anon_sym___inline] = ACTIONS(4953),
    [anon_sym___inline__] = ACTIONS(4953),
    [anon_sym___forceinline] = ACTIONS(4953),
    [anon_sym_thread_local] = ACTIONS(4953),
    [anon_sym___thread] = ACTIONS(4953),
    [anon_sym_const] = ACTIONS(4953),
    [anon_sym_constexpr] = ACTIONS(4953),
    [anon_sym_volatile] = ACTIONS(4953),
    [anon_sym_restrict] = ACTIONS(4953),
    [anon_sym___restrict__] = ACTIONS(4953),
    [anon_sym__Atomic] = ACTIONS(4953),
    [anon_sym__Noreturn] = ACTIONS(4953),
    [anon_sym_noreturn] = ACTIONS(4953),
    [anon_sym_mutable] = ACTIONS(4953),
    [anon_sym_constinit] = ACTIONS(4953),
    [anon_sym_consteval] = ACTIONS(4953),
    [anon_sym___shared__] = ACTIONS(4953),
    [anon_sym___local__] = ACTIONS(4953),
    [anon_sym___constant__] = ACTIONS(4953),
    [anon_sym___managed__] = ACTIONS(4953),
    [anon_sym___grid_constant__] = ACTIONS(4953),
    [anon_sym_alignas] = ACTIONS(4953),
    [anon_sym__Alignas] = ACTIONS(4953),
    [sym_primitive_type] = ACTIONS(4953),
    [anon_sym_enum] = ACTIONS(4953),
    [anon_sym_class] = ACTIONS(4953),
    [anon_sym_struct] = ACTIONS(4953),
    [anon_sym_union] = ACTIONS(4953),
    [anon_sym_or] = ACTIONS(4953),
    [anon_sym_and] = ACTIONS(4953),
    [anon_sym_asm] = ACTIONS(4953),
    [anon_sym___asm__] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4953),
    [anon_sym_decltype] = ACTIONS(4953),
    [anon_sym_final] = ACTIONS(4953),
    [anon_sym_override] = ACTIONS(4953),
    [sym_virtual] = ACTIONS(4953),
    [anon_sym_explicit] = ACTIONS(4953),
    [anon_sym_typename] = ACTIONS(4953),
    [anon_sym_template] = ACTIONS(4953),
    [anon_sym_GT2] = ACTIONS(4955),
    [anon_sym_operator] = ACTIONS(4953),
    [anon_sym_try] = ACTIONS(4953),
    [anon_sym_friend] = ACTIONS(4953),
    [anon_sym_using] = ACTIONS(4953),
    [anon_sym_concept] = ACTIONS(4953),
    [anon_sym_requires] = ACTIONS(4953),
    [anon_sym___launch_bounds__] = ACTIONS(4953),
  },
  [1677] = {
    [sym__declaration_modifiers] = STATE(1847),
    [sym__declaration_specifiers] = STATE(4513),
    [sym_attribute_specifier] = STATE(1847),
    [sym_attribute_declaration] = STATE(1847),
    [sym_ms_declspec_modifier] = STATE(1847),
    [sym_storage_class_specifier] = STATE(1847),
    [sym_type_qualifier] = STATE(1847),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_parameter_declaration] = STATE(7626),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_type_parameter_declaration] = STATE(7626),
    [sym_variadic_type_parameter_declaration] = STATE(7626),
    [sym_optional_type_parameter_declaration] = STATE(7626),
    [sym_template_template_parameter_declaration] = STATE(7626),
    [sym_optional_parameter_declaration] = STATE(7626),
    [sym_variadic_parameter_declaration] = STATE(7626),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6858),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_launch_bounds] = STATE(1847),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1847),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1765),
    [anon_sym___host__] = ACTIONS(1765),
    [anon_sym___global__] = ACTIONS(1765),
    [anon_sym___forceinline__] = ACTIONS(1765),
    [anon_sym___noinline__] = ACTIONS(1765),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(1771),
    [anon_sym_class] = ACTIONS(4957),
    [anon_sym_struct] = ACTIONS(1775),
    [anon_sym_union] = ACTIONS(1777),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1765),
    [anon_sym_typename] = ACTIONS(4959),
    [anon_sym_template] = ACTIONS(4961),
    [anon_sym_GT2] = ACTIONS(4963),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1678] = {
    [sym__declaration_modifiers] = STATE(1847),
    [sym__declaration_specifiers] = STATE(4513),
    [sym_attribute_specifier] = STATE(1847),
    [sym_attribute_declaration] = STATE(1847),
    [sym_ms_declspec_modifier] = STATE(1847),
    [sym_storage_class_specifier] = STATE(1847),
    [sym_type_qualifier] = STATE(1847),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_parameter_declaration] = STATE(7404),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_type_parameter_declaration] = STATE(7404),
    [sym_variadic_type_parameter_declaration] = STATE(7404),
    [sym_optional_type_parameter_declaration] = STATE(7404),
    [sym_template_template_parameter_declaration] = STATE(7404),
    [sym_optional_parameter_declaration] = STATE(7404),
    [sym_variadic_parameter_declaration] = STATE(7404),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6858),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_launch_bounds] = STATE(1847),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1847),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1765),
    [anon_sym___host__] = ACTIONS(1765),
    [anon_sym___global__] = ACTIONS(1765),
    [anon_sym___forceinline__] = ACTIONS(1765),
    [anon_sym___noinline__] = ACTIONS(1765),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(1771),
    [anon_sym_class] = ACTIONS(4957),
    [anon_sym_struct] = ACTIONS(1775),
    [anon_sym_union] = ACTIONS(1777),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1765),
    [anon_sym_typename] = ACTIONS(4959),
    [anon_sym_template] = ACTIONS(4961),
    [anon_sym_GT2] = ACTIONS(4965),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1679] = {
    [sym_identifier] = ACTIONS(4967),
    [anon_sym_COMMA] = ACTIONS(4969),
    [anon_sym_RPAREN] = ACTIONS(4969),
    [anon_sym_LPAREN2] = ACTIONS(4969),
    [anon_sym_TILDE] = ACTIONS(4969),
    [anon_sym_STAR] = ACTIONS(4969),
    [anon_sym_PIPE_PIPE] = ACTIONS(4969),
    [anon_sym_AMP_AMP] = ACTIONS(4969),
    [anon_sym_AMP] = ACTIONS(4967),
    [anon_sym_SEMI] = ACTIONS(4969),
    [anon_sym___extension__] = ACTIONS(4967),
    [anon_sym___device__] = ACTIONS(4967),
    [anon_sym___host__] = ACTIONS(4967),
    [anon_sym___global__] = ACTIONS(4967),
    [anon_sym___forceinline__] = ACTIONS(4967),
    [anon_sym___noinline__] = ACTIONS(4967),
    [anon_sym_extern] = ACTIONS(4967),
    [anon_sym___attribute__] = ACTIONS(4967),
    [anon_sym_COLON_COLON] = ACTIONS(4969),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4969),
    [anon_sym___declspec] = ACTIONS(4967),
    [anon_sym___based] = ACTIONS(4967),
    [anon_sym___cdecl] = ACTIONS(4967),
    [anon_sym___clrcall] = ACTIONS(4967),
    [anon_sym___stdcall] = ACTIONS(4967),
    [anon_sym___fastcall] = ACTIONS(4967),
    [anon_sym___thiscall] = ACTIONS(4967),
    [anon_sym___vectorcall] = ACTIONS(4967),
    [anon_sym_LBRACE] = ACTIONS(4969),
    [anon_sym_signed] = ACTIONS(4967),
    [anon_sym_unsigned] = ACTIONS(4967),
    [anon_sym_long] = ACTIONS(4967),
    [anon_sym_short] = ACTIONS(4967),
    [anon_sym_LBRACK] = ACTIONS(4967),
    [anon_sym_static] = ACTIONS(4967),
    [anon_sym_EQ] = ACTIONS(4969),
    [anon_sym_register] = ACTIONS(4967),
    [anon_sym_inline] = ACTIONS(4967),
    [anon_sym___inline] = ACTIONS(4967),
    [anon_sym___inline__] = ACTIONS(4967),
    [anon_sym___forceinline] = ACTIONS(4967),
    [anon_sym_thread_local] = ACTIONS(4967),
    [anon_sym___thread] = ACTIONS(4967),
    [anon_sym_const] = ACTIONS(4967),
    [anon_sym_constexpr] = ACTIONS(4967),
    [anon_sym_volatile] = ACTIONS(4967),
    [anon_sym_restrict] = ACTIONS(4967),
    [anon_sym___restrict__] = ACTIONS(4967),
    [anon_sym__Atomic] = ACTIONS(4967),
    [anon_sym__Noreturn] = ACTIONS(4967),
    [anon_sym_noreturn] = ACTIONS(4967),
    [anon_sym_mutable] = ACTIONS(4967),
    [anon_sym_constinit] = ACTIONS(4967),
    [anon_sym_consteval] = ACTIONS(4967),
    [anon_sym___shared__] = ACTIONS(4967),
    [anon_sym___local__] = ACTIONS(4967),
    [anon_sym___constant__] = ACTIONS(4967),
    [anon_sym___managed__] = ACTIONS(4967),
    [anon_sym___grid_constant__] = ACTIONS(4967),
    [anon_sym_alignas] = ACTIONS(4967),
    [anon_sym__Alignas] = ACTIONS(4967),
    [sym_primitive_type] = ACTIONS(4967),
    [anon_sym_enum] = ACTIONS(4967),
    [anon_sym_class] = ACTIONS(4967),
    [anon_sym_struct] = ACTIONS(4967),
    [anon_sym_union] = ACTIONS(4967),
    [anon_sym_or] = ACTIONS(4967),
    [anon_sym_and] = ACTIONS(4967),
    [anon_sym_asm] = ACTIONS(4967),
    [anon_sym___asm__] = ACTIONS(4967),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4967),
    [anon_sym_decltype] = ACTIONS(4967),
    [anon_sym_final] = ACTIONS(4967),
    [anon_sym_override] = ACTIONS(4967),
    [sym_virtual] = ACTIONS(4967),
    [anon_sym_explicit] = ACTIONS(4967),
    [anon_sym_typename] = ACTIONS(4967),
    [anon_sym_template] = ACTIONS(4967),
    [anon_sym_GT2] = ACTIONS(4969),
    [anon_sym_operator] = ACTIONS(4967),
    [anon_sym_try] = ACTIONS(4967),
    [anon_sym_friend] = ACTIONS(4967),
    [anon_sym_using] = ACTIONS(4967),
    [anon_sym_concept] = ACTIONS(4967),
    [anon_sym_requires] = ACTIONS(4967),
    [anon_sym___launch_bounds__] = ACTIONS(4967),
  },
  [1680] = {
    [sym_identifier] = ACTIONS(4945),
    [anon_sym_COMMA] = ACTIONS(4947),
    [anon_sym_RPAREN] = ACTIONS(4947),
    [anon_sym_LPAREN2] = ACTIONS(4947),
    [anon_sym_TILDE] = ACTIONS(4947),
    [anon_sym_STAR] = ACTIONS(4947),
    [anon_sym_PIPE_PIPE] = ACTIONS(4947),
    [anon_sym_AMP_AMP] = ACTIONS(4947),
    [anon_sym_AMP] = ACTIONS(4945),
    [anon_sym_SEMI] = ACTIONS(4947),
    [anon_sym___extension__] = ACTIONS(4945),
    [anon_sym___device__] = ACTIONS(4945),
    [anon_sym___host__] = ACTIONS(4945),
    [anon_sym___global__] = ACTIONS(4945),
    [anon_sym___forceinline__] = ACTIONS(4945),
    [anon_sym___noinline__] = ACTIONS(4945),
    [anon_sym_extern] = ACTIONS(4945),
    [anon_sym___attribute__] = ACTIONS(4945),
    [anon_sym_COLON_COLON] = ACTIONS(4947),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4947),
    [anon_sym___declspec] = ACTIONS(4945),
    [anon_sym___based] = ACTIONS(4945),
    [anon_sym___cdecl] = ACTIONS(4945),
    [anon_sym___clrcall] = ACTIONS(4945),
    [anon_sym___stdcall] = ACTIONS(4945),
    [anon_sym___fastcall] = ACTIONS(4945),
    [anon_sym___thiscall] = ACTIONS(4945),
    [anon_sym___vectorcall] = ACTIONS(4945),
    [anon_sym_LBRACE] = ACTIONS(4947),
    [anon_sym_signed] = ACTIONS(4945),
    [anon_sym_unsigned] = ACTIONS(4945),
    [anon_sym_long] = ACTIONS(4945),
    [anon_sym_short] = ACTIONS(4945),
    [anon_sym_LBRACK] = ACTIONS(4945),
    [anon_sym_static] = ACTIONS(4945),
    [anon_sym_EQ] = ACTIONS(4947),
    [anon_sym_register] = ACTIONS(4945),
    [anon_sym_inline] = ACTIONS(4945),
    [anon_sym___inline] = ACTIONS(4945),
    [anon_sym___inline__] = ACTIONS(4945),
    [anon_sym___forceinline] = ACTIONS(4945),
    [anon_sym_thread_local] = ACTIONS(4945),
    [anon_sym___thread] = ACTIONS(4945),
    [anon_sym_const] = ACTIONS(4945),
    [anon_sym_constexpr] = ACTIONS(4945),
    [anon_sym_volatile] = ACTIONS(4945),
    [anon_sym_restrict] = ACTIONS(4945),
    [anon_sym___restrict__] = ACTIONS(4945),
    [anon_sym__Atomic] = ACTIONS(4945),
    [anon_sym__Noreturn] = ACTIONS(4945),
    [anon_sym_noreturn] = ACTIONS(4945),
    [anon_sym_mutable] = ACTIONS(4945),
    [anon_sym_constinit] = ACTIONS(4945),
    [anon_sym_consteval] = ACTIONS(4945),
    [anon_sym___shared__] = ACTIONS(4945),
    [anon_sym___local__] = ACTIONS(4945),
    [anon_sym___constant__] = ACTIONS(4945),
    [anon_sym___managed__] = ACTIONS(4945),
    [anon_sym___grid_constant__] = ACTIONS(4945),
    [anon_sym_alignas] = ACTIONS(4945),
    [anon_sym__Alignas] = ACTIONS(4945),
    [sym_primitive_type] = ACTIONS(4945),
    [anon_sym_enum] = ACTIONS(4945),
    [anon_sym_class] = ACTIONS(4945),
    [anon_sym_struct] = ACTIONS(4945),
    [anon_sym_union] = ACTIONS(4945),
    [anon_sym_or] = ACTIONS(4945),
    [anon_sym_and] = ACTIONS(4945),
    [anon_sym_asm] = ACTIONS(4945),
    [anon_sym___asm__] = ACTIONS(4945),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4945),
    [anon_sym_decltype] = ACTIONS(4945),
    [anon_sym_final] = ACTIONS(4945),
    [anon_sym_override] = ACTIONS(4945),
    [sym_virtual] = ACTIONS(4945),
    [anon_sym_explicit] = ACTIONS(4945),
    [anon_sym_typename] = ACTIONS(4945),
    [anon_sym_template] = ACTIONS(4945),
    [anon_sym_GT2] = ACTIONS(4947),
    [anon_sym_operator] = ACTIONS(4945),
    [anon_sym_try] = ACTIONS(4945),
    [anon_sym_friend] = ACTIONS(4945),
    [anon_sym_using] = ACTIONS(4945),
    [anon_sym_concept] = ACTIONS(4945),
    [anon_sym_requires] = ACTIONS(4945),
    [anon_sym___launch_bounds__] = ACTIONS(4945),
  },
  [1681] = {
    [sym_identifier] = ACTIONS(4142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4144),
    [anon_sym_COMMA] = ACTIONS(4144),
    [anon_sym_RPAREN] = ACTIONS(4144),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_TILDE] = ACTIONS(4149),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_STAR] = ACTIONS(4146),
    [anon_sym_SLASH] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4151),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_AMP] = ACTIONS(4153),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT] = ACTIONS(4151),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4151),
    [anon_sym_LT] = ACTIONS(4151),
    [anon_sym_LT_LT] = ACTIONS(4151),
    [anon_sym_GT_GT] = ACTIONS(4144),
    [anon_sym_SEMI] = ACTIONS(4144),
    [anon_sym___extension__] = ACTIONS(4142),
    [anon_sym___device__] = ACTIONS(4142),
    [anon_sym___host__] = ACTIONS(4142),
    [anon_sym___global__] = ACTIONS(4142),
    [anon_sym___forceinline__] = ACTIONS(4142),
    [anon_sym___noinline__] = ACTIONS(4142),
    [anon_sym_extern] = ACTIONS(4142),
    [anon_sym___attribute__] = ACTIONS(4142),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4149),
    [anon_sym___declspec] = ACTIONS(4142),
    [anon_sym___based] = ACTIONS(4142),
    [anon_sym_LBRACE] = ACTIONS(4149),
    [anon_sym_LBRACK] = ACTIONS(4153),
    [anon_sym_static] = ACTIONS(4142),
    [anon_sym_register] = ACTIONS(4142),
    [anon_sym_inline] = ACTIONS(4142),
    [anon_sym___inline] = ACTIONS(4142),
    [anon_sym___inline__] = ACTIONS(4142),
    [anon_sym___forceinline] = ACTIONS(4142),
    [anon_sym_thread_local] = ACTIONS(4142),
    [anon_sym___thread] = ACTIONS(4142),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_constexpr] = ACTIONS(4142),
    [anon_sym_volatile] = ACTIONS(4142),
    [anon_sym_restrict] = ACTIONS(4142),
    [anon_sym___restrict__] = ACTIONS(4142),
    [anon_sym__Atomic] = ACTIONS(4142),
    [anon_sym__Noreturn] = ACTIONS(4142),
    [anon_sym_noreturn] = ACTIONS(4142),
    [anon_sym_mutable] = ACTIONS(4142),
    [anon_sym_constinit] = ACTIONS(4142),
    [anon_sym_consteval] = ACTIONS(4142),
    [anon_sym___shared__] = ACTIONS(4142),
    [anon_sym___local__] = ACTIONS(4142),
    [anon_sym___constant__] = ACTIONS(4142),
    [anon_sym___managed__] = ACTIONS(4142),
    [anon_sym___grid_constant__] = ACTIONS(4142),
    [anon_sym_alignas] = ACTIONS(4142),
    [anon_sym__Alignas] = ACTIONS(4142),
    [anon_sym_QMARK] = ACTIONS(4144),
    [anon_sym_LT_EQ_GT] = ACTIONS(4144),
    [anon_sym_or] = ACTIONS(4151),
    [anon_sym_and] = ACTIONS(4151),
    [anon_sym_bitor] = ACTIONS(4151),
    [anon_sym_xor] = ACTIONS(4151),
    [anon_sym_bitand] = ACTIONS(4151),
    [anon_sym_not_eq] = ACTIONS(4151),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_DOT_STAR] = ACTIONS(4144),
    [anon_sym_DASH_GT] = ACTIONS(4144),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4142),
    [anon_sym_decltype] = ACTIONS(4142),
    [sym_virtual] = ACTIONS(4142),
    [anon_sym_template] = ACTIONS(4142),
    [anon_sym_operator] = ACTIONS(4142),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4144),
    [anon_sym___launch_bounds__] = ACTIONS(4142),
  },
  [1682] = {
    [sym_identifier] = ACTIONS(4142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_RPAREN] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_TILDE] = ACTIONS(4149),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_STAR] = ACTIONS(4146),
    [anon_sym_SLASH] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4151),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_AMP] = ACTIONS(4153),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT] = ACTIONS(4151),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4151),
    [anon_sym_LT] = ACTIONS(4151),
    [anon_sym_LT_LT] = ACTIONS(4151),
    [anon_sym_GT_GT] = ACTIONS(4144),
    [anon_sym___extension__] = ACTIONS(4142),
    [anon_sym___device__] = ACTIONS(4142),
    [anon_sym___host__] = ACTIONS(4142),
    [anon_sym___global__] = ACTIONS(4142),
    [anon_sym___forceinline__] = ACTIONS(4142),
    [anon_sym___noinline__] = ACTIONS(4142),
    [anon_sym_extern] = ACTIONS(4142),
    [anon_sym___attribute__] = ACTIONS(4142),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4149),
    [anon_sym___declspec] = ACTIONS(4142),
    [anon_sym___based] = ACTIONS(4142),
    [anon_sym_LBRACE] = ACTIONS(4149),
    [anon_sym_LBRACK] = ACTIONS(4153),
    [anon_sym_static] = ACTIONS(4142),
    [anon_sym_EQ] = ACTIONS(4142),
    [anon_sym_register] = ACTIONS(4142),
    [anon_sym_inline] = ACTIONS(4142),
    [anon_sym___inline] = ACTIONS(4142),
    [anon_sym___inline__] = ACTIONS(4142),
    [anon_sym___forceinline] = ACTIONS(4142),
    [anon_sym_thread_local] = ACTIONS(4142),
    [anon_sym___thread] = ACTIONS(4142),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_constexpr] = ACTIONS(4142),
    [anon_sym_volatile] = ACTIONS(4142),
    [anon_sym_restrict] = ACTIONS(4142),
    [anon_sym___restrict__] = ACTIONS(4142),
    [anon_sym__Atomic] = ACTIONS(4142),
    [anon_sym__Noreturn] = ACTIONS(4142),
    [anon_sym_noreturn] = ACTIONS(4142),
    [anon_sym_mutable] = ACTIONS(4142),
    [anon_sym_constinit] = ACTIONS(4142),
    [anon_sym_consteval] = ACTIONS(4142),
    [anon_sym___shared__] = ACTIONS(4142),
    [anon_sym___local__] = ACTIONS(4142),
    [anon_sym___constant__] = ACTIONS(4142),
    [anon_sym___managed__] = ACTIONS(4142),
    [anon_sym___grid_constant__] = ACTIONS(4142),
    [anon_sym_alignas] = ACTIONS(4142),
    [anon_sym__Alignas] = ACTIONS(4142),
    [anon_sym_QMARK] = ACTIONS(4144),
    [anon_sym_LT_EQ_GT] = ACTIONS(4144),
    [anon_sym_or] = ACTIONS(4151),
    [anon_sym_and] = ACTIONS(4151),
    [anon_sym_bitor] = ACTIONS(4151),
    [anon_sym_xor] = ACTIONS(4151),
    [anon_sym_bitand] = ACTIONS(4151),
    [anon_sym_not_eq] = ACTIONS(4151),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_DOT_STAR] = ACTIONS(4144),
    [anon_sym_DASH_GT] = ACTIONS(4144),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4142),
    [anon_sym_decltype] = ACTIONS(4142),
    [sym_virtual] = ACTIONS(4142),
    [anon_sym_template] = ACTIONS(4142),
    [anon_sym_operator] = ACTIONS(4142),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4144),
    [anon_sym___launch_bounds__] = ACTIONS(4142),
  },
  [1683] = {
    [sym__declaration_modifiers] = STATE(1847),
    [sym__declaration_specifiers] = STATE(4513),
    [sym_attribute_specifier] = STATE(1847),
    [sym_attribute_declaration] = STATE(1847),
    [sym_ms_declspec_modifier] = STATE(1847),
    [sym_storage_class_specifier] = STATE(1847),
    [sym_type_qualifier] = STATE(1847),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_parameter_declaration] = STATE(7991),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_type_parameter_declaration] = STATE(7991),
    [sym_variadic_type_parameter_declaration] = STATE(7991),
    [sym_optional_type_parameter_declaration] = STATE(7991),
    [sym_template_template_parameter_declaration] = STATE(7991),
    [sym_optional_parameter_declaration] = STATE(7991),
    [sym_variadic_parameter_declaration] = STATE(7991),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6858),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_launch_bounds] = STATE(1847),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1847),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1765),
    [anon_sym___host__] = ACTIONS(1765),
    [anon_sym___global__] = ACTIONS(1765),
    [anon_sym___forceinline__] = ACTIONS(1765),
    [anon_sym___noinline__] = ACTIONS(1765),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(1771),
    [anon_sym_class] = ACTIONS(4957),
    [anon_sym_struct] = ACTIONS(1775),
    [anon_sym_union] = ACTIONS(1777),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1765),
    [anon_sym_typename] = ACTIONS(4959),
    [anon_sym_template] = ACTIONS(4961),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1684] = {
    [sym__declaration_modifiers] = STATE(1847),
    [sym__declaration_specifiers] = STATE(4480),
    [sym_attribute_specifier] = STATE(1847),
    [sym_attribute_declaration] = STATE(1847),
    [sym_ms_declspec_modifier] = STATE(1847),
    [sym_storage_class_specifier] = STATE(1847),
    [sym_type_qualifier] = STATE(1847),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_parameter_declaration] = STATE(7423),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_optional_parameter_declaration] = STATE(7423),
    [sym_variadic_parameter_declaration] = STATE(7423),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6858),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_launch_bounds] = STATE(1847),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1847),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1815),
    [anon_sym_RPAREN] = ACTIONS(3955),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1765),
    [anon_sym___host__] = ACTIONS(1765),
    [anon_sym___global__] = ACTIONS(1765),
    [anon_sym___forceinline__] = ACTIONS(1765),
    [anon_sym___noinline__] = ACTIONS(1765),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(1771),
    [anon_sym_class] = ACTIONS(1773),
    [anon_sym_struct] = ACTIONS(1775),
    [anon_sym_union] = ACTIONS(1777),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1765),
    [anon_sym_typename] = ACTIONS(1801),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1685] = {
    [sym__declaration_modifiers] = STATE(1847),
    [sym__declaration_specifiers] = STATE(4480),
    [sym_attribute_specifier] = STATE(1847),
    [sym_attribute_declaration] = STATE(1847),
    [sym_ms_declspec_modifier] = STATE(1847),
    [sym_storage_class_specifier] = STATE(1847),
    [sym_type_qualifier] = STATE(1847),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_parameter_declaration] = STATE(7640),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_optional_parameter_declaration] = STATE(7640),
    [sym_variadic_parameter_declaration] = STATE(7640),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6858),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_launch_bounds] = STATE(1847),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1847),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4971),
    [anon_sym_RPAREN] = ACTIONS(4973),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1765),
    [anon_sym___host__] = ACTIONS(1765),
    [anon_sym___global__] = ACTIONS(1765),
    [anon_sym___forceinline__] = ACTIONS(1765),
    [anon_sym___noinline__] = ACTIONS(1765),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(1771),
    [anon_sym_class] = ACTIONS(1773),
    [anon_sym_struct] = ACTIONS(1775),
    [anon_sym_union] = ACTIONS(1777),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1765),
    [anon_sym_typename] = ACTIONS(1801),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1686] = {
    [sym__declaration_modifiers] = STATE(1847),
    [sym__declaration_specifiers] = STATE(4480),
    [sym_attribute_specifier] = STATE(1847),
    [sym_attribute_declaration] = STATE(1847),
    [sym_ms_declspec_modifier] = STATE(1847),
    [sym_storage_class_specifier] = STATE(1847),
    [sym_type_qualifier] = STATE(1847),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_parameter_declaration] = STATE(7392),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_optional_parameter_declaration] = STATE(7392),
    [sym_variadic_parameter_declaration] = STATE(7392),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6858),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_launch_bounds] = STATE(1847),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1847),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4975),
    [anon_sym_RPAREN] = ACTIONS(4977),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1765),
    [anon_sym___host__] = ACTIONS(1765),
    [anon_sym___global__] = ACTIONS(1765),
    [anon_sym___forceinline__] = ACTIONS(1765),
    [anon_sym___noinline__] = ACTIONS(1765),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(1771),
    [anon_sym_class] = ACTIONS(1773),
    [anon_sym_struct] = ACTIONS(1775),
    [anon_sym_union] = ACTIONS(1777),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1765),
    [anon_sym_typename] = ACTIONS(1801),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1687] = {
    [sym__declaration_modifiers] = STATE(1847),
    [sym__declaration_specifiers] = STATE(4480),
    [sym_attribute_specifier] = STATE(1847),
    [sym_attribute_declaration] = STATE(1847),
    [sym_ms_declspec_modifier] = STATE(1847),
    [sym_storage_class_specifier] = STATE(1847),
    [sym_type_qualifier] = STATE(1847),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_parameter_declaration] = STATE(7738),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_optional_parameter_declaration] = STATE(7738),
    [sym_variadic_parameter_declaration] = STATE(7738),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6858),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_launch_bounds] = STATE(1847),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1847),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4979),
    [anon_sym_RPAREN] = ACTIONS(4981),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1765),
    [anon_sym___host__] = ACTIONS(1765),
    [anon_sym___global__] = ACTIONS(1765),
    [anon_sym___forceinline__] = ACTIONS(1765),
    [anon_sym___noinline__] = ACTIONS(1765),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(1771),
    [anon_sym_class] = ACTIONS(1773),
    [anon_sym_struct] = ACTIONS(1775),
    [anon_sym_union] = ACTIONS(1777),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1765),
    [anon_sym_typename] = ACTIONS(1801),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1688] = {
    [sym__declaration_modifiers] = STATE(1847),
    [sym__declaration_specifiers] = STATE(4480),
    [sym_attribute_specifier] = STATE(1847),
    [sym_attribute_declaration] = STATE(1847),
    [sym_ms_declspec_modifier] = STATE(1847),
    [sym_storage_class_specifier] = STATE(1847),
    [sym_type_qualifier] = STATE(1847),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_parameter_declaration] = STATE(7388),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_optional_parameter_declaration] = STATE(7388),
    [sym_variadic_parameter_declaration] = STATE(7388),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6858),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_launch_bounds] = STATE(1847),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1847),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4983),
    [anon_sym_RPAREN] = ACTIONS(4985),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1765),
    [anon_sym___host__] = ACTIONS(1765),
    [anon_sym___global__] = ACTIONS(1765),
    [anon_sym___forceinline__] = ACTIONS(1765),
    [anon_sym___noinline__] = ACTIONS(1765),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(1771),
    [anon_sym_class] = ACTIONS(1773),
    [anon_sym_struct] = ACTIONS(1775),
    [anon_sym_union] = ACTIONS(1777),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1765),
    [anon_sym_typename] = ACTIONS(1801),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1689] = {
    [sym_catch_clause] = STATE(1689),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1689),
    [sym_identifier] = ACTIONS(1909),
    [aux_sym_preproc_def_token1] = ACTIONS(1909),
    [aux_sym_preproc_if_token1] = ACTIONS(1909),
    [aux_sym_preproc_if_token2] = ACTIONS(1909),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1909),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1909),
    [aux_sym_preproc_else_token1] = ACTIONS(1909),
    [aux_sym_preproc_elif_token1] = ACTIONS(1909),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1909),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1909),
    [sym_preproc_directive] = ACTIONS(1909),
    [anon_sym_LPAREN2] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym___extension__] = ACTIONS(1909),
    [anon_sym_typedef] = ACTIONS(1909),
    [anon_sym___device__] = ACTIONS(1909),
    [anon_sym___host__] = ACTIONS(1909),
    [anon_sym___global__] = ACTIONS(1909),
    [anon_sym___forceinline__] = ACTIONS(1909),
    [anon_sym___noinline__] = ACTIONS(1909),
    [anon_sym_extern] = ACTIONS(1909),
    [anon_sym___attribute__] = ACTIONS(1909),
    [anon_sym_COLON_COLON] = ACTIONS(1911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1911),
    [anon_sym___declspec] = ACTIONS(1909),
    [anon_sym___based] = ACTIONS(1909),
    [anon_sym_signed] = ACTIONS(1909),
    [anon_sym_unsigned] = ACTIONS(1909),
    [anon_sym_long] = ACTIONS(1909),
    [anon_sym_short] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_static] = ACTIONS(1909),
    [anon_sym_register] = ACTIONS(1909),
    [anon_sym_inline] = ACTIONS(1909),
    [anon_sym___inline] = ACTIONS(1909),
    [anon_sym___inline__] = ACTIONS(1909),
    [anon_sym___forceinline] = ACTIONS(1909),
    [anon_sym_thread_local] = ACTIONS(1909),
    [anon_sym___thread] = ACTIONS(1909),
    [anon_sym_const] = ACTIONS(1909),
    [anon_sym_constexpr] = ACTIONS(1909),
    [anon_sym_volatile] = ACTIONS(1909),
    [anon_sym_restrict] = ACTIONS(1909),
    [anon_sym___restrict__] = ACTIONS(1909),
    [anon_sym__Atomic] = ACTIONS(1909),
    [anon_sym__Noreturn] = ACTIONS(1909),
    [anon_sym_noreturn] = ACTIONS(1909),
    [anon_sym_mutable] = ACTIONS(1909),
    [anon_sym_constinit] = ACTIONS(1909),
    [anon_sym_consteval] = ACTIONS(1909),
    [anon_sym___shared__] = ACTIONS(1909),
    [anon_sym___local__] = ACTIONS(1909),
    [anon_sym___constant__] = ACTIONS(1909),
    [anon_sym___managed__] = ACTIONS(1909),
    [anon_sym___grid_constant__] = ACTIONS(1909),
    [anon_sym_alignas] = ACTIONS(1909),
    [anon_sym__Alignas] = ACTIONS(1909),
    [sym_primitive_type] = ACTIONS(1909),
    [anon_sym_enum] = ACTIONS(1909),
    [anon_sym_class] = ACTIONS(1909),
    [anon_sym_struct] = ACTIONS(1909),
    [anon_sym_union] = ACTIONS(1909),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1909),
    [anon_sym_decltype] = ACTIONS(1909),
    [sym_virtual] = ACTIONS(1909),
    [anon_sym_explicit] = ACTIONS(1909),
    [anon_sym_typename] = ACTIONS(1909),
    [anon_sym_template] = ACTIONS(1909),
    [anon_sym_operator] = ACTIONS(1909),
    [anon_sym_friend] = ACTIONS(1909),
    [anon_sym_public] = ACTIONS(1909),
    [anon_sym_private] = ACTIONS(1909),
    [anon_sym_protected] = ACTIONS(1909),
    [anon_sym_using] = ACTIONS(1909),
    [anon_sym_static_assert] = ACTIONS(1909),
    [anon_sym_catch] = ACTIONS(4987),
    [anon_sym___launch_bounds__] = ACTIONS(1909),
  },
  [1690] = {
    [sym_catch_clause] = STATE(1689),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1689),
    [sym_identifier] = ACTIONS(1916),
    [aux_sym_preproc_def_token1] = ACTIONS(1916),
    [aux_sym_preproc_if_token1] = ACTIONS(1916),
    [aux_sym_preproc_if_token2] = ACTIONS(1916),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1916),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1916),
    [aux_sym_preproc_else_token1] = ACTIONS(1916),
    [aux_sym_preproc_elif_token1] = ACTIONS(1916),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1916),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1916),
    [sym_preproc_directive] = ACTIONS(1916),
    [anon_sym_LPAREN2] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [anon_sym_STAR] = ACTIONS(1918),
    [anon_sym_AMP_AMP] = ACTIONS(1918),
    [anon_sym_AMP] = ACTIONS(1916),
    [anon_sym___extension__] = ACTIONS(1916),
    [anon_sym_typedef] = ACTIONS(1916),
    [anon_sym___device__] = ACTIONS(1916),
    [anon_sym___host__] = ACTIONS(1916),
    [anon_sym___global__] = ACTIONS(1916),
    [anon_sym___forceinline__] = ACTIONS(1916),
    [anon_sym___noinline__] = ACTIONS(1916),
    [anon_sym_extern] = ACTIONS(1916),
    [anon_sym___attribute__] = ACTIONS(1916),
    [anon_sym_COLON_COLON] = ACTIONS(1918),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1918),
    [anon_sym___declspec] = ACTIONS(1916),
    [anon_sym___based] = ACTIONS(1916),
    [anon_sym_signed] = ACTIONS(1916),
    [anon_sym_unsigned] = ACTIONS(1916),
    [anon_sym_long] = ACTIONS(1916),
    [anon_sym_short] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1916),
    [anon_sym_static] = ACTIONS(1916),
    [anon_sym_register] = ACTIONS(1916),
    [anon_sym_inline] = ACTIONS(1916),
    [anon_sym___inline] = ACTIONS(1916),
    [anon_sym___inline__] = ACTIONS(1916),
    [anon_sym___forceinline] = ACTIONS(1916),
    [anon_sym_thread_local] = ACTIONS(1916),
    [anon_sym___thread] = ACTIONS(1916),
    [anon_sym_const] = ACTIONS(1916),
    [anon_sym_constexpr] = ACTIONS(1916),
    [anon_sym_volatile] = ACTIONS(1916),
    [anon_sym_restrict] = ACTIONS(1916),
    [anon_sym___restrict__] = ACTIONS(1916),
    [anon_sym__Atomic] = ACTIONS(1916),
    [anon_sym__Noreturn] = ACTIONS(1916),
    [anon_sym_noreturn] = ACTIONS(1916),
    [anon_sym_mutable] = ACTIONS(1916),
    [anon_sym_constinit] = ACTIONS(1916),
    [anon_sym_consteval] = ACTIONS(1916),
    [anon_sym___shared__] = ACTIONS(1916),
    [anon_sym___local__] = ACTIONS(1916),
    [anon_sym___constant__] = ACTIONS(1916),
    [anon_sym___managed__] = ACTIONS(1916),
    [anon_sym___grid_constant__] = ACTIONS(1916),
    [anon_sym_alignas] = ACTIONS(1916),
    [anon_sym__Alignas] = ACTIONS(1916),
    [sym_primitive_type] = ACTIONS(1916),
    [anon_sym_enum] = ACTIONS(1916),
    [anon_sym_class] = ACTIONS(1916),
    [anon_sym_struct] = ACTIONS(1916),
    [anon_sym_union] = ACTIONS(1916),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1916),
    [anon_sym_decltype] = ACTIONS(1916),
    [sym_virtual] = ACTIONS(1916),
    [anon_sym_explicit] = ACTIONS(1916),
    [anon_sym_typename] = ACTIONS(1916),
    [anon_sym_template] = ACTIONS(1916),
    [anon_sym_operator] = ACTIONS(1916),
    [anon_sym_friend] = ACTIONS(1916),
    [anon_sym_public] = ACTIONS(1916),
    [anon_sym_private] = ACTIONS(1916),
    [anon_sym_protected] = ACTIONS(1916),
    [anon_sym_using] = ACTIONS(1916),
    [anon_sym_static_assert] = ACTIONS(1916),
    [anon_sym_catch] = ACTIONS(4990),
    [anon_sym___launch_bounds__] = ACTIONS(1916),
  },
  [1691] = {
    [sym_catch_clause] = STATE(1689),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1689),
    [sym_identifier] = ACTIONS(1920),
    [aux_sym_preproc_def_token1] = ACTIONS(1920),
    [aux_sym_preproc_if_token1] = ACTIONS(1920),
    [aux_sym_preproc_if_token2] = ACTIONS(1920),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1920),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1920),
    [aux_sym_preproc_else_token1] = ACTIONS(1920),
    [aux_sym_preproc_elif_token1] = ACTIONS(1920),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1920),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1920),
    [sym_preproc_directive] = ACTIONS(1920),
    [anon_sym_LPAREN2] = ACTIONS(1922),
    [anon_sym_TILDE] = ACTIONS(1922),
    [anon_sym_STAR] = ACTIONS(1922),
    [anon_sym_AMP_AMP] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1920),
    [anon_sym___extension__] = ACTIONS(1920),
    [anon_sym_typedef] = ACTIONS(1920),
    [anon_sym___device__] = ACTIONS(1920),
    [anon_sym___host__] = ACTIONS(1920),
    [anon_sym___global__] = ACTIONS(1920),
    [anon_sym___forceinline__] = ACTIONS(1920),
    [anon_sym___noinline__] = ACTIONS(1920),
    [anon_sym_extern] = ACTIONS(1920),
    [anon_sym___attribute__] = ACTIONS(1920),
    [anon_sym_COLON_COLON] = ACTIONS(1922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1922),
    [anon_sym___declspec] = ACTIONS(1920),
    [anon_sym___based] = ACTIONS(1920),
    [anon_sym_signed] = ACTIONS(1920),
    [anon_sym_unsigned] = ACTIONS(1920),
    [anon_sym_long] = ACTIONS(1920),
    [anon_sym_short] = ACTIONS(1920),
    [anon_sym_LBRACK] = ACTIONS(1920),
    [anon_sym_static] = ACTIONS(1920),
    [anon_sym_register] = ACTIONS(1920),
    [anon_sym_inline] = ACTIONS(1920),
    [anon_sym___inline] = ACTIONS(1920),
    [anon_sym___inline__] = ACTIONS(1920),
    [anon_sym___forceinline] = ACTIONS(1920),
    [anon_sym_thread_local] = ACTIONS(1920),
    [anon_sym___thread] = ACTIONS(1920),
    [anon_sym_const] = ACTIONS(1920),
    [anon_sym_constexpr] = ACTIONS(1920),
    [anon_sym_volatile] = ACTIONS(1920),
    [anon_sym_restrict] = ACTIONS(1920),
    [anon_sym___restrict__] = ACTIONS(1920),
    [anon_sym__Atomic] = ACTIONS(1920),
    [anon_sym__Noreturn] = ACTIONS(1920),
    [anon_sym_noreturn] = ACTIONS(1920),
    [anon_sym_mutable] = ACTIONS(1920),
    [anon_sym_constinit] = ACTIONS(1920),
    [anon_sym_consteval] = ACTIONS(1920),
    [anon_sym___shared__] = ACTIONS(1920),
    [anon_sym___local__] = ACTIONS(1920),
    [anon_sym___constant__] = ACTIONS(1920),
    [anon_sym___managed__] = ACTIONS(1920),
    [anon_sym___grid_constant__] = ACTIONS(1920),
    [anon_sym_alignas] = ACTIONS(1920),
    [anon_sym__Alignas] = ACTIONS(1920),
    [sym_primitive_type] = ACTIONS(1920),
    [anon_sym_enum] = ACTIONS(1920),
    [anon_sym_class] = ACTIONS(1920),
    [anon_sym_struct] = ACTIONS(1920),
    [anon_sym_union] = ACTIONS(1920),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1920),
    [anon_sym_decltype] = ACTIONS(1920),
    [sym_virtual] = ACTIONS(1920),
    [anon_sym_explicit] = ACTIONS(1920),
    [anon_sym_typename] = ACTIONS(1920),
    [anon_sym_template] = ACTIONS(1920),
    [anon_sym_operator] = ACTIONS(1920),
    [anon_sym_friend] = ACTIONS(1920),
    [anon_sym_public] = ACTIONS(1920),
    [anon_sym_private] = ACTIONS(1920),
    [anon_sym_protected] = ACTIONS(1920),
    [anon_sym_using] = ACTIONS(1920),
    [anon_sym_static_assert] = ACTIONS(1920),
    [anon_sym_catch] = ACTIONS(4990),
    [anon_sym___launch_bounds__] = ACTIONS(1920),
  },
  [1692] = {
    [sym_catch_clause] = STATE(1689),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1689),
    [sym_identifier] = ACTIONS(1903),
    [aux_sym_preproc_def_token1] = ACTIONS(1903),
    [aux_sym_preproc_if_token1] = ACTIONS(1903),
    [aux_sym_preproc_if_token2] = ACTIONS(1903),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1903),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1903),
    [aux_sym_preproc_else_token1] = ACTIONS(1903),
    [aux_sym_preproc_elif_token1] = ACTIONS(1903),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1903),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1903),
    [sym_preproc_directive] = ACTIONS(1903),
    [anon_sym_LPAREN2] = ACTIONS(1905),
    [anon_sym_TILDE] = ACTIONS(1905),
    [anon_sym_STAR] = ACTIONS(1905),
    [anon_sym_AMP_AMP] = ACTIONS(1905),
    [anon_sym_AMP] = ACTIONS(1903),
    [anon_sym___extension__] = ACTIONS(1903),
    [anon_sym_typedef] = ACTIONS(1903),
    [anon_sym___device__] = ACTIONS(1903),
    [anon_sym___host__] = ACTIONS(1903),
    [anon_sym___global__] = ACTIONS(1903),
    [anon_sym___forceinline__] = ACTIONS(1903),
    [anon_sym___noinline__] = ACTIONS(1903),
    [anon_sym_extern] = ACTIONS(1903),
    [anon_sym___attribute__] = ACTIONS(1903),
    [anon_sym_COLON_COLON] = ACTIONS(1905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1905),
    [anon_sym___declspec] = ACTIONS(1903),
    [anon_sym___based] = ACTIONS(1903),
    [anon_sym_signed] = ACTIONS(1903),
    [anon_sym_unsigned] = ACTIONS(1903),
    [anon_sym_long] = ACTIONS(1903),
    [anon_sym_short] = ACTIONS(1903),
    [anon_sym_LBRACK] = ACTIONS(1903),
    [anon_sym_static] = ACTIONS(1903),
    [anon_sym_register] = ACTIONS(1903),
    [anon_sym_inline] = ACTIONS(1903),
    [anon_sym___inline] = ACTIONS(1903),
    [anon_sym___inline__] = ACTIONS(1903),
    [anon_sym___forceinline] = ACTIONS(1903),
    [anon_sym_thread_local] = ACTIONS(1903),
    [anon_sym___thread] = ACTIONS(1903),
    [anon_sym_const] = ACTIONS(1903),
    [anon_sym_constexpr] = ACTIONS(1903),
    [anon_sym_volatile] = ACTIONS(1903),
    [anon_sym_restrict] = ACTIONS(1903),
    [anon_sym___restrict__] = ACTIONS(1903),
    [anon_sym__Atomic] = ACTIONS(1903),
    [anon_sym__Noreturn] = ACTIONS(1903),
    [anon_sym_noreturn] = ACTIONS(1903),
    [anon_sym_mutable] = ACTIONS(1903),
    [anon_sym_constinit] = ACTIONS(1903),
    [anon_sym_consteval] = ACTIONS(1903),
    [anon_sym___shared__] = ACTIONS(1903),
    [anon_sym___local__] = ACTIONS(1903),
    [anon_sym___constant__] = ACTIONS(1903),
    [anon_sym___managed__] = ACTIONS(1903),
    [anon_sym___grid_constant__] = ACTIONS(1903),
    [anon_sym_alignas] = ACTIONS(1903),
    [anon_sym__Alignas] = ACTIONS(1903),
    [sym_primitive_type] = ACTIONS(1903),
    [anon_sym_enum] = ACTIONS(1903),
    [anon_sym_class] = ACTIONS(1903),
    [anon_sym_struct] = ACTIONS(1903),
    [anon_sym_union] = ACTIONS(1903),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1903),
    [anon_sym_decltype] = ACTIONS(1903),
    [sym_virtual] = ACTIONS(1903),
    [anon_sym_explicit] = ACTIONS(1903),
    [anon_sym_typename] = ACTIONS(1903),
    [anon_sym_template] = ACTIONS(1903),
    [anon_sym_operator] = ACTIONS(1903),
    [anon_sym_friend] = ACTIONS(1903),
    [anon_sym_public] = ACTIONS(1903),
    [anon_sym_private] = ACTIONS(1903),
    [anon_sym_protected] = ACTIONS(1903),
    [anon_sym_using] = ACTIONS(1903),
    [anon_sym_static_assert] = ACTIONS(1903),
    [anon_sym_catch] = ACTIONS(4990),
    [anon_sym___launch_bounds__] = ACTIONS(1903),
  },
  [1693] = {
    [sym__declaration_modifiers] = STATE(1847),
    [sym__declaration_specifiers] = STATE(4480),
    [sym_attribute_specifier] = STATE(1847),
    [sym_attribute_declaration] = STATE(1847),
    [sym_ms_declspec_modifier] = STATE(1847),
    [sym_storage_class_specifier] = STATE(1847),
    [sym_type_qualifier] = STATE(1847),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_parameter_declaration] = STATE(7541),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_optional_parameter_declaration] = STATE(7541),
    [sym_variadic_parameter_declaration] = STATE(7541),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6858),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_launch_bounds] = STATE(1847),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1847),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym_RPAREN] = ACTIONS(1755),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1765),
    [anon_sym___host__] = ACTIONS(1765),
    [anon_sym___global__] = ACTIONS(1765),
    [anon_sym___forceinline__] = ACTIONS(1765),
    [anon_sym___noinline__] = ACTIONS(1765),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(1771),
    [anon_sym_class] = ACTIONS(1773),
    [anon_sym_struct] = ACTIONS(1775),
    [anon_sym_union] = ACTIONS(1777),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1765),
    [anon_sym_typename] = ACTIONS(1801),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1694] = {
    [sym__declaration_modifiers] = STATE(1847),
    [sym__declaration_specifiers] = STATE(4480),
    [sym_attribute_specifier] = STATE(1847),
    [sym_attribute_declaration] = STATE(1847),
    [sym_ms_declspec_modifier] = STATE(1847),
    [sym_storage_class_specifier] = STATE(1847),
    [sym_type_qualifier] = STATE(1847),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_parameter_declaration] = STATE(7938),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_optional_parameter_declaration] = STATE(7938),
    [sym_variadic_parameter_declaration] = STATE(7938),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6858),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_launch_bounds] = STATE(1847),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1847),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4992),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1765),
    [anon_sym___host__] = ACTIONS(1765),
    [anon_sym___global__] = ACTIONS(1765),
    [anon_sym___forceinline__] = ACTIONS(1765),
    [anon_sym___noinline__] = ACTIONS(1765),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(1771),
    [anon_sym_class] = ACTIONS(1773),
    [anon_sym_struct] = ACTIONS(1775),
    [anon_sym_union] = ACTIONS(1777),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1765),
    [anon_sym_typename] = ACTIONS(1801),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1695] = {
    [sym__declaration_modifiers] = STATE(2716),
    [sym_attribute_specifier] = STATE(2716),
    [sym_attribute_declaration] = STATE(2716),
    [sym_ms_declspec_modifier] = STATE(2716),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6586),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2716),
    [sym_type_qualifier] = STATE(2716),
    [sym_alignas_qualifier] = STATE(2611),
    [sym_decltype] = STATE(8628),
    [sym_explicit_function_specifier] = STATE(2716),
    [sym_operator_cast] = STATE(6986),
    [sym__constructor_specifiers] = STATE(2716),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(8628),
    [sym_template_function] = STATE(6598),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5803),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_operator_cast_identifier] = STATE(6986),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2716),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2716),
    [sym_identifier] = ACTIONS(4994),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym___device__] = ACTIONS(4998),
    [anon_sym___host__] = ACTIONS(4998),
    [anon_sym___global__] = ACTIONS(4998),
    [anon_sym___forceinline__] = ACTIONS(4998),
    [anon_sym___noinline__] = ACTIONS(4998),
    [anon_sym_extern] = ACTIONS(5000),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5006),
    [anon_sym___declspec] = ACTIONS(5008),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(5000),
    [anon_sym_register] = ACTIONS(5000),
    [anon_sym_inline] = ACTIONS(5000),
    [anon_sym___inline] = ACTIONS(5000),
    [anon_sym___inline__] = ACTIONS(5000),
    [anon_sym___forceinline] = ACTIONS(5000),
    [anon_sym_thread_local] = ACTIONS(5000),
    [anon_sym___thread] = ACTIONS(5000),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym___shared__] = ACTIONS(4996),
    [anon_sym___local__] = ACTIONS(4996),
    [anon_sym___constant__] = ACTIONS(4996),
    [anon_sym___managed__] = ACTIONS(4996),
    [anon_sym___grid_constant__] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(5010),
    [anon_sym__Alignas] = ACTIONS(5010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [sym_virtual] = ACTIONS(4998),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym___launch_bounds__] = ACTIONS(5012),
  },
  [1696] = {
    [sym__declaration_modifiers] = STATE(1847),
    [sym__declaration_specifiers] = STATE(4480),
    [sym_attribute_specifier] = STATE(1847),
    [sym_attribute_declaration] = STATE(1847),
    [sym_ms_declspec_modifier] = STATE(1847),
    [sym_storage_class_specifier] = STATE(1847),
    [sym_type_qualifier] = STATE(1847),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_parameter_declaration] = STATE(7958),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_optional_parameter_declaration] = STATE(7958),
    [sym_variadic_parameter_declaration] = STATE(7958),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6858),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_launch_bounds] = STATE(1847),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1847),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1765),
    [anon_sym___host__] = ACTIONS(1765),
    [anon_sym___global__] = ACTIONS(1765),
    [anon_sym___forceinline__] = ACTIONS(1765),
    [anon_sym___noinline__] = ACTIONS(1765),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(1771),
    [anon_sym_class] = ACTIONS(1773),
    [anon_sym_struct] = ACTIONS(1775),
    [anon_sym_union] = ACTIONS(1777),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1765),
    [anon_sym_typename] = ACTIONS(1801),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1697] = {
    [sym__declaration_modifiers] = STATE(2716),
    [sym_attribute_specifier] = STATE(2716),
    [sym_attribute_declaration] = STATE(2716),
    [sym_ms_declspec_modifier] = STATE(2716),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6483),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2716),
    [sym_type_qualifier] = STATE(2716),
    [sym_alignas_qualifier] = STATE(2611),
    [sym_decltype] = STATE(8628),
    [sym_explicit_function_specifier] = STATE(2716),
    [sym_operator_cast] = STATE(6990),
    [sym__constructor_specifiers] = STATE(2716),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(8628),
    [sym_template_function] = STATE(6598),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5803),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_operator_cast_identifier] = STATE(6990),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2716),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2716),
    [sym_identifier] = ACTIONS(4994),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym___device__] = ACTIONS(4998),
    [anon_sym___host__] = ACTIONS(4998),
    [anon_sym___global__] = ACTIONS(4998),
    [anon_sym___forceinline__] = ACTIONS(4998),
    [anon_sym___noinline__] = ACTIONS(4998),
    [anon_sym_extern] = ACTIONS(5000),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5006),
    [anon_sym___declspec] = ACTIONS(5008),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(5000),
    [anon_sym_register] = ACTIONS(5000),
    [anon_sym_inline] = ACTIONS(5000),
    [anon_sym___inline] = ACTIONS(5000),
    [anon_sym___inline__] = ACTIONS(5000),
    [anon_sym___forceinline] = ACTIONS(5000),
    [anon_sym_thread_local] = ACTIONS(5000),
    [anon_sym___thread] = ACTIONS(5000),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym___shared__] = ACTIONS(4996),
    [anon_sym___local__] = ACTIONS(4996),
    [anon_sym___constant__] = ACTIONS(4996),
    [anon_sym___managed__] = ACTIONS(4996),
    [anon_sym___grid_constant__] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(5010),
    [anon_sym__Alignas] = ACTIONS(5010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [sym_virtual] = ACTIONS(4998),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym___launch_bounds__] = ACTIONS(5012),
  },
  [1698] = {
    [sym__declaration_modifiers] = STATE(2716),
    [sym_attribute_specifier] = STATE(2716),
    [sym_attribute_declaration] = STATE(2716),
    [sym_ms_declspec_modifier] = STATE(2716),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6515),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2716),
    [sym_type_qualifier] = STATE(2716),
    [sym_alignas_qualifier] = STATE(2611),
    [sym_decltype] = STATE(8628),
    [sym_explicit_function_specifier] = STATE(2716),
    [sym_operator_cast] = STATE(6990),
    [sym__constructor_specifiers] = STATE(2716),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(8628),
    [sym_template_function] = STATE(6598),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5803),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_operator_cast_identifier] = STATE(6990),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2716),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2716),
    [sym_identifier] = ACTIONS(4994),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym___device__] = ACTIONS(4998),
    [anon_sym___host__] = ACTIONS(4998),
    [anon_sym___global__] = ACTIONS(4998),
    [anon_sym___forceinline__] = ACTIONS(4998),
    [anon_sym___noinline__] = ACTIONS(4998),
    [anon_sym_extern] = ACTIONS(5000),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5006),
    [anon_sym___declspec] = ACTIONS(5008),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(5000),
    [anon_sym_register] = ACTIONS(5000),
    [anon_sym_inline] = ACTIONS(5000),
    [anon_sym___inline] = ACTIONS(5000),
    [anon_sym___inline__] = ACTIONS(5000),
    [anon_sym___forceinline] = ACTIONS(5000),
    [anon_sym_thread_local] = ACTIONS(5000),
    [anon_sym___thread] = ACTIONS(5000),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym___shared__] = ACTIONS(4996),
    [anon_sym___local__] = ACTIONS(4996),
    [anon_sym___constant__] = ACTIONS(4996),
    [anon_sym___managed__] = ACTIONS(4996),
    [anon_sym___grid_constant__] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(5010),
    [anon_sym__Alignas] = ACTIONS(5010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [sym_virtual] = ACTIONS(4998),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym___launch_bounds__] = ACTIONS(5012),
  },
  [1699] = {
    [sym__declaration_modifiers] = STATE(2716),
    [sym_attribute_specifier] = STATE(2716),
    [sym_attribute_declaration] = STATE(2716),
    [sym_ms_declspec_modifier] = STATE(2716),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6487),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2716),
    [sym_type_qualifier] = STATE(2716),
    [sym_alignas_qualifier] = STATE(2611),
    [sym_decltype] = STATE(8628),
    [sym_explicit_function_specifier] = STATE(2716),
    [sym_operator_cast] = STATE(7016),
    [sym__constructor_specifiers] = STATE(2716),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(8628),
    [sym_template_function] = STATE(6598),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5803),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_operator_cast_identifier] = STATE(7016),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2716),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2716),
    [sym_identifier] = ACTIONS(4994),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym___device__] = ACTIONS(4998),
    [anon_sym___host__] = ACTIONS(4998),
    [anon_sym___global__] = ACTIONS(4998),
    [anon_sym___forceinline__] = ACTIONS(4998),
    [anon_sym___noinline__] = ACTIONS(4998),
    [anon_sym_extern] = ACTIONS(5000),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5006),
    [anon_sym___declspec] = ACTIONS(5008),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(5000),
    [anon_sym_register] = ACTIONS(5000),
    [anon_sym_inline] = ACTIONS(5000),
    [anon_sym___inline] = ACTIONS(5000),
    [anon_sym___inline__] = ACTIONS(5000),
    [anon_sym___forceinline] = ACTIONS(5000),
    [anon_sym_thread_local] = ACTIONS(5000),
    [anon_sym___thread] = ACTIONS(5000),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym___shared__] = ACTIONS(4996),
    [anon_sym___local__] = ACTIONS(4996),
    [anon_sym___constant__] = ACTIONS(4996),
    [anon_sym___managed__] = ACTIONS(4996),
    [anon_sym___grid_constant__] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(5010),
    [anon_sym__Alignas] = ACTIONS(5010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [sym_virtual] = ACTIONS(4998),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym___launch_bounds__] = ACTIONS(5012),
  },
  [1700] = {
    [sym_identifier] = ACTIONS(1901),
    [aux_sym_preproc_def_token1] = ACTIONS(1901),
    [anon_sym_COMMA] = ACTIONS(1962),
    [aux_sym_preproc_if_token1] = ACTIONS(1901),
    [aux_sym_preproc_if_token2] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1901),
    [aux_sym_preproc_else_token1] = ACTIONS(1901),
    [aux_sym_preproc_elif_token1] = ACTIONS(1901),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1901),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1901),
    [sym_preproc_directive] = ACTIONS(1901),
    [anon_sym_LPAREN2] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_STAR] = ACTIONS(1899),
    [anon_sym_AMP_AMP] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1901),
    [anon_sym_SEMI] = ACTIONS(1962),
    [anon_sym___extension__] = ACTIONS(1901),
    [anon_sym_typedef] = ACTIONS(1901),
    [anon_sym___device__] = ACTIONS(1901),
    [anon_sym___host__] = ACTIONS(1901),
    [anon_sym___global__] = ACTIONS(1901),
    [anon_sym___forceinline__] = ACTIONS(1901),
    [anon_sym___noinline__] = ACTIONS(1901),
    [anon_sym_extern] = ACTIONS(1901),
    [anon_sym___attribute__] = ACTIONS(1901),
    [anon_sym_COLON_COLON] = ACTIONS(1899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1899),
    [anon_sym___declspec] = ACTIONS(1901),
    [anon_sym___based] = ACTIONS(1901),
    [anon_sym_signed] = ACTIONS(1901),
    [anon_sym_unsigned] = ACTIONS(1901),
    [anon_sym_long] = ACTIONS(1901),
    [anon_sym_short] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1901),
    [anon_sym_static] = ACTIONS(1901),
    [anon_sym_register] = ACTIONS(1901),
    [anon_sym_inline] = ACTIONS(1901),
    [anon_sym___inline] = ACTIONS(1901),
    [anon_sym___inline__] = ACTIONS(1901),
    [anon_sym___forceinline] = ACTIONS(1901),
    [anon_sym_thread_local] = ACTIONS(1901),
    [anon_sym___thread] = ACTIONS(1901),
    [anon_sym_const] = ACTIONS(1901),
    [anon_sym_constexpr] = ACTIONS(1901),
    [anon_sym_volatile] = ACTIONS(1901),
    [anon_sym_restrict] = ACTIONS(1901),
    [anon_sym___restrict__] = ACTIONS(1901),
    [anon_sym__Atomic] = ACTIONS(1901),
    [anon_sym__Noreturn] = ACTIONS(1901),
    [anon_sym_noreturn] = ACTIONS(1901),
    [anon_sym_mutable] = ACTIONS(1901),
    [anon_sym_constinit] = ACTIONS(1901),
    [anon_sym_consteval] = ACTIONS(1901),
    [anon_sym___shared__] = ACTIONS(1901),
    [anon_sym___local__] = ACTIONS(1901),
    [anon_sym___constant__] = ACTIONS(1901),
    [anon_sym___managed__] = ACTIONS(1901),
    [anon_sym___grid_constant__] = ACTIONS(1901),
    [anon_sym_alignas] = ACTIONS(1901),
    [anon_sym__Alignas] = ACTIONS(1901),
    [sym_primitive_type] = ACTIONS(1901),
    [anon_sym_enum] = ACTIONS(1901),
    [anon_sym_class] = ACTIONS(1901),
    [anon_sym_struct] = ACTIONS(1901),
    [anon_sym_union] = ACTIONS(1901),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1901),
    [anon_sym_decltype] = ACTIONS(1901),
    [sym_virtual] = ACTIONS(1901),
    [anon_sym_explicit] = ACTIONS(1901),
    [anon_sym_typename] = ACTIONS(1901),
    [anon_sym_template] = ACTIONS(1901),
    [anon_sym_operator] = ACTIONS(1901),
    [anon_sym_friend] = ACTIONS(1901),
    [anon_sym_public] = ACTIONS(1901),
    [anon_sym_private] = ACTIONS(1901),
    [anon_sym_protected] = ACTIONS(1901),
    [anon_sym_using] = ACTIONS(1901),
    [anon_sym_static_assert] = ACTIONS(1901),
    [anon_sym___launch_bounds__] = ACTIONS(1901),
  },
  [1701] = {
    [sym__declaration_modifiers] = STATE(2716),
    [sym_attribute_specifier] = STATE(2716),
    [sym_attribute_declaration] = STATE(2716),
    [sym_ms_declspec_modifier] = STATE(2716),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6437),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2716),
    [sym_type_qualifier] = STATE(2716),
    [sym_alignas_qualifier] = STATE(2611),
    [sym_decltype] = STATE(8628),
    [sym_explicit_function_specifier] = STATE(2716),
    [sym_operator_cast] = STATE(7007),
    [sym__constructor_specifiers] = STATE(2716),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(8628),
    [sym_template_function] = STATE(6598),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5803),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_operator_cast_identifier] = STATE(7007),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2716),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2716),
    [sym_identifier] = ACTIONS(4994),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym___device__] = ACTIONS(4998),
    [anon_sym___host__] = ACTIONS(4998),
    [anon_sym___global__] = ACTIONS(4998),
    [anon_sym___forceinline__] = ACTIONS(4998),
    [anon_sym___noinline__] = ACTIONS(4998),
    [anon_sym_extern] = ACTIONS(5000),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5006),
    [anon_sym___declspec] = ACTIONS(5008),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(5000),
    [anon_sym_register] = ACTIONS(5000),
    [anon_sym_inline] = ACTIONS(5000),
    [anon_sym___inline] = ACTIONS(5000),
    [anon_sym___inline__] = ACTIONS(5000),
    [anon_sym___forceinline] = ACTIONS(5000),
    [anon_sym_thread_local] = ACTIONS(5000),
    [anon_sym___thread] = ACTIONS(5000),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym___shared__] = ACTIONS(4996),
    [anon_sym___local__] = ACTIONS(4996),
    [anon_sym___constant__] = ACTIONS(4996),
    [anon_sym___managed__] = ACTIONS(4996),
    [anon_sym___grid_constant__] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(5010),
    [anon_sym__Alignas] = ACTIONS(5010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [sym_virtual] = ACTIONS(4998),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym___launch_bounds__] = ACTIONS(5012),
  },
  [1702] = {
    [sym__declaration_modifiers] = STATE(2716),
    [sym_attribute_specifier] = STATE(2716),
    [sym_attribute_declaration] = STATE(2716),
    [sym_ms_declspec_modifier] = STATE(2716),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6462),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2716),
    [sym_type_qualifier] = STATE(2716),
    [sym_alignas_qualifier] = STATE(2611),
    [sym_decltype] = STATE(8628),
    [sym_explicit_function_specifier] = STATE(2716),
    [sym_operator_cast] = STATE(6998),
    [sym__constructor_specifiers] = STATE(2716),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(8628),
    [sym_template_function] = STATE(6598),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5803),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_operator_cast_identifier] = STATE(6998),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2716),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2716),
    [sym_identifier] = ACTIONS(4994),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym___device__] = ACTIONS(4998),
    [anon_sym___host__] = ACTIONS(4998),
    [anon_sym___global__] = ACTIONS(4998),
    [anon_sym___forceinline__] = ACTIONS(4998),
    [anon_sym___noinline__] = ACTIONS(4998),
    [anon_sym_extern] = ACTIONS(5000),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5006),
    [anon_sym___declspec] = ACTIONS(5008),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(5000),
    [anon_sym_register] = ACTIONS(5000),
    [anon_sym_inline] = ACTIONS(5000),
    [anon_sym___inline] = ACTIONS(5000),
    [anon_sym___inline__] = ACTIONS(5000),
    [anon_sym___forceinline] = ACTIONS(5000),
    [anon_sym_thread_local] = ACTIONS(5000),
    [anon_sym___thread] = ACTIONS(5000),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym___shared__] = ACTIONS(4996),
    [anon_sym___local__] = ACTIONS(4996),
    [anon_sym___constant__] = ACTIONS(4996),
    [anon_sym___managed__] = ACTIONS(4996),
    [anon_sym___grid_constant__] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(5010),
    [anon_sym__Alignas] = ACTIONS(5010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [sym_virtual] = ACTIONS(4998),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym___launch_bounds__] = ACTIONS(5012),
  },
  [1703] = {
    [sym__declaration_modifiers] = STATE(2716),
    [sym_attribute_specifier] = STATE(2716),
    [sym_attribute_declaration] = STATE(2716),
    [sym_ms_declspec_modifier] = STATE(2716),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6496),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2716),
    [sym_type_qualifier] = STATE(2716),
    [sym_alignas_qualifier] = STATE(2611),
    [sym_decltype] = STATE(8628),
    [sym_explicit_function_specifier] = STATE(2716),
    [sym_operator_cast] = STATE(7001),
    [sym__constructor_specifiers] = STATE(2716),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(8628),
    [sym_template_function] = STATE(6598),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5803),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_operator_cast_identifier] = STATE(7001),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2716),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2716),
    [sym_identifier] = ACTIONS(4994),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym___device__] = ACTIONS(4998),
    [anon_sym___host__] = ACTIONS(4998),
    [anon_sym___global__] = ACTIONS(4998),
    [anon_sym___forceinline__] = ACTIONS(4998),
    [anon_sym___noinline__] = ACTIONS(4998),
    [anon_sym_extern] = ACTIONS(5000),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5006),
    [anon_sym___declspec] = ACTIONS(5008),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(5000),
    [anon_sym_register] = ACTIONS(5000),
    [anon_sym_inline] = ACTIONS(5000),
    [anon_sym___inline] = ACTIONS(5000),
    [anon_sym___inline__] = ACTIONS(5000),
    [anon_sym___forceinline] = ACTIONS(5000),
    [anon_sym_thread_local] = ACTIONS(5000),
    [anon_sym___thread] = ACTIONS(5000),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym___shared__] = ACTIONS(4996),
    [anon_sym___local__] = ACTIONS(4996),
    [anon_sym___constant__] = ACTIONS(4996),
    [anon_sym___managed__] = ACTIONS(4996),
    [anon_sym___grid_constant__] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(5010),
    [anon_sym__Alignas] = ACTIONS(5010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [sym_virtual] = ACTIONS(4998),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym___launch_bounds__] = ACTIONS(5012),
  },
  [1704] = {
    [sym__declaration_modifiers] = STATE(2716),
    [sym_attribute_specifier] = STATE(2716),
    [sym_attribute_declaration] = STATE(2716),
    [sym_ms_declspec_modifier] = STATE(2716),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6612),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2716),
    [sym_type_qualifier] = STATE(2716),
    [sym_alignas_qualifier] = STATE(2611),
    [sym_decltype] = STATE(8628),
    [sym_explicit_function_specifier] = STATE(2716),
    [sym_operator_cast] = STATE(6998),
    [sym__constructor_specifiers] = STATE(2716),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(8628),
    [sym_template_function] = STATE(6598),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5803),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_operator_cast_identifier] = STATE(6998),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2716),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2716),
    [sym_identifier] = ACTIONS(4994),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym___device__] = ACTIONS(4998),
    [anon_sym___host__] = ACTIONS(4998),
    [anon_sym___global__] = ACTIONS(4998),
    [anon_sym___forceinline__] = ACTIONS(4998),
    [anon_sym___noinline__] = ACTIONS(4998),
    [anon_sym_extern] = ACTIONS(5000),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5006),
    [anon_sym___declspec] = ACTIONS(5008),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(5000),
    [anon_sym_register] = ACTIONS(5000),
    [anon_sym_inline] = ACTIONS(5000),
    [anon_sym___inline] = ACTIONS(5000),
    [anon_sym___inline__] = ACTIONS(5000),
    [anon_sym___forceinline] = ACTIONS(5000),
    [anon_sym_thread_local] = ACTIONS(5000),
    [anon_sym___thread] = ACTIONS(5000),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym___shared__] = ACTIONS(4996),
    [anon_sym___local__] = ACTIONS(4996),
    [anon_sym___constant__] = ACTIONS(4996),
    [anon_sym___managed__] = ACTIONS(4996),
    [anon_sym___grid_constant__] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(5010),
    [anon_sym__Alignas] = ACTIONS(5010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [sym_virtual] = ACTIONS(4998),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym___launch_bounds__] = ACTIONS(5012),
  },
  [1705] = {
    [sym__declaration_modifiers] = STATE(2716),
    [sym_attribute_specifier] = STATE(2716),
    [sym_attribute_declaration] = STATE(2716),
    [sym_ms_declspec_modifier] = STATE(2716),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6460),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2716),
    [sym_type_qualifier] = STATE(2716),
    [sym_alignas_qualifier] = STATE(2611),
    [sym_decltype] = STATE(8628),
    [sym_explicit_function_specifier] = STATE(2716),
    [sym_operator_cast] = STATE(6986),
    [sym__constructor_specifiers] = STATE(2716),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(8628),
    [sym_template_function] = STATE(6598),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5803),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_operator_cast_identifier] = STATE(6986),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2716),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2716),
    [sym_identifier] = ACTIONS(4994),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym___device__] = ACTIONS(4998),
    [anon_sym___host__] = ACTIONS(4998),
    [anon_sym___global__] = ACTIONS(4998),
    [anon_sym___forceinline__] = ACTIONS(4998),
    [anon_sym___noinline__] = ACTIONS(4998),
    [anon_sym_extern] = ACTIONS(5000),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5006),
    [anon_sym___declspec] = ACTIONS(5008),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(5000),
    [anon_sym_register] = ACTIONS(5000),
    [anon_sym_inline] = ACTIONS(5000),
    [anon_sym___inline] = ACTIONS(5000),
    [anon_sym___inline__] = ACTIONS(5000),
    [anon_sym___forceinline] = ACTIONS(5000),
    [anon_sym_thread_local] = ACTIONS(5000),
    [anon_sym___thread] = ACTIONS(5000),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym___shared__] = ACTIONS(4996),
    [anon_sym___local__] = ACTIONS(4996),
    [anon_sym___constant__] = ACTIONS(4996),
    [anon_sym___managed__] = ACTIONS(4996),
    [anon_sym___grid_constant__] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(5010),
    [anon_sym__Alignas] = ACTIONS(5010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [sym_virtual] = ACTIONS(4998),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym___launch_bounds__] = ACTIONS(5012),
  },
  [1706] = {
    [sym__declaration_modifiers] = STATE(2716),
    [sym_attribute_specifier] = STATE(2716),
    [sym_attribute_declaration] = STATE(2716),
    [sym_ms_declspec_modifier] = STATE(2716),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6541),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2716),
    [sym_type_qualifier] = STATE(2716),
    [sym_alignas_qualifier] = STATE(2611),
    [sym_decltype] = STATE(8628),
    [sym_explicit_function_specifier] = STATE(2716),
    [sym_operator_cast] = STATE(7016),
    [sym__constructor_specifiers] = STATE(2716),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(8628),
    [sym_template_function] = STATE(6598),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5803),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_operator_cast_identifier] = STATE(7016),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2716),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2716),
    [sym_identifier] = ACTIONS(4994),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym___device__] = ACTIONS(4998),
    [anon_sym___host__] = ACTIONS(4998),
    [anon_sym___global__] = ACTIONS(4998),
    [anon_sym___forceinline__] = ACTIONS(4998),
    [anon_sym___noinline__] = ACTIONS(4998),
    [anon_sym_extern] = ACTIONS(5000),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5006),
    [anon_sym___declspec] = ACTIONS(5008),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(5000),
    [anon_sym_register] = ACTIONS(5000),
    [anon_sym_inline] = ACTIONS(5000),
    [anon_sym___inline] = ACTIONS(5000),
    [anon_sym___inline__] = ACTIONS(5000),
    [anon_sym___forceinline] = ACTIONS(5000),
    [anon_sym_thread_local] = ACTIONS(5000),
    [anon_sym___thread] = ACTIONS(5000),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym___shared__] = ACTIONS(4996),
    [anon_sym___local__] = ACTIONS(4996),
    [anon_sym___constant__] = ACTIONS(4996),
    [anon_sym___managed__] = ACTIONS(4996),
    [anon_sym___grid_constant__] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(5010),
    [anon_sym__Alignas] = ACTIONS(5010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [sym_virtual] = ACTIONS(4998),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym___launch_bounds__] = ACTIONS(5012),
  },
  [1707] = {
    [sym_identifier] = ACTIONS(1901),
    [aux_sym_preproc_def_token1] = ACTIONS(1901),
    [anon_sym_COMMA] = ACTIONS(1962),
    [aux_sym_preproc_if_token1] = ACTIONS(1901),
    [aux_sym_preproc_if_token2] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1901),
    [aux_sym_preproc_else_token1] = ACTIONS(1901),
    [aux_sym_preproc_elif_token1] = ACTIONS(1901),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1901),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1901),
    [sym_preproc_directive] = ACTIONS(1901),
    [anon_sym_LPAREN2] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_STAR] = ACTIONS(1899),
    [anon_sym_AMP_AMP] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1901),
    [anon_sym_SEMI] = ACTIONS(1962),
    [anon_sym___extension__] = ACTIONS(1901),
    [anon_sym_typedef] = ACTIONS(1901),
    [anon_sym___device__] = ACTIONS(1901),
    [anon_sym___host__] = ACTIONS(1901),
    [anon_sym___global__] = ACTIONS(1901),
    [anon_sym___forceinline__] = ACTIONS(1901),
    [anon_sym___noinline__] = ACTIONS(1901),
    [anon_sym_extern] = ACTIONS(1901),
    [anon_sym___attribute__] = ACTIONS(5014),
    [anon_sym_COLON_COLON] = ACTIONS(1899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1899),
    [anon_sym___declspec] = ACTIONS(1901),
    [anon_sym___based] = ACTIONS(1901),
    [anon_sym_signed] = ACTIONS(1901),
    [anon_sym_unsigned] = ACTIONS(1901),
    [anon_sym_long] = ACTIONS(1901),
    [anon_sym_short] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1901),
    [anon_sym_static] = ACTIONS(1901),
    [anon_sym_register] = ACTIONS(1901),
    [anon_sym_inline] = ACTIONS(1901),
    [anon_sym___inline] = ACTIONS(1901),
    [anon_sym___inline__] = ACTIONS(1901),
    [anon_sym___forceinline] = ACTIONS(1901),
    [anon_sym_thread_local] = ACTIONS(1901),
    [anon_sym___thread] = ACTIONS(1901),
    [anon_sym_const] = ACTIONS(1901),
    [anon_sym_constexpr] = ACTIONS(1901),
    [anon_sym_volatile] = ACTIONS(1901),
    [anon_sym_restrict] = ACTIONS(1901),
    [anon_sym___restrict__] = ACTIONS(1901),
    [anon_sym__Atomic] = ACTIONS(1901),
    [anon_sym__Noreturn] = ACTIONS(1901),
    [anon_sym_noreturn] = ACTIONS(1901),
    [anon_sym_mutable] = ACTIONS(1901),
    [anon_sym_constinit] = ACTIONS(1901),
    [anon_sym_consteval] = ACTIONS(1901),
    [anon_sym___shared__] = ACTIONS(1901),
    [anon_sym___local__] = ACTIONS(1901),
    [anon_sym___constant__] = ACTIONS(1901),
    [anon_sym___managed__] = ACTIONS(1901),
    [anon_sym___grid_constant__] = ACTIONS(1901),
    [anon_sym_alignas] = ACTIONS(1901),
    [anon_sym__Alignas] = ACTIONS(1901),
    [sym_primitive_type] = ACTIONS(1901),
    [anon_sym_enum] = ACTIONS(1901),
    [anon_sym_class] = ACTIONS(1901),
    [anon_sym_struct] = ACTIONS(1901),
    [anon_sym_union] = ACTIONS(1901),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1901),
    [anon_sym_decltype] = ACTIONS(1901),
    [sym_virtual] = ACTIONS(1901),
    [anon_sym_explicit] = ACTIONS(1901),
    [anon_sym_typename] = ACTIONS(1901),
    [anon_sym_template] = ACTIONS(1901),
    [anon_sym_operator] = ACTIONS(1901),
    [anon_sym_friend] = ACTIONS(1901),
    [anon_sym_public] = ACTIONS(1901),
    [anon_sym_private] = ACTIONS(1901),
    [anon_sym_protected] = ACTIONS(1901),
    [anon_sym_using] = ACTIONS(1901),
    [anon_sym_static_assert] = ACTIONS(1901),
    [anon_sym___launch_bounds__] = ACTIONS(1901),
  },
  [1708] = {
    [sym__declaration_modifiers] = STATE(2716),
    [sym_attribute_specifier] = STATE(2716),
    [sym_attribute_declaration] = STATE(2716),
    [sym_ms_declspec_modifier] = STATE(2716),
    [sym_ms_based_modifier] = STATE(8796),
    [sym__declarator] = STATE(6930),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_function_declarator] = STATE(6431),
    [sym_array_declarator] = STATE(6598),
    [sym_storage_class_specifier] = STATE(2716),
    [sym_type_qualifier] = STATE(2716),
    [sym_alignas_qualifier] = STATE(2611),
    [sym_decltype] = STATE(8628),
    [sym_explicit_function_specifier] = STATE(2716),
    [sym_operator_cast] = STATE(6996),
    [sym__constructor_specifiers] = STATE(2716),
    [sym_reference_declarator] = STATE(6598),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym_template_type] = STATE(8628),
    [sym_template_function] = STATE(6598),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(5803),
    [sym_qualified_identifier] = STATE(6598),
    [sym_qualified_operator_cast_identifier] = STATE(6996),
    [sym_operator_name] = STATE(6598),
    [sym_launch_bounds] = STATE(2716),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2716),
    [sym_identifier] = ACTIONS(4994),
    [anon_sym_LPAREN2] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym___device__] = ACTIONS(4998),
    [anon_sym___host__] = ACTIONS(4998),
    [anon_sym___global__] = ACTIONS(4998),
    [anon_sym___forceinline__] = ACTIONS(4998),
    [anon_sym___noinline__] = ACTIONS(4998),
    [anon_sym_extern] = ACTIONS(5000),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5006),
    [anon_sym___declspec] = ACTIONS(5008),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(5000),
    [anon_sym_register] = ACTIONS(5000),
    [anon_sym_inline] = ACTIONS(5000),
    [anon_sym___inline] = ACTIONS(5000),
    [anon_sym___inline__] = ACTIONS(5000),
    [anon_sym___forceinline] = ACTIONS(5000),
    [anon_sym_thread_local] = ACTIONS(5000),
    [anon_sym___thread] = ACTIONS(5000),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym___shared__] = ACTIONS(4996),
    [anon_sym___local__] = ACTIONS(4996),
    [anon_sym___constant__] = ACTIONS(4996),
    [anon_sym___managed__] = ACTIONS(4996),
    [anon_sym___grid_constant__] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(5010),
    [anon_sym__Alignas] = ACTIONS(5010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [sym_virtual] = ACTIONS(4998),
    [anon_sym_explicit] = ACTIONS(125),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(131),
    [anon_sym___launch_bounds__] = ACTIONS(5012),
  },
  [1709] = {
    [sym_identifier] = ACTIONS(1901),
    [aux_sym_preproc_def_token1] = ACTIONS(1901),
    [aux_sym_preproc_if_token1] = ACTIONS(1901),
    [aux_sym_preproc_if_token2] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1901),
    [aux_sym_preproc_else_token1] = ACTIONS(1901),
    [aux_sym_preproc_elif_token1] = ACTIONS(1901),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1901),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1901),
    [sym_preproc_directive] = ACTIONS(1901),
    [anon_sym_LPAREN2] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_STAR] = ACTIONS(1899),
    [anon_sym_AMP_AMP] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1901),
    [anon_sym___extension__] = ACTIONS(1901),
    [anon_sym_typedef] = ACTIONS(1901),
    [anon_sym___device__] = ACTIONS(1901),
    [anon_sym___host__] = ACTIONS(1901),
    [anon_sym___global__] = ACTIONS(1901),
    [anon_sym___forceinline__] = ACTIONS(1901),
    [anon_sym___noinline__] = ACTIONS(1901),
    [anon_sym_extern] = ACTIONS(1901),
    [anon_sym___attribute__] = ACTIONS(1901),
    [anon_sym_COLON_COLON] = ACTIONS(1899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1899),
    [anon_sym___declspec] = ACTIONS(1901),
    [anon_sym___based] = ACTIONS(1901),
    [anon_sym_signed] = ACTIONS(1901),
    [anon_sym_unsigned] = ACTIONS(1901),
    [anon_sym_long] = ACTIONS(1901),
    [anon_sym_short] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1901),
    [anon_sym_static] = ACTIONS(1901),
    [anon_sym_register] = ACTIONS(1901),
    [anon_sym_inline] = ACTIONS(1901),
    [anon_sym___inline] = ACTIONS(1901),
    [anon_sym___inline__] = ACTIONS(1901),
    [anon_sym___forceinline] = ACTIONS(1901),
    [anon_sym_thread_local] = ACTIONS(1901),
    [anon_sym___thread] = ACTIONS(1901),
    [anon_sym_const] = ACTIONS(1901),
    [anon_sym_constexpr] = ACTIONS(1901),
    [anon_sym_volatile] = ACTIONS(1901),
    [anon_sym_restrict] = ACTIONS(1901),
    [anon_sym___restrict__] = ACTIONS(1901),
    [anon_sym__Atomic] = ACTIONS(1901),
    [anon_sym__Noreturn] = ACTIONS(1901),
    [anon_sym_noreturn] = ACTIONS(1901),
    [anon_sym_mutable] = ACTIONS(1901),
    [anon_sym_constinit] = ACTIONS(1901),
    [anon_sym_consteval] = ACTIONS(1901),
    [anon_sym___shared__] = ACTIONS(1901),
    [anon_sym___local__] = ACTIONS(1901),
    [anon_sym___constant__] = ACTIONS(1901),
    [anon_sym___managed__] = ACTIONS(1901),
    [anon_sym___grid_constant__] = ACTIONS(1901),
    [anon_sym_alignas] = ACTIONS(1901),
    [anon_sym__Alignas] = ACTIONS(1901),
    [sym_primitive_type] = ACTIONS(1901),
    [anon_sym_enum] = ACTIONS(1901),
    [anon_sym_class] = ACTIONS(1901),
    [anon_sym_struct] = ACTIONS(1901),
    [anon_sym_union] = ACTIONS(1901),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1901),
    [anon_sym_decltype] = ACTIONS(1901),
    [sym_virtual] = ACTIONS(1901),
    [anon_sym_explicit] = ACTIONS(1901),
    [anon_sym_typename] = ACTIONS(1901),
    [anon_sym_template] = ACTIONS(1901),
    [anon_sym_operator] = ACTIONS(1901),
    [anon_sym_friend] = ACTIONS(1901),
    [anon_sym_public] = ACTIONS(1901),
    [anon_sym_private] = ACTIONS(1901),
    [anon_sym_protected] = ACTIONS(1901),
    [anon_sym_using] = ACTIONS(1901),
    [anon_sym_static_assert] = ACTIONS(1901),
    [anon_sym_catch] = ACTIONS(1901),
    [anon_sym___launch_bounds__] = ACTIONS(1901),
  },
  [1710] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1710),
    [sym_identifier] = ACTIONS(5016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5018),
    [anon_sym_COMMA] = ACTIONS(5018),
    [anon_sym_RPAREN] = ACTIONS(5018),
    [aux_sym_preproc_if_token2] = ACTIONS(5018),
    [aux_sym_preproc_else_token1] = ACTIONS(5018),
    [aux_sym_preproc_elif_token1] = ACTIONS(5016),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5018),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5018),
    [anon_sym_LPAREN2] = ACTIONS(5018),
    [anon_sym_DASH] = ACTIONS(5016),
    [anon_sym_PLUS] = ACTIONS(5016),
    [anon_sym_STAR] = ACTIONS(5018),
    [anon_sym_SLASH] = ACTIONS(5016),
    [anon_sym_PERCENT] = ACTIONS(5018),
    [anon_sym_PIPE_PIPE] = ACTIONS(5018),
    [anon_sym_AMP_AMP] = ACTIONS(5018),
    [anon_sym_PIPE] = ACTIONS(5016),
    [anon_sym_CARET] = ACTIONS(5018),
    [anon_sym_AMP] = ACTIONS(5016),
    [anon_sym_EQ_EQ] = ACTIONS(5018),
    [anon_sym_BANG_EQ] = ACTIONS(5018),
    [anon_sym_GT] = ACTIONS(5016),
    [anon_sym_GT_EQ] = ACTIONS(5018),
    [anon_sym_LT_EQ] = ACTIONS(5016),
    [anon_sym_LT] = ACTIONS(5016),
    [anon_sym_LT_LT] = ACTIONS(5016),
    [anon_sym_GT_GT] = ACTIONS(5018),
    [anon_sym_SEMI] = ACTIONS(5018),
    [anon_sym___extension__] = ACTIONS(5016),
    [anon_sym___global__] = ACTIONS(5016),
    [anon_sym___attribute__] = ACTIONS(5016),
    [anon_sym_LBRACE] = ACTIONS(5018),
    [anon_sym_RBRACE] = ACTIONS(5018),
    [anon_sym_signed] = ACTIONS(5020),
    [anon_sym_unsigned] = ACTIONS(5020),
    [anon_sym_long] = ACTIONS(5020),
    [anon_sym_short] = ACTIONS(5020),
    [anon_sym_LBRACK] = ACTIONS(5018),
    [anon_sym_RBRACK] = ACTIONS(5018),
    [anon_sym_const] = ACTIONS(5016),
    [anon_sym_constexpr] = ACTIONS(5016),
    [anon_sym_volatile] = ACTIONS(5016),
    [anon_sym_restrict] = ACTIONS(5016),
    [anon_sym___restrict__] = ACTIONS(5016),
    [anon_sym__Atomic] = ACTIONS(5016),
    [anon_sym__Noreturn] = ACTIONS(5016),
    [anon_sym_noreturn] = ACTIONS(5016),
    [anon_sym_mutable] = ACTIONS(5016),
    [anon_sym_constinit] = ACTIONS(5016),
    [anon_sym_consteval] = ACTIONS(5016),
    [anon_sym___shared__] = ACTIONS(5016),
    [anon_sym___local__] = ACTIONS(5016),
    [anon_sym___constant__] = ACTIONS(5016),
    [anon_sym___managed__] = ACTIONS(5016),
    [anon_sym___grid_constant__] = ACTIONS(5016),
    [anon_sym_alignas] = ACTIONS(5016),
    [anon_sym__Alignas] = ACTIONS(5016),
    [sym_primitive_type] = ACTIONS(5016),
    [anon_sym_COLON] = ACTIONS(5018),
    [anon_sym_QMARK] = ACTIONS(5018),
    [anon_sym_LT_EQ_GT] = ACTIONS(5018),
    [anon_sym_or] = ACTIONS(5016),
    [anon_sym_and] = ACTIONS(5016),
    [anon_sym_bitor] = ACTIONS(5016),
    [anon_sym_xor] = ACTIONS(5016),
    [anon_sym_bitand] = ACTIONS(5016),
    [anon_sym_not_eq] = ACTIONS(5016),
    [anon_sym_DASH_DASH] = ACTIONS(5018),
    [anon_sym_PLUS_PLUS] = ACTIONS(5018),
    [anon_sym_DOT] = ACTIONS(5016),
    [anon_sym_DOT_STAR] = ACTIONS(5018),
    [anon_sym_DASH_GT] = ACTIONS(5018),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5016),
    [anon_sym_decltype] = ACTIONS(5016),
    [anon_sym_final] = ACTIONS(5016),
    [anon_sym_override] = ACTIONS(5016),
    [anon_sym_requires] = ACTIONS(5016),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5018),
  },
  [1711] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4019),
    [anon_sym_COMMA] = ACTIONS(4019),
    [anon_sym_RPAREN] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(4019),
    [anon_sym_DASH] = ACTIONS(4017),
    [anon_sym_PLUS] = ACTIONS(4017),
    [anon_sym_STAR] = ACTIONS(4017),
    [anon_sym_SLASH] = ACTIONS(4017),
    [anon_sym_PERCENT] = ACTIONS(4017),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE] = ACTIONS(4017),
    [anon_sym_CARET] = ACTIONS(4017),
    [anon_sym_AMP] = ACTIONS(4017),
    [anon_sym_EQ_EQ] = ACTIONS(4019),
    [anon_sym_BANG_EQ] = ACTIONS(4019),
    [anon_sym_GT] = ACTIONS(4017),
    [anon_sym_GT_EQ] = ACTIONS(4019),
    [anon_sym_LT_EQ] = ACTIONS(4017),
    [anon_sym_LT] = ACTIONS(4017),
    [anon_sym_LT_LT] = ACTIONS(4017),
    [anon_sym_GT_GT] = ACTIONS(4017),
    [anon_sym___extension__] = ACTIONS(4019),
    [anon_sym___global__] = ACTIONS(4019),
    [anon_sym___attribute__] = ACTIONS(4019),
    [anon_sym_COLON_COLON] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4019),
    [anon_sym_LBRACK] = ACTIONS(4019),
    [anon_sym_EQ] = ACTIONS(4017),
    [anon_sym_const] = ACTIONS(4017),
    [anon_sym_constexpr] = ACTIONS(4019),
    [anon_sym_volatile] = ACTIONS(4019),
    [anon_sym_restrict] = ACTIONS(4019),
    [anon_sym___restrict__] = ACTIONS(4019),
    [anon_sym__Atomic] = ACTIONS(4019),
    [anon_sym__Noreturn] = ACTIONS(4019),
    [anon_sym_noreturn] = ACTIONS(4019),
    [anon_sym_mutable] = ACTIONS(4019),
    [anon_sym_constinit] = ACTIONS(4019),
    [anon_sym_consteval] = ACTIONS(4019),
    [anon_sym___shared__] = ACTIONS(4019),
    [anon_sym___local__] = ACTIONS(4019),
    [anon_sym___constant__] = ACTIONS(4019),
    [anon_sym___managed__] = ACTIONS(4019),
    [anon_sym___grid_constant__] = ACTIONS(4019),
    [anon_sym_alignas] = ACTIONS(4019),
    [anon_sym__Alignas] = ACTIONS(4019),
    [anon_sym_COLON] = ACTIONS(4017),
    [anon_sym_QMARK] = ACTIONS(4019),
    [anon_sym_STAR_EQ] = ACTIONS(4019),
    [anon_sym_SLASH_EQ] = ACTIONS(4019),
    [anon_sym_PERCENT_EQ] = ACTIONS(4019),
    [anon_sym_PLUS_EQ] = ACTIONS(4019),
    [anon_sym_DASH_EQ] = ACTIONS(4019),
    [anon_sym_LT_LT_EQ] = ACTIONS(4019),
    [anon_sym_GT_GT_EQ] = ACTIONS(4019),
    [anon_sym_AMP_EQ] = ACTIONS(4019),
    [anon_sym_CARET_EQ] = ACTIONS(4019),
    [anon_sym_PIPE_EQ] = ACTIONS(4019),
    [anon_sym_and_eq] = ACTIONS(4019),
    [anon_sym_or_eq] = ACTIONS(4019),
    [anon_sym_xor_eq] = ACTIONS(4019),
    [anon_sym_LT_EQ_GT] = ACTIONS(4019),
    [anon_sym_or] = ACTIONS(4017),
    [anon_sym_and] = ACTIONS(4017),
    [anon_sym_bitor] = ACTIONS(4019),
    [anon_sym_xor] = ACTIONS(4017),
    [anon_sym_bitand] = ACTIONS(4019),
    [anon_sym_not_eq] = ACTIONS(4019),
    [anon_sym_DASH_DASH] = ACTIONS(4019),
    [anon_sym_PLUS_PLUS] = ACTIONS(4019),
    [anon_sym_DOT] = ACTIONS(4017),
    [anon_sym_DOT_STAR] = ACTIONS(4019),
    [anon_sym_DASH_GT] = ACTIONS(4017),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4019),
    [anon_sym_decltype] = ACTIONS(4019),
    [anon_sym_final] = ACTIONS(4019),
    [anon_sym_override] = ACTIONS(4019),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4019),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4019),
  },
  [1712] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_RPAREN] = ACTIONS(4023),
    [anon_sym_LPAREN2] = ACTIONS(4023),
    [anon_sym_DASH] = ACTIONS(4021),
    [anon_sym_PLUS] = ACTIONS(4021),
    [anon_sym_STAR] = ACTIONS(4021),
    [anon_sym_SLASH] = ACTIONS(4021),
    [anon_sym_PERCENT] = ACTIONS(4021),
    [anon_sym_PIPE_PIPE] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4023),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_CARET] = ACTIONS(4021),
    [anon_sym_AMP] = ACTIONS(4021),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4021),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4021),
    [anon_sym___extension__] = ACTIONS(4023),
    [anon_sym___global__] = ACTIONS(4023),
    [anon_sym___attribute__] = ACTIONS(4023),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_LBRACE] = ACTIONS(4023),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_EQ] = ACTIONS(4021),
    [anon_sym_const] = ACTIONS(4021),
    [anon_sym_constexpr] = ACTIONS(4023),
    [anon_sym_volatile] = ACTIONS(4023),
    [anon_sym_restrict] = ACTIONS(4023),
    [anon_sym___restrict__] = ACTIONS(4023),
    [anon_sym__Atomic] = ACTIONS(4023),
    [anon_sym__Noreturn] = ACTIONS(4023),
    [anon_sym_noreturn] = ACTIONS(4023),
    [anon_sym_mutable] = ACTIONS(4023),
    [anon_sym_constinit] = ACTIONS(4023),
    [anon_sym_consteval] = ACTIONS(4023),
    [anon_sym___shared__] = ACTIONS(4023),
    [anon_sym___local__] = ACTIONS(4023),
    [anon_sym___constant__] = ACTIONS(4023),
    [anon_sym___managed__] = ACTIONS(4023),
    [anon_sym___grid_constant__] = ACTIONS(4023),
    [anon_sym_alignas] = ACTIONS(4023),
    [anon_sym__Alignas] = ACTIONS(4023),
    [anon_sym_COLON] = ACTIONS(4021),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_and_eq] = ACTIONS(4023),
    [anon_sym_or_eq] = ACTIONS(4023),
    [anon_sym_xor_eq] = ACTIONS(4023),
    [anon_sym_LT_EQ_GT] = ACTIONS(4023),
    [anon_sym_or] = ACTIONS(4021),
    [anon_sym_and] = ACTIONS(4021),
    [anon_sym_bitor] = ACTIONS(4023),
    [anon_sym_xor] = ACTIONS(4021),
    [anon_sym_bitand] = ACTIONS(4023),
    [anon_sym_not_eq] = ACTIONS(4023),
    [anon_sym_DASH_DASH] = ACTIONS(4023),
    [anon_sym_PLUS_PLUS] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4021),
    [anon_sym_DOT_STAR] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4021),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4023),
    [anon_sym_decltype] = ACTIONS(4023),
    [anon_sym_final] = ACTIONS(4023),
    [anon_sym_override] = ACTIONS(4023),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4023),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4023),
  },
  [1713] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3994),
    [anon_sym_COMMA] = ACTIONS(3994),
    [anon_sym_RPAREN] = ACTIONS(3994),
    [anon_sym_LPAREN2] = ACTIONS(3994),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_STAR] = ACTIONS(3992),
    [anon_sym_SLASH] = ACTIONS(3992),
    [anon_sym_PERCENT] = ACTIONS(3992),
    [anon_sym_PIPE_PIPE] = ACTIONS(3994),
    [anon_sym_AMP_AMP] = ACTIONS(3994),
    [anon_sym_PIPE] = ACTIONS(3992),
    [anon_sym_CARET] = ACTIONS(3992),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym_EQ_EQ] = ACTIONS(3994),
    [anon_sym_BANG_EQ] = ACTIONS(3994),
    [anon_sym_GT] = ACTIONS(3992),
    [anon_sym_GT_EQ] = ACTIONS(3994),
    [anon_sym_LT_EQ] = ACTIONS(3992),
    [anon_sym_LT] = ACTIONS(3992),
    [anon_sym_LT_LT] = ACTIONS(3992),
    [anon_sym_GT_GT] = ACTIONS(3992),
    [anon_sym___extension__] = ACTIONS(3994),
    [anon_sym___global__] = ACTIONS(3994),
    [anon_sym___attribute__] = ACTIONS(3994),
    [anon_sym_COLON_COLON] = ACTIONS(3994),
    [anon_sym_LBRACE] = ACTIONS(3994),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_EQ] = ACTIONS(3992),
    [anon_sym_const] = ACTIONS(3992),
    [anon_sym_constexpr] = ACTIONS(3994),
    [anon_sym_volatile] = ACTIONS(3994),
    [anon_sym_restrict] = ACTIONS(3994),
    [anon_sym___restrict__] = ACTIONS(3994),
    [anon_sym__Atomic] = ACTIONS(3994),
    [anon_sym__Noreturn] = ACTIONS(3994),
    [anon_sym_noreturn] = ACTIONS(3994),
    [anon_sym_mutable] = ACTIONS(3994),
    [anon_sym_constinit] = ACTIONS(3994),
    [anon_sym_consteval] = ACTIONS(3994),
    [anon_sym___shared__] = ACTIONS(3994),
    [anon_sym___local__] = ACTIONS(3994),
    [anon_sym___constant__] = ACTIONS(3994),
    [anon_sym___managed__] = ACTIONS(3994),
    [anon_sym___grid_constant__] = ACTIONS(3994),
    [anon_sym_alignas] = ACTIONS(3994),
    [anon_sym__Alignas] = ACTIONS(3994),
    [anon_sym_COLON] = ACTIONS(3992),
    [anon_sym_QMARK] = ACTIONS(3994),
    [anon_sym_STAR_EQ] = ACTIONS(3994),
    [anon_sym_SLASH_EQ] = ACTIONS(3994),
    [anon_sym_PERCENT_EQ] = ACTIONS(3994),
    [anon_sym_PLUS_EQ] = ACTIONS(3994),
    [anon_sym_DASH_EQ] = ACTIONS(3994),
    [anon_sym_LT_LT_EQ] = ACTIONS(3994),
    [anon_sym_GT_GT_EQ] = ACTIONS(3994),
    [anon_sym_AMP_EQ] = ACTIONS(3994),
    [anon_sym_CARET_EQ] = ACTIONS(3994),
    [anon_sym_PIPE_EQ] = ACTIONS(3994),
    [anon_sym_and_eq] = ACTIONS(3994),
    [anon_sym_or_eq] = ACTIONS(3994),
    [anon_sym_xor_eq] = ACTIONS(3994),
    [anon_sym_LT_EQ_GT] = ACTIONS(3994),
    [anon_sym_or] = ACTIONS(3992),
    [anon_sym_and] = ACTIONS(3992),
    [anon_sym_bitor] = ACTIONS(3994),
    [anon_sym_xor] = ACTIONS(3992),
    [anon_sym_bitand] = ACTIONS(3994),
    [anon_sym_not_eq] = ACTIONS(3994),
    [anon_sym_DASH_DASH] = ACTIONS(3994),
    [anon_sym_PLUS_PLUS] = ACTIONS(3994),
    [anon_sym_DOT] = ACTIONS(3992),
    [anon_sym_DOT_STAR] = ACTIONS(3994),
    [anon_sym_DASH_GT] = ACTIONS(3992),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3994),
    [anon_sym_decltype] = ACTIONS(3994),
    [anon_sym_final] = ACTIONS(3994),
    [anon_sym_override] = ACTIONS(3994),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3994),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3994),
  },
  [1714] = {
    [sym_identifier] = ACTIONS(1924),
    [aux_sym_preproc_def_token1] = ACTIONS(1924),
    [aux_sym_preproc_if_token1] = ACTIONS(1924),
    [aux_sym_preproc_if_token2] = ACTIONS(1924),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1924),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1924),
    [aux_sym_preproc_else_token1] = ACTIONS(1924),
    [aux_sym_preproc_elif_token1] = ACTIONS(1924),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1924),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1924),
    [sym_preproc_directive] = ACTIONS(1924),
    [anon_sym_LPAREN2] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [anon_sym_STAR] = ACTIONS(1926),
    [anon_sym_AMP_AMP] = ACTIONS(1926),
    [anon_sym_AMP] = ACTIONS(1924),
    [anon_sym___extension__] = ACTIONS(1924),
    [anon_sym_typedef] = ACTIONS(1924),
    [anon_sym___device__] = ACTIONS(1924),
    [anon_sym___host__] = ACTIONS(1924),
    [anon_sym___global__] = ACTIONS(1924),
    [anon_sym___forceinline__] = ACTIONS(1924),
    [anon_sym___noinline__] = ACTIONS(1924),
    [anon_sym_extern] = ACTIONS(1924),
    [anon_sym___attribute__] = ACTIONS(1924),
    [anon_sym_COLON_COLON] = ACTIONS(1926),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1926),
    [anon_sym___declspec] = ACTIONS(1924),
    [anon_sym___based] = ACTIONS(1924),
    [anon_sym_signed] = ACTIONS(1924),
    [anon_sym_unsigned] = ACTIONS(1924),
    [anon_sym_long] = ACTIONS(1924),
    [anon_sym_short] = ACTIONS(1924),
    [anon_sym_LBRACK] = ACTIONS(1924),
    [anon_sym_static] = ACTIONS(1924),
    [anon_sym_register] = ACTIONS(1924),
    [anon_sym_inline] = ACTIONS(1924),
    [anon_sym___inline] = ACTIONS(1924),
    [anon_sym___inline__] = ACTIONS(1924),
    [anon_sym___forceinline] = ACTIONS(1924),
    [anon_sym_thread_local] = ACTIONS(1924),
    [anon_sym___thread] = ACTIONS(1924),
    [anon_sym_const] = ACTIONS(1924),
    [anon_sym_constexpr] = ACTIONS(1924),
    [anon_sym_volatile] = ACTIONS(1924),
    [anon_sym_restrict] = ACTIONS(1924),
    [anon_sym___restrict__] = ACTIONS(1924),
    [anon_sym__Atomic] = ACTIONS(1924),
    [anon_sym__Noreturn] = ACTIONS(1924),
    [anon_sym_noreturn] = ACTIONS(1924),
    [anon_sym_mutable] = ACTIONS(1924),
    [anon_sym_constinit] = ACTIONS(1924),
    [anon_sym_consteval] = ACTIONS(1924),
    [anon_sym___shared__] = ACTIONS(1924),
    [anon_sym___local__] = ACTIONS(1924),
    [anon_sym___constant__] = ACTIONS(1924),
    [anon_sym___managed__] = ACTIONS(1924),
    [anon_sym___grid_constant__] = ACTIONS(1924),
    [anon_sym_alignas] = ACTIONS(1924),
    [anon_sym__Alignas] = ACTIONS(1924),
    [sym_primitive_type] = ACTIONS(1924),
    [anon_sym_enum] = ACTIONS(1924),
    [anon_sym_class] = ACTIONS(1924),
    [anon_sym_struct] = ACTIONS(1924),
    [anon_sym_union] = ACTIONS(1924),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1924),
    [anon_sym_decltype] = ACTIONS(1924),
    [sym_virtual] = ACTIONS(1924),
    [anon_sym_explicit] = ACTIONS(1924),
    [anon_sym_typename] = ACTIONS(1924),
    [anon_sym_template] = ACTIONS(1924),
    [anon_sym_operator] = ACTIONS(1924),
    [anon_sym_friend] = ACTIONS(1924),
    [anon_sym_public] = ACTIONS(1924),
    [anon_sym_private] = ACTIONS(1924),
    [anon_sym_protected] = ACTIONS(1924),
    [anon_sym_using] = ACTIONS(1924),
    [anon_sym_static_assert] = ACTIONS(1924),
    [anon_sym_catch] = ACTIONS(1924),
    [anon_sym___launch_bounds__] = ACTIONS(1924),
  },
  [1715] = {
    [sym_identifier] = ACTIONS(1897),
    [aux_sym_preproc_def_token1] = ACTIONS(1897),
    [aux_sym_preproc_if_token1] = ACTIONS(1897),
    [aux_sym_preproc_if_token2] = ACTIONS(1897),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1897),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1897),
    [aux_sym_preproc_else_token1] = ACTIONS(1897),
    [aux_sym_preproc_elif_token1] = ACTIONS(1897),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1897),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1897),
    [sym_preproc_directive] = ACTIONS(1897),
    [anon_sym_LPAREN2] = ACTIONS(1895),
    [anon_sym_TILDE] = ACTIONS(1895),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_AMP_AMP] = ACTIONS(1895),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym___extension__] = ACTIONS(1897),
    [anon_sym_typedef] = ACTIONS(1897),
    [anon_sym___device__] = ACTIONS(1897),
    [anon_sym___host__] = ACTIONS(1897),
    [anon_sym___global__] = ACTIONS(1897),
    [anon_sym___forceinline__] = ACTIONS(1897),
    [anon_sym___noinline__] = ACTIONS(1897),
    [anon_sym_extern] = ACTIONS(1897),
    [anon_sym___attribute__] = ACTIONS(1897),
    [anon_sym_COLON_COLON] = ACTIONS(1895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1895),
    [anon_sym___declspec] = ACTIONS(1897),
    [anon_sym___based] = ACTIONS(1897),
    [anon_sym_signed] = ACTIONS(1897),
    [anon_sym_unsigned] = ACTIONS(1897),
    [anon_sym_long] = ACTIONS(1897),
    [anon_sym_short] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1897),
    [anon_sym_static] = ACTIONS(1897),
    [anon_sym_register] = ACTIONS(1897),
    [anon_sym_inline] = ACTIONS(1897),
    [anon_sym___inline] = ACTIONS(1897),
    [anon_sym___inline__] = ACTIONS(1897),
    [anon_sym___forceinline] = ACTIONS(1897),
    [anon_sym_thread_local] = ACTIONS(1897),
    [anon_sym___thread] = ACTIONS(1897),
    [anon_sym_const] = ACTIONS(1897),
    [anon_sym_constexpr] = ACTIONS(1897),
    [anon_sym_volatile] = ACTIONS(1897),
    [anon_sym_restrict] = ACTIONS(1897),
    [anon_sym___restrict__] = ACTIONS(1897),
    [anon_sym__Atomic] = ACTIONS(1897),
    [anon_sym__Noreturn] = ACTIONS(1897),
    [anon_sym_noreturn] = ACTIONS(1897),
    [anon_sym_mutable] = ACTIONS(1897),
    [anon_sym_constinit] = ACTIONS(1897),
    [anon_sym_consteval] = ACTIONS(1897),
    [anon_sym___shared__] = ACTIONS(1897),
    [anon_sym___local__] = ACTIONS(1897),
    [anon_sym___constant__] = ACTIONS(1897),
    [anon_sym___managed__] = ACTIONS(1897),
    [anon_sym___grid_constant__] = ACTIONS(1897),
    [anon_sym_alignas] = ACTIONS(1897),
    [anon_sym__Alignas] = ACTIONS(1897),
    [sym_primitive_type] = ACTIONS(1897),
    [anon_sym_enum] = ACTIONS(1897),
    [anon_sym_class] = ACTIONS(1897),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1897),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1897),
    [anon_sym_decltype] = ACTIONS(1897),
    [sym_virtual] = ACTIONS(1897),
    [anon_sym_explicit] = ACTIONS(1897),
    [anon_sym_typename] = ACTIONS(1897),
    [anon_sym_template] = ACTIONS(1897),
    [anon_sym_operator] = ACTIONS(1897),
    [anon_sym_friend] = ACTIONS(1897),
    [anon_sym_public] = ACTIONS(1897),
    [anon_sym_private] = ACTIONS(1897),
    [anon_sym_protected] = ACTIONS(1897),
    [anon_sym_using] = ACTIONS(1897),
    [anon_sym_static_assert] = ACTIONS(1897),
    [anon_sym_catch] = ACTIONS(1897),
    [anon_sym___launch_bounds__] = ACTIONS(1897),
  },
  [1716] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3998),
    [anon_sym_COMMA] = ACTIONS(3998),
    [anon_sym_RPAREN] = ACTIONS(3998),
    [anon_sym_LPAREN2] = ACTIONS(3998),
    [anon_sym_DASH] = ACTIONS(3996),
    [anon_sym_PLUS] = ACTIONS(3996),
    [anon_sym_STAR] = ACTIONS(3996),
    [anon_sym_SLASH] = ACTIONS(3996),
    [anon_sym_PERCENT] = ACTIONS(3996),
    [anon_sym_PIPE_PIPE] = ACTIONS(3998),
    [anon_sym_AMP_AMP] = ACTIONS(3998),
    [anon_sym_PIPE] = ACTIONS(3996),
    [anon_sym_CARET] = ACTIONS(3996),
    [anon_sym_AMP] = ACTIONS(3996),
    [anon_sym_EQ_EQ] = ACTIONS(3998),
    [anon_sym_BANG_EQ] = ACTIONS(3998),
    [anon_sym_GT] = ACTIONS(3996),
    [anon_sym_GT_EQ] = ACTIONS(3998),
    [anon_sym_LT_EQ] = ACTIONS(3996),
    [anon_sym_LT] = ACTIONS(3996),
    [anon_sym_LT_LT] = ACTIONS(3996),
    [anon_sym_GT_GT] = ACTIONS(3996),
    [anon_sym___extension__] = ACTIONS(3998),
    [anon_sym___global__] = ACTIONS(3998),
    [anon_sym___attribute__] = ACTIONS(3998),
    [anon_sym_COLON_COLON] = ACTIONS(3998),
    [anon_sym_LBRACE] = ACTIONS(3998),
    [anon_sym_LBRACK] = ACTIONS(3998),
    [anon_sym_EQ] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3996),
    [anon_sym_constexpr] = ACTIONS(3998),
    [anon_sym_volatile] = ACTIONS(3998),
    [anon_sym_restrict] = ACTIONS(3998),
    [anon_sym___restrict__] = ACTIONS(3998),
    [anon_sym__Atomic] = ACTIONS(3998),
    [anon_sym__Noreturn] = ACTIONS(3998),
    [anon_sym_noreturn] = ACTIONS(3998),
    [anon_sym_mutable] = ACTIONS(3998),
    [anon_sym_constinit] = ACTIONS(3998),
    [anon_sym_consteval] = ACTIONS(3998),
    [anon_sym___shared__] = ACTIONS(3998),
    [anon_sym___local__] = ACTIONS(3998),
    [anon_sym___constant__] = ACTIONS(3998),
    [anon_sym___managed__] = ACTIONS(3998),
    [anon_sym___grid_constant__] = ACTIONS(3998),
    [anon_sym_alignas] = ACTIONS(3998),
    [anon_sym__Alignas] = ACTIONS(3998),
    [anon_sym_COLON] = ACTIONS(3996),
    [anon_sym_QMARK] = ACTIONS(3998),
    [anon_sym_STAR_EQ] = ACTIONS(3998),
    [anon_sym_SLASH_EQ] = ACTIONS(3998),
    [anon_sym_PERCENT_EQ] = ACTIONS(3998),
    [anon_sym_PLUS_EQ] = ACTIONS(3998),
    [anon_sym_DASH_EQ] = ACTIONS(3998),
    [anon_sym_LT_LT_EQ] = ACTIONS(3998),
    [anon_sym_GT_GT_EQ] = ACTIONS(3998),
    [anon_sym_AMP_EQ] = ACTIONS(3998),
    [anon_sym_CARET_EQ] = ACTIONS(3998),
    [anon_sym_PIPE_EQ] = ACTIONS(3998),
    [anon_sym_and_eq] = ACTIONS(3998),
    [anon_sym_or_eq] = ACTIONS(3998),
    [anon_sym_xor_eq] = ACTIONS(3998),
    [anon_sym_LT_EQ_GT] = ACTIONS(3998),
    [anon_sym_or] = ACTIONS(3996),
    [anon_sym_and] = ACTIONS(3996),
    [anon_sym_bitor] = ACTIONS(3998),
    [anon_sym_xor] = ACTIONS(3996),
    [anon_sym_bitand] = ACTIONS(3998),
    [anon_sym_not_eq] = ACTIONS(3998),
    [anon_sym_DASH_DASH] = ACTIONS(3998),
    [anon_sym_PLUS_PLUS] = ACTIONS(3998),
    [anon_sym_DOT] = ACTIONS(3996),
    [anon_sym_DOT_STAR] = ACTIONS(3998),
    [anon_sym_DASH_GT] = ACTIONS(3996),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3998),
    [anon_sym_decltype] = ACTIONS(3998),
    [anon_sym_final] = ACTIONS(3998),
    [anon_sym_override] = ACTIONS(3998),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3998),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3998),
  },
  [1717] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3982),
    [anon_sym_COMMA] = ACTIONS(3982),
    [anon_sym_RPAREN] = ACTIONS(3982),
    [anon_sym_LPAREN2] = ACTIONS(3982),
    [anon_sym_DASH] = ACTIONS(3980),
    [anon_sym_PLUS] = ACTIONS(3980),
    [anon_sym_STAR] = ACTIONS(3980),
    [anon_sym_SLASH] = ACTIONS(3980),
    [anon_sym_PERCENT] = ACTIONS(3980),
    [anon_sym_PIPE_PIPE] = ACTIONS(3982),
    [anon_sym_AMP_AMP] = ACTIONS(3982),
    [anon_sym_PIPE] = ACTIONS(3980),
    [anon_sym_CARET] = ACTIONS(3980),
    [anon_sym_AMP] = ACTIONS(3980),
    [anon_sym_EQ_EQ] = ACTIONS(3982),
    [anon_sym_BANG_EQ] = ACTIONS(3982),
    [anon_sym_GT] = ACTIONS(3980),
    [anon_sym_GT_EQ] = ACTIONS(3982),
    [anon_sym_LT_EQ] = ACTIONS(3980),
    [anon_sym_LT] = ACTIONS(3980),
    [anon_sym_LT_LT] = ACTIONS(3980),
    [anon_sym_GT_GT] = ACTIONS(3980),
    [anon_sym___extension__] = ACTIONS(3982),
    [anon_sym___global__] = ACTIONS(3982),
    [anon_sym___attribute__] = ACTIONS(3982),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(3982),
    [anon_sym_LBRACK] = ACTIONS(3982),
    [anon_sym_EQ] = ACTIONS(3980),
    [anon_sym_const] = ACTIONS(3980),
    [anon_sym_constexpr] = ACTIONS(3982),
    [anon_sym_volatile] = ACTIONS(3982),
    [anon_sym_restrict] = ACTIONS(3982),
    [anon_sym___restrict__] = ACTIONS(3982),
    [anon_sym__Atomic] = ACTIONS(3982),
    [anon_sym__Noreturn] = ACTIONS(3982),
    [anon_sym_noreturn] = ACTIONS(3982),
    [anon_sym_mutable] = ACTIONS(3982),
    [anon_sym_constinit] = ACTIONS(3982),
    [anon_sym_consteval] = ACTIONS(3982),
    [anon_sym___shared__] = ACTIONS(3982),
    [anon_sym___local__] = ACTIONS(3982),
    [anon_sym___constant__] = ACTIONS(3982),
    [anon_sym___managed__] = ACTIONS(3982),
    [anon_sym___grid_constant__] = ACTIONS(3982),
    [anon_sym_alignas] = ACTIONS(3982),
    [anon_sym__Alignas] = ACTIONS(3982),
    [anon_sym_COLON] = ACTIONS(3980),
    [anon_sym_QMARK] = ACTIONS(3982),
    [anon_sym_STAR_EQ] = ACTIONS(3982),
    [anon_sym_SLASH_EQ] = ACTIONS(3982),
    [anon_sym_PERCENT_EQ] = ACTIONS(3982),
    [anon_sym_PLUS_EQ] = ACTIONS(3982),
    [anon_sym_DASH_EQ] = ACTIONS(3982),
    [anon_sym_LT_LT_EQ] = ACTIONS(3982),
    [anon_sym_GT_GT_EQ] = ACTIONS(3982),
    [anon_sym_AMP_EQ] = ACTIONS(3982),
    [anon_sym_CARET_EQ] = ACTIONS(3982),
    [anon_sym_PIPE_EQ] = ACTIONS(3982),
    [anon_sym_and_eq] = ACTIONS(3982),
    [anon_sym_or_eq] = ACTIONS(3982),
    [anon_sym_xor_eq] = ACTIONS(3982),
    [anon_sym_LT_EQ_GT] = ACTIONS(3982),
    [anon_sym_or] = ACTIONS(3980),
    [anon_sym_and] = ACTIONS(3980),
    [anon_sym_bitor] = ACTIONS(3982),
    [anon_sym_xor] = ACTIONS(3980),
    [anon_sym_bitand] = ACTIONS(3982),
    [anon_sym_not_eq] = ACTIONS(3982),
    [anon_sym_DASH_DASH] = ACTIONS(3982),
    [anon_sym_PLUS_PLUS] = ACTIONS(3982),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_DOT_STAR] = ACTIONS(3982),
    [anon_sym_DASH_GT] = ACTIONS(3980),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3982),
    [anon_sym_decltype] = ACTIONS(3982),
    [anon_sym_final] = ACTIONS(3982),
    [anon_sym_override] = ACTIONS(3982),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3982),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3982),
  },
  [1718] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3990),
    [anon_sym_COMMA] = ACTIONS(3990),
    [anon_sym_RPAREN] = ACTIONS(3990),
    [anon_sym_LPAREN2] = ACTIONS(3990),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_STAR] = ACTIONS(3988),
    [anon_sym_SLASH] = ACTIONS(3988),
    [anon_sym_PERCENT] = ACTIONS(3988),
    [anon_sym_PIPE_PIPE] = ACTIONS(3990),
    [anon_sym_AMP_AMP] = ACTIONS(3990),
    [anon_sym_PIPE] = ACTIONS(3988),
    [anon_sym_CARET] = ACTIONS(3988),
    [anon_sym_AMP] = ACTIONS(3988),
    [anon_sym_EQ_EQ] = ACTIONS(3990),
    [anon_sym_BANG_EQ] = ACTIONS(3990),
    [anon_sym_GT] = ACTIONS(3988),
    [anon_sym_GT_EQ] = ACTIONS(3990),
    [anon_sym_LT_EQ] = ACTIONS(3988),
    [anon_sym_LT] = ACTIONS(3988),
    [anon_sym_LT_LT] = ACTIONS(3988),
    [anon_sym_GT_GT] = ACTIONS(3988),
    [anon_sym___extension__] = ACTIONS(3990),
    [anon_sym___global__] = ACTIONS(3990),
    [anon_sym___attribute__] = ACTIONS(3990),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [anon_sym_LBRACE] = ACTIONS(3990),
    [anon_sym_LBRACK] = ACTIONS(3990),
    [anon_sym_EQ] = ACTIONS(3988),
    [anon_sym_const] = ACTIONS(3988),
    [anon_sym_constexpr] = ACTIONS(3990),
    [anon_sym_volatile] = ACTIONS(3990),
    [anon_sym_restrict] = ACTIONS(3990),
    [anon_sym___restrict__] = ACTIONS(3990),
    [anon_sym__Atomic] = ACTIONS(3990),
    [anon_sym__Noreturn] = ACTIONS(3990),
    [anon_sym_noreturn] = ACTIONS(3990),
    [anon_sym_mutable] = ACTIONS(3990),
    [anon_sym_constinit] = ACTIONS(3990),
    [anon_sym_consteval] = ACTIONS(3990),
    [anon_sym___shared__] = ACTIONS(3990),
    [anon_sym___local__] = ACTIONS(3990),
    [anon_sym___constant__] = ACTIONS(3990),
    [anon_sym___managed__] = ACTIONS(3990),
    [anon_sym___grid_constant__] = ACTIONS(3990),
    [anon_sym_alignas] = ACTIONS(3990),
    [anon_sym__Alignas] = ACTIONS(3990),
    [anon_sym_COLON] = ACTIONS(3988),
    [anon_sym_QMARK] = ACTIONS(3990),
    [anon_sym_STAR_EQ] = ACTIONS(3990),
    [anon_sym_SLASH_EQ] = ACTIONS(3990),
    [anon_sym_PERCENT_EQ] = ACTIONS(3990),
    [anon_sym_PLUS_EQ] = ACTIONS(3990),
    [anon_sym_DASH_EQ] = ACTIONS(3990),
    [anon_sym_LT_LT_EQ] = ACTIONS(3990),
    [anon_sym_GT_GT_EQ] = ACTIONS(3990),
    [anon_sym_AMP_EQ] = ACTIONS(3990),
    [anon_sym_CARET_EQ] = ACTIONS(3990),
    [anon_sym_PIPE_EQ] = ACTIONS(3990),
    [anon_sym_and_eq] = ACTIONS(3990),
    [anon_sym_or_eq] = ACTIONS(3990),
    [anon_sym_xor_eq] = ACTIONS(3990),
    [anon_sym_LT_EQ_GT] = ACTIONS(3990),
    [anon_sym_or] = ACTIONS(3988),
    [anon_sym_and] = ACTIONS(3988),
    [anon_sym_bitor] = ACTIONS(3990),
    [anon_sym_xor] = ACTIONS(3988),
    [anon_sym_bitand] = ACTIONS(3990),
    [anon_sym_not_eq] = ACTIONS(3990),
    [anon_sym_DASH_DASH] = ACTIONS(3990),
    [anon_sym_PLUS_PLUS] = ACTIONS(3990),
    [anon_sym_DOT] = ACTIONS(3988),
    [anon_sym_DOT_STAR] = ACTIONS(3990),
    [anon_sym_DASH_GT] = ACTIONS(3988),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3990),
    [anon_sym_decltype] = ACTIONS(3990),
    [anon_sym_final] = ACTIONS(3990),
    [anon_sym_override] = ACTIONS(3990),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3990),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3990),
  },
  [1719] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3986),
    [anon_sym_COMMA] = ACTIONS(3986),
    [anon_sym_RPAREN] = ACTIONS(3986),
    [anon_sym_LPAREN2] = ACTIONS(3986),
    [anon_sym_DASH] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(3984),
    [anon_sym_SLASH] = ACTIONS(3984),
    [anon_sym_PERCENT] = ACTIONS(3984),
    [anon_sym_PIPE_PIPE] = ACTIONS(3986),
    [anon_sym_AMP_AMP] = ACTIONS(3986),
    [anon_sym_PIPE] = ACTIONS(3984),
    [anon_sym_CARET] = ACTIONS(3984),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_EQ_EQ] = ACTIONS(3986),
    [anon_sym_BANG_EQ] = ACTIONS(3986),
    [anon_sym_GT] = ACTIONS(3984),
    [anon_sym_GT_EQ] = ACTIONS(3986),
    [anon_sym_LT_EQ] = ACTIONS(3984),
    [anon_sym_LT] = ACTIONS(3984),
    [anon_sym_LT_LT] = ACTIONS(3984),
    [anon_sym_GT_GT] = ACTIONS(3984),
    [anon_sym___extension__] = ACTIONS(3986),
    [anon_sym___global__] = ACTIONS(3986),
    [anon_sym___attribute__] = ACTIONS(3986),
    [anon_sym_COLON_COLON] = ACTIONS(3986),
    [anon_sym_LBRACE] = ACTIONS(3986),
    [anon_sym_LBRACK] = ACTIONS(3986),
    [anon_sym_EQ] = ACTIONS(3984),
    [anon_sym_const] = ACTIONS(3984),
    [anon_sym_constexpr] = ACTIONS(3986),
    [anon_sym_volatile] = ACTIONS(3986),
    [anon_sym_restrict] = ACTIONS(3986),
    [anon_sym___restrict__] = ACTIONS(3986),
    [anon_sym__Atomic] = ACTIONS(3986),
    [anon_sym__Noreturn] = ACTIONS(3986),
    [anon_sym_noreturn] = ACTIONS(3986),
    [anon_sym_mutable] = ACTIONS(3986),
    [anon_sym_constinit] = ACTIONS(3986),
    [anon_sym_consteval] = ACTIONS(3986),
    [anon_sym___shared__] = ACTIONS(3986),
    [anon_sym___local__] = ACTIONS(3986),
    [anon_sym___constant__] = ACTIONS(3986),
    [anon_sym___managed__] = ACTIONS(3986),
    [anon_sym___grid_constant__] = ACTIONS(3986),
    [anon_sym_alignas] = ACTIONS(3986),
    [anon_sym__Alignas] = ACTIONS(3986),
    [anon_sym_COLON] = ACTIONS(3984),
    [anon_sym_QMARK] = ACTIONS(3986),
    [anon_sym_STAR_EQ] = ACTIONS(3986),
    [anon_sym_SLASH_EQ] = ACTIONS(3986),
    [anon_sym_PERCENT_EQ] = ACTIONS(3986),
    [anon_sym_PLUS_EQ] = ACTIONS(3986),
    [anon_sym_DASH_EQ] = ACTIONS(3986),
    [anon_sym_LT_LT_EQ] = ACTIONS(3986),
    [anon_sym_GT_GT_EQ] = ACTIONS(3986),
    [anon_sym_AMP_EQ] = ACTIONS(3986),
    [anon_sym_CARET_EQ] = ACTIONS(3986),
    [anon_sym_PIPE_EQ] = ACTIONS(3986),
    [anon_sym_and_eq] = ACTIONS(3986),
    [anon_sym_or_eq] = ACTIONS(3986),
    [anon_sym_xor_eq] = ACTIONS(3986),
    [anon_sym_LT_EQ_GT] = ACTIONS(3986),
    [anon_sym_or] = ACTIONS(3984),
    [anon_sym_and] = ACTIONS(3984),
    [anon_sym_bitor] = ACTIONS(3986),
    [anon_sym_xor] = ACTIONS(3984),
    [anon_sym_bitand] = ACTIONS(3986),
    [anon_sym_not_eq] = ACTIONS(3986),
    [anon_sym_DASH_DASH] = ACTIONS(3986),
    [anon_sym_PLUS_PLUS] = ACTIONS(3986),
    [anon_sym_DOT] = ACTIONS(3984),
    [anon_sym_DOT_STAR] = ACTIONS(3986),
    [anon_sym_DASH_GT] = ACTIONS(3984),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3986),
    [anon_sym_decltype] = ACTIONS(3986),
    [anon_sym_final] = ACTIONS(3986),
    [anon_sym_override] = ACTIONS(3986),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3986),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3986),
  },
  [1720] = {
    [sym_identifier] = ACTIONS(5023),
    [aux_sym_preproc_def_token1] = ACTIONS(5023),
    [aux_sym_preproc_if_token1] = ACTIONS(5023),
    [aux_sym_preproc_if_token2] = ACTIONS(5023),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5023),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5023),
    [aux_sym_preproc_else_token1] = ACTIONS(5023),
    [aux_sym_preproc_elif_token1] = ACTIONS(5023),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5023),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5023),
    [sym_preproc_directive] = ACTIONS(5023),
    [anon_sym_LPAREN2] = ACTIONS(5025),
    [anon_sym_TILDE] = ACTIONS(5025),
    [anon_sym_STAR] = ACTIONS(5025),
    [anon_sym_AMP_AMP] = ACTIONS(5025),
    [anon_sym_AMP] = ACTIONS(5023),
    [anon_sym___extension__] = ACTIONS(5023),
    [anon_sym_typedef] = ACTIONS(5023),
    [anon_sym___device__] = ACTIONS(5023),
    [anon_sym___host__] = ACTIONS(5023),
    [anon_sym___global__] = ACTIONS(5023),
    [anon_sym___forceinline__] = ACTIONS(5023),
    [anon_sym___noinline__] = ACTIONS(5023),
    [anon_sym_extern] = ACTIONS(5023),
    [anon_sym___attribute__] = ACTIONS(5023),
    [anon_sym_COLON_COLON] = ACTIONS(5025),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5025),
    [anon_sym___declspec] = ACTIONS(5023),
    [anon_sym___based] = ACTIONS(5023),
    [anon_sym_signed] = ACTIONS(5023),
    [anon_sym_unsigned] = ACTIONS(5023),
    [anon_sym_long] = ACTIONS(5023),
    [anon_sym_short] = ACTIONS(5023),
    [anon_sym_LBRACK] = ACTIONS(5023),
    [anon_sym_static] = ACTIONS(5023),
    [anon_sym_register] = ACTIONS(5023),
    [anon_sym_inline] = ACTIONS(5023),
    [anon_sym___inline] = ACTIONS(5023),
    [anon_sym___inline__] = ACTIONS(5023),
    [anon_sym___forceinline] = ACTIONS(5023),
    [anon_sym_thread_local] = ACTIONS(5023),
    [anon_sym___thread] = ACTIONS(5023),
    [anon_sym_const] = ACTIONS(5023),
    [anon_sym_constexpr] = ACTIONS(5023),
    [anon_sym_volatile] = ACTIONS(5023),
    [anon_sym_restrict] = ACTIONS(5023),
    [anon_sym___restrict__] = ACTIONS(5023),
    [anon_sym__Atomic] = ACTIONS(5023),
    [anon_sym__Noreturn] = ACTIONS(5023),
    [anon_sym_noreturn] = ACTIONS(5023),
    [anon_sym_mutable] = ACTIONS(5023),
    [anon_sym_constinit] = ACTIONS(5023),
    [anon_sym_consteval] = ACTIONS(5023),
    [anon_sym___shared__] = ACTIONS(5023),
    [anon_sym___local__] = ACTIONS(5023),
    [anon_sym___constant__] = ACTIONS(5023),
    [anon_sym___managed__] = ACTIONS(5023),
    [anon_sym___grid_constant__] = ACTIONS(5023),
    [anon_sym_alignas] = ACTIONS(5023),
    [anon_sym__Alignas] = ACTIONS(5023),
    [sym_primitive_type] = ACTIONS(5023),
    [anon_sym_enum] = ACTIONS(5023),
    [anon_sym_class] = ACTIONS(5023),
    [anon_sym_struct] = ACTIONS(5023),
    [anon_sym_union] = ACTIONS(5023),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5023),
    [anon_sym_decltype] = ACTIONS(5023),
    [sym_virtual] = ACTIONS(5023),
    [anon_sym_explicit] = ACTIONS(5023),
    [anon_sym_typename] = ACTIONS(5023),
    [anon_sym_template] = ACTIONS(5023),
    [anon_sym_operator] = ACTIONS(5023),
    [anon_sym_friend] = ACTIONS(5023),
    [anon_sym_public] = ACTIONS(5023),
    [anon_sym_private] = ACTIONS(5023),
    [anon_sym_protected] = ACTIONS(5023),
    [anon_sym_using] = ACTIONS(5023),
    [anon_sym_static_assert] = ACTIONS(5023),
    [anon_sym___launch_bounds__] = ACTIONS(5023),
  },
  [1721] = {
    [sym_identifier] = ACTIONS(2191),
    [aux_sym_preproc_def_token1] = ACTIONS(2191),
    [aux_sym_preproc_if_token1] = ACTIONS(2191),
    [aux_sym_preproc_if_token2] = ACTIONS(2191),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2191),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2191),
    [aux_sym_preproc_else_token1] = ACTIONS(2191),
    [aux_sym_preproc_elif_token1] = ACTIONS(2191),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2191),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2191),
    [sym_preproc_directive] = ACTIONS(2191),
    [anon_sym_LPAREN2] = ACTIONS(2193),
    [anon_sym_TILDE] = ACTIONS(2193),
    [anon_sym_STAR] = ACTIONS(2193),
    [anon_sym_AMP_AMP] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2191),
    [anon_sym___extension__] = ACTIONS(2191),
    [anon_sym_typedef] = ACTIONS(2191),
    [anon_sym___device__] = ACTIONS(2191),
    [anon_sym___host__] = ACTIONS(2191),
    [anon_sym___global__] = ACTIONS(2191),
    [anon_sym___forceinline__] = ACTIONS(2191),
    [anon_sym___noinline__] = ACTIONS(2191),
    [anon_sym_extern] = ACTIONS(2191),
    [anon_sym___attribute__] = ACTIONS(2191),
    [anon_sym_COLON_COLON] = ACTIONS(2193),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2193),
    [anon_sym___declspec] = ACTIONS(2191),
    [anon_sym___based] = ACTIONS(2191),
    [anon_sym_signed] = ACTIONS(2191),
    [anon_sym_unsigned] = ACTIONS(2191),
    [anon_sym_long] = ACTIONS(2191),
    [anon_sym_short] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2191),
    [anon_sym_static] = ACTIONS(2191),
    [anon_sym_register] = ACTIONS(2191),
    [anon_sym_inline] = ACTIONS(2191),
    [anon_sym___inline] = ACTIONS(2191),
    [anon_sym___inline__] = ACTIONS(2191),
    [anon_sym___forceinline] = ACTIONS(2191),
    [anon_sym_thread_local] = ACTIONS(2191),
    [anon_sym___thread] = ACTIONS(2191),
    [anon_sym_const] = ACTIONS(2191),
    [anon_sym_constexpr] = ACTIONS(2191),
    [anon_sym_volatile] = ACTIONS(2191),
    [anon_sym_restrict] = ACTIONS(2191),
    [anon_sym___restrict__] = ACTIONS(2191),
    [anon_sym__Atomic] = ACTIONS(2191),
    [anon_sym__Noreturn] = ACTIONS(2191),
    [anon_sym_noreturn] = ACTIONS(2191),
    [anon_sym_mutable] = ACTIONS(2191),
    [anon_sym_constinit] = ACTIONS(2191),
    [anon_sym_consteval] = ACTIONS(2191),
    [anon_sym___shared__] = ACTIONS(2191),
    [anon_sym___local__] = ACTIONS(2191),
    [anon_sym___constant__] = ACTIONS(2191),
    [anon_sym___managed__] = ACTIONS(2191),
    [anon_sym___grid_constant__] = ACTIONS(2191),
    [anon_sym_alignas] = ACTIONS(2191),
    [anon_sym__Alignas] = ACTIONS(2191),
    [sym_primitive_type] = ACTIONS(2191),
    [anon_sym_enum] = ACTIONS(2191),
    [anon_sym_class] = ACTIONS(2191),
    [anon_sym_struct] = ACTIONS(2191),
    [anon_sym_union] = ACTIONS(2191),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2191),
    [anon_sym_decltype] = ACTIONS(2191),
    [sym_virtual] = ACTIONS(2191),
    [anon_sym_explicit] = ACTIONS(2191),
    [anon_sym_typename] = ACTIONS(2191),
    [anon_sym_template] = ACTIONS(2191),
    [anon_sym_operator] = ACTIONS(2191),
    [anon_sym_friend] = ACTIONS(2191),
    [anon_sym_public] = ACTIONS(2191),
    [anon_sym_private] = ACTIONS(2191),
    [anon_sym_protected] = ACTIONS(2191),
    [anon_sym_using] = ACTIONS(2191),
    [anon_sym_static_assert] = ACTIONS(2191),
    [anon_sym___launch_bounds__] = ACTIONS(2191),
  },
  [1722] = {
    [sym_identifier] = ACTIONS(1964),
    [aux_sym_preproc_def_token1] = ACTIONS(1964),
    [aux_sym_preproc_if_token1] = ACTIONS(1964),
    [aux_sym_preproc_if_token2] = ACTIONS(1964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1964),
    [aux_sym_preproc_else_token1] = ACTIONS(1964),
    [aux_sym_preproc_elif_token1] = ACTIONS(1964),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1964),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1964),
    [sym_preproc_directive] = ACTIONS(1964),
    [anon_sym_LPAREN2] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [anon_sym_STAR] = ACTIONS(1966),
    [anon_sym_AMP_AMP] = ACTIONS(1966),
    [anon_sym_AMP] = ACTIONS(1964),
    [anon_sym___extension__] = ACTIONS(1964),
    [anon_sym_typedef] = ACTIONS(1964),
    [anon_sym___device__] = ACTIONS(1964),
    [anon_sym___host__] = ACTIONS(1964),
    [anon_sym___global__] = ACTIONS(1964),
    [anon_sym___forceinline__] = ACTIONS(1964),
    [anon_sym___noinline__] = ACTIONS(1964),
    [anon_sym_extern] = ACTIONS(1964),
    [anon_sym___attribute__] = ACTIONS(1964),
    [anon_sym_COLON_COLON] = ACTIONS(1966),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1966),
    [anon_sym___declspec] = ACTIONS(1964),
    [anon_sym___based] = ACTIONS(1964),
    [anon_sym_signed] = ACTIONS(1964),
    [anon_sym_unsigned] = ACTIONS(1964),
    [anon_sym_long] = ACTIONS(1964),
    [anon_sym_short] = ACTIONS(1964),
    [anon_sym_LBRACK] = ACTIONS(1964),
    [anon_sym_static] = ACTIONS(1964),
    [anon_sym_register] = ACTIONS(1964),
    [anon_sym_inline] = ACTIONS(1964),
    [anon_sym___inline] = ACTIONS(1964),
    [anon_sym___inline__] = ACTIONS(1964),
    [anon_sym___forceinline] = ACTIONS(1964),
    [anon_sym_thread_local] = ACTIONS(1964),
    [anon_sym___thread] = ACTIONS(1964),
    [anon_sym_const] = ACTIONS(1964),
    [anon_sym_constexpr] = ACTIONS(1964),
    [anon_sym_volatile] = ACTIONS(1964),
    [anon_sym_restrict] = ACTIONS(1964),
    [anon_sym___restrict__] = ACTIONS(1964),
    [anon_sym__Atomic] = ACTIONS(1964),
    [anon_sym__Noreturn] = ACTIONS(1964),
    [anon_sym_noreturn] = ACTIONS(1964),
    [anon_sym_mutable] = ACTIONS(1964),
    [anon_sym_constinit] = ACTIONS(1964),
    [anon_sym_consteval] = ACTIONS(1964),
    [anon_sym___shared__] = ACTIONS(1964),
    [anon_sym___local__] = ACTIONS(1964),
    [anon_sym___constant__] = ACTIONS(1964),
    [anon_sym___managed__] = ACTIONS(1964),
    [anon_sym___grid_constant__] = ACTIONS(1964),
    [anon_sym_alignas] = ACTIONS(1964),
    [anon_sym__Alignas] = ACTIONS(1964),
    [sym_primitive_type] = ACTIONS(1964),
    [anon_sym_enum] = ACTIONS(1964),
    [anon_sym_class] = ACTIONS(1964),
    [anon_sym_struct] = ACTIONS(1964),
    [anon_sym_union] = ACTIONS(1964),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1964),
    [anon_sym_decltype] = ACTIONS(1964),
    [sym_virtual] = ACTIONS(1964),
    [anon_sym_explicit] = ACTIONS(1964),
    [anon_sym_typename] = ACTIONS(1964),
    [anon_sym_template] = ACTIONS(1964),
    [anon_sym_operator] = ACTIONS(1964),
    [anon_sym_friend] = ACTIONS(1964),
    [anon_sym_public] = ACTIONS(1964),
    [anon_sym_private] = ACTIONS(1964),
    [anon_sym_protected] = ACTIONS(1964),
    [anon_sym_using] = ACTIONS(1964),
    [anon_sym_static_assert] = ACTIONS(1964),
    [anon_sym___launch_bounds__] = ACTIONS(1964),
  },
  [1723] = {
    [sym_identifier] = ACTIONS(1964),
    [aux_sym_preproc_def_token1] = ACTIONS(1964),
    [aux_sym_preproc_if_token1] = ACTIONS(1964),
    [aux_sym_preproc_if_token2] = ACTIONS(1964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1964),
    [aux_sym_preproc_else_token1] = ACTIONS(1964),
    [aux_sym_preproc_elif_token1] = ACTIONS(1964),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1964),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1964),
    [sym_preproc_directive] = ACTIONS(1964),
    [anon_sym_LPAREN2] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [anon_sym_STAR] = ACTIONS(1966),
    [anon_sym_AMP_AMP] = ACTIONS(1966),
    [anon_sym_AMP] = ACTIONS(1964),
    [anon_sym___extension__] = ACTIONS(1964),
    [anon_sym_typedef] = ACTIONS(1964),
    [anon_sym___device__] = ACTIONS(1964),
    [anon_sym___host__] = ACTIONS(1964),
    [anon_sym___global__] = ACTIONS(1964),
    [anon_sym___forceinline__] = ACTIONS(1964),
    [anon_sym___noinline__] = ACTIONS(1964),
    [anon_sym_extern] = ACTIONS(1964),
    [anon_sym___attribute__] = ACTIONS(1964),
    [anon_sym_COLON_COLON] = ACTIONS(1966),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1966),
    [anon_sym___declspec] = ACTIONS(1964),
    [anon_sym___based] = ACTIONS(1964),
    [anon_sym_signed] = ACTIONS(1964),
    [anon_sym_unsigned] = ACTIONS(1964),
    [anon_sym_long] = ACTIONS(1964),
    [anon_sym_short] = ACTIONS(1964),
    [anon_sym_LBRACK] = ACTIONS(1964),
    [anon_sym_static] = ACTIONS(1964),
    [anon_sym_register] = ACTIONS(1964),
    [anon_sym_inline] = ACTIONS(1964),
    [anon_sym___inline] = ACTIONS(1964),
    [anon_sym___inline__] = ACTIONS(1964),
    [anon_sym___forceinline] = ACTIONS(1964),
    [anon_sym_thread_local] = ACTIONS(1964),
    [anon_sym___thread] = ACTIONS(1964),
    [anon_sym_const] = ACTIONS(1964),
    [anon_sym_constexpr] = ACTIONS(1964),
    [anon_sym_volatile] = ACTIONS(1964),
    [anon_sym_restrict] = ACTIONS(1964),
    [anon_sym___restrict__] = ACTIONS(1964),
    [anon_sym__Atomic] = ACTIONS(1964),
    [anon_sym__Noreturn] = ACTIONS(1964),
    [anon_sym_noreturn] = ACTIONS(1964),
    [anon_sym_mutable] = ACTIONS(1964),
    [anon_sym_constinit] = ACTIONS(1964),
    [anon_sym_consteval] = ACTIONS(1964),
    [anon_sym___shared__] = ACTIONS(1964),
    [anon_sym___local__] = ACTIONS(1964),
    [anon_sym___constant__] = ACTIONS(1964),
    [anon_sym___managed__] = ACTIONS(1964),
    [anon_sym___grid_constant__] = ACTIONS(1964),
    [anon_sym_alignas] = ACTIONS(1964),
    [anon_sym__Alignas] = ACTIONS(1964),
    [sym_primitive_type] = ACTIONS(1964),
    [anon_sym_enum] = ACTIONS(1964),
    [anon_sym_class] = ACTIONS(1964),
    [anon_sym_struct] = ACTIONS(1964),
    [anon_sym_union] = ACTIONS(1964),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1964),
    [anon_sym_decltype] = ACTIONS(1964),
    [sym_virtual] = ACTIONS(1964),
    [anon_sym_explicit] = ACTIONS(1964),
    [anon_sym_typename] = ACTIONS(1964),
    [anon_sym_template] = ACTIONS(1964),
    [anon_sym_operator] = ACTIONS(1964),
    [anon_sym_friend] = ACTIONS(1964),
    [anon_sym_public] = ACTIONS(1964),
    [anon_sym_private] = ACTIONS(1964),
    [anon_sym_protected] = ACTIONS(1964),
    [anon_sym_using] = ACTIONS(1964),
    [anon_sym_static_assert] = ACTIONS(1964),
    [anon_sym___launch_bounds__] = ACTIONS(1964),
  },
  [1724] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3990),
    [anon_sym_COMMA] = ACTIONS(3990),
    [anon_sym_LPAREN2] = ACTIONS(3990),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_STAR] = ACTIONS(3988),
    [anon_sym_SLASH] = ACTIONS(3988),
    [anon_sym_PERCENT] = ACTIONS(3988),
    [anon_sym_PIPE_PIPE] = ACTIONS(3990),
    [anon_sym_AMP_AMP] = ACTIONS(3990),
    [anon_sym_PIPE] = ACTIONS(3988),
    [anon_sym_CARET] = ACTIONS(3988),
    [anon_sym_AMP] = ACTIONS(3988),
    [anon_sym_EQ_EQ] = ACTIONS(3990),
    [anon_sym_BANG_EQ] = ACTIONS(3990),
    [anon_sym_GT] = ACTIONS(3988),
    [anon_sym_GT_EQ] = ACTIONS(3988),
    [anon_sym_LT_EQ] = ACTIONS(3988),
    [anon_sym_LT] = ACTIONS(3988),
    [anon_sym_LT_LT] = ACTIONS(3988),
    [anon_sym_GT_GT] = ACTIONS(3988),
    [anon_sym___extension__] = ACTIONS(3990),
    [anon_sym___global__] = ACTIONS(3990),
    [anon_sym___attribute__] = ACTIONS(3990),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [anon_sym_LBRACE] = ACTIONS(3990),
    [anon_sym_LBRACK] = ACTIONS(3990),
    [anon_sym_EQ] = ACTIONS(3988),
    [anon_sym_const] = ACTIONS(3988),
    [anon_sym_constexpr] = ACTIONS(3990),
    [anon_sym_volatile] = ACTIONS(3990),
    [anon_sym_restrict] = ACTIONS(3990),
    [anon_sym___restrict__] = ACTIONS(3990),
    [anon_sym__Atomic] = ACTIONS(3990),
    [anon_sym__Noreturn] = ACTIONS(3990),
    [anon_sym_noreturn] = ACTIONS(3990),
    [anon_sym_mutable] = ACTIONS(3990),
    [anon_sym_constinit] = ACTIONS(3990),
    [anon_sym_consteval] = ACTIONS(3990),
    [anon_sym___shared__] = ACTIONS(3990),
    [anon_sym___local__] = ACTIONS(3990),
    [anon_sym___constant__] = ACTIONS(3990),
    [anon_sym___managed__] = ACTIONS(3990),
    [anon_sym___grid_constant__] = ACTIONS(3990),
    [anon_sym_alignas] = ACTIONS(3990),
    [anon_sym__Alignas] = ACTIONS(3990),
    [anon_sym_COLON] = ACTIONS(3988),
    [anon_sym_QMARK] = ACTIONS(3990),
    [anon_sym_STAR_EQ] = ACTIONS(3990),
    [anon_sym_SLASH_EQ] = ACTIONS(3990),
    [anon_sym_PERCENT_EQ] = ACTIONS(3990),
    [anon_sym_PLUS_EQ] = ACTIONS(3990),
    [anon_sym_DASH_EQ] = ACTIONS(3990),
    [anon_sym_LT_LT_EQ] = ACTIONS(3990),
    [anon_sym_GT_GT_EQ] = ACTIONS(3988),
    [anon_sym_AMP_EQ] = ACTIONS(3990),
    [anon_sym_CARET_EQ] = ACTIONS(3990),
    [anon_sym_PIPE_EQ] = ACTIONS(3990),
    [anon_sym_and_eq] = ACTIONS(3990),
    [anon_sym_or_eq] = ACTIONS(3990),
    [anon_sym_xor_eq] = ACTIONS(3990),
    [anon_sym_LT_EQ_GT] = ACTIONS(3990),
    [anon_sym_or] = ACTIONS(3988),
    [anon_sym_and] = ACTIONS(3988),
    [anon_sym_bitor] = ACTIONS(3990),
    [anon_sym_xor] = ACTIONS(3988),
    [anon_sym_bitand] = ACTIONS(3990),
    [anon_sym_not_eq] = ACTIONS(3990),
    [anon_sym_DASH_DASH] = ACTIONS(3990),
    [anon_sym_PLUS_PLUS] = ACTIONS(3990),
    [anon_sym_DOT] = ACTIONS(3988),
    [anon_sym_DOT_STAR] = ACTIONS(3990),
    [anon_sym_DASH_GT] = ACTIONS(3990),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3990),
    [anon_sym_decltype] = ACTIONS(3990),
    [anon_sym_final] = ACTIONS(3990),
    [anon_sym_override] = ACTIONS(3990),
    [anon_sym_GT2] = ACTIONS(3990),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3990),
  },
  [1725] = {
    [sym_identifier] = ACTIONS(5027),
    [aux_sym_preproc_def_token1] = ACTIONS(5027),
    [aux_sym_preproc_if_token1] = ACTIONS(5027),
    [aux_sym_preproc_if_token2] = ACTIONS(5027),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5027),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5027),
    [aux_sym_preproc_else_token1] = ACTIONS(5027),
    [aux_sym_preproc_elif_token1] = ACTIONS(5027),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5027),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5027),
    [sym_preproc_directive] = ACTIONS(5027),
    [anon_sym_LPAREN2] = ACTIONS(5029),
    [anon_sym_TILDE] = ACTIONS(5029),
    [anon_sym_STAR] = ACTIONS(5029),
    [anon_sym_AMP_AMP] = ACTIONS(5029),
    [anon_sym_AMP] = ACTIONS(5027),
    [anon_sym___extension__] = ACTIONS(5027),
    [anon_sym_typedef] = ACTIONS(5027),
    [anon_sym___device__] = ACTIONS(5027),
    [anon_sym___host__] = ACTIONS(5027),
    [anon_sym___global__] = ACTIONS(5027),
    [anon_sym___forceinline__] = ACTIONS(5027),
    [anon_sym___noinline__] = ACTIONS(5027),
    [anon_sym_extern] = ACTIONS(5027),
    [anon_sym___attribute__] = ACTIONS(5027),
    [anon_sym_COLON_COLON] = ACTIONS(5029),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5029),
    [anon_sym___declspec] = ACTIONS(5027),
    [anon_sym___based] = ACTIONS(5027),
    [anon_sym_signed] = ACTIONS(5027),
    [anon_sym_unsigned] = ACTIONS(5027),
    [anon_sym_long] = ACTIONS(5027),
    [anon_sym_short] = ACTIONS(5027),
    [anon_sym_LBRACK] = ACTIONS(5027),
    [anon_sym_static] = ACTIONS(5027),
    [anon_sym_register] = ACTIONS(5027),
    [anon_sym_inline] = ACTIONS(5027),
    [anon_sym___inline] = ACTIONS(5027),
    [anon_sym___inline__] = ACTIONS(5027),
    [anon_sym___forceinline] = ACTIONS(5027),
    [anon_sym_thread_local] = ACTIONS(5027),
    [anon_sym___thread] = ACTIONS(5027),
    [anon_sym_const] = ACTIONS(5027),
    [anon_sym_constexpr] = ACTIONS(5027),
    [anon_sym_volatile] = ACTIONS(5027),
    [anon_sym_restrict] = ACTIONS(5027),
    [anon_sym___restrict__] = ACTIONS(5027),
    [anon_sym__Atomic] = ACTIONS(5027),
    [anon_sym__Noreturn] = ACTIONS(5027),
    [anon_sym_noreturn] = ACTIONS(5027),
    [anon_sym_mutable] = ACTIONS(5027),
    [anon_sym_constinit] = ACTIONS(5027),
    [anon_sym_consteval] = ACTIONS(5027),
    [anon_sym___shared__] = ACTIONS(5027),
    [anon_sym___local__] = ACTIONS(5027),
    [anon_sym___constant__] = ACTIONS(5027),
    [anon_sym___managed__] = ACTIONS(5027),
    [anon_sym___grid_constant__] = ACTIONS(5027),
    [anon_sym_alignas] = ACTIONS(5027),
    [anon_sym__Alignas] = ACTIONS(5027),
    [sym_primitive_type] = ACTIONS(5027),
    [anon_sym_enum] = ACTIONS(5027),
    [anon_sym_class] = ACTIONS(5027),
    [anon_sym_struct] = ACTIONS(5027),
    [anon_sym_union] = ACTIONS(5027),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5027),
    [anon_sym_decltype] = ACTIONS(5027),
    [sym_virtual] = ACTIONS(5027),
    [anon_sym_explicit] = ACTIONS(5027),
    [anon_sym_typename] = ACTIONS(5027),
    [anon_sym_template] = ACTIONS(5027),
    [anon_sym_operator] = ACTIONS(5027),
    [anon_sym_friend] = ACTIONS(5027),
    [anon_sym_public] = ACTIONS(5027),
    [anon_sym_private] = ACTIONS(5027),
    [anon_sym_protected] = ACTIONS(5027),
    [anon_sym_using] = ACTIONS(5027),
    [anon_sym_static_assert] = ACTIONS(5027),
    [anon_sym___launch_bounds__] = ACTIONS(5027),
  },
  [1726] = {
    [sym_identifier] = ACTIONS(5031),
    [aux_sym_preproc_def_token1] = ACTIONS(5031),
    [aux_sym_preproc_if_token1] = ACTIONS(5031),
    [aux_sym_preproc_if_token2] = ACTIONS(5031),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5031),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5031),
    [aux_sym_preproc_else_token1] = ACTIONS(5031),
    [aux_sym_preproc_elif_token1] = ACTIONS(5031),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5031),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5031),
    [sym_preproc_directive] = ACTIONS(5031),
    [anon_sym_LPAREN2] = ACTIONS(5033),
    [anon_sym_TILDE] = ACTIONS(5033),
    [anon_sym_STAR] = ACTIONS(5033),
    [anon_sym_AMP_AMP] = ACTIONS(5033),
    [anon_sym_AMP] = ACTIONS(5031),
    [anon_sym___extension__] = ACTIONS(5031),
    [anon_sym_typedef] = ACTIONS(5031),
    [anon_sym___device__] = ACTIONS(5031),
    [anon_sym___host__] = ACTIONS(5031),
    [anon_sym___global__] = ACTIONS(5031),
    [anon_sym___forceinline__] = ACTIONS(5031),
    [anon_sym___noinline__] = ACTIONS(5031),
    [anon_sym_extern] = ACTIONS(5031),
    [anon_sym___attribute__] = ACTIONS(5031),
    [anon_sym_COLON_COLON] = ACTIONS(5033),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5033),
    [anon_sym___declspec] = ACTIONS(5031),
    [anon_sym___based] = ACTIONS(5031),
    [anon_sym_signed] = ACTIONS(5031),
    [anon_sym_unsigned] = ACTIONS(5031),
    [anon_sym_long] = ACTIONS(5031),
    [anon_sym_short] = ACTIONS(5031),
    [anon_sym_LBRACK] = ACTIONS(5031),
    [anon_sym_static] = ACTIONS(5031),
    [anon_sym_register] = ACTIONS(5031),
    [anon_sym_inline] = ACTIONS(5031),
    [anon_sym___inline] = ACTIONS(5031),
    [anon_sym___inline__] = ACTIONS(5031),
    [anon_sym___forceinline] = ACTIONS(5031),
    [anon_sym_thread_local] = ACTIONS(5031),
    [anon_sym___thread] = ACTIONS(5031),
    [anon_sym_const] = ACTIONS(5031),
    [anon_sym_constexpr] = ACTIONS(5031),
    [anon_sym_volatile] = ACTIONS(5031),
    [anon_sym_restrict] = ACTIONS(5031),
    [anon_sym___restrict__] = ACTIONS(5031),
    [anon_sym__Atomic] = ACTIONS(5031),
    [anon_sym__Noreturn] = ACTIONS(5031),
    [anon_sym_noreturn] = ACTIONS(5031),
    [anon_sym_mutable] = ACTIONS(5031),
    [anon_sym_constinit] = ACTIONS(5031),
    [anon_sym_consteval] = ACTIONS(5031),
    [anon_sym___shared__] = ACTIONS(5031),
    [anon_sym___local__] = ACTIONS(5031),
    [anon_sym___constant__] = ACTIONS(5031),
    [anon_sym___managed__] = ACTIONS(5031),
    [anon_sym___grid_constant__] = ACTIONS(5031),
    [anon_sym_alignas] = ACTIONS(5031),
    [anon_sym__Alignas] = ACTIONS(5031),
    [sym_primitive_type] = ACTIONS(5031),
    [anon_sym_enum] = ACTIONS(5031),
    [anon_sym_class] = ACTIONS(5031),
    [anon_sym_struct] = ACTIONS(5031),
    [anon_sym_union] = ACTIONS(5031),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5031),
    [anon_sym_decltype] = ACTIONS(5031),
    [sym_virtual] = ACTIONS(5031),
    [anon_sym_explicit] = ACTIONS(5031),
    [anon_sym_typename] = ACTIONS(5031),
    [anon_sym_template] = ACTIONS(5031),
    [anon_sym_operator] = ACTIONS(5031),
    [anon_sym_friend] = ACTIONS(5031),
    [anon_sym_public] = ACTIONS(5031),
    [anon_sym_private] = ACTIONS(5031),
    [anon_sym_protected] = ACTIONS(5031),
    [anon_sym_using] = ACTIONS(5031),
    [anon_sym_static_assert] = ACTIONS(5031),
    [anon_sym___launch_bounds__] = ACTIONS(5031),
  },
  [1727] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4019),
    [anon_sym_COMMA] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(4019),
    [anon_sym_DASH] = ACTIONS(4017),
    [anon_sym_PLUS] = ACTIONS(4017),
    [anon_sym_STAR] = ACTIONS(4017),
    [anon_sym_SLASH] = ACTIONS(4017),
    [anon_sym_PERCENT] = ACTIONS(4017),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE] = ACTIONS(4017),
    [anon_sym_CARET] = ACTIONS(4017),
    [anon_sym_AMP] = ACTIONS(4017),
    [anon_sym_EQ_EQ] = ACTIONS(4019),
    [anon_sym_BANG_EQ] = ACTIONS(4019),
    [anon_sym_GT] = ACTIONS(4017),
    [anon_sym_GT_EQ] = ACTIONS(4017),
    [anon_sym_LT_EQ] = ACTIONS(4017),
    [anon_sym_LT] = ACTIONS(4017),
    [anon_sym_LT_LT] = ACTIONS(4017),
    [anon_sym_GT_GT] = ACTIONS(4017),
    [anon_sym___extension__] = ACTIONS(4019),
    [anon_sym___global__] = ACTIONS(4019),
    [anon_sym___attribute__] = ACTIONS(4019),
    [anon_sym_COLON_COLON] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4019),
    [anon_sym_LBRACK] = ACTIONS(4019),
    [anon_sym_EQ] = ACTIONS(4017),
    [anon_sym_const] = ACTIONS(4017),
    [anon_sym_constexpr] = ACTIONS(4019),
    [anon_sym_volatile] = ACTIONS(4019),
    [anon_sym_restrict] = ACTIONS(4019),
    [anon_sym___restrict__] = ACTIONS(4019),
    [anon_sym__Atomic] = ACTIONS(4019),
    [anon_sym__Noreturn] = ACTIONS(4019),
    [anon_sym_noreturn] = ACTIONS(4019),
    [anon_sym_mutable] = ACTIONS(4019),
    [anon_sym_constinit] = ACTIONS(4019),
    [anon_sym_consteval] = ACTIONS(4019),
    [anon_sym___shared__] = ACTIONS(4019),
    [anon_sym___local__] = ACTIONS(4019),
    [anon_sym___constant__] = ACTIONS(4019),
    [anon_sym___managed__] = ACTIONS(4019),
    [anon_sym___grid_constant__] = ACTIONS(4019),
    [anon_sym_alignas] = ACTIONS(4019),
    [anon_sym__Alignas] = ACTIONS(4019),
    [anon_sym_COLON] = ACTIONS(4017),
    [anon_sym_QMARK] = ACTIONS(4019),
    [anon_sym_STAR_EQ] = ACTIONS(4019),
    [anon_sym_SLASH_EQ] = ACTIONS(4019),
    [anon_sym_PERCENT_EQ] = ACTIONS(4019),
    [anon_sym_PLUS_EQ] = ACTIONS(4019),
    [anon_sym_DASH_EQ] = ACTIONS(4019),
    [anon_sym_LT_LT_EQ] = ACTIONS(4019),
    [anon_sym_GT_GT_EQ] = ACTIONS(4017),
    [anon_sym_AMP_EQ] = ACTIONS(4019),
    [anon_sym_CARET_EQ] = ACTIONS(4019),
    [anon_sym_PIPE_EQ] = ACTIONS(4019),
    [anon_sym_and_eq] = ACTIONS(4019),
    [anon_sym_or_eq] = ACTIONS(4019),
    [anon_sym_xor_eq] = ACTIONS(4019),
    [anon_sym_LT_EQ_GT] = ACTIONS(4019),
    [anon_sym_or] = ACTIONS(4017),
    [anon_sym_and] = ACTIONS(4017),
    [anon_sym_bitor] = ACTIONS(4019),
    [anon_sym_xor] = ACTIONS(4017),
    [anon_sym_bitand] = ACTIONS(4019),
    [anon_sym_not_eq] = ACTIONS(4019),
    [anon_sym_DASH_DASH] = ACTIONS(4019),
    [anon_sym_PLUS_PLUS] = ACTIONS(4019),
    [anon_sym_DOT] = ACTIONS(4017),
    [anon_sym_DOT_STAR] = ACTIONS(4019),
    [anon_sym_DASH_GT] = ACTIONS(4019),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4019),
    [anon_sym_decltype] = ACTIONS(4019),
    [anon_sym_final] = ACTIONS(4019),
    [anon_sym_override] = ACTIONS(4019),
    [anon_sym_GT2] = ACTIONS(4019),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4019),
  },
  [1728] = {
    [sym_identifier] = ACTIONS(2436),
    [aux_sym_preproc_def_token1] = ACTIONS(2436),
    [aux_sym_preproc_if_token1] = ACTIONS(2436),
    [aux_sym_preproc_if_token2] = ACTIONS(2436),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2436),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2436),
    [aux_sym_preproc_else_token1] = ACTIONS(2436),
    [aux_sym_preproc_elif_token1] = ACTIONS(2436),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2436),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2436),
    [sym_preproc_directive] = ACTIONS(2436),
    [anon_sym_LPAREN2] = ACTIONS(2438),
    [anon_sym_TILDE] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(2438),
    [anon_sym_AMP_AMP] = ACTIONS(2438),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym___extension__] = ACTIONS(2436),
    [anon_sym_typedef] = ACTIONS(2436),
    [anon_sym___device__] = ACTIONS(2436),
    [anon_sym___host__] = ACTIONS(2436),
    [anon_sym___global__] = ACTIONS(2436),
    [anon_sym___forceinline__] = ACTIONS(2436),
    [anon_sym___noinline__] = ACTIONS(2436),
    [anon_sym_extern] = ACTIONS(2436),
    [anon_sym___attribute__] = ACTIONS(2436),
    [anon_sym_COLON_COLON] = ACTIONS(2438),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2438),
    [anon_sym___declspec] = ACTIONS(2436),
    [anon_sym___based] = ACTIONS(2436),
    [anon_sym_signed] = ACTIONS(2436),
    [anon_sym_unsigned] = ACTIONS(2436),
    [anon_sym_long] = ACTIONS(2436),
    [anon_sym_short] = ACTIONS(2436),
    [anon_sym_LBRACK] = ACTIONS(2436),
    [anon_sym_static] = ACTIONS(2436),
    [anon_sym_register] = ACTIONS(2436),
    [anon_sym_inline] = ACTIONS(2436),
    [anon_sym___inline] = ACTIONS(2436),
    [anon_sym___inline__] = ACTIONS(2436),
    [anon_sym___forceinline] = ACTIONS(2436),
    [anon_sym_thread_local] = ACTIONS(2436),
    [anon_sym___thread] = ACTIONS(2436),
    [anon_sym_const] = ACTIONS(2436),
    [anon_sym_constexpr] = ACTIONS(2436),
    [anon_sym_volatile] = ACTIONS(2436),
    [anon_sym_restrict] = ACTIONS(2436),
    [anon_sym___restrict__] = ACTIONS(2436),
    [anon_sym__Atomic] = ACTIONS(2436),
    [anon_sym__Noreturn] = ACTIONS(2436),
    [anon_sym_noreturn] = ACTIONS(2436),
    [anon_sym_mutable] = ACTIONS(2436),
    [anon_sym_constinit] = ACTIONS(2436),
    [anon_sym_consteval] = ACTIONS(2436),
    [anon_sym___shared__] = ACTIONS(2436),
    [anon_sym___local__] = ACTIONS(2436),
    [anon_sym___constant__] = ACTIONS(2436),
    [anon_sym___managed__] = ACTIONS(2436),
    [anon_sym___grid_constant__] = ACTIONS(2436),
    [anon_sym_alignas] = ACTIONS(2436),
    [anon_sym__Alignas] = ACTIONS(2436),
    [sym_primitive_type] = ACTIONS(2436),
    [anon_sym_enum] = ACTIONS(2436),
    [anon_sym_class] = ACTIONS(2436),
    [anon_sym_struct] = ACTIONS(2436),
    [anon_sym_union] = ACTIONS(2436),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2436),
    [anon_sym_decltype] = ACTIONS(2436),
    [sym_virtual] = ACTIONS(2436),
    [anon_sym_explicit] = ACTIONS(2436),
    [anon_sym_typename] = ACTIONS(2436),
    [anon_sym_template] = ACTIONS(2436),
    [anon_sym_operator] = ACTIONS(2436),
    [anon_sym_friend] = ACTIONS(2436),
    [anon_sym_public] = ACTIONS(2436),
    [anon_sym_private] = ACTIONS(2436),
    [anon_sym_protected] = ACTIONS(2436),
    [anon_sym_using] = ACTIONS(2436),
    [anon_sym_static_assert] = ACTIONS(2436),
    [anon_sym___launch_bounds__] = ACTIONS(2436),
  },
  [1729] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_LPAREN2] = ACTIONS(4023),
    [anon_sym_DASH] = ACTIONS(4021),
    [anon_sym_PLUS] = ACTIONS(4021),
    [anon_sym_STAR] = ACTIONS(4021),
    [anon_sym_SLASH] = ACTIONS(4021),
    [anon_sym_PERCENT] = ACTIONS(4021),
    [anon_sym_PIPE_PIPE] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4023),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_CARET] = ACTIONS(4021),
    [anon_sym_AMP] = ACTIONS(4021),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_EQ] = ACTIONS(4021),
    [anon_sym_LT_EQ] = ACTIONS(4021),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4021),
    [anon_sym___extension__] = ACTIONS(4023),
    [anon_sym___global__] = ACTIONS(4023),
    [anon_sym___attribute__] = ACTIONS(4023),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_LBRACE] = ACTIONS(4023),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_EQ] = ACTIONS(4021),
    [anon_sym_const] = ACTIONS(4021),
    [anon_sym_constexpr] = ACTIONS(4023),
    [anon_sym_volatile] = ACTIONS(4023),
    [anon_sym_restrict] = ACTIONS(4023),
    [anon_sym___restrict__] = ACTIONS(4023),
    [anon_sym__Atomic] = ACTIONS(4023),
    [anon_sym__Noreturn] = ACTIONS(4023),
    [anon_sym_noreturn] = ACTIONS(4023),
    [anon_sym_mutable] = ACTIONS(4023),
    [anon_sym_constinit] = ACTIONS(4023),
    [anon_sym_consteval] = ACTIONS(4023),
    [anon_sym___shared__] = ACTIONS(4023),
    [anon_sym___local__] = ACTIONS(4023),
    [anon_sym___constant__] = ACTIONS(4023),
    [anon_sym___managed__] = ACTIONS(4023),
    [anon_sym___grid_constant__] = ACTIONS(4023),
    [anon_sym_alignas] = ACTIONS(4023),
    [anon_sym__Alignas] = ACTIONS(4023),
    [anon_sym_COLON] = ACTIONS(4021),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4021),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_and_eq] = ACTIONS(4023),
    [anon_sym_or_eq] = ACTIONS(4023),
    [anon_sym_xor_eq] = ACTIONS(4023),
    [anon_sym_LT_EQ_GT] = ACTIONS(4023),
    [anon_sym_or] = ACTIONS(4021),
    [anon_sym_and] = ACTIONS(4021),
    [anon_sym_bitor] = ACTIONS(4023),
    [anon_sym_xor] = ACTIONS(4021),
    [anon_sym_bitand] = ACTIONS(4023),
    [anon_sym_not_eq] = ACTIONS(4023),
    [anon_sym_DASH_DASH] = ACTIONS(4023),
    [anon_sym_PLUS_PLUS] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4021),
    [anon_sym_DOT_STAR] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4023),
    [anon_sym_decltype] = ACTIONS(4023),
    [anon_sym_final] = ACTIONS(4023),
    [anon_sym_override] = ACTIONS(4023),
    [anon_sym_GT2] = ACTIONS(4023),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4023),
  },
  [1730] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3994),
    [anon_sym_COMMA] = ACTIONS(3994),
    [anon_sym_LPAREN2] = ACTIONS(3994),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_STAR] = ACTIONS(3992),
    [anon_sym_SLASH] = ACTIONS(3992),
    [anon_sym_PERCENT] = ACTIONS(3992),
    [anon_sym_PIPE_PIPE] = ACTIONS(3994),
    [anon_sym_AMP_AMP] = ACTIONS(3994),
    [anon_sym_PIPE] = ACTIONS(3992),
    [anon_sym_CARET] = ACTIONS(3992),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym_EQ_EQ] = ACTIONS(3994),
    [anon_sym_BANG_EQ] = ACTIONS(3994),
    [anon_sym_GT] = ACTIONS(3992),
    [anon_sym_GT_EQ] = ACTIONS(3992),
    [anon_sym_LT_EQ] = ACTIONS(3992),
    [anon_sym_LT] = ACTIONS(3992),
    [anon_sym_LT_LT] = ACTIONS(3992),
    [anon_sym_GT_GT] = ACTIONS(3992),
    [anon_sym___extension__] = ACTIONS(3994),
    [anon_sym___global__] = ACTIONS(3994),
    [anon_sym___attribute__] = ACTIONS(3994),
    [anon_sym_COLON_COLON] = ACTIONS(3994),
    [anon_sym_LBRACE] = ACTIONS(3994),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_EQ] = ACTIONS(3992),
    [anon_sym_const] = ACTIONS(3992),
    [anon_sym_constexpr] = ACTIONS(3994),
    [anon_sym_volatile] = ACTIONS(3994),
    [anon_sym_restrict] = ACTIONS(3994),
    [anon_sym___restrict__] = ACTIONS(3994),
    [anon_sym__Atomic] = ACTIONS(3994),
    [anon_sym__Noreturn] = ACTIONS(3994),
    [anon_sym_noreturn] = ACTIONS(3994),
    [anon_sym_mutable] = ACTIONS(3994),
    [anon_sym_constinit] = ACTIONS(3994),
    [anon_sym_consteval] = ACTIONS(3994),
    [anon_sym___shared__] = ACTIONS(3994),
    [anon_sym___local__] = ACTIONS(3994),
    [anon_sym___constant__] = ACTIONS(3994),
    [anon_sym___managed__] = ACTIONS(3994),
    [anon_sym___grid_constant__] = ACTIONS(3994),
    [anon_sym_alignas] = ACTIONS(3994),
    [anon_sym__Alignas] = ACTIONS(3994),
    [anon_sym_COLON] = ACTIONS(3992),
    [anon_sym_QMARK] = ACTIONS(3994),
    [anon_sym_STAR_EQ] = ACTIONS(3994),
    [anon_sym_SLASH_EQ] = ACTIONS(3994),
    [anon_sym_PERCENT_EQ] = ACTIONS(3994),
    [anon_sym_PLUS_EQ] = ACTIONS(3994),
    [anon_sym_DASH_EQ] = ACTIONS(3994),
    [anon_sym_LT_LT_EQ] = ACTIONS(3994),
    [anon_sym_GT_GT_EQ] = ACTIONS(3992),
    [anon_sym_AMP_EQ] = ACTIONS(3994),
    [anon_sym_CARET_EQ] = ACTIONS(3994),
    [anon_sym_PIPE_EQ] = ACTIONS(3994),
    [anon_sym_and_eq] = ACTIONS(3994),
    [anon_sym_or_eq] = ACTIONS(3994),
    [anon_sym_xor_eq] = ACTIONS(3994),
    [anon_sym_LT_EQ_GT] = ACTIONS(3994),
    [anon_sym_or] = ACTIONS(3992),
    [anon_sym_and] = ACTIONS(3992),
    [anon_sym_bitor] = ACTIONS(3994),
    [anon_sym_xor] = ACTIONS(3992),
    [anon_sym_bitand] = ACTIONS(3994),
    [anon_sym_not_eq] = ACTIONS(3994),
    [anon_sym_DASH_DASH] = ACTIONS(3994),
    [anon_sym_PLUS_PLUS] = ACTIONS(3994),
    [anon_sym_DOT] = ACTIONS(3992),
    [anon_sym_DOT_STAR] = ACTIONS(3994),
    [anon_sym_DASH_GT] = ACTIONS(3994),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3994),
    [anon_sym_decltype] = ACTIONS(3994),
    [anon_sym_final] = ACTIONS(3994),
    [anon_sym_override] = ACTIONS(3994),
    [anon_sym_GT2] = ACTIONS(3994),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3994),
  },
  [1731] = {
    [sym_identifier] = ACTIONS(5035),
    [aux_sym_preproc_def_token1] = ACTIONS(5035),
    [aux_sym_preproc_if_token1] = ACTIONS(5035),
    [aux_sym_preproc_if_token2] = ACTIONS(5035),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5035),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5035),
    [aux_sym_preproc_else_token1] = ACTIONS(5035),
    [aux_sym_preproc_elif_token1] = ACTIONS(5035),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5035),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5035),
    [sym_preproc_directive] = ACTIONS(5035),
    [anon_sym_LPAREN2] = ACTIONS(5037),
    [anon_sym_TILDE] = ACTIONS(5037),
    [anon_sym_STAR] = ACTIONS(5037),
    [anon_sym_AMP_AMP] = ACTIONS(5037),
    [anon_sym_AMP] = ACTIONS(5035),
    [anon_sym___extension__] = ACTIONS(5035),
    [anon_sym_typedef] = ACTIONS(5035),
    [anon_sym___device__] = ACTIONS(5035),
    [anon_sym___host__] = ACTIONS(5035),
    [anon_sym___global__] = ACTIONS(5035),
    [anon_sym___forceinline__] = ACTIONS(5035),
    [anon_sym___noinline__] = ACTIONS(5035),
    [anon_sym_extern] = ACTIONS(5035),
    [anon_sym___attribute__] = ACTIONS(5035),
    [anon_sym_COLON_COLON] = ACTIONS(5037),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5037),
    [anon_sym___declspec] = ACTIONS(5035),
    [anon_sym___based] = ACTIONS(5035),
    [anon_sym_signed] = ACTIONS(5035),
    [anon_sym_unsigned] = ACTIONS(5035),
    [anon_sym_long] = ACTIONS(5035),
    [anon_sym_short] = ACTIONS(5035),
    [anon_sym_LBRACK] = ACTIONS(5035),
    [anon_sym_static] = ACTIONS(5035),
    [anon_sym_register] = ACTIONS(5035),
    [anon_sym_inline] = ACTIONS(5035),
    [anon_sym___inline] = ACTIONS(5035),
    [anon_sym___inline__] = ACTIONS(5035),
    [anon_sym___forceinline] = ACTIONS(5035),
    [anon_sym_thread_local] = ACTIONS(5035),
    [anon_sym___thread] = ACTIONS(5035),
    [anon_sym_const] = ACTIONS(5035),
    [anon_sym_constexpr] = ACTIONS(5035),
    [anon_sym_volatile] = ACTIONS(5035),
    [anon_sym_restrict] = ACTIONS(5035),
    [anon_sym___restrict__] = ACTIONS(5035),
    [anon_sym__Atomic] = ACTIONS(5035),
    [anon_sym__Noreturn] = ACTIONS(5035),
    [anon_sym_noreturn] = ACTIONS(5035),
    [anon_sym_mutable] = ACTIONS(5035),
    [anon_sym_constinit] = ACTIONS(5035),
    [anon_sym_consteval] = ACTIONS(5035),
    [anon_sym___shared__] = ACTIONS(5035),
    [anon_sym___local__] = ACTIONS(5035),
    [anon_sym___constant__] = ACTIONS(5035),
    [anon_sym___managed__] = ACTIONS(5035),
    [anon_sym___grid_constant__] = ACTIONS(5035),
    [anon_sym_alignas] = ACTIONS(5035),
    [anon_sym__Alignas] = ACTIONS(5035),
    [sym_primitive_type] = ACTIONS(5035),
    [anon_sym_enum] = ACTIONS(5035),
    [anon_sym_class] = ACTIONS(5035),
    [anon_sym_struct] = ACTIONS(5035),
    [anon_sym_union] = ACTIONS(5035),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5035),
    [anon_sym_decltype] = ACTIONS(5035),
    [sym_virtual] = ACTIONS(5035),
    [anon_sym_explicit] = ACTIONS(5035),
    [anon_sym_typename] = ACTIONS(5035),
    [anon_sym_template] = ACTIONS(5035),
    [anon_sym_operator] = ACTIONS(5035),
    [anon_sym_friend] = ACTIONS(5035),
    [anon_sym_public] = ACTIONS(5035),
    [anon_sym_private] = ACTIONS(5035),
    [anon_sym_protected] = ACTIONS(5035),
    [anon_sym_using] = ACTIONS(5035),
    [anon_sym_static_assert] = ACTIONS(5035),
    [anon_sym___launch_bounds__] = ACTIONS(5035),
  },
  [1732] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3998),
    [anon_sym_COMMA] = ACTIONS(3998),
    [anon_sym_LPAREN2] = ACTIONS(3998),
    [anon_sym_DASH] = ACTIONS(3996),
    [anon_sym_PLUS] = ACTIONS(3996),
    [anon_sym_STAR] = ACTIONS(3996),
    [anon_sym_SLASH] = ACTIONS(3996),
    [anon_sym_PERCENT] = ACTIONS(3996),
    [anon_sym_PIPE_PIPE] = ACTIONS(3998),
    [anon_sym_AMP_AMP] = ACTIONS(3998),
    [anon_sym_PIPE] = ACTIONS(3996),
    [anon_sym_CARET] = ACTIONS(3996),
    [anon_sym_AMP] = ACTIONS(3996),
    [anon_sym_EQ_EQ] = ACTIONS(3998),
    [anon_sym_BANG_EQ] = ACTIONS(3998),
    [anon_sym_GT] = ACTIONS(3996),
    [anon_sym_GT_EQ] = ACTIONS(3996),
    [anon_sym_LT_EQ] = ACTIONS(3996),
    [anon_sym_LT] = ACTIONS(3996),
    [anon_sym_LT_LT] = ACTIONS(3996),
    [anon_sym_GT_GT] = ACTIONS(3996),
    [anon_sym___extension__] = ACTIONS(3998),
    [anon_sym___global__] = ACTIONS(3998),
    [anon_sym___attribute__] = ACTIONS(3998),
    [anon_sym_COLON_COLON] = ACTIONS(3998),
    [anon_sym_LBRACE] = ACTIONS(3998),
    [anon_sym_LBRACK] = ACTIONS(3998),
    [anon_sym_EQ] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3996),
    [anon_sym_constexpr] = ACTIONS(3998),
    [anon_sym_volatile] = ACTIONS(3998),
    [anon_sym_restrict] = ACTIONS(3998),
    [anon_sym___restrict__] = ACTIONS(3998),
    [anon_sym__Atomic] = ACTIONS(3998),
    [anon_sym__Noreturn] = ACTIONS(3998),
    [anon_sym_noreturn] = ACTIONS(3998),
    [anon_sym_mutable] = ACTIONS(3998),
    [anon_sym_constinit] = ACTIONS(3998),
    [anon_sym_consteval] = ACTIONS(3998),
    [anon_sym___shared__] = ACTIONS(3998),
    [anon_sym___local__] = ACTIONS(3998),
    [anon_sym___constant__] = ACTIONS(3998),
    [anon_sym___managed__] = ACTIONS(3998),
    [anon_sym___grid_constant__] = ACTIONS(3998),
    [anon_sym_alignas] = ACTIONS(3998),
    [anon_sym__Alignas] = ACTIONS(3998),
    [anon_sym_COLON] = ACTIONS(3996),
    [anon_sym_QMARK] = ACTIONS(3998),
    [anon_sym_STAR_EQ] = ACTIONS(3998),
    [anon_sym_SLASH_EQ] = ACTIONS(3998),
    [anon_sym_PERCENT_EQ] = ACTIONS(3998),
    [anon_sym_PLUS_EQ] = ACTIONS(3998),
    [anon_sym_DASH_EQ] = ACTIONS(3998),
    [anon_sym_LT_LT_EQ] = ACTIONS(3998),
    [anon_sym_GT_GT_EQ] = ACTIONS(3996),
    [anon_sym_AMP_EQ] = ACTIONS(3998),
    [anon_sym_CARET_EQ] = ACTIONS(3998),
    [anon_sym_PIPE_EQ] = ACTIONS(3998),
    [anon_sym_and_eq] = ACTIONS(3998),
    [anon_sym_or_eq] = ACTIONS(3998),
    [anon_sym_xor_eq] = ACTIONS(3998),
    [anon_sym_LT_EQ_GT] = ACTIONS(3998),
    [anon_sym_or] = ACTIONS(3996),
    [anon_sym_and] = ACTIONS(3996),
    [anon_sym_bitor] = ACTIONS(3998),
    [anon_sym_xor] = ACTIONS(3996),
    [anon_sym_bitand] = ACTIONS(3998),
    [anon_sym_not_eq] = ACTIONS(3998),
    [anon_sym_DASH_DASH] = ACTIONS(3998),
    [anon_sym_PLUS_PLUS] = ACTIONS(3998),
    [anon_sym_DOT] = ACTIONS(3996),
    [anon_sym_DOT_STAR] = ACTIONS(3998),
    [anon_sym_DASH_GT] = ACTIONS(3998),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3998),
    [anon_sym_decltype] = ACTIONS(3998),
    [anon_sym_final] = ACTIONS(3998),
    [anon_sym_override] = ACTIONS(3998),
    [anon_sym_GT2] = ACTIONS(3998),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3998),
  },
  [1733] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3982),
    [anon_sym_COMMA] = ACTIONS(3982),
    [anon_sym_LPAREN2] = ACTIONS(3982),
    [anon_sym_DASH] = ACTIONS(3980),
    [anon_sym_PLUS] = ACTIONS(3980),
    [anon_sym_STAR] = ACTIONS(3980),
    [anon_sym_SLASH] = ACTIONS(3980),
    [anon_sym_PERCENT] = ACTIONS(3980),
    [anon_sym_PIPE_PIPE] = ACTIONS(3982),
    [anon_sym_AMP_AMP] = ACTIONS(3982),
    [anon_sym_PIPE] = ACTIONS(3980),
    [anon_sym_CARET] = ACTIONS(3980),
    [anon_sym_AMP] = ACTIONS(3980),
    [anon_sym_EQ_EQ] = ACTIONS(3982),
    [anon_sym_BANG_EQ] = ACTIONS(3982),
    [anon_sym_GT] = ACTIONS(3980),
    [anon_sym_GT_EQ] = ACTIONS(3980),
    [anon_sym_LT_EQ] = ACTIONS(3980),
    [anon_sym_LT] = ACTIONS(3980),
    [anon_sym_LT_LT] = ACTIONS(3980),
    [anon_sym_GT_GT] = ACTIONS(3980),
    [anon_sym___extension__] = ACTIONS(3982),
    [anon_sym___global__] = ACTIONS(3982),
    [anon_sym___attribute__] = ACTIONS(3982),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(3982),
    [anon_sym_LBRACK] = ACTIONS(3982),
    [anon_sym_EQ] = ACTIONS(3980),
    [anon_sym_const] = ACTIONS(3980),
    [anon_sym_constexpr] = ACTIONS(3982),
    [anon_sym_volatile] = ACTIONS(3982),
    [anon_sym_restrict] = ACTIONS(3982),
    [anon_sym___restrict__] = ACTIONS(3982),
    [anon_sym__Atomic] = ACTIONS(3982),
    [anon_sym__Noreturn] = ACTIONS(3982),
    [anon_sym_noreturn] = ACTIONS(3982),
    [anon_sym_mutable] = ACTIONS(3982),
    [anon_sym_constinit] = ACTIONS(3982),
    [anon_sym_consteval] = ACTIONS(3982),
    [anon_sym___shared__] = ACTIONS(3982),
    [anon_sym___local__] = ACTIONS(3982),
    [anon_sym___constant__] = ACTIONS(3982),
    [anon_sym___managed__] = ACTIONS(3982),
    [anon_sym___grid_constant__] = ACTIONS(3982),
    [anon_sym_alignas] = ACTIONS(3982),
    [anon_sym__Alignas] = ACTIONS(3982),
    [anon_sym_COLON] = ACTIONS(3980),
    [anon_sym_QMARK] = ACTIONS(3982),
    [anon_sym_STAR_EQ] = ACTIONS(3982),
    [anon_sym_SLASH_EQ] = ACTIONS(3982),
    [anon_sym_PERCENT_EQ] = ACTIONS(3982),
    [anon_sym_PLUS_EQ] = ACTIONS(3982),
    [anon_sym_DASH_EQ] = ACTIONS(3982),
    [anon_sym_LT_LT_EQ] = ACTIONS(3982),
    [anon_sym_GT_GT_EQ] = ACTIONS(3980),
    [anon_sym_AMP_EQ] = ACTIONS(3982),
    [anon_sym_CARET_EQ] = ACTIONS(3982),
    [anon_sym_PIPE_EQ] = ACTIONS(3982),
    [anon_sym_and_eq] = ACTIONS(3982),
    [anon_sym_or_eq] = ACTIONS(3982),
    [anon_sym_xor_eq] = ACTIONS(3982),
    [anon_sym_LT_EQ_GT] = ACTIONS(3982),
    [anon_sym_or] = ACTIONS(3980),
    [anon_sym_and] = ACTIONS(3980),
    [anon_sym_bitor] = ACTIONS(3982),
    [anon_sym_xor] = ACTIONS(3980),
    [anon_sym_bitand] = ACTIONS(3982),
    [anon_sym_not_eq] = ACTIONS(3982),
    [anon_sym_DASH_DASH] = ACTIONS(3982),
    [anon_sym_PLUS_PLUS] = ACTIONS(3982),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_DOT_STAR] = ACTIONS(3982),
    [anon_sym_DASH_GT] = ACTIONS(3982),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3982),
    [anon_sym_decltype] = ACTIONS(3982),
    [anon_sym_final] = ACTIONS(3982),
    [anon_sym_override] = ACTIONS(3982),
    [anon_sym_GT2] = ACTIONS(3982),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3982),
  },
  [1734] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3986),
    [anon_sym_COMMA] = ACTIONS(3986),
    [anon_sym_LPAREN2] = ACTIONS(3986),
    [anon_sym_DASH] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(3984),
    [anon_sym_SLASH] = ACTIONS(3984),
    [anon_sym_PERCENT] = ACTIONS(3984),
    [anon_sym_PIPE_PIPE] = ACTIONS(3986),
    [anon_sym_AMP_AMP] = ACTIONS(3986),
    [anon_sym_PIPE] = ACTIONS(3984),
    [anon_sym_CARET] = ACTIONS(3984),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_EQ_EQ] = ACTIONS(3986),
    [anon_sym_BANG_EQ] = ACTIONS(3986),
    [anon_sym_GT] = ACTIONS(3984),
    [anon_sym_GT_EQ] = ACTIONS(3984),
    [anon_sym_LT_EQ] = ACTIONS(3984),
    [anon_sym_LT] = ACTIONS(3984),
    [anon_sym_LT_LT] = ACTIONS(3984),
    [anon_sym_GT_GT] = ACTIONS(3984),
    [anon_sym___extension__] = ACTIONS(3986),
    [anon_sym___global__] = ACTIONS(3986),
    [anon_sym___attribute__] = ACTIONS(3986),
    [anon_sym_COLON_COLON] = ACTIONS(3986),
    [anon_sym_LBRACE] = ACTIONS(3986),
    [anon_sym_LBRACK] = ACTIONS(3986),
    [anon_sym_EQ] = ACTIONS(3984),
    [anon_sym_const] = ACTIONS(3984),
    [anon_sym_constexpr] = ACTIONS(3986),
    [anon_sym_volatile] = ACTIONS(3986),
    [anon_sym_restrict] = ACTIONS(3986),
    [anon_sym___restrict__] = ACTIONS(3986),
    [anon_sym__Atomic] = ACTIONS(3986),
    [anon_sym__Noreturn] = ACTIONS(3986),
    [anon_sym_noreturn] = ACTIONS(3986),
    [anon_sym_mutable] = ACTIONS(3986),
    [anon_sym_constinit] = ACTIONS(3986),
    [anon_sym_consteval] = ACTIONS(3986),
    [anon_sym___shared__] = ACTIONS(3986),
    [anon_sym___local__] = ACTIONS(3986),
    [anon_sym___constant__] = ACTIONS(3986),
    [anon_sym___managed__] = ACTIONS(3986),
    [anon_sym___grid_constant__] = ACTIONS(3986),
    [anon_sym_alignas] = ACTIONS(3986),
    [anon_sym__Alignas] = ACTIONS(3986),
    [anon_sym_COLON] = ACTIONS(3984),
    [anon_sym_QMARK] = ACTIONS(3986),
    [anon_sym_STAR_EQ] = ACTIONS(3986),
    [anon_sym_SLASH_EQ] = ACTIONS(3986),
    [anon_sym_PERCENT_EQ] = ACTIONS(3986),
    [anon_sym_PLUS_EQ] = ACTIONS(3986),
    [anon_sym_DASH_EQ] = ACTIONS(3986),
    [anon_sym_LT_LT_EQ] = ACTIONS(3986),
    [anon_sym_GT_GT_EQ] = ACTIONS(3984),
    [anon_sym_AMP_EQ] = ACTIONS(3986),
    [anon_sym_CARET_EQ] = ACTIONS(3986),
    [anon_sym_PIPE_EQ] = ACTIONS(3986),
    [anon_sym_and_eq] = ACTIONS(3986),
    [anon_sym_or_eq] = ACTIONS(3986),
    [anon_sym_xor_eq] = ACTIONS(3986),
    [anon_sym_LT_EQ_GT] = ACTIONS(3986),
    [anon_sym_or] = ACTIONS(3984),
    [anon_sym_and] = ACTIONS(3984),
    [anon_sym_bitor] = ACTIONS(3986),
    [anon_sym_xor] = ACTIONS(3984),
    [anon_sym_bitand] = ACTIONS(3986),
    [anon_sym_not_eq] = ACTIONS(3986),
    [anon_sym_DASH_DASH] = ACTIONS(3986),
    [anon_sym_PLUS_PLUS] = ACTIONS(3986),
    [anon_sym_DOT] = ACTIONS(3984),
    [anon_sym_DOT_STAR] = ACTIONS(3986),
    [anon_sym_DASH_GT] = ACTIONS(3986),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3986),
    [anon_sym_decltype] = ACTIONS(3986),
    [anon_sym_final] = ACTIONS(3986),
    [anon_sym_override] = ACTIONS(3986),
    [anon_sym_GT2] = ACTIONS(3986),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3986),
  },
  [1735] = {
    [sym_identifier] = ACTIONS(5039),
    [aux_sym_preproc_def_token1] = ACTIONS(5039),
    [aux_sym_preproc_if_token1] = ACTIONS(5039),
    [aux_sym_preproc_if_token2] = ACTIONS(5039),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5039),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5039),
    [aux_sym_preproc_else_token1] = ACTIONS(5039),
    [aux_sym_preproc_elif_token1] = ACTIONS(5039),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5039),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5039),
    [sym_preproc_directive] = ACTIONS(5039),
    [anon_sym_LPAREN2] = ACTIONS(5041),
    [anon_sym_TILDE] = ACTIONS(5041),
    [anon_sym_STAR] = ACTIONS(5041),
    [anon_sym_AMP_AMP] = ACTIONS(5041),
    [anon_sym_AMP] = ACTIONS(5039),
    [anon_sym___extension__] = ACTIONS(5039),
    [anon_sym_typedef] = ACTIONS(5039),
    [anon_sym___device__] = ACTIONS(5039),
    [anon_sym___host__] = ACTIONS(5039),
    [anon_sym___global__] = ACTIONS(5039),
    [anon_sym___forceinline__] = ACTIONS(5039),
    [anon_sym___noinline__] = ACTIONS(5039),
    [anon_sym_extern] = ACTIONS(5039),
    [anon_sym___attribute__] = ACTIONS(5039),
    [anon_sym_COLON_COLON] = ACTIONS(5041),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5041),
    [anon_sym___declspec] = ACTIONS(5039),
    [anon_sym___based] = ACTIONS(5039),
    [anon_sym_signed] = ACTIONS(5039),
    [anon_sym_unsigned] = ACTIONS(5039),
    [anon_sym_long] = ACTIONS(5039),
    [anon_sym_short] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(5039),
    [anon_sym_static] = ACTIONS(5039),
    [anon_sym_register] = ACTIONS(5039),
    [anon_sym_inline] = ACTIONS(5039),
    [anon_sym___inline] = ACTIONS(5039),
    [anon_sym___inline__] = ACTIONS(5039),
    [anon_sym___forceinline] = ACTIONS(5039),
    [anon_sym_thread_local] = ACTIONS(5039),
    [anon_sym___thread] = ACTIONS(5039),
    [anon_sym_const] = ACTIONS(5039),
    [anon_sym_constexpr] = ACTIONS(5039),
    [anon_sym_volatile] = ACTIONS(5039),
    [anon_sym_restrict] = ACTIONS(5039),
    [anon_sym___restrict__] = ACTIONS(5039),
    [anon_sym__Atomic] = ACTIONS(5039),
    [anon_sym__Noreturn] = ACTIONS(5039),
    [anon_sym_noreturn] = ACTIONS(5039),
    [anon_sym_mutable] = ACTIONS(5039),
    [anon_sym_constinit] = ACTIONS(5039),
    [anon_sym_consteval] = ACTIONS(5039),
    [anon_sym___shared__] = ACTIONS(5039),
    [anon_sym___local__] = ACTIONS(5039),
    [anon_sym___constant__] = ACTIONS(5039),
    [anon_sym___managed__] = ACTIONS(5039),
    [anon_sym___grid_constant__] = ACTIONS(5039),
    [anon_sym_alignas] = ACTIONS(5039),
    [anon_sym__Alignas] = ACTIONS(5039),
    [sym_primitive_type] = ACTIONS(5039),
    [anon_sym_enum] = ACTIONS(5039),
    [anon_sym_class] = ACTIONS(5039),
    [anon_sym_struct] = ACTIONS(5039),
    [anon_sym_union] = ACTIONS(5039),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5039),
    [anon_sym_decltype] = ACTIONS(5039),
    [sym_virtual] = ACTIONS(5039),
    [anon_sym_explicit] = ACTIONS(5039),
    [anon_sym_typename] = ACTIONS(5039),
    [anon_sym_template] = ACTIONS(5039),
    [anon_sym_operator] = ACTIONS(5039),
    [anon_sym_friend] = ACTIONS(5039),
    [anon_sym_public] = ACTIONS(5039),
    [anon_sym_private] = ACTIONS(5039),
    [anon_sym_protected] = ACTIONS(5039),
    [anon_sym_using] = ACTIONS(5039),
    [anon_sym_static_assert] = ACTIONS(5039),
    [anon_sym___launch_bounds__] = ACTIONS(5039),
  },
  [1736] = {
    [sym_identifier] = ACTIONS(5043),
    [aux_sym_preproc_def_token1] = ACTIONS(5043),
    [aux_sym_preproc_if_token1] = ACTIONS(5043),
    [aux_sym_preproc_if_token2] = ACTIONS(5043),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5043),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5043),
    [aux_sym_preproc_else_token1] = ACTIONS(5043),
    [aux_sym_preproc_elif_token1] = ACTIONS(5043),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5043),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5043),
    [sym_preproc_directive] = ACTIONS(5043),
    [anon_sym_LPAREN2] = ACTIONS(5045),
    [anon_sym_TILDE] = ACTIONS(5045),
    [anon_sym_STAR] = ACTIONS(5045),
    [anon_sym_AMP_AMP] = ACTIONS(5045),
    [anon_sym_AMP] = ACTIONS(5043),
    [anon_sym___extension__] = ACTIONS(5043),
    [anon_sym_typedef] = ACTIONS(5043),
    [anon_sym___device__] = ACTIONS(5043),
    [anon_sym___host__] = ACTIONS(5043),
    [anon_sym___global__] = ACTIONS(5043),
    [anon_sym___forceinline__] = ACTIONS(5043),
    [anon_sym___noinline__] = ACTIONS(5043),
    [anon_sym_extern] = ACTIONS(5043),
    [anon_sym___attribute__] = ACTIONS(5043),
    [anon_sym_COLON_COLON] = ACTIONS(5045),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5045),
    [anon_sym___declspec] = ACTIONS(5043),
    [anon_sym___based] = ACTIONS(5043),
    [anon_sym_signed] = ACTIONS(5043),
    [anon_sym_unsigned] = ACTIONS(5043),
    [anon_sym_long] = ACTIONS(5043),
    [anon_sym_short] = ACTIONS(5043),
    [anon_sym_LBRACK] = ACTIONS(5043),
    [anon_sym_static] = ACTIONS(5043),
    [anon_sym_register] = ACTIONS(5043),
    [anon_sym_inline] = ACTIONS(5043),
    [anon_sym___inline] = ACTIONS(5043),
    [anon_sym___inline__] = ACTIONS(5043),
    [anon_sym___forceinline] = ACTIONS(5043),
    [anon_sym_thread_local] = ACTIONS(5043),
    [anon_sym___thread] = ACTIONS(5043),
    [anon_sym_const] = ACTIONS(5043),
    [anon_sym_constexpr] = ACTIONS(5043),
    [anon_sym_volatile] = ACTIONS(5043),
    [anon_sym_restrict] = ACTIONS(5043),
    [anon_sym___restrict__] = ACTIONS(5043),
    [anon_sym__Atomic] = ACTIONS(5043),
    [anon_sym__Noreturn] = ACTIONS(5043),
    [anon_sym_noreturn] = ACTIONS(5043),
    [anon_sym_mutable] = ACTIONS(5043),
    [anon_sym_constinit] = ACTIONS(5043),
    [anon_sym_consteval] = ACTIONS(5043),
    [anon_sym___shared__] = ACTIONS(5043),
    [anon_sym___local__] = ACTIONS(5043),
    [anon_sym___constant__] = ACTIONS(5043),
    [anon_sym___managed__] = ACTIONS(5043),
    [anon_sym___grid_constant__] = ACTIONS(5043),
    [anon_sym_alignas] = ACTIONS(5043),
    [anon_sym__Alignas] = ACTIONS(5043),
    [sym_primitive_type] = ACTIONS(5043),
    [anon_sym_enum] = ACTIONS(5043),
    [anon_sym_class] = ACTIONS(5043),
    [anon_sym_struct] = ACTIONS(5043),
    [anon_sym_union] = ACTIONS(5043),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5043),
    [anon_sym_decltype] = ACTIONS(5043),
    [sym_virtual] = ACTIONS(5043),
    [anon_sym_explicit] = ACTIONS(5043),
    [anon_sym_typename] = ACTIONS(5043),
    [anon_sym_template] = ACTIONS(5043),
    [anon_sym_operator] = ACTIONS(5043),
    [anon_sym_friend] = ACTIONS(5043),
    [anon_sym_public] = ACTIONS(5043),
    [anon_sym_private] = ACTIONS(5043),
    [anon_sym_protected] = ACTIONS(5043),
    [anon_sym_using] = ACTIONS(5043),
    [anon_sym_static_assert] = ACTIONS(5043),
    [anon_sym___launch_bounds__] = ACTIONS(5043),
  },
  [1737] = {
    [sym_identifier] = ACTIONS(5043),
    [aux_sym_preproc_def_token1] = ACTIONS(5043),
    [aux_sym_preproc_if_token1] = ACTIONS(5043),
    [aux_sym_preproc_if_token2] = ACTIONS(5043),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5043),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5043),
    [aux_sym_preproc_else_token1] = ACTIONS(5043),
    [aux_sym_preproc_elif_token1] = ACTIONS(5043),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5043),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5043),
    [sym_preproc_directive] = ACTIONS(5043),
    [anon_sym_LPAREN2] = ACTIONS(5045),
    [anon_sym_TILDE] = ACTIONS(5045),
    [anon_sym_STAR] = ACTIONS(5045),
    [anon_sym_AMP_AMP] = ACTIONS(5045),
    [anon_sym_AMP] = ACTIONS(5043),
    [anon_sym___extension__] = ACTIONS(5043),
    [anon_sym_typedef] = ACTIONS(5043),
    [anon_sym___device__] = ACTIONS(5043),
    [anon_sym___host__] = ACTIONS(5043),
    [anon_sym___global__] = ACTIONS(5043),
    [anon_sym___forceinline__] = ACTIONS(5043),
    [anon_sym___noinline__] = ACTIONS(5043),
    [anon_sym_extern] = ACTIONS(5043),
    [anon_sym___attribute__] = ACTIONS(5043),
    [anon_sym_COLON_COLON] = ACTIONS(5045),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5045),
    [anon_sym___declspec] = ACTIONS(5043),
    [anon_sym___based] = ACTIONS(5043),
    [anon_sym_signed] = ACTIONS(5043),
    [anon_sym_unsigned] = ACTIONS(5043),
    [anon_sym_long] = ACTIONS(5043),
    [anon_sym_short] = ACTIONS(5043),
    [anon_sym_LBRACK] = ACTIONS(5043),
    [anon_sym_static] = ACTIONS(5043),
    [anon_sym_register] = ACTIONS(5043),
    [anon_sym_inline] = ACTIONS(5043),
    [anon_sym___inline] = ACTIONS(5043),
    [anon_sym___inline__] = ACTIONS(5043),
    [anon_sym___forceinline] = ACTIONS(5043),
    [anon_sym_thread_local] = ACTIONS(5043),
    [anon_sym___thread] = ACTIONS(5043),
    [anon_sym_const] = ACTIONS(5043),
    [anon_sym_constexpr] = ACTIONS(5043),
    [anon_sym_volatile] = ACTIONS(5043),
    [anon_sym_restrict] = ACTIONS(5043),
    [anon_sym___restrict__] = ACTIONS(5043),
    [anon_sym__Atomic] = ACTIONS(5043),
    [anon_sym__Noreturn] = ACTIONS(5043),
    [anon_sym_noreturn] = ACTIONS(5043),
    [anon_sym_mutable] = ACTIONS(5043),
    [anon_sym_constinit] = ACTIONS(5043),
    [anon_sym_consteval] = ACTIONS(5043),
    [anon_sym___shared__] = ACTIONS(5043),
    [anon_sym___local__] = ACTIONS(5043),
    [anon_sym___constant__] = ACTIONS(5043),
    [anon_sym___managed__] = ACTIONS(5043),
    [anon_sym___grid_constant__] = ACTIONS(5043),
    [anon_sym_alignas] = ACTIONS(5043),
    [anon_sym__Alignas] = ACTIONS(5043),
    [sym_primitive_type] = ACTIONS(5043),
    [anon_sym_enum] = ACTIONS(5043),
    [anon_sym_class] = ACTIONS(5043),
    [anon_sym_struct] = ACTIONS(5043),
    [anon_sym_union] = ACTIONS(5043),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5043),
    [anon_sym_decltype] = ACTIONS(5043),
    [sym_virtual] = ACTIONS(5043),
    [anon_sym_explicit] = ACTIONS(5043),
    [anon_sym_typename] = ACTIONS(5043),
    [anon_sym_template] = ACTIONS(5043),
    [anon_sym_operator] = ACTIONS(5043),
    [anon_sym_friend] = ACTIONS(5043),
    [anon_sym_public] = ACTIONS(5043),
    [anon_sym_private] = ACTIONS(5043),
    [anon_sym_protected] = ACTIONS(5043),
    [anon_sym_using] = ACTIONS(5043),
    [anon_sym_static_assert] = ACTIONS(5043),
    [anon_sym___launch_bounds__] = ACTIONS(5043),
  },
  [1738] = {
    [sym_identifier] = ACTIONS(5043),
    [aux_sym_preproc_def_token1] = ACTIONS(5043),
    [aux_sym_preproc_if_token1] = ACTIONS(5043),
    [aux_sym_preproc_if_token2] = ACTIONS(5043),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5043),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5043),
    [aux_sym_preproc_else_token1] = ACTIONS(5043),
    [aux_sym_preproc_elif_token1] = ACTIONS(5043),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5043),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5043),
    [sym_preproc_directive] = ACTIONS(5043),
    [anon_sym_LPAREN2] = ACTIONS(5045),
    [anon_sym_TILDE] = ACTIONS(5045),
    [anon_sym_STAR] = ACTIONS(5045),
    [anon_sym_AMP_AMP] = ACTIONS(5045),
    [anon_sym_AMP] = ACTIONS(5043),
    [anon_sym___extension__] = ACTIONS(5043),
    [anon_sym_typedef] = ACTIONS(5043),
    [anon_sym___device__] = ACTIONS(5043),
    [anon_sym___host__] = ACTIONS(5043),
    [anon_sym___global__] = ACTIONS(5043),
    [anon_sym___forceinline__] = ACTIONS(5043),
    [anon_sym___noinline__] = ACTIONS(5043),
    [anon_sym_extern] = ACTIONS(5043),
    [anon_sym___attribute__] = ACTIONS(5043),
    [anon_sym_COLON_COLON] = ACTIONS(5045),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5045),
    [anon_sym___declspec] = ACTIONS(5043),
    [anon_sym___based] = ACTIONS(5043),
    [anon_sym_signed] = ACTIONS(5043),
    [anon_sym_unsigned] = ACTIONS(5043),
    [anon_sym_long] = ACTIONS(5043),
    [anon_sym_short] = ACTIONS(5043),
    [anon_sym_LBRACK] = ACTIONS(5043),
    [anon_sym_static] = ACTIONS(5043),
    [anon_sym_register] = ACTIONS(5043),
    [anon_sym_inline] = ACTIONS(5043),
    [anon_sym___inline] = ACTIONS(5043),
    [anon_sym___inline__] = ACTIONS(5043),
    [anon_sym___forceinline] = ACTIONS(5043),
    [anon_sym_thread_local] = ACTIONS(5043),
    [anon_sym___thread] = ACTIONS(5043),
    [anon_sym_const] = ACTIONS(5043),
    [anon_sym_constexpr] = ACTIONS(5043),
    [anon_sym_volatile] = ACTIONS(5043),
    [anon_sym_restrict] = ACTIONS(5043),
    [anon_sym___restrict__] = ACTIONS(5043),
    [anon_sym__Atomic] = ACTIONS(5043),
    [anon_sym__Noreturn] = ACTIONS(5043),
    [anon_sym_noreturn] = ACTIONS(5043),
    [anon_sym_mutable] = ACTIONS(5043),
    [anon_sym_constinit] = ACTIONS(5043),
    [anon_sym_consteval] = ACTIONS(5043),
    [anon_sym___shared__] = ACTIONS(5043),
    [anon_sym___local__] = ACTIONS(5043),
    [anon_sym___constant__] = ACTIONS(5043),
    [anon_sym___managed__] = ACTIONS(5043),
    [anon_sym___grid_constant__] = ACTIONS(5043),
    [anon_sym_alignas] = ACTIONS(5043),
    [anon_sym__Alignas] = ACTIONS(5043),
    [sym_primitive_type] = ACTIONS(5043),
    [anon_sym_enum] = ACTIONS(5043),
    [anon_sym_class] = ACTIONS(5043),
    [anon_sym_struct] = ACTIONS(5043),
    [anon_sym_union] = ACTIONS(5043),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5043),
    [anon_sym_decltype] = ACTIONS(5043),
    [sym_virtual] = ACTIONS(5043),
    [anon_sym_explicit] = ACTIONS(5043),
    [anon_sym_typename] = ACTIONS(5043),
    [anon_sym_template] = ACTIONS(5043),
    [anon_sym_operator] = ACTIONS(5043),
    [anon_sym_friend] = ACTIONS(5043),
    [anon_sym_public] = ACTIONS(5043),
    [anon_sym_private] = ACTIONS(5043),
    [anon_sym_protected] = ACTIONS(5043),
    [anon_sym_using] = ACTIONS(5043),
    [anon_sym_static_assert] = ACTIONS(5043),
    [anon_sym___launch_bounds__] = ACTIONS(5043),
  },
  [1739] = {
    [sym_identifier] = ACTIONS(2473),
    [aux_sym_preproc_def_token1] = ACTIONS(2473),
    [aux_sym_preproc_if_token1] = ACTIONS(2473),
    [aux_sym_preproc_if_token2] = ACTIONS(2473),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2473),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2473),
    [aux_sym_preproc_else_token1] = ACTIONS(2473),
    [aux_sym_preproc_elif_token1] = ACTIONS(2473),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2473),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2473),
    [sym_preproc_directive] = ACTIONS(2473),
    [anon_sym_LPAREN2] = ACTIONS(2475),
    [anon_sym_TILDE] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(2475),
    [anon_sym_AMP_AMP] = ACTIONS(2475),
    [anon_sym_AMP] = ACTIONS(2473),
    [anon_sym___extension__] = ACTIONS(2473),
    [anon_sym_typedef] = ACTIONS(2473),
    [anon_sym___device__] = ACTIONS(2473),
    [anon_sym___host__] = ACTIONS(2473),
    [anon_sym___global__] = ACTIONS(2473),
    [anon_sym___forceinline__] = ACTIONS(2473),
    [anon_sym___noinline__] = ACTIONS(2473),
    [anon_sym_extern] = ACTIONS(2473),
    [anon_sym___attribute__] = ACTIONS(2473),
    [anon_sym_COLON_COLON] = ACTIONS(2475),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2475),
    [anon_sym___declspec] = ACTIONS(2473),
    [anon_sym___based] = ACTIONS(2473),
    [anon_sym_signed] = ACTIONS(2473),
    [anon_sym_unsigned] = ACTIONS(2473),
    [anon_sym_long] = ACTIONS(2473),
    [anon_sym_short] = ACTIONS(2473),
    [anon_sym_LBRACK] = ACTIONS(2473),
    [anon_sym_static] = ACTIONS(2473),
    [anon_sym_register] = ACTIONS(2473),
    [anon_sym_inline] = ACTIONS(2473),
    [anon_sym___inline] = ACTIONS(2473),
    [anon_sym___inline__] = ACTIONS(2473),
    [anon_sym___forceinline] = ACTIONS(2473),
    [anon_sym_thread_local] = ACTIONS(2473),
    [anon_sym___thread] = ACTIONS(2473),
    [anon_sym_const] = ACTIONS(2473),
    [anon_sym_constexpr] = ACTIONS(2473),
    [anon_sym_volatile] = ACTIONS(2473),
    [anon_sym_restrict] = ACTIONS(2473),
    [anon_sym___restrict__] = ACTIONS(2473),
    [anon_sym__Atomic] = ACTIONS(2473),
    [anon_sym__Noreturn] = ACTIONS(2473),
    [anon_sym_noreturn] = ACTIONS(2473),
    [anon_sym_mutable] = ACTIONS(2473),
    [anon_sym_constinit] = ACTIONS(2473),
    [anon_sym_consteval] = ACTIONS(2473),
    [anon_sym___shared__] = ACTIONS(2473),
    [anon_sym___local__] = ACTIONS(2473),
    [anon_sym___constant__] = ACTIONS(2473),
    [anon_sym___managed__] = ACTIONS(2473),
    [anon_sym___grid_constant__] = ACTIONS(2473),
    [anon_sym_alignas] = ACTIONS(2473),
    [anon_sym__Alignas] = ACTIONS(2473),
    [sym_primitive_type] = ACTIONS(2473),
    [anon_sym_enum] = ACTIONS(2473),
    [anon_sym_class] = ACTIONS(2473),
    [anon_sym_struct] = ACTIONS(2473),
    [anon_sym_union] = ACTIONS(2473),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2473),
    [anon_sym_decltype] = ACTIONS(2473),
    [sym_virtual] = ACTIONS(2473),
    [anon_sym_explicit] = ACTIONS(2473),
    [anon_sym_typename] = ACTIONS(2473),
    [anon_sym_template] = ACTIONS(2473),
    [anon_sym_operator] = ACTIONS(2473),
    [anon_sym_friend] = ACTIONS(2473),
    [anon_sym_public] = ACTIONS(2473),
    [anon_sym_private] = ACTIONS(2473),
    [anon_sym_protected] = ACTIONS(2473),
    [anon_sym_using] = ACTIONS(2473),
    [anon_sym_static_assert] = ACTIONS(2473),
    [anon_sym___launch_bounds__] = ACTIONS(2473),
  },
  [1740] = {
    [sym_identifier] = ACTIONS(5039),
    [aux_sym_preproc_def_token1] = ACTIONS(5039),
    [aux_sym_preproc_if_token1] = ACTIONS(5039),
    [aux_sym_preproc_if_token2] = ACTIONS(5039),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5039),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5039),
    [aux_sym_preproc_else_token1] = ACTIONS(5039),
    [aux_sym_preproc_elif_token1] = ACTIONS(5039),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5039),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5039),
    [sym_preproc_directive] = ACTIONS(5039),
    [anon_sym_LPAREN2] = ACTIONS(5041),
    [anon_sym_TILDE] = ACTIONS(5041),
    [anon_sym_STAR] = ACTIONS(5041),
    [anon_sym_AMP_AMP] = ACTIONS(5041),
    [anon_sym_AMP] = ACTIONS(5039),
    [anon_sym___extension__] = ACTIONS(5039),
    [anon_sym_typedef] = ACTIONS(5039),
    [anon_sym___device__] = ACTIONS(5039),
    [anon_sym___host__] = ACTIONS(5039),
    [anon_sym___global__] = ACTIONS(5039),
    [anon_sym___forceinline__] = ACTIONS(5039),
    [anon_sym___noinline__] = ACTIONS(5039),
    [anon_sym_extern] = ACTIONS(5039),
    [anon_sym___attribute__] = ACTIONS(5039),
    [anon_sym_COLON_COLON] = ACTIONS(5041),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5041),
    [anon_sym___declspec] = ACTIONS(5039),
    [anon_sym___based] = ACTIONS(5039),
    [anon_sym_signed] = ACTIONS(5039),
    [anon_sym_unsigned] = ACTIONS(5039),
    [anon_sym_long] = ACTIONS(5039),
    [anon_sym_short] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(5039),
    [anon_sym_static] = ACTIONS(5039),
    [anon_sym_register] = ACTIONS(5039),
    [anon_sym_inline] = ACTIONS(5039),
    [anon_sym___inline] = ACTIONS(5039),
    [anon_sym___inline__] = ACTIONS(5039),
    [anon_sym___forceinline] = ACTIONS(5039),
    [anon_sym_thread_local] = ACTIONS(5039),
    [anon_sym___thread] = ACTIONS(5039),
    [anon_sym_const] = ACTIONS(5039),
    [anon_sym_constexpr] = ACTIONS(5039),
    [anon_sym_volatile] = ACTIONS(5039),
    [anon_sym_restrict] = ACTIONS(5039),
    [anon_sym___restrict__] = ACTIONS(5039),
    [anon_sym__Atomic] = ACTIONS(5039),
    [anon_sym__Noreturn] = ACTIONS(5039),
    [anon_sym_noreturn] = ACTIONS(5039),
    [anon_sym_mutable] = ACTIONS(5039),
    [anon_sym_constinit] = ACTIONS(5039),
    [anon_sym_consteval] = ACTIONS(5039),
    [anon_sym___shared__] = ACTIONS(5039),
    [anon_sym___local__] = ACTIONS(5039),
    [anon_sym___constant__] = ACTIONS(5039),
    [anon_sym___managed__] = ACTIONS(5039),
    [anon_sym___grid_constant__] = ACTIONS(5039),
    [anon_sym_alignas] = ACTIONS(5039),
    [anon_sym__Alignas] = ACTIONS(5039),
    [sym_primitive_type] = ACTIONS(5039),
    [anon_sym_enum] = ACTIONS(5039),
    [anon_sym_class] = ACTIONS(5039),
    [anon_sym_struct] = ACTIONS(5039),
    [anon_sym_union] = ACTIONS(5039),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5039),
    [anon_sym_decltype] = ACTIONS(5039),
    [sym_virtual] = ACTIONS(5039),
    [anon_sym_explicit] = ACTIONS(5039),
    [anon_sym_typename] = ACTIONS(5039),
    [anon_sym_template] = ACTIONS(5039),
    [anon_sym_operator] = ACTIONS(5039),
    [anon_sym_friend] = ACTIONS(5039),
    [anon_sym_public] = ACTIONS(5039),
    [anon_sym_private] = ACTIONS(5039),
    [anon_sym_protected] = ACTIONS(5039),
    [anon_sym_using] = ACTIONS(5039),
    [anon_sym_static_assert] = ACTIONS(5039),
    [anon_sym___launch_bounds__] = ACTIONS(5039),
  },
  [1741] = {
    [sym_identifier] = ACTIONS(2500),
    [aux_sym_preproc_def_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token2] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2500),
    [aux_sym_preproc_else_token1] = ACTIONS(2500),
    [aux_sym_preproc_elif_token1] = ACTIONS(2500),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2500),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2500),
    [sym_preproc_directive] = ACTIONS(2500),
    [anon_sym_LPAREN2] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [anon_sym_STAR] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2500),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_typedef] = ACTIONS(2500),
    [anon_sym___device__] = ACTIONS(2500),
    [anon_sym___host__] = ACTIONS(2500),
    [anon_sym___global__] = ACTIONS(2500),
    [anon_sym___forceinline__] = ACTIONS(2500),
    [anon_sym___noinline__] = ACTIONS(2500),
    [anon_sym_extern] = ACTIONS(2500),
    [anon_sym___attribute__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2502),
    [anon_sym___declspec] = ACTIONS(2500),
    [anon_sym___based] = ACTIONS(2500),
    [anon_sym_signed] = ACTIONS(2500),
    [anon_sym_unsigned] = ACTIONS(2500),
    [anon_sym_long] = ACTIONS(2500),
    [anon_sym_short] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_static] = ACTIONS(2500),
    [anon_sym_register] = ACTIONS(2500),
    [anon_sym_inline] = ACTIONS(2500),
    [anon_sym___inline] = ACTIONS(2500),
    [anon_sym___inline__] = ACTIONS(2500),
    [anon_sym___forceinline] = ACTIONS(2500),
    [anon_sym_thread_local] = ACTIONS(2500),
    [anon_sym___thread] = ACTIONS(2500),
    [anon_sym_const] = ACTIONS(2500),
    [anon_sym_constexpr] = ACTIONS(2500),
    [anon_sym_volatile] = ACTIONS(2500),
    [anon_sym_restrict] = ACTIONS(2500),
    [anon_sym___restrict__] = ACTIONS(2500),
    [anon_sym__Atomic] = ACTIONS(2500),
    [anon_sym__Noreturn] = ACTIONS(2500),
    [anon_sym_noreturn] = ACTIONS(2500),
    [anon_sym_mutable] = ACTIONS(2500),
    [anon_sym_constinit] = ACTIONS(2500),
    [anon_sym_consteval] = ACTIONS(2500),
    [anon_sym___shared__] = ACTIONS(2500),
    [anon_sym___local__] = ACTIONS(2500),
    [anon_sym___constant__] = ACTIONS(2500),
    [anon_sym___managed__] = ACTIONS(2500),
    [anon_sym___grid_constant__] = ACTIONS(2500),
    [anon_sym_alignas] = ACTIONS(2500),
    [anon_sym__Alignas] = ACTIONS(2500),
    [sym_primitive_type] = ACTIONS(2500),
    [anon_sym_enum] = ACTIONS(2500),
    [anon_sym_class] = ACTIONS(2500),
    [anon_sym_struct] = ACTIONS(2500),
    [anon_sym_union] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2500),
    [anon_sym_decltype] = ACTIONS(2500),
    [sym_virtual] = ACTIONS(2500),
    [anon_sym_explicit] = ACTIONS(2500),
    [anon_sym_typename] = ACTIONS(2500),
    [anon_sym_template] = ACTIONS(2500),
    [anon_sym_operator] = ACTIONS(2500),
    [anon_sym_friend] = ACTIONS(2500),
    [anon_sym_public] = ACTIONS(2500),
    [anon_sym_private] = ACTIONS(2500),
    [anon_sym_protected] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_static_assert] = ACTIONS(2500),
    [anon_sym___launch_bounds__] = ACTIONS(2500),
  },
  [1742] = {
    [sym_identifier] = ACTIONS(5047),
    [aux_sym_preproc_def_token1] = ACTIONS(5047),
    [aux_sym_preproc_if_token1] = ACTIONS(5047),
    [aux_sym_preproc_if_token2] = ACTIONS(5047),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5047),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5047),
    [aux_sym_preproc_else_token1] = ACTIONS(5047),
    [aux_sym_preproc_elif_token1] = ACTIONS(5047),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5047),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5047),
    [sym_preproc_directive] = ACTIONS(5047),
    [anon_sym_LPAREN2] = ACTIONS(5049),
    [anon_sym_TILDE] = ACTIONS(5049),
    [anon_sym_STAR] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5049),
    [anon_sym_AMP] = ACTIONS(5047),
    [anon_sym___extension__] = ACTIONS(5047),
    [anon_sym_typedef] = ACTIONS(5047),
    [anon_sym___device__] = ACTIONS(5047),
    [anon_sym___host__] = ACTIONS(5047),
    [anon_sym___global__] = ACTIONS(5047),
    [anon_sym___forceinline__] = ACTIONS(5047),
    [anon_sym___noinline__] = ACTIONS(5047),
    [anon_sym_extern] = ACTIONS(5047),
    [anon_sym___attribute__] = ACTIONS(5047),
    [anon_sym_COLON_COLON] = ACTIONS(5049),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5049),
    [anon_sym___declspec] = ACTIONS(5047),
    [anon_sym___based] = ACTIONS(5047),
    [anon_sym_signed] = ACTIONS(5047),
    [anon_sym_unsigned] = ACTIONS(5047),
    [anon_sym_long] = ACTIONS(5047),
    [anon_sym_short] = ACTIONS(5047),
    [anon_sym_LBRACK] = ACTIONS(5047),
    [anon_sym_static] = ACTIONS(5047),
    [anon_sym_register] = ACTIONS(5047),
    [anon_sym_inline] = ACTIONS(5047),
    [anon_sym___inline] = ACTIONS(5047),
    [anon_sym___inline__] = ACTIONS(5047),
    [anon_sym___forceinline] = ACTIONS(5047),
    [anon_sym_thread_local] = ACTIONS(5047),
    [anon_sym___thread] = ACTIONS(5047),
    [anon_sym_const] = ACTIONS(5047),
    [anon_sym_constexpr] = ACTIONS(5047),
    [anon_sym_volatile] = ACTIONS(5047),
    [anon_sym_restrict] = ACTIONS(5047),
    [anon_sym___restrict__] = ACTIONS(5047),
    [anon_sym__Atomic] = ACTIONS(5047),
    [anon_sym__Noreturn] = ACTIONS(5047),
    [anon_sym_noreturn] = ACTIONS(5047),
    [anon_sym_mutable] = ACTIONS(5047),
    [anon_sym_constinit] = ACTIONS(5047),
    [anon_sym_consteval] = ACTIONS(5047),
    [anon_sym___shared__] = ACTIONS(5047),
    [anon_sym___local__] = ACTIONS(5047),
    [anon_sym___constant__] = ACTIONS(5047),
    [anon_sym___managed__] = ACTIONS(5047),
    [anon_sym___grid_constant__] = ACTIONS(5047),
    [anon_sym_alignas] = ACTIONS(5047),
    [anon_sym__Alignas] = ACTIONS(5047),
    [sym_primitive_type] = ACTIONS(5047),
    [anon_sym_enum] = ACTIONS(5047),
    [anon_sym_class] = ACTIONS(5047),
    [anon_sym_struct] = ACTIONS(5047),
    [anon_sym_union] = ACTIONS(5047),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5047),
    [anon_sym_decltype] = ACTIONS(5047),
    [sym_virtual] = ACTIONS(5047),
    [anon_sym_explicit] = ACTIONS(5047),
    [anon_sym_typename] = ACTIONS(5047),
    [anon_sym_template] = ACTIONS(5047),
    [anon_sym_operator] = ACTIONS(5047),
    [anon_sym_friend] = ACTIONS(5047),
    [anon_sym_public] = ACTIONS(5047),
    [anon_sym_private] = ACTIONS(5047),
    [anon_sym_protected] = ACTIONS(5047),
    [anon_sym_using] = ACTIONS(5047),
    [anon_sym_static_assert] = ACTIONS(5047),
    [anon_sym___launch_bounds__] = ACTIONS(5047),
  },
  [1743] = {
    [sym_identifier] = ACTIONS(5051),
    [aux_sym_preproc_def_token1] = ACTIONS(5051),
    [aux_sym_preproc_if_token1] = ACTIONS(5051),
    [aux_sym_preproc_if_token2] = ACTIONS(5051),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5051),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5051),
    [aux_sym_preproc_else_token1] = ACTIONS(5051),
    [aux_sym_preproc_elif_token1] = ACTIONS(5051),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5051),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5051),
    [sym_preproc_directive] = ACTIONS(5051),
    [anon_sym_LPAREN2] = ACTIONS(5053),
    [anon_sym_TILDE] = ACTIONS(5053),
    [anon_sym_STAR] = ACTIONS(5053),
    [anon_sym_AMP_AMP] = ACTIONS(5053),
    [anon_sym_AMP] = ACTIONS(5051),
    [anon_sym___extension__] = ACTIONS(5051),
    [anon_sym_typedef] = ACTIONS(5051),
    [anon_sym___device__] = ACTIONS(5051),
    [anon_sym___host__] = ACTIONS(5051),
    [anon_sym___global__] = ACTIONS(5051),
    [anon_sym___forceinline__] = ACTIONS(5051),
    [anon_sym___noinline__] = ACTIONS(5051),
    [anon_sym_extern] = ACTIONS(5051),
    [anon_sym___attribute__] = ACTIONS(5051),
    [anon_sym_COLON_COLON] = ACTIONS(5053),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5053),
    [anon_sym___declspec] = ACTIONS(5051),
    [anon_sym___based] = ACTIONS(5051),
    [anon_sym_signed] = ACTIONS(5051),
    [anon_sym_unsigned] = ACTIONS(5051),
    [anon_sym_long] = ACTIONS(5051),
    [anon_sym_short] = ACTIONS(5051),
    [anon_sym_LBRACK] = ACTIONS(5051),
    [anon_sym_static] = ACTIONS(5051),
    [anon_sym_register] = ACTIONS(5051),
    [anon_sym_inline] = ACTIONS(5051),
    [anon_sym___inline] = ACTIONS(5051),
    [anon_sym___inline__] = ACTIONS(5051),
    [anon_sym___forceinline] = ACTIONS(5051),
    [anon_sym_thread_local] = ACTIONS(5051),
    [anon_sym___thread] = ACTIONS(5051),
    [anon_sym_const] = ACTIONS(5051),
    [anon_sym_constexpr] = ACTIONS(5051),
    [anon_sym_volatile] = ACTIONS(5051),
    [anon_sym_restrict] = ACTIONS(5051),
    [anon_sym___restrict__] = ACTIONS(5051),
    [anon_sym__Atomic] = ACTIONS(5051),
    [anon_sym__Noreturn] = ACTIONS(5051),
    [anon_sym_noreturn] = ACTIONS(5051),
    [anon_sym_mutable] = ACTIONS(5051),
    [anon_sym_constinit] = ACTIONS(5051),
    [anon_sym_consteval] = ACTIONS(5051),
    [anon_sym___shared__] = ACTIONS(5051),
    [anon_sym___local__] = ACTIONS(5051),
    [anon_sym___constant__] = ACTIONS(5051),
    [anon_sym___managed__] = ACTIONS(5051),
    [anon_sym___grid_constant__] = ACTIONS(5051),
    [anon_sym_alignas] = ACTIONS(5051),
    [anon_sym__Alignas] = ACTIONS(5051),
    [sym_primitive_type] = ACTIONS(5051),
    [anon_sym_enum] = ACTIONS(5051),
    [anon_sym_class] = ACTIONS(5051),
    [anon_sym_struct] = ACTIONS(5051),
    [anon_sym_union] = ACTIONS(5051),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5051),
    [anon_sym_decltype] = ACTIONS(5051),
    [sym_virtual] = ACTIONS(5051),
    [anon_sym_explicit] = ACTIONS(5051),
    [anon_sym_typename] = ACTIONS(5051),
    [anon_sym_template] = ACTIONS(5051),
    [anon_sym_operator] = ACTIONS(5051),
    [anon_sym_friend] = ACTIONS(5051),
    [anon_sym_public] = ACTIONS(5051),
    [anon_sym_private] = ACTIONS(5051),
    [anon_sym_protected] = ACTIONS(5051),
    [anon_sym_using] = ACTIONS(5051),
    [anon_sym_static_assert] = ACTIONS(5051),
    [anon_sym___launch_bounds__] = ACTIONS(5051),
  },
  [1744] = {
    [sym_identifier] = ACTIONS(2500),
    [aux_sym_preproc_def_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token2] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2500),
    [aux_sym_preproc_else_token1] = ACTIONS(2500),
    [aux_sym_preproc_elif_token1] = ACTIONS(2500),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2500),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2500),
    [sym_preproc_directive] = ACTIONS(2500),
    [anon_sym_LPAREN2] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [anon_sym_STAR] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2500),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_typedef] = ACTIONS(2500),
    [anon_sym___device__] = ACTIONS(2500),
    [anon_sym___host__] = ACTIONS(2500),
    [anon_sym___global__] = ACTIONS(2500),
    [anon_sym___forceinline__] = ACTIONS(2500),
    [anon_sym___noinline__] = ACTIONS(2500),
    [anon_sym_extern] = ACTIONS(2500),
    [anon_sym___attribute__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2502),
    [anon_sym___declspec] = ACTIONS(2500),
    [anon_sym___based] = ACTIONS(2500),
    [anon_sym_signed] = ACTIONS(2500),
    [anon_sym_unsigned] = ACTIONS(2500),
    [anon_sym_long] = ACTIONS(2500),
    [anon_sym_short] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_static] = ACTIONS(2500),
    [anon_sym_register] = ACTIONS(2500),
    [anon_sym_inline] = ACTIONS(2500),
    [anon_sym___inline] = ACTIONS(2500),
    [anon_sym___inline__] = ACTIONS(2500),
    [anon_sym___forceinline] = ACTIONS(2500),
    [anon_sym_thread_local] = ACTIONS(2500),
    [anon_sym___thread] = ACTIONS(2500),
    [anon_sym_const] = ACTIONS(2500),
    [anon_sym_constexpr] = ACTIONS(2500),
    [anon_sym_volatile] = ACTIONS(2500),
    [anon_sym_restrict] = ACTIONS(2500),
    [anon_sym___restrict__] = ACTIONS(2500),
    [anon_sym__Atomic] = ACTIONS(2500),
    [anon_sym__Noreturn] = ACTIONS(2500),
    [anon_sym_noreturn] = ACTIONS(2500),
    [anon_sym_mutable] = ACTIONS(2500),
    [anon_sym_constinit] = ACTIONS(2500),
    [anon_sym_consteval] = ACTIONS(2500),
    [anon_sym___shared__] = ACTIONS(2500),
    [anon_sym___local__] = ACTIONS(2500),
    [anon_sym___constant__] = ACTIONS(2500),
    [anon_sym___managed__] = ACTIONS(2500),
    [anon_sym___grid_constant__] = ACTIONS(2500),
    [anon_sym_alignas] = ACTIONS(2500),
    [anon_sym__Alignas] = ACTIONS(2500),
    [sym_primitive_type] = ACTIONS(2500),
    [anon_sym_enum] = ACTIONS(2500),
    [anon_sym_class] = ACTIONS(2500),
    [anon_sym_struct] = ACTIONS(2500),
    [anon_sym_union] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2500),
    [anon_sym_decltype] = ACTIONS(2500),
    [sym_virtual] = ACTIONS(2500),
    [anon_sym_explicit] = ACTIONS(2500),
    [anon_sym_typename] = ACTIONS(2500),
    [anon_sym_template] = ACTIONS(2500),
    [anon_sym_operator] = ACTIONS(2500),
    [anon_sym_friend] = ACTIONS(2500),
    [anon_sym_public] = ACTIONS(2500),
    [anon_sym_private] = ACTIONS(2500),
    [anon_sym_protected] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_static_assert] = ACTIONS(2500),
    [anon_sym___launch_bounds__] = ACTIONS(2500),
  },
  [1745] = {
    [sym_identifier] = ACTIONS(5055),
    [aux_sym_preproc_def_token1] = ACTIONS(5055),
    [aux_sym_preproc_if_token1] = ACTIONS(5055),
    [aux_sym_preproc_if_token2] = ACTIONS(5055),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5055),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5055),
    [aux_sym_preproc_else_token1] = ACTIONS(5055),
    [aux_sym_preproc_elif_token1] = ACTIONS(5055),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5055),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5055),
    [sym_preproc_directive] = ACTIONS(5055),
    [anon_sym_LPAREN2] = ACTIONS(5057),
    [anon_sym_TILDE] = ACTIONS(5057),
    [anon_sym_STAR] = ACTIONS(5057),
    [anon_sym_AMP_AMP] = ACTIONS(5057),
    [anon_sym_AMP] = ACTIONS(5055),
    [anon_sym___extension__] = ACTIONS(5055),
    [anon_sym_typedef] = ACTIONS(5055),
    [anon_sym___device__] = ACTIONS(5055),
    [anon_sym___host__] = ACTIONS(5055),
    [anon_sym___global__] = ACTIONS(5055),
    [anon_sym___forceinline__] = ACTIONS(5055),
    [anon_sym___noinline__] = ACTIONS(5055),
    [anon_sym_extern] = ACTIONS(5055),
    [anon_sym___attribute__] = ACTIONS(5055),
    [anon_sym_COLON_COLON] = ACTIONS(5057),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5057),
    [anon_sym___declspec] = ACTIONS(5055),
    [anon_sym___based] = ACTIONS(5055),
    [anon_sym_signed] = ACTIONS(5055),
    [anon_sym_unsigned] = ACTIONS(5055),
    [anon_sym_long] = ACTIONS(5055),
    [anon_sym_short] = ACTIONS(5055),
    [anon_sym_LBRACK] = ACTIONS(5055),
    [anon_sym_static] = ACTIONS(5055),
    [anon_sym_register] = ACTIONS(5055),
    [anon_sym_inline] = ACTIONS(5055),
    [anon_sym___inline] = ACTIONS(5055),
    [anon_sym___inline__] = ACTIONS(5055),
    [anon_sym___forceinline] = ACTIONS(5055),
    [anon_sym_thread_local] = ACTIONS(5055),
    [anon_sym___thread] = ACTIONS(5055),
    [anon_sym_const] = ACTIONS(5055),
    [anon_sym_constexpr] = ACTIONS(5055),
    [anon_sym_volatile] = ACTIONS(5055),
    [anon_sym_restrict] = ACTIONS(5055),
    [anon_sym___restrict__] = ACTIONS(5055),
    [anon_sym__Atomic] = ACTIONS(5055),
    [anon_sym__Noreturn] = ACTIONS(5055),
    [anon_sym_noreturn] = ACTIONS(5055),
    [anon_sym_mutable] = ACTIONS(5055),
    [anon_sym_constinit] = ACTIONS(5055),
    [anon_sym_consteval] = ACTIONS(5055),
    [anon_sym___shared__] = ACTIONS(5055),
    [anon_sym___local__] = ACTIONS(5055),
    [anon_sym___constant__] = ACTIONS(5055),
    [anon_sym___managed__] = ACTIONS(5055),
    [anon_sym___grid_constant__] = ACTIONS(5055),
    [anon_sym_alignas] = ACTIONS(5055),
    [anon_sym__Alignas] = ACTIONS(5055),
    [sym_primitive_type] = ACTIONS(5055),
    [anon_sym_enum] = ACTIONS(5055),
    [anon_sym_class] = ACTIONS(5055),
    [anon_sym_struct] = ACTIONS(5055),
    [anon_sym_union] = ACTIONS(5055),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5055),
    [anon_sym_decltype] = ACTIONS(5055),
    [sym_virtual] = ACTIONS(5055),
    [anon_sym_explicit] = ACTIONS(5055),
    [anon_sym_typename] = ACTIONS(5055),
    [anon_sym_template] = ACTIONS(5055),
    [anon_sym_operator] = ACTIONS(5055),
    [anon_sym_friend] = ACTIONS(5055),
    [anon_sym_public] = ACTIONS(5055),
    [anon_sym_private] = ACTIONS(5055),
    [anon_sym_protected] = ACTIONS(5055),
    [anon_sym_using] = ACTIONS(5055),
    [anon_sym_static_assert] = ACTIONS(5055),
    [anon_sym___launch_bounds__] = ACTIONS(5055),
  },
  [1746] = {
    [sym_identifier] = ACTIONS(5059),
    [aux_sym_preproc_def_token1] = ACTIONS(5059),
    [aux_sym_preproc_if_token1] = ACTIONS(5059),
    [aux_sym_preproc_if_token2] = ACTIONS(5059),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5059),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5059),
    [aux_sym_preproc_else_token1] = ACTIONS(5059),
    [aux_sym_preproc_elif_token1] = ACTIONS(5059),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5059),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5059),
    [sym_preproc_directive] = ACTIONS(5059),
    [anon_sym_LPAREN2] = ACTIONS(5061),
    [anon_sym_TILDE] = ACTIONS(5061),
    [anon_sym_STAR] = ACTIONS(5061),
    [anon_sym_AMP_AMP] = ACTIONS(5061),
    [anon_sym_AMP] = ACTIONS(5059),
    [anon_sym___extension__] = ACTIONS(5059),
    [anon_sym_typedef] = ACTIONS(5059),
    [anon_sym___device__] = ACTIONS(5059),
    [anon_sym___host__] = ACTIONS(5059),
    [anon_sym___global__] = ACTIONS(5059),
    [anon_sym___forceinline__] = ACTIONS(5059),
    [anon_sym___noinline__] = ACTIONS(5059),
    [anon_sym_extern] = ACTIONS(5059),
    [anon_sym___attribute__] = ACTIONS(5059),
    [anon_sym_COLON_COLON] = ACTIONS(5061),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5061),
    [anon_sym___declspec] = ACTIONS(5059),
    [anon_sym___based] = ACTIONS(5059),
    [anon_sym_signed] = ACTIONS(5059),
    [anon_sym_unsigned] = ACTIONS(5059),
    [anon_sym_long] = ACTIONS(5059),
    [anon_sym_short] = ACTIONS(5059),
    [anon_sym_LBRACK] = ACTIONS(5059),
    [anon_sym_static] = ACTIONS(5059),
    [anon_sym_register] = ACTIONS(5059),
    [anon_sym_inline] = ACTIONS(5059),
    [anon_sym___inline] = ACTIONS(5059),
    [anon_sym___inline__] = ACTIONS(5059),
    [anon_sym___forceinline] = ACTIONS(5059),
    [anon_sym_thread_local] = ACTIONS(5059),
    [anon_sym___thread] = ACTIONS(5059),
    [anon_sym_const] = ACTIONS(5059),
    [anon_sym_constexpr] = ACTIONS(5059),
    [anon_sym_volatile] = ACTIONS(5059),
    [anon_sym_restrict] = ACTIONS(5059),
    [anon_sym___restrict__] = ACTIONS(5059),
    [anon_sym__Atomic] = ACTIONS(5059),
    [anon_sym__Noreturn] = ACTIONS(5059),
    [anon_sym_noreturn] = ACTIONS(5059),
    [anon_sym_mutable] = ACTIONS(5059),
    [anon_sym_constinit] = ACTIONS(5059),
    [anon_sym_consteval] = ACTIONS(5059),
    [anon_sym___shared__] = ACTIONS(5059),
    [anon_sym___local__] = ACTIONS(5059),
    [anon_sym___constant__] = ACTIONS(5059),
    [anon_sym___managed__] = ACTIONS(5059),
    [anon_sym___grid_constant__] = ACTIONS(5059),
    [anon_sym_alignas] = ACTIONS(5059),
    [anon_sym__Alignas] = ACTIONS(5059),
    [sym_primitive_type] = ACTIONS(5059),
    [anon_sym_enum] = ACTIONS(5059),
    [anon_sym_class] = ACTIONS(5059),
    [anon_sym_struct] = ACTIONS(5059),
    [anon_sym_union] = ACTIONS(5059),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5059),
    [anon_sym_decltype] = ACTIONS(5059),
    [sym_virtual] = ACTIONS(5059),
    [anon_sym_explicit] = ACTIONS(5059),
    [anon_sym_typename] = ACTIONS(5059),
    [anon_sym_template] = ACTIONS(5059),
    [anon_sym_operator] = ACTIONS(5059),
    [anon_sym_friend] = ACTIONS(5059),
    [anon_sym_public] = ACTIONS(5059),
    [anon_sym_private] = ACTIONS(5059),
    [anon_sym_protected] = ACTIONS(5059),
    [anon_sym_using] = ACTIONS(5059),
    [anon_sym_static_assert] = ACTIONS(5059),
    [anon_sym___launch_bounds__] = ACTIONS(5059),
  },
  [1747] = {
    [sym_identifier] = ACTIONS(5059),
    [aux_sym_preproc_def_token1] = ACTIONS(5059),
    [aux_sym_preproc_if_token1] = ACTIONS(5059),
    [aux_sym_preproc_if_token2] = ACTIONS(5059),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5059),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5059),
    [aux_sym_preproc_else_token1] = ACTIONS(5059),
    [aux_sym_preproc_elif_token1] = ACTIONS(5059),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5059),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5059),
    [sym_preproc_directive] = ACTIONS(5059),
    [anon_sym_LPAREN2] = ACTIONS(5061),
    [anon_sym_TILDE] = ACTIONS(5061),
    [anon_sym_STAR] = ACTIONS(5061),
    [anon_sym_AMP_AMP] = ACTIONS(5061),
    [anon_sym_AMP] = ACTIONS(5059),
    [anon_sym___extension__] = ACTIONS(5059),
    [anon_sym_typedef] = ACTIONS(5059),
    [anon_sym___device__] = ACTIONS(5059),
    [anon_sym___host__] = ACTIONS(5059),
    [anon_sym___global__] = ACTIONS(5059),
    [anon_sym___forceinline__] = ACTIONS(5059),
    [anon_sym___noinline__] = ACTIONS(5059),
    [anon_sym_extern] = ACTIONS(5059),
    [anon_sym___attribute__] = ACTIONS(5059),
    [anon_sym_COLON_COLON] = ACTIONS(5061),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5061),
    [anon_sym___declspec] = ACTIONS(5059),
    [anon_sym___based] = ACTIONS(5059),
    [anon_sym_signed] = ACTIONS(5059),
    [anon_sym_unsigned] = ACTIONS(5059),
    [anon_sym_long] = ACTIONS(5059),
    [anon_sym_short] = ACTIONS(5059),
    [anon_sym_LBRACK] = ACTIONS(5059),
    [anon_sym_static] = ACTIONS(5059),
    [anon_sym_register] = ACTIONS(5059),
    [anon_sym_inline] = ACTIONS(5059),
    [anon_sym___inline] = ACTIONS(5059),
    [anon_sym___inline__] = ACTIONS(5059),
    [anon_sym___forceinline] = ACTIONS(5059),
    [anon_sym_thread_local] = ACTIONS(5059),
    [anon_sym___thread] = ACTIONS(5059),
    [anon_sym_const] = ACTIONS(5059),
    [anon_sym_constexpr] = ACTIONS(5059),
    [anon_sym_volatile] = ACTIONS(5059),
    [anon_sym_restrict] = ACTIONS(5059),
    [anon_sym___restrict__] = ACTIONS(5059),
    [anon_sym__Atomic] = ACTIONS(5059),
    [anon_sym__Noreturn] = ACTIONS(5059),
    [anon_sym_noreturn] = ACTIONS(5059),
    [anon_sym_mutable] = ACTIONS(5059),
    [anon_sym_constinit] = ACTIONS(5059),
    [anon_sym_consteval] = ACTIONS(5059),
    [anon_sym___shared__] = ACTIONS(5059),
    [anon_sym___local__] = ACTIONS(5059),
    [anon_sym___constant__] = ACTIONS(5059),
    [anon_sym___managed__] = ACTIONS(5059),
    [anon_sym___grid_constant__] = ACTIONS(5059),
    [anon_sym_alignas] = ACTIONS(5059),
    [anon_sym__Alignas] = ACTIONS(5059),
    [sym_primitive_type] = ACTIONS(5059),
    [anon_sym_enum] = ACTIONS(5059),
    [anon_sym_class] = ACTIONS(5059),
    [anon_sym_struct] = ACTIONS(5059),
    [anon_sym_union] = ACTIONS(5059),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5059),
    [anon_sym_decltype] = ACTIONS(5059),
    [sym_virtual] = ACTIONS(5059),
    [anon_sym_explicit] = ACTIONS(5059),
    [anon_sym_typename] = ACTIONS(5059),
    [anon_sym_template] = ACTIONS(5059),
    [anon_sym_operator] = ACTIONS(5059),
    [anon_sym_friend] = ACTIONS(5059),
    [anon_sym_public] = ACTIONS(5059),
    [anon_sym_private] = ACTIONS(5059),
    [anon_sym_protected] = ACTIONS(5059),
    [anon_sym_using] = ACTIONS(5059),
    [anon_sym_static_assert] = ACTIONS(5059),
    [anon_sym___launch_bounds__] = ACTIONS(5059),
  },
  [1748] = {
    [sym_identifier] = ACTIONS(5063),
    [aux_sym_preproc_def_token1] = ACTIONS(5063),
    [aux_sym_preproc_if_token1] = ACTIONS(5063),
    [aux_sym_preproc_if_token2] = ACTIONS(5063),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5063),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5063),
    [aux_sym_preproc_else_token1] = ACTIONS(5063),
    [aux_sym_preproc_elif_token1] = ACTIONS(5063),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5063),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5063),
    [sym_preproc_directive] = ACTIONS(5063),
    [anon_sym_LPAREN2] = ACTIONS(5065),
    [anon_sym_TILDE] = ACTIONS(5065),
    [anon_sym_STAR] = ACTIONS(5065),
    [anon_sym_AMP_AMP] = ACTIONS(5065),
    [anon_sym_AMP] = ACTIONS(5063),
    [anon_sym___extension__] = ACTIONS(5063),
    [anon_sym_typedef] = ACTIONS(5063),
    [anon_sym___device__] = ACTIONS(5063),
    [anon_sym___host__] = ACTIONS(5063),
    [anon_sym___global__] = ACTIONS(5063),
    [anon_sym___forceinline__] = ACTIONS(5063),
    [anon_sym___noinline__] = ACTIONS(5063),
    [anon_sym_extern] = ACTIONS(5063),
    [anon_sym___attribute__] = ACTIONS(5063),
    [anon_sym_COLON_COLON] = ACTIONS(5065),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5065),
    [anon_sym___declspec] = ACTIONS(5063),
    [anon_sym___based] = ACTIONS(5063),
    [anon_sym_signed] = ACTIONS(5063),
    [anon_sym_unsigned] = ACTIONS(5063),
    [anon_sym_long] = ACTIONS(5063),
    [anon_sym_short] = ACTIONS(5063),
    [anon_sym_LBRACK] = ACTIONS(5063),
    [anon_sym_static] = ACTIONS(5063),
    [anon_sym_register] = ACTIONS(5063),
    [anon_sym_inline] = ACTIONS(5063),
    [anon_sym___inline] = ACTIONS(5063),
    [anon_sym___inline__] = ACTIONS(5063),
    [anon_sym___forceinline] = ACTIONS(5063),
    [anon_sym_thread_local] = ACTIONS(5063),
    [anon_sym___thread] = ACTIONS(5063),
    [anon_sym_const] = ACTIONS(5063),
    [anon_sym_constexpr] = ACTIONS(5063),
    [anon_sym_volatile] = ACTIONS(5063),
    [anon_sym_restrict] = ACTIONS(5063),
    [anon_sym___restrict__] = ACTIONS(5063),
    [anon_sym__Atomic] = ACTIONS(5063),
    [anon_sym__Noreturn] = ACTIONS(5063),
    [anon_sym_noreturn] = ACTIONS(5063),
    [anon_sym_mutable] = ACTIONS(5063),
    [anon_sym_constinit] = ACTIONS(5063),
    [anon_sym_consteval] = ACTIONS(5063),
    [anon_sym___shared__] = ACTIONS(5063),
    [anon_sym___local__] = ACTIONS(5063),
    [anon_sym___constant__] = ACTIONS(5063),
    [anon_sym___managed__] = ACTIONS(5063),
    [anon_sym___grid_constant__] = ACTIONS(5063),
    [anon_sym_alignas] = ACTIONS(5063),
    [anon_sym__Alignas] = ACTIONS(5063),
    [sym_primitive_type] = ACTIONS(5063),
    [anon_sym_enum] = ACTIONS(5063),
    [anon_sym_class] = ACTIONS(5063),
    [anon_sym_struct] = ACTIONS(5063),
    [anon_sym_union] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5063),
    [anon_sym_decltype] = ACTIONS(5063),
    [sym_virtual] = ACTIONS(5063),
    [anon_sym_explicit] = ACTIONS(5063),
    [anon_sym_typename] = ACTIONS(5063),
    [anon_sym_template] = ACTIONS(5063),
    [anon_sym_operator] = ACTIONS(5063),
    [anon_sym_friend] = ACTIONS(5063),
    [anon_sym_public] = ACTIONS(5063),
    [anon_sym_private] = ACTIONS(5063),
    [anon_sym_protected] = ACTIONS(5063),
    [anon_sym_using] = ACTIONS(5063),
    [anon_sym_static_assert] = ACTIONS(5063),
    [anon_sym___launch_bounds__] = ACTIONS(5063),
  },
  [1749] = {
    [sym_identifier] = ACTIONS(5067),
    [aux_sym_preproc_def_token1] = ACTIONS(5067),
    [aux_sym_preproc_if_token1] = ACTIONS(5067),
    [aux_sym_preproc_if_token2] = ACTIONS(5067),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5067),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5067),
    [aux_sym_preproc_else_token1] = ACTIONS(5067),
    [aux_sym_preproc_elif_token1] = ACTIONS(5067),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5067),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5067),
    [sym_preproc_directive] = ACTIONS(5067),
    [anon_sym_LPAREN2] = ACTIONS(5069),
    [anon_sym_TILDE] = ACTIONS(5069),
    [anon_sym_STAR] = ACTIONS(5069),
    [anon_sym_AMP_AMP] = ACTIONS(5069),
    [anon_sym_AMP] = ACTIONS(5067),
    [anon_sym___extension__] = ACTIONS(5067),
    [anon_sym_typedef] = ACTIONS(5067),
    [anon_sym___device__] = ACTIONS(5067),
    [anon_sym___host__] = ACTIONS(5067),
    [anon_sym___global__] = ACTIONS(5067),
    [anon_sym___forceinline__] = ACTIONS(5067),
    [anon_sym___noinline__] = ACTIONS(5067),
    [anon_sym_extern] = ACTIONS(5067),
    [anon_sym___attribute__] = ACTIONS(5067),
    [anon_sym_COLON_COLON] = ACTIONS(5069),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5069),
    [anon_sym___declspec] = ACTIONS(5067),
    [anon_sym___based] = ACTIONS(5067),
    [anon_sym_signed] = ACTIONS(5067),
    [anon_sym_unsigned] = ACTIONS(5067),
    [anon_sym_long] = ACTIONS(5067),
    [anon_sym_short] = ACTIONS(5067),
    [anon_sym_LBRACK] = ACTIONS(5067),
    [anon_sym_static] = ACTIONS(5067),
    [anon_sym_register] = ACTIONS(5067),
    [anon_sym_inline] = ACTIONS(5067),
    [anon_sym___inline] = ACTIONS(5067),
    [anon_sym___inline__] = ACTIONS(5067),
    [anon_sym___forceinline] = ACTIONS(5067),
    [anon_sym_thread_local] = ACTIONS(5067),
    [anon_sym___thread] = ACTIONS(5067),
    [anon_sym_const] = ACTIONS(5067),
    [anon_sym_constexpr] = ACTIONS(5067),
    [anon_sym_volatile] = ACTIONS(5067),
    [anon_sym_restrict] = ACTIONS(5067),
    [anon_sym___restrict__] = ACTIONS(5067),
    [anon_sym__Atomic] = ACTIONS(5067),
    [anon_sym__Noreturn] = ACTIONS(5067),
    [anon_sym_noreturn] = ACTIONS(5067),
    [anon_sym_mutable] = ACTIONS(5067),
    [anon_sym_constinit] = ACTIONS(5067),
    [anon_sym_consteval] = ACTIONS(5067),
    [anon_sym___shared__] = ACTIONS(5067),
    [anon_sym___local__] = ACTIONS(5067),
    [anon_sym___constant__] = ACTIONS(5067),
    [anon_sym___managed__] = ACTIONS(5067),
    [anon_sym___grid_constant__] = ACTIONS(5067),
    [anon_sym_alignas] = ACTIONS(5067),
    [anon_sym__Alignas] = ACTIONS(5067),
    [sym_primitive_type] = ACTIONS(5067),
    [anon_sym_enum] = ACTIONS(5067),
    [anon_sym_class] = ACTIONS(5067),
    [anon_sym_struct] = ACTIONS(5067),
    [anon_sym_union] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5067),
    [anon_sym_decltype] = ACTIONS(5067),
    [sym_virtual] = ACTIONS(5067),
    [anon_sym_explicit] = ACTIONS(5067),
    [anon_sym_typename] = ACTIONS(5067),
    [anon_sym_template] = ACTIONS(5067),
    [anon_sym_operator] = ACTIONS(5067),
    [anon_sym_friend] = ACTIONS(5067),
    [anon_sym_public] = ACTIONS(5067),
    [anon_sym_private] = ACTIONS(5067),
    [anon_sym_protected] = ACTIONS(5067),
    [anon_sym_using] = ACTIONS(5067),
    [anon_sym_static_assert] = ACTIONS(5067),
    [anon_sym___launch_bounds__] = ACTIONS(5067),
  },
  [1750] = {
    [sym_identifier] = ACTIONS(5071),
    [aux_sym_preproc_def_token1] = ACTIONS(5071),
    [aux_sym_preproc_if_token1] = ACTIONS(5071),
    [aux_sym_preproc_if_token2] = ACTIONS(5071),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5071),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5071),
    [aux_sym_preproc_else_token1] = ACTIONS(5071),
    [aux_sym_preproc_elif_token1] = ACTIONS(5071),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5071),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5071),
    [sym_preproc_directive] = ACTIONS(5071),
    [anon_sym_LPAREN2] = ACTIONS(5073),
    [anon_sym_TILDE] = ACTIONS(5073),
    [anon_sym_STAR] = ACTIONS(5073),
    [anon_sym_AMP_AMP] = ACTIONS(5073),
    [anon_sym_AMP] = ACTIONS(5071),
    [anon_sym___extension__] = ACTIONS(5071),
    [anon_sym_typedef] = ACTIONS(5071),
    [anon_sym___device__] = ACTIONS(5071),
    [anon_sym___host__] = ACTIONS(5071),
    [anon_sym___global__] = ACTIONS(5071),
    [anon_sym___forceinline__] = ACTIONS(5071),
    [anon_sym___noinline__] = ACTIONS(5071),
    [anon_sym_extern] = ACTIONS(5071),
    [anon_sym___attribute__] = ACTIONS(5071),
    [anon_sym_COLON_COLON] = ACTIONS(5073),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5073),
    [anon_sym___declspec] = ACTIONS(5071),
    [anon_sym___based] = ACTIONS(5071),
    [anon_sym_signed] = ACTIONS(5071),
    [anon_sym_unsigned] = ACTIONS(5071),
    [anon_sym_long] = ACTIONS(5071),
    [anon_sym_short] = ACTIONS(5071),
    [anon_sym_LBRACK] = ACTIONS(5071),
    [anon_sym_static] = ACTIONS(5071),
    [anon_sym_register] = ACTIONS(5071),
    [anon_sym_inline] = ACTIONS(5071),
    [anon_sym___inline] = ACTIONS(5071),
    [anon_sym___inline__] = ACTIONS(5071),
    [anon_sym___forceinline] = ACTIONS(5071),
    [anon_sym_thread_local] = ACTIONS(5071),
    [anon_sym___thread] = ACTIONS(5071),
    [anon_sym_const] = ACTIONS(5071),
    [anon_sym_constexpr] = ACTIONS(5071),
    [anon_sym_volatile] = ACTIONS(5071),
    [anon_sym_restrict] = ACTIONS(5071),
    [anon_sym___restrict__] = ACTIONS(5071),
    [anon_sym__Atomic] = ACTIONS(5071),
    [anon_sym__Noreturn] = ACTIONS(5071),
    [anon_sym_noreturn] = ACTIONS(5071),
    [anon_sym_mutable] = ACTIONS(5071),
    [anon_sym_constinit] = ACTIONS(5071),
    [anon_sym_consteval] = ACTIONS(5071),
    [anon_sym___shared__] = ACTIONS(5071),
    [anon_sym___local__] = ACTIONS(5071),
    [anon_sym___constant__] = ACTIONS(5071),
    [anon_sym___managed__] = ACTIONS(5071),
    [anon_sym___grid_constant__] = ACTIONS(5071),
    [anon_sym_alignas] = ACTIONS(5071),
    [anon_sym__Alignas] = ACTIONS(5071),
    [sym_primitive_type] = ACTIONS(5071),
    [anon_sym_enum] = ACTIONS(5071),
    [anon_sym_class] = ACTIONS(5071),
    [anon_sym_struct] = ACTIONS(5071),
    [anon_sym_union] = ACTIONS(5071),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5071),
    [anon_sym_decltype] = ACTIONS(5071),
    [sym_virtual] = ACTIONS(5071),
    [anon_sym_explicit] = ACTIONS(5071),
    [anon_sym_typename] = ACTIONS(5071),
    [anon_sym_template] = ACTIONS(5071),
    [anon_sym_operator] = ACTIONS(5071),
    [anon_sym_friend] = ACTIONS(5071),
    [anon_sym_public] = ACTIONS(5071),
    [anon_sym_private] = ACTIONS(5071),
    [anon_sym_protected] = ACTIONS(5071),
    [anon_sym_using] = ACTIONS(5071),
    [anon_sym_static_assert] = ACTIONS(5071),
    [anon_sym___launch_bounds__] = ACTIONS(5071),
  },
  [1751] = {
    [sym_identifier] = ACTIONS(2080),
    [aux_sym_preproc_def_token1] = ACTIONS(2080),
    [aux_sym_preproc_if_token1] = ACTIONS(2080),
    [aux_sym_preproc_if_token2] = ACTIONS(2080),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2080),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2080),
    [aux_sym_preproc_else_token1] = ACTIONS(2080),
    [aux_sym_preproc_elif_token1] = ACTIONS(2080),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2080),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2080),
    [sym_preproc_directive] = ACTIONS(2080),
    [anon_sym_LPAREN2] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_STAR] = ACTIONS(2082),
    [anon_sym_AMP_AMP] = ACTIONS(2082),
    [anon_sym_AMP] = ACTIONS(2080),
    [anon_sym___extension__] = ACTIONS(2080),
    [anon_sym_typedef] = ACTIONS(2080),
    [anon_sym___device__] = ACTIONS(2080),
    [anon_sym___host__] = ACTIONS(2080),
    [anon_sym___global__] = ACTIONS(2080),
    [anon_sym___forceinline__] = ACTIONS(2080),
    [anon_sym___noinline__] = ACTIONS(2080),
    [anon_sym_extern] = ACTIONS(2080),
    [anon_sym___attribute__] = ACTIONS(2080),
    [anon_sym_COLON_COLON] = ACTIONS(2082),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2082),
    [anon_sym___declspec] = ACTIONS(2080),
    [anon_sym___based] = ACTIONS(2080),
    [anon_sym_signed] = ACTIONS(2080),
    [anon_sym_unsigned] = ACTIONS(2080),
    [anon_sym_long] = ACTIONS(2080),
    [anon_sym_short] = ACTIONS(2080),
    [anon_sym_LBRACK] = ACTIONS(2080),
    [anon_sym_static] = ACTIONS(2080),
    [anon_sym_register] = ACTIONS(2080),
    [anon_sym_inline] = ACTIONS(2080),
    [anon_sym___inline] = ACTIONS(2080),
    [anon_sym___inline__] = ACTIONS(2080),
    [anon_sym___forceinline] = ACTIONS(2080),
    [anon_sym_thread_local] = ACTIONS(2080),
    [anon_sym___thread] = ACTIONS(2080),
    [anon_sym_const] = ACTIONS(2080),
    [anon_sym_constexpr] = ACTIONS(2080),
    [anon_sym_volatile] = ACTIONS(2080),
    [anon_sym_restrict] = ACTIONS(2080),
    [anon_sym___restrict__] = ACTIONS(2080),
    [anon_sym__Atomic] = ACTIONS(2080),
    [anon_sym__Noreturn] = ACTIONS(2080),
    [anon_sym_noreturn] = ACTIONS(2080),
    [anon_sym_mutable] = ACTIONS(2080),
    [anon_sym_constinit] = ACTIONS(2080),
    [anon_sym_consteval] = ACTIONS(2080),
    [anon_sym___shared__] = ACTIONS(2080),
    [anon_sym___local__] = ACTIONS(2080),
    [anon_sym___constant__] = ACTIONS(2080),
    [anon_sym___managed__] = ACTIONS(2080),
    [anon_sym___grid_constant__] = ACTIONS(2080),
    [anon_sym_alignas] = ACTIONS(2080),
    [anon_sym__Alignas] = ACTIONS(2080),
    [sym_primitive_type] = ACTIONS(2080),
    [anon_sym_enum] = ACTIONS(2080),
    [anon_sym_class] = ACTIONS(2080),
    [anon_sym_struct] = ACTIONS(2080),
    [anon_sym_union] = ACTIONS(2080),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2080),
    [anon_sym_decltype] = ACTIONS(2080),
    [sym_virtual] = ACTIONS(2080),
    [anon_sym_explicit] = ACTIONS(2080),
    [anon_sym_typename] = ACTIONS(2080),
    [anon_sym_template] = ACTIONS(2080),
    [anon_sym_operator] = ACTIONS(2080),
    [anon_sym_friend] = ACTIONS(2080),
    [anon_sym_public] = ACTIONS(2080),
    [anon_sym_private] = ACTIONS(2080),
    [anon_sym_protected] = ACTIONS(2080),
    [anon_sym_using] = ACTIONS(2080),
    [anon_sym_static_assert] = ACTIONS(2080),
    [anon_sym___launch_bounds__] = ACTIONS(2080),
  },
  [1752] = {
    [sym_identifier] = ACTIONS(2409),
    [aux_sym_preproc_def_token1] = ACTIONS(2409),
    [aux_sym_preproc_if_token1] = ACTIONS(2409),
    [aux_sym_preproc_if_token2] = ACTIONS(2409),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2409),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2409),
    [aux_sym_preproc_else_token1] = ACTIONS(2409),
    [aux_sym_preproc_elif_token1] = ACTIONS(2409),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2409),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2409),
    [sym_preproc_directive] = ACTIONS(2409),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2409),
    [anon_sym___extension__] = ACTIONS(2409),
    [anon_sym_typedef] = ACTIONS(2409),
    [anon_sym___device__] = ACTIONS(2409),
    [anon_sym___host__] = ACTIONS(2409),
    [anon_sym___global__] = ACTIONS(2409),
    [anon_sym___forceinline__] = ACTIONS(2409),
    [anon_sym___noinline__] = ACTIONS(2409),
    [anon_sym_extern] = ACTIONS(2409),
    [anon_sym___attribute__] = ACTIONS(2409),
    [anon_sym_COLON_COLON] = ACTIONS(2411),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2411),
    [anon_sym___declspec] = ACTIONS(2409),
    [anon_sym___based] = ACTIONS(2409),
    [anon_sym_signed] = ACTIONS(2409),
    [anon_sym_unsigned] = ACTIONS(2409),
    [anon_sym_long] = ACTIONS(2409),
    [anon_sym_short] = ACTIONS(2409),
    [anon_sym_LBRACK] = ACTIONS(2409),
    [anon_sym_static] = ACTIONS(2409),
    [anon_sym_register] = ACTIONS(2409),
    [anon_sym_inline] = ACTIONS(2409),
    [anon_sym___inline] = ACTIONS(2409),
    [anon_sym___inline__] = ACTIONS(2409),
    [anon_sym___forceinline] = ACTIONS(2409),
    [anon_sym_thread_local] = ACTIONS(2409),
    [anon_sym___thread] = ACTIONS(2409),
    [anon_sym_const] = ACTIONS(2409),
    [anon_sym_constexpr] = ACTIONS(2409),
    [anon_sym_volatile] = ACTIONS(2409),
    [anon_sym_restrict] = ACTIONS(2409),
    [anon_sym___restrict__] = ACTIONS(2409),
    [anon_sym__Atomic] = ACTIONS(2409),
    [anon_sym__Noreturn] = ACTIONS(2409),
    [anon_sym_noreturn] = ACTIONS(2409),
    [anon_sym_mutable] = ACTIONS(2409),
    [anon_sym_constinit] = ACTIONS(2409),
    [anon_sym_consteval] = ACTIONS(2409),
    [anon_sym___shared__] = ACTIONS(2409),
    [anon_sym___local__] = ACTIONS(2409),
    [anon_sym___constant__] = ACTIONS(2409),
    [anon_sym___managed__] = ACTIONS(2409),
    [anon_sym___grid_constant__] = ACTIONS(2409),
    [anon_sym_alignas] = ACTIONS(2409),
    [anon_sym__Alignas] = ACTIONS(2409),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2409),
    [anon_sym_class] = ACTIONS(2409),
    [anon_sym_struct] = ACTIONS(2409),
    [anon_sym_union] = ACTIONS(2409),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2409),
    [anon_sym_decltype] = ACTIONS(2409),
    [sym_virtual] = ACTIONS(2409),
    [anon_sym_explicit] = ACTIONS(2409),
    [anon_sym_typename] = ACTIONS(2409),
    [anon_sym_template] = ACTIONS(2409),
    [anon_sym_operator] = ACTIONS(2409),
    [anon_sym_friend] = ACTIONS(2409),
    [anon_sym_public] = ACTIONS(2409),
    [anon_sym_private] = ACTIONS(2409),
    [anon_sym_protected] = ACTIONS(2409),
    [anon_sym_using] = ACTIONS(2409),
    [anon_sym_static_assert] = ACTIONS(2409),
    [anon_sym___launch_bounds__] = ACTIONS(2409),
  },
  [1753] = {
    [sym_identifier] = ACTIONS(2477),
    [aux_sym_preproc_def_token1] = ACTIONS(2477),
    [aux_sym_preproc_if_token1] = ACTIONS(2477),
    [aux_sym_preproc_if_token2] = ACTIONS(2477),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2477),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2477),
    [aux_sym_preproc_else_token1] = ACTIONS(2477),
    [aux_sym_preproc_elif_token1] = ACTIONS(2477),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2477),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2477),
    [sym_preproc_directive] = ACTIONS(2477),
    [anon_sym_LPAREN2] = ACTIONS(2479),
    [anon_sym_TILDE] = ACTIONS(2479),
    [anon_sym_STAR] = ACTIONS(2479),
    [anon_sym_AMP_AMP] = ACTIONS(2479),
    [anon_sym_AMP] = ACTIONS(2477),
    [anon_sym___extension__] = ACTIONS(2477),
    [anon_sym_typedef] = ACTIONS(2477),
    [anon_sym___device__] = ACTIONS(2477),
    [anon_sym___host__] = ACTIONS(2477),
    [anon_sym___global__] = ACTIONS(2477),
    [anon_sym___forceinline__] = ACTIONS(2477),
    [anon_sym___noinline__] = ACTIONS(2477),
    [anon_sym_extern] = ACTIONS(2477),
    [anon_sym___attribute__] = ACTIONS(2477),
    [anon_sym_COLON_COLON] = ACTIONS(2479),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2479),
    [anon_sym___declspec] = ACTIONS(2477),
    [anon_sym___based] = ACTIONS(2477),
    [anon_sym_signed] = ACTIONS(2477),
    [anon_sym_unsigned] = ACTIONS(2477),
    [anon_sym_long] = ACTIONS(2477),
    [anon_sym_short] = ACTIONS(2477),
    [anon_sym_LBRACK] = ACTIONS(2477),
    [anon_sym_static] = ACTIONS(2477),
    [anon_sym_register] = ACTIONS(2477),
    [anon_sym_inline] = ACTIONS(2477),
    [anon_sym___inline] = ACTIONS(2477),
    [anon_sym___inline__] = ACTIONS(2477),
    [anon_sym___forceinline] = ACTIONS(2477),
    [anon_sym_thread_local] = ACTIONS(2477),
    [anon_sym___thread] = ACTIONS(2477),
    [anon_sym_const] = ACTIONS(2477),
    [anon_sym_constexpr] = ACTIONS(2477),
    [anon_sym_volatile] = ACTIONS(2477),
    [anon_sym_restrict] = ACTIONS(2477),
    [anon_sym___restrict__] = ACTIONS(2477),
    [anon_sym__Atomic] = ACTIONS(2477),
    [anon_sym__Noreturn] = ACTIONS(2477),
    [anon_sym_noreturn] = ACTIONS(2477),
    [anon_sym_mutable] = ACTIONS(2477),
    [anon_sym_constinit] = ACTIONS(2477),
    [anon_sym_consteval] = ACTIONS(2477),
    [anon_sym___shared__] = ACTIONS(2477),
    [anon_sym___local__] = ACTIONS(2477),
    [anon_sym___constant__] = ACTIONS(2477),
    [anon_sym___managed__] = ACTIONS(2477),
    [anon_sym___grid_constant__] = ACTIONS(2477),
    [anon_sym_alignas] = ACTIONS(2477),
    [anon_sym__Alignas] = ACTIONS(2477),
    [sym_primitive_type] = ACTIONS(2477),
    [anon_sym_enum] = ACTIONS(2477),
    [anon_sym_class] = ACTIONS(2477),
    [anon_sym_struct] = ACTIONS(2477),
    [anon_sym_union] = ACTIONS(2477),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2477),
    [anon_sym_decltype] = ACTIONS(2477),
    [sym_virtual] = ACTIONS(2477),
    [anon_sym_explicit] = ACTIONS(2477),
    [anon_sym_typename] = ACTIONS(2477),
    [anon_sym_template] = ACTIONS(2477),
    [anon_sym_operator] = ACTIONS(2477),
    [anon_sym_friend] = ACTIONS(2477),
    [anon_sym_public] = ACTIONS(2477),
    [anon_sym_private] = ACTIONS(2477),
    [anon_sym_protected] = ACTIONS(2477),
    [anon_sym_using] = ACTIONS(2477),
    [anon_sym_static_assert] = ACTIONS(2477),
    [anon_sym___launch_bounds__] = ACTIONS(2477),
  },
  [1754] = {
    [sym_identifier] = ACTIONS(2259),
    [aux_sym_preproc_def_token1] = ACTIONS(2259),
    [aux_sym_preproc_if_token1] = ACTIONS(2259),
    [aux_sym_preproc_if_token2] = ACTIONS(2259),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2259),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2259),
    [aux_sym_preproc_else_token1] = ACTIONS(2259),
    [aux_sym_preproc_elif_token1] = ACTIONS(2259),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2259),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2259),
    [sym_preproc_directive] = ACTIONS(2259),
    [anon_sym_LPAREN2] = ACTIONS(2261),
    [anon_sym_TILDE] = ACTIONS(2261),
    [anon_sym_STAR] = ACTIONS(2261),
    [anon_sym_AMP_AMP] = ACTIONS(2261),
    [anon_sym_AMP] = ACTIONS(2259),
    [anon_sym___extension__] = ACTIONS(2259),
    [anon_sym_typedef] = ACTIONS(2259),
    [anon_sym___device__] = ACTIONS(2259),
    [anon_sym___host__] = ACTIONS(2259),
    [anon_sym___global__] = ACTIONS(2259),
    [anon_sym___forceinline__] = ACTIONS(2259),
    [anon_sym___noinline__] = ACTIONS(2259),
    [anon_sym_extern] = ACTIONS(2259),
    [anon_sym___attribute__] = ACTIONS(2259),
    [anon_sym_COLON_COLON] = ACTIONS(2261),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2261),
    [anon_sym___declspec] = ACTIONS(2259),
    [anon_sym___based] = ACTIONS(2259),
    [anon_sym_signed] = ACTIONS(2259),
    [anon_sym_unsigned] = ACTIONS(2259),
    [anon_sym_long] = ACTIONS(2259),
    [anon_sym_short] = ACTIONS(2259),
    [anon_sym_LBRACK] = ACTIONS(2259),
    [anon_sym_static] = ACTIONS(2259),
    [anon_sym_register] = ACTIONS(2259),
    [anon_sym_inline] = ACTIONS(2259),
    [anon_sym___inline] = ACTIONS(2259),
    [anon_sym___inline__] = ACTIONS(2259),
    [anon_sym___forceinline] = ACTIONS(2259),
    [anon_sym_thread_local] = ACTIONS(2259),
    [anon_sym___thread] = ACTIONS(2259),
    [anon_sym_const] = ACTIONS(2259),
    [anon_sym_constexpr] = ACTIONS(2259),
    [anon_sym_volatile] = ACTIONS(2259),
    [anon_sym_restrict] = ACTIONS(2259),
    [anon_sym___restrict__] = ACTIONS(2259),
    [anon_sym__Atomic] = ACTIONS(2259),
    [anon_sym__Noreturn] = ACTIONS(2259),
    [anon_sym_noreturn] = ACTIONS(2259),
    [anon_sym_mutable] = ACTIONS(2259),
    [anon_sym_constinit] = ACTIONS(2259),
    [anon_sym_consteval] = ACTIONS(2259),
    [anon_sym___shared__] = ACTIONS(2259),
    [anon_sym___local__] = ACTIONS(2259),
    [anon_sym___constant__] = ACTIONS(2259),
    [anon_sym___managed__] = ACTIONS(2259),
    [anon_sym___grid_constant__] = ACTIONS(2259),
    [anon_sym_alignas] = ACTIONS(2259),
    [anon_sym__Alignas] = ACTIONS(2259),
    [sym_primitive_type] = ACTIONS(2259),
    [anon_sym_enum] = ACTIONS(2259),
    [anon_sym_class] = ACTIONS(2259),
    [anon_sym_struct] = ACTIONS(2259),
    [anon_sym_union] = ACTIONS(2259),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2259),
    [anon_sym_decltype] = ACTIONS(2259),
    [sym_virtual] = ACTIONS(2259),
    [anon_sym_explicit] = ACTIONS(2259),
    [anon_sym_typename] = ACTIONS(2259),
    [anon_sym_template] = ACTIONS(2259),
    [anon_sym_operator] = ACTIONS(2259),
    [anon_sym_friend] = ACTIONS(2259),
    [anon_sym_public] = ACTIONS(2259),
    [anon_sym_private] = ACTIONS(2259),
    [anon_sym_protected] = ACTIONS(2259),
    [anon_sym_using] = ACTIONS(2259),
    [anon_sym_static_assert] = ACTIONS(2259),
    [anon_sym___launch_bounds__] = ACTIONS(2259),
  },
  [1755] = {
    [sym_identifier] = ACTIONS(5075),
    [aux_sym_preproc_def_token1] = ACTIONS(5075),
    [aux_sym_preproc_if_token1] = ACTIONS(5075),
    [aux_sym_preproc_if_token2] = ACTIONS(5075),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5075),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5075),
    [aux_sym_preproc_else_token1] = ACTIONS(5075),
    [aux_sym_preproc_elif_token1] = ACTIONS(5075),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5075),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5075),
    [sym_preproc_directive] = ACTIONS(5075),
    [anon_sym_LPAREN2] = ACTIONS(5077),
    [anon_sym_TILDE] = ACTIONS(5077),
    [anon_sym_STAR] = ACTIONS(5077),
    [anon_sym_AMP_AMP] = ACTIONS(5077),
    [anon_sym_AMP] = ACTIONS(5075),
    [anon_sym___extension__] = ACTIONS(5075),
    [anon_sym_typedef] = ACTIONS(5075),
    [anon_sym___device__] = ACTIONS(5075),
    [anon_sym___host__] = ACTIONS(5075),
    [anon_sym___global__] = ACTIONS(5075),
    [anon_sym___forceinline__] = ACTIONS(5075),
    [anon_sym___noinline__] = ACTIONS(5075),
    [anon_sym_extern] = ACTIONS(5075),
    [anon_sym___attribute__] = ACTIONS(5075),
    [anon_sym_COLON_COLON] = ACTIONS(5077),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5077),
    [anon_sym___declspec] = ACTIONS(5075),
    [anon_sym___based] = ACTIONS(5075),
    [anon_sym_signed] = ACTIONS(5075),
    [anon_sym_unsigned] = ACTIONS(5075),
    [anon_sym_long] = ACTIONS(5075),
    [anon_sym_short] = ACTIONS(5075),
    [anon_sym_LBRACK] = ACTIONS(5075),
    [anon_sym_static] = ACTIONS(5075),
    [anon_sym_register] = ACTIONS(5075),
    [anon_sym_inline] = ACTIONS(5075),
    [anon_sym___inline] = ACTIONS(5075),
    [anon_sym___inline__] = ACTIONS(5075),
    [anon_sym___forceinline] = ACTIONS(5075),
    [anon_sym_thread_local] = ACTIONS(5075),
    [anon_sym___thread] = ACTIONS(5075),
    [anon_sym_const] = ACTIONS(5075),
    [anon_sym_constexpr] = ACTIONS(5075),
    [anon_sym_volatile] = ACTIONS(5075),
    [anon_sym_restrict] = ACTIONS(5075),
    [anon_sym___restrict__] = ACTIONS(5075),
    [anon_sym__Atomic] = ACTIONS(5075),
    [anon_sym__Noreturn] = ACTIONS(5075),
    [anon_sym_noreturn] = ACTIONS(5075),
    [anon_sym_mutable] = ACTIONS(5075),
    [anon_sym_constinit] = ACTIONS(5075),
    [anon_sym_consteval] = ACTIONS(5075),
    [anon_sym___shared__] = ACTIONS(5075),
    [anon_sym___local__] = ACTIONS(5075),
    [anon_sym___constant__] = ACTIONS(5075),
    [anon_sym___managed__] = ACTIONS(5075),
    [anon_sym___grid_constant__] = ACTIONS(5075),
    [anon_sym_alignas] = ACTIONS(5075),
    [anon_sym__Alignas] = ACTIONS(5075),
    [sym_primitive_type] = ACTIONS(5075),
    [anon_sym_enum] = ACTIONS(5075),
    [anon_sym_class] = ACTIONS(5075),
    [anon_sym_struct] = ACTIONS(5075),
    [anon_sym_union] = ACTIONS(5075),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5075),
    [anon_sym_decltype] = ACTIONS(5075),
    [sym_virtual] = ACTIONS(5075),
    [anon_sym_explicit] = ACTIONS(5075),
    [anon_sym_typename] = ACTIONS(5075),
    [anon_sym_template] = ACTIONS(5075),
    [anon_sym_operator] = ACTIONS(5075),
    [anon_sym_friend] = ACTIONS(5075),
    [anon_sym_public] = ACTIONS(5075),
    [anon_sym_private] = ACTIONS(5075),
    [anon_sym_protected] = ACTIONS(5075),
    [anon_sym_using] = ACTIONS(5075),
    [anon_sym_static_assert] = ACTIONS(5075),
    [anon_sym___launch_bounds__] = ACTIONS(5075),
  },
  [1756] = {
    [sym_identifier] = ACTIONS(5079),
    [aux_sym_preproc_def_token1] = ACTIONS(5079),
    [aux_sym_preproc_if_token1] = ACTIONS(5079),
    [aux_sym_preproc_if_token2] = ACTIONS(5079),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5079),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5079),
    [aux_sym_preproc_else_token1] = ACTIONS(5079),
    [aux_sym_preproc_elif_token1] = ACTIONS(5079),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5079),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5079),
    [sym_preproc_directive] = ACTIONS(5079),
    [anon_sym_LPAREN2] = ACTIONS(5081),
    [anon_sym_TILDE] = ACTIONS(5081),
    [anon_sym_STAR] = ACTIONS(5081),
    [anon_sym_AMP_AMP] = ACTIONS(5081),
    [anon_sym_AMP] = ACTIONS(5079),
    [anon_sym___extension__] = ACTIONS(5079),
    [anon_sym_typedef] = ACTIONS(5079),
    [anon_sym___device__] = ACTIONS(5079),
    [anon_sym___host__] = ACTIONS(5079),
    [anon_sym___global__] = ACTIONS(5079),
    [anon_sym___forceinline__] = ACTIONS(5079),
    [anon_sym___noinline__] = ACTIONS(5079),
    [anon_sym_extern] = ACTIONS(5079),
    [anon_sym___attribute__] = ACTIONS(5079),
    [anon_sym_COLON_COLON] = ACTIONS(5081),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5081),
    [anon_sym___declspec] = ACTIONS(5079),
    [anon_sym___based] = ACTIONS(5079),
    [anon_sym_signed] = ACTIONS(5079),
    [anon_sym_unsigned] = ACTIONS(5079),
    [anon_sym_long] = ACTIONS(5079),
    [anon_sym_short] = ACTIONS(5079),
    [anon_sym_LBRACK] = ACTIONS(5079),
    [anon_sym_static] = ACTIONS(5079),
    [anon_sym_register] = ACTIONS(5079),
    [anon_sym_inline] = ACTIONS(5079),
    [anon_sym___inline] = ACTIONS(5079),
    [anon_sym___inline__] = ACTIONS(5079),
    [anon_sym___forceinline] = ACTIONS(5079),
    [anon_sym_thread_local] = ACTIONS(5079),
    [anon_sym___thread] = ACTIONS(5079),
    [anon_sym_const] = ACTIONS(5079),
    [anon_sym_constexpr] = ACTIONS(5079),
    [anon_sym_volatile] = ACTIONS(5079),
    [anon_sym_restrict] = ACTIONS(5079),
    [anon_sym___restrict__] = ACTIONS(5079),
    [anon_sym__Atomic] = ACTIONS(5079),
    [anon_sym__Noreturn] = ACTIONS(5079),
    [anon_sym_noreturn] = ACTIONS(5079),
    [anon_sym_mutable] = ACTIONS(5079),
    [anon_sym_constinit] = ACTIONS(5079),
    [anon_sym_consteval] = ACTIONS(5079),
    [anon_sym___shared__] = ACTIONS(5079),
    [anon_sym___local__] = ACTIONS(5079),
    [anon_sym___constant__] = ACTIONS(5079),
    [anon_sym___managed__] = ACTIONS(5079),
    [anon_sym___grid_constant__] = ACTIONS(5079),
    [anon_sym_alignas] = ACTIONS(5079),
    [anon_sym__Alignas] = ACTIONS(5079),
    [sym_primitive_type] = ACTIONS(5079),
    [anon_sym_enum] = ACTIONS(5079),
    [anon_sym_class] = ACTIONS(5079),
    [anon_sym_struct] = ACTIONS(5079),
    [anon_sym_union] = ACTIONS(5079),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5079),
    [anon_sym_decltype] = ACTIONS(5079),
    [sym_virtual] = ACTIONS(5079),
    [anon_sym_explicit] = ACTIONS(5079),
    [anon_sym_typename] = ACTIONS(5079),
    [anon_sym_template] = ACTIONS(5079),
    [anon_sym_operator] = ACTIONS(5079),
    [anon_sym_friend] = ACTIONS(5079),
    [anon_sym_public] = ACTIONS(5079),
    [anon_sym_private] = ACTIONS(5079),
    [anon_sym_protected] = ACTIONS(5079),
    [anon_sym_using] = ACTIONS(5079),
    [anon_sym_static_assert] = ACTIONS(5079),
    [anon_sym___launch_bounds__] = ACTIONS(5079),
  },
  [1757] = {
    [sym_identifier] = ACTIONS(2239),
    [aux_sym_preproc_def_token1] = ACTIONS(2239),
    [aux_sym_preproc_if_token1] = ACTIONS(2239),
    [aux_sym_preproc_if_token2] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2239),
    [aux_sym_preproc_else_token1] = ACTIONS(2239),
    [aux_sym_preproc_elif_token1] = ACTIONS(2239),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2239),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2239),
    [sym_preproc_directive] = ACTIONS(2239),
    [anon_sym_LPAREN2] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym___extension__] = ACTIONS(2239),
    [anon_sym_typedef] = ACTIONS(2239),
    [anon_sym___device__] = ACTIONS(2239),
    [anon_sym___host__] = ACTIONS(2239),
    [anon_sym___global__] = ACTIONS(2239),
    [anon_sym___forceinline__] = ACTIONS(2239),
    [anon_sym___noinline__] = ACTIONS(2239),
    [anon_sym_extern] = ACTIONS(2239),
    [anon_sym___attribute__] = ACTIONS(2239),
    [anon_sym_COLON_COLON] = ACTIONS(2241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2241),
    [anon_sym___declspec] = ACTIONS(2239),
    [anon_sym___based] = ACTIONS(2239),
    [anon_sym_signed] = ACTIONS(2239),
    [anon_sym_unsigned] = ACTIONS(2239),
    [anon_sym_long] = ACTIONS(2239),
    [anon_sym_short] = ACTIONS(2239),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_static] = ACTIONS(2239),
    [anon_sym_register] = ACTIONS(2239),
    [anon_sym_inline] = ACTIONS(2239),
    [anon_sym___inline] = ACTIONS(2239),
    [anon_sym___inline__] = ACTIONS(2239),
    [anon_sym___forceinline] = ACTIONS(2239),
    [anon_sym_thread_local] = ACTIONS(2239),
    [anon_sym___thread] = ACTIONS(2239),
    [anon_sym_const] = ACTIONS(2239),
    [anon_sym_constexpr] = ACTIONS(2239),
    [anon_sym_volatile] = ACTIONS(2239),
    [anon_sym_restrict] = ACTIONS(2239),
    [anon_sym___restrict__] = ACTIONS(2239),
    [anon_sym__Atomic] = ACTIONS(2239),
    [anon_sym__Noreturn] = ACTIONS(2239),
    [anon_sym_noreturn] = ACTIONS(2239),
    [anon_sym_mutable] = ACTIONS(2239),
    [anon_sym_constinit] = ACTIONS(2239),
    [anon_sym_consteval] = ACTIONS(2239),
    [anon_sym___shared__] = ACTIONS(2239),
    [anon_sym___local__] = ACTIONS(2239),
    [anon_sym___constant__] = ACTIONS(2239),
    [anon_sym___managed__] = ACTIONS(2239),
    [anon_sym___grid_constant__] = ACTIONS(2239),
    [anon_sym_alignas] = ACTIONS(2239),
    [anon_sym__Alignas] = ACTIONS(2239),
    [sym_primitive_type] = ACTIONS(2239),
    [anon_sym_enum] = ACTIONS(2239),
    [anon_sym_class] = ACTIONS(2239),
    [anon_sym_struct] = ACTIONS(2239),
    [anon_sym_union] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2239),
    [anon_sym_decltype] = ACTIONS(2239),
    [sym_virtual] = ACTIONS(2239),
    [anon_sym_explicit] = ACTIONS(2239),
    [anon_sym_typename] = ACTIONS(2239),
    [anon_sym_template] = ACTIONS(2239),
    [anon_sym_operator] = ACTIONS(2239),
    [anon_sym_friend] = ACTIONS(2239),
    [anon_sym_public] = ACTIONS(2239),
    [anon_sym_private] = ACTIONS(2239),
    [anon_sym_protected] = ACTIONS(2239),
    [anon_sym_using] = ACTIONS(2239),
    [anon_sym_static_assert] = ACTIONS(2239),
    [anon_sym___launch_bounds__] = ACTIONS(2239),
  },
  [1758] = {
    [sym_identifier] = ACTIONS(5083),
    [aux_sym_preproc_def_token1] = ACTIONS(5083),
    [aux_sym_preproc_if_token1] = ACTIONS(5083),
    [aux_sym_preproc_if_token2] = ACTIONS(5083),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5083),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5083),
    [aux_sym_preproc_else_token1] = ACTIONS(5083),
    [aux_sym_preproc_elif_token1] = ACTIONS(5083),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5083),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5083),
    [sym_preproc_directive] = ACTIONS(5083),
    [anon_sym_LPAREN2] = ACTIONS(5085),
    [anon_sym_TILDE] = ACTIONS(5085),
    [anon_sym_STAR] = ACTIONS(5085),
    [anon_sym_AMP_AMP] = ACTIONS(5085),
    [anon_sym_AMP] = ACTIONS(5083),
    [anon_sym___extension__] = ACTIONS(5083),
    [anon_sym_typedef] = ACTIONS(5083),
    [anon_sym___device__] = ACTIONS(5083),
    [anon_sym___host__] = ACTIONS(5083),
    [anon_sym___global__] = ACTIONS(5083),
    [anon_sym___forceinline__] = ACTIONS(5083),
    [anon_sym___noinline__] = ACTIONS(5083),
    [anon_sym_extern] = ACTIONS(5083),
    [anon_sym___attribute__] = ACTIONS(5083),
    [anon_sym_COLON_COLON] = ACTIONS(5085),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5085),
    [anon_sym___declspec] = ACTIONS(5083),
    [anon_sym___based] = ACTIONS(5083),
    [anon_sym_signed] = ACTIONS(5083),
    [anon_sym_unsigned] = ACTIONS(5083),
    [anon_sym_long] = ACTIONS(5083),
    [anon_sym_short] = ACTIONS(5083),
    [anon_sym_LBRACK] = ACTIONS(5083),
    [anon_sym_static] = ACTIONS(5083),
    [anon_sym_register] = ACTIONS(5083),
    [anon_sym_inline] = ACTIONS(5083),
    [anon_sym___inline] = ACTIONS(5083),
    [anon_sym___inline__] = ACTIONS(5083),
    [anon_sym___forceinline] = ACTIONS(5083),
    [anon_sym_thread_local] = ACTIONS(5083),
    [anon_sym___thread] = ACTIONS(5083),
    [anon_sym_const] = ACTIONS(5083),
    [anon_sym_constexpr] = ACTIONS(5083),
    [anon_sym_volatile] = ACTIONS(5083),
    [anon_sym_restrict] = ACTIONS(5083),
    [anon_sym___restrict__] = ACTIONS(5083),
    [anon_sym__Atomic] = ACTIONS(5083),
    [anon_sym__Noreturn] = ACTIONS(5083),
    [anon_sym_noreturn] = ACTIONS(5083),
    [anon_sym_mutable] = ACTIONS(5083),
    [anon_sym_constinit] = ACTIONS(5083),
    [anon_sym_consteval] = ACTIONS(5083),
    [anon_sym___shared__] = ACTIONS(5083),
    [anon_sym___local__] = ACTIONS(5083),
    [anon_sym___constant__] = ACTIONS(5083),
    [anon_sym___managed__] = ACTIONS(5083),
    [anon_sym___grid_constant__] = ACTIONS(5083),
    [anon_sym_alignas] = ACTIONS(5083),
    [anon_sym__Alignas] = ACTIONS(5083),
    [sym_primitive_type] = ACTIONS(5083),
    [anon_sym_enum] = ACTIONS(5083),
    [anon_sym_class] = ACTIONS(5083),
    [anon_sym_struct] = ACTIONS(5083),
    [anon_sym_union] = ACTIONS(5083),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5083),
    [anon_sym_decltype] = ACTIONS(5083),
    [sym_virtual] = ACTIONS(5083),
    [anon_sym_explicit] = ACTIONS(5083),
    [anon_sym_typename] = ACTIONS(5083),
    [anon_sym_template] = ACTIONS(5083),
    [anon_sym_operator] = ACTIONS(5083),
    [anon_sym_friend] = ACTIONS(5083),
    [anon_sym_public] = ACTIONS(5083),
    [anon_sym_private] = ACTIONS(5083),
    [anon_sym_protected] = ACTIONS(5083),
    [anon_sym_using] = ACTIONS(5083),
    [anon_sym_static_assert] = ACTIONS(5083),
    [anon_sym___launch_bounds__] = ACTIONS(5083),
  },
  [1759] = {
    [sym_identifier] = ACTIONS(5079),
    [aux_sym_preproc_def_token1] = ACTIONS(5079),
    [aux_sym_preproc_if_token1] = ACTIONS(5079),
    [aux_sym_preproc_if_token2] = ACTIONS(5079),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5079),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5079),
    [aux_sym_preproc_else_token1] = ACTIONS(5079),
    [aux_sym_preproc_elif_token1] = ACTIONS(5079),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5079),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5079),
    [sym_preproc_directive] = ACTIONS(5079),
    [anon_sym_LPAREN2] = ACTIONS(5081),
    [anon_sym_TILDE] = ACTIONS(5081),
    [anon_sym_STAR] = ACTIONS(5081),
    [anon_sym_AMP_AMP] = ACTIONS(5081),
    [anon_sym_AMP] = ACTIONS(5079),
    [anon_sym___extension__] = ACTIONS(5079),
    [anon_sym_typedef] = ACTIONS(5079),
    [anon_sym___device__] = ACTIONS(5079),
    [anon_sym___host__] = ACTIONS(5079),
    [anon_sym___global__] = ACTIONS(5079),
    [anon_sym___forceinline__] = ACTIONS(5079),
    [anon_sym___noinline__] = ACTIONS(5079),
    [anon_sym_extern] = ACTIONS(5079),
    [anon_sym___attribute__] = ACTIONS(5079),
    [anon_sym_COLON_COLON] = ACTIONS(5081),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5081),
    [anon_sym___declspec] = ACTIONS(5079),
    [anon_sym___based] = ACTIONS(5079),
    [anon_sym_signed] = ACTIONS(5079),
    [anon_sym_unsigned] = ACTIONS(5079),
    [anon_sym_long] = ACTIONS(5079),
    [anon_sym_short] = ACTIONS(5079),
    [anon_sym_LBRACK] = ACTIONS(5079),
    [anon_sym_static] = ACTIONS(5079),
    [anon_sym_register] = ACTIONS(5079),
    [anon_sym_inline] = ACTIONS(5079),
    [anon_sym___inline] = ACTIONS(5079),
    [anon_sym___inline__] = ACTIONS(5079),
    [anon_sym___forceinline] = ACTIONS(5079),
    [anon_sym_thread_local] = ACTIONS(5079),
    [anon_sym___thread] = ACTIONS(5079),
    [anon_sym_const] = ACTIONS(5079),
    [anon_sym_constexpr] = ACTIONS(5079),
    [anon_sym_volatile] = ACTIONS(5079),
    [anon_sym_restrict] = ACTIONS(5079),
    [anon_sym___restrict__] = ACTIONS(5079),
    [anon_sym__Atomic] = ACTIONS(5079),
    [anon_sym__Noreturn] = ACTIONS(5079),
    [anon_sym_noreturn] = ACTIONS(5079),
    [anon_sym_mutable] = ACTIONS(5079),
    [anon_sym_constinit] = ACTIONS(5079),
    [anon_sym_consteval] = ACTIONS(5079),
    [anon_sym___shared__] = ACTIONS(5079),
    [anon_sym___local__] = ACTIONS(5079),
    [anon_sym___constant__] = ACTIONS(5079),
    [anon_sym___managed__] = ACTIONS(5079),
    [anon_sym___grid_constant__] = ACTIONS(5079),
    [anon_sym_alignas] = ACTIONS(5079),
    [anon_sym__Alignas] = ACTIONS(5079),
    [sym_primitive_type] = ACTIONS(5079),
    [anon_sym_enum] = ACTIONS(5079),
    [anon_sym_class] = ACTIONS(5079),
    [anon_sym_struct] = ACTIONS(5079),
    [anon_sym_union] = ACTIONS(5079),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5079),
    [anon_sym_decltype] = ACTIONS(5079),
    [sym_virtual] = ACTIONS(5079),
    [anon_sym_explicit] = ACTIONS(5079),
    [anon_sym_typename] = ACTIONS(5079),
    [anon_sym_template] = ACTIONS(5079),
    [anon_sym_operator] = ACTIONS(5079),
    [anon_sym_friend] = ACTIONS(5079),
    [anon_sym_public] = ACTIONS(5079),
    [anon_sym_private] = ACTIONS(5079),
    [anon_sym_protected] = ACTIONS(5079),
    [anon_sym_using] = ACTIONS(5079),
    [anon_sym_static_assert] = ACTIONS(5079),
    [anon_sym___launch_bounds__] = ACTIONS(5079),
  },
  [1760] = {
    [sym_identifier] = ACTIONS(2504),
    [aux_sym_preproc_def_token1] = ACTIONS(2504),
    [aux_sym_preproc_if_token1] = ACTIONS(2504),
    [aux_sym_preproc_if_token2] = ACTIONS(2504),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2504),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2504),
    [aux_sym_preproc_else_token1] = ACTIONS(2504),
    [aux_sym_preproc_elif_token1] = ACTIONS(2504),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2504),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2504),
    [sym_preproc_directive] = ACTIONS(2504),
    [anon_sym_LPAREN2] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2506),
    [anon_sym_STAR] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2504),
    [anon_sym___extension__] = ACTIONS(2504),
    [anon_sym_typedef] = ACTIONS(2504),
    [anon_sym___device__] = ACTIONS(2504),
    [anon_sym___host__] = ACTIONS(2504),
    [anon_sym___global__] = ACTIONS(2504),
    [anon_sym___forceinline__] = ACTIONS(2504),
    [anon_sym___noinline__] = ACTIONS(2504),
    [anon_sym_extern] = ACTIONS(2504),
    [anon_sym___attribute__] = ACTIONS(2504),
    [anon_sym_COLON_COLON] = ACTIONS(2506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2506),
    [anon_sym___declspec] = ACTIONS(2504),
    [anon_sym___based] = ACTIONS(2504),
    [anon_sym_signed] = ACTIONS(2504),
    [anon_sym_unsigned] = ACTIONS(2504),
    [anon_sym_long] = ACTIONS(2504),
    [anon_sym_short] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(2504),
    [anon_sym_static] = ACTIONS(2504),
    [anon_sym_register] = ACTIONS(2504),
    [anon_sym_inline] = ACTIONS(2504),
    [anon_sym___inline] = ACTIONS(2504),
    [anon_sym___inline__] = ACTIONS(2504),
    [anon_sym___forceinline] = ACTIONS(2504),
    [anon_sym_thread_local] = ACTIONS(2504),
    [anon_sym___thread] = ACTIONS(2504),
    [anon_sym_const] = ACTIONS(2504),
    [anon_sym_constexpr] = ACTIONS(2504),
    [anon_sym_volatile] = ACTIONS(2504),
    [anon_sym_restrict] = ACTIONS(2504),
    [anon_sym___restrict__] = ACTIONS(2504),
    [anon_sym__Atomic] = ACTIONS(2504),
    [anon_sym__Noreturn] = ACTIONS(2504),
    [anon_sym_noreturn] = ACTIONS(2504),
    [anon_sym_mutable] = ACTIONS(2504),
    [anon_sym_constinit] = ACTIONS(2504),
    [anon_sym_consteval] = ACTIONS(2504),
    [anon_sym___shared__] = ACTIONS(2504),
    [anon_sym___local__] = ACTIONS(2504),
    [anon_sym___constant__] = ACTIONS(2504),
    [anon_sym___managed__] = ACTIONS(2504),
    [anon_sym___grid_constant__] = ACTIONS(2504),
    [anon_sym_alignas] = ACTIONS(2504),
    [anon_sym__Alignas] = ACTIONS(2504),
    [sym_primitive_type] = ACTIONS(2504),
    [anon_sym_enum] = ACTIONS(2504),
    [anon_sym_class] = ACTIONS(2504),
    [anon_sym_struct] = ACTIONS(2504),
    [anon_sym_union] = ACTIONS(2504),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2504),
    [anon_sym_decltype] = ACTIONS(2504),
    [sym_virtual] = ACTIONS(2504),
    [anon_sym_explicit] = ACTIONS(2504),
    [anon_sym_typename] = ACTIONS(2504),
    [anon_sym_template] = ACTIONS(2504),
    [anon_sym_operator] = ACTIONS(2504),
    [anon_sym_friend] = ACTIONS(2504),
    [anon_sym_public] = ACTIONS(2504),
    [anon_sym_private] = ACTIONS(2504),
    [anon_sym_protected] = ACTIONS(2504),
    [anon_sym_using] = ACTIONS(2504),
    [anon_sym_static_assert] = ACTIONS(2504),
    [anon_sym___launch_bounds__] = ACTIONS(2504),
  },
  [1761] = {
    [sym_identifier] = ACTIONS(5087),
    [aux_sym_preproc_def_token1] = ACTIONS(5087),
    [aux_sym_preproc_if_token1] = ACTIONS(5087),
    [aux_sym_preproc_if_token2] = ACTIONS(5087),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5087),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5087),
    [aux_sym_preproc_else_token1] = ACTIONS(5087),
    [aux_sym_preproc_elif_token1] = ACTIONS(5087),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5087),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5087),
    [sym_preproc_directive] = ACTIONS(5087),
    [anon_sym_LPAREN2] = ACTIONS(5089),
    [anon_sym_TILDE] = ACTIONS(5089),
    [anon_sym_STAR] = ACTIONS(5089),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_AMP] = ACTIONS(5087),
    [anon_sym___extension__] = ACTIONS(5087),
    [anon_sym_typedef] = ACTIONS(5087),
    [anon_sym___device__] = ACTIONS(5087),
    [anon_sym___host__] = ACTIONS(5087),
    [anon_sym___global__] = ACTIONS(5087),
    [anon_sym___forceinline__] = ACTIONS(5087),
    [anon_sym___noinline__] = ACTIONS(5087),
    [anon_sym_extern] = ACTIONS(5087),
    [anon_sym___attribute__] = ACTIONS(5087),
    [anon_sym_COLON_COLON] = ACTIONS(5089),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5089),
    [anon_sym___declspec] = ACTIONS(5087),
    [anon_sym___based] = ACTIONS(5087),
    [anon_sym_signed] = ACTIONS(5087),
    [anon_sym_unsigned] = ACTIONS(5087),
    [anon_sym_long] = ACTIONS(5087),
    [anon_sym_short] = ACTIONS(5087),
    [anon_sym_LBRACK] = ACTIONS(5087),
    [anon_sym_static] = ACTIONS(5087),
    [anon_sym_register] = ACTIONS(5087),
    [anon_sym_inline] = ACTIONS(5087),
    [anon_sym___inline] = ACTIONS(5087),
    [anon_sym___inline__] = ACTIONS(5087),
    [anon_sym___forceinline] = ACTIONS(5087),
    [anon_sym_thread_local] = ACTIONS(5087),
    [anon_sym___thread] = ACTIONS(5087),
    [anon_sym_const] = ACTIONS(5087),
    [anon_sym_constexpr] = ACTIONS(5087),
    [anon_sym_volatile] = ACTIONS(5087),
    [anon_sym_restrict] = ACTIONS(5087),
    [anon_sym___restrict__] = ACTIONS(5087),
    [anon_sym__Atomic] = ACTIONS(5087),
    [anon_sym__Noreturn] = ACTIONS(5087),
    [anon_sym_noreturn] = ACTIONS(5087),
    [anon_sym_mutable] = ACTIONS(5087),
    [anon_sym_constinit] = ACTIONS(5087),
    [anon_sym_consteval] = ACTIONS(5087),
    [anon_sym___shared__] = ACTIONS(5087),
    [anon_sym___local__] = ACTIONS(5087),
    [anon_sym___constant__] = ACTIONS(5087),
    [anon_sym___managed__] = ACTIONS(5087),
    [anon_sym___grid_constant__] = ACTIONS(5087),
    [anon_sym_alignas] = ACTIONS(5087),
    [anon_sym__Alignas] = ACTIONS(5087),
    [sym_primitive_type] = ACTIONS(5087),
    [anon_sym_enum] = ACTIONS(5087),
    [anon_sym_class] = ACTIONS(5087),
    [anon_sym_struct] = ACTIONS(5087),
    [anon_sym_union] = ACTIONS(5087),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5087),
    [anon_sym_decltype] = ACTIONS(5087),
    [sym_virtual] = ACTIONS(5087),
    [anon_sym_explicit] = ACTIONS(5087),
    [anon_sym_typename] = ACTIONS(5087),
    [anon_sym_template] = ACTIONS(5087),
    [anon_sym_operator] = ACTIONS(5087),
    [anon_sym_friend] = ACTIONS(5087),
    [anon_sym_public] = ACTIONS(5087),
    [anon_sym_private] = ACTIONS(5087),
    [anon_sym_protected] = ACTIONS(5087),
    [anon_sym_using] = ACTIONS(5087),
    [anon_sym_static_assert] = ACTIONS(5087),
    [anon_sym___launch_bounds__] = ACTIONS(5087),
  },
  [1762] = {
    [sym_identifier] = ACTIONS(5091),
    [aux_sym_preproc_def_token1] = ACTIONS(5091),
    [aux_sym_preproc_if_token1] = ACTIONS(5091),
    [aux_sym_preproc_if_token2] = ACTIONS(5091),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5091),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5091),
    [aux_sym_preproc_else_token1] = ACTIONS(5091),
    [aux_sym_preproc_elif_token1] = ACTIONS(5091),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5091),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5091),
    [sym_preproc_directive] = ACTIONS(5091),
    [anon_sym_LPAREN2] = ACTIONS(5093),
    [anon_sym_TILDE] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5093),
    [anon_sym_AMP_AMP] = ACTIONS(5093),
    [anon_sym_AMP] = ACTIONS(5091),
    [anon_sym___extension__] = ACTIONS(5091),
    [anon_sym_typedef] = ACTIONS(5091),
    [anon_sym___device__] = ACTIONS(5091),
    [anon_sym___host__] = ACTIONS(5091),
    [anon_sym___global__] = ACTIONS(5091),
    [anon_sym___forceinline__] = ACTIONS(5091),
    [anon_sym___noinline__] = ACTIONS(5091),
    [anon_sym_extern] = ACTIONS(5091),
    [anon_sym___attribute__] = ACTIONS(5091),
    [anon_sym_COLON_COLON] = ACTIONS(5093),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5093),
    [anon_sym___declspec] = ACTIONS(5091),
    [anon_sym___based] = ACTIONS(5091),
    [anon_sym_signed] = ACTIONS(5091),
    [anon_sym_unsigned] = ACTIONS(5091),
    [anon_sym_long] = ACTIONS(5091),
    [anon_sym_short] = ACTIONS(5091),
    [anon_sym_LBRACK] = ACTIONS(5091),
    [anon_sym_static] = ACTIONS(5091),
    [anon_sym_register] = ACTIONS(5091),
    [anon_sym_inline] = ACTIONS(5091),
    [anon_sym___inline] = ACTIONS(5091),
    [anon_sym___inline__] = ACTIONS(5091),
    [anon_sym___forceinline] = ACTIONS(5091),
    [anon_sym_thread_local] = ACTIONS(5091),
    [anon_sym___thread] = ACTIONS(5091),
    [anon_sym_const] = ACTIONS(5091),
    [anon_sym_constexpr] = ACTIONS(5091),
    [anon_sym_volatile] = ACTIONS(5091),
    [anon_sym_restrict] = ACTIONS(5091),
    [anon_sym___restrict__] = ACTIONS(5091),
    [anon_sym__Atomic] = ACTIONS(5091),
    [anon_sym__Noreturn] = ACTIONS(5091),
    [anon_sym_noreturn] = ACTIONS(5091),
    [anon_sym_mutable] = ACTIONS(5091),
    [anon_sym_constinit] = ACTIONS(5091),
    [anon_sym_consteval] = ACTIONS(5091),
    [anon_sym___shared__] = ACTIONS(5091),
    [anon_sym___local__] = ACTIONS(5091),
    [anon_sym___constant__] = ACTIONS(5091),
    [anon_sym___managed__] = ACTIONS(5091),
    [anon_sym___grid_constant__] = ACTIONS(5091),
    [anon_sym_alignas] = ACTIONS(5091),
    [anon_sym__Alignas] = ACTIONS(5091),
    [sym_primitive_type] = ACTIONS(5091),
    [anon_sym_enum] = ACTIONS(5091),
    [anon_sym_class] = ACTIONS(5091),
    [anon_sym_struct] = ACTIONS(5091),
    [anon_sym_union] = ACTIONS(5091),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5091),
    [anon_sym_decltype] = ACTIONS(5091),
    [sym_virtual] = ACTIONS(5091),
    [anon_sym_explicit] = ACTIONS(5091),
    [anon_sym_typename] = ACTIONS(5091),
    [anon_sym_template] = ACTIONS(5091),
    [anon_sym_operator] = ACTIONS(5091),
    [anon_sym_friend] = ACTIONS(5091),
    [anon_sym_public] = ACTIONS(5091),
    [anon_sym_private] = ACTIONS(5091),
    [anon_sym_protected] = ACTIONS(5091),
    [anon_sym_using] = ACTIONS(5091),
    [anon_sym_static_assert] = ACTIONS(5091),
    [anon_sym___launch_bounds__] = ACTIONS(5091),
  },
  [1763] = {
    [sym_identifier] = ACTIONS(5095),
    [aux_sym_preproc_def_token1] = ACTIONS(5095),
    [aux_sym_preproc_if_token1] = ACTIONS(5095),
    [aux_sym_preproc_if_token2] = ACTIONS(5095),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5095),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5095),
    [aux_sym_preproc_else_token1] = ACTIONS(5095),
    [aux_sym_preproc_elif_token1] = ACTIONS(5095),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5095),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5095),
    [sym_preproc_directive] = ACTIONS(5095),
    [anon_sym_LPAREN2] = ACTIONS(5097),
    [anon_sym_TILDE] = ACTIONS(5097),
    [anon_sym_STAR] = ACTIONS(5097),
    [anon_sym_AMP_AMP] = ACTIONS(5097),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym___extension__] = ACTIONS(5095),
    [anon_sym_typedef] = ACTIONS(5095),
    [anon_sym___device__] = ACTIONS(5095),
    [anon_sym___host__] = ACTIONS(5095),
    [anon_sym___global__] = ACTIONS(5095),
    [anon_sym___forceinline__] = ACTIONS(5095),
    [anon_sym___noinline__] = ACTIONS(5095),
    [anon_sym_extern] = ACTIONS(5095),
    [anon_sym___attribute__] = ACTIONS(5095),
    [anon_sym_COLON_COLON] = ACTIONS(5097),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5097),
    [anon_sym___declspec] = ACTIONS(5095),
    [anon_sym___based] = ACTIONS(5095),
    [anon_sym_signed] = ACTIONS(5095),
    [anon_sym_unsigned] = ACTIONS(5095),
    [anon_sym_long] = ACTIONS(5095),
    [anon_sym_short] = ACTIONS(5095),
    [anon_sym_LBRACK] = ACTIONS(5095),
    [anon_sym_static] = ACTIONS(5095),
    [anon_sym_register] = ACTIONS(5095),
    [anon_sym_inline] = ACTIONS(5095),
    [anon_sym___inline] = ACTIONS(5095),
    [anon_sym___inline__] = ACTIONS(5095),
    [anon_sym___forceinline] = ACTIONS(5095),
    [anon_sym_thread_local] = ACTIONS(5095),
    [anon_sym___thread] = ACTIONS(5095),
    [anon_sym_const] = ACTIONS(5095),
    [anon_sym_constexpr] = ACTIONS(5095),
    [anon_sym_volatile] = ACTIONS(5095),
    [anon_sym_restrict] = ACTIONS(5095),
    [anon_sym___restrict__] = ACTIONS(5095),
    [anon_sym__Atomic] = ACTIONS(5095),
    [anon_sym__Noreturn] = ACTIONS(5095),
    [anon_sym_noreturn] = ACTIONS(5095),
    [anon_sym_mutable] = ACTIONS(5095),
    [anon_sym_constinit] = ACTIONS(5095),
    [anon_sym_consteval] = ACTIONS(5095),
    [anon_sym___shared__] = ACTIONS(5095),
    [anon_sym___local__] = ACTIONS(5095),
    [anon_sym___constant__] = ACTIONS(5095),
    [anon_sym___managed__] = ACTIONS(5095),
    [anon_sym___grid_constant__] = ACTIONS(5095),
    [anon_sym_alignas] = ACTIONS(5095),
    [anon_sym__Alignas] = ACTIONS(5095),
    [sym_primitive_type] = ACTIONS(5095),
    [anon_sym_enum] = ACTIONS(5095),
    [anon_sym_class] = ACTIONS(5095),
    [anon_sym_struct] = ACTIONS(5095),
    [anon_sym_union] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5095),
    [anon_sym_decltype] = ACTIONS(5095),
    [sym_virtual] = ACTIONS(5095),
    [anon_sym_explicit] = ACTIONS(5095),
    [anon_sym_typename] = ACTIONS(5095),
    [anon_sym_template] = ACTIONS(5095),
    [anon_sym_operator] = ACTIONS(5095),
    [anon_sym_friend] = ACTIONS(5095),
    [anon_sym_public] = ACTIONS(5095),
    [anon_sym_private] = ACTIONS(5095),
    [anon_sym_protected] = ACTIONS(5095),
    [anon_sym_using] = ACTIONS(5095),
    [anon_sym_static_assert] = ACTIONS(5095),
    [anon_sym___launch_bounds__] = ACTIONS(5095),
  },
  [1764] = {
    [sym_identifier] = ACTIONS(5099),
    [aux_sym_preproc_def_token1] = ACTIONS(5099),
    [aux_sym_preproc_if_token1] = ACTIONS(5099),
    [aux_sym_preproc_if_token2] = ACTIONS(5099),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5099),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5099),
    [aux_sym_preproc_else_token1] = ACTIONS(5099),
    [aux_sym_preproc_elif_token1] = ACTIONS(5099),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5099),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5099),
    [sym_preproc_directive] = ACTIONS(5099),
    [anon_sym_LPAREN2] = ACTIONS(5101),
    [anon_sym_TILDE] = ACTIONS(5101),
    [anon_sym_STAR] = ACTIONS(5101),
    [anon_sym_AMP_AMP] = ACTIONS(5101),
    [anon_sym_AMP] = ACTIONS(5099),
    [anon_sym___extension__] = ACTIONS(5099),
    [anon_sym_typedef] = ACTIONS(5099),
    [anon_sym___device__] = ACTIONS(5099),
    [anon_sym___host__] = ACTIONS(5099),
    [anon_sym___global__] = ACTIONS(5099),
    [anon_sym___forceinline__] = ACTIONS(5099),
    [anon_sym___noinline__] = ACTIONS(5099),
    [anon_sym_extern] = ACTIONS(5099),
    [anon_sym___attribute__] = ACTIONS(5099),
    [anon_sym_COLON_COLON] = ACTIONS(5101),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5101),
    [anon_sym___declspec] = ACTIONS(5099),
    [anon_sym___based] = ACTIONS(5099),
    [anon_sym_signed] = ACTIONS(5099),
    [anon_sym_unsigned] = ACTIONS(5099),
    [anon_sym_long] = ACTIONS(5099),
    [anon_sym_short] = ACTIONS(5099),
    [anon_sym_LBRACK] = ACTIONS(5099),
    [anon_sym_static] = ACTIONS(5099),
    [anon_sym_register] = ACTIONS(5099),
    [anon_sym_inline] = ACTIONS(5099),
    [anon_sym___inline] = ACTIONS(5099),
    [anon_sym___inline__] = ACTIONS(5099),
    [anon_sym___forceinline] = ACTIONS(5099),
    [anon_sym_thread_local] = ACTIONS(5099),
    [anon_sym___thread] = ACTIONS(5099),
    [anon_sym_const] = ACTIONS(5099),
    [anon_sym_constexpr] = ACTIONS(5099),
    [anon_sym_volatile] = ACTIONS(5099),
    [anon_sym_restrict] = ACTIONS(5099),
    [anon_sym___restrict__] = ACTIONS(5099),
    [anon_sym__Atomic] = ACTIONS(5099),
    [anon_sym__Noreturn] = ACTIONS(5099),
    [anon_sym_noreturn] = ACTIONS(5099),
    [anon_sym_mutable] = ACTIONS(5099),
    [anon_sym_constinit] = ACTIONS(5099),
    [anon_sym_consteval] = ACTIONS(5099),
    [anon_sym___shared__] = ACTIONS(5099),
    [anon_sym___local__] = ACTIONS(5099),
    [anon_sym___constant__] = ACTIONS(5099),
    [anon_sym___managed__] = ACTIONS(5099),
    [anon_sym___grid_constant__] = ACTIONS(5099),
    [anon_sym_alignas] = ACTIONS(5099),
    [anon_sym__Alignas] = ACTIONS(5099),
    [sym_primitive_type] = ACTIONS(5099),
    [anon_sym_enum] = ACTIONS(5099),
    [anon_sym_class] = ACTIONS(5099),
    [anon_sym_struct] = ACTIONS(5099),
    [anon_sym_union] = ACTIONS(5099),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5099),
    [anon_sym_decltype] = ACTIONS(5099),
    [sym_virtual] = ACTIONS(5099),
    [anon_sym_explicit] = ACTIONS(5099),
    [anon_sym_typename] = ACTIONS(5099),
    [anon_sym_template] = ACTIONS(5099),
    [anon_sym_operator] = ACTIONS(5099),
    [anon_sym_friend] = ACTIONS(5099),
    [anon_sym_public] = ACTIONS(5099),
    [anon_sym_private] = ACTIONS(5099),
    [anon_sym_protected] = ACTIONS(5099),
    [anon_sym_using] = ACTIONS(5099),
    [anon_sym_static_assert] = ACTIONS(5099),
    [anon_sym___launch_bounds__] = ACTIONS(5099),
  },
  [1765] = {
    [sym_identifier] = ACTIONS(2461),
    [aux_sym_preproc_def_token1] = ACTIONS(2461),
    [aux_sym_preproc_if_token1] = ACTIONS(2461),
    [aux_sym_preproc_if_token2] = ACTIONS(2461),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2461),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2461),
    [aux_sym_preproc_else_token1] = ACTIONS(2461),
    [aux_sym_preproc_elif_token1] = ACTIONS(2461),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2461),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2461),
    [sym_preproc_directive] = ACTIONS(2461),
    [anon_sym_LPAREN2] = ACTIONS(2463),
    [anon_sym_TILDE] = ACTIONS(2463),
    [anon_sym_STAR] = ACTIONS(2463),
    [anon_sym_AMP_AMP] = ACTIONS(2463),
    [anon_sym_AMP] = ACTIONS(2461),
    [anon_sym___extension__] = ACTIONS(2461),
    [anon_sym_typedef] = ACTIONS(2461),
    [anon_sym___device__] = ACTIONS(2461),
    [anon_sym___host__] = ACTIONS(2461),
    [anon_sym___global__] = ACTIONS(2461),
    [anon_sym___forceinline__] = ACTIONS(2461),
    [anon_sym___noinline__] = ACTIONS(2461),
    [anon_sym_extern] = ACTIONS(2461),
    [anon_sym___attribute__] = ACTIONS(2461),
    [anon_sym_COLON_COLON] = ACTIONS(2463),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2463),
    [anon_sym___declspec] = ACTIONS(2461),
    [anon_sym___based] = ACTIONS(2461),
    [anon_sym_signed] = ACTIONS(2461),
    [anon_sym_unsigned] = ACTIONS(2461),
    [anon_sym_long] = ACTIONS(2461),
    [anon_sym_short] = ACTIONS(2461),
    [anon_sym_LBRACK] = ACTIONS(2461),
    [anon_sym_static] = ACTIONS(2461),
    [anon_sym_register] = ACTIONS(2461),
    [anon_sym_inline] = ACTIONS(2461),
    [anon_sym___inline] = ACTIONS(2461),
    [anon_sym___inline__] = ACTIONS(2461),
    [anon_sym___forceinline] = ACTIONS(2461),
    [anon_sym_thread_local] = ACTIONS(2461),
    [anon_sym___thread] = ACTIONS(2461),
    [anon_sym_const] = ACTIONS(2461),
    [anon_sym_constexpr] = ACTIONS(2461),
    [anon_sym_volatile] = ACTIONS(2461),
    [anon_sym_restrict] = ACTIONS(2461),
    [anon_sym___restrict__] = ACTIONS(2461),
    [anon_sym__Atomic] = ACTIONS(2461),
    [anon_sym__Noreturn] = ACTIONS(2461),
    [anon_sym_noreturn] = ACTIONS(2461),
    [anon_sym_mutable] = ACTIONS(2461),
    [anon_sym_constinit] = ACTIONS(2461),
    [anon_sym_consteval] = ACTIONS(2461),
    [anon_sym___shared__] = ACTIONS(2461),
    [anon_sym___local__] = ACTIONS(2461),
    [anon_sym___constant__] = ACTIONS(2461),
    [anon_sym___managed__] = ACTIONS(2461),
    [anon_sym___grid_constant__] = ACTIONS(2461),
    [anon_sym_alignas] = ACTIONS(2461),
    [anon_sym__Alignas] = ACTIONS(2461),
    [sym_primitive_type] = ACTIONS(2461),
    [anon_sym_enum] = ACTIONS(2461),
    [anon_sym_class] = ACTIONS(2461),
    [anon_sym_struct] = ACTIONS(2461),
    [anon_sym_union] = ACTIONS(2461),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2461),
    [anon_sym_decltype] = ACTIONS(2461),
    [sym_virtual] = ACTIONS(2461),
    [anon_sym_explicit] = ACTIONS(2461),
    [anon_sym_typename] = ACTIONS(2461),
    [anon_sym_template] = ACTIONS(2461),
    [anon_sym_operator] = ACTIONS(2461),
    [anon_sym_friend] = ACTIONS(2461),
    [anon_sym_public] = ACTIONS(2461),
    [anon_sym_private] = ACTIONS(2461),
    [anon_sym_protected] = ACTIONS(2461),
    [anon_sym_using] = ACTIONS(2461),
    [anon_sym_static_assert] = ACTIONS(2461),
    [anon_sym___launch_bounds__] = ACTIONS(2461),
  },
  [1766] = {
    [sym_identifier] = ACTIONS(2396),
    [aux_sym_preproc_def_token1] = ACTIONS(2396),
    [aux_sym_preproc_if_token1] = ACTIONS(2396),
    [aux_sym_preproc_if_token2] = ACTIONS(2396),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2396),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2396),
    [aux_sym_preproc_else_token1] = ACTIONS(2396),
    [aux_sym_preproc_elif_token1] = ACTIONS(2396),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2396),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2396),
    [sym_preproc_directive] = ACTIONS(2396),
    [anon_sym_LPAREN2] = ACTIONS(2398),
    [anon_sym_TILDE] = ACTIONS(2398),
    [anon_sym_STAR] = ACTIONS(2398),
    [anon_sym_AMP_AMP] = ACTIONS(2398),
    [anon_sym_AMP] = ACTIONS(2396),
    [anon_sym___extension__] = ACTIONS(2396),
    [anon_sym_typedef] = ACTIONS(2396),
    [anon_sym___device__] = ACTIONS(2396),
    [anon_sym___host__] = ACTIONS(2396),
    [anon_sym___global__] = ACTIONS(2396),
    [anon_sym___forceinline__] = ACTIONS(2396),
    [anon_sym___noinline__] = ACTIONS(2396),
    [anon_sym_extern] = ACTIONS(2396),
    [anon_sym___attribute__] = ACTIONS(2396),
    [anon_sym_COLON_COLON] = ACTIONS(2398),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2398),
    [anon_sym___declspec] = ACTIONS(2396),
    [anon_sym___based] = ACTIONS(2396),
    [anon_sym_signed] = ACTIONS(2396),
    [anon_sym_unsigned] = ACTIONS(2396),
    [anon_sym_long] = ACTIONS(2396),
    [anon_sym_short] = ACTIONS(2396),
    [anon_sym_LBRACK] = ACTIONS(2396),
    [anon_sym_static] = ACTIONS(2396),
    [anon_sym_register] = ACTIONS(2396),
    [anon_sym_inline] = ACTIONS(2396),
    [anon_sym___inline] = ACTIONS(2396),
    [anon_sym___inline__] = ACTIONS(2396),
    [anon_sym___forceinline] = ACTIONS(2396),
    [anon_sym_thread_local] = ACTIONS(2396),
    [anon_sym___thread] = ACTIONS(2396),
    [anon_sym_const] = ACTIONS(2396),
    [anon_sym_constexpr] = ACTIONS(2396),
    [anon_sym_volatile] = ACTIONS(2396),
    [anon_sym_restrict] = ACTIONS(2396),
    [anon_sym___restrict__] = ACTIONS(2396),
    [anon_sym__Atomic] = ACTIONS(2396),
    [anon_sym__Noreturn] = ACTIONS(2396),
    [anon_sym_noreturn] = ACTIONS(2396),
    [anon_sym_mutable] = ACTIONS(2396),
    [anon_sym_constinit] = ACTIONS(2396),
    [anon_sym_consteval] = ACTIONS(2396),
    [anon_sym___shared__] = ACTIONS(2396),
    [anon_sym___local__] = ACTIONS(2396),
    [anon_sym___constant__] = ACTIONS(2396),
    [anon_sym___managed__] = ACTIONS(2396),
    [anon_sym___grid_constant__] = ACTIONS(2396),
    [anon_sym_alignas] = ACTIONS(2396),
    [anon_sym__Alignas] = ACTIONS(2396),
    [sym_primitive_type] = ACTIONS(2396),
    [anon_sym_enum] = ACTIONS(2396),
    [anon_sym_class] = ACTIONS(2396),
    [anon_sym_struct] = ACTIONS(2396),
    [anon_sym_union] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2396),
    [anon_sym_decltype] = ACTIONS(2396),
    [sym_virtual] = ACTIONS(2396),
    [anon_sym_explicit] = ACTIONS(2396),
    [anon_sym_typename] = ACTIONS(2396),
    [anon_sym_template] = ACTIONS(2396),
    [anon_sym_operator] = ACTIONS(2396),
    [anon_sym_friend] = ACTIONS(2396),
    [anon_sym_public] = ACTIONS(2396),
    [anon_sym_private] = ACTIONS(2396),
    [anon_sym_protected] = ACTIONS(2396),
    [anon_sym_using] = ACTIONS(2396),
    [anon_sym_static_assert] = ACTIONS(2396),
    [anon_sym___launch_bounds__] = ACTIONS(2396),
  },
  [1767] = {
    [sym_identifier] = ACTIONS(5103),
    [aux_sym_preproc_def_token1] = ACTIONS(5103),
    [aux_sym_preproc_if_token1] = ACTIONS(5103),
    [aux_sym_preproc_if_token2] = ACTIONS(5103),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5103),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5103),
    [aux_sym_preproc_else_token1] = ACTIONS(5103),
    [aux_sym_preproc_elif_token1] = ACTIONS(5103),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5103),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5103),
    [sym_preproc_directive] = ACTIONS(5103),
    [anon_sym_LPAREN2] = ACTIONS(5105),
    [anon_sym_TILDE] = ACTIONS(5105),
    [anon_sym_STAR] = ACTIONS(5105),
    [anon_sym_AMP_AMP] = ACTIONS(5105),
    [anon_sym_AMP] = ACTIONS(5103),
    [anon_sym___extension__] = ACTIONS(5103),
    [anon_sym_typedef] = ACTIONS(5103),
    [anon_sym___device__] = ACTIONS(5103),
    [anon_sym___host__] = ACTIONS(5103),
    [anon_sym___global__] = ACTIONS(5103),
    [anon_sym___forceinline__] = ACTIONS(5103),
    [anon_sym___noinline__] = ACTIONS(5103),
    [anon_sym_extern] = ACTIONS(5103),
    [anon_sym___attribute__] = ACTIONS(5103),
    [anon_sym_COLON_COLON] = ACTIONS(5105),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5105),
    [anon_sym___declspec] = ACTIONS(5103),
    [anon_sym___based] = ACTIONS(5103),
    [anon_sym_signed] = ACTIONS(5103),
    [anon_sym_unsigned] = ACTIONS(5103),
    [anon_sym_long] = ACTIONS(5103),
    [anon_sym_short] = ACTIONS(5103),
    [anon_sym_LBRACK] = ACTIONS(5103),
    [anon_sym_static] = ACTIONS(5103),
    [anon_sym_register] = ACTIONS(5103),
    [anon_sym_inline] = ACTIONS(5103),
    [anon_sym___inline] = ACTIONS(5103),
    [anon_sym___inline__] = ACTIONS(5103),
    [anon_sym___forceinline] = ACTIONS(5103),
    [anon_sym_thread_local] = ACTIONS(5103),
    [anon_sym___thread] = ACTIONS(5103),
    [anon_sym_const] = ACTIONS(5103),
    [anon_sym_constexpr] = ACTIONS(5103),
    [anon_sym_volatile] = ACTIONS(5103),
    [anon_sym_restrict] = ACTIONS(5103),
    [anon_sym___restrict__] = ACTIONS(5103),
    [anon_sym__Atomic] = ACTIONS(5103),
    [anon_sym__Noreturn] = ACTIONS(5103),
    [anon_sym_noreturn] = ACTIONS(5103),
    [anon_sym_mutable] = ACTIONS(5103),
    [anon_sym_constinit] = ACTIONS(5103),
    [anon_sym_consteval] = ACTIONS(5103),
    [anon_sym___shared__] = ACTIONS(5103),
    [anon_sym___local__] = ACTIONS(5103),
    [anon_sym___constant__] = ACTIONS(5103),
    [anon_sym___managed__] = ACTIONS(5103),
    [anon_sym___grid_constant__] = ACTIONS(5103),
    [anon_sym_alignas] = ACTIONS(5103),
    [anon_sym__Alignas] = ACTIONS(5103),
    [sym_primitive_type] = ACTIONS(5103),
    [anon_sym_enum] = ACTIONS(5103),
    [anon_sym_class] = ACTIONS(5103),
    [anon_sym_struct] = ACTIONS(5103),
    [anon_sym_union] = ACTIONS(5103),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5103),
    [anon_sym_decltype] = ACTIONS(5103),
    [sym_virtual] = ACTIONS(5103),
    [anon_sym_explicit] = ACTIONS(5103),
    [anon_sym_typename] = ACTIONS(5103),
    [anon_sym_template] = ACTIONS(5103),
    [anon_sym_operator] = ACTIONS(5103),
    [anon_sym_friend] = ACTIONS(5103),
    [anon_sym_public] = ACTIONS(5103),
    [anon_sym_private] = ACTIONS(5103),
    [anon_sym_protected] = ACTIONS(5103),
    [anon_sym_using] = ACTIONS(5103),
    [anon_sym_static_assert] = ACTIONS(5103),
    [anon_sym___launch_bounds__] = ACTIONS(5103),
  },
  [1768] = {
    [sym_identifier] = ACTIONS(5107),
    [aux_sym_preproc_def_token1] = ACTIONS(5107),
    [aux_sym_preproc_if_token1] = ACTIONS(5107),
    [aux_sym_preproc_if_token2] = ACTIONS(5107),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5107),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5107),
    [aux_sym_preproc_else_token1] = ACTIONS(5107),
    [aux_sym_preproc_elif_token1] = ACTIONS(5107),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5107),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5107),
    [sym_preproc_directive] = ACTIONS(5107),
    [anon_sym_LPAREN2] = ACTIONS(5109),
    [anon_sym_TILDE] = ACTIONS(5109),
    [anon_sym_STAR] = ACTIONS(5109),
    [anon_sym_AMP_AMP] = ACTIONS(5109),
    [anon_sym_AMP] = ACTIONS(5107),
    [anon_sym___extension__] = ACTIONS(5107),
    [anon_sym_typedef] = ACTIONS(5107),
    [anon_sym___device__] = ACTIONS(5107),
    [anon_sym___host__] = ACTIONS(5107),
    [anon_sym___global__] = ACTIONS(5107),
    [anon_sym___forceinline__] = ACTIONS(5107),
    [anon_sym___noinline__] = ACTIONS(5107),
    [anon_sym_extern] = ACTIONS(5107),
    [anon_sym___attribute__] = ACTIONS(5107),
    [anon_sym_COLON_COLON] = ACTIONS(5109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5109),
    [anon_sym___declspec] = ACTIONS(5107),
    [anon_sym___based] = ACTIONS(5107),
    [anon_sym_signed] = ACTIONS(5107),
    [anon_sym_unsigned] = ACTIONS(5107),
    [anon_sym_long] = ACTIONS(5107),
    [anon_sym_short] = ACTIONS(5107),
    [anon_sym_LBRACK] = ACTIONS(5107),
    [anon_sym_static] = ACTIONS(5107),
    [anon_sym_register] = ACTIONS(5107),
    [anon_sym_inline] = ACTIONS(5107),
    [anon_sym___inline] = ACTIONS(5107),
    [anon_sym___inline__] = ACTIONS(5107),
    [anon_sym___forceinline] = ACTIONS(5107),
    [anon_sym_thread_local] = ACTIONS(5107),
    [anon_sym___thread] = ACTIONS(5107),
    [anon_sym_const] = ACTIONS(5107),
    [anon_sym_constexpr] = ACTIONS(5107),
    [anon_sym_volatile] = ACTIONS(5107),
    [anon_sym_restrict] = ACTIONS(5107),
    [anon_sym___restrict__] = ACTIONS(5107),
    [anon_sym__Atomic] = ACTIONS(5107),
    [anon_sym__Noreturn] = ACTIONS(5107),
    [anon_sym_noreturn] = ACTIONS(5107),
    [anon_sym_mutable] = ACTIONS(5107),
    [anon_sym_constinit] = ACTIONS(5107),
    [anon_sym_consteval] = ACTIONS(5107),
    [anon_sym___shared__] = ACTIONS(5107),
    [anon_sym___local__] = ACTIONS(5107),
    [anon_sym___constant__] = ACTIONS(5107),
    [anon_sym___managed__] = ACTIONS(5107),
    [anon_sym___grid_constant__] = ACTIONS(5107),
    [anon_sym_alignas] = ACTIONS(5107),
    [anon_sym__Alignas] = ACTIONS(5107),
    [sym_primitive_type] = ACTIONS(5107),
    [anon_sym_enum] = ACTIONS(5107),
    [anon_sym_class] = ACTIONS(5107),
    [anon_sym_struct] = ACTIONS(5107),
    [anon_sym_union] = ACTIONS(5107),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5107),
    [anon_sym_decltype] = ACTIONS(5107),
    [sym_virtual] = ACTIONS(5107),
    [anon_sym_explicit] = ACTIONS(5107),
    [anon_sym_typename] = ACTIONS(5107),
    [anon_sym_template] = ACTIONS(5107),
    [anon_sym_operator] = ACTIONS(5107),
    [anon_sym_friend] = ACTIONS(5107),
    [anon_sym_public] = ACTIONS(5107),
    [anon_sym_private] = ACTIONS(5107),
    [anon_sym_protected] = ACTIONS(5107),
    [anon_sym_using] = ACTIONS(5107),
    [anon_sym_static_assert] = ACTIONS(5107),
    [anon_sym___launch_bounds__] = ACTIONS(5107),
  },
  [1769] = {
    [sym_identifier] = ACTIONS(5111),
    [aux_sym_preproc_def_token1] = ACTIONS(5111),
    [aux_sym_preproc_if_token1] = ACTIONS(5111),
    [aux_sym_preproc_if_token2] = ACTIONS(5111),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5111),
    [aux_sym_preproc_else_token1] = ACTIONS(5111),
    [aux_sym_preproc_elif_token1] = ACTIONS(5111),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5111),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5111),
    [sym_preproc_directive] = ACTIONS(5111),
    [anon_sym_LPAREN2] = ACTIONS(5113),
    [anon_sym_TILDE] = ACTIONS(5113),
    [anon_sym_STAR] = ACTIONS(5113),
    [anon_sym_AMP_AMP] = ACTIONS(5113),
    [anon_sym_AMP] = ACTIONS(5111),
    [anon_sym___extension__] = ACTIONS(5111),
    [anon_sym_typedef] = ACTIONS(5111),
    [anon_sym___device__] = ACTIONS(5111),
    [anon_sym___host__] = ACTIONS(5111),
    [anon_sym___global__] = ACTIONS(5111),
    [anon_sym___forceinline__] = ACTIONS(5111),
    [anon_sym___noinline__] = ACTIONS(5111),
    [anon_sym_extern] = ACTIONS(5111),
    [anon_sym___attribute__] = ACTIONS(5111),
    [anon_sym_COLON_COLON] = ACTIONS(5113),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5113),
    [anon_sym___declspec] = ACTIONS(5111),
    [anon_sym___based] = ACTIONS(5111),
    [anon_sym_signed] = ACTIONS(5111),
    [anon_sym_unsigned] = ACTIONS(5111),
    [anon_sym_long] = ACTIONS(5111),
    [anon_sym_short] = ACTIONS(5111),
    [anon_sym_LBRACK] = ACTIONS(5111),
    [anon_sym_static] = ACTIONS(5111),
    [anon_sym_register] = ACTIONS(5111),
    [anon_sym_inline] = ACTIONS(5111),
    [anon_sym___inline] = ACTIONS(5111),
    [anon_sym___inline__] = ACTIONS(5111),
    [anon_sym___forceinline] = ACTIONS(5111),
    [anon_sym_thread_local] = ACTIONS(5111),
    [anon_sym___thread] = ACTIONS(5111),
    [anon_sym_const] = ACTIONS(5111),
    [anon_sym_constexpr] = ACTIONS(5111),
    [anon_sym_volatile] = ACTIONS(5111),
    [anon_sym_restrict] = ACTIONS(5111),
    [anon_sym___restrict__] = ACTIONS(5111),
    [anon_sym__Atomic] = ACTIONS(5111),
    [anon_sym__Noreturn] = ACTIONS(5111),
    [anon_sym_noreturn] = ACTIONS(5111),
    [anon_sym_mutable] = ACTIONS(5111),
    [anon_sym_constinit] = ACTIONS(5111),
    [anon_sym_consteval] = ACTIONS(5111),
    [anon_sym___shared__] = ACTIONS(5111),
    [anon_sym___local__] = ACTIONS(5111),
    [anon_sym___constant__] = ACTIONS(5111),
    [anon_sym___managed__] = ACTIONS(5111),
    [anon_sym___grid_constant__] = ACTIONS(5111),
    [anon_sym_alignas] = ACTIONS(5111),
    [anon_sym__Alignas] = ACTIONS(5111),
    [sym_primitive_type] = ACTIONS(5111),
    [anon_sym_enum] = ACTIONS(5111),
    [anon_sym_class] = ACTIONS(5111),
    [anon_sym_struct] = ACTIONS(5111),
    [anon_sym_union] = ACTIONS(5111),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5111),
    [anon_sym_decltype] = ACTIONS(5111),
    [sym_virtual] = ACTIONS(5111),
    [anon_sym_explicit] = ACTIONS(5111),
    [anon_sym_typename] = ACTIONS(5111),
    [anon_sym_template] = ACTIONS(5111),
    [anon_sym_operator] = ACTIONS(5111),
    [anon_sym_friend] = ACTIONS(5111),
    [anon_sym_public] = ACTIONS(5111),
    [anon_sym_private] = ACTIONS(5111),
    [anon_sym_protected] = ACTIONS(5111),
    [anon_sym_using] = ACTIONS(5111),
    [anon_sym_static_assert] = ACTIONS(5111),
    [anon_sym___launch_bounds__] = ACTIONS(5111),
  },
  [1770] = {
    [sym_identifier] = ACTIONS(2090),
    [aux_sym_preproc_def_token1] = ACTIONS(2090),
    [aux_sym_preproc_if_token1] = ACTIONS(2090),
    [aux_sym_preproc_if_token2] = ACTIONS(2090),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2090),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2090),
    [aux_sym_preproc_else_token1] = ACTIONS(2090),
    [aux_sym_preproc_elif_token1] = ACTIONS(2090),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2090),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2090),
    [sym_preproc_directive] = ACTIONS(2090),
    [anon_sym_LPAREN2] = ACTIONS(2092),
    [anon_sym_TILDE] = ACTIONS(2092),
    [anon_sym_STAR] = ACTIONS(2092),
    [anon_sym_AMP_AMP] = ACTIONS(2092),
    [anon_sym_AMP] = ACTIONS(2090),
    [anon_sym___extension__] = ACTIONS(2090),
    [anon_sym_typedef] = ACTIONS(2090),
    [anon_sym___device__] = ACTIONS(2090),
    [anon_sym___host__] = ACTIONS(2090),
    [anon_sym___global__] = ACTIONS(2090),
    [anon_sym___forceinline__] = ACTIONS(2090),
    [anon_sym___noinline__] = ACTIONS(2090),
    [anon_sym_extern] = ACTIONS(2090),
    [anon_sym___attribute__] = ACTIONS(2090),
    [anon_sym_COLON_COLON] = ACTIONS(2092),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2092),
    [anon_sym___declspec] = ACTIONS(2090),
    [anon_sym___based] = ACTIONS(2090),
    [anon_sym_signed] = ACTIONS(2090),
    [anon_sym_unsigned] = ACTIONS(2090),
    [anon_sym_long] = ACTIONS(2090),
    [anon_sym_short] = ACTIONS(2090),
    [anon_sym_LBRACK] = ACTIONS(2090),
    [anon_sym_static] = ACTIONS(2090),
    [anon_sym_register] = ACTIONS(2090),
    [anon_sym_inline] = ACTIONS(2090),
    [anon_sym___inline] = ACTIONS(2090),
    [anon_sym___inline__] = ACTIONS(2090),
    [anon_sym___forceinline] = ACTIONS(2090),
    [anon_sym_thread_local] = ACTIONS(2090),
    [anon_sym___thread] = ACTIONS(2090),
    [anon_sym_const] = ACTIONS(2090),
    [anon_sym_constexpr] = ACTIONS(2090),
    [anon_sym_volatile] = ACTIONS(2090),
    [anon_sym_restrict] = ACTIONS(2090),
    [anon_sym___restrict__] = ACTIONS(2090),
    [anon_sym__Atomic] = ACTIONS(2090),
    [anon_sym__Noreturn] = ACTIONS(2090),
    [anon_sym_noreturn] = ACTIONS(2090),
    [anon_sym_mutable] = ACTIONS(2090),
    [anon_sym_constinit] = ACTIONS(2090),
    [anon_sym_consteval] = ACTIONS(2090),
    [anon_sym___shared__] = ACTIONS(2090),
    [anon_sym___local__] = ACTIONS(2090),
    [anon_sym___constant__] = ACTIONS(2090),
    [anon_sym___managed__] = ACTIONS(2090),
    [anon_sym___grid_constant__] = ACTIONS(2090),
    [anon_sym_alignas] = ACTIONS(2090),
    [anon_sym__Alignas] = ACTIONS(2090),
    [sym_primitive_type] = ACTIONS(2090),
    [anon_sym_enum] = ACTIONS(2090),
    [anon_sym_class] = ACTIONS(2090),
    [anon_sym_struct] = ACTIONS(2090),
    [anon_sym_union] = ACTIONS(2090),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2090),
    [anon_sym_decltype] = ACTIONS(2090),
    [sym_virtual] = ACTIONS(2090),
    [anon_sym_explicit] = ACTIONS(2090),
    [anon_sym_typename] = ACTIONS(2090),
    [anon_sym_template] = ACTIONS(2090),
    [anon_sym_operator] = ACTIONS(2090),
    [anon_sym_friend] = ACTIONS(2090),
    [anon_sym_public] = ACTIONS(2090),
    [anon_sym_private] = ACTIONS(2090),
    [anon_sym_protected] = ACTIONS(2090),
    [anon_sym_using] = ACTIONS(2090),
    [anon_sym_static_assert] = ACTIONS(2090),
    [anon_sym___launch_bounds__] = ACTIONS(2090),
  },
  [1771] = {
    [sym_identifier] = ACTIONS(2162),
    [aux_sym_preproc_def_token1] = ACTIONS(2162),
    [aux_sym_preproc_if_token1] = ACTIONS(2162),
    [aux_sym_preproc_if_token2] = ACTIONS(2162),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2162),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2162),
    [aux_sym_preproc_else_token1] = ACTIONS(2162),
    [aux_sym_preproc_elif_token1] = ACTIONS(2162),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2162),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2162),
    [sym_preproc_directive] = ACTIONS(2162),
    [anon_sym_LPAREN2] = ACTIONS(2164),
    [anon_sym_TILDE] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(2164),
    [anon_sym_AMP_AMP] = ACTIONS(2164),
    [anon_sym_AMP] = ACTIONS(2162),
    [anon_sym___extension__] = ACTIONS(2162),
    [anon_sym_typedef] = ACTIONS(2162),
    [anon_sym___device__] = ACTIONS(2162),
    [anon_sym___host__] = ACTIONS(2162),
    [anon_sym___global__] = ACTIONS(2162),
    [anon_sym___forceinline__] = ACTIONS(2162),
    [anon_sym___noinline__] = ACTIONS(2162),
    [anon_sym_extern] = ACTIONS(2162),
    [anon_sym___attribute__] = ACTIONS(2162),
    [anon_sym_COLON_COLON] = ACTIONS(2164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2164),
    [anon_sym___declspec] = ACTIONS(2162),
    [anon_sym___based] = ACTIONS(2162),
    [anon_sym_signed] = ACTIONS(2162),
    [anon_sym_unsigned] = ACTIONS(2162),
    [anon_sym_long] = ACTIONS(2162),
    [anon_sym_short] = ACTIONS(2162),
    [anon_sym_LBRACK] = ACTIONS(2162),
    [anon_sym_static] = ACTIONS(2162),
    [anon_sym_register] = ACTIONS(2162),
    [anon_sym_inline] = ACTIONS(2162),
    [anon_sym___inline] = ACTIONS(2162),
    [anon_sym___inline__] = ACTIONS(2162),
    [anon_sym___forceinline] = ACTIONS(2162),
    [anon_sym_thread_local] = ACTIONS(2162),
    [anon_sym___thread] = ACTIONS(2162),
    [anon_sym_const] = ACTIONS(2162),
    [anon_sym_constexpr] = ACTIONS(2162),
    [anon_sym_volatile] = ACTIONS(2162),
    [anon_sym_restrict] = ACTIONS(2162),
    [anon_sym___restrict__] = ACTIONS(2162),
    [anon_sym__Atomic] = ACTIONS(2162),
    [anon_sym__Noreturn] = ACTIONS(2162),
    [anon_sym_noreturn] = ACTIONS(2162),
    [anon_sym_mutable] = ACTIONS(2162),
    [anon_sym_constinit] = ACTIONS(2162),
    [anon_sym_consteval] = ACTIONS(2162),
    [anon_sym___shared__] = ACTIONS(2162),
    [anon_sym___local__] = ACTIONS(2162),
    [anon_sym___constant__] = ACTIONS(2162),
    [anon_sym___managed__] = ACTIONS(2162),
    [anon_sym___grid_constant__] = ACTIONS(2162),
    [anon_sym_alignas] = ACTIONS(2162),
    [anon_sym__Alignas] = ACTIONS(2162),
    [sym_primitive_type] = ACTIONS(2162),
    [anon_sym_enum] = ACTIONS(2162),
    [anon_sym_class] = ACTIONS(2162),
    [anon_sym_struct] = ACTIONS(2162),
    [anon_sym_union] = ACTIONS(2162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2162),
    [anon_sym_decltype] = ACTIONS(2162),
    [sym_virtual] = ACTIONS(2162),
    [anon_sym_explicit] = ACTIONS(2162),
    [anon_sym_typename] = ACTIONS(2162),
    [anon_sym_template] = ACTIONS(2162),
    [anon_sym_operator] = ACTIONS(2162),
    [anon_sym_friend] = ACTIONS(2162),
    [anon_sym_public] = ACTIONS(2162),
    [anon_sym_private] = ACTIONS(2162),
    [anon_sym_protected] = ACTIONS(2162),
    [anon_sym_using] = ACTIONS(2162),
    [anon_sym_static_assert] = ACTIONS(2162),
    [anon_sym___launch_bounds__] = ACTIONS(2162),
  },
  [1772] = {
    [sym_identifier] = ACTIONS(5115),
    [aux_sym_preproc_def_token1] = ACTIONS(5115),
    [aux_sym_preproc_if_token1] = ACTIONS(5115),
    [aux_sym_preproc_if_token2] = ACTIONS(5115),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5115),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5115),
    [aux_sym_preproc_else_token1] = ACTIONS(5115),
    [aux_sym_preproc_elif_token1] = ACTIONS(5115),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5115),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5115),
    [sym_preproc_directive] = ACTIONS(5115),
    [anon_sym_LPAREN2] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(5117),
    [anon_sym_STAR] = ACTIONS(5117),
    [anon_sym_AMP_AMP] = ACTIONS(5117),
    [anon_sym_AMP] = ACTIONS(5115),
    [anon_sym___extension__] = ACTIONS(5115),
    [anon_sym_typedef] = ACTIONS(5115),
    [anon_sym___device__] = ACTIONS(5115),
    [anon_sym___host__] = ACTIONS(5115),
    [anon_sym___global__] = ACTIONS(5115),
    [anon_sym___forceinline__] = ACTIONS(5115),
    [anon_sym___noinline__] = ACTIONS(5115),
    [anon_sym_extern] = ACTIONS(5115),
    [anon_sym___attribute__] = ACTIONS(5115),
    [anon_sym_COLON_COLON] = ACTIONS(5117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5117),
    [anon_sym___declspec] = ACTIONS(5115),
    [anon_sym___based] = ACTIONS(5115),
    [anon_sym_signed] = ACTIONS(5115),
    [anon_sym_unsigned] = ACTIONS(5115),
    [anon_sym_long] = ACTIONS(5115),
    [anon_sym_short] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_static] = ACTIONS(5115),
    [anon_sym_register] = ACTIONS(5115),
    [anon_sym_inline] = ACTIONS(5115),
    [anon_sym___inline] = ACTIONS(5115),
    [anon_sym___inline__] = ACTIONS(5115),
    [anon_sym___forceinline] = ACTIONS(5115),
    [anon_sym_thread_local] = ACTIONS(5115),
    [anon_sym___thread] = ACTIONS(5115),
    [anon_sym_const] = ACTIONS(5115),
    [anon_sym_constexpr] = ACTIONS(5115),
    [anon_sym_volatile] = ACTIONS(5115),
    [anon_sym_restrict] = ACTIONS(5115),
    [anon_sym___restrict__] = ACTIONS(5115),
    [anon_sym__Atomic] = ACTIONS(5115),
    [anon_sym__Noreturn] = ACTIONS(5115),
    [anon_sym_noreturn] = ACTIONS(5115),
    [anon_sym_mutable] = ACTIONS(5115),
    [anon_sym_constinit] = ACTIONS(5115),
    [anon_sym_consteval] = ACTIONS(5115),
    [anon_sym___shared__] = ACTIONS(5115),
    [anon_sym___local__] = ACTIONS(5115),
    [anon_sym___constant__] = ACTIONS(5115),
    [anon_sym___managed__] = ACTIONS(5115),
    [anon_sym___grid_constant__] = ACTIONS(5115),
    [anon_sym_alignas] = ACTIONS(5115),
    [anon_sym__Alignas] = ACTIONS(5115),
    [sym_primitive_type] = ACTIONS(5115),
    [anon_sym_enum] = ACTIONS(5115),
    [anon_sym_class] = ACTIONS(5115),
    [anon_sym_struct] = ACTIONS(5115),
    [anon_sym_union] = ACTIONS(5115),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5115),
    [anon_sym_decltype] = ACTIONS(5115),
    [sym_virtual] = ACTIONS(5115),
    [anon_sym_explicit] = ACTIONS(5115),
    [anon_sym_typename] = ACTIONS(5115),
    [anon_sym_template] = ACTIONS(5115),
    [anon_sym_operator] = ACTIONS(5115),
    [anon_sym_friend] = ACTIONS(5115),
    [anon_sym_public] = ACTIONS(5115),
    [anon_sym_private] = ACTIONS(5115),
    [anon_sym_protected] = ACTIONS(5115),
    [anon_sym_using] = ACTIONS(5115),
    [anon_sym_static_assert] = ACTIONS(5115),
    [anon_sym___launch_bounds__] = ACTIONS(5115),
  },
  [1773] = {
    [sym_identifier] = ACTIONS(5119),
    [aux_sym_preproc_def_token1] = ACTIONS(5119),
    [aux_sym_preproc_if_token1] = ACTIONS(5119),
    [aux_sym_preproc_if_token2] = ACTIONS(5119),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5119),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5119),
    [aux_sym_preproc_else_token1] = ACTIONS(5119),
    [aux_sym_preproc_elif_token1] = ACTIONS(5119),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5119),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5119),
    [sym_preproc_directive] = ACTIONS(5119),
    [anon_sym_LPAREN2] = ACTIONS(5121),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_STAR] = ACTIONS(5121),
    [anon_sym_AMP_AMP] = ACTIONS(5121),
    [anon_sym_AMP] = ACTIONS(5119),
    [anon_sym___extension__] = ACTIONS(5119),
    [anon_sym_typedef] = ACTIONS(5119),
    [anon_sym___device__] = ACTIONS(5119),
    [anon_sym___host__] = ACTIONS(5119),
    [anon_sym___global__] = ACTIONS(5119),
    [anon_sym___forceinline__] = ACTIONS(5119),
    [anon_sym___noinline__] = ACTIONS(5119),
    [anon_sym_extern] = ACTIONS(5119),
    [anon_sym___attribute__] = ACTIONS(5119),
    [anon_sym_COLON_COLON] = ACTIONS(5121),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5121),
    [anon_sym___declspec] = ACTIONS(5119),
    [anon_sym___based] = ACTIONS(5119),
    [anon_sym_signed] = ACTIONS(5119),
    [anon_sym_unsigned] = ACTIONS(5119),
    [anon_sym_long] = ACTIONS(5119),
    [anon_sym_short] = ACTIONS(5119),
    [anon_sym_LBRACK] = ACTIONS(5119),
    [anon_sym_static] = ACTIONS(5119),
    [anon_sym_register] = ACTIONS(5119),
    [anon_sym_inline] = ACTIONS(5119),
    [anon_sym___inline] = ACTIONS(5119),
    [anon_sym___inline__] = ACTIONS(5119),
    [anon_sym___forceinline] = ACTIONS(5119),
    [anon_sym_thread_local] = ACTIONS(5119),
    [anon_sym___thread] = ACTIONS(5119),
    [anon_sym_const] = ACTIONS(5119),
    [anon_sym_constexpr] = ACTIONS(5119),
    [anon_sym_volatile] = ACTIONS(5119),
    [anon_sym_restrict] = ACTIONS(5119),
    [anon_sym___restrict__] = ACTIONS(5119),
    [anon_sym__Atomic] = ACTIONS(5119),
    [anon_sym__Noreturn] = ACTIONS(5119),
    [anon_sym_noreturn] = ACTIONS(5119),
    [anon_sym_mutable] = ACTIONS(5119),
    [anon_sym_constinit] = ACTIONS(5119),
    [anon_sym_consteval] = ACTIONS(5119),
    [anon_sym___shared__] = ACTIONS(5119),
    [anon_sym___local__] = ACTIONS(5119),
    [anon_sym___constant__] = ACTIONS(5119),
    [anon_sym___managed__] = ACTIONS(5119),
    [anon_sym___grid_constant__] = ACTIONS(5119),
    [anon_sym_alignas] = ACTIONS(5119),
    [anon_sym__Alignas] = ACTIONS(5119),
    [sym_primitive_type] = ACTIONS(5119),
    [anon_sym_enum] = ACTIONS(5119),
    [anon_sym_class] = ACTIONS(5119),
    [anon_sym_struct] = ACTIONS(5119),
    [anon_sym_union] = ACTIONS(5119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5119),
    [anon_sym_decltype] = ACTIONS(5119),
    [sym_virtual] = ACTIONS(5119),
    [anon_sym_explicit] = ACTIONS(5119),
    [anon_sym_typename] = ACTIONS(5119),
    [anon_sym_template] = ACTIONS(5119),
    [anon_sym_operator] = ACTIONS(5119),
    [anon_sym_friend] = ACTIONS(5119),
    [anon_sym_public] = ACTIONS(5119),
    [anon_sym_private] = ACTIONS(5119),
    [anon_sym_protected] = ACTIONS(5119),
    [anon_sym_using] = ACTIONS(5119),
    [anon_sym_static_assert] = ACTIONS(5119),
    [anon_sym___launch_bounds__] = ACTIONS(5119),
  },
  [1774] = {
    [sym_identifier] = ACTIONS(5115),
    [aux_sym_preproc_def_token1] = ACTIONS(5115),
    [aux_sym_preproc_if_token1] = ACTIONS(5115),
    [aux_sym_preproc_if_token2] = ACTIONS(5115),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5115),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5115),
    [aux_sym_preproc_else_token1] = ACTIONS(5115),
    [aux_sym_preproc_elif_token1] = ACTIONS(5115),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5115),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5115),
    [sym_preproc_directive] = ACTIONS(5115),
    [anon_sym_LPAREN2] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(5117),
    [anon_sym_STAR] = ACTIONS(5117),
    [anon_sym_AMP_AMP] = ACTIONS(5117),
    [anon_sym_AMP] = ACTIONS(5115),
    [anon_sym___extension__] = ACTIONS(5115),
    [anon_sym_typedef] = ACTIONS(5115),
    [anon_sym___device__] = ACTIONS(5115),
    [anon_sym___host__] = ACTIONS(5115),
    [anon_sym___global__] = ACTIONS(5115),
    [anon_sym___forceinline__] = ACTIONS(5115),
    [anon_sym___noinline__] = ACTIONS(5115),
    [anon_sym_extern] = ACTIONS(5115),
    [anon_sym___attribute__] = ACTIONS(5115),
    [anon_sym_COLON_COLON] = ACTIONS(5117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5117),
    [anon_sym___declspec] = ACTIONS(5115),
    [anon_sym___based] = ACTIONS(5115),
    [anon_sym_signed] = ACTIONS(5115),
    [anon_sym_unsigned] = ACTIONS(5115),
    [anon_sym_long] = ACTIONS(5115),
    [anon_sym_short] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_static] = ACTIONS(5115),
    [anon_sym_register] = ACTIONS(5115),
    [anon_sym_inline] = ACTIONS(5115),
    [anon_sym___inline] = ACTIONS(5115),
    [anon_sym___inline__] = ACTIONS(5115),
    [anon_sym___forceinline] = ACTIONS(5115),
    [anon_sym_thread_local] = ACTIONS(5115),
    [anon_sym___thread] = ACTIONS(5115),
    [anon_sym_const] = ACTIONS(5115),
    [anon_sym_constexpr] = ACTIONS(5115),
    [anon_sym_volatile] = ACTIONS(5115),
    [anon_sym_restrict] = ACTIONS(5115),
    [anon_sym___restrict__] = ACTIONS(5115),
    [anon_sym__Atomic] = ACTIONS(5115),
    [anon_sym__Noreturn] = ACTIONS(5115),
    [anon_sym_noreturn] = ACTIONS(5115),
    [anon_sym_mutable] = ACTIONS(5115),
    [anon_sym_constinit] = ACTIONS(5115),
    [anon_sym_consteval] = ACTIONS(5115),
    [anon_sym___shared__] = ACTIONS(5115),
    [anon_sym___local__] = ACTIONS(5115),
    [anon_sym___constant__] = ACTIONS(5115),
    [anon_sym___managed__] = ACTIONS(5115),
    [anon_sym___grid_constant__] = ACTIONS(5115),
    [anon_sym_alignas] = ACTIONS(5115),
    [anon_sym__Alignas] = ACTIONS(5115),
    [sym_primitive_type] = ACTIONS(5115),
    [anon_sym_enum] = ACTIONS(5115),
    [anon_sym_class] = ACTIONS(5115),
    [anon_sym_struct] = ACTIONS(5115),
    [anon_sym_union] = ACTIONS(5115),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5115),
    [anon_sym_decltype] = ACTIONS(5115),
    [sym_virtual] = ACTIONS(5115),
    [anon_sym_explicit] = ACTIONS(5115),
    [anon_sym_typename] = ACTIONS(5115),
    [anon_sym_template] = ACTIONS(5115),
    [anon_sym_operator] = ACTIONS(5115),
    [anon_sym_friend] = ACTIONS(5115),
    [anon_sym_public] = ACTIONS(5115),
    [anon_sym_private] = ACTIONS(5115),
    [anon_sym_protected] = ACTIONS(5115),
    [anon_sym_using] = ACTIONS(5115),
    [anon_sym_static_assert] = ACTIONS(5115),
    [anon_sym___launch_bounds__] = ACTIONS(5115),
  },
  [1775] = {
    [sym_identifier] = ACTIONS(5119),
    [aux_sym_preproc_def_token1] = ACTIONS(5119),
    [aux_sym_preproc_if_token1] = ACTIONS(5119),
    [aux_sym_preproc_if_token2] = ACTIONS(5119),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5119),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5119),
    [aux_sym_preproc_else_token1] = ACTIONS(5119),
    [aux_sym_preproc_elif_token1] = ACTIONS(5119),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5119),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5119),
    [sym_preproc_directive] = ACTIONS(5119),
    [anon_sym_LPAREN2] = ACTIONS(5121),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_STAR] = ACTIONS(5121),
    [anon_sym_AMP_AMP] = ACTIONS(5121),
    [anon_sym_AMP] = ACTIONS(5119),
    [anon_sym___extension__] = ACTIONS(5119),
    [anon_sym_typedef] = ACTIONS(5119),
    [anon_sym___device__] = ACTIONS(5119),
    [anon_sym___host__] = ACTIONS(5119),
    [anon_sym___global__] = ACTIONS(5119),
    [anon_sym___forceinline__] = ACTIONS(5119),
    [anon_sym___noinline__] = ACTIONS(5119),
    [anon_sym_extern] = ACTIONS(5119),
    [anon_sym___attribute__] = ACTIONS(5119),
    [anon_sym_COLON_COLON] = ACTIONS(5121),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5121),
    [anon_sym___declspec] = ACTIONS(5119),
    [anon_sym___based] = ACTIONS(5119),
    [anon_sym_signed] = ACTIONS(5119),
    [anon_sym_unsigned] = ACTIONS(5119),
    [anon_sym_long] = ACTIONS(5119),
    [anon_sym_short] = ACTIONS(5119),
    [anon_sym_LBRACK] = ACTIONS(5119),
    [anon_sym_static] = ACTIONS(5119),
    [anon_sym_register] = ACTIONS(5119),
    [anon_sym_inline] = ACTIONS(5119),
    [anon_sym___inline] = ACTIONS(5119),
    [anon_sym___inline__] = ACTIONS(5119),
    [anon_sym___forceinline] = ACTIONS(5119),
    [anon_sym_thread_local] = ACTIONS(5119),
    [anon_sym___thread] = ACTIONS(5119),
    [anon_sym_const] = ACTIONS(5119),
    [anon_sym_constexpr] = ACTIONS(5119),
    [anon_sym_volatile] = ACTIONS(5119),
    [anon_sym_restrict] = ACTIONS(5119),
    [anon_sym___restrict__] = ACTIONS(5119),
    [anon_sym__Atomic] = ACTIONS(5119),
    [anon_sym__Noreturn] = ACTIONS(5119),
    [anon_sym_noreturn] = ACTIONS(5119),
    [anon_sym_mutable] = ACTIONS(5119),
    [anon_sym_constinit] = ACTIONS(5119),
    [anon_sym_consteval] = ACTIONS(5119),
    [anon_sym___shared__] = ACTIONS(5119),
    [anon_sym___local__] = ACTIONS(5119),
    [anon_sym___constant__] = ACTIONS(5119),
    [anon_sym___managed__] = ACTIONS(5119),
    [anon_sym___grid_constant__] = ACTIONS(5119),
    [anon_sym_alignas] = ACTIONS(5119),
    [anon_sym__Alignas] = ACTIONS(5119),
    [sym_primitive_type] = ACTIONS(5119),
    [anon_sym_enum] = ACTIONS(5119),
    [anon_sym_class] = ACTIONS(5119),
    [anon_sym_struct] = ACTIONS(5119),
    [anon_sym_union] = ACTIONS(5119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5119),
    [anon_sym_decltype] = ACTIONS(5119),
    [sym_virtual] = ACTIONS(5119),
    [anon_sym_explicit] = ACTIONS(5119),
    [anon_sym_typename] = ACTIONS(5119),
    [anon_sym_template] = ACTIONS(5119),
    [anon_sym_operator] = ACTIONS(5119),
    [anon_sym_friend] = ACTIONS(5119),
    [anon_sym_public] = ACTIONS(5119),
    [anon_sym_private] = ACTIONS(5119),
    [anon_sym_protected] = ACTIONS(5119),
    [anon_sym_using] = ACTIONS(5119),
    [anon_sym_static_assert] = ACTIONS(5119),
    [anon_sym___launch_bounds__] = ACTIONS(5119),
  },
  [1776] = {
    [sym_identifier] = ACTIONS(5123),
    [aux_sym_preproc_def_token1] = ACTIONS(5123),
    [aux_sym_preproc_if_token1] = ACTIONS(5123),
    [aux_sym_preproc_if_token2] = ACTIONS(5123),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5123),
    [aux_sym_preproc_else_token1] = ACTIONS(5123),
    [aux_sym_preproc_elif_token1] = ACTIONS(5123),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5123),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5123),
    [sym_preproc_directive] = ACTIONS(5123),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_TILDE] = ACTIONS(5125),
    [anon_sym_STAR] = ACTIONS(5125),
    [anon_sym_AMP_AMP] = ACTIONS(5125),
    [anon_sym_AMP] = ACTIONS(5123),
    [anon_sym___extension__] = ACTIONS(5123),
    [anon_sym_typedef] = ACTIONS(5123),
    [anon_sym___device__] = ACTIONS(5123),
    [anon_sym___host__] = ACTIONS(5123),
    [anon_sym___global__] = ACTIONS(5123),
    [anon_sym___forceinline__] = ACTIONS(5123),
    [anon_sym___noinline__] = ACTIONS(5123),
    [anon_sym_extern] = ACTIONS(5123),
    [anon_sym___attribute__] = ACTIONS(5123),
    [anon_sym_COLON_COLON] = ACTIONS(5125),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5125),
    [anon_sym___declspec] = ACTIONS(5123),
    [anon_sym___based] = ACTIONS(5123),
    [anon_sym_signed] = ACTIONS(5123),
    [anon_sym_unsigned] = ACTIONS(5123),
    [anon_sym_long] = ACTIONS(5123),
    [anon_sym_short] = ACTIONS(5123),
    [anon_sym_LBRACK] = ACTIONS(5123),
    [anon_sym_static] = ACTIONS(5123),
    [anon_sym_register] = ACTIONS(5123),
    [anon_sym_inline] = ACTIONS(5123),
    [anon_sym___inline] = ACTIONS(5123),
    [anon_sym___inline__] = ACTIONS(5123),
    [anon_sym___forceinline] = ACTIONS(5123),
    [anon_sym_thread_local] = ACTIONS(5123),
    [anon_sym___thread] = ACTIONS(5123),
    [anon_sym_const] = ACTIONS(5123),
    [anon_sym_constexpr] = ACTIONS(5123),
    [anon_sym_volatile] = ACTIONS(5123),
    [anon_sym_restrict] = ACTIONS(5123),
    [anon_sym___restrict__] = ACTIONS(5123),
    [anon_sym__Atomic] = ACTIONS(5123),
    [anon_sym__Noreturn] = ACTIONS(5123),
    [anon_sym_noreturn] = ACTIONS(5123),
    [anon_sym_mutable] = ACTIONS(5123),
    [anon_sym_constinit] = ACTIONS(5123),
    [anon_sym_consteval] = ACTIONS(5123),
    [anon_sym___shared__] = ACTIONS(5123),
    [anon_sym___local__] = ACTIONS(5123),
    [anon_sym___constant__] = ACTIONS(5123),
    [anon_sym___managed__] = ACTIONS(5123),
    [anon_sym___grid_constant__] = ACTIONS(5123),
    [anon_sym_alignas] = ACTIONS(5123),
    [anon_sym__Alignas] = ACTIONS(5123),
    [sym_primitive_type] = ACTIONS(5123),
    [anon_sym_enum] = ACTIONS(5123),
    [anon_sym_class] = ACTIONS(5123),
    [anon_sym_struct] = ACTIONS(5123),
    [anon_sym_union] = ACTIONS(5123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5123),
    [anon_sym_decltype] = ACTIONS(5123),
    [sym_virtual] = ACTIONS(5123),
    [anon_sym_explicit] = ACTIONS(5123),
    [anon_sym_typename] = ACTIONS(5123),
    [anon_sym_template] = ACTIONS(5123),
    [anon_sym_operator] = ACTIONS(5123),
    [anon_sym_friend] = ACTIONS(5123),
    [anon_sym_public] = ACTIONS(5123),
    [anon_sym_private] = ACTIONS(5123),
    [anon_sym_protected] = ACTIONS(5123),
    [anon_sym_using] = ACTIONS(5123),
    [anon_sym_static_assert] = ACTIONS(5123),
    [anon_sym___launch_bounds__] = ACTIONS(5123),
  },
  [1777] = {
    [sym_identifier] = ACTIONS(5127),
    [aux_sym_preproc_def_token1] = ACTIONS(5127),
    [aux_sym_preproc_if_token1] = ACTIONS(5127),
    [aux_sym_preproc_if_token2] = ACTIONS(5127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5127),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5127),
    [aux_sym_preproc_else_token1] = ACTIONS(5127),
    [aux_sym_preproc_elif_token1] = ACTIONS(5127),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5127),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5127),
    [sym_preproc_directive] = ACTIONS(5127),
    [anon_sym_LPAREN2] = ACTIONS(5129),
    [anon_sym_TILDE] = ACTIONS(5129),
    [anon_sym_STAR] = ACTIONS(5129),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5127),
    [anon_sym___extension__] = ACTIONS(5127),
    [anon_sym_typedef] = ACTIONS(5127),
    [anon_sym___device__] = ACTIONS(5127),
    [anon_sym___host__] = ACTIONS(5127),
    [anon_sym___global__] = ACTIONS(5127),
    [anon_sym___forceinline__] = ACTIONS(5127),
    [anon_sym___noinline__] = ACTIONS(5127),
    [anon_sym_extern] = ACTIONS(5127),
    [anon_sym___attribute__] = ACTIONS(5127),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5129),
    [anon_sym___declspec] = ACTIONS(5127),
    [anon_sym___based] = ACTIONS(5127),
    [anon_sym_signed] = ACTIONS(5127),
    [anon_sym_unsigned] = ACTIONS(5127),
    [anon_sym_long] = ACTIONS(5127),
    [anon_sym_short] = ACTIONS(5127),
    [anon_sym_LBRACK] = ACTIONS(5127),
    [anon_sym_static] = ACTIONS(5127),
    [anon_sym_register] = ACTIONS(5127),
    [anon_sym_inline] = ACTIONS(5127),
    [anon_sym___inline] = ACTIONS(5127),
    [anon_sym___inline__] = ACTIONS(5127),
    [anon_sym___forceinline] = ACTIONS(5127),
    [anon_sym_thread_local] = ACTIONS(5127),
    [anon_sym___thread] = ACTIONS(5127),
    [anon_sym_const] = ACTIONS(5127),
    [anon_sym_constexpr] = ACTIONS(5127),
    [anon_sym_volatile] = ACTIONS(5127),
    [anon_sym_restrict] = ACTIONS(5127),
    [anon_sym___restrict__] = ACTIONS(5127),
    [anon_sym__Atomic] = ACTIONS(5127),
    [anon_sym__Noreturn] = ACTIONS(5127),
    [anon_sym_noreturn] = ACTIONS(5127),
    [anon_sym_mutable] = ACTIONS(5127),
    [anon_sym_constinit] = ACTIONS(5127),
    [anon_sym_consteval] = ACTIONS(5127),
    [anon_sym___shared__] = ACTIONS(5127),
    [anon_sym___local__] = ACTIONS(5127),
    [anon_sym___constant__] = ACTIONS(5127),
    [anon_sym___managed__] = ACTIONS(5127),
    [anon_sym___grid_constant__] = ACTIONS(5127),
    [anon_sym_alignas] = ACTIONS(5127),
    [anon_sym__Alignas] = ACTIONS(5127),
    [sym_primitive_type] = ACTIONS(5127),
    [anon_sym_enum] = ACTIONS(5127),
    [anon_sym_class] = ACTIONS(5127),
    [anon_sym_struct] = ACTIONS(5127),
    [anon_sym_union] = ACTIONS(5127),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5127),
    [anon_sym_decltype] = ACTIONS(5127),
    [sym_virtual] = ACTIONS(5127),
    [anon_sym_explicit] = ACTIONS(5127),
    [anon_sym_typename] = ACTIONS(5127),
    [anon_sym_template] = ACTIONS(5127),
    [anon_sym_operator] = ACTIONS(5127),
    [anon_sym_friend] = ACTIONS(5127),
    [anon_sym_public] = ACTIONS(5127),
    [anon_sym_private] = ACTIONS(5127),
    [anon_sym_protected] = ACTIONS(5127),
    [anon_sym_using] = ACTIONS(5127),
    [anon_sym_static_assert] = ACTIONS(5127),
    [anon_sym___launch_bounds__] = ACTIONS(5127),
  },
  [1778] = {
    [sym_identifier] = ACTIONS(2392),
    [aux_sym_preproc_def_token1] = ACTIONS(2392),
    [aux_sym_preproc_if_token1] = ACTIONS(2392),
    [aux_sym_preproc_if_token2] = ACTIONS(2392),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2392),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2392),
    [aux_sym_preproc_else_token1] = ACTIONS(2392),
    [aux_sym_preproc_elif_token1] = ACTIONS(2392),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2392),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2392),
    [sym_preproc_directive] = ACTIONS(2392),
    [anon_sym_LPAREN2] = ACTIONS(2394),
    [anon_sym_TILDE] = ACTIONS(2394),
    [anon_sym_STAR] = ACTIONS(2394),
    [anon_sym_AMP_AMP] = ACTIONS(2394),
    [anon_sym_AMP] = ACTIONS(2392),
    [anon_sym___extension__] = ACTIONS(2392),
    [anon_sym_typedef] = ACTIONS(2392),
    [anon_sym___device__] = ACTIONS(2392),
    [anon_sym___host__] = ACTIONS(2392),
    [anon_sym___global__] = ACTIONS(2392),
    [anon_sym___forceinline__] = ACTIONS(2392),
    [anon_sym___noinline__] = ACTIONS(2392),
    [anon_sym_extern] = ACTIONS(2392),
    [anon_sym___attribute__] = ACTIONS(2392),
    [anon_sym_COLON_COLON] = ACTIONS(2394),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2394),
    [anon_sym___declspec] = ACTIONS(2392),
    [anon_sym___based] = ACTIONS(2392),
    [anon_sym_signed] = ACTIONS(2392),
    [anon_sym_unsigned] = ACTIONS(2392),
    [anon_sym_long] = ACTIONS(2392),
    [anon_sym_short] = ACTIONS(2392),
    [anon_sym_LBRACK] = ACTIONS(2392),
    [anon_sym_static] = ACTIONS(2392),
    [anon_sym_register] = ACTIONS(2392),
    [anon_sym_inline] = ACTIONS(2392),
    [anon_sym___inline] = ACTIONS(2392),
    [anon_sym___inline__] = ACTIONS(2392),
    [anon_sym___forceinline] = ACTIONS(2392),
    [anon_sym_thread_local] = ACTIONS(2392),
    [anon_sym___thread] = ACTIONS(2392),
    [anon_sym_const] = ACTIONS(2392),
    [anon_sym_constexpr] = ACTIONS(2392),
    [anon_sym_volatile] = ACTIONS(2392),
    [anon_sym_restrict] = ACTIONS(2392),
    [anon_sym___restrict__] = ACTIONS(2392),
    [anon_sym__Atomic] = ACTIONS(2392),
    [anon_sym__Noreturn] = ACTIONS(2392),
    [anon_sym_noreturn] = ACTIONS(2392),
    [anon_sym_mutable] = ACTIONS(2392),
    [anon_sym_constinit] = ACTIONS(2392),
    [anon_sym_consteval] = ACTIONS(2392),
    [anon_sym___shared__] = ACTIONS(2392),
    [anon_sym___local__] = ACTIONS(2392),
    [anon_sym___constant__] = ACTIONS(2392),
    [anon_sym___managed__] = ACTIONS(2392),
    [anon_sym___grid_constant__] = ACTIONS(2392),
    [anon_sym_alignas] = ACTIONS(2392),
    [anon_sym__Alignas] = ACTIONS(2392),
    [sym_primitive_type] = ACTIONS(2392),
    [anon_sym_enum] = ACTIONS(2392),
    [anon_sym_class] = ACTIONS(2392),
    [anon_sym_struct] = ACTIONS(2392),
    [anon_sym_union] = ACTIONS(2392),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2392),
    [anon_sym_decltype] = ACTIONS(2392),
    [sym_virtual] = ACTIONS(2392),
    [anon_sym_explicit] = ACTIONS(2392),
    [anon_sym_typename] = ACTIONS(2392),
    [anon_sym_template] = ACTIONS(2392),
    [anon_sym_operator] = ACTIONS(2392),
    [anon_sym_friend] = ACTIONS(2392),
    [anon_sym_public] = ACTIONS(2392),
    [anon_sym_private] = ACTIONS(2392),
    [anon_sym_protected] = ACTIONS(2392),
    [anon_sym_using] = ACTIONS(2392),
    [anon_sym_static_assert] = ACTIONS(2392),
    [anon_sym___launch_bounds__] = ACTIONS(2392),
  },
  [1779] = {
    [sym_identifier] = ACTIONS(2388),
    [aux_sym_preproc_def_token1] = ACTIONS(2388),
    [aux_sym_preproc_if_token1] = ACTIONS(2388),
    [aux_sym_preproc_if_token2] = ACTIONS(2388),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2388),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2388),
    [aux_sym_preproc_else_token1] = ACTIONS(2388),
    [aux_sym_preproc_elif_token1] = ACTIONS(2388),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2388),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2388),
    [sym_preproc_directive] = ACTIONS(2388),
    [anon_sym_LPAREN2] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [anon_sym_STAR] = ACTIONS(2390),
    [anon_sym_AMP_AMP] = ACTIONS(2390),
    [anon_sym_AMP] = ACTIONS(2388),
    [anon_sym___extension__] = ACTIONS(2388),
    [anon_sym_typedef] = ACTIONS(2388),
    [anon_sym___device__] = ACTIONS(2388),
    [anon_sym___host__] = ACTIONS(2388),
    [anon_sym___global__] = ACTIONS(2388),
    [anon_sym___forceinline__] = ACTIONS(2388),
    [anon_sym___noinline__] = ACTIONS(2388),
    [anon_sym_extern] = ACTIONS(2388),
    [anon_sym___attribute__] = ACTIONS(2388),
    [anon_sym_COLON_COLON] = ACTIONS(2390),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2390),
    [anon_sym___declspec] = ACTIONS(2388),
    [anon_sym___based] = ACTIONS(2388),
    [anon_sym_signed] = ACTIONS(2388),
    [anon_sym_unsigned] = ACTIONS(2388),
    [anon_sym_long] = ACTIONS(2388),
    [anon_sym_short] = ACTIONS(2388),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [anon_sym_static] = ACTIONS(2388),
    [anon_sym_register] = ACTIONS(2388),
    [anon_sym_inline] = ACTIONS(2388),
    [anon_sym___inline] = ACTIONS(2388),
    [anon_sym___inline__] = ACTIONS(2388),
    [anon_sym___forceinline] = ACTIONS(2388),
    [anon_sym_thread_local] = ACTIONS(2388),
    [anon_sym___thread] = ACTIONS(2388),
    [anon_sym_const] = ACTIONS(2388),
    [anon_sym_constexpr] = ACTIONS(2388),
    [anon_sym_volatile] = ACTIONS(2388),
    [anon_sym_restrict] = ACTIONS(2388),
    [anon_sym___restrict__] = ACTIONS(2388),
    [anon_sym__Atomic] = ACTIONS(2388),
    [anon_sym__Noreturn] = ACTIONS(2388),
    [anon_sym_noreturn] = ACTIONS(2388),
    [anon_sym_mutable] = ACTIONS(2388),
    [anon_sym_constinit] = ACTIONS(2388),
    [anon_sym_consteval] = ACTIONS(2388),
    [anon_sym___shared__] = ACTIONS(2388),
    [anon_sym___local__] = ACTIONS(2388),
    [anon_sym___constant__] = ACTIONS(2388),
    [anon_sym___managed__] = ACTIONS(2388),
    [anon_sym___grid_constant__] = ACTIONS(2388),
    [anon_sym_alignas] = ACTIONS(2388),
    [anon_sym__Alignas] = ACTIONS(2388),
    [sym_primitive_type] = ACTIONS(2388),
    [anon_sym_enum] = ACTIONS(2388),
    [anon_sym_class] = ACTIONS(2388),
    [anon_sym_struct] = ACTIONS(2388),
    [anon_sym_union] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2388),
    [anon_sym_decltype] = ACTIONS(2388),
    [sym_virtual] = ACTIONS(2388),
    [anon_sym_explicit] = ACTIONS(2388),
    [anon_sym_typename] = ACTIONS(2388),
    [anon_sym_template] = ACTIONS(2388),
    [anon_sym_operator] = ACTIONS(2388),
    [anon_sym_friend] = ACTIONS(2388),
    [anon_sym_public] = ACTIONS(2388),
    [anon_sym_private] = ACTIONS(2388),
    [anon_sym_protected] = ACTIONS(2388),
    [anon_sym_using] = ACTIONS(2388),
    [anon_sym_static_assert] = ACTIONS(2388),
    [anon_sym___launch_bounds__] = ACTIONS(2388),
  },
  [1780] = {
    [sym_identifier] = ACTIONS(5131),
    [aux_sym_preproc_def_token1] = ACTIONS(5131),
    [aux_sym_preproc_if_token1] = ACTIONS(5131),
    [aux_sym_preproc_if_token2] = ACTIONS(5131),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5131),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5131),
    [aux_sym_preproc_else_token1] = ACTIONS(5131),
    [aux_sym_preproc_elif_token1] = ACTIONS(5131),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5131),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5131),
    [sym_preproc_directive] = ACTIONS(5131),
    [anon_sym_LPAREN2] = ACTIONS(5133),
    [anon_sym_TILDE] = ACTIONS(5133),
    [anon_sym_STAR] = ACTIONS(5133),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5131),
    [anon_sym___extension__] = ACTIONS(5131),
    [anon_sym_typedef] = ACTIONS(5131),
    [anon_sym___device__] = ACTIONS(5131),
    [anon_sym___host__] = ACTIONS(5131),
    [anon_sym___global__] = ACTIONS(5131),
    [anon_sym___forceinline__] = ACTIONS(5131),
    [anon_sym___noinline__] = ACTIONS(5131),
    [anon_sym_extern] = ACTIONS(5131),
    [anon_sym___attribute__] = ACTIONS(5131),
    [anon_sym_COLON_COLON] = ACTIONS(5133),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5133),
    [anon_sym___declspec] = ACTIONS(5131),
    [anon_sym___based] = ACTIONS(5131),
    [anon_sym_signed] = ACTIONS(5131),
    [anon_sym_unsigned] = ACTIONS(5131),
    [anon_sym_long] = ACTIONS(5131),
    [anon_sym_short] = ACTIONS(5131),
    [anon_sym_LBRACK] = ACTIONS(5131),
    [anon_sym_static] = ACTIONS(5131),
    [anon_sym_register] = ACTIONS(5131),
    [anon_sym_inline] = ACTIONS(5131),
    [anon_sym___inline] = ACTIONS(5131),
    [anon_sym___inline__] = ACTIONS(5131),
    [anon_sym___forceinline] = ACTIONS(5131),
    [anon_sym_thread_local] = ACTIONS(5131),
    [anon_sym___thread] = ACTIONS(5131),
    [anon_sym_const] = ACTIONS(5131),
    [anon_sym_constexpr] = ACTIONS(5131),
    [anon_sym_volatile] = ACTIONS(5131),
    [anon_sym_restrict] = ACTIONS(5131),
    [anon_sym___restrict__] = ACTIONS(5131),
    [anon_sym__Atomic] = ACTIONS(5131),
    [anon_sym__Noreturn] = ACTIONS(5131),
    [anon_sym_noreturn] = ACTIONS(5131),
    [anon_sym_mutable] = ACTIONS(5131),
    [anon_sym_constinit] = ACTIONS(5131),
    [anon_sym_consteval] = ACTIONS(5131),
    [anon_sym___shared__] = ACTIONS(5131),
    [anon_sym___local__] = ACTIONS(5131),
    [anon_sym___constant__] = ACTIONS(5131),
    [anon_sym___managed__] = ACTIONS(5131),
    [anon_sym___grid_constant__] = ACTIONS(5131),
    [anon_sym_alignas] = ACTIONS(5131),
    [anon_sym__Alignas] = ACTIONS(5131),
    [sym_primitive_type] = ACTIONS(5131),
    [anon_sym_enum] = ACTIONS(5131),
    [anon_sym_class] = ACTIONS(5131),
    [anon_sym_struct] = ACTIONS(5131),
    [anon_sym_union] = ACTIONS(5131),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5131),
    [anon_sym_decltype] = ACTIONS(5131),
    [sym_virtual] = ACTIONS(5131),
    [anon_sym_explicit] = ACTIONS(5131),
    [anon_sym_typename] = ACTIONS(5131),
    [anon_sym_template] = ACTIONS(5131),
    [anon_sym_operator] = ACTIONS(5131),
    [anon_sym_friend] = ACTIONS(5131),
    [anon_sym_public] = ACTIONS(5131),
    [anon_sym_private] = ACTIONS(5131),
    [anon_sym_protected] = ACTIONS(5131),
    [anon_sym_using] = ACTIONS(5131),
    [anon_sym_static_assert] = ACTIONS(5131),
    [anon_sym___launch_bounds__] = ACTIONS(5131),
  },
  [1781] = {
    [sym_identifier] = ACTIONS(5131),
    [aux_sym_preproc_def_token1] = ACTIONS(5131),
    [aux_sym_preproc_if_token1] = ACTIONS(5131),
    [aux_sym_preproc_if_token2] = ACTIONS(5131),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5131),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5131),
    [aux_sym_preproc_else_token1] = ACTIONS(5131),
    [aux_sym_preproc_elif_token1] = ACTIONS(5131),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5131),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5131),
    [sym_preproc_directive] = ACTIONS(5131),
    [anon_sym_LPAREN2] = ACTIONS(5133),
    [anon_sym_TILDE] = ACTIONS(5133),
    [anon_sym_STAR] = ACTIONS(5133),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5131),
    [anon_sym___extension__] = ACTIONS(5131),
    [anon_sym_typedef] = ACTIONS(5131),
    [anon_sym___device__] = ACTIONS(5131),
    [anon_sym___host__] = ACTIONS(5131),
    [anon_sym___global__] = ACTIONS(5131),
    [anon_sym___forceinline__] = ACTIONS(5131),
    [anon_sym___noinline__] = ACTIONS(5131),
    [anon_sym_extern] = ACTIONS(5131),
    [anon_sym___attribute__] = ACTIONS(5131),
    [anon_sym_COLON_COLON] = ACTIONS(5133),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5133),
    [anon_sym___declspec] = ACTIONS(5131),
    [anon_sym___based] = ACTIONS(5131),
    [anon_sym_signed] = ACTIONS(5131),
    [anon_sym_unsigned] = ACTIONS(5131),
    [anon_sym_long] = ACTIONS(5131),
    [anon_sym_short] = ACTIONS(5131),
    [anon_sym_LBRACK] = ACTIONS(5131),
    [anon_sym_static] = ACTIONS(5131),
    [anon_sym_register] = ACTIONS(5131),
    [anon_sym_inline] = ACTIONS(5131),
    [anon_sym___inline] = ACTIONS(5131),
    [anon_sym___inline__] = ACTIONS(5131),
    [anon_sym___forceinline] = ACTIONS(5131),
    [anon_sym_thread_local] = ACTIONS(5131),
    [anon_sym___thread] = ACTIONS(5131),
    [anon_sym_const] = ACTIONS(5131),
    [anon_sym_constexpr] = ACTIONS(5131),
    [anon_sym_volatile] = ACTIONS(5131),
    [anon_sym_restrict] = ACTIONS(5131),
    [anon_sym___restrict__] = ACTIONS(5131),
    [anon_sym__Atomic] = ACTIONS(5131),
    [anon_sym__Noreturn] = ACTIONS(5131),
    [anon_sym_noreturn] = ACTIONS(5131),
    [anon_sym_mutable] = ACTIONS(5131),
    [anon_sym_constinit] = ACTIONS(5131),
    [anon_sym_consteval] = ACTIONS(5131),
    [anon_sym___shared__] = ACTIONS(5131),
    [anon_sym___local__] = ACTIONS(5131),
    [anon_sym___constant__] = ACTIONS(5131),
    [anon_sym___managed__] = ACTIONS(5131),
    [anon_sym___grid_constant__] = ACTIONS(5131),
    [anon_sym_alignas] = ACTIONS(5131),
    [anon_sym__Alignas] = ACTIONS(5131),
    [sym_primitive_type] = ACTIONS(5131),
    [anon_sym_enum] = ACTIONS(5131),
    [anon_sym_class] = ACTIONS(5131),
    [anon_sym_struct] = ACTIONS(5131),
    [anon_sym_union] = ACTIONS(5131),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5131),
    [anon_sym_decltype] = ACTIONS(5131),
    [sym_virtual] = ACTIONS(5131),
    [anon_sym_explicit] = ACTIONS(5131),
    [anon_sym_typename] = ACTIONS(5131),
    [anon_sym_template] = ACTIONS(5131),
    [anon_sym_operator] = ACTIONS(5131),
    [anon_sym_friend] = ACTIONS(5131),
    [anon_sym_public] = ACTIONS(5131),
    [anon_sym_private] = ACTIONS(5131),
    [anon_sym_protected] = ACTIONS(5131),
    [anon_sym_using] = ACTIONS(5131),
    [anon_sym_static_assert] = ACTIONS(5131),
    [anon_sym___launch_bounds__] = ACTIONS(5131),
  },
  [1782] = {
    [sym_identifier] = ACTIONS(1954),
    [aux_sym_preproc_def_token1] = ACTIONS(1954),
    [aux_sym_preproc_if_token1] = ACTIONS(1954),
    [aux_sym_preproc_if_token2] = ACTIONS(1954),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1954),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1954),
    [aux_sym_preproc_else_token1] = ACTIONS(1954),
    [aux_sym_preproc_elif_token1] = ACTIONS(1954),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1954),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1954),
    [sym_preproc_directive] = ACTIONS(1954),
    [anon_sym_LPAREN2] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [anon_sym_STAR] = ACTIONS(1956),
    [anon_sym_AMP_AMP] = ACTIONS(1956),
    [anon_sym_AMP] = ACTIONS(1954),
    [anon_sym___extension__] = ACTIONS(1954),
    [anon_sym_typedef] = ACTIONS(1954),
    [anon_sym___device__] = ACTIONS(1954),
    [anon_sym___host__] = ACTIONS(1954),
    [anon_sym___global__] = ACTIONS(1954),
    [anon_sym___forceinline__] = ACTIONS(1954),
    [anon_sym___noinline__] = ACTIONS(1954),
    [anon_sym_extern] = ACTIONS(1954),
    [anon_sym___attribute__] = ACTIONS(1954),
    [anon_sym_COLON_COLON] = ACTIONS(1956),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1956),
    [anon_sym___declspec] = ACTIONS(1954),
    [anon_sym___based] = ACTIONS(1954),
    [anon_sym_signed] = ACTIONS(1954),
    [anon_sym_unsigned] = ACTIONS(1954),
    [anon_sym_long] = ACTIONS(1954),
    [anon_sym_short] = ACTIONS(1954),
    [anon_sym_LBRACK] = ACTIONS(1954),
    [anon_sym_static] = ACTIONS(1954),
    [anon_sym_register] = ACTIONS(1954),
    [anon_sym_inline] = ACTIONS(1954),
    [anon_sym___inline] = ACTIONS(1954),
    [anon_sym___inline__] = ACTIONS(1954),
    [anon_sym___forceinline] = ACTIONS(1954),
    [anon_sym_thread_local] = ACTIONS(1954),
    [anon_sym___thread] = ACTIONS(1954),
    [anon_sym_const] = ACTIONS(1954),
    [anon_sym_constexpr] = ACTIONS(1954),
    [anon_sym_volatile] = ACTIONS(1954),
    [anon_sym_restrict] = ACTIONS(1954),
    [anon_sym___restrict__] = ACTIONS(1954),
    [anon_sym__Atomic] = ACTIONS(1954),
    [anon_sym__Noreturn] = ACTIONS(1954),
    [anon_sym_noreturn] = ACTIONS(1954),
    [anon_sym_mutable] = ACTIONS(1954),
    [anon_sym_constinit] = ACTIONS(1954),
    [anon_sym_consteval] = ACTIONS(1954),
    [anon_sym___shared__] = ACTIONS(1954),
    [anon_sym___local__] = ACTIONS(1954),
    [anon_sym___constant__] = ACTIONS(1954),
    [anon_sym___managed__] = ACTIONS(1954),
    [anon_sym___grid_constant__] = ACTIONS(1954),
    [anon_sym_alignas] = ACTIONS(1954),
    [anon_sym__Alignas] = ACTIONS(1954),
    [sym_primitive_type] = ACTIONS(1954),
    [anon_sym_enum] = ACTIONS(1954),
    [anon_sym_class] = ACTIONS(1954),
    [anon_sym_struct] = ACTIONS(1954),
    [anon_sym_union] = ACTIONS(1954),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1954),
    [anon_sym_decltype] = ACTIONS(1954),
    [sym_virtual] = ACTIONS(1954),
    [anon_sym_explicit] = ACTIONS(1954),
    [anon_sym_typename] = ACTIONS(1954),
    [anon_sym_template] = ACTIONS(1954),
    [anon_sym_operator] = ACTIONS(1954),
    [anon_sym_friend] = ACTIONS(1954),
    [anon_sym_public] = ACTIONS(1954),
    [anon_sym_private] = ACTIONS(1954),
    [anon_sym_protected] = ACTIONS(1954),
    [anon_sym_using] = ACTIONS(1954),
    [anon_sym_static_assert] = ACTIONS(1954),
    [anon_sym___launch_bounds__] = ACTIONS(1954),
  },
  [1783] = {
    [sym_identifier] = ACTIONS(2384),
    [aux_sym_preproc_def_token1] = ACTIONS(2384),
    [aux_sym_preproc_if_token1] = ACTIONS(2384),
    [aux_sym_preproc_if_token2] = ACTIONS(2384),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2384),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2384),
    [aux_sym_preproc_else_token1] = ACTIONS(2384),
    [aux_sym_preproc_elif_token1] = ACTIONS(2384),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2384),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2384),
    [sym_preproc_directive] = ACTIONS(2384),
    [anon_sym_LPAREN2] = ACTIONS(2386),
    [anon_sym_TILDE] = ACTIONS(2386),
    [anon_sym_STAR] = ACTIONS(2386),
    [anon_sym_AMP_AMP] = ACTIONS(2386),
    [anon_sym_AMP] = ACTIONS(2384),
    [anon_sym___extension__] = ACTIONS(2384),
    [anon_sym_typedef] = ACTIONS(2384),
    [anon_sym___device__] = ACTIONS(2384),
    [anon_sym___host__] = ACTIONS(2384),
    [anon_sym___global__] = ACTIONS(2384),
    [anon_sym___forceinline__] = ACTIONS(2384),
    [anon_sym___noinline__] = ACTIONS(2384),
    [anon_sym_extern] = ACTIONS(2384),
    [anon_sym___attribute__] = ACTIONS(2384),
    [anon_sym_COLON_COLON] = ACTIONS(2386),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2386),
    [anon_sym___declspec] = ACTIONS(2384),
    [anon_sym___based] = ACTIONS(2384),
    [anon_sym_signed] = ACTIONS(2384),
    [anon_sym_unsigned] = ACTIONS(2384),
    [anon_sym_long] = ACTIONS(2384),
    [anon_sym_short] = ACTIONS(2384),
    [anon_sym_LBRACK] = ACTIONS(2384),
    [anon_sym_static] = ACTIONS(2384),
    [anon_sym_register] = ACTIONS(2384),
    [anon_sym_inline] = ACTIONS(2384),
    [anon_sym___inline] = ACTIONS(2384),
    [anon_sym___inline__] = ACTIONS(2384),
    [anon_sym___forceinline] = ACTIONS(2384),
    [anon_sym_thread_local] = ACTIONS(2384),
    [anon_sym___thread] = ACTIONS(2384),
    [anon_sym_const] = ACTIONS(2384),
    [anon_sym_constexpr] = ACTIONS(2384),
    [anon_sym_volatile] = ACTIONS(2384),
    [anon_sym_restrict] = ACTIONS(2384),
    [anon_sym___restrict__] = ACTIONS(2384),
    [anon_sym__Atomic] = ACTIONS(2384),
    [anon_sym__Noreturn] = ACTIONS(2384),
    [anon_sym_noreturn] = ACTIONS(2384),
    [anon_sym_mutable] = ACTIONS(2384),
    [anon_sym_constinit] = ACTIONS(2384),
    [anon_sym_consteval] = ACTIONS(2384),
    [anon_sym___shared__] = ACTIONS(2384),
    [anon_sym___local__] = ACTIONS(2384),
    [anon_sym___constant__] = ACTIONS(2384),
    [anon_sym___managed__] = ACTIONS(2384),
    [anon_sym___grid_constant__] = ACTIONS(2384),
    [anon_sym_alignas] = ACTIONS(2384),
    [anon_sym__Alignas] = ACTIONS(2384),
    [sym_primitive_type] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2384),
    [anon_sym_class] = ACTIONS(2384),
    [anon_sym_struct] = ACTIONS(2384),
    [anon_sym_union] = ACTIONS(2384),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2384),
    [anon_sym_decltype] = ACTIONS(2384),
    [sym_virtual] = ACTIONS(2384),
    [anon_sym_explicit] = ACTIONS(2384),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(2384),
    [anon_sym_operator] = ACTIONS(2384),
    [anon_sym_friend] = ACTIONS(2384),
    [anon_sym_public] = ACTIONS(2384),
    [anon_sym_private] = ACTIONS(2384),
    [anon_sym_protected] = ACTIONS(2384),
    [anon_sym_using] = ACTIONS(2384),
    [anon_sym_static_assert] = ACTIONS(2384),
    [anon_sym___launch_bounds__] = ACTIONS(2384),
  },
  [1784] = {
    [sym_identifier] = ACTIONS(2271),
    [aux_sym_preproc_def_token1] = ACTIONS(2271),
    [aux_sym_preproc_if_token1] = ACTIONS(2271),
    [aux_sym_preproc_if_token2] = ACTIONS(2271),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2271),
    [aux_sym_preproc_else_token1] = ACTIONS(2271),
    [aux_sym_preproc_elif_token1] = ACTIONS(2271),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2271),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2271),
    [sym_preproc_directive] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(2273),
    [anon_sym_TILDE] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(2273),
    [anon_sym_AMP_AMP] = ACTIONS(2273),
    [anon_sym_AMP] = ACTIONS(2271),
    [anon_sym___extension__] = ACTIONS(2271),
    [anon_sym_typedef] = ACTIONS(2271),
    [anon_sym___device__] = ACTIONS(2271),
    [anon_sym___host__] = ACTIONS(2271),
    [anon_sym___global__] = ACTIONS(2271),
    [anon_sym___forceinline__] = ACTIONS(2271),
    [anon_sym___noinline__] = ACTIONS(2271),
    [anon_sym_extern] = ACTIONS(2271),
    [anon_sym___attribute__] = ACTIONS(2271),
    [anon_sym_COLON_COLON] = ACTIONS(2273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2273),
    [anon_sym___declspec] = ACTIONS(2271),
    [anon_sym___based] = ACTIONS(2271),
    [anon_sym_signed] = ACTIONS(2271),
    [anon_sym_unsigned] = ACTIONS(2271),
    [anon_sym_long] = ACTIONS(2271),
    [anon_sym_short] = ACTIONS(2271),
    [anon_sym_LBRACK] = ACTIONS(2271),
    [anon_sym_static] = ACTIONS(2271),
    [anon_sym_register] = ACTIONS(2271),
    [anon_sym_inline] = ACTIONS(2271),
    [anon_sym___inline] = ACTIONS(2271),
    [anon_sym___inline__] = ACTIONS(2271),
    [anon_sym___forceinline] = ACTIONS(2271),
    [anon_sym_thread_local] = ACTIONS(2271),
    [anon_sym___thread] = ACTIONS(2271),
    [anon_sym_const] = ACTIONS(2271),
    [anon_sym_constexpr] = ACTIONS(2271),
    [anon_sym_volatile] = ACTIONS(2271),
    [anon_sym_restrict] = ACTIONS(2271),
    [anon_sym___restrict__] = ACTIONS(2271),
    [anon_sym__Atomic] = ACTIONS(2271),
    [anon_sym__Noreturn] = ACTIONS(2271),
    [anon_sym_noreturn] = ACTIONS(2271),
    [anon_sym_mutable] = ACTIONS(2271),
    [anon_sym_constinit] = ACTIONS(2271),
    [anon_sym_consteval] = ACTIONS(2271),
    [anon_sym___shared__] = ACTIONS(2271),
    [anon_sym___local__] = ACTIONS(2271),
    [anon_sym___constant__] = ACTIONS(2271),
    [anon_sym___managed__] = ACTIONS(2271),
    [anon_sym___grid_constant__] = ACTIONS(2271),
    [anon_sym_alignas] = ACTIONS(2271),
    [anon_sym__Alignas] = ACTIONS(2271),
    [sym_primitive_type] = ACTIONS(2271),
    [anon_sym_enum] = ACTIONS(2271),
    [anon_sym_class] = ACTIONS(2271),
    [anon_sym_struct] = ACTIONS(2271),
    [anon_sym_union] = ACTIONS(2271),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2271),
    [anon_sym_decltype] = ACTIONS(2271),
    [sym_virtual] = ACTIONS(2271),
    [anon_sym_explicit] = ACTIONS(2271),
    [anon_sym_typename] = ACTIONS(2271),
    [anon_sym_template] = ACTIONS(2271),
    [anon_sym_operator] = ACTIONS(2271),
    [anon_sym_friend] = ACTIONS(2271),
    [anon_sym_public] = ACTIONS(2271),
    [anon_sym_private] = ACTIONS(2271),
    [anon_sym_protected] = ACTIONS(2271),
    [anon_sym_using] = ACTIONS(2271),
    [anon_sym_static_assert] = ACTIONS(2271),
    [anon_sym___launch_bounds__] = ACTIONS(2271),
  },
  [1785] = {
    [sym_identifier] = ACTIONS(2384),
    [aux_sym_preproc_def_token1] = ACTIONS(2384),
    [aux_sym_preproc_if_token1] = ACTIONS(2384),
    [aux_sym_preproc_if_token2] = ACTIONS(2384),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2384),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2384),
    [aux_sym_preproc_else_token1] = ACTIONS(2384),
    [aux_sym_preproc_elif_token1] = ACTIONS(2384),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2384),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2384),
    [sym_preproc_directive] = ACTIONS(2384),
    [anon_sym_LPAREN2] = ACTIONS(2386),
    [anon_sym_TILDE] = ACTIONS(2386),
    [anon_sym_STAR] = ACTIONS(2386),
    [anon_sym_AMP_AMP] = ACTIONS(2386),
    [anon_sym_AMP] = ACTIONS(2384),
    [anon_sym___extension__] = ACTIONS(2384),
    [anon_sym_typedef] = ACTIONS(2384),
    [anon_sym___device__] = ACTIONS(2384),
    [anon_sym___host__] = ACTIONS(2384),
    [anon_sym___global__] = ACTIONS(2384),
    [anon_sym___forceinline__] = ACTIONS(2384),
    [anon_sym___noinline__] = ACTIONS(2384),
    [anon_sym_extern] = ACTIONS(2384),
    [anon_sym___attribute__] = ACTIONS(2384),
    [anon_sym_COLON_COLON] = ACTIONS(2386),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2386),
    [anon_sym___declspec] = ACTIONS(2384),
    [anon_sym___based] = ACTIONS(2384),
    [anon_sym_signed] = ACTIONS(2384),
    [anon_sym_unsigned] = ACTIONS(2384),
    [anon_sym_long] = ACTIONS(2384),
    [anon_sym_short] = ACTIONS(2384),
    [anon_sym_LBRACK] = ACTIONS(2384),
    [anon_sym_static] = ACTIONS(2384),
    [anon_sym_register] = ACTIONS(2384),
    [anon_sym_inline] = ACTIONS(2384),
    [anon_sym___inline] = ACTIONS(2384),
    [anon_sym___inline__] = ACTIONS(2384),
    [anon_sym___forceinline] = ACTIONS(2384),
    [anon_sym_thread_local] = ACTIONS(2384),
    [anon_sym___thread] = ACTIONS(2384),
    [anon_sym_const] = ACTIONS(2384),
    [anon_sym_constexpr] = ACTIONS(2384),
    [anon_sym_volatile] = ACTIONS(2384),
    [anon_sym_restrict] = ACTIONS(2384),
    [anon_sym___restrict__] = ACTIONS(2384),
    [anon_sym__Atomic] = ACTIONS(2384),
    [anon_sym__Noreturn] = ACTIONS(2384),
    [anon_sym_noreturn] = ACTIONS(2384),
    [anon_sym_mutable] = ACTIONS(2384),
    [anon_sym_constinit] = ACTIONS(2384),
    [anon_sym_consteval] = ACTIONS(2384),
    [anon_sym___shared__] = ACTIONS(2384),
    [anon_sym___local__] = ACTIONS(2384),
    [anon_sym___constant__] = ACTIONS(2384),
    [anon_sym___managed__] = ACTIONS(2384),
    [anon_sym___grid_constant__] = ACTIONS(2384),
    [anon_sym_alignas] = ACTIONS(2384),
    [anon_sym__Alignas] = ACTIONS(2384),
    [sym_primitive_type] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2384),
    [anon_sym_class] = ACTIONS(2384),
    [anon_sym_struct] = ACTIONS(2384),
    [anon_sym_union] = ACTIONS(2384),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2384),
    [anon_sym_decltype] = ACTIONS(2384),
    [sym_virtual] = ACTIONS(2384),
    [anon_sym_explicit] = ACTIONS(2384),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(2384),
    [anon_sym_operator] = ACTIONS(2384),
    [anon_sym_friend] = ACTIONS(2384),
    [anon_sym_public] = ACTIONS(2384),
    [anon_sym_private] = ACTIONS(2384),
    [anon_sym_protected] = ACTIONS(2384),
    [anon_sym_using] = ACTIONS(2384),
    [anon_sym_static_assert] = ACTIONS(2384),
    [anon_sym___launch_bounds__] = ACTIONS(2384),
  },
  [1786] = {
    [sym_identifier] = ACTIONS(1942),
    [aux_sym_preproc_def_token1] = ACTIONS(1942),
    [aux_sym_preproc_if_token1] = ACTIONS(1942),
    [aux_sym_preproc_if_token2] = ACTIONS(1942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1942),
    [aux_sym_preproc_else_token1] = ACTIONS(1942),
    [aux_sym_preproc_elif_token1] = ACTIONS(1942),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1942),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1942),
    [sym_preproc_directive] = ACTIONS(1942),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_TILDE] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym___extension__] = ACTIONS(1942),
    [anon_sym_typedef] = ACTIONS(1942),
    [anon_sym___device__] = ACTIONS(1942),
    [anon_sym___host__] = ACTIONS(1942),
    [anon_sym___global__] = ACTIONS(1942),
    [anon_sym___forceinline__] = ACTIONS(1942),
    [anon_sym___noinline__] = ACTIONS(1942),
    [anon_sym_extern] = ACTIONS(1942),
    [anon_sym___attribute__] = ACTIONS(1942),
    [anon_sym_COLON_COLON] = ACTIONS(1944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1944),
    [anon_sym___declspec] = ACTIONS(1942),
    [anon_sym___based] = ACTIONS(1942),
    [anon_sym_signed] = ACTIONS(1942),
    [anon_sym_unsigned] = ACTIONS(1942),
    [anon_sym_long] = ACTIONS(1942),
    [anon_sym_short] = ACTIONS(1942),
    [anon_sym_LBRACK] = ACTIONS(1942),
    [anon_sym_static] = ACTIONS(1942),
    [anon_sym_register] = ACTIONS(1942),
    [anon_sym_inline] = ACTIONS(1942),
    [anon_sym___inline] = ACTIONS(1942),
    [anon_sym___inline__] = ACTIONS(1942),
    [anon_sym___forceinline] = ACTIONS(1942),
    [anon_sym_thread_local] = ACTIONS(1942),
    [anon_sym___thread] = ACTIONS(1942),
    [anon_sym_const] = ACTIONS(1942),
    [anon_sym_constexpr] = ACTIONS(1942),
    [anon_sym_volatile] = ACTIONS(1942),
    [anon_sym_restrict] = ACTIONS(1942),
    [anon_sym___restrict__] = ACTIONS(1942),
    [anon_sym__Atomic] = ACTIONS(1942),
    [anon_sym__Noreturn] = ACTIONS(1942),
    [anon_sym_noreturn] = ACTIONS(1942),
    [anon_sym_mutable] = ACTIONS(1942),
    [anon_sym_constinit] = ACTIONS(1942),
    [anon_sym_consteval] = ACTIONS(1942),
    [anon_sym___shared__] = ACTIONS(1942),
    [anon_sym___local__] = ACTIONS(1942),
    [anon_sym___constant__] = ACTIONS(1942),
    [anon_sym___managed__] = ACTIONS(1942),
    [anon_sym___grid_constant__] = ACTIONS(1942),
    [anon_sym_alignas] = ACTIONS(1942),
    [anon_sym__Alignas] = ACTIONS(1942),
    [sym_primitive_type] = ACTIONS(1942),
    [anon_sym_enum] = ACTIONS(1942),
    [anon_sym_class] = ACTIONS(1942),
    [anon_sym_struct] = ACTIONS(1942),
    [anon_sym_union] = ACTIONS(1942),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1942),
    [anon_sym_decltype] = ACTIONS(1942),
    [sym_virtual] = ACTIONS(1942),
    [anon_sym_explicit] = ACTIONS(1942),
    [anon_sym_typename] = ACTIONS(1942),
    [anon_sym_template] = ACTIONS(1942),
    [anon_sym_operator] = ACTIONS(1942),
    [anon_sym_friend] = ACTIONS(1942),
    [anon_sym_public] = ACTIONS(1942),
    [anon_sym_private] = ACTIONS(1942),
    [anon_sym_protected] = ACTIONS(1942),
    [anon_sym_using] = ACTIONS(1942),
    [anon_sym_static_assert] = ACTIONS(1942),
    [anon_sym___launch_bounds__] = ACTIONS(1942),
  },
  [1787] = {
    [sym_identifier] = ACTIONS(1942),
    [aux_sym_preproc_def_token1] = ACTIONS(1942),
    [aux_sym_preproc_if_token1] = ACTIONS(1942),
    [aux_sym_preproc_if_token2] = ACTIONS(1942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1942),
    [aux_sym_preproc_else_token1] = ACTIONS(1942),
    [aux_sym_preproc_elif_token1] = ACTIONS(1942),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1942),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1942),
    [sym_preproc_directive] = ACTIONS(1942),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_TILDE] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym___extension__] = ACTIONS(1942),
    [anon_sym_typedef] = ACTIONS(1942),
    [anon_sym___device__] = ACTIONS(1942),
    [anon_sym___host__] = ACTIONS(1942),
    [anon_sym___global__] = ACTIONS(1942),
    [anon_sym___forceinline__] = ACTIONS(1942),
    [anon_sym___noinline__] = ACTIONS(1942),
    [anon_sym_extern] = ACTIONS(1942),
    [anon_sym___attribute__] = ACTIONS(1942),
    [anon_sym_COLON_COLON] = ACTIONS(1944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1944),
    [anon_sym___declspec] = ACTIONS(1942),
    [anon_sym___based] = ACTIONS(1942),
    [anon_sym_signed] = ACTIONS(1942),
    [anon_sym_unsigned] = ACTIONS(1942),
    [anon_sym_long] = ACTIONS(1942),
    [anon_sym_short] = ACTIONS(1942),
    [anon_sym_LBRACK] = ACTIONS(1942),
    [anon_sym_static] = ACTIONS(1942),
    [anon_sym_register] = ACTIONS(1942),
    [anon_sym_inline] = ACTIONS(1942),
    [anon_sym___inline] = ACTIONS(1942),
    [anon_sym___inline__] = ACTIONS(1942),
    [anon_sym___forceinline] = ACTIONS(1942),
    [anon_sym_thread_local] = ACTIONS(1942),
    [anon_sym___thread] = ACTIONS(1942),
    [anon_sym_const] = ACTIONS(1942),
    [anon_sym_constexpr] = ACTIONS(1942),
    [anon_sym_volatile] = ACTIONS(1942),
    [anon_sym_restrict] = ACTIONS(1942),
    [anon_sym___restrict__] = ACTIONS(1942),
    [anon_sym__Atomic] = ACTIONS(1942),
    [anon_sym__Noreturn] = ACTIONS(1942),
    [anon_sym_noreturn] = ACTIONS(1942),
    [anon_sym_mutable] = ACTIONS(1942),
    [anon_sym_constinit] = ACTIONS(1942),
    [anon_sym_consteval] = ACTIONS(1942),
    [anon_sym___shared__] = ACTIONS(1942),
    [anon_sym___local__] = ACTIONS(1942),
    [anon_sym___constant__] = ACTIONS(1942),
    [anon_sym___managed__] = ACTIONS(1942),
    [anon_sym___grid_constant__] = ACTIONS(1942),
    [anon_sym_alignas] = ACTIONS(1942),
    [anon_sym__Alignas] = ACTIONS(1942),
    [sym_primitive_type] = ACTIONS(1942),
    [anon_sym_enum] = ACTIONS(1942),
    [anon_sym_class] = ACTIONS(1942),
    [anon_sym_struct] = ACTIONS(1942),
    [anon_sym_union] = ACTIONS(1942),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1942),
    [anon_sym_decltype] = ACTIONS(1942),
    [sym_virtual] = ACTIONS(1942),
    [anon_sym_explicit] = ACTIONS(1942),
    [anon_sym_typename] = ACTIONS(1942),
    [anon_sym_template] = ACTIONS(1942),
    [anon_sym_operator] = ACTIONS(1942),
    [anon_sym_friend] = ACTIONS(1942),
    [anon_sym_public] = ACTIONS(1942),
    [anon_sym_private] = ACTIONS(1942),
    [anon_sym_protected] = ACTIONS(1942),
    [anon_sym_using] = ACTIONS(1942),
    [anon_sym_static_assert] = ACTIONS(1942),
    [anon_sym___launch_bounds__] = ACTIONS(1942),
  },
  [1788] = {
    [sym_identifier] = ACTIONS(2235),
    [aux_sym_preproc_def_token1] = ACTIONS(2235),
    [aux_sym_preproc_if_token1] = ACTIONS(2235),
    [aux_sym_preproc_if_token2] = ACTIONS(2235),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2235),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2235),
    [aux_sym_preproc_else_token1] = ACTIONS(2235),
    [aux_sym_preproc_elif_token1] = ACTIONS(2235),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2235),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2235),
    [sym_preproc_directive] = ACTIONS(2235),
    [anon_sym_LPAREN2] = ACTIONS(2237),
    [anon_sym_TILDE] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2237),
    [anon_sym_AMP_AMP] = ACTIONS(2237),
    [anon_sym_AMP] = ACTIONS(2235),
    [anon_sym___extension__] = ACTIONS(2235),
    [anon_sym_typedef] = ACTIONS(2235),
    [anon_sym___device__] = ACTIONS(2235),
    [anon_sym___host__] = ACTIONS(2235),
    [anon_sym___global__] = ACTIONS(2235),
    [anon_sym___forceinline__] = ACTIONS(2235),
    [anon_sym___noinline__] = ACTIONS(2235),
    [anon_sym_extern] = ACTIONS(2235),
    [anon_sym___attribute__] = ACTIONS(2235),
    [anon_sym_COLON_COLON] = ACTIONS(2237),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2237),
    [anon_sym___declspec] = ACTIONS(2235),
    [anon_sym___based] = ACTIONS(2235),
    [anon_sym_signed] = ACTIONS(2235),
    [anon_sym_unsigned] = ACTIONS(2235),
    [anon_sym_long] = ACTIONS(2235),
    [anon_sym_short] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_static] = ACTIONS(2235),
    [anon_sym_register] = ACTIONS(2235),
    [anon_sym_inline] = ACTIONS(2235),
    [anon_sym___inline] = ACTIONS(2235),
    [anon_sym___inline__] = ACTIONS(2235),
    [anon_sym___forceinline] = ACTIONS(2235),
    [anon_sym_thread_local] = ACTIONS(2235),
    [anon_sym___thread] = ACTIONS(2235),
    [anon_sym_const] = ACTIONS(2235),
    [anon_sym_constexpr] = ACTIONS(2235),
    [anon_sym_volatile] = ACTIONS(2235),
    [anon_sym_restrict] = ACTIONS(2235),
    [anon_sym___restrict__] = ACTIONS(2235),
    [anon_sym__Atomic] = ACTIONS(2235),
    [anon_sym__Noreturn] = ACTIONS(2235),
    [anon_sym_noreturn] = ACTIONS(2235),
    [anon_sym_mutable] = ACTIONS(2235),
    [anon_sym_constinit] = ACTIONS(2235),
    [anon_sym_consteval] = ACTIONS(2235),
    [anon_sym___shared__] = ACTIONS(2235),
    [anon_sym___local__] = ACTIONS(2235),
    [anon_sym___constant__] = ACTIONS(2235),
    [anon_sym___managed__] = ACTIONS(2235),
    [anon_sym___grid_constant__] = ACTIONS(2235),
    [anon_sym_alignas] = ACTIONS(2235),
    [anon_sym__Alignas] = ACTIONS(2235),
    [sym_primitive_type] = ACTIONS(2235),
    [anon_sym_enum] = ACTIONS(2235),
    [anon_sym_class] = ACTIONS(2235),
    [anon_sym_struct] = ACTIONS(2235),
    [anon_sym_union] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2235),
    [anon_sym_decltype] = ACTIONS(2235),
    [sym_virtual] = ACTIONS(2235),
    [anon_sym_explicit] = ACTIONS(2235),
    [anon_sym_typename] = ACTIONS(2235),
    [anon_sym_template] = ACTIONS(2235),
    [anon_sym_operator] = ACTIONS(2235),
    [anon_sym_friend] = ACTIONS(2235),
    [anon_sym_public] = ACTIONS(2235),
    [anon_sym_private] = ACTIONS(2235),
    [anon_sym_protected] = ACTIONS(2235),
    [anon_sym_using] = ACTIONS(2235),
    [anon_sym_static_assert] = ACTIONS(2235),
    [anon_sym___launch_bounds__] = ACTIONS(2235),
  },
  [1789] = {
    [sym_identifier] = ACTIONS(2457),
    [aux_sym_preproc_def_token1] = ACTIONS(2457),
    [aux_sym_preproc_if_token1] = ACTIONS(2457),
    [aux_sym_preproc_if_token2] = ACTIONS(2457),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2457),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2457),
    [aux_sym_preproc_else_token1] = ACTIONS(2457),
    [aux_sym_preproc_elif_token1] = ACTIONS(2457),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2457),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2457),
    [sym_preproc_directive] = ACTIONS(2457),
    [anon_sym_LPAREN2] = ACTIONS(2459),
    [anon_sym_TILDE] = ACTIONS(2459),
    [anon_sym_STAR] = ACTIONS(2459),
    [anon_sym_AMP_AMP] = ACTIONS(2459),
    [anon_sym_AMP] = ACTIONS(2457),
    [anon_sym___extension__] = ACTIONS(2457),
    [anon_sym_typedef] = ACTIONS(2457),
    [anon_sym___device__] = ACTIONS(2457),
    [anon_sym___host__] = ACTIONS(2457),
    [anon_sym___global__] = ACTIONS(2457),
    [anon_sym___forceinline__] = ACTIONS(2457),
    [anon_sym___noinline__] = ACTIONS(2457),
    [anon_sym_extern] = ACTIONS(2457),
    [anon_sym___attribute__] = ACTIONS(2457),
    [anon_sym_COLON_COLON] = ACTIONS(2459),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2459),
    [anon_sym___declspec] = ACTIONS(2457),
    [anon_sym___based] = ACTIONS(2457),
    [anon_sym_signed] = ACTIONS(2457),
    [anon_sym_unsigned] = ACTIONS(2457),
    [anon_sym_long] = ACTIONS(2457),
    [anon_sym_short] = ACTIONS(2457),
    [anon_sym_LBRACK] = ACTIONS(2457),
    [anon_sym_static] = ACTIONS(2457),
    [anon_sym_register] = ACTIONS(2457),
    [anon_sym_inline] = ACTIONS(2457),
    [anon_sym___inline] = ACTIONS(2457),
    [anon_sym___inline__] = ACTIONS(2457),
    [anon_sym___forceinline] = ACTIONS(2457),
    [anon_sym_thread_local] = ACTIONS(2457),
    [anon_sym___thread] = ACTIONS(2457),
    [anon_sym_const] = ACTIONS(2457),
    [anon_sym_constexpr] = ACTIONS(2457),
    [anon_sym_volatile] = ACTIONS(2457),
    [anon_sym_restrict] = ACTIONS(2457),
    [anon_sym___restrict__] = ACTIONS(2457),
    [anon_sym__Atomic] = ACTIONS(2457),
    [anon_sym__Noreturn] = ACTIONS(2457),
    [anon_sym_noreturn] = ACTIONS(2457),
    [anon_sym_mutable] = ACTIONS(2457),
    [anon_sym_constinit] = ACTIONS(2457),
    [anon_sym_consteval] = ACTIONS(2457),
    [anon_sym___shared__] = ACTIONS(2457),
    [anon_sym___local__] = ACTIONS(2457),
    [anon_sym___constant__] = ACTIONS(2457),
    [anon_sym___managed__] = ACTIONS(2457),
    [anon_sym___grid_constant__] = ACTIONS(2457),
    [anon_sym_alignas] = ACTIONS(2457),
    [anon_sym__Alignas] = ACTIONS(2457),
    [sym_primitive_type] = ACTIONS(2457),
    [anon_sym_enum] = ACTIONS(2457),
    [anon_sym_class] = ACTIONS(2457),
    [anon_sym_struct] = ACTIONS(2457),
    [anon_sym_union] = ACTIONS(2457),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2457),
    [anon_sym_decltype] = ACTIONS(2457),
    [sym_virtual] = ACTIONS(2457),
    [anon_sym_explicit] = ACTIONS(2457),
    [anon_sym_typename] = ACTIONS(2457),
    [anon_sym_template] = ACTIONS(2457),
    [anon_sym_operator] = ACTIONS(2457),
    [anon_sym_friend] = ACTIONS(2457),
    [anon_sym_public] = ACTIONS(2457),
    [anon_sym_private] = ACTIONS(2457),
    [anon_sym_protected] = ACTIONS(2457),
    [anon_sym_using] = ACTIONS(2457),
    [anon_sym_static_assert] = ACTIONS(2457),
    [anon_sym___launch_bounds__] = ACTIONS(2457),
  },
  [1790] = {
    [sym_identifier] = ACTIONS(2060),
    [aux_sym_preproc_def_token1] = ACTIONS(2060),
    [aux_sym_preproc_if_token1] = ACTIONS(2060),
    [aux_sym_preproc_if_token2] = ACTIONS(2060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2060),
    [aux_sym_preproc_else_token1] = ACTIONS(2060),
    [aux_sym_preproc_elif_token1] = ACTIONS(2060),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2060),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2060),
    [sym_preproc_directive] = ACTIONS(2060),
    [anon_sym_LPAREN2] = ACTIONS(2062),
    [anon_sym_TILDE] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(2062),
    [anon_sym_AMP_AMP] = ACTIONS(2062),
    [anon_sym_AMP] = ACTIONS(2060),
    [anon_sym___extension__] = ACTIONS(2060),
    [anon_sym_typedef] = ACTIONS(2060),
    [anon_sym___device__] = ACTIONS(2060),
    [anon_sym___host__] = ACTIONS(2060),
    [anon_sym___global__] = ACTIONS(2060),
    [anon_sym___forceinline__] = ACTIONS(2060),
    [anon_sym___noinline__] = ACTIONS(2060),
    [anon_sym_extern] = ACTIONS(2060),
    [anon_sym___attribute__] = ACTIONS(2060),
    [anon_sym_COLON_COLON] = ACTIONS(2062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2062),
    [anon_sym___declspec] = ACTIONS(2060),
    [anon_sym___based] = ACTIONS(2060),
    [anon_sym_signed] = ACTIONS(2060),
    [anon_sym_unsigned] = ACTIONS(2060),
    [anon_sym_long] = ACTIONS(2060),
    [anon_sym_short] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2060),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_register] = ACTIONS(2060),
    [anon_sym_inline] = ACTIONS(2060),
    [anon_sym___inline] = ACTIONS(2060),
    [anon_sym___inline__] = ACTIONS(2060),
    [anon_sym___forceinline] = ACTIONS(2060),
    [anon_sym_thread_local] = ACTIONS(2060),
    [anon_sym___thread] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_constexpr] = ACTIONS(2060),
    [anon_sym_volatile] = ACTIONS(2060),
    [anon_sym_restrict] = ACTIONS(2060),
    [anon_sym___restrict__] = ACTIONS(2060),
    [anon_sym__Atomic] = ACTIONS(2060),
    [anon_sym__Noreturn] = ACTIONS(2060),
    [anon_sym_noreturn] = ACTIONS(2060),
    [anon_sym_mutable] = ACTIONS(2060),
    [anon_sym_constinit] = ACTIONS(2060),
    [anon_sym_consteval] = ACTIONS(2060),
    [anon_sym___shared__] = ACTIONS(2060),
    [anon_sym___local__] = ACTIONS(2060),
    [anon_sym___constant__] = ACTIONS(2060),
    [anon_sym___managed__] = ACTIONS(2060),
    [anon_sym___grid_constant__] = ACTIONS(2060),
    [anon_sym_alignas] = ACTIONS(2060),
    [anon_sym__Alignas] = ACTIONS(2060),
    [sym_primitive_type] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_struct] = ACTIONS(2060),
    [anon_sym_union] = ACTIONS(2060),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2060),
    [anon_sym_decltype] = ACTIONS(2060),
    [sym_virtual] = ACTIONS(2060),
    [anon_sym_explicit] = ACTIONS(2060),
    [anon_sym_typename] = ACTIONS(2060),
    [anon_sym_template] = ACTIONS(2060),
    [anon_sym_operator] = ACTIONS(2060),
    [anon_sym_friend] = ACTIONS(2060),
    [anon_sym_public] = ACTIONS(2060),
    [anon_sym_private] = ACTIONS(2060),
    [anon_sym_protected] = ACTIONS(2060),
    [anon_sym_using] = ACTIONS(2060),
    [anon_sym_static_assert] = ACTIONS(2060),
    [anon_sym___launch_bounds__] = ACTIONS(2060),
  },
  [1791] = {
    [sym_identifier] = ACTIONS(2342),
    [aux_sym_preproc_def_token1] = ACTIONS(2342),
    [aux_sym_preproc_if_token1] = ACTIONS(2342),
    [aux_sym_preproc_if_token2] = ACTIONS(2342),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2342),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2342),
    [aux_sym_preproc_else_token1] = ACTIONS(2342),
    [aux_sym_preproc_elif_token1] = ACTIONS(2342),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2342),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2342),
    [sym_preproc_directive] = ACTIONS(2342),
    [anon_sym_LPAREN2] = ACTIONS(2344),
    [anon_sym_TILDE] = ACTIONS(2344),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2342),
    [anon_sym___extension__] = ACTIONS(2342),
    [anon_sym_typedef] = ACTIONS(2342),
    [anon_sym___device__] = ACTIONS(2342),
    [anon_sym___host__] = ACTIONS(2342),
    [anon_sym___global__] = ACTIONS(2342),
    [anon_sym___forceinline__] = ACTIONS(2342),
    [anon_sym___noinline__] = ACTIONS(2342),
    [anon_sym_extern] = ACTIONS(2342),
    [anon_sym___attribute__] = ACTIONS(2342),
    [anon_sym_COLON_COLON] = ACTIONS(2344),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2344),
    [anon_sym___declspec] = ACTIONS(2342),
    [anon_sym___based] = ACTIONS(2342),
    [anon_sym_signed] = ACTIONS(2342),
    [anon_sym_unsigned] = ACTIONS(2342),
    [anon_sym_long] = ACTIONS(2342),
    [anon_sym_short] = ACTIONS(2342),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_static] = ACTIONS(2342),
    [anon_sym_register] = ACTIONS(2342),
    [anon_sym_inline] = ACTIONS(2342),
    [anon_sym___inline] = ACTIONS(2342),
    [anon_sym___inline__] = ACTIONS(2342),
    [anon_sym___forceinline] = ACTIONS(2342),
    [anon_sym_thread_local] = ACTIONS(2342),
    [anon_sym___thread] = ACTIONS(2342),
    [anon_sym_const] = ACTIONS(2342),
    [anon_sym_constexpr] = ACTIONS(2342),
    [anon_sym_volatile] = ACTIONS(2342),
    [anon_sym_restrict] = ACTIONS(2342),
    [anon_sym___restrict__] = ACTIONS(2342),
    [anon_sym__Atomic] = ACTIONS(2342),
    [anon_sym__Noreturn] = ACTIONS(2342),
    [anon_sym_noreturn] = ACTIONS(2342),
    [anon_sym_mutable] = ACTIONS(2342),
    [anon_sym_constinit] = ACTIONS(2342),
    [anon_sym_consteval] = ACTIONS(2342),
    [anon_sym___shared__] = ACTIONS(2342),
    [anon_sym___local__] = ACTIONS(2342),
    [anon_sym___constant__] = ACTIONS(2342),
    [anon_sym___managed__] = ACTIONS(2342),
    [anon_sym___grid_constant__] = ACTIONS(2342),
    [anon_sym_alignas] = ACTIONS(2342),
    [anon_sym__Alignas] = ACTIONS(2342),
    [sym_primitive_type] = ACTIONS(2342),
    [anon_sym_enum] = ACTIONS(2342),
    [anon_sym_class] = ACTIONS(2342),
    [anon_sym_struct] = ACTIONS(2342),
    [anon_sym_union] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2342),
    [anon_sym_decltype] = ACTIONS(2342),
    [sym_virtual] = ACTIONS(2342),
    [anon_sym_explicit] = ACTIONS(2342),
    [anon_sym_typename] = ACTIONS(2342),
    [anon_sym_template] = ACTIONS(2342),
    [anon_sym_operator] = ACTIONS(2342),
    [anon_sym_friend] = ACTIONS(2342),
    [anon_sym_public] = ACTIONS(2342),
    [anon_sym_private] = ACTIONS(2342),
    [anon_sym_protected] = ACTIONS(2342),
    [anon_sym_using] = ACTIONS(2342),
    [anon_sym_static_assert] = ACTIONS(2342),
    [anon_sym___launch_bounds__] = ACTIONS(2342),
  },
  [1792] = {
    [sym_identifier] = ACTIONS(2370),
    [aux_sym_preproc_def_token1] = ACTIONS(2370),
    [aux_sym_preproc_if_token1] = ACTIONS(2370),
    [aux_sym_preproc_if_token2] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2370),
    [aux_sym_preproc_else_token1] = ACTIONS(2370),
    [aux_sym_preproc_elif_token1] = ACTIONS(2370),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2370),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2370),
    [sym_preproc_directive] = ACTIONS(2370),
    [anon_sym_LPAREN2] = ACTIONS(2372),
    [anon_sym_TILDE] = ACTIONS(2372),
    [anon_sym_STAR] = ACTIONS(2372),
    [anon_sym_AMP_AMP] = ACTIONS(2372),
    [anon_sym_AMP] = ACTIONS(2370),
    [anon_sym___extension__] = ACTIONS(2370),
    [anon_sym_typedef] = ACTIONS(2370),
    [anon_sym___device__] = ACTIONS(2370),
    [anon_sym___host__] = ACTIONS(2370),
    [anon_sym___global__] = ACTIONS(2370),
    [anon_sym___forceinline__] = ACTIONS(2370),
    [anon_sym___noinline__] = ACTIONS(2370),
    [anon_sym_extern] = ACTIONS(2370),
    [anon_sym___attribute__] = ACTIONS(2370),
    [anon_sym_COLON_COLON] = ACTIONS(2372),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2372),
    [anon_sym___declspec] = ACTIONS(2370),
    [anon_sym___based] = ACTIONS(2370),
    [anon_sym_signed] = ACTIONS(2370),
    [anon_sym_unsigned] = ACTIONS(2370),
    [anon_sym_long] = ACTIONS(2370),
    [anon_sym_short] = ACTIONS(2370),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_static] = ACTIONS(2370),
    [anon_sym_register] = ACTIONS(2370),
    [anon_sym_inline] = ACTIONS(2370),
    [anon_sym___inline] = ACTIONS(2370),
    [anon_sym___inline__] = ACTIONS(2370),
    [anon_sym___forceinline] = ACTIONS(2370),
    [anon_sym_thread_local] = ACTIONS(2370),
    [anon_sym___thread] = ACTIONS(2370),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_constexpr] = ACTIONS(2370),
    [anon_sym_volatile] = ACTIONS(2370),
    [anon_sym_restrict] = ACTIONS(2370),
    [anon_sym___restrict__] = ACTIONS(2370),
    [anon_sym__Atomic] = ACTIONS(2370),
    [anon_sym__Noreturn] = ACTIONS(2370),
    [anon_sym_noreturn] = ACTIONS(2370),
    [anon_sym_mutable] = ACTIONS(2370),
    [anon_sym_constinit] = ACTIONS(2370),
    [anon_sym_consteval] = ACTIONS(2370),
    [anon_sym___shared__] = ACTIONS(2370),
    [anon_sym___local__] = ACTIONS(2370),
    [anon_sym___constant__] = ACTIONS(2370),
    [anon_sym___managed__] = ACTIONS(2370),
    [anon_sym___grid_constant__] = ACTIONS(2370),
    [anon_sym_alignas] = ACTIONS(2370),
    [anon_sym__Alignas] = ACTIONS(2370),
    [sym_primitive_type] = ACTIONS(2370),
    [anon_sym_enum] = ACTIONS(2370),
    [anon_sym_class] = ACTIONS(2370),
    [anon_sym_struct] = ACTIONS(2370),
    [anon_sym_union] = ACTIONS(2370),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2370),
    [anon_sym_decltype] = ACTIONS(2370),
    [sym_virtual] = ACTIONS(2370),
    [anon_sym_explicit] = ACTIONS(2370),
    [anon_sym_typename] = ACTIONS(2370),
    [anon_sym_template] = ACTIONS(2370),
    [anon_sym_operator] = ACTIONS(2370),
    [anon_sym_friend] = ACTIONS(2370),
    [anon_sym_public] = ACTIONS(2370),
    [anon_sym_private] = ACTIONS(2370),
    [anon_sym_protected] = ACTIONS(2370),
    [anon_sym_using] = ACTIONS(2370),
    [anon_sym_static_assert] = ACTIONS(2370),
    [anon_sym___launch_bounds__] = ACTIONS(2370),
  },
  [1793] = {
    [sym_identifier] = ACTIONS(2094),
    [aux_sym_preproc_def_token1] = ACTIONS(2094),
    [aux_sym_preproc_if_token1] = ACTIONS(2094),
    [aux_sym_preproc_if_token2] = ACTIONS(2094),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2094),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2094),
    [aux_sym_preproc_else_token1] = ACTIONS(2094),
    [aux_sym_preproc_elif_token1] = ACTIONS(2094),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2094),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2094),
    [sym_preproc_directive] = ACTIONS(2094),
    [anon_sym_LPAREN2] = ACTIONS(2096),
    [anon_sym_TILDE] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(2096),
    [anon_sym_AMP_AMP] = ACTIONS(2096),
    [anon_sym_AMP] = ACTIONS(2094),
    [anon_sym___extension__] = ACTIONS(2094),
    [anon_sym_typedef] = ACTIONS(2094),
    [anon_sym___device__] = ACTIONS(2094),
    [anon_sym___host__] = ACTIONS(2094),
    [anon_sym___global__] = ACTIONS(2094),
    [anon_sym___forceinline__] = ACTIONS(2094),
    [anon_sym___noinline__] = ACTIONS(2094),
    [anon_sym_extern] = ACTIONS(2094),
    [anon_sym___attribute__] = ACTIONS(2094),
    [anon_sym_COLON_COLON] = ACTIONS(2096),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2096),
    [anon_sym___declspec] = ACTIONS(2094),
    [anon_sym___based] = ACTIONS(2094),
    [anon_sym_signed] = ACTIONS(2094),
    [anon_sym_unsigned] = ACTIONS(2094),
    [anon_sym_long] = ACTIONS(2094),
    [anon_sym_short] = ACTIONS(2094),
    [anon_sym_LBRACK] = ACTIONS(2094),
    [anon_sym_static] = ACTIONS(2094),
    [anon_sym_register] = ACTIONS(2094),
    [anon_sym_inline] = ACTIONS(2094),
    [anon_sym___inline] = ACTIONS(2094),
    [anon_sym___inline__] = ACTIONS(2094),
    [anon_sym___forceinline] = ACTIONS(2094),
    [anon_sym_thread_local] = ACTIONS(2094),
    [anon_sym___thread] = ACTIONS(2094),
    [anon_sym_const] = ACTIONS(2094),
    [anon_sym_constexpr] = ACTIONS(2094),
    [anon_sym_volatile] = ACTIONS(2094),
    [anon_sym_restrict] = ACTIONS(2094),
    [anon_sym___restrict__] = ACTIONS(2094),
    [anon_sym__Atomic] = ACTIONS(2094),
    [anon_sym__Noreturn] = ACTIONS(2094),
    [anon_sym_noreturn] = ACTIONS(2094),
    [anon_sym_mutable] = ACTIONS(2094),
    [anon_sym_constinit] = ACTIONS(2094),
    [anon_sym_consteval] = ACTIONS(2094),
    [anon_sym___shared__] = ACTIONS(2094),
    [anon_sym___local__] = ACTIONS(2094),
    [anon_sym___constant__] = ACTIONS(2094),
    [anon_sym___managed__] = ACTIONS(2094),
    [anon_sym___grid_constant__] = ACTIONS(2094),
    [anon_sym_alignas] = ACTIONS(2094),
    [anon_sym__Alignas] = ACTIONS(2094),
    [sym_primitive_type] = ACTIONS(2094),
    [anon_sym_enum] = ACTIONS(2094),
    [anon_sym_class] = ACTIONS(2094),
    [anon_sym_struct] = ACTIONS(2094),
    [anon_sym_union] = ACTIONS(2094),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2094),
    [anon_sym_decltype] = ACTIONS(2094),
    [sym_virtual] = ACTIONS(2094),
    [anon_sym_explicit] = ACTIONS(2094),
    [anon_sym_typename] = ACTIONS(2094),
    [anon_sym_template] = ACTIONS(2094),
    [anon_sym_operator] = ACTIONS(2094),
    [anon_sym_friend] = ACTIONS(2094),
    [anon_sym_public] = ACTIONS(2094),
    [anon_sym_private] = ACTIONS(2094),
    [anon_sym_protected] = ACTIONS(2094),
    [anon_sym_using] = ACTIONS(2094),
    [anon_sym_static_assert] = ACTIONS(2094),
    [anon_sym___launch_bounds__] = ACTIONS(2094),
  },
  [1794] = {
    [sym_identifier] = ACTIONS(2172),
    [aux_sym_preproc_def_token1] = ACTIONS(2172),
    [aux_sym_preproc_if_token1] = ACTIONS(2172),
    [aux_sym_preproc_if_token2] = ACTIONS(2172),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2172),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2172),
    [aux_sym_preproc_else_token1] = ACTIONS(2172),
    [aux_sym_preproc_elif_token1] = ACTIONS(2172),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2172),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2172),
    [sym_preproc_directive] = ACTIONS(2172),
    [anon_sym_LPAREN2] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2174),
    [anon_sym_STAR] = ACTIONS(2174),
    [anon_sym_AMP_AMP] = ACTIONS(2174),
    [anon_sym_AMP] = ACTIONS(2172),
    [anon_sym___extension__] = ACTIONS(2172),
    [anon_sym_typedef] = ACTIONS(2172),
    [anon_sym___device__] = ACTIONS(2172),
    [anon_sym___host__] = ACTIONS(2172),
    [anon_sym___global__] = ACTIONS(2172),
    [anon_sym___forceinline__] = ACTIONS(2172),
    [anon_sym___noinline__] = ACTIONS(2172),
    [anon_sym_extern] = ACTIONS(2172),
    [anon_sym___attribute__] = ACTIONS(2172),
    [anon_sym_COLON_COLON] = ACTIONS(2174),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2174),
    [anon_sym___declspec] = ACTIONS(2172),
    [anon_sym___based] = ACTIONS(2172),
    [anon_sym_signed] = ACTIONS(2172),
    [anon_sym_unsigned] = ACTIONS(2172),
    [anon_sym_long] = ACTIONS(2172),
    [anon_sym_short] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2172),
    [anon_sym_static] = ACTIONS(2172),
    [anon_sym_register] = ACTIONS(2172),
    [anon_sym_inline] = ACTIONS(2172),
    [anon_sym___inline] = ACTIONS(2172),
    [anon_sym___inline__] = ACTIONS(2172),
    [anon_sym___forceinline] = ACTIONS(2172),
    [anon_sym_thread_local] = ACTIONS(2172),
    [anon_sym___thread] = ACTIONS(2172),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_constexpr] = ACTIONS(2172),
    [anon_sym_volatile] = ACTIONS(2172),
    [anon_sym_restrict] = ACTIONS(2172),
    [anon_sym___restrict__] = ACTIONS(2172),
    [anon_sym__Atomic] = ACTIONS(2172),
    [anon_sym__Noreturn] = ACTIONS(2172),
    [anon_sym_noreturn] = ACTIONS(2172),
    [anon_sym_mutable] = ACTIONS(2172),
    [anon_sym_constinit] = ACTIONS(2172),
    [anon_sym_consteval] = ACTIONS(2172),
    [anon_sym___shared__] = ACTIONS(2172),
    [anon_sym___local__] = ACTIONS(2172),
    [anon_sym___constant__] = ACTIONS(2172),
    [anon_sym___managed__] = ACTIONS(2172),
    [anon_sym___grid_constant__] = ACTIONS(2172),
    [anon_sym_alignas] = ACTIONS(2172),
    [anon_sym__Alignas] = ACTIONS(2172),
    [sym_primitive_type] = ACTIONS(2172),
    [anon_sym_enum] = ACTIONS(2172),
    [anon_sym_class] = ACTIONS(2172),
    [anon_sym_struct] = ACTIONS(2172),
    [anon_sym_union] = ACTIONS(2172),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2172),
    [anon_sym_decltype] = ACTIONS(2172),
    [sym_virtual] = ACTIONS(2172),
    [anon_sym_explicit] = ACTIONS(2172),
    [anon_sym_typename] = ACTIONS(2172),
    [anon_sym_template] = ACTIONS(2172),
    [anon_sym_operator] = ACTIONS(2172),
    [anon_sym_friend] = ACTIONS(2172),
    [anon_sym_public] = ACTIONS(2172),
    [anon_sym_private] = ACTIONS(2172),
    [anon_sym_protected] = ACTIONS(2172),
    [anon_sym_using] = ACTIONS(2172),
    [anon_sym_static_assert] = ACTIONS(2172),
    [anon_sym___launch_bounds__] = ACTIONS(2172),
  },
  [1795] = {
    [sym_identifier] = ACTIONS(2176),
    [aux_sym_preproc_def_token1] = ACTIONS(2176),
    [aux_sym_preproc_if_token1] = ACTIONS(2176),
    [aux_sym_preproc_if_token2] = ACTIONS(2176),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2176),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2176),
    [aux_sym_preproc_else_token1] = ACTIONS(2176),
    [aux_sym_preproc_elif_token1] = ACTIONS(2176),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2176),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2176),
    [sym_preproc_directive] = ACTIONS(2176),
    [anon_sym_LPAREN2] = ACTIONS(2178),
    [anon_sym_TILDE] = ACTIONS(2178),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_AMP_AMP] = ACTIONS(2178),
    [anon_sym_AMP] = ACTIONS(2176),
    [anon_sym___extension__] = ACTIONS(2176),
    [anon_sym_typedef] = ACTIONS(2176),
    [anon_sym___device__] = ACTIONS(2176),
    [anon_sym___host__] = ACTIONS(2176),
    [anon_sym___global__] = ACTIONS(2176),
    [anon_sym___forceinline__] = ACTIONS(2176),
    [anon_sym___noinline__] = ACTIONS(2176),
    [anon_sym_extern] = ACTIONS(2176),
    [anon_sym___attribute__] = ACTIONS(2176),
    [anon_sym_COLON_COLON] = ACTIONS(2178),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2178),
    [anon_sym___declspec] = ACTIONS(2176),
    [anon_sym___based] = ACTIONS(2176),
    [anon_sym_signed] = ACTIONS(2176),
    [anon_sym_unsigned] = ACTIONS(2176),
    [anon_sym_long] = ACTIONS(2176),
    [anon_sym_short] = ACTIONS(2176),
    [anon_sym_LBRACK] = ACTIONS(2176),
    [anon_sym_static] = ACTIONS(2176),
    [anon_sym_register] = ACTIONS(2176),
    [anon_sym_inline] = ACTIONS(2176),
    [anon_sym___inline] = ACTIONS(2176),
    [anon_sym___inline__] = ACTIONS(2176),
    [anon_sym___forceinline] = ACTIONS(2176),
    [anon_sym_thread_local] = ACTIONS(2176),
    [anon_sym___thread] = ACTIONS(2176),
    [anon_sym_const] = ACTIONS(2176),
    [anon_sym_constexpr] = ACTIONS(2176),
    [anon_sym_volatile] = ACTIONS(2176),
    [anon_sym_restrict] = ACTIONS(2176),
    [anon_sym___restrict__] = ACTIONS(2176),
    [anon_sym__Atomic] = ACTIONS(2176),
    [anon_sym__Noreturn] = ACTIONS(2176),
    [anon_sym_noreturn] = ACTIONS(2176),
    [anon_sym_mutable] = ACTIONS(2176),
    [anon_sym_constinit] = ACTIONS(2176),
    [anon_sym_consteval] = ACTIONS(2176),
    [anon_sym___shared__] = ACTIONS(2176),
    [anon_sym___local__] = ACTIONS(2176),
    [anon_sym___constant__] = ACTIONS(2176),
    [anon_sym___managed__] = ACTIONS(2176),
    [anon_sym___grid_constant__] = ACTIONS(2176),
    [anon_sym_alignas] = ACTIONS(2176),
    [anon_sym__Alignas] = ACTIONS(2176),
    [sym_primitive_type] = ACTIONS(2176),
    [anon_sym_enum] = ACTIONS(2176),
    [anon_sym_class] = ACTIONS(2176),
    [anon_sym_struct] = ACTIONS(2176),
    [anon_sym_union] = ACTIONS(2176),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2176),
    [anon_sym_decltype] = ACTIONS(2176),
    [sym_virtual] = ACTIONS(2176),
    [anon_sym_explicit] = ACTIONS(2176),
    [anon_sym_typename] = ACTIONS(2176),
    [anon_sym_template] = ACTIONS(2176),
    [anon_sym_operator] = ACTIONS(2176),
    [anon_sym_friend] = ACTIONS(2176),
    [anon_sym_public] = ACTIONS(2176),
    [anon_sym_private] = ACTIONS(2176),
    [anon_sym_protected] = ACTIONS(2176),
    [anon_sym_using] = ACTIONS(2176),
    [anon_sym_static_assert] = ACTIONS(2176),
    [anon_sym___launch_bounds__] = ACTIONS(2176),
  },
  [1796] = {
    [sym_identifier] = ACTIONS(2180),
    [aux_sym_preproc_def_token1] = ACTIONS(2180),
    [aux_sym_preproc_if_token1] = ACTIONS(2180),
    [aux_sym_preproc_if_token2] = ACTIONS(2180),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2180),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2180),
    [aux_sym_preproc_else_token1] = ACTIONS(2180),
    [aux_sym_preproc_elif_token1] = ACTIONS(2180),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2180),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2180),
    [sym_preproc_directive] = ACTIONS(2180),
    [anon_sym_LPAREN2] = ACTIONS(2182),
    [anon_sym_TILDE] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(2182),
    [anon_sym_AMP_AMP] = ACTIONS(2182),
    [anon_sym_AMP] = ACTIONS(2180),
    [anon_sym___extension__] = ACTIONS(2180),
    [anon_sym_typedef] = ACTIONS(2180),
    [anon_sym___device__] = ACTIONS(2180),
    [anon_sym___host__] = ACTIONS(2180),
    [anon_sym___global__] = ACTIONS(2180),
    [anon_sym___forceinline__] = ACTIONS(2180),
    [anon_sym___noinline__] = ACTIONS(2180),
    [anon_sym_extern] = ACTIONS(2180),
    [anon_sym___attribute__] = ACTIONS(2180),
    [anon_sym_COLON_COLON] = ACTIONS(2182),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2182),
    [anon_sym___declspec] = ACTIONS(2180),
    [anon_sym___based] = ACTIONS(2180),
    [anon_sym_signed] = ACTIONS(2180),
    [anon_sym_unsigned] = ACTIONS(2180),
    [anon_sym_long] = ACTIONS(2180),
    [anon_sym_short] = ACTIONS(2180),
    [anon_sym_LBRACK] = ACTIONS(2180),
    [anon_sym_static] = ACTIONS(2180),
    [anon_sym_register] = ACTIONS(2180),
    [anon_sym_inline] = ACTIONS(2180),
    [anon_sym___inline] = ACTIONS(2180),
    [anon_sym___inline__] = ACTIONS(2180),
    [anon_sym___forceinline] = ACTIONS(2180),
    [anon_sym_thread_local] = ACTIONS(2180),
    [anon_sym___thread] = ACTIONS(2180),
    [anon_sym_const] = ACTIONS(2180),
    [anon_sym_constexpr] = ACTIONS(2180),
    [anon_sym_volatile] = ACTIONS(2180),
    [anon_sym_restrict] = ACTIONS(2180),
    [anon_sym___restrict__] = ACTIONS(2180),
    [anon_sym__Atomic] = ACTIONS(2180),
    [anon_sym__Noreturn] = ACTIONS(2180),
    [anon_sym_noreturn] = ACTIONS(2180),
    [anon_sym_mutable] = ACTIONS(2180),
    [anon_sym_constinit] = ACTIONS(2180),
    [anon_sym_consteval] = ACTIONS(2180),
    [anon_sym___shared__] = ACTIONS(2180),
    [anon_sym___local__] = ACTIONS(2180),
    [anon_sym___constant__] = ACTIONS(2180),
    [anon_sym___managed__] = ACTIONS(2180),
    [anon_sym___grid_constant__] = ACTIONS(2180),
    [anon_sym_alignas] = ACTIONS(2180),
    [anon_sym__Alignas] = ACTIONS(2180),
    [sym_primitive_type] = ACTIONS(2180),
    [anon_sym_enum] = ACTIONS(2180),
    [anon_sym_class] = ACTIONS(2180),
    [anon_sym_struct] = ACTIONS(2180),
    [anon_sym_union] = ACTIONS(2180),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2180),
    [anon_sym_decltype] = ACTIONS(2180),
    [sym_virtual] = ACTIONS(2180),
    [anon_sym_explicit] = ACTIONS(2180),
    [anon_sym_typename] = ACTIONS(2180),
    [anon_sym_template] = ACTIONS(2180),
    [anon_sym_operator] = ACTIONS(2180),
    [anon_sym_friend] = ACTIONS(2180),
    [anon_sym_public] = ACTIONS(2180),
    [anon_sym_private] = ACTIONS(2180),
    [anon_sym_protected] = ACTIONS(2180),
    [anon_sym_using] = ACTIONS(2180),
    [anon_sym_static_assert] = ACTIONS(2180),
    [anon_sym___launch_bounds__] = ACTIONS(2180),
  },
  [1797] = {
    [sym_identifier] = ACTIONS(2370),
    [aux_sym_preproc_def_token1] = ACTIONS(2370),
    [aux_sym_preproc_if_token1] = ACTIONS(2370),
    [aux_sym_preproc_if_token2] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2370),
    [aux_sym_preproc_else_token1] = ACTIONS(2370),
    [aux_sym_preproc_elif_token1] = ACTIONS(2370),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2370),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2370),
    [sym_preproc_directive] = ACTIONS(2370),
    [anon_sym_LPAREN2] = ACTIONS(2372),
    [anon_sym_TILDE] = ACTIONS(2372),
    [anon_sym_STAR] = ACTIONS(2372),
    [anon_sym_AMP_AMP] = ACTIONS(2372),
    [anon_sym_AMP] = ACTIONS(2370),
    [anon_sym___extension__] = ACTIONS(2370),
    [anon_sym_typedef] = ACTIONS(2370),
    [anon_sym___device__] = ACTIONS(2370),
    [anon_sym___host__] = ACTIONS(2370),
    [anon_sym___global__] = ACTIONS(2370),
    [anon_sym___forceinline__] = ACTIONS(2370),
    [anon_sym___noinline__] = ACTIONS(2370),
    [anon_sym_extern] = ACTIONS(2370),
    [anon_sym___attribute__] = ACTIONS(2370),
    [anon_sym_COLON_COLON] = ACTIONS(2372),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2372),
    [anon_sym___declspec] = ACTIONS(2370),
    [anon_sym___based] = ACTIONS(2370),
    [anon_sym_signed] = ACTIONS(2370),
    [anon_sym_unsigned] = ACTIONS(2370),
    [anon_sym_long] = ACTIONS(2370),
    [anon_sym_short] = ACTIONS(2370),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_static] = ACTIONS(2370),
    [anon_sym_register] = ACTIONS(2370),
    [anon_sym_inline] = ACTIONS(2370),
    [anon_sym___inline] = ACTIONS(2370),
    [anon_sym___inline__] = ACTIONS(2370),
    [anon_sym___forceinline] = ACTIONS(2370),
    [anon_sym_thread_local] = ACTIONS(2370),
    [anon_sym___thread] = ACTIONS(2370),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_constexpr] = ACTIONS(2370),
    [anon_sym_volatile] = ACTIONS(2370),
    [anon_sym_restrict] = ACTIONS(2370),
    [anon_sym___restrict__] = ACTIONS(2370),
    [anon_sym__Atomic] = ACTIONS(2370),
    [anon_sym__Noreturn] = ACTIONS(2370),
    [anon_sym_noreturn] = ACTIONS(2370),
    [anon_sym_mutable] = ACTIONS(2370),
    [anon_sym_constinit] = ACTIONS(2370),
    [anon_sym_consteval] = ACTIONS(2370),
    [anon_sym___shared__] = ACTIONS(2370),
    [anon_sym___local__] = ACTIONS(2370),
    [anon_sym___constant__] = ACTIONS(2370),
    [anon_sym___managed__] = ACTIONS(2370),
    [anon_sym___grid_constant__] = ACTIONS(2370),
    [anon_sym_alignas] = ACTIONS(2370),
    [anon_sym__Alignas] = ACTIONS(2370),
    [sym_primitive_type] = ACTIONS(2370),
    [anon_sym_enum] = ACTIONS(2370),
    [anon_sym_class] = ACTIONS(2370),
    [anon_sym_struct] = ACTIONS(2370),
    [anon_sym_union] = ACTIONS(2370),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2370),
    [anon_sym_decltype] = ACTIONS(2370),
    [sym_virtual] = ACTIONS(2370),
    [anon_sym_explicit] = ACTIONS(2370),
    [anon_sym_typename] = ACTIONS(2370),
    [anon_sym_template] = ACTIONS(2370),
    [anon_sym_operator] = ACTIONS(2370),
    [anon_sym_friend] = ACTIONS(2370),
    [anon_sym_public] = ACTIONS(2370),
    [anon_sym_private] = ACTIONS(2370),
    [anon_sym_protected] = ACTIONS(2370),
    [anon_sym_using] = ACTIONS(2370),
    [anon_sym_static_assert] = ACTIONS(2370),
    [anon_sym___launch_bounds__] = ACTIONS(2370),
  },
  [1798] = {
    [sym_identifier] = ACTIONS(2366),
    [aux_sym_preproc_def_token1] = ACTIONS(2366),
    [aux_sym_preproc_if_token1] = ACTIONS(2366),
    [aux_sym_preproc_if_token2] = ACTIONS(2366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2366),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2366),
    [aux_sym_preproc_else_token1] = ACTIONS(2366),
    [aux_sym_preproc_elif_token1] = ACTIONS(2366),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2366),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2366),
    [sym_preproc_directive] = ACTIONS(2366),
    [anon_sym_LPAREN2] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(2368),
    [anon_sym_STAR] = ACTIONS(2368),
    [anon_sym_AMP_AMP] = ACTIONS(2368),
    [anon_sym_AMP] = ACTIONS(2366),
    [anon_sym___extension__] = ACTIONS(2366),
    [anon_sym_typedef] = ACTIONS(2366),
    [anon_sym___device__] = ACTIONS(2366),
    [anon_sym___host__] = ACTIONS(2366),
    [anon_sym___global__] = ACTIONS(2366),
    [anon_sym___forceinline__] = ACTIONS(2366),
    [anon_sym___noinline__] = ACTIONS(2366),
    [anon_sym_extern] = ACTIONS(2366),
    [anon_sym___attribute__] = ACTIONS(2366),
    [anon_sym_COLON_COLON] = ACTIONS(2368),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2368),
    [anon_sym___declspec] = ACTIONS(2366),
    [anon_sym___based] = ACTIONS(2366),
    [anon_sym_signed] = ACTIONS(2366),
    [anon_sym_unsigned] = ACTIONS(2366),
    [anon_sym_long] = ACTIONS(2366),
    [anon_sym_short] = ACTIONS(2366),
    [anon_sym_LBRACK] = ACTIONS(2366),
    [anon_sym_static] = ACTIONS(2366),
    [anon_sym_register] = ACTIONS(2366),
    [anon_sym_inline] = ACTIONS(2366),
    [anon_sym___inline] = ACTIONS(2366),
    [anon_sym___inline__] = ACTIONS(2366),
    [anon_sym___forceinline] = ACTIONS(2366),
    [anon_sym_thread_local] = ACTIONS(2366),
    [anon_sym___thread] = ACTIONS(2366),
    [anon_sym_const] = ACTIONS(2366),
    [anon_sym_constexpr] = ACTIONS(2366),
    [anon_sym_volatile] = ACTIONS(2366),
    [anon_sym_restrict] = ACTIONS(2366),
    [anon_sym___restrict__] = ACTIONS(2366),
    [anon_sym__Atomic] = ACTIONS(2366),
    [anon_sym__Noreturn] = ACTIONS(2366),
    [anon_sym_noreturn] = ACTIONS(2366),
    [anon_sym_mutable] = ACTIONS(2366),
    [anon_sym_constinit] = ACTIONS(2366),
    [anon_sym_consteval] = ACTIONS(2366),
    [anon_sym___shared__] = ACTIONS(2366),
    [anon_sym___local__] = ACTIONS(2366),
    [anon_sym___constant__] = ACTIONS(2366),
    [anon_sym___managed__] = ACTIONS(2366),
    [anon_sym___grid_constant__] = ACTIONS(2366),
    [anon_sym_alignas] = ACTIONS(2366),
    [anon_sym__Alignas] = ACTIONS(2366),
    [sym_primitive_type] = ACTIONS(2366),
    [anon_sym_enum] = ACTIONS(2366),
    [anon_sym_class] = ACTIONS(2366),
    [anon_sym_struct] = ACTIONS(2366),
    [anon_sym_union] = ACTIONS(2366),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2366),
    [anon_sym_decltype] = ACTIONS(2366),
    [sym_virtual] = ACTIONS(2366),
    [anon_sym_explicit] = ACTIONS(2366),
    [anon_sym_typename] = ACTIONS(2366),
    [anon_sym_template] = ACTIONS(2366),
    [anon_sym_operator] = ACTIONS(2366),
    [anon_sym_friend] = ACTIONS(2366),
    [anon_sym_public] = ACTIONS(2366),
    [anon_sym_private] = ACTIONS(2366),
    [anon_sym_protected] = ACTIONS(2366),
    [anon_sym_using] = ACTIONS(2366),
    [anon_sym_static_assert] = ACTIONS(2366),
    [anon_sym___launch_bounds__] = ACTIONS(2366),
  },
  [1799] = {
    [sym_identifier] = ACTIONS(1980),
    [aux_sym_preproc_def_token1] = ACTIONS(1980),
    [aux_sym_preproc_if_token1] = ACTIONS(1980),
    [aux_sym_preproc_if_token2] = ACTIONS(1980),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1980),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1980),
    [aux_sym_preproc_else_token1] = ACTIONS(1980),
    [aux_sym_preproc_elif_token1] = ACTIONS(1980),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1980),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1980),
    [sym_preproc_directive] = ACTIONS(1980),
    [anon_sym_LPAREN2] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_AMP_AMP] = ACTIONS(1982),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym___extension__] = ACTIONS(1980),
    [anon_sym_typedef] = ACTIONS(1980),
    [anon_sym___device__] = ACTIONS(1980),
    [anon_sym___host__] = ACTIONS(1980),
    [anon_sym___global__] = ACTIONS(1980),
    [anon_sym___forceinline__] = ACTIONS(1980),
    [anon_sym___noinline__] = ACTIONS(1980),
    [anon_sym_extern] = ACTIONS(1980),
    [anon_sym___attribute__] = ACTIONS(1980),
    [anon_sym_COLON_COLON] = ACTIONS(1982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1982),
    [anon_sym___declspec] = ACTIONS(1980),
    [anon_sym___based] = ACTIONS(1980),
    [anon_sym_signed] = ACTIONS(1980),
    [anon_sym_unsigned] = ACTIONS(1980),
    [anon_sym_long] = ACTIONS(1980),
    [anon_sym_short] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_static] = ACTIONS(1980),
    [anon_sym_register] = ACTIONS(1980),
    [anon_sym_inline] = ACTIONS(1980),
    [anon_sym___inline] = ACTIONS(1980),
    [anon_sym___inline__] = ACTIONS(1980),
    [anon_sym___forceinline] = ACTIONS(1980),
    [anon_sym_thread_local] = ACTIONS(1980),
    [anon_sym___thread] = ACTIONS(1980),
    [anon_sym_const] = ACTIONS(1980),
    [anon_sym_constexpr] = ACTIONS(1980),
    [anon_sym_volatile] = ACTIONS(1980),
    [anon_sym_restrict] = ACTIONS(1980),
    [anon_sym___restrict__] = ACTIONS(1980),
    [anon_sym__Atomic] = ACTIONS(1980),
    [anon_sym__Noreturn] = ACTIONS(1980),
    [anon_sym_noreturn] = ACTIONS(1980),
    [anon_sym_mutable] = ACTIONS(1980),
    [anon_sym_constinit] = ACTIONS(1980),
    [anon_sym_consteval] = ACTIONS(1980),
    [anon_sym___shared__] = ACTIONS(1980),
    [anon_sym___local__] = ACTIONS(1980),
    [anon_sym___constant__] = ACTIONS(1980),
    [anon_sym___managed__] = ACTIONS(1980),
    [anon_sym___grid_constant__] = ACTIONS(1980),
    [anon_sym_alignas] = ACTIONS(1980),
    [anon_sym__Alignas] = ACTIONS(1980),
    [sym_primitive_type] = ACTIONS(1980),
    [anon_sym_enum] = ACTIONS(1980),
    [anon_sym_class] = ACTIONS(1980),
    [anon_sym_struct] = ACTIONS(1980),
    [anon_sym_union] = ACTIONS(1980),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1980),
    [anon_sym_decltype] = ACTIONS(1980),
    [sym_virtual] = ACTIONS(1980),
    [anon_sym_explicit] = ACTIONS(1980),
    [anon_sym_typename] = ACTIONS(1980),
    [anon_sym_template] = ACTIONS(1980),
    [anon_sym_operator] = ACTIONS(1980),
    [anon_sym_friend] = ACTIONS(1980),
    [anon_sym_public] = ACTIONS(1980),
    [anon_sym_private] = ACTIONS(1980),
    [anon_sym_protected] = ACTIONS(1980),
    [anon_sym_using] = ACTIONS(1980),
    [anon_sym_static_assert] = ACTIONS(1980),
    [anon_sym___launch_bounds__] = ACTIONS(1980),
  },
  [1800] = {
    [sym_identifier] = ACTIONS(2356),
    [aux_sym_preproc_def_token1] = ACTIONS(2356),
    [aux_sym_preproc_if_token1] = ACTIONS(2356),
    [aux_sym_preproc_if_token2] = ACTIONS(2356),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2356),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2356),
    [aux_sym_preproc_else_token1] = ACTIONS(2356),
    [aux_sym_preproc_elif_token1] = ACTIONS(2356),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2356),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2356),
    [sym_preproc_directive] = ACTIONS(2356),
    [anon_sym_LPAREN2] = ACTIONS(2358),
    [anon_sym_TILDE] = ACTIONS(2358),
    [anon_sym_STAR] = ACTIONS(2358),
    [anon_sym_AMP_AMP] = ACTIONS(2358),
    [anon_sym_AMP] = ACTIONS(2356),
    [anon_sym___extension__] = ACTIONS(2356),
    [anon_sym_typedef] = ACTIONS(2356),
    [anon_sym___device__] = ACTIONS(2356),
    [anon_sym___host__] = ACTIONS(2356),
    [anon_sym___global__] = ACTIONS(2356),
    [anon_sym___forceinline__] = ACTIONS(2356),
    [anon_sym___noinline__] = ACTIONS(2356),
    [anon_sym_extern] = ACTIONS(2356),
    [anon_sym___attribute__] = ACTIONS(2356),
    [anon_sym_COLON_COLON] = ACTIONS(2358),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2358),
    [anon_sym___declspec] = ACTIONS(2356),
    [anon_sym___based] = ACTIONS(2356),
    [anon_sym_signed] = ACTIONS(2356),
    [anon_sym_unsigned] = ACTIONS(2356),
    [anon_sym_long] = ACTIONS(2356),
    [anon_sym_short] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2356),
    [anon_sym_register] = ACTIONS(2356),
    [anon_sym_inline] = ACTIONS(2356),
    [anon_sym___inline] = ACTIONS(2356),
    [anon_sym___inline__] = ACTIONS(2356),
    [anon_sym___forceinline] = ACTIONS(2356),
    [anon_sym_thread_local] = ACTIONS(2356),
    [anon_sym___thread] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(2356),
    [anon_sym_constexpr] = ACTIONS(2356),
    [anon_sym_volatile] = ACTIONS(2356),
    [anon_sym_restrict] = ACTIONS(2356),
    [anon_sym___restrict__] = ACTIONS(2356),
    [anon_sym__Atomic] = ACTIONS(2356),
    [anon_sym__Noreturn] = ACTIONS(2356),
    [anon_sym_noreturn] = ACTIONS(2356),
    [anon_sym_mutable] = ACTIONS(2356),
    [anon_sym_constinit] = ACTIONS(2356),
    [anon_sym_consteval] = ACTIONS(2356),
    [anon_sym___shared__] = ACTIONS(2356),
    [anon_sym___local__] = ACTIONS(2356),
    [anon_sym___constant__] = ACTIONS(2356),
    [anon_sym___managed__] = ACTIONS(2356),
    [anon_sym___grid_constant__] = ACTIONS(2356),
    [anon_sym_alignas] = ACTIONS(2356),
    [anon_sym__Alignas] = ACTIONS(2356),
    [sym_primitive_type] = ACTIONS(2356),
    [anon_sym_enum] = ACTIONS(2356),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_struct] = ACTIONS(2356),
    [anon_sym_union] = ACTIONS(2356),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2356),
    [anon_sym_decltype] = ACTIONS(2356),
    [sym_virtual] = ACTIONS(2356),
    [anon_sym_explicit] = ACTIONS(2356),
    [anon_sym_typename] = ACTIONS(2356),
    [anon_sym_template] = ACTIONS(2356),
    [anon_sym_operator] = ACTIONS(2356),
    [anon_sym_friend] = ACTIONS(2356),
    [anon_sym_public] = ACTIONS(2356),
    [anon_sym_private] = ACTIONS(2356),
    [anon_sym_protected] = ACTIONS(2356),
    [anon_sym_using] = ACTIONS(2356),
    [anon_sym_static_assert] = ACTIONS(2356),
    [anon_sym___launch_bounds__] = ACTIONS(2356),
  },
  [1801] = {
    [sym_identifier] = ACTIONS(1976),
    [aux_sym_preproc_def_token1] = ACTIONS(1976),
    [aux_sym_preproc_if_token1] = ACTIONS(1976),
    [aux_sym_preproc_if_token2] = ACTIONS(1976),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1976),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1976),
    [aux_sym_preproc_else_token1] = ACTIONS(1976),
    [aux_sym_preproc_elif_token1] = ACTIONS(1976),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1976),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1976),
    [sym_preproc_directive] = ACTIONS(1976),
    [anon_sym_LPAREN2] = ACTIONS(1978),
    [anon_sym_TILDE] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1978),
    [anon_sym_AMP_AMP] = ACTIONS(1978),
    [anon_sym_AMP] = ACTIONS(1976),
    [anon_sym___extension__] = ACTIONS(1976),
    [anon_sym_typedef] = ACTIONS(1976),
    [anon_sym___device__] = ACTIONS(1976),
    [anon_sym___host__] = ACTIONS(1976),
    [anon_sym___global__] = ACTIONS(1976),
    [anon_sym___forceinline__] = ACTIONS(1976),
    [anon_sym___noinline__] = ACTIONS(1976),
    [anon_sym_extern] = ACTIONS(1976),
    [anon_sym___attribute__] = ACTIONS(1976),
    [anon_sym_COLON_COLON] = ACTIONS(1978),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1978),
    [anon_sym___declspec] = ACTIONS(1976),
    [anon_sym___based] = ACTIONS(1976),
    [anon_sym_signed] = ACTIONS(1976),
    [anon_sym_unsigned] = ACTIONS(1976),
    [anon_sym_long] = ACTIONS(1976),
    [anon_sym_short] = ACTIONS(1976),
    [anon_sym_LBRACK] = ACTIONS(1976),
    [anon_sym_static] = ACTIONS(1976),
    [anon_sym_register] = ACTIONS(1976),
    [anon_sym_inline] = ACTIONS(1976),
    [anon_sym___inline] = ACTIONS(1976),
    [anon_sym___inline__] = ACTIONS(1976),
    [anon_sym___forceinline] = ACTIONS(1976),
    [anon_sym_thread_local] = ACTIONS(1976),
    [anon_sym___thread] = ACTIONS(1976),
    [anon_sym_const] = ACTIONS(1976),
    [anon_sym_constexpr] = ACTIONS(1976),
    [anon_sym_volatile] = ACTIONS(1976),
    [anon_sym_restrict] = ACTIONS(1976),
    [anon_sym___restrict__] = ACTIONS(1976),
    [anon_sym__Atomic] = ACTIONS(1976),
    [anon_sym__Noreturn] = ACTIONS(1976),
    [anon_sym_noreturn] = ACTIONS(1976),
    [anon_sym_mutable] = ACTIONS(1976),
    [anon_sym_constinit] = ACTIONS(1976),
    [anon_sym_consteval] = ACTIONS(1976),
    [anon_sym___shared__] = ACTIONS(1976),
    [anon_sym___local__] = ACTIONS(1976),
    [anon_sym___constant__] = ACTIONS(1976),
    [anon_sym___managed__] = ACTIONS(1976),
    [anon_sym___grid_constant__] = ACTIONS(1976),
    [anon_sym_alignas] = ACTIONS(1976),
    [anon_sym__Alignas] = ACTIONS(1976),
    [sym_primitive_type] = ACTIONS(1976),
    [anon_sym_enum] = ACTIONS(1976),
    [anon_sym_class] = ACTIONS(1976),
    [anon_sym_struct] = ACTIONS(1976),
    [anon_sym_union] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1976),
    [anon_sym_decltype] = ACTIONS(1976),
    [sym_virtual] = ACTIONS(1976),
    [anon_sym_explicit] = ACTIONS(1976),
    [anon_sym_typename] = ACTIONS(1976),
    [anon_sym_template] = ACTIONS(1976),
    [anon_sym_operator] = ACTIONS(1976),
    [anon_sym_friend] = ACTIONS(1976),
    [anon_sym_public] = ACTIONS(1976),
    [anon_sym_private] = ACTIONS(1976),
    [anon_sym_protected] = ACTIONS(1976),
    [anon_sym_using] = ACTIONS(1976),
    [anon_sym_static_assert] = ACTIONS(1976),
    [anon_sym___launch_bounds__] = ACTIONS(1976),
  },
  [1802] = {
    [sym_identifier] = ACTIONS(2304),
    [aux_sym_preproc_def_token1] = ACTIONS(2304),
    [aux_sym_preproc_if_token1] = ACTIONS(2304),
    [aux_sym_preproc_if_token2] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2304),
    [aux_sym_preproc_else_token1] = ACTIONS(2304),
    [aux_sym_preproc_elif_token1] = ACTIONS(2304),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2304),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2304),
    [sym_preproc_directive] = ACTIONS(2304),
    [anon_sym_LPAREN2] = ACTIONS(2306),
    [anon_sym_TILDE] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym___extension__] = ACTIONS(2304),
    [anon_sym_typedef] = ACTIONS(2304),
    [anon_sym___device__] = ACTIONS(2304),
    [anon_sym___host__] = ACTIONS(2304),
    [anon_sym___global__] = ACTIONS(2304),
    [anon_sym___forceinline__] = ACTIONS(2304),
    [anon_sym___noinline__] = ACTIONS(2304),
    [anon_sym_extern] = ACTIONS(2304),
    [anon_sym___attribute__] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2306),
    [anon_sym___declspec] = ACTIONS(2304),
    [anon_sym___based] = ACTIONS(2304),
    [anon_sym_signed] = ACTIONS(2304),
    [anon_sym_unsigned] = ACTIONS(2304),
    [anon_sym_long] = ACTIONS(2304),
    [anon_sym_short] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_register] = ACTIONS(2304),
    [anon_sym_inline] = ACTIONS(2304),
    [anon_sym___inline] = ACTIONS(2304),
    [anon_sym___inline__] = ACTIONS(2304),
    [anon_sym___forceinline] = ACTIONS(2304),
    [anon_sym_thread_local] = ACTIONS(2304),
    [anon_sym___thread] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_constexpr] = ACTIONS(2304),
    [anon_sym_volatile] = ACTIONS(2304),
    [anon_sym_restrict] = ACTIONS(2304),
    [anon_sym___restrict__] = ACTIONS(2304),
    [anon_sym__Atomic] = ACTIONS(2304),
    [anon_sym__Noreturn] = ACTIONS(2304),
    [anon_sym_noreturn] = ACTIONS(2304),
    [anon_sym_mutable] = ACTIONS(2304),
    [anon_sym_constinit] = ACTIONS(2304),
    [anon_sym_consteval] = ACTIONS(2304),
    [anon_sym___shared__] = ACTIONS(2304),
    [anon_sym___local__] = ACTIONS(2304),
    [anon_sym___constant__] = ACTIONS(2304),
    [anon_sym___managed__] = ACTIONS(2304),
    [anon_sym___grid_constant__] = ACTIONS(2304),
    [anon_sym_alignas] = ACTIONS(2304),
    [anon_sym__Alignas] = ACTIONS(2304),
    [sym_primitive_type] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_struct] = ACTIONS(2304),
    [anon_sym_union] = ACTIONS(2304),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2304),
    [anon_sym_decltype] = ACTIONS(2304),
    [sym_virtual] = ACTIONS(2304),
    [anon_sym_explicit] = ACTIONS(2304),
    [anon_sym_typename] = ACTIONS(2304),
    [anon_sym_template] = ACTIONS(2304),
    [anon_sym_operator] = ACTIONS(2304),
    [anon_sym_friend] = ACTIONS(2304),
    [anon_sym_public] = ACTIONS(2304),
    [anon_sym_private] = ACTIONS(2304),
    [anon_sym_protected] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_static_assert] = ACTIONS(2304),
    [anon_sym___launch_bounds__] = ACTIONS(2304),
  },
  [1803] = {
    [sym_identifier] = ACTIONS(2203),
    [aux_sym_preproc_def_token1] = ACTIONS(2203),
    [aux_sym_preproc_if_token1] = ACTIONS(2203),
    [aux_sym_preproc_if_token2] = ACTIONS(2203),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2203),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2203),
    [aux_sym_preproc_else_token1] = ACTIONS(2203),
    [aux_sym_preproc_elif_token1] = ACTIONS(2203),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2203),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2203),
    [sym_preproc_directive] = ACTIONS(2203),
    [anon_sym_LPAREN2] = ACTIONS(2205),
    [anon_sym_TILDE] = ACTIONS(2205),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_AMP_AMP] = ACTIONS(2205),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym___extension__] = ACTIONS(2203),
    [anon_sym_typedef] = ACTIONS(2203),
    [anon_sym___device__] = ACTIONS(2203),
    [anon_sym___host__] = ACTIONS(2203),
    [anon_sym___global__] = ACTIONS(2203),
    [anon_sym___forceinline__] = ACTIONS(2203),
    [anon_sym___noinline__] = ACTIONS(2203),
    [anon_sym_extern] = ACTIONS(2203),
    [anon_sym___attribute__] = ACTIONS(2203),
    [anon_sym_COLON_COLON] = ACTIONS(2205),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2205),
    [anon_sym___declspec] = ACTIONS(2203),
    [anon_sym___based] = ACTIONS(2203),
    [anon_sym_signed] = ACTIONS(2203),
    [anon_sym_unsigned] = ACTIONS(2203),
    [anon_sym_long] = ACTIONS(2203),
    [anon_sym_short] = ACTIONS(2203),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_static] = ACTIONS(2203),
    [anon_sym_register] = ACTIONS(2203),
    [anon_sym_inline] = ACTIONS(2203),
    [anon_sym___inline] = ACTIONS(2203),
    [anon_sym___inline__] = ACTIONS(2203),
    [anon_sym___forceinline] = ACTIONS(2203),
    [anon_sym_thread_local] = ACTIONS(2203),
    [anon_sym___thread] = ACTIONS(2203),
    [anon_sym_const] = ACTIONS(2203),
    [anon_sym_constexpr] = ACTIONS(2203),
    [anon_sym_volatile] = ACTIONS(2203),
    [anon_sym_restrict] = ACTIONS(2203),
    [anon_sym___restrict__] = ACTIONS(2203),
    [anon_sym__Atomic] = ACTIONS(2203),
    [anon_sym__Noreturn] = ACTIONS(2203),
    [anon_sym_noreturn] = ACTIONS(2203),
    [anon_sym_mutable] = ACTIONS(2203),
    [anon_sym_constinit] = ACTIONS(2203),
    [anon_sym_consteval] = ACTIONS(2203),
    [anon_sym___shared__] = ACTIONS(2203),
    [anon_sym___local__] = ACTIONS(2203),
    [anon_sym___constant__] = ACTIONS(2203),
    [anon_sym___managed__] = ACTIONS(2203),
    [anon_sym___grid_constant__] = ACTIONS(2203),
    [anon_sym_alignas] = ACTIONS(2203),
    [anon_sym__Alignas] = ACTIONS(2203),
    [sym_primitive_type] = ACTIONS(2203),
    [anon_sym_enum] = ACTIONS(2203),
    [anon_sym_class] = ACTIONS(2203),
    [anon_sym_struct] = ACTIONS(2203),
    [anon_sym_union] = ACTIONS(2203),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2203),
    [anon_sym_decltype] = ACTIONS(2203),
    [sym_virtual] = ACTIONS(2203),
    [anon_sym_explicit] = ACTIONS(2203),
    [anon_sym_typename] = ACTIONS(2203),
    [anon_sym_template] = ACTIONS(2203),
    [anon_sym_operator] = ACTIONS(2203),
    [anon_sym_friend] = ACTIONS(2203),
    [anon_sym_public] = ACTIONS(2203),
    [anon_sym_private] = ACTIONS(2203),
    [anon_sym_protected] = ACTIONS(2203),
    [anon_sym_using] = ACTIONS(2203),
    [anon_sym_static_assert] = ACTIONS(2203),
    [anon_sym___launch_bounds__] = ACTIONS(2203),
  },
  [1804] = {
    [sym_identifier] = ACTIONS(2154),
    [aux_sym_preproc_def_token1] = ACTIONS(2154),
    [aux_sym_preproc_if_token1] = ACTIONS(2154),
    [aux_sym_preproc_if_token2] = ACTIONS(2154),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2154),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2154),
    [aux_sym_preproc_else_token1] = ACTIONS(2154),
    [aux_sym_preproc_elif_token1] = ACTIONS(2154),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2154),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2154),
    [sym_preproc_directive] = ACTIONS(2154),
    [anon_sym_LPAREN2] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_AMP_AMP] = ACTIONS(2156),
    [anon_sym_AMP] = ACTIONS(2154),
    [anon_sym___extension__] = ACTIONS(2154),
    [anon_sym_typedef] = ACTIONS(2154),
    [anon_sym___device__] = ACTIONS(2154),
    [anon_sym___host__] = ACTIONS(2154),
    [anon_sym___global__] = ACTIONS(2154),
    [anon_sym___forceinline__] = ACTIONS(2154),
    [anon_sym___noinline__] = ACTIONS(2154),
    [anon_sym_extern] = ACTIONS(2154),
    [anon_sym___attribute__] = ACTIONS(2154),
    [anon_sym_COLON_COLON] = ACTIONS(2156),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2156),
    [anon_sym___declspec] = ACTIONS(2154),
    [anon_sym___based] = ACTIONS(2154),
    [anon_sym_signed] = ACTIONS(2154),
    [anon_sym_unsigned] = ACTIONS(2154),
    [anon_sym_long] = ACTIONS(2154),
    [anon_sym_short] = ACTIONS(2154),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_static] = ACTIONS(2154),
    [anon_sym_register] = ACTIONS(2154),
    [anon_sym_inline] = ACTIONS(2154),
    [anon_sym___inline] = ACTIONS(2154),
    [anon_sym___inline__] = ACTIONS(2154),
    [anon_sym___forceinline] = ACTIONS(2154),
    [anon_sym_thread_local] = ACTIONS(2154),
    [anon_sym___thread] = ACTIONS(2154),
    [anon_sym_const] = ACTIONS(2154),
    [anon_sym_constexpr] = ACTIONS(2154),
    [anon_sym_volatile] = ACTIONS(2154),
    [anon_sym_restrict] = ACTIONS(2154),
    [anon_sym___restrict__] = ACTIONS(2154),
    [anon_sym__Atomic] = ACTIONS(2154),
    [anon_sym__Noreturn] = ACTIONS(2154),
    [anon_sym_noreturn] = ACTIONS(2154),
    [anon_sym_mutable] = ACTIONS(2154),
    [anon_sym_constinit] = ACTIONS(2154),
    [anon_sym_consteval] = ACTIONS(2154),
    [anon_sym___shared__] = ACTIONS(2154),
    [anon_sym___local__] = ACTIONS(2154),
    [anon_sym___constant__] = ACTIONS(2154),
    [anon_sym___managed__] = ACTIONS(2154),
    [anon_sym___grid_constant__] = ACTIONS(2154),
    [anon_sym_alignas] = ACTIONS(2154),
    [anon_sym__Alignas] = ACTIONS(2154),
    [sym_primitive_type] = ACTIONS(2154),
    [anon_sym_enum] = ACTIONS(2154),
    [anon_sym_class] = ACTIONS(2154),
    [anon_sym_struct] = ACTIONS(2154),
    [anon_sym_union] = ACTIONS(2154),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2154),
    [anon_sym_decltype] = ACTIONS(2154),
    [sym_virtual] = ACTIONS(2154),
    [anon_sym_explicit] = ACTIONS(2154),
    [anon_sym_typename] = ACTIONS(2154),
    [anon_sym_template] = ACTIONS(2154),
    [anon_sym_operator] = ACTIONS(2154),
    [anon_sym_friend] = ACTIONS(2154),
    [anon_sym_public] = ACTIONS(2154),
    [anon_sym_private] = ACTIONS(2154),
    [anon_sym_protected] = ACTIONS(2154),
    [anon_sym_using] = ACTIONS(2154),
    [anon_sym_static_assert] = ACTIONS(2154),
    [anon_sym___launch_bounds__] = ACTIONS(2154),
  },
  [1805] = {
    [sym_identifier] = ACTIONS(2300),
    [aux_sym_preproc_def_token1] = ACTIONS(2300),
    [aux_sym_preproc_if_token1] = ACTIONS(2300),
    [aux_sym_preproc_if_token2] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2300),
    [aux_sym_preproc_else_token1] = ACTIONS(2300),
    [aux_sym_preproc_elif_token1] = ACTIONS(2300),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2300),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2300),
    [sym_preproc_directive] = ACTIONS(2300),
    [anon_sym_LPAREN2] = ACTIONS(2302),
    [anon_sym_TILDE] = ACTIONS(2302),
    [anon_sym_STAR] = ACTIONS(2302),
    [anon_sym_AMP_AMP] = ACTIONS(2302),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym___extension__] = ACTIONS(2300),
    [anon_sym_typedef] = ACTIONS(2300),
    [anon_sym___device__] = ACTIONS(2300),
    [anon_sym___host__] = ACTIONS(2300),
    [anon_sym___global__] = ACTIONS(2300),
    [anon_sym___forceinline__] = ACTIONS(2300),
    [anon_sym___noinline__] = ACTIONS(2300),
    [anon_sym_extern] = ACTIONS(2300),
    [anon_sym___attribute__] = ACTIONS(2300),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2302),
    [anon_sym___declspec] = ACTIONS(2300),
    [anon_sym___based] = ACTIONS(2300),
    [anon_sym_signed] = ACTIONS(2300),
    [anon_sym_unsigned] = ACTIONS(2300),
    [anon_sym_long] = ACTIONS(2300),
    [anon_sym_short] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_register] = ACTIONS(2300),
    [anon_sym_inline] = ACTIONS(2300),
    [anon_sym___inline] = ACTIONS(2300),
    [anon_sym___inline__] = ACTIONS(2300),
    [anon_sym___forceinline] = ACTIONS(2300),
    [anon_sym_thread_local] = ACTIONS(2300),
    [anon_sym___thread] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_constexpr] = ACTIONS(2300),
    [anon_sym_volatile] = ACTIONS(2300),
    [anon_sym_restrict] = ACTIONS(2300),
    [anon_sym___restrict__] = ACTIONS(2300),
    [anon_sym__Atomic] = ACTIONS(2300),
    [anon_sym__Noreturn] = ACTIONS(2300),
    [anon_sym_noreturn] = ACTIONS(2300),
    [anon_sym_mutable] = ACTIONS(2300),
    [anon_sym_constinit] = ACTIONS(2300),
    [anon_sym_consteval] = ACTIONS(2300),
    [anon_sym___shared__] = ACTIONS(2300),
    [anon_sym___local__] = ACTIONS(2300),
    [anon_sym___constant__] = ACTIONS(2300),
    [anon_sym___managed__] = ACTIONS(2300),
    [anon_sym___grid_constant__] = ACTIONS(2300),
    [anon_sym_alignas] = ACTIONS(2300),
    [anon_sym__Alignas] = ACTIONS(2300),
    [sym_primitive_type] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_struct] = ACTIONS(2300),
    [anon_sym_union] = ACTIONS(2300),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2300),
    [anon_sym_decltype] = ACTIONS(2300),
    [sym_virtual] = ACTIONS(2300),
    [anon_sym_explicit] = ACTIONS(2300),
    [anon_sym_typename] = ACTIONS(2300),
    [anon_sym_template] = ACTIONS(2300),
    [anon_sym_operator] = ACTIONS(2300),
    [anon_sym_friend] = ACTIONS(2300),
    [anon_sym_public] = ACTIONS(2300),
    [anon_sym_private] = ACTIONS(2300),
    [anon_sym_protected] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_static_assert] = ACTIONS(2300),
    [anon_sym___launch_bounds__] = ACTIONS(2300),
  },
  [1806] = {
    [sym_identifier] = ACTIONS(2296),
    [aux_sym_preproc_def_token1] = ACTIONS(2296),
    [aux_sym_preproc_if_token1] = ACTIONS(2296),
    [aux_sym_preproc_if_token2] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2296),
    [aux_sym_preproc_else_token1] = ACTIONS(2296),
    [aux_sym_preproc_elif_token1] = ACTIONS(2296),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2296),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2296),
    [sym_preproc_directive] = ACTIONS(2296),
    [anon_sym_LPAREN2] = ACTIONS(2298),
    [anon_sym_TILDE] = ACTIONS(2298),
    [anon_sym_STAR] = ACTIONS(2298),
    [anon_sym_AMP_AMP] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym___extension__] = ACTIONS(2296),
    [anon_sym_typedef] = ACTIONS(2296),
    [anon_sym___device__] = ACTIONS(2296),
    [anon_sym___host__] = ACTIONS(2296),
    [anon_sym___global__] = ACTIONS(2296),
    [anon_sym___forceinline__] = ACTIONS(2296),
    [anon_sym___noinline__] = ACTIONS(2296),
    [anon_sym_extern] = ACTIONS(2296),
    [anon_sym___attribute__] = ACTIONS(2296),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2298),
    [anon_sym___declspec] = ACTIONS(2296),
    [anon_sym___based] = ACTIONS(2296),
    [anon_sym_signed] = ACTIONS(2296),
    [anon_sym_unsigned] = ACTIONS(2296),
    [anon_sym_long] = ACTIONS(2296),
    [anon_sym_short] = ACTIONS(2296),
    [anon_sym_LBRACK] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_register] = ACTIONS(2296),
    [anon_sym_inline] = ACTIONS(2296),
    [anon_sym___inline] = ACTIONS(2296),
    [anon_sym___inline__] = ACTIONS(2296),
    [anon_sym___forceinline] = ACTIONS(2296),
    [anon_sym_thread_local] = ACTIONS(2296),
    [anon_sym___thread] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_constexpr] = ACTIONS(2296),
    [anon_sym_volatile] = ACTIONS(2296),
    [anon_sym_restrict] = ACTIONS(2296),
    [anon_sym___restrict__] = ACTIONS(2296),
    [anon_sym__Atomic] = ACTIONS(2296),
    [anon_sym__Noreturn] = ACTIONS(2296),
    [anon_sym_noreturn] = ACTIONS(2296),
    [anon_sym_mutable] = ACTIONS(2296),
    [anon_sym_constinit] = ACTIONS(2296),
    [anon_sym_consteval] = ACTIONS(2296),
    [anon_sym___shared__] = ACTIONS(2296),
    [anon_sym___local__] = ACTIONS(2296),
    [anon_sym___constant__] = ACTIONS(2296),
    [anon_sym___managed__] = ACTIONS(2296),
    [anon_sym___grid_constant__] = ACTIONS(2296),
    [anon_sym_alignas] = ACTIONS(2296),
    [anon_sym__Alignas] = ACTIONS(2296),
    [sym_primitive_type] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2296),
    [anon_sym_class] = ACTIONS(2296),
    [anon_sym_struct] = ACTIONS(2296),
    [anon_sym_union] = ACTIONS(2296),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2296),
    [anon_sym_decltype] = ACTIONS(2296),
    [sym_virtual] = ACTIONS(2296),
    [anon_sym_explicit] = ACTIONS(2296),
    [anon_sym_typename] = ACTIONS(2296),
    [anon_sym_template] = ACTIONS(2296),
    [anon_sym_operator] = ACTIONS(2296),
    [anon_sym_friend] = ACTIONS(2296),
    [anon_sym_public] = ACTIONS(2296),
    [anon_sym_private] = ACTIONS(2296),
    [anon_sym_protected] = ACTIONS(2296),
    [anon_sym_using] = ACTIONS(2296),
    [anon_sym_static_assert] = ACTIONS(2296),
    [anon_sym___launch_bounds__] = ACTIONS(2296),
  },
  [1807] = {
    [sym_identifier] = ACTIONS(2292),
    [aux_sym_preproc_def_token1] = ACTIONS(2292),
    [aux_sym_preproc_if_token1] = ACTIONS(2292),
    [aux_sym_preproc_if_token2] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2292),
    [aux_sym_preproc_else_token1] = ACTIONS(2292),
    [aux_sym_preproc_elif_token1] = ACTIONS(2292),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2292),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2292),
    [sym_preproc_directive] = ACTIONS(2292),
    [anon_sym_LPAREN2] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym___extension__] = ACTIONS(2292),
    [anon_sym_typedef] = ACTIONS(2292),
    [anon_sym___device__] = ACTIONS(2292),
    [anon_sym___host__] = ACTIONS(2292),
    [anon_sym___global__] = ACTIONS(2292),
    [anon_sym___forceinline__] = ACTIONS(2292),
    [anon_sym___noinline__] = ACTIONS(2292),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym___attribute__] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2294),
    [anon_sym___declspec] = ACTIONS(2292),
    [anon_sym___based] = ACTIONS(2292),
    [anon_sym_signed] = ACTIONS(2292),
    [anon_sym_unsigned] = ACTIONS(2292),
    [anon_sym_long] = ACTIONS(2292),
    [anon_sym_short] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_register] = ACTIONS(2292),
    [anon_sym_inline] = ACTIONS(2292),
    [anon_sym___inline] = ACTIONS(2292),
    [anon_sym___inline__] = ACTIONS(2292),
    [anon_sym___forceinline] = ACTIONS(2292),
    [anon_sym_thread_local] = ACTIONS(2292),
    [anon_sym___thread] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym___restrict__] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym__Noreturn] = ACTIONS(2292),
    [anon_sym_noreturn] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_constinit] = ACTIONS(2292),
    [anon_sym_consteval] = ACTIONS(2292),
    [anon_sym___shared__] = ACTIONS(2292),
    [anon_sym___local__] = ACTIONS(2292),
    [anon_sym___constant__] = ACTIONS(2292),
    [anon_sym___managed__] = ACTIONS(2292),
    [anon_sym___grid_constant__] = ACTIONS(2292),
    [anon_sym_alignas] = ACTIONS(2292),
    [anon_sym__Alignas] = ACTIONS(2292),
    [sym_primitive_type] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_struct] = ACTIONS(2292),
    [anon_sym_union] = ACTIONS(2292),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2292),
    [anon_sym_decltype] = ACTIONS(2292),
    [sym_virtual] = ACTIONS(2292),
    [anon_sym_explicit] = ACTIONS(2292),
    [anon_sym_typename] = ACTIONS(2292),
    [anon_sym_template] = ACTIONS(2292),
    [anon_sym_operator] = ACTIONS(2292),
    [anon_sym_friend] = ACTIONS(2292),
    [anon_sym_public] = ACTIONS(2292),
    [anon_sym_private] = ACTIONS(2292),
    [anon_sym_protected] = ACTIONS(2292),
    [anon_sym_using] = ACTIONS(2292),
    [anon_sym_static_assert] = ACTIONS(2292),
    [anon_sym___launch_bounds__] = ACTIONS(2292),
  },
  [1808] = {
    [sym_identifier] = ACTIONS(1950),
    [aux_sym_preproc_def_token1] = ACTIONS(1950),
    [aux_sym_preproc_if_token1] = ACTIONS(1950),
    [aux_sym_preproc_if_token2] = ACTIONS(1950),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1950),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1950),
    [aux_sym_preproc_else_token1] = ACTIONS(1950),
    [aux_sym_preproc_elif_token1] = ACTIONS(1950),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1950),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1950),
    [sym_preproc_directive] = ACTIONS(1950),
    [anon_sym_LPAREN2] = ACTIONS(1952),
    [anon_sym_TILDE] = ACTIONS(1952),
    [anon_sym_STAR] = ACTIONS(1952),
    [anon_sym_AMP_AMP] = ACTIONS(1952),
    [anon_sym_AMP] = ACTIONS(1950),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_typedef] = ACTIONS(1950),
    [anon_sym___device__] = ACTIONS(1950),
    [anon_sym___host__] = ACTIONS(1950),
    [anon_sym___global__] = ACTIONS(1950),
    [anon_sym___forceinline__] = ACTIONS(1950),
    [anon_sym___noinline__] = ACTIONS(1950),
    [anon_sym_extern] = ACTIONS(1950),
    [anon_sym___attribute__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1952),
    [anon_sym___declspec] = ACTIONS(1950),
    [anon_sym___based] = ACTIONS(1950),
    [anon_sym_signed] = ACTIONS(1950),
    [anon_sym_unsigned] = ACTIONS(1950),
    [anon_sym_long] = ACTIONS(1950),
    [anon_sym_short] = ACTIONS(1950),
    [anon_sym_LBRACK] = ACTIONS(1950),
    [anon_sym_static] = ACTIONS(1950),
    [anon_sym_register] = ACTIONS(1950),
    [anon_sym_inline] = ACTIONS(1950),
    [anon_sym___inline] = ACTIONS(1950),
    [anon_sym___inline__] = ACTIONS(1950),
    [anon_sym___forceinline] = ACTIONS(1950),
    [anon_sym_thread_local] = ACTIONS(1950),
    [anon_sym___thread] = ACTIONS(1950),
    [anon_sym_const] = ACTIONS(1950),
    [anon_sym_constexpr] = ACTIONS(1950),
    [anon_sym_volatile] = ACTIONS(1950),
    [anon_sym_restrict] = ACTIONS(1950),
    [anon_sym___restrict__] = ACTIONS(1950),
    [anon_sym__Atomic] = ACTIONS(1950),
    [anon_sym__Noreturn] = ACTIONS(1950),
    [anon_sym_noreturn] = ACTIONS(1950),
    [anon_sym_mutable] = ACTIONS(1950),
    [anon_sym_constinit] = ACTIONS(1950),
    [anon_sym_consteval] = ACTIONS(1950),
    [anon_sym___shared__] = ACTIONS(1950),
    [anon_sym___local__] = ACTIONS(1950),
    [anon_sym___constant__] = ACTIONS(1950),
    [anon_sym___managed__] = ACTIONS(1950),
    [anon_sym___grid_constant__] = ACTIONS(1950),
    [anon_sym_alignas] = ACTIONS(1950),
    [anon_sym__Alignas] = ACTIONS(1950),
    [sym_primitive_type] = ACTIONS(1950),
    [anon_sym_enum] = ACTIONS(1950),
    [anon_sym_class] = ACTIONS(1950),
    [anon_sym_struct] = ACTIONS(1950),
    [anon_sym_union] = ACTIONS(1950),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1950),
    [anon_sym_decltype] = ACTIONS(1950),
    [sym_virtual] = ACTIONS(1950),
    [anon_sym_explicit] = ACTIONS(1950),
    [anon_sym_typename] = ACTIONS(1950),
    [anon_sym_template] = ACTIONS(1950),
    [anon_sym_operator] = ACTIONS(1950),
    [anon_sym_friend] = ACTIONS(1950),
    [anon_sym_public] = ACTIONS(1950),
    [anon_sym_private] = ACTIONS(1950),
    [anon_sym_protected] = ACTIONS(1950),
    [anon_sym_using] = ACTIONS(1950),
    [anon_sym_static_assert] = ACTIONS(1950),
    [anon_sym___launch_bounds__] = ACTIONS(1950),
  },
  [1809] = {
    [sym_identifier] = ACTIONS(2288),
    [aux_sym_preproc_def_token1] = ACTIONS(2288),
    [aux_sym_preproc_if_token1] = ACTIONS(2288),
    [aux_sym_preproc_if_token2] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2288),
    [aux_sym_preproc_else_token1] = ACTIONS(2288),
    [aux_sym_preproc_elif_token1] = ACTIONS(2288),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2288),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2288),
    [sym_preproc_directive] = ACTIONS(2288),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym_typedef] = ACTIONS(2288),
    [anon_sym___device__] = ACTIONS(2288),
    [anon_sym___host__] = ACTIONS(2288),
    [anon_sym___global__] = ACTIONS(2288),
    [anon_sym___forceinline__] = ACTIONS(2288),
    [anon_sym___noinline__] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2290),
    [anon_sym___declspec] = ACTIONS(2288),
    [anon_sym___based] = ACTIONS(2288),
    [anon_sym_signed] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym___inline] = ACTIONS(2288),
    [anon_sym___inline__] = ACTIONS(2288),
    [anon_sym___forceinline] = ACTIONS(2288),
    [anon_sym_thread_local] = ACTIONS(2288),
    [anon_sym___thread] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym___shared__] = ACTIONS(2288),
    [anon_sym___local__] = ACTIONS(2288),
    [anon_sym___constant__] = ACTIONS(2288),
    [anon_sym___managed__] = ACTIONS(2288),
    [anon_sym___grid_constant__] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [sym_virtual] = ACTIONS(2288),
    [anon_sym_explicit] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_operator] = ACTIONS(2288),
    [anon_sym_friend] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_static_assert] = ACTIONS(2288),
    [anon_sym___launch_bounds__] = ACTIONS(2288),
  },
  [1810] = {
    [sym_identifier] = ACTIONS(2284),
    [aux_sym_preproc_def_token1] = ACTIONS(2284),
    [aux_sym_preproc_if_token1] = ACTIONS(2284),
    [aux_sym_preproc_if_token2] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2284),
    [aux_sym_preproc_else_token1] = ACTIONS(2284),
    [aux_sym_preproc_elif_token1] = ACTIONS(2284),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2284),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2284),
    [sym_preproc_directive] = ACTIONS(2284),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_typedef] = ACTIONS(2284),
    [anon_sym___device__] = ACTIONS(2284),
    [anon_sym___host__] = ACTIONS(2284),
    [anon_sym___global__] = ACTIONS(2284),
    [anon_sym___forceinline__] = ACTIONS(2284),
    [anon_sym___noinline__] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2286),
    [anon_sym___declspec] = ACTIONS(2284),
    [anon_sym___based] = ACTIONS(2284),
    [anon_sym_signed] = ACTIONS(2284),
    [anon_sym_unsigned] = ACTIONS(2284),
    [anon_sym_long] = ACTIONS(2284),
    [anon_sym_short] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym___inline] = ACTIONS(2284),
    [anon_sym___inline__] = ACTIONS(2284),
    [anon_sym___forceinline] = ACTIONS(2284),
    [anon_sym_thread_local] = ACTIONS(2284),
    [anon_sym___thread] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym___shared__] = ACTIONS(2284),
    [anon_sym___local__] = ACTIONS(2284),
    [anon_sym___constant__] = ACTIONS(2284),
    [anon_sym___managed__] = ACTIONS(2284),
    [anon_sym___grid_constant__] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [sym_primitive_type] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
    [anon_sym_class] = ACTIONS(2284),
    [anon_sym_struct] = ACTIONS(2284),
    [anon_sym_union] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [sym_virtual] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_typename] = ACTIONS(2284),
    [anon_sym_template] = ACTIONS(2284),
    [anon_sym_operator] = ACTIONS(2284),
    [anon_sym_friend] = ACTIONS(2284),
    [anon_sym_public] = ACTIONS(2284),
    [anon_sym_private] = ACTIONS(2284),
    [anon_sym_protected] = ACTIONS(2284),
    [anon_sym_using] = ACTIONS(2284),
    [anon_sym_static_assert] = ACTIONS(2284),
    [anon_sym___launch_bounds__] = ACTIONS(2284),
  },
  [1811] = {
    [sym_identifier] = ACTIONS(2275),
    [aux_sym_preproc_def_token1] = ACTIONS(2275),
    [aux_sym_preproc_if_token1] = ACTIONS(2275),
    [aux_sym_preproc_if_token2] = ACTIONS(2275),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2275),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2275),
    [aux_sym_preproc_else_token1] = ACTIONS(2275),
    [aux_sym_preproc_elif_token1] = ACTIONS(2275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2275),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2275),
    [sym_preproc_directive] = ACTIONS(2275),
    [anon_sym_LPAREN2] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [anon_sym_STAR] = ACTIONS(2277),
    [anon_sym_AMP_AMP] = ACTIONS(2277),
    [anon_sym_AMP] = ACTIONS(2275),
    [anon_sym___extension__] = ACTIONS(2275),
    [anon_sym_typedef] = ACTIONS(2275),
    [anon_sym___device__] = ACTIONS(2275),
    [anon_sym___host__] = ACTIONS(2275),
    [anon_sym___global__] = ACTIONS(2275),
    [anon_sym___forceinline__] = ACTIONS(2275),
    [anon_sym___noinline__] = ACTIONS(2275),
    [anon_sym_extern] = ACTIONS(2275),
    [anon_sym___attribute__] = ACTIONS(2275),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2277),
    [anon_sym___declspec] = ACTIONS(2275),
    [anon_sym___based] = ACTIONS(2275),
    [anon_sym_signed] = ACTIONS(2275),
    [anon_sym_unsigned] = ACTIONS(2275),
    [anon_sym_long] = ACTIONS(2275),
    [anon_sym_short] = ACTIONS(2275),
    [anon_sym_LBRACK] = ACTIONS(2275),
    [anon_sym_static] = ACTIONS(2275),
    [anon_sym_register] = ACTIONS(2275),
    [anon_sym_inline] = ACTIONS(2275),
    [anon_sym___inline] = ACTIONS(2275),
    [anon_sym___inline__] = ACTIONS(2275),
    [anon_sym___forceinline] = ACTIONS(2275),
    [anon_sym_thread_local] = ACTIONS(2275),
    [anon_sym___thread] = ACTIONS(2275),
    [anon_sym_const] = ACTIONS(2275),
    [anon_sym_constexpr] = ACTIONS(2275),
    [anon_sym_volatile] = ACTIONS(2275),
    [anon_sym_restrict] = ACTIONS(2275),
    [anon_sym___restrict__] = ACTIONS(2275),
    [anon_sym__Atomic] = ACTIONS(2275),
    [anon_sym__Noreturn] = ACTIONS(2275),
    [anon_sym_noreturn] = ACTIONS(2275),
    [anon_sym_mutable] = ACTIONS(2275),
    [anon_sym_constinit] = ACTIONS(2275),
    [anon_sym_consteval] = ACTIONS(2275),
    [anon_sym___shared__] = ACTIONS(2275),
    [anon_sym___local__] = ACTIONS(2275),
    [anon_sym___constant__] = ACTIONS(2275),
    [anon_sym___managed__] = ACTIONS(2275),
    [anon_sym___grid_constant__] = ACTIONS(2275),
    [anon_sym_alignas] = ACTIONS(2275),
    [anon_sym__Alignas] = ACTIONS(2275),
    [sym_primitive_type] = ACTIONS(2275),
    [anon_sym_enum] = ACTIONS(2275),
    [anon_sym_class] = ACTIONS(2275),
    [anon_sym_struct] = ACTIONS(2275),
    [anon_sym_union] = ACTIONS(2275),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2275),
    [anon_sym_decltype] = ACTIONS(2275),
    [sym_virtual] = ACTIONS(2275),
    [anon_sym_explicit] = ACTIONS(2275),
    [anon_sym_typename] = ACTIONS(2275),
    [anon_sym_template] = ACTIONS(2275),
    [anon_sym_operator] = ACTIONS(2275),
    [anon_sym_friend] = ACTIONS(2275),
    [anon_sym_public] = ACTIONS(2275),
    [anon_sym_private] = ACTIONS(2275),
    [anon_sym_protected] = ACTIONS(2275),
    [anon_sym_using] = ACTIONS(2275),
    [anon_sym_static_assert] = ACTIONS(2275),
    [anon_sym___launch_bounds__] = ACTIONS(2275),
  },
  [1812] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token2] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [aux_sym_preproc_else_token1] = ACTIONS(2267),
    [aux_sym_preproc_elif_token1] = ACTIONS(2267),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2269),
    [anon_sym_TILDE] = ACTIONS(2269),
    [anon_sym_STAR] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym___device__] = ACTIONS(2267),
    [anon_sym___host__] = ACTIONS(2267),
    [anon_sym___global__] = ACTIONS(2267),
    [anon_sym___forceinline__] = ACTIONS(2267),
    [anon_sym___noinline__] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2269),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2269),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym___shared__] = ACTIONS(2267),
    [anon_sym___local__] = ACTIONS(2267),
    [anon_sym___constant__] = ACTIONS(2267),
    [anon_sym___managed__] = ACTIONS(2267),
    [anon_sym___grid_constant__] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym__Alignas] = ACTIONS(2267),
    [sym_primitive_type] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [sym_virtual] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_friend] = ACTIONS(2267),
    [anon_sym_public] = ACTIONS(2267),
    [anon_sym_private] = ACTIONS(2267),
    [anon_sym_protected] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym___launch_bounds__] = ACTIONS(2267),
  },
  [1813] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token2] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [aux_sym_preproc_else_token1] = ACTIONS(2267),
    [aux_sym_preproc_elif_token1] = ACTIONS(2267),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2269),
    [anon_sym_TILDE] = ACTIONS(2269),
    [anon_sym_STAR] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym___device__] = ACTIONS(2267),
    [anon_sym___host__] = ACTIONS(2267),
    [anon_sym___global__] = ACTIONS(2267),
    [anon_sym___forceinline__] = ACTIONS(2267),
    [anon_sym___noinline__] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2269),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2269),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym___shared__] = ACTIONS(2267),
    [anon_sym___local__] = ACTIONS(2267),
    [anon_sym___constant__] = ACTIONS(2267),
    [anon_sym___managed__] = ACTIONS(2267),
    [anon_sym___grid_constant__] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym__Alignas] = ACTIONS(2267),
    [sym_primitive_type] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [sym_virtual] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_friend] = ACTIONS(2267),
    [anon_sym_public] = ACTIONS(2267),
    [anon_sym_private] = ACTIONS(2267),
    [anon_sym_protected] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym___launch_bounds__] = ACTIONS(2267),
  },
  [1814] = {
    [sym_identifier] = ACTIONS(2231),
    [aux_sym_preproc_def_token1] = ACTIONS(2231),
    [aux_sym_preproc_if_token1] = ACTIONS(2231),
    [aux_sym_preproc_if_token2] = ACTIONS(2231),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2231),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2231),
    [aux_sym_preproc_else_token1] = ACTIONS(2231),
    [aux_sym_preproc_elif_token1] = ACTIONS(2231),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2231),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2231),
    [sym_preproc_directive] = ACTIONS(2231),
    [anon_sym_LPAREN2] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_STAR] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym___extension__] = ACTIONS(2231),
    [anon_sym_typedef] = ACTIONS(2231),
    [anon_sym___device__] = ACTIONS(2231),
    [anon_sym___host__] = ACTIONS(2231),
    [anon_sym___global__] = ACTIONS(2231),
    [anon_sym___forceinline__] = ACTIONS(2231),
    [anon_sym___noinline__] = ACTIONS(2231),
    [anon_sym_extern] = ACTIONS(2231),
    [anon_sym___attribute__] = ACTIONS(2231),
    [anon_sym_COLON_COLON] = ACTIONS(2233),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2233),
    [anon_sym___declspec] = ACTIONS(2231),
    [anon_sym___based] = ACTIONS(2231),
    [anon_sym_signed] = ACTIONS(2231),
    [anon_sym_unsigned] = ACTIONS(2231),
    [anon_sym_long] = ACTIONS(2231),
    [anon_sym_short] = ACTIONS(2231),
    [anon_sym_LBRACK] = ACTIONS(2231),
    [anon_sym_static] = ACTIONS(2231),
    [anon_sym_register] = ACTIONS(2231),
    [anon_sym_inline] = ACTIONS(2231),
    [anon_sym___inline] = ACTIONS(2231),
    [anon_sym___inline__] = ACTIONS(2231),
    [anon_sym___forceinline] = ACTIONS(2231),
    [anon_sym_thread_local] = ACTIONS(2231),
    [anon_sym___thread] = ACTIONS(2231),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_constexpr] = ACTIONS(2231),
    [anon_sym_volatile] = ACTIONS(2231),
    [anon_sym_restrict] = ACTIONS(2231),
    [anon_sym___restrict__] = ACTIONS(2231),
    [anon_sym__Atomic] = ACTIONS(2231),
    [anon_sym__Noreturn] = ACTIONS(2231),
    [anon_sym_noreturn] = ACTIONS(2231),
    [anon_sym_mutable] = ACTIONS(2231),
    [anon_sym_constinit] = ACTIONS(2231),
    [anon_sym_consteval] = ACTIONS(2231),
    [anon_sym___shared__] = ACTIONS(2231),
    [anon_sym___local__] = ACTIONS(2231),
    [anon_sym___constant__] = ACTIONS(2231),
    [anon_sym___managed__] = ACTIONS(2231),
    [anon_sym___grid_constant__] = ACTIONS(2231),
    [anon_sym_alignas] = ACTIONS(2231),
    [anon_sym__Alignas] = ACTIONS(2231),
    [sym_primitive_type] = ACTIONS(2231),
    [anon_sym_enum] = ACTIONS(2231),
    [anon_sym_class] = ACTIONS(2231),
    [anon_sym_struct] = ACTIONS(2231),
    [anon_sym_union] = ACTIONS(2231),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2231),
    [anon_sym_decltype] = ACTIONS(2231),
    [sym_virtual] = ACTIONS(2231),
    [anon_sym_explicit] = ACTIONS(2231),
    [anon_sym_typename] = ACTIONS(2231),
    [anon_sym_template] = ACTIONS(2231),
    [anon_sym_operator] = ACTIONS(2231),
    [anon_sym_friend] = ACTIONS(2231),
    [anon_sym_public] = ACTIONS(2231),
    [anon_sym_private] = ACTIONS(2231),
    [anon_sym_protected] = ACTIONS(2231),
    [anon_sym_using] = ACTIONS(2231),
    [anon_sym_static_assert] = ACTIONS(2231),
    [anon_sym___launch_bounds__] = ACTIONS(2231),
  },
  [1815] = {
    [sym_identifier] = ACTIONS(2056),
    [aux_sym_preproc_def_token1] = ACTIONS(2056),
    [aux_sym_preproc_if_token1] = ACTIONS(2056),
    [aux_sym_preproc_if_token2] = ACTIONS(2056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2056),
    [aux_sym_preproc_else_token1] = ACTIONS(2056),
    [aux_sym_preproc_elif_token1] = ACTIONS(2056),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2056),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2056),
    [sym_preproc_directive] = ACTIONS(2056),
    [anon_sym_LPAREN2] = ACTIONS(2058),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_STAR] = ACTIONS(2058),
    [anon_sym_AMP_AMP] = ACTIONS(2058),
    [anon_sym_AMP] = ACTIONS(2056),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_typedef] = ACTIONS(2056),
    [anon_sym___device__] = ACTIONS(2056),
    [anon_sym___host__] = ACTIONS(2056),
    [anon_sym___global__] = ACTIONS(2056),
    [anon_sym___forceinline__] = ACTIONS(2056),
    [anon_sym___noinline__] = ACTIONS(2056),
    [anon_sym_extern] = ACTIONS(2056),
    [anon_sym___attribute__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2058),
    [anon_sym___declspec] = ACTIONS(2056),
    [anon_sym___based] = ACTIONS(2056),
    [anon_sym_signed] = ACTIONS(2056),
    [anon_sym_unsigned] = ACTIONS(2056),
    [anon_sym_long] = ACTIONS(2056),
    [anon_sym_short] = ACTIONS(2056),
    [anon_sym_LBRACK] = ACTIONS(2056),
    [anon_sym_static] = ACTIONS(2056),
    [anon_sym_register] = ACTIONS(2056),
    [anon_sym_inline] = ACTIONS(2056),
    [anon_sym___inline] = ACTIONS(2056),
    [anon_sym___inline__] = ACTIONS(2056),
    [anon_sym___forceinline] = ACTIONS(2056),
    [anon_sym_thread_local] = ACTIONS(2056),
    [anon_sym___thread] = ACTIONS(2056),
    [anon_sym_const] = ACTIONS(2056),
    [anon_sym_constexpr] = ACTIONS(2056),
    [anon_sym_volatile] = ACTIONS(2056),
    [anon_sym_restrict] = ACTIONS(2056),
    [anon_sym___restrict__] = ACTIONS(2056),
    [anon_sym__Atomic] = ACTIONS(2056),
    [anon_sym__Noreturn] = ACTIONS(2056),
    [anon_sym_noreturn] = ACTIONS(2056),
    [anon_sym_mutable] = ACTIONS(2056),
    [anon_sym_constinit] = ACTIONS(2056),
    [anon_sym_consteval] = ACTIONS(2056),
    [anon_sym___shared__] = ACTIONS(2056),
    [anon_sym___local__] = ACTIONS(2056),
    [anon_sym___constant__] = ACTIONS(2056),
    [anon_sym___managed__] = ACTIONS(2056),
    [anon_sym___grid_constant__] = ACTIONS(2056),
    [anon_sym_alignas] = ACTIONS(2056),
    [anon_sym__Alignas] = ACTIONS(2056),
    [sym_primitive_type] = ACTIONS(2056),
    [anon_sym_enum] = ACTIONS(2056),
    [anon_sym_class] = ACTIONS(2056),
    [anon_sym_struct] = ACTIONS(2056),
    [anon_sym_union] = ACTIONS(2056),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2056),
    [anon_sym_decltype] = ACTIONS(2056),
    [sym_virtual] = ACTIONS(2056),
    [anon_sym_explicit] = ACTIONS(2056),
    [anon_sym_typename] = ACTIONS(2056),
    [anon_sym_template] = ACTIONS(2056),
    [anon_sym_operator] = ACTIONS(2056),
    [anon_sym_friend] = ACTIONS(2056),
    [anon_sym_public] = ACTIONS(2056),
    [anon_sym_private] = ACTIONS(2056),
    [anon_sym_protected] = ACTIONS(2056),
    [anon_sym_using] = ACTIONS(2056),
    [anon_sym_static_assert] = ACTIONS(2056),
    [anon_sym___launch_bounds__] = ACTIONS(2056),
  },
  [1816] = {
    [sym_identifier] = ACTIONS(2255),
    [aux_sym_preproc_def_token1] = ACTIONS(2255),
    [aux_sym_preproc_if_token1] = ACTIONS(2255),
    [aux_sym_preproc_if_token2] = ACTIONS(2255),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2255),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2255),
    [aux_sym_preproc_else_token1] = ACTIONS(2255),
    [aux_sym_preproc_elif_token1] = ACTIONS(2255),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2255),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2255),
    [sym_preproc_directive] = ACTIONS(2255),
    [anon_sym_LPAREN2] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_STAR] = ACTIONS(2257),
    [anon_sym_AMP_AMP] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2255),
    [anon_sym___extension__] = ACTIONS(2255),
    [anon_sym_typedef] = ACTIONS(2255),
    [anon_sym___device__] = ACTIONS(2255),
    [anon_sym___host__] = ACTIONS(2255),
    [anon_sym___global__] = ACTIONS(2255),
    [anon_sym___forceinline__] = ACTIONS(2255),
    [anon_sym___noinline__] = ACTIONS(2255),
    [anon_sym_extern] = ACTIONS(2255),
    [anon_sym___attribute__] = ACTIONS(2255),
    [anon_sym_COLON_COLON] = ACTIONS(2257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2257),
    [anon_sym___declspec] = ACTIONS(2255),
    [anon_sym___based] = ACTIONS(2255),
    [anon_sym_signed] = ACTIONS(2255),
    [anon_sym_unsigned] = ACTIONS(2255),
    [anon_sym_long] = ACTIONS(2255),
    [anon_sym_short] = ACTIONS(2255),
    [anon_sym_LBRACK] = ACTIONS(2255),
    [anon_sym_static] = ACTIONS(2255),
    [anon_sym_register] = ACTIONS(2255),
    [anon_sym_inline] = ACTIONS(2255),
    [anon_sym___inline] = ACTIONS(2255),
    [anon_sym___inline__] = ACTIONS(2255),
    [anon_sym___forceinline] = ACTIONS(2255),
    [anon_sym_thread_local] = ACTIONS(2255),
    [anon_sym___thread] = ACTIONS(2255),
    [anon_sym_const] = ACTIONS(2255),
    [anon_sym_constexpr] = ACTIONS(2255),
    [anon_sym_volatile] = ACTIONS(2255),
    [anon_sym_restrict] = ACTIONS(2255),
    [anon_sym___restrict__] = ACTIONS(2255),
    [anon_sym__Atomic] = ACTIONS(2255),
    [anon_sym__Noreturn] = ACTIONS(2255),
    [anon_sym_noreturn] = ACTIONS(2255),
    [anon_sym_mutable] = ACTIONS(2255),
    [anon_sym_constinit] = ACTIONS(2255),
    [anon_sym_consteval] = ACTIONS(2255),
    [anon_sym___shared__] = ACTIONS(2255),
    [anon_sym___local__] = ACTIONS(2255),
    [anon_sym___constant__] = ACTIONS(2255),
    [anon_sym___managed__] = ACTIONS(2255),
    [anon_sym___grid_constant__] = ACTIONS(2255),
    [anon_sym_alignas] = ACTIONS(2255),
    [anon_sym__Alignas] = ACTIONS(2255),
    [sym_primitive_type] = ACTIONS(2255),
    [anon_sym_enum] = ACTIONS(2255),
    [anon_sym_class] = ACTIONS(2255),
    [anon_sym_struct] = ACTIONS(2255),
    [anon_sym_union] = ACTIONS(2255),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2255),
    [anon_sym_decltype] = ACTIONS(2255),
    [sym_virtual] = ACTIONS(2255),
    [anon_sym_explicit] = ACTIONS(2255),
    [anon_sym_typename] = ACTIONS(2255),
    [anon_sym_template] = ACTIONS(2255),
    [anon_sym_operator] = ACTIONS(2255),
    [anon_sym_friend] = ACTIONS(2255),
    [anon_sym_public] = ACTIONS(2255),
    [anon_sym_private] = ACTIONS(2255),
    [anon_sym_protected] = ACTIONS(2255),
    [anon_sym_using] = ACTIONS(2255),
    [anon_sym_static_assert] = ACTIONS(2255),
    [anon_sym___launch_bounds__] = ACTIONS(2255),
  },
  [1817] = {
    [sym_catch_clause] = STATE(1817),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1817),
    [sym_identifier] = ACTIONS(1909),
    [aux_sym_preproc_def_token1] = ACTIONS(1909),
    [aux_sym_preproc_if_token1] = ACTIONS(1909),
    [aux_sym_preproc_if_token2] = ACTIONS(1909),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1909),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1909),
    [sym_preproc_directive] = ACTIONS(1909),
    [anon_sym_LPAREN2] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym___extension__] = ACTIONS(1909),
    [anon_sym_typedef] = ACTIONS(1909),
    [anon_sym___device__] = ACTIONS(1909),
    [anon_sym___host__] = ACTIONS(1909),
    [anon_sym___global__] = ACTIONS(1909),
    [anon_sym___forceinline__] = ACTIONS(1909),
    [anon_sym___noinline__] = ACTIONS(1909),
    [anon_sym_extern] = ACTIONS(1909),
    [anon_sym___attribute__] = ACTIONS(1909),
    [anon_sym_COLON_COLON] = ACTIONS(1911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1911),
    [anon_sym___declspec] = ACTIONS(1909),
    [anon_sym___based] = ACTIONS(1909),
    [anon_sym_signed] = ACTIONS(1909),
    [anon_sym_unsigned] = ACTIONS(1909),
    [anon_sym_long] = ACTIONS(1909),
    [anon_sym_short] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_static] = ACTIONS(1909),
    [anon_sym_register] = ACTIONS(1909),
    [anon_sym_inline] = ACTIONS(1909),
    [anon_sym___inline] = ACTIONS(1909),
    [anon_sym___inline__] = ACTIONS(1909),
    [anon_sym___forceinline] = ACTIONS(1909),
    [anon_sym_thread_local] = ACTIONS(1909),
    [anon_sym___thread] = ACTIONS(1909),
    [anon_sym_const] = ACTIONS(1909),
    [anon_sym_constexpr] = ACTIONS(1909),
    [anon_sym_volatile] = ACTIONS(1909),
    [anon_sym_restrict] = ACTIONS(1909),
    [anon_sym___restrict__] = ACTIONS(1909),
    [anon_sym__Atomic] = ACTIONS(1909),
    [anon_sym__Noreturn] = ACTIONS(1909),
    [anon_sym_noreturn] = ACTIONS(1909),
    [anon_sym_mutable] = ACTIONS(1909),
    [anon_sym_constinit] = ACTIONS(1909),
    [anon_sym_consteval] = ACTIONS(1909),
    [anon_sym___shared__] = ACTIONS(1909),
    [anon_sym___local__] = ACTIONS(1909),
    [anon_sym___constant__] = ACTIONS(1909),
    [anon_sym___managed__] = ACTIONS(1909),
    [anon_sym___grid_constant__] = ACTIONS(1909),
    [anon_sym_alignas] = ACTIONS(1909),
    [anon_sym__Alignas] = ACTIONS(1909),
    [sym_primitive_type] = ACTIONS(1909),
    [anon_sym_enum] = ACTIONS(1909),
    [anon_sym_class] = ACTIONS(1909),
    [anon_sym_struct] = ACTIONS(1909),
    [anon_sym_union] = ACTIONS(1909),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1909),
    [anon_sym_decltype] = ACTIONS(1909),
    [sym_virtual] = ACTIONS(1909),
    [anon_sym_explicit] = ACTIONS(1909),
    [anon_sym_typename] = ACTIONS(1909),
    [anon_sym_template] = ACTIONS(1909),
    [anon_sym_operator] = ACTIONS(1909),
    [anon_sym_friend] = ACTIONS(1909),
    [anon_sym_public] = ACTIONS(1909),
    [anon_sym_private] = ACTIONS(1909),
    [anon_sym_protected] = ACTIONS(1909),
    [anon_sym_using] = ACTIONS(1909),
    [anon_sym_static_assert] = ACTIONS(1909),
    [anon_sym_catch] = ACTIONS(5135),
    [anon_sym___launch_bounds__] = ACTIONS(1909),
  },
  [1818] = {
    [sym_catch_clause] = STATE(1817),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1817),
    [sym_identifier] = ACTIONS(1916),
    [aux_sym_preproc_def_token1] = ACTIONS(1916),
    [aux_sym_preproc_if_token1] = ACTIONS(1916),
    [aux_sym_preproc_if_token2] = ACTIONS(1916),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1916),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1916),
    [sym_preproc_directive] = ACTIONS(1916),
    [anon_sym_LPAREN2] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [anon_sym_STAR] = ACTIONS(1918),
    [anon_sym_AMP_AMP] = ACTIONS(1918),
    [anon_sym_AMP] = ACTIONS(1916),
    [anon_sym___extension__] = ACTIONS(1916),
    [anon_sym_typedef] = ACTIONS(1916),
    [anon_sym___device__] = ACTIONS(1916),
    [anon_sym___host__] = ACTIONS(1916),
    [anon_sym___global__] = ACTIONS(1916),
    [anon_sym___forceinline__] = ACTIONS(1916),
    [anon_sym___noinline__] = ACTIONS(1916),
    [anon_sym_extern] = ACTIONS(1916),
    [anon_sym___attribute__] = ACTIONS(1916),
    [anon_sym_COLON_COLON] = ACTIONS(1918),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1918),
    [anon_sym___declspec] = ACTIONS(1916),
    [anon_sym___based] = ACTIONS(1916),
    [anon_sym_signed] = ACTIONS(1916),
    [anon_sym_unsigned] = ACTIONS(1916),
    [anon_sym_long] = ACTIONS(1916),
    [anon_sym_short] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1916),
    [anon_sym_static] = ACTIONS(1916),
    [anon_sym_register] = ACTIONS(1916),
    [anon_sym_inline] = ACTIONS(1916),
    [anon_sym___inline] = ACTIONS(1916),
    [anon_sym___inline__] = ACTIONS(1916),
    [anon_sym___forceinline] = ACTIONS(1916),
    [anon_sym_thread_local] = ACTIONS(1916),
    [anon_sym___thread] = ACTIONS(1916),
    [anon_sym_const] = ACTIONS(1916),
    [anon_sym_constexpr] = ACTIONS(1916),
    [anon_sym_volatile] = ACTIONS(1916),
    [anon_sym_restrict] = ACTIONS(1916),
    [anon_sym___restrict__] = ACTIONS(1916),
    [anon_sym__Atomic] = ACTIONS(1916),
    [anon_sym__Noreturn] = ACTIONS(1916),
    [anon_sym_noreturn] = ACTIONS(1916),
    [anon_sym_mutable] = ACTIONS(1916),
    [anon_sym_constinit] = ACTIONS(1916),
    [anon_sym_consteval] = ACTIONS(1916),
    [anon_sym___shared__] = ACTIONS(1916),
    [anon_sym___local__] = ACTIONS(1916),
    [anon_sym___constant__] = ACTIONS(1916),
    [anon_sym___managed__] = ACTIONS(1916),
    [anon_sym___grid_constant__] = ACTIONS(1916),
    [anon_sym_alignas] = ACTIONS(1916),
    [anon_sym__Alignas] = ACTIONS(1916),
    [sym_primitive_type] = ACTIONS(1916),
    [anon_sym_enum] = ACTIONS(1916),
    [anon_sym_class] = ACTIONS(1916),
    [anon_sym_struct] = ACTIONS(1916),
    [anon_sym_union] = ACTIONS(1916),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1916),
    [anon_sym_decltype] = ACTIONS(1916),
    [sym_virtual] = ACTIONS(1916),
    [anon_sym_explicit] = ACTIONS(1916),
    [anon_sym_typename] = ACTIONS(1916),
    [anon_sym_template] = ACTIONS(1916),
    [anon_sym_operator] = ACTIONS(1916),
    [anon_sym_friend] = ACTIONS(1916),
    [anon_sym_public] = ACTIONS(1916),
    [anon_sym_private] = ACTIONS(1916),
    [anon_sym_protected] = ACTIONS(1916),
    [anon_sym_using] = ACTIONS(1916),
    [anon_sym_static_assert] = ACTIONS(1916),
    [anon_sym_catch] = ACTIONS(5138),
    [anon_sym___launch_bounds__] = ACTIONS(1916),
  },
  [1819] = {
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5329),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6816),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4853),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1820] = {
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5345),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6816),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4853),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1821] = {
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5335),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6816),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4853),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1822] = {
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5338),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6816),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4853),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1823] = {
    [sym_catch_clause] = STATE(1823),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1823),
    [sym_identifier] = ACTIONS(1909),
    [aux_sym_preproc_def_token1] = ACTIONS(1909),
    [aux_sym_preproc_if_token1] = ACTIONS(1909),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1909),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1909),
    [sym_preproc_directive] = ACTIONS(1909),
    [anon_sym_LPAREN2] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym___extension__] = ACTIONS(1909),
    [anon_sym_typedef] = ACTIONS(1909),
    [anon_sym___device__] = ACTIONS(1909),
    [anon_sym___host__] = ACTIONS(1909),
    [anon_sym___global__] = ACTIONS(1909),
    [anon_sym___forceinline__] = ACTIONS(1909),
    [anon_sym___noinline__] = ACTIONS(1909),
    [anon_sym_extern] = ACTIONS(1909),
    [anon_sym___attribute__] = ACTIONS(1909),
    [anon_sym_COLON_COLON] = ACTIONS(1911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1911),
    [anon_sym___declspec] = ACTIONS(1909),
    [anon_sym___based] = ACTIONS(1909),
    [anon_sym_RBRACE] = ACTIONS(1911),
    [anon_sym_signed] = ACTIONS(1909),
    [anon_sym_unsigned] = ACTIONS(1909),
    [anon_sym_long] = ACTIONS(1909),
    [anon_sym_short] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_static] = ACTIONS(1909),
    [anon_sym_register] = ACTIONS(1909),
    [anon_sym_inline] = ACTIONS(1909),
    [anon_sym___inline] = ACTIONS(1909),
    [anon_sym___inline__] = ACTIONS(1909),
    [anon_sym___forceinline] = ACTIONS(1909),
    [anon_sym_thread_local] = ACTIONS(1909),
    [anon_sym___thread] = ACTIONS(1909),
    [anon_sym_const] = ACTIONS(1909),
    [anon_sym_constexpr] = ACTIONS(1909),
    [anon_sym_volatile] = ACTIONS(1909),
    [anon_sym_restrict] = ACTIONS(1909),
    [anon_sym___restrict__] = ACTIONS(1909),
    [anon_sym__Atomic] = ACTIONS(1909),
    [anon_sym__Noreturn] = ACTIONS(1909),
    [anon_sym_noreturn] = ACTIONS(1909),
    [anon_sym_mutable] = ACTIONS(1909),
    [anon_sym_constinit] = ACTIONS(1909),
    [anon_sym_consteval] = ACTIONS(1909),
    [anon_sym___shared__] = ACTIONS(1909),
    [anon_sym___local__] = ACTIONS(1909),
    [anon_sym___constant__] = ACTIONS(1909),
    [anon_sym___managed__] = ACTIONS(1909),
    [anon_sym___grid_constant__] = ACTIONS(1909),
    [anon_sym_alignas] = ACTIONS(1909),
    [anon_sym__Alignas] = ACTIONS(1909),
    [sym_primitive_type] = ACTIONS(1909),
    [anon_sym_enum] = ACTIONS(1909),
    [anon_sym_class] = ACTIONS(1909),
    [anon_sym_struct] = ACTIONS(1909),
    [anon_sym_union] = ACTIONS(1909),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1909),
    [anon_sym_decltype] = ACTIONS(1909),
    [sym_virtual] = ACTIONS(1909),
    [anon_sym_explicit] = ACTIONS(1909),
    [anon_sym_typename] = ACTIONS(1909),
    [anon_sym_template] = ACTIONS(1909),
    [anon_sym_operator] = ACTIONS(1909),
    [anon_sym_friend] = ACTIONS(1909),
    [anon_sym_public] = ACTIONS(1909),
    [anon_sym_private] = ACTIONS(1909),
    [anon_sym_protected] = ACTIONS(1909),
    [anon_sym_using] = ACTIONS(1909),
    [anon_sym_static_assert] = ACTIONS(1909),
    [anon_sym_catch] = ACTIONS(5140),
    [anon_sym___launch_bounds__] = ACTIONS(1909),
  },
  [1824] = {
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5347),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6816),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4853),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1825] = {
    [sym_catch_clause] = STATE(1817),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1817),
    [sym_identifier] = ACTIONS(1903),
    [aux_sym_preproc_def_token1] = ACTIONS(1903),
    [aux_sym_preproc_if_token1] = ACTIONS(1903),
    [aux_sym_preproc_if_token2] = ACTIONS(1903),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1903),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1903),
    [sym_preproc_directive] = ACTIONS(1903),
    [anon_sym_LPAREN2] = ACTIONS(1905),
    [anon_sym_TILDE] = ACTIONS(1905),
    [anon_sym_STAR] = ACTIONS(1905),
    [anon_sym_AMP_AMP] = ACTIONS(1905),
    [anon_sym_AMP] = ACTIONS(1903),
    [anon_sym___extension__] = ACTIONS(1903),
    [anon_sym_typedef] = ACTIONS(1903),
    [anon_sym___device__] = ACTIONS(1903),
    [anon_sym___host__] = ACTIONS(1903),
    [anon_sym___global__] = ACTIONS(1903),
    [anon_sym___forceinline__] = ACTIONS(1903),
    [anon_sym___noinline__] = ACTIONS(1903),
    [anon_sym_extern] = ACTIONS(1903),
    [anon_sym___attribute__] = ACTIONS(1903),
    [anon_sym_COLON_COLON] = ACTIONS(1905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1905),
    [anon_sym___declspec] = ACTIONS(1903),
    [anon_sym___based] = ACTIONS(1903),
    [anon_sym_signed] = ACTIONS(1903),
    [anon_sym_unsigned] = ACTIONS(1903),
    [anon_sym_long] = ACTIONS(1903),
    [anon_sym_short] = ACTIONS(1903),
    [anon_sym_LBRACK] = ACTIONS(1903),
    [anon_sym_static] = ACTIONS(1903),
    [anon_sym_register] = ACTIONS(1903),
    [anon_sym_inline] = ACTIONS(1903),
    [anon_sym___inline] = ACTIONS(1903),
    [anon_sym___inline__] = ACTIONS(1903),
    [anon_sym___forceinline] = ACTIONS(1903),
    [anon_sym_thread_local] = ACTIONS(1903),
    [anon_sym___thread] = ACTIONS(1903),
    [anon_sym_const] = ACTIONS(1903),
    [anon_sym_constexpr] = ACTIONS(1903),
    [anon_sym_volatile] = ACTIONS(1903),
    [anon_sym_restrict] = ACTIONS(1903),
    [anon_sym___restrict__] = ACTIONS(1903),
    [anon_sym__Atomic] = ACTIONS(1903),
    [anon_sym__Noreturn] = ACTIONS(1903),
    [anon_sym_noreturn] = ACTIONS(1903),
    [anon_sym_mutable] = ACTIONS(1903),
    [anon_sym_constinit] = ACTIONS(1903),
    [anon_sym_consteval] = ACTIONS(1903),
    [anon_sym___shared__] = ACTIONS(1903),
    [anon_sym___local__] = ACTIONS(1903),
    [anon_sym___constant__] = ACTIONS(1903),
    [anon_sym___managed__] = ACTIONS(1903),
    [anon_sym___grid_constant__] = ACTIONS(1903),
    [anon_sym_alignas] = ACTIONS(1903),
    [anon_sym__Alignas] = ACTIONS(1903),
    [sym_primitive_type] = ACTIONS(1903),
    [anon_sym_enum] = ACTIONS(1903),
    [anon_sym_class] = ACTIONS(1903),
    [anon_sym_struct] = ACTIONS(1903),
    [anon_sym_union] = ACTIONS(1903),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1903),
    [anon_sym_decltype] = ACTIONS(1903),
    [sym_virtual] = ACTIONS(1903),
    [anon_sym_explicit] = ACTIONS(1903),
    [anon_sym_typename] = ACTIONS(1903),
    [anon_sym_template] = ACTIONS(1903),
    [anon_sym_operator] = ACTIONS(1903),
    [anon_sym_friend] = ACTIONS(1903),
    [anon_sym_public] = ACTIONS(1903),
    [anon_sym_private] = ACTIONS(1903),
    [anon_sym_protected] = ACTIONS(1903),
    [anon_sym_using] = ACTIONS(1903),
    [anon_sym_static_assert] = ACTIONS(1903),
    [anon_sym_catch] = ACTIONS(5138),
    [anon_sym___launch_bounds__] = ACTIONS(1903),
  },
  [1826] = {
    [sym_catch_clause] = STATE(1823),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1823),
    [sym_identifier] = ACTIONS(1916),
    [aux_sym_preproc_def_token1] = ACTIONS(1916),
    [aux_sym_preproc_if_token1] = ACTIONS(1916),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1916),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1916),
    [sym_preproc_directive] = ACTIONS(1916),
    [anon_sym_LPAREN2] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [anon_sym_STAR] = ACTIONS(1918),
    [anon_sym_AMP_AMP] = ACTIONS(1918),
    [anon_sym_AMP] = ACTIONS(1916),
    [anon_sym___extension__] = ACTIONS(1916),
    [anon_sym_typedef] = ACTIONS(1916),
    [anon_sym___device__] = ACTIONS(1916),
    [anon_sym___host__] = ACTIONS(1916),
    [anon_sym___global__] = ACTIONS(1916),
    [anon_sym___forceinline__] = ACTIONS(1916),
    [anon_sym___noinline__] = ACTIONS(1916),
    [anon_sym_extern] = ACTIONS(1916),
    [anon_sym___attribute__] = ACTIONS(1916),
    [anon_sym_COLON_COLON] = ACTIONS(1918),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1918),
    [anon_sym___declspec] = ACTIONS(1916),
    [anon_sym___based] = ACTIONS(1916),
    [anon_sym_RBRACE] = ACTIONS(1918),
    [anon_sym_signed] = ACTIONS(1916),
    [anon_sym_unsigned] = ACTIONS(1916),
    [anon_sym_long] = ACTIONS(1916),
    [anon_sym_short] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1916),
    [anon_sym_static] = ACTIONS(1916),
    [anon_sym_register] = ACTIONS(1916),
    [anon_sym_inline] = ACTIONS(1916),
    [anon_sym___inline] = ACTIONS(1916),
    [anon_sym___inline__] = ACTIONS(1916),
    [anon_sym___forceinline] = ACTIONS(1916),
    [anon_sym_thread_local] = ACTIONS(1916),
    [anon_sym___thread] = ACTIONS(1916),
    [anon_sym_const] = ACTIONS(1916),
    [anon_sym_constexpr] = ACTIONS(1916),
    [anon_sym_volatile] = ACTIONS(1916),
    [anon_sym_restrict] = ACTIONS(1916),
    [anon_sym___restrict__] = ACTIONS(1916),
    [anon_sym__Atomic] = ACTIONS(1916),
    [anon_sym__Noreturn] = ACTIONS(1916),
    [anon_sym_noreturn] = ACTIONS(1916),
    [anon_sym_mutable] = ACTIONS(1916),
    [anon_sym_constinit] = ACTIONS(1916),
    [anon_sym_consteval] = ACTIONS(1916),
    [anon_sym___shared__] = ACTIONS(1916),
    [anon_sym___local__] = ACTIONS(1916),
    [anon_sym___constant__] = ACTIONS(1916),
    [anon_sym___managed__] = ACTIONS(1916),
    [anon_sym___grid_constant__] = ACTIONS(1916),
    [anon_sym_alignas] = ACTIONS(1916),
    [anon_sym__Alignas] = ACTIONS(1916),
    [sym_primitive_type] = ACTIONS(1916),
    [anon_sym_enum] = ACTIONS(1916),
    [anon_sym_class] = ACTIONS(1916),
    [anon_sym_struct] = ACTIONS(1916),
    [anon_sym_union] = ACTIONS(1916),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1916),
    [anon_sym_decltype] = ACTIONS(1916),
    [sym_virtual] = ACTIONS(1916),
    [anon_sym_explicit] = ACTIONS(1916),
    [anon_sym_typename] = ACTIONS(1916),
    [anon_sym_template] = ACTIONS(1916),
    [anon_sym_operator] = ACTIONS(1916),
    [anon_sym_friend] = ACTIONS(1916),
    [anon_sym_public] = ACTIONS(1916),
    [anon_sym_private] = ACTIONS(1916),
    [anon_sym_protected] = ACTIONS(1916),
    [anon_sym_using] = ACTIONS(1916),
    [anon_sym_static_assert] = ACTIONS(1916),
    [anon_sym_catch] = ACTIONS(5143),
    [anon_sym___launch_bounds__] = ACTIONS(1916),
  },
  [1827] = {
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5581),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6816),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4853),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1828] = {
    [sym_catch_clause] = STATE(1823),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1823),
    [sym_identifier] = ACTIONS(1920),
    [aux_sym_preproc_def_token1] = ACTIONS(1920),
    [aux_sym_preproc_if_token1] = ACTIONS(1920),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1920),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1920),
    [sym_preproc_directive] = ACTIONS(1920),
    [anon_sym_LPAREN2] = ACTIONS(1922),
    [anon_sym_TILDE] = ACTIONS(1922),
    [anon_sym_STAR] = ACTIONS(1922),
    [anon_sym_AMP_AMP] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1920),
    [anon_sym___extension__] = ACTIONS(1920),
    [anon_sym_typedef] = ACTIONS(1920),
    [anon_sym___device__] = ACTIONS(1920),
    [anon_sym___host__] = ACTIONS(1920),
    [anon_sym___global__] = ACTIONS(1920),
    [anon_sym___forceinline__] = ACTIONS(1920),
    [anon_sym___noinline__] = ACTIONS(1920),
    [anon_sym_extern] = ACTIONS(1920),
    [anon_sym___attribute__] = ACTIONS(1920),
    [anon_sym_COLON_COLON] = ACTIONS(1922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1922),
    [anon_sym___declspec] = ACTIONS(1920),
    [anon_sym___based] = ACTIONS(1920),
    [anon_sym_RBRACE] = ACTIONS(1922),
    [anon_sym_signed] = ACTIONS(1920),
    [anon_sym_unsigned] = ACTIONS(1920),
    [anon_sym_long] = ACTIONS(1920),
    [anon_sym_short] = ACTIONS(1920),
    [anon_sym_LBRACK] = ACTIONS(1920),
    [anon_sym_static] = ACTIONS(1920),
    [anon_sym_register] = ACTIONS(1920),
    [anon_sym_inline] = ACTIONS(1920),
    [anon_sym___inline] = ACTIONS(1920),
    [anon_sym___inline__] = ACTIONS(1920),
    [anon_sym___forceinline] = ACTIONS(1920),
    [anon_sym_thread_local] = ACTIONS(1920),
    [anon_sym___thread] = ACTIONS(1920),
    [anon_sym_const] = ACTIONS(1920),
    [anon_sym_constexpr] = ACTIONS(1920),
    [anon_sym_volatile] = ACTIONS(1920),
    [anon_sym_restrict] = ACTIONS(1920),
    [anon_sym___restrict__] = ACTIONS(1920),
    [anon_sym__Atomic] = ACTIONS(1920),
    [anon_sym__Noreturn] = ACTIONS(1920),
    [anon_sym_noreturn] = ACTIONS(1920),
    [anon_sym_mutable] = ACTIONS(1920),
    [anon_sym_constinit] = ACTIONS(1920),
    [anon_sym_consteval] = ACTIONS(1920),
    [anon_sym___shared__] = ACTIONS(1920),
    [anon_sym___local__] = ACTIONS(1920),
    [anon_sym___constant__] = ACTIONS(1920),
    [anon_sym___managed__] = ACTIONS(1920),
    [anon_sym___grid_constant__] = ACTIONS(1920),
    [anon_sym_alignas] = ACTIONS(1920),
    [anon_sym__Alignas] = ACTIONS(1920),
    [sym_primitive_type] = ACTIONS(1920),
    [anon_sym_enum] = ACTIONS(1920),
    [anon_sym_class] = ACTIONS(1920),
    [anon_sym_struct] = ACTIONS(1920),
    [anon_sym_union] = ACTIONS(1920),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1920),
    [anon_sym_decltype] = ACTIONS(1920),
    [sym_virtual] = ACTIONS(1920),
    [anon_sym_explicit] = ACTIONS(1920),
    [anon_sym_typename] = ACTIONS(1920),
    [anon_sym_template] = ACTIONS(1920),
    [anon_sym_operator] = ACTIONS(1920),
    [anon_sym_friend] = ACTIONS(1920),
    [anon_sym_public] = ACTIONS(1920),
    [anon_sym_private] = ACTIONS(1920),
    [anon_sym_protected] = ACTIONS(1920),
    [anon_sym_using] = ACTIONS(1920),
    [anon_sym_static_assert] = ACTIONS(1920),
    [anon_sym_catch] = ACTIONS(5143),
    [anon_sym___launch_bounds__] = ACTIONS(1920),
  },
  [1829] = {
    [sym_catch_clause] = STATE(1823),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1823),
    [sym_identifier] = ACTIONS(1903),
    [aux_sym_preproc_def_token1] = ACTIONS(1903),
    [aux_sym_preproc_if_token1] = ACTIONS(1903),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1903),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1903),
    [sym_preproc_directive] = ACTIONS(1903),
    [anon_sym_LPAREN2] = ACTIONS(1905),
    [anon_sym_TILDE] = ACTIONS(1905),
    [anon_sym_STAR] = ACTIONS(1905),
    [anon_sym_AMP_AMP] = ACTIONS(1905),
    [anon_sym_AMP] = ACTIONS(1903),
    [anon_sym___extension__] = ACTIONS(1903),
    [anon_sym_typedef] = ACTIONS(1903),
    [anon_sym___device__] = ACTIONS(1903),
    [anon_sym___host__] = ACTIONS(1903),
    [anon_sym___global__] = ACTIONS(1903),
    [anon_sym___forceinline__] = ACTIONS(1903),
    [anon_sym___noinline__] = ACTIONS(1903),
    [anon_sym_extern] = ACTIONS(1903),
    [anon_sym___attribute__] = ACTIONS(1903),
    [anon_sym_COLON_COLON] = ACTIONS(1905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1905),
    [anon_sym___declspec] = ACTIONS(1903),
    [anon_sym___based] = ACTIONS(1903),
    [anon_sym_RBRACE] = ACTIONS(1905),
    [anon_sym_signed] = ACTIONS(1903),
    [anon_sym_unsigned] = ACTIONS(1903),
    [anon_sym_long] = ACTIONS(1903),
    [anon_sym_short] = ACTIONS(1903),
    [anon_sym_LBRACK] = ACTIONS(1903),
    [anon_sym_static] = ACTIONS(1903),
    [anon_sym_register] = ACTIONS(1903),
    [anon_sym_inline] = ACTIONS(1903),
    [anon_sym___inline] = ACTIONS(1903),
    [anon_sym___inline__] = ACTIONS(1903),
    [anon_sym___forceinline] = ACTIONS(1903),
    [anon_sym_thread_local] = ACTIONS(1903),
    [anon_sym___thread] = ACTIONS(1903),
    [anon_sym_const] = ACTIONS(1903),
    [anon_sym_constexpr] = ACTIONS(1903),
    [anon_sym_volatile] = ACTIONS(1903),
    [anon_sym_restrict] = ACTIONS(1903),
    [anon_sym___restrict__] = ACTIONS(1903),
    [anon_sym__Atomic] = ACTIONS(1903),
    [anon_sym__Noreturn] = ACTIONS(1903),
    [anon_sym_noreturn] = ACTIONS(1903),
    [anon_sym_mutable] = ACTIONS(1903),
    [anon_sym_constinit] = ACTIONS(1903),
    [anon_sym_consteval] = ACTIONS(1903),
    [anon_sym___shared__] = ACTIONS(1903),
    [anon_sym___local__] = ACTIONS(1903),
    [anon_sym___constant__] = ACTIONS(1903),
    [anon_sym___managed__] = ACTIONS(1903),
    [anon_sym___grid_constant__] = ACTIONS(1903),
    [anon_sym_alignas] = ACTIONS(1903),
    [anon_sym__Alignas] = ACTIONS(1903),
    [sym_primitive_type] = ACTIONS(1903),
    [anon_sym_enum] = ACTIONS(1903),
    [anon_sym_class] = ACTIONS(1903),
    [anon_sym_struct] = ACTIONS(1903),
    [anon_sym_union] = ACTIONS(1903),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1903),
    [anon_sym_decltype] = ACTIONS(1903),
    [sym_virtual] = ACTIONS(1903),
    [anon_sym_explicit] = ACTIONS(1903),
    [anon_sym_typename] = ACTIONS(1903),
    [anon_sym_template] = ACTIONS(1903),
    [anon_sym_operator] = ACTIONS(1903),
    [anon_sym_friend] = ACTIONS(1903),
    [anon_sym_public] = ACTIONS(1903),
    [anon_sym_private] = ACTIONS(1903),
    [anon_sym_protected] = ACTIONS(1903),
    [anon_sym_using] = ACTIONS(1903),
    [anon_sym_static_assert] = ACTIONS(1903),
    [anon_sym_catch] = ACTIONS(5143),
    [anon_sym___launch_bounds__] = ACTIONS(1903),
  },
  [1830] = {
    [sym_identifier] = ACTIONS(2586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2588),
    [anon_sym_COMMA] = ACTIONS(2588),
    [anon_sym_RPAREN] = ACTIONS(2588),
    [anon_sym_LPAREN2] = ACTIONS(2588),
    [anon_sym_TILDE] = ACTIONS(2588),
    [anon_sym_STAR] = ACTIONS(2588),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_AMP] = ACTIONS(2586),
    [anon_sym_SEMI] = ACTIONS(2588),
    [anon_sym___extension__] = ACTIONS(2586),
    [anon_sym___device__] = ACTIONS(2586),
    [anon_sym___host__] = ACTIONS(2586),
    [anon_sym___global__] = ACTIONS(2586),
    [anon_sym___forceinline__] = ACTIONS(2586),
    [anon_sym___noinline__] = ACTIONS(2586),
    [anon_sym_extern] = ACTIONS(2586),
    [anon_sym___attribute__] = ACTIONS(2586),
    [anon_sym_COLON_COLON] = ACTIONS(2588),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2588),
    [anon_sym___declspec] = ACTIONS(2586),
    [anon_sym___based] = ACTIONS(2586),
    [anon_sym_LBRACE] = ACTIONS(2588),
    [anon_sym_signed] = ACTIONS(2586),
    [anon_sym_unsigned] = ACTIONS(2586),
    [anon_sym_long] = ACTIONS(2586),
    [anon_sym_short] = ACTIONS(2586),
    [anon_sym_LBRACK] = ACTIONS(2586),
    [anon_sym_static] = ACTIONS(2586),
    [anon_sym_EQ] = ACTIONS(2588),
    [anon_sym_register] = ACTIONS(2586),
    [anon_sym_inline] = ACTIONS(2586),
    [anon_sym___inline] = ACTIONS(2586),
    [anon_sym___inline__] = ACTIONS(2586),
    [anon_sym___forceinline] = ACTIONS(2586),
    [anon_sym_thread_local] = ACTIONS(2586),
    [anon_sym___thread] = ACTIONS(2586),
    [anon_sym_const] = ACTIONS(2586),
    [anon_sym_constexpr] = ACTIONS(2586),
    [anon_sym_volatile] = ACTIONS(2586),
    [anon_sym_restrict] = ACTIONS(2586),
    [anon_sym___restrict__] = ACTIONS(2586),
    [anon_sym__Atomic] = ACTIONS(2586),
    [anon_sym__Noreturn] = ACTIONS(2586),
    [anon_sym_noreturn] = ACTIONS(2586),
    [anon_sym_mutable] = ACTIONS(2586),
    [anon_sym_constinit] = ACTIONS(2586),
    [anon_sym_consteval] = ACTIONS(2586),
    [anon_sym___shared__] = ACTIONS(2586),
    [anon_sym___local__] = ACTIONS(2586),
    [anon_sym___constant__] = ACTIONS(2586),
    [anon_sym___managed__] = ACTIONS(2586),
    [anon_sym___grid_constant__] = ACTIONS(2586),
    [anon_sym_alignas] = ACTIONS(2586),
    [anon_sym__Alignas] = ACTIONS(2586),
    [sym_primitive_type] = ACTIONS(2586),
    [anon_sym_enum] = ACTIONS(2586),
    [anon_sym_class] = ACTIONS(2586),
    [anon_sym_struct] = ACTIONS(2586),
    [anon_sym_union] = ACTIONS(2586),
    [anon_sym_asm] = ACTIONS(2586),
    [anon_sym___asm__] = ACTIONS(2586),
    [anon_sym_DASH_GT] = ACTIONS(2588),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2586),
    [anon_sym_decltype] = ACTIONS(2586),
    [anon_sym_final] = ACTIONS(2586),
    [anon_sym_override] = ACTIONS(2586),
    [sym_virtual] = ACTIONS(2586),
    [anon_sym_explicit] = ACTIONS(2586),
    [anon_sym_typename] = ACTIONS(2586),
    [anon_sym_template] = ACTIONS(2586),
    [anon_sym_GT2] = ACTIONS(2588),
    [anon_sym_operator] = ACTIONS(2586),
    [anon_sym_try] = ACTIONS(2586),
    [anon_sym_noexcept] = ACTIONS(2586),
    [anon_sym_throw] = ACTIONS(2586),
    [anon_sym_requires] = ACTIONS(2586),
    [anon_sym___launch_bounds__] = ACTIONS(2586),
  },
  [1831] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4144),
    [anon_sym_COMMA] = ACTIONS(4144),
    [anon_sym_RPAREN] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_STAR] = ACTIONS(4153),
    [anon_sym_SLASH] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4151),
    [anon_sym_CARET] = ACTIONS(4151),
    [anon_sym_AMP] = ACTIONS(4153),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT] = ACTIONS(4151),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4151),
    [anon_sym_LT] = ACTIONS(4151),
    [anon_sym_LT_LT] = ACTIONS(4151),
    [anon_sym_GT_GT] = ACTIONS(4151),
    [anon_sym_SEMI] = ACTIONS(4144),
    [anon_sym___extension__] = ACTIONS(4149),
    [anon_sym___global__] = ACTIONS(4149),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4149),
    [anon_sym_LBRACK] = ACTIONS(4153),
    [anon_sym_EQ] = ACTIONS(4151),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_constexpr] = ACTIONS(4149),
    [anon_sym_volatile] = ACTIONS(4149),
    [anon_sym_restrict] = ACTIONS(4149),
    [anon_sym___restrict__] = ACTIONS(4149),
    [anon_sym__Atomic] = ACTIONS(4149),
    [anon_sym__Noreturn] = ACTIONS(4149),
    [anon_sym_noreturn] = ACTIONS(4149),
    [anon_sym_mutable] = ACTIONS(4149),
    [anon_sym_constinit] = ACTIONS(4149),
    [anon_sym_consteval] = ACTIONS(4149),
    [anon_sym___shared__] = ACTIONS(4149),
    [anon_sym___local__] = ACTIONS(4149),
    [anon_sym___constant__] = ACTIONS(4149),
    [anon_sym___managed__] = ACTIONS(4149),
    [anon_sym___grid_constant__] = ACTIONS(4149),
    [anon_sym_alignas] = ACTIONS(4149),
    [anon_sym__Alignas] = ACTIONS(4149),
    [anon_sym_QMARK] = ACTIONS(4144),
    [anon_sym_STAR_EQ] = ACTIONS(4144),
    [anon_sym_SLASH_EQ] = ACTIONS(4144),
    [anon_sym_PERCENT_EQ] = ACTIONS(4144),
    [anon_sym_PLUS_EQ] = ACTIONS(4144),
    [anon_sym_DASH_EQ] = ACTIONS(4144),
    [anon_sym_LT_LT_EQ] = ACTIONS(4144),
    [anon_sym_GT_GT_EQ] = ACTIONS(4144),
    [anon_sym_AMP_EQ] = ACTIONS(4144),
    [anon_sym_CARET_EQ] = ACTIONS(4144),
    [anon_sym_PIPE_EQ] = ACTIONS(4144),
    [anon_sym_and_eq] = ACTIONS(4144),
    [anon_sym_or_eq] = ACTIONS(4144),
    [anon_sym_xor_eq] = ACTIONS(4144),
    [anon_sym_LT_EQ_GT] = ACTIONS(4144),
    [anon_sym_or] = ACTIONS(4151),
    [anon_sym_and] = ACTIONS(4151),
    [anon_sym_bitor] = ACTIONS(4144),
    [anon_sym_xor] = ACTIONS(4151),
    [anon_sym_bitand] = ACTIONS(4144),
    [anon_sym_not_eq] = ACTIONS(4144),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_DOT_STAR] = ACTIONS(4144),
    [anon_sym_DASH_GT] = ACTIONS(4151),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4149),
    [anon_sym_decltype] = ACTIONS(4149),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4144),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4144),
  },
  [1832] = {
    [sym_identifier] = ACTIONS(5145),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5147),
    [anon_sym_COMMA] = ACTIONS(5147),
    [anon_sym_RPAREN] = ACTIONS(5147),
    [anon_sym_LPAREN2] = ACTIONS(5147),
    [anon_sym_TILDE] = ACTIONS(5147),
    [anon_sym_STAR] = ACTIONS(5147),
    [anon_sym_AMP_AMP] = ACTIONS(5147),
    [anon_sym_AMP] = ACTIONS(5145),
    [anon_sym_SEMI] = ACTIONS(5147),
    [anon_sym___extension__] = ACTIONS(5145),
    [anon_sym___device__] = ACTIONS(5145),
    [anon_sym___host__] = ACTIONS(5145),
    [anon_sym___global__] = ACTIONS(5145),
    [anon_sym___forceinline__] = ACTIONS(5145),
    [anon_sym___noinline__] = ACTIONS(5145),
    [anon_sym_extern] = ACTIONS(5145),
    [anon_sym___attribute__] = ACTIONS(5145),
    [anon_sym_COLON_COLON] = ACTIONS(5147),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5147),
    [anon_sym___declspec] = ACTIONS(5145),
    [anon_sym___based] = ACTIONS(5145),
    [anon_sym_LBRACE] = ACTIONS(5147),
    [anon_sym_signed] = ACTIONS(5145),
    [anon_sym_unsigned] = ACTIONS(5145),
    [anon_sym_long] = ACTIONS(5145),
    [anon_sym_short] = ACTIONS(5145),
    [anon_sym_LBRACK] = ACTIONS(5145),
    [anon_sym_static] = ACTIONS(5145),
    [anon_sym_EQ] = ACTIONS(5147),
    [anon_sym_register] = ACTIONS(5145),
    [anon_sym_inline] = ACTIONS(5145),
    [anon_sym___inline] = ACTIONS(5145),
    [anon_sym___inline__] = ACTIONS(5145),
    [anon_sym___forceinline] = ACTIONS(5145),
    [anon_sym_thread_local] = ACTIONS(5145),
    [anon_sym___thread] = ACTIONS(5145),
    [anon_sym_const] = ACTIONS(5145),
    [anon_sym_constexpr] = ACTIONS(5145),
    [anon_sym_volatile] = ACTIONS(5145),
    [anon_sym_restrict] = ACTIONS(5145),
    [anon_sym___restrict__] = ACTIONS(5145),
    [anon_sym__Atomic] = ACTIONS(5145),
    [anon_sym__Noreturn] = ACTIONS(5145),
    [anon_sym_noreturn] = ACTIONS(5145),
    [anon_sym_mutable] = ACTIONS(5145),
    [anon_sym_constinit] = ACTIONS(5145),
    [anon_sym_consteval] = ACTIONS(5145),
    [anon_sym___shared__] = ACTIONS(5145),
    [anon_sym___local__] = ACTIONS(5145),
    [anon_sym___constant__] = ACTIONS(5145),
    [anon_sym___managed__] = ACTIONS(5145),
    [anon_sym___grid_constant__] = ACTIONS(5145),
    [anon_sym_alignas] = ACTIONS(5145),
    [anon_sym__Alignas] = ACTIONS(5145),
    [sym_primitive_type] = ACTIONS(5145),
    [anon_sym_enum] = ACTIONS(5145),
    [anon_sym_class] = ACTIONS(5145),
    [anon_sym_struct] = ACTIONS(5145),
    [anon_sym_union] = ACTIONS(5145),
    [anon_sym_asm] = ACTIONS(5145),
    [anon_sym___asm__] = ACTIONS(5145),
    [anon_sym_DASH_GT] = ACTIONS(5147),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5145),
    [anon_sym_decltype] = ACTIONS(5145),
    [anon_sym_final] = ACTIONS(5145),
    [anon_sym_override] = ACTIONS(5145),
    [sym_virtual] = ACTIONS(5145),
    [anon_sym_explicit] = ACTIONS(5145),
    [anon_sym_typename] = ACTIONS(5145),
    [anon_sym_template] = ACTIONS(5145),
    [anon_sym_GT2] = ACTIONS(5147),
    [anon_sym_operator] = ACTIONS(5145),
    [anon_sym_try] = ACTIONS(5145),
    [anon_sym_noexcept] = ACTIONS(5145),
    [anon_sym_throw] = ACTIONS(5145),
    [anon_sym_requires] = ACTIONS(5145),
    [anon_sym___launch_bounds__] = ACTIONS(5145),
  },
  [1833] = {
    [sym_identifier] = ACTIONS(5149),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5151),
    [anon_sym_COMMA] = ACTIONS(5151),
    [anon_sym_RPAREN] = ACTIONS(5151),
    [anon_sym_LPAREN2] = ACTIONS(5151),
    [anon_sym_TILDE] = ACTIONS(5151),
    [anon_sym_STAR] = ACTIONS(5151),
    [anon_sym_AMP_AMP] = ACTIONS(5151),
    [anon_sym_AMP] = ACTIONS(5149),
    [anon_sym_SEMI] = ACTIONS(5151),
    [anon_sym___extension__] = ACTIONS(5149),
    [anon_sym___device__] = ACTIONS(5149),
    [anon_sym___host__] = ACTIONS(5149),
    [anon_sym___global__] = ACTIONS(5149),
    [anon_sym___forceinline__] = ACTIONS(5149),
    [anon_sym___noinline__] = ACTIONS(5149),
    [anon_sym_extern] = ACTIONS(5149),
    [anon_sym___attribute__] = ACTIONS(5149),
    [anon_sym_COLON_COLON] = ACTIONS(5151),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5151),
    [anon_sym___declspec] = ACTIONS(5149),
    [anon_sym___based] = ACTIONS(5149),
    [anon_sym_LBRACE] = ACTIONS(5151),
    [anon_sym_signed] = ACTIONS(5149),
    [anon_sym_unsigned] = ACTIONS(5149),
    [anon_sym_long] = ACTIONS(5149),
    [anon_sym_short] = ACTIONS(5149),
    [anon_sym_LBRACK] = ACTIONS(5149),
    [anon_sym_static] = ACTIONS(5149),
    [anon_sym_EQ] = ACTIONS(5151),
    [anon_sym_register] = ACTIONS(5149),
    [anon_sym_inline] = ACTIONS(5149),
    [anon_sym___inline] = ACTIONS(5149),
    [anon_sym___inline__] = ACTIONS(5149),
    [anon_sym___forceinline] = ACTIONS(5149),
    [anon_sym_thread_local] = ACTIONS(5149),
    [anon_sym___thread] = ACTIONS(5149),
    [anon_sym_const] = ACTIONS(5149),
    [anon_sym_constexpr] = ACTIONS(5149),
    [anon_sym_volatile] = ACTIONS(5149),
    [anon_sym_restrict] = ACTIONS(5149),
    [anon_sym___restrict__] = ACTIONS(5149),
    [anon_sym__Atomic] = ACTIONS(5149),
    [anon_sym__Noreturn] = ACTIONS(5149),
    [anon_sym_noreturn] = ACTIONS(5149),
    [anon_sym_mutable] = ACTIONS(5149),
    [anon_sym_constinit] = ACTIONS(5149),
    [anon_sym_consteval] = ACTIONS(5149),
    [anon_sym___shared__] = ACTIONS(5149),
    [anon_sym___local__] = ACTIONS(5149),
    [anon_sym___constant__] = ACTIONS(5149),
    [anon_sym___managed__] = ACTIONS(5149),
    [anon_sym___grid_constant__] = ACTIONS(5149),
    [anon_sym_alignas] = ACTIONS(5149),
    [anon_sym__Alignas] = ACTIONS(5149),
    [sym_primitive_type] = ACTIONS(5149),
    [anon_sym_enum] = ACTIONS(5149),
    [anon_sym_class] = ACTIONS(5149),
    [anon_sym_struct] = ACTIONS(5149),
    [anon_sym_union] = ACTIONS(5149),
    [anon_sym_asm] = ACTIONS(5149),
    [anon_sym___asm__] = ACTIONS(5149),
    [anon_sym_DASH_GT] = ACTIONS(5151),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5149),
    [anon_sym_decltype] = ACTIONS(5149),
    [anon_sym_final] = ACTIONS(5149),
    [anon_sym_override] = ACTIONS(5149),
    [sym_virtual] = ACTIONS(5149),
    [anon_sym_explicit] = ACTIONS(5149),
    [anon_sym_typename] = ACTIONS(5149),
    [anon_sym_template] = ACTIONS(5149),
    [anon_sym_GT2] = ACTIONS(5151),
    [anon_sym_operator] = ACTIONS(5149),
    [anon_sym_try] = ACTIONS(5149),
    [anon_sym_noexcept] = ACTIONS(5149),
    [anon_sym_throw] = ACTIONS(5149),
    [anon_sym_requires] = ACTIONS(5149),
    [anon_sym___launch_bounds__] = ACTIONS(5149),
  },
  [1834] = {
    [sym_catch_clause] = STATE(1817),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1817),
    [sym_identifier] = ACTIONS(1920),
    [aux_sym_preproc_def_token1] = ACTIONS(1920),
    [aux_sym_preproc_if_token1] = ACTIONS(1920),
    [aux_sym_preproc_if_token2] = ACTIONS(1920),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1920),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1920),
    [sym_preproc_directive] = ACTIONS(1920),
    [anon_sym_LPAREN2] = ACTIONS(1922),
    [anon_sym_TILDE] = ACTIONS(1922),
    [anon_sym_STAR] = ACTIONS(1922),
    [anon_sym_AMP_AMP] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1920),
    [anon_sym___extension__] = ACTIONS(1920),
    [anon_sym_typedef] = ACTIONS(1920),
    [anon_sym___device__] = ACTIONS(1920),
    [anon_sym___host__] = ACTIONS(1920),
    [anon_sym___global__] = ACTIONS(1920),
    [anon_sym___forceinline__] = ACTIONS(1920),
    [anon_sym___noinline__] = ACTIONS(1920),
    [anon_sym_extern] = ACTIONS(1920),
    [anon_sym___attribute__] = ACTIONS(1920),
    [anon_sym_COLON_COLON] = ACTIONS(1922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1922),
    [anon_sym___declspec] = ACTIONS(1920),
    [anon_sym___based] = ACTIONS(1920),
    [anon_sym_signed] = ACTIONS(1920),
    [anon_sym_unsigned] = ACTIONS(1920),
    [anon_sym_long] = ACTIONS(1920),
    [anon_sym_short] = ACTIONS(1920),
    [anon_sym_LBRACK] = ACTIONS(1920),
    [anon_sym_static] = ACTIONS(1920),
    [anon_sym_register] = ACTIONS(1920),
    [anon_sym_inline] = ACTIONS(1920),
    [anon_sym___inline] = ACTIONS(1920),
    [anon_sym___inline__] = ACTIONS(1920),
    [anon_sym___forceinline] = ACTIONS(1920),
    [anon_sym_thread_local] = ACTIONS(1920),
    [anon_sym___thread] = ACTIONS(1920),
    [anon_sym_const] = ACTIONS(1920),
    [anon_sym_constexpr] = ACTIONS(1920),
    [anon_sym_volatile] = ACTIONS(1920),
    [anon_sym_restrict] = ACTIONS(1920),
    [anon_sym___restrict__] = ACTIONS(1920),
    [anon_sym__Atomic] = ACTIONS(1920),
    [anon_sym__Noreturn] = ACTIONS(1920),
    [anon_sym_noreturn] = ACTIONS(1920),
    [anon_sym_mutable] = ACTIONS(1920),
    [anon_sym_constinit] = ACTIONS(1920),
    [anon_sym_consteval] = ACTIONS(1920),
    [anon_sym___shared__] = ACTIONS(1920),
    [anon_sym___local__] = ACTIONS(1920),
    [anon_sym___constant__] = ACTIONS(1920),
    [anon_sym___managed__] = ACTIONS(1920),
    [anon_sym___grid_constant__] = ACTIONS(1920),
    [anon_sym_alignas] = ACTIONS(1920),
    [anon_sym__Alignas] = ACTIONS(1920),
    [sym_primitive_type] = ACTIONS(1920),
    [anon_sym_enum] = ACTIONS(1920),
    [anon_sym_class] = ACTIONS(1920),
    [anon_sym_struct] = ACTIONS(1920),
    [anon_sym_union] = ACTIONS(1920),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1920),
    [anon_sym_decltype] = ACTIONS(1920),
    [sym_virtual] = ACTIONS(1920),
    [anon_sym_explicit] = ACTIONS(1920),
    [anon_sym_typename] = ACTIONS(1920),
    [anon_sym_template] = ACTIONS(1920),
    [anon_sym_operator] = ACTIONS(1920),
    [anon_sym_friend] = ACTIONS(1920),
    [anon_sym_public] = ACTIONS(1920),
    [anon_sym_private] = ACTIONS(1920),
    [anon_sym_protected] = ACTIONS(1920),
    [anon_sym_using] = ACTIONS(1920),
    [anon_sym_static_assert] = ACTIONS(1920),
    [anon_sym_catch] = ACTIONS(5138),
    [anon_sym___launch_bounds__] = ACTIONS(1920),
  },
  [1835] = {
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5336),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6816),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4853),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1836] = {
    [sym_template_argument_list] = STATE(1831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4002),
    [anon_sym_COMMA] = ACTIONS(4002),
    [anon_sym_RPAREN] = ACTIONS(4004),
    [anon_sym_LPAREN2] = ACTIONS(4004),
    [anon_sym_DASH] = ACTIONS(4009),
    [anon_sym_PLUS] = ACTIONS(4009),
    [anon_sym_STAR] = ACTIONS(4011),
    [anon_sym_SLASH] = ACTIONS(4009),
    [anon_sym_PERCENT] = ACTIONS(4009),
    [anon_sym_PIPE_PIPE] = ACTIONS(4002),
    [anon_sym_AMP_AMP] = ACTIONS(4004),
    [anon_sym_PIPE] = ACTIONS(4009),
    [anon_sym_CARET] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4011),
    [anon_sym_EQ_EQ] = ACTIONS(4002),
    [anon_sym_BANG_EQ] = ACTIONS(4002),
    [anon_sym_GT] = ACTIONS(4009),
    [anon_sym_GT_EQ] = ACTIONS(4002),
    [anon_sym_LT_EQ] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(4268),
    [anon_sym_LT_LT] = ACTIONS(4009),
    [anon_sym_GT_GT] = ACTIONS(4009),
    [anon_sym___extension__] = ACTIONS(4007),
    [anon_sym___global__] = ACTIONS(4007),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4002),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4011),
    [anon_sym_EQ] = ACTIONS(4009),
    [anon_sym_const] = ACTIONS(4000),
    [anon_sym_constexpr] = ACTIONS(4007),
    [anon_sym_volatile] = ACTIONS(4007),
    [anon_sym_restrict] = ACTIONS(4007),
    [anon_sym___restrict__] = ACTIONS(4007),
    [anon_sym__Atomic] = ACTIONS(4007),
    [anon_sym__Noreturn] = ACTIONS(4007),
    [anon_sym_noreturn] = ACTIONS(4007),
    [anon_sym_mutable] = ACTIONS(4007),
    [anon_sym_constinit] = ACTIONS(4007),
    [anon_sym_consteval] = ACTIONS(4007),
    [anon_sym___shared__] = ACTIONS(4007),
    [anon_sym___local__] = ACTIONS(4007),
    [anon_sym___constant__] = ACTIONS(4007),
    [anon_sym___managed__] = ACTIONS(4007),
    [anon_sym___grid_constant__] = ACTIONS(4007),
    [anon_sym_alignas] = ACTIONS(4007),
    [anon_sym__Alignas] = ACTIONS(4007),
    [anon_sym_QMARK] = ACTIONS(4002),
    [anon_sym_STAR_EQ] = ACTIONS(4002),
    [anon_sym_SLASH_EQ] = ACTIONS(4002),
    [anon_sym_PERCENT_EQ] = ACTIONS(4002),
    [anon_sym_PLUS_EQ] = ACTIONS(4002),
    [anon_sym_DASH_EQ] = ACTIONS(4002),
    [anon_sym_LT_LT_EQ] = ACTIONS(4002),
    [anon_sym_GT_GT_EQ] = ACTIONS(4002),
    [anon_sym_AMP_EQ] = ACTIONS(4002),
    [anon_sym_CARET_EQ] = ACTIONS(4002),
    [anon_sym_PIPE_EQ] = ACTIONS(4002),
    [anon_sym_and_eq] = ACTIONS(4002),
    [anon_sym_or_eq] = ACTIONS(4002),
    [anon_sym_xor_eq] = ACTIONS(4002),
    [anon_sym_LT_EQ_GT] = ACTIONS(4002),
    [anon_sym_or] = ACTIONS(4009),
    [anon_sym_and] = ACTIONS(4009),
    [anon_sym_bitor] = ACTIONS(4002),
    [anon_sym_xor] = ACTIONS(4009),
    [anon_sym_bitand] = ACTIONS(4002),
    [anon_sym_not_eq] = ACTIONS(4002),
    [anon_sym_DASH_DASH] = ACTIONS(4002),
    [anon_sym_PLUS_PLUS] = ACTIONS(4002),
    [anon_sym_DOT] = ACTIONS(4009),
    [anon_sym_DOT_STAR] = ACTIONS(4002),
    [anon_sym_DASH_GT] = ACTIONS(4009),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4007),
    [anon_sym_decltype] = ACTIONS(4007),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4002),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4002),
  },
  [1837] = {
    [sym__declaration_modifiers] = STATE(1841),
    [sym__declaration_specifiers] = STATE(5340),
    [sym_attribute_specifier] = STATE(1841),
    [sym_attribute_declaration] = STATE(1841),
    [sym_ms_declspec_modifier] = STATE(1841),
    [sym_storage_class_specifier] = STATE(1841),
    [sym_type_qualifier] = STATE(1841),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2131),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6816),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_launch_bounds] = STATE(1841),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1841),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4853),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(1238),
    [anon_sym___host__] = ACTIONS(1238),
    [anon_sym___global__] = ACTIONS(1238),
    [anon_sym___forceinline__] = ACTIONS(1238),
    [anon_sym___noinline__] = ACTIONS(1238),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(1238),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1838] = {
    [sym_identifier] = ACTIONS(1901),
    [aux_sym_preproc_def_token1] = ACTIONS(1901),
    [anon_sym_COMMA] = ACTIONS(1962),
    [aux_sym_preproc_if_token1] = ACTIONS(1901),
    [aux_sym_preproc_if_token2] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1901),
    [sym_preproc_directive] = ACTIONS(1901),
    [anon_sym_LPAREN2] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_STAR] = ACTIONS(1899),
    [anon_sym_AMP_AMP] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1901),
    [anon_sym_SEMI] = ACTIONS(1962),
    [anon_sym___extension__] = ACTIONS(1901),
    [anon_sym_typedef] = ACTIONS(1901),
    [anon_sym___device__] = ACTIONS(1901),
    [anon_sym___host__] = ACTIONS(1901),
    [anon_sym___global__] = ACTIONS(1901),
    [anon_sym___forceinline__] = ACTIONS(1901),
    [anon_sym___noinline__] = ACTIONS(1901),
    [anon_sym_extern] = ACTIONS(1901),
    [anon_sym___attribute__] = ACTIONS(1901),
    [anon_sym_COLON_COLON] = ACTIONS(1899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1899),
    [anon_sym___declspec] = ACTIONS(1901),
    [anon_sym___based] = ACTIONS(1901),
    [anon_sym_signed] = ACTIONS(1901),
    [anon_sym_unsigned] = ACTIONS(1901),
    [anon_sym_long] = ACTIONS(1901),
    [anon_sym_short] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1901),
    [anon_sym_static] = ACTIONS(1901),
    [anon_sym_register] = ACTIONS(1901),
    [anon_sym_inline] = ACTIONS(1901),
    [anon_sym___inline] = ACTIONS(1901),
    [anon_sym___inline__] = ACTIONS(1901),
    [anon_sym___forceinline] = ACTIONS(1901),
    [anon_sym_thread_local] = ACTIONS(1901),
    [anon_sym___thread] = ACTIONS(1901),
    [anon_sym_const] = ACTIONS(1901),
    [anon_sym_constexpr] = ACTIONS(1901),
    [anon_sym_volatile] = ACTIONS(1901),
    [anon_sym_restrict] = ACTIONS(1901),
    [anon_sym___restrict__] = ACTIONS(1901),
    [anon_sym__Atomic] = ACTIONS(1901),
    [anon_sym__Noreturn] = ACTIONS(1901),
    [anon_sym_noreturn] = ACTIONS(1901),
    [anon_sym_mutable] = ACTIONS(1901),
    [anon_sym_constinit] = ACTIONS(1901),
    [anon_sym_consteval] = ACTIONS(1901),
    [anon_sym___shared__] = ACTIONS(1901),
    [anon_sym___local__] = ACTIONS(1901),
    [anon_sym___constant__] = ACTIONS(1901),
    [anon_sym___managed__] = ACTIONS(1901),
    [anon_sym___grid_constant__] = ACTIONS(1901),
    [anon_sym_alignas] = ACTIONS(1901),
    [anon_sym__Alignas] = ACTIONS(1901),
    [sym_primitive_type] = ACTIONS(1901),
    [anon_sym_enum] = ACTIONS(1901),
    [anon_sym_class] = ACTIONS(1901),
    [anon_sym_struct] = ACTIONS(1901),
    [anon_sym_union] = ACTIONS(1901),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1901),
    [anon_sym_decltype] = ACTIONS(1901),
    [sym_virtual] = ACTIONS(1901),
    [anon_sym_explicit] = ACTIONS(1901),
    [anon_sym_typename] = ACTIONS(1901),
    [anon_sym_template] = ACTIONS(1901),
    [anon_sym_operator] = ACTIONS(1901),
    [anon_sym_friend] = ACTIONS(1901),
    [anon_sym_public] = ACTIONS(1901),
    [anon_sym_private] = ACTIONS(1901),
    [anon_sym_protected] = ACTIONS(1901),
    [anon_sym_using] = ACTIONS(1901),
    [anon_sym_static_assert] = ACTIONS(1901),
    [anon_sym___launch_bounds__] = ACTIONS(1901),
  },
  [1839] = {
    [sym__declaration_modifiers] = STATE(2720),
    [sym_attribute_specifier] = STATE(2720),
    [sym_attribute_declaration] = STATE(2720),
    [sym_ms_declspec_modifier] = STATE(2720),
    [sym_storage_class_specifier] = STATE(2720),
    [sym_type_qualifier] = STATE(2720),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2128),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6816),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_launch_bounds] = STATE(2720),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2720),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4853),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(5153),
    [anon_sym___host__] = ACTIONS(5153),
    [anon_sym___global__] = ACTIONS(5153),
    [anon_sym___forceinline__] = ACTIONS(5153),
    [anon_sym___noinline__] = ACTIONS(5153),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(5153),
    [anon_sym_typename] = ACTIONS(2142),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1840] = {
    [sym__declaration_modifiers] = STATE(2720),
    [sym_attribute_specifier] = STATE(2720),
    [sym_attribute_declaration] = STATE(2720),
    [sym_ms_declspec_modifier] = STATE(2720),
    [sym_storage_class_specifier] = STATE(2720),
    [sym_type_qualifier] = STATE(2720),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(3144),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6810),
    [sym_qualified_type_identifier] = STATE(2441),
    [sym_launch_bounds] = STATE(2720),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2720),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2507),
    [sym_identifier] = ACTIONS(3544),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(5153),
    [anon_sym___host__] = ACTIONS(5153),
    [anon_sym___global__] = ACTIONS(5153),
    [anon_sym___forceinline__] = ACTIONS(5153),
    [anon_sym___noinline__] = ACTIONS(5153),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(3552),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(3554),
    [anon_sym_unsigned] = ACTIONS(3554),
    [anon_sym_long] = ACTIONS(3554),
    [anon_sym_short] = ACTIONS(3554),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(3556),
    [anon_sym_enum] = ACTIONS(3558),
    [anon_sym_class] = ACTIONS(3560),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_union] = ACTIONS(3564),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(5153),
    [anon_sym_typename] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1841] = {
    [sym__declaration_modifiers] = STATE(2720),
    [sym_attribute_specifier] = STATE(2720),
    [sym_attribute_declaration] = STATE(2720),
    [sym_ms_declspec_modifier] = STATE(2720),
    [sym_storage_class_specifier] = STATE(2720),
    [sym_type_qualifier] = STATE(2720),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2128),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6816),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_launch_bounds] = STATE(2720),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2720),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4853),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(5153),
    [anon_sym___host__] = ACTIONS(5153),
    [anon_sym___global__] = ACTIONS(5153),
    [anon_sym___forceinline__] = ACTIONS(5153),
    [anon_sym___noinline__] = ACTIONS(5153),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4855),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_struct] = ACTIONS(73),
    [anon_sym_union] = ACTIONS(75),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(5153),
    [anon_sym_typename] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1842] = {
    [sym_identifier] = ACTIONS(1901),
    [aux_sym_preproc_def_token1] = ACTIONS(1901),
    [anon_sym_COMMA] = ACTIONS(1962),
    [aux_sym_preproc_if_token1] = ACTIONS(1901),
    [aux_sym_preproc_if_token2] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1901),
    [sym_preproc_directive] = ACTIONS(1901),
    [anon_sym_LPAREN2] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_STAR] = ACTIONS(1899),
    [anon_sym_AMP_AMP] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1901),
    [anon_sym_SEMI] = ACTIONS(1962),
    [anon_sym___extension__] = ACTIONS(1901),
    [anon_sym_typedef] = ACTIONS(1901),
    [anon_sym___device__] = ACTIONS(1901),
    [anon_sym___host__] = ACTIONS(1901),
    [anon_sym___global__] = ACTIONS(1901),
    [anon_sym___forceinline__] = ACTIONS(1901),
    [anon_sym___noinline__] = ACTIONS(1901),
    [anon_sym_extern] = ACTIONS(1901),
    [anon_sym___attribute__] = ACTIONS(5014),
    [anon_sym_COLON_COLON] = ACTIONS(1899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1899),
    [anon_sym___declspec] = ACTIONS(1901),
    [anon_sym___based] = ACTIONS(1901),
    [anon_sym_signed] = ACTIONS(1901),
    [anon_sym_unsigned] = ACTIONS(1901),
    [anon_sym_long] = ACTIONS(1901),
    [anon_sym_short] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1901),
    [anon_sym_static] = ACTIONS(1901),
    [anon_sym_register] = ACTIONS(1901),
    [anon_sym_inline] = ACTIONS(1901),
    [anon_sym___inline] = ACTIONS(1901),
    [anon_sym___inline__] = ACTIONS(1901),
    [anon_sym___forceinline] = ACTIONS(1901),
    [anon_sym_thread_local] = ACTIONS(1901),
    [anon_sym___thread] = ACTIONS(1901),
    [anon_sym_const] = ACTIONS(1901),
    [anon_sym_constexpr] = ACTIONS(1901),
    [anon_sym_volatile] = ACTIONS(1901),
    [anon_sym_restrict] = ACTIONS(1901),
    [anon_sym___restrict__] = ACTIONS(1901),
    [anon_sym__Atomic] = ACTIONS(1901),
    [anon_sym__Noreturn] = ACTIONS(1901),
    [anon_sym_noreturn] = ACTIONS(1901),
    [anon_sym_mutable] = ACTIONS(1901),
    [anon_sym_constinit] = ACTIONS(1901),
    [anon_sym_consteval] = ACTIONS(1901),
    [anon_sym___shared__] = ACTIONS(1901),
    [anon_sym___local__] = ACTIONS(1901),
    [anon_sym___constant__] = ACTIONS(1901),
    [anon_sym___managed__] = ACTIONS(1901),
    [anon_sym___grid_constant__] = ACTIONS(1901),
    [anon_sym_alignas] = ACTIONS(1901),
    [anon_sym__Alignas] = ACTIONS(1901),
    [sym_primitive_type] = ACTIONS(1901),
    [anon_sym_enum] = ACTIONS(1901),
    [anon_sym_class] = ACTIONS(1901),
    [anon_sym_struct] = ACTIONS(1901),
    [anon_sym_union] = ACTIONS(1901),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1901),
    [anon_sym_decltype] = ACTIONS(1901),
    [sym_virtual] = ACTIONS(1901),
    [anon_sym_explicit] = ACTIONS(1901),
    [anon_sym_typename] = ACTIONS(1901),
    [anon_sym_template] = ACTIONS(1901),
    [anon_sym_operator] = ACTIONS(1901),
    [anon_sym_friend] = ACTIONS(1901),
    [anon_sym_public] = ACTIONS(1901),
    [anon_sym_private] = ACTIONS(1901),
    [anon_sym_protected] = ACTIONS(1901),
    [anon_sym_using] = ACTIONS(1901),
    [anon_sym_static_assert] = ACTIONS(1901),
    [anon_sym___launch_bounds__] = ACTIONS(1901),
  },
  [1843] = {
    [sym_identifier] = ACTIONS(1901),
    [aux_sym_preproc_def_token1] = ACTIONS(1901),
    [anon_sym_COMMA] = ACTIONS(1962),
    [aux_sym_preproc_if_token1] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1901),
    [sym_preproc_directive] = ACTIONS(1901),
    [anon_sym_LPAREN2] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_STAR] = ACTIONS(1899),
    [anon_sym_AMP_AMP] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1901),
    [anon_sym_SEMI] = ACTIONS(1962),
    [anon_sym___extension__] = ACTIONS(1901),
    [anon_sym_typedef] = ACTIONS(1901),
    [anon_sym___device__] = ACTIONS(1901),
    [anon_sym___host__] = ACTIONS(1901),
    [anon_sym___global__] = ACTIONS(1901),
    [anon_sym___forceinline__] = ACTIONS(1901),
    [anon_sym___noinline__] = ACTIONS(1901),
    [anon_sym_extern] = ACTIONS(1901),
    [anon_sym___attribute__] = ACTIONS(5014),
    [anon_sym_COLON_COLON] = ACTIONS(1899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1899),
    [anon_sym___declspec] = ACTIONS(1901),
    [anon_sym___based] = ACTIONS(1901),
    [anon_sym_RBRACE] = ACTIONS(1899),
    [anon_sym_signed] = ACTIONS(1901),
    [anon_sym_unsigned] = ACTIONS(1901),
    [anon_sym_long] = ACTIONS(1901),
    [anon_sym_short] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1901),
    [anon_sym_static] = ACTIONS(1901),
    [anon_sym_register] = ACTIONS(1901),
    [anon_sym_inline] = ACTIONS(1901),
    [anon_sym___inline] = ACTIONS(1901),
    [anon_sym___inline__] = ACTIONS(1901),
    [anon_sym___forceinline] = ACTIONS(1901),
    [anon_sym_thread_local] = ACTIONS(1901),
    [anon_sym___thread] = ACTIONS(1901),
    [anon_sym_const] = ACTIONS(1901),
    [anon_sym_constexpr] = ACTIONS(1901),
    [anon_sym_volatile] = ACTIONS(1901),
    [anon_sym_restrict] = ACTIONS(1901),
    [anon_sym___restrict__] = ACTIONS(1901),
    [anon_sym__Atomic] = ACTIONS(1901),
    [anon_sym__Noreturn] = ACTIONS(1901),
    [anon_sym_noreturn] = ACTIONS(1901),
    [anon_sym_mutable] = ACTIONS(1901),
    [anon_sym_constinit] = ACTIONS(1901),
    [anon_sym_consteval] = ACTIONS(1901),
    [anon_sym___shared__] = ACTIONS(1901),
    [anon_sym___local__] = ACTIONS(1901),
    [anon_sym___constant__] = ACTIONS(1901),
    [anon_sym___managed__] = ACTIONS(1901),
    [anon_sym___grid_constant__] = ACTIONS(1901),
    [anon_sym_alignas] = ACTIONS(1901),
    [anon_sym__Alignas] = ACTIONS(1901),
    [sym_primitive_type] = ACTIONS(1901),
    [anon_sym_enum] = ACTIONS(1901),
    [anon_sym_class] = ACTIONS(1901),
    [anon_sym_struct] = ACTIONS(1901),
    [anon_sym_union] = ACTIONS(1901),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1901),
    [anon_sym_decltype] = ACTIONS(1901),
    [sym_virtual] = ACTIONS(1901),
    [anon_sym_explicit] = ACTIONS(1901),
    [anon_sym_typename] = ACTIONS(1901),
    [anon_sym_template] = ACTIONS(1901),
    [anon_sym_operator] = ACTIONS(1901),
    [anon_sym_friend] = ACTIONS(1901),
    [anon_sym_public] = ACTIONS(1901),
    [anon_sym_private] = ACTIONS(1901),
    [anon_sym_protected] = ACTIONS(1901),
    [anon_sym_using] = ACTIONS(1901),
    [anon_sym_static_assert] = ACTIONS(1901),
    [anon_sym___launch_bounds__] = ACTIONS(1901),
  },
  [1844] = {
    [sym_template_argument_list] = STATE(1852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4002),
    [anon_sym_COMMA] = ACTIONS(4002),
    [anon_sym_RPAREN] = ACTIONS(4004),
    [anon_sym_LPAREN2] = ACTIONS(4004),
    [anon_sym_DASH] = ACTIONS(4009),
    [anon_sym_PLUS] = ACTIONS(4009),
    [anon_sym_STAR] = ACTIONS(4011),
    [anon_sym_SLASH] = ACTIONS(4009),
    [anon_sym_PERCENT] = ACTIONS(4009),
    [anon_sym_PIPE_PIPE] = ACTIONS(4002),
    [anon_sym_AMP_AMP] = ACTIONS(4004),
    [anon_sym_PIPE] = ACTIONS(4009),
    [anon_sym_CARET] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4011),
    [anon_sym_EQ_EQ] = ACTIONS(4002),
    [anon_sym_BANG_EQ] = ACTIONS(4002),
    [anon_sym_GT] = ACTIONS(4009),
    [anon_sym_GT_EQ] = ACTIONS(4002),
    [anon_sym_LT_EQ] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(5155),
    [anon_sym_LT_LT] = ACTIONS(4009),
    [anon_sym_GT_GT] = ACTIONS(4009),
    [anon_sym___extension__] = ACTIONS(4007),
    [anon_sym___global__] = ACTIONS(4007),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4004),
    [anon_sym_EQ] = ACTIONS(4009),
    [anon_sym_const] = ACTIONS(4000),
    [anon_sym_constexpr] = ACTIONS(4007),
    [anon_sym_volatile] = ACTIONS(4007),
    [anon_sym_restrict] = ACTIONS(4007),
    [anon_sym___restrict__] = ACTIONS(4007),
    [anon_sym__Atomic] = ACTIONS(4007),
    [anon_sym__Noreturn] = ACTIONS(4007),
    [anon_sym_noreturn] = ACTIONS(4007),
    [anon_sym_mutable] = ACTIONS(4007),
    [anon_sym_constinit] = ACTIONS(4007),
    [anon_sym_consteval] = ACTIONS(4007),
    [anon_sym___shared__] = ACTIONS(4007),
    [anon_sym___local__] = ACTIONS(4007),
    [anon_sym___constant__] = ACTIONS(4007),
    [anon_sym___managed__] = ACTIONS(4007),
    [anon_sym___grid_constant__] = ACTIONS(4007),
    [anon_sym_alignas] = ACTIONS(4007),
    [anon_sym__Alignas] = ACTIONS(4007),
    [anon_sym_QMARK] = ACTIONS(4002),
    [anon_sym_STAR_EQ] = ACTIONS(4002),
    [anon_sym_SLASH_EQ] = ACTIONS(4002),
    [anon_sym_PERCENT_EQ] = ACTIONS(4002),
    [anon_sym_PLUS_EQ] = ACTIONS(4002),
    [anon_sym_DASH_EQ] = ACTIONS(4002),
    [anon_sym_LT_LT_EQ] = ACTIONS(4002),
    [anon_sym_GT_GT_EQ] = ACTIONS(4002),
    [anon_sym_AMP_EQ] = ACTIONS(4002),
    [anon_sym_CARET_EQ] = ACTIONS(4002),
    [anon_sym_PIPE_EQ] = ACTIONS(4002),
    [anon_sym_and_eq] = ACTIONS(4002),
    [anon_sym_or_eq] = ACTIONS(4002),
    [anon_sym_xor_eq] = ACTIONS(4002),
    [anon_sym_LT_EQ_GT] = ACTIONS(4002),
    [anon_sym_or] = ACTIONS(4009),
    [anon_sym_and] = ACTIONS(4009),
    [anon_sym_bitor] = ACTIONS(4002),
    [anon_sym_xor] = ACTIONS(4009),
    [anon_sym_bitand] = ACTIONS(4002),
    [anon_sym_not_eq] = ACTIONS(4002),
    [anon_sym_DASH_DASH] = ACTIONS(4002),
    [anon_sym_PLUS_PLUS] = ACTIONS(4002),
    [anon_sym_DOT] = ACTIONS(4009),
    [anon_sym_DOT_STAR] = ACTIONS(4002),
    [anon_sym_DASH_GT] = ACTIONS(4009),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4007),
    [anon_sym_decltype] = ACTIONS(4007),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4002),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4002),
  },
  [1845] = {
    [sym_identifier] = ACTIONS(1901),
    [aux_sym_preproc_def_token1] = ACTIONS(1901),
    [anon_sym_COMMA] = ACTIONS(1962),
    [aux_sym_preproc_if_token1] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1901),
    [sym_preproc_directive] = ACTIONS(1901),
    [anon_sym_LPAREN2] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_STAR] = ACTIONS(1899),
    [anon_sym_AMP_AMP] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1901),
    [anon_sym_SEMI] = ACTIONS(1962),
    [anon_sym___extension__] = ACTIONS(1901),
    [anon_sym_typedef] = ACTIONS(1901),
    [anon_sym___device__] = ACTIONS(1901),
    [anon_sym___host__] = ACTIONS(1901),
    [anon_sym___global__] = ACTIONS(1901),
    [anon_sym___forceinline__] = ACTIONS(1901),
    [anon_sym___noinline__] = ACTIONS(1901),
    [anon_sym_extern] = ACTIONS(1901),
    [anon_sym___attribute__] = ACTIONS(1901),
    [anon_sym_COLON_COLON] = ACTIONS(1899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1899),
    [anon_sym___declspec] = ACTIONS(1901),
    [anon_sym___based] = ACTIONS(1901),
    [anon_sym_RBRACE] = ACTIONS(1899),
    [anon_sym_signed] = ACTIONS(1901),
    [anon_sym_unsigned] = ACTIONS(1901),
    [anon_sym_long] = ACTIONS(1901),
    [anon_sym_short] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1901),
    [anon_sym_static] = ACTIONS(1901),
    [anon_sym_register] = ACTIONS(1901),
    [anon_sym_inline] = ACTIONS(1901),
    [anon_sym___inline] = ACTIONS(1901),
    [anon_sym___inline__] = ACTIONS(1901),
    [anon_sym___forceinline] = ACTIONS(1901),
    [anon_sym_thread_local] = ACTIONS(1901),
    [anon_sym___thread] = ACTIONS(1901),
    [anon_sym_const] = ACTIONS(1901),
    [anon_sym_constexpr] = ACTIONS(1901),
    [anon_sym_volatile] = ACTIONS(1901),
    [anon_sym_restrict] = ACTIONS(1901),
    [anon_sym___restrict__] = ACTIONS(1901),
    [anon_sym__Atomic] = ACTIONS(1901),
    [anon_sym__Noreturn] = ACTIONS(1901),
    [anon_sym_noreturn] = ACTIONS(1901),
    [anon_sym_mutable] = ACTIONS(1901),
    [anon_sym_constinit] = ACTIONS(1901),
    [anon_sym_consteval] = ACTIONS(1901),
    [anon_sym___shared__] = ACTIONS(1901),
    [anon_sym___local__] = ACTIONS(1901),
    [anon_sym___constant__] = ACTIONS(1901),
    [anon_sym___managed__] = ACTIONS(1901),
    [anon_sym___grid_constant__] = ACTIONS(1901),
    [anon_sym_alignas] = ACTIONS(1901),
    [anon_sym__Alignas] = ACTIONS(1901),
    [sym_primitive_type] = ACTIONS(1901),
    [anon_sym_enum] = ACTIONS(1901),
    [anon_sym_class] = ACTIONS(1901),
    [anon_sym_struct] = ACTIONS(1901),
    [anon_sym_union] = ACTIONS(1901),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1901),
    [anon_sym_decltype] = ACTIONS(1901),
    [sym_virtual] = ACTIONS(1901),
    [anon_sym_explicit] = ACTIONS(1901),
    [anon_sym_typename] = ACTIONS(1901),
    [anon_sym_template] = ACTIONS(1901),
    [anon_sym_operator] = ACTIONS(1901),
    [anon_sym_friend] = ACTIONS(1901),
    [anon_sym_public] = ACTIONS(1901),
    [anon_sym_private] = ACTIONS(1901),
    [anon_sym_protected] = ACTIONS(1901),
    [anon_sym_using] = ACTIONS(1901),
    [anon_sym_static_assert] = ACTIONS(1901),
    [anon_sym___launch_bounds__] = ACTIONS(1901),
  },
  [1846] = {
    [sym_type_qualifier] = STATE(1846),
    [sym_alignas_qualifier] = STATE(2108),
    [aux_sym_array_declarator_repeat1] = STATE(1846),
    [sym_identifier] = ACTIONS(5158),
    [anon_sym_LPAREN2] = ACTIONS(5160),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [anon_sym_DASH] = ACTIONS(5158),
    [anon_sym_PLUS] = ACTIONS(5158),
    [anon_sym_STAR] = ACTIONS(5160),
    [anon_sym_AMP] = ACTIONS(5160),
    [anon_sym___extension__] = ACTIONS(5162),
    [anon_sym___global__] = ACTIONS(5162),
    [anon_sym_COLON_COLON] = ACTIONS(5160),
    [anon_sym_LBRACK] = ACTIONS(5160),
    [anon_sym_static] = ACTIONS(5165),
    [anon_sym_RBRACK] = ACTIONS(5160),
    [anon_sym_const] = ACTIONS(5162),
    [anon_sym_constexpr] = ACTIONS(5162),
    [anon_sym_volatile] = ACTIONS(5162),
    [anon_sym_restrict] = ACTIONS(5162),
    [anon_sym___restrict__] = ACTIONS(5162),
    [anon_sym__Atomic] = ACTIONS(5162),
    [anon_sym__Noreturn] = ACTIONS(5162),
    [anon_sym_noreturn] = ACTIONS(5162),
    [anon_sym_mutable] = ACTIONS(5162),
    [anon_sym_constinit] = ACTIONS(5162),
    [anon_sym_consteval] = ACTIONS(5162),
    [anon_sym___shared__] = ACTIONS(5162),
    [anon_sym___local__] = ACTIONS(5162),
    [anon_sym___constant__] = ACTIONS(5162),
    [anon_sym___managed__] = ACTIONS(5162),
    [anon_sym___grid_constant__] = ACTIONS(5162),
    [anon_sym_alignas] = ACTIONS(5168),
    [anon_sym__Alignas] = ACTIONS(5168),
    [sym_primitive_type] = ACTIONS(5158),
    [anon_sym_not] = ACTIONS(5158),
    [anon_sym_compl] = ACTIONS(5158),
    [anon_sym_DASH_DASH] = ACTIONS(5160),
    [anon_sym_PLUS_PLUS] = ACTIONS(5160),
    [anon_sym_sizeof] = ACTIONS(5158),
    [anon_sym___alignof__] = ACTIONS(5158),
    [anon_sym___alignof] = ACTIONS(5158),
    [anon_sym__alignof] = ACTIONS(5158),
    [anon_sym_alignof] = ACTIONS(5158),
    [anon_sym__Alignof] = ACTIONS(5158),
    [anon_sym_offsetof] = ACTIONS(5158),
    [anon_sym__Generic] = ACTIONS(5158),
    [anon_sym_asm] = ACTIONS(5158),
    [anon_sym___asm__] = ACTIONS(5158),
    [sym_number_literal] = ACTIONS(5160),
    [anon_sym_L_SQUOTE] = ACTIONS(5160),
    [anon_sym_u_SQUOTE] = ACTIONS(5160),
    [anon_sym_U_SQUOTE] = ACTIONS(5160),
    [anon_sym_u8_SQUOTE] = ACTIONS(5160),
    [anon_sym_SQUOTE] = ACTIONS(5160),
    [anon_sym_L_DQUOTE] = ACTIONS(5160),
    [anon_sym_u_DQUOTE] = ACTIONS(5160),
    [anon_sym_U_DQUOTE] = ACTIONS(5160),
    [anon_sym_u8_DQUOTE] = ACTIONS(5160),
    [anon_sym_DQUOTE] = ACTIONS(5160),
    [sym_true] = ACTIONS(5158),
    [sym_false] = ACTIONS(5158),
    [anon_sym_NULL] = ACTIONS(5158),
    [anon_sym_nullptr] = ACTIONS(5158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(5158),
    [anon_sym_template] = ACTIONS(5158),
    [anon_sym_delete] = ACTIONS(5158),
    [anon_sym_R_DQUOTE] = ACTIONS(5160),
    [anon_sym_LR_DQUOTE] = ACTIONS(5160),
    [anon_sym_uR_DQUOTE] = ACTIONS(5160),
    [anon_sym_UR_DQUOTE] = ACTIONS(5160),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5160),
    [anon_sym_co_await] = ACTIONS(5158),
    [anon_sym_new] = ACTIONS(5158),
    [anon_sym_requires] = ACTIONS(5158),
    [sym_this] = ACTIONS(5158),
  },
  [1847] = {
    [sym__declaration_modifiers] = STATE(2720),
    [sym_attribute_specifier] = STATE(2720),
    [sym_attribute_declaration] = STATE(2720),
    [sym_ms_declspec_modifier] = STATE(2720),
    [sym_storage_class_specifier] = STATE(2720),
    [sym_type_qualifier] = STATE(2720),
    [sym_alignas_qualifier] = STATE(1830),
    [sym_type_specifier] = STATE(2128),
    [sym_sized_type_specifier] = STATE(2200),
    [sym_enum_specifier] = STATE(2200),
    [sym_struct_specifier] = STATE(2200),
    [sym_union_specifier] = STATE(2200),
    [sym_placeholder_type_specifier] = STATE(2200),
    [sym_decltype_auto] = STATE(2194),
    [sym_decltype] = STATE(2154),
    [sym_class_specifier] = STATE(2200),
    [sym_dependent_type] = STATE(2200),
    [sym_template_type] = STATE(2154),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6858),
    [sym_qualified_type_identifier] = STATE(2604),
    [sym_launch_bounds] = STATE(2720),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2720),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2173),
    [sym_identifier] = ACTIONS(4244),
    [anon_sym___extension__] = ACTIONS(63),
    [anon_sym___device__] = ACTIONS(5153),
    [anon_sym___host__] = ACTIONS(5153),
    [anon_sym___global__] = ACTIONS(5153),
    [anon_sym___forceinline__] = ACTIONS(5153),
    [anon_sym___noinline__] = ACTIONS(5153),
    [anon_sym_extern] = ACTIONS(59),
    [anon_sym___attribute__] = ACTIONS(41),
    [anon_sym_COLON_COLON] = ACTIONS(4254),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1745),
    [anon_sym___declspec] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(55),
    [anon_sym_unsigned] = ACTIONS(55),
    [anon_sym_long] = ACTIONS(55),
    [anon_sym_short] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(59),
    [anon_sym_register] = ACTIONS(59),
    [anon_sym_inline] = ACTIONS(59),
    [anon_sym___inline] = ACTIONS(59),
    [anon_sym___inline__] = ACTIONS(59),
    [anon_sym___forceinline] = ACTIONS(59),
    [anon_sym_thread_local] = ACTIONS(59),
    [anon_sym___thread] = ACTIONS(59),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_constexpr] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_restrict] = ACTIONS(63),
    [anon_sym___restrict__] = ACTIONS(63),
    [anon_sym__Atomic] = ACTIONS(63),
    [anon_sym__Noreturn] = ACTIONS(63),
    [anon_sym_noreturn] = ACTIONS(63),
    [anon_sym_mutable] = ACTIONS(63),
    [anon_sym_constinit] = ACTIONS(63),
    [anon_sym_consteval] = ACTIONS(63),
    [anon_sym___shared__] = ACTIONS(63),
    [anon_sym___local__] = ACTIONS(63),
    [anon_sym___constant__] = ACTIONS(63),
    [anon_sym___managed__] = ACTIONS(63),
    [anon_sym___grid_constant__] = ACTIONS(63),
    [anon_sym_alignas] = ACTIONS(65),
    [anon_sym__Alignas] = ACTIONS(65),
    [sym_primitive_type] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(1771),
    [anon_sym_class] = ACTIONS(1773),
    [anon_sym_struct] = ACTIONS(1775),
    [anon_sym_union] = ACTIONS(1777),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(121),
    [anon_sym_decltype] = ACTIONS(123),
    [sym_virtual] = ACTIONS(5153),
    [anon_sym_typename] = ACTIONS(1801),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym___launch_bounds__] = ACTIONS(159),
  },
  [1848] = {
    [sym_decltype_auto] = STATE(2003),
    [sym_identifier] = ACTIONS(5171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5173),
    [anon_sym_COMMA] = ACTIONS(5173),
    [anon_sym_RPAREN] = ACTIONS(5173),
    [anon_sym_LPAREN2] = ACTIONS(5173),
    [anon_sym_DASH] = ACTIONS(5171),
    [anon_sym_PLUS] = ACTIONS(5171),
    [anon_sym_STAR] = ACTIONS(5173),
    [anon_sym_SLASH] = ACTIONS(5171),
    [anon_sym_PERCENT] = ACTIONS(5173),
    [anon_sym_PIPE_PIPE] = ACTIONS(5173),
    [anon_sym_AMP_AMP] = ACTIONS(5173),
    [anon_sym_PIPE] = ACTIONS(5171),
    [anon_sym_CARET] = ACTIONS(5173),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_EQ_EQ] = ACTIONS(5173),
    [anon_sym_BANG_EQ] = ACTIONS(5173),
    [anon_sym_GT] = ACTIONS(5171),
    [anon_sym_GT_EQ] = ACTIONS(5173),
    [anon_sym_LT_EQ] = ACTIONS(5171),
    [anon_sym_LT] = ACTIONS(5171),
    [anon_sym_LT_LT] = ACTIONS(5171),
    [anon_sym_GT_GT] = ACTIONS(5173),
    [anon_sym_SEMI] = ACTIONS(5173),
    [anon_sym___extension__] = ACTIONS(5171),
    [anon_sym___global__] = ACTIONS(5171),
    [anon_sym___attribute__] = ACTIONS(5171),
    [anon_sym___based] = ACTIONS(5171),
    [anon_sym_LBRACE] = ACTIONS(5173),
    [anon_sym_RBRACE] = ACTIONS(5173),
    [anon_sym_signed] = ACTIONS(5171),
    [anon_sym_unsigned] = ACTIONS(5171),
    [anon_sym_long] = ACTIONS(5171),
    [anon_sym_short] = ACTIONS(5171),
    [anon_sym_LBRACK] = ACTIONS(5173),
    [anon_sym_RBRACK] = ACTIONS(5173),
    [anon_sym_const] = ACTIONS(5171),
    [anon_sym_constexpr] = ACTIONS(5171),
    [anon_sym_volatile] = ACTIONS(5171),
    [anon_sym_restrict] = ACTIONS(5171),
    [anon_sym___restrict__] = ACTIONS(5171),
    [anon_sym__Atomic] = ACTIONS(5171),
    [anon_sym__Noreturn] = ACTIONS(5171),
    [anon_sym_noreturn] = ACTIONS(5171),
    [anon_sym_mutable] = ACTIONS(5171),
    [anon_sym_constinit] = ACTIONS(5171),
    [anon_sym_consteval] = ACTIONS(5171),
    [anon_sym___shared__] = ACTIONS(5171),
    [anon_sym___local__] = ACTIONS(5171),
    [anon_sym___constant__] = ACTIONS(5171),
    [anon_sym___managed__] = ACTIONS(5171),
    [anon_sym___grid_constant__] = ACTIONS(5171),
    [anon_sym_alignas] = ACTIONS(5171),
    [anon_sym__Alignas] = ACTIONS(5171),
    [sym_primitive_type] = ACTIONS(5171),
    [anon_sym_COLON] = ACTIONS(5173),
    [anon_sym_QMARK] = ACTIONS(5173),
    [anon_sym_LT_EQ_GT] = ACTIONS(5173),
    [anon_sym_or] = ACTIONS(5171),
    [anon_sym_and] = ACTIONS(5171),
    [anon_sym_bitor] = ACTIONS(5171),
    [anon_sym_xor] = ACTIONS(5171),
    [anon_sym_bitand] = ACTIONS(5171),
    [anon_sym_not_eq] = ACTIONS(5171),
    [anon_sym_DASH_DASH] = ACTIONS(5173),
    [anon_sym_PLUS_PLUS] = ACTIONS(5173),
    [anon_sym_DOT] = ACTIONS(5171),
    [anon_sym_DOT_STAR] = ACTIONS(5173),
    [anon_sym_DASH_GT] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5175),
    [anon_sym_decltype] = ACTIONS(5177),
    [anon_sym_final] = ACTIONS(5171),
    [anon_sym_override] = ACTIONS(5171),
    [anon_sym_requires] = ACTIONS(5171),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5173),
  },
  [1849] = {
    [sym_identifier] = ACTIONS(5179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5181),
    [anon_sym_COMMA] = ACTIONS(5181),
    [anon_sym_RPAREN] = ACTIONS(5181),
    [anon_sym_LPAREN2] = ACTIONS(5181),
    [anon_sym_DASH] = ACTIONS(5179),
    [anon_sym_PLUS] = ACTIONS(5179),
    [anon_sym_STAR] = ACTIONS(5181),
    [anon_sym_SLASH] = ACTIONS(5179),
    [anon_sym_PERCENT] = ACTIONS(5181),
    [anon_sym_PIPE_PIPE] = ACTIONS(5181),
    [anon_sym_AMP_AMP] = ACTIONS(5181),
    [anon_sym_PIPE] = ACTIONS(5179),
    [anon_sym_CARET] = ACTIONS(5181),
    [anon_sym_AMP] = ACTIONS(5179),
    [anon_sym_EQ_EQ] = ACTIONS(5181),
    [anon_sym_BANG_EQ] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5179),
    [anon_sym_GT_EQ] = ACTIONS(5181),
    [anon_sym_LT_EQ] = ACTIONS(5179),
    [anon_sym_LT] = ACTIONS(5179),
    [anon_sym_LT_LT] = ACTIONS(5179),
    [anon_sym_GT_GT] = ACTIONS(5181),
    [anon_sym_SEMI] = ACTIONS(5181),
    [anon_sym___extension__] = ACTIONS(5179),
    [anon_sym___global__] = ACTIONS(5179),
    [anon_sym___attribute__] = ACTIONS(5179),
    [anon_sym_COLON_COLON] = ACTIONS(5183),
    [anon_sym___based] = ACTIONS(5179),
    [anon_sym_LBRACE] = ACTIONS(5181),
    [anon_sym_RBRACE] = ACTIONS(5181),
    [anon_sym_signed] = ACTIONS(5179),
    [anon_sym_unsigned] = ACTIONS(5179),
    [anon_sym_long] = ACTIONS(5179),
    [anon_sym_short] = ACTIONS(5179),
    [anon_sym_LBRACK] = ACTIONS(5181),
    [anon_sym_RBRACK] = ACTIONS(5181),
    [anon_sym_const] = ACTIONS(5179),
    [anon_sym_constexpr] = ACTIONS(5179),
    [anon_sym_volatile] = ACTIONS(5179),
    [anon_sym_restrict] = ACTIONS(5179),
    [anon_sym___restrict__] = ACTIONS(5179),
    [anon_sym__Atomic] = ACTIONS(5179),
    [anon_sym__Noreturn] = ACTIONS(5179),
    [anon_sym_noreturn] = ACTIONS(5179),
    [anon_sym_mutable] = ACTIONS(5179),
    [anon_sym_constinit] = ACTIONS(5179),
    [anon_sym_consteval] = ACTIONS(5179),
    [anon_sym___shared__] = ACTIONS(5179),
    [anon_sym___local__] = ACTIONS(5179),
    [anon_sym___constant__] = ACTIONS(5179),
    [anon_sym___managed__] = ACTIONS(5179),
    [anon_sym___grid_constant__] = ACTIONS(5179),
    [anon_sym_alignas] = ACTIONS(5179),
    [anon_sym__Alignas] = ACTIONS(5179),
    [sym_primitive_type] = ACTIONS(5179),
    [anon_sym_COLON] = ACTIONS(5179),
    [anon_sym_QMARK] = ACTIONS(5181),
    [anon_sym_LT_EQ_GT] = ACTIONS(5181),
    [anon_sym_or] = ACTIONS(5179),
    [anon_sym_and] = ACTIONS(5179),
    [anon_sym_bitor] = ACTIONS(5179),
    [anon_sym_xor] = ACTIONS(5179),
    [anon_sym_bitand] = ACTIONS(5179),
    [anon_sym_not_eq] = ACTIONS(5179),
    [anon_sym_DASH_DASH] = ACTIONS(5181),
    [anon_sym_PLUS_PLUS] = ACTIONS(5181),
    [anon_sym_DOT] = ACTIONS(5179),
    [anon_sym_DOT_STAR] = ACTIONS(5181),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5179),
    [anon_sym_decltype] = ACTIONS(5179),
    [anon_sym_final] = ACTIONS(5179),
    [anon_sym_override] = ACTIONS(5179),
    [anon_sym_requires] = ACTIONS(5179),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5181),
  },
  [1850] = {
    [sym_identifier] = ACTIONS(4021),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_RPAREN] = ACTIONS(4023),
    [anon_sym_LPAREN2] = ACTIONS(4023),
    [anon_sym_DASH] = ACTIONS(4021),
    [anon_sym_PLUS] = ACTIONS(4021),
    [anon_sym_STAR] = ACTIONS(4023),
    [anon_sym_SLASH] = ACTIONS(4021),
    [anon_sym_PERCENT] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4023),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_CARET] = ACTIONS(4023),
    [anon_sym_AMP] = ACTIONS(4021),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4021),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4023),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym___extension__] = ACTIONS(4021),
    [anon_sym___global__] = ACTIONS(4021),
    [anon_sym___attribute__] = ACTIONS(4021),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym___based] = ACTIONS(4021),
    [anon_sym_LBRACE] = ACTIONS(4023),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_signed] = ACTIONS(4021),
    [anon_sym_unsigned] = ACTIONS(4021),
    [anon_sym_long] = ACTIONS(4021),
    [anon_sym_short] = ACTIONS(4021),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_RBRACK] = ACTIONS(4023),
    [anon_sym_const] = ACTIONS(4021),
    [anon_sym_constexpr] = ACTIONS(4021),
    [anon_sym_volatile] = ACTIONS(4021),
    [anon_sym_restrict] = ACTIONS(4021),
    [anon_sym___restrict__] = ACTIONS(4021),
    [anon_sym__Atomic] = ACTIONS(4021),
    [anon_sym__Noreturn] = ACTIONS(4021),
    [anon_sym_noreturn] = ACTIONS(4021),
    [anon_sym_mutable] = ACTIONS(4021),
    [anon_sym_constinit] = ACTIONS(4021),
    [anon_sym_consteval] = ACTIONS(4021),
    [anon_sym___shared__] = ACTIONS(4021),
    [anon_sym___local__] = ACTIONS(4021),
    [anon_sym___constant__] = ACTIONS(4021),
    [anon_sym___managed__] = ACTIONS(4021),
    [anon_sym___grid_constant__] = ACTIONS(4021),
    [anon_sym_alignas] = ACTIONS(4021),
    [anon_sym__Alignas] = ACTIONS(4021),
    [sym_primitive_type] = ACTIONS(4021),
    [anon_sym_COLON] = ACTIONS(4021),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_LT_EQ_GT] = ACTIONS(4023),
    [anon_sym_or] = ACTIONS(4021),
    [anon_sym_and] = ACTIONS(4021),
    [anon_sym_bitor] = ACTIONS(4021),
    [anon_sym_xor] = ACTIONS(4021),
    [anon_sym_bitand] = ACTIONS(4021),
    [anon_sym_not_eq] = ACTIONS(4021),
    [anon_sym_DASH_DASH] = ACTIONS(4023),
    [anon_sym_PLUS_PLUS] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4021),
    [anon_sym_DOT_STAR] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4021),
    [anon_sym_decltype] = ACTIONS(4021),
    [anon_sym_final] = ACTIONS(4021),
    [anon_sym_override] = ACTIONS(4021),
    [anon_sym_requires] = ACTIONS(4021),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4023),
  },
  [1851] = {
    [sym_identifier] = ACTIONS(5185),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5187),
    [anon_sym_COMMA] = ACTIONS(5187),
    [anon_sym_RPAREN] = ACTIONS(5187),
    [anon_sym_LPAREN2] = ACTIONS(5187),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_PLUS] = ACTIONS(5185),
    [anon_sym_STAR] = ACTIONS(5187),
    [anon_sym_SLASH] = ACTIONS(5185),
    [anon_sym_PERCENT] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5187),
    [anon_sym_AMP_AMP] = ACTIONS(5187),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_CARET] = ACTIONS(5187),
    [anon_sym_AMP] = ACTIONS(5185),
    [anon_sym_EQ_EQ] = ACTIONS(5187),
    [anon_sym_BANG_EQ] = ACTIONS(5187),
    [anon_sym_GT] = ACTIONS(5185),
    [anon_sym_GT_EQ] = ACTIONS(5187),
    [anon_sym_LT_EQ] = ACTIONS(5185),
    [anon_sym_LT] = ACTIONS(5185),
    [anon_sym_LT_LT] = ACTIONS(5185),
    [anon_sym_GT_GT] = ACTIONS(5187),
    [anon_sym_SEMI] = ACTIONS(5187),
    [anon_sym___extension__] = ACTIONS(5185),
    [anon_sym___global__] = ACTIONS(5185),
    [anon_sym___attribute__] = ACTIONS(5185),
    [anon_sym_COLON_COLON] = ACTIONS(5183),
    [anon_sym___based] = ACTIONS(5185),
    [anon_sym_LBRACE] = ACTIONS(5187),
    [anon_sym_RBRACE] = ACTIONS(5187),
    [anon_sym_signed] = ACTIONS(5185),
    [anon_sym_unsigned] = ACTIONS(5185),
    [anon_sym_long] = ACTIONS(5185),
    [anon_sym_short] = ACTIONS(5185),
    [anon_sym_LBRACK] = ACTIONS(5187),
    [anon_sym_RBRACK] = ACTIONS(5187),
    [anon_sym_const] = ACTIONS(5185),
    [anon_sym_constexpr] = ACTIONS(5185),
    [anon_sym_volatile] = ACTIONS(5185),
    [anon_sym_restrict] = ACTIONS(5185),
    [anon_sym___restrict__] = ACTIONS(5185),
    [anon_sym__Atomic] = ACTIONS(5185),
    [anon_sym__Noreturn] = ACTIONS(5185),
    [anon_sym_noreturn] = ACTIONS(5185),
    [anon_sym_mutable] = ACTIONS(5185),
    [anon_sym_constinit] = ACTIONS(5185),
    [anon_sym_consteval] = ACTIONS(5185),
    [anon_sym___shared__] = ACTIONS(5185),
    [anon_sym___local__] = ACTIONS(5185),
    [anon_sym___constant__] = ACTIONS(5185),
    [anon_sym___managed__] = ACTIONS(5185),
    [anon_sym___grid_constant__] = ACTIONS(5185),
    [anon_sym_alignas] = ACTIONS(5185),
    [anon_sym__Alignas] = ACTIONS(5185),
    [sym_primitive_type] = ACTIONS(5185),
    [anon_sym_COLON] = ACTIONS(5185),
    [anon_sym_QMARK] = ACTIONS(5187),
    [anon_sym_LT_EQ_GT] = ACTIONS(5187),
    [anon_sym_or] = ACTIONS(5185),
    [anon_sym_and] = ACTIONS(5185),
    [anon_sym_bitor] = ACTIONS(5185),
    [anon_sym_xor] = ACTIONS(5185),
    [anon_sym_bitand] = ACTIONS(5185),
    [anon_sym_not_eq] = ACTIONS(5185),
    [anon_sym_DASH_DASH] = ACTIONS(5187),
    [anon_sym_PLUS_PLUS] = ACTIONS(5187),
    [anon_sym_DOT] = ACTIONS(5185),
    [anon_sym_DOT_STAR] = ACTIONS(5187),
    [anon_sym_DASH_GT] = ACTIONS(5187),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5185),
    [anon_sym_decltype] = ACTIONS(5185),
    [anon_sym_final] = ACTIONS(5185),
    [anon_sym_override] = ACTIONS(5185),
    [anon_sym_requires] = ACTIONS(5185),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5187),
  },
  [1852] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4144),
    [anon_sym_COMMA] = ACTIONS(4144),
    [anon_sym_RPAREN] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_STAR] = ACTIONS(4153),
    [anon_sym_SLASH] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4151),
    [anon_sym_CARET] = ACTIONS(4151),
    [anon_sym_AMP] = ACTIONS(4153),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT] = ACTIONS(4151),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4151),
    [anon_sym_LT] = ACTIONS(4151),
    [anon_sym_LT_LT] = ACTIONS(4151),
    [anon_sym_GT_GT] = ACTIONS(4151),
    [anon_sym___extension__] = ACTIONS(4149),
    [anon_sym___global__] = ACTIONS(4149),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_LBRACE] = ACTIONS(4149),
    [anon_sym_LBRACK] = ACTIONS(4146),
    [anon_sym_EQ] = ACTIONS(4151),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_constexpr] = ACTIONS(4149),
    [anon_sym_volatile] = ACTIONS(4149),
    [anon_sym_restrict] = ACTIONS(4149),
    [anon_sym___restrict__] = ACTIONS(4149),
    [anon_sym__Atomic] = ACTIONS(4149),
    [anon_sym__Noreturn] = ACTIONS(4149),
    [anon_sym_noreturn] = ACTIONS(4149),
    [anon_sym_mutable] = ACTIONS(4149),
    [anon_sym_constinit] = ACTIONS(4149),
    [anon_sym_consteval] = ACTIONS(4149),
    [anon_sym___shared__] = ACTIONS(4149),
    [anon_sym___local__] = ACTIONS(4149),
    [anon_sym___constant__] = ACTIONS(4149),
    [anon_sym___managed__] = ACTIONS(4149),
    [anon_sym___grid_constant__] = ACTIONS(4149),
    [anon_sym_alignas] = ACTIONS(4149),
    [anon_sym__Alignas] = ACTIONS(4149),
    [anon_sym_QMARK] = ACTIONS(4144),
    [anon_sym_STAR_EQ] = ACTIONS(4144),
    [anon_sym_SLASH_EQ] = ACTIONS(4144),
    [anon_sym_PERCENT_EQ] = ACTIONS(4144),
    [anon_sym_PLUS_EQ] = ACTIONS(4144),
    [anon_sym_DASH_EQ] = ACTIONS(4144),
    [anon_sym_LT_LT_EQ] = ACTIONS(4144),
    [anon_sym_GT_GT_EQ] = ACTIONS(4144),
    [anon_sym_AMP_EQ] = ACTIONS(4144),
    [anon_sym_CARET_EQ] = ACTIONS(4144),
    [anon_sym_PIPE_EQ] = ACTIONS(4144),
    [anon_sym_and_eq] = ACTIONS(4144),
    [anon_sym_or_eq] = ACTIONS(4144),
    [anon_sym_xor_eq] = ACTIONS(4144),
    [anon_sym_LT_EQ_GT] = ACTIONS(4144),
    [anon_sym_or] = ACTIONS(4151),
    [anon_sym_and] = ACTIONS(4151),
    [anon_sym_bitor] = ACTIONS(4144),
    [anon_sym_xor] = ACTIONS(4151),
    [anon_sym_bitand] = ACTIONS(4144),
    [anon_sym_not_eq] = ACTIONS(4144),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_DOT_STAR] = ACTIONS(4144),
    [anon_sym_DASH_GT] = ACTIONS(4151),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4149),
    [anon_sym_decltype] = ACTIONS(4149),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4144),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4144),
  },
  [1853] = {
    [sym_identifier] = ACTIONS(5179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5181),
    [anon_sym_COMMA] = ACTIONS(5181),
    [anon_sym_RPAREN] = ACTIONS(5181),
    [anon_sym_LPAREN2] = ACTIONS(5181),
    [anon_sym_DASH] = ACTIONS(5179),
    [anon_sym_PLUS] = ACTIONS(5179),
    [anon_sym_STAR] = ACTIONS(5181),
    [anon_sym_SLASH] = ACTIONS(5179),
    [anon_sym_PERCENT] = ACTIONS(5181),
    [anon_sym_PIPE_PIPE] = ACTIONS(5181),
    [anon_sym_AMP_AMP] = ACTIONS(5181),
    [anon_sym_PIPE] = ACTIONS(5179),
    [anon_sym_CARET] = ACTIONS(5181),
    [anon_sym_AMP] = ACTIONS(5179),
    [anon_sym_EQ_EQ] = ACTIONS(5181),
    [anon_sym_BANG_EQ] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5179),
    [anon_sym_GT_EQ] = ACTIONS(5181),
    [anon_sym_LT_EQ] = ACTIONS(5179),
    [anon_sym_LT] = ACTIONS(5179),
    [anon_sym_LT_LT] = ACTIONS(5179),
    [anon_sym_GT_GT] = ACTIONS(5181),
    [anon_sym_SEMI] = ACTIONS(5181),
    [anon_sym___extension__] = ACTIONS(5179),
    [anon_sym___global__] = ACTIONS(5179),
    [anon_sym___attribute__] = ACTIONS(5179),
    [anon_sym_COLON_COLON] = ACTIONS(5183),
    [anon_sym___based] = ACTIONS(5179),
    [anon_sym_LBRACE] = ACTIONS(5181),
    [anon_sym_RBRACE] = ACTIONS(5181),
    [anon_sym_signed] = ACTIONS(5179),
    [anon_sym_unsigned] = ACTIONS(5179),
    [anon_sym_long] = ACTIONS(5179),
    [anon_sym_short] = ACTIONS(5179),
    [anon_sym_LBRACK] = ACTIONS(5181),
    [anon_sym_RBRACK] = ACTIONS(5181),
    [anon_sym_const] = ACTIONS(5179),
    [anon_sym_constexpr] = ACTIONS(5179),
    [anon_sym_volatile] = ACTIONS(5179),
    [anon_sym_restrict] = ACTIONS(5179),
    [anon_sym___restrict__] = ACTIONS(5179),
    [anon_sym__Atomic] = ACTIONS(5179),
    [anon_sym__Noreturn] = ACTIONS(5179),
    [anon_sym_noreturn] = ACTIONS(5179),
    [anon_sym_mutable] = ACTIONS(5179),
    [anon_sym_constinit] = ACTIONS(5179),
    [anon_sym_consteval] = ACTIONS(5179),
    [anon_sym___shared__] = ACTIONS(5179),
    [anon_sym___local__] = ACTIONS(5179),
    [anon_sym___constant__] = ACTIONS(5179),
    [anon_sym___managed__] = ACTIONS(5179),
    [anon_sym___grid_constant__] = ACTIONS(5179),
    [anon_sym_alignas] = ACTIONS(5179),
    [anon_sym__Alignas] = ACTIONS(5179),
    [sym_primitive_type] = ACTIONS(5179),
    [anon_sym_COLON] = ACTIONS(5179),
    [anon_sym_QMARK] = ACTIONS(5181),
    [anon_sym_LT_EQ_GT] = ACTIONS(5181),
    [anon_sym_or] = ACTIONS(5179),
    [anon_sym_and] = ACTIONS(5179),
    [anon_sym_bitor] = ACTIONS(5179),
    [anon_sym_xor] = ACTIONS(5179),
    [anon_sym_bitand] = ACTIONS(5179),
    [anon_sym_not_eq] = ACTIONS(5179),
    [anon_sym_DASH_DASH] = ACTIONS(5181),
    [anon_sym_PLUS_PLUS] = ACTIONS(5181),
    [anon_sym_DOT] = ACTIONS(5179),
    [anon_sym_DOT_STAR] = ACTIONS(5181),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5179),
    [anon_sym_decltype] = ACTIONS(5179),
    [anon_sym_final] = ACTIONS(5179),
    [anon_sym_override] = ACTIONS(5179),
    [anon_sym_requires] = ACTIONS(5179),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5181),
  },
  [1854] = {
    [sym_identifier] = ACTIONS(1924),
    [aux_sym_preproc_def_token1] = ACTIONS(1924),
    [aux_sym_preproc_if_token1] = ACTIONS(1924),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1924),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1924),
    [sym_preproc_directive] = ACTIONS(1924),
    [anon_sym_LPAREN2] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [anon_sym_STAR] = ACTIONS(1926),
    [anon_sym_AMP_AMP] = ACTIONS(1926),
    [anon_sym_AMP] = ACTIONS(1924),
    [anon_sym___extension__] = ACTIONS(1924),
    [anon_sym_typedef] = ACTIONS(1924),
    [anon_sym___device__] = ACTIONS(1924),
    [anon_sym___host__] = ACTIONS(1924),
    [anon_sym___global__] = ACTIONS(1924),
    [anon_sym___forceinline__] = ACTIONS(1924),
    [anon_sym___noinline__] = ACTIONS(1924),
    [anon_sym_extern] = ACTIONS(1924),
    [anon_sym___attribute__] = ACTIONS(1924),
    [anon_sym_COLON_COLON] = ACTIONS(1926),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1926),
    [anon_sym___declspec] = ACTIONS(1924),
    [anon_sym___based] = ACTIONS(1924),
    [anon_sym_RBRACE] = ACTIONS(1926),
    [anon_sym_signed] = ACTIONS(1924),
    [anon_sym_unsigned] = ACTIONS(1924),
    [anon_sym_long] = ACTIONS(1924),
    [anon_sym_short] = ACTIONS(1924),
    [anon_sym_LBRACK] = ACTIONS(1924),
    [anon_sym_static] = ACTIONS(1924),
    [anon_sym_register] = ACTIONS(1924),
    [anon_sym_inline] = ACTIONS(1924),
    [anon_sym___inline] = ACTIONS(1924),
    [anon_sym___inline__] = ACTIONS(1924),
    [anon_sym___forceinline] = ACTIONS(1924),
    [anon_sym_thread_local] = ACTIONS(1924),
    [anon_sym___thread] = ACTIONS(1924),
    [anon_sym_const] = ACTIONS(1924),
    [anon_sym_constexpr] = ACTIONS(1924),
    [anon_sym_volatile] = ACTIONS(1924),
    [anon_sym_restrict] = ACTIONS(1924),
    [anon_sym___restrict__] = ACTIONS(1924),
    [anon_sym__Atomic] = ACTIONS(1924),
    [anon_sym__Noreturn] = ACTIONS(1924),
    [anon_sym_noreturn] = ACTIONS(1924),
    [anon_sym_mutable] = ACTIONS(1924),
    [anon_sym_constinit] = ACTIONS(1924),
    [anon_sym_consteval] = ACTIONS(1924),
    [anon_sym___shared__] = ACTIONS(1924),
    [anon_sym___local__] = ACTIONS(1924),
    [anon_sym___constant__] = ACTIONS(1924),
    [anon_sym___managed__] = ACTIONS(1924),
    [anon_sym___grid_constant__] = ACTIONS(1924),
    [anon_sym_alignas] = ACTIONS(1924),
    [anon_sym__Alignas] = ACTIONS(1924),
    [sym_primitive_type] = ACTIONS(1924),
    [anon_sym_enum] = ACTIONS(1924),
    [anon_sym_class] = ACTIONS(1924),
    [anon_sym_struct] = ACTIONS(1924),
    [anon_sym_union] = ACTIONS(1924),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1924),
    [anon_sym_decltype] = ACTIONS(1924),
    [sym_virtual] = ACTIONS(1924),
    [anon_sym_explicit] = ACTIONS(1924),
    [anon_sym_typename] = ACTIONS(1924),
    [anon_sym_template] = ACTIONS(1924),
    [anon_sym_operator] = ACTIONS(1924),
    [anon_sym_friend] = ACTIONS(1924),
    [anon_sym_public] = ACTIONS(1924),
    [anon_sym_private] = ACTIONS(1924),
    [anon_sym_protected] = ACTIONS(1924),
    [anon_sym_using] = ACTIONS(1924),
    [anon_sym_static_assert] = ACTIONS(1924),
    [anon_sym_catch] = ACTIONS(1924),
    [anon_sym___launch_bounds__] = ACTIONS(1924),
  },
  [1855] = {
    [sym_string_literal] = STATE(2067),
    [sym_template_argument_list] = STATE(2502),
    [sym_raw_string_literal] = STATE(2067),
    [sym_identifier] = ACTIONS(3766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_RPAREN] = ACTIONS(3758),
    [aux_sym_preproc_if_token2] = ACTIONS(3758),
    [aux_sym_preproc_else_token1] = ACTIONS(3758),
    [aux_sym_preproc_elif_token1] = ACTIONS(3766),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3758),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(5189),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3758),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_RBRACE] = ACTIONS(3758),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_RBRACK] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(3766),
    [anon_sym_COLON] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3758),
    [anon_sym_SLASH_EQ] = ACTIONS(3758),
    [anon_sym_PERCENT_EQ] = ACTIONS(3758),
    [anon_sym_PLUS_EQ] = ACTIONS(3758),
    [anon_sym_DASH_EQ] = ACTIONS(3758),
    [anon_sym_LT_LT_EQ] = ACTIONS(3758),
    [anon_sym_GT_GT_EQ] = ACTIONS(3758),
    [anon_sym_AMP_EQ] = ACTIONS(3758),
    [anon_sym_CARET_EQ] = ACTIONS(3758),
    [anon_sym_PIPE_EQ] = ACTIONS(3758),
    [anon_sym_and_eq] = ACTIONS(3766),
    [anon_sym_or_eq] = ACTIONS(3766),
    [anon_sym_xor_eq] = ACTIONS(3766),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3766),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3766),
    [anon_sym_not_eq] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [1856] = {
    [sym_identifier] = ACTIONS(3996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3998),
    [anon_sym_COMMA] = ACTIONS(3998),
    [anon_sym_RPAREN] = ACTIONS(3998),
    [anon_sym_LPAREN2] = ACTIONS(3998),
    [anon_sym_DASH] = ACTIONS(3996),
    [anon_sym_PLUS] = ACTIONS(3996),
    [anon_sym_STAR] = ACTIONS(3998),
    [anon_sym_SLASH] = ACTIONS(3996),
    [anon_sym_PERCENT] = ACTIONS(3998),
    [anon_sym_PIPE_PIPE] = ACTIONS(3998),
    [anon_sym_AMP_AMP] = ACTIONS(3998),
    [anon_sym_PIPE] = ACTIONS(3996),
    [anon_sym_CARET] = ACTIONS(3998),
    [anon_sym_AMP] = ACTIONS(3996),
    [anon_sym_EQ_EQ] = ACTIONS(3998),
    [anon_sym_BANG_EQ] = ACTIONS(3998),
    [anon_sym_GT] = ACTIONS(3996),
    [anon_sym_GT_EQ] = ACTIONS(3998),
    [anon_sym_LT_EQ] = ACTIONS(3996),
    [anon_sym_LT] = ACTIONS(3996),
    [anon_sym_LT_LT] = ACTIONS(3996),
    [anon_sym_GT_GT] = ACTIONS(3998),
    [anon_sym_SEMI] = ACTIONS(3998),
    [anon_sym___extension__] = ACTIONS(3996),
    [anon_sym___global__] = ACTIONS(3996),
    [anon_sym___attribute__] = ACTIONS(3996),
    [anon_sym_COLON_COLON] = ACTIONS(3998),
    [anon_sym___based] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(3998),
    [anon_sym_RBRACE] = ACTIONS(3998),
    [anon_sym_signed] = ACTIONS(3996),
    [anon_sym_unsigned] = ACTIONS(3996),
    [anon_sym_long] = ACTIONS(3996),
    [anon_sym_short] = ACTIONS(3996),
    [anon_sym_LBRACK] = ACTIONS(3998),
    [anon_sym_RBRACK] = ACTIONS(3998),
    [anon_sym_const] = ACTIONS(3996),
    [anon_sym_constexpr] = ACTIONS(3996),
    [anon_sym_volatile] = ACTIONS(3996),
    [anon_sym_restrict] = ACTIONS(3996),
    [anon_sym___restrict__] = ACTIONS(3996),
    [anon_sym__Atomic] = ACTIONS(3996),
    [anon_sym__Noreturn] = ACTIONS(3996),
    [anon_sym_noreturn] = ACTIONS(3996),
    [anon_sym_mutable] = ACTIONS(3996),
    [anon_sym_constinit] = ACTIONS(3996),
    [anon_sym_consteval] = ACTIONS(3996),
    [anon_sym___shared__] = ACTIONS(3996),
    [anon_sym___local__] = ACTIONS(3996),
    [anon_sym___constant__] = ACTIONS(3996),
    [anon_sym___managed__] = ACTIONS(3996),
    [anon_sym___grid_constant__] = ACTIONS(3996),
    [anon_sym_alignas] = ACTIONS(3996),
    [anon_sym__Alignas] = ACTIONS(3996),
    [sym_primitive_type] = ACTIONS(3996),
    [anon_sym_COLON] = ACTIONS(3996),
    [anon_sym_QMARK] = ACTIONS(3998),
    [anon_sym_LT_EQ_GT] = ACTIONS(3998),
    [anon_sym_or] = ACTIONS(3996),
    [anon_sym_and] = ACTIONS(3996),
    [anon_sym_bitor] = ACTIONS(3996),
    [anon_sym_xor] = ACTIONS(3996),
    [anon_sym_bitand] = ACTIONS(3996),
    [anon_sym_not_eq] = ACTIONS(3996),
    [anon_sym_DASH_DASH] = ACTIONS(3998),
    [anon_sym_PLUS_PLUS] = ACTIONS(3998),
    [anon_sym_DOT] = ACTIONS(3996),
    [anon_sym_DOT_STAR] = ACTIONS(3998),
    [anon_sym_DASH_GT] = ACTIONS(3998),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3996),
    [anon_sym_decltype] = ACTIONS(3996),
    [anon_sym_final] = ACTIONS(3996),
    [anon_sym_override] = ACTIONS(3996),
    [anon_sym_requires] = ACTIONS(3996),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3998),
  },
  [1857] = {
    [sym_identifier] = ACTIONS(3980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3982),
    [anon_sym_COMMA] = ACTIONS(3982),
    [anon_sym_RPAREN] = ACTIONS(3982),
    [anon_sym_LPAREN2] = ACTIONS(3982),
    [anon_sym_DASH] = ACTIONS(3980),
    [anon_sym_PLUS] = ACTIONS(3980),
    [anon_sym_STAR] = ACTIONS(3982),
    [anon_sym_SLASH] = ACTIONS(3980),
    [anon_sym_PERCENT] = ACTIONS(3982),
    [anon_sym_PIPE_PIPE] = ACTIONS(3982),
    [anon_sym_AMP_AMP] = ACTIONS(3982),
    [anon_sym_PIPE] = ACTIONS(3980),
    [anon_sym_CARET] = ACTIONS(3982),
    [anon_sym_AMP] = ACTIONS(3980),
    [anon_sym_EQ_EQ] = ACTIONS(3982),
    [anon_sym_BANG_EQ] = ACTIONS(3982),
    [anon_sym_GT] = ACTIONS(3980),
    [anon_sym_GT_EQ] = ACTIONS(3982),
    [anon_sym_LT_EQ] = ACTIONS(3980),
    [anon_sym_LT] = ACTIONS(3980),
    [anon_sym_LT_LT] = ACTIONS(3980),
    [anon_sym_GT_GT] = ACTIONS(3982),
    [anon_sym_SEMI] = ACTIONS(3982),
    [anon_sym___extension__] = ACTIONS(3980),
    [anon_sym___global__] = ACTIONS(3980),
    [anon_sym___attribute__] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym___based] = ACTIONS(3980),
    [anon_sym_LBRACE] = ACTIONS(3982),
    [anon_sym_RBRACE] = ACTIONS(3982),
    [anon_sym_signed] = ACTIONS(3980),
    [anon_sym_unsigned] = ACTIONS(3980),
    [anon_sym_long] = ACTIONS(3980),
    [anon_sym_short] = ACTIONS(3980),
    [anon_sym_LBRACK] = ACTIONS(3982),
    [anon_sym_RBRACK] = ACTIONS(3982),
    [anon_sym_const] = ACTIONS(3980),
    [anon_sym_constexpr] = ACTIONS(3980),
    [anon_sym_volatile] = ACTIONS(3980),
    [anon_sym_restrict] = ACTIONS(3980),
    [anon_sym___restrict__] = ACTIONS(3980),
    [anon_sym__Atomic] = ACTIONS(3980),
    [anon_sym__Noreturn] = ACTIONS(3980),
    [anon_sym_noreturn] = ACTIONS(3980),
    [anon_sym_mutable] = ACTIONS(3980),
    [anon_sym_constinit] = ACTIONS(3980),
    [anon_sym_consteval] = ACTIONS(3980),
    [anon_sym___shared__] = ACTIONS(3980),
    [anon_sym___local__] = ACTIONS(3980),
    [anon_sym___constant__] = ACTIONS(3980),
    [anon_sym___managed__] = ACTIONS(3980),
    [anon_sym___grid_constant__] = ACTIONS(3980),
    [anon_sym_alignas] = ACTIONS(3980),
    [anon_sym__Alignas] = ACTIONS(3980),
    [sym_primitive_type] = ACTIONS(3980),
    [anon_sym_COLON] = ACTIONS(3980),
    [anon_sym_QMARK] = ACTIONS(3982),
    [anon_sym_LT_EQ_GT] = ACTIONS(3982),
    [anon_sym_or] = ACTIONS(3980),
    [anon_sym_and] = ACTIONS(3980),
    [anon_sym_bitor] = ACTIONS(3980),
    [anon_sym_xor] = ACTIONS(3980),
    [anon_sym_bitand] = ACTIONS(3980),
    [anon_sym_not_eq] = ACTIONS(3980),
    [anon_sym_DASH_DASH] = ACTIONS(3982),
    [anon_sym_PLUS_PLUS] = ACTIONS(3982),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_DOT_STAR] = ACTIONS(3982),
    [anon_sym_DASH_GT] = ACTIONS(3982),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3980),
    [anon_sym_decltype] = ACTIONS(3980),
    [anon_sym_final] = ACTIONS(3980),
    [anon_sym_override] = ACTIONS(3980),
    [anon_sym_requires] = ACTIONS(3980),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3982),
  },
  [1858] = {
    [sym_identifier] = ACTIONS(1924),
    [aux_sym_preproc_def_token1] = ACTIONS(1924),
    [aux_sym_preproc_if_token1] = ACTIONS(1924),
    [aux_sym_preproc_if_token2] = ACTIONS(1924),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1924),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1924),
    [sym_preproc_directive] = ACTIONS(1924),
    [anon_sym_LPAREN2] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [anon_sym_STAR] = ACTIONS(1926),
    [anon_sym_AMP_AMP] = ACTIONS(1926),
    [anon_sym_AMP] = ACTIONS(1924),
    [anon_sym___extension__] = ACTIONS(1924),
    [anon_sym_typedef] = ACTIONS(1924),
    [anon_sym___device__] = ACTIONS(1924),
    [anon_sym___host__] = ACTIONS(1924),
    [anon_sym___global__] = ACTIONS(1924),
    [anon_sym___forceinline__] = ACTIONS(1924),
    [anon_sym___noinline__] = ACTIONS(1924),
    [anon_sym_extern] = ACTIONS(1924),
    [anon_sym___attribute__] = ACTIONS(1924),
    [anon_sym_COLON_COLON] = ACTIONS(1926),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1926),
    [anon_sym___declspec] = ACTIONS(1924),
    [anon_sym___based] = ACTIONS(1924),
    [anon_sym_signed] = ACTIONS(1924),
    [anon_sym_unsigned] = ACTIONS(1924),
    [anon_sym_long] = ACTIONS(1924),
    [anon_sym_short] = ACTIONS(1924),
    [anon_sym_LBRACK] = ACTIONS(1924),
    [anon_sym_static] = ACTIONS(1924),
    [anon_sym_register] = ACTIONS(1924),
    [anon_sym_inline] = ACTIONS(1924),
    [anon_sym___inline] = ACTIONS(1924),
    [anon_sym___inline__] = ACTIONS(1924),
    [anon_sym___forceinline] = ACTIONS(1924),
    [anon_sym_thread_local] = ACTIONS(1924),
    [anon_sym___thread] = ACTIONS(1924),
    [anon_sym_const] = ACTIONS(1924),
    [anon_sym_constexpr] = ACTIONS(1924),
    [anon_sym_volatile] = ACTIONS(1924),
    [anon_sym_restrict] = ACTIONS(1924),
    [anon_sym___restrict__] = ACTIONS(1924),
    [anon_sym__Atomic] = ACTIONS(1924),
    [anon_sym__Noreturn] = ACTIONS(1924),
    [anon_sym_noreturn] = ACTIONS(1924),
    [anon_sym_mutable] = ACTIONS(1924),
    [anon_sym_constinit] = ACTIONS(1924),
    [anon_sym_consteval] = ACTIONS(1924),
    [anon_sym___shared__] = ACTIONS(1924),
    [anon_sym___local__] = ACTIONS(1924),
    [anon_sym___constant__] = ACTIONS(1924),
    [anon_sym___managed__] = ACTIONS(1924),
    [anon_sym___grid_constant__] = ACTIONS(1924),
    [anon_sym_alignas] = ACTIONS(1924),
    [anon_sym__Alignas] = ACTIONS(1924),
    [sym_primitive_type] = ACTIONS(1924),
    [anon_sym_enum] = ACTIONS(1924),
    [anon_sym_class] = ACTIONS(1924),
    [anon_sym_struct] = ACTIONS(1924),
    [anon_sym_union] = ACTIONS(1924),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1924),
    [anon_sym_decltype] = ACTIONS(1924),
    [sym_virtual] = ACTIONS(1924),
    [anon_sym_explicit] = ACTIONS(1924),
    [anon_sym_typename] = ACTIONS(1924),
    [anon_sym_template] = ACTIONS(1924),
    [anon_sym_operator] = ACTIONS(1924),
    [anon_sym_friend] = ACTIONS(1924),
    [anon_sym_public] = ACTIONS(1924),
    [anon_sym_private] = ACTIONS(1924),
    [anon_sym_protected] = ACTIONS(1924),
    [anon_sym_using] = ACTIONS(1924),
    [anon_sym_static_assert] = ACTIONS(1924),
    [anon_sym_catch] = ACTIONS(1924),
    [anon_sym___launch_bounds__] = ACTIONS(1924),
  },
  [1859] = {
    [sym_identifier] = ACTIONS(5192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5194),
    [anon_sym_COMMA] = ACTIONS(5194),
    [anon_sym_RPAREN] = ACTIONS(5194),
    [anon_sym_LPAREN2] = ACTIONS(5194),
    [anon_sym_DASH] = ACTIONS(5192),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_STAR] = ACTIONS(5194),
    [anon_sym_SLASH] = ACTIONS(5192),
    [anon_sym_PERCENT] = ACTIONS(5194),
    [anon_sym_PIPE_PIPE] = ACTIONS(5194),
    [anon_sym_AMP_AMP] = ACTIONS(5194),
    [anon_sym_PIPE] = ACTIONS(5192),
    [anon_sym_CARET] = ACTIONS(5194),
    [anon_sym_AMP] = ACTIONS(5192),
    [anon_sym_EQ_EQ] = ACTIONS(5194),
    [anon_sym_BANG_EQ] = ACTIONS(5194),
    [anon_sym_GT] = ACTIONS(5192),
    [anon_sym_GT_EQ] = ACTIONS(5194),
    [anon_sym_LT_EQ] = ACTIONS(5192),
    [anon_sym_LT] = ACTIONS(5192),
    [anon_sym_LT_LT] = ACTIONS(5192),
    [anon_sym_GT_GT] = ACTIONS(5194),
    [anon_sym_SEMI] = ACTIONS(5194),
    [anon_sym___extension__] = ACTIONS(5192),
    [anon_sym___global__] = ACTIONS(5192),
    [anon_sym___attribute__] = ACTIONS(5192),
    [anon_sym_COLON_COLON] = ACTIONS(5183),
    [anon_sym___based] = ACTIONS(5192),
    [anon_sym_LBRACE] = ACTIONS(5194),
    [anon_sym_RBRACE] = ACTIONS(5194),
    [anon_sym_signed] = ACTIONS(5192),
    [anon_sym_unsigned] = ACTIONS(5192),
    [anon_sym_long] = ACTIONS(5192),
    [anon_sym_short] = ACTIONS(5192),
    [anon_sym_LBRACK] = ACTIONS(5194),
    [anon_sym_RBRACK] = ACTIONS(5194),
    [anon_sym_const] = ACTIONS(5192),
    [anon_sym_constexpr] = ACTIONS(5192),
    [anon_sym_volatile] = ACTIONS(5192),
    [anon_sym_restrict] = ACTIONS(5192),
    [anon_sym___restrict__] = ACTIONS(5192),
    [anon_sym__Atomic] = ACTIONS(5192),
    [anon_sym__Noreturn] = ACTIONS(5192),
    [anon_sym_noreturn] = ACTIONS(5192),
    [anon_sym_mutable] = ACTIONS(5192),
    [anon_sym_constinit] = ACTIONS(5192),
    [anon_sym_consteval] = ACTIONS(5192),
    [anon_sym___shared__] = ACTIONS(5192),
    [anon_sym___local__] = ACTIONS(5192),
    [anon_sym___constant__] = ACTIONS(5192),
    [anon_sym___managed__] = ACTIONS(5192),
    [anon_sym___grid_constant__] = ACTIONS(5192),
    [anon_sym_alignas] = ACTIONS(5192),
    [anon_sym__Alignas] = ACTIONS(5192),
    [sym_primitive_type] = ACTIONS(5192),
    [anon_sym_COLON] = ACTIONS(5192),
    [anon_sym_QMARK] = ACTIONS(5194),
    [anon_sym_LT_EQ_GT] = ACTIONS(5194),
    [anon_sym_or] = ACTIONS(5192),
    [anon_sym_and] = ACTIONS(5192),
    [anon_sym_bitor] = ACTIONS(5192),
    [anon_sym_xor] = ACTIONS(5192),
    [anon_sym_bitand] = ACTIONS(5192),
    [anon_sym_not_eq] = ACTIONS(5192),
    [anon_sym_DASH_DASH] = ACTIONS(5194),
    [anon_sym_PLUS_PLUS] = ACTIONS(5194),
    [anon_sym_DOT] = ACTIONS(5192),
    [anon_sym_DOT_STAR] = ACTIONS(5194),
    [anon_sym_DASH_GT] = ACTIONS(5194),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5192),
    [anon_sym_decltype] = ACTIONS(5192),
    [anon_sym_final] = ACTIONS(5192),
    [anon_sym_override] = ACTIONS(5192),
    [anon_sym_requires] = ACTIONS(5192),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5194),
  },
  [1860] = {
    [sym_identifier] = ACTIONS(5196),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5198),
    [anon_sym_COMMA] = ACTIONS(5198),
    [anon_sym_RPAREN] = ACTIONS(5198),
    [anon_sym_LPAREN2] = ACTIONS(5198),
    [anon_sym_DASH] = ACTIONS(5196),
    [anon_sym_PLUS] = ACTIONS(5196),
    [anon_sym_STAR] = ACTIONS(5198),
    [anon_sym_SLASH] = ACTIONS(5196),
    [anon_sym_PERCENT] = ACTIONS(5198),
    [anon_sym_PIPE_PIPE] = ACTIONS(5198),
    [anon_sym_AMP_AMP] = ACTIONS(5198),
    [anon_sym_PIPE] = ACTIONS(5196),
    [anon_sym_CARET] = ACTIONS(5198),
    [anon_sym_AMP] = ACTIONS(5196),
    [anon_sym_EQ_EQ] = ACTIONS(5198),
    [anon_sym_BANG_EQ] = ACTIONS(5198),
    [anon_sym_GT] = ACTIONS(5196),
    [anon_sym_GT_EQ] = ACTIONS(5198),
    [anon_sym_LT_EQ] = ACTIONS(5196),
    [anon_sym_LT] = ACTIONS(5196),
    [anon_sym_LT_LT] = ACTIONS(5196),
    [anon_sym_GT_GT] = ACTIONS(5198),
    [anon_sym_SEMI] = ACTIONS(5198),
    [anon_sym___extension__] = ACTIONS(5196),
    [anon_sym___global__] = ACTIONS(5196),
    [anon_sym___attribute__] = ACTIONS(5196),
    [anon_sym_COLON_COLON] = ACTIONS(5198),
    [anon_sym___based] = ACTIONS(5196),
    [anon_sym_LBRACE] = ACTIONS(5198),
    [anon_sym_RBRACE] = ACTIONS(5198),
    [anon_sym_signed] = ACTIONS(5196),
    [anon_sym_unsigned] = ACTIONS(5196),
    [anon_sym_long] = ACTIONS(5196),
    [anon_sym_short] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5198),
    [anon_sym_RBRACK] = ACTIONS(5198),
    [anon_sym_const] = ACTIONS(5196),
    [anon_sym_constexpr] = ACTIONS(5196),
    [anon_sym_volatile] = ACTIONS(5196),
    [anon_sym_restrict] = ACTIONS(5196),
    [anon_sym___restrict__] = ACTIONS(5196),
    [anon_sym__Atomic] = ACTIONS(5196),
    [anon_sym__Noreturn] = ACTIONS(5196),
    [anon_sym_noreturn] = ACTIONS(5196),
    [anon_sym_mutable] = ACTIONS(5196),
    [anon_sym_constinit] = ACTIONS(5196),
    [anon_sym_consteval] = ACTIONS(5196),
    [anon_sym___shared__] = ACTIONS(5196),
    [anon_sym___local__] = ACTIONS(5196),
    [anon_sym___constant__] = ACTIONS(5196),
    [anon_sym___managed__] = ACTIONS(5196),
    [anon_sym___grid_constant__] = ACTIONS(5196),
    [anon_sym_alignas] = ACTIONS(5196),
    [anon_sym__Alignas] = ACTIONS(5196),
    [sym_primitive_type] = ACTIONS(5196),
    [anon_sym_COLON] = ACTIONS(5196),
    [anon_sym_QMARK] = ACTIONS(5198),
    [anon_sym_LT_EQ_GT] = ACTIONS(5198),
    [anon_sym_or] = ACTIONS(5196),
    [anon_sym_and] = ACTIONS(5196),
    [anon_sym_bitor] = ACTIONS(5196),
    [anon_sym_xor] = ACTIONS(5196),
    [anon_sym_bitand] = ACTIONS(5196),
    [anon_sym_not_eq] = ACTIONS(5196),
    [anon_sym_DASH_DASH] = ACTIONS(5198),
    [anon_sym_PLUS_PLUS] = ACTIONS(5198),
    [anon_sym_DOT] = ACTIONS(5196),
    [anon_sym_DOT_STAR] = ACTIONS(5198),
    [anon_sym_DASH_GT] = ACTIONS(5198),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5196),
    [anon_sym_decltype] = ACTIONS(5196),
    [anon_sym_final] = ACTIONS(5196),
    [anon_sym_override] = ACTIONS(5196),
    [anon_sym_requires] = ACTIONS(5196),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5198),
  },
  [1861] = {
    [sym_identifier] = ACTIONS(3984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3986),
    [anon_sym_COMMA] = ACTIONS(3986),
    [anon_sym_RPAREN] = ACTIONS(3986),
    [anon_sym_LPAREN2] = ACTIONS(3986),
    [anon_sym_DASH] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(3986),
    [anon_sym_SLASH] = ACTIONS(3984),
    [anon_sym_PERCENT] = ACTIONS(3986),
    [anon_sym_PIPE_PIPE] = ACTIONS(3986),
    [anon_sym_AMP_AMP] = ACTIONS(3986),
    [anon_sym_PIPE] = ACTIONS(3984),
    [anon_sym_CARET] = ACTIONS(3986),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_EQ_EQ] = ACTIONS(3986),
    [anon_sym_BANG_EQ] = ACTIONS(3986),
    [anon_sym_GT] = ACTIONS(3984),
    [anon_sym_GT_EQ] = ACTIONS(3986),
    [anon_sym_LT_EQ] = ACTIONS(3984),
    [anon_sym_LT] = ACTIONS(3984),
    [anon_sym_LT_LT] = ACTIONS(3984),
    [anon_sym_GT_GT] = ACTIONS(3986),
    [anon_sym_SEMI] = ACTIONS(3986),
    [anon_sym___extension__] = ACTIONS(3984),
    [anon_sym___global__] = ACTIONS(3984),
    [anon_sym___attribute__] = ACTIONS(3984),
    [anon_sym_COLON_COLON] = ACTIONS(3986),
    [anon_sym___based] = ACTIONS(3984),
    [anon_sym_LBRACE] = ACTIONS(3986),
    [anon_sym_RBRACE] = ACTIONS(3986),
    [anon_sym_signed] = ACTIONS(3984),
    [anon_sym_unsigned] = ACTIONS(3984),
    [anon_sym_long] = ACTIONS(3984),
    [anon_sym_short] = ACTIONS(3984),
    [anon_sym_LBRACK] = ACTIONS(3986),
    [anon_sym_RBRACK] = ACTIONS(3986),
    [anon_sym_const] = ACTIONS(3984),
    [anon_sym_constexpr] = ACTIONS(3984),
    [anon_sym_volatile] = ACTIONS(3984),
    [anon_sym_restrict] = ACTIONS(3984),
    [anon_sym___restrict__] = ACTIONS(3984),
    [anon_sym__Atomic] = ACTIONS(3984),
    [anon_sym__Noreturn] = ACTIONS(3984),
    [anon_sym_noreturn] = ACTIONS(3984),
    [anon_sym_mutable] = ACTIONS(3984),
    [anon_sym_constinit] = ACTIONS(3984),
    [anon_sym_consteval] = ACTIONS(3984),
    [anon_sym___shared__] = ACTIONS(3984),
    [anon_sym___local__] = ACTIONS(3984),
    [anon_sym___constant__] = ACTIONS(3984),
    [anon_sym___managed__] = ACTIONS(3984),
    [anon_sym___grid_constant__] = ACTIONS(3984),
    [anon_sym_alignas] = ACTIONS(3984),
    [anon_sym__Alignas] = ACTIONS(3984),
    [sym_primitive_type] = ACTIONS(3984),
    [anon_sym_COLON] = ACTIONS(3984),
    [anon_sym_QMARK] = ACTIONS(3986),
    [anon_sym_LT_EQ_GT] = ACTIONS(3986),
    [anon_sym_or] = ACTIONS(3984),
    [anon_sym_and] = ACTIONS(3984),
    [anon_sym_bitor] = ACTIONS(3984),
    [anon_sym_xor] = ACTIONS(3984),
    [anon_sym_bitand] = ACTIONS(3984),
    [anon_sym_not_eq] = ACTIONS(3984),
    [anon_sym_DASH_DASH] = ACTIONS(3986),
    [anon_sym_PLUS_PLUS] = ACTIONS(3986),
    [anon_sym_DOT] = ACTIONS(3984),
    [anon_sym_DOT_STAR] = ACTIONS(3986),
    [anon_sym_DASH_GT] = ACTIONS(3986),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3984),
    [anon_sym_decltype] = ACTIONS(3984),
    [anon_sym_final] = ACTIONS(3984),
    [anon_sym_override] = ACTIONS(3984),
    [anon_sym_requires] = ACTIONS(3984),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3986),
  },
  [1862] = {
    [sym_template_argument_list] = STATE(1997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4004),
    [anon_sym_COMMA] = ACTIONS(4004),
    [anon_sym_LPAREN2] = ACTIONS(4004),
    [anon_sym_DASH] = ACTIONS(4009),
    [anon_sym_PLUS] = ACTIONS(4009),
    [anon_sym_STAR] = ACTIONS(4011),
    [anon_sym_SLASH] = ACTIONS(4009),
    [anon_sym_PERCENT] = ACTIONS(4009),
    [anon_sym_PIPE_PIPE] = ACTIONS(4002),
    [anon_sym_AMP_AMP] = ACTIONS(4004),
    [anon_sym_PIPE] = ACTIONS(4009),
    [anon_sym_CARET] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4011),
    [anon_sym_EQ_EQ] = ACTIONS(4002),
    [anon_sym_BANG_EQ] = ACTIONS(4002),
    [anon_sym_GT] = ACTIONS(4009),
    [anon_sym_GT_EQ] = ACTIONS(4009),
    [anon_sym_LT_EQ] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(5200),
    [anon_sym_LT_LT] = ACTIONS(4009),
    [anon_sym_GT_GT] = ACTIONS(4009),
    [anon_sym___extension__] = ACTIONS(4007),
    [anon_sym___global__] = ACTIONS(4007),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4004),
    [anon_sym_EQ] = ACTIONS(4009),
    [anon_sym_const] = ACTIONS(4000),
    [anon_sym_constexpr] = ACTIONS(4007),
    [anon_sym_volatile] = ACTIONS(4007),
    [anon_sym_restrict] = ACTIONS(4007),
    [anon_sym___restrict__] = ACTIONS(4007),
    [anon_sym__Atomic] = ACTIONS(4007),
    [anon_sym__Noreturn] = ACTIONS(4007),
    [anon_sym_noreturn] = ACTIONS(4007),
    [anon_sym_mutable] = ACTIONS(4007),
    [anon_sym_constinit] = ACTIONS(4007),
    [anon_sym_consteval] = ACTIONS(4007),
    [anon_sym___shared__] = ACTIONS(4007),
    [anon_sym___local__] = ACTIONS(4007),
    [anon_sym___constant__] = ACTIONS(4007),
    [anon_sym___managed__] = ACTIONS(4007),
    [anon_sym___grid_constant__] = ACTIONS(4007),
    [anon_sym_alignas] = ACTIONS(4007),
    [anon_sym__Alignas] = ACTIONS(4007),
    [anon_sym_QMARK] = ACTIONS(4002),
    [anon_sym_STAR_EQ] = ACTIONS(4002),
    [anon_sym_SLASH_EQ] = ACTIONS(4002),
    [anon_sym_PERCENT_EQ] = ACTIONS(4002),
    [anon_sym_PLUS_EQ] = ACTIONS(4002),
    [anon_sym_DASH_EQ] = ACTIONS(4002),
    [anon_sym_LT_LT_EQ] = ACTIONS(4002),
    [anon_sym_GT_GT_EQ] = ACTIONS(4009),
    [anon_sym_AMP_EQ] = ACTIONS(4002),
    [anon_sym_CARET_EQ] = ACTIONS(4002),
    [anon_sym_PIPE_EQ] = ACTIONS(4002),
    [anon_sym_and_eq] = ACTIONS(4002),
    [anon_sym_or_eq] = ACTIONS(4002),
    [anon_sym_xor_eq] = ACTIONS(4002),
    [anon_sym_LT_EQ_GT] = ACTIONS(4002),
    [anon_sym_or] = ACTIONS(4009),
    [anon_sym_and] = ACTIONS(4009),
    [anon_sym_bitor] = ACTIONS(4002),
    [anon_sym_xor] = ACTIONS(4009),
    [anon_sym_bitand] = ACTIONS(4002),
    [anon_sym_not_eq] = ACTIONS(4002),
    [anon_sym_DASH_DASH] = ACTIONS(4002),
    [anon_sym_PLUS_PLUS] = ACTIONS(4002),
    [anon_sym_DOT] = ACTIONS(4009),
    [anon_sym_DOT_STAR] = ACTIONS(4002),
    [anon_sym_DASH_GT] = ACTIONS(4002),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4007),
    [anon_sym_decltype] = ACTIONS(4007),
    [anon_sym_GT2] = ACTIONS(4004),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4002),
  },
  [1863] = {
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3994),
    [anon_sym_COMMA] = ACTIONS(3994),
    [anon_sym_RPAREN] = ACTIONS(3994),
    [anon_sym_LPAREN2] = ACTIONS(3994),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_STAR] = ACTIONS(3994),
    [anon_sym_SLASH] = ACTIONS(3992),
    [anon_sym_PERCENT] = ACTIONS(3994),
    [anon_sym_PIPE_PIPE] = ACTIONS(3994),
    [anon_sym_AMP_AMP] = ACTIONS(3994),
    [anon_sym_PIPE] = ACTIONS(3992),
    [anon_sym_CARET] = ACTIONS(3994),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym_EQ_EQ] = ACTIONS(3994),
    [anon_sym_BANG_EQ] = ACTIONS(3994),
    [anon_sym_GT] = ACTIONS(3992),
    [anon_sym_GT_EQ] = ACTIONS(3994),
    [anon_sym_LT_EQ] = ACTIONS(3992),
    [anon_sym_LT] = ACTIONS(3992),
    [anon_sym_LT_LT] = ACTIONS(3992),
    [anon_sym_GT_GT] = ACTIONS(3994),
    [anon_sym_SEMI] = ACTIONS(3994),
    [anon_sym___extension__] = ACTIONS(3992),
    [anon_sym___global__] = ACTIONS(3992),
    [anon_sym___attribute__] = ACTIONS(3992),
    [anon_sym_COLON_COLON] = ACTIONS(3994),
    [anon_sym___based] = ACTIONS(3992),
    [anon_sym_LBRACE] = ACTIONS(3994),
    [anon_sym_RBRACE] = ACTIONS(3994),
    [anon_sym_signed] = ACTIONS(3992),
    [anon_sym_unsigned] = ACTIONS(3992),
    [anon_sym_long] = ACTIONS(3992),
    [anon_sym_short] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_RBRACK] = ACTIONS(3994),
    [anon_sym_const] = ACTIONS(3992),
    [anon_sym_constexpr] = ACTIONS(3992),
    [anon_sym_volatile] = ACTIONS(3992),
    [anon_sym_restrict] = ACTIONS(3992),
    [anon_sym___restrict__] = ACTIONS(3992),
    [anon_sym__Atomic] = ACTIONS(3992),
    [anon_sym__Noreturn] = ACTIONS(3992),
    [anon_sym_noreturn] = ACTIONS(3992),
    [anon_sym_mutable] = ACTIONS(3992),
    [anon_sym_constinit] = ACTIONS(3992),
    [anon_sym_consteval] = ACTIONS(3992),
    [anon_sym___shared__] = ACTIONS(3992),
    [anon_sym___local__] = ACTIONS(3992),
    [anon_sym___constant__] = ACTIONS(3992),
    [anon_sym___managed__] = ACTIONS(3992),
    [anon_sym___grid_constant__] = ACTIONS(3992),
    [anon_sym_alignas] = ACTIONS(3992),
    [anon_sym__Alignas] = ACTIONS(3992),
    [sym_primitive_type] = ACTIONS(3992),
    [anon_sym_COLON] = ACTIONS(3992),
    [anon_sym_QMARK] = ACTIONS(3994),
    [anon_sym_LT_EQ_GT] = ACTIONS(3994),
    [anon_sym_or] = ACTIONS(3992),
    [anon_sym_and] = ACTIONS(3992),
    [anon_sym_bitor] = ACTIONS(3992),
    [anon_sym_xor] = ACTIONS(3992),
    [anon_sym_bitand] = ACTIONS(3992),
    [anon_sym_not_eq] = ACTIONS(3992),
    [anon_sym_DASH_DASH] = ACTIONS(3994),
    [anon_sym_PLUS_PLUS] = ACTIONS(3994),
    [anon_sym_DOT] = ACTIONS(3992),
    [anon_sym_DOT_STAR] = ACTIONS(3994),
    [anon_sym_DASH_GT] = ACTIONS(3994),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3992),
    [anon_sym_decltype] = ACTIONS(3992),
    [anon_sym_final] = ACTIONS(3992),
    [anon_sym_override] = ACTIONS(3992),
    [anon_sym_requires] = ACTIONS(3992),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3994),
  },
  [1864] = {
    [sym_identifier] = ACTIONS(5203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5205),
    [anon_sym_COMMA] = ACTIONS(5205),
    [anon_sym_RPAREN] = ACTIONS(5205),
    [anon_sym_LPAREN2] = ACTIONS(5205),
    [anon_sym_DASH] = ACTIONS(5203),
    [anon_sym_PLUS] = ACTIONS(5203),
    [anon_sym_STAR] = ACTIONS(5205),
    [anon_sym_SLASH] = ACTIONS(5203),
    [anon_sym_PERCENT] = ACTIONS(5205),
    [anon_sym_PIPE_PIPE] = ACTIONS(5205),
    [anon_sym_AMP_AMP] = ACTIONS(5205),
    [anon_sym_PIPE] = ACTIONS(5203),
    [anon_sym_CARET] = ACTIONS(5205),
    [anon_sym_AMP] = ACTIONS(5203),
    [anon_sym_EQ_EQ] = ACTIONS(5205),
    [anon_sym_BANG_EQ] = ACTIONS(5205),
    [anon_sym_GT] = ACTIONS(5203),
    [anon_sym_GT_EQ] = ACTIONS(5205),
    [anon_sym_LT_EQ] = ACTIONS(5203),
    [anon_sym_LT] = ACTIONS(5203),
    [anon_sym_LT_LT] = ACTIONS(5203),
    [anon_sym_GT_GT] = ACTIONS(5205),
    [anon_sym_SEMI] = ACTIONS(5205),
    [anon_sym___extension__] = ACTIONS(5203),
    [anon_sym___global__] = ACTIONS(5203),
    [anon_sym___attribute__] = ACTIONS(5203),
    [anon_sym_COLON_COLON] = ACTIONS(5205),
    [anon_sym___based] = ACTIONS(5203),
    [anon_sym_LBRACE] = ACTIONS(5205),
    [anon_sym_RBRACE] = ACTIONS(5205),
    [anon_sym_signed] = ACTIONS(5203),
    [anon_sym_unsigned] = ACTIONS(5203),
    [anon_sym_long] = ACTIONS(5203),
    [anon_sym_short] = ACTIONS(5203),
    [anon_sym_LBRACK] = ACTIONS(5205),
    [anon_sym_RBRACK] = ACTIONS(5205),
    [anon_sym_const] = ACTIONS(5203),
    [anon_sym_constexpr] = ACTIONS(5203),
    [anon_sym_volatile] = ACTIONS(5203),
    [anon_sym_restrict] = ACTIONS(5203),
    [anon_sym___restrict__] = ACTIONS(5203),
    [anon_sym__Atomic] = ACTIONS(5203),
    [anon_sym__Noreturn] = ACTIONS(5203),
    [anon_sym_noreturn] = ACTIONS(5203),
    [anon_sym_mutable] = ACTIONS(5203),
    [anon_sym_constinit] = ACTIONS(5203),
    [anon_sym_consteval] = ACTIONS(5203),
    [anon_sym___shared__] = ACTIONS(5203),
    [anon_sym___local__] = ACTIONS(5203),
    [anon_sym___constant__] = ACTIONS(5203),
    [anon_sym___managed__] = ACTIONS(5203),
    [anon_sym___grid_constant__] = ACTIONS(5203),
    [anon_sym_alignas] = ACTIONS(5203),
    [anon_sym__Alignas] = ACTIONS(5203),
    [sym_primitive_type] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5203),
    [anon_sym_QMARK] = ACTIONS(5205),
    [anon_sym_LT_EQ_GT] = ACTIONS(5205),
    [anon_sym_or] = ACTIONS(5203),
    [anon_sym_and] = ACTIONS(5203),
    [anon_sym_bitor] = ACTIONS(5203),
    [anon_sym_xor] = ACTIONS(5203),
    [anon_sym_bitand] = ACTIONS(5203),
    [anon_sym_not_eq] = ACTIONS(5203),
    [anon_sym_DASH_DASH] = ACTIONS(5205),
    [anon_sym_PLUS_PLUS] = ACTIONS(5205),
    [anon_sym_DOT] = ACTIONS(5203),
    [anon_sym_DOT_STAR] = ACTIONS(5205),
    [anon_sym_DASH_GT] = ACTIONS(5205),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5203),
    [anon_sym_decltype] = ACTIONS(5203),
    [anon_sym_final] = ACTIONS(5203),
    [anon_sym_override] = ACTIONS(5203),
    [anon_sym_requires] = ACTIONS(5203),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5205),
  },
  [1865] = {
    [sym_identifier] = ACTIONS(1901),
    [aux_sym_preproc_def_token1] = ACTIONS(1901),
    [aux_sym_preproc_if_token1] = ACTIONS(1901),
    [aux_sym_preproc_if_token2] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1901),
    [sym_preproc_directive] = ACTIONS(1901),
    [anon_sym_LPAREN2] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_STAR] = ACTIONS(1899),
    [anon_sym_AMP_AMP] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1901),
    [anon_sym___extension__] = ACTIONS(1901),
    [anon_sym_typedef] = ACTIONS(1901),
    [anon_sym___device__] = ACTIONS(1901),
    [anon_sym___host__] = ACTIONS(1901),
    [anon_sym___global__] = ACTIONS(1901),
    [anon_sym___forceinline__] = ACTIONS(1901),
    [anon_sym___noinline__] = ACTIONS(1901),
    [anon_sym_extern] = ACTIONS(1901),
    [anon_sym___attribute__] = ACTIONS(1901),
    [anon_sym_COLON_COLON] = ACTIONS(1899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1899),
    [anon_sym___declspec] = ACTIONS(1901),
    [anon_sym___based] = ACTIONS(1901),
    [anon_sym_signed] = ACTIONS(1901),
    [anon_sym_unsigned] = ACTIONS(1901),
    [anon_sym_long] = ACTIONS(1901),
    [anon_sym_short] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1901),
    [anon_sym_static] = ACTIONS(1901),
    [anon_sym_register] = ACTIONS(1901),
    [anon_sym_inline] = ACTIONS(1901),
    [anon_sym___inline] = ACTIONS(1901),
    [anon_sym___inline__] = ACTIONS(1901),
    [anon_sym___forceinline] = ACTIONS(1901),
    [anon_sym_thread_local] = ACTIONS(1901),
    [anon_sym___thread] = ACTIONS(1901),
    [anon_sym_const] = ACTIONS(1901),
    [anon_sym_constexpr] = ACTIONS(1901),
    [anon_sym_volatile] = ACTIONS(1901),
    [anon_sym_restrict] = ACTIONS(1901),
    [anon_sym___restrict__] = ACTIONS(1901),
    [anon_sym__Atomic] = ACTIONS(1901),
    [anon_sym__Noreturn] = ACTIONS(1901),
    [anon_sym_noreturn] = ACTIONS(1901),
    [anon_sym_mutable] = ACTIONS(1901),
    [anon_sym_constinit] = ACTIONS(1901),
    [anon_sym_consteval] = ACTIONS(1901),
    [anon_sym___shared__] = ACTIONS(1901),
    [anon_sym___local__] = ACTIONS(1901),
    [anon_sym___constant__] = ACTIONS(1901),
    [anon_sym___managed__] = ACTIONS(1901),
    [anon_sym___grid_constant__] = ACTIONS(1901),
    [anon_sym_alignas] = ACTIONS(1901),
    [anon_sym__Alignas] = ACTIONS(1901),
    [sym_primitive_type] = ACTIONS(1901),
    [anon_sym_enum] = ACTIONS(1901),
    [anon_sym_class] = ACTIONS(1901),
    [anon_sym_struct] = ACTIONS(1901),
    [anon_sym_union] = ACTIONS(1901),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1901),
    [anon_sym_decltype] = ACTIONS(1901),
    [sym_virtual] = ACTIONS(1901),
    [anon_sym_explicit] = ACTIONS(1901),
    [anon_sym_typename] = ACTIONS(1901),
    [anon_sym_template] = ACTIONS(1901),
    [anon_sym_operator] = ACTIONS(1901),
    [anon_sym_friend] = ACTIONS(1901),
    [anon_sym_public] = ACTIONS(1901),
    [anon_sym_private] = ACTIONS(1901),
    [anon_sym_protected] = ACTIONS(1901),
    [anon_sym_using] = ACTIONS(1901),
    [anon_sym_static_assert] = ACTIONS(1901),
    [anon_sym_catch] = ACTIONS(1901),
    [anon_sym___launch_bounds__] = ACTIONS(1901),
  },
  [1866] = {
    [sym_identifier] = ACTIONS(3988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3990),
    [anon_sym_COMMA] = ACTIONS(3990),
    [anon_sym_RPAREN] = ACTIONS(3990),
    [anon_sym_LPAREN2] = ACTIONS(3990),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_STAR] = ACTIONS(3990),
    [anon_sym_SLASH] = ACTIONS(3988),
    [anon_sym_PERCENT] = ACTIONS(3990),
    [anon_sym_PIPE_PIPE] = ACTIONS(3990),
    [anon_sym_AMP_AMP] = ACTIONS(3990),
    [anon_sym_PIPE] = ACTIONS(3988),
    [anon_sym_CARET] = ACTIONS(3990),
    [anon_sym_AMP] = ACTIONS(3988),
    [anon_sym_EQ_EQ] = ACTIONS(3990),
    [anon_sym_BANG_EQ] = ACTIONS(3990),
    [anon_sym_GT] = ACTIONS(3988),
    [anon_sym_GT_EQ] = ACTIONS(3990),
    [anon_sym_LT_EQ] = ACTIONS(3988),
    [anon_sym_LT] = ACTIONS(3988),
    [anon_sym_LT_LT] = ACTIONS(3988),
    [anon_sym_GT_GT] = ACTIONS(3990),
    [anon_sym_SEMI] = ACTIONS(3990),
    [anon_sym___extension__] = ACTIONS(3988),
    [anon_sym___global__] = ACTIONS(3988),
    [anon_sym___attribute__] = ACTIONS(3988),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [anon_sym___based] = ACTIONS(3988),
    [anon_sym_LBRACE] = ACTIONS(3990),
    [anon_sym_RBRACE] = ACTIONS(3990),
    [anon_sym_signed] = ACTIONS(3988),
    [anon_sym_unsigned] = ACTIONS(3988),
    [anon_sym_long] = ACTIONS(3988),
    [anon_sym_short] = ACTIONS(3988),
    [anon_sym_LBRACK] = ACTIONS(3990),
    [anon_sym_RBRACK] = ACTIONS(3990),
    [anon_sym_const] = ACTIONS(3988),
    [anon_sym_constexpr] = ACTIONS(3988),
    [anon_sym_volatile] = ACTIONS(3988),
    [anon_sym_restrict] = ACTIONS(3988),
    [anon_sym___restrict__] = ACTIONS(3988),
    [anon_sym__Atomic] = ACTIONS(3988),
    [anon_sym__Noreturn] = ACTIONS(3988),
    [anon_sym_noreturn] = ACTIONS(3988),
    [anon_sym_mutable] = ACTIONS(3988),
    [anon_sym_constinit] = ACTIONS(3988),
    [anon_sym_consteval] = ACTIONS(3988),
    [anon_sym___shared__] = ACTIONS(3988),
    [anon_sym___local__] = ACTIONS(3988),
    [anon_sym___constant__] = ACTIONS(3988),
    [anon_sym___managed__] = ACTIONS(3988),
    [anon_sym___grid_constant__] = ACTIONS(3988),
    [anon_sym_alignas] = ACTIONS(3988),
    [anon_sym__Alignas] = ACTIONS(3988),
    [sym_primitive_type] = ACTIONS(3988),
    [anon_sym_COLON] = ACTIONS(3988),
    [anon_sym_QMARK] = ACTIONS(3990),
    [anon_sym_LT_EQ_GT] = ACTIONS(3990),
    [anon_sym_or] = ACTIONS(3988),
    [anon_sym_and] = ACTIONS(3988),
    [anon_sym_bitor] = ACTIONS(3988),
    [anon_sym_xor] = ACTIONS(3988),
    [anon_sym_bitand] = ACTIONS(3988),
    [anon_sym_not_eq] = ACTIONS(3988),
    [anon_sym_DASH_DASH] = ACTIONS(3990),
    [anon_sym_PLUS_PLUS] = ACTIONS(3990),
    [anon_sym_DOT] = ACTIONS(3988),
    [anon_sym_DOT_STAR] = ACTIONS(3990),
    [anon_sym_DASH_GT] = ACTIONS(3990),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3988),
    [anon_sym_decltype] = ACTIONS(3988),
    [anon_sym_final] = ACTIONS(3988),
    [anon_sym_override] = ACTIONS(3988),
    [anon_sym_requires] = ACTIONS(3988),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3990),
  },
  [1867] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1867),
    [sym_identifier] = ACTIONS(5016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5018),
    [anon_sym_COMMA] = ACTIONS(5018),
    [anon_sym_RPAREN] = ACTIONS(5018),
    [anon_sym_LPAREN2] = ACTIONS(5018),
    [anon_sym_TILDE] = ACTIONS(5018),
    [anon_sym_STAR] = ACTIONS(5018),
    [anon_sym_AMP_AMP] = ACTIONS(5018),
    [anon_sym_AMP] = ACTIONS(5016),
    [anon_sym_SEMI] = ACTIONS(5018),
    [anon_sym___extension__] = ACTIONS(5016),
    [anon_sym___device__] = ACTIONS(5016),
    [anon_sym___host__] = ACTIONS(5016),
    [anon_sym___global__] = ACTIONS(5016),
    [anon_sym___forceinline__] = ACTIONS(5016),
    [anon_sym___noinline__] = ACTIONS(5016),
    [anon_sym_extern] = ACTIONS(5016),
    [anon_sym___attribute__] = ACTIONS(5016),
    [anon_sym_COLON_COLON] = ACTIONS(5018),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5018),
    [anon_sym___declspec] = ACTIONS(5016),
    [anon_sym___based] = ACTIONS(5016),
    [anon_sym___cdecl] = ACTIONS(5016),
    [anon_sym___clrcall] = ACTIONS(5016),
    [anon_sym___stdcall] = ACTIONS(5016),
    [anon_sym___fastcall] = ACTIONS(5016),
    [anon_sym___thiscall] = ACTIONS(5016),
    [anon_sym___vectorcall] = ACTIONS(5016),
    [anon_sym_LBRACE] = ACTIONS(5018),
    [anon_sym_signed] = ACTIONS(5207),
    [anon_sym_unsigned] = ACTIONS(5207),
    [anon_sym_long] = ACTIONS(5207),
    [anon_sym_short] = ACTIONS(5207),
    [anon_sym_LBRACK] = ACTIONS(5016),
    [anon_sym_static] = ACTIONS(5016),
    [anon_sym_EQ] = ACTIONS(5018),
    [anon_sym_register] = ACTIONS(5016),
    [anon_sym_inline] = ACTIONS(5016),
    [anon_sym___inline] = ACTIONS(5016),
    [anon_sym___inline__] = ACTIONS(5016),
    [anon_sym___forceinline] = ACTIONS(5016),
    [anon_sym_thread_local] = ACTIONS(5016),
    [anon_sym___thread] = ACTIONS(5016),
    [anon_sym_const] = ACTIONS(5016),
    [anon_sym_constexpr] = ACTIONS(5016),
    [anon_sym_volatile] = ACTIONS(5016),
    [anon_sym_restrict] = ACTIONS(5016),
    [anon_sym___restrict__] = ACTIONS(5016),
    [anon_sym__Atomic] = ACTIONS(5016),
    [anon_sym__Noreturn] = ACTIONS(5016),
    [anon_sym_noreturn] = ACTIONS(5016),
    [anon_sym_mutable] = ACTIONS(5016),
    [anon_sym_constinit] = ACTIONS(5016),
    [anon_sym_consteval] = ACTIONS(5016),
    [anon_sym___shared__] = ACTIONS(5016),
    [anon_sym___local__] = ACTIONS(5016),
    [anon_sym___constant__] = ACTIONS(5016),
    [anon_sym___managed__] = ACTIONS(5016),
    [anon_sym___grid_constant__] = ACTIONS(5016),
    [anon_sym_alignas] = ACTIONS(5016),
    [anon_sym__Alignas] = ACTIONS(5016),
    [sym_primitive_type] = ACTIONS(5016),
    [anon_sym_asm] = ACTIONS(5016),
    [anon_sym___asm__] = ACTIONS(5016),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5016),
    [anon_sym_decltype] = ACTIONS(5016),
    [anon_sym_final] = ACTIONS(5016),
    [anon_sym_override] = ACTIONS(5016),
    [sym_virtual] = ACTIONS(5016),
    [anon_sym_template] = ACTIONS(5016),
    [anon_sym_GT2] = ACTIONS(5018),
    [anon_sym_operator] = ACTIONS(5016),
    [anon_sym_try] = ACTIONS(5016),
    [anon_sym_requires] = ACTIONS(5016),
    [anon_sym___launch_bounds__] = ACTIONS(5016),
  },
  [1868] = {
    [sym_template_argument_list] = STATE(1651),
    [sym_identifier] = ACTIONS(4000),
    [anon_sym_LPAREN2] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_STAR] = ACTIONS(4007),
    [anon_sym_PIPE_PIPE] = ACTIONS(4007),
    [anon_sym_AMP_AMP] = ACTIONS(4007),
    [anon_sym_AMP] = ACTIONS(4000),
    [anon_sym_LT] = ACTIONS(5210),
    [anon_sym___extension__] = ACTIONS(4000),
    [anon_sym___device__] = ACTIONS(4000),
    [anon_sym___host__] = ACTIONS(4000),
    [anon_sym___global__] = ACTIONS(4000),
    [anon_sym___forceinline__] = ACTIONS(4000),
    [anon_sym___noinline__] = ACTIONS(4000),
    [anon_sym_extern] = ACTIONS(4000),
    [anon_sym___attribute__] = ACTIONS(4000),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4007),
    [anon_sym___declspec] = ACTIONS(4000),
    [anon_sym___based] = ACTIONS(4000),
    [anon_sym___cdecl] = ACTIONS(4000),
    [anon_sym___clrcall] = ACTIONS(4000),
    [anon_sym___stdcall] = ACTIONS(4000),
    [anon_sym___fastcall] = ACTIONS(4000),
    [anon_sym___thiscall] = ACTIONS(4000),
    [anon_sym___vectorcall] = ACTIONS(4000),
    [anon_sym_signed] = ACTIONS(4000),
    [anon_sym_unsigned] = ACTIONS(4000),
    [anon_sym_long] = ACTIONS(4000),
    [anon_sym_short] = ACTIONS(4000),
    [anon_sym_LBRACK] = ACTIONS(4000),
    [anon_sym_static] = ACTIONS(4000),
    [anon_sym_register] = ACTIONS(4000),
    [anon_sym_inline] = ACTIONS(4000),
    [anon_sym___inline] = ACTIONS(4000),
    [anon_sym___inline__] = ACTIONS(4000),
    [anon_sym___forceinline] = ACTIONS(4000),
    [anon_sym_thread_local] = ACTIONS(4000),
    [anon_sym___thread] = ACTIONS(4000),
    [anon_sym_const] = ACTIONS(4000),
    [anon_sym_constexpr] = ACTIONS(4000),
    [anon_sym_volatile] = ACTIONS(4000),
    [anon_sym_restrict] = ACTIONS(4000),
    [anon_sym___restrict__] = ACTIONS(4000),
    [anon_sym__Atomic] = ACTIONS(4000),
    [anon_sym__Noreturn] = ACTIONS(4000),
    [anon_sym_noreturn] = ACTIONS(4000),
    [anon_sym_mutable] = ACTIONS(4000),
    [anon_sym_constinit] = ACTIONS(4000),
    [anon_sym_consteval] = ACTIONS(4000),
    [anon_sym___shared__] = ACTIONS(4000),
    [anon_sym___local__] = ACTIONS(4000),
    [anon_sym___constant__] = ACTIONS(4000),
    [anon_sym___managed__] = ACTIONS(4000),
    [anon_sym___grid_constant__] = ACTIONS(4000),
    [anon_sym_alignas] = ACTIONS(4000),
    [anon_sym__Alignas] = ACTIONS(4000),
    [sym_primitive_type] = ACTIONS(4000),
    [anon_sym_enum] = ACTIONS(4000),
    [anon_sym_class] = ACTIONS(4000),
    [anon_sym_struct] = ACTIONS(4000),
    [anon_sym_union] = ACTIONS(4000),
    [anon_sym_or] = ACTIONS(4000),
    [anon_sym_and] = ACTIONS(4000),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4000),
    [anon_sym_decltype] = ACTIONS(4000),
    [sym_virtual] = ACTIONS(4000),
    [anon_sym_explicit] = ACTIONS(4000),
    [anon_sym_typename] = ACTIONS(4000),
    [anon_sym_template] = ACTIONS(4000),
    [anon_sym_operator] = ACTIONS(4000),
    [anon_sym_friend] = ACTIONS(4000),
    [anon_sym_using] = ACTIONS(4000),
    [anon_sym_concept] = ACTIONS(4000),
    [anon_sym___launch_bounds__] = ACTIONS(4000),
  },
  [1869] = {
    [sym_identifier] = ACTIONS(1897),
    [aux_sym_preproc_def_token1] = ACTIONS(1897),
    [aux_sym_preproc_if_token1] = ACTIONS(1897),
    [aux_sym_preproc_if_token2] = ACTIONS(1897),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1897),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1897),
    [sym_preproc_directive] = ACTIONS(1897),
    [anon_sym_LPAREN2] = ACTIONS(1895),
    [anon_sym_TILDE] = ACTIONS(1895),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_AMP_AMP] = ACTIONS(1895),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym___extension__] = ACTIONS(1897),
    [anon_sym_typedef] = ACTIONS(1897),
    [anon_sym___device__] = ACTIONS(1897),
    [anon_sym___host__] = ACTIONS(1897),
    [anon_sym___global__] = ACTIONS(1897),
    [anon_sym___forceinline__] = ACTIONS(1897),
    [anon_sym___noinline__] = ACTIONS(1897),
    [anon_sym_extern] = ACTIONS(1897),
    [anon_sym___attribute__] = ACTIONS(1897),
    [anon_sym_COLON_COLON] = ACTIONS(1895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1895),
    [anon_sym___declspec] = ACTIONS(1897),
    [anon_sym___based] = ACTIONS(1897),
    [anon_sym_signed] = ACTIONS(1897),
    [anon_sym_unsigned] = ACTIONS(1897),
    [anon_sym_long] = ACTIONS(1897),
    [anon_sym_short] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1897),
    [anon_sym_static] = ACTIONS(1897),
    [anon_sym_register] = ACTIONS(1897),
    [anon_sym_inline] = ACTIONS(1897),
    [anon_sym___inline] = ACTIONS(1897),
    [anon_sym___inline__] = ACTIONS(1897),
    [anon_sym___forceinline] = ACTIONS(1897),
    [anon_sym_thread_local] = ACTIONS(1897),
    [anon_sym___thread] = ACTIONS(1897),
    [anon_sym_const] = ACTIONS(1897),
    [anon_sym_constexpr] = ACTIONS(1897),
    [anon_sym_volatile] = ACTIONS(1897),
    [anon_sym_restrict] = ACTIONS(1897),
    [anon_sym___restrict__] = ACTIONS(1897),
    [anon_sym__Atomic] = ACTIONS(1897),
    [anon_sym__Noreturn] = ACTIONS(1897),
    [anon_sym_noreturn] = ACTIONS(1897),
    [anon_sym_mutable] = ACTIONS(1897),
    [anon_sym_constinit] = ACTIONS(1897),
    [anon_sym_consteval] = ACTIONS(1897),
    [anon_sym___shared__] = ACTIONS(1897),
    [anon_sym___local__] = ACTIONS(1897),
    [anon_sym___constant__] = ACTIONS(1897),
    [anon_sym___managed__] = ACTIONS(1897),
    [anon_sym___grid_constant__] = ACTIONS(1897),
    [anon_sym_alignas] = ACTIONS(1897),
    [anon_sym__Alignas] = ACTIONS(1897),
    [sym_primitive_type] = ACTIONS(1897),
    [anon_sym_enum] = ACTIONS(1897),
    [anon_sym_class] = ACTIONS(1897),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1897),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1897),
    [anon_sym_decltype] = ACTIONS(1897),
    [sym_virtual] = ACTIONS(1897),
    [anon_sym_explicit] = ACTIONS(1897),
    [anon_sym_typename] = ACTIONS(1897),
    [anon_sym_template] = ACTIONS(1897),
    [anon_sym_operator] = ACTIONS(1897),
    [anon_sym_friend] = ACTIONS(1897),
    [anon_sym_public] = ACTIONS(1897),
    [anon_sym_private] = ACTIONS(1897),
    [anon_sym_protected] = ACTIONS(1897),
    [anon_sym_using] = ACTIONS(1897),
    [anon_sym_static_assert] = ACTIONS(1897),
    [anon_sym_catch] = ACTIONS(1897),
    [anon_sym___launch_bounds__] = ACTIONS(1897),
  },
  [1870] = {
    [sym_identifier] = ACTIONS(1897),
    [aux_sym_preproc_def_token1] = ACTIONS(1897),
    [aux_sym_preproc_if_token1] = ACTIONS(1897),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1897),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1897),
    [sym_preproc_directive] = ACTIONS(1897),
    [anon_sym_LPAREN2] = ACTIONS(1895),
    [anon_sym_TILDE] = ACTIONS(1895),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_AMP_AMP] = ACTIONS(1895),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym___extension__] = ACTIONS(1897),
    [anon_sym_typedef] = ACTIONS(1897),
    [anon_sym___device__] = ACTIONS(1897),
    [anon_sym___host__] = ACTIONS(1897),
    [anon_sym___global__] = ACTIONS(1897),
    [anon_sym___forceinline__] = ACTIONS(1897),
    [anon_sym___noinline__] = ACTIONS(1897),
    [anon_sym_extern] = ACTIONS(1897),
    [anon_sym___attribute__] = ACTIONS(1897),
    [anon_sym_COLON_COLON] = ACTIONS(1895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1895),
    [anon_sym___declspec] = ACTIONS(1897),
    [anon_sym___based] = ACTIONS(1897),
    [anon_sym_RBRACE] = ACTIONS(1895),
    [anon_sym_signed] = ACTIONS(1897),
    [anon_sym_unsigned] = ACTIONS(1897),
    [anon_sym_long] = ACTIONS(1897),
    [anon_sym_short] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1897),
    [anon_sym_static] = ACTIONS(1897),
    [anon_sym_register] = ACTIONS(1897),
    [anon_sym_inline] = ACTIONS(1897),
    [anon_sym___inline] = ACTIONS(1897),
    [anon_sym___inline__] = ACTIONS(1897),
    [anon_sym___forceinline] = ACTIONS(1897),
    [anon_sym_thread_local] = ACTIONS(1897),
    [anon_sym___thread] = ACTIONS(1897),
    [anon_sym_const] = ACTIONS(1897),
    [anon_sym_constexpr] = ACTIONS(1897),
    [anon_sym_volatile] = ACTIONS(1897),
    [anon_sym_restrict] = ACTIONS(1897),
    [anon_sym___restrict__] = ACTIONS(1897),
    [anon_sym__Atomic] = ACTIONS(1897),
    [anon_sym__Noreturn] = ACTIONS(1897),
    [anon_sym_noreturn] = ACTIONS(1897),
    [anon_sym_mutable] = ACTIONS(1897),
    [anon_sym_constinit] = ACTIONS(1897),
    [anon_sym_consteval] = ACTIONS(1897),
    [anon_sym___shared__] = ACTIONS(1897),
    [anon_sym___local__] = ACTIONS(1897),
    [anon_sym___constant__] = ACTIONS(1897),
    [anon_sym___managed__] = ACTIONS(1897),
    [anon_sym___grid_constant__] = ACTIONS(1897),
    [anon_sym_alignas] = ACTIONS(1897),
    [anon_sym__Alignas] = ACTIONS(1897),
    [sym_primitive_type] = ACTIONS(1897),
    [anon_sym_enum] = ACTIONS(1897),
    [anon_sym_class] = ACTIONS(1897),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1897),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1897),
    [anon_sym_decltype] = ACTIONS(1897),
    [sym_virtual] = ACTIONS(1897),
    [anon_sym_explicit] = ACTIONS(1897),
    [anon_sym_typename] = ACTIONS(1897),
    [anon_sym_template] = ACTIONS(1897),
    [anon_sym_operator] = ACTIONS(1897),
    [anon_sym_friend] = ACTIONS(1897),
    [anon_sym_public] = ACTIONS(1897),
    [anon_sym_private] = ACTIONS(1897),
    [anon_sym_protected] = ACTIONS(1897),
    [anon_sym_using] = ACTIONS(1897),
    [anon_sym_static_assert] = ACTIONS(1897),
    [anon_sym_catch] = ACTIONS(1897),
    [anon_sym___launch_bounds__] = ACTIONS(1897),
  },
  [1871] = {
    [sym_template_argument_list] = STATE(1651),
    [sym_identifier] = ACTIONS(5212),
    [anon_sym_LPAREN2] = ACTIONS(3782),
    [anon_sym_TILDE] = ACTIONS(3782),
    [anon_sym_STAR] = ACTIONS(3782),
    [anon_sym_PIPE_PIPE] = ACTIONS(3782),
    [anon_sym_AMP_AMP] = ACTIONS(3782),
    [anon_sym_AMP] = ACTIONS(5212),
    [anon_sym_LT] = ACTIONS(5210),
    [anon_sym___extension__] = ACTIONS(5212),
    [anon_sym___device__] = ACTIONS(5212),
    [anon_sym___host__] = ACTIONS(5212),
    [anon_sym___global__] = ACTIONS(5212),
    [anon_sym___forceinline__] = ACTIONS(5212),
    [anon_sym___noinline__] = ACTIONS(5212),
    [anon_sym_extern] = ACTIONS(5212),
    [anon_sym___attribute__] = ACTIONS(5212),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3782),
    [anon_sym___declspec] = ACTIONS(5212),
    [anon_sym___based] = ACTIONS(5212),
    [anon_sym___cdecl] = ACTIONS(5212),
    [anon_sym___clrcall] = ACTIONS(5212),
    [anon_sym___stdcall] = ACTIONS(5212),
    [anon_sym___fastcall] = ACTIONS(5212),
    [anon_sym___thiscall] = ACTIONS(5212),
    [anon_sym___vectorcall] = ACTIONS(5212),
    [anon_sym_signed] = ACTIONS(5212),
    [anon_sym_unsigned] = ACTIONS(5212),
    [anon_sym_long] = ACTIONS(5212),
    [anon_sym_short] = ACTIONS(5212),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_static] = ACTIONS(5212),
    [anon_sym_register] = ACTIONS(5212),
    [anon_sym_inline] = ACTIONS(5212),
    [anon_sym___inline] = ACTIONS(5212),
    [anon_sym___inline__] = ACTIONS(5212),
    [anon_sym___forceinline] = ACTIONS(5212),
    [anon_sym_thread_local] = ACTIONS(5212),
    [anon_sym___thread] = ACTIONS(5212),
    [anon_sym_const] = ACTIONS(5212),
    [anon_sym_constexpr] = ACTIONS(5212),
    [anon_sym_volatile] = ACTIONS(5212),
    [anon_sym_restrict] = ACTIONS(5212),
    [anon_sym___restrict__] = ACTIONS(5212),
    [anon_sym__Atomic] = ACTIONS(5212),
    [anon_sym__Noreturn] = ACTIONS(5212),
    [anon_sym_noreturn] = ACTIONS(5212),
    [anon_sym_mutable] = ACTIONS(5212),
    [anon_sym_constinit] = ACTIONS(5212),
    [anon_sym_consteval] = ACTIONS(5212),
    [anon_sym___shared__] = ACTIONS(5212),
    [anon_sym___local__] = ACTIONS(5212),
    [anon_sym___constant__] = ACTIONS(5212),
    [anon_sym___managed__] = ACTIONS(5212),
    [anon_sym___grid_constant__] = ACTIONS(5212),
    [anon_sym_alignas] = ACTIONS(5212),
    [anon_sym__Alignas] = ACTIONS(5212),
    [sym_primitive_type] = ACTIONS(5212),
    [anon_sym_enum] = ACTIONS(5212),
    [anon_sym_class] = ACTIONS(5212),
    [anon_sym_struct] = ACTIONS(5212),
    [anon_sym_union] = ACTIONS(5212),
    [anon_sym_or] = ACTIONS(5212),
    [anon_sym_and] = ACTIONS(5212),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5212),
    [anon_sym_decltype] = ACTIONS(5212),
    [sym_virtual] = ACTIONS(5212),
    [anon_sym_explicit] = ACTIONS(5212),
    [anon_sym_typename] = ACTIONS(5212),
    [anon_sym_template] = ACTIONS(5212),
    [anon_sym_operator] = ACTIONS(5212),
    [anon_sym_friend] = ACTIONS(5212),
    [anon_sym_using] = ACTIONS(5212),
    [anon_sym_concept] = ACTIONS(5212),
    [anon_sym___launch_bounds__] = ACTIONS(5212),
  },
  [1872] = {
    [sym_identifier] = ACTIONS(1901),
    [aux_sym_preproc_def_token1] = ACTIONS(1901),
    [aux_sym_preproc_if_token1] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1901),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1901),
    [sym_preproc_directive] = ACTIONS(1901),
    [anon_sym_LPAREN2] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_STAR] = ACTIONS(1899),
    [anon_sym_AMP_AMP] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1901),
    [anon_sym___extension__] = ACTIONS(1901),
    [anon_sym_typedef] = ACTIONS(1901),
    [anon_sym___device__] = ACTIONS(1901),
    [anon_sym___host__] = ACTIONS(1901),
    [anon_sym___global__] = ACTIONS(1901),
    [anon_sym___forceinline__] = ACTIONS(1901),
    [anon_sym___noinline__] = ACTIONS(1901),
    [anon_sym_extern] = ACTIONS(1901),
    [anon_sym___attribute__] = ACTIONS(1901),
    [anon_sym_COLON_COLON] = ACTIONS(1899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1899),
    [anon_sym___declspec] = ACTIONS(1901),
    [anon_sym___based] = ACTIONS(1901),
    [anon_sym_RBRACE] = ACTIONS(1899),
    [anon_sym_signed] = ACTIONS(1901),
    [anon_sym_unsigned] = ACTIONS(1901),
    [anon_sym_long] = ACTIONS(1901),
    [anon_sym_short] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1901),
    [anon_sym_static] = ACTIONS(1901),
    [anon_sym_register] = ACTIONS(1901),
    [anon_sym_inline] = ACTIONS(1901),
    [anon_sym___inline] = ACTIONS(1901),
    [anon_sym___inline__] = ACTIONS(1901),
    [anon_sym___forceinline] = ACTIONS(1901),
    [anon_sym_thread_local] = ACTIONS(1901),
    [anon_sym___thread] = ACTIONS(1901),
    [anon_sym_const] = ACTIONS(1901),
    [anon_sym_constexpr] = ACTIONS(1901),
    [anon_sym_volatile] = ACTIONS(1901),
    [anon_sym_restrict] = ACTIONS(1901),
    [anon_sym___restrict__] = ACTIONS(1901),
    [anon_sym__Atomic] = ACTIONS(1901),
    [anon_sym__Noreturn] = ACTIONS(1901),
    [anon_sym_noreturn] = ACTIONS(1901),
    [anon_sym_mutable] = ACTIONS(1901),
    [anon_sym_constinit] = ACTIONS(1901),
    [anon_sym_consteval] = ACTIONS(1901),
    [anon_sym___shared__] = ACTIONS(1901),
    [anon_sym___local__] = ACTIONS(1901),
    [anon_sym___constant__] = ACTIONS(1901),
    [anon_sym___managed__] = ACTIONS(1901),
    [anon_sym___grid_constant__] = ACTIONS(1901),
    [anon_sym_alignas] = ACTIONS(1901),
    [anon_sym__Alignas] = ACTIONS(1901),
    [sym_primitive_type] = ACTIONS(1901),
    [anon_sym_enum] = ACTIONS(1901),
    [anon_sym_class] = ACTIONS(1901),
    [anon_sym_struct] = ACTIONS(1901),
    [anon_sym_union] = ACTIONS(1901),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1901),
    [anon_sym_decltype] = ACTIONS(1901),
    [sym_virtual] = ACTIONS(1901),
    [anon_sym_explicit] = ACTIONS(1901),
    [anon_sym_typename] = ACTIONS(1901),
    [anon_sym_template] = ACTIONS(1901),
    [anon_sym_operator] = ACTIONS(1901),
    [anon_sym_friend] = ACTIONS(1901),
    [anon_sym_public] = ACTIONS(1901),
    [anon_sym_private] = ACTIONS(1901),
    [anon_sym_protected] = ACTIONS(1901),
    [anon_sym_using] = ACTIONS(1901),
    [anon_sym_static_assert] = ACTIONS(1901),
    [anon_sym_catch] = ACTIONS(1901),
    [anon_sym___launch_bounds__] = ACTIONS(1901),
  },
  [1873] = {
    [sym_identifier] = ACTIONS(4017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4019),
    [anon_sym_COMMA] = ACTIONS(4019),
    [anon_sym_RPAREN] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(4019),
    [anon_sym_DASH] = ACTIONS(4017),
    [anon_sym_PLUS] = ACTIONS(4017),
    [anon_sym_STAR] = ACTIONS(4019),
    [anon_sym_SLASH] = ACTIONS(4017),
    [anon_sym_PERCENT] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE] = ACTIONS(4017),
    [anon_sym_CARET] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4017),
    [anon_sym_EQ_EQ] = ACTIONS(4019),
    [anon_sym_BANG_EQ] = ACTIONS(4019),
    [anon_sym_GT] = ACTIONS(4017),
    [anon_sym_GT_EQ] = ACTIONS(4019),
    [anon_sym_LT_EQ] = ACTIONS(4017),
    [anon_sym_LT] = ACTIONS(4017),
    [anon_sym_LT_LT] = ACTIONS(4017),
    [anon_sym_GT_GT] = ACTIONS(4019),
    [anon_sym_SEMI] = ACTIONS(4019),
    [anon_sym___extension__] = ACTIONS(4017),
    [anon_sym___global__] = ACTIONS(4017),
    [anon_sym___attribute__] = ACTIONS(4017),
    [anon_sym_COLON_COLON] = ACTIONS(4019),
    [anon_sym___based] = ACTIONS(4017),
    [anon_sym_LBRACE] = ACTIONS(4019),
    [anon_sym_RBRACE] = ACTIONS(4019),
    [anon_sym_signed] = ACTIONS(4017),
    [anon_sym_unsigned] = ACTIONS(4017),
    [anon_sym_long] = ACTIONS(4017),
    [anon_sym_short] = ACTIONS(4017),
    [anon_sym_LBRACK] = ACTIONS(4019),
    [anon_sym_RBRACK] = ACTIONS(4019),
    [anon_sym_const] = ACTIONS(4017),
    [anon_sym_constexpr] = ACTIONS(4017),
    [anon_sym_volatile] = ACTIONS(4017),
    [anon_sym_restrict] = ACTIONS(4017),
    [anon_sym___restrict__] = ACTIONS(4017),
    [anon_sym__Atomic] = ACTIONS(4017),
    [anon_sym__Noreturn] = ACTIONS(4017),
    [anon_sym_noreturn] = ACTIONS(4017),
    [anon_sym_mutable] = ACTIONS(4017),
    [anon_sym_constinit] = ACTIONS(4017),
    [anon_sym_consteval] = ACTIONS(4017),
    [anon_sym___shared__] = ACTIONS(4017),
    [anon_sym___local__] = ACTIONS(4017),
    [anon_sym___constant__] = ACTIONS(4017),
    [anon_sym___managed__] = ACTIONS(4017),
    [anon_sym___grid_constant__] = ACTIONS(4017),
    [anon_sym_alignas] = ACTIONS(4017),
    [anon_sym__Alignas] = ACTIONS(4017),
    [sym_primitive_type] = ACTIONS(4017),
    [anon_sym_COLON] = ACTIONS(4017),
    [anon_sym_QMARK] = ACTIONS(4019),
    [anon_sym_LT_EQ_GT] = ACTIONS(4019),
    [anon_sym_or] = ACTIONS(4017),
    [anon_sym_and] = ACTIONS(4017),
    [anon_sym_bitor] = ACTIONS(4017),
    [anon_sym_xor] = ACTIONS(4017),
    [anon_sym_bitand] = ACTIONS(4017),
    [anon_sym_not_eq] = ACTIONS(4017),
    [anon_sym_DASH_DASH] = ACTIONS(4019),
    [anon_sym_PLUS_PLUS] = ACTIONS(4019),
    [anon_sym_DOT] = ACTIONS(4017),
    [anon_sym_DOT_STAR] = ACTIONS(4019),
    [anon_sym_DASH_GT] = ACTIONS(4019),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4017),
    [anon_sym_decltype] = ACTIONS(4017),
    [anon_sym_final] = ACTIONS(4017),
    [anon_sym_override] = ACTIONS(4017),
    [anon_sym_requires] = ACTIONS(4017),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4019),
  },
  [1874] = {
    [sym_identifier] = ACTIONS(5214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5216),
    [anon_sym_COMMA] = ACTIONS(5216),
    [anon_sym_RPAREN] = ACTIONS(5216),
    [anon_sym_LPAREN2] = ACTIONS(5216),
    [anon_sym_DASH] = ACTIONS(5214),
    [anon_sym_PLUS] = ACTIONS(5214),
    [anon_sym_STAR] = ACTIONS(5216),
    [anon_sym_SLASH] = ACTIONS(5214),
    [anon_sym_PERCENT] = ACTIONS(5216),
    [anon_sym_PIPE_PIPE] = ACTIONS(5216),
    [anon_sym_AMP_AMP] = ACTIONS(5216),
    [anon_sym_PIPE] = ACTIONS(5214),
    [anon_sym_CARET] = ACTIONS(5216),
    [anon_sym_AMP] = ACTIONS(5214),
    [anon_sym_EQ_EQ] = ACTIONS(5216),
    [anon_sym_BANG_EQ] = ACTIONS(5216),
    [anon_sym_GT] = ACTIONS(5214),
    [anon_sym_GT_EQ] = ACTIONS(5216),
    [anon_sym_LT_EQ] = ACTIONS(5214),
    [anon_sym_LT] = ACTIONS(5214),
    [anon_sym_LT_LT] = ACTIONS(5214),
    [anon_sym_GT_GT] = ACTIONS(5216),
    [anon_sym_SEMI] = ACTIONS(5216),
    [anon_sym___extension__] = ACTIONS(5214),
    [anon_sym___global__] = ACTIONS(5214),
    [anon_sym___attribute__] = ACTIONS(5214),
    [anon_sym___based] = ACTIONS(5214),
    [anon_sym_LBRACE] = ACTIONS(5216),
    [anon_sym_RBRACE] = ACTIONS(5216),
    [anon_sym_signed] = ACTIONS(5214),
    [anon_sym_unsigned] = ACTIONS(5214),
    [anon_sym_long] = ACTIONS(5214),
    [anon_sym_short] = ACTIONS(5214),
    [anon_sym_LBRACK] = ACTIONS(5216),
    [anon_sym_RBRACK] = ACTIONS(5216),
    [anon_sym_const] = ACTIONS(5214),
    [anon_sym_constexpr] = ACTIONS(5214),
    [anon_sym_volatile] = ACTIONS(5214),
    [anon_sym_restrict] = ACTIONS(5214),
    [anon_sym___restrict__] = ACTIONS(5214),
    [anon_sym__Atomic] = ACTIONS(5214),
    [anon_sym__Noreturn] = ACTIONS(5214),
    [anon_sym_noreturn] = ACTIONS(5214),
    [anon_sym_mutable] = ACTIONS(5214),
    [anon_sym_constinit] = ACTIONS(5214),
    [anon_sym_consteval] = ACTIONS(5214),
    [anon_sym___shared__] = ACTIONS(5214),
    [anon_sym___local__] = ACTIONS(5214),
    [anon_sym___constant__] = ACTIONS(5214),
    [anon_sym___managed__] = ACTIONS(5214),
    [anon_sym___grid_constant__] = ACTIONS(5214),
    [anon_sym_alignas] = ACTIONS(5214),
    [anon_sym__Alignas] = ACTIONS(5214),
    [sym_primitive_type] = ACTIONS(5214),
    [anon_sym_COLON] = ACTIONS(5216),
    [anon_sym_QMARK] = ACTIONS(5216),
    [anon_sym_LT_EQ_GT] = ACTIONS(5216),
    [anon_sym_or] = ACTIONS(5214),
    [anon_sym_and] = ACTIONS(5214),
    [anon_sym_bitor] = ACTIONS(5214),
    [anon_sym_xor] = ACTIONS(5214),
    [anon_sym_bitand] = ACTIONS(5214),
    [anon_sym_not_eq] = ACTIONS(5214),
    [anon_sym_DASH_DASH] = ACTIONS(5216),
    [anon_sym_PLUS_PLUS] = ACTIONS(5216),
    [anon_sym_DOT] = ACTIONS(5214),
    [anon_sym_DOT_STAR] = ACTIONS(5216),
    [anon_sym_DASH_GT] = ACTIONS(5216),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5214),
    [anon_sym_decltype] = ACTIONS(5214),
    [anon_sym_final] = ACTIONS(5214),
    [anon_sym_override] = ACTIONS(5214),
    [anon_sym_requires] = ACTIONS(5214),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5216),
  },
  [1875] = {
    [sym_identifier] = ACTIONS(5043),
    [aux_sym_preproc_def_token1] = ACTIONS(5043),
    [aux_sym_preproc_if_token1] = ACTIONS(5043),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5043),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5043),
    [sym_preproc_directive] = ACTIONS(5043),
    [anon_sym_LPAREN2] = ACTIONS(5045),
    [anon_sym_TILDE] = ACTIONS(5045),
    [anon_sym_STAR] = ACTIONS(5045),
    [anon_sym_AMP_AMP] = ACTIONS(5045),
    [anon_sym_AMP] = ACTIONS(5043),
    [anon_sym___extension__] = ACTIONS(5043),
    [anon_sym_typedef] = ACTIONS(5043),
    [anon_sym___device__] = ACTIONS(5043),
    [anon_sym___host__] = ACTIONS(5043),
    [anon_sym___global__] = ACTIONS(5043),
    [anon_sym___forceinline__] = ACTIONS(5043),
    [anon_sym___noinline__] = ACTIONS(5043),
    [anon_sym_extern] = ACTIONS(5043),
    [anon_sym___attribute__] = ACTIONS(5043),
    [anon_sym_COLON_COLON] = ACTIONS(5045),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5045),
    [anon_sym___declspec] = ACTIONS(5043),
    [anon_sym___based] = ACTIONS(5043),
    [anon_sym_RBRACE] = ACTIONS(5045),
    [anon_sym_signed] = ACTIONS(5043),
    [anon_sym_unsigned] = ACTIONS(5043),
    [anon_sym_long] = ACTIONS(5043),
    [anon_sym_short] = ACTIONS(5043),
    [anon_sym_LBRACK] = ACTIONS(5043),
    [anon_sym_static] = ACTIONS(5043),
    [anon_sym_register] = ACTIONS(5043),
    [anon_sym_inline] = ACTIONS(5043),
    [anon_sym___inline] = ACTIONS(5043),
    [anon_sym___inline__] = ACTIONS(5043),
    [anon_sym___forceinline] = ACTIONS(5043),
    [anon_sym_thread_local] = ACTIONS(5043),
    [anon_sym___thread] = ACTIONS(5043),
    [anon_sym_const] = ACTIONS(5043),
    [anon_sym_constexpr] = ACTIONS(5043),
    [anon_sym_volatile] = ACTIONS(5043),
    [anon_sym_restrict] = ACTIONS(5043),
    [anon_sym___restrict__] = ACTIONS(5043),
    [anon_sym__Atomic] = ACTIONS(5043),
    [anon_sym__Noreturn] = ACTIONS(5043),
    [anon_sym_noreturn] = ACTIONS(5043),
    [anon_sym_mutable] = ACTIONS(5043),
    [anon_sym_constinit] = ACTIONS(5043),
    [anon_sym_consteval] = ACTIONS(5043),
    [anon_sym___shared__] = ACTIONS(5043),
    [anon_sym___local__] = ACTIONS(5043),
    [anon_sym___constant__] = ACTIONS(5043),
    [anon_sym___managed__] = ACTIONS(5043),
    [anon_sym___grid_constant__] = ACTIONS(5043),
    [anon_sym_alignas] = ACTIONS(5043),
    [anon_sym__Alignas] = ACTIONS(5043),
    [sym_primitive_type] = ACTIONS(5043),
    [anon_sym_enum] = ACTIONS(5043),
    [anon_sym_class] = ACTIONS(5043),
    [anon_sym_struct] = ACTIONS(5043),
    [anon_sym_union] = ACTIONS(5043),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5043),
    [anon_sym_decltype] = ACTIONS(5043),
    [sym_virtual] = ACTIONS(5043),
    [anon_sym_explicit] = ACTIONS(5043),
    [anon_sym_typename] = ACTIONS(5043),
    [anon_sym_template] = ACTIONS(5043),
    [anon_sym_operator] = ACTIONS(5043),
    [anon_sym_friend] = ACTIONS(5043),
    [anon_sym_public] = ACTIONS(5043),
    [anon_sym_private] = ACTIONS(5043),
    [anon_sym_protected] = ACTIONS(5043),
    [anon_sym_using] = ACTIONS(5043),
    [anon_sym_static_assert] = ACTIONS(5043),
    [anon_sym___launch_bounds__] = ACTIONS(5043),
  },
  [1876] = {
    [sym_identifier] = ACTIONS(2180),
    [aux_sym_preproc_def_token1] = ACTIONS(2180),
    [aux_sym_preproc_if_token1] = ACTIONS(2180),
    [aux_sym_preproc_if_token2] = ACTIONS(2180),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2180),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2180),
    [sym_preproc_directive] = ACTIONS(2180),
    [anon_sym_LPAREN2] = ACTIONS(2182),
    [anon_sym_TILDE] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(2182),
    [anon_sym_AMP_AMP] = ACTIONS(2182),
    [anon_sym_AMP] = ACTIONS(2180),
    [anon_sym___extension__] = ACTIONS(2180),
    [anon_sym_typedef] = ACTIONS(2180),
    [anon_sym___device__] = ACTIONS(2180),
    [anon_sym___host__] = ACTIONS(2180),
    [anon_sym___global__] = ACTIONS(2180),
    [anon_sym___forceinline__] = ACTIONS(2180),
    [anon_sym___noinline__] = ACTIONS(2180),
    [anon_sym_extern] = ACTIONS(2180),
    [anon_sym___attribute__] = ACTIONS(2180),
    [anon_sym_COLON_COLON] = ACTIONS(2182),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2182),
    [anon_sym___declspec] = ACTIONS(2180),
    [anon_sym___based] = ACTIONS(2180),
    [anon_sym_signed] = ACTIONS(2180),
    [anon_sym_unsigned] = ACTIONS(2180),
    [anon_sym_long] = ACTIONS(2180),
    [anon_sym_short] = ACTIONS(2180),
    [anon_sym_LBRACK] = ACTIONS(2180),
    [anon_sym_static] = ACTIONS(2180),
    [anon_sym_register] = ACTIONS(2180),
    [anon_sym_inline] = ACTIONS(2180),
    [anon_sym___inline] = ACTIONS(2180),
    [anon_sym___inline__] = ACTIONS(2180),
    [anon_sym___forceinline] = ACTIONS(2180),
    [anon_sym_thread_local] = ACTIONS(2180),
    [anon_sym___thread] = ACTIONS(2180),
    [anon_sym_const] = ACTIONS(2180),
    [anon_sym_constexpr] = ACTIONS(2180),
    [anon_sym_volatile] = ACTIONS(2180),
    [anon_sym_restrict] = ACTIONS(2180),
    [anon_sym___restrict__] = ACTIONS(2180),
    [anon_sym__Atomic] = ACTIONS(2180),
    [anon_sym__Noreturn] = ACTIONS(2180),
    [anon_sym_noreturn] = ACTIONS(2180),
    [anon_sym_mutable] = ACTIONS(2180),
    [anon_sym_constinit] = ACTIONS(2180),
    [anon_sym_consteval] = ACTIONS(2180),
    [anon_sym___shared__] = ACTIONS(2180),
    [anon_sym___local__] = ACTIONS(2180),
    [anon_sym___constant__] = ACTIONS(2180),
    [anon_sym___managed__] = ACTIONS(2180),
    [anon_sym___grid_constant__] = ACTIONS(2180),
    [anon_sym_alignas] = ACTIONS(2180),
    [anon_sym__Alignas] = ACTIONS(2180),
    [sym_primitive_type] = ACTIONS(2180),
    [anon_sym_enum] = ACTIONS(2180),
    [anon_sym_class] = ACTIONS(2180),
    [anon_sym_struct] = ACTIONS(2180),
    [anon_sym_union] = ACTIONS(2180),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2180),
    [anon_sym_decltype] = ACTIONS(2180),
    [sym_virtual] = ACTIONS(2180),
    [anon_sym_explicit] = ACTIONS(2180),
    [anon_sym_typename] = ACTIONS(2180),
    [anon_sym_template] = ACTIONS(2180),
    [anon_sym_operator] = ACTIONS(2180),
    [anon_sym_friend] = ACTIONS(2180),
    [anon_sym_public] = ACTIONS(2180),
    [anon_sym_private] = ACTIONS(2180),
    [anon_sym_protected] = ACTIONS(2180),
    [anon_sym_using] = ACTIONS(2180),
    [anon_sym_static_assert] = ACTIONS(2180),
    [anon_sym___launch_bounds__] = ACTIONS(2180),
  },
  [1877] = {
    [sym_identifier] = ACTIONS(2191),
    [aux_sym_preproc_def_token1] = ACTIONS(2191),
    [aux_sym_preproc_if_token1] = ACTIONS(2191),
    [aux_sym_preproc_if_token2] = ACTIONS(2191),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2191),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2191),
    [sym_preproc_directive] = ACTIONS(2191),
    [anon_sym_LPAREN2] = ACTIONS(2193),
    [anon_sym_TILDE] = ACTIONS(2193),
    [anon_sym_STAR] = ACTIONS(2193),
    [anon_sym_AMP_AMP] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2191),
    [anon_sym___extension__] = ACTIONS(2191),
    [anon_sym_typedef] = ACTIONS(2191),
    [anon_sym___device__] = ACTIONS(2191),
    [anon_sym___host__] = ACTIONS(2191),
    [anon_sym___global__] = ACTIONS(2191),
    [anon_sym___forceinline__] = ACTIONS(2191),
    [anon_sym___noinline__] = ACTIONS(2191),
    [anon_sym_extern] = ACTIONS(2191),
    [anon_sym___attribute__] = ACTIONS(2191),
    [anon_sym_COLON_COLON] = ACTIONS(2193),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2193),
    [anon_sym___declspec] = ACTIONS(2191),
    [anon_sym___based] = ACTIONS(2191),
    [anon_sym_signed] = ACTIONS(2191),
    [anon_sym_unsigned] = ACTIONS(2191),
    [anon_sym_long] = ACTIONS(2191),
    [anon_sym_short] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2191),
    [anon_sym_static] = ACTIONS(2191),
    [anon_sym_register] = ACTIONS(2191),
    [anon_sym_inline] = ACTIONS(2191),
    [anon_sym___inline] = ACTIONS(2191),
    [anon_sym___inline__] = ACTIONS(2191),
    [anon_sym___forceinline] = ACTIONS(2191),
    [anon_sym_thread_local] = ACTIONS(2191),
    [anon_sym___thread] = ACTIONS(2191),
    [anon_sym_const] = ACTIONS(2191),
    [anon_sym_constexpr] = ACTIONS(2191),
    [anon_sym_volatile] = ACTIONS(2191),
    [anon_sym_restrict] = ACTIONS(2191),
    [anon_sym___restrict__] = ACTIONS(2191),
    [anon_sym__Atomic] = ACTIONS(2191),
    [anon_sym__Noreturn] = ACTIONS(2191),
    [anon_sym_noreturn] = ACTIONS(2191),
    [anon_sym_mutable] = ACTIONS(2191),
    [anon_sym_constinit] = ACTIONS(2191),
    [anon_sym_consteval] = ACTIONS(2191),
    [anon_sym___shared__] = ACTIONS(2191),
    [anon_sym___local__] = ACTIONS(2191),
    [anon_sym___constant__] = ACTIONS(2191),
    [anon_sym___managed__] = ACTIONS(2191),
    [anon_sym___grid_constant__] = ACTIONS(2191),
    [anon_sym_alignas] = ACTIONS(2191),
    [anon_sym__Alignas] = ACTIONS(2191),
    [sym_primitive_type] = ACTIONS(2191),
    [anon_sym_enum] = ACTIONS(2191),
    [anon_sym_class] = ACTIONS(2191),
    [anon_sym_struct] = ACTIONS(2191),
    [anon_sym_union] = ACTIONS(2191),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2191),
    [anon_sym_decltype] = ACTIONS(2191),
    [sym_virtual] = ACTIONS(2191),
    [anon_sym_explicit] = ACTIONS(2191),
    [anon_sym_typename] = ACTIONS(2191),
    [anon_sym_template] = ACTIONS(2191),
    [anon_sym_operator] = ACTIONS(2191),
    [anon_sym_friend] = ACTIONS(2191),
    [anon_sym_public] = ACTIONS(2191),
    [anon_sym_private] = ACTIONS(2191),
    [anon_sym_protected] = ACTIONS(2191),
    [anon_sym_using] = ACTIONS(2191),
    [anon_sym_static_assert] = ACTIONS(2191),
    [anon_sym___launch_bounds__] = ACTIONS(2191),
  },
  [1878] = {
    [sym_identifier] = ACTIONS(2060),
    [aux_sym_preproc_def_token1] = ACTIONS(2060),
    [aux_sym_preproc_if_token1] = ACTIONS(2060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2060),
    [sym_preproc_directive] = ACTIONS(2060),
    [anon_sym_LPAREN2] = ACTIONS(2062),
    [anon_sym_TILDE] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(2062),
    [anon_sym_AMP_AMP] = ACTIONS(2062),
    [anon_sym_AMP] = ACTIONS(2060),
    [anon_sym___extension__] = ACTIONS(2060),
    [anon_sym_typedef] = ACTIONS(2060),
    [anon_sym___device__] = ACTIONS(2060),
    [anon_sym___host__] = ACTIONS(2060),
    [anon_sym___global__] = ACTIONS(2060),
    [anon_sym___forceinline__] = ACTIONS(2060),
    [anon_sym___noinline__] = ACTIONS(2060),
    [anon_sym_extern] = ACTIONS(2060),
    [anon_sym___attribute__] = ACTIONS(2060),
    [anon_sym_COLON_COLON] = ACTIONS(2062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2062),
    [anon_sym___declspec] = ACTIONS(2060),
    [anon_sym___based] = ACTIONS(2060),
    [anon_sym_RBRACE] = ACTIONS(2062),
    [anon_sym_signed] = ACTIONS(2060),
    [anon_sym_unsigned] = ACTIONS(2060),
    [anon_sym_long] = ACTIONS(2060),
    [anon_sym_short] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2060),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_register] = ACTIONS(2060),
    [anon_sym_inline] = ACTIONS(2060),
    [anon_sym___inline] = ACTIONS(2060),
    [anon_sym___inline__] = ACTIONS(2060),
    [anon_sym___forceinline] = ACTIONS(2060),
    [anon_sym_thread_local] = ACTIONS(2060),
    [anon_sym___thread] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_constexpr] = ACTIONS(2060),
    [anon_sym_volatile] = ACTIONS(2060),
    [anon_sym_restrict] = ACTIONS(2060),
    [anon_sym___restrict__] = ACTIONS(2060),
    [anon_sym__Atomic] = ACTIONS(2060),
    [anon_sym__Noreturn] = ACTIONS(2060),
    [anon_sym_noreturn] = ACTIONS(2060),
    [anon_sym_mutable] = ACTIONS(2060),
    [anon_sym_constinit] = ACTIONS(2060),
    [anon_sym_consteval] = ACTIONS(2060),
    [anon_sym___shared__] = ACTIONS(2060),
    [anon_sym___local__] = ACTIONS(2060),
    [anon_sym___constant__] = ACTIONS(2060),
    [anon_sym___managed__] = ACTIONS(2060),
    [anon_sym___grid_constant__] = ACTIONS(2060),
    [anon_sym_alignas] = ACTIONS(2060),
    [anon_sym__Alignas] = ACTIONS(2060),
    [sym_primitive_type] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_struct] = ACTIONS(2060),
    [anon_sym_union] = ACTIONS(2060),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2060),
    [anon_sym_decltype] = ACTIONS(2060),
    [sym_virtual] = ACTIONS(2060),
    [anon_sym_explicit] = ACTIONS(2060),
    [anon_sym_typename] = ACTIONS(2060),
    [anon_sym_template] = ACTIONS(2060),
    [anon_sym_operator] = ACTIONS(2060),
    [anon_sym_friend] = ACTIONS(2060),
    [anon_sym_public] = ACTIONS(2060),
    [anon_sym_private] = ACTIONS(2060),
    [anon_sym_protected] = ACTIONS(2060),
    [anon_sym_using] = ACTIONS(2060),
    [anon_sym_static_assert] = ACTIONS(2060),
    [anon_sym___launch_bounds__] = ACTIONS(2060),
  },
  [1879] = {
    [sym_identifier] = ACTIONS(5127),
    [aux_sym_preproc_def_token1] = ACTIONS(5127),
    [aux_sym_preproc_if_token1] = ACTIONS(5127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5127),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5127),
    [sym_preproc_directive] = ACTIONS(5127),
    [anon_sym_LPAREN2] = ACTIONS(5129),
    [anon_sym_TILDE] = ACTIONS(5129),
    [anon_sym_STAR] = ACTIONS(5129),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5127),
    [anon_sym___extension__] = ACTIONS(5127),
    [anon_sym_typedef] = ACTIONS(5127),
    [anon_sym___device__] = ACTIONS(5127),
    [anon_sym___host__] = ACTIONS(5127),
    [anon_sym___global__] = ACTIONS(5127),
    [anon_sym___forceinline__] = ACTIONS(5127),
    [anon_sym___noinline__] = ACTIONS(5127),
    [anon_sym_extern] = ACTIONS(5127),
    [anon_sym___attribute__] = ACTIONS(5127),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5129),
    [anon_sym___declspec] = ACTIONS(5127),
    [anon_sym___based] = ACTIONS(5127),
    [anon_sym_RBRACE] = ACTIONS(5129),
    [anon_sym_signed] = ACTIONS(5127),
    [anon_sym_unsigned] = ACTIONS(5127),
    [anon_sym_long] = ACTIONS(5127),
    [anon_sym_short] = ACTIONS(5127),
    [anon_sym_LBRACK] = ACTIONS(5127),
    [anon_sym_static] = ACTIONS(5127),
    [anon_sym_register] = ACTIONS(5127),
    [anon_sym_inline] = ACTIONS(5127),
    [anon_sym___inline] = ACTIONS(5127),
    [anon_sym___inline__] = ACTIONS(5127),
    [anon_sym___forceinline] = ACTIONS(5127),
    [anon_sym_thread_local] = ACTIONS(5127),
    [anon_sym___thread] = ACTIONS(5127),
    [anon_sym_const] = ACTIONS(5127),
    [anon_sym_constexpr] = ACTIONS(5127),
    [anon_sym_volatile] = ACTIONS(5127),
    [anon_sym_restrict] = ACTIONS(5127),
    [anon_sym___restrict__] = ACTIONS(5127),
    [anon_sym__Atomic] = ACTIONS(5127),
    [anon_sym__Noreturn] = ACTIONS(5127),
    [anon_sym_noreturn] = ACTIONS(5127),
    [anon_sym_mutable] = ACTIONS(5127),
    [anon_sym_constinit] = ACTIONS(5127),
    [anon_sym_consteval] = ACTIONS(5127),
    [anon_sym___shared__] = ACTIONS(5127),
    [anon_sym___local__] = ACTIONS(5127),
    [anon_sym___constant__] = ACTIONS(5127),
    [anon_sym___managed__] = ACTIONS(5127),
    [anon_sym___grid_constant__] = ACTIONS(5127),
    [anon_sym_alignas] = ACTIONS(5127),
    [anon_sym__Alignas] = ACTIONS(5127),
    [sym_primitive_type] = ACTIONS(5127),
    [anon_sym_enum] = ACTIONS(5127),
    [anon_sym_class] = ACTIONS(5127),
    [anon_sym_struct] = ACTIONS(5127),
    [anon_sym_union] = ACTIONS(5127),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5127),
    [anon_sym_decltype] = ACTIONS(5127),
    [sym_virtual] = ACTIONS(5127),
    [anon_sym_explicit] = ACTIONS(5127),
    [anon_sym_typename] = ACTIONS(5127),
    [anon_sym_template] = ACTIONS(5127),
    [anon_sym_operator] = ACTIONS(5127),
    [anon_sym_friend] = ACTIONS(5127),
    [anon_sym_public] = ACTIONS(5127),
    [anon_sym_private] = ACTIONS(5127),
    [anon_sym_protected] = ACTIONS(5127),
    [anon_sym_using] = ACTIONS(5127),
    [anon_sym_static_assert] = ACTIONS(5127),
    [anon_sym___launch_bounds__] = ACTIONS(5127),
  },
  [1880] = {
    [sym_identifier] = ACTIONS(5123),
    [aux_sym_preproc_def_token1] = ACTIONS(5123),
    [aux_sym_preproc_if_token1] = ACTIONS(5123),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5123),
    [sym_preproc_directive] = ACTIONS(5123),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_TILDE] = ACTIONS(5125),
    [anon_sym_STAR] = ACTIONS(5125),
    [anon_sym_AMP_AMP] = ACTIONS(5125),
    [anon_sym_AMP] = ACTIONS(5123),
    [anon_sym___extension__] = ACTIONS(5123),
    [anon_sym_typedef] = ACTIONS(5123),
    [anon_sym___device__] = ACTIONS(5123),
    [anon_sym___host__] = ACTIONS(5123),
    [anon_sym___global__] = ACTIONS(5123),
    [anon_sym___forceinline__] = ACTIONS(5123),
    [anon_sym___noinline__] = ACTIONS(5123),
    [anon_sym_extern] = ACTIONS(5123),
    [anon_sym___attribute__] = ACTIONS(5123),
    [anon_sym_COLON_COLON] = ACTIONS(5125),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5125),
    [anon_sym___declspec] = ACTIONS(5123),
    [anon_sym___based] = ACTIONS(5123),
    [anon_sym_RBRACE] = ACTIONS(5125),
    [anon_sym_signed] = ACTIONS(5123),
    [anon_sym_unsigned] = ACTIONS(5123),
    [anon_sym_long] = ACTIONS(5123),
    [anon_sym_short] = ACTIONS(5123),
    [anon_sym_LBRACK] = ACTIONS(5123),
    [anon_sym_static] = ACTIONS(5123),
    [anon_sym_register] = ACTIONS(5123),
    [anon_sym_inline] = ACTIONS(5123),
    [anon_sym___inline] = ACTIONS(5123),
    [anon_sym___inline__] = ACTIONS(5123),
    [anon_sym___forceinline] = ACTIONS(5123),
    [anon_sym_thread_local] = ACTIONS(5123),
    [anon_sym___thread] = ACTIONS(5123),
    [anon_sym_const] = ACTIONS(5123),
    [anon_sym_constexpr] = ACTIONS(5123),
    [anon_sym_volatile] = ACTIONS(5123),
    [anon_sym_restrict] = ACTIONS(5123),
    [anon_sym___restrict__] = ACTIONS(5123),
    [anon_sym__Atomic] = ACTIONS(5123),
    [anon_sym__Noreturn] = ACTIONS(5123),
    [anon_sym_noreturn] = ACTIONS(5123),
    [anon_sym_mutable] = ACTIONS(5123),
    [anon_sym_constinit] = ACTIONS(5123),
    [anon_sym_consteval] = ACTIONS(5123),
    [anon_sym___shared__] = ACTIONS(5123),
    [anon_sym___local__] = ACTIONS(5123),
    [anon_sym___constant__] = ACTIONS(5123),
    [anon_sym___managed__] = ACTIONS(5123),
    [anon_sym___grid_constant__] = ACTIONS(5123),
    [anon_sym_alignas] = ACTIONS(5123),
    [anon_sym__Alignas] = ACTIONS(5123),
    [sym_primitive_type] = ACTIONS(5123),
    [anon_sym_enum] = ACTIONS(5123),
    [anon_sym_class] = ACTIONS(5123),
    [anon_sym_struct] = ACTIONS(5123),
    [anon_sym_union] = ACTIONS(5123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5123),
    [anon_sym_decltype] = ACTIONS(5123),
    [sym_virtual] = ACTIONS(5123),
    [anon_sym_explicit] = ACTIONS(5123),
    [anon_sym_typename] = ACTIONS(5123),
    [anon_sym_template] = ACTIONS(5123),
    [anon_sym_operator] = ACTIONS(5123),
    [anon_sym_friend] = ACTIONS(5123),
    [anon_sym_public] = ACTIONS(5123),
    [anon_sym_private] = ACTIONS(5123),
    [anon_sym_protected] = ACTIONS(5123),
    [anon_sym_using] = ACTIONS(5123),
    [anon_sym_static_assert] = ACTIONS(5123),
    [anon_sym___launch_bounds__] = ACTIONS(5123),
  },
  [1881] = {
    [sym_identifier] = ACTIONS(2203),
    [aux_sym_preproc_def_token1] = ACTIONS(2203),
    [aux_sym_preproc_if_token1] = ACTIONS(2203),
    [aux_sym_preproc_if_token2] = ACTIONS(2203),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2203),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2203),
    [sym_preproc_directive] = ACTIONS(2203),
    [anon_sym_LPAREN2] = ACTIONS(2205),
    [anon_sym_TILDE] = ACTIONS(2205),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_AMP_AMP] = ACTIONS(2205),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym___extension__] = ACTIONS(2203),
    [anon_sym_typedef] = ACTIONS(2203),
    [anon_sym___device__] = ACTIONS(2203),
    [anon_sym___host__] = ACTIONS(2203),
    [anon_sym___global__] = ACTIONS(2203),
    [anon_sym___forceinline__] = ACTIONS(2203),
    [anon_sym___noinline__] = ACTIONS(2203),
    [anon_sym_extern] = ACTIONS(2203),
    [anon_sym___attribute__] = ACTIONS(2203),
    [anon_sym_COLON_COLON] = ACTIONS(2205),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2205),
    [anon_sym___declspec] = ACTIONS(2203),
    [anon_sym___based] = ACTIONS(2203),
    [anon_sym_signed] = ACTIONS(2203),
    [anon_sym_unsigned] = ACTIONS(2203),
    [anon_sym_long] = ACTIONS(2203),
    [anon_sym_short] = ACTIONS(2203),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_static] = ACTIONS(2203),
    [anon_sym_register] = ACTIONS(2203),
    [anon_sym_inline] = ACTIONS(2203),
    [anon_sym___inline] = ACTIONS(2203),
    [anon_sym___inline__] = ACTIONS(2203),
    [anon_sym___forceinline] = ACTIONS(2203),
    [anon_sym_thread_local] = ACTIONS(2203),
    [anon_sym___thread] = ACTIONS(2203),
    [anon_sym_const] = ACTIONS(2203),
    [anon_sym_constexpr] = ACTIONS(2203),
    [anon_sym_volatile] = ACTIONS(2203),
    [anon_sym_restrict] = ACTIONS(2203),
    [anon_sym___restrict__] = ACTIONS(2203),
    [anon_sym__Atomic] = ACTIONS(2203),
    [anon_sym__Noreturn] = ACTIONS(2203),
    [anon_sym_noreturn] = ACTIONS(2203),
    [anon_sym_mutable] = ACTIONS(2203),
    [anon_sym_constinit] = ACTIONS(2203),
    [anon_sym_consteval] = ACTIONS(2203),
    [anon_sym___shared__] = ACTIONS(2203),
    [anon_sym___local__] = ACTIONS(2203),
    [anon_sym___constant__] = ACTIONS(2203),
    [anon_sym___managed__] = ACTIONS(2203),
    [anon_sym___grid_constant__] = ACTIONS(2203),
    [anon_sym_alignas] = ACTIONS(2203),
    [anon_sym__Alignas] = ACTIONS(2203),
    [sym_primitive_type] = ACTIONS(2203),
    [anon_sym_enum] = ACTIONS(2203),
    [anon_sym_class] = ACTIONS(2203),
    [anon_sym_struct] = ACTIONS(2203),
    [anon_sym_union] = ACTIONS(2203),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2203),
    [anon_sym_decltype] = ACTIONS(2203),
    [sym_virtual] = ACTIONS(2203),
    [anon_sym_explicit] = ACTIONS(2203),
    [anon_sym_typename] = ACTIONS(2203),
    [anon_sym_template] = ACTIONS(2203),
    [anon_sym_operator] = ACTIONS(2203),
    [anon_sym_friend] = ACTIONS(2203),
    [anon_sym_public] = ACTIONS(2203),
    [anon_sym_private] = ACTIONS(2203),
    [anon_sym_protected] = ACTIONS(2203),
    [anon_sym_using] = ACTIONS(2203),
    [anon_sym_static_assert] = ACTIONS(2203),
    [anon_sym___launch_bounds__] = ACTIONS(2203),
  },
  [1882] = {
    [sym_identifier] = ACTIONS(5119),
    [aux_sym_preproc_def_token1] = ACTIONS(5119),
    [aux_sym_preproc_if_token1] = ACTIONS(5119),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5119),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5119),
    [sym_preproc_directive] = ACTIONS(5119),
    [anon_sym_LPAREN2] = ACTIONS(5121),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_STAR] = ACTIONS(5121),
    [anon_sym_AMP_AMP] = ACTIONS(5121),
    [anon_sym_AMP] = ACTIONS(5119),
    [anon_sym___extension__] = ACTIONS(5119),
    [anon_sym_typedef] = ACTIONS(5119),
    [anon_sym___device__] = ACTIONS(5119),
    [anon_sym___host__] = ACTIONS(5119),
    [anon_sym___global__] = ACTIONS(5119),
    [anon_sym___forceinline__] = ACTIONS(5119),
    [anon_sym___noinline__] = ACTIONS(5119),
    [anon_sym_extern] = ACTIONS(5119),
    [anon_sym___attribute__] = ACTIONS(5119),
    [anon_sym_COLON_COLON] = ACTIONS(5121),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5121),
    [anon_sym___declspec] = ACTIONS(5119),
    [anon_sym___based] = ACTIONS(5119),
    [anon_sym_RBRACE] = ACTIONS(5121),
    [anon_sym_signed] = ACTIONS(5119),
    [anon_sym_unsigned] = ACTIONS(5119),
    [anon_sym_long] = ACTIONS(5119),
    [anon_sym_short] = ACTIONS(5119),
    [anon_sym_LBRACK] = ACTIONS(5119),
    [anon_sym_static] = ACTIONS(5119),
    [anon_sym_register] = ACTIONS(5119),
    [anon_sym_inline] = ACTIONS(5119),
    [anon_sym___inline] = ACTIONS(5119),
    [anon_sym___inline__] = ACTIONS(5119),
    [anon_sym___forceinline] = ACTIONS(5119),
    [anon_sym_thread_local] = ACTIONS(5119),
    [anon_sym___thread] = ACTIONS(5119),
    [anon_sym_const] = ACTIONS(5119),
    [anon_sym_constexpr] = ACTIONS(5119),
    [anon_sym_volatile] = ACTIONS(5119),
    [anon_sym_restrict] = ACTIONS(5119),
    [anon_sym___restrict__] = ACTIONS(5119),
    [anon_sym__Atomic] = ACTIONS(5119),
    [anon_sym__Noreturn] = ACTIONS(5119),
    [anon_sym_noreturn] = ACTIONS(5119),
    [anon_sym_mutable] = ACTIONS(5119),
    [anon_sym_constinit] = ACTIONS(5119),
    [anon_sym_consteval] = ACTIONS(5119),
    [anon_sym___shared__] = ACTIONS(5119),
    [anon_sym___local__] = ACTIONS(5119),
    [anon_sym___constant__] = ACTIONS(5119),
    [anon_sym___managed__] = ACTIONS(5119),
    [anon_sym___grid_constant__] = ACTIONS(5119),
    [anon_sym_alignas] = ACTIONS(5119),
    [anon_sym__Alignas] = ACTIONS(5119),
    [sym_primitive_type] = ACTIONS(5119),
    [anon_sym_enum] = ACTIONS(5119),
    [anon_sym_class] = ACTIONS(5119),
    [anon_sym_struct] = ACTIONS(5119),
    [anon_sym_union] = ACTIONS(5119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5119),
    [anon_sym_decltype] = ACTIONS(5119),
    [sym_virtual] = ACTIONS(5119),
    [anon_sym_explicit] = ACTIONS(5119),
    [anon_sym_typename] = ACTIONS(5119),
    [anon_sym_template] = ACTIONS(5119),
    [anon_sym_operator] = ACTIONS(5119),
    [anon_sym_friend] = ACTIONS(5119),
    [anon_sym_public] = ACTIONS(5119),
    [anon_sym_private] = ACTIONS(5119),
    [anon_sym_protected] = ACTIONS(5119),
    [anon_sym_using] = ACTIONS(5119),
    [anon_sym_static_assert] = ACTIONS(5119),
    [anon_sym___launch_bounds__] = ACTIONS(5119),
  },
  [1883] = {
    [sym_identifier] = ACTIONS(5115),
    [aux_sym_preproc_def_token1] = ACTIONS(5115),
    [aux_sym_preproc_if_token1] = ACTIONS(5115),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5115),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5115),
    [sym_preproc_directive] = ACTIONS(5115),
    [anon_sym_LPAREN2] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(5117),
    [anon_sym_STAR] = ACTIONS(5117),
    [anon_sym_AMP_AMP] = ACTIONS(5117),
    [anon_sym_AMP] = ACTIONS(5115),
    [anon_sym___extension__] = ACTIONS(5115),
    [anon_sym_typedef] = ACTIONS(5115),
    [anon_sym___device__] = ACTIONS(5115),
    [anon_sym___host__] = ACTIONS(5115),
    [anon_sym___global__] = ACTIONS(5115),
    [anon_sym___forceinline__] = ACTIONS(5115),
    [anon_sym___noinline__] = ACTIONS(5115),
    [anon_sym_extern] = ACTIONS(5115),
    [anon_sym___attribute__] = ACTIONS(5115),
    [anon_sym_COLON_COLON] = ACTIONS(5117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5117),
    [anon_sym___declspec] = ACTIONS(5115),
    [anon_sym___based] = ACTIONS(5115),
    [anon_sym_RBRACE] = ACTIONS(5117),
    [anon_sym_signed] = ACTIONS(5115),
    [anon_sym_unsigned] = ACTIONS(5115),
    [anon_sym_long] = ACTIONS(5115),
    [anon_sym_short] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_static] = ACTIONS(5115),
    [anon_sym_register] = ACTIONS(5115),
    [anon_sym_inline] = ACTIONS(5115),
    [anon_sym___inline] = ACTIONS(5115),
    [anon_sym___inline__] = ACTIONS(5115),
    [anon_sym___forceinline] = ACTIONS(5115),
    [anon_sym_thread_local] = ACTIONS(5115),
    [anon_sym___thread] = ACTIONS(5115),
    [anon_sym_const] = ACTIONS(5115),
    [anon_sym_constexpr] = ACTIONS(5115),
    [anon_sym_volatile] = ACTIONS(5115),
    [anon_sym_restrict] = ACTIONS(5115),
    [anon_sym___restrict__] = ACTIONS(5115),
    [anon_sym__Atomic] = ACTIONS(5115),
    [anon_sym__Noreturn] = ACTIONS(5115),
    [anon_sym_noreturn] = ACTIONS(5115),
    [anon_sym_mutable] = ACTIONS(5115),
    [anon_sym_constinit] = ACTIONS(5115),
    [anon_sym_consteval] = ACTIONS(5115),
    [anon_sym___shared__] = ACTIONS(5115),
    [anon_sym___local__] = ACTIONS(5115),
    [anon_sym___constant__] = ACTIONS(5115),
    [anon_sym___managed__] = ACTIONS(5115),
    [anon_sym___grid_constant__] = ACTIONS(5115),
    [anon_sym_alignas] = ACTIONS(5115),
    [anon_sym__Alignas] = ACTIONS(5115),
    [sym_primitive_type] = ACTIONS(5115),
    [anon_sym_enum] = ACTIONS(5115),
    [anon_sym_class] = ACTIONS(5115),
    [anon_sym_struct] = ACTIONS(5115),
    [anon_sym_union] = ACTIONS(5115),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5115),
    [anon_sym_decltype] = ACTIONS(5115),
    [sym_virtual] = ACTIONS(5115),
    [anon_sym_explicit] = ACTIONS(5115),
    [anon_sym_typename] = ACTIONS(5115),
    [anon_sym_template] = ACTIONS(5115),
    [anon_sym_operator] = ACTIONS(5115),
    [anon_sym_friend] = ACTIONS(5115),
    [anon_sym_public] = ACTIONS(5115),
    [anon_sym_private] = ACTIONS(5115),
    [anon_sym_protected] = ACTIONS(5115),
    [anon_sym_using] = ACTIONS(5115),
    [anon_sym_static_assert] = ACTIONS(5115),
    [anon_sym___launch_bounds__] = ACTIONS(5115),
  },
  [1884] = {
    [sym_identifier] = ACTIONS(2235),
    [aux_sym_preproc_def_token1] = ACTIONS(2235),
    [aux_sym_preproc_if_token1] = ACTIONS(2235),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2235),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2235),
    [sym_preproc_directive] = ACTIONS(2235),
    [anon_sym_LPAREN2] = ACTIONS(2237),
    [anon_sym_TILDE] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2237),
    [anon_sym_AMP_AMP] = ACTIONS(2237),
    [anon_sym_AMP] = ACTIONS(2235),
    [anon_sym___extension__] = ACTIONS(2235),
    [anon_sym_typedef] = ACTIONS(2235),
    [anon_sym___device__] = ACTIONS(2235),
    [anon_sym___host__] = ACTIONS(2235),
    [anon_sym___global__] = ACTIONS(2235),
    [anon_sym___forceinline__] = ACTIONS(2235),
    [anon_sym___noinline__] = ACTIONS(2235),
    [anon_sym_extern] = ACTIONS(2235),
    [anon_sym___attribute__] = ACTIONS(2235),
    [anon_sym_COLON_COLON] = ACTIONS(2237),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2237),
    [anon_sym___declspec] = ACTIONS(2235),
    [anon_sym___based] = ACTIONS(2235),
    [anon_sym_RBRACE] = ACTIONS(2237),
    [anon_sym_signed] = ACTIONS(2235),
    [anon_sym_unsigned] = ACTIONS(2235),
    [anon_sym_long] = ACTIONS(2235),
    [anon_sym_short] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_static] = ACTIONS(2235),
    [anon_sym_register] = ACTIONS(2235),
    [anon_sym_inline] = ACTIONS(2235),
    [anon_sym___inline] = ACTIONS(2235),
    [anon_sym___inline__] = ACTIONS(2235),
    [anon_sym___forceinline] = ACTIONS(2235),
    [anon_sym_thread_local] = ACTIONS(2235),
    [anon_sym___thread] = ACTIONS(2235),
    [anon_sym_const] = ACTIONS(2235),
    [anon_sym_constexpr] = ACTIONS(2235),
    [anon_sym_volatile] = ACTIONS(2235),
    [anon_sym_restrict] = ACTIONS(2235),
    [anon_sym___restrict__] = ACTIONS(2235),
    [anon_sym__Atomic] = ACTIONS(2235),
    [anon_sym__Noreturn] = ACTIONS(2235),
    [anon_sym_noreturn] = ACTIONS(2235),
    [anon_sym_mutable] = ACTIONS(2235),
    [anon_sym_constinit] = ACTIONS(2235),
    [anon_sym_consteval] = ACTIONS(2235),
    [anon_sym___shared__] = ACTIONS(2235),
    [anon_sym___local__] = ACTIONS(2235),
    [anon_sym___constant__] = ACTIONS(2235),
    [anon_sym___managed__] = ACTIONS(2235),
    [anon_sym___grid_constant__] = ACTIONS(2235),
    [anon_sym_alignas] = ACTIONS(2235),
    [anon_sym__Alignas] = ACTIONS(2235),
    [sym_primitive_type] = ACTIONS(2235),
    [anon_sym_enum] = ACTIONS(2235),
    [anon_sym_class] = ACTIONS(2235),
    [anon_sym_struct] = ACTIONS(2235),
    [anon_sym_union] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2235),
    [anon_sym_decltype] = ACTIONS(2235),
    [sym_virtual] = ACTIONS(2235),
    [anon_sym_explicit] = ACTIONS(2235),
    [anon_sym_typename] = ACTIONS(2235),
    [anon_sym_template] = ACTIONS(2235),
    [anon_sym_operator] = ACTIONS(2235),
    [anon_sym_friend] = ACTIONS(2235),
    [anon_sym_public] = ACTIONS(2235),
    [anon_sym_private] = ACTIONS(2235),
    [anon_sym_protected] = ACTIONS(2235),
    [anon_sym_using] = ACTIONS(2235),
    [anon_sym_static_assert] = ACTIONS(2235),
    [anon_sym___launch_bounds__] = ACTIONS(2235),
  },
  [1885] = {
    [sym_identifier] = ACTIONS(5119),
    [aux_sym_preproc_def_token1] = ACTIONS(5119),
    [aux_sym_preproc_if_token1] = ACTIONS(5119),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5119),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5119),
    [sym_preproc_directive] = ACTIONS(5119),
    [anon_sym_LPAREN2] = ACTIONS(5121),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_STAR] = ACTIONS(5121),
    [anon_sym_AMP_AMP] = ACTIONS(5121),
    [anon_sym_AMP] = ACTIONS(5119),
    [anon_sym___extension__] = ACTIONS(5119),
    [anon_sym_typedef] = ACTIONS(5119),
    [anon_sym___device__] = ACTIONS(5119),
    [anon_sym___host__] = ACTIONS(5119),
    [anon_sym___global__] = ACTIONS(5119),
    [anon_sym___forceinline__] = ACTIONS(5119),
    [anon_sym___noinline__] = ACTIONS(5119),
    [anon_sym_extern] = ACTIONS(5119),
    [anon_sym___attribute__] = ACTIONS(5119),
    [anon_sym_COLON_COLON] = ACTIONS(5121),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5121),
    [anon_sym___declspec] = ACTIONS(5119),
    [anon_sym___based] = ACTIONS(5119),
    [anon_sym_RBRACE] = ACTIONS(5121),
    [anon_sym_signed] = ACTIONS(5119),
    [anon_sym_unsigned] = ACTIONS(5119),
    [anon_sym_long] = ACTIONS(5119),
    [anon_sym_short] = ACTIONS(5119),
    [anon_sym_LBRACK] = ACTIONS(5119),
    [anon_sym_static] = ACTIONS(5119),
    [anon_sym_register] = ACTIONS(5119),
    [anon_sym_inline] = ACTIONS(5119),
    [anon_sym___inline] = ACTIONS(5119),
    [anon_sym___inline__] = ACTIONS(5119),
    [anon_sym___forceinline] = ACTIONS(5119),
    [anon_sym_thread_local] = ACTIONS(5119),
    [anon_sym___thread] = ACTIONS(5119),
    [anon_sym_const] = ACTIONS(5119),
    [anon_sym_constexpr] = ACTIONS(5119),
    [anon_sym_volatile] = ACTIONS(5119),
    [anon_sym_restrict] = ACTIONS(5119),
    [anon_sym___restrict__] = ACTIONS(5119),
    [anon_sym__Atomic] = ACTIONS(5119),
    [anon_sym__Noreturn] = ACTIONS(5119),
    [anon_sym_noreturn] = ACTIONS(5119),
    [anon_sym_mutable] = ACTIONS(5119),
    [anon_sym_constinit] = ACTIONS(5119),
    [anon_sym_consteval] = ACTIONS(5119),
    [anon_sym___shared__] = ACTIONS(5119),
    [anon_sym___local__] = ACTIONS(5119),
    [anon_sym___constant__] = ACTIONS(5119),
    [anon_sym___managed__] = ACTIONS(5119),
    [anon_sym___grid_constant__] = ACTIONS(5119),
    [anon_sym_alignas] = ACTIONS(5119),
    [anon_sym__Alignas] = ACTIONS(5119),
    [sym_primitive_type] = ACTIONS(5119),
    [anon_sym_enum] = ACTIONS(5119),
    [anon_sym_class] = ACTIONS(5119),
    [anon_sym_struct] = ACTIONS(5119),
    [anon_sym_union] = ACTIONS(5119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5119),
    [anon_sym_decltype] = ACTIONS(5119),
    [sym_virtual] = ACTIONS(5119),
    [anon_sym_explicit] = ACTIONS(5119),
    [anon_sym_typename] = ACTIONS(5119),
    [anon_sym_template] = ACTIONS(5119),
    [anon_sym_operator] = ACTIONS(5119),
    [anon_sym_friend] = ACTIONS(5119),
    [anon_sym_public] = ACTIONS(5119),
    [anon_sym_private] = ACTIONS(5119),
    [anon_sym_protected] = ACTIONS(5119),
    [anon_sym_using] = ACTIONS(5119),
    [anon_sym_static_assert] = ACTIONS(5119),
    [anon_sym___launch_bounds__] = ACTIONS(5119),
  },
  [1886] = {
    [sym_identifier] = ACTIONS(5115),
    [aux_sym_preproc_def_token1] = ACTIONS(5115),
    [aux_sym_preproc_if_token1] = ACTIONS(5115),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5115),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5115),
    [sym_preproc_directive] = ACTIONS(5115),
    [anon_sym_LPAREN2] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(5117),
    [anon_sym_STAR] = ACTIONS(5117),
    [anon_sym_AMP_AMP] = ACTIONS(5117),
    [anon_sym_AMP] = ACTIONS(5115),
    [anon_sym___extension__] = ACTIONS(5115),
    [anon_sym_typedef] = ACTIONS(5115),
    [anon_sym___device__] = ACTIONS(5115),
    [anon_sym___host__] = ACTIONS(5115),
    [anon_sym___global__] = ACTIONS(5115),
    [anon_sym___forceinline__] = ACTIONS(5115),
    [anon_sym___noinline__] = ACTIONS(5115),
    [anon_sym_extern] = ACTIONS(5115),
    [anon_sym___attribute__] = ACTIONS(5115),
    [anon_sym_COLON_COLON] = ACTIONS(5117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5117),
    [anon_sym___declspec] = ACTIONS(5115),
    [anon_sym___based] = ACTIONS(5115),
    [anon_sym_RBRACE] = ACTIONS(5117),
    [anon_sym_signed] = ACTIONS(5115),
    [anon_sym_unsigned] = ACTIONS(5115),
    [anon_sym_long] = ACTIONS(5115),
    [anon_sym_short] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_static] = ACTIONS(5115),
    [anon_sym_register] = ACTIONS(5115),
    [anon_sym_inline] = ACTIONS(5115),
    [anon_sym___inline] = ACTIONS(5115),
    [anon_sym___inline__] = ACTIONS(5115),
    [anon_sym___forceinline] = ACTIONS(5115),
    [anon_sym_thread_local] = ACTIONS(5115),
    [anon_sym___thread] = ACTIONS(5115),
    [anon_sym_const] = ACTIONS(5115),
    [anon_sym_constexpr] = ACTIONS(5115),
    [anon_sym_volatile] = ACTIONS(5115),
    [anon_sym_restrict] = ACTIONS(5115),
    [anon_sym___restrict__] = ACTIONS(5115),
    [anon_sym__Atomic] = ACTIONS(5115),
    [anon_sym__Noreturn] = ACTIONS(5115),
    [anon_sym_noreturn] = ACTIONS(5115),
    [anon_sym_mutable] = ACTIONS(5115),
    [anon_sym_constinit] = ACTIONS(5115),
    [anon_sym_consteval] = ACTIONS(5115),
    [anon_sym___shared__] = ACTIONS(5115),
    [anon_sym___local__] = ACTIONS(5115),
    [anon_sym___constant__] = ACTIONS(5115),
    [anon_sym___managed__] = ACTIONS(5115),
    [anon_sym___grid_constant__] = ACTIONS(5115),
    [anon_sym_alignas] = ACTIONS(5115),
    [anon_sym__Alignas] = ACTIONS(5115),
    [sym_primitive_type] = ACTIONS(5115),
    [anon_sym_enum] = ACTIONS(5115),
    [anon_sym_class] = ACTIONS(5115),
    [anon_sym_struct] = ACTIONS(5115),
    [anon_sym_union] = ACTIONS(5115),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5115),
    [anon_sym_decltype] = ACTIONS(5115),
    [sym_virtual] = ACTIONS(5115),
    [anon_sym_explicit] = ACTIONS(5115),
    [anon_sym_typename] = ACTIONS(5115),
    [anon_sym_template] = ACTIONS(5115),
    [anon_sym_operator] = ACTIONS(5115),
    [anon_sym_friend] = ACTIONS(5115),
    [anon_sym_public] = ACTIONS(5115),
    [anon_sym_private] = ACTIONS(5115),
    [anon_sym_protected] = ACTIONS(5115),
    [anon_sym_using] = ACTIONS(5115),
    [anon_sym_static_assert] = ACTIONS(5115),
    [anon_sym___launch_bounds__] = ACTIONS(5115),
  },
  [1887] = {
    [sym_identifier] = ACTIONS(2154),
    [aux_sym_preproc_def_token1] = ACTIONS(2154),
    [aux_sym_preproc_if_token1] = ACTIONS(2154),
    [aux_sym_preproc_if_token2] = ACTIONS(2154),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2154),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2154),
    [sym_preproc_directive] = ACTIONS(2154),
    [anon_sym_LPAREN2] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_AMP_AMP] = ACTIONS(2156),
    [anon_sym_AMP] = ACTIONS(2154),
    [anon_sym___extension__] = ACTIONS(2154),
    [anon_sym_typedef] = ACTIONS(2154),
    [anon_sym___device__] = ACTIONS(2154),
    [anon_sym___host__] = ACTIONS(2154),
    [anon_sym___global__] = ACTIONS(2154),
    [anon_sym___forceinline__] = ACTIONS(2154),
    [anon_sym___noinline__] = ACTIONS(2154),
    [anon_sym_extern] = ACTIONS(2154),
    [anon_sym___attribute__] = ACTIONS(2154),
    [anon_sym_COLON_COLON] = ACTIONS(2156),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2156),
    [anon_sym___declspec] = ACTIONS(2154),
    [anon_sym___based] = ACTIONS(2154),
    [anon_sym_signed] = ACTIONS(2154),
    [anon_sym_unsigned] = ACTIONS(2154),
    [anon_sym_long] = ACTIONS(2154),
    [anon_sym_short] = ACTIONS(2154),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_static] = ACTIONS(2154),
    [anon_sym_register] = ACTIONS(2154),
    [anon_sym_inline] = ACTIONS(2154),
    [anon_sym___inline] = ACTIONS(2154),
    [anon_sym___inline__] = ACTIONS(2154),
    [anon_sym___forceinline] = ACTIONS(2154),
    [anon_sym_thread_local] = ACTIONS(2154),
    [anon_sym___thread] = ACTIONS(2154),
    [anon_sym_const] = ACTIONS(2154),
    [anon_sym_constexpr] = ACTIONS(2154),
    [anon_sym_volatile] = ACTIONS(2154),
    [anon_sym_restrict] = ACTIONS(2154),
    [anon_sym___restrict__] = ACTIONS(2154),
    [anon_sym__Atomic] = ACTIONS(2154),
    [anon_sym__Noreturn] = ACTIONS(2154),
    [anon_sym_noreturn] = ACTIONS(2154),
    [anon_sym_mutable] = ACTIONS(2154),
    [anon_sym_constinit] = ACTIONS(2154),
    [anon_sym_consteval] = ACTIONS(2154),
    [anon_sym___shared__] = ACTIONS(2154),
    [anon_sym___local__] = ACTIONS(2154),
    [anon_sym___constant__] = ACTIONS(2154),
    [anon_sym___managed__] = ACTIONS(2154),
    [anon_sym___grid_constant__] = ACTIONS(2154),
    [anon_sym_alignas] = ACTIONS(2154),
    [anon_sym__Alignas] = ACTIONS(2154),
    [sym_primitive_type] = ACTIONS(2154),
    [anon_sym_enum] = ACTIONS(2154),
    [anon_sym_class] = ACTIONS(2154),
    [anon_sym_struct] = ACTIONS(2154),
    [anon_sym_union] = ACTIONS(2154),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2154),
    [anon_sym_decltype] = ACTIONS(2154),
    [sym_virtual] = ACTIONS(2154),
    [anon_sym_explicit] = ACTIONS(2154),
    [anon_sym_typename] = ACTIONS(2154),
    [anon_sym_template] = ACTIONS(2154),
    [anon_sym_operator] = ACTIONS(2154),
    [anon_sym_friend] = ACTIONS(2154),
    [anon_sym_public] = ACTIONS(2154),
    [anon_sym_private] = ACTIONS(2154),
    [anon_sym_protected] = ACTIONS(2154),
    [anon_sym_using] = ACTIONS(2154),
    [anon_sym_static_assert] = ACTIONS(2154),
    [anon_sym___launch_bounds__] = ACTIONS(2154),
  },
  [1888] = {
    [sym_identifier] = ACTIONS(2473),
    [aux_sym_preproc_def_token1] = ACTIONS(2473),
    [aux_sym_preproc_if_token1] = ACTIONS(2473),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2473),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2473),
    [sym_preproc_directive] = ACTIONS(2473),
    [anon_sym_LPAREN2] = ACTIONS(2475),
    [anon_sym_TILDE] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(2475),
    [anon_sym_AMP_AMP] = ACTIONS(2475),
    [anon_sym_AMP] = ACTIONS(2473),
    [anon_sym___extension__] = ACTIONS(2473),
    [anon_sym_typedef] = ACTIONS(2473),
    [anon_sym___device__] = ACTIONS(2473),
    [anon_sym___host__] = ACTIONS(2473),
    [anon_sym___global__] = ACTIONS(2473),
    [anon_sym___forceinline__] = ACTIONS(2473),
    [anon_sym___noinline__] = ACTIONS(2473),
    [anon_sym_extern] = ACTIONS(2473),
    [anon_sym___attribute__] = ACTIONS(2473),
    [anon_sym_COLON_COLON] = ACTIONS(2475),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2475),
    [anon_sym___declspec] = ACTIONS(2473),
    [anon_sym___based] = ACTIONS(2473),
    [anon_sym_RBRACE] = ACTIONS(2475),
    [anon_sym_signed] = ACTIONS(2473),
    [anon_sym_unsigned] = ACTIONS(2473),
    [anon_sym_long] = ACTIONS(2473),
    [anon_sym_short] = ACTIONS(2473),
    [anon_sym_LBRACK] = ACTIONS(2473),
    [anon_sym_static] = ACTIONS(2473),
    [anon_sym_register] = ACTIONS(2473),
    [anon_sym_inline] = ACTIONS(2473),
    [anon_sym___inline] = ACTIONS(2473),
    [anon_sym___inline__] = ACTIONS(2473),
    [anon_sym___forceinline] = ACTIONS(2473),
    [anon_sym_thread_local] = ACTIONS(2473),
    [anon_sym___thread] = ACTIONS(2473),
    [anon_sym_const] = ACTIONS(2473),
    [anon_sym_constexpr] = ACTIONS(2473),
    [anon_sym_volatile] = ACTIONS(2473),
    [anon_sym_restrict] = ACTIONS(2473),
    [anon_sym___restrict__] = ACTIONS(2473),
    [anon_sym__Atomic] = ACTIONS(2473),
    [anon_sym__Noreturn] = ACTIONS(2473),
    [anon_sym_noreturn] = ACTIONS(2473),
    [anon_sym_mutable] = ACTIONS(2473),
    [anon_sym_constinit] = ACTIONS(2473),
    [anon_sym_consteval] = ACTIONS(2473),
    [anon_sym___shared__] = ACTIONS(2473),
    [anon_sym___local__] = ACTIONS(2473),
    [anon_sym___constant__] = ACTIONS(2473),
    [anon_sym___managed__] = ACTIONS(2473),
    [anon_sym___grid_constant__] = ACTIONS(2473),
    [anon_sym_alignas] = ACTIONS(2473),
    [anon_sym__Alignas] = ACTIONS(2473),
    [sym_primitive_type] = ACTIONS(2473),
    [anon_sym_enum] = ACTIONS(2473),
    [anon_sym_class] = ACTIONS(2473),
    [anon_sym_struct] = ACTIONS(2473),
    [anon_sym_union] = ACTIONS(2473),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2473),
    [anon_sym_decltype] = ACTIONS(2473),
    [sym_virtual] = ACTIONS(2473),
    [anon_sym_explicit] = ACTIONS(2473),
    [anon_sym_typename] = ACTIONS(2473),
    [anon_sym_template] = ACTIONS(2473),
    [anon_sym_operator] = ACTIONS(2473),
    [anon_sym_friend] = ACTIONS(2473),
    [anon_sym_public] = ACTIONS(2473),
    [anon_sym_private] = ACTIONS(2473),
    [anon_sym_protected] = ACTIONS(2473),
    [anon_sym_using] = ACTIONS(2473),
    [anon_sym_static_assert] = ACTIONS(2473),
    [anon_sym___launch_bounds__] = ACTIONS(2473),
  },
  [1889] = {
    [sym_identifier] = ACTIONS(5131),
    [aux_sym_preproc_def_token1] = ACTIONS(5131),
    [aux_sym_preproc_if_token1] = ACTIONS(5131),
    [aux_sym_preproc_if_token2] = ACTIONS(5131),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5131),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5131),
    [sym_preproc_directive] = ACTIONS(5131),
    [anon_sym_LPAREN2] = ACTIONS(5133),
    [anon_sym_TILDE] = ACTIONS(5133),
    [anon_sym_STAR] = ACTIONS(5133),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5131),
    [anon_sym___extension__] = ACTIONS(5131),
    [anon_sym_typedef] = ACTIONS(5131),
    [anon_sym___device__] = ACTIONS(5131),
    [anon_sym___host__] = ACTIONS(5131),
    [anon_sym___global__] = ACTIONS(5131),
    [anon_sym___forceinline__] = ACTIONS(5131),
    [anon_sym___noinline__] = ACTIONS(5131),
    [anon_sym_extern] = ACTIONS(5131),
    [anon_sym___attribute__] = ACTIONS(5131),
    [anon_sym_COLON_COLON] = ACTIONS(5133),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5133),
    [anon_sym___declspec] = ACTIONS(5131),
    [anon_sym___based] = ACTIONS(5131),
    [anon_sym_signed] = ACTIONS(5131),
    [anon_sym_unsigned] = ACTIONS(5131),
    [anon_sym_long] = ACTIONS(5131),
    [anon_sym_short] = ACTIONS(5131),
    [anon_sym_LBRACK] = ACTIONS(5131),
    [anon_sym_static] = ACTIONS(5131),
    [anon_sym_register] = ACTIONS(5131),
    [anon_sym_inline] = ACTIONS(5131),
    [anon_sym___inline] = ACTIONS(5131),
    [anon_sym___inline__] = ACTIONS(5131),
    [anon_sym___forceinline] = ACTIONS(5131),
    [anon_sym_thread_local] = ACTIONS(5131),
    [anon_sym___thread] = ACTIONS(5131),
    [anon_sym_const] = ACTIONS(5131),
    [anon_sym_constexpr] = ACTIONS(5131),
    [anon_sym_volatile] = ACTIONS(5131),
    [anon_sym_restrict] = ACTIONS(5131),
    [anon_sym___restrict__] = ACTIONS(5131),
    [anon_sym__Atomic] = ACTIONS(5131),
    [anon_sym__Noreturn] = ACTIONS(5131),
    [anon_sym_noreturn] = ACTIONS(5131),
    [anon_sym_mutable] = ACTIONS(5131),
    [anon_sym_constinit] = ACTIONS(5131),
    [anon_sym_consteval] = ACTIONS(5131),
    [anon_sym___shared__] = ACTIONS(5131),
    [anon_sym___local__] = ACTIONS(5131),
    [anon_sym___constant__] = ACTIONS(5131),
    [anon_sym___managed__] = ACTIONS(5131),
    [anon_sym___grid_constant__] = ACTIONS(5131),
    [anon_sym_alignas] = ACTIONS(5131),
    [anon_sym__Alignas] = ACTIONS(5131),
    [sym_primitive_type] = ACTIONS(5131),
    [anon_sym_enum] = ACTIONS(5131),
    [anon_sym_class] = ACTIONS(5131),
    [anon_sym_struct] = ACTIONS(5131),
    [anon_sym_union] = ACTIONS(5131),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5131),
    [anon_sym_decltype] = ACTIONS(5131),
    [sym_virtual] = ACTIONS(5131),
    [anon_sym_explicit] = ACTIONS(5131),
    [anon_sym_typename] = ACTIONS(5131),
    [anon_sym_template] = ACTIONS(5131),
    [anon_sym_operator] = ACTIONS(5131),
    [anon_sym_friend] = ACTIONS(5131),
    [anon_sym_public] = ACTIONS(5131),
    [anon_sym_private] = ACTIONS(5131),
    [anon_sym_protected] = ACTIONS(5131),
    [anon_sym_using] = ACTIONS(5131),
    [anon_sym_static_assert] = ACTIONS(5131),
    [anon_sym___launch_bounds__] = ACTIONS(5131),
  },
  [1890] = {
    [sym_identifier] = ACTIONS(5131),
    [aux_sym_preproc_def_token1] = ACTIONS(5131),
    [aux_sym_preproc_if_token1] = ACTIONS(5131),
    [aux_sym_preproc_if_token2] = ACTIONS(5131),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5131),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5131),
    [sym_preproc_directive] = ACTIONS(5131),
    [anon_sym_LPAREN2] = ACTIONS(5133),
    [anon_sym_TILDE] = ACTIONS(5133),
    [anon_sym_STAR] = ACTIONS(5133),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5131),
    [anon_sym___extension__] = ACTIONS(5131),
    [anon_sym_typedef] = ACTIONS(5131),
    [anon_sym___device__] = ACTIONS(5131),
    [anon_sym___host__] = ACTIONS(5131),
    [anon_sym___global__] = ACTIONS(5131),
    [anon_sym___forceinline__] = ACTIONS(5131),
    [anon_sym___noinline__] = ACTIONS(5131),
    [anon_sym_extern] = ACTIONS(5131),
    [anon_sym___attribute__] = ACTIONS(5131),
    [anon_sym_COLON_COLON] = ACTIONS(5133),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5133),
    [anon_sym___declspec] = ACTIONS(5131),
    [anon_sym___based] = ACTIONS(5131),
    [anon_sym_signed] = ACTIONS(5131),
    [anon_sym_unsigned] = ACTIONS(5131),
    [anon_sym_long] = ACTIONS(5131),
    [anon_sym_short] = ACTIONS(5131),
    [anon_sym_LBRACK] = ACTIONS(5131),
    [anon_sym_static] = ACTIONS(5131),
    [anon_sym_register] = ACTIONS(5131),
    [anon_sym_inline] = ACTIONS(5131),
    [anon_sym___inline] = ACTIONS(5131),
    [anon_sym___inline__] = ACTIONS(5131),
    [anon_sym___forceinline] = ACTIONS(5131),
    [anon_sym_thread_local] = ACTIONS(5131),
    [anon_sym___thread] = ACTIONS(5131),
    [anon_sym_const] = ACTIONS(5131),
    [anon_sym_constexpr] = ACTIONS(5131),
    [anon_sym_volatile] = ACTIONS(5131),
    [anon_sym_restrict] = ACTIONS(5131),
    [anon_sym___restrict__] = ACTIONS(5131),
    [anon_sym__Atomic] = ACTIONS(5131),
    [anon_sym__Noreturn] = ACTIONS(5131),
    [anon_sym_noreturn] = ACTIONS(5131),
    [anon_sym_mutable] = ACTIONS(5131),
    [anon_sym_constinit] = ACTIONS(5131),
    [anon_sym_consteval] = ACTIONS(5131),
    [anon_sym___shared__] = ACTIONS(5131),
    [anon_sym___local__] = ACTIONS(5131),
    [anon_sym___constant__] = ACTIONS(5131),
    [anon_sym___managed__] = ACTIONS(5131),
    [anon_sym___grid_constant__] = ACTIONS(5131),
    [anon_sym_alignas] = ACTIONS(5131),
    [anon_sym__Alignas] = ACTIONS(5131),
    [sym_primitive_type] = ACTIONS(5131),
    [anon_sym_enum] = ACTIONS(5131),
    [anon_sym_class] = ACTIONS(5131),
    [anon_sym_struct] = ACTIONS(5131),
    [anon_sym_union] = ACTIONS(5131),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5131),
    [anon_sym_decltype] = ACTIONS(5131),
    [sym_virtual] = ACTIONS(5131),
    [anon_sym_explicit] = ACTIONS(5131),
    [anon_sym_typename] = ACTIONS(5131),
    [anon_sym_template] = ACTIONS(5131),
    [anon_sym_operator] = ACTIONS(5131),
    [anon_sym_friend] = ACTIONS(5131),
    [anon_sym_public] = ACTIONS(5131),
    [anon_sym_private] = ACTIONS(5131),
    [anon_sym_protected] = ACTIONS(5131),
    [anon_sym_using] = ACTIONS(5131),
    [anon_sym_static_assert] = ACTIONS(5131),
    [anon_sym___launch_bounds__] = ACTIONS(5131),
  },
  [1891] = {
    [sym_identifier] = ACTIONS(5127),
    [aux_sym_preproc_def_token1] = ACTIONS(5127),
    [aux_sym_preproc_if_token1] = ACTIONS(5127),
    [aux_sym_preproc_if_token2] = ACTIONS(5127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5127),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5127),
    [sym_preproc_directive] = ACTIONS(5127),
    [anon_sym_LPAREN2] = ACTIONS(5129),
    [anon_sym_TILDE] = ACTIONS(5129),
    [anon_sym_STAR] = ACTIONS(5129),
    [anon_sym_AMP_AMP] = ACTIONS(5129),
    [anon_sym_AMP] = ACTIONS(5127),
    [anon_sym___extension__] = ACTIONS(5127),
    [anon_sym_typedef] = ACTIONS(5127),
    [anon_sym___device__] = ACTIONS(5127),
    [anon_sym___host__] = ACTIONS(5127),
    [anon_sym___global__] = ACTIONS(5127),
    [anon_sym___forceinline__] = ACTIONS(5127),
    [anon_sym___noinline__] = ACTIONS(5127),
    [anon_sym_extern] = ACTIONS(5127),
    [anon_sym___attribute__] = ACTIONS(5127),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5129),
    [anon_sym___declspec] = ACTIONS(5127),
    [anon_sym___based] = ACTIONS(5127),
    [anon_sym_signed] = ACTIONS(5127),
    [anon_sym_unsigned] = ACTIONS(5127),
    [anon_sym_long] = ACTIONS(5127),
    [anon_sym_short] = ACTIONS(5127),
    [anon_sym_LBRACK] = ACTIONS(5127),
    [anon_sym_static] = ACTIONS(5127),
    [anon_sym_register] = ACTIONS(5127),
    [anon_sym_inline] = ACTIONS(5127),
    [anon_sym___inline] = ACTIONS(5127),
    [anon_sym___inline__] = ACTIONS(5127),
    [anon_sym___forceinline] = ACTIONS(5127),
    [anon_sym_thread_local] = ACTIONS(5127),
    [anon_sym___thread] = ACTIONS(5127),
    [anon_sym_const] = ACTIONS(5127),
    [anon_sym_constexpr] = ACTIONS(5127),
    [anon_sym_volatile] = ACTIONS(5127),
    [anon_sym_restrict] = ACTIONS(5127),
    [anon_sym___restrict__] = ACTIONS(5127),
    [anon_sym__Atomic] = ACTIONS(5127),
    [anon_sym__Noreturn] = ACTIONS(5127),
    [anon_sym_noreturn] = ACTIONS(5127),
    [anon_sym_mutable] = ACTIONS(5127),
    [anon_sym_constinit] = ACTIONS(5127),
    [anon_sym_consteval] = ACTIONS(5127),
    [anon_sym___shared__] = ACTIONS(5127),
    [anon_sym___local__] = ACTIONS(5127),
    [anon_sym___constant__] = ACTIONS(5127),
    [anon_sym___managed__] = ACTIONS(5127),
    [anon_sym___grid_constant__] = ACTIONS(5127),
    [anon_sym_alignas] = ACTIONS(5127),
    [anon_sym__Alignas] = ACTIONS(5127),
    [sym_primitive_type] = ACTIONS(5127),
    [anon_sym_enum] = ACTIONS(5127),
    [anon_sym_class] = ACTIONS(5127),
    [anon_sym_struct] = ACTIONS(5127),
    [anon_sym_union] = ACTIONS(5127),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5127),
    [anon_sym_decltype] = ACTIONS(5127),
    [sym_virtual] = ACTIONS(5127),
    [anon_sym_explicit] = ACTIONS(5127),
    [anon_sym_typename] = ACTIONS(5127),
    [anon_sym_template] = ACTIONS(5127),
    [anon_sym_operator] = ACTIONS(5127),
    [anon_sym_friend] = ACTIONS(5127),
    [anon_sym_public] = ACTIONS(5127),
    [anon_sym_private] = ACTIONS(5127),
    [anon_sym_protected] = ACTIONS(5127),
    [anon_sym_using] = ACTIONS(5127),
    [anon_sym_static_assert] = ACTIONS(5127),
    [anon_sym___launch_bounds__] = ACTIONS(5127),
  },
  [1892] = {
    [sym_identifier] = ACTIONS(5123),
    [aux_sym_preproc_def_token1] = ACTIONS(5123),
    [aux_sym_preproc_if_token1] = ACTIONS(5123),
    [aux_sym_preproc_if_token2] = ACTIONS(5123),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5123),
    [sym_preproc_directive] = ACTIONS(5123),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_TILDE] = ACTIONS(5125),
    [anon_sym_STAR] = ACTIONS(5125),
    [anon_sym_AMP_AMP] = ACTIONS(5125),
    [anon_sym_AMP] = ACTIONS(5123),
    [anon_sym___extension__] = ACTIONS(5123),
    [anon_sym_typedef] = ACTIONS(5123),
    [anon_sym___device__] = ACTIONS(5123),
    [anon_sym___host__] = ACTIONS(5123),
    [anon_sym___global__] = ACTIONS(5123),
    [anon_sym___forceinline__] = ACTIONS(5123),
    [anon_sym___noinline__] = ACTIONS(5123),
    [anon_sym_extern] = ACTIONS(5123),
    [anon_sym___attribute__] = ACTIONS(5123),
    [anon_sym_COLON_COLON] = ACTIONS(5125),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5125),
    [anon_sym___declspec] = ACTIONS(5123),
    [anon_sym___based] = ACTIONS(5123),
    [anon_sym_signed] = ACTIONS(5123),
    [anon_sym_unsigned] = ACTIONS(5123),
    [anon_sym_long] = ACTIONS(5123),
    [anon_sym_short] = ACTIONS(5123),
    [anon_sym_LBRACK] = ACTIONS(5123),
    [anon_sym_static] = ACTIONS(5123),
    [anon_sym_register] = ACTIONS(5123),
    [anon_sym_inline] = ACTIONS(5123),
    [anon_sym___inline] = ACTIONS(5123),
    [anon_sym___inline__] = ACTIONS(5123),
    [anon_sym___forceinline] = ACTIONS(5123),
    [anon_sym_thread_local] = ACTIONS(5123),
    [anon_sym___thread] = ACTIONS(5123),
    [anon_sym_const] = ACTIONS(5123),
    [anon_sym_constexpr] = ACTIONS(5123),
    [anon_sym_volatile] = ACTIONS(5123),
    [anon_sym_restrict] = ACTIONS(5123),
    [anon_sym___restrict__] = ACTIONS(5123),
    [anon_sym__Atomic] = ACTIONS(5123),
    [anon_sym__Noreturn] = ACTIONS(5123),
    [anon_sym_noreturn] = ACTIONS(5123),
    [anon_sym_mutable] = ACTIONS(5123),
    [anon_sym_constinit] = ACTIONS(5123),
    [anon_sym_consteval] = ACTIONS(5123),
    [anon_sym___shared__] = ACTIONS(5123),
    [anon_sym___local__] = ACTIONS(5123),
    [anon_sym___constant__] = ACTIONS(5123),
    [anon_sym___managed__] = ACTIONS(5123),
    [anon_sym___grid_constant__] = ACTIONS(5123),
    [anon_sym_alignas] = ACTIONS(5123),
    [anon_sym__Alignas] = ACTIONS(5123),
    [sym_primitive_type] = ACTIONS(5123),
    [anon_sym_enum] = ACTIONS(5123),
    [anon_sym_class] = ACTIONS(5123),
    [anon_sym_struct] = ACTIONS(5123),
    [anon_sym_union] = ACTIONS(5123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5123),
    [anon_sym_decltype] = ACTIONS(5123),
    [sym_virtual] = ACTIONS(5123),
    [anon_sym_explicit] = ACTIONS(5123),
    [anon_sym_typename] = ACTIONS(5123),
    [anon_sym_template] = ACTIONS(5123),
    [anon_sym_operator] = ACTIONS(5123),
    [anon_sym_friend] = ACTIONS(5123),
    [anon_sym_public] = ACTIONS(5123),
    [anon_sym_private] = ACTIONS(5123),
    [anon_sym_protected] = ACTIONS(5123),
    [anon_sym_using] = ACTIONS(5123),
    [anon_sym_static_assert] = ACTIONS(5123),
    [anon_sym___launch_bounds__] = ACTIONS(5123),
  },
  [1893] = {
    [sym_identifier] = ACTIONS(5111),
    [aux_sym_preproc_def_token1] = ACTIONS(5111),
    [aux_sym_preproc_if_token1] = ACTIONS(5111),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5111),
    [sym_preproc_directive] = ACTIONS(5111),
    [anon_sym_LPAREN2] = ACTIONS(5113),
    [anon_sym_TILDE] = ACTIONS(5113),
    [anon_sym_STAR] = ACTIONS(5113),
    [anon_sym_AMP_AMP] = ACTIONS(5113),
    [anon_sym_AMP] = ACTIONS(5111),
    [anon_sym___extension__] = ACTIONS(5111),
    [anon_sym_typedef] = ACTIONS(5111),
    [anon_sym___device__] = ACTIONS(5111),
    [anon_sym___host__] = ACTIONS(5111),
    [anon_sym___global__] = ACTIONS(5111),
    [anon_sym___forceinline__] = ACTIONS(5111),
    [anon_sym___noinline__] = ACTIONS(5111),
    [anon_sym_extern] = ACTIONS(5111),
    [anon_sym___attribute__] = ACTIONS(5111),
    [anon_sym_COLON_COLON] = ACTIONS(5113),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5113),
    [anon_sym___declspec] = ACTIONS(5111),
    [anon_sym___based] = ACTIONS(5111),
    [anon_sym_RBRACE] = ACTIONS(5113),
    [anon_sym_signed] = ACTIONS(5111),
    [anon_sym_unsigned] = ACTIONS(5111),
    [anon_sym_long] = ACTIONS(5111),
    [anon_sym_short] = ACTIONS(5111),
    [anon_sym_LBRACK] = ACTIONS(5111),
    [anon_sym_static] = ACTIONS(5111),
    [anon_sym_register] = ACTIONS(5111),
    [anon_sym_inline] = ACTIONS(5111),
    [anon_sym___inline] = ACTIONS(5111),
    [anon_sym___inline__] = ACTIONS(5111),
    [anon_sym___forceinline] = ACTIONS(5111),
    [anon_sym_thread_local] = ACTIONS(5111),
    [anon_sym___thread] = ACTIONS(5111),
    [anon_sym_const] = ACTIONS(5111),
    [anon_sym_constexpr] = ACTIONS(5111),
    [anon_sym_volatile] = ACTIONS(5111),
    [anon_sym_restrict] = ACTIONS(5111),
    [anon_sym___restrict__] = ACTIONS(5111),
    [anon_sym__Atomic] = ACTIONS(5111),
    [anon_sym__Noreturn] = ACTIONS(5111),
    [anon_sym_noreturn] = ACTIONS(5111),
    [anon_sym_mutable] = ACTIONS(5111),
    [anon_sym_constinit] = ACTIONS(5111),
    [anon_sym_consteval] = ACTIONS(5111),
    [anon_sym___shared__] = ACTIONS(5111),
    [anon_sym___local__] = ACTIONS(5111),
    [anon_sym___constant__] = ACTIONS(5111),
    [anon_sym___managed__] = ACTIONS(5111),
    [anon_sym___grid_constant__] = ACTIONS(5111),
    [anon_sym_alignas] = ACTIONS(5111),
    [anon_sym__Alignas] = ACTIONS(5111),
    [sym_primitive_type] = ACTIONS(5111),
    [anon_sym_enum] = ACTIONS(5111),
    [anon_sym_class] = ACTIONS(5111),
    [anon_sym_struct] = ACTIONS(5111),
    [anon_sym_union] = ACTIONS(5111),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5111),
    [anon_sym_decltype] = ACTIONS(5111),
    [sym_virtual] = ACTIONS(5111),
    [anon_sym_explicit] = ACTIONS(5111),
    [anon_sym_typename] = ACTIONS(5111),
    [anon_sym_template] = ACTIONS(5111),
    [anon_sym_operator] = ACTIONS(5111),
    [anon_sym_friend] = ACTIONS(5111),
    [anon_sym_public] = ACTIONS(5111),
    [anon_sym_private] = ACTIONS(5111),
    [anon_sym_protected] = ACTIONS(5111),
    [anon_sym_using] = ACTIONS(5111),
    [anon_sym_static_assert] = ACTIONS(5111),
    [anon_sym___launch_bounds__] = ACTIONS(5111),
  },
  [1894] = {
    [sym_identifier] = ACTIONS(5119),
    [aux_sym_preproc_def_token1] = ACTIONS(5119),
    [aux_sym_preproc_if_token1] = ACTIONS(5119),
    [aux_sym_preproc_if_token2] = ACTIONS(5119),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5119),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5119),
    [sym_preproc_directive] = ACTIONS(5119),
    [anon_sym_LPAREN2] = ACTIONS(5121),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_STAR] = ACTIONS(5121),
    [anon_sym_AMP_AMP] = ACTIONS(5121),
    [anon_sym_AMP] = ACTIONS(5119),
    [anon_sym___extension__] = ACTIONS(5119),
    [anon_sym_typedef] = ACTIONS(5119),
    [anon_sym___device__] = ACTIONS(5119),
    [anon_sym___host__] = ACTIONS(5119),
    [anon_sym___global__] = ACTIONS(5119),
    [anon_sym___forceinline__] = ACTIONS(5119),
    [anon_sym___noinline__] = ACTIONS(5119),
    [anon_sym_extern] = ACTIONS(5119),
    [anon_sym___attribute__] = ACTIONS(5119),
    [anon_sym_COLON_COLON] = ACTIONS(5121),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5121),
    [anon_sym___declspec] = ACTIONS(5119),
    [anon_sym___based] = ACTIONS(5119),
    [anon_sym_signed] = ACTIONS(5119),
    [anon_sym_unsigned] = ACTIONS(5119),
    [anon_sym_long] = ACTIONS(5119),
    [anon_sym_short] = ACTIONS(5119),
    [anon_sym_LBRACK] = ACTIONS(5119),
    [anon_sym_static] = ACTIONS(5119),
    [anon_sym_register] = ACTIONS(5119),
    [anon_sym_inline] = ACTIONS(5119),
    [anon_sym___inline] = ACTIONS(5119),
    [anon_sym___inline__] = ACTIONS(5119),
    [anon_sym___forceinline] = ACTIONS(5119),
    [anon_sym_thread_local] = ACTIONS(5119),
    [anon_sym___thread] = ACTIONS(5119),
    [anon_sym_const] = ACTIONS(5119),
    [anon_sym_constexpr] = ACTIONS(5119),
    [anon_sym_volatile] = ACTIONS(5119),
    [anon_sym_restrict] = ACTIONS(5119),
    [anon_sym___restrict__] = ACTIONS(5119),
    [anon_sym__Atomic] = ACTIONS(5119),
    [anon_sym__Noreturn] = ACTIONS(5119),
    [anon_sym_noreturn] = ACTIONS(5119),
    [anon_sym_mutable] = ACTIONS(5119),
    [anon_sym_constinit] = ACTIONS(5119),
    [anon_sym_consteval] = ACTIONS(5119),
    [anon_sym___shared__] = ACTIONS(5119),
    [anon_sym___local__] = ACTIONS(5119),
    [anon_sym___constant__] = ACTIONS(5119),
    [anon_sym___managed__] = ACTIONS(5119),
    [anon_sym___grid_constant__] = ACTIONS(5119),
    [anon_sym_alignas] = ACTIONS(5119),
    [anon_sym__Alignas] = ACTIONS(5119),
    [sym_primitive_type] = ACTIONS(5119),
    [anon_sym_enum] = ACTIONS(5119),
    [anon_sym_class] = ACTIONS(5119),
    [anon_sym_struct] = ACTIONS(5119),
    [anon_sym_union] = ACTIONS(5119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5119),
    [anon_sym_decltype] = ACTIONS(5119),
    [sym_virtual] = ACTIONS(5119),
    [anon_sym_explicit] = ACTIONS(5119),
    [anon_sym_typename] = ACTIONS(5119),
    [anon_sym_template] = ACTIONS(5119),
    [anon_sym_operator] = ACTIONS(5119),
    [anon_sym_friend] = ACTIONS(5119),
    [anon_sym_public] = ACTIONS(5119),
    [anon_sym_private] = ACTIONS(5119),
    [anon_sym_protected] = ACTIONS(5119),
    [anon_sym_using] = ACTIONS(5119),
    [anon_sym_static_assert] = ACTIONS(5119),
    [anon_sym___launch_bounds__] = ACTIONS(5119),
  },
  [1895] = {
    [sym_identifier] = ACTIONS(5115),
    [aux_sym_preproc_def_token1] = ACTIONS(5115),
    [aux_sym_preproc_if_token1] = ACTIONS(5115),
    [aux_sym_preproc_if_token2] = ACTIONS(5115),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5115),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5115),
    [sym_preproc_directive] = ACTIONS(5115),
    [anon_sym_LPAREN2] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(5117),
    [anon_sym_STAR] = ACTIONS(5117),
    [anon_sym_AMP_AMP] = ACTIONS(5117),
    [anon_sym_AMP] = ACTIONS(5115),
    [anon_sym___extension__] = ACTIONS(5115),
    [anon_sym_typedef] = ACTIONS(5115),
    [anon_sym___device__] = ACTIONS(5115),
    [anon_sym___host__] = ACTIONS(5115),
    [anon_sym___global__] = ACTIONS(5115),
    [anon_sym___forceinline__] = ACTIONS(5115),
    [anon_sym___noinline__] = ACTIONS(5115),
    [anon_sym_extern] = ACTIONS(5115),
    [anon_sym___attribute__] = ACTIONS(5115),
    [anon_sym_COLON_COLON] = ACTIONS(5117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5117),
    [anon_sym___declspec] = ACTIONS(5115),
    [anon_sym___based] = ACTIONS(5115),
    [anon_sym_signed] = ACTIONS(5115),
    [anon_sym_unsigned] = ACTIONS(5115),
    [anon_sym_long] = ACTIONS(5115),
    [anon_sym_short] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_static] = ACTIONS(5115),
    [anon_sym_register] = ACTIONS(5115),
    [anon_sym_inline] = ACTIONS(5115),
    [anon_sym___inline] = ACTIONS(5115),
    [anon_sym___inline__] = ACTIONS(5115),
    [anon_sym___forceinline] = ACTIONS(5115),
    [anon_sym_thread_local] = ACTIONS(5115),
    [anon_sym___thread] = ACTIONS(5115),
    [anon_sym_const] = ACTIONS(5115),
    [anon_sym_constexpr] = ACTIONS(5115),
    [anon_sym_volatile] = ACTIONS(5115),
    [anon_sym_restrict] = ACTIONS(5115),
    [anon_sym___restrict__] = ACTIONS(5115),
    [anon_sym__Atomic] = ACTIONS(5115),
    [anon_sym__Noreturn] = ACTIONS(5115),
    [anon_sym_noreturn] = ACTIONS(5115),
    [anon_sym_mutable] = ACTIONS(5115),
    [anon_sym_constinit] = ACTIONS(5115),
    [anon_sym_consteval] = ACTIONS(5115),
    [anon_sym___shared__] = ACTIONS(5115),
    [anon_sym___local__] = ACTIONS(5115),
    [anon_sym___constant__] = ACTIONS(5115),
    [anon_sym___managed__] = ACTIONS(5115),
    [anon_sym___grid_constant__] = ACTIONS(5115),
    [anon_sym_alignas] = ACTIONS(5115),
    [anon_sym__Alignas] = ACTIONS(5115),
    [sym_primitive_type] = ACTIONS(5115),
    [anon_sym_enum] = ACTIONS(5115),
    [anon_sym_class] = ACTIONS(5115),
    [anon_sym_struct] = ACTIONS(5115),
    [anon_sym_union] = ACTIONS(5115),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5115),
    [anon_sym_decltype] = ACTIONS(5115),
    [sym_virtual] = ACTIONS(5115),
    [anon_sym_explicit] = ACTIONS(5115),
    [anon_sym_typename] = ACTIONS(5115),
    [anon_sym_template] = ACTIONS(5115),
    [anon_sym_operator] = ACTIONS(5115),
    [anon_sym_friend] = ACTIONS(5115),
    [anon_sym_public] = ACTIONS(5115),
    [anon_sym_private] = ACTIONS(5115),
    [anon_sym_protected] = ACTIONS(5115),
    [anon_sym_using] = ACTIONS(5115),
    [anon_sym_static_assert] = ACTIONS(5115),
    [anon_sym___launch_bounds__] = ACTIONS(5115),
  },
  [1896] = {
    [sym_identifier] = ACTIONS(5218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5220),
    [anon_sym_COMMA] = ACTIONS(5220),
    [anon_sym_RPAREN] = ACTIONS(5220),
    [anon_sym_LPAREN2] = ACTIONS(5220),
    [anon_sym_DASH] = ACTIONS(5218),
    [anon_sym_PLUS] = ACTIONS(5218),
    [anon_sym_STAR] = ACTIONS(5220),
    [anon_sym_SLASH] = ACTIONS(5218),
    [anon_sym_PERCENT] = ACTIONS(5220),
    [anon_sym_PIPE_PIPE] = ACTIONS(5220),
    [anon_sym_AMP_AMP] = ACTIONS(5220),
    [anon_sym_PIPE] = ACTIONS(5218),
    [anon_sym_CARET] = ACTIONS(5220),
    [anon_sym_AMP] = ACTIONS(5218),
    [anon_sym_EQ_EQ] = ACTIONS(5220),
    [anon_sym_BANG_EQ] = ACTIONS(5220),
    [anon_sym_GT] = ACTIONS(5218),
    [anon_sym_GT_EQ] = ACTIONS(5220),
    [anon_sym_LT_EQ] = ACTIONS(5218),
    [anon_sym_LT] = ACTIONS(5218),
    [anon_sym_LT_LT] = ACTIONS(5218),
    [anon_sym_GT_GT] = ACTIONS(5220),
    [anon_sym_SEMI] = ACTIONS(5220),
    [anon_sym___extension__] = ACTIONS(5218),
    [anon_sym___global__] = ACTIONS(5218),
    [anon_sym___attribute__] = ACTIONS(5218),
    [anon_sym___based] = ACTIONS(5218),
    [anon_sym_LBRACE] = ACTIONS(5220),
    [anon_sym_RBRACE] = ACTIONS(5220),
    [anon_sym_signed] = ACTIONS(5218),
    [anon_sym_unsigned] = ACTIONS(5218),
    [anon_sym_long] = ACTIONS(5218),
    [anon_sym_short] = ACTIONS(5218),
    [anon_sym_LBRACK] = ACTIONS(5220),
    [anon_sym_RBRACK] = ACTIONS(5220),
    [anon_sym_const] = ACTIONS(5218),
    [anon_sym_constexpr] = ACTIONS(5218),
    [anon_sym_volatile] = ACTIONS(5218),
    [anon_sym_restrict] = ACTIONS(5218),
    [anon_sym___restrict__] = ACTIONS(5218),
    [anon_sym__Atomic] = ACTIONS(5218),
    [anon_sym__Noreturn] = ACTIONS(5218),
    [anon_sym_noreturn] = ACTIONS(5218),
    [anon_sym_mutable] = ACTIONS(5218),
    [anon_sym_constinit] = ACTIONS(5218),
    [anon_sym_consteval] = ACTIONS(5218),
    [anon_sym___shared__] = ACTIONS(5218),
    [anon_sym___local__] = ACTIONS(5218),
    [anon_sym___constant__] = ACTIONS(5218),
    [anon_sym___managed__] = ACTIONS(5218),
    [anon_sym___grid_constant__] = ACTIONS(5218),
    [anon_sym_alignas] = ACTIONS(5218),
    [anon_sym__Alignas] = ACTIONS(5218),
    [sym_primitive_type] = ACTIONS(5218),
    [anon_sym_COLON] = ACTIONS(5220),
    [anon_sym_QMARK] = ACTIONS(5220),
    [anon_sym_LT_EQ_GT] = ACTIONS(5220),
    [anon_sym_or] = ACTIONS(5218),
    [anon_sym_and] = ACTIONS(5218),
    [anon_sym_bitor] = ACTIONS(5218),
    [anon_sym_xor] = ACTIONS(5218),
    [anon_sym_bitand] = ACTIONS(5218),
    [anon_sym_not_eq] = ACTIONS(5218),
    [anon_sym_DASH_DASH] = ACTIONS(5220),
    [anon_sym_PLUS_PLUS] = ACTIONS(5220),
    [anon_sym_DOT] = ACTIONS(5218),
    [anon_sym_DOT_STAR] = ACTIONS(5220),
    [anon_sym_DASH_GT] = ACTIONS(5220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5218),
    [anon_sym_decltype] = ACTIONS(5218),
    [anon_sym_final] = ACTIONS(5218),
    [anon_sym_override] = ACTIONS(5218),
    [anon_sym_requires] = ACTIONS(5218),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5220),
  },
  [1897] = {
    [sym_identifier] = ACTIONS(5119),
    [aux_sym_preproc_def_token1] = ACTIONS(5119),
    [aux_sym_preproc_if_token1] = ACTIONS(5119),
    [aux_sym_preproc_if_token2] = ACTIONS(5119),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5119),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5119),
    [sym_preproc_directive] = ACTIONS(5119),
    [anon_sym_LPAREN2] = ACTIONS(5121),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_STAR] = ACTIONS(5121),
    [anon_sym_AMP_AMP] = ACTIONS(5121),
    [anon_sym_AMP] = ACTIONS(5119),
    [anon_sym___extension__] = ACTIONS(5119),
    [anon_sym_typedef] = ACTIONS(5119),
    [anon_sym___device__] = ACTIONS(5119),
    [anon_sym___host__] = ACTIONS(5119),
    [anon_sym___global__] = ACTIONS(5119),
    [anon_sym___forceinline__] = ACTIONS(5119),
    [anon_sym___noinline__] = ACTIONS(5119),
    [anon_sym_extern] = ACTIONS(5119),
    [anon_sym___attribute__] = ACTIONS(5119),
    [anon_sym_COLON_COLON] = ACTIONS(5121),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5121),
    [anon_sym___declspec] = ACTIONS(5119),
    [anon_sym___based] = ACTIONS(5119),
    [anon_sym_signed] = ACTIONS(5119),
    [anon_sym_unsigned] = ACTIONS(5119),
    [anon_sym_long] = ACTIONS(5119),
    [anon_sym_short] = ACTIONS(5119),
    [anon_sym_LBRACK] = ACTIONS(5119),
    [anon_sym_static] = ACTIONS(5119),
    [anon_sym_register] = ACTIONS(5119),
    [anon_sym_inline] = ACTIONS(5119),
    [anon_sym___inline] = ACTIONS(5119),
    [anon_sym___inline__] = ACTIONS(5119),
    [anon_sym___forceinline] = ACTIONS(5119),
    [anon_sym_thread_local] = ACTIONS(5119),
    [anon_sym___thread] = ACTIONS(5119),
    [anon_sym_const] = ACTIONS(5119),
    [anon_sym_constexpr] = ACTIONS(5119),
    [anon_sym_volatile] = ACTIONS(5119),
    [anon_sym_restrict] = ACTIONS(5119),
    [anon_sym___restrict__] = ACTIONS(5119),
    [anon_sym__Atomic] = ACTIONS(5119),
    [anon_sym__Noreturn] = ACTIONS(5119),
    [anon_sym_noreturn] = ACTIONS(5119),
    [anon_sym_mutable] = ACTIONS(5119),
    [anon_sym_constinit] = ACTIONS(5119),
    [anon_sym_consteval] = ACTIONS(5119),
    [anon_sym___shared__] = ACTIONS(5119),
    [anon_sym___local__] = ACTIONS(5119),
    [anon_sym___constant__] = ACTIONS(5119),
    [anon_sym___managed__] = ACTIONS(5119),
    [anon_sym___grid_constant__] = ACTIONS(5119),
    [anon_sym_alignas] = ACTIONS(5119),
    [anon_sym__Alignas] = ACTIONS(5119),
    [sym_primitive_type] = ACTIONS(5119),
    [anon_sym_enum] = ACTIONS(5119),
    [anon_sym_class] = ACTIONS(5119),
    [anon_sym_struct] = ACTIONS(5119),
    [anon_sym_union] = ACTIONS(5119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5119),
    [anon_sym_decltype] = ACTIONS(5119),
    [sym_virtual] = ACTIONS(5119),
    [anon_sym_explicit] = ACTIONS(5119),
    [anon_sym_typename] = ACTIONS(5119),
    [anon_sym_template] = ACTIONS(5119),
    [anon_sym_operator] = ACTIONS(5119),
    [anon_sym_friend] = ACTIONS(5119),
    [anon_sym_public] = ACTIONS(5119),
    [anon_sym_private] = ACTIONS(5119),
    [anon_sym_protected] = ACTIONS(5119),
    [anon_sym_using] = ACTIONS(5119),
    [anon_sym_static_assert] = ACTIONS(5119),
    [anon_sym___launch_bounds__] = ACTIONS(5119),
  },
  [1898] = {
    [sym_identifier] = ACTIONS(2191),
    [aux_sym_preproc_def_token1] = ACTIONS(2191),
    [aux_sym_preproc_if_token1] = ACTIONS(2191),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2191),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2191),
    [sym_preproc_directive] = ACTIONS(2191),
    [anon_sym_LPAREN2] = ACTIONS(2193),
    [anon_sym_TILDE] = ACTIONS(2193),
    [anon_sym_STAR] = ACTIONS(2193),
    [anon_sym_AMP_AMP] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2191),
    [anon_sym___extension__] = ACTIONS(2191),
    [anon_sym_typedef] = ACTIONS(2191),
    [anon_sym___device__] = ACTIONS(2191),
    [anon_sym___host__] = ACTIONS(2191),
    [anon_sym___global__] = ACTIONS(2191),
    [anon_sym___forceinline__] = ACTIONS(2191),
    [anon_sym___noinline__] = ACTIONS(2191),
    [anon_sym_extern] = ACTIONS(2191),
    [anon_sym___attribute__] = ACTIONS(2191),
    [anon_sym_COLON_COLON] = ACTIONS(2193),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2193),
    [anon_sym___declspec] = ACTIONS(2191),
    [anon_sym___based] = ACTIONS(2191),
    [anon_sym_RBRACE] = ACTIONS(2193),
    [anon_sym_signed] = ACTIONS(2191),
    [anon_sym_unsigned] = ACTIONS(2191),
    [anon_sym_long] = ACTIONS(2191),
    [anon_sym_short] = ACTIONS(2191),
    [anon_sym_LBRACK] = ACTIONS(2191),
    [anon_sym_static] = ACTIONS(2191),
    [anon_sym_register] = ACTIONS(2191),
    [anon_sym_inline] = ACTIONS(2191),
    [anon_sym___inline] = ACTIONS(2191),
    [anon_sym___inline__] = ACTIONS(2191),
    [anon_sym___forceinline] = ACTIONS(2191),
    [anon_sym_thread_local] = ACTIONS(2191),
    [anon_sym___thread] = ACTIONS(2191),
    [anon_sym_const] = ACTIONS(2191),
    [anon_sym_constexpr] = ACTIONS(2191),
    [anon_sym_volatile] = ACTIONS(2191),
    [anon_sym_restrict] = ACTIONS(2191),
    [anon_sym___restrict__] = ACTIONS(2191),
    [anon_sym__Atomic] = ACTIONS(2191),
    [anon_sym__Noreturn] = ACTIONS(2191),
    [anon_sym_noreturn] = ACTIONS(2191),
    [anon_sym_mutable] = ACTIONS(2191),
    [anon_sym_constinit] = ACTIONS(2191),
    [anon_sym_consteval] = ACTIONS(2191),
    [anon_sym___shared__] = ACTIONS(2191),
    [anon_sym___local__] = ACTIONS(2191),
    [anon_sym___constant__] = ACTIONS(2191),
    [anon_sym___managed__] = ACTIONS(2191),
    [anon_sym___grid_constant__] = ACTIONS(2191),
    [anon_sym_alignas] = ACTIONS(2191),
    [anon_sym__Alignas] = ACTIONS(2191),
    [sym_primitive_type] = ACTIONS(2191),
    [anon_sym_enum] = ACTIONS(2191),
    [anon_sym_class] = ACTIONS(2191),
    [anon_sym_struct] = ACTIONS(2191),
    [anon_sym_union] = ACTIONS(2191),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2191),
    [anon_sym_decltype] = ACTIONS(2191),
    [sym_virtual] = ACTIONS(2191),
    [anon_sym_explicit] = ACTIONS(2191),
    [anon_sym_typename] = ACTIONS(2191),
    [anon_sym_template] = ACTIONS(2191),
    [anon_sym_operator] = ACTIONS(2191),
    [anon_sym_friend] = ACTIONS(2191),
    [anon_sym_public] = ACTIONS(2191),
    [anon_sym_private] = ACTIONS(2191),
    [anon_sym_protected] = ACTIONS(2191),
    [anon_sym_using] = ACTIONS(2191),
    [anon_sym_static_assert] = ACTIONS(2191),
    [anon_sym___launch_bounds__] = ACTIONS(2191),
  },
  [1899] = {
    [sym_identifier] = ACTIONS(5115),
    [aux_sym_preproc_def_token1] = ACTIONS(5115),
    [aux_sym_preproc_if_token1] = ACTIONS(5115),
    [aux_sym_preproc_if_token2] = ACTIONS(5115),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5115),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5115),
    [sym_preproc_directive] = ACTIONS(5115),
    [anon_sym_LPAREN2] = ACTIONS(5117),
    [anon_sym_TILDE] = ACTIONS(5117),
    [anon_sym_STAR] = ACTIONS(5117),
    [anon_sym_AMP_AMP] = ACTIONS(5117),
    [anon_sym_AMP] = ACTIONS(5115),
    [anon_sym___extension__] = ACTIONS(5115),
    [anon_sym_typedef] = ACTIONS(5115),
    [anon_sym___device__] = ACTIONS(5115),
    [anon_sym___host__] = ACTIONS(5115),
    [anon_sym___global__] = ACTIONS(5115),
    [anon_sym___forceinline__] = ACTIONS(5115),
    [anon_sym___noinline__] = ACTIONS(5115),
    [anon_sym_extern] = ACTIONS(5115),
    [anon_sym___attribute__] = ACTIONS(5115),
    [anon_sym_COLON_COLON] = ACTIONS(5117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5117),
    [anon_sym___declspec] = ACTIONS(5115),
    [anon_sym___based] = ACTIONS(5115),
    [anon_sym_signed] = ACTIONS(5115),
    [anon_sym_unsigned] = ACTIONS(5115),
    [anon_sym_long] = ACTIONS(5115),
    [anon_sym_short] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5115),
    [anon_sym_static] = ACTIONS(5115),
    [anon_sym_register] = ACTIONS(5115),
    [anon_sym_inline] = ACTIONS(5115),
    [anon_sym___inline] = ACTIONS(5115),
    [anon_sym___inline__] = ACTIONS(5115),
    [anon_sym___forceinline] = ACTIONS(5115),
    [anon_sym_thread_local] = ACTIONS(5115),
    [anon_sym___thread] = ACTIONS(5115),
    [anon_sym_const] = ACTIONS(5115),
    [anon_sym_constexpr] = ACTIONS(5115),
    [anon_sym_volatile] = ACTIONS(5115),
    [anon_sym_restrict] = ACTIONS(5115),
    [anon_sym___restrict__] = ACTIONS(5115),
    [anon_sym__Atomic] = ACTIONS(5115),
    [anon_sym__Noreturn] = ACTIONS(5115),
    [anon_sym_noreturn] = ACTIONS(5115),
    [anon_sym_mutable] = ACTIONS(5115),
    [anon_sym_constinit] = ACTIONS(5115),
    [anon_sym_consteval] = ACTIONS(5115),
    [anon_sym___shared__] = ACTIONS(5115),
    [anon_sym___local__] = ACTIONS(5115),
    [anon_sym___constant__] = ACTIONS(5115),
    [anon_sym___managed__] = ACTIONS(5115),
    [anon_sym___grid_constant__] = ACTIONS(5115),
    [anon_sym_alignas] = ACTIONS(5115),
    [anon_sym__Alignas] = ACTIONS(5115),
    [sym_primitive_type] = ACTIONS(5115),
    [anon_sym_enum] = ACTIONS(5115),
    [anon_sym_class] = ACTIONS(5115),
    [anon_sym_struct] = ACTIONS(5115),
    [anon_sym_union] = ACTIONS(5115),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5115),
    [anon_sym_decltype] = ACTIONS(5115),
    [sym_virtual] = ACTIONS(5115),
    [anon_sym_explicit] = ACTIONS(5115),
    [anon_sym_typename] = ACTIONS(5115),
    [anon_sym_template] = ACTIONS(5115),
    [anon_sym_operator] = ACTIONS(5115),
    [anon_sym_friend] = ACTIONS(5115),
    [anon_sym_public] = ACTIONS(5115),
    [anon_sym_private] = ACTIONS(5115),
    [anon_sym_protected] = ACTIONS(5115),
    [anon_sym_using] = ACTIONS(5115),
    [anon_sym_static_assert] = ACTIONS(5115),
    [anon_sym___launch_bounds__] = ACTIONS(5115),
  },
  [1900] = {
    [sym_identifier] = ACTIONS(5111),
    [aux_sym_preproc_def_token1] = ACTIONS(5111),
    [aux_sym_preproc_if_token1] = ACTIONS(5111),
    [aux_sym_preproc_if_token2] = ACTIONS(5111),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5111),
    [sym_preproc_directive] = ACTIONS(5111),
    [anon_sym_LPAREN2] = ACTIONS(5113),
    [anon_sym_TILDE] = ACTIONS(5113),
    [anon_sym_STAR] = ACTIONS(5113),
    [anon_sym_AMP_AMP] = ACTIONS(5113),
    [anon_sym_AMP] = ACTIONS(5111),
    [anon_sym___extension__] = ACTIONS(5111),
    [anon_sym_typedef] = ACTIONS(5111),
    [anon_sym___device__] = ACTIONS(5111),
    [anon_sym___host__] = ACTIONS(5111),
    [anon_sym___global__] = ACTIONS(5111),
    [anon_sym___forceinline__] = ACTIONS(5111),
    [anon_sym___noinline__] = ACTIONS(5111),
    [anon_sym_extern] = ACTIONS(5111),
    [anon_sym___attribute__] = ACTIONS(5111),
    [anon_sym_COLON_COLON] = ACTIONS(5113),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5113),
    [anon_sym___declspec] = ACTIONS(5111),
    [anon_sym___based] = ACTIONS(5111),
    [anon_sym_signed] = ACTIONS(5111),
    [anon_sym_unsigned] = ACTIONS(5111),
    [anon_sym_long] = ACTIONS(5111),
    [anon_sym_short] = ACTIONS(5111),
    [anon_sym_LBRACK] = ACTIONS(5111),
    [anon_sym_static] = ACTIONS(5111),
    [anon_sym_register] = ACTIONS(5111),
    [anon_sym_inline] = ACTIONS(5111),
    [anon_sym___inline] = ACTIONS(5111),
    [anon_sym___inline__] = ACTIONS(5111),
    [anon_sym___forceinline] = ACTIONS(5111),
    [anon_sym_thread_local] = ACTIONS(5111),
    [anon_sym___thread] = ACTIONS(5111),
    [anon_sym_const] = ACTIONS(5111),
    [anon_sym_constexpr] = ACTIONS(5111),
    [anon_sym_volatile] = ACTIONS(5111),
    [anon_sym_restrict] = ACTIONS(5111),
    [anon_sym___restrict__] = ACTIONS(5111),
    [anon_sym__Atomic] = ACTIONS(5111),
    [anon_sym__Noreturn] = ACTIONS(5111),
    [anon_sym_noreturn] = ACTIONS(5111),
    [anon_sym_mutable] = ACTIONS(5111),
    [anon_sym_constinit] = ACTIONS(5111),
    [anon_sym_consteval] = ACTIONS(5111),
    [anon_sym___shared__] = ACTIONS(5111),
    [anon_sym___local__] = ACTIONS(5111),
    [anon_sym___constant__] = ACTIONS(5111),
    [anon_sym___managed__] = ACTIONS(5111),
    [anon_sym___grid_constant__] = ACTIONS(5111),
    [anon_sym_alignas] = ACTIONS(5111),
    [anon_sym__Alignas] = ACTIONS(5111),
    [sym_primitive_type] = ACTIONS(5111),
    [anon_sym_enum] = ACTIONS(5111),
    [anon_sym_class] = ACTIONS(5111),
    [anon_sym_struct] = ACTIONS(5111),
    [anon_sym_union] = ACTIONS(5111),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5111),
    [anon_sym_decltype] = ACTIONS(5111),
    [sym_virtual] = ACTIONS(5111),
    [anon_sym_explicit] = ACTIONS(5111),
    [anon_sym_typename] = ACTIONS(5111),
    [anon_sym_template] = ACTIONS(5111),
    [anon_sym_operator] = ACTIONS(5111),
    [anon_sym_friend] = ACTIONS(5111),
    [anon_sym_public] = ACTIONS(5111),
    [anon_sym_private] = ACTIONS(5111),
    [anon_sym_protected] = ACTIONS(5111),
    [anon_sym_using] = ACTIONS(5111),
    [anon_sym_static_assert] = ACTIONS(5111),
    [anon_sym___launch_bounds__] = ACTIONS(5111),
  },
  [1901] = {
    [sym_identifier] = ACTIONS(5107),
    [aux_sym_preproc_def_token1] = ACTIONS(5107),
    [aux_sym_preproc_if_token1] = ACTIONS(5107),
    [aux_sym_preproc_if_token2] = ACTIONS(5107),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5107),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5107),
    [sym_preproc_directive] = ACTIONS(5107),
    [anon_sym_LPAREN2] = ACTIONS(5109),
    [anon_sym_TILDE] = ACTIONS(5109),
    [anon_sym_STAR] = ACTIONS(5109),
    [anon_sym_AMP_AMP] = ACTIONS(5109),
    [anon_sym_AMP] = ACTIONS(5107),
    [anon_sym___extension__] = ACTIONS(5107),
    [anon_sym_typedef] = ACTIONS(5107),
    [anon_sym___device__] = ACTIONS(5107),
    [anon_sym___host__] = ACTIONS(5107),
    [anon_sym___global__] = ACTIONS(5107),
    [anon_sym___forceinline__] = ACTIONS(5107),
    [anon_sym___noinline__] = ACTIONS(5107),
    [anon_sym_extern] = ACTIONS(5107),
    [anon_sym___attribute__] = ACTIONS(5107),
    [anon_sym_COLON_COLON] = ACTIONS(5109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5109),
    [anon_sym___declspec] = ACTIONS(5107),
    [anon_sym___based] = ACTIONS(5107),
    [anon_sym_signed] = ACTIONS(5107),
    [anon_sym_unsigned] = ACTIONS(5107),
    [anon_sym_long] = ACTIONS(5107),
    [anon_sym_short] = ACTIONS(5107),
    [anon_sym_LBRACK] = ACTIONS(5107),
    [anon_sym_static] = ACTIONS(5107),
    [anon_sym_register] = ACTIONS(5107),
    [anon_sym_inline] = ACTIONS(5107),
    [anon_sym___inline] = ACTIONS(5107),
    [anon_sym___inline__] = ACTIONS(5107),
    [anon_sym___forceinline] = ACTIONS(5107),
    [anon_sym_thread_local] = ACTIONS(5107),
    [anon_sym___thread] = ACTIONS(5107),
    [anon_sym_const] = ACTIONS(5107),
    [anon_sym_constexpr] = ACTIONS(5107),
    [anon_sym_volatile] = ACTIONS(5107),
    [anon_sym_restrict] = ACTIONS(5107),
    [anon_sym___restrict__] = ACTIONS(5107),
    [anon_sym__Atomic] = ACTIONS(5107),
    [anon_sym__Noreturn] = ACTIONS(5107),
    [anon_sym_noreturn] = ACTIONS(5107),
    [anon_sym_mutable] = ACTIONS(5107),
    [anon_sym_constinit] = ACTIONS(5107),
    [anon_sym_consteval] = ACTIONS(5107),
    [anon_sym___shared__] = ACTIONS(5107),
    [anon_sym___local__] = ACTIONS(5107),
    [anon_sym___constant__] = ACTIONS(5107),
    [anon_sym___managed__] = ACTIONS(5107),
    [anon_sym___grid_constant__] = ACTIONS(5107),
    [anon_sym_alignas] = ACTIONS(5107),
    [anon_sym__Alignas] = ACTIONS(5107),
    [sym_primitive_type] = ACTIONS(5107),
    [anon_sym_enum] = ACTIONS(5107),
    [anon_sym_class] = ACTIONS(5107),
    [anon_sym_struct] = ACTIONS(5107),
    [anon_sym_union] = ACTIONS(5107),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5107),
    [anon_sym_decltype] = ACTIONS(5107),
    [sym_virtual] = ACTIONS(5107),
    [anon_sym_explicit] = ACTIONS(5107),
    [anon_sym_typename] = ACTIONS(5107),
    [anon_sym_template] = ACTIONS(5107),
    [anon_sym_operator] = ACTIONS(5107),
    [anon_sym_friend] = ACTIONS(5107),
    [anon_sym_public] = ACTIONS(5107),
    [anon_sym_private] = ACTIONS(5107),
    [anon_sym_protected] = ACTIONS(5107),
    [anon_sym_using] = ACTIONS(5107),
    [anon_sym_static_assert] = ACTIONS(5107),
    [anon_sym___launch_bounds__] = ACTIONS(5107),
  },
  [1902] = {
    [sym_identifier] = ACTIONS(2172),
    [aux_sym_preproc_def_token1] = ACTIONS(2172),
    [aux_sym_preproc_if_token1] = ACTIONS(2172),
    [aux_sym_preproc_if_token2] = ACTIONS(2172),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2172),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2172),
    [sym_preproc_directive] = ACTIONS(2172),
    [anon_sym_LPAREN2] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2174),
    [anon_sym_STAR] = ACTIONS(2174),
    [anon_sym_AMP_AMP] = ACTIONS(2174),
    [anon_sym_AMP] = ACTIONS(2172),
    [anon_sym___extension__] = ACTIONS(2172),
    [anon_sym_typedef] = ACTIONS(2172),
    [anon_sym___device__] = ACTIONS(2172),
    [anon_sym___host__] = ACTIONS(2172),
    [anon_sym___global__] = ACTIONS(2172),
    [anon_sym___forceinline__] = ACTIONS(2172),
    [anon_sym___noinline__] = ACTIONS(2172),
    [anon_sym_extern] = ACTIONS(2172),
    [anon_sym___attribute__] = ACTIONS(2172),
    [anon_sym_COLON_COLON] = ACTIONS(2174),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2174),
    [anon_sym___declspec] = ACTIONS(2172),
    [anon_sym___based] = ACTIONS(2172),
    [anon_sym_signed] = ACTIONS(2172),
    [anon_sym_unsigned] = ACTIONS(2172),
    [anon_sym_long] = ACTIONS(2172),
    [anon_sym_short] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2172),
    [anon_sym_static] = ACTIONS(2172),
    [anon_sym_register] = ACTIONS(2172),
    [anon_sym_inline] = ACTIONS(2172),
    [anon_sym___inline] = ACTIONS(2172),
    [anon_sym___inline__] = ACTIONS(2172),
    [anon_sym___forceinline] = ACTIONS(2172),
    [anon_sym_thread_local] = ACTIONS(2172),
    [anon_sym___thread] = ACTIONS(2172),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_constexpr] = ACTIONS(2172),
    [anon_sym_volatile] = ACTIONS(2172),
    [anon_sym_restrict] = ACTIONS(2172),
    [anon_sym___restrict__] = ACTIONS(2172),
    [anon_sym__Atomic] = ACTIONS(2172),
    [anon_sym__Noreturn] = ACTIONS(2172),
    [anon_sym_noreturn] = ACTIONS(2172),
    [anon_sym_mutable] = ACTIONS(2172),
    [anon_sym_constinit] = ACTIONS(2172),
    [anon_sym_consteval] = ACTIONS(2172),
    [anon_sym___shared__] = ACTIONS(2172),
    [anon_sym___local__] = ACTIONS(2172),
    [anon_sym___constant__] = ACTIONS(2172),
    [anon_sym___managed__] = ACTIONS(2172),
    [anon_sym___grid_constant__] = ACTIONS(2172),
    [anon_sym_alignas] = ACTIONS(2172),
    [anon_sym__Alignas] = ACTIONS(2172),
    [sym_primitive_type] = ACTIONS(2172),
    [anon_sym_enum] = ACTIONS(2172),
    [anon_sym_class] = ACTIONS(2172),
    [anon_sym_struct] = ACTIONS(2172),
    [anon_sym_union] = ACTIONS(2172),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2172),
    [anon_sym_decltype] = ACTIONS(2172),
    [sym_virtual] = ACTIONS(2172),
    [anon_sym_explicit] = ACTIONS(2172),
    [anon_sym_typename] = ACTIONS(2172),
    [anon_sym_template] = ACTIONS(2172),
    [anon_sym_operator] = ACTIONS(2172),
    [anon_sym_friend] = ACTIONS(2172),
    [anon_sym_public] = ACTIONS(2172),
    [anon_sym_private] = ACTIONS(2172),
    [anon_sym_protected] = ACTIONS(2172),
    [anon_sym_using] = ACTIONS(2172),
    [anon_sym_static_assert] = ACTIONS(2172),
    [anon_sym___launch_bounds__] = ACTIONS(2172),
  },
  [1903] = {
    [sym_identifier] = ACTIONS(5103),
    [aux_sym_preproc_def_token1] = ACTIONS(5103),
    [aux_sym_preproc_if_token1] = ACTIONS(5103),
    [aux_sym_preproc_if_token2] = ACTIONS(5103),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5103),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5103),
    [sym_preproc_directive] = ACTIONS(5103),
    [anon_sym_LPAREN2] = ACTIONS(5105),
    [anon_sym_TILDE] = ACTIONS(5105),
    [anon_sym_STAR] = ACTIONS(5105),
    [anon_sym_AMP_AMP] = ACTIONS(5105),
    [anon_sym_AMP] = ACTIONS(5103),
    [anon_sym___extension__] = ACTIONS(5103),
    [anon_sym_typedef] = ACTIONS(5103),
    [anon_sym___device__] = ACTIONS(5103),
    [anon_sym___host__] = ACTIONS(5103),
    [anon_sym___global__] = ACTIONS(5103),
    [anon_sym___forceinline__] = ACTIONS(5103),
    [anon_sym___noinline__] = ACTIONS(5103),
    [anon_sym_extern] = ACTIONS(5103),
    [anon_sym___attribute__] = ACTIONS(5103),
    [anon_sym_COLON_COLON] = ACTIONS(5105),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5105),
    [anon_sym___declspec] = ACTIONS(5103),
    [anon_sym___based] = ACTIONS(5103),
    [anon_sym_signed] = ACTIONS(5103),
    [anon_sym_unsigned] = ACTIONS(5103),
    [anon_sym_long] = ACTIONS(5103),
    [anon_sym_short] = ACTIONS(5103),
    [anon_sym_LBRACK] = ACTIONS(5103),
    [anon_sym_static] = ACTIONS(5103),
    [anon_sym_register] = ACTIONS(5103),
    [anon_sym_inline] = ACTIONS(5103),
    [anon_sym___inline] = ACTIONS(5103),
    [anon_sym___inline__] = ACTIONS(5103),
    [anon_sym___forceinline] = ACTIONS(5103),
    [anon_sym_thread_local] = ACTIONS(5103),
    [anon_sym___thread] = ACTIONS(5103),
    [anon_sym_const] = ACTIONS(5103),
    [anon_sym_constexpr] = ACTIONS(5103),
    [anon_sym_volatile] = ACTIONS(5103),
    [anon_sym_restrict] = ACTIONS(5103),
    [anon_sym___restrict__] = ACTIONS(5103),
    [anon_sym__Atomic] = ACTIONS(5103),
    [anon_sym__Noreturn] = ACTIONS(5103),
    [anon_sym_noreturn] = ACTIONS(5103),
    [anon_sym_mutable] = ACTIONS(5103),
    [anon_sym_constinit] = ACTIONS(5103),
    [anon_sym_consteval] = ACTIONS(5103),
    [anon_sym___shared__] = ACTIONS(5103),
    [anon_sym___local__] = ACTIONS(5103),
    [anon_sym___constant__] = ACTIONS(5103),
    [anon_sym___managed__] = ACTIONS(5103),
    [anon_sym___grid_constant__] = ACTIONS(5103),
    [anon_sym_alignas] = ACTIONS(5103),
    [anon_sym__Alignas] = ACTIONS(5103),
    [sym_primitive_type] = ACTIONS(5103),
    [anon_sym_enum] = ACTIONS(5103),
    [anon_sym_class] = ACTIONS(5103),
    [anon_sym_struct] = ACTIONS(5103),
    [anon_sym_union] = ACTIONS(5103),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5103),
    [anon_sym_decltype] = ACTIONS(5103),
    [sym_virtual] = ACTIONS(5103),
    [anon_sym_explicit] = ACTIONS(5103),
    [anon_sym_typename] = ACTIONS(5103),
    [anon_sym_template] = ACTIONS(5103),
    [anon_sym_operator] = ACTIONS(5103),
    [anon_sym_friend] = ACTIONS(5103),
    [anon_sym_public] = ACTIONS(5103),
    [anon_sym_private] = ACTIONS(5103),
    [anon_sym_protected] = ACTIONS(5103),
    [anon_sym_using] = ACTIONS(5103),
    [anon_sym_static_assert] = ACTIONS(5103),
    [anon_sym___launch_bounds__] = ACTIONS(5103),
  },
  [1904] = {
    [sym_identifier] = ACTIONS(5099),
    [aux_sym_preproc_def_token1] = ACTIONS(5099),
    [aux_sym_preproc_if_token1] = ACTIONS(5099),
    [aux_sym_preproc_if_token2] = ACTIONS(5099),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5099),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5099),
    [sym_preproc_directive] = ACTIONS(5099),
    [anon_sym_LPAREN2] = ACTIONS(5101),
    [anon_sym_TILDE] = ACTIONS(5101),
    [anon_sym_STAR] = ACTIONS(5101),
    [anon_sym_AMP_AMP] = ACTIONS(5101),
    [anon_sym_AMP] = ACTIONS(5099),
    [anon_sym___extension__] = ACTIONS(5099),
    [anon_sym_typedef] = ACTIONS(5099),
    [anon_sym___device__] = ACTIONS(5099),
    [anon_sym___host__] = ACTIONS(5099),
    [anon_sym___global__] = ACTIONS(5099),
    [anon_sym___forceinline__] = ACTIONS(5099),
    [anon_sym___noinline__] = ACTIONS(5099),
    [anon_sym_extern] = ACTIONS(5099),
    [anon_sym___attribute__] = ACTIONS(5099),
    [anon_sym_COLON_COLON] = ACTIONS(5101),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5101),
    [anon_sym___declspec] = ACTIONS(5099),
    [anon_sym___based] = ACTIONS(5099),
    [anon_sym_signed] = ACTIONS(5099),
    [anon_sym_unsigned] = ACTIONS(5099),
    [anon_sym_long] = ACTIONS(5099),
    [anon_sym_short] = ACTIONS(5099),
    [anon_sym_LBRACK] = ACTIONS(5099),
    [anon_sym_static] = ACTIONS(5099),
    [anon_sym_register] = ACTIONS(5099),
    [anon_sym_inline] = ACTIONS(5099),
    [anon_sym___inline] = ACTIONS(5099),
    [anon_sym___inline__] = ACTIONS(5099),
    [anon_sym___forceinline] = ACTIONS(5099),
    [anon_sym_thread_local] = ACTIONS(5099),
    [anon_sym___thread] = ACTIONS(5099),
    [anon_sym_const] = ACTIONS(5099),
    [anon_sym_constexpr] = ACTIONS(5099),
    [anon_sym_volatile] = ACTIONS(5099),
    [anon_sym_restrict] = ACTIONS(5099),
    [anon_sym___restrict__] = ACTIONS(5099),
    [anon_sym__Atomic] = ACTIONS(5099),
    [anon_sym__Noreturn] = ACTIONS(5099),
    [anon_sym_noreturn] = ACTIONS(5099),
    [anon_sym_mutable] = ACTIONS(5099),
    [anon_sym_constinit] = ACTIONS(5099),
    [anon_sym_consteval] = ACTIONS(5099),
    [anon_sym___shared__] = ACTIONS(5099),
    [anon_sym___local__] = ACTIONS(5099),
    [anon_sym___constant__] = ACTIONS(5099),
    [anon_sym___managed__] = ACTIONS(5099),
    [anon_sym___grid_constant__] = ACTIONS(5099),
    [anon_sym_alignas] = ACTIONS(5099),
    [anon_sym__Alignas] = ACTIONS(5099),
    [sym_primitive_type] = ACTIONS(5099),
    [anon_sym_enum] = ACTIONS(5099),
    [anon_sym_class] = ACTIONS(5099),
    [anon_sym_struct] = ACTIONS(5099),
    [anon_sym_union] = ACTIONS(5099),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5099),
    [anon_sym_decltype] = ACTIONS(5099),
    [sym_virtual] = ACTIONS(5099),
    [anon_sym_explicit] = ACTIONS(5099),
    [anon_sym_typename] = ACTIONS(5099),
    [anon_sym_template] = ACTIONS(5099),
    [anon_sym_operator] = ACTIONS(5099),
    [anon_sym_friend] = ACTIONS(5099),
    [anon_sym_public] = ACTIONS(5099),
    [anon_sym_private] = ACTIONS(5099),
    [anon_sym_protected] = ACTIONS(5099),
    [anon_sym_using] = ACTIONS(5099),
    [anon_sym_static_assert] = ACTIONS(5099),
    [anon_sym___launch_bounds__] = ACTIONS(5099),
  },
  [1905] = {
    [sym_identifier] = ACTIONS(5095),
    [aux_sym_preproc_def_token1] = ACTIONS(5095),
    [aux_sym_preproc_if_token1] = ACTIONS(5095),
    [aux_sym_preproc_if_token2] = ACTIONS(5095),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5095),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5095),
    [sym_preproc_directive] = ACTIONS(5095),
    [anon_sym_LPAREN2] = ACTIONS(5097),
    [anon_sym_TILDE] = ACTIONS(5097),
    [anon_sym_STAR] = ACTIONS(5097),
    [anon_sym_AMP_AMP] = ACTIONS(5097),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym___extension__] = ACTIONS(5095),
    [anon_sym_typedef] = ACTIONS(5095),
    [anon_sym___device__] = ACTIONS(5095),
    [anon_sym___host__] = ACTIONS(5095),
    [anon_sym___global__] = ACTIONS(5095),
    [anon_sym___forceinline__] = ACTIONS(5095),
    [anon_sym___noinline__] = ACTIONS(5095),
    [anon_sym_extern] = ACTIONS(5095),
    [anon_sym___attribute__] = ACTIONS(5095),
    [anon_sym_COLON_COLON] = ACTIONS(5097),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5097),
    [anon_sym___declspec] = ACTIONS(5095),
    [anon_sym___based] = ACTIONS(5095),
    [anon_sym_signed] = ACTIONS(5095),
    [anon_sym_unsigned] = ACTIONS(5095),
    [anon_sym_long] = ACTIONS(5095),
    [anon_sym_short] = ACTIONS(5095),
    [anon_sym_LBRACK] = ACTIONS(5095),
    [anon_sym_static] = ACTIONS(5095),
    [anon_sym_register] = ACTIONS(5095),
    [anon_sym_inline] = ACTIONS(5095),
    [anon_sym___inline] = ACTIONS(5095),
    [anon_sym___inline__] = ACTIONS(5095),
    [anon_sym___forceinline] = ACTIONS(5095),
    [anon_sym_thread_local] = ACTIONS(5095),
    [anon_sym___thread] = ACTIONS(5095),
    [anon_sym_const] = ACTIONS(5095),
    [anon_sym_constexpr] = ACTIONS(5095),
    [anon_sym_volatile] = ACTIONS(5095),
    [anon_sym_restrict] = ACTIONS(5095),
    [anon_sym___restrict__] = ACTIONS(5095),
    [anon_sym__Atomic] = ACTIONS(5095),
    [anon_sym__Noreturn] = ACTIONS(5095),
    [anon_sym_noreturn] = ACTIONS(5095),
    [anon_sym_mutable] = ACTIONS(5095),
    [anon_sym_constinit] = ACTIONS(5095),
    [anon_sym_consteval] = ACTIONS(5095),
    [anon_sym___shared__] = ACTIONS(5095),
    [anon_sym___local__] = ACTIONS(5095),
    [anon_sym___constant__] = ACTIONS(5095),
    [anon_sym___managed__] = ACTIONS(5095),
    [anon_sym___grid_constant__] = ACTIONS(5095),
    [anon_sym_alignas] = ACTIONS(5095),
    [anon_sym__Alignas] = ACTIONS(5095),
    [sym_primitive_type] = ACTIONS(5095),
    [anon_sym_enum] = ACTIONS(5095),
    [anon_sym_class] = ACTIONS(5095),
    [anon_sym_struct] = ACTIONS(5095),
    [anon_sym_union] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5095),
    [anon_sym_decltype] = ACTIONS(5095),
    [sym_virtual] = ACTIONS(5095),
    [anon_sym_explicit] = ACTIONS(5095),
    [anon_sym_typename] = ACTIONS(5095),
    [anon_sym_template] = ACTIONS(5095),
    [anon_sym_operator] = ACTIONS(5095),
    [anon_sym_friend] = ACTIONS(5095),
    [anon_sym_public] = ACTIONS(5095),
    [anon_sym_private] = ACTIONS(5095),
    [anon_sym_protected] = ACTIONS(5095),
    [anon_sym_using] = ACTIONS(5095),
    [anon_sym_static_assert] = ACTIONS(5095),
    [anon_sym___launch_bounds__] = ACTIONS(5095),
  },
  [1906] = {
    [sym_identifier] = ACTIONS(5091),
    [aux_sym_preproc_def_token1] = ACTIONS(5091),
    [aux_sym_preproc_if_token1] = ACTIONS(5091),
    [aux_sym_preproc_if_token2] = ACTIONS(5091),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5091),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5091),
    [sym_preproc_directive] = ACTIONS(5091),
    [anon_sym_LPAREN2] = ACTIONS(5093),
    [anon_sym_TILDE] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5093),
    [anon_sym_AMP_AMP] = ACTIONS(5093),
    [anon_sym_AMP] = ACTIONS(5091),
    [anon_sym___extension__] = ACTIONS(5091),
    [anon_sym_typedef] = ACTIONS(5091),
    [anon_sym___device__] = ACTIONS(5091),
    [anon_sym___host__] = ACTIONS(5091),
    [anon_sym___global__] = ACTIONS(5091),
    [anon_sym___forceinline__] = ACTIONS(5091),
    [anon_sym___noinline__] = ACTIONS(5091),
    [anon_sym_extern] = ACTIONS(5091),
    [anon_sym___attribute__] = ACTIONS(5091),
    [anon_sym_COLON_COLON] = ACTIONS(5093),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5093),
    [anon_sym___declspec] = ACTIONS(5091),
    [anon_sym___based] = ACTIONS(5091),
    [anon_sym_signed] = ACTIONS(5091),
    [anon_sym_unsigned] = ACTIONS(5091),
    [anon_sym_long] = ACTIONS(5091),
    [anon_sym_short] = ACTIONS(5091),
    [anon_sym_LBRACK] = ACTIONS(5091),
    [anon_sym_static] = ACTIONS(5091),
    [anon_sym_register] = ACTIONS(5091),
    [anon_sym_inline] = ACTIONS(5091),
    [anon_sym___inline] = ACTIONS(5091),
    [anon_sym___inline__] = ACTIONS(5091),
    [anon_sym___forceinline] = ACTIONS(5091),
    [anon_sym_thread_local] = ACTIONS(5091),
    [anon_sym___thread] = ACTIONS(5091),
    [anon_sym_const] = ACTIONS(5091),
    [anon_sym_constexpr] = ACTIONS(5091),
    [anon_sym_volatile] = ACTIONS(5091),
    [anon_sym_restrict] = ACTIONS(5091),
    [anon_sym___restrict__] = ACTIONS(5091),
    [anon_sym__Atomic] = ACTIONS(5091),
    [anon_sym__Noreturn] = ACTIONS(5091),
    [anon_sym_noreturn] = ACTIONS(5091),
    [anon_sym_mutable] = ACTIONS(5091),
    [anon_sym_constinit] = ACTIONS(5091),
    [anon_sym_consteval] = ACTIONS(5091),
    [anon_sym___shared__] = ACTIONS(5091),
    [anon_sym___local__] = ACTIONS(5091),
    [anon_sym___constant__] = ACTIONS(5091),
    [anon_sym___managed__] = ACTIONS(5091),
    [anon_sym___grid_constant__] = ACTIONS(5091),
    [anon_sym_alignas] = ACTIONS(5091),
    [anon_sym__Alignas] = ACTIONS(5091),
    [sym_primitive_type] = ACTIONS(5091),
    [anon_sym_enum] = ACTIONS(5091),
    [anon_sym_class] = ACTIONS(5091),
    [anon_sym_struct] = ACTIONS(5091),
    [anon_sym_union] = ACTIONS(5091),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5091),
    [anon_sym_decltype] = ACTIONS(5091),
    [sym_virtual] = ACTIONS(5091),
    [anon_sym_explicit] = ACTIONS(5091),
    [anon_sym_typename] = ACTIONS(5091),
    [anon_sym_template] = ACTIONS(5091),
    [anon_sym_operator] = ACTIONS(5091),
    [anon_sym_friend] = ACTIONS(5091),
    [anon_sym_public] = ACTIONS(5091),
    [anon_sym_private] = ACTIONS(5091),
    [anon_sym_protected] = ACTIONS(5091),
    [anon_sym_using] = ACTIONS(5091),
    [anon_sym_static_assert] = ACTIONS(5091),
    [anon_sym___launch_bounds__] = ACTIONS(5091),
  },
  [1907] = {
    [sym_identifier] = ACTIONS(5079),
    [aux_sym_preproc_def_token1] = ACTIONS(5079),
    [aux_sym_preproc_if_token1] = ACTIONS(5079),
    [aux_sym_preproc_if_token2] = ACTIONS(5079),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5079),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5079),
    [sym_preproc_directive] = ACTIONS(5079),
    [anon_sym_LPAREN2] = ACTIONS(5081),
    [anon_sym_TILDE] = ACTIONS(5081),
    [anon_sym_STAR] = ACTIONS(5081),
    [anon_sym_AMP_AMP] = ACTIONS(5081),
    [anon_sym_AMP] = ACTIONS(5079),
    [anon_sym___extension__] = ACTIONS(5079),
    [anon_sym_typedef] = ACTIONS(5079),
    [anon_sym___device__] = ACTIONS(5079),
    [anon_sym___host__] = ACTIONS(5079),
    [anon_sym___global__] = ACTIONS(5079),
    [anon_sym___forceinline__] = ACTIONS(5079),
    [anon_sym___noinline__] = ACTIONS(5079),
    [anon_sym_extern] = ACTIONS(5079),
    [anon_sym___attribute__] = ACTIONS(5079),
    [anon_sym_COLON_COLON] = ACTIONS(5081),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5081),
    [anon_sym___declspec] = ACTIONS(5079),
    [anon_sym___based] = ACTIONS(5079),
    [anon_sym_signed] = ACTIONS(5079),
    [anon_sym_unsigned] = ACTIONS(5079),
    [anon_sym_long] = ACTIONS(5079),
    [anon_sym_short] = ACTIONS(5079),
    [anon_sym_LBRACK] = ACTIONS(5079),
    [anon_sym_static] = ACTIONS(5079),
    [anon_sym_register] = ACTIONS(5079),
    [anon_sym_inline] = ACTIONS(5079),
    [anon_sym___inline] = ACTIONS(5079),
    [anon_sym___inline__] = ACTIONS(5079),
    [anon_sym___forceinline] = ACTIONS(5079),
    [anon_sym_thread_local] = ACTIONS(5079),
    [anon_sym___thread] = ACTIONS(5079),
    [anon_sym_const] = ACTIONS(5079),
    [anon_sym_constexpr] = ACTIONS(5079),
    [anon_sym_volatile] = ACTIONS(5079),
    [anon_sym_restrict] = ACTIONS(5079),
    [anon_sym___restrict__] = ACTIONS(5079),
    [anon_sym__Atomic] = ACTIONS(5079),
    [anon_sym__Noreturn] = ACTIONS(5079),
    [anon_sym_noreturn] = ACTIONS(5079),
    [anon_sym_mutable] = ACTIONS(5079),
    [anon_sym_constinit] = ACTIONS(5079),
    [anon_sym_consteval] = ACTIONS(5079),
    [anon_sym___shared__] = ACTIONS(5079),
    [anon_sym___local__] = ACTIONS(5079),
    [anon_sym___constant__] = ACTIONS(5079),
    [anon_sym___managed__] = ACTIONS(5079),
    [anon_sym___grid_constant__] = ACTIONS(5079),
    [anon_sym_alignas] = ACTIONS(5079),
    [anon_sym__Alignas] = ACTIONS(5079),
    [sym_primitive_type] = ACTIONS(5079),
    [anon_sym_enum] = ACTIONS(5079),
    [anon_sym_class] = ACTIONS(5079),
    [anon_sym_struct] = ACTIONS(5079),
    [anon_sym_union] = ACTIONS(5079),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5079),
    [anon_sym_decltype] = ACTIONS(5079),
    [sym_virtual] = ACTIONS(5079),
    [anon_sym_explicit] = ACTIONS(5079),
    [anon_sym_typename] = ACTIONS(5079),
    [anon_sym_template] = ACTIONS(5079),
    [anon_sym_operator] = ACTIONS(5079),
    [anon_sym_friend] = ACTIONS(5079),
    [anon_sym_public] = ACTIONS(5079),
    [anon_sym_private] = ACTIONS(5079),
    [anon_sym_protected] = ACTIONS(5079),
    [anon_sym_using] = ACTIONS(5079),
    [anon_sym_static_assert] = ACTIONS(5079),
    [anon_sym___launch_bounds__] = ACTIONS(5079),
  },
  [1908] = {
    [sym_identifier] = ACTIONS(5079),
    [aux_sym_preproc_def_token1] = ACTIONS(5079),
    [aux_sym_preproc_if_token1] = ACTIONS(5079),
    [aux_sym_preproc_if_token2] = ACTIONS(5079),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5079),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5079),
    [sym_preproc_directive] = ACTIONS(5079),
    [anon_sym_LPAREN2] = ACTIONS(5081),
    [anon_sym_TILDE] = ACTIONS(5081),
    [anon_sym_STAR] = ACTIONS(5081),
    [anon_sym_AMP_AMP] = ACTIONS(5081),
    [anon_sym_AMP] = ACTIONS(5079),
    [anon_sym___extension__] = ACTIONS(5079),
    [anon_sym_typedef] = ACTIONS(5079),
    [anon_sym___device__] = ACTIONS(5079),
    [anon_sym___host__] = ACTIONS(5079),
    [anon_sym___global__] = ACTIONS(5079),
    [anon_sym___forceinline__] = ACTIONS(5079),
    [anon_sym___noinline__] = ACTIONS(5079),
    [anon_sym_extern] = ACTIONS(5079),
    [anon_sym___attribute__] = ACTIONS(5079),
    [anon_sym_COLON_COLON] = ACTIONS(5081),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5081),
    [anon_sym___declspec] = ACTIONS(5079),
    [anon_sym___based] = ACTIONS(5079),
    [anon_sym_signed] = ACTIONS(5079),
    [anon_sym_unsigned] = ACTIONS(5079),
    [anon_sym_long] = ACTIONS(5079),
    [anon_sym_short] = ACTIONS(5079),
    [anon_sym_LBRACK] = ACTIONS(5079),
    [anon_sym_static] = ACTIONS(5079),
    [anon_sym_register] = ACTIONS(5079),
    [anon_sym_inline] = ACTIONS(5079),
    [anon_sym___inline] = ACTIONS(5079),
    [anon_sym___inline__] = ACTIONS(5079),
    [anon_sym___forceinline] = ACTIONS(5079),
    [anon_sym_thread_local] = ACTIONS(5079),
    [anon_sym___thread] = ACTIONS(5079),
    [anon_sym_const] = ACTIONS(5079),
    [anon_sym_constexpr] = ACTIONS(5079),
    [anon_sym_volatile] = ACTIONS(5079),
    [anon_sym_restrict] = ACTIONS(5079),
    [anon_sym___restrict__] = ACTIONS(5079),
    [anon_sym__Atomic] = ACTIONS(5079),
    [anon_sym__Noreturn] = ACTIONS(5079),
    [anon_sym_noreturn] = ACTIONS(5079),
    [anon_sym_mutable] = ACTIONS(5079),
    [anon_sym_constinit] = ACTIONS(5079),
    [anon_sym_consteval] = ACTIONS(5079),
    [anon_sym___shared__] = ACTIONS(5079),
    [anon_sym___local__] = ACTIONS(5079),
    [anon_sym___constant__] = ACTIONS(5079),
    [anon_sym___managed__] = ACTIONS(5079),
    [anon_sym___grid_constant__] = ACTIONS(5079),
    [anon_sym_alignas] = ACTIONS(5079),
    [anon_sym__Alignas] = ACTIONS(5079),
    [sym_primitive_type] = ACTIONS(5079),
    [anon_sym_enum] = ACTIONS(5079),
    [anon_sym_class] = ACTIONS(5079),
    [anon_sym_struct] = ACTIONS(5079),
    [anon_sym_union] = ACTIONS(5079),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5079),
    [anon_sym_decltype] = ACTIONS(5079),
    [sym_virtual] = ACTIONS(5079),
    [anon_sym_explicit] = ACTIONS(5079),
    [anon_sym_typename] = ACTIONS(5079),
    [anon_sym_template] = ACTIONS(5079),
    [anon_sym_operator] = ACTIONS(5079),
    [anon_sym_friend] = ACTIONS(5079),
    [anon_sym_public] = ACTIONS(5079),
    [anon_sym_private] = ACTIONS(5079),
    [anon_sym_protected] = ACTIONS(5079),
    [anon_sym_using] = ACTIONS(5079),
    [anon_sym_static_assert] = ACTIONS(5079),
    [anon_sym___launch_bounds__] = ACTIONS(5079),
  },
  [1909] = {
    [sym_identifier] = ACTIONS(5222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5224),
    [anon_sym_COMMA] = ACTIONS(5224),
    [anon_sym_RPAREN] = ACTIONS(5224),
    [anon_sym_LPAREN2] = ACTIONS(5224),
    [anon_sym_DASH] = ACTIONS(5222),
    [anon_sym_PLUS] = ACTIONS(5222),
    [anon_sym_STAR] = ACTIONS(5224),
    [anon_sym_SLASH] = ACTIONS(5222),
    [anon_sym_PERCENT] = ACTIONS(5224),
    [anon_sym_PIPE_PIPE] = ACTIONS(5224),
    [anon_sym_AMP_AMP] = ACTIONS(5224),
    [anon_sym_PIPE] = ACTIONS(5222),
    [anon_sym_CARET] = ACTIONS(5224),
    [anon_sym_AMP] = ACTIONS(5222),
    [anon_sym_EQ_EQ] = ACTIONS(5224),
    [anon_sym_BANG_EQ] = ACTIONS(5224),
    [anon_sym_GT] = ACTIONS(5222),
    [anon_sym_GT_EQ] = ACTIONS(5224),
    [anon_sym_LT_EQ] = ACTIONS(5222),
    [anon_sym_LT] = ACTIONS(5222),
    [anon_sym_LT_LT] = ACTIONS(5222),
    [anon_sym_GT_GT] = ACTIONS(5224),
    [anon_sym_SEMI] = ACTIONS(5224),
    [anon_sym___extension__] = ACTIONS(5222),
    [anon_sym___global__] = ACTIONS(5222),
    [anon_sym___attribute__] = ACTIONS(5222),
    [anon_sym___based] = ACTIONS(5222),
    [anon_sym_LBRACE] = ACTIONS(5224),
    [anon_sym_RBRACE] = ACTIONS(5224),
    [anon_sym_signed] = ACTIONS(5222),
    [anon_sym_unsigned] = ACTIONS(5222),
    [anon_sym_long] = ACTIONS(5222),
    [anon_sym_short] = ACTIONS(5222),
    [anon_sym_LBRACK] = ACTIONS(5224),
    [anon_sym_RBRACK] = ACTIONS(5224),
    [anon_sym_const] = ACTIONS(5222),
    [anon_sym_constexpr] = ACTIONS(5222),
    [anon_sym_volatile] = ACTIONS(5222),
    [anon_sym_restrict] = ACTIONS(5222),
    [anon_sym___restrict__] = ACTIONS(5222),
    [anon_sym__Atomic] = ACTIONS(5222),
    [anon_sym__Noreturn] = ACTIONS(5222),
    [anon_sym_noreturn] = ACTIONS(5222),
    [anon_sym_mutable] = ACTIONS(5222),
    [anon_sym_constinit] = ACTIONS(5222),
    [anon_sym_consteval] = ACTIONS(5222),
    [anon_sym___shared__] = ACTIONS(5222),
    [anon_sym___local__] = ACTIONS(5222),
    [anon_sym___constant__] = ACTIONS(5222),
    [anon_sym___managed__] = ACTIONS(5222),
    [anon_sym___grid_constant__] = ACTIONS(5222),
    [anon_sym_alignas] = ACTIONS(5222),
    [anon_sym__Alignas] = ACTIONS(5222),
    [sym_primitive_type] = ACTIONS(5222),
    [anon_sym_COLON] = ACTIONS(5224),
    [anon_sym_QMARK] = ACTIONS(5224),
    [anon_sym_LT_EQ_GT] = ACTIONS(5224),
    [anon_sym_or] = ACTIONS(5222),
    [anon_sym_and] = ACTIONS(5222),
    [anon_sym_bitor] = ACTIONS(5222),
    [anon_sym_xor] = ACTIONS(5222),
    [anon_sym_bitand] = ACTIONS(5222),
    [anon_sym_not_eq] = ACTIONS(5222),
    [anon_sym_DASH_DASH] = ACTIONS(5224),
    [anon_sym_PLUS_PLUS] = ACTIONS(5224),
    [anon_sym_DOT] = ACTIONS(5222),
    [anon_sym_DOT_STAR] = ACTIONS(5224),
    [anon_sym_DASH_GT] = ACTIONS(5224),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5222),
    [anon_sym_decltype] = ACTIONS(5222),
    [anon_sym_final] = ACTIONS(5222),
    [anon_sym_override] = ACTIONS(5222),
    [anon_sym_requires] = ACTIONS(5222),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5224),
  },
  [1910] = {
    [sym_identifier] = ACTIONS(5075),
    [aux_sym_preproc_def_token1] = ACTIONS(5075),
    [aux_sym_preproc_if_token1] = ACTIONS(5075),
    [aux_sym_preproc_if_token2] = ACTIONS(5075),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5075),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5075),
    [sym_preproc_directive] = ACTIONS(5075),
    [anon_sym_LPAREN2] = ACTIONS(5077),
    [anon_sym_TILDE] = ACTIONS(5077),
    [anon_sym_STAR] = ACTIONS(5077),
    [anon_sym_AMP_AMP] = ACTIONS(5077),
    [anon_sym_AMP] = ACTIONS(5075),
    [anon_sym___extension__] = ACTIONS(5075),
    [anon_sym_typedef] = ACTIONS(5075),
    [anon_sym___device__] = ACTIONS(5075),
    [anon_sym___host__] = ACTIONS(5075),
    [anon_sym___global__] = ACTIONS(5075),
    [anon_sym___forceinline__] = ACTIONS(5075),
    [anon_sym___noinline__] = ACTIONS(5075),
    [anon_sym_extern] = ACTIONS(5075),
    [anon_sym___attribute__] = ACTIONS(5075),
    [anon_sym_COLON_COLON] = ACTIONS(5077),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5077),
    [anon_sym___declspec] = ACTIONS(5075),
    [anon_sym___based] = ACTIONS(5075),
    [anon_sym_signed] = ACTIONS(5075),
    [anon_sym_unsigned] = ACTIONS(5075),
    [anon_sym_long] = ACTIONS(5075),
    [anon_sym_short] = ACTIONS(5075),
    [anon_sym_LBRACK] = ACTIONS(5075),
    [anon_sym_static] = ACTIONS(5075),
    [anon_sym_register] = ACTIONS(5075),
    [anon_sym_inline] = ACTIONS(5075),
    [anon_sym___inline] = ACTIONS(5075),
    [anon_sym___inline__] = ACTIONS(5075),
    [anon_sym___forceinline] = ACTIONS(5075),
    [anon_sym_thread_local] = ACTIONS(5075),
    [anon_sym___thread] = ACTIONS(5075),
    [anon_sym_const] = ACTIONS(5075),
    [anon_sym_constexpr] = ACTIONS(5075),
    [anon_sym_volatile] = ACTIONS(5075),
    [anon_sym_restrict] = ACTIONS(5075),
    [anon_sym___restrict__] = ACTIONS(5075),
    [anon_sym__Atomic] = ACTIONS(5075),
    [anon_sym__Noreturn] = ACTIONS(5075),
    [anon_sym_noreturn] = ACTIONS(5075),
    [anon_sym_mutable] = ACTIONS(5075),
    [anon_sym_constinit] = ACTIONS(5075),
    [anon_sym_consteval] = ACTIONS(5075),
    [anon_sym___shared__] = ACTIONS(5075),
    [anon_sym___local__] = ACTIONS(5075),
    [anon_sym___constant__] = ACTIONS(5075),
    [anon_sym___managed__] = ACTIONS(5075),
    [anon_sym___grid_constant__] = ACTIONS(5075),
    [anon_sym_alignas] = ACTIONS(5075),
    [anon_sym__Alignas] = ACTIONS(5075),
    [sym_primitive_type] = ACTIONS(5075),
    [anon_sym_enum] = ACTIONS(5075),
    [anon_sym_class] = ACTIONS(5075),
    [anon_sym_struct] = ACTIONS(5075),
    [anon_sym_union] = ACTIONS(5075),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5075),
    [anon_sym_decltype] = ACTIONS(5075),
    [sym_virtual] = ACTIONS(5075),
    [anon_sym_explicit] = ACTIONS(5075),
    [anon_sym_typename] = ACTIONS(5075),
    [anon_sym_template] = ACTIONS(5075),
    [anon_sym_operator] = ACTIONS(5075),
    [anon_sym_friend] = ACTIONS(5075),
    [anon_sym_public] = ACTIONS(5075),
    [anon_sym_private] = ACTIONS(5075),
    [anon_sym_protected] = ACTIONS(5075),
    [anon_sym_using] = ACTIONS(5075),
    [anon_sym_static_assert] = ACTIONS(5075),
    [anon_sym___launch_bounds__] = ACTIONS(5075),
  },
  [1911] = {
    [sym_identifier] = ACTIONS(5071),
    [aux_sym_preproc_def_token1] = ACTIONS(5071),
    [aux_sym_preproc_if_token1] = ACTIONS(5071),
    [aux_sym_preproc_if_token2] = ACTIONS(5071),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5071),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5071),
    [sym_preproc_directive] = ACTIONS(5071),
    [anon_sym_LPAREN2] = ACTIONS(5073),
    [anon_sym_TILDE] = ACTIONS(5073),
    [anon_sym_STAR] = ACTIONS(5073),
    [anon_sym_AMP_AMP] = ACTIONS(5073),
    [anon_sym_AMP] = ACTIONS(5071),
    [anon_sym___extension__] = ACTIONS(5071),
    [anon_sym_typedef] = ACTIONS(5071),
    [anon_sym___device__] = ACTIONS(5071),
    [anon_sym___host__] = ACTIONS(5071),
    [anon_sym___global__] = ACTIONS(5071),
    [anon_sym___forceinline__] = ACTIONS(5071),
    [anon_sym___noinline__] = ACTIONS(5071),
    [anon_sym_extern] = ACTIONS(5071),
    [anon_sym___attribute__] = ACTIONS(5071),
    [anon_sym_COLON_COLON] = ACTIONS(5073),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5073),
    [anon_sym___declspec] = ACTIONS(5071),
    [anon_sym___based] = ACTIONS(5071),
    [anon_sym_signed] = ACTIONS(5071),
    [anon_sym_unsigned] = ACTIONS(5071),
    [anon_sym_long] = ACTIONS(5071),
    [anon_sym_short] = ACTIONS(5071),
    [anon_sym_LBRACK] = ACTIONS(5071),
    [anon_sym_static] = ACTIONS(5071),
    [anon_sym_register] = ACTIONS(5071),
    [anon_sym_inline] = ACTIONS(5071),
    [anon_sym___inline] = ACTIONS(5071),
    [anon_sym___inline__] = ACTIONS(5071),
    [anon_sym___forceinline] = ACTIONS(5071),
    [anon_sym_thread_local] = ACTIONS(5071),
    [anon_sym___thread] = ACTIONS(5071),
    [anon_sym_const] = ACTIONS(5071),
    [anon_sym_constexpr] = ACTIONS(5071),
    [anon_sym_volatile] = ACTIONS(5071),
    [anon_sym_restrict] = ACTIONS(5071),
    [anon_sym___restrict__] = ACTIONS(5071),
    [anon_sym__Atomic] = ACTIONS(5071),
    [anon_sym__Noreturn] = ACTIONS(5071),
    [anon_sym_noreturn] = ACTIONS(5071),
    [anon_sym_mutable] = ACTIONS(5071),
    [anon_sym_constinit] = ACTIONS(5071),
    [anon_sym_consteval] = ACTIONS(5071),
    [anon_sym___shared__] = ACTIONS(5071),
    [anon_sym___local__] = ACTIONS(5071),
    [anon_sym___constant__] = ACTIONS(5071),
    [anon_sym___managed__] = ACTIONS(5071),
    [anon_sym___grid_constant__] = ACTIONS(5071),
    [anon_sym_alignas] = ACTIONS(5071),
    [anon_sym__Alignas] = ACTIONS(5071),
    [sym_primitive_type] = ACTIONS(5071),
    [anon_sym_enum] = ACTIONS(5071),
    [anon_sym_class] = ACTIONS(5071),
    [anon_sym_struct] = ACTIONS(5071),
    [anon_sym_union] = ACTIONS(5071),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5071),
    [anon_sym_decltype] = ACTIONS(5071),
    [sym_virtual] = ACTIONS(5071),
    [anon_sym_explicit] = ACTIONS(5071),
    [anon_sym_typename] = ACTIONS(5071),
    [anon_sym_template] = ACTIONS(5071),
    [anon_sym_operator] = ACTIONS(5071),
    [anon_sym_friend] = ACTIONS(5071),
    [anon_sym_public] = ACTIONS(5071),
    [anon_sym_private] = ACTIONS(5071),
    [anon_sym_protected] = ACTIONS(5071),
    [anon_sym_using] = ACTIONS(5071),
    [anon_sym_static_assert] = ACTIONS(5071),
    [anon_sym___launch_bounds__] = ACTIONS(5071),
  },
  [1912] = {
    [sym_identifier] = ACTIONS(5067),
    [aux_sym_preproc_def_token1] = ACTIONS(5067),
    [aux_sym_preproc_if_token1] = ACTIONS(5067),
    [aux_sym_preproc_if_token2] = ACTIONS(5067),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5067),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5067),
    [sym_preproc_directive] = ACTIONS(5067),
    [anon_sym_LPAREN2] = ACTIONS(5069),
    [anon_sym_TILDE] = ACTIONS(5069),
    [anon_sym_STAR] = ACTIONS(5069),
    [anon_sym_AMP_AMP] = ACTIONS(5069),
    [anon_sym_AMP] = ACTIONS(5067),
    [anon_sym___extension__] = ACTIONS(5067),
    [anon_sym_typedef] = ACTIONS(5067),
    [anon_sym___device__] = ACTIONS(5067),
    [anon_sym___host__] = ACTIONS(5067),
    [anon_sym___global__] = ACTIONS(5067),
    [anon_sym___forceinline__] = ACTIONS(5067),
    [anon_sym___noinline__] = ACTIONS(5067),
    [anon_sym_extern] = ACTIONS(5067),
    [anon_sym___attribute__] = ACTIONS(5067),
    [anon_sym_COLON_COLON] = ACTIONS(5069),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5069),
    [anon_sym___declspec] = ACTIONS(5067),
    [anon_sym___based] = ACTIONS(5067),
    [anon_sym_signed] = ACTIONS(5067),
    [anon_sym_unsigned] = ACTIONS(5067),
    [anon_sym_long] = ACTIONS(5067),
    [anon_sym_short] = ACTIONS(5067),
    [anon_sym_LBRACK] = ACTIONS(5067),
    [anon_sym_static] = ACTIONS(5067),
    [anon_sym_register] = ACTIONS(5067),
    [anon_sym_inline] = ACTIONS(5067),
    [anon_sym___inline] = ACTIONS(5067),
    [anon_sym___inline__] = ACTIONS(5067),
    [anon_sym___forceinline] = ACTIONS(5067),
    [anon_sym_thread_local] = ACTIONS(5067),
    [anon_sym___thread] = ACTIONS(5067),
    [anon_sym_const] = ACTIONS(5067),
    [anon_sym_constexpr] = ACTIONS(5067),
    [anon_sym_volatile] = ACTIONS(5067),
    [anon_sym_restrict] = ACTIONS(5067),
    [anon_sym___restrict__] = ACTIONS(5067),
    [anon_sym__Atomic] = ACTIONS(5067),
    [anon_sym__Noreturn] = ACTIONS(5067),
    [anon_sym_noreturn] = ACTIONS(5067),
    [anon_sym_mutable] = ACTIONS(5067),
    [anon_sym_constinit] = ACTIONS(5067),
    [anon_sym_consteval] = ACTIONS(5067),
    [anon_sym___shared__] = ACTIONS(5067),
    [anon_sym___local__] = ACTIONS(5067),
    [anon_sym___constant__] = ACTIONS(5067),
    [anon_sym___managed__] = ACTIONS(5067),
    [anon_sym___grid_constant__] = ACTIONS(5067),
    [anon_sym_alignas] = ACTIONS(5067),
    [anon_sym__Alignas] = ACTIONS(5067),
    [sym_primitive_type] = ACTIONS(5067),
    [anon_sym_enum] = ACTIONS(5067),
    [anon_sym_class] = ACTIONS(5067),
    [anon_sym_struct] = ACTIONS(5067),
    [anon_sym_union] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5067),
    [anon_sym_decltype] = ACTIONS(5067),
    [sym_virtual] = ACTIONS(5067),
    [anon_sym_explicit] = ACTIONS(5067),
    [anon_sym_typename] = ACTIONS(5067),
    [anon_sym_template] = ACTIONS(5067),
    [anon_sym_operator] = ACTIONS(5067),
    [anon_sym_friend] = ACTIONS(5067),
    [anon_sym_public] = ACTIONS(5067),
    [anon_sym_private] = ACTIONS(5067),
    [anon_sym_protected] = ACTIONS(5067),
    [anon_sym_using] = ACTIONS(5067),
    [anon_sym_static_assert] = ACTIONS(5067),
    [anon_sym___launch_bounds__] = ACTIONS(5067),
  },
  [1913] = {
    [sym_identifier] = ACTIONS(5063),
    [aux_sym_preproc_def_token1] = ACTIONS(5063),
    [aux_sym_preproc_if_token1] = ACTIONS(5063),
    [aux_sym_preproc_if_token2] = ACTIONS(5063),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5063),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5063),
    [sym_preproc_directive] = ACTIONS(5063),
    [anon_sym_LPAREN2] = ACTIONS(5065),
    [anon_sym_TILDE] = ACTIONS(5065),
    [anon_sym_STAR] = ACTIONS(5065),
    [anon_sym_AMP_AMP] = ACTIONS(5065),
    [anon_sym_AMP] = ACTIONS(5063),
    [anon_sym___extension__] = ACTIONS(5063),
    [anon_sym_typedef] = ACTIONS(5063),
    [anon_sym___device__] = ACTIONS(5063),
    [anon_sym___host__] = ACTIONS(5063),
    [anon_sym___global__] = ACTIONS(5063),
    [anon_sym___forceinline__] = ACTIONS(5063),
    [anon_sym___noinline__] = ACTIONS(5063),
    [anon_sym_extern] = ACTIONS(5063),
    [anon_sym___attribute__] = ACTIONS(5063),
    [anon_sym_COLON_COLON] = ACTIONS(5065),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5065),
    [anon_sym___declspec] = ACTIONS(5063),
    [anon_sym___based] = ACTIONS(5063),
    [anon_sym_signed] = ACTIONS(5063),
    [anon_sym_unsigned] = ACTIONS(5063),
    [anon_sym_long] = ACTIONS(5063),
    [anon_sym_short] = ACTIONS(5063),
    [anon_sym_LBRACK] = ACTIONS(5063),
    [anon_sym_static] = ACTIONS(5063),
    [anon_sym_register] = ACTIONS(5063),
    [anon_sym_inline] = ACTIONS(5063),
    [anon_sym___inline] = ACTIONS(5063),
    [anon_sym___inline__] = ACTIONS(5063),
    [anon_sym___forceinline] = ACTIONS(5063),
    [anon_sym_thread_local] = ACTIONS(5063),
    [anon_sym___thread] = ACTIONS(5063),
    [anon_sym_const] = ACTIONS(5063),
    [anon_sym_constexpr] = ACTIONS(5063),
    [anon_sym_volatile] = ACTIONS(5063),
    [anon_sym_restrict] = ACTIONS(5063),
    [anon_sym___restrict__] = ACTIONS(5063),
    [anon_sym__Atomic] = ACTIONS(5063),
    [anon_sym__Noreturn] = ACTIONS(5063),
    [anon_sym_noreturn] = ACTIONS(5063),
    [anon_sym_mutable] = ACTIONS(5063),
    [anon_sym_constinit] = ACTIONS(5063),
    [anon_sym_consteval] = ACTIONS(5063),
    [anon_sym___shared__] = ACTIONS(5063),
    [anon_sym___local__] = ACTIONS(5063),
    [anon_sym___constant__] = ACTIONS(5063),
    [anon_sym___managed__] = ACTIONS(5063),
    [anon_sym___grid_constant__] = ACTIONS(5063),
    [anon_sym_alignas] = ACTIONS(5063),
    [anon_sym__Alignas] = ACTIONS(5063),
    [sym_primitive_type] = ACTIONS(5063),
    [anon_sym_enum] = ACTIONS(5063),
    [anon_sym_class] = ACTIONS(5063),
    [anon_sym_struct] = ACTIONS(5063),
    [anon_sym_union] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5063),
    [anon_sym_decltype] = ACTIONS(5063),
    [sym_virtual] = ACTIONS(5063),
    [anon_sym_explicit] = ACTIONS(5063),
    [anon_sym_typename] = ACTIONS(5063),
    [anon_sym_template] = ACTIONS(5063),
    [anon_sym_operator] = ACTIONS(5063),
    [anon_sym_friend] = ACTIONS(5063),
    [anon_sym_public] = ACTIONS(5063),
    [anon_sym_private] = ACTIONS(5063),
    [anon_sym_protected] = ACTIONS(5063),
    [anon_sym_using] = ACTIONS(5063),
    [anon_sym_static_assert] = ACTIONS(5063),
    [anon_sym___launch_bounds__] = ACTIONS(5063),
  },
  [1914] = {
    [sym_identifier] = ACTIONS(5226),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5228),
    [anon_sym_COMMA] = ACTIONS(5228),
    [anon_sym_RPAREN] = ACTIONS(5228),
    [anon_sym_LPAREN2] = ACTIONS(5228),
    [anon_sym_DASH] = ACTIONS(5226),
    [anon_sym_PLUS] = ACTIONS(5226),
    [anon_sym_STAR] = ACTIONS(5228),
    [anon_sym_SLASH] = ACTIONS(5226),
    [anon_sym_PERCENT] = ACTIONS(5228),
    [anon_sym_PIPE_PIPE] = ACTIONS(5228),
    [anon_sym_AMP_AMP] = ACTIONS(5228),
    [anon_sym_PIPE] = ACTIONS(5226),
    [anon_sym_CARET] = ACTIONS(5228),
    [anon_sym_AMP] = ACTIONS(5226),
    [anon_sym_EQ_EQ] = ACTIONS(5228),
    [anon_sym_BANG_EQ] = ACTIONS(5228),
    [anon_sym_GT] = ACTIONS(5226),
    [anon_sym_GT_EQ] = ACTIONS(5228),
    [anon_sym_LT_EQ] = ACTIONS(5226),
    [anon_sym_LT] = ACTIONS(5226),
    [anon_sym_LT_LT] = ACTIONS(5226),
    [anon_sym_GT_GT] = ACTIONS(5228),
    [anon_sym_SEMI] = ACTIONS(5228),
    [anon_sym___extension__] = ACTIONS(5226),
    [anon_sym___global__] = ACTIONS(5226),
    [anon_sym___attribute__] = ACTIONS(5226),
    [anon_sym___based] = ACTIONS(5226),
    [anon_sym_LBRACE] = ACTIONS(5228),
    [anon_sym_RBRACE] = ACTIONS(5228),
    [anon_sym_signed] = ACTIONS(5226),
    [anon_sym_unsigned] = ACTIONS(5226),
    [anon_sym_long] = ACTIONS(5226),
    [anon_sym_short] = ACTIONS(5226),
    [anon_sym_LBRACK] = ACTIONS(5228),
    [anon_sym_RBRACK] = ACTIONS(5228),
    [anon_sym_const] = ACTIONS(5226),
    [anon_sym_constexpr] = ACTIONS(5226),
    [anon_sym_volatile] = ACTIONS(5226),
    [anon_sym_restrict] = ACTIONS(5226),
    [anon_sym___restrict__] = ACTIONS(5226),
    [anon_sym__Atomic] = ACTIONS(5226),
    [anon_sym__Noreturn] = ACTIONS(5226),
    [anon_sym_noreturn] = ACTIONS(5226),
    [anon_sym_mutable] = ACTIONS(5226),
    [anon_sym_constinit] = ACTIONS(5226),
    [anon_sym_consteval] = ACTIONS(5226),
    [anon_sym___shared__] = ACTIONS(5226),
    [anon_sym___local__] = ACTIONS(5226),
    [anon_sym___constant__] = ACTIONS(5226),
    [anon_sym___managed__] = ACTIONS(5226),
    [anon_sym___grid_constant__] = ACTIONS(5226),
    [anon_sym_alignas] = ACTIONS(5226),
    [anon_sym__Alignas] = ACTIONS(5226),
    [sym_primitive_type] = ACTIONS(5226),
    [anon_sym_COLON] = ACTIONS(5228),
    [anon_sym_QMARK] = ACTIONS(5228),
    [anon_sym_LT_EQ_GT] = ACTIONS(5228),
    [anon_sym_or] = ACTIONS(5226),
    [anon_sym_and] = ACTIONS(5226),
    [anon_sym_bitor] = ACTIONS(5226),
    [anon_sym_xor] = ACTIONS(5226),
    [anon_sym_bitand] = ACTIONS(5226),
    [anon_sym_not_eq] = ACTIONS(5226),
    [anon_sym_DASH_DASH] = ACTIONS(5228),
    [anon_sym_PLUS_PLUS] = ACTIONS(5228),
    [anon_sym_DOT] = ACTIONS(5226),
    [anon_sym_DOT_STAR] = ACTIONS(5228),
    [anon_sym_DASH_GT] = ACTIONS(5228),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5226),
    [anon_sym_decltype] = ACTIONS(5226),
    [anon_sym_final] = ACTIONS(5226),
    [anon_sym_override] = ACTIONS(5226),
    [anon_sym_requires] = ACTIONS(5226),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5228),
  },
  [1915] = {
    [sym_identifier] = ACTIONS(5023),
    [aux_sym_preproc_def_token1] = ACTIONS(5023),
    [aux_sym_preproc_if_token1] = ACTIONS(5023),
    [aux_sym_preproc_if_token2] = ACTIONS(5023),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5023),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5023),
    [sym_preproc_directive] = ACTIONS(5023),
    [anon_sym_LPAREN2] = ACTIONS(5025),
    [anon_sym_TILDE] = ACTIONS(5025),
    [anon_sym_STAR] = ACTIONS(5025),
    [anon_sym_AMP_AMP] = ACTIONS(5025),
    [anon_sym_AMP] = ACTIONS(5023),
    [anon_sym___extension__] = ACTIONS(5023),
    [anon_sym_typedef] = ACTIONS(5023),
    [anon_sym___device__] = ACTIONS(5023),
    [anon_sym___host__] = ACTIONS(5023),
    [anon_sym___global__] = ACTIONS(5023),
    [anon_sym___forceinline__] = ACTIONS(5023),
    [anon_sym___noinline__] = ACTIONS(5023),
    [anon_sym_extern] = ACTIONS(5023),
    [anon_sym___attribute__] = ACTIONS(5023),
    [anon_sym_COLON_COLON] = ACTIONS(5025),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5025),
    [anon_sym___declspec] = ACTIONS(5023),
    [anon_sym___based] = ACTIONS(5023),
    [anon_sym_signed] = ACTIONS(5023),
    [anon_sym_unsigned] = ACTIONS(5023),
    [anon_sym_long] = ACTIONS(5023),
    [anon_sym_short] = ACTIONS(5023),
    [anon_sym_LBRACK] = ACTIONS(5023),
    [anon_sym_static] = ACTIONS(5023),
    [anon_sym_register] = ACTIONS(5023),
    [anon_sym_inline] = ACTIONS(5023),
    [anon_sym___inline] = ACTIONS(5023),
    [anon_sym___inline__] = ACTIONS(5023),
    [anon_sym___forceinline] = ACTIONS(5023),
    [anon_sym_thread_local] = ACTIONS(5023),
    [anon_sym___thread] = ACTIONS(5023),
    [anon_sym_const] = ACTIONS(5023),
    [anon_sym_constexpr] = ACTIONS(5023),
    [anon_sym_volatile] = ACTIONS(5023),
    [anon_sym_restrict] = ACTIONS(5023),
    [anon_sym___restrict__] = ACTIONS(5023),
    [anon_sym__Atomic] = ACTIONS(5023),
    [anon_sym__Noreturn] = ACTIONS(5023),
    [anon_sym_noreturn] = ACTIONS(5023),
    [anon_sym_mutable] = ACTIONS(5023),
    [anon_sym_constinit] = ACTIONS(5023),
    [anon_sym_consteval] = ACTIONS(5023),
    [anon_sym___shared__] = ACTIONS(5023),
    [anon_sym___local__] = ACTIONS(5023),
    [anon_sym___constant__] = ACTIONS(5023),
    [anon_sym___managed__] = ACTIONS(5023),
    [anon_sym___grid_constant__] = ACTIONS(5023),
    [anon_sym_alignas] = ACTIONS(5023),
    [anon_sym__Alignas] = ACTIONS(5023),
    [sym_primitive_type] = ACTIONS(5023),
    [anon_sym_enum] = ACTIONS(5023),
    [anon_sym_class] = ACTIONS(5023),
    [anon_sym_struct] = ACTIONS(5023),
    [anon_sym_union] = ACTIONS(5023),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5023),
    [anon_sym_decltype] = ACTIONS(5023),
    [sym_virtual] = ACTIONS(5023),
    [anon_sym_explicit] = ACTIONS(5023),
    [anon_sym_typename] = ACTIONS(5023),
    [anon_sym_template] = ACTIONS(5023),
    [anon_sym_operator] = ACTIONS(5023),
    [anon_sym_friend] = ACTIONS(5023),
    [anon_sym_public] = ACTIONS(5023),
    [anon_sym_private] = ACTIONS(5023),
    [anon_sym_protected] = ACTIONS(5023),
    [anon_sym_using] = ACTIONS(5023),
    [anon_sym_static_assert] = ACTIONS(5023),
    [anon_sym___launch_bounds__] = ACTIONS(5023),
  },
  [1916] = {
    [sym_identifier] = ACTIONS(5230),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5232),
    [anon_sym_COMMA] = ACTIONS(5232),
    [anon_sym_RPAREN] = ACTIONS(5232),
    [anon_sym_LPAREN2] = ACTIONS(5232),
    [anon_sym_DASH] = ACTIONS(5230),
    [anon_sym_PLUS] = ACTIONS(5230),
    [anon_sym_STAR] = ACTIONS(5232),
    [anon_sym_SLASH] = ACTIONS(5230),
    [anon_sym_PERCENT] = ACTIONS(5232),
    [anon_sym_PIPE_PIPE] = ACTIONS(5232),
    [anon_sym_AMP_AMP] = ACTIONS(5232),
    [anon_sym_PIPE] = ACTIONS(5230),
    [anon_sym_CARET] = ACTIONS(5232),
    [anon_sym_AMP] = ACTIONS(5230),
    [anon_sym_EQ_EQ] = ACTIONS(5232),
    [anon_sym_BANG_EQ] = ACTIONS(5232),
    [anon_sym_GT] = ACTIONS(5230),
    [anon_sym_GT_EQ] = ACTIONS(5232),
    [anon_sym_LT_EQ] = ACTIONS(5230),
    [anon_sym_LT] = ACTIONS(5230),
    [anon_sym_LT_LT] = ACTIONS(5230),
    [anon_sym_GT_GT] = ACTIONS(5232),
    [anon_sym_SEMI] = ACTIONS(5232),
    [anon_sym___extension__] = ACTIONS(5230),
    [anon_sym___global__] = ACTIONS(5230),
    [anon_sym___attribute__] = ACTIONS(5230),
    [anon_sym___based] = ACTIONS(5230),
    [anon_sym_LBRACE] = ACTIONS(5232),
    [anon_sym_RBRACE] = ACTIONS(5232),
    [anon_sym_signed] = ACTIONS(5230),
    [anon_sym_unsigned] = ACTIONS(5230),
    [anon_sym_long] = ACTIONS(5230),
    [anon_sym_short] = ACTIONS(5230),
    [anon_sym_LBRACK] = ACTIONS(5232),
    [anon_sym_RBRACK] = ACTIONS(5232),
    [anon_sym_const] = ACTIONS(5230),
    [anon_sym_constexpr] = ACTIONS(5230),
    [anon_sym_volatile] = ACTIONS(5230),
    [anon_sym_restrict] = ACTIONS(5230),
    [anon_sym___restrict__] = ACTIONS(5230),
    [anon_sym__Atomic] = ACTIONS(5230),
    [anon_sym__Noreturn] = ACTIONS(5230),
    [anon_sym_noreturn] = ACTIONS(5230),
    [anon_sym_mutable] = ACTIONS(5230),
    [anon_sym_constinit] = ACTIONS(5230),
    [anon_sym_consteval] = ACTIONS(5230),
    [anon_sym___shared__] = ACTIONS(5230),
    [anon_sym___local__] = ACTIONS(5230),
    [anon_sym___constant__] = ACTIONS(5230),
    [anon_sym___managed__] = ACTIONS(5230),
    [anon_sym___grid_constant__] = ACTIONS(5230),
    [anon_sym_alignas] = ACTIONS(5230),
    [anon_sym__Alignas] = ACTIONS(5230),
    [sym_primitive_type] = ACTIONS(5230),
    [anon_sym_COLON] = ACTIONS(5232),
    [anon_sym_QMARK] = ACTIONS(5232),
    [anon_sym_LT_EQ_GT] = ACTIONS(5232),
    [anon_sym_or] = ACTIONS(5230),
    [anon_sym_and] = ACTIONS(5230),
    [anon_sym_bitor] = ACTIONS(5230),
    [anon_sym_xor] = ACTIONS(5230),
    [anon_sym_bitand] = ACTIONS(5230),
    [anon_sym_not_eq] = ACTIONS(5230),
    [anon_sym_DASH_DASH] = ACTIONS(5232),
    [anon_sym_PLUS_PLUS] = ACTIONS(5232),
    [anon_sym_DOT] = ACTIONS(5230),
    [anon_sym_DOT_STAR] = ACTIONS(5232),
    [anon_sym_DASH_GT] = ACTIONS(5232),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5230),
    [anon_sym_decltype] = ACTIONS(5230),
    [anon_sym_final] = ACTIONS(5230),
    [anon_sym_override] = ACTIONS(5230),
    [anon_sym_requires] = ACTIONS(5230),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5232),
  },
  [1917] = {
    [sym_identifier] = ACTIONS(5059),
    [aux_sym_preproc_def_token1] = ACTIONS(5059),
    [aux_sym_preproc_if_token1] = ACTIONS(5059),
    [aux_sym_preproc_if_token2] = ACTIONS(5059),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5059),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5059),
    [sym_preproc_directive] = ACTIONS(5059),
    [anon_sym_LPAREN2] = ACTIONS(5061),
    [anon_sym_TILDE] = ACTIONS(5061),
    [anon_sym_STAR] = ACTIONS(5061),
    [anon_sym_AMP_AMP] = ACTIONS(5061),
    [anon_sym_AMP] = ACTIONS(5059),
    [anon_sym___extension__] = ACTIONS(5059),
    [anon_sym_typedef] = ACTIONS(5059),
    [anon_sym___device__] = ACTIONS(5059),
    [anon_sym___host__] = ACTIONS(5059),
    [anon_sym___global__] = ACTIONS(5059),
    [anon_sym___forceinline__] = ACTIONS(5059),
    [anon_sym___noinline__] = ACTIONS(5059),
    [anon_sym_extern] = ACTIONS(5059),
    [anon_sym___attribute__] = ACTIONS(5059),
    [anon_sym_COLON_COLON] = ACTIONS(5061),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5061),
    [anon_sym___declspec] = ACTIONS(5059),
    [anon_sym___based] = ACTIONS(5059),
    [anon_sym_signed] = ACTIONS(5059),
    [anon_sym_unsigned] = ACTIONS(5059),
    [anon_sym_long] = ACTIONS(5059),
    [anon_sym_short] = ACTIONS(5059),
    [anon_sym_LBRACK] = ACTIONS(5059),
    [anon_sym_static] = ACTIONS(5059),
    [anon_sym_register] = ACTIONS(5059),
    [anon_sym_inline] = ACTIONS(5059),
    [anon_sym___inline] = ACTIONS(5059),
    [anon_sym___inline__] = ACTIONS(5059),
    [anon_sym___forceinline] = ACTIONS(5059),
    [anon_sym_thread_local] = ACTIONS(5059),
    [anon_sym___thread] = ACTIONS(5059),
    [anon_sym_const] = ACTIONS(5059),
    [anon_sym_constexpr] = ACTIONS(5059),
    [anon_sym_volatile] = ACTIONS(5059),
    [anon_sym_restrict] = ACTIONS(5059),
    [anon_sym___restrict__] = ACTIONS(5059),
    [anon_sym__Atomic] = ACTIONS(5059),
    [anon_sym__Noreturn] = ACTIONS(5059),
    [anon_sym_noreturn] = ACTIONS(5059),
    [anon_sym_mutable] = ACTIONS(5059),
    [anon_sym_constinit] = ACTIONS(5059),
    [anon_sym_consteval] = ACTIONS(5059),
    [anon_sym___shared__] = ACTIONS(5059),
    [anon_sym___local__] = ACTIONS(5059),
    [anon_sym___constant__] = ACTIONS(5059),
    [anon_sym___managed__] = ACTIONS(5059),
    [anon_sym___grid_constant__] = ACTIONS(5059),
    [anon_sym_alignas] = ACTIONS(5059),
    [anon_sym__Alignas] = ACTIONS(5059),
    [sym_primitive_type] = ACTIONS(5059),
    [anon_sym_enum] = ACTIONS(5059),
    [anon_sym_class] = ACTIONS(5059),
    [anon_sym_struct] = ACTIONS(5059),
    [anon_sym_union] = ACTIONS(5059),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5059),
    [anon_sym_decltype] = ACTIONS(5059),
    [sym_virtual] = ACTIONS(5059),
    [anon_sym_explicit] = ACTIONS(5059),
    [anon_sym_typename] = ACTIONS(5059),
    [anon_sym_template] = ACTIONS(5059),
    [anon_sym_operator] = ACTIONS(5059),
    [anon_sym_friend] = ACTIONS(5059),
    [anon_sym_public] = ACTIONS(5059),
    [anon_sym_private] = ACTIONS(5059),
    [anon_sym_protected] = ACTIONS(5059),
    [anon_sym_using] = ACTIONS(5059),
    [anon_sym_static_assert] = ACTIONS(5059),
    [anon_sym___launch_bounds__] = ACTIONS(5059),
  },
  [1918] = {
    [sym_identifier] = ACTIONS(5059),
    [aux_sym_preproc_def_token1] = ACTIONS(5059),
    [aux_sym_preproc_if_token1] = ACTIONS(5059),
    [aux_sym_preproc_if_token2] = ACTIONS(5059),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5059),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5059),
    [sym_preproc_directive] = ACTIONS(5059),
    [anon_sym_LPAREN2] = ACTIONS(5061),
    [anon_sym_TILDE] = ACTIONS(5061),
    [anon_sym_STAR] = ACTIONS(5061),
    [anon_sym_AMP_AMP] = ACTIONS(5061),
    [anon_sym_AMP] = ACTIONS(5059),
    [anon_sym___extension__] = ACTIONS(5059),
    [anon_sym_typedef] = ACTIONS(5059),
    [anon_sym___device__] = ACTIONS(5059),
    [anon_sym___host__] = ACTIONS(5059),
    [anon_sym___global__] = ACTIONS(5059),
    [anon_sym___forceinline__] = ACTIONS(5059),
    [anon_sym___noinline__] = ACTIONS(5059),
    [anon_sym_extern] = ACTIONS(5059),
    [anon_sym___attribute__] = ACTIONS(5059),
    [anon_sym_COLON_COLON] = ACTIONS(5061),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5061),
    [anon_sym___declspec] = ACTIONS(5059),
    [anon_sym___based] = ACTIONS(5059),
    [anon_sym_signed] = ACTIONS(5059),
    [anon_sym_unsigned] = ACTIONS(5059),
    [anon_sym_long] = ACTIONS(5059),
    [anon_sym_short] = ACTIONS(5059),
    [anon_sym_LBRACK] = ACTIONS(5059),
    [anon_sym_static] = ACTIONS(5059),
    [anon_sym_register] = ACTIONS(5059),
    [anon_sym_inline] = ACTIONS(5059),
    [anon_sym___inline] = ACTIONS(5059),
    [anon_sym___inline__] = ACTIONS(5059),
    [anon_sym___forceinline] = ACTIONS(5059),
    [anon_sym_thread_local] = ACTIONS(5059),
    [anon_sym___thread] = ACTIONS(5059),
    [anon_sym_const] = ACTIONS(5059),
    [anon_sym_constexpr] = ACTIONS(5059),
    [anon_sym_volatile] = ACTIONS(5059),
    [anon_sym_restrict] = ACTIONS(5059),
    [anon_sym___restrict__] = ACTIONS(5059),
    [anon_sym__Atomic] = ACTIONS(5059),
    [anon_sym__Noreturn] = ACTIONS(5059),
    [anon_sym_noreturn] = ACTIONS(5059),
    [anon_sym_mutable] = ACTIONS(5059),
    [anon_sym_constinit] = ACTIONS(5059),
    [anon_sym_consteval] = ACTIONS(5059),
    [anon_sym___shared__] = ACTIONS(5059),
    [anon_sym___local__] = ACTIONS(5059),
    [anon_sym___constant__] = ACTIONS(5059),
    [anon_sym___managed__] = ACTIONS(5059),
    [anon_sym___grid_constant__] = ACTIONS(5059),
    [anon_sym_alignas] = ACTIONS(5059),
    [anon_sym__Alignas] = ACTIONS(5059),
    [sym_primitive_type] = ACTIONS(5059),
    [anon_sym_enum] = ACTIONS(5059),
    [anon_sym_class] = ACTIONS(5059),
    [anon_sym_struct] = ACTIONS(5059),
    [anon_sym_union] = ACTIONS(5059),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5059),
    [anon_sym_decltype] = ACTIONS(5059),
    [sym_virtual] = ACTIONS(5059),
    [anon_sym_explicit] = ACTIONS(5059),
    [anon_sym_typename] = ACTIONS(5059),
    [anon_sym_template] = ACTIONS(5059),
    [anon_sym_operator] = ACTIONS(5059),
    [anon_sym_friend] = ACTIONS(5059),
    [anon_sym_public] = ACTIONS(5059),
    [anon_sym_private] = ACTIONS(5059),
    [anon_sym_protected] = ACTIONS(5059),
    [anon_sym_using] = ACTIONS(5059),
    [anon_sym_static_assert] = ACTIONS(5059),
    [anon_sym___launch_bounds__] = ACTIONS(5059),
  },
  [1919] = {
    [sym_identifier] = ACTIONS(5055),
    [aux_sym_preproc_def_token1] = ACTIONS(5055),
    [aux_sym_preproc_if_token1] = ACTIONS(5055),
    [aux_sym_preproc_if_token2] = ACTIONS(5055),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5055),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5055),
    [sym_preproc_directive] = ACTIONS(5055),
    [anon_sym_LPAREN2] = ACTIONS(5057),
    [anon_sym_TILDE] = ACTIONS(5057),
    [anon_sym_STAR] = ACTIONS(5057),
    [anon_sym_AMP_AMP] = ACTIONS(5057),
    [anon_sym_AMP] = ACTIONS(5055),
    [anon_sym___extension__] = ACTIONS(5055),
    [anon_sym_typedef] = ACTIONS(5055),
    [anon_sym___device__] = ACTIONS(5055),
    [anon_sym___host__] = ACTIONS(5055),
    [anon_sym___global__] = ACTIONS(5055),
    [anon_sym___forceinline__] = ACTIONS(5055),
    [anon_sym___noinline__] = ACTIONS(5055),
    [anon_sym_extern] = ACTIONS(5055),
    [anon_sym___attribute__] = ACTIONS(5055),
    [anon_sym_COLON_COLON] = ACTIONS(5057),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5057),
    [anon_sym___declspec] = ACTIONS(5055),
    [anon_sym___based] = ACTIONS(5055),
    [anon_sym_signed] = ACTIONS(5055),
    [anon_sym_unsigned] = ACTIONS(5055),
    [anon_sym_long] = ACTIONS(5055),
    [anon_sym_short] = ACTIONS(5055),
    [anon_sym_LBRACK] = ACTIONS(5055),
    [anon_sym_static] = ACTIONS(5055),
    [anon_sym_register] = ACTIONS(5055),
    [anon_sym_inline] = ACTIONS(5055),
    [anon_sym___inline] = ACTIONS(5055),
    [anon_sym___inline__] = ACTIONS(5055),
    [anon_sym___forceinline] = ACTIONS(5055),
    [anon_sym_thread_local] = ACTIONS(5055),
    [anon_sym___thread] = ACTIONS(5055),
    [anon_sym_const] = ACTIONS(5055),
    [anon_sym_constexpr] = ACTIONS(5055),
    [anon_sym_volatile] = ACTIONS(5055),
    [anon_sym_restrict] = ACTIONS(5055),
    [anon_sym___restrict__] = ACTIONS(5055),
    [anon_sym__Atomic] = ACTIONS(5055),
    [anon_sym__Noreturn] = ACTIONS(5055),
    [anon_sym_noreturn] = ACTIONS(5055),
    [anon_sym_mutable] = ACTIONS(5055),
    [anon_sym_constinit] = ACTIONS(5055),
    [anon_sym_consteval] = ACTIONS(5055),
    [anon_sym___shared__] = ACTIONS(5055),
    [anon_sym___local__] = ACTIONS(5055),
    [anon_sym___constant__] = ACTIONS(5055),
    [anon_sym___managed__] = ACTIONS(5055),
    [anon_sym___grid_constant__] = ACTIONS(5055),
    [anon_sym_alignas] = ACTIONS(5055),
    [anon_sym__Alignas] = ACTIONS(5055),
    [sym_primitive_type] = ACTIONS(5055),
    [anon_sym_enum] = ACTIONS(5055),
    [anon_sym_class] = ACTIONS(5055),
    [anon_sym_struct] = ACTIONS(5055),
    [anon_sym_union] = ACTIONS(5055),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5055),
    [anon_sym_decltype] = ACTIONS(5055),
    [sym_virtual] = ACTIONS(5055),
    [anon_sym_explicit] = ACTIONS(5055),
    [anon_sym_typename] = ACTIONS(5055),
    [anon_sym_template] = ACTIONS(5055),
    [anon_sym_operator] = ACTIONS(5055),
    [anon_sym_friend] = ACTIONS(5055),
    [anon_sym_public] = ACTIONS(5055),
    [anon_sym_private] = ACTIONS(5055),
    [anon_sym_protected] = ACTIONS(5055),
    [anon_sym_using] = ACTIONS(5055),
    [anon_sym_static_assert] = ACTIONS(5055),
    [anon_sym___launch_bounds__] = ACTIONS(5055),
  },
  [1920] = {
    [sym_identifier] = ACTIONS(5051),
    [aux_sym_preproc_def_token1] = ACTIONS(5051),
    [aux_sym_preproc_if_token1] = ACTIONS(5051),
    [aux_sym_preproc_if_token2] = ACTIONS(5051),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5051),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5051),
    [sym_preproc_directive] = ACTIONS(5051),
    [anon_sym_LPAREN2] = ACTIONS(5053),
    [anon_sym_TILDE] = ACTIONS(5053),
    [anon_sym_STAR] = ACTIONS(5053),
    [anon_sym_AMP_AMP] = ACTIONS(5053),
    [anon_sym_AMP] = ACTIONS(5051),
    [anon_sym___extension__] = ACTIONS(5051),
    [anon_sym_typedef] = ACTIONS(5051),
    [anon_sym___device__] = ACTIONS(5051),
    [anon_sym___host__] = ACTIONS(5051),
    [anon_sym___global__] = ACTIONS(5051),
    [anon_sym___forceinline__] = ACTIONS(5051),
    [anon_sym___noinline__] = ACTIONS(5051),
    [anon_sym_extern] = ACTIONS(5051),
    [anon_sym___attribute__] = ACTIONS(5051),
    [anon_sym_COLON_COLON] = ACTIONS(5053),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5053),
    [anon_sym___declspec] = ACTIONS(5051),
    [anon_sym___based] = ACTIONS(5051),
    [anon_sym_signed] = ACTIONS(5051),
    [anon_sym_unsigned] = ACTIONS(5051),
    [anon_sym_long] = ACTIONS(5051),
    [anon_sym_short] = ACTIONS(5051),
    [anon_sym_LBRACK] = ACTIONS(5051),
    [anon_sym_static] = ACTIONS(5051),
    [anon_sym_register] = ACTIONS(5051),
    [anon_sym_inline] = ACTIONS(5051),
    [anon_sym___inline] = ACTIONS(5051),
    [anon_sym___inline__] = ACTIONS(5051),
    [anon_sym___forceinline] = ACTIONS(5051),
    [anon_sym_thread_local] = ACTIONS(5051),
    [anon_sym___thread] = ACTIONS(5051),
    [anon_sym_const] = ACTIONS(5051),
    [anon_sym_constexpr] = ACTIONS(5051),
    [anon_sym_volatile] = ACTIONS(5051),
    [anon_sym_restrict] = ACTIONS(5051),
    [anon_sym___restrict__] = ACTIONS(5051),
    [anon_sym__Atomic] = ACTIONS(5051),
    [anon_sym__Noreturn] = ACTIONS(5051),
    [anon_sym_noreturn] = ACTIONS(5051),
    [anon_sym_mutable] = ACTIONS(5051),
    [anon_sym_constinit] = ACTIONS(5051),
    [anon_sym_consteval] = ACTIONS(5051),
    [anon_sym___shared__] = ACTIONS(5051),
    [anon_sym___local__] = ACTIONS(5051),
    [anon_sym___constant__] = ACTIONS(5051),
    [anon_sym___managed__] = ACTIONS(5051),
    [anon_sym___grid_constant__] = ACTIONS(5051),
    [anon_sym_alignas] = ACTIONS(5051),
    [anon_sym__Alignas] = ACTIONS(5051),
    [sym_primitive_type] = ACTIONS(5051),
    [anon_sym_enum] = ACTIONS(5051),
    [anon_sym_class] = ACTIONS(5051),
    [anon_sym_struct] = ACTIONS(5051),
    [anon_sym_union] = ACTIONS(5051),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5051),
    [anon_sym_decltype] = ACTIONS(5051),
    [sym_virtual] = ACTIONS(5051),
    [anon_sym_explicit] = ACTIONS(5051),
    [anon_sym_typename] = ACTIONS(5051),
    [anon_sym_template] = ACTIONS(5051),
    [anon_sym_operator] = ACTIONS(5051),
    [anon_sym_friend] = ACTIONS(5051),
    [anon_sym_public] = ACTIONS(5051),
    [anon_sym_private] = ACTIONS(5051),
    [anon_sym_protected] = ACTIONS(5051),
    [anon_sym_using] = ACTIONS(5051),
    [anon_sym_static_assert] = ACTIONS(5051),
    [anon_sym___launch_bounds__] = ACTIONS(5051),
  },
  [1921] = {
    [sym_identifier] = ACTIONS(5047),
    [aux_sym_preproc_def_token1] = ACTIONS(5047),
    [aux_sym_preproc_if_token1] = ACTIONS(5047),
    [aux_sym_preproc_if_token2] = ACTIONS(5047),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5047),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5047),
    [sym_preproc_directive] = ACTIONS(5047),
    [anon_sym_LPAREN2] = ACTIONS(5049),
    [anon_sym_TILDE] = ACTIONS(5049),
    [anon_sym_STAR] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5049),
    [anon_sym_AMP] = ACTIONS(5047),
    [anon_sym___extension__] = ACTIONS(5047),
    [anon_sym_typedef] = ACTIONS(5047),
    [anon_sym___device__] = ACTIONS(5047),
    [anon_sym___host__] = ACTIONS(5047),
    [anon_sym___global__] = ACTIONS(5047),
    [anon_sym___forceinline__] = ACTIONS(5047),
    [anon_sym___noinline__] = ACTIONS(5047),
    [anon_sym_extern] = ACTIONS(5047),
    [anon_sym___attribute__] = ACTIONS(5047),
    [anon_sym_COLON_COLON] = ACTIONS(5049),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5049),
    [anon_sym___declspec] = ACTIONS(5047),
    [anon_sym___based] = ACTIONS(5047),
    [anon_sym_signed] = ACTIONS(5047),
    [anon_sym_unsigned] = ACTIONS(5047),
    [anon_sym_long] = ACTIONS(5047),
    [anon_sym_short] = ACTIONS(5047),
    [anon_sym_LBRACK] = ACTIONS(5047),
    [anon_sym_static] = ACTIONS(5047),
    [anon_sym_register] = ACTIONS(5047),
    [anon_sym_inline] = ACTIONS(5047),
    [anon_sym___inline] = ACTIONS(5047),
    [anon_sym___inline__] = ACTIONS(5047),
    [anon_sym___forceinline] = ACTIONS(5047),
    [anon_sym_thread_local] = ACTIONS(5047),
    [anon_sym___thread] = ACTIONS(5047),
    [anon_sym_const] = ACTIONS(5047),
    [anon_sym_constexpr] = ACTIONS(5047),
    [anon_sym_volatile] = ACTIONS(5047),
    [anon_sym_restrict] = ACTIONS(5047),
    [anon_sym___restrict__] = ACTIONS(5047),
    [anon_sym__Atomic] = ACTIONS(5047),
    [anon_sym__Noreturn] = ACTIONS(5047),
    [anon_sym_noreturn] = ACTIONS(5047),
    [anon_sym_mutable] = ACTIONS(5047),
    [anon_sym_constinit] = ACTIONS(5047),
    [anon_sym_consteval] = ACTIONS(5047),
    [anon_sym___shared__] = ACTIONS(5047),
    [anon_sym___local__] = ACTIONS(5047),
    [anon_sym___constant__] = ACTIONS(5047),
    [anon_sym___managed__] = ACTIONS(5047),
    [anon_sym___grid_constant__] = ACTIONS(5047),
    [anon_sym_alignas] = ACTIONS(5047),
    [anon_sym__Alignas] = ACTIONS(5047),
    [sym_primitive_type] = ACTIONS(5047),
    [anon_sym_enum] = ACTIONS(5047),
    [anon_sym_class] = ACTIONS(5047),
    [anon_sym_struct] = ACTIONS(5047),
    [anon_sym_union] = ACTIONS(5047),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5047),
    [anon_sym_decltype] = ACTIONS(5047),
    [sym_virtual] = ACTIONS(5047),
    [anon_sym_explicit] = ACTIONS(5047),
    [anon_sym_typename] = ACTIONS(5047),
    [anon_sym_template] = ACTIONS(5047),
    [anon_sym_operator] = ACTIONS(5047),
    [anon_sym_friend] = ACTIONS(5047),
    [anon_sym_public] = ACTIONS(5047),
    [anon_sym_private] = ACTIONS(5047),
    [anon_sym_protected] = ACTIONS(5047),
    [anon_sym_using] = ACTIONS(5047),
    [anon_sym_static_assert] = ACTIONS(5047),
    [anon_sym___launch_bounds__] = ACTIONS(5047),
  },
  [1922] = {
    [sym_identifier] = ACTIONS(3652),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3654),
    [anon_sym_COMMA] = ACTIONS(3654),
    [anon_sym_RPAREN] = ACTIONS(3654),
    [anon_sym_LPAREN2] = ACTIONS(3654),
    [anon_sym_TILDE] = ACTIONS(3654),
    [anon_sym_STAR] = ACTIONS(3654),
    [anon_sym_AMP_AMP] = ACTIONS(3654),
    [anon_sym_AMP] = ACTIONS(3652),
    [anon_sym_SEMI] = ACTIONS(3654),
    [anon_sym___extension__] = ACTIONS(3652),
    [anon_sym___device__] = ACTIONS(3652),
    [anon_sym___host__] = ACTIONS(3652),
    [anon_sym___global__] = ACTIONS(3652),
    [anon_sym___forceinline__] = ACTIONS(3652),
    [anon_sym___noinline__] = ACTIONS(3652),
    [anon_sym_extern] = ACTIONS(3652),
    [anon_sym___attribute__] = ACTIONS(3652),
    [anon_sym_COLON_COLON] = ACTIONS(3654),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3654),
    [anon_sym___declspec] = ACTIONS(3652),
    [anon_sym___based] = ACTIONS(3652),
    [anon_sym___cdecl] = ACTIONS(3652),
    [anon_sym___clrcall] = ACTIONS(3652),
    [anon_sym___stdcall] = ACTIONS(3652),
    [anon_sym___fastcall] = ACTIONS(3652),
    [anon_sym___thiscall] = ACTIONS(3652),
    [anon_sym___vectorcall] = ACTIONS(3652),
    [anon_sym_LBRACE] = ACTIONS(3654),
    [anon_sym_LBRACK] = ACTIONS(3652),
    [anon_sym_static] = ACTIONS(3652),
    [anon_sym_EQ] = ACTIONS(3654),
    [anon_sym_register] = ACTIONS(3652),
    [anon_sym_inline] = ACTIONS(3652),
    [anon_sym___inline] = ACTIONS(3652),
    [anon_sym___inline__] = ACTIONS(3652),
    [anon_sym___forceinline] = ACTIONS(3652),
    [anon_sym_thread_local] = ACTIONS(3652),
    [anon_sym___thread] = ACTIONS(3652),
    [anon_sym_const] = ACTIONS(3652),
    [anon_sym_constexpr] = ACTIONS(3652),
    [anon_sym_volatile] = ACTIONS(3652),
    [anon_sym_restrict] = ACTIONS(3652),
    [anon_sym___restrict__] = ACTIONS(3652),
    [anon_sym__Atomic] = ACTIONS(3652),
    [anon_sym__Noreturn] = ACTIONS(3652),
    [anon_sym_noreturn] = ACTIONS(3652),
    [anon_sym_mutable] = ACTIONS(3652),
    [anon_sym_constinit] = ACTIONS(3652),
    [anon_sym_consteval] = ACTIONS(3652),
    [anon_sym___shared__] = ACTIONS(3652),
    [anon_sym___local__] = ACTIONS(3652),
    [anon_sym___constant__] = ACTIONS(3652),
    [anon_sym___managed__] = ACTIONS(3652),
    [anon_sym___grid_constant__] = ACTIONS(3652),
    [anon_sym_alignas] = ACTIONS(3652),
    [anon_sym__Alignas] = ACTIONS(3652),
    [anon_sym_COLON] = ACTIONS(3652),
    [anon_sym_asm] = ACTIONS(3652),
    [anon_sym___asm__] = ACTIONS(3652),
    [anon_sym_DASH_GT] = ACTIONS(3654),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3652),
    [anon_sym_final] = ACTIONS(3652),
    [anon_sym_override] = ACTIONS(3652),
    [sym_virtual] = ACTIONS(3652),
    [anon_sym_explicit] = ACTIONS(3652),
    [anon_sym_template] = ACTIONS(3652),
    [anon_sym_GT2] = ACTIONS(3654),
    [anon_sym_operator] = ACTIONS(3652),
    [anon_sym_try] = ACTIONS(3652),
    [anon_sym_public] = ACTIONS(3652),
    [anon_sym_private] = ACTIONS(3652),
    [anon_sym_protected] = ACTIONS(3652),
    [anon_sym_requires] = ACTIONS(3652),
    [anon_sym___launch_bounds__] = ACTIONS(3652),
  },
  [1923] = {
    [sym_identifier] = ACTIONS(2231),
    [aux_sym_preproc_def_token1] = ACTIONS(2231),
    [aux_sym_preproc_if_token1] = ACTIONS(2231),
    [aux_sym_preproc_if_token2] = ACTIONS(2231),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2231),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2231),
    [sym_preproc_directive] = ACTIONS(2231),
    [anon_sym_LPAREN2] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_STAR] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym___extension__] = ACTIONS(2231),
    [anon_sym_typedef] = ACTIONS(2231),
    [anon_sym___device__] = ACTIONS(2231),
    [anon_sym___host__] = ACTIONS(2231),
    [anon_sym___global__] = ACTIONS(2231),
    [anon_sym___forceinline__] = ACTIONS(2231),
    [anon_sym___noinline__] = ACTIONS(2231),
    [anon_sym_extern] = ACTIONS(2231),
    [anon_sym___attribute__] = ACTIONS(2231),
    [anon_sym_COLON_COLON] = ACTIONS(2233),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2233),
    [anon_sym___declspec] = ACTIONS(2231),
    [anon_sym___based] = ACTIONS(2231),
    [anon_sym_signed] = ACTIONS(2231),
    [anon_sym_unsigned] = ACTIONS(2231),
    [anon_sym_long] = ACTIONS(2231),
    [anon_sym_short] = ACTIONS(2231),
    [anon_sym_LBRACK] = ACTIONS(2231),
    [anon_sym_static] = ACTIONS(2231),
    [anon_sym_register] = ACTIONS(2231),
    [anon_sym_inline] = ACTIONS(2231),
    [anon_sym___inline] = ACTIONS(2231),
    [anon_sym___inline__] = ACTIONS(2231),
    [anon_sym___forceinline] = ACTIONS(2231),
    [anon_sym_thread_local] = ACTIONS(2231),
    [anon_sym___thread] = ACTIONS(2231),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_constexpr] = ACTIONS(2231),
    [anon_sym_volatile] = ACTIONS(2231),
    [anon_sym_restrict] = ACTIONS(2231),
    [anon_sym___restrict__] = ACTIONS(2231),
    [anon_sym__Atomic] = ACTIONS(2231),
    [anon_sym__Noreturn] = ACTIONS(2231),
    [anon_sym_noreturn] = ACTIONS(2231),
    [anon_sym_mutable] = ACTIONS(2231),
    [anon_sym_constinit] = ACTIONS(2231),
    [anon_sym_consteval] = ACTIONS(2231),
    [anon_sym___shared__] = ACTIONS(2231),
    [anon_sym___local__] = ACTIONS(2231),
    [anon_sym___constant__] = ACTIONS(2231),
    [anon_sym___managed__] = ACTIONS(2231),
    [anon_sym___grid_constant__] = ACTIONS(2231),
    [anon_sym_alignas] = ACTIONS(2231),
    [anon_sym__Alignas] = ACTIONS(2231),
    [sym_primitive_type] = ACTIONS(2231),
    [anon_sym_enum] = ACTIONS(2231),
    [anon_sym_class] = ACTIONS(2231),
    [anon_sym_struct] = ACTIONS(2231),
    [anon_sym_union] = ACTIONS(2231),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2231),
    [anon_sym_decltype] = ACTIONS(2231),
    [sym_virtual] = ACTIONS(2231),
    [anon_sym_explicit] = ACTIONS(2231),
    [anon_sym_typename] = ACTIONS(2231),
    [anon_sym_template] = ACTIONS(2231),
    [anon_sym_operator] = ACTIONS(2231),
    [anon_sym_friend] = ACTIONS(2231),
    [anon_sym_public] = ACTIONS(2231),
    [anon_sym_private] = ACTIONS(2231),
    [anon_sym_protected] = ACTIONS(2231),
    [anon_sym_using] = ACTIONS(2231),
    [anon_sym_static_assert] = ACTIONS(2231),
    [anon_sym___launch_bounds__] = ACTIONS(2231),
  },
  [1924] = {
    [sym_identifier] = ACTIONS(2255),
    [aux_sym_preproc_def_token1] = ACTIONS(2255),
    [aux_sym_preproc_if_token1] = ACTIONS(2255),
    [aux_sym_preproc_if_token2] = ACTIONS(2255),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2255),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2255),
    [sym_preproc_directive] = ACTIONS(2255),
    [anon_sym_LPAREN2] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_STAR] = ACTIONS(2257),
    [anon_sym_AMP_AMP] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2255),
    [anon_sym___extension__] = ACTIONS(2255),
    [anon_sym_typedef] = ACTIONS(2255),
    [anon_sym___device__] = ACTIONS(2255),
    [anon_sym___host__] = ACTIONS(2255),
    [anon_sym___global__] = ACTIONS(2255),
    [anon_sym___forceinline__] = ACTIONS(2255),
    [anon_sym___noinline__] = ACTIONS(2255),
    [anon_sym_extern] = ACTIONS(2255),
    [anon_sym___attribute__] = ACTIONS(2255),
    [anon_sym_COLON_COLON] = ACTIONS(2257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2257),
    [anon_sym___declspec] = ACTIONS(2255),
    [anon_sym___based] = ACTIONS(2255),
    [anon_sym_signed] = ACTIONS(2255),
    [anon_sym_unsigned] = ACTIONS(2255),
    [anon_sym_long] = ACTIONS(2255),
    [anon_sym_short] = ACTIONS(2255),
    [anon_sym_LBRACK] = ACTIONS(2255),
    [anon_sym_static] = ACTIONS(2255),
    [anon_sym_register] = ACTIONS(2255),
    [anon_sym_inline] = ACTIONS(2255),
    [anon_sym___inline] = ACTIONS(2255),
    [anon_sym___inline__] = ACTIONS(2255),
    [anon_sym___forceinline] = ACTIONS(2255),
    [anon_sym_thread_local] = ACTIONS(2255),
    [anon_sym___thread] = ACTIONS(2255),
    [anon_sym_const] = ACTIONS(2255),
    [anon_sym_constexpr] = ACTIONS(2255),
    [anon_sym_volatile] = ACTIONS(2255),
    [anon_sym_restrict] = ACTIONS(2255),
    [anon_sym___restrict__] = ACTIONS(2255),
    [anon_sym__Atomic] = ACTIONS(2255),
    [anon_sym__Noreturn] = ACTIONS(2255),
    [anon_sym_noreturn] = ACTIONS(2255),
    [anon_sym_mutable] = ACTIONS(2255),
    [anon_sym_constinit] = ACTIONS(2255),
    [anon_sym_consteval] = ACTIONS(2255),
    [anon_sym___shared__] = ACTIONS(2255),
    [anon_sym___local__] = ACTIONS(2255),
    [anon_sym___constant__] = ACTIONS(2255),
    [anon_sym___managed__] = ACTIONS(2255),
    [anon_sym___grid_constant__] = ACTIONS(2255),
    [anon_sym_alignas] = ACTIONS(2255),
    [anon_sym__Alignas] = ACTIONS(2255),
    [sym_primitive_type] = ACTIONS(2255),
    [anon_sym_enum] = ACTIONS(2255),
    [anon_sym_class] = ACTIONS(2255),
    [anon_sym_struct] = ACTIONS(2255),
    [anon_sym_union] = ACTIONS(2255),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2255),
    [anon_sym_decltype] = ACTIONS(2255),
    [sym_virtual] = ACTIONS(2255),
    [anon_sym_explicit] = ACTIONS(2255),
    [anon_sym_typename] = ACTIONS(2255),
    [anon_sym_template] = ACTIONS(2255),
    [anon_sym_operator] = ACTIONS(2255),
    [anon_sym_friend] = ACTIONS(2255),
    [anon_sym_public] = ACTIONS(2255),
    [anon_sym_private] = ACTIONS(2255),
    [anon_sym_protected] = ACTIONS(2255),
    [anon_sym_using] = ACTIONS(2255),
    [anon_sym_static_assert] = ACTIONS(2255),
    [anon_sym___launch_bounds__] = ACTIONS(2255),
  },
  [1925] = {
    [sym_identifier] = ACTIONS(2094),
    [aux_sym_preproc_def_token1] = ACTIONS(2094),
    [aux_sym_preproc_if_token1] = ACTIONS(2094),
    [aux_sym_preproc_if_token2] = ACTIONS(2094),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2094),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2094),
    [sym_preproc_directive] = ACTIONS(2094),
    [anon_sym_LPAREN2] = ACTIONS(2096),
    [anon_sym_TILDE] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(2096),
    [anon_sym_AMP_AMP] = ACTIONS(2096),
    [anon_sym_AMP] = ACTIONS(2094),
    [anon_sym___extension__] = ACTIONS(2094),
    [anon_sym_typedef] = ACTIONS(2094),
    [anon_sym___device__] = ACTIONS(2094),
    [anon_sym___host__] = ACTIONS(2094),
    [anon_sym___global__] = ACTIONS(2094),
    [anon_sym___forceinline__] = ACTIONS(2094),
    [anon_sym___noinline__] = ACTIONS(2094),
    [anon_sym_extern] = ACTIONS(2094),
    [anon_sym___attribute__] = ACTIONS(2094),
    [anon_sym_COLON_COLON] = ACTIONS(2096),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2096),
    [anon_sym___declspec] = ACTIONS(2094),
    [anon_sym___based] = ACTIONS(2094),
    [anon_sym_signed] = ACTIONS(2094),
    [anon_sym_unsigned] = ACTIONS(2094),
    [anon_sym_long] = ACTIONS(2094),
    [anon_sym_short] = ACTIONS(2094),
    [anon_sym_LBRACK] = ACTIONS(2094),
    [anon_sym_static] = ACTIONS(2094),
    [anon_sym_register] = ACTIONS(2094),
    [anon_sym_inline] = ACTIONS(2094),
    [anon_sym___inline] = ACTIONS(2094),
    [anon_sym___inline__] = ACTIONS(2094),
    [anon_sym___forceinline] = ACTIONS(2094),
    [anon_sym_thread_local] = ACTIONS(2094),
    [anon_sym___thread] = ACTIONS(2094),
    [anon_sym_const] = ACTIONS(2094),
    [anon_sym_constexpr] = ACTIONS(2094),
    [anon_sym_volatile] = ACTIONS(2094),
    [anon_sym_restrict] = ACTIONS(2094),
    [anon_sym___restrict__] = ACTIONS(2094),
    [anon_sym__Atomic] = ACTIONS(2094),
    [anon_sym__Noreturn] = ACTIONS(2094),
    [anon_sym_noreturn] = ACTIONS(2094),
    [anon_sym_mutable] = ACTIONS(2094),
    [anon_sym_constinit] = ACTIONS(2094),
    [anon_sym_consteval] = ACTIONS(2094),
    [anon_sym___shared__] = ACTIONS(2094),
    [anon_sym___local__] = ACTIONS(2094),
    [anon_sym___constant__] = ACTIONS(2094),
    [anon_sym___managed__] = ACTIONS(2094),
    [anon_sym___grid_constant__] = ACTIONS(2094),
    [anon_sym_alignas] = ACTIONS(2094),
    [anon_sym__Alignas] = ACTIONS(2094),
    [sym_primitive_type] = ACTIONS(2094),
    [anon_sym_enum] = ACTIONS(2094),
    [anon_sym_class] = ACTIONS(2094),
    [anon_sym_struct] = ACTIONS(2094),
    [anon_sym_union] = ACTIONS(2094),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2094),
    [anon_sym_decltype] = ACTIONS(2094),
    [sym_virtual] = ACTIONS(2094),
    [anon_sym_explicit] = ACTIONS(2094),
    [anon_sym_typename] = ACTIONS(2094),
    [anon_sym_template] = ACTIONS(2094),
    [anon_sym_operator] = ACTIONS(2094),
    [anon_sym_friend] = ACTIONS(2094),
    [anon_sym_public] = ACTIONS(2094),
    [anon_sym_private] = ACTIONS(2094),
    [anon_sym_protected] = ACTIONS(2094),
    [anon_sym_using] = ACTIONS(2094),
    [anon_sym_static_assert] = ACTIONS(2094),
    [anon_sym___launch_bounds__] = ACTIONS(2094),
  },
  [1926] = {
    [sym_identifier] = ACTIONS(2409),
    [aux_sym_preproc_def_token1] = ACTIONS(2409),
    [aux_sym_preproc_if_token1] = ACTIONS(2409),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2409),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2409),
    [sym_preproc_directive] = ACTIONS(2409),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2409),
    [anon_sym___extension__] = ACTIONS(2409),
    [anon_sym_typedef] = ACTIONS(2409),
    [anon_sym___device__] = ACTIONS(2409),
    [anon_sym___host__] = ACTIONS(2409),
    [anon_sym___global__] = ACTIONS(2409),
    [anon_sym___forceinline__] = ACTIONS(2409),
    [anon_sym___noinline__] = ACTIONS(2409),
    [anon_sym_extern] = ACTIONS(2409),
    [anon_sym___attribute__] = ACTIONS(2409),
    [anon_sym_COLON_COLON] = ACTIONS(2411),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2411),
    [anon_sym___declspec] = ACTIONS(2409),
    [anon_sym___based] = ACTIONS(2409),
    [anon_sym_RBRACE] = ACTIONS(2411),
    [anon_sym_signed] = ACTIONS(2409),
    [anon_sym_unsigned] = ACTIONS(2409),
    [anon_sym_long] = ACTIONS(2409),
    [anon_sym_short] = ACTIONS(2409),
    [anon_sym_LBRACK] = ACTIONS(2409),
    [anon_sym_static] = ACTIONS(2409),
    [anon_sym_register] = ACTIONS(2409),
    [anon_sym_inline] = ACTIONS(2409),
    [anon_sym___inline] = ACTIONS(2409),
    [anon_sym___inline__] = ACTIONS(2409),
    [anon_sym___forceinline] = ACTIONS(2409),
    [anon_sym_thread_local] = ACTIONS(2409),
    [anon_sym___thread] = ACTIONS(2409),
    [anon_sym_const] = ACTIONS(2409),
    [anon_sym_constexpr] = ACTIONS(2409),
    [anon_sym_volatile] = ACTIONS(2409),
    [anon_sym_restrict] = ACTIONS(2409),
    [anon_sym___restrict__] = ACTIONS(2409),
    [anon_sym__Atomic] = ACTIONS(2409),
    [anon_sym__Noreturn] = ACTIONS(2409),
    [anon_sym_noreturn] = ACTIONS(2409),
    [anon_sym_mutable] = ACTIONS(2409),
    [anon_sym_constinit] = ACTIONS(2409),
    [anon_sym_consteval] = ACTIONS(2409),
    [anon_sym___shared__] = ACTIONS(2409),
    [anon_sym___local__] = ACTIONS(2409),
    [anon_sym___constant__] = ACTIONS(2409),
    [anon_sym___managed__] = ACTIONS(2409),
    [anon_sym___grid_constant__] = ACTIONS(2409),
    [anon_sym_alignas] = ACTIONS(2409),
    [anon_sym__Alignas] = ACTIONS(2409),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2409),
    [anon_sym_class] = ACTIONS(2409),
    [anon_sym_struct] = ACTIONS(2409),
    [anon_sym_union] = ACTIONS(2409),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2409),
    [anon_sym_decltype] = ACTIONS(2409),
    [sym_virtual] = ACTIONS(2409),
    [anon_sym_explicit] = ACTIONS(2409),
    [anon_sym_typename] = ACTIONS(2409),
    [anon_sym_template] = ACTIONS(2409),
    [anon_sym_operator] = ACTIONS(2409),
    [anon_sym_friend] = ACTIONS(2409),
    [anon_sym_public] = ACTIONS(2409),
    [anon_sym_private] = ACTIONS(2409),
    [anon_sym_protected] = ACTIONS(2409),
    [anon_sym_using] = ACTIONS(2409),
    [anon_sym_static_assert] = ACTIONS(2409),
    [anon_sym___launch_bounds__] = ACTIONS(2409),
  },
  [1927] = {
    [sym_identifier] = ACTIONS(2235),
    [aux_sym_preproc_def_token1] = ACTIONS(2235),
    [aux_sym_preproc_if_token1] = ACTIONS(2235),
    [aux_sym_preproc_if_token2] = ACTIONS(2235),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2235),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2235),
    [sym_preproc_directive] = ACTIONS(2235),
    [anon_sym_LPAREN2] = ACTIONS(2237),
    [anon_sym_TILDE] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2237),
    [anon_sym_AMP_AMP] = ACTIONS(2237),
    [anon_sym_AMP] = ACTIONS(2235),
    [anon_sym___extension__] = ACTIONS(2235),
    [anon_sym_typedef] = ACTIONS(2235),
    [anon_sym___device__] = ACTIONS(2235),
    [anon_sym___host__] = ACTIONS(2235),
    [anon_sym___global__] = ACTIONS(2235),
    [anon_sym___forceinline__] = ACTIONS(2235),
    [anon_sym___noinline__] = ACTIONS(2235),
    [anon_sym_extern] = ACTIONS(2235),
    [anon_sym___attribute__] = ACTIONS(2235),
    [anon_sym_COLON_COLON] = ACTIONS(2237),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2237),
    [anon_sym___declspec] = ACTIONS(2235),
    [anon_sym___based] = ACTIONS(2235),
    [anon_sym_signed] = ACTIONS(2235),
    [anon_sym_unsigned] = ACTIONS(2235),
    [anon_sym_long] = ACTIONS(2235),
    [anon_sym_short] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_static] = ACTIONS(2235),
    [anon_sym_register] = ACTIONS(2235),
    [anon_sym_inline] = ACTIONS(2235),
    [anon_sym___inline] = ACTIONS(2235),
    [anon_sym___inline__] = ACTIONS(2235),
    [anon_sym___forceinline] = ACTIONS(2235),
    [anon_sym_thread_local] = ACTIONS(2235),
    [anon_sym___thread] = ACTIONS(2235),
    [anon_sym_const] = ACTIONS(2235),
    [anon_sym_constexpr] = ACTIONS(2235),
    [anon_sym_volatile] = ACTIONS(2235),
    [anon_sym_restrict] = ACTIONS(2235),
    [anon_sym___restrict__] = ACTIONS(2235),
    [anon_sym__Atomic] = ACTIONS(2235),
    [anon_sym__Noreturn] = ACTIONS(2235),
    [anon_sym_noreturn] = ACTIONS(2235),
    [anon_sym_mutable] = ACTIONS(2235),
    [anon_sym_constinit] = ACTIONS(2235),
    [anon_sym_consteval] = ACTIONS(2235),
    [anon_sym___shared__] = ACTIONS(2235),
    [anon_sym___local__] = ACTIONS(2235),
    [anon_sym___constant__] = ACTIONS(2235),
    [anon_sym___managed__] = ACTIONS(2235),
    [anon_sym___grid_constant__] = ACTIONS(2235),
    [anon_sym_alignas] = ACTIONS(2235),
    [anon_sym__Alignas] = ACTIONS(2235),
    [sym_primitive_type] = ACTIONS(2235),
    [anon_sym_enum] = ACTIONS(2235),
    [anon_sym_class] = ACTIONS(2235),
    [anon_sym_struct] = ACTIONS(2235),
    [anon_sym_union] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2235),
    [anon_sym_decltype] = ACTIONS(2235),
    [sym_virtual] = ACTIONS(2235),
    [anon_sym_explicit] = ACTIONS(2235),
    [anon_sym_typename] = ACTIONS(2235),
    [anon_sym_template] = ACTIONS(2235),
    [anon_sym_operator] = ACTIONS(2235),
    [anon_sym_friend] = ACTIONS(2235),
    [anon_sym_public] = ACTIONS(2235),
    [anon_sym_private] = ACTIONS(2235),
    [anon_sym_protected] = ACTIONS(2235),
    [anon_sym_using] = ACTIONS(2235),
    [anon_sym_static_assert] = ACTIONS(2235),
    [anon_sym___launch_bounds__] = ACTIONS(2235),
  },
  [1928] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token2] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2269),
    [anon_sym_TILDE] = ACTIONS(2269),
    [anon_sym_STAR] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym___device__] = ACTIONS(2267),
    [anon_sym___host__] = ACTIONS(2267),
    [anon_sym___global__] = ACTIONS(2267),
    [anon_sym___forceinline__] = ACTIONS(2267),
    [anon_sym___noinline__] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2269),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2269),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym___shared__] = ACTIONS(2267),
    [anon_sym___local__] = ACTIONS(2267),
    [anon_sym___constant__] = ACTIONS(2267),
    [anon_sym___managed__] = ACTIONS(2267),
    [anon_sym___grid_constant__] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym__Alignas] = ACTIONS(2267),
    [sym_primitive_type] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [sym_virtual] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_friend] = ACTIONS(2267),
    [anon_sym_public] = ACTIONS(2267),
    [anon_sym_private] = ACTIONS(2267),
    [anon_sym_protected] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym___launch_bounds__] = ACTIONS(2267),
  },
  [1929] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token2] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2269),
    [anon_sym_TILDE] = ACTIONS(2269),
    [anon_sym_STAR] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym___device__] = ACTIONS(2267),
    [anon_sym___host__] = ACTIONS(2267),
    [anon_sym___global__] = ACTIONS(2267),
    [anon_sym___forceinline__] = ACTIONS(2267),
    [anon_sym___noinline__] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2269),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2269),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym___shared__] = ACTIONS(2267),
    [anon_sym___local__] = ACTIONS(2267),
    [anon_sym___constant__] = ACTIONS(2267),
    [anon_sym___managed__] = ACTIONS(2267),
    [anon_sym___grid_constant__] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym__Alignas] = ACTIONS(2267),
    [sym_primitive_type] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [sym_virtual] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_friend] = ACTIONS(2267),
    [anon_sym_public] = ACTIONS(2267),
    [anon_sym_private] = ACTIONS(2267),
    [anon_sym_protected] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym___launch_bounds__] = ACTIONS(2267),
  },
  [1930] = {
    [sym_identifier] = ACTIONS(2094),
    [aux_sym_preproc_def_token1] = ACTIONS(2094),
    [aux_sym_preproc_if_token1] = ACTIONS(2094),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2094),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2094),
    [sym_preproc_directive] = ACTIONS(2094),
    [anon_sym_LPAREN2] = ACTIONS(2096),
    [anon_sym_TILDE] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(2096),
    [anon_sym_AMP_AMP] = ACTIONS(2096),
    [anon_sym_AMP] = ACTIONS(2094),
    [anon_sym___extension__] = ACTIONS(2094),
    [anon_sym_typedef] = ACTIONS(2094),
    [anon_sym___device__] = ACTIONS(2094),
    [anon_sym___host__] = ACTIONS(2094),
    [anon_sym___global__] = ACTIONS(2094),
    [anon_sym___forceinline__] = ACTIONS(2094),
    [anon_sym___noinline__] = ACTIONS(2094),
    [anon_sym_extern] = ACTIONS(2094),
    [anon_sym___attribute__] = ACTIONS(2094),
    [anon_sym_COLON_COLON] = ACTIONS(2096),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2096),
    [anon_sym___declspec] = ACTIONS(2094),
    [anon_sym___based] = ACTIONS(2094),
    [anon_sym_RBRACE] = ACTIONS(2096),
    [anon_sym_signed] = ACTIONS(2094),
    [anon_sym_unsigned] = ACTIONS(2094),
    [anon_sym_long] = ACTIONS(2094),
    [anon_sym_short] = ACTIONS(2094),
    [anon_sym_LBRACK] = ACTIONS(2094),
    [anon_sym_static] = ACTIONS(2094),
    [anon_sym_register] = ACTIONS(2094),
    [anon_sym_inline] = ACTIONS(2094),
    [anon_sym___inline] = ACTIONS(2094),
    [anon_sym___inline__] = ACTIONS(2094),
    [anon_sym___forceinline] = ACTIONS(2094),
    [anon_sym_thread_local] = ACTIONS(2094),
    [anon_sym___thread] = ACTIONS(2094),
    [anon_sym_const] = ACTIONS(2094),
    [anon_sym_constexpr] = ACTIONS(2094),
    [anon_sym_volatile] = ACTIONS(2094),
    [anon_sym_restrict] = ACTIONS(2094),
    [anon_sym___restrict__] = ACTIONS(2094),
    [anon_sym__Atomic] = ACTIONS(2094),
    [anon_sym__Noreturn] = ACTIONS(2094),
    [anon_sym_noreturn] = ACTIONS(2094),
    [anon_sym_mutable] = ACTIONS(2094),
    [anon_sym_constinit] = ACTIONS(2094),
    [anon_sym_consteval] = ACTIONS(2094),
    [anon_sym___shared__] = ACTIONS(2094),
    [anon_sym___local__] = ACTIONS(2094),
    [anon_sym___constant__] = ACTIONS(2094),
    [anon_sym___managed__] = ACTIONS(2094),
    [anon_sym___grid_constant__] = ACTIONS(2094),
    [anon_sym_alignas] = ACTIONS(2094),
    [anon_sym__Alignas] = ACTIONS(2094),
    [sym_primitive_type] = ACTIONS(2094),
    [anon_sym_enum] = ACTIONS(2094),
    [anon_sym_class] = ACTIONS(2094),
    [anon_sym_struct] = ACTIONS(2094),
    [anon_sym_union] = ACTIONS(2094),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2094),
    [anon_sym_decltype] = ACTIONS(2094),
    [sym_virtual] = ACTIONS(2094),
    [anon_sym_explicit] = ACTIONS(2094),
    [anon_sym_typename] = ACTIONS(2094),
    [anon_sym_template] = ACTIONS(2094),
    [anon_sym_operator] = ACTIONS(2094),
    [anon_sym_friend] = ACTIONS(2094),
    [anon_sym_public] = ACTIONS(2094),
    [anon_sym_private] = ACTIONS(2094),
    [anon_sym_protected] = ACTIONS(2094),
    [anon_sym_using] = ACTIONS(2094),
    [anon_sym_static_assert] = ACTIONS(2094),
    [anon_sym___launch_bounds__] = ACTIONS(2094),
  },
  [1931] = {
    [sym_identifier] = ACTIONS(2172),
    [aux_sym_preproc_def_token1] = ACTIONS(2172),
    [aux_sym_preproc_if_token1] = ACTIONS(2172),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2172),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2172),
    [sym_preproc_directive] = ACTIONS(2172),
    [anon_sym_LPAREN2] = ACTIONS(2174),
    [anon_sym_TILDE] = ACTIONS(2174),
    [anon_sym_STAR] = ACTIONS(2174),
    [anon_sym_AMP_AMP] = ACTIONS(2174),
    [anon_sym_AMP] = ACTIONS(2172),
    [anon_sym___extension__] = ACTIONS(2172),
    [anon_sym_typedef] = ACTIONS(2172),
    [anon_sym___device__] = ACTIONS(2172),
    [anon_sym___host__] = ACTIONS(2172),
    [anon_sym___global__] = ACTIONS(2172),
    [anon_sym___forceinline__] = ACTIONS(2172),
    [anon_sym___noinline__] = ACTIONS(2172),
    [anon_sym_extern] = ACTIONS(2172),
    [anon_sym___attribute__] = ACTIONS(2172),
    [anon_sym_COLON_COLON] = ACTIONS(2174),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2174),
    [anon_sym___declspec] = ACTIONS(2172),
    [anon_sym___based] = ACTIONS(2172),
    [anon_sym_RBRACE] = ACTIONS(2174),
    [anon_sym_signed] = ACTIONS(2172),
    [anon_sym_unsigned] = ACTIONS(2172),
    [anon_sym_long] = ACTIONS(2172),
    [anon_sym_short] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2172),
    [anon_sym_static] = ACTIONS(2172),
    [anon_sym_register] = ACTIONS(2172),
    [anon_sym_inline] = ACTIONS(2172),
    [anon_sym___inline] = ACTIONS(2172),
    [anon_sym___inline__] = ACTIONS(2172),
    [anon_sym___forceinline] = ACTIONS(2172),
    [anon_sym_thread_local] = ACTIONS(2172),
    [anon_sym___thread] = ACTIONS(2172),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_constexpr] = ACTIONS(2172),
    [anon_sym_volatile] = ACTIONS(2172),
    [anon_sym_restrict] = ACTIONS(2172),
    [anon_sym___restrict__] = ACTIONS(2172),
    [anon_sym__Atomic] = ACTIONS(2172),
    [anon_sym__Noreturn] = ACTIONS(2172),
    [anon_sym_noreturn] = ACTIONS(2172),
    [anon_sym_mutable] = ACTIONS(2172),
    [anon_sym_constinit] = ACTIONS(2172),
    [anon_sym_consteval] = ACTIONS(2172),
    [anon_sym___shared__] = ACTIONS(2172),
    [anon_sym___local__] = ACTIONS(2172),
    [anon_sym___constant__] = ACTIONS(2172),
    [anon_sym___managed__] = ACTIONS(2172),
    [anon_sym___grid_constant__] = ACTIONS(2172),
    [anon_sym_alignas] = ACTIONS(2172),
    [anon_sym__Alignas] = ACTIONS(2172),
    [sym_primitive_type] = ACTIONS(2172),
    [anon_sym_enum] = ACTIONS(2172),
    [anon_sym_class] = ACTIONS(2172),
    [anon_sym_struct] = ACTIONS(2172),
    [anon_sym_union] = ACTIONS(2172),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2172),
    [anon_sym_decltype] = ACTIONS(2172),
    [sym_virtual] = ACTIONS(2172),
    [anon_sym_explicit] = ACTIONS(2172),
    [anon_sym_typename] = ACTIONS(2172),
    [anon_sym_template] = ACTIONS(2172),
    [anon_sym_operator] = ACTIONS(2172),
    [anon_sym_friend] = ACTIONS(2172),
    [anon_sym_public] = ACTIONS(2172),
    [anon_sym_private] = ACTIONS(2172),
    [anon_sym_protected] = ACTIONS(2172),
    [anon_sym_using] = ACTIONS(2172),
    [anon_sym_static_assert] = ACTIONS(2172),
    [anon_sym___launch_bounds__] = ACTIONS(2172),
  },
  [1932] = {
    [sym_identifier] = ACTIONS(5234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5236),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_RPAREN] = ACTIONS(5236),
    [anon_sym_LPAREN2] = ACTIONS(5236),
    [anon_sym_DASH] = ACTIONS(5234),
    [anon_sym_PLUS] = ACTIONS(5234),
    [anon_sym_STAR] = ACTIONS(5236),
    [anon_sym_SLASH] = ACTIONS(5234),
    [anon_sym_PERCENT] = ACTIONS(5236),
    [anon_sym_PIPE_PIPE] = ACTIONS(5236),
    [anon_sym_AMP_AMP] = ACTIONS(5236),
    [anon_sym_PIPE] = ACTIONS(5234),
    [anon_sym_CARET] = ACTIONS(5236),
    [anon_sym_AMP] = ACTIONS(5234),
    [anon_sym_EQ_EQ] = ACTIONS(5236),
    [anon_sym_BANG_EQ] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5234),
    [anon_sym_GT_EQ] = ACTIONS(5236),
    [anon_sym_LT_EQ] = ACTIONS(5234),
    [anon_sym_LT] = ACTIONS(5234),
    [anon_sym_LT_LT] = ACTIONS(5234),
    [anon_sym_GT_GT] = ACTIONS(5236),
    [anon_sym_SEMI] = ACTIONS(5236),
    [anon_sym___extension__] = ACTIONS(5234),
    [anon_sym___global__] = ACTIONS(5234),
    [anon_sym___attribute__] = ACTIONS(5234),
    [anon_sym___based] = ACTIONS(5234),
    [anon_sym_LBRACE] = ACTIONS(5236),
    [anon_sym_RBRACE] = ACTIONS(5236),
    [anon_sym_signed] = ACTIONS(5234),
    [anon_sym_unsigned] = ACTIONS(5234),
    [anon_sym_long] = ACTIONS(5234),
    [anon_sym_short] = ACTIONS(5234),
    [anon_sym_LBRACK] = ACTIONS(5236),
    [anon_sym_RBRACK] = ACTIONS(5236),
    [anon_sym_const] = ACTIONS(5234),
    [anon_sym_constexpr] = ACTIONS(5234),
    [anon_sym_volatile] = ACTIONS(5234),
    [anon_sym_restrict] = ACTIONS(5234),
    [anon_sym___restrict__] = ACTIONS(5234),
    [anon_sym__Atomic] = ACTIONS(5234),
    [anon_sym__Noreturn] = ACTIONS(5234),
    [anon_sym_noreturn] = ACTIONS(5234),
    [anon_sym_mutable] = ACTIONS(5234),
    [anon_sym_constinit] = ACTIONS(5234),
    [anon_sym_consteval] = ACTIONS(5234),
    [anon_sym___shared__] = ACTIONS(5234),
    [anon_sym___local__] = ACTIONS(5234),
    [anon_sym___constant__] = ACTIONS(5234),
    [anon_sym___managed__] = ACTIONS(5234),
    [anon_sym___grid_constant__] = ACTIONS(5234),
    [anon_sym_alignas] = ACTIONS(5234),
    [anon_sym__Alignas] = ACTIONS(5234),
    [sym_primitive_type] = ACTIONS(5234),
    [anon_sym_COLON] = ACTIONS(5236),
    [anon_sym_QMARK] = ACTIONS(5236),
    [anon_sym_LT_EQ_GT] = ACTIONS(5236),
    [anon_sym_or] = ACTIONS(5234),
    [anon_sym_and] = ACTIONS(5234),
    [anon_sym_bitor] = ACTIONS(5234),
    [anon_sym_xor] = ACTIONS(5234),
    [anon_sym_bitand] = ACTIONS(5234),
    [anon_sym_not_eq] = ACTIONS(5234),
    [anon_sym_DASH_DASH] = ACTIONS(5236),
    [anon_sym_PLUS_PLUS] = ACTIONS(5236),
    [anon_sym_DOT] = ACTIONS(5234),
    [anon_sym_DOT_STAR] = ACTIONS(5236),
    [anon_sym_DASH_GT] = ACTIONS(5236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5234),
    [anon_sym_decltype] = ACTIONS(5234),
    [anon_sym_final] = ACTIONS(5234),
    [anon_sym_override] = ACTIONS(5234),
    [anon_sym_requires] = ACTIONS(5234),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5236),
  },
  [1933] = {
    [sym_identifier] = ACTIONS(2275),
    [aux_sym_preproc_def_token1] = ACTIONS(2275),
    [aux_sym_preproc_if_token1] = ACTIONS(2275),
    [aux_sym_preproc_if_token2] = ACTIONS(2275),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2275),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2275),
    [sym_preproc_directive] = ACTIONS(2275),
    [anon_sym_LPAREN2] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [anon_sym_STAR] = ACTIONS(2277),
    [anon_sym_AMP_AMP] = ACTIONS(2277),
    [anon_sym_AMP] = ACTIONS(2275),
    [anon_sym___extension__] = ACTIONS(2275),
    [anon_sym_typedef] = ACTIONS(2275),
    [anon_sym___device__] = ACTIONS(2275),
    [anon_sym___host__] = ACTIONS(2275),
    [anon_sym___global__] = ACTIONS(2275),
    [anon_sym___forceinline__] = ACTIONS(2275),
    [anon_sym___noinline__] = ACTIONS(2275),
    [anon_sym_extern] = ACTIONS(2275),
    [anon_sym___attribute__] = ACTIONS(2275),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2277),
    [anon_sym___declspec] = ACTIONS(2275),
    [anon_sym___based] = ACTIONS(2275),
    [anon_sym_signed] = ACTIONS(2275),
    [anon_sym_unsigned] = ACTIONS(2275),
    [anon_sym_long] = ACTIONS(2275),
    [anon_sym_short] = ACTIONS(2275),
    [anon_sym_LBRACK] = ACTIONS(2275),
    [anon_sym_static] = ACTIONS(2275),
    [anon_sym_register] = ACTIONS(2275),
    [anon_sym_inline] = ACTIONS(2275),
    [anon_sym___inline] = ACTIONS(2275),
    [anon_sym___inline__] = ACTIONS(2275),
    [anon_sym___forceinline] = ACTIONS(2275),
    [anon_sym_thread_local] = ACTIONS(2275),
    [anon_sym___thread] = ACTIONS(2275),
    [anon_sym_const] = ACTIONS(2275),
    [anon_sym_constexpr] = ACTIONS(2275),
    [anon_sym_volatile] = ACTIONS(2275),
    [anon_sym_restrict] = ACTIONS(2275),
    [anon_sym___restrict__] = ACTIONS(2275),
    [anon_sym__Atomic] = ACTIONS(2275),
    [anon_sym__Noreturn] = ACTIONS(2275),
    [anon_sym_noreturn] = ACTIONS(2275),
    [anon_sym_mutable] = ACTIONS(2275),
    [anon_sym_constinit] = ACTIONS(2275),
    [anon_sym_consteval] = ACTIONS(2275),
    [anon_sym___shared__] = ACTIONS(2275),
    [anon_sym___local__] = ACTIONS(2275),
    [anon_sym___constant__] = ACTIONS(2275),
    [anon_sym___managed__] = ACTIONS(2275),
    [anon_sym___grid_constant__] = ACTIONS(2275),
    [anon_sym_alignas] = ACTIONS(2275),
    [anon_sym__Alignas] = ACTIONS(2275),
    [sym_primitive_type] = ACTIONS(2275),
    [anon_sym_enum] = ACTIONS(2275),
    [anon_sym_class] = ACTIONS(2275),
    [anon_sym_struct] = ACTIONS(2275),
    [anon_sym_union] = ACTIONS(2275),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2275),
    [anon_sym_decltype] = ACTIONS(2275),
    [sym_virtual] = ACTIONS(2275),
    [anon_sym_explicit] = ACTIONS(2275),
    [anon_sym_typename] = ACTIONS(2275),
    [anon_sym_template] = ACTIONS(2275),
    [anon_sym_operator] = ACTIONS(2275),
    [anon_sym_friend] = ACTIONS(2275),
    [anon_sym_public] = ACTIONS(2275),
    [anon_sym_private] = ACTIONS(2275),
    [anon_sym_protected] = ACTIONS(2275),
    [anon_sym_using] = ACTIONS(2275),
    [anon_sym_static_assert] = ACTIONS(2275),
    [anon_sym___launch_bounds__] = ACTIONS(2275),
  },
  [1934] = {
    [sym_identifier] = ACTIONS(2284),
    [aux_sym_preproc_def_token1] = ACTIONS(2284),
    [aux_sym_preproc_if_token1] = ACTIONS(2284),
    [aux_sym_preproc_if_token2] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2284),
    [sym_preproc_directive] = ACTIONS(2284),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_typedef] = ACTIONS(2284),
    [anon_sym___device__] = ACTIONS(2284),
    [anon_sym___host__] = ACTIONS(2284),
    [anon_sym___global__] = ACTIONS(2284),
    [anon_sym___forceinline__] = ACTIONS(2284),
    [anon_sym___noinline__] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2286),
    [anon_sym___declspec] = ACTIONS(2284),
    [anon_sym___based] = ACTIONS(2284),
    [anon_sym_signed] = ACTIONS(2284),
    [anon_sym_unsigned] = ACTIONS(2284),
    [anon_sym_long] = ACTIONS(2284),
    [anon_sym_short] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym___inline] = ACTIONS(2284),
    [anon_sym___inline__] = ACTIONS(2284),
    [anon_sym___forceinline] = ACTIONS(2284),
    [anon_sym_thread_local] = ACTIONS(2284),
    [anon_sym___thread] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym___shared__] = ACTIONS(2284),
    [anon_sym___local__] = ACTIONS(2284),
    [anon_sym___constant__] = ACTIONS(2284),
    [anon_sym___managed__] = ACTIONS(2284),
    [anon_sym___grid_constant__] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [sym_primitive_type] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
    [anon_sym_class] = ACTIONS(2284),
    [anon_sym_struct] = ACTIONS(2284),
    [anon_sym_union] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [sym_virtual] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_typename] = ACTIONS(2284),
    [anon_sym_template] = ACTIONS(2284),
    [anon_sym_operator] = ACTIONS(2284),
    [anon_sym_friend] = ACTIONS(2284),
    [anon_sym_public] = ACTIONS(2284),
    [anon_sym_private] = ACTIONS(2284),
    [anon_sym_protected] = ACTIONS(2284),
    [anon_sym_using] = ACTIONS(2284),
    [anon_sym_static_assert] = ACTIONS(2284),
    [anon_sym___launch_bounds__] = ACTIONS(2284),
  },
  [1935] = {
    [sym_identifier] = ACTIONS(2342),
    [aux_sym_preproc_def_token1] = ACTIONS(2342),
    [aux_sym_preproc_if_token1] = ACTIONS(2342),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2342),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2342),
    [sym_preproc_directive] = ACTIONS(2342),
    [anon_sym_LPAREN2] = ACTIONS(2344),
    [anon_sym_TILDE] = ACTIONS(2344),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2342),
    [anon_sym___extension__] = ACTIONS(2342),
    [anon_sym_typedef] = ACTIONS(2342),
    [anon_sym___device__] = ACTIONS(2342),
    [anon_sym___host__] = ACTIONS(2342),
    [anon_sym___global__] = ACTIONS(2342),
    [anon_sym___forceinline__] = ACTIONS(2342),
    [anon_sym___noinline__] = ACTIONS(2342),
    [anon_sym_extern] = ACTIONS(2342),
    [anon_sym___attribute__] = ACTIONS(2342),
    [anon_sym_COLON_COLON] = ACTIONS(2344),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2344),
    [anon_sym___declspec] = ACTIONS(2342),
    [anon_sym___based] = ACTIONS(2342),
    [anon_sym_RBRACE] = ACTIONS(2344),
    [anon_sym_signed] = ACTIONS(2342),
    [anon_sym_unsigned] = ACTIONS(2342),
    [anon_sym_long] = ACTIONS(2342),
    [anon_sym_short] = ACTIONS(2342),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_static] = ACTIONS(2342),
    [anon_sym_register] = ACTIONS(2342),
    [anon_sym_inline] = ACTIONS(2342),
    [anon_sym___inline] = ACTIONS(2342),
    [anon_sym___inline__] = ACTIONS(2342),
    [anon_sym___forceinline] = ACTIONS(2342),
    [anon_sym_thread_local] = ACTIONS(2342),
    [anon_sym___thread] = ACTIONS(2342),
    [anon_sym_const] = ACTIONS(2342),
    [anon_sym_constexpr] = ACTIONS(2342),
    [anon_sym_volatile] = ACTIONS(2342),
    [anon_sym_restrict] = ACTIONS(2342),
    [anon_sym___restrict__] = ACTIONS(2342),
    [anon_sym__Atomic] = ACTIONS(2342),
    [anon_sym__Noreturn] = ACTIONS(2342),
    [anon_sym_noreturn] = ACTIONS(2342),
    [anon_sym_mutable] = ACTIONS(2342),
    [anon_sym_constinit] = ACTIONS(2342),
    [anon_sym_consteval] = ACTIONS(2342),
    [anon_sym___shared__] = ACTIONS(2342),
    [anon_sym___local__] = ACTIONS(2342),
    [anon_sym___constant__] = ACTIONS(2342),
    [anon_sym___managed__] = ACTIONS(2342),
    [anon_sym___grid_constant__] = ACTIONS(2342),
    [anon_sym_alignas] = ACTIONS(2342),
    [anon_sym__Alignas] = ACTIONS(2342),
    [sym_primitive_type] = ACTIONS(2342),
    [anon_sym_enum] = ACTIONS(2342),
    [anon_sym_class] = ACTIONS(2342),
    [anon_sym_struct] = ACTIONS(2342),
    [anon_sym_union] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2342),
    [anon_sym_decltype] = ACTIONS(2342),
    [sym_virtual] = ACTIONS(2342),
    [anon_sym_explicit] = ACTIONS(2342),
    [anon_sym_typename] = ACTIONS(2342),
    [anon_sym_template] = ACTIONS(2342),
    [anon_sym_operator] = ACTIONS(2342),
    [anon_sym_friend] = ACTIONS(2342),
    [anon_sym_public] = ACTIONS(2342),
    [anon_sym_private] = ACTIONS(2342),
    [anon_sym_protected] = ACTIONS(2342),
    [anon_sym_using] = ACTIONS(2342),
    [anon_sym_static_assert] = ACTIONS(2342),
    [anon_sym___launch_bounds__] = ACTIONS(2342),
  },
  [1936] = {
    [sym_identifier] = ACTIONS(2288),
    [aux_sym_preproc_def_token1] = ACTIONS(2288),
    [aux_sym_preproc_if_token1] = ACTIONS(2288),
    [aux_sym_preproc_if_token2] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2288),
    [sym_preproc_directive] = ACTIONS(2288),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym_typedef] = ACTIONS(2288),
    [anon_sym___device__] = ACTIONS(2288),
    [anon_sym___host__] = ACTIONS(2288),
    [anon_sym___global__] = ACTIONS(2288),
    [anon_sym___forceinline__] = ACTIONS(2288),
    [anon_sym___noinline__] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2290),
    [anon_sym___declspec] = ACTIONS(2288),
    [anon_sym___based] = ACTIONS(2288),
    [anon_sym_signed] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym___inline] = ACTIONS(2288),
    [anon_sym___inline__] = ACTIONS(2288),
    [anon_sym___forceinline] = ACTIONS(2288),
    [anon_sym_thread_local] = ACTIONS(2288),
    [anon_sym___thread] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym___shared__] = ACTIONS(2288),
    [anon_sym___local__] = ACTIONS(2288),
    [anon_sym___constant__] = ACTIONS(2288),
    [anon_sym___managed__] = ACTIONS(2288),
    [anon_sym___grid_constant__] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [sym_virtual] = ACTIONS(2288),
    [anon_sym_explicit] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_operator] = ACTIONS(2288),
    [anon_sym_friend] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_static_assert] = ACTIONS(2288),
    [anon_sym___launch_bounds__] = ACTIONS(2288),
  },
  [1937] = {
    [sym_identifier] = ACTIONS(5238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5240),
    [anon_sym_COMMA] = ACTIONS(5240),
    [anon_sym_RPAREN] = ACTIONS(5240),
    [anon_sym_LPAREN2] = ACTIONS(5240),
    [anon_sym_DASH] = ACTIONS(5238),
    [anon_sym_PLUS] = ACTIONS(5238),
    [anon_sym_STAR] = ACTIONS(5240),
    [anon_sym_SLASH] = ACTIONS(5238),
    [anon_sym_PERCENT] = ACTIONS(5240),
    [anon_sym_PIPE_PIPE] = ACTIONS(5240),
    [anon_sym_AMP_AMP] = ACTIONS(5240),
    [anon_sym_PIPE] = ACTIONS(5238),
    [anon_sym_CARET] = ACTIONS(5240),
    [anon_sym_AMP] = ACTIONS(5238),
    [anon_sym_EQ_EQ] = ACTIONS(5240),
    [anon_sym_BANG_EQ] = ACTIONS(5240),
    [anon_sym_GT] = ACTIONS(5238),
    [anon_sym_GT_EQ] = ACTIONS(5240),
    [anon_sym_LT_EQ] = ACTIONS(5238),
    [anon_sym_LT] = ACTIONS(5238),
    [anon_sym_LT_LT] = ACTIONS(5238),
    [anon_sym_GT_GT] = ACTIONS(5240),
    [anon_sym_SEMI] = ACTIONS(5240),
    [anon_sym___extension__] = ACTIONS(5238),
    [anon_sym___global__] = ACTIONS(5238),
    [anon_sym___attribute__] = ACTIONS(5238),
    [anon_sym___based] = ACTIONS(5238),
    [anon_sym_LBRACE] = ACTIONS(5240),
    [anon_sym_RBRACE] = ACTIONS(5240),
    [anon_sym_signed] = ACTIONS(5238),
    [anon_sym_unsigned] = ACTIONS(5238),
    [anon_sym_long] = ACTIONS(5238),
    [anon_sym_short] = ACTIONS(5238),
    [anon_sym_LBRACK] = ACTIONS(5240),
    [anon_sym_RBRACK] = ACTIONS(5240),
    [anon_sym_const] = ACTIONS(5238),
    [anon_sym_constexpr] = ACTIONS(5238),
    [anon_sym_volatile] = ACTIONS(5238),
    [anon_sym_restrict] = ACTIONS(5238),
    [anon_sym___restrict__] = ACTIONS(5238),
    [anon_sym__Atomic] = ACTIONS(5238),
    [anon_sym__Noreturn] = ACTIONS(5238),
    [anon_sym_noreturn] = ACTIONS(5238),
    [anon_sym_mutable] = ACTIONS(5238),
    [anon_sym_constinit] = ACTIONS(5238),
    [anon_sym_consteval] = ACTIONS(5238),
    [anon_sym___shared__] = ACTIONS(5238),
    [anon_sym___local__] = ACTIONS(5238),
    [anon_sym___constant__] = ACTIONS(5238),
    [anon_sym___managed__] = ACTIONS(5238),
    [anon_sym___grid_constant__] = ACTIONS(5238),
    [anon_sym_alignas] = ACTIONS(5238),
    [anon_sym__Alignas] = ACTIONS(5238),
    [sym_primitive_type] = ACTIONS(5238),
    [anon_sym_COLON] = ACTIONS(5240),
    [anon_sym_QMARK] = ACTIONS(5240),
    [anon_sym_LT_EQ_GT] = ACTIONS(5240),
    [anon_sym_or] = ACTIONS(5238),
    [anon_sym_and] = ACTIONS(5238),
    [anon_sym_bitor] = ACTIONS(5238),
    [anon_sym_xor] = ACTIONS(5238),
    [anon_sym_bitand] = ACTIONS(5238),
    [anon_sym_not_eq] = ACTIONS(5238),
    [anon_sym_DASH_DASH] = ACTIONS(5240),
    [anon_sym_PLUS_PLUS] = ACTIONS(5240),
    [anon_sym_DOT] = ACTIONS(5238),
    [anon_sym_DOT_STAR] = ACTIONS(5240),
    [anon_sym_DASH_GT] = ACTIONS(5240),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5238),
    [anon_sym_decltype] = ACTIONS(5238),
    [anon_sym_final] = ACTIONS(5238),
    [anon_sym_override] = ACTIONS(5238),
    [anon_sym_requires] = ACTIONS(5238),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5240),
  },
  [1938] = {
    [sym_identifier] = ACTIONS(2292),
    [aux_sym_preproc_def_token1] = ACTIONS(2292),
    [aux_sym_preproc_if_token1] = ACTIONS(2292),
    [aux_sym_preproc_if_token2] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2292),
    [sym_preproc_directive] = ACTIONS(2292),
    [anon_sym_LPAREN2] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym___extension__] = ACTIONS(2292),
    [anon_sym_typedef] = ACTIONS(2292),
    [anon_sym___device__] = ACTIONS(2292),
    [anon_sym___host__] = ACTIONS(2292),
    [anon_sym___global__] = ACTIONS(2292),
    [anon_sym___forceinline__] = ACTIONS(2292),
    [anon_sym___noinline__] = ACTIONS(2292),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym___attribute__] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2294),
    [anon_sym___declspec] = ACTIONS(2292),
    [anon_sym___based] = ACTIONS(2292),
    [anon_sym_signed] = ACTIONS(2292),
    [anon_sym_unsigned] = ACTIONS(2292),
    [anon_sym_long] = ACTIONS(2292),
    [anon_sym_short] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_register] = ACTIONS(2292),
    [anon_sym_inline] = ACTIONS(2292),
    [anon_sym___inline] = ACTIONS(2292),
    [anon_sym___inline__] = ACTIONS(2292),
    [anon_sym___forceinline] = ACTIONS(2292),
    [anon_sym_thread_local] = ACTIONS(2292),
    [anon_sym___thread] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym___restrict__] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym__Noreturn] = ACTIONS(2292),
    [anon_sym_noreturn] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_constinit] = ACTIONS(2292),
    [anon_sym_consteval] = ACTIONS(2292),
    [anon_sym___shared__] = ACTIONS(2292),
    [anon_sym___local__] = ACTIONS(2292),
    [anon_sym___constant__] = ACTIONS(2292),
    [anon_sym___managed__] = ACTIONS(2292),
    [anon_sym___grid_constant__] = ACTIONS(2292),
    [anon_sym_alignas] = ACTIONS(2292),
    [anon_sym__Alignas] = ACTIONS(2292),
    [sym_primitive_type] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_struct] = ACTIONS(2292),
    [anon_sym_union] = ACTIONS(2292),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2292),
    [anon_sym_decltype] = ACTIONS(2292),
    [sym_virtual] = ACTIONS(2292),
    [anon_sym_explicit] = ACTIONS(2292),
    [anon_sym_typename] = ACTIONS(2292),
    [anon_sym_template] = ACTIONS(2292),
    [anon_sym_operator] = ACTIONS(2292),
    [anon_sym_friend] = ACTIONS(2292),
    [anon_sym_public] = ACTIONS(2292),
    [anon_sym_private] = ACTIONS(2292),
    [anon_sym_protected] = ACTIONS(2292),
    [anon_sym_using] = ACTIONS(2292),
    [anon_sym_static_assert] = ACTIONS(2292),
    [anon_sym___launch_bounds__] = ACTIONS(2292),
  },
  [1939] = {
    [sym_identifier] = ACTIONS(2296),
    [aux_sym_preproc_def_token1] = ACTIONS(2296),
    [aux_sym_preproc_if_token1] = ACTIONS(2296),
    [aux_sym_preproc_if_token2] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2296),
    [sym_preproc_directive] = ACTIONS(2296),
    [anon_sym_LPAREN2] = ACTIONS(2298),
    [anon_sym_TILDE] = ACTIONS(2298),
    [anon_sym_STAR] = ACTIONS(2298),
    [anon_sym_AMP_AMP] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym___extension__] = ACTIONS(2296),
    [anon_sym_typedef] = ACTIONS(2296),
    [anon_sym___device__] = ACTIONS(2296),
    [anon_sym___host__] = ACTIONS(2296),
    [anon_sym___global__] = ACTIONS(2296),
    [anon_sym___forceinline__] = ACTIONS(2296),
    [anon_sym___noinline__] = ACTIONS(2296),
    [anon_sym_extern] = ACTIONS(2296),
    [anon_sym___attribute__] = ACTIONS(2296),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2298),
    [anon_sym___declspec] = ACTIONS(2296),
    [anon_sym___based] = ACTIONS(2296),
    [anon_sym_signed] = ACTIONS(2296),
    [anon_sym_unsigned] = ACTIONS(2296),
    [anon_sym_long] = ACTIONS(2296),
    [anon_sym_short] = ACTIONS(2296),
    [anon_sym_LBRACK] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_register] = ACTIONS(2296),
    [anon_sym_inline] = ACTIONS(2296),
    [anon_sym___inline] = ACTIONS(2296),
    [anon_sym___inline__] = ACTIONS(2296),
    [anon_sym___forceinline] = ACTIONS(2296),
    [anon_sym_thread_local] = ACTIONS(2296),
    [anon_sym___thread] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_constexpr] = ACTIONS(2296),
    [anon_sym_volatile] = ACTIONS(2296),
    [anon_sym_restrict] = ACTIONS(2296),
    [anon_sym___restrict__] = ACTIONS(2296),
    [anon_sym__Atomic] = ACTIONS(2296),
    [anon_sym__Noreturn] = ACTIONS(2296),
    [anon_sym_noreturn] = ACTIONS(2296),
    [anon_sym_mutable] = ACTIONS(2296),
    [anon_sym_constinit] = ACTIONS(2296),
    [anon_sym_consteval] = ACTIONS(2296),
    [anon_sym___shared__] = ACTIONS(2296),
    [anon_sym___local__] = ACTIONS(2296),
    [anon_sym___constant__] = ACTIONS(2296),
    [anon_sym___managed__] = ACTIONS(2296),
    [anon_sym___grid_constant__] = ACTIONS(2296),
    [anon_sym_alignas] = ACTIONS(2296),
    [anon_sym__Alignas] = ACTIONS(2296),
    [sym_primitive_type] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2296),
    [anon_sym_class] = ACTIONS(2296),
    [anon_sym_struct] = ACTIONS(2296),
    [anon_sym_union] = ACTIONS(2296),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2296),
    [anon_sym_decltype] = ACTIONS(2296),
    [sym_virtual] = ACTIONS(2296),
    [anon_sym_explicit] = ACTIONS(2296),
    [anon_sym_typename] = ACTIONS(2296),
    [anon_sym_template] = ACTIONS(2296),
    [anon_sym_operator] = ACTIONS(2296),
    [anon_sym_friend] = ACTIONS(2296),
    [anon_sym_public] = ACTIONS(2296),
    [anon_sym_private] = ACTIONS(2296),
    [anon_sym_protected] = ACTIONS(2296),
    [anon_sym_using] = ACTIONS(2296),
    [anon_sym_static_assert] = ACTIONS(2296),
    [anon_sym___launch_bounds__] = ACTIONS(2296),
  },
  [1940] = {
    [sym_identifier] = ACTIONS(5242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5244),
    [anon_sym_COMMA] = ACTIONS(5244),
    [anon_sym_RPAREN] = ACTIONS(5244),
    [anon_sym_LPAREN2] = ACTIONS(5244),
    [anon_sym_DASH] = ACTIONS(5242),
    [anon_sym_PLUS] = ACTIONS(5242),
    [anon_sym_STAR] = ACTIONS(5244),
    [anon_sym_SLASH] = ACTIONS(5242),
    [anon_sym_PERCENT] = ACTIONS(5244),
    [anon_sym_PIPE_PIPE] = ACTIONS(5244),
    [anon_sym_AMP_AMP] = ACTIONS(5244),
    [anon_sym_PIPE] = ACTIONS(5242),
    [anon_sym_CARET] = ACTIONS(5244),
    [anon_sym_AMP] = ACTIONS(5242),
    [anon_sym_EQ_EQ] = ACTIONS(5244),
    [anon_sym_BANG_EQ] = ACTIONS(5244),
    [anon_sym_GT] = ACTIONS(5242),
    [anon_sym_GT_EQ] = ACTIONS(5244),
    [anon_sym_LT_EQ] = ACTIONS(5242),
    [anon_sym_LT] = ACTIONS(5242),
    [anon_sym_LT_LT] = ACTIONS(5242),
    [anon_sym_GT_GT] = ACTIONS(5244),
    [anon_sym_SEMI] = ACTIONS(5244),
    [anon_sym___extension__] = ACTIONS(5242),
    [anon_sym___global__] = ACTIONS(5242),
    [anon_sym___attribute__] = ACTIONS(5242),
    [anon_sym___based] = ACTIONS(5242),
    [anon_sym_LBRACE] = ACTIONS(5244),
    [anon_sym_RBRACE] = ACTIONS(5244),
    [anon_sym_signed] = ACTIONS(5242),
    [anon_sym_unsigned] = ACTIONS(5242),
    [anon_sym_long] = ACTIONS(5242),
    [anon_sym_short] = ACTIONS(5242),
    [anon_sym_LBRACK] = ACTIONS(5244),
    [anon_sym_RBRACK] = ACTIONS(5244),
    [anon_sym_const] = ACTIONS(5242),
    [anon_sym_constexpr] = ACTIONS(5242),
    [anon_sym_volatile] = ACTIONS(5242),
    [anon_sym_restrict] = ACTIONS(5242),
    [anon_sym___restrict__] = ACTIONS(5242),
    [anon_sym__Atomic] = ACTIONS(5242),
    [anon_sym__Noreturn] = ACTIONS(5242),
    [anon_sym_noreturn] = ACTIONS(5242),
    [anon_sym_mutable] = ACTIONS(5242),
    [anon_sym_constinit] = ACTIONS(5242),
    [anon_sym_consteval] = ACTIONS(5242),
    [anon_sym___shared__] = ACTIONS(5242),
    [anon_sym___local__] = ACTIONS(5242),
    [anon_sym___constant__] = ACTIONS(5242),
    [anon_sym___managed__] = ACTIONS(5242),
    [anon_sym___grid_constant__] = ACTIONS(5242),
    [anon_sym_alignas] = ACTIONS(5242),
    [anon_sym__Alignas] = ACTIONS(5242),
    [sym_primitive_type] = ACTIONS(5242),
    [anon_sym_COLON] = ACTIONS(5244),
    [anon_sym_QMARK] = ACTIONS(5244),
    [anon_sym_LT_EQ_GT] = ACTIONS(5244),
    [anon_sym_or] = ACTIONS(5242),
    [anon_sym_and] = ACTIONS(5242),
    [anon_sym_bitor] = ACTIONS(5242),
    [anon_sym_xor] = ACTIONS(5242),
    [anon_sym_bitand] = ACTIONS(5242),
    [anon_sym_not_eq] = ACTIONS(5242),
    [anon_sym_DASH_DASH] = ACTIONS(5244),
    [anon_sym_PLUS_PLUS] = ACTIONS(5244),
    [anon_sym_DOT] = ACTIONS(5242),
    [anon_sym_DOT_STAR] = ACTIONS(5244),
    [anon_sym_DASH_GT] = ACTIONS(5244),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5242),
    [anon_sym_decltype] = ACTIONS(5242),
    [anon_sym_final] = ACTIONS(5242),
    [anon_sym_override] = ACTIONS(5242),
    [anon_sym_requires] = ACTIONS(5242),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5244),
  },
  [1941] = {
    [sym_identifier] = ACTIONS(2457),
    [aux_sym_preproc_def_token1] = ACTIONS(2457),
    [aux_sym_preproc_if_token1] = ACTIONS(2457),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2457),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2457),
    [sym_preproc_directive] = ACTIONS(2457),
    [anon_sym_LPAREN2] = ACTIONS(2459),
    [anon_sym_TILDE] = ACTIONS(2459),
    [anon_sym_STAR] = ACTIONS(2459),
    [anon_sym_AMP_AMP] = ACTIONS(2459),
    [anon_sym_AMP] = ACTIONS(2457),
    [anon_sym___extension__] = ACTIONS(2457),
    [anon_sym_typedef] = ACTIONS(2457),
    [anon_sym___device__] = ACTIONS(2457),
    [anon_sym___host__] = ACTIONS(2457),
    [anon_sym___global__] = ACTIONS(2457),
    [anon_sym___forceinline__] = ACTIONS(2457),
    [anon_sym___noinline__] = ACTIONS(2457),
    [anon_sym_extern] = ACTIONS(2457),
    [anon_sym___attribute__] = ACTIONS(2457),
    [anon_sym_COLON_COLON] = ACTIONS(2459),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2459),
    [anon_sym___declspec] = ACTIONS(2457),
    [anon_sym___based] = ACTIONS(2457),
    [anon_sym_RBRACE] = ACTIONS(2459),
    [anon_sym_signed] = ACTIONS(2457),
    [anon_sym_unsigned] = ACTIONS(2457),
    [anon_sym_long] = ACTIONS(2457),
    [anon_sym_short] = ACTIONS(2457),
    [anon_sym_LBRACK] = ACTIONS(2457),
    [anon_sym_static] = ACTIONS(2457),
    [anon_sym_register] = ACTIONS(2457),
    [anon_sym_inline] = ACTIONS(2457),
    [anon_sym___inline] = ACTIONS(2457),
    [anon_sym___inline__] = ACTIONS(2457),
    [anon_sym___forceinline] = ACTIONS(2457),
    [anon_sym_thread_local] = ACTIONS(2457),
    [anon_sym___thread] = ACTIONS(2457),
    [anon_sym_const] = ACTIONS(2457),
    [anon_sym_constexpr] = ACTIONS(2457),
    [anon_sym_volatile] = ACTIONS(2457),
    [anon_sym_restrict] = ACTIONS(2457),
    [anon_sym___restrict__] = ACTIONS(2457),
    [anon_sym__Atomic] = ACTIONS(2457),
    [anon_sym__Noreturn] = ACTIONS(2457),
    [anon_sym_noreturn] = ACTIONS(2457),
    [anon_sym_mutable] = ACTIONS(2457),
    [anon_sym_constinit] = ACTIONS(2457),
    [anon_sym_consteval] = ACTIONS(2457),
    [anon_sym___shared__] = ACTIONS(2457),
    [anon_sym___local__] = ACTIONS(2457),
    [anon_sym___constant__] = ACTIONS(2457),
    [anon_sym___managed__] = ACTIONS(2457),
    [anon_sym___grid_constant__] = ACTIONS(2457),
    [anon_sym_alignas] = ACTIONS(2457),
    [anon_sym__Alignas] = ACTIONS(2457),
    [sym_primitive_type] = ACTIONS(2457),
    [anon_sym_enum] = ACTIONS(2457),
    [anon_sym_class] = ACTIONS(2457),
    [anon_sym_struct] = ACTIONS(2457),
    [anon_sym_union] = ACTIONS(2457),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2457),
    [anon_sym_decltype] = ACTIONS(2457),
    [sym_virtual] = ACTIONS(2457),
    [anon_sym_explicit] = ACTIONS(2457),
    [anon_sym_typename] = ACTIONS(2457),
    [anon_sym_template] = ACTIONS(2457),
    [anon_sym_operator] = ACTIONS(2457),
    [anon_sym_friend] = ACTIONS(2457),
    [anon_sym_public] = ACTIONS(2457),
    [anon_sym_private] = ACTIONS(2457),
    [anon_sym_protected] = ACTIONS(2457),
    [anon_sym_using] = ACTIONS(2457),
    [anon_sym_static_assert] = ACTIONS(2457),
    [anon_sym___launch_bounds__] = ACTIONS(2457),
  },
  [1942] = {
    [sym_identifier] = ACTIONS(5246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5248),
    [anon_sym_COMMA] = ACTIONS(5248),
    [anon_sym_RPAREN] = ACTIONS(5248),
    [anon_sym_LPAREN2] = ACTIONS(5248),
    [anon_sym_DASH] = ACTIONS(5246),
    [anon_sym_PLUS] = ACTIONS(5246),
    [anon_sym_STAR] = ACTIONS(5248),
    [anon_sym_SLASH] = ACTIONS(5246),
    [anon_sym_PERCENT] = ACTIONS(5248),
    [anon_sym_PIPE_PIPE] = ACTIONS(5248),
    [anon_sym_AMP_AMP] = ACTIONS(5248),
    [anon_sym_PIPE] = ACTIONS(5246),
    [anon_sym_CARET] = ACTIONS(5248),
    [anon_sym_AMP] = ACTIONS(5246),
    [anon_sym_EQ_EQ] = ACTIONS(5248),
    [anon_sym_BANG_EQ] = ACTIONS(5248),
    [anon_sym_GT] = ACTIONS(5246),
    [anon_sym_GT_EQ] = ACTIONS(5248),
    [anon_sym_LT_EQ] = ACTIONS(5246),
    [anon_sym_LT] = ACTIONS(5246),
    [anon_sym_LT_LT] = ACTIONS(5246),
    [anon_sym_GT_GT] = ACTIONS(5248),
    [anon_sym_SEMI] = ACTIONS(5248),
    [anon_sym___extension__] = ACTIONS(5246),
    [anon_sym___global__] = ACTIONS(5246),
    [anon_sym___attribute__] = ACTIONS(5246),
    [anon_sym___based] = ACTIONS(5246),
    [anon_sym_LBRACE] = ACTIONS(5248),
    [anon_sym_RBRACE] = ACTIONS(5248),
    [anon_sym_signed] = ACTIONS(5246),
    [anon_sym_unsigned] = ACTIONS(5246),
    [anon_sym_long] = ACTIONS(5246),
    [anon_sym_short] = ACTIONS(5246),
    [anon_sym_LBRACK] = ACTIONS(5248),
    [anon_sym_RBRACK] = ACTIONS(5248),
    [anon_sym_const] = ACTIONS(5246),
    [anon_sym_constexpr] = ACTIONS(5246),
    [anon_sym_volatile] = ACTIONS(5246),
    [anon_sym_restrict] = ACTIONS(5246),
    [anon_sym___restrict__] = ACTIONS(5246),
    [anon_sym__Atomic] = ACTIONS(5246),
    [anon_sym__Noreturn] = ACTIONS(5246),
    [anon_sym_noreturn] = ACTIONS(5246),
    [anon_sym_mutable] = ACTIONS(5246),
    [anon_sym_constinit] = ACTIONS(5246),
    [anon_sym_consteval] = ACTIONS(5246),
    [anon_sym___shared__] = ACTIONS(5246),
    [anon_sym___local__] = ACTIONS(5246),
    [anon_sym___constant__] = ACTIONS(5246),
    [anon_sym___managed__] = ACTIONS(5246),
    [anon_sym___grid_constant__] = ACTIONS(5246),
    [anon_sym_alignas] = ACTIONS(5246),
    [anon_sym__Alignas] = ACTIONS(5246),
    [sym_primitive_type] = ACTIONS(5246),
    [anon_sym_COLON] = ACTIONS(5248),
    [anon_sym_QMARK] = ACTIONS(5248),
    [anon_sym_LT_EQ_GT] = ACTIONS(5248),
    [anon_sym_or] = ACTIONS(5246),
    [anon_sym_and] = ACTIONS(5246),
    [anon_sym_bitor] = ACTIONS(5246),
    [anon_sym_xor] = ACTIONS(5246),
    [anon_sym_bitand] = ACTIONS(5246),
    [anon_sym_not_eq] = ACTIONS(5246),
    [anon_sym_DASH_DASH] = ACTIONS(5248),
    [anon_sym_PLUS_PLUS] = ACTIONS(5248),
    [anon_sym_DOT] = ACTIONS(5246),
    [anon_sym_DOT_STAR] = ACTIONS(5248),
    [anon_sym_DASH_GT] = ACTIONS(5248),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5246),
    [anon_sym_decltype] = ACTIONS(5246),
    [anon_sym_final] = ACTIONS(5246),
    [anon_sym_override] = ACTIONS(5246),
    [anon_sym_requires] = ACTIONS(5246),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5248),
  },
  [1943] = {
    [sym_identifier] = ACTIONS(2300),
    [aux_sym_preproc_def_token1] = ACTIONS(2300),
    [aux_sym_preproc_if_token1] = ACTIONS(2300),
    [aux_sym_preproc_if_token2] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2300),
    [sym_preproc_directive] = ACTIONS(2300),
    [anon_sym_LPAREN2] = ACTIONS(2302),
    [anon_sym_TILDE] = ACTIONS(2302),
    [anon_sym_STAR] = ACTIONS(2302),
    [anon_sym_AMP_AMP] = ACTIONS(2302),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym___extension__] = ACTIONS(2300),
    [anon_sym_typedef] = ACTIONS(2300),
    [anon_sym___device__] = ACTIONS(2300),
    [anon_sym___host__] = ACTIONS(2300),
    [anon_sym___global__] = ACTIONS(2300),
    [anon_sym___forceinline__] = ACTIONS(2300),
    [anon_sym___noinline__] = ACTIONS(2300),
    [anon_sym_extern] = ACTIONS(2300),
    [anon_sym___attribute__] = ACTIONS(2300),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2302),
    [anon_sym___declspec] = ACTIONS(2300),
    [anon_sym___based] = ACTIONS(2300),
    [anon_sym_signed] = ACTIONS(2300),
    [anon_sym_unsigned] = ACTIONS(2300),
    [anon_sym_long] = ACTIONS(2300),
    [anon_sym_short] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_register] = ACTIONS(2300),
    [anon_sym_inline] = ACTIONS(2300),
    [anon_sym___inline] = ACTIONS(2300),
    [anon_sym___inline__] = ACTIONS(2300),
    [anon_sym___forceinline] = ACTIONS(2300),
    [anon_sym_thread_local] = ACTIONS(2300),
    [anon_sym___thread] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_constexpr] = ACTIONS(2300),
    [anon_sym_volatile] = ACTIONS(2300),
    [anon_sym_restrict] = ACTIONS(2300),
    [anon_sym___restrict__] = ACTIONS(2300),
    [anon_sym__Atomic] = ACTIONS(2300),
    [anon_sym__Noreturn] = ACTIONS(2300),
    [anon_sym_noreturn] = ACTIONS(2300),
    [anon_sym_mutable] = ACTIONS(2300),
    [anon_sym_constinit] = ACTIONS(2300),
    [anon_sym_consteval] = ACTIONS(2300),
    [anon_sym___shared__] = ACTIONS(2300),
    [anon_sym___local__] = ACTIONS(2300),
    [anon_sym___constant__] = ACTIONS(2300),
    [anon_sym___managed__] = ACTIONS(2300),
    [anon_sym___grid_constant__] = ACTIONS(2300),
    [anon_sym_alignas] = ACTIONS(2300),
    [anon_sym__Alignas] = ACTIONS(2300),
    [sym_primitive_type] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_struct] = ACTIONS(2300),
    [anon_sym_union] = ACTIONS(2300),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2300),
    [anon_sym_decltype] = ACTIONS(2300),
    [sym_virtual] = ACTIONS(2300),
    [anon_sym_explicit] = ACTIONS(2300),
    [anon_sym_typename] = ACTIONS(2300),
    [anon_sym_template] = ACTIONS(2300),
    [anon_sym_operator] = ACTIONS(2300),
    [anon_sym_friend] = ACTIONS(2300),
    [anon_sym_public] = ACTIONS(2300),
    [anon_sym_private] = ACTIONS(2300),
    [anon_sym_protected] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_static_assert] = ACTIONS(2300),
    [anon_sym___launch_bounds__] = ACTIONS(2300),
  },
  [1944] = {
    [sym_identifier] = ACTIONS(5250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5252),
    [anon_sym_COMMA] = ACTIONS(5252),
    [anon_sym_RPAREN] = ACTIONS(5252),
    [anon_sym_LPAREN2] = ACTIONS(5252),
    [anon_sym_DASH] = ACTIONS(5250),
    [anon_sym_PLUS] = ACTIONS(5250),
    [anon_sym_STAR] = ACTIONS(5252),
    [anon_sym_SLASH] = ACTIONS(5250),
    [anon_sym_PERCENT] = ACTIONS(5252),
    [anon_sym_PIPE_PIPE] = ACTIONS(5252),
    [anon_sym_AMP_AMP] = ACTIONS(5252),
    [anon_sym_PIPE] = ACTIONS(5250),
    [anon_sym_CARET] = ACTIONS(5252),
    [anon_sym_AMP] = ACTIONS(5250),
    [anon_sym_EQ_EQ] = ACTIONS(5252),
    [anon_sym_BANG_EQ] = ACTIONS(5252),
    [anon_sym_GT] = ACTIONS(5250),
    [anon_sym_GT_EQ] = ACTIONS(5252),
    [anon_sym_LT_EQ] = ACTIONS(5250),
    [anon_sym_LT] = ACTIONS(5250),
    [anon_sym_LT_LT] = ACTIONS(5250),
    [anon_sym_GT_GT] = ACTIONS(5252),
    [anon_sym_SEMI] = ACTIONS(5252),
    [anon_sym___extension__] = ACTIONS(5250),
    [anon_sym___global__] = ACTIONS(5250),
    [anon_sym___attribute__] = ACTIONS(5250),
    [anon_sym___based] = ACTIONS(5250),
    [anon_sym_LBRACE] = ACTIONS(5252),
    [anon_sym_RBRACE] = ACTIONS(5252),
    [anon_sym_signed] = ACTIONS(5250),
    [anon_sym_unsigned] = ACTIONS(5250),
    [anon_sym_long] = ACTIONS(5250),
    [anon_sym_short] = ACTIONS(5250),
    [anon_sym_LBRACK] = ACTIONS(5252),
    [anon_sym_RBRACK] = ACTIONS(5252),
    [anon_sym_const] = ACTIONS(5250),
    [anon_sym_constexpr] = ACTIONS(5250),
    [anon_sym_volatile] = ACTIONS(5250),
    [anon_sym_restrict] = ACTIONS(5250),
    [anon_sym___restrict__] = ACTIONS(5250),
    [anon_sym__Atomic] = ACTIONS(5250),
    [anon_sym__Noreturn] = ACTIONS(5250),
    [anon_sym_noreturn] = ACTIONS(5250),
    [anon_sym_mutable] = ACTIONS(5250),
    [anon_sym_constinit] = ACTIONS(5250),
    [anon_sym_consteval] = ACTIONS(5250),
    [anon_sym___shared__] = ACTIONS(5250),
    [anon_sym___local__] = ACTIONS(5250),
    [anon_sym___constant__] = ACTIONS(5250),
    [anon_sym___managed__] = ACTIONS(5250),
    [anon_sym___grid_constant__] = ACTIONS(5250),
    [anon_sym_alignas] = ACTIONS(5250),
    [anon_sym__Alignas] = ACTIONS(5250),
    [sym_primitive_type] = ACTIONS(5250),
    [anon_sym_COLON] = ACTIONS(5252),
    [anon_sym_QMARK] = ACTIONS(5252),
    [anon_sym_LT_EQ_GT] = ACTIONS(5252),
    [anon_sym_or] = ACTIONS(5250),
    [anon_sym_and] = ACTIONS(5250),
    [anon_sym_bitor] = ACTIONS(5250),
    [anon_sym_xor] = ACTIONS(5250),
    [anon_sym_bitand] = ACTIONS(5250),
    [anon_sym_not_eq] = ACTIONS(5250),
    [anon_sym_DASH_DASH] = ACTIONS(5252),
    [anon_sym_PLUS_PLUS] = ACTIONS(5252),
    [anon_sym_DOT] = ACTIONS(5250),
    [anon_sym_DOT_STAR] = ACTIONS(5252),
    [anon_sym_DASH_GT] = ACTIONS(5252),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5250),
    [anon_sym_decltype] = ACTIONS(5250),
    [anon_sym_final] = ACTIONS(5250),
    [anon_sym_override] = ACTIONS(5250),
    [anon_sym_requires] = ACTIONS(5250),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5252),
  },
  [1945] = {
    [sym_identifier] = ACTIONS(5254),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5256),
    [anon_sym_COMMA] = ACTIONS(5256),
    [anon_sym_RPAREN] = ACTIONS(5256),
    [anon_sym_LPAREN2] = ACTIONS(5256),
    [anon_sym_DASH] = ACTIONS(5254),
    [anon_sym_PLUS] = ACTIONS(5254),
    [anon_sym_STAR] = ACTIONS(5256),
    [anon_sym_SLASH] = ACTIONS(5254),
    [anon_sym_PERCENT] = ACTIONS(5256),
    [anon_sym_PIPE_PIPE] = ACTIONS(5256),
    [anon_sym_AMP_AMP] = ACTIONS(5256),
    [anon_sym_PIPE] = ACTIONS(5254),
    [anon_sym_CARET] = ACTIONS(5256),
    [anon_sym_AMP] = ACTIONS(5254),
    [anon_sym_EQ_EQ] = ACTIONS(5256),
    [anon_sym_BANG_EQ] = ACTIONS(5256),
    [anon_sym_GT] = ACTIONS(5254),
    [anon_sym_GT_EQ] = ACTIONS(5256),
    [anon_sym_LT_EQ] = ACTIONS(5254),
    [anon_sym_LT] = ACTIONS(5254),
    [anon_sym_LT_LT] = ACTIONS(5254),
    [anon_sym_GT_GT] = ACTIONS(5256),
    [anon_sym_SEMI] = ACTIONS(5256),
    [anon_sym___extension__] = ACTIONS(5254),
    [anon_sym___global__] = ACTIONS(5254),
    [anon_sym___attribute__] = ACTIONS(5254),
    [anon_sym___based] = ACTIONS(5254),
    [anon_sym_LBRACE] = ACTIONS(5256),
    [anon_sym_RBRACE] = ACTIONS(5256),
    [anon_sym_signed] = ACTIONS(5254),
    [anon_sym_unsigned] = ACTIONS(5254),
    [anon_sym_long] = ACTIONS(5254),
    [anon_sym_short] = ACTIONS(5254),
    [anon_sym_LBRACK] = ACTIONS(5256),
    [anon_sym_RBRACK] = ACTIONS(5256),
    [anon_sym_const] = ACTIONS(5254),
    [anon_sym_constexpr] = ACTIONS(5254),
    [anon_sym_volatile] = ACTIONS(5254),
    [anon_sym_restrict] = ACTIONS(5254),
    [anon_sym___restrict__] = ACTIONS(5254),
    [anon_sym__Atomic] = ACTIONS(5254),
    [anon_sym__Noreturn] = ACTIONS(5254),
    [anon_sym_noreturn] = ACTIONS(5254),
    [anon_sym_mutable] = ACTIONS(5254),
    [anon_sym_constinit] = ACTIONS(5254),
    [anon_sym_consteval] = ACTIONS(5254),
    [anon_sym___shared__] = ACTIONS(5254),
    [anon_sym___local__] = ACTIONS(5254),
    [anon_sym___constant__] = ACTIONS(5254),
    [anon_sym___managed__] = ACTIONS(5254),
    [anon_sym___grid_constant__] = ACTIONS(5254),
    [anon_sym_alignas] = ACTIONS(5254),
    [anon_sym__Alignas] = ACTIONS(5254),
    [sym_primitive_type] = ACTIONS(5254),
    [anon_sym_COLON] = ACTIONS(5256),
    [anon_sym_QMARK] = ACTIONS(5256),
    [anon_sym_LT_EQ_GT] = ACTIONS(5256),
    [anon_sym_or] = ACTIONS(5254),
    [anon_sym_and] = ACTIONS(5254),
    [anon_sym_bitor] = ACTIONS(5254),
    [anon_sym_xor] = ACTIONS(5254),
    [anon_sym_bitand] = ACTIONS(5254),
    [anon_sym_not_eq] = ACTIONS(5254),
    [anon_sym_DASH_DASH] = ACTIONS(5256),
    [anon_sym_PLUS_PLUS] = ACTIONS(5256),
    [anon_sym_DOT] = ACTIONS(5254),
    [anon_sym_DOT_STAR] = ACTIONS(5256),
    [anon_sym_DASH_GT] = ACTIONS(5256),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5254),
    [anon_sym_decltype] = ACTIONS(5254),
    [anon_sym_final] = ACTIONS(5254),
    [anon_sym_override] = ACTIONS(5254),
    [anon_sym_requires] = ACTIONS(5254),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5256),
  },
  [1946] = {
    [sym_identifier] = ACTIONS(2304),
    [aux_sym_preproc_def_token1] = ACTIONS(2304),
    [aux_sym_preproc_if_token1] = ACTIONS(2304),
    [aux_sym_preproc_if_token2] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2304),
    [sym_preproc_directive] = ACTIONS(2304),
    [anon_sym_LPAREN2] = ACTIONS(2306),
    [anon_sym_TILDE] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym___extension__] = ACTIONS(2304),
    [anon_sym_typedef] = ACTIONS(2304),
    [anon_sym___device__] = ACTIONS(2304),
    [anon_sym___host__] = ACTIONS(2304),
    [anon_sym___global__] = ACTIONS(2304),
    [anon_sym___forceinline__] = ACTIONS(2304),
    [anon_sym___noinline__] = ACTIONS(2304),
    [anon_sym_extern] = ACTIONS(2304),
    [anon_sym___attribute__] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2306),
    [anon_sym___declspec] = ACTIONS(2304),
    [anon_sym___based] = ACTIONS(2304),
    [anon_sym_signed] = ACTIONS(2304),
    [anon_sym_unsigned] = ACTIONS(2304),
    [anon_sym_long] = ACTIONS(2304),
    [anon_sym_short] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_register] = ACTIONS(2304),
    [anon_sym_inline] = ACTIONS(2304),
    [anon_sym___inline] = ACTIONS(2304),
    [anon_sym___inline__] = ACTIONS(2304),
    [anon_sym___forceinline] = ACTIONS(2304),
    [anon_sym_thread_local] = ACTIONS(2304),
    [anon_sym___thread] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_constexpr] = ACTIONS(2304),
    [anon_sym_volatile] = ACTIONS(2304),
    [anon_sym_restrict] = ACTIONS(2304),
    [anon_sym___restrict__] = ACTIONS(2304),
    [anon_sym__Atomic] = ACTIONS(2304),
    [anon_sym__Noreturn] = ACTIONS(2304),
    [anon_sym_noreturn] = ACTIONS(2304),
    [anon_sym_mutable] = ACTIONS(2304),
    [anon_sym_constinit] = ACTIONS(2304),
    [anon_sym_consteval] = ACTIONS(2304),
    [anon_sym___shared__] = ACTIONS(2304),
    [anon_sym___local__] = ACTIONS(2304),
    [anon_sym___constant__] = ACTIONS(2304),
    [anon_sym___managed__] = ACTIONS(2304),
    [anon_sym___grid_constant__] = ACTIONS(2304),
    [anon_sym_alignas] = ACTIONS(2304),
    [anon_sym__Alignas] = ACTIONS(2304),
    [sym_primitive_type] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_struct] = ACTIONS(2304),
    [anon_sym_union] = ACTIONS(2304),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2304),
    [anon_sym_decltype] = ACTIONS(2304),
    [sym_virtual] = ACTIONS(2304),
    [anon_sym_explicit] = ACTIONS(2304),
    [anon_sym_typename] = ACTIONS(2304),
    [anon_sym_template] = ACTIONS(2304),
    [anon_sym_operator] = ACTIONS(2304),
    [anon_sym_friend] = ACTIONS(2304),
    [anon_sym_public] = ACTIONS(2304),
    [anon_sym_private] = ACTIONS(2304),
    [anon_sym_protected] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_static_assert] = ACTIONS(2304),
    [anon_sym___launch_bounds__] = ACTIONS(2304),
  },
  [1947] = {
    [sym_identifier] = ACTIONS(2056),
    [aux_sym_preproc_def_token1] = ACTIONS(2056),
    [aux_sym_preproc_if_token1] = ACTIONS(2056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2056),
    [sym_preproc_directive] = ACTIONS(2056),
    [anon_sym_LPAREN2] = ACTIONS(2058),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_STAR] = ACTIONS(2058),
    [anon_sym_AMP_AMP] = ACTIONS(2058),
    [anon_sym_AMP] = ACTIONS(2056),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_typedef] = ACTIONS(2056),
    [anon_sym___device__] = ACTIONS(2056),
    [anon_sym___host__] = ACTIONS(2056),
    [anon_sym___global__] = ACTIONS(2056),
    [anon_sym___forceinline__] = ACTIONS(2056),
    [anon_sym___noinline__] = ACTIONS(2056),
    [anon_sym_extern] = ACTIONS(2056),
    [anon_sym___attribute__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2058),
    [anon_sym___declspec] = ACTIONS(2056),
    [anon_sym___based] = ACTIONS(2056),
    [anon_sym_RBRACE] = ACTIONS(2058),
    [anon_sym_signed] = ACTIONS(2056),
    [anon_sym_unsigned] = ACTIONS(2056),
    [anon_sym_long] = ACTIONS(2056),
    [anon_sym_short] = ACTIONS(2056),
    [anon_sym_LBRACK] = ACTIONS(2056),
    [anon_sym_static] = ACTIONS(2056),
    [anon_sym_register] = ACTIONS(2056),
    [anon_sym_inline] = ACTIONS(2056),
    [anon_sym___inline] = ACTIONS(2056),
    [anon_sym___inline__] = ACTIONS(2056),
    [anon_sym___forceinline] = ACTIONS(2056),
    [anon_sym_thread_local] = ACTIONS(2056),
    [anon_sym___thread] = ACTIONS(2056),
    [anon_sym_const] = ACTIONS(2056),
    [anon_sym_constexpr] = ACTIONS(2056),
    [anon_sym_volatile] = ACTIONS(2056),
    [anon_sym_restrict] = ACTIONS(2056),
    [anon_sym___restrict__] = ACTIONS(2056),
    [anon_sym__Atomic] = ACTIONS(2056),
    [anon_sym__Noreturn] = ACTIONS(2056),
    [anon_sym_noreturn] = ACTIONS(2056),
    [anon_sym_mutable] = ACTIONS(2056),
    [anon_sym_constinit] = ACTIONS(2056),
    [anon_sym_consteval] = ACTIONS(2056),
    [anon_sym___shared__] = ACTIONS(2056),
    [anon_sym___local__] = ACTIONS(2056),
    [anon_sym___constant__] = ACTIONS(2056),
    [anon_sym___managed__] = ACTIONS(2056),
    [anon_sym___grid_constant__] = ACTIONS(2056),
    [anon_sym_alignas] = ACTIONS(2056),
    [anon_sym__Alignas] = ACTIONS(2056),
    [sym_primitive_type] = ACTIONS(2056),
    [anon_sym_enum] = ACTIONS(2056),
    [anon_sym_class] = ACTIONS(2056),
    [anon_sym_struct] = ACTIONS(2056),
    [anon_sym_union] = ACTIONS(2056),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2056),
    [anon_sym_decltype] = ACTIONS(2056),
    [sym_virtual] = ACTIONS(2056),
    [anon_sym_explicit] = ACTIONS(2056),
    [anon_sym_typename] = ACTIONS(2056),
    [anon_sym_template] = ACTIONS(2056),
    [anon_sym_operator] = ACTIONS(2056),
    [anon_sym_friend] = ACTIONS(2056),
    [anon_sym_public] = ACTIONS(2056),
    [anon_sym_private] = ACTIONS(2056),
    [anon_sym_protected] = ACTIONS(2056),
    [anon_sym_using] = ACTIONS(2056),
    [anon_sym_static_assert] = ACTIONS(2056),
    [anon_sym___launch_bounds__] = ACTIONS(2056),
  },
  [1948] = {
    [sym_identifier] = ACTIONS(5246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5248),
    [anon_sym_COMMA] = ACTIONS(5248),
    [anon_sym_RPAREN] = ACTIONS(5248),
    [anon_sym_LPAREN2] = ACTIONS(5248),
    [anon_sym_DASH] = ACTIONS(5246),
    [anon_sym_PLUS] = ACTIONS(5246),
    [anon_sym_STAR] = ACTIONS(5248),
    [anon_sym_SLASH] = ACTIONS(5246),
    [anon_sym_PERCENT] = ACTIONS(5248),
    [anon_sym_PIPE_PIPE] = ACTIONS(5248),
    [anon_sym_AMP_AMP] = ACTIONS(5248),
    [anon_sym_PIPE] = ACTIONS(5246),
    [anon_sym_CARET] = ACTIONS(5248),
    [anon_sym_AMP] = ACTIONS(5246),
    [anon_sym_EQ_EQ] = ACTIONS(5248),
    [anon_sym_BANG_EQ] = ACTIONS(5248),
    [anon_sym_GT] = ACTIONS(5246),
    [anon_sym_GT_EQ] = ACTIONS(5248),
    [anon_sym_LT_EQ] = ACTIONS(5246),
    [anon_sym_LT] = ACTIONS(5246),
    [anon_sym_LT_LT] = ACTIONS(5246),
    [anon_sym_GT_GT] = ACTIONS(5248),
    [anon_sym_SEMI] = ACTIONS(5248),
    [anon_sym___extension__] = ACTIONS(5246),
    [anon_sym___global__] = ACTIONS(5246),
    [anon_sym___attribute__] = ACTIONS(5246),
    [anon_sym___based] = ACTIONS(5246),
    [anon_sym_LBRACE] = ACTIONS(5248),
    [anon_sym_RBRACE] = ACTIONS(5248),
    [anon_sym_signed] = ACTIONS(5246),
    [anon_sym_unsigned] = ACTIONS(5246),
    [anon_sym_long] = ACTIONS(5246),
    [anon_sym_short] = ACTIONS(5246),
    [anon_sym_LBRACK] = ACTIONS(5248),
    [anon_sym_RBRACK] = ACTIONS(5248),
    [anon_sym_const] = ACTIONS(5246),
    [anon_sym_constexpr] = ACTIONS(5246),
    [anon_sym_volatile] = ACTIONS(5246),
    [anon_sym_restrict] = ACTIONS(5246),
    [anon_sym___restrict__] = ACTIONS(5246),
    [anon_sym__Atomic] = ACTIONS(5246),
    [anon_sym__Noreturn] = ACTIONS(5246),
    [anon_sym_noreturn] = ACTIONS(5246),
    [anon_sym_mutable] = ACTIONS(5246),
    [anon_sym_constinit] = ACTIONS(5246),
    [anon_sym_consteval] = ACTIONS(5246),
    [anon_sym___shared__] = ACTIONS(5246),
    [anon_sym___local__] = ACTIONS(5246),
    [anon_sym___constant__] = ACTIONS(5246),
    [anon_sym___managed__] = ACTIONS(5246),
    [anon_sym___grid_constant__] = ACTIONS(5246),
    [anon_sym_alignas] = ACTIONS(5246),
    [anon_sym__Alignas] = ACTIONS(5246),
    [sym_primitive_type] = ACTIONS(5246),
    [anon_sym_COLON] = ACTIONS(5248),
    [anon_sym_QMARK] = ACTIONS(5248),
    [anon_sym_LT_EQ_GT] = ACTIONS(5248),
    [anon_sym_or] = ACTIONS(5246),
    [anon_sym_and] = ACTIONS(5246),
    [anon_sym_bitor] = ACTIONS(5246),
    [anon_sym_xor] = ACTIONS(5246),
    [anon_sym_bitand] = ACTIONS(5246),
    [anon_sym_not_eq] = ACTIONS(5246),
    [anon_sym_DASH_DASH] = ACTIONS(5248),
    [anon_sym_PLUS_PLUS] = ACTIONS(5248),
    [anon_sym_DOT] = ACTIONS(5246),
    [anon_sym_DOT_STAR] = ACTIONS(5248),
    [anon_sym_DASH_GT] = ACTIONS(5248),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5246),
    [anon_sym_decltype] = ACTIONS(5246),
    [anon_sym_final] = ACTIONS(5246),
    [anon_sym_override] = ACTIONS(5246),
    [anon_sym_requires] = ACTIONS(5246),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5248),
  },
  [1949] = {
    [sym_identifier] = ACTIONS(1980),
    [aux_sym_preproc_def_token1] = ACTIONS(1980),
    [aux_sym_preproc_if_token1] = ACTIONS(1980),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1980),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1980),
    [sym_preproc_directive] = ACTIONS(1980),
    [anon_sym_LPAREN2] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_AMP_AMP] = ACTIONS(1982),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym___extension__] = ACTIONS(1980),
    [anon_sym_typedef] = ACTIONS(1980),
    [anon_sym___device__] = ACTIONS(1980),
    [anon_sym___host__] = ACTIONS(1980),
    [anon_sym___global__] = ACTIONS(1980),
    [anon_sym___forceinline__] = ACTIONS(1980),
    [anon_sym___noinline__] = ACTIONS(1980),
    [anon_sym_extern] = ACTIONS(1980),
    [anon_sym___attribute__] = ACTIONS(1980),
    [anon_sym_COLON_COLON] = ACTIONS(1982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1982),
    [anon_sym___declspec] = ACTIONS(1980),
    [anon_sym___based] = ACTIONS(1980),
    [anon_sym_RBRACE] = ACTIONS(1982),
    [anon_sym_signed] = ACTIONS(1980),
    [anon_sym_unsigned] = ACTIONS(1980),
    [anon_sym_long] = ACTIONS(1980),
    [anon_sym_short] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_static] = ACTIONS(1980),
    [anon_sym_register] = ACTIONS(1980),
    [anon_sym_inline] = ACTIONS(1980),
    [anon_sym___inline] = ACTIONS(1980),
    [anon_sym___inline__] = ACTIONS(1980),
    [anon_sym___forceinline] = ACTIONS(1980),
    [anon_sym_thread_local] = ACTIONS(1980),
    [anon_sym___thread] = ACTIONS(1980),
    [anon_sym_const] = ACTIONS(1980),
    [anon_sym_constexpr] = ACTIONS(1980),
    [anon_sym_volatile] = ACTIONS(1980),
    [anon_sym_restrict] = ACTIONS(1980),
    [anon_sym___restrict__] = ACTIONS(1980),
    [anon_sym__Atomic] = ACTIONS(1980),
    [anon_sym__Noreturn] = ACTIONS(1980),
    [anon_sym_noreturn] = ACTIONS(1980),
    [anon_sym_mutable] = ACTIONS(1980),
    [anon_sym_constinit] = ACTIONS(1980),
    [anon_sym_consteval] = ACTIONS(1980),
    [anon_sym___shared__] = ACTIONS(1980),
    [anon_sym___local__] = ACTIONS(1980),
    [anon_sym___constant__] = ACTIONS(1980),
    [anon_sym___managed__] = ACTIONS(1980),
    [anon_sym___grid_constant__] = ACTIONS(1980),
    [anon_sym_alignas] = ACTIONS(1980),
    [anon_sym__Alignas] = ACTIONS(1980),
    [sym_primitive_type] = ACTIONS(1980),
    [anon_sym_enum] = ACTIONS(1980),
    [anon_sym_class] = ACTIONS(1980),
    [anon_sym_struct] = ACTIONS(1980),
    [anon_sym_union] = ACTIONS(1980),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1980),
    [anon_sym_decltype] = ACTIONS(1980),
    [sym_virtual] = ACTIONS(1980),
    [anon_sym_explicit] = ACTIONS(1980),
    [anon_sym_typename] = ACTIONS(1980),
    [anon_sym_template] = ACTIONS(1980),
    [anon_sym_operator] = ACTIONS(1980),
    [anon_sym_friend] = ACTIONS(1980),
    [anon_sym_public] = ACTIONS(1980),
    [anon_sym_private] = ACTIONS(1980),
    [anon_sym_protected] = ACTIONS(1980),
    [anon_sym_using] = ACTIONS(1980),
    [anon_sym_static_assert] = ACTIONS(1980),
    [anon_sym___launch_bounds__] = ACTIONS(1980),
  },
  [1950] = {
    [sym_identifier] = ACTIONS(1976),
    [aux_sym_preproc_def_token1] = ACTIONS(1976),
    [aux_sym_preproc_if_token1] = ACTIONS(1976),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1976),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1976),
    [sym_preproc_directive] = ACTIONS(1976),
    [anon_sym_LPAREN2] = ACTIONS(1978),
    [anon_sym_TILDE] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1978),
    [anon_sym_AMP_AMP] = ACTIONS(1978),
    [anon_sym_AMP] = ACTIONS(1976),
    [anon_sym___extension__] = ACTIONS(1976),
    [anon_sym_typedef] = ACTIONS(1976),
    [anon_sym___device__] = ACTIONS(1976),
    [anon_sym___host__] = ACTIONS(1976),
    [anon_sym___global__] = ACTIONS(1976),
    [anon_sym___forceinline__] = ACTIONS(1976),
    [anon_sym___noinline__] = ACTIONS(1976),
    [anon_sym_extern] = ACTIONS(1976),
    [anon_sym___attribute__] = ACTIONS(1976),
    [anon_sym_COLON_COLON] = ACTIONS(1978),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1978),
    [anon_sym___declspec] = ACTIONS(1976),
    [anon_sym___based] = ACTIONS(1976),
    [anon_sym_RBRACE] = ACTIONS(1978),
    [anon_sym_signed] = ACTIONS(1976),
    [anon_sym_unsigned] = ACTIONS(1976),
    [anon_sym_long] = ACTIONS(1976),
    [anon_sym_short] = ACTIONS(1976),
    [anon_sym_LBRACK] = ACTIONS(1976),
    [anon_sym_static] = ACTIONS(1976),
    [anon_sym_register] = ACTIONS(1976),
    [anon_sym_inline] = ACTIONS(1976),
    [anon_sym___inline] = ACTIONS(1976),
    [anon_sym___inline__] = ACTIONS(1976),
    [anon_sym___forceinline] = ACTIONS(1976),
    [anon_sym_thread_local] = ACTIONS(1976),
    [anon_sym___thread] = ACTIONS(1976),
    [anon_sym_const] = ACTIONS(1976),
    [anon_sym_constexpr] = ACTIONS(1976),
    [anon_sym_volatile] = ACTIONS(1976),
    [anon_sym_restrict] = ACTIONS(1976),
    [anon_sym___restrict__] = ACTIONS(1976),
    [anon_sym__Atomic] = ACTIONS(1976),
    [anon_sym__Noreturn] = ACTIONS(1976),
    [anon_sym_noreturn] = ACTIONS(1976),
    [anon_sym_mutable] = ACTIONS(1976),
    [anon_sym_constinit] = ACTIONS(1976),
    [anon_sym_consteval] = ACTIONS(1976),
    [anon_sym___shared__] = ACTIONS(1976),
    [anon_sym___local__] = ACTIONS(1976),
    [anon_sym___constant__] = ACTIONS(1976),
    [anon_sym___managed__] = ACTIONS(1976),
    [anon_sym___grid_constant__] = ACTIONS(1976),
    [anon_sym_alignas] = ACTIONS(1976),
    [anon_sym__Alignas] = ACTIONS(1976),
    [sym_primitive_type] = ACTIONS(1976),
    [anon_sym_enum] = ACTIONS(1976),
    [anon_sym_class] = ACTIONS(1976),
    [anon_sym_struct] = ACTIONS(1976),
    [anon_sym_union] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1976),
    [anon_sym_decltype] = ACTIONS(1976),
    [sym_virtual] = ACTIONS(1976),
    [anon_sym_explicit] = ACTIONS(1976),
    [anon_sym_typename] = ACTIONS(1976),
    [anon_sym_template] = ACTIONS(1976),
    [anon_sym_operator] = ACTIONS(1976),
    [anon_sym_friend] = ACTIONS(1976),
    [anon_sym_public] = ACTIONS(1976),
    [anon_sym_private] = ACTIONS(1976),
    [anon_sym_protected] = ACTIONS(1976),
    [anon_sym_using] = ACTIONS(1976),
    [anon_sym_static_assert] = ACTIONS(1976),
    [anon_sym___launch_bounds__] = ACTIONS(1976),
  },
  [1951] = {
    [sym_identifier] = ACTIONS(5246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5248),
    [anon_sym_COMMA] = ACTIONS(5248),
    [anon_sym_RPAREN] = ACTIONS(5248),
    [anon_sym_LPAREN2] = ACTIONS(5248),
    [anon_sym_DASH] = ACTIONS(5246),
    [anon_sym_PLUS] = ACTIONS(5246),
    [anon_sym_STAR] = ACTIONS(5248),
    [anon_sym_SLASH] = ACTIONS(5246),
    [anon_sym_PERCENT] = ACTIONS(5248),
    [anon_sym_PIPE_PIPE] = ACTIONS(5248),
    [anon_sym_AMP_AMP] = ACTIONS(5248),
    [anon_sym_PIPE] = ACTIONS(5246),
    [anon_sym_CARET] = ACTIONS(5248),
    [anon_sym_AMP] = ACTIONS(5246),
    [anon_sym_EQ_EQ] = ACTIONS(5248),
    [anon_sym_BANG_EQ] = ACTIONS(5248),
    [anon_sym_GT] = ACTIONS(5246),
    [anon_sym_GT_EQ] = ACTIONS(5248),
    [anon_sym_LT_EQ] = ACTIONS(5246),
    [anon_sym_LT] = ACTIONS(5246),
    [anon_sym_LT_LT] = ACTIONS(5246),
    [anon_sym_GT_GT] = ACTIONS(5248),
    [anon_sym_SEMI] = ACTIONS(5248),
    [anon_sym___extension__] = ACTIONS(5246),
    [anon_sym___global__] = ACTIONS(5246),
    [anon_sym___attribute__] = ACTIONS(5246),
    [anon_sym___based] = ACTIONS(5246),
    [anon_sym_LBRACE] = ACTIONS(5248),
    [anon_sym_RBRACE] = ACTIONS(5248),
    [anon_sym_signed] = ACTIONS(5246),
    [anon_sym_unsigned] = ACTIONS(5246),
    [anon_sym_long] = ACTIONS(5246),
    [anon_sym_short] = ACTIONS(5246),
    [anon_sym_LBRACK] = ACTIONS(5248),
    [anon_sym_RBRACK] = ACTIONS(5248),
    [anon_sym_const] = ACTIONS(5246),
    [anon_sym_constexpr] = ACTIONS(5246),
    [anon_sym_volatile] = ACTIONS(5246),
    [anon_sym_restrict] = ACTIONS(5246),
    [anon_sym___restrict__] = ACTIONS(5246),
    [anon_sym__Atomic] = ACTIONS(5246),
    [anon_sym__Noreturn] = ACTIONS(5246),
    [anon_sym_noreturn] = ACTIONS(5246),
    [anon_sym_mutable] = ACTIONS(5246),
    [anon_sym_constinit] = ACTIONS(5246),
    [anon_sym_consteval] = ACTIONS(5246),
    [anon_sym___shared__] = ACTIONS(5246),
    [anon_sym___local__] = ACTIONS(5246),
    [anon_sym___constant__] = ACTIONS(5246),
    [anon_sym___managed__] = ACTIONS(5246),
    [anon_sym___grid_constant__] = ACTIONS(5246),
    [anon_sym_alignas] = ACTIONS(5246),
    [anon_sym__Alignas] = ACTIONS(5246),
    [sym_primitive_type] = ACTIONS(5246),
    [anon_sym_COLON] = ACTIONS(5248),
    [anon_sym_QMARK] = ACTIONS(5248),
    [anon_sym_LT_EQ_GT] = ACTIONS(5248),
    [anon_sym_or] = ACTIONS(5246),
    [anon_sym_and] = ACTIONS(5246),
    [anon_sym_bitor] = ACTIONS(5246),
    [anon_sym_xor] = ACTIONS(5246),
    [anon_sym_bitand] = ACTIONS(5246),
    [anon_sym_not_eq] = ACTIONS(5246),
    [anon_sym_DASH_DASH] = ACTIONS(5248),
    [anon_sym_PLUS_PLUS] = ACTIONS(5248),
    [anon_sym_DOT] = ACTIONS(5246),
    [anon_sym_DOT_STAR] = ACTIONS(5248),
    [anon_sym_DASH_GT] = ACTIONS(5248),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5246),
    [anon_sym_decltype] = ACTIONS(5246),
    [anon_sym_final] = ACTIONS(5246),
    [anon_sym_override] = ACTIONS(5246),
    [anon_sym_requires] = ACTIONS(5246),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5248),
  },
  [1952] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1710),
    [sym_identifier] = ACTIONS(5016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5258),
    [anon_sym_COMMA] = ACTIONS(5258),
    [anon_sym_RPAREN] = ACTIONS(5258),
    [anon_sym_LPAREN2] = ACTIONS(5258),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5261),
    [anon_sym_STAR] = ACTIONS(5258),
    [anon_sym_SLASH] = ACTIONS(5261),
    [anon_sym_PERCENT] = ACTIONS(5258),
    [anon_sym_PIPE_PIPE] = ACTIONS(5258),
    [anon_sym_AMP_AMP] = ACTIONS(5258),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_CARET] = ACTIONS(5258),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_EQ_EQ] = ACTIONS(5258),
    [anon_sym_BANG_EQ] = ACTIONS(5258),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5258),
    [anon_sym_LT_EQ] = ACTIONS(5261),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_LT] = ACTIONS(5261),
    [anon_sym_GT_GT] = ACTIONS(5258),
    [anon_sym_SEMI] = ACTIONS(5258),
    [anon_sym___extension__] = ACTIONS(5261),
    [anon_sym___global__] = ACTIONS(5261),
    [anon_sym___attribute__] = ACTIONS(5261),
    [anon_sym_LBRACE] = ACTIONS(5258),
    [anon_sym_RBRACE] = ACTIONS(5258),
    [anon_sym_signed] = ACTIONS(5020),
    [anon_sym_unsigned] = ACTIONS(5020),
    [anon_sym_long] = ACTIONS(5020),
    [anon_sym_short] = ACTIONS(5020),
    [anon_sym_LBRACK] = ACTIONS(5258),
    [anon_sym_RBRACK] = ACTIONS(5258),
    [anon_sym_const] = ACTIONS(5261),
    [anon_sym_constexpr] = ACTIONS(5261),
    [anon_sym_volatile] = ACTIONS(5261),
    [anon_sym_restrict] = ACTIONS(5261),
    [anon_sym___restrict__] = ACTIONS(5261),
    [anon_sym__Atomic] = ACTIONS(5261),
    [anon_sym__Noreturn] = ACTIONS(5261),
    [anon_sym_noreturn] = ACTIONS(5261),
    [anon_sym_mutable] = ACTIONS(5261),
    [anon_sym_constinit] = ACTIONS(5261),
    [anon_sym_consteval] = ACTIONS(5261),
    [anon_sym___shared__] = ACTIONS(5261),
    [anon_sym___local__] = ACTIONS(5261),
    [anon_sym___constant__] = ACTIONS(5261),
    [anon_sym___managed__] = ACTIONS(5261),
    [anon_sym___grid_constant__] = ACTIONS(5261),
    [anon_sym_alignas] = ACTIONS(5261),
    [anon_sym__Alignas] = ACTIONS(5261),
    [sym_primitive_type] = ACTIONS(5016),
    [anon_sym_COLON] = ACTIONS(5258),
    [anon_sym_QMARK] = ACTIONS(5258),
    [anon_sym_LT_EQ_GT] = ACTIONS(5258),
    [anon_sym_or] = ACTIONS(5261),
    [anon_sym_and] = ACTIONS(5261),
    [anon_sym_bitor] = ACTIONS(5261),
    [anon_sym_xor] = ACTIONS(5261),
    [anon_sym_bitand] = ACTIONS(5261),
    [anon_sym_not_eq] = ACTIONS(5261),
    [anon_sym_DASH_DASH] = ACTIONS(5258),
    [anon_sym_PLUS_PLUS] = ACTIONS(5258),
    [anon_sym_DOT] = ACTIONS(5261),
    [anon_sym_DOT_STAR] = ACTIONS(5258),
    [anon_sym_DASH_GT] = ACTIONS(5258),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5261),
    [anon_sym_decltype] = ACTIONS(5261),
    [anon_sym_final] = ACTIONS(5261),
    [anon_sym_override] = ACTIONS(5261),
    [anon_sym_requires] = ACTIONS(5261),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5258),
  },
  [1953] = {
    [sym_identifier] = ACTIONS(2176),
    [aux_sym_preproc_def_token1] = ACTIONS(2176),
    [aux_sym_preproc_if_token1] = ACTIONS(2176),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2176),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2176),
    [sym_preproc_directive] = ACTIONS(2176),
    [anon_sym_LPAREN2] = ACTIONS(2178),
    [anon_sym_TILDE] = ACTIONS(2178),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_AMP_AMP] = ACTIONS(2178),
    [anon_sym_AMP] = ACTIONS(2176),
    [anon_sym___extension__] = ACTIONS(2176),
    [anon_sym_typedef] = ACTIONS(2176),
    [anon_sym___device__] = ACTIONS(2176),
    [anon_sym___host__] = ACTIONS(2176),
    [anon_sym___global__] = ACTIONS(2176),
    [anon_sym___forceinline__] = ACTIONS(2176),
    [anon_sym___noinline__] = ACTIONS(2176),
    [anon_sym_extern] = ACTIONS(2176),
    [anon_sym___attribute__] = ACTIONS(2176),
    [anon_sym_COLON_COLON] = ACTIONS(2178),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2178),
    [anon_sym___declspec] = ACTIONS(2176),
    [anon_sym___based] = ACTIONS(2176),
    [anon_sym_RBRACE] = ACTIONS(2178),
    [anon_sym_signed] = ACTIONS(2176),
    [anon_sym_unsigned] = ACTIONS(2176),
    [anon_sym_long] = ACTIONS(2176),
    [anon_sym_short] = ACTIONS(2176),
    [anon_sym_LBRACK] = ACTIONS(2176),
    [anon_sym_static] = ACTIONS(2176),
    [anon_sym_register] = ACTIONS(2176),
    [anon_sym_inline] = ACTIONS(2176),
    [anon_sym___inline] = ACTIONS(2176),
    [anon_sym___inline__] = ACTIONS(2176),
    [anon_sym___forceinline] = ACTIONS(2176),
    [anon_sym_thread_local] = ACTIONS(2176),
    [anon_sym___thread] = ACTIONS(2176),
    [anon_sym_const] = ACTIONS(2176),
    [anon_sym_constexpr] = ACTIONS(2176),
    [anon_sym_volatile] = ACTIONS(2176),
    [anon_sym_restrict] = ACTIONS(2176),
    [anon_sym___restrict__] = ACTIONS(2176),
    [anon_sym__Atomic] = ACTIONS(2176),
    [anon_sym__Noreturn] = ACTIONS(2176),
    [anon_sym_noreturn] = ACTIONS(2176),
    [anon_sym_mutable] = ACTIONS(2176),
    [anon_sym_constinit] = ACTIONS(2176),
    [anon_sym_consteval] = ACTIONS(2176),
    [anon_sym___shared__] = ACTIONS(2176),
    [anon_sym___local__] = ACTIONS(2176),
    [anon_sym___constant__] = ACTIONS(2176),
    [anon_sym___managed__] = ACTIONS(2176),
    [anon_sym___grid_constant__] = ACTIONS(2176),
    [anon_sym_alignas] = ACTIONS(2176),
    [anon_sym__Alignas] = ACTIONS(2176),
    [sym_primitive_type] = ACTIONS(2176),
    [anon_sym_enum] = ACTIONS(2176),
    [anon_sym_class] = ACTIONS(2176),
    [anon_sym_struct] = ACTIONS(2176),
    [anon_sym_union] = ACTIONS(2176),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2176),
    [anon_sym_decltype] = ACTIONS(2176),
    [sym_virtual] = ACTIONS(2176),
    [anon_sym_explicit] = ACTIONS(2176),
    [anon_sym_typename] = ACTIONS(2176),
    [anon_sym_template] = ACTIONS(2176),
    [anon_sym_operator] = ACTIONS(2176),
    [anon_sym_friend] = ACTIONS(2176),
    [anon_sym_public] = ACTIONS(2176),
    [anon_sym_private] = ACTIONS(2176),
    [anon_sym_protected] = ACTIONS(2176),
    [anon_sym_using] = ACTIONS(2176),
    [anon_sym_static_assert] = ACTIONS(2176),
    [anon_sym___launch_bounds__] = ACTIONS(2176),
  },
  [1954] = {
    [sym_identifier] = ACTIONS(2477),
    [aux_sym_preproc_def_token1] = ACTIONS(2477),
    [aux_sym_preproc_if_token1] = ACTIONS(2477),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2477),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2477),
    [sym_preproc_directive] = ACTIONS(2477),
    [anon_sym_LPAREN2] = ACTIONS(2479),
    [anon_sym_TILDE] = ACTIONS(2479),
    [anon_sym_STAR] = ACTIONS(2479),
    [anon_sym_AMP_AMP] = ACTIONS(2479),
    [anon_sym_AMP] = ACTIONS(2477),
    [anon_sym___extension__] = ACTIONS(2477),
    [anon_sym_typedef] = ACTIONS(2477),
    [anon_sym___device__] = ACTIONS(2477),
    [anon_sym___host__] = ACTIONS(2477),
    [anon_sym___global__] = ACTIONS(2477),
    [anon_sym___forceinline__] = ACTIONS(2477),
    [anon_sym___noinline__] = ACTIONS(2477),
    [anon_sym_extern] = ACTIONS(2477),
    [anon_sym___attribute__] = ACTIONS(2477),
    [anon_sym_COLON_COLON] = ACTIONS(2479),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2479),
    [anon_sym___declspec] = ACTIONS(2477),
    [anon_sym___based] = ACTIONS(2477),
    [anon_sym_RBRACE] = ACTIONS(2479),
    [anon_sym_signed] = ACTIONS(2477),
    [anon_sym_unsigned] = ACTIONS(2477),
    [anon_sym_long] = ACTIONS(2477),
    [anon_sym_short] = ACTIONS(2477),
    [anon_sym_LBRACK] = ACTIONS(2477),
    [anon_sym_static] = ACTIONS(2477),
    [anon_sym_register] = ACTIONS(2477),
    [anon_sym_inline] = ACTIONS(2477),
    [anon_sym___inline] = ACTIONS(2477),
    [anon_sym___inline__] = ACTIONS(2477),
    [anon_sym___forceinline] = ACTIONS(2477),
    [anon_sym_thread_local] = ACTIONS(2477),
    [anon_sym___thread] = ACTIONS(2477),
    [anon_sym_const] = ACTIONS(2477),
    [anon_sym_constexpr] = ACTIONS(2477),
    [anon_sym_volatile] = ACTIONS(2477),
    [anon_sym_restrict] = ACTIONS(2477),
    [anon_sym___restrict__] = ACTIONS(2477),
    [anon_sym__Atomic] = ACTIONS(2477),
    [anon_sym__Noreturn] = ACTIONS(2477),
    [anon_sym_noreturn] = ACTIONS(2477),
    [anon_sym_mutable] = ACTIONS(2477),
    [anon_sym_constinit] = ACTIONS(2477),
    [anon_sym_consteval] = ACTIONS(2477),
    [anon_sym___shared__] = ACTIONS(2477),
    [anon_sym___local__] = ACTIONS(2477),
    [anon_sym___constant__] = ACTIONS(2477),
    [anon_sym___managed__] = ACTIONS(2477),
    [anon_sym___grid_constant__] = ACTIONS(2477),
    [anon_sym_alignas] = ACTIONS(2477),
    [anon_sym__Alignas] = ACTIONS(2477),
    [sym_primitive_type] = ACTIONS(2477),
    [anon_sym_enum] = ACTIONS(2477),
    [anon_sym_class] = ACTIONS(2477),
    [anon_sym_struct] = ACTIONS(2477),
    [anon_sym_union] = ACTIONS(2477),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2477),
    [anon_sym_decltype] = ACTIONS(2477),
    [sym_virtual] = ACTIONS(2477),
    [anon_sym_explicit] = ACTIONS(2477),
    [anon_sym_typename] = ACTIONS(2477),
    [anon_sym_template] = ACTIONS(2477),
    [anon_sym_operator] = ACTIONS(2477),
    [anon_sym_friend] = ACTIONS(2477),
    [anon_sym_public] = ACTIONS(2477),
    [anon_sym_private] = ACTIONS(2477),
    [anon_sym_protected] = ACTIONS(2477),
    [anon_sym_using] = ACTIONS(2477),
    [anon_sym_static_assert] = ACTIONS(2477),
    [anon_sym___launch_bounds__] = ACTIONS(2477),
  },
  [1955] = {
    [sym_identifier] = ACTIONS(5039),
    [aux_sym_preproc_def_token1] = ACTIONS(5039),
    [aux_sym_preproc_if_token1] = ACTIONS(5039),
    [aux_sym_preproc_if_token2] = ACTIONS(5039),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5039),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5039),
    [sym_preproc_directive] = ACTIONS(5039),
    [anon_sym_LPAREN2] = ACTIONS(5041),
    [anon_sym_TILDE] = ACTIONS(5041),
    [anon_sym_STAR] = ACTIONS(5041),
    [anon_sym_AMP_AMP] = ACTIONS(5041),
    [anon_sym_AMP] = ACTIONS(5039),
    [anon_sym___extension__] = ACTIONS(5039),
    [anon_sym_typedef] = ACTIONS(5039),
    [anon_sym___device__] = ACTIONS(5039),
    [anon_sym___host__] = ACTIONS(5039),
    [anon_sym___global__] = ACTIONS(5039),
    [anon_sym___forceinline__] = ACTIONS(5039),
    [anon_sym___noinline__] = ACTIONS(5039),
    [anon_sym_extern] = ACTIONS(5039),
    [anon_sym___attribute__] = ACTIONS(5039),
    [anon_sym_COLON_COLON] = ACTIONS(5041),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5041),
    [anon_sym___declspec] = ACTIONS(5039),
    [anon_sym___based] = ACTIONS(5039),
    [anon_sym_signed] = ACTIONS(5039),
    [anon_sym_unsigned] = ACTIONS(5039),
    [anon_sym_long] = ACTIONS(5039),
    [anon_sym_short] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(5039),
    [anon_sym_static] = ACTIONS(5039),
    [anon_sym_register] = ACTIONS(5039),
    [anon_sym_inline] = ACTIONS(5039),
    [anon_sym___inline] = ACTIONS(5039),
    [anon_sym___inline__] = ACTIONS(5039),
    [anon_sym___forceinline] = ACTIONS(5039),
    [anon_sym_thread_local] = ACTIONS(5039),
    [anon_sym___thread] = ACTIONS(5039),
    [anon_sym_const] = ACTIONS(5039),
    [anon_sym_constexpr] = ACTIONS(5039),
    [anon_sym_volatile] = ACTIONS(5039),
    [anon_sym_restrict] = ACTIONS(5039),
    [anon_sym___restrict__] = ACTIONS(5039),
    [anon_sym__Atomic] = ACTIONS(5039),
    [anon_sym__Noreturn] = ACTIONS(5039),
    [anon_sym_noreturn] = ACTIONS(5039),
    [anon_sym_mutable] = ACTIONS(5039),
    [anon_sym_constinit] = ACTIONS(5039),
    [anon_sym_consteval] = ACTIONS(5039),
    [anon_sym___shared__] = ACTIONS(5039),
    [anon_sym___local__] = ACTIONS(5039),
    [anon_sym___constant__] = ACTIONS(5039),
    [anon_sym___managed__] = ACTIONS(5039),
    [anon_sym___grid_constant__] = ACTIONS(5039),
    [anon_sym_alignas] = ACTIONS(5039),
    [anon_sym__Alignas] = ACTIONS(5039),
    [sym_primitive_type] = ACTIONS(5039),
    [anon_sym_enum] = ACTIONS(5039),
    [anon_sym_class] = ACTIONS(5039),
    [anon_sym_struct] = ACTIONS(5039),
    [anon_sym_union] = ACTIONS(5039),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5039),
    [anon_sym_decltype] = ACTIONS(5039),
    [sym_virtual] = ACTIONS(5039),
    [anon_sym_explicit] = ACTIONS(5039),
    [anon_sym_typename] = ACTIONS(5039),
    [anon_sym_template] = ACTIONS(5039),
    [anon_sym_operator] = ACTIONS(5039),
    [anon_sym_friend] = ACTIONS(5039),
    [anon_sym_public] = ACTIONS(5039),
    [anon_sym_private] = ACTIONS(5039),
    [anon_sym_protected] = ACTIONS(5039),
    [anon_sym_using] = ACTIONS(5039),
    [anon_sym_static_assert] = ACTIONS(5039),
    [anon_sym___launch_bounds__] = ACTIONS(5039),
  },
  [1956] = {
    [sym_identifier] = ACTIONS(5043),
    [aux_sym_preproc_def_token1] = ACTIONS(5043),
    [aux_sym_preproc_if_token1] = ACTIONS(5043),
    [aux_sym_preproc_if_token2] = ACTIONS(5043),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5043),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5043),
    [sym_preproc_directive] = ACTIONS(5043),
    [anon_sym_LPAREN2] = ACTIONS(5045),
    [anon_sym_TILDE] = ACTIONS(5045),
    [anon_sym_STAR] = ACTIONS(5045),
    [anon_sym_AMP_AMP] = ACTIONS(5045),
    [anon_sym_AMP] = ACTIONS(5043),
    [anon_sym___extension__] = ACTIONS(5043),
    [anon_sym_typedef] = ACTIONS(5043),
    [anon_sym___device__] = ACTIONS(5043),
    [anon_sym___host__] = ACTIONS(5043),
    [anon_sym___global__] = ACTIONS(5043),
    [anon_sym___forceinline__] = ACTIONS(5043),
    [anon_sym___noinline__] = ACTIONS(5043),
    [anon_sym_extern] = ACTIONS(5043),
    [anon_sym___attribute__] = ACTIONS(5043),
    [anon_sym_COLON_COLON] = ACTIONS(5045),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5045),
    [anon_sym___declspec] = ACTIONS(5043),
    [anon_sym___based] = ACTIONS(5043),
    [anon_sym_signed] = ACTIONS(5043),
    [anon_sym_unsigned] = ACTIONS(5043),
    [anon_sym_long] = ACTIONS(5043),
    [anon_sym_short] = ACTIONS(5043),
    [anon_sym_LBRACK] = ACTIONS(5043),
    [anon_sym_static] = ACTIONS(5043),
    [anon_sym_register] = ACTIONS(5043),
    [anon_sym_inline] = ACTIONS(5043),
    [anon_sym___inline] = ACTIONS(5043),
    [anon_sym___inline__] = ACTIONS(5043),
    [anon_sym___forceinline] = ACTIONS(5043),
    [anon_sym_thread_local] = ACTIONS(5043),
    [anon_sym___thread] = ACTIONS(5043),
    [anon_sym_const] = ACTIONS(5043),
    [anon_sym_constexpr] = ACTIONS(5043),
    [anon_sym_volatile] = ACTIONS(5043),
    [anon_sym_restrict] = ACTIONS(5043),
    [anon_sym___restrict__] = ACTIONS(5043),
    [anon_sym__Atomic] = ACTIONS(5043),
    [anon_sym__Noreturn] = ACTIONS(5043),
    [anon_sym_noreturn] = ACTIONS(5043),
    [anon_sym_mutable] = ACTIONS(5043),
    [anon_sym_constinit] = ACTIONS(5043),
    [anon_sym_consteval] = ACTIONS(5043),
    [anon_sym___shared__] = ACTIONS(5043),
    [anon_sym___local__] = ACTIONS(5043),
    [anon_sym___constant__] = ACTIONS(5043),
    [anon_sym___managed__] = ACTIONS(5043),
    [anon_sym___grid_constant__] = ACTIONS(5043),
    [anon_sym_alignas] = ACTIONS(5043),
    [anon_sym__Alignas] = ACTIONS(5043),
    [sym_primitive_type] = ACTIONS(5043),
    [anon_sym_enum] = ACTIONS(5043),
    [anon_sym_class] = ACTIONS(5043),
    [anon_sym_struct] = ACTIONS(5043),
    [anon_sym_union] = ACTIONS(5043),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5043),
    [anon_sym_decltype] = ACTIONS(5043),
    [sym_virtual] = ACTIONS(5043),
    [anon_sym_explicit] = ACTIONS(5043),
    [anon_sym_typename] = ACTIONS(5043),
    [anon_sym_template] = ACTIONS(5043),
    [anon_sym_operator] = ACTIONS(5043),
    [anon_sym_friend] = ACTIONS(5043),
    [anon_sym_public] = ACTIONS(5043),
    [anon_sym_private] = ACTIONS(5043),
    [anon_sym_protected] = ACTIONS(5043),
    [anon_sym_using] = ACTIONS(5043),
    [anon_sym_static_assert] = ACTIONS(5043),
    [anon_sym___launch_bounds__] = ACTIONS(5043),
  },
  [1957] = {
    [sym_identifier] = ACTIONS(5043),
    [aux_sym_preproc_def_token1] = ACTIONS(5043),
    [aux_sym_preproc_if_token1] = ACTIONS(5043),
    [aux_sym_preproc_if_token2] = ACTIONS(5043),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5043),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5043),
    [sym_preproc_directive] = ACTIONS(5043),
    [anon_sym_LPAREN2] = ACTIONS(5045),
    [anon_sym_TILDE] = ACTIONS(5045),
    [anon_sym_STAR] = ACTIONS(5045),
    [anon_sym_AMP_AMP] = ACTIONS(5045),
    [anon_sym_AMP] = ACTIONS(5043),
    [anon_sym___extension__] = ACTIONS(5043),
    [anon_sym_typedef] = ACTIONS(5043),
    [anon_sym___device__] = ACTIONS(5043),
    [anon_sym___host__] = ACTIONS(5043),
    [anon_sym___global__] = ACTIONS(5043),
    [anon_sym___forceinline__] = ACTIONS(5043),
    [anon_sym___noinline__] = ACTIONS(5043),
    [anon_sym_extern] = ACTIONS(5043),
    [anon_sym___attribute__] = ACTIONS(5043),
    [anon_sym_COLON_COLON] = ACTIONS(5045),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5045),
    [anon_sym___declspec] = ACTIONS(5043),
    [anon_sym___based] = ACTIONS(5043),
    [anon_sym_signed] = ACTIONS(5043),
    [anon_sym_unsigned] = ACTIONS(5043),
    [anon_sym_long] = ACTIONS(5043),
    [anon_sym_short] = ACTIONS(5043),
    [anon_sym_LBRACK] = ACTIONS(5043),
    [anon_sym_static] = ACTIONS(5043),
    [anon_sym_register] = ACTIONS(5043),
    [anon_sym_inline] = ACTIONS(5043),
    [anon_sym___inline] = ACTIONS(5043),
    [anon_sym___inline__] = ACTIONS(5043),
    [anon_sym___forceinline] = ACTIONS(5043),
    [anon_sym_thread_local] = ACTIONS(5043),
    [anon_sym___thread] = ACTIONS(5043),
    [anon_sym_const] = ACTIONS(5043),
    [anon_sym_constexpr] = ACTIONS(5043),
    [anon_sym_volatile] = ACTIONS(5043),
    [anon_sym_restrict] = ACTIONS(5043),
    [anon_sym___restrict__] = ACTIONS(5043),
    [anon_sym__Atomic] = ACTIONS(5043),
    [anon_sym__Noreturn] = ACTIONS(5043),
    [anon_sym_noreturn] = ACTIONS(5043),
    [anon_sym_mutable] = ACTIONS(5043),
    [anon_sym_constinit] = ACTIONS(5043),
    [anon_sym_consteval] = ACTIONS(5043),
    [anon_sym___shared__] = ACTIONS(5043),
    [anon_sym___local__] = ACTIONS(5043),
    [anon_sym___constant__] = ACTIONS(5043),
    [anon_sym___managed__] = ACTIONS(5043),
    [anon_sym___grid_constant__] = ACTIONS(5043),
    [anon_sym_alignas] = ACTIONS(5043),
    [anon_sym__Alignas] = ACTIONS(5043),
    [sym_primitive_type] = ACTIONS(5043),
    [anon_sym_enum] = ACTIONS(5043),
    [anon_sym_class] = ACTIONS(5043),
    [anon_sym_struct] = ACTIONS(5043),
    [anon_sym_union] = ACTIONS(5043),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5043),
    [anon_sym_decltype] = ACTIONS(5043),
    [sym_virtual] = ACTIONS(5043),
    [anon_sym_explicit] = ACTIONS(5043),
    [anon_sym_typename] = ACTIONS(5043),
    [anon_sym_template] = ACTIONS(5043),
    [anon_sym_operator] = ACTIONS(5043),
    [anon_sym_friend] = ACTIONS(5043),
    [anon_sym_public] = ACTIONS(5043),
    [anon_sym_private] = ACTIONS(5043),
    [anon_sym_protected] = ACTIONS(5043),
    [anon_sym_using] = ACTIONS(5043),
    [anon_sym_static_assert] = ACTIONS(5043),
    [anon_sym___launch_bounds__] = ACTIONS(5043),
  },
  [1958] = {
    [sym_identifier] = ACTIONS(5043),
    [aux_sym_preproc_def_token1] = ACTIONS(5043),
    [aux_sym_preproc_if_token1] = ACTIONS(5043),
    [aux_sym_preproc_if_token2] = ACTIONS(5043),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5043),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5043),
    [sym_preproc_directive] = ACTIONS(5043),
    [anon_sym_LPAREN2] = ACTIONS(5045),
    [anon_sym_TILDE] = ACTIONS(5045),
    [anon_sym_STAR] = ACTIONS(5045),
    [anon_sym_AMP_AMP] = ACTIONS(5045),
    [anon_sym_AMP] = ACTIONS(5043),
    [anon_sym___extension__] = ACTIONS(5043),
    [anon_sym_typedef] = ACTIONS(5043),
    [anon_sym___device__] = ACTIONS(5043),
    [anon_sym___host__] = ACTIONS(5043),
    [anon_sym___global__] = ACTIONS(5043),
    [anon_sym___forceinline__] = ACTIONS(5043),
    [anon_sym___noinline__] = ACTIONS(5043),
    [anon_sym_extern] = ACTIONS(5043),
    [anon_sym___attribute__] = ACTIONS(5043),
    [anon_sym_COLON_COLON] = ACTIONS(5045),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5045),
    [anon_sym___declspec] = ACTIONS(5043),
    [anon_sym___based] = ACTIONS(5043),
    [anon_sym_signed] = ACTIONS(5043),
    [anon_sym_unsigned] = ACTIONS(5043),
    [anon_sym_long] = ACTIONS(5043),
    [anon_sym_short] = ACTIONS(5043),
    [anon_sym_LBRACK] = ACTIONS(5043),
    [anon_sym_static] = ACTIONS(5043),
    [anon_sym_register] = ACTIONS(5043),
    [anon_sym_inline] = ACTIONS(5043),
    [anon_sym___inline] = ACTIONS(5043),
    [anon_sym___inline__] = ACTIONS(5043),
    [anon_sym___forceinline] = ACTIONS(5043),
    [anon_sym_thread_local] = ACTIONS(5043),
    [anon_sym___thread] = ACTIONS(5043),
    [anon_sym_const] = ACTIONS(5043),
    [anon_sym_constexpr] = ACTIONS(5043),
    [anon_sym_volatile] = ACTIONS(5043),
    [anon_sym_restrict] = ACTIONS(5043),
    [anon_sym___restrict__] = ACTIONS(5043),
    [anon_sym__Atomic] = ACTIONS(5043),
    [anon_sym__Noreturn] = ACTIONS(5043),
    [anon_sym_noreturn] = ACTIONS(5043),
    [anon_sym_mutable] = ACTIONS(5043),
    [anon_sym_constinit] = ACTIONS(5043),
    [anon_sym_consteval] = ACTIONS(5043),
    [anon_sym___shared__] = ACTIONS(5043),
    [anon_sym___local__] = ACTIONS(5043),
    [anon_sym___constant__] = ACTIONS(5043),
    [anon_sym___managed__] = ACTIONS(5043),
    [anon_sym___grid_constant__] = ACTIONS(5043),
    [anon_sym_alignas] = ACTIONS(5043),
    [anon_sym__Alignas] = ACTIONS(5043),
    [sym_primitive_type] = ACTIONS(5043),
    [anon_sym_enum] = ACTIONS(5043),
    [anon_sym_class] = ACTIONS(5043),
    [anon_sym_struct] = ACTIONS(5043),
    [anon_sym_union] = ACTIONS(5043),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5043),
    [anon_sym_decltype] = ACTIONS(5043),
    [sym_virtual] = ACTIONS(5043),
    [anon_sym_explicit] = ACTIONS(5043),
    [anon_sym_typename] = ACTIONS(5043),
    [anon_sym_template] = ACTIONS(5043),
    [anon_sym_operator] = ACTIONS(5043),
    [anon_sym_friend] = ACTIONS(5043),
    [anon_sym_public] = ACTIONS(5043),
    [anon_sym_private] = ACTIONS(5043),
    [anon_sym_protected] = ACTIONS(5043),
    [anon_sym_using] = ACTIONS(5043),
    [anon_sym_static_assert] = ACTIONS(5043),
    [anon_sym___launch_bounds__] = ACTIONS(5043),
  },
  [1959] = {
    [sym_identifier] = ACTIONS(5039),
    [aux_sym_preproc_def_token1] = ACTIONS(5039),
    [aux_sym_preproc_if_token1] = ACTIONS(5039),
    [aux_sym_preproc_if_token2] = ACTIONS(5039),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5039),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5039),
    [sym_preproc_directive] = ACTIONS(5039),
    [anon_sym_LPAREN2] = ACTIONS(5041),
    [anon_sym_TILDE] = ACTIONS(5041),
    [anon_sym_STAR] = ACTIONS(5041),
    [anon_sym_AMP_AMP] = ACTIONS(5041),
    [anon_sym_AMP] = ACTIONS(5039),
    [anon_sym___extension__] = ACTIONS(5039),
    [anon_sym_typedef] = ACTIONS(5039),
    [anon_sym___device__] = ACTIONS(5039),
    [anon_sym___host__] = ACTIONS(5039),
    [anon_sym___global__] = ACTIONS(5039),
    [anon_sym___forceinline__] = ACTIONS(5039),
    [anon_sym___noinline__] = ACTIONS(5039),
    [anon_sym_extern] = ACTIONS(5039),
    [anon_sym___attribute__] = ACTIONS(5039),
    [anon_sym_COLON_COLON] = ACTIONS(5041),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5041),
    [anon_sym___declspec] = ACTIONS(5039),
    [anon_sym___based] = ACTIONS(5039),
    [anon_sym_signed] = ACTIONS(5039),
    [anon_sym_unsigned] = ACTIONS(5039),
    [anon_sym_long] = ACTIONS(5039),
    [anon_sym_short] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(5039),
    [anon_sym_static] = ACTIONS(5039),
    [anon_sym_register] = ACTIONS(5039),
    [anon_sym_inline] = ACTIONS(5039),
    [anon_sym___inline] = ACTIONS(5039),
    [anon_sym___inline__] = ACTIONS(5039),
    [anon_sym___forceinline] = ACTIONS(5039),
    [anon_sym_thread_local] = ACTIONS(5039),
    [anon_sym___thread] = ACTIONS(5039),
    [anon_sym_const] = ACTIONS(5039),
    [anon_sym_constexpr] = ACTIONS(5039),
    [anon_sym_volatile] = ACTIONS(5039),
    [anon_sym_restrict] = ACTIONS(5039),
    [anon_sym___restrict__] = ACTIONS(5039),
    [anon_sym__Atomic] = ACTIONS(5039),
    [anon_sym__Noreturn] = ACTIONS(5039),
    [anon_sym_noreturn] = ACTIONS(5039),
    [anon_sym_mutable] = ACTIONS(5039),
    [anon_sym_constinit] = ACTIONS(5039),
    [anon_sym_consteval] = ACTIONS(5039),
    [anon_sym___shared__] = ACTIONS(5039),
    [anon_sym___local__] = ACTIONS(5039),
    [anon_sym___constant__] = ACTIONS(5039),
    [anon_sym___managed__] = ACTIONS(5039),
    [anon_sym___grid_constant__] = ACTIONS(5039),
    [anon_sym_alignas] = ACTIONS(5039),
    [anon_sym__Alignas] = ACTIONS(5039),
    [sym_primitive_type] = ACTIONS(5039),
    [anon_sym_enum] = ACTIONS(5039),
    [anon_sym_class] = ACTIONS(5039),
    [anon_sym_struct] = ACTIONS(5039),
    [anon_sym_union] = ACTIONS(5039),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5039),
    [anon_sym_decltype] = ACTIONS(5039),
    [sym_virtual] = ACTIONS(5039),
    [anon_sym_explicit] = ACTIONS(5039),
    [anon_sym_typename] = ACTIONS(5039),
    [anon_sym_template] = ACTIONS(5039),
    [anon_sym_operator] = ACTIONS(5039),
    [anon_sym_friend] = ACTIONS(5039),
    [anon_sym_public] = ACTIONS(5039),
    [anon_sym_private] = ACTIONS(5039),
    [anon_sym_protected] = ACTIONS(5039),
    [anon_sym_using] = ACTIONS(5039),
    [anon_sym_static_assert] = ACTIONS(5039),
    [anon_sym___launch_bounds__] = ACTIONS(5039),
  },
  [1960] = {
    [sym_identifier] = ACTIONS(5035),
    [aux_sym_preproc_def_token1] = ACTIONS(5035),
    [aux_sym_preproc_if_token1] = ACTIONS(5035),
    [aux_sym_preproc_if_token2] = ACTIONS(5035),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5035),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5035),
    [sym_preproc_directive] = ACTIONS(5035),
    [anon_sym_LPAREN2] = ACTIONS(5037),
    [anon_sym_TILDE] = ACTIONS(5037),
    [anon_sym_STAR] = ACTIONS(5037),
    [anon_sym_AMP_AMP] = ACTIONS(5037),
    [anon_sym_AMP] = ACTIONS(5035),
    [anon_sym___extension__] = ACTIONS(5035),
    [anon_sym_typedef] = ACTIONS(5035),
    [anon_sym___device__] = ACTIONS(5035),
    [anon_sym___host__] = ACTIONS(5035),
    [anon_sym___global__] = ACTIONS(5035),
    [anon_sym___forceinline__] = ACTIONS(5035),
    [anon_sym___noinline__] = ACTIONS(5035),
    [anon_sym_extern] = ACTIONS(5035),
    [anon_sym___attribute__] = ACTIONS(5035),
    [anon_sym_COLON_COLON] = ACTIONS(5037),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5037),
    [anon_sym___declspec] = ACTIONS(5035),
    [anon_sym___based] = ACTIONS(5035),
    [anon_sym_signed] = ACTIONS(5035),
    [anon_sym_unsigned] = ACTIONS(5035),
    [anon_sym_long] = ACTIONS(5035),
    [anon_sym_short] = ACTIONS(5035),
    [anon_sym_LBRACK] = ACTIONS(5035),
    [anon_sym_static] = ACTIONS(5035),
    [anon_sym_register] = ACTIONS(5035),
    [anon_sym_inline] = ACTIONS(5035),
    [anon_sym___inline] = ACTIONS(5035),
    [anon_sym___inline__] = ACTIONS(5035),
    [anon_sym___forceinline] = ACTIONS(5035),
    [anon_sym_thread_local] = ACTIONS(5035),
    [anon_sym___thread] = ACTIONS(5035),
    [anon_sym_const] = ACTIONS(5035),
    [anon_sym_constexpr] = ACTIONS(5035),
    [anon_sym_volatile] = ACTIONS(5035),
    [anon_sym_restrict] = ACTIONS(5035),
    [anon_sym___restrict__] = ACTIONS(5035),
    [anon_sym__Atomic] = ACTIONS(5035),
    [anon_sym__Noreturn] = ACTIONS(5035),
    [anon_sym_noreturn] = ACTIONS(5035),
    [anon_sym_mutable] = ACTIONS(5035),
    [anon_sym_constinit] = ACTIONS(5035),
    [anon_sym_consteval] = ACTIONS(5035),
    [anon_sym___shared__] = ACTIONS(5035),
    [anon_sym___local__] = ACTIONS(5035),
    [anon_sym___constant__] = ACTIONS(5035),
    [anon_sym___managed__] = ACTIONS(5035),
    [anon_sym___grid_constant__] = ACTIONS(5035),
    [anon_sym_alignas] = ACTIONS(5035),
    [anon_sym__Alignas] = ACTIONS(5035),
    [sym_primitive_type] = ACTIONS(5035),
    [anon_sym_enum] = ACTIONS(5035),
    [anon_sym_class] = ACTIONS(5035),
    [anon_sym_struct] = ACTIONS(5035),
    [anon_sym_union] = ACTIONS(5035),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5035),
    [anon_sym_decltype] = ACTIONS(5035),
    [sym_virtual] = ACTIONS(5035),
    [anon_sym_explicit] = ACTIONS(5035),
    [anon_sym_typename] = ACTIONS(5035),
    [anon_sym_template] = ACTIONS(5035),
    [anon_sym_operator] = ACTIONS(5035),
    [anon_sym_friend] = ACTIONS(5035),
    [anon_sym_public] = ACTIONS(5035),
    [anon_sym_private] = ACTIONS(5035),
    [anon_sym_protected] = ACTIONS(5035),
    [anon_sym_using] = ACTIONS(5035),
    [anon_sym_static_assert] = ACTIONS(5035),
    [anon_sym___launch_bounds__] = ACTIONS(5035),
  },
  [1961] = {
    [sym_identifier] = ACTIONS(5031),
    [aux_sym_preproc_def_token1] = ACTIONS(5031),
    [aux_sym_preproc_if_token1] = ACTIONS(5031),
    [aux_sym_preproc_if_token2] = ACTIONS(5031),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5031),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5031),
    [sym_preproc_directive] = ACTIONS(5031),
    [anon_sym_LPAREN2] = ACTIONS(5033),
    [anon_sym_TILDE] = ACTIONS(5033),
    [anon_sym_STAR] = ACTIONS(5033),
    [anon_sym_AMP_AMP] = ACTIONS(5033),
    [anon_sym_AMP] = ACTIONS(5031),
    [anon_sym___extension__] = ACTIONS(5031),
    [anon_sym_typedef] = ACTIONS(5031),
    [anon_sym___device__] = ACTIONS(5031),
    [anon_sym___host__] = ACTIONS(5031),
    [anon_sym___global__] = ACTIONS(5031),
    [anon_sym___forceinline__] = ACTIONS(5031),
    [anon_sym___noinline__] = ACTIONS(5031),
    [anon_sym_extern] = ACTIONS(5031),
    [anon_sym___attribute__] = ACTIONS(5031),
    [anon_sym_COLON_COLON] = ACTIONS(5033),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5033),
    [anon_sym___declspec] = ACTIONS(5031),
    [anon_sym___based] = ACTIONS(5031),
    [anon_sym_signed] = ACTIONS(5031),
    [anon_sym_unsigned] = ACTIONS(5031),
    [anon_sym_long] = ACTIONS(5031),
    [anon_sym_short] = ACTIONS(5031),
    [anon_sym_LBRACK] = ACTIONS(5031),
    [anon_sym_static] = ACTIONS(5031),
    [anon_sym_register] = ACTIONS(5031),
    [anon_sym_inline] = ACTIONS(5031),
    [anon_sym___inline] = ACTIONS(5031),
    [anon_sym___inline__] = ACTIONS(5031),
    [anon_sym___forceinline] = ACTIONS(5031),
    [anon_sym_thread_local] = ACTIONS(5031),
    [anon_sym___thread] = ACTIONS(5031),
    [anon_sym_const] = ACTIONS(5031),
    [anon_sym_constexpr] = ACTIONS(5031),
    [anon_sym_volatile] = ACTIONS(5031),
    [anon_sym_restrict] = ACTIONS(5031),
    [anon_sym___restrict__] = ACTIONS(5031),
    [anon_sym__Atomic] = ACTIONS(5031),
    [anon_sym__Noreturn] = ACTIONS(5031),
    [anon_sym_noreturn] = ACTIONS(5031),
    [anon_sym_mutable] = ACTIONS(5031),
    [anon_sym_constinit] = ACTIONS(5031),
    [anon_sym_consteval] = ACTIONS(5031),
    [anon_sym___shared__] = ACTIONS(5031),
    [anon_sym___local__] = ACTIONS(5031),
    [anon_sym___constant__] = ACTIONS(5031),
    [anon_sym___managed__] = ACTIONS(5031),
    [anon_sym___grid_constant__] = ACTIONS(5031),
    [anon_sym_alignas] = ACTIONS(5031),
    [anon_sym__Alignas] = ACTIONS(5031),
    [sym_primitive_type] = ACTIONS(5031),
    [anon_sym_enum] = ACTIONS(5031),
    [anon_sym_class] = ACTIONS(5031),
    [anon_sym_struct] = ACTIONS(5031),
    [anon_sym_union] = ACTIONS(5031),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5031),
    [anon_sym_decltype] = ACTIONS(5031),
    [sym_virtual] = ACTIONS(5031),
    [anon_sym_explicit] = ACTIONS(5031),
    [anon_sym_typename] = ACTIONS(5031),
    [anon_sym_template] = ACTIONS(5031),
    [anon_sym_operator] = ACTIONS(5031),
    [anon_sym_friend] = ACTIONS(5031),
    [anon_sym_public] = ACTIONS(5031),
    [anon_sym_private] = ACTIONS(5031),
    [anon_sym_protected] = ACTIONS(5031),
    [anon_sym_using] = ACTIONS(5031),
    [anon_sym_static_assert] = ACTIONS(5031),
    [anon_sym___launch_bounds__] = ACTIONS(5031),
  },
  [1962] = {
    [sym_identifier] = ACTIONS(5027),
    [aux_sym_preproc_def_token1] = ACTIONS(5027),
    [aux_sym_preproc_if_token1] = ACTIONS(5027),
    [aux_sym_preproc_if_token2] = ACTIONS(5027),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5027),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5027),
    [sym_preproc_directive] = ACTIONS(5027),
    [anon_sym_LPAREN2] = ACTIONS(5029),
    [anon_sym_TILDE] = ACTIONS(5029),
    [anon_sym_STAR] = ACTIONS(5029),
    [anon_sym_AMP_AMP] = ACTIONS(5029),
    [anon_sym_AMP] = ACTIONS(5027),
    [anon_sym___extension__] = ACTIONS(5027),
    [anon_sym_typedef] = ACTIONS(5027),
    [anon_sym___device__] = ACTIONS(5027),
    [anon_sym___host__] = ACTIONS(5027),
    [anon_sym___global__] = ACTIONS(5027),
    [anon_sym___forceinline__] = ACTIONS(5027),
    [anon_sym___noinline__] = ACTIONS(5027),
    [anon_sym_extern] = ACTIONS(5027),
    [anon_sym___attribute__] = ACTIONS(5027),
    [anon_sym_COLON_COLON] = ACTIONS(5029),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5029),
    [anon_sym___declspec] = ACTIONS(5027),
    [anon_sym___based] = ACTIONS(5027),
    [anon_sym_signed] = ACTIONS(5027),
    [anon_sym_unsigned] = ACTIONS(5027),
    [anon_sym_long] = ACTIONS(5027),
    [anon_sym_short] = ACTIONS(5027),
    [anon_sym_LBRACK] = ACTIONS(5027),
    [anon_sym_static] = ACTIONS(5027),
    [anon_sym_register] = ACTIONS(5027),
    [anon_sym_inline] = ACTIONS(5027),
    [anon_sym___inline] = ACTIONS(5027),
    [anon_sym___inline__] = ACTIONS(5027),
    [anon_sym___forceinline] = ACTIONS(5027),
    [anon_sym_thread_local] = ACTIONS(5027),
    [anon_sym___thread] = ACTIONS(5027),
    [anon_sym_const] = ACTIONS(5027),
    [anon_sym_constexpr] = ACTIONS(5027),
    [anon_sym_volatile] = ACTIONS(5027),
    [anon_sym_restrict] = ACTIONS(5027),
    [anon_sym___restrict__] = ACTIONS(5027),
    [anon_sym__Atomic] = ACTIONS(5027),
    [anon_sym__Noreturn] = ACTIONS(5027),
    [anon_sym_noreturn] = ACTIONS(5027),
    [anon_sym_mutable] = ACTIONS(5027),
    [anon_sym_constinit] = ACTIONS(5027),
    [anon_sym_consteval] = ACTIONS(5027),
    [anon_sym___shared__] = ACTIONS(5027),
    [anon_sym___local__] = ACTIONS(5027),
    [anon_sym___constant__] = ACTIONS(5027),
    [anon_sym___managed__] = ACTIONS(5027),
    [anon_sym___grid_constant__] = ACTIONS(5027),
    [anon_sym_alignas] = ACTIONS(5027),
    [anon_sym__Alignas] = ACTIONS(5027),
    [sym_primitive_type] = ACTIONS(5027),
    [anon_sym_enum] = ACTIONS(5027),
    [anon_sym_class] = ACTIONS(5027),
    [anon_sym_struct] = ACTIONS(5027),
    [anon_sym_union] = ACTIONS(5027),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5027),
    [anon_sym_decltype] = ACTIONS(5027),
    [sym_virtual] = ACTIONS(5027),
    [anon_sym_explicit] = ACTIONS(5027),
    [anon_sym_typename] = ACTIONS(5027),
    [anon_sym_template] = ACTIONS(5027),
    [anon_sym_operator] = ACTIONS(5027),
    [anon_sym_friend] = ACTIONS(5027),
    [anon_sym_public] = ACTIONS(5027),
    [anon_sym_private] = ACTIONS(5027),
    [anon_sym_protected] = ACTIONS(5027),
    [anon_sym_using] = ACTIONS(5027),
    [anon_sym_static_assert] = ACTIONS(5027),
    [anon_sym___launch_bounds__] = ACTIONS(5027),
  },
  [1963] = {
    [sym_identifier] = ACTIONS(2259),
    [aux_sym_preproc_def_token1] = ACTIONS(2259),
    [aux_sym_preproc_if_token1] = ACTIONS(2259),
    [aux_sym_preproc_if_token2] = ACTIONS(2259),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2259),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2259),
    [sym_preproc_directive] = ACTIONS(2259),
    [anon_sym_LPAREN2] = ACTIONS(2261),
    [anon_sym_TILDE] = ACTIONS(2261),
    [anon_sym_STAR] = ACTIONS(2261),
    [anon_sym_AMP_AMP] = ACTIONS(2261),
    [anon_sym_AMP] = ACTIONS(2259),
    [anon_sym___extension__] = ACTIONS(2259),
    [anon_sym_typedef] = ACTIONS(2259),
    [anon_sym___device__] = ACTIONS(2259),
    [anon_sym___host__] = ACTIONS(2259),
    [anon_sym___global__] = ACTIONS(2259),
    [anon_sym___forceinline__] = ACTIONS(2259),
    [anon_sym___noinline__] = ACTIONS(2259),
    [anon_sym_extern] = ACTIONS(2259),
    [anon_sym___attribute__] = ACTIONS(2259),
    [anon_sym_COLON_COLON] = ACTIONS(2261),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2261),
    [anon_sym___declspec] = ACTIONS(2259),
    [anon_sym___based] = ACTIONS(2259),
    [anon_sym_signed] = ACTIONS(2259),
    [anon_sym_unsigned] = ACTIONS(2259),
    [anon_sym_long] = ACTIONS(2259),
    [anon_sym_short] = ACTIONS(2259),
    [anon_sym_LBRACK] = ACTIONS(2259),
    [anon_sym_static] = ACTIONS(2259),
    [anon_sym_register] = ACTIONS(2259),
    [anon_sym_inline] = ACTIONS(2259),
    [anon_sym___inline] = ACTIONS(2259),
    [anon_sym___inline__] = ACTIONS(2259),
    [anon_sym___forceinline] = ACTIONS(2259),
    [anon_sym_thread_local] = ACTIONS(2259),
    [anon_sym___thread] = ACTIONS(2259),
    [anon_sym_const] = ACTIONS(2259),
    [anon_sym_constexpr] = ACTIONS(2259),
    [anon_sym_volatile] = ACTIONS(2259),
    [anon_sym_restrict] = ACTIONS(2259),
    [anon_sym___restrict__] = ACTIONS(2259),
    [anon_sym__Atomic] = ACTIONS(2259),
    [anon_sym__Noreturn] = ACTIONS(2259),
    [anon_sym_noreturn] = ACTIONS(2259),
    [anon_sym_mutable] = ACTIONS(2259),
    [anon_sym_constinit] = ACTIONS(2259),
    [anon_sym_consteval] = ACTIONS(2259),
    [anon_sym___shared__] = ACTIONS(2259),
    [anon_sym___local__] = ACTIONS(2259),
    [anon_sym___constant__] = ACTIONS(2259),
    [anon_sym___managed__] = ACTIONS(2259),
    [anon_sym___grid_constant__] = ACTIONS(2259),
    [anon_sym_alignas] = ACTIONS(2259),
    [anon_sym__Alignas] = ACTIONS(2259),
    [sym_primitive_type] = ACTIONS(2259),
    [anon_sym_enum] = ACTIONS(2259),
    [anon_sym_class] = ACTIONS(2259),
    [anon_sym_struct] = ACTIONS(2259),
    [anon_sym_union] = ACTIONS(2259),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2259),
    [anon_sym_decltype] = ACTIONS(2259),
    [sym_virtual] = ACTIONS(2259),
    [anon_sym_explicit] = ACTIONS(2259),
    [anon_sym_typename] = ACTIONS(2259),
    [anon_sym_template] = ACTIONS(2259),
    [anon_sym_operator] = ACTIONS(2259),
    [anon_sym_friend] = ACTIONS(2259),
    [anon_sym_public] = ACTIONS(2259),
    [anon_sym_private] = ACTIONS(2259),
    [anon_sym_protected] = ACTIONS(2259),
    [anon_sym_using] = ACTIONS(2259),
    [anon_sym_static_assert] = ACTIONS(2259),
    [anon_sym___launch_bounds__] = ACTIONS(2259),
  },
  [1964] = {
    [sym_identifier] = ACTIONS(2239),
    [aux_sym_preproc_def_token1] = ACTIONS(2239),
    [aux_sym_preproc_if_token1] = ACTIONS(2239),
    [aux_sym_preproc_if_token2] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2239),
    [sym_preproc_directive] = ACTIONS(2239),
    [anon_sym_LPAREN2] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym___extension__] = ACTIONS(2239),
    [anon_sym_typedef] = ACTIONS(2239),
    [anon_sym___device__] = ACTIONS(2239),
    [anon_sym___host__] = ACTIONS(2239),
    [anon_sym___global__] = ACTIONS(2239),
    [anon_sym___forceinline__] = ACTIONS(2239),
    [anon_sym___noinline__] = ACTIONS(2239),
    [anon_sym_extern] = ACTIONS(2239),
    [anon_sym___attribute__] = ACTIONS(2239),
    [anon_sym_COLON_COLON] = ACTIONS(2241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2241),
    [anon_sym___declspec] = ACTIONS(2239),
    [anon_sym___based] = ACTIONS(2239),
    [anon_sym_signed] = ACTIONS(2239),
    [anon_sym_unsigned] = ACTIONS(2239),
    [anon_sym_long] = ACTIONS(2239),
    [anon_sym_short] = ACTIONS(2239),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_static] = ACTIONS(2239),
    [anon_sym_register] = ACTIONS(2239),
    [anon_sym_inline] = ACTIONS(2239),
    [anon_sym___inline] = ACTIONS(2239),
    [anon_sym___inline__] = ACTIONS(2239),
    [anon_sym___forceinline] = ACTIONS(2239),
    [anon_sym_thread_local] = ACTIONS(2239),
    [anon_sym___thread] = ACTIONS(2239),
    [anon_sym_const] = ACTIONS(2239),
    [anon_sym_constexpr] = ACTIONS(2239),
    [anon_sym_volatile] = ACTIONS(2239),
    [anon_sym_restrict] = ACTIONS(2239),
    [anon_sym___restrict__] = ACTIONS(2239),
    [anon_sym__Atomic] = ACTIONS(2239),
    [anon_sym__Noreturn] = ACTIONS(2239),
    [anon_sym_noreturn] = ACTIONS(2239),
    [anon_sym_mutable] = ACTIONS(2239),
    [anon_sym_constinit] = ACTIONS(2239),
    [anon_sym_consteval] = ACTIONS(2239),
    [anon_sym___shared__] = ACTIONS(2239),
    [anon_sym___local__] = ACTIONS(2239),
    [anon_sym___constant__] = ACTIONS(2239),
    [anon_sym___managed__] = ACTIONS(2239),
    [anon_sym___grid_constant__] = ACTIONS(2239),
    [anon_sym_alignas] = ACTIONS(2239),
    [anon_sym__Alignas] = ACTIONS(2239),
    [sym_primitive_type] = ACTIONS(2239),
    [anon_sym_enum] = ACTIONS(2239),
    [anon_sym_class] = ACTIONS(2239),
    [anon_sym_struct] = ACTIONS(2239),
    [anon_sym_union] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2239),
    [anon_sym_decltype] = ACTIONS(2239),
    [sym_virtual] = ACTIONS(2239),
    [anon_sym_explicit] = ACTIONS(2239),
    [anon_sym_typename] = ACTIONS(2239),
    [anon_sym_template] = ACTIONS(2239),
    [anon_sym_operator] = ACTIONS(2239),
    [anon_sym_friend] = ACTIONS(2239),
    [anon_sym_public] = ACTIONS(2239),
    [anon_sym_private] = ACTIONS(2239),
    [anon_sym_protected] = ACTIONS(2239),
    [anon_sym_using] = ACTIONS(2239),
    [anon_sym_static_assert] = ACTIONS(2239),
    [anon_sym___launch_bounds__] = ACTIONS(2239),
  },
  [1965] = {
    [sym_identifier] = ACTIONS(2356),
    [aux_sym_preproc_def_token1] = ACTIONS(2356),
    [aux_sym_preproc_if_token1] = ACTIONS(2356),
    [aux_sym_preproc_if_token2] = ACTIONS(2356),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2356),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2356),
    [sym_preproc_directive] = ACTIONS(2356),
    [anon_sym_LPAREN2] = ACTIONS(2358),
    [anon_sym_TILDE] = ACTIONS(2358),
    [anon_sym_STAR] = ACTIONS(2358),
    [anon_sym_AMP_AMP] = ACTIONS(2358),
    [anon_sym_AMP] = ACTIONS(2356),
    [anon_sym___extension__] = ACTIONS(2356),
    [anon_sym_typedef] = ACTIONS(2356),
    [anon_sym___device__] = ACTIONS(2356),
    [anon_sym___host__] = ACTIONS(2356),
    [anon_sym___global__] = ACTIONS(2356),
    [anon_sym___forceinline__] = ACTIONS(2356),
    [anon_sym___noinline__] = ACTIONS(2356),
    [anon_sym_extern] = ACTIONS(2356),
    [anon_sym___attribute__] = ACTIONS(2356),
    [anon_sym_COLON_COLON] = ACTIONS(2358),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2358),
    [anon_sym___declspec] = ACTIONS(2356),
    [anon_sym___based] = ACTIONS(2356),
    [anon_sym_signed] = ACTIONS(2356),
    [anon_sym_unsigned] = ACTIONS(2356),
    [anon_sym_long] = ACTIONS(2356),
    [anon_sym_short] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2356),
    [anon_sym_register] = ACTIONS(2356),
    [anon_sym_inline] = ACTIONS(2356),
    [anon_sym___inline] = ACTIONS(2356),
    [anon_sym___inline__] = ACTIONS(2356),
    [anon_sym___forceinline] = ACTIONS(2356),
    [anon_sym_thread_local] = ACTIONS(2356),
    [anon_sym___thread] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(2356),
    [anon_sym_constexpr] = ACTIONS(2356),
    [anon_sym_volatile] = ACTIONS(2356),
    [anon_sym_restrict] = ACTIONS(2356),
    [anon_sym___restrict__] = ACTIONS(2356),
    [anon_sym__Atomic] = ACTIONS(2356),
    [anon_sym__Noreturn] = ACTIONS(2356),
    [anon_sym_noreturn] = ACTIONS(2356),
    [anon_sym_mutable] = ACTIONS(2356),
    [anon_sym_constinit] = ACTIONS(2356),
    [anon_sym_consteval] = ACTIONS(2356),
    [anon_sym___shared__] = ACTIONS(2356),
    [anon_sym___local__] = ACTIONS(2356),
    [anon_sym___constant__] = ACTIONS(2356),
    [anon_sym___managed__] = ACTIONS(2356),
    [anon_sym___grid_constant__] = ACTIONS(2356),
    [anon_sym_alignas] = ACTIONS(2356),
    [anon_sym__Alignas] = ACTIONS(2356),
    [sym_primitive_type] = ACTIONS(2356),
    [anon_sym_enum] = ACTIONS(2356),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_struct] = ACTIONS(2356),
    [anon_sym_union] = ACTIONS(2356),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2356),
    [anon_sym_decltype] = ACTIONS(2356),
    [sym_virtual] = ACTIONS(2356),
    [anon_sym_explicit] = ACTIONS(2356),
    [anon_sym_typename] = ACTIONS(2356),
    [anon_sym_template] = ACTIONS(2356),
    [anon_sym_operator] = ACTIONS(2356),
    [anon_sym_friend] = ACTIONS(2356),
    [anon_sym_public] = ACTIONS(2356),
    [anon_sym_private] = ACTIONS(2356),
    [anon_sym_protected] = ACTIONS(2356),
    [anon_sym_using] = ACTIONS(2356),
    [anon_sym_static_assert] = ACTIONS(2356),
    [anon_sym___launch_bounds__] = ACTIONS(2356),
  },
  [1966] = {
    [sym_identifier] = ACTIONS(2504),
    [aux_sym_preproc_def_token1] = ACTIONS(2504),
    [aux_sym_preproc_if_token1] = ACTIONS(2504),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2504),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2504),
    [sym_preproc_directive] = ACTIONS(2504),
    [anon_sym_LPAREN2] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2506),
    [anon_sym_STAR] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2504),
    [anon_sym___extension__] = ACTIONS(2504),
    [anon_sym_typedef] = ACTIONS(2504),
    [anon_sym___device__] = ACTIONS(2504),
    [anon_sym___host__] = ACTIONS(2504),
    [anon_sym___global__] = ACTIONS(2504),
    [anon_sym___forceinline__] = ACTIONS(2504),
    [anon_sym___noinline__] = ACTIONS(2504),
    [anon_sym_extern] = ACTIONS(2504),
    [anon_sym___attribute__] = ACTIONS(2504),
    [anon_sym_COLON_COLON] = ACTIONS(2506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2506),
    [anon_sym___declspec] = ACTIONS(2504),
    [anon_sym___based] = ACTIONS(2504),
    [anon_sym_RBRACE] = ACTIONS(2506),
    [anon_sym_signed] = ACTIONS(2504),
    [anon_sym_unsigned] = ACTIONS(2504),
    [anon_sym_long] = ACTIONS(2504),
    [anon_sym_short] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(2504),
    [anon_sym_static] = ACTIONS(2504),
    [anon_sym_register] = ACTIONS(2504),
    [anon_sym_inline] = ACTIONS(2504),
    [anon_sym___inline] = ACTIONS(2504),
    [anon_sym___inline__] = ACTIONS(2504),
    [anon_sym___forceinline] = ACTIONS(2504),
    [anon_sym_thread_local] = ACTIONS(2504),
    [anon_sym___thread] = ACTIONS(2504),
    [anon_sym_const] = ACTIONS(2504),
    [anon_sym_constexpr] = ACTIONS(2504),
    [anon_sym_volatile] = ACTIONS(2504),
    [anon_sym_restrict] = ACTIONS(2504),
    [anon_sym___restrict__] = ACTIONS(2504),
    [anon_sym__Atomic] = ACTIONS(2504),
    [anon_sym__Noreturn] = ACTIONS(2504),
    [anon_sym_noreturn] = ACTIONS(2504),
    [anon_sym_mutable] = ACTIONS(2504),
    [anon_sym_constinit] = ACTIONS(2504),
    [anon_sym_consteval] = ACTIONS(2504),
    [anon_sym___shared__] = ACTIONS(2504),
    [anon_sym___local__] = ACTIONS(2504),
    [anon_sym___constant__] = ACTIONS(2504),
    [anon_sym___managed__] = ACTIONS(2504),
    [anon_sym___grid_constant__] = ACTIONS(2504),
    [anon_sym_alignas] = ACTIONS(2504),
    [anon_sym__Alignas] = ACTIONS(2504),
    [sym_primitive_type] = ACTIONS(2504),
    [anon_sym_enum] = ACTIONS(2504),
    [anon_sym_class] = ACTIONS(2504),
    [anon_sym_struct] = ACTIONS(2504),
    [anon_sym_union] = ACTIONS(2504),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2504),
    [anon_sym_decltype] = ACTIONS(2504),
    [sym_virtual] = ACTIONS(2504),
    [anon_sym_explicit] = ACTIONS(2504),
    [anon_sym_typename] = ACTIONS(2504),
    [anon_sym_template] = ACTIONS(2504),
    [anon_sym_operator] = ACTIONS(2504),
    [anon_sym_friend] = ACTIONS(2504),
    [anon_sym_public] = ACTIONS(2504),
    [anon_sym_private] = ACTIONS(2504),
    [anon_sym_protected] = ACTIONS(2504),
    [anon_sym_using] = ACTIONS(2504),
    [anon_sym_static_assert] = ACTIONS(2504),
    [anon_sym___launch_bounds__] = ACTIONS(2504),
  },
  [1967] = {
    [sym_identifier] = ACTIONS(2366),
    [aux_sym_preproc_def_token1] = ACTIONS(2366),
    [aux_sym_preproc_if_token1] = ACTIONS(2366),
    [aux_sym_preproc_if_token2] = ACTIONS(2366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2366),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2366),
    [sym_preproc_directive] = ACTIONS(2366),
    [anon_sym_LPAREN2] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(2368),
    [anon_sym_STAR] = ACTIONS(2368),
    [anon_sym_AMP_AMP] = ACTIONS(2368),
    [anon_sym_AMP] = ACTIONS(2366),
    [anon_sym___extension__] = ACTIONS(2366),
    [anon_sym_typedef] = ACTIONS(2366),
    [anon_sym___device__] = ACTIONS(2366),
    [anon_sym___host__] = ACTIONS(2366),
    [anon_sym___global__] = ACTIONS(2366),
    [anon_sym___forceinline__] = ACTIONS(2366),
    [anon_sym___noinline__] = ACTIONS(2366),
    [anon_sym_extern] = ACTIONS(2366),
    [anon_sym___attribute__] = ACTIONS(2366),
    [anon_sym_COLON_COLON] = ACTIONS(2368),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2368),
    [anon_sym___declspec] = ACTIONS(2366),
    [anon_sym___based] = ACTIONS(2366),
    [anon_sym_signed] = ACTIONS(2366),
    [anon_sym_unsigned] = ACTIONS(2366),
    [anon_sym_long] = ACTIONS(2366),
    [anon_sym_short] = ACTIONS(2366),
    [anon_sym_LBRACK] = ACTIONS(2366),
    [anon_sym_static] = ACTIONS(2366),
    [anon_sym_register] = ACTIONS(2366),
    [anon_sym_inline] = ACTIONS(2366),
    [anon_sym___inline] = ACTIONS(2366),
    [anon_sym___inline__] = ACTIONS(2366),
    [anon_sym___forceinline] = ACTIONS(2366),
    [anon_sym_thread_local] = ACTIONS(2366),
    [anon_sym___thread] = ACTIONS(2366),
    [anon_sym_const] = ACTIONS(2366),
    [anon_sym_constexpr] = ACTIONS(2366),
    [anon_sym_volatile] = ACTIONS(2366),
    [anon_sym_restrict] = ACTIONS(2366),
    [anon_sym___restrict__] = ACTIONS(2366),
    [anon_sym__Atomic] = ACTIONS(2366),
    [anon_sym__Noreturn] = ACTIONS(2366),
    [anon_sym_noreturn] = ACTIONS(2366),
    [anon_sym_mutable] = ACTIONS(2366),
    [anon_sym_constinit] = ACTIONS(2366),
    [anon_sym_consteval] = ACTIONS(2366),
    [anon_sym___shared__] = ACTIONS(2366),
    [anon_sym___local__] = ACTIONS(2366),
    [anon_sym___constant__] = ACTIONS(2366),
    [anon_sym___managed__] = ACTIONS(2366),
    [anon_sym___grid_constant__] = ACTIONS(2366),
    [anon_sym_alignas] = ACTIONS(2366),
    [anon_sym__Alignas] = ACTIONS(2366),
    [sym_primitive_type] = ACTIONS(2366),
    [anon_sym_enum] = ACTIONS(2366),
    [anon_sym_class] = ACTIONS(2366),
    [anon_sym_struct] = ACTIONS(2366),
    [anon_sym_union] = ACTIONS(2366),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2366),
    [anon_sym_decltype] = ACTIONS(2366),
    [sym_virtual] = ACTIONS(2366),
    [anon_sym_explicit] = ACTIONS(2366),
    [anon_sym_typename] = ACTIONS(2366),
    [anon_sym_template] = ACTIONS(2366),
    [anon_sym_operator] = ACTIONS(2366),
    [anon_sym_friend] = ACTIONS(2366),
    [anon_sym_public] = ACTIONS(2366),
    [anon_sym_private] = ACTIONS(2366),
    [anon_sym_protected] = ACTIONS(2366),
    [anon_sym_using] = ACTIONS(2366),
    [anon_sym_static_assert] = ACTIONS(2366),
    [anon_sym___launch_bounds__] = ACTIONS(2366),
  },
  [1968] = {
    [sym_identifier] = ACTIONS(2370),
    [aux_sym_preproc_def_token1] = ACTIONS(2370),
    [aux_sym_preproc_if_token1] = ACTIONS(2370),
    [aux_sym_preproc_if_token2] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2370),
    [sym_preproc_directive] = ACTIONS(2370),
    [anon_sym_LPAREN2] = ACTIONS(2372),
    [anon_sym_TILDE] = ACTIONS(2372),
    [anon_sym_STAR] = ACTIONS(2372),
    [anon_sym_AMP_AMP] = ACTIONS(2372),
    [anon_sym_AMP] = ACTIONS(2370),
    [anon_sym___extension__] = ACTIONS(2370),
    [anon_sym_typedef] = ACTIONS(2370),
    [anon_sym___device__] = ACTIONS(2370),
    [anon_sym___host__] = ACTIONS(2370),
    [anon_sym___global__] = ACTIONS(2370),
    [anon_sym___forceinline__] = ACTIONS(2370),
    [anon_sym___noinline__] = ACTIONS(2370),
    [anon_sym_extern] = ACTIONS(2370),
    [anon_sym___attribute__] = ACTIONS(2370),
    [anon_sym_COLON_COLON] = ACTIONS(2372),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2372),
    [anon_sym___declspec] = ACTIONS(2370),
    [anon_sym___based] = ACTIONS(2370),
    [anon_sym_signed] = ACTIONS(2370),
    [anon_sym_unsigned] = ACTIONS(2370),
    [anon_sym_long] = ACTIONS(2370),
    [anon_sym_short] = ACTIONS(2370),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_static] = ACTIONS(2370),
    [anon_sym_register] = ACTIONS(2370),
    [anon_sym_inline] = ACTIONS(2370),
    [anon_sym___inline] = ACTIONS(2370),
    [anon_sym___inline__] = ACTIONS(2370),
    [anon_sym___forceinline] = ACTIONS(2370),
    [anon_sym_thread_local] = ACTIONS(2370),
    [anon_sym___thread] = ACTIONS(2370),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_constexpr] = ACTIONS(2370),
    [anon_sym_volatile] = ACTIONS(2370),
    [anon_sym_restrict] = ACTIONS(2370),
    [anon_sym___restrict__] = ACTIONS(2370),
    [anon_sym__Atomic] = ACTIONS(2370),
    [anon_sym__Noreturn] = ACTIONS(2370),
    [anon_sym_noreturn] = ACTIONS(2370),
    [anon_sym_mutable] = ACTIONS(2370),
    [anon_sym_constinit] = ACTIONS(2370),
    [anon_sym_consteval] = ACTIONS(2370),
    [anon_sym___shared__] = ACTIONS(2370),
    [anon_sym___local__] = ACTIONS(2370),
    [anon_sym___constant__] = ACTIONS(2370),
    [anon_sym___managed__] = ACTIONS(2370),
    [anon_sym___grid_constant__] = ACTIONS(2370),
    [anon_sym_alignas] = ACTIONS(2370),
    [anon_sym__Alignas] = ACTIONS(2370),
    [sym_primitive_type] = ACTIONS(2370),
    [anon_sym_enum] = ACTIONS(2370),
    [anon_sym_class] = ACTIONS(2370),
    [anon_sym_struct] = ACTIONS(2370),
    [anon_sym_union] = ACTIONS(2370),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2370),
    [anon_sym_decltype] = ACTIONS(2370),
    [sym_virtual] = ACTIONS(2370),
    [anon_sym_explicit] = ACTIONS(2370),
    [anon_sym_typename] = ACTIONS(2370),
    [anon_sym_template] = ACTIONS(2370),
    [anon_sym_operator] = ACTIONS(2370),
    [anon_sym_friend] = ACTIONS(2370),
    [anon_sym_public] = ACTIONS(2370),
    [anon_sym_private] = ACTIONS(2370),
    [anon_sym_protected] = ACTIONS(2370),
    [anon_sym_using] = ACTIONS(2370),
    [anon_sym_static_assert] = ACTIONS(2370),
    [anon_sym___launch_bounds__] = ACTIONS(2370),
  },
  [1969] = {
    [sym_identifier] = ACTIONS(2180),
    [aux_sym_preproc_def_token1] = ACTIONS(2180),
    [aux_sym_preproc_if_token1] = ACTIONS(2180),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2180),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2180),
    [sym_preproc_directive] = ACTIONS(2180),
    [anon_sym_LPAREN2] = ACTIONS(2182),
    [anon_sym_TILDE] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(2182),
    [anon_sym_AMP_AMP] = ACTIONS(2182),
    [anon_sym_AMP] = ACTIONS(2180),
    [anon_sym___extension__] = ACTIONS(2180),
    [anon_sym_typedef] = ACTIONS(2180),
    [anon_sym___device__] = ACTIONS(2180),
    [anon_sym___host__] = ACTIONS(2180),
    [anon_sym___global__] = ACTIONS(2180),
    [anon_sym___forceinline__] = ACTIONS(2180),
    [anon_sym___noinline__] = ACTIONS(2180),
    [anon_sym_extern] = ACTIONS(2180),
    [anon_sym___attribute__] = ACTIONS(2180),
    [anon_sym_COLON_COLON] = ACTIONS(2182),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2182),
    [anon_sym___declspec] = ACTIONS(2180),
    [anon_sym___based] = ACTIONS(2180),
    [anon_sym_RBRACE] = ACTIONS(2182),
    [anon_sym_signed] = ACTIONS(2180),
    [anon_sym_unsigned] = ACTIONS(2180),
    [anon_sym_long] = ACTIONS(2180),
    [anon_sym_short] = ACTIONS(2180),
    [anon_sym_LBRACK] = ACTIONS(2180),
    [anon_sym_static] = ACTIONS(2180),
    [anon_sym_register] = ACTIONS(2180),
    [anon_sym_inline] = ACTIONS(2180),
    [anon_sym___inline] = ACTIONS(2180),
    [anon_sym___inline__] = ACTIONS(2180),
    [anon_sym___forceinline] = ACTIONS(2180),
    [anon_sym_thread_local] = ACTIONS(2180),
    [anon_sym___thread] = ACTIONS(2180),
    [anon_sym_const] = ACTIONS(2180),
    [anon_sym_constexpr] = ACTIONS(2180),
    [anon_sym_volatile] = ACTIONS(2180),
    [anon_sym_restrict] = ACTIONS(2180),
    [anon_sym___restrict__] = ACTIONS(2180),
    [anon_sym__Atomic] = ACTIONS(2180),
    [anon_sym__Noreturn] = ACTIONS(2180),
    [anon_sym_noreturn] = ACTIONS(2180),
    [anon_sym_mutable] = ACTIONS(2180),
    [anon_sym_constinit] = ACTIONS(2180),
    [anon_sym_consteval] = ACTIONS(2180),
    [anon_sym___shared__] = ACTIONS(2180),
    [anon_sym___local__] = ACTIONS(2180),
    [anon_sym___constant__] = ACTIONS(2180),
    [anon_sym___managed__] = ACTIONS(2180),
    [anon_sym___grid_constant__] = ACTIONS(2180),
    [anon_sym_alignas] = ACTIONS(2180),
    [anon_sym__Alignas] = ACTIONS(2180),
    [sym_primitive_type] = ACTIONS(2180),
    [anon_sym_enum] = ACTIONS(2180),
    [anon_sym_class] = ACTIONS(2180),
    [anon_sym_struct] = ACTIONS(2180),
    [anon_sym_union] = ACTIONS(2180),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2180),
    [anon_sym_decltype] = ACTIONS(2180),
    [sym_virtual] = ACTIONS(2180),
    [anon_sym_explicit] = ACTIONS(2180),
    [anon_sym_typename] = ACTIONS(2180),
    [anon_sym_template] = ACTIONS(2180),
    [anon_sym_operator] = ACTIONS(2180),
    [anon_sym_friend] = ACTIONS(2180),
    [anon_sym_public] = ACTIONS(2180),
    [anon_sym_private] = ACTIONS(2180),
    [anon_sym_protected] = ACTIONS(2180),
    [anon_sym_using] = ACTIONS(2180),
    [anon_sym_static_assert] = ACTIONS(2180),
    [anon_sym___launch_bounds__] = ACTIONS(2180),
  },
  [1970] = {
    [sym_identifier] = ACTIONS(5039),
    [aux_sym_preproc_def_token1] = ACTIONS(5039),
    [aux_sym_preproc_if_token1] = ACTIONS(5039),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5039),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5039),
    [sym_preproc_directive] = ACTIONS(5039),
    [anon_sym_LPAREN2] = ACTIONS(5041),
    [anon_sym_TILDE] = ACTIONS(5041),
    [anon_sym_STAR] = ACTIONS(5041),
    [anon_sym_AMP_AMP] = ACTIONS(5041),
    [anon_sym_AMP] = ACTIONS(5039),
    [anon_sym___extension__] = ACTIONS(5039),
    [anon_sym_typedef] = ACTIONS(5039),
    [anon_sym___device__] = ACTIONS(5039),
    [anon_sym___host__] = ACTIONS(5039),
    [anon_sym___global__] = ACTIONS(5039),
    [anon_sym___forceinline__] = ACTIONS(5039),
    [anon_sym___noinline__] = ACTIONS(5039),
    [anon_sym_extern] = ACTIONS(5039),
    [anon_sym___attribute__] = ACTIONS(5039),
    [anon_sym_COLON_COLON] = ACTIONS(5041),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5041),
    [anon_sym___declspec] = ACTIONS(5039),
    [anon_sym___based] = ACTIONS(5039),
    [anon_sym_RBRACE] = ACTIONS(5041),
    [anon_sym_signed] = ACTIONS(5039),
    [anon_sym_unsigned] = ACTIONS(5039),
    [anon_sym_long] = ACTIONS(5039),
    [anon_sym_short] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(5039),
    [anon_sym_static] = ACTIONS(5039),
    [anon_sym_register] = ACTIONS(5039),
    [anon_sym_inline] = ACTIONS(5039),
    [anon_sym___inline] = ACTIONS(5039),
    [anon_sym___inline__] = ACTIONS(5039),
    [anon_sym___forceinline] = ACTIONS(5039),
    [anon_sym_thread_local] = ACTIONS(5039),
    [anon_sym___thread] = ACTIONS(5039),
    [anon_sym_const] = ACTIONS(5039),
    [anon_sym_constexpr] = ACTIONS(5039),
    [anon_sym_volatile] = ACTIONS(5039),
    [anon_sym_restrict] = ACTIONS(5039),
    [anon_sym___restrict__] = ACTIONS(5039),
    [anon_sym__Atomic] = ACTIONS(5039),
    [anon_sym__Noreturn] = ACTIONS(5039),
    [anon_sym_noreturn] = ACTIONS(5039),
    [anon_sym_mutable] = ACTIONS(5039),
    [anon_sym_constinit] = ACTIONS(5039),
    [anon_sym_consteval] = ACTIONS(5039),
    [anon_sym___shared__] = ACTIONS(5039),
    [anon_sym___local__] = ACTIONS(5039),
    [anon_sym___constant__] = ACTIONS(5039),
    [anon_sym___managed__] = ACTIONS(5039),
    [anon_sym___grid_constant__] = ACTIONS(5039),
    [anon_sym_alignas] = ACTIONS(5039),
    [anon_sym__Alignas] = ACTIONS(5039),
    [sym_primitive_type] = ACTIONS(5039),
    [anon_sym_enum] = ACTIONS(5039),
    [anon_sym_class] = ACTIONS(5039),
    [anon_sym_struct] = ACTIONS(5039),
    [anon_sym_union] = ACTIONS(5039),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5039),
    [anon_sym_decltype] = ACTIONS(5039),
    [sym_virtual] = ACTIONS(5039),
    [anon_sym_explicit] = ACTIONS(5039),
    [anon_sym_typename] = ACTIONS(5039),
    [anon_sym_template] = ACTIONS(5039),
    [anon_sym_operator] = ACTIONS(5039),
    [anon_sym_friend] = ACTIONS(5039),
    [anon_sym_public] = ACTIONS(5039),
    [anon_sym_private] = ACTIONS(5039),
    [anon_sym_protected] = ACTIONS(5039),
    [anon_sym_using] = ACTIONS(5039),
    [anon_sym_static_assert] = ACTIONS(5039),
    [anon_sym___launch_bounds__] = ACTIONS(5039),
  },
  [1971] = {
    [sym_identifier] = ACTIONS(2370),
    [aux_sym_preproc_def_token1] = ACTIONS(2370),
    [aux_sym_preproc_if_token1] = ACTIONS(2370),
    [aux_sym_preproc_if_token2] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2370),
    [sym_preproc_directive] = ACTIONS(2370),
    [anon_sym_LPAREN2] = ACTIONS(2372),
    [anon_sym_TILDE] = ACTIONS(2372),
    [anon_sym_STAR] = ACTIONS(2372),
    [anon_sym_AMP_AMP] = ACTIONS(2372),
    [anon_sym_AMP] = ACTIONS(2370),
    [anon_sym___extension__] = ACTIONS(2370),
    [anon_sym_typedef] = ACTIONS(2370),
    [anon_sym___device__] = ACTIONS(2370),
    [anon_sym___host__] = ACTIONS(2370),
    [anon_sym___global__] = ACTIONS(2370),
    [anon_sym___forceinline__] = ACTIONS(2370),
    [anon_sym___noinline__] = ACTIONS(2370),
    [anon_sym_extern] = ACTIONS(2370),
    [anon_sym___attribute__] = ACTIONS(2370),
    [anon_sym_COLON_COLON] = ACTIONS(2372),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2372),
    [anon_sym___declspec] = ACTIONS(2370),
    [anon_sym___based] = ACTIONS(2370),
    [anon_sym_signed] = ACTIONS(2370),
    [anon_sym_unsigned] = ACTIONS(2370),
    [anon_sym_long] = ACTIONS(2370),
    [anon_sym_short] = ACTIONS(2370),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_static] = ACTIONS(2370),
    [anon_sym_register] = ACTIONS(2370),
    [anon_sym_inline] = ACTIONS(2370),
    [anon_sym___inline] = ACTIONS(2370),
    [anon_sym___inline__] = ACTIONS(2370),
    [anon_sym___forceinline] = ACTIONS(2370),
    [anon_sym_thread_local] = ACTIONS(2370),
    [anon_sym___thread] = ACTIONS(2370),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_constexpr] = ACTIONS(2370),
    [anon_sym_volatile] = ACTIONS(2370),
    [anon_sym_restrict] = ACTIONS(2370),
    [anon_sym___restrict__] = ACTIONS(2370),
    [anon_sym__Atomic] = ACTIONS(2370),
    [anon_sym__Noreturn] = ACTIONS(2370),
    [anon_sym_noreturn] = ACTIONS(2370),
    [anon_sym_mutable] = ACTIONS(2370),
    [anon_sym_constinit] = ACTIONS(2370),
    [anon_sym_consteval] = ACTIONS(2370),
    [anon_sym___shared__] = ACTIONS(2370),
    [anon_sym___local__] = ACTIONS(2370),
    [anon_sym___constant__] = ACTIONS(2370),
    [anon_sym___managed__] = ACTIONS(2370),
    [anon_sym___grid_constant__] = ACTIONS(2370),
    [anon_sym_alignas] = ACTIONS(2370),
    [anon_sym__Alignas] = ACTIONS(2370),
    [sym_primitive_type] = ACTIONS(2370),
    [anon_sym_enum] = ACTIONS(2370),
    [anon_sym_class] = ACTIONS(2370),
    [anon_sym_struct] = ACTIONS(2370),
    [anon_sym_union] = ACTIONS(2370),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2370),
    [anon_sym_decltype] = ACTIONS(2370),
    [sym_virtual] = ACTIONS(2370),
    [anon_sym_explicit] = ACTIONS(2370),
    [anon_sym_typename] = ACTIONS(2370),
    [anon_sym_template] = ACTIONS(2370),
    [anon_sym_operator] = ACTIONS(2370),
    [anon_sym_friend] = ACTIONS(2370),
    [anon_sym_public] = ACTIONS(2370),
    [anon_sym_private] = ACTIONS(2370),
    [anon_sym_protected] = ACTIONS(2370),
    [anon_sym_using] = ACTIONS(2370),
    [anon_sym_static_assert] = ACTIONS(2370),
    [anon_sym___launch_bounds__] = ACTIONS(2370),
  },
  [1972] = {
    [sym_identifier] = ACTIONS(5179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5181),
    [anon_sym_COMMA] = ACTIONS(5181),
    [anon_sym_RPAREN] = ACTIONS(5181),
    [anon_sym_LPAREN2] = ACTIONS(5181),
    [anon_sym_DASH] = ACTIONS(5179),
    [anon_sym_PLUS] = ACTIONS(5179),
    [anon_sym_STAR] = ACTIONS(5181),
    [anon_sym_SLASH] = ACTIONS(5179),
    [anon_sym_PERCENT] = ACTIONS(5181),
    [anon_sym_PIPE_PIPE] = ACTIONS(5181),
    [anon_sym_AMP_AMP] = ACTIONS(5181),
    [anon_sym_PIPE] = ACTIONS(5179),
    [anon_sym_CARET] = ACTIONS(5181),
    [anon_sym_AMP] = ACTIONS(5179),
    [anon_sym_EQ_EQ] = ACTIONS(5181),
    [anon_sym_BANG_EQ] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5179),
    [anon_sym_GT_EQ] = ACTIONS(5181),
    [anon_sym_LT_EQ] = ACTIONS(5179),
    [anon_sym_LT] = ACTIONS(5179),
    [anon_sym_LT_LT] = ACTIONS(5179),
    [anon_sym_GT_GT] = ACTIONS(5181),
    [anon_sym_SEMI] = ACTIONS(5181),
    [anon_sym___extension__] = ACTIONS(5179),
    [anon_sym___global__] = ACTIONS(5179),
    [anon_sym___attribute__] = ACTIONS(5179),
    [anon_sym___based] = ACTIONS(5179),
    [anon_sym_LBRACE] = ACTIONS(5181),
    [anon_sym_RBRACE] = ACTIONS(5181),
    [anon_sym_signed] = ACTIONS(5179),
    [anon_sym_unsigned] = ACTIONS(5179),
    [anon_sym_long] = ACTIONS(5179),
    [anon_sym_short] = ACTIONS(5179),
    [anon_sym_LBRACK] = ACTIONS(5181),
    [anon_sym_RBRACK] = ACTIONS(5181),
    [anon_sym_const] = ACTIONS(5179),
    [anon_sym_constexpr] = ACTIONS(5179),
    [anon_sym_volatile] = ACTIONS(5179),
    [anon_sym_restrict] = ACTIONS(5179),
    [anon_sym___restrict__] = ACTIONS(5179),
    [anon_sym__Atomic] = ACTIONS(5179),
    [anon_sym__Noreturn] = ACTIONS(5179),
    [anon_sym_noreturn] = ACTIONS(5179),
    [anon_sym_mutable] = ACTIONS(5179),
    [anon_sym_constinit] = ACTIONS(5179),
    [anon_sym_consteval] = ACTIONS(5179),
    [anon_sym___shared__] = ACTIONS(5179),
    [anon_sym___local__] = ACTIONS(5179),
    [anon_sym___constant__] = ACTIONS(5179),
    [anon_sym___managed__] = ACTIONS(5179),
    [anon_sym___grid_constant__] = ACTIONS(5179),
    [anon_sym_alignas] = ACTIONS(5179),
    [anon_sym__Alignas] = ACTIONS(5179),
    [sym_primitive_type] = ACTIONS(5179),
    [anon_sym_COLON] = ACTIONS(5181),
    [anon_sym_QMARK] = ACTIONS(5181),
    [anon_sym_LT_EQ_GT] = ACTIONS(5181),
    [anon_sym_or] = ACTIONS(5179),
    [anon_sym_and] = ACTIONS(5179),
    [anon_sym_bitor] = ACTIONS(5179),
    [anon_sym_xor] = ACTIONS(5179),
    [anon_sym_bitand] = ACTIONS(5179),
    [anon_sym_not_eq] = ACTIONS(5179),
    [anon_sym_DASH_DASH] = ACTIONS(5181),
    [anon_sym_PLUS_PLUS] = ACTIONS(5181),
    [anon_sym_DOT] = ACTIONS(5179),
    [anon_sym_DOT_STAR] = ACTIONS(5181),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5179),
    [anon_sym_decltype] = ACTIONS(5179),
    [anon_sym_final] = ACTIONS(5179),
    [anon_sym_override] = ACTIONS(5179),
    [anon_sym_requires] = ACTIONS(5179),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5181),
  },
  [1973] = {
    [sym_identifier] = ACTIONS(2203),
    [aux_sym_preproc_def_token1] = ACTIONS(2203),
    [aux_sym_preproc_if_token1] = ACTIONS(2203),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2203),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2203),
    [sym_preproc_directive] = ACTIONS(2203),
    [anon_sym_LPAREN2] = ACTIONS(2205),
    [anon_sym_TILDE] = ACTIONS(2205),
    [anon_sym_STAR] = ACTIONS(2205),
    [anon_sym_AMP_AMP] = ACTIONS(2205),
    [anon_sym_AMP] = ACTIONS(2203),
    [anon_sym___extension__] = ACTIONS(2203),
    [anon_sym_typedef] = ACTIONS(2203),
    [anon_sym___device__] = ACTIONS(2203),
    [anon_sym___host__] = ACTIONS(2203),
    [anon_sym___global__] = ACTIONS(2203),
    [anon_sym___forceinline__] = ACTIONS(2203),
    [anon_sym___noinline__] = ACTIONS(2203),
    [anon_sym_extern] = ACTIONS(2203),
    [anon_sym___attribute__] = ACTIONS(2203),
    [anon_sym_COLON_COLON] = ACTIONS(2205),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2205),
    [anon_sym___declspec] = ACTIONS(2203),
    [anon_sym___based] = ACTIONS(2203),
    [anon_sym_RBRACE] = ACTIONS(2205),
    [anon_sym_signed] = ACTIONS(2203),
    [anon_sym_unsigned] = ACTIONS(2203),
    [anon_sym_long] = ACTIONS(2203),
    [anon_sym_short] = ACTIONS(2203),
    [anon_sym_LBRACK] = ACTIONS(2203),
    [anon_sym_static] = ACTIONS(2203),
    [anon_sym_register] = ACTIONS(2203),
    [anon_sym_inline] = ACTIONS(2203),
    [anon_sym___inline] = ACTIONS(2203),
    [anon_sym___inline__] = ACTIONS(2203),
    [anon_sym___forceinline] = ACTIONS(2203),
    [anon_sym_thread_local] = ACTIONS(2203),
    [anon_sym___thread] = ACTIONS(2203),
    [anon_sym_const] = ACTIONS(2203),
    [anon_sym_constexpr] = ACTIONS(2203),
    [anon_sym_volatile] = ACTIONS(2203),
    [anon_sym_restrict] = ACTIONS(2203),
    [anon_sym___restrict__] = ACTIONS(2203),
    [anon_sym__Atomic] = ACTIONS(2203),
    [anon_sym__Noreturn] = ACTIONS(2203),
    [anon_sym_noreturn] = ACTIONS(2203),
    [anon_sym_mutable] = ACTIONS(2203),
    [anon_sym_constinit] = ACTIONS(2203),
    [anon_sym_consteval] = ACTIONS(2203),
    [anon_sym___shared__] = ACTIONS(2203),
    [anon_sym___local__] = ACTIONS(2203),
    [anon_sym___constant__] = ACTIONS(2203),
    [anon_sym___managed__] = ACTIONS(2203),
    [anon_sym___grid_constant__] = ACTIONS(2203),
    [anon_sym_alignas] = ACTIONS(2203),
    [anon_sym__Alignas] = ACTIONS(2203),
    [sym_primitive_type] = ACTIONS(2203),
    [anon_sym_enum] = ACTIONS(2203),
    [anon_sym_class] = ACTIONS(2203),
    [anon_sym_struct] = ACTIONS(2203),
    [anon_sym_union] = ACTIONS(2203),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2203),
    [anon_sym_decltype] = ACTIONS(2203),
    [sym_virtual] = ACTIONS(2203),
    [anon_sym_explicit] = ACTIONS(2203),
    [anon_sym_typename] = ACTIONS(2203),
    [anon_sym_template] = ACTIONS(2203),
    [anon_sym_operator] = ACTIONS(2203),
    [anon_sym_friend] = ACTIONS(2203),
    [anon_sym_public] = ACTIONS(2203),
    [anon_sym_private] = ACTIONS(2203),
    [anon_sym_protected] = ACTIONS(2203),
    [anon_sym_using] = ACTIONS(2203),
    [anon_sym_static_assert] = ACTIONS(2203),
    [anon_sym___launch_bounds__] = ACTIONS(2203),
  },
  [1974] = {
    [sym_identifier] = ACTIONS(2154),
    [aux_sym_preproc_def_token1] = ACTIONS(2154),
    [aux_sym_preproc_if_token1] = ACTIONS(2154),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2154),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2154),
    [sym_preproc_directive] = ACTIONS(2154),
    [anon_sym_LPAREN2] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2156),
    [anon_sym_STAR] = ACTIONS(2156),
    [anon_sym_AMP_AMP] = ACTIONS(2156),
    [anon_sym_AMP] = ACTIONS(2154),
    [anon_sym___extension__] = ACTIONS(2154),
    [anon_sym_typedef] = ACTIONS(2154),
    [anon_sym___device__] = ACTIONS(2154),
    [anon_sym___host__] = ACTIONS(2154),
    [anon_sym___global__] = ACTIONS(2154),
    [anon_sym___forceinline__] = ACTIONS(2154),
    [anon_sym___noinline__] = ACTIONS(2154),
    [anon_sym_extern] = ACTIONS(2154),
    [anon_sym___attribute__] = ACTIONS(2154),
    [anon_sym_COLON_COLON] = ACTIONS(2156),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2156),
    [anon_sym___declspec] = ACTIONS(2154),
    [anon_sym___based] = ACTIONS(2154),
    [anon_sym_RBRACE] = ACTIONS(2156),
    [anon_sym_signed] = ACTIONS(2154),
    [anon_sym_unsigned] = ACTIONS(2154),
    [anon_sym_long] = ACTIONS(2154),
    [anon_sym_short] = ACTIONS(2154),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_static] = ACTIONS(2154),
    [anon_sym_register] = ACTIONS(2154),
    [anon_sym_inline] = ACTIONS(2154),
    [anon_sym___inline] = ACTIONS(2154),
    [anon_sym___inline__] = ACTIONS(2154),
    [anon_sym___forceinline] = ACTIONS(2154),
    [anon_sym_thread_local] = ACTIONS(2154),
    [anon_sym___thread] = ACTIONS(2154),
    [anon_sym_const] = ACTIONS(2154),
    [anon_sym_constexpr] = ACTIONS(2154),
    [anon_sym_volatile] = ACTIONS(2154),
    [anon_sym_restrict] = ACTIONS(2154),
    [anon_sym___restrict__] = ACTIONS(2154),
    [anon_sym__Atomic] = ACTIONS(2154),
    [anon_sym__Noreturn] = ACTIONS(2154),
    [anon_sym_noreturn] = ACTIONS(2154),
    [anon_sym_mutable] = ACTIONS(2154),
    [anon_sym_constinit] = ACTIONS(2154),
    [anon_sym_consteval] = ACTIONS(2154),
    [anon_sym___shared__] = ACTIONS(2154),
    [anon_sym___local__] = ACTIONS(2154),
    [anon_sym___constant__] = ACTIONS(2154),
    [anon_sym___managed__] = ACTIONS(2154),
    [anon_sym___grid_constant__] = ACTIONS(2154),
    [anon_sym_alignas] = ACTIONS(2154),
    [anon_sym__Alignas] = ACTIONS(2154),
    [sym_primitive_type] = ACTIONS(2154),
    [anon_sym_enum] = ACTIONS(2154),
    [anon_sym_class] = ACTIONS(2154),
    [anon_sym_struct] = ACTIONS(2154),
    [anon_sym_union] = ACTIONS(2154),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2154),
    [anon_sym_decltype] = ACTIONS(2154),
    [sym_virtual] = ACTIONS(2154),
    [anon_sym_explicit] = ACTIONS(2154),
    [anon_sym_typename] = ACTIONS(2154),
    [anon_sym_template] = ACTIONS(2154),
    [anon_sym_operator] = ACTIONS(2154),
    [anon_sym_friend] = ACTIONS(2154),
    [anon_sym_public] = ACTIONS(2154),
    [anon_sym_private] = ACTIONS(2154),
    [anon_sym_protected] = ACTIONS(2154),
    [anon_sym_using] = ACTIONS(2154),
    [anon_sym_static_assert] = ACTIONS(2154),
    [anon_sym___launch_bounds__] = ACTIONS(2154),
  },
  [1975] = {
    [sym_identifier] = ACTIONS(1942),
    [aux_sym_preproc_def_token1] = ACTIONS(1942),
    [aux_sym_preproc_if_token1] = ACTIONS(1942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1942),
    [sym_preproc_directive] = ACTIONS(1942),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_TILDE] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym___extension__] = ACTIONS(1942),
    [anon_sym_typedef] = ACTIONS(1942),
    [anon_sym___device__] = ACTIONS(1942),
    [anon_sym___host__] = ACTIONS(1942),
    [anon_sym___global__] = ACTIONS(1942),
    [anon_sym___forceinline__] = ACTIONS(1942),
    [anon_sym___noinline__] = ACTIONS(1942),
    [anon_sym_extern] = ACTIONS(1942),
    [anon_sym___attribute__] = ACTIONS(1942),
    [anon_sym_COLON_COLON] = ACTIONS(1944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1944),
    [anon_sym___declspec] = ACTIONS(1942),
    [anon_sym___based] = ACTIONS(1942),
    [anon_sym_RBRACE] = ACTIONS(1944),
    [anon_sym_signed] = ACTIONS(1942),
    [anon_sym_unsigned] = ACTIONS(1942),
    [anon_sym_long] = ACTIONS(1942),
    [anon_sym_short] = ACTIONS(1942),
    [anon_sym_LBRACK] = ACTIONS(1942),
    [anon_sym_static] = ACTIONS(1942),
    [anon_sym_register] = ACTIONS(1942),
    [anon_sym_inline] = ACTIONS(1942),
    [anon_sym___inline] = ACTIONS(1942),
    [anon_sym___inline__] = ACTIONS(1942),
    [anon_sym___forceinline] = ACTIONS(1942),
    [anon_sym_thread_local] = ACTIONS(1942),
    [anon_sym___thread] = ACTIONS(1942),
    [anon_sym_const] = ACTIONS(1942),
    [anon_sym_constexpr] = ACTIONS(1942),
    [anon_sym_volatile] = ACTIONS(1942),
    [anon_sym_restrict] = ACTIONS(1942),
    [anon_sym___restrict__] = ACTIONS(1942),
    [anon_sym__Atomic] = ACTIONS(1942),
    [anon_sym__Noreturn] = ACTIONS(1942),
    [anon_sym_noreturn] = ACTIONS(1942),
    [anon_sym_mutable] = ACTIONS(1942),
    [anon_sym_constinit] = ACTIONS(1942),
    [anon_sym_consteval] = ACTIONS(1942),
    [anon_sym___shared__] = ACTIONS(1942),
    [anon_sym___local__] = ACTIONS(1942),
    [anon_sym___constant__] = ACTIONS(1942),
    [anon_sym___managed__] = ACTIONS(1942),
    [anon_sym___grid_constant__] = ACTIONS(1942),
    [anon_sym_alignas] = ACTIONS(1942),
    [anon_sym__Alignas] = ACTIONS(1942),
    [sym_primitive_type] = ACTIONS(1942),
    [anon_sym_enum] = ACTIONS(1942),
    [anon_sym_class] = ACTIONS(1942),
    [anon_sym_struct] = ACTIONS(1942),
    [anon_sym_union] = ACTIONS(1942),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1942),
    [anon_sym_decltype] = ACTIONS(1942),
    [sym_virtual] = ACTIONS(1942),
    [anon_sym_explicit] = ACTIONS(1942),
    [anon_sym_typename] = ACTIONS(1942),
    [anon_sym_template] = ACTIONS(1942),
    [anon_sym_operator] = ACTIONS(1942),
    [anon_sym_friend] = ACTIONS(1942),
    [anon_sym_public] = ACTIONS(1942),
    [anon_sym_private] = ACTIONS(1942),
    [anon_sym_protected] = ACTIONS(1942),
    [anon_sym_using] = ACTIONS(1942),
    [anon_sym_static_assert] = ACTIONS(1942),
    [anon_sym___launch_bounds__] = ACTIONS(1942),
  },
  [1976] = {
    [sym_identifier] = ACTIONS(2384),
    [aux_sym_preproc_def_token1] = ACTIONS(2384),
    [aux_sym_preproc_if_token1] = ACTIONS(2384),
    [aux_sym_preproc_if_token2] = ACTIONS(2384),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2384),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2384),
    [sym_preproc_directive] = ACTIONS(2384),
    [anon_sym_LPAREN2] = ACTIONS(2386),
    [anon_sym_TILDE] = ACTIONS(2386),
    [anon_sym_STAR] = ACTIONS(2386),
    [anon_sym_AMP_AMP] = ACTIONS(2386),
    [anon_sym_AMP] = ACTIONS(2384),
    [anon_sym___extension__] = ACTIONS(2384),
    [anon_sym_typedef] = ACTIONS(2384),
    [anon_sym___device__] = ACTIONS(2384),
    [anon_sym___host__] = ACTIONS(2384),
    [anon_sym___global__] = ACTIONS(2384),
    [anon_sym___forceinline__] = ACTIONS(2384),
    [anon_sym___noinline__] = ACTIONS(2384),
    [anon_sym_extern] = ACTIONS(2384),
    [anon_sym___attribute__] = ACTIONS(2384),
    [anon_sym_COLON_COLON] = ACTIONS(2386),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2386),
    [anon_sym___declspec] = ACTIONS(2384),
    [anon_sym___based] = ACTIONS(2384),
    [anon_sym_signed] = ACTIONS(2384),
    [anon_sym_unsigned] = ACTIONS(2384),
    [anon_sym_long] = ACTIONS(2384),
    [anon_sym_short] = ACTIONS(2384),
    [anon_sym_LBRACK] = ACTIONS(2384),
    [anon_sym_static] = ACTIONS(2384),
    [anon_sym_register] = ACTIONS(2384),
    [anon_sym_inline] = ACTIONS(2384),
    [anon_sym___inline] = ACTIONS(2384),
    [anon_sym___inline__] = ACTIONS(2384),
    [anon_sym___forceinline] = ACTIONS(2384),
    [anon_sym_thread_local] = ACTIONS(2384),
    [anon_sym___thread] = ACTIONS(2384),
    [anon_sym_const] = ACTIONS(2384),
    [anon_sym_constexpr] = ACTIONS(2384),
    [anon_sym_volatile] = ACTIONS(2384),
    [anon_sym_restrict] = ACTIONS(2384),
    [anon_sym___restrict__] = ACTIONS(2384),
    [anon_sym__Atomic] = ACTIONS(2384),
    [anon_sym__Noreturn] = ACTIONS(2384),
    [anon_sym_noreturn] = ACTIONS(2384),
    [anon_sym_mutable] = ACTIONS(2384),
    [anon_sym_constinit] = ACTIONS(2384),
    [anon_sym_consteval] = ACTIONS(2384),
    [anon_sym___shared__] = ACTIONS(2384),
    [anon_sym___local__] = ACTIONS(2384),
    [anon_sym___constant__] = ACTIONS(2384),
    [anon_sym___managed__] = ACTIONS(2384),
    [anon_sym___grid_constant__] = ACTIONS(2384),
    [anon_sym_alignas] = ACTIONS(2384),
    [anon_sym__Alignas] = ACTIONS(2384),
    [sym_primitive_type] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2384),
    [anon_sym_class] = ACTIONS(2384),
    [anon_sym_struct] = ACTIONS(2384),
    [anon_sym_union] = ACTIONS(2384),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2384),
    [anon_sym_decltype] = ACTIONS(2384),
    [sym_virtual] = ACTIONS(2384),
    [anon_sym_explicit] = ACTIONS(2384),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(2384),
    [anon_sym_operator] = ACTIONS(2384),
    [anon_sym_friend] = ACTIONS(2384),
    [anon_sym_public] = ACTIONS(2384),
    [anon_sym_private] = ACTIONS(2384),
    [anon_sym_protected] = ACTIONS(2384),
    [anon_sym_using] = ACTIONS(2384),
    [anon_sym_static_assert] = ACTIONS(2384),
    [anon_sym___launch_bounds__] = ACTIONS(2384),
  },
  [1977] = {
    [sym_identifier] = ACTIONS(2384),
    [aux_sym_preproc_def_token1] = ACTIONS(2384),
    [aux_sym_preproc_if_token1] = ACTIONS(2384),
    [aux_sym_preproc_if_token2] = ACTIONS(2384),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2384),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2384),
    [sym_preproc_directive] = ACTIONS(2384),
    [anon_sym_LPAREN2] = ACTIONS(2386),
    [anon_sym_TILDE] = ACTIONS(2386),
    [anon_sym_STAR] = ACTIONS(2386),
    [anon_sym_AMP_AMP] = ACTIONS(2386),
    [anon_sym_AMP] = ACTIONS(2384),
    [anon_sym___extension__] = ACTIONS(2384),
    [anon_sym_typedef] = ACTIONS(2384),
    [anon_sym___device__] = ACTIONS(2384),
    [anon_sym___host__] = ACTIONS(2384),
    [anon_sym___global__] = ACTIONS(2384),
    [anon_sym___forceinline__] = ACTIONS(2384),
    [anon_sym___noinline__] = ACTIONS(2384),
    [anon_sym_extern] = ACTIONS(2384),
    [anon_sym___attribute__] = ACTIONS(2384),
    [anon_sym_COLON_COLON] = ACTIONS(2386),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2386),
    [anon_sym___declspec] = ACTIONS(2384),
    [anon_sym___based] = ACTIONS(2384),
    [anon_sym_signed] = ACTIONS(2384),
    [anon_sym_unsigned] = ACTIONS(2384),
    [anon_sym_long] = ACTIONS(2384),
    [anon_sym_short] = ACTIONS(2384),
    [anon_sym_LBRACK] = ACTIONS(2384),
    [anon_sym_static] = ACTIONS(2384),
    [anon_sym_register] = ACTIONS(2384),
    [anon_sym_inline] = ACTIONS(2384),
    [anon_sym___inline] = ACTIONS(2384),
    [anon_sym___inline__] = ACTIONS(2384),
    [anon_sym___forceinline] = ACTIONS(2384),
    [anon_sym_thread_local] = ACTIONS(2384),
    [anon_sym___thread] = ACTIONS(2384),
    [anon_sym_const] = ACTIONS(2384),
    [anon_sym_constexpr] = ACTIONS(2384),
    [anon_sym_volatile] = ACTIONS(2384),
    [anon_sym_restrict] = ACTIONS(2384),
    [anon_sym___restrict__] = ACTIONS(2384),
    [anon_sym__Atomic] = ACTIONS(2384),
    [anon_sym__Noreturn] = ACTIONS(2384),
    [anon_sym_noreturn] = ACTIONS(2384),
    [anon_sym_mutable] = ACTIONS(2384),
    [anon_sym_constinit] = ACTIONS(2384),
    [anon_sym_consteval] = ACTIONS(2384),
    [anon_sym___shared__] = ACTIONS(2384),
    [anon_sym___local__] = ACTIONS(2384),
    [anon_sym___constant__] = ACTIONS(2384),
    [anon_sym___managed__] = ACTIONS(2384),
    [anon_sym___grid_constant__] = ACTIONS(2384),
    [anon_sym_alignas] = ACTIONS(2384),
    [anon_sym__Alignas] = ACTIONS(2384),
    [sym_primitive_type] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2384),
    [anon_sym_class] = ACTIONS(2384),
    [anon_sym_struct] = ACTIONS(2384),
    [anon_sym_union] = ACTIONS(2384),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2384),
    [anon_sym_decltype] = ACTIONS(2384),
    [sym_virtual] = ACTIONS(2384),
    [anon_sym_explicit] = ACTIONS(2384),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(2384),
    [anon_sym_operator] = ACTIONS(2384),
    [anon_sym_friend] = ACTIONS(2384),
    [anon_sym_public] = ACTIONS(2384),
    [anon_sym_private] = ACTIONS(2384),
    [anon_sym_protected] = ACTIONS(2384),
    [anon_sym_using] = ACTIONS(2384),
    [anon_sym_static_assert] = ACTIONS(2384),
    [anon_sym___launch_bounds__] = ACTIONS(2384),
  },
  [1978] = {
    [sym_identifier] = ACTIONS(2388),
    [aux_sym_preproc_def_token1] = ACTIONS(2388),
    [aux_sym_preproc_if_token1] = ACTIONS(2388),
    [aux_sym_preproc_if_token2] = ACTIONS(2388),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2388),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2388),
    [sym_preproc_directive] = ACTIONS(2388),
    [anon_sym_LPAREN2] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [anon_sym_STAR] = ACTIONS(2390),
    [anon_sym_AMP_AMP] = ACTIONS(2390),
    [anon_sym_AMP] = ACTIONS(2388),
    [anon_sym___extension__] = ACTIONS(2388),
    [anon_sym_typedef] = ACTIONS(2388),
    [anon_sym___device__] = ACTIONS(2388),
    [anon_sym___host__] = ACTIONS(2388),
    [anon_sym___global__] = ACTIONS(2388),
    [anon_sym___forceinline__] = ACTIONS(2388),
    [anon_sym___noinline__] = ACTIONS(2388),
    [anon_sym_extern] = ACTIONS(2388),
    [anon_sym___attribute__] = ACTIONS(2388),
    [anon_sym_COLON_COLON] = ACTIONS(2390),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2390),
    [anon_sym___declspec] = ACTIONS(2388),
    [anon_sym___based] = ACTIONS(2388),
    [anon_sym_signed] = ACTIONS(2388),
    [anon_sym_unsigned] = ACTIONS(2388),
    [anon_sym_long] = ACTIONS(2388),
    [anon_sym_short] = ACTIONS(2388),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [anon_sym_static] = ACTIONS(2388),
    [anon_sym_register] = ACTIONS(2388),
    [anon_sym_inline] = ACTIONS(2388),
    [anon_sym___inline] = ACTIONS(2388),
    [anon_sym___inline__] = ACTIONS(2388),
    [anon_sym___forceinline] = ACTIONS(2388),
    [anon_sym_thread_local] = ACTIONS(2388),
    [anon_sym___thread] = ACTIONS(2388),
    [anon_sym_const] = ACTIONS(2388),
    [anon_sym_constexpr] = ACTIONS(2388),
    [anon_sym_volatile] = ACTIONS(2388),
    [anon_sym_restrict] = ACTIONS(2388),
    [anon_sym___restrict__] = ACTIONS(2388),
    [anon_sym__Atomic] = ACTIONS(2388),
    [anon_sym__Noreturn] = ACTIONS(2388),
    [anon_sym_noreturn] = ACTIONS(2388),
    [anon_sym_mutable] = ACTIONS(2388),
    [anon_sym_constinit] = ACTIONS(2388),
    [anon_sym_consteval] = ACTIONS(2388),
    [anon_sym___shared__] = ACTIONS(2388),
    [anon_sym___local__] = ACTIONS(2388),
    [anon_sym___constant__] = ACTIONS(2388),
    [anon_sym___managed__] = ACTIONS(2388),
    [anon_sym___grid_constant__] = ACTIONS(2388),
    [anon_sym_alignas] = ACTIONS(2388),
    [anon_sym__Alignas] = ACTIONS(2388),
    [sym_primitive_type] = ACTIONS(2388),
    [anon_sym_enum] = ACTIONS(2388),
    [anon_sym_class] = ACTIONS(2388),
    [anon_sym_struct] = ACTIONS(2388),
    [anon_sym_union] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2388),
    [anon_sym_decltype] = ACTIONS(2388),
    [sym_virtual] = ACTIONS(2388),
    [anon_sym_explicit] = ACTIONS(2388),
    [anon_sym_typename] = ACTIONS(2388),
    [anon_sym_template] = ACTIONS(2388),
    [anon_sym_operator] = ACTIONS(2388),
    [anon_sym_friend] = ACTIONS(2388),
    [anon_sym_public] = ACTIONS(2388),
    [anon_sym_private] = ACTIONS(2388),
    [anon_sym_protected] = ACTIONS(2388),
    [anon_sym_using] = ACTIONS(2388),
    [anon_sym_static_assert] = ACTIONS(2388),
    [anon_sym___launch_bounds__] = ACTIONS(2388),
  },
  [1979] = {
    [sym_identifier] = ACTIONS(2392),
    [aux_sym_preproc_def_token1] = ACTIONS(2392),
    [aux_sym_preproc_if_token1] = ACTIONS(2392),
    [aux_sym_preproc_if_token2] = ACTIONS(2392),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2392),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2392),
    [sym_preproc_directive] = ACTIONS(2392),
    [anon_sym_LPAREN2] = ACTIONS(2394),
    [anon_sym_TILDE] = ACTIONS(2394),
    [anon_sym_STAR] = ACTIONS(2394),
    [anon_sym_AMP_AMP] = ACTIONS(2394),
    [anon_sym_AMP] = ACTIONS(2392),
    [anon_sym___extension__] = ACTIONS(2392),
    [anon_sym_typedef] = ACTIONS(2392),
    [anon_sym___device__] = ACTIONS(2392),
    [anon_sym___host__] = ACTIONS(2392),
    [anon_sym___global__] = ACTIONS(2392),
    [anon_sym___forceinline__] = ACTIONS(2392),
    [anon_sym___noinline__] = ACTIONS(2392),
    [anon_sym_extern] = ACTIONS(2392),
    [anon_sym___attribute__] = ACTIONS(2392),
    [anon_sym_COLON_COLON] = ACTIONS(2394),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2394),
    [anon_sym___declspec] = ACTIONS(2392),
    [anon_sym___based] = ACTIONS(2392),
    [anon_sym_signed] = ACTIONS(2392),
    [anon_sym_unsigned] = ACTIONS(2392),
    [anon_sym_long] = ACTIONS(2392),
    [anon_sym_short] = ACTIONS(2392),
    [anon_sym_LBRACK] = ACTIONS(2392),
    [anon_sym_static] = ACTIONS(2392),
    [anon_sym_register] = ACTIONS(2392),
    [anon_sym_inline] = ACTIONS(2392),
    [anon_sym___inline] = ACTIONS(2392),
    [anon_sym___inline__] = ACTIONS(2392),
    [anon_sym___forceinline] = ACTIONS(2392),
    [anon_sym_thread_local] = ACTIONS(2392),
    [anon_sym___thread] = ACTIONS(2392),
    [anon_sym_const] = ACTIONS(2392),
    [anon_sym_constexpr] = ACTIONS(2392),
    [anon_sym_volatile] = ACTIONS(2392),
    [anon_sym_restrict] = ACTIONS(2392),
    [anon_sym___restrict__] = ACTIONS(2392),
    [anon_sym__Atomic] = ACTIONS(2392),
    [anon_sym__Noreturn] = ACTIONS(2392),
    [anon_sym_noreturn] = ACTIONS(2392),
    [anon_sym_mutable] = ACTIONS(2392),
    [anon_sym_constinit] = ACTIONS(2392),
    [anon_sym_consteval] = ACTIONS(2392),
    [anon_sym___shared__] = ACTIONS(2392),
    [anon_sym___local__] = ACTIONS(2392),
    [anon_sym___constant__] = ACTIONS(2392),
    [anon_sym___managed__] = ACTIONS(2392),
    [anon_sym___grid_constant__] = ACTIONS(2392),
    [anon_sym_alignas] = ACTIONS(2392),
    [anon_sym__Alignas] = ACTIONS(2392),
    [sym_primitive_type] = ACTIONS(2392),
    [anon_sym_enum] = ACTIONS(2392),
    [anon_sym_class] = ACTIONS(2392),
    [anon_sym_struct] = ACTIONS(2392),
    [anon_sym_union] = ACTIONS(2392),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2392),
    [anon_sym_decltype] = ACTIONS(2392),
    [sym_virtual] = ACTIONS(2392),
    [anon_sym_explicit] = ACTIONS(2392),
    [anon_sym_typename] = ACTIONS(2392),
    [anon_sym_template] = ACTIONS(2392),
    [anon_sym_operator] = ACTIONS(2392),
    [anon_sym_friend] = ACTIONS(2392),
    [anon_sym_public] = ACTIONS(2392),
    [anon_sym_private] = ACTIONS(2392),
    [anon_sym_protected] = ACTIONS(2392),
    [anon_sym_using] = ACTIONS(2392),
    [anon_sym_static_assert] = ACTIONS(2392),
    [anon_sym___launch_bounds__] = ACTIONS(2392),
  },
  [1980] = {
    [sym_identifier] = ACTIONS(2396),
    [aux_sym_preproc_def_token1] = ACTIONS(2396),
    [aux_sym_preproc_if_token1] = ACTIONS(2396),
    [aux_sym_preproc_if_token2] = ACTIONS(2396),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2396),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2396),
    [sym_preproc_directive] = ACTIONS(2396),
    [anon_sym_LPAREN2] = ACTIONS(2398),
    [anon_sym_TILDE] = ACTIONS(2398),
    [anon_sym_STAR] = ACTIONS(2398),
    [anon_sym_AMP_AMP] = ACTIONS(2398),
    [anon_sym_AMP] = ACTIONS(2396),
    [anon_sym___extension__] = ACTIONS(2396),
    [anon_sym_typedef] = ACTIONS(2396),
    [anon_sym___device__] = ACTIONS(2396),
    [anon_sym___host__] = ACTIONS(2396),
    [anon_sym___global__] = ACTIONS(2396),
    [anon_sym___forceinline__] = ACTIONS(2396),
    [anon_sym___noinline__] = ACTIONS(2396),
    [anon_sym_extern] = ACTIONS(2396),
    [anon_sym___attribute__] = ACTIONS(2396),
    [anon_sym_COLON_COLON] = ACTIONS(2398),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2398),
    [anon_sym___declspec] = ACTIONS(2396),
    [anon_sym___based] = ACTIONS(2396),
    [anon_sym_signed] = ACTIONS(2396),
    [anon_sym_unsigned] = ACTIONS(2396),
    [anon_sym_long] = ACTIONS(2396),
    [anon_sym_short] = ACTIONS(2396),
    [anon_sym_LBRACK] = ACTIONS(2396),
    [anon_sym_static] = ACTIONS(2396),
    [anon_sym_register] = ACTIONS(2396),
    [anon_sym_inline] = ACTIONS(2396),
    [anon_sym___inline] = ACTIONS(2396),
    [anon_sym___inline__] = ACTIONS(2396),
    [anon_sym___forceinline] = ACTIONS(2396),
    [anon_sym_thread_local] = ACTIONS(2396),
    [anon_sym___thread] = ACTIONS(2396),
    [anon_sym_const] = ACTIONS(2396),
    [anon_sym_constexpr] = ACTIONS(2396),
    [anon_sym_volatile] = ACTIONS(2396),
    [anon_sym_restrict] = ACTIONS(2396),
    [anon_sym___restrict__] = ACTIONS(2396),
    [anon_sym__Atomic] = ACTIONS(2396),
    [anon_sym__Noreturn] = ACTIONS(2396),
    [anon_sym_noreturn] = ACTIONS(2396),
    [anon_sym_mutable] = ACTIONS(2396),
    [anon_sym_constinit] = ACTIONS(2396),
    [anon_sym_consteval] = ACTIONS(2396),
    [anon_sym___shared__] = ACTIONS(2396),
    [anon_sym___local__] = ACTIONS(2396),
    [anon_sym___constant__] = ACTIONS(2396),
    [anon_sym___managed__] = ACTIONS(2396),
    [anon_sym___grid_constant__] = ACTIONS(2396),
    [anon_sym_alignas] = ACTIONS(2396),
    [anon_sym__Alignas] = ACTIONS(2396),
    [sym_primitive_type] = ACTIONS(2396),
    [anon_sym_enum] = ACTIONS(2396),
    [anon_sym_class] = ACTIONS(2396),
    [anon_sym_struct] = ACTIONS(2396),
    [anon_sym_union] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2396),
    [anon_sym_decltype] = ACTIONS(2396),
    [sym_virtual] = ACTIONS(2396),
    [anon_sym_explicit] = ACTIONS(2396),
    [anon_sym_typename] = ACTIONS(2396),
    [anon_sym_template] = ACTIONS(2396),
    [anon_sym_operator] = ACTIONS(2396),
    [anon_sym_friend] = ACTIONS(2396),
    [anon_sym_public] = ACTIONS(2396),
    [anon_sym_private] = ACTIONS(2396),
    [anon_sym_protected] = ACTIONS(2396),
    [anon_sym_using] = ACTIONS(2396),
    [anon_sym_static_assert] = ACTIONS(2396),
    [anon_sym___launch_bounds__] = ACTIONS(2396),
  },
  [1981] = {
    [sym_identifier] = ACTIONS(1942),
    [aux_sym_preproc_def_token1] = ACTIONS(1942),
    [aux_sym_preproc_if_token1] = ACTIONS(1942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1942),
    [sym_preproc_directive] = ACTIONS(1942),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_TILDE] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym___extension__] = ACTIONS(1942),
    [anon_sym_typedef] = ACTIONS(1942),
    [anon_sym___device__] = ACTIONS(1942),
    [anon_sym___host__] = ACTIONS(1942),
    [anon_sym___global__] = ACTIONS(1942),
    [anon_sym___forceinline__] = ACTIONS(1942),
    [anon_sym___noinline__] = ACTIONS(1942),
    [anon_sym_extern] = ACTIONS(1942),
    [anon_sym___attribute__] = ACTIONS(1942),
    [anon_sym_COLON_COLON] = ACTIONS(1944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1944),
    [anon_sym___declspec] = ACTIONS(1942),
    [anon_sym___based] = ACTIONS(1942),
    [anon_sym_RBRACE] = ACTIONS(1944),
    [anon_sym_signed] = ACTIONS(1942),
    [anon_sym_unsigned] = ACTIONS(1942),
    [anon_sym_long] = ACTIONS(1942),
    [anon_sym_short] = ACTIONS(1942),
    [anon_sym_LBRACK] = ACTIONS(1942),
    [anon_sym_static] = ACTIONS(1942),
    [anon_sym_register] = ACTIONS(1942),
    [anon_sym_inline] = ACTIONS(1942),
    [anon_sym___inline] = ACTIONS(1942),
    [anon_sym___inline__] = ACTIONS(1942),
    [anon_sym___forceinline] = ACTIONS(1942),
    [anon_sym_thread_local] = ACTIONS(1942),
    [anon_sym___thread] = ACTIONS(1942),
    [anon_sym_const] = ACTIONS(1942),
    [anon_sym_constexpr] = ACTIONS(1942),
    [anon_sym_volatile] = ACTIONS(1942),
    [anon_sym_restrict] = ACTIONS(1942),
    [anon_sym___restrict__] = ACTIONS(1942),
    [anon_sym__Atomic] = ACTIONS(1942),
    [anon_sym__Noreturn] = ACTIONS(1942),
    [anon_sym_noreturn] = ACTIONS(1942),
    [anon_sym_mutable] = ACTIONS(1942),
    [anon_sym_constinit] = ACTIONS(1942),
    [anon_sym_consteval] = ACTIONS(1942),
    [anon_sym___shared__] = ACTIONS(1942),
    [anon_sym___local__] = ACTIONS(1942),
    [anon_sym___constant__] = ACTIONS(1942),
    [anon_sym___managed__] = ACTIONS(1942),
    [anon_sym___grid_constant__] = ACTIONS(1942),
    [anon_sym_alignas] = ACTIONS(1942),
    [anon_sym__Alignas] = ACTIONS(1942),
    [sym_primitive_type] = ACTIONS(1942),
    [anon_sym_enum] = ACTIONS(1942),
    [anon_sym_class] = ACTIONS(1942),
    [anon_sym_struct] = ACTIONS(1942),
    [anon_sym_union] = ACTIONS(1942),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1942),
    [anon_sym_decltype] = ACTIONS(1942),
    [sym_virtual] = ACTIONS(1942),
    [anon_sym_explicit] = ACTIONS(1942),
    [anon_sym_typename] = ACTIONS(1942),
    [anon_sym_template] = ACTIONS(1942),
    [anon_sym_operator] = ACTIONS(1942),
    [anon_sym_friend] = ACTIONS(1942),
    [anon_sym_public] = ACTIONS(1942),
    [anon_sym_private] = ACTIONS(1942),
    [anon_sym_protected] = ACTIONS(1942),
    [anon_sym_using] = ACTIONS(1942),
    [anon_sym_static_assert] = ACTIONS(1942),
    [anon_sym___launch_bounds__] = ACTIONS(1942),
  },
  [1982] = {
    [sym_identifier] = ACTIONS(2461),
    [aux_sym_preproc_def_token1] = ACTIONS(2461),
    [aux_sym_preproc_if_token1] = ACTIONS(2461),
    [aux_sym_preproc_if_token2] = ACTIONS(2461),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2461),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2461),
    [sym_preproc_directive] = ACTIONS(2461),
    [anon_sym_LPAREN2] = ACTIONS(2463),
    [anon_sym_TILDE] = ACTIONS(2463),
    [anon_sym_STAR] = ACTIONS(2463),
    [anon_sym_AMP_AMP] = ACTIONS(2463),
    [anon_sym_AMP] = ACTIONS(2461),
    [anon_sym___extension__] = ACTIONS(2461),
    [anon_sym_typedef] = ACTIONS(2461),
    [anon_sym___device__] = ACTIONS(2461),
    [anon_sym___host__] = ACTIONS(2461),
    [anon_sym___global__] = ACTIONS(2461),
    [anon_sym___forceinline__] = ACTIONS(2461),
    [anon_sym___noinline__] = ACTIONS(2461),
    [anon_sym_extern] = ACTIONS(2461),
    [anon_sym___attribute__] = ACTIONS(2461),
    [anon_sym_COLON_COLON] = ACTIONS(2463),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2463),
    [anon_sym___declspec] = ACTIONS(2461),
    [anon_sym___based] = ACTIONS(2461),
    [anon_sym_signed] = ACTIONS(2461),
    [anon_sym_unsigned] = ACTIONS(2461),
    [anon_sym_long] = ACTIONS(2461),
    [anon_sym_short] = ACTIONS(2461),
    [anon_sym_LBRACK] = ACTIONS(2461),
    [anon_sym_static] = ACTIONS(2461),
    [anon_sym_register] = ACTIONS(2461),
    [anon_sym_inline] = ACTIONS(2461),
    [anon_sym___inline] = ACTIONS(2461),
    [anon_sym___inline__] = ACTIONS(2461),
    [anon_sym___forceinline] = ACTIONS(2461),
    [anon_sym_thread_local] = ACTIONS(2461),
    [anon_sym___thread] = ACTIONS(2461),
    [anon_sym_const] = ACTIONS(2461),
    [anon_sym_constexpr] = ACTIONS(2461),
    [anon_sym_volatile] = ACTIONS(2461),
    [anon_sym_restrict] = ACTIONS(2461),
    [anon_sym___restrict__] = ACTIONS(2461),
    [anon_sym__Atomic] = ACTIONS(2461),
    [anon_sym__Noreturn] = ACTIONS(2461),
    [anon_sym_noreturn] = ACTIONS(2461),
    [anon_sym_mutable] = ACTIONS(2461),
    [anon_sym_constinit] = ACTIONS(2461),
    [anon_sym_consteval] = ACTIONS(2461),
    [anon_sym___shared__] = ACTIONS(2461),
    [anon_sym___local__] = ACTIONS(2461),
    [anon_sym___constant__] = ACTIONS(2461),
    [anon_sym___managed__] = ACTIONS(2461),
    [anon_sym___grid_constant__] = ACTIONS(2461),
    [anon_sym_alignas] = ACTIONS(2461),
    [anon_sym__Alignas] = ACTIONS(2461),
    [sym_primitive_type] = ACTIONS(2461),
    [anon_sym_enum] = ACTIONS(2461),
    [anon_sym_class] = ACTIONS(2461),
    [anon_sym_struct] = ACTIONS(2461),
    [anon_sym_union] = ACTIONS(2461),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2461),
    [anon_sym_decltype] = ACTIONS(2461),
    [sym_virtual] = ACTIONS(2461),
    [anon_sym_explicit] = ACTIONS(2461),
    [anon_sym_typename] = ACTIONS(2461),
    [anon_sym_template] = ACTIONS(2461),
    [anon_sym_operator] = ACTIONS(2461),
    [anon_sym_friend] = ACTIONS(2461),
    [anon_sym_public] = ACTIONS(2461),
    [anon_sym_private] = ACTIONS(2461),
    [anon_sym_protected] = ACTIONS(2461),
    [anon_sym_using] = ACTIONS(2461),
    [anon_sym_static_assert] = ACTIONS(2461),
    [anon_sym___launch_bounds__] = ACTIONS(2461),
  },
  [1983] = {
    [sym_identifier] = ACTIONS(2461),
    [aux_sym_preproc_def_token1] = ACTIONS(2461),
    [aux_sym_preproc_if_token1] = ACTIONS(2461),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2461),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2461),
    [sym_preproc_directive] = ACTIONS(2461),
    [anon_sym_LPAREN2] = ACTIONS(2463),
    [anon_sym_TILDE] = ACTIONS(2463),
    [anon_sym_STAR] = ACTIONS(2463),
    [anon_sym_AMP_AMP] = ACTIONS(2463),
    [anon_sym_AMP] = ACTIONS(2461),
    [anon_sym___extension__] = ACTIONS(2461),
    [anon_sym_typedef] = ACTIONS(2461),
    [anon_sym___device__] = ACTIONS(2461),
    [anon_sym___host__] = ACTIONS(2461),
    [anon_sym___global__] = ACTIONS(2461),
    [anon_sym___forceinline__] = ACTIONS(2461),
    [anon_sym___noinline__] = ACTIONS(2461),
    [anon_sym_extern] = ACTIONS(2461),
    [anon_sym___attribute__] = ACTIONS(2461),
    [anon_sym_COLON_COLON] = ACTIONS(2463),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2463),
    [anon_sym___declspec] = ACTIONS(2461),
    [anon_sym___based] = ACTIONS(2461),
    [anon_sym_RBRACE] = ACTIONS(2463),
    [anon_sym_signed] = ACTIONS(2461),
    [anon_sym_unsigned] = ACTIONS(2461),
    [anon_sym_long] = ACTIONS(2461),
    [anon_sym_short] = ACTIONS(2461),
    [anon_sym_LBRACK] = ACTIONS(2461),
    [anon_sym_static] = ACTIONS(2461),
    [anon_sym_register] = ACTIONS(2461),
    [anon_sym_inline] = ACTIONS(2461),
    [anon_sym___inline] = ACTIONS(2461),
    [anon_sym___inline__] = ACTIONS(2461),
    [anon_sym___forceinline] = ACTIONS(2461),
    [anon_sym_thread_local] = ACTIONS(2461),
    [anon_sym___thread] = ACTIONS(2461),
    [anon_sym_const] = ACTIONS(2461),
    [anon_sym_constexpr] = ACTIONS(2461),
    [anon_sym_volatile] = ACTIONS(2461),
    [anon_sym_restrict] = ACTIONS(2461),
    [anon_sym___restrict__] = ACTIONS(2461),
    [anon_sym__Atomic] = ACTIONS(2461),
    [anon_sym__Noreturn] = ACTIONS(2461),
    [anon_sym_noreturn] = ACTIONS(2461),
    [anon_sym_mutable] = ACTIONS(2461),
    [anon_sym_constinit] = ACTIONS(2461),
    [anon_sym_consteval] = ACTIONS(2461),
    [anon_sym___shared__] = ACTIONS(2461),
    [anon_sym___local__] = ACTIONS(2461),
    [anon_sym___constant__] = ACTIONS(2461),
    [anon_sym___managed__] = ACTIONS(2461),
    [anon_sym___grid_constant__] = ACTIONS(2461),
    [anon_sym_alignas] = ACTIONS(2461),
    [anon_sym__Alignas] = ACTIONS(2461),
    [sym_primitive_type] = ACTIONS(2461),
    [anon_sym_enum] = ACTIONS(2461),
    [anon_sym_class] = ACTIONS(2461),
    [anon_sym_struct] = ACTIONS(2461),
    [anon_sym_union] = ACTIONS(2461),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2461),
    [anon_sym_decltype] = ACTIONS(2461),
    [sym_virtual] = ACTIONS(2461),
    [anon_sym_explicit] = ACTIONS(2461),
    [anon_sym_typename] = ACTIONS(2461),
    [anon_sym_template] = ACTIONS(2461),
    [anon_sym_operator] = ACTIONS(2461),
    [anon_sym_friend] = ACTIONS(2461),
    [anon_sym_public] = ACTIONS(2461),
    [anon_sym_private] = ACTIONS(2461),
    [anon_sym_protected] = ACTIONS(2461),
    [anon_sym_using] = ACTIONS(2461),
    [anon_sym_static_assert] = ACTIONS(2461),
    [anon_sym___launch_bounds__] = ACTIONS(2461),
  },
  [1984] = {
    [sym_identifier] = ACTIONS(2504),
    [aux_sym_preproc_def_token1] = ACTIONS(2504),
    [aux_sym_preproc_if_token1] = ACTIONS(2504),
    [aux_sym_preproc_if_token2] = ACTIONS(2504),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2504),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2504),
    [sym_preproc_directive] = ACTIONS(2504),
    [anon_sym_LPAREN2] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2506),
    [anon_sym_STAR] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2504),
    [anon_sym___extension__] = ACTIONS(2504),
    [anon_sym_typedef] = ACTIONS(2504),
    [anon_sym___device__] = ACTIONS(2504),
    [anon_sym___host__] = ACTIONS(2504),
    [anon_sym___global__] = ACTIONS(2504),
    [anon_sym___forceinline__] = ACTIONS(2504),
    [anon_sym___noinline__] = ACTIONS(2504),
    [anon_sym_extern] = ACTIONS(2504),
    [anon_sym___attribute__] = ACTIONS(2504),
    [anon_sym_COLON_COLON] = ACTIONS(2506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2506),
    [anon_sym___declspec] = ACTIONS(2504),
    [anon_sym___based] = ACTIONS(2504),
    [anon_sym_signed] = ACTIONS(2504),
    [anon_sym_unsigned] = ACTIONS(2504),
    [anon_sym_long] = ACTIONS(2504),
    [anon_sym_short] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(2504),
    [anon_sym_static] = ACTIONS(2504),
    [anon_sym_register] = ACTIONS(2504),
    [anon_sym_inline] = ACTIONS(2504),
    [anon_sym___inline] = ACTIONS(2504),
    [anon_sym___inline__] = ACTIONS(2504),
    [anon_sym___forceinline] = ACTIONS(2504),
    [anon_sym_thread_local] = ACTIONS(2504),
    [anon_sym___thread] = ACTIONS(2504),
    [anon_sym_const] = ACTIONS(2504),
    [anon_sym_constexpr] = ACTIONS(2504),
    [anon_sym_volatile] = ACTIONS(2504),
    [anon_sym_restrict] = ACTIONS(2504),
    [anon_sym___restrict__] = ACTIONS(2504),
    [anon_sym__Atomic] = ACTIONS(2504),
    [anon_sym__Noreturn] = ACTIONS(2504),
    [anon_sym_noreturn] = ACTIONS(2504),
    [anon_sym_mutable] = ACTIONS(2504),
    [anon_sym_constinit] = ACTIONS(2504),
    [anon_sym_consteval] = ACTIONS(2504),
    [anon_sym___shared__] = ACTIONS(2504),
    [anon_sym___local__] = ACTIONS(2504),
    [anon_sym___constant__] = ACTIONS(2504),
    [anon_sym___managed__] = ACTIONS(2504),
    [anon_sym___grid_constant__] = ACTIONS(2504),
    [anon_sym_alignas] = ACTIONS(2504),
    [anon_sym__Alignas] = ACTIONS(2504),
    [sym_primitive_type] = ACTIONS(2504),
    [anon_sym_enum] = ACTIONS(2504),
    [anon_sym_class] = ACTIONS(2504),
    [anon_sym_struct] = ACTIONS(2504),
    [anon_sym_union] = ACTIONS(2504),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2504),
    [anon_sym_decltype] = ACTIONS(2504),
    [sym_virtual] = ACTIONS(2504),
    [anon_sym_explicit] = ACTIONS(2504),
    [anon_sym_typename] = ACTIONS(2504),
    [anon_sym_template] = ACTIONS(2504),
    [anon_sym_operator] = ACTIONS(2504),
    [anon_sym_friend] = ACTIONS(2504),
    [anon_sym_public] = ACTIONS(2504),
    [anon_sym_private] = ACTIONS(2504),
    [anon_sym_protected] = ACTIONS(2504),
    [anon_sym_using] = ACTIONS(2504),
    [anon_sym_static_assert] = ACTIONS(2504),
    [anon_sym___launch_bounds__] = ACTIONS(2504),
  },
  [1985] = {
    [sym_identifier] = ACTIONS(2477),
    [aux_sym_preproc_def_token1] = ACTIONS(2477),
    [aux_sym_preproc_if_token1] = ACTIONS(2477),
    [aux_sym_preproc_if_token2] = ACTIONS(2477),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2477),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2477),
    [sym_preproc_directive] = ACTIONS(2477),
    [anon_sym_LPAREN2] = ACTIONS(2479),
    [anon_sym_TILDE] = ACTIONS(2479),
    [anon_sym_STAR] = ACTIONS(2479),
    [anon_sym_AMP_AMP] = ACTIONS(2479),
    [anon_sym_AMP] = ACTIONS(2477),
    [anon_sym___extension__] = ACTIONS(2477),
    [anon_sym_typedef] = ACTIONS(2477),
    [anon_sym___device__] = ACTIONS(2477),
    [anon_sym___host__] = ACTIONS(2477),
    [anon_sym___global__] = ACTIONS(2477),
    [anon_sym___forceinline__] = ACTIONS(2477),
    [anon_sym___noinline__] = ACTIONS(2477),
    [anon_sym_extern] = ACTIONS(2477),
    [anon_sym___attribute__] = ACTIONS(2477),
    [anon_sym_COLON_COLON] = ACTIONS(2479),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2479),
    [anon_sym___declspec] = ACTIONS(2477),
    [anon_sym___based] = ACTIONS(2477),
    [anon_sym_signed] = ACTIONS(2477),
    [anon_sym_unsigned] = ACTIONS(2477),
    [anon_sym_long] = ACTIONS(2477),
    [anon_sym_short] = ACTIONS(2477),
    [anon_sym_LBRACK] = ACTIONS(2477),
    [anon_sym_static] = ACTIONS(2477),
    [anon_sym_register] = ACTIONS(2477),
    [anon_sym_inline] = ACTIONS(2477),
    [anon_sym___inline] = ACTIONS(2477),
    [anon_sym___inline__] = ACTIONS(2477),
    [anon_sym___forceinline] = ACTIONS(2477),
    [anon_sym_thread_local] = ACTIONS(2477),
    [anon_sym___thread] = ACTIONS(2477),
    [anon_sym_const] = ACTIONS(2477),
    [anon_sym_constexpr] = ACTIONS(2477),
    [anon_sym_volatile] = ACTIONS(2477),
    [anon_sym_restrict] = ACTIONS(2477),
    [anon_sym___restrict__] = ACTIONS(2477),
    [anon_sym__Atomic] = ACTIONS(2477),
    [anon_sym__Noreturn] = ACTIONS(2477),
    [anon_sym_noreturn] = ACTIONS(2477),
    [anon_sym_mutable] = ACTIONS(2477),
    [anon_sym_constinit] = ACTIONS(2477),
    [anon_sym_consteval] = ACTIONS(2477),
    [anon_sym___shared__] = ACTIONS(2477),
    [anon_sym___local__] = ACTIONS(2477),
    [anon_sym___constant__] = ACTIONS(2477),
    [anon_sym___managed__] = ACTIONS(2477),
    [anon_sym___grid_constant__] = ACTIONS(2477),
    [anon_sym_alignas] = ACTIONS(2477),
    [anon_sym__Alignas] = ACTIONS(2477),
    [sym_primitive_type] = ACTIONS(2477),
    [anon_sym_enum] = ACTIONS(2477),
    [anon_sym_class] = ACTIONS(2477),
    [anon_sym_struct] = ACTIONS(2477),
    [anon_sym_union] = ACTIONS(2477),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2477),
    [anon_sym_decltype] = ACTIONS(2477),
    [sym_virtual] = ACTIONS(2477),
    [anon_sym_explicit] = ACTIONS(2477),
    [anon_sym_typename] = ACTIONS(2477),
    [anon_sym_template] = ACTIONS(2477),
    [anon_sym_operator] = ACTIONS(2477),
    [anon_sym_friend] = ACTIONS(2477),
    [anon_sym_public] = ACTIONS(2477),
    [anon_sym_private] = ACTIONS(2477),
    [anon_sym_protected] = ACTIONS(2477),
    [anon_sym_using] = ACTIONS(2477),
    [anon_sym_static_assert] = ACTIONS(2477),
    [anon_sym___launch_bounds__] = ACTIONS(2477),
  },
  [1986] = {
    [sym_identifier] = ACTIONS(2090),
    [aux_sym_preproc_def_token1] = ACTIONS(2090),
    [aux_sym_preproc_if_token1] = ACTIONS(2090),
    [aux_sym_preproc_if_token2] = ACTIONS(2090),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2090),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2090),
    [sym_preproc_directive] = ACTIONS(2090),
    [anon_sym_LPAREN2] = ACTIONS(2092),
    [anon_sym_TILDE] = ACTIONS(2092),
    [anon_sym_STAR] = ACTIONS(2092),
    [anon_sym_AMP_AMP] = ACTIONS(2092),
    [anon_sym_AMP] = ACTIONS(2090),
    [anon_sym___extension__] = ACTIONS(2090),
    [anon_sym_typedef] = ACTIONS(2090),
    [anon_sym___device__] = ACTIONS(2090),
    [anon_sym___host__] = ACTIONS(2090),
    [anon_sym___global__] = ACTIONS(2090),
    [anon_sym___forceinline__] = ACTIONS(2090),
    [anon_sym___noinline__] = ACTIONS(2090),
    [anon_sym_extern] = ACTIONS(2090),
    [anon_sym___attribute__] = ACTIONS(2090),
    [anon_sym_COLON_COLON] = ACTIONS(2092),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2092),
    [anon_sym___declspec] = ACTIONS(2090),
    [anon_sym___based] = ACTIONS(2090),
    [anon_sym_signed] = ACTIONS(2090),
    [anon_sym_unsigned] = ACTIONS(2090),
    [anon_sym_long] = ACTIONS(2090),
    [anon_sym_short] = ACTIONS(2090),
    [anon_sym_LBRACK] = ACTIONS(2090),
    [anon_sym_static] = ACTIONS(2090),
    [anon_sym_register] = ACTIONS(2090),
    [anon_sym_inline] = ACTIONS(2090),
    [anon_sym___inline] = ACTIONS(2090),
    [anon_sym___inline__] = ACTIONS(2090),
    [anon_sym___forceinline] = ACTIONS(2090),
    [anon_sym_thread_local] = ACTIONS(2090),
    [anon_sym___thread] = ACTIONS(2090),
    [anon_sym_const] = ACTIONS(2090),
    [anon_sym_constexpr] = ACTIONS(2090),
    [anon_sym_volatile] = ACTIONS(2090),
    [anon_sym_restrict] = ACTIONS(2090),
    [anon_sym___restrict__] = ACTIONS(2090),
    [anon_sym__Atomic] = ACTIONS(2090),
    [anon_sym__Noreturn] = ACTIONS(2090),
    [anon_sym_noreturn] = ACTIONS(2090),
    [anon_sym_mutable] = ACTIONS(2090),
    [anon_sym_constinit] = ACTIONS(2090),
    [anon_sym_consteval] = ACTIONS(2090),
    [anon_sym___shared__] = ACTIONS(2090),
    [anon_sym___local__] = ACTIONS(2090),
    [anon_sym___constant__] = ACTIONS(2090),
    [anon_sym___managed__] = ACTIONS(2090),
    [anon_sym___grid_constant__] = ACTIONS(2090),
    [anon_sym_alignas] = ACTIONS(2090),
    [anon_sym__Alignas] = ACTIONS(2090),
    [sym_primitive_type] = ACTIONS(2090),
    [anon_sym_enum] = ACTIONS(2090),
    [anon_sym_class] = ACTIONS(2090),
    [anon_sym_struct] = ACTIONS(2090),
    [anon_sym_union] = ACTIONS(2090),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2090),
    [anon_sym_decltype] = ACTIONS(2090),
    [sym_virtual] = ACTIONS(2090),
    [anon_sym_explicit] = ACTIONS(2090),
    [anon_sym_typename] = ACTIONS(2090),
    [anon_sym_template] = ACTIONS(2090),
    [anon_sym_operator] = ACTIONS(2090),
    [anon_sym_friend] = ACTIONS(2090),
    [anon_sym_public] = ACTIONS(2090),
    [anon_sym_private] = ACTIONS(2090),
    [anon_sym_protected] = ACTIONS(2090),
    [anon_sym_using] = ACTIONS(2090),
    [anon_sym_static_assert] = ACTIONS(2090),
    [anon_sym___launch_bounds__] = ACTIONS(2090),
  },
  [1987] = {
    [sym_identifier] = ACTIONS(2162),
    [aux_sym_preproc_def_token1] = ACTIONS(2162),
    [aux_sym_preproc_if_token1] = ACTIONS(2162),
    [aux_sym_preproc_if_token2] = ACTIONS(2162),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2162),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2162),
    [sym_preproc_directive] = ACTIONS(2162),
    [anon_sym_LPAREN2] = ACTIONS(2164),
    [anon_sym_TILDE] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(2164),
    [anon_sym_AMP_AMP] = ACTIONS(2164),
    [anon_sym_AMP] = ACTIONS(2162),
    [anon_sym___extension__] = ACTIONS(2162),
    [anon_sym_typedef] = ACTIONS(2162),
    [anon_sym___device__] = ACTIONS(2162),
    [anon_sym___host__] = ACTIONS(2162),
    [anon_sym___global__] = ACTIONS(2162),
    [anon_sym___forceinline__] = ACTIONS(2162),
    [anon_sym___noinline__] = ACTIONS(2162),
    [anon_sym_extern] = ACTIONS(2162),
    [anon_sym___attribute__] = ACTIONS(2162),
    [anon_sym_COLON_COLON] = ACTIONS(2164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2164),
    [anon_sym___declspec] = ACTIONS(2162),
    [anon_sym___based] = ACTIONS(2162),
    [anon_sym_signed] = ACTIONS(2162),
    [anon_sym_unsigned] = ACTIONS(2162),
    [anon_sym_long] = ACTIONS(2162),
    [anon_sym_short] = ACTIONS(2162),
    [anon_sym_LBRACK] = ACTIONS(2162),
    [anon_sym_static] = ACTIONS(2162),
    [anon_sym_register] = ACTIONS(2162),
    [anon_sym_inline] = ACTIONS(2162),
    [anon_sym___inline] = ACTIONS(2162),
    [anon_sym___inline__] = ACTIONS(2162),
    [anon_sym___forceinline] = ACTIONS(2162),
    [anon_sym_thread_local] = ACTIONS(2162),
    [anon_sym___thread] = ACTIONS(2162),
    [anon_sym_const] = ACTIONS(2162),
    [anon_sym_constexpr] = ACTIONS(2162),
    [anon_sym_volatile] = ACTIONS(2162),
    [anon_sym_restrict] = ACTIONS(2162),
    [anon_sym___restrict__] = ACTIONS(2162),
    [anon_sym__Atomic] = ACTIONS(2162),
    [anon_sym__Noreturn] = ACTIONS(2162),
    [anon_sym_noreturn] = ACTIONS(2162),
    [anon_sym_mutable] = ACTIONS(2162),
    [anon_sym_constinit] = ACTIONS(2162),
    [anon_sym_consteval] = ACTIONS(2162),
    [anon_sym___shared__] = ACTIONS(2162),
    [anon_sym___local__] = ACTIONS(2162),
    [anon_sym___constant__] = ACTIONS(2162),
    [anon_sym___managed__] = ACTIONS(2162),
    [anon_sym___grid_constant__] = ACTIONS(2162),
    [anon_sym_alignas] = ACTIONS(2162),
    [anon_sym__Alignas] = ACTIONS(2162),
    [sym_primitive_type] = ACTIONS(2162),
    [anon_sym_enum] = ACTIONS(2162),
    [anon_sym_class] = ACTIONS(2162),
    [anon_sym_struct] = ACTIONS(2162),
    [anon_sym_union] = ACTIONS(2162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2162),
    [anon_sym_decltype] = ACTIONS(2162),
    [sym_virtual] = ACTIONS(2162),
    [anon_sym_explicit] = ACTIONS(2162),
    [anon_sym_typename] = ACTIONS(2162),
    [anon_sym_template] = ACTIONS(2162),
    [anon_sym_operator] = ACTIONS(2162),
    [anon_sym_friend] = ACTIONS(2162),
    [anon_sym_public] = ACTIONS(2162),
    [anon_sym_private] = ACTIONS(2162),
    [anon_sym_protected] = ACTIONS(2162),
    [anon_sym_using] = ACTIONS(2162),
    [anon_sym_static_assert] = ACTIONS(2162),
    [anon_sym___launch_bounds__] = ACTIONS(2162),
  },
  [1988] = {
    [sym_identifier] = ACTIONS(2409),
    [aux_sym_preproc_def_token1] = ACTIONS(2409),
    [aux_sym_preproc_if_token1] = ACTIONS(2409),
    [aux_sym_preproc_if_token2] = ACTIONS(2409),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2409),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2409),
    [sym_preproc_directive] = ACTIONS(2409),
    [anon_sym_LPAREN2] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2411),
    [anon_sym_STAR] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2409),
    [anon_sym___extension__] = ACTIONS(2409),
    [anon_sym_typedef] = ACTIONS(2409),
    [anon_sym___device__] = ACTIONS(2409),
    [anon_sym___host__] = ACTIONS(2409),
    [anon_sym___global__] = ACTIONS(2409),
    [anon_sym___forceinline__] = ACTIONS(2409),
    [anon_sym___noinline__] = ACTIONS(2409),
    [anon_sym_extern] = ACTIONS(2409),
    [anon_sym___attribute__] = ACTIONS(2409),
    [anon_sym_COLON_COLON] = ACTIONS(2411),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2411),
    [anon_sym___declspec] = ACTIONS(2409),
    [anon_sym___based] = ACTIONS(2409),
    [anon_sym_signed] = ACTIONS(2409),
    [anon_sym_unsigned] = ACTIONS(2409),
    [anon_sym_long] = ACTIONS(2409),
    [anon_sym_short] = ACTIONS(2409),
    [anon_sym_LBRACK] = ACTIONS(2409),
    [anon_sym_static] = ACTIONS(2409),
    [anon_sym_register] = ACTIONS(2409),
    [anon_sym_inline] = ACTIONS(2409),
    [anon_sym___inline] = ACTIONS(2409),
    [anon_sym___inline__] = ACTIONS(2409),
    [anon_sym___forceinline] = ACTIONS(2409),
    [anon_sym_thread_local] = ACTIONS(2409),
    [anon_sym___thread] = ACTIONS(2409),
    [anon_sym_const] = ACTIONS(2409),
    [anon_sym_constexpr] = ACTIONS(2409),
    [anon_sym_volatile] = ACTIONS(2409),
    [anon_sym_restrict] = ACTIONS(2409),
    [anon_sym___restrict__] = ACTIONS(2409),
    [anon_sym__Atomic] = ACTIONS(2409),
    [anon_sym__Noreturn] = ACTIONS(2409),
    [anon_sym_noreturn] = ACTIONS(2409),
    [anon_sym_mutable] = ACTIONS(2409),
    [anon_sym_constinit] = ACTIONS(2409),
    [anon_sym_consteval] = ACTIONS(2409),
    [anon_sym___shared__] = ACTIONS(2409),
    [anon_sym___local__] = ACTIONS(2409),
    [anon_sym___constant__] = ACTIONS(2409),
    [anon_sym___managed__] = ACTIONS(2409),
    [anon_sym___grid_constant__] = ACTIONS(2409),
    [anon_sym_alignas] = ACTIONS(2409),
    [anon_sym__Alignas] = ACTIONS(2409),
    [sym_primitive_type] = ACTIONS(2409),
    [anon_sym_enum] = ACTIONS(2409),
    [anon_sym_class] = ACTIONS(2409),
    [anon_sym_struct] = ACTIONS(2409),
    [anon_sym_union] = ACTIONS(2409),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2409),
    [anon_sym_decltype] = ACTIONS(2409),
    [sym_virtual] = ACTIONS(2409),
    [anon_sym_explicit] = ACTIONS(2409),
    [anon_sym_typename] = ACTIONS(2409),
    [anon_sym_template] = ACTIONS(2409),
    [anon_sym_operator] = ACTIONS(2409),
    [anon_sym_friend] = ACTIONS(2409),
    [anon_sym_public] = ACTIONS(2409),
    [anon_sym_private] = ACTIONS(2409),
    [anon_sym_protected] = ACTIONS(2409),
    [anon_sym_using] = ACTIONS(2409),
    [anon_sym_static_assert] = ACTIONS(2409),
    [anon_sym___launch_bounds__] = ACTIONS(2409),
  },
  [1989] = {
    [sym_identifier] = ACTIONS(2080),
    [aux_sym_preproc_def_token1] = ACTIONS(2080),
    [aux_sym_preproc_if_token1] = ACTIONS(2080),
    [aux_sym_preproc_if_token2] = ACTIONS(2080),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2080),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2080),
    [sym_preproc_directive] = ACTIONS(2080),
    [anon_sym_LPAREN2] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_STAR] = ACTIONS(2082),
    [anon_sym_AMP_AMP] = ACTIONS(2082),
    [anon_sym_AMP] = ACTIONS(2080),
    [anon_sym___extension__] = ACTIONS(2080),
    [anon_sym_typedef] = ACTIONS(2080),
    [anon_sym___device__] = ACTIONS(2080),
    [anon_sym___host__] = ACTIONS(2080),
    [anon_sym___global__] = ACTIONS(2080),
    [anon_sym___forceinline__] = ACTIONS(2080),
    [anon_sym___noinline__] = ACTIONS(2080),
    [anon_sym_extern] = ACTIONS(2080),
    [anon_sym___attribute__] = ACTIONS(2080),
    [anon_sym_COLON_COLON] = ACTIONS(2082),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2082),
    [anon_sym___declspec] = ACTIONS(2080),
    [anon_sym___based] = ACTIONS(2080),
    [anon_sym_signed] = ACTIONS(2080),
    [anon_sym_unsigned] = ACTIONS(2080),
    [anon_sym_long] = ACTIONS(2080),
    [anon_sym_short] = ACTIONS(2080),
    [anon_sym_LBRACK] = ACTIONS(2080),
    [anon_sym_static] = ACTIONS(2080),
    [anon_sym_register] = ACTIONS(2080),
    [anon_sym_inline] = ACTIONS(2080),
    [anon_sym___inline] = ACTIONS(2080),
    [anon_sym___inline__] = ACTIONS(2080),
    [anon_sym___forceinline] = ACTIONS(2080),
    [anon_sym_thread_local] = ACTIONS(2080),
    [anon_sym___thread] = ACTIONS(2080),
    [anon_sym_const] = ACTIONS(2080),
    [anon_sym_constexpr] = ACTIONS(2080),
    [anon_sym_volatile] = ACTIONS(2080),
    [anon_sym_restrict] = ACTIONS(2080),
    [anon_sym___restrict__] = ACTIONS(2080),
    [anon_sym__Atomic] = ACTIONS(2080),
    [anon_sym__Noreturn] = ACTIONS(2080),
    [anon_sym_noreturn] = ACTIONS(2080),
    [anon_sym_mutable] = ACTIONS(2080),
    [anon_sym_constinit] = ACTIONS(2080),
    [anon_sym_consteval] = ACTIONS(2080),
    [anon_sym___shared__] = ACTIONS(2080),
    [anon_sym___local__] = ACTIONS(2080),
    [anon_sym___constant__] = ACTIONS(2080),
    [anon_sym___managed__] = ACTIONS(2080),
    [anon_sym___grid_constant__] = ACTIONS(2080),
    [anon_sym_alignas] = ACTIONS(2080),
    [anon_sym__Alignas] = ACTIONS(2080),
    [sym_primitive_type] = ACTIONS(2080),
    [anon_sym_enum] = ACTIONS(2080),
    [anon_sym_class] = ACTIONS(2080),
    [anon_sym_struct] = ACTIONS(2080),
    [anon_sym_union] = ACTIONS(2080),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2080),
    [anon_sym_decltype] = ACTIONS(2080),
    [sym_virtual] = ACTIONS(2080),
    [anon_sym_explicit] = ACTIONS(2080),
    [anon_sym_typename] = ACTIONS(2080),
    [anon_sym_template] = ACTIONS(2080),
    [anon_sym_operator] = ACTIONS(2080),
    [anon_sym_friend] = ACTIONS(2080),
    [anon_sym_public] = ACTIONS(2080),
    [anon_sym_private] = ACTIONS(2080),
    [anon_sym_protected] = ACTIONS(2080),
    [anon_sym_using] = ACTIONS(2080),
    [anon_sym_static_assert] = ACTIONS(2080),
    [anon_sym___launch_bounds__] = ACTIONS(2080),
  },
  [1990] = {
    [sym_identifier] = ACTIONS(1954),
    [aux_sym_preproc_def_token1] = ACTIONS(1954),
    [aux_sym_preproc_if_token1] = ACTIONS(1954),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1954),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1954),
    [sym_preproc_directive] = ACTIONS(1954),
    [anon_sym_LPAREN2] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [anon_sym_STAR] = ACTIONS(1956),
    [anon_sym_AMP_AMP] = ACTIONS(1956),
    [anon_sym_AMP] = ACTIONS(1954),
    [anon_sym___extension__] = ACTIONS(1954),
    [anon_sym_typedef] = ACTIONS(1954),
    [anon_sym___device__] = ACTIONS(1954),
    [anon_sym___host__] = ACTIONS(1954),
    [anon_sym___global__] = ACTIONS(1954),
    [anon_sym___forceinline__] = ACTIONS(1954),
    [anon_sym___noinline__] = ACTIONS(1954),
    [anon_sym_extern] = ACTIONS(1954),
    [anon_sym___attribute__] = ACTIONS(1954),
    [anon_sym_COLON_COLON] = ACTIONS(1956),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1956),
    [anon_sym___declspec] = ACTIONS(1954),
    [anon_sym___based] = ACTIONS(1954),
    [anon_sym_RBRACE] = ACTIONS(1956),
    [anon_sym_signed] = ACTIONS(1954),
    [anon_sym_unsigned] = ACTIONS(1954),
    [anon_sym_long] = ACTIONS(1954),
    [anon_sym_short] = ACTIONS(1954),
    [anon_sym_LBRACK] = ACTIONS(1954),
    [anon_sym_static] = ACTIONS(1954),
    [anon_sym_register] = ACTIONS(1954),
    [anon_sym_inline] = ACTIONS(1954),
    [anon_sym___inline] = ACTIONS(1954),
    [anon_sym___inline__] = ACTIONS(1954),
    [anon_sym___forceinline] = ACTIONS(1954),
    [anon_sym_thread_local] = ACTIONS(1954),
    [anon_sym___thread] = ACTIONS(1954),
    [anon_sym_const] = ACTIONS(1954),
    [anon_sym_constexpr] = ACTIONS(1954),
    [anon_sym_volatile] = ACTIONS(1954),
    [anon_sym_restrict] = ACTIONS(1954),
    [anon_sym___restrict__] = ACTIONS(1954),
    [anon_sym__Atomic] = ACTIONS(1954),
    [anon_sym__Noreturn] = ACTIONS(1954),
    [anon_sym_noreturn] = ACTIONS(1954),
    [anon_sym_mutable] = ACTIONS(1954),
    [anon_sym_constinit] = ACTIONS(1954),
    [anon_sym_consteval] = ACTIONS(1954),
    [anon_sym___shared__] = ACTIONS(1954),
    [anon_sym___local__] = ACTIONS(1954),
    [anon_sym___constant__] = ACTIONS(1954),
    [anon_sym___managed__] = ACTIONS(1954),
    [anon_sym___grid_constant__] = ACTIONS(1954),
    [anon_sym_alignas] = ACTIONS(1954),
    [anon_sym__Alignas] = ACTIONS(1954),
    [sym_primitive_type] = ACTIONS(1954),
    [anon_sym_enum] = ACTIONS(1954),
    [anon_sym_class] = ACTIONS(1954),
    [anon_sym_struct] = ACTIONS(1954),
    [anon_sym_union] = ACTIONS(1954),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1954),
    [anon_sym_decltype] = ACTIONS(1954),
    [sym_virtual] = ACTIONS(1954),
    [anon_sym_explicit] = ACTIONS(1954),
    [anon_sym_typename] = ACTIONS(1954),
    [anon_sym_template] = ACTIONS(1954),
    [anon_sym_operator] = ACTIONS(1954),
    [anon_sym_friend] = ACTIONS(1954),
    [anon_sym_public] = ACTIONS(1954),
    [anon_sym_private] = ACTIONS(1954),
    [anon_sym_protected] = ACTIONS(1954),
    [anon_sym_using] = ACTIONS(1954),
    [anon_sym_static_assert] = ACTIONS(1954),
    [anon_sym___launch_bounds__] = ACTIONS(1954),
  },
  [1991] = {
    [sym_identifier] = ACTIONS(1964),
    [aux_sym_preproc_def_token1] = ACTIONS(1964),
    [aux_sym_preproc_if_token1] = ACTIONS(1964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1964),
    [sym_preproc_directive] = ACTIONS(1964),
    [anon_sym_LPAREN2] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [anon_sym_STAR] = ACTIONS(1966),
    [anon_sym_AMP_AMP] = ACTIONS(1966),
    [anon_sym_AMP] = ACTIONS(1964),
    [anon_sym___extension__] = ACTIONS(1964),
    [anon_sym_typedef] = ACTIONS(1964),
    [anon_sym___device__] = ACTIONS(1964),
    [anon_sym___host__] = ACTIONS(1964),
    [anon_sym___global__] = ACTIONS(1964),
    [anon_sym___forceinline__] = ACTIONS(1964),
    [anon_sym___noinline__] = ACTIONS(1964),
    [anon_sym_extern] = ACTIONS(1964),
    [anon_sym___attribute__] = ACTIONS(1964),
    [anon_sym_COLON_COLON] = ACTIONS(1966),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1966),
    [anon_sym___declspec] = ACTIONS(1964),
    [anon_sym___based] = ACTIONS(1964),
    [anon_sym_RBRACE] = ACTIONS(1966),
    [anon_sym_signed] = ACTIONS(1964),
    [anon_sym_unsigned] = ACTIONS(1964),
    [anon_sym_long] = ACTIONS(1964),
    [anon_sym_short] = ACTIONS(1964),
    [anon_sym_LBRACK] = ACTIONS(1964),
    [anon_sym_static] = ACTIONS(1964),
    [anon_sym_register] = ACTIONS(1964),
    [anon_sym_inline] = ACTIONS(1964),
    [anon_sym___inline] = ACTIONS(1964),
    [anon_sym___inline__] = ACTIONS(1964),
    [anon_sym___forceinline] = ACTIONS(1964),
    [anon_sym_thread_local] = ACTIONS(1964),
    [anon_sym___thread] = ACTIONS(1964),
    [anon_sym_const] = ACTIONS(1964),
    [anon_sym_constexpr] = ACTIONS(1964),
    [anon_sym_volatile] = ACTIONS(1964),
    [anon_sym_restrict] = ACTIONS(1964),
    [anon_sym___restrict__] = ACTIONS(1964),
    [anon_sym__Atomic] = ACTIONS(1964),
    [anon_sym__Noreturn] = ACTIONS(1964),
    [anon_sym_noreturn] = ACTIONS(1964),
    [anon_sym_mutable] = ACTIONS(1964),
    [anon_sym_constinit] = ACTIONS(1964),
    [anon_sym_consteval] = ACTIONS(1964),
    [anon_sym___shared__] = ACTIONS(1964),
    [anon_sym___local__] = ACTIONS(1964),
    [anon_sym___constant__] = ACTIONS(1964),
    [anon_sym___managed__] = ACTIONS(1964),
    [anon_sym___grid_constant__] = ACTIONS(1964),
    [anon_sym_alignas] = ACTIONS(1964),
    [anon_sym__Alignas] = ACTIONS(1964),
    [sym_primitive_type] = ACTIONS(1964),
    [anon_sym_enum] = ACTIONS(1964),
    [anon_sym_class] = ACTIONS(1964),
    [anon_sym_struct] = ACTIONS(1964),
    [anon_sym_union] = ACTIONS(1964),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1964),
    [anon_sym_decltype] = ACTIONS(1964),
    [sym_virtual] = ACTIONS(1964),
    [anon_sym_explicit] = ACTIONS(1964),
    [anon_sym_typename] = ACTIONS(1964),
    [anon_sym_template] = ACTIONS(1964),
    [anon_sym_operator] = ACTIONS(1964),
    [anon_sym_friend] = ACTIONS(1964),
    [anon_sym_public] = ACTIONS(1964),
    [anon_sym_private] = ACTIONS(1964),
    [anon_sym_protected] = ACTIONS(1964),
    [anon_sym_using] = ACTIONS(1964),
    [anon_sym_static_assert] = ACTIONS(1964),
    [anon_sym___launch_bounds__] = ACTIONS(1964),
  },
  [1992] = {
    [sym_identifier] = ACTIONS(2500),
    [aux_sym_preproc_def_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token2] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2500),
    [sym_preproc_directive] = ACTIONS(2500),
    [anon_sym_LPAREN2] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [anon_sym_STAR] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2500),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_typedef] = ACTIONS(2500),
    [anon_sym___device__] = ACTIONS(2500),
    [anon_sym___host__] = ACTIONS(2500),
    [anon_sym___global__] = ACTIONS(2500),
    [anon_sym___forceinline__] = ACTIONS(2500),
    [anon_sym___noinline__] = ACTIONS(2500),
    [anon_sym_extern] = ACTIONS(2500),
    [anon_sym___attribute__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2502),
    [anon_sym___declspec] = ACTIONS(2500),
    [anon_sym___based] = ACTIONS(2500),
    [anon_sym_signed] = ACTIONS(2500),
    [anon_sym_unsigned] = ACTIONS(2500),
    [anon_sym_long] = ACTIONS(2500),
    [anon_sym_short] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_static] = ACTIONS(2500),
    [anon_sym_register] = ACTIONS(2500),
    [anon_sym_inline] = ACTIONS(2500),
    [anon_sym___inline] = ACTIONS(2500),
    [anon_sym___inline__] = ACTIONS(2500),
    [anon_sym___forceinline] = ACTIONS(2500),
    [anon_sym_thread_local] = ACTIONS(2500),
    [anon_sym___thread] = ACTIONS(2500),
    [anon_sym_const] = ACTIONS(2500),
    [anon_sym_constexpr] = ACTIONS(2500),
    [anon_sym_volatile] = ACTIONS(2500),
    [anon_sym_restrict] = ACTIONS(2500),
    [anon_sym___restrict__] = ACTIONS(2500),
    [anon_sym__Atomic] = ACTIONS(2500),
    [anon_sym__Noreturn] = ACTIONS(2500),
    [anon_sym_noreturn] = ACTIONS(2500),
    [anon_sym_mutable] = ACTIONS(2500),
    [anon_sym_constinit] = ACTIONS(2500),
    [anon_sym_consteval] = ACTIONS(2500),
    [anon_sym___shared__] = ACTIONS(2500),
    [anon_sym___local__] = ACTIONS(2500),
    [anon_sym___constant__] = ACTIONS(2500),
    [anon_sym___managed__] = ACTIONS(2500),
    [anon_sym___grid_constant__] = ACTIONS(2500),
    [anon_sym_alignas] = ACTIONS(2500),
    [anon_sym__Alignas] = ACTIONS(2500),
    [sym_primitive_type] = ACTIONS(2500),
    [anon_sym_enum] = ACTIONS(2500),
    [anon_sym_class] = ACTIONS(2500),
    [anon_sym_struct] = ACTIONS(2500),
    [anon_sym_union] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2500),
    [anon_sym_decltype] = ACTIONS(2500),
    [sym_virtual] = ACTIONS(2500),
    [anon_sym_explicit] = ACTIONS(2500),
    [anon_sym_typename] = ACTIONS(2500),
    [anon_sym_template] = ACTIONS(2500),
    [anon_sym_operator] = ACTIONS(2500),
    [anon_sym_friend] = ACTIONS(2500),
    [anon_sym_public] = ACTIONS(2500),
    [anon_sym_private] = ACTIONS(2500),
    [anon_sym_protected] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_static_assert] = ACTIONS(2500),
    [anon_sym___launch_bounds__] = ACTIONS(2500),
  },
  [1993] = {
    [sym_identifier] = ACTIONS(5107),
    [aux_sym_preproc_def_token1] = ACTIONS(5107),
    [aux_sym_preproc_if_token1] = ACTIONS(5107),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5107),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5107),
    [sym_preproc_directive] = ACTIONS(5107),
    [anon_sym_LPAREN2] = ACTIONS(5109),
    [anon_sym_TILDE] = ACTIONS(5109),
    [anon_sym_STAR] = ACTIONS(5109),
    [anon_sym_AMP_AMP] = ACTIONS(5109),
    [anon_sym_AMP] = ACTIONS(5107),
    [anon_sym___extension__] = ACTIONS(5107),
    [anon_sym_typedef] = ACTIONS(5107),
    [anon_sym___device__] = ACTIONS(5107),
    [anon_sym___host__] = ACTIONS(5107),
    [anon_sym___global__] = ACTIONS(5107),
    [anon_sym___forceinline__] = ACTIONS(5107),
    [anon_sym___noinline__] = ACTIONS(5107),
    [anon_sym_extern] = ACTIONS(5107),
    [anon_sym___attribute__] = ACTIONS(5107),
    [anon_sym_COLON_COLON] = ACTIONS(5109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5109),
    [anon_sym___declspec] = ACTIONS(5107),
    [anon_sym___based] = ACTIONS(5107),
    [anon_sym_RBRACE] = ACTIONS(5109),
    [anon_sym_signed] = ACTIONS(5107),
    [anon_sym_unsigned] = ACTIONS(5107),
    [anon_sym_long] = ACTIONS(5107),
    [anon_sym_short] = ACTIONS(5107),
    [anon_sym_LBRACK] = ACTIONS(5107),
    [anon_sym_static] = ACTIONS(5107),
    [anon_sym_register] = ACTIONS(5107),
    [anon_sym_inline] = ACTIONS(5107),
    [anon_sym___inline] = ACTIONS(5107),
    [anon_sym___inline__] = ACTIONS(5107),
    [anon_sym___forceinline] = ACTIONS(5107),
    [anon_sym_thread_local] = ACTIONS(5107),
    [anon_sym___thread] = ACTIONS(5107),
    [anon_sym_const] = ACTIONS(5107),
    [anon_sym_constexpr] = ACTIONS(5107),
    [anon_sym_volatile] = ACTIONS(5107),
    [anon_sym_restrict] = ACTIONS(5107),
    [anon_sym___restrict__] = ACTIONS(5107),
    [anon_sym__Atomic] = ACTIONS(5107),
    [anon_sym__Noreturn] = ACTIONS(5107),
    [anon_sym_noreturn] = ACTIONS(5107),
    [anon_sym_mutable] = ACTIONS(5107),
    [anon_sym_constinit] = ACTIONS(5107),
    [anon_sym_consteval] = ACTIONS(5107),
    [anon_sym___shared__] = ACTIONS(5107),
    [anon_sym___local__] = ACTIONS(5107),
    [anon_sym___constant__] = ACTIONS(5107),
    [anon_sym___managed__] = ACTIONS(5107),
    [anon_sym___grid_constant__] = ACTIONS(5107),
    [anon_sym_alignas] = ACTIONS(5107),
    [anon_sym__Alignas] = ACTIONS(5107),
    [sym_primitive_type] = ACTIONS(5107),
    [anon_sym_enum] = ACTIONS(5107),
    [anon_sym_class] = ACTIONS(5107),
    [anon_sym_struct] = ACTIONS(5107),
    [anon_sym_union] = ACTIONS(5107),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5107),
    [anon_sym_decltype] = ACTIONS(5107),
    [sym_virtual] = ACTIONS(5107),
    [anon_sym_explicit] = ACTIONS(5107),
    [anon_sym_typename] = ACTIONS(5107),
    [anon_sym_template] = ACTIONS(5107),
    [anon_sym_operator] = ACTIONS(5107),
    [anon_sym_friend] = ACTIONS(5107),
    [anon_sym_public] = ACTIONS(5107),
    [anon_sym_private] = ACTIONS(5107),
    [anon_sym_protected] = ACTIONS(5107),
    [anon_sym_using] = ACTIONS(5107),
    [anon_sym_static_assert] = ACTIONS(5107),
    [anon_sym___launch_bounds__] = ACTIONS(5107),
  },
  [1994] = {
    [sym_identifier] = ACTIONS(2500),
    [aux_sym_preproc_def_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token2] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2500),
    [sym_preproc_directive] = ACTIONS(2500),
    [anon_sym_LPAREN2] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [anon_sym_STAR] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2500),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_typedef] = ACTIONS(2500),
    [anon_sym___device__] = ACTIONS(2500),
    [anon_sym___host__] = ACTIONS(2500),
    [anon_sym___global__] = ACTIONS(2500),
    [anon_sym___forceinline__] = ACTIONS(2500),
    [anon_sym___noinline__] = ACTIONS(2500),
    [anon_sym_extern] = ACTIONS(2500),
    [anon_sym___attribute__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2502),
    [anon_sym___declspec] = ACTIONS(2500),
    [anon_sym___based] = ACTIONS(2500),
    [anon_sym_signed] = ACTIONS(2500),
    [anon_sym_unsigned] = ACTIONS(2500),
    [anon_sym_long] = ACTIONS(2500),
    [anon_sym_short] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_static] = ACTIONS(2500),
    [anon_sym_register] = ACTIONS(2500),
    [anon_sym_inline] = ACTIONS(2500),
    [anon_sym___inline] = ACTIONS(2500),
    [anon_sym___inline__] = ACTIONS(2500),
    [anon_sym___forceinline] = ACTIONS(2500),
    [anon_sym_thread_local] = ACTIONS(2500),
    [anon_sym___thread] = ACTIONS(2500),
    [anon_sym_const] = ACTIONS(2500),
    [anon_sym_constexpr] = ACTIONS(2500),
    [anon_sym_volatile] = ACTIONS(2500),
    [anon_sym_restrict] = ACTIONS(2500),
    [anon_sym___restrict__] = ACTIONS(2500),
    [anon_sym__Atomic] = ACTIONS(2500),
    [anon_sym__Noreturn] = ACTIONS(2500),
    [anon_sym_noreturn] = ACTIONS(2500),
    [anon_sym_mutable] = ACTIONS(2500),
    [anon_sym_constinit] = ACTIONS(2500),
    [anon_sym_consteval] = ACTIONS(2500),
    [anon_sym___shared__] = ACTIONS(2500),
    [anon_sym___local__] = ACTIONS(2500),
    [anon_sym___constant__] = ACTIONS(2500),
    [anon_sym___managed__] = ACTIONS(2500),
    [anon_sym___grid_constant__] = ACTIONS(2500),
    [anon_sym_alignas] = ACTIONS(2500),
    [anon_sym__Alignas] = ACTIONS(2500),
    [sym_primitive_type] = ACTIONS(2500),
    [anon_sym_enum] = ACTIONS(2500),
    [anon_sym_class] = ACTIONS(2500),
    [anon_sym_struct] = ACTIONS(2500),
    [anon_sym_union] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2500),
    [anon_sym_decltype] = ACTIONS(2500),
    [sym_virtual] = ACTIONS(2500),
    [anon_sym_explicit] = ACTIONS(2500),
    [anon_sym_typename] = ACTIONS(2500),
    [anon_sym_template] = ACTIONS(2500),
    [anon_sym_operator] = ACTIONS(2500),
    [anon_sym_friend] = ACTIONS(2500),
    [anon_sym_public] = ACTIONS(2500),
    [anon_sym_private] = ACTIONS(2500),
    [anon_sym_protected] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_static_assert] = ACTIONS(2500),
    [anon_sym___launch_bounds__] = ACTIONS(2500),
  },
  [1995] = {
    [sym_identifier] = ACTIONS(2162),
    [aux_sym_preproc_def_token1] = ACTIONS(2162),
    [aux_sym_preproc_if_token1] = ACTIONS(2162),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2162),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2162),
    [sym_preproc_directive] = ACTIONS(2162),
    [anon_sym_LPAREN2] = ACTIONS(2164),
    [anon_sym_TILDE] = ACTIONS(2164),
    [anon_sym_STAR] = ACTIONS(2164),
    [anon_sym_AMP_AMP] = ACTIONS(2164),
    [anon_sym_AMP] = ACTIONS(2162),
    [anon_sym___extension__] = ACTIONS(2162),
    [anon_sym_typedef] = ACTIONS(2162),
    [anon_sym___device__] = ACTIONS(2162),
    [anon_sym___host__] = ACTIONS(2162),
    [anon_sym___global__] = ACTIONS(2162),
    [anon_sym___forceinline__] = ACTIONS(2162),
    [anon_sym___noinline__] = ACTIONS(2162),
    [anon_sym_extern] = ACTIONS(2162),
    [anon_sym___attribute__] = ACTIONS(2162),
    [anon_sym_COLON_COLON] = ACTIONS(2164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2164),
    [anon_sym___declspec] = ACTIONS(2162),
    [anon_sym___based] = ACTIONS(2162),
    [anon_sym_RBRACE] = ACTIONS(2164),
    [anon_sym_signed] = ACTIONS(2162),
    [anon_sym_unsigned] = ACTIONS(2162),
    [anon_sym_long] = ACTIONS(2162),
    [anon_sym_short] = ACTIONS(2162),
    [anon_sym_LBRACK] = ACTIONS(2162),
    [anon_sym_static] = ACTIONS(2162),
    [anon_sym_register] = ACTIONS(2162),
    [anon_sym_inline] = ACTIONS(2162),
    [anon_sym___inline] = ACTIONS(2162),
    [anon_sym___inline__] = ACTIONS(2162),
    [anon_sym___forceinline] = ACTIONS(2162),
    [anon_sym_thread_local] = ACTIONS(2162),
    [anon_sym___thread] = ACTIONS(2162),
    [anon_sym_const] = ACTIONS(2162),
    [anon_sym_constexpr] = ACTIONS(2162),
    [anon_sym_volatile] = ACTIONS(2162),
    [anon_sym_restrict] = ACTIONS(2162),
    [anon_sym___restrict__] = ACTIONS(2162),
    [anon_sym__Atomic] = ACTIONS(2162),
    [anon_sym__Noreturn] = ACTIONS(2162),
    [anon_sym_noreturn] = ACTIONS(2162),
    [anon_sym_mutable] = ACTIONS(2162),
    [anon_sym_constinit] = ACTIONS(2162),
    [anon_sym_consteval] = ACTIONS(2162),
    [anon_sym___shared__] = ACTIONS(2162),
    [anon_sym___local__] = ACTIONS(2162),
    [anon_sym___constant__] = ACTIONS(2162),
    [anon_sym___managed__] = ACTIONS(2162),
    [anon_sym___grid_constant__] = ACTIONS(2162),
    [anon_sym_alignas] = ACTIONS(2162),
    [anon_sym__Alignas] = ACTIONS(2162),
    [sym_primitive_type] = ACTIONS(2162),
    [anon_sym_enum] = ACTIONS(2162),
    [anon_sym_class] = ACTIONS(2162),
    [anon_sym_struct] = ACTIONS(2162),
    [anon_sym_union] = ACTIONS(2162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2162),
    [anon_sym_decltype] = ACTIONS(2162),
    [sym_virtual] = ACTIONS(2162),
    [anon_sym_explicit] = ACTIONS(2162),
    [anon_sym_typename] = ACTIONS(2162),
    [anon_sym_template] = ACTIONS(2162),
    [anon_sym_operator] = ACTIONS(2162),
    [anon_sym_friend] = ACTIONS(2162),
    [anon_sym_public] = ACTIONS(2162),
    [anon_sym_private] = ACTIONS(2162),
    [anon_sym_protected] = ACTIONS(2162),
    [anon_sym_using] = ACTIONS(2162),
    [anon_sym_static_assert] = ACTIONS(2162),
    [anon_sym___launch_bounds__] = ACTIONS(2162),
  },
  [1996] = {
    [sym_identifier] = ACTIONS(2473),
    [aux_sym_preproc_def_token1] = ACTIONS(2473),
    [aux_sym_preproc_if_token1] = ACTIONS(2473),
    [aux_sym_preproc_if_token2] = ACTIONS(2473),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2473),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2473),
    [sym_preproc_directive] = ACTIONS(2473),
    [anon_sym_LPAREN2] = ACTIONS(2475),
    [anon_sym_TILDE] = ACTIONS(2475),
    [anon_sym_STAR] = ACTIONS(2475),
    [anon_sym_AMP_AMP] = ACTIONS(2475),
    [anon_sym_AMP] = ACTIONS(2473),
    [anon_sym___extension__] = ACTIONS(2473),
    [anon_sym_typedef] = ACTIONS(2473),
    [anon_sym___device__] = ACTIONS(2473),
    [anon_sym___host__] = ACTIONS(2473),
    [anon_sym___global__] = ACTIONS(2473),
    [anon_sym___forceinline__] = ACTIONS(2473),
    [anon_sym___noinline__] = ACTIONS(2473),
    [anon_sym_extern] = ACTIONS(2473),
    [anon_sym___attribute__] = ACTIONS(2473),
    [anon_sym_COLON_COLON] = ACTIONS(2475),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2475),
    [anon_sym___declspec] = ACTIONS(2473),
    [anon_sym___based] = ACTIONS(2473),
    [anon_sym_signed] = ACTIONS(2473),
    [anon_sym_unsigned] = ACTIONS(2473),
    [anon_sym_long] = ACTIONS(2473),
    [anon_sym_short] = ACTIONS(2473),
    [anon_sym_LBRACK] = ACTIONS(2473),
    [anon_sym_static] = ACTIONS(2473),
    [anon_sym_register] = ACTIONS(2473),
    [anon_sym_inline] = ACTIONS(2473),
    [anon_sym___inline] = ACTIONS(2473),
    [anon_sym___inline__] = ACTIONS(2473),
    [anon_sym___forceinline] = ACTIONS(2473),
    [anon_sym_thread_local] = ACTIONS(2473),
    [anon_sym___thread] = ACTIONS(2473),
    [anon_sym_const] = ACTIONS(2473),
    [anon_sym_constexpr] = ACTIONS(2473),
    [anon_sym_volatile] = ACTIONS(2473),
    [anon_sym_restrict] = ACTIONS(2473),
    [anon_sym___restrict__] = ACTIONS(2473),
    [anon_sym__Atomic] = ACTIONS(2473),
    [anon_sym__Noreturn] = ACTIONS(2473),
    [anon_sym_noreturn] = ACTIONS(2473),
    [anon_sym_mutable] = ACTIONS(2473),
    [anon_sym_constinit] = ACTIONS(2473),
    [anon_sym_consteval] = ACTIONS(2473),
    [anon_sym___shared__] = ACTIONS(2473),
    [anon_sym___local__] = ACTIONS(2473),
    [anon_sym___constant__] = ACTIONS(2473),
    [anon_sym___managed__] = ACTIONS(2473),
    [anon_sym___grid_constant__] = ACTIONS(2473),
    [anon_sym_alignas] = ACTIONS(2473),
    [anon_sym__Alignas] = ACTIONS(2473),
    [sym_primitive_type] = ACTIONS(2473),
    [anon_sym_enum] = ACTIONS(2473),
    [anon_sym_class] = ACTIONS(2473),
    [anon_sym_struct] = ACTIONS(2473),
    [anon_sym_union] = ACTIONS(2473),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2473),
    [anon_sym_decltype] = ACTIONS(2473),
    [sym_virtual] = ACTIONS(2473),
    [anon_sym_explicit] = ACTIONS(2473),
    [anon_sym_typename] = ACTIONS(2473),
    [anon_sym_template] = ACTIONS(2473),
    [anon_sym_operator] = ACTIONS(2473),
    [anon_sym_friend] = ACTIONS(2473),
    [anon_sym_public] = ACTIONS(2473),
    [anon_sym_private] = ACTIONS(2473),
    [anon_sym_protected] = ACTIONS(2473),
    [anon_sym_using] = ACTIONS(2473),
    [anon_sym_static_assert] = ACTIONS(2473),
    [anon_sym___launch_bounds__] = ACTIONS(2473),
  },
  [1997] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_STAR] = ACTIONS(4153),
    [anon_sym_SLASH] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4151),
    [anon_sym_CARET] = ACTIONS(4151),
    [anon_sym_AMP] = ACTIONS(4153),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT] = ACTIONS(4151),
    [anon_sym_GT_EQ] = ACTIONS(4151),
    [anon_sym_LT_EQ] = ACTIONS(4151),
    [anon_sym_LT] = ACTIONS(4151),
    [anon_sym_LT_LT] = ACTIONS(4151),
    [anon_sym_GT_GT] = ACTIONS(4151),
    [anon_sym___extension__] = ACTIONS(4149),
    [anon_sym___global__] = ACTIONS(4149),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_LBRACE] = ACTIONS(4149),
    [anon_sym_LBRACK] = ACTIONS(4146),
    [anon_sym_EQ] = ACTIONS(4151),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_constexpr] = ACTIONS(4149),
    [anon_sym_volatile] = ACTIONS(4149),
    [anon_sym_restrict] = ACTIONS(4149),
    [anon_sym___restrict__] = ACTIONS(4149),
    [anon_sym__Atomic] = ACTIONS(4149),
    [anon_sym__Noreturn] = ACTIONS(4149),
    [anon_sym_noreturn] = ACTIONS(4149),
    [anon_sym_mutable] = ACTIONS(4149),
    [anon_sym_constinit] = ACTIONS(4149),
    [anon_sym_consteval] = ACTIONS(4149),
    [anon_sym___shared__] = ACTIONS(4149),
    [anon_sym___local__] = ACTIONS(4149),
    [anon_sym___constant__] = ACTIONS(4149),
    [anon_sym___managed__] = ACTIONS(4149),
    [anon_sym___grid_constant__] = ACTIONS(4149),
    [anon_sym_alignas] = ACTIONS(4149),
    [anon_sym__Alignas] = ACTIONS(4149),
    [anon_sym_QMARK] = ACTIONS(4144),
    [anon_sym_STAR_EQ] = ACTIONS(4144),
    [anon_sym_SLASH_EQ] = ACTIONS(4144),
    [anon_sym_PERCENT_EQ] = ACTIONS(4144),
    [anon_sym_PLUS_EQ] = ACTIONS(4144),
    [anon_sym_DASH_EQ] = ACTIONS(4144),
    [anon_sym_LT_LT_EQ] = ACTIONS(4144),
    [anon_sym_GT_GT_EQ] = ACTIONS(4151),
    [anon_sym_AMP_EQ] = ACTIONS(4144),
    [anon_sym_CARET_EQ] = ACTIONS(4144),
    [anon_sym_PIPE_EQ] = ACTIONS(4144),
    [anon_sym_and_eq] = ACTIONS(4144),
    [anon_sym_or_eq] = ACTIONS(4144),
    [anon_sym_xor_eq] = ACTIONS(4144),
    [anon_sym_LT_EQ_GT] = ACTIONS(4144),
    [anon_sym_or] = ACTIONS(4151),
    [anon_sym_and] = ACTIONS(4151),
    [anon_sym_bitor] = ACTIONS(4144),
    [anon_sym_xor] = ACTIONS(4151),
    [anon_sym_bitand] = ACTIONS(4144),
    [anon_sym_not_eq] = ACTIONS(4144),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_DOT_STAR] = ACTIONS(4144),
    [anon_sym_DASH_GT] = ACTIONS(4144),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4149),
    [anon_sym_decltype] = ACTIONS(4149),
    [anon_sym_GT2] = ACTIONS(4146),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4144),
  },
  [1998] = {
    [sym_identifier] = ACTIONS(2271),
    [aux_sym_preproc_def_token1] = ACTIONS(2271),
    [aux_sym_preproc_if_token1] = ACTIONS(2271),
    [aux_sym_preproc_if_token2] = ACTIONS(2271),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2271),
    [sym_preproc_directive] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(2273),
    [anon_sym_TILDE] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(2273),
    [anon_sym_AMP_AMP] = ACTIONS(2273),
    [anon_sym_AMP] = ACTIONS(2271),
    [anon_sym___extension__] = ACTIONS(2271),
    [anon_sym_typedef] = ACTIONS(2271),
    [anon_sym___device__] = ACTIONS(2271),
    [anon_sym___host__] = ACTIONS(2271),
    [anon_sym___global__] = ACTIONS(2271),
    [anon_sym___forceinline__] = ACTIONS(2271),
    [anon_sym___noinline__] = ACTIONS(2271),
    [anon_sym_extern] = ACTIONS(2271),
    [anon_sym___attribute__] = ACTIONS(2271),
    [anon_sym_COLON_COLON] = ACTIONS(2273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2273),
    [anon_sym___declspec] = ACTIONS(2271),
    [anon_sym___based] = ACTIONS(2271),
    [anon_sym_signed] = ACTIONS(2271),
    [anon_sym_unsigned] = ACTIONS(2271),
    [anon_sym_long] = ACTIONS(2271),
    [anon_sym_short] = ACTIONS(2271),
    [anon_sym_LBRACK] = ACTIONS(2271),
    [anon_sym_static] = ACTIONS(2271),
    [anon_sym_register] = ACTIONS(2271),
    [anon_sym_inline] = ACTIONS(2271),
    [anon_sym___inline] = ACTIONS(2271),
    [anon_sym___inline__] = ACTIONS(2271),
    [anon_sym___forceinline] = ACTIONS(2271),
    [anon_sym_thread_local] = ACTIONS(2271),
    [anon_sym___thread] = ACTIONS(2271),
    [anon_sym_const] = ACTIONS(2271),
    [anon_sym_constexpr] = ACTIONS(2271),
    [anon_sym_volatile] = ACTIONS(2271),
    [anon_sym_restrict] = ACTIONS(2271),
    [anon_sym___restrict__] = ACTIONS(2271),
    [anon_sym__Atomic] = ACTIONS(2271),
    [anon_sym__Noreturn] = ACTIONS(2271),
    [anon_sym_noreturn] = ACTIONS(2271),
    [anon_sym_mutable] = ACTIONS(2271),
    [anon_sym_constinit] = ACTIONS(2271),
    [anon_sym_consteval] = ACTIONS(2271),
    [anon_sym___shared__] = ACTIONS(2271),
    [anon_sym___local__] = ACTIONS(2271),
    [anon_sym___constant__] = ACTIONS(2271),
    [anon_sym___managed__] = ACTIONS(2271),
    [anon_sym___grid_constant__] = ACTIONS(2271),
    [anon_sym_alignas] = ACTIONS(2271),
    [anon_sym__Alignas] = ACTIONS(2271),
    [sym_primitive_type] = ACTIONS(2271),
    [anon_sym_enum] = ACTIONS(2271),
    [anon_sym_class] = ACTIONS(2271),
    [anon_sym_struct] = ACTIONS(2271),
    [anon_sym_union] = ACTIONS(2271),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2271),
    [anon_sym_decltype] = ACTIONS(2271),
    [sym_virtual] = ACTIONS(2271),
    [anon_sym_explicit] = ACTIONS(2271),
    [anon_sym_typename] = ACTIONS(2271),
    [anon_sym_template] = ACTIONS(2271),
    [anon_sym_operator] = ACTIONS(2271),
    [anon_sym_friend] = ACTIONS(2271),
    [anon_sym_public] = ACTIONS(2271),
    [anon_sym_private] = ACTIONS(2271),
    [anon_sym_protected] = ACTIONS(2271),
    [anon_sym_using] = ACTIONS(2271),
    [anon_sym_static_assert] = ACTIONS(2271),
    [anon_sym___launch_bounds__] = ACTIONS(2271),
  },
  [1999] = {
    [sym_identifier] = ACTIONS(2436),
    [aux_sym_preproc_def_token1] = ACTIONS(2436),
    [aux_sym_preproc_if_token1] = ACTIONS(2436),
    [aux_sym_preproc_if_token2] = ACTIONS(2436),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2436),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2436),
    [sym_preproc_directive] = ACTIONS(2436),
    [anon_sym_LPAREN2] = ACTIONS(2438),
    [anon_sym_TILDE] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(2438),
    [anon_sym_AMP_AMP] = ACTIONS(2438),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym___extension__] = ACTIONS(2436),
    [anon_sym_typedef] = ACTIONS(2436),
    [anon_sym___device__] = ACTIONS(2436),
    [anon_sym___host__] = ACTIONS(2436),
    [anon_sym___global__] = ACTIONS(2436),
    [anon_sym___forceinline__] = ACTIONS(2436),
    [anon_sym___noinline__] = ACTIONS(2436),
    [anon_sym_extern] = ACTIONS(2436),
    [anon_sym___attribute__] = ACTIONS(2436),
    [anon_sym_COLON_COLON] = ACTIONS(2438),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2438),
    [anon_sym___declspec] = ACTIONS(2436),
    [anon_sym___based] = ACTIONS(2436),
    [anon_sym_signed] = ACTIONS(2436),
    [anon_sym_unsigned] = ACTIONS(2436),
    [anon_sym_long] = ACTIONS(2436),
    [anon_sym_short] = ACTIONS(2436),
    [anon_sym_LBRACK] = ACTIONS(2436),
    [anon_sym_static] = ACTIONS(2436),
    [anon_sym_register] = ACTIONS(2436),
    [anon_sym_inline] = ACTIONS(2436),
    [anon_sym___inline] = ACTIONS(2436),
    [anon_sym___inline__] = ACTIONS(2436),
    [anon_sym___forceinline] = ACTIONS(2436),
    [anon_sym_thread_local] = ACTIONS(2436),
    [anon_sym___thread] = ACTIONS(2436),
    [anon_sym_const] = ACTIONS(2436),
    [anon_sym_constexpr] = ACTIONS(2436),
    [anon_sym_volatile] = ACTIONS(2436),
    [anon_sym_restrict] = ACTIONS(2436),
    [anon_sym___restrict__] = ACTIONS(2436),
    [anon_sym__Atomic] = ACTIONS(2436),
    [anon_sym__Noreturn] = ACTIONS(2436),
    [anon_sym_noreturn] = ACTIONS(2436),
    [anon_sym_mutable] = ACTIONS(2436),
    [anon_sym_constinit] = ACTIONS(2436),
    [anon_sym_consteval] = ACTIONS(2436),
    [anon_sym___shared__] = ACTIONS(2436),
    [anon_sym___local__] = ACTIONS(2436),
    [anon_sym___constant__] = ACTIONS(2436),
    [anon_sym___managed__] = ACTIONS(2436),
    [anon_sym___grid_constant__] = ACTIONS(2436),
    [anon_sym_alignas] = ACTIONS(2436),
    [anon_sym__Alignas] = ACTIONS(2436),
    [sym_primitive_type] = ACTIONS(2436),
    [anon_sym_enum] = ACTIONS(2436),
    [anon_sym_class] = ACTIONS(2436),
    [anon_sym_struct] = ACTIONS(2436),
    [anon_sym_union] = ACTIONS(2436),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2436),
    [anon_sym_decltype] = ACTIONS(2436),
    [sym_virtual] = ACTIONS(2436),
    [anon_sym_explicit] = ACTIONS(2436),
    [anon_sym_typename] = ACTIONS(2436),
    [anon_sym_template] = ACTIONS(2436),
    [anon_sym_operator] = ACTIONS(2436),
    [anon_sym_friend] = ACTIONS(2436),
    [anon_sym_public] = ACTIONS(2436),
    [anon_sym_private] = ACTIONS(2436),
    [anon_sym_protected] = ACTIONS(2436),
    [anon_sym_using] = ACTIONS(2436),
    [anon_sym_static_assert] = ACTIONS(2436),
    [anon_sym___launch_bounds__] = ACTIONS(2436),
  },
  [2000] = {
    [sym_identifier] = ACTIONS(2396),
    [aux_sym_preproc_def_token1] = ACTIONS(2396),
    [aux_sym_preproc_if_token1] = ACTIONS(2396),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2396),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2396),
    [sym_preproc_directive] = ACTIONS(2396),
    [anon_sym_LPAREN2] = ACTIONS(2398),
    [anon_sym_TILDE] = ACTIONS(2398),
    [anon_sym_STAR] = ACTIONS(2398),
    [anon_sym_AMP_AMP] = ACTIONS(2398),
    [anon_sym_AMP] = ACTIONS(2396),
    [anon_sym___extension__] = ACTIONS(2396),
    [anon_sym_typedef] = ACTIONS(2396),
    [anon_sym___device__] = ACTIONS(2396),
    [anon_sym___host__] = ACTIONS(2396),
    [anon_sym___global__] = ACTIONS(2396),
    [anon_sym___forceinline__] = ACTIONS(2396),
    [anon_sym___noinline__] = ACTIONS(2396),
    [anon_sym_extern] = ACTIONS(2396),
    [anon_sym___attribute__] = ACTIONS(2396),
    [anon_sym_COLON_COLON] = ACTIONS(2398),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2398),
    [anon_sym___declspec] = ACTIONS(2396),
    [anon_sym___based] = ACTIONS(2396),
    [anon_sym_RBRACE] = ACTIONS(2398),
    [anon_sym_signed] = ACTIONS(2396),
    [anon_sym_unsigned] = ACTIONS(2396),
    [anon_sym_long] = ACTIONS(2396),
    [anon_sym_short] = ACTIONS(2396),
    [anon_sym_LBRACK] = ACTIONS(2396),
    [anon_sym_static] = ACTIONS(2396),
    [anon_sym_register] = ACTIONS(2396),
    [anon_sym_inline] = ACTIONS(2396),
    [anon_sym___inline] = ACTIONS(2396),
    [anon_sym___inline__] = ACTIONS(2396),
    [anon_sym___forceinline] = ACTIONS(2396),
    [anon_sym_thread_local] = ACTIONS(2396),
    [anon_sym___thread] = ACTIONS(2396),
    [anon_sym_const] = ACTIONS(2396),
    [anon_sym_constexpr] = ACTIONS(2396),
    [anon_sym_volatile] = ACTIONS(2396),
    [anon_sym_restrict] = ACTIONS(2396),
    [anon_sym___restrict__] = ACTIONS(2396),
    [anon_sym__Atomic] = ACTIONS(2396),
    [anon_sym__Noreturn] = ACTIONS(2396),
    [anon_sym_noreturn] = ACTIONS(2396),
    [anon_sym_mutable] = ACTIONS(2396),
    [anon_sym_constinit] = ACTIONS(2396),
    [anon_sym_consteval] = ACTIONS(2396),
    [anon_sym___shared__] = ACTIONS(2396),
    [anon_sym___local__] = ACTIONS(2396),
    [anon_sym___constant__] = ACTIONS(2396),
    [anon_sym___managed__] = ACTIONS(2396),
    [anon_sym___grid_constant__] = ACTIONS(2396),
    [anon_sym_alignas] = ACTIONS(2396),
    [anon_sym__Alignas] = ACTIONS(2396),
    [sym_primitive_type] = ACTIONS(2396),
    [anon_sym_enum] = ACTIONS(2396),
    [anon_sym_class] = ACTIONS(2396),
    [anon_sym_struct] = ACTIONS(2396),
    [anon_sym_union] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2396),
    [anon_sym_decltype] = ACTIONS(2396),
    [sym_virtual] = ACTIONS(2396),
    [anon_sym_explicit] = ACTIONS(2396),
    [anon_sym_typename] = ACTIONS(2396),
    [anon_sym_template] = ACTIONS(2396),
    [anon_sym_operator] = ACTIONS(2396),
    [anon_sym_friend] = ACTIONS(2396),
    [anon_sym_public] = ACTIONS(2396),
    [anon_sym_private] = ACTIONS(2396),
    [anon_sym_protected] = ACTIONS(2396),
    [anon_sym_using] = ACTIONS(2396),
    [anon_sym_static_assert] = ACTIONS(2396),
    [anon_sym___launch_bounds__] = ACTIONS(2396),
  },
  [2001] = {
    [sym_string_literal] = STATE(2001),
    [sym_raw_string_literal] = STATE(2001),
    [aux_sym_concatenated_string_repeat1] = STATE(2001),
    [sym_identifier] = ACTIONS(5264),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5267),
    [anon_sym_COMMA] = ACTIONS(5267),
    [anon_sym_RPAREN] = ACTIONS(5267),
    [aux_sym_preproc_if_token2] = ACTIONS(5267),
    [aux_sym_preproc_else_token1] = ACTIONS(5267),
    [aux_sym_preproc_elif_token1] = ACTIONS(5269),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5267),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5267),
    [anon_sym_LPAREN2] = ACTIONS(5267),
    [anon_sym_DASH] = ACTIONS(5269),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_STAR] = ACTIONS(5269),
    [anon_sym_SLASH] = ACTIONS(5269),
    [anon_sym_PERCENT] = ACTIONS(5269),
    [anon_sym_PIPE_PIPE] = ACTIONS(5267),
    [anon_sym_AMP_AMP] = ACTIONS(5267),
    [anon_sym_PIPE] = ACTIONS(5269),
    [anon_sym_CARET] = ACTIONS(5269),
    [anon_sym_AMP] = ACTIONS(5269),
    [anon_sym_EQ_EQ] = ACTIONS(5267),
    [anon_sym_BANG_EQ] = ACTIONS(5267),
    [anon_sym_GT] = ACTIONS(5269),
    [anon_sym_GT_EQ] = ACTIONS(5267),
    [anon_sym_LT_EQ] = ACTIONS(5269),
    [anon_sym_LT] = ACTIONS(5269),
    [anon_sym_LT_LT] = ACTIONS(5269),
    [anon_sym_GT_GT] = ACTIONS(5269),
    [anon_sym_SEMI] = ACTIONS(5267),
    [anon_sym_RBRACE] = ACTIONS(5267),
    [anon_sym_LBRACK] = ACTIONS(5267),
    [anon_sym_RBRACK] = ACTIONS(5267),
    [anon_sym_EQ] = ACTIONS(5269),
    [anon_sym_COLON] = ACTIONS(5267),
    [anon_sym_QMARK] = ACTIONS(5267),
    [anon_sym_STAR_EQ] = ACTIONS(5267),
    [anon_sym_SLASH_EQ] = ACTIONS(5267),
    [anon_sym_PERCENT_EQ] = ACTIONS(5267),
    [anon_sym_PLUS_EQ] = ACTIONS(5267),
    [anon_sym_DASH_EQ] = ACTIONS(5267),
    [anon_sym_LT_LT_EQ] = ACTIONS(5267),
    [anon_sym_GT_GT_EQ] = ACTIONS(5267),
    [anon_sym_AMP_EQ] = ACTIONS(5267),
    [anon_sym_CARET_EQ] = ACTIONS(5267),
    [anon_sym_PIPE_EQ] = ACTIONS(5267),
    [anon_sym_and_eq] = ACTIONS(5269),
    [anon_sym_or_eq] = ACTIONS(5269),
    [anon_sym_xor_eq] = ACTIONS(5269),
    [anon_sym_LT_EQ_GT] = ACTIONS(5267),
    [anon_sym_or] = ACTIONS(5269),
    [anon_sym_and] = ACTIONS(5269),
    [anon_sym_bitor] = ACTIONS(5269),
    [anon_sym_xor] = ACTIONS(5269),
    [anon_sym_bitand] = ACTIONS(5269),
    [anon_sym_not_eq] = ACTIONS(5269),
    [anon_sym_DASH_DASH] = ACTIONS(5267),
    [anon_sym_PLUS_PLUS] = ACTIONS(5267),
    [anon_sym_DOT] = ACTIONS(5269),
    [anon_sym_DOT_STAR] = ACTIONS(5267),
    [anon_sym_DASH_GT] = ACTIONS(5267),
    [anon_sym_L_DQUOTE] = ACTIONS(5271),
    [anon_sym_u_DQUOTE] = ACTIONS(5271),
    [anon_sym_U_DQUOTE] = ACTIONS(5271),
    [anon_sym_u8_DQUOTE] = ACTIONS(5271),
    [anon_sym_DQUOTE] = ACTIONS(5271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5274),
    [anon_sym_LR_DQUOTE] = ACTIONS(5274),
    [anon_sym_uR_DQUOTE] = ACTIONS(5274),
    [anon_sym_UR_DQUOTE] = ACTIONS(5274),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5274),
    [sym_literal_suffix] = ACTIONS(5269),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5267),
  },
  [2002] = {
    [sym_identifier] = ACTIONS(1964),
    [aux_sym_preproc_def_token1] = ACTIONS(1964),
    [aux_sym_preproc_if_token1] = ACTIONS(1964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1964),
    [sym_preproc_directive] = ACTIONS(1964),
    [anon_sym_LPAREN2] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [anon_sym_STAR] = ACTIONS(1966),
    [anon_sym_AMP_AMP] = ACTIONS(1966),
    [anon_sym_AMP] = ACTIONS(1964),
    [anon_sym___extension__] = ACTIONS(1964),
    [anon_sym_typedef] = ACTIONS(1964),
    [anon_sym___device__] = ACTIONS(1964),
    [anon_sym___host__] = ACTIONS(1964),
    [anon_sym___global__] = ACTIONS(1964),
    [anon_sym___forceinline__] = ACTIONS(1964),
    [anon_sym___noinline__] = ACTIONS(1964),
    [anon_sym_extern] = ACTIONS(1964),
    [anon_sym___attribute__] = ACTIONS(1964),
    [anon_sym_COLON_COLON] = ACTIONS(1966),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1966),
    [anon_sym___declspec] = ACTIONS(1964),
    [anon_sym___based] = ACTIONS(1964),
    [anon_sym_RBRACE] = ACTIONS(1966),
    [anon_sym_signed] = ACTIONS(1964),
    [anon_sym_unsigned] = ACTIONS(1964),
    [anon_sym_long] = ACTIONS(1964),
    [anon_sym_short] = ACTIONS(1964),
    [anon_sym_LBRACK] = ACTIONS(1964),
    [anon_sym_static] = ACTIONS(1964),
    [anon_sym_register] = ACTIONS(1964),
    [anon_sym_inline] = ACTIONS(1964),
    [anon_sym___inline] = ACTIONS(1964),
    [anon_sym___inline__] = ACTIONS(1964),
    [anon_sym___forceinline] = ACTIONS(1964),
    [anon_sym_thread_local] = ACTIONS(1964),
    [anon_sym___thread] = ACTIONS(1964),
    [anon_sym_const] = ACTIONS(1964),
    [anon_sym_constexpr] = ACTIONS(1964),
    [anon_sym_volatile] = ACTIONS(1964),
    [anon_sym_restrict] = ACTIONS(1964),
    [anon_sym___restrict__] = ACTIONS(1964),
    [anon_sym__Atomic] = ACTIONS(1964),
    [anon_sym__Noreturn] = ACTIONS(1964),
    [anon_sym_noreturn] = ACTIONS(1964),
    [anon_sym_mutable] = ACTIONS(1964),
    [anon_sym_constinit] = ACTIONS(1964),
    [anon_sym_consteval] = ACTIONS(1964),
    [anon_sym___shared__] = ACTIONS(1964),
    [anon_sym___local__] = ACTIONS(1964),
    [anon_sym___constant__] = ACTIONS(1964),
    [anon_sym___managed__] = ACTIONS(1964),
    [anon_sym___grid_constant__] = ACTIONS(1964),
    [anon_sym_alignas] = ACTIONS(1964),
    [anon_sym__Alignas] = ACTIONS(1964),
    [sym_primitive_type] = ACTIONS(1964),
    [anon_sym_enum] = ACTIONS(1964),
    [anon_sym_class] = ACTIONS(1964),
    [anon_sym_struct] = ACTIONS(1964),
    [anon_sym_union] = ACTIONS(1964),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1964),
    [anon_sym_decltype] = ACTIONS(1964),
    [sym_virtual] = ACTIONS(1964),
    [anon_sym_explicit] = ACTIONS(1964),
    [anon_sym_typename] = ACTIONS(1964),
    [anon_sym_template] = ACTIONS(1964),
    [anon_sym_operator] = ACTIONS(1964),
    [anon_sym_friend] = ACTIONS(1964),
    [anon_sym_public] = ACTIONS(1964),
    [anon_sym_private] = ACTIONS(1964),
    [anon_sym_protected] = ACTIONS(1964),
    [anon_sym_using] = ACTIONS(1964),
    [anon_sym_static_assert] = ACTIONS(1964),
    [anon_sym___launch_bounds__] = ACTIONS(1964),
  },
  [2003] = {
    [sym_identifier] = ACTIONS(5277),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5279),
    [anon_sym_COMMA] = ACTIONS(5279),
    [anon_sym_RPAREN] = ACTIONS(5279),
    [anon_sym_LPAREN2] = ACTIONS(5279),
    [anon_sym_DASH] = ACTIONS(5277),
    [anon_sym_PLUS] = ACTIONS(5277),
    [anon_sym_STAR] = ACTIONS(5279),
    [anon_sym_SLASH] = ACTIONS(5277),
    [anon_sym_PERCENT] = ACTIONS(5279),
    [anon_sym_PIPE_PIPE] = ACTIONS(5279),
    [anon_sym_AMP_AMP] = ACTIONS(5279),
    [anon_sym_PIPE] = ACTIONS(5277),
    [anon_sym_CARET] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5277),
    [anon_sym_EQ_EQ] = ACTIONS(5279),
    [anon_sym_BANG_EQ] = ACTIONS(5279),
    [anon_sym_GT] = ACTIONS(5277),
    [anon_sym_GT_EQ] = ACTIONS(5279),
    [anon_sym_LT_EQ] = ACTIONS(5277),
    [anon_sym_LT] = ACTIONS(5277),
    [anon_sym_LT_LT] = ACTIONS(5277),
    [anon_sym_GT_GT] = ACTIONS(5279),
    [anon_sym_SEMI] = ACTIONS(5279),
    [anon_sym___extension__] = ACTIONS(5277),
    [anon_sym___global__] = ACTIONS(5277),
    [anon_sym___attribute__] = ACTIONS(5277),
    [anon_sym___based] = ACTIONS(5277),
    [anon_sym_LBRACE] = ACTIONS(5279),
    [anon_sym_RBRACE] = ACTIONS(5279),
    [anon_sym_signed] = ACTIONS(5277),
    [anon_sym_unsigned] = ACTIONS(5277),
    [anon_sym_long] = ACTIONS(5277),
    [anon_sym_short] = ACTIONS(5277),
    [anon_sym_LBRACK] = ACTIONS(5279),
    [anon_sym_RBRACK] = ACTIONS(5279),
    [anon_sym_const] = ACTIONS(5277),
    [anon_sym_constexpr] = ACTIONS(5277),
    [anon_sym_volatile] = ACTIONS(5277),
    [anon_sym_restrict] = ACTIONS(5277),
    [anon_sym___restrict__] = ACTIONS(5277),
    [anon_sym__Atomic] = ACTIONS(5277),
    [anon_sym__Noreturn] = ACTIONS(5277),
    [anon_sym_noreturn] = ACTIONS(5277),
    [anon_sym_mutable] = ACTIONS(5277),
    [anon_sym_constinit] = ACTIONS(5277),
    [anon_sym_consteval] = ACTIONS(5277),
    [anon_sym___shared__] = ACTIONS(5277),
    [anon_sym___local__] = ACTIONS(5277),
    [anon_sym___constant__] = ACTIONS(5277),
    [anon_sym___managed__] = ACTIONS(5277),
    [anon_sym___grid_constant__] = ACTIONS(5277),
    [anon_sym_alignas] = ACTIONS(5277),
    [anon_sym__Alignas] = ACTIONS(5277),
    [sym_primitive_type] = ACTIONS(5277),
    [anon_sym_COLON] = ACTIONS(5279),
    [anon_sym_QMARK] = ACTIONS(5279),
    [anon_sym_LT_EQ_GT] = ACTIONS(5279),
    [anon_sym_or] = ACTIONS(5277),
    [anon_sym_and] = ACTIONS(5277),
    [anon_sym_bitor] = ACTIONS(5277),
    [anon_sym_xor] = ACTIONS(5277),
    [anon_sym_bitand] = ACTIONS(5277),
    [anon_sym_not_eq] = ACTIONS(5277),
    [anon_sym_DASH_DASH] = ACTIONS(5279),
    [anon_sym_PLUS_PLUS] = ACTIONS(5279),
    [anon_sym_DOT] = ACTIONS(5277),
    [anon_sym_DOT_STAR] = ACTIONS(5279),
    [anon_sym_DASH_GT] = ACTIONS(5279),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5277),
    [anon_sym_decltype] = ACTIONS(5277),
    [anon_sym_final] = ACTIONS(5277),
    [anon_sym_override] = ACTIONS(5277),
    [anon_sym_requires] = ACTIONS(5277),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5279),
  },
  [2004] = {
    [sym_identifier] = ACTIONS(5039),
    [aux_sym_preproc_def_token1] = ACTIONS(5039),
    [aux_sym_preproc_if_token1] = ACTIONS(5039),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5039),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5039),
    [sym_preproc_directive] = ACTIONS(5039),
    [anon_sym_LPAREN2] = ACTIONS(5041),
    [anon_sym_TILDE] = ACTIONS(5041),
    [anon_sym_STAR] = ACTIONS(5041),
    [anon_sym_AMP_AMP] = ACTIONS(5041),
    [anon_sym_AMP] = ACTIONS(5039),
    [anon_sym___extension__] = ACTIONS(5039),
    [anon_sym_typedef] = ACTIONS(5039),
    [anon_sym___device__] = ACTIONS(5039),
    [anon_sym___host__] = ACTIONS(5039),
    [anon_sym___global__] = ACTIONS(5039),
    [anon_sym___forceinline__] = ACTIONS(5039),
    [anon_sym___noinline__] = ACTIONS(5039),
    [anon_sym_extern] = ACTIONS(5039),
    [anon_sym___attribute__] = ACTIONS(5039),
    [anon_sym_COLON_COLON] = ACTIONS(5041),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5041),
    [anon_sym___declspec] = ACTIONS(5039),
    [anon_sym___based] = ACTIONS(5039),
    [anon_sym_RBRACE] = ACTIONS(5041),
    [anon_sym_signed] = ACTIONS(5039),
    [anon_sym_unsigned] = ACTIONS(5039),
    [anon_sym_long] = ACTIONS(5039),
    [anon_sym_short] = ACTIONS(5039),
    [anon_sym_LBRACK] = ACTIONS(5039),
    [anon_sym_static] = ACTIONS(5039),
    [anon_sym_register] = ACTIONS(5039),
    [anon_sym_inline] = ACTIONS(5039),
    [anon_sym___inline] = ACTIONS(5039),
    [anon_sym___inline__] = ACTIONS(5039),
    [anon_sym___forceinline] = ACTIONS(5039),
    [anon_sym_thread_local] = ACTIONS(5039),
    [anon_sym___thread] = ACTIONS(5039),
    [anon_sym_const] = ACTIONS(5039),
    [anon_sym_constexpr] = ACTIONS(5039),
    [anon_sym_volatile] = ACTIONS(5039),
    [anon_sym_restrict] = ACTIONS(5039),
    [anon_sym___restrict__] = ACTIONS(5039),
    [anon_sym__Atomic] = ACTIONS(5039),
    [anon_sym__Noreturn] = ACTIONS(5039),
    [anon_sym_noreturn] = ACTIONS(5039),
    [anon_sym_mutable] = ACTIONS(5039),
    [anon_sym_constinit] = ACTIONS(5039),
    [anon_sym_consteval] = ACTIONS(5039),
    [anon_sym___shared__] = ACTIONS(5039),
    [anon_sym___local__] = ACTIONS(5039),
    [anon_sym___constant__] = ACTIONS(5039),
    [anon_sym___managed__] = ACTIONS(5039),
    [anon_sym___grid_constant__] = ACTIONS(5039),
    [anon_sym_alignas] = ACTIONS(5039),
    [anon_sym__Alignas] = ACTIONS(5039),
    [sym_primitive_type] = ACTIONS(5039),
    [anon_sym_enum] = ACTIONS(5039),
    [anon_sym_class] = ACTIONS(5039),
    [anon_sym_struct] = ACTIONS(5039),
    [anon_sym_union] = ACTIONS(5039),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5039),
    [anon_sym_decltype] = ACTIONS(5039),
    [sym_virtual] = ACTIONS(5039),
    [anon_sym_explicit] = ACTIONS(5039),
    [anon_sym_typename] = ACTIONS(5039),
    [anon_sym_template] = ACTIONS(5039),
    [anon_sym_operator] = ACTIONS(5039),
    [anon_sym_friend] = ACTIONS(5039),
    [anon_sym_public] = ACTIONS(5039),
    [anon_sym_private] = ACTIONS(5039),
    [anon_sym_protected] = ACTIONS(5039),
    [anon_sym_using] = ACTIONS(5039),
    [anon_sym_static_assert] = ACTIONS(5039),
    [anon_sym___launch_bounds__] = ACTIONS(5039),
  },
  [2005] = {
    [sym_identifier] = ACTIONS(2392),
    [aux_sym_preproc_def_token1] = ACTIONS(2392),
    [aux_sym_preproc_if_token1] = ACTIONS(2392),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2392),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2392),
    [sym_preproc_directive] = ACTIONS(2392),
    [anon_sym_LPAREN2] = ACTIONS(2394),
    [anon_sym_TILDE] = ACTIONS(2394),
    [anon_sym_STAR] = ACTIONS(2394),
    [anon_sym_AMP_AMP] = ACTIONS(2394),
    [anon_sym_AMP] = ACTIONS(2392),
    [anon_sym___extension__] = ACTIONS(2392),
    [anon_sym_typedef] = ACTIONS(2392),
    [anon_sym___device__] = ACTIONS(2392),
    [anon_sym___host__] = ACTIONS(2392),
    [anon_sym___global__] = ACTIONS(2392),
    [anon_sym___forceinline__] = ACTIONS(2392),
    [anon_sym___noinline__] = ACTIONS(2392),
    [anon_sym_extern] = ACTIONS(2392),
    [anon_sym___attribute__] = ACTIONS(2392),
    [anon_sym_COLON_COLON] = ACTIONS(2394),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2394),
    [anon_sym___declspec] = ACTIONS(2392),
    [anon_sym___based] = ACTIONS(2392),
    [anon_sym_RBRACE] = ACTIONS(2394),
    [anon_sym_signed] = ACTIONS(2392),
    [anon_sym_unsigned] = ACTIONS(2392),
    [anon_sym_long] = ACTIONS(2392),
    [anon_sym_short] = ACTIONS(2392),
    [anon_sym_LBRACK] = ACTIONS(2392),
    [anon_sym_static] = ACTIONS(2392),
    [anon_sym_register] = ACTIONS(2392),
    [anon_sym_inline] = ACTIONS(2392),
    [anon_sym___inline] = ACTIONS(2392),
    [anon_sym___inline__] = ACTIONS(2392),
    [anon_sym___forceinline] = ACTIONS(2392),
    [anon_sym_thread_local] = ACTIONS(2392),
    [anon_sym___thread] = ACTIONS(2392),
    [anon_sym_const] = ACTIONS(2392),
    [anon_sym_constexpr] = ACTIONS(2392),
    [anon_sym_volatile] = ACTIONS(2392),
    [anon_sym_restrict] = ACTIONS(2392),
    [anon_sym___restrict__] = ACTIONS(2392),
    [anon_sym__Atomic] = ACTIONS(2392),
    [anon_sym__Noreturn] = ACTIONS(2392),
    [anon_sym_noreturn] = ACTIONS(2392),
    [anon_sym_mutable] = ACTIONS(2392),
    [anon_sym_constinit] = ACTIONS(2392),
    [anon_sym_consteval] = ACTIONS(2392),
    [anon_sym___shared__] = ACTIONS(2392),
    [anon_sym___local__] = ACTIONS(2392),
    [anon_sym___constant__] = ACTIONS(2392),
    [anon_sym___managed__] = ACTIONS(2392),
    [anon_sym___grid_constant__] = ACTIONS(2392),
    [anon_sym_alignas] = ACTIONS(2392),
    [anon_sym__Alignas] = ACTIONS(2392),
    [sym_primitive_type] = ACTIONS(2392),
    [anon_sym_enum] = ACTIONS(2392),
    [anon_sym_class] = ACTIONS(2392),
    [anon_sym_struct] = ACTIONS(2392),
    [anon_sym_union] = ACTIONS(2392),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2392),
    [anon_sym_decltype] = ACTIONS(2392),
    [sym_virtual] = ACTIONS(2392),
    [anon_sym_explicit] = ACTIONS(2392),
    [anon_sym_typename] = ACTIONS(2392),
    [anon_sym_template] = ACTIONS(2392),
    [anon_sym_operator] = ACTIONS(2392),
    [anon_sym_friend] = ACTIONS(2392),
    [anon_sym_public] = ACTIONS(2392),
    [anon_sym_private] = ACTIONS(2392),
    [anon_sym_protected] = ACTIONS(2392),
    [anon_sym_using] = ACTIONS(2392),
    [anon_sym_static_assert] = ACTIONS(2392),
    [anon_sym___launch_bounds__] = ACTIONS(2392),
  },
  [2006] = {
    [sym_identifier] = ACTIONS(5043),
    [aux_sym_preproc_def_token1] = ACTIONS(5043),
    [aux_sym_preproc_if_token1] = ACTIONS(5043),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5043),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5043),
    [sym_preproc_directive] = ACTIONS(5043),
    [anon_sym_LPAREN2] = ACTIONS(5045),
    [anon_sym_TILDE] = ACTIONS(5045),
    [anon_sym_STAR] = ACTIONS(5045),
    [anon_sym_AMP_AMP] = ACTIONS(5045),
    [anon_sym_AMP] = ACTIONS(5043),
    [anon_sym___extension__] = ACTIONS(5043),
    [anon_sym_typedef] = ACTIONS(5043),
    [anon_sym___device__] = ACTIONS(5043),
    [anon_sym___host__] = ACTIONS(5043),
    [anon_sym___global__] = ACTIONS(5043),
    [anon_sym___forceinline__] = ACTIONS(5043),
    [anon_sym___noinline__] = ACTIONS(5043),
    [anon_sym_extern] = ACTIONS(5043),
    [anon_sym___attribute__] = ACTIONS(5043),
    [anon_sym_COLON_COLON] = ACTIONS(5045),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5045),
    [anon_sym___declspec] = ACTIONS(5043),
    [anon_sym___based] = ACTIONS(5043),
    [anon_sym_RBRACE] = ACTIONS(5045),
    [anon_sym_signed] = ACTIONS(5043),
    [anon_sym_unsigned] = ACTIONS(5043),
    [anon_sym_long] = ACTIONS(5043),
    [anon_sym_short] = ACTIONS(5043),
    [anon_sym_LBRACK] = ACTIONS(5043),
    [anon_sym_static] = ACTIONS(5043),
    [anon_sym_register] = ACTIONS(5043),
    [anon_sym_inline] = ACTIONS(5043),
    [anon_sym___inline] = ACTIONS(5043),
    [anon_sym___inline__] = ACTIONS(5043),
    [anon_sym___forceinline] = ACTIONS(5043),
    [anon_sym_thread_local] = ACTIONS(5043),
    [anon_sym___thread] = ACTIONS(5043),
    [anon_sym_const] = ACTIONS(5043),
    [anon_sym_constexpr] = ACTIONS(5043),
    [anon_sym_volatile] = ACTIONS(5043),
    [anon_sym_restrict] = ACTIONS(5043),
    [anon_sym___restrict__] = ACTIONS(5043),
    [anon_sym__Atomic] = ACTIONS(5043),
    [anon_sym__Noreturn] = ACTIONS(5043),
    [anon_sym_noreturn] = ACTIONS(5043),
    [anon_sym_mutable] = ACTIONS(5043),
    [anon_sym_constinit] = ACTIONS(5043),
    [anon_sym_consteval] = ACTIONS(5043),
    [anon_sym___shared__] = ACTIONS(5043),
    [anon_sym___local__] = ACTIONS(5043),
    [anon_sym___constant__] = ACTIONS(5043),
    [anon_sym___managed__] = ACTIONS(5043),
    [anon_sym___grid_constant__] = ACTIONS(5043),
    [anon_sym_alignas] = ACTIONS(5043),
    [anon_sym__Alignas] = ACTIONS(5043),
    [sym_primitive_type] = ACTIONS(5043),
    [anon_sym_enum] = ACTIONS(5043),
    [anon_sym_class] = ACTIONS(5043),
    [anon_sym_struct] = ACTIONS(5043),
    [anon_sym_union] = ACTIONS(5043),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5043),
    [anon_sym_decltype] = ACTIONS(5043),
    [sym_virtual] = ACTIONS(5043),
    [anon_sym_explicit] = ACTIONS(5043),
    [anon_sym_typename] = ACTIONS(5043),
    [anon_sym_template] = ACTIONS(5043),
    [anon_sym_operator] = ACTIONS(5043),
    [anon_sym_friend] = ACTIONS(5043),
    [anon_sym_public] = ACTIONS(5043),
    [anon_sym_private] = ACTIONS(5043),
    [anon_sym_protected] = ACTIONS(5043),
    [anon_sym_using] = ACTIONS(5043),
    [anon_sym_static_assert] = ACTIONS(5043),
    [anon_sym___launch_bounds__] = ACTIONS(5043),
  },
  [2007] = {
    [sym_identifier] = ACTIONS(5083),
    [aux_sym_preproc_def_token1] = ACTIONS(5083),
    [aux_sym_preproc_if_token1] = ACTIONS(5083),
    [aux_sym_preproc_if_token2] = ACTIONS(5083),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5083),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5083),
    [sym_preproc_directive] = ACTIONS(5083),
    [anon_sym_LPAREN2] = ACTIONS(5085),
    [anon_sym_TILDE] = ACTIONS(5085),
    [anon_sym_STAR] = ACTIONS(5085),
    [anon_sym_AMP_AMP] = ACTIONS(5085),
    [anon_sym_AMP] = ACTIONS(5083),
    [anon_sym___extension__] = ACTIONS(5083),
    [anon_sym_typedef] = ACTIONS(5083),
    [anon_sym___device__] = ACTIONS(5083),
    [anon_sym___host__] = ACTIONS(5083),
    [anon_sym___global__] = ACTIONS(5083),
    [anon_sym___forceinline__] = ACTIONS(5083),
    [anon_sym___noinline__] = ACTIONS(5083),
    [anon_sym_extern] = ACTIONS(5083),
    [anon_sym___attribute__] = ACTIONS(5083),
    [anon_sym_COLON_COLON] = ACTIONS(5085),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5085),
    [anon_sym___declspec] = ACTIONS(5083),
    [anon_sym___based] = ACTIONS(5083),
    [anon_sym_signed] = ACTIONS(5083),
    [anon_sym_unsigned] = ACTIONS(5083),
    [anon_sym_long] = ACTIONS(5083),
    [anon_sym_short] = ACTIONS(5083),
    [anon_sym_LBRACK] = ACTIONS(5083),
    [anon_sym_static] = ACTIONS(5083),
    [anon_sym_register] = ACTIONS(5083),
    [anon_sym_inline] = ACTIONS(5083),
    [anon_sym___inline] = ACTIONS(5083),
    [anon_sym___inline__] = ACTIONS(5083),
    [anon_sym___forceinline] = ACTIONS(5083),
    [anon_sym_thread_local] = ACTIONS(5083),
    [anon_sym___thread] = ACTIONS(5083),
    [anon_sym_const] = ACTIONS(5083),
    [anon_sym_constexpr] = ACTIONS(5083),
    [anon_sym_volatile] = ACTIONS(5083),
    [anon_sym_restrict] = ACTIONS(5083),
    [anon_sym___restrict__] = ACTIONS(5083),
    [anon_sym__Atomic] = ACTIONS(5083),
    [anon_sym__Noreturn] = ACTIONS(5083),
    [anon_sym_noreturn] = ACTIONS(5083),
    [anon_sym_mutable] = ACTIONS(5083),
    [anon_sym_constinit] = ACTIONS(5083),
    [anon_sym_consteval] = ACTIONS(5083),
    [anon_sym___shared__] = ACTIONS(5083),
    [anon_sym___local__] = ACTIONS(5083),
    [anon_sym___constant__] = ACTIONS(5083),
    [anon_sym___managed__] = ACTIONS(5083),
    [anon_sym___grid_constant__] = ACTIONS(5083),
    [anon_sym_alignas] = ACTIONS(5083),
    [anon_sym__Alignas] = ACTIONS(5083),
    [sym_primitive_type] = ACTIONS(5083),
    [anon_sym_enum] = ACTIONS(5083),
    [anon_sym_class] = ACTIONS(5083),
    [anon_sym_struct] = ACTIONS(5083),
    [anon_sym_union] = ACTIONS(5083),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5083),
    [anon_sym_decltype] = ACTIONS(5083),
    [sym_virtual] = ACTIONS(5083),
    [anon_sym_explicit] = ACTIONS(5083),
    [anon_sym_typename] = ACTIONS(5083),
    [anon_sym_template] = ACTIONS(5083),
    [anon_sym_operator] = ACTIONS(5083),
    [anon_sym_friend] = ACTIONS(5083),
    [anon_sym_public] = ACTIONS(5083),
    [anon_sym_private] = ACTIONS(5083),
    [anon_sym_protected] = ACTIONS(5083),
    [anon_sym_using] = ACTIONS(5083),
    [anon_sym_static_assert] = ACTIONS(5083),
    [anon_sym___launch_bounds__] = ACTIONS(5083),
  },
  [2008] = {
    [sym_identifier] = ACTIONS(5087),
    [aux_sym_preproc_def_token1] = ACTIONS(5087),
    [aux_sym_preproc_if_token1] = ACTIONS(5087),
    [aux_sym_preproc_if_token2] = ACTIONS(5087),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5087),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5087),
    [sym_preproc_directive] = ACTIONS(5087),
    [anon_sym_LPAREN2] = ACTIONS(5089),
    [anon_sym_TILDE] = ACTIONS(5089),
    [anon_sym_STAR] = ACTIONS(5089),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_AMP] = ACTIONS(5087),
    [anon_sym___extension__] = ACTIONS(5087),
    [anon_sym_typedef] = ACTIONS(5087),
    [anon_sym___device__] = ACTIONS(5087),
    [anon_sym___host__] = ACTIONS(5087),
    [anon_sym___global__] = ACTIONS(5087),
    [anon_sym___forceinline__] = ACTIONS(5087),
    [anon_sym___noinline__] = ACTIONS(5087),
    [anon_sym_extern] = ACTIONS(5087),
    [anon_sym___attribute__] = ACTIONS(5087),
    [anon_sym_COLON_COLON] = ACTIONS(5089),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5089),
    [anon_sym___declspec] = ACTIONS(5087),
    [anon_sym___based] = ACTIONS(5087),
    [anon_sym_signed] = ACTIONS(5087),
    [anon_sym_unsigned] = ACTIONS(5087),
    [anon_sym_long] = ACTIONS(5087),
    [anon_sym_short] = ACTIONS(5087),
    [anon_sym_LBRACK] = ACTIONS(5087),
    [anon_sym_static] = ACTIONS(5087),
    [anon_sym_register] = ACTIONS(5087),
    [anon_sym_inline] = ACTIONS(5087),
    [anon_sym___inline] = ACTIONS(5087),
    [anon_sym___inline__] = ACTIONS(5087),
    [anon_sym___forceinline] = ACTIONS(5087),
    [anon_sym_thread_local] = ACTIONS(5087),
    [anon_sym___thread] = ACTIONS(5087),
    [anon_sym_const] = ACTIONS(5087),
    [anon_sym_constexpr] = ACTIONS(5087),
    [anon_sym_volatile] = ACTIONS(5087),
    [anon_sym_restrict] = ACTIONS(5087),
    [anon_sym___restrict__] = ACTIONS(5087),
    [anon_sym__Atomic] = ACTIONS(5087),
    [anon_sym__Noreturn] = ACTIONS(5087),
    [anon_sym_noreturn] = ACTIONS(5087),
    [anon_sym_mutable] = ACTIONS(5087),
    [anon_sym_constinit] = ACTIONS(5087),
    [anon_sym_consteval] = ACTIONS(5087),
    [anon_sym___shared__] = ACTIONS(5087),
    [anon_sym___local__] = ACTIONS(5087),
    [anon_sym___constant__] = ACTIONS(5087),
    [anon_sym___managed__] = ACTIONS(5087),
    [anon_sym___grid_constant__] = ACTIONS(5087),
    [anon_sym_alignas] = ACTIONS(5087),
    [anon_sym__Alignas] = ACTIONS(5087),
    [sym_primitive_type] = ACTIONS(5087),
    [anon_sym_enum] = ACTIONS(5087),
    [anon_sym_class] = ACTIONS(5087),
    [anon_sym_struct] = ACTIONS(5087),
    [anon_sym_union] = ACTIONS(5087),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5087),
    [anon_sym_decltype] = ACTIONS(5087),
    [sym_virtual] = ACTIONS(5087),
    [anon_sym_explicit] = ACTIONS(5087),
    [anon_sym_typename] = ACTIONS(5087),
    [anon_sym_template] = ACTIONS(5087),
    [anon_sym_operator] = ACTIONS(5087),
    [anon_sym_friend] = ACTIONS(5087),
    [anon_sym_public] = ACTIONS(5087),
    [anon_sym_private] = ACTIONS(5087),
    [anon_sym_protected] = ACTIONS(5087),
    [anon_sym_using] = ACTIONS(5087),
    [anon_sym_static_assert] = ACTIONS(5087),
    [anon_sym___launch_bounds__] = ACTIONS(5087),
  },
  [2009] = {
    [sym_identifier] = ACTIONS(5281),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5283),
    [anon_sym_COMMA] = ACTIONS(5283),
    [anon_sym_RPAREN] = ACTIONS(5283),
    [anon_sym_LPAREN2] = ACTIONS(5283),
    [anon_sym_DASH] = ACTIONS(5281),
    [anon_sym_PLUS] = ACTIONS(5281),
    [anon_sym_STAR] = ACTIONS(5283),
    [anon_sym_SLASH] = ACTIONS(5281),
    [anon_sym_PERCENT] = ACTIONS(5283),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5283),
    [anon_sym_PIPE] = ACTIONS(5281),
    [anon_sym_CARET] = ACTIONS(5283),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_EQ_EQ] = ACTIONS(5283),
    [anon_sym_BANG_EQ] = ACTIONS(5283),
    [anon_sym_GT] = ACTIONS(5281),
    [anon_sym_GT_EQ] = ACTIONS(5283),
    [anon_sym_LT_EQ] = ACTIONS(5281),
    [anon_sym_LT] = ACTIONS(5281),
    [anon_sym_LT_LT] = ACTIONS(5281),
    [anon_sym_GT_GT] = ACTIONS(5283),
    [anon_sym_SEMI] = ACTIONS(5283),
    [anon_sym___extension__] = ACTIONS(5281),
    [anon_sym___global__] = ACTIONS(5281),
    [anon_sym___attribute__] = ACTIONS(5281),
    [anon_sym___based] = ACTIONS(5281),
    [anon_sym_LBRACE] = ACTIONS(5283),
    [anon_sym_RBRACE] = ACTIONS(5283),
    [anon_sym_signed] = ACTIONS(5281),
    [anon_sym_unsigned] = ACTIONS(5281),
    [anon_sym_long] = ACTIONS(5281),
    [anon_sym_short] = ACTIONS(5281),
    [anon_sym_LBRACK] = ACTIONS(5283),
    [anon_sym_RBRACK] = ACTIONS(5283),
    [anon_sym_const] = ACTIONS(5281),
    [anon_sym_constexpr] = ACTIONS(5281),
    [anon_sym_volatile] = ACTIONS(5281),
    [anon_sym_restrict] = ACTIONS(5281),
    [anon_sym___restrict__] = ACTIONS(5281),
    [anon_sym__Atomic] = ACTIONS(5281),
    [anon_sym__Noreturn] = ACTIONS(5281),
    [anon_sym_noreturn] = ACTIONS(5281),
    [anon_sym_mutable] = ACTIONS(5281),
    [anon_sym_constinit] = ACTIONS(5281),
    [anon_sym_consteval] = ACTIONS(5281),
    [anon_sym___shared__] = ACTIONS(5281),
    [anon_sym___local__] = ACTIONS(5281),
    [anon_sym___constant__] = ACTIONS(5281),
    [anon_sym___managed__] = ACTIONS(5281),
    [anon_sym___grid_constant__] = ACTIONS(5281),
    [anon_sym_alignas] = ACTIONS(5281),
    [anon_sym__Alignas] = ACTIONS(5281),
    [sym_primitive_type] = ACTIONS(5281),
    [anon_sym_COLON] = ACTIONS(5283),
    [anon_sym_QMARK] = ACTIONS(5283),
    [anon_sym_LT_EQ_GT] = ACTIONS(5283),
    [anon_sym_or] = ACTIONS(5281),
    [anon_sym_and] = ACTIONS(5281),
    [anon_sym_bitor] = ACTIONS(5281),
    [anon_sym_xor] = ACTIONS(5281),
    [anon_sym_bitand] = ACTIONS(5281),
    [anon_sym_not_eq] = ACTIONS(5281),
    [anon_sym_DASH_DASH] = ACTIONS(5283),
    [anon_sym_PLUS_PLUS] = ACTIONS(5283),
    [anon_sym_DOT] = ACTIONS(5281),
    [anon_sym_DOT_STAR] = ACTIONS(5283),
    [anon_sym_DASH_GT] = ACTIONS(5283),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5281),
    [anon_sym_decltype] = ACTIONS(5281),
    [anon_sym_final] = ACTIONS(5281),
    [anon_sym_override] = ACTIONS(5281),
    [anon_sym_requires] = ACTIONS(5281),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5283),
  },
  [2010] = {
    [sym_identifier] = ACTIONS(2231),
    [aux_sym_preproc_def_token1] = ACTIONS(2231),
    [aux_sym_preproc_if_token1] = ACTIONS(2231),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2231),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2231),
    [sym_preproc_directive] = ACTIONS(2231),
    [anon_sym_LPAREN2] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_STAR] = ACTIONS(2233),
    [anon_sym_AMP_AMP] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym___extension__] = ACTIONS(2231),
    [anon_sym_typedef] = ACTIONS(2231),
    [anon_sym___device__] = ACTIONS(2231),
    [anon_sym___host__] = ACTIONS(2231),
    [anon_sym___global__] = ACTIONS(2231),
    [anon_sym___forceinline__] = ACTIONS(2231),
    [anon_sym___noinline__] = ACTIONS(2231),
    [anon_sym_extern] = ACTIONS(2231),
    [anon_sym___attribute__] = ACTIONS(2231),
    [anon_sym_COLON_COLON] = ACTIONS(2233),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2233),
    [anon_sym___declspec] = ACTIONS(2231),
    [anon_sym___based] = ACTIONS(2231),
    [anon_sym_RBRACE] = ACTIONS(2233),
    [anon_sym_signed] = ACTIONS(2231),
    [anon_sym_unsigned] = ACTIONS(2231),
    [anon_sym_long] = ACTIONS(2231),
    [anon_sym_short] = ACTIONS(2231),
    [anon_sym_LBRACK] = ACTIONS(2231),
    [anon_sym_static] = ACTIONS(2231),
    [anon_sym_register] = ACTIONS(2231),
    [anon_sym_inline] = ACTIONS(2231),
    [anon_sym___inline] = ACTIONS(2231),
    [anon_sym___inline__] = ACTIONS(2231),
    [anon_sym___forceinline] = ACTIONS(2231),
    [anon_sym_thread_local] = ACTIONS(2231),
    [anon_sym___thread] = ACTIONS(2231),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_constexpr] = ACTIONS(2231),
    [anon_sym_volatile] = ACTIONS(2231),
    [anon_sym_restrict] = ACTIONS(2231),
    [anon_sym___restrict__] = ACTIONS(2231),
    [anon_sym__Atomic] = ACTIONS(2231),
    [anon_sym__Noreturn] = ACTIONS(2231),
    [anon_sym_noreturn] = ACTIONS(2231),
    [anon_sym_mutable] = ACTIONS(2231),
    [anon_sym_constinit] = ACTIONS(2231),
    [anon_sym_consteval] = ACTIONS(2231),
    [anon_sym___shared__] = ACTIONS(2231),
    [anon_sym___local__] = ACTIONS(2231),
    [anon_sym___constant__] = ACTIONS(2231),
    [anon_sym___managed__] = ACTIONS(2231),
    [anon_sym___grid_constant__] = ACTIONS(2231),
    [anon_sym_alignas] = ACTIONS(2231),
    [anon_sym__Alignas] = ACTIONS(2231),
    [sym_primitive_type] = ACTIONS(2231),
    [anon_sym_enum] = ACTIONS(2231),
    [anon_sym_class] = ACTIONS(2231),
    [anon_sym_struct] = ACTIONS(2231),
    [anon_sym_union] = ACTIONS(2231),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2231),
    [anon_sym_decltype] = ACTIONS(2231),
    [sym_virtual] = ACTIONS(2231),
    [anon_sym_explicit] = ACTIONS(2231),
    [anon_sym_typename] = ACTIONS(2231),
    [anon_sym_template] = ACTIONS(2231),
    [anon_sym_operator] = ACTIONS(2231),
    [anon_sym_friend] = ACTIONS(2231),
    [anon_sym_public] = ACTIONS(2231),
    [anon_sym_private] = ACTIONS(2231),
    [anon_sym_protected] = ACTIONS(2231),
    [anon_sym_using] = ACTIONS(2231),
    [anon_sym_static_assert] = ACTIONS(2231),
    [anon_sym___launch_bounds__] = ACTIONS(2231),
  },
  [2011] = {
    [sym_identifier] = ACTIONS(5285),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5287),
    [anon_sym_COMMA] = ACTIONS(5287),
    [anon_sym_RPAREN] = ACTIONS(5287),
    [anon_sym_LPAREN2] = ACTIONS(5287),
    [anon_sym_DASH] = ACTIONS(5285),
    [anon_sym_PLUS] = ACTIONS(5285),
    [anon_sym_STAR] = ACTIONS(5287),
    [anon_sym_SLASH] = ACTIONS(5285),
    [anon_sym_PERCENT] = ACTIONS(5287),
    [anon_sym_PIPE_PIPE] = ACTIONS(5287),
    [anon_sym_AMP_AMP] = ACTIONS(5287),
    [anon_sym_PIPE] = ACTIONS(5285),
    [anon_sym_CARET] = ACTIONS(5287),
    [anon_sym_AMP] = ACTIONS(5285),
    [anon_sym_EQ_EQ] = ACTIONS(5287),
    [anon_sym_BANG_EQ] = ACTIONS(5287),
    [anon_sym_GT] = ACTIONS(5285),
    [anon_sym_GT_EQ] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5285),
    [anon_sym_LT_LT] = ACTIONS(5285),
    [anon_sym_GT_GT] = ACTIONS(5287),
    [anon_sym_SEMI] = ACTIONS(5287),
    [anon_sym___extension__] = ACTIONS(5285),
    [anon_sym___global__] = ACTIONS(5285),
    [anon_sym___attribute__] = ACTIONS(5285),
    [anon_sym___based] = ACTIONS(5285),
    [anon_sym_LBRACE] = ACTIONS(5287),
    [anon_sym_RBRACE] = ACTIONS(5287),
    [anon_sym_signed] = ACTIONS(5285),
    [anon_sym_unsigned] = ACTIONS(5285),
    [anon_sym_long] = ACTIONS(5285),
    [anon_sym_short] = ACTIONS(5285),
    [anon_sym_LBRACK] = ACTIONS(5287),
    [anon_sym_RBRACK] = ACTIONS(5287),
    [anon_sym_const] = ACTIONS(5285),
    [anon_sym_constexpr] = ACTIONS(5285),
    [anon_sym_volatile] = ACTIONS(5285),
    [anon_sym_restrict] = ACTIONS(5285),
    [anon_sym___restrict__] = ACTIONS(5285),
    [anon_sym__Atomic] = ACTIONS(5285),
    [anon_sym__Noreturn] = ACTIONS(5285),
    [anon_sym_noreturn] = ACTIONS(5285),
    [anon_sym_mutable] = ACTIONS(5285),
    [anon_sym_constinit] = ACTIONS(5285),
    [anon_sym_consteval] = ACTIONS(5285),
    [anon_sym___shared__] = ACTIONS(5285),
    [anon_sym___local__] = ACTIONS(5285),
    [anon_sym___constant__] = ACTIONS(5285),
    [anon_sym___managed__] = ACTIONS(5285),
    [anon_sym___grid_constant__] = ACTIONS(5285),
    [anon_sym_alignas] = ACTIONS(5285),
    [anon_sym__Alignas] = ACTIONS(5285),
    [sym_primitive_type] = ACTIONS(5285),
    [anon_sym_COLON] = ACTIONS(5287),
    [anon_sym_QMARK] = ACTIONS(5287),
    [anon_sym_LT_EQ_GT] = ACTIONS(5287),
    [anon_sym_or] = ACTIONS(5285),
    [anon_sym_and] = ACTIONS(5285),
    [anon_sym_bitor] = ACTIONS(5285),
    [anon_sym_xor] = ACTIONS(5285),
    [anon_sym_bitand] = ACTIONS(5285),
    [anon_sym_not_eq] = ACTIONS(5285),
    [anon_sym_DASH_DASH] = ACTIONS(5287),
    [anon_sym_PLUS_PLUS] = ACTIONS(5287),
    [anon_sym_DOT] = ACTIONS(5285),
    [anon_sym_DOT_STAR] = ACTIONS(5287),
    [anon_sym_DASH_GT] = ACTIONS(5287),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5285),
    [anon_sym_decltype] = ACTIONS(5285),
    [anon_sym_final] = ACTIONS(5285),
    [anon_sym_override] = ACTIONS(5285),
    [anon_sym_requires] = ACTIONS(5285),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5287),
  },
  [2012] = {
    [sym_identifier] = ACTIONS(2176),
    [aux_sym_preproc_def_token1] = ACTIONS(2176),
    [aux_sym_preproc_if_token1] = ACTIONS(2176),
    [aux_sym_preproc_if_token2] = ACTIONS(2176),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2176),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2176),
    [sym_preproc_directive] = ACTIONS(2176),
    [anon_sym_LPAREN2] = ACTIONS(2178),
    [anon_sym_TILDE] = ACTIONS(2178),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_AMP_AMP] = ACTIONS(2178),
    [anon_sym_AMP] = ACTIONS(2176),
    [anon_sym___extension__] = ACTIONS(2176),
    [anon_sym_typedef] = ACTIONS(2176),
    [anon_sym___device__] = ACTIONS(2176),
    [anon_sym___host__] = ACTIONS(2176),
    [anon_sym___global__] = ACTIONS(2176),
    [anon_sym___forceinline__] = ACTIONS(2176),
    [anon_sym___noinline__] = ACTIONS(2176),
    [anon_sym_extern] = ACTIONS(2176),
    [anon_sym___attribute__] = ACTIONS(2176),
    [anon_sym_COLON_COLON] = ACTIONS(2178),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2178),
    [anon_sym___declspec] = ACTIONS(2176),
    [anon_sym___based] = ACTIONS(2176),
    [anon_sym_signed] = ACTIONS(2176),
    [anon_sym_unsigned] = ACTIONS(2176),
    [anon_sym_long] = ACTIONS(2176),
    [anon_sym_short] = ACTIONS(2176),
    [anon_sym_LBRACK] = ACTIONS(2176),
    [anon_sym_static] = ACTIONS(2176),
    [anon_sym_register] = ACTIONS(2176),
    [anon_sym_inline] = ACTIONS(2176),
    [anon_sym___inline] = ACTIONS(2176),
    [anon_sym___inline__] = ACTIONS(2176),
    [anon_sym___forceinline] = ACTIONS(2176),
    [anon_sym_thread_local] = ACTIONS(2176),
    [anon_sym___thread] = ACTIONS(2176),
    [anon_sym_const] = ACTIONS(2176),
    [anon_sym_constexpr] = ACTIONS(2176),
    [anon_sym_volatile] = ACTIONS(2176),
    [anon_sym_restrict] = ACTIONS(2176),
    [anon_sym___restrict__] = ACTIONS(2176),
    [anon_sym__Atomic] = ACTIONS(2176),
    [anon_sym__Noreturn] = ACTIONS(2176),
    [anon_sym_noreturn] = ACTIONS(2176),
    [anon_sym_mutable] = ACTIONS(2176),
    [anon_sym_constinit] = ACTIONS(2176),
    [anon_sym_consteval] = ACTIONS(2176),
    [anon_sym___shared__] = ACTIONS(2176),
    [anon_sym___local__] = ACTIONS(2176),
    [anon_sym___constant__] = ACTIONS(2176),
    [anon_sym___managed__] = ACTIONS(2176),
    [anon_sym___grid_constant__] = ACTIONS(2176),
    [anon_sym_alignas] = ACTIONS(2176),
    [anon_sym__Alignas] = ACTIONS(2176),
    [sym_primitive_type] = ACTIONS(2176),
    [anon_sym_enum] = ACTIONS(2176),
    [anon_sym_class] = ACTIONS(2176),
    [anon_sym_struct] = ACTIONS(2176),
    [anon_sym_union] = ACTIONS(2176),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2176),
    [anon_sym_decltype] = ACTIONS(2176),
    [sym_virtual] = ACTIONS(2176),
    [anon_sym_explicit] = ACTIONS(2176),
    [anon_sym_typename] = ACTIONS(2176),
    [anon_sym_template] = ACTIONS(2176),
    [anon_sym_operator] = ACTIONS(2176),
    [anon_sym_friend] = ACTIONS(2176),
    [anon_sym_public] = ACTIONS(2176),
    [anon_sym_private] = ACTIONS(2176),
    [anon_sym_protected] = ACTIONS(2176),
    [anon_sym_using] = ACTIONS(2176),
    [anon_sym_static_assert] = ACTIONS(2176),
    [anon_sym___launch_bounds__] = ACTIONS(2176),
  },
  [2013] = {
    [sym_identifier] = ACTIONS(5289),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5291),
    [anon_sym_COMMA] = ACTIONS(5291),
    [anon_sym_RPAREN] = ACTIONS(5291),
    [anon_sym_LPAREN2] = ACTIONS(5291),
    [anon_sym_DASH] = ACTIONS(5289),
    [anon_sym_PLUS] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_SLASH] = ACTIONS(5289),
    [anon_sym_PERCENT] = ACTIONS(5291),
    [anon_sym_PIPE_PIPE] = ACTIONS(5291),
    [anon_sym_AMP_AMP] = ACTIONS(5291),
    [anon_sym_PIPE] = ACTIONS(5289),
    [anon_sym_CARET] = ACTIONS(5291),
    [anon_sym_AMP] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5291),
    [anon_sym_BANG_EQ] = ACTIONS(5291),
    [anon_sym_GT] = ACTIONS(5289),
    [anon_sym_GT_EQ] = ACTIONS(5291),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_LT] = ACTIONS(5289),
    [anon_sym_LT_LT] = ACTIONS(5289),
    [anon_sym_GT_GT] = ACTIONS(5291),
    [anon_sym_SEMI] = ACTIONS(5291),
    [anon_sym___extension__] = ACTIONS(5289),
    [anon_sym___global__] = ACTIONS(5289),
    [anon_sym___attribute__] = ACTIONS(5289),
    [anon_sym___based] = ACTIONS(5289),
    [anon_sym_LBRACE] = ACTIONS(5291),
    [anon_sym_RBRACE] = ACTIONS(5291),
    [anon_sym_signed] = ACTIONS(5289),
    [anon_sym_unsigned] = ACTIONS(5289),
    [anon_sym_long] = ACTIONS(5289),
    [anon_sym_short] = ACTIONS(5289),
    [anon_sym_LBRACK] = ACTIONS(5291),
    [anon_sym_RBRACK] = ACTIONS(5291),
    [anon_sym_const] = ACTIONS(5289),
    [anon_sym_constexpr] = ACTIONS(5289),
    [anon_sym_volatile] = ACTIONS(5289),
    [anon_sym_restrict] = ACTIONS(5289),
    [anon_sym___restrict__] = ACTIONS(5289),
    [anon_sym__Atomic] = ACTIONS(5289),
    [anon_sym__Noreturn] = ACTIONS(5289),
    [anon_sym_noreturn] = ACTIONS(5289),
    [anon_sym_mutable] = ACTIONS(5289),
    [anon_sym_constinit] = ACTIONS(5289),
    [anon_sym_consteval] = ACTIONS(5289),
    [anon_sym___shared__] = ACTIONS(5289),
    [anon_sym___local__] = ACTIONS(5289),
    [anon_sym___constant__] = ACTIONS(5289),
    [anon_sym___managed__] = ACTIONS(5289),
    [anon_sym___grid_constant__] = ACTIONS(5289),
    [anon_sym_alignas] = ACTIONS(5289),
    [anon_sym__Alignas] = ACTIONS(5289),
    [sym_primitive_type] = ACTIONS(5289),
    [anon_sym_COLON] = ACTIONS(5291),
    [anon_sym_QMARK] = ACTIONS(5291),
    [anon_sym_LT_EQ_GT] = ACTIONS(5291),
    [anon_sym_or] = ACTIONS(5289),
    [anon_sym_and] = ACTIONS(5289),
    [anon_sym_bitor] = ACTIONS(5289),
    [anon_sym_xor] = ACTIONS(5289),
    [anon_sym_bitand] = ACTIONS(5289),
    [anon_sym_not_eq] = ACTIONS(5289),
    [anon_sym_DASH_DASH] = ACTIONS(5291),
    [anon_sym_PLUS_PLUS] = ACTIONS(5291),
    [anon_sym_DOT] = ACTIONS(5289),
    [anon_sym_DOT_STAR] = ACTIONS(5291),
    [anon_sym_DASH_GT] = ACTIONS(5291),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5289),
    [anon_sym_decltype] = ACTIONS(5289),
    [anon_sym_final] = ACTIONS(5289),
    [anon_sym_override] = ACTIONS(5289),
    [anon_sym_requires] = ACTIONS(5289),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5291),
  },
  [2014] = {
    [sym_identifier] = ACTIONS(5043),
    [aux_sym_preproc_def_token1] = ACTIONS(5043),
    [aux_sym_preproc_if_token1] = ACTIONS(5043),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5043),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5043),
    [sym_preproc_directive] = ACTIONS(5043),
    [anon_sym_LPAREN2] = ACTIONS(5045),
    [anon_sym_TILDE] = ACTIONS(5045),
    [anon_sym_STAR] = ACTIONS(5045),
    [anon_sym_AMP_AMP] = ACTIONS(5045),
    [anon_sym_AMP] = ACTIONS(5043),
    [anon_sym___extension__] = ACTIONS(5043),
    [anon_sym_typedef] = ACTIONS(5043),
    [anon_sym___device__] = ACTIONS(5043),
    [anon_sym___host__] = ACTIONS(5043),
    [anon_sym___global__] = ACTIONS(5043),
    [anon_sym___forceinline__] = ACTIONS(5043),
    [anon_sym___noinline__] = ACTIONS(5043),
    [anon_sym_extern] = ACTIONS(5043),
    [anon_sym___attribute__] = ACTIONS(5043),
    [anon_sym_COLON_COLON] = ACTIONS(5045),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5045),
    [anon_sym___declspec] = ACTIONS(5043),
    [anon_sym___based] = ACTIONS(5043),
    [anon_sym_RBRACE] = ACTIONS(5045),
    [anon_sym_signed] = ACTIONS(5043),
    [anon_sym_unsigned] = ACTIONS(5043),
    [anon_sym_long] = ACTIONS(5043),
    [anon_sym_short] = ACTIONS(5043),
    [anon_sym_LBRACK] = ACTIONS(5043),
    [anon_sym_static] = ACTIONS(5043),
    [anon_sym_register] = ACTIONS(5043),
    [anon_sym_inline] = ACTIONS(5043),
    [anon_sym___inline] = ACTIONS(5043),
    [anon_sym___inline__] = ACTIONS(5043),
    [anon_sym___forceinline] = ACTIONS(5043),
    [anon_sym_thread_local] = ACTIONS(5043),
    [anon_sym___thread] = ACTIONS(5043),
    [anon_sym_const] = ACTIONS(5043),
    [anon_sym_constexpr] = ACTIONS(5043),
    [anon_sym_volatile] = ACTIONS(5043),
    [anon_sym_restrict] = ACTIONS(5043),
    [anon_sym___restrict__] = ACTIONS(5043),
    [anon_sym__Atomic] = ACTIONS(5043),
    [anon_sym__Noreturn] = ACTIONS(5043),
    [anon_sym_noreturn] = ACTIONS(5043),
    [anon_sym_mutable] = ACTIONS(5043),
    [anon_sym_constinit] = ACTIONS(5043),
    [anon_sym_consteval] = ACTIONS(5043),
    [anon_sym___shared__] = ACTIONS(5043),
    [anon_sym___local__] = ACTIONS(5043),
    [anon_sym___constant__] = ACTIONS(5043),
    [anon_sym___managed__] = ACTIONS(5043),
    [anon_sym___grid_constant__] = ACTIONS(5043),
    [anon_sym_alignas] = ACTIONS(5043),
    [anon_sym__Alignas] = ACTIONS(5043),
    [sym_primitive_type] = ACTIONS(5043),
    [anon_sym_enum] = ACTIONS(5043),
    [anon_sym_class] = ACTIONS(5043),
    [anon_sym_struct] = ACTIONS(5043),
    [anon_sym_union] = ACTIONS(5043),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5043),
    [anon_sym_decltype] = ACTIONS(5043),
    [sym_virtual] = ACTIONS(5043),
    [anon_sym_explicit] = ACTIONS(5043),
    [anon_sym_typename] = ACTIONS(5043),
    [anon_sym_template] = ACTIONS(5043),
    [anon_sym_operator] = ACTIONS(5043),
    [anon_sym_friend] = ACTIONS(5043),
    [anon_sym_public] = ACTIONS(5043),
    [anon_sym_private] = ACTIONS(5043),
    [anon_sym_protected] = ACTIONS(5043),
    [anon_sym_using] = ACTIONS(5043),
    [anon_sym_static_assert] = ACTIONS(5043),
    [anon_sym___launch_bounds__] = ACTIONS(5043),
  },
  [2015] = {
    [sym_identifier] = ACTIONS(1964),
    [aux_sym_preproc_def_token1] = ACTIONS(1964),
    [aux_sym_preproc_if_token1] = ACTIONS(1964),
    [aux_sym_preproc_if_token2] = ACTIONS(1964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1964),
    [sym_preproc_directive] = ACTIONS(1964),
    [anon_sym_LPAREN2] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [anon_sym_STAR] = ACTIONS(1966),
    [anon_sym_AMP_AMP] = ACTIONS(1966),
    [anon_sym_AMP] = ACTIONS(1964),
    [anon_sym___extension__] = ACTIONS(1964),
    [anon_sym_typedef] = ACTIONS(1964),
    [anon_sym___device__] = ACTIONS(1964),
    [anon_sym___host__] = ACTIONS(1964),
    [anon_sym___global__] = ACTIONS(1964),
    [anon_sym___forceinline__] = ACTIONS(1964),
    [anon_sym___noinline__] = ACTIONS(1964),
    [anon_sym_extern] = ACTIONS(1964),
    [anon_sym___attribute__] = ACTIONS(1964),
    [anon_sym_COLON_COLON] = ACTIONS(1966),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1966),
    [anon_sym___declspec] = ACTIONS(1964),
    [anon_sym___based] = ACTIONS(1964),
    [anon_sym_signed] = ACTIONS(1964),
    [anon_sym_unsigned] = ACTIONS(1964),
    [anon_sym_long] = ACTIONS(1964),
    [anon_sym_short] = ACTIONS(1964),
    [anon_sym_LBRACK] = ACTIONS(1964),
    [anon_sym_static] = ACTIONS(1964),
    [anon_sym_register] = ACTIONS(1964),
    [anon_sym_inline] = ACTIONS(1964),
    [anon_sym___inline] = ACTIONS(1964),
    [anon_sym___inline__] = ACTIONS(1964),
    [anon_sym___forceinline] = ACTIONS(1964),
    [anon_sym_thread_local] = ACTIONS(1964),
    [anon_sym___thread] = ACTIONS(1964),
    [anon_sym_const] = ACTIONS(1964),
    [anon_sym_constexpr] = ACTIONS(1964),
    [anon_sym_volatile] = ACTIONS(1964),
    [anon_sym_restrict] = ACTIONS(1964),
    [anon_sym___restrict__] = ACTIONS(1964),
    [anon_sym__Atomic] = ACTIONS(1964),
    [anon_sym__Noreturn] = ACTIONS(1964),
    [anon_sym_noreturn] = ACTIONS(1964),
    [anon_sym_mutable] = ACTIONS(1964),
    [anon_sym_constinit] = ACTIONS(1964),
    [anon_sym_consteval] = ACTIONS(1964),
    [anon_sym___shared__] = ACTIONS(1964),
    [anon_sym___local__] = ACTIONS(1964),
    [anon_sym___constant__] = ACTIONS(1964),
    [anon_sym___managed__] = ACTIONS(1964),
    [anon_sym___grid_constant__] = ACTIONS(1964),
    [anon_sym_alignas] = ACTIONS(1964),
    [anon_sym__Alignas] = ACTIONS(1964),
    [sym_primitive_type] = ACTIONS(1964),
    [anon_sym_enum] = ACTIONS(1964),
    [anon_sym_class] = ACTIONS(1964),
    [anon_sym_struct] = ACTIONS(1964),
    [anon_sym_union] = ACTIONS(1964),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1964),
    [anon_sym_decltype] = ACTIONS(1964),
    [sym_virtual] = ACTIONS(1964),
    [anon_sym_explicit] = ACTIONS(1964),
    [anon_sym_typename] = ACTIONS(1964),
    [anon_sym_template] = ACTIONS(1964),
    [anon_sym_operator] = ACTIONS(1964),
    [anon_sym_friend] = ACTIONS(1964),
    [anon_sym_public] = ACTIONS(1964),
    [anon_sym_private] = ACTIONS(1964),
    [anon_sym_protected] = ACTIONS(1964),
    [anon_sym_using] = ACTIONS(1964),
    [anon_sym_static_assert] = ACTIONS(1964),
    [anon_sym___launch_bounds__] = ACTIONS(1964),
  },
  [2016] = {
    [sym_identifier] = ACTIONS(5293),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5295),
    [anon_sym_COMMA] = ACTIONS(5295),
    [anon_sym_RPAREN] = ACTIONS(5295),
    [anon_sym_LPAREN2] = ACTIONS(5295),
    [anon_sym_DASH] = ACTIONS(5293),
    [anon_sym_PLUS] = ACTIONS(5293),
    [anon_sym_STAR] = ACTIONS(5295),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_PERCENT] = ACTIONS(5295),
    [anon_sym_PIPE_PIPE] = ACTIONS(5295),
    [anon_sym_AMP_AMP] = ACTIONS(5295),
    [anon_sym_PIPE] = ACTIONS(5293),
    [anon_sym_CARET] = ACTIONS(5295),
    [anon_sym_AMP] = ACTIONS(5293),
    [anon_sym_EQ_EQ] = ACTIONS(5295),
    [anon_sym_BANG_EQ] = ACTIONS(5295),
    [anon_sym_GT] = ACTIONS(5293),
    [anon_sym_GT_EQ] = ACTIONS(5295),
    [anon_sym_LT_EQ] = ACTIONS(5293),
    [anon_sym_LT] = ACTIONS(5293),
    [anon_sym_LT_LT] = ACTIONS(5293),
    [anon_sym_GT_GT] = ACTIONS(5295),
    [anon_sym_SEMI] = ACTIONS(5295),
    [anon_sym___extension__] = ACTIONS(5293),
    [anon_sym___global__] = ACTIONS(5293),
    [anon_sym___attribute__] = ACTIONS(5293),
    [anon_sym___based] = ACTIONS(5293),
    [anon_sym_LBRACE] = ACTIONS(5295),
    [anon_sym_RBRACE] = ACTIONS(5295),
    [anon_sym_signed] = ACTIONS(5293),
    [anon_sym_unsigned] = ACTIONS(5293),
    [anon_sym_long] = ACTIONS(5293),
    [anon_sym_short] = ACTIONS(5293),
    [anon_sym_LBRACK] = ACTIONS(5295),
    [anon_sym_RBRACK] = ACTIONS(5295),
    [anon_sym_const] = ACTIONS(5293),
    [anon_sym_constexpr] = ACTIONS(5293),
    [anon_sym_volatile] = ACTIONS(5293),
    [anon_sym_restrict] = ACTIONS(5293),
    [anon_sym___restrict__] = ACTIONS(5293),
    [anon_sym__Atomic] = ACTIONS(5293),
    [anon_sym__Noreturn] = ACTIONS(5293),
    [anon_sym_noreturn] = ACTIONS(5293),
    [anon_sym_mutable] = ACTIONS(5293),
    [anon_sym_constinit] = ACTIONS(5293),
    [anon_sym_consteval] = ACTIONS(5293),
    [anon_sym___shared__] = ACTIONS(5293),
    [anon_sym___local__] = ACTIONS(5293),
    [anon_sym___constant__] = ACTIONS(5293),
    [anon_sym___managed__] = ACTIONS(5293),
    [anon_sym___grid_constant__] = ACTIONS(5293),
    [anon_sym_alignas] = ACTIONS(5293),
    [anon_sym__Alignas] = ACTIONS(5293),
    [sym_primitive_type] = ACTIONS(5293),
    [anon_sym_COLON] = ACTIONS(5295),
    [anon_sym_QMARK] = ACTIONS(5295),
    [anon_sym_LT_EQ_GT] = ACTIONS(5295),
    [anon_sym_or] = ACTIONS(5293),
    [anon_sym_and] = ACTIONS(5293),
    [anon_sym_bitor] = ACTIONS(5293),
    [anon_sym_xor] = ACTIONS(5293),
    [anon_sym_bitand] = ACTIONS(5293),
    [anon_sym_not_eq] = ACTIONS(5293),
    [anon_sym_DASH_DASH] = ACTIONS(5295),
    [anon_sym_PLUS_PLUS] = ACTIONS(5295),
    [anon_sym_DOT] = ACTIONS(5293),
    [anon_sym_DOT_STAR] = ACTIONS(5295),
    [anon_sym_DASH_GT] = ACTIONS(5295),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5293),
    [anon_sym_decltype] = ACTIONS(5293),
    [anon_sym_final] = ACTIONS(5293),
    [anon_sym_override] = ACTIONS(5293),
    [anon_sym_requires] = ACTIONS(5293),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5295),
  },
  [2017] = {
    [sym_identifier] = ACTIONS(5103),
    [aux_sym_preproc_def_token1] = ACTIONS(5103),
    [aux_sym_preproc_if_token1] = ACTIONS(5103),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5103),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5103),
    [sym_preproc_directive] = ACTIONS(5103),
    [anon_sym_LPAREN2] = ACTIONS(5105),
    [anon_sym_TILDE] = ACTIONS(5105),
    [anon_sym_STAR] = ACTIONS(5105),
    [anon_sym_AMP_AMP] = ACTIONS(5105),
    [anon_sym_AMP] = ACTIONS(5103),
    [anon_sym___extension__] = ACTIONS(5103),
    [anon_sym_typedef] = ACTIONS(5103),
    [anon_sym___device__] = ACTIONS(5103),
    [anon_sym___host__] = ACTIONS(5103),
    [anon_sym___global__] = ACTIONS(5103),
    [anon_sym___forceinline__] = ACTIONS(5103),
    [anon_sym___noinline__] = ACTIONS(5103),
    [anon_sym_extern] = ACTIONS(5103),
    [anon_sym___attribute__] = ACTIONS(5103),
    [anon_sym_COLON_COLON] = ACTIONS(5105),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5105),
    [anon_sym___declspec] = ACTIONS(5103),
    [anon_sym___based] = ACTIONS(5103),
    [anon_sym_RBRACE] = ACTIONS(5105),
    [anon_sym_signed] = ACTIONS(5103),
    [anon_sym_unsigned] = ACTIONS(5103),
    [anon_sym_long] = ACTIONS(5103),
    [anon_sym_short] = ACTIONS(5103),
    [anon_sym_LBRACK] = ACTIONS(5103),
    [anon_sym_static] = ACTIONS(5103),
    [anon_sym_register] = ACTIONS(5103),
    [anon_sym_inline] = ACTIONS(5103),
    [anon_sym___inline] = ACTIONS(5103),
    [anon_sym___inline__] = ACTIONS(5103),
    [anon_sym___forceinline] = ACTIONS(5103),
    [anon_sym_thread_local] = ACTIONS(5103),
    [anon_sym___thread] = ACTIONS(5103),
    [anon_sym_const] = ACTIONS(5103),
    [anon_sym_constexpr] = ACTIONS(5103),
    [anon_sym_volatile] = ACTIONS(5103),
    [anon_sym_restrict] = ACTIONS(5103),
    [anon_sym___restrict__] = ACTIONS(5103),
    [anon_sym__Atomic] = ACTIONS(5103),
    [anon_sym__Noreturn] = ACTIONS(5103),
    [anon_sym_noreturn] = ACTIONS(5103),
    [anon_sym_mutable] = ACTIONS(5103),
    [anon_sym_constinit] = ACTIONS(5103),
    [anon_sym_consteval] = ACTIONS(5103),
    [anon_sym___shared__] = ACTIONS(5103),
    [anon_sym___local__] = ACTIONS(5103),
    [anon_sym___constant__] = ACTIONS(5103),
    [anon_sym___managed__] = ACTIONS(5103),
    [anon_sym___grid_constant__] = ACTIONS(5103),
    [anon_sym_alignas] = ACTIONS(5103),
    [anon_sym__Alignas] = ACTIONS(5103),
    [sym_primitive_type] = ACTIONS(5103),
    [anon_sym_enum] = ACTIONS(5103),
    [anon_sym_class] = ACTIONS(5103),
    [anon_sym_struct] = ACTIONS(5103),
    [anon_sym_union] = ACTIONS(5103),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5103),
    [anon_sym_decltype] = ACTIONS(5103),
    [sym_virtual] = ACTIONS(5103),
    [anon_sym_explicit] = ACTIONS(5103),
    [anon_sym_typename] = ACTIONS(5103),
    [anon_sym_template] = ACTIONS(5103),
    [anon_sym_operator] = ACTIONS(5103),
    [anon_sym_friend] = ACTIONS(5103),
    [anon_sym_public] = ACTIONS(5103),
    [anon_sym_private] = ACTIONS(5103),
    [anon_sym_protected] = ACTIONS(5103),
    [anon_sym_using] = ACTIONS(5103),
    [anon_sym_static_assert] = ACTIONS(5103),
    [anon_sym___launch_bounds__] = ACTIONS(5103),
  },
  [2018] = {
    [sym_identifier] = ACTIONS(1964),
    [aux_sym_preproc_def_token1] = ACTIONS(1964),
    [aux_sym_preproc_if_token1] = ACTIONS(1964),
    [aux_sym_preproc_if_token2] = ACTIONS(1964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1964),
    [sym_preproc_directive] = ACTIONS(1964),
    [anon_sym_LPAREN2] = ACTIONS(1966),
    [anon_sym_TILDE] = ACTIONS(1966),
    [anon_sym_STAR] = ACTIONS(1966),
    [anon_sym_AMP_AMP] = ACTIONS(1966),
    [anon_sym_AMP] = ACTIONS(1964),
    [anon_sym___extension__] = ACTIONS(1964),
    [anon_sym_typedef] = ACTIONS(1964),
    [anon_sym___device__] = ACTIONS(1964),
    [anon_sym___host__] = ACTIONS(1964),
    [anon_sym___global__] = ACTIONS(1964),
    [anon_sym___forceinline__] = ACTIONS(1964),
    [anon_sym___noinline__] = ACTIONS(1964),
    [anon_sym_extern] = ACTIONS(1964),
    [anon_sym___attribute__] = ACTIONS(1964),
    [anon_sym_COLON_COLON] = ACTIONS(1966),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1966),
    [anon_sym___declspec] = ACTIONS(1964),
    [anon_sym___based] = ACTIONS(1964),
    [anon_sym_signed] = ACTIONS(1964),
    [anon_sym_unsigned] = ACTIONS(1964),
    [anon_sym_long] = ACTIONS(1964),
    [anon_sym_short] = ACTIONS(1964),
    [anon_sym_LBRACK] = ACTIONS(1964),
    [anon_sym_static] = ACTIONS(1964),
    [anon_sym_register] = ACTIONS(1964),
    [anon_sym_inline] = ACTIONS(1964),
    [anon_sym___inline] = ACTIONS(1964),
    [anon_sym___inline__] = ACTIONS(1964),
    [anon_sym___forceinline] = ACTIONS(1964),
    [anon_sym_thread_local] = ACTIONS(1964),
    [anon_sym___thread] = ACTIONS(1964),
    [anon_sym_const] = ACTIONS(1964),
    [anon_sym_constexpr] = ACTIONS(1964),
    [anon_sym_volatile] = ACTIONS(1964),
    [anon_sym_restrict] = ACTIONS(1964),
    [anon_sym___restrict__] = ACTIONS(1964),
    [anon_sym__Atomic] = ACTIONS(1964),
    [anon_sym__Noreturn] = ACTIONS(1964),
    [anon_sym_noreturn] = ACTIONS(1964),
    [anon_sym_mutable] = ACTIONS(1964),
    [anon_sym_constinit] = ACTIONS(1964),
    [anon_sym_consteval] = ACTIONS(1964),
    [anon_sym___shared__] = ACTIONS(1964),
    [anon_sym___local__] = ACTIONS(1964),
    [anon_sym___constant__] = ACTIONS(1964),
    [anon_sym___managed__] = ACTIONS(1964),
    [anon_sym___grid_constant__] = ACTIONS(1964),
    [anon_sym_alignas] = ACTIONS(1964),
    [anon_sym__Alignas] = ACTIONS(1964),
    [sym_primitive_type] = ACTIONS(1964),
    [anon_sym_enum] = ACTIONS(1964),
    [anon_sym_class] = ACTIONS(1964),
    [anon_sym_struct] = ACTIONS(1964),
    [anon_sym_union] = ACTIONS(1964),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1964),
    [anon_sym_decltype] = ACTIONS(1964),
    [sym_virtual] = ACTIONS(1964),
    [anon_sym_explicit] = ACTIONS(1964),
    [anon_sym_typename] = ACTIONS(1964),
    [anon_sym_template] = ACTIONS(1964),
    [anon_sym_operator] = ACTIONS(1964),
    [anon_sym_friend] = ACTIONS(1964),
    [anon_sym_public] = ACTIONS(1964),
    [anon_sym_private] = ACTIONS(1964),
    [anon_sym_protected] = ACTIONS(1964),
    [anon_sym_using] = ACTIONS(1964),
    [anon_sym_static_assert] = ACTIONS(1964),
    [anon_sym___launch_bounds__] = ACTIONS(1964),
  },
  [2019] = {
    [sym_identifier] = ACTIONS(5297),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5299),
    [anon_sym_COMMA] = ACTIONS(5299),
    [anon_sym_RPAREN] = ACTIONS(5299),
    [anon_sym_LPAREN2] = ACTIONS(5299),
    [anon_sym_DASH] = ACTIONS(5297),
    [anon_sym_PLUS] = ACTIONS(5297),
    [anon_sym_STAR] = ACTIONS(5299),
    [anon_sym_SLASH] = ACTIONS(5297),
    [anon_sym_PERCENT] = ACTIONS(5299),
    [anon_sym_PIPE_PIPE] = ACTIONS(5299),
    [anon_sym_AMP_AMP] = ACTIONS(5299),
    [anon_sym_PIPE] = ACTIONS(5297),
    [anon_sym_CARET] = ACTIONS(5299),
    [anon_sym_AMP] = ACTIONS(5297),
    [anon_sym_EQ_EQ] = ACTIONS(5299),
    [anon_sym_BANG_EQ] = ACTIONS(5299),
    [anon_sym_GT] = ACTIONS(5297),
    [anon_sym_GT_EQ] = ACTIONS(5299),
    [anon_sym_LT_EQ] = ACTIONS(5297),
    [anon_sym_LT] = ACTIONS(5297),
    [anon_sym_LT_LT] = ACTIONS(5297),
    [anon_sym_GT_GT] = ACTIONS(5299),
    [anon_sym_SEMI] = ACTIONS(5299),
    [anon_sym___extension__] = ACTIONS(5297),
    [anon_sym___global__] = ACTIONS(5297),
    [anon_sym___attribute__] = ACTIONS(5297),
    [anon_sym___based] = ACTIONS(5297),
    [anon_sym_LBRACE] = ACTIONS(5299),
    [anon_sym_RBRACE] = ACTIONS(5299),
    [anon_sym_signed] = ACTIONS(5297),
    [anon_sym_unsigned] = ACTIONS(5297),
    [anon_sym_long] = ACTIONS(5297),
    [anon_sym_short] = ACTIONS(5297),
    [anon_sym_LBRACK] = ACTIONS(5299),
    [anon_sym_RBRACK] = ACTIONS(5299),
    [anon_sym_const] = ACTIONS(5297),
    [anon_sym_constexpr] = ACTIONS(5297),
    [anon_sym_volatile] = ACTIONS(5297),
    [anon_sym_restrict] = ACTIONS(5297),
    [anon_sym___restrict__] = ACTIONS(5297),
    [anon_sym__Atomic] = ACTIONS(5297),
    [anon_sym__Noreturn] = ACTIONS(5297),
    [anon_sym_noreturn] = ACTIONS(5297),
    [anon_sym_mutable] = ACTIONS(5297),
    [anon_sym_constinit] = ACTIONS(5297),
    [anon_sym_consteval] = ACTIONS(5297),
    [anon_sym___shared__] = ACTIONS(5297),
    [anon_sym___local__] = ACTIONS(5297),
    [anon_sym___constant__] = ACTIONS(5297),
    [anon_sym___managed__] = ACTIONS(5297),
    [anon_sym___grid_constant__] = ACTIONS(5297),
    [anon_sym_alignas] = ACTIONS(5297),
    [anon_sym__Alignas] = ACTIONS(5297),
    [sym_primitive_type] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_QMARK] = ACTIONS(5299),
    [anon_sym_LT_EQ_GT] = ACTIONS(5299),
    [anon_sym_or] = ACTIONS(5297),
    [anon_sym_and] = ACTIONS(5297),
    [anon_sym_bitor] = ACTIONS(5297),
    [anon_sym_xor] = ACTIONS(5297),
    [anon_sym_bitand] = ACTIONS(5297),
    [anon_sym_not_eq] = ACTIONS(5297),
    [anon_sym_DASH_DASH] = ACTIONS(5299),
    [anon_sym_PLUS_PLUS] = ACTIONS(5299),
    [anon_sym_DOT] = ACTIONS(5297),
    [anon_sym_DOT_STAR] = ACTIONS(5299),
    [anon_sym_DASH_GT] = ACTIONS(5299),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5297),
    [anon_sym_decltype] = ACTIONS(5297),
    [anon_sym_final] = ACTIONS(5297),
    [anon_sym_override] = ACTIONS(5297),
    [anon_sym_requires] = ACTIONS(5297),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5299),
  },
  [2020] = {
    [sym_identifier] = ACTIONS(2388),
    [aux_sym_preproc_def_token1] = ACTIONS(2388),
    [aux_sym_preproc_if_token1] = ACTIONS(2388),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2388),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2388),
    [sym_preproc_directive] = ACTIONS(2388),
    [anon_sym_LPAREN2] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [anon_sym_STAR] = ACTIONS(2390),
    [anon_sym_AMP_AMP] = ACTIONS(2390),
    [anon_sym_AMP] = ACTIONS(2388),
    [anon_sym___extension__] = ACTIONS(2388),
    [anon_sym_typedef] = ACTIONS(2388),
    [anon_sym___device__] = ACTIONS(2388),
    [anon_sym___host__] = ACTIONS(2388),
    [anon_sym___global__] = ACTIONS(2388),
    [anon_sym___forceinline__] = ACTIONS(2388),
    [anon_sym___noinline__] = ACTIONS(2388),
    [anon_sym_extern] = ACTIONS(2388),
    [anon_sym___attribute__] = ACTIONS(2388),
    [anon_sym_COLON_COLON] = ACTIONS(2390),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2390),
    [anon_sym___declspec] = ACTIONS(2388),
    [anon_sym___based] = ACTIONS(2388),
    [anon_sym_RBRACE] = ACTIONS(2390),
    [anon_sym_signed] = ACTIONS(2388),
    [anon_sym_unsigned] = ACTIONS(2388),
    [anon_sym_long] = ACTIONS(2388),
    [anon_sym_short] = ACTIONS(2388),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [anon_sym_static] = ACTIONS(2388),
    [anon_sym_register] = ACTIONS(2388),
    [anon_sym_inline] = ACTIONS(2388),
    [anon_sym___inline] = ACTIONS(2388),
    [anon_sym___inline__] = ACTIONS(2388),
    [anon_sym___forceinline] = ACTIONS(2388),
    [anon_sym_thread_local] = ACTIONS(2388),
    [anon_sym___thread] = ACTIONS(2388),
    [anon_sym_const] = ACTIONS(2388),
    [anon_sym_constexpr] = ACTIONS(2388),
    [anon_sym_volatile] = ACTIONS(2388),
    [anon_sym_restrict] = ACTIONS(2388),
    [anon_sym___restrict__] = ACTIONS(2388),
    [anon_sym__Atomic] = ACTIONS(2388),
    [anon_sym__Noreturn] = ACTIONS(2388),
    [anon_sym_noreturn] = ACTIONS(2388),
    [anon_sym_mutable] = ACTIONS(2388),
    [anon_sym_constinit] = ACTIONS(2388),
    [anon_sym_consteval] = ACTIONS(2388),
    [anon_sym___shared__] = ACTIONS(2388),
    [anon_sym___local__] = ACTIONS(2388),
    [anon_sym___constant__] = ACTIONS(2388),
    [anon_sym___managed__] = ACTIONS(2388),
    [anon_sym___grid_constant__] = ACTIONS(2388),
    [anon_sym_alignas] = ACTIONS(2388),
    [anon_sym__Alignas] = ACTIONS(2388),
    [sym_primitive_type] = ACTIONS(2388),
    [anon_sym_enum] = ACTIONS(2388),
    [anon_sym_class] = ACTIONS(2388),
    [anon_sym_struct] = ACTIONS(2388),
    [anon_sym_union] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2388),
    [anon_sym_decltype] = ACTIONS(2388),
    [sym_virtual] = ACTIONS(2388),
    [anon_sym_explicit] = ACTIONS(2388),
    [anon_sym_typename] = ACTIONS(2388),
    [anon_sym_template] = ACTIONS(2388),
    [anon_sym_operator] = ACTIONS(2388),
    [anon_sym_friend] = ACTIONS(2388),
    [anon_sym_public] = ACTIONS(2388),
    [anon_sym_private] = ACTIONS(2388),
    [anon_sym_protected] = ACTIONS(2388),
    [anon_sym_using] = ACTIONS(2388),
    [anon_sym_static_assert] = ACTIONS(2388),
    [anon_sym___launch_bounds__] = ACTIONS(2388),
  },
  [2021] = {
    [sym_identifier] = ACTIONS(5301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5303),
    [anon_sym_COMMA] = ACTIONS(5303),
    [anon_sym_RPAREN] = ACTIONS(5303),
    [anon_sym_LPAREN2] = ACTIONS(5303),
    [anon_sym_DASH] = ACTIONS(5301),
    [anon_sym_PLUS] = ACTIONS(5301),
    [anon_sym_STAR] = ACTIONS(5303),
    [anon_sym_SLASH] = ACTIONS(5301),
    [anon_sym_PERCENT] = ACTIONS(5303),
    [anon_sym_PIPE_PIPE] = ACTIONS(5303),
    [anon_sym_AMP_AMP] = ACTIONS(5303),
    [anon_sym_PIPE] = ACTIONS(5301),
    [anon_sym_CARET] = ACTIONS(5303),
    [anon_sym_AMP] = ACTIONS(5301),
    [anon_sym_EQ_EQ] = ACTIONS(5303),
    [anon_sym_BANG_EQ] = ACTIONS(5303),
    [anon_sym_GT] = ACTIONS(5301),
    [anon_sym_GT_EQ] = ACTIONS(5303),
    [anon_sym_LT_EQ] = ACTIONS(5301),
    [anon_sym_LT] = ACTIONS(5301),
    [anon_sym_LT_LT] = ACTIONS(5301),
    [anon_sym_GT_GT] = ACTIONS(5303),
    [anon_sym_SEMI] = ACTIONS(5303),
    [anon_sym___extension__] = ACTIONS(5301),
    [anon_sym___global__] = ACTIONS(5301),
    [anon_sym___attribute__] = ACTIONS(5301),
    [anon_sym___based] = ACTIONS(5301),
    [anon_sym_LBRACE] = ACTIONS(5303),
    [anon_sym_RBRACE] = ACTIONS(5303),
    [anon_sym_signed] = ACTIONS(5301),
    [anon_sym_unsigned] = ACTIONS(5301),
    [anon_sym_long] = ACTIONS(5301),
    [anon_sym_short] = ACTIONS(5301),
    [anon_sym_LBRACK] = ACTIONS(5303),
    [anon_sym_RBRACK] = ACTIONS(5303),
    [anon_sym_const] = ACTIONS(5301),
    [anon_sym_constexpr] = ACTIONS(5301),
    [anon_sym_volatile] = ACTIONS(5301),
    [anon_sym_restrict] = ACTIONS(5301),
    [anon_sym___restrict__] = ACTIONS(5301),
    [anon_sym__Atomic] = ACTIONS(5301),
    [anon_sym__Noreturn] = ACTIONS(5301),
    [anon_sym_noreturn] = ACTIONS(5301),
    [anon_sym_mutable] = ACTIONS(5301),
    [anon_sym_constinit] = ACTIONS(5301),
    [anon_sym_consteval] = ACTIONS(5301),
    [anon_sym___shared__] = ACTIONS(5301),
    [anon_sym___local__] = ACTIONS(5301),
    [anon_sym___constant__] = ACTIONS(5301),
    [anon_sym___managed__] = ACTIONS(5301),
    [anon_sym___grid_constant__] = ACTIONS(5301),
    [anon_sym_alignas] = ACTIONS(5301),
    [anon_sym__Alignas] = ACTIONS(5301),
    [sym_primitive_type] = ACTIONS(5301),
    [anon_sym_COLON] = ACTIONS(5303),
    [anon_sym_QMARK] = ACTIONS(5303),
    [anon_sym_LT_EQ_GT] = ACTIONS(5303),
    [anon_sym_or] = ACTIONS(5301),
    [anon_sym_and] = ACTIONS(5301),
    [anon_sym_bitor] = ACTIONS(5301),
    [anon_sym_xor] = ACTIONS(5301),
    [anon_sym_bitand] = ACTIONS(5301),
    [anon_sym_not_eq] = ACTIONS(5301),
    [anon_sym_DASH_DASH] = ACTIONS(5303),
    [anon_sym_PLUS_PLUS] = ACTIONS(5303),
    [anon_sym_DOT] = ACTIONS(5301),
    [anon_sym_DOT_STAR] = ACTIONS(5303),
    [anon_sym_DASH_GT] = ACTIONS(5303),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5301),
    [anon_sym_decltype] = ACTIONS(5301),
    [anon_sym_final] = ACTIONS(5301),
    [anon_sym_override] = ACTIONS(5301),
    [anon_sym_requires] = ACTIONS(5301),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5303),
  },
  [2022] = {
    [sym_identifier] = ACTIONS(2436),
    [aux_sym_preproc_def_token1] = ACTIONS(2436),
    [aux_sym_preproc_if_token1] = ACTIONS(2436),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2436),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2436),
    [sym_preproc_directive] = ACTIONS(2436),
    [anon_sym_LPAREN2] = ACTIONS(2438),
    [anon_sym_TILDE] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(2438),
    [anon_sym_AMP_AMP] = ACTIONS(2438),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym___extension__] = ACTIONS(2436),
    [anon_sym_typedef] = ACTIONS(2436),
    [anon_sym___device__] = ACTIONS(2436),
    [anon_sym___host__] = ACTIONS(2436),
    [anon_sym___global__] = ACTIONS(2436),
    [anon_sym___forceinline__] = ACTIONS(2436),
    [anon_sym___noinline__] = ACTIONS(2436),
    [anon_sym_extern] = ACTIONS(2436),
    [anon_sym___attribute__] = ACTIONS(2436),
    [anon_sym_COLON_COLON] = ACTIONS(2438),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2438),
    [anon_sym___declspec] = ACTIONS(2436),
    [anon_sym___based] = ACTIONS(2436),
    [anon_sym_RBRACE] = ACTIONS(2438),
    [anon_sym_signed] = ACTIONS(2436),
    [anon_sym_unsigned] = ACTIONS(2436),
    [anon_sym_long] = ACTIONS(2436),
    [anon_sym_short] = ACTIONS(2436),
    [anon_sym_LBRACK] = ACTIONS(2436),
    [anon_sym_static] = ACTIONS(2436),
    [anon_sym_register] = ACTIONS(2436),
    [anon_sym_inline] = ACTIONS(2436),
    [anon_sym___inline] = ACTIONS(2436),
    [anon_sym___inline__] = ACTIONS(2436),
    [anon_sym___forceinline] = ACTIONS(2436),
    [anon_sym_thread_local] = ACTIONS(2436),
    [anon_sym___thread] = ACTIONS(2436),
    [anon_sym_const] = ACTIONS(2436),
    [anon_sym_constexpr] = ACTIONS(2436),
    [anon_sym_volatile] = ACTIONS(2436),
    [anon_sym_restrict] = ACTIONS(2436),
    [anon_sym___restrict__] = ACTIONS(2436),
    [anon_sym__Atomic] = ACTIONS(2436),
    [anon_sym__Noreturn] = ACTIONS(2436),
    [anon_sym_noreturn] = ACTIONS(2436),
    [anon_sym_mutable] = ACTIONS(2436),
    [anon_sym_constinit] = ACTIONS(2436),
    [anon_sym_consteval] = ACTIONS(2436),
    [anon_sym___shared__] = ACTIONS(2436),
    [anon_sym___local__] = ACTIONS(2436),
    [anon_sym___constant__] = ACTIONS(2436),
    [anon_sym___managed__] = ACTIONS(2436),
    [anon_sym___grid_constant__] = ACTIONS(2436),
    [anon_sym_alignas] = ACTIONS(2436),
    [anon_sym__Alignas] = ACTIONS(2436),
    [sym_primitive_type] = ACTIONS(2436),
    [anon_sym_enum] = ACTIONS(2436),
    [anon_sym_class] = ACTIONS(2436),
    [anon_sym_struct] = ACTIONS(2436),
    [anon_sym_union] = ACTIONS(2436),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2436),
    [anon_sym_decltype] = ACTIONS(2436),
    [sym_virtual] = ACTIONS(2436),
    [anon_sym_explicit] = ACTIONS(2436),
    [anon_sym_typename] = ACTIONS(2436),
    [anon_sym_template] = ACTIONS(2436),
    [anon_sym_operator] = ACTIONS(2436),
    [anon_sym_friend] = ACTIONS(2436),
    [anon_sym_public] = ACTIONS(2436),
    [anon_sym_private] = ACTIONS(2436),
    [anon_sym_protected] = ACTIONS(2436),
    [anon_sym_using] = ACTIONS(2436),
    [anon_sym_static_assert] = ACTIONS(2436),
    [anon_sym___launch_bounds__] = ACTIONS(2436),
  },
  [2023] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2269),
    [anon_sym_TILDE] = ACTIONS(2269),
    [anon_sym_STAR] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym___device__] = ACTIONS(2267),
    [anon_sym___host__] = ACTIONS(2267),
    [anon_sym___global__] = ACTIONS(2267),
    [anon_sym___forceinline__] = ACTIONS(2267),
    [anon_sym___noinline__] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2269),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2269),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym_RBRACE] = ACTIONS(2269),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym___shared__] = ACTIONS(2267),
    [anon_sym___local__] = ACTIONS(2267),
    [anon_sym___constant__] = ACTIONS(2267),
    [anon_sym___managed__] = ACTIONS(2267),
    [anon_sym___grid_constant__] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym__Alignas] = ACTIONS(2267),
    [sym_primitive_type] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [sym_virtual] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_friend] = ACTIONS(2267),
    [anon_sym_public] = ACTIONS(2267),
    [anon_sym_private] = ACTIONS(2267),
    [anon_sym_protected] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym___launch_bounds__] = ACTIONS(2267),
  },
  [2024] = {
    [sym_identifier] = ACTIONS(5192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5194),
    [anon_sym_COMMA] = ACTIONS(5194),
    [anon_sym_RPAREN] = ACTIONS(5194),
    [anon_sym_LPAREN2] = ACTIONS(5194),
    [anon_sym_DASH] = ACTIONS(5192),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_STAR] = ACTIONS(5194),
    [anon_sym_SLASH] = ACTIONS(5192),
    [anon_sym_PERCENT] = ACTIONS(5194),
    [anon_sym_PIPE_PIPE] = ACTIONS(5194),
    [anon_sym_AMP_AMP] = ACTIONS(5194),
    [anon_sym_PIPE] = ACTIONS(5192),
    [anon_sym_CARET] = ACTIONS(5194),
    [anon_sym_AMP] = ACTIONS(5192),
    [anon_sym_EQ_EQ] = ACTIONS(5194),
    [anon_sym_BANG_EQ] = ACTIONS(5194),
    [anon_sym_GT] = ACTIONS(5192),
    [anon_sym_GT_EQ] = ACTIONS(5194),
    [anon_sym_LT_EQ] = ACTIONS(5192),
    [anon_sym_LT] = ACTIONS(5192),
    [anon_sym_LT_LT] = ACTIONS(5192),
    [anon_sym_GT_GT] = ACTIONS(5194),
    [anon_sym_SEMI] = ACTIONS(5194),
    [anon_sym___extension__] = ACTIONS(5192),
    [anon_sym___global__] = ACTIONS(5192),
    [anon_sym___attribute__] = ACTIONS(5192),
    [anon_sym___based] = ACTIONS(5192),
    [anon_sym_LBRACE] = ACTIONS(5194),
    [anon_sym_RBRACE] = ACTIONS(5194),
    [anon_sym_signed] = ACTIONS(5192),
    [anon_sym_unsigned] = ACTIONS(5192),
    [anon_sym_long] = ACTIONS(5192),
    [anon_sym_short] = ACTIONS(5192),
    [anon_sym_LBRACK] = ACTIONS(5194),
    [anon_sym_RBRACK] = ACTIONS(5194),
    [anon_sym_const] = ACTIONS(5192),
    [anon_sym_constexpr] = ACTIONS(5192),
    [anon_sym_volatile] = ACTIONS(5192),
    [anon_sym_restrict] = ACTIONS(5192),
    [anon_sym___restrict__] = ACTIONS(5192),
    [anon_sym__Atomic] = ACTIONS(5192),
    [anon_sym__Noreturn] = ACTIONS(5192),
    [anon_sym_noreturn] = ACTIONS(5192),
    [anon_sym_mutable] = ACTIONS(5192),
    [anon_sym_constinit] = ACTIONS(5192),
    [anon_sym_consteval] = ACTIONS(5192),
    [anon_sym___shared__] = ACTIONS(5192),
    [anon_sym___local__] = ACTIONS(5192),
    [anon_sym___constant__] = ACTIONS(5192),
    [anon_sym___managed__] = ACTIONS(5192),
    [anon_sym___grid_constant__] = ACTIONS(5192),
    [anon_sym_alignas] = ACTIONS(5192),
    [anon_sym__Alignas] = ACTIONS(5192),
    [sym_primitive_type] = ACTIONS(5192),
    [anon_sym_COLON] = ACTIONS(5194),
    [anon_sym_QMARK] = ACTIONS(5194),
    [anon_sym_LT_EQ_GT] = ACTIONS(5194),
    [anon_sym_or] = ACTIONS(5192),
    [anon_sym_and] = ACTIONS(5192),
    [anon_sym_bitor] = ACTIONS(5192),
    [anon_sym_xor] = ACTIONS(5192),
    [anon_sym_bitand] = ACTIONS(5192),
    [anon_sym_not_eq] = ACTIONS(5192),
    [anon_sym_DASH_DASH] = ACTIONS(5194),
    [anon_sym_PLUS_PLUS] = ACTIONS(5194),
    [anon_sym_DOT] = ACTIONS(5192),
    [anon_sym_DOT_STAR] = ACTIONS(5194),
    [anon_sym_DASH_GT] = ACTIONS(5194),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5192),
    [anon_sym_decltype] = ACTIONS(5192),
    [anon_sym_final] = ACTIONS(5192),
    [anon_sym_override] = ACTIONS(5192),
    [anon_sym_requires] = ACTIONS(5192),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5194),
  },
  [2025] = {
    [sym_identifier] = ACTIONS(2267),
    [aux_sym_preproc_def_token1] = ACTIONS(2267),
    [aux_sym_preproc_if_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2267),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2267),
    [sym_preproc_directive] = ACTIONS(2267),
    [anon_sym_LPAREN2] = ACTIONS(2269),
    [anon_sym_TILDE] = ACTIONS(2269),
    [anon_sym_STAR] = ACTIONS(2269),
    [anon_sym_AMP_AMP] = ACTIONS(2269),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym___extension__] = ACTIONS(2267),
    [anon_sym_typedef] = ACTIONS(2267),
    [anon_sym___device__] = ACTIONS(2267),
    [anon_sym___host__] = ACTIONS(2267),
    [anon_sym___global__] = ACTIONS(2267),
    [anon_sym___forceinline__] = ACTIONS(2267),
    [anon_sym___noinline__] = ACTIONS(2267),
    [anon_sym_extern] = ACTIONS(2267),
    [anon_sym___attribute__] = ACTIONS(2267),
    [anon_sym_COLON_COLON] = ACTIONS(2269),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2269),
    [anon_sym___declspec] = ACTIONS(2267),
    [anon_sym___based] = ACTIONS(2267),
    [anon_sym_RBRACE] = ACTIONS(2269),
    [anon_sym_signed] = ACTIONS(2267),
    [anon_sym_unsigned] = ACTIONS(2267),
    [anon_sym_long] = ACTIONS(2267),
    [anon_sym_short] = ACTIONS(2267),
    [anon_sym_LBRACK] = ACTIONS(2267),
    [anon_sym_static] = ACTIONS(2267),
    [anon_sym_register] = ACTIONS(2267),
    [anon_sym_inline] = ACTIONS(2267),
    [anon_sym___inline] = ACTIONS(2267),
    [anon_sym___inline__] = ACTIONS(2267),
    [anon_sym___forceinline] = ACTIONS(2267),
    [anon_sym_thread_local] = ACTIONS(2267),
    [anon_sym___thread] = ACTIONS(2267),
    [anon_sym_const] = ACTIONS(2267),
    [anon_sym_constexpr] = ACTIONS(2267),
    [anon_sym_volatile] = ACTIONS(2267),
    [anon_sym_restrict] = ACTIONS(2267),
    [anon_sym___restrict__] = ACTIONS(2267),
    [anon_sym__Atomic] = ACTIONS(2267),
    [anon_sym__Noreturn] = ACTIONS(2267),
    [anon_sym_noreturn] = ACTIONS(2267),
    [anon_sym_mutable] = ACTIONS(2267),
    [anon_sym_constinit] = ACTIONS(2267),
    [anon_sym_consteval] = ACTIONS(2267),
    [anon_sym___shared__] = ACTIONS(2267),
    [anon_sym___local__] = ACTIONS(2267),
    [anon_sym___constant__] = ACTIONS(2267),
    [anon_sym___managed__] = ACTIONS(2267),
    [anon_sym___grid_constant__] = ACTIONS(2267),
    [anon_sym_alignas] = ACTIONS(2267),
    [anon_sym__Alignas] = ACTIONS(2267),
    [sym_primitive_type] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2267),
    [anon_sym_class] = ACTIONS(2267),
    [anon_sym_struct] = ACTIONS(2267),
    [anon_sym_union] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2267),
    [anon_sym_decltype] = ACTIONS(2267),
    [sym_virtual] = ACTIONS(2267),
    [anon_sym_explicit] = ACTIONS(2267),
    [anon_sym_typename] = ACTIONS(2267),
    [anon_sym_template] = ACTIONS(2267),
    [anon_sym_operator] = ACTIONS(2267),
    [anon_sym_friend] = ACTIONS(2267),
    [anon_sym_public] = ACTIONS(2267),
    [anon_sym_private] = ACTIONS(2267),
    [anon_sym_protected] = ACTIONS(2267),
    [anon_sym_using] = ACTIONS(2267),
    [anon_sym_static_assert] = ACTIONS(2267),
    [anon_sym___launch_bounds__] = ACTIONS(2267),
  },
  [2026] = {
    [sym_string_literal] = STATE(2001),
    [sym_raw_string_literal] = STATE(2001),
    [aux_sym_concatenated_string_repeat1] = STATE(2001),
    [sym_identifier] = ACTIONS(5305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5307),
    [anon_sym_COMMA] = ACTIONS(5307),
    [anon_sym_RPAREN] = ACTIONS(5307),
    [aux_sym_preproc_if_token2] = ACTIONS(5307),
    [aux_sym_preproc_else_token1] = ACTIONS(5307),
    [aux_sym_preproc_elif_token1] = ACTIONS(5309),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5307),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5307),
    [anon_sym_LPAREN2] = ACTIONS(5307),
    [anon_sym_DASH] = ACTIONS(5309),
    [anon_sym_PLUS] = ACTIONS(5309),
    [anon_sym_STAR] = ACTIONS(5309),
    [anon_sym_SLASH] = ACTIONS(5309),
    [anon_sym_PERCENT] = ACTIONS(5309),
    [anon_sym_PIPE_PIPE] = ACTIONS(5307),
    [anon_sym_AMP_AMP] = ACTIONS(5307),
    [anon_sym_PIPE] = ACTIONS(5309),
    [anon_sym_CARET] = ACTIONS(5309),
    [anon_sym_AMP] = ACTIONS(5309),
    [anon_sym_EQ_EQ] = ACTIONS(5307),
    [anon_sym_BANG_EQ] = ACTIONS(5307),
    [anon_sym_GT] = ACTIONS(5309),
    [anon_sym_GT_EQ] = ACTIONS(5307),
    [anon_sym_LT_EQ] = ACTIONS(5309),
    [anon_sym_LT] = ACTIONS(5309),
    [anon_sym_LT_LT] = ACTIONS(5309),
    [anon_sym_GT_GT] = ACTIONS(5309),
    [anon_sym_SEMI] = ACTIONS(5307),
    [anon_sym_RBRACE] = ACTIONS(5307),
    [anon_sym_LBRACK] = ACTIONS(5307),
    [anon_sym_RBRACK] = ACTIONS(5307),
    [anon_sym_EQ] = ACTIONS(5309),
    [anon_sym_COLON] = ACTIONS(5307),
    [anon_sym_QMARK] = ACTIONS(5307),
    [anon_sym_STAR_EQ] = ACTIONS(5307),
    [anon_sym_SLASH_EQ] = ACTIONS(5307),
    [anon_sym_PERCENT_EQ] = ACTIONS(5307),
    [anon_sym_PLUS_EQ] = ACTIONS(5307),
    [anon_sym_DASH_EQ] = ACTIONS(5307),
    [anon_sym_LT_LT_EQ] = ACTIONS(5307),
    [anon_sym_GT_GT_EQ] = ACTIONS(5307),
    [anon_sym_AMP_EQ] = ACTIONS(5307),
    [anon_sym_CARET_EQ] = ACTIONS(5307),
    [anon_sym_PIPE_EQ] = ACTIONS(5307),
    [anon_sym_and_eq] = ACTIONS(5309),
    [anon_sym_or_eq] = ACTIONS(5309),
    [anon_sym_xor_eq] = ACTIONS(5309),
    [anon_sym_LT_EQ_GT] = ACTIONS(5307),
    [anon_sym_or] = ACTIONS(5309),
    [anon_sym_and] = ACTIONS(5309),
    [anon_sym_bitor] = ACTIONS(5309),
    [anon_sym_xor] = ACTIONS(5309),
    [anon_sym_bitand] = ACTIONS(5309),
    [anon_sym_not_eq] = ACTIONS(5309),
    [anon_sym_DASH_DASH] = ACTIONS(5307),
    [anon_sym_PLUS_PLUS] = ACTIONS(5307),
    [anon_sym_DOT] = ACTIONS(5309),
    [anon_sym_DOT_STAR] = ACTIONS(5307),
    [anon_sym_DASH_GT] = ACTIONS(5307),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [sym_literal_suffix] = ACTIONS(5309),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5307),
  },
  [2027] = {
    [sym_identifier] = ACTIONS(2255),
    [aux_sym_preproc_def_token1] = ACTIONS(2255),
    [aux_sym_preproc_if_token1] = ACTIONS(2255),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2255),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2255),
    [sym_preproc_directive] = ACTIONS(2255),
    [anon_sym_LPAREN2] = ACTIONS(2257),
    [anon_sym_TILDE] = ACTIONS(2257),
    [anon_sym_STAR] = ACTIONS(2257),
    [anon_sym_AMP_AMP] = ACTIONS(2257),
    [anon_sym_AMP] = ACTIONS(2255),
    [anon_sym___extension__] = ACTIONS(2255),
    [anon_sym_typedef] = ACTIONS(2255),
    [anon_sym___device__] = ACTIONS(2255),
    [anon_sym___host__] = ACTIONS(2255),
    [anon_sym___global__] = ACTIONS(2255),
    [anon_sym___forceinline__] = ACTIONS(2255),
    [anon_sym___noinline__] = ACTIONS(2255),
    [anon_sym_extern] = ACTIONS(2255),
    [anon_sym___attribute__] = ACTIONS(2255),
    [anon_sym_COLON_COLON] = ACTIONS(2257),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2257),
    [anon_sym___declspec] = ACTIONS(2255),
    [anon_sym___based] = ACTIONS(2255),
    [anon_sym_RBRACE] = ACTIONS(2257),
    [anon_sym_signed] = ACTIONS(2255),
    [anon_sym_unsigned] = ACTIONS(2255),
    [anon_sym_long] = ACTIONS(2255),
    [anon_sym_short] = ACTIONS(2255),
    [anon_sym_LBRACK] = ACTIONS(2255),
    [anon_sym_static] = ACTIONS(2255),
    [anon_sym_register] = ACTIONS(2255),
    [anon_sym_inline] = ACTIONS(2255),
    [anon_sym___inline] = ACTIONS(2255),
    [anon_sym___inline__] = ACTIONS(2255),
    [anon_sym___forceinline] = ACTIONS(2255),
    [anon_sym_thread_local] = ACTIONS(2255),
    [anon_sym___thread] = ACTIONS(2255),
    [anon_sym_const] = ACTIONS(2255),
    [anon_sym_constexpr] = ACTIONS(2255),
    [anon_sym_volatile] = ACTIONS(2255),
    [anon_sym_restrict] = ACTIONS(2255),
    [anon_sym___restrict__] = ACTIONS(2255),
    [anon_sym__Atomic] = ACTIONS(2255),
    [anon_sym__Noreturn] = ACTIONS(2255),
    [anon_sym_noreturn] = ACTIONS(2255),
    [anon_sym_mutable] = ACTIONS(2255),
    [anon_sym_constinit] = ACTIONS(2255),
    [anon_sym_consteval] = ACTIONS(2255),
    [anon_sym___shared__] = ACTIONS(2255),
    [anon_sym___local__] = ACTIONS(2255),
    [anon_sym___constant__] = ACTIONS(2255),
    [anon_sym___managed__] = ACTIONS(2255),
    [anon_sym___grid_constant__] = ACTIONS(2255),
    [anon_sym_alignas] = ACTIONS(2255),
    [anon_sym__Alignas] = ACTIONS(2255),
    [sym_primitive_type] = ACTIONS(2255),
    [anon_sym_enum] = ACTIONS(2255),
    [anon_sym_class] = ACTIONS(2255),
    [anon_sym_struct] = ACTIONS(2255),
    [anon_sym_union] = ACTIONS(2255),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2255),
    [anon_sym_decltype] = ACTIONS(2255),
    [sym_virtual] = ACTIONS(2255),
    [anon_sym_explicit] = ACTIONS(2255),
    [anon_sym_typename] = ACTIONS(2255),
    [anon_sym_template] = ACTIONS(2255),
    [anon_sym_operator] = ACTIONS(2255),
    [anon_sym_friend] = ACTIONS(2255),
    [anon_sym_public] = ACTIONS(2255),
    [anon_sym_private] = ACTIONS(2255),
    [anon_sym_protected] = ACTIONS(2255),
    [anon_sym_using] = ACTIONS(2255),
    [anon_sym_static_assert] = ACTIONS(2255),
    [anon_sym___launch_bounds__] = ACTIONS(2255),
  },
  [2028] = {
    [sym_identifier] = ACTIONS(2366),
    [aux_sym_preproc_def_token1] = ACTIONS(2366),
    [aux_sym_preproc_if_token1] = ACTIONS(2366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2366),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2366),
    [sym_preproc_directive] = ACTIONS(2366),
    [anon_sym_LPAREN2] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(2368),
    [anon_sym_STAR] = ACTIONS(2368),
    [anon_sym_AMP_AMP] = ACTIONS(2368),
    [anon_sym_AMP] = ACTIONS(2366),
    [anon_sym___extension__] = ACTIONS(2366),
    [anon_sym_typedef] = ACTIONS(2366),
    [anon_sym___device__] = ACTIONS(2366),
    [anon_sym___host__] = ACTIONS(2366),
    [anon_sym___global__] = ACTIONS(2366),
    [anon_sym___forceinline__] = ACTIONS(2366),
    [anon_sym___noinline__] = ACTIONS(2366),
    [anon_sym_extern] = ACTIONS(2366),
    [anon_sym___attribute__] = ACTIONS(2366),
    [anon_sym_COLON_COLON] = ACTIONS(2368),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2368),
    [anon_sym___declspec] = ACTIONS(2366),
    [anon_sym___based] = ACTIONS(2366),
    [anon_sym_RBRACE] = ACTIONS(2368),
    [anon_sym_signed] = ACTIONS(2366),
    [anon_sym_unsigned] = ACTIONS(2366),
    [anon_sym_long] = ACTIONS(2366),
    [anon_sym_short] = ACTIONS(2366),
    [anon_sym_LBRACK] = ACTIONS(2366),
    [anon_sym_static] = ACTIONS(2366),
    [anon_sym_register] = ACTIONS(2366),
    [anon_sym_inline] = ACTIONS(2366),
    [anon_sym___inline] = ACTIONS(2366),
    [anon_sym___inline__] = ACTIONS(2366),
    [anon_sym___forceinline] = ACTIONS(2366),
    [anon_sym_thread_local] = ACTIONS(2366),
    [anon_sym___thread] = ACTIONS(2366),
    [anon_sym_const] = ACTIONS(2366),
    [anon_sym_constexpr] = ACTIONS(2366),
    [anon_sym_volatile] = ACTIONS(2366),
    [anon_sym_restrict] = ACTIONS(2366),
    [anon_sym___restrict__] = ACTIONS(2366),
    [anon_sym__Atomic] = ACTIONS(2366),
    [anon_sym__Noreturn] = ACTIONS(2366),
    [anon_sym_noreturn] = ACTIONS(2366),
    [anon_sym_mutable] = ACTIONS(2366),
    [anon_sym_constinit] = ACTIONS(2366),
    [anon_sym_consteval] = ACTIONS(2366),
    [anon_sym___shared__] = ACTIONS(2366),
    [anon_sym___local__] = ACTIONS(2366),
    [anon_sym___constant__] = ACTIONS(2366),
    [anon_sym___managed__] = ACTIONS(2366),
    [anon_sym___grid_constant__] = ACTIONS(2366),
    [anon_sym_alignas] = ACTIONS(2366),
    [anon_sym__Alignas] = ACTIONS(2366),
    [sym_primitive_type] = ACTIONS(2366),
    [anon_sym_enum] = ACTIONS(2366),
    [anon_sym_class] = ACTIONS(2366),
    [anon_sym_struct] = ACTIONS(2366),
    [anon_sym_union] = ACTIONS(2366),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2366),
    [anon_sym_decltype] = ACTIONS(2366),
    [sym_virtual] = ACTIONS(2366),
    [anon_sym_explicit] = ACTIONS(2366),
    [anon_sym_typename] = ACTIONS(2366),
    [anon_sym_template] = ACTIONS(2366),
    [anon_sym_operator] = ACTIONS(2366),
    [anon_sym_friend] = ACTIONS(2366),
    [anon_sym_public] = ACTIONS(2366),
    [anon_sym_private] = ACTIONS(2366),
    [anon_sym_protected] = ACTIONS(2366),
    [anon_sym_using] = ACTIONS(2366),
    [anon_sym_static_assert] = ACTIONS(2366),
    [anon_sym___launch_bounds__] = ACTIONS(2366),
  },
  [2029] = {
    [sym_identifier] = ACTIONS(5131),
    [aux_sym_preproc_def_token1] = ACTIONS(5131),
    [aux_sym_preproc_if_token1] = ACTIONS(5131),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5131),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5131),
    [sym_preproc_directive] = ACTIONS(5131),
    [anon_sym_LPAREN2] = ACTIONS(5133),
    [anon_sym_TILDE] = ACTIONS(5133),
    [anon_sym_STAR] = ACTIONS(5133),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5131),
    [anon_sym___extension__] = ACTIONS(5131),
    [anon_sym_typedef] = ACTIONS(5131),
    [anon_sym___device__] = ACTIONS(5131),
    [anon_sym___host__] = ACTIONS(5131),
    [anon_sym___global__] = ACTIONS(5131),
    [anon_sym___forceinline__] = ACTIONS(5131),
    [anon_sym___noinline__] = ACTIONS(5131),
    [anon_sym_extern] = ACTIONS(5131),
    [anon_sym___attribute__] = ACTIONS(5131),
    [anon_sym_COLON_COLON] = ACTIONS(5133),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5133),
    [anon_sym___declspec] = ACTIONS(5131),
    [anon_sym___based] = ACTIONS(5131),
    [anon_sym_RBRACE] = ACTIONS(5133),
    [anon_sym_signed] = ACTIONS(5131),
    [anon_sym_unsigned] = ACTIONS(5131),
    [anon_sym_long] = ACTIONS(5131),
    [anon_sym_short] = ACTIONS(5131),
    [anon_sym_LBRACK] = ACTIONS(5131),
    [anon_sym_static] = ACTIONS(5131),
    [anon_sym_register] = ACTIONS(5131),
    [anon_sym_inline] = ACTIONS(5131),
    [anon_sym___inline] = ACTIONS(5131),
    [anon_sym___inline__] = ACTIONS(5131),
    [anon_sym___forceinline] = ACTIONS(5131),
    [anon_sym_thread_local] = ACTIONS(5131),
    [anon_sym___thread] = ACTIONS(5131),
    [anon_sym_const] = ACTIONS(5131),
    [anon_sym_constexpr] = ACTIONS(5131),
    [anon_sym_volatile] = ACTIONS(5131),
    [anon_sym_restrict] = ACTIONS(5131),
    [anon_sym___restrict__] = ACTIONS(5131),
    [anon_sym__Atomic] = ACTIONS(5131),
    [anon_sym__Noreturn] = ACTIONS(5131),
    [anon_sym_noreturn] = ACTIONS(5131),
    [anon_sym_mutable] = ACTIONS(5131),
    [anon_sym_constinit] = ACTIONS(5131),
    [anon_sym_consteval] = ACTIONS(5131),
    [anon_sym___shared__] = ACTIONS(5131),
    [anon_sym___local__] = ACTIONS(5131),
    [anon_sym___constant__] = ACTIONS(5131),
    [anon_sym___managed__] = ACTIONS(5131),
    [anon_sym___grid_constant__] = ACTIONS(5131),
    [anon_sym_alignas] = ACTIONS(5131),
    [anon_sym__Alignas] = ACTIONS(5131),
    [sym_primitive_type] = ACTIONS(5131),
    [anon_sym_enum] = ACTIONS(5131),
    [anon_sym_class] = ACTIONS(5131),
    [anon_sym_struct] = ACTIONS(5131),
    [anon_sym_union] = ACTIONS(5131),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5131),
    [anon_sym_decltype] = ACTIONS(5131),
    [sym_virtual] = ACTIONS(5131),
    [anon_sym_explicit] = ACTIONS(5131),
    [anon_sym_typename] = ACTIONS(5131),
    [anon_sym_template] = ACTIONS(5131),
    [anon_sym_operator] = ACTIONS(5131),
    [anon_sym_friend] = ACTIONS(5131),
    [anon_sym_public] = ACTIONS(5131),
    [anon_sym_private] = ACTIONS(5131),
    [anon_sym_protected] = ACTIONS(5131),
    [anon_sym_using] = ACTIONS(5131),
    [anon_sym_static_assert] = ACTIONS(5131),
    [anon_sym___launch_bounds__] = ACTIONS(5131),
  },
  [2030] = {
    [sym_identifier] = ACTIONS(5131),
    [aux_sym_preproc_def_token1] = ACTIONS(5131),
    [aux_sym_preproc_if_token1] = ACTIONS(5131),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5131),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5131),
    [sym_preproc_directive] = ACTIONS(5131),
    [anon_sym_LPAREN2] = ACTIONS(5133),
    [anon_sym_TILDE] = ACTIONS(5133),
    [anon_sym_STAR] = ACTIONS(5133),
    [anon_sym_AMP_AMP] = ACTIONS(5133),
    [anon_sym_AMP] = ACTIONS(5131),
    [anon_sym___extension__] = ACTIONS(5131),
    [anon_sym_typedef] = ACTIONS(5131),
    [anon_sym___device__] = ACTIONS(5131),
    [anon_sym___host__] = ACTIONS(5131),
    [anon_sym___global__] = ACTIONS(5131),
    [anon_sym___forceinline__] = ACTIONS(5131),
    [anon_sym___noinline__] = ACTIONS(5131),
    [anon_sym_extern] = ACTIONS(5131),
    [anon_sym___attribute__] = ACTIONS(5131),
    [anon_sym_COLON_COLON] = ACTIONS(5133),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5133),
    [anon_sym___declspec] = ACTIONS(5131),
    [anon_sym___based] = ACTIONS(5131),
    [anon_sym_RBRACE] = ACTIONS(5133),
    [anon_sym_signed] = ACTIONS(5131),
    [anon_sym_unsigned] = ACTIONS(5131),
    [anon_sym_long] = ACTIONS(5131),
    [anon_sym_short] = ACTIONS(5131),
    [anon_sym_LBRACK] = ACTIONS(5131),
    [anon_sym_static] = ACTIONS(5131),
    [anon_sym_register] = ACTIONS(5131),
    [anon_sym_inline] = ACTIONS(5131),
    [anon_sym___inline] = ACTIONS(5131),
    [anon_sym___inline__] = ACTIONS(5131),
    [anon_sym___forceinline] = ACTIONS(5131),
    [anon_sym_thread_local] = ACTIONS(5131),
    [anon_sym___thread] = ACTIONS(5131),
    [anon_sym_const] = ACTIONS(5131),
    [anon_sym_constexpr] = ACTIONS(5131),
    [anon_sym_volatile] = ACTIONS(5131),
    [anon_sym_restrict] = ACTIONS(5131),
    [anon_sym___restrict__] = ACTIONS(5131),
    [anon_sym__Atomic] = ACTIONS(5131),
    [anon_sym__Noreturn] = ACTIONS(5131),
    [anon_sym_noreturn] = ACTIONS(5131),
    [anon_sym_mutable] = ACTIONS(5131),
    [anon_sym_constinit] = ACTIONS(5131),
    [anon_sym_consteval] = ACTIONS(5131),
    [anon_sym___shared__] = ACTIONS(5131),
    [anon_sym___local__] = ACTIONS(5131),
    [anon_sym___constant__] = ACTIONS(5131),
    [anon_sym___managed__] = ACTIONS(5131),
    [anon_sym___grid_constant__] = ACTIONS(5131),
    [anon_sym_alignas] = ACTIONS(5131),
    [anon_sym__Alignas] = ACTIONS(5131),
    [sym_primitive_type] = ACTIONS(5131),
    [anon_sym_enum] = ACTIONS(5131),
    [anon_sym_class] = ACTIONS(5131),
    [anon_sym_struct] = ACTIONS(5131),
    [anon_sym_union] = ACTIONS(5131),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5131),
    [anon_sym_decltype] = ACTIONS(5131),
    [sym_virtual] = ACTIONS(5131),
    [anon_sym_explicit] = ACTIONS(5131),
    [anon_sym_typename] = ACTIONS(5131),
    [anon_sym_template] = ACTIONS(5131),
    [anon_sym_operator] = ACTIONS(5131),
    [anon_sym_friend] = ACTIONS(5131),
    [anon_sym_public] = ACTIONS(5131),
    [anon_sym_private] = ACTIONS(5131),
    [anon_sym_protected] = ACTIONS(5131),
    [anon_sym_using] = ACTIONS(5131),
    [anon_sym_static_assert] = ACTIONS(5131),
    [anon_sym___launch_bounds__] = ACTIONS(5131),
  },
  [2031] = {
    [sym_identifier] = ACTIONS(5035),
    [aux_sym_preproc_def_token1] = ACTIONS(5035),
    [aux_sym_preproc_if_token1] = ACTIONS(5035),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5035),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5035),
    [sym_preproc_directive] = ACTIONS(5035),
    [anon_sym_LPAREN2] = ACTIONS(5037),
    [anon_sym_TILDE] = ACTIONS(5037),
    [anon_sym_STAR] = ACTIONS(5037),
    [anon_sym_AMP_AMP] = ACTIONS(5037),
    [anon_sym_AMP] = ACTIONS(5035),
    [anon_sym___extension__] = ACTIONS(5035),
    [anon_sym_typedef] = ACTIONS(5035),
    [anon_sym___device__] = ACTIONS(5035),
    [anon_sym___host__] = ACTIONS(5035),
    [anon_sym___global__] = ACTIONS(5035),
    [anon_sym___forceinline__] = ACTIONS(5035),
    [anon_sym___noinline__] = ACTIONS(5035),
    [anon_sym_extern] = ACTIONS(5035),
    [anon_sym___attribute__] = ACTIONS(5035),
    [anon_sym_COLON_COLON] = ACTIONS(5037),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5037),
    [anon_sym___declspec] = ACTIONS(5035),
    [anon_sym___based] = ACTIONS(5035),
    [anon_sym_RBRACE] = ACTIONS(5037),
    [anon_sym_signed] = ACTIONS(5035),
    [anon_sym_unsigned] = ACTIONS(5035),
    [anon_sym_long] = ACTIONS(5035),
    [anon_sym_short] = ACTIONS(5035),
    [anon_sym_LBRACK] = ACTIONS(5035),
    [anon_sym_static] = ACTIONS(5035),
    [anon_sym_register] = ACTIONS(5035),
    [anon_sym_inline] = ACTIONS(5035),
    [anon_sym___inline] = ACTIONS(5035),
    [anon_sym___inline__] = ACTIONS(5035),
    [anon_sym___forceinline] = ACTIONS(5035),
    [anon_sym_thread_local] = ACTIONS(5035),
    [anon_sym___thread] = ACTIONS(5035),
    [anon_sym_const] = ACTIONS(5035),
    [anon_sym_constexpr] = ACTIONS(5035),
    [anon_sym_volatile] = ACTIONS(5035),
    [anon_sym_restrict] = ACTIONS(5035),
    [anon_sym___restrict__] = ACTIONS(5035),
    [anon_sym__Atomic] = ACTIONS(5035),
    [anon_sym__Noreturn] = ACTIONS(5035),
    [anon_sym_noreturn] = ACTIONS(5035),
    [anon_sym_mutable] = ACTIONS(5035),
    [anon_sym_constinit] = ACTIONS(5035),
    [anon_sym_consteval] = ACTIONS(5035),
    [anon_sym___shared__] = ACTIONS(5035),
    [anon_sym___local__] = ACTIONS(5035),
    [anon_sym___constant__] = ACTIONS(5035),
    [anon_sym___managed__] = ACTIONS(5035),
    [anon_sym___grid_constant__] = ACTIONS(5035),
    [anon_sym_alignas] = ACTIONS(5035),
    [anon_sym__Alignas] = ACTIONS(5035),
    [sym_primitive_type] = ACTIONS(5035),
    [anon_sym_enum] = ACTIONS(5035),
    [anon_sym_class] = ACTIONS(5035),
    [anon_sym_struct] = ACTIONS(5035),
    [anon_sym_union] = ACTIONS(5035),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5035),
    [anon_sym_decltype] = ACTIONS(5035),
    [sym_virtual] = ACTIONS(5035),
    [anon_sym_explicit] = ACTIONS(5035),
    [anon_sym_typename] = ACTIONS(5035),
    [anon_sym_template] = ACTIONS(5035),
    [anon_sym_operator] = ACTIONS(5035),
    [anon_sym_friend] = ACTIONS(5035),
    [anon_sym_public] = ACTIONS(5035),
    [anon_sym_private] = ACTIONS(5035),
    [anon_sym_protected] = ACTIONS(5035),
    [anon_sym_using] = ACTIONS(5035),
    [anon_sym_static_assert] = ACTIONS(5035),
    [anon_sym___launch_bounds__] = ACTIONS(5035),
  },
  [2032] = {
    [sym_identifier] = ACTIONS(1954),
    [aux_sym_preproc_def_token1] = ACTIONS(1954),
    [aux_sym_preproc_if_token1] = ACTIONS(1954),
    [aux_sym_preproc_if_token2] = ACTIONS(1954),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1954),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1954),
    [sym_preproc_directive] = ACTIONS(1954),
    [anon_sym_LPAREN2] = ACTIONS(1956),
    [anon_sym_TILDE] = ACTIONS(1956),
    [anon_sym_STAR] = ACTIONS(1956),
    [anon_sym_AMP_AMP] = ACTIONS(1956),
    [anon_sym_AMP] = ACTIONS(1954),
    [anon_sym___extension__] = ACTIONS(1954),
    [anon_sym_typedef] = ACTIONS(1954),
    [anon_sym___device__] = ACTIONS(1954),
    [anon_sym___host__] = ACTIONS(1954),
    [anon_sym___global__] = ACTIONS(1954),
    [anon_sym___forceinline__] = ACTIONS(1954),
    [anon_sym___noinline__] = ACTIONS(1954),
    [anon_sym_extern] = ACTIONS(1954),
    [anon_sym___attribute__] = ACTIONS(1954),
    [anon_sym_COLON_COLON] = ACTIONS(1956),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1956),
    [anon_sym___declspec] = ACTIONS(1954),
    [anon_sym___based] = ACTIONS(1954),
    [anon_sym_signed] = ACTIONS(1954),
    [anon_sym_unsigned] = ACTIONS(1954),
    [anon_sym_long] = ACTIONS(1954),
    [anon_sym_short] = ACTIONS(1954),
    [anon_sym_LBRACK] = ACTIONS(1954),
    [anon_sym_static] = ACTIONS(1954),
    [anon_sym_register] = ACTIONS(1954),
    [anon_sym_inline] = ACTIONS(1954),
    [anon_sym___inline] = ACTIONS(1954),
    [anon_sym___inline__] = ACTIONS(1954),
    [anon_sym___forceinline] = ACTIONS(1954),
    [anon_sym_thread_local] = ACTIONS(1954),
    [anon_sym___thread] = ACTIONS(1954),
    [anon_sym_const] = ACTIONS(1954),
    [anon_sym_constexpr] = ACTIONS(1954),
    [anon_sym_volatile] = ACTIONS(1954),
    [anon_sym_restrict] = ACTIONS(1954),
    [anon_sym___restrict__] = ACTIONS(1954),
    [anon_sym__Atomic] = ACTIONS(1954),
    [anon_sym__Noreturn] = ACTIONS(1954),
    [anon_sym_noreturn] = ACTIONS(1954),
    [anon_sym_mutable] = ACTIONS(1954),
    [anon_sym_constinit] = ACTIONS(1954),
    [anon_sym_consteval] = ACTIONS(1954),
    [anon_sym___shared__] = ACTIONS(1954),
    [anon_sym___local__] = ACTIONS(1954),
    [anon_sym___constant__] = ACTIONS(1954),
    [anon_sym___managed__] = ACTIONS(1954),
    [anon_sym___grid_constant__] = ACTIONS(1954),
    [anon_sym_alignas] = ACTIONS(1954),
    [anon_sym__Alignas] = ACTIONS(1954),
    [sym_primitive_type] = ACTIONS(1954),
    [anon_sym_enum] = ACTIONS(1954),
    [anon_sym_class] = ACTIONS(1954),
    [anon_sym_struct] = ACTIONS(1954),
    [anon_sym_union] = ACTIONS(1954),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1954),
    [anon_sym_decltype] = ACTIONS(1954),
    [sym_virtual] = ACTIONS(1954),
    [anon_sym_explicit] = ACTIONS(1954),
    [anon_sym_typename] = ACTIONS(1954),
    [anon_sym_template] = ACTIONS(1954),
    [anon_sym_operator] = ACTIONS(1954),
    [anon_sym_friend] = ACTIONS(1954),
    [anon_sym_public] = ACTIONS(1954),
    [anon_sym_private] = ACTIONS(1954),
    [anon_sym_protected] = ACTIONS(1954),
    [anon_sym_using] = ACTIONS(1954),
    [anon_sym_static_assert] = ACTIONS(1954),
    [anon_sym___launch_bounds__] = ACTIONS(1954),
  },
  [2033] = {
    [sym_identifier] = ACTIONS(1942),
    [aux_sym_preproc_def_token1] = ACTIONS(1942),
    [aux_sym_preproc_if_token1] = ACTIONS(1942),
    [aux_sym_preproc_if_token2] = ACTIONS(1942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1942),
    [sym_preproc_directive] = ACTIONS(1942),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_TILDE] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym___extension__] = ACTIONS(1942),
    [anon_sym_typedef] = ACTIONS(1942),
    [anon_sym___device__] = ACTIONS(1942),
    [anon_sym___host__] = ACTIONS(1942),
    [anon_sym___global__] = ACTIONS(1942),
    [anon_sym___forceinline__] = ACTIONS(1942),
    [anon_sym___noinline__] = ACTIONS(1942),
    [anon_sym_extern] = ACTIONS(1942),
    [anon_sym___attribute__] = ACTIONS(1942),
    [anon_sym_COLON_COLON] = ACTIONS(1944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1944),
    [anon_sym___declspec] = ACTIONS(1942),
    [anon_sym___based] = ACTIONS(1942),
    [anon_sym_signed] = ACTIONS(1942),
    [anon_sym_unsigned] = ACTIONS(1942),
    [anon_sym_long] = ACTIONS(1942),
    [anon_sym_short] = ACTIONS(1942),
    [anon_sym_LBRACK] = ACTIONS(1942),
    [anon_sym_static] = ACTIONS(1942),
    [anon_sym_register] = ACTIONS(1942),
    [anon_sym_inline] = ACTIONS(1942),
    [anon_sym___inline] = ACTIONS(1942),
    [anon_sym___inline__] = ACTIONS(1942),
    [anon_sym___forceinline] = ACTIONS(1942),
    [anon_sym_thread_local] = ACTIONS(1942),
    [anon_sym___thread] = ACTIONS(1942),
    [anon_sym_const] = ACTIONS(1942),
    [anon_sym_constexpr] = ACTIONS(1942),
    [anon_sym_volatile] = ACTIONS(1942),
    [anon_sym_restrict] = ACTIONS(1942),
    [anon_sym___restrict__] = ACTIONS(1942),
    [anon_sym__Atomic] = ACTIONS(1942),
    [anon_sym__Noreturn] = ACTIONS(1942),
    [anon_sym_noreturn] = ACTIONS(1942),
    [anon_sym_mutable] = ACTIONS(1942),
    [anon_sym_constinit] = ACTIONS(1942),
    [anon_sym_consteval] = ACTIONS(1942),
    [anon_sym___shared__] = ACTIONS(1942),
    [anon_sym___local__] = ACTIONS(1942),
    [anon_sym___constant__] = ACTIONS(1942),
    [anon_sym___managed__] = ACTIONS(1942),
    [anon_sym___grid_constant__] = ACTIONS(1942),
    [anon_sym_alignas] = ACTIONS(1942),
    [anon_sym__Alignas] = ACTIONS(1942),
    [sym_primitive_type] = ACTIONS(1942),
    [anon_sym_enum] = ACTIONS(1942),
    [anon_sym_class] = ACTIONS(1942),
    [anon_sym_struct] = ACTIONS(1942),
    [anon_sym_union] = ACTIONS(1942),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1942),
    [anon_sym_decltype] = ACTIONS(1942),
    [sym_virtual] = ACTIONS(1942),
    [anon_sym_explicit] = ACTIONS(1942),
    [anon_sym_typename] = ACTIONS(1942),
    [anon_sym_template] = ACTIONS(1942),
    [anon_sym_operator] = ACTIONS(1942),
    [anon_sym_friend] = ACTIONS(1942),
    [anon_sym_public] = ACTIONS(1942),
    [anon_sym_private] = ACTIONS(1942),
    [anon_sym_protected] = ACTIONS(1942),
    [anon_sym_using] = ACTIONS(1942),
    [anon_sym_static_assert] = ACTIONS(1942),
    [anon_sym___launch_bounds__] = ACTIONS(1942),
  },
  [2034] = {
    [sym_identifier] = ACTIONS(1942),
    [aux_sym_preproc_def_token1] = ACTIONS(1942),
    [aux_sym_preproc_if_token1] = ACTIONS(1942),
    [aux_sym_preproc_if_token2] = ACTIONS(1942),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1942),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1942),
    [sym_preproc_directive] = ACTIONS(1942),
    [anon_sym_LPAREN2] = ACTIONS(1944),
    [anon_sym_TILDE] = ACTIONS(1944),
    [anon_sym_STAR] = ACTIONS(1944),
    [anon_sym_AMP_AMP] = ACTIONS(1944),
    [anon_sym_AMP] = ACTIONS(1942),
    [anon_sym___extension__] = ACTIONS(1942),
    [anon_sym_typedef] = ACTIONS(1942),
    [anon_sym___device__] = ACTIONS(1942),
    [anon_sym___host__] = ACTIONS(1942),
    [anon_sym___global__] = ACTIONS(1942),
    [anon_sym___forceinline__] = ACTIONS(1942),
    [anon_sym___noinline__] = ACTIONS(1942),
    [anon_sym_extern] = ACTIONS(1942),
    [anon_sym___attribute__] = ACTIONS(1942),
    [anon_sym_COLON_COLON] = ACTIONS(1944),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1944),
    [anon_sym___declspec] = ACTIONS(1942),
    [anon_sym___based] = ACTIONS(1942),
    [anon_sym_signed] = ACTIONS(1942),
    [anon_sym_unsigned] = ACTIONS(1942),
    [anon_sym_long] = ACTIONS(1942),
    [anon_sym_short] = ACTIONS(1942),
    [anon_sym_LBRACK] = ACTIONS(1942),
    [anon_sym_static] = ACTIONS(1942),
    [anon_sym_register] = ACTIONS(1942),
    [anon_sym_inline] = ACTIONS(1942),
    [anon_sym___inline] = ACTIONS(1942),
    [anon_sym___inline__] = ACTIONS(1942),
    [anon_sym___forceinline] = ACTIONS(1942),
    [anon_sym_thread_local] = ACTIONS(1942),
    [anon_sym___thread] = ACTIONS(1942),
    [anon_sym_const] = ACTIONS(1942),
    [anon_sym_constexpr] = ACTIONS(1942),
    [anon_sym_volatile] = ACTIONS(1942),
    [anon_sym_restrict] = ACTIONS(1942),
    [anon_sym___restrict__] = ACTIONS(1942),
    [anon_sym__Atomic] = ACTIONS(1942),
    [anon_sym__Noreturn] = ACTIONS(1942),
    [anon_sym_noreturn] = ACTIONS(1942),
    [anon_sym_mutable] = ACTIONS(1942),
    [anon_sym_constinit] = ACTIONS(1942),
    [anon_sym_consteval] = ACTIONS(1942),
    [anon_sym___shared__] = ACTIONS(1942),
    [anon_sym___local__] = ACTIONS(1942),
    [anon_sym___constant__] = ACTIONS(1942),
    [anon_sym___managed__] = ACTIONS(1942),
    [anon_sym___grid_constant__] = ACTIONS(1942),
    [anon_sym_alignas] = ACTIONS(1942),
    [anon_sym__Alignas] = ACTIONS(1942),
    [sym_primitive_type] = ACTIONS(1942),
    [anon_sym_enum] = ACTIONS(1942),
    [anon_sym_class] = ACTIONS(1942),
    [anon_sym_struct] = ACTIONS(1942),
    [anon_sym_union] = ACTIONS(1942),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1942),
    [anon_sym_decltype] = ACTIONS(1942),
    [sym_virtual] = ACTIONS(1942),
    [anon_sym_explicit] = ACTIONS(1942),
    [anon_sym_typename] = ACTIONS(1942),
    [anon_sym_template] = ACTIONS(1942),
    [anon_sym_operator] = ACTIONS(1942),
    [anon_sym_friend] = ACTIONS(1942),
    [anon_sym_public] = ACTIONS(1942),
    [anon_sym_private] = ACTIONS(1942),
    [anon_sym_protected] = ACTIONS(1942),
    [anon_sym_using] = ACTIONS(1942),
    [anon_sym_static_assert] = ACTIONS(1942),
    [anon_sym___launch_bounds__] = ACTIONS(1942),
  },
  [2035] = {
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5313),
    [anon_sym_COMMA] = ACTIONS(5313),
    [anon_sym_RPAREN] = ACTIONS(5313),
    [anon_sym_LPAREN2] = ACTIONS(5313),
    [anon_sym_DASH] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(5311),
    [anon_sym_STAR] = ACTIONS(5313),
    [anon_sym_SLASH] = ACTIONS(5311),
    [anon_sym_PERCENT] = ACTIONS(5313),
    [anon_sym_PIPE_PIPE] = ACTIONS(5313),
    [anon_sym_AMP_AMP] = ACTIONS(5313),
    [anon_sym_PIPE] = ACTIONS(5311),
    [anon_sym_CARET] = ACTIONS(5313),
    [anon_sym_AMP] = ACTIONS(5311),
    [anon_sym_EQ_EQ] = ACTIONS(5313),
    [anon_sym_BANG_EQ] = ACTIONS(5313),
    [anon_sym_GT] = ACTIONS(5311),
    [anon_sym_GT_EQ] = ACTIONS(5313),
    [anon_sym_LT_EQ] = ACTIONS(5311),
    [anon_sym_LT] = ACTIONS(5311),
    [anon_sym_LT_LT] = ACTIONS(5311),
    [anon_sym_GT_GT] = ACTIONS(5313),
    [anon_sym_SEMI] = ACTIONS(5313),
    [anon_sym___extension__] = ACTIONS(5311),
    [anon_sym___global__] = ACTIONS(5311),
    [anon_sym___attribute__] = ACTIONS(5311),
    [anon_sym___based] = ACTIONS(5311),
    [anon_sym_LBRACE] = ACTIONS(5313),
    [anon_sym_RBRACE] = ACTIONS(5313),
    [anon_sym_signed] = ACTIONS(5311),
    [anon_sym_unsigned] = ACTIONS(5311),
    [anon_sym_long] = ACTIONS(5311),
    [anon_sym_short] = ACTIONS(5311),
    [anon_sym_LBRACK] = ACTIONS(5313),
    [anon_sym_RBRACK] = ACTIONS(5313),
    [anon_sym_const] = ACTIONS(5311),
    [anon_sym_constexpr] = ACTIONS(5311),
    [anon_sym_volatile] = ACTIONS(5311),
    [anon_sym_restrict] = ACTIONS(5311),
    [anon_sym___restrict__] = ACTIONS(5311),
    [anon_sym__Atomic] = ACTIONS(5311),
    [anon_sym__Noreturn] = ACTIONS(5311),
    [anon_sym_noreturn] = ACTIONS(5311),
    [anon_sym_mutable] = ACTIONS(5311),
    [anon_sym_constinit] = ACTIONS(5311),
    [anon_sym_consteval] = ACTIONS(5311),
    [anon_sym___shared__] = ACTIONS(5311),
    [anon_sym___local__] = ACTIONS(5311),
    [anon_sym___constant__] = ACTIONS(5311),
    [anon_sym___managed__] = ACTIONS(5311),
    [anon_sym___grid_constant__] = ACTIONS(5311),
    [anon_sym_alignas] = ACTIONS(5311),
    [anon_sym__Alignas] = ACTIONS(5311),
    [sym_primitive_type] = ACTIONS(5311),
    [anon_sym_COLON] = ACTIONS(5313),
    [anon_sym_QMARK] = ACTIONS(5313),
    [anon_sym_LT_EQ_GT] = ACTIONS(5313),
    [anon_sym_or] = ACTIONS(5311),
    [anon_sym_and] = ACTIONS(5311),
    [anon_sym_bitor] = ACTIONS(5311),
    [anon_sym_xor] = ACTIONS(5311),
    [anon_sym_bitand] = ACTIONS(5311),
    [anon_sym_not_eq] = ACTIONS(5311),
    [anon_sym_DASH_DASH] = ACTIONS(5313),
    [anon_sym_PLUS_PLUS] = ACTIONS(5313),
    [anon_sym_DOT] = ACTIONS(5311),
    [anon_sym_DOT_STAR] = ACTIONS(5313),
    [anon_sym_DASH_GT] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5311),
    [anon_sym_decltype] = ACTIONS(5311),
    [anon_sym_final] = ACTIONS(5311),
    [anon_sym_override] = ACTIONS(5311),
    [anon_sym_requires] = ACTIONS(5311),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5313),
  },
  [2036] = {
    [sym_identifier] = ACTIONS(5031),
    [aux_sym_preproc_def_token1] = ACTIONS(5031),
    [aux_sym_preproc_if_token1] = ACTIONS(5031),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5031),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5031),
    [sym_preproc_directive] = ACTIONS(5031),
    [anon_sym_LPAREN2] = ACTIONS(5033),
    [anon_sym_TILDE] = ACTIONS(5033),
    [anon_sym_STAR] = ACTIONS(5033),
    [anon_sym_AMP_AMP] = ACTIONS(5033),
    [anon_sym_AMP] = ACTIONS(5031),
    [anon_sym___extension__] = ACTIONS(5031),
    [anon_sym_typedef] = ACTIONS(5031),
    [anon_sym___device__] = ACTIONS(5031),
    [anon_sym___host__] = ACTIONS(5031),
    [anon_sym___global__] = ACTIONS(5031),
    [anon_sym___forceinline__] = ACTIONS(5031),
    [anon_sym___noinline__] = ACTIONS(5031),
    [anon_sym_extern] = ACTIONS(5031),
    [anon_sym___attribute__] = ACTIONS(5031),
    [anon_sym_COLON_COLON] = ACTIONS(5033),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5033),
    [anon_sym___declspec] = ACTIONS(5031),
    [anon_sym___based] = ACTIONS(5031),
    [anon_sym_RBRACE] = ACTIONS(5033),
    [anon_sym_signed] = ACTIONS(5031),
    [anon_sym_unsigned] = ACTIONS(5031),
    [anon_sym_long] = ACTIONS(5031),
    [anon_sym_short] = ACTIONS(5031),
    [anon_sym_LBRACK] = ACTIONS(5031),
    [anon_sym_static] = ACTIONS(5031),
    [anon_sym_register] = ACTIONS(5031),
    [anon_sym_inline] = ACTIONS(5031),
    [anon_sym___inline] = ACTIONS(5031),
    [anon_sym___inline__] = ACTIONS(5031),
    [anon_sym___forceinline] = ACTIONS(5031),
    [anon_sym_thread_local] = ACTIONS(5031),
    [anon_sym___thread] = ACTIONS(5031),
    [anon_sym_const] = ACTIONS(5031),
    [anon_sym_constexpr] = ACTIONS(5031),
    [anon_sym_volatile] = ACTIONS(5031),
    [anon_sym_restrict] = ACTIONS(5031),
    [anon_sym___restrict__] = ACTIONS(5031),
    [anon_sym__Atomic] = ACTIONS(5031),
    [anon_sym__Noreturn] = ACTIONS(5031),
    [anon_sym_noreturn] = ACTIONS(5031),
    [anon_sym_mutable] = ACTIONS(5031),
    [anon_sym_constinit] = ACTIONS(5031),
    [anon_sym_consteval] = ACTIONS(5031),
    [anon_sym___shared__] = ACTIONS(5031),
    [anon_sym___local__] = ACTIONS(5031),
    [anon_sym___constant__] = ACTIONS(5031),
    [anon_sym___managed__] = ACTIONS(5031),
    [anon_sym___grid_constant__] = ACTIONS(5031),
    [anon_sym_alignas] = ACTIONS(5031),
    [anon_sym__Alignas] = ACTIONS(5031),
    [sym_primitive_type] = ACTIONS(5031),
    [anon_sym_enum] = ACTIONS(5031),
    [anon_sym_class] = ACTIONS(5031),
    [anon_sym_struct] = ACTIONS(5031),
    [anon_sym_union] = ACTIONS(5031),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5031),
    [anon_sym_decltype] = ACTIONS(5031),
    [sym_virtual] = ACTIONS(5031),
    [anon_sym_explicit] = ACTIONS(5031),
    [anon_sym_typename] = ACTIONS(5031),
    [anon_sym_template] = ACTIONS(5031),
    [anon_sym_operator] = ACTIONS(5031),
    [anon_sym_friend] = ACTIONS(5031),
    [anon_sym_public] = ACTIONS(5031),
    [anon_sym_private] = ACTIONS(5031),
    [anon_sym_protected] = ACTIONS(5031),
    [anon_sym_using] = ACTIONS(5031),
    [anon_sym_static_assert] = ACTIONS(5031),
    [anon_sym___launch_bounds__] = ACTIONS(5031),
  },
  [2037] = {
    [sym_identifier] = ACTIONS(5067),
    [aux_sym_preproc_def_token1] = ACTIONS(5067),
    [aux_sym_preproc_if_token1] = ACTIONS(5067),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5067),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5067),
    [sym_preproc_directive] = ACTIONS(5067),
    [anon_sym_LPAREN2] = ACTIONS(5069),
    [anon_sym_TILDE] = ACTIONS(5069),
    [anon_sym_STAR] = ACTIONS(5069),
    [anon_sym_AMP_AMP] = ACTIONS(5069),
    [anon_sym_AMP] = ACTIONS(5067),
    [anon_sym___extension__] = ACTIONS(5067),
    [anon_sym_typedef] = ACTIONS(5067),
    [anon_sym___device__] = ACTIONS(5067),
    [anon_sym___host__] = ACTIONS(5067),
    [anon_sym___global__] = ACTIONS(5067),
    [anon_sym___forceinline__] = ACTIONS(5067),
    [anon_sym___noinline__] = ACTIONS(5067),
    [anon_sym_extern] = ACTIONS(5067),
    [anon_sym___attribute__] = ACTIONS(5067),
    [anon_sym_COLON_COLON] = ACTIONS(5069),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5069),
    [anon_sym___declspec] = ACTIONS(5067),
    [anon_sym___based] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(5069),
    [anon_sym_signed] = ACTIONS(5067),
    [anon_sym_unsigned] = ACTIONS(5067),
    [anon_sym_long] = ACTIONS(5067),
    [anon_sym_short] = ACTIONS(5067),
    [anon_sym_LBRACK] = ACTIONS(5067),
    [anon_sym_static] = ACTIONS(5067),
    [anon_sym_register] = ACTIONS(5067),
    [anon_sym_inline] = ACTIONS(5067),
    [anon_sym___inline] = ACTIONS(5067),
    [anon_sym___inline__] = ACTIONS(5067),
    [anon_sym___forceinline] = ACTIONS(5067),
    [anon_sym_thread_local] = ACTIONS(5067),
    [anon_sym___thread] = ACTIONS(5067),
    [anon_sym_const] = ACTIONS(5067),
    [anon_sym_constexpr] = ACTIONS(5067),
    [anon_sym_volatile] = ACTIONS(5067),
    [anon_sym_restrict] = ACTIONS(5067),
    [anon_sym___restrict__] = ACTIONS(5067),
    [anon_sym__Atomic] = ACTIONS(5067),
    [anon_sym__Noreturn] = ACTIONS(5067),
    [anon_sym_noreturn] = ACTIONS(5067),
    [anon_sym_mutable] = ACTIONS(5067),
    [anon_sym_constinit] = ACTIONS(5067),
    [anon_sym_consteval] = ACTIONS(5067),
    [anon_sym___shared__] = ACTIONS(5067),
    [anon_sym___local__] = ACTIONS(5067),
    [anon_sym___constant__] = ACTIONS(5067),
    [anon_sym___managed__] = ACTIONS(5067),
    [anon_sym___grid_constant__] = ACTIONS(5067),
    [anon_sym_alignas] = ACTIONS(5067),
    [anon_sym__Alignas] = ACTIONS(5067),
    [sym_primitive_type] = ACTIONS(5067),
    [anon_sym_enum] = ACTIONS(5067),
    [anon_sym_class] = ACTIONS(5067),
    [anon_sym_struct] = ACTIONS(5067),
    [anon_sym_union] = ACTIONS(5067),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5067),
    [anon_sym_decltype] = ACTIONS(5067),
    [sym_virtual] = ACTIONS(5067),
    [anon_sym_explicit] = ACTIONS(5067),
    [anon_sym_typename] = ACTIONS(5067),
    [anon_sym_template] = ACTIONS(5067),
    [anon_sym_operator] = ACTIONS(5067),
    [anon_sym_friend] = ACTIONS(5067),
    [anon_sym_public] = ACTIONS(5067),
    [anon_sym_private] = ACTIONS(5067),
    [anon_sym_protected] = ACTIONS(5067),
    [anon_sym_using] = ACTIONS(5067),
    [anon_sym_static_assert] = ACTIONS(5067),
    [anon_sym___launch_bounds__] = ACTIONS(5067),
  },
  [2038] = {
    [sym_identifier] = ACTIONS(5071),
    [aux_sym_preproc_def_token1] = ACTIONS(5071),
    [aux_sym_preproc_if_token1] = ACTIONS(5071),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5071),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5071),
    [sym_preproc_directive] = ACTIONS(5071),
    [anon_sym_LPAREN2] = ACTIONS(5073),
    [anon_sym_TILDE] = ACTIONS(5073),
    [anon_sym_STAR] = ACTIONS(5073),
    [anon_sym_AMP_AMP] = ACTIONS(5073),
    [anon_sym_AMP] = ACTIONS(5071),
    [anon_sym___extension__] = ACTIONS(5071),
    [anon_sym_typedef] = ACTIONS(5071),
    [anon_sym___device__] = ACTIONS(5071),
    [anon_sym___host__] = ACTIONS(5071),
    [anon_sym___global__] = ACTIONS(5071),
    [anon_sym___forceinline__] = ACTIONS(5071),
    [anon_sym___noinline__] = ACTIONS(5071),
    [anon_sym_extern] = ACTIONS(5071),
    [anon_sym___attribute__] = ACTIONS(5071),
    [anon_sym_COLON_COLON] = ACTIONS(5073),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5073),
    [anon_sym___declspec] = ACTIONS(5071),
    [anon_sym___based] = ACTIONS(5071),
    [anon_sym_RBRACE] = ACTIONS(5073),
    [anon_sym_signed] = ACTIONS(5071),
    [anon_sym_unsigned] = ACTIONS(5071),
    [anon_sym_long] = ACTIONS(5071),
    [anon_sym_short] = ACTIONS(5071),
    [anon_sym_LBRACK] = ACTIONS(5071),
    [anon_sym_static] = ACTIONS(5071),
    [anon_sym_register] = ACTIONS(5071),
    [anon_sym_inline] = ACTIONS(5071),
    [anon_sym___inline] = ACTIONS(5071),
    [anon_sym___inline__] = ACTIONS(5071),
    [anon_sym___forceinline] = ACTIONS(5071),
    [anon_sym_thread_local] = ACTIONS(5071),
    [anon_sym___thread] = ACTIONS(5071),
    [anon_sym_const] = ACTIONS(5071),
    [anon_sym_constexpr] = ACTIONS(5071),
    [anon_sym_volatile] = ACTIONS(5071),
    [anon_sym_restrict] = ACTIONS(5071),
    [anon_sym___restrict__] = ACTIONS(5071),
    [anon_sym__Atomic] = ACTIONS(5071),
    [anon_sym__Noreturn] = ACTIONS(5071),
    [anon_sym_noreturn] = ACTIONS(5071),
    [anon_sym_mutable] = ACTIONS(5071),
    [anon_sym_constinit] = ACTIONS(5071),
    [anon_sym_consteval] = ACTIONS(5071),
    [anon_sym___shared__] = ACTIONS(5071),
    [anon_sym___local__] = ACTIONS(5071),
    [anon_sym___constant__] = ACTIONS(5071),
    [anon_sym___managed__] = ACTIONS(5071),
    [anon_sym___grid_constant__] = ACTIONS(5071),
    [anon_sym_alignas] = ACTIONS(5071),
    [anon_sym__Alignas] = ACTIONS(5071),
    [sym_primitive_type] = ACTIONS(5071),
    [anon_sym_enum] = ACTIONS(5071),
    [anon_sym_class] = ACTIONS(5071),
    [anon_sym_struct] = ACTIONS(5071),
    [anon_sym_union] = ACTIONS(5071),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5071),
    [anon_sym_decltype] = ACTIONS(5071),
    [sym_virtual] = ACTIONS(5071),
    [anon_sym_explicit] = ACTIONS(5071),
    [anon_sym_typename] = ACTIONS(5071),
    [anon_sym_template] = ACTIONS(5071),
    [anon_sym_operator] = ACTIONS(5071),
    [anon_sym_friend] = ACTIONS(5071),
    [anon_sym_public] = ACTIONS(5071),
    [anon_sym_private] = ACTIONS(5071),
    [anon_sym_protected] = ACTIONS(5071),
    [anon_sym_using] = ACTIONS(5071),
    [anon_sym_static_assert] = ACTIONS(5071),
    [anon_sym___launch_bounds__] = ACTIONS(5071),
  },
  [2039] = {
    [sym_identifier] = ACTIONS(5099),
    [aux_sym_preproc_def_token1] = ACTIONS(5099),
    [aux_sym_preproc_if_token1] = ACTIONS(5099),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5099),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5099),
    [sym_preproc_directive] = ACTIONS(5099),
    [anon_sym_LPAREN2] = ACTIONS(5101),
    [anon_sym_TILDE] = ACTIONS(5101),
    [anon_sym_STAR] = ACTIONS(5101),
    [anon_sym_AMP_AMP] = ACTIONS(5101),
    [anon_sym_AMP] = ACTIONS(5099),
    [anon_sym___extension__] = ACTIONS(5099),
    [anon_sym_typedef] = ACTIONS(5099),
    [anon_sym___device__] = ACTIONS(5099),
    [anon_sym___host__] = ACTIONS(5099),
    [anon_sym___global__] = ACTIONS(5099),
    [anon_sym___forceinline__] = ACTIONS(5099),
    [anon_sym___noinline__] = ACTIONS(5099),
    [anon_sym_extern] = ACTIONS(5099),
    [anon_sym___attribute__] = ACTIONS(5099),
    [anon_sym_COLON_COLON] = ACTIONS(5101),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5101),
    [anon_sym___declspec] = ACTIONS(5099),
    [anon_sym___based] = ACTIONS(5099),
    [anon_sym_RBRACE] = ACTIONS(5101),
    [anon_sym_signed] = ACTIONS(5099),
    [anon_sym_unsigned] = ACTIONS(5099),
    [anon_sym_long] = ACTIONS(5099),
    [anon_sym_short] = ACTIONS(5099),
    [anon_sym_LBRACK] = ACTIONS(5099),
    [anon_sym_static] = ACTIONS(5099),
    [anon_sym_register] = ACTIONS(5099),
    [anon_sym_inline] = ACTIONS(5099),
    [anon_sym___inline] = ACTIONS(5099),
    [anon_sym___inline__] = ACTIONS(5099),
    [anon_sym___forceinline] = ACTIONS(5099),
    [anon_sym_thread_local] = ACTIONS(5099),
    [anon_sym___thread] = ACTIONS(5099),
    [anon_sym_const] = ACTIONS(5099),
    [anon_sym_constexpr] = ACTIONS(5099),
    [anon_sym_volatile] = ACTIONS(5099),
    [anon_sym_restrict] = ACTIONS(5099),
    [anon_sym___restrict__] = ACTIONS(5099),
    [anon_sym__Atomic] = ACTIONS(5099),
    [anon_sym__Noreturn] = ACTIONS(5099),
    [anon_sym_noreturn] = ACTIONS(5099),
    [anon_sym_mutable] = ACTIONS(5099),
    [anon_sym_constinit] = ACTIONS(5099),
    [anon_sym_consteval] = ACTIONS(5099),
    [anon_sym___shared__] = ACTIONS(5099),
    [anon_sym___local__] = ACTIONS(5099),
    [anon_sym___constant__] = ACTIONS(5099),
    [anon_sym___managed__] = ACTIONS(5099),
    [anon_sym___grid_constant__] = ACTIONS(5099),
    [anon_sym_alignas] = ACTIONS(5099),
    [anon_sym__Alignas] = ACTIONS(5099),
    [sym_primitive_type] = ACTIONS(5099),
    [anon_sym_enum] = ACTIONS(5099),
    [anon_sym_class] = ACTIONS(5099),
    [anon_sym_struct] = ACTIONS(5099),
    [anon_sym_union] = ACTIONS(5099),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5099),
    [anon_sym_decltype] = ACTIONS(5099),
    [sym_virtual] = ACTIONS(5099),
    [anon_sym_explicit] = ACTIONS(5099),
    [anon_sym_typename] = ACTIONS(5099),
    [anon_sym_template] = ACTIONS(5099),
    [anon_sym_operator] = ACTIONS(5099),
    [anon_sym_friend] = ACTIONS(5099),
    [anon_sym_public] = ACTIONS(5099),
    [anon_sym_private] = ACTIONS(5099),
    [anon_sym_protected] = ACTIONS(5099),
    [anon_sym_using] = ACTIONS(5099),
    [anon_sym_static_assert] = ACTIONS(5099),
    [anon_sym___launch_bounds__] = ACTIONS(5099),
  },
  [2040] = {
    [sym_identifier] = ACTIONS(2356),
    [aux_sym_preproc_def_token1] = ACTIONS(2356),
    [aux_sym_preproc_if_token1] = ACTIONS(2356),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2356),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2356),
    [sym_preproc_directive] = ACTIONS(2356),
    [anon_sym_LPAREN2] = ACTIONS(2358),
    [anon_sym_TILDE] = ACTIONS(2358),
    [anon_sym_STAR] = ACTIONS(2358),
    [anon_sym_AMP_AMP] = ACTIONS(2358),
    [anon_sym_AMP] = ACTIONS(2356),
    [anon_sym___extension__] = ACTIONS(2356),
    [anon_sym_typedef] = ACTIONS(2356),
    [anon_sym___device__] = ACTIONS(2356),
    [anon_sym___host__] = ACTIONS(2356),
    [anon_sym___global__] = ACTIONS(2356),
    [anon_sym___forceinline__] = ACTIONS(2356),
    [anon_sym___noinline__] = ACTIONS(2356),
    [anon_sym_extern] = ACTIONS(2356),
    [anon_sym___attribute__] = ACTIONS(2356),
    [anon_sym_COLON_COLON] = ACTIONS(2358),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2358),
    [anon_sym___declspec] = ACTIONS(2356),
    [anon_sym___based] = ACTIONS(2356),
    [anon_sym_RBRACE] = ACTIONS(2358),
    [anon_sym_signed] = ACTIONS(2356),
    [anon_sym_unsigned] = ACTIONS(2356),
    [anon_sym_long] = ACTIONS(2356),
    [anon_sym_short] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2356),
    [anon_sym_register] = ACTIONS(2356),
    [anon_sym_inline] = ACTIONS(2356),
    [anon_sym___inline] = ACTIONS(2356),
    [anon_sym___inline__] = ACTIONS(2356),
    [anon_sym___forceinline] = ACTIONS(2356),
    [anon_sym_thread_local] = ACTIONS(2356),
    [anon_sym___thread] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(2356),
    [anon_sym_constexpr] = ACTIONS(2356),
    [anon_sym_volatile] = ACTIONS(2356),
    [anon_sym_restrict] = ACTIONS(2356),
    [anon_sym___restrict__] = ACTIONS(2356),
    [anon_sym__Atomic] = ACTIONS(2356),
    [anon_sym__Noreturn] = ACTIONS(2356),
    [anon_sym_noreturn] = ACTIONS(2356),
    [anon_sym_mutable] = ACTIONS(2356),
    [anon_sym_constinit] = ACTIONS(2356),
    [anon_sym_consteval] = ACTIONS(2356),
    [anon_sym___shared__] = ACTIONS(2356),
    [anon_sym___local__] = ACTIONS(2356),
    [anon_sym___constant__] = ACTIONS(2356),
    [anon_sym___managed__] = ACTIONS(2356),
    [anon_sym___grid_constant__] = ACTIONS(2356),
    [anon_sym_alignas] = ACTIONS(2356),
    [anon_sym__Alignas] = ACTIONS(2356),
    [sym_primitive_type] = ACTIONS(2356),
    [anon_sym_enum] = ACTIONS(2356),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_struct] = ACTIONS(2356),
    [anon_sym_union] = ACTIONS(2356),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2356),
    [anon_sym_decltype] = ACTIONS(2356),
    [sym_virtual] = ACTIONS(2356),
    [anon_sym_explicit] = ACTIONS(2356),
    [anon_sym_typename] = ACTIONS(2356),
    [anon_sym_template] = ACTIONS(2356),
    [anon_sym_operator] = ACTIONS(2356),
    [anon_sym_friend] = ACTIONS(2356),
    [anon_sym_public] = ACTIONS(2356),
    [anon_sym_private] = ACTIONS(2356),
    [anon_sym_protected] = ACTIONS(2356),
    [anon_sym_using] = ACTIONS(2356),
    [anon_sym_static_assert] = ACTIONS(2356),
    [anon_sym___launch_bounds__] = ACTIONS(2356),
  },
  [2041] = {
    [sym_identifier] = ACTIONS(5095),
    [aux_sym_preproc_def_token1] = ACTIONS(5095),
    [aux_sym_preproc_if_token1] = ACTIONS(5095),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5095),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5095),
    [sym_preproc_directive] = ACTIONS(5095),
    [anon_sym_LPAREN2] = ACTIONS(5097),
    [anon_sym_TILDE] = ACTIONS(5097),
    [anon_sym_STAR] = ACTIONS(5097),
    [anon_sym_AMP_AMP] = ACTIONS(5097),
    [anon_sym_AMP] = ACTIONS(5095),
    [anon_sym___extension__] = ACTIONS(5095),
    [anon_sym_typedef] = ACTIONS(5095),
    [anon_sym___device__] = ACTIONS(5095),
    [anon_sym___host__] = ACTIONS(5095),
    [anon_sym___global__] = ACTIONS(5095),
    [anon_sym___forceinline__] = ACTIONS(5095),
    [anon_sym___noinline__] = ACTIONS(5095),
    [anon_sym_extern] = ACTIONS(5095),
    [anon_sym___attribute__] = ACTIONS(5095),
    [anon_sym_COLON_COLON] = ACTIONS(5097),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5097),
    [anon_sym___declspec] = ACTIONS(5095),
    [anon_sym___based] = ACTIONS(5095),
    [anon_sym_RBRACE] = ACTIONS(5097),
    [anon_sym_signed] = ACTIONS(5095),
    [anon_sym_unsigned] = ACTIONS(5095),
    [anon_sym_long] = ACTIONS(5095),
    [anon_sym_short] = ACTIONS(5095),
    [anon_sym_LBRACK] = ACTIONS(5095),
    [anon_sym_static] = ACTIONS(5095),
    [anon_sym_register] = ACTIONS(5095),
    [anon_sym_inline] = ACTIONS(5095),
    [anon_sym___inline] = ACTIONS(5095),
    [anon_sym___inline__] = ACTIONS(5095),
    [anon_sym___forceinline] = ACTIONS(5095),
    [anon_sym_thread_local] = ACTIONS(5095),
    [anon_sym___thread] = ACTIONS(5095),
    [anon_sym_const] = ACTIONS(5095),
    [anon_sym_constexpr] = ACTIONS(5095),
    [anon_sym_volatile] = ACTIONS(5095),
    [anon_sym_restrict] = ACTIONS(5095),
    [anon_sym___restrict__] = ACTIONS(5095),
    [anon_sym__Atomic] = ACTIONS(5095),
    [anon_sym__Noreturn] = ACTIONS(5095),
    [anon_sym_noreturn] = ACTIONS(5095),
    [anon_sym_mutable] = ACTIONS(5095),
    [anon_sym_constinit] = ACTIONS(5095),
    [anon_sym_consteval] = ACTIONS(5095),
    [anon_sym___shared__] = ACTIONS(5095),
    [anon_sym___local__] = ACTIONS(5095),
    [anon_sym___constant__] = ACTIONS(5095),
    [anon_sym___managed__] = ACTIONS(5095),
    [anon_sym___grid_constant__] = ACTIONS(5095),
    [anon_sym_alignas] = ACTIONS(5095),
    [anon_sym__Alignas] = ACTIONS(5095),
    [sym_primitive_type] = ACTIONS(5095),
    [anon_sym_enum] = ACTIONS(5095),
    [anon_sym_class] = ACTIONS(5095),
    [anon_sym_struct] = ACTIONS(5095),
    [anon_sym_union] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5095),
    [anon_sym_decltype] = ACTIONS(5095),
    [sym_virtual] = ACTIONS(5095),
    [anon_sym_explicit] = ACTIONS(5095),
    [anon_sym_typename] = ACTIONS(5095),
    [anon_sym_template] = ACTIONS(5095),
    [anon_sym_operator] = ACTIONS(5095),
    [anon_sym_friend] = ACTIONS(5095),
    [anon_sym_public] = ACTIONS(5095),
    [anon_sym_private] = ACTIONS(5095),
    [anon_sym_protected] = ACTIONS(5095),
    [anon_sym_using] = ACTIONS(5095),
    [anon_sym_static_assert] = ACTIONS(5095),
    [anon_sym___launch_bounds__] = ACTIONS(5095),
  },
  [2042] = {
    [sym_identifier] = ACTIONS(5091),
    [aux_sym_preproc_def_token1] = ACTIONS(5091),
    [aux_sym_preproc_if_token1] = ACTIONS(5091),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5091),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5091),
    [sym_preproc_directive] = ACTIONS(5091),
    [anon_sym_LPAREN2] = ACTIONS(5093),
    [anon_sym_TILDE] = ACTIONS(5093),
    [anon_sym_STAR] = ACTIONS(5093),
    [anon_sym_AMP_AMP] = ACTIONS(5093),
    [anon_sym_AMP] = ACTIONS(5091),
    [anon_sym___extension__] = ACTIONS(5091),
    [anon_sym_typedef] = ACTIONS(5091),
    [anon_sym___device__] = ACTIONS(5091),
    [anon_sym___host__] = ACTIONS(5091),
    [anon_sym___global__] = ACTIONS(5091),
    [anon_sym___forceinline__] = ACTIONS(5091),
    [anon_sym___noinline__] = ACTIONS(5091),
    [anon_sym_extern] = ACTIONS(5091),
    [anon_sym___attribute__] = ACTIONS(5091),
    [anon_sym_COLON_COLON] = ACTIONS(5093),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5093),
    [anon_sym___declspec] = ACTIONS(5091),
    [anon_sym___based] = ACTIONS(5091),
    [anon_sym_RBRACE] = ACTIONS(5093),
    [anon_sym_signed] = ACTIONS(5091),
    [anon_sym_unsigned] = ACTIONS(5091),
    [anon_sym_long] = ACTIONS(5091),
    [anon_sym_short] = ACTIONS(5091),
    [anon_sym_LBRACK] = ACTIONS(5091),
    [anon_sym_static] = ACTIONS(5091),
    [anon_sym_register] = ACTIONS(5091),
    [anon_sym_inline] = ACTIONS(5091),
    [anon_sym___inline] = ACTIONS(5091),
    [anon_sym___inline__] = ACTIONS(5091),
    [anon_sym___forceinline] = ACTIONS(5091),
    [anon_sym_thread_local] = ACTIONS(5091),
    [anon_sym___thread] = ACTIONS(5091),
    [anon_sym_const] = ACTIONS(5091),
    [anon_sym_constexpr] = ACTIONS(5091),
    [anon_sym_volatile] = ACTIONS(5091),
    [anon_sym_restrict] = ACTIONS(5091),
    [anon_sym___restrict__] = ACTIONS(5091),
    [anon_sym__Atomic] = ACTIONS(5091),
    [anon_sym__Noreturn] = ACTIONS(5091),
    [anon_sym_noreturn] = ACTIONS(5091),
    [anon_sym_mutable] = ACTIONS(5091),
    [anon_sym_constinit] = ACTIONS(5091),
    [anon_sym_consteval] = ACTIONS(5091),
    [anon_sym___shared__] = ACTIONS(5091),
    [anon_sym___local__] = ACTIONS(5091),
    [anon_sym___constant__] = ACTIONS(5091),
    [anon_sym___managed__] = ACTIONS(5091),
    [anon_sym___grid_constant__] = ACTIONS(5091),
    [anon_sym_alignas] = ACTIONS(5091),
    [anon_sym__Alignas] = ACTIONS(5091),
    [sym_primitive_type] = ACTIONS(5091),
    [anon_sym_enum] = ACTIONS(5091),
    [anon_sym_class] = ACTIONS(5091),
    [anon_sym_struct] = ACTIONS(5091),
    [anon_sym_union] = ACTIONS(5091),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5091),
    [anon_sym_decltype] = ACTIONS(5091),
    [sym_virtual] = ACTIONS(5091),
    [anon_sym_explicit] = ACTIONS(5091),
    [anon_sym_typename] = ACTIONS(5091),
    [anon_sym_template] = ACTIONS(5091),
    [anon_sym_operator] = ACTIONS(5091),
    [anon_sym_friend] = ACTIONS(5091),
    [anon_sym_public] = ACTIONS(5091),
    [anon_sym_private] = ACTIONS(5091),
    [anon_sym_protected] = ACTIONS(5091),
    [anon_sym_using] = ACTIONS(5091),
    [anon_sym_static_assert] = ACTIONS(5091),
    [anon_sym___launch_bounds__] = ACTIONS(5091),
  },
  [2043] = {
    [sym_identifier] = ACTIONS(2275),
    [aux_sym_preproc_def_token1] = ACTIONS(2275),
    [aux_sym_preproc_if_token1] = ACTIONS(2275),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2275),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2275),
    [sym_preproc_directive] = ACTIONS(2275),
    [anon_sym_LPAREN2] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [anon_sym_STAR] = ACTIONS(2277),
    [anon_sym_AMP_AMP] = ACTIONS(2277),
    [anon_sym_AMP] = ACTIONS(2275),
    [anon_sym___extension__] = ACTIONS(2275),
    [anon_sym_typedef] = ACTIONS(2275),
    [anon_sym___device__] = ACTIONS(2275),
    [anon_sym___host__] = ACTIONS(2275),
    [anon_sym___global__] = ACTIONS(2275),
    [anon_sym___forceinline__] = ACTIONS(2275),
    [anon_sym___noinline__] = ACTIONS(2275),
    [anon_sym_extern] = ACTIONS(2275),
    [anon_sym___attribute__] = ACTIONS(2275),
    [anon_sym_COLON_COLON] = ACTIONS(2277),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2277),
    [anon_sym___declspec] = ACTIONS(2275),
    [anon_sym___based] = ACTIONS(2275),
    [anon_sym_RBRACE] = ACTIONS(2277),
    [anon_sym_signed] = ACTIONS(2275),
    [anon_sym_unsigned] = ACTIONS(2275),
    [anon_sym_long] = ACTIONS(2275),
    [anon_sym_short] = ACTIONS(2275),
    [anon_sym_LBRACK] = ACTIONS(2275),
    [anon_sym_static] = ACTIONS(2275),
    [anon_sym_register] = ACTIONS(2275),
    [anon_sym_inline] = ACTIONS(2275),
    [anon_sym___inline] = ACTIONS(2275),
    [anon_sym___inline__] = ACTIONS(2275),
    [anon_sym___forceinline] = ACTIONS(2275),
    [anon_sym_thread_local] = ACTIONS(2275),
    [anon_sym___thread] = ACTIONS(2275),
    [anon_sym_const] = ACTIONS(2275),
    [anon_sym_constexpr] = ACTIONS(2275),
    [anon_sym_volatile] = ACTIONS(2275),
    [anon_sym_restrict] = ACTIONS(2275),
    [anon_sym___restrict__] = ACTIONS(2275),
    [anon_sym__Atomic] = ACTIONS(2275),
    [anon_sym__Noreturn] = ACTIONS(2275),
    [anon_sym_noreturn] = ACTIONS(2275),
    [anon_sym_mutable] = ACTIONS(2275),
    [anon_sym_constinit] = ACTIONS(2275),
    [anon_sym_consteval] = ACTIONS(2275),
    [anon_sym___shared__] = ACTIONS(2275),
    [anon_sym___local__] = ACTIONS(2275),
    [anon_sym___constant__] = ACTIONS(2275),
    [anon_sym___managed__] = ACTIONS(2275),
    [anon_sym___grid_constant__] = ACTIONS(2275),
    [anon_sym_alignas] = ACTIONS(2275),
    [anon_sym__Alignas] = ACTIONS(2275),
    [sym_primitive_type] = ACTIONS(2275),
    [anon_sym_enum] = ACTIONS(2275),
    [anon_sym_class] = ACTIONS(2275),
    [anon_sym_struct] = ACTIONS(2275),
    [anon_sym_union] = ACTIONS(2275),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2275),
    [anon_sym_decltype] = ACTIONS(2275),
    [sym_virtual] = ACTIONS(2275),
    [anon_sym_explicit] = ACTIONS(2275),
    [anon_sym_typename] = ACTIONS(2275),
    [anon_sym_template] = ACTIONS(2275),
    [anon_sym_operator] = ACTIONS(2275),
    [anon_sym_friend] = ACTIONS(2275),
    [anon_sym_public] = ACTIONS(2275),
    [anon_sym_private] = ACTIONS(2275),
    [anon_sym_protected] = ACTIONS(2275),
    [anon_sym_using] = ACTIONS(2275),
    [anon_sym_static_assert] = ACTIONS(2275),
    [anon_sym___launch_bounds__] = ACTIONS(2275),
  },
  [2044] = {
    [sym_identifier] = ACTIONS(2056),
    [aux_sym_preproc_def_token1] = ACTIONS(2056),
    [aux_sym_preproc_if_token1] = ACTIONS(2056),
    [aux_sym_preproc_if_token2] = ACTIONS(2056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2056),
    [sym_preproc_directive] = ACTIONS(2056),
    [anon_sym_LPAREN2] = ACTIONS(2058),
    [anon_sym_TILDE] = ACTIONS(2058),
    [anon_sym_STAR] = ACTIONS(2058),
    [anon_sym_AMP_AMP] = ACTIONS(2058),
    [anon_sym_AMP] = ACTIONS(2056),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_typedef] = ACTIONS(2056),
    [anon_sym___device__] = ACTIONS(2056),
    [anon_sym___host__] = ACTIONS(2056),
    [anon_sym___global__] = ACTIONS(2056),
    [anon_sym___forceinline__] = ACTIONS(2056),
    [anon_sym___noinline__] = ACTIONS(2056),
    [anon_sym_extern] = ACTIONS(2056),
    [anon_sym___attribute__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2058),
    [anon_sym___declspec] = ACTIONS(2056),
    [anon_sym___based] = ACTIONS(2056),
    [anon_sym_signed] = ACTIONS(2056),
    [anon_sym_unsigned] = ACTIONS(2056),
    [anon_sym_long] = ACTIONS(2056),
    [anon_sym_short] = ACTIONS(2056),
    [anon_sym_LBRACK] = ACTIONS(2056),
    [anon_sym_static] = ACTIONS(2056),
    [anon_sym_register] = ACTIONS(2056),
    [anon_sym_inline] = ACTIONS(2056),
    [anon_sym___inline] = ACTIONS(2056),
    [anon_sym___inline__] = ACTIONS(2056),
    [anon_sym___forceinline] = ACTIONS(2056),
    [anon_sym_thread_local] = ACTIONS(2056),
    [anon_sym___thread] = ACTIONS(2056),
    [anon_sym_const] = ACTIONS(2056),
    [anon_sym_constexpr] = ACTIONS(2056),
    [anon_sym_volatile] = ACTIONS(2056),
    [anon_sym_restrict] = ACTIONS(2056),
    [anon_sym___restrict__] = ACTIONS(2056),
    [anon_sym__Atomic] = ACTIONS(2056),
    [anon_sym__Noreturn] = ACTIONS(2056),
    [anon_sym_noreturn] = ACTIONS(2056),
    [anon_sym_mutable] = ACTIONS(2056),
    [anon_sym_constinit] = ACTIONS(2056),
    [anon_sym_consteval] = ACTIONS(2056),
    [anon_sym___shared__] = ACTIONS(2056),
    [anon_sym___local__] = ACTIONS(2056),
    [anon_sym___constant__] = ACTIONS(2056),
    [anon_sym___managed__] = ACTIONS(2056),
    [anon_sym___grid_constant__] = ACTIONS(2056),
    [anon_sym_alignas] = ACTIONS(2056),
    [anon_sym__Alignas] = ACTIONS(2056),
    [sym_primitive_type] = ACTIONS(2056),
    [anon_sym_enum] = ACTIONS(2056),
    [anon_sym_class] = ACTIONS(2056),
    [anon_sym_struct] = ACTIONS(2056),
    [anon_sym_union] = ACTIONS(2056),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2056),
    [anon_sym_decltype] = ACTIONS(2056),
    [sym_virtual] = ACTIONS(2056),
    [anon_sym_explicit] = ACTIONS(2056),
    [anon_sym_typename] = ACTIONS(2056),
    [anon_sym_template] = ACTIONS(2056),
    [anon_sym_operator] = ACTIONS(2056),
    [anon_sym_friend] = ACTIONS(2056),
    [anon_sym_public] = ACTIONS(2056),
    [anon_sym_private] = ACTIONS(2056),
    [anon_sym_protected] = ACTIONS(2056),
    [anon_sym_using] = ACTIONS(2056),
    [anon_sym_static_assert] = ACTIONS(2056),
    [anon_sym___launch_bounds__] = ACTIONS(2056),
  },
  [2045] = {
    [sym_identifier] = ACTIONS(5315),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5317),
    [anon_sym_COMMA] = ACTIONS(5317),
    [anon_sym_RPAREN] = ACTIONS(5317),
    [anon_sym_LPAREN2] = ACTIONS(5317),
    [anon_sym_DASH] = ACTIONS(5315),
    [anon_sym_PLUS] = ACTIONS(5315),
    [anon_sym_STAR] = ACTIONS(5317),
    [anon_sym_SLASH] = ACTIONS(5315),
    [anon_sym_PERCENT] = ACTIONS(5317),
    [anon_sym_PIPE_PIPE] = ACTIONS(5317),
    [anon_sym_AMP_AMP] = ACTIONS(5317),
    [anon_sym_PIPE] = ACTIONS(5315),
    [anon_sym_CARET] = ACTIONS(5317),
    [anon_sym_AMP] = ACTIONS(5315),
    [anon_sym_EQ_EQ] = ACTIONS(5317),
    [anon_sym_BANG_EQ] = ACTIONS(5317),
    [anon_sym_GT] = ACTIONS(5315),
    [anon_sym_GT_EQ] = ACTIONS(5317),
    [anon_sym_LT_EQ] = ACTIONS(5315),
    [anon_sym_LT] = ACTIONS(5315),
    [anon_sym_LT_LT] = ACTIONS(5315),
    [anon_sym_GT_GT] = ACTIONS(5317),
    [anon_sym_SEMI] = ACTIONS(5317),
    [anon_sym___extension__] = ACTIONS(5315),
    [anon_sym___global__] = ACTIONS(5315),
    [anon_sym___attribute__] = ACTIONS(5315),
    [anon_sym___based] = ACTIONS(5315),
    [anon_sym_LBRACE] = ACTIONS(5317),
    [anon_sym_RBRACE] = ACTIONS(5317),
    [anon_sym_signed] = ACTIONS(5315),
    [anon_sym_unsigned] = ACTIONS(5315),
    [anon_sym_long] = ACTIONS(5315),
    [anon_sym_short] = ACTIONS(5315),
    [anon_sym_LBRACK] = ACTIONS(5317),
    [anon_sym_RBRACK] = ACTIONS(5317),
    [anon_sym_const] = ACTIONS(5315),
    [anon_sym_constexpr] = ACTIONS(5315),
    [anon_sym_volatile] = ACTIONS(5315),
    [anon_sym_restrict] = ACTIONS(5315),
    [anon_sym___restrict__] = ACTIONS(5315),
    [anon_sym__Atomic] = ACTIONS(5315),
    [anon_sym__Noreturn] = ACTIONS(5315),
    [anon_sym_noreturn] = ACTIONS(5315),
    [anon_sym_mutable] = ACTIONS(5315),
    [anon_sym_constinit] = ACTIONS(5315),
    [anon_sym_consteval] = ACTIONS(5315),
    [anon_sym___shared__] = ACTIONS(5315),
    [anon_sym___local__] = ACTIONS(5315),
    [anon_sym___constant__] = ACTIONS(5315),
    [anon_sym___managed__] = ACTIONS(5315),
    [anon_sym___grid_constant__] = ACTIONS(5315),
    [anon_sym_alignas] = ACTIONS(5315),
    [anon_sym__Alignas] = ACTIONS(5315),
    [sym_primitive_type] = ACTIONS(5315),
    [anon_sym_COLON] = ACTIONS(5317),
    [anon_sym_QMARK] = ACTIONS(5317),
    [anon_sym_LT_EQ_GT] = ACTIONS(5317),
    [anon_sym_or] = ACTIONS(5315),
    [anon_sym_and] = ACTIONS(5315),
    [anon_sym_bitor] = ACTIONS(5315),
    [anon_sym_xor] = ACTIONS(5315),
    [anon_sym_bitand] = ACTIONS(5315),
    [anon_sym_not_eq] = ACTIONS(5315),
    [anon_sym_DASH_DASH] = ACTIONS(5317),
    [anon_sym_PLUS_PLUS] = ACTIONS(5317),
    [anon_sym_DOT] = ACTIONS(5315),
    [anon_sym_DOT_STAR] = ACTIONS(5317),
    [anon_sym_DASH_GT] = ACTIONS(5317),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5315),
    [anon_sym_decltype] = ACTIONS(5315),
    [anon_sym_final] = ACTIONS(5315),
    [anon_sym_override] = ACTIONS(5315),
    [anon_sym_requires] = ACTIONS(5315),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5317),
  },
  [2046] = {
    [sym_identifier] = ACTIONS(5319),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5321),
    [anon_sym_COMMA] = ACTIONS(5321),
    [anon_sym_RPAREN] = ACTIONS(5321),
    [anon_sym_LPAREN2] = ACTIONS(5321),
    [anon_sym_DASH] = ACTIONS(5319),
    [anon_sym_PLUS] = ACTIONS(5319),
    [anon_sym_STAR] = ACTIONS(5321),
    [anon_sym_SLASH] = ACTIONS(5319),
    [anon_sym_PERCENT] = ACTIONS(5321),
    [anon_sym_PIPE_PIPE] = ACTIONS(5321),
    [anon_sym_AMP_AMP] = ACTIONS(5321),
    [anon_sym_PIPE] = ACTIONS(5319),
    [anon_sym_CARET] = ACTIONS(5321),
    [anon_sym_AMP] = ACTIONS(5319),
    [anon_sym_EQ_EQ] = ACTIONS(5321),
    [anon_sym_BANG_EQ] = ACTIONS(5321),
    [anon_sym_GT] = ACTIONS(5319),
    [anon_sym_GT_EQ] = ACTIONS(5321),
    [anon_sym_LT_EQ] = ACTIONS(5319),
    [anon_sym_LT] = ACTIONS(5319),
    [anon_sym_LT_LT] = ACTIONS(5319),
    [anon_sym_GT_GT] = ACTIONS(5321),
    [anon_sym_SEMI] = ACTIONS(5321),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym___global__] = ACTIONS(5319),
    [anon_sym___attribute__] = ACTIONS(5319),
    [anon_sym___based] = ACTIONS(5319),
    [anon_sym_LBRACE] = ACTIONS(5321),
    [anon_sym_RBRACE] = ACTIONS(5321),
    [anon_sym_signed] = ACTIONS(5319),
    [anon_sym_unsigned] = ACTIONS(5319),
    [anon_sym_long] = ACTIONS(5319),
    [anon_sym_short] = ACTIONS(5319),
    [anon_sym_LBRACK] = ACTIONS(5321),
    [anon_sym_RBRACK] = ACTIONS(5321),
    [anon_sym_const] = ACTIONS(5319),
    [anon_sym_constexpr] = ACTIONS(5319),
    [anon_sym_volatile] = ACTIONS(5319),
    [anon_sym_restrict] = ACTIONS(5319),
    [anon_sym___restrict__] = ACTIONS(5319),
    [anon_sym__Atomic] = ACTIONS(5319),
    [anon_sym__Noreturn] = ACTIONS(5319),
    [anon_sym_noreturn] = ACTIONS(5319),
    [anon_sym_mutable] = ACTIONS(5319),
    [anon_sym_constinit] = ACTIONS(5319),
    [anon_sym_consteval] = ACTIONS(5319),
    [anon_sym___shared__] = ACTIONS(5319),
    [anon_sym___local__] = ACTIONS(5319),
    [anon_sym___constant__] = ACTIONS(5319),
    [anon_sym___managed__] = ACTIONS(5319),
    [anon_sym___grid_constant__] = ACTIONS(5319),
    [anon_sym_alignas] = ACTIONS(5319),
    [anon_sym__Alignas] = ACTIONS(5319),
    [sym_primitive_type] = ACTIONS(5319),
    [anon_sym_COLON] = ACTIONS(5321),
    [anon_sym_QMARK] = ACTIONS(5321),
    [anon_sym_LT_EQ_GT] = ACTIONS(5321),
    [anon_sym_or] = ACTIONS(5319),
    [anon_sym_and] = ACTIONS(5319),
    [anon_sym_bitor] = ACTIONS(5319),
    [anon_sym_xor] = ACTIONS(5319),
    [anon_sym_bitand] = ACTIONS(5319),
    [anon_sym_not_eq] = ACTIONS(5319),
    [anon_sym_DASH_DASH] = ACTIONS(5321),
    [anon_sym_PLUS_PLUS] = ACTIONS(5321),
    [anon_sym_DOT] = ACTIONS(5319),
    [anon_sym_DOT_STAR] = ACTIONS(5321),
    [anon_sym_DASH_GT] = ACTIONS(5321),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5319),
    [anon_sym_decltype] = ACTIONS(5319),
    [anon_sym_final] = ACTIONS(5319),
    [anon_sym_override] = ACTIONS(5319),
    [anon_sym_requires] = ACTIONS(5319),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5321),
  },
  [2047] = {
    [sym_identifier] = ACTIONS(5079),
    [aux_sym_preproc_def_token1] = ACTIONS(5079),
    [aux_sym_preproc_if_token1] = ACTIONS(5079),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5079),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5079),
    [sym_preproc_directive] = ACTIONS(5079),
    [anon_sym_LPAREN2] = ACTIONS(5081),
    [anon_sym_TILDE] = ACTIONS(5081),
    [anon_sym_STAR] = ACTIONS(5081),
    [anon_sym_AMP_AMP] = ACTIONS(5081),
    [anon_sym_AMP] = ACTIONS(5079),
    [anon_sym___extension__] = ACTIONS(5079),
    [anon_sym_typedef] = ACTIONS(5079),
    [anon_sym___device__] = ACTIONS(5079),
    [anon_sym___host__] = ACTIONS(5079),
    [anon_sym___global__] = ACTIONS(5079),
    [anon_sym___forceinline__] = ACTIONS(5079),
    [anon_sym___noinline__] = ACTIONS(5079),
    [anon_sym_extern] = ACTIONS(5079),
    [anon_sym___attribute__] = ACTIONS(5079),
    [anon_sym_COLON_COLON] = ACTIONS(5081),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5081),
    [anon_sym___declspec] = ACTIONS(5079),
    [anon_sym___based] = ACTIONS(5079),
    [anon_sym_RBRACE] = ACTIONS(5081),
    [anon_sym_signed] = ACTIONS(5079),
    [anon_sym_unsigned] = ACTIONS(5079),
    [anon_sym_long] = ACTIONS(5079),
    [anon_sym_short] = ACTIONS(5079),
    [anon_sym_LBRACK] = ACTIONS(5079),
    [anon_sym_static] = ACTIONS(5079),
    [anon_sym_register] = ACTIONS(5079),
    [anon_sym_inline] = ACTIONS(5079),
    [anon_sym___inline] = ACTIONS(5079),
    [anon_sym___inline__] = ACTIONS(5079),
    [anon_sym___forceinline] = ACTIONS(5079),
    [anon_sym_thread_local] = ACTIONS(5079),
    [anon_sym___thread] = ACTIONS(5079),
    [anon_sym_const] = ACTIONS(5079),
    [anon_sym_constexpr] = ACTIONS(5079),
    [anon_sym_volatile] = ACTIONS(5079),
    [anon_sym_restrict] = ACTIONS(5079),
    [anon_sym___restrict__] = ACTIONS(5079),
    [anon_sym__Atomic] = ACTIONS(5079),
    [anon_sym__Noreturn] = ACTIONS(5079),
    [anon_sym_noreturn] = ACTIONS(5079),
    [anon_sym_mutable] = ACTIONS(5079),
    [anon_sym_constinit] = ACTIONS(5079),
    [anon_sym_consteval] = ACTIONS(5079),
    [anon_sym___shared__] = ACTIONS(5079),
    [anon_sym___local__] = ACTIONS(5079),
    [anon_sym___constant__] = ACTIONS(5079),
    [anon_sym___managed__] = ACTIONS(5079),
    [anon_sym___grid_constant__] = ACTIONS(5079),
    [anon_sym_alignas] = ACTIONS(5079),
    [anon_sym__Alignas] = ACTIONS(5079),
    [sym_primitive_type] = ACTIONS(5079),
    [anon_sym_enum] = ACTIONS(5079),
    [anon_sym_class] = ACTIONS(5079),
    [anon_sym_struct] = ACTIONS(5079),
    [anon_sym_union] = ACTIONS(5079),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5079),
    [anon_sym_decltype] = ACTIONS(5079),
    [sym_virtual] = ACTIONS(5079),
    [anon_sym_explicit] = ACTIONS(5079),
    [anon_sym_typename] = ACTIONS(5079),
    [anon_sym_template] = ACTIONS(5079),
    [anon_sym_operator] = ACTIONS(5079),
    [anon_sym_friend] = ACTIONS(5079),
    [anon_sym_public] = ACTIONS(5079),
    [anon_sym_private] = ACTIONS(5079),
    [anon_sym_protected] = ACTIONS(5079),
    [anon_sym_using] = ACTIONS(5079),
    [anon_sym_static_assert] = ACTIONS(5079),
    [anon_sym___launch_bounds__] = ACTIONS(5079),
  },
  [2048] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1952),
    [sym_identifier] = ACTIONS(5323),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5325),
    [anon_sym_COMMA] = ACTIONS(5325),
    [anon_sym_RPAREN] = ACTIONS(5325),
    [anon_sym_LPAREN2] = ACTIONS(5325),
    [anon_sym_DASH] = ACTIONS(5327),
    [anon_sym_PLUS] = ACTIONS(5327),
    [anon_sym_STAR] = ACTIONS(5325),
    [anon_sym_SLASH] = ACTIONS(5327),
    [anon_sym_PERCENT] = ACTIONS(5325),
    [anon_sym_PIPE_PIPE] = ACTIONS(5325),
    [anon_sym_AMP_AMP] = ACTIONS(5325),
    [anon_sym_PIPE] = ACTIONS(5327),
    [anon_sym_CARET] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5327),
    [anon_sym_EQ_EQ] = ACTIONS(5325),
    [anon_sym_BANG_EQ] = ACTIONS(5325),
    [anon_sym_GT] = ACTIONS(5327),
    [anon_sym_GT_EQ] = ACTIONS(5325),
    [anon_sym_LT_EQ] = ACTIONS(5327),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_LT_LT] = ACTIONS(5327),
    [anon_sym_GT_GT] = ACTIONS(5325),
    [anon_sym_SEMI] = ACTIONS(5325),
    [anon_sym___extension__] = ACTIONS(5327),
    [anon_sym___global__] = ACTIONS(5327),
    [anon_sym___attribute__] = ACTIONS(5327),
    [anon_sym_LBRACE] = ACTIONS(5325),
    [anon_sym_RBRACE] = ACTIONS(5325),
    [anon_sym_signed] = ACTIONS(5329),
    [anon_sym_unsigned] = ACTIONS(5329),
    [anon_sym_long] = ACTIONS(5329),
    [anon_sym_short] = ACTIONS(5329),
    [anon_sym_LBRACK] = ACTIONS(5325),
    [anon_sym_RBRACK] = ACTIONS(5325),
    [anon_sym_const] = ACTIONS(5327),
    [anon_sym_constexpr] = ACTIONS(5327),
    [anon_sym_volatile] = ACTIONS(5327),
    [anon_sym_restrict] = ACTIONS(5327),
    [anon_sym___restrict__] = ACTIONS(5327),
    [anon_sym__Atomic] = ACTIONS(5327),
    [anon_sym__Noreturn] = ACTIONS(5327),
    [anon_sym_noreturn] = ACTIONS(5327),
    [anon_sym_mutable] = ACTIONS(5327),
    [anon_sym_constinit] = ACTIONS(5327),
    [anon_sym_consteval] = ACTIONS(5327),
    [anon_sym___shared__] = ACTIONS(5327),
    [anon_sym___local__] = ACTIONS(5327),
    [anon_sym___constant__] = ACTIONS(5327),
    [anon_sym___managed__] = ACTIONS(5327),
    [anon_sym___grid_constant__] = ACTIONS(5327),
    [anon_sym_alignas] = ACTIONS(5327),
    [anon_sym__Alignas] = ACTIONS(5327),
    [sym_primitive_type] = ACTIONS(5331),
    [anon_sym_COLON] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(5325),
    [anon_sym_LT_EQ_GT] = ACTIONS(5325),
    [anon_sym_or] = ACTIONS(5327),
    [anon_sym_and] = ACTIONS(5327),
    [anon_sym_bitor] = ACTIONS(5327),
    [anon_sym_xor] = ACTIONS(5327),
    [anon_sym_bitand] = ACTIONS(5327),
    [anon_sym_not_eq] = ACTIONS(5327),
    [anon_sym_DASH_DASH] = ACTIONS(5325),
    [anon_sym_PLUS_PLUS] = ACTIONS(5325),
    [anon_sym_DOT] = ACTIONS(5327),
    [anon_sym_DOT_STAR] = ACTIONS(5325),
    [anon_sym_DASH_GT] = ACTIONS(5325),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5327),
    [anon_sym_decltype] = ACTIONS(5327),
    [anon_sym_final] = ACTIONS(5327),
    [anon_sym_override] = ACTIONS(5327),
    [anon_sym_requires] = ACTIONS(5327),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5325),
  },
  [2049] = {
    [sym_identifier] = ACTIONS(5047),
    [aux_sym_preproc_def_token1] = ACTIONS(5047),
    [aux_sym_preproc_if_token1] = ACTIONS(5047),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5047),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5047),
    [sym_preproc_directive] = ACTIONS(5047),
    [anon_sym_LPAREN2] = ACTIONS(5049),
    [anon_sym_TILDE] = ACTIONS(5049),
    [anon_sym_STAR] = ACTIONS(5049),
    [anon_sym_AMP_AMP] = ACTIONS(5049),
    [anon_sym_AMP] = ACTIONS(5047),
    [anon_sym___extension__] = ACTIONS(5047),
    [anon_sym_typedef] = ACTIONS(5047),
    [anon_sym___device__] = ACTIONS(5047),
    [anon_sym___host__] = ACTIONS(5047),
    [anon_sym___global__] = ACTIONS(5047),
    [anon_sym___forceinline__] = ACTIONS(5047),
    [anon_sym___noinline__] = ACTIONS(5047),
    [anon_sym_extern] = ACTIONS(5047),
    [anon_sym___attribute__] = ACTIONS(5047),
    [anon_sym_COLON_COLON] = ACTIONS(5049),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5049),
    [anon_sym___declspec] = ACTIONS(5047),
    [anon_sym___based] = ACTIONS(5047),
    [anon_sym_RBRACE] = ACTIONS(5049),
    [anon_sym_signed] = ACTIONS(5047),
    [anon_sym_unsigned] = ACTIONS(5047),
    [anon_sym_long] = ACTIONS(5047),
    [anon_sym_short] = ACTIONS(5047),
    [anon_sym_LBRACK] = ACTIONS(5047),
    [anon_sym_static] = ACTIONS(5047),
    [anon_sym_register] = ACTIONS(5047),
    [anon_sym_inline] = ACTIONS(5047),
    [anon_sym___inline] = ACTIONS(5047),
    [anon_sym___inline__] = ACTIONS(5047),
    [anon_sym___forceinline] = ACTIONS(5047),
    [anon_sym_thread_local] = ACTIONS(5047),
    [anon_sym___thread] = ACTIONS(5047),
    [anon_sym_const] = ACTIONS(5047),
    [anon_sym_constexpr] = ACTIONS(5047),
    [anon_sym_volatile] = ACTIONS(5047),
    [anon_sym_restrict] = ACTIONS(5047),
    [anon_sym___restrict__] = ACTIONS(5047),
    [anon_sym__Atomic] = ACTIONS(5047),
    [anon_sym__Noreturn] = ACTIONS(5047),
    [anon_sym_noreturn] = ACTIONS(5047),
    [anon_sym_mutable] = ACTIONS(5047),
    [anon_sym_constinit] = ACTIONS(5047),
    [anon_sym_consteval] = ACTIONS(5047),
    [anon_sym___shared__] = ACTIONS(5047),
    [anon_sym___local__] = ACTIONS(5047),
    [anon_sym___constant__] = ACTIONS(5047),
    [anon_sym___managed__] = ACTIONS(5047),
    [anon_sym___grid_constant__] = ACTIONS(5047),
    [anon_sym_alignas] = ACTIONS(5047),
    [anon_sym__Alignas] = ACTIONS(5047),
    [sym_primitive_type] = ACTIONS(5047),
    [anon_sym_enum] = ACTIONS(5047),
    [anon_sym_class] = ACTIONS(5047),
    [anon_sym_struct] = ACTIONS(5047),
    [anon_sym_union] = ACTIONS(5047),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5047),
    [anon_sym_decltype] = ACTIONS(5047),
    [sym_virtual] = ACTIONS(5047),
    [anon_sym_explicit] = ACTIONS(5047),
    [anon_sym_typename] = ACTIONS(5047),
    [anon_sym_template] = ACTIONS(5047),
    [anon_sym_operator] = ACTIONS(5047),
    [anon_sym_friend] = ACTIONS(5047),
    [anon_sym_public] = ACTIONS(5047),
    [anon_sym_private] = ACTIONS(5047),
    [anon_sym_protected] = ACTIONS(5047),
    [anon_sym_using] = ACTIONS(5047),
    [anon_sym_static_assert] = ACTIONS(5047),
    [anon_sym___launch_bounds__] = ACTIONS(5047),
  },
  [2050] = {
    [sym_template_argument_list] = STATE(2115),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4002),
    [anon_sym_RPAREN] = ACTIONS(4004),
    [anon_sym_LPAREN2] = ACTIONS(4004),
    [anon_sym_DASH] = ACTIONS(4009),
    [anon_sym_PLUS] = ACTIONS(4009),
    [anon_sym_STAR] = ACTIONS(4011),
    [anon_sym_SLASH] = ACTIONS(4009),
    [anon_sym_PERCENT] = ACTIONS(4009),
    [anon_sym_PIPE_PIPE] = ACTIONS(4002),
    [anon_sym_AMP_AMP] = ACTIONS(4004),
    [anon_sym_PIPE] = ACTIONS(4009),
    [anon_sym_CARET] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4011),
    [anon_sym_EQ_EQ] = ACTIONS(4002),
    [anon_sym_BANG_EQ] = ACTIONS(4002),
    [anon_sym_GT] = ACTIONS(4009),
    [anon_sym_GT_EQ] = ACTIONS(4002),
    [anon_sym_LT_EQ] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(5333),
    [anon_sym_LT_LT] = ACTIONS(4009),
    [anon_sym_GT_GT] = ACTIONS(4009),
    [anon_sym___extension__] = ACTIONS(4007),
    [anon_sym___global__] = ACTIONS(4007),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4004),
    [anon_sym_EQ] = ACTIONS(4009),
    [anon_sym_const] = ACTIONS(4000),
    [anon_sym_constexpr] = ACTIONS(4007),
    [anon_sym_volatile] = ACTIONS(4007),
    [anon_sym_restrict] = ACTIONS(4007),
    [anon_sym___restrict__] = ACTIONS(4007),
    [anon_sym__Atomic] = ACTIONS(4007),
    [anon_sym__Noreturn] = ACTIONS(4007),
    [anon_sym_noreturn] = ACTIONS(4007),
    [anon_sym_mutable] = ACTIONS(4007),
    [anon_sym_constinit] = ACTIONS(4007),
    [anon_sym_consteval] = ACTIONS(4007),
    [anon_sym___shared__] = ACTIONS(4007),
    [anon_sym___local__] = ACTIONS(4007),
    [anon_sym___constant__] = ACTIONS(4007),
    [anon_sym___managed__] = ACTIONS(4007),
    [anon_sym___grid_constant__] = ACTIONS(4007),
    [anon_sym_alignas] = ACTIONS(4007),
    [anon_sym__Alignas] = ACTIONS(4007),
    [anon_sym_QMARK] = ACTIONS(4002),
    [anon_sym_STAR_EQ] = ACTIONS(4002),
    [anon_sym_SLASH_EQ] = ACTIONS(4002),
    [anon_sym_PERCENT_EQ] = ACTIONS(4002),
    [anon_sym_PLUS_EQ] = ACTIONS(4002),
    [anon_sym_DASH_EQ] = ACTIONS(4002),
    [anon_sym_LT_LT_EQ] = ACTIONS(4002),
    [anon_sym_GT_GT_EQ] = ACTIONS(4002),
    [anon_sym_AMP_EQ] = ACTIONS(4002),
    [anon_sym_CARET_EQ] = ACTIONS(4002),
    [anon_sym_PIPE_EQ] = ACTIONS(4002),
    [anon_sym_and_eq] = ACTIONS(4002),
    [anon_sym_or_eq] = ACTIONS(4002),
    [anon_sym_xor_eq] = ACTIONS(4002),
    [anon_sym_LT_EQ_GT] = ACTIONS(4002),
    [anon_sym_or] = ACTIONS(4009),
    [anon_sym_and] = ACTIONS(4009),
    [anon_sym_bitor] = ACTIONS(4002),
    [anon_sym_xor] = ACTIONS(4009),
    [anon_sym_bitand] = ACTIONS(4002),
    [anon_sym_not_eq] = ACTIONS(4002),
    [anon_sym_DASH_DASH] = ACTIONS(4002),
    [anon_sym_PLUS_PLUS] = ACTIONS(4002),
    [anon_sym_DOT] = ACTIONS(4009),
    [anon_sym_DOT_STAR] = ACTIONS(4002),
    [anon_sym_DASH_GT] = ACTIONS(4002),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4007),
    [anon_sym_decltype] = ACTIONS(4007),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4002),
  },
  [2051] = {
    [sym_identifier] = ACTIONS(5051),
    [aux_sym_preproc_def_token1] = ACTIONS(5051),
    [aux_sym_preproc_if_token1] = ACTIONS(5051),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5051),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5051),
    [sym_preproc_directive] = ACTIONS(5051),
    [anon_sym_LPAREN2] = ACTIONS(5053),
    [anon_sym_TILDE] = ACTIONS(5053),
    [anon_sym_STAR] = ACTIONS(5053),
    [anon_sym_AMP_AMP] = ACTIONS(5053),
    [anon_sym_AMP] = ACTIONS(5051),
    [anon_sym___extension__] = ACTIONS(5051),
    [anon_sym_typedef] = ACTIONS(5051),
    [anon_sym___device__] = ACTIONS(5051),
    [anon_sym___host__] = ACTIONS(5051),
    [anon_sym___global__] = ACTIONS(5051),
    [anon_sym___forceinline__] = ACTIONS(5051),
    [anon_sym___noinline__] = ACTIONS(5051),
    [anon_sym_extern] = ACTIONS(5051),
    [anon_sym___attribute__] = ACTIONS(5051),
    [anon_sym_COLON_COLON] = ACTIONS(5053),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5053),
    [anon_sym___declspec] = ACTIONS(5051),
    [anon_sym___based] = ACTIONS(5051),
    [anon_sym_RBRACE] = ACTIONS(5053),
    [anon_sym_signed] = ACTIONS(5051),
    [anon_sym_unsigned] = ACTIONS(5051),
    [anon_sym_long] = ACTIONS(5051),
    [anon_sym_short] = ACTIONS(5051),
    [anon_sym_LBRACK] = ACTIONS(5051),
    [anon_sym_static] = ACTIONS(5051),
    [anon_sym_register] = ACTIONS(5051),
    [anon_sym_inline] = ACTIONS(5051),
    [anon_sym___inline] = ACTIONS(5051),
    [anon_sym___inline__] = ACTIONS(5051),
    [anon_sym___forceinline] = ACTIONS(5051),
    [anon_sym_thread_local] = ACTIONS(5051),
    [anon_sym___thread] = ACTIONS(5051),
    [anon_sym_const] = ACTIONS(5051),
    [anon_sym_constexpr] = ACTIONS(5051),
    [anon_sym_volatile] = ACTIONS(5051),
    [anon_sym_restrict] = ACTIONS(5051),
    [anon_sym___restrict__] = ACTIONS(5051),
    [anon_sym__Atomic] = ACTIONS(5051),
    [anon_sym__Noreturn] = ACTIONS(5051),
    [anon_sym_noreturn] = ACTIONS(5051),
    [anon_sym_mutable] = ACTIONS(5051),
    [anon_sym_constinit] = ACTIONS(5051),
    [anon_sym_consteval] = ACTIONS(5051),
    [anon_sym___shared__] = ACTIONS(5051),
    [anon_sym___local__] = ACTIONS(5051),
    [anon_sym___constant__] = ACTIONS(5051),
    [anon_sym___managed__] = ACTIONS(5051),
    [anon_sym___grid_constant__] = ACTIONS(5051),
    [anon_sym_alignas] = ACTIONS(5051),
    [anon_sym__Alignas] = ACTIONS(5051),
    [sym_primitive_type] = ACTIONS(5051),
    [anon_sym_enum] = ACTIONS(5051),
    [anon_sym_class] = ACTIONS(5051),
    [anon_sym_struct] = ACTIONS(5051),
    [anon_sym_union] = ACTIONS(5051),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5051),
    [anon_sym_decltype] = ACTIONS(5051),
    [sym_virtual] = ACTIONS(5051),
    [anon_sym_explicit] = ACTIONS(5051),
    [anon_sym_typename] = ACTIONS(5051),
    [anon_sym_template] = ACTIONS(5051),
    [anon_sym_operator] = ACTIONS(5051),
    [anon_sym_friend] = ACTIONS(5051),
    [anon_sym_public] = ACTIONS(5051),
    [anon_sym_private] = ACTIONS(5051),
    [anon_sym_protected] = ACTIONS(5051),
    [anon_sym_using] = ACTIONS(5051),
    [anon_sym_static_assert] = ACTIONS(5051),
    [anon_sym___launch_bounds__] = ACTIONS(5051),
  },
  [2052] = {
    [sym_identifier] = ACTIONS(5055),
    [aux_sym_preproc_def_token1] = ACTIONS(5055),
    [aux_sym_preproc_if_token1] = ACTIONS(5055),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5055),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5055),
    [sym_preproc_directive] = ACTIONS(5055),
    [anon_sym_LPAREN2] = ACTIONS(5057),
    [anon_sym_TILDE] = ACTIONS(5057),
    [anon_sym_STAR] = ACTIONS(5057),
    [anon_sym_AMP_AMP] = ACTIONS(5057),
    [anon_sym_AMP] = ACTIONS(5055),
    [anon_sym___extension__] = ACTIONS(5055),
    [anon_sym_typedef] = ACTIONS(5055),
    [anon_sym___device__] = ACTIONS(5055),
    [anon_sym___host__] = ACTIONS(5055),
    [anon_sym___global__] = ACTIONS(5055),
    [anon_sym___forceinline__] = ACTIONS(5055),
    [anon_sym___noinline__] = ACTIONS(5055),
    [anon_sym_extern] = ACTIONS(5055),
    [anon_sym___attribute__] = ACTIONS(5055),
    [anon_sym_COLON_COLON] = ACTIONS(5057),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5057),
    [anon_sym___declspec] = ACTIONS(5055),
    [anon_sym___based] = ACTIONS(5055),
    [anon_sym_RBRACE] = ACTIONS(5057),
    [anon_sym_signed] = ACTIONS(5055),
    [anon_sym_unsigned] = ACTIONS(5055),
    [anon_sym_long] = ACTIONS(5055),
    [anon_sym_short] = ACTIONS(5055),
    [anon_sym_LBRACK] = ACTIONS(5055),
    [anon_sym_static] = ACTIONS(5055),
    [anon_sym_register] = ACTIONS(5055),
    [anon_sym_inline] = ACTIONS(5055),
    [anon_sym___inline] = ACTIONS(5055),
    [anon_sym___inline__] = ACTIONS(5055),
    [anon_sym___forceinline] = ACTIONS(5055),
    [anon_sym_thread_local] = ACTIONS(5055),
    [anon_sym___thread] = ACTIONS(5055),
    [anon_sym_const] = ACTIONS(5055),
    [anon_sym_constexpr] = ACTIONS(5055),
    [anon_sym_volatile] = ACTIONS(5055),
    [anon_sym_restrict] = ACTIONS(5055),
    [anon_sym___restrict__] = ACTIONS(5055),
    [anon_sym__Atomic] = ACTIONS(5055),
    [anon_sym__Noreturn] = ACTIONS(5055),
    [anon_sym_noreturn] = ACTIONS(5055),
    [anon_sym_mutable] = ACTIONS(5055),
    [anon_sym_constinit] = ACTIONS(5055),
    [anon_sym_consteval] = ACTIONS(5055),
    [anon_sym___shared__] = ACTIONS(5055),
    [anon_sym___local__] = ACTIONS(5055),
    [anon_sym___constant__] = ACTIONS(5055),
    [anon_sym___managed__] = ACTIONS(5055),
    [anon_sym___grid_constant__] = ACTIONS(5055),
    [anon_sym_alignas] = ACTIONS(5055),
    [anon_sym__Alignas] = ACTIONS(5055),
    [sym_primitive_type] = ACTIONS(5055),
    [anon_sym_enum] = ACTIONS(5055),
    [anon_sym_class] = ACTIONS(5055),
    [anon_sym_struct] = ACTIONS(5055),
    [anon_sym_union] = ACTIONS(5055),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5055),
    [anon_sym_decltype] = ACTIONS(5055),
    [sym_virtual] = ACTIONS(5055),
    [anon_sym_explicit] = ACTIONS(5055),
    [anon_sym_typename] = ACTIONS(5055),
    [anon_sym_template] = ACTIONS(5055),
    [anon_sym_operator] = ACTIONS(5055),
    [anon_sym_friend] = ACTIONS(5055),
    [anon_sym_public] = ACTIONS(5055),
    [anon_sym_private] = ACTIONS(5055),
    [anon_sym_protected] = ACTIONS(5055),
    [anon_sym_using] = ACTIONS(5055),
    [anon_sym_static_assert] = ACTIONS(5055),
    [anon_sym___launch_bounds__] = ACTIONS(5055),
  },
  [2053] = {
    [sym_identifier] = ACTIONS(4142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4149),
    [anon_sym_COMMA] = ACTIONS(4149),
    [anon_sym_RPAREN] = ACTIONS(4149),
    [aux_sym_preproc_if_token2] = ACTIONS(4149),
    [aux_sym_preproc_else_token1] = ACTIONS(4149),
    [aux_sym_preproc_elif_token1] = ACTIONS(4142),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4149),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4149),
    [anon_sym_LPAREN2] = ACTIONS(4149),
    [anon_sym_DASH] = ACTIONS(4142),
    [anon_sym_PLUS] = ACTIONS(4142),
    [anon_sym_STAR] = ACTIONS(4149),
    [anon_sym_SLASH] = ACTIONS(4142),
    [anon_sym_PERCENT] = ACTIONS(4149),
    [anon_sym_PIPE_PIPE] = ACTIONS(4149),
    [anon_sym_AMP_AMP] = ACTIONS(4149),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_CARET] = ACTIONS(4149),
    [anon_sym_AMP] = ACTIONS(4142),
    [anon_sym_EQ_EQ] = ACTIONS(4149),
    [anon_sym_BANG_EQ] = ACTIONS(4149),
    [anon_sym_GT] = ACTIONS(4142),
    [anon_sym_GT_EQ] = ACTIONS(4149),
    [anon_sym_LT_EQ] = ACTIONS(4142),
    [anon_sym_LT] = ACTIONS(4142),
    [anon_sym_LT_LT] = ACTIONS(4142),
    [anon_sym_GT_GT] = ACTIONS(4149),
    [anon_sym_SEMI] = ACTIONS(4149),
    [anon_sym___extension__] = ACTIONS(4142),
    [anon_sym___global__] = ACTIONS(4142),
    [anon_sym___attribute__] = ACTIONS(4142),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_LBRACE] = ACTIONS(4149),
    [anon_sym_RBRACE] = ACTIONS(4149),
    [anon_sym_LBRACK] = ACTIONS(4149),
    [anon_sym_RBRACK] = ACTIONS(4149),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_constexpr] = ACTIONS(4142),
    [anon_sym_volatile] = ACTIONS(4142),
    [anon_sym_restrict] = ACTIONS(4142),
    [anon_sym___restrict__] = ACTIONS(4142),
    [anon_sym__Atomic] = ACTIONS(4142),
    [anon_sym__Noreturn] = ACTIONS(4142),
    [anon_sym_noreturn] = ACTIONS(4142),
    [anon_sym_mutable] = ACTIONS(4142),
    [anon_sym_constinit] = ACTIONS(4142),
    [anon_sym_consteval] = ACTIONS(4142),
    [anon_sym___shared__] = ACTIONS(4142),
    [anon_sym___local__] = ACTIONS(4142),
    [anon_sym___constant__] = ACTIONS(4142),
    [anon_sym___managed__] = ACTIONS(4142),
    [anon_sym___grid_constant__] = ACTIONS(4142),
    [anon_sym_alignas] = ACTIONS(4142),
    [anon_sym__Alignas] = ACTIONS(4142),
    [anon_sym_COLON] = ACTIONS(4142),
    [anon_sym_QMARK] = ACTIONS(4149),
    [anon_sym_LT_EQ_GT] = ACTIONS(4149),
    [anon_sym_or] = ACTIONS(4142),
    [anon_sym_and] = ACTIONS(4142),
    [anon_sym_bitor] = ACTIONS(4142),
    [anon_sym_xor] = ACTIONS(4142),
    [anon_sym_bitand] = ACTIONS(4142),
    [anon_sym_not_eq] = ACTIONS(4142),
    [anon_sym_DASH_DASH] = ACTIONS(4149),
    [anon_sym_PLUS_PLUS] = ACTIONS(4149),
    [anon_sym_DOT] = ACTIONS(4142),
    [anon_sym_DOT_STAR] = ACTIONS(4149),
    [anon_sym_DASH_GT] = ACTIONS(4149),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4142),
    [anon_sym_decltype] = ACTIONS(4142),
    [anon_sym_final] = ACTIONS(4142),
    [anon_sym_override] = ACTIONS(4142),
    [anon_sym_requires] = ACTIONS(4142),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4149),
  },
  [2054] = {
    [sym_identifier] = ACTIONS(5083),
    [aux_sym_preproc_def_token1] = ACTIONS(5083),
    [aux_sym_preproc_if_token1] = ACTIONS(5083),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5083),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5083),
    [sym_preproc_directive] = ACTIONS(5083),
    [anon_sym_LPAREN2] = ACTIONS(5085),
    [anon_sym_TILDE] = ACTIONS(5085),
    [anon_sym_STAR] = ACTIONS(5085),
    [anon_sym_AMP_AMP] = ACTIONS(5085),
    [anon_sym_AMP] = ACTIONS(5083),
    [anon_sym___extension__] = ACTIONS(5083),
    [anon_sym_typedef] = ACTIONS(5083),
    [anon_sym___device__] = ACTIONS(5083),
    [anon_sym___host__] = ACTIONS(5083),
    [anon_sym___global__] = ACTIONS(5083),
    [anon_sym___forceinline__] = ACTIONS(5083),
    [anon_sym___noinline__] = ACTIONS(5083),
    [anon_sym_extern] = ACTIONS(5083),
    [anon_sym___attribute__] = ACTIONS(5083),
    [anon_sym_COLON_COLON] = ACTIONS(5085),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5085),
    [anon_sym___declspec] = ACTIONS(5083),
    [anon_sym___based] = ACTIONS(5083),
    [anon_sym_RBRACE] = ACTIONS(5085),
    [anon_sym_signed] = ACTIONS(5083),
    [anon_sym_unsigned] = ACTIONS(5083),
    [anon_sym_long] = ACTIONS(5083),
    [anon_sym_short] = ACTIONS(5083),
    [anon_sym_LBRACK] = ACTIONS(5083),
    [anon_sym_static] = ACTIONS(5083),
    [anon_sym_register] = ACTIONS(5083),
    [anon_sym_inline] = ACTIONS(5083),
    [anon_sym___inline] = ACTIONS(5083),
    [anon_sym___inline__] = ACTIONS(5083),
    [anon_sym___forceinline] = ACTIONS(5083),
    [anon_sym_thread_local] = ACTIONS(5083),
    [anon_sym___thread] = ACTIONS(5083),
    [anon_sym_const] = ACTIONS(5083),
    [anon_sym_constexpr] = ACTIONS(5083),
    [anon_sym_volatile] = ACTIONS(5083),
    [anon_sym_restrict] = ACTIONS(5083),
    [anon_sym___restrict__] = ACTIONS(5083),
    [anon_sym__Atomic] = ACTIONS(5083),
    [anon_sym__Noreturn] = ACTIONS(5083),
    [anon_sym_noreturn] = ACTIONS(5083),
    [anon_sym_mutable] = ACTIONS(5083),
    [anon_sym_constinit] = ACTIONS(5083),
    [anon_sym_consteval] = ACTIONS(5083),
    [anon_sym___shared__] = ACTIONS(5083),
    [anon_sym___local__] = ACTIONS(5083),
    [anon_sym___constant__] = ACTIONS(5083),
    [anon_sym___managed__] = ACTIONS(5083),
    [anon_sym___grid_constant__] = ACTIONS(5083),
    [anon_sym_alignas] = ACTIONS(5083),
    [anon_sym__Alignas] = ACTIONS(5083),
    [sym_primitive_type] = ACTIONS(5083),
    [anon_sym_enum] = ACTIONS(5083),
    [anon_sym_class] = ACTIONS(5083),
    [anon_sym_struct] = ACTIONS(5083),
    [anon_sym_union] = ACTIONS(5083),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5083),
    [anon_sym_decltype] = ACTIONS(5083),
    [sym_virtual] = ACTIONS(5083),
    [anon_sym_explicit] = ACTIONS(5083),
    [anon_sym_typename] = ACTIONS(5083),
    [anon_sym_template] = ACTIONS(5083),
    [anon_sym_operator] = ACTIONS(5083),
    [anon_sym_friend] = ACTIONS(5083),
    [anon_sym_public] = ACTIONS(5083),
    [anon_sym_private] = ACTIONS(5083),
    [anon_sym_protected] = ACTIONS(5083),
    [anon_sym_using] = ACTIONS(5083),
    [anon_sym_static_assert] = ACTIONS(5083),
    [anon_sym___launch_bounds__] = ACTIONS(5083),
  },
  [2055] = {
    [sym_identifier] = ACTIONS(2271),
    [aux_sym_preproc_def_token1] = ACTIONS(2271),
    [aux_sym_preproc_if_token1] = ACTIONS(2271),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2271),
    [sym_preproc_directive] = ACTIONS(2271),
    [anon_sym_LPAREN2] = ACTIONS(2273),
    [anon_sym_TILDE] = ACTIONS(2273),
    [anon_sym_STAR] = ACTIONS(2273),
    [anon_sym_AMP_AMP] = ACTIONS(2273),
    [anon_sym_AMP] = ACTIONS(2271),
    [anon_sym___extension__] = ACTIONS(2271),
    [anon_sym_typedef] = ACTIONS(2271),
    [anon_sym___device__] = ACTIONS(2271),
    [anon_sym___host__] = ACTIONS(2271),
    [anon_sym___global__] = ACTIONS(2271),
    [anon_sym___forceinline__] = ACTIONS(2271),
    [anon_sym___noinline__] = ACTIONS(2271),
    [anon_sym_extern] = ACTIONS(2271),
    [anon_sym___attribute__] = ACTIONS(2271),
    [anon_sym_COLON_COLON] = ACTIONS(2273),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2273),
    [anon_sym___declspec] = ACTIONS(2271),
    [anon_sym___based] = ACTIONS(2271),
    [anon_sym_RBRACE] = ACTIONS(2273),
    [anon_sym_signed] = ACTIONS(2271),
    [anon_sym_unsigned] = ACTIONS(2271),
    [anon_sym_long] = ACTIONS(2271),
    [anon_sym_short] = ACTIONS(2271),
    [anon_sym_LBRACK] = ACTIONS(2271),
    [anon_sym_static] = ACTIONS(2271),
    [anon_sym_register] = ACTIONS(2271),
    [anon_sym_inline] = ACTIONS(2271),
    [anon_sym___inline] = ACTIONS(2271),
    [anon_sym___inline__] = ACTIONS(2271),
    [anon_sym___forceinline] = ACTIONS(2271),
    [anon_sym_thread_local] = ACTIONS(2271),
    [anon_sym___thread] = ACTIONS(2271),
    [anon_sym_const] = ACTIONS(2271),
    [anon_sym_constexpr] = ACTIONS(2271),
    [anon_sym_volatile] = ACTIONS(2271),
    [anon_sym_restrict] = ACTIONS(2271),
    [anon_sym___restrict__] = ACTIONS(2271),
    [anon_sym__Atomic] = ACTIONS(2271),
    [anon_sym__Noreturn] = ACTIONS(2271),
    [anon_sym_noreturn] = ACTIONS(2271),
    [anon_sym_mutable] = ACTIONS(2271),
    [anon_sym_constinit] = ACTIONS(2271),
    [anon_sym_consteval] = ACTIONS(2271),
    [anon_sym___shared__] = ACTIONS(2271),
    [anon_sym___local__] = ACTIONS(2271),
    [anon_sym___constant__] = ACTIONS(2271),
    [anon_sym___managed__] = ACTIONS(2271),
    [anon_sym___grid_constant__] = ACTIONS(2271),
    [anon_sym_alignas] = ACTIONS(2271),
    [anon_sym__Alignas] = ACTIONS(2271),
    [sym_primitive_type] = ACTIONS(2271),
    [anon_sym_enum] = ACTIONS(2271),
    [anon_sym_class] = ACTIONS(2271),
    [anon_sym_struct] = ACTIONS(2271),
    [anon_sym_union] = ACTIONS(2271),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2271),
    [anon_sym_decltype] = ACTIONS(2271),
    [sym_virtual] = ACTIONS(2271),
    [anon_sym_explicit] = ACTIONS(2271),
    [anon_sym_typename] = ACTIONS(2271),
    [anon_sym_template] = ACTIONS(2271),
    [anon_sym_operator] = ACTIONS(2271),
    [anon_sym_friend] = ACTIONS(2271),
    [anon_sym_public] = ACTIONS(2271),
    [anon_sym_private] = ACTIONS(2271),
    [anon_sym_protected] = ACTIONS(2271),
    [anon_sym_using] = ACTIONS(2271),
    [anon_sym_static_assert] = ACTIONS(2271),
    [anon_sym___launch_bounds__] = ACTIONS(2271),
  },
  [2056] = {
    [sym_identifier] = ACTIONS(2239),
    [aux_sym_preproc_def_token1] = ACTIONS(2239),
    [aux_sym_preproc_if_token1] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2239),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2239),
    [sym_preproc_directive] = ACTIONS(2239),
    [anon_sym_LPAREN2] = ACTIONS(2241),
    [anon_sym_TILDE] = ACTIONS(2241),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_AMP] = ACTIONS(2239),
    [anon_sym___extension__] = ACTIONS(2239),
    [anon_sym_typedef] = ACTIONS(2239),
    [anon_sym___device__] = ACTIONS(2239),
    [anon_sym___host__] = ACTIONS(2239),
    [anon_sym___global__] = ACTIONS(2239),
    [anon_sym___forceinline__] = ACTIONS(2239),
    [anon_sym___noinline__] = ACTIONS(2239),
    [anon_sym_extern] = ACTIONS(2239),
    [anon_sym___attribute__] = ACTIONS(2239),
    [anon_sym_COLON_COLON] = ACTIONS(2241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2241),
    [anon_sym___declspec] = ACTIONS(2239),
    [anon_sym___based] = ACTIONS(2239),
    [anon_sym_RBRACE] = ACTIONS(2241),
    [anon_sym_signed] = ACTIONS(2239),
    [anon_sym_unsigned] = ACTIONS(2239),
    [anon_sym_long] = ACTIONS(2239),
    [anon_sym_short] = ACTIONS(2239),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_static] = ACTIONS(2239),
    [anon_sym_register] = ACTIONS(2239),
    [anon_sym_inline] = ACTIONS(2239),
    [anon_sym___inline] = ACTIONS(2239),
    [anon_sym___inline__] = ACTIONS(2239),
    [anon_sym___forceinline] = ACTIONS(2239),
    [anon_sym_thread_local] = ACTIONS(2239),
    [anon_sym___thread] = ACTIONS(2239),
    [anon_sym_const] = ACTIONS(2239),
    [anon_sym_constexpr] = ACTIONS(2239),
    [anon_sym_volatile] = ACTIONS(2239),
    [anon_sym_restrict] = ACTIONS(2239),
    [anon_sym___restrict__] = ACTIONS(2239),
    [anon_sym__Atomic] = ACTIONS(2239),
    [anon_sym__Noreturn] = ACTIONS(2239),
    [anon_sym_noreturn] = ACTIONS(2239),
    [anon_sym_mutable] = ACTIONS(2239),
    [anon_sym_constinit] = ACTIONS(2239),
    [anon_sym_consteval] = ACTIONS(2239),
    [anon_sym___shared__] = ACTIONS(2239),
    [anon_sym___local__] = ACTIONS(2239),
    [anon_sym___constant__] = ACTIONS(2239),
    [anon_sym___managed__] = ACTIONS(2239),
    [anon_sym___grid_constant__] = ACTIONS(2239),
    [anon_sym_alignas] = ACTIONS(2239),
    [anon_sym__Alignas] = ACTIONS(2239),
    [sym_primitive_type] = ACTIONS(2239),
    [anon_sym_enum] = ACTIONS(2239),
    [anon_sym_class] = ACTIONS(2239),
    [anon_sym_struct] = ACTIONS(2239),
    [anon_sym_union] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2239),
    [anon_sym_decltype] = ACTIONS(2239),
    [sym_virtual] = ACTIONS(2239),
    [anon_sym_explicit] = ACTIONS(2239),
    [anon_sym_typename] = ACTIONS(2239),
    [anon_sym_template] = ACTIONS(2239),
    [anon_sym_operator] = ACTIONS(2239),
    [anon_sym_friend] = ACTIONS(2239),
    [anon_sym_public] = ACTIONS(2239),
    [anon_sym_private] = ACTIONS(2239),
    [anon_sym_protected] = ACTIONS(2239),
    [anon_sym_using] = ACTIONS(2239),
    [anon_sym_static_assert] = ACTIONS(2239),
    [anon_sym___launch_bounds__] = ACTIONS(2239),
  },
  [2057] = {
    [sym_identifier] = ACTIONS(5336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5338),
    [anon_sym_COMMA] = ACTIONS(5338),
    [anon_sym_RPAREN] = ACTIONS(5338),
    [anon_sym_LPAREN2] = ACTIONS(5338),
    [anon_sym_DASH] = ACTIONS(5336),
    [anon_sym_PLUS] = ACTIONS(5336),
    [anon_sym_STAR] = ACTIONS(5338),
    [anon_sym_SLASH] = ACTIONS(5336),
    [anon_sym_PERCENT] = ACTIONS(5338),
    [anon_sym_PIPE_PIPE] = ACTIONS(5338),
    [anon_sym_AMP_AMP] = ACTIONS(5338),
    [anon_sym_PIPE] = ACTIONS(5336),
    [anon_sym_CARET] = ACTIONS(5338),
    [anon_sym_AMP] = ACTIONS(5336),
    [anon_sym_EQ_EQ] = ACTIONS(5338),
    [anon_sym_BANG_EQ] = ACTIONS(5338),
    [anon_sym_GT] = ACTIONS(5336),
    [anon_sym_GT_EQ] = ACTIONS(5338),
    [anon_sym_LT_EQ] = ACTIONS(5336),
    [anon_sym_LT] = ACTIONS(5336),
    [anon_sym_LT_LT] = ACTIONS(5336),
    [anon_sym_GT_GT] = ACTIONS(5338),
    [anon_sym_SEMI] = ACTIONS(5338),
    [anon_sym___extension__] = ACTIONS(5336),
    [anon_sym___global__] = ACTIONS(5336),
    [anon_sym___attribute__] = ACTIONS(5336),
    [anon_sym___based] = ACTIONS(5336),
    [anon_sym_LBRACE] = ACTIONS(5338),
    [anon_sym_RBRACE] = ACTIONS(5338),
    [anon_sym_signed] = ACTIONS(5336),
    [anon_sym_unsigned] = ACTIONS(5336),
    [anon_sym_long] = ACTIONS(5336),
    [anon_sym_short] = ACTIONS(5336),
    [anon_sym_LBRACK] = ACTIONS(5338),
    [anon_sym_RBRACK] = ACTIONS(5338),
    [anon_sym_const] = ACTIONS(5336),
    [anon_sym_constexpr] = ACTIONS(5336),
    [anon_sym_volatile] = ACTIONS(5336),
    [anon_sym_restrict] = ACTIONS(5336),
    [anon_sym___restrict__] = ACTIONS(5336),
    [anon_sym__Atomic] = ACTIONS(5336),
    [anon_sym__Noreturn] = ACTIONS(5336),
    [anon_sym_noreturn] = ACTIONS(5336),
    [anon_sym_mutable] = ACTIONS(5336),
    [anon_sym_constinit] = ACTIONS(5336),
    [anon_sym_consteval] = ACTIONS(5336),
    [anon_sym___shared__] = ACTIONS(5336),
    [anon_sym___local__] = ACTIONS(5336),
    [anon_sym___constant__] = ACTIONS(5336),
    [anon_sym___managed__] = ACTIONS(5336),
    [anon_sym___grid_constant__] = ACTIONS(5336),
    [anon_sym_alignas] = ACTIONS(5336),
    [anon_sym__Alignas] = ACTIONS(5336),
    [sym_primitive_type] = ACTIONS(5336),
    [anon_sym_COLON] = ACTIONS(5338),
    [anon_sym_QMARK] = ACTIONS(5338),
    [anon_sym_LT_EQ_GT] = ACTIONS(5338),
    [anon_sym_or] = ACTIONS(5336),
    [anon_sym_and] = ACTIONS(5336),
    [anon_sym_bitor] = ACTIONS(5336),
    [anon_sym_xor] = ACTIONS(5336),
    [anon_sym_bitand] = ACTIONS(5336),
    [anon_sym_not_eq] = ACTIONS(5336),
    [anon_sym_DASH_DASH] = ACTIONS(5338),
    [anon_sym_PLUS_PLUS] = ACTIONS(5338),
    [anon_sym_DOT] = ACTIONS(5336),
    [anon_sym_DOT_STAR] = ACTIONS(5338),
    [anon_sym_DASH_GT] = ACTIONS(5338),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5336),
    [anon_sym_decltype] = ACTIONS(5336),
    [anon_sym_final] = ACTIONS(5336),
    [anon_sym_override] = ACTIONS(5336),
    [anon_sym_requires] = ACTIONS(5336),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5338),
  },
  [2058] = {
    [sym_identifier] = ACTIONS(5059),
    [aux_sym_preproc_def_token1] = ACTIONS(5059),
    [aux_sym_preproc_if_token1] = ACTIONS(5059),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5059),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5059),
    [sym_preproc_directive] = ACTIONS(5059),
    [anon_sym_LPAREN2] = ACTIONS(5061),
    [anon_sym_TILDE] = ACTIONS(5061),
    [anon_sym_STAR] = ACTIONS(5061),
    [anon_sym_AMP_AMP] = ACTIONS(5061),
    [anon_sym_AMP] = ACTIONS(5059),
    [anon_sym___extension__] = ACTIONS(5059),
    [anon_sym_typedef] = ACTIONS(5059),
    [anon_sym___device__] = ACTIONS(5059),
    [anon_sym___host__] = ACTIONS(5059),
    [anon_sym___global__] = ACTIONS(5059),
    [anon_sym___forceinline__] = ACTIONS(5059),
    [anon_sym___noinline__] = ACTIONS(5059),
    [anon_sym_extern] = ACTIONS(5059),
    [anon_sym___attribute__] = ACTIONS(5059),
    [anon_sym_COLON_COLON] = ACTIONS(5061),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5061),
    [anon_sym___declspec] = ACTIONS(5059),
    [anon_sym___based] = ACTIONS(5059),
    [anon_sym_RBRACE] = ACTIONS(5061),
    [anon_sym_signed] = ACTIONS(5059),
    [anon_sym_unsigned] = ACTIONS(5059),
    [anon_sym_long] = ACTIONS(5059),
    [anon_sym_short] = ACTIONS(5059),
    [anon_sym_LBRACK] = ACTIONS(5059),
    [anon_sym_static] = ACTIONS(5059),
    [anon_sym_register] = ACTIONS(5059),
    [anon_sym_inline] = ACTIONS(5059),
    [anon_sym___inline] = ACTIONS(5059),
    [anon_sym___inline__] = ACTIONS(5059),
    [anon_sym___forceinline] = ACTIONS(5059),
    [anon_sym_thread_local] = ACTIONS(5059),
    [anon_sym___thread] = ACTIONS(5059),
    [anon_sym_const] = ACTIONS(5059),
    [anon_sym_constexpr] = ACTIONS(5059),
    [anon_sym_volatile] = ACTIONS(5059),
    [anon_sym_restrict] = ACTIONS(5059),
    [anon_sym___restrict__] = ACTIONS(5059),
    [anon_sym__Atomic] = ACTIONS(5059),
    [anon_sym__Noreturn] = ACTIONS(5059),
    [anon_sym_noreturn] = ACTIONS(5059),
    [anon_sym_mutable] = ACTIONS(5059),
    [anon_sym_constinit] = ACTIONS(5059),
    [anon_sym_consteval] = ACTIONS(5059),
    [anon_sym___shared__] = ACTIONS(5059),
    [anon_sym___local__] = ACTIONS(5059),
    [anon_sym___constant__] = ACTIONS(5059),
    [anon_sym___managed__] = ACTIONS(5059),
    [anon_sym___grid_constant__] = ACTIONS(5059),
    [anon_sym_alignas] = ACTIONS(5059),
    [anon_sym__Alignas] = ACTIONS(5059),
    [sym_primitive_type] = ACTIONS(5059),
    [anon_sym_enum] = ACTIONS(5059),
    [anon_sym_class] = ACTIONS(5059),
    [anon_sym_struct] = ACTIONS(5059),
    [anon_sym_union] = ACTIONS(5059),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5059),
    [anon_sym_decltype] = ACTIONS(5059),
    [sym_virtual] = ACTIONS(5059),
    [anon_sym_explicit] = ACTIONS(5059),
    [anon_sym_typename] = ACTIONS(5059),
    [anon_sym_template] = ACTIONS(5059),
    [anon_sym_operator] = ACTIONS(5059),
    [anon_sym_friend] = ACTIONS(5059),
    [anon_sym_public] = ACTIONS(5059),
    [anon_sym_private] = ACTIONS(5059),
    [anon_sym_protected] = ACTIONS(5059),
    [anon_sym_using] = ACTIONS(5059),
    [anon_sym_static_assert] = ACTIONS(5059),
    [anon_sym___launch_bounds__] = ACTIONS(5059),
  },
  [2059] = {
    [sym_identifier] = ACTIONS(5059),
    [aux_sym_preproc_def_token1] = ACTIONS(5059),
    [aux_sym_preproc_if_token1] = ACTIONS(5059),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5059),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5059),
    [sym_preproc_directive] = ACTIONS(5059),
    [anon_sym_LPAREN2] = ACTIONS(5061),
    [anon_sym_TILDE] = ACTIONS(5061),
    [anon_sym_STAR] = ACTIONS(5061),
    [anon_sym_AMP_AMP] = ACTIONS(5061),
    [anon_sym_AMP] = ACTIONS(5059),
    [anon_sym___extension__] = ACTIONS(5059),
    [anon_sym_typedef] = ACTIONS(5059),
    [anon_sym___device__] = ACTIONS(5059),
    [anon_sym___host__] = ACTIONS(5059),
    [anon_sym___global__] = ACTIONS(5059),
    [anon_sym___forceinline__] = ACTIONS(5059),
    [anon_sym___noinline__] = ACTIONS(5059),
    [anon_sym_extern] = ACTIONS(5059),
    [anon_sym___attribute__] = ACTIONS(5059),
    [anon_sym_COLON_COLON] = ACTIONS(5061),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5061),
    [anon_sym___declspec] = ACTIONS(5059),
    [anon_sym___based] = ACTIONS(5059),
    [anon_sym_RBRACE] = ACTIONS(5061),
    [anon_sym_signed] = ACTIONS(5059),
    [anon_sym_unsigned] = ACTIONS(5059),
    [anon_sym_long] = ACTIONS(5059),
    [anon_sym_short] = ACTIONS(5059),
    [anon_sym_LBRACK] = ACTIONS(5059),
    [anon_sym_static] = ACTIONS(5059),
    [anon_sym_register] = ACTIONS(5059),
    [anon_sym_inline] = ACTIONS(5059),
    [anon_sym___inline] = ACTIONS(5059),
    [anon_sym___inline__] = ACTIONS(5059),
    [anon_sym___forceinline] = ACTIONS(5059),
    [anon_sym_thread_local] = ACTIONS(5059),
    [anon_sym___thread] = ACTIONS(5059),
    [anon_sym_const] = ACTIONS(5059),
    [anon_sym_constexpr] = ACTIONS(5059),
    [anon_sym_volatile] = ACTIONS(5059),
    [anon_sym_restrict] = ACTIONS(5059),
    [anon_sym___restrict__] = ACTIONS(5059),
    [anon_sym__Atomic] = ACTIONS(5059),
    [anon_sym__Noreturn] = ACTIONS(5059),
    [anon_sym_noreturn] = ACTIONS(5059),
    [anon_sym_mutable] = ACTIONS(5059),
    [anon_sym_constinit] = ACTIONS(5059),
    [anon_sym_consteval] = ACTIONS(5059),
    [anon_sym___shared__] = ACTIONS(5059),
    [anon_sym___local__] = ACTIONS(5059),
    [anon_sym___constant__] = ACTIONS(5059),
    [anon_sym___managed__] = ACTIONS(5059),
    [anon_sym___grid_constant__] = ACTIONS(5059),
    [anon_sym_alignas] = ACTIONS(5059),
    [anon_sym__Alignas] = ACTIONS(5059),
    [sym_primitive_type] = ACTIONS(5059),
    [anon_sym_enum] = ACTIONS(5059),
    [anon_sym_class] = ACTIONS(5059),
    [anon_sym_struct] = ACTIONS(5059),
    [anon_sym_union] = ACTIONS(5059),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5059),
    [anon_sym_decltype] = ACTIONS(5059),
    [sym_virtual] = ACTIONS(5059),
    [anon_sym_explicit] = ACTIONS(5059),
    [anon_sym_typename] = ACTIONS(5059),
    [anon_sym_template] = ACTIONS(5059),
    [anon_sym_operator] = ACTIONS(5059),
    [anon_sym_friend] = ACTIONS(5059),
    [anon_sym_public] = ACTIONS(5059),
    [anon_sym_private] = ACTIONS(5059),
    [anon_sym_protected] = ACTIONS(5059),
    [anon_sym_using] = ACTIONS(5059),
    [anon_sym_static_assert] = ACTIONS(5059),
    [anon_sym___launch_bounds__] = ACTIONS(5059),
  },
  [2060] = {
    [sym_identifier] = ACTIONS(2259),
    [aux_sym_preproc_def_token1] = ACTIONS(2259),
    [aux_sym_preproc_if_token1] = ACTIONS(2259),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2259),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2259),
    [sym_preproc_directive] = ACTIONS(2259),
    [anon_sym_LPAREN2] = ACTIONS(2261),
    [anon_sym_TILDE] = ACTIONS(2261),
    [anon_sym_STAR] = ACTIONS(2261),
    [anon_sym_AMP_AMP] = ACTIONS(2261),
    [anon_sym_AMP] = ACTIONS(2259),
    [anon_sym___extension__] = ACTIONS(2259),
    [anon_sym_typedef] = ACTIONS(2259),
    [anon_sym___device__] = ACTIONS(2259),
    [anon_sym___host__] = ACTIONS(2259),
    [anon_sym___global__] = ACTIONS(2259),
    [anon_sym___forceinline__] = ACTIONS(2259),
    [anon_sym___noinline__] = ACTIONS(2259),
    [anon_sym_extern] = ACTIONS(2259),
    [anon_sym___attribute__] = ACTIONS(2259),
    [anon_sym_COLON_COLON] = ACTIONS(2261),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2261),
    [anon_sym___declspec] = ACTIONS(2259),
    [anon_sym___based] = ACTIONS(2259),
    [anon_sym_RBRACE] = ACTIONS(2261),
    [anon_sym_signed] = ACTIONS(2259),
    [anon_sym_unsigned] = ACTIONS(2259),
    [anon_sym_long] = ACTIONS(2259),
    [anon_sym_short] = ACTIONS(2259),
    [anon_sym_LBRACK] = ACTIONS(2259),
    [anon_sym_static] = ACTIONS(2259),
    [anon_sym_register] = ACTIONS(2259),
    [anon_sym_inline] = ACTIONS(2259),
    [anon_sym___inline] = ACTIONS(2259),
    [anon_sym___inline__] = ACTIONS(2259),
    [anon_sym___forceinline] = ACTIONS(2259),
    [anon_sym_thread_local] = ACTIONS(2259),
    [anon_sym___thread] = ACTIONS(2259),
    [anon_sym_const] = ACTIONS(2259),
    [anon_sym_constexpr] = ACTIONS(2259),
    [anon_sym_volatile] = ACTIONS(2259),
    [anon_sym_restrict] = ACTIONS(2259),
    [anon_sym___restrict__] = ACTIONS(2259),
    [anon_sym__Atomic] = ACTIONS(2259),
    [anon_sym__Noreturn] = ACTIONS(2259),
    [anon_sym_noreturn] = ACTIONS(2259),
    [anon_sym_mutable] = ACTIONS(2259),
    [anon_sym_constinit] = ACTIONS(2259),
    [anon_sym_consteval] = ACTIONS(2259),
    [anon_sym___shared__] = ACTIONS(2259),
    [anon_sym___local__] = ACTIONS(2259),
    [anon_sym___constant__] = ACTIONS(2259),
    [anon_sym___managed__] = ACTIONS(2259),
    [anon_sym___grid_constant__] = ACTIONS(2259),
    [anon_sym_alignas] = ACTIONS(2259),
    [anon_sym__Alignas] = ACTIONS(2259),
    [sym_primitive_type] = ACTIONS(2259),
    [anon_sym_enum] = ACTIONS(2259),
    [anon_sym_class] = ACTIONS(2259),
    [anon_sym_struct] = ACTIONS(2259),
    [anon_sym_union] = ACTIONS(2259),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2259),
    [anon_sym_decltype] = ACTIONS(2259),
    [sym_virtual] = ACTIONS(2259),
    [anon_sym_explicit] = ACTIONS(2259),
    [anon_sym_typename] = ACTIONS(2259),
    [anon_sym_template] = ACTIONS(2259),
    [anon_sym_operator] = ACTIONS(2259),
    [anon_sym_friend] = ACTIONS(2259),
    [anon_sym_public] = ACTIONS(2259),
    [anon_sym_private] = ACTIONS(2259),
    [anon_sym_protected] = ACTIONS(2259),
    [anon_sym_using] = ACTIONS(2259),
    [anon_sym_static_assert] = ACTIONS(2259),
    [anon_sym___launch_bounds__] = ACTIONS(2259),
  },
  [2061] = {
    [sym_identifier] = ACTIONS(5023),
    [aux_sym_preproc_def_token1] = ACTIONS(5023),
    [aux_sym_preproc_if_token1] = ACTIONS(5023),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5023),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5023),
    [sym_preproc_directive] = ACTIONS(5023),
    [anon_sym_LPAREN2] = ACTIONS(5025),
    [anon_sym_TILDE] = ACTIONS(5025),
    [anon_sym_STAR] = ACTIONS(5025),
    [anon_sym_AMP_AMP] = ACTIONS(5025),
    [anon_sym_AMP] = ACTIONS(5023),
    [anon_sym___extension__] = ACTIONS(5023),
    [anon_sym_typedef] = ACTIONS(5023),
    [anon_sym___device__] = ACTIONS(5023),
    [anon_sym___host__] = ACTIONS(5023),
    [anon_sym___global__] = ACTIONS(5023),
    [anon_sym___forceinline__] = ACTIONS(5023),
    [anon_sym___noinline__] = ACTIONS(5023),
    [anon_sym_extern] = ACTIONS(5023),
    [anon_sym___attribute__] = ACTIONS(5023),
    [anon_sym_COLON_COLON] = ACTIONS(5025),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5025),
    [anon_sym___declspec] = ACTIONS(5023),
    [anon_sym___based] = ACTIONS(5023),
    [anon_sym_RBRACE] = ACTIONS(5025),
    [anon_sym_signed] = ACTIONS(5023),
    [anon_sym_unsigned] = ACTIONS(5023),
    [anon_sym_long] = ACTIONS(5023),
    [anon_sym_short] = ACTIONS(5023),
    [anon_sym_LBRACK] = ACTIONS(5023),
    [anon_sym_static] = ACTIONS(5023),
    [anon_sym_register] = ACTIONS(5023),
    [anon_sym_inline] = ACTIONS(5023),
    [anon_sym___inline] = ACTIONS(5023),
    [anon_sym___inline__] = ACTIONS(5023),
    [anon_sym___forceinline] = ACTIONS(5023),
    [anon_sym_thread_local] = ACTIONS(5023),
    [anon_sym___thread] = ACTIONS(5023),
    [anon_sym_const] = ACTIONS(5023),
    [anon_sym_constexpr] = ACTIONS(5023),
    [anon_sym_volatile] = ACTIONS(5023),
    [anon_sym_restrict] = ACTIONS(5023),
    [anon_sym___restrict__] = ACTIONS(5023),
    [anon_sym__Atomic] = ACTIONS(5023),
    [anon_sym__Noreturn] = ACTIONS(5023),
    [anon_sym_noreturn] = ACTIONS(5023),
    [anon_sym_mutable] = ACTIONS(5023),
    [anon_sym_constinit] = ACTIONS(5023),
    [anon_sym_consteval] = ACTIONS(5023),
    [anon_sym___shared__] = ACTIONS(5023),
    [anon_sym___local__] = ACTIONS(5023),
    [anon_sym___constant__] = ACTIONS(5023),
    [anon_sym___managed__] = ACTIONS(5023),
    [anon_sym___grid_constant__] = ACTIONS(5023),
    [anon_sym_alignas] = ACTIONS(5023),
    [anon_sym__Alignas] = ACTIONS(5023),
    [sym_primitive_type] = ACTIONS(5023),
    [anon_sym_enum] = ACTIONS(5023),
    [anon_sym_class] = ACTIONS(5023),
    [anon_sym_struct] = ACTIONS(5023),
    [anon_sym_union] = ACTIONS(5023),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5023),
    [anon_sym_decltype] = ACTIONS(5023),
    [sym_virtual] = ACTIONS(5023),
    [anon_sym_explicit] = ACTIONS(5023),
    [anon_sym_typename] = ACTIONS(5023),
    [anon_sym_template] = ACTIONS(5023),
    [anon_sym_operator] = ACTIONS(5023),
    [anon_sym_friend] = ACTIONS(5023),
    [anon_sym_public] = ACTIONS(5023),
    [anon_sym_private] = ACTIONS(5023),
    [anon_sym_protected] = ACTIONS(5023),
    [anon_sym_using] = ACTIONS(5023),
    [anon_sym_static_assert] = ACTIONS(5023),
    [anon_sym___launch_bounds__] = ACTIONS(5023),
  },
  [2062] = {
    [sym_identifier] = ACTIONS(5063),
    [aux_sym_preproc_def_token1] = ACTIONS(5063),
    [aux_sym_preproc_if_token1] = ACTIONS(5063),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5063),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5063),
    [sym_preproc_directive] = ACTIONS(5063),
    [anon_sym_LPAREN2] = ACTIONS(5065),
    [anon_sym_TILDE] = ACTIONS(5065),
    [anon_sym_STAR] = ACTIONS(5065),
    [anon_sym_AMP_AMP] = ACTIONS(5065),
    [anon_sym_AMP] = ACTIONS(5063),
    [anon_sym___extension__] = ACTIONS(5063),
    [anon_sym_typedef] = ACTIONS(5063),
    [anon_sym___device__] = ACTIONS(5063),
    [anon_sym___host__] = ACTIONS(5063),
    [anon_sym___global__] = ACTIONS(5063),
    [anon_sym___forceinline__] = ACTIONS(5063),
    [anon_sym___noinline__] = ACTIONS(5063),
    [anon_sym_extern] = ACTIONS(5063),
    [anon_sym___attribute__] = ACTIONS(5063),
    [anon_sym_COLON_COLON] = ACTIONS(5065),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5065),
    [anon_sym___declspec] = ACTIONS(5063),
    [anon_sym___based] = ACTIONS(5063),
    [anon_sym_RBRACE] = ACTIONS(5065),
    [anon_sym_signed] = ACTIONS(5063),
    [anon_sym_unsigned] = ACTIONS(5063),
    [anon_sym_long] = ACTIONS(5063),
    [anon_sym_short] = ACTIONS(5063),
    [anon_sym_LBRACK] = ACTIONS(5063),
    [anon_sym_static] = ACTIONS(5063),
    [anon_sym_register] = ACTIONS(5063),
    [anon_sym_inline] = ACTIONS(5063),
    [anon_sym___inline] = ACTIONS(5063),
    [anon_sym___inline__] = ACTIONS(5063),
    [anon_sym___forceinline] = ACTIONS(5063),
    [anon_sym_thread_local] = ACTIONS(5063),
    [anon_sym___thread] = ACTIONS(5063),
    [anon_sym_const] = ACTIONS(5063),
    [anon_sym_constexpr] = ACTIONS(5063),
    [anon_sym_volatile] = ACTIONS(5063),
    [anon_sym_restrict] = ACTIONS(5063),
    [anon_sym___restrict__] = ACTIONS(5063),
    [anon_sym__Atomic] = ACTIONS(5063),
    [anon_sym__Noreturn] = ACTIONS(5063),
    [anon_sym_noreturn] = ACTIONS(5063),
    [anon_sym_mutable] = ACTIONS(5063),
    [anon_sym_constinit] = ACTIONS(5063),
    [anon_sym_consteval] = ACTIONS(5063),
    [anon_sym___shared__] = ACTIONS(5063),
    [anon_sym___local__] = ACTIONS(5063),
    [anon_sym___constant__] = ACTIONS(5063),
    [anon_sym___managed__] = ACTIONS(5063),
    [anon_sym___grid_constant__] = ACTIONS(5063),
    [anon_sym_alignas] = ACTIONS(5063),
    [anon_sym__Alignas] = ACTIONS(5063),
    [sym_primitive_type] = ACTIONS(5063),
    [anon_sym_enum] = ACTIONS(5063),
    [anon_sym_class] = ACTIONS(5063),
    [anon_sym_struct] = ACTIONS(5063),
    [anon_sym_union] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5063),
    [anon_sym_decltype] = ACTIONS(5063),
    [sym_virtual] = ACTIONS(5063),
    [anon_sym_explicit] = ACTIONS(5063),
    [anon_sym_typename] = ACTIONS(5063),
    [anon_sym_template] = ACTIONS(5063),
    [anon_sym_operator] = ACTIONS(5063),
    [anon_sym_friend] = ACTIONS(5063),
    [anon_sym_public] = ACTIONS(5063),
    [anon_sym_private] = ACTIONS(5063),
    [anon_sym_protected] = ACTIONS(5063),
    [anon_sym_using] = ACTIONS(5063),
    [anon_sym_static_assert] = ACTIONS(5063),
    [anon_sym___launch_bounds__] = ACTIONS(5063),
  },
  [2063] = {
    [sym_identifier] = ACTIONS(1950),
    [aux_sym_preproc_def_token1] = ACTIONS(1950),
    [aux_sym_preproc_if_token1] = ACTIONS(1950),
    [aux_sym_preproc_if_token2] = ACTIONS(1950),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1950),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1950),
    [sym_preproc_directive] = ACTIONS(1950),
    [anon_sym_LPAREN2] = ACTIONS(1952),
    [anon_sym_TILDE] = ACTIONS(1952),
    [anon_sym_STAR] = ACTIONS(1952),
    [anon_sym_AMP_AMP] = ACTIONS(1952),
    [anon_sym_AMP] = ACTIONS(1950),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_typedef] = ACTIONS(1950),
    [anon_sym___device__] = ACTIONS(1950),
    [anon_sym___host__] = ACTIONS(1950),
    [anon_sym___global__] = ACTIONS(1950),
    [anon_sym___forceinline__] = ACTIONS(1950),
    [anon_sym___noinline__] = ACTIONS(1950),
    [anon_sym_extern] = ACTIONS(1950),
    [anon_sym___attribute__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1952),
    [anon_sym___declspec] = ACTIONS(1950),
    [anon_sym___based] = ACTIONS(1950),
    [anon_sym_signed] = ACTIONS(1950),
    [anon_sym_unsigned] = ACTIONS(1950),
    [anon_sym_long] = ACTIONS(1950),
    [anon_sym_short] = ACTIONS(1950),
    [anon_sym_LBRACK] = ACTIONS(1950),
    [anon_sym_static] = ACTIONS(1950),
    [anon_sym_register] = ACTIONS(1950),
    [anon_sym_inline] = ACTIONS(1950),
    [anon_sym___inline] = ACTIONS(1950),
    [anon_sym___inline__] = ACTIONS(1950),
    [anon_sym___forceinline] = ACTIONS(1950),
    [anon_sym_thread_local] = ACTIONS(1950),
    [anon_sym___thread] = ACTIONS(1950),
    [anon_sym_const] = ACTIONS(1950),
    [anon_sym_constexpr] = ACTIONS(1950),
    [anon_sym_volatile] = ACTIONS(1950),
    [anon_sym_restrict] = ACTIONS(1950),
    [anon_sym___restrict__] = ACTIONS(1950),
    [anon_sym__Atomic] = ACTIONS(1950),
    [anon_sym__Noreturn] = ACTIONS(1950),
    [anon_sym_noreturn] = ACTIONS(1950),
    [anon_sym_mutable] = ACTIONS(1950),
    [anon_sym_constinit] = ACTIONS(1950),
    [anon_sym_consteval] = ACTIONS(1950),
    [anon_sym___shared__] = ACTIONS(1950),
    [anon_sym___local__] = ACTIONS(1950),
    [anon_sym___constant__] = ACTIONS(1950),
    [anon_sym___managed__] = ACTIONS(1950),
    [anon_sym___grid_constant__] = ACTIONS(1950),
    [anon_sym_alignas] = ACTIONS(1950),
    [anon_sym__Alignas] = ACTIONS(1950),
    [sym_primitive_type] = ACTIONS(1950),
    [anon_sym_enum] = ACTIONS(1950),
    [anon_sym_class] = ACTIONS(1950),
    [anon_sym_struct] = ACTIONS(1950),
    [anon_sym_union] = ACTIONS(1950),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1950),
    [anon_sym_decltype] = ACTIONS(1950),
    [sym_virtual] = ACTIONS(1950),
    [anon_sym_explicit] = ACTIONS(1950),
    [anon_sym_typename] = ACTIONS(1950),
    [anon_sym_template] = ACTIONS(1950),
    [anon_sym_operator] = ACTIONS(1950),
    [anon_sym_friend] = ACTIONS(1950),
    [anon_sym_public] = ACTIONS(1950),
    [anon_sym_private] = ACTIONS(1950),
    [anon_sym_protected] = ACTIONS(1950),
    [anon_sym_using] = ACTIONS(1950),
    [anon_sym_static_assert] = ACTIONS(1950),
    [anon_sym___launch_bounds__] = ACTIONS(1950),
  },
  [2064] = {
    [sym_identifier] = ACTIONS(5340),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5342),
    [anon_sym_COMMA] = ACTIONS(5342),
    [anon_sym_RPAREN] = ACTIONS(5342),
    [anon_sym_LPAREN2] = ACTIONS(5342),
    [anon_sym_DASH] = ACTIONS(5340),
    [anon_sym_PLUS] = ACTIONS(5340),
    [anon_sym_STAR] = ACTIONS(5342),
    [anon_sym_SLASH] = ACTIONS(5340),
    [anon_sym_PERCENT] = ACTIONS(5342),
    [anon_sym_PIPE_PIPE] = ACTIONS(5342),
    [anon_sym_AMP_AMP] = ACTIONS(5342),
    [anon_sym_PIPE] = ACTIONS(5340),
    [anon_sym_CARET] = ACTIONS(5342),
    [anon_sym_AMP] = ACTIONS(5340),
    [anon_sym_EQ_EQ] = ACTIONS(5342),
    [anon_sym_BANG_EQ] = ACTIONS(5342),
    [anon_sym_GT] = ACTIONS(5340),
    [anon_sym_GT_EQ] = ACTIONS(5342),
    [anon_sym_LT_EQ] = ACTIONS(5340),
    [anon_sym_LT] = ACTIONS(5340),
    [anon_sym_LT_LT] = ACTIONS(5340),
    [anon_sym_GT_GT] = ACTIONS(5342),
    [anon_sym_SEMI] = ACTIONS(5342),
    [anon_sym___extension__] = ACTIONS(5340),
    [anon_sym___global__] = ACTIONS(5340),
    [anon_sym___attribute__] = ACTIONS(5340),
    [anon_sym___based] = ACTIONS(5340),
    [anon_sym_LBRACE] = ACTIONS(5342),
    [anon_sym_RBRACE] = ACTIONS(5342),
    [anon_sym_signed] = ACTIONS(5340),
    [anon_sym_unsigned] = ACTIONS(5340),
    [anon_sym_long] = ACTIONS(5340),
    [anon_sym_short] = ACTIONS(5340),
    [anon_sym_LBRACK] = ACTIONS(5342),
    [anon_sym_RBRACK] = ACTIONS(5342),
    [anon_sym_const] = ACTIONS(5340),
    [anon_sym_constexpr] = ACTIONS(5340),
    [anon_sym_volatile] = ACTIONS(5340),
    [anon_sym_restrict] = ACTIONS(5340),
    [anon_sym___restrict__] = ACTIONS(5340),
    [anon_sym__Atomic] = ACTIONS(5340),
    [anon_sym__Noreturn] = ACTIONS(5340),
    [anon_sym_noreturn] = ACTIONS(5340),
    [anon_sym_mutable] = ACTIONS(5340),
    [anon_sym_constinit] = ACTIONS(5340),
    [anon_sym_consteval] = ACTIONS(5340),
    [anon_sym___shared__] = ACTIONS(5340),
    [anon_sym___local__] = ACTIONS(5340),
    [anon_sym___constant__] = ACTIONS(5340),
    [anon_sym___managed__] = ACTIONS(5340),
    [anon_sym___grid_constant__] = ACTIONS(5340),
    [anon_sym_alignas] = ACTIONS(5340),
    [anon_sym__Alignas] = ACTIONS(5340),
    [sym_primitive_type] = ACTIONS(5340),
    [anon_sym_COLON] = ACTIONS(5342),
    [anon_sym_QMARK] = ACTIONS(5342),
    [anon_sym_LT_EQ_GT] = ACTIONS(5342),
    [anon_sym_or] = ACTIONS(5340),
    [anon_sym_and] = ACTIONS(5340),
    [anon_sym_bitor] = ACTIONS(5340),
    [anon_sym_xor] = ACTIONS(5340),
    [anon_sym_bitand] = ACTIONS(5340),
    [anon_sym_not_eq] = ACTIONS(5340),
    [anon_sym_DASH_DASH] = ACTIONS(5342),
    [anon_sym_PLUS_PLUS] = ACTIONS(5342),
    [anon_sym_DOT] = ACTIONS(5340),
    [anon_sym_DOT_STAR] = ACTIONS(5342),
    [anon_sym_DASH_GT] = ACTIONS(5342),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5340),
    [anon_sym_decltype] = ACTIONS(5340),
    [anon_sym_final] = ACTIONS(5340),
    [anon_sym_override] = ACTIONS(5340),
    [anon_sym_requires] = ACTIONS(5340),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5342),
  },
  [2065] = {
    [sym_identifier] = ACTIONS(5087),
    [aux_sym_preproc_def_token1] = ACTIONS(5087),
    [aux_sym_preproc_if_token1] = ACTIONS(5087),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5087),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5087),
    [sym_preproc_directive] = ACTIONS(5087),
    [anon_sym_LPAREN2] = ACTIONS(5089),
    [anon_sym_TILDE] = ACTIONS(5089),
    [anon_sym_STAR] = ACTIONS(5089),
    [anon_sym_AMP_AMP] = ACTIONS(5089),
    [anon_sym_AMP] = ACTIONS(5087),
    [anon_sym___extension__] = ACTIONS(5087),
    [anon_sym_typedef] = ACTIONS(5087),
    [anon_sym___device__] = ACTIONS(5087),
    [anon_sym___host__] = ACTIONS(5087),
    [anon_sym___global__] = ACTIONS(5087),
    [anon_sym___forceinline__] = ACTIONS(5087),
    [anon_sym___noinline__] = ACTIONS(5087),
    [anon_sym_extern] = ACTIONS(5087),
    [anon_sym___attribute__] = ACTIONS(5087),
    [anon_sym_COLON_COLON] = ACTIONS(5089),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5089),
    [anon_sym___declspec] = ACTIONS(5087),
    [anon_sym___based] = ACTIONS(5087),
    [anon_sym_RBRACE] = ACTIONS(5089),
    [anon_sym_signed] = ACTIONS(5087),
    [anon_sym_unsigned] = ACTIONS(5087),
    [anon_sym_long] = ACTIONS(5087),
    [anon_sym_short] = ACTIONS(5087),
    [anon_sym_LBRACK] = ACTIONS(5087),
    [anon_sym_static] = ACTIONS(5087),
    [anon_sym_register] = ACTIONS(5087),
    [anon_sym_inline] = ACTIONS(5087),
    [anon_sym___inline] = ACTIONS(5087),
    [anon_sym___inline__] = ACTIONS(5087),
    [anon_sym___forceinline] = ACTIONS(5087),
    [anon_sym_thread_local] = ACTIONS(5087),
    [anon_sym___thread] = ACTIONS(5087),
    [anon_sym_const] = ACTIONS(5087),
    [anon_sym_constexpr] = ACTIONS(5087),
    [anon_sym_volatile] = ACTIONS(5087),
    [anon_sym_restrict] = ACTIONS(5087),
    [anon_sym___restrict__] = ACTIONS(5087),
    [anon_sym__Atomic] = ACTIONS(5087),
    [anon_sym__Noreturn] = ACTIONS(5087),
    [anon_sym_noreturn] = ACTIONS(5087),
    [anon_sym_mutable] = ACTIONS(5087),
    [anon_sym_constinit] = ACTIONS(5087),
    [anon_sym_consteval] = ACTIONS(5087),
    [anon_sym___shared__] = ACTIONS(5087),
    [anon_sym___local__] = ACTIONS(5087),
    [anon_sym___constant__] = ACTIONS(5087),
    [anon_sym___managed__] = ACTIONS(5087),
    [anon_sym___grid_constant__] = ACTIONS(5087),
    [anon_sym_alignas] = ACTIONS(5087),
    [anon_sym__Alignas] = ACTIONS(5087),
    [sym_primitive_type] = ACTIONS(5087),
    [anon_sym_enum] = ACTIONS(5087),
    [anon_sym_class] = ACTIONS(5087),
    [anon_sym_struct] = ACTIONS(5087),
    [anon_sym_union] = ACTIONS(5087),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5087),
    [anon_sym_decltype] = ACTIONS(5087),
    [sym_virtual] = ACTIONS(5087),
    [anon_sym_explicit] = ACTIONS(5087),
    [anon_sym_typename] = ACTIONS(5087),
    [anon_sym_template] = ACTIONS(5087),
    [anon_sym_operator] = ACTIONS(5087),
    [anon_sym_friend] = ACTIONS(5087),
    [anon_sym_public] = ACTIONS(5087),
    [anon_sym_private] = ACTIONS(5087),
    [anon_sym_protected] = ACTIONS(5087),
    [anon_sym_using] = ACTIONS(5087),
    [anon_sym_static_assert] = ACTIONS(5087),
    [anon_sym___launch_bounds__] = ACTIONS(5087),
  },
  [2066] = {
    [sym_identifier] = ACTIONS(5079),
    [aux_sym_preproc_def_token1] = ACTIONS(5079),
    [aux_sym_preproc_if_token1] = ACTIONS(5079),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5079),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5079),
    [sym_preproc_directive] = ACTIONS(5079),
    [anon_sym_LPAREN2] = ACTIONS(5081),
    [anon_sym_TILDE] = ACTIONS(5081),
    [anon_sym_STAR] = ACTIONS(5081),
    [anon_sym_AMP_AMP] = ACTIONS(5081),
    [anon_sym_AMP] = ACTIONS(5079),
    [anon_sym___extension__] = ACTIONS(5079),
    [anon_sym_typedef] = ACTIONS(5079),
    [anon_sym___device__] = ACTIONS(5079),
    [anon_sym___host__] = ACTIONS(5079),
    [anon_sym___global__] = ACTIONS(5079),
    [anon_sym___forceinline__] = ACTIONS(5079),
    [anon_sym___noinline__] = ACTIONS(5079),
    [anon_sym_extern] = ACTIONS(5079),
    [anon_sym___attribute__] = ACTIONS(5079),
    [anon_sym_COLON_COLON] = ACTIONS(5081),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5081),
    [anon_sym___declspec] = ACTIONS(5079),
    [anon_sym___based] = ACTIONS(5079),
    [anon_sym_RBRACE] = ACTIONS(5081),
    [anon_sym_signed] = ACTIONS(5079),
    [anon_sym_unsigned] = ACTIONS(5079),
    [anon_sym_long] = ACTIONS(5079),
    [anon_sym_short] = ACTIONS(5079),
    [anon_sym_LBRACK] = ACTIONS(5079),
    [anon_sym_static] = ACTIONS(5079),
    [anon_sym_register] = ACTIONS(5079),
    [anon_sym_inline] = ACTIONS(5079),
    [anon_sym___inline] = ACTIONS(5079),
    [anon_sym___inline__] = ACTIONS(5079),
    [anon_sym___forceinline] = ACTIONS(5079),
    [anon_sym_thread_local] = ACTIONS(5079),
    [anon_sym___thread] = ACTIONS(5079),
    [anon_sym_const] = ACTIONS(5079),
    [anon_sym_constexpr] = ACTIONS(5079),
    [anon_sym_volatile] = ACTIONS(5079),
    [anon_sym_restrict] = ACTIONS(5079),
    [anon_sym___restrict__] = ACTIONS(5079),
    [anon_sym__Atomic] = ACTIONS(5079),
    [anon_sym__Noreturn] = ACTIONS(5079),
    [anon_sym_noreturn] = ACTIONS(5079),
    [anon_sym_mutable] = ACTIONS(5079),
    [anon_sym_constinit] = ACTIONS(5079),
    [anon_sym_consteval] = ACTIONS(5079),
    [anon_sym___shared__] = ACTIONS(5079),
    [anon_sym___local__] = ACTIONS(5079),
    [anon_sym___constant__] = ACTIONS(5079),
    [anon_sym___managed__] = ACTIONS(5079),
    [anon_sym___grid_constant__] = ACTIONS(5079),
    [anon_sym_alignas] = ACTIONS(5079),
    [anon_sym__Alignas] = ACTIONS(5079),
    [sym_primitive_type] = ACTIONS(5079),
    [anon_sym_enum] = ACTIONS(5079),
    [anon_sym_class] = ACTIONS(5079),
    [anon_sym_struct] = ACTIONS(5079),
    [anon_sym_union] = ACTIONS(5079),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5079),
    [anon_sym_decltype] = ACTIONS(5079),
    [sym_virtual] = ACTIONS(5079),
    [anon_sym_explicit] = ACTIONS(5079),
    [anon_sym_typename] = ACTIONS(5079),
    [anon_sym_template] = ACTIONS(5079),
    [anon_sym_operator] = ACTIONS(5079),
    [anon_sym_friend] = ACTIONS(5079),
    [anon_sym_public] = ACTIONS(5079),
    [anon_sym_private] = ACTIONS(5079),
    [anon_sym_protected] = ACTIONS(5079),
    [anon_sym_using] = ACTIONS(5079),
    [anon_sym_static_assert] = ACTIONS(5079),
    [anon_sym___launch_bounds__] = ACTIONS(5079),
  },
  [2067] = {
    [sym_string_literal] = STATE(2026),
    [sym_raw_string_literal] = STATE(2026),
    [aux_sym_concatenated_string_repeat1] = STATE(2026),
    [sym_identifier] = ACTIONS(5344),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5346),
    [anon_sym_COMMA] = ACTIONS(5346),
    [anon_sym_RPAREN] = ACTIONS(5346),
    [aux_sym_preproc_if_token2] = ACTIONS(5346),
    [aux_sym_preproc_else_token1] = ACTIONS(5346),
    [aux_sym_preproc_elif_token1] = ACTIONS(5348),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5346),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5346),
    [anon_sym_LPAREN2] = ACTIONS(5346),
    [anon_sym_DASH] = ACTIONS(5348),
    [anon_sym_PLUS] = ACTIONS(5348),
    [anon_sym_STAR] = ACTIONS(5348),
    [anon_sym_SLASH] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [anon_sym_PIPE_PIPE] = ACTIONS(5346),
    [anon_sym_AMP_AMP] = ACTIONS(5346),
    [anon_sym_PIPE] = ACTIONS(5348),
    [anon_sym_CARET] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5348),
    [anon_sym_EQ_EQ] = ACTIONS(5346),
    [anon_sym_BANG_EQ] = ACTIONS(5346),
    [anon_sym_GT] = ACTIONS(5348),
    [anon_sym_GT_EQ] = ACTIONS(5346),
    [anon_sym_LT_EQ] = ACTIONS(5348),
    [anon_sym_LT] = ACTIONS(5348),
    [anon_sym_LT_LT] = ACTIONS(5348),
    [anon_sym_GT_GT] = ACTIONS(5348),
    [anon_sym_SEMI] = ACTIONS(5346),
    [anon_sym_RBRACE] = ACTIONS(5346),
    [anon_sym_LBRACK] = ACTIONS(5346),
    [anon_sym_RBRACK] = ACTIONS(5346),
    [anon_sym_EQ] = ACTIONS(5348),
    [anon_sym_COLON] = ACTIONS(5346),
    [anon_sym_QMARK] = ACTIONS(5346),
    [anon_sym_STAR_EQ] = ACTIONS(5346),
    [anon_sym_SLASH_EQ] = ACTIONS(5346),
    [anon_sym_PERCENT_EQ] = ACTIONS(5346),
    [anon_sym_PLUS_EQ] = ACTIONS(5346),
    [anon_sym_DASH_EQ] = ACTIONS(5346),
    [anon_sym_LT_LT_EQ] = ACTIONS(5346),
    [anon_sym_GT_GT_EQ] = ACTIONS(5346),
    [anon_sym_AMP_EQ] = ACTIONS(5346),
    [anon_sym_CARET_EQ] = ACTIONS(5346),
    [anon_sym_PIPE_EQ] = ACTIONS(5346),
    [anon_sym_and_eq] = ACTIONS(5348),
    [anon_sym_or_eq] = ACTIONS(5348),
    [anon_sym_xor_eq] = ACTIONS(5348),
    [anon_sym_LT_EQ_GT] = ACTIONS(5346),
    [anon_sym_or] = ACTIONS(5348),
    [anon_sym_and] = ACTIONS(5348),
    [anon_sym_bitor] = ACTIONS(5348),
    [anon_sym_xor] = ACTIONS(5348),
    [anon_sym_bitand] = ACTIONS(5348),
    [anon_sym_not_eq] = ACTIONS(5348),
    [anon_sym_DASH_DASH] = ACTIONS(5346),
    [anon_sym_PLUS_PLUS] = ACTIONS(5346),
    [anon_sym_DOT] = ACTIONS(5348),
    [anon_sym_DOT_STAR] = ACTIONS(5346),
    [anon_sym_DASH_GT] = ACTIONS(5346),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [sym_literal_suffix] = ACTIONS(5348),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5346),
  },
  [2068] = {
    [sym_identifier] = ACTIONS(1976),
    [aux_sym_preproc_def_token1] = ACTIONS(1976),
    [aux_sym_preproc_if_token1] = ACTIONS(1976),
    [aux_sym_preproc_if_token2] = ACTIONS(1976),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1976),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1976),
    [sym_preproc_directive] = ACTIONS(1976),
    [anon_sym_LPAREN2] = ACTIONS(1978),
    [anon_sym_TILDE] = ACTIONS(1978),
    [anon_sym_STAR] = ACTIONS(1978),
    [anon_sym_AMP_AMP] = ACTIONS(1978),
    [anon_sym_AMP] = ACTIONS(1976),
    [anon_sym___extension__] = ACTIONS(1976),
    [anon_sym_typedef] = ACTIONS(1976),
    [anon_sym___device__] = ACTIONS(1976),
    [anon_sym___host__] = ACTIONS(1976),
    [anon_sym___global__] = ACTIONS(1976),
    [anon_sym___forceinline__] = ACTIONS(1976),
    [anon_sym___noinline__] = ACTIONS(1976),
    [anon_sym_extern] = ACTIONS(1976),
    [anon_sym___attribute__] = ACTIONS(1976),
    [anon_sym_COLON_COLON] = ACTIONS(1978),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1978),
    [anon_sym___declspec] = ACTIONS(1976),
    [anon_sym___based] = ACTIONS(1976),
    [anon_sym_signed] = ACTIONS(1976),
    [anon_sym_unsigned] = ACTIONS(1976),
    [anon_sym_long] = ACTIONS(1976),
    [anon_sym_short] = ACTIONS(1976),
    [anon_sym_LBRACK] = ACTIONS(1976),
    [anon_sym_static] = ACTIONS(1976),
    [anon_sym_register] = ACTIONS(1976),
    [anon_sym_inline] = ACTIONS(1976),
    [anon_sym___inline] = ACTIONS(1976),
    [anon_sym___inline__] = ACTIONS(1976),
    [anon_sym___forceinline] = ACTIONS(1976),
    [anon_sym_thread_local] = ACTIONS(1976),
    [anon_sym___thread] = ACTIONS(1976),
    [anon_sym_const] = ACTIONS(1976),
    [anon_sym_constexpr] = ACTIONS(1976),
    [anon_sym_volatile] = ACTIONS(1976),
    [anon_sym_restrict] = ACTIONS(1976),
    [anon_sym___restrict__] = ACTIONS(1976),
    [anon_sym__Atomic] = ACTIONS(1976),
    [anon_sym__Noreturn] = ACTIONS(1976),
    [anon_sym_noreturn] = ACTIONS(1976),
    [anon_sym_mutable] = ACTIONS(1976),
    [anon_sym_constinit] = ACTIONS(1976),
    [anon_sym_consteval] = ACTIONS(1976),
    [anon_sym___shared__] = ACTIONS(1976),
    [anon_sym___local__] = ACTIONS(1976),
    [anon_sym___constant__] = ACTIONS(1976),
    [anon_sym___managed__] = ACTIONS(1976),
    [anon_sym___grid_constant__] = ACTIONS(1976),
    [anon_sym_alignas] = ACTIONS(1976),
    [anon_sym__Alignas] = ACTIONS(1976),
    [sym_primitive_type] = ACTIONS(1976),
    [anon_sym_enum] = ACTIONS(1976),
    [anon_sym_class] = ACTIONS(1976),
    [anon_sym_struct] = ACTIONS(1976),
    [anon_sym_union] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1976),
    [anon_sym_decltype] = ACTIONS(1976),
    [sym_virtual] = ACTIONS(1976),
    [anon_sym_explicit] = ACTIONS(1976),
    [anon_sym_typename] = ACTIONS(1976),
    [anon_sym_template] = ACTIONS(1976),
    [anon_sym_operator] = ACTIONS(1976),
    [anon_sym_friend] = ACTIONS(1976),
    [anon_sym_public] = ACTIONS(1976),
    [anon_sym_private] = ACTIONS(1976),
    [anon_sym_protected] = ACTIONS(1976),
    [anon_sym_using] = ACTIONS(1976),
    [anon_sym_static_assert] = ACTIONS(1976),
    [anon_sym___launch_bounds__] = ACTIONS(1976),
  },
  [2069] = {
    [sym_identifier] = ACTIONS(1980),
    [aux_sym_preproc_def_token1] = ACTIONS(1980),
    [aux_sym_preproc_if_token1] = ACTIONS(1980),
    [aux_sym_preproc_if_token2] = ACTIONS(1980),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1980),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1980),
    [sym_preproc_directive] = ACTIONS(1980),
    [anon_sym_LPAREN2] = ACTIONS(1982),
    [anon_sym_TILDE] = ACTIONS(1982),
    [anon_sym_STAR] = ACTIONS(1982),
    [anon_sym_AMP_AMP] = ACTIONS(1982),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym___extension__] = ACTIONS(1980),
    [anon_sym_typedef] = ACTIONS(1980),
    [anon_sym___device__] = ACTIONS(1980),
    [anon_sym___host__] = ACTIONS(1980),
    [anon_sym___global__] = ACTIONS(1980),
    [anon_sym___forceinline__] = ACTIONS(1980),
    [anon_sym___noinline__] = ACTIONS(1980),
    [anon_sym_extern] = ACTIONS(1980),
    [anon_sym___attribute__] = ACTIONS(1980),
    [anon_sym_COLON_COLON] = ACTIONS(1982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1982),
    [anon_sym___declspec] = ACTIONS(1980),
    [anon_sym___based] = ACTIONS(1980),
    [anon_sym_signed] = ACTIONS(1980),
    [anon_sym_unsigned] = ACTIONS(1980),
    [anon_sym_long] = ACTIONS(1980),
    [anon_sym_short] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1980),
    [anon_sym_static] = ACTIONS(1980),
    [anon_sym_register] = ACTIONS(1980),
    [anon_sym_inline] = ACTIONS(1980),
    [anon_sym___inline] = ACTIONS(1980),
    [anon_sym___inline__] = ACTIONS(1980),
    [anon_sym___forceinline] = ACTIONS(1980),
    [anon_sym_thread_local] = ACTIONS(1980),
    [anon_sym___thread] = ACTIONS(1980),
    [anon_sym_const] = ACTIONS(1980),
    [anon_sym_constexpr] = ACTIONS(1980),
    [anon_sym_volatile] = ACTIONS(1980),
    [anon_sym_restrict] = ACTIONS(1980),
    [anon_sym___restrict__] = ACTIONS(1980),
    [anon_sym__Atomic] = ACTIONS(1980),
    [anon_sym__Noreturn] = ACTIONS(1980),
    [anon_sym_noreturn] = ACTIONS(1980),
    [anon_sym_mutable] = ACTIONS(1980),
    [anon_sym_constinit] = ACTIONS(1980),
    [anon_sym_consteval] = ACTIONS(1980),
    [anon_sym___shared__] = ACTIONS(1980),
    [anon_sym___local__] = ACTIONS(1980),
    [anon_sym___constant__] = ACTIONS(1980),
    [anon_sym___managed__] = ACTIONS(1980),
    [anon_sym___grid_constant__] = ACTIONS(1980),
    [anon_sym_alignas] = ACTIONS(1980),
    [anon_sym__Alignas] = ACTIONS(1980),
    [sym_primitive_type] = ACTIONS(1980),
    [anon_sym_enum] = ACTIONS(1980),
    [anon_sym_class] = ACTIONS(1980),
    [anon_sym_struct] = ACTIONS(1980),
    [anon_sym_union] = ACTIONS(1980),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1980),
    [anon_sym_decltype] = ACTIONS(1980),
    [sym_virtual] = ACTIONS(1980),
    [anon_sym_explicit] = ACTIONS(1980),
    [anon_sym_typename] = ACTIONS(1980),
    [anon_sym_template] = ACTIONS(1980),
    [anon_sym_operator] = ACTIONS(1980),
    [anon_sym_friend] = ACTIONS(1980),
    [anon_sym_public] = ACTIONS(1980),
    [anon_sym_private] = ACTIONS(1980),
    [anon_sym_protected] = ACTIONS(1980),
    [anon_sym_using] = ACTIONS(1980),
    [anon_sym_static_assert] = ACTIONS(1980),
    [anon_sym___launch_bounds__] = ACTIONS(1980),
  },
  [2070] = {
    [sym_identifier] = ACTIONS(2342),
    [aux_sym_preproc_def_token1] = ACTIONS(2342),
    [aux_sym_preproc_if_token1] = ACTIONS(2342),
    [aux_sym_preproc_if_token2] = ACTIONS(2342),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2342),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2342),
    [sym_preproc_directive] = ACTIONS(2342),
    [anon_sym_LPAREN2] = ACTIONS(2344),
    [anon_sym_TILDE] = ACTIONS(2344),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2342),
    [anon_sym___extension__] = ACTIONS(2342),
    [anon_sym_typedef] = ACTIONS(2342),
    [anon_sym___device__] = ACTIONS(2342),
    [anon_sym___host__] = ACTIONS(2342),
    [anon_sym___global__] = ACTIONS(2342),
    [anon_sym___forceinline__] = ACTIONS(2342),
    [anon_sym___noinline__] = ACTIONS(2342),
    [anon_sym_extern] = ACTIONS(2342),
    [anon_sym___attribute__] = ACTIONS(2342),
    [anon_sym_COLON_COLON] = ACTIONS(2344),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2344),
    [anon_sym___declspec] = ACTIONS(2342),
    [anon_sym___based] = ACTIONS(2342),
    [anon_sym_signed] = ACTIONS(2342),
    [anon_sym_unsigned] = ACTIONS(2342),
    [anon_sym_long] = ACTIONS(2342),
    [anon_sym_short] = ACTIONS(2342),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_static] = ACTIONS(2342),
    [anon_sym_register] = ACTIONS(2342),
    [anon_sym_inline] = ACTIONS(2342),
    [anon_sym___inline] = ACTIONS(2342),
    [anon_sym___inline__] = ACTIONS(2342),
    [anon_sym___forceinline] = ACTIONS(2342),
    [anon_sym_thread_local] = ACTIONS(2342),
    [anon_sym___thread] = ACTIONS(2342),
    [anon_sym_const] = ACTIONS(2342),
    [anon_sym_constexpr] = ACTIONS(2342),
    [anon_sym_volatile] = ACTIONS(2342),
    [anon_sym_restrict] = ACTIONS(2342),
    [anon_sym___restrict__] = ACTIONS(2342),
    [anon_sym__Atomic] = ACTIONS(2342),
    [anon_sym__Noreturn] = ACTIONS(2342),
    [anon_sym_noreturn] = ACTIONS(2342),
    [anon_sym_mutable] = ACTIONS(2342),
    [anon_sym_constinit] = ACTIONS(2342),
    [anon_sym_consteval] = ACTIONS(2342),
    [anon_sym___shared__] = ACTIONS(2342),
    [anon_sym___local__] = ACTIONS(2342),
    [anon_sym___constant__] = ACTIONS(2342),
    [anon_sym___managed__] = ACTIONS(2342),
    [anon_sym___grid_constant__] = ACTIONS(2342),
    [anon_sym_alignas] = ACTIONS(2342),
    [anon_sym__Alignas] = ACTIONS(2342),
    [sym_primitive_type] = ACTIONS(2342),
    [anon_sym_enum] = ACTIONS(2342),
    [anon_sym_class] = ACTIONS(2342),
    [anon_sym_struct] = ACTIONS(2342),
    [anon_sym_union] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2342),
    [anon_sym_decltype] = ACTIONS(2342),
    [sym_virtual] = ACTIONS(2342),
    [anon_sym_explicit] = ACTIONS(2342),
    [anon_sym_typename] = ACTIONS(2342),
    [anon_sym_template] = ACTIONS(2342),
    [anon_sym_operator] = ACTIONS(2342),
    [anon_sym_friend] = ACTIONS(2342),
    [anon_sym_public] = ACTIONS(2342),
    [anon_sym_private] = ACTIONS(2342),
    [anon_sym_protected] = ACTIONS(2342),
    [anon_sym_using] = ACTIONS(2342),
    [anon_sym_static_assert] = ACTIONS(2342),
    [anon_sym___launch_bounds__] = ACTIONS(2342),
  },
  [2071] = {
    [sym_identifier] = ACTIONS(2060),
    [aux_sym_preproc_def_token1] = ACTIONS(2060),
    [aux_sym_preproc_if_token1] = ACTIONS(2060),
    [aux_sym_preproc_if_token2] = ACTIONS(2060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2060),
    [sym_preproc_directive] = ACTIONS(2060),
    [anon_sym_LPAREN2] = ACTIONS(2062),
    [anon_sym_TILDE] = ACTIONS(2062),
    [anon_sym_STAR] = ACTIONS(2062),
    [anon_sym_AMP_AMP] = ACTIONS(2062),
    [anon_sym_AMP] = ACTIONS(2060),
    [anon_sym___extension__] = ACTIONS(2060),
    [anon_sym_typedef] = ACTIONS(2060),
    [anon_sym___device__] = ACTIONS(2060),
    [anon_sym___host__] = ACTIONS(2060),
    [anon_sym___global__] = ACTIONS(2060),
    [anon_sym___forceinline__] = ACTIONS(2060),
    [anon_sym___noinline__] = ACTIONS(2060),
    [anon_sym_extern] = ACTIONS(2060),
    [anon_sym___attribute__] = ACTIONS(2060),
    [anon_sym_COLON_COLON] = ACTIONS(2062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2062),
    [anon_sym___declspec] = ACTIONS(2060),
    [anon_sym___based] = ACTIONS(2060),
    [anon_sym_signed] = ACTIONS(2060),
    [anon_sym_unsigned] = ACTIONS(2060),
    [anon_sym_long] = ACTIONS(2060),
    [anon_sym_short] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2060),
    [anon_sym_static] = ACTIONS(2060),
    [anon_sym_register] = ACTIONS(2060),
    [anon_sym_inline] = ACTIONS(2060),
    [anon_sym___inline] = ACTIONS(2060),
    [anon_sym___inline__] = ACTIONS(2060),
    [anon_sym___forceinline] = ACTIONS(2060),
    [anon_sym_thread_local] = ACTIONS(2060),
    [anon_sym___thread] = ACTIONS(2060),
    [anon_sym_const] = ACTIONS(2060),
    [anon_sym_constexpr] = ACTIONS(2060),
    [anon_sym_volatile] = ACTIONS(2060),
    [anon_sym_restrict] = ACTIONS(2060),
    [anon_sym___restrict__] = ACTIONS(2060),
    [anon_sym__Atomic] = ACTIONS(2060),
    [anon_sym__Noreturn] = ACTIONS(2060),
    [anon_sym_noreturn] = ACTIONS(2060),
    [anon_sym_mutable] = ACTIONS(2060),
    [anon_sym_constinit] = ACTIONS(2060),
    [anon_sym_consteval] = ACTIONS(2060),
    [anon_sym___shared__] = ACTIONS(2060),
    [anon_sym___local__] = ACTIONS(2060),
    [anon_sym___constant__] = ACTIONS(2060),
    [anon_sym___managed__] = ACTIONS(2060),
    [anon_sym___grid_constant__] = ACTIONS(2060),
    [anon_sym_alignas] = ACTIONS(2060),
    [anon_sym__Alignas] = ACTIONS(2060),
    [sym_primitive_type] = ACTIONS(2060),
    [anon_sym_enum] = ACTIONS(2060),
    [anon_sym_class] = ACTIONS(2060),
    [anon_sym_struct] = ACTIONS(2060),
    [anon_sym_union] = ACTIONS(2060),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2060),
    [anon_sym_decltype] = ACTIONS(2060),
    [sym_virtual] = ACTIONS(2060),
    [anon_sym_explicit] = ACTIONS(2060),
    [anon_sym_typename] = ACTIONS(2060),
    [anon_sym_template] = ACTIONS(2060),
    [anon_sym_operator] = ACTIONS(2060),
    [anon_sym_friend] = ACTIONS(2060),
    [anon_sym_public] = ACTIONS(2060),
    [anon_sym_private] = ACTIONS(2060),
    [anon_sym_protected] = ACTIONS(2060),
    [anon_sym_using] = ACTIONS(2060),
    [anon_sym_static_assert] = ACTIONS(2060),
    [anon_sym___launch_bounds__] = ACTIONS(2060),
  },
  [2072] = {
    [sym_identifier] = ACTIONS(2457),
    [aux_sym_preproc_def_token1] = ACTIONS(2457),
    [aux_sym_preproc_if_token1] = ACTIONS(2457),
    [aux_sym_preproc_if_token2] = ACTIONS(2457),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2457),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2457),
    [sym_preproc_directive] = ACTIONS(2457),
    [anon_sym_LPAREN2] = ACTIONS(2459),
    [anon_sym_TILDE] = ACTIONS(2459),
    [anon_sym_STAR] = ACTIONS(2459),
    [anon_sym_AMP_AMP] = ACTIONS(2459),
    [anon_sym_AMP] = ACTIONS(2457),
    [anon_sym___extension__] = ACTIONS(2457),
    [anon_sym_typedef] = ACTIONS(2457),
    [anon_sym___device__] = ACTIONS(2457),
    [anon_sym___host__] = ACTIONS(2457),
    [anon_sym___global__] = ACTIONS(2457),
    [anon_sym___forceinline__] = ACTIONS(2457),
    [anon_sym___noinline__] = ACTIONS(2457),
    [anon_sym_extern] = ACTIONS(2457),
    [anon_sym___attribute__] = ACTIONS(2457),
    [anon_sym_COLON_COLON] = ACTIONS(2459),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2459),
    [anon_sym___declspec] = ACTIONS(2457),
    [anon_sym___based] = ACTIONS(2457),
    [anon_sym_signed] = ACTIONS(2457),
    [anon_sym_unsigned] = ACTIONS(2457),
    [anon_sym_long] = ACTIONS(2457),
    [anon_sym_short] = ACTIONS(2457),
    [anon_sym_LBRACK] = ACTIONS(2457),
    [anon_sym_static] = ACTIONS(2457),
    [anon_sym_register] = ACTIONS(2457),
    [anon_sym_inline] = ACTIONS(2457),
    [anon_sym___inline] = ACTIONS(2457),
    [anon_sym___inline__] = ACTIONS(2457),
    [anon_sym___forceinline] = ACTIONS(2457),
    [anon_sym_thread_local] = ACTIONS(2457),
    [anon_sym___thread] = ACTIONS(2457),
    [anon_sym_const] = ACTIONS(2457),
    [anon_sym_constexpr] = ACTIONS(2457),
    [anon_sym_volatile] = ACTIONS(2457),
    [anon_sym_restrict] = ACTIONS(2457),
    [anon_sym___restrict__] = ACTIONS(2457),
    [anon_sym__Atomic] = ACTIONS(2457),
    [anon_sym__Noreturn] = ACTIONS(2457),
    [anon_sym_noreturn] = ACTIONS(2457),
    [anon_sym_mutable] = ACTIONS(2457),
    [anon_sym_constinit] = ACTIONS(2457),
    [anon_sym_consteval] = ACTIONS(2457),
    [anon_sym___shared__] = ACTIONS(2457),
    [anon_sym___local__] = ACTIONS(2457),
    [anon_sym___constant__] = ACTIONS(2457),
    [anon_sym___managed__] = ACTIONS(2457),
    [anon_sym___grid_constant__] = ACTIONS(2457),
    [anon_sym_alignas] = ACTIONS(2457),
    [anon_sym__Alignas] = ACTIONS(2457),
    [sym_primitive_type] = ACTIONS(2457),
    [anon_sym_enum] = ACTIONS(2457),
    [anon_sym_class] = ACTIONS(2457),
    [anon_sym_struct] = ACTIONS(2457),
    [anon_sym_union] = ACTIONS(2457),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2457),
    [anon_sym_decltype] = ACTIONS(2457),
    [sym_virtual] = ACTIONS(2457),
    [anon_sym_explicit] = ACTIONS(2457),
    [anon_sym_typename] = ACTIONS(2457),
    [anon_sym_template] = ACTIONS(2457),
    [anon_sym_operator] = ACTIONS(2457),
    [anon_sym_friend] = ACTIONS(2457),
    [anon_sym_public] = ACTIONS(2457),
    [anon_sym_private] = ACTIONS(2457),
    [anon_sym_protected] = ACTIONS(2457),
    [anon_sym_using] = ACTIONS(2457),
    [anon_sym_static_assert] = ACTIONS(2457),
    [anon_sym___launch_bounds__] = ACTIONS(2457),
  },
  [2073] = {
    [sym_identifier] = ACTIONS(5350),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5352),
    [anon_sym_COMMA] = ACTIONS(5352),
    [anon_sym_RPAREN] = ACTIONS(5352),
    [anon_sym_LPAREN2] = ACTIONS(5352),
    [anon_sym_DASH] = ACTIONS(5350),
    [anon_sym_PLUS] = ACTIONS(5350),
    [anon_sym_STAR] = ACTIONS(5352),
    [anon_sym_SLASH] = ACTIONS(5350),
    [anon_sym_PERCENT] = ACTIONS(5352),
    [anon_sym_PIPE_PIPE] = ACTIONS(5352),
    [anon_sym_AMP_AMP] = ACTIONS(5352),
    [anon_sym_PIPE] = ACTIONS(5350),
    [anon_sym_CARET] = ACTIONS(5352),
    [anon_sym_AMP] = ACTIONS(5350),
    [anon_sym_EQ_EQ] = ACTIONS(5352),
    [anon_sym_BANG_EQ] = ACTIONS(5352),
    [anon_sym_GT] = ACTIONS(5350),
    [anon_sym_GT_EQ] = ACTIONS(5352),
    [anon_sym_LT_EQ] = ACTIONS(5350),
    [anon_sym_LT] = ACTIONS(5350),
    [anon_sym_LT_LT] = ACTIONS(5350),
    [anon_sym_GT_GT] = ACTIONS(5352),
    [anon_sym_SEMI] = ACTIONS(5352),
    [anon_sym___extension__] = ACTIONS(5350),
    [anon_sym___global__] = ACTIONS(5350),
    [anon_sym___attribute__] = ACTIONS(5350),
    [anon_sym___based] = ACTIONS(5350),
    [anon_sym_LBRACE] = ACTIONS(5352),
    [anon_sym_RBRACE] = ACTIONS(5352),
    [anon_sym_signed] = ACTIONS(5350),
    [anon_sym_unsigned] = ACTIONS(5350),
    [anon_sym_long] = ACTIONS(5350),
    [anon_sym_short] = ACTIONS(5350),
    [anon_sym_LBRACK] = ACTIONS(5352),
    [anon_sym_RBRACK] = ACTIONS(5352),
    [anon_sym_const] = ACTIONS(5350),
    [anon_sym_constexpr] = ACTIONS(5350),
    [anon_sym_volatile] = ACTIONS(5350),
    [anon_sym_restrict] = ACTIONS(5350),
    [anon_sym___restrict__] = ACTIONS(5350),
    [anon_sym__Atomic] = ACTIONS(5350),
    [anon_sym__Noreturn] = ACTIONS(5350),
    [anon_sym_noreturn] = ACTIONS(5350),
    [anon_sym_mutable] = ACTIONS(5350),
    [anon_sym_constinit] = ACTIONS(5350),
    [anon_sym_consteval] = ACTIONS(5350),
    [anon_sym___shared__] = ACTIONS(5350),
    [anon_sym___local__] = ACTIONS(5350),
    [anon_sym___constant__] = ACTIONS(5350),
    [anon_sym___managed__] = ACTIONS(5350),
    [anon_sym___grid_constant__] = ACTIONS(5350),
    [anon_sym_alignas] = ACTIONS(5350),
    [anon_sym__Alignas] = ACTIONS(5350),
    [sym_primitive_type] = ACTIONS(5350),
    [anon_sym_COLON] = ACTIONS(5352),
    [anon_sym_QMARK] = ACTIONS(5352),
    [anon_sym_LT_EQ_GT] = ACTIONS(5352),
    [anon_sym_or] = ACTIONS(5350),
    [anon_sym_and] = ACTIONS(5350),
    [anon_sym_bitor] = ACTIONS(5350),
    [anon_sym_xor] = ACTIONS(5350),
    [anon_sym_bitand] = ACTIONS(5350),
    [anon_sym_not_eq] = ACTIONS(5350),
    [anon_sym_DASH_DASH] = ACTIONS(5352),
    [anon_sym_PLUS_PLUS] = ACTIONS(5352),
    [anon_sym_DOT] = ACTIONS(5350),
    [anon_sym_DOT_STAR] = ACTIONS(5352),
    [anon_sym_DASH_GT] = ACTIONS(5352),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5350),
    [anon_sym_decltype] = ACTIONS(5350),
    [anon_sym_final] = ACTIONS(5350),
    [anon_sym_override] = ACTIONS(5350),
    [anon_sym_requires] = ACTIONS(5350),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5352),
  },
  [2074] = {
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3650),
    [anon_sym_COMMA] = ACTIONS(3650),
    [anon_sym_RPAREN] = ACTIONS(3650),
    [anon_sym_LPAREN2] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_AMP_AMP] = ACTIONS(3650),
    [anon_sym_AMP] = ACTIONS(3648),
    [anon_sym_SEMI] = ACTIONS(3650),
    [anon_sym___extension__] = ACTIONS(3648),
    [anon_sym___device__] = ACTIONS(3648),
    [anon_sym___host__] = ACTIONS(3648),
    [anon_sym___global__] = ACTIONS(3648),
    [anon_sym___forceinline__] = ACTIONS(3648),
    [anon_sym___noinline__] = ACTIONS(3648),
    [anon_sym_extern] = ACTIONS(3648),
    [anon_sym___attribute__] = ACTIONS(3648),
    [anon_sym_COLON_COLON] = ACTIONS(3650),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3650),
    [anon_sym___declspec] = ACTIONS(3648),
    [anon_sym___based] = ACTIONS(3648),
    [anon_sym___cdecl] = ACTIONS(3648),
    [anon_sym___clrcall] = ACTIONS(3648),
    [anon_sym___stdcall] = ACTIONS(3648),
    [anon_sym___fastcall] = ACTIONS(3648),
    [anon_sym___thiscall] = ACTIONS(3648),
    [anon_sym___vectorcall] = ACTIONS(3648),
    [anon_sym_LBRACE] = ACTIONS(3650),
    [anon_sym_LBRACK] = ACTIONS(3648),
    [anon_sym_static] = ACTIONS(3648),
    [anon_sym_EQ] = ACTIONS(3650),
    [anon_sym_register] = ACTIONS(3648),
    [anon_sym_inline] = ACTIONS(3648),
    [anon_sym___inline] = ACTIONS(3648),
    [anon_sym___inline__] = ACTIONS(3648),
    [anon_sym___forceinline] = ACTIONS(3648),
    [anon_sym_thread_local] = ACTIONS(3648),
    [anon_sym___thread] = ACTIONS(3648),
    [anon_sym_const] = ACTIONS(3648),
    [anon_sym_constexpr] = ACTIONS(3648),
    [anon_sym_volatile] = ACTIONS(3648),
    [anon_sym_restrict] = ACTIONS(3648),
    [anon_sym___restrict__] = ACTIONS(3648),
    [anon_sym__Atomic] = ACTIONS(3648),
    [anon_sym__Noreturn] = ACTIONS(3648),
    [anon_sym_noreturn] = ACTIONS(3648),
    [anon_sym_mutable] = ACTIONS(3648),
    [anon_sym_constinit] = ACTIONS(3648),
    [anon_sym_consteval] = ACTIONS(3648),
    [anon_sym___shared__] = ACTIONS(3648),
    [anon_sym___local__] = ACTIONS(3648),
    [anon_sym___constant__] = ACTIONS(3648),
    [anon_sym___managed__] = ACTIONS(3648),
    [anon_sym___grid_constant__] = ACTIONS(3648),
    [anon_sym_alignas] = ACTIONS(3648),
    [anon_sym__Alignas] = ACTIONS(3648),
    [anon_sym_COLON] = ACTIONS(3648),
    [anon_sym_asm] = ACTIONS(3648),
    [anon_sym___asm__] = ACTIONS(3648),
    [anon_sym_DASH_GT] = ACTIONS(3650),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3648),
    [anon_sym_final] = ACTIONS(3648),
    [anon_sym_override] = ACTIONS(3648),
    [sym_virtual] = ACTIONS(3648),
    [anon_sym_explicit] = ACTIONS(3648),
    [anon_sym_template] = ACTIONS(3648),
    [anon_sym_GT2] = ACTIONS(3650),
    [anon_sym_operator] = ACTIONS(3648),
    [anon_sym_try] = ACTIONS(3648),
    [anon_sym_public] = ACTIONS(3648),
    [anon_sym_private] = ACTIONS(3648),
    [anon_sym_protected] = ACTIONS(3648),
    [anon_sym_requires] = ACTIONS(3648),
    [anon_sym___launch_bounds__] = ACTIONS(3648),
  },
  [2075] = {
    [sym_identifier] = ACTIONS(2500),
    [aux_sym_preproc_def_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2500),
    [sym_preproc_directive] = ACTIONS(2500),
    [anon_sym_LPAREN2] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [anon_sym_STAR] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2500),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_typedef] = ACTIONS(2500),
    [anon_sym___device__] = ACTIONS(2500),
    [anon_sym___host__] = ACTIONS(2500),
    [anon_sym___global__] = ACTIONS(2500),
    [anon_sym___forceinline__] = ACTIONS(2500),
    [anon_sym___noinline__] = ACTIONS(2500),
    [anon_sym_extern] = ACTIONS(2500),
    [anon_sym___attribute__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2502),
    [anon_sym___declspec] = ACTIONS(2500),
    [anon_sym___based] = ACTIONS(2500),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_signed] = ACTIONS(2500),
    [anon_sym_unsigned] = ACTIONS(2500),
    [anon_sym_long] = ACTIONS(2500),
    [anon_sym_short] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_static] = ACTIONS(2500),
    [anon_sym_register] = ACTIONS(2500),
    [anon_sym_inline] = ACTIONS(2500),
    [anon_sym___inline] = ACTIONS(2500),
    [anon_sym___inline__] = ACTIONS(2500),
    [anon_sym___forceinline] = ACTIONS(2500),
    [anon_sym_thread_local] = ACTIONS(2500),
    [anon_sym___thread] = ACTIONS(2500),
    [anon_sym_const] = ACTIONS(2500),
    [anon_sym_constexpr] = ACTIONS(2500),
    [anon_sym_volatile] = ACTIONS(2500),
    [anon_sym_restrict] = ACTIONS(2500),
    [anon_sym___restrict__] = ACTIONS(2500),
    [anon_sym__Atomic] = ACTIONS(2500),
    [anon_sym__Noreturn] = ACTIONS(2500),
    [anon_sym_noreturn] = ACTIONS(2500),
    [anon_sym_mutable] = ACTIONS(2500),
    [anon_sym_constinit] = ACTIONS(2500),
    [anon_sym_consteval] = ACTIONS(2500),
    [anon_sym___shared__] = ACTIONS(2500),
    [anon_sym___local__] = ACTIONS(2500),
    [anon_sym___constant__] = ACTIONS(2500),
    [anon_sym___managed__] = ACTIONS(2500),
    [anon_sym___grid_constant__] = ACTIONS(2500),
    [anon_sym_alignas] = ACTIONS(2500),
    [anon_sym__Alignas] = ACTIONS(2500),
    [sym_primitive_type] = ACTIONS(2500),
    [anon_sym_enum] = ACTIONS(2500),
    [anon_sym_class] = ACTIONS(2500),
    [anon_sym_struct] = ACTIONS(2500),
    [anon_sym_union] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2500),
    [anon_sym_decltype] = ACTIONS(2500),
    [sym_virtual] = ACTIONS(2500),
    [anon_sym_explicit] = ACTIONS(2500),
    [anon_sym_typename] = ACTIONS(2500),
    [anon_sym_template] = ACTIONS(2500),
    [anon_sym_operator] = ACTIONS(2500),
    [anon_sym_friend] = ACTIONS(2500),
    [anon_sym_public] = ACTIONS(2500),
    [anon_sym_private] = ACTIONS(2500),
    [anon_sym_protected] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_static_assert] = ACTIONS(2500),
    [anon_sym___launch_bounds__] = ACTIONS(2500),
  },
  [2076] = {
    [sym_identifier] = ACTIONS(2500),
    [aux_sym_preproc_def_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2500),
    [sym_preproc_directive] = ACTIONS(2500),
    [anon_sym_LPAREN2] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [anon_sym_STAR] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2500),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_typedef] = ACTIONS(2500),
    [anon_sym___device__] = ACTIONS(2500),
    [anon_sym___host__] = ACTIONS(2500),
    [anon_sym___global__] = ACTIONS(2500),
    [anon_sym___forceinline__] = ACTIONS(2500),
    [anon_sym___noinline__] = ACTIONS(2500),
    [anon_sym_extern] = ACTIONS(2500),
    [anon_sym___attribute__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2502),
    [anon_sym___declspec] = ACTIONS(2500),
    [anon_sym___based] = ACTIONS(2500),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_signed] = ACTIONS(2500),
    [anon_sym_unsigned] = ACTIONS(2500),
    [anon_sym_long] = ACTIONS(2500),
    [anon_sym_short] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_static] = ACTIONS(2500),
    [anon_sym_register] = ACTIONS(2500),
    [anon_sym_inline] = ACTIONS(2500),
    [anon_sym___inline] = ACTIONS(2500),
    [anon_sym___inline__] = ACTIONS(2500),
    [anon_sym___forceinline] = ACTIONS(2500),
    [anon_sym_thread_local] = ACTIONS(2500),
    [anon_sym___thread] = ACTIONS(2500),
    [anon_sym_const] = ACTIONS(2500),
    [anon_sym_constexpr] = ACTIONS(2500),
    [anon_sym_volatile] = ACTIONS(2500),
    [anon_sym_restrict] = ACTIONS(2500),
    [anon_sym___restrict__] = ACTIONS(2500),
    [anon_sym__Atomic] = ACTIONS(2500),
    [anon_sym__Noreturn] = ACTIONS(2500),
    [anon_sym_noreturn] = ACTIONS(2500),
    [anon_sym_mutable] = ACTIONS(2500),
    [anon_sym_constinit] = ACTIONS(2500),
    [anon_sym_consteval] = ACTIONS(2500),
    [anon_sym___shared__] = ACTIONS(2500),
    [anon_sym___local__] = ACTIONS(2500),
    [anon_sym___constant__] = ACTIONS(2500),
    [anon_sym___managed__] = ACTIONS(2500),
    [anon_sym___grid_constant__] = ACTIONS(2500),
    [anon_sym_alignas] = ACTIONS(2500),
    [anon_sym__Alignas] = ACTIONS(2500),
    [sym_primitive_type] = ACTIONS(2500),
    [anon_sym_enum] = ACTIONS(2500),
    [anon_sym_class] = ACTIONS(2500),
    [anon_sym_struct] = ACTIONS(2500),
    [anon_sym_union] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2500),
    [anon_sym_decltype] = ACTIONS(2500),
    [sym_virtual] = ACTIONS(2500),
    [anon_sym_explicit] = ACTIONS(2500),
    [anon_sym_typename] = ACTIONS(2500),
    [anon_sym_template] = ACTIONS(2500),
    [anon_sym_operator] = ACTIONS(2500),
    [anon_sym_friend] = ACTIONS(2500),
    [anon_sym_public] = ACTIONS(2500),
    [anon_sym_private] = ACTIONS(2500),
    [anon_sym_protected] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_static_assert] = ACTIONS(2500),
    [anon_sym___launch_bounds__] = ACTIONS(2500),
  },
  [2077] = {
    [sym_identifier] = ACTIONS(2080),
    [aux_sym_preproc_def_token1] = ACTIONS(2080),
    [aux_sym_preproc_if_token1] = ACTIONS(2080),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2080),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2080),
    [sym_preproc_directive] = ACTIONS(2080),
    [anon_sym_LPAREN2] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2082),
    [anon_sym_STAR] = ACTIONS(2082),
    [anon_sym_AMP_AMP] = ACTIONS(2082),
    [anon_sym_AMP] = ACTIONS(2080),
    [anon_sym___extension__] = ACTIONS(2080),
    [anon_sym_typedef] = ACTIONS(2080),
    [anon_sym___device__] = ACTIONS(2080),
    [anon_sym___host__] = ACTIONS(2080),
    [anon_sym___global__] = ACTIONS(2080),
    [anon_sym___forceinline__] = ACTIONS(2080),
    [anon_sym___noinline__] = ACTIONS(2080),
    [anon_sym_extern] = ACTIONS(2080),
    [anon_sym___attribute__] = ACTIONS(2080),
    [anon_sym_COLON_COLON] = ACTIONS(2082),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2082),
    [anon_sym___declspec] = ACTIONS(2080),
    [anon_sym___based] = ACTIONS(2080),
    [anon_sym_RBRACE] = ACTIONS(2082),
    [anon_sym_signed] = ACTIONS(2080),
    [anon_sym_unsigned] = ACTIONS(2080),
    [anon_sym_long] = ACTIONS(2080),
    [anon_sym_short] = ACTIONS(2080),
    [anon_sym_LBRACK] = ACTIONS(2080),
    [anon_sym_static] = ACTIONS(2080),
    [anon_sym_register] = ACTIONS(2080),
    [anon_sym_inline] = ACTIONS(2080),
    [anon_sym___inline] = ACTIONS(2080),
    [anon_sym___inline__] = ACTIONS(2080),
    [anon_sym___forceinline] = ACTIONS(2080),
    [anon_sym_thread_local] = ACTIONS(2080),
    [anon_sym___thread] = ACTIONS(2080),
    [anon_sym_const] = ACTIONS(2080),
    [anon_sym_constexpr] = ACTIONS(2080),
    [anon_sym_volatile] = ACTIONS(2080),
    [anon_sym_restrict] = ACTIONS(2080),
    [anon_sym___restrict__] = ACTIONS(2080),
    [anon_sym__Atomic] = ACTIONS(2080),
    [anon_sym__Noreturn] = ACTIONS(2080),
    [anon_sym_noreturn] = ACTIONS(2080),
    [anon_sym_mutable] = ACTIONS(2080),
    [anon_sym_constinit] = ACTIONS(2080),
    [anon_sym_consteval] = ACTIONS(2080),
    [anon_sym___shared__] = ACTIONS(2080),
    [anon_sym___local__] = ACTIONS(2080),
    [anon_sym___constant__] = ACTIONS(2080),
    [anon_sym___managed__] = ACTIONS(2080),
    [anon_sym___grid_constant__] = ACTIONS(2080),
    [anon_sym_alignas] = ACTIONS(2080),
    [anon_sym__Alignas] = ACTIONS(2080),
    [sym_primitive_type] = ACTIONS(2080),
    [anon_sym_enum] = ACTIONS(2080),
    [anon_sym_class] = ACTIONS(2080),
    [anon_sym_struct] = ACTIONS(2080),
    [anon_sym_union] = ACTIONS(2080),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2080),
    [anon_sym_decltype] = ACTIONS(2080),
    [sym_virtual] = ACTIONS(2080),
    [anon_sym_explicit] = ACTIONS(2080),
    [anon_sym_typename] = ACTIONS(2080),
    [anon_sym_template] = ACTIONS(2080),
    [anon_sym_operator] = ACTIONS(2080),
    [anon_sym_friend] = ACTIONS(2080),
    [anon_sym_public] = ACTIONS(2080),
    [anon_sym_private] = ACTIONS(2080),
    [anon_sym_protected] = ACTIONS(2080),
    [anon_sym_using] = ACTIONS(2080),
    [anon_sym_static_assert] = ACTIONS(2080),
    [anon_sym___launch_bounds__] = ACTIONS(2080),
  },
  [2078] = {
    [sym_identifier] = ACTIONS(5027),
    [aux_sym_preproc_def_token1] = ACTIONS(5027),
    [aux_sym_preproc_if_token1] = ACTIONS(5027),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5027),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5027),
    [sym_preproc_directive] = ACTIONS(5027),
    [anon_sym_LPAREN2] = ACTIONS(5029),
    [anon_sym_TILDE] = ACTIONS(5029),
    [anon_sym_STAR] = ACTIONS(5029),
    [anon_sym_AMP_AMP] = ACTIONS(5029),
    [anon_sym_AMP] = ACTIONS(5027),
    [anon_sym___extension__] = ACTIONS(5027),
    [anon_sym_typedef] = ACTIONS(5027),
    [anon_sym___device__] = ACTIONS(5027),
    [anon_sym___host__] = ACTIONS(5027),
    [anon_sym___global__] = ACTIONS(5027),
    [anon_sym___forceinline__] = ACTIONS(5027),
    [anon_sym___noinline__] = ACTIONS(5027),
    [anon_sym_extern] = ACTIONS(5027),
    [anon_sym___attribute__] = ACTIONS(5027),
    [anon_sym_COLON_COLON] = ACTIONS(5029),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5029),
    [anon_sym___declspec] = ACTIONS(5027),
    [anon_sym___based] = ACTIONS(5027),
    [anon_sym_RBRACE] = ACTIONS(5029),
    [anon_sym_signed] = ACTIONS(5027),
    [anon_sym_unsigned] = ACTIONS(5027),
    [anon_sym_long] = ACTIONS(5027),
    [anon_sym_short] = ACTIONS(5027),
    [anon_sym_LBRACK] = ACTIONS(5027),
    [anon_sym_static] = ACTIONS(5027),
    [anon_sym_register] = ACTIONS(5027),
    [anon_sym_inline] = ACTIONS(5027),
    [anon_sym___inline] = ACTIONS(5027),
    [anon_sym___inline__] = ACTIONS(5027),
    [anon_sym___forceinline] = ACTIONS(5027),
    [anon_sym_thread_local] = ACTIONS(5027),
    [anon_sym___thread] = ACTIONS(5027),
    [anon_sym_const] = ACTIONS(5027),
    [anon_sym_constexpr] = ACTIONS(5027),
    [anon_sym_volatile] = ACTIONS(5027),
    [anon_sym_restrict] = ACTIONS(5027),
    [anon_sym___restrict__] = ACTIONS(5027),
    [anon_sym__Atomic] = ACTIONS(5027),
    [anon_sym__Noreturn] = ACTIONS(5027),
    [anon_sym_noreturn] = ACTIONS(5027),
    [anon_sym_mutable] = ACTIONS(5027),
    [anon_sym_constinit] = ACTIONS(5027),
    [anon_sym_consteval] = ACTIONS(5027),
    [anon_sym___shared__] = ACTIONS(5027),
    [anon_sym___local__] = ACTIONS(5027),
    [anon_sym___constant__] = ACTIONS(5027),
    [anon_sym___managed__] = ACTIONS(5027),
    [anon_sym___grid_constant__] = ACTIONS(5027),
    [anon_sym_alignas] = ACTIONS(5027),
    [anon_sym__Alignas] = ACTIONS(5027),
    [sym_primitive_type] = ACTIONS(5027),
    [anon_sym_enum] = ACTIONS(5027),
    [anon_sym_class] = ACTIONS(5027),
    [anon_sym_struct] = ACTIONS(5027),
    [anon_sym_union] = ACTIONS(5027),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5027),
    [anon_sym_decltype] = ACTIONS(5027),
    [sym_virtual] = ACTIONS(5027),
    [anon_sym_explicit] = ACTIONS(5027),
    [anon_sym_typename] = ACTIONS(5027),
    [anon_sym_template] = ACTIONS(5027),
    [anon_sym_operator] = ACTIONS(5027),
    [anon_sym_friend] = ACTIONS(5027),
    [anon_sym_public] = ACTIONS(5027),
    [anon_sym_private] = ACTIONS(5027),
    [anon_sym_protected] = ACTIONS(5027),
    [anon_sym_using] = ACTIONS(5027),
    [anon_sym_static_assert] = ACTIONS(5027),
    [anon_sym___launch_bounds__] = ACTIONS(5027),
  },
  [2079] = {
    [sym_identifier] = ACTIONS(2284),
    [aux_sym_preproc_def_token1] = ACTIONS(2284),
    [aux_sym_preproc_if_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2284),
    [sym_preproc_directive] = ACTIONS(2284),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_typedef] = ACTIONS(2284),
    [anon_sym___device__] = ACTIONS(2284),
    [anon_sym___host__] = ACTIONS(2284),
    [anon_sym___global__] = ACTIONS(2284),
    [anon_sym___forceinline__] = ACTIONS(2284),
    [anon_sym___noinline__] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2286),
    [anon_sym___declspec] = ACTIONS(2284),
    [anon_sym___based] = ACTIONS(2284),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_signed] = ACTIONS(2284),
    [anon_sym_unsigned] = ACTIONS(2284),
    [anon_sym_long] = ACTIONS(2284),
    [anon_sym_short] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym___inline] = ACTIONS(2284),
    [anon_sym___inline__] = ACTIONS(2284),
    [anon_sym___forceinline] = ACTIONS(2284),
    [anon_sym_thread_local] = ACTIONS(2284),
    [anon_sym___thread] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym___shared__] = ACTIONS(2284),
    [anon_sym___local__] = ACTIONS(2284),
    [anon_sym___constant__] = ACTIONS(2284),
    [anon_sym___managed__] = ACTIONS(2284),
    [anon_sym___grid_constant__] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [sym_primitive_type] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
    [anon_sym_class] = ACTIONS(2284),
    [anon_sym_struct] = ACTIONS(2284),
    [anon_sym_union] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [sym_virtual] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_typename] = ACTIONS(2284),
    [anon_sym_template] = ACTIONS(2284),
    [anon_sym_operator] = ACTIONS(2284),
    [anon_sym_friend] = ACTIONS(2284),
    [anon_sym_public] = ACTIONS(2284),
    [anon_sym_private] = ACTIONS(2284),
    [anon_sym_protected] = ACTIONS(2284),
    [anon_sym_using] = ACTIONS(2284),
    [anon_sym_static_assert] = ACTIONS(2284),
    [anon_sym___launch_bounds__] = ACTIONS(2284),
  },
  [2080] = {
    [sym_identifier] = ACTIONS(2288),
    [aux_sym_preproc_def_token1] = ACTIONS(2288),
    [aux_sym_preproc_if_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2288),
    [sym_preproc_directive] = ACTIONS(2288),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym_typedef] = ACTIONS(2288),
    [anon_sym___device__] = ACTIONS(2288),
    [anon_sym___host__] = ACTIONS(2288),
    [anon_sym___global__] = ACTIONS(2288),
    [anon_sym___forceinline__] = ACTIONS(2288),
    [anon_sym___noinline__] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2290),
    [anon_sym___declspec] = ACTIONS(2288),
    [anon_sym___based] = ACTIONS(2288),
    [anon_sym_RBRACE] = ACTIONS(2290),
    [anon_sym_signed] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym___inline] = ACTIONS(2288),
    [anon_sym___inline__] = ACTIONS(2288),
    [anon_sym___forceinline] = ACTIONS(2288),
    [anon_sym_thread_local] = ACTIONS(2288),
    [anon_sym___thread] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym___shared__] = ACTIONS(2288),
    [anon_sym___local__] = ACTIONS(2288),
    [anon_sym___constant__] = ACTIONS(2288),
    [anon_sym___managed__] = ACTIONS(2288),
    [anon_sym___grid_constant__] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [sym_virtual] = ACTIONS(2288),
    [anon_sym_explicit] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_operator] = ACTIONS(2288),
    [anon_sym_friend] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_static_assert] = ACTIONS(2288),
    [anon_sym___launch_bounds__] = ACTIONS(2288),
  },
  [2081] = {
    [sym_identifier] = ACTIONS(2292),
    [aux_sym_preproc_def_token1] = ACTIONS(2292),
    [aux_sym_preproc_if_token1] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2292),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2292),
    [sym_preproc_directive] = ACTIONS(2292),
    [anon_sym_LPAREN2] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2292),
    [anon_sym___extension__] = ACTIONS(2292),
    [anon_sym_typedef] = ACTIONS(2292),
    [anon_sym___device__] = ACTIONS(2292),
    [anon_sym___host__] = ACTIONS(2292),
    [anon_sym___global__] = ACTIONS(2292),
    [anon_sym___forceinline__] = ACTIONS(2292),
    [anon_sym___noinline__] = ACTIONS(2292),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym___attribute__] = ACTIONS(2292),
    [anon_sym_COLON_COLON] = ACTIONS(2294),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2294),
    [anon_sym___declspec] = ACTIONS(2292),
    [anon_sym___based] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(2294),
    [anon_sym_signed] = ACTIONS(2292),
    [anon_sym_unsigned] = ACTIONS(2292),
    [anon_sym_long] = ACTIONS(2292),
    [anon_sym_short] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_register] = ACTIONS(2292),
    [anon_sym_inline] = ACTIONS(2292),
    [anon_sym___inline] = ACTIONS(2292),
    [anon_sym___inline__] = ACTIONS(2292),
    [anon_sym___forceinline] = ACTIONS(2292),
    [anon_sym_thread_local] = ACTIONS(2292),
    [anon_sym___thread] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_constexpr] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym_restrict] = ACTIONS(2292),
    [anon_sym___restrict__] = ACTIONS(2292),
    [anon_sym__Atomic] = ACTIONS(2292),
    [anon_sym__Noreturn] = ACTIONS(2292),
    [anon_sym_noreturn] = ACTIONS(2292),
    [anon_sym_mutable] = ACTIONS(2292),
    [anon_sym_constinit] = ACTIONS(2292),
    [anon_sym_consteval] = ACTIONS(2292),
    [anon_sym___shared__] = ACTIONS(2292),
    [anon_sym___local__] = ACTIONS(2292),
    [anon_sym___constant__] = ACTIONS(2292),
    [anon_sym___managed__] = ACTIONS(2292),
    [anon_sym___grid_constant__] = ACTIONS(2292),
    [anon_sym_alignas] = ACTIONS(2292),
    [anon_sym__Alignas] = ACTIONS(2292),
    [sym_primitive_type] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_struct] = ACTIONS(2292),
    [anon_sym_union] = ACTIONS(2292),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2292),
    [anon_sym_decltype] = ACTIONS(2292),
    [sym_virtual] = ACTIONS(2292),
    [anon_sym_explicit] = ACTIONS(2292),
    [anon_sym_typename] = ACTIONS(2292),
    [anon_sym_template] = ACTIONS(2292),
    [anon_sym_operator] = ACTIONS(2292),
    [anon_sym_friend] = ACTIONS(2292),
    [anon_sym_public] = ACTIONS(2292),
    [anon_sym_private] = ACTIONS(2292),
    [anon_sym_protected] = ACTIONS(2292),
    [anon_sym_using] = ACTIONS(2292),
    [anon_sym_static_assert] = ACTIONS(2292),
    [anon_sym___launch_bounds__] = ACTIONS(2292),
  },
  [2082] = {
    [sym_identifier] = ACTIONS(2296),
    [aux_sym_preproc_def_token1] = ACTIONS(2296),
    [aux_sym_preproc_if_token1] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2296),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2296),
    [sym_preproc_directive] = ACTIONS(2296),
    [anon_sym_LPAREN2] = ACTIONS(2298),
    [anon_sym_TILDE] = ACTIONS(2298),
    [anon_sym_STAR] = ACTIONS(2298),
    [anon_sym_AMP_AMP] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2296),
    [anon_sym___extension__] = ACTIONS(2296),
    [anon_sym_typedef] = ACTIONS(2296),
    [anon_sym___device__] = ACTIONS(2296),
    [anon_sym___host__] = ACTIONS(2296),
    [anon_sym___global__] = ACTIONS(2296),
    [anon_sym___forceinline__] = ACTIONS(2296),
    [anon_sym___noinline__] = ACTIONS(2296),
    [anon_sym_extern] = ACTIONS(2296),
    [anon_sym___attribute__] = ACTIONS(2296),
    [anon_sym_COLON_COLON] = ACTIONS(2298),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2298),
    [anon_sym___declspec] = ACTIONS(2296),
    [anon_sym___based] = ACTIONS(2296),
    [anon_sym_RBRACE] = ACTIONS(2298),
    [anon_sym_signed] = ACTIONS(2296),
    [anon_sym_unsigned] = ACTIONS(2296),
    [anon_sym_long] = ACTIONS(2296),
    [anon_sym_short] = ACTIONS(2296),
    [anon_sym_LBRACK] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_register] = ACTIONS(2296),
    [anon_sym_inline] = ACTIONS(2296),
    [anon_sym___inline] = ACTIONS(2296),
    [anon_sym___inline__] = ACTIONS(2296),
    [anon_sym___forceinline] = ACTIONS(2296),
    [anon_sym_thread_local] = ACTIONS(2296),
    [anon_sym___thread] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_constexpr] = ACTIONS(2296),
    [anon_sym_volatile] = ACTIONS(2296),
    [anon_sym_restrict] = ACTIONS(2296),
    [anon_sym___restrict__] = ACTIONS(2296),
    [anon_sym__Atomic] = ACTIONS(2296),
    [anon_sym__Noreturn] = ACTIONS(2296),
    [anon_sym_noreturn] = ACTIONS(2296),
    [anon_sym_mutable] = ACTIONS(2296),
    [anon_sym_constinit] = ACTIONS(2296),
    [anon_sym_consteval] = ACTIONS(2296),
    [anon_sym___shared__] = ACTIONS(2296),
    [anon_sym___local__] = ACTIONS(2296),
    [anon_sym___constant__] = ACTIONS(2296),
    [anon_sym___managed__] = ACTIONS(2296),
    [anon_sym___grid_constant__] = ACTIONS(2296),
    [anon_sym_alignas] = ACTIONS(2296),
    [anon_sym__Alignas] = ACTIONS(2296),
    [sym_primitive_type] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2296),
    [anon_sym_class] = ACTIONS(2296),
    [anon_sym_struct] = ACTIONS(2296),
    [anon_sym_union] = ACTIONS(2296),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2296),
    [anon_sym_decltype] = ACTIONS(2296),
    [sym_virtual] = ACTIONS(2296),
    [anon_sym_explicit] = ACTIONS(2296),
    [anon_sym_typename] = ACTIONS(2296),
    [anon_sym_template] = ACTIONS(2296),
    [anon_sym_operator] = ACTIONS(2296),
    [anon_sym_friend] = ACTIONS(2296),
    [anon_sym_public] = ACTIONS(2296),
    [anon_sym_private] = ACTIONS(2296),
    [anon_sym_protected] = ACTIONS(2296),
    [anon_sym_using] = ACTIONS(2296),
    [anon_sym_static_assert] = ACTIONS(2296),
    [anon_sym___launch_bounds__] = ACTIONS(2296),
  },
  [2083] = {
    [sym_identifier] = ACTIONS(2300),
    [aux_sym_preproc_def_token1] = ACTIONS(2300),
    [aux_sym_preproc_if_token1] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2300),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2300),
    [sym_preproc_directive] = ACTIONS(2300),
    [anon_sym_LPAREN2] = ACTIONS(2302),
    [anon_sym_TILDE] = ACTIONS(2302),
    [anon_sym_STAR] = ACTIONS(2302),
    [anon_sym_AMP_AMP] = ACTIONS(2302),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym___extension__] = ACTIONS(2300),
    [anon_sym_typedef] = ACTIONS(2300),
    [anon_sym___device__] = ACTIONS(2300),
    [anon_sym___host__] = ACTIONS(2300),
    [anon_sym___global__] = ACTIONS(2300),
    [anon_sym___forceinline__] = ACTIONS(2300),
    [anon_sym___noinline__] = ACTIONS(2300),
    [anon_sym_extern] = ACTIONS(2300),
    [anon_sym___attribute__] = ACTIONS(2300),
    [anon_sym_COLON_COLON] = ACTIONS(2302),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2302),
    [anon_sym___declspec] = ACTIONS(2300),
    [anon_sym___based] = ACTIONS(2300),
    [anon_sym_RBRACE] = ACTIONS(2302),
    [anon_sym_signed] = ACTIONS(2300),
    [anon_sym_unsigned] = ACTIONS(2300),
    [anon_sym_long] = ACTIONS(2300),
    [anon_sym_short] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_register] = ACTIONS(2300),
    [anon_sym_inline] = ACTIONS(2300),
    [anon_sym___inline] = ACTIONS(2300),
    [anon_sym___inline__] = ACTIONS(2300),
    [anon_sym___forceinline] = ACTIONS(2300),
    [anon_sym_thread_local] = ACTIONS(2300),
    [anon_sym___thread] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_constexpr] = ACTIONS(2300),
    [anon_sym_volatile] = ACTIONS(2300),
    [anon_sym_restrict] = ACTIONS(2300),
    [anon_sym___restrict__] = ACTIONS(2300),
    [anon_sym__Atomic] = ACTIONS(2300),
    [anon_sym__Noreturn] = ACTIONS(2300),
    [anon_sym_noreturn] = ACTIONS(2300),
    [anon_sym_mutable] = ACTIONS(2300),
    [anon_sym_constinit] = ACTIONS(2300),
    [anon_sym_consteval] = ACTIONS(2300),
    [anon_sym___shared__] = ACTIONS(2300),
    [anon_sym___local__] = ACTIONS(2300),
    [anon_sym___constant__] = ACTIONS(2300),
    [anon_sym___managed__] = ACTIONS(2300),
    [anon_sym___grid_constant__] = ACTIONS(2300),
    [anon_sym_alignas] = ACTIONS(2300),
    [anon_sym__Alignas] = ACTIONS(2300),
    [sym_primitive_type] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_struct] = ACTIONS(2300),
    [anon_sym_union] = ACTIONS(2300),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2300),
    [anon_sym_decltype] = ACTIONS(2300),
    [sym_virtual] = ACTIONS(2300),
    [anon_sym_explicit] = ACTIONS(2300),
    [anon_sym_typename] = ACTIONS(2300),
    [anon_sym_template] = ACTIONS(2300),
    [anon_sym_operator] = ACTIONS(2300),
    [anon_sym_friend] = ACTIONS(2300),
    [anon_sym_public] = ACTIONS(2300),
    [anon_sym_private] = ACTIONS(2300),
    [anon_sym_protected] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_static_assert] = ACTIONS(2300),
    [anon_sym___launch_bounds__] = ACTIONS(2300),
  },
  [2084] = {
    [sym_identifier] = ACTIONS(2304),
    [aux_sym_preproc_def_token1] = ACTIONS(2304),
    [aux_sym_preproc_if_token1] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2304),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2304),
    [sym_preproc_directive] = ACTIONS(2304),
    [anon_sym_LPAREN2] = ACTIONS(2306),
    [anon_sym_TILDE] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(2306),
    [anon_sym_AMP_AMP] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym___extension__] = ACTIONS(2304),
    [anon_sym_typedef] = ACTIONS(2304),
    [anon_sym___device__] = ACTIONS(2304),
    [anon_sym___host__] = ACTIONS(2304),
    [anon_sym___global__] = ACTIONS(2304),
    [anon_sym___forceinline__] = ACTIONS(2304),
    [anon_sym___noinline__] = ACTIONS(2304),
    [anon_sym_extern] = ACTIONS(2304),
    [anon_sym___attribute__] = ACTIONS(2304),
    [anon_sym_COLON_COLON] = ACTIONS(2306),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2306),
    [anon_sym___declspec] = ACTIONS(2304),
    [anon_sym___based] = ACTIONS(2304),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [anon_sym_signed] = ACTIONS(2304),
    [anon_sym_unsigned] = ACTIONS(2304),
    [anon_sym_long] = ACTIONS(2304),
    [anon_sym_short] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_register] = ACTIONS(2304),
    [anon_sym_inline] = ACTIONS(2304),
    [anon_sym___inline] = ACTIONS(2304),
    [anon_sym___inline__] = ACTIONS(2304),
    [anon_sym___forceinline] = ACTIONS(2304),
    [anon_sym_thread_local] = ACTIONS(2304),
    [anon_sym___thread] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_constexpr] = ACTIONS(2304),
    [anon_sym_volatile] = ACTIONS(2304),
    [anon_sym_restrict] = ACTIONS(2304),
    [anon_sym___restrict__] = ACTIONS(2304),
    [anon_sym__Atomic] = ACTIONS(2304),
    [anon_sym__Noreturn] = ACTIONS(2304),
    [anon_sym_noreturn] = ACTIONS(2304),
    [anon_sym_mutable] = ACTIONS(2304),
    [anon_sym_constinit] = ACTIONS(2304),
    [anon_sym_consteval] = ACTIONS(2304),
    [anon_sym___shared__] = ACTIONS(2304),
    [anon_sym___local__] = ACTIONS(2304),
    [anon_sym___constant__] = ACTIONS(2304),
    [anon_sym___managed__] = ACTIONS(2304),
    [anon_sym___grid_constant__] = ACTIONS(2304),
    [anon_sym_alignas] = ACTIONS(2304),
    [anon_sym__Alignas] = ACTIONS(2304),
    [sym_primitive_type] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_struct] = ACTIONS(2304),
    [anon_sym_union] = ACTIONS(2304),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2304),
    [anon_sym_decltype] = ACTIONS(2304),
    [sym_virtual] = ACTIONS(2304),
    [anon_sym_explicit] = ACTIONS(2304),
    [anon_sym_typename] = ACTIONS(2304),
    [anon_sym_template] = ACTIONS(2304),
    [anon_sym_operator] = ACTIONS(2304),
    [anon_sym_friend] = ACTIONS(2304),
    [anon_sym_public] = ACTIONS(2304),
    [anon_sym_private] = ACTIONS(2304),
    [anon_sym_protected] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_static_assert] = ACTIONS(2304),
    [anon_sym___launch_bounds__] = ACTIONS(2304),
  },
  [2085] = {
    [sym_identifier] = ACTIONS(5354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5356),
    [anon_sym_COMMA] = ACTIONS(5356),
    [anon_sym_RPAREN] = ACTIONS(5356),
    [anon_sym_LPAREN2] = ACTIONS(5356),
    [anon_sym_DASH] = ACTIONS(5354),
    [anon_sym_PLUS] = ACTIONS(5354),
    [anon_sym_STAR] = ACTIONS(5356),
    [anon_sym_SLASH] = ACTIONS(5354),
    [anon_sym_PERCENT] = ACTIONS(5356),
    [anon_sym_PIPE_PIPE] = ACTIONS(5356),
    [anon_sym_AMP_AMP] = ACTIONS(5356),
    [anon_sym_PIPE] = ACTIONS(5354),
    [anon_sym_CARET] = ACTIONS(5356),
    [anon_sym_AMP] = ACTIONS(5354),
    [anon_sym_EQ_EQ] = ACTIONS(5356),
    [anon_sym_BANG_EQ] = ACTIONS(5356),
    [anon_sym_GT] = ACTIONS(5354),
    [anon_sym_GT_EQ] = ACTIONS(5356),
    [anon_sym_LT_EQ] = ACTIONS(5354),
    [anon_sym_LT] = ACTIONS(5354),
    [anon_sym_LT_LT] = ACTIONS(5354),
    [anon_sym_GT_GT] = ACTIONS(5356),
    [anon_sym_SEMI] = ACTIONS(5356),
    [anon_sym___extension__] = ACTIONS(5354),
    [anon_sym___global__] = ACTIONS(5354),
    [anon_sym___attribute__] = ACTIONS(5354),
    [anon_sym___based] = ACTIONS(5354),
    [anon_sym_LBRACE] = ACTIONS(5356),
    [anon_sym_RBRACE] = ACTIONS(5356),
    [anon_sym_signed] = ACTIONS(5354),
    [anon_sym_unsigned] = ACTIONS(5354),
    [anon_sym_long] = ACTIONS(5354),
    [anon_sym_short] = ACTIONS(5354),
    [anon_sym_LBRACK] = ACTIONS(5356),
    [anon_sym_RBRACK] = ACTIONS(5356),
    [anon_sym_const] = ACTIONS(5354),
    [anon_sym_constexpr] = ACTIONS(5354),
    [anon_sym_volatile] = ACTIONS(5354),
    [anon_sym_restrict] = ACTIONS(5354),
    [anon_sym___restrict__] = ACTIONS(5354),
    [anon_sym__Atomic] = ACTIONS(5354),
    [anon_sym__Noreturn] = ACTIONS(5354),
    [anon_sym_noreturn] = ACTIONS(5354),
    [anon_sym_mutable] = ACTIONS(5354),
    [anon_sym_constinit] = ACTIONS(5354),
    [anon_sym_consteval] = ACTIONS(5354),
    [anon_sym___shared__] = ACTIONS(5354),
    [anon_sym___local__] = ACTIONS(5354),
    [anon_sym___constant__] = ACTIONS(5354),
    [anon_sym___managed__] = ACTIONS(5354),
    [anon_sym___grid_constant__] = ACTIONS(5354),
    [anon_sym_alignas] = ACTIONS(5354),
    [anon_sym__Alignas] = ACTIONS(5354),
    [sym_primitive_type] = ACTIONS(5354),
    [anon_sym_COLON] = ACTIONS(5356),
    [anon_sym_QMARK] = ACTIONS(5356),
    [anon_sym_LT_EQ_GT] = ACTIONS(5356),
    [anon_sym_or] = ACTIONS(5354),
    [anon_sym_and] = ACTIONS(5354),
    [anon_sym_bitor] = ACTIONS(5354),
    [anon_sym_xor] = ACTIONS(5354),
    [anon_sym_bitand] = ACTIONS(5354),
    [anon_sym_not_eq] = ACTIONS(5354),
    [anon_sym_DASH_DASH] = ACTIONS(5356),
    [anon_sym_PLUS_PLUS] = ACTIONS(5356),
    [anon_sym_DOT] = ACTIONS(5354),
    [anon_sym_DOT_STAR] = ACTIONS(5356),
    [anon_sym_DASH_GT] = ACTIONS(5356),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5354),
    [anon_sym_decltype] = ACTIONS(5354),
    [anon_sym_final] = ACTIONS(5354),
    [anon_sym_override] = ACTIONS(5354),
    [anon_sym_requires] = ACTIONS(5354),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5356),
  },
  [2086] = {
    [sym_identifier] = ACTIONS(5358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5360),
    [anon_sym_COMMA] = ACTIONS(5360),
    [anon_sym_RPAREN] = ACTIONS(5360),
    [anon_sym_LPAREN2] = ACTIONS(5360),
    [anon_sym_DASH] = ACTIONS(5358),
    [anon_sym_PLUS] = ACTIONS(5358),
    [anon_sym_STAR] = ACTIONS(5360),
    [anon_sym_SLASH] = ACTIONS(5358),
    [anon_sym_PERCENT] = ACTIONS(5360),
    [anon_sym_PIPE_PIPE] = ACTIONS(5360),
    [anon_sym_AMP_AMP] = ACTIONS(5360),
    [anon_sym_PIPE] = ACTIONS(5358),
    [anon_sym_CARET] = ACTIONS(5360),
    [anon_sym_AMP] = ACTIONS(5358),
    [anon_sym_EQ_EQ] = ACTIONS(5360),
    [anon_sym_BANG_EQ] = ACTIONS(5360),
    [anon_sym_GT] = ACTIONS(5358),
    [anon_sym_GT_EQ] = ACTIONS(5360),
    [anon_sym_LT_EQ] = ACTIONS(5358),
    [anon_sym_LT] = ACTIONS(5358),
    [anon_sym_LT_LT] = ACTIONS(5358),
    [anon_sym_GT_GT] = ACTIONS(5360),
    [anon_sym_SEMI] = ACTIONS(5360),
    [anon_sym___extension__] = ACTIONS(5358),
    [anon_sym___global__] = ACTIONS(5358),
    [anon_sym___attribute__] = ACTIONS(5358),
    [anon_sym___based] = ACTIONS(5358),
    [anon_sym_LBRACE] = ACTIONS(5360),
    [anon_sym_RBRACE] = ACTIONS(5360),
    [anon_sym_signed] = ACTIONS(5358),
    [anon_sym_unsigned] = ACTIONS(5358),
    [anon_sym_long] = ACTIONS(5358),
    [anon_sym_short] = ACTIONS(5358),
    [anon_sym_LBRACK] = ACTIONS(5360),
    [anon_sym_RBRACK] = ACTIONS(5360),
    [anon_sym_const] = ACTIONS(5358),
    [anon_sym_constexpr] = ACTIONS(5358),
    [anon_sym_volatile] = ACTIONS(5358),
    [anon_sym_restrict] = ACTIONS(5358),
    [anon_sym___restrict__] = ACTIONS(5358),
    [anon_sym__Atomic] = ACTIONS(5358),
    [anon_sym__Noreturn] = ACTIONS(5358),
    [anon_sym_noreturn] = ACTIONS(5358),
    [anon_sym_mutable] = ACTIONS(5358),
    [anon_sym_constinit] = ACTIONS(5358),
    [anon_sym_consteval] = ACTIONS(5358),
    [anon_sym___shared__] = ACTIONS(5358),
    [anon_sym___local__] = ACTIONS(5358),
    [anon_sym___constant__] = ACTIONS(5358),
    [anon_sym___managed__] = ACTIONS(5358),
    [anon_sym___grid_constant__] = ACTIONS(5358),
    [anon_sym_alignas] = ACTIONS(5358),
    [anon_sym__Alignas] = ACTIONS(5358),
    [sym_primitive_type] = ACTIONS(5358),
    [anon_sym_COLON] = ACTIONS(5360),
    [anon_sym_QMARK] = ACTIONS(5360),
    [anon_sym_LT_EQ_GT] = ACTIONS(5360),
    [anon_sym_or] = ACTIONS(5358),
    [anon_sym_and] = ACTIONS(5358),
    [anon_sym_bitor] = ACTIONS(5358),
    [anon_sym_xor] = ACTIONS(5358),
    [anon_sym_bitand] = ACTIONS(5358),
    [anon_sym_not_eq] = ACTIONS(5358),
    [anon_sym_DASH_DASH] = ACTIONS(5360),
    [anon_sym_PLUS_PLUS] = ACTIONS(5360),
    [anon_sym_DOT] = ACTIONS(5358),
    [anon_sym_DOT_STAR] = ACTIONS(5360),
    [anon_sym_DASH_GT] = ACTIONS(5360),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5358),
    [anon_sym_decltype] = ACTIONS(5358),
    [anon_sym_final] = ACTIONS(5358),
    [anon_sym_override] = ACTIONS(5358),
    [anon_sym_requires] = ACTIONS(5358),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5360),
  },
  [2087] = {
    [sym_identifier] = ACTIONS(5362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5364),
    [anon_sym_COMMA] = ACTIONS(5364),
    [anon_sym_RPAREN] = ACTIONS(5364),
    [anon_sym_LPAREN2] = ACTIONS(5364),
    [anon_sym_DASH] = ACTIONS(5362),
    [anon_sym_PLUS] = ACTIONS(5362),
    [anon_sym_STAR] = ACTIONS(5364),
    [anon_sym_SLASH] = ACTIONS(5362),
    [anon_sym_PERCENT] = ACTIONS(5364),
    [anon_sym_PIPE_PIPE] = ACTIONS(5364),
    [anon_sym_AMP_AMP] = ACTIONS(5364),
    [anon_sym_PIPE] = ACTIONS(5362),
    [anon_sym_CARET] = ACTIONS(5364),
    [anon_sym_AMP] = ACTIONS(5362),
    [anon_sym_EQ_EQ] = ACTIONS(5364),
    [anon_sym_BANG_EQ] = ACTIONS(5364),
    [anon_sym_GT] = ACTIONS(5362),
    [anon_sym_GT_EQ] = ACTIONS(5364),
    [anon_sym_LT_EQ] = ACTIONS(5362),
    [anon_sym_LT] = ACTIONS(5362),
    [anon_sym_LT_LT] = ACTIONS(5362),
    [anon_sym_GT_GT] = ACTIONS(5364),
    [anon_sym_SEMI] = ACTIONS(5364),
    [anon_sym___extension__] = ACTIONS(5362),
    [anon_sym___global__] = ACTIONS(5362),
    [anon_sym___attribute__] = ACTIONS(5362),
    [anon_sym___based] = ACTIONS(5362),
    [anon_sym_LBRACE] = ACTIONS(5364),
    [anon_sym_RBRACE] = ACTIONS(5364),
    [anon_sym_signed] = ACTIONS(5362),
    [anon_sym_unsigned] = ACTIONS(5362),
    [anon_sym_long] = ACTIONS(5362),
    [anon_sym_short] = ACTIONS(5362),
    [anon_sym_LBRACK] = ACTIONS(5364),
    [anon_sym_RBRACK] = ACTIONS(5364),
    [anon_sym_const] = ACTIONS(5362),
    [anon_sym_constexpr] = ACTIONS(5362),
    [anon_sym_volatile] = ACTIONS(5362),
    [anon_sym_restrict] = ACTIONS(5362),
    [anon_sym___restrict__] = ACTIONS(5362),
    [anon_sym__Atomic] = ACTIONS(5362),
    [anon_sym__Noreturn] = ACTIONS(5362),
    [anon_sym_noreturn] = ACTIONS(5362),
    [anon_sym_mutable] = ACTIONS(5362),
    [anon_sym_constinit] = ACTIONS(5362),
    [anon_sym_consteval] = ACTIONS(5362),
    [anon_sym___shared__] = ACTIONS(5362),
    [anon_sym___local__] = ACTIONS(5362),
    [anon_sym___constant__] = ACTIONS(5362),
    [anon_sym___managed__] = ACTIONS(5362),
    [anon_sym___grid_constant__] = ACTIONS(5362),
    [anon_sym_alignas] = ACTIONS(5362),
    [anon_sym__Alignas] = ACTIONS(5362),
    [sym_primitive_type] = ACTIONS(5362),
    [anon_sym_COLON] = ACTIONS(5364),
    [anon_sym_QMARK] = ACTIONS(5364),
    [anon_sym_LT_EQ_GT] = ACTIONS(5364),
    [anon_sym_or] = ACTIONS(5362),
    [anon_sym_and] = ACTIONS(5362),
    [anon_sym_bitor] = ACTIONS(5362),
    [anon_sym_xor] = ACTIONS(5362),
    [anon_sym_bitand] = ACTIONS(5362),
    [anon_sym_not_eq] = ACTIONS(5362),
    [anon_sym_DASH_DASH] = ACTIONS(5364),
    [anon_sym_PLUS_PLUS] = ACTIONS(5364),
    [anon_sym_DOT] = ACTIONS(5362),
    [anon_sym_DOT_STAR] = ACTIONS(5364),
    [anon_sym_DASH_GT] = ACTIONS(5364),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5362),
    [anon_sym_decltype] = ACTIONS(5362),
    [anon_sym_final] = ACTIONS(5362),
    [anon_sym_override] = ACTIONS(5362),
    [anon_sym_requires] = ACTIONS(5362),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5364),
  },
  [2088] = {
    [sym_identifier] = ACTIONS(5366),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5368),
    [anon_sym_COMMA] = ACTIONS(5368),
    [anon_sym_RPAREN] = ACTIONS(5368),
    [anon_sym_LPAREN2] = ACTIONS(5368),
    [anon_sym_DASH] = ACTIONS(5366),
    [anon_sym_PLUS] = ACTIONS(5366),
    [anon_sym_STAR] = ACTIONS(5368),
    [anon_sym_SLASH] = ACTIONS(5366),
    [anon_sym_PERCENT] = ACTIONS(5368),
    [anon_sym_PIPE_PIPE] = ACTIONS(5368),
    [anon_sym_AMP_AMP] = ACTIONS(5368),
    [anon_sym_PIPE] = ACTIONS(5366),
    [anon_sym_CARET] = ACTIONS(5368),
    [anon_sym_AMP] = ACTIONS(5366),
    [anon_sym_EQ_EQ] = ACTIONS(5368),
    [anon_sym_BANG_EQ] = ACTIONS(5368),
    [anon_sym_GT] = ACTIONS(5366),
    [anon_sym_GT_EQ] = ACTIONS(5368),
    [anon_sym_LT_EQ] = ACTIONS(5366),
    [anon_sym_LT] = ACTIONS(5366),
    [anon_sym_LT_LT] = ACTIONS(5366),
    [anon_sym_GT_GT] = ACTIONS(5368),
    [anon_sym_SEMI] = ACTIONS(5368),
    [anon_sym___extension__] = ACTIONS(5366),
    [anon_sym___global__] = ACTIONS(5366),
    [anon_sym___attribute__] = ACTIONS(5366),
    [anon_sym___based] = ACTIONS(5366),
    [anon_sym_LBRACE] = ACTIONS(5368),
    [anon_sym_RBRACE] = ACTIONS(5368),
    [anon_sym_signed] = ACTIONS(5366),
    [anon_sym_unsigned] = ACTIONS(5366),
    [anon_sym_long] = ACTIONS(5366),
    [anon_sym_short] = ACTIONS(5366),
    [anon_sym_LBRACK] = ACTIONS(5368),
    [anon_sym_RBRACK] = ACTIONS(5368),
    [anon_sym_const] = ACTIONS(5366),
    [anon_sym_constexpr] = ACTIONS(5366),
    [anon_sym_volatile] = ACTIONS(5366),
    [anon_sym_restrict] = ACTIONS(5366),
    [anon_sym___restrict__] = ACTIONS(5366),
    [anon_sym__Atomic] = ACTIONS(5366),
    [anon_sym__Noreturn] = ACTIONS(5366),
    [anon_sym_noreturn] = ACTIONS(5366),
    [anon_sym_mutable] = ACTIONS(5366),
    [anon_sym_constinit] = ACTIONS(5366),
    [anon_sym_consteval] = ACTIONS(5366),
    [anon_sym___shared__] = ACTIONS(5366),
    [anon_sym___local__] = ACTIONS(5366),
    [anon_sym___constant__] = ACTIONS(5366),
    [anon_sym___managed__] = ACTIONS(5366),
    [anon_sym___grid_constant__] = ACTIONS(5366),
    [anon_sym_alignas] = ACTIONS(5366),
    [anon_sym__Alignas] = ACTIONS(5366),
    [sym_primitive_type] = ACTIONS(5366),
    [anon_sym_COLON] = ACTIONS(5368),
    [anon_sym_QMARK] = ACTIONS(5368),
    [anon_sym_LT_EQ_GT] = ACTIONS(5368),
    [anon_sym_or] = ACTIONS(5366),
    [anon_sym_and] = ACTIONS(5366),
    [anon_sym_bitor] = ACTIONS(5366),
    [anon_sym_xor] = ACTIONS(5366),
    [anon_sym_bitand] = ACTIONS(5366),
    [anon_sym_not_eq] = ACTIONS(5366),
    [anon_sym_DASH_DASH] = ACTIONS(5368),
    [anon_sym_PLUS_PLUS] = ACTIONS(5368),
    [anon_sym_DOT] = ACTIONS(5366),
    [anon_sym_DOT_STAR] = ACTIONS(5368),
    [anon_sym_DASH_GT] = ACTIONS(5368),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5366),
    [anon_sym_decltype] = ACTIONS(5366),
    [anon_sym_final] = ACTIONS(5366),
    [anon_sym_override] = ACTIONS(5366),
    [anon_sym_requires] = ACTIONS(5366),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5368),
  },
  [2089] = {
    [sym_identifier] = ACTIONS(2384),
    [aux_sym_preproc_def_token1] = ACTIONS(2384),
    [aux_sym_preproc_if_token1] = ACTIONS(2384),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2384),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2384),
    [sym_preproc_directive] = ACTIONS(2384),
    [anon_sym_LPAREN2] = ACTIONS(2386),
    [anon_sym_TILDE] = ACTIONS(2386),
    [anon_sym_STAR] = ACTIONS(2386),
    [anon_sym_AMP_AMP] = ACTIONS(2386),
    [anon_sym_AMP] = ACTIONS(2384),
    [anon_sym___extension__] = ACTIONS(2384),
    [anon_sym_typedef] = ACTIONS(2384),
    [anon_sym___device__] = ACTIONS(2384),
    [anon_sym___host__] = ACTIONS(2384),
    [anon_sym___global__] = ACTIONS(2384),
    [anon_sym___forceinline__] = ACTIONS(2384),
    [anon_sym___noinline__] = ACTIONS(2384),
    [anon_sym_extern] = ACTIONS(2384),
    [anon_sym___attribute__] = ACTIONS(2384),
    [anon_sym_COLON_COLON] = ACTIONS(2386),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2386),
    [anon_sym___declspec] = ACTIONS(2384),
    [anon_sym___based] = ACTIONS(2384),
    [anon_sym_RBRACE] = ACTIONS(2386),
    [anon_sym_signed] = ACTIONS(2384),
    [anon_sym_unsigned] = ACTIONS(2384),
    [anon_sym_long] = ACTIONS(2384),
    [anon_sym_short] = ACTIONS(2384),
    [anon_sym_LBRACK] = ACTIONS(2384),
    [anon_sym_static] = ACTIONS(2384),
    [anon_sym_register] = ACTIONS(2384),
    [anon_sym_inline] = ACTIONS(2384),
    [anon_sym___inline] = ACTIONS(2384),
    [anon_sym___inline__] = ACTIONS(2384),
    [anon_sym___forceinline] = ACTIONS(2384),
    [anon_sym_thread_local] = ACTIONS(2384),
    [anon_sym___thread] = ACTIONS(2384),
    [anon_sym_const] = ACTIONS(2384),
    [anon_sym_constexpr] = ACTIONS(2384),
    [anon_sym_volatile] = ACTIONS(2384),
    [anon_sym_restrict] = ACTIONS(2384),
    [anon_sym___restrict__] = ACTIONS(2384),
    [anon_sym__Atomic] = ACTIONS(2384),
    [anon_sym__Noreturn] = ACTIONS(2384),
    [anon_sym_noreturn] = ACTIONS(2384),
    [anon_sym_mutable] = ACTIONS(2384),
    [anon_sym_constinit] = ACTIONS(2384),
    [anon_sym_consteval] = ACTIONS(2384),
    [anon_sym___shared__] = ACTIONS(2384),
    [anon_sym___local__] = ACTIONS(2384),
    [anon_sym___constant__] = ACTIONS(2384),
    [anon_sym___managed__] = ACTIONS(2384),
    [anon_sym___grid_constant__] = ACTIONS(2384),
    [anon_sym_alignas] = ACTIONS(2384),
    [anon_sym__Alignas] = ACTIONS(2384),
    [sym_primitive_type] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2384),
    [anon_sym_class] = ACTIONS(2384),
    [anon_sym_struct] = ACTIONS(2384),
    [anon_sym_union] = ACTIONS(2384),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2384),
    [anon_sym_decltype] = ACTIONS(2384),
    [sym_virtual] = ACTIONS(2384),
    [anon_sym_explicit] = ACTIONS(2384),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(2384),
    [anon_sym_operator] = ACTIONS(2384),
    [anon_sym_friend] = ACTIONS(2384),
    [anon_sym_public] = ACTIONS(2384),
    [anon_sym_private] = ACTIONS(2384),
    [anon_sym_protected] = ACTIONS(2384),
    [anon_sym_using] = ACTIONS(2384),
    [anon_sym_static_assert] = ACTIONS(2384),
    [anon_sym___launch_bounds__] = ACTIONS(2384),
  },
  [2090] = {
    [sym_identifier] = ACTIONS(1950),
    [aux_sym_preproc_def_token1] = ACTIONS(1950),
    [aux_sym_preproc_if_token1] = ACTIONS(1950),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1950),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1950),
    [sym_preproc_directive] = ACTIONS(1950),
    [anon_sym_LPAREN2] = ACTIONS(1952),
    [anon_sym_TILDE] = ACTIONS(1952),
    [anon_sym_STAR] = ACTIONS(1952),
    [anon_sym_AMP_AMP] = ACTIONS(1952),
    [anon_sym_AMP] = ACTIONS(1950),
    [anon_sym___extension__] = ACTIONS(1950),
    [anon_sym_typedef] = ACTIONS(1950),
    [anon_sym___device__] = ACTIONS(1950),
    [anon_sym___host__] = ACTIONS(1950),
    [anon_sym___global__] = ACTIONS(1950),
    [anon_sym___forceinline__] = ACTIONS(1950),
    [anon_sym___noinline__] = ACTIONS(1950),
    [anon_sym_extern] = ACTIONS(1950),
    [anon_sym___attribute__] = ACTIONS(1950),
    [anon_sym_COLON_COLON] = ACTIONS(1952),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1952),
    [anon_sym___declspec] = ACTIONS(1950),
    [anon_sym___based] = ACTIONS(1950),
    [anon_sym_RBRACE] = ACTIONS(1952),
    [anon_sym_signed] = ACTIONS(1950),
    [anon_sym_unsigned] = ACTIONS(1950),
    [anon_sym_long] = ACTIONS(1950),
    [anon_sym_short] = ACTIONS(1950),
    [anon_sym_LBRACK] = ACTIONS(1950),
    [anon_sym_static] = ACTIONS(1950),
    [anon_sym_register] = ACTIONS(1950),
    [anon_sym_inline] = ACTIONS(1950),
    [anon_sym___inline] = ACTIONS(1950),
    [anon_sym___inline__] = ACTIONS(1950),
    [anon_sym___forceinline] = ACTIONS(1950),
    [anon_sym_thread_local] = ACTIONS(1950),
    [anon_sym___thread] = ACTIONS(1950),
    [anon_sym_const] = ACTIONS(1950),
    [anon_sym_constexpr] = ACTIONS(1950),
    [anon_sym_volatile] = ACTIONS(1950),
    [anon_sym_restrict] = ACTIONS(1950),
    [anon_sym___restrict__] = ACTIONS(1950),
    [anon_sym__Atomic] = ACTIONS(1950),
    [anon_sym__Noreturn] = ACTIONS(1950),
    [anon_sym_noreturn] = ACTIONS(1950),
    [anon_sym_mutable] = ACTIONS(1950),
    [anon_sym_constinit] = ACTIONS(1950),
    [anon_sym_consteval] = ACTIONS(1950),
    [anon_sym___shared__] = ACTIONS(1950),
    [anon_sym___local__] = ACTIONS(1950),
    [anon_sym___constant__] = ACTIONS(1950),
    [anon_sym___managed__] = ACTIONS(1950),
    [anon_sym___grid_constant__] = ACTIONS(1950),
    [anon_sym_alignas] = ACTIONS(1950),
    [anon_sym__Alignas] = ACTIONS(1950),
    [sym_primitive_type] = ACTIONS(1950),
    [anon_sym_enum] = ACTIONS(1950),
    [anon_sym_class] = ACTIONS(1950),
    [anon_sym_struct] = ACTIONS(1950),
    [anon_sym_union] = ACTIONS(1950),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1950),
    [anon_sym_decltype] = ACTIONS(1950),
    [sym_virtual] = ACTIONS(1950),
    [anon_sym_explicit] = ACTIONS(1950),
    [anon_sym_typename] = ACTIONS(1950),
    [anon_sym_template] = ACTIONS(1950),
    [anon_sym_operator] = ACTIONS(1950),
    [anon_sym_friend] = ACTIONS(1950),
    [anon_sym_public] = ACTIONS(1950),
    [anon_sym_private] = ACTIONS(1950),
    [anon_sym_protected] = ACTIONS(1950),
    [anon_sym_using] = ACTIONS(1950),
    [anon_sym_static_assert] = ACTIONS(1950),
    [anon_sym___launch_bounds__] = ACTIONS(1950),
  },
  [2091] = {
    [sym_identifier] = ACTIONS(5370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5372),
    [anon_sym_COMMA] = ACTIONS(5372),
    [anon_sym_RPAREN] = ACTIONS(5372),
    [anon_sym_LPAREN2] = ACTIONS(5372),
    [anon_sym_DASH] = ACTIONS(5370),
    [anon_sym_PLUS] = ACTIONS(5370),
    [anon_sym_STAR] = ACTIONS(5372),
    [anon_sym_SLASH] = ACTIONS(5370),
    [anon_sym_PERCENT] = ACTIONS(5372),
    [anon_sym_PIPE_PIPE] = ACTIONS(5372),
    [anon_sym_AMP_AMP] = ACTIONS(5372),
    [anon_sym_PIPE] = ACTIONS(5370),
    [anon_sym_CARET] = ACTIONS(5372),
    [anon_sym_AMP] = ACTIONS(5370),
    [anon_sym_EQ_EQ] = ACTIONS(5372),
    [anon_sym_BANG_EQ] = ACTIONS(5372),
    [anon_sym_GT] = ACTIONS(5370),
    [anon_sym_GT_EQ] = ACTIONS(5372),
    [anon_sym_LT_EQ] = ACTIONS(5370),
    [anon_sym_LT] = ACTIONS(5370),
    [anon_sym_LT_LT] = ACTIONS(5370),
    [anon_sym_GT_GT] = ACTIONS(5372),
    [anon_sym_SEMI] = ACTIONS(5372),
    [anon_sym___extension__] = ACTIONS(5370),
    [anon_sym___global__] = ACTIONS(5370),
    [anon_sym___attribute__] = ACTIONS(5370),
    [anon_sym___based] = ACTIONS(5370),
    [anon_sym_LBRACE] = ACTIONS(5372),
    [anon_sym_RBRACE] = ACTIONS(5372),
    [anon_sym_signed] = ACTIONS(5370),
    [anon_sym_unsigned] = ACTIONS(5370),
    [anon_sym_long] = ACTIONS(5370),
    [anon_sym_short] = ACTIONS(5370),
    [anon_sym_LBRACK] = ACTIONS(5372),
    [anon_sym_RBRACK] = ACTIONS(5372),
    [anon_sym_const] = ACTIONS(5370),
    [anon_sym_constexpr] = ACTIONS(5370),
    [anon_sym_volatile] = ACTIONS(5370),
    [anon_sym_restrict] = ACTIONS(5370),
    [anon_sym___restrict__] = ACTIONS(5370),
    [anon_sym__Atomic] = ACTIONS(5370),
    [anon_sym__Noreturn] = ACTIONS(5370),
    [anon_sym_noreturn] = ACTIONS(5370),
    [anon_sym_mutable] = ACTIONS(5370),
    [anon_sym_constinit] = ACTIONS(5370),
    [anon_sym_consteval] = ACTIONS(5370),
    [anon_sym___shared__] = ACTIONS(5370),
    [anon_sym___local__] = ACTIONS(5370),
    [anon_sym___constant__] = ACTIONS(5370),
    [anon_sym___managed__] = ACTIONS(5370),
    [anon_sym___grid_constant__] = ACTIONS(5370),
    [anon_sym_alignas] = ACTIONS(5370),
    [anon_sym__Alignas] = ACTIONS(5370),
    [sym_primitive_type] = ACTIONS(5370),
    [anon_sym_COLON] = ACTIONS(5372),
    [anon_sym_QMARK] = ACTIONS(5372),
    [anon_sym_LT_EQ_GT] = ACTIONS(5372),
    [anon_sym_or] = ACTIONS(5370),
    [anon_sym_and] = ACTIONS(5370),
    [anon_sym_bitor] = ACTIONS(5370),
    [anon_sym_xor] = ACTIONS(5370),
    [anon_sym_bitand] = ACTIONS(5370),
    [anon_sym_not_eq] = ACTIONS(5370),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_DOT] = ACTIONS(5370),
    [anon_sym_DOT_STAR] = ACTIONS(5372),
    [anon_sym_DASH_GT] = ACTIONS(5372),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5370),
    [anon_sym_decltype] = ACTIONS(5370),
    [anon_sym_final] = ACTIONS(5370),
    [anon_sym_override] = ACTIONS(5370),
    [anon_sym_requires] = ACTIONS(5370),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5372),
  },
  [2092] = {
    [sym_identifier] = ACTIONS(2384),
    [aux_sym_preproc_def_token1] = ACTIONS(2384),
    [aux_sym_preproc_if_token1] = ACTIONS(2384),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2384),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2384),
    [sym_preproc_directive] = ACTIONS(2384),
    [anon_sym_LPAREN2] = ACTIONS(2386),
    [anon_sym_TILDE] = ACTIONS(2386),
    [anon_sym_STAR] = ACTIONS(2386),
    [anon_sym_AMP_AMP] = ACTIONS(2386),
    [anon_sym_AMP] = ACTIONS(2384),
    [anon_sym___extension__] = ACTIONS(2384),
    [anon_sym_typedef] = ACTIONS(2384),
    [anon_sym___device__] = ACTIONS(2384),
    [anon_sym___host__] = ACTIONS(2384),
    [anon_sym___global__] = ACTIONS(2384),
    [anon_sym___forceinline__] = ACTIONS(2384),
    [anon_sym___noinline__] = ACTIONS(2384),
    [anon_sym_extern] = ACTIONS(2384),
    [anon_sym___attribute__] = ACTIONS(2384),
    [anon_sym_COLON_COLON] = ACTIONS(2386),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2386),
    [anon_sym___declspec] = ACTIONS(2384),
    [anon_sym___based] = ACTIONS(2384),
    [anon_sym_RBRACE] = ACTIONS(2386),
    [anon_sym_signed] = ACTIONS(2384),
    [anon_sym_unsigned] = ACTIONS(2384),
    [anon_sym_long] = ACTIONS(2384),
    [anon_sym_short] = ACTIONS(2384),
    [anon_sym_LBRACK] = ACTIONS(2384),
    [anon_sym_static] = ACTIONS(2384),
    [anon_sym_register] = ACTIONS(2384),
    [anon_sym_inline] = ACTIONS(2384),
    [anon_sym___inline] = ACTIONS(2384),
    [anon_sym___inline__] = ACTIONS(2384),
    [anon_sym___forceinline] = ACTIONS(2384),
    [anon_sym_thread_local] = ACTIONS(2384),
    [anon_sym___thread] = ACTIONS(2384),
    [anon_sym_const] = ACTIONS(2384),
    [anon_sym_constexpr] = ACTIONS(2384),
    [anon_sym_volatile] = ACTIONS(2384),
    [anon_sym_restrict] = ACTIONS(2384),
    [anon_sym___restrict__] = ACTIONS(2384),
    [anon_sym__Atomic] = ACTIONS(2384),
    [anon_sym__Noreturn] = ACTIONS(2384),
    [anon_sym_noreturn] = ACTIONS(2384),
    [anon_sym_mutable] = ACTIONS(2384),
    [anon_sym_constinit] = ACTIONS(2384),
    [anon_sym_consteval] = ACTIONS(2384),
    [anon_sym___shared__] = ACTIONS(2384),
    [anon_sym___local__] = ACTIONS(2384),
    [anon_sym___constant__] = ACTIONS(2384),
    [anon_sym___managed__] = ACTIONS(2384),
    [anon_sym___grid_constant__] = ACTIONS(2384),
    [anon_sym_alignas] = ACTIONS(2384),
    [anon_sym__Alignas] = ACTIONS(2384),
    [sym_primitive_type] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2384),
    [anon_sym_class] = ACTIONS(2384),
    [anon_sym_struct] = ACTIONS(2384),
    [anon_sym_union] = ACTIONS(2384),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2384),
    [anon_sym_decltype] = ACTIONS(2384),
    [sym_virtual] = ACTIONS(2384),
    [anon_sym_explicit] = ACTIONS(2384),
    [anon_sym_typename] = ACTIONS(2384),
    [anon_sym_template] = ACTIONS(2384),
    [anon_sym_operator] = ACTIONS(2384),
    [anon_sym_friend] = ACTIONS(2384),
    [anon_sym_public] = ACTIONS(2384),
    [anon_sym_private] = ACTIONS(2384),
    [anon_sym_protected] = ACTIONS(2384),
    [anon_sym_using] = ACTIONS(2384),
    [anon_sym_static_assert] = ACTIONS(2384),
    [anon_sym___launch_bounds__] = ACTIONS(2384),
  },
  [2093] = {
    [sym_identifier] = ACTIONS(5374),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5376),
    [anon_sym_COMMA] = ACTIONS(5376),
    [anon_sym_RPAREN] = ACTIONS(5376),
    [anon_sym_LPAREN2] = ACTIONS(5376),
    [anon_sym_DASH] = ACTIONS(5374),
    [anon_sym_PLUS] = ACTIONS(5374),
    [anon_sym_STAR] = ACTIONS(5376),
    [anon_sym_SLASH] = ACTIONS(5374),
    [anon_sym_PERCENT] = ACTIONS(5376),
    [anon_sym_PIPE_PIPE] = ACTIONS(5376),
    [anon_sym_AMP_AMP] = ACTIONS(5376),
    [anon_sym_PIPE] = ACTIONS(5374),
    [anon_sym_CARET] = ACTIONS(5376),
    [anon_sym_AMP] = ACTIONS(5374),
    [anon_sym_EQ_EQ] = ACTIONS(5376),
    [anon_sym_BANG_EQ] = ACTIONS(5376),
    [anon_sym_GT] = ACTIONS(5374),
    [anon_sym_GT_EQ] = ACTIONS(5376),
    [anon_sym_LT_EQ] = ACTIONS(5374),
    [anon_sym_LT] = ACTIONS(5374),
    [anon_sym_LT_LT] = ACTIONS(5374),
    [anon_sym_GT_GT] = ACTIONS(5376),
    [anon_sym_SEMI] = ACTIONS(5376),
    [anon_sym___extension__] = ACTIONS(5374),
    [anon_sym___global__] = ACTIONS(5374),
    [anon_sym___attribute__] = ACTIONS(5374),
    [anon_sym___based] = ACTIONS(5374),
    [anon_sym_LBRACE] = ACTIONS(5376),
    [anon_sym_RBRACE] = ACTIONS(5376),
    [anon_sym_signed] = ACTIONS(5374),
    [anon_sym_unsigned] = ACTIONS(5374),
    [anon_sym_long] = ACTIONS(5374),
    [anon_sym_short] = ACTIONS(5374),
    [anon_sym_LBRACK] = ACTIONS(5376),
    [anon_sym_RBRACK] = ACTIONS(5376),
    [anon_sym_const] = ACTIONS(5374),
    [anon_sym_constexpr] = ACTIONS(5374),
    [anon_sym_volatile] = ACTIONS(5374),
    [anon_sym_restrict] = ACTIONS(5374),
    [anon_sym___restrict__] = ACTIONS(5374),
    [anon_sym__Atomic] = ACTIONS(5374),
    [anon_sym__Noreturn] = ACTIONS(5374),
    [anon_sym_noreturn] = ACTIONS(5374),
    [anon_sym_mutable] = ACTIONS(5374),
    [anon_sym_constinit] = ACTIONS(5374),
    [anon_sym_consteval] = ACTIONS(5374),
    [anon_sym___shared__] = ACTIONS(5374),
    [anon_sym___local__] = ACTIONS(5374),
    [anon_sym___constant__] = ACTIONS(5374),
    [anon_sym___managed__] = ACTIONS(5374),
    [anon_sym___grid_constant__] = ACTIONS(5374),
    [anon_sym_alignas] = ACTIONS(5374),
    [anon_sym__Alignas] = ACTIONS(5374),
    [sym_primitive_type] = ACTIONS(5374),
    [anon_sym_COLON] = ACTIONS(5376),
    [anon_sym_QMARK] = ACTIONS(5376),
    [anon_sym_LT_EQ_GT] = ACTIONS(5376),
    [anon_sym_or] = ACTIONS(5374),
    [anon_sym_and] = ACTIONS(5374),
    [anon_sym_bitor] = ACTIONS(5374),
    [anon_sym_xor] = ACTIONS(5374),
    [anon_sym_bitand] = ACTIONS(5374),
    [anon_sym_not_eq] = ACTIONS(5374),
    [anon_sym_DASH_DASH] = ACTIONS(5376),
    [anon_sym_PLUS_PLUS] = ACTIONS(5376),
    [anon_sym_DOT] = ACTIONS(5374),
    [anon_sym_DOT_STAR] = ACTIONS(5376),
    [anon_sym_DASH_GT] = ACTIONS(5376),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5374),
    [anon_sym_decltype] = ACTIONS(5374),
    [anon_sym_final] = ACTIONS(5374),
    [anon_sym_override] = ACTIONS(5374),
    [anon_sym_requires] = ACTIONS(5374),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5376),
  },
  [2094] = {
    [sym_identifier] = ACTIONS(5378),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5380),
    [anon_sym_COMMA] = ACTIONS(5380),
    [anon_sym_RPAREN] = ACTIONS(5380),
    [anon_sym_LPAREN2] = ACTIONS(5380),
    [anon_sym_DASH] = ACTIONS(5378),
    [anon_sym_PLUS] = ACTIONS(5378),
    [anon_sym_STAR] = ACTIONS(5380),
    [anon_sym_SLASH] = ACTIONS(5378),
    [anon_sym_PERCENT] = ACTIONS(5380),
    [anon_sym_PIPE_PIPE] = ACTIONS(5380),
    [anon_sym_AMP_AMP] = ACTIONS(5380),
    [anon_sym_PIPE] = ACTIONS(5378),
    [anon_sym_CARET] = ACTIONS(5380),
    [anon_sym_AMP] = ACTIONS(5378),
    [anon_sym_EQ_EQ] = ACTIONS(5380),
    [anon_sym_BANG_EQ] = ACTIONS(5380),
    [anon_sym_GT] = ACTIONS(5378),
    [anon_sym_GT_EQ] = ACTIONS(5380),
    [anon_sym_LT_EQ] = ACTIONS(5378),
    [anon_sym_LT] = ACTIONS(5378),
    [anon_sym_LT_LT] = ACTIONS(5378),
    [anon_sym_GT_GT] = ACTIONS(5380),
    [anon_sym_SEMI] = ACTIONS(5380),
    [anon_sym___extension__] = ACTIONS(5378),
    [anon_sym___global__] = ACTIONS(5378),
    [anon_sym___attribute__] = ACTIONS(5378),
    [anon_sym___based] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(5380),
    [anon_sym_RBRACE] = ACTIONS(5380),
    [anon_sym_signed] = ACTIONS(5378),
    [anon_sym_unsigned] = ACTIONS(5378),
    [anon_sym_long] = ACTIONS(5378),
    [anon_sym_short] = ACTIONS(5378),
    [anon_sym_LBRACK] = ACTIONS(5380),
    [anon_sym_RBRACK] = ACTIONS(5380),
    [anon_sym_const] = ACTIONS(5378),
    [anon_sym_constexpr] = ACTIONS(5378),
    [anon_sym_volatile] = ACTIONS(5378),
    [anon_sym_restrict] = ACTIONS(5378),
    [anon_sym___restrict__] = ACTIONS(5378),
    [anon_sym__Atomic] = ACTIONS(5378),
    [anon_sym__Noreturn] = ACTIONS(5378),
    [anon_sym_noreturn] = ACTIONS(5378),
    [anon_sym_mutable] = ACTIONS(5378),
    [anon_sym_constinit] = ACTIONS(5378),
    [anon_sym_consteval] = ACTIONS(5378),
    [anon_sym___shared__] = ACTIONS(5378),
    [anon_sym___local__] = ACTIONS(5378),
    [anon_sym___constant__] = ACTIONS(5378),
    [anon_sym___managed__] = ACTIONS(5378),
    [anon_sym___grid_constant__] = ACTIONS(5378),
    [anon_sym_alignas] = ACTIONS(5378),
    [anon_sym__Alignas] = ACTIONS(5378),
    [sym_primitive_type] = ACTIONS(5378),
    [anon_sym_COLON] = ACTIONS(5380),
    [anon_sym_QMARK] = ACTIONS(5380),
    [anon_sym_LT_EQ_GT] = ACTIONS(5380),
    [anon_sym_or] = ACTIONS(5378),
    [anon_sym_and] = ACTIONS(5378),
    [anon_sym_bitor] = ACTIONS(5378),
    [anon_sym_xor] = ACTIONS(5378),
    [anon_sym_bitand] = ACTIONS(5378),
    [anon_sym_not_eq] = ACTIONS(5378),
    [anon_sym_DASH_DASH] = ACTIONS(5380),
    [anon_sym_PLUS_PLUS] = ACTIONS(5380),
    [anon_sym_DOT] = ACTIONS(5378),
    [anon_sym_DOT_STAR] = ACTIONS(5380),
    [anon_sym_DASH_GT] = ACTIONS(5380),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5378),
    [anon_sym_decltype] = ACTIONS(5378),
    [anon_sym_final] = ACTIONS(5378),
    [anon_sym_override] = ACTIONS(5378),
    [anon_sym_requires] = ACTIONS(5378),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5380),
  },
  [2095] = {
    [sym_identifier] = ACTIONS(5382),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5384),
    [anon_sym_COMMA] = ACTIONS(5384),
    [anon_sym_RPAREN] = ACTIONS(5384),
    [anon_sym_LPAREN2] = ACTIONS(5384),
    [anon_sym_DASH] = ACTIONS(5382),
    [anon_sym_PLUS] = ACTIONS(5382),
    [anon_sym_STAR] = ACTIONS(5384),
    [anon_sym_SLASH] = ACTIONS(5382),
    [anon_sym_PERCENT] = ACTIONS(5384),
    [anon_sym_PIPE_PIPE] = ACTIONS(5384),
    [anon_sym_AMP_AMP] = ACTIONS(5384),
    [anon_sym_PIPE] = ACTIONS(5382),
    [anon_sym_CARET] = ACTIONS(5384),
    [anon_sym_AMP] = ACTIONS(5382),
    [anon_sym_EQ_EQ] = ACTIONS(5384),
    [anon_sym_BANG_EQ] = ACTIONS(5384),
    [anon_sym_GT] = ACTIONS(5382),
    [anon_sym_GT_EQ] = ACTIONS(5384),
    [anon_sym_LT_EQ] = ACTIONS(5382),
    [anon_sym_LT] = ACTIONS(5382),
    [anon_sym_LT_LT] = ACTIONS(5382),
    [anon_sym_GT_GT] = ACTIONS(5384),
    [anon_sym_SEMI] = ACTIONS(5384),
    [anon_sym___extension__] = ACTIONS(5382),
    [anon_sym___global__] = ACTIONS(5382),
    [anon_sym___attribute__] = ACTIONS(5382),
    [anon_sym___based] = ACTIONS(5382),
    [anon_sym_LBRACE] = ACTIONS(5384),
    [anon_sym_RBRACE] = ACTIONS(5384),
    [anon_sym_signed] = ACTIONS(5382),
    [anon_sym_unsigned] = ACTIONS(5382),
    [anon_sym_long] = ACTIONS(5382),
    [anon_sym_short] = ACTIONS(5382),
    [anon_sym_LBRACK] = ACTIONS(5384),
    [anon_sym_RBRACK] = ACTIONS(5384),
    [anon_sym_const] = ACTIONS(5382),
    [anon_sym_constexpr] = ACTIONS(5382),
    [anon_sym_volatile] = ACTIONS(5382),
    [anon_sym_restrict] = ACTIONS(5382),
    [anon_sym___restrict__] = ACTIONS(5382),
    [anon_sym__Atomic] = ACTIONS(5382),
    [anon_sym__Noreturn] = ACTIONS(5382),
    [anon_sym_noreturn] = ACTIONS(5382),
    [anon_sym_mutable] = ACTIONS(5382),
    [anon_sym_constinit] = ACTIONS(5382),
    [anon_sym_consteval] = ACTIONS(5382),
    [anon_sym___shared__] = ACTIONS(5382),
    [anon_sym___local__] = ACTIONS(5382),
    [anon_sym___constant__] = ACTIONS(5382),
    [anon_sym___managed__] = ACTIONS(5382),
    [anon_sym___grid_constant__] = ACTIONS(5382),
    [anon_sym_alignas] = ACTIONS(5382),
    [anon_sym__Alignas] = ACTIONS(5382),
    [sym_primitive_type] = ACTIONS(5382),
    [anon_sym_COLON] = ACTIONS(5384),
    [anon_sym_QMARK] = ACTIONS(5384),
    [anon_sym_LT_EQ_GT] = ACTIONS(5384),
    [anon_sym_or] = ACTIONS(5382),
    [anon_sym_and] = ACTIONS(5382),
    [anon_sym_bitor] = ACTIONS(5382),
    [anon_sym_xor] = ACTIONS(5382),
    [anon_sym_bitand] = ACTIONS(5382),
    [anon_sym_not_eq] = ACTIONS(5382),
    [anon_sym_DASH_DASH] = ACTIONS(5384),
    [anon_sym_PLUS_PLUS] = ACTIONS(5384),
    [anon_sym_DOT] = ACTIONS(5382),
    [anon_sym_DOT_STAR] = ACTIONS(5384),
    [anon_sym_DASH_GT] = ACTIONS(5384),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5382),
    [anon_sym_decltype] = ACTIONS(5382),
    [anon_sym_final] = ACTIONS(5382),
    [anon_sym_override] = ACTIONS(5382),
    [anon_sym_requires] = ACTIONS(5382),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5384),
  },
  [2096] = {
    [sym_identifier] = ACTIONS(5336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5338),
    [anon_sym_COMMA] = ACTIONS(5338),
    [anon_sym_RPAREN] = ACTIONS(5338),
    [anon_sym_LPAREN2] = ACTIONS(5338),
    [anon_sym_DASH] = ACTIONS(5336),
    [anon_sym_PLUS] = ACTIONS(5336),
    [anon_sym_STAR] = ACTIONS(5338),
    [anon_sym_SLASH] = ACTIONS(5336),
    [anon_sym_PERCENT] = ACTIONS(5338),
    [anon_sym_PIPE_PIPE] = ACTIONS(5338),
    [anon_sym_AMP_AMP] = ACTIONS(5338),
    [anon_sym_PIPE] = ACTIONS(5336),
    [anon_sym_CARET] = ACTIONS(5338),
    [anon_sym_AMP] = ACTIONS(5336),
    [anon_sym_EQ_EQ] = ACTIONS(5338),
    [anon_sym_BANG_EQ] = ACTIONS(5338),
    [anon_sym_GT] = ACTIONS(5336),
    [anon_sym_GT_EQ] = ACTIONS(5338),
    [anon_sym_LT_EQ] = ACTIONS(5336),
    [anon_sym_LT] = ACTIONS(5336),
    [anon_sym_LT_LT] = ACTIONS(5336),
    [anon_sym_GT_GT] = ACTIONS(5338),
    [anon_sym_SEMI] = ACTIONS(5338),
    [anon_sym___extension__] = ACTIONS(5336),
    [anon_sym___global__] = ACTIONS(5336),
    [anon_sym___attribute__] = ACTIONS(5336),
    [anon_sym___based] = ACTIONS(5336),
    [anon_sym_LBRACE] = ACTIONS(5338),
    [anon_sym_RBRACE] = ACTIONS(5338),
    [anon_sym_signed] = ACTIONS(5336),
    [anon_sym_unsigned] = ACTIONS(5336),
    [anon_sym_long] = ACTIONS(5336),
    [anon_sym_short] = ACTIONS(5336),
    [anon_sym_LBRACK] = ACTIONS(5338),
    [anon_sym_RBRACK] = ACTIONS(5338),
    [anon_sym_const] = ACTIONS(5336),
    [anon_sym_constexpr] = ACTIONS(5336),
    [anon_sym_volatile] = ACTIONS(5336),
    [anon_sym_restrict] = ACTIONS(5336),
    [anon_sym___restrict__] = ACTIONS(5336),
    [anon_sym__Atomic] = ACTIONS(5336),
    [anon_sym__Noreturn] = ACTIONS(5336),
    [anon_sym_noreturn] = ACTIONS(5336),
    [anon_sym_mutable] = ACTIONS(5336),
    [anon_sym_constinit] = ACTIONS(5336),
    [anon_sym_consteval] = ACTIONS(5336),
    [anon_sym___shared__] = ACTIONS(5336),
    [anon_sym___local__] = ACTIONS(5336),
    [anon_sym___constant__] = ACTIONS(5336),
    [anon_sym___managed__] = ACTIONS(5336),
    [anon_sym___grid_constant__] = ACTIONS(5336),
    [anon_sym_alignas] = ACTIONS(5336),
    [anon_sym__Alignas] = ACTIONS(5336),
    [sym_primitive_type] = ACTIONS(5336),
    [anon_sym_COLON] = ACTIONS(5338),
    [anon_sym_QMARK] = ACTIONS(5338),
    [anon_sym_LT_EQ_GT] = ACTIONS(5338),
    [anon_sym_or] = ACTIONS(5336),
    [anon_sym_and] = ACTIONS(5336),
    [anon_sym_bitor] = ACTIONS(5336),
    [anon_sym_xor] = ACTIONS(5336),
    [anon_sym_bitand] = ACTIONS(5336),
    [anon_sym_not_eq] = ACTIONS(5336),
    [anon_sym_DASH_DASH] = ACTIONS(5338),
    [anon_sym_PLUS_PLUS] = ACTIONS(5338),
    [anon_sym_DOT] = ACTIONS(5336),
    [anon_sym_DOT_STAR] = ACTIONS(5338),
    [anon_sym_DASH_GT] = ACTIONS(5338),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5336),
    [anon_sym_decltype] = ACTIONS(5336),
    [anon_sym_final] = ACTIONS(5336),
    [anon_sym_override] = ACTIONS(5336),
    [anon_sym_requires] = ACTIONS(5336),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5338),
  },
  [2097] = {
    [sym_identifier] = ACTIONS(2370),
    [aux_sym_preproc_def_token1] = ACTIONS(2370),
    [aux_sym_preproc_if_token1] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2370),
    [sym_preproc_directive] = ACTIONS(2370),
    [anon_sym_LPAREN2] = ACTIONS(2372),
    [anon_sym_TILDE] = ACTIONS(2372),
    [anon_sym_STAR] = ACTIONS(2372),
    [anon_sym_AMP_AMP] = ACTIONS(2372),
    [anon_sym_AMP] = ACTIONS(2370),
    [anon_sym___extension__] = ACTIONS(2370),
    [anon_sym_typedef] = ACTIONS(2370),
    [anon_sym___device__] = ACTIONS(2370),
    [anon_sym___host__] = ACTIONS(2370),
    [anon_sym___global__] = ACTIONS(2370),
    [anon_sym___forceinline__] = ACTIONS(2370),
    [anon_sym___noinline__] = ACTIONS(2370),
    [anon_sym_extern] = ACTIONS(2370),
    [anon_sym___attribute__] = ACTIONS(2370),
    [anon_sym_COLON_COLON] = ACTIONS(2372),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2372),
    [anon_sym___declspec] = ACTIONS(2370),
    [anon_sym___based] = ACTIONS(2370),
    [anon_sym_RBRACE] = ACTIONS(2372),
    [anon_sym_signed] = ACTIONS(2370),
    [anon_sym_unsigned] = ACTIONS(2370),
    [anon_sym_long] = ACTIONS(2370),
    [anon_sym_short] = ACTIONS(2370),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_static] = ACTIONS(2370),
    [anon_sym_register] = ACTIONS(2370),
    [anon_sym_inline] = ACTIONS(2370),
    [anon_sym___inline] = ACTIONS(2370),
    [anon_sym___inline__] = ACTIONS(2370),
    [anon_sym___forceinline] = ACTIONS(2370),
    [anon_sym_thread_local] = ACTIONS(2370),
    [anon_sym___thread] = ACTIONS(2370),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_constexpr] = ACTIONS(2370),
    [anon_sym_volatile] = ACTIONS(2370),
    [anon_sym_restrict] = ACTIONS(2370),
    [anon_sym___restrict__] = ACTIONS(2370),
    [anon_sym__Atomic] = ACTIONS(2370),
    [anon_sym__Noreturn] = ACTIONS(2370),
    [anon_sym_noreturn] = ACTIONS(2370),
    [anon_sym_mutable] = ACTIONS(2370),
    [anon_sym_constinit] = ACTIONS(2370),
    [anon_sym_consteval] = ACTIONS(2370),
    [anon_sym___shared__] = ACTIONS(2370),
    [anon_sym___local__] = ACTIONS(2370),
    [anon_sym___constant__] = ACTIONS(2370),
    [anon_sym___managed__] = ACTIONS(2370),
    [anon_sym___grid_constant__] = ACTIONS(2370),
    [anon_sym_alignas] = ACTIONS(2370),
    [anon_sym__Alignas] = ACTIONS(2370),
    [sym_primitive_type] = ACTIONS(2370),
    [anon_sym_enum] = ACTIONS(2370),
    [anon_sym_class] = ACTIONS(2370),
    [anon_sym_struct] = ACTIONS(2370),
    [anon_sym_union] = ACTIONS(2370),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2370),
    [anon_sym_decltype] = ACTIONS(2370),
    [sym_virtual] = ACTIONS(2370),
    [anon_sym_explicit] = ACTIONS(2370),
    [anon_sym_typename] = ACTIONS(2370),
    [anon_sym_template] = ACTIONS(2370),
    [anon_sym_operator] = ACTIONS(2370),
    [anon_sym_friend] = ACTIONS(2370),
    [anon_sym_public] = ACTIONS(2370),
    [anon_sym_private] = ACTIONS(2370),
    [anon_sym_protected] = ACTIONS(2370),
    [anon_sym_using] = ACTIONS(2370),
    [anon_sym_static_assert] = ACTIONS(2370),
    [anon_sym___launch_bounds__] = ACTIONS(2370),
  },
  [2098] = {
    [sym_identifier] = ACTIONS(2370),
    [aux_sym_preproc_def_token1] = ACTIONS(2370),
    [aux_sym_preproc_if_token1] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2370),
    [sym_preproc_directive] = ACTIONS(2370),
    [anon_sym_LPAREN2] = ACTIONS(2372),
    [anon_sym_TILDE] = ACTIONS(2372),
    [anon_sym_STAR] = ACTIONS(2372),
    [anon_sym_AMP_AMP] = ACTIONS(2372),
    [anon_sym_AMP] = ACTIONS(2370),
    [anon_sym___extension__] = ACTIONS(2370),
    [anon_sym_typedef] = ACTIONS(2370),
    [anon_sym___device__] = ACTIONS(2370),
    [anon_sym___host__] = ACTIONS(2370),
    [anon_sym___global__] = ACTIONS(2370),
    [anon_sym___forceinline__] = ACTIONS(2370),
    [anon_sym___noinline__] = ACTIONS(2370),
    [anon_sym_extern] = ACTIONS(2370),
    [anon_sym___attribute__] = ACTIONS(2370),
    [anon_sym_COLON_COLON] = ACTIONS(2372),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2372),
    [anon_sym___declspec] = ACTIONS(2370),
    [anon_sym___based] = ACTIONS(2370),
    [anon_sym_RBRACE] = ACTIONS(2372),
    [anon_sym_signed] = ACTIONS(2370),
    [anon_sym_unsigned] = ACTIONS(2370),
    [anon_sym_long] = ACTIONS(2370),
    [anon_sym_short] = ACTIONS(2370),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_static] = ACTIONS(2370),
    [anon_sym_register] = ACTIONS(2370),
    [anon_sym_inline] = ACTIONS(2370),
    [anon_sym___inline] = ACTIONS(2370),
    [anon_sym___inline__] = ACTIONS(2370),
    [anon_sym___forceinline] = ACTIONS(2370),
    [anon_sym_thread_local] = ACTIONS(2370),
    [anon_sym___thread] = ACTIONS(2370),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_constexpr] = ACTIONS(2370),
    [anon_sym_volatile] = ACTIONS(2370),
    [anon_sym_restrict] = ACTIONS(2370),
    [anon_sym___restrict__] = ACTIONS(2370),
    [anon_sym__Atomic] = ACTIONS(2370),
    [anon_sym__Noreturn] = ACTIONS(2370),
    [anon_sym_noreturn] = ACTIONS(2370),
    [anon_sym_mutable] = ACTIONS(2370),
    [anon_sym_constinit] = ACTIONS(2370),
    [anon_sym_consteval] = ACTIONS(2370),
    [anon_sym___shared__] = ACTIONS(2370),
    [anon_sym___local__] = ACTIONS(2370),
    [anon_sym___constant__] = ACTIONS(2370),
    [anon_sym___managed__] = ACTIONS(2370),
    [anon_sym___grid_constant__] = ACTIONS(2370),
    [anon_sym_alignas] = ACTIONS(2370),
    [anon_sym__Alignas] = ACTIONS(2370),
    [sym_primitive_type] = ACTIONS(2370),
    [anon_sym_enum] = ACTIONS(2370),
    [anon_sym_class] = ACTIONS(2370),
    [anon_sym_struct] = ACTIONS(2370),
    [anon_sym_union] = ACTIONS(2370),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2370),
    [anon_sym_decltype] = ACTIONS(2370),
    [sym_virtual] = ACTIONS(2370),
    [anon_sym_explicit] = ACTIONS(2370),
    [anon_sym_typename] = ACTIONS(2370),
    [anon_sym_template] = ACTIONS(2370),
    [anon_sym_operator] = ACTIONS(2370),
    [anon_sym_friend] = ACTIONS(2370),
    [anon_sym_public] = ACTIONS(2370),
    [anon_sym_private] = ACTIONS(2370),
    [anon_sym_protected] = ACTIONS(2370),
    [anon_sym_using] = ACTIONS(2370),
    [anon_sym_static_assert] = ACTIONS(2370),
    [anon_sym___launch_bounds__] = ACTIONS(2370),
  },
  [2099] = {
    [sym_identifier] = ACTIONS(5075),
    [aux_sym_preproc_def_token1] = ACTIONS(5075),
    [aux_sym_preproc_if_token1] = ACTIONS(5075),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5075),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5075),
    [sym_preproc_directive] = ACTIONS(5075),
    [anon_sym_LPAREN2] = ACTIONS(5077),
    [anon_sym_TILDE] = ACTIONS(5077),
    [anon_sym_STAR] = ACTIONS(5077),
    [anon_sym_AMP_AMP] = ACTIONS(5077),
    [anon_sym_AMP] = ACTIONS(5075),
    [anon_sym___extension__] = ACTIONS(5075),
    [anon_sym_typedef] = ACTIONS(5075),
    [anon_sym___device__] = ACTIONS(5075),
    [anon_sym___host__] = ACTIONS(5075),
    [anon_sym___global__] = ACTIONS(5075),
    [anon_sym___forceinline__] = ACTIONS(5075),
    [anon_sym___noinline__] = ACTIONS(5075),
    [anon_sym_extern] = ACTIONS(5075),
    [anon_sym___attribute__] = ACTIONS(5075),
    [anon_sym_COLON_COLON] = ACTIONS(5077),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5077),
    [anon_sym___declspec] = ACTIONS(5075),
    [anon_sym___based] = ACTIONS(5075),
    [anon_sym_RBRACE] = ACTIONS(5077),
    [anon_sym_signed] = ACTIONS(5075),
    [anon_sym_unsigned] = ACTIONS(5075),
    [anon_sym_long] = ACTIONS(5075),
    [anon_sym_short] = ACTIONS(5075),
    [anon_sym_LBRACK] = ACTIONS(5075),
    [anon_sym_static] = ACTIONS(5075),
    [anon_sym_register] = ACTIONS(5075),
    [anon_sym_inline] = ACTIONS(5075),
    [anon_sym___inline] = ACTIONS(5075),
    [anon_sym___inline__] = ACTIONS(5075),
    [anon_sym___forceinline] = ACTIONS(5075),
    [anon_sym_thread_local] = ACTIONS(5075),
    [anon_sym___thread] = ACTIONS(5075),
    [anon_sym_const] = ACTIONS(5075),
    [anon_sym_constexpr] = ACTIONS(5075),
    [anon_sym_volatile] = ACTIONS(5075),
    [anon_sym_restrict] = ACTIONS(5075),
    [anon_sym___restrict__] = ACTIONS(5075),
    [anon_sym__Atomic] = ACTIONS(5075),
    [anon_sym__Noreturn] = ACTIONS(5075),
    [anon_sym_noreturn] = ACTIONS(5075),
    [anon_sym_mutable] = ACTIONS(5075),
    [anon_sym_constinit] = ACTIONS(5075),
    [anon_sym_consteval] = ACTIONS(5075),
    [anon_sym___shared__] = ACTIONS(5075),
    [anon_sym___local__] = ACTIONS(5075),
    [anon_sym___constant__] = ACTIONS(5075),
    [anon_sym___managed__] = ACTIONS(5075),
    [anon_sym___grid_constant__] = ACTIONS(5075),
    [anon_sym_alignas] = ACTIONS(5075),
    [anon_sym__Alignas] = ACTIONS(5075),
    [sym_primitive_type] = ACTIONS(5075),
    [anon_sym_enum] = ACTIONS(5075),
    [anon_sym_class] = ACTIONS(5075),
    [anon_sym_struct] = ACTIONS(5075),
    [anon_sym_union] = ACTIONS(5075),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5075),
    [anon_sym_decltype] = ACTIONS(5075),
    [sym_virtual] = ACTIONS(5075),
    [anon_sym_explicit] = ACTIONS(5075),
    [anon_sym_typename] = ACTIONS(5075),
    [anon_sym_template] = ACTIONS(5075),
    [anon_sym_operator] = ACTIONS(5075),
    [anon_sym_friend] = ACTIONS(5075),
    [anon_sym_public] = ACTIONS(5075),
    [anon_sym_private] = ACTIONS(5075),
    [anon_sym_protected] = ACTIONS(5075),
    [anon_sym_using] = ACTIONS(5075),
    [anon_sym_static_assert] = ACTIONS(5075),
    [anon_sym___launch_bounds__] = ACTIONS(5075),
  },
  [2100] = {
    [sym_identifier] = ACTIONS(2090),
    [aux_sym_preproc_def_token1] = ACTIONS(2090),
    [aux_sym_preproc_if_token1] = ACTIONS(2090),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2090),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2090),
    [sym_preproc_directive] = ACTIONS(2090),
    [anon_sym_LPAREN2] = ACTIONS(2092),
    [anon_sym_TILDE] = ACTIONS(2092),
    [anon_sym_STAR] = ACTIONS(2092),
    [anon_sym_AMP_AMP] = ACTIONS(2092),
    [anon_sym_AMP] = ACTIONS(2090),
    [anon_sym___extension__] = ACTIONS(2090),
    [anon_sym_typedef] = ACTIONS(2090),
    [anon_sym___device__] = ACTIONS(2090),
    [anon_sym___host__] = ACTIONS(2090),
    [anon_sym___global__] = ACTIONS(2090),
    [anon_sym___forceinline__] = ACTIONS(2090),
    [anon_sym___noinline__] = ACTIONS(2090),
    [anon_sym_extern] = ACTIONS(2090),
    [anon_sym___attribute__] = ACTIONS(2090),
    [anon_sym_COLON_COLON] = ACTIONS(2092),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2092),
    [anon_sym___declspec] = ACTIONS(2090),
    [anon_sym___based] = ACTIONS(2090),
    [anon_sym_RBRACE] = ACTIONS(2092),
    [anon_sym_signed] = ACTIONS(2090),
    [anon_sym_unsigned] = ACTIONS(2090),
    [anon_sym_long] = ACTIONS(2090),
    [anon_sym_short] = ACTIONS(2090),
    [anon_sym_LBRACK] = ACTIONS(2090),
    [anon_sym_static] = ACTIONS(2090),
    [anon_sym_register] = ACTIONS(2090),
    [anon_sym_inline] = ACTIONS(2090),
    [anon_sym___inline] = ACTIONS(2090),
    [anon_sym___inline__] = ACTIONS(2090),
    [anon_sym___forceinline] = ACTIONS(2090),
    [anon_sym_thread_local] = ACTIONS(2090),
    [anon_sym___thread] = ACTIONS(2090),
    [anon_sym_const] = ACTIONS(2090),
    [anon_sym_constexpr] = ACTIONS(2090),
    [anon_sym_volatile] = ACTIONS(2090),
    [anon_sym_restrict] = ACTIONS(2090),
    [anon_sym___restrict__] = ACTIONS(2090),
    [anon_sym__Atomic] = ACTIONS(2090),
    [anon_sym__Noreturn] = ACTIONS(2090),
    [anon_sym_noreturn] = ACTIONS(2090),
    [anon_sym_mutable] = ACTIONS(2090),
    [anon_sym_constinit] = ACTIONS(2090),
    [anon_sym_consteval] = ACTIONS(2090),
    [anon_sym___shared__] = ACTIONS(2090),
    [anon_sym___local__] = ACTIONS(2090),
    [anon_sym___constant__] = ACTIONS(2090),
    [anon_sym___managed__] = ACTIONS(2090),
    [anon_sym___grid_constant__] = ACTIONS(2090),
    [anon_sym_alignas] = ACTIONS(2090),
    [anon_sym__Alignas] = ACTIONS(2090),
    [sym_primitive_type] = ACTIONS(2090),
    [anon_sym_enum] = ACTIONS(2090),
    [anon_sym_class] = ACTIONS(2090),
    [anon_sym_struct] = ACTIONS(2090),
    [anon_sym_union] = ACTIONS(2090),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2090),
    [anon_sym_decltype] = ACTIONS(2090),
    [sym_virtual] = ACTIONS(2090),
    [anon_sym_explicit] = ACTIONS(2090),
    [anon_sym_typename] = ACTIONS(2090),
    [anon_sym_template] = ACTIONS(2090),
    [anon_sym_operator] = ACTIONS(2090),
    [anon_sym_friend] = ACTIONS(2090),
    [anon_sym_public] = ACTIONS(2090),
    [anon_sym_private] = ACTIONS(2090),
    [anon_sym_protected] = ACTIONS(2090),
    [anon_sym_using] = ACTIONS(2090),
    [anon_sym_static_assert] = ACTIONS(2090),
    [anon_sym___launch_bounds__] = ACTIONS(2090),
  },
  [2101] = {
    [sym_identifier] = ACTIONS(5386),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5388),
    [anon_sym_COMMA] = ACTIONS(5388),
    [anon_sym_RPAREN] = ACTIONS(5388),
    [anon_sym_LPAREN2] = ACTIONS(5388),
    [anon_sym_DASH] = ACTIONS(5386),
    [anon_sym_PLUS] = ACTIONS(5386),
    [anon_sym_STAR] = ACTIONS(5388),
    [anon_sym_SLASH] = ACTIONS(5386),
    [anon_sym_PERCENT] = ACTIONS(5388),
    [anon_sym_PIPE_PIPE] = ACTIONS(5388),
    [anon_sym_AMP_AMP] = ACTIONS(5388),
    [anon_sym_PIPE] = ACTIONS(5386),
    [anon_sym_CARET] = ACTIONS(5388),
    [anon_sym_AMP] = ACTIONS(5386),
    [anon_sym_EQ_EQ] = ACTIONS(5388),
    [anon_sym_BANG_EQ] = ACTIONS(5388),
    [anon_sym_GT] = ACTIONS(5386),
    [anon_sym_GT_EQ] = ACTIONS(5388),
    [anon_sym_LT_EQ] = ACTIONS(5386),
    [anon_sym_LT] = ACTIONS(5386),
    [anon_sym_LT_LT] = ACTIONS(5386),
    [anon_sym_GT_GT] = ACTIONS(5388),
    [anon_sym_SEMI] = ACTIONS(5388),
    [anon_sym___extension__] = ACTIONS(5386),
    [anon_sym___global__] = ACTIONS(5386),
    [anon_sym___attribute__] = ACTIONS(5386),
    [anon_sym___based] = ACTIONS(5386),
    [anon_sym_LBRACE] = ACTIONS(5388),
    [anon_sym_RBRACE] = ACTIONS(5388),
    [anon_sym_signed] = ACTIONS(5386),
    [anon_sym_unsigned] = ACTIONS(5386),
    [anon_sym_long] = ACTIONS(5386),
    [anon_sym_short] = ACTIONS(5386),
    [anon_sym_LBRACK] = ACTIONS(5388),
    [anon_sym_RBRACK] = ACTIONS(5388),
    [anon_sym_const] = ACTIONS(5386),
    [anon_sym_constexpr] = ACTIONS(5386),
    [anon_sym_volatile] = ACTIONS(5386),
    [anon_sym_restrict] = ACTIONS(5386),
    [anon_sym___restrict__] = ACTIONS(5386),
    [anon_sym__Atomic] = ACTIONS(5386),
    [anon_sym__Noreturn] = ACTIONS(5386),
    [anon_sym_noreturn] = ACTIONS(5386),
    [anon_sym_mutable] = ACTIONS(5386),
    [anon_sym_constinit] = ACTIONS(5386),
    [anon_sym_consteval] = ACTIONS(5386),
    [anon_sym___shared__] = ACTIONS(5386),
    [anon_sym___local__] = ACTIONS(5386),
    [anon_sym___constant__] = ACTIONS(5386),
    [anon_sym___managed__] = ACTIONS(5386),
    [anon_sym___grid_constant__] = ACTIONS(5386),
    [anon_sym_alignas] = ACTIONS(5386),
    [anon_sym__Alignas] = ACTIONS(5386),
    [sym_primitive_type] = ACTIONS(5386),
    [anon_sym_COLON] = ACTIONS(5388),
    [anon_sym_QMARK] = ACTIONS(5388),
    [anon_sym_LT_EQ_GT] = ACTIONS(5388),
    [anon_sym_or] = ACTIONS(5386),
    [anon_sym_and] = ACTIONS(5386),
    [anon_sym_bitor] = ACTIONS(5386),
    [anon_sym_xor] = ACTIONS(5386),
    [anon_sym_bitand] = ACTIONS(5386),
    [anon_sym_not_eq] = ACTIONS(5386),
    [anon_sym_DASH_DASH] = ACTIONS(5388),
    [anon_sym_PLUS_PLUS] = ACTIONS(5388),
    [anon_sym_DOT] = ACTIONS(5386),
    [anon_sym_DOT_STAR] = ACTIONS(5388),
    [anon_sym_DASH_GT] = ACTIONS(5388),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5386),
    [anon_sym_decltype] = ACTIONS(5386),
    [anon_sym_final] = ACTIONS(5386),
    [anon_sym_override] = ACTIONS(5386),
    [anon_sym_requires] = ACTIONS(5386),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5388),
  },
  [2102] = {
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_LPAREN2] = ACTIONS(3994),
    [anon_sym_TILDE] = ACTIONS(3994),
    [anon_sym_STAR] = ACTIONS(3994),
    [anon_sym_PIPE_PIPE] = ACTIONS(3994),
    [anon_sym_AMP_AMP] = ACTIONS(3994),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym___extension__] = ACTIONS(3992),
    [anon_sym___device__] = ACTIONS(3992),
    [anon_sym___host__] = ACTIONS(3992),
    [anon_sym___global__] = ACTIONS(3992),
    [anon_sym___forceinline__] = ACTIONS(3992),
    [anon_sym___noinline__] = ACTIONS(3992),
    [anon_sym_extern] = ACTIONS(3992),
    [anon_sym___attribute__] = ACTIONS(3992),
    [anon_sym_COLON_COLON] = ACTIONS(3994),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3994),
    [anon_sym___declspec] = ACTIONS(3992),
    [anon_sym___based] = ACTIONS(3992),
    [anon_sym___cdecl] = ACTIONS(3992),
    [anon_sym___clrcall] = ACTIONS(3992),
    [anon_sym___stdcall] = ACTIONS(3992),
    [anon_sym___fastcall] = ACTIONS(3992),
    [anon_sym___thiscall] = ACTIONS(3992),
    [anon_sym___vectorcall] = ACTIONS(3992),
    [anon_sym_signed] = ACTIONS(3992),
    [anon_sym_unsigned] = ACTIONS(3992),
    [anon_sym_long] = ACTIONS(3992),
    [anon_sym_short] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(3992),
    [anon_sym_static] = ACTIONS(3992),
    [anon_sym_register] = ACTIONS(3992),
    [anon_sym_inline] = ACTIONS(3992),
    [anon_sym___inline] = ACTIONS(3992),
    [anon_sym___inline__] = ACTIONS(3992),
    [anon_sym___forceinline] = ACTIONS(3992),
    [anon_sym_thread_local] = ACTIONS(3992),
    [anon_sym___thread] = ACTIONS(3992),
    [anon_sym_const] = ACTIONS(3992),
    [anon_sym_constexpr] = ACTIONS(3992),
    [anon_sym_volatile] = ACTIONS(3992),
    [anon_sym_restrict] = ACTIONS(3992),
    [anon_sym___restrict__] = ACTIONS(3992),
    [anon_sym__Atomic] = ACTIONS(3992),
    [anon_sym__Noreturn] = ACTIONS(3992),
    [anon_sym_noreturn] = ACTIONS(3992),
    [anon_sym_mutable] = ACTIONS(3992),
    [anon_sym_constinit] = ACTIONS(3992),
    [anon_sym_consteval] = ACTIONS(3992),
    [anon_sym___shared__] = ACTIONS(3992),
    [anon_sym___local__] = ACTIONS(3992),
    [anon_sym___constant__] = ACTIONS(3992),
    [anon_sym___managed__] = ACTIONS(3992),
    [anon_sym___grid_constant__] = ACTIONS(3992),
    [anon_sym_alignas] = ACTIONS(3992),
    [anon_sym__Alignas] = ACTIONS(3992),
    [sym_primitive_type] = ACTIONS(3992),
    [anon_sym_enum] = ACTIONS(3992),
    [anon_sym_class] = ACTIONS(3992),
    [anon_sym_struct] = ACTIONS(3992),
    [anon_sym_union] = ACTIONS(3992),
    [anon_sym_or] = ACTIONS(3992),
    [anon_sym_and] = ACTIONS(3992),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3992),
    [anon_sym_decltype] = ACTIONS(3992),
    [sym_virtual] = ACTIONS(3992),
    [anon_sym_explicit] = ACTIONS(3992),
    [anon_sym_typename] = ACTIONS(3992),
    [anon_sym_template] = ACTIONS(3992),
    [anon_sym_operator] = ACTIONS(3992),
    [anon_sym_friend] = ACTIONS(3992),
    [anon_sym_using] = ACTIONS(3992),
    [anon_sym_concept] = ACTIONS(3992),
    [anon_sym___launch_bounds__] = ACTIONS(3992),
  },
  [2103] = {
    [sym_identifier] = ACTIONS(5145),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5147),
    [anon_sym_COMMA] = ACTIONS(5147),
    [anon_sym_RPAREN] = ACTIONS(5147),
    [aux_sym_preproc_if_token2] = ACTIONS(5147),
    [aux_sym_preproc_else_token1] = ACTIONS(5147),
    [aux_sym_preproc_elif_token1] = ACTIONS(5145),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5147),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5147),
    [anon_sym_LPAREN2] = ACTIONS(5147),
    [anon_sym_DASH] = ACTIONS(5145),
    [anon_sym_PLUS] = ACTIONS(5145),
    [anon_sym_STAR] = ACTIONS(5147),
    [anon_sym_SLASH] = ACTIONS(5145),
    [anon_sym_PERCENT] = ACTIONS(5147),
    [anon_sym_PIPE_PIPE] = ACTIONS(5147),
    [anon_sym_AMP_AMP] = ACTIONS(5147),
    [anon_sym_PIPE] = ACTIONS(5145),
    [anon_sym_CARET] = ACTIONS(5147),
    [anon_sym_AMP] = ACTIONS(5145),
    [anon_sym_EQ_EQ] = ACTIONS(5147),
    [anon_sym_BANG_EQ] = ACTIONS(5147),
    [anon_sym_GT] = ACTIONS(5145),
    [anon_sym_GT_EQ] = ACTIONS(5147),
    [anon_sym_LT_EQ] = ACTIONS(5145),
    [anon_sym_LT] = ACTIONS(5145),
    [anon_sym_LT_LT] = ACTIONS(5145),
    [anon_sym_GT_GT] = ACTIONS(5147),
    [anon_sym_SEMI] = ACTIONS(5147),
    [anon_sym___extension__] = ACTIONS(5145),
    [anon_sym___global__] = ACTIONS(5145),
    [anon_sym___attribute__] = ACTIONS(5145),
    [anon_sym_LBRACE] = ACTIONS(5147),
    [anon_sym_RBRACE] = ACTIONS(5147),
    [anon_sym_LBRACK] = ACTIONS(5147),
    [anon_sym_RBRACK] = ACTIONS(5147),
    [anon_sym_const] = ACTIONS(5145),
    [anon_sym_constexpr] = ACTIONS(5145),
    [anon_sym_volatile] = ACTIONS(5145),
    [anon_sym_restrict] = ACTIONS(5145),
    [anon_sym___restrict__] = ACTIONS(5145),
    [anon_sym__Atomic] = ACTIONS(5145),
    [anon_sym__Noreturn] = ACTIONS(5145),
    [anon_sym_noreturn] = ACTIONS(5145),
    [anon_sym_mutable] = ACTIONS(5145),
    [anon_sym_constinit] = ACTIONS(5145),
    [anon_sym_consteval] = ACTIONS(5145),
    [anon_sym___shared__] = ACTIONS(5145),
    [anon_sym___local__] = ACTIONS(5145),
    [anon_sym___constant__] = ACTIONS(5145),
    [anon_sym___managed__] = ACTIONS(5145),
    [anon_sym___grid_constant__] = ACTIONS(5145),
    [anon_sym_alignas] = ACTIONS(5145),
    [anon_sym__Alignas] = ACTIONS(5145),
    [anon_sym_COLON] = ACTIONS(5147),
    [anon_sym_QMARK] = ACTIONS(5147),
    [anon_sym_LT_EQ_GT] = ACTIONS(5147),
    [anon_sym_or] = ACTIONS(5145),
    [anon_sym_and] = ACTIONS(5145),
    [anon_sym_bitor] = ACTIONS(5145),
    [anon_sym_xor] = ACTIONS(5145),
    [anon_sym_bitand] = ACTIONS(5145),
    [anon_sym_not_eq] = ACTIONS(5145),
    [anon_sym_DASH_DASH] = ACTIONS(5147),
    [anon_sym_PLUS_PLUS] = ACTIONS(5147),
    [anon_sym_DOT] = ACTIONS(5145),
    [anon_sym_DOT_STAR] = ACTIONS(5147),
    [anon_sym_DASH_GT] = ACTIONS(5147),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5145),
    [anon_sym_decltype] = ACTIONS(5145),
    [anon_sym_final] = ACTIONS(5145),
    [anon_sym_override] = ACTIONS(5145),
    [anon_sym_requires] = ACTIONS(5145),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5147),
  },
  [2104] = {
    [sym_identifier] = ACTIONS(5179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5181),
    [anon_sym_COMMA] = ACTIONS(5181),
    [anon_sym_RPAREN] = ACTIONS(5181),
    [anon_sym_LPAREN2] = ACTIONS(5181),
    [anon_sym_TILDE] = ACTIONS(5181),
    [anon_sym_STAR] = ACTIONS(5181),
    [anon_sym_PIPE_PIPE] = ACTIONS(5181),
    [anon_sym_AMP_AMP] = ACTIONS(5181),
    [anon_sym_AMP] = ACTIONS(5179),
    [anon_sym_SEMI] = ACTIONS(5181),
    [anon_sym___extension__] = ACTIONS(5179),
    [anon_sym___device__] = ACTIONS(5179),
    [anon_sym___host__] = ACTIONS(5179),
    [anon_sym___global__] = ACTIONS(5179),
    [anon_sym___forceinline__] = ACTIONS(5179),
    [anon_sym___noinline__] = ACTIONS(5179),
    [anon_sym_extern] = ACTIONS(5179),
    [anon_sym___attribute__] = ACTIONS(5179),
    [anon_sym_COLON_COLON] = ACTIONS(5183),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5181),
    [anon_sym___declspec] = ACTIONS(5179),
    [anon_sym___based] = ACTIONS(5179),
    [anon_sym___cdecl] = ACTIONS(5179),
    [anon_sym___clrcall] = ACTIONS(5179),
    [anon_sym___stdcall] = ACTIONS(5179),
    [anon_sym___fastcall] = ACTIONS(5179),
    [anon_sym___thiscall] = ACTIONS(5179),
    [anon_sym___vectorcall] = ACTIONS(5179),
    [anon_sym_LBRACE] = ACTIONS(5181),
    [anon_sym_LBRACK] = ACTIONS(5179),
    [anon_sym_static] = ACTIONS(5179),
    [anon_sym_EQ] = ACTIONS(5181),
    [anon_sym_register] = ACTIONS(5179),
    [anon_sym_inline] = ACTIONS(5179),
    [anon_sym___inline] = ACTIONS(5179),
    [anon_sym___inline__] = ACTIONS(5179),
    [anon_sym___forceinline] = ACTIONS(5179),
    [anon_sym_thread_local] = ACTIONS(5179),
    [anon_sym___thread] = ACTIONS(5179),
    [anon_sym_const] = ACTIONS(5179),
    [anon_sym_constexpr] = ACTIONS(5179),
    [anon_sym_volatile] = ACTIONS(5179),
    [anon_sym_restrict] = ACTIONS(5179),
    [anon_sym___restrict__] = ACTIONS(5179),
    [anon_sym__Atomic] = ACTIONS(5179),
    [anon_sym__Noreturn] = ACTIONS(5179),
    [anon_sym_noreturn] = ACTIONS(5179),
    [anon_sym_mutable] = ACTIONS(5179),
    [anon_sym_constinit] = ACTIONS(5179),
    [anon_sym_consteval] = ACTIONS(5179),
    [anon_sym___shared__] = ACTIONS(5179),
    [anon_sym___local__] = ACTIONS(5179),
    [anon_sym___constant__] = ACTIONS(5179),
    [anon_sym___managed__] = ACTIONS(5179),
    [anon_sym___grid_constant__] = ACTIONS(5179),
    [anon_sym_alignas] = ACTIONS(5179),
    [anon_sym__Alignas] = ACTIONS(5179),
    [anon_sym_COLON] = ACTIONS(5179),
    [anon_sym_or] = ACTIONS(5179),
    [anon_sym_and] = ACTIONS(5179),
    [anon_sym_asm] = ACTIONS(5179),
    [anon_sym___asm__] = ACTIONS(5179),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5179),
    [anon_sym_decltype] = ACTIONS(5179),
    [anon_sym_final] = ACTIONS(5179),
    [anon_sym_override] = ACTIONS(5179),
    [sym_virtual] = ACTIONS(5179),
    [anon_sym_template] = ACTIONS(5179),
    [anon_sym_GT2] = ACTIONS(5181),
    [anon_sym_operator] = ACTIONS(5179),
    [anon_sym_try] = ACTIONS(5179),
    [anon_sym_requires] = ACTIONS(5179),
    [anon_sym___launch_bounds__] = ACTIONS(5179),
  },
  [2105] = {
    [sym_identifier] = ACTIONS(5149),
    [anon_sym_LPAREN2] = ACTIONS(5151),
    [anon_sym_BANG] = ACTIONS(5151),
    [anon_sym_TILDE] = ACTIONS(5151),
    [anon_sym_DASH] = ACTIONS(5149),
    [anon_sym_PLUS] = ACTIONS(5149),
    [anon_sym_STAR] = ACTIONS(5151),
    [anon_sym_AMP] = ACTIONS(5151),
    [anon_sym___extension__] = ACTIONS(5149),
    [anon_sym___global__] = ACTIONS(5149),
    [anon_sym_COLON_COLON] = ACTIONS(5151),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_static] = ACTIONS(5149),
    [anon_sym_RBRACK] = ACTIONS(5151),
    [anon_sym_const] = ACTIONS(5149),
    [anon_sym_constexpr] = ACTIONS(5149),
    [anon_sym_volatile] = ACTIONS(5149),
    [anon_sym_restrict] = ACTIONS(5149),
    [anon_sym___restrict__] = ACTIONS(5149),
    [anon_sym__Atomic] = ACTIONS(5149),
    [anon_sym__Noreturn] = ACTIONS(5149),
    [anon_sym_noreturn] = ACTIONS(5149),
    [anon_sym_mutable] = ACTIONS(5149),
    [anon_sym_constinit] = ACTIONS(5149),
    [anon_sym_consteval] = ACTIONS(5149),
    [anon_sym___shared__] = ACTIONS(5149),
    [anon_sym___local__] = ACTIONS(5149),
    [anon_sym___constant__] = ACTIONS(5149),
    [anon_sym___managed__] = ACTIONS(5149),
    [anon_sym___grid_constant__] = ACTIONS(5149),
    [anon_sym_alignas] = ACTIONS(5149),
    [anon_sym__Alignas] = ACTIONS(5149),
    [sym_primitive_type] = ACTIONS(5149),
    [anon_sym_not] = ACTIONS(5149),
    [anon_sym_compl] = ACTIONS(5149),
    [anon_sym_DASH_DASH] = ACTIONS(5151),
    [anon_sym_PLUS_PLUS] = ACTIONS(5151),
    [anon_sym_sizeof] = ACTIONS(5149),
    [anon_sym___alignof__] = ACTIONS(5149),
    [anon_sym___alignof] = ACTIONS(5149),
    [anon_sym__alignof] = ACTIONS(5149),
    [anon_sym_alignof] = ACTIONS(5149),
    [anon_sym__Alignof] = ACTIONS(5149),
    [anon_sym_offsetof] = ACTIONS(5149),
    [anon_sym__Generic] = ACTIONS(5149),
    [anon_sym_asm] = ACTIONS(5149),
    [anon_sym___asm__] = ACTIONS(5149),
    [sym_number_literal] = ACTIONS(5151),
    [anon_sym_L_SQUOTE] = ACTIONS(5151),
    [anon_sym_u_SQUOTE] = ACTIONS(5151),
    [anon_sym_U_SQUOTE] = ACTIONS(5151),
    [anon_sym_u8_SQUOTE] = ACTIONS(5151),
    [anon_sym_SQUOTE] = ACTIONS(5151),
    [anon_sym_L_DQUOTE] = ACTIONS(5151),
    [anon_sym_u_DQUOTE] = ACTIONS(5151),
    [anon_sym_U_DQUOTE] = ACTIONS(5151),
    [anon_sym_u8_DQUOTE] = ACTIONS(5151),
    [anon_sym_DQUOTE] = ACTIONS(5151),
    [sym_true] = ACTIONS(5149),
    [sym_false] = ACTIONS(5149),
    [anon_sym_NULL] = ACTIONS(5149),
    [anon_sym_nullptr] = ACTIONS(5149),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(5149),
    [anon_sym_template] = ACTIONS(5149),
    [anon_sym_delete] = ACTIONS(5149),
    [anon_sym_R_DQUOTE] = ACTIONS(5151),
    [anon_sym_LR_DQUOTE] = ACTIONS(5151),
    [anon_sym_uR_DQUOTE] = ACTIONS(5151),
    [anon_sym_UR_DQUOTE] = ACTIONS(5151),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5151),
    [anon_sym_co_await] = ACTIONS(5149),
    [anon_sym_new] = ACTIONS(5149),
    [anon_sym_requires] = ACTIONS(5149),
    [sym_this] = ACTIONS(5149),
  },
  [2106] = {
    [sym_identifier] = ACTIONS(5390),
    [anon_sym_LPAREN2] = ACTIONS(5392),
    [anon_sym_TILDE] = ACTIONS(5392),
    [anon_sym_STAR] = ACTIONS(5392),
    [anon_sym_PIPE_PIPE] = ACTIONS(5394),
    [anon_sym_AMP_AMP] = ACTIONS(5396),
    [anon_sym_AMP] = ACTIONS(5390),
    [anon_sym___extension__] = ACTIONS(5390),
    [anon_sym___device__] = ACTIONS(5390),
    [anon_sym___host__] = ACTIONS(5390),
    [anon_sym___global__] = ACTIONS(5390),
    [anon_sym___forceinline__] = ACTIONS(5390),
    [anon_sym___noinline__] = ACTIONS(5390),
    [anon_sym_extern] = ACTIONS(5390),
    [anon_sym___attribute__] = ACTIONS(5390),
    [anon_sym_COLON_COLON] = ACTIONS(5392),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5392),
    [anon_sym___declspec] = ACTIONS(5390),
    [anon_sym___based] = ACTIONS(5390),
    [anon_sym___cdecl] = ACTIONS(5390),
    [anon_sym___clrcall] = ACTIONS(5390),
    [anon_sym___stdcall] = ACTIONS(5390),
    [anon_sym___fastcall] = ACTIONS(5390),
    [anon_sym___thiscall] = ACTIONS(5390),
    [anon_sym___vectorcall] = ACTIONS(5390),
    [anon_sym_signed] = ACTIONS(5390),
    [anon_sym_unsigned] = ACTIONS(5390),
    [anon_sym_long] = ACTIONS(5390),
    [anon_sym_short] = ACTIONS(5390),
    [anon_sym_LBRACK] = ACTIONS(5390),
    [anon_sym_static] = ACTIONS(5390),
    [anon_sym_register] = ACTIONS(5390),
    [anon_sym_inline] = ACTIONS(5390),
    [anon_sym___inline] = ACTIONS(5390),
    [anon_sym___inline__] = ACTIONS(5390),
    [anon_sym___forceinline] = ACTIONS(5390),
    [anon_sym_thread_local] = ACTIONS(5390),
    [anon_sym___thread] = ACTIONS(5390),
    [anon_sym_const] = ACTIONS(5390),
    [anon_sym_constexpr] = ACTIONS(5390),
    [anon_sym_volatile] = ACTIONS(5390),
    [anon_sym_restrict] = ACTIONS(5390),
    [anon_sym___restrict__] = ACTIONS(5390),
    [anon_sym__Atomic] = ACTIONS(5390),
    [anon_sym__Noreturn] = ACTIONS(5390),
    [anon_sym_noreturn] = ACTIONS(5390),
    [anon_sym_mutable] = ACTIONS(5390),
    [anon_sym_constinit] = ACTIONS(5390),
    [anon_sym_consteval] = ACTIONS(5390),
    [anon_sym___shared__] = ACTIONS(5390),
    [anon_sym___local__] = ACTIONS(5390),
    [anon_sym___constant__] = ACTIONS(5390),
    [anon_sym___managed__] = ACTIONS(5390),
    [anon_sym___grid_constant__] = ACTIONS(5390),
    [anon_sym_alignas] = ACTIONS(5390),
    [anon_sym__Alignas] = ACTIONS(5390),
    [sym_primitive_type] = ACTIONS(5390),
    [anon_sym_enum] = ACTIONS(5390),
    [anon_sym_class] = ACTIONS(5390),
    [anon_sym_struct] = ACTIONS(5390),
    [anon_sym_union] = ACTIONS(5390),
    [anon_sym_or] = ACTIONS(5398),
    [anon_sym_and] = ACTIONS(5400),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5390),
    [anon_sym_decltype] = ACTIONS(5390),
    [sym_virtual] = ACTIONS(5390),
    [anon_sym_explicit] = ACTIONS(5390),
    [anon_sym_typename] = ACTIONS(5390),
    [anon_sym_template] = ACTIONS(5390),
    [anon_sym_operator] = ACTIONS(5390),
    [anon_sym_friend] = ACTIONS(5390),
    [anon_sym_using] = ACTIONS(5390),
    [anon_sym_concept] = ACTIONS(5390),
    [anon_sym___launch_bounds__] = ACTIONS(5390),
  },
  [2107] = {
    [sym_identifier] = ACTIONS(5179),
    [anon_sym_LPAREN2] = ACTIONS(5181),
    [anon_sym_TILDE] = ACTIONS(5181),
    [anon_sym_STAR] = ACTIONS(5181),
    [anon_sym_PIPE_PIPE] = ACTIONS(5181),
    [anon_sym_AMP_AMP] = ACTIONS(5181),
    [anon_sym_AMP] = ACTIONS(5179),
    [anon_sym___extension__] = ACTIONS(5179),
    [anon_sym___device__] = ACTIONS(5179),
    [anon_sym___host__] = ACTIONS(5179),
    [anon_sym___global__] = ACTIONS(5179),
    [anon_sym___forceinline__] = ACTIONS(5179),
    [anon_sym___noinline__] = ACTIONS(5179),
    [anon_sym_extern] = ACTIONS(5179),
    [anon_sym___attribute__] = ACTIONS(5179),
    [anon_sym_COLON_COLON] = ACTIONS(5183),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5181),
    [anon_sym___declspec] = ACTIONS(5179),
    [anon_sym___based] = ACTIONS(5179),
    [anon_sym___cdecl] = ACTIONS(5179),
    [anon_sym___clrcall] = ACTIONS(5179),
    [anon_sym___stdcall] = ACTIONS(5179),
    [anon_sym___fastcall] = ACTIONS(5179),
    [anon_sym___thiscall] = ACTIONS(5179),
    [anon_sym___vectorcall] = ACTIONS(5179),
    [anon_sym_signed] = ACTIONS(5179),
    [anon_sym_unsigned] = ACTIONS(5179),
    [anon_sym_long] = ACTIONS(5179),
    [anon_sym_short] = ACTIONS(5179),
    [anon_sym_LBRACK] = ACTIONS(5179),
    [anon_sym_static] = ACTIONS(5179),
    [anon_sym_register] = ACTIONS(5179),
    [anon_sym_inline] = ACTIONS(5179),
    [anon_sym___inline] = ACTIONS(5179),
    [anon_sym___inline__] = ACTIONS(5179),
    [anon_sym___forceinline] = ACTIONS(5179),
    [anon_sym_thread_local] = ACTIONS(5179),
    [anon_sym___thread] = ACTIONS(5179),
    [anon_sym_const] = ACTIONS(5179),
    [anon_sym_constexpr] = ACTIONS(5179),
    [anon_sym_volatile] = ACTIONS(5179),
    [anon_sym_restrict] = ACTIONS(5179),
    [anon_sym___restrict__] = ACTIONS(5179),
    [anon_sym__Atomic] = ACTIONS(5179),
    [anon_sym__Noreturn] = ACTIONS(5179),
    [anon_sym_noreturn] = ACTIONS(5179),
    [anon_sym_mutable] = ACTIONS(5179),
    [anon_sym_constinit] = ACTIONS(5179),
    [anon_sym_consteval] = ACTIONS(5179),
    [anon_sym___shared__] = ACTIONS(5179),
    [anon_sym___local__] = ACTIONS(5179),
    [anon_sym___constant__] = ACTIONS(5179),
    [anon_sym___managed__] = ACTIONS(5179),
    [anon_sym___grid_constant__] = ACTIONS(5179),
    [anon_sym_alignas] = ACTIONS(5179),
    [anon_sym__Alignas] = ACTIONS(5179),
    [sym_primitive_type] = ACTIONS(5179),
    [anon_sym_enum] = ACTIONS(5179),
    [anon_sym_class] = ACTIONS(5179),
    [anon_sym_struct] = ACTIONS(5179),
    [anon_sym_union] = ACTIONS(5179),
    [anon_sym_or] = ACTIONS(5179),
    [anon_sym_and] = ACTIONS(5179),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5179),
    [anon_sym_decltype] = ACTIONS(5179),
    [sym_virtual] = ACTIONS(5179),
    [anon_sym_explicit] = ACTIONS(5179),
    [anon_sym_typename] = ACTIONS(5179),
    [anon_sym_template] = ACTIONS(5179),
    [anon_sym_operator] = ACTIONS(5179),
    [anon_sym_friend] = ACTIONS(5179),
    [anon_sym_using] = ACTIONS(5179),
    [anon_sym_concept] = ACTIONS(5179),
    [anon_sym___launch_bounds__] = ACTIONS(5179),
  },
  [2108] = {
    [sym_identifier] = ACTIONS(2586),
    [anon_sym_LPAREN2] = ACTIONS(2588),
    [anon_sym_BANG] = ACTIONS(2588),
    [anon_sym_TILDE] = ACTIONS(2588),
    [anon_sym_DASH] = ACTIONS(2586),
    [anon_sym_PLUS] = ACTIONS(2586),
    [anon_sym_STAR] = ACTIONS(2588),
    [anon_sym_AMP] = ACTIONS(2588),
    [anon_sym___extension__] = ACTIONS(2586),
    [anon_sym___global__] = ACTIONS(2586),
    [anon_sym_COLON_COLON] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_static] = ACTIONS(2586),
    [anon_sym_RBRACK] = ACTIONS(2588),
    [anon_sym_const] = ACTIONS(2586),
    [anon_sym_constexpr] = ACTIONS(2586),
    [anon_sym_volatile] = ACTIONS(2586),
    [anon_sym_restrict] = ACTIONS(2586),
    [anon_sym___restrict__] = ACTIONS(2586),
    [anon_sym__Atomic] = ACTIONS(2586),
    [anon_sym__Noreturn] = ACTIONS(2586),
    [anon_sym_noreturn] = ACTIONS(2586),
    [anon_sym_mutable] = ACTIONS(2586),
    [anon_sym_constinit] = ACTIONS(2586),
    [anon_sym_consteval] = ACTIONS(2586),
    [anon_sym___shared__] = ACTIONS(2586),
    [anon_sym___local__] = ACTIONS(2586),
    [anon_sym___constant__] = ACTIONS(2586),
    [anon_sym___managed__] = ACTIONS(2586),
    [anon_sym___grid_constant__] = ACTIONS(2586),
    [anon_sym_alignas] = ACTIONS(2586),
    [anon_sym__Alignas] = ACTIONS(2586),
    [sym_primitive_type] = ACTIONS(2586),
    [anon_sym_not] = ACTIONS(2586),
    [anon_sym_compl] = ACTIONS(2586),
    [anon_sym_DASH_DASH] = ACTIONS(2588),
    [anon_sym_PLUS_PLUS] = ACTIONS(2588),
    [anon_sym_sizeof] = ACTIONS(2586),
    [anon_sym___alignof__] = ACTIONS(2586),
    [anon_sym___alignof] = ACTIONS(2586),
    [anon_sym__alignof] = ACTIONS(2586),
    [anon_sym_alignof] = ACTIONS(2586),
    [anon_sym__Alignof] = ACTIONS(2586),
    [anon_sym_offsetof] = ACTIONS(2586),
    [anon_sym__Generic] = ACTIONS(2586),
    [anon_sym_asm] = ACTIONS(2586),
    [anon_sym___asm__] = ACTIONS(2586),
    [sym_number_literal] = ACTIONS(2588),
    [anon_sym_L_SQUOTE] = ACTIONS(2588),
    [anon_sym_u_SQUOTE] = ACTIONS(2588),
    [anon_sym_U_SQUOTE] = ACTIONS(2588),
    [anon_sym_u8_SQUOTE] = ACTIONS(2588),
    [anon_sym_SQUOTE] = ACTIONS(2588),
    [anon_sym_L_DQUOTE] = ACTIONS(2588),
    [anon_sym_u_DQUOTE] = ACTIONS(2588),
    [anon_sym_U_DQUOTE] = ACTIONS(2588),
    [anon_sym_u8_DQUOTE] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(2588),
    [sym_true] = ACTIONS(2586),
    [sym_false] = ACTIONS(2586),
    [anon_sym_NULL] = ACTIONS(2586),
    [anon_sym_nullptr] = ACTIONS(2586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2586),
    [anon_sym_template] = ACTIONS(2586),
    [anon_sym_delete] = ACTIONS(2586),
    [anon_sym_R_DQUOTE] = ACTIONS(2588),
    [anon_sym_LR_DQUOTE] = ACTIONS(2588),
    [anon_sym_uR_DQUOTE] = ACTIONS(2588),
    [anon_sym_UR_DQUOTE] = ACTIONS(2588),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2588),
    [anon_sym_co_await] = ACTIONS(2586),
    [anon_sym_new] = ACTIONS(2586),
    [anon_sym_requires] = ACTIONS(2586),
    [sym_this] = ACTIONS(2586),
  },
  [2109] = {
    [sym_identifier] = ACTIONS(5185),
    [anon_sym_LPAREN2] = ACTIONS(5187),
    [anon_sym_TILDE] = ACTIONS(5187),
    [anon_sym_STAR] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5187),
    [anon_sym_AMP_AMP] = ACTIONS(5187),
    [anon_sym_AMP] = ACTIONS(5185),
    [anon_sym___extension__] = ACTIONS(5185),
    [anon_sym___device__] = ACTIONS(5185),
    [anon_sym___host__] = ACTIONS(5185),
    [anon_sym___global__] = ACTIONS(5185),
    [anon_sym___forceinline__] = ACTIONS(5185),
    [anon_sym___noinline__] = ACTIONS(5185),
    [anon_sym_extern] = ACTIONS(5185),
    [anon_sym___attribute__] = ACTIONS(5185),
    [anon_sym_COLON_COLON] = ACTIONS(5183),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5187),
    [anon_sym___declspec] = ACTIONS(5185),
    [anon_sym___based] = ACTIONS(5185),
    [anon_sym___cdecl] = ACTIONS(5185),
    [anon_sym___clrcall] = ACTIONS(5185),
    [anon_sym___stdcall] = ACTIONS(5185),
    [anon_sym___fastcall] = ACTIONS(5185),
    [anon_sym___thiscall] = ACTIONS(5185),
    [anon_sym___vectorcall] = ACTIONS(5185),
    [anon_sym_signed] = ACTIONS(5185),
    [anon_sym_unsigned] = ACTIONS(5185),
    [anon_sym_long] = ACTIONS(5185),
    [anon_sym_short] = ACTIONS(5185),
    [anon_sym_LBRACK] = ACTIONS(5185),
    [anon_sym_static] = ACTIONS(5185),
    [anon_sym_register] = ACTIONS(5185),
    [anon_sym_inline] = ACTIONS(5185),
    [anon_sym___inline] = ACTIONS(5185),
    [anon_sym___inline__] = ACTIONS(5185),
    [anon_sym___forceinline] = ACTIONS(5185),
    [anon_sym_thread_local] = ACTIONS(5185),
    [anon_sym___thread] = ACTIONS(5185),
    [anon_sym_const] = ACTIONS(5185),
    [anon_sym_constexpr] = ACTIONS(5185),
    [anon_sym_volatile] = ACTIONS(5185),
    [anon_sym_restrict] = ACTIONS(5185),
    [anon_sym___restrict__] = ACTIONS(5185),
    [anon_sym__Atomic] = ACTIONS(5185),
    [anon_sym__Noreturn] = ACTIONS(5185),
    [anon_sym_noreturn] = ACTIONS(5185),
    [anon_sym_mutable] = ACTIONS(5185),
    [anon_sym_constinit] = ACTIONS(5185),
    [anon_sym_consteval] = ACTIONS(5185),
    [anon_sym___shared__] = ACTIONS(5185),
    [anon_sym___local__] = ACTIONS(5185),
    [anon_sym___constant__] = ACTIONS(5185),
    [anon_sym___managed__] = ACTIONS(5185),
    [anon_sym___grid_constant__] = ACTIONS(5185),
    [anon_sym_alignas] = ACTIONS(5185),
    [anon_sym__Alignas] = ACTIONS(5185),
    [sym_primitive_type] = ACTIONS(5185),
    [anon_sym_enum] = ACTIONS(5185),
    [anon_sym_class] = ACTIONS(5185),
    [anon_sym_struct] = ACTIONS(5185),
    [anon_sym_union] = ACTIONS(5185),
    [anon_sym_or] = ACTIONS(5185),
    [anon_sym_and] = ACTIONS(5185),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5185),
    [anon_sym_decltype] = ACTIONS(5185),
    [sym_virtual] = ACTIONS(5185),
    [anon_sym_explicit] = ACTIONS(5185),
    [anon_sym_typename] = ACTIONS(5185),
    [anon_sym_template] = ACTIONS(5185),
    [anon_sym_operator] = ACTIONS(5185),
    [anon_sym_friend] = ACTIONS(5185),
    [anon_sym_using] = ACTIONS(5185),
    [anon_sym_concept] = ACTIONS(5185),
    [anon_sym___launch_bounds__] = ACTIONS(5185),
  },
  [2110] = {
    [sym_identifier] = ACTIONS(5179),
    [anon_sym_LPAREN2] = ACTIONS(5181),
    [anon_sym_TILDE] = ACTIONS(5181),
    [anon_sym_STAR] = ACTIONS(5181),
    [anon_sym_PIPE_PIPE] = ACTIONS(5181),
    [anon_sym_AMP_AMP] = ACTIONS(5181),
    [anon_sym_AMP] = ACTIONS(5179),
    [anon_sym___extension__] = ACTIONS(5179),
    [anon_sym___device__] = ACTIONS(5179),
    [anon_sym___host__] = ACTIONS(5179),
    [anon_sym___global__] = ACTIONS(5179),
    [anon_sym___forceinline__] = ACTIONS(5179),
    [anon_sym___noinline__] = ACTIONS(5179),
    [anon_sym_extern] = ACTIONS(5179),
    [anon_sym___attribute__] = ACTIONS(5179),
    [anon_sym_COLON_COLON] = ACTIONS(5183),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5181),
    [anon_sym___declspec] = ACTIONS(5179),
    [anon_sym___based] = ACTIONS(5179),
    [anon_sym___cdecl] = ACTIONS(5179),
    [anon_sym___clrcall] = ACTIONS(5179),
    [anon_sym___stdcall] = ACTIONS(5179),
    [anon_sym___fastcall] = ACTIONS(5179),
    [anon_sym___thiscall] = ACTIONS(5179),
    [anon_sym___vectorcall] = ACTIONS(5179),
    [anon_sym_signed] = ACTIONS(5179),
    [anon_sym_unsigned] = ACTIONS(5179),
    [anon_sym_long] = ACTIONS(5179),
    [anon_sym_short] = ACTIONS(5179),
    [anon_sym_LBRACK] = ACTIONS(5179),
    [anon_sym_static] = ACTIONS(5179),
    [anon_sym_register] = ACTIONS(5179),
    [anon_sym_inline] = ACTIONS(5179),
    [anon_sym___inline] = ACTIONS(5179),
    [anon_sym___inline__] = ACTIONS(5179),
    [anon_sym___forceinline] = ACTIONS(5179),
    [anon_sym_thread_local] = ACTIONS(5179),
    [anon_sym___thread] = ACTIONS(5179),
    [anon_sym_const] = ACTIONS(5179),
    [anon_sym_constexpr] = ACTIONS(5179),
    [anon_sym_volatile] = ACTIONS(5179),
    [anon_sym_restrict] = ACTIONS(5179),
    [anon_sym___restrict__] = ACTIONS(5179),
    [anon_sym__Atomic] = ACTIONS(5179),
    [anon_sym__Noreturn] = ACTIONS(5179),
    [anon_sym_noreturn] = ACTIONS(5179),
    [anon_sym_mutable] = ACTIONS(5179),
    [anon_sym_constinit] = ACTIONS(5179),
    [anon_sym_consteval] = ACTIONS(5179),
    [anon_sym___shared__] = ACTIONS(5179),
    [anon_sym___local__] = ACTIONS(5179),
    [anon_sym___constant__] = ACTIONS(5179),
    [anon_sym___managed__] = ACTIONS(5179),
    [anon_sym___grid_constant__] = ACTIONS(5179),
    [anon_sym_alignas] = ACTIONS(5179),
    [anon_sym__Alignas] = ACTIONS(5179),
    [sym_primitive_type] = ACTIONS(5179),
    [anon_sym_enum] = ACTIONS(5179),
    [anon_sym_class] = ACTIONS(5179),
    [anon_sym_struct] = ACTIONS(5179),
    [anon_sym_union] = ACTIONS(5179),
    [anon_sym_or] = ACTIONS(5179),
    [anon_sym_and] = ACTIONS(5179),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5179),
    [anon_sym_decltype] = ACTIONS(5179),
    [sym_virtual] = ACTIONS(5179),
    [anon_sym_explicit] = ACTIONS(5179),
    [anon_sym_typename] = ACTIONS(5179),
    [anon_sym_template] = ACTIONS(5179),
    [anon_sym_operator] = ACTIONS(5179),
    [anon_sym_friend] = ACTIONS(5179),
    [anon_sym_using] = ACTIONS(5179),
    [anon_sym_concept] = ACTIONS(5179),
    [anon_sym___launch_bounds__] = ACTIONS(5179),
  },
  [2111] = {
    [sym_identifier] = ACTIONS(5196),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5198),
    [anon_sym_COMMA] = ACTIONS(5198),
    [anon_sym_RPAREN] = ACTIONS(5198),
    [anon_sym_LPAREN2] = ACTIONS(5198),
    [anon_sym_TILDE] = ACTIONS(5198),
    [anon_sym_STAR] = ACTIONS(5198),
    [anon_sym_PIPE_PIPE] = ACTIONS(5198),
    [anon_sym_AMP_AMP] = ACTIONS(5198),
    [anon_sym_AMP] = ACTIONS(5196),
    [anon_sym_SEMI] = ACTIONS(5198),
    [anon_sym___extension__] = ACTIONS(5196),
    [anon_sym___device__] = ACTIONS(5196),
    [anon_sym___host__] = ACTIONS(5196),
    [anon_sym___global__] = ACTIONS(5196),
    [anon_sym___forceinline__] = ACTIONS(5196),
    [anon_sym___noinline__] = ACTIONS(5196),
    [anon_sym_extern] = ACTIONS(5196),
    [anon_sym___attribute__] = ACTIONS(5196),
    [anon_sym_COLON_COLON] = ACTIONS(5198),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5198),
    [anon_sym___declspec] = ACTIONS(5196),
    [anon_sym___based] = ACTIONS(5196),
    [anon_sym___cdecl] = ACTIONS(5196),
    [anon_sym___clrcall] = ACTIONS(5196),
    [anon_sym___stdcall] = ACTIONS(5196),
    [anon_sym___fastcall] = ACTIONS(5196),
    [anon_sym___thiscall] = ACTIONS(5196),
    [anon_sym___vectorcall] = ACTIONS(5196),
    [anon_sym_LBRACE] = ACTIONS(5198),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_static] = ACTIONS(5196),
    [anon_sym_EQ] = ACTIONS(5198),
    [anon_sym_register] = ACTIONS(5196),
    [anon_sym_inline] = ACTIONS(5196),
    [anon_sym___inline] = ACTIONS(5196),
    [anon_sym___inline__] = ACTIONS(5196),
    [anon_sym___forceinline] = ACTIONS(5196),
    [anon_sym_thread_local] = ACTIONS(5196),
    [anon_sym___thread] = ACTIONS(5196),
    [anon_sym_const] = ACTIONS(5196),
    [anon_sym_constexpr] = ACTIONS(5196),
    [anon_sym_volatile] = ACTIONS(5196),
    [anon_sym_restrict] = ACTIONS(5196),
    [anon_sym___restrict__] = ACTIONS(5196),
    [anon_sym__Atomic] = ACTIONS(5196),
    [anon_sym__Noreturn] = ACTIONS(5196),
    [anon_sym_noreturn] = ACTIONS(5196),
    [anon_sym_mutable] = ACTIONS(5196),
    [anon_sym_constinit] = ACTIONS(5196),
    [anon_sym_consteval] = ACTIONS(5196),
    [anon_sym___shared__] = ACTIONS(5196),
    [anon_sym___local__] = ACTIONS(5196),
    [anon_sym___constant__] = ACTIONS(5196),
    [anon_sym___managed__] = ACTIONS(5196),
    [anon_sym___grid_constant__] = ACTIONS(5196),
    [anon_sym_alignas] = ACTIONS(5196),
    [anon_sym__Alignas] = ACTIONS(5196),
    [anon_sym_COLON] = ACTIONS(5196),
    [anon_sym_or] = ACTIONS(5196),
    [anon_sym_and] = ACTIONS(5196),
    [anon_sym_asm] = ACTIONS(5196),
    [anon_sym___asm__] = ACTIONS(5196),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5196),
    [anon_sym_decltype] = ACTIONS(5196),
    [anon_sym_final] = ACTIONS(5196),
    [anon_sym_override] = ACTIONS(5196),
    [sym_virtual] = ACTIONS(5196),
    [anon_sym_template] = ACTIONS(5196),
    [anon_sym_GT2] = ACTIONS(5198),
    [anon_sym_operator] = ACTIONS(5196),
    [anon_sym_try] = ACTIONS(5196),
    [anon_sym_requires] = ACTIONS(5196),
    [anon_sym___launch_bounds__] = ACTIONS(5196),
  },
  [2112] = {
    [sym_identifier] = ACTIONS(5179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5181),
    [anon_sym_COMMA] = ACTIONS(5181),
    [anon_sym_RPAREN] = ACTIONS(5181),
    [anon_sym_LPAREN2] = ACTIONS(5181),
    [anon_sym_TILDE] = ACTIONS(5181),
    [anon_sym_STAR] = ACTIONS(5181),
    [anon_sym_PIPE_PIPE] = ACTIONS(5181),
    [anon_sym_AMP_AMP] = ACTIONS(5181),
    [anon_sym_AMP] = ACTIONS(5179),
    [anon_sym_SEMI] = ACTIONS(5181),
    [anon_sym___extension__] = ACTIONS(5179),
    [anon_sym___device__] = ACTIONS(5179),
    [anon_sym___host__] = ACTIONS(5179),
    [anon_sym___global__] = ACTIONS(5179),
    [anon_sym___forceinline__] = ACTIONS(5179),
    [anon_sym___noinline__] = ACTIONS(5179),
    [anon_sym_extern] = ACTIONS(5179),
    [anon_sym___attribute__] = ACTIONS(5179),
    [anon_sym_COLON_COLON] = ACTIONS(5183),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5181),
    [anon_sym___declspec] = ACTIONS(5179),
    [anon_sym___based] = ACTIONS(5179),
    [anon_sym___cdecl] = ACTIONS(5179),
    [anon_sym___clrcall] = ACTIONS(5179),
    [anon_sym___stdcall] = ACTIONS(5179),
    [anon_sym___fastcall] = ACTIONS(5179),
    [anon_sym___thiscall] = ACTIONS(5179),
    [anon_sym___vectorcall] = ACTIONS(5179),
    [anon_sym_LBRACE] = ACTIONS(5181),
    [anon_sym_LBRACK] = ACTIONS(5179),
    [anon_sym_static] = ACTIONS(5179),
    [anon_sym_EQ] = ACTIONS(5181),
    [anon_sym_register] = ACTIONS(5179),
    [anon_sym_inline] = ACTIONS(5179),
    [anon_sym___inline] = ACTIONS(5179),
    [anon_sym___inline__] = ACTIONS(5179),
    [anon_sym___forceinline] = ACTIONS(5179),
    [anon_sym_thread_local] = ACTIONS(5179),
    [anon_sym___thread] = ACTIONS(5179),
    [anon_sym_const] = ACTIONS(5179),
    [anon_sym_constexpr] = ACTIONS(5179),
    [anon_sym_volatile] = ACTIONS(5179),
    [anon_sym_restrict] = ACTIONS(5179),
    [anon_sym___restrict__] = ACTIONS(5179),
    [anon_sym__Atomic] = ACTIONS(5179),
    [anon_sym__Noreturn] = ACTIONS(5179),
    [anon_sym_noreturn] = ACTIONS(5179),
    [anon_sym_mutable] = ACTIONS(5179),
    [anon_sym_constinit] = ACTIONS(5179),
    [anon_sym_consteval] = ACTIONS(5179),
    [anon_sym___shared__] = ACTIONS(5179),
    [anon_sym___local__] = ACTIONS(5179),
    [anon_sym___constant__] = ACTIONS(5179),
    [anon_sym___managed__] = ACTIONS(5179),
    [anon_sym___grid_constant__] = ACTIONS(5179),
    [anon_sym_alignas] = ACTIONS(5179),
    [anon_sym__Alignas] = ACTIONS(5179),
    [anon_sym_COLON] = ACTIONS(5179),
    [anon_sym_or] = ACTIONS(5179),
    [anon_sym_and] = ACTIONS(5179),
    [anon_sym_asm] = ACTIONS(5179),
    [anon_sym___asm__] = ACTIONS(5179),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5179),
    [anon_sym_decltype] = ACTIONS(5179),
    [anon_sym_final] = ACTIONS(5179),
    [anon_sym_override] = ACTIONS(5179),
    [sym_virtual] = ACTIONS(5179),
    [anon_sym_template] = ACTIONS(5179),
    [anon_sym_GT2] = ACTIONS(5181),
    [anon_sym_operator] = ACTIONS(5179),
    [anon_sym_try] = ACTIONS(5179),
    [anon_sym_requires] = ACTIONS(5179),
    [anon_sym___launch_bounds__] = ACTIONS(5179),
  },
  [2113] = {
    [sym_identifier] = ACTIONS(5185),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5187),
    [anon_sym_COMMA] = ACTIONS(5187),
    [anon_sym_RPAREN] = ACTIONS(5187),
    [anon_sym_LPAREN2] = ACTIONS(5187),
    [anon_sym_TILDE] = ACTIONS(5187),
    [anon_sym_STAR] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5187),
    [anon_sym_AMP_AMP] = ACTIONS(5187),
    [anon_sym_AMP] = ACTIONS(5185),
    [anon_sym_SEMI] = ACTIONS(5187),
    [anon_sym___extension__] = ACTIONS(5185),
    [anon_sym___device__] = ACTIONS(5185),
    [anon_sym___host__] = ACTIONS(5185),
    [anon_sym___global__] = ACTIONS(5185),
    [anon_sym___forceinline__] = ACTIONS(5185),
    [anon_sym___noinline__] = ACTIONS(5185),
    [anon_sym_extern] = ACTIONS(5185),
    [anon_sym___attribute__] = ACTIONS(5185),
    [anon_sym_COLON_COLON] = ACTIONS(5183),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5187),
    [anon_sym___declspec] = ACTIONS(5185),
    [anon_sym___based] = ACTIONS(5185),
    [anon_sym___cdecl] = ACTIONS(5185),
    [anon_sym___clrcall] = ACTIONS(5185),
    [anon_sym___stdcall] = ACTIONS(5185),
    [anon_sym___fastcall] = ACTIONS(5185),
    [anon_sym___thiscall] = ACTIONS(5185),
    [anon_sym___vectorcall] = ACTIONS(5185),
    [anon_sym_LBRACE] = ACTIONS(5187),
    [anon_sym_LBRACK] = ACTIONS(5185),
    [anon_sym_static] = ACTIONS(5185),
    [anon_sym_EQ] = ACTIONS(5187),
    [anon_sym_register] = ACTIONS(5185),
    [anon_sym_inline] = ACTIONS(5185),
    [anon_sym___inline] = ACTIONS(5185),
    [anon_sym___inline__] = ACTIONS(5185),
    [anon_sym___forceinline] = ACTIONS(5185),
    [anon_sym_thread_local] = ACTIONS(5185),
    [anon_sym___thread] = ACTIONS(5185),
    [anon_sym_const] = ACTIONS(5185),
    [anon_sym_constexpr] = ACTIONS(5185),
    [anon_sym_volatile] = ACTIONS(5185),
    [anon_sym_restrict] = ACTIONS(5185),
    [anon_sym___restrict__] = ACTIONS(5185),
    [anon_sym__Atomic] = ACTIONS(5185),
    [anon_sym__Noreturn] = ACTIONS(5185),
    [anon_sym_noreturn] = ACTIONS(5185),
    [anon_sym_mutable] = ACTIONS(5185),
    [anon_sym_constinit] = ACTIONS(5185),
    [anon_sym_consteval] = ACTIONS(5185),
    [anon_sym___shared__] = ACTIONS(5185),
    [anon_sym___local__] = ACTIONS(5185),
    [anon_sym___constant__] = ACTIONS(5185),
    [anon_sym___managed__] = ACTIONS(5185),
    [anon_sym___grid_constant__] = ACTIONS(5185),
    [anon_sym_alignas] = ACTIONS(5185),
    [anon_sym__Alignas] = ACTIONS(5185),
    [anon_sym_COLON] = ACTIONS(5185),
    [anon_sym_or] = ACTIONS(5185),
    [anon_sym_and] = ACTIONS(5185),
    [anon_sym_asm] = ACTIONS(5185),
    [anon_sym___asm__] = ACTIONS(5185),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5185),
    [anon_sym_decltype] = ACTIONS(5185),
    [anon_sym_final] = ACTIONS(5185),
    [anon_sym_override] = ACTIONS(5185),
    [sym_virtual] = ACTIONS(5185),
    [anon_sym_template] = ACTIONS(5185),
    [anon_sym_GT2] = ACTIONS(5187),
    [anon_sym_operator] = ACTIONS(5185),
    [anon_sym_try] = ACTIONS(5185),
    [anon_sym_requires] = ACTIONS(5185),
    [anon_sym___launch_bounds__] = ACTIONS(5185),
  },
  [2114] = {
    [sym_identifier] = ACTIONS(5179),
    [anon_sym_LPAREN2] = ACTIONS(5181),
    [anon_sym_TILDE] = ACTIONS(5181),
    [anon_sym_STAR] = ACTIONS(5181),
    [anon_sym_PIPE_PIPE] = ACTIONS(5181),
    [anon_sym_AMP_AMP] = ACTIONS(5181),
    [anon_sym_AMP] = ACTIONS(5179),
    [anon_sym___extension__] = ACTIONS(5179),
    [anon_sym___device__] = ACTIONS(5179),
    [anon_sym___host__] = ACTIONS(5179),
    [anon_sym___global__] = ACTIONS(5179),
    [anon_sym___forceinline__] = ACTIONS(5179),
    [anon_sym___noinline__] = ACTIONS(5179),
    [anon_sym_extern] = ACTIONS(5179),
    [anon_sym___attribute__] = ACTIONS(5179),
    [anon_sym_COLON_COLON] = ACTIONS(5181),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5181),
    [anon_sym___declspec] = ACTIONS(5179),
    [anon_sym___based] = ACTIONS(5179),
    [anon_sym___cdecl] = ACTIONS(5179),
    [anon_sym___clrcall] = ACTIONS(5179),
    [anon_sym___stdcall] = ACTIONS(5179),
    [anon_sym___fastcall] = ACTIONS(5179),
    [anon_sym___thiscall] = ACTIONS(5179),
    [anon_sym___vectorcall] = ACTIONS(5179),
    [anon_sym_signed] = ACTIONS(5179),
    [anon_sym_unsigned] = ACTIONS(5179),
    [anon_sym_long] = ACTIONS(5179),
    [anon_sym_short] = ACTIONS(5179),
    [anon_sym_LBRACK] = ACTIONS(5179),
    [anon_sym_static] = ACTIONS(5179),
    [anon_sym_register] = ACTIONS(5179),
    [anon_sym_inline] = ACTIONS(5179),
    [anon_sym___inline] = ACTIONS(5179),
    [anon_sym___inline__] = ACTIONS(5179),
    [anon_sym___forceinline] = ACTIONS(5179),
    [anon_sym_thread_local] = ACTIONS(5179),
    [anon_sym___thread] = ACTIONS(5179),
    [anon_sym_const] = ACTIONS(5179),
    [anon_sym_constexpr] = ACTIONS(5179),
    [anon_sym_volatile] = ACTIONS(5179),
    [anon_sym_restrict] = ACTIONS(5179),
    [anon_sym___restrict__] = ACTIONS(5179),
    [anon_sym__Atomic] = ACTIONS(5179),
    [anon_sym__Noreturn] = ACTIONS(5179),
    [anon_sym_noreturn] = ACTIONS(5179),
    [anon_sym_mutable] = ACTIONS(5179),
    [anon_sym_constinit] = ACTIONS(5179),
    [anon_sym_consteval] = ACTIONS(5179),
    [anon_sym___shared__] = ACTIONS(5179),
    [anon_sym___local__] = ACTIONS(5179),
    [anon_sym___constant__] = ACTIONS(5179),
    [anon_sym___managed__] = ACTIONS(5179),
    [anon_sym___grid_constant__] = ACTIONS(5179),
    [anon_sym_alignas] = ACTIONS(5179),
    [anon_sym__Alignas] = ACTIONS(5179),
    [sym_primitive_type] = ACTIONS(5179),
    [anon_sym_enum] = ACTIONS(5179),
    [anon_sym_class] = ACTIONS(5179),
    [anon_sym_struct] = ACTIONS(5179),
    [anon_sym_union] = ACTIONS(5179),
    [anon_sym_or] = ACTIONS(5179),
    [anon_sym_and] = ACTIONS(5179),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5179),
    [anon_sym_decltype] = ACTIONS(5179),
    [sym_virtual] = ACTIONS(5179),
    [anon_sym_explicit] = ACTIONS(5179),
    [anon_sym_typename] = ACTIONS(5179),
    [anon_sym_template] = ACTIONS(5179),
    [anon_sym_operator] = ACTIONS(5179),
    [anon_sym_friend] = ACTIONS(5179),
    [anon_sym_using] = ACTIONS(5179),
    [anon_sym_concept] = ACTIONS(5179),
    [anon_sym___launch_bounds__] = ACTIONS(5179),
  },
  [2115] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4144),
    [anon_sym_RPAREN] = ACTIONS(4146),
    [anon_sym_LPAREN2] = ACTIONS(4146),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_STAR] = ACTIONS(4153),
    [anon_sym_SLASH] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4146),
    [anon_sym_PIPE] = ACTIONS(4151),
    [anon_sym_CARET] = ACTIONS(4151),
    [anon_sym_AMP] = ACTIONS(4153),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT] = ACTIONS(4151),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4151),
    [anon_sym_LT] = ACTIONS(4151),
    [anon_sym_LT_LT] = ACTIONS(4151),
    [anon_sym_GT_GT] = ACTIONS(4151),
    [anon_sym___extension__] = ACTIONS(4149),
    [anon_sym___global__] = ACTIONS(4149),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_LBRACE] = ACTIONS(4149),
    [anon_sym_LBRACK] = ACTIONS(4146),
    [anon_sym_EQ] = ACTIONS(4151),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_constexpr] = ACTIONS(4149),
    [anon_sym_volatile] = ACTIONS(4149),
    [anon_sym_restrict] = ACTIONS(4149),
    [anon_sym___restrict__] = ACTIONS(4149),
    [anon_sym__Atomic] = ACTIONS(4149),
    [anon_sym__Noreturn] = ACTIONS(4149),
    [anon_sym_noreturn] = ACTIONS(4149),
    [anon_sym_mutable] = ACTIONS(4149),
    [anon_sym_constinit] = ACTIONS(4149),
    [anon_sym_consteval] = ACTIONS(4149),
    [anon_sym___shared__] = ACTIONS(4149),
    [anon_sym___local__] = ACTIONS(4149),
    [anon_sym___constant__] = ACTIONS(4149),
    [anon_sym___managed__] = ACTIONS(4149),
    [anon_sym___grid_constant__] = ACTIONS(4149),
    [anon_sym_alignas] = ACTIONS(4149),
    [anon_sym__Alignas] = ACTIONS(4149),
    [anon_sym_QMARK] = ACTIONS(4144),
    [anon_sym_STAR_EQ] = ACTIONS(4144),
    [anon_sym_SLASH_EQ] = ACTIONS(4144),
    [anon_sym_PERCENT_EQ] = ACTIONS(4144),
    [anon_sym_PLUS_EQ] = ACTIONS(4144),
    [anon_sym_DASH_EQ] = ACTIONS(4144),
    [anon_sym_LT_LT_EQ] = ACTIONS(4144),
    [anon_sym_GT_GT_EQ] = ACTIONS(4144),
    [anon_sym_AMP_EQ] = ACTIONS(4144),
    [anon_sym_CARET_EQ] = ACTIONS(4144),
    [anon_sym_PIPE_EQ] = ACTIONS(4144),
    [anon_sym_and_eq] = ACTIONS(4144),
    [anon_sym_or_eq] = ACTIONS(4144),
    [anon_sym_xor_eq] = ACTIONS(4144),
    [anon_sym_LT_EQ_GT] = ACTIONS(4144),
    [anon_sym_or] = ACTIONS(4151),
    [anon_sym_and] = ACTIONS(4151),
    [anon_sym_bitor] = ACTIONS(4144),
    [anon_sym_xor] = ACTIONS(4151),
    [anon_sym_bitand] = ACTIONS(4144),
    [anon_sym_not_eq] = ACTIONS(4144),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_DOT_STAR] = ACTIONS(4144),
    [anon_sym_DASH_GT] = ACTIONS(4144),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4149),
    [anon_sym_decltype] = ACTIONS(4149),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4144),
  },
  [2116] = {
    [sym_identifier] = ACTIONS(1897),
    [anon_sym_LPAREN2] = ACTIONS(1895),
    [anon_sym_TILDE] = ACTIONS(1895),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_PIPE_PIPE] = ACTIONS(1895),
    [anon_sym_AMP_AMP] = ACTIONS(1895),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym___extension__] = ACTIONS(1897),
    [anon_sym___device__] = ACTIONS(1897),
    [anon_sym___host__] = ACTIONS(1897),
    [anon_sym___global__] = ACTIONS(1897),
    [anon_sym___forceinline__] = ACTIONS(1897),
    [anon_sym___noinline__] = ACTIONS(1897),
    [anon_sym_extern] = ACTIONS(1897),
    [anon_sym___attribute__] = ACTIONS(1897),
    [anon_sym_COLON_COLON] = ACTIONS(1895),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1895),
    [anon_sym___declspec] = ACTIONS(1897),
    [anon_sym___based] = ACTIONS(1897),
    [anon_sym___cdecl] = ACTIONS(1897),
    [anon_sym___clrcall] = ACTIONS(1897),
    [anon_sym___stdcall] = ACTIONS(1897),
    [anon_sym___fastcall] = ACTIONS(1897),
    [anon_sym___thiscall] = ACTIONS(1897),
    [anon_sym___vectorcall] = ACTIONS(1897),
    [anon_sym_signed] = ACTIONS(1897),
    [anon_sym_unsigned] = ACTIONS(1897),
    [anon_sym_long] = ACTIONS(1897),
    [anon_sym_short] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1897),
    [anon_sym_static] = ACTIONS(1897),
    [anon_sym_register] = ACTIONS(1897),
    [anon_sym_inline] = ACTIONS(1897),
    [anon_sym___inline] = ACTIONS(1897),
    [anon_sym___inline__] = ACTIONS(1897),
    [anon_sym___forceinline] = ACTIONS(1897),
    [anon_sym_thread_local] = ACTIONS(1897),
    [anon_sym___thread] = ACTIONS(1897),
    [anon_sym_const] = ACTIONS(1897),
    [anon_sym_constexpr] = ACTIONS(1897),
    [anon_sym_volatile] = ACTIONS(1897),
    [anon_sym_restrict] = ACTIONS(1897),
    [anon_sym___restrict__] = ACTIONS(1897),
    [anon_sym__Atomic] = ACTIONS(1897),
    [anon_sym__Noreturn] = ACTIONS(1897),
    [anon_sym_noreturn] = ACTIONS(1897),
    [anon_sym_mutable] = ACTIONS(1897),
    [anon_sym_constinit] = ACTIONS(1897),
    [anon_sym_consteval] = ACTIONS(1897),
    [anon_sym___shared__] = ACTIONS(1897),
    [anon_sym___local__] = ACTIONS(1897),
    [anon_sym___constant__] = ACTIONS(1897),
    [anon_sym___managed__] = ACTIONS(1897),
    [anon_sym___grid_constant__] = ACTIONS(1897),
    [anon_sym_alignas] = ACTIONS(1897),
    [anon_sym__Alignas] = ACTIONS(1897),
    [sym_primitive_type] = ACTIONS(1897),
    [anon_sym_enum] = ACTIONS(1897),
    [anon_sym_class] = ACTIONS(1897),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1897),
    [anon_sym_or] = ACTIONS(1897),
    [anon_sym_and] = ACTIONS(1897),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1897),
    [anon_sym_decltype] = ACTIONS(1897),
    [sym_virtual] = ACTIONS(1897),
    [anon_sym_explicit] = ACTIONS(1897),
    [anon_sym_typename] = ACTIONS(1897),
    [anon_sym_template] = ACTIONS(1897),
    [anon_sym_operator] = ACTIONS(1897),
    [anon_sym_friend] = ACTIONS(1897),
    [anon_sym_using] = ACTIONS(1897),
    [anon_sym_concept] = ACTIONS(1897),
    [anon_sym___launch_bounds__] = ACTIONS(1897),
  },
  [2117] = {
    [sym_identifier] = ACTIONS(3988),
    [anon_sym_LPAREN2] = ACTIONS(3990),
    [anon_sym_TILDE] = ACTIONS(3990),
    [anon_sym_STAR] = ACTIONS(3990),
    [anon_sym_PIPE_PIPE] = ACTIONS(3990),
    [anon_sym_AMP_AMP] = ACTIONS(3990),
    [anon_sym_AMP] = ACTIONS(3988),
    [anon_sym___extension__] = ACTIONS(3988),
    [anon_sym___device__] = ACTIONS(3988),
    [anon_sym___host__] = ACTIONS(3988),
    [anon_sym___global__] = ACTIONS(3988),
    [anon_sym___forceinline__] = ACTIONS(3988),
    [anon_sym___noinline__] = ACTIONS(3988),
    [anon_sym_extern] = ACTIONS(3988),
    [anon_sym___attribute__] = ACTIONS(3988),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3990),
    [anon_sym___declspec] = ACTIONS(3988),
    [anon_sym___based] = ACTIONS(3988),
    [anon_sym___cdecl] = ACTIONS(3988),
    [anon_sym___clrcall] = ACTIONS(3988),
    [anon_sym___stdcall] = ACTIONS(3988),
    [anon_sym___fastcall] = ACTIONS(3988),
    [anon_sym___thiscall] = ACTIONS(3988),
    [anon_sym___vectorcall] = ACTIONS(3988),
    [anon_sym_signed] = ACTIONS(3988),
    [anon_sym_unsigned] = ACTIONS(3988),
    [anon_sym_long] = ACTIONS(3988),
    [anon_sym_short] = ACTIONS(3988),
    [anon_sym_LBRACK] = ACTIONS(3988),
    [anon_sym_static] = ACTIONS(3988),
    [anon_sym_register] = ACTIONS(3988),
    [anon_sym_inline] = ACTIONS(3988),
    [anon_sym___inline] = ACTIONS(3988),
    [anon_sym___inline__] = ACTIONS(3988),
    [anon_sym___forceinline] = ACTIONS(3988),
    [anon_sym_thread_local] = ACTIONS(3988),
    [anon_sym___thread] = ACTIONS(3988),
    [anon_sym_const] = ACTIONS(3988),
    [anon_sym_constexpr] = ACTIONS(3988),
    [anon_sym_volatile] = ACTIONS(3988),
    [anon_sym_restrict] = ACTIONS(3988),
    [anon_sym___restrict__] = ACTIONS(3988),
    [anon_sym__Atomic] = ACTIONS(3988),
    [anon_sym__Noreturn] = ACTIONS(3988),
    [anon_sym_noreturn] = ACTIONS(3988),
    [anon_sym_mutable] = ACTIONS(3988),
    [anon_sym_constinit] = ACTIONS(3988),
    [anon_sym_consteval] = ACTIONS(3988),
    [anon_sym___shared__] = ACTIONS(3988),
    [anon_sym___local__] = ACTIONS(3988),
    [anon_sym___constant__] = ACTIONS(3988),
    [anon_sym___managed__] = ACTIONS(3988),
    [anon_sym___grid_constant__] = ACTIONS(3988),
    [anon_sym_alignas] = ACTIONS(3988),
    [anon_sym__Alignas] = ACTIONS(3988),
    [sym_primitive_type] = ACTIONS(3988),
    [anon_sym_enum] = ACTIONS(3988),
    [anon_sym_class] = ACTIONS(3988),
    [anon_sym_struct] = ACTIONS(3988),
    [anon_sym_union] = ACTIONS(3988),
    [anon_sym_or] = ACTIONS(3988),
    [anon_sym_and] = ACTIONS(3988),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3988),
    [anon_sym_decltype] = ACTIONS(3988),
    [sym_virtual] = ACTIONS(3988),
    [anon_sym_explicit] = ACTIONS(3988),
    [anon_sym_typename] = ACTIONS(3988),
    [anon_sym_template] = ACTIONS(3988),
    [anon_sym_operator] = ACTIONS(3988),
    [anon_sym_friend] = ACTIONS(3988),
    [anon_sym_using] = ACTIONS(3988),
    [anon_sym_concept] = ACTIONS(3988),
    [anon_sym___launch_bounds__] = ACTIONS(3988),
  },
  [2118] = {
    [sym_identifier] = ACTIONS(4021),
    [anon_sym_LPAREN2] = ACTIONS(4023),
    [anon_sym_TILDE] = ACTIONS(4023),
    [anon_sym_STAR] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4023),
    [anon_sym_AMP] = ACTIONS(4021),
    [anon_sym___extension__] = ACTIONS(4021),
    [anon_sym___device__] = ACTIONS(4021),
    [anon_sym___host__] = ACTIONS(4021),
    [anon_sym___global__] = ACTIONS(4021),
    [anon_sym___forceinline__] = ACTIONS(4021),
    [anon_sym___noinline__] = ACTIONS(4021),
    [anon_sym_extern] = ACTIONS(4021),
    [anon_sym___attribute__] = ACTIONS(4021),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4023),
    [anon_sym___declspec] = ACTIONS(4021),
    [anon_sym___based] = ACTIONS(4021),
    [anon_sym___cdecl] = ACTIONS(4021),
    [anon_sym___clrcall] = ACTIONS(4021),
    [anon_sym___stdcall] = ACTIONS(4021),
    [anon_sym___fastcall] = ACTIONS(4021),
    [anon_sym___thiscall] = ACTIONS(4021),
    [anon_sym___vectorcall] = ACTIONS(4021),
    [anon_sym_signed] = ACTIONS(4021),
    [anon_sym_unsigned] = ACTIONS(4021),
    [anon_sym_long] = ACTIONS(4021),
    [anon_sym_short] = ACTIONS(4021),
    [anon_sym_LBRACK] = ACTIONS(4021),
    [anon_sym_static] = ACTIONS(4021),
    [anon_sym_register] = ACTIONS(4021),
    [anon_sym_inline] = ACTIONS(4021),
    [anon_sym___inline] = ACTIONS(4021),
    [anon_sym___inline__] = ACTIONS(4021),
    [anon_sym___forceinline] = ACTIONS(4021),
    [anon_sym_thread_local] = ACTIONS(4021),
    [anon_sym___thread] = ACTIONS(4021),
    [anon_sym_const] = ACTIONS(4021),
    [anon_sym_constexpr] = ACTIONS(4021),
    [anon_sym_volatile] = ACTIONS(4021),
    [anon_sym_restrict] = ACTIONS(4021),
    [anon_sym___restrict__] = ACTIONS(4021),
    [anon_sym__Atomic] = ACTIONS(4021),
    [anon_sym__Noreturn] = ACTIONS(4021),
    [anon_sym_noreturn] = ACTIONS(4021),
    [anon_sym_mutable] = ACTIONS(4021),
    [anon_sym_constinit] = ACTIONS(4021),
    [anon_sym_consteval] = ACTIONS(4021),
    [anon_sym___shared__] = ACTIONS(4021),
    [anon_sym___local__] = ACTIONS(4021),
    [anon_sym___constant__] = ACTIONS(4021),
    [anon_sym___managed__] = ACTIONS(4021),
    [anon_sym___grid_constant__] = ACTIONS(4021),
    [anon_sym_alignas] = ACTIONS(4021),
    [anon_sym__Alignas] = ACTIONS(4021),
    [sym_primitive_type] = ACTIONS(4021),
    [anon_sym_enum] = ACTIONS(4021),
    [anon_sym_class] = ACTIONS(4021),
    [anon_sym_struct] = ACTIONS(4021),
    [anon_sym_union] = ACTIONS(4021),
    [anon_sym_or] = ACTIONS(4021),
    [anon_sym_and] = ACTIONS(4021),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4021),
    [anon_sym_decltype] = ACTIONS(4021),
    [sym_virtual] = ACTIONS(4021),
    [anon_sym_explicit] = ACTIONS(4021),
    [anon_sym_typename] = ACTIONS(4021),
    [anon_sym_template] = ACTIONS(4021),
    [anon_sym_operator] = ACTIONS(4021),
    [anon_sym_friend] = ACTIONS(4021),
    [anon_sym_using] = ACTIONS(4021),
    [anon_sym_concept] = ACTIONS(4021),
    [anon_sym___launch_bounds__] = ACTIONS(4021),
  },
  [2119] = {
    [sym_identifier] = ACTIONS(4017),
    [anon_sym_LPAREN2] = ACTIONS(4019),
    [anon_sym_TILDE] = ACTIONS(4019),
    [anon_sym_STAR] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4017),
    [anon_sym___extension__] = ACTIONS(4017),
    [anon_sym___device__] = ACTIONS(4017),
    [anon_sym___host__] = ACTIONS(4017),
    [anon_sym___global__] = ACTIONS(4017),
    [anon_sym___forceinline__] = ACTIONS(4017),
    [anon_sym___noinline__] = ACTIONS(4017),
    [anon_sym_extern] = ACTIONS(4017),
    [anon_sym___attribute__] = ACTIONS(4017),
    [anon_sym_COLON_COLON] = ACTIONS(4019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4019),
    [anon_sym___declspec] = ACTIONS(4017),
    [anon_sym___based] = ACTIONS(4017),
    [anon_sym___cdecl] = ACTIONS(4017),
    [anon_sym___clrcall] = ACTIONS(4017),
    [anon_sym___stdcall] = ACTIONS(4017),
    [anon_sym___fastcall] = ACTIONS(4017),
    [anon_sym___thiscall] = ACTIONS(4017),
    [anon_sym___vectorcall] = ACTIONS(4017),
    [anon_sym_signed] = ACTIONS(4017),
    [anon_sym_unsigned] = ACTIONS(4017),
    [anon_sym_long] = ACTIONS(4017),
    [anon_sym_short] = ACTIONS(4017),
    [anon_sym_LBRACK] = ACTIONS(4017),
    [anon_sym_static] = ACTIONS(4017),
    [anon_sym_register] = ACTIONS(4017),
    [anon_sym_inline] = ACTIONS(4017),
    [anon_sym___inline] = ACTIONS(4017),
    [anon_sym___inline__] = ACTIONS(4017),
    [anon_sym___forceinline] = ACTIONS(4017),
    [anon_sym_thread_local] = ACTIONS(4017),
    [anon_sym___thread] = ACTIONS(4017),
    [anon_sym_const] = ACTIONS(4017),
    [anon_sym_constexpr] = ACTIONS(4017),
    [anon_sym_volatile] = ACTIONS(4017),
    [anon_sym_restrict] = ACTIONS(4017),
    [anon_sym___restrict__] = ACTIONS(4017),
    [anon_sym__Atomic] = ACTIONS(4017),
    [anon_sym__Noreturn] = ACTIONS(4017),
    [anon_sym_noreturn] = ACTIONS(4017),
    [anon_sym_mutable] = ACTIONS(4017),
    [anon_sym_constinit] = ACTIONS(4017),
    [anon_sym_consteval] = ACTIONS(4017),
    [anon_sym___shared__] = ACTIONS(4017),
    [anon_sym___local__] = ACTIONS(4017),
    [anon_sym___constant__] = ACTIONS(4017),
    [anon_sym___managed__] = ACTIONS(4017),
    [anon_sym___grid_constant__] = ACTIONS(4017),
    [anon_sym_alignas] = ACTIONS(4017),
    [anon_sym__Alignas] = ACTIONS(4017),
    [sym_primitive_type] = ACTIONS(4017),
    [anon_sym_enum] = ACTIONS(4017),
    [anon_sym_class] = ACTIONS(4017),
    [anon_sym_struct] = ACTIONS(4017),
    [anon_sym_union] = ACTIONS(4017),
    [anon_sym_or] = ACTIONS(4017),
    [anon_sym_and] = ACTIONS(4017),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4017),
    [anon_sym_decltype] = ACTIONS(4017),
    [sym_virtual] = ACTIONS(4017),
    [anon_sym_explicit] = ACTIONS(4017),
    [anon_sym_typename] = ACTIONS(4017),
    [anon_sym_template] = ACTIONS(4017),
    [anon_sym_operator] = ACTIONS(4017),
    [anon_sym_friend] = ACTIONS(4017),
    [anon_sym_using] = ACTIONS(4017),
    [anon_sym_concept] = ACTIONS(4017),
    [anon_sym___launch_bounds__] = ACTIONS(4017),
  },
  [2120] = {
    [sym_identifier] = ACTIONS(5196),
    [anon_sym_LPAREN2] = ACTIONS(5198),
    [anon_sym_TILDE] = ACTIONS(5198),
    [anon_sym_STAR] = ACTIONS(5198),
    [anon_sym_PIPE_PIPE] = ACTIONS(5198),
    [anon_sym_AMP_AMP] = ACTIONS(5198),
    [anon_sym_AMP] = ACTIONS(5196),
    [anon_sym___extension__] = ACTIONS(5196),
    [anon_sym___device__] = ACTIONS(5196),
    [anon_sym___host__] = ACTIONS(5196),
    [anon_sym___global__] = ACTIONS(5196),
    [anon_sym___forceinline__] = ACTIONS(5196),
    [anon_sym___noinline__] = ACTIONS(5196),
    [anon_sym_extern] = ACTIONS(5196),
    [anon_sym___attribute__] = ACTIONS(5196),
    [anon_sym_COLON_COLON] = ACTIONS(5198),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5198),
    [anon_sym___declspec] = ACTIONS(5196),
    [anon_sym___based] = ACTIONS(5196),
    [anon_sym___cdecl] = ACTIONS(5196),
    [anon_sym___clrcall] = ACTIONS(5196),
    [anon_sym___stdcall] = ACTIONS(5196),
    [anon_sym___fastcall] = ACTIONS(5196),
    [anon_sym___thiscall] = ACTIONS(5196),
    [anon_sym___vectorcall] = ACTIONS(5196),
    [anon_sym_signed] = ACTIONS(5196),
    [anon_sym_unsigned] = ACTIONS(5196),
    [anon_sym_long] = ACTIONS(5196),
    [anon_sym_short] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(5196),
    [anon_sym_static] = ACTIONS(5196),
    [anon_sym_register] = ACTIONS(5196),
    [anon_sym_inline] = ACTIONS(5196),
    [anon_sym___inline] = ACTIONS(5196),
    [anon_sym___inline__] = ACTIONS(5196),
    [anon_sym___forceinline] = ACTIONS(5196),
    [anon_sym_thread_local] = ACTIONS(5196),
    [anon_sym___thread] = ACTIONS(5196),
    [anon_sym_const] = ACTIONS(5196),
    [anon_sym_constexpr] = ACTIONS(5196),
    [anon_sym_volatile] = ACTIONS(5196),
    [anon_sym_restrict] = ACTIONS(5196),
    [anon_sym___restrict__] = ACTIONS(5196),
    [anon_sym__Atomic] = ACTIONS(5196),
    [anon_sym__Noreturn] = ACTIONS(5196),
    [anon_sym_noreturn] = ACTIONS(5196),
    [anon_sym_mutable] = ACTIONS(5196),
    [anon_sym_constinit] = ACTIONS(5196),
    [anon_sym_consteval] = ACTIONS(5196),
    [anon_sym___shared__] = ACTIONS(5196),
    [anon_sym___local__] = ACTIONS(5196),
    [anon_sym___constant__] = ACTIONS(5196),
    [anon_sym___managed__] = ACTIONS(5196),
    [anon_sym___grid_constant__] = ACTIONS(5196),
    [anon_sym_alignas] = ACTIONS(5196),
    [anon_sym__Alignas] = ACTIONS(5196),
    [sym_primitive_type] = ACTIONS(5196),
    [anon_sym_enum] = ACTIONS(5196),
    [anon_sym_class] = ACTIONS(5196),
    [anon_sym_struct] = ACTIONS(5196),
    [anon_sym_union] = ACTIONS(5196),
    [anon_sym_or] = ACTIONS(5196),
    [anon_sym_and] = ACTIONS(5196),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5196),
    [anon_sym_decltype] = ACTIONS(5196),
    [sym_virtual] = ACTIONS(5196),
    [anon_sym_explicit] = ACTIONS(5196),
    [anon_sym_typename] = ACTIONS(5196),
    [anon_sym_template] = ACTIONS(5196),
    [anon_sym_operator] = ACTIONS(5196),
    [anon_sym_friend] = ACTIONS(5196),
    [anon_sym_using] = ACTIONS(5196),
    [anon_sym_concept] = ACTIONS(5196),
    [anon_sym___launch_bounds__] = ACTIONS(5196),
  },
  [2121] = {
    [sym_identifier] = ACTIONS(3996),
    [anon_sym_LPAREN2] = ACTIONS(3998),
    [anon_sym_TILDE] = ACTIONS(3998),
    [anon_sym_STAR] = ACTIONS(3998),
    [anon_sym_PIPE_PIPE] = ACTIONS(3998),
    [anon_sym_AMP_AMP] = ACTIONS(3998),
    [anon_sym_AMP] = ACTIONS(3996),
    [anon_sym___extension__] = ACTIONS(3996),
    [anon_sym___device__] = ACTIONS(3996),
    [anon_sym___host__] = ACTIONS(3996),
    [anon_sym___global__] = ACTIONS(3996),
    [anon_sym___forceinline__] = ACTIONS(3996),
    [anon_sym___noinline__] = ACTIONS(3996),
    [anon_sym_extern] = ACTIONS(3996),
    [anon_sym___attribute__] = ACTIONS(3996),
    [anon_sym_COLON_COLON] = ACTIONS(3998),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3998),
    [anon_sym___declspec] = ACTIONS(3996),
    [anon_sym___based] = ACTIONS(3996),
    [anon_sym___cdecl] = ACTIONS(3996),
    [anon_sym___clrcall] = ACTIONS(3996),
    [anon_sym___stdcall] = ACTIONS(3996),
    [anon_sym___fastcall] = ACTIONS(3996),
    [anon_sym___thiscall] = ACTIONS(3996),
    [anon_sym___vectorcall] = ACTIONS(3996),
    [anon_sym_signed] = ACTIONS(3996),
    [anon_sym_unsigned] = ACTIONS(3996),
    [anon_sym_long] = ACTIONS(3996),
    [anon_sym_short] = ACTIONS(3996),
    [anon_sym_LBRACK] = ACTIONS(3996),
    [anon_sym_static] = ACTIONS(3996),
    [anon_sym_register] = ACTIONS(3996),
    [anon_sym_inline] = ACTIONS(3996),
    [anon_sym___inline] = ACTIONS(3996),
    [anon_sym___inline__] = ACTIONS(3996),
    [anon_sym___forceinline] = ACTIONS(3996),
    [anon_sym_thread_local] = ACTIONS(3996),
    [anon_sym___thread] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3996),
    [anon_sym_constexpr] = ACTIONS(3996),
    [anon_sym_volatile] = ACTIONS(3996),
    [anon_sym_restrict] = ACTIONS(3996),
    [anon_sym___restrict__] = ACTIONS(3996),
    [anon_sym__Atomic] = ACTIONS(3996),
    [anon_sym__Noreturn] = ACTIONS(3996),
    [anon_sym_noreturn] = ACTIONS(3996),
    [anon_sym_mutable] = ACTIONS(3996),
    [anon_sym_constinit] = ACTIONS(3996),
    [anon_sym_consteval] = ACTIONS(3996),
    [anon_sym___shared__] = ACTIONS(3996),
    [anon_sym___local__] = ACTIONS(3996),
    [anon_sym___constant__] = ACTIONS(3996),
    [anon_sym___managed__] = ACTIONS(3996),
    [anon_sym___grid_constant__] = ACTIONS(3996),
    [anon_sym_alignas] = ACTIONS(3996),
    [anon_sym__Alignas] = ACTIONS(3996),
    [sym_primitive_type] = ACTIONS(3996),
    [anon_sym_enum] = ACTIONS(3996),
    [anon_sym_class] = ACTIONS(3996),
    [anon_sym_struct] = ACTIONS(3996),
    [anon_sym_union] = ACTIONS(3996),
    [anon_sym_or] = ACTIONS(3996),
    [anon_sym_and] = ACTIONS(3996),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3996),
    [anon_sym_decltype] = ACTIONS(3996),
    [sym_virtual] = ACTIONS(3996),
    [anon_sym_explicit] = ACTIONS(3996),
    [anon_sym_typename] = ACTIONS(3996),
    [anon_sym_template] = ACTIONS(3996),
    [anon_sym_operator] = ACTIONS(3996),
    [anon_sym_friend] = ACTIONS(3996),
    [anon_sym_using] = ACTIONS(3996),
    [anon_sym_concept] = ACTIONS(3996),
    [anon_sym___launch_bounds__] = ACTIONS(3996),
  },
  [2122] = {
    [sym_identifier] = ACTIONS(3980),
    [anon_sym_LPAREN2] = ACTIONS(3982),
    [anon_sym_TILDE] = ACTIONS(3982),
    [anon_sym_STAR] = ACTIONS(3982),
    [anon_sym_PIPE_PIPE] = ACTIONS(3982),
    [anon_sym_AMP_AMP] = ACTIONS(3982),
    [anon_sym_AMP] = ACTIONS(3980),
    [anon_sym___extension__] = ACTIONS(3980),
    [anon_sym___device__] = ACTIONS(3980),
    [anon_sym___host__] = ACTIONS(3980),
    [anon_sym___global__] = ACTIONS(3980),
    [anon_sym___forceinline__] = ACTIONS(3980),
    [anon_sym___noinline__] = ACTIONS(3980),
    [anon_sym_extern] = ACTIONS(3980),
    [anon_sym___attribute__] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3982),
    [anon_sym___declspec] = ACTIONS(3980),
    [anon_sym___based] = ACTIONS(3980),
    [anon_sym___cdecl] = ACTIONS(3980),
    [anon_sym___clrcall] = ACTIONS(3980),
    [anon_sym___stdcall] = ACTIONS(3980),
    [anon_sym___fastcall] = ACTIONS(3980),
    [anon_sym___thiscall] = ACTIONS(3980),
    [anon_sym___vectorcall] = ACTIONS(3980),
    [anon_sym_signed] = ACTIONS(3980),
    [anon_sym_unsigned] = ACTIONS(3980),
    [anon_sym_long] = ACTIONS(3980),
    [anon_sym_short] = ACTIONS(3980),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_static] = ACTIONS(3980),
    [anon_sym_register] = ACTIONS(3980),
    [anon_sym_inline] = ACTIONS(3980),
    [anon_sym___inline] = ACTIONS(3980),
    [anon_sym___inline__] = ACTIONS(3980),
    [anon_sym___forceinline] = ACTIONS(3980),
    [anon_sym_thread_local] = ACTIONS(3980),
    [anon_sym___thread] = ACTIONS(3980),
    [anon_sym_const] = ACTIONS(3980),
    [anon_sym_constexpr] = ACTIONS(3980),
    [anon_sym_volatile] = ACTIONS(3980),
    [anon_sym_restrict] = ACTIONS(3980),
    [anon_sym___restrict__] = ACTIONS(3980),
    [anon_sym__Atomic] = ACTIONS(3980),
    [anon_sym__Noreturn] = ACTIONS(3980),
    [anon_sym_noreturn] = ACTIONS(3980),
    [anon_sym_mutable] = ACTIONS(3980),
    [anon_sym_constinit] = ACTIONS(3980),
    [anon_sym_consteval] = ACTIONS(3980),
    [anon_sym___shared__] = ACTIONS(3980),
    [anon_sym___local__] = ACTIONS(3980),
    [anon_sym___constant__] = ACTIONS(3980),
    [anon_sym___managed__] = ACTIONS(3980),
    [anon_sym___grid_constant__] = ACTIONS(3980),
    [anon_sym_alignas] = ACTIONS(3980),
    [anon_sym__Alignas] = ACTIONS(3980),
    [sym_primitive_type] = ACTIONS(3980),
    [anon_sym_enum] = ACTIONS(3980),
    [anon_sym_class] = ACTIONS(3980),
    [anon_sym_struct] = ACTIONS(3980),
    [anon_sym_union] = ACTIONS(3980),
    [anon_sym_or] = ACTIONS(3980),
    [anon_sym_and] = ACTIONS(3980),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3980),
    [anon_sym_decltype] = ACTIONS(3980),
    [sym_virtual] = ACTIONS(3980),
    [anon_sym_explicit] = ACTIONS(3980),
    [anon_sym_typename] = ACTIONS(3980),
    [anon_sym_template] = ACTIONS(3980),
    [anon_sym_operator] = ACTIONS(3980),
    [anon_sym_friend] = ACTIONS(3980),
    [anon_sym_using] = ACTIONS(3980),
    [anon_sym_concept] = ACTIONS(3980),
    [anon_sym___launch_bounds__] = ACTIONS(3980),
  },
  [2123] = {
    [sym_identifier] = ACTIONS(3984),
    [anon_sym_LPAREN2] = ACTIONS(3986),
    [anon_sym_TILDE] = ACTIONS(3986),
    [anon_sym_STAR] = ACTIONS(3986),
    [anon_sym_PIPE_PIPE] = ACTIONS(3986),
    [anon_sym_AMP_AMP] = ACTIONS(3986),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym___extension__] = ACTIONS(3984),
    [anon_sym___device__] = ACTIONS(3984),
    [anon_sym___host__] = ACTIONS(3984),
    [anon_sym___global__] = ACTIONS(3984),
    [anon_sym___forceinline__] = ACTIONS(3984),
    [anon_sym___noinline__] = ACTIONS(3984),
    [anon_sym_extern] = ACTIONS(3984),
    [anon_sym___attribute__] = ACTIONS(3984),
    [anon_sym_COLON_COLON] = ACTIONS(3986),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3986),
    [anon_sym___declspec] = ACTIONS(3984),
    [anon_sym___based] = ACTIONS(3984),
    [anon_sym___cdecl] = ACTIONS(3984),
    [anon_sym___clrcall] = ACTIONS(3984),
    [anon_sym___stdcall] = ACTIONS(3984),
    [anon_sym___fastcall] = ACTIONS(3984),
    [anon_sym___thiscall] = ACTIONS(3984),
    [anon_sym___vectorcall] = ACTIONS(3984),
    [anon_sym_signed] = ACTIONS(3984),
    [anon_sym_unsigned] = ACTIONS(3984),
    [anon_sym_long] = ACTIONS(3984),
    [anon_sym_short] = ACTIONS(3984),
    [anon_sym_LBRACK] = ACTIONS(3984),
    [anon_sym_static] = ACTIONS(3984),
    [anon_sym_register] = ACTIONS(3984),
    [anon_sym_inline] = ACTIONS(3984),
    [anon_sym___inline] = ACTIONS(3984),
    [anon_sym___inline__] = ACTIONS(3984),
    [anon_sym___forceinline] = ACTIONS(3984),
    [anon_sym_thread_local] = ACTIONS(3984),
    [anon_sym___thread] = ACTIONS(3984),
    [anon_sym_const] = ACTIONS(3984),
    [anon_sym_constexpr] = ACTIONS(3984),
    [anon_sym_volatile] = ACTIONS(3984),
    [anon_sym_restrict] = ACTIONS(3984),
    [anon_sym___restrict__] = ACTIONS(3984),
    [anon_sym__Atomic] = ACTIONS(3984),
    [anon_sym__Noreturn] = ACTIONS(3984),
    [anon_sym_noreturn] = ACTIONS(3984),
    [anon_sym_mutable] = ACTIONS(3984),
    [anon_sym_constinit] = ACTIONS(3984),
    [anon_sym_consteval] = ACTIONS(3984),
    [anon_sym___shared__] = ACTIONS(3984),
    [anon_sym___local__] = ACTIONS(3984),
    [anon_sym___constant__] = ACTIONS(3984),
    [anon_sym___managed__] = ACTIONS(3984),
    [anon_sym___grid_constant__] = ACTIONS(3984),
    [anon_sym_alignas] = ACTIONS(3984),
    [anon_sym__Alignas] = ACTIONS(3984),
    [sym_primitive_type] = ACTIONS(3984),
    [anon_sym_enum] = ACTIONS(3984),
    [anon_sym_class] = ACTIONS(3984),
    [anon_sym_struct] = ACTIONS(3984),
    [anon_sym_union] = ACTIONS(3984),
    [anon_sym_or] = ACTIONS(3984),
    [anon_sym_and] = ACTIONS(3984),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3984),
    [anon_sym_decltype] = ACTIONS(3984),
    [sym_virtual] = ACTIONS(3984),
    [anon_sym_explicit] = ACTIONS(3984),
    [anon_sym_typename] = ACTIONS(3984),
    [anon_sym_template] = ACTIONS(3984),
    [anon_sym_operator] = ACTIONS(3984),
    [anon_sym_friend] = ACTIONS(3984),
    [anon_sym_using] = ACTIONS(3984),
    [anon_sym_concept] = ACTIONS(3984),
    [anon_sym___launch_bounds__] = ACTIONS(3984),
  },
  [2124] = {
    [sym_identifier] = ACTIONS(5192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5194),
    [anon_sym_COMMA] = ACTIONS(5194),
    [anon_sym_RPAREN] = ACTIONS(5194),
    [aux_sym_preproc_if_token2] = ACTIONS(5194),
    [aux_sym_preproc_else_token1] = ACTIONS(5194),
    [aux_sym_preproc_elif_token1] = ACTIONS(5192),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5194),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5194),
    [anon_sym_LPAREN2] = ACTIONS(5194),
    [anon_sym_DASH] = ACTIONS(5192),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_STAR] = ACTIONS(5194),
    [anon_sym_SLASH] = ACTIONS(5192),
    [anon_sym_PERCENT] = ACTIONS(5194),
    [anon_sym_PIPE_PIPE] = ACTIONS(5194),
    [anon_sym_AMP_AMP] = ACTIONS(5194),
    [anon_sym_PIPE] = ACTIONS(5192),
    [anon_sym_CARET] = ACTIONS(5194),
    [anon_sym_AMP] = ACTIONS(5192),
    [anon_sym_EQ_EQ] = ACTIONS(5194),
    [anon_sym_BANG_EQ] = ACTIONS(5194),
    [anon_sym_GT] = ACTIONS(5192),
    [anon_sym_GT_EQ] = ACTIONS(5194),
    [anon_sym_LT_EQ] = ACTIONS(5192),
    [anon_sym_LT] = ACTIONS(5192),
    [anon_sym_LT_LT] = ACTIONS(5192),
    [anon_sym_GT_GT] = ACTIONS(5194),
    [anon_sym_SEMI] = ACTIONS(5194),
    [anon_sym___extension__] = ACTIONS(5192),
    [anon_sym___global__] = ACTIONS(5192),
    [anon_sym___attribute__] = ACTIONS(5192),
    [anon_sym_LBRACE] = ACTIONS(5194),
    [anon_sym_RBRACE] = ACTIONS(5194),
    [anon_sym_LBRACK] = ACTIONS(5194),
    [anon_sym_RBRACK] = ACTIONS(5194),
    [anon_sym_const] = ACTIONS(5192),
    [anon_sym_constexpr] = ACTIONS(5192),
    [anon_sym_volatile] = ACTIONS(5192),
    [anon_sym_restrict] = ACTIONS(5192),
    [anon_sym___restrict__] = ACTIONS(5192),
    [anon_sym__Atomic] = ACTIONS(5192),
    [anon_sym__Noreturn] = ACTIONS(5192),
    [anon_sym_noreturn] = ACTIONS(5192),
    [anon_sym_mutable] = ACTIONS(5192),
    [anon_sym_constinit] = ACTIONS(5192),
    [anon_sym_consteval] = ACTIONS(5192),
    [anon_sym___shared__] = ACTIONS(5192),
    [anon_sym___local__] = ACTIONS(5192),
    [anon_sym___constant__] = ACTIONS(5192),
    [anon_sym___managed__] = ACTIONS(5192),
    [anon_sym___grid_constant__] = ACTIONS(5192),
    [anon_sym_alignas] = ACTIONS(5192),
    [anon_sym__Alignas] = ACTIONS(5192),
    [anon_sym_COLON] = ACTIONS(5194),
    [anon_sym_QMARK] = ACTIONS(5194),
    [anon_sym_LT_EQ_GT] = ACTIONS(5194),
    [anon_sym_or] = ACTIONS(5192),
    [anon_sym_and] = ACTIONS(5192),
    [anon_sym_bitor] = ACTIONS(5192),
    [anon_sym_xor] = ACTIONS(5192),
    [anon_sym_bitand] = ACTIONS(5192),
    [anon_sym_not_eq] = ACTIONS(5192),
    [anon_sym_DASH_DASH] = ACTIONS(5194),
    [anon_sym_PLUS_PLUS] = ACTIONS(5194),
    [anon_sym_DOT] = ACTIONS(5192),
    [anon_sym_DOT_STAR] = ACTIONS(5194),
    [anon_sym_DASH_GT] = ACTIONS(5194),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5192),
    [anon_sym_decltype] = ACTIONS(5192),
    [anon_sym_final] = ACTIONS(5192),
    [anon_sym_override] = ACTIONS(5192),
    [anon_sym_requires] = ACTIONS(5192),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5194),
  },
  [2125] = {
    [sym_identifier] = ACTIONS(5179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5181),
    [anon_sym_COMMA] = ACTIONS(5181),
    [anon_sym_RPAREN] = ACTIONS(5181),
    [anon_sym_LPAREN2] = ACTIONS(5181),
    [anon_sym_TILDE] = ACTIONS(5181),
    [anon_sym_STAR] = ACTIONS(5181),
    [anon_sym_PIPE_PIPE] = ACTIONS(5181),
    [anon_sym_AMP_AMP] = ACTIONS(5181),
    [anon_sym_AMP] = ACTIONS(5179),
    [anon_sym_SEMI] = ACTIONS(5181),
    [anon_sym___extension__] = ACTIONS(5179),
    [anon_sym___device__] = ACTIONS(5179),
    [anon_sym___host__] = ACTIONS(5179),
    [anon_sym___global__] = ACTIONS(5179),
    [anon_sym___forceinline__] = ACTIONS(5179),
    [anon_sym___noinline__] = ACTIONS(5179),
    [anon_sym_extern] = ACTIONS(5179),
    [anon_sym___attribute__] = ACTIONS(5179),
    [anon_sym_COLON_COLON] = ACTIONS(5181),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5181),
    [anon_sym___declspec] = ACTIONS(5179),
    [anon_sym___based] = ACTIONS(5179),
    [anon_sym___cdecl] = ACTIONS(5179),
    [anon_sym___clrcall] = ACTIONS(5179),
    [anon_sym___stdcall] = ACTIONS(5179),
    [anon_sym___fastcall] = ACTIONS(5179),
    [anon_sym___thiscall] = ACTIONS(5179),
    [anon_sym___vectorcall] = ACTIONS(5179),
    [anon_sym_LBRACE] = ACTIONS(5181),
    [anon_sym_LBRACK] = ACTIONS(5179),
    [anon_sym_static] = ACTIONS(5179),
    [anon_sym_EQ] = ACTIONS(5181),
    [anon_sym_register] = ACTIONS(5179),
    [anon_sym_inline] = ACTIONS(5179),
    [anon_sym___inline] = ACTIONS(5179),
    [anon_sym___inline__] = ACTIONS(5179),
    [anon_sym___forceinline] = ACTIONS(5179),
    [anon_sym_thread_local] = ACTIONS(5179),
    [anon_sym___thread] = ACTIONS(5179),
    [anon_sym_const] = ACTIONS(5179),
    [anon_sym_constexpr] = ACTIONS(5179),
    [anon_sym_volatile] = ACTIONS(5179),
    [anon_sym_restrict] = ACTIONS(5179),
    [anon_sym___restrict__] = ACTIONS(5179),
    [anon_sym__Atomic] = ACTIONS(5179),
    [anon_sym__Noreturn] = ACTIONS(5179),
    [anon_sym_noreturn] = ACTIONS(5179),
    [anon_sym_mutable] = ACTIONS(5179),
    [anon_sym_constinit] = ACTIONS(5179),
    [anon_sym_consteval] = ACTIONS(5179),
    [anon_sym___shared__] = ACTIONS(5179),
    [anon_sym___local__] = ACTIONS(5179),
    [anon_sym___constant__] = ACTIONS(5179),
    [anon_sym___managed__] = ACTIONS(5179),
    [anon_sym___grid_constant__] = ACTIONS(5179),
    [anon_sym_alignas] = ACTIONS(5179),
    [anon_sym__Alignas] = ACTIONS(5179),
    [anon_sym_COLON] = ACTIONS(5179),
    [anon_sym_or] = ACTIONS(5179),
    [anon_sym_and] = ACTIONS(5179),
    [anon_sym_asm] = ACTIONS(5179),
    [anon_sym___asm__] = ACTIONS(5179),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5179),
    [anon_sym_decltype] = ACTIONS(5179),
    [anon_sym_final] = ACTIONS(5179),
    [anon_sym_override] = ACTIONS(5179),
    [sym_virtual] = ACTIONS(5179),
    [anon_sym_template] = ACTIONS(5179),
    [anon_sym_GT2] = ACTIONS(5181),
    [anon_sym_operator] = ACTIONS(5179),
    [anon_sym_try] = ACTIONS(5179),
    [anon_sym_requires] = ACTIONS(5179),
    [anon_sym___launch_bounds__] = ACTIONS(5179),
  },
  [2126] = {
    [sym_identifier] = ACTIONS(5402),
    [anon_sym_LPAREN2] = ACTIONS(5404),
    [anon_sym_TILDE] = ACTIONS(5404),
    [anon_sym_STAR] = ACTIONS(5404),
    [anon_sym_PIPE_PIPE] = ACTIONS(5404),
    [anon_sym_AMP_AMP] = ACTIONS(5396),
    [anon_sym_AMP] = ACTIONS(5402),
    [anon_sym___extension__] = ACTIONS(5402),
    [anon_sym___device__] = ACTIONS(5402),
    [anon_sym___host__] = ACTIONS(5402),
    [anon_sym___global__] = ACTIONS(5402),
    [anon_sym___forceinline__] = ACTIONS(5402),
    [anon_sym___noinline__] = ACTIONS(5402),
    [anon_sym_extern] = ACTIONS(5402),
    [anon_sym___attribute__] = ACTIONS(5402),
    [anon_sym_COLON_COLON] = ACTIONS(5404),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5404),
    [anon_sym___declspec] = ACTIONS(5402),
    [anon_sym___based] = ACTIONS(5402),
    [anon_sym___cdecl] = ACTIONS(5402),
    [anon_sym___clrcall] = ACTIONS(5402),
    [anon_sym___stdcall] = ACTIONS(5402),
    [anon_sym___fastcall] = ACTIONS(5402),
    [anon_sym___thiscall] = ACTIONS(5402),
    [anon_sym___vectorcall] = ACTIONS(5402),
    [anon_sym_signed] = ACTIONS(5402),
    [anon_sym_unsigned] = ACTIONS(5402),
    [anon_sym_long] = ACTIONS(5402),
    [anon_sym_short] = ACTIONS(5402),
    [anon_sym_LBRACK] = ACTIONS(5402),
    [anon_sym_static] = ACTIONS(5402),
    [anon_sym_register] = ACTIONS(5402),
    [anon_sym_inline] = ACTIONS(5402),
    [anon_sym___inline] = ACTIONS(5402),
    [anon_sym___inline__] = ACTIONS(5402),
    [anon_sym___forceinline] = ACTIONS(5402),
    [anon_sym_thread_local] = ACTIONS(5402),
    [anon_sym___thread] = ACTIONS(5402),
    [anon_sym_const] = ACTIONS(5402),
    [anon_sym_constexpr] = ACTIONS(5402),
    [anon_sym_volatile] = ACTIONS(5402),
    [anon_sym_restrict] = ACTIONS(5402),
    [anon_sym___restrict__] = ACTIONS(5402),
    [anon_sym__Atomic] = ACTIONS(5402),
    [anon_sym__Noreturn] = ACTIONS(5402),
    [anon_sym_noreturn] = ACTIONS(5402),
    [anon_sym_mutable] = ACTIONS(5402),
    [anon_sym_constinit] = ACTIONS(5402),
    [anon_sym_consteval] = ACTIONS(5402),
    [anon_sym___shared__] = ACTIONS(5402),
    [anon_sym___local__] = ACTIONS(5402),
    [anon_sym___constant__] = ACTIONS(5402),
    [anon_sym___managed__] = ACTIONS(5402),
    [anon_sym___grid_constant__] = ACTIONS(5402),
    [anon_sym_alignas] = ACTIONS(5402),
    [anon_sym__Alignas] = ACTIONS(5402),
    [sym_primitive_type] = ACTIONS(5402),
    [anon_sym_enum] = ACTIONS(5402),
    [anon_sym_class] = ACTIONS(5402),
    [anon_sym_struct] = ACTIONS(5402),
    [anon_sym_union] = ACTIONS(5402),
    [anon_sym_or] = ACTIONS(5402),
    [anon_sym_and] = ACTIONS(5400),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5402),
    [anon_sym_decltype] = ACTIONS(5402),
    [sym_virtual] = ACTIONS(5402),
    [anon_sym_explicit] = ACTIONS(5402),
    [anon_sym_typename] = ACTIONS(5402),
    [anon_sym_template] = ACTIONS(5402),
    [anon_sym_operator] = ACTIONS(5402),
    [anon_sym_friend] = ACTIONS(5402),
    [anon_sym_using] = ACTIONS(5402),
    [anon_sym_concept] = ACTIONS(5402),
    [anon_sym___launch_bounds__] = ACTIONS(5402),
  },
  [2127] = {
    [sym_identifier] = ACTIONS(1901),
    [anon_sym_LPAREN2] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_STAR] = ACTIONS(1899),
    [anon_sym_PIPE_PIPE] = ACTIONS(1899),
    [anon_sym_AMP_AMP] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1901),
    [anon_sym___extension__] = ACTIONS(1901),
    [anon_sym___device__] = ACTIONS(1901),
    [anon_sym___host__] = ACTIONS(1901),
    [anon_sym___global__] = ACTIONS(1901),
    [anon_sym___forceinline__] = ACTIONS(1901),
    [anon_sym___noinline__] = ACTIONS(1901),
    [anon_sym_extern] = ACTIONS(1901),
    [anon_sym___attribute__] = ACTIONS(1901),
    [anon_sym_COLON_COLON] = ACTIONS(1899),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1899),
    [anon_sym___declspec] = ACTIONS(1901),
    [anon_sym___based] = ACTIONS(1901),
    [anon_sym___cdecl] = ACTIONS(1901),
    [anon_sym___clrcall] = ACTIONS(1901),
    [anon_sym___stdcall] = ACTIONS(1901),
    [anon_sym___fastcall] = ACTIONS(1901),
    [anon_sym___thiscall] = ACTIONS(1901),
    [anon_sym___vectorcall] = ACTIONS(1901),
    [anon_sym_signed] = ACTIONS(1901),
    [anon_sym_unsigned] = ACTIONS(1901),
    [anon_sym_long] = ACTIONS(1901),
    [anon_sym_short] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1901),
    [anon_sym_static] = ACTIONS(1901),
    [anon_sym_register] = ACTIONS(1901),
    [anon_sym_inline] = ACTIONS(1901),
    [anon_sym___inline] = ACTIONS(1901),
    [anon_sym___inline__] = ACTIONS(1901),
    [anon_sym___forceinline] = ACTIONS(1901),
    [anon_sym_thread_local] = ACTIONS(1901),
    [anon_sym___thread] = ACTIONS(1901),
    [anon_sym_const] = ACTIONS(1901),
    [anon_sym_constexpr] = ACTIONS(1901),
    [anon_sym_volatile] = ACTIONS(1901),
    [anon_sym_restrict] = ACTIONS(1901),
    [anon_sym___restrict__] = ACTIONS(1901),
    [anon_sym__Atomic] = ACTIONS(1901),
    [anon_sym__Noreturn] = ACTIONS(1901),
    [anon_sym_noreturn] = ACTIONS(1901),
    [anon_sym_mutable] = ACTIONS(1901),
    [anon_sym_constinit] = ACTIONS(1901),
    [anon_sym_consteval] = ACTIONS(1901),
    [anon_sym___shared__] = ACTIONS(1901),
    [anon_sym___local__] = ACTIONS(1901),
    [anon_sym___constant__] = ACTIONS(1901),
    [anon_sym___managed__] = ACTIONS(1901),
    [anon_sym___grid_constant__] = ACTIONS(1901),
    [anon_sym_alignas] = ACTIONS(1901),
    [anon_sym__Alignas] = ACTIONS(1901),
    [sym_primitive_type] = ACTIONS(1901),
    [anon_sym_enum] = ACTIONS(1901),
    [anon_sym_class] = ACTIONS(1901),
    [anon_sym_struct] = ACTIONS(1901),
    [anon_sym_union] = ACTIONS(1901),
    [anon_sym_or] = ACTIONS(1901),
    [anon_sym_and] = ACTIONS(1901),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1901),
    [anon_sym_decltype] = ACTIONS(1901),
    [sym_virtual] = ACTIONS(1901),
    [anon_sym_explicit] = ACTIONS(1901),
    [anon_sym_typename] = ACTIONS(1901),
    [anon_sym_template] = ACTIONS(1901),
    [anon_sym_operator] = ACTIONS(1901),
    [anon_sym_friend] = ACTIONS(1901),
    [anon_sym_using] = ACTIONS(1901),
    [anon_sym_concept] = ACTIONS(1901),
    [anon_sym___launch_bounds__] = ACTIONS(1901),
  },
  [2128] = {
    [sym__declaration_modifiers] = STATE(2151),
    [sym_attribute_specifier] = STATE(2151),
    [sym_attribute_declaration] = STATE(2151),
    [sym_ms_declspec_modifier] = STATE(2151),
    [sym_storage_class_specifier] = STATE(2151),
    [sym_type_qualifier] = STATE(2151),
    [sym_alignas_qualifier] = STATE(2611),
    [sym_decltype_auto] = STATE(2182),
    [sym_launch_bounds] = STATE(2151),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2151),
    [sym_identifier] = ACTIONS(5406),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5408),
    [anon_sym_COMMA] = ACTIONS(5408),
    [anon_sym_RPAREN] = ACTIONS(5408),
    [anon_sym_LPAREN2] = ACTIONS(5408),
    [anon_sym_TILDE] = ACTIONS(5408),
    [anon_sym_STAR] = ACTIONS(5408),
    [anon_sym_AMP_AMP] = ACTIONS(5408),
    [anon_sym_AMP] = ACTIONS(5406),
    [anon_sym_SEMI] = ACTIONS(5408),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym___device__] = ACTIONS(5410),
    [anon_sym___host__] = ACTIONS(5410),
    [anon_sym___global__] = ACTIONS(5410),
    [anon_sym___forceinline__] = ACTIONS(5410),
    [anon_sym___noinline__] = ACTIONS(5410),
    [anon_sym_extern] = ACTIONS(5000),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5408),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5006),
    [anon_sym___declspec] = ACTIONS(5008),
    [anon_sym___based] = ACTIONS(5406),
    [anon_sym___cdecl] = ACTIONS(5406),
    [anon_sym___clrcall] = ACTIONS(5406),
    [anon_sym___stdcall] = ACTIONS(5406),
    [anon_sym___fastcall] = ACTIONS(5406),
    [anon_sym___thiscall] = ACTIONS(5406),
    [anon_sym___vectorcall] = ACTIONS(5406),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [anon_sym_static] = ACTIONS(5000),
    [anon_sym_EQ] = ACTIONS(5408),
    [anon_sym_register] = ACTIONS(5000),
    [anon_sym_inline] = ACTIONS(5000),
    [anon_sym___inline] = ACTIONS(5000),
    [anon_sym___inline__] = ACTIONS(5000),
    [anon_sym___forceinline] = ACTIONS(5000),
    [anon_sym_thread_local] = ACTIONS(5000),
    [anon_sym___thread] = ACTIONS(5000),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym___shared__] = ACTIONS(4996),
    [anon_sym___local__] = ACTIONS(4996),
    [anon_sym___constant__] = ACTIONS(4996),
    [anon_sym___managed__] = ACTIONS(4996),
    [anon_sym___grid_constant__] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(5010),
    [anon_sym__Alignas] = ACTIONS(5010),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5412),
    [anon_sym_decltype] = ACTIONS(5414),
    [sym_virtual] = ACTIONS(5410),
    [anon_sym_template] = ACTIONS(5406),
    [anon_sym_GT2] = ACTIONS(5408),
    [anon_sym_operator] = ACTIONS(5406),
    [anon_sym___launch_bounds__] = ACTIONS(5012),
  },
  [2129] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5416),
    [anon_sym_COMMA] = ACTIONS(5416),
    [anon_sym_RPAREN] = ACTIONS(5416),
    [anon_sym_LPAREN2] = ACTIONS(5416),
    [anon_sym_DASH] = ACTIONS(5418),
    [anon_sym_PLUS] = ACTIONS(5418),
    [anon_sym_STAR] = ACTIONS(5416),
    [anon_sym_SLASH] = ACTIONS(5418),
    [anon_sym_PERCENT] = ACTIONS(5416),
    [anon_sym_PIPE_PIPE] = ACTIONS(5416),
    [anon_sym_AMP_AMP] = ACTIONS(5416),
    [anon_sym_PIPE] = ACTIONS(5418),
    [anon_sym_CARET] = ACTIONS(5416),
    [anon_sym_AMP] = ACTIONS(5418),
    [anon_sym_EQ_EQ] = ACTIONS(5416),
    [anon_sym_BANG_EQ] = ACTIONS(5416),
    [anon_sym_GT] = ACTIONS(5418),
    [anon_sym_GT_EQ] = ACTIONS(5416),
    [anon_sym_LT_EQ] = ACTIONS(5418),
    [anon_sym_LT] = ACTIONS(5418),
    [anon_sym_LT_LT] = ACTIONS(5418),
    [anon_sym_GT_GT] = ACTIONS(5416),
    [anon_sym_SEMI] = ACTIONS(5416),
    [anon_sym___extension__] = ACTIONS(5416),
    [anon_sym___global__] = ACTIONS(5416),
    [anon_sym___attribute__] = ACTIONS(5416),
    [anon_sym_LBRACE] = ACTIONS(5416),
    [anon_sym_RBRACE] = ACTIONS(5416),
    [anon_sym_signed] = ACTIONS(5420),
    [anon_sym_unsigned] = ACTIONS(5420),
    [anon_sym_long] = ACTIONS(5420),
    [anon_sym_short] = ACTIONS(5420),
    [anon_sym_LBRACK] = ACTIONS(5416),
    [anon_sym_RBRACK] = ACTIONS(5416),
    [anon_sym_const] = ACTIONS(5418),
    [anon_sym_constexpr] = ACTIONS(5416),
    [anon_sym_volatile] = ACTIONS(5416),
    [anon_sym_restrict] = ACTIONS(5416),
    [anon_sym___restrict__] = ACTIONS(5416),
    [anon_sym__Atomic] = ACTIONS(5416),
    [anon_sym__Noreturn] = ACTIONS(5416),
    [anon_sym_noreturn] = ACTIONS(5416),
    [anon_sym_mutable] = ACTIONS(5416),
    [anon_sym_constinit] = ACTIONS(5416),
    [anon_sym_consteval] = ACTIONS(5416),
    [anon_sym___shared__] = ACTIONS(5416),
    [anon_sym___local__] = ACTIONS(5416),
    [anon_sym___constant__] = ACTIONS(5416),
    [anon_sym___managed__] = ACTIONS(5416),
    [anon_sym___grid_constant__] = ACTIONS(5416),
    [anon_sym_alignas] = ACTIONS(5416),
    [anon_sym__Alignas] = ACTIONS(5416),
    [anon_sym_COLON] = ACTIONS(5416),
    [anon_sym_QMARK] = ACTIONS(5416),
    [anon_sym_LT_EQ_GT] = ACTIONS(5416),
    [anon_sym_or] = ACTIONS(5416),
    [anon_sym_and] = ACTIONS(5416),
    [anon_sym_bitor] = ACTIONS(5416),
    [anon_sym_xor] = ACTIONS(5416),
    [anon_sym_bitand] = ACTIONS(5416),
    [anon_sym_not_eq] = ACTIONS(5416),
    [anon_sym_DASH_DASH] = ACTIONS(5416),
    [anon_sym_PLUS_PLUS] = ACTIONS(5416),
    [anon_sym_DOT] = ACTIONS(5418),
    [anon_sym_DOT_STAR] = ACTIONS(5416),
    [anon_sym_DASH_GT] = ACTIONS(5416),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5416),
    [anon_sym_decltype] = ACTIONS(5416),
    [anon_sym_final] = ACTIONS(5416),
    [anon_sym_override] = ACTIONS(5416),
    [anon_sym_requires] = ACTIONS(5416),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5416),
  },
  [2130] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5422),
    [anon_sym_COMMA] = ACTIONS(5422),
    [anon_sym_RPAREN] = ACTIONS(5422),
    [anon_sym_LPAREN2] = ACTIONS(5422),
    [anon_sym_DASH] = ACTIONS(5424),
    [anon_sym_PLUS] = ACTIONS(5424),
    [anon_sym_STAR] = ACTIONS(5422),
    [anon_sym_SLASH] = ACTIONS(5424),
    [anon_sym_PERCENT] = ACTIONS(5422),
    [anon_sym_PIPE_PIPE] = ACTIONS(5422),
    [anon_sym_AMP_AMP] = ACTIONS(5422),
    [anon_sym_PIPE] = ACTIONS(5424),
    [anon_sym_CARET] = ACTIONS(5422),
    [anon_sym_AMP] = ACTIONS(5424),
    [anon_sym_EQ_EQ] = ACTIONS(5422),
    [anon_sym_BANG_EQ] = ACTIONS(5422),
    [anon_sym_GT] = ACTIONS(5424),
    [anon_sym_GT_EQ] = ACTIONS(5422),
    [anon_sym_LT_EQ] = ACTIONS(5424),
    [anon_sym_LT] = ACTIONS(5424),
    [anon_sym_LT_LT] = ACTIONS(5424),
    [anon_sym_GT_GT] = ACTIONS(5422),
    [anon_sym_SEMI] = ACTIONS(5422),
    [anon_sym___extension__] = ACTIONS(5422),
    [anon_sym___global__] = ACTIONS(5422),
    [anon_sym___attribute__] = ACTIONS(5422),
    [anon_sym_LBRACE] = ACTIONS(5422),
    [anon_sym_RBRACE] = ACTIONS(5422),
    [anon_sym_signed] = ACTIONS(5420),
    [anon_sym_unsigned] = ACTIONS(5420),
    [anon_sym_long] = ACTIONS(5420),
    [anon_sym_short] = ACTIONS(5420),
    [anon_sym_LBRACK] = ACTIONS(5422),
    [anon_sym_RBRACK] = ACTIONS(5422),
    [anon_sym_const] = ACTIONS(5424),
    [anon_sym_constexpr] = ACTIONS(5422),
    [anon_sym_volatile] = ACTIONS(5422),
    [anon_sym_restrict] = ACTIONS(5422),
    [anon_sym___restrict__] = ACTIONS(5422),
    [anon_sym__Atomic] = ACTIONS(5422),
    [anon_sym__Noreturn] = ACTIONS(5422),
    [anon_sym_noreturn] = ACTIONS(5422),
    [anon_sym_mutable] = ACTIONS(5422),
    [anon_sym_constinit] = ACTIONS(5422),
    [anon_sym_consteval] = ACTIONS(5422),
    [anon_sym___shared__] = ACTIONS(5422),
    [anon_sym___local__] = ACTIONS(5422),
    [anon_sym___constant__] = ACTIONS(5422),
    [anon_sym___managed__] = ACTIONS(5422),
    [anon_sym___grid_constant__] = ACTIONS(5422),
    [anon_sym_alignas] = ACTIONS(5422),
    [anon_sym__Alignas] = ACTIONS(5422),
    [anon_sym_COLON] = ACTIONS(5422),
    [anon_sym_QMARK] = ACTIONS(5422),
    [anon_sym_LT_EQ_GT] = ACTIONS(5422),
    [anon_sym_or] = ACTIONS(5422),
    [anon_sym_and] = ACTIONS(5422),
    [anon_sym_bitor] = ACTIONS(5422),
    [anon_sym_xor] = ACTIONS(5422),
    [anon_sym_bitand] = ACTIONS(5422),
    [anon_sym_not_eq] = ACTIONS(5422),
    [anon_sym_DASH_DASH] = ACTIONS(5422),
    [anon_sym_PLUS_PLUS] = ACTIONS(5422),
    [anon_sym_DOT] = ACTIONS(5424),
    [anon_sym_DOT_STAR] = ACTIONS(5422),
    [anon_sym_DASH_GT] = ACTIONS(5422),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5422),
    [anon_sym_decltype] = ACTIONS(5422),
    [anon_sym_final] = ACTIONS(5422),
    [anon_sym_override] = ACTIONS(5422),
    [anon_sym_requires] = ACTIONS(5422),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5422),
  },
  [2131] = {
    [sym__declaration_modifiers] = STATE(2156),
    [sym_attribute_specifier] = STATE(2156),
    [sym_attribute_declaration] = STATE(2156),
    [sym_ms_declspec_modifier] = STATE(2156),
    [sym_storage_class_specifier] = STATE(2156),
    [sym_type_qualifier] = STATE(2156),
    [sym_alignas_qualifier] = STATE(2611),
    [sym_decltype_auto] = STATE(2182),
    [sym_launch_bounds] = STATE(2156),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2156),
    [sym_identifier] = ACTIONS(5426),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5428),
    [anon_sym_COMMA] = ACTIONS(5428),
    [anon_sym_RPAREN] = ACTIONS(5428),
    [anon_sym_LPAREN2] = ACTIONS(5428),
    [anon_sym_TILDE] = ACTIONS(5428),
    [anon_sym_STAR] = ACTIONS(5428),
    [anon_sym_AMP_AMP] = ACTIONS(5428),
    [anon_sym_AMP] = ACTIONS(5426),
    [anon_sym_SEMI] = ACTIONS(5428),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym___device__] = ACTIONS(5430),
    [anon_sym___host__] = ACTIONS(5430),
    [anon_sym___global__] = ACTIONS(5430),
    [anon_sym___forceinline__] = ACTIONS(5430),
    [anon_sym___noinline__] = ACTIONS(5430),
    [anon_sym_extern] = ACTIONS(5000),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5428),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5006),
    [anon_sym___declspec] = ACTIONS(5008),
    [anon_sym___based] = ACTIONS(5426),
    [anon_sym___cdecl] = ACTIONS(5426),
    [anon_sym___clrcall] = ACTIONS(5426),
    [anon_sym___stdcall] = ACTIONS(5426),
    [anon_sym___fastcall] = ACTIONS(5426),
    [anon_sym___thiscall] = ACTIONS(5426),
    [anon_sym___vectorcall] = ACTIONS(5426),
    [anon_sym_LBRACK] = ACTIONS(5426),
    [anon_sym_static] = ACTIONS(5000),
    [anon_sym_EQ] = ACTIONS(5428),
    [anon_sym_register] = ACTIONS(5000),
    [anon_sym_inline] = ACTIONS(5000),
    [anon_sym___inline] = ACTIONS(5000),
    [anon_sym___inline__] = ACTIONS(5000),
    [anon_sym___forceinline] = ACTIONS(5000),
    [anon_sym_thread_local] = ACTIONS(5000),
    [anon_sym___thread] = ACTIONS(5000),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym___shared__] = ACTIONS(4996),
    [anon_sym___local__] = ACTIONS(4996),
    [anon_sym___constant__] = ACTIONS(4996),
    [anon_sym___managed__] = ACTIONS(4996),
    [anon_sym___grid_constant__] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(5010),
    [anon_sym__Alignas] = ACTIONS(5010),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5412),
    [anon_sym_decltype] = ACTIONS(5414),
    [sym_virtual] = ACTIONS(5430),
    [anon_sym_template] = ACTIONS(5426),
    [anon_sym_GT2] = ACTIONS(5428),
    [anon_sym_operator] = ACTIONS(5426),
    [anon_sym___launch_bounds__] = ACTIONS(5012),
  },
  [2132] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5432),
    [anon_sym_COMMA] = ACTIONS(5432),
    [anon_sym_RPAREN] = ACTIONS(5432),
    [anon_sym_LPAREN2] = ACTIONS(5432),
    [anon_sym_DASH] = ACTIONS(5434),
    [anon_sym_PLUS] = ACTIONS(5434),
    [anon_sym_STAR] = ACTIONS(5432),
    [anon_sym_SLASH] = ACTIONS(5434),
    [anon_sym_PERCENT] = ACTIONS(5432),
    [anon_sym_PIPE_PIPE] = ACTIONS(5432),
    [anon_sym_AMP_AMP] = ACTIONS(5432),
    [anon_sym_PIPE] = ACTIONS(5434),
    [anon_sym_CARET] = ACTIONS(5432),
    [anon_sym_AMP] = ACTIONS(5434),
    [anon_sym_EQ_EQ] = ACTIONS(5432),
    [anon_sym_BANG_EQ] = ACTIONS(5432),
    [anon_sym_GT] = ACTIONS(5434),
    [anon_sym_GT_EQ] = ACTIONS(5432),
    [anon_sym_LT_EQ] = ACTIONS(5434),
    [anon_sym_LT] = ACTIONS(5434),
    [anon_sym_LT_LT] = ACTIONS(5434),
    [anon_sym_GT_GT] = ACTIONS(5432),
    [anon_sym_SEMI] = ACTIONS(5432),
    [anon_sym___extension__] = ACTIONS(5432),
    [anon_sym___global__] = ACTIONS(5432),
    [anon_sym___attribute__] = ACTIONS(5432),
    [anon_sym_LBRACE] = ACTIONS(5432),
    [anon_sym_RBRACE] = ACTIONS(5432),
    [anon_sym_signed] = ACTIONS(5420),
    [anon_sym_unsigned] = ACTIONS(5420),
    [anon_sym_long] = ACTIONS(5420),
    [anon_sym_short] = ACTIONS(5420),
    [anon_sym_LBRACK] = ACTIONS(5432),
    [anon_sym_RBRACK] = ACTIONS(5432),
    [anon_sym_const] = ACTIONS(5434),
    [anon_sym_constexpr] = ACTIONS(5432),
    [anon_sym_volatile] = ACTIONS(5432),
    [anon_sym_restrict] = ACTIONS(5432),
    [anon_sym___restrict__] = ACTIONS(5432),
    [anon_sym__Atomic] = ACTIONS(5432),
    [anon_sym__Noreturn] = ACTIONS(5432),
    [anon_sym_noreturn] = ACTIONS(5432),
    [anon_sym_mutable] = ACTIONS(5432),
    [anon_sym_constinit] = ACTIONS(5432),
    [anon_sym_consteval] = ACTIONS(5432),
    [anon_sym___shared__] = ACTIONS(5432),
    [anon_sym___local__] = ACTIONS(5432),
    [anon_sym___constant__] = ACTIONS(5432),
    [anon_sym___managed__] = ACTIONS(5432),
    [anon_sym___grid_constant__] = ACTIONS(5432),
    [anon_sym_alignas] = ACTIONS(5432),
    [anon_sym__Alignas] = ACTIONS(5432),
    [anon_sym_COLON] = ACTIONS(5432),
    [anon_sym_QMARK] = ACTIONS(5432),
    [anon_sym_LT_EQ_GT] = ACTIONS(5432),
    [anon_sym_or] = ACTIONS(5432),
    [anon_sym_and] = ACTIONS(5432),
    [anon_sym_bitor] = ACTIONS(5432),
    [anon_sym_xor] = ACTIONS(5432),
    [anon_sym_bitand] = ACTIONS(5432),
    [anon_sym_not_eq] = ACTIONS(5432),
    [anon_sym_DASH_DASH] = ACTIONS(5432),
    [anon_sym_PLUS_PLUS] = ACTIONS(5432),
    [anon_sym_DOT] = ACTIONS(5434),
    [anon_sym_DOT_STAR] = ACTIONS(5432),
    [anon_sym_DASH_GT] = ACTIONS(5432),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5432),
    [anon_sym_decltype] = ACTIONS(5432),
    [anon_sym_final] = ACTIONS(5432),
    [anon_sym_override] = ACTIONS(5432),
    [anon_sym_requires] = ACTIONS(5432),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5432),
  },
  [2133] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5436),
    [anon_sym_COMMA] = ACTIONS(5436),
    [anon_sym_RPAREN] = ACTIONS(5436),
    [anon_sym_LPAREN2] = ACTIONS(5436),
    [anon_sym_DASH] = ACTIONS(5438),
    [anon_sym_PLUS] = ACTIONS(5438),
    [anon_sym_STAR] = ACTIONS(5436),
    [anon_sym_SLASH] = ACTIONS(5438),
    [anon_sym_PERCENT] = ACTIONS(5436),
    [anon_sym_PIPE_PIPE] = ACTIONS(5436),
    [anon_sym_AMP_AMP] = ACTIONS(5436),
    [anon_sym_PIPE] = ACTIONS(5438),
    [anon_sym_CARET] = ACTIONS(5436),
    [anon_sym_AMP] = ACTIONS(5438),
    [anon_sym_EQ_EQ] = ACTIONS(5436),
    [anon_sym_BANG_EQ] = ACTIONS(5436),
    [anon_sym_GT] = ACTIONS(5438),
    [anon_sym_GT_EQ] = ACTIONS(5436),
    [anon_sym_LT_EQ] = ACTIONS(5438),
    [anon_sym_LT] = ACTIONS(5438),
    [anon_sym_LT_LT] = ACTIONS(5438),
    [anon_sym_GT_GT] = ACTIONS(5436),
    [anon_sym_SEMI] = ACTIONS(5436),
    [anon_sym___extension__] = ACTIONS(5436),
    [anon_sym___global__] = ACTIONS(5436),
    [anon_sym___attribute__] = ACTIONS(5436),
    [anon_sym_LBRACE] = ACTIONS(5436),
    [anon_sym_RBRACE] = ACTIONS(5436),
    [anon_sym_signed] = ACTIONS(5420),
    [anon_sym_unsigned] = ACTIONS(5420),
    [anon_sym_long] = ACTIONS(5420),
    [anon_sym_short] = ACTIONS(5420),
    [anon_sym_LBRACK] = ACTIONS(5436),
    [anon_sym_RBRACK] = ACTIONS(5436),
    [anon_sym_const] = ACTIONS(5438),
    [anon_sym_constexpr] = ACTIONS(5436),
    [anon_sym_volatile] = ACTIONS(5436),
    [anon_sym_restrict] = ACTIONS(5436),
    [anon_sym___restrict__] = ACTIONS(5436),
    [anon_sym__Atomic] = ACTIONS(5436),
    [anon_sym__Noreturn] = ACTIONS(5436),
    [anon_sym_noreturn] = ACTIONS(5436),
    [anon_sym_mutable] = ACTIONS(5436),
    [anon_sym_constinit] = ACTIONS(5436),
    [anon_sym_consteval] = ACTIONS(5436),
    [anon_sym___shared__] = ACTIONS(5436),
    [anon_sym___local__] = ACTIONS(5436),
    [anon_sym___constant__] = ACTIONS(5436),
    [anon_sym___managed__] = ACTIONS(5436),
    [anon_sym___grid_constant__] = ACTIONS(5436),
    [anon_sym_alignas] = ACTIONS(5436),
    [anon_sym__Alignas] = ACTIONS(5436),
    [anon_sym_COLON] = ACTIONS(5436),
    [anon_sym_QMARK] = ACTIONS(5436),
    [anon_sym_LT_EQ_GT] = ACTIONS(5436),
    [anon_sym_or] = ACTIONS(5436),
    [anon_sym_and] = ACTIONS(5436),
    [anon_sym_bitor] = ACTIONS(5436),
    [anon_sym_xor] = ACTIONS(5436),
    [anon_sym_bitand] = ACTIONS(5436),
    [anon_sym_not_eq] = ACTIONS(5436),
    [anon_sym_DASH_DASH] = ACTIONS(5436),
    [anon_sym_PLUS_PLUS] = ACTIONS(5436),
    [anon_sym_DOT] = ACTIONS(5438),
    [anon_sym_DOT_STAR] = ACTIONS(5436),
    [anon_sym_DASH_GT] = ACTIONS(5436),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5436),
    [anon_sym_decltype] = ACTIONS(5436),
    [anon_sym_final] = ACTIONS(5436),
    [anon_sym_override] = ACTIONS(5436),
    [anon_sym_requires] = ACTIONS(5436),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5436),
  },
  [2134] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5440),
    [anon_sym_COMMA] = ACTIONS(5440),
    [anon_sym_RPAREN] = ACTIONS(5440),
    [anon_sym_LPAREN2] = ACTIONS(5440),
    [anon_sym_DASH] = ACTIONS(5442),
    [anon_sym_PLUS] = ACTIONS(5442),
    [anon_sym_STAR] = ACTIONS(5440),
    [anon_sym_SLASH] = ACTIONS(5442),
    [anon_sym_PERCENT] = ACTIONS(5440),
    [anon_sym_PIPE_PIPE] = ACTIONS(5440),
    [anon_sym_AMP_AMP] = ACTIONS(5440),
    [anon_sym_PIPE] = ACTIONS(5442),
    [anon_sym_CARET] = ACTIONS(5440),
    [anon_sym_AMP] = ACTIONS(5442),
    [anon_sym_EQ_EQ] = ACTIONS(5440),
    [anon_sym_BANG_EQ] = ACTIONS(5440),
    [anon_sym_GT] = ACTIONS(5442),
    [anon_sym_GT_EQ] = ACTIONS(5440),
    [anon_sym_LT_EQ] = ACTIONS(5442),
    [anon_sym_LT] = ACTIONS(5442),
    [anon_sym_LT_LT] = ACTIONS(5442),
    [anon_sym_GT_GT] = ACTIONS(5440),
    [anon_sym_SEMI] = ACTIONS(5440),
    [anon_sym___extension__] = ACTIONS(5440),
    [anon_sym___global__] = ACTIONS(5440),
    [anon_sym___attribute__] = ACTIONS(5440),
    [anon_sym_LBRACE] = ACTIONS(5440),
    [anon_sym_RBRACE] = ACTIONS(5440),
    [anon_sym_signed] = ACTIONS(5444),
    [anon_sym_unsigned] = ACTIONS(5444),
    [anon_sym_long] = ACTIONS(5444),
    [anon_sym_short] = ACTIONS(5444),
    [anon_sym_LBRACK] = ACTIONS(5440),
    [anon_sym_RBRACK] = ACTIONS(5440),
    [anon_sym_const] = ACTIONS(5442),
    [anon_sym_constexpr] = ACTIONS(5440),
    [anon_sym_volatile] = ACTIONS(5440),
    [anon_sym_restrict] = ACTIONS(5440),
    [anon_sym___restrict__] = ACTIONS(5440),
    [anon_sym__Atomic] = ACTIONS(5440),
    [anon_sym__Noreturn] = ACTIONS(5440),
    [anon_sym_noreturn] = ACTIONS(5440),
    [anon_sym_mutable] = ACTIONS(5440),
    [anon_sym_constinit] = ACTIONS(5440),
    [anon_sym_consteval] = ACTIONS(5440),
    [anon_sym___shared__] = ACTIONS(5440),
    [anon_sym___local__] = ACTIONS(5440),
    [anon_sym___constant__] = ACTIONS(5440),
    [anon_sym___managed__] = ACTIONS(5440),
    [anon_sym___grid_constant__] = ACTIONS(5440),
    [anon_sym_alignas] = ACTIONS(5440),
    [anon_sym__Alignas] = ACTIONS(5440),
    [anon_sym_COLON] = ACTIONS(5440),
    [anon_sym_QMARK] = ACTIONS(5440),
    [anon_sym_LT_EQ_GT] = ACTIONS(5440),
    [anon_sym_or] = ACTIONS(5440),
    [anon_sym_and] = ACTIONS(5440),
    [anon_sym_bitor] = ACTIONS(5440),
    [anon_sym_xor] = ACTIONS(5440),
    [anon_sym_bitand] = ACTIONS(5440),
    [anon_sym_not_eq] = ACTIONS(5440),
    [anon_sym_DASH_DASH] = ACTIONS(5440),
    [anon_sym_PLUS_PLUS] = ACTIONS(5440),
    [anon_sym_DOT] = ACTIONS(5442),
    [anon_sym_DOT_STAR] = ACTIONS(5440),
    [anon_sym_DASH_GT] = ACTIONS(5440),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5440),
    [anon_sym_decltype] = ACTIONS(5440),
    [anon_sym_final] = ACTIONS(5440),
    [anon_sym_override] = ACTIONS(5440),
    [anon_sym_requires] = ACTIONS(5440),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5440),
  },
  [2135] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5446),
    [anon_sym_COMMA] = ACTIONS(5446),
    [anon_sym_RPAREN] = ACTIONS(5446),
    [anon_sym_LPAREN2] = ACTIONS(5446),
    [anon_sym_DASH] = ACTIONS(5448),
    [anon_sym_PLUS] = ACTIONS(5448),
    [anon_sym_STAR] = ACTIONS(5446),
    [anon_sym_SLASH] = ACTIONS(5448),
    [anon_sym_PERCENT] = ACTIONS(5446),
    [anon_sym_PIPE_PIPE] = ACTIONS(5446),
    [anon_sym_AMP_AMP] = ACTIONS(5446),
    [anon_sym_PIPE] = ACTIONS(5448),
    [anon_sym_CARET] = ACTIONS(5446),
    [anon_sym_AMP] = ACTIONS(5448),
    [anon_sym_EQ_EQ] = ACTIONS(5446),
    [anon_sym_BANG_EQ] = ACTIONS(5446),
    [anon_sym_GT] = ACTIONS(5448),
    [anon_sym_GT_EQ] = ACTIONS(5446),
    [anon_sym_LT_EQ] = ACTIONS(5448),
    [anon_sym_LT] = ACTIONS(5448),
    [anon_sym_LT_LT] = ACTIONS(5448),
    [anon_sym_GT_GT] = ACTIONS(5446),
    [anon_sym_SEMI] = ACTIONS(5446),
    [anon_sym___extension__] = ACTIONS(5446),
    [anon_sym___global__] = ACTIONS(5446),
    [anon_sym___attribute__] = ACTIONS(5446),
    [anon_sym_LBRACE] = ACTIONS(5446),
    [anon_sym_RBRACE] = ACTIONS(5446),
    [anon_sym_signed] = ACTIONS(5450),
    [anon_sym_unsigned] = ACTIONS(5450),
    [anon_sym_long] = ACTIONS(5450),
    [anon_sym_short] = ACTIONS(5450),
    [anon_sym_LBRACK] = ACTIONS(5446),
    [anon_sym_RBRACK] = ACTIONS(5446),
    [anon_sym_const] = ACTIONS(5448),
    [anon_sym_constexpr] = ACTIONS(5446),
    [anon_sym_volatile] = ACTIONS(5446),
    [anon_sym_restrict] = ACTIONS(5446),
    [anon_sym___restrict__] = ACTIONS(5446),
    [anon_sym__Atomic] = ACTIONS(5446),
    [anon_sym__Noreturn] = ACTIONS(5446),
    [anon_sym_noreturn] = ACTIONS(5446),
    [anon_sym_mutable] = ACTIONS(5446),
    [anon_sym_constinit] = ACTIONS(5446),
    [anon_sym_consteval] = ACTIONS(5446),
    [anon_sym___shared__] = ACTIONS(5446),
    [anon_sym___local__] = ACTIONS(5446),
    [anon_sym___constant__] = ACTIONS(5446),
    [anon_sym___managed__] = ACTIONS(5446),
    [anon_sym___grid_constant__] = ACTIONS(5446),
    [anon_sym_alignas] = ACTIONS(5446),
    [anon_sym__Alignas] = ACTIONS(5446),
    [anon_sym_COLON] = ACTIONS(5446),
    [anon_sym_QMARK] = ACTIONS(5446),
    [anon_sym_LT_EQ_GT] = ACTIONS(5446),
    [anon_sym_or] = ACTIONS(5446),
    [anon_sym_and] = ACTIONS(5446),
    [anon_sym_bitor] = ACTIONS(5446),
    [anon_sym_xor] = ACTIONS(5446),
    [anon_sym_bitand] = ACTIONS(5446),
    [anon_sym_not_eq] = ACTIONS(5446),
    [anon_sym_DASH_DASH] = ACTIONS(5446),
    [anon_sym_PLUS_PLUS] = ACTIONS(5446),
    [anon_sym_DOT] = ACTIONS(5448),
    [anon_sym_DOT_STAR] = ACTIONS(5446),
    [anon_sym_DASH_GT] = ACTIONS(5446),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5446),
    [anon_sym_decltype] = ACTIONS(5446),
    [anon_sym_final] = ACTIONS(5446),
    [anon_sym_override] = ACTIONS(5446),
    [anon_sym_requires] = ACTIONS(5446),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5446),
  },
  [2136] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2133),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5194),
    [anon_sym_COMMA] = ACTIONS(5194),
    [anon_sym_RPAREN] = ACTIONS(5194),
    [anon_sym_LPAREN2] = ACTIONS(5194),
    [anon_sym_DASH] = ACTIONS(5192),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_STAR] = ACTIONS(5194),
    [anon_sym_SLASH] = ACTIONS(5192),
    [anon_sym_PERCENT] = ACTIONS(5194),
    [anon_sym_PIPE_PIPE] = ACTIONS(5194),
    [anon_sym_AMP_AMP] = ACTIONS(5194),
    [anon_sym_PIPE] = ACTIONS(5192),
    [anon_sym_CARET] = ACTIONS(5194),
    [anon_sym_AMP] = ACTIONS(5192),
    [anon_sym_EQ_EQ] = ACTIONS(5194),
    [anon_sym_BANG_EQ] = ACTIONS(5194),
    [anon_sym_GT] = ACTIONS(5192),
    [anon_sym_GT_EQ] = ACTIONS(5194),
    [anon_sym_LT_EQ] = ACTIONS(5192),
    [anon_sym_LT] = ACTIONS(5192),
    [anon_sym_LT_LT] = ACTIONS(5192),
    [anon_sym_GT_GT] = ACTIONS(5194),
    [anon_sym_SEMI] = ACTIONS(5194),
    [anon_sym___extension__] = ACTIONS(5194),
    [anon_sym___global__] = ACTIONS(5194),
    [anon_sym___attribute__] = ACTIONS(5194),
    [anon_sym_LBRACE] = ACTIONS(5194),
    [anon_sym_RBRACE] = ACTIONS(5194),
    [anon_sym_signed] = ACTIONS(5452),
    [anon_sym_unsigned] = ACTIONS(5452),
    [anon_sym_long] = ACTIONS(5452),
    [anon_sym_short] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5194),
    [anon_sym_RBRACK] = ACTIONS(5194),
    [anon_sym_const] = ACTIONS(5192),
    [anon_sym_constexpr] = ACTIONS(5194),
    [anon_sym_volatile] = ACTIONS(5194),
    [anon_sym_restrict] = ACTIONS(5194),
    [anon_sym___restrict__] = ACTIONS(5194),
    [anon_sym__Atomic] = ACTIONS(5194),
    [anon_sym__Noreturn] = ACTIONS(5194),
    [anon_sym_noreturn] = ACTIONS(5194),
    [anon_sym_mutable] = ACTIONS(5194),
    [anon_sym_constinit] = ACTIONS(5194),
    [anon_sym_consteval] = ACTIONS(5194),
    [anon_sym___shared__] = ACTIONS(5194),
    [anon_sym___local__] = ACTIONS(5194),
    [anon_sym___constant__] = ACTIONS(5194),
    [anon_sym___managed__] = ACTIONS(5194),
    [anon_sym___grid_constant__] = ACTIONS(5194),
    [anon_sym_alignas] = ACTIONS(5194),
    [anon_sym__Alignas] = ACTIONS(5194),
    [anon_sym_COLON] = ACTIONS(5194),
    [anon_sym_QMARK] = ACTIONS(5194),
    [anon_sym_LT_EQ_GT] = ACTIONS(5194),
    [anon_sym_or] = ACTIONS(5194),
    [anon_sym_and] = ACTIONS(5194),
    [anon_sym_bitor] = ACTIONS(5194),
    [anon_sym_xor] = ACTIONS(5194),
    [anon_sym_bitand] = ACTIONS(5194),
    [anon_sym_not_eq] = ACTIONS(5194),
    [anon_sym_DASH_DASH] = ACTIONS(5194),
    [anon_sym_PLUS_PLUS] = ACTIONS(5194),
    [anon_sym_DOT] = ACTIONS(5192),
    [anon_sym_DOT_STAR] = ACTIONS(5194),
    [anon_sym_DASH_GT] = ACTIONS(5194),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5194),
    [anon_sym_decltype] = ACTIONS(5194),
    [anon_sym_final] = ACTIONS(5194),
    [anon_sym_override] = ACTIONS(5194),
    [anon_sym_requires] = ACTIONS(5194),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5194),
  },
  [2137] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2133),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5376),
    [anon_sym_COMMA] = ACTIONS(5376),
    [anon_sym_RPAREN] = ACTIONS(5376),
    [anon_sym_LPAREN2] = ACTIONS(5376),
    [anon_sym_DASH] = ACTIONS(5374),
    [anon_sym_PLUS] = ACTIONS(5374),
    [anon_sym_STAR] = ACTIONS(5376),
    [anon_sym_SLASH] = ACTIONS(5374),
    [anon_sym_PERCENT] = ACTIONS(5376),
    [anon_sym_PIPE_PIPE] = ACTIONS(5376),
    [anon_sym_AMP_AMP] = ACTIONS(5376),
    [anon_sym_PIPE] = ACTIONS(5374),
    [anon_sym_CARET] = ACTIONS(5376),
    [anon_sym_AMP] = ACTIONS(5374),
    [anon_sym_EQ_EQ] = ACTIONS(5376),
    [anon_sym_BANG_EQ] = ACTIONS(5376),
    [anon_sym_GT] = ACTIONS(5374),
    [anon_sym_GT_EQ] = ACTIONS(5376),
    [anon_sym_LT_EQ] = ACTIONS(5374),
    [anon_sym_LT] = ACTIONS(5374),
    [anon_sym_LT_LT] = ACTIONS(5374),
    [anon_sym_GT_GT] = ACTIONS(5376),
    [anon_sym_SEMI] = ACTIONS(5376),
    [anon_sym___extension__] = ACTIONS(5376),
    [anon_sym___global__] = ACTIONS(5376),
    [anon_sym___attribute__] = ACTIONS(5376),
    [anon_sym_LBRACE] = ACTIONS(5376),
    [anon_sym_RBRACE] = ACTIONS(5376),
    [anon_sym_signed] = ACTIONS(5452),
    [anon_sym_unsigned] = ACTIONS(5452),
    [anon_sym_long] = ACTIONS(5452),
    [anon_sym_short] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5376),
    [anon_sym_RBRACK] = ACTIONS(5376),
    [anon_sym_const] = ACTIONS(5374),
    [anon_sym_constexpr] = ACTIONS(5376),
    [anon_sym_volatile] = ACTIONS(5376),
    [anon_sym_restrict] = ACTIONS(5376),
    [anon_sym___restrict__] = ACTIONS(5376),
    [anon_sym__Atomic] = ACTIONS(5376),
    [anon_sym__Noreturn] = ACTIONS(5376),
    [anon_sym_noreturn] = ACTIONS(5376),
    [anon_sym_mutable] = ACTIONS(5376),
    [anon_sym_constinit] = ACTIONS(5376),
    [anon_sym_consteval] = ACTIONS(5376),
    [anon_sym___shared__] = ACTIONS(5376),
    [anon_sym___local__] = ACTIONS(5376),
    [anon_sym___constant__] = ACTIONS(5376),
    [anon_sym___managed__] = ACTIONS(5376),
    [anon_sym___grid_constant__] = ACTIONS(5376),
    [anon_sym_alignas] = ACTIONS(5376),
    [anon_sym__Alignas] = ACTIONS(5376),
    [anon_sym_COLON] = ACTIONS(5376),
    [anon_sym_QMARK] = ACTIONS(5376),
    [anon_sym_LT_EQ_GT] = ACTIONS(5376),
    [anon_sym_or] = ACTIONS(5376),
    [anon_sym_and] = ACTIONS(5376),
    [anon_sym_bitor] = ACTIONS(5376),
    [anon_sym_xor] = ACTIONS(5376),
    [anon_sym_bitand] = ACTIONS(5376),
    [anon_sym_not_eq] = ACTIONS(5376),
    [anon_sym_DASH_DASH] = ACTIONS(5376),
    [anon_sym_PLUS_PLUS] = ACTIONS(5376),
    [anon_sym_DOT] = ACTIONS(5374),
    [anon_sym_DOT_STAR] = ACTIONS(5376),
    [anon_sym_DASH_GT] = ACTIONS(5376),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5376),
    [anon_sym_decltype] = ACTIONS(5376),
    [anon_sym_final] = ACTIONS(5376),
    [anon_sym_override] = ACTIONS(5376),
    [anon_sym_requires] = ACTIONS(5376),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5376),
  },
  [2138] = {
    [sym_identifier] = ACTIONS(5454),
    [anon_sym_LPAREN2] = ACTIONS(5456),
    [anon_sym_TILDE] = ACTIONS(5456),
    [anon_sym_STAR] = ACTIONS(5456),
    [anon_sym_AMP_AMP] = ACTIONS(5456),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym___extension__] = ACTIONS(5454),
    [anon_sym___device__] = ACTIONS(5454),
    [anon_sym___host__] = ACTIONS(5454),
    [anon_sym___global__] = ACTIONS(5454),
    [anon_sym___forceinline__] = ACTIONS(5454),
    [anon_sym___noinline__] = ACTIONS(5454),
    [anon_sym_extern] = ACTIONS(5454),
    [anon_sym___attribute__] = ACTIONS(5454),
    [anon_sym_COLON_COLON] = ACTIONS(5456),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5456),
    [anon_sym___declspec] = ACTIONS(5454),
    [anon_sym___based] = ACTIONS(5454),
    [anon_sym___cdecl] = ACTIONS(5454),
    [anon_sym___clrcall] = ACTIONS(5454),
    [anon_sym___stdcall] = ACTIONS(5454),
    [anon_sym___fastcall] = ACTIONS(5454),
    [anon_sym___thiscall] = ACTIONS(5454),
    [anon_sym___vectorcall] = ACTIONS(5454),
    [anon_sym_signed] = ACTIONS(5454),
    [anon_sym_unsigned] = ACTIONS(5454),
    [anon_sym_long] = ACTIONS(5454),
    [anon_sym_short] = ACTIONS(5454),
    [anon_sym_LBRACK] = ACTIONS(5454),
    [anon_sym_static] = ACTIONS(5454),
    [anon_sym_register] = ACTIONS(5454),
    [anon_sym_inline] = ACTIONS(5454),
    [anon_sym___inline] = ACTIONS(5454),
    [anon_sym___inline__] = ACTIONS(5454),
    [anon_sym___forceinline] = ACTIONS(5454),
    [anon_sym_thread_local] = ACTIONS(5454),
    [anon_sym___thread] = ACTIONS(5454),
    [anon_sym_const] = ACTIONS(5454),
    [anon_sym_constexpr] = ACTIONS(5454),
    [anon_sym_volatile] = ACTIONS(5454),
    [anon_sym_restrict] = ACTIONS(5454),
    [anon_sym___restrict__] = ACTIONS(5454),
    [anon_sym__Atomic] = ACTIONS(5454),
    [anon_sym__Noreturn] = ACTIONS(5454),
    [anon_sym_noreturn] = ACTIONS(5454),
    [anon_sym_mutable] = ACTIONS(5454),
    [anon_sym_constinit] = ACTIONS(5454),
    [anon_sym_consteval] = ACTIONS(5454),
    [anon_sym___shared__] = ACTIONS(5454),
    [anon_sym___local__] = ACTIONS(5454),
    [anon_sym___constant__] = ACTIONS(5454),
    [anon_sym___managed__] = ACTIONS(5454),
    [anon_sym___grid_constant__] = ACTIONS(5454),
    [anon_sym_alignas] = ACTIONS(5454),
    [anon_sym__Alignas] = ACTIONS(5454),
    [sym_primitive_type] = ACTIONS(5454),
    [anon_sym_enum] = ACTIONS(5454),
    [anon_sym_class] = ACTIONS(5454),
    [anon_sym_struct] = ACTIONS(5454),
    [anon_sym_union] = ACTIONS(5454),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5454),
    [anon_sym_decltype] = ACTIONS(5454),
    [sym_virtual] = ACTIONS(5454),
    [anon_sym_explicit] = ACTIONS(5454),
    [anon_sym_typename] = ACTIONS(5454),
    [anon_sym_template] = ACTIONS(5454),
    [anon_sym_operator] = ACTIONS(5454),
    [anon_sym_friend] = ACTIONS(5454),
    [anon_sym_using] = ACTIONS(5454),
    [anon_sym_concept] = ACTIONS(5454),
    [anon_sym_requires] = ACTIONS(5454),
    [anon_sym___launch_bounds__] = ACTIONS(5454),
  },
  [2139] = {
    [sym_identifier] = ACTIONS(5458),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5460),
    [anon_sym_COMMA] = ACTIONS(5460),
    [anon_sym_RPAREN] = ACTIONS(5460),
    [aux_sym_preproc_if_token2] = ACTIONS(5460),
    [aux_sym_preproc_else_token1] = ACTIONS(5460),
    [aux_sym_preproc_elif_token1] = ACTIONS(5458),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5460),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5460),
    [anon_sym_LPAREN2] = ACTIONS(5460),
    [anon_sym_DASH] = ACTIONS(5458),
    [anon_sym_PLUS] = ACTIONS(5458),
    [anon_sym_STAR] = ACTIONS(5458),
    [anon_sym_SLASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5458),
    [anon_sym_PIPE_PIPE] = ACTIONS(5460),
    [anon_sym_AMP_AMP] = ACTIONS(5460),
    [anon_sym_PIPE] = ACTIONS(5458),
    [anon_sym_CARET] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5458),
    [anon_sym_EQ_EQ] = ACTIONS(5460),
    [anon_sym_BANG_EQ] = ACTIONS(5460),
    [anon_sym_GT] = ACTIONS(5458),
    [anon_sym_GT_EQ] = ACTIONS(5460),
    [anon_sym_LT_EQ] = ACTIONS(5458),
    [anon_sym_LT] = ACTIONS(5458),
    [anon_sym_LT_LT] = ACTIONS(5458),
    [anon_sym_GT_GT] = ACTIONS(5458),
    [anon_sym_SEMI] = ACTIONS(5460),
    [anon_sym_RBRACE] = ACTIONS(5460),
    [anon_sym_LBRACK] = ACTIONS(5460),
    [anon_sym_RBRACK] = ACTIONS(5460),
    [anon_sym_EQ] = ACTIONS(5458),
    [anon_sym_COLON] = ACTIONS(5460),
    [anon_sym_QMARK] = ACTIONS(5460),
    [anon_sym_STAR_EQ] = ACTIONS(5460),
    [anon_sym_SLASH_EQ] = ACTIONS(5460),
    [anon_sym_PERCENT_EQ] = ACTIONS(5460),
    [anon_sym_PLUS_EQ] = ACTIONS(5460),
    [anon_sym_DASH_EQ] = ACTIONS(5460),
    [anon_sym_LT_LT_EQ] = ACTIONS(5460),
    [anon_sym_GT_GT_EQ] = ACTIONS(5460),
    [anon_sym_AMP_EQ] = ACTIONS(5460),
    [anon_sym_CARET_EQ] = ACTIONS(5460),
    [anon_sym_PIPE_EQ] = ACTIONS(5460),
    [anon_sym_and_eq] = ACTIONS(5458),
    [anon_sym_or_eq] = ACTIONS(5458),
    [anon_sym_xor_eq] = ACTIONS(5458),
    [anon_sym_LT_EQ_GT] = ACTIONS(5460),
    [anon_sym_or] = ACTIONS(5458),
    [anon_sym_and] = ACTIONS(5458),
    [anon_sym_bitor] = ACTIONS(5458),
    [anon_sym_xor] = ACTIONS(5458),
    [anon_sym_bitand] = ACTIONS(5458),
    [anon_sym_not_eq] = ACTIONS(5458),
    [anon_sym_DASH_DASH] = ACTIONS(5460),
    [anon_sym_PLUS_PLUS] = ACTIONS(5460),
    [anon_sym_DOT] = ACTIONS(5458),
    [anon_sym_DOT_STAR] = ACTIONS(5460),
    [anon_sym_DASH_GT] = ACTIONS(5460),
    [anon_sym_L_DQUOTE] = ACTIONS(5460),
    [anon_sym_u_DQUOTE] = ACTIONS(5460),
    [anon_sym_U_DQUOTE] = ACTIONS(5460),
    [anon_sym_u8_DQUOTE] = ACTIONS(5460),
    [anon_sym_DQUOTE] = ACTIONS(5460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5460),
    [anon_sym_LR_DQUOTE] = ACTIONS(5460),
    [anon_sym_uR_DQUOTE] = ACTIONS(5460),
    [anon_sym_UR_DQUOTE] = ACTIONS(5460),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5460),
    [sym_literal_suffix] = ACTIONS(5458),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5460),
  },
  [2140] = {
    [sym_identifier] = ACTIONS(5462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5464),
    [anon_sym_COMMA] = ACTIONS(5464),
    [anon_sym_RPAREN] = ACTIONS(5464),
    [aux_sym_preproc_if_token2] = ACTIONS(5464),
    [aux_sym_preproc_else_token1] = ACTIONS(5464),
    [aux_sym_preproc_elif_token1] = ACTIONS(5462),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5464),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5464),
    [anon_sym_LPAREN2] = ACTIONS(5464),
    [anon_sym_DASH] = ACTIONS(5462),
    [anon_sym_PLUS] = ACTIONS(5462),
    [anon_sym_STAR] = ACTIONS(5462),
    [anon_sym_SLASH] = ACTIONS(5462),
    [anon_sym_PERCENT] = ACTIONS(5462),
    [anon_sym_PIPE_PIPE] = ACTIONS(5464),
    [anon_sym_AMP_AMP] = ACTIONS(5464),
    [anon_sym_PIPE] = ACTIONS(5462),
    [anon_sym_CARET] = ACTIONS(5462),
    [anon_sym_AMP] = ACTIONS(5462),
    [anon_sym_EQ_EQ] = ACTIONS(5464),
    [anon_sym_BANG_EQ] = ACTIONS(5464),
    [anon_sym_GT] = ACTIONS(5462),
    [anon_sym_GT_EQ] = ACTIONS(5464),
    [anon_sym_LT_EQ] = ACTIONS(5462),
    [anon_sym_LT] = ACTIONS(5462),
    [anon_sym_LT_LT] = ACTIONS(5462),
    [anon_sym_GT_GT] = ACTIONS(5462),
    [anon_sym_SEMI] = ACTIONS(5464),
    [anon_sym_RBRACE] = ACTIONS(5464),
    [anon_sym_LBRACK] = ACTIONS(5464),
    [anon_sym_RBRACK] = ACTIONS(5464),
    [anon_sym_EQ] = ACTIONS(5462),
    [anon_sym_COLON] = ACTIONS(5464),
    [anon_sym_QMARK] = ACTIONS(5464),
    [anon_sym_STAR_EQ] = ACTIONS(5464),
    [anon_sym_SLASH_EQ] = ACTIONS(5464),
    [anon_sym_PERCENT_EQ] = ACTIONS(5464),
    [anon_sym_PLUS_EQ] = ACTIONS(5464),
    [anon_sym_DASH_EQ] = ACTIONS(5464),
    [anon_sym_LT_LT_EQ] = ACTIONS(5464),
    [anon_sym_GT_GT_EQ] = ACTIONS(5464),
    [anon_sym_AMP_EQ] = ACTIONS(5464),
    [anon_sym_CARET_EQ] = ACTIONS(5464),
    [anon_sym_PIPE_EQ] = ACTIONS(5464),
    [anon_sym_and_eq] = ACTIONS(5462),
    [anon_sym_or_eq] = ACTIONS(5462),
    [anon_sym_xor_eq] = ACTIONS(5462),
    [anon_sym_LT_EQ_GT] = ACTIONS(5464),
    [anon_sym_or] = ACTIONS(5462),
    [anon_sym_and] = ACTIONS(5462),
    [anon_sym_bitor] = ACTIONS(5462),
    [anon_sym_xor] = ACTIONS(5462),
    [anon_sym_bitand] = ACTIONS(5462),
    [anon_sym_not_eq] = ACTIONS(5462),
    [anon_sym_DASH_DASH] = ACTIONS(5464),
    [anon_sym_PLUS_PLUS] = ACTIONS(5464),
    [anon_sym_DOT] = ACTIONS(5462),
    [anon_sym_DOT_STAR] = ACTIONS(5464),
    [anon_sym_DASH_GT] = ACTIONS(5464),
    [anon_sym_L_DQUOTE] = ACTIONS(5464),
    [anon_sym_u_DQUOTE] = ACTIONS(5464),
    [anon_sym_U_DQUOTE] = ACTIONS(5464),
    [anon_sym_u8_DQUOTE] = ACTIONS(5464),
    [anon_sym_DQUOTE] = ACTIONS(5464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5464),
    [anon_sym_LR_DQUOTE] = ACTIONS(5464),
    [anon_sym_uR_DQUOTE] = ACTIONS(5464),
    [anon_sym_UR_DQUOTE] = ACTIONS(5464),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5464),
    [sym_literal_suffix] = ACTIONS(5462),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5464),
  },
  [2141] = {
    [sym_identifier] = ACTIONS(5466),
    [anon_sym_LPAREN2] = ACTIONS(5468),
    [anon_sym_TILDE] = ACTIONS(5468),
    [anon_sym_STAR] = ACTIONS(5468),
    [anon_sym_AMP_AMP] = ACTIONS(5468),
    [anon_sym_AMP] = ACTIONS(5466),
    [anon_sym___extension__] = ACTIONS(5466),
    [anon_sym___device__] = ACTIONS(5466),
    [anon_sym___host__] = ACTIONS(5466),
    [anon_sym___global__] = ACTIONS(5466),
    [anon_sym___forceinline__] = ACTIONS(5466),
    [anon_sym___noinline__] = ACTIONS(5466),
    [anon_sym_extern] = ACTIONS(5466),
    [anon_sym___attribute__] = ACTIONS(5466),
    [anon_sym_COLON_COLON] = ACTIONS(5468),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5468),
    [anon_sym___declspec] = ACTIONS(5466),
    [anon_sym___based] = ACTIONS(5466),
    [anon_sym___cdecl] = ACTIONS(5466),
    [anon_sym___clrcall] = ACTIONS(5466),
    [anon_sym___stdcall] = ACTIONS(5466),
    [anon_sym___fastcall] = ACTIONS(5466),
    [anon_sym___thiscall] = ACTIONS(5466),
    [anon_sym___vectorcall] = ACTIONS(5466),
    [anon_sym_signed] = ACTIONS(5466),
    [anon_sym_unsigned] = ACTIONS(5466),
    [anon_sym_long] = ACTIONS(5466),
    [anon_sym_short] = ACTIONS(5466),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_static] = ACTIONS(5466),
    [anon_sym_register] = ACTIONS(5466),
    [anon_sym_inline] = ACTIONS(5466),
    [anon_sym___inline] = ACTIONS(5466),
    [anon_sym___inline__] = ACTIONS(5466),
    [anon_sym___forceinline] = ACTIONS(5466),
    [anon_sym_thread_local] = ACTIONS(5466),
    [anon_sym___thread] = ACTIONS(5466),
    [anon_sym_const] = ACTIONS(5466),
    [anon_sym_constexpr] = ACTIONS(5466),
    [anon_sym_volatile] = ACTIONS(5466),
    [anon_sym_restrict] = ACTIONS(5466),
    [anon_sym___restrict__] = ACTIONS(5466),
    [anon_sym__Atomic] = ACTIONS(5466),
    [anon_sym__Noreturn] = ACTIONS(5466),
    [anon_sym_noreturn] = ACTIONS(5466),
    [anon_sym_mutable] = ACTIONS(5466),
    [anon_sym_constinit] = ACTIONS(5466),
    [anon_sym_consteval] = ACTIONS(5466),
    [anon_sym___shared__] = ACTIONS(5466),
    [anon_sym___local__] = ACTIONS(5466),
    [anon_sym___constant__] = ACTIONS(5466),
    [anon_sym___managed__] = ACTIONS(5466),
    [anon_sym___grid_constant__] = ACTIONS(5466),
    [anon_sym_alignas] = ACTIONS(5466),
    [anon_sym__Alignas] = ACTIONS(5466),
    [sym_primitive_type] = ACTIONS(5466),
    [anon_sym_enum] = ACTIONS(5466),
    [anon_sym_class] = ACTIONS(5466),
    [anon_sym_struct] = ACTIONS(5466),
    [anon_sym_union] = ACTIONS(5466),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5466),
    [anon_sym_decltype] = ACTIONS(5466),
    [sym_virtual] = ACTIONS(5466),
    [anon_sym_explicit] = ACTIONS(5466),
    [anon_sym_typename] = ACTIONS(5466),
    [anon_sym_template] = ACTIONS(5466),
    [anon_sym_operator] = ACTIONS(5466),
    [anon_sym_friend] = ACTIONS(5466),
    [anon_sym_using] = ACTIONS(5466),
    [anon_sym_concept] = ACTIONS(5466),
    [anon_sym_requires] = ACTIONS(5466),
    [anon_sym___launch_bounds__] = ACTIONS(5466),
  },
  [2142] = {
    [sym_identifier] = ACTIONS(5470),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5472),
    [anon_sym_COMMA] = ACTIONS(5472),
    [anon_sym_RPAREN] = ACTIONS(5472),
    [aux_sym_preproc_if_token2] = ACTIONS(5472),
    [aux_sym_preproc_else_token1] = ACTIONS(5472),
    [aux_sym_preproc_elif_token1] = ACTIONS(5470),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5472),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5472),
    [anon_sym_LPAREN2] = ACTIONS(5472),
    [anon_sym_DASH] = ACTIONS(5470),
    [anon_sym_PLUS] = ACTIONS(5470),
    [anon_sym_STAR] = ACTIONS(5470),
    [anon_sym_SLASH] = ACTIONS(5470),
    [anon_sym_PERCENT] = ACTIONS(5470),
    [anon_sym_PIPE_PIPE] = ACTIONS(5472),
    [anon_sym_AMP_AMP] = ACTIONS(5472),
    [anon_sym_PIPE] = ACTIONS(5470),
    [anon_sym_CARET] = ACTIONS(5470),
    [anon_sym_AMP] = ACTIONS(5470),
    [anon_sym_EQ_EQ] = ACTIONS(5472),
    [anon_sym_BANG_EQ] = ACTIONS(5472),
    [anon_sym_GT] = ACTIONS(5470),
    [anon_sym_GT_EQ] = ACTIONS(5472),
    [anon_sym_LT_EQ] = ACTIONS(5470),
    [anon_sym_LT] = ACTIONS(5470),
    [anon_sym_LT_LT] = ACTIONS(5470),
    [anon_sym_GT_GT] = ACTIONS(5470),
    [anon_sym_SEMI] = ACTIONS(5472),
    [anon_sym_RBRACE] = ACTIONS(5472),
    [anon_sym_LBRACK] = ACTIONS(5472),
    [anon_sym_RBRACK] = ACTIONS(5472),
    [anon_sym_EQ] = ACTIONS(5470),
    [anon_sym_COLON] = ACTIONS(5472),
    [anon_sym_QMARK] = ACTIONS(5472),
    [anon_sym_STAR_EQ] = ACTIONS(5472),
    [anon_sym_SLASH_EQ] = ACTIONS(5472),
    [anon_sym_PERCENT_EQ] = ACTIONS(5472),
    [anon_sym_PLUS_EQ] = ACTIONS(5472),
    [anon_sym_DASH_EQ] = ACTIONS(5472),
    [anon_sym_LT_LT_EQ] = ACTIONS(5472),
    [anon_sym_GT_GT_EQ] = ACTIONS(5472),
    [anon_sym_AMP_EQ] = ACTIONS(5472),
    [anon_sym_CARET_EQ] = ACTIONS(5472),
    [anon_sym_PIPE_EQ] = ACTIONS(5472),
    [anon_sym_and_eq] = ACTIONS(5470),
    [anon_sym_or_eq] = ACTIONS(5470),
    [anon_sym_xor_eq] = ACTIONS(5470),
    [anon_sym_LT_EQ_GT] = ACTIONS(5472),
    [anon_sym_or] = ACTIONS(5470),
    [anon_sym_and] = ACTIONS(5470),
    [anon_sym_bitor] = ACTIONS(5470),
    [anon_sym_xor] = ACTIONS(5470),
    [anon_sym_bitand] = ACTIONS(5470),
    [anon_sym_not_eq] = ACTIONS(5470),
    [anon_sym_DASH_DASH] = ACTIONS(5472),
    [anon_sym_PLUS_PLUS] = ACTIONS(5472),
    [anon_sym_DOT] = ACTIONS(5470),
    [anon_sym_DOT_STAR] = ACTIONS(5472),
    [anon_sym_DASH_GT] = ACTIONS(5472),
    [anon_sym_L_DQUOTE] = ACTIONS(5472),
    [anon_sym_u_DQUOTE] = ACTIONS(5472),
    [anon_sym_U_DQUOTE] = ACTIONS(5472),
    [anon_sym_u8_DQUOTE] = ACTIONS(5472),
    [anon_sym_DQUOTE] = ACTIONS(5472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5472),
    [anon_sym_LR_DQUOTE] = ACTIONS(5472),
    [anon_sym_uR_DQUOTE] = ACTIONS(5472),
    [anon_sym_UR_DQUOTE] = ACTIONS(5472),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5472),
    [sym_literal_suffix] = ACTIONS(5470),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5472),
  },
  [2143] = {
    [sym_identifier] = ACTIONS(5474),
    [anon_sym_LPAREN2] = ACTIONS(5476),
    [anon_sym_TILDE] = ACTIONS(5476),
    [anon_sym_STAR] = ACTIONS(5476),
    [anon_sym_AMP_AMP] = ACTIONS(5476),
    [anon_sym_AMP] = ACTIONS(5474),
    [anon_sym___extension__] = ACTIONS(5474),
    [anon_sym___device__] = ACTIONS(5474),
    [anon_sym___host__] = ACTIONS(5474),
    [anon_sym___global__] = ACTIONS(5474),
    [anon_sym___forceinline__] = ACTIONS(5474),
    [anon_sym___noinline__] = ACTIONS(5474),
    [anon_sym_extern] = ACTIONS(5474),
    [anon_sym___attribute__] = ACTIONS(5474),
    [anon_sym_COLON_COLON] = ACTIONS(5476),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5476),
    [anon_sym___declspec] = ACTIONS(5474),
    [anon_sym___based] = ACTIONS(5474),
    [anon_sym___cdecl] = ACTIONS(5474),
    [anon_sym___clrcall] = ACTIONS(5474),
    [anon_sym___stdcall] = ACTIONS(5474),
    [anon_sym___fastcall] = ACTIONS(5474),
    [anon_sym___thiscall] = ACTIONS(5474),
    [anon_sym___vectorcall] = ACTIONS(5474),
    [anon_sym_signed] = ACTIONS(5474),
    [anon_sym_unsigned] = ACTIONS(5474),
    [anon_sym_long] = ACTIONS(5474),
    [anon_sym_short] = ACTIONS(5474),
    [anon_sym_LBRACK] = ACTIONS(5474),
    [anon_sym_static] = ACTIONS(5474),
    [anon_sym_register] = ACTIONS(5474),
    [anon_sym_inline] = ACTIONS(5474),
    [anon_sym___inline] = ACTIONS(5474),
    [anon_sym___inline__] = ACTIONS(5474),
    [anon_sym___forceinline] = ACTIONS(5474),
    [anon_sym_thread_local] = ACTIONS(5474),
    [anon_sym___thread] = ACTIONS(5474),
    [anon_sym_const] = ACTIONS(5474),
    [anon_sym_constexpr] = ACTIONS(5474),
    [anon_sym_volatile] = ACTIONS(5474),
    [anon_sym_restrict] = ACTIONS(5474),
    [anon_sym___restrict__] = ACTIONS(5474),
    [anon_sym__Atomic] = ACTIONS(5474),
    [anon_sym__Noreturn] = ACTIONS(5474),
    [anon_sym_noreturn] = ACTIONS(5474),
    [anon_sym_mutable] = ACTIONS(5474),
    [anon_sym_constinit] = ACTIONS(5474),
    [anon_sym_consteval] = ACTIONS(5474),
    [anon_sym___shared__] = ACTIONS(5474),
    [anon_sym___local__] = ACTIONS(5474),
    [anon_sym___constant__] = ACTIONS(5474),
    [anon_sym___managed__] = ACTIONS(5474),
    [anon_sym___grid_constant__] = ACTIONS(5474),
    [anon_sym_alignas] = ACTIONS(5474),
    [anon_sym__Alignas] = ACTIONS(5474),
    [sym_primitive_type] = ACTIONS(5474),
    [anon_sym_enum] = ACTIONS(5474),
    [anon_sym_class] = ACTIONS(5474),
    [anon_sym_struct] = ACTIONS(5474),
    [anon_sym_union] = ACTIONS(5474),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5474),
    [anon_sym_decltype] = ACTIONS(5474),
    [sym_virtual] = ACTIONS(5474),
    [anon_sym_explicit] = ACTIONS(5474),
    [anon_sym_typename] = ACTIONS(5474),
    [anon_sym_template] = ACTIONS(5474),
    [anon_sym_operator] = ACTIONS(5474),
    [anon_sym_friend] = ACTIONS(5474),
    [anon_sym_using] = ACTIONS(5474),
    [anon_sym_concept] = ACTIONS(5474),
    [anon_sym_requires] = ACTIONS(5474),
    [anon_sym___launch_bounds__] = ACTIONS(5474),
  },
  [2144] = {
    [sym_identifier] = ACTIONS(5478),
    [anon_sym_LPAREN2] = ACTIONS(5480),
    [anon_sym_BANG] = ACTIONS(5480),
    [anon_sym_TILDE] = ACTIONS(5480),
    [anon_sym_DASH] = ACTIONS(5478),
    [anon_sym_PLUS] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(5480),
    [anon_sym_AMP] = ACTIONS(5480),
    [anon_sym_SEMI] = ACTIONS(5480),
    [anon_sym_COLON_COLON] = ACTIONS(5480),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5480),
    [anon_sym_LBRACE] = ACTIONS(5480),
    [anon_sym_LBRACK] = ACTIONS(5478),
    [sym_primitive_type] = ACTIONS(5478),
    [anon_sym_if] = ACTIONS(5478),
    [anon_sym_switch] = ACTIONS(5478),
    [anon_sym_case] = ACTIONS(5478),
    [anon_sym_default] = ACTIONS(5478),
    [anon_sym_while] = ACTIONS(5478),
    [anon_sym_do] = ACTIONS(5478),
    [anon_sym_for] = ACTIONS(5478),
    [anon_sym_return] = ACTIONS(5478),
    [anon_sym_break] = ACTIONS(5478),
    [anon_sym_continue] = ACTIONS(5478),
    [anon_sym_goto] = ACTIONS(5478),
    [anon_sym___try] = ACTIONS(5478),
    [anon_sym___leave] = ACTIONS(5478),
    [anon_sym_not] = ACTIONS(5478),
    [anon_sym_compl] = ACTIONS(5478),
    [anon_sym_DASH_DASH] = ACTIONS(5480),
    [anon_sym_PLUS_PLUS] = ACTIONS(5480),
    [anon_sym_sizeof] = ACTIONS(5478),
    [anon_sym___alignof__] = ACTIONS(5478),
    [anon_sym___alignof] = ACTIONS(5478),
    [anon_sym__alignof] = ACTIONS(5478),
    [anon_sym_alignof] = ACTIONS(5478),
    [anon_sym__Alignof] = ACTIONS(5478),
    [anon_sym_offsetof] = ACTIONS(5478),
    [anon_sym__Generic] = ACTIONS(5478),
    [anon_sym_asm] = ACTIONS(5478),
    [anon_sym___asm__] = ACTIONS(5478),
    [sym_number_literal] = ACTIONS(5480),
    [anon_sym_L_SQUOTE] = ACTIONS(5480),
    [anon_sym_u_SQUOTE] = ACTIONS(5480),
    [anon_sym_U_SQUOTE] = ACTIONS(5480),
    [anon_sym_u8_SQUOTE] = ACTIONS(5480),
    [anon_sym_SQUOTE] = ACTIONS(5480),
    [anon_sym_L_DQUOTE] = ACTIONS(5480),
    [anon_sym_u_DQUOTE] = ACTIONS(5480),
    [anon_sym_U_DQUOTE] = ACTIONS(5480),
    [anon_sym_u8_DQUOTE] = ACTIONS(5480),
    [anon_sym_DQUOTE] = ACTIONS(5480),
    [sym_true] = ACTIONS(5478),
    [sym_false] = ACTIONS(5478),
    [anon_sym_NULL] = ACTIONS(5478),
    [anon_sym_nullptr] = ACTIONS(5478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(5478),
    [anon_sym_template] = ACTIONS(5478),
    [anon_sym_try] = ACTIONS(5478),
    [anon_sym_delete] = ACTIONS(5478),
    [anon_sym_throw] = ACTIONS(5478),
    [anon_sym_co_return] = ACTIONS(5478),
    [anon_sym_co_yield] = ACTIONS(5478),
    [anon_sym_R_DQUOTE] = ACTIONS(5480),
    [anon_sym_LR_DQUOTE] = ACTIONS(5480),
    [anon_sym_uR_DQUOTE] = ACTIONS(5480),
    [anon_sym_UR_DQUOTE] = ACTIONS(5480),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5480),
    [anon_sym_co_await] = ACTIONS(5478),
    [anon_sym_new] = ACTIONS(5478),
    [anon_sym_requires] = ACTIONS(5478),
    [sym_this] = ACTIONS(5478),
  },
  [2145] = {
    [sym_ms_based_modifier] = STATE(8387),
    [sym_ms_unaligned_ptr_modifier] = STATE(4253),
    [sym_ms_pointer_modifier] = STATE(2148),
    [sym__declarator] = STATE(6643),
    [sym__abstract_declarator] = STATE(6720),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_abstract_parenthesized_declarator] = STATE(6430),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_abstract_pointer_declarator] = STATE(6430),
    [sym_function_declarator] = STATE(6598),
    [sym_abstract_function_declarator] = STATE(6430),
    [sym_array_declarator] = STATE(6598),
    [sym_abstract_array_declarator] = STATE(6430),
    [sym_type_qualifier] = STATE(2479),
    [sym_alignas_qualifier] = STATE(4511),
    [sym_parameter_list] = STATE(2819),
    [sym_decltype] = STATE(8628),
    [sym_reference_declarator] = STATE(6598),
    [sym_abstract_reference_declarator] = STATE(6430),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym__function_declarator_seq] = STATE(6416),
    [sym_template_type] = STATE(8628),
    [sym_template_function] = STATE(6598),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6059),
    [sym_qualified_identifier] = STATE(6598),
    [sym_operator_name] = STATE(6598),
    [aux_sym__type_definition_type_repeat1] = STATE(2479),
    [aux_sym_pointer_declarator_repeat1] = STATE(2148),
    [sym_identifier] = ACTIONS(5482),
    [anon_sym_COMMA] = ACTIONS(5484),
    [anon_sym_RPAREN] = ACTIONS(5484),
    [anon_sym_LPAREN2] = ACTIONS(3957),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(5486),
    [anon_sym_AMP_AMP] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5490),
    [anon_sym___extension__] = ACTIONS(3171),
    [anon_sym___global__] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(5492),
    [anon_sym___based] = ACTIONS(49),
    [sym_ms_restrict_modifier] = ACTIONS(3173),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3173),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3173),
    [anon_sym__unaligned] = ACTIONS(3175),
    [anon_sym___unaligned] = ACTIONS(3175),
    [anon_sym_LBRACK] = ACTIONS(5494),
    [anon_sym_EQ] = ACTIONS(5484),
    [anon_sym_const] = ACTIONS(3171),
    [anon_sym_constexpr] = ACTIONS(3171),
    [anon_sym_volatile] = ACTIONS(3171),
    [anon_sym_restrict] = ACTIONS(3171),
    [anon_sym___restrict__] = ACTIONS(3171),
    [anon_sym__Atomic] = ACTIONS(3171),
    [anon_sym__Noreturn] = ACTIONS(3171),
    [anon_sym_noreturn] = ACTIONS(3171),
    [anon_sym_mutable] = ACTIONS(3171),
    [anon_sym_constinit] = ACTIONS(3171),
    [anon_sym_consteval] = ACTIONS(3171),
    [anon_sym___shared__] = ACTIONS(3171),
    [anon_sym___local__] = ACTIONS(3171),
    [anon_sym___constant__] = ACTIONS(3171),
    [anon_sym___managed__] = ACTIONS(3171),
    [anon_sym___grid_constant__] = ACTIONS(3171),
    [anon_sym_alignas] = ACTIONS(3177),
    [anon_sym__Alignas] = ACTIONS(3177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_GT2] = ACTIONS(5484),
    [anon_sym_operator] = ACTIONS(1883),
  },
  [2146] = {
    [sym_identifier] = ACTIONS(5496),
    [anon_sym_LPAREN2] = ACTIONS(5498),
    [anon_sym_BANG] = ACTIONS(5498),
    [anon_sym_TILDE] = ACTIONS(5498),
    [anon_sym_DASH] = ACTIONS(5496),
    [anon_sym_PLUS] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(5498),
    [anon_sym_AMP] = ACTIONS(5498),
    [anon_sym_SEMI] = ACTIONS(5498),
    [anon_sym_COLON_COLON] = ACTIONS(5498),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5498),
    [anon_sym_LBRACE] = ACTIONS(5498),
    [anon_sym_LBRACK] = ACTIONS(5496),
    [sym_primitive_type] = ACTIONS(5496),
    [anon_sym_if] = ACTIONS(5496),
    [anon_sym_switch] = ACTIONS(5496),
    [anon_sym_case] = ACTIONS(5496),
    [anon_sym_default] = ACTIONS(5496),
    [anon_sym_while] = ACTIONS(5496),
    [anon_sym_do] = ACTIONS(5496),
    [anon_sym_for] = ACTIONS(5496),
    [anon_sym_return] = ACTIONS(5496),
    [anon_sym_break] = ACTIONS(5496),
    [anon_sym_continue] = ACTIONS(5496),
    [anon_sym_goto] = ACTIONS(5496),
    [anon_sym___try] = ACTIONS(5496),
    [anon_sym___leave] = ACTIONS(5496),
    [anon_sym_not] = ACTIONS(5496),
    [anon_sym_compl] = ACTIONS(5496),
    [anon_sym_DASH_DASH] = ACTIONS(5498),
    [anon_sym_PLUS_PLUS] = ACTIONS(5498),
    [anon_sym_sizeof] = ACTIONS(5496),
    [anon_sym___alignof__] = ACTIONS(5496),
    [anon_sym___alignof] = ACTIONS(5496),
    [anon_sym__alignof] = ACTIONS(5496),
    [anon_sym_alignof] = ACTIONS(5496),
    [anon_sym__Alignof] = ACTIONS(5496),
    [anon_sym_offsetof] = ACTIONS(5496),
    [anon_sym__Generic] = ACTIONS(5496),
    [anon_sym_asm] = ACTIONS(5496),
    [anon_sym___asm__] = ACTIONS(5496),
    [sym_number_literal] = ACTIONS(5498),
    [anon_sym_L_SQUOTE] = ACTIONS(5498),
    [anon_sym_u_SQUOTE] = ACTIONS(5498),
    [anon_sym_U_SQUOTE] = ACTIONS(5498),
    [anon_sym_u8_SQUOTE] = ACTIONS(5498),
    [anon_sym_SQUOTE] = ACTIONS(5498),
    [anon_sym_L_DQUOTE] = ACTIONS(5498),
    [anon_sym_u_DQUOTE] = ACTIONS(5498),
    [anon_sym_U_DQUOTE] = ACTIONS(5498),
    [anon_sym_u8_DQUOTE] = ACTIONS(5498),
    [anon_sym_DQUOTE] = ACTIONS(5498),
    [sym_true] = ACTIONS(5496),
    [sym_false] = ACTIONS(5496),
    [anon_sym_NULL] = ACTIONS(5496),
    [anon_sym_nullptr] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(5496),
    [anon_sym_template] = ACTIONS(5496),
    [anon_sym_try] = ACTIONS(5496),
    [anon_sym_delete] = ACTIONS(5496),
    [anon_sym_throw] = ACTIONS(5496),
    [anon_sym_co_return] = ACTIONS(5496),
    [anon_sym_co_yield] = ACTIONS(5496),
    [anon_sym_R_DQUOTE] = ACTIONS(5498),
    [anon_sym_LR_DQUOTE] = ACTIONS(5498),
    [anon_sym_uR_DQUOTE] = ACTIONS(5498),
    [anon_sym_UR_DQUOTE] = ACTIONS(5498),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5498),
    [anon_sym_co_await] = ACTIONS(5496),
    [anon_sym_new] = ACTIONS(5496),
    [anon_sym_requires] = ACTIONS(5496),
    [sym_this] = ACTIONS(5496),
  },
  [2147] = {
    [sym_identifier] = ACTIONS(5500),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5502),
    [anon_sym_COMMA] = ACTIONS(5502),
    [anon_sym_RPAREN] = ACTIONS(5502),
    [aux_sym_preproc_if_token2] = ACTIONS(5502),
    [aux_sym_preproc_else_token1] = ACTIONS(5502),
    [aux_sym_preproc_elif_token1] = ACTIONS(5500),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5502),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5502),
    [anon_sym_LPAREN2] = ACTIONS(5502),
    [anon_sym_DASH] = ACTIONS(5500),
    [anon_sym_PLUS] = ACTIONS(5500),
    [anon_sym_STAR] = ACTIONS(5500),
    [anon_sym_SLASH] = ACTIONS(5500),
    [anon_sym_PERCENT] = ACTIONS(5500),
    [anon_sym_PIPE_PIPE] = ACTIONS(5502),
    [anon_sym_AMP_AMP] = ACTIONS(5502),
    [anon_sym_PIPE] = ACTIONS(5500),
    [anon_sym_CARET] = ACTIONS(5500),
    [anon_sym_AMP] = ACTIONS(5500),
    [anon_sym_EQ_EQ] = ACTIONS(5502),
    [anon_sym_BANG_EQ] = ACTIONS(5502),
    [anon_sym_GT] = ACTIONS(5500),
    [anon_sym_GT_EQ] = ACTIONS(5502),
    [anon_sym_LT_EQ] = ACTIONS(5500),
    [anon_sym_LT] = ACTIONS(5500),
    [anon_sym_LT_LT] = ACTIONS(5500),
    [anon_sym_GT_GT] = ACTIONS(5500),
    [anon_sym_SEMI] = ACTIONS(5502),
    [anon_sym_RBRACE] = ACTIONS(5502),
    [anon_sym_LBRACK] = ACTIONS(5502),
    [anon_sym_RBRACK] = ACTIONS(5502),
    [anon_sym_EQ] = ACTIONS(5500),
    [anon_sym_COLON] = ACTIONS(5502),
    [anon_sym_QMARK] = ACTIONS(5502),
    [anon_sym_STAR_EQ] = ACTIONS(5502),
    [anon_sym_SLASH_EQ] = ACTIONS(5502),
    [anon_sym_PERCENT_EQ] = ACTIONS(5502),
    [anon_sym_PLUS_EQ] = ACTIONS(5502),
    [anon_sym_DASH_EQ] = ACTIONS(5502),
    [anon_sym_LT_LT_EQ] = ACTIONS(5502),
    [anon_sym_GT_GT_EQ] = ACTIONS(5502),
    [anon_sym_AMP_EQ] = ACTIONS(5502),
    [anon_sym_CARET_EQ] = ACTIONS(5502),
    [anon_sym_PIPE_EQ] = ACTIONS(5502),
    [anon_sym_and_eq] = ACTIONS(5500),
    [anon_sym_or_eq] = ACTIONS(5500),
    [anon_sym_xor_eq] = ACTIONS(5500),
    [anon_sym_LT_EQ_GT] = ACTIONS(5502),
    [anon_sym_or] = ACTIONS(5500),
    [anon_sym_and] = ACTIONS(5500),
    [anon_sym_bitor] = ACTIONS(5500),
    [anon_sym_xor] = ACTIONS(5500),
    [anon_sym_bitand] = ACTIONS(5500),
    [anon_sym_not_eq] = ACTIONS(5500),
    [anon_sym_DASH_DASH] = ACTIONS(5502),
    [anon_sym_PLUS_PLUS] = ACTIONS(5502),
    [anon_sym_DOT] = ACTIONS(5500),
    [anon_sym_DOT_STAR] = ACTIONS(5502),
    [anon_sym_DASH_GT] = ACTIONS(5502),
    [anon_sym_L_DQUOTE] = ACTIONS(5502),
    [anon_sym_u_DQUOTE] = ACTIONS(5502),
    [anon_sym_U_DQUOTE] = ACTIONS(5502),
    [anon_sym_u8_DQUOTE] = ACTIONS(5502),
    [anon_sym_DQUOTE] = ACTIONS(5502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5502),
    [anon_sym_LR_DQUOTE] = ACTIONS(5502),
    [anon_sym_uR_DQUOTE] = ACTIONS(5502),
    [anon_sym_UR_DQUOTE] = ACTIONS(5502),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5502),
    [sym_literal_suffix] = ACTIONS(5500),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5502),
  },
  [2148] = {
    [sym_ms_based_modifier] = STATE(8387),
    [sym_ms_unaligned_ptr_modifier] = STATE(4253),
    [sym_ms_pointer_modifier] = STATE(4023),
    [sym__declarator] = STATE(6666),
    [sym__abstract_declarator] = STATE(6745),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_abstract_parenthesized_declarator] = STATE(6430),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_abstract_pointer_declarator] = STATE(6430),
    [sym_function_declarator] = STATE(6598),
    [sym_abstract_function_declarator] = STATE(6430),
    [sym_array_declarator] = STATE(6598),
    [sym_abstract_array_declarator] = STATE(6430),
    [sym_type_qualifier] = STATE(2498),
    [sym_alignas_qualifier] = STATE(4511),
    [sym_parameter_list] = STATE(2819),
    [sym_decltype] = STATE(8628),
    [sym_reference_declarator] = STATE(6598),
    [sym_abstract_reference_declarator] = STATE(6430),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym__function_declarator_seq] = STATE(6416),
    [sym_template_type] = STATE(8628),
    [sym_template_function] = STATE(6598),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6059),
    [sym_qualified_identifier] = STATE(6598),
    [sym_operator_name] = STATE(6598),
    [aux_sym__type_definition_type_repeat1] = STATE(2498),
    [aux_sym_pointer_declarator_repeat1] = STATE(4023),
    [sym_identifier] = ACTIONS(5482),
    [anon_sym_COMMA] = ACTIONS(5504),
    [anon_sym_RPAREN] = ACTIONS(5504),
    [anon_sym_LPAREN2] = ACTIONS(3957),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(5486),
    [anon_sym_AMP_AMP] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5490),
    [anon_sym___extension__] = ACTIONS(3171),
    [anon_sym___global__] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(5492),
    [anon_sym___based] = ACTIONS(49),
    [sym_ms_restrict_modifier] = ACTIONS(3173),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3173),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3173),
    [anon_sym__unaligned] = ACTIONS(3175),
    [anon_sym___unaligned] = ACTIONS(3175),
    [anon_sym_LBRACK] = ACTIONS(5494),
    [anon_sym_EQ] = ACTIONS(5504),
    [anon_sym_const] = ACTIONS(3171),
    [anon_sym_constexpr] = ACTIONS(3171),
    [anon_sym_volatile] = ACTIONS(3171),
    [anon_sym_restrict] = ACTIONS(3171),
    [anon_sym___restrict__] = ACTIONS(3171),
    [anon_sym__Atomic] = ACTIONS(3171),
    [anon_sym__Noreturn] = ACTIONS(3171),
    [anon_sym_noreturn] = ACTIONS(3171),
    [anon_sym_mutable] = ACTIONS(3171),
    [anon_sym_constinit] = ACTIONS(3171),
    [anon_sym_consteval] = ACTIONS(3171),
    [anon_sym___shared__] = ACTIONS(3171),
    [anon_sym___local__] = ACTIONS(3171),
    [anon_sym___constant__] = ACTIONS(3171),
    [anon_sym___managed__] = ACTIONS(3171),
    [anon_sym___grid_constant__] = ACTIONS(3171),
    [anon_sym_alignas] = ACTIONS(3177),
    [anon_sym__Alignas] = ACTIONS(3177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_GT2] = ACTIONS(5504),
    [anon_sym_operator] = ACTIONS(1883),
  },
  [2149] = {
    [sym_attribute_specifier] = STATE(1945),
    [sym_field_declaration_list] = STATE(2244),
    [sym_virtual_specifier] = STATE(7332),
    [sym_base_class_clause] = STATE(8126),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5506),
    [anon_sym_COMMA] = ACTIONS(5506),
    [anon_sym_RPAREN] = ACTIONS(5506),
    [anon_sym_LPAREN2] = ACTIONS(5506),
    [anon_sym_DASH] = ACTIONS(5508),
    [anon_sym_PLUS] = ACTIONS(5508),
    [anon_sym_STAR] = ACTIONS(5506),
    [anon_sym_SLASH] = ACTIONS(5508),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [anon_sym_PIPE_PIPE] = ACTIONS(5506),
    [anon_sym_AMP_AMP] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(5508),
    [anon_sym_CARET] = ACTIONS(5506),
    [anon_sym_AMP] = ACTIONS(5508),
    [anon_sym_EQ_EQ] = ACTIONS(5506),
    [anon_sym_BANG_EQ] = ACTIONS(5506),
    [anon_sym_GT] = ACTIONS(5508),
    [anon_sym_GT_EQ] = ACTIONS(5506),
    [anon_sym_LT_EQ] = ACTIONS(5508),
    [anon_sym_LT] = ACTIONS(5508),
    [anon_sym_LT_LT] = ACTIONS(5508),
    [anon_sym_GT_GT] = ACTIONS(5506),
    [anon_sym_SEMI] = ACTIONS(5506),
    [anon_sym___extension__] = ACTIONS(5506),
    [anon_sym___global__] = ACTIONS(5506),
    [anon_sym___attribute__] = ACTIONS(5510),
    [anon_sym_LBRACE] = ACTIONS(5512),
    [anon_sym_RBRACE] = ACTIONS(5506),
    [anon_sym_LBRACK] = ACTIONS(5506),
    [anon_sym_RBRACK] = ACTIONS(5506),
    [anon_sym_const] = ACTIONS(5508),
    [anon_sym_constexpr] = ACTIONS(5506),
    [anon_sym_volatile] = ACTIONS(5506),
    [anon_sym_restrict] = ACTIONS(5506),
    [anon_sym___restrict__] = ACTIONS(5506),
    [anon_sym__Atomic] = ACTIONS(5506),
    [anon_sym__Noreturn] = ACTIONS(5506),
    [anon_sym_noreturn] = ACTIONS(5506),
    [anon_sym_mutable] = ACTIONS(5506),
    [anon_sym_constinit] = ACTIONS(5506),
    [anon_sym_consteval] = ACTIONS(5506),
    [anon_sym___shared__] = ACTIONS(5506),
    [anon_sym___local__] = ACTIONS(5506),
    [anon_sym___constant__] = ACTIONS(5506),
    [anon_sym___managed__] = ACTIONS(5506),
    [anon_sym___grid_constant__] = ACTIONS(5506),
    [anon_sym_alignas] = ACTIONS(5506),
    [anon_sym__Alignas] = ACTIONS(5506),
    [anon_sym_COLON] = ACTIONS(5514),
    [anon_sym_QMARK] = ACTIONS(5506),
    [anon_sym_LT_EQ_GT] = ACTIONS(5506),
    [anon_sym_or] = ACTIONS(5506),
    [anon_sym_and] = ACTIONS(5506),
    [anon_sym_bitor] = ACTIONS(5506),
    [anon_sym_xor] = ACTIONS(5506),
    [anon_sym_bitand] = ACTIONS(5506),
    [anon_sym_not_eq] = ACTIONS(5506),
    [anon_sym_DASH_DASH] = ACTIONS(5506),
    [anon_sym_PLUS_PLUS] = ACTIONS(5506),
    [anon_sym_DOT] = ACTIONS(5508),
    [anon_sym_DOT_STAR] = ACTIONS(5506),
    [anon_sym_DASH_GT] = ACTIONS(5506),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5506),
    [anon_sym_decltype] = ACTIONS(5506),
    [anon_sym_final] = ACTIONS(5516),
    [anon_sym_override] = ACTIONS(5516),
    [anon_sym_requires] = ACTIONS(5506),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5506),
  },
  [2150] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2162),
    [sym_identifier] = ACTIONS(5016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5258),
    [anon_sym_COMMA] = ACTIONS(5258),
    [anon_sym_LPAREN2] = ACTIONS(5258),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5261),
    [anon_sym_STAR] = ACTIONS(5258),
    [anon_sym_SLASH] = ACTIONS(5261),
    [anon_sym_PERCENT] = ACTIONS(5258),
    [anon_sym_PIPE_PIPE] = ACTIONS(5258),
    [anon_sym_AMP_AMP] = ACTIONS(5258),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_CARET] = ACTIONS(5258),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_EQ_EQ] = ACTIONS(5258),
    [anon_sym_BANG_EQ] = ACTIONS(5258),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5261),
    [anon_sym_LT_EQ] = ACTIONS(5261),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_LT] = ACTIONS(5261),
    [anon_sym_GT_GT] = ACTIONS(5261),
    [anon_sym___extension__] = ACTIONS(5261),
    [anon_sym___global__] = ACTIONS(5261),
    [anon_sym___attribute__] = ACTIONS(5261),
    [anon_sym_LBRACE] = ACTIONS(5258),
    [anon_sym_signed] = ACTIONS(5518),
    [anon_sym_unsigned] = ACTIONS(5518),
    [anon_sym_long] = ACTIONS(5518),
    [anon_sym_short] = ACTIONS(5518),
    [anon_sym_LBRACK] = ACTIONS(5258),
    [anon_sym_const] = ACTIONS(5261),
    [anon_sym_constexpr] = ACTIONS(5261),
    [anon_sym_volatile] = ACTIONS(5261),
    [anon_sym_restrict] = ACTIONS(5261),
    [anon_sym___restrict__] = ACTIONS(5261),
    [anon_sym__Atomic] = ACTIONS(5261),
    [anon_sym__Noreturn] = ACTIONS(5261),
    [anon_sym_noreturn] = ACTIONS(5261),
    [anon_sym_mutable] = ACTIONS(5261),
    [anon_sym_constinit] = ACTIONS(5261),
    [anon_sym_consteval] = ACTIONS(5261),
    [anon_sym___shared__] = ACTIONS(5261),
    [anon_sym___local__] = ACTIONS(5261),
    [anon_sym___constant__] = ACTIONS(5261),
    [anon_sym___managed__] = ACTIONS(5261),
    [anon_sym___grid_constant__] = ACTIONS(5261),
    [anon_sym_alignas] = ACTIONS(5261),
    [anon_sym__Alignas] = ACTIONS(5261),
    [sym_primitive_type] = ACTIONS(5016),
    [anon_sym_QMARK] = ACTIONS(5258),
    [anon_sym_LT_EQ_GT] = ACTIONS(5258),
    [anon_sym_or] = ACTIONS(5261),
    [anon_sym_and] = ACTIONS(5261),
    [anon_sym_bitor] = ACTIONS(5261),
    [anon_sym_xor] = ACTIONS(5261),
    [anon_sym_bitand] = ACTIONS(5261),
    [anon_sym_not_eq] = ACTIONS(5261),
    [anon_sym_DASH_DASH] = ACTIONS(5258),
    [anon_sym_PLUS_PLUS] = ACTIONS(5258),
    [anon_sym_DOT] = ACTIONS(5261),
    [anon_sym_DOT_STAR] = ACTIONS(5258),
    [anon_sym_DASH_GT] = ACTIONS(5258),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5261),
    [anon_sym_decltype] = ACTIONS(5261),
    [anon_sym_final] = ACTIONS(5261),
    [anon_sym_override] = ACTIONS(5261),
    [anon_sym_GT2] = ACTIONS(5258),
    [anon_sym_requires] = ACTIONS(5261),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5258),
  },
  [2151] = {
    [sym__declaration_modifiers] = STATE(2159),
    [sym_attribute_specifier] = STATE(2159),
    [sym_attribute_declaration] = STATE(2159),
    [sym_ms_declspec_modifier] = STATE(2159),
    [sym_storage_class_specifier] = STATE(2159),
    [sym_type_qualifier] = STATE(2159),
    [sym_alignas_qualifier] = STATE(2611),
    [sym_launch_bounds] = STATE(2159),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(5521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5523),
    [anon_sym_COMMA] = ACTIONS(5523),
    [anon_sym_RPAREN] = ACTIONS(5523),
    [anon_sym_LPAREN2] = ACTIONS(5523),
    [anon_sym_TILDE] = ACTIONS(5523),
    [anon_sym_STAR] = ACTIONS(5523),
    [anon_sym_AMP_AMP] = ACTIONS(5523),
    [anon_sym_AMP] = ACTIONS(5521),
    [anon_sym_SEMI] = ACTIONS(5523),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym___device__] = ACTIONS(5525),
    [anon_sym___host__] = ACTIONS(5525),
    [anon_sym___global__] = ACTIONS(5525),
    [anon_sym___forceinline__] = ACTIONS(5525),
    [anon_sym___noinline__] = ACTIONS(5525),
    [anon_sym_extern] = ACTIONS(5000),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5006),
    [anon_sym___declspec] = ACTIONS(5008),
    [anon_sym___based] = ACTIONS(5521),
    [anon_sym___cdecl] = ACTIONS(5521),
    [anon_sym___clrcall] = ACTIONS(5521),
    [anon_sym___stdcall] = ACTIONS(5521),
    [anon_sym___fastcall] = ACTIONS(5521),
    [anon_sym___thiscall] = ACTIONS(5521),
    [anon_sym___vectorcall] = ACTIONS(5521),
    [anon_sym_LBRACK] = ACTIONS(5521),
    [anon_sym_static] = ACTIONS(5000),
    [anon_sym_EQ] = ACTIONS(5523),
    [anon_sym_register] = ACTIONS(5000),
    [anon_sym_inline] = ACTIONS(5000),
    [anon_sym___inline] = ACTIONS(5000),
    [anon_sym___inline__] = ACTIONS(5000),
    [anon_sym___forceinline] = ACTIONS(5000),
    [anon_sym_thread_local] = ACTIONS(5000),
    [anon_sym___thread] = ACTIONS(5000),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym___shared__] = ACTIONS(4996),
    [anon_sym___local__] = ACTIONS(4996),
    [anon_sym___constant__] = ACTIONS(4996),
    [anon_sym___managed__] = ACTIONS(4996),
    [anon_sym___grid_constant__] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(5010),
    [anon_sym__Alignas] = ACTIONS(5010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(5521),
    [sym_virtual] = ACTIONS(5525),
    [anon_sym_template] = ACTIONS(5521),
    [anon_sym_GT2] = ACTIONS(5523),
    [anon_sym_operator] = ACTIONS(5521),
    [anon_sym___launch_bounds__] = ACTIONS(5012),
  },
  [2152] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2152),
    [sym_identifier] = ACTIONS(5016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5018),
    [anon_sym_COMMA] = ACTIONS(5018),
    [anon_sym_RPAREN] = ACTIONS(5018),
    [aux_sym_preproc_if_token2] = ACTIONS(5018),
    [aux_sym_preproc_else_token1] = ACTIONS(5018),
    [aux_sym_preproc_elif_token1] = ACTIONS(5016),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5018),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5018),
    [anon_sym_LPAREN2] = ACTIONS(5018),
    [anon_sym_DASH] = ACTIONS(5016),
    [anon_sym_PLUS] = ACTIONS(5016),
    [anon_sym_STAR] = ACTIONS(5016),
    [anon_sym_SLASH] = ACTIONS(5016),
    [anon_sym_PERCENT] = ACTIONS(5016),
    [anon_sym_PIPE_PIPE] = ACTIONS(5018),
    [anon_sym_AMP_AMP] = ACTIONS(5018),
    [anon_sym_PIPE] = ACTIONS(5016),
    [anon_sym_CARET] = ACTIONS(5016),
    [anon_sym_AMP] = ACTIONS(5016),
    [anon_sym_EQ_EQ] = ACTIONS(5018),
    [anon_sym_BANG_EQ] = ACTIONS(5018),
    [anon_sym_GT] = ACTIONS(5016),
    [anon_sym_GT_EQ] = ACTIONS(5018),
    [anon_sym_LT_EQ] = ACTIONS(5016),
    [anon_sym_LT] = ACTIONS(5016),
    [anon_sym_LT_LT] = ACTIONS(5016),
    [anon_sym_GT_GT] = ACTIONS(5016),
    [anon_sym_SEMI] = ACTIONS(5018),
    [anon_sym___attribute__] = ACTIONS(5016),
    [anon_sym_LBRACE] = ACTIONS(5018),
    [anon_sym_RBRACE] = ACTIONS(5018),
    [anon_sym_signed] = ACTIONS(5527),
    [anon_sym_unsigned] = ACTIONS(5527),
    [anon_sym_long] = ACTIONS(5527),
    [anon_sym_short] = ACTIONS(5527),
    [anon_sym_LBRACK] = ACTIONS(5018),
    [anon_sym_RBRACK] = ACTIONS(5018),
    [anon_sym_EQ] = ACTIONS(5016),
    [sym_primitive_type] = ACTIONS(5016),
    [anon_sym_COLON] = ACTIONS(5018),
    [anon_sym_QMARK] = ACTIONS(5018),
    [anon_sym_STAR_EQ] = ACTIONS(5018),
    [anon_sym_SLASH_EQ] = ACTIONS(5018),
    [anon_sym_PERCENT_EQ] = ACTIONS(5018),
    [anon_sym_PLUS_EQ] = ACTIONS(5018),
    [anon_sym_DASH_EQ] = ACTIONS(5018),
    [anon_sym_LT_LT_EQ] = ACTIONS(5018),
    [anon_sym_GT_GT_EQ] = ACTIONS(5018),
    [anon_sym_AMP_EQ] = ACTIONS(5018),
    [anon_sym_CARET_EQ] = ACTIONS(5018),
    [anon_sym_PIPE_EQ] = ACTIONS(5018),
    [anon_sym_and_eq] = ACTIONS(5016),
    [anon_sym_or_eq] = ACTIONS(5016),
    [anon_sym_xor_eq] = ACTIONS(5016),
    [anon_sym_LT_EQ_GT] = ACTIONS(5018),
    [anon_sym_or] = ACTIONS(5016),
    [anon_sym_and] = ACTIONS(5016),
    [anon_sym_bitor] = ACTIONS(5016),
    [anon_sym_xor] = ACTIONS(5016),
    [anon_sym_bitand] = ACTIONS(5016),
    [anon_sym_not_eq] = ACTIONS(5016),
    [anon_sym_DASH_DASH] = ACTIONS(5018),
    [anon_sym_PLUS_PLUS] = ACTIONS(5018),
    [anon_sym_DOT] = ACTIONS(5016),
    [anon_sym_DOT_STAR] = ACTIONS(5018),
    [anon_sym_DASH_GT] = ACTIONS(5018),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5016),
    [anon_sym_decltype] = ACTIONS(5016),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5018),
  },
  [2153] = {
    [sym_template_argument_list] = STATE(1651),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(5530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5532),
    [anon_sym_COMMA] = ACTIONS(5532),
    [anon_sym_RPAREN] = ACTIONS(5532),
    [anon_sym_LPAREN2] = ACTIONS(5532),
    [anon_sym_TILDE] = ACTIONS(5532),
    [anon_sym_STAR] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5530),
    [anon_sym_LT] = ACTIONS(5534),
    [anon_sym_SEMI] = ACTIONS(5532),
    [anon_sym___extension__] = ACTIONS(5530),
    [anon_sym___device__] = ACTIONS(5530),
    [anon_sym___host__] = ACTIONS(5530),
    [anon_sym___global__] = ACTIONS(5530),
    [anon_sym___forceinline__] = ACTIONS(5530),
    [anon_sym___noinline__] = ACTIONS(5530),
    [anon_sym_extern] = ACTIONS(5530),
    [anon_sym___attribute__] = ACTIONS(5530),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5532),
    [anon_sym___declspec] = ACTIONS(5530),
    [anon_sym___based] = ACTIONS(5530),
    [anon_sym___cdecl] = ACTIONS(5530),
    [anon_sym___clrcall] = ACTIONS(5530),
    [anon_sym___stdcall] = ACTIONS(5530),
    [anon_sym___fastcall] = ACTIONS(5530),
    [anon_sym___thiscall] = ACTIONS(5530),
    [anon_sym___vectorcall] = ACTIONS(5530),
    [anon_sym_LBRACE] = ACTIONS(5532),
    [anon_sym_signed] = ACTIONS(3784),
    [anon_sym_unsigned] = ACTIONS(3784),
    [anon_sym_long] = ACTIONS(3784),
    [anon_sym_short] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(5530),
    [anon_sym_static] = ACTIONS(5530),
    [anon_sym_EQ] = ACTIONS(5532),
    [anon_sym_register] = ACTIONS(5530),
    [anon_sym_inline] = ACTIONS(5530),
    [anon_sym___inline] = ACTIONS(5530),
    [anon_sym___inline__] = ACTIONS(5530),
    [anon_sym___forceinline] = ACTIONS(5530),
    [anon_sym_thread_local] = ACTIONS(5530),
    [anon_sym___thread] = ACTIONS(5530),
    [anon_sym_const] = ACTIONS(5530),
    [anon_sym_constexpr] = ACTIONS(5530),
    [anon_sym_volatile] = ACTIONS(5530),
    [anon_sym_restrict] = ACTIONS(5530),
    [anon_sym___restrict__] = ACTIONS(5530),
    [anon_sym__Atomic] = ACTIONS(5530),
    [anon_sym__Noreturn] = ACTIONS(5530),
    [anon_sym_noreturn] = ACTIONS(5530),
    [anon_sym_mutable] = ACTIONS(5530),
    [anon_sym_constinit] = ACTIONS(5530),
    [anon_sym_consteval] = ACTIONS(5530),
    [anon_sym___shared__] = ACTIONS(5530),
    [anon_sym___local__] = ACTIONS(5530),
    [anon_sym___constant__] = ACTIONS(5530),
    [anon_sym___managed__] = ACTIONS(5530),
    [anon_sym___grid_constant__] = ACTIONS(5530),
    [anon_sym_alignas] = ACTIONS(5530),
    [anon_sym__Alignas] = ACTIONS(5530),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5530),
    [anon_sym_decltype] = ACTIONS(5530),
    [sym_virtual] = ACTIONS(5530),
    [anon_sym_template] = ACTIONS(5530),
    [anon_sym_GT2] = ACTIONS(5532),
    [anon_sym_operator] = ACTIONS(5530),
    [anon_sym___launch_bounds__] = ACTIONS(5530),
  },
  [2154] = {
    [sym_identifier] = ACTIONS(5192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5194),
    [anon_sym_COMMA] = ACTIONS(5194),
    [anon_sym_RPAREN] = ACTIONS(5194),
    [anon_sym_LPAREN2] = ACTIONS(5194),
    [anon_sym_TILDE] = ACTIONS(5194),
    [anon_sym_STAR] = ACTIONS(5194),
    [anon_sym_AMP_AMP] = ACTIONS(5194),
    [anon_sym_AMP] = ACTIONS(5192),
    [anon_sym_SEMI] = ACTIONS(5194),
    [anon_sym___extension__] = ACTIONS(5192),
    [anon_sym___device__] = ACTIONS(5192),
    [anon_sym___host__] = ACTIONS(5192),
    [anon_sym___global__] = ACTIONS(5192),
    [anon_sym___forceinline__] = ACTIONS(5192),
    [anon_sym___noinline__] = ACTIONS(5192),
    [anon_sym_extern] = ACTIONS(5192),
    [anon_sym___attribute__] = ACTIONS(5192),
    [anon_sym_COLON_COLON] = ACTIONS(5183),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5194),
    [anon_sym___declspec] = ACTIONS(5192),
    [anon_sym___based] = ACTIONS(5192),
    [anon_sym___cdecl] = ACTIONS(5192),
    [anon_sym___clrcall] = ACTIONS(5192),
    [anon_sym___stdcall] = ACTIONS(5192),
    [anon_sym___fastcall] = ACTIONS(5192),
    [anon_sym___thiscall] = ACTIONS(5192),
    [anon_sym___vectorcall] = ACTIONS(5192),
    [anon_sym_LBRACE] = ACTIONS(5194),
    [anon_sym_LBRACK] = ACTIONS(5192),
    [anon_sym_static] = ACTIONS(5192),
    [anon_sym_EQ] = ACTIONS(5194),
    [anon_sym_register] = ACTIONS(5192),
    [anon_sym_inline] = ACTIONS(5192),
    [anon_sym___inline] = ACTIONS(5192),
    [anon_sym___inline__] = ACTIONS(5192),
    [anon_sym___forceinline] = ACTIONS(5192),
    [anon_sym_thread_local] = ACTIONS(5192),
    [anon_sym___thread] = ACTIONS(5192),
    [anon_sym_const] = ACTIONS(5192),
    [anon_sym_constexpr] = ACTIONS(5192),
    [anon_sym_volatile] = ACTIONS(5192),
    [anon_sym_restrict] = ACTIONS(5192),
    [anon_sym___restrict__] = ACTIONS(5192),
    [anon_sym__Atomic] = ACTIONS(5192),
    [anon_sym__Noreturn] = ACTIONS(5192),
    [anon_sym_noreturn] = ACTIONS(5192),
    [anon_sym_mutable] = ACTIONS(5192),
    [anon_sym_constinit] = ACTIONS(5192),
    [anon_sym_consteval] = ACTIONS(5192),
    [anon_sym___shared__] = ACTIONS(5192),
    [anon_sym___local__] = ACTIONS(5192),
    [anon_sym___constant__] = ACTIONS(5192),
    [anon_sym___managed__] = ACTIONS(5192),
    [anon_sym___grid_constant__] = ACTIONS(5192),
    [anon_sym_alignas] = ACTIONS(5192),
    [anon_sym__Alignas] = ACTIONS(5192),
    [anon_sym_COLON] = ACTIONS(5192),
    [anon_sym_asm] = ACTIONS(5192),
    [anon_sym___asm__] = ACTIONS(5192),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5192),
    [anon_sym_decltype] = ACTIONS(5192),
    [anon_sym_final] = ACTIONS(5192),
    [anon_sym_override] = ACTIONS(5192),
    [sym_virtual] = ACTIONS(5192),
    [anon_sym_template] = ACTIONS(5192),
    [anon_sym_GT2] = ACTIONS(5194),
    [anon_sym_operator] = ACTIONS(5192),
    [anon_sym_try] = ACTIONS(5192),
    [anon_sym_requires] = ACTIONS(5192),
    [anon_sym___launch_bounds__] = ACTIONS(5192),
  },
  [2155] = {
    [sym_identifier] = ACTIONS(5203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5205),
    [anon_sym_COMMA] = ACTIONS(5205),
    [anon_sym_RPAREN] = ACTIONS(5205),
    [anon_sym_LPAREN2] = ACTIONS(5205),
    [anon_sym_TILDE] = ACTIONS(5205),
    [anon_sym_STAR] = ACTIONS(5205),
    [anon_sym_AMP_AMP] = ACTIONS(5205),
    [anon_sym_AMP] = ACTIONS(5203),
    [anon_sym_SEMI] = ACTIONS(5205),
    [anon_sym___extension__] = ACTIONS(5203),
    [anon_sym___device__] = ACTIONS(5203),
    [anon_sym___host__] = ACTIONS(5203),
    [anon_sym___global__] = ACTIONS(5203),
    [anon_sym___forceinline__] = ACTIONS(5203),
    [anon_sym___noinline__] = ACTIONS(5203),
    [anon_sym_extern] = ACTIONS(5203),
    [anon_sym___attribute__] = ACTIONS(5203),
    [anon_sym_COLON_COLON] = ACTIONS(5205),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5205),
    [anon_sym___declspec] = ACTIONS(5203),
    [anon_sym___based] = ACTIONS(5203),
    [anon_sym___cdecl] = ACTIONS(5203),
    [anon_sym___clrcall] = ACTIONS(5203),
    [anon_sym___stdcall] = ACTIONS(5203),
    [anon_sym___fastcall] = ACTIONS(5203),
    [anon_sym___thiscall] = ACTIONS(5203),
    [anon_sym___vectorcall] = ACTIONS(5203),
    [anon_sym_LBRACE] = ACTIONS(5205),
    [anon_sym_LBRACK] = ACTIONS(5203),
    [anon_sym_static] = ACTIONS(5203),
    [anon_sym_EQ] = ACTIONS(5205),
    [anon_sym_register] = ACTIONS(5203),
    [anon_sym_inline] = ACTIONS(5203),
    [anon_sym___inline] = ACTIONS(5203),
    [anon_sym___inline__] = ACTIONS(5203),
    [anon_sym___forceinline] = ACTIONS(5203),
    [anon_sym_thread_local] = ACTIONS(5203),
    [anon_sym___thread] = ACTIONS(5203),
    [anon_sym_const] = ACTIONS(5203),
    [anon_sym_constexpr] = ACTIONS(5203),
    [anon_sym_volatile] = ACTIONS(5203),
    [anon_sym_restrict] = ACTIONS(5203),
    [anon_sym___restrict__] = ACTIONS(5203),
    [anon_sym__Atomic] = ACTIONS(5203),
    [anon_sym__Noreturn] = ACTIONS(5203),
    [anon_sym_noreturn] = ACTIONS(5203),
    [anon_sym_mutable] = ACTIONS(5203),
    [anon_sym_constinit] = ACTIONS(5203),
    [anon_sym_consteval] = ACTIONS(5203),
    [anon_sym___shared__] = ACTIONS(5203),
    [anon_sym___local__] = ACTIONS(5203),
    [anon_sym___constant__] = ACTIONS(5203),
    [anon_sym___managed__] = ACTIONS(5203),
    [anon_sym___grid_constant__] = ACTIONS(5203),
    [anon_sym_alignas] = ACTIONS(5203),
    [anon_sym__Alignas] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5203),
    [anon_sym_asm] = ACTIONS(5203),
    [anon_sym___asm__] = ACTIONS(5203),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5203),
    [anon_sym_decltype] = ACTIONS(5203),
    [anon_sym_final] = ACTIONS(5203),
    [anon_sym_override] = ACTIONS(5203),
    [sym_virtual] = ACTIONS(5203),
    [anon_sym_template] = ACTIONS(5203),
    [anon_sym_GT2] = ACTIONS(5205),
    [anon_sym_operator] = ACTIONS(5203),
    [anon_sym_try] = ACTIONS(5203),
    [anon_sym_requires] = ACTIONS(5203),
    [anon_sym___launch_bounds__] = ACTIONS(5203),
  },
  [2156] = {
    [sym__declaration_modifiers] = STATE(2159),
    [sym_attribute_specifier] = STATE(2159),
    [sym_attribute_declaration] = STATE(2159),
    [sym_ms_declspec_modifier] = STATE(2159),
    [sym_storage_class_specifier] = STATE(2159),
    [sym_type_qualifier] = STATE(2159),
    [sym_alignas_qualifier] = STATE(2611),
    [sym_launch_bounds] = STATE(2159),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(5536),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5538),
    [anon_sym_COMMA] = ACTIONS(5538),
    [anon_sym_RPAREN] = ACTIONS(5538),
    [anon_sym_LPAREN2] = ACTIONS(5538),
    [anon_sym_TILDE] = ACTIONS(5538),
    [anon_sym_STAR] = ACTIONS(5538),
    [anon_sym_AMP_AMP] = ACTIONS(5538),
    [anon_sym_AMP] = ACTIONS(5536),
    [anon_sym_SEMI] = ACTIONS(5538),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym___device__] = ACTIONS(5525),
    [anon_sym___host__] = ACTIONS(5525),
    [anon_sym___global__] = ACTIONS(5525),
    [anon_sym___forceinline__] = ACTIONS(5525),
    [anon_sym___noinline__] = ACTIONS(5525),
    [anon_sym_extern] = ACTIONS(5000),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5538),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5006),
    [anon_sym___declspec] = ACTIONS(5008),
    [anon_sym___based] = ACTIONS(5536),
    [anon_sym___cdecl] = ACTIONS(5536),
    [anon_sym___clrcall] = ACTIONS(5536),
    [anon_sym___stdcall] = ACTIONS(5536),
    [anon_sym___fastcall] = ACTIONS(5536),
    [anon_sym___thiscall] = ACTIONS(5536),
    [anon_sym___vectorcall] = ACTIONS(5536),
    [anon_sym_LBRACK] = ACTIONS(5536),
    [anon_sym_static] = ACTIONS(5000),
    [anon_sym_EQ] = ACTIONS(5538),
    [anon_sym_register] = ACTIONS(5000),
    [anon_sym_inline] = ACTIONS(5000),
    [anon_sym___inline] = ACTIONS(5000),
    [anon_sym___inline__] = ACTIONS(5000),
    [anon_sym___forceinline] = ACTIONS(5000),
    [anon_sym_thread_local] = ACTIONS(5000),
    [anon_sym___thread] = ACTIONS(5000),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym___shared__] = ACTIONS(4996),
    [anon_sym___local__] = ACTIONS(4996),
    [anon_sym___constant__] = ACTIONS(4996),
    [anon_sym___managed__] = ACTIONS(4996),
    [anon_sym___grid_constant__] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(5010),
    [anon_sym__Alignas] = ACTIONS(5010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(5536),
    [sym_virtual] = ACTIONS(5525),
    [anon_sym_template] = ACTIONS(5536),
    [anon_sym_GT2] = ACTIONS(5538),
    [anon_sym_operator] = ACTIONS(5536),
    [anon_sym___launch_bounds__] = ACTIONS(5012),
  },
  [2157] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2150),
    [sym_identifier] = ACTIONS(5540),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5325),
    [anon_sym_COMMA] = ACTIONS(5325),
    [anon_sym_LPAREN2] = ACTIONS(5325),
    [anon_sym_DASH] = ACTIONS(5327),
    [anon_sym_PLUS] = ACTIONS(5327),
    [anon_sym_STAR] = ACTIONS(5325),
    [anon_sym_SLASH] = ACTIONS(5327),
    [anon_sym_PERCENT] = ACTIONS(5325),
    [anon_sym_PIPE_PIPE] = ACTIONS(5325),
    [anon_sym_AMP_AMP] = ACTIONS(5325),
    [anon_sym_PIPE] = ACTIONS(5327),
    [anon_sym_CARET] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5327),
    [anon_sym_EQ_EQ] = ACTIONS(5325),
    [anon_sym_BANG_EQ] = ACTIONS(5325),
    [anon_sym_GT] = ACTIONS(5327),
    [anon_sym_GT_EQ] = ACTIONS(5327),
    [anon_sym_LT_EQ] = ACTIONS(5327),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_LT_LT] = ACTIONS(5327),
    [anon_sym_GT_GT] = ACTIONS(5327),
    [anon_sym___extension__] = ACTIONS(5327),
    [anon_sym___global__] = ACTIONS(5327),
    [anon_sym___attribute__] = ACTIONS(5327),
    [anon_sym_LBRACE] = ACTIONS(5325),
    [anon_sym_signed] = ACTIONS(5542),
    [anon_sym_unsigned] = ACTIONS(5542),
    [anon_sym_long] = ACTIONS(5542),
    [anon_sym_short] = ACTIONS(5542),
    [anon_sym_LBRACK] = ACTIONS(5325),
    [anon_sym_const] = ACTIONS(5327),
    [anon_sym_constexpr] = ACTIONS(5327),
    [anon_sym_volatile] = ACTIONS(5327),
    [anon_sym_restrict] = ACTIONS(5327),
    [anon_sym___restrict__] = ACTIONS(5327),
    [anon_sym__Atomic] = ACTIONS(5327),
    [anon_sym__Noreturn] = ACTIONS(5327),
    [anon_sym_noreturn] = ACTIONS(5327),
    [anon_sym_mutable] = ACTIONS(5327),
    [anon_sym_constinit] = ACTIONS(5327),
    [anon_sym_consteval] = ACTIONS(5327),
    [anon_sym___shared__] = ACTIONS(5327),
    [anon_sym___local__] = ACTIONS(5327),
    [anon_sym___constant__] = ACTIONS(5327),
    [anon_sym___managed__] = ACTIONS(5327),
    [anon_sym___grid_constant__] = ACTIONS(5327),
    [anon_sym_alignas] = ACTIONS(5327),
    [anon_sym__Alignas] = ACTIONS(5327),
    [sym_primitive_type] = ACTIONS(5544),
    [anon_sym_QMARK] = ACTIONS(5325),
    [anon_sym_LT_EQ_GT] = ACTIONS(5325),
    [anon_sym_or] = ACTIONS(5327),
    [anon_sym_and] = ACTIONS(5327),
    [anon_sym_bitor] = ACTIONS(5327),
    [anon_sym_xor] = ACTIONS(5327),
    [anon_sym_bitand] = ACTIONS(5327),
    [anon_sym_not_eq] = ACTIONS(5327),
    [anon_sym_DASH_DASH] = ACTIONS(5325),
    [anon_sym_PLUS_PLUS] = ACTIONS(5325),
    [anon_sym_DOT] = ACTIONS(5327),
    [anon_sym_DOT_STAR] = ACTIONS(5325),
    [anon_sym_DASH_GT] = ACTIONS(5325),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5327),
    [anon_sym_decltype] = ACTIONS(5327),
    [anon_sym_final] = ACTIONS(5327),
    [anon_sym_override] = ACTIONS(5327),
    [anon_sym_GT2] = ACTIONS(5325),
    [anon_sym_requires] = ACTIONS(5327),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5325),
  },
  [2158] = {
    [sym_attribute_specifier] = STATE(2404),
    [sym_field_declaration_list] = STATE(2362),
    [sym_virtual_specifier] = STATE(7148),
    [sym_base_class_clause] = STATE(7904),
    [sym_identifier] = ACTIONS(5508),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5506),
    [anon_sym_COMMA] = ACTIONS(5506),
    [anon_sym_RPAREN] = ACTIONS(5506),
    [aux_sym_preproc_if_token2] = ACTIONS(5506),
    [aux_sym_preproc_else_token1] = ACTIONS(5506),
    [aux_sym_preproc_elif_token1] = ACTIONS(5508),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5506),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5506),
    [anon_sym_LPAREN2] = ACTIONS(5506),
    [anon_sym_DASH] = ACTIONS(5508),
    [anon_sym_PLUS] = ACTIONS(5508),
    [anon_sym_STAR] = ACTIONS(5508),
    [anon_sym_SLASH] = ACTIONS(5508),
    [anon_sym_PERCENT] = ACTIONS(5508),
    [anon_sym_PIPE_PIPE] = ACTIONS(5506),
    [anon_sym_AMP_AMP] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(5508),
    [anon_sym_CARET] = ACTIONS(5508),
    [anon_sym_AMP] = ACTIONS(5508),
    [anon_sym_EQ_EQ] = ACTIONS(5506),
    [anon_sym_BANG_EQ] = ACTIONS(5506),
    [anon_sym_GT] = ACTIONS(5508),
    [anon_sym_GT_EQ] = ACTIONS(5506),
    [anon_sym_LT_EQ] = ACTIONS(5508),
    [anon_sym_LT] = ACTIONS(5508),
    [anon_sym_LT_LT] = ACTIONS(5508),
    [anon_sym_GT_GT] = ACTIONS(5508),
    [anon_sym_SEMI] = ACTIONS(5506),
    [anon_sym___attribute__] = ACTIONS(5546),
    [anon_sym_LBRACE] = ACTIONS(5548),
    [anon_sym_RBRACE] = ACTIONS(5506),
    [anon_sym_LBRACK] = ACTIONS(5506),
    [anon_sym_RBRACK] = ACTIONS(5506),
    [anon_sym_EQ] = ACTIONS(5508),
    [anon_sym_COLON] = ACTIONS(5514),
    [anon_sym_QMARK] = ACTIONS(5506),
    [anon_sym_STAR_EQ] = ACTIONS(5506),
    [anon_sym_SLASH_EQ] = ACTIONS(5506),
    [anon_sym_PERCENT_EQ] = ACTIONS(5506),
    [anon_sym_PLUS_EQ] = ACTIONS(5506),
    [anon_sym_DASH_EQ] = ACTIONS(5506),
    [anon_sym_LT_LT_EQ] = ACTIONS(5506),
    [anon_sym_GT_GT_EQ] = ACTIONS(5506),
    [anon_sym_AMP_EQ] = ACTIONS(5506),
    [anon_sym_CARET_EQ] = ACTIONS(5506),
    [anon_sym_PIPE_EQ] = ACTIONS(5506),
    [anon_sym_and_eq] = ACTIONS(5508),
    [anon_sym_or_eq] = ACTIONS(5508),
    [anon_sym_xor_eq] = ACTIONS(5508),
    [anon_sym_LT_EQ_GT] = ACTIONS(5506),
    [anon_sym_or] = ACTIONS(5508),
    [anon_sym_and] = ACTIONS(5508),
    [anon_sym_bitor] = ACTIONS(5508),
    [anon_sym_xor] = ACTIONS(5508),
    [anon_sym_bitand] = ACTIONS(5508),
    [anon_sym_not_eq] = ACTIONS(5508),
    [anon_sym_DASH_DASH] = ACTIONS(5506),
    [anon_sym_PLUS_PLUS] = ACTIONS(5506),
    [anon_sym_DOT] = ACTIONS(5508),
    [anon_sym_DOT_STAR] = ACTIONS(5506),
    [anon_sym_DASH_GT] = ACTIONS(5506),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5508),
    [anon_sym_decltype] = ACTIONS(5508),
    [anon_sym_final] = ACTIONS(5550),
    [anon_sym_override] = ACTIONS(5550),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5506),
  },
  [2159] = {
    [sym__declaration_modifiers] = STATE(2159),
    [sym_attribute_specifier] = STATE(2159),
    [sym_attribute_declaration] = STATE(2159),
    [sym_ms_declspec_modifier] = STATE(2159),
    [sym_storage_class_specifier] = STATE(2159),
    [sym_type_qualifier] = STATE(2159),
    [sym_alignas_qualifier] = STATE(2611),
    [sym_launch_bounds] = STATE(2159),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2159),
    [sym_identifier] = ACTIONS(5552),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5554),
    [anon_sym_COMMA] = ACTIONS(5554),
    [anon_sym_RPAREN] = ACTIONS(5554),
    [anon_sym_LPAREN2] = ACTIONS(5554),
    [anon_sym_TILDE] = ACTIONS(5554),
    [anon_sym_STAR] = ACTIONS(5554),
    [anon_sym_AMP_AMP] = ACTIONS(5554),
    [anon_sym_AMP] = ACTIONS(5552),
    [anon_sym_SEMI] = ACTIONS(5554),
    [anon_sym___extension__] = ACTIONS(5556),
    [anon_sym___device__] = ACTIONS(5559),
    [anon_sym___host__] = ACTIONS(5559),
    [anon_sym___global__] = ACTIONS(5559),
    [anon_sym___forceinline__] = ACTIONS(5559),
    [anon_sym___noinline__] = ACTIONS(5559),
    [anon_sym_extern] = ACTIONS(5562),
    [anon_sym___attribute__] = ACTIONS(5565),
    [anon_sym_COLON_COLON] = ACTIONS(5554),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5568),
    [anon_sym___declspec] = ACTIONS(5571),
    [anon_sym___based] = ACTIONS(5552),
    [anon_sym___cdecl] = ACTIONS(5552),
    [anon_sym___clrcall] = ACTIONS(5552),
    [anon_sym___stdcall] = ACTIONS(5552),
    [anon_sym___fastcall] = ACTIONS(5552),
    [anon_sym___thiscall] = ACTIONS(5552),
    [anon_sym___vectorcall] = ACTIONS(5552),
    [anon_sym_LBRACK] = ACTIONS(5552),
    [anon_sym_static] = ACTIONS(5562),
    [anon_sym_EQ] = ACTIONS(5554),
    [anon_sym_register] = ACTIONS(5562),
    [anon_sym_inline] = ACTIONS(5562),
    [anon_sym___inline] = ACTIONS(5562),
    [anon_sym___inline__] = ACTIONS(5562),
    [anon_sym___forceinline] = ACTIONS(5562),
    [anon_sym_thread_local] = ACTIONS(5562),
    [anon_sym___thread] = ACTIONS(5562),
    [anon_sym_const] = ACTIONS(5556),
    [anon_sym_constexpr] = ACTIONS(5556),
    [anon_sym_volatile] = ACTIONS(5556),
    [anon_sym_restrict] = ACTIONS(5556),
    [anon_sym___restrict__] = ACTIONS(5556),
    [anon_sym__Atomic] = ACTIONS(5556),
    [anon_sym__Noreturn] = ACTIONS(5556),
    [anon_sym_noreturn] = ACTIONS(5556),
    [anon_sym_mutable] = ACTIONS(5556),
    [anon_sym_constinit] = ACTIONS(5556),
    [anon_sym_consteval] = ACTIONS(5556),
    [anon_sym___shared__] = ACTIONS(5556),
    [anon_sym___local__] = ACTIONS(5556),
    [anon_sym___constant__] = ACTIONS(5556),
    [anon_sym___managed__] = ACTIONS(5556),
    [anon_sym___grid_constant__] = ACTIONS(5556),
    [anon_sym_alignas] = ACTIONS(5574),
    [anon_sym__Alignas] = ACTIONS(5574),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(5552),
    [sym_virtual] = ACTIONS(5559),
    [anon_sym_template] = ACTIONS(5552),
    [anon_sym_GT2] = ACTIONS(5554),
    [anon_sym_operator] = ACTIONS(5552),
    [anon_sym___launch_bounds__] = ACTIONS(5577),
  },
  [2160] = {
    [sym_decltype_auto] = STATE(2182),
    [sym_identifier] = ACTIONS(5171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5173),
    [anon_sym_COMMA] = ACTIONS(5173),
    [anon_sym_RPAREN] = ACTIONS(5173),
    [anon_sym_LPAREN2] = ACTIONS(5173),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_STAR] = ACTIONS(5173),
    [anon_sym_AMP_AMP] = ACTIONS(5173),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_SEMI] = ACTIONS(5173),
    [anon_sym___extension__] = ACTIONS(5171),
    [anon_sym___device__] = ACTIONS(5171),
    [anon_sym___host__] = ACTIONS(5171),
    [anon_sym___global__] = ACTIONS(5171),
    [anon_sym___forceinline__] = ACTIONS(5171),
    [anon_sym___noinline__] = ACTIONS(5171),
    [anon_sym_extern] = ACTIONS(5171),
    [anon_sym___attribute__] = ACTIONS(5171),
    [anon_sym_COLON_COLON] = ACTIONS(5173),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5173),
    [anon_sym___declspec] = ACTIONS(5171),
    [anon_sym___based] = ACTIONS(5171),
    [anon_sym___cdecl] = ACTIONS(5171),
    [anon_sym___clrcall] = ACTIONS(5171),
    [anon_sym___stdcall] = ACTIONS(5171),
    [anon_sym___fastcall] = ACTIONS(5171),
    [anon_sym___thiscall] = ACTIONS(5171),
    [anon_sym___vectorcall] = ACTIONS(5171),
    [anon_sym_LBRACE] = ACTIONS(5173),
    [anon_sym_LBRACK] = ACTIONS(5171),
    [anon_sym_static] = ACTIONS(5171),
    [anon_sym_EQ] = ACTIONS(5173),
    [anon_sym_register] = ACTIONS(5171),
    [anon_sym_inline] = ACTIONS(5171),
    [anon_sym___inline] = ACTIONS(5171),
    [anon_sym___inline__] = ACTIONS(5171),
    [anon_sym___forceinline] = ACTIONS(5171),
    [anon_sym_thread_local] = ACTIONS(5171),
    [anon_sym___thread] = ACTIONS(5171),
    [anon_sym_const] = ACTIONS(5171),
    [anon_sym_constexpr] = ACTIONS(5171),
    [anon_sym_volatile] = ACTIONS(5171),
    [anon_sym_restrict] = ACTIONS(5171),
    [anon_sym___restrict__] = ACTIONS(5171),
    [anon_sym__Atomic] = ACTIONS(5171),
    [anon_sym__Noreturn] = ACTIONS(5171),
    [anon_sym_noreturn] = ACTIONS(5171),
    [anon_sym_mutable] = ACTIONS(5171),
    [anon_sym_constinit] = ACTIONS(5171),
    [anon_sym_consteval] = ACTIONS(5171),
    [anon_sym___shared__] = ACTIONS(5171),
    [anon_sym___local__] = ACTIONS(5171),
    [anon_sym___constant__] = ACTIONS(5171),
    [anon_sym___managed__] = ACTIONS(5171),
    [anon_sym___grid_constant__] = ACTIONS(5171),
    [anon_sym_alignas] = ACTIONS(5171),
    [anon_sym__Alignas] = ACTIONS(5171),
    [anon_sym_asm] = ACTIONS(5171),
    [anon_sym___asm__] = ACTIONS(5171),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5412),
    [anon_sym_decltype] = ACTIONS(5414),
    [anon_sym_final] = ACTIONS(5171),
    [anon_sym_override] = ACTIONS(5171),
    [sym_virtual] = ACTIONS(5171),
    [anon_sym_template] = ACTIONS(5171),
    [anon_sym_GT2] = ACTIONS(5173),
    [anon_sym_operator] = ACTIONS(5171),
    [anon_sym_try] = ACTIONS(5171),
    [anon_sym_requires] = ACTIONS(5171),
    [anon_sym___launch_bounds__] = ACTIONS(5171),
  },
  [2161] = {
    [sym_attribute_specifier] = STATE(2203),
    [sym_field_declaration_list] = STATE(2475),
    [sym_virtual_specifier] = STATE(7228),
    [sym_base_class_clause] = STATE(8034),
    [sym_identifier] = ACTIONS(5508),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5506),
    [anon_sym_COMMA] = ACTIONS(5506),
    [anon_sym_RPAREN] = ACTIONS(5506),
    [anon_sym_LPAREN2] = ACTIONS(5506),
    [anon_sym_TILDE] = ACTIONS(5506),
    [anon_sym_STAR] = ACTIONS(5506),
    [anon_sym_AMP_AMP] = ACTIONS(5506),
    [anon_sym_AMP] = ACTIONS(5508),
    [anon_sym_SEMI] = ACTIONS(5506),
    [anon_sym___extension__] = ACTIONS(5508),
    [anon_sym___device__] = ACTIONS(5508),
    [anon_sym___host__] = ACTIONS(5508),
    [anon_sym___global__] = ACTIONS(5508),
    [anon_sym___forceinline__] = ACTIONS(5508),
    [anon_sym___noinline__] = ACTIONS(5508),
    [anon_sym_extern] = ACTIONS(5508),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5506),
    [anon_sym___declspec] = ACTIONS(5508),
    [anon_sym___based] = ACTIONS(5508),
    [anon_sym___cdecl] = ACTIONS(5508),
    [anon_sym___clrcall] = ACTIONS(5508),
    [anon_sym___stdcall] = ACTIONS(5508),
    [anon_sym___fastcall] = ACTIONS(5508),
    [anon_sym___thiscall] = ACTIONS(5508),
    [anon_sym___vectorcall] = ACTIONS(5508),
    [anon_sym_LBRACE] = ACTIONS(5580),
    [anon_sym_LBRACK] = ACTIONS(5508),
    [anon_sym_static] = ACTIONS(5508),
    [anon_sym_EQ] = ACTIONS(5506),
    [anon_sym_register] = ACTIONS(5508),
    [anon_sym_inline] = ACTIONS(5508),
    [anon_sym___inline] = ACTIONS(5508),
    [anon_sym___inline__] = ACTIONS(5508),
    [anon_sym___forceinline] = ACTIONS(5508),
    [anon_sym_thread_local] = ACTIONS(5508),
    [anon_sym___thread] = ACTIONS(5508),
    [anon_sym_const] = ACTIONS(5508),
    [anon_sym_constexpr] = ACTIONS(5508),
    [anon_sym_volatile] = ACTIONS(5508),
    [anon_sym_restrict] = ACTIONS(5508),
    [anon_sym___restrict__] = ACTIONS(5508),
    [anon_sym__Atomic] = ACTIONS(5508),
    [anon_sym__Noreturn] = ACTIONS(5508),
    [anon_sym_noreturn] = ACTIONS(5508),
    [anon_sym_mutable] = ACTIONS(5508),
    [anon_sym_constinit] = ACTIONS(5508),
    [anon_sym_consteval] = ACTIONS(5508),
    [anon_sym___shared__] = ACTIONS(5508),
    [anon_sym___local__] = ACTIONS(5508),
    [anon_sym___constant__] = ACTIONS(5508),
    [anon_sym___managed__] = ACTIONS(5508),
    [anon_sym___grid_constant__] = ACTIONS(5508),
    [anon_sym_alignas] = ACTIONS(5508),
    [anon_sym__Alignas] = ACTIONS(5508),
    [anon_sym_COLON] = ACTIONS(5582),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5508),
    [anon_sym_decltype] = ACTIONS(5508),
    [anon_sym_final] = ACTIONS(5550),
    [anon_sym_override] = ACTIONS(5550),
    [sym_virtual] = ACTIONS(5508),
    [anon_sym_template] = ACTIONS(5508),
    [anon_sym_GT2] = ACTIONS(5506),
    [anon_sym_operator] = ACTIONS(5508),
    [anon_sym___launch_bounds__] = ACTIONS(5508),
  },
  [2162] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2162),
    [sym_identifier] = ACTIONS(5016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5018),
    [anon_sym_COMMA] = ACTIONS(5018),
    [anon_sym_LPAREN2] = ACTIONS(5018),
    [anon_sym_DASH] = ACTIONS(5016),
    [anon_sym_PLUS] = ACTIONS(5016),
    [anon_sym_STAR] = ACTIONS(5018),
    [anon_sym_SLASH] = ACTIONS(5016),
    [anon_sym_PERCENT] = ACTIONS(5018),
    [anon_sym_PIPE_PIPE] = ACTIONS(5018),
    [anon_sym_AMP_AMP] = ACTIONS(5018),
    [anon_sym_PIPE] = ACTIONS(5016),
    [anon_sym_CARET] = ACTIONS(5018),
    [anon_sym_AMP] = ACTIONS(5016),
    [anon_sym_EQ_EQ] = ACTIONS(5018),
    [anon_sym_BANG_EQ] = ACTIONS(5018),
    [anon_sym_GT] = ACTIONS(5016),
    [anon_sym_GT_EQ] = ACTIONS(5016),
    [anon_sym_LT_EQ] = ACTIONS(5016),
    [anon_sym_LT] = ACTIONS(5016),
    [anon_sym_LT_LT] = ACTIONS(5016),
    [anon_sym_GT_GT] = ACTIONS(5016),
    [anon_sym___extension__] = ACTIONS(5016),
    [anon_sym___global__] = ACTIONS(5016),
    [anon_sym___attribute__] = ACTIONS(5016),
    [anon_sym_LBRACE] = ACTIONS(5018),
    [anon_sym_signed] = ACTIONS(5518),
    [anon_sym_unsigned] = ACTIONS(5518),
    [anon_sym_long] = ACTIONS(5518),
    [anon_sym_short] = ACTIONS(5518),
    [anon_sym_LBRACK] = ACTIONS(5018),
    [anon_sym_const] = ACTIONS(5016),
    [anon_sym_constexpr] = ACTIONS(5016),
    [anon_sym_volatile] = ACTIONS(5016),
    [anon_sym_restrict] = ACTIONS(5016),
    [anon_sym___restrict__] = ACTIONS(5016),
    [anon_sym__Atomic] = ACTIONS(5016),
    [anon_sym__Noreturn] = ACTIONS(5016),
    [anon_sym_noreturn] = ACTIONS(5016),
    [anon_sym_mutable] = ACTIONS(5016),
    [anon_sym_constinit] = ACTIONS(5016),
    [anon_sym_consteval] = ACTIONS(5016),
    [anon_sym___shared__] = ACTIONS(5016),
    [anon_sym___local__] = ACTIONS(5016),
    [anon_sym___constant__] = ACTIONS(5016),
    [anon_sym___managed__] = ACTIONS(5016),
    [anon_sym___grid_constant__] = ACTIONS(5016),
    [anon_sym_alignas] = ACTIONS(5016),
    [anon_sym__Alignas] = ACTIONS(5016),
    [sym_primitive_type] = ACTIONS(5016),
    [anon_sym_QMARK] = ACTIONS(5018),
    [anon_sym_LT_EQ_GT] = ACTIONS(5018),
    [anon_sym_or] = ACTIONS(5016),
    [anon_sym_and] = ACTIONS(5016),
    [anon_sym_bitor] = ACTIONS(5016),
    [anon_sym_xor] = ACTIONS(5016),
    [anon_sym_bitand] = ACTIONS(5016),
    [anon_sym_not_eq] = ACTIONS(5016),
    [anon_sym_DASH_DASH] = ACTIONS(5018),
    [anon_sym_PLUS_PLUS] = ACTIONS(5018),
    [anon_sym_DOT] = ACTIONS(5016),
    [anon_sym_DOT_STAR] = ACTIONS(5018),
    [anon_sym_DASH_GT] = ACTIONS(5018),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5016),
    [anon_sym_decltype] = ACTIONS(5016),
    [anon_sym_final] = ACTIONS(5016),
    [anon_sym_override] = ACTIONS(5016),
    [anon_sym_GT2] = ACTIONS(5018),
    [anon_sym_requires] = ACTIONS(5016),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5018),
  },
  [2163] = {
    [sym_string_literal] = STATE(2752),
    [sym_template_argument_list] = STATE(4108),
    [sym_raw_string_literal] = STATE(2752),
    [sym_identifier] = ACTIONS(3766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [aux_sym_preproc_if_token2] = ACTIONS(3758),
    [aux_sym_preproc_else_token1] = ACTIONS(3758),
    [aux_sym_preproc_elif_token1] = ACTIONS(3766),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3758),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(5584),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(5587),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(5589),
    [anon_sym_SLASH_EQ] = ACTIONS(5589),
    [anon_sym_PERCENT_EQ] = ACTIONS(5589),
    [anon_sym_PLUS_EQ] = ACTIONS(5589),
    [anon_sym_DASH_EQ] = ACTIONS(5589),
    [anon_sym_LT_LT_EQ] = ACTIONS(5589),
    [anon_sym_GT_GT_EQ] = ACTIONS(5589),
    [anon_sym_AMP_EQ] = ACTIONS(5589),
    [anon_sym_CARET_EQ] = ACTIONS(5589),
    [anon_sym_PIPE_EQ] = ACTIONS(5589),
    [anon_sym_and_eq] = ACTIONS(5587),
    [anon_sym_or_eq] = ACTIONS(5587),
    [anon_sym_xor_eq] = ACTIONS(5587),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3766),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3766),
    [anon_sym_not_eq] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2164] = {
    [sym_identifier] = ACTIONS(5289),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5291),
    [anon_sym_COMMA] = ACTIONS(5291),
    [anon_sym_RPAREN] = ACTIONS(5291),
    [anon_sym_LPAREN2] = ACTIONS(5291),
    [anon_sym_TILDE] = ACTIONS(5291),
    [anon_sym_STAR] = ACTIONS(5291),
    [anon_sym_AMP_AMP] = ACTIONS(5291),
    [anon_sym_AMP] = ACTIONS(5289),
    [anon_sym_SEMI] = ACTIONS(5291),
    [anon_sym___extension__] = ACTIONS(5289),
    [anon_sym___device__] = ACTIONS(5289),
    [anon_sym___host__] = ACTIONS(5289),
    [anon_sym___global__] = ACTIONS(5289),
    [anon_sym___forceinline__] = ACTIONS(5289),
    [anon_sym___noinline__] = ACTIONS(5289),
    [anon_sym_extern] = ACTIONS(5289),
    [anon_sym___attribute__] = ACTIONS(5289),
    [anon_sym_COLON_COLON] = ACTIONS(5291),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5291),
    [anon_sym___declspec] = ACTIONS(5289),
    [anon_sym___based] = ACTIONS(5289),
    [anon_sym___cdecl] = ACTIONS(5289),
    [anon_sym___clrcall] = ACTIONS(5289),
    [anon_sym___stdcall] = ACTIONS(5289),
    [anon_sym___fastcall] = ACTIONS(5289),
    [anon_sym___thiscall] = ACTIONS(5289),
    [anon_sym___vectorcall] = ACTIONS(5289),
    [anon_sym_LBRACE] = ACTIONS(5291),
    [anon_sym_LBRACK] = ACTIONS(5289),
    [anon_sym_static] = ACTIONS(5289),
    [anon_sym_EQ] = ACTIONS(5291),
    [anon_sym_register] = ACTIONS(5289),
    [anon_sym_inline] = ACTIONS(5289),
    [anon_sym___inline] = ACTIONS(5289),
    [anon_sym___inline__] = ACTIONS(5289),
    [anon_sym___forceinline] = ACTIONS(5289),
    [anon_sym_thread_local] = ACTIONS(5289),
    [anon_sym___thread] = ACTIONS(5289),
    [anon_sym_const] = ACTIONS(5289),
    [anon_sym_constexpr] = ACTIONS(5289),
    [anon_sym_volatile] = ACTIONS(5289),
    [anon_sym_restrict] = ACTIONS(5289),
    [anon_sym___restrict__] = ACTIONS(5289),
    [anon_sym__Atomic] = ACTIONS(5289),
    [anon_sym__Noreturn] = ACTIONS(5289),
    [anon_sym_noreturn] = ACTIONS(5289),
    [anon_sym_mutable] = ACTIONS(5289),
    [anon_sym_constinit] = ACTIONS(5289),
    [anon_sym_consteval] = ACTIONS(5289),
    [anon_sym___shared__] = ACTIONS(5289),
    [anon_sym___local__] = ACTIONS(5289),
    [anon_sym___constant__] = ACTIONS(5289),
    [anon_sym___managed__] = ACTIONS(5289),
    [anon_sym___grid_constant__] = ACTIONS(5289),
    [anon_sym_alignas] = ACTIONS(5289),
    [anon_sym__Alignas] = ACTIONS(5289),
    [anon_sym_asm] = ACTIONS(5289),
    [anon_sym___asm__] = ACTIONS(5289),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5289),
    [anon_sym_decltype] = ACTIONS(5289),
    [anon_sym_final] = ACTIONS(5289),
    [anon_sym_override] = ACTIONS(5289),
    [sym_virtual] = ACTIONS(5289),
    [anon_sym_template] = ACTIONS(5289),
    [anon_sym_GT2] = ACTIONS(5291),
    [anon_sym_operator] = ACTIONS(5289),
    [anon_sym_try] = ACTIONS(5289),
    [anon_sym_requires] = ACTIONS(5289),
    [anon_sym___launch_bounds__] = ACTIONS(5289),
  },
  [2165] = {
    [sym_ms_based_modifier] = STATE(8387),
    [sym_ms_unaligned_ptr_modifier] = STATE(4253),
    [sym_ms_pointer_modifier] = STATE(4023),
    [sym__declarator] = STATE(6666),
    [sym__abstract_declarator] = STATE(6951),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_abstract_parenthesized_declarator] = STATE(6430),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_abstract_pointer_declarator] = STATE(6430),
    [sym_function_declarator] = STATE(6598),
    [sym_abstract_function_declarator] = STATE(6430),
    [sym_array_declarator] = STATE(6598),
    [sym_abstract_array_declarator] = STATE(6430),
    [sym_type_qualifier] = STATE(2643),
    [sym_alignas_qualifier] = STATE(4511),
    [sym_parameter_list] = STATE(3079),
    [sym_decltype] = STATE(8628),
    [sym_reference_declarator] = STATE(6598),
    [sym_abstract_reference_declarator] = STATE(6430),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym__function_declarator_seq] = STATE(6416),
    [sym_template_type] = STATE(8628),
    [sym_template_function] = STATE(6598),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6059),
    [sym_qualified_identifier] = STATE(6598),
    [sym_operator_name] = STATE(6598),
    [aux_sym__type_definition_type_repeat1] = STATE(2643),
    [aux_sym_pointer_declarator_repeat1] = STATE(4023),
    [sym_identifier] = ACTIONS(5482),
    [anon_sym_COMMA] = ACTIONS(5504),
    [anon_sym_LPAREN2] = ACTIONS(3957),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(5591),
    [anon_sym_AMP_AMP] = ACTIONS(5593),
    [anon_sym_AMP] = ACTIONS(5595),
    [anon_sym___extension__] = ACTIONS(3171),
    [anon_sym___global__] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(5492),
    [anon_sym___based] = ACTIONS(49),
    [sym_ms_restrict_modifier] = ACTIONS(3173),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3173),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3173),
    [anon_sym__unaligned] = ACTIONS(3175),
    [anon_sym___unaligned] = ACTIONS(3175),
    [anon_sym_LBRACK] = ACTIONS(5494),
    [anon_sym_const] = ACTIONS(3171),
    [anon_sym_constexpr] = ACTIONS(3171),
    [anon_sym_volatile] = ACTIONS(3171),
    [anon_sym_restrict] = ACTIONS(3171),
    [anon_sym___restrict__] = ACTIONS(3171),
    [anon_sym__Atomic] = ACTIONS(3171),
    [anon_sym__Noreturn] = ACTIONS(3171),
    [anon_sym_noreturn] = ACTIONS(3171),
    [anon_sym_mutable] = ACTIONS(3171),
    [anon_sym_constinit] = ACTIONS(3171),
    [anon_sym_consteval] = ACTIONS(3171),
    [anon_sym___shared__] = ACTIONS(3171),
    [anon_sym___local__] = ACTIONS(3171),
    [anon_sym___constant__] = ACTIONS(3171),
    [anon_sym___managed__] = ACTIONS(3171),
    [anon_sym___grid_constant__] = ACTIONS(3171),
    [anon_sym_alignas] = ACTIONS(3177),
    [anon_sym__Alignas] = ACTIONS(3177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_GT2] = ACTIONS(5504),
    [anon_sym_operator] = ACTIONS(1883),
  },
  [2166] = {
    [sym_identifier] = ACTIONS(5246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5248),
    [anon_sym_COMMA] = ACTIONS(5248),
    [anon_sym_RPAREN] = ACTIONS(5248),
    [anon_sym_LPAREN2] = ACTIONS(5248),
    [anon_sym_TILDE] = ACTIONS(5248),
    [anon_sym_STAR] = ACTIONS(5248),
    [anon_sym_AMP_AMP] = ACTIONS(5248),
    [anon_sym_AMP] = ACTIONS(5246),
    [anon_sym_SEMI] = ACTIONS(5248),
    [anon_sym___extension__] = ACTIONS(5246),
    [anon_sym___device__] = ACTIONS(5246),
    [anon_sym___host__] = ACTIONS(5246),
    [anon_sym___global__] = ACTIONS(5246),
    [anon_sym___forceinline__] = ACTIONS(5246),
    [anon_sym___noinline__] = ACTIONS(5246),
    [anon_sym_extern] = ACTIONS(5246),
    [anon_sym___attribute__] = ACTIONS(5246),
    [anon_sym_COLON_COLON] = ACTIONS(5248),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5248),
    [anon_sym___declspec] = ACTIONS(5246),
    [anon_sym___based] = ACTIONS(5246),
    [anon_sym___cdecl] = ACTIONS(5246),
    [anon_sym___clrcall] = ACTIONS(5246),
    [anon_sym___stdcall] = ACTIONS(5246),
    [anon_sym___fastcall] = ACTIONS(5246),
    [anon_sym___thiscall] = ACTIONS(5246),
    [anon_sym___vectorcall] = ACTIONS(5246),
    [anon_sym_LBRACE] = ACTIONS(5248),
    [anon_sym_LBRACK] = ACTIONS(5246),
    [anon_sym_static] = ACTIONS(5246),
    [anon_sym_EQ] = ACTIONS(5248),
    [anon_sym_register] = ACTIONS(5246),
    [anon_sym_inline] = ACTIONS(5246),
    [anon_sym___inline] = ACTIONS(5246),
    [anon_sym___inline__] = ACTIONS(5246),
    [anon_sym___forceinline] = ACTIONS(5246),
    [anon_sym_thread_local] = ACTIONS(5246),
    [anon_sym___thread] = ACTIONS(5246),
    [anon_sym_const] = ACTIONS(5246),
    [anon_sym_constexpr] = ACTIONS(5246),
    [anon_sym_volatile] = ACTIONS(5246),
    [anon_sym_restrict] = ACTIONS(5246),
    [anon_sym___restrict__] = ACTIONS(5246),
    [anon_sym__Atomic] = ACTIONS(5246),
    [anon_sym__Noreturn] = ACTIONS(5246),
    [anon_sym_noreturn] = ACTIONS(5246),
    [anon_sym_mutable] = ACTIONS(5246),
    [anon_sym_constinit] = ACTIONS(5246),
    [anon_sym_consteval] = ACTIONS(5246),
    [anon_sym___shared__] = ACTIONS(5246),
    [anon_sym___local__] = ACTIONS(5246),
    [anon_sym___constant__] = ACTIONS(5246),
    [anon_sym___managed__] = ACTIONS(5246),
    [anon_sym___grid_constant__] = ACTIONS(5246),
    [anon_sym_alignas] = ACTIONS(5246),
    [anon_sym__Alignas] = ACTIONS(5246),
    [anon_sym_asm] = ACTIONS(5246),
    [anon_sym___asm__] = ACTIONS(5246),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5246),
    [anon_sym_decltype] = ACTIONS(5246),
    [anon_sym_final] = ACTIONS(5246),
    [anon_sym_override] = ACTIONS(5246),
    [sym_virtual] = ACTIONS(5246),
    [anon_sym_template] = ACTIONS(5246),
    [anon_sym_GT2] = ACTIONS(5248),
    [anon_sym_operator] = ACTIONS(5246),
    [anon_sym_try] = ACTIONS(5246),
    [anon_sym_requires] = ACTIONS(5246),
    [anon_sym___launch_bounds__] = ACTIONS(5246),
  },
  [2167] = {
    [sym_identifier] = ACTIONS(5358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5360),
    [anon_sym_COMMA] = ACTIONS(5360),
    [anon_sym_RPAREN] = ACTIONS(5360),
    [anon_sym_LPAREN2] = ACTIONS(5360),
    [anon_sym_TILDE] = ACTIONS(5360),
    [anon_sym_STAR] = ACTIONS(5360),
    [anon_sym_AMP_AMP] = ACTIONS(5360),
    [anon_sym_AMP] = ACTIONS(5358),
    [anon_sym_SEMI] = ACTIONS(5360),
    [anon_sym___extension__] = ACTIONS(5358),
    [anon_sym___device__] = ACTIONS(5358),
    [anon_sym___host__] = ACTIONS(5358),
    [anon_sym___global__] = ACTIONS(5358),
    [anon_sym___forceinline__] = ACTIONS(5358),
    [anon_sym___noinline__] = ACTIONS(5358),
    [anon_sym_extern] = ACTIONS(5358),
    [anon_sym___attribute__] = ACTIONS(5358),
    [anon_sym_COLON_COLON] = ACTIONS(5360),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5360),
    [anon_sym___declspec] = ACTIONS(5358),
    [anon_sym___based] = ACTIONS(5358),
    [anon_sym___cdecl] = ACTIONS(5358),
    [anon_sym___clrcall] = ACTIONS(5358),
    [anon_sym___stdcall] = ACTIONS(5358),
    [anon_sym___fastcall] = ACTIONS(5358),
    [anon_sym___thiscall] = ACTIONS(5358),
    [anon_sym___vectorcall] = ACTIONS(5358),
    [anon_sym_LBRACE] = ACTIONS(5360),
    [anon_sym_LBRACK] = ACTIONS(5358),
    [anon_sym_static] = ACTIONS(5358),
    [anon_sym_EQ] = ACTIONS(5360),
    [anon_sym_register] = ACTIONS(5358),
    [anon_sym_inline] = ACTIONS(5358),
    [anon_sym___inline] = ACTIONS(5358),
    [anon_sym___inline__] = ACTIONS(5358),
    [anon_sym___forceinline] = ACTIONS(5358),
    [anon_sym_thread_local] = ACTIONS(5358),
    [anon_sym___thread] = ACTIONS(5358),
    [anon_sym_const] = ACTIONS(5358),
    [anon_sym_constexpr] = ACTIONS(5358),
    [anon_sym_volatile] = ACTIONS(5358),
    [anon_sym_restrict] = ACTIONS(5358),
    [anon_sym___restrict__] = ACTIONS(5358),
    [anon_sym__Atomic] = ACTIONS(5358),
    [anon_sym__Noreturn] = ACTIONS(5358),
    [anon_sym_noreturn] = ACTIONS(5358),
    [anon_sym_mutable] = ACTIONS(5358),
    [anon_sym_constinit] = ACTIONS(5358),
    [anon_sym_consteval] = ACTIONS(5358),
    [anon_sym___shared__] = ACTIONS(5358),
    [anon_sym___local__] = ACTIONS(5358),
    [anon_sym___constant__] = ACTIONS(5358),
    [anon_sym___managed__] = ACTIONS(5358),
    [anon_sym___grid_constant__] = ACTIONS(5358),
    [anon_sym_alignas] = ACTIONS(5358),
    [anon_sym__Alignas] = ACTIONS(5358),
    [anon_sym_asm] = ACTIONS(5358),
    [anon_sym___asm__] = ACTIONS(5358),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5358),
    [anon_sym_decltype] = ACTIONS(5358),
    [anon_sym_final] = ACTIONS(5358),
    [anon_sym_override] = ACTIONS(5358),
    [sym_virtual] = ACTIONS(5358),
    [anon_sym_template] = ACTIONS(5358),
    [anon_sym_GT2] = ACTIONS(5360),
    [anon_sym_operator] = ACTIONS(5358),
    [anon_sym_try] = ACTIONS(5358),
    [anon_sym_requires] = ACTIONS(5358),
    [anon_sym___launch_bounds__] = ACTIONS(5358),
  },
  [2168] = {
    [sym_attribute_specifier] = STATE(1914),
    [sym_enumerator_list] = STATE(2217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5597),
    [anon_sym_COMMA] = ACTIONS(5597),
    [anon_sym_RPAREN] = ACTIONS(5597),
    [anon_sym_LPAREN2] = ACTIONS(5597),
    [anon_sym_DASH] = ACTIONS(5599),
    [anon_sym_PLUS] = ACTIONS(5599),
    [anon_sym_STAR] = ACTIONS(5597),
    [anon_sym_SLASH] = ACTIONS(5599),
    [anon_sym_PERCENT] = ACTIONS(5597),
    [anon_sym_PIPE_PIPE] = ACTIONS(5597),
    [anon_sym_AMP_AMP] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5599),
    [anon_sym_CARET] = ACTIONS(5597),
    [anon_sym_AMP] = ACTIONS(5599),
    [anon_sym_EQ_EQ] = ACTIONS(5597),
    [anon_sym_BANG_EQ] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5599),
    [anon_sym_GT_EQ] = ACTIONS(5597),
    [anon_sym_LT_EQ] = ACTIONS(5599),
    [anon_sym_LT] = ACTIONS(5599),
    [anon_sym_LT_LT] = ACTIONS(5599),
    [anon_sym_GT_GT] = ACTIONS(5597),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym___extension__] = ACTIONS(5597),
    [anon_sym___global__] = ACTIONS(5597),
    [anon_sym___attribute__] = ACTIONS(5510),
    [anon_sym_LBRACE] = ACTIONS(5601),
    [anon_sym_RBRACE] = ACTIONS(5597),
    [anon_sym_LBRACK] = ACTIONS(5597),
    [anon_sym_RBRACK] = ACTIONS(5597),
    [anon_sym_const] = ACTIONS(5599),
    [anon_sym_constexpr] = ACTIONS(5597),
    [anon_sym_volatile] = ACTIONS(5597),
    [anon_sym_restrict] = ACTIONS(5597),
    [anon_sym___restrict__] = ACTIONS(5597),
    [anon_sym__Atomic] = ACTIONS(5597),
    [anon_sym__Noreturn] = ACTIONS(5597),
    [anon_sym_noreturn] = ACTIONS(5597),
    [anon_sym_mutable] = ACTIONS(5597),
    [anon_sym_constinit] = ACTIONS(5597),
    [anon_sym_consteval] = ACTIONS(5597),
    [anon_sym___shared__] = ACTIONS(5597),
    [anon_sym___local__] = ACTIONS(5597),
    [anon_sym___constant__] = ACTIONS(5597),
    [anon_sym___managed__] = ACTIONS(5597),
    [anon_sym___grid_constant__] = ACTIONS(5597),
    [anon_sym_alignas] = ACTIONS(5597),
    [anon_sym__Alignas] = ACTIONS(5597),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_QMARK] = ACTIONS(5597),
    [anon_sym_LT_EQ_GT] = ACTIONS(5597),
    [anon_sym_or] = ACTIONS(5597),
    [anon_sym_and] = ACTIONS(5597),
    [anon_sym_bitor] = ACTIONS(5597),
    [anon_sym_xor] = ACTIONS(5597),
    [anon_sym_bitand] = ACTIONS(5597),
    [anon_sym_not_eq] = ACTIONS(5597),
    [anon_sym_DASH_DASH] = ACTIONS(5597),
    [anon_sym_PLUS_PLUS] = ACTIONS(5597),
    [anon_sym_DOT] = ACTIONS(5599),
    [anon_sym_DOT_STAR] = ACTIONS(5597),
    [anon_sym_DASH_GT] = ACTIONS(5597),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5597),
    [anon_sym_decltype] = ACTIONS(5597),
    [anon_sym_final] = ACTIONS(5597),
    [anon_sym_override] = ACTIONS(5597),
    [anon_sym_requires] = ACTIONS(5597),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5597),
  },
  [2169] = {
    [sym_identifier] = ACTIONS(5230),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5232),
    [anon_sym_COMMA] = ACTIONS(5232),
    [anon_sym_RPAREN] = ACTIONS(5232),
    [anon_sym_LPAREN2] = ACTIONS(5232),
    [anon_sym_TILDE] = ACTIONS(5232),
    [anon_sym_STAR] = ACTIONS(5232),
    [anon_sym_AMP_AMP] = ACTIONS(5232),
    [anon_sym_AMP] = ACTIONS(5230),
    [anon_sym_SEMI] = ACTIONS(5232),
    [anon_sym___extension__] = ACTIONS(5230),
    [anon_sym___device__] = ACTIONS(5230),
    [anon_sym___host__] = ACTIONS(5230),
    [anon_sym___global__] = ACTIONS(5230),
    [anon_sym___forceinline__] = ACTIONS(5230),
    [anon_sym___noinline__] = ACTIONS(5230),
    [anon_sym_extern] = ACTIONS(5230),
    [anon_sym___attribute__] = ACTIONS(5230),
    [anon_sym_COLON_COLON] = ACTIONS(5232),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5232),
    [anon_sym___declspec] = ACTIONS(5230),
    [anon_sym___based] = ACTIONS(5230),
    [anon_sym___cdecl] = ACTIONS(5230),
    [anon_sym___clrcall] = ACTIONS(5230),
    [anon_sym___stdcall] = ACTIONS(5230),
    [anon_sym___fastcall] = ACTIONS(5230),
    [anon_sym___thiscall] = ACTIONS(5230),
    [anon_sym___vectorcall] = ACTIONS(5230),
    [anon_sym_LBRACE] = ACTIONS(5232),
    [anon_sym_LBRACK] = ACTIONS(5230),
    [anon_sym_static] = ACTIONS(5230),
    [anon_sym_EQ] = ACTIONS(5232),
    [anon_sym_register] = ACTIONS(5230),
    [anon_sym_inline] = ACTIONS(5230),
    [anon_sym___inline] = ACTIONS(5230),
    [anon_sym___inline__] = ACTIONS(5230),
    [anon_sym___forceinline] = ACTIONS(5230),
    [anon_sym_thread_local] = ACTIONS(5230),
    [anon_sym___thread] = ACTIONS(5230),
    [anon_sym_const] = ACTIONS(5230),
    [anon_sym_constexpr] = ACTIONS(5230),
    [anon_sym_volatile] = ACTIONS(5230),
    [anon_sym_restrict] = ACTIONS(5230),
    [anon_sym___restrict__] = ACTIONS(5230),
    [anon_sym__Atomic] = ACTIONS(5230),
    [anon_sym__Noreturn] = ACTIONS(5230),
    [anon_sym_noreturn] = ACTIONS(5230),
    [anon_sym_mutable] = ACTIONS(5230),
    [anon_sym_constinit] = ACTIONS(5230),
    [anon_sym_consteval] = ACTIONS(5230),
    [anon_sym___shared__] = ACTIONS(5230),
    [anon_sym___local__] = ACTIONS(5230),
    [anon_sym___constant__] = ACTIONS(5230),
    [anon_sym___managed__] = ACTIONS(5230),
    [anon_sym___grid_constant__] = ACTIONS(5230),
    [anon_sym_alignas] = ACTIONS(5230),
    [anon_sym__Alignas] = ACTIONS(5230),
    [anon_sym_asm] = ACTIONS(5230),
    [anon_sym___asm__] = ACTIONS(5230),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5230),
    [anon_sym_decltype] = ACTIONS(5230),
    [anon_sym_final] = ACTIONS(5230),
    [anon_sym_override] = ACTIONS(5230),
    [sym_virtual] = ACTIONS(5230),
    [anon_sym_template] = ACTIONS(5230),
    [anon_sym_GT2] = ACTIONS(5232),
    [anon_sym_operator] = ACTIONS(5230),
    [anon_sym_try] = ACTIONS(5230),
    [anon_sym_requires] = ACTIONS(5230),
    [anon_sym___launch_bounds__] = ACTIONS(5230),
  },
  [2170] = {
    [sym_identifier] = ACTIONS(5226),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5228),
    [anon_sym_COMMA] = ACTIONS(5228),
    [anon_sym_RPAREN] = ACTIONS(5228),
    [anon_sym_LPAREN2] = ACTIONS(5228),
    [anon_sym_TILDE] = ACTIONS(5228),
    [anon_sym_STAR] = ACTIONS(5228),
    [anon_sym_AMP_AMP] = ACTIONS(5228),
    [anon_sym_AMP] = ACTIONS(5226),
    [anon_sym_SEMI] = ACTIONS(5228),
    [anon_sym___extension__] = ACTIONS(5226),
    [anon_sym___device__] = ACTIONS(5226),
    [anon_sym___host__] = ACTIONS(5226),
    [anon_sym___global__] = ACTIONS(5226),
    [anon_sym___forceinline__] = ACTIONS(5226),
    [anon_sym___noinline__] = ACTIONS(5226),
    [anon_sym_extern] = ACTIONS(5226),
    [anon_sym___attribute__] = ACTIONS(5226),
    [anon_sym_COLON_COLON] = ACTIONS(5228),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5228),
    [anon_sym___declspec] = ACTIONS(5226),
    [anon_sym___based] = ACTIONS(5226),
    [anon_sym___cdecl] = ACTIONS(5226),
    [anon_sym___clrcall] = ACTIONS(5226),
    [anon_sym___stdcall] = ACTIONS(5226),
    [anon_sym___fastcall] = ACTIONS(5226),
    [anon_sym___thiscall] = ACTIONS(5226),
    [anon_sym___vectorcall] = ACTIONS(5226),
    [anon_sym_LBRACE] = ACTIONS(5228),
    [anon_sym_LBRACK] = ACTIONS(5226),
    [anon_sym_static] = ACTIONS(5226),
    [anon_sym_EQ] = ACTIONS(5228),
    [anon_sym_register] = ACTIONS(5226),
    [anon_sym_inline] = ACTIONS(5226),
    [anon_sym___inline] = ACTIONS(5226),
    [anon_sym___inline__] = ACTIONS(5226),
    [anon_sym___forceinline] = ACTIONS(5226),
    [anon_sym_thread_local] = ACTIONS(5226),
    [anon_sym___thread] = ACTIONS(5226),
    [anon_sym_const] = ACTIONS(5226),
    [anon_sym_constexpr] = ACTIONS(5226),
    [anon_sym_volatile] = ACTIONS(5226),
    [anon_sym_restrict] = ACTIONS(5226),
    [anon_sym___restrict__] = ACTIONS(5226),
    [anon_sym__Atomic] = ACTIONS(5226),
    [anon_sym__Noreturn] = ACTIONS(5226),
    [anon_sym_noreturn] = ACTIONS(5226),
    [anon_sym_mutable] = ACTIONS(5226),
    [anon_sym_constinit] = ACTIONS(5226),
    [anon_sym_consteval] = ACTIONS(5226),
    [anon_sym___shared__] = ACTIONS(5226),
    [anon_sym___local__] = ACTIONS(5226),
    [anon_sym___constant__] = ACTIONS(5226),
    [anon_sym___managed__] = ACTIONS(5226),
    [anon_sym___grid_constant__] = ACTIONS(5226),
    [anon_sym_alignas] = ACTIONS(5226),
    [anon_sym__Alignas] = ACTIONS(5226),
    [anon_sym_asm] = ACTIONS(5226),
    [anon_sym___asm__] = ACTIONS(5226),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5226),
    [anon_sym_decltype] = ACTIONS(5226),
    [anon_sym_final] = ACTIONS(5226),
    [anon_sym_override] = ACTIONS(5226),
    [sym_virtual] = ACTIONS(5226),
    [anon_sym_template] = ACTIONS(5226),
    [anon_sym_GT2] = ACTIONS(5228),
    [anon_sym_operator] = ACTIONS(5226),
    [anon_sym_try] = ACTIONS(5226),
    [anon_sym_requires] = ACTIONS(5226),
    [anon_sym___launch_bounds__] = ACTIONS(5226),
  },
  [2171] = {
    [sym_identifier] = ACTIONS(5222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5224),
    [anon_sym_COMMA] = ACTIONS(5224),
    [anon_sym_RPAREN] = ACTIONS(5224),
    [anon_sym_LPAREN2] = ACTIONS(5224),
    [anon_sym_TILDE] = ACTIONS(5224),
    [anon_sym_STAR] = ACTIONS(5224),
    [anon_sym_AMP_AMP] = ACTIONS(5224),
    [anon_sym_AMP] = ACTIONS(5222),
    [anon_sym_SEMI] = ACTIONS(5224),
    [anon_sym___extension__] = ACTIONS(5222),
    [anon_sym___device__] = ACTIONS(5222),
    [anon_sym___host__] = ACTIONS(5222),
    [anon_sym___global__] = ACTIONS(5222),
    [anon_sym___forceinline__] = ACTIONS(5222),
    [anon_sym___noinline__] = ACTIONS(5222),
    [anon_sym_extern] = ACTIONS(5222),
    [anon_sym___attribute__] = ACTIONS(5222),
    [anon_sym_COLON_COLON] = ACTIONS(5224),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5224),
    [anon_sym___declspec] = ACTIONS(5222),
    [anon_sym___based] = ACTIONS(5222),
    [anon_sym___cdecl] = ACTIONS(5222),
    [anon_sym___clrcall] = ACTIONS(5222),
    [anon_sym___stdcall] = ACTIONS(5222),
    [anon_sym___fastcall] = ACTIONS(5222),
    [anon_sym___thiscall] = ACTIONS(5222),
    [anon_sym___vectorcall] = ACTIONS(5222),
    [anon_sym_LBRACE] = ACTIONS(5224),
    [anon_sym_LBRACK] = ACTIONS(5222),
    [anon_sym_static] = ACTIONS(5222),
    [anon_sym_EQ] = ACTIONS(5224),
    [anon_sym_register] = ACTIONS(5222),
    [anon_sym_inline] = ACTIONS(5222),
    [anon_sym___inline] = ACTIONS(5222),
    [anon_sym___inline__] = ACTIONS(5222),
    [anon_sym___forceinline] = ACTIONS(5222),
    [anon_sym_thread_local] = ACTIONS(5222),
    [anon_sym___thread] = ACTIONS(5222),
    [anon_sym_const] = ACTIONS(5222),
    [anon_sym_constexpr] = ACTIONS(5222),
    [anon_sym_volatile] = ACTIONS(5222),
    [anon_sym_restrict] = ACTIONS(5222),
    [anon_sym___restrict__] = ACTIONS(5222),
    [anon_sym__Atomic] = ACTIONS(5222),
    [anon_sym__Noreturn] = ACTIONS(5222),
    [anon_sym_noreturn] = ACTIONS(5222),
    [anon_sym_mutable] = ACTIONS(5222),
    [anon_sym_constinit] = ACTIONS(5222),
    [anon_sym_consteval] = ACTIONS(5222),
    [anon_sym___shared__] = ACTIONS(5222),
    [anon_sym___local__] = ACTIONS(5222),
    [anon_sym___constant__] = ACTIONS(5222),
    [anon_sym___managed__] = ACTIONS(5222),
    [anon_sym___grid_constant__] = ACTIONS(5222),
    [anon_sym_alignas] = ACTIONS(5222),
    [anon_sym__Alignas] = ACTIONS(5222),
    [anon_sym_asm] = ACTIONS(5222),
    [anon_sym___asm__] = ACTIONS(5222),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5222),
    [anon_sym_decltype] = ACTIONS(5222),
    [anon_sym_final] = ACTIONS(5222),
    [anon_sym_override] = ACTIONS(5222),
    [sym_virtual] = ACTIONS(5222),
    [anon_sym_template] = ACTIONS(5222),
    [anon_sym_GT2] = ACTIONS(5224),
    [anon_sym_operator] = ACTIONS(5222),
    [anon_sym_try] = ACTIONS(5222),
    [anon_sym_requires] = ACTIONS(5222),
    [anon_sym___launch_bounds__] = ACTIONS(5222),
  },
  [2172] = {
    [sym_identifier] = ACTIONS(5242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5244),
    [anon_sym_COMMA] = ACTIONS(5244),
    [anon_sym_RPAREN] = ACTIONS(5244),
    [anon_sym_LPAREN2] = ACTIONS(5244),
    [anon_sym_TILDE] = ACTIONS(5244),
    [anon_sym_STAR] = ACTIONS(5244),
    [anon_sym_AMP_AMP] = ACTIONS(5244),
    [anon_sym_AMP] = ACTIONS(5242),
    [anon_sym_SEMI] = ACTIONS(5244),
    [anon_sym___extension__] = ACTIONS(5242),
    [anon_sym___device__] = ACTIONS(5242),
    [anon_sym___host__] = ACTIONS(5242),
    [anon_sym___global__] = ACTIONS(5242),
    [anon_sym___forceinline__] = ACTIONS(5242),
    [anon_sym___noinline__] = ACTIONS(5242),
    [anon_sym_extern] = ACTIONS(5242),
    [anon_sym___attribute__] = ACTIONS(5242),
    [anon_sym_COLON_COLON] = ACTIONS(5244),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5244),
    [anon_sym___declspec] = ACTIONS(5242),
    [anon_sym___based] = ACTIONS(5242),
    [anon_sym___cdecl] = ACTIONS(5242),
    [anon_sym___clrcall] = ACTIONS(5242),
    [anon_sym___stdcall] = ACTIONS(5242),
    [anon_sym___fastcall] = ACTIONS(5242),
    [anon_sym___thiscall] = ACTIONS(5242),
    [anon_sym___vectorcall] = ACTIONS(5242),
    [anon_sym_LBRACE] = ACTIONS(5244),
    [anon_sym_LBRACK] = ACTIONS(5242),
    [anon_sym_static] = ACTIONS(5242),
    [anon_sym_EQ] = ACTIONS(5244),
    [anon_sym_register] = ACTIONS(5242),
    [anon_sym_inline] = ACTIONS(5242),
    [anon_sym___inline] = ACTIONS(5242),
    [anon_sym___inline__] = ACTIONS(5242),
    [anon_sym___forceinline] = ACTIONS(5242),
    [anon_sym_thread_local] = ACTIONS(5242),
    [anon_sym___thread] = ACTIONS(5242),
    [anon_sym_const] = ACTIONS(5242),
    [anon_sym_constexpr] = ACTIONS(5242),
    [anon_sym_volatile] = ACTIONS(5242),
    [anon_sym_restrict] = ACTIONS(5242),
    [anon_sym___restrict__] = ACTIONS(5242),
    [anon_sym__Atomic] = ACTIONS(5242),
    [anon_sym__Noreturn] = ACTIONS(5242),
    [anon_sym_noreturn] = ACTIONS(5242),
    [anon_sym_mutable] = ACTIONS(5242),
    [anon_sym_constinit] = ACTIONS(5242),
    [anon_sym_consteval] = ACTIONS(5242),
    [anon_sym___shared__] = ACTIONS(5242),
    [anon_sym___local__] = ACTIONS(5242),
    [anon_sym___constant__] = ACTIONS(5242),
    [anon_sym___managed__] = ACTIONS(5242),
    [anon_sym___grid_constant__] = ACTIONS(5242),
    [anon_sym_alignas] = ACTIONS(5242),
    [anon_sym__Alignas] = ACTIONS(5242),
    [anon_sym_asm] = ACTIONS(5242),
    [anon_sym___asm__] = ACTIONS(5242),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5242),
    [anon_sym_decltype] = ACTIONS(5242),
    [anon_sym_final] = ACTIONS(5242),
    [anon_sym_override] = ACTIONS(5242),
    [sym_virtual] = ACTIONS(5242),
    [anon_sym_template] = ACTIONS(5242),
    [anon_sym_GT2] = ACTIONS(5244),
    [anon_sym_operator] = ACTIONS(5242),
    [anon_sym_try] = ACTIONS(5242),
    [anon_sym_requires] = ACTIONS(5242),
    [anon_sym___launch_bounds__] = ACTIONS(5242),
  },
  [2173] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2202),
    [sym_identifier] = ACTIONS(5603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5325),
    [anon_sym_COMMA] = ACTIONS(5325),
    [anon_sym_RPAREN] = ACTIONS(5325),
    [anon_sym_LPAREN2] = ACTIONS(5325),
    [anon_sym_TILDE] = ACTIONS(5325),
    [anon_sym_STAR] = ACTIONS(5325),
    [anon_sym_AMP_AMP] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5327),
    [anon_sym_SEMI] = ACTIONS(5325),
    [anon_sym___extension__] = ACTIONS(5327),
    [anon_sym___device__] = ACTIONS(5327),
    [anon_sym___host__] = ACTIONS(5327),
    [anon_sym___global__] = ACTIONS(5327),
    [anon_sym___forceinline__] = ACTIONS(5327),
    [anon_sym___noinline__] = ACTIONS(5327),
    [anon_sym_extern] = ACTIONS(5327),
    [anon_sym___attribute__] = ACTIONS(5327),
    [anon_sym_COLON_COLON] = ACTIONS(5325),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5325),
    [anon_sym___declspec] = ACTIONS(5327),
    [anon_sym___based] = ACTIONS(5327),
    [anon_sym___cdecl] = ACTIONS(5327),
    [anon_sym___clrcall] = ACTIONS(5327),
    [anon_sym___stdcall] = ACTIONS(5327),
    [anon_sym___fastcall] = ACTIONS(5327),
    [anon_sym___thiscall] = ACTIONS(5327),
    [anon_sym___vectorcall] = ACTIONS(5327),
    [anon_sym_LBRACE] = ACTIONS(5325),
    [anon_sym_signed] = ACTIONS(5606),
    [anon_sym_unsigned] = ACTIONS(5606),
    [anon_sym_long] = ACTIONS(5606),
    [anon_sym_short] = ACTIONS(5606),
    [anon_sym_LBRACK] = ACTIONS(5327),
    [anon_sym_static] = ACTIONS(5327),
    [anon_sym_EQ] = ACTIONS(5325),
    [anon_sym_register] = ACTIONS(5327),
    [anon_sym_inline] = ACTIONS(5327),
    [anon_sym___inline] = ACTIONS(5327),
    [anon_sym___inline__] = ACTIONS(5327),
    [anon_sym___forceinline] = ACTIONS(5327),
    [anon_sym_thread_local] = ACTIONS(5327),
    [anon_sym___thread] = ACTIONS(5327),
    [anon_sym_const] = ACTIONS(5327),
    [anon_sym_constexpr] = ACTIONS(5327),
    [anon_sym_volatile] = ACTIONS(5327),
    [anon_sym_restrict] = ACTIONS(5327),
    [anon_sym___restrict__] = ACTIONS(5327),
    [anon_sym__Atomic] = ACTIONS(5327),
    [anon_sym__Noreturn] = ACTIONS(5327),
    [anon_sym_noreturn] = ACTIONS(5327),
    [anon_sym_mutable] = ACTIONS(5327),
    [anon_sym_constinit] = ACTIONS(5327),
    [anon_sym_consteval] = ACTIONS(5327),
    [anon_sym___shared__] = ACTIONS(5327),
    [anon_sym___local__] = ACTIONS(5327),
    [anon_sym___constant__] = ACTIONS(5327),
    [anon_sym___managed__] = ACTIONS(5327),
    [anon_sym___grid_constant__] = ACTIONS(5327),
    [anon_sym_alignas] = ACTIONS(5327),
    [anon_sym__Alignas] = ACTIONS(5327),
    [sym_primitive_type] = ACTIONS(5608),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5327),
    [anon_sym_decltype] = ACTIONS(5327),
    [sym_virtual] = ACTIONS(5327),
    [anon_sym_template] = ACTIONS(5327),
    [anon_sym_GT2] = ACTIONS(5325),
    [anon_sym_operator] = ACTIONS(5327),
    [anon_sym___launch_bounds__] = ACTIONS(5327),
  },
  [2174] = {
    [sym_identifier] = ACTIONS(5281),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5283),
    [anon_sym_COMMA] = ACTIONS(5283),
    [anon_sym_RPAREN] = ACTIONS(5283),
    [anon_sym_LPAREN2] = ACTIONS(5283),
    [anon_sym_TILDE] = ACTIONS(5283),
    [anon_sym_STAR] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5283),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_SEMI] = ACTIONS(5283),
    [anon_sym___extension__] = ACTIONS(5281),
    [anon_sym___device__] = ACTIONS(5281),
    [anon_sym___host__] = ACTIONS(5281),
    [anon_sym___global__] = ACTIONS(5281),
    [anon_sym___forceinline__] = ACTIONS(5281),
    [anon_sym___noinline__] = ACTIONS(5281),
    [anon_sym_extern] = ACTIONS(5281),
    [anon_sym___attribute__] = ACTIONS(5281),
    [anon_sym_COLON_COLON] = ACTIONS(5283),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5283),
    [anon_sym___declspec] = ACTIONS(5281),
    [anon_sym___based] = ACTIONS(5281),
    [anon_sym___cdecl] = ACTIONS(5281),
    [anon_sym___clrcall] = ACTIONS(5281),
    [anon_sym___stdcall] = ACTIONS(5281),
    [anon_sym___fastcall] = ACTIONS(5281),
    [anon_sym___thiscall] = ACTIONS(5281),
    [anon_sym___vectorcall] = ACTIONS(5281),
    [anon_sym_LBRACE] = ACTIONS(5283),
    [anon_sym_LBRACK] = ACTIONS(5281),
    [anon_sym_static] = ACTIONS(5281),
    [anon_sym_EQ] = ACTIONS(5283),
    [anon_sym_register] = ACTIONS(5281),
    [anon_sym_inline] = ACTIONS(5281),
    [anon_sym___inline] = ACTIONS(5281),
    [anon_sym___inline__] = ACTIONS(5281),
    [anon_sym___forceinline] = ACTIONS(5281),
    [anon_sym_thread_local] = ACTIONS(5281),
    [anon_sym___thread] = ACTIONS(5281),
    [anon_sym_const] = ACTIONS(5281),
    [anon_sym_constexpr] = ACTIONS(5281),
    [anon_sym_volatile] = ACTIONS(5281),
    [anon_sym_restrict] = ACTIONS(5281),
    [anon_sym___restrict__] = ACTIONS(5281),
    [anon_sym__Atomic] = ACTIONS(5281),
    [anon_sym__Noreturn] = ACTIONS(5281),
    [anon_sym_noreturn] = ACTIONS(5281),
    [anon_sym_mutable] = ACTIONS(5281),
    [anon_sym_constinit] = ACTIONS(5281),
    [anon_sym_consteval] = ACTIONS(5281),
    [anon_sym___shared__] = ACTIONS(5281),
    [anon_sym___local__] = ACTIONS(5281),
    [anon_sym___constant__] = ACTIONS(5281),
    [anon_sym___managed__] = ACTIONS(5281),
    [anon_sym___grid_constant__] = ACTIONS(5281),
    [anon_sym_alignas] = ACTIONS(5281),
    [anon_sym__Alignas] = ACTIONS(5281),
    [anon_sym_asm] = ACTIONS(5281),
    [anon_sym___asm__] = ACTIONS(5281),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5281),
    [anon_sym_decltype] = ACTIONS(5281),
    [anon_sym_final] = ACTIONS(5281),
    [anon_sym_override] = ACTIONS(5281),
    [sym_virtual] = ACTIONS(5281),
    [anon_sym_template] = ACTIONS(5281),
    [anon_sym_GT2] = ACTIONS(5283),
    [anon_sym_operator] = ACTIONS(5281),
    [anon_sym_try] = ACTIONS(5281),
    [anon_sym_requires] = ACTIONS(5281),
    [anon_sym___launch_bounds__] = ACTIONS(5281),
  },
  [2175] = {
    [sym_identifier] = ACTIONS(5238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5240),
    [anon_sym_COMMA] = ACTIONS(5240),
    [anon_sym_RPAREN] = ACTIONS(5240),
    [anon_sym_LPAREN2] = ACTIONS(5240),
    [anon_sym_TILDE] = ACTIONS(5240),
    [anon_sym_STAR] = ACTIONS(5240),
    [anon_sym_AMP_AMP] = ACTIONS(5240),
    [anon_sym_AMP] = ACTIONS(5238),
    [anon_sym_SEMI] = ACTIONS(5240),
    [anon_sym___extension__] = ACTIONS(5238),
    [anon_sym___device__] = ACTIONS(5238),
    [anon_sym___host__] = ACTIONS(5238),
    [anon_sym___global__] = ACTIONS(5238),
    [anon_sym___forceinline__] = ACTIONS(5238),
    [anon_sym___noinline__] = ACTIONS(5238),
    [anon_sym_extern] = ACTIONS(5238),
    [anon_sym___attribute__] = ACTIONS(5238),
    [anon_sym_COLON_COLON] = ACTIONS(5240),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5240),
    [anon_sym___declspec] = ACTIONS(5238),
    [anon_sym___based] = ACTIONS(5238),
    [anon_sym___cdecl] = ACTIONS(5238),
    [anon_sym___clrcall] = ACTIONS(5238),
    [anon_sym___stdcall] = ACTIONS(5238),
    [anon_sym___fastcall] = ACTIONS(5238),
    [anon_sym___thiscall] = ACTIONS(5238),
    [anon_sym___vectorcall] = ACTIONS(5238),
    [anon_sym_LBRACE] = ACTIONS(5240),
    [anon_sym_LBRACK] = ACTIONS(5238),
    [anon_sym_static] = ACTIONS(5238),
    [anon_sym_EQ] = ACTIONS(5240),
    [anon_sym_register] = ACTIONS(5238),
    [anon_sym_inline] = ACTIONS(5238),
    [anon_sym___inline] = ACTIONS(5238),
    [anon_sym___inline__] = ACTIONS(5238),
    [anon_sym___forceinline] = ACTIONS(5238),
    [anon_sym_thread_local] = ACTIONS(5238),
    [anon_sym___thread] = ACTIONS(5238),
    [anon_sym_const] = ACTIONS(5238),
    [anon_sym_constexpr] = ACTIONS(5238),
    [anon_sym_volatile] = ACTIONS(5238),
    [anon_sym_restrict] = ACTIONS(5238),
    [anon_sym___restrict__] = ACTIONS(5238),
    [anon_sym__Atomic] = ACTIONS(5238),
    [anon_sym__Noreturn] = ACTIONS(5238),
    [anon_sym_noreturn] = ACTIONS(5238),
    [anon_sym_mutable] = ACTIONS(5238),
    [anon_sym_constinit] = ACTIONS(5238),
    [anon_sym_consteval] = ACTIONS(5238),
    [anon_sym___shared__] = ACTIONS(5238),
    [anon_sym___local__] = ACTIONS(5238),
    [anon_sym___constant__] = ACTIONS(5238),
    [anon_sym___managed__] = ACTIONS(5238),
    [anon_sym___grid_constant__] = ACTIONS(5238),
    [anon_sym_alignas] = ACTIONS(5238),
    [anon_sym__Alignas] = ACTIONS(5238),
    [anon_sym_asm] = ACTIONS(5238),
    [anon_sym___asm__] = ACTIONS(5238),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5238),
    [anon_sym_decltype] = ACTIONS(5238),
    [anon_sym_final] = ACTIONS(5238),
    [anon_sym_override] = ACTIONS(5238),
    [sym_virtual] = ACTIONS(5238),
    [anon_sym_template] = ACTIONS(5238),
    [anon_sym_GT2] = ACTIONS(5240),
    [anon_sym_operator] = ACTIONS(5238),
    [anon_sym_try] = ACTIONS(5238),
    [anon_sym_requires] = ACTIONS(5238),
    [anon_sym___launch_bounds__] = ACTIONS(5238),
  },
  [2176] = {
    [sym_identifier] = ACTIONS(5285),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5287),
    [anon_sym_COMMA] = ACTIONS(5287),
    [anon_sym_RPAREN] = ACTIONS(5287),
    [anon_sym_LPAREN2] = ACTIONS(5287),
    [anon_sym_TILDE] = ACTIONS(5287),
    [anon_sym_STAR] = ACTIONS(5287),
    [anon_sym_AMP_AMP] = ACTIONS(5287),
    [anon_sym_AMP] = ACTIONS(5285),
    [anon_sym_SEMI] = ACTIONS(5287),
    [anon_sym___extension__] = ACTIONS(5285),
    [anon_sym___device__] = ACTIONS(5285),
    [anon_sym___host__] = ACTIONS(5285),
    [anon_sym___global__] = ACTIONS(5285),
    [anon_sym___forceinline__] = ACTIONS(5285),
    [anon_sym___noinline__] = ACTIONS(5285),
    [anon_sym_extern] = ACTIONS(5285),
    [anon_sym___attribute__] = ACTIONS(5285),
    [anon_sym_COLON_COLON] = ACTIONS(5287),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5287),
    [anon_sym___declspec] = ACTIONS(5285),
    [anon_sym___based] = ACTIONS(5285),
    [anon_sym___cdecl] = ACTIONS(5285),
    [anon_sym___clrcall] = ACTIONS(5285),
    [anon_sym___stdcall] = ACTIONS(5285),
    [anon_sym___fastcall] = ACTIONS(5285),
    [anon_sym___thiscall] = ACTIONS(5285),
    [anon_sym___vectorcall] = ACTIONS(5285),
    [anon_sym_LBRACE] = ACTIONS(5287),
    [anon_sym_LBRACK] = ACTIONS(5285),
    [anon_sym_static] = ACTIONS(5285),
    [anon_sym_EQ] = ACTIONS(5287),
    [anon_sym_register] = ACTIONS(5285),
    [anon_sym_inline] = ACTIONS(5285),
    [anon_sym___inline] = ACTIONS(5285),
    [anon_sym___inline__] = ACTIONS(5285),
    [anon_sym___forceinline] = ACTIONS(5285),
    [anon_sym_thread_local] = ACTIONS(5285),
    [anon_sym___thread] = ACTIONS(5285),
    [anon_sym_const] = ACTIONS(5285),
    [anon_sym_constexpr] = ACTIONS(5285),
    [anon_sym_volatile] = ACTIONS(5285),
    [anon_sym_restrict] = ACTIONS(5285),
    [anon_sym___restrict__] = ACTIONS(5285),
    [anon_sym__Atomic] = ACTIONS(5285),
    [anon_sym__Noreturn] = ACTIONS(5285),
    [anon_sym_noreturn] = ACTIONS(5285),
    [anon_sym_mutable] = ACTIONS(5285),
    [anon_sym_constinit] = ACTIONS(5285),
    [anon_sym_consteval] = ACTIONS(5285),
    [anon_sym___shared__] = ACTIONS(5285),
    [anon_sym___local__] = ACTIONS(5285),
    [anon_sym___constant__] = ACTIONS(5285),
    [anon_sym___managed__] = ACTIONS(5285),
    [anon_sym___grid_constant__] = ACTIONS(5285),
    [anon_sym_alignas] = ACTIONS(5285),
    [anon_sym__Alignas] = ACTIONS(5285),
    [anon_sym_asm] = ACTIONS(5285),
    [anon_sym___asm__] = ACTIONS(5285),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5285),
    [anon_sym_decltype] = ACTIONS(5285),
    [anon_sym_final] = ACTIONS(5285),
    [anon_sym_override] = ACTIONS(5285),
    [sym_virtual] = ACTIONS(5285),
    [anon_sym_template] = ACTIONS(5285),
    [anon_sym_GT2] = ACTIONS(5287),
    [anon_sym_operator] = ACTIONS(5285),
    [anon_sym_try] = ACTIONS(5285),
    [anon_sym_requires] = ACTIONS(5285),
    [anon_sym___launch_bounds__] = ACTIONS(5285),
  },
  [2177] = {
    [sym_identifier] = ACTIONS(5214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5216),
    [anon_sym_COMMA] = ACTIONS(5216),
    [anon_sym_RPAREN] = ACTIONS(5216),
    [anon_sym_LPAREN2] = ACTIONS(5216),
    [anon_sym_TILDE] = ACTIONS(5216),
    [anon_sym_STAR] = ACTIONS(5216),
    [anon_sym_AMP_AMP] = ACTIONS(5216),
    [anon_sym_AMP] = ACTIONS(5214),
    [anon_sym_SEMI] = ACTIONS(5216),
    [anon_sym___extension__] = ACTIONS(5214),
    [anon_sym___device__] = ACTIONS(5214),
    [anon_sym___host__] = ACTIONS(5214),
    [anon_sym___global__] = ACTIONS(5214),
    [anon_sym___forceinline__] = ACTIONS(5214),
    [anon_sym___noinline__] = ACTIONS(5214),
    [anon_sym_extern] = ACTIONS(5214),
    [anon_sym___attribute__] = ACTIONS(5214),
    [anon_sym_COLON_COLON] = ACTIONS(5216),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5216),
    [anon_sym___declspec] = ACTIONS(5214),
    [anon_sym___based] = ACTIONS(5214),
    [anon_sym___cdecl] = ACTIONS(5214),
    [anon_sym___clrcall] = ACTIONS(5214),
    [anon_sym___stdcall] = ACTIONS(5214),
    [anon_sym___fastcall] = ACTIONS(5214),
    [anon_sym___thiscall] = ACTIONS(5214),
    [anon_sym___vectorcall] = ACTIONS(5214),
    [anon_sym_LBRACE] = ACTIONS(5216),
    [anon_sym_LBRACK] = ACTIONS(5214),
    [anon_sym_static] = ACTIONS(5214),
    [anon_sym_EQ] = ACTIONS(5216),
    [anon_sym_register] = ACTIONS(5214),
    [anon_sym_inline] = ACTIONS(5214),
    [anon_sym___inline] = ACTIONS(5214),
    [anon_sym___inline__] = ACTIONS(5214),
    [anon_sym___forceinline] = ACTIONS(5214),
    [anon_sym_thread_local] = ACTIONS(5214),
    [anon_sym___thread] = ACTIONS(5214),
    [anon_sym_const] = ACTIONS(5214),
    [anon_sym_constexpr] = ACTIONS(5214),
    [anon_sym_volatile] = ACTIONS(5214),
    [anon_sym_restrict] = ACTIONS(5214),
    [anon_sym___restrict__] = ACTIONS(5214),
    [anon_sym__Atomic] = ACTIONS(5214),
    [anon_sym__Noreturn] = ACTIONS(5214),
    [anon_sym_noreturn] = ACTIONS(5214),
    [anon_sym_mutable] = ACTIONS(5214),
    [anon_sym_constinit] = ACTIONS(5214),
    [anon_sym_consteval] = ACTIONS(5214),
    [anon_sym___shared__] = ACTIONS(5214),
    [anon_sym___local__] = ACTIONS(5214),
    [anon_sym___constant__] = ACTIONS(5214),
    [anon_sym___managed__] = ACTIONS(5214),
    [anon_sym___grid_constant__] = ACTIONS(5214),
    [anon_sym_alignas] = ACTIONS(5214),
    [anon_sym__Alignas] = ACTIONS(5214),
    [anon_sym_asm] = ACTIONS(5214),
    [anon_sym___asm__] = ACTIONS(5214),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5214),
    [anon_sym_decltype] = ACTIONS(5214),
    [anon_sym_final] = ACTIONS(5214),
    [anon_sym_override] = ACTIONS(5214),
    [sym_virtual] = ACTIONS(5214),
    [anon_sym_template] = ACTIONS(5214),
    [anon_sym_GT2] = ACTIONS(5216),
    [anon_sym_operator] = ACTIONS(5214),
    [anon_sym_try] = ACTIONS(5214),
    [anon_sym_requires] = ACTIONS(5214),
    [anon_sym___launch_bounds__] = ACTIONS(5214),
  },
  [2178] = {
    [sym_identifier] = ACTIONS(5374),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5376),
    [anon_sym_COMMA] = ACTIONS(5376),
    [anon_sym_RPAREN] = ACTIONS(5376),
    [anon_sym_LPAREN2] = ACTIONS(5376),
    [anon_sym_TILDE] = ACTIONS(5376),
    [anon_sym_STAR] = ACTIONS(5376),
    [anon_sym_AMP_AMP] = ACTIONS(5376),
    [anon_sym_AMP] = ACTIONS(5374),
    [anon_sym_SEMI] = ACTIONS(5376),
    [anon_sym___extension__] = ACTIONS(5374),
    [anon_sym___device__] = ACTIONS(5374),
    [anon_sym___host__] = ACTIONS(5374),
    [anon_sym___global__] = ACTIONS(5374),
    [anon_sym___forceinline__] = ACTIONS(5374),
    [anon_sym___noinline__] = ACTIONS(5374),
    [anon_sym_extern] = ACTIONS(5374),
    [anon_sym___attribute__] = ACTIONS(5374),
    [anon_sym_COLON_COLON] = ACTIONS(5376),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5376),
    [anon_sym___declspec] = ACTIONS(5374),
    [anon_sym___based] = ACTIONS(5374),
    [anon_sym___cdecl] = ACTIONS(5374),
    [anon_sym___clrcall] = ACTIONS(5374),
    [anon_sym___stdcall] = ACTIONS(5374),
    [anon_sym___fastcall] = ACTIONS(5374),
    [anon_sym___thiscall] = ACTIONS(5374),
    [anon_sym___vectorcall] = ACTIONS(5374),
    [anon_sym_LBRACE] = ACTIONS(5376),
    [anon_sym_LBRACK] = ACTIONS(5374),
    [anon_sym_static] = ACTIONS(5374),
    [anon_sym_EQ] = ACTIONS(5376),
    [anon_sym_register] = ACTIONS(5374),
    [anon_sym_inline] = ACTIONS(5374),
    [anon_sym___inline] = ACTIONS(5374),
    [anon_sym___inline__] = ACTIONS(5374),
    [anon_sym___forceinline] = ACTIONS(5374),
    [anon_sym_thread_local] = ACTIONS(5374),
    [anon_sym___thread] = ACTIONS(5374),
    [anon_sym_const] = ACTIONS(5374),
    [anon_sym_constexpr] = ACTIONS(5374),
    [anon_sym_volatile] = ACTIONS(5374),
    [anon_sym_restrict] = ACTIONS(5374),
    [anon_sym___restrict__] = ACTIONS(5374),
    [anon_sym__Atomic] = ACTIONS(5374),
    [anon_sym__Noreturn] = ACTIONS(5374),
    [anon_sym_noreturn] = ACTIONS(5374),
    [anon_sym_mutable] = ACTIONS(5374),
    [anon_sym_constinit] = ACTIONS(5374),
    [anon_sym_consteval] = ACTIONS(5374),
    [anon_sym___shared__] = ACTIONS(5374),
    [anon_sym___local__] = ACTIONS(5374),
    [anon_sym___constant__] = ACTIONS(5374),
    [anon_sym___managed__] = ACTIONS(5374),
    [anon_sym___grid_constant__] = ACTIONS(5374),
    [anon_sym_alignas] = ACTIONS(5374),
    [anon_sym__Alignas] = ACTIONS(5374),
    [anon_sym_asm] = ACTIONS(5374),
    [anon_sym___asm__] = ACTIONS(5374),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5374),
    [anon_sym_decltype] = ACTIONS(5374),
    [anon_sym_final] = ACTIONS(5374),
    [anon_sym_override] = ACTIONS(5374),
    [sym_virtual] = ACTIONS(5374),
    [anon_sym_template] = ACTIONS(5374),
    [anon_sym_GT2] = ACTIONS(5376),
    [anon_sym_operator] = ACTIONS(5374),
    [anon_sym_try] = ACTIONS(5374),
    [anon_sym_requires] = ACTIONS(5374),
    [anon_sym___launch_bounds__] = ACTIONS(5374),
  },
  [2179] = {
    [sym_identifier] = ACTIONS(5246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5248),
    [anon_sym_COMMA] = ACTIONS(5248),
    [anon_sym_RPAREN] = ACTIONS(5248),
    [anon_sym_LPAREN2] = ACTIONS(5248),
    [anon_sym_TILDE] = ACTIONS(5248),
    [anon_sym_STAR] = ACTIONS(5248),
    [anon_sym_AMP_AMP] = ACTIONS(5248),
    [anon_sym_AMP] = ACTIONS(5246),
    [anon_sym_SEMI] = ACTIONS(5248),
    [anon_sym___extension__] = ACTIONS(5246),
    [anon_sym___device__] = ACTIONS(5246),
    [anon_sym___host__] = ACTIONS(5246),
    [anon_sym___global__] = ACTIONS(5246),
    [anon_sym___forceinline__] = ACTIONS(5246),
    [anon_sym___noinline__] = ACTIONS(5246),
    [anon_sym_extern] = ACTIONS(5246),
    [anon_sym___attribute__] = ACTIONS(5246),
    [anon_sym_COLON_COLON] = ACTIONS(5248),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5248),
    [anon_sym___declspec] = ACTIONS(5246),
    [anon_sym___based] = ACTIONS(5246),
    [anon_sym___cdecl] = ACTIONS(5246),
    [anon_sym___clrcall] = ACTIONS(5246),
    [anon_sym___stdcall] = ACTIONS(5246),
    [anon_sym___fastcall] = ACTIONS(5246),
    [anon_sym___thiscall] = ACTIONS(5246),
    [anon_sym___vectorcall] = ACTIONS(5246),
    [anon_sym_LBRACE] = ACTIONS(5248),
    [anon_sym_LBRACK] = ACTIONS(5246),
    [anon_sym_static] = ACTIONS(5246),
    [anon_sym_EQ] = ACTIONS(5248),
    [anon_sym_register] = ACTIONS(5246),
    [anon_sym_inline] = ACTIONS(5246),
    [anon_sym___inline] = ACTIONS(5246),
    [anon_sym___inline__] = ACTIONS(5246),
    [anon_sym___forceinline] = ACTIONS(5246),
    [anon_sym_thread_local] = ACTIONS(5246),
    [anon_sym___thread] = ACTIONS(5246),
    [anon_sym_const] = ACTIONS(5246),
    [anon_sym_constexpr] = ACTIONS(5246),
    [anon_sym_volatile] = ACTIONS(5246),
    [anon_sym_restrict] = ACTIONS(5246),
    [anon_sym___restrict__] = ACTIONS(5246),
    [anon_sym__Atomic] = ACTIONS(5246),
    [anon_sym__Noreturn] = ACTIONS(5246),
    [anon_sym_noreturn] = ACTIONS(5246),
    [anon_sym_mutable] = ACTIONS(5246),
    [anon_sym_constinit] = ACTIONS(5246),
    [anon_sym_consteval] = ACTIONS(5246),
    [anon_sym___shared__] = ACTIONS(5246),
    [anon_sym___local__] = ACTIONS(5246),
    [anon_sym___constant__] = ACTIONS(5246),
    [anon_sym___managed__] = ACTIONS(5246),
    [anon_sym___grid_constant__] = ACTIONS(5246),
    [anon_sym_alignas] = ACTIONS(5246),
    [anon_sym__Alignas] = ACTIONS(5246),
    [anon_sym_asm] = ACTIONS(5246),
    [anon_sym___asm__] = ACTIONS(5246),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5246),
    [anon_sym_decltype] = ACTIONS(5246),
    [anon_sym_final] = ACTIONS(5246),
    [anon_sym_override] = ACTIONS(5246),
    [sym_virtual] = ACTIONS(5246),
    [anon_sym_template] = ACTIONS(5246),
    [anon_sym_GT2] = ACTIONS(5248),
    [anon_sym_operator] = ACTIONS(5246),
    [anon_sym_try] = ACTIONS(5246),
    [anon_sym_requires] = ACTIONS(5246),
    [anon_sym___launch_bounds__] = ACTIONS(5246),
  },
  [2180] = {
    [sym_identifier] = ACTIONS(5293),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5295),
    [anon_sym_COMMA] = ACTIONS(5295),
    [anon_sym_RPAREN] = ACTIONS(5295),
    [anon_sym_LPAREN2] = ACTIONS(5295),
    [anon_sym_TILDE] = ACTIONS(5295),
    [anon_sym_STAR] = ACTIONS(5295),
    [anon_sym_AMP_AMP] = ACTIONS(5295),
    [anon_sym_AMP] = ACTIONS(5293),
    [anon_sym_SEMI] = ACTIONS(5295),
    [anon_sym___extension__] = ACTIONS(5293),
    [anon_sym___device__] = ACTIONS(5293),
    [anon_sym___host__] = ACTIONS(5293),
    [anon_sym___global__] = ACTIONS(5293),
    [anon_sym___forceinline__] = ACTIONS(5293),
    [anon_sym___noinline__] = ACTIONS(5293),
    [anon_sym_extern] = ACTIONS(5293),
    [anon_sym___attribute__] = ACTIONS(5293),
    [anon_sym_COLON_COLON] = ACTIONS(5295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5295),
    [anon_sym___declspec] = ACTIONS(5293),
    [anon_sym___based] = ACTIONS(5293),
    [anon_sym___cdecl] = ACTIONS(5293),
    [anon_sym___clrcall] = ACTIONS(5293),
    [anon_sym___stdcall] = ACTIONS(5293),
    [anon_sym___fastcall] = ACTIONS(5293),
    [anon_sym___thiscall] = ACTIONS(5293),
    [anon_sym___vectorcall] = ACTIONS(5293),
    [anon_sym_LBRACE] = ACTIONS(5295),
    [anon_sym_LBRACK] = ACTIONS(5293),
    [anon_sym_static] = ACTIONS(5293),
    [anon_sym_EQ] = ACTIONS(5295),
    [anon_sym_register] = ACTIONS(5293),
    [anon_sym_inline] = ACTIONS(5293),
    [anon_sym___inline] = ACTIONS(5293),
    [anon_sym___inline__] = ACTIONS(5293),
    [anon_sym___forceinline] = ACTIONS(5293),
    [anon_sym_thread_local] = ACTIONS(5293),
    [anon_sym___thread] = ACTIONS(5293),
    [anon_sym_const] = ACTIONS(5293),
    [anon_sym_constexpr] = ACTIONS(5293),
    [anon_sym_volatile] = ACTIONS(5293),
    [anon_sym_restrict] = ACTIONS(5293),
    [anon_sym___restrict__] = ACTIONS(5293),
    [anon_sym__Atomic] = ACTIONS(5293),
    [anon_sym__Noreturn] = ACTIONS(5293),
    [anon_sym_noreturn] = ACTIONS(5293),
    [anon_sym_mutable] = ACTIONS(5293),
    [anon_sym_constinit] = ACTIONS(5293),
    [anon_sym_consteval] = ACTIONS(5293),
    [anon_sym___shared__] = ACTIONS(5293),
    [anon_sym___local__] = ACTIONS(5293),
    [anon_sym___constant__] = ACTIONS(5293),
    [anon_sym___managed__] = ACTIONS(5293),
    [anon_sym___grid_constant__] = ACTIONS(5293),
    [anon_sym_alignas] = ACTIONS(5293),
    [anon_sym__Alignas] = ACTIONS(5293),
    [anon_sym_asm] = ACTIONS(5293),
    [anon_sym___asm__] = ACTIONS(5293),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5293),
    [anon_sym_decltype] = ACTIONS(5293),
    [anon_sym_final] = ACTIONS(5293),
    [anon_sym_override] = ACTIONS(5293),
    [sym_virtual] = ACTIONS(5293),
    [anon_sym_template] = ACTIONS(5293),
    [anon_sym_GT2] = ACTIONS(5295),
    [anon_sym_operator] = ACTIONS(5293),
    [anon_sym_try] = ACTIONS(5293),
    [anon_sym_requires] = ACTIONS(5293),
    [anon_sym___launch_bounds__] = ACTIONS(5293),
  },
  [2181] = {
    [sym_identifier] = ACTIONS(5319),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5321),
    [anon_sym_COMMA] = ACTIONS(5321),
    [anon_sym_RPAREN] = ACTIONS(5321),
    [anon_sym_LPAREN2] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [anon_sym_STAR] = ACTIONS(5321),
    [anon_sym_AMP_AMP] = ACTIONS(5321),
    [anon_sym_AMP] = ACTIONS(5319),
    [anon_sym_SEMI] = ACTIONS(5321),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym___device__] = ACTIONS(5319),
    [anon_sym___host__] = ACTIONS(5319),
    [anon_sym___global__] = ACTIONS(5319),
    [anon_sym___forceinline__] = ACTIONS(5319),
    [anon_sym___noinline__] = ACTIONS(5319),
    [anon_sym_extern] = ACTIONS(5319),
    [anon_sym___attribute__] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(5321),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5321),
    [anon_sym___declspec] = ACTIONS(5319),
    [anon_sym___based] = ACTIONS(5319),
    [anon_sym___cdecl] = ACTIONS(5319),
    [anon_sym___clrcall] = ACTIONS(5319),
    [anon_sym___stdcall] = ACTIONS(5319),
    [anon_sym___fastcall] = ACTIONS(5319),
    [anon_sym___thiscall] = ACTIONS(5319),
    [anon_sym___vectorcall] = ACTIONS(5319),
    [anon_sym_LBRACE] = ACTIONS(5321),
    [anon_sym_LBRACK] = ACTIONS(5319),
    [anon_sym_static] = ACTIONS(5319),
    [anon_sym_EQ] = ACTIONS(5321),
    [anon_sym_register] = ACTIONS(5319),
    [anon_sym_inline] = ACTIONS(5319),
    [anon_sym___inline] = ACTIONS(5319),
    [anon_sym___inline__] = ACTIONS(5319),
    [anon_sym___forceinline] = ACTIONS(5319),
    [anon_sym_thread_local] = ACTIONS(5319),
    [anon_sym___thread] = ACTIONS(5319),
    [anon_sym_const] = ACTIONS(5319),
    [anon_sym_constexpr] = ACTIONS(5319),
    [anon_sym_volatile] = ACTIONS(5319),
    [anon_sym_restrict] = ACTIONS(5319),
    [anon_sym___restrict__] = ACTIONS(5319),
    [anon_sym__Atomic] = ACTIONS(5319),
    [anon_sym__Noreturn] = ACTIONS(5319),
    [anon_sym_noreturn] = ACTIONS(5319),
    [anon_sym_mutable] = ACTIONS(5319),
    [anon_sym_constinit] = ACTIONS(5319),
    [anon_sym_consteval] = ACTIONS(5319),
    [anon_sym___shared__] = ACTIONS(5319),
    [anon_sym___local__] = ACTIONS(5319),
    [anon_sym___constant__] = ACTIONS(5319),
    [anon_sym___managed__] = ACTIONS(5319),
    [anon_sym___grid_constant__] = ACTIONS(5319),
    [anon_sym_alignas] = ACTIONS(5319),
    [anon_sym__Alignas] = ACTIONS(5319),
    [anon_sym_asm] = ACTIONS(5319),
    [anon_sym___asm__] = ACTIONS(5319),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5319),
    [anon_sym_decltype] = ACTIONS(5319),
    [anon_sym_final] = ACTIONS(5319),
    [anon_sym_override] = ACTIONS(5319),
    [sym_virtual] = ACTIONS(5319),
    [anon_sym_template] = ACTIONS(5319),
    [anon_sym_GT2] = ACTIONS(5321),
    [anon_sym_operator] = ACTIONS(5319),
    [anon_sym_try] = ACTIONS(5319),
    [anon_sym_requires] = ACTIONS(5319),
    [anon_sym___launch_bounds__] = ACTIONS(5319),
  },
  [2182] = {
    [sym_identifier] = ACTIONS(5277),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5279),
    [anon_sym_COMMA] = ACTIONS(5279),
    [anon_sym_RPAREN] = ACTIONS(5279),
    [anon_sym_LPAREN2] = ACTIONS(5279),
    [anon_sym_TILDE] = ACTIONS(5279),
    [anon_sym_STAR] = ACTIONS(5279),
    [anon_sym_AMP_AMP] = ACTIONS(5279),
    [anon_sym_AMP] = ACTIONS(5277),
    [anon_sym_SEMI] = ACTIONS(5279),
    [anon_sym___extension__] = ACTIONS(5277),
    [anon_sym___device__] = ACTIONS(5277),
    [anon_sym___host__] = ACTIONS(5277),
    [anon_sym___global__] = ACTIONS(5277),
    [anon_sym___forceinline__] = ACTIONS(5277),
    [anon_sym___noinline__] = ACTIONS(5277),
    [anon_sym_extern] = ACTIONS(5277),
    [anon_sym___attribute__] = ACTIONS(5277),
    [anon_sym_COLON_COLON] = ACTIONS(5279),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5279),
    [anon_sym___declspec] = ACTIONS(5277),
    [anon_sym___based] = ACTIONS(5277),
    [anon_sym___cdecl] = ACTIONS(5277),
    [anon_sym___clrcall] = ACTIONS(5277),
    [anon_sym___stdcall] = ACTIONS(5277),
    [anon_sym___fastcall] = ACTIONS(5277),
    [anon_sym___thiscall] = ACTIONS(5277),
    [anon_sym___vectorcall] = ACTIONS(5277),
    [anon_sym_LBRACE] = ACTIONS(5279),
    [anon_sym_LBRACK] = ACTIONS(5277),
    [anon_sym_static] = ACTIONS(5277),
    [anon_sym_EQ] = ACTIONS(5279),
    [anon_sym_register] = ACTIONS(5277),
    [anon_sym_inline] = ACTIONS(5277),
    [anon_sym___inline] = ACTIONS(5277),
    [anon_sym___inline__] = ACTIONS(5277),
    [anon_sym___forceinline] = ACTIONS(5277),
    [anon_sym_thread_local] = ACTIONS(5277),
    [anon_sym___thread] = ACTIONS(5277),
    [anon_sym_const] = ACTIONS(5277),
    [anon_sym_constexpr] = ACTIONS(5277),
    [anon_sym_volatile] = ACTIONS(5277),
    [anon_sym_restrict] = ACTIONS(5277),
    [anon_sym___restrict__] = ACTIONS(5277),
    [anon_sym__Atomic] = ACTIONS(5277),
    [anon_sym__Noreturn] = ACTIONS(5277),
    [anon_sym_noreturn] = ACTIONS(5277),
    [anon_sym_mutable] = ACTIONS(5277),
    [anon_sym_constinit] = ACTIONS(5277),
    [anon_sym_consteval] = ACTIONS(5277),
    [anon_sym___shared__] = ACTIONS(5277),
    [anon_sym___local__] = ACTIONS(5277),
    [anon_sym___constant__] = ACTIONS(5277),
    [anon_sym___managed__] = ACTIONS(5277),
    [anon_sym___grid_constant__] = ACTIONS(5277),
    [anon_sym_alignas] = ACTIONS(5277),
    [anon_sym__Alignas] = ACTIONS(5277),
    [anon_sym_asm] = ACTIONS(5277),
    [anon_sym___asm__] = ACTIONS(5277),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5277),
    [anon_sym_decltype] = ACTIONS(5277),
    [anon_sym_final] = ACTIONS(5277),
    [anon_sym_override] = ACTIONS(5277),
    [sym_virtual] = ACTIONS(5277),
    [anon_sym_template] = ACTIONS(5277),
    [anon_sym_GT2] = ACTIONS(5279),
    [anon_sym_operator] = ACTIONS(5277),
    [anon_sym_try] = ACTIONS(5277),
    [anon_sym_requires] = ACTIONS(5277),
    [anon_sym___launch_bounds__] = ACTIONS(5277),
  },
  [2183] = {
    [sym_identifier] = ACTIONS(5386),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5388),
    [anon_sym_COMMA] = ACTIONS(5388),
    [anon_sym_RPAREN] = ACTIONS(5388),
    [anon_sym_LPAREN2] = ACTIONS(5388),
    [anon_sym_TILDE] = ACTIONS(5388),
    [anon_sym_STAR] = ACTIONS(5388),
    [anon_sym_AMP_AMP] = ACTIONS(5388),
    [anon_sym_AMP] = ACTIONS(5386),
    [anon_sym_SEMI] = ACTIONS(5388),
    [anon_sym___extension__] = ACTIONS(5386),
    [anon_sym___device__] = ACTIONS(5386),
    [anon_sym___host__] = ACTIONS(5386),
    [anon_sym___global__] = ACTIONS(5386),
    [anon_sym___forceinline__] = ACTIONS(5386),
    [anon_sym___noinline__] = ACTIONS(5386),
    [anon_sym_extern] = ACTIONS(5386),
    [anon_sym___attribute__] = ACTIONS(5386),
    [anon_sym_COLON_COLON] = ACTIONS(5388),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5388),
    [anon_sym___declspec] = ACTIONS(5386),
    [anon_sym___based] = ACTIONS(5386),
    [anon_sym___cdecl] = ACTIONS(5386),
    [anon_sym___clrcall] = ACTIONS(5386),
    [anon_sym___stdcall] = ACTIONS(5386),
    [anon_sym___fastcall] = ACTIONS(5386),
    [anon_sym___thiscall] = ACTIONS(5386),
    [anon_sym___vectorcall] = ACTIONS(5386),
    [anon_sym_LBRACE] = ACTIONS(5388),
    [anon_sym_LBRACK] = ACTIONS(5386),
    [anon_sym_static] = ACTIONS(5386),
    [anon_sym_EQ] = ACTIONS(5388),
    [anon_sym_register] = ACTIONS(5386),
    [anon_sym_inline] = ACTIONS(5386),
    [anon_sym___inline] = ACTIONS(5386),
    [anon_sym___inline__] = ACTIONS(5386),
    [anon_sym___forceinline] = ACTIONS(5386),
    [anon_sym_thread_local] = ACTIONS(5386),
    [anon_sym___thread] = ACTIONS(5386),
    [anon_sym_const] = ACTIONS(5386),
    [anon_sym_constexpr] = ACTIONS(5386),
    [anon_sym_volatile] = ACTIONS(5386),
    [anon_sym_restrict] = ACTIONS(5386),
    [anon_sym___restrict__] = ACTIONS(5386),
    [anon_sym__Atomic] = ACTIONS(5386),
    [anon_sym__Noreturn] = ACTIONS(5386),
    [anon_sym_noreturn] = ACTIONS(5386),
    [anon_sym_mutable] = ACTIONS(5386),
    [anon_sym_constinit] = ACTIONS(5386),
    [anon_sym_consteval] = ACTIONS(5386),
    [anon_sym___shared__] = ACTIONS(5386),
    [anon_sym___local__] = ACTIONS(5386),
    [anon_sym___constant__] = ACTIONS(5386),
    [anon_sym___managed__] = ACTIONS(5386),
    [anon_sym___grid_constant__] = ACTIONS(5386),
    [anon_sym_alignas] = ACTIONS(5386),
    [anon_sym__Alignas] = ACTIONS(5386),
    [anon_sym_asm] = ACTIONS(5386),
    [anon_sym___asm__] = ACTIONS(5386),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5386),
    [anon_sym_decltype] = ACTIONS(5386),
    [anon_sym_final] = ACTIONS(5386),
    [anon_sym_override] = ACTIONS(5386),
    [sym_virtual] = ACTIONS(5386),
    [anon_sym_template] = ACTIONS(5386),
    [anon_sym_GT2] = ACTIONS(5388),
    [anon_sym_operator] = ACTIONS(5386),
    [anon_sym_try] = ACTIONS(5386),
    [anon_sym_requires] = ACTIONS(5386),
    [anon_sym___launch_bounds__] = ACTIONS(5386),
  },
  [2184] = {
    [sym_identifier] = ACTIONS(5366),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5368),
    [anon_sym_COMMA] = ACTIONS(5368),
    [anon_sym_RPAREN] = ACTIONS(5368),
    [anon_sym_LPAREN2] = ACTIONS(5368),
    [anon_sym_TILDE] = ACTIONS(5368),
    [anon_sym_STAR] = ACTIONS(5368),
    [anon_sym_AMP_AMP] = ACTIONS(5368),
    [anon_sym_AMP] = ACTIONS(5366),
    [anon_sym_SEMI] = ACTIONS(5368),
    [anon_sym___extension__] = ACTIONS(5366),
    [anon_sym___device__] = ACTIONS(5366),
    [anon_sym___host__] = ACTIONS(5366),
    [anon_sym___global__] = ACTIONS(5366),
    [anon_sym___forceinline__] = ACTIONS(5366),
    [anon_sym___noinline__] = ACTIONS(5366),
    [anon_sym_extern] = ACTIONS(5366),
    [anon_sym___attribute__] = ACTIONS(5366),
    [anon_sym_COLON_COLON] = ACTIONS(5368),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5368),
    [anon_sym___declspec] = ACTIONS(5366),
    [anon_sym___based] = ACTIONS(5366),
    [anon_sym___cdecl] = ACTIONS(5366),
    [anon_sym___clrcall] = ACTIONS(5366),
    [anon_sym___stdcall] = ACTIONS(5366),
    [anon_sym___fastcall] = ACTIONS(5366),
    [anon_sym___thiscall] = ACTIONS(5366),
    [anon_sym___vectorcall] = ACTIONS(5366),
    [anon_sym_LBRACE] = ACTIONS(5368),
    [anon_sym_LBRACK] = ACTIONS(5366),
    [anon_sym_static] = ACTIONS(5366),
    [anon_sym_EQ] = ACTIONS(5368),
    [anon_sym_register] = ACTIONS(5366),
    [anon_sym_inline] = ACTIONS(5366),
    [anon_sym___inline] = ACTIONS(5366),
    [anon_sym___inline__] = ACTIONS(5366),
    [anon_sym___forceinline] = ACTIONS(5366),
    [anon_sym_thread_local] = ACTIONS(5366),
    [anon_sym___thread] = ACTIONS(5366),
    [anon_sym_const] = ACTIONS(5366),
    [anon_sym_constexpr] = ACTIONS(5366),
    [anon_sym_volatile] = ACTIONS(5366),
    [anon_sym_restrict] = ACTIONS(5366),
    [anon_sym___restrict__] = ACTIONS(5366),
    [anon_sym__Atomic] = ACTIONS(5366),
    [anon_sym__Noreturn] = ACTIONS(5366),
    [anon_sym_noreturn] = ACTIONS(5366),
    [anon_sym_mutable] = ACTIONS(5366),
    [anon_sym_constinit] = ACTIONS(5366),
    [anon_sym_consteval] = ACTIONS(5366),
    [anon_sym___shared__] = ACTIONS(5366),
    [anon_sym___local__] = ACTIONS(5366),
    [anon_sym___constant__] = ACTIONS(5366),
    [anon_sym___managed__] = ACTIONS(5366),
    [anon_sym___grid_constant__] = ACTIONS(5366),
    [anon_sym_alignas] = ACTIONS(5366),
    [anon_sym__Alignas] = ACTIONS(5366),
    [anon_sym_asm] = ACTIONS(5366),
    [anon_sym___asm__] = ACTIONS(5366),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5366),
    [anon_sym_decltype] = ACTIONS(5366),
    [anon_sym_final] = ACTIONS(5366),
    [anon_sym_override] = ACTIONS(5366),
    [sym_virtual] = ACTIONS(5366),
    [anon_sym_template] = ACTIONS(5366),
    [anon_sym_GT2] = ACTIONS(5368),
    [anon_sym_operator] = ACTIONS(5366),
    [anon_sym_try] = ACTIONS(5366),
    [anon_sym_requires] = ACTIONS(5366),
    [anon_sym___launch_bounds__] = ACTIONS(5366),
  },
  [2185] = {
    [sym_identifier] = ACTIONS(5340),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5342),
    [anon_sym_COMMA] = ACTIONS(5342),
    [anon_sym_RPAREN] = ACTIONS(5342),
    [anon_sym_LPAREN2] = ACTIONS(5342),
    [anon_sym_TILDE] = ACTIONS(5342),
    [anon_sym_STAR] = ACTIONS(5342),
    [anon_sym_AMP_AMP] = ACTIONS(5342),
    [anon_sym_AMP] = ACTIONS(5340),
    [anon_sym_SEMI] = ACTIONS(5342),
    [anon_sym___extension__] = ACTIONS(5340),
    [anon_sym___device__] = ACTIONS(5340),
    [anon_sym___host__] = ACTIONS(5340),
    [anon_sym___global__] = ACTIONS(5340),
    [anon_sym___forceinline__] = ACTIONS(5340),
    [anon_sym___noinline__] = ACTIONS(5340),
    [anon_sym_extern] = ACTIONS(5340),
    [anon_sym___attribute__] = ACTIONS(5340),
    [anon_sym_COLON_COLON] = ACTIONS(5342),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5342),
    [anon_sym___declspec] = ACTIONS(5340),
    [anon_sym___based] = ACTIONS(5340),
    [anon_sym___cdecl] = ACTIONS(5340),
    [anon_sym___clrcall] = ACTIONS(5340),
    [anon_sym___stdcall] = ACTIONS(5340),
    [anon_sym___fastcall] = ACTIONS(5340),
    [anon_sym___thiscall] = ACTIONS(5340),
    [anon_sym___vectorcall] = ACTIONS(5340),
    [anon_sym_LBRACE] = ACTIONS(5342),
    [anon_sym_LBRACK] = ACTIONS(5340),
    [anon_sym_static] = ACTIONS(5340),
    [anon_sym_EQ] = ACTIONS(5342),
    [anon_sym_register] = ACTIONS(5340),
    [anon_sym_inline] = ACTIONS(5340),
    [anon_sym___inline] = ACTIONS(5340),
    [anon_sym___inline__] = ACTIONS(5340),
    [anon_sym___forceinline] = ACTIONS(5340),
    [anon_sym_thread_local] = ACTIONS(5340),
    [anon_sym___thread] = ACTIONS(5340),
    [anon_sym_const] = ACTIONS(5340),
    [anon_sym_constexpr] = ACTIONS(5340),
    [anon_sym_volatile] = ACTIONS(5340),
    [anon_sym_restrict] = ACTIONS(5340),
    [anon_sym___restrict__] = ACTIONS(5340),
    [anon_sym__Atomic] = ACTIONS(5340),
    [anon_sym__Noreturn] = ACTIONS(5340),
    [anon_sym_noreturn] = ACTIONS(5340),
    [anon_sym_mutable] = ACTIONS(5340),
    [anon_sym_constinit] = ACTIONS(5340),
    [anon_sym_consteval] = ACTIONS(5340),
    [anon_sym___shared__] = ACTIONS(5340),
    [anon_sym___local__] = ACTIONS(5340),
    [anon_sym___constant__] = ACTIONS(5340),
    [anon_sym___managed__] = ACTIONS(5340),
    [anon_sym___grid_constant__] = ACTIONS(5340),
    [anon_sym_alignas] = ACTIONS(5340),
    [anon_sym__Alignas] = ACTIONS(5340),
    [anon_sym_asm] = ACTIONS(5340),
    [anon_sym___asm__] = ACTIONS(5340),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5340),
    [anon_sym_decltype] = ACTIONS(5340),
    [anon_sym_final] = ACTIONS(5340),
    [anon_sym_override] = ACTIONS(5340),
    [sym_virtual] = ACTIONS(5340),
    [anon_sym_template] = ACTIONS(5340),
    [anon_sym_GT2] = ACTIONS(5342),
    [anon_sym_operator] = ACTIONS(5340),
    [anon_sym_try] = ACTIONS(5340),
    [anon_sym_requires] = ACTIONS(5340),
    [anon_sym___launch_bounds__] = ACTIONS(5340),
  },
  [2186] = {
    [sym_attribute_specifier] = STATE(2095),
    [sym_enumerator_list] = STATE(2222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5610),
    [anon_sym_COMMA] = ACTIONS(5610),
    [anon_sym_RPAREN] = ACTIONS(5610),
    [anon_sym_LPAREN2] = ACTIONS(5610),
    [anon_sym_DASH] = ACTIONS(5612),
    [anon_sym_PLUS] = ACTIONS(5612),
    [anon_sym_STAR] = ACTIONS(5610),
    [anon_sym_SLASH] = ACTIONS(5612),
    [anon_sym_PERCENT] = ACTIONS(5610),
    [anon_sym_PIPE_PIPE] = ACTIONS(5610),
    [anon_sym_AMP_AMP] = ACTIONS(5610),
    [anon_sym_PIPE] = ACTIONS(5612),
    [anon_sym_CARET] = ACTIONS(5610),
    [anon_sym_AMP] = ACTIONS(5612),
    [anon_sym_EQ_EQ] = ACTIONS(5610),
    [anon_sym_BANG_EQ] = ACTIONS(5610),
    [anon_sym_GT] = ACTIONS(5612),
    [anon_sym_GT_EQ] = ACTIONS(5610),
    [anon_sym_LT_EQ] = ACTIONS(5612),
    [anon_sym_LT] = ACTIONS(5612),
    [anon_sym_LT_LT] = ACTIONS(5612),
    [anon_sym_GT_GT] = ACTIONS(5610),
    [anon_sym_SEMI] = ACTIONS(5610),
    [anon_sym___extension__] = ACTIONS(5610),
    [anon_sym___global__] = ACTIONS(5610),
    [anon_sym___attribute__] = ACTIONS(5510),
    [anon_sym_LBRACE] = ACTIONS(5601),
    [anon_sym_RBRACE] = ACTIONS(5610),
    [anon_sym_LBRACK] = ACTIONS(5610),
    [anon_sym_RBRACK] = ACTIONS(5610),
    [anon_sym_const] = ACTIONS(5612),
    [anon_sym_constexpr] = ACTIONS(5610),
    [anon_sym_volatile] = ACTIONS(5610),
    [anon_sym_restrict] = ACTIONS(5610),
    [anon_sym___restrict__] = ACTIONS(5610),
    [anon_sym__Atomic] = ACTIONS(5610),
    [anon_sym__Noreturn] = ACTIONS(5610),
    [anon_sym_noreturn] = ACTIONS(5610),
    [anon_sym_mutable] = ACTIONS(5610),
    [anon_sym_constinit] = ACTIONS(5610),
    [anon_sym_consteval] = ACTIONS(5610),
    [anon_sym___shared__] = ACTIONS(5610),
    [anon_sym___local__] = ACTIONS(5610),
    [anon_sym___constant__] = ACTIONS(5610),
    [anon_sym___managed__] = ACTIONS(5610),
    [anon_sym___grid_constant__] = ACTIONS(5610),
    [anon_sym_alignas] = ACTIONS(5610),
    [anon_sym__Alignas] = ACTIONS(5610),
    [anon_sym_COLON] = ACTIONS(5610),
    [anon_sym_QMARK] = ACTIONS(5610),
    [anon_sym_LT_EQ_GT] = ACTIONS(5610),
    [anon_sym_or] = ACTIONS(5610),
    [anon_sym_and] = ACTIONS(5610),
    [anon_sym_bitor] = ACTIONS(5610),
    [anon_sym_xor] = ACTIONS(5610),
    [anon_sym_bitand] = ACTIONS(5610),
    [anon_sym_not_eq] = ACTIONS(5610),
    [anon_sym_DASH_DASH] = ACTIONS(5610),
    [anon_sym_PLUS_PLUS] = ACTIONS(5610),
    [anon_sym_DOT] = ACTIONS(5612),
    [anon_sym_DOT_STAR] = ACTIONS(5610),
    [anon_sym_DASH_GT] = ACTIONS(5610),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5610),
    [anon_sym_decltype] = ACTIONS(5610),
    [anon_sym_final] = ACTIONS(5610),
    [anon_sym_override] = ACTIONS(5610),
    [anon_sym_requires] = ACTIONS(5610),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5610),
  },
  [2187] = {
    [sym_identifier] = ACTIONS(5362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5364),
    [anon_sym_COMMA] = ACTIONS(5364),
    [anon_sym_RPAREN] = ACTIONS(5364),
    [anon_sym_LPAREN2] = ACTIONS(5364),
    [anon_sym_TILDE] = ACTIONS(5364),
    [anon_sym_STAR] = ACTIONS(5364),
    [anon_sym_AMP_AMP] = ACTIONS(5364),
    [anon_sym_AMP] = ACTIONS(5362),
    [anon_sym_SEMI] = ACTIONS(5364),
    [anon_sym___extension__] = ACTIONS(5362),
    [anon_sym___device__] = ACTIONS(5362),
    [anon_sym___host__] = ACTIONS(5362),
    [anon_sym___global__] = ACTIONS(5362),
    [anon_sym___forceinline__] = ACTIONS(5362),
    [anon_sym___noinline__] = ACTIONS(5362),
    [anon_sym_extern] = ACTIONS(5362),
    [anon_sym___attribute__] = ACTIONS(5362),
    [anon_sym_COLON_COLON] = ACTIONS(5364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5364),
    [anon_sym___declspec] = ACTIONS(5362),
    [anon_sym___based] = ACTIONS(5362),
    [anon_sym___cdecl] = ACTIONS(5362),
    [anon_sym___clrcall] = ACTIONS(5362),
    [anon_sym___stdcall] = ACTIONS(5362),
    [anon_sym___fastcall] = ACTIONS(5362),
    [anon_sym___thiscall] = ACTIONS(5362),
    [anon_sym___vectorcall] = ACTIONS(5362),
    [anon_sym_LBRACE] = ACTIONS(5364),
    [anon_sym_LBRACK] = ACTIONS(5362),
    [anon_sym_static] = ACTIONS(5362),
    [anon_sym_EQ] = ACTIONS(5364),
    [anon_sym_register] = ACTIONS(5362),
    [anon_sym_inline] = ACTIONS(5362),
    [anon_sym___inline] = ACTIONS(5362),
    [anon_sym___inline__] = ACTIONS(5362),
    [anon_sym___forceinline] = ACTIONS(5362),
    [anon_sym_thread_local] = ACTIONS(5362),
    [anon_sym___thread] = ACTIONS(5362),
    [anon_sym_const] = ACTIONS(5362),
    [anon_sym_constexpr] = ACTIONS(5362),
    [anon_sym_volatile] = ACTIONS(5362),
    [anon_sym_restrict] = ACTIONS(5362),
    [anon_sym___restrict__] = ACTIONS(5362),
    [anon_sym__Atomic] = ACTIONS(5362),
    [anon_sym__Noreturn] = ACTIONS(5362),
    [anon_sym_noreturn] = ACTIONS(5362),
    [anon_sym_mutable] = ACTIONS(5362),
    [anon_sym_constinit] = ACTIONS(5362),
    [anon_sym_consteval] = ACTIONS(5362),
    [anon_sym___shared__] = ACTIONS(5362),
    [anon_sym___local__] = ACTIONS(5362),
    [anon_sym___constant__] = ACTIONS(5362),
    [anon_sym___managed__] = ACTIONS(5362),
    [anon_sym___grid_constant__] = ACTIONS(5362),
    [anon_sym_alignas] = ACTIONS(5362),
    [anon_sym__Alignas] = ACTIONS(5362),
    [anon_sym_asm] = ACTIONS(5362),
    [anon_sym___asm__] = ACTIONS(5362),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5362),
    [anon_sym_decltype] = ACTIONS(5362),
    [anon_sym_final] = ACTIONS(5362),
    [anon_sym_override] = ACTIONS(5362),
    [sym_virtual] = ACTIONS(5362),
    [anon_sym_template] = ACTIONS(5362),
    [anon_sym_GT2] = ACTIONS(5364),
    [anon_sym_operator] = ACTIONS(5362),
    [anon_sym_try] = ACTIONS(5362),
    [anon_sym_requires] = ACTIONS(5362),
    [anon_sym___launch_bounds__] = ACTIONS(5362),
  },
  [2188] = {
    [sym_identifier] = ACTIONS(5234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5236),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_RPAREN] = ACTIONS(5236),
    [anon_sym_LPAREN2] = ACTIONS(5236),
    [anon_sym_TILDE] = ACTIONS(5236),
    [anon_sym_STAR] = ACTIONS(5236),
    [anon_sym_AMP_AMP] = ACTIONS(5236),
    [anon_sym_AMP] = ACTIONS(5234),
    [anon_sym_SEMI] = ACTIONS(5236),
    [anon_sym___extension__] = ACTIONS(5234),
    [anon_sym___device__] = ACTIONS(5234),
    [anon_sym___host__] = ACTIONS(5234),
    [anon_sym___global__] = ACTIONS(5234),
    [anon_sym___forceinline__] = ACTIONS(5234),
    [anon_sym___noinline__] = ACTIONS(5234),
    [anon_sym_extern] = ACTIONS(5234),
    [anon_sym___attribute__] = ACTIONS(5234),
    [anon_sym_COLON_COLON] = ACTIONS(5236),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5236),
    [anon_sym___declspec] = ACTIONS(5234),
    [anon_sym___based] = ACTIONS(5234),
    [anon_sym___cdecl] = ACTIONS(5234),
    [anon_sym___clrcall] = ACTIONS(5234),
    [anon_sym___stdcall] = ACTIONS(5234),
    [anon_sym___fastcall] = ACTIONS(5234),
    [anon_sym___thiscall] = ACTIONS(5234),
    [anon_sym___vectorcall] = ACTIONS(5234),
    [anon_sym_LBRACE] = ACTIONS(5236),
    [anon_sym_LBRACK] = ACTIONS(5234),
    [anon_sym_static] = ACTIONS(5234),
    [anon_sym_EQ] = ACTIONS(5236),
    [anon_sym_register] = ACTIONS(5234),
    [anon_sym_inline] = ACTIONS(5234),
    [anon_sym___inline] = ACTIONS(5234),
    [anon_sym___inline__] = ACTIONS(5234),
    [anon_sym___forceinline] = ACTIONS(5234),
    [anon_sym_thread_local] = ACTIONS(5234),
    [anon_sym___thread] = ACTIONS(5234),
    [anon_sym_const] = ACTIONS(5234),
    [anon_sym_constexpr] = ACTIONS(5234),
    [anon_sym_volatile] = ACTIONS(5234),
    [anon_sym_restrict] = ACTIONS(5234),
    [anon_sym___restrict__] = ACTIONS(5234),
    [anon_sym__Atomic] = ACTIONS(5234),
    [anon_sym__Noreturn] = ACTIONS(5234),
    [anon_sym_noreturn] = ACTIONS(5234),
    [anon_sym_mutable] = ACTIONS(5234),
    [anon_sym_constinit] = ACTIONS(5234),
    [anon_sym_consteval] = ACTIONS(5234),
    [anon_sym___shared__] = ACTIONS(5234),
    [anon_sym___local__] = ACTIONS(5234),
    [anon_sym___constant__] = ACTIONS(5234),
    [anon_sym___managed__] = ACTIONS(5234),
    [anon_sym___grid_constant__] = ACTIONS(5234),
    [anon_sym_alignas] = ACTIONS(5234),
    [anon_sym__Alignas] = ACTIONS(5234),
    [anon_sym_asm] = ACTIONS(5234),
    [anon_sym___asm__] = ACTIONS(5234),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5234),
    [anon_sym_decltype] = ACTIONS(5234),
    [anon_sym_final] = ACTIONS(5234),
    [anon_sym_override] = ACTIONS(5234),
    [sym_virtual] = ACTIONS(5234),
    [anon_sym_template] = ACTIONS(5234),
    [anon_sym_GT2] = ACTIONS(5236),
    [anon_sym_operator] = ACTIONS(5234),
    [anon_sym_try] = ACTIONS(5234),
    [anon_sym_requires] = ACTIONS(5234),
    [anon_sym___launch_bounds__] = ACTIONS(5234),
  },
  [2189] = {
    [sym_identifier] = ACTIONS(5246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5248),
    [anon_sym_COMMA] = ACTIONS(5248),
    [anon_sym_RPAREN] = ACTIONS(5248),
    [anon_sym_LPAREN2] = ACTIONS(5248),
    [anon_sym_TILDE] = ACTIONS(5248),
    [anon_sym_STAR] = ACTIONS(5248),
    [anon_sym_AMP_AMP] = ACTIONS(5248),
    [anon_sym_AMP] = ACTIONS(5246),
    [anon_sym_SEMI] = ACTIONS(5248),
    [anon_sym___extension__] = ACTIONS(5246),
    [anon_sym___device__] = ACTIONS(5246),
    [anon_sym___host__] = ACTIONS(5246),
    [anon_sym___global__] = ACTIONS(5246),
    [anon_sym___forceinline__] = ACTIONS(5246),
    [anon_sym___noinline__] = ACTIONS(5246),
    [anon_sym_extern] = ACTIONS(5246),
    [anon_sym___attribute__] = ACTIONS(5246),
    [anon_sym_COLON_COLON] = ACTIONS(5248),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5248),
    [anon_sym___declspec] = ACTIONS(5246),
    [anon_sym___based] = ACTIONS(5246),
    [anon_sym___cdecl] = ACTIONS(5246),
    [anon_sym___clrcall] = ACTIONS(5246),
    [anon_sym___stdcall] = ACTIONS(5246),
    [anon_sym___fastcall] = ACTIONS(5246),
    [anon_sym___thiscall] = ACTIONS(5246),
    [anon_sym___vectorcall] = ACTIONS(5246),
    [anon_sym_LBRACE] = ACTIONS(5248),
    [anon_sym_LBRACK] = ACTIONS(5246),
    [anon_sym_static] = ACTIONS(5246),
    [anon_sym_EQ] = ACTIONS(5248),
    [anon_sym_register] = ACTIONS(5246),
    [anon_sym_inline] = ACTIONS(5246),
    [anon_sym___inline] = ACTIONS(5246),
    [anon_sym___inline__] = ACTIONS(5246),
    [anon_sym___forceinline] = ACTIONS(5246),
    [anon_sym_thread_local] = ACTIONS(5246),
    [anon_sym___thread] = ACTIONS(5246),
    [anon_sym_const] = ACTIONS(5246),
    [anon_sym_constexpr] = ACTIONS(5246),
    [anon_sym_volatile] = ACTIONS(5246),
    [anon_sym_restrict] = ACTIONS(5246),
    [anon_sym___restrict__] = ACTIONS(5246),
    [anon_sym__Atomic] = ACTIONS(5246),
    [anon_sym__Noreturn] = ACTIONS(5246),
    [anon_sym_noreturn] = ACTIONS(5246),
    [anon_sym_mutable] = ACTIONS(5246),
    [anon_sym_constinit] = ACTIONS(5246),
    [anon_sym_consteval] = ACTIONS(5246),
    [anon_sym___shared__] = ACTIONS(5246),
    [anon_sym___local__] = ACTIONS(5246),
    [anon_sym___constant__] = ACTIONS(5246),
    [anon_sym___managed__] = ACTIONS(5246),
    [anon_sym___grid_constant__] = ACTIONS(5246),
    [anon_sym_alignas] = ACTIONS(5246),
    [anon_sym__Alignas] = ACTIONS(5246),
    [anon_sym_asm] = ACTIONS(5246),
    [anon_sym___asm__] = ACTIONS(5246),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5246),
    [anon_sym_decltype] = ACTIONS(5246),
    [anon_sym_final] = ACTIONS(5246),
    [anon_sym_override] = ACTIONS(5246),
    [sym_virtual] = ACTIONS(5246),
    [anon_sym_template] = ACTIONS(5246),
    [anon_sym_GT2] = ACTIONS(5248),
    [anon_sym_operator] = ACTIONS(5246),
    [anon_sym_try] = ACTIONS(5246),
    [anon_sym_requires] = ACTIONS(5246),
    [anon_sym___launch_bounds__] = ACTIONS(5246),
  },
  [2190] = {
    [sym_ms_based_modifier] = STATE(8387),
    [sym_ms_unaligned_ptr_modifier] = STATE(4253),
    [sym_ms_pointer_modifier] = STATE(2165),
    [sym__declarator] = STATE(6643),
    [sym__abstract_declarator] = STATE(6946),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_abstract_parenthesized_declarator] = STATE(6430),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_abstract_pointer_declarator] = STATE(6430),
    [sym_function_declarator] = STATE(6598),
    [sym_abstract_function_declarator] = STATE(6430),
    [sym_array_declarator] = STATE(6598),
    [sym_abstract_array_declarator] = STATE(6430),
    [sym_type_qualifier] = STATE(2740),
    [sym_alignas_qualifier] = STATE(4511),
    [sym_parameter_list] = STATE(3079),
    [sym_decltype] = STATE(8628),
    [sym_reference_declarator] = STATE(6598),
    [sym_abstract_reference_declarator] = STATE(6430),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym__function_declarator_seq] = STATE(6416),
    [sym_template_type] = STATE(8628),
    [sym_template_function] = STATE(6598),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6059),
    [sym_qualified_identifier] = STATE(6598),
    [sym_operator_name] = STATE(6598),
    [aux_sym__type_definition_type_repeat1] = STATE(2740),
    [aux_sym_pointer_declarator_repeat1] = STATE(2165),
    [sym_identifier] = ACTIONS(5482),
    [anon_sym_COMMA] = ACTIONS(5484),
    [anon_sym_LPAREN2] = ACTIONS(3957),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(5591),
    [anon_sym_AMP_AMP] = ACTIONS(5593),
    [anon_sym_AMP] = ACTIONS(5595),
    [anon_sym___extension__] = ACTIONS(3171),
    [anon_sym___global__] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(5492),
    [anon_sym___based] = ACTIONS(49),
    [sym_ms_restrict_modifier] = ACTIONS(3173),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3173),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3173),
    [anon_sym__unaligned] = ACTIONS(3175),
    [anon_sym___unaligned] = ACTIONS(3175),
    [anon_sym_LBRACK] = ACTIONS(5494),
    [anon_sym_const] = ACTIONS(3171),
    [anon_sym_constexpr] = ACTIONS(3171),
    [anon_sym_volatile] = ACTIONS(3171),
    [anon_sym_restrict] = ACTIONS(3171),
    [anon_sym___restrict__] = ACTIONS(3171),
    [anon_sym__Atomic] = ACTIONS(3171),
    [anon_sym__Noreturn] = ACTIONS(3171),
    [anon_sym_noreturn] = ACTIONS(3171),
    [anon_sym_mutable] = ACTIONS(3171),
    [anon_sym_constinit] = ACTIONS(3171),
    [anon_sym_consteval] = ACTIONS(3171),
    [anon_sym___shared__] = ACTIONS(3171),
    [anon_sym___local__] = ACTIONS(3171),
    [anon_sym___constant__] = ACTIONS(3171),
    [anon_sym___managed__] = ACTIONS(3171),
    [anon_sym___grid_constant__] = ACTIONS(3171),
    [anon_sym_alignas] = ACTIONS(3177),
    [anon_sym__Alignas] = ACTIONS(3177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_GT2] = ACTIONS(5484),
    [anon_sym_operator] = ACTIONS(1883),
  },
  [2191] = {
    [sym_identifier] = ACTIONS(5315),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5317),
    [anon_sym_COMMA] = ACTIONS(5317),
    [anon_sym_RPAREN] = ACTIONS(5317),
    [anon_sym_LPAREN2] = ACTIONS(5317),
    [anon_sym_TILDE] = ACTIONS(5317),
    [anon_sym_STAR] = ACTIONS(5317),
    [anon_sym_AMP_AMP] = ACTIONS(5317),
    [anon_sym_AMP] = ACTIONS(5315),
    [anon_sym_SEMI] = ACTIONS(5317),
    [anon_sym___extension__] = ACTIONS(5315),
    [anon_sym___device__] = ACTIONS(5315),
    [anon_sym___host__] = ACTIONS(5315),
    [anon_sym___global__] = ACTIONS(5315),
    [anon_sym___forceinline__] = ACTIONS(5315),
    [anon_sym___noinline__] = ACTIONS(5315),
    [anon_sym_extern] = ACTIONS(5315),
    [anon_sym___attribute__] = ACTIONS(5315),
    [anon_sym_COLON_COLON] = ACTIONS(5317),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5317),
    [anon_sym___declspec] = ACTIONS(5315),
    [anon_sym___based] = ACTIONS(5315),
    [anon_sym___cdecl] = ACTIONS(5315),
    [anon_sym___clrcall] = ACTIONS(5315),
    [anon_sym___stdcall] = ACTIONS(5315),
    [anon_sym___fastcall] = ACTIONS(5315),
    [anon_sym___thiscall] = ACTIONS(5315),
    [anon_sym___vectorcall] = ACTIONS(5315),
    [anon_sym_LBRACE] = ACTIONS(5317),
    [anon_sym_LBRACK] = ACTIONS(5315),
    [anon_sym_static] = ACTIONS(5315),
    [anon_sym_EQ] = ACTIONS(5317),
    [anon_sym_register] = ACTIONS(5315),
    [anon_sym_inline] = ACTIONS(5315),
    [anon_sym___inline] = ACTIONS(5315),
    [anon_sym___inline__] = ACTIONS(5315),
    [anon_sym___forceinline] = ACTIONS(5315),
    [anon_sym_thread_local] = ACTIONS(5315),
    [anon_sym___thread] = ACTIONS(5315),
    [anon_sym_const] = ACTIONS(5315),
    [anon_sym_constexpr] = ACTIONS(5315),
    [anon_sym_volatile] = ACTIONS(5315),
    [anon_sym_restrict] = ACTIONS(5315),
    [anon_sym___restrict__] = ACTIONS(5315),
    [anon_sym__Atomic] = ACTIONS(5315),
    [anon_sym__Noreturn] = ACTIONS(5315),
    [anon_sym_noreturn] = ACTIONS(5315),
    [anon_sym_mutable] = ACTIONS(5315),
    [anon_sym_constinit] = ACTIONS(5315),
    [anon_sym_consteval] = ACTIONS(5315),
    [anon_sym___shared__] = ACTIONS(5315),
    [anon_sym___local__] = ACTIONS(5315),
    [anon_sym___constant__] = ACTIONS(5315),
    [anon_sym___managed__] = ACTIONS(5315),
    [anon_sym___grid_constant__] = ACTIONS(5315),
    [anon_sym_alignas] = ACTIONS(5315),
    [anon_sym__Alignas] = ACTIONS(5315),
    [anon_sym_asm] = ACTIONS(5315),
    [anon_sym___asm__] = ACTIONS(5315),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5315),
    [anon_sym_decltype] = ACTIONS(5315),
    [anon_sym_final] = ACTIONS(5315),
    [anon_sym_override] = ACTIONS(5315),
    [sym_virtual] = ACTIONS(5315),
    [anon_sym_template] = ACTIONS(5315),
    [anon_sym_GT2] = ACTIONS(5317),
    [anon_sym_operator] = ACTIONS(5315),
    [anon_sym_try] = ACTIONS(5315),
    [anon_sym_requires] = ACTIONS(5315),
    [anon_sym___launch_bounds__] = ACTIONS(5315),
  },
  [2192] = {
    [sym_identifier] = ACTIONS(5297),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5299),
    [anon_sym_COMMA] = ACTIONS(5299),
    [anon_sym_RPAREN] = ACTIONS(5299),
    [anon_sym_LPAREN2] = ACTIONS(5299),
    [anon_sym_TILDE] = ACTIONS(5299),
    [anon_sym_STAR] = ACTIONS(5299),
    [anon_sym_AMP_AMP] = ACTIONS(5299),
    [anon_sym_AMP] = ACTIONS(5297),
    [anon_sym_SEMI] = ACTIONS(5299),
    [anon_sym___extension__] = ACTIONS(5297),
    [anon_sym___device__] = ACTIONS(5297),
    [anon_sym___host__] = ACTIONS(5297),
    [anon_sym___global__] = ACTIONS(5297),
    [anon_sym___forceinline__] = ACTIONS(5297),
    [anon_sym___noinline__] = ACTIONS(5297),
    [anon_sym_extern] = ACTIONS(5297),
    [anon_sym___attribute__] = ACTIONS(5297),
    [anon_sym_COLON_COLON] = ACTIONS(5299),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5299),
    [anon_sym___declspec] = ACTIONS(5297),
    [anon_sym___based] = ACTIONS(5297),
    [anon_sym___cdecl] = ACTIONS(5297),
    [anon_sym___clrcall] = ACTIONS(5297),
    [anon_sym___stdcall] = ACTIONS(5297),
    [anon_sym___fastcall] = ACTIONS(5297),
    [anon_sym___thiscall] = ACTIONS(5297),
    [anon_sym___vectorcall] = ACTIONS(5297),
    [anon_sym_LBRACE] = ACTIONS(5299),
    [anon_sym_LBRACK] = ACTIONS(5297),
    [anon_sym_static] = ACTIONS(5297),
    [anon_sym_EQ] = ACTIONS(5299),
    [anon_sym_register] = ACTIONS(5297),
    [anon_sym_inline] = ACTIONS(5297),
    [anon_sym___inline] = ACTIONS(5297),
    [anon_sym___inline__] = ACTIONS(5297),
    [anon_sym___forceinline] = ACTIONS(5297),
    [anon_sym_thread_local] = ACTIONS(5297),
    [anon_sym___thread] = ACTIONS(5297),
    [anon_sym_const] = ACTIONS(5297),
    [anon_sym_constexpr] = ACTIONS(5297),
    [anon_sym_volatile] = ACTIONS(5297),
    [anon_sym_restrict] = ACTIONS(5297),
    [anon_sym___restrict__] = ACTIONS(5297),
    [anon_sym__Atomic] = ACTIONS(5297),
    [anon_sym__Noreturn] = ACTIONS(5297),
    [anon_sym_noreturn] = ACTIONS(5297),
    [anon_sym_mutable] = ACTIONS(5297),
    [anon_sym_constinit] = ACTIONS(5297),
    [anon_sym_consteval] = ACTIONS(5297),
    [anon_sym___shared__] = ACTIONS(5297),
    [anon_sym___local__] = ACTIONS(5297),
    [anon_sym___constant__] = ACTIONS(5297),
    [anon_sym___managed__] = ACTIONS(5297),
    [anon_sym___grid_constant__] = ACTIONS(5297),
    [anon_sym_alignas] = ACTIONS(5297),
    [anon_sym__Alignas] = ACTIONS(5297),
    [anon_sym_asm] = ACTIONS(5297),
    [anon_sym___asm__] = ACTIONS(5297),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5297),
    [anon_sym_decltype] = ACTIONS(5297),
    [anon_sym_final] = ACTIONS(5297),
    [anon_sym_override] = ACTIONS(5297),
    [sym_virtual] = ACTIONS(5297),
    [anon_sym_template] = ACTIONS(5297),
    [anon_sym_GT2] = ACTIONS(5299),
    [anon_sym_operator] = ACTIONS(5297),
    [anon_sym_try] = ACTIONS(5297),
    [anon_sym_requires] = ACTIONS(5297),
    [anon_sym___launch_bounds__] = ACTIONS(5297),
  },
  [2193] = {
    [sym_identifier] = ACTIONS(5218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5220),
    [anon_sym_COMMA] = ACTIONS(5220),
    [anon_sym_RPAREN] = ACTIONS(5220),
    [anon_sym_LPAREN2] = ACTIONS(5220),
    [anon_sym_TILDE] = ACTIONS(5220),
    [anon_sym_STAR] = ACTIONS(5220),
    [anon_sym_AMP_AMP] = ACTIONS(5220),
    [anon_sym_AMP] = ACTIONS(5218),
    [anon_sym_SEMI] = ACTIONS(5220),
    [anon_sym___extension__] = ACTIONS(5218),
    [anon_sym___device__] = ACTIONS(5218),
    [anon_sym___host__] = ACTIONS(5218),
    [anon_sym___global__] = ACTIONS(5218),
    [anon_sym___forceinline__] = ACTIONS(5218),
    [anon_sym___noinline__] = ACTIONS(5218),
    [anon_sym_extern] = ACTIONS(5218),
    [anon_sym___attribute__] = ACTIONS(5218),
    [anon_sym_COLON_COLON] = ACTIONS(5220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5220),
    [anon_sym___declspec] = ACTIONS(5218),
    [anon_sym___based] = ACTIONS(5218),
    [anon_sym___cdecl] = ACTIONS(5218),
    [anon_sym___clrcall] = ACTIONS(5218),
    [anon_sym___stdcall] = ACTIONS(5218),
    [anon_sym___fastcall] = ACTIONS(5218),
    [anon_sym___thiscall] = ACTIONS(5218),
    [anon_sym___vectorcall] = ACTIONS(5218),
    [anon_sym_LBRACE] = ACTIONS(5220),
    [anon_sym_LBRACK] = ACTIONS(5218),
    [anon_sym_static] = ACTIONS(5218),
    [anon_sym_EQ] = ACTIONS(5220),
    [anon_sym_register] = ACTIONS(5218),
    [anon_sym_inline] = ACTIONS(5218),
    [anon_sym___inline] = ACTIONS(5218),
    [anon_sym___inline__] = ACTIONS(5218),
    [anon_sym___forceinline] = ACTIONS(5218),
    [anon_sym_thread_local] = ACTIONS(5218),
    [anon_sym___thread] = ACTIONS(5218),
    [anon_sym_const] = ACTIONS(5218),
    [anon_sym_constexpr] = ACTIONS(5218),
    [anon_sym_volatile] = ACTIONS(5218),
    [anon_sym_restrict] = ACTIONS(5218),
    [anon_sym___restrict__] = ACTIONS(5218),
    [anon_sym__Atomic] = ACTIONS(5218),
    [anon_sym__Noreturn] = ACTIONS(5218),
    [anon_sym_noreturn] = ACTIONS(5218),
    [anon_sym_mutable] = ACTIONS(5218),
    [anon_sym_constinit] = ACTIONS(5218),
    [anon_sym_consteval] = ACTIONS(5218),
    [anon_sym___shared__] = ACTIONS(5218),
    [anon_sym___local__] = ACTIONS(5218),
    [anon_sym___constant__] = ACTIONS(5218),
    [anon_sym___managed__] = ACTIONS(5218),
    [anon_sym___grid_constant__] = ACTIONS(5218),
    [anon_sym_alignas] = ACTIONS(5218),
    [anon_sym__Alignas] = ACTIONS(5218),
    [anon_sym_asm] = ACTIONS(5218),
    [anon_sym___asm__] = ACTIONS(5218),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5218),
    [anon_sym_decltype] = ACTIONS(5218),
    [anon_sym_final] = ACTIONS(5218),
    [anon_sym_override] = ACTIONS(5218),
    [sym_virtual] = ACTIONS(5218),
    [anon_sym_template] = ACTIONS(5218),
    [anon_sym_GT2] = ACTIONS(5220),
    [anon_sym_operator] = ACTIONS(5218),
    [anon_sym_try] = ACTIONS(5218),
    [anon_sym_requires] = ACTIONS(5218),
    [anon_sym___launch_bounds__] = ACTIONS(5218),
  },
  [2194] = {
    [sym_identifier] = ACTIONS(5301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5303),
    [anon_sym_COMMA] = ACTIONS(5303),
    [anon_sym_RPAREN] = ACTIONS(5303),
    [anon_sym_LPAREN2] = ACTIONS(5303),
    [anon_sym_TILDE] = ACTIONS(5303),
    [anon_sym_STAR] = ACTIONS(5303),
    [anon_sym_AMP_AMP] = ACTIONS(5303),
    [anon_sym_AMP] = ACTIONS(5301),
    [anon_sym_SEMI] = ACTIONS(5303),
    [anon_sym___extension__] = ACTIONS(5301),
    [anon_sym___device__] = ACTIONS(5301),
    [anon_sym___host__] = ACTIONS(5301),
    [anon_sym___global__] = ACTIONS(5301),
    [anon_sym___forceinline__] = ACTIONS(5301),
    [anon_sym___noinline__] = ACTIONS(5301),
    [anon_sym_extern] = ACTIONS(5301),
    [anon_sym___attribute__] = ACTIONS(5301),
    [anon_sym_COLON_COLON] = ACTIONS(5303),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5303),
    [anon_sym___declspec] = ACTIONS(5301),
    [anon_sym___based] = ACTIONS(5301),
    [anon_sym___cdecl] = ACTIONS(5301),
    [anon_sym___clrcall] = ACTIONS(5301),
    [anon_sym___stdcall] = ACTIONS(5301),
    [anon_sym___fastcall] = ACTIONS(5301),
    [anon_sym___thiscall] = ACTIONS(5301),
    [anon_sym___vectorcall] = ACTIONS(5301),
    [anon_sym_LBRACE] = ACTIONS(5303),
    [anon_sym_LBRACK] = ACTIONS(5301),
    [anon_sym_static] = ACTIONS(5301),
    [anon_sym_EQ] = ACTIONS(5303),
    [anon_sym_register] = ACTIONS(5301),
    [anon_sym_inline] = ACTIONS(5301),
    [anon_sym___inline] = ACTIONS(5301),
    [anon_sym___inline__] = ACTIONS(5301),
    [anon_sym___forceinline] = ACTIONS(5301),
    [anon_sym_thread_local] = ACTIONS(5301),
    [anon_sym___thread] = ACTIONS(5301),
    [anon_sym_const] = ACTIONS(5301),
    [anon_sym_constexpr] = ACTIONS(5301),
    [anon_sym_volatile] = ACTIONS(5301),
    [anon_sym_restrict] = ACTIONS(5301),
    [anon_sym___restrict__] = ACTIONS(5301),
    [anon_sym__Atomic] = ACTIONS(5301),
    [anon_sym__Noreturn] = ACTIONS(5301),
    [anon_sym_noreturn] = ACTIONS(5301),
    [anon_sym_mutable] = ACTIONS(5301),
    [anon_sym_constinit] = ACTIONS(5301),
    [anon_sym_consteval] = ACTIONS(5301),
    [anon_sym___shared__] = ACTIONS(5301),
    [anon_sym___local__] = ACTIONS(5301),
    [anon_sym___constant__] = ACTIONS(5301),
    [anon_sym___managed__] = ACTIONS(5301),
    [anon_sym___grid_constant__] = ACTIONS(5301),
    [anon_sym_alignas] = ACTIONS(5301),
    [anon_sym__Alignas] = ACTIONS(5301),
    [anon_sym_asm] = ACTIONS(5301),
    [anon_sym___asm__] = ACTIONS(5301),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5301),
    [anon_sym_decltype] = ACTIONS(5301),
    [anon_sym_final] = ACTIONS(5301),
    [anon_sym_override] = ACTIONS(5301),
    [sym_virtual] = ACTIONS(5301),
    [anon_sym_template] = ACTIONS(5301),
    [anon_sym_GT2] = ACTIONS(5303),
    [anon_sym_operator] = ACTIONS(5301),
    [anon_sym_try] = ACTIONS(5301),
    [anon_sym_requires] = ACTIONS(5301),
    [anon_sym___launch_bounds__] = ACTIONS(5301),
  },
  [2195] = {
    [sym_argument_list] = STATE(2726),
    [sym_initializer_list] = STATE(4269),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2219),
    [sym_identifier] = ACTIONS(5192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5194),
    [anon_sym_COMMA] = ACTIONS(5194),
    [anon_sym_RPAREN] = ACTIONS(5194),
    [anon_sym_LPAREN2] = ACTIONS(5614),
    [anon_sym_TILDE] = ACTIONS(5194),
    [anon_sym_STAR] = ACTIONS(5194),
    [anon_sym_AMP_AMP] = ACTIONS(5194),
    [anon_sym_AMP] = ACTIONS(5192),
    [anon_sym_SEMI] = ACTIONS(5194),
    [anon_sym___extension__] = ACTIONS(5192),
    [anon_sym___device__] = ACTIONS(5192),
    [anon_sym___host__] = ACTIONS(5192),
    [anon_sym___global__] = ACTIONS(5192),
    [anon_sym___forceinline__] = ACTIONS(5192),
    [anon_sym___noinline__] = ACTIONS(5192),
    [anon_sym_extern] = ACTIONS(5192),
    [anon_sym___attribute__] = ACTIONS(5192),
    [anon_sym_COLON_COLON] = ACTIONS(5194),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5194),
    [anon_sym___declspec] = ACTIONS(5192),
    [anon_sym___based] = ACTIONS(5192),
    [anon_sym___cdecl] = ACTIONS(5192),
    [anon_sym___clrcall] = ACTIONS(5192),
    [anon_sym___stdcall] = ACTIONS(5192),
    [anon_sym___fastcall] = ACTIONS(5192),
    [anon_sym___thiscall] = ACTIONS(5192),
    [anon_sym___vectorcall] = ACTIONS(5192),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_signed] = ACTIONS(5617),
    [anon_sym_unsigned] = ACTIONS(5617),
    [anon_sym_long] = ACTIONS(5617),
    [anon_sym_short] = ACTIONS(5617),
    [anon_sym_LBRACK] = ACTIONS(5192),
    [anon_sym_static] = ACTIONS(5192),
    [anon_sym_EQ] = ACTIONS(5194),
    [anon_sym_register] = ACTIONS(5192),
    [anon_sym_inline] = ACTIONS(5192),
    [anon_sym___inline] = ACTIONS(5192),
    [anon_sym___inline__] = ACTIONS(5192),
    [anon_sym___forceinline] = ACTIONS(5192),
    [anon_sym_thread_local] = ACTIONS(5192),
    [anon_sym___thread] = ACTIONS(5192),
    [anon_sym_const] = ACTIONS(5192),
    [anon_sym_constexpr] = ACTIONS(5192),
    [anon_sym_volatile] = ACTIONS(5192),
    [anon_sym_restrict] = ACTIONS(5192),
    [anon_sym___restrict__] = ACTIONS(5192),
    [anon_sym__Atomic] = ACTIONS(5192),
    [anon_sym__Noreturn] = ACTIONS(5192),
    [anon_sym_noreturn] = ACTIONS(5192),
    [anon_sym_mutable] = ACTIONS(5192),
    [anon_sym_constinit] = ACTIONS(5192),
    [anon_sym_consteval] = ACTIONS(5192),
    [anon_sym___shared__] = ACTIONS(5192),
    [anon_sym___local__] = ACTIONS(5192),
    [anon_sym___constant__] = ACTIONS(5192),
    [anon_sym___managed__] = ACTIONS(5192),
    [anon_sym___grid_constant__] = ACTIONS(5192),
    [anon_sym_alignas] = ACTIONS(5192),
    [anon_sym__Alignas] = ACTIONS(5192),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5192),
    [anon_sym_decltype] = ACTIONS(5192),
    [sym_virtual] = ACTIONS(5192),
    [anon_sym_template] = ACTIONS(5192),
    [anon_sym_operator] = ACTIONS(5192),
    [anon_sym___launch_bounds__] = ACTIONS(5192),
  },
  [2196] = {
    [sym_identifier] = ACTIONS(5378),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5380),
    [anon_sym_COMMA] = ACTIONS(5380),
    [anon_sym_RPAREN] = ACTIONS(5380),
    [anon_sym_LPAREN2] = ACTIONS(5380),
    [anon_sym_TILDE] = ACTIONS(5380),
    [anon_sym_STAR] = ACTIONS(5380),
    [anon_sym_AMP_AMP] = ACTIONS(5380),
    [anon_sym_AMP] = ACTIONS(5378),
    [anon_sym_SEMI] = ACTIONS(5380),
    [anon_sym___extension__] = ACTIONS(5378),
    [anon_sym___device__] = ACTIONS(5378),
    [anon_sym___host__] = ACTIONS(5378),
    [anon_sym___global__] = ACTIONS(5378),
    [anon_sym___forceinline__] = ACTIONS(5378),
    [anon_sym___noinline__] = ACTIONS(5378),
    [anon_sym_extern] = ACTIONS(5378),
    [anon_sym___attribute__] = ACTIONS(5378),
    [anon_sym_COLON_COLON] = ACTIONS(5380),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5380),
    [anon_sym___declspec] = ACTIONS(5378),
    [anon_sym___based] = ACTIONS(5378),
    [anon_sym___cdecl] = ACTIONS(5378),
    [anon_sym___clrcall] = ACTIONS(5378),
    [anon_sym___stdcall] = ACTIONS(5378),
    [anon_sym___fastcall] = ACTIONS(5378),
    [anon_sym___thiscall] = ACTIONS(5378),
    [anon_sym___vectorcall] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(5380),
    [anon_sym_LBRACK] = ACTIONS(5378),
    [anon_sym_static] = ACTIONS(5378),
    [anon_sym_EQ] = ACTIONS(5380),
    [anon_sym_register] = ACTIONS(5378),
    [anon_sym_inline] = ACTIONS(5378),
    [anon_sym___inline] = ACTIONS(5378),
    [anon_sym___inline__] = ACTIONS(5378),
    [anon_sym___forceinline] = ACTIONS(5378),
    [anon_sym_thread_local] = ACTIONS(5378),
    [anon_sym___thread] = ACTIONS(5378),
    [anon_sym_const] = ACTIONS(5378),
    [anon_sym_constexpr] = ACTIONS(5378),
    [anon_sym_volatile] = ACTIONS(5378),
    [anon_sym_restrict] = ACTIONS(5378),
    [anon_sym___restrict__] = ACTIONS(5378),
    [anon_sym__Atomic] = ACTIONS(5378),
    [anon_sym__Noreturn] = ACTIONS(5378),
    [anon_sym_noreturn] = ACTIONS(5378),
    [anon_sym_mutable] = ACTIONS(5378),
    [anon_sym_constinit] = ACTIONS(5378),
    [anon_sym_consteval] = ACTIONS(5378),
    [anon_sym___shared__] = ACTIONS(5378),
    [anon_sym___local__] = ACTIONS(5378),
    [anon_sym___constant__] = ACTIONS(5378),
    [anon_sym___managed__] = ACTIONS(5378),
    [anon_sym___grid_constant__] = ACTIONS(5378),
    [anon_sym_alignas] = ACTIONS(5378),
    [anon_sym__Alignas] = ACTIONS(5378),
    [anon_sym_asm] = ACTIONS(5378),
    [anon_sym___asm__] = ACTIONS(5378),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5378),
    [anon_sym_decltype] = ACTIONS(5378),
    [anon_sym_final] = ACTIONS(5378),
    [anon_sym_override] = ACTIONS(5378),
    [sym_virtual] = ACTIONS(5378),
    [anon_sym_template] = ACTIONS(5378),
    [anon_sym_GT2] = ACTIONS(5380),
    [anon_sym_operator] = ACTIONS(5378),
    [anon_sym_try] = ACTIONS(5378),
    [anon_sym_requires] = ACTIONS(5378),
    [anon_sym___launch_bounds__] = ACTIONS(5378),
  },
  [2197] = {
    [sym_identifier] = ACTIONS(5350),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5352),
    [anon_sym_COMMA] = ACTIONS(5352),
    [anon_sym_RPAREN] = ACTIONS(5352),
    [anon_sym_LPAREN2] = ACTIONS(5352),
    [anon_sym_TILDE] = ACTIONS(5352),
    [anon_sym_STAR] = ACTIONS(5352),
    [anon_sym_AMP_AMP] = ACTIONS(5352),
    [anon_sym_AMP] = ACTIONS(5350),
    [anon_sym_SEMI] = ACTIONS(5352),
    [anon_sym___extension__] = ACTIONS(5350),
    [anon_sym___device__] = ACTIONS(5350),
    [anon_sym___host__] = ACTIONS(5350),
    [anon_sym___global__] = ACTIONS(5350),
    [anon_sym___forceinline__] = ACTIONS(5350),
    [anon_sym___noinline__] = ACTIONS(5350),
    [anon_sym_extern] = ACTIONS(5350),
    [anon_sym___attribute__] = ACTIONS(5350),
    [anon_sym_COLON_COLON] = ACTIONS(5352),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5352),
    [anon_sym___declspec] = ACTIONS(5350),
    [anon_sym___based] = ACTIONS(5350),
    [anon_sym___cdecl] = ACTIONS(5350),
    [anon_sym___clrcall] = ACTIONS(5350),
    [anon_sym___stdcall] = ACTIONS(5350),
    [anon_sym___fastcall] = ACTIONS(5350),
    [anon_sym___thiscall] = ACTIONS(5350),
    [anon_sym___vectorcall] = ACTIONS(5350),
    [anon_sym_LBRACE] = ACTIONS(5352),
    [anon_sym_LBRACK] = ACTIONS(5350),
    [anon_sym_static] = ACTIONS(5350),
    [anon_sym_EQ] = ACTIONS(5352),
    [anon_sym_register] = ACTIONS(5350),
    [anon_sym_inline] = ACTIONS(5350),
    [anon_sym___inline] = ACTIONS(5350),
    [anon_sym___inline__] = ACTIONS(5350),
    [anon_sym___forceinline] = ACTIONS(5350),
    [anon_sym_thread_local] = ACTIONS(5350),
    [anon_sym___thread] = ACTIONS(5350),
    [anon_sym_const] = ACTIONS(5350),
    [anon_sym_constexpr] = ACTIONS(5350),
    [anon_sym_volatile] = ACTIONS(5350),
    [anon_sym_restrict] = ACTIONS(5350),
    [anon_sym___restrict__] = ACTIONS(5350),
    [anon_sym__Atomic] = ACTIONS(5350),
    [anon_sym__Noreturn] = ACTIONS(5350),
    [anon_sym_noreturn] = ACTIONS(5350),
    [anon_sym_mutable] = ACTIONS(5350),
    [anon_sym_constinit] = ACTIONS(5350),
    [anon_sym_consteval] = ACTIONS(5350),
    [anon_sym___shared__] = ACTIONS(5350),
    [anon_sym___local__] = ACTIONS(5350),
    [anon_sym___constant__] = ACTIONS(5350),
    [anon_sym___managed__] = ACTIONS(5350),
    [anon_sym___grid_constant__] = ACTIONS(5350),
    [anon_sym_alignas] = ACTIONS(5350),
    [anon_sym__Alignas] = ACTIONS(5350),
    [anon_sym_asm] = ACTIONS(5350),
    [anon_sym___asm__] = ACTIONS(5350),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5350),
    [anon_sym_decltype] = ACTIONS(5350),
    [anon_sym_final] = ACTIONS(5350),
    [anon_sym_override] = ACTIONS(5350),
    [sym_virtual] = ACTIONS(5350),
    [anon_sym_template] = ACTIONS(5350),
    [anon_sym_GT2] = ACTIONS(5352),
    [anon_sym_operator] = ACTIONS(5350),
    [anon_sym_try] = ACTIONS(5350),
    [anon_sym_requires] = ACTIONS(5350),
    [anon_sym___launch_bounds__] = ACTIONS(5350),
  },
  [2198] = {
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5313),
    [anon_sym_COMMA] = ACTIONS(5313),
    [anon_sym_RPAREN] = ACTIONS(5313),
    [anon_sym_LPAREN2] = ACTIONS(5313),
    [anon_sym_TILDE] = ACTIONS(5313),
    [anon_sym_STAR] = ACTIONS(5313),
    [anon_sym_AMP_AMP] = ACTIONS(5313),
    [anon_sym_AMP] = ACTIONS(5311),
    [anon_sym_SEMI] = ACTIONS(5313),
    [anon_sym___extension__] = ACTIONS(5311),
    [anon_sym___device__] = ACTIONS(5311),
    [anon_sym___host__] = ACTIONS(5311),
    [anon_sym___global__] = ACTIONS(5311),
    [anon_sym___forceinline__] = ACTIONS(5311),
    [anon_sym___noinline__] = ACTIONS(5311),
    [anon_sym_extern] = ACTIONS(5311),
    [anon_sym___attribute__] = ACTIONS(5311),
    [anon_sym_COLON_COLON] = ACTIONS(5313),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5313),
    [anon_sym___declspec] = ACTIONS(5311),
    [anon_sym___based] = ACTIONS(5311),
    [anon_sym___cdecl] = ACTIONS(5311),
    [anon_sym___clrcall] = ACTIONS(5311),
    [anon_sym___stdcall] = ACTIONS(5311),
    [anon_sym___fastcall] = ACTIONS(5311),
    [anon_sym___thiscall] = ACTIONS(5311),
    [anon_sym___vectorcall] = ACTIONS(5311),
    [anon_sym_LBRACE] = ACTIONS(5313),
    [anon_sym_LBRACK] = ACTIONS(5311),
    [anon_sym_static] = ACTIONS(5311),
    [anon_sym_EQ] = ACTIONS(5313),
    [anon_sym_register] = ACTIONS(5311),
    [anon_sym_inline] = ACTIONS(5311),
    [anon_sym___inline] = ACTIONS(5311),
    [anon_sym___inline__] = ACTIONS(5311),
    [anon_sym___forceinline] = ACTIONS(5311),
    [anon_sym_thread_local] = ACTIONS(5311),
    [anon_sym___thread] = ACTIONS(5311),
    [anon_sym_const] = ACTIONS(5311),
    [anon_sym_constexpr] = ACTIONS(5311),
    [anon_sym_volatile] = ACTIONS(5311),
    [anon_sym_restrict] = ACTIONS(5311),
    [anon_sym___restrict__] = ACTIONS(5311),
    [anon_sym__Atomic] = ACTIONS(5311),
    [anon_sym__Noreturn] = ACTIONS(5311),
    [anon_sym_noreturn] = ACTIONS(5311),
    [anon_sym_mutable] = ACTIONS(5311),
    [anon_sym_constinit] = ACTIONS(5311),
    [anon_sym_consteval] = ACTIONS(5311),
    [anon_sym___shared__] = ACTIONS(5311),
    [anon_sym___local__] = ACTIONS(5311),
    [anon_sym___constant__] = ACTIONS(5311),
    [anon_sym___managed__] = ACTIONS(5311),
    [anon_sym___grid_constant__] = ACTIONS(5311),
    [anon_sym_alignas] = ACTIONS(5311),
    [anon_sym__Alignas] = ACTIONS(5311),
    [anon_sym_asm] = ACTIONS(5311),
    [anon_sym___asm__] = ACTIONS(5311),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5311),
    [anon_sym_decltype] = ACTIONS(5311),
    [anon_sym_final] = ACTIONS(5311),
    [anon_sym_override] = ACTIONS(5311),
    [sym_virtual] = ACTIONS(5311),
    [anon_sym_template] = ACTIONS(5311),
    [anon_sym_GT2] = ACTIONS(5313),
    [anon_sym_operator] = ACTIONS(5311),
    [anon_sym_try] = ACTIONS(5311),
    [anon_sym_requires] = ACTIONS(5311),
    [anon_sym___launch_bounds__] = ACTIONS(5311),
  },
  [2199] = {
    [sym_identifier] = ACTIONS(5382),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5384),
    [anon_sym_COMMA] = ACTIONS(5384),
    [anon_sym_RPAREN] = ACTIONS(5384),
    [anon_sym_LPAREN2] = ACTIONS(5384),
    [anon_sym_TILDE] = ACTIONS(5384),
    [anon_sym_STAR] = ACTIONS(5384),
    [anon_sym_AMP_AMP] = ACTIONS(5384),
    [anon_sym_AMP] = ACTIONS(5382),
    [anon_sym_SEMI] = ACTIONS(5384),
    [anon_sym___extension__] = ACTIONS(5382),
    [anon_sym___device__] = ACTIONS(5382),
    [anon_sym___host__] = ACTIONS(5382),
    [anon_sym___global__] = ACTIONS(5382),
    [anon_sym___forceinline__] = ACTIONS(5382),
    [anon_sym___noinline__] = ACTIONS(5382),
    [anon_sym_extern] = ACTIONS(5382),
    [anon_sym___attribute__] = ACTIONS(5382),
    [anon_sym_COLON_COLON] = ACTIONS(5384),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5384),
    [anon_sym___declspec] = ACTIONS(5382),
    [anon_sym___based] = ACTIONS(5382),
    [anon_sym___cdecl] = ACTIONS(5382),
    [anon_sym___clrcall] = ACTIONS(5382),
    [anon_sym___stdcall] = ACTIONS(5382),
    [anon_sym___fastcall] = ACTIONS(5382),
    [anon_sym___thiscall] = ACTIONS(5382),
    [anon_sym___vectorcall] = ACTIONS(5382),
    [anon_sym_LBRACE] = ACTIONS(5384),
    [anon_sym_LBRACK] = ACTIONS(5382),
    [anon_sym_static] = ACTIONS(5382),
    [anon_sym_EQ] = ACTIONS(5384),
    [anon_sym_register] = ACTIONS(5382),
    [anon_sym_inline] = ACTIONS(5382),
    [anon_sym___inline] = ACTIONS(5382),
    [anon_sym___inline__] = ACTIONS(5382),
    [anon_sym___forceinline] = ACTIONS(5382),
    [anon_sym_thread_local] = ACTIONS(5382),
    [anon_sym___thread] = ACTIONS(5382),
    [anon_sym_const] = ACTIONS(5382),
    [anon_sym_constexpr] = ACTIONS(5382),
    [anon_sym_volatile] = ACTIONS(5382),
    [anon_sym_restrict] = ACTIONS(5382),
    [anon_sym___restrict__] = ACTIONS(5382),
    [anon_sym__Atomic] = ACTIONS(5382),
    [anon_sym__Noreturn] = ACTIONS(5382),
    [anon_sym_noreturn] = ACTIONS(5382),
    [anon_sym_mutable] = ACTIONS(5382),
    [anon_sym_constinit] = ACTIONS(5382),
    [anon_sym_consteval] = ACTIONS(5382),
    [anon_sym___shared__] = ACTIONS(5382),
    [anon_sym___local__] = ACTIONS(5382),
    [anon_sym___constant__] = ACTIONS(5382),
    [anon_sym___managed__] = ACTIONS(5382),
    [anon_sym___grid_constant__] = ACTIONS(5382),
    [anon_sym_alignas] = ACTIONS(5382),
    [anon_sym__Alignas] = ACTIONS(5382),
    [anon_sym_asm] = ACTIONS(5382),
    [anon_sym___asm__] = ACTIONS(5382),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5382),
    [anon_sym_decltype] = ACTIONS(5382),
    [anon_sym_final] = ACTIONS(5382),
    [anon_sym_override] = ACTIONS(5382),
    [sym_virtual] = ACTIONS(5382),
    [anon_sym_template] = ACTIONS(5382),
    [anon_sym_GT2] = ACTIONS(5384),
    [anon_sym_operator] = ACTIONS(5382),
    [anon_sym_try] = ACTIONS(5382),
    [anon_sym_requires] = ACTIONS(5382),
    [anon_sym___launch_bounds__] = ACTIONS(5382),
  },
  [2200] = {
    [sym_identifier] = ACTIONS(5192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5194),
    [anon_sym_COMMA] = ACTIONS(5194),
    [anon_sym_RPAREN] = ACTIONS(5194),
    [anon_sym_LPAREN2] = ACTIONS(5194),
    [anon_sym_TILDE] = ACTIONS(5194),
    [anon_sym_STAR] = ACTIONS(5194),
    [anon_sym_AMP_AMP] = ACTIONS(5194),
    [anon_sym_AMP] = ACTIONS(5192),
    [anon_sym_SEMI] = ACTIONS(5194),
    [anon_sym___extension__] = ACTIONS(5192),
    [anon_sym___device__] = ACTIONS(5192),
    [anon_sym___host__] = ACTIONS(5192),
    [anon_sym___global__] = ACTIONS(5192),
    [anon_sym___forceinline__] = ACTIONS(5192),
    [anon_sym___noinline__] = ACTIONS(5192),
    [anon_sym_extern] = ACTIONS(5192),
    [anon_sym___attribute__] = ACTIONS(5192),
    [anon_sym_COLON_COLON] = ACTIONS(5194),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5194),
    [anon_sym___declspec] = ACTIONS(5192),
    [anon_sym___based] = ACTIONS(5192),
    [anon_sym___cdecl] = ACTIONS(5192),
    [anon_sym___clrcall] = ACTIONS(5192),
    [anon_sym___stdcall] = ACTIONS(5192),
    [anon_sym___fastcall] = ACTIONS(5192),
    [anon_sym___thiscall] = ACTIONS(5192),
    [anon_sym___vectorcall] = ACTIONS(5192),
    [anon_sym_LBRACE] = ACTIONS(5194),
    [anon_sym_LBRACK] = ACTIONS(5192),
    [anon_sym_static] = ACTIONS(5192),
    [anon_sym_EQ] = ACTIONS(5194),
    [anon_sym_register] = ACTIONS(5192),
    [anon_sym_inline] = ACTIONS(5192),
    [anon_sym___inline] = ACTIONS(5192),
    [anon_sym___inline__] = ACTIONS(5192),
    [anon_sym___forceinline] = ACTIONS(5192),
    [anon_sym_thread_local] = ACTIONS(5192),
    [anon_sym___thread] = ACTIONS(5192),
    [anon_sym_const] = ACTIONS(5192),
    [anon_sym_constexpr] = ACTIONS(5192),
    [anon_sym_volatile] = ACTIONS(5192),
    [anon_sym_restrict] = ACTIONS(5192),
    [anon_sym___restrict__] = ACTIONS(5192),
    [anon_sym__Atomic] = ACTIONS(5192),
    [anon_sym__Noreturn] = ACTIONS(5192),
    [anon_sym_noreturn] = ACTIONS(5192),
    [anon_sym_mutable] = ACTIONS(5192),
    [anon_sym_constinit] = ACTIONS(5192),
    [anon_sym_consteval] = ACTIONS(5192),
    [anon_sym___shared__] = ACTIONS(5192),
    [anon_sym___local__] = ACTIONS(5192),
    [anon_sym___constant__] = ACTIONS(5192),
    [anon_sym___managed__] = ACTIONS(5192),
    [anon_sym___grid_constant__] = ACTIONS(5192),
    [anon_sym_alignas] = ACTIONS(5192),
    [anon_sym__Alignas] = ACTIONS(5192),
    [anon_sym_asm] = ACTIONS(5192),
    [anon_sym___asm__] = ACTIONS(5192),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5192),
    [anon_sym_decltype] = ACTIONS(5192),
    [anon_sym_final] = ACTIONS(5192),
    [anon_sym_override] = ACTIONS(5192),
    [sym_virtual] = ACTIONS(5192),
    [anon_sym_template] = ACTIONS(5192),
    [anon_sym_GT2] = ACTIONS(5194),
    [anon_sym_operator] = ACTIONS(5192),
    [anon_sym_try] = ACTIONS(5192),
    [anon_sym_requires] = ACTIONS(5192),
    [anon_sym___launch_bounds__] = ACTIONS(5192),
  },
  [2201] = {
    [sym_identifier] = ACTIONS(5336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5338),
    [anon_sym_COMMA] = ACTIONS(5338),
    [anon_sym_RPAREN] = ACTIONS(5338),
    [anon_sym_LPAREN2] = ACTIONS(5338),
    [anon_sym_TILDE] = ACTIONS(5338),
    [anon_sym_STAR] = ACTIONS(5338),
    [anon_sym_AMP_AMP] = ACTIONS(5338),
    [anon_sym_AMP] = ACTIONS(5336),
    [anon_sym_SEMI] = ACTIONS(5338),
    [anon_sym___extension__] = ACTIONS(5336),
    [anon_sym___device__] = ACTIONS(5336),
    [anon_sym___host__] = ACTIONS(5336),
    [anon_sym___global__] = ACTIONS(5336),
    [anon_sym___forceinline__] = ACTIONS(5336),
    [anon_sym___noinline__] = ACTIONS(5336),
    [anon_sym_extern] = ACTIONS(5336),
    [anon_sym___attribute__] = ACTIONS(5336),
    [anon_sym_COLON_COLON] = ACTIONS(5338),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5338),
    [anon_sym___declspec] = ACTIONS(5336),
    [anon_sym___based] = ACTIONS(5336),
    [anon_sym___cdecl] = ACTIONS(5336),
    [anon_sym___clrcall] = ACTIONS(5336),
    [anon_sym___stdcall] = ACTIONS(5336),
    [anon_sym___fastcall] = ACTIONS(5336),
    [anon_sym___thiscall] = ACTIONS(5336),
    [anon_sym___vectorcall] = ACTIONS(5336),
    [anon_sym_LBRACE] = ACTIONS(5338),
    [anon_sym_LBRACK] = ACTIONS(5336),
    [anon_sym_static] = ACTIONS(5336),
    [anon_sym_EQ] = ACTIONS(5338),
    [anon_sym_register] = ACTIONS(5336),
    [anon_sym_inline] = ACTIONS(5336),
    [anon_sym___inline] = ACTIONS(5336),
    [anon_sym___inline__] = ACTIONS(5336),
    [anon_sym___forceinline] = ACTIONS(5336),
    [anon_sym_thread_local] = ACTIONS(5336),
    [anon_sym___thread] = ACTIONS(5336),
    [anon_sym_const] = ACTIONS(5336),
    [anon_sym_constexpr] = ACTIONS(5336),
    [anon_sym_volatile] = ACTIONS(5336),
    [anon_sym_restrict] = ACTIONS(5336),
    [anon_sym___restrict__] = ACTIONS(5336),
    [anon_sym__Atomic] = ACTIONS(5336),
    [anon_sym__Noreturn] = ACTIONS(5336),
    [anon_sym_noreturn] = ACTIONS(5336),
    [anon_sym_mutable] = ACTIONS(5336),
    [anon_sym_constinit] = ACTIONS(5336),
    [anon_sym_consteval] = ACTIONS(5336),
    [anon_sym___shared__] = ACTIONS(5336),
    [anon_sym___local__] = ACTIONS(5336),
    [anon_sym___constant__] = ACTIONS(5336),
    [anon_sym___managed__] = ACTIONS(5336),
    [anon_sym___grid_constant__] = ACTIONS(5336),
    [anon_sym_alignas] = ACTIONS(5336),
    [anon_sym__Alignas] = ACTIONS(5336),
    [anon_sym_asm] = ACTIONS(5336),
    [anon_sym___asm__] = ACTIONS(5336),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5336),
    [anon_sym_decltype] = ACTIONS(5336),
    [anon_sym_final] = ACTIONS(5336),
    [anon_sym_override] = ACTIONS(5336),
    [sym_virtual] = ACTIONS(5336),
    [anon_sym_template] = ACTIONS(5336),
    [anon_sym_GT2] = ACTIONS(5338),
    [anon_sym_operator] = ACTIONS(5336),
    [anon_sym_try] = ACTIONS(5336),
    [anon_sym_requires] = ACTIONS(5336),
    [anon_sym___launch_bounds__] = ACTIONS(5336),
  },
  [2202] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1867),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5258),
    [anon_sym_COMMA] = ACTIONS(5258),
    [anon_sym_RPAREN] = ACTIONS(5258),
    [anon_sym_LPAREN2] = ACTIONS(5258),
    [anon_sym_TILDE] = ACTIONS(5258),
    [anon_sym_STAR] = ACTIONS(5258),
    [anon_sym_AMP_AMP] = ACTIONS(5258),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_SEMI] = ACTIONS(5258),
    [anon_sym___extension__] = ACTIONS(5261),
    [anon_sym___device__] = ACTIONS(5261),
    [anon_sym___host__] = ACTIONS(5261),
    [anon_sym___global__] = ACTIONS(5261),
    [anon_sym___forceinline__] = ACTIONS(5261),
    [anon_sym___noinline__] = ACTIONS(5261),
    [anon_sym_extern] = ACTIONS(5261),
    [anon_sym___attribute__] = ACTIONS(5261),
    [anon_sym_COLON_COLON] = ACTIONS(5258),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5258),
    [anon_sym___declspec] = ACTIONS(5261),
    [anon_sym___based] = ACTIONS(5261),
    [anon_sym___cdecl] = ACTIONS(5261),
    [anon_sym___clrcall] = ACTIONS(5261),
    [anon_sym___stdcall] = ACTIONS(5261),
    [anon_sym___fastcall] = ACTIONS(5261),
    [anon_sym___thiscall] = ACTIONS(5261),
    [anon_sym___vectorcall] = ACTIONS(5261),
    [anon_sym_LBRACE] = ACTIONS(5258),
    [anon_sym_signed] = ACTIONS(5207),
    [anon_sym_unsigned] = ACTIONS(5207),
    [anon_sym_long] = ACTIONS(5207),
    [anon_sym_short] = ACTIONS(5207),
    [anon_sym_LBRACK] = ACTIONS(5261),
    [anon_sym_static] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5258),
    [anon_sym_register] = ACTIONS(5261),
    [anon_sym_inline] = ACTIONS(5261),
    [anon_sym___inline] = ACTIONS(5261),
    [anon_sym___inline__] = ACTIONS(5261),
    [anon_sym___forceinline] = ACTIONS(5261),
    [anon_sym_thread_local] = ACTIONS(5261),
    [anon_sym___thread] = ACTIONS(5261),
    [anon_sym_const] = ACTIONS(5261),
    [anon_sym_constexpr] = ACTIONS(5261),
    [anon_sym_volatile] = ACTIONS(5261),
    [anon_sym_restrict] = ACTIONS(5261),
    [anon_sym___restrict__] = ACTIONS(5261),
    [anon_sym__Atomic] = ACTIONS(5261),
    [anon_sym__Noreturn] = ACTIONS(5261),
    [anon_sym_noreturn] = ACTIONS(5261),
    [anon_sym_mutable] = ACTIONS(5261),
    [anon_sym_constinit] = ACTIONS(5261),
    [anon_sym_consteval] = ACTIONS(5261),
    [anon_sym___shared__] = ACTIONS(5261),
    [anon_sym___local__] = ACTIONS(5261),
    [anon_sym___constant__] = ACTIONS(5261),
    [anon_sym___managed__] = ACTIONS(5261),
    [anon_sym___grid_constant__] = ACTIONS(5261),
    [anon_sym_alignas] = ACTIONS(5261),
    [anon_sym__Alignas] = ACTIONS(5261),
    [sym_primitive_type] = ACTIONS(5016),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5261),
    [anon_sym_decltype] = ACTIONS(5261),
    [sym_virtual] = ACTIONS(5261),
    [anon_sym_template] = ACTIONS(5261),
    [anon_sym_GT2] = ACTIONS(5258),
    [anon_sym_operator] = ACTIONS(5261),
    [anon_sym___launch_bounds__] = ACTIONS(5261),
  },
  [2203] = {
    [sym_identifier] = ACTIONS(5254),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5256),
    [anon_sym_COMMA] = ACTIONS(5256),
    [anon_sym_RPAREN] = ACTIONS(5256),
    [anon_sym_LPAREN2] = ACTIONS(5256),
    [anon_sym_TILDE] = ACTIONS(5256),
    [anon_sym_STAR] = ACTIONS(5256),
    [anon_sym_AMP_AMP] = ACTIONS(5256),
    [anon_sym_AMP] = ACTIONS(5254),
    [anon_sym_SEMI] = ACTIONS(5256),
    [anon_sym___extension__] = ACTIONS(5254),
    [anon_sym___device__] = ACTIONS(5254),
    [anon_sym___host__] = ACTIONS(5254),
    [anon_sym___global__] = ACTIONS(5254),
    [anon_sym___forceinline__] = ACTIONS(5254),
    [anon_sym___noinline__] = ACTIONS(5254),
    [anon_sym_extern] = ACTIONS(5254),
    [anon_sym___attribute__] = ACTIONS(5254),
    [anon_sym_COLON_COLON] = ACTIONS(5256),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5256),
    [anon_sym___declspec] = ACTIONS(5254),
    [anon_sym___based] = ACTIONS(5254),
    [anon_sym___cdecl] = ACTIONS(5254),
    [anon_sym___clrcall] = ACTIONS(5254),
    [anon_sym___stdcall] = ACTIONS(5254),
    [anon_sym___fastcall] = ACTIONS(5254),
    [anon_sym___thiscall] = ACTIONS(5254),
    [anon_sym___vectorcall] = ACTIONS(5254),
    [anon_sym_LBRACE] = ACTIONS(5256),
    [anon_sym_LBRACK] = ACTIONS(5254),
    [anon_sym_static] = ACTIONS(5254),
    [anon_sym_EQ] = ACTIONS(5256),
    [anon_sym_register] = ACTIONS(5254),
    [anon_sym_inline] = ACTIONS(5254),
    [anon_sym___inline] = ACTIONS(5254),
    [anon_sym___inline__] = ACTIONS(5254),
    [anon_sym___forceinline] = ACTIONS(5254),
    [anon_sym_thread_local] = ACTIONS(5254),
    [anon_sym___thread] = ACTIONS(5254),
    [anon_sym_const] = ACTIONS(5254),
    [anon_sym_constexpr] = ACTIONS(5254),
    [anon_sym_volatile] = ACTIONS(5254),
    [anon_sym_restrict] = ACTIONS(5254),
    [anon_sym___restrict__] = ACTIONS(5254),
    [anon_sym__Atomic] = ACTIONS(5254),
    [anon_sym__Noreturn] = ACTIONS(5254),
    [anon_sym_noreturn] = ACTIONS(5254),
    [anon_sym_mutable] = ACTIONS(5254),
    [anon_sym_constinit] = ACTIONS(5254),
    [anon_sym_consteval] = ACTIONS(5254),
    [anon_sym___shared__] = ACTIONS(5254),
    [anon_sym___local__] = ACTIONS(5254),
    [anon_sym___constant__] = ACTIONS(5254),
    [anon_sym___managed__] = ACTIONS(5254),
    [anon_sym___grid_constant__] = ACTIONS(5254),
    [anon_sym_alignas] = ACTIONS(5254),
    [anon_sym__Alignas] = ACTIONS(5254),
    [anon_sym_asm] = ACTIONS(5254),
    [anon_sym___asm__] = ACTIONS(5254),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5254),
    [anon_sym_decltype] = ACTIONS(5254),
    [anon_sym_final] = ACTIONS(5254),
    [anon_sym_override] = ACTIONS(5254),
    [sym_virtual] = ACTIONS(5254),
    [anon_sym_template] = ACTIONS(5254),
    [anon_sym_GT2] = ACTIONS(5256),
    [anon_sym_operator] = ACTIONS(5254),
    [anon_sym_try] = ACTIONS(5254),
    [anon_sym_requires] = ACTIONS(5254),
    [anon_sym___launch_bounds__] = ACTIONS(5254),
  },
  [2204] = {
    [sym_identifier] = ACTIONS(5354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5356),
    [anon_sym_COMMA] = ACTIONS(5356),
    [anon_sym_RPAREN] = ACTIONS(5356),
    [anon_sym_LPAREN2] = ACTIONS(5356),
    [anon_sym_TILDE] = ACTIONS(5356),
    [anon_sym_STAR] = ACTIONS(5356),
    [anon_sym_AMP_AMP] = ACTIONS(5356),
    [anon_sym_AMP] = ACTIONS(5354),
    [anon_sym_SEMI] = ACTIONS(5356),
    [anon_sym___extension__] = ACTIONS(5354),
    [anon_sym___device__] = ACTIONS(5354),
    [anon_sym___host__] = ACTIONS(5354),
    [anon_sym___global__] = ACTIONS(5354),
    [anon_sym___forceinline__] = ACTIONS(5354),
    [anon_sym___noinline__] = ACTIONS(5354),
    [anon_sym_extern] = ACTIONS(5354),
    [anon_sym___attribute__] = ACTIONS(5354),
    [anon_sym_COLON_COLON] = ACTIONS(5356),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5356),
    [anon_sym___declspec] = ACTIONS(5354),
    [anon_sym___based] = ACTIONS(5354),
    [anon_sym___cdecl] = ACTIONS(5354),
    [anon_sym___clrcall] = ACTIONS(5354),
    [anon_sym___stdcall] = ACTIONS(5354),
    [anon_sym___fastcall] = ACTIONS(5354),
    [anon_sym___thiscall] = ACTIONS(5354),
    [anon_sym___vectorcall] = ACTIONS(5354),
    [anon_sym_LBRACE] = ACTIONS(5356),
    [anon_sym_LBRACK] = ACTIONS(5354),
    [anon_sym_static] = ACTIONS(5354),
    [anon_sym_EQ] = ACTIONS(5356),
    [anon_sym_register] = ACTIONS(5354),
    [anon_sym_inline] = ACTIONS(5354),
    [anon_sym___inline] = ACTIONS(5354),
    [anon_sym___inline__] = ACTIONS(5354),
    [anon_sym___forceinline] = ACTIONS(5354),
    [anon_sym_thread_local] = ACTIONS(5354),
    [anon_sym___thread] = ACTIONS(5354),
    [anon_sym_const] = ACTIONS(5354),
    [anon_sym_constexpr] = ACTIONS(5354),
    [anon_sym_volatile] = ACTIONS(5354),
    [anon_sym_restrict] = ACTIONS(5354),
    [anon_sym___restrict__] = ACTIONS(5354),
    [anon_sym__Atomic] = ACTIONS(5354),
    [anon_sym__Noreturn] = ACTIONS(5354),
    [anon_sym_noreturn] = ACTIONS(5354),
    [anon_sym_mutable] = ACTIONS(5354),
    [anon_sym_constinit] = ACTIONS(5354),
    [anon_sym_consteval] = ACTIONS(5354),
    [anon_sym___shared__] = ACTIONS(5354),
    [anon_sym___local__] = ACTIONS(5354),
    [anon_sym___constant__] = ACTIONS(5354),
    [anon_sym___managed__] = ACTIONS(5354),
    [anon_sym___grid_constant__] = ACTIONS(5354),
    [anon_sym_alignas] = ACTIONS(5354),
    [anon_sym__Alignas] = ACTIONS(5354),
    [anon_sym_asm] = ACTIONS(5354),
    [anon_sym___asm__] = ACTIONS(5354),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5354),
    [anon_sym_decltype] = ACTIONS(5354),
    [anon_sym_final] = ACTIONS(5354),
    [anon_sym_override] = ACTIONS(5354),
    [sym_virtual] = ACTIONS(5354),
    [anon_sym_template] = ACTIONS(5354),
    [anon_sym_GT2] = ACTIONS(5356),
    [anon_sym_operator] = ACTIONS(5354),
    [anon_sym_try] = ACTIONS(5354),
    [anon_sym_requires] = ACTIONS(5354),
    [anon_sym___launch_bounds__] = ACTIONS(5354),
  },
  [2205] = {
    [sym_ms_based_modifier] = STATE(8387),
    [sym_ms_unaligned_ptr_modifier] = STATE(4253),
    [sym_ms_pointer_modifier] = STATE(4023),
    [sym__declarator] = STATE(6666),
    [sym__abstract_declarator] = STATE(6960),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_abstract_parenthesized_declarator] = STATE(6430),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_abstract_pointer_declarator] = STATE(6430),
    [sym_function_declarator] = STATE(6598),
    [sym_abstract_function_declarator] = STATE(6430),
    [sym_array_declarator] = STATE(6598),
    [sym_abstract_array_declarator] = STATE(6430),
    [sym_type_qualifier] = STATE(2685),
    [sym_alignas_qualifier] = STATE(4511),
    [sym_parameter_list] = STATE(2989),
    [sym_decltype] = STATE(8628),
    [sym_reference_declarator] = STATE(6598),
    [sym_abstract_reference_declarator] = STATE(6430),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym__function_declarator_seq] = STATE(6416),
    [sym_template_type] = STATE(8628),
    [sym_template_function] = STATE(6598),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6059),
    [sym_qualified_identifier] = STATE(6598),
    [sym_operator_name] = STATE(6598),
    [aux_sym__type_definition_type_repeat1] = STATE(2685),
    [aux_sym_pointer_declarator_repeat1] = STATE(4023),
    [sym_identifier] = ACTIONS(5482),
    [anon_sym_COMMA] = ACTIONS(5504),
    [anon_sym_RPAREN] = ACTIONS(5504),
    [anon_sym_LPAREN2] = ACTIONS(3957),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(5619),
    [anon_sym_AMP_AMP] = ACTIONS(5621),
    [anon_sym_AMP] = ACTIONS(5623),
    [anon_sym___extension__] = ACTIONS(3171),
    [anon_sym___global__] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(5492),
    [anon_sym___based] = ACTIONS(49),
    [sym_ms_restrict_modifier] = ACTIONS(3173),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3173),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3173),
    [anon_sym__unaligned] = ACTIONS(3175),
    [anon_sym___unaligned] = ACTIONS(3175),
    [anon_sym_LBRACK] = ACTIONS(5494),
    [anon_sym_const] = ACTIONS(3171),
    [anon_sym_constexpr] = ACTIONS(3171),
    [anon_sym_volatile] = ACTIONS(3171),
    [anon_sym_restrict] = ACTIONS(3171),
    [anon_sym___restrict__] = ACTIONS(3171),
    [anon_sym__Atomic] = ACTIONS(3171),
    [anon_sym__Noreturn] = ACTIONS(3171),
    [anon_sym_noreturn] = ACTIONS(3171),
    [anon_sym_mutable] = ACTIONS(3171),
    [anon_sym_constinit] = ACTIONS(3171),
    [anon_sym_consteval] = ACTIONS(3171),
    [anon_sym___shared__] = ACTIONS(3171),
    [anon_sym___local__] = ACTIONS(3171),
    [anon_sym___constant__] = ACTIONS(3171),
    [anon_sym___managed__] = ACTIONS(3171),
    [anon_sym___grid_constant__] = ACTIONS(3171),
    [anon_sym_alignas] = ACTIONS(3177),
    [anon_sym__Alignas] = ACTIONS(3177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1883),
  },
  [2206] = {
    [sym_identifier] = ACTIONS(5250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5252),
    [anon_sym_COMMA] = ACTIONS(5252),
    [anon_sym_RPAREN] = ACTIONS(5252),
    [anon_sym_LPAREN2] = ACTIONS(5252),
    [anon_sym_TILDE] = ACTIONS(5252),
    [anon_sym_STAR] = ACTIONS(5252),
    [anon_sym_AMP_AMP] = ACTIONS(5252),
    [anon_sym_AMP] = ACTIONS(5250),
    [anon_sym_SEMI] = ACTIONS(5252),
    [anon_sym___extension__] = ACTIONS(5250),
    [anon_sym___device__] = ACTIONS(5250),
    [anon_sym___host__] = ACTIONS(5250),
    [anon_sym___global__] = ACTIONS(5250),
    [anon_sym___forceinline__] = ACTIONS(5250),
    [anon_sym___noinline__] = ACTIONS(5250),
    [anon_sym_extern] = ACTIONS(5250),
    [anon_sym___attribute__] = ACTIONS(5250),
    [anon_sym_COLON_COLON] = ACTIONS(5252),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5252),
    [anon_sym___declspec] = ACTIONS(5250),
    [anon_sym___based] = ACTIONS(5250),
    [anon_sym___cdecl] = ACTIONS(5250),
    [anon_sym___clrcall] = ACTIONS(5250),
    [anon_sym___stdcall] = ACTIONS(5250),
    [anon_sym___fastcall] = ACTIONS(5250),
    [anon_sym___thiscall] = ACTIONS(5250),
    [anon_sym___vectorcall] = ACTIONS(5250),
    [anon_sym_LBRACE] = ACTIONS(5252),
    [anon_sym_LBRACK] = ACTIONS(5250),
    [anon_sym_static] = ACTIONS(5250),
    [anon_sym_EQ] = ACTIONS(5252),
    [anon_sym_register] = ACTIONS(5250),
    [anon_sym_inline] = ACTIONS(5250),
    [anon_sym___inline] = ACTIONS(5250),
    [anon_sym___inline__] = ACTIONS(5250),
    [anon_sym___forceinline] = ACTIONS(5250),
    [anon_sym_thread_local] = ACTIONS(5250),
    [anon_sym___thread] = ACTIONS(5250),
    [anon_sym_const] = ACTIONS(5250),
    [anon_sym_constexpr] = ACTIONS(5250),
    [anon_sym_volatile] = ACTIONS(5250),
    [anon_sym_restrict] = ACTIONS(5250),
    [anon_sym___restrict__] = ACTIONS(5250),
    [anon_sym__Atomic] = ACTIONS(5250),
    [anon_sym__Noreturn] = ACTIONS(5250),
    [anon_sym_noreturn] = ACTIONS(5250),
    [anon_sym_mutable] = ACTIONS(5250),
    [anon_sym_constinit] = ACTIONS(5250),
    [anon_sym_consteval] = ACTIONS(5250),
    [anon_sym___shared__] = ACTIONS(5250),
    [anon_sym___local__] = ACTIONS(5250),
    [anon_sym___constant__] = ACTIONS(5250),
    [anon_sym___managed__] = ACTIONS(5250),
    [anon_sym___grid_constant__] = ACTIONS(5250),
    [anon_sym_alignas] = ACTIONS(5250),
    [anon_sym__Alignas] = ACTIONS(5250),
    [anon_sym_asm] = ACTIONS(5250),
    [anon_sym___asm__] = ACTIONS(5250),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5250),
    [anon_sym_decltype] = ACTIONS(5250),
    [anon_sym_final] = ACTIONS(5250),
    [anon_sym_override] = ACTIONS(5250),
    [sym_virtual] = ACTIONS(5250),
    [anon_sym_template] = ACTIONS(5250),
    [anon_sym_GT2] = ACTIONS(5252),
    [anon_sym_operator] = ACTIONS(5250),
    [anon_sym_try] = ACTIONS(5250),
    [anon_sym_requires] = ACTIONS(5250),
    [anon_sym___launch_bounds__] = ACTIONS(5250),
  },
  [2207] = {
    [sym_ms_based_modifier] = STATE(8387),
    [sym_ms_unaligned_ptr_modifier] = STATE(4253),
    [sym_ms_pointer_modifier] = STATE(2205),
    [sym__declarator] = STATE(6643),
    [sym__abstract_declarator] = STATE(6923),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_abstract_parenthesized_declarator] = STATE(6430),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_abstract_pointer_declarator] = STATE(6430),
    [sym_function_declarator] = STATE(6598),
    [sym_abstract_function_declarator] = STATE(6430),
    [sym_array_declarator] = STATE(6598),
    [sym_abstract_array_declarator] = STATE(6430),
    [sym_type_qualifier] = STATE(2695),
    [sym_alignas_qualifier] = STATE(4511),
    [sym_parameter_list] = STATE(2989),
    [sym_decltype] = STATE(8628),
    [sym_reference_declarator] = STATE(6598),
    [sym_abstract_reference_declarator] = STATE(6430),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym__function_declarator_seq] = STATE(6416),
    [sym_template_type] = STATE(8628),
    [sym_template_function] = STATE(6598),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6059),
    [sym_qualified_identifier] = STATE(6598),
    [sym_operator_name] = STATE(6598),
    [aux_sym__type_definition_type_repeat1] = STATE(2695),
    [aux_sym_pointer_declarator_repeat1] = STATE(2205),
    [sym_identifier] = ACTIONS(5482),
    [anon_sym_COMMA] = ACTIONS(5484),
    [anon_sym_RPAREN] = ACTIONS(5484),
    [anon_sym_LPAREN2] = ACTIONS(3957),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(5619),
    [anon_sym_AMP_AMP] = ACTIONS(5621),
    [anon_sym_AMP] = ACTIONS(5623),
    [anon_sym___extension__] = ACTIONS(3171),
    [anon_sym___global__] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(5492),
    [anon_sym___based] = ACTIONS(49),
    [sym_ms_restrict_modifier] = ACTIONS(3173),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3173),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3173),
    [anon_sym__unaligned] = ACTIONS(3175),
    [anon_sym___unaligned] = ACTIONS(3175),
    [anon_sym_LBRACK] = ACTIONS(5494),
    [anon_sym_const] = ACTIONS(3171),
    [anon_sym_constexpr] = ACTIONS(3171),
    [anon_sym_volatile] = ACTIONS(3171),
    [anon_sym_restrict] = ACTIONS(3171),
    [anon_sym___restrict__] = ACTIONS(3171),
    [anon_sym__Atomic] = ACTIONS(3171),
    [anon_sym__Noreturn] = ACTIONS(3171),
    [anon_sym_noreturn] = ACTIONS(3171),
    [anon_sym_mutable] = ACTIONS(3171),
    [anon_sym_constinit] = ACTIONS(3171),
    [anon_sym_consteval] = ACTIONS(3171),
    [anon_sym___shared__] = ACTIONS(3171),
    [anon_sym___local__] = ACTIONS(3171),
    [anon_sym___constant__] = ACTIONS(3171),
    [anon_sym___managed__] = ACTIONS(3171),
    [anon_sym___grid_constant__] = ACTIONS(3171),
    [anon_sym_alignas] = ACTIONS(3177),
    [anon_sym__Alignas] = ACTIONS(3177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1883),
  },
  [2208] = {
    [sym_identifier] = ACTIONS(5370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5372),
    [anon_sym_COMMA] = ACTIONS(5372),
    [anon_sym_RPAREN] = ACTIONS(5372),
    [anon_sym_LPAREN2] = ACTIONS(5372),
    [anon_sym_TILDE] = ACTIONS(5372),
    [anon_sym_STAR] = ACTIONS(5372),
    [anon_sym_AMP_AMP] = ACTIONS(5372),
    [anon_sym_AMP] = ACTIONS(5370),
    [anon_sym_SEMI] = ACTIONS(5372),
    [anon_sym___extension__] = ACTIONS(5370),
    [anon_sym___device__] = ACTIONS(5370),
    [anon_sym___host__] = ACTIONS(5370),
    [anon_sym___global__] = ACTIONS(5370),
    [anon_sym___forceinline__] = ACTIONS(5370),
    [anon_sym___noinline__] = ACTIONS(5370),
    [anon_sym_extern] = ACTIONS(5370),
    [anon_sym___attribute__] = ACTIONS(5370),
    [anon_sym_COLON_COLON] = ACTIONS(5372),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5372),
    [anon_sym___declspec] = ACTIONS(5370),
    [anon_sym___based] = ACTIONS(5370),
    [anon_sym___cdecl] = ACTIONS(5370),
    [anon_sym___clrcall] = ACTIONS(5370),
    [anon_sym___stdcall] = ACTIONS(5370),
    [anon_sym___fastcall] = ACTIONS(5370),
    [anon_sym___thiscall] = ACTIONS(5370),
    [anon_sym___vectorcall] = ACTIONS(5370),
    [anon_sym_LBRACE] = ACTIONS(5372),
    [anon_sym_LBRACK] = ACTIONS(5370),
    [anon_sym_static] = ACTIONS(5370),
    [anon_sym_EQ] = ACTIONS(5372),
    [anon_sym_register] = ACTIONS(5370),
    [anon_sym_inline] = ACTIONS(5370),
    [anon_sym___inline] = ACTIONS(5370),
    [anon_sym___inline__] = ACTIONS(5370),
    [anon_sym___forceinline] = ACTIONS(5370),
    [anon_sym_thread_local] = ACTIONS(5370),
    [anon_sym___thread] = ACTIONS(5370),
    [anon_sym_const] = ACTIONS(5370),
    [anon_sym_constexpr] = ACTIONS(5370),
    [anon_sym_volatile] = ACTIONS(5370),
    [anon_sym_restrict] = ACTIONS(5370),
    [anon_sym___restrict__] = ACTIONS(5370),
    [anon_sym__Atomic] = ACTIONS(5370),
    [anon_sym__Noreturn] = ACTIONS(5370),
    [anon_sym_noreturn] = ACTIONS(5370),
    [anon_sym_mutable] = ACTIONS(5370),
    [anon_sym_constinit] = ACTIONS(5370),
    [anon_sym_consteval] = ACTIONS(5370),
    [anon_sym___shared__] = ACTIONS(5370),
    [anon_sym___local__] = ACTIONS(5370),
    [anon_sym___constant__] = ACTIONS(5370),
    [anon_sym___managed__] = ACTIONS(5370),
    [anon_sym___grid_constant__] = ACTIONS(5370),
    [anon_sym_alignas] = ACTIONS(5370),
    [anon_sym__Alignas] = ACTIONS(5370),
    [anon_sym_asm] = ACTIONS(5370),
    [anon_sym___asm__] = ACTIONS(5370),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5370),
    [anon_sym_decltype] = ACTIONS(5370),
    [anon_sym_final] = ACTIONS(5370),
    [anon_sym_override] = ACTIONS(5370),
    [sym_virtual] = ACTIONS(5370),
    [anon_sym_template] = ACTIONS(5370),
    [anon_sym_GT2] = ACTIONS(5372),
    [anon_sym_operator] = ACTIONS(5370),
    [anon_sym_try] = ACTIONS(5370),
    [anon_sym_requires] = ACTIONS(5370),
    [anon_sym___launch_bounds__] = ACTIONS(5370),
  },
  [2209] = {
    [sym_identifier] = ACTIONS(5336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5338),
    [anon_sym_COMMA] = ACTIONS(5338),
    [anon_sym_RPAREN] = ACTIONS(5338),
    [anon_sym_LPAREN2] = ACTIONS(5338),
    [anon_sym_TILDE] = ACTIONS(5338),
    [anon_sym_STAR] = ACTIONS(5338),
    [anon_sym_AMP_AMP] = ACTIONS(5338),
    [anon_sym_AMP] = ACTIONS(5336),
    [anon_sym_SEMI] = ACTIONS(5338),
    [anon_sym___extension__] = ACTIONS(5336),
    [anon_sym___device__] = ACTIONS(5336),
    [anon_sym___host__] = ACTIONS(5336),
    [anon_sym___global__] = ACTIONS(5336),
    [anon_sym___forceinline__] = ACTIONS(5336),
    [anon_sym___noinline__] = ACTIONS(5336),
    [anon_sym_extern] = ACTIONS(5336),
    [anon_sym___attribute__] = ACTIONS(5336),
    [anon_sym_COLON_COLON] = ACTIONS(5338),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5338),
    [anon_sym___declspec] = ACTIONS(5336),
    [anon_sym___based] = ACTIONS(5336),
    [anon_sym___cdecl] = ACTIONS(5336),
    [anon_sym___clrcall] = ACTIONS(5336),
    [anon_sym___stdcall] = ACTIONS(5336),
    [anon_sym___fastcall] = ACTIONS(5336),
    [anon_sym___thiscall] = ACTIONS(5336),
    [anon_sym___vectorcall] = ACTIONS(5336),
    [anon_sym_LBRACE] = ACTIONS(5338),
    [anon_sym_LBRACK] = ACTIONS(5336),
    [anon_sym_static] = ACTIONS(5336),
    [anon_sym_EQ] = ACTIONS(5338),
    [anon_sym_register] = ACTIONS(5336),
    [anon_sym_inline] = ACTIONS(5336),
    [anon_sym___inline] = ACTIONS(5336),
    [anon_sym___inline__] = ACTIONS(5336),
    [anon_sym___forceinline] = ACTIONS(5336),
    [anon_sym_thread_local] = ACTIONS(5336),
    [anon_sym___thread] = ACTIONS(5336),
    [anon_sym_const] = ACTIONS(5336),
    [anon_sym_constexpr] = ACTIONS(5336),
    [anon_sym_volatile] = ACTIONS(5336),
    [anon_sym_restrict] = ACTIONS(5336),
    [anon_sym___restrict__] = ACTIONS(5336),
    [anon_sym__Atomic] = ACTIONS(5336),
    [anon_sym__Noreturn] = ACTIONS(5336),
    [anon_sym_noreturn] = ACTIONS(5336),
    [anon_sym_mutable] = ACTIONS(5336),
    [anon_sym_constinit] = ACTIONS(5336),
    [anon_sym_consteval] = ACTIONS(5336),
    [anon_sym___shared__] = ACTIONS(5336),
    [anon_sym___local__] = ACTIONS(5336),
    [anon_sym___constant__] = ACTIONS(5336),
    [anon_sym___managed__] = ACTIONS(5336),
    [anon_sym___grid_constant__] = ACTIONS(5336),
    [anon_sym_alignas] = ACTIONS(5336),
    [anon_sym__Alignas] = ACTIONS(5336),
    [anon_sym_asm] = ACTIONS(5336),
    [anon_sym___asm__] = ACTIONS(5336),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5336),
    [anon_sym_decltype] = ACTIONS(5336),
    [anon_sym_final] = ACTIONS(5336),
    [anon_sym_override] = ACTIONS(5336),
    [sym_virtual] = ACTIONS(5336),
    [anon_sym_template] = ACTIONS(5336),
    [anon_sym_GT2] = ACTIONS(5338),
    [anon_sym_operator] = ACTIONS(5336),
    [anon_sym_try] = ACTIONS(5336),
    [anon_sym_requires] = ACTIONS(5336),
    [anon_sym___launch_bounds__] = ACTIONS(5336),
  },
  [2210] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2243),
    [sym_identifier] = ACTIONS(5424),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5422),
    [anon_sym_COMMA] = ACTIONS(5422),
    [anon_sym_RPAREN] = ACTIONS(5422),
    [anon_sym_LPAREN2] = ACTIONS(5422),
    [anon_sym_TILDE] = ACTIONS(5422),
    [anon_sym_STAR] = ACTIONS(5422),
    [anon_sym_AMP_AMP] = ACTIONS(5422),
    [anon_sym_AMP] = ACTIONS(5424),
    [anon_sym_SEMI] = ACTIONS(5422),
    [anon_sym___extension__] = ACTIONS(5424),
    [anon_sym___device__] = ACTIONS(5424),
    [anon_sym___host__] = ACTIONS(5424),
    [anon_sym___global__] = ACTIONS(5424),
    [anon_sym___forceinline__] = ACTIONS(5424),
    [anon_sym___noinline__] = ACTIONS(5424),
    [anon_sym_extern] = ACTIONS(5424),
    [anon_sym___attribute__] = ACTIONS(5424),
    [anon_sym_COLON_COLON] = ACTIONS(5422),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5422),
    [anon_sym___declspec] = ACTIONS(5424),
    [anon_sym___based] = ACTIONS(5424),
    [anon_sym___cdecl] = ACTIONS(5424),
    [anon_sym___clrcall] = ACTIONS(5424),
    [anon_sym___stdcall] = ACTIONS(5424),
    [anon_sym___fastcall] = ACTIONS(5424),
    [anon_sym___thiscall] = ACTIONS(5424),
    [anon_sym___vectorcall] = ACTIONS(5424),
    [anon_sym_LBRACE] = ACTIONS(5422),
    [anon_sym_signed] = ACTIONS(5625),
    [anon_sym_unsigned] = ACTIONS(5625),
    [anon_sym_long] = ACTIONS(5625),
    [anon_sym_short] = ACTIONS(5625),
    [anon_sym_LBRACK] = ACTIONS(5424),
    [anon_sym_static] = ACTIONS(5424),
    [anon_sym_EQ] = ACTIONS(5422),
    [anon_sym_register] = ACTIONS(5424),
    [anon_sym_inline] = ACTIONS(5424),
    [anon_sym___inline] = ACTIONS(5424),
    [anon_sym___inline__] = ACTIONS(5424),
    [anon_sym___forceinline] = ACTIONS(5424),
    [anon_sym_thread_local] = ACTIONS(5424),
    [anon_sym___thread] = ACTIONS(5424),
    [anon_sym_const] = ACTIONS(5424),
    [anon_sym_constexpr] = ACTIONS(5424),
    [anon_sym_volatile] = ACTIONS(5424),
    [anon_sym_restrict] = ACTIONS(5424),
    [anon_sym___restrict__] = ACTIONS(5424),
    [anon_sym__Atomic] = ACTIONS(5424),
    [anon_sym__Noreturn] = ACTIONS(5424),
    [anon_sym_noreturn] = ACTIONS(5424),
    [anon_sym_mutable] = ACTIONS(5424),
    [anon_sym_constinit] = ACTIONS(5424),
    [anon_sym_consteval] = ACTIONS(5424),
    [anon_sym___shared__] = ACTIONS(5424),
    [anon_sym___local__] = ACTIONS(5424),
    [anon_sym___constant__] = ACTIONS(5424),
    [anon_sym___managed__] = ACTIONS(5424),
    [anon_sym___grid_constant__] = ACTIONS(5424),
    [anon_sym_alignas] = ACTIONS(5424),
    [anon_sym__Alignas] = ACTIONS(5424),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5424),
    [anon_sym_decltype] = ACTIONS(5424),
    [sym_virtual] = ACTIONS(5424),
    [anon_sym_template] = ACTIONS(5424),
    [anon_sym_GT2] = ACTIONS(5422),
    [anon_sym_operator] = ACTIONS(5424),
    [anon_sym___launch_bounds__] = ACTIONS(5424),
  },
  [2211] = {
    [sym_attribute_specifier] = STATE(2009),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5627),
    [anon_sym_COMMA] = ACTIONS(5627),
    [anon_sym_RPAREN] = ACTIONS(5627),
    [anon_sym_LPAREN2] = ACTIONS(5627),
    [anon_sym_DASH] = ACTIONS(5629),
    [anon_sym_PLUS] = ACTIONS(5629),
    [anon_sym_STAR] = ACTIONS(5627),
    [anon_sym_SLASH] = ACTIONS(5629),
    [anon_sym_PERCENT] = ACTIONS(5627),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5627),
    [anon_sym_PIPE] = ACTIONS(5629),
    [anon_sym_CARET] = ACTIONS(5627),
    [anon_sym_AMP] = ACTIONS(5629),
    [anon_sym_EQ_EQ] = ACTIONS(5627),
    [anon_sym_BANG_EQ] = ACTIONS(5627),
    [anon_sym_GT] = ACTIONS(5629),
    [anon_sym_GT_EQ] = ACTIONS(5627),
    [anon_sym_LT_EQ] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5629),
    [anon_sym_LT_LT] = ACTIONS(5629),
    [anon_sym_GT_GT] = ACTIONS(5627),
    [anon_sym_SEMI] = ACTIONS(5627),
    [anon_sym___extension__] = ACTIONS(5627),
    [anon_sym___global__] = ACTIONS(5627),
    [anon_sym___attribute__] = ACTIONS(5510),
    [anon_sym_LBRACE] = ACTIONS(5627),
    [anon_sym_RBRACE] = ACTIONS(5627),
    [anon_sym_LBRACK] = ACTIONS(5627),
    [anon_sym_RBRACK] = ACTIONS(5627),
    [anon_sym_const] = ACTIONS(5629),
    [anon_sym_constexpr] = ACTIONS(5627),
    [anon_sym_volatile] = ACTIONS(5627),
    [anon_sym_restrict] = ACTIONS(5627),
    [anon_sym___restrict__] = ACTIONS(5627),
    [anon_sym__Atomic] = ACTIONS(5627),
    [anon_sym__Noreturn] = ACTIONS(5627),
    [anon_sym_noreturn] = ACTIONS(5627),
    [anon_sym_mutable] = ACTIONS(5627),
    [anon_sym_constinit] = ACTIONS(5627),
    [anon_sym_consteval] = ACTIONS(5627),
    [anon_sym___shared__] = ACTIONS(5627),
    [anon_sym___local__] = ACTIONS(5627),
    [anon_sym___constant__] = ACTIONS(5627),
    [anon_sym___managed__] = ACTIONS(5627),
    [anon_sym___grid_constant__] = ACTIONS(5627),
    [anon_sym_alignas] = ACTIONS(5627),
    [anon_sym__Alignas] = ACTIONS(5627),
    [anon_sym_COLON] = ACTIONS(5627),
    [anon_sym_QMARK] = ACTIONS(5627),
    [anon_sym_LT_EQ_GT] = ACTIONS(5627),
    [anon_sym_or] = ACTIONS(5627),
    [anon_sym_and] = ACTIONS(5627),
    [anon_sym_bitor] = ACTIONS(5627),
    [anon_sym_xor] = ACTIONS(5627),
    [anon_sym_bitand] = ACTIONS(5627),
    [anon_sym_not_eq] = ACTIONS(5627),
    [anon_sym_DASH_DASH] = ACTIONS(5627),
    [anon_sym_PLUS_PLUS] = ACTIONS(5627),
    [anon_sym_DOT] = ACTIONS(5629),
    [anon_sym_DOT_STAR] = ACTIONS(5627),
    [anon_sym_DASH_GT] = ACTIONS(5627),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5627),
    [anon_sym_decltype] = ACTIONS(5627),
    [anon_sym_final] = ACTIONS(5627),
    [anon_sym_override] = ACTIONS(5627),
    [anon_sym_requires] = ACTIONS(5627),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5627),
  },
  [2212] = {
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_unaligned_ptr_modifier] = STATE(4253),
    [sym_ms_pointer_modifier] = STATE(4023),
    [sym__declarator] = STATE(6714),
    [sym__abstract_declarator] = STATE(6960),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_abstract_parenthesized_declarator] = STATE(6430),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_abstract_pointer_declarator] = STATE(6430),
    [sym_function_declarator] = STATE(6598),
    [sym_abstract_function_declarator] = STATE(6430),
    [sym_array_declarator] = STATE(6598),
    [sym_abstract_array_declarator] = STATE(6430),
    [sym_type_qualifier] = STATE(2750),
    [sym_alignas_qualifier] = STATE(4511),
    [sym_parameter_list] = STATE(2989),
    [sym_decltype] = STATE(8628),
    [sym_reference_declarator] = STATE(6598),
    [sym_abstract_reference_declarator] = STATE(6430),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym__function_declarator_seq] = STATE(6416),
    [sym_template_type] = STATE(8628),
    [sym_template_function] = STATE(6598),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6094),
    [sym_qualified_identifier] = STATE(6598),
    [sym_operator_name] = STATE(6598),
    [aux_sym__type_definition_type_repeat1] = STATE(2750),
    [aux_sym_pointer_declarator_repeat1] = STATE(4023),
    [sym_identifier] = ACTIONS(4994),
    [anon_sym_RPAREN] = ACTIONS(5504),
    [anon_sym_LPAREN2] = ACTIONS(3957),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(3959),
    [anon_sym_AMP_AMP] = ACTIONS(3961),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym___extension__] = ACTIONS(3171),
    [anon_sym___global__] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(5631),
    [anon_sym___based] = ACTIONS(49),
    [sym_ms_restrict_modifier] = ACTIONS(3173),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3173),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3173),
    [anon_sym__unaligned] = ACTIONS(3175),
    [anon_sym___unaligned] = ACTIONS(3175),
    [anon_sym_LBRACK] = ACTIONS(5494),
    [anon_sym_const] = ACTIONS(3171),
    [anon_sym_constexpr] = ACTIONS(3171),
    [anon_sym_volatile] = ACTIONS(3171),
    [anon_sym_restrict] = ACTIONS(3171),
    [anon_sym___restrict__] = ACTIONS(3171),
    [anon_sym__Atomic] = ACTIONS(3171),
    [anon_sym__Noreturn] = ACTIONS(3171),
    [anon_sym_noreturn] = ACTIONS(3171),
    [anon_sym_mutable] = ACTIONS(3171),
    [anon_sym_constinit] = ACTIONS(3171),
    [anon_sym_consteval] = ACTIONS(3171),
    [anon_sym___shared__] = ACTIONS(3171),
    [anon_sym___local__] = ACTIONS(3171),
    [anon_sym___constant__] = ACTIONS(3171),
    [anon_sym___managed__] = ACTIONS(3171),
    [anon_sym___grid_constant__] = ACTIONS(3171),
    [anon_sym_alignas] = ACTIONS(3177),
    [anon_sym__Alignas] = ACTIONS(3177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1883),
  },
  [2213] = {
    [sym_attribute_specifier] = STATE(2087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5633),
    [anon_sym_COMMA] = ACTIONS(5633),
    [anon_sym_RPAREN] = ACTIONS(5633),
    [anon_sym_LPAREN2] = ACTIONS(5633),
    [anon_sym_DASH] = ACTIONS(5635),
    [anon_sym_PLUS] = ACTIONS(5635),
    [anon_sym_STAR] = ACTIONS(5633),
    [anon_sym_SLASH] = ACTIONS(5635),
    [anon_sym_PERCENT] = ACTIONS(5633),
    [anon_sym_PIPE_PIPE] = ACTIONS(5633),
    [anon_sym_AMP_AMP] = ACTIONS(5633),
    [anon_sym_PIPE] = ACTIONS(5635),
    [anon_sym_CARET] = ACTIONS(5633),
    [anon_sym_AMP] = ACTIONS(5635),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5635),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_LT_EQ] = ACTIONS(5635),
    [anon_sym_LT] = ACTIONS(5635),
    [anon_sym_LT_LT] = ACTIONS(5635),
    [anon_sym_GT_GT] = ACTIONS(5633),
    [anon_sym_SEMI] = ACTIONS(5633),
    [anon_sym___extension__] = ACTIONS(5633),
    [anon_sym___global__] = ACTIONS(5633),
    [anon_sym___attribute__] = ACTIONS(5510),
    [anon_sym_LBRACE] = ACTIONS(5633),
    [anon_sym_RBRACE] = ACTIONS(5633),
    [anon_sym_LBRACK] = ACTIONS(5633),
    [anon_sym_RBRACK] = ACTIONS(5633),
    [anon_sym_const] = ACTIONS(5635),
    [anon_sym_constexpr] = ACTIONS(5633),
    [anon_sym_volatile] = ACTIONS(5633),
    [anon_sym_restrict] = ACTIONS(5633),
    [anon_sym___restrict__] = ACTIONS(5633),
    [anon_sym__Atomic] = ACTIONS(5633),
    [anon_sym__Noreturn] = ACTIONS(5633),
    [anon_sym_noreturn] = ACTIONS(5633),
    [anon_sym_mutable] = ACTIONS(5633),
    [anon_sym_constinit] = ACTIONS(5633),
    [anon_sym_consteval] = ACTIONS(5633),
    [anon_sym___shared__] = ACTIONS(5633),
    [anon_sym___local__] = ACTIONS(5633),
    [anon_sym___constant__] = ACTIONS(5633),
    [anon_sym___managed__] = ACTIONS(5633),
    [anon_sym___grid_constant__] = ACTIONS(5633),
    [anon_sym_alignas] = ACTIONS(5633),
    [anon_sym__Alignas] = ACTIONS(5633),
    [anon_sym_COLON] = ACTIONS(5633),
    [anon_sym_QMARK] = ACTIONS(5633),
    [anon_sym_LT_EQ_GT] = ACTIONS(5633),
    [anon_sym_or] = ACTIONS(5633),
    [anon_sym_and] = ACTIONS(5633),
    [anon_sym_bitor] = ACTIONS(5633),
    [anon_sym_xor] = ACTIONS(5633),
    [anon_sym_bitand] = ACTIONS(5633),
    [anon_sym_not_eq] = ACTIONS(5633),
    [anon_sym_DASH_DASH] = ACTIONS(5633),
    [anon_sym_PLUS_PLUS] = ACTIONS(5633),
    [anon_sym_DOT] = ACTIONS(5635),
    [anon_sym_DOT_STAR] = ACTIONS(5633),
    [anon_sym_DASH_GT] = ACTIONS(5633),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5633),
    [anon_sym_decltype] = ACTIONS(5633),
    [anon_sym_final] = ACTIONS(5633),
    [anon_sym_override] = ACTIONS(5633),
    [anon_sym_requires] = ACTIONS(5633),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5633),
  },
  [2214] = {
    [sym_template_argument_list] = STATE(2259),
    [sym_identifier] = ACTIONS(4000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4007),
    [anon_sym_COMMA] = ACTIONS(4007),
    [anon_sym_RPAREN] = ACTIONS(4007),
    [aux_sym_preproc_if_token2] = ACTIONS(4007),
    [aux_sym_preproc_else_token1] = ACTIONS(4007),
    [aux_sym_preproc_elif_token1] = ACTIONS(4000),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4007),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4007),
    [anon_sym_LPAREN2] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(4000),
    [anon_sym_STAR] = ACTIONS(4000),
    [anon_sym_SLASH] = ACTIONS(4000),
    [anon_sym_PERCENT] = ACTIONS(4000),
    [anon_sym_PIPE_PIPE] = ACTIONS(4007),
    [anon_sym_AMP_AMP] = ACTIONS(4007),
    [anon_sym_PIPE] = ACTIONS(4000),
    [anon_sym_CARET] = ACTIONS(4000),
    [anon_sym_AMP] = ACTIONS(4000),
    [anon_sym_EQ_EQ] = ACTIONS(4007),
    [anon_sym_BANG_EQ] = ACTIONS(4007),
    [anon_sym_GT] = ACTIONS(4000),
    [anon_sym_GT_EQ] = ACTIONS(4007),
    [anon_sym_LT_EQ] = ACTIONS(4000),
    [anon_sym_LT] = ACTIONS(5637),
    [anon_sym_LT_LT] = ACTIONS(4000),
    [anon_sym_GT_GT] = ACTIONS(4000),
    [anon_sym_SEMI] = ACTIONS(4007),
    [anon_sym___attribute__] = ACTIONS(4000),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_RBRACE] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4007),
    [anon_sym_RBRACK] = ACTIONS(4007),
    [anon_sym_EQ] = ACTIONS(4000),
    [anon_sym_COLON] = ACTIONS(4000),
    [anon_sym_QMARK] = ACTIONS(4007),
    [anon_sym_STAR_EQ] = ACTIONS(4007),
    [anon_sym_SLASH_EQ] = ACTIONS(4007),
    [anon_sym_PERCENT_EQ] = ACTIONS(4007),
    [anon_sym_PLUS_EQ] = ACTIONS(4007),
    [anon_sym_DASH_EQ] = ACTIONS(4007),
    [anon_sym_LT_LT_EQ] = ACTIONS(4007),
    [anon_sym_GT_GT_EQ] = ACTIONS(4007),
    [anon_sym_AMP_EQ] = ACTIONS(4007),
    [anon_sym_CARET_EQ] = ACTIONS(4007),
    [anon_sym_PIPE_EQ] = ACTIONS(4007),
    [anon_sym_and_eq] = ACTIONS(4000),
    [anon_sym_or_eq] = ACTIONS(4000),
    [anon_sym_xor_eq] = ACTIONS(4000),
    [anon_sym_LT_EQ_GT] = ACTIONS(4007),
    [anon_sym_or] = ACTIONS(4000),
    [anon_sym_and] = ACTIONS(4000),
    [anon_sym_bitor] = ACTIONS(4000),
    [anon_sym_xor] = ACTIONS(4000),
    [anon_sym_bitand] = ACTIONS(4000),
    [anon_sym_not_eq] = ACTIONS(4000),
    [anon_sym_DASH_DASH] = ACTIONS(4007),
    [anon_sym_PLUS_PLUS] = ACTIONS(4007),
    [anon_sym_DOT] = ACTIONS(4000),
    [anon_sym_DOT_STAR] = ACTIONS(4007),
    [anon_sym_DASH_GT] = ACTIONS(4007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4000),
    [anon_sym_decltype] = ACTIONS(4000),
    [anon_sym_final] = ACTIONS(4000),
    [anon_sym_override] = ACTIONS(4000),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4007),
  },
  [2215] = {
    [sym_argument_list] = STATE(2704),
    [sym_initializer_list] = STATE(2704),
    [sym_decltype_auto] = STATE(2460),
    [sym_new_declarator] = STATE(2433),
    [sym_identifier] = ACTIONS(5640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5642),
    [anon_sym_COMMA] = ACTIONS(5642),
    [anon_sym_RPAREN] = ACTIONS(5642),
    [aux_sym_preproc_if_token2] = ACTIONS(5642),
    [aux_sym_preproc_else_token1] = ACTIONS(5642),
    [aux_sym_preproc_elif_token1] = ACTIONS(5640),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5642),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5642),
    [anon_sym_LPAREN2] = ACTIONS(5644),
    [anon_sym_DASH] = ACTIONS(5640),
    [anon_sym_PLUS] = ACTIONS(5640),
    [anon_sym_STAR] = ACTIONS(5640),
    [anon_sym_SLASH] = ACTIONS(5640),
    [anon_sym_PERCENT] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5642),
    [anon_sym_AMP_AMP] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5640),
    [anon_sym_CARET] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5640),
    [anon_sym_EQ_EQ] = ACTIONS(5642),
    [anon_sym_BANG_EQ] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5640),
    [anon_sym_GT_EQ] = ACTIONS(5642),
    [anon_sym_LT_EQ] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5640),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym___attribute__] = ACTIONS(5640),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_RBRACE] = ACTIONS(5642),
    [anon_sym_LBRACK] = ACTIONS(5646),
    [anon_sym_RBRACK] = ACTIONS(5642),
    [anon_sym_EQ] = ACTIONS(5640),
    [anon_sym_COLON] = ACTIONS(5642),
    [anon_sym_QMARK] = ACTIONS(5642),
    [anon_sym_STAR_EQ] = ACTIONS(5642),
    [anon_sym_SLASH_EQ] = ACTIONS(5642),
    [anon_sym_PERCENT_EQ] = ACTIONS(5642),
    [anon_sym_PLUS_EQ] = ACTIONS(5642),
    [anon_sym_DASH_EQ] = ACTIONS(5642),
    [anon_sym_LT_LT_EQ] = ACTIONS(5642),
    [anon_sym_GT_GT_EQ] = ACTIONS(5642),
    [anon_sym_AMP_EQ] = ACTIONS(5642),
    [anon_sym_CARET_EQ] = ACTIONS(5642),
    [anon_sym_PIPE_EQ] = ACTIONS(5642),
    [anon_sym_and_eq] = ACTIONS(5640),
    [anon_sym_or_eq] = ACTIONS(5640),
    [anon_sym_xor_eq] = ACTIONS(5640),
    [anon_sym_LT_EQ_GT] = ACTIONS(5642),
    [anon_sym_or] = ACTIONS(5640),
    [anon_sym_and] = ACTIONS(5640),
    [anon_sym_bitor] = ACTIONS(5640),
    [anon_sym_xor] = ACTIONS(5640),
    [anon_sym_bitand] = ACTIONS(5640),
    [anon_sym_not_eq] = ACTIONS(5640),
    [anon_sym_DASH_DASH] = ACTIONS(5642),
    [anon_sym_PLUS_PLUS] = ACTIONS(5642),
    [anon_sym_DOT] = ACTIONS(5640),
    [anon_sym_DOT_STAR] = ACTIONS(5642),
    [anon_sym_DASH_GT] = ACTIONS(5642),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5648),
    [anon_sym_decltype] = ACTIONS(5650),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5642),
  },
  [2216] = {
    [sym_attribute_specifier] = STATE(2597),
    [sym_field_declaration_list] = STATE(2386),
    [sym_virtual_specifier] = STATE(7273),
    [sym_base_class_clause] = STATE(8104),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5506),
    [anon_sym_COMMA] = ACTIONS(5506),
    [anon_sym_LPAREN2] = ACTIONS(5506),
    [anon_sym_DASH] = ACTIONS(5508),
    [anon_sym_PLUS] = ACTIONS(5508),
    [anon_sym_STAR] = ACTIONS(5506),
    [anon_sym_SLASH] = ACTIONS(5508),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [anon_sym_PIPE_PIPE] = ACTIONS(5506),
    [anon_sym_AMP_AMP] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(5508),
    [anon_sym_CARET] = ACTIONS(5506),
    [anon_sym_AMP] = ACTIONS(5508),
    [anon_sym_EQ_EQ] = ACTIONS(5506),
    [anon_sym_BANG_EQ] = ACTIONS(5506),
    [anon_sym_GT] = ACTIONS(5508),
    [anon_sym_GT_EQ] = ACTIONS(5508),
    [anon_sym_LT_EQ] = ACTIONS(5508),
    [anon_sym_LT] = ACTIONS(5508),
    [anon_sym_LT_LT] = ACTIONS(5508),
    [anon_sym_GT_GT] = ACTIONS(5508),
    [anon_sym___extension__] = ACTIONS(5506),
    [anon_sym___global__] = ACTIONS(5506),
    [anon_sym___attribute__] = ACTIONS(5652),
    [anon_sym_LBRACE] = ACTIONS(5654),
    [anon_sym_LBRACK] = ACTIONS(5506),
    [anon_sym_const] = ACTIONS(5508),
    [anon_sym_constexpr] = ACTIONS(5506),
    [anon_sym_volatile] = ACTIONS(5506),
    [anon_sym_restrict] = ACTIONS(5506),
    [anon_sym___restrict__] = ACTIONS(5506),
    [anon_sym__Atomic] = ACTIONS(5506),
    [anon_sym__Noreturn] = ACTIONS(5506),
    [anon_sym_noreturn] = ACTIONS(5506),
    [anon_sym_mutable] = ACTIONS(5506),
    [anon_sym_constinit] = ACTIONS(5506),
    [anon_sym_consteval] = ACTIONS(5506),
    [anon_sym___shared__] = ACTIONS(5506),
    [anon_sym___local__] = ACTIONS(5506),
    [anon_sym___constant__] = ACTIONS(5506),
    [anon_sym___managed__] = ACTIONS(5506),
    [anon_sym___grid_constant__] = ACTIONS(5506),
    [anon_sym_alignas] = ACTIONS(5506),
    [anon_sym__Alignas] = ACTIONS(5506),
    [anon_sym_COLON] = ACTIONS(5514),
    [anon_sym_QMARK] = ACTIONS(5506),
    [anon_sym_LT_EQ_GT] = ACTIONS(5506),
    [anon_sym_or] = ACTIONS(5506),
    [anon_sym_and] = ACTIONS(5506),
    [anon_sym_bitor] = ACTIONS(5506),
    [anon_sym_xor] = ACTIONS(5506),
    [anon_sym_bitand] = ACTIONS(5506),
    [anon_sym_not_eq] = ACTIONS(5506),
    [anon_sym_DASH_DASH] = ACTIONS(5506),
    [anon_sym_PLUS_PLUS] = ACTIONS(5506),
    [anon_sym_DOT] = ACTIONS(5508),
    [anon_sym_DOT_STAR] = ACTIONS(5506),
    [anon_sym_DASH_GT] = ACTIONS(5506),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5506),
    [anon_sym_decltype] = ACTIONS(5506),
    [anon_sym_final] = ACTIONS(5516),
    [anon_sym_override] = ACTIONS(5516),
    [anon_sym_GT2] = ACTIONS(5506),
    [anon_sym_requires] = ACTIONS(5506),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5506),
  },
  [2217] = {
    [sym_attribute_specifier] = STATE(2019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5656),
    [anon_sym_COMMA] = ACTIONS(5656),
    [anon_sym_RPAREN] = ACTIONS(5656),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_DASH] = ACTIONS(5658),
    [anon_sym_PLUS] = ACTIONS(5658),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_SLASH] = ACTIONS(5658),
    [anon_sym_PERCENT] = ACTIONS(5656),
    [anon_sym_PIPE_PIPE] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_PIPE] = ACTIONS(5658),
    [anon_sym_CARET] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_EQ_EQ] = ACTIONS(5656),
    [anon_sym_BANG_EQ] = ACTIONS(5656),
    [anon_sym_GT] = ACTIONS(5658),
    [anon_sym_GT_EQ] = ACTIONS(5656),
    [anon_sym_LT_EQ] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5658),
    [anon_sym_GT_GT] = ACTIONS(5656),
    [anon_sym_SEMI] = ACTIONS(5656),
    [anon_sym___extension__] = ACTIONS(5656),
    [anon_sym___global__] = ACTIONS(5656),
    [anon_sym___attribute__] = ACTIONS(5510),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_RBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [anon_sym_RBRACK] = ACTIONS(5656),
    [anon_sym_const] = ACTIONS(5658),
    [anon_sym_constexpr] = ACTIONS(5656),
    [anon_sym_volatile] = ACTIONS(5656),
    [anon_sym_restrict] = ACTIONS(5656),
    [anon_sym___restrict__] = ACTIONS(5656),
    [anon_sym__Atomic] = ACTIONS(5656),
    [anon_sym__Noreturn] = ACTIONS(5656),
    [anon_sym_noreturn] = ACTIONS(5656),
    [anon_sym_mutable] = ACTIONS(5656),
    [anon_sym_constinit] = ACTIONS(5656),
    [anon_sym_consteval] = ACTIONS(5656),
    [anon_sym___shared__] = ACTIONS(5656),
    [anon_sym___local__] = ACTIONS(5656),
    [anon_sym___constant__] = ACTIONS(5656),
    [anon_sym___managed__] = ACTIONS(5656),
    [anon_sym___grid_constant__] = ACTIONS(5656),
    [anon_sym_alignas] = ACTIONS(5656),
    [anon_sym__Alignas] = ACTIONS(5656),
    [anon_sym_COLON] = ACTIONS(5656),
    [anon_sym_QMARK] = ACTIONS(5656),
    [anon_sym_LT_EQ_GT] = ACTIONS(5656),
    [anon_sym_or] = ACTIONS(5656),
    [anon_sym_and] = ACTIONS(5656),
    [anon_sym_bitor] = ACTIONS(5656),
    [anon_sym_xor] = ACTIONS(5656),
    [anon_sym_bitand] = ACTIONS(5656),
    [anon_sym_not_eq] = ACTIONS(5656),
    [anon_sym_DASH_DASH] = ACTIONS(5656),
    [anon_sym_PLUS_PLUS] = ACTIONS(5656),
    [anon_sym_DOT] = ACTIONS(5658),
    [anon_sym_DOT_STAR] = ACTIONS(5656),
    [anon_sym_DASH_GT] = ACTIONS(5656),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5656),
    [anon_sym_decltype] = ACTIONS(5656),
    [anon_sym_final] = ACTIONS(5656),
    [anon_sym_override] = ACTIONS(5656),
    [anon_sym_requires] = ACTIONS(5656),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5656),
  },
  [2218] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2235),
    [sym_identifier] = ACTIONS(5442),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5440),
    [anon_sym_COMMA] = ACTIONS(5440),
    [anon_sym_RPAREN] = ACTIONS(5440),
    [anon_sym_LPAREN2] = ACTIONS(5440),
    [anon_sym_TILDE] = ACTIONS(5440),
    [anon_sym_STAR] = ACTIONS(5440),
    [anon_sym_AMP_AMP] = ACTIONS(5440),
    [anon_sym_AMP] = ACTIONS(5442),
    [anon_sym_SEMI] = ACTIONS(5440),
    [anon_sym___extension__] = ACTIONS(5442),
    [anon_sym___device__] = ACTIONS(5442),
    [anon_sym___host__] = ACTIONS(5442),
    [anon_sym___global__] = ACTIONS(5442),
    [anon_sym___forceinline__] = ACTIONS(5442),
    [anon_sym___noinline__] = ACTIONS(5442),
    [anon_sym_extern] = ACTIONS(5442),
    [anon_sym___attribute__] = ACTIONS(5442),
    [anon_sym_COLON_COLON] = ACTIONS(5440),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5440),
    [anon_sym___declspec] = ACTIONS(5442),
    [anon_sym___based] = ACTIONS(5442),
    [anon_sym___cdecl] = ACTIONS(5442),
    [anon_sym___clrcall] = ACTIONS(5442),
    [anon_sym___stdcall] = ACTIONS(5442),
    [anon_sym___fastcall] = ACTIONS(5442),
    [anon_sym___thiscall] = ACTIONS(5442),
    [anon_sym___vectorcall] = ACTIONS(5442),
    [anon_sym_LBRACE] = ACTIONS(5440),
    [anon_sym_signed] = ACTIONS(5660),
    [anon_sym_unsigned] = ACTIONS(5660),
    [anon_sym_long] = ACTIONS(5660),
    [anon_sym_short] = ACTIONS(5660),
    [anon_sym_LBRACK] = ACTIONS(5442),
    [anon_sym_static] = ACTIONS(5442),
    [anon_sym_EQ] = ACTIONS(5440),
    [anon_sym_register] = ACTIONS(5442),
    [anon_sym_inline] = ACTIONS(5442),
    [anon_sym___inline] = ACTIONS(5442),
    [anon_sym___inline__] = ACTIONS(5442),
    [anon_sym___forceinline] = ACTIONS(5442),
    [anon_sym_thread_local] = ACTIONS(5442),
    [anon_sym___thread] = ACTIONS(5442),
    [anon_sym_const] = ACTIONS(5442),
    [anon_sym_constexpr] = ACTIONS(5442),
    [anon_sym_volatile] = ACTIONS(5442),
    [anon_sym_restrict] = ACTIONS(5442),
    [anon_sym___restrict__] = ACTIONS(5442),
    [anon_sym__Atomic] = ACTIONS(5442),
    [anon_sym__Noreturn] = ACTIONS(5442),
    [anon_sym_noreturn] = ACTIONS(5442),
    [anon_sym_mutable] = ACTIONS(5442),
    [anon_sym_constinit] = ACTIONS(5442),
    [anon_sym_consteval] = ACTIONS(5442),
    [anon_sym___shared__] = ACTIONS(5442),
    [anon_sym___local__] = ACTIONS(5442),
    [anon_sym___constant__] = ACTIONS(5442),
    [anon_sym___managed__] = ACTIONS(5442),
    [anon_sym___grid_constant__] = ACTIONS(5442),
    [anon_sym_alignas] = ACTIONS(5442),
    [anon_sym__Alignas] = ACTIONS(5442),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5442),
    [anon_sym_decltype] = ACTIONS(5442),
    [sym_virtual] = ACTIONS(5442),
    [anon_sym_template] = ACTIONS(5442),
    [anon_sym_GT2] = ACTIONS(5440),
    [anon_sym_operator] = ACTIONS(5442),
    [anon_sym___launch_bounds__] = ACTIONS(5442),
  },
  [2219] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2243),
    [sym_identifier] = ACTIONS(5438),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5436),
    [anon_sym_COMMA] = ACTIONS(5436),
    [anon_sym_RPAREN] = ACTIONS(5436),
    [anon_sym_LPAREN2] = ACTIONS(5436),
    [anon_sym_TILDE] = ACTIONS(5436),
    [anon_sym_STAR] = ACTIONS(5436),
    [anon_sym_AMP_AMP] = ACTIONS(5436),
    [anon_sym_AMP] = ACTIONS(5438),
    [anon_sym_SEMI] = ACTIONS(5436),
    [anon_sym___extension__] = ACTIONS(5438),
    [anon_sym___device__] = ACTIONS(5438),
    [anon_sym___host__] = ACTIONS(5438),
    [anon_sym___global__] = ACTIONS(5438),
    [anon_sym___forceinline__] = ACTIONS(5438),
    [anon_sym___noinline__] = ACTIONS(5438),
    [anon_sym_extern] = ACTIONS(5438),
    [anon_sym___attribute__] = ACTIONS(5438),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5436),
    [anon_sym___declspec] = ACTIONS(5438),
    [anon_sym___based] = ACTIONS(5438),
    [anon_sym___cdecl] = ACTIONS(5438),
    [anon_sym___clrcall] = ACTIONS(5438),
    [anon_sym___stdcall] = ACTIONS(5438),
    [anon_sym___fastcall] = ACTIONS(5438),
    [anon_sym___thiscall] = ACTIONS(5438),
    [anon_sym___vectorcall] = ACTIONS(5438),
    [anon_sym_LBRACE] = ACTIONS(5436),
    [anon_sym_signed] = ACTIONS(5625),
    [anon_sym_unsigned] = ACTIONS(5625),
    [anon_sym_long] = ACTIONS(5625),
    [anon_sym_short] = ACTIONS(5625),
    [anon_sym_LBRACK] = ACTIONS(5438),
    [anon_sym_static] = ACTIONS(5438),
    [anon_sym_EQ] = ACTIONS(5436),
    [anon_sym_register] = ACTIONS(5438),
    [anon_sym_inline] = ACTIONS(5438),
    [anon_sym___inline] = ACTIONS(5438),
    [anon_sym___inline__] = ACTIONS(5438),
    [anon_sym___forceinline] = ACTIONS(5438),
    [anon_sym_thread_local] = ACTIONS(5438),
    [anon_sym___thread] = ACTIONS(5438),
    [anon_sym_const] = ACTIONS(5438),
    [anon_sym_constexpr] = ACTIONS(5438),
    [anon_sym_volatile] = ACTIONS(5438),
    [anon_sym_restrict] = ACTIONS(5438),
    [anon_sym___restrict__] = ACTIONS(5438),
    [anon_sym__Atomic] = ACTIONS(5438),
    [anon_sym__Noreturn] = ACTIONS(5438),
    [anon_sym_noreturn] = ACTIONS(5438),
    [anon_sym_mutable] = ACTIONS(5438),
    [anon_sym_constinit] = ACTIONS(5438),
    [anon_sym_consteval] = ACTIONS(5438),
    [anon_sym___shared__] = ACTIONS(5438),
    [anon_sym___local__] = ACTIONS(5438),
    [anon_sym___constant__] = ACTIONS(5438),
    [anon_sym___managed__] = ACTIONS(5438),
    [anon_sym___grid_constant__] = ACTIONS(5438),
    [anon_sym_alignas] = ACTIONS(5438),
    [anon_sym__Alignas] = ACTIONS(5438),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5438),
    [anon_sym_decltype] = ACTIONS(5438),
    [sym_virtual] = ACTIONS(5438),
    [anon_sym_template] = ACTIONS(5438),
    [anon_sym_GT2] = ACTIONS(5436),
    [anon_sym_operator] = ACTIONS(5438),
    [anon_sym___launch_bounds__] = ACTIONS(5438),
  },
  [2220] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2210),
    [sym_identifier] = ACTIONS(5448),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5446),
    [anon_sym_COMMA] = ACTIONS(5446),
    [anon_sym_RPAREN] = ACTIONS(5446),
    [anon_sym_LPAREN2] = ACTIONS(5446),
    [anon_sym_TILDE] = ACTIONS(5446),
    [anon_sym_STAR] = ACTIONS(5446),
    [anon_sym_AMP_AMP] = ACTIONS(5446),
    [anon_sym_AMP] = ACTIONS(5448),
    [anon_sym_SEMI] = ACTIONS(5446),
    [anon_sym___extension__] = ACTIONS(5448),
    [anon_sym___device__] = ACTIONS(5448),
    [anon_sym___host__] = ACTIONS(5448),
    [anon_sym___global__] = ACTIONS(5448),
    [anon_sym___forceinline__] = ACTIONS(5448),
    [anon_sym___noinline__] = ACTIONS(5448),
    [anon_sym_extern] = ACTIONS(5448),
    [anon_sym___attribute__] = ACTIONS(5448),
    [anon_sym_COLON_COLON] = ACTIONS(5446),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5446),
    [anon_sym___declspec] = ACTIONS(5448),
    [anon_sym___based] = ACTIONS(5448),
    [anon_sym___cdecl] = ACTIONS(5448),
    [anon_sym___clrcall] = ACTIONS(5448),
    [anon_sym___stdcall] = ACTIONS(5448),
    [anon_sym___fastcall] = ACTIONS(5448),
    [anon_sym___thiscall] = ACTIONS(5448),
    [anon_sym___vectorcall] = ACTIONS(5448),
    [anon_sym_LBRACE] = ACTIONS(5446),
    [anon_sym_signed] = ACTIONS(5662),
    [anon_sym_unsigned] = ACTIONS(5662),
    [anon_sym_long] = ACTIONS(5662),
    [anon_sym_short] = ACTIONS(5662),
    [anon_sym_LBRACK] = ACTIONS(5448),
    [anon_sym_static] = ACTIONS(5448),
    [anon_sym_EQ] = ACTIONS(5446),
    [anon_sym_register] = ACTIONS(5448),
    [anon_sym_inline] = ACTIONS(5448),
    [anon_sym___inline] = ACTIONS(5448),
    [anon_sym___inline__] = ACTIONS(5448),
    [anon_sym___forceinline] = ACTIONS(5448),
    [anon_sym_thread_local] = ACTIONS(5448),
    [anon_sym___thread] = ACTIONS(5448),
    [anon_sym_const] = ACTIONS(5448),
    [anon_sym_constexpr] = ACTIONS(5448),
    [anon_sym_volatile] = ACTIONS(5448),
    [anon_sym_restrict] = ACTIONS(5448),
    [anon_sym___restrict__] = ACTIONS(5448),
    [anon_sym__Atomic] = ACTIONS(5448),
    [anon_sym__Noreturn] = ACTIONS(5448),
    [anon_sym_noreturn] = ACTIONS(5448),
    [anon_sym_mutable] = ACTIONS(5448),
    [anon_sym_constinit] = ACTIONS(5448),
    [anon_sym_consteval] = ACTIONS(5448),
    [anon_sym___shared__] = ACTIONS(5448),
    [anon_sym___local__] = ACTIONS(5448),
    [anon_sym___constant__] = ACTIONS(5448),
    [anon_sym___managed__] = ACTIONS(5448),
    [anon_sym___grid_constant__] = ACTIONS(5448),
    [anon_sym_alignas] = ACTIONS(5448),
    [anon_sym__Alignas] = ACTIONS(5448),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5448),
    [anon_sym_decltype] = ACTIONS(5448),
    [sym_virtual] = ACTIONS(5448),
    [anon_sym_template] = ACTIONS(5448),
    [anon_sym_GT2] = ACTIONS(5446),
    [anon_sym_operator] = ACTIONS(5448),
    [anon_sym___launch_bounds__] = ACTIONS(5448),
  },
  [2221] = {
    [sym_argument_list] = STATE(2660),
    [sym_initializer_list] = STATE(2660),
    [sym_decltype_auto] = STATE(2460),
    [sym_new_declarator] = STATE(2416),
    [sym_identifier] = ACTIONS(5664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5666),
    [anon_sym_COMMA] = ACTIONS(5666),
    [anon_sym_RPAREN] = ACTIONS(5666),
    [aux_sym_preproc_if_token2] = ACTIONS(5666),
    [aux_sym_preproc_else_token1] = ACTIONS(5666),
    [aux_sym_preproc_elif_token1] = ACTIONS(5664),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5666),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5666),
    [anon_sym_LPAREN2] = ACTIONS(5644),
    [anon_sym_DASH] = ACTIONS(5664),
    [anon_sym_PLUS] = ACTIONS(5664),
    [anon_sym_STAR] = ACTIONS(5664),
    [anon_sym_SLASH] = ACTIONS(5664),
    [anon_sym_PERCENT] = ACTIONS(5664),
    [anon_sym_PIPE_PIPE] = ACTIONS(5666),
    [anon_sym_AMP_AMP] = ACTIONS(5666),
    [anon_sym_PIPE] = ACTIONS(5664),
    [anon_sym_CARET] = ACTIONS(5664),
    [anon_sym_AMP] = ACTIONS(5664),
    [anon_sym_EQ_EQ] = ACTIONS(5666),
    [anon_sym_BANG_EQ] = ACTIONS(5666),
    [anon_sym_GT] = ACTIONS(5664),
    [anon_sym_GT_EQ] = ACTIONS(5666),
    [anon_sym_LT_EQ] = ACTIONS(5664),
    [anon_sym_LT] = ACTIONS(5664),
    [anon_sym_LT_LT] = ACTIONS(5664),
    [anon_sym_GT_GT] = ACTIONS(5664),
    [anon_sym_SEMI] = ACTIONS(5666),
    [anon_sym___attribute__] = ACTIONS(5664),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_RBRACE] = ACTIONS(5666),
    [anon_sym_LBRACK] = ACTIONS(5646),
    [anon_sym_RBRACK] = ACTIONS(5666),
    [anon_sym_EQ] = ACTIONS(5664),
    [anon_sym_COLON] = ACTIONS(5666),
    [anon_sym_QMARK] = ACTIONS(5666),
    [anon_sym_STAR_EQ] = ACTIONS(5666),
    [anon_sym_SLASH_EQ] = ACTIONS(5666),
    [anon_sym_PERCENT_EQ] = ACTIONS(5666),
    [anon_sym_PLUS_EQ] = ACTIONS(5666),
    [anon_sym_DASH_EQ] = ACTIONS(5666),
    [anon_sym_LT_LT_EQ] = ACTIONS(5666),
    [anon_sym_GT_GT_EQ] = ACTIONS(5666),
    [anon_sym_AMP_EQ] = ACTIONS(5666),
    [anon_sym_CARET_EQ] = ACTIONS(5666),
    [anon_sym_PIPE_EQ] = ACTIONS(5666),
    [anon_sym_and_eq] = ACTIONS(5664),
    [anon_sym_or_eq] = ACTIONS(5664),
    [anon_sym_xor_eq] = ACTIONS(5664),
    [anon_sym_LT_EQ_GT] = ACTIONS(5666),
    [anon_sym_or] = ACTIONS(5664),
    [anon_sym_and] = ACTIONS(5664),
    [anon_sym_bitor] = ACTIONS(5664),
    [anon_sym_xor] = ACTIONS(5664),
    [anon_sym_bitand] = ACTIONS(5664),
    [anon_sym_not_eq] = ACTIONS(5664),
    [anon_sym_DASH_DASH] = ACTIONS(5666),
    [anon_sym_PLUS_PLUS] = ACTIONS(5666),
    [anon_sym_DOT] = ACTIONS(5664),
    [anon_sym_DOT_STAR] = ACTIONS(5666),
    [anon_sym_DASH_GT] = ACTIONS(5666),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5648),
    [anon_sym_decltype] = ACTIONS(5650),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5666),
  },
  [2222] = {
    [sym_attribute_specifier] = STATE(1916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5668),
    [anon_sym_COMMA] = ACTIONS(5668),
    [anon_sym_RPAREN] = ACTIONS(5668),
    [anon_sym_LPAREN2] = ACTIONS(5668),
    [anon_sym_DASH] = ACTIONS(5670),
    [anon_sym_PLUS] = ACTIONS(5670),
    [anon_sym_STAR] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(5670),
    [anon_sym_PERCENT] = ACTIONS(5668),
    [anon_sym_PIPE_PIPE] = ACTIONS(5668),
    [anon_sym_AMP_AMP] = ACTIONS(5668),
    [anon_sym_PIPE] = ACTIONS(5670),
    [anon_sym_CARET] = ACTIONS(5668),
    [anon_sym_AMP] = ACTIONS(5670),
    [anon_sym_EQ_EQ] = ACTIONS(5668),
    [anon_sym_BANG_EQ] = ACTIONS(5668),
    [anon_sym_GT] = ACTIONS(5670),
    [anon_sym_GT_EQ] = ACTIONS(5668),
    [anon_sym_LT_EQ] = ACTIONS(5670),
    [anon_sym_LT] = ACTIONS(5670),
    [anon_sym_LT_LT] = ACTIONS(5670),
    [anon_sym_GT_GT] = ACTIONS(5668),
    [anon_sym_SEMI] = ACTIONS(5668),
    [anon_sym___extension__] = ACTIONS(5668),
    [anon_sym___global__] = ACTIONS(5668),
    [anon_sym___attribute__] = ACTIONS(5510),
    [anon_sym_LBRACE] = ACTIONS(5668),
    [anon_sym_RBRACE] = ACTIONS(5668),
    [anon_sym_LBRACK] = ACTIONS(5668),
    [anon_sym_RBRACK] = ACTIONS(5668),
    [anon_sym_const] = ACTIONS(5670),
    [anon_sym_constexpr] = ACTIONS(5668),
    [anon_sym_volatile] = ACTIONS(5668),
    [anon_sym_restrict] = ACTIONS(5668),
    [anon_sym___restrict__] = ACTIONS(5668),
    [anon_sym__Atomic] = ACTIONS(5668),
    [anon_sym__Noreturn] = ACTIONS(5668),
    [anon_sym_noreturn] = ACTIONS(5668),
    [anon_sym_mutable] = ACTIONS(5668),
    [anon_sym_constinit] = ACTIONS(5668),
    [anon_sym_consteval] = ACTIONS(5668),
    [anon_sym___shared__] = ACTIONS(5668),
    [anon_sym___local__] = ACTIONS(5668),
    [anon_sym___constant__] = ACTIONS(5668),
    [anon_sym___managed__] = ACTIONS(5668),
    [anon_sym___grid_constant__] = ACTIONS(5668),
    [anon_sym_alignas] = ACTIONS(5668),
    [anon_sym__Alignas] = ACTIONS(5668),
    [anon_sym_COLON] = ACTIONS(5668),
    [anon_sym_QMARK] = ACTIONS(5668),
    [anon_sym_LT_EQ_GT] = ACTIONS(5668),
    [anon_sym_or] = ACTIONS(5668),
    [anon_sym_and] = ACTIONS(5668),
    [anon_sym_bitor] = ACTIONS(5668),
    [anon_sym_xor] = ACTIONS(5668),
    [anon_sym_bitand] = ACTIONS(5668),
    [anon_sym_not_eq] = ACTIONS(5668),
    [anon_sym_DASH_DASH] = ACTIONS(5668),
    [anon_sym_PLUS_PLUS] = ACTIONS(5668),
    [anon_sym_DOT] = ACTIONS(5670),
    [anon_sym_DOT_STAR] = ACTIONS(5668),
    [anon_sym_DASH_GT] = ACTIONS(5668),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5668),
    [anon_sym_decltype] = ACTIONS(5668),
    [anon_sym_final] = ACTIONS(5668),
    [anon_sym_override] = ACTIONS(5668),
    [anon_sym_requires] = ACTIONS(5668),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5668),
  },
  [2223] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5446),
    [anon_sym_COMMA] = ACTIONS(5446),
    [anon_sym_LPAREN2] = ACTIONS(5446),
    [anon_sym_DASH] = ACTIONS(5448),
    [anon_sym_PLUS] = ACTIONS(5448),
    [anon_sym_STAR] = ACTIONS(5446),
    [anon_sym_SLASH] = ACTIONS(5448),
    [anon_sym_PERCENT] = ACTIONS(5446),
    [anon_sym_PIPE_PIPE] = ACTIONS(5446),
    [anon_sym_AMP_AMP] = ACTIONS(5446),
    [anon_sym_PIPE] = ACTIONS(5448),
    [anon_sym_CARET] = ACTIONS(5446),
    [anon_sym_AMP] = ACTIONS(5448),
    [anon_sym_EQ_EQ] = ACTIONS(5446),
    [anon_sym_BANG_EQ] = ACTIONS(5446),
    [anon_sym_GT] = ACTIONS(5448),
    [anon_sym_GT_EQ] = ACTIONS(5448),
    [anon_sym_LT_EQ] = ACTIONS(5448),
    [anon_sym_LT] = ACTIONS(5448),
    [anon_sym_LT_LT] = ACTIONS(5448),
    [anon_sym_GT_GT] = ACTIONS(5448),
    [anon_sym___extension__] = ACTIONS(5446),
    [anon_sym___global__] = ACTIONS(5446),
    [anon_sym___attribute__] = ACTIONS(5446),
    [anon_sym_LBRACE] = ACTIONS(5446),
    [anon_sym_signed] = ACTIONS(5672),
    [anon_sym_unsigned] = ACTIONS(5672),
    [anon_sym_long] = ACTIONS(5672),
    [anon_sym_short] = ACTIONS(5672),
    [anon_sym_LBRACK] = ACTIONS(5446),
    [anon_sym_const] = ACTIONS(5448),
    [anon_sym_constexpr] = ACTIONS(5446),
    [anon_sym_volatile] = ACTIONS(5446),
    [anon_sym_restrict] = ACTIONS(5446),
    [anon_sym___restrict__] = ACTIONS(5446),
    [anon_sym__Atomic] = ACTIONS(5446),
    [anon_sym__Noreturn] = ACTIONS(5446),
    [anon_sym_noreturn] = ACTIONS(5446),
    [anon_sym_mutable] = ACTIONS(5446),
    [anon_sym_constinit] = ACTIONS(5446),
    [anon_sym_consteval] = ACTIONS(5446),
    [anon_sym___shared__] = ACTIONS(5446),
    [anon_sym___local__] = ACTIONS(5446),
    [anon_sym___constant__] = ACTIONS(5446),
    [anon_sym___managed__] = ACTIONS(5446),
    [anon_sym___grid_constant__] = ACTIONS(5446),
    [anon_sym_alignas] = ACTIONS(5446),
    [anon_sym__Alignas] = ACTIONS(5446),
    [anon_sym_QMARK] = ACTIONS(5446),
    [anon_sym_LT_EQ_GT] = ACTIONS(5446),
    [anon_sym_or] = ACTIONS(5446),
    [anon_sym_and] = ACTIONS(5446),
    [anon_sym_bitor] = ACTIONS(5446),
    [anon_sym_xor] = ACTIONS(5446),
    [anon_sym_bitand] = ACTIONS(5446),
    [anon_sym_not_eq] = ACTIONS(5446),
    [anon_sym_DASH_DASH] = ACTIONS(5446),
    [anon_sym_PLUS_PLUS] = ACTIONS(5446),
    [anon_sym_DOT] = ACTIONS(5448),
    [anon_sym_DOT_STAR] = ACTIONS(5446),
    [anon_sym_DASH_GT] = ACTIONS(5446),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5446),
    [anon_sym_decltype] = ACTIONS(5446),
    [anon_sym_final] = ACTIONS(5446),
    [anon_sym_override] = ACTIONS(5446),
    [anon_sym_GT2] = ACTIONS(5446),
    [anon_sym_requires] = ACTIONS(5446),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5446),
  },
  [2224] = {
    [sym_attribute_specifier] = STATE(2035),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5674),
    [anon_sym_COMMA] = ACTIONS(5674),
    [anon_sym_RPAREN] = ACTIONS(5674),
    [anon_sym_LPAREN2] = ACTIONS(5674),
    [anon_sym_DASH] = ACTIONS(5676),
    [anon_sym_PLUS] = ACTIONS(5676),
    [anon_sym_STAR] = ACTIONS(5674),
    [anon_sym_SLASH] = ACTIONS(5676),
    [anon_sym_PERCENT] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_CARET] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
    [anon_sym_EQ_EQ] = ACTIONS(5674),
    [anon_sym_BANG_EQ] = ACTIONS(5674),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_EQ] = ACTIONS(5674),
    [anon_sym_LT_EQ] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5674),
    [anon_sym___extension__] = ACTIONS(5674),
    [anon_sym___global__] = ACTIONS(5674),
    [anon_sym___attribute__] = ACTIONS(5510),
    [anon_sym_LBRACE] = ACTIONS(5674),
    [anon_sym_RBRACE] = ACTIONS(5674),
    [anon_sym_LBRACK] = ACTIONS(5674),
    [anon_sym_RBRACK] = ACTIONS(5674),
    [anon_sym_const] = ACTIONS(5676),
    [anon_sym_constexpr] = ACTIONS(5674),
    [anon_sym_volatile] = ACTIONS(5674),
    [anon_sym_restrict] = ACTIONS(5674),
    [anon_sym___restrict__] = ACTIONS(5674),
    [anon_sym__Atomic] = ACTIONS(5674),
    [anon_sym__Noreturn] = ACTIONS(5674),
    [anon_sym_noreturn] = ACTIONS(5674),
    [anon_sym_mutable] = ACTIONS(5674),
    [anon_sym_constinit] = ACTIONS(5674),
    [anon_sym_consteval] = ACTIONS(5674),
    [anon_sym___shared__] = ACTIONS(5674),
    [anon_sym___local__] = ACTIONS(5674),
    [anon_sym___constant__] = ACTIONS(5674),
    [anon_sym___managed__] = ACTIONS(5674),
    [anon_sym___grid_constant__] = ACTIONS(5674),
    [anon_sym_alignas] = ACTIONS(5674),
    [anon_sym__Alignas] = ACTIONS(5674),
    [anon_sym_COLON] = ACTIONS(5674),
    [anon_sym_QMARK] = ACTIONS(5674),
    [anon_sym_LT_EQ_GT] = ACTIONS(5674),
    [anon_sym_or] = ACTIONS(5674),
    [anon_sym_and] = ACTIONS(5674),
    [anon_sym_bitor] = ACTIONS(5674),
    [anon_sym_xor] = ACTIONS(5674),
    [anon_sym_bitand] = ACTIONS(5674),
    [anon_sym_not_eq] = ACTIONS(5674),
    [anon_sym_DASH_DASH] = ACTIONS(5674),
    [anon_sym_PLUS_PLUS] = ACTIONS(5674),
    [anon_sym_DOT] = ACTIONS(5676),
    [anon_sym_DOT_STAR] = ACTIONS(5674),
    [anon_sym_DASH_GT] = ACTIONS(5674),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5674),
    [anon_sym_decltype] = ACTIONS(5674),
    [anon_sym_final] = ACTIONS(5674),
    [anon_sym_override] = ACTIONS(5674),
    [anon_sym_requires] = ACTIONS(5674),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5674),
  },
  [2225] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2226),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5440),
    [anon_sym_COMMA] = ACTIONS(5440),
    [anon_sym_LPAREN2] = ACTIONS(5440),
    [anon_sym_DASH] = ACTIONS(5442),
    [anon_sym_PLUS] = ACTIONS(5442),
    [anon_sym_STAR] = ACTIONS(5440),
    [anon_sym_SLASH] = ACTIONS(5442),
    [anon_sym_PERCENT] = ACTIONS(5440),
    [anon_sym_PIPE_PIPE] = ACTIONS(5440),
    [anon_sym_AMP_AMP] = ACTIONS(5440),
    [anon_sym_PIPE] = ACTIONS(5442),
    [anon_sym_CARET] = ACTIONS(5440),
    [anon_sym_AMP] = ACTIONS(5442),
    [anon_sym_EQ_EQ] = ACTIONS(5440),
    [anon_sym_BANG_EQ] = ACTIONS(5440),
    [anon_sym_GT] = ACTIONS(5442),
    [anon_sym_GT_EQ] = ACTIONS(5442),
    [anon_sym_LT_EQ] = ACTIONS(5442),
    [anon_sym_LT] = ACTIONS(5442),
    [anon_sym_LT_LT] = ACTIONS(5442),
    [anon_sym_GT_GT] = ACTIONS(5442),
    [anon_sym___extension__] = ACTIONS(5440),
    [anon_sym___global__] = ACTIONS(5440),
    [anon_sym___attribute__] = ACTIONS(5440),
    [anon_sym_LBRACE] = ACTIONS(5440),
    [anon_sym_signed] = ACTIONS(5678),
    [anon_sym_unsigned] = ACTIONS(5678),
    [anon_sym_long] = ACTIONS(5678),
    [anon_sym_short] = ACTIONS(5678),
    [anon_sym_LBRACK] = ACTIONS(5440),
    [anon_sym_const] = ACTIONS(5442),
    [anon_sym_constexpr] = ACTIONS(5440),
    [anon_sym_volatile] = ACTIONS(5440),
    [anon_sym_restrict] = ACTIONS(5440),
    [anon_sym___restrict__] = ACTIONS(5440),
    [anon_sym__Atomic] = ACTIONS(5440),
    [anon_sym__Noreturn] = ACTIONS(5440),
    [anon_sym_noreturn] = ACTIONS(5440),
    [anon_sym_mutable] = ACTIONS(5440),
    [anon_sym_constinit] = ACTIONS(5440),
    [anon_sym_consteval] = ACTIONS(5440),
    [anon_sym___shared__] = ACTIONS(5440),
    [anon_sym___local__] = ACTIONS(5440),
    [anon_sym___constant__] = ACTIONS(5440),
    [anon_sym___managed__] = ACTIONS(5440),
    [anon_sym___grid_constant__] = ACTIONS(5440),
    [anon_sym_alignas] = ACTIONS(5440),
    [anon_sym__Alignas] = ACTIONS(5440),
    [anon_sym_QMARK] = ACTIONS(5440),
    [anon_sym_LT_EQ_GT] = ACTIONS(5440),
    [anon_sym_or] = ACTIONS(5440),
    [anon_sym_and] = ACTIONS(5440),
    [anon_sym_bitor] = ACTIONS(5440),
    [anon_sym_xor] = ACTIONS(5440),
    [anon_sym_bitand] = ACTIONS(5440),
    [anon_sym_not_eq] = ACTIONS(5440),
    [anon_sym_DASH_DASH] = ACTIONS(5440),
    [anon_sym_PLUS_PLUS] = ACTIONS(5440),
    [anon_sym_DOT] = ACTIONS(5442),
    [anon_sym_DOT_STAR] = ACTIONS(5440),
    [anon_sym_DASH_GT] = ACTIONS(5440),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5440),
    [anon_sym_decltype] = ACTIONS(5440),
    [anon_sym_final] = ACTIONS(5440),
    [anon_sym_override] = ACTIONS(5440),
    [anon_sym_GT2] = ACTIONS(5440),
    [anon_sym_requires] = ACTIONS(5440),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5440),
  },
  [2226] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5416),
    [anon_sym_COMMA] = ACTIONS(5416),
    [anon_sym_LPAREN2] = ACTIONS(5416),
    [anon_sym_DASH] = ACTIONS(5418),
    [anon_sym_PLUS] = ACTIONS(5418),
    [anon_sym_STAR] = ACTIONS(5416),
    [anon_sym_SLASH] = ACTIONS(5418),
    [anon_sym_PERCENT] = ACTIONS(5416),
    [anon_sym_PIPE_PIPE] = ACTIONS(5416),
    [anon_sym_AMP_AMP] = ACTIONS(5416),
    [anon_sym_PIPE] = ACTIONS(5418),
    [anon_sym_CARET] = ACTIONS(5416),
    [anon_sym_AMP] = ACTIONS(5418),
    [anon_sym_EQ_EQ] = ACTIONS(5416),
    [anon_sym_BANG_EQ] = ACTIONS(5416),
    [anon_sym_GT] = ACTIONS(5418),
    [anon_sym_GT_EQ] = ACTIONS(5418),
    [anon_sym_LT_EQ] = ACTIONS(5418),
    [anon_sym_LT] = ACTIONS(5418),
    [anon_sym_LT_LT] = ACTIONS(5418),
    [anon_sym_GT_GT] = ACTIONS(5418),
    [anon_sym___extension__] = ACTIONS(5416),
    [anon_sym___global__] = ACTIONS(5416),
    [anon_sym___attribute__] = ACTIONS(5416),
    [anon_sym_LBRACE] = ACTIONS(5416),
    [anon_sym_signed] = ACTIONS(5680),
    [anon_sym_unsigned] = ACTIONS(5680),
    [anon_sym_long] = ACTIONS(5680),
    [anon_sym_short] = ACTIONS(5680),
    [anon_sym_LBRACK] = ACTIONS(5416),
    [anon_sym_const] = ACTIONS(5418),
    [anon_sym_constexpr] = ACTIONS(5416),
    [anon_sym_volatile] = ACTIONS(5416),
    [anon_sym_restrict] = ACTIONS(5416),
    [anon_sym___restrict__] = ACTIONS(5416),
    [anon_sym__Atomic] = ACTIONS(5416),
    [anon_sym__Noreturn] = ACTIONS(5416),
    [anon_sym_noreturn] = ACTIONS(5416),
    [anon_sym_mutable] = ACTIONS(5416),
    [anon_sym_constinit] = ACTIONS(5416),
    [anon_sym_consteval] = ACTIONS(5416),
    [anon_sym___shared__] = ACTIONS(5416),
    [anon_sym___local__] = ACTIONS(5416),
    [anon_sym___constant__] = ACTIONS(5416),
    [anon_sym___managed__] = ACTIONS(5416),
    [anon_sym___grid_constant__] = ACTIONS(5416),
    [anon_sym_alignas] = ACTIONS(5416),
    [anon_sym__Alignas] = ACTIONS(5416),
    [anon_sym_QMARK] = ACTIONS(5416),
    [anon_sym_LT_EQ_GT] = ACTIONS(5416),
    [anon_sym_or] = ACTIONS(5416),
    [anon_sym_and] = ACTIONS(5416),
    [anon_sym_bitor] = ACTIONS(5416),
    [anon_sym_xor] = ACTIONS(5416),
    [anon_sym_bitand] = ACTIONS(5416),
    [anon_sym_not_eq] = ACTIONS(5416),
    [anon_sym_DASH_DASH] = ACTIONS(5416),
    [anon_sym_PLUS_PLUS] = ACTIONS(5416),
    [anon_sym_DOT] = ACTIONS(5418),
    [anon_sym_DOT_STAR] = ACTIONS(5416),
    [anon_sym_DASH_GT] = ACTIONS(5416),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5416),
    [anon_sym_decltype] = ACTIONS(5416),
    [anon_sym_final] = ACTIONS(5416),
    [anon_sym_override] = ACTIONS(5416),
    [anon_sym_GT2] = ACTIONS(5416),
    [anon_sym_requires] = ACTIONS(5416),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5416),
  },
  [2227] = {
    [sym_attribute_specifier] = STATE(1909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5682),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_RPAREN] = ACTIONS(5682),
    [anon_sym_LPAREN2] = ACTIONS(5682),
    [anon_sym_DASH] = ACTIONS(5684),
    [anon_sym_PLUS] = ACTIONS(5684),
    [anon_sym_STAR] = ACTIONS(5682),
    [anon_sym_SLASH] = ACTIONS(5684),
    [anon_sym_PERCENT] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_EQ_EQ] = ACTIONS(5682),
    [anon_sym_BANG_EQ] = ACTIONS(5682),
    [anon_sym_GT] = ACTIONS(5684),
    [anon_sym_GT_EQ] = ACTIONS(5682),
    [anon_sym_LT_EQ] = ACTIONS(5684),
    [anon_sym_LT] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(5684),
    [anon_sym_GT_GT] = ACTIONS(5682),
    [anon_sym_SEMI] = ACTIONS(5682),
    [anon_sym___extension__] = ACTIONS(5682),
    [anon_sym___global__] = ACTIONS(5682),
    [anon_sym___attribute__] = ACTIONS(5510),
    [anon_sym_LBRACE] = ACTIONS(5682),
    [anon_sym_RBRACE] = ACTIONS(5682),
    [anon_sym_LBRACK] = ACTIONS(5682),
    [anon_sym_RBRACK] = ACTIONS(5682),
    [anon_sym_const] = ACTIONS(5684),
    [anon_sym_constexpr] = ACTIONS(5682),
    [anon_sym_volatile] = ACTIONS(5682),
    [anon_sym_restrict] = ACTIONS(5682),
    [anon_sym___restrict__] = ACTIONS(5682),
    [anon_sym__Atomic] = ACTIONS(5682),
    [anon_sym__Noreturn] = ACTIONS(5682),
    [anon_sym_noreturn] = ACTIONS(5682),
    [anon_sym_mutable] = ACTIONS(5682),
    [anon_sym_constinit] = ACTIONS(5682),
    [anon_sym_consteval] = ACTIONS(5682),
    [anon_sym___shared__] = ACTIONS(5682),
    [anon_sym___local__] = ACTIONS(5682),
    [anon_sym___constant__] = ACTIONS(5682),
    [anon_sym___managed__] = ACTIONS(5682),
    [anon_sym___grid_constant__] = ACTIONS(5682),
    [anon_sym_alignas] = ACTIONS(5682),
    [anon_sym__Alignas] = ACTIONS(5682),
    [anon_sym_COLON] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5682),
    [anon_sym_LT_EQ_GT] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5682),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_bitor] = ACTIONS(5682),
    [anon_sym_xor] = ACTIONS(5682),
    [anon_sym_bitand] = ACTIONS(5682),
    [anon_sym_not_eq] = ACTIONS(5682),
    [anon_sym_DASH_DASH] = ACTIONS(5682),
    [anon_sym_PLUS_PLUS] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(5684),
    [anon_sym_DOT_STAR] = ACTIONS(5682),
    [anon_sym_DASH_GT] = ACTIONS(5682),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5682),
    [anon_sym_decltype] = ACTIONS(5682),
    [anon_sym_final] = ACTIONS(5682),
    [anon_sym_override] = ACTIONS(5682),
    [anon_sym_requires] = ACTIONS(5682),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5682),
  },
  [2228] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2219),
    [sym_identifier] = ACTIONS(5374),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5376),
    [anon_sym_COMMA] = ACTIONS(5376),
    [anon_sym_RPAREN] = ACTIONS(5376),
    [anon_sym_LPAREN2] = ACTIONS(5376),
    [anon_sym_TILDE] = ACTIONS(5376),
    [anon_sym_STAR] = ACTIONS(5376),
    [anon_sym_AMP_AMP] = ACTIONS(5376),
    [anon_sym_AMP] = ACTIONS(5374),
    [anon_sym_SEMI] = ACTIONS(5376),
    [anon_sym___extension__] = ACTIONS(5374),
    [anon_sym___device__] = ACTIONS(5374),
    [anon_sym___host__] = ACTIONS(5374),
    [anon_sym___global__] = ACTIONS(5374),
    [anon_sym___forceinline__] = ACTIONS(5374),
    [anon_sym___noinline__] = ACTIONS(5374),
    [anon_sym_extern] = ACTIONS(5374),
    [anon_sym___attribute__] = ACTIONS(5374),
    [anon_sym_COLON_COLON] = ACTIONS(5376),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5376),
    [anon_sym___declspec] = ACTIONS(5374),
    [anon_sym___based] = ACTIONS(5374),
    [anon_sym___cdecl] = ACTIONS(5374),
    [anon_sym___clrcall] = ACTIONS(5374),
    [anon_sym___stdcall] = ACTIONS(5374),
    [anon_sym___fastcall] = ACTIONS(5374),
    [anon_sym___thiscall] = ACTIONS(5374),
    [anon_sym___vectorcall] = ACTIONS(5374),
    [anon_sym_LBRACE] = ACTIONS(5376),
    [anon_sym_signed] = ACTIONS(5617),
    [anon_sym_unsigned] = ACTIONS(5617),
    [anon_sym_long] = ACTIONS(5617),
    [anon_sym_short] = ACTIONS(5617),
    [anon_sym_LBRACK] = ACTIONS(5374),
    [anon_sym_static] = ACTIONS(5374),
    [anon_sym_EQ] = ACTIONS(5376),
    [anon_sym_register] = ACTIONS(5374),
    [anon_sym_inline] = ACTIONS(5374),
    [anon_sym___inline] = ACTIONS(5374),
    [anon_sym___inline__] = ACTIONS(5374),
    [anon_sym___forceinline] = ACTIONS(5374),
    [anon_sym_thread_local] = ACTIONS(5374),
    [anon_sym___thread] = ACTIONS(5374),
    [anon_sym_const] = ACTIONS(5374),
    [anon_sym_constexpr] = ACTIONS(5374),
    [anon_sym_volatile] = ACTIONS(5374),
    [anon_sym_restrict] = ACTIONS(5374),
    [anon_sym___restrict__] = ACTIONS(5374),
    [anon_sym__Atomic] = ACTIONS(5374),
    [anon_sym__Noreturn] = ACTIONS(5374),
    [anon_sym_noreturn] = ACTIONS(5374),
    [anon_sym_mutable] = ACTIONS(5374),
    [anon_sym_constinit] = ACTIONS(5374),
    [anon_sym_consteval] = ACTIONS(5374),
    [anon_sym___shared__] = ACTIONS(5374),
    [anon_sym___local__] = ACTIONS(5374),
    [anon_sym___constant__] = ACTIONS(5374),
    [anon_sym___managed__] = ACTIONS(5374),
    [anon_sym___grid_constant__] = ACTIONS(5374),
    [anon_sym_alignas] = ACTIONS(5374),
    [anon_sym__Alignas] = ACTIONS(5374),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5374),
    [anon_sym_decltype] = ACTIONS(5374),
    [sym_virtual] = ACTIONS(5374),
    [anon_sym_template] = ACTIONS(5374),
    [anon_sym_GT2] = ACTIONS(5376),
    [anon_sym_operator] = ACTIONS(5374),
    [anon_sym___launch_bounds__] = ACTIONS(5374),
  },
  [2229] = {
    [sym_attribute_specifier] = STATE(1874),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5686),
    [anon_sym_COMMA] = ACTIONS(5686),
    [anon_sym_RPAREN] = ACTIONS(5686),
    [anon_sym_LPAREN2] = ACTIONS(5686),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5688),
    [anon_sym_STAR] = ACTIONS(5686),
    [anon_sym_SLASH] = ACTIONS(5688),
    [anon_sym_PERCENT] = ACTIONS(5686),
    [anon_sym_PIPE_PIPE] = ACTIONS(5686),
    [anon_sym_AMP_AMP] = ACTIONS(5686),
    [anon_sym_PIPE] = ACTIONS(5688),
    [anon_sym_CARET] = ACTIONS(5686),
    [anon_sym_AMP] = ACTIONS(5688),
    [anon_sym_EQ_EQ] = ACTIONS(5686),
    [anon_sym_BANG_EQ] = ACTIONS(5686),
    [anon_sym_GT] = ACTIONS(5688),
    [anon_sym_GT_EQ] = ACTIONS(5686),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_LT] = ACTIONS(5688),
    [anon_sym_LT_LT] = ACTIONS(5688),
    [anon_sym_GT_GT] = ACTIONS(5686),
    [anon_sym_SEMI] = ACTIONS(5686),
    [anon_sym___extension__] = ACTIONS(5686),
    [anon_sym___global__] = ACTIONS(5686),
    [anon_sym___attribute__] = ACTIONS(5510),
    [anon_sym_LBRACE] = ACTIONS(5686),
    [anon_sym_RBRACE] = ACTIONS(5686),
    [anon_sym_LBRACK] = ACTIONS(5686),
    [anon_sym_RBRACK] = ACTIONS(5686),
    [anon_sym_const] = ACTIONS(5688),
    [anon_sym_constexpr] = ACTIONS(5686),
    [anon_sym_volatile] = ACTIONS(5686),
    [anon_sym_restrict] = ACTIONS(5686),
    [anon_sym___restrict__] = ACTIONS(5686),
    [anon_sym__Atomic] = ACTIONS(5686),
    [anon_sym__Noreturn] = ACTIONS(5686),
    [anon_sym_noreturn] = ACTIONS(5686),
    [anon_sym_mutable] = ACTIONS(5686),
    [anon_sym_constinit] = ACTIONS(5686),
    [anon_sym_consteval] = ACTIONS(5686),
    [anon_sym___shared__] = ACTIONS(5686),
    [anon_sym___local__] = ACTIONS(5686),
    [anon_sym___constant__] = ACTIONS(5686),
    [anon_sym___managed__] = ACTIONS(5686),
    [anon_sym___grid_constant__] = ACTIONS(5686),
    [anon_sym_alignas] = ACTIONS(5686),
    [anon_sym__Alignas] = ACTIONS(5686),
    [anon_sym_COLON] = ACTIONS(5686),
    [anon_sym_QMARK] = ACTIONS(5686),
    [anon_sym_LT_EQ_GT] = ACTIONS(5686),
    [anon_sym_or] = ACTIONS(5686),
    [anon_sym_and] = ACTIONS(5686),
    [anon_sym_bitor] = ACTIONS(5686),
    [anon_sym_xor] = ACTIONS(5686),
    [anon_sym_bitand] = ACTIONS(5686),
    [anon_sym_not_eq] = ACTIONS(5686),
    [anon_sym_DASH_DASH] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5686),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_DOT_STAR] = ACTIONS(5686),
    [anon_sym_DASH_GT] = ACTIONS(5686),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5686),
    [anon_sym_decltype] = ACTIONS(5686),
    [anon_sym_final] = ACTIONS(5686),
    [anon_sym_override] = ACTIONS(5686),
    [anon_sym_requires] = ACTIONS(5686),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5686),
  },
  [2230] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5432),
    [anon_sym_COMMA] = ACTIONS(5432),
    [anon_sym_LPAREN2] = ACTIONS(5432),
    [anon_sym_DASH] = ACTIONS(5434),
    [anon_sym_PLUS] = ACTIONS(5434),
    [anon_sym_STAR] = ACTIONS(5432),
    [anon_sym_SLASH] = ACTIONS(5434),
    [anon_sym_PERCENT] = ACTIONS(5432),
    [anon_sym_PIPE_PIPE] = ACTIONS(5432),
    [anon_sym_AMP_AMP] = ACTIONS(5432),
    [anon_sym_PIPE] = ACTIONS(5434),
    [anon_sym_CARET] = ACTIONS(5432),
    [anon_sym_AMP] = ACTIONS(5434),
    [anon_sym_EQ_EQ] = ACTIONS(5432),
    [anon_sym_BANG_EQ] = ACTIONS(5432),
    [anon_sym_GT] = ACTIONS(5434),
    [anon_sym_GT_EQ] = ACTIONS(5434),
    [anon_sym_LT_EQ] = ACTIONS(5434),
    [anon_sym_LT] = ACTIONS(5434),
    [anon_sym_LT_LT] = ACTIONS(5434),
    [anon_sym_GT_GT] = ACTIONS(5434),
    [anon_sym___extension__] = ACTIONS(5432),
    [anon_sym___global__] = ACTIONS(5432),
    [anon_sym___attribute__] = ACTIONS(5432),
    [anon_sym_LBRACE] = ACTIONS(5432),
    [anon_sym_signed] = ACTIONS(5680),
    [anon_sym_unsigned] = ACTIONS(5680),
    [anon_sym_long] = ACTIONS(5680),
    [anon_sym_short] = ACTIONS(5680),
    [anon_sym_LBRACK] = ACTIONS(5432),
    [anon_sym_const] = ACTIONS(5434),
    [anon_sym_constexpr] = ACTIONS(5432),
    [anon_sym_volatile] = ACTIONS(5432),
    [anon_sym_restrict] = ACTIONS(5432),
    [anon_sym___restrict__] = ACTIONS(5432),
    [anon_sym__Atomic] = ACTIONS(5432),
    [anon_sym__Noreturn] = ACTIONS(5432),
    [anon_sym_noreturn] = ACTIONS(5432),
    [anon_sym_mutable] = ACTIONS(5432),
    [anon_sym_constinit] = ACTIONS(5432),
    [anon_sym_consteval] = ACTIONS(5432),
    [anon_sym___shared__] = ACTIONS(5432),
    [anon_sym___local__] = ACTIONS(5432),
    [anon_sym___constant__] = ACTIONS(5432),
    [anon_sym___managed__] = ACTIONS(5432),
    [anon_sym___grid_constant__] = ACTIONS(5432),
    [anon_sym_alignas] = ACTIONS(5432),
    [anon_sym__Alignas] = ACTIONS(5432),
    [anon_sym_QMARK] = ACTIONS(5432),
    [anon_sym_LT_EQ_GT] = ACTIONS(5432),
    [anon_sym_or] = ACTIONS(5432),
    [anon_sym_and] = ACTIONS(5432),
    [anon_sym_bitor] = ACTIONS(5432),
    [anon_sym_xor] = ACTIONS(5432),
    [anon_sym_bitand] = ACTIONS(5432),
    [anon_sym_not_eq] = ACTIONS(5432),
    [anon_sym_DASH_DASH] = ACTIONS(5432),
    [anon_sym_PLUS_PLUS] = ACTIONS(5432),
    [anon_sym_DOT] = ACTIONS(5434),
    [anon_sym_DOT_STAR] = ACTIONS(5432),
    [anon_sym_DASH_GT] = ACTIONS(5432),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5432),
    [anon_sym_decltype] = ACTIONS(5432),
    [anon_sym_final] = ACTIONS(5432),
    [anon_sym_override] = ACTIONS(5432),
    [anon_sym_GT2] = ACTIONS(5432),
    [anon_sym_requires] = ACTIONS(5432),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5432),
  },
  [2231] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5422),
    [anon_sym_COMMA] = ACTIONS(5422),
    [anon_sym_LPAREN2] = ACTIONS(5422),
    [anon_sym_DASH] = ACTIONS(5424),
    [anon_sym_PLUS] = ACTIONS(5424),
    [anon_sym_STAR] = ACTIONS(5422),
    [anon_sym_SLASH] = ACTIONS(5424),
    [anon_sym_PERCENT] = ACTIONS(5422),
    [anon_sym_PIPE_PIPE] = ACTIONS(5422),
    [anon_sym_AMP_AMP] = ACTIONS(5422),
    [anon_sym_PIPE] = ACTIONS(5424),
    [anon_sym_CARET] = ACTIONS(5422),
    [anon_sym_AMP] = ACTIONS(5424),
    [anon_sym_EQ_EQ] = ACTIONS(5422),
    [anon_sym_BANG_EQ] = ACTIONS(5422),
    [anon_sym_GT] = ACTIONS(5424),
    [anon_sym_GT_EQ] = ACTIONS(5424),
    [anon_sym_LT_EQ] = ACTIONS(5424),
    [anon_sym_LT] = ACTIONS(5424),
    [anon_sym_LT_LT] = ACTIONS(5424),
    [anon_sym_GT_GT] = ACTIONS(5424),
    [anon_sym___extension__] = ACTIONS(5422),
    [anon_sym___global__] = ACTIONS(5422),
    [anon_sym___attribute__] = ACTIONS(5422),
    [anon_sym_LBRACE] = ACTIONS(5422),
    [anon_sym_signed] = ACTIONS(5680),
    [anon_sym_unsigned] = ACTIONS(5680),
    [anon_sym_long] = ACTIONS(5680),
    [anon_sym_short] = ACTIONS(5680),
    [anon_sym_LBRACK] = ACTIONS(5422),
    [anon_sym_const] = ACTIONS(5424),
    [anon_sym_constexpr] = ACTIONS(5422),
    [anon_sym_volatile] = ACTIONS(5422),
    [anon_sym_restrict] = ACTIONS(5422),
    [anon_sym___restrict__] = ACTIONS(5422),
    [anon_sym__Atomic] = ACTIONS(5422),
    [anon_sym__Noreturn] = ACTIONS(5422),
    [anon_sym_noreturn] = ACTIONS(5422),
    [anon_sym_mutable] = ACTIONS(5422),
    [anon_sym_constinit] = ACTIONS(5422),
    [anon_sym_consteval] = ACTIONS(5422),
    [anon_sym___shared__] = ACTIONS(5422),
    [anon_sym___local__] = ACTIONS(5422),
    [anon_sym___constant__] = ACTIONS(5422),
    [anon_sym___managed__] = ACTIONS(5422),
    [anon_sym___grid_constant__] = ACTIONS(5422),
    [anon_sym_alignas] = ACTIONS(5422),
    [anon_sym__Alignas] = ACTIONS(5422),
    [anon_sym_QMARK] = ACTIONS(5422),
    [anon_sym_LT_EQ_GT] = ACTIONS(5422),
    [anon_sym_or] = ACTIONS(5422),
    [anon_sym_and] = ACTIONS(5422),
    [anon_sym_bitor] = ACTIONS(5422),
    [anon_sym_xor] = ACTIONS(5422),
    [anon_sym_bitand] = ACTIONS(5422),
    [anon_sym_not_eq] = ACTIONS(5422),
    [anon_sym_DASH_DASH] = ACTIONS(5422),
    [anon_sym_PLUS_PLUS] = ACTIONS(5422),
    [anon_sym_DOT] = ACTIONS(5424),
    [anon_sym_DOT_STAR] = ACTIONS(5422),
    [anon_sym_DASH_GT] = ACTIONS(5422),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5422),
    [anon_sym_decltype] = ACTIONS(5422),
    [anon_sym_final] = ACTIONS(5422),
    [anon_sym_override] = ACTIONS(5422),
    [anon_sym_GT2] = ACTIONS(5422),
    [anon_sym_requires] = ACTIONS(5422),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5422),
  },
  [2232] = {
    [sym_argument_list] = STATE(2669),
    [sym_initializer_list] = STATE(2669),
    [sym_decltype_auto] = STATE(2460),
    [sym_new_declarator] = STATE(2380),
    [sym_identifier] = ACTIONS(5690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5692),
    [anon_sym_COMMA] = ACTIONS(5692),
    [anon_sym_RPAREN] = ACTIONS(5692),
    [aux_sym_preproc_if_token2] = ACTIONS(5692),
    [aux_sym_preproc_else_token1] = ACTIONS(5692),
    [aux_sym_preproc_elif_token1] = ACTIONS(5690),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5692),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5692),
    [anon_sym_LPAREN2] = ACTIONS(5644),
    [anon_sym_DASH] = ACTIONS(5690),
    [anon_sym_PLUS] = ACTIONS(5690),
    [anon_sym_STAR] = ACTIONS(5690),
    [anon_sym_SLASH] = ACTIONS(5690),
    [anon_sym_PERCENT] = ACTIONS(5690),
    [anon_sym_PIPE_PIPE] = ACTIONS(5692),
    [anon_sym_AMP_AMP] = ACTIONS(5692),
    [anon_sym_PIPE] = ACTIONS(5690),
    [anon_sym_CARET] = ACTIONS(5690),
    [anon_sym_AMP] = ACTIONS(5690),
    [anon_sym_EQ_EQ] = ACTIONS(5692),
    [anon_sym_BANG_EQ] = ACTIONS(5692),
    [anon_sym_GT] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5692),
    [anon_sym_LT_EQ] = ACTIONS(5690),
    [anon_sym_LT] = ACTIONS(5690),
    [anon_sym_LT_LT] = ACTIONS(5690),
    [anon_sym_GT_GT] = ACTIONS(5690),
    [anon_sym_SEMI] = ACTIONS(5692),
    [anon_sym___attribute__] = ACTIONS(5690),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_RBRACE] = ACTIONS(5692),
    [anon_sym_LBRACK] = ACTIONS(5646),
    [anon_sym_RBRACK] = ACTIONS(5692),
    [anon_sym_EQ] = ACTIONS(5690),
    [anon_sym_COLON] = ACTIONS(5692),
    [anon_sym_QMARK] = ACTIONS(5692),
    [anon_sym_STAR_EQ] = ACTIONS(5692),
    [anon_sym_SLASH_EQ] = ACTIONS(5692),
    [anon_sym_PERCENT_EQ] = ACTIONS(5692),
    [anon_sym_PLUS_EQ] = ACTIONS(5692),
    [anon_sym_DASH_EQ] = ACTIONS(5692),
    [anon_sym_LT_LT_EQ] = ACTIONS(5692),
    [anon_sym_GT_GT_EQ] = ACTIONS(5692),
    [anon_sym_AMP_EQ] = ACTIONS(5692),
    [anon_sym_CARET_EQ] = ACTIONS(5692),
    [anon_sym_PIPE_EQ] = ACTIONS(5692),
    [anon_sym_and_eq] = ACTIONS(5690),
    [anon_sym_or_eq] = ACTIONS(5690),
    [anon_sym_xor_eq] = ACTIONS(5690),
    [anon_sym_LT_EQ_GT] = ACTIONS(5692),
    [anon_sym_or] = ACTIONS(5690),
    [anon_sym_and] = ACTIONS(5690),
    [anon_sym_bitor] = ACTIONS(5690),
    [anon_sym_xor] = ACTIONS(5690),
    [anon_sym_bitand] = ACTIONS(5690),
    [anon_sym_not_eq] = ACTIONS(5690),
    [anon_sym_DASH_DASH] = ACTIONS(5692),
    [anon_sym_PLUS_PLUS] = ACTIONS(5692),
    [anon_sym_DOT] = ACTIONS(5690),
    [anon_sym_DOT_STAR] = ACTIONS(5692),
    [anon_sym_DASH_GT] = ACTIONS(5692),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5648),
    [anon_sym_decltype] = ACTIONS(5650),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5692),
  },
  [2233] = {
    [sym_attribute_specifier] = STATE(1944),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5694),
    [anon_sym_COMMA] = ACTIONS(5694),
    [anon_sym_RPAREN] = ACTIONS(5694),
    [anon_sym_LPAREN2] = ACTIONS(5694),
    [anon_sym_DASH] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_STAR] = ACTIONS(5694),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5694),
    [anon_sym_PIPE_PIPE] = ACTIONS(5694),
    [anon_sym_AMP_AMP] = ACTIONS(5694),
    [anon_sym_PIPE] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5694),
    [anon_sym_AMP] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5694),
    [anon_sym_BANG_EQ] = ACTIONS(5694),
    [anon_sym_GT] = ACTIONS(5696),
    [anon_sym_GT_EQ] = ACTIONS(5694),
    [anon_sym_LT_EQ] = ACTIONS(5696),
    [anon_sym_LT] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5694),
    [anon_sym_SEMI] = ACTIONS(5694),
    [anon_sym___extension__] = ACTIONS(5694),
    [anon_sym___global__] = ACTIONS(5694),
    [anon_sym___attribute__] = ACTIONS(5510),
    [anon_sym_LBRACE] = ACTIONS(5694),
    [anon_sym_RBRACE] = ACTIONS(5694),
    [anon_sym_LBRACK] = ACTIONS(5694),
    [anon_sym_RBRACK] = ACTIONS(5694),
    [anon_sym_const] = ACTIONS(5696),
    [anon_sym_constexpr] = ACTIONS(5694),
    [anon_sym_volatile] = ACTIONS(5694),
    [anon_sym_restrict] = ACTIONS(5694),
    [anon_sym___restrict__] = ACTIONS(5694),
    [anon_sym__Atomic] = ACTIONS(5694),
    [anon_sym__Noreturn] = ACTIONS(5694),
    [anon_sym_noreturn] = ACTIONS(5694),
    [anon_sym_mutable] = ACTIONS(5694),
    [anon_sym_constinit] = ACTIONS(5694),
    [anon_sym_consteval] = ACTIONS(5694),
    [anon_sym___shared__] = ACTIONS(5694),
    [anon_sym___local__] = ACTIONS(5694),
    [anon_sym___constant__] = ACTIONS(5694),
    [anon_sym___managed__] = ACTIONS(5694),
    [anon_sym___grid_constant__] = ACTIONS(5694),
    [anon_sym_alignas] = ACTIONS(5694),
    [anon_sym__Alignas] = ACTIONS(5694),
    [anon_sym_COLON] = ACTIONS(5694),
    [anon_sym_QMARK] = ACTIONS(5694),
    [anon_sym_LT_EQ_GT] = ACTIONS(5694),
    [anon_sym_or] = ACTIONS(5694),
    [anon_sym_and] = ACTIONS(5694),
    [anon_sym_bitor] = ACTIONS(5694),
    [anon_sym_xor] = ACTIONS(5694),
    [anon_sym_bitand] = ACTIONS(5694),
    [anon_sym_not_eq] = ACTIONS(5694),
    [anon_sym_DASH_DASH] = ACTIONS(5694),
    [anon_sym_PLUS_PLUS] = ACTIONS(5694),
    [anon_sym_DOT] = ACTIONS(5696),
    [anon_sym_DOT_STAR] = ACTIONS(5694),
    [anon_sym_DASH_GT] = ACTIONS(5694),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5694),
    [anon_sym_decltype] = ACTIONS(5694),
    [anon_sym_final] = ACTIONS(5694),
    [anon_sym_override] = ACTIONS(5694),
    [anon_sym_requires] = ACTIONS(5694),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5694),
  },
  [2234] = {
    [sym_attribute_specifier] = STATE(2094),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5698),
    [anon_sym_RPAREN] = ACTIONS(5698),
    [anon_sym_LPAREN2] = ACTIONS(5698),
    [anon_sym_DASH] = ACTIONS(5700),
    [anon_sym_PLUS] = ACTIONS(5700),
    [anon_sym_STAR] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5700),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_PIPE] = ACTIONS(5700),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_AMP] = ACTIONS(5700),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5700),
    [anon_sym_GT_EQ] = ACTIONS(5698),
    [anon_sym_LT_EQ] = ACTIONS(5700),
    [anon_sym_LT] = ACTIONS(5700),
    [anon_sym_LT_LT] = ACTIONS(5700),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_SEMI] = ACTIONS(5698),
    [anon_sym___extension__] = ACTIONS(5698),
    [anon_sym___global__] = ACTIONS(5698),
    [anon_sym___attribute__] = ACTIONS(5510),
    [anon_sym_LBRACE] = ACTIONS(5698),
    [anon_sym_RBRACE] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5698),
    [anon_sym_RBRACK] = ACTIONS(5698),
    [anon_sym_const] = ACTIONS(5700),
    [anon_sym_constexpr] = ACTIONS(5698),
    [anon_sym_volatile] = ACTIONS(5698),
    [anon_sym_restrict] = ACTIONS(5698),
    [anon_sym___restrict__] = ACTIONS(5698),
    [anon_sym__Atomic] = ACTIONS(5698),
    [anon_sym__Noreturn] = ACTIONS(5698),
    [anon_sym_noreturn] = ACTIONS(5698),
    [anon_sym_mutable] = ACTIONS(5698),
    [anon_sym_constinit] = ACTIONS(5698),
    [anon_sym_consteval] = ACTIONS(5698),
    [anon_sym___shared__] = ACTIONS(5698),
    [anon_sym___local__] = ACTIONS(5698),
    [anon_sym___constant__] = ACTIONS(5698),
    [anon_sym___managed__] = ACTIONS(5698),
    [anon_sym___grid_constant__] = ACTIONS(5698),
    [anon_sym_alignas] = ACTIONS(5698),
    [anon_sym__Alignas] = ACTIONS(5698),
    [anon_sym_COLON] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5698),
    [anon_sym_LT_EQ_GT] = ACTIONS(5698),
    [anon_sym_or] = ACTIONS(5698),
    [anon_sym_and] = ACTIONS(5698),
    [anon_sym_bitor] = ACTIONS(5698),
    [anon_sym_xor] = ACTIONS(5698),
    [anon_sym_bitand] = ACTIONS(5698),
    [anon_sym_not_eq] = ACTIONS(5698),
    [anon_sym_DASH_DASH] = ACTIONS(5698),
    [anon_sym_PLUS_PLUS] = ACTIONS(5698),
    [anon_sym_DOT] = ACTIONS(5700),
    [anon_sym_DOT_STAR] = ACTIONS(5698),
    [anon_sym_DASH_GT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5698),
    [anon_sym_decltype] = ACTIONS(5698),
    [anon_sym_final] = ACTIONS(5698),
    [anon_sym_override] = ACTIONS(5698),
    [anon_sym_requires] = ACTIONS(5698),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5698),
  },
  [2235] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2243),
    [sym_identifier] = ACTIONS(5418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5416),
    [anon_sym_COMMA] = ACTIONS(5416),
    [anon_sym_RPAREN] = ACTIONS(5416),
    [anon_sym_LPAREN2] = ACTIONS(5416),
    [anon_sym_TILDE] = ACTIONS(5416),
    [anon_sym_STAR] = ACTIONS(5416),
    [anon_sym_AMP_AMP] = ACTIONS(5416),
    [anon_sym_AMP] = ACTIONS(5418),
    [anon_sym_SEMI] = ACTIONS(5416),
    [anon_sym___extension__] = ACTIONS(5418),
    [anon_sym___device__] = ACTIONS(5418),
    [anon_sym___host__] = ACTIONS(5418),
    [anon_sym___global__] = ACTIONS(5418),
    [anon_sym___forceinline__] = ACTIONS(5418),
    [anon_sym___noinline__] = ACTIONS(5418),
    [anon_sym_extern] = ACTIONS(5418),
    [anon_sym___attribute__] = ACTIONS(5418),
    [anon_sym_COLON_COLON] = ACTIONS(5416),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5416),
    [anon_sym___declspec] = ACTIONS(5418),
    [anon_sym___based] = ACTIONS(5418),
    [anon_sym___cdecl] = ACTIONS(5418),
    [anon_sym___clrcall] = ACTIONS(5418),
    [anon_sym___stdcall] = ACTIONS(5418),
    [anon_sym___fastcall] = ACTIONS(5418),
    [anon_sym___thiscall] = ACTIONS(5418),
    [anon_sym___vectorcall] = ACTIONS(5418),
    [anon_sym_LBRACE] = ACTIONS(5416),
    [anon_sym_signed] = ACTIONS(5625),
    [anon_sym_unsigned] = ACTIONS(5625),
    [anon_sym_long] = ACTIONS(5625),
    [anon_sym_short] = ACTIONS(5625),
    [anon_sym_LBRACK] = ACTIONS(5418),
    [anon_sym_static] = ACTIONS(5418),
    [anon_sym_EQ] = ACTIONS(5416),
    [anon_sym_register] = ACTIONS(5418),
    [anon_sym_inline] = ACTIONS(5418),
    [anon_sym___inline] = ACTIONS(5418),
    [anon_sym___inline__] = ACTIONS(5418),
    [anon_sym___forceinline] = ACTIONS(5418),
    [anon_sym_thread_local] = ACTIONS(5418),
    [anon_sym___thread] = ACTIONS(5418),
    [anon_sym_const] = ACTIONS(5418),
    [anon_sym_constexpr] = ACTIONS(5418),
    [anon_sym_volatile] = ACTIONS(5418),
    [anon_sym_restrict] = ACTIONS(5418),
    [anon_sym___restrict__] = ACTIONS(5418),
    [anon_sym__Atomic] = ACTIONS(5418),
    [anon_sym__Noreturn] = ACTIONS(5418),
    [anon_sym_noreturn] = ACTIONS(5418),
    [anon_sym_mutable] = ACTIONS(5418),
    [anon_sym_constinit] = ACTIONS(5418),
    [anon_sym_consteval] = ACTIONS(5418),
    [anon_sym___shared__] = ACTIONS(5418),
    [anon_sym___local__] = ACTIONS(5418),
    [anon_sym___constant__] = ACTIONS(5418),
    [anon_sym___managed__] = ACTIONS(5418),
    [anon_sym___grid_constant__] = ACTIONS(5418),
    [anon_sym_alignas] = ACTIONS(5418),
    [anon_sym__Alignas] = ACTIONS(5418),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5418),
    [anon_sym_decltype] = ACTIONS(5418),
    [sym_virtual] = ACTIONS(5418),
    [anon_sym_template] = ACTIONS(5418),
    [anon_sym_GT2] = ACTIONS(5416),
    [anon_sym_operator] = ACTIONS(5418),
    [anon_sym___launch_bounds__] = ACTIONS(5418),
  },
  [2236] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5436),
    [anon_sym_COMMA] = ACTIONS(5436),
    [anon_sym_LPAREN2] = ACTIONS(5436),
    [anon_sym_DASH] = ACTIONS(5438),
    [anon_sym_PLUS] = ACTIONS(5438),
    [anon_sym_STAR] = ACTIONS(5436),
    [anon_sym_SLASH] = ACTIONS(5438),
    [anon_sym_PERCENT] = ACTIONS(5436),
    [anon_sym_PIPE_PIPE] = ACTIONS(5436),
    [anon_sym_AMP_AMP] = ACTIONS(5436),
    [anon_sym_PIPE] = ACTIONS(5438),
    [anon_sym_CARET] = ACTIONS(5436),
    [anon_sym_AMP] = ACTIONS(5438),
    [anon_sym_EQ_EQ] = ACTIONS(5436),
    [anon_sym_BANG_EQ] = ACTIONS(5436),
    [anon_sym_GT] = ACTIONS(5438),
    [anon_sym_GT_EQ] = ACTIONS(5438),
    [anon_sym_LT_EQ] = ACTIONS(5438),
    [anon_sym_LT] = ACTIONS(5438),
    [anon_sym_LT_LT] = ACTIONS(5438),
    [anon_sym_GT_GT] = ACTIONS(5438),
    [anon_sym___extension__] = ACTIONS(5436),
    [anon_sym___global__] = ACTIONS(5436),
    [anon_sym___attribute__] = ACTIONS(5436),
    [anon_sym_LBRACE] = ACTIONS(5436),
    [anon_sym_signed] = ACTIONS(5680),
    [anon_sym_unsigned] = ACTIONS(5680),
    [anon_sym_long] = ACTIONS(5680),
    [anon_sym_short] = ACTIONS(5680),
    [anon_sym_LBRACK] = ACTIONS(5436),
    [anon_sym_const] = ACTIONS(5438),
    [anon_sym_constexpr] = ACTIONS(5436),
    [anon_sym_volatile] = ACTIONS(5436),
    [anon_sym_restrict] = ACTIONS(5436),
    [anon_sym___restrict__] = ACTIONS(5436),
    [anon_sym__Atomic] = ACTIONS(5436),
    [anon_sym__Noreturn] = ACTIONS(5436),
    [anon_sym_noreturn] = ACTIONS(5436),
    [anon_sym_mutable] = ACTIONS(5436),
    [anon_sym_constinit] = ACTIONS(5436),
    [anon_sym_consteval] = ACTIONS(5436),
    [anon_sym___shared__] = ACTIONS(5436),
    [anon_sym___local__] = ACTIONS(5436),
    [anon_sym___constant__] = ACTIONS(5436),
    [anon_sym___managed__] = ACTIONS(5436),
    [anon_sym___grid_constant__] = ACTIONS(5436),
    [anon_sym_alignas] = ACTIONS(5436),
    [anon_sym__Alignas] = ACTIONS(5436),
    [anon_sym_QMARK] = ACTIONS(5436),
    [anon_sym_LT_EQ_GT] = ACTIONS(5436),
    [anon_sym_or] = ACTIONS(5436),
    [anon_sym_and] = ACTIONS(5436),
    [anon_sym_bitor] = ACTIONS(5436),
    [anon_sym_xor] = ACTIONS(5436),
    [anon_sym_bitand] = ACTIONS(5436),
    [anon_sym_not_eq] = ACTIONS(5436),
    [anon_sym_DASH_DASH] = ACTIONS(5436),
    [anon_sym_PLUS_PLUS] = ACTIONS(5436),
    [anon_sym_DOT] = ACTIONS(5438),
    [anon_sym_DOT_STAR] = ACTIONS(5436),
    [anon_sym_DASH_GT] = ACTIONS(5436),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5436),
    [anon_sym_decltype] = ACTIONS(5436),
    [anon_sym_final] = ACTIONS(5436),
    [anon_sym_override] = ACTIONS(5436),
    [anon_sym_GT2] = ACTIONS(5436),
    [anon_sym_requires] = ACTIONS(5436),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5436),
  },
  [2237] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5376),
    [anon_sym_COMMA] = ACTIONS(5376),
    [anon_sym_LPAREN2] = ACTIONS(5376),
    [anon_sym_DASH] = ACTIONS(5374),
    [anon_sym_PLUS] = ACTIONS(5374),
    [anon_sym_STAR] = ACTIONS(5376),
    [anon_sym_SLASH] = ACTIONS(5374),
    [anon_sym_PERCENT] = ACTIONS(5376),
    [anon_sym_PIPE_PIPE] = ACTIONS(5376),
    [anon_sym_AMP_AMP] = ACTIONS(5376),
    [anon_sym_PIPE] = ACTIONS(5374),
    [anon_sym_CARET] = ACTIONS(5376),
    [anon_sym_AMP] = ACTIONS(5374),
    [anon_sym_EQ_EQ] = ACTIONS(5376),
    [anon_sym_BANG_EQ] = ACTIONS(5376),
    [anon_sym_GT] = ACTIONS(5374),
    [anon_sym_GT_EQ] = ACTIONS(5374),
    [anon_sym_LT_EQ] = ACTIONS(5374),
    [anon_sym_LT] = ACTIONS(5374),
    [anon_sym_LT_LT] = ACTIONS(5374),
    [anon_sym_GT_GT] = ACTIONS(5374),
    [anon_sym___extension__] = ACTIONS(5376),
    [anon_sym___global__] = ACTIONS(5376),
    [anon_sym___attribute__] = ACTIONS(5376),
    [anon_sym_LBRACE] = ACTIONS(5376),
    [anon_sym_signed] = ACTIONS(5702),
    [anon_sym_unsigned] = ACTIONS(5702),
    [anon_sym_long] = ACTIONS(5702),
    [anon_sym_short] = ACTIONS(5702),
    [anon_sym_LBRACK] = ACTIONS(5376),
    [anon_sym_const] = ACTIONS(5374),
    [anon_sym_constexpr] = ACTIONS(5376),
    [anon_sym_volatile] = ACTIONS(5376),
    [anon_sym_restrict] = ACTIONS(5376),
    [anon_sym___restrict__] = ACTIONS(5376),
    [anon_sym__Atomic] = ACTIONS(5376),
    [anon_sym__Noreturn] = ACTIONS(5376),
    [anon_sym_noreturn] = ACTIONS(5376),
    [anon_sym_mutable] = ACTIONS(5376),
    [anon_sym_constinit] = ACTIONS(5376),
    [anon_sym_consteval] = ACTIONS(5376),
    [anon_sym___shared__] = ACTIONS(5376),
    [anon_sym___local__] = ACTIONS(5376),
    [anon_sym___constant__] = ACTIONS(5376),
    [anon_sym___managed__] = ACTIONS(5376),
    [anon_sym___grid_constant__] = ACTIONS(5376),
    [anon_sym_alignas] = ACTIONS(5376),
    [anon_sym__Alignas] = ACTIONS(5376),
    [anon_sym_QMARK] = ACTIONS(5376),
    [anon_sym_LT_EQ_GT] = ACTIONS(5376),
    [anon_sym_or] = ACTIONS(5376),
    [anon_sym_and] = ACTIONS(5376),
    [anon_sym_bitor] = ACTIONS(5376),
    [anon_sym_xor] = ACTIONS(5376),
    [anon_sym_bitand] = ACTIONS(5376),
    [anon_sym_not_eq] = ACTIONS(5376),
    [anon_sym_DASH_DASH] = ACTIONS(5376),
    [anon_sym_PLUS_PLUS] = ACTIONS(5376),
    [anon_sym_DOT] = ACTIONS(5374),
    [anon_sym_DOT_STAR] = ACTIONS(5376),
    [anon_sym_DASH_GT] = ACTIONS(5376),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5376),
    [anon_sym_decltype] = ACTIONS(5376),
    [anon_sym_final] = ACTIONS(5376),
    [anon_sym_override] = ACTIONS(5376),
    [anon_sym_GT2] = ACTIONS(5376),
    [anon_sym_requires] = ACTIONS(5376),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5376),
  },
  [2238] = {
    [sym_argument_list] = STATE(2712),
    [sym_initializer_list] = STATE(2712),
    [sym_decltype_auto] = STATE(2460),
    [sym_new_declarator] = STATE(2383),
    [sym_identifier] = ACTIONS(5704),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5706),
    [anon_sym_COMMA] = ACTIONS(5706),
    [anon_sym_RPAREN] = ACTIONS(5706),
    [aux_sym_preproc_if_token2] = ACTIONS(5706),
    [aux_sym_preproc_else_token1] = ACTIONS(5706),
    [aux_sym_preproc_elif_token1] = ACTIONS(5704),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5706),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5706),
    [anon_sym_LPAREN2] = ACTIONS(5644),
    [anon_sym_DASH] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5704),
    [anon_sym_STAR] = ACTIONS(5704),
    [anon_sym_SLASH] = ACTIONS(5704),
    [anon_sym_PERCENT] = ACTIONS(5704),
    [anon_sym_PIPE_PIPE] = ACTIONS(5706),
    [anon_sym_AMP_AMP] = ACTIONS(5706),
    [anon_sym_PIPE] = ACTIONS(5704),
    [anon_sym_CARET] = ACTIONS(5704),
    [anon_sym_AMP] = ACTIONS(5704),
    [anon_sym_EQ_EQ] = ACTIONS(5706),
    [anon_sym_BANG_EQ] = ACTIONS(5706),
    [anon_sym_GT] = ACTIONS(5704),
    [anon_sym_GT_EQ] = ACTIONS(5706),
    [anon_sym_LT_EQ] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5704),
    [anon_sym_LT_LT] = ACTIONS(5704),
    [anon_sym_GT_GT] = ACTIONS(5704),
    [anon_sym_SEMI] = ACTIONS(5706),
    [anon_sym___attribute__] = ACTIONS(5704),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_RBRACE] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5646),
    [anon_sym_RBRACK] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5704),
    [anon_sym_COLON] = ACTIONS(5706),
    [anon_sym_QMARK] = ACTIONS(5706),
    [anon_sym_STAR_EQ] = ACTIONS(5706),
    [anon_sym_SLASH_EQ] = ACTIONS(5706),
    [anon_sym_PERCENT_EQ] = ACTIONS(5706),
    [anon_sym_PLUS_EQ] = ACTIONS(5706),
    [anon_sym_DASH_EQ] = ACTIONS(5706),
    [anon_sym_LT_LT_EQ] = ACTIONS(5706),
    [anon_sym_GT_GT_EQ] = ACTIONS(5706),
    [anon_sym_AMP_EQ] = ACTIONS(5706),
    [anon_sym_CARET_EQ] = ACTIONS(5706),
    [anon_sym_PIPE_EQ] = ACTIONS(5706),
    [anon_sym_and_eq] = ACTIONS(5704),
    [anon_sym_or_eq] = ACTIONS(5704),
    [anon_sym_xor_eq] = ACTIONS(5704),
    [anon_sym_LT_EQ_GT] = ACTIONS(5706),
    [anon_sym_or] = ACTIONS(5704),
    [anon_sym_and] = ACTIONS(5704),
    [anon_sym_bitor] = ACTIONS(5704),
    [anon_sym_xor] = ACTIONS(5704),
    [anon_sym_bitand] = ACTIONS(5704),
    [anon_sym_not_eq] = ACTIONS(5704),
    [anon_sym_DASH_DASH] = ACTIONS(5706),
    [anon_sym_PLUS_PLUS] = ACTIONS(5706),
    [anon_sym_DOT] = ACTIONS(5704),
    [anon_sym_DOT_STAR] = ACTIONS(5706),
    [anon_sym_DASH_GT] = ACTIONS(5706),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5648),
    [anon_sym_decltype] = ACTIONS(5650),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5706),
  },
  [2239] = {
    [sym_string_literal] = STATE(2067),
    [sym_raw_string_literal] = STATE(2067),
    [sym_identifier] = ACTIONS(3766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [aux_sym_preproc_if_token2] = ACTIONS(3758),
    [aux_sym_preproc_else_token1] = ACTIONS(3758),
    [aux_sym_preproc_elif_token1] = ACTIONS(3766),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3758),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3758),
    [anon_sym_SLASH_EQ] = ACTIONS(3758),
    [anon_sym_PERCENT_EQ] = ACTIONS(3758),
    [anon_sym_PLUS_EQ] = ACTIONS(3758),
    [anon_sym_DASH_EQ] = ACTIONS(3758),
    [anon_sym_LT_LT_EQ] = ACTIONS(3758),
    [anon_sym_GT_GT_EQ] = ACTIONS(3758),
    [anon_sym_AMP_EQ] = ACTIONS(3758),
    [anon_sym_CARET_EQ] = ACTIONS(3758),
    [anon_sym_PIPE_EQ] = ACTIONS(3758),
    [anon_sym_and_eq] = ACTIONS(3766),
    [anon_sym_or_eq] = ACTIONS(3766),
    [anon_sym_xor_eq] = ACTIONS(3766),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3766),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3766),
    [anon_sym_not_eq] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [sym_literal_suffix] = ACTIONS(5708),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2240] = {
    [sym_ms_based_modifier] = STATE(8796),
    [sym_ms_unaligned_ptr_modifier] = STATE(4253),
    [sym_ms_pointer_modifier] = STATE(2212),
    [sym__declarator] = STATE(6744),
    [sym__abstract_declarator] = STATE(6923),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_abstract_parenthesized_declarator] = STATE(6430),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_abstract_pointer_declarator] = STATE(6430),
    [sym_function_declarator] = STATE(6598),
    [sym_abstract_function_declarator] = STATE(6430),
    [sym_array_declarator] = STATE(6598),
    [sym_abstract_array_declarator] = STATE(6430),
    [sym_type_qualifier] = STATE(2761),
    [sym_alignas_qualifier] = STATE(4511),
    [sym_parameter_list] = STATE(2989),
    [sym_decltype] = STATE(8628),
    [sym_reference_declarator] = STATE(6598),
    [sym_abstract_reference_declarator] = STATE(6430),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym__function_declarator_seq] = STATE(6416),
    [sym_template_type] = STATE(8628),
    [sym_template_function] = STATE(6598),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6094),
    [sym_qualified_identifier] = STATE(6598),
    [sym_operator_name] = STATE(6598),
    [aux_sym__type_definition_type_repeat1] = STATE(2761),
    [aux_sym_pointer_declarator_repeat1] = STATE(2212),
    [sym_identifier] = ACTIONS(4994),
    [anon_sym_RPAREN] = ACTIONS(5484),
    [anon_sym_LPAREN2] = ACTIONS(3957),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(3959),
    [anon_sym_AMP_AMP] = ACTIONS(3961),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym___extension__] = ACTIONS(3171),
    [anon_sym___global__] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(5631),
    [anon_sym___based] = ACTIONS(49),
    [sym_ms_restrict_modifier] = ACTIONS(3173),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3173),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3173),
    [anon_sym__unaligned] = ACTIONS(3175),
    [anon_sym___unaligned] = ACTIONS(3175),
    [anon_sym_LBRACK] = ACTIONS(5494),
    [anon_sym_const] = ACTIONS(3171),
    [anon_sym_constexpr] = ACTIONS(3171),
    [anon_sym_volatile] = ACTIONS(3171),
    [anon_sym_restrict] = ACTIONS(3171),
    [anon_sym___restrict__] = ACTIONS(3171),
    [anon_sym__Atomic] = ACTIONS(3171),
    [anon_sym__Noreturn] = ACTIONS(3171),
    [anon_sym_noreturn] = ACTIONS(3171),
    [anon_sym_mutable] = ACTIONS(3171),
    [anon_sym_constinit] = ACTIONS(3171),
    [anon_sym_consteval] = ACTIONS(3171),
    [anon_sym___shared__] = ACTIONS(3171),
    [anon_sym___local__] = ACTIONS(3171),
    [anon_sym___constant__] = ACTIONS(3171),
    [anon_sym___managed__] = ACTIONS(3171),
    [anon_sym___grid_constant__] = ACTIONS(3171),
    [anon_sym_alignas] = ACTIONS(3177),
    [anon_sym__Alignas] = ACTIONS(3177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_operator] = ACTIONS(1883),
  },
  [2241] = {
    [sym_string_literal] = STATE(2067),
    [sym_raw_string_literal] = STATE(2067),
    [sym_identifier] = ACTIONS(5710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5712),
    [anon_sym_COMMA] = ACTIONS(5712),
    [aux_sym_preproc_if_token2] = ACTIONS(5712),
    [aux_sym_preproc_else_token1] = ACTIONS(5712),
    [aux_sym_preproc_elif_token1] = ACTIONS(5710),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5712),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5712),
    [anon_sym_LPAREN2] = ACTIONS(5712),
    [anon_sym_DASH] = ACTIONS(5710),
    [anon_sym_PLUS] = ACTIONS(5710),
    [anon_sym_STAR] = ACTIONS(5710),
    [anon_sym_SLASH] = ACTIONS(5710),
    [anon_sym_PERCENT] = ACTIONS(5710),
    [anon_sym_PIPE_PIPE] = ACTIONS(5712),
    [anon_sym_AMP_AMP] = ACTIONS(5712),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_CARET] = ACTIONS(5710),
    [anon_sym_AMP] = ACTIONS(5710),
    [anon_sym_EQ_EQ] = ACTIONS(5712),
    [anon_sym_BANG_EQ] = ACTIONS(5712),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_EQ] = ACTIONS(5712),
    [anon_sym_LT_EQ] = ACTIONS(5710),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5710),
    [anon_sym_LBRACK] = ACTIONS(5712),
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_QMARK] = ACTIONS(5712),
    [anon_sym_STAR_EQ] = ACTIONS(5712),
    [anon_sym_SLASH_EQ] = ACTIONS(5712),
    [anon_sym_PERCENT_EQ] = ACTIONS(5712),
    [anon_sym_PLUS_EQ] = ACTIONS(5712),
    [anon_sym_DASH_EQ] = ACTIONS(5712),
    [anon_sym_LT_LT_EQ] = ACTIONS(5712),
    [anon_sym_GT_GT_EQ] = ACTIONS(5712),
    [anon_sym_AMP_EQ] = ACTIONS(5712),
    [anon_sym_CARET_EQ] = ACTIONS(5712),
    [anon_sym_PIPE_EQ] = ACTIONS(5712),
    [anon_sym_and_eq] = ACTIONS(5710),
    [anon_sym_or_eq] = ACTIONS(5710),
    [anon_sym_xor_eq] = ACTIONS(5710),
    [anon_sym_LT_EQ_GT] = ACTIONS(5712),
    [anon_sym_or] = ACTIONS(5710),
    [anon_sym_and] = ACTIONS(5710),
    [anon_sym_bitor] = ACTIONS(5710),
    [anon_sym_xor] = ACTIONS(5710),
    [anon_sym_bitand] = ACTIONS(5710),
    [anon_sym_not_eq] = ACTIONS(5710),
    [anon_sym_DASH_DASH] = ACTIONS(5712),
    [anon_sym_PLUS_PLUS] = ACTIONS(5712),
    [anon_sym_DOT] = ACTIONS(5710),
    [anon_sym_DOT_STAR] = ACTIONS(5712),
    [anon_sym_DASH_GT] = ACTIONS(5712),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [sym_literal_suffix] = ACTIONS(5708),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5712),
  },
  [2242] = {
    [sym_attribute_specifier] = STATE(2085),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5714),
    [anon_sym_COMMA] = ACTIONS(5714),
    [anon_sym_RPAREN] = ACTIONS(5714),
    [anon_sym_LPAREN2] = ACTIONS(5714),
    [anon_sym_DASH] = ACTIONS(5716),
    [anon_sym_PLUS] = ACTIONS(5716),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_SLASH] = ACTIONS(5716),
    [anon_sym_PERCENT] = ACTIONS(5714),
    [anon_sym_PIPE_PIPE] = ACTIONS(5714),
    [anon_sym_AMP_AMP] = ACTIONS(5714),
    [anon_sym_PIPE] = ACTIONS(5716),
    [anon_sym_CARET] = ACTIONS(5714),
    [anon_sym_AMP] = ACTIONS(5716),
    [anon_sym_EQ_EQ] = ACTIONS(5714),
    [anon_sym_BANG_EQ] = ACTIONS(5714),
    [anon_sym_GT] = ACTIONS(5716),
    [anon_sym_GT_EQ] = ACTIONS(5714),
    [anon_sym_LT_EQ] = ACTIONS(5716),
    [anon_sym_LT] = ACTIONS(5716),
    [anon_sym_LT_LT] = ACTIONS(5716),
    [anon_sym_GT_GT] = ACTIONS(5714),
    [anon_sym_SEMI] = ACTIONS(5714),
    [anon_sym___extension__] = ACTIONS(5714),
    [anon_sym___global__] = ACTIONS(5714),
    [anon_sym___attribute__] = ACTIONS(5510),
    [anon_sym_LBRACE] = ACTIONS(5714),
    [anon_sym_RBRACE] = ACTIONS(5714),
    [anon_sym_LBRACK] = ACTIONS(5714),
    [anon_sym_RBRACK] = ACTIONS(5714),
    [anon_sym_const] = ACTIONS(5716),
    [anon_sym_constexpr] = ACTIONS(5714),
    [anon_sym_volatile] = ACTIONS(5714),
    [anon_sym_restrict] = ACTIONS(5714),
    [anon_sym___restrict__] = ACTIONS(5714),
    [anon_sym__Atomic] = ACTIONS(5714),
    [anon_sym__Noreturn] = ACTIONS(5714),
    [anon_sym_noreturn] = ACTIONS(5714),
    [anon_sym_mutable] = ACTIONS(5714),
    [anon_sym_constinit] = ACTIONS(5714),
    [anon_sym_consteval] = ACTIONS(5714),
    [anon_sym___shared__] = ACTIONS(5714),
    [anon_sym___local__] = ACTIONS(5714),
    [anon_sym___constant__] = ACTIONS(5714),
    [anon_sym___managed__] = ACTIONS(5714),
    [anon_sym___grid_constant__] = ACTIONS(5714),
    [anon_sym_alignas] = ACTIONS(5714),
    [anon_sym__Alignas] = ACTIONS(5714),
    [anon_sym_COLON] = ACTIONS(5714),
    [anon_sym_QMARK] = ACTIONS(5714),
    [anon_sym_LT_EQ_GT] = ACTIONS(5714),
    [anon_sym_or] = ACTIONS(5714),
    [anon_sym_and] = ACTIONS(5714),
    [anon_sym_bitor] = ACTIONS(5714),
    [anon_sym_xor] = ACTIONS(5714),
    [anon_sym_bitand] = ACTIONS(5714),
    [anon_sym_not_eq] = ACTIONS(5714),
    [anon_sym_DASH_DASH] = ACTIONS(5714),
    [anon_sym_PLUS_PLUS] = ACTIONS(5714),
    [anon_sym_DOT] = ACTIONS(5716),
    [anon_sym_DOT_STAR] = ACTIONS(5714),
    [anon_sym_DASH_GT] = ACTIONS(5714),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5714),
    [anon_sym_decltype] = ACTIONS(5714),
    [anon_sym_final] = ACTIONS(5714),
    [anon_sym_override] = ACTIONS(5714),
    [anon_sym_requires] = ACTIONS(5714),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5714),
  },
  [2243] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2243),
    [sym_identifier] = ACTIONS(5016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5018),
    [anon_sym_COMMA] = ACTIONS(5018),
    [anon_sym_RPAREN] = ACTIONS(5018),
    [anon_sym_LPAREN2] = ACTIONS(5018),
    [anon_sym_TILDE] = ACTIONS(5018),
    [anon_sym_STAR] = ACTIONS(5018),
    [anon_sym_AMP_AMP] = ACTIONS(5018),
    [anon_sym_AMP] = ACTIONS(5016),
    [anon_sym_SEMI] = ACTIONS(5018),
    [anon_sym___extension__] = ACTIONS(5016),
    [anon_sym___device__] = ACTIONS(5016),
    [anon_sym___host__] = ACTIONS(5016),
    [anon_sym___global__] = ACTIONS(5016),
    [anon_sym___forceinline__] = ACTIONS(5016),
    [anon_sym___noinline__] = ACTIONS(5016),
    [anon_sym_extern] = ACTIONS(5016),
    [anon_sym___attribute__] = ACTIONS(5016),
    [anon_sym_COLON_COLON] = ACTIONS(5018),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5018),
    [anon_sym___declspec] = ACTIONS(5016),
    [anon_sym___based] = ACTIONS(5016),
    [anon_sym___cdecl] = ACTIONS(5016),
    [anon_sym___clrcall] = ACTIONS(5016),
    [anon_sym___stdcall] = ACTIONS(5016),
    [anon_sym___fastcall] = ACTIONS(5016),
    [anon_sym___thiscall] = ACTIONS(5016),
    [anon_sym___vectorcall] = ACTIONS(5016),
    [anon_sym_LBRACE] = ACTIONS(5018),
    [anon_sym_signed] = ACTIONS(5718),
    [anon_sym_unsigned] = ACTIONS(5718),
    [anon_sym_long] = ACTIONS(5718),
    [anon_sym_short] = ACTIONS(5718),
    [anon_sym_LBRACK] = ACTIONS(5016),
    [anon_sym_static] = ACTIONS(5016),
    [anon_sym_EQ] = ACTIONS(5018),
    [anon_sym_register] = ACTIONS(5016),
    [anon_sym_inline] = ACTIONS(5016),
    [anon_sym___inline] = ACTIONS(5016),
    [anon_sym___inline__] = ACTIONS(5016),
    [anon_sym___forceinline] = ACTIONS(5016),
    [anon_sym_thread_local] = ACTIONS(5016),
    [anon_sym___thread] = ACTIONS(5016),
    [anon_sym_const] = ACTIONS(5016),
    [anon_sym_constexpr] = ACTIONS(5016),
    [anon_sym_volatile] = ACTIONS(5016),
    [anon_sym_restrict] = ACTIONS(5016),
    [anon_sym___restrict__] = ACTIONS(5016),
    [anon_sym__Atomic] = ACTIONS(5016),
    [anon_sym__Noreturn] = ACTIONS(5016),
    [anon_sym_noreturn] = ACTIONS(5016),
    [anon_sym_mutable] = ACTIONS(5016),
    [anon_sym_constinit] = ACTIONS(5016),
    [anon_sym_consteval] = ACTIONS(5016),
    [anon_sym___shared__] = ACTIONS(5016),
    [anon_sym___local__] = ACTIONS(5016),
    [anon_sym___constant__] = ACTIONS(5016),
    [anon_sym___managed__] = ACTIONS(5016),
    [anon_sym___grid_constant__] = ACTIONS(5016),
    [anon_sym_alignas] = ACTIONS(5016),
    [anon_sym__Alignas] = ACTIONS(5016),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5016),
    [anon_sym_decltype] = ACTIONS(5016),
    [sym_virtual] = ACTIONS(5016),
    [anon_sym_template] = ACTIONS(5016),
    [anon_sym_GT2] = ACTIONS(5018),
    [anon_sym_operator] = ACTIONS(5016),
    [anon_sym___launch_bounds__] = ACTIONS(5016),
  },
  [2244] = {
    [sym_attribute_specifier] = STATE(2091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5721),
    [anon_sym_COMMA] = ACTIONS(5721),
    [anon_sym_RPAREN] = ACTIONS(5721),
    [anon_sym_LPAREN2] = ACTIONS(5721),
    [anon_sym_DASH] = ACTIONS(5723),
    [anon_sym_PLUS] = ACTIONS(5723),
    [anon_sym_STAR] = ACTIONS(5721),
    [anon_sym_SLASH] = ACTIONS(5723),
    [anon_sym_PERCENT] = ACTIONS(5721),
    [anon_sym_PIPE_PIPE] = ACTIONS(5721),
    [anon_sym_AMP_AMP] = ACTIONS(5721),
    [anon_sym_PIPE] = ACTIONS(5723),
    [anon_sym_CARET] = ACTIONS(5721),
    [anon_sym_AMP] = ACTIONS(5723),
    [anon_sym_EQ_EQ] = ACTIONS(5721),
    [anon_sym_BANG_EQ] = ACTIONS(5721),
    [anon_sym_GT] = ACTIONS(5723),
    [anon_sym_GT_EQ] = ACTIONS(5721),
    [anon_sym_LT_EQ] = ACTIONS(5723),
    [anon_sym_LT] = ACTIONS(5723),
    [anon_sym_LT_LT] = ACTIONS(5723),
    [anon_sym_GT_GT] = ACTIONS(5721),
    [anon_sym_SEMI] = ACTIONS(5721),
    [anon_sym___extension__] = ACTIONS(5721),
    [anon_sym___global__] = ACTIONS(5721),
    [anon_sym___attribute__] = ACTIONS(5510),
    [anon_sym_LBRACE] = ACTIONS(5721),
    [anon_sym_RBRACE] = ACTIONS(5721),
    [anon_sym_LBRACK] = ACTIONS(5721),
    [anon_sym_RBRACK] = ACTIONS(5721),
    [anon_sym_const] = ACTIONS(5723),
    [anon_sym_constexpr] = ACTIONS(5721),
    [anon_sym_volatile] = ACTIONS(5721),
    [anon_sym_restrict] = ACTIONS(5721),
    [anon_sym___restrict__] = ACTIONS(5721),
    [anon_sym__Atomic] = ACTIONS(5721),
    [anon_sym__Noreturn] = ACTIONS(5721),
    [anon_sym_noreturn] = ACTIONS(5721),
    [anon_sym_mutable] = ACTIONS(5721),
    [anon_sym_constinit] = ACTIONS(5721),
    [anon_sym_consteval] = ACTIONS(5721),
    [anon_sym___shared__] = ACTIONS(5721),
    [anon_sym___local__] = ACTIONS(5721),
    [anon_sym___constant__] = ACTIONS(5721),
    [anon_sym___managed__] = ACTIONS(5721),
    [anon_sym___grid_constant__] = ACTIONS(5721),
    [anon_sym_alignas] = ACTIONS(5721),
    [anon_sym__Alignas] = ACTIONS(5721),
    [anon_sym_COLON] = ACTIONS(5721),
    [anon_sym_QMARK] = ACTIONS(5721),
    [anon_sym_LT_EQ_GT] = ACTIONS(5721),
    [anon_sym_or] = ACTIONS(5721),
    [anon_sym_and] = ACTIONS(5721),
    [anon_sym_bitor] = ACTIONS(5721),
    [anon_sym_xor] = ACTIONS(5721),
    [anon_sym_bitand] = ACTIONS(5721),
    [anon_sym_not_eq] = ACTIONS(5721),
    [anon_sym_DASH_DASH] = ACTIONS(5721),
    [anon_sym_PLUS_PLUS] = ACTIONS(5721),
    [anon_sym_DOT] = ACTIONS(5723),
    [anon_sym_DOT_STAR] = ACTIONS(5721),
    [anon_sym_DASH_GT] = ACTIONS(5721),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5721),
    [anon_sym_decltype] = ACTIONS(5721),
    [anon_sym_final] = ACTIONS(5721),
    [anon_sym_override] = ACTIONS(5721),
    [anon_sym_requires] = ACTIONS(5721),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5721),
  },
  [2245] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2243),
    [sym_identifier] = ACTIONS(5434),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5432),
    [anon_sym_COMMA] = ACTIONS(5432),
    [anon_sym_RPAREN] = ACTIONS(5432),
    [anon_sym_LPAREN2] = ACTIONS(5432),
    [anon_sym_TILDE] = ACTIONS(5432),
    [anon_sym_STAR] = ACTIONS(5432),
    [anon_sym_AMP_AMP] = ACTIONS(5432),
    [anon_sym_AMP] = ACTIONS(5434),
    [anon_sym_SEMI] = ACTIONS(5432),
    [anon_sym___extension__] = ACTIONS(5434),
    [anon_sym___device__] = ACTIONS(5434),
    [anon_sym___host__] = ACTIONS(5434),
    [anon_sym___global__] = ACTIONS(5434),
    [anon_sym___forceinline__] = ACTIONS(5434),
    [anon_sym___noinline__] = ACTIONS(5434),
    [anon_sym_extern] = ACTIONS(5434),
    [anon_sym___attribute__] = ACTIONS(5434),
    [anon_sym_COLON_COLON] = ACTIONS(5432),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5432),
    [anon_sym___declspec] = ACTIONS(5434),
    [anon_sym___based] = ACTIONS(5434),
    [anon_sym___cdecl] = ACTIONS(5434),
    [anon_sym___clrcall] = ACTIONS(5434),
    [anon_sym___stdcall] = ACTIONS(5434),
    [anon_sym___fastcall] = ACTIONS(5434),
    [anon_sym___thiscall] = ACTIONS(5434),
    [anon_sym___vectorcall] = ACTIONS(5434),
    [anon_sym_LBRACE] = ACTIONS(5432),
    [anon_sym_signed] = ACTIONS(5625),
    [anon_sym_unsigned] = ACTIONS(5625),
    [anon_sym_long] = ACTIONS(5625),
    [anon_sym_short] = ACTIONS(5625),
    [anon_sym_LBRACK] = ACTIONS(5434),
    [anon_sym_static] = ACTIONS(5434),
    [anon_sym_EQ] = ACTIONS(5432),
    [anon_sym_register] = ACTIONS(5434),
    [anon_sym_inline] = ACTIONS(5434),
    [anon_sym___inline] = ACTIONS(5434),
    [anon_sym___inline__] = ACTIONS(5434),
    [anon_sym___forceinline] = ACTIONS(5434),
    [anon_sym_thread_local] = ACTIONS(5434),
    [anon_sym___thread] = ACTIONS(5434),
    [anon_sym_const] = ACTIONS(5434),
    [anon_sym_constexpr] = ACTIONS(5434),
    [anon_sym_volatile] = ACTIONS(5434),
    [anon_sym_restrict] = ACTIONS(5434),
    [anon_sym___restrict__] = ACTIONS(5434),
    [anon_sym__Atomic] = ACTIONS(5434),
    [anon_sym__Noreturn] = ACTIONS(5434),
    [anon_sym_noreturn] = ACTIONS(5434),
    [anon_sym_mutable] = ACTIONS(5434),
    [anon_sym_constinit] = ACTIONS(5434),
    [anon_sym_consteval] = ACTIONS(5434),
    [anon_sym___shared__] = ACTIONS(5434),
    [anon_sym___local__] = ACTIONS(5434),
    [anon_sym___constant__] = ACTIONS(5434),
    [anon_sym___managed__] = ACTIONS(5434),
    [anon_sym___grid_constant__] = ACTIONS(5434),
    [anon_sym_alignas] = ACTIONS(5434),
    [anon_sym__Alignas] = ACTIONS(5434),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5434),
    [anon_sym_decltype] = ACTIONS(5434),
    [sym_virtual] = ACTIONS(5434),
    [anon_sym_template] = ACTIONS(5434),
    [anon_sym_GT2] = ACTIONS(5432),
    [anon_sym_operator] = ACTIONS(5434),
    [anon_sym___launch_bounds__] = ACTIONS(5434),
  },
  [2246] = {
    [sym_attribute_specifier] = STATE(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5725),
    [anon_sym_COMMA] = ACTIONS(5725),
    [anon_sym_RPAREN] = ACTIONS(5725),
    [anon_sym_LPAREN2] = ACTIONS(5725),
    [anon_sym_DASH] = ACTIONS(5727),
    [anon_sym_PLUS] = ACTIONS(5727),
    [anon_sym_STAR] = ACTIONS(5725),
    [anon_sym_SLASH] = ACTIONS(5727),
    [anon_sym_PERCENT] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_CARET] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
    [anon_sym_EQ_EQ] = ACTIONS(5725),
    [anon_sym_BANG_EQ] = ACTIONS(5725),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_EQ] = ACTIONS(5725),
    [anon_sym_LT_EQ] = ACTIONS(5727),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5725),
    [anon_sym_SEMI] = ACTIONS(5725),
    [anon_sym___extension__] = ACTIONS(5725),
    [anon_sym___global__] = ACTIONS(5725),
    [anon_sym___attribute__] = ACTIONS(5510),
    [anon_sym_LBRACE] = ACTIONS(5725),
    [anon_sym_RBRACE] = ACTIONS(5725),
    [anon_sym_LBRACK] = ACTIONS(5725),
    [anon_sym_RBRACK] = ACTIONS(5725),
    [anon_sym_const] = ACTIONS(5727),
    [anon_sym_constexpr] = ACTIONS(5725),
    [anon_sym_volatile] = ACTIONS(5725),
    [anon_sym_restrict] = ACTIONS(5725),
    [anon_sym___restrict__] = ACTIONS(5725),
    [anon_sym__Atomic] = ACTIONS(5725),
    [anon_sym__Noreturn] = ACTIONS(5725),
    [anon_sym_noreturn] = ACTIONS(5725),
    [anon_sym_mutable] = ACTIONS(5725),
    [anon_sym_constinit] = ACTIONS(5725),
    [anon_sym_consteval] = ACTIONS(5725),
    [anon_sym___shared__] = ACTIONS(5725),
    [anon_sym___local__] = ACTIONS(5725),
    [anon_sym___constant__] = ACTIONS(5725),
    [anon_sym___managed__] = ACTIONS(5725),
    [anon_sym___grid_constant__] = ACTIONS(5725),
    [anon_sym_alignas] = ACTIONS(5725),
    [anon_sym__Alignas] = ACTIONS(5725),
    [anon_sym_COLON] = ACTIONS(5725),
    [anon_sym_QMARK] = ACTIONS(5725),
    [anon_sym_LT_EQ_GT] = ACTIONS(5725),
    [anon_sym_or] = ACTIONS(5725),
    [anon_sym_and] = ACTIONS(5725),
    [anon_sym_bitor] = ACTIONS(5725),
    [anon_sym_xor] = ACTIONS(5725),
    [anon_sym_bitand] = ACTIONS(5725),
    [anon_sym_not_eq] = ACTIONS(5725),
    [anon_sym_DASH_DASH] = ACTIONS(5725),
    [anon_sym_PLUS_PLUS] = ACTIONS(5725),
    [anon_sym_DOT] = ACTIONS(5727),
    [anon_sym_DOT_STAR] = ACTIONS(5725),
    [anon_sym_DASH_GT] = ACTIONS(5725),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5725),
    [anon_sym_decltype] = ACTIONS(5725),
    [anon_sym_final] = ACTIONS(5725),
    [anon_sym_override] = ACTIONS(5725),
    [anon_sym_requires] = ACTIONS(5725),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5725),
  },
  [2247] = {
    [sym_template_argument_list] = STATE(2259),
    [sym_identifier] = ACTIONS(5212),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3782),
    [anon_sym_COMMA] = ACTIONS(3782),
    [anon_sym_RPAREN] = ACTIONS(3782),
    [aux_sym_preproc_if_token2] = ACTIONS(3782),
    [aux_sym_preproc_else_token1] = ACTIONS(3782),
    [aux_sym_preproc_elif_token1] = ACTIONS(5212),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3782),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3782),
    [anon_sym_LPAREN2] = ACTIONS(3782),
    [anon_sym_DASH] = ACTIONS(5212),
    [anon_sym_PLUS] = ACTIONS(5212),
    [anon_sym_STAR] = ACTIONS(5212),
    [anon_sym_SLASH] = ACTIONS(5212),
    [anon_sym_PERCENT] = ACTIONS(5212),
    [anon_sym_PIPE_PIPE] = ACTIONS(3782),
    [anon_sym_AMP_AMP] = ACTIONS(3782),
    [anon_sym_PIPE] = ACTIONS(5212),
    [anon_sym_CARET] = ACTIONS(5212),
    [anon_sym_AMP] = ACTIONS(5212),
    [anon_sym_EQ_EQ] = ACTIONS(3782),
    [anon_sym_BANG_EQ] = ACTIONS(3782),
    [anon_sym_GT] = ACTIONS(5212),
    [anon_sym_GT_EQ] = ACTIONS(3782),
    [anon_sym_LT_EQ] = ACTIONS(5212),
    [anon_sym_LT] = ACTIONS(5729),
    [anon_sym_LT_LT] = ACTIONS(5212),
    [anon_sym_GT_GT] = ACTIONS(5212),
    [anon_sym_SEMI] = ACTIONS(3782),
    [anon_sym___attribute__] = ACTIONS(5212),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_RBRACE] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3782),
    [anon_sym_RBRACK] = ACTIONS(3782),
    [anon_sym_EQ] = ACTIONS(5212),
    [anon_sym_COLON] = ACTIONS(5212),
    [anon_sym_QMARK] = ACTIONS(3782),
    [anon_sym_STAR_EQ] = ACTIONS(3782),
    [anon_sym_SLASH_EQ] = ACTIONS(3782),
    [anon_sym_PERCENT_EQ] = ACTIONS(3782),
    [anon_sym_PLUS_EQ] = ACTIONS(3782),
    [anon_sym_DASH_EQ] = ACTIONS(3782),
    [anon_sym_LT_LT_EQ] = ACTIONS(3782),
    [anon_sym_GT_GT_EQ] = ACTIONS(3782),
    [anon_sym_AMP_EQ] = ACTIONS(3782),
    [anon_sym_CARET_EQ] = ACTIONS(3782),
    [anon_sym_PIPE_EQ] = ACTIONS(3782),
    [anon_sym_and_eq] = ACTIONS(5212),
    [anon_sym_or_eq] = ACTIONS(5212),
    [anon_sym_xor_eq] = ACTIONS(5212),
    [anon_sym_LT_EQ_GT] = ACTIONS(3782),
    [anon_sym_or] = ACTIONS(5212),
    [anon_sym_and] = ACTIONS(5212),
    [anon_sym_bitor] = ACTIONS(5212),
    [anon_sym_xor] = ACTIONS(5212),
    [anon_sym_bitand] = ACTIONS(5212),
    [anon_sym_not_eq] = ACTIONS(5212),
    [anon_sym_DASH_DASH] = ACTIONS(3782),
    [anon_sym_PLUS_PLUS] = ACTIONS(3782),
    [anon_sym_DOT] = ACTIONS(5212),
    [anon_sym_DOT_STAR] = ACTIONS(3782),
    [anon_sym_DASH_GT] = ACTIONS(3782),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5212),
    [anon_sym_decltype] = ACTIONS(5212),
    [anon_sym_final] = ACTIONS(5212),
    [anon_sym_override] = ACTIONS(5212),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3782),
  },
  [2248] = {
    [sym__declaration_modifiers] = STATE(2156),
    [sym_attribute_specifier] = STATE(2156),
    [sym_attribute_declaration] = STATE(2156),
    [sym_ms_declspec_modifier] = STATE(2156),
    [sym_storage_class_specifier] = STATE(2156),
    [sym_type_qualifier] = STATE(2156),
    [sym_alignas_qualifier] = STATE(2611),
    [sym_decltype_auto] = STATE(2182),
    [sym_launch_bounds] = STATE(2156),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2156),
    [sym_identifier] = ACTIONS(5426),
    [anon_sym_LPAREN2] = ACTIONS(5428),
    [anon_sym_TILDE] = ACTIONS(5428),
    [anon_sym_STAR] = ACTIONS(5428),
    [anon_sym_AMP_AMP] = ACTIONS(5428),
    [anon_sym_AMP] = ACTIONS(5426),
    [anon_sym_SEMI] = ACTIONS(5731),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym___device__] = ACTIONS(5430),
    [anon_sym___host__] = ACTIONS(5430),
    [anon_sym___global__] = ACTIONS(5430),
    [anon_sym___forceinline__] = ACTIONS(5430),
    [anon_sym___noinline__] = ACTIONS(5430),
    [anon_sym_extern] = ACTIONS(5000),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5428),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5006),
    [anon_sym___declspec] = ACTIONS(5008),
    [anon_sym___based] = ACTIONS(5426),
    [anon_sym___cdecl] = ACTIONS(5426),
    [anon_sym___clrcall] = ACTIONS(5426),
    [anon_sym___stdcall] = ACTIONS(5426),
    [anon_sym___fastcall] = ACTIONS(5426),
    [anon_sym___thiscall] = ACTIONS(5426),
    [anon_sym___vectorcall] = ACTIONS(5426),
    [anon_sym_LBRACK] = ACTIONS(5426),
    [anon_sym_static] = ACTIONS(5000),
    [anon_sym_register] = ACTIONS(5000),
    [anon_sym_inline] = ACTIONS(5000),
    [anon_sym___inline] = ACTIONS(5000),
    [anon_sym___inline__] = ACTIONS(5000),
    [anon_sym___forceinline] = ACTIONS(5000),
    [anon_sym_thread_local] = ACTIONS(5000),
    [anon_sym___thread] = ACTIONS(5000),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym___shared__] = ACTIONS(4996),
    [anon_sym___local__] = ACTIONS(4996),
    [anon_sym___constant__] = ACTIONS(4996),
    [anon_sym___managed__] = ACTIONS(4996),
    [anon_sym___grid_constant__] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(5010),
    [anon_sym__Alignas] = ACTIONS(5010),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5412),
    [anon_sym_decltype] = ACTIONS(5414),
    [sym_virtual] = ACTIONS(5430),
    [anon_sym_template] = ACTIONS(5426),
    [anon_sym_operator] = ACTIONS(5426),
    [anon_sym___launch_bounds__] = ACTIONS(5012),
  },
  [2249] = {
    [sym_identifier] = ACTIONS(3992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3994),
    [anon_sym_COMMA] = ACTIONS(3994),
    [anon_sym_RPAREN] = ACTIONS(3994),
    [anon_sym_LPAREN2] = ACTIONS(3994),
    [anon_sym_TILDE] = ACTIONS(3994),
    [anon_sym_STAR] = ACTIONS(3994),
    [anon_sym_PIPE_PIPE] = ACTIONS(3994),
    [anon_sym_AMP_AMP] = ACTIONS(3994),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym_SEMI] = ACTIONS(3994),
    [anon_sym___extension__] = ACTIONS(3992),
    [anon_sym___device__] = ACTIONS(3992),
    [anon_sym___host__] = ACTIONS(3992),
    [anon_sym___global__] = ACTIONS(3992),
    [anon_sym___forceinline__] = ACTIONS(3992),
    [anon_sym___noinline__] = ACTIONS(3992),
    [anon_sym_extern] = ACTIONS(3992),
    [anon_sym___attribute__] = ACTIONS(3992),
    [anon_sym_COLON_COLON] = ACTIONS(3994),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3994),
    [anon_sym___declspec] = ACTIONS(3992),
    [anon_sym___based] = ACTIONS(3992),
    [anon_sym_LBRACE] = ACTIONS(3994),
    [anon_sym_LBRACK] = ACTIONS(3992),
    [anon_sym_static] = ACTIONS(3992),
    [anon_sym_EQ] = ACTIONS(3994),
    [anon_sym_register] = ACTIONS(3992),
    [anon_sym_inline] = ACTIONS(3992),
    [anon_sym___inline] = ACTIONS(3992),
    [anon_sym___inline__] = ACTIONS(3992),
    [anon_sym___forceinline] = ACTIONS(3992),
    [anon_sym_thread_local] = ACTIONS(3992),
    [anon_sym___thread] = ACTIONS(3992),
    [anon_sym_const] = ACTIONS(3992),
    [anon_sym_constexpr] = ACTIONS(3992),
    [anon_sym_volatile] = ACTIONS(3992),
    [anon_sym_restrict] = ACTIONS(3992),
    [anon_sym___restrict__] = ACTIONS(3992),
    [anon_sym__Atomic] = ACTIONS(3992),
    [anon_sym__Noreturn] = ACTIONS(3992),
    [anon_sym_noreturn] = ACTIONS(3992),
    [anon_sym_mutable] = ACTIONS(3992),
    [anon_sym_constinit] = ACTIONS(3992),
    [anon_sym_consteval] = ACTIONS(3992),
    [anon_sym___shared__] = ACTIONS(3992),
    [anon_sym___local__] = ACTIONS(3992),
    [anon_sym___constant__] = ACTIONS(3992),
    [anon_sym___managed__] = ACTIONS(3992),
    [anon_sym___grid_constant__] = ACTIONS(3992),
    [anon_sym_alignas] = ACTIONS(3992),
    [anon_sym__Alignas] = ACTIONS(3992),
    [anon_sym_COLON] = ACTIONS(3992),
    [anon_sym_or] = ACTIONS(3992),
    [anon_sym_and] = ACTIONS(3992),
    [anon_sym_asm] = ACTIONS(3992),
    [anon_sym___asm__] = ACTIONS(3992),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3992),
    [anon_sym_decltype] = ACTIONS(3992),
    [anon_sym_final] = ACTIONS(3992),
    [anon_sym_override] = ACTIONS(3992),
    [sym_virtual] = ACTIONS(3992),
    [anon_sym_template] = ACTIONS(3992),
    [anon_sym_GT2] = ACTIONS(3994),
    [anon_sym_operator] = ACTIONS(3992),
    [anon_sym_try] = ACTIONS(3992),
    [anon_sym_requires] = ACTIONS(3992),
    [anon_sym___launch_bounds__] = ACTIONS(3992),
  },
  [2250] = {
    [sym_identifier] = ACTIONS(3980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3982),
    [anon_sym_COMMA] = ACTIONS(3982),
    [anon_sym_RPAREN] = ACTIONS(3982),
    [anon_sym_LPAREN2] = ACTIONS(3982),
    [anon_sym_TILDE] = ACTIONS(3982),
    [anon_sym_STAR] = ACTIONS(3982),
    [anon_sym_PIPE_PIPE] = ACTIONS(3982),
    [anon_sym_AMP_AMP] = ACTIONS(3982),
    [anon_sym_AMP] = ACTIONS(3980),
    [anon_sym_SEMI] = ACTIONS(3982),
    [anon_sym___extension__] = ACTIONS(3980),
    [anon_sym___device__] = ACTIONS(3980),
    [anon_sym___host__] = ACTIONS(3980),
    [anon_sym___global__] = ACTIONS(3980),
    [anon_sym___forceinline__] = ACTIONS(3980),
    [anon_sym___noinline__] = ACTIONS(3980),
    [anon_sym_extern] = ACTIONS(3980),
    [anon_sym___attribute__] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3982),
    [anon_sym___declspec] = ACTIONS(3980),
    [anon_sym___based] = ACTIONS(3980),
    [anon_sym_LBRACE] = ACTIONS(3982),
    [anon_sym_LBRACK] = ACTIONS(3980),
    [anon_sym_static] = ACTIONS(3980),
    [anon_sym_EQ] = ACTIONS(3982),
    [anon_sym_register] = ACTIONS(3980),
    [anon_sym_inline] = ACTIONS(3980),
    [anon_sym___inline] = ACTIONS(3980),
    [anon_sym___inline__] = ACTIONS(3980),
    [anon_sym___forceinline] = ACTIONS(3980),
    [anon_sym_thread_local] = ACTIONS(3980),
    [anon_sym___thread] = ACTIONS(3980),
    [anon_sym_const] = ACTIONS(3980),
    [anon_sym_constexpr] = ACTIONS(3980),
    [anon_sym_volatile] = ACTIONS(3980),
    [anon_sym_restrict] = ACTIONS(3980),
    [anon_sym___restrict__] = ACTIONS(3980),
    [anon_sym__Atomic] = ACTIONS(3980),
    [anon_sym__Noreturn] = ACTIONS(3980),
    [anon_sym_noreturn] = ACTIONS(3980),
    [anon_sym_mutable] = ACTIONS(3980),
    [anon_sym_constinit] = ACTIONS(3980),
    [anon_sym_consteval] = ACTIONS(3980),
    [anon_sym___shared__] = ACTIONS(3980),
    [anon_sym___local__] = ACTIONS(3980),
    [anon_sym___constant__] = ACTIONS(3980),
    [anon_sym___managed__] = ACTIONS(3980),
    [anon_sym___grid_constant__] = ACTIONS(3980),
    [anon_sym_alignas] = ACTIONS(3980),
    [anon_sym__Alignas] = ACTIONS(3980),
    [anon_sym_COLON] = ACTIONS(3980),
    [anon_sym_or] = ACTIONS(3980),
    [anon_sym_and] = ACTIONS(3980),
    [anon_sym_asm] = ACTIONS(3980),
    [anon_sym___asm__] = ACTIONS(3980),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3980),
    [anon_sym_decltype] = ACTIONS(3980),
    [anon_sym_final] = ACTIONS(3980),
    [anon_sym_override] = ACTIONS(3980),
    [sym_virtual] = ACTIONS(3980),
    [anon_sym_template] = ACTIONS(3980),
    [anon_sym_GT2] = ACTIONS(3982),
    [anon_sym_operator] = ACTIONS(3980),
    [anon_sym_try] = ACTIONS(3980),
    [anon_sym_requires] = ACTIONS(3980),
    [anon_sym___launch_bounds__] = ACTIONS(3980),
  },
  [2251] = {
    [sym_string_literal] = STATE(1647),
    [sym_identifier] = ACTIONS(5733),
    [anon_sym_LPAREN2] = ACTIONS(5735),
    [anon_sym_TILDE] = ACTIONS(5735),
    [anon_sym_STAR] = ACTIONS(5735),
    [anon_sym_AMP_AMP] = ACTIONS(5735),
    [anon_sym_AMP] = ACTIONS(5733),
    [anon_sym___extension__] = ACTIONS(5733),
    [anon_sym___device__] = ACTIONS(5733),
    [anon_sym___host__] = ACTIONS(5733),
    [anon_sym___global__] = ACTIONS(5733),
    [anon_sym___forceinline__] = ACTIONS(5733),
    [anon_sym___noinline__] = ACTIONS(5733),
    [anon_sym_extern] = ACTIONS(5733),
    [anon_sym___attribute__] = ACTIONS(5733),
    [anon_sym_COLON_COLON] = ACTIONS(5735),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5735),
    [anon_sym___declspec] = ACTIONS(5733),
    [anon_sym___based] = ACTIONS(5733),
    [anon_sym_signed] = ACTIONS(5733),
    [anon_sym_unsigned] = ACTIONS(5733),
    [anon_sym_long] = ACTIONS(5733),
    [anon_sym_short] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5733),
    [anon_sym_static] = ACTIONS(5733),
    [anon_sym_register] = ACTIONS(5733),
    [anon_sym_inline] = ACTIONS(5733),
    [anon_sym___inline] = ACTIONS(5733),
    [anon_sym___inline__] = ACTIONS(5733),
    [anon_sym___forceinline] = ACTIONS(5733),
    [anon_sym_thread_local] = ACTIONS(5733),
    [anon_sym___thread] = ACTIONS(5733),
    [anon_sym_const] = ACTIONS(5733),
    [anon_sym_constexpr] = ACTIONS(5733),
    [anon_sym_volatile] = ACTIONS(5733),
    [anon_sym_restrict] = ACTIONS(5733),
    [anon_sym___restrict__] = ACTIONS(5733),
    [anon_sym__Atomic] = ACTIONS(5733),
    [anon_sym__Noreturn] = ACTIONS(5733),
    [anon_sym_noreturn] = ACTIONS(5733),
    [anon_sym_mutable] = ACTIONS(5733),
    [anon_sym_constinit] = ACTIONS(5733),
    [anon_sym_consteval] = ACTIONS(5733),
    [anon_sym___shared__] = ACTIONS(5733),
    [anon_sym___local__] = ACTIONS(5733),
    [anon_sym___constant__] = ACTIONS(5733),
    [anon_sym___managed__] = ACTIONS(5733),
    [anon_sym___grid_constant__] = ACTIONS(5733),
    [anon_sym_alignas] = ACTIONS(5733),
    [anon_sym__Alignas] = ACTIONS(5733),
    [sym_primitive_type] = ACTIONS(5733),
    [anon_sym_enum] = ACTIONS(5733),
    [anon_sym_class] = ACTIONS(5733),
    [anon_sym_struct] = ACTIONS(5733),
    [anon_sym_union] = ACTIONS(5733),
    [anon_sym_L_DQUOTE] = ACTIONS(5737),
    [anon_sym_u_DQUOTE] = ACTIONS(5737),
    [anon_sym_U_DQUOTE] = ACTIONS(5737),
    [anon_sym_u8_DQUOTE] = ACTIONS(5737),
    [anon_sym_DQUOTE] = ACTIONS(5737),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5733),
    [anon_sym_decltype] = ACTIONS(5733),
    [sym_virtual] = ACTIONS(5733),
    [anon_sym_explicit] = ACTIONS(5733),
    [anon_sym_typename] = ACTIONS(5733),
    [anon_sym_template] = ACTIONS(5733),
    [anon_sym_operator] = ACTIONS(5733),
    [anon_sym___launch_bounds__] = ACTIONS(5733),
  },
  [2252] = {
    [sym_identifier] = ACTIONS(3996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3998),
    [anon_sym_COMMA] = ACTIONS(3998),
    [anon_sym_RPAREN] = ACTIONS(3998),
    [anon_sym_LPAREN2] = ACTIONS(3998),
    [anon_sym_TILDE] = ACTIONS(3998),
    [anon_sym_STAR] = ACTIONS(3998),
    [anon_sym_PIPE_PIPE] = ACTIONS(3998),
    [anon_sym_AMP_AMP] = ACTIONS(3998),
    [anon_sym_AMP] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(3998),
    [anon_sym___extension__] = ACTIONS(3996),
    [anon_sym___device__] = ACTIONS(3996),
    [anon_sym___host__] = ACTIONS(3996),
    [anon_sym___global__] = ACTIONS(3996),
    [anon_sym___forceinline__] = ACTIONS(3996),
    [anon_sym___noinline__] = ACTIONS(3996),
    [anon_sym_extern] = ACTIONS(3996),
    [anon_sym___attribute__] = ACTIONS(3996),
    [anon_sym_COLON_COLON] = ACTIONS(3998),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3998),
    [anon_sym___declspec] = ACTIONS(3996),
    [anon_sym___based] = ACTIONS(3996),
    [anon_sym_LBRACE] = ACTIONS(3998),
    [anon_sym_LBRACK] = ACTIONS(3996),
    [anon_sym_static] = ACTIONS(3996),
    [anon_sym_EQ] = ACTIONS(3998),
    [anon_sym_register] = ACTIONS(3996),
    [anon_sym_inline] = ACTIONS(3996),
    [anon_sym___inline] = ACTIONS(3996),
    [anon_sym___inline__] = ACTIONS(3996),
    [anon_sym___forceinline] = ACTIONS(3996),
    [anon_sym_thread_local] = ACTIONS(3996),
    [anon_sym___thread] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3996),
    [anon_sym_constexpr] = ACTIONS(3996),
    [anon_sym_volatile] = ACTIONS(3996),
    [anon_sym_restrict] = ACTIONS(3996),
    [anon_sym___restrict__] = ACTIONS(3996),
    [anon_sym__Atomic] = ACTIONS(3996),
    [anon_sym__Noreturn] = ACTIONS(3996),
    [anon_sym_noreturn] = ACTIONS(3996),
    [anon_sym_mutable] = ACTIONS(3996),
    [anon_sym_constinit] = ACTIONS(3996),
    [anon_sym_consteval] = ACTIONS(3996),
    [anon_sym___shared__] = ACTIONS(3996),
    [anon_sym___local__] = ACTIONS(3996),
    [anon_sym___constant__] = ACTIONS(3996),
    [anon_sym___managed__] = ACTIONS(3996),
    [anon_sym___grid_constant__] = ACTIONS(3996),
    [anon_sym_alignas] = ACTIONS(3996),
    [anon_sym__Alignas] = ACTIONS(3996),
    [anon_sym_COLON] = ACTIONS(3996),
    [anon_sym_or] = ACTIONS(3996),
    [anon_sym_and] = ACTIONS(3996),
    [anon_sym_asm] = ACTIONS(3996),
    [anon_sym___asm__] = ACTIONS(3996),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3996),
    [anon_sym_decltype] = ACTIONS(3996),
    [anon_sym_final] = ACTIONS(3996),
    [anon_sym_override] = ACTIONS(3996),
    [sym_virtual] = ACTIONS(3996),
    [anon_sym_template] = ACTIONS(3996),
    [anon_sym_GT2] = ACTIONS(3998),
    [anon_sym_operator] = ACTIONS(3996),
    [anon_sym_try] = ACTIONS(3996),
    [anon_sym_requires] = ACTIONS(3996),
    [anon_sym___launch_bounds__] = ACTIONS(3996),
  },
  [2253] = {
    [sym_string_literal] = STATE(2752),
    [sym_template_argument_list] = STATE(4108),
    [sym_raw_string_literal] = STATE(2752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_RPAREN] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(4850),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3758),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_RBRACE] = ACTIONS(3758),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(3790),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3794),
    [anon_sym_SLASH_EQ] = ACTIONS(3794),
    [anon_sym_PERCENT_EQ] = ACTIONS(3794),
    [anon_sym_PLUS_EQ] = ACTIONS(3794),
    [anon_sym_DASH_EQ] = ACTIONS(3794),
    [anon_sym_LT_LT_EQ] = ACTIONS(3794),
    [anon_sym_GT_GT_EQ] = ACTIONS(3794),
    [anon_sym_AMP_EQ] = ACTIONS(3794),
    [anon_sym_CARET_EQ] = ACTIONS(3794),
    [anon_sym_PIPE_EQ] = ACTIONS(3794),
    [anon_sym_and_eq] = ACTIONS(3794),
    [anon_sym_or_eq] = ACTIONS(3794),
    [anon_sym_xor_eq] = ACTIONS(3794),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2254] = {
    [sym_identifier] = ACTIONS(5196),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5198),
    [anon_sym_COMMA] = ACTIONS(5198),
    [anon_sym_RPAREN] = ACTIONS(5198),
    [aux_sym_preproc_if_token2] = ACTIONS(5198),
    [aux_sym_preproc_else_token1] = ACTIONS(5198),
    [aux_sym_preproc_elif_token1] = ACTIONS(5196),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5198),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5198),
    [anon_sym_LPAREN2] = ACTIONS(5198),
    [anon_sym_DASH] = ACTIONS(5196),
    [anon_sym_PLUS] = ACTIONS(5196),
    [anon_sym_STAR] = ACTIONS(5196),
    [anon_sym_SLASH] = ACTIONS(5196),
    [anon_sym_PERCENT] = ACTIONS(5196),
    [anon_sym_PIPE_PIPE] = ACTIONS(5198),
    [anon_sym_AMP_AMP] = ACTIONS(5198),
    [anon_sym_PIPE] = ACTIONS(5196),
    [anon_sym_CARET] = ACTIONS(5196),
    [anon_sym_AMP] = ACTIONS(5196),
    [anon_sym_EQ_EQ] = ACTIONS(5198),
    [anon_sym_BANG_EQ] = ACTIONS(5198),
    [anon_sym_GT] = ACTIONS(5196),
    [anon_sym_GT_EQ] = ACTIONS(5198),
    [anon_sym_LT_EQ] = ACTIONS(5196),
    [anon_sym_LT] = ACTIONS(5196),
    [anon_sym_LT_LT] = ACTIONS(5196),
    [anon_sym_GT_GT] = ACTIONS(5196),
    [anon_sym_SEMI] = ACTIONS(5198),
    [anon_sym___attribute__] = ACTIONS(5196),
    [anon_sym_COLON_COLON] = ACTIONS(5198),
    [anon_sym_LBRACE] = ACTIONS(5198),
    [anon_sym_RBRACE] = ACTIONS(5198),
    [anon_sym_LBRACK] = ACTIONS(5198),
    [anon_sym_RBRACK] = ACTIONS(5198),
    [anon_sym_EQ] = ACTIONS(5196),
    [anon_sym_COLON] = ACTIONS(5196),
    [anon_sym_QMARK] = ACTIONS(5198),
    [anon_sym_STAR_EQ] = ACTIONS(5198),
    [anon_sym_SLASH_EQ] = ACTIONS(5198),
    [anon_sym_PERCENT_EQ] = ACTIONS(5198),
    [anon_sym_PLUS_EQ] = ACTIONS(5198),
    [anon_sym_DASH_EQ] = ACTIONS(5198),
    [anon_sym_LT_LT_EQ] = ACTIONS(5198),
    [anon_sym_GT_GT_EQ] = ACTIONS(5198),
    [anon_sym_AMP_EQ] = ACTIONS(5198),
    [anon_sym_CARET_EQ] = ACTIONS(5198),
    [anon_sym_PIPE_EQ] = ACTIONS(5198),
    [anon_sym_and_eq] = ACTIONS(5196),
    [anon_sym_or_eq] = ACTIONS(5196),
    [anon_sym_xor_eq] = ACTIONS(5196),
    [anon_sym_LT_EQ_GT] = ACTIONS(5198),
    [anon_sym_or] = ACTIONS(5196),
    [anon_sym_and] = ACTIONS(5196),
    [anon_sym_bitor] = ACTIONS(5196),
    [anon_sym_xor] = ACTIONS(5196),
    [anon_sym_bitand] = ACTIONS(5196),
    [anon_sym_not_eq] = ACTIONS(5196),
    [anon_sym_DASH_DASH] = ACTIONS(5198),
    [anon_sym_PLUS_PLUS] = ACTIONS(5198),
    [anon_sym_DOT] = ACTIONS(5196),
    [anon_sym_DOT_STAR] = ACTIONS(5198),
    [anon_sym_DASH_GT] = ACTIONS(5198),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5196),
    [anon_sym_decltype] = ACTIONS(5196),
    [anon_sym_final] = ACTIONS(5196),
    [anon_sym_override] = ACTIONS(5196),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5198),
  },
  [2255] = {
    [sym_string_literal] = STATE(2067),
    [sym_raw_string_literal] = STATE(2067),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5712),
    [anon_sym_COMMA] = ACTIONS(5712),
    [anon_sym_RPAREN] = ACTIONS(5712),
    [anon_sym_LPAREN2] = ACTIONS(5712),
    [anon_sym_DASH] = ACTIONS(5710),
    [anon_sym_PLUS] = ACTIONS(5710),
    [anon_sym_STAR] = ACTIONS(5710),
    [anon_sym_SLASH] = ACTIONS(5710),
    [anon_sym_PERCENT] = ACTIONS(5710),
    [anon_sym_PIPE_PIPE] = ACTIONS(5712),
    [anon_sym_AMP_AMP] = ACTIONS(5712),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_CARET] = ACTIONS(5710),
    [anon_sym_AMP] = ACTIONS(5710),
    [anon_sym_EQ_EQ] = ACTIONS(5712),
    [anon_sym_BANG_EQ] = ACTIONS(5712),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_EQ] = ACTIONS(5712),
    [anon_sym_LT_EQ] = ACTIONS(5710),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5710),
    [anon_sym_SEMI] = ACTIONS(5712),
    [anon_sym_RBRACE] = ACTIONS(5712),
    [anon_sym_LBRACK] = ACTIONS(5712),
    [anon_sym_RBRACK] = ACTIONS(5712),
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_COLON] = ACTIONS(5712),
    [anon_sym_QMARK] = ACTIONS(5712),
    [anon_sym_STAR_EQ] = ACTIONS(5712),
    [anon_sym_SLASH_EQ] = ACTIONS(5712),
    [anon_sym_PERCENT_EQ] = ACTIONS(5712),
    [anon_sym_PLUS_EQ] = ACTIONS(5712),
    [anon_sym_DASH_EQ] = ACTIONS(5712),
    [anon_sym_LT_LT_EQ] = ACTIONS(5712),
    [anon_sym_GT_GT_EQ] = ACTIONS(5712),
    [anon_sym_AMP_EQ] = ACTIONS(5712),
    [anon_sym_CARET_EQ] = ACTIONS(5712),
    [anon_sym_PIPE_EQ] = ACTIONS(5712),
    [anon_sym_and_eq] = ACTIONS(5710),
    [anon_sym_or_eq] = ACTIONS(5710),
    [anon_sym_xor_eq] = ACTIONS(5710),
    [anon_sym_LT_EQ_GT] = ACTIONS(5712),
    [anon_sym_or] = ACTIONS(5710),
    [anon_sym_and] = ACTIONS(5710),
    [anon_sym_bitor] = ACTIONS(5710),
    [anon_sym_xor] = ACTIONS(5710),
    [anon_sym_bitand] = ACTIONS(5710),
    [anon_sym_not_eq] = ACTIONS(5710),
    [anon_sym_DASH_DASH] = ACTIONS(5712),
    [anon_sym_PLUS_PLUS] = ACTIONS(5712),
    [anon_sym_DOT] = ACTIONS(5710),
    [anon_sym_DOT_STAR] = ACTIONS(5712),
    [anon_sym_DASH_GT] = ACTIONS(5712),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [sym_literal_suffix] = ACTIONS(5708),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5712),
  },
  [2256] = {
    [sym__declaration_modifiers] = STATE(2156),
    [sym_attribute_specifier] = STATE(2156),
    [sym_attribute_declaration] = STATE(2156),
    [sym_ms_declspec_modifier] = STATE(2156),
    [sym_storage_class_specifier] = STATE(2156),
    [sym_type_qualifier] = STATE(2156),
    [sym_alignas_qualifier] = STATE(2611),
    [sym_decltype_auto] = STATE(2182),
    [sym_launch_bounds] = STATE(2156),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2156),
    [sym_identifier] = ACTIONS(5426),
    [anon_sym_LPAREN2] = ACTIONS(5428),
    [anon_sym_TILDE] = ACTIONS(5428),
    [anon_sym_STAR] = ACTIONS(5428),
    [anon_sym_AMP_AMP] = ACTIONS(5428),
    [anon_sym_AMP] = ACTIONS(5426),
    [anon_sym_SEMI] = ACTIONS(5739),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym___device__] = ACTIONS(5430),
    [anon_sym___host__] = ACTIONS(5430),
    [anon_sym___global__] = ACTIONS(5430),
    [anon_sym___forceinline__] = ACTIONS(5430),
    [anon_sym___noinline__] = ACTIONS(5430),
    [anon_sym_extern] = ACTIONS(5000),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5428),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5006),
    [anon_sym___declspec] = ACTIONS(5008),
    [anon_sym___based] = ACTIONS(5426),
    [anon_sym___cdecl] = ACTIONS(5426),
    [anon_sym___clrcall] = ACTIONS(5426),
    [anon_sym___stdcall] = ACTIONS(5426),
    [anon_sym___fastcall] = ACTIONS(5426),
    [anon_sym___thiscall] = ACTIONS(5426),
    [anon_sym___vectorcall] = ACTIONS(5426),
    [anon_sym_LBRACK] = ACTIONS(5426),
    [anon_sym_static] = ACTIONS(5000),
    [anon_sym_register] = ACTIONS(5000),
    [anon_sym_inline] = ACTIONS(5000),
    [anon_sym___inline] = ACTIONS(5000),
    [anon_sym___inline__] = ACTIONS(5000),
    [anon_sym___forceinline] = ACTIONS(5000),
    [anon_sym_thread_local] = ACTIONS(5000),
    [anon_sym___thread] = ACTIONS(5000),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym___shared__] = ACTIONS(4996),
    [anon_sym___local__] = ACTIONS(4996),
    [anon_sym___constant__] = ACTIONS(4996),
    [anon_sym___managed__] = ACTIONS(4996),
    [anon_sym___grid_constant__] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(5010),
    [anon_sym__Alignas] = ACTIONS(5010),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5412),
    [anon_sym_decltype] = ACTIONS(5414),
    [sym_virtual] = ACTIONS(5430),
    [anon_sym_template] = ACTIONS(5426),
    [anon_sym_operator] = ACTIONS(5426),
    [anon_sym___launch_bounds__] = ACTIONS(5012),
  },
  [2257] = {
    [sym_string_literal] = STATE(2752),
    [sym_template_argument_list] = STATE(4108),
    [sym_raw_string_literal] = STATE(2752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(4850),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3758),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_RBRACE] = ACTIONS(3758),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(3790),
    [anon_sym_COLON] = ACTIONS(5741),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3794),
    [anon_sym_SLASH_EQ] = ACTIONS(3794),
    [anon_sym_PERCENT_EQ] = ACTIONS(3794),
    [anon_sym_PLUS_EQ] = ACTIONS(3794),
    [anon_sym_DASH_EQ] = ACTIONS(3794),
    [anon_sym_LT_LT_EQ] = ACTIONS(3794),
    [anon_sym_GT_GT_EQ] = ACTIONS(3794),
    [anon_sym_AMP_EQ] = ACTIONS(3794),
    [anon_sym_CARET_EQ] = ACTIONS(3794),
    [anon_sym_PIPE_EQ] = ACTIONS(3794),
    [anon_sym_and_eq] = ACTIONS(3794),
    [anon_sym_or_eq] = ACTIONS(3794),
    [anon_sym_xor_eq] = ACTIONS(3794),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2258] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2219),
    [sym_identifier] = ACTIONS(5192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5194),
    [anon_sym_COMMA] = ACTIONS(5194),
    [anon_sym_RPAREN] = ACTIONS(5194),
    [anon_sym_LPAREN2] = ACTIONS(5194),
    [anon_sym_TILDE] = ACTIONS(5194),
    [anon_sym_STAR] = ACTIONS(5194),
    [anon_sym_AMP_AMP] = ACTIONS(5194),
    [anon_sym_AMP] = ACTIONS(5192),
    [anon_sym_SEMI] = ACTIONS(5194),
    [anon_sym___extension__] = ACTIONS(5192),
    [anon_sym___device__] = ACTIONS(5192),
    [anon_sym___host__] = ACTIONS(5192),
    [anon_sym___global__] = ACTIONS(5192),
    [anon_sym___forceinline__] = ACTIONS(5192),
    [anon_sym___noinline__] = ACTIONS(5192),
    [anon_sym_extern] = ACTIONS(5192),
    [anon_sym___attribute__] = ACTIONS(5192),
    [anon_sym_COLON_COLON] = ACTIONS(5194),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5194),
    [anon_sym___declspec] = ACTIONS(5192),
    [anon_sym___based] = ACTIONS(5192),
    [anon_sym___cdecl] = ACTIONS(5192),
    [anon_sym___clrcall] = ACTIONS(5192),
    [anon_sym___stdcall] = ACTIONS(5192),
    [anon_sym___fastcall] = ACTIONS(5192),
    [anon_sym___thiscall] = ACTIONS(5192),
    [anon_sym___vectorcall] = ACTIONS(5192),
    [anon_sym_signed] = ACTIONS(5617),
    [anon_sym_unsigned] = ACTIONS(5617),
    [anon_sym_long] = ACTIONS(5617),
    [anon_sym_short] = ACTIONS(5617),
    [anon_sym_LBRACK] = ACTIONS(5192),
    [anon_sym_static] = ACTIONS(5192),
    [anon_sym_EQ] = ACTIONS(5194),
    [anon_sym_register] = ACTIONS(5192),
    [anon_sym_inline] = ACTIONS(5192),
    [anon_sym___inline] = ACTIONS(5192),
    [anon_sym___inline__] = ACTIONS(5192),
    [anon_sym___forceinline] = ACTIONS(5192),
    [anon_sym_thread_local] = ACTIONS(5192),
    [anon_sym___thread] = ACTIONS(5192),
    [anon_sym_const] = ACTIONS(5192),
    [anon_sym_constexpr] = ACTIONS(5192),
    [anon_sym_volatile] = ACTIONS(5192),
    [anon_sym_restrict] = ACTIONS(5192),
    [anon_sym___restrict__] = ACTIONS(5192),
    [anon_sym__Atomic] = ACTIONS(5192),
    [anon_sym__Noreturn] = ACTIONS(5192),
    [anon_sym_noreturn] = ACTIONS(5192),
    [anon_sym_mutable] = ACTIONS(5192),
    [anon_sym_constinit] = ACTIONS(5192),
    [anon_sym_consteval] = ACTIONS(5192),
    [anon_sym___shared__] = ACTIONS(5192),
    [anon_sym___local__] = ACTIONS(5192),
    [anon_sym___constant__] = ACTIONS(5192),
    [anon_sym___managed__] = ACTIONS(5192),
    [anon_sym___grid_constant__] = ACTIONS(5192),
    [anon_sym_alignas] = ACTIONS(5192),
    [anon_sym__Alignas] = ACTIONS(5192),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5192),
    [anon_sym_decltype] = ACTIONS(5192),
    [sym_virtual] = ACTIONS(5192),
    [anon_sym_template] = ACTIONS(5192),
    [anon_sym_GT2] = ACTIONS(5194),
    [anon_sym_operator] = ACTIONS(5192),
    [anon_sym___launch_bounds__] = ACTIONS(5192),
  },
  [2259] = {
    [sym_identifier] = ACTIONS(4142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4149),
    [anon_sym_COMMA] = ACTIONS(4149),
    [anon_sym_RPAREN] = ACTIONS(4149),
    [aux_sym_preproc_if_token2] = ACTIONS(4149),
    [aux_sym_preproc_else_token1] = ACTIONS(4149),
    [aux_sym_preproc_elif_token1] = ACTIONS(4142),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4149),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4149),
    [anon_sym_LPAREN2] = ACTIONS(4149),
    [anon_sym_DASH] = ACTIONS(4142),
    [anon_sym_PLUS] = ACTIONS(4142),
    [anon_sym_STAR] = ACTIONS(4142),
    [anon_sym_SLASH] = ACTIONS(4142),
    [anon_sym_PERCENT] = ACTIONS(4142),
    [anon_sym_PIPE_PIPE] = ACTIONS(4149),
    [anon_sym_AMP_AMP] = ACTIONS(4149),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_CARET] = ACTIONS(4142),
    [anon_sym_AMP] = ACTIONS(4142),
    [anon_sym_EQ_EQ] = ACTIONS(4149),
    [anon_sym_BANG_EQ] = ACTIONS(4149),
    [anon_sym_GT] = ACTIONS(4142),
    [anon_sym_GT_EQ] = ACTIONS(4149),
    [anon_sym_LT_EQ] = ACTIONS(4142),
    [anon_sym_LT] = ACTIONS(4142),
    [anon_sym_LT_LT] = ACTIONS(4142),
    [anon_sym_GT_GT] = ACTIONS(4142),
    [anon_sym_SEMI] = ACTIONS(4149),
    [anon_sym___attribute__] = ACTIONS(4142),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_LBRACE] = ACTIONS(4149),
    [anon_sym_RBRACE] = ACTIONS(4149),
    [anon_sym_LBRACK] = ACTIONS(4149),
    [anon_sym_RBRACK] = ACTIONS(4149),
    [anon_sym_EQ] = ACTIONS(4142),
    [anon_sym_COLON] = ACTIONS(4142),
    [anon_sym_QMARK] = ACTIONS(4149),
    [anon_sym_STAR_EQ] = ACTIONS(4149),
    [anon_sym_SLASH_EQ] = ACTIONS(4149),
    [anon_sym_PERCENT_EQ] = ACTIONS(4149),
    [anon_sym_PLUS_EQ] = ACTIONS(4149),
    [anon_sym_DASH_EQ] = ACTIONS(4149),
    [anon_sym_LT_LT_EQ] = ACTIONS(4149),
    [anon_sym_GT_GT_EQ] = ACTIONS(4149),
    [anon_sym_AMP_EQ] = ACTIONS(4149),
    [anon_sym_CARET_EQ] = ACTIONS(4149),
    [anon_sym_PIPE_EQ] = ACTIONS(4149),
    [anon_sym_and_eq] = ACTIONS(4142),
    [anon_sym_or_eq] = ACTIONS(4142),
    [anon_sym_xor_eq] = ACTIONS(4142),
    [anon_sym_LT_EQ_GT] = ACTIONS(4149),
    [anon_sym_or] = ACTIONS(4142),
    [anon_sym_and] = ACTIONS(4142),
    [anon_sym_bitor] = ACTIONS(4142),
    [anon_sym_xor] = ACTIONS(4142),
    [anon_sym_bitand] = ACTIONS(4142),
    [anon_sym_not_eq] = ACTIONS(4142),
    [anon_sym_DASH_DASH] = ACTIONS(4149),
    [anon_sym_PLUS_PLUS] = ACTIONS(4149),
    [anon_sym_DOT] = ACTIONS(4142),
    [anon_sym_DOT_STAR] = ACTIONS(4149),
    [anon_sym_DASH_GT] = ACTIONS(4149),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4142),
    [anon_sym_decltype] = ACTIONS(4142),
    [anon_sym_final] = ACTIONS(4142),
    [anon_sym_override] = ACTIONS(4142),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4149),
  },
  [2260] = {
    [sym_string_literal] = STATE(2291),
    [sym_template_argument_list] = STATE(3113),
    [sym_raw_string_literal] = STATE(2291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_RPAREN] = ACTIONS(5743),
    [anon_sym_LPAREN2] = ACTIONS(5743),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(4807),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4810),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [anon_sym_EQ] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3758),
    [anon_sym_SLASH_EQ] = ACTIONS(3758),
    [anon_sym_PERCENT_EQ] = ACTIONS(3758),
    [anon_sym_PLUS_EQ] = ACTIONS(3758),
    [anon_sym_DASH_EQ] = ACTIONS(3758),
    [anon_sym_LT_LT_EQ] = ACTIONS(3758),
    [anon_sym_GT_GT_EQ] = ACTIONS(3758),
    [anon_sym_AMP_EQ] = ACTIONS(3758),
    [anon_sym_CARET_EQ] = ACTIONS(3758),
    [anon_sym_PIPE_EQ] = ACTIONS(3758),
    [anon_sym_and_eq] = ACTIONS(3758),
    [anon_sym_or_eq] = ACTIONS(3758),
    [anon_sym_xor_eq] = ACTIONS(3758),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3766),
    [anon_sym_L_DQUOTE] = ACTIONS(4814),
    [anon_sym_u_DQUOTE] = ACTIONS(4814),
    [anon_sym_U_DQUOTE] = ACTIONS(4814),
    [anon_sym_u8_DQUOTE] = ACTIONS(4814),
    [anon_sym_DQUOTE] = ACTIONS(4814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4816),
    [anon_sym_LR_DQUOTE] = ACTIONS(4816),
    [anon_sym_uR_DQUOTE] = ACTIONS(4816),
    [anon_sym_UR_DQUOTE] = ACTIONS(4816),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4816),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3758),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2261] = {
    [sym_string_literal] = STATE(2291),
    [sym_template_argument_list] = STATE(3307),
    [sym_raw_string_literal] = STATE(2291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_RPAREN] = ACTIONS(5749),
    [anon_sym_LPAREN2] = ACTIONS(5749),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(4834),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5749),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(5751),
    [anon_sym_EQ] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3758),
    [anon_sym_SLASH_EQ] = ACTIONS(3758),
    [anon_sym_PERCENT_EQ] = ACTIONS(3758),
    [anon_sym_PLUS_EQ] = ACTIONS(3758),
    [anon_sym_DASH_EQ] = ACTIONS(3758),
    [anon_sym_LT_LT_EQ] = ACTIONS(3758),
    [anon_sym_GT_GT_EQ] = ACTIONS(3758),
    [anon_sym_AMP_EQ] = ACTIONS(3758),
    [anon_sym_CARET_EQ] = ACTIONS(3758),
    [anon_sym_PIPE_EQ] = ACTIONS(3758),
    [anon_sym_and_eq] = ACTIONS(3758),
    [anon_sym_or_eq] = ACTIONS(3758),
    [anon_sym_xor_eq] = ACTIONS(3758),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3766),
    [anon_sym_L_DQUOTE] = ACTIONS(4814),
    [anon_sym_u_DQUOTE] = ACTIONS(4814),
    [anon_sym_U_DQUOTE] = ACTIONS(4814),
    [anon_sym_u8_DQUOTE] = ACTIONS(4814),
    [anon_sym_DQUOTE] = ACTIONS(4814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4816),
    [anon_sym_LR_DQUOTE] = ACTIONS(4816),
    [anon_sym_uR_DQUOTE] = ACTIONS(4816),
    [anon_sym_UR_DQUOTE] = ACTIONS(4816),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4816),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3758),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2262] = {
    [sym_identifier] = ACTIONS(5179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5181),
    [anon_sym_COMMA] = ACTIONS(5181),
    [anon_sym_RPAREN] = ACTIONS(5181),
    [aux_sym_preproc_if_token2] = ACTIONS(5181),
    [aux_sym_preproc_else_token1] = ACTIONS(5181),
    [aux_sym_preproc_elif_token1] = ACTIONS(5179),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5181),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5181),
    [anon_sym_LPAREN2] = ACTIONS(5181),
    [anon_sym_DASH] = ACTIONS(5179),
    [anon_sym_PLUS] = ACTIONS(5179),
    [anon_sym_STAR] = ACTIONS(5179),
    [anon_sym_SLASH] = ACTIONS(5179),
    [anon_sym_PERCENT] = ACTIONS(5179),
    [anon_sym_PIPE_PIPE] = ACTIONS(5181),
    [anon_sym_AMP_AMP] = ACTIONS(5181),
    [anon_sym_PIPE] = ACTIONS(5179),
    [anon_sym_CARET] = ACTIONS(5179),
    [anon_sym_AMP] = ACTIONS(5179),
    [anon_sym_EQ_EQ] = ACTIONS(5181),
    [anon_sym_BANG_EQ] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5179),
    [anon_sym_GT_EQ] = ACTIONS(5181),
    [anon_sym_LT_EQ] = ACTIONS(5179),
    [anon_sym_LT] = ACTIONS(5179),
    [anon_sym_LT_LT] = ACTIONS(5179),
    [anon_sym_GT_GT] = ACTIONS(5179),
    [anon_sym_SEMI] = ACTIONS(5181),
    [anon_sym___attribute__] = ACTIONS(5179),
    [anon_sym_COLON_COLON] = ACTIONS(5183),
    [anon_sym_LBRACE] = ACTIONS(5181),
    [anon_sym_RBRACE] = ACTIONS(5181),
    [anon_sym_LBRACK] = ACTIONS(5181),
    [anon_sym_RBRACK] = ACTIONS(5181),
    [anon_sym_EQ] = ACTIONS(5179),
    [anon_sym_COLON] = ACTIONS(5179),
    [anon_sym_QMARK] = ACTIONS(5181),
    [anon_sym_STAR_EQ] = ACTIONS(5181),
    [anon_sym_SLASH_EQ] = ACTIONS(5181),
    [anon_sym_PERCENT_EQ] = ACTIONS(5181),
    [anon_sym_PLUS_EQ] = ACTIONS(5181),
    [anon_sym_DASH_EQ] = ACTIONS(5181),
    [anon_sym_LT_LT_EQ] = ACTIONS(5181),
    [anon_sym_GT_GT_EQ] = ACTIONS(5181),
    [anon_sym_AMP_EQ] = ACTIONS(5181),
    [anon_sym_CARET_EQ] = ACTIONS(5181),
    [anon_sym_PIPE_EQ] = ACTIONS(5181),
    [anon_sym_and_eq] = ACTIONS(5179),
    [anon_sym_or_eq] = ACTIONS(5179),
    [anon_sym_xor_eq] = ACTIONS(5179),
    [anon_sym_LT_EQ_GT] = ACTIONS(5181),
    [anon_sym_or] = ACTIONS(5179),
    [anon_sym_and] = ACTIONS(5179),
    [anon_sym_bitor] = ACTIONS(5179),
    [anon_sym_xor] = ACTIONS(5179),
    [anon_sym_bitand] = ACTIONS(5179),
    [anon_sym_not_eq] = ACTIONS(5179),
    [anon_sym_DASH_DASH] = ACTIONS(5181),
    [anon_sym_PLUS_PLUS] = ACTIONS(5181),
    [anon_sym_DOT] = ACTIONS(5179),
    [anon_sym_DOT_STAR] = ACTIONS(5181),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5179),
    [anon_sym_decltype] = ACTIONS(5179),
    [anon_sym_final] = ACTIONS(5179),
    [anon_sym_override] = ACTIONS(5179),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5181),
  },
  [2263] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2236),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5194),
    [anon_sym_COMMA] = ACTIONS(5194),
    [anon_sym_LPAREN2] = ACTIONS(5194),
    [anon_sym_DASH] = ACTIONS(5192),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_STAR] = ACTIONS(5194),
    [anon_sym_SLASH] = ACTIONS(5192),
    [anon_sym_PERCENT] = ACTIONS(5194),
    [anon_sym_PIPE_PIPE] = ACTIONS(5194),
    [anon_sym_AMP_AMP] = ACTIONS(5194),
    [anon_sym_PIPE] = ACTIONS(5192),
    [anon_sym_CARET] = ACTIONS(5194),
    [anon_sym_AMP] = ACTIONS(5192),
    [anon_sym_EQ_EQ] = ACTIONS(5194),
    [anon_sym_BANG_EQ] = ACTIONS(5194),
    [anon_sym_GT] = ACTIONS(5192),
    [anon_sym_GT_EQ] = ACTIONS(5192),
    [anon_sym_LT_EQ] = ACTIONS(5192),
    [anon_sym_LT] = ACTIONS(5192),
    [anon_sym_LT_LT] = ACTIONS(5192),
    [anon_sym_GT_GT] = ACTIONS(5192),
    [anon_sym___extension__] = ACTIONS(5194),
    [anon_sym___global__] = ACTIONS(5194),
    [anon_sym_LBRACE] = ACTIONS(5194),
    [anon_sym_signed] = ACTIONS(5702),
    [anon_sym_unsigned] = ACTIONS(5702),
    [anon_sym_long] = ACTIONS(5702),
    [anon_sym_short] = ACTIONS(5702),
    [anon_sym_LBRACK] = ACTIONS(5194),
    [anon_sym_const] = ACTIONS(5192),
    [anon_sym_constexpr] = ACTIONS(5194),
    [anon_sym_volatile] = ACTIONS(5194),
    [anon_sym_restrict] = ACTIONS(5194),
    [anon_sym___restrict__] = ACTIONS(5194),
    [anon_sym__Atomic] = ACTIONS(5194),
    [anon_sym__Noreturn] = ACTIONS(5194),
    [anon_sym_noreturn] = ACTIONS(5194),
    [anon_sym_mutable] = ACTIONS(5194),
    [anon_sym_constinit] = ACTIONS(5194),
    [anon_sym_consteval] = ACTIONS(5194),
    [anon_sym___shared__] = ACTIONS(5194),
    [anon_sym___local__] = ACTIONS(5194),
    [anon_sym___constant__] = ACTIONS(5194),
    [anon_sym___managed__] = ACTIONS(5194),
    [anon_sym___grid_constant__] = ACTIONS(5194),
    [anon_sym_alignas] = ACTIONS(5194),
    [anon_sym__Alignas] = ACTIONS(5194),
    [anon_sym_QMARK] = ACTIONS(5194),
    [anon_sym_LT_EQ_GT] = ACTIONS(5194),
    [anon_sym_or] = ACTIONS(5194),
    [anon_sym_and] = ACTIONS(5194),
    [anon_sym_bitor] = ACTIONS(5194),
    [anon_sym_xor] = ACTIONS(5194),
    [anon_sym_bitand] = ACTIONS(5194),
    [anon_sym_not_eq] = ACTIONS(5194),
    [anon_sym_DASH_DASH] = ACTIONS(5194),
    [anon_sym_PLUS_PLUS] = ACTIONS(5194),
    [anon_sym_DOT] = ACTIONS(5192),
    [anon_sym_DOT_STAR] = ACTIONS(5194),
    [anon_sym_DASH_GT] = ACTIONS(5194),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5194),
    [anon_sym_decltype] = ACTIONS(5194),
    [anon_sym_final] = ACTIONS(5194),
    [anon_sym_override] = ACTIONS(5194),
    [anon_sym_GT2] = ACTIONS(5194),
    [anon_sym_requires] = ACTIONS(5194),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5194),
  },
  [2264] = {
    [sym_string_literal] = STATE(2752),
    [sym_template_argument_list] = STATE(4108),
    [sym_raw_string_literal] = STATE(2752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(4850),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3758),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_RBRACE] = ACTIONS(3758),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(3790),
    [anon_sym_COLON] = ACTIONS(3820),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3794),
    [anon_sym_SLASH_EQ] = ACTIONS(3794),
    [anon_sym_PERCENT_EQ] = ACTIONS(3794),
    [anon_sym_PLUS_EQ] = ACTIONS(3794),
    [anon_sym_DASH_EQ] = ACTIONS(3794),
    [anon_sym_LT_LT_EQ] = ACTIONS(3794),
    [anon_sym_GT_GT_EQ] = ACTIONS(3794),
    [anon_sym_AMP_EQ] = ACTIONS(3794),
    [anon_sym_CARET_EQ] = ACTIONS(3794),
    [anon_sym_PIPE_EQ] = ACTIONS(3794),
    [anon_sym_and_eq] = ACTIONS(3794),
    [anon_sym_or_eq] = ACTIONS(3794),
    [anon_sym_xor_eq] = ACTIONS(3794),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2265] = {
    [sym_string_literal] = STATE(1646),
    [sym_identifier] = ACTIONS(5733),
    [anon_sym_LPAREN2] = ACTIONS(5735),
    [anon_sym_TILDE] = ACTIONS(5735),
    [anon_sym_STAR] = ACTIONS(5735),
    [anon_sym_AMP_AMP] = ACTIONS(5735),
    [anon_sym_AMP] = ACTIONS(5733),
    [anon_sym___extension__] = ACTIONS(5733),
    [anon_sym___device__] = ACTIONS(5733),
    [anon_sym___host__] = ACTIONS(5733),
    [anon_sym___global__] = ACTIONS(5733),
    [anon_sym___forceinline__] = ACTIONS(5733),
    [anon_sym___noinline__] = ACTIONS(5733),
    [anon_sym_extern] = ACTIONS(5733),
    [anon_sym___attribute__] = ACTIONS(5733),
    [anon_sym_COLON_COLON] = ACTIONS(5735),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5735),
    [anon_sym___declspec] = ACTIONS(5733),
    [anon_sym___based] = ACTIONS(5733),
    [anon_sym_signed] = ACTIONS(5733),
    [anon_sym_unsigned] = ACTIONS(5733),
    [anon_sym_long] = ACTIONS(5733),
    [anon_sym_short] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5733),
    [anon_sym_static] = ACTIONS(5733),
    [anon_sym_register] = ACTIONS(5733),
    [anon_sym_inline] = ACTIONS(5733),
    [anon_sym___inline] = ACTIONS(5733),
    [anon_sym___inline__] = ACTIONS(5733),
    [anon_sym___forceinline] = ACTIONS(5733),
    [anon_sym_thread_local] = ACTIONS(5733),
    [anon_sym___thread] = ACTIONS(5733),
    [anon_sym_const] = ACTIONS(5733),
    [anon_sym_constexpr] = ACTIONS(5733),
    [anon_sym_volatile] = ACTIONS(5733),
    [anon_sym_restrict] = ACTIONS(5733),
    [anon_sym___restrict__] = ACTIONS(5733),
    [anon_sym__Atomic] = ACTIONS(5733),
    [anon_sym__Noreturn] = ACTIONS(5733),
    [anon_sym_noreturn] = ACTIONS(5733),
    [anon_sym_mutable] = ACTIONS(5733),
    [anon_sym_constinit] = ACTIONS(5733),
    [anon_sym_consteval] = ACTIONS(5733),
    [anon_sym___shared__] = ACTIONS(5733),
    [anon_sym___local__] = ACTIONS(5733),
    [anon_sym___constant__] = ACTIONS(5733),
    [anon_sym___managed__] = ACTIONS(5733),
    [anon_sym___grid_constant__] = ACTIONS(5733),
    [anon_sym_alignas] = ACTIONS(5733),
    [anon_sym__Alignas] = ACTIONS(5733),
    [sym_primitive_type] = ACTIONS(5733),
    [anon_sym_enum] = ACTIONS(5733),
    [anon_sym_class] = ACTIONS(5733),
    [anon_sym_struct] = ACTIONS(5733),
    [anon_sym_union] = ACTIONS(5733),
    [anon_sym_L_DQUOTE] = ACTIONS(5737),
    [anon_sym_u_DQUOTE] = ACTIONS(5737),
    [anon_sym_U_DQUOTE] = ACTIONS(5737),
    [anon_sym_u8_DQUOTE] = ACTIONS(5737),
    [anon_sym_DQUOTE] = ACTIONS(5737),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5733),
    [anon_sym_decltype] = ACTIONS(5733),
    [sym_virtual] = ACTIONS(5733),
    [anon_sym_explicit] = ACTIONS(5733),
    [anon_sym_typename] = ACTIONS(5733),
    [anon_sym_template] = ACTIONS(5733),
    [anon_sym_operator] = ACTIONS(5733),
    [anon_sym___launch_bounds__] = ACTIONS(5733),
  },
  [2266] = {
    [sym_string_literal] = STATE(1645),
    [sym_identifier] = ACTIONS(5733),
    [anon_sym_LPAREN2] = ACTIONS(5735),
    [anon_sym_TILDE] = ACTIONS(5735),
    [anon_sym_STAR] = ACTIONS(5735),
    [anon_sym_AMP_AMP] = ACTIONS(5735),
    [anon_sym_AMP] = ACTIONS(5733),
    [anon_sym___extension__] = ACTIONS(5733),
    [anon_sym___device__] = ACTIONS(5733),
    [anon_sym___host__] = ACTIONS(5733),
    [anon_sym___global__] = ACTIONS(5733),
    [anon_sym___forceinline__] = ACTIONS(5733),
    [anon_sym___noinline__] = ACTIONS(5733),
    [anon_sym_extern] = ACTIONS(5733),
    [anon_sym___attribute__] = ACTIONS(5733),
    [anon_sym_COLON_COLON] = ACTIONS(5735),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5735),
    [anon_sym___declspec] = ACTIONS(5733),
    [anon_sym___based] = ACTIONS(5733),
    [anon_sym_signed] = ACTIONS(5733),
    [anon_sym_unsigned] = ACTIONS(5733),
    [anon_sym_long] = ACTIONS(5733),
    [anon_sym_short] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5733),
    [anon_sym_static] = ACTIONS(5733),
    [anon_sym_register] = ACTIONS(5733),
    [anon_sym_inline] = ACTIONS(5733),
    [anon_sym___inline] = ACTIONS(5733),
    [anon_sym___inline__] = ACTIONS(5733),
    [anon_sym___forceinline] = ACTIONS(5733),
    [anon_sym_thread_local] = ACTIONS(5733),
    [anon_sym___thread] = ACTIONS(5733),
    [anon_sym_const] = ACTIONS(5733),
    [anon_sym_constexpr] = ACTIONS(5733),
    [anon_sym_volatile] = ACTIONS(5733),
    [anon_sym_restrict] = ACTIONS(5733),
    [anon_sym___restrict__] = ACTIONS(5733),
    [anon_sym__Atomic] = ACTIONS(5733),
    [anon_sym__Noreturn] = ACTIONS(5733),
    [anon_sym_noreturn] = ACTIONS(5733),
    [anon_sym_mutable] = ACTIONS(5733),
    [anon_sym_constinit] = ACTIONS(5733),
    [anon_sym_consteval] = ACTIONS(5733),
    [anon_sym___shared__] = ACTIONS(5733),
    [anon_sym___local__] = ACTIONS(5733),
    [anon_sym___constant__] = ACTIONS(5733),
    [anon_sym___managed__] = ACTIONS(5733),
    [anon_sym___grid_constant__] = ACTIONS(5733),
    [anon_sym_alignas] = ACTIONS(5733),
    [anon_sym__Alignas] = ACTIONS(5733),
    [sym_primitive_type] = ACTIONS(5733),
    [anon_sym_enum] = ACTIONS(5733),
    [anon_sym_class] = ACTIONS(5733),
    [anon_sym_struct] = ACTIONS(5733),
    [anon_sym_union] = ACTIONS(5733),
    [anon_sym_L_DQUOTE] = ACTIONS(5737),
    [anon_sym_u_DQUOTE] = ACTIONS(5737),
    [anon_sym_U_DQUOTE] = ACTIONS(5737),
    [anon_sym_u8_DQUOTE] = ACTIONS(5737),
    [anon_sym_DQUOTE] = ACTIONS(5737),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5733),
    [anon_sym_decltype] = ACTIONS(5733),
    [sym_virtual] = ACTIONS(5733),
    [anon_sym_explicit] = ACTIONS(5733),
    [anon_sym_typename] = ACTIONS(5733),
    [anon_sym_template] = ACTIONS(5733),
    [anon_sym_operator] = ACTIONS(5733),
    [anon_sym___launch_bounds__] = ACTIONS(5733),
  },
  [2267] = {
    [sym_string_literal] = STATE(1648),
    [sym_identifier] = ACTIONS(5733),
    [anon_sym_LPAREN2] = ACTIONS(5735),
    [anon_sym_TILDE] = ACTIONS(5735),
    [anon_sym_STAR] = ACTIONS(5735),
    [anon_sym_AMP_AMP] = ACTIONS(5735),
    [anon_sym_AMP] = ACTIONS(5733),
    [anon_sym___extension__] = ACTIONS(5733),
    [anon_sym___device__] = ACTIONS(5733),
    [anon_sym___host__] = ACTIONS(5733),
    [anon_sym___global__] = ACTIONS(5733),
    [anon_sym___forceinline__] = ACTIONS(5733),
    [anon_sym___noinline__] = ACTIONS(5733),
    [anon_sym_extern] = ACTIONS(5733),
    [anon_sym___attribute__] = ACTIONS(5733),
    [anon_sym_COLON_COLON] = ACTIONS(5735),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5735),
    [anon_sym___declspec] = ACTIONS(5733),
    [anon_sym___based] = ACTIONS(5733),
    [anon_sym_signed] = ACTIONS(5733),
    [anon_sym_unsigned] = ACTIONS(5733),
    [anon_sym_long] = ACTIONS(5733),
    [anon_sym_short] = ACTIONS(5733),
    [anon_sym_LBRACK] = ACTIONS(5733),
    [anon_sym_static] = ACTIONS(5733),
    [anon_sym_register] = ACTIONS(5733),
    [anon_sym_inline] = ACTIONS(5733),
    [anon_sym___inline] = ACTIONS(5733),
    [anon_sym___inline__] = ACTIONS(5733),
    [anon_sym___forceinline] = ACTIONS(5733),
    [anon_sym_thread_local] = ACTIONS(5733),
    [anon_sym___thread] = ACTIONS(5733),
    [anon_sym_const] = ACTIONS(5733),
    [anon_sym_constexpr] = ACTIONS(5733),
    [anon_sym_volatile] = ACTIONS(5733),
    [anon_sym_restrict] = ACTIONS(5733),
    [anon_sym___restrict__] = ACTIONS(5733),
    [anon_sym__Atomic] = ACTIONS(5733),
    [anon_sym__Noreturn] = ACTIONS(5733),
    [anon_sym_noreturn] = ACTIONS(5733),
    [anon_sym_mutable] = ACTIONS(5733),
    [anon_sym_constinit] = ACTIONS(5733),
    [anon_sym_consteval] = ACTIONS(5733),
    [anon_sym___shared__] = ACTIONS(5733),
    [anon_sym___local__] = ACTIONS(5733),
    [anon_sym___constant__] = ACTIONS(5733),
    [anon_sym___managed__] = ACTIONS(5733),
    [anon_sym___grid_constant__] = ACTIONS(5733),
    [anon_sym_alignas] = ACTIONS(5733),
    [anon_sym__Alignas] = ACTIONS(5733),
    [sym_primitive_type] = ACTIONS(5733),
    [anon_sym_enum] = ACTIONS(5733),
    [anon_sym_class] = ACTIONS(5733),
    [anon_sym_struct] = ACTIONS(5733),
    [anon_sym_union] = ACTIONS(5733),
    [anon_sym_L_DQUOTE] = ACTIONS(5737),
    [anon_sym_u_DQUOTE] = ACTIONS(5737),
    [anon_sym_U_DQUOTE] = ACTIONS(5737),
    [anon_sym_u8_DQUOTE] = ACTIONS(5737),
    [anon_sym_DQUOTE] = ACTIONS(5737),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5733),
    [anon_sym_decltype] = ACTIONS(5733),
    [sym_virtual] = ACTIONS(5733),
    [anon_sym_explicit] = ACTIONS(5733),
    [anon_sym_typename] = ACTIONS(5733),
    [anon_sym_template] = ACTIONS(5733),
    [anon_sym_operator] = ACTIONS(5733),
    [anon_sym___launch_bounds__] = ACTIONS(5733),
  },
  [2268] = {
    [sym_identifier] = ACTIONS(3984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3986),
    [anon_sym_COMMA] = ACTIONS(3986),
    [anon_sym_RPAREN] = ACTIONS(3986),
    [anon_sym_LPAREN2] = ACTIONS(3986),
    [anon_sym_TILDE] = ACTIONS(3986),
    [anon_sym_STAR] = ACTIONS(3986),
    [anon_sym_PIPE_PIPE] = ACTIONS(3986),
    [anon_sym_AMP_AMP] = ACTIONS(3986),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_SEMI] = ACTIONS(3986),
    [anon_sym___extension__] = ACTIONS(3984),
    [anon_sym___device__] = ACTIONS(3984),
    [anon_sym___host__] = ACTIONS(3984),
    [anon_sym___global__] = ACTIONS(3984),
    [anon_sym___forceinline__] = ACTIONS(3984),
    [anon_sym___noinline__] = ACTIONS(3984),
    [anon_sym_extern] = ACTIONS(3984),
    [anon_sym___attribute__] = ACTIONS(3984),
    [anon_sym_COLON_COLON] = ACTIONS(3986),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3986),
    [anon_sym___declspec] = ACTIONS(3984),
    [anon_sym___based] = ACTIONS(3984),
    [anon_sym_LBRACE] = ACTIONS(3986),
    [anon_sym_LBRACK] = ACTIONS(3984),
    [anon_sym_static] = ACTIONS(3984),
    [anon_sym_EQ] = ACTIONS(3986),
    [anon_sym_register] = ACTIONS(3984),
    [anon_sym_inline] = ACTIONS(3984),
    [anon_sym___inline] = ACTIONS(3984),
    [anon_sym___inline__] = ACTIONS(3984),
    [anon_sym___forceinline] = ACTIONS(3984),
    [anon_sym_thread_local] = ACTIONS(3984),
    [anon_sym___thread] = ACTIONS(3984),
    [anon_sym_const] = ACTIONS(3984),
    [anon_sym_constexpr] = ACTIONS(3984),
    [anon_sym_volatile] = ACTIONS(3984),
    [anon_sym_restrict] = ACTIONS(3984),
    [anon_sym___restrict__] = ACTIONS(3984),
    [anon_sym__Atomic] = ACTIONS(3984),
    [anon_sym__Noreturn] = ACTIONS(3984),
    [anon_sym_noreturn] = ACTIONS(3984),
    [anon_sym_mutable] = ACTIONS(3984),
    [anon_sym_constinit] = ACTIONS(3984),
    [anon_sym_consteval] = ACTIONS(3984),
    [anon_sym___shared__] = ACTIONS(3984),
    [anon_sym___local__] = ACTIONS(3984),
    [anon_sym___constant__] = ACTIONS(3984),
    [anon_sym___managed__] = ACTIONS(3984),
    [anon_sym___grid_constant__] = ACTIONS(3984),
    [anon_sym_alignas] = ACTIONS(3984),
    [anon_sym__Alignas] = ACTIONS(3984),
    [anon_sym_COLON] = ACTIONS(3984),
    [anon_sym_or] = ACTIONS(3984),
    [anon_sym_and] = ACTIONS(3984),
    [anon_sym_asm] = ACTIONS(3984),
    [anon_sym___asm__] = ACTIONS(3984),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3984),
    [anon_sym_decltype] = ACTIONS(3984),
    [anon_sym_final] = ACTIONS(3984),
    [anon_sym_override] = ACTIONS(3984),
    [sym_virtual] = ACTIONS(3984),
    [anon_sym_template] = ACTIONS(3984),
    [anon_sym_GT2] = ACTIONS(3986),
    [anon_sym_operator] = ACTIONS(3984),
    [anon_sym_try] = ACTIONS(3984),
    [anon_sym_requires] = ACTIONS(3984),
    [anon_sym___launch_bounds__] = ACTIONS(3984),
  },
  [2269] = {
    [sym_identifier] = ACTIONS(5145),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5147),
    [anon_sym_COMMA] = ACTIONS(5147),
    [anon_sym_RPAREN] = ACTIONS(5147),
    [anon_sym_LPAREN2] = ACTIONS(5147),
    [anon_sym_TILDE] = ACTIONS(5147),
    [anon_sym_STAR] = ACTIONS(5147),
    [anon_sym_AMP_AMP] = ACTIONS(5147),
    [anon_sym_AMP] = ACTIONS(5145),
    [anon_sym_SEMI] = ACTIONS(5147),
    [anon_sym___extension__] = ACTIONS(5145),
    [anon_sym___device__] = ACTIONS(5145),
    [anon_sym___host__] = ACTIONS(5145),
    [anon_sym___global__] = ACTIONS(5145),
    [anon_sym___forceinline__] = ACTIONS(5145),
    [anon_sym___noinline__] = ACTIONS(5145),
    [anon_sym_extern] = ACTIONS(5145),
    [anon_sym___attribute__] = ACTIONS(5145),
    [anon_sym_COLON_COLON] = ACTIONS(5147),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5147),
    [anon_sym___declspec] = ACTIONS(5145),
    [anon_sym___based] = ACTIONS(5145),
    [anon_sym___cdecl] = ACTIONS(5145),
    [anon_sym___clrcall] = ACTIONS(5145),
    [anon_sym___stdcall] = ACTIONS(5145),
    [anon_sym___fastcall] = ACTIONS(5145),
    [anon_sym___thiscall] = ACTIONS(5145),
    [anon_sym___vectorcall] = ACTIONS(5145),
    [anon_sym_LBRACE] = ACTIONS(5147),
    [anon_sym_LBRACK] = ACTIONS(5145),
    [anon_sym_static] = ACTIONS(5145),
    [anon_sym_EQ] = ACTIONS(5147),
    [anon_sym_register] = ACTIONS(5145),
    [anon_sym_inline] = ACTIONS(5145),
    [anon_sym___inline] = ACTIONS(5145),
    [anon_sym___inline__] = ACTIONS(5145),
    [anon_sym___forceinline] = ACTIONS(5145),
    [anon_sym_thread_local] = ACTIONS(5145),
    [anon_sym___thread] = ACTIONS(5145),
    [anon_sym_const] = ACTIONS(5145),
    [anon_sym_constexpr] = ACTIONS(5145),
    [anon_sym_volatile] = ACTIONS(5145),
    [anon_sym_restrict] = ACTIONS(5145),
    [anon_sym___restrict__] = ACTIONS(5145),
    [anon_sym__Atomic] = ACTIONS(5145),
    [anon_sym__Noreturn] = ACTIONS(5145),
    [anon_sym_noreturn] = ACTIONS(5145),
    [anon_sym_mutable] = ACTIONS(5145),
    [anon_sym_constinit] = ACTIONS(5145),
    [anon_sym_consteval] = ACTIONS(5145),
    [anon_sym___shared__] = ACTIONS(5145),
    [anon_sym___local__] = ACTIONS(5145),
    [anon_sym___constant__] = ACTIONS(5145),
    [anon_sym___managed__] = ACTIONS(5145),
    [anon_sym___grid_constant__] = ACTIONS(5145),
    [anon_sym_alignas] = ACTIONS(5145),
    [anon_sym__Alignas] = ACTIONS(5145),
    [anon_sym_COLON] = ACTIONS(5145),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5145),
    [anon_sym_decltype] = ACTIONS(5145),
    [anon_sym_final] = ACTIONS(5145),
    [anon_sym_override] = ACTIONS(5145),
    [sym_virtual] = ACTIONS(5145),
    [anon_sym_explicit] = ACTIONS(5145),
    [anon_sym_template] = ACTIONS(5145),
    [anon_sym_GT2] = ACTIONS(5147),
    [anon_sym_operator] = ACTIONS(5145),
    [anon_sym___launch_bounds__] = ACTIONS(5145),
  },
  [2270] = {
    [sym_string_literal] = STATE(2067),
    [sym_template_argument_list] = STATE(2502),
    [sym_raw_string_literal] = STATE(2067),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(5749),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(5189),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3758),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5749),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_RBRACE] = ACTIONS(3758),
    [anon_sym_LBRACK] = ACTIONS(5751),
    [anon_sym_EQ] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3758),
    [anon_sym_SLASH_EQ] = ACTIONS(3758),
    [anon_sym_PERCENT_EQ] = ACTIONS(3758),
    [anon_sym_PLUS_EQ] = ACTIONS(3758),
    [anon_sym_DASH_EQ] = ACTIONS(3758),
    [anon_sym_LT_LT_EQ] = ACTIONS(3758),
    [anon_sym_GT_GT_EQ] = ACTIONS(3758),
    [anon_sym_AMP_EQ] = ACTIONS(3758),
    [anon_sym_CARET_EQ] = ACTIONS(3758),
    [anon_sym_PIPE_EQ] = ACTIONS(3758),
    [anon_sym_and_eq] = ACTIONS(3758),
    [anon_sym_or_eq] = ACTIONS(3758),
    [anon_sym_xor_eq] = ACTIONS(3758),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2271] = {
    [sym_identifier] = ACTIONS(4021),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_RPAREN] = ACTIONS(4023),
    [anon_sym_LPAREN2] = ACTIONS(4023),
    [anon_sym_TILDE] = ACTIONS(4023),
    [anon_sym_STAR] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4023),
    [anon_sym_AMP] = ACTIONS(4021),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym___extension__] = ACTIONS(4021),
    [anon_sym___device__] = ACTIONS(4021),
    [anon_sym___host__] = ACTIONS(4021),
    [anon_sym___global__] = ACTIONS(4021),
    [anon_sym___forceinline__] = ACTIONS(4021),
    [anon_sym___noinline__] = ACTIONS(4021),
    [anon_sym_extern] = ACTIONS(4021),
    [anon_sym___attribute__] = ACTIONS(4021),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4023),
    [anon_sym___declspec] = ACTIONS(4021),
    [anon_sym___based] = ACTIONS(4021),
    [anon_sym_LBRACE] = ACTIONS(4023),
    [anon_sym_LBRACK] = ACTIONS(4021),
    [anon_sym_static] = ACTIONS(4021),
    [anon_sym_EQ] = ACTIONS(4023),
    [anon_sym_register] = ACTIONS(4021),
    [anon_sym_inline] = ACTIONS(4021),
    [anon_sym___inline] = ACTIONS(4021),
    [anon_sym___inline__] = ACTIONS(4021),
    [anon_sym___forceinline] = ACTIONS(4021),
    [anon_sym_thread_local] = ACTIONS(4021),
    [anon_sym___thread] = ACTIONS(4021),
    [anon_sym_const] = ACTIONS(4021),
    [anon_sym_constexpr] = ACTIONS(4021),
    [anon_sym_volatile] = ACTIONS(4021),
    [anon_sym_restrict] = ACTIONS(4021),
    [anon_sym___restrict__] = ACTIONS(4021),
    [anon_sym__Atomic] = ACTIONS(4021),
    [anon_sym__Noreturn] = ACTIONS(4021),
    [anon_sym_noreturn] = ACTIONS(4021),
    [anon_sym_mutable] = ACTIONS(4021),
    [anon_sym_constinit] = ACTIONS(4021),
    [anon_sym_consteval] = ACTIONS(4021),
    [anon_sym___shared__] = ACTIONS(4021),
    [anon_sym___local__] = ACTIONS(4021),
    [anon_sym___constant__] = ACTIONS(4021),
    [anon_sym___managed__] = ACTIONS(4021),
    [anon_sym___grid_constant__] = ACTIONS(4021),
    [anon_sym_alignas] = ACTIONS(4021),
    [anon_sym__Alignas] = ACTIONS(4021),
    [anon_sym_COLON] = ACTIONS(4021),
    [anon_sym_or] = ACTIONS(4021),
    [anon_sym_and] = ACTIONS(4021),
    [anon_sym_asm] = ACTIONS(4021),
    [anon_sym___asm__] = ACTIONS(4021),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4021),
    [anon_sym_decltype] = ACTIONS(4021),
    [anon_sym_final] = ACTIONS(4021),
    [anon_sym_override] = ACTIONS(4021),
    [sym_virtual] = ACTIONS(4021),
    [anon_sym_template] = ACTIONS(4021),
    [anon_sym_GT2] = ACTIONS(4023),
    [anon_sym_operator] = ACTIONS(4021),
    [anon_sym_try] = ACTIONS(4021),
    [anon_sym_requires] = ACTIONS(4021),
    [anon_sym___launch_bounds__] = ACTIONS(4021),
  },
  [2272] = {
    [sym_identifier] = ACTIONS(4017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4019),
    [anon_sym_COMMA] = ACTIONS(4019),
    [anon_sym_RPAREN] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(4019),
    [anon_sym_TILDE] = ACTIONS(4019),
    [anon_sym_STAR] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4017),
    [anon_sym_SEMI] = ACTIONS(4019),
    [anon_sym___extension__] = ACTIONS(4017),
    [anon_sym___device__] = ACTIONS(4017),
    [anon_sym___host__] = ACTIONS(4017),
    [anon_sym___global__] = ACTIONS(4017),
    [anon_sym___forceinline__] = ACTIONS(4017),
    [anon_sym___noinline__] = ACTIONS(4017),
    [anon_sym_extern] = ACTIONS(4017),
    [anon_sym___attribute__] = ACTIONS(4017),
    [anon_sym_COLON_COLON] = ACTIONS(4019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4019),
    [anon_sym___declspec] = ACTIONS(4017),
    [anon_sym___based] = ACTIONS(4017),
    [anon_sym_LBRACE] = ACTIONS(4019),
    [anon_sym_LBRACK] = ACTIONS(4017),
    [anon_sym_static] = ACTIONS(4017),
    [anon_sym_EQ] = ACTIONS(4019),
    [anon_sym_register] = ACTIONS(4017),
    [anon_sym_inline] = ACTIONS(4017),
    [anon_sym___inline] = ACTIONS(4017),
    [anon_sym___inline__] = ACTIONS(4017),
    [anon_sym___forceinline] = ACTIONS(4017),
    [anon_sym_thread_local] = ACTIONS(4017),
    [anon_sym___thread] = ACTIONS(4017),
    [anon_sym_const] = ACTIONS(4017),
    [anon_sym_constexpr] = ACTIONS(4017),
    [anon_sym_volatile] = ACTIONS(4017),
    [anon_sym_restrict] = ACTIONS(4017),
    [anon_sym___restrict__] = ACTIONS(4017),
    [anon_sym__Atomic] = ACTIONS(4017),
    [anon_sym__Noreturn] = ACTIONS(4017),
    [anon_sym_noreturn] = ACTIONS(4017),
    [anon_sym_mutable] = ACTIONS(4017),
    [anon_sym_constinit] = ACTIONS(4017),
    [anon_sym_consteval] = ACTIONS(4017),
    [anon_sym___shared__] = ACTIONS(4017),
    [anon_sym___local__] = ACTIONS(4017),
    [anon_sym___constant__] = ACTIONS(4017),
    [anon_sym___managed__] = ACTIONS(4017),
    [anon_sym___grid_constant__] = ACTIONS(4017),
    [anon_sym_alignas] = ACTIONS(4017),
    [anon_sym__Alignas] = ACTIONS(4017),
    [anon_sym_COLON] = ACTIONS(4017),
    [anon_sym_or] = ACTIONS(4017),
    [anon_sym_and] = ACTIONS(4017),
    [anon_sym_asm] = ACTIONS(4017),
    [anon_sym___asm__] = ACTIONS(4017),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4017),
    [anon_sym_decltype] = ACTIONS(4017),
    [anon_sym_final] = ACTIONS(4017),
    [anon_sym_override] = ACTIONS(4017),
    [sym_virtual] = ACTIONS(4017),
    [anon_sym_template] = ACTIONS(4017),
    [anon_sym_GT2] = ACTIONS(4019),
    [anon_sym_operator] = ACTIONS(4017),
    [anon_sym_try] = ACTIONS(4017),
    [anon_sym_requires] = ACTIONS(4017),
    [anon_sym___launch_bounds__] = ACTIONS(4017),
  },
  [2273] = {
    [sym_string_literal] = STATE(2067),
    [sym_template_argument_list] = STATE(3008),
    [sym_raw_string_literal] = STATE(2067),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(5743),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(5753),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3758),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4810),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_RBRACE] = ACTIONS(3758),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [anon_sym_EQ] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3758),
    [anon_sym_SLASH_EQ] = ACTIONS(3758),
    [anon_sym_PERCENT_EQ] = ACTIONS(3758),
    [anon_sym_PLUS_EQ] = ACTIONS(3758),
    [anon_sym_DASH_EQ] = ACTIONS(3758),
    [anon_sym_LT_LT_EQ] = ACTIONS(3758),
    [anon_sym_GT_GT_EQ] = ACTIONS(3758),
    [anon_sym_AMP_EQ] = ACTIONS(3758),
    [anon_sym_CARET_EQ] = ACTIONS(3758),
    [anon_sym_PIPE_EQ] = ACTIONS(3758),
    [anon_sym_and_eq] = ACTIONS(3758),
    [anon_sym_or_eq] = ACTIONS(3758),
    [anon_sym_xor_eq] = ACTIONS(3758),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2274] = {
    [sym__declaration_modifiers] = STATE(2156),
    [sym_attribute_specifier] = STATE(2156),
    [sym_attribute_declaration] = STATE(2156),
    [sym_ms_declspec_modifier] = STATE(2156),
    [sym_storage_class_specifier] = STATE(2156),
    [sym_type_qualifier] = STATE(2156),
    [sym_alignas_qualifier] = STATE(2611),
    [sym_decltype_auto] = STATE(2182),
    [sym_launch_bounds] = STATE(2156),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2156),
    [sym_identifier] = ACTIONS(5426),
    [anon_sym_LPAREN2] = ACTIONS(5428),
    [anon_sym_TILDE] = ACTIONS(5428),
    [anon_sym_STAR] = ACTIONS(5428),
    [anon_sym_AMP_AMP] = ACTIONS(5428),
    [anon_sym_AMP] = ACTIONS(5426),
    [anon_sym_SEMI] = ACTIONS(5756),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym___device__] = ACTIONS(5430),
    [anon_sym___host__] = ACTIONS(5430),
    [anon_sym___global__] = ACTIONS(5430),
    [anon_sym___forceinline__] = ACTIONS(5430),
    [anon_sym___noinline__] = ACTIONS(5430),
    [anon_sym_extern] = ACTIONS(5000),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5428),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5006),
    [anon_sym___declspec] = ACTIONS(5008),
    [anon_sym___based] = ACTIONS(5426),
    [anon_sym___cdecl] = ACTIONS(5426),
    [anon_sym___clrcall] = ACTIONS(5426),
    [anon_sym___stdcall] = ACTIONS(5426),
    [anon_sym___fastcall] = ACTIONS(5426),
    [anon_sym___thiscall] = ACTIONS(5426),
    [anon_sym___vectorcall] = ACTIONS(5426),
    [anon_sym_LBRACK] = ACTIONS(5426),
    [anon_sym_static] = ACTIONS(5000),
    [anon_sym_register] = ACTIONS(5000),
    [anon_sym_inline] = ACTIONS(5000),
    [anon_sym___inline] = ACTIONS(5000),
    [anon_sym___inline__] = ACTIONS(5000),
    [anon_sym___forceinline] = ACTIONS(5000),
    [anon_sym_thread_local] = ACTIONS(5000),
    [anon_sym___thread] = ACTIONS(5000),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym___shared__] = ACTIONS(4996),
    [anon_sym___local__] = ACTIONS(4996),
    [anon_sym___constant__] = ACTIONS(4996),
    [anon_sym___managed__] = ACTIONS(4996),
    [anon_sym___grid_constant__] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(5010),
    [anon_sym__Alignas] = ACTIONS(5010),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5412),
    [anon_sym_decltype] = ACTIONS(5414),
    [sym_virtual] = ACTIONS(5430),
    [anon_sym_template] = ACTIONS(5426),
    [anon_sym_operator] = ACTIONS(5426),
    [anon_sym___launch_bounds__] = ACTIONS(5012),
  },
  [2275] = {
    [sym__declaration_modifiers] = STATE(2156),
    [sym_attribute_specifier] = STATE(2156),
    [sym_attribute_declaration] = STATE(2156),
    [sym_ms_declspec_modifier] = STATE(2156),
    [sym_storage_class_specifier] = STATE(2156),
    [sym_type_qualifier] = STATE(2156),
    [sym_alignas_qualifier] = STATE(2611),
    [sym_decltype_auto] = STATE(2182),
    [sym_launch_bounds] = STATE(2156),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2156),
    [sym_identifier] = ACTIONS(5426),
    [anon_sym_LPAREN2] = ACTIONS(5428),
    [anon_sym_TILDE] = ACTIONS(5428),
    [anon_sym_STAR] = ACTIONS(5428),
    [anon_sym_AMP_AMP] = ACTIONS(5428),
    [anon_sym_AMP] = ACTIONS(5426),
    [anon_sym_SEMI] = ACTIONS(5758),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym___device__] = ACTIONS(5430),
    [anon_sym___host__] = ACTIONS(5430),
    [anon_sym___global__] = ACTIONS(5430),
    [anon_sym___forceinline__] = ACTIONS(5430),
    [anon_sym___noinline__] = ACTIONS(5430),
    [anon_sym_extern] = ACTIONS(5000),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5428),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5006),
    [anon_sym___declspec] = ACTIONS(5008),
    [anon_sym___based] = ACTIONS(5426),
    [anon_sym___cdecl] = ACTIONS(5426),
    [anon_sym___clrcall] = ACTIONS(5426),
    [anon_sym___stdcall] = ACTIONS(5426),
    [anon_sym___fastcall] = ACTIONS(5426),
    [anon_sym___thiscall] = ACTIONS(5426),
    [anon_sym___vectorcall] = ACTIONS(5426),
    [anon_sym_LBRACK] = ACTIONS(5426),
    [anon_sym_static] = ACTIONS(5000),
    [anon_sym_register] = ACTIONS(5000),
    [anon_sym_inline] = ACTIONS(5000),
    [anon_sym___inline] = ACTIONS(5000),
    [anon_sym___inline__] = ACTIONS(5000),
    [anon_sym___forceinline] = ACTIONS(5000),
    [anon_sym_thread_local] = ACTIONS(5000),
    [anon_sym___thread] = ACTIONS(5000),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym___shared__] = ACTIONS(4996),
    [anon_sym___local__] = ACTIONS(4996),
    [anon_sym___constant__] = ACTIONS(4996),
    [anon_sym___managed__] = ACTIONS(4996),
    [anon_sym___grid_constant__] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(5010),
    [anon_sym__Alignas] = ACTIONS(5010),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5412),
    [anon_sym_decltype] = ACTIONS(5414),
    [sym_virtual] = ACTIONS(5430),
    [anon_sym_template] = ACTIONS(5426),
    [anon_sym_operator] = ACTIONS(5426),
    [anon_sym___launch_bounds__] = ACTIONS(5012),
  },
  [2276] = {
    [sym_identifier] = ACTIONS(5179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5181),
    [anon_sym_COMMA] = ACTIONS(5181),
    [anon_sym_RPAREN] = ACTIONS(5181),
    [aux_sym_preproc_if_token2] = ACTIONS(5181),
    [aux_sym_preproc_else_token1] = ACTIONS(5181),
    [aux_sym_preproc_elif_token1] = ACTIONS(5179),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5181),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5181),
    [anon_sym_LPAREN2] = ACTIONS(5181),
    [anon_sym_DASH] = ACTIONS(5179),
    [anon_sym_PLUS] = ACTIONS(5179),
    [anon_sym_STAR] = ACTIONS(5179),
    [anon_sym_SLASH] = ACTIONS(5179),
    [anon_sym_PERCENT] = ACTIONS(5179),
    [anon_sym_PIPE_PIPE] = ACTIONS(5181),
    [anon_sym_AMP_AMP] = ACTIONS(5181),
    [anon_sym_PIPE] = ACTIONS(5179),
    [anon_sym_CARET] = ACTIONS(5179),
    [anon_sym_AMP] = ACTIONS(5179),
    [anon_sym_EQ_EQ] = ACTIONS(5181),
    [anon_sym_BANG_EQ] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5179),
    [anon_sym_GT_EQ] = ACTIONS(5181),
    [anon_sym_LT_EQ] = ACTIONS(5179),
    [anon_sym_LT] = ACTIONS(5179),
    [anon_sym_LT_LT] = ACTIONS(5179),
    [anon_sym_GT_GT] = ACTIONS(5179),
    [anon_sym_SEMI] = ACTIONS(5181),
    [anon_sym___attribute__] = ACTIONS(5179),
    [anon_sym_COLON_COLON] = ACTIONS(5183),
    [anon_sym_LBRACE] = ACTIONS(5181),
    [anon_sym_RBRACE] = ACTIONS(5181),
    [anon_sym_LBRACK] = ACTIONS(5181),
    [anon_sym_RBRACK] = ACTIONS(5181),
    [anon_sym_EQ] = ACTIONS(5179),
    [anon_sym_COLON] = ACTIONS(5179),
    [anon_sym_QMARK] = ACTIONS(5181),
    [anon_sym_STAR_EQ] = ACTIONS(5181),
    [anon_sym_SLASH_EQ] = ACTIONS(5181),
    [anon_sym_PERCENT_EQ] = ACTIONS(5181),
    [anon_sym_PLUS_EQ] = ACTIONS(5181),
    [anon_sym_DASH_EQ] = ACTIONS(5181),
    [anon_sym_LT_LT_EQ] = ACTIONS(5181),
    [anon_sym_GT_GT_EQ] = ACTIONS(5181),
    [anon_sym_AMP_EQ] = ACTIONS(5181),
    [anon_sym_CARET_EQ] = ACTIONS(5181),
    [anon_sym_PIPE_EQ] = ACTIONS(5181),
    [anon_sym_and_eq] = ACTIONS(5179),
    [anon_sym_or_eq] = ACTIONS(5179),
    [anon_sym_xor_eq] = ACTIONS(5179),
    [anon_sym_LT_EQ_GT] = ACTIONS(5181),
    [anon_sym_or] = ACTIONS(5179),
    [anon_sym_and] = ACTIONS(5179),
    [anon_sym_bitor] = ACTIONS(5179),
    [anon_sym_xor] = ACTIONS(5179),
    [anon_sym_bitand] = ACTIONS(5179),
    [anon_sym_not_eq] = ACTIONS(5179),
    [anon_sym_DASH_DASH] = ACTIONS(5181),
    [anon_sym_PLUS_PLUS] = ACTIONS(5181),
    [anon_sym_DOT] = ACTIONS(5179),
    [anon_sym_DOT_STAR] = ACTIONS(5181),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5179),
    [anon_sym_decltype] = ACTIONS(5179),
    [anon_sym_final] = ACTIONS(5179),
    [anon_sym_override] = ACTIONS(5179),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5181),
  },
  [2277] = {
    [sym__declaration_modifiers] = STATE(2156),
    [sym_attribute_specifier] = STATE(2156),
    [sym_attribute_declaration] = STATE(2156),
    [sym_ms_declspec_modifier] = STATE(2156),
    [sym_storage_class_specifier] = STATE(2156),
    [sym_type_qualifier] = STATE(2156),
    [sym_alignas_qualifier] = STATE(2611),
    [sym_decltype_auto] = STATE(2182),
    [sym_launch_bounds] = STATE(2156),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2156),
    [sym_identifier] = ACTIONS(5426),
    [anon_sym_LPAREN2] = ACTIONS(5428),
    [anon_sym_TILDE] = ACTIONS(5428),
    [anon_sym_STAR] = ACTIONS(5428),
    [anon_sym_AMP_AMP] = ACTIONS(5428),
    [anon_sym_AMP] = ACTIONS(5426),
    [anon_sym_SEMI] = ACTIONS(5760),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym___device__] = ACTIONS(5430),
    [anon_sym___host__] = ACTIONS(5430),
    [anon_sym___global__] = ACTIONS(5430),
    [anon_sym___forceinline__] = ACTIONS(5430),
    [anon_sym___noinline__] = ACTIONS(5430),
    [anon_sym_extern] = ACTIONS(5000),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5428),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5006),
    [anon_sym___declspec] = ACTIONS(5008),
    [anon_sym___based] = ACTIONS(5426),
    [anon_sym___cdecl] = ACTIONS(5426),
    [anon_sym___clrcall] = ACTIONS(5426),
    [anon_sym___stdcall] = ACTIONS(5426),
    [anon_sym___fastcall] = ACTIONS(5426),
    [anon_sym___thiscall] = ACTIONS(5426),
    [anon_sym___vectorcall] = ACTIONS(5426),
    [anon_sym_LBRACK] = ACTIONS(5426),
    [anon_sym_static] = ACTIONS(5000),
    [anon_sym_register] = ACTIONS(5000),
    [anon_sym_inline] = ACTIONS(5000),
    [anon_sym___inline] = ACTIONS(5000),
    [anon_sym___inline__] = ACTIONS(5000),
    [anon_sym___forceinline] = ACTIONS(5000),
    [anon_sym_thread_local] = ACTIONS(5000),
    [anon_sym___thread] = ACTIONS(5000),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym___shared__] = ACTIONS(4996),
    [anon_sym___local__] = ACTIONS(4996),
    [anon_sym___constant__] = ACTIONS(4996),
    [anon_sym___managed__] = ACTIONS(4996),
    [anon_sym___grid_constant__] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(5010),
    [anon_sym__Alignas] = ACTIONS(5010),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5412),
    [anon_sym_decltype] = ACTIONS(5414),
    [sym_virtual] = ACTIONS(5430),
    [anon_sym_template] = ACTIONS(5426),
    [anon_sym_operator] = ACTIONS(5426),
    [anon_sym___launch_bounds__] = ACTIONS(5012),
  },
  [2278] = {
    [sym__declaration_modifiers] = STATE(2156),
    [sym_attribute_specifier] = STATE(2156),
    [sym_attribute_declaration] = STATE(2156),
    [sym_ms_declspec_modifier] = STATE(2156),
    [sym_storage_class_specifier] = STATE(2156),
    [sym_type_qualifier] = STATE(2156),
    [sym_alignas_qualifier] = STATE(2611),
    [sym_decltype_auto] = STATE(2182),
    [sym_launch_bounds] = STATE(2156),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2156),
    [sym_identifier] = ACTIONS(5426),
    [anon_sym_LPAREN2] = ACTIONS(5428),
    [anon_sym_TILDE] = ACTIONS(5428),
    [anon_sym_STAR] = ACTIONS(5428),
    [anon_sym_AMP_AMP] = ACTIONS(5428),
    [anon_sym_AMP] = ACTIONS(5426),
    [anon_sym_SEMI] = ACTIONS(5762),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym___device__] = ACTIONS(5430),
    [anon_sym___host__] = ACTIONS(5430),
    [anon_sym___global__] = ACTIONS(5430),
    [anon_sym___forceinline__] = ACTIONS(5430),
    [anon_sym___noinline__] = ACTIONS(5430),
    [anon_sym_extern] = ACTIONS(5000),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5428),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5006),
    [anon_sym___declspec] = ACTIONS(5008),
    [anon_sym___based] = ACTIONS(5426),
    [anon_sym___cdecl] = ACTIONS(5426),
    [anon_sym___clrcall] = ACTIONS(5426),
    [anon_sym___stdcall] = ACTIONS(5426),
    [anon_sym___fastcall] = ACTIONS(5426),
    [anon_sym___thiscall] = ACTIONS(5426),
    [anon_sym___vectorcall] = ACTIONS(5426),
    [anon_sym_LBRACK] = ACTIONS(5426),
    [anon_sym_static] = ACTIONS(5000),
    [anon_sym_register] = ACTIONS(5000),
    [anon_sym_inline] = ACTIONS(5000),
    [anon_sym___inline] = ACTIONS(5000),
    [anon_sym___inline__] = ACTIONS(5000),
    [anon_sym___forceinline] = ACTIONS(5000),
    [anon_sym_thread_local] = ACTIONS(5000),
    [anon_sym___thread] = ACTIONS(5000),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym___shared__] = ACTIONS(4996),
    [anon_sym___local__] = ACTIONS(4996),
    [anon_sym___constant__] = ACTIONS(4996),
    [anon_sym___managed__] = ACTIONS(4996),
    [anon_sym___grid_constant__] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(5010),
    [anon_sym__Alignas] = ACTIONS(5010),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5412),
    [anon_sym_decltype] = ACTIONS(5414),
    [sym_virtual] = ACTIONS(5430),
    [anon_sym_template] = ACTIONS(5426),
    [anon_sym_operator] = ACTIONS(5426),
    [anon_sym___launch_bounds__] = ACTIONS(5012),
  },
  [2279] = {
    [sym_string_literal] = STATE(2067),
    [sym_raw_string_literal] = STATE(2067),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_RPAREN] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3758),
    [anon_sym_RBRACE] = ACTIONS(3758),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_RBRACK] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(3766),
    [anon_sym_COLON] = ACTIONS(3758),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3758),
    [anon_sym_SLASH_EQ] = ACTIONS(3758),
    [anon_sym_PERCENT_EQ] = ACTIONS(3758),
    [anon_sym_PLUS_EQ] = ACTIONS(3758),
    [anon_sym_DASH_EQ] = ACTIONS(3758),
    [anon_sym_LT_LT_EQ] = ACTIONS(3758),
    [anon_sym_GT_GT_EQ] = ACTIONS(3758),
    [anon_sym_AMP_EQ] = ACTIONS(3758),
    [anon_sym_CARET_EQ] = ACTIONS(3758),
    [anon_sym_PIPE_EQ] = ACTIONS(3758),
    [anon_sym_and_eq] = ACTIONS(3766),
    [anon_sym_or_eq] = ACTIONS(3766),
    [anon_sym_xor_eq] = ACTIONS(3766),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3766),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3766),
    [anon_sym_not_eq] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(2536),
    [anon_sym_u_DQUOTE] = ACTIONS(2536),
    [anon_sym_U_DQUOTE] = ACTIONS(2536),
    [anon_sym_u8_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [sym_literal_suffix] = ACTIONS(5708),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2280] = {
    [sym_identifier] = ACTIONS(5185),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5187),
    [anon_sym_COMMA] = ACTIONS(5187),
    [anon_sym_RPAREN] = ACTIONS(5187),
    [aux_sym_preproc_if_token2] = ACTIONS(5187),
    [aux_sym_preproc_else_token1] = ACTIONS(5187),
    [aux_sym_preproc_elif_token1] = ACTIONS(5185),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5187),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5187),
    [anon_sym_LPAREN2] = ACTIONS(5187),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_PLUS] = ACTIONS(5185),
    [anon_sym_STAR] = ACTIONS(5185),
    [anon_sym_SLASH] = ACTIONS(5185),
    [anon_sym_PERCENT] = ACTIONS(5185),
    [anon_sym_PIPE_PIPE] = ACTIONS(5187),
    [anon_sym_AMP_AMP] = ACTIONS(5187),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_CARET] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5185),
    [anon_sym_EQ_EQ] = ACTIONS(5187),
    [anon_sym_BANG_EQ] = ACTIONS(5187),
    [anon_sym_GT] = ACTIONS(5185),
    [anon_sym_GT_EQ] = ACTIONS(5187),
    [anon_sym_LT_EQ] = ACTIONS(5185),
    [anon_sym_LT] = ACTIONS(5185),
    [anon_sym_LT_LT] = ACTIONS(5185),
    [anon_sym_GT_GT] = ACTIONS(5185),
    [anon_sym_SEMI] = ACTIONS(5187),
    [anon_sym___attribute__] = ACTIONS(5185),
    [anon_sym_COLON_COLON] = ACTIONS(5183),
    [anon_sym_LBRACE] = ACTIONS(5187),
    [anon_sym_RBRACE] = ACTIONS(5187),
    [anon_sym_LBRACK] = ACTIONS(5187),
    [anon_sym_RBRACK] = ACTIONS(5187),
    [anon_sym_EQ] = ACTIONS(5185),
    [anon_sym_COLON] = ACTIONS(5185),
    [anon_sym_QMARK] = ACTIONS(5187),
    [anon_sym_STAR_EQ] = ACTIONS(5187),
    [anon_sym_SLASH_EQ] = ACTIONS(5187),
    [anon_sym_PERCENT_EQ] = ACTIONS(5187),
    [anon_sym_PLUS_EQ] = ACTIONS(5187),
    [anon_sym_DASH_EQ] = ACTIONS(5187),
    [anon_sym_LT_LT_EQ] = ACTIONS(5187),
    [anon_sym_GT_GT_EQ] = ACTIONS(5187),
    [anon_sym_AMP_EQ] = ACTIONS(5187),
    [anon_sym_CARET_EQ] = ACTIONS(5187),
    [anon_sym_PIPE_EQ] = ACTIONS(5187),
    [anon_sym_and_eq] = ACTIONS(5185),
    [anon_sym_or_eq] = ACTIONS(5185),
    [anon_sym_xor_eq] = ACTIONS(5185),
    [anon_sym_LT_EQ_GT] = ACTIONS(5187),
    [anon_sym_or] = ACTIONS(5185),
    [anon_sym_and] = ACTIONS(5185),
    [anon_sym_bitor] = ACTIONS(5185),
    [anon_sym_xor] = ACTIONS(5185),
    [anon_sym_bitand] = ACTIONS(5185),
    [anon_sym_not_eq] = ACTIONS(5185),
    [anon_sym_DASH_DASH] = ACTIONS(5187),
    [anon_sym_PLUS_PLUS] = ACTIONS(5187),
    [anon_sym_DOT] = ACTIONS(5185),
    [anon_sym_DOT_STAR] = ACTIONS(5187),
    [anon_sym_DASH_GT] = ACTIONS(5187),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5185),
    [anon_sym_decltype] = ACTIONS(5185),
    [anon_sym_final] = ACTIONS(5185),
    [anon_sym_override] = ACTIONS(5185),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5187),
  },
  [2281] = {
    [sym_string_literal] = STATE(2752),
    [sym_template_argument_list] = STATE(4108),
    [sym_raw_string_literal] = STATE(2752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(5749),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(4850),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3758),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5749),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_RBRACE] = ACTIONS(3758),
    [anon_sym_LBRACK] = ACTIONS(5751),
    [anon_sym_EQ] = ACTIONS(3790),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3794),
    [anon_sym_SLASH_EQ] = ACTIONS(3794),
    [anon_sym_PERCENT_EQ] = ACTIONS(3794),
    [anon_sym_PLUS_EQ] = ACTIONS(3794),
    [anon_sym_DASH_EQ] = ACTIONS(3794),
    [anon_sym_LT_LT_EQ] = ACTIONS(3794),
    [anon_sym_GT_GT_EQ] = ACTIONS(3794),
    [anon_sym_AMP_EQ] = ACTIONS(3794),
    [anon_sym_CARET_EQ] = ACTIONS(3794),
    [anon_sym_PIPE_EQ] = ACTIONS(3794),
    [anon_sym_and_eq] = ACTIONS(3794),
    [anon_sym_or_eq] = ACTIONS(3794),
    [anon_sym_xor_eq] = ACTIONS(3794),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2282] = {
    [sym_identifier] = ACTIONS(3988),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3990),
    [anon_sym_COMMA] = ACTIONS(3990),
    [anon_sym_RPAREN] = ACTIONS(3990),
    [anon_sym_LPAREN2] = ACTIONS(3990),
    [anon_sym_TILDE] = ACTIONS(3990),
    [anon_sym_STAR] = ACTIONS(3990),
    [anon_sym_PIPE_PIPE] = ACTIONS(3990),
    [anon_sym_AMP_AMP] = ACTIONS(3990),
    [anon_sym_AMP] = ACTIONS(3988),
    [anon_sym_SEMI] = ACTIONS(3990),
    [anon_sym___extension__] = ACTIONS(3988),
    [anon_sym___device__] = ACTIONS(3988),
    [anon_sym___host__] = ACTIONS(3988),
    [anon_sym___global__] = ACTIONS(3988),
    [anon_sym___forceinline__] = ACTIONS(3988),
    [anon_sym___noinline__] = ACTIONS(3988),
    [anon_sym_extern] = ACTIONS(3988),
    [anon_sym___attribute__] = ACTIONS(3988),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3990),
    [anon_sym___declspec] = ACTIONS(3988),
    [anon_sym___based] = ACTIONS(3988),
    [anon_sym_LBRACE] = ACTIONS(3990),
    [anon_sym_LBRACK] = ACTIONS(3988),
    [anon_sym_static] = ACTIONS(3988),
    [anon_sym_EQ] = ACTIONS(3990),
    [anon_sym_register] = ACTIONS(3988),
    [anon_sym_inline] = ACTIONS(3988),
    [anon_sym___inline] = ACTIONS(3988),
    [anon_sym___inline__] = ACTIONS(3988),
    [anon_sym___forceinline] = ACTIONS(3988),
    [anon_sym_thread_local] = ACTIONS(3988),
    [anon_sym___thread] = ACTIONS(3988),
    [anon_sym_const] = ACTIONS(3988),
    [anon_sym_constexpr] = ACTIONS(3988),
    [anon_sym_volatile] = ACTIONS(3988),
    [anon_sym_restrict] = ACTIONS(3988),
    [anon_sym___restrict__] = ACTIONS(3988),
    [anon_sym__Atomic] = ACTIONS(3988),
    [anon_sym__Noreturn] = ACTIONS(3988),
    [anon_sym_noreturn] = ACTIONS(3988),
    [anon_sym_mutable] = ACTIONS(3988),
    [anon_sym_constinit] = ACTIONS(3988),
    [anon_sym_consteval] = ACTIONS(3988),
    [anon_sym___shared__] = ACTIONS(3988),
    [anon_sym___local__] = ACTIONS(3988),
    [anon_sym___constant__] = ACTIONS(3988),
    [anon_sym___managed__] = ACTIONS(3988),
    [anon_sym___grid_constant__] = ACTIONS(3988),
    [anon_sym_alignas] = ACTIONS(3988),
    [anon_sym__Alignas] = ACTIONS(3988),
    [anon_sym_COLON] = ACTIONS(3988),
    [anon_sym_or] = ACTIONS(3988),
    [anon_sym_and] = ACTIONS(3988),
    [anon_sym_asm] = ACTIONS(3988),
    [anon_sym___asm__] = ACTIONS(3988),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3988),
    [anon_sym_decltype] = ACTIONS(3988),
    [anon_sym_final] = ACTIONS(3988),
    [anon_sym_override] = ACTIONS(3988),
    [sym_virtual] = ACTIONS(3988),
    [anon_sym_template] = ACTIONS(3988),
    [anon_sym_GT2] = ACTIONS(3990),
    [anon_sym_operator] = ACTIONS(3988),
    [anon_sym_try] = ACTIONS(3988),
    [anon_sym_requires] = ACTIONS(3988),
    [anon_sym___launch_bounds__] = ACTIONS(3988),
  },
  [2283] = {
    [sym__declaration_modifiers] = STATE(2156),
    [sym_attribute_specifier] = STATE(2156),
    [sym_attribute_declaration] = STATE(2156),
    [sym_ms_declspec_modifier] = STATE(2156),
    [sym_storage_class_specifier] = STATE(2156),
    [sym_type_qualifier] = STATE(2156),
    [sym_alignas_qualifier] = STATE(2611),
    [sym_decltype_auto] = STATE(2182),
    [sym_launch_bounds] = STATE(2156),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2156),
    [sym_identifier] = ACTIONS(5426),
    [anon_sym_LPAREN2] = ACTIONS(5428),
    [anon_sym_TILDE] = ACTIONS(5428),
    [anon_sym_STAR] = ACTIONS(5428),
    [anon_sym_AMP_AMP] = ACTIONS(5428),
    [anon_sym_AMP] = ACTIONS(5426),
    [anon_sym_SEMI] = ACTIONS(5764),
    [anon_sym___extension__] = ACTIONS(4996),
    [anon_sym___device__] = ACTIONS(5430),
    [anon_sym___host__] = ACTIONS(5430),
    [anon_sym___global__] = ACTIONS(5430),
    [anon_sym___forceinline__] = ACTIONS(5430),
    [anon_sym___noinline__] = ACTIONS(5430),
    [anon_sym_extern] = ACTIONS(5000),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5428),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5006),
    [anon_sym___declspec] = ACTIONS(5008),
    [anon_sym___based] = ACTIONS(5426),
    [anon_sym___cdecl] = ACTIONS(5426),
    [anon_sym___clrcall] = ACTIONS(5426),
    [anon_sym___stdcall] = ACTIONS(5426),
    [anon_sym___fastcall] = ACTIONS(5426),
    [anon_sym___thiscall] = ACTIONS(5426),
    [anon_sym___vectorcall] = ACTIONS(5426),
    [anon_sym_LBRACK] = ACTIONS(5426),
    [anon_sym_static] = ACTIONS(5000),
    [anon_sym_register] = ACTIONS(5000),
    [anon_sym_inline] = ACTIONS(5000),
    [anon_sym___inline] = ACTIONS(5000),
    [anon_sym___inline__] = ACTIONS(5000),
    [anon_sym___forceinline] = ACTIONS(5000),
    [anon_sym_thread_local] = ACTIONS(5000),
    [anon_sym___thread] = ACTIONS(5000),
    [anon_sym_const] = ACTIONS(4996),
    [anon_sym_constexpr] = ACTIONS(4996),
    [anon_sym_volatile] = ACTIONS(4996),
    [anon_sym_restrict] = ACTIONS(4996),
    [anon_sym___restrict__] = ACTIONS(4996),
    [anon_sym__Atomic] = ACTIONS(4996),
    [anon_sym__Noreturn] = ACTIONS(4996),
    [anon_sym_noreturn] = ACTIONS(4996),
    [anon_sym_mutable] = ACTIONS(4996),
    [anon_sym_constinit] = ACTIONS(4996),
    [anon_sym_consteval] = ACTIONS(4996),
    [anon_sym___shared__] = ACTIONS(4996),
    [anon_sym___local__] = ACTIONS(4996),
    [anon_sym___constant__] = ACTIONS(4996),
    [anon_sym___managed__] = ACTIONS(4996),
    [anon_sym___grid_constant__] = ACTIONS(4996),
    [anon_sym_alignas] = ACTIONS(5010),
    [anon_sym__Alignas] = ACTIONS(5010),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5412),
    [anon_sym_decltype] = ACTIONS(5414),
    [sym_virtual] = ACTIONS(5430),
    [anon_sym_template] = ACTIONS(5426),
    [anon_sym_operator] = ACTIONS(5426),
    [anon_sym___launch_bounds__] = ACTIONS(5012),
  },
  [2284] = {
    [sym_string_literal] = STATE(2298),
    [sym_template_argument_list] = STATE(2502),
    [sym_raw_string_literal] = STATE(2298),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(5189),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3758),
    [anon_sym___attribute__] = ACTIONS(3758),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3758),
    [anon_sym_SLASH_EQ] = ACTIONS(3758),
    [anon_sym_PERCENT_EQ] = ACTIONS(3758),
    [anon_sym_PLUS_EQ] = ACTIONS(3758),
    [anon_sym_DASH_EQ] = ACTIONS(3758),
    [anon_sym_LT_LT_EQ] = ACTIONS(3758),
    [anon_sym_GT_GT_EQ] = ACTIONS(3758),
    [anon_sym_AMP_EQ] = ACTIONS(3758),
    [anon_sym_CARET_EQ] = ACTIONS(3758),
    [anon_sym_PIPE_EQ] = ACTIONS(3758),
    [anon_sym_and_eq] = ACTIONS(3758),
    [anon_sym_or_eq] = ACTIONS(3758),
    [anon_sym_xor_eq] = ACTIONS(3758),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(5766),
    [anon_sym_u_DQUOTE] = ACTIONS(5766),
    [anon_sym_U_DQUOTE] = ACTIONS(5766),
    [anon_sym_u8_DQUOTE] = ACTIONS(5766),
    [anon_sym_DQUOTE] = ACTIONS(5766),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5768),
    [anon_sym_LR_DQUOTE] = ACTIONS(5768),
    [anon_sym_uR_DQUOTE] = ACTIONS(5768),
    [anon_sym_UR_DQUOTE] = ACTIONS(5768),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5768),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2285] = {
    [sym_template_argument_list] = STATE(1651),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2438),
    [sym_identifier] = ACTIONS(5530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5532),
    [anon_sym_COMMA] = ACTIONS(5532),
    [aux_sym_preproc_if_token2] = ACTIONS(5532),
    [aux_sym_preproc_else_token1] = ACTIONS(5532),
    [aux_sym_preproc_elif_token1] = ACTIONS(5530),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5532),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5532),
    [anon_sym_LPAREN2] = ACTIONS(5532),
    [anon_sym_DASH] = ACTIONS(5530),
    [anon_sym_PLUS] = ACTIONS(5530),
    [anon_sym_STAR] = ACTIONS(5530),
    [anon_sym_SLASH] = ACTIONS(5530),
    [anon_sym_PERCENT] = ACTIONS(5530),
    [anon_sym_PIPE_PIPE] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_PIPE] = ACTIONS(5530),
    [anon_sym_CARET] = ACTIONS(5530),
    [anon_sym_AMP] = ACTIONS(5530),
    [anon_sym_EQ_EQ] = ACTIONS(5532),
    [anon_sym_BANG_EQ] = ACTIONS(5532),
    [anon_sym_GT] = ACTIONS(5530),
    [anon_sym_GT_EQ] = ACTIONS(5532),
    [anon_sym_LT_EQ] = ACTIONS(5530),
    [anon_sym_LT] = ACTIONS(5530),
    [anon_sym_LT_LT] = ACTIONS(5530),
    [anon_sym_GT_GT] = ACTIONS(5530),
    [anon_sym___attribute__] = ACTIONS(5530),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(5532),
    [anon_sym_signed] = ACTIONS(5770),
    [anon_sym_unsigned] = ACTIONS(5770),
    [anon_sym_long] = ACTIONS(5770),
    [anon_sym_short] = ACTIONS(5770),
    [anon_sym_LBRACK] = ACTIONS(5532),
    [anon_sym_EQ] = ACTIONS(5530),
    [anon_sym_QMARK] = ACTIONS(5532),
    [anon_sym_STAR_EQ] = ACTIONS(5532),
    [anon_sym_SLASH_EQ] = ACTIONS(5532),
    [anon_sym_PERCENT_EQ] = ACTIONS(5532),
    [anon_sym_PLUS_EQ] = ACTIONS(5532),
    [anon_sym_DASH_EQ] = ACTIONS(5532),
    [anon_sym_LT_LT_EQ] = ACTIONS(5532),
    [anon_sym_GT_GT_EQ] = ACTIONS(5532),
    [anon_sym_AMP_EQ] = ACTIONS(5532),
    [anon_sym_CARET_EQ] = ACTIONS(5532),
    [anon_sym_PIPE_EQ] = ACTIONS(5532),
    [anon_sym_and_eq] = ACTIONS(5530),
    [anon_sym_or_eq] = ACTIONS(5530),
    [anon_sym_xor_eq] = ACTIONS(5530),
    [anon_sym_LT_EQ_GT] = ACTIONS(5532),
    [anon_sym_or] = ACTIONS(5530),
    [anon_sym_and] = ACTIONS(5530),
    [anon_sym_bitor] = ACTIONS(5530),
    [anon_sym_xor] = ACTIONS(5530),
    [anon_sym_bitand] = ACTIONS(5530),
    [anon_sym_not_eq] = ACTIONS(5530),
    [anon_sym_DASH_DASH] = ACTIONS(5532),
    [anon_sym_PLUS_PLUS] = ACTIONS(5532),
    [anon_sym_DOT] = ACTIONS(5530),
    [anon_sym_DOT_STAR] = ACTIONS(5532),
    [anon_sym_DASH_GT] = ACTIONS(5532),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5530),
    [anon_sym_decltype] = ACTIONS(5530),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5532),
  },
  [2286] = {
    [sym_attribute_specifier] = STATE(2450),
    [sym_enumerator_list] = STATE(2352),
    [sym_identifier] = ACTIONS(5599),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5597),
    [anon_sym_COMMA] = ACTIONS(5597),
    [anon_sym_RPAREN] = ACTIONS(5597),
    [aux_sym_preproc_if_token2] = ACTIONS(5597),
    [aux_sym_preproc_else_token1] = ACTIONS(5597),
    [aux_sym_preproc_elif_token1] = ACTIONS(5599),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5597),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5597),
    [anon_sym_LPAREN2] = ACTIONS(5597),
    [anon_sym_DASH] = ACTIONS(5599),
    [anon_sym_PLUS] = ACTIONS(5599),
    [anon_sym_STAR] = ACTIONS(5599),
    [anon_sym_SLASH] = ACTIONS(5599),
    [anon_sym_PERCENT] = ACTIONS(5599),
    [anon_sym_PIPE_PIPE] = ACTIONS(5597),
    [anon_sym_AMP_AMP] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5599),
    [anon_sym_CARET] = ACTIONS(5599),
    [anon_sym_AMP] = ACTIONS(5599),
    [anon_sym_EQ_EQ] = ACTIONS(5597),
    [anon_sym_BANG_EQ] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5599),
    [anon_sym_GT_EQ] = ACTIONS(5597),
    [anon_sym_LT_EQ] = ACTIONS(5599),
    [anon_sym_LT] = ACTIONS(5599),
    [anon_sym_LT_LT] = ACTIONS(5599),
    [anon_sym_GT_GT] = ACTIONS(5599),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym___attribute__] = ACTIONS(5546),
    [anon_sym_LBRACE] = ACTIONS(5772),
    [anon_sym_RBRACE] = ACTIONS(5597),
    [anon_sym_LBRACK] = ACTIONS(5597),
    [anon_sym_RBRACK] = ACTIONS(5597),
    [anon_sym_EQ] = ACTIONS(5599),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_QMARK] = ACTIONS(5597),
    [anon_sym_STAR_EQ] = ACTIONS(5597),
    [anon_sym_SLASH_EQ] = ACTIONS(5597),
    [anon_sym_PERCENT_EQ] = ACTIONS(5597),
    [anon_sym_PLUS_EQ] = ACTIONS(5597),
    [anon_sym_DASH_EQ] = ACTIONS(5597),
    [anon_sym_LT_LT_EQ] = ACTIONS(5597),
    [anon_sym_GT_GT_EQ] = ACTIONS(5597),
    [anon_sym_AMP_EQ] = ACTIONS(5597),
    [anon_sym_CARET_EQ] = ACTIONS(5597),
    [anon_sym_PIPE_EQ] = ACTIONS(5597),
    [anon_sym_and_eq] = ACTIONS(5599),
    [anon_sym_or_eq] = ACTIONS(5599),
    [anon_sym_xor_eq] = ACTIONS(5599),
    [anon_sym_LT_EQ_GT] = ACTIONS(5597),
    [anon_sym_or] = ACTIONS(5599),
    [anon_sym_and] = ACTIONS(5599),
    [anon_sym_bitor] = ACTIONS(5599),
    [anon_sym_xor] = ACTIONS(5599),
    [anon_sym_bitand] = ACTIONS(5599),
    [anon_sym_not_eq] = ACTIONS(5599),
    [anon_sym_DASH_DASH] = ACTIONS(5597),
    [anon_sym_PLUS_PLUS] = ACTIONS(5597),
    [anon_sym_DOT] = ACTIONS(5599),
    [anon_sym_DOT_STAR] = ACTIONS(5597),
    [anon_sym_DASH_GT] = ACTIONS(5597),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5599),
    [anon_sym_decltype] = ACTIONS(5599),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5597),
  },
  [2287] = {
    [sym_string_literal] = STATE(2290),
    [sym_raw_string_literal] = STATE(2290),
    [aux_sym_concatenated_string_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(5774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5307),
    [anon_sym_COMMA] = ACTIONS(5307),
    [anon_sym_RPAREN] = ACTIONS(5307),
    [anon_sym_LPAREN2] = ACTIONS(5307),
    [anon_sym_DASH] = ACTIONS(5309),
    [anon_sym_PLUS] = ACTIONS(5309),
    [anon_sym_STAR] = ACTIONS(5309),
    [anon_sym_SLASH] = ACTIONS(5309),
    [anon_sym_PERCENT] = ACTIONS(5309),
    [anon_sym_PIPE_PIPE] = ACTIONS(5307),
    [anon_sym_AMP_AMP] = ACTIONS(5307),
    [anon_sym_PIPE] = ACTIONS(5309),
    [anon_sym_CARET] = ACTIONS(5309),
    [anon_sym_AMP] = ACTIONS(5309),
    [anon_sym_EQ_EQ] = ACTIONS(5307),
    [anon_sym_BANG_EQ] = ACTIONS(5307),
    [anon_sym_GT] = ACTIONS(5309),
    [anon_sym_GT_EQ] = ACTIONS(5307),
    [anon_sym_LT_EQ] = ACTIONS(5309),
    [anon_sym_LT] = ACTIONS(5309),
    [anon_sym_LT_LT] = ACTIONS(5309),
    [anon_sym_GT_GT] = ACTIONS(5309),
    [anon_sym_LBRACK] = ACTIONS(5307),
    [anon_sym_EQ] = ACTIONS(5309),
    [anon_sym_QMARK] = ACTIONS(5307),
    [anon_sym_STAR_EQ] = ACTIONS(5307),
    [anon_sym_SLASH_EQ] = ACTIONS(5307),
    [anon_sym_PERCENT_EQ] = ACTIONS(5307),
    [anon_sym_PLUS_EQ] = ACTIONS(5307),
    [anon_sym_DASH_EQ] = ACTIONS(5307),
    [anon_sym_LT_LT_EQ] = ACTIONS(5307),
    [anon_sym_GT_GT_EQ] = ACTIONS(5307),
    [anon_sym_AMP_EQ] = ACTIONS(5307),
    [anon_sym_CARET_EQ] = ACTIONS(5307),
    [anon_sym_PIPE_EQ] = ACTIONS(5307),
    [anon_sym_and_eq] = ACTIONS(5309),
    [anon_sym_or_eq] = ACTIONS(5309),
    [anon_sym_xor_eq] = ACTIONS(5309),
    [anon_sym_LT_EQ_GT] = ACTIONS(5307),
    [anon_sym_or] = ACTIONS(5309),
    [anon_sym_and] = ACTIONS(5309),
    [anon_sym_bitor] = ACTIONS(5309),
    [anon_sym_xor] = ACTIONS(5309),
    [anon_sym_bitand] = ACTIONS(5309),
    [anon_sym_not_eq] = ACTIONS(5309),
    [anon_sym_DASH_DASH] = ACTIONS(5307),
    [anon_sym_PLUS_PLUS] = ACTIONS(5307),
    [anon_sym_DOT] = ACTIONS(5309),
    [anon_sym_DOT_STAR] = ACTIONS(5307),
    [anon_sym_DASH_GT] = ACTIONS(5309),
    [anon_sym_L_DQUOTE] = ACTIONS(4814),
    [anon_sym_u_DQUOTE] = ACTIONS(4814),
    [anon_sym_U_DQUOTE] = ACTIONS(4814),
    [anon_sym_u8_DQUOTE] = ACTIONS(4814),
    [anon_sym_DQUOTE] = ACTIONS(4814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4816),
    [anon_sym_LR_DQUOTE] = ACTIONS(4816),
    [anon_sym_uR_DQUOTE] = ACTIONS(4816),
    [anon_sym_UR_DQUOTE] = ACTIONS(4816),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4816),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5307),
    [sym_literal_suffix] = ACTIONS(5309),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5307),
  },
  [2288] = {
    [sym_string_literal] = STATE(2288),
    [sym_raw_string_literal] = STATE(2288),
    [aux_sym_concatenated_string_repeat1] = STATE(2288),
    [sym_identifier] = ACTIONS(5776),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5267),
    [anon_sym_COMMA] = ACTIONS(5267),
    [anon_sym_LPAREN2] = ACTIONS(5267),
    [anon_sym_DASH] = ACTIONS(5269),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_STAR] = ACTIONS(5269),
    [anon_sym_SLASH] = ACTIONS(5269),
    [anon_sym_PERCENT] = ACTIONS(5269),
    [anon_sym_PIPE_PIPE] = ACTIONS(5267),
    [anon_sym_AMP_AMP] = ACTIONS(5267),
    [anon_sym_PIPE] = ACTIONS(5269),
    [anon_sym_CARET] = ACTIONS(5269),
    [anon_sym_AMP] = ACTIONS(5269),
    [anon_sym_EQ_EQ] = ACTIONS(5267),
    [anon_sym_BANG_EQ] = ACTIONS(5267),
    [anon_sym_GT] = ACTIONS(5269),
    [anon_sym_GT_EQ] = ACTIONS(5267),
    [anon_sym_LT_EQ] = ACTIONS(5269),
    [anon_sym_LT] = ACTIONS(5269),
    [anon_sym_LT_LT] = ACTIONS(5269),
    [anon_sym_GT_GT] = ACTIONS(5269),
    [anon_sym_SEMI] = ACTIONS(5267),
    [anon_sym___attribute__] = ACTIONS(5269),
    [anon_sym_LBRACK] = ACTIONS(5267),
    [anon_sym_EQ] = ACTIONS(5269),
    [anon_sym_QMARK] = ACTIONS(5267),
    [anon_sym_STAR_EQ] = ACTIONS(5267),
    [anon_sym_SLASH_EQ] = ACTIONS(5267),
    [anon_sym_PERCENT_EQ] = ACTIONS(5267),
    [anon_sym_PLUS_EQ] = ACTIONS(5267),
    [anon_sym_DASH_EQ] = ACTIONS(5267),
    [anon_sym_LT_LT_EQ] = ACTIONS(5267),
    [anon_sym_GT_GT_EQ] = ACTIONS(5267),
    [anon_sym_AMP_EQ] = ACTIONS(5267),
    [anon_sym_CARET_EQ] = ACTIONS(5267),
    [anon_sym_PIPE_EQ] = ACTIONS(5267),
    [anon_sym_and_eq] = ACTIONS(5269),
    [anon_sym_or_eq] = ACTIONS(5269),
    [anon_sym_xor_eq] = ACTIONS(5269),
    [anon_sym_LT_EQ_GT] = ACTIONS(5267),
    [anon_sym_or] = ACTIONS(5269),
    [anon_sym_and] = ACTIONS(5269),
    [anon_sym_bitor] = ACTIONS(5269),
    [anon_sym_xor] = ACTIONS(5269),
    [anon_sym_bitand] = ACTIONS(5269),
    [anon_sym_not_eq] = ACTIONS(5269),
    [anon_sym_DASH_DASH] = ACTIONS(5267),
    [anon_sym_PLUS_PLUS] = ACTIONS(5267),
    [anon_sym_DOT] = ACTIONS(5269),
    [anon_sym_DOT_STAR] = ACTIONS(5267),
    [anon_sym_DASH_GT] = ACTIONS(5267),
    [anon_sym_L_DQUOTE] = ACTIONS(5779),
    [anon_sym_u_DQUOTE] = ACTIONS(5779),
    [anon_sym_U_DQUOTE] = ACTIONS(5779),
    [anon_sym_u8_DQUOTE] = ACTIONS(5779),
    [anon_sym_DQUOTE] = ACTIONS(5779),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5782),
    [anon_sym_LR_DQUOTE] = ACTIONS(5782),
    [anon_sym_uR_DQUOTE] = ACTIONS(5782),
    [anon_sym_UR_DQUOTE] = ACTIONS(5782),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5782),
    [sym_literal_suffix] = ACTIONS(5269),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5267),
  },
  [2289] = {
    [sym_string_literal] = STATE(2752),
    [sym_template_argument_list] = STATE(4108),
    [sym_raw_string_literal] = STATE(2752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(4850),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3758),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(3790),
    [anon_sym_COLON] = ACTIONS(5785),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3794),
    [anon_sym_SLASH_EQ] = ACTIONS(3794),
    [anon_sym_PERCENT_EQ] = ACTIONS(3794),
    [anon_sym_PLUS_EQ] = ACTIONS(3794),
    [anon_sym_DASH_EQ] = ACTIONS(3794),
    [anon_sym_LT_LT_EQ] = ACTIONS(3794),
    [anon_sym_GT_GT_EQ] = ACTIONS(3794),
    [anon_sym_AMP_EQ] = ACTIONS(3794),
    [anon_sym_CARET_EQ] = ACTIONS(3794),
    [anon_sym_PIPE_EQ] = ACTIONS(3794),
    [anon_sym_and_eq] = ACTIONS(3794),
    [anon_sym_or_eq] = ACTIONS(3794),
    [anon_sym_xor_eq] = ACTIONS(3794),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2290] = {
    [sym_string_literal] = STATE(2290),
    [sym_raw_string_literal] = STATE(2290),
    [aux_sym_concatenated_string_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(5787),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5267),
    [anon_sym_COMMA] = ACTIONS(5267),
    [anon_sym_RPAREN] = ACTIONS(5267),
    [anon_sym_LPAREN2] = ACTIONS(5267),
    [anon_sym_DASH] = ACTIONS(5269),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_STAR] = ACTIONS(5269),
    [anon_sym_SLASH] = ACTIONS(5269),
    [anon_sym_PERCENT] = ACTIONS(5269),
    [anon_sym_PIPE_PIPE] = ACTIONS(5267),
    [anon_sym_AMP_AMP] = ACTIONS(5267),
    [anon_sym_PIPE] = ACTIONS(5269),
    [anon_sym_CARET] = ACTIONS(5269),
    [anon_sym_AMP] = ACTIONS(5269),
    [anon_sym_EQ_EQ] = ACTIONS(5267),
    [anon_sym_BANG_EQ] = ACTIONS(5267),
    [anon_sym_GT] = ACTIONS(5269),
    [anon_sym_GT_EQ] = ACTIONS(5267),
    [anon_sym_LT_EQ] = ACTIONS(5269),
    [anon_sym_LT] = ACTIONS(5269),
    [anon_sym_LT_LT] = ACTIONS(5269),
    [anon_sym_GT_GT] = ACTIONS(5269),
    [anon_sym_LBRACK] = ACTIONS(5267),
    [anon_sym_EQ] = ACTIONS(5269),
    [anon_sym_QMARK] = ACTIONS(5267),
    [anon_sym_STAR_EQ] = ACTIONS(5267),
    [anon_sym_SLASH_EQ] = ACTIONS(5267),
    [anon_sym_PERCENT_EQ] = ACTIONS(5267),
    [anon_sym_PLUS_EQ] = ACTIONS(5267),
    [anon_sym_DASH_EQ] = ACTIONS(5267),
    [anon_sym_LT_LT_EQ] = ACTIONS(5267),
    [anon_sym_GT_GT_EQ] = ACTIONS(5267),
    [anon_sym_AMP_EQ] = ACTIONS(5267),
    [anon_sym_CARET_EQ] = ACTIONS(5267),
    [anon_sym_PIPE_EQ] = ACTIONS(5267),
    [anon_sym_and_eq] = ACTIONS(5269),
    [anon_sym_or_eq] = ACTIONS(5269),
    [anon_sym_xor_eq] = ACTIONS(5269),
    [anon_sym_LT_EQ_GT] = ACTIONS(5267),
    [anon_sym_or] = ACTIONS(5269),
    [anon_sym_and] = ACTIONS(5269),
    [anon_sym_bitor] = ACTIONS(5269),
    [anon_sym_xor] = ACTIONS(5269),
    [anon_sym_bitand] = ACTIONS(5269),
    [anon_sym_not_eq] = ACTIONS(5269),
    [anon_sym_DASH_DASH] = ACTIONS(5267),
    [anon_sym_PLUS_PLUS] = ACTIONS(5267),
    [anon_sym_DOT] = ACTIONS(5269),
    [anon_sym_DOT_STAR] = ACTIONS(5267),
    [anon_sym_DASH_GT] = ACTIONS(5269),
    [anon_sym_L_DQUOTE] = ACTIONS(5790),
    [anon_sym_u_DQUOTE] = ACTIONS(5790),
    [anon_sym_U_DQUOTE] = ACTIONS(5790),
    [anon_sym_u8_DQUOTE] = ACTIONS(5790),
    [anon_sym_DQUOTE] = ACTIONS(5790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5793),
    [anon_sym_LR_DQUOTE] = ACTIONS(5793),
    [anon_sym_uR_DQUOTE] = ACTIONS(5793),
    [anon_sym_UR_DQUOTE] = ACTIONS(5793),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5793),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5267),
    [sym_literal_suffix] = ACTIONS(5269),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5267),
  },
  [2291] = {
    [sym_string_literal] = STATE(2287),
    [sym_raw_string_literal] = STATE(2287),
    [aux_sym_concatenated_string_repeat1] = STATE(2287),
    [sym_identifier] = ACTIONS(5796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5346),
    [anon_sym_COMMA] = ACTIONS(5346),
    [anon_sym_RPAREN] = ACTIONS(5346),
    [anon_sym_LPAREN2] = ACTIONS(5346),
    [anon_sym_DASH] = ACTIONS(5348),
    [anon_sym_PLUS] = ACTIONS(5348),
    [anon_sym_STAR] = ACTIONS(5348),
    [anon_sym_SLASH] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [anon_sym_PIPE_PIPE] = ACTIONS(5346),
    [anon_sym_AMP_AMP] = ACTIONS(5346),
    [anon_sym_PIPE] = ACTIONS(5348),
    [anon_sym_CARET] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5348),
    [anon_sym_EQ_EQ] = ACTIONS(5346),
    [anon_sym_BANG_EQ] = ACTIONS(5346),
    [anon_sym_GT] = ACTIONS(5348),
    [anon_sym_GT_EQ] = ACTIONS(5346),
    [anon_sym_LT_EQ] = ACTIONS(5348),
    [anon_sym_LT] = ACTIONS(5348),
    [anon_sym_LT_LT] = ACTIONS(5348),
    [anon_sym_GT_GT] = ACTIONS(5348),
    [anon_sym_LBRACK] = ACTIONS(5346),
    [anon_sym_EQ] = ACTIONS(5348),
    [anon_sym_QMARK] = ACTIONS(5346),
    [anon_sym_STAR_EQ] = ACTIONS(5346),
    [anon_sym_SLASH_EQ] = ACTIONS(5346),
    [anon_sym_PERCENT_EQ] = ACTIONS(5346),
    [anon_sym_PLUS_EQ] = ACTIONS(5346),
    [anon_sym_DASH_EQ] = ACTIONS(5346),
    [anon_sym_LT_LT_EQ] = ACTIONS(5346),
    [anon_sym_GT_GT_EQ] = ACTIONS(5346),
    [anon_sym_AMP_EQ] = ACTIONS(5346),
    [anon_sym_CARET_EQ] = ACTIONS(5346),
    [anon_sym_PIPE_EQ] = ACTIONS(5346),
    [anon_sym_and_eq] = ACTIONS(5348),
    [anon_sym_or_eq] = ACTIONS(5348),
    [anon_sym_xor_eq] = ACTIONS(5348),
    [anon_sym_LT_EQ_GT] = ACTIONS(5346),
    [anon_sym_or] = ACTIONS(5348),
    [anon_sym_and] = ACTIONS(5348),
    [anon_sym_bitor] = ACTIONS(5348),
    [anon_sym_xor] = ACTIONS(5348),
    [anon_sym_bitand] = ACTIONS(5348),
    [anon_sym_not_eq] = ACTIONS(5348),
    [anon_sym_DASH_DASH] = ACTIONS(5346),
    [anon_sym_PLUS_PLUS] = ACTIONS(5346),
    [anon_sym_DOT] = ACTIONS(5348),
    [anon_sym_DOT_STAR] = ACTIONS(5346),
    [anon_sym_DASH_GT] = ACTIONS(5348),
    [anon_sym_L_DQUOTE] = ACTIONS(4814),
    [anon_sym_u_DQUOTE] = ACTIONS(4814),
    [anon_sym_U_DQUOTE] = ACTIONS(4814),
    [anon_sym_u8_DQUOTE] = ACTIONS(4814),
    [anon_sym_DQUOTE] = ACTIONS(4814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4816),
    [anon_sym_LR_DQUOTE] = ACTIONS(4816),
    [anon_sym_uR_DQUOTE] = ACTIONS(4816),
    [anon_sym_UR_DQUOTE] = ACTIONS(4816),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4816),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5346),
    [sym_literal_suffix] = ACTIONS(5348),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5346),
  },
  [2292] = {
    [sym_attribute_specifier] = STATE(2439),
    [sym_enumerator_list] = STATE(2343),
    [sym_identifier] = ACTIONS(5612),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5610),
    [anon_sym_COMMA] = ACTIONS(5610),
    [anon_sym_RPAREN] = ACTIONS(5610),
    [aux_sym_preproc_if_token2] = ACTIONS(5610),
    [aux_sym_preproc_else_token1] = ACTIONS(5610),
    [aux_sym_preproc_elif_token1] = ACTIONS(5612),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5610),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5610),
    [anon_sym_LPAREN2] = ACTIONS(5610),
    [anon_sym_DASH] = ACTIONS(5612),
    [anon_sym_PLUS] = ACTIONS(5612),
    [anon_sym_STAR] = ACTIONS(5612),
    [anon_sym_SLASH] = ACTIONS(5612),
    [anon_sym_PERCENT] = ACTIONS(5612),
    [anon_sym_PIPE_PIPE] = ACTIONS(5610),
    [anon_sym_AMP_AMP] = ACTIONS(5610),
    [anon_sym_PIPE] = ACTIONS(5612),
    [anon_sym_CARET] = ACTIONS(5612),
    [anon_sym_AMP] = ACTIONS(5612),
    [anon_sym_EQ_EQ] = ACTIONS(5610),
    [anon_sym_BANG_EQ] = ACTIONS(5610),
    [anon_sym_GT] = ACTIONS(5612),
    [anon_sym_GT_EQ] = ACTIONS(5610),
    [anon_sym_LT_EQ] = ACTIONS(5612),
    [anon_sym_LT] = ACTIONS(5612),
    [anon_sym_LT_LT] = ACTIONS(5612),
    [anon_sym_GT_GT] = ACTIONS(5612),
    [anon_sym_SEMI] = ACTIONS(5610),
    [anon_sym___attribute__] = ACTIONS(5546),
    [anon_sym_LBRACE] = ACTIONS(5772),
    [anon_sym_RBRACE] = ACTIONS(5610),
    [anon_sym_LBRACK] = ACTIONS(5610),
    [anon_sym_RBRACK] = ACTIONS(5610),
    [anon_sym_EQ] = ACTIONS(5612),
    [anon_sym_COLON] = ACTIONS(5610),
    [anon_sym_QMARK] = ACTIONS(5610),
    [anon_sym_STAR_EQ] = ACTIONS(5610),
    [anon_sym_SLASH_EQ] = ACTIONS(5610),
    [anon_sym_PERCENT_EQ] = ACTIONS(5610),
    [anon_sym_PLUS_EQ] = ACTIONS(5610),
    [anon_sym_DASH_EQ] = ACTIONS(5610),
    [anon_sym_LT_LT_EQ] = ACTIONS(5610),
    [anon_sym_GT_GT_EQ] = ACTIONS(5610),
    [anon_sym_AMP_EQ] = ACTIONS(5610),
    [anon_sym_CARET_EQ] = ACTIONS(5610),
    [anon_sym_PIPE_EQ] = ACTIONS(5610),
    [anon_sym_and_eq] = ACTIONS(5612),
    [anon_sym_or_eq] = ACTIONS(5612),
    [anon_sym_xor_eq] = ACTIONS(5612),
    [anon_sym_LT_EQ_GT] = ACTIONS(5610),
    [anon_sym_or] = ACTIONS(5612),
    [anon_sym_and] = ACTIONS(5612),
    [anon_sym_bitor] = ACTIONS(5612),
    [anon_sym_xor] = ACTIONS(5612),
    [anon_sym_bitand] = ACTIONS(5612),
    [anon_sym_not_eq] = ACTIONS(5612),
    [anon_sym_DASH_DASH] = ACTIONS(5610),
    [anon_sym_PLUS_PLUS] = ACTIONS(5610),
    [anon_sym_DOT] = ACTIONS(5612),
    [anon_sym_DOT_STAR] = ACTIONS(5610),
    [anon_sym_DASH_GT] = ACTIONS(5610),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5612),
    [anon_sym_decltype] = ACTIONS(5612),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5610),
  },
  [2293] = {
    [sym_string_literal] = STATE(2752),
    [sym_template_argument_list] = STATE(4108),
    [sym_raw_string_literal] = STATE(2752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(4850),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3758),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(3790),
    [anon_sym_COLON] = ACTIONS(3822),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3794),
    [anon_sym_SLASH_EQ] = ACTIONS(3794),
    [anon_sym_PERCENT_EQ] = ACTIONS(3794),
    [anon_sym_PLUS_EQ] = ACTIONS(3794),
    [anon_sym_DASH_EQ] = ACTIONS(3794),
    [anon_sym_LT_LT_EQ] = ACTIONS(3794),
    [anon_sym_GT_GT_EQ] = ACTIONS(3794),
    [anon_sym_AMP_EQ] = ACTIONS(3794),
    [anon_sym_CARET_EQ] = ACTIONS(3794),
    [anon_sym_PIPE_EQ] = ACTIONS(3794),
    [anon_sym_and_eq] = ACTIONS(3794),
    [anon_sym_or_eq] = ACTIONS(3794),
    [anon_sym_xor_eq] = ACTIONS(3794),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2294] = {
    [sym_string_literal] = STATE(2752),
    [sym_template_argument_list] = STATE(4108),
    [sym_raw_string_literal] = STATE(2752),
    [aux_sym_structured_binding_declarator_repeat1] = STATE(7601),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_LPAREN2] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(4850),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_RBRACK] = ACTIONS(5801),
    [anon_sym_EQ] = ACTIONS(5804),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(5806),
    [anon_sym_SLASH_EQ] = ACTIONS(5806),
    [anon_sym_PERCENT_EQ] = ACTIONS(5806),
    [anon_sym_PLUS_EQ] = ACTIONS(5806),
    [anon_sym_DASH_EQ] = ACTIONS(5806),
    [anon_sym_LT_LT_EQ] = ACTIONS(5806),
    [anon_sym_GT_GT_EQ] = ACTIONS(5806),
    [anon_sym_AMP_EQ] = ACTIONS(5806),
    [anon_sym_CARET_EQ] = ACTIONS(5806),
    [anon_sym_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_and_eq] = ACTIONS(5806),
    [anon_sym_or_eq] = ACTIONS(5806),
    [anon_sym_xor_eq] = ACTIONS(5806),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2295] = {
    [sym_string_literal] = STATE(2752),
    [sym_template_argument_list] = STATE(4108),
    [sym_raw_string_literal] = STATE(2752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(4850),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3758),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(3790),
    [anon_sym_COLON] = ACTIONS(3969),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3794),
    [anon_sym_SLASH_EQ] = ACTIONS(3794),
    [anon_sym_PERCENT_EQ] = ACTIONS(3794),
    [anon_sym_PLUS_EQ] = ACTIONS(3794),
    [anon_sym_DASH_EQ] = ACTIONS(3794),
    [anon_sym_LT_LT_EQ] = ACTIONS(3794),
    [anon_sym_GT_GT_EQ] = ACTIONS(3794),
    [anon_sym_AMP_EQ] = ACTIONS(3794),
    [anon_sym_CARET_EQ] = ACTIONS(3794),
    [anon_sym_PIPE_EQ] = ACTIONS(3794),
    [anon_sym_and_eq] = ACTIONS(3794),
    [anon_sym_or_eq] = ACTIONS(3794),
    [anon_sym_xor_eq] = ACTIONS(3794),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2296] = {
    [sym_string_literal] = STATE(3562),
    [sym_template_argument_list] = STATE(4108),
    [sym_raw_string_literal] = STATE(3562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(4850),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3758),
    [anon_sym___attribute__] = ACTIONS(3758),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(5808),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(5810),
    [anon_sym_SLASH_EQ] = ACTIONS(5810),
    [anon_sym_PERCENT_EQ] = ACTIONS(5810),
    [anon_sym_PLUS_EQ] = ACTIONS(5810),
    [anon_sym_DASH_EQ] = ACTIONS(5810),
    [anon_sym_LT_LT_EQ] = ACTIONS(5810),
    [anon_sym_GT_GT_EQ] = ACTIONS(5810),
    [anon_sym_AMP_EQ] = ACTIONS(5810),
    [anon_sym_CARET_EQ] = ACTIONS(5810),
    [anon_sym_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_and_eq] = ACTIONS(5810),
    [anon_sym_or_eq] = ACTIONS(5810),
    [anon_sym_xor_eq] = ACTIONS(5810),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(5812),
    [anon_sym_u_DQUOTE] = ACTIONS(5812),
    [anon_sym_U_DQUOTE] = ACTIONS(5812),
    [anon_sym_u8_DQUOTE] = ACTIONS(5812),
    [anon_sym_DQUOTE] = ACTIONS(5812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5814),
    [anon_sym_LR_DQUOTE] = ACTIONS(5814),
    [anon_sym_uR_DQUOTE] = ACTIONS(5814),
    [anon_sym_UR_DQUOTE] = ACTIONS(5814),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5814),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2297] = {
    [sym_identifier] = ACTIONS(4142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4149),
    [anon_sym_COMMA] = ACTIONS(4149),
    [anon_sym_RPAREN] = ACTIONS(4149),
    [anon_sym_LPAREN2] = ACTIONS(4149),
    [anon_sym_TILDE] = ACTIONS(4149),
    [anon_sym_STAR] = ACTIONS(4149),
    [anon_sym_AMP_AMP] = ACTIONS(4149),
    [anon_sym_AMP] = ACTIONS(4142),
    [anon_sym_SEMI] = ACTIONS(4149),
    [anon_sym___extension__] = ACTIONS(4142),
    [anon_sym___device__] = ACTIONS(4142),
    [anon_sym___host__] = ACTIONS(4142),
    [anon_sym___global__] = ACTIONS(4142),
    [anon_sym___forceinline__] = ACTIONS(4142),
    [anon_sym___noinline__] = ACTIONS(4142),
    [anon_sym_extern] = ACTIONS(4142),
    [anon_sym___attribute__] = ACTIONS(4142),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4149),
    [anon_sym___declspec] = ACTIONS(4142),
    [anon_sym___based] = ACTIONS(4142),
    [anon_sym___cdecl] = ACTIONS(4142),
    [anon_sym___clrcall] = ACTIONS(4142),
    [anon_sym___stdcall] = ACTIONS(4142),
    [anon_sym___fastcall] = ACTIONS(4142),
    [anon_sym___thiscall] = ACTIONS(4142),
    [anon_sym___vectorcall] = ACTIONS(4142),
    [anon_sym_LBRACE] = ACTIONS(4149),
    [anon_sym_LBRACK] = ACTIONS(4142),
    [anon_sym_static] = ACTIONS(4142),
    [anon_sym_EQ] = ACTIONS(4149),
    [anon_sym_register] = ACTIONS(4142),
    [anon_sym_inline] = ACTIONS(4142),
    [anon_sym___inline] = ACTIONS(4142),
    [anon_sym___inline__] = ACTIONS(4142),
    [anon_sym___forceinline] = ACTIONS(4142),
    [anon_sym_thread_local] = ACTIONS(4142),
    [anon_sym___thread] = ACTIONS(4142),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_constexpr] = ACTIONS(4142),
    [anon_sym_volatile] = ACTIONS(4142),
    [anon_sym_restrict] = ACTIONS(4142),
    [anon_sym___restrict__] = ACTIONS(4142),
    [anon_sym__Atomic] = ACTIONS(4142),
    [anon_sym__Noreturn] = ACTIONS(4142),
    [anon_sym_noreturn] = ACTIONS(4142),
    [anon_sym_mutable] = ACTIONS(4142),
    [anon_sym_constinit] = ACTIONS(4142),
    [anon_sym_consteval] = ACTIONS(4142),
    [anon_sym___shared__] = ACTIONS(4142),
    [anon_sym___local__] = ACTIONS(4142),
    [anon_sym___constant__] = ACTIONS(4142),
    [anon_sym___managed__] = ACTIONS(4142),
    [anon_sym___grid_constant__] = ACTIONS(4142),
    [anon_sym_alignas] = ACTIONS(4142),
    [anon_sym__Alignas] = ACTIONS(4142),
    [anon_sym_COLON] = ACTIONS(4142),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4142),
    [anon_sym_decltype] = ACTIONS(4142),
    [anon_sym_final] = ACTIONS(4142),
    [anon_sym_override] = ACTIONS(4142),
    [sym_virtual] = ACTIONS(4142),
    [anon_sym_template] = ACTIONS(4142),
    [anon_sym_GT2] = ACTIONS(4149),
    [anon_sym_operator] = ACTIONS(4142),
    [anon_sym___launch_bounds__] = ACTIONS(4142),
  },
  [2298] = {
    [sym_string_literal] = STATE(2302),
    [sym_raw_string_literal] = STATE(2302),
    [aux_sym_concatenated_string_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(5816),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5346),
    [anon_sym_COMMA] = ACTIONS(5346),
    [anon_sym_LPAREN2] = ACTIONS(5346),
    [anon_sym_DASH] = ACTIONS(5348),
    [anon_sym_PLUS] = ACTIONS(5348),
    [anon_sym_STAR] = ACTIONS(5348),
    [anon_sym_SLASH] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [anon_sym_PIPE_PIPE] = ACTIONS(5346),
    [anon_sym_AMP_AMP] = ACTIONS(5346),
    [anon_sym_PIPE] = ACTIONS(5348),
    [anon_sym_CARET] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5348),
    [anon_sym_EQ_EQ] = ACTIONS(5346),
    [anon_sym_BANG_EQ] = ACTIONS(5346),
    [anon_sym_GT] = ACTIONS(5348),
    [anon_sym_GT_EQ] = ACTIONS(5346),
    [anon_sym_LT_EQ] = ACTIONS(5348),
    [anon_sym_LT] = ACTIONS(5348),
    [anon_sym_LT_LT] = ACTIONS(5348),
    [anon_sym_GT_GT] = ACTIONS(5348),
    [anon_sym_SEMI] = ACTIONS(5346),
    [anon_sym___attribute__] = ACTIONS(5348),
    [anon_sym_LBRACK] = ACTIONS(5346),
    [anon_sym_EQ] = ACTIONS(5348),
    [anon_sym_QMARK] = ACTIONS(5346),
    [anon_sym_STAR_EQ] = ACTIONS(5346),
    [anon_sym_SLASH_EQ] = ACTIONS(5346),
    [anon_sym_PERCENT_EQ] = ACTIONS(5346),
    [anon_sym_PLUS_EQ] = ACTIONS(5346),
    [anon_sym_DASH_EQ] = ACTIONS(5346),
    [anon_sym_LT_LT_EQ] = ACTIONS(5346),
    [anon_sym_GT_GT_EQ] = ACTIONS(5346),
    [anon_sym_AMP_EQ] = ACTIONS(5346),
    [anon_sym_CARET_EQ] = ACTIONS(5346),
    [anon_sym_PIPE_EQ] = ACTIONS(5346),
    [anon_sym_and_eq] = ACTIONS(5348),
    [anon_sym_or_eq] = ACTIONS(5348),
    [anon_sym_xor_eq] = ACTIONS(5348),
    [anon_sym_LT_EQ_GT] = ACTIONS(5346),
    [anon_sym_or] = ACTIONS(5348),
    [anon_sym_and] = ACTIONS(5348),
    [anon_sym_bitor] = ACTIONS(5348),
    [anon_sym_xor] = ACTIONS(5348),
    [anon_sym_bitand] = ACTIONS(5348),
    [anon_sym_not_eq] = ACTIONS(5348),
    [anon_sym_DASH_DASH] = ACTIONS(5346),
    [anon_sym_PLUS_PLUS] = ACTIONS(5346),
    [anon_sym_DOT] = ACTIONS(5348),
    [anon_sym_DOT_STAR] = ACTIONS(5346),
    [anon_sym_DASH_GT] = ACTIONS(5346),
    [anon_sym_L_DQUOTE] = ACTIONS(5766),
    [anon_sym_u_DQUOTE] = ACTIONS(5766),
    [anon_sym_U_DQUOTE] = ACTIONS(5766),
    [anon_sym_u8_DQUOTE] = ACTIONS(5766),
    [anon_sym_DQUOTE] = ACTIONS(5766),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5768),
    [anon_sym_LR_DQUOTE] = ACTIONS(5768),
    [anon_sym_uR_DQUOTE] = ACTIONS(5768),
    [anon_sym_UR_DQUOTE] = ACTIONS(5768),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5768),
    [sym_literal_suffix] = ACTIONS(5348),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5346),
  },
  [2299] = {
    [sym_string_literal] = STATE(2752),
    [sym_template_argument_list] = STATE(4108),
    [sym_raw_string_literal] = STATE(2752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(4850),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3758),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(3790),
    [anon_sym_COLON] = ACTIONS(3818),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3794),
    [anon_sym_SLASH_EQ] = ACTIONS(3794),
    [anon_sym_PERCENT_EQ] = ACTIONS(3794),
    [anon_sym_PLUS_EQ] = ACTIONS(3794),
    [anon_sym_DASH_EQ] = ACTIONS(3794),
    [anon_sym_LT_LT_EQ] = ACTIONS(3794),
    [anon_sym_GT_GT_EQ] = ACTIONS(3794),
    [anon_sym_AMP_EQ] = ACTIONS(3794),
    [anon_sym_CARET_EQ] = ACTIONS(3794),
    [anon_sym_PIPE_EQ] = ACTIONS(3794),
    [anon_sym_and_eq] = ACTIONS(3794),
    [anon_sym_or_eq] = ACTIONS(3794),
    [anon_sym_xor_eq] = ACTIONS(3794),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2300] = {
    [sym_string_literal] = STATE(2519),
    [sym_template_argument_list] = STATE(3947),
    [sym_raw_string_literal] = STATE(2519),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_RPAREN] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(5818),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3758),
    [anon_sym_SLASH_EQ] = ACTIONS(3758),
    [anon_sym_PERCENT_EQ] = ACTIONS(3758),
    [anon_sym_PLUS_EQ] = ACTIONS(3758),
    [anon_sym_DASH_EQ] = ACTIONS(3758),
    [anon_sym_LT_LT_EQ] = ACTIONS(3758),
    [anon_sym_GT_GT_EQ] = ACTIONS(3758),
    [anon_sym_AMP_EQ] = ACTIONS(3758),
    [anon_sym_CARET_EQ] = ACTIONS(3758),
    [anon_sym_PIPE_EQ] = ACTIONS(3758),
    [anon_sym_and_eq] = ACTIONS(5821),
    [anon_sym_or_eq] = ACTIONS(5821),
    [anon_sym_xor_eq] = ACTIONS(5821),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3766),
    [anon_sym_L_DQUOTE] = ACTIONS(3976),
    [anon_sym_u_DQUOTE] = ACTIONS(3976),
    [anon_sym_U_DQUOTE] = ACTIONS(3976),
    [anon_sym_u8_DQUOTE] = ACTIONS(3976),
    [anon_sym_DQUOTE] = ACTIONS(3976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3978),
    [anon_sym_LR_DQUOTE] = ACTIONS(3978),
    [anon_sym_uR_DQUOTE] = ACTIONS(3978),
    [anon_sym_UR_DQUOTE] = ACTIONS(3978),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3978),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3758),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2301] = {
    [sym_string_literal] = STATE(2752),
    [sym_template_argument_list] = STATE(4108),
    [sym_raw_string_literal] = STATE(2752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(4850),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3758),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(3790),
    [anon_sym_COLON] = ACTIONS(3828),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3794),
    [anon_sym_SLASH_EQ] = ACTIONS(3794),
    [anon_sym_PERCENT_EQ] = ACTIONS(3794),
    [anon_sym_PLUS_EQ] = ACTIONS(3794),
    [anon_sym_DASH_EQ] = ACTIONS(3794),
    [anon_sym_LT_LT_EQ] = ACTIONS(3794),
    [anon_sym_GT_GT_EQ] = ACTIONS(3794),
    [anon_sym_AMP_EQ] = ACTIONS(3794),
    [anon_sym_CARET_EQ] = ACTIONS(3794),
    [anon_sym_PIPE_EQ] = ACTIONS(3794),
    [anon_sym_and_eq] = ACTIONS(3794),
    [anon_sym_or_eq] = ACTIONS(3794),
    [anon_sym_xor_eq] = ACTIONS(3794),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2302] = {
    [sym_string_literal] = STATE(2288),
    [sym_raw_string_literal] = STATE(2288),
    [aux_sym_concatenated_string_repeat1] = STATE(2288),
    [sym_identifier] = ACTIONS(5823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5307),
    [anon_sym_COMMA] = ACTIONS(5307),
    [anon_sym_LPAREN2] = ACTIONS(5307),
    [anon_sym_DASH] = ACTIONS(5309),
    [anon_sym_PLUS] = ACTIONS(5309),
    [anon_sym_STAR] = ACTIONS(5309),
    [anon_sym_SLASH] = ACTIONS(5309),
    [anon_sym_PERCENT] = ACTIONS(5309),
    [anon_sym_PIPE_PIPE] = ACTIONS(5307),
    [anon_sym_AMP_AMP] = ACTIONS(5307),
    [anon_sym_PIPE] = ACTIONS(5309),
    [anon_sym_CARET] = ACTIONS(5309),
    [anon_sym_AMP] = ACTIONS(5309),
    [anon_sym_EQ_EQ] = ACTIONS(5307),
    [anon_sym_BANG_EQ] = ACTIONS(5307),
    [anon_sym_GT] = ACTIONS(5309),
    [anon_sym_GT_EQ] = ACTIONS(5307),
    [anon_sym_LT_EQ] = ACTIONS(5309),
    [anon_sym_LT] = ACTIONS(5309),
    [anon_sym_LT_LT] = ACTIONS(5309),
    [anon_sym_GT_GT] = ACTIONS(5309),
    [anon_sym_SEMI] = ACTIONS(5307),
    [anon_sym___attribute__] = ACTIONS(5309),
    [anon_sym_LBRACK] = ACTIONS(5307),
    [anon_sym_EQ] = ACTIONS(5309),
    [anon_sym_QMARK] = ACTIONS(5307),
    [anon_sym_STAR_EQ] = ACTIONS(5307),
    [anon_sym_SLASH_EQ] = ACTIONS(5307),
    [anon_sym_PERCENT_EQ] = ACTIONS(5307),
    [anon_sym_PLUS_EQ] = ACTIONS(5307),
    [anon_sym_DASH_EQ] = ACTIONS(5307),
    [anon_sym_LT_LT_EQ] = ACTIONS(5307),
    [anon_sym_GT_GT_EQ] = ACTIONS(5307),
    [anon_sym_AMP_EQ] = ACTIONS(5307),
    [anon_sym_CARET_EQ] = ACTIONS(5307),
    [anon_sym_PIPE_EQ] = ACTIONS(5307),
    [anon_sym_and_eq] = ACTIONS(5309),
    [anon_sym_or_eq] = ACTIONS(5309),
    [anon_sym_xor_eq] = ACTIONS(5309),
    [anon_sym_LT_EQ_GT] = ACTIONS(5307),
    [anon_sym_or] = ACTIONS(5309),
    [anon_sym_and] = ACTIONS(5309),
    [anon_sym_bitor] = ACTIONS(5309),
    [anon_sym_xor] = ACTIONS(5309),
    [anon_sym_bitand] = ACTIONS(5309),
    [anon_sym_not_eq] = ACTIONS(5309),
    [anon_sym_DASH_DASH] = ACTIONS(5307),
    [anon_sym_PLUS_PLUS] = ACTIONS(5307),
    [anon_sym_DOT] = ACTIONS(5309),
    [anon_sym_DOT_STAR] = ACTIONS(5307),
    [anon_sym_DASH_GT] = ACTIONS(5307),
    [anon_sym_L_DQUOTE] = ACTIONS(5766),
    [anon_sym_u_DQUOTE] = ACTIONS(5766),
    [anon_sym_U_DQUOTE] = ACTIONS(5766),
    [anon_sym_u8_DQUOTE] = ACTIONS(5766),
    [anon_sym_DQUOTE] = ACTIONS(5766),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5768),
    [anon_sym_LR_DQUOTE] = ACTIONS(5768),
    [anon_sym_uR_DQUOTE] = ACTIONS(5768),
    [anon_sym_UR_DQUOTE] = ACTIONS(5768),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5768),
    [sym_literal_suffix] = ACTIONS(5309),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5307),
  },
  [2303] = {
    [sym_string_literal] = STATE(2752),
    [sym_template_argument_list] = STATE(4108),
    [sym_raw_string_literal] = STATE(2752),
    [aux_sym_structured_binding_declarator_repeat1] = STATE(7601),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(5825),
    [anon_sym_LPAREN2] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(4850),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_RBRACK] = ACTIONS(5801),
    [anon_sym_EQ] = ACTIONS(5804),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(5806),
    [anon_sym_SLASH_EQ] = ACTIONS(5806),
    [anon_sym_PERCENT_EQ] = ACTIONS(5806),
    [anon_sym_PLUS_EQ] = ACTIONS(5806),
    [anon_sym_DASH_EQ] = ACTIONS(5806),
    [anon_sym_LT_LT_EQ] = ACTIONS(5806),
    [anon_sym_GT_GT_EQ] = ACTIONS(5806),
    [anon_sym_AMP_EQ] = ACTIONS(5806),
    [anon_sym_CARET_EQ] = ACTIONS(5806),
    [anon_sym_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_and_eq] = ACTIONS(5806),
    [anon_sym_or_eq] = ACTIONS(5806),
    [anon_sym_xor_eq] = ACTIONS(5806),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2304] = {
    [sym_string_literal] = STATE(2291),
    [sym_template_argument_list] = STATE(3307),
    [sym_raw_string_literal] = STATE(2291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_RPAREN] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(4834),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3758),
    [anon_sym_SLASH_EQ] = ACTIONS(3758),
    [anon_sym_PERCENT_EQ] = ACTIONS(3758),
    [anon_sym_PLUS_EQ] = ACTIONS(3758),
    [anon_sym_DASH_EQ] = ACTIONS(3758),
    [anon_sym_LT_LT_EQ] = ACTIONS(3758),
    [anon_sym_GT_GT_EQ] = ACTIONS(3758),
    [anon_sym_AMP_EQ] = ACTIONS(3758),
    [anon_sym_CARET_EQ] = ACTIONS(3758),
    [anon_sym_PIPE_EQ] = ACTIONS(3758),
    [anon_sym_and_eq] = ACTIONS(3758),
    [anon_sym_or_eq] = ACTIONS(3758),
    [anon_sym_xor_eq] = ACTIONS(3758),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3766),
    [anon_sym_L_DQUOTE] = ACTIONS(4814),
    [anon_sym_u_DQUOTE] = ACTIONS(4814),
    [anon_sym_U_DQUOTE] = ACTIONS(4814),
    [anon_sym_u8_DQUOTE] = ACTIONS(4814),
    [anon_sym_DQUOTE] = ACTIONS(4814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4816),
    [anon_sym_LR_DQUOTE] = ACTIONS(4816),
    [anon_sym_uR_DQUOTE] = ACTIONS(4816),
    [anon_sym_UR_DQUOTE] = ACTIONS(4816),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4816),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3758),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2305] = {
    [sym_identifier] = ACTIONS(5149),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5151),
    [anon_sym_COMMA] = ACTIONS(5151),
    [anon_sym_RPAREN] = ACTIONS(5151),
    [anon_sym_LPAREN2] = ACTIONS(5151),
    [anon_sym_TILDE] = ACTIONS(5151),
    [anon_sym_STAR] = ACTIONS(5151),
    [anon_sym_AMP_AMP] = ACTIONS(5151),
    [anon_sym_AMP] = ACTIONS(5149),
    [anon_sym_SEMI] = ACTIONS(5151),
    [anon_sym___extension__] = ACTIONS(5149),
    [anon_sym___device__] = ACTIONS(5149),
    [anon_sym___host__] = ACTIONS(5149),
    [anon_sym___global__] = ACTIONS(5149),
    [anon_sym___forceinline__] = ACTIONS(5149),
    [anon_sym___noinline__] = ACTIONS(5149),
    [anon_sym_extern] = ACTIONS(5149),
    [anon_sym___attribute__] = ACTIONS(5149),
    [anon_sym_COLON_COLON] = ACTIONS(5151),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5151),
    [anon_sym___declspec] = ACTIONS(5149),
    [anon_sym___based] = ACTIONS(5149),
    [anon_sym___cdecl] = ACTIONS(5149),
    [anon_sym___clrcall] = ACTIONS(5149),
    [anon_sym___stdcall] = ACTIONS(5149),
    [anon_sym___fastcall] = ACTIONS(5149),
    [anon_sym___thiscall] = ACTIONS(5149),
    [anon_sym___vectorcall] = ACTIONS(5149),
    [anon_sym_LBRACE] = ACTIONS(5151),
    [anon_sym_LBRACK] = ACTIONS(5149),
    [anon_sym_static] = ACTIONS(5149),
    [anon_sym_EQ] = ACTIONS(5151),
    [anon_sym_register] = ACTIONS(5149),
    [anon_sym_inline] = ACTIONS(5149),
    [anon_sym___inline] = ACTIONS(5149),
    [anon_sym___inline__] = ACTIONS(5149),
    [anon_sym___forceinline] = ACTIONS(5149),
    [anon_sym_thread_local] = ACTIONS(5149),
    [anon_sym___thread] = ACTIONS(5149),
    [anon_sym_const] = ACTIONS(5149),
    [anon_sym_constexpr] = ACTIONS(5149),
    [anon_sym_volatile] = ACTIONS(5149),
    [anon_sym_restrict] = ACTIONS(5149),
    [anon_sym___restrict__] = ACTIONS(5149),
    [anon_sym__Atomic] = ACTIONS(5149),
    [anon_sym__Noreturn] = ACTIONS(5149),
    [anon_sym_noreturn] = ACTIONS(5149),
    [anon_sym_mutable] = ACTIONS(5149),
    [anon_sym_constinit] = ACTIONS(5149),
    [anon_sym_consteval] = ACTIONS(5149),
    [anon_sym___shared__] = ACTIONS(5149),
    [anon_sym___local__] = ACTIONS(5149),
    [anon_sym___constant__] = ACTIONS(5149),
    [anon_sym___managed__] = ACTIONS(5149),
    [anon_sym___grid_constant__] = ACTIONS(5149),
    [anon_sym_alignas] = ACTIONS(5149),
    [anon_sym__Alignas] = ACTIONS(5149),
    [anon_sym_COLON] = ACTIONS(5149),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(5149),
    [anon_sym_final] = ACTIONS(5149),
    [anon_sym_override] = ACTIONS(5149),
    [sym_virtual] = ACTIONS(5149),
    [anon_sym_explicit] = ACTIONS(5149),
    [anon_sym_template] = ACTIONS(5149),
    [anon_sym_GT2] = ACTIONS(5151),
    [anon_sym_operator] = ACTIONS(5149),
    [anon_sym___launch_bounds__] = ACTIONS(5149),
  },
  [2306] = {
    [sym_identifier] = ACTIONS(5827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5829),
    [anon_sym_COMMA] = ACTIONS(5829),
    [anon_sym_RPAREN] = ACTIONS(5829),
    [anon_sym_LPAREN2] = ACTIONS(5829),
    [anon_sym_TILDE] = ACTIONS(5829),
    [anon_sym_STAR] = ACTIONS(5829),
    [anon_sym_AMP_AMP] = ACTIONS(5829),
    [anon_sym_AMP] = ACTIONS(5827),
    [anon_sym_SEMI] = ACTIONS(5829),
    [anon_sym___extension__] = ACTIONS(5827),
    [anon_sym___device__] = ACTIONS(5827),
    [anon_sym___host__] = ACTIONS(5827),
    [anon_sym___global__] = ACTIONS(5827),
    [anon_sym___forceinline__] = ACTIONS(5827),
    [anon_sym___noinline__] = ACTIONS(5827),
    [anon_sym_extern] = ACTIONS(5827),
    [anon_sym___attribute__] = ACTIONS(5827),
    [anon_sym_COLON_COLON] = ACTIONS(5829),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5829),
    [anon_sym___declspec] = ACTIONS(5827),
    [anon_sym___based] = ACTIONS(5827),
    [anon_sym___cdecl] = ACTIONS(5827),
    [anon_sym___clrcall] = ACTIONS(5827),
    [anon_sym___stdcall] = ACTIONS(5827),
    [anon_sym___fastcall] = ACTIONS(5827),
    [anon_sym___thiscall] = ACTIONS(5827),
    [anon_sym___vectorcall] = ACTIONS(5827),
    [anon_sym_LBRACE] = ACTIONS(5829),
    [anon_sym_LBRACK] = ACTIONS(5827),
    [anon_sym_static] = ACTIONS(5827),
    [anon_sym_EQ] = ACTIONS(5829),
    [anon_sym_register] = ACTIONS(5827),
    [anon_sym_inline] = ACTIONS(5827),
    [anon_sym___inline] = ACTIONS(5827),
    [anon_sym___inline__] = ACTIONS(5827),
    [anon_sym___forceinline] = ACTIONS(5827),
    [anon_sym_thread_local] = ACTIONS(5827),
    [anon_sym___thread] = ACTIONS(5827),
    [anon_sym_const] = ACTIONS(5827),
    [anon_sym_constexpr] = ACTIONS(5827),
    [anon_sym_volatile] = ACTIONS(5827),
    [anon_sym_restrict] = ACTIONS(5827),
    [anon_sym___restrict__] = ACTIONS(5827),
    [anon_sym__Atomic] = ACTIONS(5827),
    [anon_sym__Noreturn] = ACTIONS(5827),
    [anon_sym_noreturn] = ACTIONS(5827),
    [anon_sym_mutable] = ACTIONS(5827),
    [anon_sym_constinit] = ACTIONS(5827),
    [anon_sym_consteval] = ACTIONS(5827),
    [anon_sym___shared__] = ACTIONS(5827),
    [anon_sym___local__] = ACTIONS(5827),
    [anon_sym___constant__] = ACTIONS(5827),
    [anon_sym___managed__] = ACTIONS(5827),
    [anon_sym___grid_constant__] = ACTIONS(5827),
    [anon_sym_alignas] = ACTIONS(5827),
    [anon_sym__Alignas] = ACTIONS(5827),
    [anon_sym_COLON] = ACTIONS(5827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(5827),
    [anon_sym_final] = ACTIONS(5827),
    [anon_sym_override] = ACTIONS(5827),
    [sym_virtual] = ACTIONS(5827),
    [anon_sym_explicit] = ACTIONS(5827),
    [anon_sym_template] = ACTIONS(5827),
    [anon_sym_GT2] = ACTIONS(5829),
    [anon_sym_operator] = ACTIONS(5827),
    [anon_sym___launch_bounds__] = ACTIONS(5827),
  },
  [2307] = {
    [sym_identifier] = ACTIONS(5179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5181),
    [anon_sym_COMMA] = ACTIONS(5181),
    [anon_sym_RPAREN] = ACTIONS(5181),
    [aux_sym_preproc_if_token2] = ACTIONS(5181),
    [aux_sym_preproc_else_token1] = ACTIONS(5181),
    [aux_sym_preproc_elif_token1] = ACTIONS(5179),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5181),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5181),
    [anon_sym_LPAREN2] = ACTIONS(5181),
    [anon_sym_DASH] = ACTIONS(5179),
    [anon_sym_PLUS] = ACTIONS(5179),
    [anon_sym_STAR] = ACTIONS(5179),
    [anon_sym_SLASH] = ACTIONS(5179),
    [anon_sym_PERCENT] = ACTIONS(5179),
    [anon_sym_PIPE_PIPE] = ACTIONS(5181),
    [anon_sym_AMP_AMP] = ACTIONS(5181),
    [anon_sym_PIPE] = ACTIONS(5179),
    [anon_sym_CARET] = ACTIONS(5179),
    [anon_sym_AMP] = ACTIONS(5179),
    [anon_sym_EQ_EQ] = ACTIONS(5181),
    [anon_sym_BANG_EQ] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5179),
    [anon_sym_GT_EQ] = ACTIONS(5181),
    [anon_sym_LT_EQ] = ACTIONS(5179),
    [anon_sym_LT] = ACTIONS(5179),
    [anon_sym_LT_LT] = ACTIONS(5179),
    [anon_sym_GT_GT] = ACTIONS(5179),
    [anon_sym_SEMI] = ACTIONS(5181),
    [anon_sym___attribute__] = ACTIONS(5179),
    [anon_sym_LBRACE] = ACTIONS(5181),
    [anon_sym_RBRACE] = ACTIONS(5181),
    [anon_sym_LBRACK] = ACTIONS(5181),
    [anon_sym_RBRACK] = ACTIONS(5181),
    [anon_sym_EQ] = ACTIONS(5179),
    [anon_sym_COLON] = ACTIONS(5181),
    [anon_sym_QMARK] = ACTIONS(5181),
    [anon_sym_STAR_EQ] = ACTIONS(5181),
    [anon_sym_SLASH_EQ] = ACTIONS(5181),
    [anon_sym_PERCENT_EQ] = ACTIONS(5181),
    [anon_sym_PLUS_EQ] = ACTIONS(5181),
    [anon_sym_DASH_EQ] = ACTIONS(5181),
    [anon_sym_LT_LT_EQ] = ACTIONS(5181),
    [anon_sym_GT_GT_EQ] = ACTIONS(5181),
    [anon_sym_AMP_EQ] = ACTIONS(5181),
    [anon_sym_CARET_EQ] = ACTIONS(5181),
    [anon_sym_PIPE_EQ] = ACTIONS(5181),
    [anon_sym_and_eq] = ACTIONS(5179),
    [anon_sym_or_eq] = ACTIONS(5179),
    [anon_sym_xor_eq] = ACTIONS(5179),
    [anon_sym_LT_EQ_GT] = ACTIONS(5181),
    [anon_sym_or] = ACTIONS(5179),
    [anon_sym_and] = ACTIONS(5179),
    [anon_sym_bitor] = ACTIONS(5179),
    [anon_sym_xor] = ACTIONS(5179),
    [anon_sym_bitand] = ACTIONS(5179),
    [anon_sym_not_eq] = ACTIONS(5179),
    [anon_sym_DASH_DASH] = ACTIONS(5181),
    [anon_sym_PLUS_PLUS] = ACTIONS(5181),
    [anon_sym_DOT] = ACTIONS(5179),
    [anon_sym_DOT_STAR] = ACTIONS(5181),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5179),
    [anon_sym_decltype] = ACTIONS(5179),
    [anon_sym_final] = ACTIONS(5179),
    [anon_sym_override] = ACTIONS(5179),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5181),
  },
  [2308] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2152),
    [sym_identifier] = ACTIONS(5016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5258),
    [anon_sym_COMMA] = ACTIONS(5258),
    [anon_sym_RPAREN] = ACTIONS(5258),
    [anon_sym_LPAREN2] = ACTIONS(5258),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5261),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5261),
    [anon_sym_PERCENT] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5258),
    [anon_sym_AMP_AMP] = ACTIONS(5258),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_CARET] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_EQ_EQ] = ACTIONS(5258),
    [anon_sym_BANG_EQ] = ACTIONS(5258),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5258),
    [anon_sym_LT_EQ] = ACTIONS(5261),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_LT] = ACTIONS(5261),
    [anon_sym_GT_GT] = ACTIONS(5261),
    [anon_sym_SEMI] = ACTIONS(5258),
    [anon_sym___attribute__] = ACTIONS(5261),
    [anon_sym_LBRACE] = ACTIONS(5258),
    [anon_sym_RBRACE] = ACTIONS(5258),
    [anon_sym_signed] = ACTIONS(5527),
    [anon_sym_unsigned] = ACTIONS(5527),
    [anon_sym_long] = ACTIONS(5527),
    [anon_sym_short] = ACTIONS(5527),
    [anon_sym_LBRACK] = ACTIONS(5258),
    [anon_sym_RBRACK] = ACTIONS(5258),
    [anon_sym_EQ] = ACTIONS(5261),
    [sym_primitive_type] = ACTIONS(5016),
    [anon_sym_COLON] = ACTIONS(5258),
    [anon_sym_QMARK] = ACTIONS(5258),
    [anon_sym_STAR_EQ] = ACTIONS(5258),
    [anon_sym_SLASH_EQ] = ACTIONS(5258),
    [anon_sym_PERCENT_EQ] = ACTIONS(5258),
    [anon_sym_PLUS_EQ] = ACTIONS(5258),
    [anon_sym_DASH_EQ] = ACTIONS(5258),
    [anon_sym_LT_LT_EQ] = ACTIONS(5258),
    [anon_sym_GT_GT_EQ] = ACTIONS(5258),
    [anon_sym_AMP_EQ] = ACTIONS(5258),
    [anon_sym_CARET_EQ] = ACTIONS(5258),
    [anon_sym_PIPE_EQ] = ACTIONS(5258),
    [anon_sym_and_eq] = ACTIONS(5261),
    [anon_sym_or_eq] = ACTIONS(5261),
    [anon_sym_xor_eq] = ACTIONS(5261),
    [anon_sym_LT_EQ_GT] = ACTIONS(5258),
    [anon_sym_or] = ACTIONS(5261),
    [anon_sym_and] = ACTIONS(5261),
    [anon_sym_bitor] = ACTIONS(5261),
    [anon_sym_xor] = ACTIONS(5261),
    [anon_sym_bitand] = ACTIONS(5261),
    [anon_sym_not_eq] = ACTIONS(5261),
    [anon_sym_DASH_DASH] = ACTIONS(5258),
    [anon_sym_PLUS_PLUS] = ACTIONS(5258),
    [anon_sym_DOT] = ACTIONS(5261),
    [anon_sym_DOT_STAR] = ACTIONS(5258),
    [anon_sym_DASH_GT] = ACTIONS(5258),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5261),
    [anon_sym_decltype] = ACTIONS(5261),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5258),
  },
  [2309] = {
    [sym_attribute_declaration] = STATE(2388),
    [sym_parameter_list] = STATE(2456),
    [aux_sym_attributed_declarator_repeat1] = STATE(2388),
    [sym_identifier] = ACTIONS(5831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5833),
    [anon_sym_COMMA] = ACTIONS(5833),
    [anon_sym_RPAREN] = ACTIONS(5833),
    [aux_sym_preproc_if_token2] = ACTIONS(5833),
    [aux_sym_preproc_else_token1] = ACTIONS(5833),
    [aux_sym_preproc_elif_token1] = ACTIONS(5831),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5833),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5833),
    [anon_sym_LPAREN2] = ACTIONS(5835),
    [anon_sym_DASH] = ACTIONS(5831),
    [anon_sym_PLUS] = ACTIONS(5831),
    [anon_sym_STAR] = ACTIONS(5831),
    [anon_sym_SLASH] = ACTIONS(5831),
    [anon_sym_PERCENT] = ACTIONS(5831),
    [anon_sym_PIPE_PIPE] = ACTIONS(5833),
    [anon_sym_AMP_AMP] = ACTIONS(5833),
    [anon_sym_PIPE] = ACTIONS(5831),
    [anon_sym_CARET] = ACTIONS(5831),
    [anon_sym_AMP] = ACTIONS(5831),
    [anon_sym_EQ_EQ] = ACTIONS(5833),
    [anon_sym_BANG_EQ] = ACTIONS(5833),
    [anon_sym_GT] = ACTIONS(5831),
    [anon_sym_GT_EQ] = ACTIONS(5833),
    [anon_sym_LT_EQ] = ACTIONS(5831),
    [anon_sym_LT] = ACTIONS(5831),
    [anon_sym_LT_LT] = ACTIONS(5831),
    [anon_sym_GT_GT] = ACTIONS(5831),
    [anon_sym_SEMI] = ACTIONS(5833),
    [anon_sym___attribute__] = ACTIONS(5831),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5837),
    [anon_sym_RBRACE] = ACTIONS(5833),
    [anon_sym_LBRACK] = ACTIONS(5839),
    [anon_sym_RBRACK] = ACTIONS(5833),
    [anon_sym_EQ] = ACTIONS(5831),
    [anon_sym_COLON] = ACTIONS(5833),
    [anon_sym_QMARK] = ACTIONS(5833),
    [anon_sym_STAR_EQ] = ACTIONS(5833),
    [anon_sym_SLASH_EQ] = ACTIONS(5833),
    [anon_sym_PERCENT_EQ] = ACTIONS(5833),
    [anon_sym_PLUS_EQ] = ACTIONS(5833),
    [anon_sym_DASH_EQ] = ACTIONS(5833),
    [anon_sym_LT_LT_EQ] = ACTIONS(5833),
    [anon_sym_GT_GT_EQ] = ACTIONS(5833),
    [anon_sym_AMP_EQ] = ACTIONS(5833),
    [anon_sym_CARET_EQ] = ACTIONS(5833),
    [anon_sym_PIPE_EQ] = ACTIONS(5833),
    [anon_sym_and_eq] = ACTIONS(5831),
    [anon_sym_or_eq] = ACTIONS(5831),
    [anon_sym_xor_eq] = ACTIONS(5831),
    [anon_sym_LT_EQ_GT] = ACTIONS(5833),
    [anon_sym_or] = ACTIONS(5831),
    [anon_sym_and] = ACTIONS(5831),
    [anon_sym_bitor] = ACTIONS(5831),
    [anon_sym_xor] = ACTIONS(5831),
    [anon_sym_bitand] = ACTIONS(5831),
    [anon_sym_not_eq] = ACTIONS(5831),
    [anon_sym_DASH_DASH] = ACTIONS(5833),
    [anon_sym_PLUS_PLUS] = ACTIONS(5833),
    [anon_sym_DOT] = ACTIONS(5831),
    [anon_sym_DOT_STAR] = ACTIONS(5833),
    [anon_sym_DASH_GT] = ACTIONS(5833),
    [sym_comment] = ACTIONS(3),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5833),
  },
  [2310] = {
    [sym_attribute_specifier] = STATE(2203),
    [sym_field_declaration_list] = STATE(2475),
    [sym_virtual_specifier] = STATE(7228),
    [sym_base_class_clause] = STATE(8034),
    [sym_identifier] = ACTIONS(5508),
    [anon_sym_LPAREN2] = ACTIONS(5506),
    [anon_sym_TILDE] = ACTIONS(5506),
    [anon_sym_STAR] = ACTIONS(5506),
    [anon_sym_AMP_AMP] = ACTIONS(5506),
    [anon_sym_AMP] = ACTIONS(5508),
    [anon_sym_SEMI] = ACTIONS(5841),
    [anon_sym___extension__] = ACTIONS(5508),
    [anon_sym___device__] = ACTIONS(5508),
    [anon_sym___host__] = ACTIONS(5508),
    [anon_sym___global__] = ACTIONS(5508),
    [anon_sym___forceinline__] = ACTIONS(5508),
    [anon_sym___noinline__] = ACTIONS(5508),
    [anon_sym_extern] = ACTIONS(5508),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5506),
    [anon_sym___declspec] = ACTIONS(5508),
    [anon_sym___based] = ACTIONS(5508),
    [anon_sym___cdecl] = ACTIONS(5508),
    [anon_sym___clrcall] = ACTIONS(5508),
    [anon_sym___stdcall] = ACTIONS(5508),
    [anon_sym___fastcall] = ACTIONS(5508),
    [anon_sym___thiscall] = ACTIONS(5508),
    [anon_sym___vectorcall] = ACTIONS(5508),
    [anon_sym_LBRACE] = ACTIONS(5580),
    [anon_sym_LBRACK] = ACTIONS(5508),
    [anon_sym_static] = ACTIONS(5508),
    [anon_sym_register] = ACTIONS(5508),
    [anon_sym_inline] = ACTIONS(5508),
    [anon_sym___inline] = ACTIONS(5508),
    [anon_sym___inline__] = ACTIONS(5508),
    [anon_sym___forceinline] = ACTIONS(5508),
    [anon_sym_thread_local] = ACTIONS(5508),
    [anon_sym___thread] = ACTIONS(5508),
    [anon_sym_const] = ACTIONS(5508),
    [anon_sym_constexpr] = ACTIONS(5508),
    [anon_sym_volatile] = ACTIONS(5508),
    [anon_sym_restrict] = ACTIONS(5508),
    [anon_sym___restrict__] = ACTIONS(5508),
    [anon_sym__Atomic] = ACTIONS(5508),
    [anon_sym__Noreturn] = ACTIONS(5508),
    [anon_sym_noreturn] = ACTIONS(5508),
    [anon_sym_mutable] = ACTIONS(5508),
    [anon_sym_constinit] = ACTIONS(5508),
    [anon_sym_consteval] = ACTIONS(5508),
    [anon_sym___shared__] = ACTIONS(5508),
    [anon_sym___local__] = ACTIONS(5508),
    [anon_sym___constant__] = ACTIONS(5508),
    [anon_sym___managed__] = ACTIONS(5508),
    [anon_sym___grid_constant__] = ACTIONS(5508),
    [anon_sym_alignas] = ACTIONS(5508),
    [anon_sym__Alignas] = ACTIONS(5508),
    [anon_sym_COLON] = ACTIONS(5582),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5508),
    [anon_sym_decltype] = ACTIONS(5508),
    [anon_sym_final] = ACTIONS(5550),
    [anon_sym_override] = ACTIONS(5550),
    [sym_virtual] = ACTIONS(5508),
    [anon_sym_template] = ACTIONS(5508),
    [anon_sym_operator] = ACTIONS(5508),
    [anon_sym___launch_bounds__] = ACTIONS(5508),
  },
  [2311] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5472),
    [anon_sym_COMMA] = ACTIONS(5472),
    [anon_sym_RPAREN] = ACTIONS(5472),
    [anon_sym_LPAREN2] = ACTIONS(5472),
    [anon_sym_DASH] = ACTIONS(5470),
    [anon_sym_PLUS] = ACTIONS(5470),
    [anon_sym_STAR] = ACTIONS(5470),
    [anon_sym_SLASH] = ACTIONS(5470),
    [anon_sym_PERCENT] = ACTIONS(5470),
    [anon_sym_PIPE_PIPE] = ACTIONS(5472),
    [anon_sym_AMP_AMP] = ACTIONS(5472),
    [anon_sym_PIPE] = ACTIONS(5470),
    [anon_sym_CARET] = ACTIONS(5470),
    [anon_sym_AMP] = ACTIONS(5470),
    [anon_sym_EQ_EQ] = ACTIONS(5472),
    [anon_sym_BANG_EQ] = ACTIONS(5472),
    [anon_sym_GT] = ACTIONS(5470),
    [anon_sym_GT_EQ] = ACTIONS(5472),
    [anon_sym_LT_EQ] = ACTIONS(5470),
    [anon_sym_LT] = ACTIONS(5470),
    [anon_sym_LT_LT] = ACTIONS(5470),
    [anon_sym_GT_GT] = ACTIONS(5470),
    [anon_sym_SEMI] = ACTIONS(5472),
    [anon_sym_RBRACE] = ACTIONS(5472),
    [anon_sym_LBRACK] = ACTIONS(5472),
    [anon_sym_RBRACK] = ACTIONS(5472),
    [anon_sym_EQ] = ACTIONS(5470),
    [anon_sym_COLON] = ACTIONS(5472),
    [anon_sym_QMARK] = ACTIONS(5472),
    [anon_sym_STAR_EQ] = ACTIONS(5472),
    [anon_sym_SLASH_EQ] = ACTIONS(5472),
    [anon_sym_PERCENT_EQ] = ACTIONS(5472),
    [anon_sym_PLUS_EQ] = ACTIONS(5472),
    [anon_sym_DASH_EQ] = ACTIONS(5472),
    [anon_sym_LT_LT_EQ] = ACTIONS(5472),
    [anon_sym_GT_GT_EQ] = ACTIONS(5472),
    [anon_sym_AMP_EQ] = ACTIONS(5472),
    [anon_sym_CARET_EQ] = ACTIONS(5472),
    [anon_sym_PIPE_EQ] = ACTIONS(5472),
    [anon_sym_and_eq] = ACTIONS(5470),
    [anon_sym_or_eq] = ACTIONS(5470),
    [anon_sym_xor_eq] = ACTIONS(5470),
    [anon_sym_LT_EQ_GT] = ACTIONS(5472),
    [anon_sym_or] = ACTIONS(5470),
    [anon_sym_and] = ACTIONS(5470),
    [anon_sym_bitor] = ACTIONS(5470),
    [anon_sym_xor] = ACTIONS(5470),
    [anon_sym_bitand] = ACTIONS(5470),
    [anon_sym_not_eq] = ACTIONS(5470),
    [anon_sym_DASH_DASH] = ACTIONS(5472),
    [anon_sym_PLUS_PLUS] = ACTIONS(5472),
    [anon_sym_DOT] = ACTIONS(5470),
    [anon_sym_DOT_STAR] = ACTIONS(5472),
    [anon_sym_DASH_GT] = ACTIONS(5472),
    [anon_sym_L_DQUOTE] = ACTIONS(5472),
    [anon_sym_u_DQUOTE] = ACTIONS(5472),
    [anon_sym_U_DQUOTE] = ACTIONS(5472),
    [anon_sym_u8_DQUOTE] = ACTIONS(5472),
    [anon_sym_DQUOTE] = ACTIONS(5472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5472),
    [anon_sym_LR_DQUOTE] = ACTIONS(5472),
    [anon_sym_uR_DQUOTE] = ACTIONS(5472),
    [anon_sym_UR_DQUOTE] = ACTIONS(5472),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5472),
    [sym_literal_suffix] = ACTIONS(5470),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5472),
  },
  [2312] = {
    [sym_attribute_declaration] = STATE(2388),
    [sym_parameter_list] = STATE(2456),
    [aux_sym_attributed_declarator_repeat1] = STATE(2388),
    [sym_identifier] = ACTIONS(5843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5845),
    [anon_sym_COMMA] = ACTIONS(5845),
    [anon_sym_RPAREN] = ACTIONS(5845),
    [aux_sym_preproc_if_token2] = ACTIONS(5845),
    [aux_sym_preproc_else_token1] = ACTIONS(5845),
    [aux_sym_preproc_elif_token1] = ACTIONS(5843),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5845),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5845),
    [anon_sym_LPAREN2] = ACTIONS(5835),
    [anon_sym_DASH] = ACTIONS(5843),
    [anon_sym_PLUS] = ACTIONS(5843),
    [anon_sym_STAR] = ACTIONS(5843),
    [anon_sym_SLASH] = ACTIONS(5843),
    [anon_sym_PERCENT] = ACTIONS(5843),
    [anon_sym_PIPE_PIPE] = ACTIONS(5845),
    [anon_sym_AMP_AMP] = ACTIONS(5845),
    [anon_sym_PIPE] = ACTIONS(5843),
    [anon_sym_CARET] = ACTIONS(5843),
    [anon_sym_AMP] = ACTIONS(5843),
    [anon_sym_EQ_EQ] = ACTIONS(5845),
    [anon_sym_BANG_EQ] = ACTIONS(5845),
    [anon_sym_GT] = ACTIONS(5843),
    [anon_sym_GT_EQ] = ACTIONS(5845),
    [anon_sym_LT_EQ] = ACTIONS(5843),
    [anon_sym_LT] = ACTIONS(5843),
    [anon_sym_LT_LT] = ACTIONS(5843),
    [anon_sym_GT_GT] = ACTIONS(5843),
    [anon_sym_SEMI] = ACTIONS(5845),
    [anon_sym___attribute__] = ACTIONS(5843),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5837),
    [anon_sym_RBRACE] = ACTIONS(5845),
    [anon_sym_LBRACK] = ACTIONS(5839),
    [anon_sym_RBRACK] = ACTIONS(5845),
    [anon_sym_EQ] = ACTIONS(5843),
    [anon_sym_COLON] = ACTIONS(5845),
    [anon_sym_QMARK] = ACTIONS(5845),
    [anon_sym_STAR_EQ] = ACTIONS(5845),
    [anon_sym_SLASH_EQ] = ACTIONS(5845),
    [anon_sym_PERCENT_EQ] = ACTIONS(5845),
    [anon_sym_PLUS_EQ] = ACTIONS(5845),
    [anon_sym_DASH_EQ] = ACTIONS(5845),
    [anon_sym_LT_LT_EQ] = ACTIONS(5845),
    [anon_sym_GT_GT_EQ] = ACTIONS(5845),
    [anon_sym_AMP_EQ] = ACTIONS(5845),
    [anon_sym_CARET_EQ] = ACTIONS(5845),
    [anon_sym_PIPE_EQ] = ACTIONS(5845),
    [anon_sym_and_eq] = ACTIONS(5843),
    [anon_sym_or_eq] = ACTIONS(5843),
    [anon_sym_xor_eq] = ACTIONS(5843),
    [anon_sym_LT_EQ_GT] = ACTIONS(5845),
    [anon_sym_or] = ACTIONS(5843),
    [anon_sym_and] = ACTIONS(5843),
    [anon_sym_bitor] = ACTIONS(5843),
    [anon_sym_xor] = ACTIONS(5843),
    [anon_sym_bitand] = ACTIONS(5843),
    [anon_sym_not_eq] = ACTIONS(5843),
    [anon_sym_DASH_DASH] = ACTIONS(5845),
    [anon_sym_PLUS_PLUS] = ACTIONS(5845),
    [anon_sym_DOT] = ACTIONS(5843),
    [anon_sym_DOT_STAR] = ACTIONS(5845),
    [anon_sym_DASH_GT] = ACTIONS(5845),
    [sym_comment] = ACTIONS(3),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5845),
  },
  [2313] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4149),
    [anon_sym_COMMA] = ACTIONS(4149),
    [anon_sym_LPAREN2] = ACTIONS(4149),
    [anon_sym_DASH] = ACTIONS(4142),
    [anon_sym_PLUS] = ACTIONS(4142),
    [anon_sym_STAR] = ACTIONS(4149),
    [anon_sym_SLASH] = ACTIONS(4142),
    [anon_sym_PERCENT] = ACTIONS(4149),
    [anon_sym_PIPE_PIPE] = ACTIONS(4149),
    [anon_sym_AMP_AMP] = ACTIONS(4149),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_CARET] = ACTIONS(4149),
    [anon_sym_AMP] = ACTIONS(4142),
    [anon_sym_EQ_EQ] = ACTIONS(4149),
    [anon_sym_BANG_EQ] = ACTIONS(4149),
    [anon_sym_GT] = ACTIONS(4142),
    [anon_sym_GT_EQ] = ACTIONS(4142),
    [anon_sym_LT_EQ] = ACTIONS(4142),
    [anon_sym_LT] = ACTIONS(4142),
    [anon_sym_LT_LT] = ACTIONS(4142),
    [anon_sym_GT_GT] = ACTIONS(4142),
    [anon_sym___extension__] = ACTIONS(4149),
    [anon_sym___global__] = ACTIONS(4149),
    [anon_sym___attribute__] = ACTIONS(4149),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_LBRACE] = ACTIONS(4149),
    [anon_sym_LBRACK] = ACTIONS(4149),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_constexpr] = ACTIONS(4149),
    [anon_sym_volatile] = ACTIONS(4149),
    [anon_sym_restrict] = ACTIONS(4149),
    [anon_sym___restrict__] = ACTIONS(4149),
    [anon_sym__Atomic] = ACTIONS(4149),
    [anon_sym__Noreturn] = ACTIONS(4149),
    [anon_sym_noreturn] = ACTIONS(4149),
    [anon_sym_mutable] = ACTIONS(4149),
    [anon_sym_constinit] = ACTIONS(4149),
    [anon_sym_consteval] = ACTIONS(4149),
    [anon_sym___shared__] = ACTIONS(4149),
    [anon_sym___local__] = ACTIONS(4149),
    [anon_sym___constant__] = ACTIONS(4149),
    [anon_sym___managed__] = ACTIONS(4149),
    [anon_sym___grid_constant__] = ACTIONS(4149),
    [anon_sym_alignas] = ACTIONS(4149),
    [anon_sym__Alignas] = ACTIONS(4149),
    [anon_sym_COLON] = ACTIONS(4142),
    [anon_sym_QMARK] = ACTIONS(4149),
    [anon_sym_LT_EQ_GT] = ACTIONS(4149),
    [anon_sym_or] = ACTIONS(4149),
    [anon_sym_and] = ACTIONS(4149),
    [anon_sym_bitor] = ACTIONS(4149),
    [anon_sym_xor] = ACTIONS(4149),
    [anon_sym_bitand] = ACTIONS(4149),
    [anon_sym_not_eq] = ACTIONS(4149),
    [anon_sym_DASH_DASH] = ACTIONS(4149),
    [anon_sym_PLUS_PLUS] = ACTIONS(4149),
    [anon_sym_DOT] = ACTIONS(4142),
    [anon_sym_DOT_STAR] = ACTIONS(4149),
    [anon_sym_DASH_GT] = ACTIONS(4149),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4149),
    [anon_sym_decltype] = ACTIONS(4149),
    [anon_sym_final] = ACTIONS(4149),
    [anon_sym_override] = ACTIONS(4149),
    [anon_sym_GT2] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4149),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4149),
  },
  [2314] = {
    [sym_attribute_specifier] = STATE(2203),
    [sym_field_declaration_list] = STATE(2475),
    [sym_virtual_specifier] = STATE(7228),
    [sym_base_class_clause] = STATE(8034),
    [sym_identifier] = ACTIONS(5508),
    [anon_sym_LPAREN2] = ACTIONS(5506),
    [anon_sym_TILDE] = ACTIONS(5506),
    [anon_sym_STAR] = ACTIONS(5506),
    [anon_sym_AMP_AMP] = ACTIONS(5506),
    [anon_sym_AMP] = ACTIONS(5508),
    [anon_sym_SEMI] = ACTIONS(5847),
    [anon_sym___extension__] = ACTIONS(5508),
    [anon_sym___device__] = ACTIONS(5508),
    [anon_sym___host__] = ACTIONS(5508),
    [anon_sym___global__] = ACTIONS(5508),
    [anon_sym___forceinline__] = ACTIONS(5508),
    [anon_sym___noinline__] = ACTIONS(5508),
    [anon_sym_extern] = ACTIONS(5508),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5506),
    [anon_sym___declspec] = ACTIONS(5508),
    [anon_sym___based] = ACTIONS(5508),
    [anon_sym___cdecl] = ACTIONS(5508),
    [anon_sym___clrcall] = ACTIONS(5508),
    [anon_sym___stdcall] = ACTIONS(5508),
    [anon_sym___fastcall] = ACTIONS(5508),
    [anon_sym___thiscall] = ACTIONS(5508),
    [anon_sym___vectorcall] = ACTIONS(5508),
    [anon_sym_LBRACE] = ACTIONS(5580),
    [anon_sym_LBRACK] = ACTIONS(5508),
    [anon_sym_static] = ACTIONS(5508),
    [anon_sym_register] = ACTIONS(5508),
    [anon_sym_inline] = ACTIONS(5508),
    [anon_sym___inline] = ACTIONS(5508),
    [anon_sym___inline__] = ACTIONS(5508),
    [anon_sym___forceinline] = ACTIONS(5508),
    [anon_sym_thread_local] = ACTIONS(5508),
    [anon_sym___thread] = ACTIONS(5508),
    [anon_sym_const] = ACTIONS(5508),
    [anon_sym_constexpr] = ACTIONS(5508),
    [anon_sym_volatile] = ACTIONS(5508),
    [anon_sym_restrict] = ACTIONS(5508),
    [anon_sym___restrict__] = ACTIONS(5508),
    [anon_sym__Atomic] = ACTIONS(5508),
    [anon_sym__Noreturn] = ACTIONS(5508),
    [anon_sym_noreturn] = ACTIONS(5508),
    [anon_sym_mutable] = ACTIONS(5508),
    [anon_sym_constinit] = ACTIONS(5508),
    [anon_sym_consteval] = ACTIONS(5508),
    [anon_sym___shared__] = ACTIONS(5508),
    [anon_sym___local__] = ACTIONS(5508),
    [anon_sym___constant__] = ACTIONS(5508),
    [anon_sym___managed__] = ACTIONS(5508),
    [anon_sym___grid_constant__] = ACTIONS(5508),
    [anon_sym_alignas] = ACTIONS(5508),
    [anon_sym__Alignas] = ACTIONS(5508),
    [anon_sym_COLON] = ACTIONS(5582),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5508),
    [anon_sym_decltype] = ACTIONS(5508),
    [anon_sym_final] = ACTIONS(5550),
    [anon_sym_override] = ACTIONS(5550),
    [sym_virtual] = ACTIONS(5508),
    [anon_sym_template] = ACTIONS(5508),
    [anon_sym_operator] = ACTIONS(5508),
    [anon_sym___launch_bounds__] = ACTIONS(5508),
  },
  [2315] = {
    [sym_attribute_specifier] = STATE(2203),
    [sym_field_declaration_list] = STATE(2475),
    [sym_virtual_specifier] = STATE(7228),
    [sym_base_class_clause] = STATE(8034),
    [sym_identifier] = ACTIONS(5508),
    [anon_sym_LPAREN2] = ACTIONS(5506),
    [anon_sym_TILDE] = ACTIONS(5506),
    [anon_sym_STAR] = ACTIONS(5506),
    [anon_sym_AMP_AMP] = ACTIONS(5506),
    [anon_sym_AMP] = ACTIONS(5508),
    [anon_sym_SEMI] = ACTIONS(5849),
    [anon_sym___extension__] = ACTIONS(5508),
    [anon_sym___device__] = ACTIONS(5508),
    [anon_sym___host__] = ACTIONS(5508),
    [anon_sym___global__] = ACTIONS(5508),
    [anon_sym___forceinline__] = ACTIONS(5508),
    [anon_sym___noinline__] = ACTIONS(5508),
    [anon_sym_extern] = ACTIONS(5508),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5506),
    [anon_sym___declspec] = ACTIONS(5508),
    [anon_sym___based] = ACTIONS(5508),
    [anon_sym___cdecl] = ACTIONS(5508),
    [anon_sym___clrcall] = ACTIONS(5508),
    [anon_sym___stdcall] = ACTIONS(5508),
    [anon_sym___fastcall] = ACTIONS(5508),
    [anon_sym___thiscall] = ACTIONS(5508),
    [anon_sym___vectorcall] = ACTIONS(5508),
    [anon_sym_LBRACE] = ACTIONS(5580),
    [anon_sym_LBRACK] = ACTIONS(5508),
    [anon_sym_static] = ACTIONS(5508),
    [anon_sym_register] = ACTIONS(5508),
    [anon_sym_inline] = ACTIONS(5508),
    [anon_sym___inline] = ACTIONS(5508),
    [anon_sym___inline__] = ACTIONS(5508),
    [anon_sym___forceinline] = ACTIONS(5508),
    [anon_sym_thread_local] = ACTIONS(5508),
    [anon_sym___thread] = ACTIONS(5508),
    [anon_sym_const] = ACTIONS(5508),
    [anon_sym_constexpr] = ACTIONS(5508),
    [anon_sym_volatile] = ACTIONS(5508),
    [anon_sym_restrict] = ACTIONS(5508),
    [anon_sym___restrict__] = ACTIONS(5508),
    [anon_sym__Atomic] = ACTIONS(5508),
    [anon_sym__Noreturn] = ACTIONS(5508),
    [anon_sym_noreturn] = ACTIONS(5508),
    [anon_sym_mutable] = ACTIONS(5508),
    [anon_sym_constinit] = ACTIONS(5508),
    [anon_sym_consteval] = ACTIONS(5508),
    [anon_sym___shared__] = ACTIONS(5508),
    [anon_sym___local__] = ACTIONS(5508),
    [anon_sym___constant__] = ACTIONS(5508),
    [anon_sym___managed__] = ACTIONS(5508),
    [anon_sym___grid_constant__] = ACTIONS(5508),
    [anon_sym_alignas] = ACTIONS(5508),
    [anon_sym__Alignas] = ACTIONS(5508),
    [anon_sym_COLON] = ACTIONS(5582),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5508),
    [anon_sym_decltype] = ACTIONS(5508),
    [anon_sym_final] = ACTIONS(5550),
    [anon_sym_override] = ACTIONS(5550),
    [sym_virtual] = ACTIONS(5508),
    [anon_sym_template] = ACTIONS(5508),
    [anon_sym_operator] = ACTIONS(5508),
    [anon_sym___launch_bounds__] = ACTIONS(5508),
  },
  [2316] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4019),
    [anon_sym_COMMA] = ACTIONS(4019),
    [anon_sym_LPAREN2] = ACTIONS(4019),
    [anon_sym_DASH] = ACTIONS(4017),
    [anon_sym_PLUS] = ACTIONS(4017),
    [anon_sym_STAR] = ACTIONS(4019),
    [anon_sym_SLASH] = ACTIONS(4017),
    [anon_sym_PERCENT] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE] = ACTIONS(4017),
    [anon_sym_CARET] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4017),
    [anon_sym_EQ_EQ] = ACTIONS(4019),
    [anon_sym_BANG_EQ] = ACTIONS(4019),
    [anon_sym_GT] = ACTIONS(4017),
    [anon_sym_GT_EQ] = ACTIONS(4017),
    [anon_sym_LT_EQ] = ACTIONS(4017),
    [anon_sym_LT] = ACTIONS(4017),
    [anon_sym_LT_LT] = ACTIONS(4017),
    [anon_sym_GT_GT] = ACTIONS(4017),
    [anon_sym___extension__] = ACTIONS(4019),
    [anon_sym___global__] = ACTIONS(4019),
    [anon_sym___attribute__] = ACTIONS(4019),
    [anon_sym_COLON_COLON] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4019),
    [anon_sym_LBRACK] = ACTIONS(4019),
    [anon_sym_const] = ACTIONS(4017),
    [anon_sym_constexpr] = ACTIONS(4019),
    [anon_sym_volatile] = ACTIONS(4019),
    [anon_sym_restrict] = ACTIONS(4019),
    [anon_sym___restrict__] = ACTIONS(4019),
    [anon_sym__Atomic] = ACTIONS(4019),
    [anon_sym__Noreturn] = ACTIONS(4019),
    [anon_sym_noreturn] = ACTIONS(4019),
    [anon_sym_mutable] = ACTIONS(4019),
    [anon_sym_constinit] = ACTIONS(4019),
    [anon_sym_consteval] = ACTIONS(4019),
    [anon_sym___shared__] = ACTIONS(4019),
    [anon_sym___local__] = ACTIONS(4019),
    [anon_sym___constant__] = ACTIONS(4019),
    [anon_sym___managed__] = ACTIONS(4019),
    [anon_sym___grid_constant__] = ACTIONS(4019),
    [anon_sym_alignas] = ACTIONS(4019),
    [anon_sym__Alignas] = ACTIONS(4019),
    [anon_sym_COLON] = ACTIONS(4017),
    [anon_sym_QMARK] = ACTIONS(4019),
    [anon_sym_LT_EQ_GT] = ACTIONS(4019),
    [anon_sym_or] = ACTIONS(4019),
    [anon_sym_and] = ACTIONS(4019),
    [anon_sym_bitor] = ACTIONS(4019),
    [anon_sym_xor] = ACTIONS(4019),
    [anon_sym_bitand] = ACTIONS(4019),
    [anon_sym_not_eq] = ACTIONS(4019),
    [anon_sym_DASH_DASH] = ACTIONS(4019),
    [anon_sym_PLUS_PLUS] = ACTIONS(4019),
    [anon_sym_DOT] = ACTIONS(4017),
    [anon_sym_DOT_STAR] = ACTIONS(4019),
    [anon_sym_DASH_GT] = ACTIONS(4019),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4019),
    [anon_sym_decltype] = ACTIONS(4019),
    [anon_sym_final] = ACTIONS(4019),
    [anon_sym_override] = ACTIONS(4019),
    [anon_sym_GT2] = ACTIONS(4019),
    [anon_sym_requires] = ACTIONS(4019),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4019),
  },
  [2317] = {
    [sym_attribute_specifier] = STATE(2452),
    [sym_identifier] = ACTIONS(5684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5682),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_RPAREN] = ACTIONS(5682),
    [aux_sym_preproc_if_token2] = ACTIONS(5682),
    [aux_sym_preproc_else_token1] = ACTIONS(5682),
    [aux_sym_preproc_elif_token1] = ACTIONS(5684),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5682),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5682),
    [anon_sym_LPAREN2] = ACTIONS(5682),
    [anon_sym_DASH] = ACTIONS(5684),
    [anon_sym_PLUS] = ACTIONS(5684),
    [anon_sym_STAR] = ACTIONS(5684),
    [anon_sym_SLASH] = ACTIONS(5684),
    [anon_sym_PERCENT] = ACTIONS(5684),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_CARET] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_EQ_EQ] = ACTIONS(5682),
    [anon_sym_BANG_EQ] = ACTIONS(5682),
    [anon_sym_GT] = ACTIONS(5684),
    [anon_sym_GT_EQ] = ACTIONS(5682),
    [anon_sym_LT_EQ] = ACTIONS(5684),
    [anon_sym_LT] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(5684),
    [anon_sym_GT_GT] = ACTIONS(5684),
    [anon_sym_SEMI] = ACTIONS(5682),
    [anon_sym___attribute__] = ACTIONS(5546),
    [anon_sym_LBRACE] = ACTIONS(5682),
    [anon_sym_RBRACE] = ACTIONS(5682),
    [anon_sym_LBRACK] = ACTIONS(5682),
    [anon_sym_RBRACK] = ACTIONS(5682),
    [anon_sym_EQ] = ACTIONS(5684),
    [anon_sym_COLON] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5682),
    [anon_sym_STAR_EQ] = ACTIONS(5682),
    [anon_sym_SLASH_EQ] = ACTIONS(5682),
    [anon_sym_PERCENT_EQ] = ACTIONS(5682),
    [anon_sym_PLUS_EQ] = ACTIONS(5682),
    [anon_sym_DASH_EQ] = ACTIONS(5682),
    [anon_sym_LT_LT_EQ] = ACTIONS(5682),
    [anon_sym_GT_GT_EQ] = ACTIONS(5682),
    [anon_sym_AMP_EQ] = ACTIONS(5682),
    [anon_sym_CARET_EQ] = ACTIONS(5682),
    [anon_sym_PIPE_EQ] = ACTIONS(5682),
    [anon_sym_and_eq] = ACTIONS(5684),
    [anon_sym_or_eq] = ACTIONS(5684),
    [anon_sym_xor_eq] = ACTIONS(5684),
    [anon_sym_LT_EQ_GT] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5684),
    [anon_sym_and] = ACTIONS(5684),
    [anon_sym_bitor] = ACTIONS(5684),
    [anon_sym_xor] = ACTIONS(5684),
    [anon_sym_bitand] = ACTIONS(5684),
    [anon_sym_not_eq] = ACTIONS(5684),
    [anon_sym_DASH_DASH] = ACTIONS(5682),
    [anon_sym_PLUS_PLUS] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(5684),
    [anon_sym_DOT_STAR] = ACTIONS(5682),
    [anon_sym_DASH_GT] = ACTIONS(5682),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5684),
    [anon_sym_decltype] = ACTIONS(5684),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5682),
  },
  [2318] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_LPAREN2] = ACTIONS(4023),
    [anon_sym_DASH] = ACTIONS(4021),
    [anon_sym_PLUS] = ACTIONS(4021),
    [anon_sym_STAR] = ACTIONS(4023),
    [anon_sym_SLASH] = ACTIONS(4021),
    [anon_sym_PERCENT] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4023),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_CARET] = ACTIONS(4023),
    [anon_sym_AMP] = ACTIONS(4021),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_GT_EQ] = ACTIONS(4021),
    [anon_sym_LT_EQ] = ACTIONS(4021),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_LT_LT] = ACTIONS(4021),
    [anon_sym_GT_GT] = ACTIONS(4021),
    [anon_sym___extension__] = ACTIONS(4023),
    [anon_sym___global__] = ACTIONS(4023),
    [anon_sym___attribute__] = ACTIONS(4023),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_LBRACE] = ACTIONS(4023),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_const] = ACTIONS(4021),
    [anon_sym_constexpr] = ACTIONS(4023),
    [anon_sym_volatile] = ACTIONS(4023),
    [anon_sym_restrict] = ACTIONS(4023),
    [anon_sym___restrict__] = ACTIONS(4023),
    [anon_sym__Atomic] = ACTIONS(4023),
    [anon_sym__Noreturn] = ACTIONS(4023),
    [anon_sym_noreturn] = ACTIONS(4023),
    [anon_sym_mutable] = ACTIONS(4023),
    [anon_sym_constinit] = ACTIONS(4023),
    [anon_sym_consteval] = ACTIONS(4023),
    [anon_sym___shared__] = ACTIONS(4023),
    [anon_sym___local__] = ACTIONS(4023),
    [anon_sym___constant__] = ACTIONS(4023),
    [anon_sym___managed__] = ACTIONS(4023),
    [anon_sym___grid_constant__] = ACTIONS(4023),
    [anon_sym_alignas] = ACTIONS(4023),
    [anon_sym__Alignas] = ACTIONS(4023),
    [anon_sym_COLON] = ACTIONS(4021),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_LT_EQ_GT] = ACTIONS(4023),
    [anon_sym_or] = ACTIONS(4023),
    [anon_sym_and] = ACTIONS(4023),
    [anon_sym_bitor] = ACTIONS(4023),
    [anon_sym_xor] = ACTIONS(4023),
    [anon_sym_bitand] = ACTIONS(4023),
    [anon_sym_not_eq] = ACTIONS(4023),
    [anon_sym_DASH_DASH] = ACTIONS(4023),
    [anon_sym_PLUS_PLUS] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4021),
    [anon_sym_DOT_STAR] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4023),
    [anon_sym_decltype] = ACTIONS(4023),
    [anon_sym_final] = ACTIONS(4023),
    [anon_sym_override] = ACTIONS(4023),
    [anon_sym_GT2] = ACTIONS(4023),
    [anon_sym_requires] = ACTIONS(4023),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4023),
  },
  [2319] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3994),
    [anon_sym_COMMA] = ACTIONS(3994),
    [anon_sym_LPAREN2] = ACTIONS(3994),
    [anon_sym_DASH] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3992),
    [anon_sym_STAR] = ACTIONS(3994),
    [anon_sym_SLASH] = ACTIONS(3992),
    [anon_sym_PERCENT] = ACTIONS(3994),
    [anon_sym_PIPE_PIPE] = ACTIONS(3994),
    [anon_sym_AMP_AMP] = ACTIONS(3994),
    [anon_sym_PIPE] = ACTIONS(3992),
    [anon_sym_CARET] = ACTIONS(3994),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym_EQ_EQ] = ACTIONS(3994),
    [anon_sym_BANG_EQ] = ACTIONS(3994),
    [anon_sym_GT] = ACTIONS(3992),
    [anon_sym_GT_EQ] = ACTIONS(3992),
    [anon_sym_LT_EQ] = ACTIONS(3992),
    [anon_sym_LT] = ACTIONS(3992),
    [anon_sym_LT_LT] = ACTIONS(3992),
    [anon_sym_GT_GT] = ACTIONS(3992),
    [anon_sym___extension__] = ACTIONS(3994),
    [anon_sym___global__] = ACTIONS(3994),
    [anon_sym___attribute__] = ACTIONS(3994),
    [anon_sym_COLON_COLON] = ACTIONS(3994),
    [anon_sym_LBRACE] = ACTIONS(3994),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_const] = ACTIONS(3992),
    [anon_sym_constexpr] = ACTIONS(3994),
    [anon_sym_volatile] = ACTIONS(3994),
    [anon_sym_restrict] = ACTIONS(3994),
    [anon_sym___restrict__] = ACTIONS(3994),
    [anon_sym__Atomic] = ACTIONS(3994),
    [anon_sym__Noreturn] = ACTIONS(3994),
    [anon_sym_noreturn] = ACTIONS(3994),
    [anon_sym_mutable] = ACTIONS(3994),
    [anon_sym_constinit] = ACTIONS(3994),
    [anon_sym_consteval] = ACTIONS(3994),
    [anon_sym___shared__] = ACTIONS(3994),
    [anon_sym___local__] = ACTIONS(3994),
    [anon_sym___constant__] = ACTIONS(3994),
    [anon_sym___managed__] = ACTIONS(3994),
    [anon_sym___grid_constant__] = ACTIONS(3994),
    [anon_sym_alignas] = ACTIONS(3994),
    [anon_sym__Alignas] = ACTIONS(3994),
    [anon_sym_COLON] = ACTIONS(3992),
    [anon_sym_QMARK] = ACTIONS(3994),
    [anon_sym_LT_EQ_GT] = ACTIONS(3994),
    [anon_sym_or] = ACTIONS(3994),
    [anon_sym_and] = ACTIONS(3994),
    [anon_sym_bitor] = ACTIONS(3994),
    [anon_sym_xor] = ACTIONS(3994),
    [anon_sym_bitand] = ACTIONS(3994),
    [anon_sym_not_eq] = ACTIONS(3994),
    [anon_sym_DASH_DASH] = ACTIONS(3994),
    [anon_sym_PLUS_PLUS] = ACTIONS(3994),
    [anon_sym_DOT] = ACTIONS(3992),
    [anon_sym_DOT_STAR] = ACTIONS(3994),
    [anon_sym_DASH_GT] = ACTIONS(3994),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3994),
    [anon_sym_decltype] = ACTIONS(3994),
    [anon_sym_final] = ACTIONS(3994),
    [anon_sym_override] = ACTIONS(3994),
    [anon_sym_GT2] = ACTIONS(3994),
    [anon_sym_requires] = ACTIONS(3994),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3994),
  },
  [2320] = {
    [sym_string_literal] = STATE(2320),
    [sym_raw_string_literal] = STATE(2320),
    [aux_sym_concatenated_string_repeat1] = STATE(2320),
    [sym_identifier] = ACTIONS(5851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5267),
    [anon_sym_COMMA] = ACTIONS(5267),
    [anon_sym_LPAREN2] = ACTIONS(5267),
    [anon_sym_DASH] = ACTIONS(5269),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_STAR] = ACTIONS(5269),
    [anon_sym_SLASH] = ACTIONS(5269),
    [anon_sym_PERCENT] = ACTIONS(5269),
    [anon_sym_PIPE_PIPE] = ACTIONS(5267),
    [anon_sym_AMP_AMP] = ACTIONS(5267),
    [anon_sym_PIPE] = ACTIONS(5269),
    [anon_sym_CARET] = ACTIONS(5269),
    [anon_sym_AMP] = ACTIONS(5269),
    [anon_sym_EQ_EQ] = ACTIONS(5267),
    [anon_sym_BANG_EQ] = ACTIONS(5267),
    [anon_sym_GT] = ACTIONS(5269),
    [anon_sym_GT_EQ] = ACTIONS(5269),
    [anon_sym_LT_EQ] = ACTIONS(5269),
    [anon_sym_LT] = ACTIONS(5269),
    [anon_sym_LT_LT] = ACTIONS(5269),
    [anon_sym_GT_GT] = ACTIONS(5269),
    [anon_sym_LBRACK] = ACTIONS(5267),
    [anon_sym_EQ] = ACTIONS(5269),
    [anon_sym_QMARK] = ACTIONS(5267),
    [anon_sym_STAR_EQ] = ACTIONS(5267),
    [anon_sym_SLASH_EQ] = ACTIONS(5267),
    [anon_sym_PERCENT_EQ] = ACTIONS(5267),
    [anon_sym_PLUS_EQ] = ACTIONS(5267),
    [anon_sym_DASH_EQ] = ACTIONS(5267),
    [anon_sym_LT_LT_EQ] = ACTIONS(5267),
    [anon_sym_GT_GT_EQ] = ACTIONS(5269),
    [anon_sym_AMP_EQ] = ACTIONS(5267),
    [anon_sym_CARET_EQ] = ACTIONS(5267),
    [anon_sym_PIPE_EQ] = ACTIONS(5267),
    [anon_sym_and_eq] = ACTIONS(5269),
    [anon_sym_or_eq] = ACTIONS(5269),
    [anon_sym_xor_eq] = ACTIONS(5269),
    [anon_sym_LT_EQ_GT] = ACTIONS(5267),
    [anon_sym_or] = ACTIONS(5269),
    [anon_sym_and] = ACTIONS(5269),
    [anon_sym_bitor] = ACTIONS(5269),
    [anon_sym_xor] = ACTIONS(5269),
    [anon_sym_bitand] = ACTIONS(5269),
    [anon_sym_not_eq] = ACTIONS(5269),
    [anon_sym_DASH_DASH] = ACTIONS(5267),
    [anon_sym_PLUS_PLUS] = ACTIONS(5267),
    [anon_sym_DOT] = ACTIONS(5269),
    [anon_sym_DOT_STAR] = ACTIONS(5267),
    [anon_sym_DASH_GT] = ACTIONS(5267),
    [anon_sym_L_DQUOTE] = ACTIONS(5854),
    [anon_sym_u_DQUOTE] = ACTIONS(5854),
    [anon_sym_U_DQUOTE] = ACTIONS(5854),
    [anon_sym_u8_DQUOTE] = ACTIONS(5854),
    [anon_sym_DQUOTE] = ACTIONS(5854),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(5267),
    [anon_sym_R_DQUOTE] = ACTIONS(5857),
    [anon_sym_LR_DQUOTE] = ACTIONS(5857),
    [anon_sym_uR_DQUOTE] = ACTIONS(5857),
    [anon_sym_UR_DQUOTE] = ACTIONS(5857),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5857),
    [sym_literal_suffix] = ACTIONS(5269),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5267),
  },
  [2321] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2152),
    [sym_identifier] = ACTIONS(5261),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5258),
    [anon_sym_COMMA] = ACTIONS(5258),
    [aux_sym_preproc_if_token2] = ACTIONS(5258),
    [aux_sym_preproc_else_token1] = ACTIONS(5258),
    [aux_sym_preproc_elif_token1] = ACTIONS(5261),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5258),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5258),
    [anon_sym_LPAREN2] = ACTIONS(5258),
    [anon_sym_DASH] = ACTIONS(5261),
    [anon_sym_PLUS] = ACTIONS(5261),
    [anon_sym_STAR] = ACTIONS(5261),
    [anon_sym_SLASH] = ACTIONS(5261),
    [anon_sym_PERCENT] = ACTIONS(5261),
    [anon_sym_PIPE_PIPE] = ACTIONS(5258),
    [anon_sym_AMP_AMP] = ACTIONS(5258),
    [anon_sym_PIPE] = ACTIONS(5261),
    [anon_sym_CARET] = ACTIONS(5261),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_EQ_EQ] = ACTIONS(5258),
    [anon_sym_BANG_EQ] = ACTIONS(5258),
    [anon_sym_GT] = ACTIONS(5261),
    [anon_sym_GT_EQ] = ACTIONS(5258),
    [anon_sym_LT_EQ] = ACTIONS(5261),
    [anon_sym_LT] = ACTIONS(5261),
    [anon_sym_LT_LT] = ACTIONS(5261),
    [anon_sym_GT_GT] = ACTIONS(5261),
    [anon_sym___attribute__] = ACTIONS(5261),
    [anon_sym_LBRACE] = ACTIONS(5258),
    [anon_sym_signed] = ACTIONS(5527),
    [anon_sym_unsigned] = ACTIONS(5527),
    [anon_sym_long] = ACTIONS(5527),
    [anon_sym_short] = ACTIONS(5527),
    [anon_sym_LBRACK] = ACTIONS(5258),
    [anon_sym_EQ] = ACTIONS(5261),
    [sym_primitive_type] = ACTIONS(5016),
    [anon_sym_QMARK] = ACTIONS(5258),
    [anon_sym_STAR_EQ] = ACTIONS(5258),
    [anon_sym_SLASH_EQ] = ACTIONS(5258),
    [anon_sym_PERCENT_EQ] = ACTIONS(5258),
    [anon_sym_PLUS_EQ] = ACTIONS(5258),
    [anon_sym_DASH_EQ] = ACTIONS(5258),
    [anon_sym_LT_LT_EQ] = ACTIONS(5258),
    [anon_sym_GT_GT_EQ] = ACTIONS(5258),
    [anon_sym_AMP_EQ] = ACTIONS(5258),
    [anon_sym_CARET_EQ] = ACTIONS(5258),
    [anon_sym_PIPE_EQ] = ACTIONS(5258),
    [anon_sym_and_eq] = ACTIONS(5261),
    [anon_sym_or_eq] = ACTIONS(5261),
    [anon_sym_xor_eq] = ACTIONS(5261),
    [anon_sym_LT_EQ_GT] = ACTIONS(5258),
    [anon_sym_or] = ACTIONS(5261),
    [anon_sym_and] = ACTIONS(5261),
    [anon_sym_bitor] = ACTIONS(5261),
    [anon_sym_xor] = ACTIONS(5261),
    [anon_sym_bitand] = ACTIONS(5261),
    [anon_sym_not_eq] = ACTIONS(5261),
    [anon_sym_DASH_DASH] = ACTIONS(5258),
    [anon_sym_PLUS_PLUS] = ACTIONS(5258),
    [anon_sym_DOT] = ACTIONS(5261),
    [anon_sym_DOT_STAR] = ACTIONS(5258),
    [anon_sym_DASH_GT] = ACTIONS(5258),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5261),
    [anon_sym_decltype] = ACTIONS(5261),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5258),
  },
  [2322] = {
    [sym_identifier] = ACTIONS(5192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5194),
    [anon_sym_COMMA] = ACTIONS(5194),
    [anon_sym_RPAREN] = ACTIONS(5194),
    [aux_sym_preproc_if_token2] = ACTIONS(5194),
    [aux_sym_preproc_else_token1] = ACTIONS(5194),
    [aux_sym_preproc_elif_token1] = ACTIONS(5192),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5194),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5194),
    [anon_sym_LPAREN2] = ACTIONS(5194),
    [anon_sym_DASH] = ACTIONS(5192),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_STAR] = ACTIONS(5192),
    [anon_sym_SLASH] = ACTIONS(5192),
    [anon_sym_PERCENT] = ACTIONS(5192),
    [anon_sym_PIPE_PIPE] = ACTIONS(5194),
    [anon_sym_AMP_AMP] = ACTIONS(5194),
    [anon_sym_PIPE] = ACTIONS(5192),
    [anon_sym_CARET] = ACTIONS(5192),
    [anon_sym_AMP] = ACTIONS(5192),
    [anon_sym_EQ_EQ] = ACTIONS(5194),
    [anon_sym_BANG_EQ] = ACTIONS(5194),
    [anon_sym_GT] = ACTIONS(5192),
    [anon_sym_GT_EQ] = ACTIONS(5194),
    [anon_sym_LT_EQ] = ACTIONS(5192),
    [anon_sym_LT] = ACTIONS(5192),
    [anon_sym_LT_LT] = ACTIONS(5192),
    [anon_sym_GT_GT] = ACTIONS(5192),
    [anon_sym_SEMI] = ACTIONS(5194),
    [anon_sym___attribute__] = ACTIONS(5192),
    [anon_sym_COLON_COLON] = ACTIONS(5183),
    [anon_sym_LBRACE] = ACTIONS(5194),
    [anon_sym_RBRACE] = ACTIONS(5194),
    [anon_sym_LBRACK] = ACTIONS(5194),
    [anon_sym_RBRACK] = ACTIONS(5194),
    [anon_sym_EQ] = ACTIONS(5192),
    [anon_sym_COLON] = ACTIONS(5192),
    [anon_sym_QMARK] = ACTIONS(5194),
    [anon_sym_STAR_EQ] = ACTIONS(5194),
    [anon_sym_SLASH_EQ] = ACTIONS(5194),
    [anon_sym_PERCENT_EQ] = ACTIONS(5194),
    [anon_sym_PLUS_EQ] = ACTIONS(5194),
    [anon_sym_DASH_EQ] = ACTIONS(5194),
    [anon_sym_LT_LT_EQ] = ACTIONS(5194),
    [anon_sym_GT_GT_EQ] = ACTIONS(5194),
    [anon_sym_AMP_EQ] = ACTIONS(5194),
    [anon_sym_CARET_EQ] = ACTIONS(5194),
    [anon_sym_PIPE_EQ] = ACTIONS(5194),
    [anon_sym_and_eq] = ACTIONS(5192),
    [anon_sym_or_eq] = ACTIONS(5192),
    [anon_sym_xor_eq] = ACTIONS(5192),
    [anon_sym_LT_EQ_GT] = ACTIONS(5194),
    [anon_sym_or] = ACTIONS(5192),
    [anon_sym_and] = ACTIONS(5192),
    [anon_sym_bitor] = ACTIONS(5192),
    [anon_sym_xor] = ACTIONS(5192),
    [anon_sym_bitand] = ACTIONS(5192),
    [anon_sym_not_eq] = ACTIONS(5192),
    [anon_sym_DASH_DASH] = ACTIONS(5194),
    [anon_sym_PLUS_PLUS] = ACTIONS(5194),
    [anon_sym_DOT] = ACTIONS(5192),
    [anon_sym_DOT_STAR] = ACTIONS(5194),
    [anon_sym_DASH_GT] = ACTIONS(5194),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5192),
    [anon_sym_decltype] = ACTIONS(5192),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5194),
  },
  [2323] = {
    [sym_string_literal] = STATE(2347),
    [sym_template_argument_list] = STATE(3524),
    [sym_raw_string_literal] = STATE(2347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3758),
    [anon_sym_SLASH_EQ] = ACTIONS(3758),
    [anon_sym_PERCENT_EQ] = ACTIONS(3758),
    [anon_sym_PLUS_EQ] = ACTIONS(3758),
    [anon_sym_DASH_EQ] = ACTIONS(3758),
    [anon_sym_LT_LT_EQ] = ACTIONS(3758),
    [anon_sym_GT_GT_EQ] = ACTIONS(3758),
    [anon_sym_AMP_EQ] = ACTIONS(3758),
    [anon_sym_CARET_EQ] = ACTIONS(3758),
    [anon_sym_PIPE_EQ] = ACTIONS(3758),
    [anon_sym_and_eq] = ACTIONS(3758),
    [anon_sym_or_eq] = ACTIONS(3758),
    [anon_sym_xor_eq] = ACTIONS(3758),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(5863),
    [anon_sym_u_DQUOTE] = ACTIONS(5863),
    [anon_sym_U_DQUOTE] = ACTIONS(5863),
    [anon_sym_u8_DQUOTE] = ACTIONS(5863),
    [anon_sym_DQUOTE] = ACTIONS(5863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5865),
    [anon_sym_LR_DQUOTE] = ACTIONS(5865),
    [anon_sym_uR_DQUOTE] = ACTIONS(5865),
    [anon_sym_UR_DQUOTE] = ACTIONS(5865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5865),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
    [aux_sym_kernel_call_syntax_token2] = ACTIONS(3758),
  },
  [2324] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2321),
    [sym_identifier] = ACTIONS(5867),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5325),
    [anon_sym_COMMA] = ACTIONS(5325),
    [aux_sym_preproc_if_token2] = ACTIONS(5325),
    [aux_sym_preproc_else_token1] = ACTIONS(5325),
    [aux_sym_preproc_elif_token1] = ACTIONS(5327),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5325),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5325),
    [anon_sym_LPAREN2] = ACTIONS(5325),
    [anon_sym_DASH] = ACTIONS(5327),
    [anon_sym_PLUS] = ACTIONS(5327),
    [anon_sym_STAR] = ACTIONS(5327),
    [anon_sym_SLASH] = ACTIONS(5327),
    [anon_sym_PERCENT] = ACTIONS(5327),
    [anon_sym_PIPE_PIPE] = ACTIONS(5325),
    [anon_sym_AMP_AMP] = ACTIONS(5325),
    [anon_sym_PIPE] = ACTIONS(5327),
    [anon_sym_CARET] = ACTIONS(5327),
    [anon_sym_AMP] = ACTIONS(5327),
    [anon_sym_EQ_EQ] = ACTIONS(5325),
    [anon_sym_BANG_EQ] = ACTIONS(5325),
    [anon_sym_GT] = ACTIONS(5327),
    [anon_sym_GT_EQ] = ACTIONS(5325),
    [anon_sym_LT_EQ] = ACTIONS(5327),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_LT_LT] = ACTIONS(5327),
    [anon_sym_GT_GT] = ACTIONS(5327),
    [anon_sym___attribute__] = ACTIONS(5327),
    [anon_sym_LBRACE] = ACTIONS(5325),
    [anon_sym_signed] = ACTIONS(5870),
    [anon_sym_unsigned] = ACTIONS(5870),
    [anon_sym_long] = ACTIONS(5870),
    [anon_sym_short] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5327),
    [sym_primitive_type] = ACTIONS(5872),
    [anon_sym_QMARK] = ACTIONS(5325),
    [anon_sym_STAR_EQ] = ACTIONS(5325),
    [anon_sym_SLASH_EQ] = ACTIONS(5325),
    [anon_sym_PERCENT_EQ] = ACTIONS(5325),
    [anon_sym_PLUS_EQ] = ACTIONS(5325),
    [anon_sym_DASH_EQ] = ACTIONS(5325),
    [anon_sym_LT_LT_EQ] = ACTIONS(5325),
    [anon_sym_GT_GT_EQ] = ACTIONS(5325),
    [anon_sym_AMP_EQ] = ACTIONS(5325),
    [anon_sym_CARET_EQ] = ACTIONS(5325),
    [anon_sym_PIPE_EQ] = ACTIONS(5325),
    [anon_sym_and_eq] = ACTIONS(5327),
    [anon_sym_or_eq] = ACTIONS(5327),
    [anon_sym_xor_eq] = ACTIONS(5327),
    [anon_sym_LT_EQ_GT] = ACTIONS(5325),
    [anon_sym_or] = ACTIONS(5327),
    [anon_sym_and] = ACTIONS(5327),
    [anon_sym_bitor] = ACTIONS(5327),
    [anon_sym_xor] = ACTIONS(5327),
    [anon_sym_bitand] = ACTIONS(5327),
    [anon_sym_not_eq] = ACTIONS(5327),
    [anon_sym_DASH_DASH] = ACTIONS(5325),
    [anon_sym_PLUS_PLUS] = ACTIONS(5325),
    [anon_sym_DOT] = ACTIONS(5327),
    [anon_sym_DOT_STAR] = ACTIONS(5325),
    [anon_sym_DASH_GT] = ACTIONS(5325),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5327),
    [anon_sym_decltype] = ACTIONS(5327),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5325),
  },
  [2325] = {
    [sym_attribute_specifier] = STATE(2443),
    [sym_identifier] = ACTIONS(5629),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5627),
    [anon_sym_COMMA] = ACTIONS(5627),
    [anon_sym_RPAREN] = ACTIONS(5627),
    [aux_sym_preproc_if_token2] = ACTIONS(5627),
    [aux_sym_preproc_else_token1] = ACTIONS(5627),
    [aux_sym_preproc_elif_token1] = ACTIONS(5629),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5627),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5627),
    [anon_sym_LPAREN2] = ACTIONS(5627),
    [anon_sym_DASH] = ACTIONS(5629),
    [anon_sym_PLUS] = ACTIONS(5629),
    [anon_sym_STAR] = ACTIONS(5629),
    [anon_sym_SLASH] = ACTIONS(5629),
    [anon_sym_PERCENT] = ACTIONS(5629),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5627),
    [anon_sym_PIPE] = ACTIONS(5629),
    [anon_sym_CARET] = ACTIONS(5629),
    [anon_sym_AMP] = ACTIONS(5629),
    [anon_sym_EQ_EQ] = ACTIONS(5627),
    [anon_sym_BANG_EQ] = ACTIONS(5627),
    [anon_sym_GT] = ACTIONS(5629),
    [anon_sym_GT_EQ] = ACTIONS(5627),
    [anon_sym_LT_EQ] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5629),
    [anon_sym_LT_LT] = ACTIONS(5629),
    [anon_sym_GT_GT] = ACTIONS(5629),
    [anon_sym_SEMI] = ACTIONS(5627),
    [anon_sym___attribute__] = ACTIONS(5546),
    [anon_sym_LBRACE] = ACTIONS(5627),
    [anon_sym_RBRACE] = ACTIONS(5627),
    [anon_sym_LBRACK] = ACTIONS(5627),
    [anon_sym_RBRACK] = ACTIONS(5627),
    [anon_sym_EQ] = ACTIONS(5629),
    [anon_sym_COLON] = ACTIONS(5627),
    [anon_sym_QMARK] = ACTIONS(5627),
    [anon_sym_STAR_EQ] = ACTIONS(5627),
    [anon_sym_SLASH_EQ] = ACTIONS(5627),
    [anon_sym_PERCENT_EQ] = ACTIONS(5627),
    [anon_sym_PLUS_EQ] = ACTIONS(5627),
    [anon_sym_DASH_EQ] = ACTIONS(5627),
    [anon_sym_LT_LT_EQ] = ACTIONS(5627),
    [anon_sym_GT_GT_EQ] = ACTIONS(5627),
    [anon_sym_AMP_EQ] = ACTIONS(5627),
    [anon_sym_CARET_EQ] = ACTIONS(5627),
    [anon_sym_PIPE_EQ] = ACTIONS(5627),
    [anon_sym_and_eq] = ACTIONS(5629),
    [anon_sym_or_eq] = ACTIONS(5629),
    [anon_sym_xor_eq] = ACTIONS(5629),
    [anon_sym_LT_EQ_GT] = ACTIONS(5627),
    [anon_sym_or] = ACTIONS(5629),
    [anon_sym_and] = ACTIONS(5629),
    [anon_sym_bitor] = ACTIONS(5629),
    [anon_sym_xor] = ACTIONS(5629),
    [anon_sym_bitand] = ACTIONS(5629),
    [anon_sym_not_eq] = ACTIONS(5629),
    [anon_sym_DASH_DASH] = ACTIONS(5627),
    [anon_sym_PLUS_PLUS] = ACTIONS(5627),
    [anon_sym_DOT] = ACTIONS(5629),
    [anon_sym_DOT_STAR] = ACTIONS(5627),
    [anon_sym_DASH_GT] = ACTIONS(5627),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5629),
    [anon_sym_decltype] = ACTIONS(5629),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5627),
  },
  [2326] = {
    [sym_template_argument_list] = STATE(2259),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2438),
    [sym_identifier] = ACTIONS(3756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3764),
    [anon_sym_COMMA] = ACTIONS(3764),
    [aux_sym_preproc_if_token2] = ACTIONS(3764),
    [aux_sym_preproc_else_token1] = ACTIONS(3764),
    [aux_sym_preproc_elif_token1] = ACTIONS(3756),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3764),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3764),
    [anon_sym_LPAREN2] = ACTIONS(3764),
    [anon_sym_DASH] = ACTIONS(3756),
    [anon_sym_PLUS] = ACTIONS(3756),
    [anon_sym_STAR] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3756),
    [anon_sym_PERCENT] = ACTIONS(3756),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_AMP_AMP] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3756),
    [anon_sym_CARET] = ACTIONS(3756),
    [anon_sym_AMP] = ACTIONS(3756),
    [anon_sym_EQ_EQ] = ACTIONS(3764),
    [anon_sym_BANG_EQ] = ACTIONS(3764),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_GT_EQ] = ACTIONS(3764),
    [anon_sym_LT_EQ] = ACTIONS(3756),
    [anon_sym_LT] = ACTIONS(5729),
    [anon_sym_LT_LT] = ACTIONS(3756),
    [anon_sym_GT_GT] = ACTIONS(3756),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3764),
    [anon_sym_signed] = ACTIONS(5770),
    [anon_sym_unsigned] = ACTIONS(5770),
    [anon_sym_long] = ACTIONS(5770),
    [anon_sym_short] = ACTIONS(5770),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_EQ] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3764),
    [anon_sym_STAR_EQ] = ACTIONS(3764),
    [anon_sym_SLASH_EQ] = ACTIONS(3764),
    [anon_sym_PERCENT_EQ] = ACTIONS(3764),
    [anon_sym_PLUS_EQ] = ACTIONS(3764),
    [anon_sym_DASH_EQ] = ACTIONS(3764),
    [anon_sym_LT_LT_EQ] = ACTIONS(3764),
    [anon_sym_GT_GT_EQ] = ACTIONS(3764),
    [anon_sym_AMP_EQ] = ACTIONS(3764),
    [anon_sym_CARET_EQ] = ACTIONS(3764),
    [anon_sym_PIPE_EQ] = ACTIONS(3764),
    [anon_sym_and_eq] = ACTIONS(3756),
    [anon_sym_or_eq] = ACTIONS(3756),
    [anon_sym_xor_eq] = ACTIONS(3756),
    [anon_sym_LT_EQ_GT] = ACTIONS(3764),
    [anon_sym_or] = ACTIONS(3756),
    [anon_sym_and] = ACTIONS(3756),
    [anon_sym_bitor] = ACTIONS(3756),
    [anon_sym_xor] = ACTIONS(3756),
    [anon_sym_bitand] = ACTIONS(3756),
    [anon_sym_not_eq] = ACTIONS(3756),
    [anon_sym_DASH_DASH] = ACTIONS(3764),
    [anon_sym_PLUS_PLUS] = ACTIONS(3764),
    [anon_sym_DOT] = ACTIONS(3756),
    [anon_sym_DOT_STAR] = ACTIONS(3764),
    [anon_sym_DASH_GT] = ACTIONS(3764),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3756),
    [anon_sym_decltype] = ACTIONS(3756),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3764),
  },
  [2327] = {
    [sym_attribute_specifier] = STATE(2203),
    [sym_field_declaration_list] = STATE(2475),
    [sym_virtual_specifier] = STATE(7228),
    [sym_base_class_clause] = STATE(8034),
    [sym_identifier] = ACTIONS(5508),
    [anon_sym_LPAREN2] = ACTIONS(5506),
    [anon_sym_TILDE] = ACTIONS(5506),
    [anon_sym_STAR] = ACTIONS(5506),
    [anon_sym_AMP_AMP] = ACTIONS(5506),
    [anon_sym_AMP] = ACTIONS(5508),
    [anon_sym_SEMI] = ACTIONS(5874),
    [anon_sym___extension__] = ACTIONS(5508),
    [anon_sym___device__] = ACTIONS(5508),
    [anon_sym___host__] = ACTIONS(5508),
    [anon_sym___global__] = ACTIONS(5508),
    [anon_sym___forceinline__] = ACTIONS(5508),
    [anon_sym___noinline__] = ACTIONS(5508),
    [anon_sym_extern] = ACTIONS(5508),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5506),
    [anon_sym___declspec] = ACTIONS(5508),
    [anon_sym___based] = ACTIONS(5508),
    [anon_sym___cdecl] = ACTIONS(5508),
    [anon_sym___clrcall] = ACTIONS(5508),
    [anon_sym___stdcall] = ACTIONS(5508),
    [anon_sym___fastcall] = ACTIONS(5508),
    [anon_sym___thiscall] = ACTIONS(5508),
    [anon_sym___vectorcall] = ACTIONS(5508),
    [anon_sym_LBRACE] = ACTIONS(5580),
    [anon_sym_LBRACK] = ACTIONS(5508),
    [anon_sym_static] = ACTIONS(5508),
    [anon_sym_register] = ACTIONS(5508),
    [anon_sym_inline] = ACTIONS(5508),
    [anon_sym___inline] = ACTIONS(5508),
    [anon_sym___inline__] = ACTIONS(5508),
    [anon_sym___forceinline] = ACTIONS(5508),
    [anon_sym_thread_local] = ACTIONS(5508),
    [anon_sym___thread] = ACTIONS(5508),
    [anon_sym_const] = ACTIONS(5508),
    [anon_sym_constexpr] = ACTIONS(5508),
    [anon_sym_volatile] = ACTIONS(5508),
    [anon_sym_restrict] = ACTIONS(5508),
    [anon_sym___restrict__] = ACTIONS(5508),
    [anon_sym__Atomic] = ACTIONS(5508),
    [anon_sym__Noreturn] = ACTIONS(5508),
    [anon_sym_noreturn] = ACTIONS(5508),
    [anon_sym_mutable] = ACTIONS(5508),
    [anon_sym_constinit] = ACTIONS(5508),
    [anon_sym_consteval] = ACTIONS(5508),
    [anon_sym___shared__] = ACTIONS(5508),
    [anon_sym___local__] = ACTIONS(5508),
    [anon_sym___constant__] = ACTIONS(5508),
    [anon_sym___managed__] = ACTIONS(5508),
    [anon_sym___grid_constant__] = ACTIONS(5508),
    [anon_sym_alignas] = ACTIONS(5508),
    [anon_sym__Alignas] = ACTIONS(5508),
    [anon_sym_COLON] = ACTIONS(5582),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5508),
    [anon_sym_decltype] = ACTIONS(5508),
    [anon_sym_final] = ACTIONS(5550),
    [anon_sym_override] = ACTIONS(5550),
    [sym_virtual] = ACTIONS(5508),
    [anon_sym_template] = ACTIONS(5508),
    [anon_sym_operator] = ACTIONS(5508),
    [anon_sym___launch_bounds__] = ACTIONS(5508),
  },
  [2328] = {
    [sym_string_literal] = STATE(3733),
    [sym_template_argument_list] = STATE(5136),
    [sym_raw_string_literal] = STATE(3733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(5876),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(5879),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(5881),
    [anon_sym_SLASH_EQ] = ACTIONS(5881),
    [anon_sym_PERCENT_EQ] = ACTIONS(5881),
    [anon_sym_PLUS_EQ] = ACTIONS(5881),
    [anon_sym_DASH_EQ] = ACTIONS(5881),
    [anon_sym_LT_LT_EQ] = ACTIONS(5881),
    [anon_sym_GT_GT_EQ] = ACTIONS(5881),
    [anon_sym_AMP_EQ] = ACTIONS(5881),
    [anon_sym_CARET_EQ] = ACTIONS(5881),
    [anon_sym_PIPE_EQ] = ACTIONS(5881),
    [anon_sym_and_eq] = ACTIONS(5881),
    [anon_sym_or_eq] = ACTIONS(5881),
    [anon_sym_xor_eq] = ACTIONS(5881),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(5883),
    [anon_sym_u_DQUOTE] = ACTIONS(5883),
    [anon_sym_U_DQUOTE] = ACTIONS(5883),
    [anon_sym_u8_DQUOTE] = ACTIONS(5883),
    [anon_sym_DQUOTE] = ACTIONS(5883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5885),
    [anon_sym_LR_DQUOTE] = ACTIONS(5885),
    [anon_sym_uR_DQUOTE] = ACTIONS(5885),
    [anon_sym_UR_DQUOTE] = ACTIONS(5885),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5885),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
    [aux_sym_kernel_call_syntax_token2] = ACTIONS(3758),
  },
  [2329] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3998),
    [anon_sym_COMMA] = ACTIONS(3998),
    [anon_sym_LPAREN2] = ACTIONS(3998),
    [anon_sym_DASH] = ACTIONS(3996),
    [anon_sym_PLUS] = ACTIONS(3996),
    [anon_sym_STAR] = ACTIONS(3998),
    [anon_sym_SLASH] = ACTIONS(3996),
    [anon_sym_PERCENT] = ACTIONS(3998),
    [anon_sym_PIPE_PIPE] = ACTIONS(3998),
    [anon_sym_AMP_AMP] = ACTIONS(3998),
    [anon_sym_PIPE] = ACTIONS(3996),
    [anon_sym_CARET] = ACTIONS(3998),
    [anon_sym_AMP] = ACTIONS(3996),
    [anon_sym_EQ_EQ] = ACTIONS(3998),
    [anon_sym_BANG_EQ] = ACTIONS(3998),
    [anon_sym_GT] = ACTIONS(3996),
    [anon_sym_GT_EQ] = ACTIONS(3996),
    [anon_sym_LT_EQ] = ACTIONS(3996),
    [anon_sym_LT] = ACTIONS(3996),
    [anon_sym_LT_LT] = ACTIONS(3996),
    [anon_sym_GT_GT] = ACTIONS(3996),
    [anon_sym___extension__] = ACTIONS(3998),
    [anon_sym___global__] = ACTIONS(3998),
    [anon_sym___attribute__] = ACTIONS(3998),
    [anon_sym_COLON_COLON] = ACTIONS(3998),
    [anon_sym_LBRACE] = ACTIONS(3998),
    [anon_sym_LBRACK] = ACTIONS(3998),
    [anon_sym_const] = ACTIONS(3996),
    [anon_sym_constexpr] = ACTIONS(3998),
    [anon_sym_volatile] = ACTIONS(3998),
    [anon_sym_restrict] = ACTIONS(3998),
    [anon_sym___restrict__] = ACTIONS(3998),
    [anon_sym__Atomic] = ACTIONS(3998),
    [anon_sym__Noreturn] = ACTIONS(3998),
    [anon_sym_noreturn] = ACTIONS(3998),
    [anon_sym_mutable] = ACTIONS(3998),
    [anon_sym_constinit] = ACTIONS(3998),
    [anon_sym_consteval] = ACTIONS(3998),
    [anon_sym___shared__] = ACTIONS(3998),
    [anon_sym___local__] = ACTIONS(3998),
    [anon_sym___constant__] = ACTIONS(3998),
    [anon_sym___managed__] = ACTIONS(3998),
    [anon_sym___grid_constant__] = ACTIONS(3998),
    [anon_sym_alignas] = ACTIONS(3998),
    [anon_sym__Alignas] = ACTIONS(3998),
    [anon_sym_COLON] = ACTIONS(3996),
    [anon_sym_QMARK] = ACTIONS(3998),
    [anon_sym_LT_EQ_GT] = ACTIONS(3998),
    [anon_sym_or] = ACTIONS(3998),
    [anon_sym_and] = ACTIONS(3998),
    [anon_sym_bitor] = ACTIONS(3998),
    [anon_sym_xor] = ACTIONS(3998),
    [anon_sym_bitand] = ACTIONS(3998),
    [anon_sym_not_eq] = ACTIONS(3998),
    [anon_sym_DASH_DASH] = ACTIONS(3998),
    [anon_sym_PLUS_PLUS] = ACTIONS(3998),
    [anon_sym_DOT] = ACTIONS(3996),
    [anon_sym_DOT_STAR] = ACTIONS(3998),
    [anon_sym_DASH_GT] = ACTIONS(3998),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3998),
    [anon_sym_decltype] = ACTIONS(3998),
    [anon_sym_final] = ACTIONS(3998),
    [anon_sym_override] = ACTIONS(3998),
    [anon_sym_GT2] = ACTIONS(3998),
    [anon_sym_requires] = ACTIONS(3998),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3998),
  },
  [2330] = {
    [sym_identifier] = ACTIONS(5203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5205),
    [anon_sym_COMMA] = ACTIONS(5205),
    [anon_sym_RPAREN] = ACTIONS(5205),
    [aux_sym_preproc_if_token2] = ACTIONS(5205),
    [aux_sym_preproc_else_token1] = ACTIONS(5205),
    [aux_sym_preproc_elif_token1] = ACTIONS(5203),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5205),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5205),
    [anon_sym_LPAREN2] = ACTIONS(5205),
    [anon_sym_DASH] = ACTIONS(5203),
    [anon_sym_PLUS] = ACTIONS(5203),
    [anon_sym_STAR] = ACTIONS(5203),
    [anon_sym_SLASH] = ACTIONS(5203),
    [anon_sym_PERCENT] = ACTIONS(5203),
    [anon_sym_PIPE_PIPE] = ACTIONS(5205),
    [anon_sym_AMP_AMP] = ACTIONS(5205),
    [anon_sym_PIPE] = ACTIONS(5203),
    [anon_sym_CARET] = ACTIONS(5203),
    [anon_sym_AMP] = ACTIONS(5203),
    [anon_sym_EQ_EQ] = ACTIONS(5205),
    [anon_sym_BANG_EQ] = ACTIONS(5205),
    [anon_sym_GT] = ACTIONS(5203),
    [anon_sym_GT_EQ] = ACTIONS(5205),
    [anon_sym_LT_EQ] = ACTIONS(5203),
    [anon_sym_LT] = ACTIONS(5203),
    [anon_sym_LT_LT] = ACTIONS(5203),
    [anon_sym_GT_GT] = ACTIONS(5203),
    [anon_sym_SEMI] = ACTIONS(5205),
    [anon_sym___attribute__] = ACTIONS(5203),
    [anon_sym_COLON_COLON] = ACTIONS(5205),
    [anon_sym_LBRACE] = ACTIONS(5205),
    [anon_sym_RBRACE] = ACTIONS(5205),
    [anon_sym_LBRACK] = ACTIONS(5205),
    [anon_sym_RBRACK] = ACTIONS(5205),
    [anon_sym_EQ] = ACTIONS(5203),
    [anon_sym_COLON] = ACTIONS(5203),
    [anon_sym_QMARK] = ACTIONS(5205),
    [anon_sym_STAR_EQ] = ACTIONS(5205),
    [anon_sym_SLASH_EQ] = ACTIONS(5205),
    [anon_sym_PERCENT_EQ] = ACTIONS(5205),
    [anon_sym_PLUS_EQ] = ACTIONS(5205),
    [anon_sym_DASH_EQ] = ACTIONS(5205),
    [anon_sym_LT_LT_EQ] = ACTIONS(5205),
    [anon_sym_GT_GT_EQ] = ACTIONS(5205),
    [anon_sym_AMP_EQ] = ACTIONS(5205),
    [anon_sym_CARET_EQ] = ACTIONS(5205),
    [anon_sym_PIPE_EQ] = ACTIONS(5205),
    [anon_sym_and_eq] = ACTIONS(5203),
    [anon_sym_or_eq] = ACTIONS(5203),
    [anon_sym_xor_eq] = ACTIONS(5203),
    [anon_sym_LT_EQ_GT] = ACTIONS(5205),
    [anon_sym_or] = ACTIONS(5203),
    [anon_sym_and] = ACTIONS(5203),
    [anon_sym_bitor] = ACTIONS(5203),
    [anon_sym_xor] = ACTIONS(5203),
    [anon_sym_bitand] = ACTIONS(5203),
    [anon_sym_not_eq] = ACTIONS(5203),
    [anon_sym_DASH_DASH] = ACTIONS(5205),
    [anon_sym_PLUS_PLUS] = ACTIONS(5205),
    [anon_sym_DOT] = ACTIONS(5203),
    [anon_sym_DOT_STAR] = ACTIONS(5205),
    [anon_sym_DASH_GT] = ACTIONS(5205),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5203),
    [anon_sym_decltype] = ACTIONS(5203),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5205),
  },
  [2331] = {
    [sym_attribute_specifier] = STATE(2203),
    [sym_field_declaration_list] = STATE(2475),
    [sym_virtual_specifier] = STATE(7228),
    [sym_base_class_clause] = STATE(8034),
    [sym_identifier] = ACTIONS(5508),
    [anon_sym_LPAREN2] = ACTIONS(5506),
    [anon_sym_TILDE] = ACTIONS(5506),
    [anon_sym_STAR] = ACTIONS(5506),
    [anon_sym_AMP_AMP] = ACTIONS(5506),
    [anon_sym_AMP] = ACTIONS(5508),
    [anon_sym_SEMI] = ACTIONS(5887),
    [anon_sym___extension__] = ACTIONS(5508),
    [anon_sym___device__] = ACTIONS(5508),
    [anon_sym___host__] = ACTIONS(5508),
    [anon_sym___global__] = ACTIONS(5508),
    [anon_sym___forceinline__] = ACTIONS(5508),
    [anon_sym___noinline__] = ACTIONS(5508),
    [anon_sym_extern] = ACTIONS(5508),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5506),
    [anon_sym___declspec] = ACTIONS(5508),
    [anon_sym___based] = ACTIONS(5508),
    [anon_sym___cdecl] = ACTIONS(5508),
    [anon_sym___clrcall] = ACTIONS(5508),
    [anon_sym___stdcall] = ACTIONS(5508),
    [anon_sym___fastcall] = ACTIONS(5508),
    [anon_sym___thiscall] = ACTIONS(5508),
    [anon_sym___vectorcall] = ACTIONS(5508),
    [anon_sym_LBRACE] = ACTIONS(5580),
    [anon_sym_LBRACK] = ACTIONS(5508),
    [anon_sym_static] = ACTIONS(5508),
    [anon_sym_register] = ACTIONS(5508),
    [anon_sym_inline] = ACTIONS(5508),
    [anon_sym___inline] = ACTIONS(5508),
    [anon_sym___inline__] = ACTIONS(5508),
    [anon_sym___forceinline] = ACTIONS(5508),
    [anon_sym_thread_local] = ACTIONS(5508),
    [anon_sym___thread] = ACTIONS(5508),
    [anon_sym_const] = ACTIONS(5508),
    [anon_sym_constexpr] = ACTIONS(5508),
    [anon_sym_volatile] = ACTIONS(5508),
    [anon_sym_restrict] = ACTIONS(5508),
    [anon_sym___restrict__] = ACTIONS(5508),
    [anon_sym__Atomic] = ACTIONS(5508),
    [anon_sym__Noreturn] = ACTIONS(5508),
    [anon_sym_noreturn] = ACTIONS(5508),
    [anon_sym_mutable] = ACTIONS(5508),
    [anon_sym_constinit] = ACTIONS(5508),
    [anon_sym_consteval] = ACTIONS(5508),
    [anon_sym___shared__] = ACTIONS(5508),
    [anon_sym___local__] = ACTIONS(5508),
    [anon_sym___constant__] = ACTIONS(5508),
    [anon_sym___managed__] = ACTIONS(5508),
    [anon_sym___grid_constant__] = ACTIONS(5508),
    [anon_sym_alignas] = ACTIONS(5508),
    [anon_sym__Alignas] = ACTIONS(5508),
    [anon_sym_COLON] = ACTIONS(5582),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5508),
    [anon_sym_decltype] = ACTIONS(5508),
    [anon_sym_final] = ACTIONS(5550),
    [anon_sym_override] = ACTIONS(5550),
    [sym_virtual] = ACTIONS(5508),
    [anon_sym_template] = ACTIONS(5508),
    [anon_sym_operator] = ACTIONS(5508),
    [anon_sym___launch_bounds__] = ACTIONS(5508),
  },
  [2332] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3982),
    [anon_sym_COMMA] = ACTIONS(3982),
    [anon_sym_LPAREN2] = ACTIONS(3982),
    [anon_sym_DASH] = ACTIONS(3980),
    [anon_sym_PLUS] = ACTIONS(3980),
    [anon_sym_STAR] = ACTIONS(3982),
    [anon_sym_SLASH] = ACTIONS(3980),
    [anon_sym_PERCENT] = ACTIONS(3982),
    [anon_sym_PIPE_PIPE] = ACTIONS(3982),
    [anon_sym_AMP_AMP] = ACTIONS(3982),
    [anon_sym_PIPE] = ACTIONS(3980),
    [anon_sym_CARET] = ACTIONS(3982),
    [anon_sym_AMP] = ACTIONS(3980),
    [anon_sym_EQ_EQ] = ACTIONS(3982),
    [anon_sym_BANG_EQ] = ACTIONS(3982),
    [anon_sym_GT] = ACTIONS(3980),
    [anon_sym_GT_EQ] = ACTIONS(3980),
    [anon_sym_LT_EQ] = ACTIONS(3980),
    [anon_sym_LT] = ACTIONS(3980),
    [anon_sym_LT_LT] = ACTIONS(3980),
    [anon_sym_GT_GT] = ACTIONS(3980),
    [anon_sym___extension__] = ACTIONS(3982),
    [anon_sym___global__] = ACTIONS(3982),
    [anon_sym___attribute__] = ACTIONS(3982),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_LBRACE] = ACTIONS(3982),
    [anon_sym_LBRACK] = ACTIONS(3982),
    [anon_sym_const] = ACTIONS(3980),
    [anon_sym_constexpr] = ACTIONS(3982),
    [anon_sym_volatile] = ACTIONS(3982),
    [anon_sym_restrict] = ACTIONS(3982),
    [anon_sym___restrict__] = ACTIONS(3982),
    [anon_sym__Atomic] = ACTIONS(3982),
    [anon_sym__Noreturn] = ACTIONS(3982),
    [anon_sym_noreturn] = ACTIONS(3982),
    [anon_sym_mutable] = ACTIONS(3982),
    [anon_sym_constinit] = ACTIONS(3982),
    [anon_sym_consteval] = ACTIONS(3982),
    [anon_sym___shared__] = ACTIONS(3982),
    [anon_sym___local__] = ACTIONS(3982),
    [anon_sym___constant__] = ACTIONS(3982),
    [anon_sym___managed__] = ACTIONS(3982),
    [anon_sym___grid_constant__] = ACTIONS(3982),
    [anon_sym_alignas] = ACTIONS(3982),
    [anon_sym__Alignas] = ACTIONS(3982),
    [anon_sym_COLON] = ACTIONS(3980),
    [anon_sym_QMARK] = ACTIONS(3982),
    [anon_sym_LT_EQ_GT] = ACTIONS(3982),
    [anon_sym_or] = ACTIONS(3982),
    [anon_sym_and] = ACTIONS(3982),
    [anon_sym_bitor] = ACTIONS(3982),
    [anon_sym_xor] = ACTIONS(3982),
    [anon_sym_bitand] = ACTIONS(3982),
    [anon_sym_not_eq] = ACTIONS(3982),
    [anon_sym_DASH_DASH] = ACTIONS(3982),
    [anon_sym_PLUS_PLUS] = ACTIONS(3982),
    [anon_sym_DOT] = ACTIONS(3980),
    [anon_sym_DOT_STAR] = ACTIONS(3982),
    [anon_sym_DASH_GT] = ACTIONS(3982),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3982),
    [anon_sym_decltype] = ACTIONS(3982),
    [anon_sym_final] = ACTIONS(3982),
    [anon_sym_override] = ACTIONS(3982),
    [anon_sym_GT2] = ACTIONS(3982),
    [anon_sym_requires] = ACTIONS(3982),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3982),
  },
  [2333] = {
    [sym_attribute_specifier] = STATE(2203),
    [sym_field_declaration_list] = STATE(2475),
    [sym_virtual_specifier] = STATE(7228),
    [sym_base_class_clause] = STATE(8034),
    [sym_identifier] = ACTIONS(5508),
    [anon_sym_LPAREN2] = ACTIONS(5506),
    [anon_sym_TILDE] = ACTIONS(5506),
    [anon_sym_STAR] = ACTIONS(5506),
    [anon_sym_AMP_AMP] = ACTIONS(5506),
    [anon_sym_AMP] = ACTIONS(5508),
    [anon_sym_SEMI] = ACTIONS(5889),
    [anon_sym___extension__] = ACTIONS(5508),
    [anon_sym___device__] = ACTIONS(5508),
    [anon_sym___host__] = ACTIONS(5508),
    [anon_sym___global__] = ACTIONS(5508),
    [anon_sym___forceinline__] = ACTIONS(5508),
    [anon_sym___noinline__] = ACTIONS(5508),
    [anon_sym_extern] = ACTIONS(5508),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5506),
    [anon_sym___declspec] = ACTIONS(5508),
    [anon_sym___based] = ACTIONS(5508),
    [anon_sym___cdecl] = ACTIONS(5508),
    [anon_sym___clrcall] = ACTIONS(5508),
    [anon_sym___stdcall] = ACTIONS(5508),
    [anon_sym___fastcall] = ACTIONS(5508),
    [anon_sym___thiscall] = ACTIONS(5508),
    [anon_sym___vectorcall] = ACTIONS(5508),
    [anon_sym_LBRACE] = ACTIONS(5580),
    [anon_sym_LBRACK] = ACTIONS(5508),
    [anon_sym_static] = ACTIONS(5508),
    [anon_sym_register] = ACTIONS(5508),
    [anon_sym_inline] = ACTIONS(5508),
    [anon_sym___inline] = ACTIONS(5508),
    [anon_sym___inline__] = ACTIONS(5508),
    [anon_sym___forceinline] = ACTIONS(5508),
    [anon_sym_thread_local] = ACTIONS(5508),
    [anon_sym___thread] = ACTIONS(5508),
    [anon_sym_const] = ACTIONS(5508),
    [anon_sym_constexpr] = ACTIONS(5508),
    [anon_sym_volatile] = ACTIONS(5508),
    [anon_sym_restrict] = ACTIONS(5508),
    [anon_sym___restrict__] = ACTIONS(5508),
    [anon_sym__Atomic] = ACTIONS(5508),
    [anon_sym__Noreturn] = ACTIONS(5508),
    [anon_sym_noreturn] = ACTIONS(5508),
    [anon_sym_mutable] = ACTIONS(5508),
    [anon_sym_constinit] = ACTIONS(5508),
    [anon_sym_consteval] = ACTIONS(5508),
    [anon_sym___shared__] = ACTIONS(5508),
    [anon_sym___local__] = ACTIONS(5508),
    [anon_sym___constant__] = ACTIONS(5508),
    [anon_sym___managed__] = ACTIONS(5508),
    [anon_sym___grid_constant__] = ACTIONS(5508),
    [anon_sym_alignas] = ACTIONS(5508),
    [anon_sym__Alignas] = ACTIONS(5508),
    [anon_sym_COLON] = ACTIONS(5582),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5508),
    [anon_sym_decltype] = ACTIONS(5508),
    [anon_sym_final] = ACTIONS(5550),
    [anon_sym_override] = ACTIONS(5550),
    [sym_virtual] = ACTIONS(5508),
    [anon_sym_template] = ACTIONS(5508),
    [anon_sym_operator] = ACTIONS(5508),
    [anon_sym___launch_bounds__] = ACTIONS(5508),
  },
  [2334] = {
    [sym_attribute_specifier] = STATE(2413),
    [sym_identifier] = ACTIONS(5688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5686),
    [anon_sym_COMMA] = ACTIONS(5686),
    [anon_sym_RPAREN] = ACTIONS(5686),
    [aux_sym_preproc_if_token2] = ACTIONS(5686),
    [aux_sym_preproc_else_token1] = ACTIONS(5686),
    [aux_sym_preproc_elif_token1] = ACTIONS(5688),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5686),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5686),
    [anon_sym_LPAREN2] = ACTIONS(5686),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5688),
    [anon_sym_STAR] = ACTIONS(5688),
    [anon_sym_SLASH] = ACTIONS(5688),
    [anon_sym_PERCENT] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE] = ACTIONS(5686),
    [anon_sym_AMP_AMP] = ACTIONS(5686),
    [anon_sym_PIPE] = ACTIONS(5688),
    [anon_sym_CARET] = ACTIONS(5688),
    [anon_sym_AMP] = ACTIONS(5688),
    [anon_sym_EQ_EQ] = ACTIONS(5686),
    [anon_sym_BANG_EQ] = ACTIONS(5686),
    [anon_sym_GT] = ACTIONS(5688),
    [anon_sym_GT_EQ] = ACTIONS(5686),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_LT] = ACTIONS(5688),
    [anon_sym_LT_LT] = ACTIONS(5688),
    [anon_sym_GT_GT] = ACTIONS(5688),
    [anon_sym_SEMI] = ACTIONS(5686),
    [anon_sym___attribute__] = ACTIONS(5546),
    [anon_sym_LBRACE] = ACTIONS(5686),
    [anon_sym_RBRACE] = ACTIONS(5686),
    [anon_sym_LBRACK] = ACTIONS(5686),
    [anon_sym_RBRACK] = ACTIONS(5686),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_COLON] = ACTIONS(5686),
    [anon_sym_QMARK] = ACTIONS(5686),
    [anon_sym_STAR_EQ] = ACTIONS(5686),
    [anon_sym_SLASH_EQ] = ACTIONS(5686),
    [anon_sym_PERCENT_EQ] = ACTIONS(5686),
    [anon_sym_PLUS_EQ] = ACTIONS(5686),
    [anon_sym_DASH_EQ] = ACTIONS(5686),
    [anon_sym_LT_LT_EQ] = ACTIONS(5686),
    [anon_sym_GT_GT_EQ] = ACTIONS(5686),
    [anon_sym_AMP_EQ] = ACTIONS(5686),
    [anon_sym_CARET_EQ] = ACTIONS(5686),
    [anon_sym_PIPE_EQ] = ACTIONS(5686),
    [anon_sym_and_eq] = ACTIONS(5688),
    [anon_sym_or_eq] = ACTIONS(5688),
    [anon_sym_xor_eq] = ACTIONS(5688),
    [anon_sym_LT_EQ_GT] = ACTIONS(5686),
    [anon_sym_or] = ACTIONS(5688),
    [anon_sym_and] = ACTIONS(5688),
    [anon_sym_bitor] = ACTIONS(5688),
    [anon_sym_xor] = ACTIONS(5688),
    [anon_sym_bitand] = ACTIONS(5688),
    [anon_sym_not_eq] = ACTIONS(5688),
    [anon_sym_DASH_DASH] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5686),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_DOT_STAR] = ACTIONS(5686),
    [anon_sym_DASH_GT] = ACTIONS(5686),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5688),
    [anon_sym_decltype] = ACTIONS(5688),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5686),
  },
  [2335] = {
    [sym_attribute_specifier] = STATE(2405),
    [sym_identifier] = ACTIONS(5696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5694),
    [anon_sym_COMMA] = ACTIONS(5694),
    [anon_sym_RPAREN] = ACTIONS(5694),
    [aux_sym_preproc_if_token2] = ACTIONS(5694),
    [aux_sym_preproc_else_token1] = ACTIONS(5694),
    [aux_sym_preproc_elif_token1] = ACTIONS(5696),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5694),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5694),
    [anon_sym_LPAREN2] = ACTIONS(5694),
    [anon_sym_DASH] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_STAR] = ACTIONS(5696),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE] = ACTIONS(5694),
    [anon_sym_AMP_AMP] = ACTIONS(5694),
    [anon_sym_PIPE] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5696),
    [anon_sym_AMP] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5694),
    [anon_sym_BANG_EQ] = ACTIONS(5694),
    [anon_sym_GT] = ACTIONS(5696),
    [anon_sym_GT_EQ] = ACTIONS(5694),
    [anon_sym_LT_EQ] = ACTIONS(5696),
    [anon_sym_LT] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym_SEMI] = ACTIONS(5694),
    [anon_sym___attribute__] = ACTIONS(5546),
    [anon_sym_LBRACE] = ACTIONS(5694),
    [anon_sym_RBRACE] = ACTIONS(5694),
    [anon_sym_LBRACK] = ACTIONS(5694),
    [anon_sym_RBRACK] = ACTIONS(5694),
    [anon_sym_EQ] = ACTIONS(5696),
    [anon_sym_COLON] = ACTIONS(5694),
    [anon_sym_QMARK] = ACTIONS(5694),
    [anon_sym_STAR_EQ] = ACTIONS(5694),
    [anon_sym_SLASH_EQ] = ACTIONS(5694),
    [anon_sym_PERCENT_EQ] = ACTIONS(5694),
    [anon_sym_PLUS_EQ] = ACTIONS(5694),
    [anon_sym_DASH_EQ] = ACTIONS(5694),
    [anon_sym_LT_LT_EQ] = ACTIONS(5694),
    [anon_sym_GT_GT_EQ] = ACTIONS(5694),
    [anon_sym_AMP_EQ] = ACTIONS(5694),
    [anon_sym_CARET_EQ] = ACTIONS(5694),
    [anon_sym_PIPE_EQ] = ACTIONS(5694),
    [anon_sym_and_eq] = ACTIONS(5696),
    [anon_sym_or_eq] = ACTIONS(5696),
    [anon_sym_xor_eq] = ACTIONS(5696),
    [anon_sym_LT_EQ_GT] = ACTIONS(5694),
    [anon_sym_or] = ACTIONS(5696),
    [anon_sym_and] = ACTIONS(5696),
    [anon_sym_bitor] = ACTIONS(5696),
    [anon_sym_xor] = ACTIONS(5696),
    [anon_sym_bitand] = ACTIONS(5696),
    [anon_sym_not_eq] = ACTIONS(5696),
    [anon_sym_DASH_DASH] = ACTIONS(5694),
    [anon_sym_PLUS_PLUS] = ACTIONS(5694),
    [anon_sym_DOT] = ACTIONS(5696),
    [anon_sym_DOT_STAR] = ACTIONS(5694),
    [anon_sym_DASH_GT] = ACTIONS(5694),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5696),
    [anon_sym_decltype] = ACTIONS(5696),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5694),
  },
  [2336] = {
    [sym_string_literal] = STATE(2349),
    [sym_raw_string_literal] = STATE(2349),
    [aux_sym_concatenated_string_repeat1] = STATE(2349),
    [sym_identifier] = ACTIONS(5891),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5346),
    [anon_sym_COMMA] = ACTIONS(5346),
    [anon_sym_LPAREN2] = ACTIONS(5346),
    [anon_sym_DASH] = ACTIONS(5348),
    [anon_sym_PLUS] = ACTIONS(5348),
    [anon_sym_STAR] = ACTIONS(5348),
    [anon_sym_SLASH] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [anon_sym_PIPE_PIPE] = ACTIONS(5346),
    [anon_sym_AMP_AMP] = ACTIONS(5346),
    [anon_sym_PIPE] = ACTIONS(5348),
    [anon_sym_CARET] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5348),
    [anon_sym_EQ_EQ] = ACTIONS(5346),
    [anon_sym_BANG_EQ] = ACTIONS(5346),
    [anon_sym_GT] = ACTIONS(5348),
    [anon_sym_GT_EQ] = ACTIONS(5348),
    [anon_sym_LT_EQ] = ACTIONS(5348),
    [anon_sym_LT] = ACTIONS(5348),
    [anon_sym_LT_LT] = ACTIONS(5348),
    [anon_sym_GT_GT] = ACTIONS(5348),
    [anon_sym_LBRACK] = ACTIONS(5346),
    [anon_sym_EQ] = ACTIONS(5348),
    [anon_sym_QMARK] = ACTIONS(5346),
    [anon_sym_STAR_EQ] = ACTIONS(5346),
    [anon_sym_SLASH_EQ] = ACTIONS(5346),
    [anon_sym_PERCENT_EQ] = ACTIONS(5346),
    [anon_sym_PLUS_EQ] = ACTIONS(5346),
    [anon_sym_DASH_EQ] = ACTIONS(5346),
    [anon_sym_LT_LT_EQ] = ACTIONS(5346),
    [anon_sym_GT_GT_EQ] = ACTIONS(5348),
    [anon_sym_AMP_EQ] = ACTIONS(5346),
    [anon_sym_CARET_EQ] = ACTIONS(5346),
    [anon_sym_PIPE_EQ] = ACTIONS(5346),
    [anon_sym_and_eq] = ACTIONS(5348),
    [anon_sym_or_eq] = ACTIONS(5348),
    [anon_sym_xor_eq] = ACTIONS(5348),
    [anon_sym_LT_EQ_GT] = ACTIONS(5346),
    [anon_sym_or] = ACTIONS(5348),
    [anon_sym_and] = ACTIONS(5348),
    [anon_sym_bitor] = ACTIONS(5348),
    [anon_sym_xor] = ACTIONS(5348),
    [anon_sym_bitand] = ACTIONS(5348),
    [anon_sym_not_eq] = ACTIONS(5348),
    [anon_sym_DASH_DASH] = ACTIONS(5346),
    [anon_sym_PLUS_PLUS] = ACTIONS(5346),
    [anon_sym_DOT] = ACTIONS(5348),
    [anon_sym_DOT_STAR] = ACTIONS(5346),
    [anon_sym_DASH_GT] = ACTIONS(5346),
    [anon_sym_L_DQUOTE] = ACTIONS(5893),
    [anon_sym_u_DQUOTE] = ACTIONS(5893),
    [anon_sym_U_DQUOTE] = ACTIONS(5893),
    [anon_sym_u8_DQUOTE] = ACTIONS(5893),
    [anon_sym_DQUOTE] = ACTIONS(5893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(5346),
    [anon_sym_R_DQUOTE] = ACTIONS(5895),
    [anon_sym_LR_DQUOTE] = ACTIONS(5895),
    [anon_sym_uR_DQUOTE] = ACTIONS(5895),
    [anon_sym_UR_DQUOTE] = ACTIONS(5895),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5895),
    [sym_literal_suffix] = ACTIONS(5348),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5346),
  },
  [2337] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3986),
    [anon_sym_COMMA] = ACTIONS(3986),
    [anon_sym_LPAREN2] = ACTIONS(3986),
    [anon_sym_DASH] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3984),
    [anon_sym_STAR] = ACTIONS(3986),
    [anon_sym_SLASH] = ACTIONS(3984),
    [anon_sym_PERCENT] = ACTIONS(3986),
    [anon_sym_PIPE_PIPE] = ACTIONS(3986),
    [anon_sym_AMP_AMP] = ACTIONS(3986),
    [anon_sym_PIPE] = ACTIONS(3984),
    [anon_sym_CARET] = ACTIONS(3986),
    [anon_sym_AMP] = ACTIONS(3984),
    [anon_sym_EQ_EQ] = ACTIONS(3986),
    [anon_sym_BANG_EQ] = ACTIONS(3986),
    [anon_sym_GT] = ACTIONS(3984),
    [anon_sym_GT_EQ] = ACTIONS(3984),
    [anon_sym_LT_EQ] = ACTIONS(3984),
    [anon_sym_LT] = ACTIONS(3984),
    [anon_sym_LT_LT] = ACTIONS(3984),
    [anon_sym_GT_GT] = ACTIONS(3984),
    [anon_sym___extension__] = ACTIONS(3986),
    [anon_sym___global__] = ACTIONS(3986),
    [anon_sym___attribute__] = ACTIONS(3986),
    [anon_sym_COLON_COLON] = ACTIONS(3986),
    [anon_sym_LBRACE] = ACTIONS(3986),
    [anon_sym_LBRACK] = ACTIONS(3986),
    [anon_sym_const] = ACTIONS(3984),
    [anon_sym_constexpr] = ACTIONS(3986),
    [anon_sym_volatile] = ACTIONS(3986),
    [anon_sym_restrict] = ACTIONS(3986),
    [anon_sym___restrict__] = ACTIONS(3986),
    [anon_sym__Atomic] = ACTIONS(3986),
    [anon_sym__Noreturn] = ACTIONS(3986),
    [anon_sym_noreturn] = ACTIONS(3986),
    [anon_sym_mutable] = ACTIONS(3986),
    [anon_sym_constinit] = ACTIONS(3986),
    [anon_sym_consteval] = ACTIONS(3986),
    [anon_sym___shared__] = ACTIONS(3986),
    [anon_sym___local__] = ACTIONS(3986),
    [anon_sym___constant__] = ACTIONS(3986),
    [anon_sym___managed__] = ACTIONS(3986),
    [anon_sym___grid_constant__] = ACTIONS(3986),
    [anon_sym_alignas] = ACTIONS(3986),
    [anon_sym__Alignas] = ACTIONS(3986),
    [anon_sym_COLON] = ACTIONS(3984),
    [anon_sym_QMARK] = ACTIONS(3986),
    [anon_sym_LT_EQ_GT] = ACTIONS(3986),
    [anon_sym_or] = ACTIONS(3986),
    [anon_sym_and] = ACTIONS(3986),
    [anon_sym_bitor] = ACTIONS(3986),
    [anon_sym_xor] = ACTIONS(3986),
    [anon_sym_bitand] = ACTIONS(3986),
    [anon_sym_not_eq] = ACTIONS(3986),
    [anon_sym_DASH_DASH] = ACTIONS(3986),
    [anon_sym_PLUS_PLUS] = ACTIONS(3986),
    [anon_sym_DOT] = ACTIONS(3984),
    [anon_sym_DOT_STAR] = ACTIONS(3986),
    [anon_sym_DASH_GT] = ACTIONS(3986),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3986),
    [anon_sym_decltype] = ACTIONS(3986),
    [anon_sym_final] = ACTIONS(3986),
    [anon_sym_override] = ACTIONS(3986),
    [anon_sym_GT2] = ACTIONS(3986),
    [anon_sym_requires] = ACTIONS(3986),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3986),
  },
  [2338] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5181),
    [anon_sym_COMMA] = ACTIONS(5181),
    [anon_sym_LPAREN2] = ACTIONS(5181),
    [anon_sym_DASH] = ACTIONS(5179),
    [anon_sym_PLUS] = ACTIONS(5179),
    [anon_sym_STAR] = ACTIONS(5181),
    [anon_sym_SLASH] = ACTIONS(5179),
    [anon_sym_PERCENT] = ACTIONS(5181),
    [anon_sym_PIPE_PIPE] = ACTIONS(5181),
    [anon_sym_AMP_AMP] = ACTIONS(5181),
    [anon_sym_PIPE] = ACTIONS(5179),
    [anon_sym_CARET] = ACTIONS(5181),
    [anon_sym_AMP] = ACTIONS(5179),
    [anon_sym_EQ_EQ] = ACTIONS(5181),
    [anon_sym_BANG_EQ] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5179),
    [anon_sym_GT_EQ] = ACTIONS(5179),
    [anon_sym_LT_EQ] = ACTIONS(5179),
    [anon_sym_LT] = ACTIONS(5179),
    [anon_sym_LT_LT] = ACTIONS(5179),
    [anon_sym_GT_GT] = ACTIONS(5179),
    [anon_sym___extension__] = ACTIONS(5181),
    [anon_sym___global__] = ACTIONS(5181),
    [anon_sym___attribute__] = ACTIONS(5181),
    [anon_sym_COLON_COLON] = ACTIONS(5183),
    [anon_sym_LBRACE] = ACTIONS(5181),
    [anon_sym_LBRACK] = ACTIONS(5181),
    [anon_sym_const] = ACTIONS(5179),
    [anon_sym_constexpr] = ACTIONS(5181),
    [anon_sym_volatile] = ACTIONS(5181),
    [anon_sym_restrict] = ACTIONS(5181),
    [anon_sym___restrict__] = ACTIONS(5181),
    [anon_sym__Atomic] = ACTIONS(5181),
    [anon_sym__Noreturn] = ACTIONS(5181),
    [anon_sym_noreturn] = ACTIONS(5181),
    [anon_sym_mutable] = ACTIONS(5181),
    [anon_sym_constinit] = ACTIONS(5181),
    [anon_sym_consteval] = ACTIONS(5181),
    [anon_sym___shared__] = ACTIONS(5181),
    [anon_sym___local__] = ACTIONS(5181),
    [anon_sym___constant__] = ACTIONS(5181),
    [anon_sym___managed__] = ACTIONS(5181),
    [anon_sym___grid_constant__] = ACTIONS(5181),
    [anon_sym_alignas] = ACTIONS(5181),
    [anon_sym__Alignas] = ACTIONS(5181),
    [anon_sym_COLON] = ACTIONS(5179),
    [anon_sym_QMARK] = ACTIONS(5181),
    [anon_sym_LT_EQ_GT] = ACTIONS(5181),
    [anon_sym_or] = ACTIONS(5181),
    [anon_sym_and] = ACTIONS(5181),
    [anon_sym_bitor] = ACTIONS(5181),
    [anon_sym_xor] = ACTIONS(5181),
    [anon_sym_bitand] = ACTIONS(5181),
    [anon_sym_not_eq] = ACTIONS(5181),
    [anon_sym_DASH_DASH] = ACTIONS(5181),
    [anon_sym_PLUS_PLUS] = ACTIONS(5181),
    [anon_sym_DOT] = ACTIONS(5179),
    [anon_sym_DOT_STAR] = ACTIONS(5181),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5181),
    [anon_sym_decltype] = ACTIONS(5181),
    [anon_sym_final] = ACTIONS(5181),
    [anon_sym_override] = ACTIONS(5181),
    [anon_sym_GT2] = ACTIONS(5181),
    [anon_sym_requires] = ACTIONS(5181),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5181),
  },
  [2339] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5181),
    [anon_sym_COMMA] = ACTIONS(5181),
    [anon_sym_LPAREN2] = ACTIONS(5181),
    [anon_sym_DASH] = ACTIONS(5179),
    [anon_sym_PLUS] = ACTIONS(5179),
    [anon_sym_STAR] = ACTIONS(5181),
    [anon_sym_SLASH] = ACTIONS(5179),
    [anon_sym_PERCENT] = ACTIONS(5181),
    [anon_sym_PIPE_PIPE] = ACTIONS(5181),
    [anon_sym_AMP_AMP] = ACTIONS(5181),
    [anon_sym_PIPE] = ACTIONS(5179),
    [anon_sym_CARET] = ACTIONS(5181),
    [anon_sym_AMP] = ACTIONS(5179),
    [anon_sym_EQ_EQ] = ACTIONS(5181),
    [anon_sym_BANG_EQ] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5179),
    [anon_sym_GT_EQ] = ACTIONS(5179),
    [anon_sym_LT_EQ] = ACTIONS(5179),
    [anon_sym_LT] = ACTIONS(5179),
    [anon_sym_LT_LT] = ACTIONS(5179),
    [anon_sym_GT_GT] = ACTIONS(5179),
    [anon_sym___extension__] = ACTIONS(5181),
    [anon_sym___global__] = ACTIONS(5181),
    [anon_sym___attribute__] = ACTIONS(5181),
    [anon_sym_COLON_COLON] = ACTIONS(5183),
    [anon_sym_LBRACE] = ACTIONS(5181),
    [anon_sym_LBRACK] = ACTIONS(5181),
    [anon_sym_const] = ACTIONS(5179),
    [anon_sym_constexpr] = ACTIONS(5181),
    [anon_sym_volatile] = ACTIONS(5181),
    [anon_sym_restrict] = ACTIONS(5181),
    [anon_sym___restrict__] = ACTIONS(5181),
    [anon_sym__Atomic] = ACTIONS(5181),
    [anon_sym__Noreturn] = ACTIONS(5181),
    [anon_sym_noreturn] = ACTIONS(5181),
    [anon_sym_mutable] = ACTIONS(5181),
    [anon_sym_constinit] = ACTIONS(5181),
    [anon_sym_consteval] = ACTIONS(5181),
    [anon_sym___shared__] = ACTIONS(5181),
    [anon_sym___local__] = ACTIONS(5181),
    [anon_sym___constant__] = ACTIONS(5181),
    [anon_sym___managed__] = ACTIONS(5181),
    [anon_sym___grid_constant__] = ACTIONS(5181),
    [anon_sym_alignas] = ACTIONS(5181),
    [anon_sym__Alignas] = ACTIONS(5181),
    [anon_sym_COLON] = ACTIONS(5179),
    [anon_sym_QMARK] = ACTIONS(5181),
    [anon_sym_LT_EQ_GT] = ACTIONS(5181),
    [anon_sym_or] = ACTIONS(5181),
    [anon_sym_and] = ACTIONS(5181),
    [anon_sym_bitor] = ACTIONS(5181),
    [anon_sym_xor] = ACTIONS(5181),
    [anon_sym_bitand] = ACTIONS(5181),
    [anon_sym_not_eq] = ACTIONS(5181),
    [anon_sym_DASH_DASH] = ACTIONS(5181),
    [anon_sym_PLUS_PLUS] = ACTIONS(5181),
    [anon_sym_DOT] = ACTIONS(5179),
    [anon_sym_DOT_STAR] = ACTIONS(5181),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5181),
    [anon_sym_decltype] = ACTIONS(5181),
    [anon_sym_final] = ACTIONS(5181),
    [anon_sym_override] = ACTIONS(5181),
    [anon_sym_GT2] = ACTIONS(5181),
    [anon_sym_requires] = ACTIONS(5181),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5181),
  },
  [2340] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5460),
    [anon_sym_COMMA] = ACTIONS(5460),
    [anon_sym_RPAREN] = ACTIONS(5460),
    [anon_sym_LPAREN2] = ACTIONS(5460),
    [anon_sym_DASH] = ACTIONS(5458),
    [anon_sym_PLUS] = ACTIONS(5458),
    [anon_sym_STAR] = ACTIONS(5458),
    [anon_sym_SLASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5458),
    [anon_sym_PIPE_PIPE] = ACTIONS(5460),
    [anon_sym_AMP_AMP] = ACTIONS(5460),
    [anon_sym_PIPE] = ACTIONS(5458),
    [anon_sym_CARET] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5458),
    [anon_sym_EQ_EQ] = ACTIONS(5460),
    [anon_sym_BANG_EQ] = ACTIONS(5460),
    [anon_sym_GT] = ACTIONS(5458),
    [anon_sym_GT_EQ] = ACTIONS(5460),
    [anon_sym_LT_EQ] = ACTIONS(5458),
    [anon_sym_LT] = ACTIONS(5458),
    [anon_sym_LT_LT] = ACTIONS(5458),
    [anon_sym_GT_GT] = ACTIONS(5458),
    [anon_sym_SEMI] = ACTIONS(5460),
    [anon_sym_RBRACE] = ACTIONS(5460),
    [anon_sym_LBRACK] = ACTIONS(5460),
    [anon_sym_RBRACK] = ACTIONS(5460),
    [anon_sym_EQ] = ACTIONS(5458),
    [anon_sym_COLON] = ACTIONS(5460),
    [anon_sym_QMARK] = ACTIONS(5460),
    [anon_sym_STAR_EQ] = ACTIONS(5460),
    [anon_sym_SLASH_EQ] = ACTIONS(5460),
    [anon_sym_PERCENT_EQ] = ACTIONS(5460),
    [anon_sym_PLUS_EQ] = ACTIONS(5460),
    [anon_sym_DASH_EQ] = ACTIONS(5460),
    [anon_sym_LT_LT_EQ] = ACTIONS(5460),
    [anon_sym_GT_GT_EQ] = ACTIONS(5460),
    [anon_sym_AMP_EQ] = ACTIONS(5460),
    [anon_sym_CARET_EQ] = ACTIONS(5460),
    [anon_sym_PIPE_EQ] = ACTIONS(5460),
    [anon_sym_and_eq] = ACTIONS(5458),
    [anon_sym_or_eq] = ACTIONS(5458),
    [anon_sym_xor_eq] = ACTIONS(5458),
    [anon_sym_LT_EQ_GT] = ACTIONS(5460),
    [anon_sym_or] = ACTIONS(5458),
    [anon_sym_and] = ACTIONS(5458),
    [anon_sym_bitor] = ACTIONS(5458),
    [anon_sym_xor] = ACTIONS(5458),
    [anon_sym_bitand] = ACTIONS(5458),
    [anon_sym_not_eq] = ACTIONS(5458),
    [anon_sym_DASH_DASH] = ACTIONS(5460),
    [anon_sym_PLUS_PLUS] = ACTIONS(5460),
    [anon_sym_DOT] = ACTIONS(5458),
    [anon_sym_DOT_STAR] = ACTIONS(5460),
    [anon_sym_DASH_GT] = ACTIONS(5460),
    [anon_sym_L_DQUOTE] = ACTIONS(5460),
    [anon_sym_u_DQUOTE] = ACTIONS(5460),
    [anon_sym_U_DQUOTE] = ACTIONS(5460),
    [anon_sym_u8_DQUOTE] = ACTIONS(5460),
    [anon_sym_DQUOTE] = ACTIONS(5460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5460),
    [anon_sym_LR_DQUOTE] = ACTIONS(5460),
    [anon_sym_uR_DQUOTE] = ACTIONS(5460),
    [anon_sym_UR_DQUOTE] = ACTIONS(5460),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5460),
    [sym_literal_suffix] = ACTIONS(5458),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5460),
  },
  [2341] = {
    [sym_attribute_declaration] = STATE(2388),
    [sym_parameter_list] = STATE(2456),
    [aux_sym_attributed_declarator_repeat1] = STATE(2388),
    [sym_identifier] = ACTIONS(5897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5899),
    [anon_sym_COMMA] = ACTIONS(5899),
    [anon_sym_RPAREN] = ACTIONS(5899),
    [aux_sym_preproc_if_token2] = ACTIONS(5899),
    [aux_sym_preproc_else_token1] = ACTIONS(5899),
    [aux_sym_preproc_elif_token1] = ACTIONS(5897),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5899),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5899),
    [anon_sym_LPAREN2] = ACTIONS(5835),
    [anon_sym_DASH] = ACTIONS(5897),
    [anon_sym_PLUS] = ACTIONS(5897),
    [anon_sym_STAR] = ACTIONS(5897),
    [anon_sym_SLASH] = ACTIONS(5897),
    [anon_sym_PERCENT] = ACTIONS(5897),
    [anon_sym_PIPE_PIPE] = ACTIONS(5899),
    [anon_sym_AMP_AMP] = ACTIONS(5899),
    [anon_sym_PIPE] = ACTIONS(5897),
    [anon_sym_CARET] = ACTIONS(5897),
    [anon_sym_AMP] = ACTIONS(5897),
    [anon_sym_EQ_EQ] = ACTIONS(5899),
    [anon_sym_BANG_EQ] = ACTIONS(5899),
    [anon_sym_GT] = ACTIONS(5897),
    [anon_sym_GT_EQ] = ACTIONS(5899),
    [anon_sym_LT_EQ] = ACTIONS(5897),
    [anon_sym_LT] = ACTIONS(5897),
    [anon_sym_LT_LT] = ACTIONS(5897),
    [anon_sym_GT_GT] = ACTIONS(5897),
    [anon_sym_SEMI] = ACTIONS(5899),
    [anon_sym___attribute__] = ACTIONS(5897),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5837),
    [anon_sym_RBRACE] = ACTIONS(5899),
    [anon_sym_LBRACK] = ACTIONS(5839),
    [anon_sym_RBRACK] = ACTIONS(5899),
    [anon_sym_EQ] = ACTIONS(5897),
    [anon_sym_COLON] = ACTIONS(5899),
    [anon_sym_QMARK] = ACTIONS(5899),
    [anon_sym_STAR_EQ] = ACTIONS(5899),
    [anon_sym_SLASH_EQ] = ACTIONS(5899),
    [anon_sym_PERCENT_EQ] = ACTIONS(5899),
    [anon_sym_PLUS_EQ] = ACTIONS(5899),
    [anon_sym_DASH_EQ] = ACTIONS(5899),
    [anon_sym_LT_LT_EQ] = ACTIONS(5899),
    [anon_sym_GT_GT_EQ] = ACTIONS(5899),
    [anon_sym_AMP_EQ] = ACTIONS(5899),
    [anon_sym_CARET_EQ] = ACTIONS(5899),
    [anon_sym_PIPE_EQ] = ACTIONS(5899),
    [anon_sym_and_eq] = ACTIONS(5897),
    [anon_sym_or_eq] = ACTIONS(5897),
    [anon_sym_xor_eq] = ACTIONS(5897),
    [anon_sym_LT_EQ_GT] = ACTIONS(5899),
    [anon_sym_or] = ACTIONS(5897),
    [anon_sym_and] = ACTIONS(5897),
    [anon_sym_bitor] = ACTIONS(5897),
    [anon_sym_xor] = ACTIONS(5897),
    [anon_sym_bitand] = ACTIONS(5897),
    [anon_sym_not_eq] = ACTIONS(5897),
    [anon_sym_DASH_DASH] = ACTIONS(5899),
    [anon_sym_PLUS_PLUS] = ACTIONS(5899),
    [anon_sym_DOT] = ACTIONS(5897),
    [anon_sym_DOT_STAR] = ACTIONS(5899),
    [anon_sym_DASH_GT] = ACTIONS(5899),
    [sym_comment] = ACTIONS(3),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5899),
  },
  [2342] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5198),
    [anon_sym_COMMA] = ACTIONS(5198),
    [anon_sym_LPAREN2] = ACTIONS(5198),
    [anon_sym_DASH] = ACTIONS(5196),
    [anon_sym_PLUS] = ACTIONS(5196),
    [anon_sym_STAR] = ACTIONS(5198),
    [anon_sym_SLASH] = ACTIONS(5196),
    [anon_sym_PERCENT] = ACTIONS(5198),
    [anon_sym_PIPE_PIPE] = ACTIONS(5198),
    [anon_sym_AMP_AMP] = ACTIONS(5198),
    [anon_sym_PIPE] = ACTIONS(5196),
    [anon_sym_CARET] = ACTIONS(5198),
    [anon_sym_AMP] = ACTIONS(5196),
    [anon_sym_EQ_EQ] = ACTIONS(5198),
    [anon_sym_BANG_EQ] = ACTIONS(5198),
    [anon_sym_GT] = ACTIONS(5196),
    [anon_sym_GT_EQ] = ACTIONS(5196),
    [anon_sym_LT_EQ] = ACTIONS(5196),
    [anon_sym_LT] = ACTIONS(5196),
    [anon_sym_LT_LT] = ACTIONS(5196),
    [anon_sym_GT_GT] = ACTIONS(5196),
    [anon_sym___extension__] = ACTIONS(5198),
    [anon_sym___global__] = ACTIONS(5198),
    [anon_sym___attribute__] = ACTIONS(5198),
    [anon_sym_COLON_COLON] = ACTIONS(5198),
    [anon_sym_LBRACE] = ACTIONS(5198),
    [anon_sym_LBRACK] = ACTIONS(5198),
    [anon_sym_const] = ACTIONS(5196),
    [anon_sym_constexpr] = ACTIONS(5198),
    [anon_sym_volatile] = ACTIONS(5198),
    [anon_sym_restrict] = ACTIONS(5198),
    [anon_sym___restrict__] = ACTIONS(5198),
    [anon_sym__Atomic] = ACTIONS(5198),
    [anon_sym__Noreturn] = ACTIONS(5198),
    [anon_sym_noreturn] = ACTIONS(5198),
    [anon_sym_mutable] = ACTIONS(5198),
    [anon_sym_constinit] = ACTIONS(5198),
    [anon_sym_consteval] = ACTIONS(5198),
    [anon_sym___shared__] = ACTIONS(5198),
    [anon_sym___local__] = ACTIONS(5198),
    [anon_sym___constant__] = ACTIONS(5198),
    [anon_sym___managed__] = ACTIONS(5198),
    [anon_sym___grid_constant__] = ACTIONS(5198),
    [anon_sym_alignas] = ACTIONS(5198),
    [anon_sym__Alignas] = ACTIONS(5198),
    [anon_sym_COLON] = ACTIONS(5196),
    [anon_sym_QMARK] = ACTIONS(5198),
    [anon_sym_LT_EQ_GT] = ACTIONS(5198),
    [anon_sym_or] = ACTIONS(5198),
    [anon_sym_and] = ACTIONS(5198),
    [anon_sym_bitor] = ACTIONS(5198),
    [anon_sym_xor] = ACTIONS(5198),
    [anon_sym_bitand] = ACTIONS(5198),
    [anon_sym_not_eq] = ACTIONS(5198),
    [anon_sym_DASH_DASH] = ACTIONS(5198),
    [anon_sym_PLUS_PLUS] = ACTIONS(5198),
    [anon_sym_DOT] = ACTIONS(5196),
    [anon_sym_DOT_STAR] = ACTIONS(5198),
    [anon_sym_DASH_GT] = ACTIONS(5198),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5198),
    [anon_sym_decltype] = ACTIONS(5198),
    [anon_sym_final] = ACTIONS(5198),
    [anon_sym_override] = ACTIONS(5198),
    [anon_sym_GT2] = ACTIONS(5198),
    [anon_sym_requires] = ACTIONS(5198),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5198),
  },
  [2343] = {
    [sym_attribute_specifier] = STATE(2445),
    [sym_identifier] = ACTIONS(5670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5668),
    [anon_sym_COMMA] = ACTIONS(5668),
    [anon_sym_RPAREN] = ACTIONS(5668),
    [aux_sym_preproc_if_token2] = ACTIONS(5668),
    [aux_sym_preproc_else_token1] = ACTIONS(5668),
    [aux_sym_preproc_elif_token1] = ACTIONS(5670),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5668),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5668),
    [anon_sym_LPAREN2] = ACTIONS(5668),
    [anon_sym_DASH] = ACTIONS(5670),
    [anon_sym_PLUS] = ACTIONS(5670),
    [anon_sym_STAR] = ACTIONS(5670),
    [anon_sym_SLASH] = ACTIONS(5670),
    [anon_sym_PERCENT] = ACTIONS(5670),
    [anon_sym_PIPE_PIPE] = ACTIONS(5668),
    [anon_sym_AMP_AMP] = ACTIONS(5668),
    [anon_sym_PIPE] = ACTIONS(5670),
    [anon_sym_CARET] = ACTIONS(5670),
    [anon_sym_AMP] = ACTIONS(5670),
    [anon_sym_EQ_EQ] = ACTIONS(5668),
    [anon_sym_BANG_EQ] = ACTIONS(5668),
    [anon_sym_GT] = ACTIONS(5670),
    [anon_sym_GT_EQ] = ACTIONS(5668),
    [anon_sym_LT_EQ] = ACTIONS(5670),
    [anon_sym_LT] = ACTIONS(5670),
    [anon_sym_LT_LT] = ACTIONS(5670),
    [anon_sym_GT_GT] = ACTIONS(5670),
    [anon_sym_SEMI] = ACTIONS(5668),
    [anon_sym___attribute__] = ACTIONS(5546),
    [anon_sym_LBRACE] = ACTIONS(5668),
    [anon_sym_RBRACE] = ACTIONS(5668),
    [anon_sym_LBRACK] = ACTIONS(5668),
    [anon_sym_RBRACK] = ACTIONS(5668),
    [anon_sym_EQ] = ACTIONS(5670),
    [anon_sym_COLON] = ACTIONS(5668),
    [anon_sym_QMARK] = ACTIONS(5668),
    [anon_sym_STAR_EQ] = ACTIONS(5668),
    [anon_sym_SLASH_EQ] = ACTIONS(5668),
    [anon_sym_PERCENT_EQ] = ACTIONS(5668),
    [anon_sym_PLUS_EQ] = ACTIONS(5668),
    [anon_sym_DASH_EQ] = ACTIONS(5668),
    [anon_sym_LT_LT_EQ] = ACTIONS(5668),
    [anon_sym_GT_GT_EQ] = ACTIONS(5668),
    [anon_sym_AMP_EQ] = ACTIONS(5668),
    [anon_sym_CARET_EQ] = ACTIONS(5668),
    [anon_sym_PIPE_EQ] = ACTIONS(5668),
    [anon_sym_and_eq] = ACTIONS(5670),
    [anon_sym_or_eq] = ACTIONS(5670),
    [anon_sym_xor_eq] = ACTIONS(5670),
    [anon_sym_LT_EQ_GT] = ACTIONS(5668),
    [anon_sym_or] = ACTIONS(5670),
    [anon_sym_and] = ACTIONS(5670),
    [anon_sym_bitor] = ACTIONS(5670),
    [anon_sym_xor] = ACTIONS(5670),
    [anon_sym_bitand] = ACTIONS(5670),
    [anon_sym_not_eq] = ACTIONS(5670),
    [anon_sym_DASH_DASH] = ACTIONS(5668),
    [anon_sym_PLUS_PLUS] = ACTIONS(5668),
    [anon_sym_DOT] = ACTIONS(5670),
    [anon_sym_DOT_STAR] = ACTIONS(5668),
    [anon_sym_DASH_GT] = ACTIONS(5668),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5670),
    [anon_sym_decltype] = ACTIONS(5670),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5668),
  },
  [2344] = {
    [sym_string_literal] = STATE(2752),
    [sym_template_argument_list] = STATE(4108),
    [sym_raw_string_literal] = STATE(2752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(4850),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(5901),
    [anon_sym_COLON] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(5903),
    [anon_sym_SLASH_EQ] = ACTIONS(5903),
    [anon_sym_PERCENT_EQ] = ACTIONS(5903),
    [anon_sym_PLUS_EQ] = ACTIONS(5903),
    [anon_sym_DASH_EQ] = ACTIONS(5903),
    [anon_sym_LT_LT_EQ] = ACTIONS(5903),
    [anon_sym_GT_GT_EQ] = ACTIONS(5903),
    [anon_sym_AMP_EQ] = ACTIONS(5903),
    [anon_sym_CARET_EQ] = ACTIONS(5903),
    [anon_sym_PIPE_EQ] = ACTIONS(5903),
    [anon_sym_and_eq] = ACTIONS(5903),
    [anon_sym_or_eq] = ACTIONS(5903),
    [anon_sym_xor_eq] = ACTIONS(5903),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2345] = {
    [sym_decltype_auto] = STATE(2460),
    [sym_identifier] = ACTIONS(5171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5173),
    [anon_sym_COMMA] = ACTIONS(5173),
    [anon_sym_RPAREN] = ACTIONS(5173),
    [aux_sym_preproc_if_token2] = ACTIONS(5173),
    [aux_sym_preproc_else_token1] = ACTIONS(5173),
    [aux_sym_preproc_elif_token1] = ACTIONS(5171),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5173),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5173),
    [anon_sym_LPAREN2] = ACTIONS(5173),
    [anon_sym_DASH] = ACTIONS(5171),
    [anon_sym_PLUS] = ACTIONS(5171),
    [anon_sym_STAR] = ACTIONS(5171),
    [anon_sym_SLASH] = ACTIONS(5171),
    [anon_sym_PERCENT] = ACTIONS(5171),
    [anon_sym_PIPE_PIPE] = ACTIONS(5173),
    [anon_sym_AMP_AMP] = ACTIONS(5173),
    [anon_sym_PIPE] = ACTIONS(5171),
    [anon_sym_CARET] = ACTIONS(5171),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_EQ_EQ] = ACTIONS(5173),
    [anon_sym_BANG_EQ] = ACTIONS(5173),
    [anon_sym_GT] = ACTIONS(5171),
    [anon_sym_GT_EQ] = ACTIONS(5173),
    [anon_sym_LT_EQ] = ACTIONS(5171),
    [anon_sym_LT] = ACTIONS(5171),
    [anon_sym_LT_LT] = ACTIONS(5171),
    [anon_sym_GT_GT] = ACTIONS(5171),
    [anon_sym_SEMI] = ACTIONS(5173),
    [anon_sym___attribute__] = ACTIONS(5171),
    [anon_sym_LBRACE] = ACTIONS(5173),
    [anon_sym_RBRACE] = ACTIONS(5173),
    [anon_sym_LBRACK] = ACTIONS(5173),
    [anon_sym_RBRACK] = ACTIONS(5173),
    [anon_sym_EQ] = ACTIONS(5171),
    [anon_sym_COLON] = ACTIONS(5173),
    [anon_sym_QMARK] = ACTIONS(5173),
    [anon_sym_STAR_EQ] = ACTIONS(5173),
    [anon_sym_SLASH_EQ] = ACTIONS(5173),
    [anon_sym_PERCENT_EQ] = ACTIONS(5173),
    [anon_sym_PLUS_EQ] = ACTIONS(5173),
    [anon_sym_DASH_EQ] = ACTIONS(5173),
    [anon_sym_LT_LT_EQ] = ACTIONS(5173),
    [anon_sym_GT_GT_EQ] = ACTIONS(5173),
    [anon_sym_AMP_EQ] = ACTIONS(5173),
    [anon_sym_CARET_EQ] = ACTIONS(5173),
    [anon_sym_PIPE_EQ] = ACTIONS(5173),
    [anon_sym_and_eq] = ACTIONS(5171),
    [anon_sym_or_eq] = ACTIONS(5171),
    [anon_sym_xor_eq] = ACTIONS(5171),
    [anon_sym_LT_EQ_GT] = ACTIONS(5173),
    [anon_sym_or] = ACTIONS(5171),
    [anon_sym_and] = ACTIONS(5171),
    [anon_sym_bitor] = ACTIONS(5171),
    [anon_sym_xor] = ACTIONS(5171),
    [anon_sym_bitand] = ACTIONS(5171),
    [anon_sym_not_eq] = ACTIONS(5171),
    [anon_sym_DASH_DASH] = ACTIONS(5173),
    [anon_sym_PLUS_PLUS] = ACTIONS(5173),
    [anon_sym_DOT] = ACTIONS(5171),
    [anon_sym_DOT_STAR] = ACTIONS(5173),
    [anon_sym_DASH_GT] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5648),
    [anon_sym_decltype] = ACTIONS(5650),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5173),
  },
  [2346] = {
    [sym_attribute_declaration] = STATE(2388),
    [sym_parameter_list] = STATE(2456),
    [aux_sym_attributed_declarator_repeat1] = STATE(2388),
    [sym_identifier] = ACTIONS(5905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5907),
    [anon_sym_COMMA] = ACTIONS(5907),
    [anon_sym_RPAREN] = ACTIONS(5907),
    [aux_sym_preproc_if_token2] = ACTIONS(5907),
    [aux_sym_preproc_else_token1] = ACTIONS(5907),
    [aux_sym_preproc_elif_token1] = ACTIONS(5905),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5907),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5907),
    [anon_sym_LPAREN2] = ACTIONS(5835),
    [anon_sym_DASH] = ACTIONS(5905),
    [anon_sym_PLUS] = ACTIONS(5905),
    [anon_sym_STAR] = ACTIONS(5905),
    [anon_sym_SLASH] = ACTIONS(5905),
    [anon_sym_PERCENT] = ACTIONS(5905),
    [anon_sym_PIPE_PIPE] = ACTIONS(5907),
    [anon_sym_AMP_AMP] = ACTIONS(5907),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_CARET] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5905),
    [anon_sym_EQ_EQ] = ACTIONS(5907),
    [anon_sym_BANG_EQ] = ACTIONS(5907),
    [anon_sym_GT] = ACTIONS(5905),
    [anon_sym_GT_EQ] = ACTIONS(5907),
    [anon_sym_LT_EQ] = ACTIONS(5905),
    [anon_sym_LT] = ACTIONS(5905),
    [anon_sym_LT_LT] = ACTIONS(5905),
    [anon_sym_GT_GT] = ACTIONS(5905),
    [anon_sym_SEMI] = ACTIONS(5907),
    [anon_sym___attribute__] = ACTIONS(5905),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5837),
    [anon_sym_RBRACE] = ACTIONS(5907),
    [anon_sym_LBRACK] = ACTIONS(5839),
    [anon_sym_RBRACK] = ACTIONS(5907),
    [anon_sym_EQ] = ACTIONS(5905),
    [anon_sym_COLON] = ACTIONS(5907),
    [anon_sym_QMARK] = ACTIONS(5907),
    [anon_sym_STAR_EQ] = ACTIONS(5907),
    [anon_sym_SLASH_EQ] = ACTIONS(5907),
    [anon_sym_PERCENT_EQ] = ACTIONS(5907),
    [anon_sym_PLUS_EQ] = ACTIONS(5907),
    [anon_sym_DASH_EQ] = ACTIONS(5907),
    [anon_sym_LT_LT_EQ] = ACTIONS(5907),
    [anon_sym_GT_GT_EQ] = ACTIONS(5907),
    [anon_sym_AMP_EQ] = ACTIONS(5907),
    [anon_sym_CARET_EQ] = ACTIONS(5907),
    [anon_sym_PIPE_EQ] = ACTIONS(5907),
    [anon_sym_and_eq] = ACTIONS(5905),
    [anon_sym_or_eq] = ACTIONS(5905),
    [anon_sym_xor_eq] = ACTIONS(5905),
    [anon_sym_LT_EQ_GT] = ACTIONS(5907),
    [anon_sym_or] = ACTIONS(5905),
    [anon_sym_and] = ACTIONS(5905),
    [anon_sym_bitor] = ACTIONS(5905),
    [anon_sym_xor] = ACTIONS(5905),
    [anon_sym_bitand] = ACTIONS(5905),
    [anon_sym_not_eq] = ACTIONS(5905),
    [anon_sym_DASH_DASH] = ACTIONS(5907),
    [anon_sym_PLUS_PLUS] = ACTIONS(5907),
    [anon_sym_DOT] = ACTIONS(5905),
    [anon_sym_DOT_STAR] = ACTIONS(5907),
    [anon_sym_DASH_GT] = ACTIONS(5907),
    [sym_comment] = ACTIONS(3),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5907),
  },
  [2347] = {
    [sym_string_literal] = STATE(2357),
    [sym_raw_string_literal] = STATE(2357),
    [aux_sym_concatenated_string_repeat1] = STATE(2357),
    [sym_identifier] = ACTIONS(5909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5346),
    [anon_sym_COMMA] = ACTIONS(5346),
    [anon_sym_LPAREN2] = ACTIONS(5346),
    [anon_sym_DASH] = ACTIONS(5348),
    [anon_sym_PLUS] = ACTIONS(5348),
    [anon_sym_STAR] = ACTIONS(5348),
    [anon_sym_SLASH] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [anon_sym_PIPE_PIPE] = ACTIONS(5346),
    [anon_sym_AMP_AMP] = ACTIONS(5346),
    [anon_sym_PIPE] = ACTIONS(5348),
    [anon_sym_CARET] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5348),
    [anon_sym_EQ_EQ] = ACTIONS(5346),
    [anon_sym_BANG_EQ] = ACTIONS(5346),
    [anon_sym_GT] = ACTIONS(5348),
    [anon_sym_GT_EQ] = ACTIONS(5346),
    [anon_sym_LT_EQ] = ACTIONS(5348),
    [anon_sym_LT] = ACTIONS(5348),
    [anon_sym_LT_LT] = ACTIONS(5348),
    [anon_sym_GT_GT] = ACTIONS(5348),
    [anon_sym_LBRACK] = ACTIONS(5346),
    [anon_sym_EQ] = ACTIONS(5348),
    [anon_sym_QMARK] = ACTIONS(5346),
    [anon_sym_STAR_EQ] = ACTIONS(5346),
    [anon_sym_SLASH_EQ] = ACTIONS(5346),
    [anon_sym_PERCENT_EQ] = ACTIONS(5346),
    [anon_sym_PLUS_EQ] = ACTIONS(5346),
    [anon_sym_DASH_EQ] = ACTIONS(5346),
    [anon_sym_LT_LT_EQ] = ACTIONS(5346),
    [anon_sym_GT_GT_EQ] = ACTIONS(5346),
    [anon_sym_AMP_EQ] = ACTIONS(5346),
    [anon_sym_CARET_EQ] = ACTIONS(5346),
    [anon_sym_PIPE_EQ] = ACTIONS(5346),
    [anon_sym_and_eq] = ACTIONS(5348),
    [anon_sym_or_eq] = ACTIONS(5348),
    [anon_sym_xor_eq] = ACTIONS(5348),
    [anon_sym_LT_EQ_GT] = ACTIONS(5346),
    [anon_sym_or] = ACTIONS(5348),
    [anon_sym_and] = ACTIONS(5348),
    [anon_sym_bitor] = ACTIONS(5348),
    [anon_sym_xor] = ACTIONS(5348),
    [anon_sym_bitand] = ACTIONS(5348),
    [anon_sym_not_eq] = ACTIONS(5348),
    [anon_sym_DASH_DASH] = ACTIONS(5346),
    [anon_sym_PLUS_PLUS] = ACTIONS(5346),
    [anon_sym_DOT] = ACTIONS(5348),
    [anon_sym_DOT_STAR] = ACTIONS(5346),
    [anon_sym_DASH_GT] = ACTIONS(5346),
    [anon_sym_L_DQUOTE] = ACTIONS(5863),
    [anon_sym_u_DQUOTE] = ACTIONS(5863),
    [anon_sym_U_DQUOTE] = ACTIONS(5863),
    [anon_sym_u8_DQUOTE] = ACTIONS(5863),
    [anon_sym_DQUOTE] = ACTIONS(5863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5865),
    [anon_sym_LR_DQUOTE] = ACTIONS(5865),
    [anon_sym_uR_DQUOTE] = ACTIONS(5865),
    [anon_sym_UR_DQUOTE] = ACTIONS(5865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5865),
    [sym_literal_suffix] = ACTIONS(5348),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5346),
    [aux_sym_kernel_call_syntax_token2] = ACTIONS(5346),
  },
  [2348] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5464),
    [anon_sym_COMMA] = ACTIONS(5464),
    [anon_sym_RPAREN] = ACTIONS(5464),
    [anon_sym_LPAREN2] = ACTIONS(5464),
    [anon_sym_DASH] = ACTIONS(5462),
    [anon_sym_PLUS] = ACTIONS(5462),
    [anon_sym_STAR] = ACTIONS(5462),
    [anon_sym_SLASH] = ACTIONS(5462),
    [anon_sym_PERCENT] = ACTIONS(5462),
    [anon_sym_PIPE_PIPE] = ACTIONS(5464),
    [anon_sym_AMP_AMP] = ACTIONS(5464),
    [anon_sym_PIPE] = ACTIONS(5462),
    [anon_sym_CARET] = ACTIONS(5462),
    [anon_sym_AMP] = ACTIONS(5462),
    [anon_sym_EQ_EQ] = ACTIONS(5464),
    [anon_sym_BANG_EQ] = ACTIONS(5464),
    [anon_sym_GT] = ACTIONS(5462),
    [anon_sym_GT_EQ] = ACTIONS(5464),
    [anon_sym_LT_EQ] = ACTIONS(5462),
    [anon_sym_LT] = ACTIONS(5462),
    [anon_sym_LT_LT] = ACTIONS(5462),
    [anon_sym_GT_GT] = ACTIONS(5462),
    [anon_sym_SEMI] = ACTIONS(5464),
    [anon_sym_RBRACE] = ACTIONS(5464),
    [anon_sym_LBRACK] = ACTIONS(5464),
    [anon_sym_RBRACK] = ACTIONS(5464),
    [anon_sym_EQ] = ACTIONS(5462),
    [anon_sym_COLON] = ACTIONS(5464),
    [anon_sym_QMARK] = ACTIONS(5464),
    [anon_sym_STAR_EQ] = ACTIONS(5464),
    [anon_sym_SLASH_EQ] = ACTIONS(5464),
    [anon_sym_PERCENT_EQ] = ACTIONS(5464),
    [anon_sym_PLUS_EQ] = ACTIONS(5464),
    [anon_sym_DASH_EQ] = ACTIONS(5464),
    [anon_sym_LT_LT_EQ] = ACTIONS(5464),
    [anon_sym_GT_GT_EQ] = ACTIONS(5464),
    [anon_sym_AMP_EQ] = ACTIONS(5464),
    [anon_sym_CARET_EQ] = ACTIONS(5464),
    [anon_sym_PIPE_EQ] = ACTIONS(5464),
    [anon_sym_and_eq] = ACTIONS(5462),
    [anon_sym_or_eq] = ACTIONS(5462),
    [anon_sym_xor_eq] = ACTIONS(5462),
    [anon_sym_LT_EQ_GT] = ACTIONS(5464),
    [anon_sym_or] = ACTIONS(5462),
    [anon_sym_and] = ACTIONS(5462),
    [anon_sym_bitor] = ACTIONS(5462),
    [anon_sym_xor] = ACTIONS(5462),
    [anon_sym_bitand] = ACTIONS(5462),
    [anon_sym_not_eq] = ACTIONS(5462),
    [anon_sym_DASH_DASH] = ACTIONS(5464),
    [anon_sym_PLUS_PLUS] = ACTIONS(5464),
    [anon_sym_DOT] = ACTIONS(5462),
    [anon_sym_DOT_STAR] = ACTIONS(5464),
    [anon_sym_DASH_GT] = ACTIONS(5464),
    [anon_sym_L_DQUOTE] = ACTIONS(5464),
    [anon_sym_u_DQUOTE] = ACTIONS(5464),
    [anon_sym_U_DQUOTE] = ACTIONS(5464),
    [anon_sym_u8_DQUOTE] = ACTIONS(5464),
    [anon_sym_DQUOTE] = ACTIONS(5464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5464),
    [anon_sym_LR_DQUOTE] = ACTIONS(5464),
    [anon_sym_uR_DQUOTE] = ACTIONS(5464),
    [anon_sym_UR_DQUOTE] = ACTIONS(5464),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5464),
    [sym_literal_suffix] = ACTIONS(5462),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5464),
  },
  [2349] = {
    [sym_string_literal] = STATE(2320),
    [sym_raw_string_literal] = STATE(2320),
    [aux_sym_concatenated_string_repeat1] = STATE(2320),
    [sym_identifier] = ACTIONS(5911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5307),
    [anon_sym_COMMA] = ACTIONS(5307),
    [anon_sym_LPAREN2] = ACTIONS(5307),
    [anon_sym_DASH] = ACTIONS(5309),
    [anon_sym_PLUS] = ACTIONS(5309),
    [anon_sym_STAR] = ACTIONS(5309),
    [anon_sym_SLASH] = ACTIONS(5309),
    [anon_sym_PERCENT] = ACTIONS(5309),
    [anon_sym_PIPE_PIPE] = ACTIONS(5307),
    [anon_sym_AMP_AMP] = ACTIONS(5307),
    [anon_sym_PIPE] = ACTIONS(5309),
    [anon_sym_CARET] = ACTIONS(5309),
    [anon_sym_AMP] = ACTIONS(5309),
    [anon_sym_EQ_EQ] = ACTIONS(5307),
    [anon_sym_BANG_EQ] = ACTIONS(5307),
    [anon_sym_GT] = ACTIONS(5309),
    [anon_sym_GT_EQ] = ACTIONS(5309),
    [anon_sym_LT_EQ] = ACTIONS(5309),
    [anon_sym_LT] = ACTIONS(5309),
    [anon_sym_LT_LT] = ACTIONS(5309),
    [anon_sym_GT_GT] = ACTIONS(5309),
    [anon_sym_LBRACK] = ACTIONS(5307),
    [anon_sym_EQ] = ACTIONS(5309),
    [anon_sym_QMARK] = ACTIONS(5307),
    [anon_sym_STAR_EQ] = ACTIONS(5307),
    [anon_sym_SLASH_EQ] = ACTIONS(5307),
    [anon_sym_PERCENT_EQ] = ACTIONS(5307),
    [anon_sym_PLUS_EQ] = ACTIONS(5307),
    [anon_sym_DASH_EQ] = ACTIONS(5307),
    [anon_sym_LT_LT_EQ] = ACTIONS(5307),
    [anon_sym_GT_GT_EQ] = ACTIONS(5309),
    [anon_sym_AMP_EQ] = ACTIONS(5307),
    [anon_sym_CARET_EQ] = ACTIONS(5307),
    [anon_sym_PIPE_EQ] = ACTIONS(5307),
    [anon_sym_and_eq] = ACTIONS(5309),
    [anon_sym_or_eq] = ACTIONS(5309),
    [anon_sym_xor_eq] = ACTIONS(5309),
    [anon_sym_LT_EQ_GT] = ACTIONS(5307),
    [anon_sym_or] = ACTIONS(5309),
    [anon_sym_and] = ACTIONS(5309),
    [anon_sym_bitor] = ACTIONS(5309),
    [anon_sym_xor] = ACTIONS(5309),
    [anon_sym_bitand] = ACTIONS(5309),
    [anon_sym_not_eq] = ACTIONS(5309),
    [anon_sym_DASH_DASH] = ACTIONS(5307),
    [anon_sym_PLUS_PLUS] = ACTIONS(5307),
    [anon_sym_DOT] = ACTIONS(5309),
    [anon_sym_DOT_STAR] = ACTIONS(5307),
    [anon_sym_DASH_GT] = ACTIONS(5307),
    [anon_sym_L_DQUOTE] = ACTIONS(5893),
    [anon_sym_u_DQUOTE] = ACTIONS(5893),
    [anon_sym_U_DQUOTE] = ACTIONS(5893),
    [anon_sym_u8_DQUOTE] = ACTIONS(5893),
    [anon_sym_DQUOTE] = ACTIONS(5893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(5307),
    [anon_sym_R_DQUOTE] = ACTIONS(5895),
    [anon_sym_LR_DQUOTE] = ACTIONS(5895),
    [anon_sym_uR_DQUOTE] = ACTIONS(5895),
    [anon_sym_UR_DQUOTE] = ACTIONS(5895),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5895),
    [sym_literal_suffix] = ACTIONS(5309),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5307),
  },
  [2350] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3990),
    [anon_sym_COMMA] = ACTIONS(3990),
    [anon_sym_LPAREN2] = ACTIONS(3990),
    [anon_sym_DASH] = ACTIONS(3988),
    [anon_sym_PLUS] = ACTIONS(3988),
    [anon_sym_STAR] = ACTIONS(3990),
    [anon_sym_SLASH] = ACTIONS(3988),
    [anon_sym_PERCENT] = ACTIONS(3990),
    [anon_sym_PIPE_PIPE] = ACTIONS(3990),
    [anon_sym_AMP_AMP] = ACTIONS(3990),
    [anon_sym_PIPE] = ACTIONS(3988),
    [anon_sym_CARET] = ACTIONS(3990),
    [anon_sym_AMP] = ACTIONS(3988),
    [anon_sym_EQ_EQ] = ACTIONS(3990),
    [anon_sym_BANG_EQ] = ACTIONS(3990),
    [anon_sym_GT] = ACTIONS(3988),
    [anon_sym_GT_EQ] = ACTIONS(3988),
    [anon_sym_LT_EQ] = ACTIONS(3988),
    [anon_sym_LT] = ACTIONS(3988),
    [anon_sym_LT_LT] = ACTIONS(3988),
    [anon_sym_GT_GT] = ACTIONS(3988),
    [anon_sym___extension__] = ACTIONS(3990),
    [anon_sym___global__] = ACTIONS(3990),
    [anon_sym___attribute__] = ACTIONS(3990),
    [anon_sym_COLON_COLON] = ACTIONS(3990),
    [anon_sym_LBRACE] = ACTIONS(3990),
    [anon_sym_LBRACK] = ACTIONS(3990),
    [anon_sym_const] = ACTIONS(3988),
    [anon_sym_constexpr] = ACTIONS(3990),
    [anon_sym_volatile] = ACTIONS(3990),
    [anon_sym_restrict] = ACTIONS(3990),
    [anon_sym___restrict__] = ACTIONS(3990),
    [anon_sym__Atomic] = ACTIONS(3990),
    [anon_sym__Noreturn] = ACTIONS(3990),
    [anon_sym_noreturn] = ACTIONS(3990),
    [anon_sym_mutable] = ACTIONS(3990),
    [anon_sym_constinit] = ACTIONS(3990),
    [anon_sym_consteval] = ACTIONS(3990),
    [anon_sym___shared__] = ACTIONS(3990),
    [anon_sym___local__] = ACTIONS(3990),
    [anon_sym___constant__] = ACTIONS(3990),
    [anon_sym___managed__] = ACTIONS(3990),
    [anon_sym___grid_constant__] = ACTIONS(3990),
    [anon_sym_alignas] = ACTIONS(3990),
    [anon_sym__Alignas] = ACTIONS(3990),
    [anon_sym_COLON] = ACTIONS(3988),
    [anon_sym_QMARK] = ACTIONS(3990),
    [anon_sym_LT_EQ_GT] = ACTIONS(3990),
    [anon_sym_or] = ACTIONS(3990),
    [anon_sym_and] = ACTIONS(3990),
    [anon_sym_bitor] = ACTIONS(3990),
    [anon_sym_xor] = ACTIONS(3990),
    [anon_sym_bitand] = ACTIONS(3990),
    [anon_sym_not_eq] = ACTIONS(3990),
    [anon_sym_DASH_DASH] = ACTIONS(3990),
    [anon_sym_PLUS_PLUS] = ACTIONS(3990),
    [anon_sym_DOT] = ACTIONS(3988),
    [anon_sym_DOT_STAR] = ACTIONS(3990),
    [anon_sym_DASH_GT] = ACTIONS(3990),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3990),
    [anon_sym_decltype] = ACTIONS(3990),
    [anon_sym_final] = ACTIONS(3990),
    [anon_sym_override] = ACTIONS(3990),
    [anon_sym_GT2] = ACTIONS(3990),
    [anon_sym_requires] = ACTIONS(3990),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3990),
  },
  [2351] = {
    [sym_attribute_specifier] = STATE(2429),
    [sym_identifier] = ACTIONS(5727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5725),
    [anon_sym_COMMA] = ACTIONS(5725),
    [anon_sym_RPAREN] = ACTIONS(5725),
    [aux_sym_preproc_if_token2] = ACTIONS(5725),
    [aux_sym_preproc_else_token1] = ACTIONS(5725),
    [aux_sym_preproc_elif_token1] = ACTIONS(5727),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5725),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5725),
    [anon_sym_LPAREN2] = ACTIONS(5725),
    [anon_sym_DASH] = ACTIONS(5727),
    [anon_sym_PLUS] = ACTIONS(5727),
    [anon_sym_STAR] = ACTIONS(5727),
    [anon_sym_SLASH] = ACTIONS(5727),
    [anon_sym_PERCENT] = ACTIONS(5727),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_CARET] = ACTIONS(5727),
    [anon_sym_AMP] = ACTIONS(5727),
    [anon_sym_EQ_EQ] = ACTIONS(5725),
    [anon_sym_BANG_EQ] = ACTIONS(5725),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_EQ] = ACTIONS(5725),
    [anon_sym_LT_EQ] = ACTIONS(5727),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5727),
    [anon_sym_SEMI] = ACTIONS(5725),
    [anon_sym___attribute__] = ACTIONS(5546),
    [anon_sym_LBRACE] = ACTIONS(5725),
    [anon_sym_RBRACE] = ACTIONS(5725),
    [anon_sym_LBRACK] = ACTIONS(5725),
    [anon_sym_RBRACK] = ACTIONS(5725),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_COLON] = ACTIONS(5725),
    [anon_sym_QMARK] = ACTIONS(5725),
    [anon_sym_STAR_EQ] = ACTIONS(5725),
    [anon_sym_SLASH_EQ] = ACTIONS(5725),
    [anon_sym_PERCENT_EQ] = ACTIONS(5725),
    [anon_sym_PLUS_EQ] = ACTIONS(5725),
    [anon_sym_DASH_EQ] = ACTIONS(5725),
    [anon_sym_LT_LT_EQ] = ACTIONS(5725),
    [anon_sym_GT_GT_EQ] = ACTIONS(5725),
    [anon_sym_AMP_EQ] = ACTIONS(5725),
    [anon_sym_CARET_EQ] = ACTIONS(5725),
    [anon_sym_PIPE_EQ] = ACTIONS(5725),
    [anon_sym_and_eq] = ACTIONS(5727),
    [anon_sym_or_eq] = ACTIONS(5727),
    [anon_sym_xor_eq] = ACTIONS(5727),
    [anon_sym_LT_EQ_GT] = ACTIONS(5725),
    [anon_sym_or] = ACTIONS(5727),
    [anon_sym_and] = ACTIONS(5727),
    [anon_sym_bitor] = ACTIONS(5727),
    [anon_sym_xor] = ACTIONS(5727),
    [anon_sym_bitand] = ACTIONS(5727),
    [anon_sym_not_eq] = ACTIONS(5727),
    [anon_sym_DASH_DASH] = ACTIONS(5725),
    [anon_sym_PLUS_PLUS] = ACTIONS(5725),
    [anon_sym_DOT] = ACTIONS(5727),
    [anon_sym_DOT_STAR] = ACTIONS(5725),
    [anon_sym_DASH_GT] = ACTIONS(5725),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5727),
    [anon_sym_decltype] = ACTIONS(5727),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5725),
  },
  [2352] = {
    [sym_attribute_specifier] = STATE(2424),
    [sym_identifier] = ACTIONS(5658),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5656),
    [anon_sym_COMMA] = ACTIONS(5656),
    [anon_sym_RPAREN] = ACTIONS(5656),
    [aux_sym_preproc_if_token2] = ACTIONS(5656),
    [aux_sym_preproc_else_token1] = ACTIONS(5656),
    [aux_sym_preproc_elif_token1] = ACTIONS(5658),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5656),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5656),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_DASH] = ACTIONS(5658),
    [anon_sym_PLUS] = ACTIONS(5658),
    [anon_sym_STAR] = ACTIONS(5658),
    [anon_sym_SLASH] = ACTIONS(5658),
    [anon_sym_PERCENT] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_PIPE] = ACTIONS(5658),
    [anon_sym_CARET] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_EQ_EQ] = ACTIONS(5656),
    [anon_sym_BANG_EQ] = ACTIONS(5656),
    [anon_sym_GT] = ACTIONS(5658),
    [anon_sym_GT_EQ] = ACTIONS(5656),
    [anon_sym_LT_EQ] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5658),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5656),
    [anon_sym___attribute__] = ACTIONS(5546),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_RBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [anon_sym_RBRACK] = ACTIONS(5656),
    [anon_sym_EQ] = ACTIONS(5658),
    [anon_sym_COLON] = ACTIONS(5656),
    [anon_sym_QMARK] = ACTIONS(5656),
    [anon_sym_STAR_EQ] = ACTIONS(5656),
    [anon_sym_SLASH_EQ] = ACTIONS(5656),
    [anon_sym_PERCENT_EQ] = ACTIONS(5656),
    [anon_sym_PLUS_EQ] = ACTIONS(5656),
    [anon_sym_DASH_EQ] = ACTIONS(5656),
    [anon_sym_LT_LT_EQ] = ACTIONS(5656),
    [anon_sym_GT_GT_EQ] = ACTIONS(5656),
    [anon_sym_AMP_EQ] = ACTIONS(5656),
    [anon_sym_CARET_EQ] = ACTIONS(5656),
    [anon_sym_PIPE_EQ] = ACTIONS(5656),
    [anon_sym_and_eq] = ACTIONS(5658),
    [anon_sym_or_eq] = ACTIONS(5658),
    [anon_sym_xor_eq] = ACTIONS(5658),
    [anon_sym_LT_EQ_GT] = ACTIONS(5656),
    [anon_sym_or] = ACTIONS(5658),
    [anon_sym_and] = ACTIONS(5658),
    [anon_sym_bitor] = ACTIONS(5658),
    [anon_sym_xor] = ACTIONS(5658),
    [anon_sym_bitand] = ACTIONS(5658),
    [anon_sym_not_eq] = ACTIONS(5658),
    [anon_sym_DASH_DASH] = ACTIONS(5656),
    [anon_sym_PLUS_PLUS] = ACTIONS(5656),
    [anon_sym_DOT] = ACTIONS(5658),
    [anon_sym_DOT_STAR] = ACTIONS(5656),
    [anon_sym_DASH_GT] = ACTIONS(5656),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5658),
    [anon_sym_decltype] = ACTIONS(5658),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5656),
  },
  [2353] = {
    [sym_attribute_specifier] = STATE(2579),
    [sym_enumerator_list] = STATE(2434),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5610),
    [anon_sym_COMMA] = ACTIONS(5610),
    [anon_sym_LPAREN2] = ACTIONS(5610),
    [anon_sym_DASH] = ACTIONS(5612),
    [anon_sym_PLUS] = ACTIONS(5612),
    [anon_sym_STAR] = ACTIONS(5610),
    [anon_sym_SLASH] = ACTIONS(5612),
    [anon_sym_PERCENT] = ACTIONS(5610),
    [anon_sym_PIPE_PIPE] = ACTIONS(5610),
    [anon_sym_AMP_AMP] = ACTIONS(5610),
    [anon_sym_PIPE] = ACTIONS(5612),
    [anon_sym_CARET] = ACTIONS(5610),
    [anon_sym_AMP] = ACTIONS(5612),
    [anon_sym_EQ_EQ] = ACTIONS(5610),
    [anon_sym_BANG_EQ] = ACTIONS(5610),
    [anon_sym_GT] = ACTIONS(5612),
    [anon_sym_GT_EQ] = ACTIONS(5612),
    [anon_sym_LT_EQ] = ACTIONS(5612),
    [anon_sym_LT] = ACTIONS(5612),
    [anon_sym_LT_LT] = ACTIONS(5612),
    [anon_sym_GT_GT] = ACTIONS(5612),
    [anon_sym___extension__] = ACTIONS(5610),
    [anon_sym___global__] = ACTIONS(5610),
    [anon_sym___attribute__] = ACTIONS(5652),
    [anon_sym_LBRACE] = ACTIONS(5913),
    [anon_sym_LBRACK] = ACTIONS(5610),
    [anon_sym_const] = ACTIONS(5612),
    [anon_sym_constexpr] = ACTIONS(5610),
    [anon_sym_volatile] = ACTIONS(5610),
    [anon_sym_restrict] = ACTIONS(5610),
    [anon_sym___restrict__] = ACTIONS(5610),
    [anon_sym__Atomic] = ACTIONS(5610),
    [anon_sym__Noreturn] = ACTIONS(5610),
    [anon_sym_noreturn] = ACTIONS(5610),
    [anon_sym_mutable] = ACTIONS(5610),
    [anon_sym_constinit] = ACTIONS(5610),
    [anon_sym_consteval] = ACTIONS(5610),
    [anon_sym___shared__] = ACTIONS(5610),
    [anon_sym___local__] = ACTIONS(5610),
    [anon_sym___constant__] = ACTIONS(5610),
    [anon_sym___managed__] = ACTIONS(5610),
    [anon_sym___grid_constant__] = ACTIONS(5610),
    [anon_sym_alignas] = ACTIONS(5610),
    [anon_sym__Alignas] = ACTIONS(5610),
    [anon_sym_QMARK] = ACTIONS(5610),
    [anon_sym_LT_EQ_GT] = ACTIONS(5610),
    [anon_sym_or] = ACTIONS(5610),
    [anon_sym_and] = ACTIONS(5610),
    [anon_sym_bitor] = ACTIONS(5610),
    [anon_sym_xor] = ACTIONS(5610),
    [anon_sym_bitand] = ACTIONS(5610),
    [anon_sym_not_eq] = ACTIONS(5610),
    [anon_sym_DASH_DASH] = ACTIONS(5610),
    [anon_sym_PLUS_PLUS] = ACTIONS(5610),
    [anon_sym_DOT] = ACTIONS(5612),
    [anon_sym_DOT_STAR] = ACTIONS(5610),
    [anon_sym_DASH_GT] = ACTIONS(5610),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5610),
    [anon_sym_decltype] = ACTIONS(5610),
    [anon_sym_final] = ACTIONS(5610),
    [anon_sym_override] = ACTIONS(5610),
    [anon_sym_GT2] = ACTIONS(5610),
    [anon_sym_requires] = ACTIONS(5610),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5610),
  },
  [2354] = {
    [sym_attribute_specifier] = STATE(2417),
    [sym_identifier] = ACTIONS(5676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5674),
    [anon_sym_COMMA] = ACTIONS(5674),
    [anon_sym_RPAREN] = ACTIONS(5674),
    [aux_sym_preproc_if_token2] = ACTIONS(5674),
    [aux_sym_preproc_else_token1] = ACTIONS(5674),
    [aux_sym_preproc_elif_token1] = ACTIONS(5676),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5674),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5674),
    [anon_sym_LPAREN2] = ACTIONS(5674),
    [anon_sym_DASH] = ACTIONS(5676),
    [anon_sym_PLUS] = ACTIONS(5676),
    [anon_sym_STAR] = ACTIONS(5676),
    [anon_sym_SLASH] = ACTIONS(5676),
    [anon_sym_PERCENT] = ACTIONS(5676),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_CARET] = ACTIONS(5676),
    [anon_sym_AMP] = ACTIONS(5676),
    [anon_sym_EQ_EQ] = ACTIONS(5674),
    [anon_sym_BANG_EQ] = ACTIONS(5674),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_EQ] = ACTIONS(5674),
    [anon_sym_LT_EQ] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5676),
    [anon_sym_SEMI] = ACTIONS(5674),
    [anon_sym___attribute__] = ACTIONS(5546),
    [anon_sym_LBRACE] = ACTIONS(5674),
    [anon_sym_RBRACE] = ACTIONS(5674),
    [anon_sym_LBRACK] = ACTIONS(5674),
    [anon_sym_RBRACK] = ACTIONS(5674),
    [anon_sym_EQ] = ACTIONS(5676),
    [anon_sym_COLON] = ACTIONS(5674),
    [anon_sym_QMARK] = ACTIONS(5674),
    [anon_sym_STAR_EQ] = ACTIONS(5674),
    [anon_sym_SLASH_EQ] = ACTIONS(5674),
    [anon_sym_PERCENT_EQ] = ACTIONS(5674),
    [anon_sym_PLUS_EQ] = ACTIONS(5674),
    [anon_sym_DASH_EQ] = ACTIONS(5674),
    [anon_sym_LT_LT_EQ] = ACTIONS(5674),
    [anon_sym_GT_GT_EQ] = ACTIONS(5674),
    [anon_sym_AMP_EQ] = ACTIONS(5674),
    [anon_sym_CARET_EQ] = ACTIONS(5674),
    [anon_sym_PIPE_EQ] = ACTIONS(5674),
    [anon_sym_and_eq] = ACTIONS(5676),
    [anon_sym_or_eq] = ACTIONS(5676),
    [anon_sym_xor_eq] = ACTIONS(5676),
    [anon_sym_LT_EQ_GT] = ACTIONS(5674),
    [anon_sym_or] = ACTIONS(5676),
    [anon_sym_and] = ACTIONS(5676),
    [anon_sym_bitor] = ACTIONS(5676),
    [anon_sym_xor] = ACTIONS(5676),
    [anon_sym_bitand] = ACTIONS(5676),
    [anon_sym_not_eq] = ACTIONS(5676),
    [anon_sym_DASH_DASH] = ACTIONS(5674),
    [anon_sym_PLUS_PLUS] = ACTIONS(5674),
    [anon_sym_DOT] = ACTIONS(5676),
    [anon_sym_DOT_STAR] = ACTIONS(5674),
    [anon_sym_DASH_GT] = ACTIONS(5674),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5676),
    [anon_sym_decltype] = ACTIONS(5676),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5674),
  },
  [2355] = {
    [sym_template_argument_list] = STATE(1651),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2518),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5532),
    [anon_sym_COMMA] = ACTIONS(5532),
    [anon_sym_RPAREN] = ACTIONS(5532),
    [anon_sym_LPAREN2] = ACTIONS(5532),
    [anon_sym_DASH] = ACTIONS(5530),
    [anon_sym_PLUS] = ACTIONS(5530),
    [anon_sym_STAR] = ACTIONS(5530),
    [anon_sym_SLASH] = ACTIONS(5530),
    [anon_sym_PERCENT] = ACTIONS(5530),
    [anon_sym_PIPE_PIPE] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_PIPE] = ACTIONS(5530),
    [anon_sym_CARET] = ACTIONS(5530),
    [anon_sym_AMP] = ACTIONS(5530),
    [anon_sym_EQ_EQ] = ACTIONS(5532),
    [anon_sym_BANG_EQ] = ACTIONS(5532),
    [anon_sym_GT] = ACTIONS(5530),
    [anon_sym_GT_EQ] = ACTIONS(5532),
    [anon_sym_LT_EQ] = ACTIONS(5530),
    [anon_sym_LT] = ACTIONS(5530),
    [anon_sym_LT_LT] = ACTIONS(5530),
    [anon_sym_GT_GT] = ACTIONS(5530),
    [anon_sym_SEMI] = ACTIONS(5532),
    [anon_sym___attribute__] = ACTIONS(5532),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(5532),
    [anon_sym_RBRACE] = ACTIONS(5532),
    [anon_sym_signed] = ACTIONS(5915),
    [anon_sym_unsigned] = ACTIONS(5915),
    [anon_sym_long] = ACTIONS(5915),
    [anon_sym_short] = ACTIONS(5915),
    [anon_sym_LBRACK] = ACTIONS(5532),
    [anon_sym_RBRACK] = ACTIONS(5532),
    [anon_sym_EQ] = ACTIONS(5530),
    [anon_sym_COLON] = ACTIONS(5530),
    [anon_sym_QMARK] = ACTIONS(5532),
    [anon_sym_STAR_EQ] = ACTIONS(5532),
    [anon_sym_SLASH_EQ] = ACTIONS(5532),
    [anon_sym_PERCENT_EQ] = ACTIONS(5532),
    [anon_sym_PLUS_EQ] = ACTIONS(5532),
    [anon_sym_DASH_EQ] = ACTIONS(5532),
    [anon_sym_LT_LT_EQ] = ACTIONS(5532),
    [anon_sym_GT_GT_EQ] = ACTIONS(5532),
    [anon_sym_AMP_EQ] = ACTIONS(5532),
    [anon_sym_CARET_EQ] = ACTIONS(5532),
    [anon_sym_PIPE_EQ] = ACTIONS(5532),
    [anon_sym_and_eq] = ACTIONS(5532),
    [anon_sym_or_eq] = ACTIONS(5532),
    [anon_sym_xor_eq] = ACTIONS(5532),
    [anon_sym_LT_EQ_GT] = ACTIONS(5532),
    [anon_sym_or] = ACTIONS(5530),
    [anon_sym_and] = ACTIONS(5530),
    [anon_sym_bitor] = ACTIONS(5532),
    [anon_sym_xor] = ACTIONS(5530),
    [anon_sym_bitand] = ACTIONS(5532),
    [anon_sym_not_eq] = ACTIONS(5532),
    [anon_sym_DASH_DASH] = ACTIONS(5532),
    [anon_sym_PLUS_PLUS] = ACTIONS(5532),
    [anon_sym_DOT] = ACTIONS(5530),
    [anon_sym_DOT_STAR] = ACTIONS(5532),
    [anon_sym_DASH_GT] = ACTIONS(5532),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5532),
    [anon_sym_decltype] = ACTIONS(5532),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5532),
  },
  [2356] = {
    [sym_attribute_specifier] = STATE(2203),
    [sym_field_declaration_list] = STATE(2475),
    [sym_virtual_specifier] = STATE(7228),
    [sym_base_class_clause] = STATE(8034),
    [sym_identifier] = ACTIONS(5508),
    [anon_sym_LPAREN2] = ACTIONS(5506),
    [anon_sym_TILDE] = ACTIONS(5506),
    [anon_sym_STAR] = ACTIONS(5506),
    [anon_sym_AMP_AMP] = ACTIONS(5506),
    [anon_sym_AMP] = ACTIONS(5508),
    [anon_sym_SEMI] = ACTIONS(5917),
    [anon_sym___extension__] = ACTIONS(5508),
    [anon_sym___device__] = ACTIONS(5508),
    [anon_sym___host__] = ACTIONS(5508),
    [anon_sym___global__] = ACTIONS(5508),
    [anon_sym___forceinline__] = ACTIONS(5508),
    [anon_sym___noinline__] = ACTIONS(5508),
    [anon_sym_extern] = ACTIONS(5508),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5506),
    [anon_sym___declspec] = ACTIONS(5508),
    [anon_sym___based] = ACTIONS(5508),
    [anon_sym___cdecl] = ACTIONS(5508),
    [anon_sym___clrcall] = ACTIONS(5508),
    [anon_sym___stdcall] = ACTIONS(5508),
    [anon_sym___fastcall] = ACTIONS(5508),
    [anon_sym___thiscall] = ACTIONS(5508),
    [anon_sym___vectorcall] = ACTIONS(5508),
    [anon_sym_LBRACE] = ACTIONS(5580),
    [anon_sym_LBRACK] = ACTIONS(5508),
    [anon_sym_static] = ACTIONS(5508),
    [anon_sym_register] = ACTIONS(5508),
    [anon_sym_inline] = ACTIONS(5508),
    [anon_sym___inline] = ACTIONS(5508),
    [anon_sym___inline__] = ACTIONS(5508),
    [anon_sym___forceinline] = ACTIONS(5508),
    [anon_sym_thread_local] = ACTIONS(5508),
    [anon_sym___thread] = ACTIONS(5508),
    [anon_sym_const] = ACTIONS(5508),
    [anon_sym_constexpr] = ACTIONS(5508),
    [anon_sym_volatile] = ACTIONS(5508),
    [anon_sym_restrict] = ACTIONS(5508),
    [anon_sym___restrict__] = ACTIONS(5508),
    [anon_sym__Atomic] = ACTIONS(5508),
    [anon_sym__Noreturn] = ACTIONS(5508),
    [anon_sym_noreturn] = ACTIONS(5508),
    [anon_sym_mutable] = ACTIONS(5508),
    [anon_sym_constinit] = ACTIONS(5508),
    [anon_sym_consteval] = ACTIONS(5508),
    [anon_sym___shared__] = ACTIONS(5508),
    [anon_sym___local__] = ACTIONS(5508),
    [anon_sym___constant__] = ACTIONS(5508),
    [anon_sym___managed__] = ACTIONS(5508),
    [anon_sym___grid_constant__] = ACTIONS(5508),
    [anon_sym_alignas] = ACTIONS(5508),
    [anon_sym__Alignas] = ACTIONS(5508),
    [anon_sym_COLON] = ACTIONS(5582),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5508),
    [anon_sym_decltype] = ACTIONS(5508),
    [anon_sym_final] = ACTIONS(5550),
    [anon_sym_override] = ACTIONS(5550),
    [sym_virtual] = ACTIONS(5508),
    [anon_sym_template] = ACTIONS(5508),
    [anon_sym_operator] = ACTIONS(5508),
    [anon_sym___launch_bounds__] = ACTIONS(5508),
  },
  [2357] = {
    [sym_string_literal] = STATE(2370),
    [sym_raw_string_literal] = STATE(2370),
    [aux_sym_concatenated_string_repeat1] = STATE(2370),
    [sym_identifier] = ACTIONS(5919),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5307),
    [anon_sym_COMMA] = ACTIONS(5307),
    [anon_sym_LPAREN2] = ACTIONS(5307),
    [anon_sym_DASH] = ACTIONS(5309),
    [anon_sym_PLUS] = ACTIONS(5309),
    [anon_sym_STAR] = ACTIONS(5309),
    [anon_sym_SLASH] = ACTIONS(5309),
    [anon_sym_PERCENT] = ACTIONS(5309),
    [anon_sym_PIPE_PIPE] = ACTIONS(5307),
    [anon_sym_AMP_AMP] = ACTIONS(5307),
    [anon_sym_PIPE] = ACTIONS(5309),
    [anon_sym_CARET] = ACTIONS(5309),
    [anon_sym_AMP] = ACTIONS(5309),
    [anon_sym_EQ_EQ] = ACTIONS(5307),
    [anon_sym_BANG_EQ] = ACTIONS(5307),
    [anon_sym_GT] = ACTIONS(5309),
    [anon_sym_GT_EQ] = ACTIONS(5307),
    [anon_sym_LT_EQ] = ACTIONS(5309),
    [anon_sym_LT] = ACTIONS(5309),
    [anon_sym_LT_LT] = ACTIONS(5309),
    [anon_sym_GT_GT] = ACTIONS(5309),
    [anon_sym_LBRACK] = ACTIONS(5307),
    [anon_sym_EQ] = ACTIONS(5309),
    [anon_sym_QMARK] = ACTIONS(5307),
    [anon_sym_STAR_EQ] = ACTIONS(5307),
    [anon_sym_SLASH_EQ] = ACTIONS(5307),
    [anon_sym_PERCENT_EQ] = ACTIONS(5307),
    [anon_sym_PLUS_EQ] = ACTIONS(5307),
    [anon_sym_DASH_EQ] = ACTIONS(5307),
    [anon_sym_LT_LT_EQ] = ACTIONS(5307),
    [anon_sym_GT_GT_EQ] = ACTIONS(5307),
    [anon_sym_AMP_EQ] = ACTIONS(5307),
    [anon_sym_CARET_EQ] = ACTIONS(5307),
    [anon_sym_PIPE_EQ] = ACTIONS(5307),
    [anon_sym_and_eq] = ACTIONS(5309),
    [anon_sym_or_eq] = ACTIONS(5309),
    [anon_sym_xor_eq] = ACTIONS(5309),
    [anon_sym_LT_EQ_GT] = ACTIONS(5307),
    [anon_sym_or] = ACTIONS(5309),
    [anon_sym_and] = ACTIONS(5309),
    [anon_sym_bitor] = ACTIONS(5309),
    [anon_sym_xor] = ACTIONS(5309),
    [anon_sym_bitand] = ACTIONS(5309),
    [anon_sym_not_eq] = ACTIONS(5309),
    [anon_sym_DASH_DASH] = ACTIONS(5307),
    [anon_sym_PLUS_PLUS] = ACTIONS(5307),
    [anon_sym_DOT] = ACTIONS(5309),
    [anon_sym_DOT_STAR] = ACTIONS(5307),
    [anon_sym_DASH_GT] = ACTIONS(5307),
    [anon_sym_L_DQUOTE] = ACTIONS(5863),
    [anon_sym_u_DQUOTE] = ACTIONS(5863),
    [anon_sym_U_DQUOTE] = ACTIONS(5863),
    [anon_sym_u8_DQUOTE] = ACTIONS(5863),
    [anon_sym_DQUOTE] = ACTIONS(5863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5865),
    [anon_sym_LR_DQUOTE] = ACTIONS(5865),
    [anon_sym_uR_DQUOTE] = ACTIONS(5865),
    [anon_sym_UR_DQUOTE] = ACTIONS(5865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5865),
    [sym_literal_suffix] = ACTIONS(5309),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5307),
    [aux_sym_kernel_call_syntax_token2] = ACTIONS(5307),
  },
  [2358] = {
    [sym_attribute_specifier] = STATE(2199),
    [sym_enumerator_list] = STATE(2481),
    [sym_identifier] = ACTIONS(5612),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5610),
    [anon_sym_COMMA] = ACTIONS(5610),
    [anon_sym_RPAREN] = ACTIONS(5610),
    [anon_sym_LPAREN2] = ACTIONS(5610),
    [anon_sym_TILDE] = ACTIONS(5610),
    [anon_sym_STAR] = ACTIONS(5610),
    [anon_sym_AMP_AMP] = ACTIONS(5610),
    [anon_sym_AMP] = ACTIONS(5612),
    [anon_sym_SEMI] = ACTIONS(5610),
    [anon_sym___extension__] = ACTIONS(5612),
    [anon_sym___device__] = ACTIONS(5612),
    [anon_sym___host__] = ACTIONS(5612),
    [anon_sym___global__] = ACTIONS(5612),
    [anon_sym___forceinline__] = ACTIONS(5612),
    [anon_sym___noinline__] = ACTIONS(5612),
    [anon_sym_extern] = ACTIONS(5612),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5610),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5610),
    [anon_sym___declspec] = ACTIONS(5612),
    [anon_sym___based] = ACTIONS(5612),
    [anon_sym___cdecl] = ACTIONS(5612),
    [anon_sym___clrcall] = ACTIONS(5612),
    [anon_sym___stdcall] = ACTIONS(5612),
    [anon_sym___fastcall] = ACTIONS(5612),
    [anon_sym___thiscall] = ACTIONS(5612),
    [anon_sym___vectorcall] = ACTIONS(5612),
    [anon_sym_LBRACE] = ACTIONS(5921),
    [anon_sym_LBRACK] = ACTIONS(5612),
    [anon_sym_static] = ACTIONS(5612),
    [anon_sym_EQ] = ACTIONS(5610),
    [anon_sym_register] = ACTIONS(5612),
    [anon_sym_inline] = ACTIONS(5612),
    [anon_sym___inline] = ACTIONS(5612),
    [anon_sym___inline__] = ACTIONS(5612),
    [anon_sym___forceinline] = ACTIONS(5612),
    [anon_sym_thread_local] = ACTIONS(5612),
    [anon_sym___thread] = ACTIONS(5612),
    [anon_sym_const] = ACTIONS(5612),
    [anon_sym_constexpr] = ACTIONS(5612),
    [anon_sym_volatile] = ACTIONS(5612),
    [anon_sym_restrict] = ACTIONS(5612),
    [anon_sym___restrict__] = ACTIONS(5612),
    [anon_sym__Atomic] = ACTIONS(5612),
    [anon_sym__Noreturn] = ACTIONS(5612),
    [anon_sym_noreturn] = ACTIONS(5612),
    [anon_sym_mutable] = ACTIONS(5612),
    [anon_sym_constinit] = ACTIONS(5612),
    [anon_sym_consteval] = ACTIONS(5612),
    [anon_sym___shared__] = ACTIONS(5612),
    [anon_sym___local__] = ACTIONS(5612),
    [anon_sym___constant__] = ACTIONS(5612),
    [anon_sym___managed__] = ACTIONS(5612),
    [anon_sym___grid_constant__] = ACTIONS(5612),
    [anon_sym_alignas] = ACTIONS(5612),
    [anon_sym__Alignas] = ACTIONS(5612),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5612),
    [anon_sym_decltype] = ACTIONS(5612),
    [sym_virtual] = ACTIONS(5612),
    [anon_sym_template] = ACTIONS(5612),
    [anon_sym_GT2] = ACTIONS(5610),
    [anon_sym_operator] = ACTIONS(5612),
    [anon_sym___launch_bounds__] = ACTIONS(5612),
  },
  [2359] = {
    [sym_string_literal] = STATE(2752),
    [sym_template_argument_list] = STATE(4108),
    [sym_raw_string_literal] = STATE(2752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(4850),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_RBRACK] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(5804),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(5806),
    [anon_sym_SLASH_EQ] = ACTIONS(5806),
    [anon_sym_PERCENT_EQ] = ACTIONS(5806),
    [anon_sym_PLUS_EQ] = ACTIONS(5806),
    [anon_sym_DASH_EQ] = ACTIONS(5806),
    [anon_sym_LT_LT_EQ] = ACTIONS(5806),
    [anon_sym_GT_GT_EQ] = ACTIONS(5806),
    [anon_sym_AMP_EQ] = ACTIONS(5806),
    [anon_sym_CARET_EQ] = ACTIONS(5806),
    [anon_sym_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_and_eq] = ACTIONS(5806),
    [anon_sym_or_eq] = ACTIONS(5806),
    [anon_sym_xor_eq] = ACTIONS(5806),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(3594),
    [anon_sym_u_DQUOTE] = ACTIONS(3594),
    [anon_sym_U_DQUOTE] = ACTIONS(3594),
    [anon_sym_u8_DQUOTE] = ACTIONS(3594),
    [anon_sym_DQUOTE] = ACTIONS(3594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3598),
    [anon_sym_LR_DQUOTE] = ACTIONS(3598),
    [anon_sym_uR_DQUOTE] = ACTIONS(3598),
    [anon_sym_UR_DQUOTE] = ACTIONS(3598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3598),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2360] = {
    [sym_attribute_specifier] = STATE(2563),
    [sym_enumerator_list] = STATE(2459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5597),
    [anon_sym_COMMA] = ACTIONS(5597),
    [anon_sym_LPAREN2] = ACTIONS(5597),
    [anon_sym_DASH] = ACTIONS(5599),
    [anon_sym_PLUS] = ACTIONS(5599),
    [anon_sym_STAR] = ACTIONS(5597),
    [anon_sym_SLASH] = ACTIONS(5599),
    [anon_sym_PERCENT] = ACTIONS(5597),
    [anon_sym_PIPE_PIPE] = ACTIONS(5597),
    [anon_sym_AMP_AMP] = ACTIONS(5597),
    [anon_sym_PIPE] = ACTIONS(5599),
    [anon_sym_CARET] = ACTIONS(5597),
    [anon_sym_AMP] = ACTIONS(5599),
    [anon_sym_EQ_EQ] = ACTIONS(5597),
    [anon_sym_BANG_EQ] = ACTIONS(5597),
    [anon_sym_GT] = ACTIONS(5599),
    [anon_sym_GT_EQ] = ACTIONS(5599),
    [anon_sym_LT_EQ] = ACTIONS(5599),
    [anon_sym_LT] = ACTIONS(5599),
    [anon_sym_LT_LT] = ACTIONS(5599),
    [anon_sym_GT_GT] = ACTIONS(5599),
    [anon_sym___extension__] = ACTIONS(5597),
    [anon_sym___global__] = ACTIONS(5597),
    [anon_sym___attribute__] = ACTIONS(5652),
    [anon_sym_LBRACE] = ACTIONS(5913),
    [anon_sym_LBRACK] = ACTIONS(5597),
    [anon_sym_const] = ACTIONS(5599),
    [anon_sym_constexpr] = ACTIONS(5597),
    [anon_sym_volatile] = ACTIONS(5597),
    [anon_sym_restrict] = ACTIONS(5597),
    [anon_sym___restrict__] = ACTIONS(5597),
    [anon_sym__Atomic] = ACTIONS(5597),
    [anon_sym__Noreturn] = ACTIONS(5597),
    [anon_sym_noreturn] = ACTIONS(5597),
    [anon_sym_mutable] = ACTIONS(5597),
    [anon_sym_constinit] = ACTIONS(5597),
    [anon_sym_consteval] = ACTIONS(5597),
    [anon_sym___shared__] = ACTIONS(5597),
    [anon_sym___local__] = ACTIONS(5597),
    [anon_sym___constant__] = ACTIONS(5597),
    [anon_sym___managed__] = ACTIONS(5597),
    [anon_sym___grid_constant__] = ACTIONS(5597),
    [anon_sym_alignas] = ACTIONS(5597),
    [anon_sym__Alignas] = ACTIONS(5597),
    [anon_sym_QMARK] = ACTIONS(5597),
    [anon_sym_LT_EQ_GT] = ACTIONS(5597),
    [anon_sym_or] = ACTIONS(5597),
    [anon_sym_and] = ACTIONS(5597),
    [anon_sym_bitor] = ACTIONS(5597),
    [anon_sym_xor] = ACTIONS(5597),
    [anon_sym_bitand] = ACTIONS(5597),
    [anon_sym_not_eq] = ACTIONS(5597),
    [anon_sym_DASH_DASH] = ACTIONS(5597),
    [anon_sym_PLUS_PLUS] = ACTIONS(5597),
    [anon_sym_DOT] = ACTIONS(5599),
    [anon_sym_DOT_STAR] = ACTIONS(5597),
    [anon_sym_DASH_GT] = ACTIONS(5597),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5597),
    [anon_sym_decltype] = ACTIONS(5597),
    [anon_sym_final] = ACTIONS(5597),
    [anon_sym_override] = ACTIONS(5597),
    [anon_sym_GT2] = ACTIONS(5597),
    [anon_sym_requires] = ACTIONS(5597),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5597),
  },
  [2361] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5187),
    [anon_sym_COMMA] = ACTIONS(5187),
    [anon_sym_LPAREN2] = ACTIONS(5187),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_PLUS] = ACTIONS(5185),
    [anon_sym_STAR] = ACTIONS(5187),
    [anon_sym_SLASH] = ACTIONS(5185),
    [anon_sym_PERCENT] = ACTIONS(5187),
    [anon_sym_PIPE_PIPE] = ACTIONS(5187),
    [anon_sym_AMP_AMP] = ACTIONS(5187),
    [anon_sym_PIPE] = ACTIONS(5185),
    [anon_sym_CARET] = ACTIONS(5187),
    [anon_sym_AMP] = ACTIONS(5185),
    [anon_sym_EQ_EQ] = ACTIONS(5187),
    [anon_sym_BANG_EQ] = ACTIONS(5187),
    [anon_sym_GT] = ACTIONS(5185),
    [anon_sym_GT_EQ] = ACTIONS(5185),
    [anon_sym_LT_EQ] = ACTIONS(5185),
    [anon_sym_LT] = ACTIONS(5185),
    [anon_sym_LT_LT] = ACTIONS(5185),
    [anon_sym_GT_GT] = ACTIONS(5185),
    [anon_sym___extension__] = ACTIONS(5187),
    [anon_sym___global__] = ACTIONS(5187),
    [anon_sym___attribute__] = ACTIONS(5187),
    [anon_sym_COLON_COLON] = ACTIONS(5183),
    [anon_sym_LBRACE] = ACTIONS(5187),
    [anon_sym_LBRACK] = ACTIONS(5187),
    [anon_sym_const] = ACTIONS(5185),
    [anon_sym_constexpr] = ACTIONS(5187),
    [anon_sym_volatile] = ACTIONS(5187),
    [anon_sym_restrict] = ACTIONS(5187),
    [anon_sym___restrict__] = ACTIONS(5187),
    [anon_sym__Atomic] = ACTIONS(5187),
    [anon_sym__Noreturn] = ACTIONS(5187),
    [anon_sym_noreturn] = ACTIONS(5187),
    [anon_sym_mutable] = ACTIONS(5187),
    [anon_sym_constinit] = ACTIONS(5187),
    [anon_sym_consteval] = ACTIONS(5187),
    [anon_sym___shared__] = ACTIONS(5187),
    [anon_sym___local__] = ACTIONS(5187),
    [anon_sym___constant__] = ACTIONS(5187),
    [anon_sym___managed__] = ACTIONS(5187),
    [anon_sym___grid_constant__] = ACTIONS(5187),
    [anon_sym_alignas] = ACTIONS(5187),
    [anon_sym__Alignas] = ACTIONS(5187),
    [anon_sym_COLON] = ACTIONS(5185),
    [anon_sym_QMARK] = ACTIONS(5187),
    [anon_sym_LT_EQ_GT] = ACTIONS(5187),
    [anon_sym_or] = ACTIONS(5187),
    [anon_sym_and] = ACTIONS(5187),
    [anon_sym_bitor] = ACTIONS(5187),
    [anon_sym_xor] = ACTIONS(5187),
    [anon_sym_bitand] = ACTIONS(5187),
    [anon_sym_not_eq] = ACTIONS(5187),
    [anon_sym_DASH_DASH] = ACTIONS(5187),
    [anon_sym_PLUS_PLUS] = ACTIONS(5187),
    [anon_sym_DOT] = ACTIONS(5185),
    [anon_sym_DOT_STAR] = ACTIONS(5187),
    [anon_sym_DASH_GT] = ACTIONS(5187),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5187),
    [anon_sym_decltype] = ACTIONS(5187),
    [anon_sym_final] = ACTIONS(5187),
    [anon_sym_override] = ACTIONS(5187),
    [anon_sym_GT2] = ACTIONS(5187),
    [anon_sym_requires] = ACTIONS(5187),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5187),
  },
  [2362] = {
    [sym_attribute_specifier] = STATE(2419),
    [sym_identifier] = ACTIONS(5723),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5721),
    [anon_sym_COMMA] = ACTIONS(5721),
    [anon_sym_RPAREN] = ACTIONS(5721),
    [aux_sym_preproc_if_token2] = ACTIONS(5721),
    [aux_sym_preproc_else_token1] = ACTIONS(5721),
    [aux_sym_preproc_elif_token1] = ACTIONS(5723),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5721),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5721),
    [anon_sym_LPAREN2] = ACTIONS(5721),
    [anon_sym_DASH] = ACTIONS(5723),
    [anon_sym_PLUS] = ACTIONS(5723),
    [anon_sym_STAR] = ACTIONS(5723),
    [anon_sym_SLASH] = ACTIONS(5723),
    [anon_sym_PERCENT] = ACTIONS(5723),
    [anon_sym_PIPE_PIPE] = ACTIONS(5721),
    [anon_sym_AMP_AMP] = ACTIONS(5721),
    [anon_sym_PIPE] = ACTIONS(5723),
    [anon_sym_CARET] = ACTIONS(5723),
    [anon_sym_AMP] = ACTIONS(5723),
    [anon_sym_EQ_EQ] = ACTIONS(5721),
    [anon_sym_BANG_EQ] = ACTIONS(5721),
    [anon_sym_GT] = ACTIONS(5723),
    [anon_sym_GT_EQ] = ACTIONS(5721),
    [anon_sym_LT_EQ] = ACTIONS(5723),
    [anon_sym_LT] = ACTIONS(5723),
    [anon_sym_LT_LT] = ACTIONS(5723),
    [anon_sym_GT_GT] = ACTIONS(5723),
    [anon_sym_SEMI] = ACTIONS(5721),
    [anon_sym___attribute__] = ACTIONS(5546),
    [anon_sym_LBRACE] = ACTIONS(5721),
    [anon_sym_RBRACE] = ACTIONS(5721),
    [anon_sym_LBRACK] = ACTIONS(5721),
    [anon_sym_RBRACK] = ACTIONS(5721),
    [anon_sym_EQ] = ACTIONS(5723),
    [anon_sym_COLON] = ACTIONS(5721),
    [anon_sym_QMARK] = ACTIONS(5721),
    [anon_sym_STAR_EQ] = ACTIONS(5721),
    [anon_sym_SLASH_EQ] = ACTIONS(5721),
    [anon_sym_PERCENT_EQ] = ACTIONS(5721),
    [anon_sym_PLUS_EQ] = ACTIONS(5721),
    [anon_sym_DASH_EQ] = ACTIONS(5721),
    [anon_sym_LT_LT_EQ] = ACTIONS(5721),
    [anon_sym_GT_GT_EQ] = ACTIONS(5721),
    [anon_sym_AMP_EQ] = ACTIONS(5721),
    [anon_sym_CARET_EQ] = ACTIONS(5721),
    [anon_sym_PIPE_EQ] = ACTIONS(5721),
    [anon_sym_and_eq] = ACTIONS(5723),
    [anon_sym_or_eq] = ACTIONS(5723),
    [anon_sym_xor_eq] = ACTIONS(5723),
    [anon_sym_LT_EQ_GT] = ACTIONS(5721),
    [anon_sym_or] = ACTIONS(5723),
    [anon_sym_and] = ACTIONS(5723),
    [anon_sym_bitor] = ACTIONS(5723),
    [anon_sym_xor] = ACTIONS(5723),
    [anon_sym_bitand] = ACTIONS(5723),
    [anon_sym_not_eq] = ACTIONS(5723),
    [anon_sym_DASH_DASH] = ACTIONS(5721),
    [anon_sym_PLUS_PLUS] = ACTIONS(5721),
    [anon_sym_DOT] = ACTIONS(5723),
    [anon_sym_DOT_STAR] = ACTIONS(5721),
    [anon_sym_DASH_GT] = ACTIONS(5721),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5723),
    [anon_sym_decltype] = ACTIONS(5723),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5721),
  },
  [2363] = {
    [sym_attribute_specifier] = STATE(2170),
    [sym_enumerator_list] = STATE(2512),
    [sym_identifier] = ACTIONS(5599),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5597),
    [anon_sym_COMMA] = ACTIONS(5597),
    [anon_sym_RPAREN] = ACTIONS(5597),
    [anon_sym_LPAREN2] = ACTIONS(5597),
    [anon_sym_TILDE] = ACTIONS(5597),
    [anon_sym_STAR] = ACTIONS(5597),
    [anon_sym_AMP_AMP] = ACTIONS(5597),
    [anon_sym_AMP] = ACTIONS(5599),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym___extension__] = ACTIONS(5599),
    [anon_sym___device__] = ACTIONS(5599),
    [anon_sym___host__] = ACTIONS(5599),
    [anon_sym___global__] = ACTIONS(5599),
    [anon_sym___forceinline__] = ACTIONS(5599),
    [anon_sym___noinline__] = ACTIONS(5599),
    [anon_sym_extern] = ACTIONS(5599),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5597),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5597),
    [anon_sym___declspec] = ACTIONS(5599),
    [anon_sym___based] = ACTIONS(5599),
    [anon_sym___cdecl] = ACTIONS(5599),
    [anon_sym___clrcall] = ACTIONS(5599),
    [anon_sym___stdcall] = ACTIONS(5599),
    [anon_sym___fastcall] = ACTIONS(5599),
    [anon_sym___thiscall] = ACTIONS(5599),
    [anon_sym___vectorcall] = ACTIONS(5599),
    [anon_sym_LBRACE] = ACTIONS(5921),
    [anon_sym_LBRACK] = ACTIONS(5599),
    [anon_sym_static] = ACTIONS(5599),
    [anon_sym_EQ] = ACTIONS(5597),
    [anon_sym_register] = ACTIONS(5599),
    [anon_sym_inline] = ACTIONS(5599),
    [anon_sym___inline] = ACTIONS(5599),
    [anon_sym___inline__] = ACTIONS(5599),
    [anon_sym___forceinline] = ACTIONS(5599),
    [anon_sym_thread_local] = ACTIONS(5599),
    [anon_sym___thread] = ACTIONS(5599),
    [anon_sym_const] = ACTIONS(5599),
    [anon_sym_constexpr] = ACTIONS(5599),
    [anon_sym_volatile] = ACTIONS(5599),
    [anon_sym_restrict] = ACTIONS(5599),
    [anon_sym___restrict__] = ACTIONS(5599),
    [anon_sym__Atomic] = ACTIONS(5599),
    [anon_sym__Noreturn] = ACTIONS(5599),
    [anon_sym_noreturn] = ACTIONS(5599),
    [anon_sym_mutable] = ACTIONS(5599),
    [anon_sym_constinit] = ACTIONS(5599),
    [anon_sym_consteval] = ACTIONS(5599),
    [anon_sym___shared__] = ACTIONS(5599),
    [anon_sym___local__] = ACTIONS(5599),
    [anon_sym___constant__] = ACTIONS(5599),
    [anon_sym___managed__] = ACTIONS(5599),
    [anon_sym___grid_constant__] = ACTIONS(5599),
    [anon_sym_alignas] = ACTIONS(5599),
    [anon_sym__Alignas] = ACTIONS(5599),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5599),
    [anon_sym_decltype] = ACTIONS(5599),
    [sym_virtual] = ACTIONS(5599),
    [anon_sym_template] = ACTIONS(5599),
    [anon_sym_GT2] = ACTIONS(5597),
    [anon_sym_operator] = ACTIONS(5599),
    [anon_sym___launch_bounds__] = ACTIONS(5599),
  },
  [2364] = {
    [sym_attribute_declaration] = STATE(2388),
    [sym_parameter_list] = STATE(2456),
    [aux_sym_attributed_declarator_repeat1] = STATE(2388),
    [sym_identifier] = ACTIONS(5923),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5925),
    [anon_sym_COMMA] = ACTIONS(5925),
    [anon_sym_RPAREN] = ACTIONS(5925),
    [aux_sym_preproc_if_token2] = ACTIONS(5925),
    [aux_sym_preproc_else_token1] = ACTIONS(5925),
    [aux_sym_preproc_elif_token1] = ACTIONS(5923),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5925),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5925),
    [anon_sym_LPAREN2] = ACTIONS(5835),
    [anon_sym_DASH] = ACTIONS(5923),
    [anon_sym_PLUS] = ACTIONS(5923),
    [anon_sym_STAR] = ACTIONS(5923),
    [anon_sym_SLASH] = ACTIONS(5923),
    [anon_sym_PERCENT] = ACTIONS(5923),
    [anon_sym_PIPE_PIPE] = ACTIONS(5925),
    [anon_sym_AMP_AMP] = ACTIONS(5925),
    [anon_sym_PIPE] = ACTIONS(5923),
    [anon_sym_CARET] = ACTIONS(5923),
    [anon_sym_AMP] = ACTIONS(5923),
    [anon_sym_EQ_EQ] = ACTIONS(5925),
    [anon_sym_BANG_EQ] = ACTIONS(5925),
    [anon_sym_GT] = ACTIONS(5923),
    [anon_sym_GT_EQ] = ACTIONS(5925),
    [anon_sym_LT_EQ] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(5923),
    [anon_sym_LT_LT] = ACTIONS(5923),
    [anon_sym_GT_GT] = ACTIONS(5923),
    [anon_sym_SEMI] = ACTIONS(5925),
    [anon_sym___attribute__] = ACTIONS(5923),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5837),
    [anon_sym_RBRACE] = ACTIONS(5925),
    [anon_sym_LBRACK] = ACTIONS(5839),
    [anon_sym_RBRACK] = ACTIONS(5925),
    [anon_sym_EQ] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_QMARK] = ACTIONS(5925),
    [anon_sym_STAR_EQ] = ACTIONS(5925),
    [anon_sym_SLASH_EQ] = ACTIONS(5925),
    [anon_sym_PERCENT_EQ] = ACTIONS(5925),
    [anon_sym_PLUS_EQ] = ACTIONS(5925),
    [anon_sym_DASH_EQ] = ACTIONS(5925),
    [anon_sym_LT_LT_EQ] = ACTIONS(5925),
    [anon_sym_GT_GT_EQ] = ACTIONS(5925),
    [anon_sym_AMP_EQ] = ACTIONS(5925),
    [anon_sym_CARET_EQ] = ACTIONS(5925),
    [anon_sym_PIPE_EQ] = ACTIONS(5925),
    [anon_sym_and_eq] = ACTIONS(5923),
    [anon_sym_or_eq] = ACTIONS(5923),
    [anon_sym_xor_eq] = ACTIONS(5923),
    [anon_sym_LT_EQ_GT] = ACTIONS(5925),
    [anon_sym_or] = ACTIONS(5923),
    [anon_sym_and] = ACTIONS(5923),
    [anon_sym_bitor] = ACTIONS(5923),
    [anon_sym_xor] = ACTIONS(5923),
    [anon_sym_bitand] = ACTIONS(5923),
    [anon_sym_not_eq] = ACTIONS(5923),
    [anon_sym_DASH_DASH] = ACTIONS(5925),
    [anon_sym_PLUS_PLUS] = ACTIONS(5925),
    [anon_sym_DOT] = ACTIONS(5923),
    [anon_sym_DOT_STAR] = ACTIONS(5925),
    [anon_sym_DASH_GT] = ACTIONS(5925),
    [sym_comment] = ACTIONS(3),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5925),
  },
  [2365] = {
    [sym_string_literal] = STATE(3772),
    [sym_template_argument_list] = STATE(5141),
    [sym_raw_string_literal] = STATE(3772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3766),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(4837),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(4842),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(4844),
    [anon_sym_SLASH_EQ] = ACTIONS(4844),
    [anon_sym_PERCENT_EQ] = ACTIONS(4844),
    [anon_sym_PLUS_EQ] = ACTIONS(4844),
    [anon_sym_DASH_EQ] = ACTIONS(4844),
    [anon_sym_LT_LT_EQ] = ACTIONS(4844),
    [anon_sym_GT_GT_EQ] = ACTIONS(4842),
    [anon_sym_AMP_EQ] = ACTIONS(4844),
    [anon_sym_CARET_EQ] = ACTIONS(4844),
    [anon_sym_PIPE_EQ] = ACTIONS(4844),
    [anon_sym_and_eq] = ACTIONS(4844),
    [anon_sym_or_eq] = ACTIONS(4844),
    [anon_sym_xor_eq] = ACTIONS(4844),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(4846),
    [anon_sym_u_DQUOTE] = ACTIONS(4846),
    [anon_sym_U_DQUOTE] = ACTIONS(4846),
    [anon_sym_u8_DQUOTE] = ACTIONS(4846),
    [anon_sym_DQUOTE] = ACTIONS(4846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(3758),
    [anon_sym_R_DQUOTE] = ACTIONS(4848),
    [anon_sym_LR_DQUOTE] = ACTIONS(4848),
    [anon_sym_uR_DQUOTE] = ACTIONS(4848),
    [anon_sym_UR_DQUOTE] = ACTIONS(4848),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4848),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2366] = {
    [sym_attribute_specifier] = STATE(2393),
    [sym_identifier] = ACTIONS(5635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5633),
    [anon_sym_COMMA] = ACTIONS(5633),
    [anon_sym_RPAREN] = ACTIONS(5633),
    [aux_sym_preproc_if_token2] = ACTIONS(5633),
    [aux_sym_preproc_else_token1] = ACTIONS(5633),
    [aux_sym_preproc_elif_token1] = ACTIONS(5635),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5633),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5633),
    [anon_sym_LPAREN2] = ACTIONS(5633),
    [anon_sym_DASH] = ACTIONS(5635),
    [anon_sym_PLUS] = ACTIONS(5635),
    [anon_sym_STAR] = ACTIONS(5635),
    [anon_sym_SLASH] = ACTIONS(5635),
    [anon_sym_PERCENT] = ACTIONS(5635),
    [anon_sym_PIPE_PIPE] = ACTIONS(5633),
    [anon_sym_AMP_AMP] = ACTIONS(5633),
    [anon_sym_PIPE] = ACTIONS(5635),
    [anon_sym_CARET] = ACTIONS(5635),
    [anon_sym_AMP] = ACTIONS(5635),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5635),
    [anon_sym_GT_EQ] = ACTIONS(5633),
    [anon_sym_LT_EQ] = ACTIONS(5635),
    [anon_sym_LT] = ACTIONS(5635),
    [anon_sym_LT_LT] = ACTIONS(5635),
    [anon_sym_GT_GT] = ACTIONS(5635),
    [anon_sym_SEMI] = ACTIONS(5633),
    [anon_sym___attribute__] = ACTIONS(5546),
    [anon_sym_LBRACE] = ACTIONS(5633),
    [anon_sym_RBRACE] = ACTIONS(5633),
    [anon_sym_LBRACK] = ACTIONS(5633),
    [anon_sym_RBRACK] = ACTIONS(5633),
    [anon_sym_EQ] = ACTIONS(5635),
    [anon_sym_COLON] = ACTIONS(5633),
    [anon_sym_QMARK] = ACTIONS(5633),
    [anon_sym_STAR_EQ] = ACTIONS(5633),
    [anon_sym_SLASH_EQ] = ACTIONS(5633),
    [anon_sym_PERCENT_EQ] = ACTIONS(5633),
    [anon_sym_PLUS_EQ] = ACTIONS(5633),
    [anon_sym_DASH_EQ] = ACTIONS(5633),
    [anon_sym_LT_LT_EQ] = ACTIONS(5633),
    [anon_sym_GT_GT_EQ] = ACTIONS(5633),
    [anon_sym_AMP_EQ] = ACTIONS(5633),
    [anon_sym_CARET_EQ] = ACTIONS(5633),
    [anon_sym_PIPE_EQ] = ACTIONS(5633),
    [anon_sym_and_eq] = ACTIONS(5635),
    [anon_sym_or_eq] = ACTIONS(5635),
    [anon_sym_xor_eq] = ACTIONS(5635),
    [anon_sym_LT_EQ_GT] = ACTIONS(5633),
    [anon_sym_or] = ACTIONS(5635),
    [anon_sym_and] = ACTIONS(5635),
    [anon_sym_bitor] = ACTIONS(5635),
    [anon_sym_xor] = ACTIONS(5635),
    [anon_sym_bitand] = ACTIONS(5635),
    [anon_sym_not_eq] = ACTIONS(5635),
    [anon_sym_DASH_DASH] = ACTIONS(5633),
    [anon_sym_PLUS_PLUS] = ACTIONS(5633),
    [anon_sym_DOT] = ACTIONS(5635),
    [anon_sym_DOT_STAR] = ACTIONS(5633),
    [anon_sym_DASH_GT] = ACTIONS(5633),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5635),
    [anon_sym_decltype] = ACTIONS(5635),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5633),
  },
  [2367] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2308),
    [sym_identifier] = ACTIONS(5927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5325),
    [anon_sym_COMMA] = ACTIONS(5325),
    [anon_sym_RPAREN] = ACTIONS(5325),
    [anon_sym_LPAREN2] = ACTIONS(5325),
    [anon_sym_DASH] = ACTIONS(5327),
    [anon_sym_PLUS] = ACTIONS(5327),
    [anon_sym_STAR] = ACTIONS(5327),
    [anon_sym_SLASH] = ACTIONS(5327),
    [anon_sym_PERCENT] = ACTIONS(5327),
    [anon_sym_PIPE_PIPE] = ACTIONS(5325),
    [anon_sym_AMP_AMP] = ACTIONS(5325),
    [anon_sym_PIPE] = ACTIONS(5327),
    [anon_sym_CARET] = ACTIONS(5327),
    [anon_sym_AMP] = ACTIONS(5327),
    [anon_sym_EQ_EQ] = ACTIONS(5325),
    [anon_sym_BANG_EQ] = ACTIONS(5325),
    [anon_sym_GT] = ACTIONS(5327),
    [anon_sym_GT_EQ] = ACTIONS(5325),
    [anon_sym_LT_EQ] = ACTIONS(5327),
    [anon_sym_LT] = ACTIONS(5327),
    [anon_sym_LT_LT] = ACTIONS(5327),
    [anon_sym_GT_GT] = ACTIONS(5327),
    [anon_sym_SEMI] = ACTIONS(5325),
    [anon_sym___attribute__] = ACTIONS(5327),
    [anon_sym_LBRACE] = ACTIONS(5325),
    [anon_sym_RBRACE] = ACTIONS(5325),
    [anon_sym_signed] = ACTIONS(5929),
    [anon_sym_unsigned] = ACTIONS(5929),
    [anon_sym_long] = ACTIONS(5929),
    [anon_sym_short] = ACTIONS(5929),
    [anon_sym_LBRACK] = ACTIONS(5325),
    [anon_sym_RBRACK] = ACTIONS(5325),
    [anon_sym_EQ] = ACTIONS(5327),
    [sym_primitive_type] = ACTIONS(5931),
    [anon_sym_COLON] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(5325),
    [anon_sym_STAR_EQ] = ACTIONS(5325),
    [anon_sym_SLASH_EQ] = ACTIONS(5325),
    [anon_sym_PERCENT_EQ] = ACTIONS(5325),
    [anon_sym_PLUS_EQ] = ACTIONS(5325),
    [anon_sym_DASH_EQ] = ACTIONS(5325),
    [anon_sym_LT_LT_EQ] = ACTIONS(5325),
    [anon_sym_GT_GT_EQ] = ACTIONS(5325),
    [anon_sym_AMP_EQ] = ACTIONS(5325),
    [anon_sym_CARET_EQ] = ACTIONS(5325),
    [anon_sym_PIPE_EQ] = ACTIONS(5325),
    [anon_sym_and_eq] = ACTIONS(5327),
    [anon_sym_or_eq] = ACTIONS(5327),
    [anon_sym_xor_eq] = ACTIONS(5327),
    [anon_sym_LT_EQ_GT] = ACTIONS(5325),
    [anon_sym_or] = ACTIONS(5327),
    [anon_sym_and] = ACTIONS(5327),
    [anon_sym_bitor] = ACTIONS(5327),
    [anon_sym_xor] = ACTIONS(5327),
    [anon_sym_bitand] = ACTIONS(5327),
    [anon_sym_not_eq] = ACTIONS(5327),
    [anon_sym_DASH_DASH] = ACTIONS(5325),
    [anon_sym_PLUS_PLUS] = ACTIONS(5325),
    [anon_sym_DOT] = ACTIONS(5327),
    [anon_sym_DOT_STAR] = ACTIONS(5325),
    [anon_sym_DASH_GT] = ACTIONS(5325),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5327),
    [anon_sym_decltype] = ACTIONS(5327),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5325),
  },
  [2368] = {
    [sym_string_literal] = STATE(2336),
    [sym_template_argument_list] = STATE(3521),
    [sym_raw_string_literal] = STATE(2336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3766),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(5933),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3758),
    [anon_sym_SLASH_EQ] = ACTIONS(3758),
    [anon_sym_PERCENT_EQ] = ACTIONS(3758),
    [anon_sym_PLUS_EQ] = ACTIONS(3758),
    [anon_sym_DASH_EQ] = ACTIONS(3758),
    [anon_sym_LT_LT_EQ] = ACTIONS(3758),
    [anon_sym_GT_GT_EQ] = ACTIONS(3766),
    [anon_sym_AMP_EQ] = ACTIONS(3758),
    [anon_sym_CARET_EQ] = ACTIONS(3758),
    [anon_sym_PIPE_EQ] = ACTIONS(3758),
    [anon_sym_and_eq] = ACTIONS(3758),
    [anon_sym_or_eq] = ACTIONS(3758),
    [anon_sym_xor_eq] = ACTIONS(3758),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3758),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3758),
    [anon_sym_not_eq] = ACTIONS(3758),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(5893),
    [anon_sym_u_DQUOTE] = ACTIONS(5893),
    [anon_sym_U_DQUOTE] = ACTIONS(5893),
    [anon_sym_u8_DQUOTE] = ACTIONS(5893),
    [anon_sym_DQUOTE] = ACTIONS(5893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(3758),
    [anon_sym_R_DQUOTE] = ACTIONS(5895),
    [anon_sym_LR_DQUOTE] = ACTIONS(5895),
    [anon_sym_uR_DQUOTE] = ACTIONS(5895),
    [anon_sym_UR_DQUOTE] = ACTIONS(5895),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5895),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2369] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5502),
    [anon_sym_COMMA] = ACTIONS(5502),
    [anon_sym_RPAREN] = ACTIONS(5502),
    [anon_sym_LPAREN2] = ACTIONS(5502),
    [anon_sym_DASH] = ACTIONS(5500),
    [anon_sym_PLUS] = ACTIONS(5500),
    [anon_sym_STAR] = ACTIONS(5500),
    [anon_sym_SLASH] = ACTIONS(5500),
    [anon_sym_PERCENT] = ACTIONS(5500),
    [anon_sym_PIPE_PIPE] = ACTIONS(5502),
    [anon_sym_AMP_AMP] = ACTIONS(5502),
    [anon_sym_PIPE] = ACTIONS(5500),
    [anon_sym_CARET] = ACTIONS(5500),
    [anon_sym_AMP] = ACTIONS(5500),
    [anon_sym_EQ_EQ] = ACTIONS(5502),
    [anon_sym_BANG_EQ] = ACTIONS(5502),
    [anon_sym_GT] = ACTIONS(5500),
    [anon_sym_GT_EQ] = ACTIONS(5502),
    [anon_sym_LT_EQ] = ACTIONS(5500),
    [anon_sym_LT] = ACTIONS(5500),
    [anon_sym_LT_LT] = ACTIONS(5500),
    [anon_sym_GT_GT] = ACTIONS(5500),
    [anon_sym_SEMI] = ACTIONS(5502),
    [anon_sym_RBRACE] = ACTIONS(5502),
    [anon_sym_LBRACK] = ACTIONS(5502),
    [anon_sym_RBRACK] = ACTIONS(5502),
    [anon_sym_EQ] = ACTIONS(5500),
    [anon_sym_COLON] = ACTIONS(5502),
    [anon_sym_QMARK] = ACTIONS(5502),
    [anon_sym_STAR_EQ] = ACTIONS(5502),
    [anon_sym_SLASH_EQ] = ACTIONS(5502),
    [anon_sym_PERCENT_EQ] = ACTIONS(5502),
    [anon_sym_PLUS_EQ] = ACTIONS(5502),
    [anon_sym_DASH_EQ] = ACTIONS(5502),
    [anon_sym_LT_LT_EQ] = ACTIONS(5502),
    [anon_sym_GT_GT_EQ] = ACTIONS(5502),
    [anon_sym_AMP_EQ] = ACTIONS(5502),
    [anon_sym_CARET_EQ] = ACTIONS(5502),
    [anon_sym_PIPE_EQ] = ACTIONS(5502),
    [anon_sym_and_eq] = ACTIONS(5500),
    [anon_sym_or_eq] = ACTIONS(5500),
    [anon_sym_xor_eq] = ACTIONS(5500),
    [anon_sym_LT_EQ_GT] = ACTIONS(5502),
    [anon_sym_or] = ACTIONS(5500),
    [anon_sym_and] = ACTIONS(5500),
    [anon_sym_bitor] = ACTIONS(5500),
    [anon_sym_xor] = ACTIONS(5500),
    [anon_sym_bitand] = ACTIONS(5500),
    [anon_sym_not_eq] = ACTIONS(5500),
    [anon_sym_DASH_DASH] = ACTIONS(5502),
    [anon_sym_PLUS_PLUS] = ACTIONS(5502),
    [anon_sym_DOT] = ACTIONS(5500),
    [anon_sym_DOT_STAR] = ACTIONS(5502),
    [anon_sym_DASH_GT] = ACTIONS(5502),
    [anon_sym_L_DQUOTE] = ACTIONS(5502),
    [anon_sym_u_DQUOTE] = ACTIONS(5502),
    [anon_sym_U_DQUOTE] = ACTIONS(5502),
    [anon_sym_u8_DQUOTE] = ACTIONS(5502),
    [anon_sym_DQUOTE] = ACTIONS(5502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5502),
    [anon_sym_LR_DQUOTE] = ACTIONS(5502),
    [anon_sym_uR_DQUOTE] = ACTIONS(5502),
    [anon_sym_UR_DQUOTE] = ACTIONS(5502),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5502),
    [sym_literal_suffix] = ACTIONS(5500),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5502),
  },
  [2370] = {
    [sym_string_literal] = STATE(2370),
    [sym_raw_string_literal] = STATE(2370),
    [aux_sym_concatenated_string_repeat1] = STATE(2370),
    [sym_identifier] = ACTIONS(5936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5267),
    [anon_sym_COMMA] = ACTIONS(5267),
    [anon_sym_LPAREN2] = ACTIONS(5267),
    [anon_sym_DASH] = ACTIONS(5269),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_STAR] = ACTIONS(5269),
    [anon_sym_SLASH] = ACTIONS(5269),
    [anon_sym_PERCENT] = ACTIONS(5269),
    [anon_sym_PIPE_PIPE] = ACTIONS(5267),
    [anon_sym_AMP_AMP] = ACTIONS(5267),
    [anon_sym_PIPE] = ACTIONS(5269),
    [anon_sym_CARET] = ACTIONS(5269),
    [anon_sym_AMP] = ACTIONS(5269),
    [anon_sym_EQ_EQ] = ACTIONS(5267),
    [anon_sym_BANG_EQ] = ACTIONS(5267),
    [anon_sym_GT] = ACTIONS(5269),
    [anon_sym_GT_EQ] = ACTIONS(5267),
    [anon_sym_LT_EQ] = ACTIONS(5269),
    [anon_sym_LT] = ACTIONS(5269),
    [anon_sym_LT_LT] = ACTIONS(5269),
    [anon_sym_GT_GT] = ACTIONS(5269),
    [anon_sym_LBRACK] = ACTIONS(5267),
    [anon_sym_EQ] = ACTIONS(5269),
    [anon_sym_QMARK] = ACTIONS(5267),
    [anon_sym_STAR_EQ] = ACTIONS(5267),
    [anon_sym_SLASH_EQ] = ACTIONS(5267),
    [anon_sym_PERCENT_EQ] = ACTIONS(5267),
    [anon_sym_PLUS_EQ] = ACTIONS(5267),
    [anon_sym_DASH_EQ] = ACTIONS(5267),
    [anon_sym_LT_LT_EQ] = ACTIONS(5267),
    [anon_sym_GT_GT_EQ] = ACTIONS(5267),
    [anon_sym_AMP_EQ] = ACTIONS(5267),
    [anon_sym_CARET_EQ] = ACTIONS(5267),
    [anon_sym_PIPE_EQ] = ACTIONS(5267),
    [anon_sym_and_eq] = ACTIONS(5269),
    [anon_sym_or_eq] = ACTIONS(5269),
    [anon_sym_xor_eq] = ACTIONS(5269),
    [anon_sym_LT_EQ_GT] = ACTIONS(5267),
    [anon_sym_or] = ACTIONS(5269),
    [anon_sym_and] = ACTIONS(5269),
    [anon_sym_bitor] = ACTIONS(5269),
    [anon_sym_xor] = ACTIONS(5269),
    [anon_sym_bitand] = ACTIONS(5269),
    [anon_sym_not_eq] = ACTIONS(5269),
    [anon_sym_DASH_DASH] = ACTIONS(5267),
    [anon_sym_PLUS_PLUS] = ACTIONS(5267),
    [anon_sym_DOT] = ACTIONS(5269),
    [anon_sym_DOT_STAR] = ACTIONS(5267),
    [anon_sym_DASH_GT] = ACTIONS(5267),
    [anon_sym_L_DQUOTE] = ACTIONS(5939),
    [anon_sym_u_DQUOTE] = ACTIONS(5939),
    [anon_sym_U_DQUOTE] = ACTIONS(5939),
    [anon_sym_u8_DQUOTE] = ACTIONS(5939),
    [anon_sym_DQUOTE] = ACTIONS(5939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5942),
    [anon_sym_LR_DQUOTE] = ACTIONS(5942),
    [anon_sym_uR_DQUOTE] = ACTIONS(5942),
    [anon_sym_UR_DQUOTE] = ACTIONS(5942),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5942),
    [sym_literal_suffix] = ACTIONS(5269),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5267),
    [aux_sym_kernel_call_syntax_token2] = ACTIONS(5267),
  },
  [2371] = {
    [sym_template_argument_list] = STATE(2259),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2518),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3764),
    [anon_sym_COMMA] = ACTIONS(3764),
    [anon_sym_RPAREN] = ACTIONS(3764),
    [anon_sym_LPAREN2] = ACTIONS(3764),
    [anon_sym_DASH] = ACTIONS(3756),
    [anon_sym_PLUS] = ACTIONS(3756),
    [anon_sym_STAR] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3756),
    [anon_sym_PERCENT] = ACTIONS(3756),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_AMP_AMP] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3756),
    [anon_sym_CARET] = ACTIONS(3756),
    [anon_sym_AMP] = ACTIONS(3756),
    [anon_sym_EQ_EQ] = ACTIONS(3764),
    [anon_sym_BANG_EQ] = ACTIONS(3764),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_GT_EQ] = ACTIONS(3764),
    [anon_sym_LT_EQ] = ACTIONS(3756),
    [anon_sym_LT] = ACTIONS(5729),
    [anon_sym_LT_LT] = ACTIONS(3756),
    [anon_sym_GT_GT] = ACTIONS(3756),
    [anon_sym_SEMI] = ACTIONS(3764),
    [anon_sym___attribute__] = ACTIONS(3764),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(3764),
    [anon_sym_RBRACE] = ACTIONS(3764),
    [anon_sym_signed] = ACTIONS(5915),
    [anon_sym_unsigned] = ACTIONS(5915),
    [anon_sym_long] = ACTIONS(5915),
    [anon_sym_short] = ACTIONS(5915),
    [anon_sym_LBRACK] = ACTIONS(3764),
    [anon_sym_RBRACK] = ACTIONS(3764),
    [anon_sym_EQ] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3764),
    [anon_sym_STAR_EQ] = ACTIONS(3764),
    [anon_sym_SLASH_EQ] = ACTIONS(3764),
    [anon_sym_PERCENT_EQ] = ACTIONS(3764),
    [anon_sym_PLUS_EQ] = ACTIONS(3764),
    [anon_sym_DASH_EQ] = ACTIONS(3764),
    [anon_sym_LT_LT_EQ] = ACTIONS(3764),
    [anon_sym_GT_GT_EQ] = ACTIONS(3764),
    [anon_sym_AMP_EQ] = ACTIONS(3764),
    [anon_sym_CARET_EQ] = ACTIONS(3764),
    [anon_sym_PIPE_EQ] = ACTIONS(3764),
    [anon_sym_and_eq] = ACTIONS(3764),
    [anon_sym_or_eq] = ACTIONS(3764),
    [anon_sym_xor_eq] = ACTIONS(3764),
    [anon_sym_LT_EQ_GT] = ACTIONS(3764),
    [anon_sym_or] = ACTIONS(3756),
    [anon_sym_and] = ACTIONS(3756),
    [anon_sym_bitor] = ACTIONS(3764),
    [anon_sym_xor] = ACTIONS(3756),
    [anon_sym_bitand] = ACTIONS(3764),
    [anon_sym_not_eq] = ACTIONS(3764),
    [anon_sym_DASH_DASH] = ACTIONS(3764),
    [anon_sym_PLUS_PLUS] = ACTIONS(3764),
    [anon_sym_DOT] = ACTIONS(3756),
    [anon_sym_DOT_STAR] = ACTIONS(3764),
    [anon_sym_DASH_GT] = ACTIONS(3764),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3764),
    [anon_sym_decltype] = ACTIONS(3764),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3764),
  },
  [2372] = {
    [sym_attribute_specifier] = STATE(2446),
    [sym_identifier] = ACTIONS(5700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5698),
    [anon_sym_RPAREN] = ACTIONS(5698),
    [aux_sym_preproc_if_token2] = ACTIONS(5698),
    [aux_sym_preproc_else_token1] = ACTIONS(5698),
    [aux_sym_preproc_elif_token1] = ACTIONS(5700),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5698),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5698),
    [anon_sym_LPAREN2] = ACTIONS(5698),
    [anon_sym_DASH] = ACTIONS(5700),
    [anon_sym_PLUS] = ACTIONS(5700),
    [anon_sym_STAR] = ACTIONS(5700),
    [anon_sym_SLASH] = ACTIONS(5700),
    [anon_sym_PERCENT] = ACTIONS(5700),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_PIPE] = ACTIONS(5700),
    [anon_sym_CARET] = ACTIONS(5700),
    [anon_sym_AMP] = ACTIONS(5700),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5700),
    [anon_sym_GT_EQ] = ACTIONS(5698),
    [anon_sym_LT_EQ] = ACTIONS(5700),
    [anon_sym_LT] = ACTIONS(5700),
    [anon_sym_LT_LT] = ACTIONS(5700),
    [anon_sym_GT_GT] = ACTIONS(5700),
    [anon_sym_SEMI] = ACTIONS(5698),
    [anon_sym___attribute__] = ACTIONS(5546),
    [anon_sym_LBRACE] = ACTIONS(5698),
    [anon_sym_RBRACE] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5698),
    [anon_sym_RBRACK] = ACTIONS(5698),
    [anon_sym_EQ] = ACTIONS(5700),
    [anon_sym_COLON] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5698),
    [anon_sym_STAR_EQ] = ACTIONS(5698),
    [anon_sym_SLASH_EQ] = ACTIONS(5698),
    [anon_sym_PERCENT_EQ] = ACTIONS(5698),
    [anon_sym_PLUS_EQ] = ACTIONS(5698),
    [anon_sym_DASH_EQ] = ACTIONS(5698),
    [anon_sym_LT_LT_EQ] = ACTIONS(5698),
    [anon_sym_GT_GT_EQ] = ACTIONS(5698),
    [anon_sym_AMP_EQ] = ACTIONS(5698),
    [anon_sym_CARET_EQ] = ACTIONS(5698),
    [anon_sym_PIPE_EQ] = ACTIONS(5698),
    [anon_sym_and_eq] = ACTIONS(5700),
    [anon_sym_or_eq] = ACTIONS(5700),
    [anon_sym_xor_eq] = ACTIONS(5700),
    [anon_sym_LT_EQ_GT] = ACTIONS(5698),
    [anon_sym_or] = ACTIONS(5700),
    [anon_sym_and] = ACTIONS(5700),
    [anon_sym_bitor] = ACTIONS(5700),
    [anon_sym_xor] = ACTIONS(5700),
    [anon_sym_bitand] = ACTIONS(5700),
    [anon_sym_not_eq] = ACTIONS(5700),
    [anon_sym_DASH_DASH] = ACTIONS(5698),
    [anon_sym_PLUS_PLUS] = ACTIONS(5698),
    [anon_sym_DOT] = ACTIONS(5700),
    [anon_sym_DOT_STAR] = ACTIONS(5698),
    [anon_sym_DASH_GT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5700),
    [anon_sym_decltype] = ACTIONS(5700),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5698),
  },
  [2373] = {
    [sym_attribute_specifier] = STATE(2395),
    [sym_identifier] = ACTIONS(5716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5714),
    [anon_sym_COMMA] = ACTIONS(5714),
    [anon_sym_RPAREN] = ACTIONS(5714),
    [aux_sym_preproc_if_token2] = ACTIONS(5714),
    [aux_sym_preproc_else_token1] = ACTIONS(5714),
    [aux_sym_preproc_elif_token1] = ACTIONS(5716),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5714),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5714),
    [anon_sym_LPAREN2] = ACTIONS(5714),
    [anon_sym_DASH] = ACTIONS(5716),
    [anon_sym_PLUS] = ACTIONS(5716),
    [anon_sym_STAR] = ACTIONS(5716),
    [anon_sym_SLASH] = ACTIONS(5716),
    [anon_sym_PERCENT] = ACTIONS(5716),
    [anon_sym_PIPE_PIPE] = ACTIONS(5714),
    [anon_sym_AMP_AMP] = ACTIONS(5714),
    [anon_sym_PIPE] = ACTIONS(5716),
    [anon_sym_CARET] = ACTIONS(5716),
    [anon_sym_AMP] = ACTIONS(5716),
    [anon_sym_EQ_EQ] = ACTIONS(5714),
    [anon_sym_BANG_EQ] = ACTIONS(5714),
    [anon_sym_GT] = ACTIONS(5716),
    [anon_sym_GT_EQ] = ACTIONS(5714),
    [anon_sym_LT_EQ] = ACTIONS(5716),
    [anon_sym_LT] = ACTIONS(5716),
    [anon_sym_LT_LT] = ACTIONS(5716),
    [anon_sym_GT_GT] = ACTIONS(5716),
    [anon_sym_SEMI] = ACTIONS(5714),
    [anon_sym___attribute__] = ACTIONS(5546),
    [anon_sym_LBRACE] = ACTIONS(5714),
    [anon_sym_RBRACE] = ACTIONS(5714),
    [anon_sym_LBRACK] = ACTIONS(5714),
    [anon_sym_RBRACK] = ACTIONS(5714),
    [anon_sym_EQ] = ACTIONS(5716),
    [anon_sym_COLON] = ACTIONS(5714),
    [anon_sym_QMARK] = ACTIONS(5714),
    [anon_sym_STAR_EQ] = ACTIONS(5714),
    [anon_sym_SLASH_EQ] = ACTIONS(5714),
    [anon_sym_PERCENT_EQ] = ACTIONS(5714),
    [anon_sym_PLUS_EQ] = ACTIONS(5714),
    [anon_sym_DASH_EQ] = ACTIONS(5714),
    [anon_sym_LT_LT_EQ] = ACTIONS(5714),
    [anon_sym_GT_GT_EQ] = ACTIONS(5714),
    [anon_sym_AMP_EQ] = ACTIONS(5714),
    [anon_sym_CARET_EQ] = ACTIONS(5714),
    [anon_sym_PIPE_EQ] = ACTIONS(5714),
    [anon_sym_and_eq] = ACTIONS(5716),
    [anon_sym_or_eq] = ACTIONS(5716),
    [anon_sym_xor_eq] = ACTIONS(5716),
    [anon_sym_LT_EQ_GT] = ACTIONS(5714),
    [anon_sym_or] = ACTIONS(5716),
    [anon_sym_and] = ACTIONS(5716),
    [anon_sym_bitor] = ACTIONS(5716),
    [anon_sym_xor] = ACTIONS(5716),
    [anon_sym_bitand] = ACTIONS(5716),
    [anon_sym_not_eq] = ACTIONS(5716),
    [anon_sym_DASH_DASH] = ACTIONS(5714),
    [anon_sym_PLUS_PLUS] = ACTIONS(5714),
    [anon_sym_DOT] = ACTIONS(5716),
    [anon_sym_DOT_STAR] = ACTIONS(5714),
    [anon_sym_DASH_GT] = ACTIONS(5714),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5716),
    [anon_sym_decltype] = ACTIONS(5716),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5714),
  },
  [2374] = {
    [sym_attribute_specifier] = STATE(2565),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5682),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_LPAREN2] = ACTIONS(5682),
    [anon_sym_DASH] = ACTIONS(5684),
    [anon_sym_PLUS] = ACTIONS(5684),
    [anon_sym_STAR] = ACTIONS(5682),
    [anon_sym_SLASH] = ACTIONS(5684),
    [anon_sym_PERCENT] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_EQ_EQ] = ACTIONS(5682),
    [anon_sym_BANG_EQ] = ACTIONS(5682),
    [anon_sym_GT] = ACTIONS(5684),
    [anon_sym_GT_EQ] = ACTIONS(5684),
    [anon_sym_LT_EQ] = ACTIONS(5684),
    [anon_sym_LT] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(5684),
    [anon_sym_GT_GT] = ACTIONS(5684),
    [anon_sym___extension__] = ACTIONS(5682),
    [anon_sym___global__] = ACTIONS(5682),
    [anon_sym___attribute__] = ACTIONS(5652),
    [anon_sym_LBRACE] = ACTIONS(5682),
    [anon_sym_LBRACK] = ACTIONS(5682),
    [anon_sym_const] = ACTIONS(5684),
    [anon_sym_constexpr] = ACTIONS(5682),
    [anon_sym_volatile] = ACTIONS(5682),
    [anon_sym_restrict] = ACTIONS(5682),
    [anon_sym___restrict__] = ACTIONS(5682),
    [anon_sym__Atomic] = ACTIONS(5682),
    [anon_sym__Noreturn] = ACTIONS(5682),
    [anon_sym_noreturn] = ACTIONS(5682),
    [anon_sym_mutable] = ACTIONS(5682),
    [anon_sym_constinit] = ACTIONS(5682),
    [anon_sym_consteval] = ACTIONS(5682),
    [anon_sym___shared__] = ACTIONS(5682),
    [anon_sym___local__] = ACTIONS(5682),
    [anon_sym___constant__] = ACTIONS(5682),
    [anon_sym___managed__] = ACTIONS(5682),
    [anon_sym___grid_constant__] = ACTIONS(5682),
    [anon_sym_alignas] = ACTIONS(5682),
    [anon_sym__Alignas] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5682),
    [anon_sym_LT_EQ_GT] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5682),
    [anon_sym_and] = ACTIONS(5682),
    [anon_sym_bitor] = ACTIONS(5682),
    [anon_sym_xor] = ACTIONS(5682),
    [anon_sym_bitand] = ACTIONS(5682),
    [anon_sym_not_eq] = ACTIONS(5682),
    [anon_sym_DASH_DASH] = ACTIONS(5682),
    [anon_sym_PLUS_PLUS] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(5684),
    [anon_sym_DOT_STAR] = ACTIONS(5682),
    [anon_sym_DASH_GT] = ACTIONS(5682),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5682),
    [anon_sym_decltype] = ACTIONS(5682),
    [anon_sym_final] = ACTIONS(5682),
    [anon_sym_override] = ACTIONS(5682),
    [anon_sym_GT2] = ACTIONS(5682),
    [anon_sym_requires] = ACTIONS(5682),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5682),
  },
  [2375] = {
    [sym_template_argument_list] = STATE(2297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(3756),
    [anon_sym_LPAREN2] = ACTIONS(3764),
    [anon_sym_TILDE] = ACTIONS(3764),
    [anon_sym_STAR] = ACTIONS(3764),
    [anon_sym_AMP_AMP] = ACTIONS(3764),
    [anon_sym_AMP] = ACTIONS(3756),
    [anon_sym_LT] = ACTIONS(5534),
    [anon_sym_SEMI] = ACTIONS(3782),
    [anon_sym___extension__] = ACTIONS(3756),
    [anon_sym___device__] = ACTIONS(3756),
    [anon_sym___host__] = ACTIONS(3756),
    [anon_sym___global__] = ACTIONS(3756),
    [anon_sym___forceinline__] = ACTIONS(3756),
    [anon_sym___noinline__] = ACTIONS(3756),
    [anon_sym_extern] = ACTIONS(3756),
    [anon_sym___attribute__] = ACTIONS(3756),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3764),
    [anon_sym___declspec] = ACTIONS(3756),
    [anon_sym___based] = ACTIONS(3756),
    [anon_sym___cdecl] = ACTIONS(3756),
    [anon_sym___clrcall] = ACTIONS(3756),
    [anon_sym___stdcall] = ACTIONS(3756),
    [anon_sym___fastcall] = ACTIONS(3756),
    [anon_sym___thiscall] = ACTIONS(3756),
    [anon_sym___vectorcall] = ACTIONS(3756),
    [anon_sym_signed] = ACTIONS(3784),
    [anon_sym_unsigned] = ACTIONS(3784),
    [anon_sym_long] = ACTIONS(3784),
    [anon_sym_short] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3756),
    [anon_sym_static] = ACTIONS(3756),
    [anon_sym_register] = ACTIONS(3756),
    [anon_sym_inline] = ACTIONS(3756),
    [anon_sym___inline] = ACTIONS(3756),
    [anon_sym___inline__] = ACTIONS(3756),
    [anon_sym___forceinline] = ACTIONS(3756),
    [anon_sym_thread_local] = ACTIONS(3756),
    [anon_sym___thread] = ACTIONS(3756),
    [anon_sym_const] = ACTIONS(3756),
    [anon_sym_constexpr] = ACTIONS(3756),
    [anon_sym_volatile] = ACTIONS(3756),
    [anon_sym_restrict] = ACTIONS(3756),
    [anon_sym___restrict__] = ACTIONS(3756),
    [anon_sym__Atomic] = ACTIONS(3756),
    [anon_sym__Noreturn] = ACTIONS(3756),
    [anon_sym_noreturn] = ACTIONS(3756),
    [anon_sym_mutable] = ACTIONS(3756),
    [anon_sym_constinit] = ACTIONS(3756),
    [anon_sym_consteval] = ACTIONS(3756),
    [anon_sym___shared__] = ACTIONS(3756),
    [anon_sym___local__] = ACTIONS(3756),
    [anon_sym___constant__] = ACTIONS(3756),
    [anon_sym___managed__] = ACTIONS(3756),
    [anon_sym___grid_constant__] = ACTIONS(3756),
    [anon_sym_alignas] = ACTIONS(3756),
    [anon_sym__Alignas] = ACTIONS(3756),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3756),
    [anon_sym_decltype] = ACTIONS(3756),
    [sym_virtual] = ACTIONS(3756),
    [anon_sym_template] = ACTIONS(3756),
    [anon_sym_operator] = ACTIONS(3756),
    [anon_sym___launch_bounds__] = ACTIONS(3756),
  },
  [2376] = {
    [sym_identifier] = ACTIONS(5285),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5287),
    [anon_sym_COMMA] = ACTIONS(5287),
    [anon_sym_RPAREN] = ACTIONS(5287),
    [aux_sym_preproc_if_token2] = ACTIONS(5287),
    [aux_sym_preproc_else_token1] = ACTIONS(5287),
    [aux_sym_preproc_elif_token1] = ACTIONS(5285),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5287),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5287),
    [anon_sym_LPAREN2] = ACTIONS(5287),
    [anon_sym_DASH] = ACTIONS(5285),
    [anon_sym_PLUS] = ACTIONS(5285),
    [anon_sym_STAR] = ACTIONS(5285),
    [anon_sym_SLASH] = ACTIONS(5285),
    [anon_sym_PERCENT] = ACTIONS(5285),
    [anon_sym_PIPE_PIPE] = ACTIONS(5287),
    [anon_sym_AMP_AMP] = ACTIONS(5287),
    [anon_sym_PIPE] = ACTIONS(5285),
    [anon_sym_CARET] = ACTIONS(5285),
    [anon_sym_AMP] = ACTIONS(5285),
    [anon_sym_EQ_EQ] = ACTIONS(5287),
    [anon_sym_BANG_EQ] = ACTIONS(5287),
    [anon_sym_GT] = ACTIONS(5285),
    [anon_sym_GT_EQ] = ACTIONS(5287),
    [anon_sym_LT_EQ] = ACTIONS(5285),
    [anon_sym_LT] = ACTIONS(5285),
    [anon_sym_LT_LT] = ACTIONS(5285),
    [anon_sym_GT_GT] = ACTIONS(5285),
    [anon_sym_SEMI] = ACTIONS(5287),
    [anon_sym___attribute__] = ACTIONS(5285),
    [anon_sym_LBRACE] = ACTIONS(5287),
    [anon_sym_RBRACE] = ACTIONS(5287),
    [anon_sym_LBRACK] = ACTIONS(5287),
    [anon_sym_RBRACK] = ACTIONS(5287),
    [anon_sym_EQ] = ACTIONS(5285),
    [anon_sym_COLON] = ACTIONS(5287),
    [anon_sym_QMARK] = ACTIONS(5287),
    [anon_sym_STAR_EQ] = ACTIONS(5287),
    [anon_sym_SLASH_EQ] = ACTIONS(5287),
    [anon_sym_PERCENT_EQ] = ACTIONS(5287),
    [anon_sym_PLUS_EQ] = ACTIONS(5287),
    [anon_sym_DASH_EQ] = ACTIONS(5287),
    [anon_sym_LT_LT_EQ] = ACTIONS(5287),
    [anon_sym_GT_GT_EQ] = ACTIONS(5287),
    [anon_sym_AMP_EQ] = ACTIONS(5287),
    [anon_sym_CARET_EQ] = ACTIONS(5287),
    [anon_sym_PIPE_EQ] = ACTIONS(5287),
    [anon_sym_and_eq] = ACTIONS(5285),
    [anon_sym_or_eq] = ACTIONS(5285),
    [anon_sym_xor_eq] = ACTIONS(5285),
    [anon_sym_LT_EQ_GT] = ACTIONS(5287),
    [anon_sym_or] = ACTIONS(5285),
    [anon_sym_and] = ACTIONS(5285),
    [anon_sym_bitor] = ACTIONS(5285),
    [anon_sym_xor] = ACTIONS(5285),
    [anon_sym_bitand] = ACTIONS(5285),
    [anon_sym_not_eq] = ACTIONS(5285),
    [anon_sym_DASH_DASH] = ACTIONS(5287),
    [anon_sym_PLUS_PLUS] = ACTIONS(5287),
    [anon_sym_DOT] = ACTIONS(5285),
    [anon_sym_DOT_STAR] = ACTIONS(5287),
    [anon_sym_DASH_GT] = ACTIONS(5287),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5285),
    [anon_sym_decltype] = ACTIONS(5285),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5287),
  },
  [2377] = {
    [sym_identifier] = ACTIONS(5945),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5947),
    [anon_sym_COMMA] = ACTIONS(5947),
    [anon_sym_RPAREN] = ACTIONS(5947),
    [aux_sym_preproc_if_token2] = ACTIONS(5947),
    [aux_sym_preproc_else_token1] = ACTIONS(5947),
    [aux_sym_preproc_elif_token1] = ACTIONS(5945),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5947),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5947),
    [anon_sym_LPAREN2] = ACTIONS(5947),
    [anon_sym_DASH] = ACTIONS(5945),
    [anon_sym_PLUS] = ACTIONS(5945),
    [anon_sym_STAR] = ACTIONS(5945),
    [anon_sym_SLASH] = ACTIONS(5945),
    [anon_sym_PERCENT] = ACTIONS(5945),
    [anon_sym_PIPE_PIPE] = ACTIONS(5947),
    [anon_sym_AMP_AMP] = ACTIONS(5947),
    [anon_sym_PIPE] = ACTIONS(5945),
    [anon_sym_CARET] = ACTIONS(5945),
    [anon_sym_AMP] = ACTIONS(5945),
    [anon_sym_EQ_EQ] = ACTIONS(5947),
    [anon_sym_BANG_EQ] = ACTIONS(5947),
    [anon_sym_GT] = ACTIONS(5945),
    [anon_sym_GT_EQ] = ACTIONS(5947),
    [anon_sym_LT_EQ] = ACTIONS(5945),
    [anon_sym_LT] = ACTIONS(5945),
    [anon_sym_LT_LT] = ACTIONS(5945),
    [anon_sym_GT_GT] = ACTIONS(5945),
    [anon_sym_SEMI] = ACTIONS(5947),
    [anon_sym___attribute__] = ACTIONS(5945),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5947),
    [anon_sym_LBRACE] = ACTIONS(5947),
    [anon_sym_RBRACE] = ACTIONS(5947),
    [anon_sym_LBRACK] = ACTIONS(5945),
    [anon_sym_RBRACK] = ACTIONS(5947),
    [anon_sym_EQ] = ACTIONS(5945),
    [anon_sym_COLON] = ACTIONS(5947),
    [anon_sym_QMARK] = ACTIONS(5947),
    [anon_sym_STAR_EQ] = ACTIONS(5947),
    [anon_sym_SLASH_EQ] = ACTIONS(5947),
    [anon_sym_PERCENT_EQ] = ACTIONS(5947),
    [anon_sym_PLUS_EQ] = ACTIONS(5947),
    [anon_sym_DASH_EQ] = ACTIONS(5947),
    [anon_sym_LT_LT_EQ] = ACTIONS(5947),
    [anon_sym_GT_GT_EQ] = ACTIONS(5947),
    [anon_sym_AMP_EQ] = ACTIONS(5947),
    [anon_sym_CARET_EQ] = ACTIONS(5947),
    [anon_sym_PIPE_EQ] = ACTIONS(5947),
    [anon_sym_and_eq] = ACTIONS(5945),
    [anon_sym_or_eq] = ACTIONS(5945),
    [anon_sym_xor_eq] = ACTIONS(5945),
    [anon_sym_LT_EQ_GT] = ACTIONS(5947),
    [anon_sym_or] = ACTIONS(5945),
    [anon_sym_and] = ACTIONS(5945),
    [anon_sym_bitor] = ACTIONS(5945),
    [anon_sym_xor] = ACTIONS(5945),
    [anon_sym_bitand] = ACTIONS(5945),
    [anon_sym_not_eq] = ACTIONS(5945),
    [anon_sym_DASH_DASH] = ACTIONS(5947),
    [anon_sym_PLUS_PLUS] = ACTIONS(5947),
    [anon_sym_DOT] = ACTIONS(5945),
    [anon_sym_DOT_STAR] = ACTIONS(5947),
    [anon_sym_DASH_GT] = ACTIONS(5947),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(5945),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5947),
  },
  [2378] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2378),
    [sym_identifier] = ACTIONS(5016),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5018),
    [anon_sym_COMMA] = ACTIONS(5018),
    [aux_sym_preproc_if_token2] = ACTIONS(5018),
    [aux_sym_preproc_else_token1] = ACTIONS(5018),
    [aux_sym_preproc_elif_token1] = ACTIONS(5016),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5018),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5018),
    [anon_sym_LPAREN2] = ACTIONS(5018),
    [anon_sym_DASH] = ACTIONS(5016),
    [anon_sym_PLUS] = ACTIONS(5016),
    [anon_sym_STAR] = ACTIONS(5016),
    [anon_sym_SLASH] = ACTIONS(5016),
    [anon_sym_PERCENT] = ACTIONS(5016),
    [anon_sym_PIPE_PIPE] = ACTIONS(5018),
    [anon_sym_AMP_AMP] = ACTIONS(5018),
    [anon_sym_PIPE] = ACTIONS(5016),
    [anon_sym_CARET] = ACTIONS(5016),
    [anon_sym_AMP] = ACTIONS(5016),
    [anon_sym_EQ_EQ] = ACTIONS(5018),
    [anon_sym_BANG_EQ] = ACTIONS(5018),
    [anon_sym_GT] = ACTIONS(5016),
    [anon_sym_GT_EQ] = ACTIONS(5018),
    [anon_sym_LT_EQ] = ACTIONS(5016),
    [anon_sym_LT] = ACTIONS(5016),
    [anon_sym_LT_LT] = ACTIONS(5016),
    [anon_sym_GT_GT] = ACTIONS(5016),
    [anon_sym___attribute__] = ACTIONS(5016),
    [anon_sym_LBRACE] = ACTIONS(5018),
    [anon_sym_signed] = ACTIONS(5949),
    [anon_sym_unsigned] = ACTIONS(5949),
    [anon_sym_long] = ACTIONS(5949),
    [anon_sym_short] = ACTIONS(5949),
    [anon_sym_LBRACK] = ACTIONS(5018),
    [anon_sym_EQ] = ACTIONS(5016),
    [anon_sym_QMARK] = ACTIONS(5018),
    [anon_sym_STAR_EQ] = ACTIONS(5018),
    [anon_sym_SLASH_EQ] = ACTIONS(5018),
    [anon_sym_PERCENT_EQ] = ACTIONS(5018),
    [anon_sym_PLUS_EQ] = ACTIONS(5018),
    [anon_sym_DASH_EQ] = ACTIONS(5018),
    [anon_sym_LT_LT_EQ] = ACTIONS(5018),
    [anon_sym_GT_GT_EQ] = ACTIONS(5018),
    [anon_sym_AMP_EQ] = ACTIONS(5018),
    [anon_sym_CARET_EQ] = ACTIONS(5018),
    [anon_sym_PIPE_EQ] = ACTIONS(5018),
    [anon_sym_and_eq] = ACTIONS(5016),
    [anon_sym_or_eq] = ACTIONS(5016),
    [anon_sym_xor_eq] = ACTIONS(5016),
    [anon_sym_LT_EQ_GT] = ACTIONS(5018),
    [anon_sym_or] = ACTIONS(5016),
    [anon_sym_and] = ACTIONS(5016),
    [anon_sym_bitor] = ACTIONS(5016),
    [anon_sym_xor] = ACTIONS(5016),
    [anon_sym_bitand] = ACTIONS(5016),
    [anon_sym_not_eq] = ACTIONS(5016),
    [anon_sym_DASH_DASH] = ACTIONS(5018),
    [anon_sym_PLUS_PLUS] = ACTIONS(5018),
    [anon_sym_DOT] = ACTIONS(5016),
    [anon_sym_DOT_STAR] = ACTIONS(5018),
    [anon_sym_DASH_GT] = ACTIONS(5018),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5016),
    [anon_sym_decltype] = ACTIONS(5016),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5018),
  },
  [2379] = {
    [sym_template_argument_list] = STATE(1651),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2689),
    [anon_sym_COMMA] = ACTIONS(5532),
    [anon_sym_RPAREN] = ACTIONS(5532),
    [anon_sym_LPAREN2] = ACTIONS(5532),
    [anon_sym_STAR] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5530),
    [anon_sym_LT] = ACTIONS(5534),
    [anon_sym_SEMI] = ACTIONS(5532),
    [anon_sym___extension__] = ACTIONS(5532),
    [anon_sym___device__] = ACTIONS(5532),
    [anon_sym___host__] = ACTIONS(5532),
    [anon_sym___global__] = ACTIONS(5532),
    [anon_sym___forceinline__] = ACTIONS(5532),
    [anon_sym___noinline__] = ACTIONS(5532),
    [anon_sym_extern] = ACTIONS(5532),
    [anon_sym___attribute__] = ACTIONS(5532),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5532),
    [anon_sym___declspec] = ACTIONS(5532),
    [anon_sym_LBRACE] = ACTIONS(5532),
    [anon_sym_signed] = ACTIONS(5952),
    [anon_sym_unsigned] = ACTIONS(5952),
    [anon_sym_long] = ACTIONS(5952),
    [anon_sym_short] = ACTIONS(5952),
    [anon_sym_LBRACK] = ACTIONS(5530),
    [anon_sym_static] = ACTIONS(5532),
    [anon_sym_EQ] = ACTIONS(5532),
    [anon_sym_register] = ACTIONS(5532),
    [anon_sym_inline] = ACTIONS(5532),
    [anon_sym___inline] = ACTIONS(5530),
    [anon_sym___inline__] = ACTIONS(5532),
    [anon_sym___forceinline] = ACTIONS(5530),
    [anon_sym_thread_local] = ACTIONS(5532),
    [anon_sym___thread] = ACTIONS(5532),
    [anon_sym_const] = ACTIONS(5530),
    [anon_sym_constexpr] = ACTIONS(5532),
    [anon_sym_volatile] = ACTIONS(5532),
    [anon_sym_restrict] = ACTIONS(5532),
    [anon_sym___restrict__] = ACTIONS(5532),
    [anon_sym__Atomic] = ACTIONS(5532),
    [anon_sym__Noreturn] = ACTIONS(5532),
    [anon_sym_noreturn] = ACTIONS(5532),
    [anon_sym_mutable] = ACTIONS(5532),
    [anon_sym_constinit] = ACTIONS(5532),
    [anon_sym_consteval] = ACTIONS(5532),
    [anon_sym___shared__] = ACTIONS(5532),
    [anon_sym___local__] = ACTIONS(5532),
    [anon_sym___constant__] = ACTIONS(5532),
    [anon_sym___managed__] = ACTIONS(5532),
    [anon_sym___grid_constant__] = ACTIONS(5532),
    [anon_sym_alignas] = ACTIONS(5532),
    [anon_sym__Alignas] = ACTIONS(5532),
    [anon_sym_asm] = ACTIONS(5532),
    [anon_sym___asm__] = ACTIONS(5532),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5532),
    [anon_sym_decltype] = ACTIONS(5532),
    [anon_sym_final] = ACTIONS(5532),
    [anon_sym_override] = ACTIONS(5532),
    [sym_virtual] = ACTIONS(5532),
    [anon_sym_GT2] = ACTIONS(5532),
    [anon_sym_try] = ACTIONS(5532),
    [anon_sym_requires] = ACTIONS(5532),
    [anon_sym___launch_bounds__] = ACTIONS(5532),
  },
  [2380] = {
    [sym_argument_list] = STATE(2703),
    [sym_initializer_list] = STATE(2703),
    [sym_identifier] = ACTIONS(5954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5956),
    [anon_sym_COMMA] = ACTIONS(5956),
    [anon_sym_RPAREN] = ACTIONS(5956),
    [aux_sym_preproc_if_token2] = ACTIONS(5956),
    [aux_sym_preproc_else_token1] = ACTIONS(5956),
    [aux_sym_preproc_elif_token1] = ACTIONS(5954),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5956),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5956),
    [anon_sym_LPAREN2] = ACTIONS(5644),
    [anon_sym_DASH] = ACTIONS(5954),
    [anon_sym_PLUS] = ACTIONS(5954),
    [anon_sym_STAR] = ACTIONS(5954),
    [anon_sym_SLASH] = ACTIONS(5954),
    [anon_sym_PERCENT] = ACTIONS(5954),
    [anon_sym_PIPE_PIPE] = ACTIONS(5956),
    [anon_sym_AMP_AMP] = ACTIONS(5956),
    [anon_sym_PIPE] = ACTIONS(5954),
    [anon_sym_CARET] = ACTIONS(5954),
    [anon_sym_AMP] = ACTIONS(5954),
    [anon_sym_EQ_EQ] = ACTIONS(5956),
    [anon_sym_BANG_EQ] = ACTIONS(5956),
    [anon_sym_GT] = ACTIONS(5954),
    [anon_sym_GT_EQ] = ACTIONS(5956),
    [anon_sym_LT_EQ] = ACTIONS(5954),
    [anon_sym_LT] = ACTIONS(5954),
    [anon_sym_LT_LT] = ACTIONS(5954),
    [anon_sym_GT_GT] = ACTIONS(5954),
    [anon_sym_SEMI] = ACTIONS(5956),
    [anon_sym___attribute__] = ACTIONS(5954),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_RBRACE] = ACTIONS(5956),
    [anon_sym_LBRACK] = ACTIONS(5956),
    [anon_sym_RBRACK] = ACTIONS(5956),
    [anon_sym_EQ] = ACTIONS(5954),
    [anon_sym_COLON] = ACTIONS(5956),
    [anon_sym_QMARK] = ACTIONS(5956),
    [anon_sym_STAR_EQ] = ACTIONS(5956),
    [anon_sym_SLASH_EQ] = ACTIONS(5956),
    [anon_sym_PERCENT_EQ] = ACTIONS(5956),
    [anon_sym_PLUS_EQ] = ACTIONS(5956),
    [anon_sym_DASH_EQ] = ACTIONS(5956),
    [anon_sym_LT_LT_EQ] = ACTIONS(5956),
    [anon_sym_GT_GT_EQ] = ACTIONS(5956),
    [anon_sym_AMP_EQ] = ACTIONS(5956),
    [anon_sym_CARET_EQ] = ACTIONS(5956),
    [anon_sym_PIPE_EQ] = ACTIONS(5956),
    [anon_sym_and_eq] = ACTIONS(5954),
    [anon_sym_or_eq] = ACTIONS(5954),
    [anon_sym_xor_eq] = ACTIONS(5954),
    [anon_sym_LT_EQ_GT] = ACTIONS(5956),
    [anon_sym_or] = ACTIONS(5954),
    [anon_sym_and] = ACTIONS(5954),
    [anon_sym_bitor] = ACTIONS(5954),
    [anon_sym_xor] = ACTIONS(5954),
    [anon_sym_bitand] = ACTIONS(5954),
    [anon_sym_not_eq] = ACTIONS(5954),
    [anon_sym_DASH_DASH] = ACTIONS(5956),
    [anon_sym_PLUS_PLUS] = ACTIONS(5956),
    [anon_sym_DOT] = ACTIONS(5954),
    [anon_sym_DOT_STAR] = ACTIONS(5956),
    [anon_sym_DASH_GT] = ACTIONS(5956),
    [sym_comment] = ACTIONS(3),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5956),
  },
  [2381] = {
    [sym_identifier] = ACTIONS(5958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5960),
    [anon_sym_COMMA] = ACTIONS(5960),
    [anon_sym_RPAREN] = ACTIONS(5960),
    [aux_sym_preproc_if_token2] = ACTIONS(5960),
    [aux_sym_preproc_else_token1] = ACTIONS(5960),
    [aux_sym_preproc_elif_token1] = ACTIONS(5958),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5960),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5960),
    [anon_sym_LPAREN2] = ACTIONS(5960),
    [anon_sym_DASH] = ACTIONS(5958),
    [anon_sym_PLUS] = ACTIONS(5958),
    [anon_sym_STAR] = ACTIONS(5958),
    [anon_sym_SLASH] = ACTIONS(5958),
    [anon_sym_PERCENT] = ACTIONS(5958),
    [anon_sym_PIPE_PIPE] = ACTIONS(5960),
    [anon_sym_AMP_AMP] = ACTIONS(5960),
    [anon_sym_PIPE] = ACTIONS(5958),
    [anon_sym_CARET] = ACTIONS(5958),
    [anon_sym_AMP] = ACTIONS(5958),
    [anon_sym_EQ_EQ] = ACTIONS(5960),
    [anon_sym_BANG_EQ] = ACTIONS(5960),
    [anon_sym_GT] = ACTIONS(5958),
    [anon_sym_GT_EQ] = ACTIONS(5960),
    [anon_sym_LT_EQ] = ACTIONS(5958),
    [anon_sym_LT] = ACTIONS(5958),
    [anon_sym_LT_LT] = ACTIONS(5958),
    [anon_sym_GT_GT] = ACTIONS(5958),
    [anon_sym_SEMI] = ACTIONS(5960),
    [anon_sym___attribute__] = ACTIONS(5958),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5960),
    [anon_sym_LBRACE] = ACTIONS(5960),
    [anon_sym_RBRACE] = ACTIONS(5960),
    [anon_sym_LBRACK] = ACTIONS(5958),
    [anon_sym_RBRACK] = ACTIONS(5960),
    [anon_sym_EQ] = ACTIONS(5958),
    [anon_sym_COLON] = ACTIONS(5960),
    [anon_sym_QMARK] = ACTIONS(5960),
    [anon_sym_STAR_EQ] = ACTIONS(5960),
    [anon_sym_SLASH_EQ] = ACTIONS(5960),
    [anon_sym_PERCENT_EQ] = ACTIONS(5960),
    [anon_sym_PLUS_EQ] = ACTIONS(5960),
    [anon_sym_DASH_EQ] = ACTIONS(5960),
    [anon_sym_LT_LT_EQ] = ACTIONS(5960),
    [anon_sym_GT_GT_EQ] = ACTIONS(5960),
    [anon_sym_AMP_EQ] = ACTIONS(5960),
    [anon_sym_CARET_EQ] = ACTIONS(5960),
    [anon_sym_PIPE_EQ] = ACTIONS(5960),
    [anon_sym_and_eq] = ACTIONS(5958),
    [anon_sym_or_eq] = ACTIONS(5958),
    [anon_sym_xor_eq] = ACTIONS(5958),
    [anon_sym_LT_EQ_GT] = ACTIONS(5960),
    [anon_sym_or] = ACTIONS(5958),
    [anon_sym_and] = ACTIONS(5958),
    [anon_sym_bitor] = ACTIONS(5958),
    [anon_sym_xor] = ACTIONS(5958),
    [anon_sym_bitand] = ACTIONS(5958),
    [anon_sym_not_eq] = ACTIONS(5958),
    [anon_sym_DASH_DASH] = ACTIONS(5960),
    [anon_sym_PLUS_PLUS] = ACTIONS(5960),
    [anon_sym_DOT] = ACTIONS(5958),
    [anon_sym_DOT_STAR] = ACTIONS(5960),
    [anon_sym_DASH_GT] = ACTIONS(5960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(5958),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5960),
  },
  [2382] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2455),
    [sym_identifier] = ACTIONS(5448),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5446),
    [anon_sym_COMMA] = ACTIONS(5446),
    [aux_sym_preproc_if_token2] = ACTIONS(5446),
    [aux_sym_preproc_else_token1] = ACTIONS(5446),
    [aux_sym_preproc_elif_token1] = ACTIONS(5448),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5446),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5446),
    [anon_sym_LPAREN2] = ACTIONS(5446),
    [anon_sym_DASH] = ACTIONS(5448),
    [anon_sym_PLUS] = ACTIONS(5448),
    [anon_sym_STAR] = ACTIONS(5448),
    [anon_sym_SLASH] = ACTIONS(5448),
    [anon_sym_PERCENT] = ACTIONS(5448),
    [anon_sym_PIPE_PIPE] = ACTIONS(5446),
    [anon_sym_AMP_AMP] = ACTIONS(5446),
    [anon_sym_PIPE] = ACTIONS(5448),
    [anon_sym_CARET] = ACTIONS(5448),
    [anon_sym_AMP] = ACTIONS(5448),
    [anon_sym_EQ_EQ] = ACTIONS(5446),
    [anon_sym_BANG_EQ] = ACTIONS(5446),
    [anon_sym_GT] = ACTIONS(5448),
    [anon_sym_GT_EQ] = ACTIONS(5446),
    [anon_sym_LT_EQ] = ACTIONS(5448),
    [anon_sym_LT] = ACTIONS(5448),
    [anon_sym_LT_LT] = ACTIONS(5448),
    [anon_sym_GT_GT] = ACTIONS(5448),
    [anon_sym___attribute__] = ACTIONS(5448),
    [anon_sym_LBRACE] = ACTIONS(5446),
    [anon_sym_signed] = ACTIONS(5962),
    [anon_sym_unsigned] = ACTIONS(5962),
    [anon_sym_long] = ACTIONS(5962),
    [anon_sym_short] = ACTIONS(5962),
    [anon_sym_LBRACK] = ACTIONS(5446),
    [anon_sym_EQ] = ACTIONS(5448),
    [anon_sym_QMARK] = ACTIONS(5446),
    [anon_sym_STAR_EQ] = ACTIONS(5446),
    [anon_sym_SLASH_EQ] = ACTIONS(5446),
    [anon_sym_PERCENT_EQ] = ACTIONS(5446),
    [anon_sym_PLUS_EQ] = ACTIONS(5446),
    [anon_sym_DASH_EQ] = ACTIONS(5446),
    [anon_sym_LT_LT_EQ] = ACTIONS(5446),
    [anon_sym_GT_GT_EQ] = ACTIONS(5446),
    [anon_sym_AMP_EQ] = ACTIONS(5446),
    [anon_sym_CARET_EQ] = ACTIONS(5446),
    [anon_sym_PIPE_EQ] = ACTIONS(5446),
    [anon_sym_and_eq] = ACTIONS(5448),
    [anon_sym_or_eq] = ACTIONS(5448),
    [anon_sym_xor_eq] = ACTIONS(5448),
    [anon_sym_LT_EQ_GT] = ACTIONS(5446),
    [anon_sym_or] = ACTIONS(5448),
    [anon_sym_and] = ACTIONS(5448),
    [anon_sym_bitor] = ACTIONS(5448),
    [anon_sym_xor] = ACTIONS(5448),
    [anon_sym_bitand] = ACTIONS(5448),
    [anon_sym_not_eq] = ACTIONS(5448),
    [anon_sym_DASH_DASH] = ACTIONS(5446),
    [anon_sym_PLUS_PLUS] = ACTIONS(5446),
    [anon_sym_DOT] = ACTIONS(5448),
    [anon_sym_DOT_STAR] = ACTIONS(5446),
    [anon_sym_DASH_GT] = ACTIONS(5446),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5448),
    [anon_sym_decltype] = ACTIONS(5448),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5446),
  },
  [2383] = {
    [sym_argument_list] = STATE(2659),
    [sym_initializer_list] = STATE(2659),
    [sym_identifier] = ACTIONS(5964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5966),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_RPAREN] = ACTIONS(5966),
    [aux_sym_preproc_if_token2] = ACTIONS(5966),
    [aux_sym_preproc_else_token1] = ACTIONS(5966),
    [aux_sym_preproc_elif_token1] = ACTIONS(5964),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5966),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5966),
    [anon_sym_LPAREN2] = ACTIONS(5644),
    [anon_sym_DASH] = ACTIONS(5964),
    [anon_sym_PLUS] = ACTIONS(5964),
    [anon_sym_STAR] = ACTIONS(5964),
    [anon_sym_SLASH] = ACTIONS(5964),
    [anon_sym_PERCENT] = ACTIONS(5964),
    [anon_sym_PIPE_PIPE] = ACTIONS(5966),
    [anon_sym_AMP_AMP] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(5964),
    [anon_sym_CARET] = ACTIONS(5964),
    [anon_sym_AMP] = ACTIONS(5964),
    [anon_sym_EQ_EQ] = ACTIONS(5966),
    [anon_sym_BANG_EQ] = ACTIONS(5966),
    [anon_sym_GT] = ACTIONS(5964),
    [anon_sym_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_EQ] = ACTIONS(5964),
    [anon_sym_LT] = ACTIONS(5964),
    [anon_sym_LT_LT] = ACTIONS(5964),
    [anon_sym_GT_GT] = ACTIONS(5964),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym___attribute__] = ACTIONS(5964),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_RBRACE] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_RBRACK] = ACTIONS(5966),
    [anon_sym_EQ] = ACTIONS(5964),
    [anon_sym_COLON] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_and_eq] = ACTIONS(5964),
    [anon_sym_or_eq] = ACTIONS(5964),
    [anon_sym_xor_eq] = ACTIONS(5964),
    [anon_sym_LT_EQ_GT] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5964),
    [anon_sym_and] = ACTIONS(5964),
    [anon_sym_bitor] = ACTIONS(5964),
    [anon_sym_xor] = ACTIONS(5964),
    [anon_sym_bitand] = ACTIONS(5964),
    [anon_sym_not_eq] = ACTIONS(5964),
    [anon_sym_DASH_DASH] = ACTIONS(5966),
    [anon_sym_PLUS_PLUS] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(5964),
    [anon_sym_DOT_STAR] = ACTIONS(5966),
    [anon_sym_DASH_GT] = ACTIONS(5966),
    [sym_comment] = ACTIONS(3),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5966),
  },
  [2384] = {
    [sym_attribute_specifier] = STATE(2580),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5698),
    [anon_sym_LPAREN2] = ACTIONS(5698),
    [anon_sym_DASH] = ACTIONS(5700),
    [anon_sym_PLUS] = ACTIONS(5700),
    [anon_sym_STAR] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5700),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_PIPE] = ACTIONS(5700),
    [anon_sym_CARET] = ACTIONS(5698),
    [anon_sym_AMP] = ACTIONS(5700),
    [anon_sym_EQ_EQ] = ACTIONS(5698),
    [anon_sym_BANG_EQ] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5700),
    [anon_sym_GT_EQ] = ACTIONS(5700),
    [anon_sym_LT_EQ] = ACTIONS(5700),
    [anon_sym_LT] = ACTIONS(5700),
    [anon_sym_LT_LT] = ACTIONS(5700),
    [anon_sym_GT_GT] = ACTIONS(5700),
    [anon_sym___extension__] = ACTIONS(5698),
    [anon_sym___global__] = ACTIONS(5698),
    [anon_sym___attribute__] = ACTIONS(5652),
    [anon_sym_LBRACE] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5698),
    [anon_sym_const] = ACTIONS(5700),
    [anon_sym_constexpr] = ACTIONS(5698),
    [anon_sym_volatile] = ACTIONS(5698),
    [anon_sym_restrict] = ACTIONS(5698),
    [anon_sym___restrict__] = ACTIONS(5698),
    [anon_sym__Atomic] = ACTIONS(5698),
    [anon_sym__Noreturn] = ACTIONS(5698),
    [anon_sym_noreturn] = ACTIONS(5698),
    [anon_sym_mutable] = ACTIONS(5698),
    [anon_sym_constinit] = ACTIONS(5698),
    [anon_sym_consteval] = ACTIONS(5698),
    [anon_sym___shared__] = ACTIONS(5698),
    [anon_sym___local__] = ACTIONS(5698),
    [anon_sym___constant__] = ACTIONS(5698),
    [anon_sym___managed__] = ACTIONS(5698),
    [anon_sym___grid_constant__] = ACTIONS(5698),
    [anon_sym_alignas] = ACTIONS(5698),
    [anon_sym__Alignas] = ACTIONS(5698),
    [anon_sym_QMARK] = ACTIONS(5698),
    [anon_sym_LT_EQ_GT] = ACTIONS(5698),
    [anon_sym_or] = ACTIONS(5698),
    [anon_sym_and] = ACTIONS(5698),
    [anon_sym_bitor] = ACTIONS(5698),
    [anon_sym_xor] = ACTIONS(5698),
    [anon_sym_bitand] = ACTIONS(5698),
    [anon_sym_not_eq] = ACTIONS(5698),
    [anon_sym_DASH_DASH] = ACTIONS(5698),
    [anon_sym_PLUS_PLUS] = ACTIONS(5698),
    [anon_sym_DOT] = ACTIONS(5700),
    [anon_sym_DOT_STAR] = ACTIONS(5698),
    [anon_sym_DASH_GT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5698),
    [anon_sym_decltype] = ACTIONS(5698),
    [anon_sym_final] = ACTIONS(5698),
    [anon_sym_override] = ACTIONS(5698),
    [anon_sym_GT2] = ACTIONS(5698),
    [anon_sym_requires] = ACTIONS(5698),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5698),
  },
  [2385] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5181),
    [anon_sym_COMMA] = ACTIONS(5181),
    [anon_sym_LPAREN2] = ACTIONS(5181),
    [anon_sym_DASH] = ACTIONS(5179),
    [anon_sym_PLUS] = ACTIONS(5179),
    [anon_sym_STAR] = ACTIONS(5181),
    [anon_sym_SLASH] = ACTIONS(5179),
    [anon_sym_PERCENT] = ACTIONS(5181),
    [anon_sym_PIPE_PIPE] = ACTIONS(5181),
    [anon_sym_AMP_AMP] = ACTIONS(5181),
    [anon_sym_PIPE] = ACTIONS(5179),
    [anon_sym_CARET] = ACTIONS(5181),
    [anon_sym_AMP] = ACTIONS(5179),
    [anon_sym_EQ_EQ] = ACTIONS(5181),
    [anon_sym_BANG_EQ] = ACTIONS(5181),
    [anon_sym_GT] = ACTIONS(5179),
    [anon_sym_GT_EQ] = ACTIONS(5179),
    [anon_sym_LT_EQ] = ACTIONS(5179),
    [anon_sym_LT] = ACTIONS(5179),
    [anon_sym_LT_LT] = ACTIONS(5179),
    [anon_sym_GT_GT] = ACTIONS(5179),
    [anon_sym___extension__] = ACTIONS(5181),
    [anon_sym___global__] = ACTIONS(5181),
    [anon_sym___attribute__] = ACTIONS(5181),
    [anon_sym_LBRACE] = ACTIONS(5181),
    [anon_sym_LBRACK] = ACTIONS(5181),
    [anon_sym_const] = ACTIONS(5179),
    [anon_sym_constexpr] = ACTIONS(5181),
    [anon_sym_volatile] = ACTIONS(5181),
    [anon_sym_restrict] = ACTIONS(5181),
    [anon_sym___restrict__] = ACTIONS(5181),
    [anon_sym__Atomic] = ACTIONS(5181),
    [anon_sym__Noreturn] = ACTIONS(5181),
    [anon_sym_noreturn] = ACTIONS(5181),
    [anon_sym_mutable] = ACTIONS(5181),
    [anon_sym_constinit] = ACTIONS(5181),
    [anon_sym_consteval] = ACTIONS(5181),
    [anon_sym___shared__] = ACTIONS(5181),
    [anon_sym___local__] = ACTIONS(5181),
    [anon_sym___constant__] = ACTIONS(5181),
    [anon_sym___managed__] = ACTIONS(5181),
    [anon_sym___grid_constant__] = ACTIONS(5181),
    [anon_sym_alignas] = ACTIONS(5181),
    [anon_sym__Alignas] = ACTIONS(5181),
    [anon_sym_COLON] = ACTIONS(5181),
    [anon_sym_QMARK] = ACTIONS(5181),
    [anon_sym_LT_EQ_GT] = ACTIONS(5181),
    [anon_sym_or] = ACTIONS(5181),
    [anon_sym_and] = ACTIONS(5181),
    [anon_sym_bitor] = ACTIONS(5181),
    [anon_sym_xor] = ACTIONS(5181),
    [anon_sym_bitand] = ACTIONS(5181),
    [anon_sym_not_eq] = ACTIONS(5181),
    [anon_sym_DASH_DASH] = ACTIONS(5181),
    [anon_sym_PLUS_PLUS] = ACTIONS(5181),
    [anon_sym_DOT] = ACTIONS(5179),
    [anon_sym_DOT_STAR] = ACTIONS(5181),
    [anon_sym_DASH_GT] = ACTIONS(5181),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5181),
    [anon_sym_decltype] = ACTIONS(5181),
    [anon_sym_final] = ACTIONS(5181),
    [anon_sym_override] = ACTIONS(5181),
    [anon_sym_GT2] = ACTIONS(5181),
    [anon_sym_requires] = ACTIONS(5181),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5181),
  },
  [2386] = {
    [sym_attribute_specifier] = STATE(2575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5721),
    [anon_sym_COMMA] = ACTIONS(5721),
    [anon_sym_LPAREN2] = ACTIONS(5721),
    [anon_sym_DASH] = ACTIONS(5723),
    [anon_sym_PLUS] = ACTIONS(5723),
    [anon_sym_STAR] = ACTIONS(5721),
    [anon_sym_SLASH] = ACTIONS(5723),
    [anon_sym_PERCENT] = ACTIONS(5721),
    [anon_sym_PIPE_PIPE] = ACTIONS(5721),
    [anon_sym_AMP_AMP] = ACTIONS(5721),
    [anon_sym_PIPE] = ACTIONS(5723),
    [anon_sym_CARET] = ACTIONS(5721),
    [anon_sym_AMP] = ACTIONS(5723),
    [anon_sym_EQ_EQ] = ACTIONS(5721),
    [anon_sym_BANG_EQ] = ACTIONS(5721),
    [anon_sym_GT] = ACTIONS(5723),
    [anon_sym_GT_EQ] = ACTIONS(5723),
    [anon_sym_LT_EQ] = ACTIONS(5723),
    [anon_sym_LT] = ACTIONS(5723),
    [anon_sym_LT_LT] = ACTIONS(5723),
    [anon_sym_GT_GT] = ACTIONS(5723),
    [anon_sym___extension__] = ACTIONS(5721),
    [anon_sym___global__] = ACTIONS(5721),
    [anon_sym___attribute__] = ACTIONS(5652),
    [anon_sym_LBRACE] = ACTIONS(5721),
    [anon_sym_LBRACK] = ACTIONS(5721),
    [anon_sym_const] = ACTIONS(5723),
    [anon_sym_constexpr] = ACTIONS(5721),
    [anon_sym_volatile] = ACTIONS(5721),
    [anon_sym_restrict] = ACTIONS(5721),
    [anon_sym___restrict__] = ACTIONS(5721),
    [anon_sym__Atomic] = ACTIONS(5721),
    [anon_sym__Noreturn] = ACTIONS(5721),
    [anon_sym_noreturn] = ACTIONS(5721),
    [anon_sym_mutable] = ACTIONS(5721),
    [anon_sym_constinit] = ACTIONS(5721),
    [anon_sym_consteval] = ACTIONS(5721),
    [anon_sym___shared__] = ACTIONS(5721),
    [anon_sym___local__] = ACTIONS(5721),
    [anon_sym___constant__] = ACTIONS(5721),
    [anon_sym___managed__] = ACTIONS(5721),
    [anon_sym___grid_constant__] = ACTIONS(5721),
    [anon_sym_alignas] = ACTIONS(5721),
    [anon_sym__Alignas] = ACTIONS(5721),
    [anon_sym_QMARK] = ACTIONS(5721),
    [anon_sym_LT_EQ_GT] = ACTIONS(5721),
    [anon_sym_or] = ACTIONS(5721),
    [anon_sym_and] = ACTIONS(5721),
    [anon_sym_bitor] = ACTIONS(5721),
    [anon_sym_xor] = ACTIONS(5721),
    [anon_sym_bitand] = ACTIONS(5721),
    [anon_sym_not_eq] = ACTIONS(5721),
    [anon_sym_DASH_DASH] = ACTIONS(5721),
    [anon_sym_PLUS_PLUS] = ACTIONS(5721),
    [anon_sym_DOT] = ACTIONS(5723),
    [anon_sym_DOT_STAR] = ACTIONS(5721),
    [anon_sym_DASH_GT] = ACTIONS(5721),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5721),
    [anon_sym_decltype] = ACTIONS(5721),
    [anon_sym_final] = ACTIONS(5721),
    [anon_sym_override] = ACTIONS(5721),
    [anon_sym_GT2] = ACTIONS(5721),
    [anon_sym_requires] = ACTIONS(5721),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5721),
  },
  [2387] = {
    [sym_attribute_specifier] = STATE(2570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5714),
    [anon_sym_COMMA] = ACTIONS(5714),
    [anon_sym_LPAREN2] = ACTIONS(5714),
    [anon_sym_DASH] = ACTIONS(5716),
    [anon_sym_PLUS] = ACTIONS(5716),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_SLASH] = ACTIONS(5716),
    [anon_sym_PERCENT] = ACTIONS(5714),
    [anon_sym_PIPE_PIPE] = ACTIONS(5714),
    [anon_sym_AMP_AMP] = ACTIONS(5714),
    [anon_sym_PIPE] = ACTIONS(5716),
    [anon_sym_CARET] = ACTIONS(5714),
    [anon_sym_AMP] = ACTIONS(5716),
    [anon_sym_EQ_EQ] = ACTIONS(5714),
    [anon_sym_BANG_EQ] = ACTIONS(5714),
    [anon_sym_GT] = ACTIONS(5716),
    [anon_sym_GT_EQ] = ACTIONS(5716),
    [anon_sym_LT_EQ] = ACTIONS(5716),
    [anon_sym_LT] = ACTIONS(5716),
    [anon_sym_LT_LT] = ACTIONS(5716),
    [anon_sym_GT_GT] = ACTIONS(5716),
    [anon_sym___extension__] = ACTIONS(5714),
    [anon_sym___global__] = ACTIONS(5714),
    [anon_sym___attribute__] = ACTIONS(5652),
    [anon_sym_LBRACE] = ACTIONS(5714),
    [anon_sym_LBRACK] = ACTIONS(5714),
    [anon_sym_const] = ACTIONS(5716),
    [anon_sym_constexpr] = ACTIONS(5714),
    [anon_sym_volatile] = ACTIONS(5714),
    [anon_sym_restrict] = ACTIONS(5714),
    [anon_sym___restrict__] = ACTIONS(5714),
    [anon_sym__Atomic] = ACTIONS(5714),
    [anon_sym__Noreturn] = ACTIONS(5714),
    [anon_sym_noreturn] = ACTIONS(5714),
    [anon_sym_mutable] = ACTIONS(5714),
    [anon_sym_constinit] = ACTIONS(5714),
    [anon_sym_consteval] = ACTIONS(5714),
    [anon_sym___shared__] = ACTIONS(5714),
    [anon_sym___local__] = ACTIONS(5714),
    [anon_sym___constant__] = ACTIONS(5714),
    [anon_sym___managed__] = ACTIONS(5714),
    [anon_sym___grid_constant__] = ACTIONS(5714),
    [anon_sym_alignas] = ACTIONS(5714),
    [anon_sym__Alignas] = ACTIONS(5714),
    [anon_sym_QMARK] = ACTIONS(5714),
    [anon_sym_LT_EQ_GT] = ACTIONS(5714),
    [anon_sym_or] = ACTIONS(5714),
    [anon_sym_and] = ACTIONS(5714),
    [anon_sym_bitor] = ACTIONS(5714),
    [anon_sym_xor] = ACTIONS(5714),
    [anon_sym_bitand] = ACTIONS(5714),
    [anon_sym_not_eq] = ACTIONS(5714),
    [anon_sym_DASH_DASH] = ACTIONS(5714),
    [anon_sym_PLUS_PLUS] = ACTIONS(5714),
    [anon_sym_DOT] = ACTIONS(5716),
    [anon_sym_DOT_STAR] = ACTIONS(5714),
    [anon_sym_DASH_GT] = ACTIONS(5714),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5714),
    [anon_sym_decltype] = ACTIONS(5714),
    [anon_sym_final] = ACTIONS(5714),
    [anon_sym_override] = ACTIONS(5714),
    [anon_sym_GT2] = ACTIONS(5714),
    [anon_sym_requires] = ACTIONS(5714),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5714),
  },
  [2388] = {
    [sym_attribute_declaration] = STATE(2400),
    [aux_sym_attributed_declarator_repeat1] = STATE(2400),
    [sym_identifier] = ACTIONS(5968),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5970),
    [anon_sym_COMMA] = ACTIONS(5970),
    [anon_sym_RPAREN] = ACTIONS(5970),
    [aux_sym_preproc_if_token2] = ACTIONS(5970),
    [aux_sym_preproc_else_token1] = ACTIONS(5970),
    [aux_sym_preproc_elif_token1] = ACTIONS(5968),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5970),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5970),
    [anon_sym_LPAREN2] = ACTIONS(5970),
    [anon_sym_DASH] = ACTIONS(5968),
    [anon_sym_PLUS] = ACTIONS(5968),
    [anon_sym_STAR] = ACTIONS(5968),
    [anon_sym_SLASH] = ACTIONS(5968),
    [anon_sym_PERCENT] = ACTIONS(5968),
    [anon_sym_PIPE_PIPE] = ACTIONS(5970),
    [anon_sym_AMP_AMP] = ACTIONS(5970),
    [anon_sym_PIPE] = ACTIONS(5968),
    [anon_sym_CARET] = ACTIONS(5968),
    [anon_sym_AMP] = ACTIONS(5968),
    [anon_sym_EQ_EQ] = ACTIONS(5970),
    [anon_sym_BANG_EQ] = ACTIONS(5970),
    [anon_sym_GT] = ACTIONS(5968),
    [anon_sym_GT_EQ] = ACTIONS(5970),
    [anon_sym_LT_EQ] = ACTIONS(5968),
    [anon_sym_LT] = ACTIONS(5968),
    [anon_sym_LT_LT] = ACTIONS(5968),
    [anon_sym_GT_GT] = ACTIONS(5968),
    [anon_sym_SEMI] = ACTIONS(5970),
    [anon_sym___attribute__] = ACTIONS(5968),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5837),
    [anon_sym_RBRACE] = ACTIONS(5970),
    [anon_sym_LBRACK] = ACTIONS(5968),
    [anon_sym_RBRACK] = ACTIONS(5970),
    [anon_sym_EQ] = ACTIONS(5968),
    [anon_sym_COLON] = ACTIONS(5970),
    [anon_sym_QMARK] = ACTIONS(5970),
    [anon_sym_STAR_EQ] = ACTIONS(5970),
    [anon_sym_SLASH_EQ] = ACTIONS(5970),
    [anon_sym_PERCENT_EQ] = ACTIONS(5970),
    [anon_sym_PLUS_EQ] = ACTIONS(5970),
    [anon_sym_DASH_EQ] = ACTIONS(5970),
    [anon_sym_LT_LT_EQ] = ACTIONS(5970),
    [anon_sym_GT_GT_EQ] = ACTIONS(5970),
    [anon_sym_AMP_EQ] = ACTIONS(5970),
    [anon_sym_CARET_EQ] = ACTIONS(5970),
    [anon_sym_PIPE_EQ] = ACTIONS(5970),
    [anon_sym_and_eq] = ACTIONS(5968),
    [anon_sym_or_eq] = ACTIONS(5968),
    [anon_sym_xor_eq] = ACTIONS(5968),
    [anon_sym_LT_EQ_GT] = ACTIONS(5970),
    [anon_sym_or] = ACTIONS(5968),
    [anon_sym_and] = ACTIONS(5968),
    [anon_sym_bitor] = ACTIONS(5968),
    [anon_sym_xor] = ACTIONS(5968),
    [anon_sym_bitand] = ACTIONS(5968),
    [anon_sym_not_eq] = ACTIONS(5968),
    [anon_sym_DASH_DASH] = ACTIONS(5970),
    [anon_sym_PLUS_PLUS] = ACTIONS(5970),
    [anon_sym_DOT] = ACTIONS(5968),
    [anon_sym_DOT_STAR] = ACTIONS(5970),
    [anon_sym_DASH_GT] = ACTIONS(5970),
    [sym_comment] = ACTIONS(3),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5970),
  },
  [2389] = {
    [sym_identifier] = ACTIONS(5972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5974),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_RPAREN] = ACTIONS(5974),
    [aux_sym_preproc_if_token2] = ACTIONS(5974),
    [aux_sym_preproc_else_token1] = ACTIONS(5974),
    [aux_sym_preproc_elif_token1] = ACTIONS(5972),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5974),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5974),
    [anon_sym_LPAREN2] = ACTIONS(5974),
    [anon_sym_DASH] = ACTIONS(5972),
    [anon_sym_PLUS] = ACTIONS(5972),
    [anon_sym_STAR] = ACTIONS(5972),
    [anon_sym_SLASH] = ACTIONS(5972),
    [anon_sym_PERCENT] = ACTIONS(5972),
    [anon_sym_PIPE_PIPE] = ACTIONS(5974),
    [anon_sym_AMP_AMP] = ACTIONS(5974),
    [anon_sym_PIPE] = ACTIONS(5972),
    [anon_sym_CARET] = ACTIONS(5972),
    [anon_sym_AMP] = ACTIONS(5972),
    [anon_sym_EQ_EQ] = ACTIONS(5974),
    [anon_sym_BANG_EQ] = ACTIONS(5974),
    [anon_sym_GT] = ACTIONS(5972),
    [anon_sym_GT_EQ] = ACTIONS(5974),
    [anon_sym_LT_EQ] = ACTIONS(5972),
    [anon_sym_LT] = ACTIONS(5972),
    [anon_sym_LT_LT] = ACTIONS(5972),
    [anon_sym_GT_GT] = ACTIONS(5972),
    [anon_sym_SEMI] = ACTIONS(5974),
    [anon_sym___attribute__] = ACTIONS(5972),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5974),
    [anon_sym_LBRACE] = ACTIONS(5974),
    [anon_sym_RBRACE] = ACTIONS(5974),
    [anon_sym_LBRACK] = ACTIONS(5972),
    [anon_sym_RBRACK] = ACTIONS(5974),
    [anon_sym_EQ] = ACTIONS(5972),
    [anon_sym_COLON] = ACTIONS(5974),
    [anon_sym_QMARK] = ACTIONS(5974),
    [anon_sym_STAR_EQ] = ACTIONS(5974),
    [anon_sym_SLASH_EQ] = ACTIONS(5974),
    [anon_sym_PERCENT_EQ] = ACTIONS(5974),
    [anon_sym_PLUS_EQ] = ACTIONS(5974),
    [anon_sym_DASH_EQ] = ACTIONS(5974),
    [anon_sym_LT_LT_EQ] = ACTIONS(5974),
    [anon_sym_GT_GT_EQ] = ACTIONS(5974),
    [anon_sym_AMP_EQ] = ACTIONS(5974),
    [anon_sym_CARET_EQ] = ACTIONS(5974),
    [anon_sym_PIPE_EQ] = ACTIONS(5974),
    [anon_sym_and_eq] = ACTIONS(5972),
    [anon_sym_or_eq] = ACTIONS(5972),
    [anon_sym_xor_eq] = ACTIONS(5972),
    [anon_sym_LT_EQ_GT] = ACTIONS(5974),
    [anon_sym_or] = ACTIONS(5972),
    [anon_sym_and] = ACTIONS(5972),
    [anon_sym_bitor] = ACTIONS(5972),
    [anon_sym_xor] = ACTIONS(5972),
    [anon_sym_bitand] = ACTIONS(5972),
    [anon_sym_not_eq] = ACTIONS(5972),
    [anon_sym_DASH_DASH] = ACTIONS(5974),
    [anon_sym_PLUS_PLUS] = ACTIONS(5974),
    [anon_sym_DOT] = ACTIONS(5972),
    [anon_sym_DOT_STAR] = ACTIONS(5974),
    [anon_sym_DASH_GT] = ACTIONS(5974),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(5972),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5974),
  },
  [2390] = {
    [sym_identifier] = ACTIONS(5301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5303),
    [anon_sym_COMMA] = ACTIONS(5303),
    [anon_sym_RPAREN] = ACTIONS(5303),
    [aux_sym_preproc_if_token2] = ACTIONS(5303),
    [aux_sym_preproc_else_token1] = ACTIONS(5303),
    [aux_sym_preproc_elif_token1] = ACTIONS(5301),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5303),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5303),
    [anon_sym_LPAREN2] = ACTIONS(5303),
    [anon_sym_DASH] = ACTIONS(5301),
    [anon_sym_PLUS] = ACTIONS(5301),
    [anon_sym_STAR] = ACTIONS(5301),
    [anon_sym_SLASH] = ACTIONS(5301),
    [anon_sym_PERCENT] = ACTIONS(5301),
    [anon_sym_PIPE_PIPE] = ACTIONS(5303),
    [anon_sym_AMP_AMP] = ACTIONS(5303),
    [anon_sym_PIPE] = ACTIONS(5301),
    [anon_sym_CARET] = ACTIONS(5301),
    [anon_sym_AMP] = ACTIONS(5301),
    [anon_sym_EQ_EQ] = ACTIONS(5303),
    [anon_sym_BANG_EQ] = ACTIONS(5303),
    [anon_sym_GT] = ACTIONS(5301),
    [anon_sym_GT_EQ] = ACTIONS(5303),
    [anon_sym_LT_EQ] = ACTIONS(5301),
    [anon_sym_LT] = ACTIONS(5301),
    [anon_sym_LT_LT] = ACTIONS(5301),
    [anon_sym_GT_GT] = ACTIONS(5301),
    [anon_sym_SEMI] = ACTIONS(5303),
    [anon_sym___attribute__] = ACTIONS(5301),
    [anon_sym_LBRACE] = ACTIONS(5303),
    [anon_sym_RBRACE] = ACTIONS(5303),
    [anon_sym_LBRACK] = ACTIONS(5303),
    [anon_sym_RBRACK] = ACTIONS(5303),
    [anon_sym_EQ] = ACTIONS(5301),
    [anon_sym_COLON] = ACTIONS(5303),
    [anon_sym_QMARK] = ACTIONS(5303),
    [anon_sym_STAR_EQ] = ACTIONS(5303),
    [anon_sym_SLASH_EQ] = ACTIONS(5303),
    [anon_sym_PERCENT_EQ] = ACTIONS(5303),
    [anon_sym_PLUS_EQ] = ACTIONS(5303),
    [anon_sym_DASH_EQ] = ACTIONS(5303),
    [anon_sym_LT_LT_EQ] = ACTIONS(5303),
    [anon_sym_GT_GT_EQ] = ACTIONS(5303),
    [anon_sym_AMP_EQ] = ACTIONS(5303),
    [anon_sym_CARET_EQ] = ACTIONS(5303),
    [anon_sym_PIPE_EQ] = ACTIONS(5303),
    [anon_sym_and_eq] = ACTIONS(5301),
    [anon_sym_or_eq] = ACTIONS(5301),
    [anon_sym_xor_eq] = ACTIONS(5301),
    [anon_sym_LT_EQ_GT] = ACTIONS(5303),
    [anon_sym_or] = ACTIONS(5301),
    [anon_sym_and] = ACTIONS(5301),
    [anon_sym_bitor] = ACTIONS(5301),
    [anon_sym_xor] = ACTIONS(5301),
    [anon_sym_bitand] = ACTIONS(5301),
    [anon_sym_not_eq] = ACTIONS(5301),
    [anon_sym_DASH_DASH] = ACTIONS(5303),
    [anon_sym_PLUS_PLUS] = ACTIONS(5303),
    [anon_sym_DOT] = ACTIONS(5301),
    [anon_sym_DOT_STAR] = ACTIONS(5303),
    [anon_sym_DASH_GT] = ACTIONS(5303),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5301),
    [anon_sym_decltype] = ACTIONS(5301),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5303),
  },
  [2391] = {
    [sym_identifier] = ACTIONS(5366),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5368),
    [anon_sym_COMMA] = ACTIONS(5368),
    [anon_sym_RPAREN] = ACTIONS(5368),
    [aux_sym_preproc_if_token2] = ACTIONS(5368),
    [aux_sym_preproc_else_token1] = ACTIONS(5368),
    [aux_sym_preproc_elif_token1] = ACTIONS(5366),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5368),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5368),
    [anon_sym_LPAREN2] = ACTIONS(5368),
    [anon_sym_DASH] = ACTIONS(5366),
    [anon_sym_PLUS] = ACTIONS(5366),
    [anon_sym_STAR] = ACTIONS(5366),
    [anon_sym_SLASH] = ACTIONS(5366),
    [anon_sym_PERCENT] = ACTIONS(5366),
    [anon_sym_PIPE_PIPE] = ACTIONS(5368),
    [anon_sym_AMP_AMP] = ACTIONS(5368),
    [anon_sym_PIPE] = ACTIONS(5366),
    [anon_sym_CARET] = ACTIONS(5366),
    [anon_sym_AMP] = ACTIONS(5366),
    [anon_sym_EQ_EQ] = ACTIONS(5368),
    [anon_sym_BANG_EQ] = ACTIONS(5368),
    [anon_sym_GT] = ACTIONS(5366),
    [anon_sym_GT_EQ] = ACTIONS(5368),
    [anon_sym_LT_EQ] = ACTIONS(5366),
    [anon_sym_LT] = ACTIONS(5366),
    [anon_sym_LT_LT] = ACTIONS(5366),
    [anon_sym_GT_GT] = ACTIONS(5366),
    [anon_sym_SEMI] = ACTIONS(5368),
    [anon_sym___attribute__] = ACTIONS(5366),
    [anon_sym_LBRACE] = ACTIONS(5368),
    [anon_sym_RBRACE] = ACTIONS(5368),
    [anon_sym_LBRACK] = ACTIONS(5368),
    [anon_sym_RBRACK] = ACTIONS(5368),
    [anon_sym_EQ] = ACTIONS(5366),
    [anon_sym_COLON] = ACTIONS(5368),
    [anon_sym_QMARK] = ACTIONS(5368),
    [anon_sym_STAR_EQ] = ACTIONS(5368),
    [anon_sym_SLASH_EQ] = ACTIONS(5368),
    [anon_sym_PERCENT_EQ] = ACTIONS(5368),
    [anon_sym_PLUS_EQ] = ACTIONS(5368),
    [anon_sym_DASH_EQ] = ACTIONS(5368),
    [anon_sym_LT_LT_EQ] = ACTIONS(5368),
    [anon_sym_GT_GT_EQ] = ACTIONS(5368),
    [anon_sym_AMP_EQ] = ACTIONS(5368),
    [anon_sym_CARET_EQ] = ACTIONS(5368),
    [anon_sym_PIPE_EQ] = ACTIONS(5368),
    [anon_sym_and_eq] = ACTIONS(5366),
    [anon_sym_or_eq] = ACTIONS(5366),
    [anon_sym_xor_eq] = ACTIONS(5366),
    [anon_sym_LT_EQ_GT] = ACTIONS(5368),
    [anon_sym_or] = ACTIONS(5366),
    [anon_sym_and] = ACTIONS(5366),
    [anon_sym_bitor] = ACTIONS(5366),
    [anon_sym_xor] = ACTIONS(5366),
    [anon_sym_bitand] = ACTIONS(5366),
    [anon_sym_not_eq] = ACTIONS(5366),
    [anon_sym_DASH_DASH] = ACTIONS(5368),
    [anon_sym_PLUS_PLUS] = ACTIONS(5368),
    [anon_sym_DOT] = ACTIONS(5366),
    [anon_sym_DOT_STAR] = ACTIONS(5368),
    [anon_sym_DASH_GT] = ACTIONS(5368),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5366),
    [anon_sym_decltype] = ACTIONS(5366),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5368),
  },
  [2392] = {
    [sym_identifier] = ACTIONS(5976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5978),
    [anon_sym_COMMA] = ACTIONS(5978),
    [anon_sym_RPAREN] = ACTIONS(5978),
    [aux_sym_preproc_if_token2] = ACTIONS(5978),
    [aux_sym_preproc_else_token1] = ACTIONS(5978),
    [aux_sym_preproc_elif_token1] = ACTIONS(5976),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5978),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5978),
    [anon_sym_LPAREN2] = ACTIONS(5978),
    [anon_sym_DASH] = ACTIONS(5976),
    [anon_sym_PLUS] = ACTIONS(5976),
    [anon_sym_STAR] = ACTIONS(5976),
    [anon_sym_SLASH] = ACTIONS(5976),
    [anon_sym_PERCENT] = ACTIONS(5976),
    [anon_sym_PIPE_PIPE] = ACTIONS(5978),
    [anon_sym_AMP_AMP] = ACTIONS(5978),
    [anon_sym_PIPE] = ACTIONS(5976),
    [anon_sym_CARET] = ACTIONS(5976),
    [anon_sym_AMP] = ACTIONS(5976),
    [anon_sym_EQ_EQ] = ACTIONS(5978),
    [anon_sym_BANG_EQ] = ACTIONS(5978),
    [anon_sym_GT] = ACTIONS(5976),
    [anon_sym_GT_EQ] = ACTIONS(5978),
    [anon_sym_LT_EQ] = ACTIONS(5976),
    [anon_sym_LT] = ACTIONS(5976),
    [anon_sym_LT_LT] = ACTIONS(5976),
    [anon_sym_GT_GT] = ACTIONS(5976),
    [anon_sym_SEMI] = ACTIONS(5978),
    [anon_sym___attribute__] = ACTIONS(5976),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5978),
    [anon_sym_LBRACE] = ACTIONS(5978),
    [anon_sym_RBRACE] = ACTIONS(5978),
    [anon_sym_LBRACK] = ACTIONS(5976),
    [anon_sym_RBRACK] = ACTIONS(5978),
    [anon_sym_EQ] = ACTIONS(5976),
    [anon_sym_COLON] = ACTIONS(5978),
    [anon_sym_QMARK] = ACTIONS(5978),
    [anon_sym_STAR_EQ] = ACTIONS(5978),
    [anon_sym_SLASH_EQ] = ACTIONS(5978),
    [anon_sym_PERCENT_EQ] = ACTIONS(5978),
    [anon_sym_PLUS_EQ] = ACTIONS(5978),
    [anon_sym_DASH_EQ] = ACTIONS(5978),
    [anon_sym_LT_LT_EQ] = ACTIONS(5978),
    [anon_sym_GT_GT_EQ] = ACTIONS(5978),
    [anon_sym_AMP_EQ] = ACTIONS(5978),
    [anon_sym_CARET_EQ] = ACTIONS(5978),
    [anon_sym_PIPE_EQ] = ACTIONS(5978),
    [anon_sym_and_eq] = ACTIONS(5976),
    [anon_sym_or_eq] = ACTIONS(5976),
    [anon_sym_xor_eq] = ACTIONS(5976),
    [anon_sym_LT_EQ_GT] = ACTIONS(5978),
    [anon_sym_or] = ACTIONS(5976),
    [anon_sym_and] = ACTIONS(5976),
    [anon_sym_bitor] = ACTIONS(5976),
    [anon_sym_xor] = ACTIONS(5976),
    [anon_sym_bitand] = ACTIONS(5976),
    [anon_sym_not_eq] = ACTIONS(5976),
    [anon_sym_DASH_DASH] = ACTIONS(5978),
    [anon_sym_PLUS_PLUS] = ACTIONS(5978),
    [anon_sym_DOT] = ACTIONS(5976),
    [anon_sym_DOT_STAR] = ACTIONS(5978),
    [anon_sym_DASH_GT] = ACTIONS(5978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(5976),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5978),
  },
  [2393] = {
    [sym_identifier] = ACTIONS(5362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5364),
    [anon_sym_COMMA] = ACTIONS(5364),
    [anon_sym_RPAREN] = ACTIONS(5364),
    [aux_sym_preproc_if_token2] = ACTIONS(5364),
    [aux_sym_preproc_else_token1] = ACTIONS(5364),
    [aux_sym_preproc_elif_token1] = ACTIONS(5362),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5364),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5364),
    [anon_sym_LPAREN2] = ACTIONS(5364),
    [anon_sym_DASH] = ACTIONS(5362),
    [anon_sym_PLUS] = ACTIONS(5362),
    [anon_sym_STAR] = ACTIONS(5362),
    [anon_sym_SLASH] = ACTIONS(5362),
    [anon_sym_PERCENT] = ACTIONS(5362),
    [anon_sym_PIPE_PIPE] = ACTIONS(5364),
    [anon_sym_AMP_AMP] = ACTIONS(5364),
    [anon_sym_PIPE] = ACTIONS(5362),
    [anon_sym_CARET] = ACTIONS(5362),
    [anon_sym_AMP] = ACTIONS(5362),
    [anon_sym_EQ_EQ] = ACTIONS(5364),
    [anon_sym_BANG_EQ] = ACTIONS(5364),
    [anon_sym_GT] = ACTIONS(5362),
    [anon_sym_GT_EQ] = ACTIONS(5364),
    [anon_sym_LT_EQ] = ACTIONS(5362),
    [anon_sym_LT] = ACTIONS(5362),
    [anon_sym_LT_LT] = ACTIONS(5362),
    [anon_sym_GT_GT] = ACTIONS(5362),
    [anon_sym_SEMI] = ACTIONS(5364),
    [anon_sym___attribute__] = ACTIONS(5362),
    [anon_sym_LBRACE] = ACTIONS(5364),
    [anon_sym_RBRACE] = ACTIONS(5364),
    [anon_sym_LBRACK] = ACTIONS(5364),
    [anon_sym_RBRACK] = ACTIONS(5364),
    [anon_sym_EQ] = ACTIONS(5362),
    [anon_sym_COLON] = ACTIONS(5364),
    [anon_sym_QMARK] = ACTIONS(5364),
    [anon_sym_STAR_EQ] = ACTIONS(5364),
    [anon_sym_SLASH_EQ] = ACTIONS(5364),
    [anon_sym_PERCENT_EQ] = ACTIONS(5364),
    [anon_sym_PLUS_EQ] = ACTIONS(5364),
    [anon_sym_DASH_EQ] = ACTIONS(5364),
    [anon_sym_LT_LT_EQ] = ACTIONS(5364),
    [anon_sym_GT_GT_EQ] = ACTIONS(5364),
    [anon_sym_AMP_EQ] = ACTIONS(5364),
    [anon_sym_CARET_EQ] = ACTIONS(5364),
    [anon_sym_PIPE_EQ] = ACTIONS(5364),
    [anon_sym_and_eq] = ACTIONS(5362),
    [anon_sym_or_eq] = ACTIONS(5362),
    [anon_sym_xor_eq] = ACTIONS(5362),
    [anon_sym_LT_EQ_GT] = ACTIONS(5364),
    [anon_sym_or] = ACTIONS(5362),
    [anon_sym_and] = ACTIONS(5362),
    [anon_sym_bitor] = ACTIONS(5362),
    [anon_sym_xor] = ACTIONS(5362),
    [anon_sym_bitand] = ACTIONS(5362),
    [anon_sym_not_eq] = ACTIONS(5362),
    [anon_sym_DASH_DASH] = ACTIONS(5364),
    [anon_sym_PLUS_PLUS] = ACTIONS(5364),
    [anon_sym_DOT] = ACTIONS(5362),
    [anon_sym_DOT_STAR] = ACTIONS(5364),
    [anon_sym_DASH_GT] = ACTIONS(5364),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5362),
    [anon_sym_decltype] = ACTIONS(5362),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5364),
  },
  [2394] = {
    [sym_identifier] = ACTIONS(5358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5360),
    [anon_sym_COMMA] = ACTIONS(5360),
    [anon_sym_RPAREN] = ACTIONS(5360),
    [aux_sym_preproc_if_token2] = ACTIONS(5360),
    [aux_sym_preproc_else_token1] = ACTIONS(5360),
    [aux_sym_preproc_elif_token1] = ACTIONS(5358),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5360),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5360),
    [anon_sym_LPAREN2] = ACTIONS(5360),
    [anon_sym_DASH] = ACTIONS(5358),
    [anon_sym_PLUS] = ACTIONS(5358),
    [anon_sym_STAR] = ACTIONS(5358),
    [anon_sym_SLASH] = ACTIONS(5358),
    [anon_sym_PERCENT] = ACTIONS(5358),
    [anon_sym_PIPE_PIPE] = ACTIONS(5360),
    [anon_sym_AMP_AMP] = ACTIONS(5360),
    [anon_sym_PIPE] = ACTIONS(5358),
    [anon_sym_CARET] = ACTIONS(5358),
    [anon_sym_AMP] = ACTIONS(5358),
    [anon_sym_EQ_EQ] = ACTIONS(5360),
    [anon_sym_BANG_EQ] = ACTIONS(5360),
    [anon_sym_GT] = ACTIONS(5358),
    [anon_sym_GT_EQ] = ACTIONS(5360),
    [anon_sym_LT_EQ] = ACTIONS(5358),
    [anon_sym_LT] = ACTIONS(5358),
    [anon_sym_LT_LT] = ACTIONS(5358),
    [anon_sym_GT_GT] = ACTIONS(5358),
    [anon_sym_SEMI] = ACTIONS(5360),
    [anon_sym___attribute__] = ACTIONS(5358),
    [anon_sym_LBRACE] = ACTIONS(5360),
    [anon_sym_RBRACE] = ACTIONS(5360),
    [anon_sym_LBRACK] = ACTIONS(5360),
    [anon_sym_RBRACK] = ACTIONS(5360),
    [anon_sym_EQ] = ACTIONS(5358),
    [anon_sym_COLON] = ACTIONS(5360),
    [anon_sym_QMARK] = ACTIONS(5360),
    [anon_sym_STAR_EQ] = ACTIONS(5360),
    [anon_sym_SLASH_EQ] = ACTIONS(5360),
    [anon_sym_PERCENT_EQ] = ACTIONS(5360),
    [anon_sym_PLUS_EQ] = ACTIONS(5360),
    [anon_sym_DASH_EQ] = ACTIONS(5360),
    [anon_sym_LT_LT_EQ] = ACTIONS(5360),
    [anon_sym_GT_GT_EQ] = ACTIONS(5360),
    [anon_sym_AMP_EQ] = ACTIONS(5360),
    [anon_sym_CARET_EQ] = ACTIONS(5360),
    [anon_sym_PIPE_EQ] = ACTIONS(5360),
    [anon_sym_and_eq] = ACTIONS(5358),
    [anon_sym_or_eq] = ACTIONS(5358),
    [anon_sym_xor_eq] = ACTIONS(5358),
    [anon_sym_LT_EQ_GT] = ACTIONS(5360),
    [anon_sym_or] = ACTIONS(5358),
    [anon_sym_and] = ACTIONS(5358),
    [anon_sym_bitor] = ACTIONS(5358),
    [anon_sym_xor] = ACTIONS(5358),
    [anon_sym_bitand] = ACTIONS(5358),
    [anon_sym_not_eq] = ACTIONS(5358),
    [anon_sym_DASH_DASH] = ACTIONS(5360),
    [anon_sym_PLUS_PLUS] = ACTIONS(5360),
    [anon_sym_DOT] = ACTIONS(5358),
    [anon_sym_DOT_STAR] = ACTIONS(5360),
    [anon_sym_DASH_GT] = ACTIONS(5360),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5358),
    [anon_sym_decltype] = ACTIONS(5358),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5360),
  },
  [2395] = {
    [sym_identifier] = ACTIONS(5354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5356),
    [anon_sym_COMMA] = ACTIONS(5356),
    [anon_sym_RPAREN] = ACTIONS(5356),
    [aux_sym_preproc_if_token2] = ACTIONS(5356),
    [aux_sym_preproc_else_token1] = ACTIONS(5356),
    [aux_sym_preproc_elif_token1] = ACTIONS(5354),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5356),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5356),
    [anon_sym_LPAREN2] = ACTIONS(5356),
    [anon_sym_DASH] = ACTIONS(5354),
    [anon_sym_PLUS] = ACTIONS(5354),
    [anon_sym_STAR] = ACTIONS(5354),
    [anon_sym_SLASH] = ACTIONS(5354),
    [anon_sym_PERCENT] = ACTIONS(5354),
    [anon_sym_PIPE_PIPE] = ACTIONS(5356),
    [anon_sym_AMP_AMP] = ACTIONS(5356),
    [anon_sym_PIPE] = ACTIONS(5354),
    [anon_sym_CARET] = ACTIONS(5354),
    [anon_sym_AMP] = ACTIONS(5354),
    [anon_sym_EQ_EQ] = ACTIONS(5356),
    [anon_sym_BANG_EQ] = ACTIONS(5356),
    [anon_sym_GT] = ACTIONS(5354),
    [anon_sym_GT_EQ] = ACTIONS(5356),
    [anon_sym_LT_EQ] = ACTIONS(5354),
    [anon_sym_LT] = ACTIONS(5354),
    [anon_sym_LT_LT] = ACTIONS(5354),
    [anon_sym_GT_GT] = ACTIONS(5354),
    [anon_sym_SEMI] = ACTIONS(5356),
    [anon_sym___attribute__] = ACTIONS(5354),
    [anon_sym_LBRACE] = ACTIONS(5356),
    [anon_sym_RBRACE] = ACTIONS(5356),
    [anon_sym_LBRACK] = ACTIONS(5356),
    [anon_sym_RBRACK] = ACTIONS(5356),
    [anon_sym_EQ] = ACTIONS(5354),
    [anon_sym_COLON] = ACTIONS(5356),
    [anon_sym_QMARK] = ACTIONS(5356),
    [anon_sym_STAR_EQ] = ACTIONS(5356),
    [anon_sym_SLASH_EQ] = ACTIONS(5356),
    [anon_sym_PERCENT_EQ] = ACTIONS(5356),
    [anon_sym_PLUS_EQ] = ACTIONS(5356),
    [anon_sym_DASH_EQ] = ACTIONS(5356),
    [anon_sym_LT_LT_EQ] = ACTIONS(5356),
    [anon_sym_GT_GT_EQ] = ACTIONS(5356),
    [anon_sym_AMP_EQ] = ACTIONS(5356),
    [anon_sym_CARET_EQ] = ACTIONS(5356),
    [anon_sym_PIPE_EQ] = ACTIONS(5356),
    [anon_sym_and_eq] = ACTIONS(5354),
    [anon_sym_or_eq] = ACTIONS(5354),
    [anon_sym_xor_eq] = ACTIONS(5354),
    [anon_sym_LT_EQ_GT] = ACTIONS(5356),
    [anon_sym_or] = ACTIONS(5354),
    [anon_sym_and] = ACTIONS(5354),
    [anon_sym_bitor] = ACTIONS(5354),
    [anon_sym_xor] = ACTIONS(5354),
    [anon_sym_bitand] = ACTIONS(5354),
    [anon_sym_not_eq] = ACTIONS(5354),
    [anon_sym_DASH_DASH] = ACTIONS(5356),
    [anon_sym_PLUS_PLUS] = ACTIONS(5356),
    [anon_sym_DOT] = ACTIONS(5354),
    [anon_sym_DOT_STAR] = ACTIONS(5356),
    [anon_sym_DASH_GT] = ACTIONS(5356),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5354),
    [anon_sym_decltype] = ACTIONS(5354),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5356),
  },
  [2396] = {
    [sym_identifier] = ACTIONS(5192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5194),
    [anon_sym_COMMA] = ACTIONS(5194),
    [anon_sym_RPAREN] = ACTIONS(5194),
    [aux_sym_preproc_if_token2] = ACTIONS(5194),
    [aux_sym_preproc_else_token1] = ACTIONS(5194),
    [aux_sym_preproc_elif_token1] = ACTIONS(5192),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5194),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5194),
    [anon_sym_LPAREN2] = ACTIONS(5194),
    [anon_sym_DASH] = ACTIONS(5192),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_STAR] = ACTIONS(5192),
    [anon_sym_SLASH] = ACTIONS(5192),
    [anon_sym_PERCENT] = ACTIONS(5192),
    [anon_sym_PIPE_PIPE] = ACTIONS(5194),
    [anon_sym_AMP_AMP] = ACTIONS(5194),
    [anon_sym_PIPE] = ACTIONS(5192),
    [anon_sym_CARET] = ACTIONS(5192),
    [anon_sym_AMP] = ACTIONS(5192),
    [anon_sym_EQ_EQ] = ACTIONS(5194),
    [anon_sym_BANG_EQ] = ACTIONS(5194),
    [anon_sym_GT] = ACTIONS(5192),
    [anon_sym_GT_EQ] = ACTIONS(5194),
    [anon_sym_LT_EQ] = ACTIONS(5192),
    [anon_sym_LT] = ACTIONS(5192),
    [anon_sym_LT_LT] = ACTIONS(5192),
    [anon_sym_GT_GT] = ACTIONS(5192),
    [anon_sym_SEMI] = ACTIONS(5194),
    [anon_sym___attribute__] = ACTIONS(5192),
    [anon_sym_LBRACE] = ACTIONS(5194),
    [anon_sym_RBRACE] = ACTIONS(5194),
    [anon_sym_LBRACK] = ACTIONS(5194),
    [anon_sym_RBRACK] = ACTIONS(5194),
    [anon_sym_EQ] = ACTIONS(5192),
    [anon_sym_COLON] = ACTIONS(5194),
    [anon_sym_QMARK] = ACTIONS(5194),
    [anon_sym_STAR_EQ] = ACTIONS(5194),
    [anon_sym_SLASH_EQ] = ACTIONS(5194),
    [anon_sym_PERCENT_EQ] = ACTIONS(5194),
    [anon_sym_PLUS_EQ] = ACTIONS(5194),
    [anon_sym_DASH_EQ] = ACTIONS(5194),
    [anon_sym_LT_LT_EQ] = ACTIONS(5194),
    [anon_sym_GT_GT_EQ] = ACTIONS(5194),
    [anon_sym_AMP_EQ] = ACTIONS(5194),
    [anon_sym_CARET_EQ] = ACTIONS(5194),
    [anon_sym_PIPE_EQ] = ACTIONS(5194),
    [anon_sym_and_eq] = ACTIONS(5192),
    [anon_sym_or_eq] = ACTIONS(5192),
    [anon_sym_xor_eq] = ACTIONS(5192),
    [anon_sym_LT_EQ_GT] = ACTIONS(5194),
    [anon_sym_or] = ACTIONS(5192),
    [anon_sym_and] = ACTIONS(5192),
    [anon_sym_bitor] = ACTIONS(5192),
    [anon_sym_xor] = ACTIONS(5192),
    [anon_sym_bitand] = ACTIONS(5192),
    [anon_sym_not_eq] = ACTIONS(5192),
    [anon_sym_DASH_DASH] = ACTIONS(5194),
    [anon_sym_PLUS_PLUS] = ACTIONS(5194),
    [anon_sym_DOT] = ACTIONS(5192),
    [anon_sym_DOT_STAR] = ACTIONS(5194),
    [anon_sym_DASH_GT] = ACTIONS(5194),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5192),
    [anon_sym_decltype] = ACTIONS(5192),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5194),
  },
  [2397] = {
    [sym_string_literal] = STATE(2291),
    [sym_raw_string_literal] = STATE(2291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5712),
    [anon_sym_COMMA] = ACTIONS(5712),
    [anon_sym_RPAREN] = ACTIONS(5712),
    [anon_sym_LPAREN2] = ACTIONS(5712),
    [anon_sym_DASH] = ACTIONS(5710),
    [anon_sym_PLUS] = ACTIONS(5710),
    [anon_sym_STAR] = ACTIONS(5710),
    [anon_sym_SLASH] = ACTIONS(5710),
    [anon_sym_PERCENT] = ACTIONS(5710),
    [anon_sym_PIPE_PIPE] = ACTIONS(5712),
    [anon_sym_AMP_AMP] = ACTIONS(5712),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_CARET] = ACTIONS(5710),
    [anon_sym_AMP] = ACTIONS(5710),
    [anon_sym_EQ_EQ] = ACTIONS(5712),
    [anon_sym_BANG_EQ] = ACTIONS(5712),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_EQ] = ACTIONS(5712),
    [anon_sym_LT_EQ] = ACTIONS(5710),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5710),
    [anon_sym_LBRACK] = ACTIONS(5712),
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_QMARK] = ACTIONS(5712),
    [anon_sym_STAR_EQ] = ACTIONS(5712),
    [anon_sym_SLASH_EQ] = ACTIONS(5712),
    [anon_sym_PERCENT_EQ] = ACTIONS(5712),
    [anon_sym_PLUS_EQ] = ACTIONS(5712),
    [anon_sym_DASH_EQ] = ACTIONS(5712),
    [anon_sym_LT_LT_EQ] = ACTIONS(5712),
    [anon_sym_GT_GT_EQ] = ACTIONS(5712),
    [anon_sym_AMP_EQ] = ACTIONS(5712),
    [anon_sym_CARET_EQ] = ACTIONS(5712),
    [anon_sym_PIPE_EQ] = ACTIONS(5712),
    [anon_sym_and_eq] = ACTIONS(5710),
    [anon_sym_or_eq] = ACTIONS(5710),
    [anon_sym_xor_eq] = ACTIONS(5710),
    [anon_sym_LT_EQ_GT] = ACTIONS(5712),
    [anon_sym_or] = ACTIONS(5710),
    [anon_sym_and] = ACTIONS(5710),
    [anon_sym_bitor] = ACTIONS(5710),
    [anon_sym_xor] = ACTIONS(5710),
    [anon_sym_bitand] = ACTIONS(5710),
    [anon_sym_not_eq] = ACTIONS(5710),
    [anon_sym_DASH_DASH] = ACTIONS(5712),
    [anon_sym_PLUS_PLUS] = ACTIONS(5712),
    [anon_sym_DOT] = ACTIONS(5710),
    [anon_sym_DOT_STAR] = ACTIONS(5712),
    [anon_sym_DASH_GT] = ACTIONS(5710),
    [anon_sym_L_DQUOTE] = ACTIONS(4814),
    [anon_sym_u_DQUOTE] = ACTIONS(4814),
    [anon_sym_U_DQUOTE] = ACTIONS(4814),
    [anon_sym_u8_DQUOTE] = ACTIONS(4814),
    [anon_sym_DQUOTE] = ACTIONS(4814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4816),
    [anon_sym_LR_DQUOTE] = ACTIONS(4816),
    [anon_sym_uR_DQUOTE] = ACTIONS(4816),
    [anon_sym_UR_DQUOTE] = ACTIONS(4816),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4816),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5712),
    [sym_literal_suffix] = ACTIONS(5980),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5712),
  },
  [2398] = {
    [sym_identifier] = ACTIONS(5982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5984),
    [anon_sym_COMMA] = ACTIONS(5984),
    [anon_sym_RPAREN] = ACTIONS(5984),
    [aux_sym_preproc_if_token2] = ACTIONS(5984),
    [aux_sym_preproc_else_token1] = ACTIONS(5984),
    [aux_sym_preproc_elif_token1] = ACTIONS(5982),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5984),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5984),
    [anon_sym_LPAREN2] = ACTIONS(5984),
    [anon_sym_DASH] = ACTIONS(5982),
    [anon_sym_PLUS] = ACTIONS(5982),
    [anon_sym_STAR] = ACTIONS(5982),
    [anon_sym_SLASH] = ACTIONS(5982),
    [anon_sym_PERCENT] = ACTIONS(5982),
    [anon_sym_PIPE_PIPE] = ACTIONS(5984),
    [anon_sym_AMP_AMP] = ACTIONS(5984),
    [anon_sym_PIPE] = ACTIONS(5982),
    [anon_sym_CARET] = ACTIONS(5982),
    [anon_sym_AMP] = ACTIONS(5982),
    [anon_sym_EQ_EQ] = ACTIONS(5984),
    [anon_sym_BANG_EQ] = ACTIONS(5984),
    [anon_sym_GT] = ACTIONS(5982),
    [anon_sym_GT_EQ] = ACTIONS(5984),
    [anon_sym_LT_EQ] = ACTIONS(5982),
    [anon_sym_LT] = ACTIONS(5982),
    [anon_sym_LT_LT] = ACTIONS(5982),
    [anon_sym_GT_GT] = ACTIONS(5982),
    [anon_sym_SEMI] = ACTIONS(5984),
    [anon_sym___attribute__] = ACTIONS(5982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5984),
    [anon_sym_LBRACE] = ACTIONS(5984),
    [anon_sym_RBRACE] = ACTIONS(5984),
    [anon_sym_LBRACK] = ACTIONS(5982),
    [anon_sym_RBRACK] = ACTIONS(5984),
    [anon_sym_EQ] = ACTIONS(5982),
    [anon_sym_COLON] = ACTIONS(5984),
    [anon_sym_QMARK] = ACTIONS(5984),
    [anon_sym_STAR_EQ] = ACTIONS(5984),
    [anon_sym_SLASH_EQ] = ACTIONS(5984),
    [anon_sym_PERCENT_EQ] = ACTIONS(5984),
    [anon_sym_PLUS_EQ] = ACTIONS(5984),
    [anon_sym_DASH_EQ] = ACTIONS(5984),
    [anon_sym_LT_LT_EQ] = ACTIONS(5984),
    [anon_sym_GT_GT_EQ] = ACTIONS(5984),
    [anon_sym_AMP_EQ] = ACTIONS(5984),
    [anon_sym_CARET_EQ] = ACTIONS(5984),
    [anon_sym_PIPE_EQ] = ACTIONS(5984),
    [anon_sym_and_eq] = ACTIONS(5982),
    [anon_sym_or_eq] = ACTIONS(5982),
    [anon_sym_xor_eq] = ACTIONS(5982),
    [anon_sym_LT_EQ_GT] = ACTIONS(5984),
    [anon_sym_or] = ACTIONS(5982),
    [anon_sym_and] = ACTIONS(5982),
    [anon_sym_bitor] = ACTIONS(5982),
    [anon_sym_xor] = ACTIONS(5982),
    [anon_sym_bitand] = ACTIONS(5982),
    [anon_sym_not_eq] = ACTIONS(5982),
    [anon_sym_DASH_DASH] = ACTIONS(5984),
    [anon_sym_PLUS_PLUS] = ACTIONS(5984),
    [anon_sym_DOT] = ACTIONS(5982),
    [anon_sym_DOT_STAR] = ACTIONS(5984),
    [anon_sym_DASH_GT] = ACTIONS(5984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(5982),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5984),
  },
  [2399] = {
    [sym_attribute_specifier] = STATE(2587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5633),
    [anon_sym_COMMA] = ACTIONS(5633),
    [anon_sym_LPAREN2] = ACTIONS(5633),
    [anon_sym_DASH] = ACTIONS(5635),
    [anon_sym_PLUS] = ACTIONS(5635),
    [anon_sym_STAR] = ACTIONS(5633),
    [anon_sym_SLASH] = ACTIONS(5635),
    [anon_sym_PERCENT] = ACTIONS(5633),
    [anon_sym_PIPE_PIPE] = ACTIONS(5633),
    [anon_sym_AMP_AMP] = ACTIONS(5633),
    [anon_sym_PIPE] = ACTIONS(5635),
    [anon_sym_CARET] = ACTIONS(5633),
    [anon_sym_AMP] = ACTIONS(5635),
    [anon_sym_EQ_EQ] = ACTIONS(5633),
    [anon_sym_BANG_EQ] = ACTIONS(5633),
    [anon_sym_GT] = ACTIONS(5635),
    [anon_sym_GT_EQ] = ACTIONS(5635),
    [anon_sym_LT_EQ] = ACTIONS(5635),
    [anon_sym_LT] = ACTIONS(5635),
    [anon_sym_LT_LT] = ACTIONS(5635),
    [anon_sym_GT_GT] = ACTIONS(5635),
    [anon_sym___extension__] = ACTIONS(5633),
    [anon_sym___global__] = ACTIONS(5633),
    [anon_sym___attribute__] = ACTIONS(5652),
    [anon_sym_LBRACE] = ACTIONS(5633),
    [anon_sym_LBRACK] = ACTIONS(5633),
    [anon_sym_const] = ACTIONS(5635),
    [anon_sym_constexpr] = ACTIONS(5633),
    [anon_sym_volatile] = ACTIONS(5633),
    [anon_sym_restrict] = ACTIONS(5633),
    [anon_sym___restrict__] = ACTIONS(5633),
    [anon_sym__Atomic] = ACTIONS(5633),
    [anon_sym__Noreturn] = ACTIONS(5633),
    [anon_sym_noreturn] = ACTIONS(5633),
    [anon_sym_mutable] = ACTIONS(5633),
    [anon_sym_constinit] = ACTIONS(5633),
    [anon_sym_consteval] = ACTIONS(5633),
    [anon_sym___shared__] = ACTIONS(5633),
    [anon_sym___local__] = ACTIONS(5633),
    [anon_sym___constant__] = ACTIONS(5633),
    [anon_sym___managed__] = ACTIONS(5633),
    [anon_sym___grid_constant__] = ACTIONS(5633),
    [anon_sym_alignas] = ACTIONS(5633),
    [anon_sym__Alignas] = ACTIONS(5633),
    [anon_sym_QMARK] = ACTIONS(5633),
    [anon_sym_LT_EQ_GT] = ACTIONS(5633),
    [anon_sym_or] = ACTIONS(5633),
    [anon_sym_and] = ACTIONS(5633),
    [anon_sym_bitor] = ACTIONS(5633),
    [anon_sym_xor] = ACTIONS(5633),
    [anon_sym_bitand] = ACTIONS(5633),
    [anon_sym_not_eq] = ACTIONS(5633),
    [anon_sym_DASH_DASH] = ACTIONS(5633),
    [anon_sym_PLUS_PLUS] = ACTIONS(5633),
    [anon_sym_DOT] = ACTIONS(5635),
    [anon_sym_DOT_STAR] = ACTIONS(5633),
    [anon_sym_DASH_GT] = ACTIONS(5633),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5633),
    [anon_sym_decltype] = ACTIONS(5633),
    [anon_sym_final] = ACTIONS(5633),
    [anon_sym_override] = ACTIONS(5633),
    [anon_sym_GT2] = ACTIONS(5633),
    [anon_sym_requires] = ACTIONS(5633),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5633),
  },
  [2400] = {
    [sym_attribute_declaration] = STATE(2400),
    [aux_sym_attributed_declarator_repeat1] = STATE(2400),
    [sym_identifier] = ACTIONS(5986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5988),
    [anon_sym_COMMA] = ACTIONS(5988),
    [anon_sym_RPAREN] = ACTIONS(5988),
    [aux_sym_preproc_if_token2] = ACTIONS(5988),
    [aux_sym_preproc_else_token1] = ACTIONS(5988),
    [aux_sym_preproc_elif_token1] = ACTIONS(5986),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5988),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5988),
    [anon_sym_LPAREN2] = ACTIONS(5988),
    [anon_sym_DASH] = ACTIONS(5986),
    [anon_sym_PLUS] = ACTIONS(5986),
    [anon_sym_STAR] = ACTIONS(5986),
    [anon_sym_SLASH] = ACTIONS(5986),
    [anon_sym_PERCENT] = ACTIONS(5986),
    [anon_sym_PIPE_PIPE] = ACTIONS(5988),
    [anon_sym_AMP_AMP] = ACTIONS(5988),
    [anon_sym_PIPE] = ACTIONS(5986),
    [anon_sym_CARET] = ACTIONS(5986),
    [anon_sym_AMP] = ACTIONS(5986),
    [anon_sym_EQ_EQ] = ACTIONS(5988),
    [anon_sym_BANG_EQ] = ACTIONS(5988),
    [anon_sym_GT] = ACTIONS(5986),
    [anon_sym_GT_EQ] = ACTIONS(5988),
    [anon_sym_LT_EQ] = ACTIONS(5986),
    [anon_sym_LT] = ACTIONS(5986),
    [anon_sym_LT_LT] = ACTIONS(5986),
    [anon_sym_GT_GT] = ACTIONS(5986),
    [anon_sym_SEMI] = ACTIONS(5988),
    [anon_sym___attribute__] = ACTIONS(5986),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5990),
    [anon_sym_RBRACE] = ACTIONS(5988),
    [anon_sym_LBRACK] = ACTIONS(5986),
    [anon_sym_RBRACK] = ACTIONS(5988),
    [anon_sym_EQ] = ACTIONS(5986),
    [anon_sym_COLON] = ACTIONS(5988),
    [anon_sym_QMARK] = ACTIONS(5988),
    [anon_sym_STAR_EQ] = ACTIONS(5988),
    [anon_sym_SLASH_EQ] = ACTIONS(5988),
    [anon_sym_PERCENT_EQ] = ACTIONS(5988),
    [anon_sym_PLUS_EQ] = ACTIONS(5988),
    [anon_sym_DASH_EQ] = ACTIONS(5988),
    [anon_sym_LT_LT_EQ] = ACTIONS(5988),
    [anon_sym_GT_GT_EQ] = ACTIONS(5988),
    [anon_sym_AMP_EQ] = ACTIONS(5988),
    [anon_sym_CARET_EQ] = ACTIONS(5988),
    [anon_sym_PIPE_EQ] = ACTIONS(5988),
    [anon_sym_and_eq] = ACTIONS(5986),
    [anon_sym_or_eq] = ACTIONS(5986),
    [anon_sym_xor_eq] = ACTIONS(5986),
    [anon_sym_LT_EQ_GT] = ACTIONS(5988),
    [anon_sym_or] = ACTIONS(5986),
    [anon_sym_and] = ACTIONS(5986),
    [anon_sym_bitor] = ACTIONS(5986),
    [anon_sym_xor] = ACTIONS(5986),
    [anon_sym_bitand] = ACTIONS(5986),
    [anon_sym_not_eq] = ACTIONS(5986),
    [anon_sym_DASH_DASH] = ACTIONS(5988),
    [anon_sym_PLUS_PLUS] = ACTIONS(5988),
    [anon_sym_DOT] = ACTIONS(5986),
    [anon_sym_DOT_STAR] = ACTIONS(5988),
    [anon_sym_DASH_GT] = ACTIONS(5988),
    [sym_comment] = ACTIONS(3),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5988),
  },
  [2401] = {
    [sym_identifier] = ACTIONS(5246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5248),
    [anon_sym_COMMA] = ACTIONS(5248),
    [anon_sym_RPAREN] = ACTIONS(5248),
    [aux_sym_preproc_if_token2] = ACTIONS(5248),
    [aux_sym_preproc_else_token1] = ACTIONS(5248),
    [aux_sym_preproc_elif_token1] = ACTIONS(5246),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5248),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5248),
    [anon_sym_LPAREN2] = ACTIONS(5248),
    [anon_sym_DASH] = ACTIONS(5246),
    [anon_sym_PLUS] = ACTIONS(5246),
    [anon_sym_STAR] = ACTIONS(5246),
    [anon_sym_SLASH] = ACTIONS(5246),
    [anon_sym_PERCENT] = ACTIONS(5246),
    [anon_sym_PIPE_PIPE] = ACTIONS(5248),
    [anon_sym_AMP_AMP] = ACTIONS(5248),
    [anon_sym_PIPE] = ACTIONS(5246),
    [anon_sym_CARET] = ACTIONS(5246),
    [anon_sym_AMP] = ACTIONS(5246),
    [anon_sym_EQ_EQ] = ACTIONS(5248),
    [anon_sym_BANG_EQ] = ACTIONS(5248),
    [anon_sym_GT] = ACTIONS(5246),
    [anon_sym_GT_EQ] = ACTIONS(5248),
    [anon_sym_LT_EQ] = ACTIONS(5246),
    [anon_sym_LT] = ACTIONS(5246),
    [anon_sym_LT_LT] = ACTIONS(5246),
    [anon_sym_GT_GT] = ACTIONS(5246),
    [anon_sym_SEMI] = ACTIONS(5248),
    [anon_sym___attribute__] = ACTIONS(5246),
    [anon_sym_LBRACE] = ACTIONS(5248),
    [anon_sym_RBRACE] = ACTIONS(5248),
    [anon_sym_LBRACK] = ACTIONS(5248),
    [anon_sym_RBRACK] = ACTIONS(5248),
    [anon_sym_EQ] = ACTIONS(5246),
    [anon_sym_COLON] = ACTIONS(5248),
    [anon_sym_QMARK] = ACTIONS(5248),
    [anon_sym_STAR_EQ] = ACTIONS(5248),
    [anon_sym_SLASH_EQ] = ACTIONS(5248),
    [anon_sym_PERCENT_EQ] = ACTIONS(5248),
    [anon_sym_PLUS_EQ] = ACTIONS(5248),
    [anon_sym_DASH_EQ] = ACTIONS(5248),
    [anon_sym_LT_LT_EQ] = ACTIONS(5248),
    [anon_sym_GT_GT_EQ] = ACTIONS(5248),
    [anon_sym_AMP_EQ] = ACTIONS(5248),
    [anon_sym_CARET_EQ] = ACTIONS(5248),
    [anon_sym_PIPE_EQ] = ACTIONS(5248),
    [anon_sym_and_eq] = ACTIONS(5246),
    [anon_sym_or_eq] = ACTIONS(5246),
    [anon_sym_xor_eq] = ACTIONS(5246),
    [anon_sym_LT_EQ_GT] = ACTIONS(5248),
    [anon_sym_or] = ACTIONS(5246),
    [anon_sym_and] = ACTIONS(5246),
    [anon_sym_bitor] = ACTIONS(5246),
    [anon_sym_xor] = ACTIONS(5246),
    [anon_sym_bitand] = ACTIONS(5246),
    [anon_sym_not_eq] = ACTIONS(5246),
    [anon_sym_DASH_DASH] = ACTIONS(5248),
    [anon_sym_PLUS_PLUS] = ACTIONS(5248),
    [anon_sym_DOT] = ACTIONS(5246),
    [anon_sym_DOT_STAR] = ACTIONS(5248),
    [anon_sym_DASH_GT] = ACTIONS(5248),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5246),
    [anon_sym_decltype] = ACTIONS(5246),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5248),
  },
  [2402] = {
    [sym_identifier] = ACTIONS(5246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5248),
    [anon_sym_COMMA] = ACTIONS(5248),
    [anon_sym_RPAREN] = ACTIONS(5248),
    [aux_sym_preproc_if_token2] = ACTIONS(5248),
    [aux_sym_preproc_else_token1] = ACTIONS(5248),
    [aux_sym_preproc_elif_token1] = ACTIONS(5246),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5248),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5248),
    [anon_sym_LPAREN2] = ACTIONS(5248),
    [anon_sym_DASH] = ACTIONS(5246),
    [anon_sym_PLUS] = ACTIONS(5246),
    [anon_sym_STAR] = ACTIONS(5246),
    [anon_sym_SLASH] = ACTIONS(5246),
    [anon_sym_PERCENT] = ACTIONS(5246),
    [anon_sym_PIPE_PIPE] = ACTIONS(5248),
    [anon_sym_AMP_AMP] = ACTIONS(5248),
    [anon_sym_PIPE] = ACTIONS(5246),
    [anon_sym_CARET] = ACTIONS(5246),
    [anon_sym_AMP] = ACTIONS(5246),
    [anon_sym_EQ_EQ] = ACTIONS(5248),
    [anon_sym_BANG_EQ] = ACTIONS(5248),
    [anon_sym_GT] = ACTIONS(5246),
    [anon_sym_GT_EQ] = ACTIONS(5248),
    [anon_sym_LT_EQ] = ACTIONS(5246),
    [anon_sym_LT] = ACTIONS(5246),
    [anon_sym_LT_LT] = ACTIONS(5246),
    [anon_sym_GT_GT] = ACTIONS(5246),
    [anon_sym_SEMI] = ACTIONS(5248),
    [anon_sym___attribute__] = ACTIONS(5246),
    [anon_sym_LBRACE] = ACTIONS(5248),
    [anon_sym_RBRACE] = ACTIONS(5248),
    [anon_sym_LBRACK] = ACTIONS(5248),
    [anon_sym_RBRACK] = ACTIONS(5248),
    [anon_sym_EQ] = ACTIONS(5246),
    [anon_sym_COLON] = ACTIONS(5248),
    [anon_sym_QMARK] = ACTIONS(5248),
    [anon_sym_STAR_EQ] = ACTIONS(5248),
    [anon_sym_SLASH_EQ] = ACTIONS(5248),
    [anon_sym_PERCENT_EQ] = ACTIONS(5248),
    [anon_sym_PLUS_EQ] = ACTIONS(5248),
    [anon_sym_DASH_EQ] = ACTIONS(5248),
    [anon_sym_LT_LT_EQ] = ACTIONS(5248),
    [anon_sym_GT_GT_EQ] = ACTIONS(5248),
    [anon_sym_AMP_EQ] = ACTIONS(5248),
    [anon_sym_CARET_EQ] = ACTIONS(5248),
    [anon_sym_PIPE_EQ] = ACTIONS(5248),
    [anon_sym_and_eq] = ACTIONS(5246),
    [anon_sym_or_eq] = ACTIONS(5246),
    [anon_sym_xor_eq] = ACTIONS(5246),
    [anon_sym_LT_EQ_GT] = ACTIONS(5248),
    [anon_sym_or] = ACTIONS(5246),
    [anon_sym_and] = ACTIONS(5246),
    [anon_sym_bitor] = ACTIONS(5246),
    [anon_sym_xor] = ACTIONS(5246),
    [anon_sym_bitand] = ACTIONS(5246),
    [anon_sym_not_eq] = ACTIONS(5246),
    [anon_sym_DASH_DASH] = ACTIONS(5248),
    [anon_sym_PLUS_PLUS] = ACTIONS(5248),
    [anon_sym_DOT] = ACTIONS(5246),
    [anon_sym_DOT_STAR] = ACTIONS(5248),
    [anon_sym_DASH_GT] = ACTIONS(5248),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5246),
    [anon_sym_decltype] = ACTIONS(5246),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5248),
  },
  [2403] = {
    [sym_template_argument_list] = STATE(2938),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(3756),
    [anon_sym_LPAREN2] = ACTIONS(3779),
    [anon_sym_TILDE] = ACTIONS(3764),
    [anon_sym_STAR] = ACTIONS(3764),
    [anon_sym_AMP_AMP] = ACTIONS(3764),
    [anon_sym_AMP] = ACTIONS(3756),
    [anon_sym_LT] = ACTIONS(5534),
    [anon_sym_SEMI] = ACTIONS(3764),
    [anon_sym___extension__] = ACTIONS(3756),
    [anon_sym___device__] = ACTIONS(3756),
    [anon_sym___host__] = ACTIONS(3756),
    [anon_sym___global__] = ACTIONS(3756),
    [anon_sym___forceinline__] = ACTIONS(3756),
    [anon_sym___noinline__] = ACTIONS(3756),
    [anon_sym_extern] = ACTIONS(3756),
    [anon_sym___attribute__] = ACTIONS(3756),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3779),
    [anon_sym___declspec] = ACTIONS(3756),
    [anon_sym___based] = ACTIONS(3756),
    [anon_sym___cdecl] = ACTIONS(3756),
    [anon_sym___clrcall] = ACTIONS(3756),
    [anon_sym___stdcall] = ACTIONS(3756),
    [anon_sym___fastcall] = ACTIONS(3756),
    [anon_sym___thiscall] = ACTIONS(3756),
    [anon_sym___vectorcall] = ACTIONS(3756),
    [anon_sym_signed] = ACTIONS(3784),
    [anon_sym_unsigned] = ACTIONS(3784),
    [anon_sym_long] = ACTIONS(3784),
    [anon_sym_short] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(5993),
    [anon_sym_static] = ACTIONS(3756),
    [anon_sym_register] = ACTIONS(3756),
    [anon_sym_inline] = ACTIONS(3756),
    [anon_sym___inline] = ACTIONS(3756),
    [anon_sym___inline__] = ACTIONS(3756),
    [anon_sym___forceinline] = ACTIONS(3756),
    [anon_sym_thread_local] = ACTIONS(3756),
    [anon_sym___thread] = ACTIONS(3756),
    [anon_sym_const] = ACTIONS(3756),
    [anon_sym_constexpr] = ACTIONS(3756),
    [anon_sym_volatile] = ACTIONS(3756),
    [anon_sym_restrict] = ACTIONS(3756),
    [anon_sym___restrict__] = ACTIONS(3756),
    [anon_sym__Atomic] = ACTIONS(3756),
    [anon_sym__Noreturn] = ACTIONS(3756),
    [anon_sym_noreturn] = ACTIONS(3756),
    [anon_sym_mutable] = ACTIONS(3756),
    [anon_sym_constinit] = ACTIONS(3756),
    [anon_sym_consteval] = ACTIONS(3756),
    [anon_sym___shared__] = ACTIONS(3756),
    [anon_sym___local__] = ACTIONS(3756),
    [anon_sym___constant__] = ACTIONS(3756),
    [anon_sym___managed__] = ACTIONS(3756),
    [anon_sym___grid_constant__] = ACTIONS(3756),
    [anon_sym_alignas] = ACTIONS(3756),
    [anon_sym__Alignas] = ACTIONS(3756),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3756),
    [anon_sym_decltype] = ACTIONS(3756),
    [sym_virtual] = ACTIONS(3756),
    [anon_sym_template] = ACTIONS(3756),
    [anon_sym_operator] = ACTIONS(3756),
    [anon_sym___launch_bounds__] = ACTIONS(3756),
  },
  [2404] = {
    [sym_identifier] = ACTIONS(5254),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5256),
    [anon_sym_COMMA] = ACTIONS(5256),
    [anon_sym_RPAREN] = ACTIONS(5256),
    [aux_sym_preproc_if_token2] = ACTIONS(5256),
    [aux_sym_preproc_else_token1] = ACTIONS(5256),
    [aux_sym_preproc_elif_token1] = ACTIONS(5254),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5256),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5256),
    [anon_sym_LPAREN2] = ACTIONS(5256),
    [anon_sym_DASH] = ACTIONS(5254),
    [anon_sym_PLUS] = ACTIONS(5254),
    [anon_sym_STAR] = ACTIONS(5254),
    [anon_sym_SLASH] = ACTIONS(5254),
    [anon_sym_PERCENT] = ACTIONS(5254),
    [anon_sym_PIPE_PIPE] = ACTIONS(5256),
    [anon_sym_AMP_AMP] = ACTIONS(5256),
    [anon_sym_PIPE] = ACTIONS(5254),
    [anon_sym_CARET] = ACTIONS(5254),
    [anon_sym_AMP] = ACTIONS(5254),
    [anon_sym_EQ_EQ] = ACTIONS(5256),
    [anon_sym_BANG_EQ] = ACTIONS(5256),
    [anon_sym_GT] = ACTIONS(5254),
    [anon_sym_GT_EQ] = ACTIONS(5256),
    [anon_sym_LT_EQ] = ACTIONS(5254),
    [anon_sym_LT] = ACTIONS(5254),
    [anon_sym_LT_LT] = ACTIONS(5254),
    [anon_sym_GT_GT] = ACTIONS(5254),
    [anon_sym_SEMI] = ACTIONS(5256),
    [anon_sym___attribute__] = ACTIONS(5254),
    [anon_sym_LBRACE] = ACTIONS(5256),
    [anon_sym_RBRACE] = ACTIONS(5256),
    [anon_sym_LBRACK] = ACTIONS(5256),
    [anon_sym_RBRACK] = ACTIONS(5256),
    [anon_sym_EQ] = ACTIONS(5254),
    [anon_sym_COLON] = ACTIONS(5256),
    [anon_sym_QMARK] = ACTIONS(5256),
    [anon_sym_STAR_EQ] = ACTIONS(5256),
    [anon_sym_SLASH_EQ] = ACTIONS(5256),
    [anon_sym_PERCENT_EQ] = ACTIONS(5256),
    [anon_sym_PLUS_EQ] = ACTIONS(5256),
    [anon_sym_DASH_EQ] = ACTIONS(5256),
    [anon_sym_LT_LT_EQ] = ACTIONS(5256),
    [anon_sym_GT_GT_EQ] = ACTIONS(5256),
    [anon_sym_AMP_EQ] = ACTIONS(5256),
    [anon_sym_CARET_EQ] = ACTIONS(5256),
    [anon_sym_PIPE_EQ] = ACTIONS(5256),
    [anon_sym_and_eq] = ACTIONS(5254),
    [anon_sym_or_eq] = ACTIONS(5254),
    [anon_sym_xor_eq] = ACTIONS(5254),
    [anon_sym_LT_EQ_GT] = ACTIONS(5256),
    [anon_sym_or] = ACTIONS(5254),
    [anon_sym_and] = ACTIONS(5254),
    [anon_sym_bitor] = ACTIONS(5254),
    [anon_sym_xor] = ACTIONS(5254),
    [anon_sym_bitand] = ACTIONS(5254),
    [anon_sym_not_eq] = ACTIONS(5254),
    [anon_sym_DASH_DASH] = ACTIONS(5256),
    [anon_sym_PLUS_PLUS] = ACTIONS(5256),
    [anon_sym_DOT] = ACTIONS(5254),
    [anon_sym_DOT_STAR] = ACTIONS(5256),
    [anon_sym_DASH_GT] = ACTIONS(5256),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5254),
    [anon_sym_decltype] = ACTIONS(5254),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5256),
  },
  [2405] = {
    [sym_identifier] = ACTIONS(5250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5252),
    [anon_sym_COMMA] = ACTIONS(5252),
    [anon_sym_RPAREN] = ACTIONS(5252),
    [aux_sym_preproc_if_token2] = ACTIONS(5252),
    [aux_sym_preproc_else_token1] = ACTIONS(5252),
    [aux_sym_preproc_elif_token1] = ACTIONS(5250),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5252),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5252),
    [anon_sym_LPAREN2] = ACTIONS(5252),
    [anon_sym_DASH] = ACTIONS(5250),
    [anon_sym_PLUS] = ACTIONS(5250),
    [anon_sym_STAR] = ACTIONS(5250),
    [anon_sym_SLASH] = ACTIONS(5250),
    [anon_sym_PERCENT] = ACTIONS(5250),
    [anon_sym_PIPE_PIPE] = ACTIONS(5252),
    [anon_sym_AMP_AMP] = ACTIONS(5252),
    [anon_sym_PIPE] = ACTIONS(5250),
    [anon_sym_CARET] = ACTIONS(5250),
    [anon_sym_AMP] = ACTIONS(5250),
    [anon_sym_EQ_EQ] = ACTIONS(5252),
    [anon_sym_BANG_EQ] = ACTIONS(5252),
    [anon_sym_GT] = ACTIONS(5250),
    [anon_sym_GT_EQ] = ACTIONS(5252),
    [anon_sym_LT_EQ] = ACTIONS(5250),
    [anon_sym_LT] = ACTIONS(5250),
    [anon_sym_LT_LT] = ACTIONS(5250),
    [anon_sym_GT_GT] = ACTIONS(5250),
    [anon_sym_SEMI] = ACTIONS(5252),
    [anon_sym___attribute__] = ACTIONS(5250),
    [anon_sym_LBRACE] = ACTIONS(5252),
    [anon_sym_RBRACE] = ACTIONS(5252),
    [anon_sym_LBRACK] = ACTIONS(5252),
    [anon_sym_RBRACK] = ACTIONS(5252),
    [anon_sym_EQ] = ACTIONS(5250),
    [anon_sym_COLON] = ACTIONS(5252),
    [anon_sym_QMARK] = ACTIONS(5252),
    [anon_sym_STAR_EQ] = ACTIONS(5252),
    [anon_sym_SLASH_EQ] = ACTIONS(5252),
    [anon_sym_PERCENT_EQ] = ACTIONS(5252),
    [anon_sym_PLUS_EQ] = ACTIONS(5252),
    [anon_sym_DASH_EQ] = ACTIONS(5252),
    [anon_sym_LT_LT_EQ] = ACTIONS(5252),
    [anon_sym_GT_GT_EQ] = ACTIONS(5252),
    [anon_sym_AMP_EQ] = ACTIONS(5252),
    [anon_sym_CARET_EQ] = ACTIONS(5252),
    [anon_sym_PIPE_EQ] = ACTIONS(5252),
    [anon_sym_and_eq] = ACTIONS(5250),
    [anon_sym_or_eq] = ACTIONS(5250),
    [anon_sym_xor_eq] = ACTIONS(5250),
    [anon_sym_LT_EQ_GT] = ACTIONS(5252),
    [anon_sym_or] = ACTIONS(5250),
    [anon_sym_and] = ACTIONS(5250),
    [anon_sym_bitor] = ACTIONS(5250),
    [anon_sym_xor] = ACTIONS(5250),
    [anon_sym_bitand] = ACTIONS(5250),
    [anon_sym_not_eq] = ACTIONS(5250),
    [anon_sym_DASH_DASH] = ACTIONS(5252),
    [anon_sym_PLUS_PLUS] = ACTIONS(5252),
    [anon_sym_DOT] = ACTIONS(5250),
    [anon_sym_DOT_STAR] = ACTIONS(5252),
    [anon_sym_DASH_GT] = ACTIONS(5252),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5250),
    [anon_sym_decltype] = ACTIONS(5250),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5252),
  },
  [2406] = {
    [sym_identifier] = ACTIONS(5246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5248),
    [anon_sym_COMMA] = ACTIONS(5248),
    [anon_sym_RPAREN] = ACTIONS(5248),
    [aux_sym_preproc_if_token2] = ACTIONS(5248),
    [aux_sym_preproc_else_token1] = ACTIONS(5248),
    [aux_sym_preproc_elif_token1] = ACTIONS(5246),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5248),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5248),
    [anon_sym_LPAREN2] = ACTIONS(5248),
    [anon_sym_DASH] = ACTIONS(5246),
    [anon_sym_PLUS] = ACTIONS(5246),
    [anon_sym_STAR] = ACTIONS(5246),
    [anon_sym_SLASH] = ACTIONS(5246),
    [anon_sym_PERCENT] = ACTIONS(5246),
    [anon_sym_PIPE_PIPE] = ACTIONS(5248),
    [anon_sym_AMP_AMP] = ACTIONS(5248),
    [anon_sym_PIPE] = ACTIONS(5246),
    [anon_sym_CARET] = ACTIONS(5246),
    [anon_sym_AMP] = ACTIONS(5246),
    [anon_sym_EQ_EQ] = ACTIONS(5248),
    [anon_sym_BANG_EQ] = ACTIONS(5248),
    [anon_sym_GT] = ACTIONS(5246),
    [anon_sym_GT_EQ] = ACTIONS(5248),
    [anon_sym_LT_EQ] = ACTIONS(5246),
    [anon_sym_LT] = ACTIONS(5246),
    [anon_sym_LT_LT] = ACTIONS(5246),
    [anon_sym_GT_GT] = ACTIONS(5246),
    [anon_sym_SEMI] = ACTIONS(5248),
    [anon_sym___attribute__] = ACTIONS(5246),
    [anon_sym_LBRACE] = ACTIONS(5248),
    [anon_sym_RBRACE] = ACTIONS(5248),
    [anon_sym_LBRACK] = ACTIONS(5248),
    [anon_sym_RBRACK] = ACTIONS(5248),
    [anon_sym_EQ] = ACTIONS(5246),
    [anon_sym_COLON] = ACTIONS(5248),
    [anon_sym_QMARK] = ACTIONS(5248),
    [anon_sym_STAR_EQ] = ACTIONS(5248),
    [anon_sym_SLASH_EQ] = ACTIONS(5248),
    [anon_sym_PERCENT_EQ] = ACTIONS(5248),
    [anon_sym_PLUS_EQ] = ACTIONS(5248),
    [anon_sym_DASH_EQ] = ACTIONS(5248),
    [anon_sym_LT_LT_EQ] = ACTIONS(5248),
    [anon_sym_GT_GT_EQ] = ACTIONS(5248),
    [anon_sym_AMP_EQ] = ACTIONS(5248),
    [anon_sym_CARET_EQ] = ACTIONS(5248),
    [anon_sym_PIPE_EQ] = ACTIONS(5248),
    [anon_sym_and_eq] = ACTIONS(5246),
    [anon_sym_or_eq] = ACTIONS(5246),
    [anon_sym_xor_eq] = ACTIONS(5246),
    [anon_sym_LT_EQ_GT] = ACTIONS(5248),
    [anon_sym_or] = ACTIONS(5246),
    [anon_sym_and] = ACTIONS(5246),
    [anon_sym_bitor] = ACTIONS(5246),
    [anon_sym_xor] = ACTIONS(5246),
    [anon_sym_bitand] = ACTIONS(5246),
    [anon_sym_not_eq] = ACTIONS(5246),
    [anon_sym_DASH_DASH] = ACTIONS(5248),
    [anon_sym_PLUS_PLUS] = ACTIONS(5248),
    [anon_sym_DOT] = ACTIONS(5246),
    [anon_sym_DOT_STAR] = ACTIONS(5248),
    [anon_sym_DASH_GT] = ACTIONS(5248),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5246),
    [anon_sym_decltype] = ACTIONS(5246),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5248),
  },
  [2407] = {
    [sym_identifier] = ACTIONS(5242),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5244),
    [anon_sym_COMMA] = ACTIONS(5244),
    [anon_sym_RPAREN] = ACTIONS(5244),
    [aux_sym_preproc_if_token2] = ACTIONS(5244),
    [aux_sym_preproc_else_token1] = ACTIONS(5244),
    [aux_sym_preproc_elif_token1] = ACTIONS(5242),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5244),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5244),
    [anon_sym_LPAREN2] = ACTIONS(5244),
    [anon_sym_DASH] = ACTIONS(5242),
    [anon_sym_PLUS] = ACTIONS(5242),
    [anon_sym_STAR] = ACTIONS(5242),
    [anon_sym_SLASH] = ACTIONS(5242),
    [anon_sym_PERCENT] = ACTIONS(5242),
    [anon_sym_PIPE_PIPE] = ACTIONS(5244),
    [anon_sym_AMP_AMP] = ACTIONS(5244),
    [anon_sym_PIPE] = ACTIONS(5242),
    [anon_sym_CARET] = ACTIONS(5242),
    [anon_sym_AMP] = ACTIONS(5242),
    [anon_sym_EQ_EQ] = ACTIONS(5244),
    [anon_sym_BANG_EQ] = ACTIONS(5244),
    [anon_sym_GT] = ACTIONS(5242),
    [anon_sym_GT_EQ] = ACTIONS(5244),
    [anon_sym_LT_EQ] = ACTIONS(5242),
    [anon_sym_LT] = ACTIONS(5242),
    [anon_sym_LT_LT] = ACTIONS(5242),
    [anon_sym_GT_GT] = ACTIONS(5242),
    [anon_sym_SEMI] = ACTIONS(5244),
    [anon_sym___attribute__] = ACTIONS(5242),
    [anon_sym_LBRACE] = ACTIONS(5244),
    [anon_sym_RBRACE] = ACTIONS(5244),
    [anon_sym_LBRACK] = ACTIONS(5244),
    [anon_sym_RBRACK] = ACTIONS(5244),
    [anon_sym_EQ] = ACTIONS(5242),
    [anon_sym_COLON] = ACTIONS(5244),
    [anon_sym_QMARK] = ACTIONS(5244),
    [anon_sym_STAR_EQ] = ACTIONS(5244),
    [anon_sym_SLASH_EQ] = ACTIONS(5244),
    [anon_sym_PERCENT_EQ] = ACTIONS(5244),
    [anon_sym_PLUS_EQ] = ACTIONS(5244),
    [anon_sym_DASH_EQ] = ACTIONS(5244),
    [anon_sym_LT_LT_EQ] = ACTIONS(5244),
    [anon_sym_GT_GT_EQ] = ACTIONS(5244),
    [anon_sym_AMP_EQ] = ACTIONS(5244),
    [anon_sym_CARET_EQ] = ACTIONS(5244),
    [anon_sym_PIPE_EQ] = ACTIONS(5244),
    [anon_sym_and_eq] = ACTIONS(5242),
    [anon_sym_or_eq] = ACTIONS(5242),
    [anon_sym_xor_eq] = ACTIONS(5242),
    [anon_sym_LT_EQ_GT] = ACTIONS(5244),
    [anon_sym_or] = ACTIONS(5242),
    [anon_sym_and] = ACTIONS(5242),
    [anon_sym_bitor] = ACTIONS(5242),
    [anon_sym_xor] = ACTIONS(5242),
    [anon_sym_bitand] = ACTIONS(5242),
    [anon_sym_not_eq] = ACTIONS(5242),
    [anon_sym_DASH_DASH] = ACTIONS(5244),
    [anon_sym_PLUS_PLUS] = ACTIONS(5244),
    [anon_sym_DOT] = ACTIONS(5242),
    [anon_sym_DOT_STAR] = ACTIONS(5244),
    [anon_sym_DASH_GT] = ACTIONS(5244),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5242),
    [anon_sym_decltype] = ACTIONS(5242),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5244),
  },
  [2408] = {
    [sym_identifier] = ACTIONS(5996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5998),
    [anon_sym_COMMA] = ACTIONS(5998),
    [anon_sym_RPAREN] = ACTIONS(5998),
    [aux_sym_preproc_if_token2] = ACTIONS(5998),
    [aux_sym_preproc_else_token1] = ACTIONS(5998),
    [aux_sym_preproc_elif_token1] = ACTIONS(5996),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5998),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5998),
    [anon_sym_LPAREN2] = ACTIONS(5998),
    [anon_sym_DASH] = ACTIONS(5996),
    [anon_sym_PLUS] = ACTIONS(5996),
    [anon_sym_STAR] = ACTIONS(5996),
    [anon_sym_SLASH] = ACTIONS(5996),
    [anon_sym_PERCENT] = ACTIONS(5996),
    [anon_sym_PIPE_PIPE] = ACTIONS(5998),
    [anon_sym_AMP_AMP] = ACTIONS(5998),
    [anon_sym_PIPE] = ACTIONS(5996),
    [anon_sym_CARET] = ACTIONS(5996),
    [anon_sym_AMP] = ACTIONS(5996),
    [anon_sym_EQ_EQ] = ACTIONS(5998),
    [anon_sym_BANG_EQ] = ACTIONS(5998),
    [anon_sym_GT] = ACTIONS(5996),
    [anon_sym_GT_EQ] = ACTIONS(5998),
    [anon_sym_LT_EQ] = ACTIONS(5996),
    [anon_sym_LT] = ACTIONS(5996),
    [anon_sym_LT_LT] = ACTIONS(5996),
    [anon_sym_GT_GT] = ACTIONS(5996),
    [anon_sym_SEMI] = ACTIONS(5998),
    [anon_sym___attribute__] = ACTIONS(5996),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5998),
    [anon_sym_LBRACE] = ACTIONS(5998),
    [anon_sym_RBRACE] = ACTIONS(5998),
    [anon_sym_LBRACK] = ACTIONS(5996),
    [anon_sym_RBRACK] = ACTIONS(5998),
    [anon_sym_EQ] = ACTIONS(5996),
    [anon_sym_COLON] = ACTIONS(5998),
    [anon_sym_QMARK] = ACTIONS(5998),
    [anon_sym_STAR_EQ] = ACTIONS(5998),
    [anon_sym_SLASH_EQ] = ACTIONS(5998),
    [anon_sym_PERCENT_EQ] = ACTIONS(5998),
    [anon_sym_PLUS_EQ] = ACTIONS(5998),
    [anon_sym_DASH_EQ] = ACTIONS(5998),
    [anon_sym_LT_LT_EQ] = ACTIONS(5998),
    [anon_sym_GT_GT_EQ] = ACTIONS(5998),
    [anon_sym_AMP_EQ] = ACTIONS(5998),
    [anon_sym_CARET_EQ] = ACTIONS(5998),
    [anon_sym_PIPE_EQ] = ACTIONS(5998),
    [anon_sym_and_eq] = ACTIONS(5996),
    [anon_sym_or_eq] = ACTIONS(5996),
    [anon_sym_xor_eq] = ACTIONS(5996),
    [anon_sym_LT_EQ_GT] = ACTIONS(5998),
    [anon_sym_or] = ACTIONS(5996),
    [anon_sym_and] = ACTIONS(5996),
    [anon_sym_bitor] = ACTIONS(5996),
    [anon_sym_xor] = ACTIONS(5996),
    [anon_sym_bitand] = ACTIONS(5996),
    [anon_sym_not_eq] = ACTIONS(5996),
    [anon_sym_DASH_DASH] = ACTIONS(5998),
    [anon_sym_PLUS_PLUS] = ACTIONS(5998),
    [anon_sym_DOT] = ACTIONS(5996),
    [anon_sym_DOT_STAR] = ACTIONS(5998),
    [anon_sym_DASH_GT] = ACTIONS(5998),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(5996),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5998),
  },
  [2409] = {
    [sym_identifier] = ACTIONS(6000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6002),
    [anon_sym_COMMA] = ACTIONS(6002),
    [anon_sym_RPAREN] = ACTIONS(6002),
    [aux_sym_preproc_if_token2] = ACTIONS(6002),
    [aux_sym_preproc_else_token1] = ACTIONS(6002),
    [aux_sym_preproc_elif_token1] = ACTIONS(6000),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6002),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6002),
    [anon_sym_LPAREN2] = ACTIONS(6002),
    [anon_sym_DASH] = ACTIONS(6000),
    [anon_sym_PLUS] = ACTIONS(6000),
    [anon_sym_STAR] = ACTIONS(6000),
    [anon_sym_SLASH] = ACTIONS(6000),
    [anon_sym_PERCENT] = ACTIONS(6000),
    [anon_sym_PIPE_PIPE] = ACTIONS(6002),
    [anon_sym_AMP_AMP] = ACTIONS(6002),
    [anon_sym_PIPE] = ACTIONS(6000),
    [anon_sym_CARET] = ACTIONS(6000),
    [anon_sym_AMP] = ACTIONS(6000),
    [anon_sym_EQ_EQ] = ACTIONS(6002),
    [anon_sym_BANG_EQ] = ACTIONS(6002),
    [anon_sym_GT] = ACTIONS(6000),
    [anon_sym_GT_EQ] = ACTIONS(6002),
    [anon_sym_LT_EQ] = ACTIONS(6000),
    [anon_sym_LT] = ACTIONS(6000),
    [anon_sym_LT_LT] = ACTIONS(6000),
    [anon_sym_GT_GT] = ACTIONS(6000),
    [anon_sym_SEMI] = ACTIONS(6002),
    [anon_sym___attribute__] = ACTIONS(6000),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6002),
    [anon_sym_LBRACE] = ACTIONS(6002),
    [anon_sym_RBRACE] = ACTIONS(6002),
    [anon_sym_LBRACK] = ACTIONS(6000),
    [anon_sym_RBRACK] = ACTIONS(6002),
    [anon_sym_EQ] = ACTIONS(6000),
    [anon_sym_COLON] = ACTIONS(6002),
    [anon_sym_QMARK] = ACTIONS(6002),
    [anon_sym_STAR_EQ] = ACTIONS(6002),
    [anon_sym_SLASH_EQ] = ACTIONS(6002),
    [anon_sym_PERCENT_EQ] = ACTIONS(6002),
    [anon_sym_PLUS_EQ] = ACTIONS(6002),
    [anon_sym_DASH_EQ] = ACTIONS(6002),
    [anon_sym_LT_LT_EQ] = ACTIONS(6002),
    [anon_sym_GT_GT_EQ] = ACTIONS(6002),
    [anon_sym_AMP_EQ] = ACTIONS(6002),
    [anon_sym_CARET_EQ] = ACTIONS(6002),
    [anon_sym_PIPE_EQ] = ACTIONS(6002),
    [anon_sym_and_eq] = ACTIONS(6000),
    [anon_sym_or_eq] = ACTIONS(6000),
    [anon_sym_xor_eq] = ACTIONS(6000),
    [anon_sym_LT_EQ_GT] = ACTIONS(6002),
    [anon_sym_or] = ACTIONS(6000),
    [anon_sym_and] = ACTIONS(6000),
    [anon_sym_bitor] = ACTIONS(6000),
    [anon_sym_xor] = ACTIONS(6000),
    [anon_sym_bitand] = ACTIONS(6000),
    [anon_sym_not_eq] = ACTIONS(6000),
    [anon_sym_DASH_DASH] = ACTIONS(6002),
    [anon_sym_PLUS_PLUS] = ACTIONS(6002),
    [anon_sym_DOT] = ACTIONS(6000),
    [anon_sym_DOT_STAR] = ACTIONS(6002),
    [anon_sym_DASH_GT] = ACTIONS(6002),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6000),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(6002),
  },
  [2410] = {
    [sym_identifier] = ACTIONS(6004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6006),
    [anon_sym_COMMA] = ACTIONS(6006),
    [anon_sym_RPAREN] = ACTIONS(6006),
    [aux_sym_preproc_if_token2] = ACTIONS(6006),
    [aux_sym_preproc_else_token1] = ACTIONS(6006),
    [aux_sym_preproc_elif_token1] = ACTIONS(6004),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6006),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6006),
    [anon_sym_LPAREN2] = ACTIONS(6006),
    [anon_sym_DASH] = ACTIONS(6004),
    [anon_sym_PLUS] = ACTIONS(6004),
    [anon_sym_STAR] = ACTIONS(6004),
    [anon_sym_SLASH] = ACTIONS(6004),
    [anon_sym_PERCENT] = ACTIONS(6004),
    [anon_sym_PIPE_PIPE] = ACTIONS(6006),
    [anon_sym_AMP_AMP] = ACTIONS(6006),
    [anon_sym_PIPE] = ACTIONS(6004),
    [anon_sym_CARET] = ACTIONS(6004),
    [anon_sym_AMP] = ACTIONS(6004),
    [anon_sym_EQ_EQ] = ACTIONS(6006),
    [anon_sym_BANG_EQ] = ACTIONS(6006),
    [anon_sym_GT] = ACTIONS(6004),
    [anon_sym_GT_EQ] = ACTIONS(6006),
    [anon_sym_LT_EQ] = ACTIONS(6004),
    [anon_sym_LT] = ACTIONS(6004),
    [anon_sym_LT_LT] = ACTIONS(6004),
    [anon_sym_GT_GT] = ACTIONS(6004),
    [anon_sym_SEMI] = ACTIONS(6006),
    [anon_sym___attribute__] = ACTIONS(6004),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6006),
    [anon_sym_LBRACE] = ACTIONS(6006),
    [anon_sym_RBRACE] = ACTIONS(6006),
    [anon_sym_LBRACK] = ACTIONS(6004),
    [anon_sym_RBRACK] = ACTIONS(6006),
    [anon_sym_EQ] = ACTIONS(6004),
    [anon_sym_COLON] = ACTIONS(6006),
    [anon_sym_QMARK] = ACTIONS(6006),
    [anon_sym_STAR_EQ] = ACTIONS(6006),
    [anon_sym_SLASH_EQ] = ACTIONS(6006),
    [anon_sym_PERCENT_EQ] = ACTIONS(6006),
    [anon_sym_PLUS_EQ] = ACTIONS(6006),
    [anon_sym_DASH_EQ] = ACTIONS(6006),
    [anon_sym_LT_LT_EQ] = ACTIONS(6006),
    [anon_sym_GT_GT_EQ] = ACTIONS(6006),
    [anon_sym_AMP_EQ] = ACTIONS(6006),
    [anon_sym_CARET_EQ] = ACTIONS(6006),
    [anon_sym_PIPE_EQ] = ACTIONS(6006),
    [anon_sym_and_eq] = ACTIONS(6004),
    [anon_sym_or_eq] = ACTIONS(6004),
    [anon_sym_xor_eq] = ACTIONS(6004),
    [anon_sym_LT_EQ_GT] = ACTIONS(6006),
    [anon_sym_or] = ACTIONS(6004),
    [anon_sym_and] = ACTIONS(6004),
    [anon_sym_bitor] = ACTIONS(6004),
    [anon_sym_xor] = ACTIONS(6004),
    [anon_sym_bitand] = ACTIONS(6004),
    [anon_sym_not_eq] = ACTIONS(6004),
    [anon_sym_DASH_DASH] = ACTIONS(6006),
    [anon_sym_PLUS_PLUS] = ACTIONS(6006),
    [anon_sym_DOT] = ACTIONS(6004),
    [anon_sym_DOT_STAR] = ACTIONS(6006),
    [anon_sym_DASH_GT] = ACTIONS(6006),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6004),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(6006),
  },
  [2411] = {
    [sym_identifier] = ACTIONS(5238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5240),
    [anon_sym_COMMA] = ACTIONS(5240),
    [anon_sym_RPAREN] = ACTIONS(5240),
    [aux_sym_preproc_if_token2] = ACTIONS(5240),
    [aux_sym_preproc_else_token1] = ACTIONS(5240),
    [aux_sym_preproc_elif_token1] = ACTIONS(5238),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5240),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5240),
    [anon_sym_LPAREN2] = ACTIONS(5240),
    [anon_sym_DASH] = ACTIONS(5238),
    [anon_sym_PLUS] = ACTIONS(5238),
    [anon_sym_STAR] = ACTIONS(5238),
    [anon_sym_SLASH] = ACTIONS(5238),
    [anon_sym_PERCENT] = ACTIONS(5238),
    [anon_sym_PIPE_PIPE] = ACTIONS(5240),
    [anon_sym_AMP_AMP] = ACTIONS(5240),
    [anon_sym_PIPE] = ACTIONS(5238),
    [anon_sym_CARET] = ACTIONS(5238),
    [anon_sym_AMP] = ACTIONS(5238),
    [anon_sym_EQ_EQ] = ACTIONS(5240),
    [anon_sym_BANG_EQ] = ACTIONS(5240),
    [anon_sym_GT] = ACTIONS(5238),
    [anon_sym_GT_EQ] = ACTIONS(5240),
    [anon_sym_LT_EQ] = ACTIONS(5238),
    [anon_sym_LT] = ACTIONS(5238),
    [anon_sym_LT_LT] = ACTIONS(5238),
    [anon_sym_GT_GT] = ACTIONS(5238),
    [anon_sym_SEMI] = ACTIONS(5240),
    [anon_sym___attribute__] = ACTIONS(5238),
    [anon_sym_LBRACE] = ACTIONS(5240),
    [anon_sym_RBRACE] = ACTIONS(5240),
    [anon_sym_LBRACK] = ACTIONS(5240),
    [anon_sym_RBRACK] = ACTIONS(5240),
    [anon_sym_EQ] = ACTIONS(5238),
    [anon_sym_COLON] = ACTIONS(5240),
    [anon_sym_QMARK] = ACTIONS(5240),
    [anon_sym_STAR_EQ] = ACTIONS(5240),
    [anon_sym_SLASH_EQ] = ACTIONS(5240),
    [anon_sym_PERCENT_EQ] = ACTIONS(5240),
    [anon_sym_PLUS_EQ] = ACTIONS(5240),
    [anon_sym_DASH_EQ] = ACTIONS(5240),
    [anon_sym_LT_LT_EQ] = ACTIONS(5240),
    [anon_sym_GT_GT_EQ] = ACTIONS(5240),
    [anon_sym_AMP_EQ] = ACTIONS(5240),
    [anon_sym_CARET_EQ] = ACTIONS(5240),
    [anon_sym_PIPE_EQ] = ACTIONS(5240),
    [anon_sym_and_eq] = ACTIONS(5238),
    [anon_sym_or_eq] = ACTIONS(5238),
    [anon_sym_xor_eq] = ACTIONS(5238),
    [anon_sym_LT_EQ_GT] = ACTIONS(5240),
    [anon_sym_or] = ACTIONS(5238),
    [anon_sym_and] = ACTIONS(5238),
    [anon_sym_bitor] = ACTIONS(5238),
    [anon_sym_xor] = ACTIONS(5238),
    [anon_sym_bitand] = ACTIONS(5238),
    [anon_sym_not_eq] = ACTIONS(5238),
    [anon_sym_DASH_DASH] = ACTIONS(5240),
    [anon_sym_PLUS_PLUS] = ACTIONS(5240),
    [anon_sym_DOT] = ACTIONS(5238),
    [anon_sym_DOT_STAR] = ACTIONS(5240),
    [anon_sym_DASH_GT] = ACTIONS(5240),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5238),
    [anon_sym_decltype] = ACTIONS(5238),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5240),
  },
  [2412] = {
    [sym_identifier] = ACTIONS(5192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5194),
    [anon_sym_COMMA] = ACTIONS(5194),
    [anon_sym_RPAREN] = ACTIONS(5194),
    [aux_sym_preproc_if_token2] = ACTIONS(5194),
    [aux_sym_preproc_else_token1] = ACTIONS(5194),
    [aux_sym_preproc_elif_token1] = ACTIONS(5192),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5194),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5194),
    [anon_sym_LPAREN2] = ACTIONS(5194),
    [anon_sym_DASH] = ACTIONS(5192),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_STAR] = ACTIONS(5192),
    [anon_sym_SLASH] = ACTIONS(5192),
    [anon_sym_PERCENT] = ACTIONS(5192),
    [anon_sym_PIPE_PIPE] = ACTIONS(5194),
    [anon_sym_AMP_AMP] = ACTIONS(5194),
    [anon_sym_PIPE] = ACTIONS(5192),
    [anon_sym_CARET] = ACTIONS(5192),
    [anon_sym_AMP] = ACTIONS(5192),
    [anon_sym_EQ_EQ] = ACTIONS(5194),
    [anon_sym_BANG_EQ] = ACTIONS(5194),
    [anon_sym_GT] = ACTIONS(5192),
    [anon_sym_GT_EQ] = ACTIONS(5194),
    [anon_sym_LT_EQ] = ACTIONS(5192),
    [anon_sym_LT] = ACTIONS(5192),
    [anon_sym_LT_LT] = ACTIONS(5192),
    [anon_sym_GT_GT] = ACTIONS(5192),
    [anon_sym_SEMI] = ACTIONS(5194),
    [anon_sym___attribute__] = ACTIONS(5192),
    [anon_sym_LBRACE] = ACTIONS(5194),
    [anon_sym_RBRACE] = ACTIONS(5194),
    [anon_sym_LBRACK] = ACTIONS(5194),
    [anon_sym_RBRACK] = ACTIONS(5194),
    [anon_sym_EQ] = ACTIONS(5192),
    [anon_sym_COLON] = ACTIONS(5194),
    [anon_sym_QMARK] = ACTIONS(5194),
    [anon_sym_STAR_EQ] = ACTIONS(5194),
    [anon_sym_SLASH_EQ] = ACTIONS(5194),
    [anon_sym_PERCENT_EQ] = ACTIONS(5194),
    [anon_sym_PLUS_EQ] = ACTIONS(5194),
    [anon_sym_DASH_EQ] = ACTIONS(5194),
    [anon_sym_LT_LT_EQ] = ACTIONS(5194),
    [anon_sym_GT_GT_EQ] = ACTIONS(5194),
    [anon_sym_AMP_EQ] = ACTIONS(5194),
    [anon_sym_CARET_EQ] = ACTIONS(5194),
    [anon_sym_PIPE_EQ] = ACTIONS(5194),
    [anon_sym_and_eq] = ACTIONS(5192),
    [anon_sym_or_eq] = ACTIONS(5192),
    [anon_sym_xor_eq] = ACTIONS(5192),
    [anon_sym_LT_EQ_GT] = ACTIONS(5194),
    [anon_sym_or] = ACTIONS(5192),
    [anon_sym_and] = ACTIONS(5192),
    [anon_sym_bitor] = ACTIONS(5192),
    [anon_sym_xor] = ACTIONS(5192),
    [anon_sym_bitand] = ACTIONS(5192),
    [anon_sym_not_eq] = ACTIONS(5192),
    [anon_sym_DASH_DASH] = ACTIONS(5194),
    [anon_sym_PLUS_PLUS] = ACTIONS(5194),
    [anon_sym_DOT] = ACTIONS(5192),
    [anon_sym_DOT_STAR] = ACTIONS(5194),
    [anon_sym_DASH_GT] = ACTIONS(5194),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5192),
    [anon_sym_decltype] = ACTIONS(5192),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5194),
  },
  [2413] = {
    [sym_identifier] = ACTIONS(5214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5216),
    [anon_sym_COMMA] = ACTIONS(5216),
    [anon_sym_RPAREN] = ACTIONS(5216),
    [aux_sym_preproc_if_token2] = ACTIONS(5216),
    [aux_sym_preproc_else_token1] = ACTIONS(5216),
    [aux_sym_preproc_elif_token1] = ACTIONS(5214),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5216),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5216),
    [anon_sym_LPAREN2] = ACTIONS(5216),
    [anon_sym_DASH] = ACTIONS(5214),
    [anon_sym_PLUS] = ACTIONS(5214),
    [anon_sym_STAR] = ACTIONS(5214),
    [anon_sym_SLASH] = ACTIONS(5214),
    [anon_sym_PERCENT] = ACTIONS(5214),
    [anon_sym_PIPE_PIPE] = ACTIONS(5216),
    [anon_sym_AMP_AMP] = ACTIONS(5216),
    [anon_sym_PIPE] = ACTIONS(5214),
    [anon_sym_CARET] = ACTIONS(5214),
    [anon_sym_AMP] = ACTIONS(5214),
    [anon_sym_EQ_EQ] = ACTIONS(5216),
    [anon_sym_BANG_EQ] = ACTIONS(5216),
    [anon_sym_GT] = ACTIONS(5214),
    [anon_sym_GT_EQ] = ACTIONS(5216),
    [anon_sym_LT_EQ] = ACTIONS(5214),
    [anon_sym_LT] = ACTIONS(5214),
    [anon_sym_LT_LT] = ACTIONS(5214),
    [anon_sym_GT_GT] = ACTIONS(5214),
    [anon_sym_SEMI] = ACTIONS(5216),
    [anon_sym___attribute__] = ACTIONS(5214),
    [anon_sym_LBRACE] = ACTIONS(5216),
    [anon_sym_RBRACE] = ACTIONS(5216),
    [anon_sym_LBRACK] = ACTIONS(5216),
    [anon_sym_RBRACK] = ACTIONS(5216),
    [anon_sym_EQ] = ACTIONS(5214),
    [anon_sym_COLON] = ACTIONS(5216),
    [anon_sym_QMARK] = ACTIONS(5216),
    [anon_sym_STAR_EQ] = ACTIONS(5216),
    [anon_sym_SLASH_EQ] = ACTIONS(5216),
    [anon_sym_PERCENT_EQ] = ACTIONS(5216),
    [anon_sym_PLUS_EQ] = ACTIONS(5216),
    [anon_sym_DASH_EQ] = ACTIONS(5216),
    [anon_sym_LT_LT_EQ] = ACTIONS(5216),
    [anon_sym_GT_GT_EQ] = ACTIONS(5216),
    [anon_sym_AMP_EQ] = ACTIONS(5216),
    [anon_sym_CARET_EQ] = ACTIONS(5216),
    [anon_sym_PIPE_EQ] = ACTIONS(5216),
    [anon_sym_and_eq] = ACTIONS(5214),
    [anon_sym_or_eq] = ACTIONS(5214),
    [anon_sym_xor_eq] = ACTIONS(5214),
    [anon_sym_LT_EQ_GT] = ACTIONS(5216),
    [anon_sym_or] = ACTIONS(5214),
    [anon_sym_and] = ACTIONS(5214),
    [anon_sym_bitor] = ACTIONS(5214),
    [anon_sym_xor] = ACTIONS(5214),
    [anon_sym_bitand] = ACTIONS(5214),
    [anon_sym_not_eq] = ACTIONS(5214),
    [anon_sym_DASH_DASH] = ACTIONS(5216),
    [anon_sym_PLUS_PLUS] = ACTIONS(5216),
    [anon_sym_DOT] = ACTIONS(5214),
    [anon_sym_DOT_STAR] = ACTIONS(5216),
    [anon_sym_DASH_GT] = ACTIONS(5216),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5214),
    [anon_sym_decltype] = ACTIONS(5214),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5216),
  },
  [2414] = {
    [sym_identifier] = ACTIONS(6008),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6010),
    [anon_sym_COMMA] = ACTIONS(6010),
    [anon_sym_RPAREN] = ACTIONS(6010),
    [aux_sym_preproc_if_token2] = ACTIONS(6010),
    [aux_sym_preproc_else_token1] = ACTIONS(6010),
    [aux_sym_preproc_elif_token1] = ACTIONS(6008),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6010),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6010),
    [anon_sym_LPAREN2] = ACTIONS(6010),
    [anon_sym_DASH] = ACTIONS(6008),
    [anon_sym_PLUS] = ACTIONS(6008),
    [anon_sym_STAR] = ACTIONS(6008),
    [anon_sym_SLASH] = ACTIONS(6008),
    [anon_sym_PERCENT] = ACTIONS(6008),
    [anon_sym_PIPE_PIPE] = ACTIONS(6010),
    [anon_sym_AMP_AMP] = ACTIONS(6010),
    [anon_sym_PIPE] = ACTIONS(6008),
    [anon_sym_CARET] = ACTIONS(6008),
    [anon_sym_AMP] = ACTIONS(6008),
    [anon_sym_EQ_EQ] = ACTIONS(6010),
    [anon_sym_BANG_EQ] = ACTIONS(6010),
    [anon_sym_GT] = ACTIONS(6008),
    [anon_sym_GT_EQ] = ACTIONS(6010),
    [anon_sym_LT_EQ] = ACTIONS(6008),
    [anon_sym_LT] = ACTIONS(6008),
    [anon_sym_LT_LT] = ACTIONS(6008),
    [anon_sym_GT_GT] = ACTIONS(6008),
    [anon_sym_SEMI] = ACTIONS(6010),
    [anon_sym___attribute__] = ACTIONS(6008),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6010),
    [anon_sym_LBRACE] = ACTIONS(6010),
    [anon_sym_RBRACE] = ACTIONS(6010),
    [anon_sym_LBRACK] = ACTIONS(6008),
    [anon_sym_RBRACK] = ACTIONS(6010),
    [anon_sym_EQ] = ACTIONS(6008),
    [anon_sym_COLON] = ACTIONS(6010),
    [anon_sym_QMARK] = ACTIONS(6010),
    [anon_sym_STAR_EQ] = ACTIONS(6010),
    [anon_sym_SLASH_EQ] = ACTIONS(6010),
    [anon_sym_PERCENT_EQ] = ACTIONS(6010),
    [anon_sym_PLUS_EQ] = ACTIONS(6010),
    [anon_sym_DASH_EQ] = ACTIONS(6010),
    [anon_sym_LT_LT_EQ] = ACTIONS(6010),
    [anon_sym_GT_GT_EQ] = ACTIONS(6010),
    [anon_sym_AMP_EQ] = ACTIONS(6010),
    [anon_sym_CARET_EQ] = ACTIONS(6010),
    [anon_sym_PIPE_EQ] = ACTIONS(6010),
    [anon_sym_and_eq] = ACTIONS(6008),
    [anon_sym_or_eq] = ACTIONS(6008),
    [anon_sym_xor_eq] = ACTIONS(6008),
    [anon_sym_LT_EQ_GT] = ACTIONS(6010),
    [anon_sym_or] = ACTIONS(6008),
    [anon_sym_and] = ACTIONS(6008),
    [anon_sym_bitor] = ACTIONS(6008),
    [anon_sym_xor] = ACTIONS(6008),
    [anon_sym_bitand] = ACTIONS(6008),
    [anon_sym_not_eq] = ACTIONS(6008),
    [anon_sym_DASH_DASH] = ACTIONS(6010),
    [anon_sym_PLUS_PLUS] = ACTIONS(6010),
    [anon_sym_DOT] = ACTIONS(6008),
    [anon_sym_DOT_STAR] = ACTIONS(6010),
    [anon_sym_DASH_GT] = ACTIONS(6010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6008),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(6010),
  },
  [2415] = {
    [sym_identifier] = ACTIONS(5234),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5236),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_RPAREN] = ACTIONS(5236),
    [aux_sym_preproc_if_token2] = ACTIONS(5236),
    [aux_sym_preproc_else_token1] = ACTIONS(5236),
    [aux_sym_preproc_elif_token1] = ACTIONS(5234),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5236),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5236),
    [anon_sym_LPAREN2] = ACTIONS(5236),
    [anon_sym_DASH] = ACTIONS(5234),
    [anon_sym_PLUS] = ACTIONS(5234),
    [anon_sym_STAR] = ACTIONS(5234),
    [anon_sym_SLASH] = ACTIONS(5234),
    [anon_sym_PERCENT] = ACTIONS(5234),
    [anon_sym_PIPE_PIPE] = ACTIONS(5236),
    [anon_sym_AMP_AMP] = ACTIONS(5236),
    [anon_sym_PIPE] = ACTIONS(5234),
    [anon_sym_CARET] = ACTIONS(5234),
    [anon_sym_AMP] = ACTIONS(5234),
    [anon_sym_EQ_EQ] = ACTIONS(5236),
    [anon_sym_BANG_EQ] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5234),
    [anon_sym_GT_EQ] = ACTIONS(5236),
    [anon_sym_LT_EQ] = ACTIONS(5234),
    [anon_sym_LT] = ACTIONS(5234),
    [anon_sym_LT_LT] = ACTIONS(5234),
    [anon_sym_GT_GT] = ACTIONS(5234),
    [anon_sym_SEMI] = ACTIONS(5236),
    [anon_sym___attribute__] = ACTIONS(5234),
    [anon_sym_LBRACE] = ACTIONS(5236),
    [anon_sym_RBRACE] = ACTIONS(5236),
    [anon_sym_LBRACK] = ACTIONS(5236),
    [anon_sym_RBRACK] = ACTIONS(5236),
    [anon_sym_EQ] = ACTIONS(5234),
    [anon_sym_COLON] = ACTIONS(5236),
    [anon_sym_QMARK] = ACTIONS(5236),
    [anon_sym_STAR_EQ] = ACTIONS(5236),
    [anon_sym_SLASH_EQ] = ACTIONS(5236),
    [anon_sym_PERCENT_EQ] = ACTIONS(5236),
    [anon_sym_PLUS_EQ] = ACTIONS(5236),
    [anon_sym_DASH_EQ] = ACTIONS(5236),
    [anon_sym_LT_LT_EQ] = ACTIONS(5236),
    [anon_sym_GT_GT_EQ] = ACTIONS(5236),
    [anon_sym_AMP_EQ] = ACTIONS(5236),
    [anon_sym_CARET_EQ] = ACTIONS(5236),
    [anon_sym_PIPE_EQ] = ACTIONS(5236),
    [anon_sym_and_eq] = ACTIONS(5234),
    [anon_sym_or_eq] = ACTIONS(5234),
    [anon_sym_xor_eq] = ACTIONS(5234),
    [anon_sym_LT_EQ_GT] = ACTIONS(5236),
    [anon_sym_or] = ACTIONS(5234),
    [anon_sym_and] = ACTIONS(5234),
    [anon_sym_bitor] = ACTIONS(5234),
    [anon_sym_xor] = ACTIONS(5234),
    [anon_sym_bitand] = ACTIONS(5234),
    [anon_sym_not_eq] = ACTIONS(5234),
    [anon_sym_DASH_DASH] = ACTIONS(5236),
    [anon_sym_PLUS_PLUS] = ACTIONS(5236),
    [anon_sym_DOT] = ACTIONS(5234),
    [anon_sym_DOT_STAR] = ACTIONS(5236),
    [anon_sym_DASH_GT] = ACTIONS(5236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5234),
    [anon_sym_decltype] = ACTIONS(5234),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5236),
  },
  [2416] = {
    [sym_argument_list] = STATE(2741),
    [sym_initializer_list] = STATE(2741),
    [sym_identifier] = ACTIONS(6012),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6014),
    [anon_sym_COMMA] = ACTIONS(6014),
    [anon_sym_RPAREN] = ACTIONS(6014),
    [aux_sym_preproc_if_token2] = ACTIONS(6014),
    [aux_sym_preproc_else_token1] = ACTIONS(6014),
    [aux_sym_preproc_elif_token1] = ACTIONS(6012),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6014),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6014),
    [anon_sym_LPAREN2] = ACTIONS(5644),
    [anon_sym_DASH] = ACTIONS(6012),
    [anon_sym_PLUS] = ACTIONS(6012),
    [anon_sym_STAR] = ACTIONS(6012),
    [anon_sym_SLASH] = ACTIONS(6012),
    [anon_sym_PERCENT] = ACTIONS(6012),
    [anon_sym_PIPE_PIPE] = ACTIONS(6014),
    [anon_sym_AMP_AMP] = ACTIONS(6014),
    [anon_sym_PIPE] = ACTIONS(6012),
    [anon_sym_CARET] = ACTIONS(6012),
    [anon_sym_AMP] = ACTIONS(6012),
    [anon_sym_EQ_EQ] = ACTIONS(6014),
    [anon_sym_BANG_EQ] = ACTIONS(6014),
    [anon_sym_GT] = ACTIONS(6012),
    [anon_sym_GT_EQ] = ACTIONS(6014),
    [anon_sym_LT_EQ] = ACTIONS(6012),
    [anon_sym_LT] = ACTIONS(6012),
    [anon_sym_LT_LT] = ACTIONS(6012),
    [anon_sym_GT_GT] = ACTIONS(6012),
    [anon_sym_SEMI] = ACTIONS(6014),
    [anon_sym___attribute__] = ACTIONS(6012),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_RBRACE] = ACTIONS(6014),
    [anon_sym_LBRACK] = ACTIONS(6014),
    [anon_sym_RBRACK] = ACTIONS(6014),
    [anon_sym_EQ] = ACTIONS(6012),
    [anon_sym_COLON] = ACTIONS(6014),
    [anon_sym_QMARK] = ACTIONS(6014),
    [anon_sym_STAR_EQ] = ACTIONS(6014),
    [anon_sym_SLASH_EQ] = ACTIONS(6014),
    [anon_sym_PERCENT_EQ] = ACTIONS(6014),
    [anon_sym_PLUS_EQ] = ACTIONS(6014),
    [anon_sym_DASH_EQ] = ACTIONS(6014),
    [anon_sym_LT_LT_EQ] = ACTIONS(6014),
    [anon_sym_GT_GT_EQ] = ACTIONS(6014),
    [anon_sym_AMP_EQ] = ACTIONS(6014),
    [anon_sym_CARET_EQ] = ACTIONS(6014),
    [anon_sym_PIPE_EQ] = ACTIONS(6014),
    [anon_sym_and_eq] = ACTIONS(6012),
    [anon_sym_or_eq] = ACTIONS(6012),
    [anon_sym_xor_eq] = ACTIONS(6012),
    [anon_sym_LT_EQ_GT] = ACTIONS(6014),
    [anon_sym_or] = ACTIONS(6012),
    [anon_sym_and] = ACTIONS(6012),
    [anon_sym_bitor] = ACTIONS(6012),
    [anon_sym_xor] = ACTIONS(6012),
    [anon_sym_bitand] = ACTIONS(6012),
    [anon_sym_not_eq] = ACTIONS(6012),
    [anon_sym_DASH_DASH] = ACTIONS(6014),
    [anon_sym_PLUS_PLUS] = ACTIONS(6014),
    [anon_sym_DOT] = ACTIONS(6012),
    [anon_sym_DOT_STAR] = ACTIONS(6014),
    [anon_sym_DASH_GT] = ACTIONS(6014),
    [sym_comment] = ACTIONS(3),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(6014),
  },
  [2417] = {
    [sym_identifier] = ACTIONS(5311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5313),
    [anon_sym_COMMA] = ACTIONS(5313),
    [anon_sym_RPAREN] = ACTIONS(5313),
    [aux_sym_preproc_if_token2] = ACTIONS(5313),
    [aux_sym_preproc_else_token1] = ACTIONS(5313),
    [aux_sym_preproc_elif_token1] = ACTIONS(5311),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5313),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5313),
    [anon_sym_LPAREN2] = ACTIONS(5313),
    [anon_sym_DASH] = ACTIONS(5311),
    [anon_sym_PLUS] = ACTIONS(5311),
    [anon_sym_STAR] = ACTIONS(5311),
    [anon_sym_SLASH] = ACTIONS(5311),
    [anon_sym_PERCENT] = ACTIONS(5311),
    [anon_sym_PIPE_PIPE] = ACTIONS(5313),
    [anon_sym_AMP_AMP] = ACTIONS(5313),
    [anon_sym_PIPE] = ACTIONS(5311),
    [anon_sym_CARET] = ACTIONS(5311),
    [anon_sym_AMP] = ACTIONS(5311),
    [anon_sym_EQ_EQ] = ACTIONS(5313),
    [anon_sym_BANG_EQ] = ACTIONS(5313),
    [anon_sym_GT] = ACTIONS(5311),
    [anon_sym_GT_EQ] = ACTIONS(5313),
    [anon_sym_LT_EQ] = ACTIONS(5311),
    [anon_sym_LT] = ACTIONS(5311),
    [anon_sym_LT_LT] = ACTIONS(5311),
    [anon_sym_GT_GT] = ACTIONS(5311),
    [anon_sym_SEMI] = ACTIONS(5313),
    [anon_sym___attribute__] = ACTIONS(5311),
    [anon_sym_LBRACE] = ACTIONS(5313),
    [anon_sym_RBRACE] = ACTIONS(5313),
    [anon_sym_LBRACK] = ACTIONS(5313),
    [anon_sym_RBRACK] = ACTIONS(5313),
    [anon_sym_EQ] = ACTIONS(5311),
    [anon_sym_COLON] = ACTIONS(5313),
    [anon_sym_QMARK] = ACTIONS(5313),
    [anon_sym_STAR_EQ] = ACTIONS(5313),
    [anon_sym_SLASH_EQ] = ACTIONS(5313),
    [anon_sym_PERCENT_EQ] = ACTIONS(5313),
    [anon_sym_PLUS_EQ] = ACTIONS(5313),
    [anon_sym_DASH_EQ] = ACTIONS(5313),
    [anon_sym_LT_LT_EQ] = ACTIONS(5313),
    [anon_sym_GT_GT_EQ] = ACTIONS(5313),
    [anon_sym_AMP_EQ] = ACTIONS(5313),
    [anon_sym_CARET_EQ] = ACTIONS(5313),
    [anon_sym_PIPE_EQ] = ACTIONS(5313),
    [anon_sym_and_eq] = ACTIONS(5311),
    [anon_sym_or_eq] = ACTIONS(5311),
    [anon_sym_xor_eq] = ACTIONS(5311),
    [anon_sym_LT_EQ_GT] = ACTIONS(5313),
    [anon_sym_or] = ACTIONS(5311),
    [anon_sym_and] = ACTIONS(5311),
    [anon_sym_bitor] = ACTIONS(5311),
    [anon_sym_xor] = ACTIONS(5311),
    [anon_sym_bitand] = ACTIONS(5311),
    [anon_sym_not_eq] = ACTIONS(5311),
    [anon_sym_DASH_DASH] = ACTIONS(5313),
    [anon_sym_PLUS_PLUS] = ACTIONS(5313),
    [anon_sym_DOT] = ACTIONS(5311),
    [anon_sym_DOT_STAR] = ACTIONS(5313),
    [anon_sym_DASH_GT] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5311),
    [anon_sym_decltype] = ACTIONS(5311),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5313),
  },
  [2418] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2447),
    [sym_identifier] = ACTIONS(5442),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5440),
    [anon_sym_COMMA] = ACTIONS(5440),
    [aux_sym_preproc_if_token2] = ACTIONS(5440),
    [aux_sym_preproc_else_token1] = ACTIONS(5440),
    [aux_sym_preproc_elif_token1] = ACTIONS(5442),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5440),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5440),
    [anon_sym_LPAREN2] = ACTIONS(5440),
    [anon_sym_DASH] = ACTIONS(5442),
    [anon_sym_PLUS] = ACTIONS(5442),
    [anon_sym_STAR] = ACTIONS(5442),
    [anon_sym_SLASH] = ACTIONS(5442),
    [anon_sym_PERCENT] = ACTIONS(5442),
    [anon_sym_PIPE_PIPE] = ACTIONS(5440),
    [anon_sym_AMP_AMP] = ACTIONS(5440),
    [anon_sym_PIPE] = ACTIONS(5442),
    [anon_sym_CARET] = ACTIONS(5442),
    [anon_sym_AMP] = ACTIONS(5442),
    [anon_sym_EQ_EQ] = ACTIONS(5440),
    [anon_sym_BANG_EQ] = ACTIONS(5440),
    [anon_sym_GT] = ACTIONS(5442),
    [anon_sym_GT_EQ] = ACTIONS(5440),
    [anon_sym_LT_EQ] = ACTIONS(5442),
    [anon_sym_LT] = ACTIONS(5442),
    [anon_sym_LT_LT] = ACTIONS(5442),
    [anon_sym_GT_GT] = ACTIONS(5442),
    [anon_sym___attribute__] = ACTIONS(5442),
    [anon_sym_LBRACE] = ACTIONS(5440),
    [anon_sym_signed] = ACTIONS(6016),
    [anon_sym_unsigned] = ACTIONS(6016),
    [anon_sym_long] = ACTIONS(6016),
    [anon_sym_short] = ACTIONS(6016),
    [anon_sym_LBRACK] = ACTIONS(5440),
    [anon_sym_EQ] = ACTIONS(5442),
    [anon_sym_QMARK] = ACTIONS(5440),
    [anon_sym_STAR_EQ] = ACTIONS(5440),
    [anon_sym_SLASH_EQ] = ACTIONS(5440),
    [anon_sym_PERCENT_EQ] = ACTIONS(5440),
    [anon_sym_PLUS_EQ] = ACTIONS(5440),
    [anon_sym_DASH_EQ] = ACTIONS(5440),
    [anon_sym_LT_LT_EQ] = ACTIONS(5440),
    [anon_sym_GT_GT_EQ] = ACTIONS(5440),
    [anon_sym_AMP_EQ] = ACTIONS(5440),
    [anon_sym_CARET_EQ] = ACTIONS(5440),
    [anon_sym_PIPE_EQ] = ACTIONS(5440),
    [anon_sym_and_eq] = ACTIONS(5442),
    [anon_sym_or_eq] = ACTIONS(5442),
    [anon_sym_xor_eq] = ACTIONS(5442),
    [anon_sym_LT_EQ_GT] = ACTIONS(5440),
    [anon_sym_or] = ACTIONS(5442),
    [anon_sym_and] = ACTIONS(5442),
    [anon_sym_bitor] = ACTIONS(5442),
    [anon_sym_xor] = ACTIONS(5442),
    [anon_sym_bitand] = ACTIONS(5442),
    [anon_sym_not_eq] = ACTIONS(5442),
    [anon_sym_DASH_DASH] = ACTIONS(5440),
    [anon_sym_PLUS_PLUS] = ACTIONS(5440),
    [anon_sym_DOT] = ACTIONS(5442),
    [anon_sym_DOT_STAR] = ACTIONS(5440),
    [anon_sym_DASH_GT] = ACTIONS(5440),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5442),
    [anon_sym_decltype] = ACTIONS(5442),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5440),
  },
  [2419] = {
    [sym_identifier] = ACTIONS(5370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5372),
    [anon_sym_COMMA] = ACTIONS(5372),
    [anon_sym_RPAREN] = ACTIONS(5372),
    [aux_sym_preproc_if_token2] = ACTIONS(5372),
    [aux_sym_preproc_else_token1] = ACTIONS(5372),
    [aux_sym_preproc_elif_token1] = ACTIONS(5370),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5372),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5372),
    [anon_sym_LPAREN2] = ACTIONS(5372),
    [anon_sym_DASH] = ACTIONS(5370),
    [anon_sym_PLUS] = ACTIONS(5370),
    [anon_sym_STAR] = ACTIONS(5370),
    [anon_sym_SLASH] = ACTIONS(5370),
    [anon_sym_PERCENT] = ACTIONS(5370),
    [anon_sym_PIPE_PIPE] = ACTIONS(5372),
    [anon_sym_AMP_AMP] = ACTIONS(5372),
    [anon_sym_PIPE] = ACTIONS(5370),
    [anon_sym_CARET] = ACTIONS(5370),
    [anon_sym_AMP] = ACTIONS(5370),
    [anon_sym_EQ_EQ] = ACTIONS(5372),
    [anon_sym_BANG_EQ] = ACTIONS(5372),
    [anon_sym_GT] = ACTIONS(5370),
    [anon_sym_GT_EQ] = ACTIONS(5372),
    [anon_sym_LT_EQ] = ACTIONS(5370),
    [anon_sym_LT] = ACTIONS(5370),
    [anon_sym_LT_LT] = ACTIONS(5370),
    [anon_sym_GT_GT] = ACTIONS(5370),
    [anon_sym_SEMI] = ACTIONS(5372),
    [anon_sym___attribute__] = ACTIONS(5370),
    [anon_sym_LBRACE] = ACTIONS(5372),
    [anon_sym_RBRACE] = ACTIONS(5372),
    [anon_sym_LBRACK] = ACTIONS(5372),
    [anon_sym_RBRACK] = ACTIONS(5372),
    [anon_sym_EQ] = ACTIONS(5370),
    [anon_sym_COLON] = ACTIONS(5372),
    [anon_sym_QMARK] = ACTIONS(5372),
    [anon_sym_STAR_EQ] = ACTIONS(5372),
    [anon_sym_SLASH_EQ] = ACTIONS(5372),
    [anon_sym_PERCENT_EQ] = ACTIONS(5372),
    [anon_sym_PLUS_EQ] = ACTIONS(5372),
    [anon_sym_DASH_EQ] = ACTIONS(5372),
    [anon_sym_LT_LT_EQ] = ACTIONS(5372),
    [anon_sym_GT_GT_EQ] = ACTIONS(5372),
    [anon_sym_AMP_EQ] = ACTIONS(5372),
    [anon_sym_CARET_EQ] = ACTIONS(5372),
    [anon_sym_PIPE_EQ] = ACTIONS(5372),
    [anon_sym_and_eq] = ACTIONS(5370),
    [anon_sym_or_eq] = ACTIONS(5370),
    [anon_sym_xor_eq] = ACTIONS(5370),
    [anon_sym_LT_EQ_GT] = ACTIONS(5372),
    [anon_sym_or] = ACTIONS(5370),
    [anon_sym_and] = ACTIONS(5370),
    [anon_sym_bitor] = ACTIONS(5370),
    [anon_sym_xor] = ACTIONS(5370),
    [anon_sym_bitand] = ACTIONS(5370),
    [anon_sym_not_eq] = ACTIONS(5370),
    [anon_sym_DASH_DASH] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5372),
    [anon_sym_DOT] = ACTIONS(5370),
    [anon_sym_DOT_STAR] = ACTIONS(5372),
    [anon_sym_DASH_GT] = ACTIONS(5372),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5370),
    [anon_sym_decltype] = ACTIONS(5370),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5372),
  },
  [2420] = {
    [sym_identifier] = ACTIONS(5145),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5147),
    [anon_sym_COMMA] = ACTIONS(5147),
    [anon_sym_RPAREN] = ACTIONS(5147),
    [aux_sym_preproc_if_token2] = ACTIONS(5147),
    [aux_sym_preproc_else_token1] = ACTIONS(5147),
    [aux_sym_preproc_elif_token1] = ACTIONS(5145),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5147),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5147),
    [anon_sym_LPAREN2] = ACTIONS(5147),
    [anon_sym_DASH] = ACTIONS(5145),
    [anon_sym_PLUS] = ACTIONS(5145),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_SLASH] = ACTIONS(5145),
    [anon_sym_PERCENT] = ACTIONS(5145),
    [anon_sym_PIPE_PIPE] = ACTIONS(5147),
    [anon_sym_AMP_AMP] = ACTIONS(5147),
    [anon_sym_PIPE] = ACTIONS(5145),
    [anon_sym_CARET] = ACTIONS(5145),
    [anon_sym_AMP] = ACTIONS(5145),
    [anon_sym_EQ_EQ] = ACTIONS(5147),
    [anon_sym_BANG_EQ] = ACTIONS(5147),
    [anon_sym_GT] = ACTIONS(5145),
    [anon_sym_GT_EQ] = ACTIONS(5147),
    [anon_sym_LT_EQ] = ACTIONS(5145),
    [anon_sym_LT] = ACTIONS(5145),
    [anon_sym_LT_LT] = ACTIONS(5145),
    [anon_sym_GT_GT] = ACTIONS(5145),
    [anon_sym_SEMI] = ACTIONS(5147),
    [anon_sym___attribute__] = ACTIONS(5145),
    [anon_sym_LBRACE] = ACTIONS(5147),
    [anon_sym_RBRACE] = ACTIONS(5147),
    [anon_sym_LBRACK] = ACTIONS(5147),
    [anon_sym_RBRACK] = ACTIONS(5147),
    [anon_sym_EQ] = ACTIONS(5145),
    [anon_sym_COLON] = ACTIONS(5147),
    [anon_sym_QMARK] = ACTIONS(5147),
    [anon_sym_STAR_EQ] = ACTIONS(5147),
    [anon_sym_SLASH_EQ] = ACTIONS(5147),
    [anon_sym_PERCENT_EQ] = ACTIONS(5147),
    [anon_sym_PLUS_EQ] = ACTIONS(5147),
    [anon_sym_DASH_EQ] = ACTIONS(5147),
    [anon_sym_LT_LT_EQ] = ACTIONS(5147),
    [anon_sym_GT_GT_EQ] = ACTIONS(5147),
    [anon_sym_AMP_EQ] = ACTIONS(5147),
    [anon_sym_CARET_EQ] = ACTIONS(5147),
    [anon_sym_PIPE_EQ] = ACTIONS(5147),
    [anon_sym_and_eq] = ACTIONS(5145),
    [anon_sym_or_eq] = ACTIONS(5145),
    [anon_sym_xor_eq] = ACTIONS(5145),
    [anon_sym_LT_EQ_GT] = ACTIONS(5147),
    [anon_sym_or] = ACTIONS(5145),
    [anon_sym_and] = ACTIONS(5145),
    [anon_sym_bitor] = ACTIONS(5145),
    [anon_sym_xor] = ACTIONS(5145),
    [anon_sym_bitand] = ACTIONS(5145),
    [anon_sym_not_eq] = ACTIONS(5145),
    [anon_sym_DASH_DASH] = ACTIONS(5147),
    [anon_sym_PLUS_PLUS] = ACTIONS(5147),
    [anon_sym_DOT] = ACTIONS(5145),
    [anon_sym_DOT_STAR] = ACTIONS(5147),
    [anon_sym_DASH_GT] = ACTIONS(5147),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5145),
    [anon_sym_decltype] = ACTIONS(5145),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5147),
  },
  [2421] = {
    [sym_identifier] = ACTIONS(5293),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5295),
    [anon_sym_COMMA] = ACTIONS(5295),
    [anon_sym_RPAREN] = ACTIONS(5295),
    [aux_sym_preproc_if_token2] = ACTIONS(5295),
    [aux_sym_preproc_else_token1] = ACTIONS(5295),
    [aux_sym_preproc_elif_token1] = ACTIONS(5293),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5295),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5295),
    [anon_sym_LPAREN2] = ACTIONS(5295),
    [anon_sym_DASH] = ACTIONS(5293),
    [anon_sym_PLUS] = ACTIONS(5293),
    [anon_sym_STAR] = ACTIONS(5293),
    [anon_sym_SLASH] = ACTIONS(5293),
    [anon_sym_PERCENT] = ACTIONS(5293),
    [anon_sym_PIPE_PIPE] = ACTIONS(5295),
    [anon_sym_AMP_AMP] = ACTIONS(5295),
    [anon_sym_PIPE] = ACTIONS(5293),
    [anon_sym_CARET] = ACTIONS(5293),
    [anon_sym_AMP] = ACTIONS(5293),
    [anon_sym_EQ_EQ] = ACTIONS(5295),
    [anon_sym_BANG_EQ] = ACTIONS(5295),
    [anon_sym_GT] = ACTIONS(5293),
    [anon_sym_GT_EQ] = ACTIONS(5295),
    [anon_sym_LT_EQ] = ACTIONS(5293),
    [anon_sym_LT] = ACTIONS(5293),
    [anon_sym_LT_LT] = ACTIONS(5293),
    [anon_sym_GT_GT] = ACTIONS(5293),
    [anon_sym_SEMI] = ACTIONS(5295),
    [anon_sym___attribute__] = ACTIONS(5293),
    [anon_sym_LBRACE] = ACTIONS(5295),
    [anon_sym_RBRACE] = ACTIONS(5295),
    [anon_sym_LBRACK] = ACTIONS(5295),
    [anon_sym_RBRACK] = ACTIONS(5295),
    [anon_sym_EQ] = ACTIONS(5293),
    [anon_sym_COLON] = ACTIONS(5295),
    [anon_sym_QMARK] = ACTIONS(5295),
    [anon_sym_STAR_EQ] = ACTIONS(5295),
    [anon_sym_SLASH_EQ] = ACTIONS(5295),
    [anon_sym_PERCENT_EQ] = ACTIONS(5295),
    [anon_sym_PLUS_EQ] = ACTIONS(5295),
    [anon_sym_DASH_EQ] = ACTIONS(5295),
    [anon_sym_LT_LT_EQ] = ACTIONS(5295),
    [anon_sym_GT_GT_EQ] = ACTIONS(5295),
    [anon_sym_AMP_EQ] = ACTIONS(5295),
    [anon_sym_CARET_EQ] = ACTIONS(5295),
    [anon_sym_PIPE_EQ] = ACTIONS(5295),
    [anon_sym_and_eq] = ACTIONS(5293),
    [anon_sym_or_eq] = ACTIONS(5293),
    [anon_sym_xor_eq] = ACTIONS(5293),
    [anon_sym_LT_EQ_GT] = ACTIONS(5295),
    [anon_sym_or] = ACTIONS(5293),
    [anon_sym_and] = ACTIONS(5293),
    [anon_sym_bitor] = ACTIONS(5293),
    [anon_sym_xor] = ACTIONS(5293),
    [anon_sym_bitand] = ACTIONS(5293),
    [anon_sym_not_eq] = ACTIONS(5293),
    [anon_sym_DASH_DASH] = ACTIONS(5295),
    [anon_sym_PLUS_PLUS] = ACTIONS(5295),
    [anon_sym_DOT] = ACTIONS(5293),
    [anon_sym_DOT_STAR] = ACTIONS(5295),
    [anon_sym_DASH_GT] = ACTIONS(5295),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5293),
    [anon_sym_decltype] = ACTIONS(5293),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5295),
  },
  [2422] = {
    [sym_identifier] = ACTIONS(5336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5338),
    [anon_sym_COMMA] = ACTIONS(5338),
    [anon_sym_RPAREN] = ACTIONS(5338),
    [aux_sym_preproc_if_token2] = ACTIONS(5338),
    [aux_sym_preproc_else_token1] = ACTIONS(5338),
    [aux_sym_preproc_elif_token1] = ACTIONS(5336),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5338),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5338),
    [anon_sym_LPAREN2] = ACTIONS(5338),
    [anon_sym_DASH] = ACTIONS(5336),
    [anon_sym_PLUS] = ACTIONS(5336),
    [anon_sym_STAR] = ACTIONS(5336),
    [anon_sym_SLASH] = ACTIONS(5336),
    [anon_sym_PERCENT] = ACTIONS(5336),
    [anon_sym_PIPE_PIPE] = ACTIONS(5338),
    [anon_sym_AMP_AMP] = ACTIONS(5338),
    [anon_sym_PIPE] = ACTIONS(5336),
    [anon_sym_CARET] = ACTIONS(5336),
    [anon_sym_AMP] = ACTIONS(5336),
    [anon_sym_EQ_EQ] = ACTIONS(5338),
    [anon_sym_BANG_EQ] = ACTIONS(5338),
    [anon_sym_GT] = ACTIONS(5336),
    [anon_sym_GT_EQ] = ACTIONS(5338),
    [anon_sym_LT_EQ] = ACTIONS(5336),
    [anon_sym_LT] = ACTIONS(5336),
    [anon_sym_LT_LT] = ACTIONS(5336),
    [anon_sym_GT_GT] = ACTIONS(5336),
    [anon_sym_SEMI] = ACTIONS(5338),
    [anon_sym___attribute__] = ACTIONS(5336),
    [anon_sym_LBRACE] = ACTIONS(5338),
    [anon_sym_RBRACE] = ACTIONS(5338),
    [anon_sym_LBRACK] = ACTIONS(5338),
    [anon_sym_RBRACK] = ACTIONS(5338),
    [anon_sym_EQ] = ACTIONS(5336),
    [anon_sym_COLON] = ACTIONS(5338),
    [anon_sym_QMARK] = ACTIONS(5338),
    [anon_sym_STAR_EQ] = ACTIONS(5338),
    [anon_sym_SLASH_EQ] = ACTIONS(5338),
    [anon_sym_PERCENT_EQ] = ACTIONS(5338),
    [anon_sym_PLUS_EQ] = ACTIONS(5338),
    [anon_sym_DASH_EQ] = ACTIONS(5338),
    [anon_sym_LT_LT_EQ] = ACTIONS(5338),
    [anon_sym_GT_GT_EQ] = ACTIONS(5338),
    [anon_sym_AMP_EQ] = ACTIONS(5338),
    [anon_sym_CARET_EQ] = ACTIONS(5338),
    [anon_sym_PIPE_EQ] = ACTIONS(5338),
    [anon_sym_and_eq] = ACTIONS(5336),
    [anon_sym_or_eq] = ACTIONS(5336),
    [anon_sym_xor_eq] = ACTIONS(5336),
    [anon_sym_LT_EQ_GT] = ACTIONS(5338),
    [anon_sym_or] = ACTIONS(5336),
    [anon_sym_and] = ACTIONS(5336),
    [anon_sym_bitor] = ACTIONS(5336),
    [anon_sym_xor] = ACTIONS(5336),
    [anon_sym_bitand] = ACTIONS(5336),
    [anon_sym_not_eq] = ACTIONS(5336),
    [anon_sym_DASH_DASH] = ACTIONS(5338),
    [anon_sym_PLUS_PLUS] = ACTIONS(5338),
    [anon_sym_DOT] = ACTIONS(5336),
    [anon_sym_DOT_STAR] = ACTIONS(5338),
    [anon_sym_DASH_GT] = ACTIONS(5338),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5336),
    [anon_sym_decltype] = ACTIONS(5336),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5338),
  },
  [2423] = {
    [sym_identifier] = ACTIONS(5350),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5352),
    [anon_sym_COMMA] = ACTIONS(5352),
    [anon_sym_RPAREN] = ACTIONS(5352),
    [aux_sym_preproc_if_token2] = ACTIONS(5352),
    [aux_sym_preproc_else_token1] = ACTIONS(5352),
    [aux_sym_preproc_elif_token1] = ACTIONS(5350),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5352),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5352),
    [anon_sym_LPAREN2] = ACTIONS(5352),
    [anon_sym_DASH] = ACTIONS(5350),
    [anon_sym_PLUS] = ACTIONS(5350),
    [anon_sym_STAR] = ACTIONS(5350),
    [anon_sym_SLASH] = ACTIONS(5350),
    [anon_sym_PERCENT] = ACTIONS(5350),
    [anon_sym_PIPE_PIPE] = ACTIONS(5352),
    [anon_sym_AMP_AMP] = ACTIONS(5352),
    [anon_sym_PIPE] = ACTIONS(5350),
    [anon_sym_CARET] = ACTIONS(5350),
    [anon_sym_AMP] = ACTIONS(5350),
    [anon_sym_EQ_EQ] = ACTIONS(5352),
    [anon_sym_BANG_EQ] = ACTIONS(5352),
    [anon_sym_GT] = ACTIONS(5350),
    [anon_sym_GT_EQ] = ACTIONS(5352),
    [anon_sym_LT_EQ] = ACTIONS(5350),
    [anon_sym_LT] = ACTIONS(5350),
    [anon_sym_LT_LT] = ACTIONS(5350),
    [anon_sym_GT_GT] = ACTIONS(5350),
    [anon_sym_SEMI] = ACTIONS(5352),
    [anon_sym___attribute__] = ACTIONS(5350),
    [anon_sym_LBRACE] = ACTIONS(5352),
    [anon_sym_RBRACE] = ACTIONS(5352),
    [anon_sym_LBRACK] = ACTIONS(5352),
    [anon_sym_RBRACK] = ACTIONS(5352),
    [anon_sym_EQ] = ACTIONS(5350),
    [anon_sym_COLON] = ACTIONS(5352),
    [anon_sym_QMARK] = ACTIONS(5352),
    [anon_sym_STAR_EQ] = ACTIONS(5352),
    [anon_sym_SLASH_EQ] = ACTIONS(5352),
    [anon_sym_PERCENT_EQ] = ACTIONS(5352),
    [anon_sym_PLUS_EQ] = ACTIONS(5352),
    [anon_sym_DASH_EQ] = ACTIONS(5352),
    [anon_sym_LT_LT_EQ] = ACTIONS(5352),
    [anon_sym_GT_GT_EQ] = ACTIONS(5352),
    [anon_sym_AMP_EQ] = ACTIONS(5352),
    [anon_sym_CARET_EQ] = ACTIONS(5352),
    [anon_sym_PIPE_EQ] = ACTIONS(5352),
    [anon_sym_and_eq] = ACTIONS(5350),
    [anon_sym_or_eq] = ACTIONS(5350),
    [anon_sym_xor_eq] = ACTIONS(5350),
    [anon_sym_LT_EQ_GT] = ACTIONS(5352),
    [anon_sym_or] = ACTIONS(5350),
    [anon_sym_and] = ACTIONS(5350),
    [anon_sym_bitor] = ACTIONS(5350),
    [anon_sym_xor] = ACTIONS(5350),
    [anon_sym_bitand] = ACTIONS(5350),
    [anon_sym_not_eq] = ACTIONS(5350),
    [anon_sym_DASH_DASH] = ACTIONS(5352),
    [anon_sym_PLUS_PLUS] = ACTIONS(5352),
    [anon_sym_DOT] = ACTIONS(5350),
    [anon_sym_DOT_STAR] = ACTIONS(5352),
    [anon_sym_DASH_GT] = ACTIONS(5352),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5350),
    [anon_sym_decltype] = ACTIONS(5350),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5352),
  },
  [2424] = {
    [sym_identifier] = ACTIONS(5297),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5299),
    [anon_sym_COMMA] = ACTIONS(5299),
    [anon_sym_RPAREN] = ACTIONS(5299),
    [aux_sym_preproc_if_token2] = ACTIONS(5299),
    [aux_sym_preproc_else_token1] = ACTIONS(5299),
    [aux_sym_preproc_elif_token1] = ACTIONS(5297),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5299),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5299),
    [anon_sym_LPAREN2] = ACTIONS(5299),
    [anon_sym_DASH] = ACTIONS(5297),
    [anon_sym_PLUS] = ACTIONS(5297),
    [anon_sym_STAR] = ACTIONS(5297),
    [anon_sym_SLASH] = ACTIONS(5297),
    [anon_sym_PERCENT] = ACTIONS(5297),
    [anon_sym_PIPE_PIPE] = ACTIONS(5299),
    [anon_sym_AMP_AMP] = ACTIONS(5299),
    [anon_sym_PIPE] = ACTIONS(5297),
    [anon_sym_CARET] = ACTIONS(5297),
    [anon_sym_AMP] = ACTIONS(5297),
    [anon_sym_EQ_EQ] = ACTIONS(5299),
    [anon_sym_BANG_EQ] = ACTIONS(5299),
    [anon_sym_GT] = ACTIONS(5297),
    [anon_sym_GT_EQ] = ACTIONS(5299),
    [anon_sym_LT_EQ] = ACTIONS(5297),
    [anon_sym_LT] = ACTIONS(5297),
    [anon_sym_LT_LT] = ACTIONS(5297),
    [anon_sym_GT_GT] = ACTIONS(5297),
    [anon_sym_SEMI] = ACTIONS(5299),
    [anon_sym___attribute__] = ACTIONS(5297),
    [anon_sym_LBRACE] = ACTIONS(5299),
    [anon_sym_RBRACE] = ACTIONS(5299),
    [anon_sym_LBRACK] = ACTIONS(5299),
    [anon_sym_RBRACK] = ACTIONS(5299),
    [anon_sym_EQ] = ACTIONS(5297),
    [anon_sym_COLON] = ACTIONS(5299),
    [anon_sym_QMARK] = ACTIONS(5299),
    [anon_sym_STAR_EQ] = ACTIONS(5299),
    [anon_sym_SLASH_EQ] = ACTIONS(5299),
    [anon_sym_PERCENT_EQ] = ACTIONS(5299),
    [anon_sym_PLUS_EQ] = ACTIONS(5299),
    [anon_sym_DASH_EQ] = ACTIONS(5299),
    [anon_sym_LT_LT_EQ] = ACTIONS(5299),
    [anon_sym_GT_GT_EQ] = ACTIONS(5299),
    [anon_sym_AMP_EQ] = ACTIONS(5299),
    [anon_sym_CARET_EQ] = ACTIONS(5299),
    [anon_sym_PIPE_EQ] = ACTIONS(5299),
    [anon_sym_and_eq] = ACTIONS(5297),
    [anon_sym_or_eq] = ACTIONS(5297),
    [anon_sym_xor_eq] = ACTIONS(5297),
    [anon_sym_LT_EQ_GT] = ACTIONS(5299),
    [anon_sym_or] = ACTIONS(5297),
    [anon_sym_and] = ACTIONS(5297),
    [anon_sym_bitor] = ACTIONS(5297),
    [anon_sym_xor] = ACTIONS(5297),
    [anon_sym_bitand] = ACTIONS(5297),
    [anon_sym_not_eq] = ACTIONS(5297),
    [anon_sym_DASH_DASH] = ACTIONS(5299),
    [anon_sym_PLUS_PLUS] = ACTIONS(5299),
    [anon_sym_DOT] = ACTIONS(5297),
    [anon_sym_DOT_STAR] = ACTIONS(5299),
    [anon_sym_DASH_GT] = ACTIONS(5299),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5297),
    [anon_sym_decltype] = ACTIONS(5297),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5299),
  },
  [2425] = {
    [sym_identifier] = ACTIONS(5340),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5342),
    [anon_sym_COMMA] = ACTIONS(5342),
    [anon_sym_RPAREN] = ACTIONS(5342),
    [aux_sym_preproc_if_token2] = ACTIONS(5342),
    [aux_sym_preproc_else_token1] = ACTIONS(5342),
    [aux_sym_preproc_elif_token1] = ACTIONS(5340),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5342),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5342),
    [anon_sym_LPAREN2] = ACTIONS(5342),
    [anon_sym_DASH] = ACTIONS(5340),
    [anon_sym_PLUS] = ACTIONS(5340),
    [anon_sym_STAR] = ACTIONS(5340),
    [anon_sym_SLASH] = ACTIONS(5340),
    [anon_sym_PERCENT] = ACTIONS(5340),
    [anon_sym_PIPE_PIPE] = ACTIONS(5342),
    [anon_sym_AMP_AMP] = ACTIONS(5342),
    [anon_sym_PIPE] = ACTIONS(5340),
    [anon_sym_CARET] = ACTIONS(5340),
    [anon_sym_AMP] = ACTIONS(5340),
    [anon_sym_EQ_EQ] = ACTIONS(5342),
    [anon_sym_BANG_EQ] = ACTIONS(5342),
    [anon_sym_GT] = ACTIONS(5340),
    [anon_sym_GT_EQ] = ACTIONS(5342),
    [anon_sym_LT_EQ] = ACTIONS(5340),
    [anon_sym_LT] = ACTIONS(5340),
    [anon_sym_LT_LT] = ACTIONS(5340),
    [anon_sym_GT_GT] = ACTIONS(5340),
    [anon_sym_SEMI] = ACTIONS(5342),
    [anon_sym___attribute__] = ACTIONS(5340),
    [anon_sym_LBRACE] = ACTIONS(5342),
    [anon_sym_RBRACE] = ACTIONS(5342),
    [anon_sym_LBRACK] = ACTIONS(5342),
    [anon_sym_RBRACK] = ACTIONS(5342),
    [anon_sym_EQ] = ACTIONS(5340),
    [anon_sym_COLON] = ACTIONS(5342),
    [anon_sym_QMARK] = ACTIONS(5342),
    [anon_sym_STAR_EQ] = ACTIONS(5342),
    [anon_sym_SLASH_EQ] = ACTIONS(5342),
    [anon_sym_PERCENT_EQ] = ACTIONS(5342),
    [anon_sym_PLUS_EQ] = ACTIONS(5342),
    [anon_sym_DASH_EQ] = ACTIONS(5342),
    [anon_sym_LT_LT_EQ] = ACTIONS(5342),
    [anon_sym_GT_GT_EQ] = ACTIONS(5342),
    [anon_sym_AMP_EQ] = ACTIONS(5342),
    [anon_sym_CARET_EQ] = ACTIONS(5342),
    [anon_sym_PIPE_EQ] = ACTIONS(5342),
    [anon_sym_and_eq] = ACTIONS(5340),
    [anon_sym_or_eq] = ACTIONS(5340),
    [anon_sym_xor_eq] = ACTIONS(5340),
    [anon_sym_LT_EQ_GT] = ACTIONS(5342),
    [anon_sym_or] = ACTIONS(5340),
    [anon_sym_and] = ACTIONS(5340),
    [anon_sym_bitor] = ACTIONS(5340),
    [anon_sym_xor] = ACTIONS(5340),
    [anon_sym_bitand] = ACTIONS(5340),
    [anon_sym_not_eq] = ACTIONS(5340),
    [anon_sym_DASH_DASH] = ACTIONS(5342),
    [anon_sym_PLUS_PLUS] = ACTIONS(5342),
    [anon_sym_DOT] = ACTIONS(5340),
    [anon_sym_DOT_STAR] = ACTIONS(5342),
    [anon_sym_DASH_GT] = ACTIONS(5342),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5340),
    [anon_sym_decltype] = ACTIONS(5340),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5342),
  },
  [2426] = {
    [sym_identifier] = ACTIONS(5319),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5321),
    [anon_sym_COMMA] = ACTIONS(5321),
    [anon_sym_RPAREN] = ACTIONS(5321),
    [aux_sym_preproc_if_token2] = ACTIONS(5321),
    [aux_sym_preproc_else_token1] = ACTIONS(5321),
    [aux_sym_preproc_elif_token1] = ACTIONS(5319),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5321),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5321),
    [anon_sym_LPAREN2] = ACTIONS(5321),
    [anon_sym_DASH] = ACTIONS(5319),
    [anon_sym_PLUS] = ACTIONS(5319),
    [anon_sym_STAR] = ACTIONS(5319),
    [anon_sym_SLASH] = ACTIONS(5319),
    [anon_sym_PERCENT] = ACTIONS(5319),
    [anon_sym_PIPE_PIPE] = ACTIONS(5321),
    [anon_sym_AMP_AMP] = ACTIONS(5321),
    [anon_sym_PIPE] = ACTIONS(5319),
    [anon_sym_CARET] = ACTIONS(5319),
    [anon_sym_AMP] = ACTIONS(5319),
    [anon_sym_EQ_EQ] = ACTIONS(5321),
    [anon_sym_BANG_EQ] = ACTIONS(5321),
    [anon_sym_GT] = ACTIONS(5319),
    [anon_sym_GT_EQ] = ACTIONS(5321),
    [anon_sym_LT_EQ] = ACTIONS(5319),
    [anon_sym_LT] = ACTIONS(5319),
    [anon_sym_LT_LT] = ACTIONS(5319),
    [anon_sym_GT_GT] = ACTIONS(5319),
    [anon_sym_SEMI] = ACTIONS(5321),
    [anon_sym___attribute__] = ACTIONS(5319),
    [anon_sym_LBRACE] = ACTIONS(5321),
    [anon_sym_RBRACE] = ACTIONS(5321),
    [anon_sym_LBRACK] = ACTIONS(5321),
    [anon_sym_RBRACK] = ACTIONS(5321),
    [anon_sym_EQ] = ACTIONS(5319),
    [anon_sym_COLON] = ACTIONS(5321),
    [anon_sym_QMARK] = ACTIONS(5321),
    [anon_sym_STAR_EQ] = ACTIONS(5321),
    [anon_sym_SLASH_EQ] = ACTIONS(5321),
    [anon_sym_PERCENT_EQ] = ACTIONS(5321),
    [anon_sym_PLUS_EQ] = ACTIONS(5321),
    [anon_sym_DASH_EQ] = ACTIONS(5321),
    [anon_sym_LT_LT_EQ] = ACTIONS(5321),
    [anon_sym_GT_GT_EQ] = ACTIONS(5321),
    [anon_sym_AMP_EQ] = ACTIONS(5321),
    [anon_sym_CARET_EQ] = ACTIONS(5321),
    [anon_sym_PIPE_EQ] = ACTIONS(5321),
    [anon_sym_and_eq] = ACTIONS(5319),
    [anon_sym_or_eq] = ACTIONS(5319),
    [anon_sym_xor_eq] = ACTIONS(5319),
    [anon_sym_LT_EQ_GT] = ACTIONS(5321),
    [anon_sym_or] = ACTIONS(5319),
    [anon_sym_and] = ACTIONS(5319),
    [anon_sym_bitor] = ACTIONS(5319),
    [anon_sym_xor] = ACTIONS(5319),
    [anon_sym_bitand] = ACTIONS(5319),
    [anon_sym_not_eq] = ACTIONS(5319),
    [anon_sym_DASH_DASH] = ACTIONS(5321),
    [anon_sym_PLUS_PLUS] = ACTIONS(5321),
    [anon_sym_DOT] = ACTIONS(5319),
    [anon_sym_DOT_STAR] = ACTIONS(5321),
    [anon_sym_DASH_GT] = ACTIONS(5321),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5319),
    [anon_sym_decltype] = ACTIONS(5319),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5321),
  },
  [2427] = {
    [sym_identifier] = ACTIONS(5315),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5317),
    [anon_sym_COMMA] = ACTIONS(5317),
    [anon_sym_RPAREN] = ACTIONS(5317),
    [aux_sym_preproc_if_token2] = ACTIONS(5317),
    [aux_sym_preproc_else_token1] = ACTIONS(5317),
    [aux_sym_preproc_elif_token1] = ACTIONS(5315),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5317),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5317),
    [anon_sym_LPAREN2] = ACTIONS(5317),
    [anon_sym_DASH] = ACTIONS(5315),
    [anon_sym_PLUS] = ACTIONS(5315),
    [anon_sym_STAR] = ACTIONS(5315),
    [anon_sym_SLASH] = ACTIONS(5315),
    [anon_sym_PERCENT] = ACTIONS(5315),
    [anon_sym_PIPE_PIPE] = ACTIONS(5317),
    [anon_sym_AMP_AMP] = ACTIONS(5317),
    [anon_sym_PIPE] = ACTIONS(5315),
    [anon_sym_CARET] = ACTIONS(5315),
    [anon_sym_AMP] = ACTIONS(5315),
    [anon_sym_EQ_EQ] = ACTIONS(5317),
    [anon_sym_BANG_EQ] = ACTIONS(5317),
    [anon_sym_GT] = ACTIONS(5315),
    [anon_sym_GT_EQ] = ACTIONS(5317),
    [anon_sym_LT_EQ] = ACTIONS(5315),
    [anon_sym_LT] = ACTIONS(5315),
    [anon_sym_LT_LT] = ACTIONS(5315),
    [anon_sym_GT_GT] = ACTIONS(5315),
    [anon_sym_SEMI] = ACTIONS(5317),
    [anon_sym___attribute__] = ACTIONS(5315),
    [anon_sym_LBRACE] = ACTIONS(5317),
    [anon_sym_RBRACE] = ACTIONS(5317),
    [anon_sym_LBRACK] = ACTIONS(5317),
    [anon_sym_RBRACK] = ACTIONS(5317),
    [anon_sym_EQ] = ACTIONS(5315),
    [anon_sym_COLON] = ACTIONS(5317),
    [anon_sym_QMARK] = ACTIONS(5317),
    [anon_sym_STAR_EQ] = ACTIONS(5317),
    [anon_sym_SLASH_EQ] = ACTIONS(5317),
    [anon_sym_PERCENT_EQ] = ACTIONS(5317),
    [anon_sym_PLUS_EQ] = ACTIONS(5317),
    [anon_sym_DASH_EQ] = ACTIONS(5317),
    [anon_sym_LT_LT_EQ] = ACTIONS(5317),
    [anon_sym_GT_GT_EQ] = ACTIONS(5317),
    [anon_sym_AMP_EQ] = ACTIONS(5317),
    [anon_sym_CARET_EQ] = ACTIONS(5317),
    [anon_sym_PIPE_EQ] = ACTIONS(5317),
    [anon_sym_and_eq] = ACTIONS(5315),
    [anon_sym_or_eq] = ACTIONS(5315),
    [anon_sym_xor_eq] = ACTIONS(5315),
    [anon_sym_LT_EQ_GT] = ACTIONS(5317),
    [anon_sym_or] = ACTIONS(5315),
    [anon_sym_and] = ACTIONS(5315),
    [anon_sym_bitor] = ACTIONS(5315),
    [anon_sym_xor] = ACTIONS(5315),
    [anon_sym_bitand] = ACTIONS(5315),
    [anon_sym_not_eq] = ACTIONS(5315),
    [anon_sym_DASH_DASH] = ACTIONS(5317),
    [anon_sym_PLUS_PLUS] = ACTIONS(5317),
    [anon_sym_DOT] = ACTIONS(5315),
    [anon_sym_DOT_STAR] = ACTIONS(5317),
    [anon_sym_DASH_GT] = ACTIONS(5317),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5315),
    [anon_sym_decltype] = ACTIONS(5315),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5317),
  },
  [2428] = {
    [sym_string_literal] = STATE(2298),
    [sym_raw_string_literal] = STATE(2298),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_SEMI] = ACTIONS(3758),
    [anon_sym___attribute__] = ACTIONS(3766),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3758),
    [anon_sym_SLASH_EQ] = ACTIONS(3758),
    [anon_sym_PERCENT_EQ] = ACTIONS(3758),
    [anon_sym_PLUS_EQ] = ACTIONS(3758),
    [anon_sym_DASH_EQ] = ACTIONS(3758),
    [anon_sym_LT_LT_EQ] = ACTIONS(3758),
    [anon_sym_GT_GT_EQ] = ACTIONS(3758),
    [anon_sym_AMP_EQ] = ACTIONS(3758),
    [anon_sym_CARET_EQ] = ACTIONS(3758),
    [anon_sym_PIPE_EQ] = ACTIONS(3758),
    [anon_sym_and_eq] = ACTIONS(3766),
    [anon_sym_or_eq] = ACTIONS(3766),
    [anon_sym_xor_eq] = ACTIONS(3766),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3766),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3766),
    [anon_sym_not_eq] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(5766),
    [anon_sym_u_DQUOTE] = ACTIONS(5766),
    [anon_sym_U_DQUOTE] = ACTIONS(5766),
    [anon_sym_u8_DQUOTE] = ACTIONS(5766),
    [anon_sym_DQUOTE] = ACTIONS(5766),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5768),
    [anon_sym_LR_DQUOTE] = ACTIONS(5768),
    [anon_sym_uR_DQUOTE] = ACTIONS(5768),
    [anon_sym_UR_DQUOTE] = ACTIONS(5768),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5768),
    [sym_literal_suffix] = ACTIONS(5708),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2429] = {
    [sym_identifier] = ACTIONS(5289),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5291),
    [anon_sym_COMMA] = ACTIONS(5291),
    [anon_sym_RPAREN] = ACTIONS(5291),
    [aux_sym_preproc_if_token2] = ACTIONS(5291),
    [aux_sym_preproc_else_token1] = ACTIONS(5291),
    [aux_sym_preproc_elif_token1] = ACTIONS(5289),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5291),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5291),
    [anon_sym_LPAREN2] = ACTIONS(5291),
    [anon_sym_DASH] = ACTIONS(5289),
    [anon_sym_PLUS] = ACTIONS(5289),
    [anon_sym_STAR] = ACTIONS(5289),
    [anon_sym_SLASH] = ACTIONS(5289),
    [anon_sym_PERCENT] = ACTIONS(5289),
    [anon_sym_PIPE_PIPE] = ACTIONS(5291),
    [anon_sym_AMP_AMP] = ACTIONS(5291),
    [anon_sym_PIPE] = ACTIONS(5289),
    [anon_sym_CARET] = ACTIONS(5289),
    [anon_sym_AMP] = ACTIONS(5289),
    [anon_sym_EQ_EQ] = ACTIONS(5291),
    [anon_sym_BANG_EQ] = ACTIONS(5291),
    [anon_sym_GT] = ACTIONS(5289),
    [anon_sym_GT_EQ] = ACTIONS(5291),
    [anon_sym_LT_EQ] = ACTIONS(5289),
    [anon_sym_LT] = ACTIONS(5289),
    [anon_sym_LT_LT] = ACTIONS(5289),
    [anon_sym_GT_GT] = ACTIONS(5289),
    [anon_sym_SEMI] = ACTIONS(5291),
    [anon_sym___attribute__] = ACTIONS(5289),
    [anon_sym_LBRACE] = ACTIONS(5291),
    [anon_sym_RBRACE] = ACTIONS(5291),
    [anon_sym_LBRACK] = ACTIONS(5291),
    [anon_sym_RBRACK] = ACTIONS(5291),
    [anon_sym_EQ] = ACTIONS(5289),
    [anon_sym_COLON] = ACTIONS(5291),
    [anon_sym_QMARK] = ACTIONS(5291),
    [anon_sym_STAR_EQ] = ACTIONS(5291),
    [anon_sym_SLASH_EQ] = ACTIONS(5291),
    [anon_sym_PERCENT_EQ] = ACTIONS(5291),
    [anon_sym_PLUS_EQ] = ACTIONS(5291),
    [anon_sym_DASH_EQ] = ACTIONS(5291),
    [anon_sym_LT_LT_EQ] = ACTIONS(5291),
    [anon_sym_GT_GT_EQ] = ACTIONS(5291),
    [anon_sym_AMP_EQ] = ACTIONS(5291),
    [anon_sym_CARET_EQ] = ACTIONS(5291),
    [anon_sym_PIPE_EQ] = ACTIONS(5291),
    [anon_sym_and_eq] = ACTIONS(5289),
    [anon_sym_or_eq] = ACTIONS(5289),
    [anon_sym_xor_eq] = ACTIONS(5289),
    [anon_sym_LT_EQ_GT] = ACTIONS(5291),
    [anon_sym_or] = ACTIONS(5289),
    [anon_sym_and] = ACTIONS(5289),
    [anon_sym_bitor] = ACTIONS(5289),
    [anon_sym_xor] = ACTIONS(5289),
    [anon_sym_bitand] = ACTIONS(5289),
    [anon_sym_not_eq] = ACTIONS(5289),
    [anon_sym_DASH_DASH] = ACTIONS(5291),
    [anon_sym_PLUS_PLUS] = ACTIONS(5291),
    [anon_sym_DOT] = ACTIONS(5289),
    [anon_sym_DOT_STAR] = ACTIONS(5291),
    [anon_sym_DASH_GT] = ACTIONS(5291),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5289),
    [anon_sym_decltype] = ACTIONS(5289),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5291),
  },
  [2430] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2378),
    [sym_identifier] = ACTIONS(5438),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5436),
    [anon_sym_COMMA] = ACTIONS(5436),
    [aux_sym_preproc_if_token2] = ACTIONS(5436),
    [aux_sym_preproc_else_token1] = ACTIONS(5436),
    [aux_sym_preproc_elif_token1] = ACTIONS(5438),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5436),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5436),
    [anon_sym_LPAREN2] = ACTIONS(5436),
    [anon_sym_DASH] = ACTIONS(5438),
    [anon_sym_PLUS] = ACTIONS(5438),
    [anon_sym_STAR] = ACTIONS(5438),
    [anon_sym_SLASH] = ACTIONS(5438),
    [anon_sym_PERCENT] = ACTIONS(5438),
    [anon_sym_PIPE_PIPE] = ACTIONS(5436),
    [anon_sym_AMP_AMP] = ACTIONS(5436),
    [anon_sym_PIPE] = ACTIONS(5438),
    [anon_sym_CARET] = ACTIONS(5438),
    [anon_sym_AMP] = ACTIONS(5438),
    [anon_sym_EQ_EQ] = ACTIONS(5436),
    [anon_sym_BANG_EQ] = ACTIONS(5436),
    [anon_sym_GT] = ACTIONS(5438),
    [anon_sym_GT_EQ] = ACTIONS(5436),
    [anon_sym_LT_EQ] = ACTIONS(5438),
    [anon_sym_LT] = ACTIONS(5438),
    [anon_sym_LT_LT] = ACTIONS(5438),
    [anon_sym_GT_GT] = ACTIONS(5438),
    [anon_sym___attribute__] = ACTIONS(5438),
    [anon_sym_LBRACE] = ACTIONS(5436),
    [anon_sym_signed] = ACTIONS(6018),
    [anon_sym_unsigned] = ACTIONS(6018),
    [anon_sym_long] = ACTIONS(6018),
    [anon_sym_short] = ACTIONS(6018),
    [anon_sym_LBRACK] = ACTIONS(5436),
    [anon_sym_EQ] = ACTIONS(5438),
    [anon_sym_QMARK] = ACTIONS(5436),
    [anon_sym_STAR_EQ] = ACTIONS(5436),
    [anon_sym_SLASH_EQ] = ACTIONS(5436),
    [anon_sym_PERCENT_EQ] = ACTIONS(5436),
    [anon_sym_PLUS_EQ] = ACTIONS(5436),
    [anon_sym_DASH_EQ] = ACTIONS(5436),
    [anon_sym_LT_LT_EQ] = ACTIONS(5436),
    [anon_sym_GT_GT_EQ] = ACTIONS(5436),
    [anon_sym_AMP_EQ] = ACTIONS(5436),
    [anon_sym_CARET_EQ] = ACTIONS(5436),
    [anon_sym_PIPE_EQ] = ACTIONS(5436),
    [anon_sym_and_eq] = ACTIONS(5438),
    [anon_sym_or_eq] = ACTIONS(5438),
    [anon_sym_xor_eq] = ACTIONS(5438),
    [anon_sym_LT_EQ_GT] = ACTIONS(5436),
    [anon_sym_or] = ACTIONS(5438),
    [anon_sym_and] = ACTIONS(5438),
    [anon_sym_bitor] = ACTIONS(5438),
    [anon_sym_xor] = ACTIONS(5438),
    [anon_sym_bitand] = ACTIONS(5438),
    [anon_sym_not_eq] = ACTIONS(5438),
    [anon_sym_DASH_DASH] = ACTIONS(5436),
    [anon_sym_PLUS_PLUS] = ACTIONS(5436),
    [anon_sym_DOT] = ACTIONS(5438),
    [anon_sym_DOT_STAR] = ACTIONS(5436),
    [anon_sym_DASH_GT] = ACTIONS(5436),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5438),
    [anon_sym_decltype] = ACTIONS(5438),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5436),
  },
  [2431] = {
    [sym_string_literal] = STATE(2298),
    [sym_raw_string_literal] = STATE(2298),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5712),
    [anon_sym_COMMA] = ACTIONS(5712),
    [anon_sym_LPAREN2] = ACTIONS(5712),
    [anon_sym_DASH] = ACTIONS(5710),
    [anon_sym_PLUS] = ACTIONS(5710),
    [anon_sym_STAR] = ACTIONS(5710),
    [anon_sym_SLASH] = ACTIONS(5710),
    [anon_sym_PERCENT] = ACTIONS(5710),
    [anon_sym_PIPE_PIPE] = ACTIONS(5712),
    [anon_sym_AMP_AMP] = ACTIONS(5712),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_CARET] = ACTIONS(5710),
    [anon_sym_AMP] = ACTIONS(5710),
    [anon_sym_EQ_EQ] = ACTIONS(5712),
    [anon_sym_BANG_EQ] = ACTIONS(5712),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_EQ] = ACTIONS(5712),
    [anon_sym_LT_EQ] = ACTIONS(5710),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5710),
    [anon_sym_SEMI] = ACTIONS(5712),
    [anon_sym___attribute__] = ACTIONS(5710),
    [anon_sym_LBRACK] = ACTIONS(5712),
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_QMARK] = ACTIONS(5712),
    [anon_sym_STAR_EQ] = ACTIONS(5712),
    [anon_sym_SLASH_EQ] = ACTIONS(5712),
    [anon_sym_PERCENT_EQ] = ACTIONS(5712),
    [anon_sym_PLUS_EQ] = ACTIONS(5712),
    [anon_sym_DASH_EQ] = ACTIONS(5712),
    [anon_sym_LT_LT_EQ] = ACTIONS(5712),
    [anon_sym_GT_GT_EQ] = ACTIONS(5712),
    [anon_sym_AMP_EQ] = ACTIONS(5712),
    [anon_sym_CARET_EQ] = ACTIONS(5712),
    [anon_sym_PIPE_EQ] = ACTIONS(5712),
    [anon_sym_and_eq] = ACTIONS(5710),
    [anon_sym_or_eq] = ACTIONS(5710),
    [anon_sym_xor_eq] = ACTIONS(5710),
    [anon_sym_LT_EQ_GT] = ACTIONS(5712),
    [anon_sym_or] = ACTIONS(5710),
    [anon_sym_and] = ACTIONS(5710),
    [anon_sym_bitor] = ACTIONS(5710),
    [anon_sym_xor] = ACTIONS(5710),
    [anon_sym_bitand] = ACTIONS(5710),
    [anon_sym_not_eq] = ACTIONS(5710),
    [anon_sym_DASH_DASH] = ACTIONS(5712),
    [anon_sym_PLUS_PLUS] = ACTIONS(5712),
    [anon_sym_DOT] = ACTIONS(5710),
    [anon_sym_DOT_STAR] = ACTIONS(5712),
    [anon_sym_DASH_GT] = ACTIONS(5712),
    [anon_sym_L_DQUOTE] = ACTIONS(5766),
    [anon_sym_u_DQUOTE] = ACTIONS(5766),
    [anon_sym_U_DQUOTE] = ACTIONS(5766),
    [anon_sym_u8_DQUOTE] = ACTIONS(5766),
    [anon_sym_DQUOTE] = ACTIONS(5766),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5768),
    [anon_sym_LR_DQUOTE] = ACTIONS(5768),
    [anon_sym_uR_DQUOTE] = ACTIONS(5768),
    [anon_sym_UR_DQUOTE] = ACTIONS(5768),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5768),
    [sym_literal_suffix] = ACTIONS(5708),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5712),
  },
  [2432] = {
    [sym_identifier] = ACTIONS(6020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6022),
    [anon_sym_COMMA] = ACTIONS(6022),
    [anon_sym_RPAREN] = ACTIONS(6022),
    [aux_sym_preproc_if_token2] = ACTIONS(6022),
    [aux_sym_preproc_else_token1] = ACTIONS(6022),
    [aux_sym_preproc_elif_token1] = ACTIONS(6020),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6022),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6022),
    [anon_sym_LPAREN2] = ACTIONS(6022),
    [anon_sym_DASH] = ACTIONS(6020),
    [anon_sym_PLUS] = ACTIONS(6020),
    [anon_sym_STAR] = ACTIONS(6020),
    [anon_sym_SLASH] = ACTIONS(6020),
    [anon_sym_PERCENT] = ACTIONS(6020),
    [anon_sym_PIPE_PIPE] = ACTIONS(6022),
    [anon_sym_AMP_AMP] = ACTIONS(6022),
    [anon_sym_PIPE] = ACTIONS(6020),
    [anon_sym_CARET] = ACTIONS(6020),
    [anon_sym_AMP] = ACTIONS(6020),
    [anon_sym_EQ_EQ] = ACTIONS(6022),
    [anon_sym_BANG_EQ] = ACTIONS(6022),
    [anon_sym_GT] = ACTIONS(6020),
    [anon_sym_GT_EQ] = ACTIONS(6022),
    [anon_sym_LT_EQ] = ACTIONS(6020),
    [anon_sym_LT] = ACTIONS(6020),
    [anon_sym_LT_LT] = ACTIONS(6020),
    [anon_sym_GT_GT] = ACTIONS(6020),
    [anon_sym_SEMI] = ACTIONS(6022),
    [anon_sym___attribute__] = ACTIONS(6020),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6022),
    [anon_sym_LBRACE] = ACTIONS(6022),
    [anon_sym_RBRACE] = ACTIONS(6022),
    [anon_sym_LBRACK] = ACTIONS(6020),
    [anon_sym_RBRACK] = ACTIONS(6022),
    [anon_sym_EQ] = ACTIONS(6020),
    [anon_sym_COLON] = ACTIONS(6022),
    [anon_sym_QMARK] = ACTIONS(6022),
    [anon_sym_STAR_EQ] = ACTIONS(6022),
    [anon_sym_SLASH_EQ] = ACTIONS(6022),
    [anon_sym_PERCENT_EQ] = ACTIONS(6022),
    [anon_sym_PLUS_EQ] = ACTIONS(6022),
    [anon_sym_DASH_EQ] = ACTIONS(6022),
    [anon_sym_LT_LT_EQ] = ACTIONS(6022),
    [anon_sym_GT_GT_EQ] = ACTIONS(6022),
    [anon_sym_AMP_EQ] = ACTIONS(6022),
    [anon_sym_CARET_EQ] = ACTIONS(6022),
    [anon_sym_PIPE_EQ] = ACTIONS(6022),
    [anon_sym_and_eq] = ACTIONS(6020),
    [anon_sym_or_eq] = ACTIONS(6020),
    [anon_sym_xor_eq] = ACTIONS(6020),
    [anon_sym_LT_EQ_GT] = ACTIONS(6022),
    [anon_sym_or] = ACTIONS(6020),
    [anon_sym_and] = ACTIONS(6020),
    [anon_sym_bitor] = ACTIONS(6020),
    [anon_sym_xor] = ACTIONS(6020),
    [anon_sym_bitand] = ACTIONS(6020),
    [anon_sym_not_eq] = ACTIONS(6020),
    [anon_sym_DASH_DASH] = ACTIONS(6022),
    [anon_sym_PLUS_PLUS] = ACTIONS(6022),
    [anon_sym_DOT] = ACTIONS(6020),
    [anon_sym_DOT_STAR] = ACTIONS(6022),
    [anon_sym_DASH_GT] = ACTIONS(6022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6020),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(6022),
  },
  [2433] = {
    [sym_argument_list] = STATE(2731),
    [sym_initializer_list] = STATE(2731),
    [sym_identifier] = ACTIONS(6024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6026),
    [anon_sym_COMMA] = ACTIONS(6026),
    [anon_sym_RPAREN] = ACTIONS(6026),
    [aux_sym_preproc_if_token2] = ACTIONS(6026),
    [aux_sym_preproc_else_token1] = ACTIONS(6026),
    [aux_sym_preproc_elif_token1] = ACTIONS(6024),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6026),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6026),
    [anon_sym_LPAREN2] = ACTIONS(5644),
    [anon_sym_DASH] = ACTIONS(6024),
    [anon_sym_PLUS] = ACTIONS(6024),
    [anon_sym_STAR] = ACTIONS(6024),
    [anon_sym_SLASH] = ACTIONS(6024),
    [anon_sym_PERCENT] = ACTIONS(6024),
    [anon_sym_PIPE_PIPE] = ACTIONS(6026),
    [anon_sym_AMP_AMP] = ACTIONS(6026),
    [anon_sym_PIPE] = ACTIONS(6024),
    [anon_sym_CARET] = ACTIONS(6024),
    [anon_sym_AMP] = ACTIONS(6024),
    [anon_sym_EQ_EQ] = ACTIONS(6026),
    [anon_sym_BANG_EQ] = ACTIONS(6026),
    [anon_sym_GT] = ACTIONS(6024),
    [anon_sym_GT_EQ] = ACTIONS(6026),
    [anon_sym_LT_EQ] = ACTIONS(6024),
    [anon_sym_LT] = ACTIONS(6024),
    [anon_sym_LT_LT] = ACTIONS(6024),
    [anon_sym_GT_GT] = ACTIONS(6024),
    [anon_sym_SEMI] = ACTIONS(6026),
    [anon_sym___attribute__] = ACTIONS(6024),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_RBRACE] = ACTIONS(6026),
    [anon_sym_LBRACK] = ACTIONS(6026),
    [anon_sym_RBRACK] = ACTIONS(6026),
    [anon_sym_EQ] = ACTIONS(6024),
    [anon_sym_COLON] = ACTIONS(6026),
    [anon_sym_QMARK] = ACTIONS(6026),
    [anon_sym_STAR_EQ] = ACTIONS(6026),
    [anon_sym_SLASH_EQ] = ACTIONS(6026),
    [anon_sym_PERCENT_EQ] = ACTIONS(6026),
    [anon_sym_PLUS_EQ] = ACTIONS(6026),
    [anon_sym_DASH_EQ] = ACTIONS(6026),
    [anon_sym_LT_LT_EQ] = ACTIONS(6026),
    [anon_sym_GT_GT_EQ] = ACTIONS(6026),
    [anon_sym_AMP_EQ] = ACTIONS(6026),
    [anon_sym_CARET_EQ] = ACTIONS(6026),
    [anon_sym_PIPE_EQ] = ACTIONS(6026),
    [anon_sym_and_eq] = ACTIONS(6024),
    [anon_sym_or_eq] = ACTIONS(6024),
    [anon_sym_xor_eq] = ACTIONS(6024),
    [anon_sym_LT_EQ_GT] = ACTIONS(6026),
    [anon_sym_or] = ACTIONS(6024),
    [anon_sym_and] = ACTIONS(6024),
    [anon_sym_bitor] = ACTIONS(6024),
    [anon_sym_xor] = ACTIONS(6024),
    [anon_sym_bitand] = ACTIONS(6024),
    [anon_sym_not_eq] = ACTIONS(6024),
    [anon_sym_DASH_DASH] = ACTIONS(6026),
    [anon_sym_PLUS_PLUS] = ACTIONS(6026),
    [anon_sym_DOT] = ACTIONS(6024),
    [anon_sym_DOT_STAR] = ACTIONS(6026),
    [anon_sym_DASH_GT] = ACTIONS(6026),
    [sym_comment] = ACTIONS(3),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(6026),
  },
  [2434] = {
    [sym_attribute_specifier] = STATE(2527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5668),
    [anon_sym_COMMA] = ACTIONS(5668),
    [anon_sym_LPAREN2] = ACTIONS(5668),
    [anon_sym_DASH] = ACTIONS(5670),
    [anon_sym_PLUS] = ACTIONS(5670),
    [anon_sym_STAR] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(5670),
    [anon_sym_PERCENT] = ACTIONS(5668),
    [anon_sym_PIPE_PIPE] = ACTIONS(5668),
    [anon_sym_AMP_AMP] = ACTIONS(5668),
    [anon_sym_PIPE] = ACTIONS(5670),
    [anon_sym_CARET] = ACTIONS(5668),
    [anon_sym_AMP] = ACTIONS(5670),
    [anon_sym_EQ_EQ] = ACTIONS(5668),
    [anon_sym_BANG_EQ] = ACTIONS(5668),
    [anon_sym_GT] = ACTIONS(5670),
    [anon_sym_GT_EQ] = ACTIONS(5670),
    [anon_sym_LT_EQ] = ACTIONS(5670),
    [anon_sym_LT] = ACTIONS(5670),
    [anon_sym_LT_LT] = ACTIONS(5670),
    [anon_sym_GT_GT] = ACTIONS(5670),
    [anon_sym___extension__] = ACTIONS(5668),
    [anon_sym___global__] = ACTIONS(5668),
    [anon_sym___attribute__] = ACTIONS(5652),
    [anon_sym_LBRACE] = ACTIONS(5668),
    [anon_sym_LBRACK] = ACTIONS(5668),
    [anon_sym_const] = ACTIONS(5670),
    [anon_sym_constexpr] = ACTIONS(5668),
    [anon_sym_volatile] = ACTIONS(5668),
    [anon_sym_restrict] = ACTIONS(5668),
    [anon_sym___restrict__] = ACTIONS(5668),
    [anon_sym__Atomic] = ACTIONS(5668),
    [anon_sym__Noreturn] = ACTIONS(5668),
    [anon_sym_noreturn] = ACTIONS(5668),
    [anon_sym_mutable] = ACTIONS(5668),
    [anon_sym_constinit] = ACTIONS(5668),
    [anon_sym_consteval] = ACTIONS(5668),
    [anon_sym___shared__] = ACTIONS(5668),
    [anon_sym___local__] = ACTIONS(5668),
    [anon_sym___constant__] = ACTIONS(5668),
    [anon_sym___managed__] = ACTIONS(5668),
    [anon_sym___grid_constant__] = ACTIONS(5668),
    [anon_sym_alignas] = ACTIONS(5668),
    [anon_sym__Alignas] = ACTIONS(5668),
    [anon_sym_QMARK] = ACTIONS(5668),
    [anon_sym_LT_EQ_GT] = ACTIONS(5668),
    [anon_sym_or] = ACTIONS(5668),
    [anon_sym_and] = ACTIONS(5668),
    [anon_sym_bitor] = ACTIONS(5668),
    [anon_sym_xor] = ACTIONS(5668),
    [anon_sym_bitand] = ACTIONS(5668),
    [anon_sym_not_eq] = ACTIONS(5668),
    [anon_sym_DASH_DASH] = ACTIONS(5668),
    [anon_sym_PLUS_PLUS] = ACTIONS(5668),
    [anon_sym_DOT] = ACTIONS(5670),
    [anon_sym_DOT_STAR] = ACTIONS(5668),
    [anon_sym_DASH_GT] = ACTIONS(5668),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5668),
    [anon_sym_decltype] = ACTIONS(5668),
    [anon_sym_final] = ACTIONS(5668),
    [anon_sym_override] = ACTIONS(5668),
    [anon_sym_GT2] = ACTIONS(5668),
    [anon_sym_requires] = ACTIONS(5668),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5668),
  },
  [2435] = {
    [sym_template_argument_list] = STATE(2502),
    [sym_identifier] = ACTIONS(4009),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4002),
    [anon_sym_COMMA] = ACTIONS(4002),
    [anon_sym_RPAREN] = ACTIONS(4002),
    [aux_sym_preproc_if_token2] = ACTIONS(4002),
    [aux_sym_preproc_else_token1] = ACTIONS(4002),
    [aux_sym_preproc_elif_token1] = ACTIONS(4009),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4002),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4002),
    [anon_sym_LPAREN2] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4009),
    [anon_sym_PLUS] = ACTIONS(4009),
    [anon_sym_STAR] = ACTIONS(4009),
    [anon_sym_SLASH] = ACTIONS(4009),
    [anon_sym_PERCENT] = ACTIONS(4009),
    [anon_sym_PIPE_PIPE] = ACTIONS(4002),
    [anon_sym_AMP_AMP] = ACTIONS(4002),
    [anon_sym_PIPE] = ACTIONS(4009),
    [anon_sym_CARET] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4009),
    [anon_sym_EQ_EQ] = ACTIONS(4002),
    [anon_sym_BANG_EQ] = ACTIONS(4002),
    [anon_sym_GT] = ACTIONS(4009),
    [anon_sym_GT_EQ] = ACTIONS(4002),
    [anon_sym_LT_EQ] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(5333),
    [anon_sym_LT_LT] = ACTIONS(4009),
    [anon_sym_GT_GT] = ACTIONS(4009),
    [anon_sym_SEMI] = ACTIONS(4002),
    [anon_sym___attribute__] = ACTIONS(4009),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_RBRACE] = ACTIONS(4002),
    [anon_sym_LBRACK] = ACTIONS(4002),
    [anon_sym_RBRACK] = ACTIONS(4002),
    [anon_sym_EQ] = ACTIONS(4009),
    [anon_sym_COLON] = ACTIONS(4009),
    [anon_sym_QMARK] = ACTIONS(4002),
    [anon_sym_STAR_EQ] = ACTIONS(4002),
    [anon_sym_SLASH_EQ] = ACTIONS(4002),
    [anon_sym_PERCENT_EQ] = ACTIONS(4002),
    [anon_sym_PLUS_EQ] = ACTIONS(4002),
    [anon_sym_DASH_EQ] = ACTIONS(4002),
    [anon_sym_LT_LT_EQ] = ACTIONS(4002),
    [anon_sym_GT_GT_EQ] = ACTIONS(4002),
    [anon_sym_AMP_EQ] = ACTIONS(4002),
    [anon_sym_CARET_EQ] = ACTIONS(4002),
    [anon_sym_PIPE_EQ] = ACTIONS(4002),
    [anon_sym_and_eq] = ACTIONS(4009),
    [anon_sym_or_eq] = ACTIONS(4009),
    [anon_sym_xor_eq] = ACTIONS(4009),
    [anon_sym_LT_EQ_GT] = ACTIONS(4002),
    [anon_sym_or] = ACTIONS(4009),
    [anon_sym_and] = ACTIONS(4009),
    [anon_sym_bitor] = ACTIONS(4009),
    [anon_sym_xor] = ACTIONS(4009),
    [anon_sym_bitand] = ACTIONS(4009),
    [anon_sym_not_eq] = ACTIONS(4009),
    [anon_sym_DASH_DASH] = ACTIONS(4002),
    [anon_sym_PLUS_PLUS] = ACTIONS(4002),
    [anon_sym_DOT] = ACTIONS(4009),
    [anon_sym_DOT_STAR] = ACTIONS(4002),
    [anon_sym_DASH_GT] = ACTIONS(4002),
    [sym_comment] = ACTIONS(3),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4002),
  },
  [2436] = {
    [sym_attribute_specifier] = STATE(2615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5686),
    [anon_sym_COMMA] = ACTIONS(5686),
    [anon_sym_LPAREN2] = ACTIONS(5686),
    [anon_sym_DASH] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5688),
    [anon_sym_STAR] = ACTIONS(5686),
    [anon_sym_SLASH] = ACTIONS(5688),
    [anon_sym_PERCENT] = ACTIONS(5686),
    [anon_sym_PIPE_PIPE] = ACTIONS(5686),
    [anon_sym_AMP_AMP] = ACTIONS(5686),
    [anon_sym_PIPE] = ACTIONS(5688),
    [anon_sym_CARET] = ACTIONS(5686),
    [anon_sym_AMP] = ACTIONS(5688),
    [anon_sym_EQ_EQ] = ACTIONS(5686),
    [anon_sym_BANG_EQ] = ACTIONS(5686),
    [anon_sym_GT] = ACTIONS(5688),
    [anon_sym_GT_EQ] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_LT] = ACTIONS(5688),
    [anon_sym_LT_LT] = ACTIONS(5688),
    [anon_sym_GT_GT] = ACTIONS(5688),
    [anon_sym___extension__] = ACTIONS(5686),
    [anon_sym___global__] = ACTIONS(5686),
    [anon_sym___attribute__] = ACTIONS(5652),
    [anon_sym_LBRACE] = ACTIONS(5686),
    [anon_sym_LBRACK] = ACTIONS(5686),
    [anon_sym_const] = ACTIONS(5688),
    [anon_sym_constexpr] = ACTIONS(5686),
    [anon_sym_volatile] = ACTIONS(5686),
    [anon_sym_restrict] = ACTIONS(5686),
    [anon_sym___restrict__] = ACTIONS(5686),
    [anon_sym__Atomic] = ACTIONS(5686),
    [anon_sym__Noreturn] = ACTIONS(5686),
    [anon_sym_noreturn] = ACTIONS(5686),
    [anon_sym_mutable] = ACTIONS(5686),
    [anon_sym_constinit] = ACTIONS(5686),
    [anon_sym_consteval] = ACTIONS(5686),
    [anon_sym___shared__] = ACTIONS(5686),
    [anon_sym___local__] = ACTIONS(5686),
    [anon_sym___constant__] = ACTIONS(5686),
    [anon_sym___managed__] = ACTIONS(5686),
    [anon_sym___grid_constant__] = ACTIONS(5686),
    [anon_sym_alignas] = ACTIONS(5686),
    [anon_sym__Alignas] = ACTIONS(5686),
    [anon_sym_QMARK] = ACTIONS(5686),
    [anon_sym_LT_EQ_GT] = ACTIONS(5686),
    [anon_sym_or] = ACTIONS(5686),
    [anon_sym_and] = ACTIONS(5686),
    [anon_sym_bitor] = ACTIONS(5686),
    [anon_sym_xor] = ACTIONS(5686),
    [anon_sym_bitand] = ACTIONS(5686),
    [anon_sym_not_eq] = ACTIONS(5686),
    [anon_sym_DASH_DASH] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5686),
    [anon_sym_DOT] = ACTIONS(5688),
    [anon_sym_DOT_STAR] = ACTIONS(5686),
    [anon_sym_DASH_GT] = ACTIONS(5686),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5686),
    [anon_sym_decltype] = ACTIONS(5686),
    [anon_sym_final] = ACTIONS(5686),
    [anon_sym_override] = ACTIONS(5686),
    [anon_sym_GT2] = ACTIONS(5686),
    [anon_sym_requires] = ACTIONS(5686),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5686),
  },
  [2437] = {
    [sym_identifier] = ACTIONS(5386),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5388),
    [anon_sym_COMMA] = ACTIONS(5388),
    [anon_sym_RPAREN] = ACTIONS(5388),
    [aux_sym_preproc_if_token2] = ACTIONS(5388),
    [aux_sym_preproc_else_token1] = ACTIONS(5388),
    [aux_sym_preproc_elif_token1] = ACTIONS(5386),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5388),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5388),
    [anon_sym_LPAREN2] = ACTIONS(5388),
    [anon_sym_DASH] = ACTIONS(5386),
    [anon_sym_PLUS] = ACTIONS(5386),
    [anon_sym_STAR] = ACTIONS(5386),
    [anon_sym_SLASH] = ACTIONS(5386),
    [anon_sym_PERCENT] = ACTIONS(5386),
    [anon_sym_PIPE_PIPE] = ACTIONS(5388),
    [anon_sym_AMP_AMP] = ACTIONS(5388),
    [anon_sym_PIPE] = ACTIONS(5386),
    [anon_sym_CARET] = ACTIONS(5386),
    [anon_sym_AMP] = ACTIONS(5386),
    [anon_sym_EQ_EQ] = ACTIONS(5388),
    [anon_sym_BANG_EQ] = ACTIONS(5388),
    [anon_sym_GT] = ACTIONS(5386),
    [anon_sym_GT_EQ] = ACTIONS(5388),
    [anon_sym_LT_EQ] = ACTIONS(5386),
    [anon_sym_LT] = ACTIONS(5386),
    [anon_sym_LT_LT] = ACTIONS(5386),
    [anon_sym_GT_GT] = ACTIONS(5386),
    [anon_sym_SEMI] = ACTIONS(5388),
    [anon_sym___attribute__] = ACTIONS(5386),
    [anon_sym_LBRACE] = ACTIONS(5388),
    [anon_sym_RBRACE] = ACTIONS(5388),
    [anon_sym_LBRACK] = ACTIONS(5388),
    [anon_sym_RBRACK] = ACTIONS(5388),
    [anon_sym_EQ] = ACTIONS(5386),
    [anon_sym_COLON] = ACTIONS(5388),
    [anon_sym_QMARK] = ACTIONS(5388),
    [anon_sym_STAR_EQ] = ACTIONS(5388),
    [anon_sym_SLASH_EQ] = ACTIONS(5388),
    [anon_sym_PERCENT_EQ] = ACTIONS(5388),
    [anon_sym_PLUS_EQ] = ACTIONS(5388),
    [anon_sym_DASH_EQ] = ACTIONS(5388),
    [anon_sym_LT_LT_EQ] = ACTIONS(5388),
    [anon_sym_GT_GT_EQ] = ACTIONS(5388),
    [anon_sym_AMP_EQ] = ACTIONS(5388),
    [anon_sym_CARET_EQ] = ACTIONS(5388),
    [anon_sym_PIPE_EQ] = ACTIONS(5388),
    [anon_sym_and_eq] = ACTIONS(5386),
    [anon_sym_or_eq] = ACTIONS(5386),
    [anon_sym_xor_eq] = ACTIONS(5386),
    [anon_sym_LT_EQ_GT] = ACTIONS(5388),
    [anon_sym_or] = ACTIONS(5386),
    [anon_sym_and] = ACTIONS(5386),
    [anon_sym_bitor] = ACTIONS(5386),
    [anon_sym_xor] = ACTIONS(5386),
    [anon_sym_bitand] = ACTIONS(5386),
    [anon_sym_not_eq] = ACTIONS(5386),
    [anon_sym_DASH_DASH] = ACTIONS(5388),
    [anon_sym_PLUS_PLUS] = ACTIONS(5388),
    [anon_sym_DOT] = ACTIONS(5386),
    [anon_sym_DOT_STAR] = ACTIONS(5388),
    [anon_sym_DASH_GT] = ACTIONS(5388),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5386),
    [anon_sym_decltype] = ACTIONS(5386),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5388),
  },
  [2438] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2378),
    [sym_identifier] = ACTIONS(5434),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5432),
    [anon_sym_COMMA] = ACTIONS(5432),
    [aux_sym_preproc_if_token2] = ACTIONS(5432),
    [aux_sym_preproc_else_token1] = ACTIONS(5432),
    [aux_sym_preproc_elif_token1] = ACTIONS(5434),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5432),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5432),
    [anon_sym_LPAREN2] = ACTIONS(5432),
    [anon_sym_DASH] = ACTIONS(5434),
    [anon_sym_PLUS] = ACTIONS(5434),
    [anon_sym_STAR] = ACTIONS(5434),
    [anon_sym_SLASH] = ACTIONS(5434),
    [anon_sym_PERCENT] = ACTIONS(5434),
    [anon_sym_PIPE_PIPE] = ACTIONS(5432),
    [anon_sym_AMP_AMP] = ACTIONS(5432),
    [anon_sym_PIPE] = ACTIONS(5434),
    [anon_sym_CARET] = ACTIONS(5434),
    [anon_sym_AMP] = ACTIONS(5434),
    [anon_sym_EQ_EQ] = ACTIONS(5432),
    [anon_sym_BANG_EQ] = ACTIONS(5432),
    [anon_sym_GT] = ACTIONS(5434),
    [anon_sym_GT_EQ] = ACTIONS(5432),
    [anon_sym_LT_EQ] = ACTIONS(5434),
    [anon_sym_LT] = ACTIONS(5434),
    [anon_sym_LT_LT] = ACTIONS(5434),
    [anon_sym_GT_GT] = ACTIONS(5434),
    [anon_sym___attribute__] = ACTIONS(5434),
    [anon_sym_LBRACE] = ACTIONS(5432),
    [anon_sym_signed] = ACTIONS(6018),
    [anon_sym_unsigned] = ACTIONS(6018),
    [anon_sym_long] = ACTIONS(6018),
    [anon_sym_short] = ACTIONS(6018),
    [anon_sym_LBRACK] = ACTIONS(5432),
    [anon_sym_EQ] = ACTIONS(5434),
    [anon_sym_QMARK] = ACTIONS(5432),
    [anon_sym_STAR_EQ] = ACTIONS(5432),
    [anon_sym_SLASH_EQ] = ACTIONS(5432),
    [anon_sym_PERCENT_EQ] = ACTIONS(5432),
    [anon_sym_PLUS_EQ] = ACTIONS(5432),
    [anon_sym_DASH_EQ] = ACTIONS(5432),
    [anon_sym_LT_LT_EQ] = ACTIONS(5432),
    [anon_sym_GT_GT_EQ] = ACTIONS(5432),
    [anon_sym_AMP_EQ] = ACTIONS(5432),
    [anon_sym_CARET_EQ] = ACTIONS(5432),
    [anon_sym_PIPE_EQ] = ACTIONS(5432),
    [anon_sym_and_eq] = ACTIONS(5434),
    [anon_sym_or_eq] = ACTIONS(5434),
    [anon_sym_xor_eq] = ACTIONS(5434),
    [anon_sym_LT_EQ_GT] = ACTIONS(5432),
    [anon_sym_or] = ACTIONS(5434),
    [anon_sym_and] = ACTIONS(5434),
    [anon_sym_bitor] = ACTIONS(5434),
    [anon_sym_xor] = ACTIONS(5434),
    [anon_sym_bitand] = ACTIONS(5434),
    [anon_sym_not_eq] = ACTIONS(5434),
    [anon_sym_DASH_DASH] = ACTIONS(5432),
    [anon_sym_PLUS_PLUS] = ACTIONS(5432),
    [anon_sym_DOT] = ACTIONS(5434),
    [anon_sym_DOT_STAR] = ACTIONS(5432),
    [anon_sym_DASH_GT] = ACTIONS(5432),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5434),
    [anon_sym_decltype] = ACTIONS(5434),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5432),
  },
  [2439] = {
    [sym_identifier] = ACTIONS(5382),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5384),
    [anon_sym_COMMA] = ACTIONS(5384),
    [anon_sym_RPAREN] = ACTIONS(5384),
    [aux_sym_preproc_if_token2] = ACTIONS(5384),
    [aux_sym_preproc_else_token1] = ACTIONS(5384),
    [aux_sym_preproc_elif_token1] = ACTIONS(5382),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5384),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5384),
    [anon_sym_LPAREN2] = ACTIONS(5384),
    [anon_sym_DASH] = ACTIONS(5382),
    [anon_sym_PLUS] = ACTIONS(5382),
    [anon_sym_STAR] = ACTIONS(5382),
    [anon_sym_SLASH] = ACTIONS(5382),
    [anon_sym_PERCENT] = ACTIONS(5382),
    [anon_sym_PIPE_PIPE] = ACTIONS(5384),
    [anon_sym_AMP_AMP] = ACTIONS(5384),
    [anon_sym_PIPE] = ACTIONS(5382),
    [anon_sym_CARET] = ACTIONS(5382),
    [anon_sym_AMP] = ACTIONS(5382),
    [anon_sym_EQ_EQ] = ACTIONS(5384),
    [anon_sym_BANG_EQ] = ACTIONS(5384),
    [anon_sym_GT] = ACTIONS(5382),
    [anon_sym_GT_EQ] = ACTIONS(5384),
    [anon_sym_LT_EQ] = ACTIONS(5382),
    [anon_sym_LT] = ACTIONS(5382),
    [anon_sym_LT_LT] = ACTIONS(5382),
    [anon_sym_GT_GT] = ACTIONS(5382),
    [anon_sym_SEMI] = ACTIONS(5384),
    [anon_sym___attribute__] = ACTIONS(5382),
    [anon_sym_LBRACE] = ACTIONS(5384),
    [anon_sym_RBRACE] = ACTIONS(5384),
    [anon_sym_LBRACK] = ACTIONS(5384),
    [anon_sym_RBRACK] = ACTIONS(5384),
    [anon_sym_EQ] = ACTIONS(5382),
    [anon_sym_COLON] = ACTIONS(5384),
    [anon_sym_QMARK] = ACTIONS(5384),
    [anon_sym_STAR_EQ] = ACTIONS(5384),
    [anon_sym_SLASH_EQ] = ACTIONS(5384),
    [anon_sym_PERCENT_EQ] = ACTIONS(5384),
    [anon_sym_PLUS_EQ] = ACTIONS(5384),
    [anon_sym_DASH_EQ] = ACTIONS(5384),
    [anon_sym_LT_LT_EQ] = ACTIONS(5384),
    [anon_sym_GT_GT_EQ] = ACTIONS(5384),
    [anon_sym_AMP_EQ] = ACTIONS(5384),
    [anon_sym_CARET_EQ] = ACTIONS(5384),
    [anon_sym_PIPE_EQ] = ACTIONS(5384),
    [anon_sym_and_eq] = ACTIONS(5382),
    [anon_sym_or_eq] = ACTIONS(5382),
    [anon_sym_xor_eq] = ACTIONS(5382),
    [anon_sym_LT_EQ_GT] = ACTIONS(5384),
    [anon_sym_or] = ACTIONS(5382),
    [anon_sym_and] = ACTIONS(5382),
    [anon_sym_bitor] = ACTIONS(5382),
    [anon_sym_xor] = ACTIONS(5382),
    [anon_sym_bitand] = ACTIONS(5382),
    [anon_sym_not_eq] = ACTIONS(5382),
    [anon_sym_DASH_DASH] = ACTIONS(5384),
    [anon_sym_PLUS_PLUS] = ACTIONS(5384),
    [anon_sym_DOT] = ACTIONS(5382),
    [anon_sym_DOT_STAR] = ACTIONS(5384),
    [anon_sym_DASH_GT] = ACTIONS(5384),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5382),
    [anon_sym_decltype] = ACTIONS(5382),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5384),
  },
  [2440] = {
    [sym_identifier] = ACTIONS(5336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5338),
    [anon_sym_COMMA] = ACTIONS(5338),
    [anon_sym_RPAREN] = ACTIONS(5338),
    [aux_sym_preproc_if_token2] = ACTIONS(5338),
    [aux_sym_preproc_else_token1] = ACTIONS(5338),
    [aux_sym_preproc_elif_token1] = ACTIONS(5336),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5338),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5338),
    [anon_sym_LPAREN2] = ACTIONS(5338),
    [anon_sym_DASH] = ACTIONS(5336),
    [anon_sym_PLUS] = ACTIONS(5336),
    [anon_sym_STAR] = ACTIONS(5336),
    [anon_sym_SLASH] = ACTIONS(5336),
    [anon_sym_PERCENT] = ACTIONS(5336),
    [anon_sym_PIPE_PIPE] = ACTIONS(5338),
    [anon_sym_AMP_AMP] = ACTIONS(5338),
    [anon_sym_PIPE] = ACTIONS(5336),
    [anon_sym_CARET] = ACTIONS(5336),
    [anon_sym_AMP] = ACTIONS(5336),
    [anon_sym_EQ_EQ] = ACTIONS(5338),
    [anon_sym_BANG_EQ] = ACTIONS(5338),
    [anon_sym_GT] = ACTIONS(5336),
    [anon_sym_GT_EQ] = ACTIONS(5338),
    [anon_sym_LT_EQ] = ACTIONS(5336),
    [anon_sym_LT] = ACTIONS(5336),
    [anon_sym_LT_LT] = ACTIONS(5336),
    [anon_sym_GT_GT] = ACTIONS(5336),
    [anon_sym_SEMI] = ACTIONS(5338),
    [anon_sym___attribute__] = ACTIONS(5336),
    [anon_sym_LBRACE] = ACTIONS(5338),
    [anon_sym_RBRACE] = ACTIONS(5338),
    [anon_sym_LBRACK] = ACTIONS(5338),
    [anon_sym_RBRACK] = ACTIONS(5338),
    [anon_sym_EQ] = ACTIONS(5336),
    [anon_sym_COLON] = ACTIONS(5338),
    [anon_sym_QMARK] = ACTIONS(5338),
    [anon_sym_STAR_EQ] = ACTIONS(5338),
    [anon_sym_SLASH_EQ] = ACTIONS(5338),
    [anon_sym_PERCENT_EQ] = ACTIONS(5338),
    [anon_sym_PLUS_EQ] = ACTIONS(5338),
    [anon_sym_DASH_EQ] = ACTIONS(5338),
    [anon_sym_LT_LT_EQ] = ACTIONS(5338),
    [anon_sym_GT_GT_EQ] = ACTIONS(5338),
    [anon_sym_AMP_EQ] = ACTIONS(5338),
    [anon_sym_CARET_EQ] = ACTIONS(5338),
    [anon_sym_PIPE_EQ] = ACTIONS(5338),
    [anon_sym_and_eq] = ACTIONS(5336),
    [anon_sym_or_eq] = ACTIONS(5336),
    [anon_sym_xor_eq] = ACTIONS(5336),
    [anon_sym_LT_EQ_GT] = ACTIONS(5338),
    [anon_sym_or] = ACTIONS(5336),
    [anon_sym_and] = ACTIONS(5336),
    [anon_sym_bitor] = ACTIONS(5336),
    [anon_sym_xor] = ACTIONS(5336),
    [anon_sym_bitand] = ACTIONS(5336),
    [anon_sym_not_eq] = ACTIONS(5336),
    [anon_sym_DASH_DASH] = ACTIONS(5338),
    [anon_sym_PLUS_PLUS] = ACTIONS(5338),
    [anon_sym_DOT] = ACTIONS(5336),
    [anon_sym_DOT_STAR] = ACTIONS(5338),
    [anon_sym_DASH_GT] = ACTIONS(5338),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5336),
    [anon_sym_decltype] = ACTIONS(5336),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5338),
  },
  [2441] = {
    [sym_identifier] = ACTIONS(5192),
    [anon_sym_COMMA] = ACTIONS(5194),
    [anon_sym_RPAREN] = ACTIONS(5194),
    [anon_sym_LPAREN2] = ACTIONS(5194),
    [anon_sym_STAR] = ACTIONS(5194),
    [anon_sym_AMP_AMP] = ACTIONS(5194),
    [anon_sym_AMP] = ACTIONS(5192),
    [anon_sym_SEMI] = ACTIONS(5194),
    [anon_sym___extension__] = ACTIONS(5192),
    [anon_sym___device__] = ACTIONS(5192),
    [anon_sym___host__] = ACTIONS(5192),
    [anon_sym___global__] = ACTIONS(5192),
    [anon_sym___forceinline__] = ACTIONS(5192),
    [anon_sym___noinline__] = ACTIONS(5192),
    [anon_sym_extern] = ACTIONS(5192),
    [anon_sym___attribute__] = ACTIONS(5192),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5194),
    [anon_sym___declspec] = ACTIONS(5192),
    [anon_sym___based] = ACTIONS(5192),
    [anon_sym_LBRACE] = ACTIONS(5194),
    [anon_sym_signed] = ACTIONS(5192),
    [anon_sym_unsigned] = ACTIONS(5192),
    [anon_sym_long] = ACTIONS(5192),
    [anon_sym_short] = ACTIONS(5192),
    [anon_sym_LBRACK] = ACTIONS(5192),
    [anon_sym_static] = ACTIONS(5192),
    [anon_sym_EQ] = ACTIONS(5194),
    [anon_sym_register] = ACTIONS(5192),
    [anon_sym_inline] = ACTIONS(5192),
    [anon_sym___inline] = ACTIONS(5192),
    [anon_sym___inline__] = ACTIONS(5192),
    [anon_sym___forceinline] = ACTIONS(5192),
    [anon_sym_thread_local] = ACTIONS(5192),
    [anon_sym___thread] = ACTIONS(5192),
    [anon_sym_const] = ACTIONS(5192),
    [anon_sym_constexpr] = ACTIONS(5192),
    [anon_sym_volatile] = ACTIONS(5192),
    [anon_sym_restrict] = ACTIONS(5192),
    [anon_sym___restrict__] = ACTIONS(5192),
    [anon_sym__Atomic] = ACTIONS(5192),
    [anon_sym__Noreturn] = ACTIONS(5192),
    [anon_sym_noreturn] = ACTIONS(5192),
    [anon_sym_mutable] = ACTIONS(5192),
    [anon_sym_constinit] = ACTIONS(5192),
    [anon_sym_consteval] = ACTIONS(5192),
    [anon_sym___shared__] = ACTIONS(5192),
    [anon_sym___local__] = ACTIONS(5192),
    [anon_sym___constant__] = ACTIONS(5192),
    [anon_sym___managed__] = ACTIONS(5192),
    [anon_sym___grid_constant__] = ACTIONS(5192),
    [anon_sym_alignas] = ACTIONS(5192),
    [anon_sym__Alignas] = ACTIONS(5192),
    [sym_primitive_type] = ACTIONS(5192),
    [anon_sym_COLON] = ACTIONS(5194),
    [anon_sym_asm] = ACTIONS(5192),
    [anon_sym___asm__] = ACTIONS(5192),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5192),
    [anon_sym_decltype] = ACTIONS(5192),
    [anon_sym_final] = ACTIONS(5192),
    [anon_sym_override] = ACTIONS(5192),
    [sym_virtual] = ACTIONS(5192),
    [anon_sym_GT2] = ACTIONS(5194),
    [anon_sym_try] = ACTIONS(5192),
    [anon_sym_requires] = ACTIONS(5192),
    [anon_sym___launch_bounds__] = ACTIONS(5192),
  },
  [2442] = {
    [sym_template_argument_list] = STATE(2297),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2245),
    [sym_identifier] = ACTIONS(3756),
    [anon_sym_LPAREN2] = ACTIONS(3764),
    [anon_sym_TILDE] = ACTIONS(3764),
    [anon_sym_STAR] = ACTIONS(3764),
    [anon_sym_AMP_AMP] = ACTIONS(3764),
    [anon_sym_AMP] = ACTIONS(3756),
    [anon_sym_LT] = ACTIONS(5534),
    [anon_sym_SEMI] = ACTIONS(3764),
    [anon_sym___extension__] = ACTIONS(3756),
    [anon_sym___device__] = ACTIONS(3756),
    [anon_sym___host__] = ACTIONS(3756),
    [anon_sym___global__] = ACTIONS(3756),
    [anon_sym___forceinline__] = ACTIONS(3756),
    [anon_sym___noinline__] = ACTIONS(3756),
    [anon_sym_extern] = ACTIONS(3756),
    [anon_sym___attribute__] = ACTIONS(3756),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3764),
    [anon_sym___declspec] = ACTIONS(3756),
    [anon_sym___based] = ACTIONS(3756),
    [anon_sym___cdecl] = ACTIONS(3756),
    [anon_sym___clrcall] = ACTIONS(3756),
    [anon_sym___stdcall] = ACTIONS(3756),
    [anon_sym___fastcall] = ACTIONS(3756),
    [anon_sym___thiscall] = ACTIONS(3756),
    [anon_sym___vectorcall] = ACTIONS(3756),
    [anon_sym_signed] = ACTIONS(3784),
    [anon_sym_unsigned] = ACTIONS(3784),
    [anon_sym_long] = ACTIONS(3784),
    [anon_sym_short] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3756),
    [anon_sym_static] = ACTIONS(3756),
    [anon_sym_register] = ACTIONS(3756),
    [anon_sym_inline] = ACTIONS(3756),
    [anon_sym___inline] = ACTIONS(3756),
    [anon_sym___inline__] = ACTIONS(3756),
    [anon_sym___forceinline] = ACTIONS(3756),
    [anon_sym_thread_local] = ACTIONS(3756),
    [anon_sym___thread] = ACTIONS(3756),
    [anon_sym_const] = ACTIONS(3756),
    [anon_sym_constexpr] = ACTIONS(3756),
    [anon_sym_volatile] = ACTIONS(3756),
    [anon_sym_restrict] = ACTIONS(3756),
    [anon_sym___restrict__] = ACTIONS(3756),
    [anon_sym__Atomic] = ACTIONS(3756),
    [anon_sym__Noreturn] = ACTIONS(3756),
    [anon_sym_noreturn] = ACTIONS(3756),
    [anon_sym_mutable] = ACTIONS(3756),
    [anon_sym_constinit] = ACTIONS(3756),
    [anon_sym_consteval] = ACTIONS(3756),
    [anon_sym___shared__] = ACTIONS(3756),
    [anon_sym___local__] = ACTIONS(3756),
    [anon_sym___constant__] = ACTIONS(3756),
    [anon_sym___managed__] = ACTIONS(3756),
    [anon_sym___grid_constant__] = ACTIONS(3756),
    [anon_sym_alignas] = ACTIONS(3756),
    [anon_sym__Alignas] = ACTIONS(3756),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3756),
    [anon_sym_decltype] = ACTIONS(3756),
    [sym_virtual] = ACTIONS(3756),
    [anon_sym_template] = ACTIONS(3756),
    [anon_sym_operator] = ACTIONS(3756),
    [anon_sym___launch_bounds__] = ACTIONS(3756),
  },
  [2443] = {
    [sym_identifier] = ACTIONS(5281),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5283),
    [anon_sym_COMMA] = ACTIONS(5283),
    [anon_sym_RPAREN] = ACTIONS(5283),
    [aux_sym_preproc_if_token2] = ACTIONS(5283),
    [aux_sym_preproc_else_token1] = ACTIONS(5283),
    [aux_sym_preproc_elif_token1] = ACTIONS(5281),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5283),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5283),
    [anon_sym_LPAREN2] = ACTIONS(5283),
    [anon_sym_DASH] = ACTIONS(5281),
    [anon_sym_PLUS] = ACTIONS(5281),
    [anon_sym_STAR] = ACTIONS(5281),
    [anon_sym_SLASH] = ACTIONS(5281),
    [anon_sym_PERCENT] = ACTIONS(5281),
    [anon_sym_PIPE_PIPE] = ACTIONS(5283),
    [anon_sym_AMP_AMP] = ACTIONS(5283),
    [anon_sym_PIPE] = ACTIONS(5281),
    [anon_sym_CARET] = ACTIONS(5281),
    [anon_sym_AMP] = ACTIONS(5281),
    [anon_sym_EQ_EQ] = ACTIONS(5283),
    [anon_sym_BANG_EQ] = ACTIONS(5283),
    [anon_sym_GT] = ACTIONS(5281),
    [anon_sym_GT_EQ] = ACTIONS(5283),
    [anon_sym_LT_EQ] = ACTIONS(5281),
    [anon_sym_LT] = ACTIONS(5281),
    [anon_sym_LT_LT] = ACTIONS(5281),
    [anon_sym_GT_GT] = ACTIONS(5281),
    [anon_sym_SEMI] = ACTIONS(5283),
    [anon_sym___attribute__] = ACTIONS(5281),
    [anon_sym_LBRACE] = ACTIONS(5283),
    [anon_sym_RBRACE] = ACTIONS(5283),
    [anon_sym_LBRACK] = ACTIONS(5283),
    [anon_sym_RBRACK] = ACTIONS(5283),
    [anon_sym_EQ] = ACTIONS(5281),
    [anon_sym_COLON] = ACTIONS(5283),
    [anon_sym_QMARK] = ACTIONS(5283),
    [anon_sym_STAR_EQ] = ACTIONS(5283),
    [anon_sym_SLASH_EQ] = ACTIONS(5283),
    [anon_sym_PERCENT_EQ] = ACTIONS(5283),
    [anon_sym_PLUS_EQ] = ACTIONS(5283),
    [anon_sym_DASH_EQ] = ACTIONS(5283),
    [anon_sym_LT_LT_EQ] = ACTIONS(5283),
    [anon_sym_GT_GT_EQ] = ACTIONS(5283),
    [anon_sym_AMP_EQ] = ACTIONS(5283),
    [anon_sym_CARET_EQ] = ACTIONS(5283),
    [anon_sym_PIPE_EQ] = ACTIONS(5283),
    [anon_sym_and_eq] = ACTIONS(5281),
    [anon_sym_or_eq] = ACTIONS(5281),
    [anon_sym_xor_eq] = ACTIONS(5281),
    [anon_sym_LT_EQ_GT] = ACTIONS(5283),
    [anon_sym_or] = ACTIONS(5281),
    [anon_sym_and] = ACTIONS(5281),
    [anon_sym_bitor] = ACTIONS(5281),
    [anon_sym_xor] = ACTIONS(5281),
    [anon_sym_bitand] = ACTIONS(5281),
    [anon_sym_not_eq] = ACTIONS(5281),
    [anon_sym_DASH_DASH] = ACTIONS(5283),
    [anon_sym_PLUS_PLUS] = ACTIONS(5283),
    [anon_sym_DOT] = ACTIONS(5281),
    [anon_sym_DOT_STAR] = ACTIONS(5283),
    [anon_sym_DASH_GT] = ACTIONS(5283),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5281),
    [anon_sym_decltype] = ACTIONS(5281),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5283),
  },
  [2444] = {
    [sym_attribute_specifier] = STATE(2562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5627),
    [anon_sym_COMMA] = ACTIONS(5627),
    [anon_sym_LPAREN2] = ACTIONS(5627),
    [anon_sym_DASH] = ACTIONS(5629),
    [anon_sym_PLUS] = ACTIONS(5629),
    [anon_sym_STAR] = ACTIONS(5627),
    [anon_sym_SLASH] = ACTIONS(5629),
    [anon_sym_PERCENT] = ACTIONS(5627),
    [anon_sym_PIPE_PIPE] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5627),
    [anon_sym_PIPE] = ACTIONS(5629),
    [anon_sym_CARET] = ACTIONS(5627),
    [anon_sym_AMP] = ACTIONS(5629),
    [anon_sym_EQ_EQ] = ACTIONS(5627),
    [anon_sym_BANG_EQ] = ACTIONS(5627),
    [anon_sym_GT] = ACTIONS(5629),
    [anon_sym_GT_EQ] = ACTIONS(5629),
    [anon_sym_LT_EQ] = ACTIONS(5629),
    [anon_sym_LT] = ACTIONS(5629),
    [anon_sym_LT_LT] = ACTIONS(5629),
    [anon_sym_GT_GT] = ACTIONS(5629),
    [anon_sym___extension__] = ACTIONS(5627),
    [anon_sym___global__] = ACTIONS(5627),
    [anon_sym___attribute__] = ACTIONS(5652),
    [anon_sym_LBRACE] = ACTIONS(5627),
    [anon_sym_LBRACK] = ACTIONS(5627),
    [anon_sym_const] = ACTIONS(5629),
    [anon_sym_constexpr] = ACTIONS(5627),
    [anon_sym_volatile] = ACTIONS(5627),
    [anon_sym_restrict] = ACTIONS(5627),
    [anon_sym___restrict__] = ACTIONS(5627),
    [anon_sym__Atomic] = ACTIONS(5627),
    [anon_sym__Noreturn] = ACTIONS(5627),
    [anon_sym_noreturn] = ACTIONS(5627),
    [anon_sym_mutable] = ACTIONS(5627),
    [anon_sym_constinit] = ACTIONS(5627),
    [anon_sym_consteval] = ACTIONS(5627),
    [anon_sym___shared__] = ACTIONS(5627),
    [anon_sym___local__] = ACTIONS(5627),
    [anon_sym___constant__] = ACTIONS(5627),
    [anon_sym___managed__] = ACTIONS(5627),
    [anon_sym___grid_constant__] = ACTIONS(5627),
    [anon_sym_alignas] = ACTIONS(5627),
    [anon_sym__Alignas] = ACTIONS(5627),
    [anon_sym_QMARK] = ACTIONS(5627),
    [anon_sym_LT_EQ_GT] = ACTIONS(5627),
    [anon_sym_or] = ACTIONS(5627),
    [anon_sym_and] = ACTIONS(5627),
    [anon_sym_bitor] = ACTIONS(5627),
    [anon_sym_xor] = ACTIONS(5627),
    [anon_sym_bitand] = ACTIONS(5627),
    [anon_sym_not_eq] = ACTIONS(5627),
    [anon_sym_DASH_DASH] = ACTIONS(5627),
    [anon_sym_PLUS_PLUS] = ACTIONS(5627),
    [anon_sym_DOT] = ACTIONS(5629),
    [anon_sym_DOT_STAR] = ACTIONS(5627),
    [anon_sym_DASH_GT] = ACTIONS(5627),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5627),
    [anon_sym_decltype] = ACTIONS(5627),
    [anon_sym_final] = ACTIONS(5627),
    [anon_sym_override] = ACTIONS(5627),
    [anon_sym_GT2] = ACTIONS(5627),
    [anon_sym_requires] = ACTIONS(5627),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5627),
  },
  [2445] = {
    [sym_identifier] = ACTIONS(5230),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5232),
    [anon_sym_COMMA] = ACTIONS(5232),
    [anon_sym_RPAREN] = ACTIONS(5232),
    [aux_sym_preproc_if_token2] = ACTIONS(5232),
    [aux_sym_preproc_else_token1] = ACTIONS(5232),
    [aux_sym_preproc_elif_token1] = ACTIONS(5230),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5232),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5232),
    [anon_sym_LPAREN2] = ACTIONS(5232),
    [anon_sym_DASH] = ACTIONS(5230),
    [anon_sym_PLUS] = ACTIONS(5230),
    [anon_sym_STAR] = ACTIONS(5230),
    [anon_sym_SLASH] = ACTIONS(5230),
    [anon_sym_PERCENT] = ACTIONS(5230),
    [anon_sym_PIPE_PIPE] = ACTIONS(5232),
    [anon_sym_AMP_AMP] = ACTIONS(5232),
    [anon_sym_PIPE] = ACTIONS(5230),
    [anon_sym_CARET] = ACTIONS(5230),
    [anon_sym_AMP] = ACTIONS(5230),
    [anon_sym_EQ_EQ] = ACTIONS(5232),
    [anon_sym_BANG_EQ] = ACTIONS(5232),
    [anon_sym_GT] = ACTIONS(5230),
    [anon_sym_GT_EQ] = ACTIONS(5232),
    [anon_sym_LT_EQ] = ACTIONS(5230),
    [anon_sym_LT] = ACTIONS(5230),
    [anon_sym_LT_LT] = ACTIONS(5230),
    [anon_sym_GT_GT] = ACTIONS(5230),
    [anon_sym_SEMI] = ACTIONS(5232),
    [anon_sym___attribute__] = ACTIONS(5230),
    [anon_sym_LBRACE] = ACTIONS(5232),
    [anon_sym_RBRACE] = ACTIONS(5232),
    [anon_sym_LBRACK] = ACTIONS(5232),
    [anon_sym_RBRACK] = ACTIONS(5232),
    [anon_sym_EQ] = ACTIONS(5230),
    [anon_sym_COLON] = ACTIONS(5232),
    [anon_sym_QMARK] = ACTIONS(5232),
    [anon_sym_STAR_EQ] = ACTIONS(5232),
    [anon_sym_SLASH_EQ] = ACTIONS(5232),
    [anon_sym_PERCENT_EQ] = ACTIONS(5232),
    [anon_sym_PLUS_EQ] = ACTIONS(5232),
    [anon_sym_DASH_EQ] = ACTIONS(5232),
    [anon_sym_LT_LT_EQ] = ACTIONS(5232),
    [anon_sym_GT_GT_EQ] = ACTIONS(5232),
    [anon_sym_AMP_EQ] = ACTIONS(5232),
    [anon_sym_CARET_EQ] = ACTIONS(5232),
    [anon_sym_PIPE_EQ] = ACTIONS(5232),
    [anon_sym_and_eq] = ACTIONS(5230),
    [anon_sym_or_eq] = ACTIONS(5230),
    [anon_sym_xor_eq] = ACTIONS(5230),
    [anon_sym_LT_EQ_GT] = ACTIONS(5232),
    [anon_sym_or] = ACTIONS(5230),
    [anon_sym_and] = ACTIONS(5230),
    [anon_sym_bitor] = ACTIONS(5230),
    [anon_sym_xor] = ACTIONS(5230),
    [anon_sym_bitand] = ACTIONS(5230),
    [anon_sym_not_eq] = ACTIONS(5230),
    [anon_sym_DASH_DASH] = ACTIONS(5232),
    [anon_sym_PLUS_PLUS] = ACTIONS(5232),
    [anon_sym_DOT] = ACTIONS(5230),
    [anon_sym_DOT_STAR] = ACTIONS(5232),
    [anon_sym_DASH_GT] = ACTIONS(5232),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5230),
    [anon_sym_decltype] = ACTIONS(5230),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5232),
  },
  [2446] = {
    [sym_identifier] = ACTIONS(5378),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5380),
    [anon_sym_COMMA] = ACTIONS(5380),
    [anon_sym_RPAREN] = ACTIONS(5380),
    [aux_sym_preproc_if_token2] = ACTIONS(5380),
    [aux_sym_preproc_else_token1] = ACTIONS(5380),
    [aux_sym_preproc_elif_token1] = ACTIONS(5378),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5380),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5380),
    [anon_sym_LPAREN2] = ACTIONS(5380),
    [anon_sym_DASH] = ACTIONS(5378),
    [anon_sym_PLUS] = ACTIONS(5378),
    [anon_sym_STAR] = ACTIONS(5378),
    [anon_sym_SLASH] = ACTIONS(5378),
    [anon_sym_PERCENT] = ACTIONS(5378),
    [anon_sym_PIPE_PIPE] = ACTIONS(5380),
    [anon_sym_AMP_AMP] = ACTIONS(5380),
    [anon_sym_PIPE] = ACTIONS(5378),
    [anon_sym_CARET] = ACTIONS(5378),
    [anon_sym_AMP] = ACTIONS(5378),
    [anon_sym_EQ_EQ] = ACTIONS(5380),
    [anon_sym_BANG_EQ] = ACTIONS(5380),
    [anon_sym_GT] = ACTIONS(5378),
    [anon_sym_GT_EQ] = ACTIONS(5380),
    [anon_sym_LT_EQ] = ACTIONS(5378),
    [anon_sym_LT] = ACTIONS(5378),
    [anon_sym_LT_LT] = ACTIONS(5378),
    [anon_sym_GT_GT] = ACTIONS(5378),
    [anon_sym_SEMI] = ACTIONS(5380),
    [anon_sym___attribute__] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(5380),
    [anon_sym_RBRACE] = ACTIONS(5380),
    [anon_sym_LBRACK] = ACTIONS(5380),
    [anon_sym_RBRACK] = ACTIONS(5380),
    [anon_sym_EQ] = ACTIONS(5378),
    [anon_sym_COLON] = ACTIONS(5380),
    [anon_sym_QMARK] = ACTIONS(5380),
    [anon_sym_STAR_EQ] = ACTIONS(5380),
    [anon_sym_SLASH_EQ] = ACTIONS(5380),
    [anon_sym_PERCENT_EQ] = ACTIONS(5380),
    [anon_sym_PLUS_EQ] = ACTIONS(5380),
    [anon_sym_DASH_EQ] = ACTIONS(5380),
    [anon_sym_LT_LT_EQ] = ACTIONS(5380),
    [anon_sym_GT_GT_EQ] = ACTIONS(5380),
    [anon_sym_AMP_EQ] = ACTIONS(5380),
    [anon_sym_CARET_EQ] = ACTIONS(5380),
    [anon_sym_PIPE_EQ] = ACTIONS(5380),
    [anon_sym_and_eq] = ACTIONS(5378),
    [anon_sym_or_eq] = ACTIONS(5378),
    [anon_sym_xor_eq] = ACTIONS(5378),
    [anon_sym_LT_EQ_GT] = ACTIONS(5380),
    [anon_sym_or] = ACTIONS(5378),
    [anon_sym_and] = ACTIONS(5378),
    [anon_sym_bitor] = ACTIONS(5378),
    [anon_sym_xor] = ACTIONS(5378),
    [anon_sym_bitand] = ACTIONS(5378),
    [anon_sym_not_eq] = ACTIONS(5378),
    [anon_sym_DASH_DASH] = ACTIONS(5380),
    [anon_sym_PLUS_PLUS] = ACTIONS(5380),
    [anon_sym_DOT] = ACTIONS(5378),
    [anon_sym_DOT_STAR] = ACTIONS(5380),
    [anon_sym_DASH_GT] = ACTIONS(5380),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5378),
    [anon_sym_decltype] = ACTIONS(5378),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5380),
  },
  [2447] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2378),
    [sym_identifier] = ACTIONS(5418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5416),
    [anon_sym_COMMA] = ACTIONS(5416),
    [aux_sym_preproc_if_token2] = ACTIONS(5416),
    [aux_sym_preproc_else_token1] = ACTIONS(5416),
    [aux_sym_preproc_elif_token1] = ACTIONS(5418),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5416),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5416),
    [anon_sym_LPAREN2] = ACTIONS(5416),
    [anon_sym_DASH] = ACTIONS(5418),
    [anon_sym_PLUS] = ACTIONS(5418),
    [anon_sym_STAR] = ACTIONS(5418),
    [anon_sym_SLASH] = ACTIONS(5418),
    [anon_sym_PERCENT] = ACTIONS(5418),
    [anon_sym_PIPE_PIPE] = ACTIONS(5416),
    [anon_sym_AMP_AMP] = ACTIONS(5416),
    [anon_sym_PIPE] = ACTIONS(5418),
    [anon_sym_CARET] = ACTIONS(5418),
    [anon_sym_AMP] = ACTIONS(5418),
    [anon_sym_EQ_EQ] = ACTIONS(5416),
    [anon_sym_BANG_EQ] = ACTIONS(5416),
    [anon_sym_GT] = ACTIONS(5418),
    [anon_sym_GT_EQ] = ACTIONS(5416),
    [anon_sym_LT_EQ] = ACTIONS(5418),
    [anon_sym_LT] = ACTIONS(5418),
    [anon_sym_LT_LT] = ACTIONS(5418),
    [anon_sym_GT_GT] = ACTIONS(5418),
    [anon_sym___attribute__] = ACTIONS(5418),
    [anon_sym_LBRACE] = ACTIONS(5416),
    [anon_sym_signed] = ACTIONS(6018),
    [anon_sym_unsigned] = ACTIONS(6018),
    [anon_sym_long] = ACTIONS(6018),
    [anon_sym_short] = ACTIONS(6018),
    [anon_sym_LBRACK] = ACTIONS(5416),
    [anon_sym_EQ] = ACTIONS(5418),
    [anon_sym_QMARK] = ACTIONS(5416),
    [anon_sym_STAR_EQ] = ACTIONS(5416),
    [anon_sym_SLASH_EQ] = ACTIONS(5416),
    [anon_sym_PERCENT_EQ] = ACTIONS(5416),
    [anon_sym_PLUS_EQ] = ACTIONS(5416),
    [anon_sym_DASH_EQ] = ACTIONS(5416),
    [anon_sym_LT_LT_EQ] = ACTIONS(5416),
    [anon_sym_GT_GT_EQ] = ACTIONS(5416),
    [anon_sym_AMP_EQ] = ACTIONS(5416),
    [anon_sym_CARET_EQ] = ACTIONS(5416),
    [anon_sym_PIPE_EQ] = ACTIONS(5416),
    [anon_sym_and_eq] = ACTIONS(5418),
    [anon_sym_or_eq] = ACTIONS(5418),
    [anon_sym_xor_eq] = ACTIONS(5418),
    [anon_sym_LT_EQ_GT] = ACTIONS(5416),
    [anon_sym_or] = ACTIONS(5418),
    [anon_sym_and] = ACTIONS(5418),
    [anon_sym_bitor] = ACTIONS(5418),
    [anon_sym_xor] = ACTIONS(5418),
    [anon_sym_bitand] = ACTIONS(5418),
    [anon_sym_not_eq] = ACTIONS(5418),
    [anon_sym_DASH_DASH] = ACTIONS(5416),
    [anon_sym_PLUS_PLUS] = ACTIONS(5416),
    [anon_sym_DOT] = ACTIONS(5418),
    [anon_sym_DOT_STAR] = ACTIONS(5416),
    [anon_sym_DASH_GT] = ACTIONS(5416),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5418),
    [anon_sym_decltype] = ACTIONS(5418),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5416),
  },
  [2448] = {
    [sym_attribute_specifier] = STATE(2561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5725),
    [anon_sym_COMMA] = ACTIONS(5725),
    [anon_sym_LPAREN2] = ACTIONS(5725),
    [anon_sym_DASH] = ACTIONS(5727),
    [anon_sym_PLUS] = ACTIONS(5727),
    [anon_sym_STAR] = ACTIONS(5725),
    [anon_sym_SLASH] = ACTIONS(5727),
    [anon_sym_PERCENT] = ACTIONS(5725),
    [anon_sym_PIPE_PIPE] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_PIPE] = ACTIONS(5727),
    [anon_sym_CARET] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
    [anon_sym_EQ_EQ] = ACTIONS(5725),
    [anon_sym_BANG_EQ] = ACTIONS(5725),
    [anon_sym_GT] = ACTIONS(5727),
    [anon_sym_GT_EQ] = ACTIONS(5727),
    [anon_sym_LT_EQ] = ACTIONS(5727),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_LT_LT] = ACTIONS(5727),
    [anon_sym_GT_GT] = ACTIONS(5727),
    [anon_sym___extension__] = ACTIONS(5725),
    [anon_sym___global__] = ACTIONS(5725),
    [anon_sym___attribute__] = ACTIONS(5652),
    [anon_sym_LBRACE] = ACTIONS(5725),
    [anon_sym_LBRACK] = ACTIONS(5725),
    [anon_sym_const] = ACTIONS(5727),
    [anon_sym_constexpr] = ACTIONS(5725),
    [anon_sym_volatile] = ACTIONS(5725),
    [anon_sym_restrict] = ACTIONS(5725),
    [anon_sym___restrict__] = ACTIONS(5725),
    [anon_sym__Atomic] = ACTIONS(5725),
    [anon_sym__Noreturn] = ACTIONS(5725),
    [anon_sym_noreturn] = ACTIONS(5725),
    [anon_sym_mutable] = ACTIONS(5725),
    [anon_sym_constinit] = ACTIONS(5725),
    [anon_sym_consteval] = ACTIONS(5725),
    [anon_sym___shared__] = ACTIONS(5725),
    [anon_sym___local__] = ACTIONS(5725),
    [anon_sym___constant__] = ACTIONS(5725),
    [anon_sym___managed__] = ACTIONS(5725),
    [anon_sym___grid_constant__] = ACTIONS(5725),
    [anon_sym_alignas] = ACTIONS(5725),
    [anon_sym__Alignas] = ACTIONS(5725),
    [anon_sym_QMARK] = ACTIONS(5725),
    [anon_sym_LT_EQ_GT] = ACTIONS(5725),
    [anon_sym_or] = ACTIONS(5725),
    [anon_sym_and] = ACTIONS(5725),
    [anon_sym_bitor] = ACTIONS(5725),
    [anon_sym_xor] = ACTIONS(5725),
    [anon_sym_bitand] = ACTIONS(5725),
    [anon_sym_not_eq] = ACTIONS(5725),
    [anon_sym_DASH_DASH] = ACTIONS(5725),
    [anon_sym_PLUS_PLUS] = ACTIONS(5725),
    [anon_sym_DOT] = ACTIONS(5727),
    [anon_sym_DOT_STAR] = ACTIONS(5725),
    [anon_sym_DASH_GT] = ACTIONS(5725),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5725),
    [anon_sym_decltype] = ACTIONS(5725),
    [anon_sym_final] = ACTIONS(5725),
    [anon_sym_override] = ACTIONS(5725),
    [anon_sym_GT2] = ACTIONS(5725),
    [anon_sym_requires] = ACTIONS(5725),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5725),
  },
  [2449] = {
    [sym_string_literal] = STATE(2291),
    [sym_raw_string_literal] = STATE(2291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_RPAREN] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3758),
    [anon_sym_SLASH_EQ] = ACTIONS(3758),
    [anon_sym_PERCENT_EQ] = ACTIONS(3758),
    [anon_sym_PLUS_EQ] = ACTIONS(3758),
    [anon_sym_DASH_EQ] = ACTIONS(3758),
    [anon_sym_LT_LT_EQ] = ACTIONS(3758),
    [anon_sym_GT_GT_EQ] = ACTIONS(3758),
    [anon_sym_AMP_EQ] = ACTIONS(3758),
    [anon_sym_CARET_EQ] = ACTIONS(3758),
    [anon_sym_PIPE_EQ] = ACTIONS(3758),
    [anon_sym_and_eq] = ACTIONS(3766),
    [anon_sym_or_eq] = ACTIONS(3766),
    [anon_sym_xor_eq] = ACTIONS(3766),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3766),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3766),
    [anon_sym_not_eq] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3766),
    [anon_sym_L_DQUOTE] = ACTIONS(4814),
    [anon_sym_u_DQUOTE] = ACTIONS(4814),
    [anon_sym_U_DQUOTE] = ACTIONS(4814),
    [anon_sym_u8_DQUOTE] = ACTIONS(4814),
    [anon_sym_DQUOTE] = ACTIONS(4814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4816),
    [anon_sym_LR_DQUOTE] = ACTIONS(4816),
    [anon_sym_uR_DQUOTE] = ACTIONS(4816),
    [anon_sym_UR_DQUOTE] = ACTIONS(4816),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4816),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3758),
    [sym_literal_suffix] = ACTIONS(5980),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2450] = {
    [sym_identifier] = ACTIONS(5226),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5228),
    [anon_sym_COMMA] = ACTIONS(5228),
    [anon_sym_RPAREN] = ACTIONS(5228),
    [aux_sym_preproc_if_token2] = ACTIONS(5228),
    [aux_sym_preproc_else_token1] = ACTIONS(5228),
    [aux_sym_preproc_elif_token1] = ACTIONS(5226),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5228),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5228),
    [anon_sym_LPAREN2] = ACTIONS(5228),
    [anon_sym_DASH] = ACTIONS(5226),
    [anon_sym_PLUS] = ACTIONS(5226),
    [anon_sym_STAR] = ACTIONS(5226),
    [anon_sym_SLASH] = ACTIONS(5226),
    [anon_sym_PERCENT] = ACTIONS(5226),
    [anon_sym_PIPE_PIPE] = ACTIONS(5228),
    [anon_sym_AMP_AMP] = ACTIONS(5228),
    [anon_sym_PIPE] = ACTIONS(5226),
    [anon_sym_CARET] = ACTIONS(5226),
    [anon_sym_AMP] = ACTIONS(5226),
    [anon_sym_EQ_EQ] = ACTIONS(5228),
    [anon_sym_BANG_EQ] = ACTIONS(5228),
    [anon_sym_GT] = ACTIONS(5226),
    [anon_sym_GT_EQ] = ACTIONS(5228),
    [anon_sym_LT_EQ] = ACTIONS(5226),
    [anon_sym_LT] = ACTIONS(5226),
    [anon_sym_LT_LT] = ACTIONS(5226),
    [anon_sym_GT_GT] = ACTIONS(5226),
    [anon_sym_SEMI] = ACTIONS(5228),
    [anon_sym___attribute__] = ACTIONS(5226),
    [anon_sym_LBRACE] = ACTIONS(5228),
    [anon_sym_RBRACE] = ACTIONS(5228),
    [anon_sym_LBRACK] = ACTIONS(5228),
    [anon_sym_RBRACK] = ACTIONS(5228),
    [anon_sym_EQ] = ACTIONS(5226),
    [anon_sym_COLON] = ACTIONS(5228),
    [anon_sym_QMARK] = ACTIONS(5228),
    [anon_sym_STAR_EQ] = ACTIONS(5228),
    [anon_sym_SLASH_EQ] = ACTIONS(5228),
    [anon_sym_PERCENT_EQ] = ACTIONS(5228),
    [anon_sym_PLUS_EQ] = ACTIONS(5228),
    [anon_sym_DASH_EQ] = ACTIONS(5228),
    [anon_sym_LT_LT_EQ] = ACTIONS(5228),
    [anon_sym_GT_GT_EQ] = ACTIONS(5228),
    [anon_sym_AMP_EQ] = ACTIONS(5228),
    [anon_sym_CARET_EQ] = ACTIONS(5228),
    [anon_sym_PIPE_EQ] = ACTIONS(5228),
    [anon_sym_and_eq] = ACTIONS(5226),
    [anon_sym_or_eq] = ACTIONS(5226),
    [anon_sym_xor_eq] = ACTIONS(5226),
    [anon_sym_LT_EQ_GT] = ACTIONS(5228),
    [anon_sym_or] = ACTIONS(5226),
    [anon_sym_and] = ACTIONS(5226),
    [anon_sym_bitor] = ACTIONS(5226),
    [anon_sym_xor] = ACTIONS(5226),
    [anon_sym_bitand] = ACTIONS(5226),
    [anon_sym_not_eq] = ACTIONS(5226),
    [anon_sym_DASH_DASH] = ACTIONS(5228),
    [anon_sym_PLUS_PLUS] = ACTIONS(5228),
    [anon_sym_DOT] = ACTIONS(5226),
    [anon_sym_DOT_STAR] = ACTIONS(5228),
    [anon_sym_DASH_GT] = ACTIONS(5228),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5226),
    [anon_sym_decltype] = ACTIONS(5226),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5228),
  },
  [2451] = {
    [sym_attribute_specifier] = STATE(2554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5674),
    [anon_sym_COMMA] = ACTIONS(5674),
    [anon_sym_LPAREN2] = ACTIONS(5674),
    [anon_sym_DASH] = ACTIONS(5676),
    [anon_sym_PLUS] = ACTIONS(5676),
    [anon_sym_STAR] = ACTIONS(5674),
    [anon_sym_SLASH] = ACTIONS(5676),
    [anon_sym_PERCENT] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_CARET] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
    [anon_sym_EQ_EQ] = ACTIONS(5674),
    [anon_sym_BANG_EQ] = ACTIONS(5674),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_EQ] = ACTIONS(5676),
    [anon_sym_LT_EQ] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5676),
    [anon_sym___extension__] = ACTIONS(5674),
    [anon_sym___global__] = ACTIONS(5674),
    [anon_sym___attribute__] = ACTIONS(5652),
    [anon_sym_LBRACE] = ACTIONS(5674),
    [anon_sym_LBRACK] = ACTIONS(5674),
    [anon_sym_const] = ACTIONS(5676),
    [anon_sym_constexpr] = ACTIONS(5674),
    [anon_sym_volatile] = ACTIONS(5674),
    [anon_sym_restrict] = ACTIONS(5674),
    [anon_sym___restrict__] = ACTIONS(5674),
    [anon_sym__Atomic] = ACTIONS(5674),
    [anon_sym__Noreturn] = ACTIONS(5674),
    [anon_sym_noreturn] = ACTIONS(5674),
    [anon_sym_mutable] = ACTIONS(5674),
    [anon_sym_constinit] = ACTIONS(5674),
    [anon_sym_consteval] = ACTIONS(5674),
    [anon_sym___shared__] = ACTIONS(5674),
    [anon_sym___local__] = ACTIONS(5674),
    [anon_sym___constant__] = ACTIONS(5674),
    [anon_sym___managed__] = ACTIONS(5674),
    [anon_sym___grid_constant__] = ACTIONS(5674),
    [anon_sym_alignas] = ACTIONS(5674),
    [anon_sym__Alignas] = ACTIONS(5674),
    [anon_sym_QMARK] = ACTIONS(5674),
    [anon_sym_LT_EQ_GT] = ACTIONS(5674),
    [anon_sym_or] = ACTIONS(5674),
    [anon_sym_and] = ACTIONS(5674),
    [anon_sym_bitor] = ACTIONS(5674),
    [anon_sym_xor] = ACTIONS(5674),
    [anon_sym_bitand] = ACTIONS(5674),
    [anon_sym_not_eq] = ACTIONS(5674),
    [anon_sym_DASH_DASH] = ACTIONS(5674),
    [anon_sym_PLUS_PLUS] = ACTIONS(5674),
    [anon_sym_DOT] = ACTIONS(5676),
    [anon_sym_DOT_STAR] = ACTIONS(5674),
    [anon_sym_DASH_GT] = ACTIONS(5674),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5674),
    [anon_sym_decltype] = ACTIONS(5674),
    [anon_sym_final] = ACTIONS(5674),
    [anon_sym_override] = ACTIONS(5674),
    [anon_sym_GT2] = ACTIONS(5674),
    [anon_sym_requires] = ACTIONS(5674),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5674),
  },
  [2452] = {
    [sym_identifier] = ACTIONS(5222),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5224),
    [anon_sym_COMMA] = ACTIONS(5224),
    [anon_sym_RPAREN] = ACTIONS(5224),
    [aux_sym_preproc_if_token2] = ACTIONS(5224),
    [aux_sym_preproc_else_token1] = ACTIONS(5224),
    [aux_sym_preproc_elif_token1] = ACTIONS(5222),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5224),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5224),
    [anon_sym_LPAREN2] = ACTIONS(5224),
    [anon_sym_DASH] = ACTIONS(5222),
    [anon_sym_PLUS] = ACTIONS(5222),
    [anon_sym_STAR] = ACTIONS(5222),
    [anon_sym_SLASH] = ACTIONS(5222),
    [anon_sym_PERCENT] = ACTIONS(5222),
    [anon_sym_PIPE_PIPE] = ACTIONS(5224),
    [anon_sym_AMP_AMP] = ACTIONS(5224),
    [anon_sym_PIPE] = ACTIONS(5222),
    [anon_sym_CARET] = ACTIONS(5222),
    [anon_sym_AMP] = ACTIONS(5222),
    [anon_sym_EQ_EQ] = ACTIONS(5224),
    [anon_sym_BANG_EQ] = ACTIONS(5224),
    [anon_sym_GT] = ACTIONS(5222),
    [anon_sym_GT_EQ] = ACTIONS(5224),
    [anon_sym_LT_EQ] = ACTIONS(5222),
    [anon_sym_LT] = ACTIONS(5222),
    [anon_sym_LT_LT] = ACTIONS(5222),
    [anon_sym_GT_GT] = ACTIONS(5222),
    [anon_sym_SEMI] = ACTIONS(5224),
    [anon_sym___attribute__] = ACTIONS(5222),
    [anon_sym_LBRACE] = ACTIONS(5224),
    [anon_sym_RBRACE] = ACTIONS(5224),
    [anon_sym_LBRACK] = ACTIONS(5224),
    [anon_sym_RBRACK] = ACTIONS(5224),
    [anon_sym_EQ] = ACTIONS(5222),
    [anon_sym_COLON] = ACTIONS(5224),
    [anon_sym_QMARK] = ACTIONS(5224),
    [anon_sym_STAR_EQ] = ACTIONS(5224),
    [anon_sym_SLASH_EQ] = ACTIONS(5224),
    [anon_sym_PERCENT_EQ] = ACTIONS(5224),
    [anon_sym_PLUS_EQ] = ACTIONS(5224),
    [anon_sym_DASH_EQ] = ACTIONS(5224),
    [anon_sym_LT_LT_EQ] = ACTIONS(5224),
    [anon_sym_GT_GT_EQ] = ACTIONS(5224),
    [anon_sym_AMP_EQ] = ACTIONS(5224),
    [anon_sym_CARET_EQ] = ACTIONS(5224),
    [anon_sym_PIPE_EQ] = ACTIONS(5224),
    [anon_sym_and_eq] = ACTIONS(5222),
    [anon_sym_or_eq] = ACTIONS(5222),
    [anon_sym_xor_eq] = ACTIONS(5222),
    [anon_sym_LT_EQ_GT] = ACTIONS(5224),
    [anon_sym_or] = ACTIONS(5222),
    [anon_sym_and] = ACTIONS(5222),
    [anon_sym_bitor] = ACTIONS(5222),
    [anon_sym_xor] = ACTIONS(5222),
    [anon_sym_bitand] = ACTIONS(5222),
    [anon_sym_not_eq] = ACTIONS(5222),
    [anon_sym_DASH_DASH] = ACTIONS(5224),
    [anon_sym_PLUS_PLUS] = ACTIONS(5224),
    [anon_sym_DOT] = ACTIONS(5222),
    [anon_sym_DOT_STAR] = ACTIONS(5224),
    [anon_sym_DASH_GT] = ACTIONS(5224),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5222),
    [anon_sym_decltype] = ACTIONS(5222),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5224),
  },
  [2453] = {
    [sym_identifier] = ACTIONS(5218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5220),
    [anon_sym_COMMA] = ACTIONS(5220),
    [anon_sym_RPAREN] = ACTIONS(5220),
    [aux_sym_preproc_if_token2] = ACTIONS(5220),
    [aux_sym_preproc_else_token1] = ACTIONS(5220),
    [aux_sym_preproc_elif_token1] = ACTIONS(5218),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5220),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5220),
    [anon_sym_LPAREN2] = ACTIONS(5220),
    [anon_sym_DASH] = ACTIONS(5218),
    [anon_sym_PLUS] = ACTIONS(5218),
    [anon_sym_STAR] = ACTIONS(5218),
    [anon_sym_SLASH] = ACTIONS(5218),
    [anon_sym_PERCENT] = ACTIONS(5218),
    [anon_sym_PIPE_PIPE] = ACTIONS(5220),
    [anon_sym_AMP_AMP] = ACTIONS(5220),
    [anon_sym_PIPE] = ACTIONS(5218),
    [anon_sym_CARET] = ACTIONS(5218),
    [anon_sym_AMP] = ACTIONS(5218),
    [anon_sym_EQ_EQ] = ACTIONS(5220),
    [anon_sym_BANG_EQ] = ACTIONS(5220),
    [anon_sym_GT] = ACTIONS(5218),
    [anon_sym_GT_EQ] = ACTIONS(5220),
    [anon_sym_LT_EQ] = ACTIONS(5218),
    [anon_sym_LT] = ACTIONS(5218),
    [anon_sym_LT_LT] = ACTIONS(5218),
    [anon_sym_GT_GT] = ACTIONS(5218),
    [anon_sym_SEMI] = ACTIONS(5220),
    [anon_sym___attribute__] = ACTIONS(5218),
    [anon_sym_LBRACE] = ACTIONS(5220),
    [anon_sym_RBRACE] = ACTIONS(5220),
    [anon_sym_LBRACK] = ACTIONS(5220),
    [anon_sym_RBRACK] = ACTIONS(5220),
    [anon_sym_EQ] = ACTIONS(5218),
    [anon_sym_COLON] = ACTIONS(5220),
    [anon_sym_QMARK] = ACTIONS(5220),
    [anon_sym_STAR_EQ] = ACTIONS(5220),
    [anon_sym_SLASH_EQ] = ACTIONS(5220),
    [anon_sym_PERCENT_EQ] = ACTIONS(5220),
    [anon_sym_PLUS_EQ] = ACTIONS(5220),
    [anon_sym_DASH_EQ] = ACTIONS(5220),
    [anon_sym_LT_LT_EQ] = ACTIONS(5220),
    [anon_sym_GT_GT_EQ] = ACTIONS(5220),
    [anon_sym_AMP_EQ] = ACTIONS(5220),
    [anon_sym_CARET_EQ] = ACTIONS(5220),
    [anon_sym_PIPE_EQ] = ACTIONS(5220),
    [anon_sym_and_eq] = ACTIONS(5218),
    [anon_sym_or_eq] = ACTIONS(5218),
    [anon_sym_xor_eq] = ACTIONS(5218),
    [anon_sym_LT_EQ_GT] = ACTIONS(5220),
    [anon_sym_or] = ACTIONS(5218),
    [anon_sym_and] = ACTIONS(5218),
    [anon_sym_bitor] = ACTIONS(5218),
    [anon_sym_xor] = ACTIONS(5218),
    [anon_sym_bitand] = ACTIONS(5218),
    [anon_sym_not_eq] = ACTIONS(5218),
    [anon_sym_DASH_DASH] = ACTIONS(5220),
    [anon_sym_PLUS_PLUS] = ACTIONS(5220),
    [anon_sym_DOT] = ACTIONS(5218),
    [anon_sym_DOT_STAR] = ACTIONS(5220),
    [anon_sym_DASH_GT] = ACTIONS(5220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5218),
    [anon_sym_decltype] = ACTIONS(5218),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5220),
  },
  [2454] = {
    [sym_attribute_specifier] = STATE(2601),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5694),
    [anon_sym_COMMA] = ACTIONS(5694),
    [anon_sym_LPAREN2] = ACTIONS(5694),
    [anon_sym_DASH] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5696),
    [anon_sym_STAR] = ACTIONS(5694),
    [anon_sym_SLASH] = ACTIONS(5696),
    [anon_sym_PERCENT] = ACTIONS(5694),
    [anon_sym_PIPE_PIPE] = ACTIONS(5694),
    [anon_sym_AMP_AMP] = ACTIONS(5694),
    [anon_sym_PIPE] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5694),
    [anon_sym_AMP] = ACTIONS(5696),
    [anon_sym_EQ_EQ] = ACTIONS(5694),
    [anon_sym_BANG_EQ] = ACTIONS(5694),
    [anon_sym_GT] = ACTIONS(5696),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5696),
    [anon_sym_LT] = ACTIONS(5696),
    [anon_sym_LT_LT] = ACTIONS(5696),
    [anon_sym_GT_GT] = ACTIONS(5696),
    [anon_sym___extension__] = ACTIONS(5694),
    [anon_sym___global__] = ACTIONS(5694),
    [anon_sym___attribute__] = ACTIONS(5652),
    [anon_sym_LBRACE] = ACTIONS(5694),
    [anon_sym_LBRACK] = ACTIONS(5694),
    [anon_sym_const] = ACTIONS(5696),
    [anon_sym_constexpr] = ACTIONS(5694),
    [anon_sym_volatile] = ACTIONS(5694),
    [anon_sym_restrict] = ACTIONS(5694),
    [anon_sym___restrict__] = ACTIONS(5694),
    [anon_sym__Atomic] = ACTIONS(5694),
    [anon_sym__Noreturn] = ACTIONS(5694),
    [anon_sym_noreturn] = ACTIONS(5694),
    [anon_sym_mutable] = ACTIONS(5694),
    [anon_sym_constinit] = ACTIONS(5694),
    [anon_sym_consteval] = ACTIONS(5694),
    [anon_sym___shared__] = ACTIONS(5694),
    [anon_sym___local__] = ACTIONS(5694),
    [anon_sym___constant__] = ACTIONS(5694),
    [anon_sym___managed__] = ACTIONS(5694),
    [anon_sym___grid_constant__] = ACTIONS(5694),
    [anon_sym_alignas] = ACTIONS(5694),
    [anon_sym__Alignas] = ACTIONS(5694),
    [anon_sym_QMARK] = ACTIONS(5694),
    [anon_sym_LT_EQ_GT] = ACTIONS(5694),
    [anon_sym_or] = ACTIONS(5694),
    [anon_sym_and] = ACTIONS(5694),
    [anon_sym_bitor] = ACTIONS(5694),
    [anon_sym_xor] = ACTIONS(5694),
    [anon_sym_bitand] = ACTIONS(5694),
    [anon_sym_not_eq] = ACTIONS(5694),
    [anon_sym_DASH_DASH] = ACTIONS(5694),
    [anon_sym_PLUS_PLUS] = ACTIONS(5694),
    [anon_sym_DOT] = ACTIONS(5696),
    [anon_sym_DOT_STAR] = ACTIONS(5694),
    [anon_sym_DASH_GT] = ACTIONS(5694),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5694),
    [anon_sym_decltype] = ACTIONS(5694),
    [anon_sym_final] = ACTIONS(5694),
    [anon_sym_override] = ACTIONS(5694),
    [anon_sym_GT2] = ACTIONS(5694),
    [anon_sym_requires] = ACTIONS(5694),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5694),
  },
  [2455] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2378),
    [sym_identifier] = ACTIONS(5424),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5422),
    [anon_sym_COMMA] = ACTIONS(5422),
    [aux_sym_preproc_if_token2] = ACTIONS(5422),
    [aux_sym_preproc_else_token1] = ACTIONS(5422),
    [aux_sym_preproc_elif_token1] = ACTIONS(5424),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5422),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5422),
    [anon_sym_LPAREN2] = ACTIONS(5422),
    [anon_sym_DASH] = ACTIONS(5424),
    [anon_sym_PLUS] = ACTIONS(5424),
    [anon_sym_STAR] = ACTIONS(5424),
    [anon_sym_SLASH] = ACTIONS(5424),
    [anon_sym_PERCENT] = ACTIONS(5424),
    [anon_sym_PIPE_PIPE] = ACTIONS(5422),
    [anon_sym_AMP_AMP] = ACTIONS(5422),
    [anon_sym_PIPE] = ACTIONS(5424),
    [anon_sym_CARET] = ACTIONS(5424),
    [anon_sym_AMP] = ACTIONS(5424),
    [anon_sym_EQ_EQ] = ACTIONS(5422),
    [anon_sym_BANG_EQ] = ACTIONS(5422),
    [anon_sym_GT] = ACTIONS(5424),
    [anon_sym_GT_EQ] = ACTIONS(5422),
    [anon_sym_LT_EQ] = ACTIONS(5424),
    [anon_sym_LT] = ACTIONS(5424),
    [anon_sym_LT_LT] = ACTIONS(5424),
    [anon_sym_GT_GT] = ACTIONS(5424),
    [anon_sym___attribute__] = ACTIONS(5424),
    [anon_sym_LBRACE] = ACTIONS(5422),
    [anon_sym_signed] = ACTIONS(6018),
    [anon_sym_unsigned] = ACTIONS(6018),
    [anon_sym_long] = ACTIONS(6018),
    [anon_sym_short] = ACTIONS(6018),
    [anon_sym_LBRACK] = ACTIONS(5422),
    [anon_sym_EQ] = ACTIONS(5424),
    [anon_sym_QMARK] = ACTIONS(5422),
    [anon_sym_STAR_EQ] = ACTIONS(5422),
    [anon_sym_SLASH_EQ] = ACTIONS(5422),
    [anon_sym_PERCENT_EQ] = ACTIONS(5422),
    [anon_sym_PLUS_EQ] = ACTIONS(5422),
    [anon_sym_DASH_EQ] = ACTIONS(5422),
    [anon_sym_LT_LT_EQ] = ACTIONS(5422),
    [anon_sym_GT_GT_EQ] = ACTIONS(5422),
    [anon_sym_AMP_EQ] = ACTIONS(5422),
    [anon_sym_CARET_EQ] = ACTIONS(5422),
    [anon_sym_PIPE_EQ] = ACTIONS(5422),
    [anon_sym_and_eq] = ACTIONS(5424),
    [anon_sym_or_eq] = ACTIONS(5424),
    [anon_sym_xor_eq] = ACTIONS(5424),
    [anon_sym_LT_EQ_GT] = ACTIONS(5422),
    [anon_sym_or] = ACTIONS(5424),
    [anon_sym_and] = ACTIONS(5424),
    [anon_sym_bitor] = ACTIONS(5424),
    [anon_sym_xor] = ACTIONS(5424),
    [anon_sym_bitand] = ACTIONS(5424),
    [anon_sym_not_eq] = ACTIONS(5424),
    [anon_sym_DASH_DASH] = ACTIONS(5422),
    [anon_sym_PLUS_PLUS] = ACTIONS(5422),
    [anon_sym_DOT] = ACTIONS(5424),
    [anon_sym_DOT_STAR] = ACTIONS(5422),
    [anon_sym_DASH_GT] = ACTIONS(5422),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5424),
    [anon_sym_decltype] = ACTIONS(5424),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5422),
  },
  [2456] = {
    [sym_identifier] = ACTIONS(6028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6030),
    [anon_sym_COMMA] = ACTIONS(6030),
    [anon_sym_RPAREN] = ACTIONS(6030),
    [aux_sym_preproc_if_token2] = ACTIONS(6030),
    [aux_sym_preproc_else_token1] = ACTIONS(6030),
    [aux_sym_preproc_elif_token1] = ACTIONS(6028),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6030),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6030),
    [anon_sym_LPAREN2] = ACTIONS(6030),
    [anon_sym_DASH] = ACTIONS(6028),
    [anon_sym_PLUS] = ACTIONS(6028),
    [anon_sym_STAR] = ACTIONS(6028),
    [anon_sym_SLASH] = ACTIONS(6028),
    [anon_sym_PERCENT] = ACTIONS(6028),
    [anon_sym_PIPE_PIPE] = ACTIONS(6030),
    [anon_sym_AMP_AMP] = ACTIONS(6030),
    [anon_sym_PIPE] = ACTIONS(6028),
    [anon_sym_CARET] = ACTIONS(6028),
    [anon_sym_AMP] = ACTIONS(6028),
    [anon_sym_EQ_EQ] = ACTIONS(6030),
    [anon_sym_BANG_EQ] = ACTIONS(6030),
    [anon_sym_GT] = ACTIONS(6028),
    [anon_sym_GT_EQ] = ACTIONS(6030),
    [anon_sym_LT_EQ] = ACTIONS(6028),
    [anon_sym_LT] = ACTIONS(6028),
    [anon_sym_LT_LT] = ACTIONS(6028),
    [anon_sym_GT_GT] = ACTIONS(6028),
    [anon_sym_SEMI] = ACTIONS(6030),
    [anon_sym___attribute__] = ACTIONS(6028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6030),
    [anon_sym_LBRACE] = ACTIONS(6030),
    [anon_sym_RBRACE] = ACTIONS(6030),
    [anon_sym_LBRACK] = ACTIONS(6028),
    [anon_sym_RBRACK] = ACTIONS(6030),
    [anon_sym_EQ] = ACTIONS(6028),
    [anon_sym_COLON] = ACTIONS(6030),
    [anon_sym_QMARK] = ACTIONS(6030),
    [anon_sym_STAR_EQ] = ACTIONS(6030),
    [anon_sym_SLASH_EQ] = ACTIONS(6030),
    [anon_sym_PERCENT_EQ] = ACTIONS(6030),
    [anon_sym_PLUS_EQ] = ACTIONS(6030),
    [anon_sym_DASH_EQ] = ACTIONS(6030),
    [anon_sym_LT_LT_EQ] = ACTIONS(6030),
    [anon_sym_GT_GT_EQ] = ACTIONS(6030),
    [anon_sym_AMP_EQ] = ACTIONS(6030),
    [anon_sym_CARET_EQ] = ACTIONS(6030),
    [anon_sym_PIPE_EQ] = ACTIONS(6030),
    [anon_sym_and_eq] = ACTIONS(6028),
    [anon_sym_or_eq] = ACTIONS(6028),
    [anon_sym_xor_eq] = ACTIONS(6028),
    [anon_sym_LT_EQ_GT] = ACTIONS(6030),
    [anon_sym_or] = ACTIONS(6028),
    [anon_sym_and] = ACTIONS(6028),
    [anon_sym_bitor] = ACTIONS(6028),
    [anon_sym_xor] = ACTIONS(6028),
    [anon_sym_bitand] = ACTIONS(6028),
    [anon_sym_not_eq] = ACTIONS(6028),
    [anon_sym_DASH_DASH] = ACTIONS(6030),
    [anon_sym_PLUS_PLUS] = ACTIONS(6030),
    [anon_sym_DOT] = ACTIONS(6028),
    [anon_sym_DOT_STAR] = ACTIONS(6030),
    [anon_sym_DASH_GT] = ACTIONS(6030),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6028),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(6030),
  },
  [2457] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2430),
    [sym_identifier] = ACTIONS(5374),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5376),
    [anon_sym_COMMA] = ACTIONS(5376),
    [aux_sym_preproc_if_token2] = ACTIONS(5376),
    [aux_sym_preproc_else_token1] = ACTIONS(5376),
    [aux_sym_preproc_elif_token1] = ACTIONS(5374),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5376),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5376),
    [anon_sym_LPAREN2] = ACTIONS(5376),
    [anon_sym_DASH] = ACTIONS(5374),
    [anon_sym_PLUS] = ACTIONS(5374),
    [anon_sym_STAR] = ACTIONS(5374),
    [anon_sym_SLASH] = ACTIONS(5374),
    [anon_sym_PERCENT] = ACTIONS(5374),
    [anon_sym_PIPE_PIPE] = ACTIONS(5376),
    [anon_sym_AMP_AMP] = ACTIONS(5376),
    [anon_sym_PIPE] = ACTIONS(5374),
    [anon_sym_CARET] = ACTIONS(5374),
    [anon_sym_AMP] = ACTIONS(5374),
    [anon_sym_EQ_EQ] = ACTIONS(5376),
    [anon_sym_BANG_EQ] = ACTIONS(5376),
    [anon_sym_GT] = ACTIONS(5374),
    [anon_sym_GT_EQ] = ACTIONS(5376),
    [anon_sym_LT_EQ] = ACTIONS(5374),
    [anon_sym_LT] = ACTIONS(5374),
    [anon_sym_LT_LT] = ACTIONS(5374),
    [anon_sym_GT_GT] = ACTIONS(5374),
    [anon_sym___attribute__] = ACTIONS(5374),
    [anon_sym_LBRACE] = ACTIONS(5376),
    [anon_sym_signed] = ACTIONS(6032),
    [anon_sym_unsigned] = ACTIONS(6032),
    [anon_sym_long] = ACTIONS(6032),
    [anon_sym_short] = ACTIONS(6032),
    [anon_sym_LBRACK] = ACTIONS(5376),
    [anon_sym_EQ] = ACTIONS(5374),
    [anon_sym_QMARK] = ACTIONS(5376),
    [anon_sym_STAR_EQ] = ACTIONS(5376),
    [anon_sym_SLASH_EQ] = ACTIONS(5376),
    [anon_sym_PERCENT_EQ] = ACTIONS(5376),
    [anon_sym_PLUS_EQ] = ACTIONS(5376),
    [anon_sym_DASH_EQ] = ACTIONS(5376),
    [anon_sym_LT_LT_EQ] = ACTIONS(5376),
    [anon_sym_GT_GT_EQ] = ACTIONS(5376),
    [anon_sym_AMP_EQ] = ACTIONS(5376),
    [anon_sym_CARET_EQ] = ACTIONS(5376),
    [anon_sym_PIPE_EQ] = ACTIONS(5376),
    [anon_sym_and_eq] = ACTIONS(5374),
    [anon_sym_or_eq] = ACTIONS(5374),
    [anon_sym_xor_eq] = ACTIONS(5374),
    [anon_sym_LT_EQ_GT] = ACTIONS(5376),
    [anon_sym_or] = ACTIONS(5374),
    [anon_sym_and] = ACTIONS(5374),
    [anon_sym_bitor] = ACTIONS(5374),
    [anon_sym_xor] = ACTIONS(5374),
    [anon_sym_bitand] = ACTIONS(5374),
    [anon_sym_not_eq] = ACTIONS(5374),
    [anon_sym_DASH_DASH] = ACTIONS(5376),
    [anon_sym_PLUS_PLUS] = ACTIONS(5376),
    [anon_sym_DOT] = ACTIONS(5374),
    [anon_sym_DOT_STAR] = ACTIONS(5376),
    [anon_sym_DASH_GT] = ACTIONS(5376),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5374),
    [anon_sym_decltype] = ACTIONS(5374),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5376),
  },
  [2458] = {
    [sym_identifier] = ACTIONS(5374),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5376),
    [anon_sym_COMMA] = ACTIONS(5376),
    [anon_sym_RPAREN] = ACTIONS(5376),
    [aux_sym_preproc_if_token2] = ACTIONS(5376),
    [aux_sym_preproc_else_token1] = ACTIONS(5376),
    [aux_sym_preproc_elif_token1] = ACTIONS(5374),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5376),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5376),
    [anon_sym_LPAREN2] = ACTIONS(5376),
    [anon_sym_DASH] = ACTIONS(5374),
    [anon_sym_PLUS] = ACTIONS(5374),
    [anon_sym_STAR] = ACTIONS(5374),
    [anon_sym_SLASH] = ACTIONS(5374),
    [anon_sym_PERCENT] = ACTIONS(5374),
    [anon_sym_PIPE_PIPE] = ACTIONS(5376),
    [anon_sym_AMP_AMP] = ACTIONS(5376),
    [anon_sym_PIPE] = ACTIONS(5374),
    [anon_sym_CARET] = ACTIONS(5374),
    [anon_sym_AMP] = ACTIONS(5374),
    [anon_sym_EQ_EQ] = ACTIONS(5376),
    [anon_sym_BANG_EQ] = ACTIONS(5376),
    [anon_sym_GT] = ACTIONS(5374),
    [anon_sym_GT_EQ] = ACTIONS(5376),
    [anon_sym_LT_EQ] = ACTIONS(5374),
    [anon_sym_LT] = ACTIONS(5374),
    [anon_sym_LT_LT] = ACTIONS(5374),
    [anon_sym_GT_GT] = ACTIONS(5374),
    [anon_sym_SEMI] = ACTIONS(5376),
    [anon_sym___attribute__] = ACTIONS(5374),
    [anon_sym_LBRACE] = ACTIONS(5376),
    [anon_sym_RBRACE] = ACTIONS(5376),
    [anon_sym_LBRACK] = ACTIONS(5376),
    [anon_sym_RBRACK] = ACTIONS(5376),
    [anon_sym_EQ] = ACTIONS(5374),
    [anon_sym_COLON] = ACTIONS(5376),
    [anon_sym_QMARK] = ACTIONS(5376),
    [anon_sym_STAR_EQ] = ACTIONS(5376),
    [anon_sym_SLASH_EQ] = ACTIONS(5376),
    [anon_sym_PERCENT_EQ] = ACTIONS(5376),
    [anon_sym_PLUS_EQ] = ACTIONS(5376),
    [anon_sym_DASH_EQ] = ACTIONS(5376),
    [anon_sym_LT_LT_EQ] = ACTIONS(5376),
    [anon_sym_GT_GT_EQ] = ACTIONS(5376),
    [anon_sym_AMP_EQ] = ACTIONS(5376),
    [anon_sym_CARET_EQ] = ACTIONS(5376),
    [anon_sym_PIPE_EQ] = ACTIONS(5376),
    [anon_sym_and_eq] = ACTIONS(5374),
    [anon_sym_or_eq] = ACTIONS(5374),
    [anon_sym_xor_eq] = ACTIONS(5374),
    [anon_sym_LT_EQ_GT] = ACTIONS(5376),
    [anon_sym_or] = ACTIONS(5374),
    [anon_sym_and] = ACTIONS(5374),
    [anon_sym_bitor] = ACTIONS(5374),
    [anon_sym_xor] = ACTIONS(5374),
    [anon_sym_bitand] = ACTIONS(5374),
    [anon_sym_not_eq] = ACTIONS(5374),
    [anon_sym_DASH_DASH] = ACTIONS(5376),
    [anon_sym_PLUS_PLUS] = ACTIONS(5376),
    [anon_sym_DOT] = ACTIONS(5374),
    [anon_sym_DOT_STAR] = ACTIONS(5376),
    [anon_sym_DASH_GT] = ACTIONS(5376),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5374),
    [anon_sym_decltype] = ACTIONS(5374),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5376),
  },
  [2459] = {
    [sym_attribute_specifier] = STATE(2555),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5656),
    [anon_sym_COMMA] = ACTIONS(5656),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_DASH] = ACTIONS(5658),
    [anon_sym_PLUS] = ACTIONS(5658),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_SLASH] = ACTIONS(5658),
    [anon_sym_PERCENT] = ACTIONS(5656),
    [anon_sym_PIPE_PIPE] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_PIPE] = ACTIONS(5658),
    [anon_sym_CARET] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_EQ_EQ] = ACTIONS(5656),
    [anon_sym_BANG_EQ] = ACTIONS(5656),
    [anon_sym_GT] = ACTIONS(5658),
    [anon_sym_GT_EQ] = ACTIONS(5658),
    [anon_sym_LT_EQ] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5658),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym___extension__] = ACTIONS(5656),
    [anon_sym___global__] = ACTIONS(5656),
    [anon_sym___attribute__] = ACTIONS(5652),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [anon_sym_const] = ACTIONS(5658),
    [anon_sym_constexpr] = ACTIONS(5656),
    [anon_sym_volatile] = ACTIONS(5656),
    [anon_sym_restrict] = ACTIONS(5656),
    [anon_sym___restrict__] = ACTIONS(5656),
    [anon_sym__Atomic] = ACTIONS(5656),
    [anon_sym__Noreturn] = ACTIONS(5656),
    [anon_sym_noreturn] = ACTIONS(5656),
    [anon_sym_mutable] = ACTIONS(5656),
    [anon_sym_constinit] = ACTIONS(5656),
    [anon_sym_consteval] = ACTIONS(5656),
    [anon_sym___shared__] = ACTIONS(5656),
    [anon_sym___local__] = ACTIONS(5656),
    [anon_sym___constant__] = ACTIONS(5656),
    [anon_sym___managed__] = ACTIONS(5656),
    [anon_sym___grid_constant__] = ACTIONS(5656),
    [anon_sym_alignas] = ACTIONS(5656),
    [anon_sym__Alignas] = ACTIONS(5656),
    [anon_sym_QMARK] = ACTIONS(5656),
    [anon_sym_LT_EQ_GT] = ACTIONS(5656),
    [anon_sym_or] = ACTIONS(5656),
    [anon_sym_and] = ACTIONS(5656),
    [anon_sym_bitor] = ACTIONS(5656),
    [anon_sym_xor] = ACTIONS(5656),
    [anon_sym_bitand] = ACTIONS(5656),
    [anon_sym_not_eq] = ACTIONS(5656),
    [anon_sym_DASH_DASH] = ACTIONS(5656),
    [anon_sym_PLUS_PLUS] = ACTIONS(5656),
    [anon_sym_DOT] = ACTIONS(5658),
    [anon_sym_DOT_STAR] = ACTIONS(5656),
    [anon_sym_DASH_GT] = ACTIONS(5656),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5656),
    [anon_sym_decltype] = ACTIONS(5656),
    [anon_sym_final] = ACTIONS(5656),
    [anon_sym_override] = ACTIONS(5656),
    [anon_sym_GT2] = ACTIONS(5656),
    [anon_sym_requires] = ACTIONS(5656),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5656),
  },
  [2460] = {
    [sym_identifier] = ACTIONS(5277),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5279),
    [anon_sym_COMMA] = ACTIONS(5279),
    [anon_sym_RPAREN] = ACTIONS(5279),
    [aux_sym_preproc_if_token2] = ACTIONS(5279),
    [aux_sym_preproc_else_token1] = ACTIONS(5279),
    [aux_sym_preproc_elif_token1] = ACTIONS(5277),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5279),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5279),
    [anon_sym_LPAREN2] = ACTIONS(5279),
    [anon_sym_DASH] = ACTIONS(5277),
    [anon_sym_PLUS] = ACTIONS(5277),
    [anon_sym_STAR] = ACTIONS(5277),
    [anon_sym_SLASH] = ACTIONS(5277),
    [anon_sym_PERCENT] = ACTIONS(5277),
    [anon_sym_PIPE_PIPE] = ACTIONS(5279),
    [anon_sym_AMP_AMP] = ACTIONS(5279),
    [anon_sym_PIPE] = ACTIONS(5277),
    [anon_sym_CARET] = ACTIONS(5277),
    [anon_sym_AMP] = ACTIONS(5277),
    [anon_sym_EQ_EQ] = ACTIONS(5279),
    [anon_sym_BANG_EQ] = ACTIONS(5279),
    [anon_sym_GT] = ACTIONS(5277),
    [anon_sym_GT_EQ] = ACTIONS(5279),
    [anon_sym_LT_EQ] = ACTIONS(5277),
    [anon_sym_LT] = ACTIONS(5277),
    [anon_sym_LT_LT] = ACTIONS(5277),
    [anon_sym_GT_GT] = ACTIONS(5277),
    [anon_sym_SEMI] = ACTIONS(5279),
    [anon_sym___attribute__] = ACTIONS(5277),
    [anon_sym_LBRACE] = ACTIONS(5279),
    [anon_sym_RBRACE] = ACTIONS(5279),
    [anon_sym_LBRACK] = ACTIONS(5279),
    [anon_sym_RBRACK] = ACTIONS(5279),
    [anon_sym_EQ] = ACTIONS(5277),
    [anon_sym_COLON] = ACTIONS(5279),
    [anon_sym_QMARK] = ACTIONS(5279),
    [anon_sym_STAR_EQ] = ACTIONS(5279),
    [anon_sym_SLASH_EQ] = ACTIONS(5279),
    [anon_sym_PERCENT_EQ] = ACTIONS(5279),
    [anon_sym_PLUS_EQ] = ACTIONS(5279),
    [anon_sym_DASH_EQ] = ACTIONS(5279),
    [anon_sym_LT_LT_EQ] = ACTIONS(5279),
    [anon_sym_GT_GT_EQ] = ACTIONS(5279),
    [anon_sym_AMP_EQ] = ACTIONS(5279),
    [anon_sym_CARET_EQ] = ACTIONS(5279),
    [anon_sym_PIPE_EQ] = ACTIONS(5279),
    [anon_sym_and_eq] = ACTIONS(5277),
    [anon_sym_or_eq] = ACTIONS(5277),
    [anon_sym_xor_eq] = ACTIONS(5277),
    [anon_sym_LT_EQ_GT] = ACTIONS(5279),
    [anon_sym_or] = ACTIONS(5277),
    [anon_sym_and] = ACTIONS(5277),
    [anon_sym_bitor] = ACTIONS(5277),
    [anon_sym_xor] = ACTIONS(5277),
    [anon_sym_bitand] = ACTIONS(5277),
    [anon_sym_not_eq] = ACTIONS(5277),
    [anon_sym_DASH_DASH] = ACTIONS(5279),
    [anon_sym_PLUS_PLUS] = ACTIONS(5279),
    [anon_sym_DOT] = ACTIONS(5277),
    [anon_sym_DOT_STAR] = ACTIONS(5279),
    [anon_sym_DASH_GT] = ACTIONS(5279),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5277),
    [anon_sym_decltype] = ACTIONS(5277),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5279),
  },
  [2461] = {
    [sym_identifier] = ACTIONS(5462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5464),
    [anon_sym_COMMA] = ACTIONS(5464),
    [anon_sym_LPAREN2] = ACTIONS(5464),
    [anon_sym_DASH] = ACTIONS(5462),
    [anon_sym_PLUS] = ACTIONS(5462),
    [anon_sym_STAR] = ACTIONS(5462),
    [anon_sym_SLASH] = ACTIONS(5462),
    [anon_sym_PERCENT] = ACTIONS(5462),
    [anon_sym_PIPE_PIPE] = ACTIONS(5464),
    [anon_sym_AMP_AMP] = ACTIONS(5464),
    [anon_sym_PIPE] = ACTIONS(5462),
    [anon_sym_CARET] = ACTIONS(5462),
    [anon_sym_AMP] = ACTIONS(5462),
    [anon_sym_EQ_EQ] = ACTIONS(5464),
    [anon_sym_BANG_EQ] = ACTIONS(5464),
    [anon_sym_GT] = ACTIONS(5462),
    [anon_sym_GT_EQ] = ACTIONS(5464),
    [anon_sym_LT_EQ] = ACTIONS(5462),
    [anon_sym_LT] = ACTIONS(5462),
    [anon_sym_LT_LT] = ACTIONS(5462),
    [anon_sym_GT_GT] = ACTIONS(5462),
    [anon_sym_SEMI] = ACTIONS(5464),
    [anon_sym___attribute__] = ACTIONS(5462),
    [anon_sym_LBRACK] = ACTIONS(5464),
    [anon_sym_EQ] = ACTIONS(5462),
    [anon_sym_QMARK] = ACTIONS(5464),
    [anon_sym_STAR_EQ] = ACTIONS(5464),
    [anon_sym_SLASH_EQ] = ACTIONS(5464),
    [anon_sym_PERCENT_EQ] = ACTIONS(5464),
    [anon_sym_PLUS_EQ] = ACTIONS(5464),
    [anon_sym_DASH_EQ] = ACTIONS(5464),
    [anon_sym_LT_LT_EQ] = ACTIONS(5464),
    [anon_sym_GT_GT_EQ] = ACTIONS(5464),
    [anon_sym_AMP_EQ] = ACTIONS(5464),
    [anon_sym_CARET_EQ] = ACTIONS(5464),
    [anon_sym_PIPE_EQ] = ACTIONS(5464),
    [anon_sym_and_eq] = ACTIONS(5462),
    [anon_sym_or_eq] = ACTIONS(5462),
    [anon_sym_xor_eq] = ACTIONS(5462),
    [anon_sym_LT_EQ_GT] = ACTIONS(5464),
    [anon_sym_or] = ACTIONS(5462),
    [anon_sym_and] = ACTIONS(5462),
    [anon_sym_bitor] = ACTIONS(5462),
    [anon_sym_xor] = ACTIONS(5462),
    [anon_sym_bitand] = ACTIONS(5462),
    [anon_sym_not_eq] = ACTIONS(5462),
    [anon_sym_DASH_DASH] = ACTIONS(5464),
    [anon_sym_PLUS_PLUS] = ACTIONS(5464),
    [anon_sym_DOT] = ACTIONS(5462),
    [anon_sym_DOT_STAR] = ACTIONS(5464),
    [anon_sym_DASH_GT] = ACTIONS(5464),
    [anon_sym_L_DQUOTE] = ACTIONS(5464),
    [anon_sym_u_DQUOTE] = ACTIONS(5464),
    [anon_sym_U_DQUOTE] = ACTIONS(5464),
    [anon_sym_u8_DQUOTE] = ACTIONS(5464),
    [anon_sym_DQUOTE] = ACTIONS(5464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5464),
    [anon_sym_LR_DQUOTE] = ACTIONS(5464),
    [anon_sym_uR_DQUOTE] = ACTIONS(5464),
    [anon_sym_UR_DQUOTE] = ACTIONS(5464),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5464),
    [sym_literal_suffix] = ACTIONS(5462),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5464),
  },
  [2462] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5422),
    [anon_sym_COMMA] = ACTIONS(5422),
    [anon_sym_RPAREN] = ACTIONS(5422),
    [anon_sym_LPAREN2] = ACTIONS(5422),
    [anon_sym_DASH] = ACTIONS(5424),
    [anon_sym_PLUS] = ACTIONS(5424),
    [anon_sym_STAR] = ACTIONS(5424),
    [anon_sym_SLASH] = ACTIONS(5424),
    [anon_sym_PERCENT] = ACTIONS(5424),
    [anon_sym_PIPE_PIPE] = ACTIONS(5422),
    [anon_sym_AMP_AMP] = ACTIONS(5422),
    [anon_sym_PIPE] = ACTIONS(5424),
    [anon_sym_CARET] = ACTIONS(5424),
    [anon_sym_AMP] = ACTIONS(5424),
    [anon_sym_EQ_EQ] = ACTIONS(5422),
    [anon_sym_BANG_EQ] = ACTIONS(5422),
    [anon_sym_GT] = ACTIONS(5424),
    [anon_sym_GT_EQ] = ACTIONS(5422),
    [anon_sym_LT_EQ] = ACTIONS(5424),
    [anon_sym_LT] = ACTIONS(5424),
    [anon_sym_LT_LT] = ACTIONS(5424),
    [anon_sym_GT_GT] = ACTIONS(5424),
    [anon_sym_SEMI] = ACTIONS(5422),
    [anon_sym___attribute__] = ACTIONS(5422),
    [anon_sym_LBRACE] = ACTIONS(5422),
    [anon_sym_RBRACE] = ACTIONS(5422),
    [anon_sym_signed] = ACTIONS(6034),
    [anon_sym_unsigned] = ACTIONS(6034),
    [anon_sym_long] = ACTIONS(6034),
    [anon_sym_short] = ACTIONS(6034),
    [anon_sym_LBRACK] = ACTIONS(5422),
    [anon_sym_RBRACK] = ACTIONS(5422),
    [anon_sym_EQ] = ACTIONS(5424),
    [anon_sym_COLON] = ACTIONS(5422),
    [anon_sym_QMARK] = ACTIONS(5422),
    [anon_sym_STAR_EQ] = ACTIONS(5422),
    [anon_sym_SLASH_EQ] = ACTIONS(5422),
    [anon_sym_PERCENT_EQ] = ACTIONS(5422),
    [anon_sym_PLUS_EQ] = ACTIONS(5422),
    [anon_sym_DASH_EQ] = ACTIONS(5422),
    [anon_sym_LT_LT_EQ] = ACTIONS(5422),
    [anon_sym_GT_GT_EQ] = ACTIONS(5422),
    [anon_sym_AMP_EQ] = ACTIONS(5422),
    [anon_sym_CARET_EQ] = ACTIONS(5422),
    [anon_sym_PIPE_EQ] = ACTIONS(5422),
    [anon_sym_and_eq] = ACTIONS(5422),
    [anon_sym_or_eq] = ACTIONS(5422),
    [anon_sym_xor_eq] = ACTIONS(5422),
    [anon_sym_LT_EQ_GT] = ACTIONS(5422),
    [anon_sym_or] = ACTIONS(5424),
    [anon_sym_and] = ACTIONS(5424),
    [anon_sym_bitor] = ACTIONS(5422),
    [anon_sym_xor] = ACTIONS(5424),
    [anon_sym_bitand] = ACTIONS(5422),
    [anon_sym_not_eq] = ACTIONS(5422),
    [anon_sym_DASH_DASH] = ACTIONS(5422),
    [anon_sym_PLUS_PLUS] = ACTIONS(5422),
    [anon_sym_DOT] = ACTIONS(5424),
    [anon_sym_DOT_STAR] = ACTIONS(5422),
    [anon_sym_DASH_GT] = ACTIONS(5422),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5422),
    [anon_sym_decltype] = ACTIONS(5422),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5422),
  },
  [2463] = {
    [sym_string_literal] = STATE(2336),
    [sym_raw_string_literal] = STATE(2336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5712),
    [anon_sym_COMMA] = ACTIONS(5712),
    [anon_sym_LPAREN2] = ACTIONS(5712),
    [anon_sym_DASH] = ACTIONS(5710),
    [anon_sym_PLUS] = ACTIONS(5710),
    [anon_sym_STAR] = ACTIONS(5710),
    [anon_sym_SLASH] = ACTIONS(5710),
    [anon_sym_PERCENT] = ACTIONS(5710),
    [anon_sym_PIPE_PIPE] = ACTIONS(5712),
    [anon_sym_AMP_AMP] = ACTIONS(5712),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_CARET] = ACTIONS(5710),
    [anon_sym_AMP] = ACTIONS(5710),
    [anon_sym_EQ_EQ] = ACTIONS(5712),
    [anon_sym_BANG_EQ] = ACTIONS(5712),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_EQ] = ACTIONS(5710),
    [anon_sym_LT_EQ] = ACTIONS(5710),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5710),
    [anon_sym_LBRACK] = ACTIONS(5712),
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_QMARK] = ACTIONS(5712),
    [anon_sym_STAR_EQ] = ACTIONS(5712),
    [anon_sym_SLASH_EQ] = ACTIONS(5712),
    [anon_sym_PERCENT_EQ] = ACTIONS(5712),
    [anon_sym_PLUS_EQ] = ACTIONS(5712),
    [anon_sym_DASH_EQ] = ACTIONS(5712),
    [anon_sym_LT_LT_EQ] = ACTIONS(5712),
    [anon_sym_GT_GT_EQ] = ACTIONS(5710),
    [anon_sym_AMP_EQ] = ACTIONS(5712),
    [anon_sym_CARET_EQ] = ACTIONS(5712),
    [anon_sym_PIPE_EQ] = ACTIONS(5712),
    [anon_sym_and_eq] = ACTIONS(5710),
    [anon_sym_or_eq] = ACTIONS(5710),
    [anon_sym_xor_eq] = ACTIONS(5710),
    [anon_sym_LT_EQ_GT] = ACTIONS(5712),
    [anon_sym_or] = ACTIONS(5710),
    [anon_sym_and] = ACTIONS(5710),
    [anon_sym_bitor] = ACTIONS(5710),
    [anon_sym_xor] = ACTIONS(5710),
    [anon_sym_bitand] = ACTIONS(5710),
    [anon_sym_not_eq] = ACTIONS(5710),
    [anon_sym_DASH_DASH] = ACTIONS(5712),
    [anon_sym_PLUS_PLUS] = ACTIONS(5712),
    [anon_sym_DOT] = ACTIONS(5710),
    [anon_sym_DOT_STAR] = ACTIONS(5712),
    [anon_sym_DASH_GT] = ACTIONS(5712),
    [anon_sym_L_DQUOTE] = ACTIONS(5893),
    [anon_sym_u_DQUOTE] = ACTIONS(5893),
    [anon_sym_U_DQUOTE] = ACTIONS(5893),
    [anon_sym_u8_DQUOTE] = ACTIONS(5893),
    [anon_sym_DQUOTE] = ACTIONS(5893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(5712),
    [anon_sym_R_DQUOTE] = ACTIONS(5895),
    [anon_sym_LR_DQUOTE] = ACTIONS(5895),
    [anon_sym_uR_DQUOTE] = ACTIONS(5895),
    [anon_sym_UR_DQUOTE] = ACTIONS(5895),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5895),
    [sym_literal_suffix] = ACTIONS(6036),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5712),
  },
  [2464] = {
    [sym_new_declarator] = STATE(2542),
    [sym_identifier] = ACTIONS(6038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6040),
    [anon_sym_COMMA] = ACTIONS(6040),
    [anon_sym_RPAREN] = ACTIONS(6040),
    [aux_sym_preproc_if_token2] = ACTIONS(6040),
    [aux_sym_preproc_else_token1] = ACTIONS(6040),
    [aux_sym_preproc_elif_token1] = ACTIONS(6038),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6040),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6040),
    [anon_sym_LPAREN2] = ACTIONS(6040),
    [anon_sym_DASH] = ACTIONS(6038),
    [anon_sym_PLUS] = ACTIONS(6038),
    [anon_sym_STAR] = ACTIONS(6038),
    [anon_sym_SLASH] = ACTIONS(6038),
    [anon_sym_PERCENT] = ACTIONS(6038),
    [anon_sym_PIPE_PIPE] = ACTIONS(6040),
    [anon_sym_AMP_AMP] = ACTIONS(6040),
    [anon_sym_PIPE] = ACTIONS(6038),
    [anon_sym_CARET] = ACTIONS(6038),
    [anon_sym_AMP] = ACTIONS(6038),
    [anon_sym_EQ_EQ] = ACTIONS(6040),
    [anon_sym_BANG_EQ] = ACTIONS(6040),
    [anon_sym_GT] = ACTIONS(6038),
    [anon_sym_GT_EQ] = ACTIONS(6040),
    [anon_sym_LT_EQ] = ACTIONS(6038),
    [anon_sym_LT] = ACTIONS(6038),
    [anon_sym_LT_LT] = ACTIONS(6038),
    [anon_sym_GT_GT] = ACTIONS(6038),
    [anon_sym_SEMI] = ACTIONS(6040),
    [anon_sym___attribute__] = ACTIONS(6038),
    [anon_sym_LBRACE] = ACTIONS(6040),
    [anon_sym_RBRACE] = ACTIONS(6040),
    [anon_sym_LBRACK] = ACTIONS(5646),
    [anon_sym_RBRACK] = ACTIONS(6040),
    [anon_sym_EQ] = ACTIONS(6038),
    [anon_sym_COLON] = ACTIONS(6040),
    [anon_sym_QMARK] = ACTIONS(6040),
    [anon_sym_STAR_EQ] = ACTIONS(6040),
    [anon_sym_SLASH_EQ] = ACTIONS(6040),
    [anon_sym_PERCENT_EQ] = ACTIONS(6040),
    [anon_sym_PLUS_EQ] = ACTIONS(6040),
    [anon_sym_DASH_EQ] = ACTIONS(6040),
    [anon_sym_LT_LT_EQ] = ACTIONS(6040),
    [anon_sym_GT_GT_EQ] = ACTIONS(6040),
    [anon_sym_AMP_EQ] = ACTIONS(6040),
    [anon_sym_CARET_EQ] = ACTIONS(6040),
    [anon_sym_PIPE_EQ] = ACTIONS(6040),
    [anon_sym_and_eq] = ACTIONS(6038),
    [anon_sym_or_eq] = ACTIONS(6038),
    [anon_sym_xor_eq] = ACTIONS(6038),
    [anon_sym_LT_EQ_GT] = ACTIONS(6040),
    [anon_sym_or] = ACTIONS(6038),
    [anon_sym_and] = ACTIONS(6038),
    [anon_sym_bitor] = ACTIONS(6038),
    [anon_sym_xor] = ACTIONS(6038),
    [anon_sym_bitand] = ACTIONS(6038),
    [anon_sym_not_eq] = ACTIONS(6038),
    [anon_sym_DASH_DASH] = ACTIONS(6040),
    [anon_sym_PLUS_PLUS] = ACTIONS(6040),
    [anon_sym_DOT] = ACTIONS(6038),
    [anon_sym_DOT_STAR] = ACTIONS(6040),
    [anon_sym_DASH_GT] = ACTIONS(6040),
    [sym_comment] = ACTIONS(3),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(6040),
  },
  [2465] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5220),
    [anon_sym_COMMA] = ACTIONS(5220),
    [anon_sym_LPAREN2] = ACTIONS(5220),
    [anon_sym_DASH] = ACTIONS(5218),
    [anon_sym_PLUS] = ACTIONS(5218),
    [anon_sym_STAR] = ACTIONS(5220),
    [anon_sym_SLASH] = ACTIONS(5218),
    [anon_sym_PERCENT] = ACTIONS(5220),
    [anon_sym_PIPE_PIPE] = ACTIONS(5220),
    [anon_sym_AMP_AMP] = ACTIONS(5220),
    [anon_sym_PIPE] = ACTIONS(5218),
    [anon_sym_CARET] = ACTIONS(5220),
    [anon_sym_AMP] = ACTIONS(5218),
    [anon_sym_EQ_EQ] = ACTIONS(5220),
    [anon_sym_BANG_EQ] = ACTIONS(5220),
    [anon_sym_GT] = ACTIONS(5218),
    [anon_sym_GT_EQ] = ACTIONS(5218),
    [anon_sym_LT_EQ] = ACTIONS(5218),
    [anon_sym_LT] = ACTIONS(5218),
    [anon_sym_LT_LT] = ACTIONS(5218),
    [anon_sym_GT_GT] = ACTIONS(5218),
    [anon_sym___extension__] = ACTIONS(5220),
    [anon_sym___global__] = ACTIONS(5220),
    [anon_sym___attribute__] = ACTIONS(5220),
    [anon_sym_LBRACE] = ACTIONS(5220),
    [anon_sym_LBRACK] = ACTIONS(5220),
    [anon_sym_const] = ACTIONS(5218),
    [anon_sym_constexpr] = ACTIONS(5220),
    [anon_sym_volatile] = ACTIONS(5220),
    [anon_sym_restrict] = ACTIONS(5220),
    [anon_sym___restrict__] = ACTIONS(5220),
    [anon_sym__Atomic] = ACTIONS(5220),
    [anon_sym__Noreturn] = ACTIONS(5220),
    [anon_sym_noreturn] = ACTIONS(5220),
    [anon_sym_mutable] = ACTIONS(5220),
    [anon_sym_constinit] = ACTIONS(5220),
    [anon_sym_consteval] = ACTIONS(5220),
    [anon_sym___shared__] = ACTIONS(5220),
    [anon_sym___local__] = ACTIONS(5220),
    [anon_sym___constant__] = ACTIONS(5220),
    [anon_sym___managed__] = ACTIONS(5220),
    [anon_sym___grid_constant__] = ACTIONS(5220),
    [anon_sym_alignas] = ACTIONS(5220),
    [anon_sym__Alignas] = ACTIONS(5220),
    [anon_sym_QMARK] = ACTIONS(5220),
    [anon_sym_LT_EQ_GT] = ACTIONS(5220),
    [anon_sym_or] = ACTIONS(5220),
    [anon_sym_and] = ACTIONS(5220),
    [anon_sym_bitor] = ACTIONS(5220),
    [anon_sym_xor] = ACTIONS(5220),
    [anon_sym_bitand] = ACTIONS(5220),
    [anon_sym_not_eq] = ACTIONS(5220),
    [anon_sym_DASH_DASH] = ACTIONS(5220),
    [anon_sym_PLUS_PLUS] = ACTIONS(5220),
    [anon_sym_DOT] = ACTIONS(5218),
    [anon_sym_DOT_STAR] = ACTIONS(5220),
    [anon_sym_DASH_GT] = ACTIONS(5220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5220),
    [anon_sym_decltype] = ACTIONS(5220),
    [anon_sym_final] = ACTIONS(5220),
    [anon_sym_override] = ACTIONS(5220),
    [anon_sym_GT2] = ACTIONS(5220),
    [anon_sym_requires] = ACTIONS(5220),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5220),
  },
  [2466] = {
    [sym_identifier] = ACTIONS(5462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5464),
    [anon_sym_COMMA] = ACTIONS(5464),
    [anon_sym_RPAREN] = ACTIONS(5464),
    [anon_sym_LPAREN2] = ACTIONS(5464),
    [anon_sym_DASH] = ACTIONS(5462),
    [anon_sym_PLUS] = ACTIONS(5462),
    [anon_sym_STAR] = ACTIONS(5462),
    [anon_sym_SLASH] = ACTIONS(5462),
    [anon_sym_PERCENT] = ACTIONS(5462),
    [anon_sym_PIPE_PIPE] = ACTIONS(5464),
    [anon_sym_AMP_AMP] = ACTIONS(5464),
    [anon_sym_PIPE] = ACTIONS(5462),
    [anon_sym_CARET] = ACTIONS(5462),
    [anon_sym_AMP] = ACTIONS(5462),
    [anon_sym_EQ_EQ] = ACTIONS(5464),
    [anon_sym_BANG_EQ] = ACTIONS(5464),
    [anon_sym_GT] = ACTIONS(5462),
    [anon_sym_GT_EQ] = ACTIONS(5464),
    [anon_sym_LT_EQ] = ACTIONS(5462),
    [anon_sym_LT] = ACTIONS(5462),
    [anon_sym_LT_LT] = ACTIONS(5462),
    [anon_sym_GT_GT] = ACTIONS(5462),
    [anon_sym_LBRACK] = ACTIONS(5464),
    [anon_sym_EQ] = ACTIONS(5462),
    [anon_sym_QMARK] = ACTIONS(5464),
    [anon_sym_STAR_EQ] = ACTIONS(5464),
    [anon_sym_SLASH_EQ] = ACTIONS(5464),
    [anon_sym_PERCENT_EQ] = ACTIONS(5464),
    [anon_sym_PLUS_EQ] = ACTIONS(5464),
    [anon_sym_DASH_EQ] = ACTIONS(5464),
    [anon_sym_LT_LT_EQ] = ACTIONS(5464),
    [anon_sym_GT_GT_EQ] = ACTIONS(5464),
    [anon_sym_AMP_EQ] = ACTIONS(5464),
    [anon_sym_CARET_EQ] = ACTIONS(5464),
    [anon_sym_PIPE_EQ] = ACTIONS(5464),
    [anon_sym_and_eq] = ACTIONS(5462),
    [anon_sym_or_eq] = ACTIONS(5462),
    [anon_sym_xor_eq] = ACTIONS(5462),
    [anon_sym_LT_EQ_GT] = ACTIONS(5464),
    [anon_sym_or] = ACTIONS(5462),
    [anon_sym_and] = ACTIONS(5462),
    [anon_sym_bitor] = ACTIONS(5462),
    [anon_sym_xor] = ACTIONS(5462),
    [anon_sym_bitand] = ACTIONS(5462),
    [anon_sym_not_eq] = ACTIONS(5462),
    [anon_sym_DASH_DASH] = ACTIONS(5464),
    [anon_sym_PLUS_PLUS] = ACTIONS(5464),
    [anon_sym_DOT] = ACTIONS(5462),
    [anon_sym_DOT_STAR] = ACTIONS(5464),
    [anon_sym_DASH_GT] = ACTIONS(5462),
    [anon_sym_L_DQUOTE] = ACTIONS(5464),
    [anon_sym_u_DQUOTE] = ACTIONS(5464),
    [anon_sym_U_DQUOTE] = ACTIONS(5464),
    [anon_sym_u8_DQUOTE] = ACTIONS(5464),
    [anon_sym_DQUOTE] = ACTIONS(5464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5464),
    [anon_sym_LR_DQUOTE] = ACTIONS(5464),
    [anon_sym_uR_DQUOTE] = ACTIONS(5464),
    [anon_sym_UR_DQUOTE] = ACTIONS(5464),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5464),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5464),
    [sym_literal_suffix] = ACTIONS(5462),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5464),
  },
  [2467] = {
    [sym_attribute_specifier] = STATE(2411),
    [sym_enumerator_list] = STATE(2372),
    [sym__enum_base_clause] = STATE(2292),
    [sym_identifier] = ACTIONS(6042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6044),
    [anon_sym_COMMA] = ACTIONS(6044),
    [aux_sym_preproc_if_token2] = ACTIONS(6044),
    [aux_sym_preproc_else_token1] = ACTIONS(6044),
    [aux_sym_preproc_elif_token1] = ACTIONS(6042),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6044),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6044),
    [anon_sym_LPAREN2] = ACTIONS(6044),
    [anon_sym_DASH] = ACTIONS(6042),
    [anon_sym_PLUS] = ACTIONS(6042),
    [anon_sym_STAR] = ACTIONS(6042),
    [anon_sym_SLASH] = ACTIONS(6042),
    [anon_sym_PERCENT] = ACTIONS(6042),
    [anon_sym_PIPE_PIPE] = ACTIONS(6044),
    [anon_sym_AMP_AMP] = ACTIONS(6044),
    [anon_sym_PIPE] = ACTIONS(6042),
    [anon_sym_CARET] = ACTIONS(6042),
    [anon_sym_AMP] = ACTIONS(6042),
    [anon_sym_EQ_EQ] = ACTIONS(6044),
    [anon_sym_BANG_EQ] = ACTIONS(6044),
    [anon_sym_GT] = ACTIONS(6042),
    [anon_sym_GT_EQ] = ACTIONS(6044),
    [anon_sym_LT_EQ] = ACTIONS(6042),
    [anon_sym_LT] = ACTIONS(6042),
    [anon_sym_LT_LT] = ACTIONS(6042),
    [anon_sym_GT_GT] = ACTIONS(6042),
    [anon_sym___attribute__] = ACTIONS(5546),
    [anon_sym_LBRACE] = ACTIONS(5772),
    [anon_sym_LBRACK] = ACTIONS(6044),
    [anon_sym_EQ] = ACTIONS(6042),
    [anon_sym_COLON] = ACTIONS(6046),
    [anon_sym_QMARK] = ACTIONS(6044),
    [anon_sym_STAR_EQ] = ACTIONS(6044),
    [anon_sym_SLASH_EQ] = ACTIONS(6044),
    [anon_sym_PERCENT_EQ] = ACTIONS(6044),
    [anon_sym_PLUS_EQ] = ACTIONS(6044),
    [anon_sym_DASH_EQ] = ACTIONS(6044),
    [anon_sym_LT_LT_EQ] = ACTIONS(6044),
    [anon_sym_GT_GT_EQ] = ACTIONS(6044),
    [anon_sym_AMP_EQ] = ACTIONS(6044),
    [anon_sym_CARET_EQ] = ACTIONS(6044),
    [anon_sym_PIPE_EQ] = ACTIONS(6044),
    [anon_sym_and_eq] = ACTIONS(6042),
    [anon_sym_or_eq] = ACTIONS(6042),
    [anon_sym_xor_eq] = ACTIONS(6042),
    [anon_sym_LT_EQ_GT] = ACTIONS(6044),
    [anon_sym_or] = ACTIONS(6042),
    [anon_sym_and] = ACTIONS(6042),
    [anon_sym_bitor] = ACTIONS(6042),
    [anon_sym_xor] = ACTIONS(6042),
    [anon_sym_bitand] = ACTIONS(6042),
    [anon_sym_not_eq] = ACTIONS(6042),
    [anon_sym_DASH_DASH] = ACTIONS(6044),
    [anon_sym_PLUS_PLUS] = ACTIONS(6044),
    [anon_sym_DOT] = ACTIONS(6042),
    [anon_sym_DOT_STAR] = ACTIONS(6044),
    [anon_sym_DASH_GT] = ACTIONS(6044),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6042),
    [anon_sym_decltype] = ACTIONS(6042),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(6044),
  },
  [2468] = {
    [sym_attribute_specifier] = STATE(2187),
    [sym_identifier] = ACTIONS(5635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5633),
    [anon_sym_COMMA] = ACTIONS(5633),
    [anon_sym_RPAREN] = ACTIONS(5633),
    [anon_sym_LPAREN2] = ACTIONS(5633),
    [anon_sym_TILDE] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5633),
    [anon_sym_AMP_AMP] = ACTIONS(5633),
    [anon_sym_AMP] = ACTIONS(5635),
    [anon_sym_SEMI] = ACTIONS(5633),
    [anon_sym___extension__] = ACTIONS(5635),
    [anon_sym___device__] = ACTIONS(5635),
    [anon_sym___host__] = ACTIONS(5635),
    [anon_sym___global__] = ACTIONS(5635),
    [anon_sym___forceinline__] = ACTIONS(5635),
    [anon_sym___noinline__] = ACTIONS(5635),
    [anon_sym_extern] = ACTIONS(5635),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5633),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5633),
    [anon_sym___declspec] = ACTIONS(5635),
    [anon_sym___based] = ACTIONS(5635),
    [anon_sym___cdecl] = ACTIONS(5635),
    [anon_sym___clrcall] = ACTIONS(5635),
    [anon_sym___stdcall] = ACTIONS(5635),
    [anon_sym___fastcall] = ACTIONS(5635),
    [anon_sym___thiscall] = ACTIONS(5635),
    [anon_sym___vectorcall] = ACTIONS(5635),
    [anon_sym_LBRACK] = ACTIONS(5635),
    [anon_sym_static] = ACTIONS(5635),
    [anon_sym_EQ] = ACTIONS(5633),
    [anon_sym_register] = ACTIONS(5635),
    [anon_sym_inline] = ACTIONS(5635),
    [anon_sym___inline] = ACTIONS(5635),
    [anon_sym___inline__] = ACTIONS(5635),
    [anon_sym___forceinline] = ACTIONS(5635),
    [anon_sym_thread_local] = ACTIONS(5635),
    [anon_sym___thread] = ACTIONS(5635),
    [anon_sym_const] = ACTIONS(5635),
    [anon_sym_constexpr] = ACTIONS(5635),
    [anon_sym_volatile] = ACTIONS(5635),
    [anon_sym_restrict] = ACTIONS(5635),
    [anon_sym___restrict__] = ACTIONS(5635),
    [anon_sym__Atomic] = ACTIONS(5635),
    [anon_sym__Noreturn] = ACTIONS(5635),
    [anon_sym_noreturn] = ACTIONS(5635),
    [anon_sym_mutable] = ACTIONS(5635),
    [anon_sym_constinit] = ACTIONS(5635),
    [anon_sym_consteval] = ACTIONS(5635),
    [anon_sym___shared__] = ACTIONS(5635),
    [anon_sym___local__] = ACTIONS(5635),
    [anon_sym___constant__] = ACTIONS(5635),
    [anon_sym___managed__] = ACTIONS(5635),
    [anon_sym___grid_constant__] = ACTIONS(5635),
    [anon_sym_alignas] = ACTIONS(5635),
    [anon_sym__Alignas] = ACTIONS(5635),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5635),
    [anon_sym_decltype] = ACTIONS(5635),
    [sym_virtual] = ACTIONS(5635),
    [anon_sym_template] = ACTIONS(5635),
    [anon_sym_GT2] = ACTIONS(5633),
    [anon_sym_operator] = ACTIONS(5635),
    [anon_sym___launch_bounds__] = ACTIONS(5635),
  },
  [2469] = {
    [sym_attribute_specifier] = STATE(2391),
    [sym_enumerator_list] = STATE(2317),
    [sym__enum_base_clause] = STATE(2286),
    [sym_identifier] = ACTIONS(6048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6050),
    [anon_sym_COMMA] = ACTIONS(6050),
    [aux_sym_preproc_if_token2] = ACTIONS(6050),
    [aux_sym_preproc_else_token1] = ACTIONS(6050),
    [aux_sym_preproc_elif_token1] = ACTIONS(6048),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6050),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6050),
    [anon_sym_LPAREN2] = ACTIONS(6050),
    [anon_sym_DASH] = ACTIONS(6048),
    [anon_sym_PLUS] = ACTIONS(6048),
    [anon_sym_STAR] = ACTIONS(6048),
    [anon_sym_SLASH] = ACTIONS(6048),
    [anon_sym_PERCENT] = ACTIONS(6048),
    [anon_sym_PIPE_PIPE] = ACTIONS(6050),
    [anon_sym_AMP_AMP] = ACTIONS(6050),
    [anon_sym_PIPE] = ACTIONS(6048),
    [anon_sym_CARET] = ACTIONS(6048),
    [anon_sym_AMP] = ACTIONS(6048),
    [anon_sym_EQ_EQ] = ACTIONS(6050),
    [anon_sym_BANG_EQ] = ACTIONS(6050),
    [anon_sym_GT] = ACTIONS(6048),
    [anon_sym_GT_EQ] = ACTIONS(6050),
    [anon_sym_LT_EQ] = ACTIONS(6048),
    [anon_sym_LT] = ACTIONS(6048),
    [anon_sym_LT_LT] = ACTIONS(6048),
    [anon_sym_GT_GT] = ACTIONS(6048),
    [anon_sym___attribute__] = ACTIONS(5546),
    [anon_sym_LBRACE] = ACTIONS(5772),
    [anon_sym_LBRACK] = ACTIONS(6050),
    [anon_sym_EQ] = ACTIONS(6048),
    [anon_sym_COLON] = ACTIONS(6046),
    [anon_sym_QMARK] = ACTIONS(6050),
    [anon_sym_STAR_EQ] = ACTIONS(6050),
    [anon_sym_SLASH_EQ] = ACTIONS(6050),
    [anon_sym_PERCENT_EQ] = ACTIONS(6050),
    [anon_sym_PLUS_EQ] = ACTIONS(6050),
    [anon_sym_DASH_EQ] = ACTIONS(6050),
    [anon_sym_LT_LT_EQ] = ACTIONS(6050),
    [anon_sym_GT_GT_EQ] = ACTIONS(6050),
    [anon_sym_AMP_EQ] = ACTIONS(6050),
    [anon_sym_CARET_EQ] = ACTIONS(6050),
    [anon_sym_PIPE_EQ] = ACTIONS(6050),
    [anon_sym_and_eq] = ACTIONS(6048),
    [anon_sym_or_eq] = ACTIONS(6048),
    [anon_sym_xor_eq] = ACTIONS(6048),
    [anon_sym_LT_EQ_GT] = ACTIONS(6050),
    [anon_sym_or] = ACTIONS(6048),
    [anon_sym_and] = ACTIONS(6048),
    [anon_sym_bitor] = ACTIONS(6048),
    [anon_sym_xor] = ACTIONS(6048),
    [anon_sym_bitand] = ACTIONS(6048),
    [anon_sym_not_eq] = ACTIONS(6048),
    [anon_sym_DASH_DASH] = ACTIONS(6050),
    [anon_sym_PLUS_PLUS] = ACTIONS(6050),
    [anon_sym_DOT] = ACTIONS(6048),
    [anon_sym_DOT_STAR] = ACTIONS(6050),
    [anon_sym_DASH_GT] = ACTIONS(6050),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6048),
    [anon_sym_decltype] = ACTIONS(6048),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(6050),
  },
  [2470] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1867),
    [sym_identifier] = ACTIONS(5016),
    [anon_sym_COMMA] = ACTIONS(5258),
    [anon_sym_RPAREN] = ACTIONS(5258),
    [anon_sym_LPAREN2] = ACTIONS(5258),
    [anon_sym_STAR] = ACTIONS(5258),
    [anon_sym_AMP_AMP] = ACTIONS(5258),
    [anon_sym_AMP] = ACTIONS(5261),
    [anon_sym_SEMI] = ACTIONS(5258),
    [anon_sym___extension__] = ACTIONS(5261),
    [anon_sym___device__] = ACTIONS(5261),
    [anon_sym___host__] = ACTIONS(5261),
    [anon_sym___global__] = ACTIONS(5261),
    [anon_sym___forceinline__] = ACTIONS(5261),
    [anon_sym___noinline__] = ACTIONS(5261),
    [anon_sym_extern] = ACTIONS(5261),
    [anon_sym___attribute__] = ACTIONS(5261),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5258),
    [anon_sym___declspec] = ACTIONS(5261),
    [anon_sym_LBRACE] = ACTIONS(5258),
    [anon_sym_signed] = ACTIONS(5207),
    [anon_sym_unsigned] = ACTIONS(5207),
    [anon_sym_long] = ACTIONS(5207),
    [anon_sym_short] = ACTIONS(5207),
    [anon_sym_LBRACK] = ACTIONS(5261),
    [anon_sym_static] = ACTIONS(5261),
    [anon_sym_EQ] = ACTIONS(5258),
    [anon_sym_register] = ACTIONS(5261),
    [anon_sym_inline] = ACTIONS(5261),
    [anon_sym___inline] = ACTIONS(5261),
    [anon_sym___inline__] = ACTIONS(5261),
    [anon_sym___forceinline] = ACTIONS(5261),
    [anon_sym_thread_local] = ACTIONS(5261),
    [anon_sym___thread] = ACTIONS(5261),
    [anon_sym_const] = ACTIONS(5261),
    [anon_sym_constexpr] = ACTIONS(5261),
    [anon_sym_volatile] = ACTIONS(5261),
    [anon_sym_restrict] = ACTIONS(5261),
    [anon_sym___restrict__] = ACTIONS(5261),
    [anon_sym__Atomic] = ACTIONS(5261),
    [anon_sym__Noreturn] = ACTIONS(5261),
    [anon_sym_noreturn] = ACTIONS(5261),
    [anon_sym_mutable] = ACTIONS(5261),
    [anon_sym_constinit] = ACTIONS(5261),
    [anon_sym_consteval] = ACTIONS(5261),
    [anon_sym___shared__] = ACTIONS(5261),
    [anon_sym___local__] = ACTIONS(5261),
    [anon_sym___constant__] = ACTIONS(5261),
    [anon_sym___managed__] = ACTIONS(5261),
    [anon_sym___grid_constant__] = ACTIONS(5261),
    [anon_sym_alignas] = ACTIONS(5261),
    [anon_sym__Alignas] = ACTIONS(5261),
    [sym_primitive_type] = ACTIONS(5016),
    [anon_sym_asm] = ACTIONS(5261),
    [anon_sym___asm__] = ACTIONS(5261),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5261),
    [anon_sym_decltype] = ACTIONS(5261),
    [anon_sym_final] = ACTIONS(5261),
    [anon_sym_override] = ACTIONS(5261),
    [sym_virtual] = ACTIONS(5261),
    [anon_sym_GT2] = ACTIONS(5258),
    [anon_sym_try] = ACTIONS(5261),
    [anon_sym_requires] = ACTIONS(5261),
    [anon_sym___launch_bounds__] = ACTIONS(5261),
  },
  [2471] = {
    [sym_argument_list] = STATE(2738),
    [sym_subscript_argument_list] = STATE(2734),
    [sym_kernel_call_syntax] = STATE(8019),
    [sym_identifier] = ACTIONS(6052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6054),
    [anon_sym_COMMA] = ACTIONS(6054),
    [anon_sym_RPAREN] = ACTIONS(6054),
    [aux_sym_preproc_if_token2] = ACTIONS(6054),
    [aux_sym_preproc_else_token1] = ACTIONS(6054),
    [aux_sym_preproc_elif_token1] = ACTIONS(6052),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6054),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6054),
    [anon_sym_LPAREN2] = ACTIONS(5644),
    [anon_sym_DASH] = ACTIONS(6052),
    [anon_sym_PLUS] = ACTIONS(6052),
    [anon_sym_STAR] = ACTIONS(6052),
    [anon_sym_SLASH] = ACTIONS(6052),
    [anon_sym_PERCENT] = ACTIONS(6052),
    [anon_sym_PIPE_PIPE] = ACTIONS(6054),
    [anon_sym_AMP_AMP] = ACTIONS(6054),
    [anon_sym_PIPE] = ACTIONS(6052),
    [anon_sym_CARET] = ACTIONS(6052),
    [anon_sym_AMP] = ACTIONS(6052),
    [anon_sym_EQ_EQ] = ACTIONS(6054),
    [anon_sym_BANG_EQ] = ACTIONS(6054),
    [anon_sym_GT] = ACTIONS(6052),
    [anon_sym_GT_EQ] = ACTIONS(6054),
    [anon_sym_LT_EQ] = ACTIONS(6052),
    [anon_sym_LT] = ACTIONS(6052),
    [anon_sym_LT_LT] = ACTIONS(6052),
    [anon_sym_GT_GT] = ACTIONS(6052),
    [anon_sym_SEMI] = ACTIONS(6054),
    [anon_sym___attribute__] = ACTIONS(6052),
    [anon_sym_RBRACE] = ACTIONS(6054),
    [anon_sym_LBRACK] = ACTIONS(6056),
    [anon_sym_RBRACK] = ACTIONS(6054),
    [anon_sym_EQ] = ACTIONS(6052),
    [anon_sym_QMARK] = ACTIONS(6054),
    [anon_sym_STAR_EQ] = ACTIONS(6054),
    [anon_sym_SLASH_EQ] = ACTIONS(6054),
    [anon_sym_PERCENT_EQ] = ACTIONS(6054),
    [anon_sym_PLUS_EQ] = ACTIONS(6054),
    [anon_sym_DASH_EQ] = ACTIONS(6054),
    [anon_sym_LT_LT_EQ] = ACTIONS(6054),
    [anon_sym_GT_GT_EQ] = ACTIONS(6054),
    [anon_sym_AMP_EQ] = ACTIONS(6054),
    [anon_sym_CARET_EQ] = ACTIONS(6054),
    [anon_sym_PIPE_EQ] = ACTIONS(6054),
    [anon_sym_and_eq] = ACTIONS(6052),
    [anon_sym_or_eq] = ACTIONS(6052),
    [anon_sym_xor_eq] = ACTIONS(6052),
    [anon_sym_LT_EQ_GT] = ACTIONS(6054),
    [anon_sym_or] = ACTIONS(6052),
    [anon_sym_and] = ACTIONS(6052),
    [anon_sym_bitor] = ACTIONS(6052),
    [anon_sym_xor] = ACTIONS(6052),
    [anon_sym_bitand] = ACTIONS(6052),
    [anon_sym_not_eq] = ACTIONS(6052),
    [anon_sym_DASH_DASH] = ACTIONS(6058),
    [anon_sym_PLUS_PLUS] = ACTIONS(6058),
    [anon_sym_DOT] = ACTIONS(6060),
    [anon_sym_DOT_STAR] = ACTIONS(6062),
    [anon_sym_DASH_GT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(3),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(6054),
  },
  [2472] = {
    [sym_identifier] = ACTIONS(5179),
    [anon_sym_COMMA] = ACTIONS(5181),
    [anon_sym_RPAREN] = ACTIONS(5181),
    [anon_sym_LPAREN2] = ACTIONS(5181),
    [anon_sym_STAR] = ACTIONS(5181),
    [anon_sym_PIPE_PIPE] = ACTIONS(5181),
    [anon_sym_AMP_AMP] = ACTIONS(5181),
    [anon_sym_AMP] = ACTIONS(5179),
    [anon_sym_SEMI] = ACTIONS(5181),
    [anon_sym___extension__] = ACTIONS(5179),
    [anon_sym___device__] = ACTIONS(5179),
    [anon_sym___host__] = ACTIONS(5179),
    [anon_sym___global__] = ACTIONS(5179),
    [anon_sym___forceinline__] = ACTIONS(5179),
    [anon_sym___noinline__] = ACTIONS(5179),
    [anon_sym_extern] = ACTIONS(5179),
    [anon_sym___attribute__] = ACTIONS(5179),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5181),
    [anon_sym___declspec] = ACTIONS(5179),
    [anon_sym___based] = ACTIONS(5179),
    [anon_sym_LBRACE] = ACTIONS(5181),
    [anon_sym_LBRACK] = ACTIONS(5179),
    [anon_sym_static] = ACTIONS(5179),
    [anon_sym_EQ] = ACTIONS(5181),
    [anon_sym_register] = ACTIONS(5179),
    [anon_sym_inline] = ACTIONS(5179),
    [anon_sym___inline] = ACTIONS(5179),
    [anon_sym___inline__] = ACTIONS(5179),
    [anon_sym___forceinline] = ACTIONS(5179),
    [anon_sym_thread_local] = ACTIONS(5179),
    [anon_sym___thread] = ACTIONS(5179),
    [anon_sym_const] = ACTIONS(5179),
    [anon_sym_constexpr] = ACTIONS(5179),
    [anon_sym_volatile] = ACTIONS(5179),
    [anon_sym_restrict] = ACTIONS(5179),
    [anon_sym___restrict__] = ACTIONS(5179),
    [anon_sym__Atomic] = ACTIONS(5179),
    [anon_sym__Noreturn] = ACTIONS(5179),
    [anon_sym_noreturn] = ACTIONS(5179),
    [anon_sym_mutable] = ACTIONS(5179),
    [anon_sym_constinit] = ACTIONS(5179),
    [anon_sym_consteval] = ACTIONS(5179),
    [anon_sym___shared__] = ACTIONS(5179),
    [anon_sym___local__] = ACTIONS(5179),
    [anon_sym___constant__] = ACTIONS(5179),
    [anon_sym___managed__] = ACTIONS(5179),
    [anon_sym___grid_constant__] = ACTIONS(5179),
    [anon_sym_alignas] = ACTIONS(5179),
    [anon_sym__Alignas] = ACTIONS(5179),
    [anon_sym_COLON] = ACTIONS(5181),
    [anon_sym_or] = ACTIONS(5179),
    [anon_sym_and] = ACTIONS(5179),
    [anon_sym_asm] = ACTIONS(5179),
    [anon_sym___asm__] = ACTIONS(5179),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5179),
    [anon_sym_decltype] = ACTIONS(5179),
    [anon_sym_final] = ACTIONS(5179),
    [anon_sym_override] = ACTIONS(5179),
    [sym_virtual] = ACTIONS(5179),
    [anon_sym_GT2] = ACTIONS(5181),
    [anon_sym_operator] = ACTIONS(5179),
    [anon_sym_try] = ACTIONS(5179),
    [anon_sym_requires] = ACTIONS(5179),
    [anon_sym___launch_bounds__] = ACTIONS(5179),
  },
  [2473] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5388),
    [anon_sym_COMMA] = ACTIONS(5388),
    [anon_sym_LPAREN2] = ACTIONS(5388),
    [anon_sym_DASH] = ACTIONS(5386),
    [anon_sym_PLUS] = ACTIONS(5386),
    [anon_sym_STAR] = ACTIONS(5388),
    [anon_sym_SLASH] = ACTIONS(5386),
    [anon_sym_PERCENT] = ACTIONS(5388),
    [anon_sym_PIPE_PIPE] = ACTIONS(5388),
    [anon_sym_AMP_AMP] = ACTIONS(5388),
    [anon_sym_PIPE] = ACTIONS(5386),
    [anon_sym_CARET] = ACTIONS(5388),
    [anon_sym_AMP] = ACTIONS(5386),
    [anon_sym_EQ_EQ] = ACTIONS(5388),
    [anon_sym_BANG_EQ] = ACTIONS(5388),
    [anon_sym_GT] = ACTIONS(5386),
    [anon_sym_GT_EQ] = ACTIONS(5386),
    [anon_sym_LT_EQ] = ACTIONS(5386),
    [anon_sym_LT] = ACTIONS(5386),
    [anon_sym_LT_LT] = ACTIONS(5386),
    [anon_sym_GT_GT] = ACTIONS(5386),
    [anon_sym___extension__] = ACTIONS(5388),
    [anon_sym___global__] = ACTIONS(5388),
    [anon_sym___attribute__] = ACTIONS(5388),
    [anon_sym_LBRACE] = ACTIONS(5388),
    [anon_sym_LBRACK] = ACTIONS(5388),
    [anon_sym_const] = ACTIONS(5386),
    [anon_sym_constexpr] = ACTIONS(5388),
    [anon_sym_volatile] = ACTIONS(5388),
    [anon_sym_restrict] = ACTIONS(5388),
    [anon_sym___restrict__] = ACTIONS(5388),
    [anon_sym__Atomic] = ACTIONS(5388),
    [anon_sym__Noreturn] = ACTIONS(5388),
    [anon_sym_noreturn] = ACTIONS(5388),
    [anon_sym_mutable] = ACTIONS(5388),
    [anon_sym_constinit] = ACTIONS(5388),
    [anon_sym_consteval] = ACTIONS(5388),
    [anon_sym___shared__] = ACTIONS(5388),
    [anon_sym___local__] = ACTIONS(5388),
    [anon_sym___constant__] = ACTIONS(5388),
    [anon_sym___managed__] = ACTIONS(5388),
    [anon_sym___grid_constant__] = ACTIONS(5388),
    [anon_sym_alignas] = ACTIONS(5388),
    [anon_sym__Alignas] = ACTIONS(5388),
    [anon_sym_QMARK] = ACTIONS(5388),
    [anon_sym_LT_EQ_GT] = ACTIONS(5388),
    [anon_sym_or] = ACTIONS(5388),
    [anon_sym_and] = ACTIONS(5388),
    [anon_sym_bitor] = ACTIONS(5388),
    [anon_sym_xor] = ACTIONS(5388),
    [anon_sym_bitand] = ACTIONS(5388),
    [anon_sym_not_eq] = ACTIONS(5388),
    [anon_sym_DASH_DASH] = ACTIONS(5388),
    [anon_sym_PLUS_PLUS] = ACTIONS(5388),
    [anon_sym_DOT] = ACTIONS(5386),
    [anon_sym_DOT_STAR] = ACTIONS(5388),
    [anon_sym_DASH_GT] = ACTIONS(5388),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5388),
    [anon_sym_decltype] = ACTIONS(5388),
    [anon_sym_final] = ACTIONS(5388),
    [anon_sym_override] = ACTIONS(5388),
    [anon_sym_GT2] = ACTIONS(5388),
    [anon_sym_requires] = ACTIONS(5388),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5388),
  },
  [2474] = {
    [sym_attribute_specifier] = STATE(2198),
    [sym_identifier] = ACTIONS(5676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5674),
    [anon_sym_COMMA] = ACTIONS(5674),
    [anon_sym_RPAREN] = ACTIONS(5674),
    [anon_sym_LPAREN2] = ACTIONS(5674),
    [anon_sym_TILDE] = ACTIONS(5674),
    [anon_sym_STAR] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5676),
    [anon_sym_SEMI] = ACTIONS(5674),
    [anon_sym___extension__] = ACTIONS(5676),
    [anon_sym___device__] = ACTIONS(5676),
    [anon_sym___host__] = ACTIONS(5676),
    [anon_sym___global__] = ACTIONS(5676),
    [anon_sym___forceinline__] = ACTIONS(5676),
    [anon_sym___noinline__] = ACTIONS(5676),
    [anon_sym_extern] = ACTIONS(5676),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5674),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5674),
    [anon_sym___declspec] = ACTIONS(5676),
    [anon_sym___based] = ACTIONS(5676),
    [anon_sym___cdecl] = ACTIONS(5676),
    [anon_sym___clrcall] = ACTIONS(5676),
    [anon_sym___stdcall] = ACTIONS(5676),
    [anon_sym___fastcall] = ACTIONS(5676),
    [anon_sym___thiscall] = ACTIONS(5676),
    [anon_sym___vectorcall] = ACTIONS(5676),
    [anon_sym_LBRACK] = ACTIONS(5676),
    [anon_sym_static] = ACTIONS(5676),
    [anon_sym_EQ] = ACTIONS(5674),
    [anon_sym_register] = ACTIONS(5676),
    [anon_sym_inline] = ACTIONS(5676),
    [anon_sym___inline] = ACTIONS(5676),
    [anon_sym___inline__] = ACTIONS(5676),
    [anon_sym___forceinline] = ACTIONS(5676),
    [anon_sym_thread_local] = ACTIONS(5676),
    [anon_sym___thread] = ACTIONS(5676),
    [anon_sym_const] = ACTIONS(5676),
    [anon_sym_constexpr] = ACTIONS(5676),
    [anon_sym_volatile] = ACTIONS(5676),
    [anon_sym_restrict] = ACTIONS(5676),
    [anon_sym___restrict__] = ACTIONS(5676),
    [anon_sym__Atomic] = ACTIONS(5676),
    [anon_sym__Noreturn] = ACTIONS(5676),
    [anon_sym_noreturn] = ACTIONS(5676),
    [anon_sym_mutable] = ACTIONS(5676),
    [anon_sym_constinit] = ACTIONS(5676),
    [anon_sym_consteval] = ACTIONS(5676),
    [anon_sym___shared__] = ACTIONS(5676),
    [anon_sym___local__] = ACTIONS(5676),
    [anon_sym___constant__] = ACTIONS(5676),
    [anon_sym___managed__] = ACTIONS(5676),
    [anon_sym___grid_constant__] = ACTIONS(5676),
    [anon_sym_alignas] = ACTIONS(5676),
    [anon_sym__Alignas] = ACTIONS(5676),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5676),
    [anon_sym_decltype] = ACTIONS(5676),
    [sym_virtual] = ACTIONS(5676),
    [anon_sym_template] = ACTIONS(5676),
    [anon_sym_GT2] = ACTIONS(5674),
    [anon_sym_operator] = ACTIONS(5676),
    [anon_sym___launch_bounds__] = ACTIONS(5676),
  },
  [2475] = {
    [sym_attribute_specifier] = STATE(2208),
    [sym_identifier] = ACTIONS(5723),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5721),
    [anon_sym_COMMA] = ACTIONS(5721),
    [anon_sym_RPAREN] = ACTIONS(5721),
    [anon_sym_LPAREN2] = ACTIONS(5721),
    [anon_sym_TILDE] = ACTIONS(5721),
    [anon_sym_STAR] = ACTIONS(5721),
    [anon_sym_AMP_AMP] = ACTIONS(5721),
    [anon_sym_AMP] = ACTIONS(5723),
    [anon_sym_SEMI] = ACTIONS(5721),
    [anon_sym___extension__] = ACTIONS(5723),
    [anon_sym___device__] = ACTIONS(5723),
    [anon_sym___host__] = ACTIONS(5723),
    [anon_sym___global__] = ACTIONS(5723),
    [anon_sym___forceinline__] = ACTIONS(5723),
    [anon_sym___noinline__] = ACTIONS(5723),
    [anon_sym_extern] = ACTIONS(5723),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5721),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5721),
    [anon_sym___declspec] = ACTIONS(5723),
    [anon_sym___based] = ACTIONS(5723),
    [anon_sym___cdecl] = ACTIONS(5723),
    [anon_sym___clrcall] = ACTIONS(5723),
    [anon_sym___stdcall] = ACTIONS(5723),
    [anon_sym___fastcall] = ACTIONS(5723),
    [anon_sym___thiscall] = ACTIONS(5723),
    [anon_sym___vectorcall] = ACTIONS(5723),
    [anon_sym_LBRACK] = ACTIONS(5723),
    [anon_sym_static] = ACTIONS(5723),
    [anon_sym_EQ] = ACTIONS(5721),
    [anon_sym_register] = ACTIONS(5723),
    [anon_sym_inline] = ACTIONS(5723),
    [anon_sym___inline] = ACTIONS(5723),
    [anon_sym___inline__] = ACTIONS(5723),
    [anon_sym___forceinline] = ACTIONS(5723),
    [anon_sym_thread_local] = ACTIONS(5723),
    [anon_sym___thread] = ACTIONS(5723),
    [anon_sym_const] = ACTIONS(5723),
    [anon_sym_constexpr] = ACTIONS(5723),
    [anon_sym_volatile] = ACTIONS(5723),
    [anon_sym_restrict] = ACTIONS(5723),
    [anon_sym___restrict__] = ACTIONS(5723),
    [anon_sym__Atomic] = ACTIONS(5723),
    [anon_sym__Noreturn] = ACTIONS(5723),
    [anon_sym_noreturn] = ACTIONS(5723),
    [anon_sym_mutable] = ACTIONS(5723),
    [anon_sym_constinit] = ACTIONS(5723),
    [anon_sym_consteval] = ACTIONS(5723),
    [anon_sym___shared__] = ACTIONS(5723),
    [anon_sym___local__] = ACTIONS(5723),
    [anon_sym___constant__] = ACTIONS(5723),
    [anon_sym___managed__] = ACTIONS(5723),
    [anon_sym___grid_constant__] = ACTIONS(5723),
    [anon_sym_alignas] = ACTIONS(5723),
    [anon_sym__Alignas] = ACTIONS(5723),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5723),
    [anon_sym_decltype] = ACTIONS(5723),
    [sym_virtual] = ACTIONS(5723),
    [anon_sym_template] = ACTIONS(5723),
    [anon_sym_GT2] = ACTIONS(5721),
    [anon_sym_operator] = ACTIONS(5723),
    [anon_sym___launch_bounds__] = ACTIONS(5723),
  },
  [2476] = {
    [sym_identifier] = ACTIONS(5458),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5460),
    [anon_sym_COMMA] = ACTIONS(5460),
    [anon_sym_RPAREN] = ACTIONS(5460),
    [anon_sym_LPAREN2] = ACTIONS(5460),
    [anon_sym_DASH] = ACTIONS(5458),
    [anon_sym_PLUS] = ACTIONS(5458),
    [anon_sym_STAR] = ACTIONS(5458),
    [anon_sym_SLASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5458),
    [anon_sym_PIPE_PIPE] = ACTIONS(5460),
    [anon_sym_AMP_AMP] = ACTIONS(5460),
    [anon_sym_PIPE] = ACTIONS(5458),
    [anon_sym_CARET] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5458),
    [anon_sym_EQ_EQ] = ACTIONS(5460),
    [anon_sym_BANG_EQ] = ACTIONS(5460),
    [anon_sym_GT] = ACTIONS(5458),
    [anon_sym_GT_EQ] = ACTIONS(5460),
    [anon_sym_LT_EQ] = ACTIONS(5458),
    [anon_sym_LT] = ACTIONS(5458),
    [anon_sym_LT_LT] = ACTIONS(5458),
    [anon_sym_GT_GT] = ACTIONS(5458),
    [anon_sym_LBRACK] = ACTIONS(5460),
    [anon_sym_EQ] = ACTIONS(5458),
    [anon_sym_QMARK] = ACTIONS(5460),
    [anon_sym_STAR_EQ] = ACTIONS(5460),
    [anon_sym_SLASH_EQ] = ACTIONS(5460),
    [anon_sym_PERCENT_EQ] = ACTIONS(5460),
    [anon_sym_PLUS_EQ] = ACTIONS(5460),
    [anon_sym_DASH_EQ] = ACTIONS(5460),
    [anon_sym_LT_LT_EQ] = ACTIONS(5460),
    [anon_sym_GT_GT_EQ] = ACTIONS(5460),
    [anon_sym_AMP_EQ] = ACTIONS(5460),
    [anon_sym_CARET_EQ] = ACTIONS(5460),
    [anon_sym_PIPE_EQ] = ACTIONS(5460),
    [anon_sym_and_eq] = ACTIONS(5458),
    [anon_sym_or_eq] = ACTIONS(5458),
    [anon_sym_xor_eq] = ACTIONS(5458),
    [anon_sym_LT_EQ_GT] = ACTIONS(5460),
    [anon_sym_or] = ACTIONS(5458),
    [anon_sym_and] = ACTIONS(5458),
    [anon_sym_bitor] = ACTIONS(5458),
    [anon_sym_xor] = ACTIONS(5458),
    [anon_sym_bitand] = ACTIONS(5458),
    [anon_sym_not_eq] = ACTIONS(5458),
    [anon_sym_DASH_DASH] = ACTIONS(5460),
    [anon_sym_PLUS_PLUS] = ACTIONS(5460),
    [anon_sym_DOT] = ACTIONS(5458),
    [anon_sym_DOT_STAR] = ACTIONS(5460),
    [anon_sym_DASH_GT] = ACTIONS(5458),
    [anon_sym_L_DQUOTE] = ACTIONS(5460),
    [anon_sym_u_DQUOTE] = ACTIONS(5460),
    [anon_sym_U_DQUOTE] = ACTIONS(5460),
    [anon_sym_u8_DQUOTE] = ACTIONS(5460),
    [anon_sym_DQUOTE] = ACTIONS(5460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5460),
    [anon_sym_LR_DQUOTE] = ACTIONS(5460),
    [anon_sym_uR_DQUOTE] = ACTIONS(5460),
    [anon_sym_UR_DQUOTE] = ACTIONS(5460),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5460),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5460),
    [sym_literal_suffix] = ACTIONS(5458),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5460),
  },
  [2477] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5194),
    [anon_sym_COMMA] = ACTIONS(5194),
    [anon_sym_LPAREN2] = ACTIONS(5194),
    [anon_sym_DASH] = ACTIONS(5192),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_STAR] = ACTIONS(5194),
    [anon_sym_SLASH] = ACTIONS(5192),
    [anon_sym_PERCENT] = ACTIONS(5194),
    [anon_sym_PIPE_PIPE] = ACTIONS(5194),
    [anon_sym_AMP_AMP] = ACTIONS(5194),
    [anon_sym_PIPE] = ACTIONS(5192),
    [anon_sym_CARET] = ACTIONS(5194),
    [anon_sym_AMP] = ACTIONS(5192),
    [anon_sym_EQ_EQ] = ACTIONS(5194),
    [anon_sym_BANG_EQ] = ACTIONS(5194),
    [anon_sym_GT] = ACTIONS(5192),
    [anon_sym_GT_EQ] = ACTIONS(5192),
    [anon_sym_LT_EQ] = ACTIONS(5192),
    [anon_sym_LT] = ACTIONS(5192),
    [anon_sym_LT_LT] = ACTIONS(5192),
    [anon_sym_GT_GT] = ACTIONS(5192),
    [anon_sym___extension__] = ACTIONS(5194),
    [anon_sym___global__] = ACTIONS(5194),
    [anon_sym_COLON_COLON] = ACTIONS(5183),
    [anon_sym_LBRACE] = ACTIONS(5194),
    [anon_sym_LBRACK] = ACTIONS(5194),
    [anon_sym_const] = ACTIONS(5192),
    [anon_sym_constexpr] = ACTIONS(5194),
    [anon_sym_volatile] = ACTIONS(5194),
    [anon_sym_restrict] = ACTIONS(5194),
    [anon_sym___restrict__] = ACTIONS(5194),
    [anon_sym__Atomic] = ACTIONS(5194),
    [anon_sym__Noreturn] = ACTIONS(5194),
    [anon_sym_noreturn] = ACTIONS(5194),
    [anon_sym_mutable] = ACTIONS(5194),
    [anon_sym_constinit] = ACTIONS(5194),
    [anon_sym_consteval] = ACTIONS(5194),
    [anon_sym___shared__] = ACTIONS(5194),
    [anon_sym___local__] = ACTIONS(5194),
    [anon_sym___constant__] = ACTIONS(5194),
    [anon_sym___managed__] = ACTIONS(5194),
    [anon_sym___grid_constant__] = ACTIONS(5194),
    [anon_sym_alignas] = ACTIONS(5194),
    [anon_sym__Alignas] = ACTIONS(5194),
    [anon_sym_QMARK] = ACTIONS(5194),
    [anon_sym_LT_EQ_GT] = ACTIONS(5194),
    [anon_sym_or] = ACTIONS(5194),
    [anon_sym_and] = ACTIONS(5194),
    [anon_sym_bitor] = ACTIONS(5194),
    [anon_sym_xor] = ACTIONS(5194),
    [anon_sym_bitand] = ACTIONS(5194),
    [anon_sym_not_eq] = ACTIONS(5194),
    [anon_sym_DASH_DASH] = ACTIONS(5194),
    [anon_sym_PLUS_PLUS] = ACTIONS(5194),
    [anon_sym_DOT] = ACTIONS(5192),
    [anon_sym_DOT_STAR] = ACTIONS(5194),
    [anon_sym_DASH_GT] = ACTIONS(5194),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5194),
    [anon_sym_decltype] = ACTIONS(5194),
    [anon_sym_final] = ACTIONS(5194),
    [anon_sym_override] = ACTIONS(5194),
    [anon_sym_GT2] = ACTIONS(5194),
    [anon_sym_requires] = ACTIONS(5194),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5194),
  },
  [2478] = {
    [sym_attribute_specifier] = STATE(2196),
    [sym_identifier] = ACTIONS(5700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5698),
    [anon_sym_COMMA] = ACTIONS(5698),
    [anon_sym_RPAREN] = ACTIONS(5698),
    [anon_sym_LPAREN2] = ACTIONS(5698),
    [anon_sym_TILDE] = ACTIONS(5698),
    [anon_sym_STAR] = ACTIONS(5698),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_AMP] = ACTIONS(5700),
    [anon_sym_SEMI] = ACTIONS(5698),
    [anon_sym___extension__] = ACTIONS(5700),
    [anon_sym___device__] = ACTIONS(5700),
    [anon_sym___host__] = ACTIONS(5700),
    [anon_sym___global__] = ACTIONS(5700),
    [anon_sym___forceinline__] = ACTIONS(5700),
    [anon_sym___noinline__] = ACTIONS(5700),
    [anon_sym_extern] = ACTIONS(5700),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5698),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5698),
    [anon_sym___declspec] = ACTIONS(5700),
    [anon_sym___based] = ACTIONS(5700),
    [anon_sym___cdecl] = ACTIONS(5700),
    [anon_sym___clrcall] = ACTIONS(5700),
    [anon_sym___stdcall] = ACTIONS(5700),
    [anon_sym___fastcall] = ACTIONS(5700),
    [anon_sym___thiscall] = ACTIONS(5700),
    [anon_sym___vectorcall] = ACTIONS(5700),
    [anon_sym_LBRACK] = ACTIONS(5700),
    [anon_sym_static] = ACTIONS(5700),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_register] = ACTIONS(5700),
    [anon_sym_inline] = ACTIONS(5700),
    [anon_sym___inline] = ACTIONS(5700),
    [anon_sym___inline__] = ACTIONS(5700),
    [anon_sym___forceinline] = ACTIONS(5700),
    [anon_sym_thread_local] = ACTIONS(5700),
    [anon_sym___thread] = ACTIONS(5700),
    [anon_sym_const] = ACTIONS(5700),
    [anon_sym_constexpr] = ACTIONS(5700),
    [anon_sym_volatile] = ACTIONS(5700),
    [anon_sym_restrict] = ACTIONS(5700),
    [anon_sym___restrict__] = ACTIONS(5700),
    [anon_sym__Atomic] = ACTIONS(5700),
    [anon_sym__Noreturn] = ACTIONS(5700),
    [anon_sym_noreturn] = ACTIONS(5700),
    [anon_sym_mutable] = ACTIONS(5700),
    [anon_sym_constinit] = ACTIONS(5700),
    [anon_sym_consteval] = ACTIONS(5700),
    [anon_sym___shared__] = ACTIONS(5700),
    [anon_sym___local__] = ACTIONS(5700),
    [anon_sym___constant__] = ACTIONS(5700),
    [anon_sym___managed__] = ACTIONS(5700),
    [anon_sym___grid_constant__] = ACTIONS(5700),
    [anon_sym_alignas] = ACTIONS(5700),
    [anon_sym__Alignas] = ACTIONS(5700),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5700),
    [anon_sym_decltype] = ACTIONS(5700),
    [sym_virtual] = ACTIONS(5700),
    [anon_sym_template] = ACTIONS(5700),
    [anon_sym_GT2] = ACTIONS(5698),
    [anon_sym_operator] = ACTIONS(5700),
    [anon_sym___launch_bounds__] = ACTIONS(5700),
  },
  [2479] = {
    [sym_ms_based_modifier] = STATE(8387),
    [sym__declarator] = STATE(6666),
    [sym__abstract_declarator] = STATE(6745),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_abstract_parenthesized_declarator] = STATE(6430),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_abstract_pointer_declarator] = STATE(6430),
    [sym_function_declarator] = STATE(6598),
    [sym_abstract_function_declarator] = STATE(6430),
    [sym_array_declarator] = STATE(6598),
    [sym_abstract_array_declarator] = STATE(6430),
    [sym_type_qualifier] = STATE(5008),
    [sym_alignas_qualifier] = STATE(4511),
    [sym_parameter_list] = STATE(2819),
    [sym_decltype] = STATE(8628),
    [sym_reference_declarator] = STATE(6598),
    [sym_abstract_reference_declarator] = STATE(6430),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym__function_declarator_seq] = STATE(6416),
    [sym_template_type] = STATE(8628),
    [sym_template_function] = STATE(6598),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6059),
    [sym_qualified_identifier] = STATE(6598),
    [sym_operator_name] = STATE(6598),
    [aux_sym__type_definition_type_repeat1] = STATE(5008),
    [sym_identifier] = ACTIONS(5482),
    [anon_sym_COMMA] = ACTIONS(5504),
    [anon_sym_RPAREN] = ACTIONS(5504),
    [anon_sym_LPAREN2] = ACTIONS(3957),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(5486),
    [anon_sym_AMP_AMP] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5490),
    [anon_sym___extension__] = ACTIONS(3171),
    [anon_sym___global__] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(5492),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(5494),
    [anon_sym_EQ] = ACTIONS(5504),
    [anon_sym_const] = ACTIONS(3171),
    [anon_sym_constexpr] = ACTIONS(3171),
    [anon_sym_volatile] = ACTIONS(3171),
    [anon_sym_restrict] = ACTIONS(3171),
    [anon_sym___restrict__] = ACTIONS(3171),
    [anon_sym__Atomic] = ACTIONS(3171),
    [anon_sym__Noreturn] = ACTIONS(3171),
    [anon_sym_noreturn] = ACTIONS(3171),
    [anon_sym_mutable] = ACTIONS(3171),
    [anon_sym_constinit] = ACTIONS(3171),
    [anon_sym_consteval] = ACTIONS(3171),
    [anon_sym___shared__] = ACTIONS(3171),
    [anon_sym___local__] = ACTIONS(3171),
    [anon_sym___constant__] = ACTIONS(3171),
    [anon_sym___managed__] = ACTIONS(3171),
    [anon_sym___grid_constant__] = ACTIONS(3171),
    [anon_sym_alignas] = ACTIONS(3177),
    [anon_sym__Alignas] = ACTIONS(3177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_GT2] = ACTIONS(5504),
    [anon_sym_operator] = ACTIONS(1883),
  },
  [2480] = {
    [sym_argument_list] = STATE(2738),
    [sym_subscript_argument_list] = STATE(2734),
    [sym_kernel_call_syntax] = STATE(8019),
    [sym_identifier] = ACTIONS(6064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6066),
    [anon_sym_COMMA] = ACTIONS(6066),
    [anon_sym_RPAREN] = ACTIONS(6066),
    [aux_sym_preproc_if_token2] = ACTIONS(6066),
    [aux_sym_preproc_else_token1] = ACTIONS(6066),
    [aux_sym_preproc_elif_token1] = ACTIONS(6064),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6066),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6066),
    [anon_sym_LPAREN2] = ACTIONS(5644),
    [anon_sym_DASH] = ACTIONS(6064),
    [anon_sym_PLUS] = ACTIONS(6064),
    [anon_sym_STAR] = ACTIONS(6064),
    [anon_sym_SLASH] = ACTIONS(6064),
    [anon_sym_PERCENT] = ACTIONS(6064),
    [anon_sym_PIPE_PIPE] = ACTIONS(6066),
    [anon_sym_AMP_AMP] = ACTIONS(6066),
    [anon_sym_PIPE] = ACTIONS(6064),
    [anon_sym_CARET] = ACTIONS(6064),
    [anon_sym_AMP] = ACTIONS(6064),
    [anon_sym_EQ_EQ] = ACTIONS(6066),
    [anon_sym_BANG_EQ] = ACTIONS(6066),
    [anon_sym_GT] = ACTIONS(6064),
    [anon_sym_GT_EQ] = ACTIONS(6066),
    [anon_sym_LT_EQ] = ACTIONS(6064),
    [anon_sym_LT] = ACTIONS(6064),
    [anon_sym_LT_LT] = ACTIONS(6064),
    [anon_sym_GT_GT] = ACTIONS(6064),
    [anon_sym_SEMI] = ACTIONS(6066),
    [anon_sym___attribute__] = ACTIONS(6064),
    [anon_sym_RBRACE] = ACTIONS(6066),
    [anon_sym_LBRACK] = ACTIONS(6056),
    [anon_sym_RBRACK] = ACTIONS(6066),
    [anon_sym_EQ] = ACTIONS(6064),
    [anon_sym_QMARK] = ACTIONS(6066),
    [anon_sym_STAR_EQ] = ACTIONS(6066),
    [anon_sym_SLASH_EQ] = ACTIONS(6066),
    [anon_sym_PERCENT_EQ] = ACTIONS(6066),
    [anon_sym_PLUS_EQ] = ACTIONS(6066),
    [anon_sym_DASH_EQ] = ACTIONS(6066),
    [anon_sym_LT_LT_EQ] = ACTIONS(6066),
    [anon_sym_GT_GT_EQ] = ACTIONS(6066),
    [anon_sym_AMP_EQ] = ACTIONS(6066),
    [anon_sym_CARET_EQ] = ACTIONS(6066),
    [anon_sym_PIPE_EQ] = ACTIONS(6066),
    [anon_sym_and_eq] = ACTIONS(6064),
    [anon_sym_or_eq] = ACTIONS(6064),
    [anon_sym_xor_eq] = ACTIONS(6064),
    [anon_sym_LT_EQ_GT] = ACTIONS(6066),
    [anon_sym_or] = ACTIONS(6064),
    [anon_sym_and] = ACTIONS(6064),
    [anon_sym_bitor] = ACTIONS(6064),
    [anon_sym_xor] = ACTIONS(6064),
    [anon_sym_bitand] = ACTIONS(6064),
    [anon_sym_not_eq] = ACTIONS(6064),
    [anon_sym_DASH_DASH] = ACTIONS(6058),
    [anon_sym_PLUS_PLUS] = ACTIONS(6058),
    [anon_sym_DOT] = ACTIONS(6060),
    [anon_sym_DOT_STAR] = ACTIONS(6062),
    [anon_sym_DASH_GT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(3),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(6066),
  },
  [2481] = {
    [sym_attribute_specifier] = STATE(2169),
    [sym_identifier] = ACTIONS(5670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5668),
    [anon_sym_COMMA] = ACTIONS(5668),
    [anon_sym_RPAREN] = ACTIONS(5668),
    [anon_sym_LPAREN2] = ACTIONS(5668),
    [anon_sym_TILDE] = ACTIONS(5668),
    [anon_sym_STAR] = ACTIONS(5668),
    [anon_sym_AMP_AMP] = ACTIONS(5668),
    [anon_sym_AMP] = ACTIONS(5670),
    [anon_sym_SEMI] = ACTIONS(5668),
    [anon_sym___extension__] = ACTIONS(5670),
    [anon_sym___device__] = ACTIONS(5670),
    [anon_sym___host__] = ACTIONS(5670),
    [anon_sym___global__] = ACTIONS(5670),
    [anon_sym___forceinline__] = ACTIONS(5670),
    [anon_sym___noinline__] = ACTIONS(5670),
    [anon_sym_extern] = ACTIONS(5670),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5668),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5668),
    [anon_sym___declspec] = ACTIONS(5670),
    [anon_sym___based] = ACTIONS(5670),
    [anon_sym___cdecl] = ACTIONS(5670),
    [anon_sym___clrcall] = ACTIONS(5670),
    [anon_sym___stdcall] = ACTIONS(5670),
    [anon_sym___fastcall] = ACTIONS(5670),
    [anon_sym___thiscall] = ACTIONS(5670),
    [anon_sym___vectorcall] = ACTIONS(5670),
    [anon_sym_LBRACK] = ACTIONS(5670),
    [anon_sym_static] = ACTIONS(5670),
    [anon_sym_EQ] = ACTIONS(5668),
    [anon_sym_register] = ACTIONS(5670),
    [anon_sym_inline] = ACTIONS(5670),
    [anon_sym___inline] = ACTIONS(5670),
    [anon_sym___inline__] = ACTIONS(5670),
    [anon_sym___forceinline] = ACTIONS(5670),
    [anon_sym_thread_local] = ACTIONS(5670),
    [anon_sym___thread] = ACTIONS(5670),
    [anon_sym_const] = ACTIONS(5670),
    [anon_sym_constexpr] = ACTIONS(5670),
    [anon_sym_volatile] = ACTIONS(5670),
    [anon_sym_restrict] = ACTIONS(5670),
    [anon_sym___restrict__] = ACTIONS(5670),
    [anon_sym__Atomic] = ACTIONS(5670),
    [anon_sym__Noreturn] = ACTIONS(5670),
    [anon_sym_noreturn] = ACTIONS(5670),
    [anon_sym_mutable] = ACTIONS(5670),
    [anon_sym_constinit] = ACTIONS(5670),
    [anon_sym_consteval] = ACTIONS(5670),
    [anon_sym___shared__] = ACTIONS(5670),
    [anon_sym___local__] = ACTIONS(5670),
    [anon_sym___constant__] = ACTIONS(5670),
    [anon_sym___managed__] = ACTIONS(5670),
    [anon_sym___grid_constant__] = ACTIONS(5670),
    [anon_sym_alignas] = ACTIONS(5670),
    [anon_sym__Alignas] = ACTIONS(5670),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5670),
    [anon_sym_decltype] = ACTIONS(5670),
    [sym_virtual] = ACTIONS(5670),
    [anon_sym_template] = ACTIONS(5670),
    [anon_sym_GT2] = ACTIONS(5668),
    [anon_sym_operator] = ACTIONS(5670),
    [anon_sym___launch_bounds__] = ACTIONS(5670),
  },
  [2482] = {
    [sym_argument_list] = STATE(2738),
    [sym_subscript_argument_list] = STATE(2734),
    [sym_kernel_call_syntax] = STATE(8019),
    [sym_identifier] = ACTIONS(6068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6070),
    [anon_sym_COMMA] = ACTIONS(6070),
    [anon_sym_RPAREN] = ACTIONS(6070),
    [aux_sym_preproc_if_token2] = ACTIONS(6070),
    [aux_sym_preproc_else_token1] = ACTIONS(6070),
    [aux_sym_preproc_elif_token1] = ACTIONS(6068),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6070),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6070),
    [anon_sym_LPAREN2] = ACTIONS(5644),
    [anon_sym_DASH] = ACTIONS(6068),
    [anon_sym_PLUS] = ACTIONS(6068),
    [anon_sym_STAR] = ACTIONS(6068),
    [anon_sym_SLASH] = ACTIONS(6068),
    [anon_sym_PERCENT] = ACTIONS(6068),
    [anon_sym_PIPE_PIPE] = ACTIONS(6070),
    [anon_sym_AMP_AMP] = ACTIONS(6070),
    [anon_sym_PIPE] = ACTIONS(6068),
    [anon_sym_CARET] = ACTIONS(6068),
    [anon_sym_AMP] = ACTIONS(6068),
    [anon_sym_EQ_EQ] = ACTIONS(6070),
    [anon_sym_BANG_EQ] = ACTIONS(6070),
    [anon_sym_GT] = ACTIONS(6068),
    [anon_sym_GT_EQ] = ACTIONS(6070),
    [anon_sym_LT_EQ] = ACTIONS(6068),
    [anon_sym_LT] = ACTIONS(6068),
    [anon_sym_LT_LT] = ACTIONS(6068),
    [anon_sym_GT_GT] = ACTIONS(6068),
    [anon_sym_SEMI] = ACTIONS(6070),
    [anon_sym___attribute__] = ACTIONS(6068),
    [anon_sym_RBRACE] = ACTIONS(6070),
    [anon_sym_LBRACK] = ACTIONS(6056),
    [anon_sym_RBRACK] = ACTIONS(6070),
    [anon_sym_EQ] = ACTIONS(6068),
    [anon_sym_QMARK] = ACTIONS(6070),
    [anon_sym_STAR_EQ] = ACTIONS(6070),
    [anon_sym_SLASH_EQ] = ACTIONS(6070),
    [anon_sym_PERCENT_EQ] = ACTIONS(6070),
    [anon_sym_PLUS_EQ] = ACTIONS(6070),
    [anon_sym_DASH_EQ] = ACTIONS(6070),
    [anon_sym_LT_LT_EQ] = ACTIONS(6070),
    [anon_sym_GT_GT_EQ] = ACTIONS(6070),
    [anon_sym_AMP_EQ] = ACTIONS(6070),
    [anon_sym_CARET_EQ] = ACTIONS(6070),
    [anon_sym_PIPE_EQ] = ACTIONS(6070),
    [anon_sym_and_eq] = ACTIONS(6068),
    [anon_sym_or_eq] = ACTIONS(6068),
    [anon_sym_xor_eq] = ACTIONS(6068),
    [anon_sym_LT_EQ_GT] = ACTIONS(6070),
    [anon_sym_or] = ACTIONS(6068),
    [anon_sym_and] = ACTIONS(6068),
    [anon_sym_bitor] = ACTIONS(6068),
    [anon_sym_xor] = ACTIONS(6068),
    [anon_sym_bitand] = ACTIONS(6068),
    [anon_sym_not_eq] = ACTIONS(6068),
    [anon_sym_DASH_DASH] = ACTIONS(6070),
    [anon_sym_PLUS_PLUS] = ACTIONS(6070),
    [anon_sym_DOT] = ACTIONS(6060),
    [anon_sym_DOT_STAR] = ACTIONS(6062),
    [anon_sym_DASH_GT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(3),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(6070),
  },
  [2483] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5244),
    [anon_sym_COMMA] = ACTIONS(5244),
    [anon_sym_LPAREN2] = ACTIONS(5244),
    [anon_sym_DASH] = ACTIONS(5242),
    [anon_sym_PLUS] = ACTIONS(5242),
    [anon_sym_STAR] = ACTIONS(5244),
    [anon_sym_SLASH] = ACTIONS(5242),
    [anon_sym_PERCENT] = ACTIONS(5244),
    [anon_sym_PIPE_PIPE] = ACTIONS(5244),
    [anon_sym_AMP_AMP] = ACTIONS(5244),
    [anon_sym_PIPE] = ACTIONS(5242),
    [anon_sym_CARET] = ACTIONS(5244),
    [anon_sym_AMP] = ACTIONS(5242),
    [anon_sym_EQ_EQ] = ACTIONS(5244),
    [anon_sym_BANG_EQ] = ACTIONS(5244),
    [anon_sym_GT] = ACTIONS(5242),
    [anon_sym_GT_EQ] = ACTIONS(5242),
    [anon_sym_LT_EQ] = ACTIONS(5242),
    [anon_sym_LT] = ACTIONS(5242),
    [anon_sym_LT_LT] = ACTIONS(5242),
    [anon_sym_GT_GT] = ACTIONS(5242),
    [anon_sym___extension__] = ACTIONS(5244),
    [anon_sym___global__] = ACTIONS(5244),
    [anon_sym___attribute__] = ACTIONS(5244),
    [anon_sym_LBRACE] = ACTIONS(5244),
    [anon_sym_LBRACK] = ACTIONS(5244),
    [anon_sym_const] = ACTIONS(5242),
    [anon_sym_constexpr] = ACTIONS(5244),
    [anon_sym_volatile] = ACTIONS(5244),
    [anon_sym_restrict] = ACTIONS(5244),
    [anon_sym___restrict__] = ACTIONS(5244),
    [anon_sym__Atomic] = ACTIONS(5244),
    [anon_sym__Noreturn] = ACTIONS(5244),
    [anon_sym_noreturn] = ACTIONS(5244),
    [anon_sym_mutable] = ACTIONS(5244),
    [anon_sym_constinit] = ACTIONS(5244),
    [anon_sym_consteval] = ACTIONS(5244),
    [anon_sym___shared__] = ACTIONS(5244),
    [anon_sym___local__] = ACTIONS(5244),
    [anon_sym___constant__] = ACTIONS(5244),
    [anon_sym___managed__] = ACTIONS(5244),
    [anon_sym___grid_constant__] = ACTIONS(5244),
    [anon_sym_alignas] = ACTIONS(5244),
    [anon_sym__Alignas] = ACTIONS(5244),
    [anon_sym_QMARK] = ACTIONS(5244),
    [anon_sym_LT_EQ_GT] = ACTIONS(5244),
    [anon_sym_or] = ACTIONS(5244),
    [anon_sym_and] = ACTIONS(5244),
    [anon_sym_bitor] = ACTIONS(5244),
    [anon_sym_xor] = ACTIONS(5244),
    [anon_sym_bitand] = ACTIONS(5244),
    [anon_sym_not_eq] = ACTIONS(5244),
    [anon_sym_DASH_DASH] = ACTIONS(5244),
    [anon_sym_PLUS_PLUS] = ACTIONS(5244),
    [anon_sym_DOT] = ACTIONS(5242),
    [anon_sym_DOT_STAR] = ACTIONS(5244),
    [anon_sym_DASH_GT] = ACTIONS(5244),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5244),
    [anon_sym_decltype] = ACTIONS(5244),
    [anon_sym_final] = ACTIONS(5244),
    [anon_sym_override] = ACTIONS(5244),
    [anon_sym_GT2] = ACTIONS(5244),
    [anon_sym_requires] = ACTIONS(5244),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5244),
  },
  [2484] = {
    [sym_attribute_specifier] = STATE(2206),
    [sym_identifier] = ACTIONS(5696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5694),
    [anon_sym_COMMA] = ACTIONS(5694),
    [anon_sym_RPAREN] = ACTIONS(5694),
    [anon_sym_LPAREN2] = ACTIONS(5694),
    [anon_sym_TILDE] = ACTIONS(5694),
    [anon_sym_STAR] = ACTIONS(5694),
    [anon_sym_AMP_AMP] = ACTIONS(5694),
    [anon_sym_AMP] = ACTIONS(5696),
    [anon_sym_SEMI] = ACTIONS(5694),
    [anon_sym___extension__] = ACTIONS(5696),
    [anon_sym___device__] = ACTIONS(5696),
    [anon_sym___host__] = ACTIONS(5696),
    [anon_sym___global__] = ACTIONS(5696),
    [anon_sym___forceinline__] = ACTIONS(5696),
    [anon_sym___noinline__] = ACTIONS(5696),
    [anon_sym_extern] = ACTIONS(5696),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5694),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5694),
    [anon_sym___declspec] = ACTIONS(5696),
    [anon_sym___based] = ACTIONS(5696),
    [anon_sym___cdecl] = ACTIONS(5696),
    [anon_sym___clrcall] = ACTIONS(5696),
    [anon_sym___stdcall] = ACTIONS(5696),
    [anon_sym___fastcall] = ACTIONS(5696),
    [anon_sym___thiscall] = ACTIONS(5696),
    [anon_sym___vectorcall] = ACTIONS(5696),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_static] = ACTIONS(5696),
    [anon_sym_EQ] = ACTIONS(5694),
    [anon_sym_register] = ACTIONS(5696),
    [anon_sym_inline] = ACTIONS(5696),
    [anon_sym___inline] = ACTIONS(5696),
    [anon_sym___inline__] = ACTIONS(5696),
    [anon_sym___forceinline] = ACTIONS(5696),
    [anon_sym_thread_local] = ACTIONS(5696),
    [anon_sym___thread] = ACTIONS(5696),
    [anon_sym_const] = ACTIONS(5696),
    [anon_sym_constexpr] = ACTIONS(5696),
    [anon_sym_volatile] = ACTIONS(5696),
    [anon_sym_restrict] = ACTIONS(5696),
    [anon_sym___restrict__] = ACTIONS(5696),
    [anon_sym__Atomic] = ACTIONS(5696),
    [anon_sym__Noreturn] = ACTIONS(5696),
    [anon_sym_noreturn] = ACTIONS(5696),
    [anon_sym_mutable] = ACTIONS(5696),
    [anon_sym_constinit] = ACTIONS(5696),
    [anon_sym_consteval] = ACTIONS(5696),
    [anon_sym___shared__] = ACTIONS(5696),
    [anon_sym___local__] = ACTIONS(5696),
    [anon_sym___constant__] = ACTIONS(5696),
    [anon_sym___managed__] = ACTIONS(5696),
    [anon_sym___grid_constant__] = ACTIONS(5696),
    [anon_sym_alignas] = ACTIONS(5696),
    [anon_sym__Alignas] = ACTIONS(5696),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5696),
    [anon_sym_decltype] = ACTIONS(5696),
    [sym_virtual] = ACTIONS(5696),
    [anon_sym_template] = ACTIONS(5696),
    [anon_sym_GT2] = ACTIONS(5694),
    [anon_sym_operator] = ACTIONS(5696),
    [anon_sym___launch_bounds__] = ACTIONS(5696),
  },
  [2485] = {
    [sym_template_argument_list] = STATE(2487),
    [sym_identifier] = ACTIONS(6072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6074),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_RPAREN] = ACTIONS(6074),
    [aux_sym_preproc_if_token2] = ACTIONS(6074),
    [aux_sym_preproc_else_token1] = ACTIONS(6074),
    [aux_sym_preproc_elif_token1] = ACTIONS(6072),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6074),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6074),
    [anon_sym_LPAREN2] = ACTIONS(6074),
    [anon_sym_DASH] = ACTIONS(6072),
    [anon_sym_PLUS] = ACTIONS(6072),
    [anon_sym_STAR] = ACTIONS(6072),
    [anon_sym_SLASH] = ACTIONS(6072),
    [anon_sym_PERCENT] = ACTIONS(6072),
    [anon_sym_PIPE_PIPE] = ACTIONS(6074),
    [anon_sym_AMP_AMP] = ACTIONS(6074),
    [anon_sym_PIPE] = ACTIONS(6072),
    [anon_sym_CARET] = ACTIONS(6072),
    [anon_sym_AMP] = ACTIONS(6072),
    [anon_sym_EQ_EQ] = ACTIONS(6074),
    [anon_sym_BANG_EQ] = ACTIONS(6074),
    [anon_sym_GT] = ACTIONS(6072),
    [anon_sym_GT_EQ] = ACTIONS(6074),
    [anon_sym_LT_EQ] = ACTIONS(6072),
    [anon_sym_LT] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6072),
    [anon_sym_GT_GT] = ACTIONS(6072),
    [anon_sym_SEMI] = ACTIONS(6074),
    [anon_sym___attribute__] = ACTIONS(6072),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_RBRACE] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6074),
    [anon_sym_RBRACK] = ACTIONS(6074),
    [anon_sym_EQ] = ACTIONS(6072),
    [anon_sym_COLON] = ACTIONS(6072),
    [anon_sym_QMARK] = ACTIONS(6074),
    [anon_sym_STAR_EQ] = ACTIONS(6074),
    [anon_sym_SLASH_EQ] = ACTIONS(6074),
    [anon_sym_PERCENT_EQ] = ACTIONS(6074),
    [anon_sym_PLUS_EQ] = ACTIONS(6074),
    [anon_sym_DASH_EQ] = ACTIONS(6074),
    [anon_sym_LT_LT_EQ] = ACTIONS(6074),
    [anon_sym_GT_GT_EQ] = ACTIONS(6074),
    [anon_sym_AMP_EQ] = ACTIONS(6074),
    [anon_sym_CARET_EQ] = ACTIONS(6074),
    [anon_sym_PIPE_EQ] = ACTIONS(6074),
    [anon_sym_and_eq] = ACTIONS(6072),
    [anon_sym_or_eq] = ACTIONS(6072),
    [anon_sym_xor_eq] = ACTIONS(6072),
    [anon_sym_LT_EQ_GT] = ACTIONS(6074),
    [anon_sym_or] = ACTIONS(6072),
    [anon_sym_and] = ACTIONS(6072),
    [anon_sym_bitor] = ACTIONS(6072),
    [anon_sym_xor] = ACTIONS(6072),
    [anon_sym_bitand] = ACTIONS(6072),
    [anon_sym_not_eq] = ACTIONS(6072),
    [anon_sym_DASH_DASH] = ACTIONS(6074),
    [anon_sym_PLUS_PLUS] = ACTIONS(6074),
    [anon_sym_DOT] = ACTIONS(6072),
    [anon_sym_DOT_STAR] = ACTIONS(6074),
    [anon_sym_DASH_GT] = ACTIONS(6074),
    [sym_comment] = ACTIONS(3),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(6074),
  },
  [2486] = {
    [sym_identifier] = ACTIONS(5500),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5502),
    [anon_sym_COMMA] = ACTIONS(5502),
    [anon_sym_RPAREN] = ACTIONS(5502),
    [anon_sym_LPAREN2] = ACTIONS(5502),
    [anon_sym_DASH] = ACTIONS(5500),
    [anon_sym_PLUS] = ACTIONS(5500),
    [anon_sym_STAR] = ACTIONS(5500),
    [anon_sym_SLASH] = ACTIONS(5500),
    [anon_sym_PERCENT] = ACTIONS(5500),
    [anon_sym_PIPE_PIPE] = ACTIONS(5502),
    [anon_sym_AMP_AMP] = ACTIONS(5502),
    [anon_sym_PIPE] = ACTIONS(5500),
    [anon_sym_CARET] = ACTIONS(5500),
    [anon_sym_AMP] = ACTIONS(5500),
    [anon_sym_EQ_EQ] = ACTIONS(5502),
    [anon_sym_BANG_EQ] = ACTIONS(5502),
    [anon_sym_GT] = ACTIONS(5500),
    [anon_sym_GT_EQ] = ACTIONS(5502),
    [anon_sym_LT_EQ] = ACTIONS(5500),
    [anon_sym_LT] = ACTIONS(5500),
    [anon_sym_LT_LT] = ACTIONS(5500),
    [anon_sym_GT_GT] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5502),
    [anon_sym_EQ] = ACTIONS(5500),
    [anon_sym_QMARK] = ACTIONS(5502),
    [anon_sym_STAR_EQ] = ACTIONS(5502),
    [anon_sym_SLASH_EQ] = ACTIONS(5502),
    [anon_sym_PERCENT_EQ] = ACTIONS(5502),
    [anon_sym_PLUS_EQ] = ACTIONS(5502),
    [anon_sym_DASH_EQ] = ACTIONS(5502),
    [anon_sym_LT_LT_EQ] = ACTIONS(5502),
    [anon_sym_GT_GT_EQ] = ACTIONS(5502),
    [anon_sym_AMP_EQ] = ACTIONS(5502),
    [anon_sym_CARET_EQ] = ACTIONS(5502),
    [anon_sym_PIPE_EQ] = ACTIONS(5502),
    [anon_sym_and_eq] = ACTIONS(5500),
    [anon_sym_or_eq] = ACTIONS(5500),
    [anon_sym_xor_eq] = ACTIONS(5500),
    [anon_sym_LT_EQ_GT] = ACTIONS(5502),
    [anon_sym_or] = ACTIONS(5500),
    [anon_sym_and] = ACTIONS(5500),
    [anon_sym_bitor] = ACTIONS(5500),
    [anon_sym_xor] = ACTIONS(5500),
    [anon_sym_bitand] = ACTIONS(5500),
    [anon_sym_not_eq] = ACTIONS(5500),
    [anon_sym_DASH_DASH] = ACTIONS(5502),
    [anon_sym_PLUS_PLUS] = ACTIONS(5502),
    [anon_sym_DOT] = ACTIONS(5500),
    [anon_sym_DOT_STAR] = ACTIONS(5502),
    [anon_sym_DASH_GT] = ACTIONS(5500),
    [anon_sym_L_DQUOTE] = ACTIONS(5502),
    [anon_sym_u_DQUOTE] = ACTIONS(5502),
    [anon_sym_U_DQUOTE] = ACTIONS(5502),
    [anon_sym_u8_DQUOTE] = ACTIONS(5502),
    [anon_sym_DQUOTE] = ACTIONS(5502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5502),
    [anon_sym_LR_DQUOTE] = ACTIONS(5502),
    [anon_sym_uR_DQUOTE] = ACTIONS(5502),
    [anon_sym_UR_DQUOTE] = ACTIONS(5502),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5502),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5502),
    [sym_literal_suffix] = ACTIONS(5500),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5502),
  },
  [2487] = {
    [sym_identifier] = ACTIONS(6079),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6081),
    [anon_sym_RPAREN] = ACTIONS(6081),
    [aux_sym_preproc_if_token2] = ACTIONS(6081),
    [aux_sym_preproc_else_token1] = ACTIONS(6081),
    [aux_sym_preproc_elif_token1] = ACTIONS(6079),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6081),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6081),
    [anon_sym_LPAREN2] = ACTIONS(6081),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6079),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_PERCENT] = ACTIONS(6079),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_PIPE] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6079),
    [anon_sym_AMP] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6079),
    [anon_sym_GT_EQ] = ACTIONS(6081),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6079),
    [anon_sym_LT_LT] = ACTIONS(6079),
    [anon_sym_GT_GT] = ACTIONS(6079),
    [anon_sym_SEMI] = ACTIONS(6081),
    [anon_sym___attribute__] = ACTIONS(6079),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_LBRACE] = ACTIONS(6081),
    [anon_sym_RBRACE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(6081),
    [anon_sym_RBRACK] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6079),
    [anon_sym_COLON] = ACTIONS(6079),
    [anon_sym_QMARK] = ACTIONS(6081),
    [anon_sym_STAR_EQ] = ACTIONS(6081),
    [anon_sym_SLASH_EQ] = ACTIONS(6081),
    [anon_sym_PERCENT_EQ] = ACTIONS(6081),
    [anon_sym_PLUS_EQ] = ACTIONS(6081),
    [anon_sym_DASH_EQ] = ACTIONS(6081),
    [anon_sym_LT_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT_GT_EQ] = ACTIONS(6081),
    [anon_sym_AMP_EQ] = ACTIONS(6081),
    [anon_sym_CARET_EQ] = ACTIONS(6081),
    [anon_sym_PIPE_EQ] = ACTIONS(6081),
    [anon_sym_and_eq] = ACTIONS(6079),
    [anon_sym_or_eq] = ACTIONS(6079),
    [anon_sym_xor_eq] = ACTIONS(6079),
    [anon_sym_LT_EQ_GT] = ACTIONS(6081),
    [anon_sym_or] = ACTIONS(6079),
    [anon_sym_and] = ACTIONS(6079),
    [anon_sym_bitor] = ACTIONS(6079),
    [anon_sym_xor] = ACTIONS(6079),
    [anon_sym_bitand] = ACTIONS(6079),
    [anon_sym_not_eq] = ACTIONS(6079),
    [anon_sym_DASH_DASH] = ACTIONS(6081),
    [anon_sym_PLUS_PLUS] = ACTIONS(6081),
    [anon_sym_DOT] = ACTIONS(6079),
    [anon_sym_DOT_STAR] = ACTIONS(6081),
    [anon_sym_DASH_GT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(3),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(6081),
  },
  [2488] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5376),
    [anon_sym_COMMA] = ACTIONS(5376),
    [anon_sym_LPAREN2] = ACTIONS(5376),
    [anon_sym_DASH] = ACTIONS(5374),
    [anon_sym_PLUS] = ACTIONS(5374),
    [anon_sym_STAR] = ACTIONS(5376),
    [anon_sym_SLASH] = ACTIONS(5374),
    [anon_sym_PERCENT] = ACTIONS(5376),
    [anon_sym_PIPE_PIPE] = ACTIONS(5376),
    [anon_sym_AMP_AMP] = ACTIONS(5376),
    [anon_sym_PIPE] = ACTIONS(5374),
    [anon_sym_CARET] = ACTIONS(5376),
    [anon_sym_AMP] = ACTIONS(5374),
    [anon_sym_EQ_EQ] = ACTIONS(5376),
    [anon_sym_BANG_EQ] = ACTIONS(5376),
    [anon_sym_GT] = ACTIONS(5374),
    [anon_sym_GT_EQ] = ACTIONS(5374),
    [anon_sym_LT_EQ] = ACTIONS(5374),
    [anon_sym_LT] = ACTIONS(5374),
    [anon_sym_LT_LT] = ACTIONS(5374),
    [anon_sym_GT_GT] = ACTIONS(5374),
    [anon_sym___extension__] = ACTIONS(5376),
    [anon_sym___global__] = ACTIONS(5376),
    [anon_sym___attribute__] = ACTIONS(5376),
    [anon_sym_LBRACE] = ACTIONS(5376),
    [anon_sym_LBRACK] = ACTIONS(5376),
    [anon_sym_const] = ACTIONS(5374),
    [anon_sym_constexpr] = ACTIONS(5376),
    [anon_sym_volatile] = ACTIONS(5376),
    [anon_sym_restrict] = ACTIONS(5376),
    [anon_sym___restrict__] = ACTIONS(5376),
    [anon_sym__Atomic] = ACTIONS(5376),
    [anon_sym__Noreturn] = ACTIONS(5376),
    [anon_sym_noreturn] = ACTIONS(5376),
    [anon_sym_mutable] = ACTIONS(5376),
    [anon_sym_constinit] = ACTIONS(5376),
    [anon_sym_consteval] = ACTIONS(5376),
    [anon_sym___shared__] = ACTIONS(5376),
    [anon_sym___local__] = ACTIONS(5376),
    [anon_sym___constant__] = ACTIONS(5376),
    [anon_sym___managed__] = ACTIONS(5376),
    [anon_sym___grid_constant__] = ACTIONS(5376),
    [anon_sym_alignas] = ACTIONS(5376),
    [anon_sym__Alignas] = ACTIONS(5376),
    [anon_sym_QMARK] = ACTIONS(5376),
    [anon_sym_LT_EQ_GT] = ACTIONS(5376),
    [anon_sym_or] = ACTIONS(5376),
    [anon_sym_and] = ACTIONS(5376),
    [anon_sym_bitor] = ACTIONS(5376),
    [anon_sym_xor] = ACTIONS(5376),
    [anon_sym_bitand] = ACTIONS(5376),
    [anon_sym_not_eq] = ACTIONS(5376),
    [anon_sym_DASH_DASH] = ACTIONS(5376),
    [anon_sym_PLUS_PLUS] = ACTIONS(5376),
    [anon_sym_DOT] = ACTIONS(5374),
    [anon_sym_DOT_STAR] = ACTIONS(5376),
    [anon_sym_DASH_GT] = ACTIONS(5376),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5376),
    [anon_sym_decltype] = ACTIONS(5376),
    [anon_sym_final] = ACTIONS(5376),
    [anon_sym_override] = ACTIONS(5376),
    [anon_sym_GT2] = ACTIONS(5376),
    [anon_sym_requires] = ACTIONS(5376),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5376),
  },
  [2489] = {
    [sym_string_literal] = STATE(2489),
    [sym_raw_string_literal] = STATE(2489),
    [aux_sym_concatenated_string_repeat1] = STATE(2489),
    [sym_identifier] = ACTIONS(6083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5267),
    [anon_sym_COMMA] = ACTIONS(5267),
    [anon_sym_RPAREN] = ACTIONS(5267),
    [anon_sym_LPAREN2] = ACTIONS(5267),
    [anon_sym_DASH] = ACTIONS(5269),
    [anon_sym_PLUS] = ACTIONS(5269),
    [anon_sym_STAR] = ACTIONS(5269),
    [anon_sym_SLASH] = ACTIONS(5269),
    [anon_sym_PERCENT] = ACTIONS(5269),
    [anon_sym_PIPE_PIPE] = ACTIONS(5267),
    [anon_sym_AMP_AMP] = ACTIONS(5267),
    [anon_sym_PIPE] = ACTIONS(5269),
    [anon_sym_CARET] = ACTIONS(5269),
    [anon_sym_AMP] = ACTIONS(5269),
    [anon_sym_EQ_EQ] = ACTIONS(5267),
    [anon_sym_BANG_EQ] = ACTIONS(5267),
    [anon_sym_GT] = ACTIONS(5269),
    [anon_sym_GT_EQ] = ACTIONS(5267),
    [anon_sym_LT_EQ] = ACTIONS(5269),
    [anon_sym_LT] = ACTIONS(5269),
    [anon_sym_LT_LT] = ACTIONS(5269),
    [anon_sym_GT_GT] = ACTIONS(5269),
    [anon_sym_LBRACK] = ACTIONS(5267),
    [anon_sym_EQ] = ACTIONS(5269),
    [anon_sym_QMARK] = ACTIONS(5267),
    [anon_sym_STAR_EQ] = ACTIONS(5267),
    [anon_sym_SLASH_EQ] = ACTIONS(5267),
    [anon_sym_PERCENT_EQ] = ACTIONS(5267),
    [anon_sym_PLUS_EQ] = ACTIONS(5267),
    [anon_sym_DASH_EQ] = ACTIONS(5267),
    [anon_sym_LT_LT_EQ] = ACTIONS(5267),
    [anon_sym_GT_GT_EQ] = ACTIONS(5267),
    [anon_sym_AMP_EQ] = ACTIONS(5267),
    [anon_sym_CARET_EQ] = ACTIONS(5267),
    [anon_sym_PIPE_EQ] = ACTIONS(5267),
    [anon_sym_LT_EQ_GT] = ACTIONS(5267),
    [anon_sym_or] = ACTIONS(5269),
    [anon_sym_and] = ACTIONS(5269),
    [anon_sym_bitor] = ACTIONS(5269),
    [anon_sym_xor] = ACTIONS(5269),
    [anon_sym_bitand] = ACTIONS(5269),
    [anon_sym_not_eq] = ACTIONS(5269),
    [anon_sym_DASH_DASH] = ACTIONS(5267),
    [anon_sym_PLUS_PLUS] = ACTIONS(5267),
    [anon_sym_DOT] = ACTIONS(5269),
    [anon_sym_DOT_STAR] = ACTIONS(5267),
    [anon_sym_DASH_GT] = ACTIONS(5269),
    [anon_sym_L_DQUOTE] = ACTIONS(6086),
    [anon_sym_u_DQUOTE] = ACTIONS(6086),
    [anon_sym_U_DQUOTE] = ACTIONS(6086),
    [anon_sym_u8_DQUOTE] = ACTIONS(6086),
    [anon_sym_DQUOTE] = ACTIONS(6086),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6089),
    [anon_sym_LR_DQUOTE] = ACTIONS(6089),
    [anon_sym_uR_DQUOTE] = ACTIONS(6089),
    [anon_sym_UR_DQUOTE] = ACTIONS(6089),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6089),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5267),
    [sym_literal_suffix] = ACTIONS(5269),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5267),
  },
  [2490] = {
    [sym_string_literal] = STATE(2347),
    [sym_raw_string_literal] = STATE(2347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5712),
    [anon_sym_COMMA] = ACTIONS(5712),
    [anon_sym_LPAREN2] = ACTIONS(5712),
    [anon_sym_DASH] = ACTIONS(5710),
    [anon_sym_PLUS] = ACTIONS(5710),
    [anon_sym_STAR] = ACTIONS(5710),
    [anon_sym_SLASH] = ACTIONS(5710),
    [anon_sym_PERCENT] = ACTIONS(5710),
    [anon_sym_PIPE_PIPE] = ACTIONS(5712),
    [anon_sym_AMP_AMP] = ACTIONS(5712),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_CARET] = ACTIONS(5710),
    [anon_sym_AMP] = ACTIONS(5710),
    [anon_sym_EQ_EQ] = ACTIONS(5712),
    [anon_sym_BANG_EQ] = ACTIONS(5712),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_EQ] = ACTIONS(5712),
    [anon_sym_LT_EQ] = ACTIONS(5710),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5710),
    [anon_sym_LBRACK] = ACTIONS(5712),
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_QMARK] = ACTIONS(5712),
    [anon_sym_STAR_EQ] = ACTIONS(5712),
    [anon_sym_SLASH_EQ] = ACTIONS(5712),
    [anon_sym_PERCENT_EQ] = ACTIONS(5712),
    [anon_sym_PLUS_EQ] = ACTIONS(5712),
    [anon_sym_DASH_EQ] = ACTIONS(5712),
    [anon_sym_LT_LT_EQ] = ACTIONS(5712),
    [anon_sym_GT_GT_EQ] = ACTIONS(5712),
    [anon_sym_AMP_EQ] = ACTIONS(5712),
    [anon_sym_CARET_EQ] = ACTIONS(5712),
    [anon_sym_PIPE_EQ] = ACTIONS(5712),
    [anon_sym_and_eq] = ACTIONS(5710),
    [anon_sym_or_eq] = ACTIONS(5710),
    [anon_sym_xor_eq] = ACTIONS(5710),
    [anon_sym_LT_EQ_GT] = ACTIONS(5712),
    [anon_sym_or] = ACTIONS(5710),
    [anon_sym_and] = ACTIONS(5710),
    [anon_sym_bitor] = ACTIONS(5710),
    [anon_sym_xor] = ACTIONS(5710),
    [anon_sym_bitand] = ACTIONS(5710),
    [anon_sym_not_eq] = ACTIONS(5710),
    [anon_sym_DASH_DASH] = ACTIONS(5712),
    [anon_sym_PLUS_PLUS] = ACTIONS(5712),
    [anon_sym_DOT] = ACTIONS(5710),
    [anon_sym_DOT_STAR] = ACTIONS(5712),
    [anon_sym_DASH_GT] = ACTIONS(5712),
    [anon_sym_L_DQUOTE] = ACTIONS(5863),
    [anon_sym_u_DQUOTE] = ACTIONS(5863),
    [anon_sym_U_DQUOTE] = ACTIONS(5863),
    [anon_sym_u8_DQUOTE] = ACTIONS(5863),
    [anon_sym_DQUOTE] = ACTIONS(5863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5865),
    [anon_sym_LR_DQUOTE] = ACTIONS(5865),
    [anon_sym_uR_DQUOTE] = ACTIONS(5865),
    [anon_sym_UR_DQUOTE] = ACTIONS(5865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5865),
    [sym_literal_suffix] = ACTIONS(6092),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5712),
    [aux_sym_kernel_call_syntax_token2] = ACTIONS(5712),
  },
  [2491] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5376),
    [anon_sym_COMMA] = ACTIONS(5376),
    [anon_sym_RPAREN] = ACTIONS(5376),
    [anon_sym_LPAREN2] = ACTIONS(5376),
    [anon_sym_DASH] = ACTIONS(5374),
    [anon_sym_PLUS] = ACTIONS(5374),
    [anon_sym_STAR] = ACTIONS(5374),
    [anon_sym_SLASH] = ACTIONS(5374),
    [anon_sym_PERCENT] = ACTIONS(5374),
    [anon_sym_PIPE_PIPE] = ACTIONS(5376),
    [anon_sym_AMP_AMP] = ACTIONS(5376),
    [anon_sym_PIPE] = ACTIONS(5374),
    [anon_sym_CARET] = ACTIONS(5374),
    [anon_sym_AMP] = ACTIONS(5374),
    [anon_sym_EQ_EQ] = ACTIONS(5376),
    [anon_sym_BANG_EQ] = ACTIONS(5376),
    [anon_sym_GT] = ACTIONS(5374),
    [anon_sym_GT_EQ] = ACTIONS(5376),
    [anon_sym_LT_EQ] = ACTIONS(5374),
    [anon_sym_LT] = ACTIONS(5374),
    [anon_sym_LT_LT] = ACTIONS(5374),
    [anon_sym_GT_GT] = ACTIONS(5374),
    [anon_sym_SEMI] = ACTIONS(5376),
    [anon_sym___attribute__] = ACTIONS(5376),
    [anon_sym_LBRACE] = ACTIONS(5376),
    [anon_sym_RBRACE] = ACTIONS(5376),
    [anon_sym_signed] = ACTIONS(6094),
    [anon_sym_unsigned] = ACTIONS(6094),
    [anon_sym_long] = ACTIONS(6094),
    [anon_sym_short] = ACTIONS(6094),
    [anon_sym_LBRACK] = ACTIONS(5376),
    [anon_sym_RBRACK] = ACTIONS(5376),
    [anon_sym_EQ] = ACTIONS(5374),
    [anon_sym_COLON] = ACTIONS(5376),
    [anon_sym_QMARK] = ACTIONS(5376),
    [anon_sym_STAR_EQ] = ACTIONS(5376),
    [anon_sym_SLASH_EQ] = ACTIONS(5376),
    [anon_sym_PERCENT_EQ] = ACTIONS(5376),
    [anon_sym_PLUS_EQ] = ACTIONS(5376),
    [anon_sym_DASH_EQ] = ACTIONS(5376),
    [anon_sym_LT_LT_EQ] = ACTIONS(5376),
    [anon_sym_GT_GT_EQ] = ACTIONS(5376),
    [anon_sym_AMP_EQ] = ACTIONS(5376),
    [anon_sym_CARET_EQ] = ACTIONS(5376),
    [anon_sym_PIPE_EQ] = ACTIONS(5376),
    [anon_sym_and_eq] = ACTIONS(5376),
    [anon_sym_or_eq] = ACTIONS(5376),
    [anon_sym_xor_eq] = ACTIONS(5376),
    [anon_sym_LT_EQ_GT] = ACTIONS(5376),
    [anon_sym_or] = ACTIONS(5374),
    [anon_sym_and] = ACTIONS(5374),
    [anon_sym_bitor] = ACTIONS(5376),
    [anon_sym_xor] = ACTIONS(5374),
    [anon_sym_bitand] = ACTIONS(5376),
    [anon_sym_not_eq] = ACTIONS(5376),
    [anon_sym_DASH_DASH] = ACTIONS(5376),
    [anon_sym_PLUS_PLUS] = ACTIONS(5376),
    [anon_sym_DOT] = ACTIONS(5374),
    [anon_sym_DOT_STAR] = ACTIONS(5376),
    [anon_sym_DASH_GT] = ACTIONS(5376),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5376),
    [anon_sym_decltype] = ACTIONS(5376),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5376),
  },
  [2492] = {
    [sym_attribute_specifier] = STATE(2177),
    [sym_identifier] = ACTIONS(5688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5686),
    [anon_sym_COMMA] = ACTIONS(5686),
    [anon_sym_RPAREN] = ACTIONS(5686),
    [anon_sym_LPAREN2] = ACTIONS(5686),
    [anon_sym_TILDE] = ACTIONS(5686),
    [anon_sym_STAR] = ACTIONS(5686),
    [anon_sym_AMP_AMP] = ACTIONS(5686),
    [anon_sym_AMP] = ACTIONS(5688),
    [anon_sym_SEMI] = ACTIONS(5686),
    [anon_sym___extension__] = ACTIONS(5688),
    [anon_sym___device__] = ACTIONS(5688),
    [anon_sym___host__] = ACTIONS(5688),
    [anon_sym___global__] = ACTIONS(5688),
    [anon_sym___forceinline__] = ACTIONS(5688),
    [anon_sym___noinline__] = ACTIONS(5688),
    [anon_sym_extern] = ACTIONS(5688),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5686),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5686),
    [anon_sym___declspec] = ACTIONS(5688),
    [anon_sym___based] = ACTIONS(5688),
    [anon_sym___cdecl] = ACTIONS(5688),
    [anon_sym___clrcall] = ACTIONS(5688),
    [anon_sym___stdcall] = ACTIONS(5688),
    [anon_sym___fastcall] = ACTIONS(5688),
    [anon_sym___thiscall] = ACTIONS(5688),
    [anon_sym___vectorcall] = ACTIONS(5688),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_static] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5686),
    [anon_sym_register] = ACTIONS(5688),
    [anon_sym_inline] = ACTIONS(5688),
    [anon_sym___inline] = ACTIONS(5688),
    [anon_sym___inline__] = ACTIONS(5688),
    [anon_sym___forceinline] = ACTIONS(5688),
    [anon_sym_thread_local] = ACTIONS(5688),
    [anon_sym___thread] = ACTIONS(5688),
    [anon_sym_const] = ACTIONS(5688),
    [anon_sym_constexpr] = ACTIONS(5688),
    [anon_sym_volatile] = ACTIONS(5688),
    [anon_sym_restrict] = ACTIONS(5688),
    [anon_sym___restrict__] = ACTIONS(5688),
    [anon_sym__Atomic] = ACTIONS(5688),
    [anon_sym__Noreturn] = ACTIONS(5688),
    [anon_sym_noreturn] = ACTIONS(5688),
    [anon_sym_mutable] = ACTIONS(5688),
    [anon_sym_constinit] = ACTIONS(5688),
    [anon_sym_consteval] = ACTIONS(5688),
    [anon_sym___shared__] = ACTIONS(5688),
    [anon_sym___local__] = ACTIONS(5688),
    [anon_sym___constant__] = ACTIONS(5688),
    [anon_sym___managed__] = ACTIONS(5688),
    [anon_sym___grid_constant__] = ACTIONS(5688),
    [anon_sym_alignas] = ACTIONS(5688),
    [anon_sym__Alignas] = ACTIONS(5688),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5688),
    [anon_sym_decltype] = ACTIONS(5688),
    [sym_virtual] = ACTIONS(5688),
    [anon_sym_template] = ACTIONS(5688),
    [anon_sym_GT2] = ACTIONS(5686),
    [anon_sym_operator] = ACTIONS(5688),
    [anon_sym___launch_bounds__] = ACTIONS(5688),
  },
  [2493] = {
    [sym_identifier] = ACTIONS(5500),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5502),
    [anon_sym_COMMA] = ACTIONS(5502),
    [anon_sym_LPAREN2] = ACTIONS(5502),
    [anon_sym_DASH] = ACTIONS(5500),
    [anon_sym_PLUS] = ACTIONS(5500),
    [anon_sym_STAR] = ACTIONS(5500),
    [anon_sym_SLASH] = ACTIONS(5500),
    [anon_sym_PERCENT] = ACTIONS(5500),
    [anon_sym_PIPE_PIPE] = ACTIONS(5502),
    [anon_sym_AMP_AMP] = ACTIONS(5502),
    [anon_sym_PIPE] = ACTIONS(5500),
    [anon_sym_CARET] = ACTIONS(5500),
    [anon_sym_AMP] = ACTIONS(5500),
    [anon_sym_EQ_EQ] = ACTIONS(5502),
    [anon_sym_BANG_EQ] = ACTIONS(5502),
    [anon_sym_GT] = ACTIONS(5500),
    [anon_sym_GT_EQ] = ACTIONS(5502),
    [anon_sym_LT_EQ] = ACTIONS(5500),
    [anon_sym_LT] = ACTIONS(5500),
    [anon_sym_LT_LT] = ACTIONS(5500),
    [anon_sym_GT_GT] = ACTIONS(5500),
    [anon_sym_SEMI] = ACTIONS(5502),
    [anon_sym___attribute__] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5502),
    [anon_sym_EQ] = ACTIONS(5500),
    [anon_sym_QMARK] = ACTIONS(5502),
    [anon_sym_STAR_EQ] = ACTIONS(5502),
    [anon_sym_SLASH_EQ] = ACTIONS(5502),
    [anon_sym_PERCENT_EQ] = ACTIONS(5502),
    [anon_sym_PLUS_EQ] = ACTIONS(5502),
    [anon_sym_DASH_EQ] = ACTIONS(5502),
    [anon_sym_LT_LT_EQ] = ACTIONS(5502),
    [anon_sym_GT_GT_EQ] = ACTIONS(5502),
    [anon_sym_AMP_EQ] = ACTIONS(5502),
    [anon_sym_CARET_EQ] = ACTIONS(5502),
    [anon_sym_PIPE_EQ] = ACTIONS(5502),
    [anon_sym_and_eq] = ACTIONS(5500),
    [anon_sym_or_eq] = ACTIONS(5500),
    [anon_sym_xor_eq] = ACTIONS(5500),
    [anon_sym_LT_EQ_GT] = ACTIONS(5502),
    [anon_sym_or] = ACTIONS(5500),
    [anon_sym_and] = ACTIONS(5500),
    [anon_sym_bitor] = ACTIONS(5500),
    [anon_sym_xor] = ACTIONS(5500),
    [anon_sym_bitand] = ACTIONS(5500),
    [anon_sym_not_eq] = ACTIONS(5500),
    [anon_sym_DASH_DASH] = ACTIONS(5502),
    [anon_sym_PLUS_PLUS] = ACTIONS(5502),
    [anon_sym_DOT] = ACTIONS(5500),
    [anon_sym_DOT_STAR] = ACTIONS(5502),
    [anon_sym_DASH_GT] = ACTIONS(5502),
    [anon_sym_L_DQUOTE] = ACTIONS(5502),
    [anon_sym_u_DQUOTE] = ACTIONS(5502),
    [anon_sym_U_DQUOTE] = ACTIONS(5502),
    [anon_sym_u8_DQUOTE] = ACTIONS(5502),
    [anon_sym_DQUOTE] = ACTIONS(5502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5502),
    [anon_sym_LR_DQUOTE] = ACTIONS(5502),
    [anon_sym_uR_DQUOTE] = ACTIONS(5502),
    [anon_sym_UR_DQUOTE] = ACTIONS(5502),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5502),
    [sym_literal_suffix] = ACTIONS(5500),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5502),
  },
  [2494] = {
    [sym_string_literal] = STATE(2336),
    [sym_raw_string_literal] = STATE(2336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3766),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3758),
    [anon_sym_SLASH_EQ] = ACTIONS(3758),
    [anon_sym_PERCENT_EQ] = ACTIONS(3758),
    [anon_sym_PLUS_EQ] = ACTIONS(3758),
    [anon_sym_DASH_EQ] = ACTIONS(3758),
    [anon_sym_LT_LT_EQ] = ACTIONS(3758),
    [anon_sym_GT_GT_EQ] = ACTIONS(3766),
    [anon_sym_AMP_EQ] = ACTIONS(3758),
    [anon_sym_CARET_EQ] = ACTIONS(3758),
    [anon_sym_PIPE_EQ] = ACTIONS(3758),
    [anon_sym_and_eq] = ACTIONS(3766),
    [anon_sym_or_eq] = ACTIONS(3766),
    [anon_sym_xor_eq] = ACTIONS(3766),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3766),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3766),
    [anon_sym_not_eq] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(5893),
    [anon_sym_u_DQUOTE] = ACTIONS(5893),
    [anon_sym_U_DQUOTE] = ACTIONS(5893),
    [anon_sym_u8_DQUOTE] = ACTIONS(5893),
    [anon_sym_DQUOTE] = ACTIONS(5893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(3758),
    [anon_sym_R_DQUOTE] = ACTIONS(5895),
    [anon_sym_LR_DQUOTE] = ACTIONS(5895),
    [anon_sym_uR_DQUOTE] = ACTIONS(5895),
    [anon_sym_UR_DQUOTE] = ACTIONS(5895),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5895),
    [sym_literal_suffix] = ACTIONS(6036),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
  },
  [2495] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5205),
    [anon_sym_COMMA] = ACTIONS(5205),
    [anon_sym_LPAREN2] = ACTIONS(5205),
    [anon_sym_DASH] = ACTIONS(5203),
    [anon_sym_PLUS] = ACTIONS(5203),
    [anon_sym_STAR] = ACTIONS(5205),
    [anon_sym_SLASH] = ACTIONS(5203),
    [anon_sym_PERCENT] = ACTIONS(5205),
    [anon_sym_PIPE_PIPE] = ACTIONS(5205),
    [anon_sym_AMP_AMP] = ACTIONS(5205),
    [anon_sym_PIPE] = ACTIONS(5203),
    [anon_sym_CARET] = ACTIONS(5205),
    [anon_sym_AMP] = ACTIONS(5203),
    [anon_sym_EQ_EQ] = ACTIONS(5205),
    [anon_sym_BANG_EQ] = ACTIONS(5205),
    [anon_sym_GT] = ACTIONS(5203),
    [anon_sym_GT_EQ] = ACTIONS(5203),
    [anon_sym_LT_EQ] = ACTIONS(5203),
    [anon_sym_LT] = ACTIONS(5203),
    [anon_sym_LT_LT] = ACTIONS(5203),
    [anon_sym_GT_GT] = ACTIONS(5203),
    [anon_sym___extension__] = ACTIONS(5205),
    [anon_sym___global__] = ACTIONS(5205),
    [anon_sym_COLON_COLON] = ACTIONS(5205),
    [anon_sym_LBRACE] = ACTIONS(5205),
    [anon_sym_LBRACK] = ACTIONS(5205),
    [anon_sym_const] = ACTIONS(5203),
    [anon_sym_constexpr] = ACTIONS(5205),
    [anon_sym_volatile] = ACTIONS(5205),
    [anon_sym_restrict] = ACTIONS(5205),
    [anon_sym___restrict__] = ACTIONS(5205),
    [anon_sym__Atomic] = ACTIONS(5205),
    [anon_sym__Noreturn] = ACTIONS(5205),
    [anon_sym_noreturn] = ACTIONS(5205),
    [anon_sym_mutable] = ACTIONS(5205),
    [anon_sym_constinit] = ACTIONS(5205),
    [anon_sym_consteval] = ACTIONS(5205),
    [anon_sym___shared__] = ACTIONS(5205),
    [anon_sym___local__] = ACTIONS(5205),
    [anon_sym___constant__] = ACTIONS(5205),
    [anon_sym___managed__] = ACTIONS(5205),
    [anon_sym___grid_constant__] = ACTIONS(5205),
    [anon_sym_alignas] = ACTIONS(5205),
    [anon_sym__Alignas] = ACTIONS(5205),
    [anon_sym_QMARK] = ACTIONS(5205),
    [anon_sym_LT_EQ_GT] = ACTIONS(5205),
    [anon_sym_or] = ACTIONS(5205),
    [anon_sym_and] = ACTIONS(5205),
    [anon_sym_bitor] = ACTIONS(5205),
    [anon_sym_xor] = ACTIONS(5205),
    [anon_sym_bitand] = ACTIONS(5205),
    [anon_sym_not_eq] = ACTIONS(5205),
    [anon_sym_DASH_DASH] = ACTIONS(5205),
    [anon_sym_PLUS_PLUS] = ACTIONS(5205),
    [anon_sym_DOT] = ACTIONS(5203),
    [anon_sym_DOT_STAR] = ACTIONS(5205),
    [anon_sym_DASH_GT] = ACTIONS(5205),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5205),
    [anon_sym_decltype] = ACTIONS(5205),
    [anon_sym_final] = ACTIONS(5205),
    [anon_sym_override] = ACTIONS(5205),
    [anon_sym_GT2] = ACTIONS(5205),
    [anon_sym_requires] = ACTIONS(5205),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5205),
  },
  [2496] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5416),
    [anon_sym_COMMA] = ACTIONS(5416),
    [anon_sym_RPAREN] = ACTIONS(5416),
    [anon_sym_LPAREN2] = ACTIONS(5416),
    [anon_sym_DASH] = ACTIONS(5418),
    [anon_sym_PLUS] = ACTIONS(5418),
    [anon_sym_STAR] = ACTIONS(5418),
    [anon_sym_SLASH] = ACTIONS(5418),
    [anon_sym_PERCENT] = ACTIONS(5418),
    [anon_sym_PIPE_PIPE] = ACTIONS(5416),
    [anon_sym_AMP_AMP] = ACTIONS(5416),
    [anon_sym_PIPE] = ACTIONS(5418),
    [anon_sym_CARET] = ACTIONS(5418),
    [anon_sym_AMP] = ACTIONS(5418),
    [anon_sym_EQ_EQ] = ACTIONS(5416),
    [anon_sym_BANG_EQ] = ACTIONS(5416),
    [anon_sym_GT] = ACTIONS(5418),
    [anon_sym_GT_EQ] = ACTIONS(5416),
    [anon_sym_LT_EQ] = ACTIONS(5418),
    [anon_sym_LT] = ACTIONS(5418),
    [anon_sym_LT_LT] = ACTIONS(5418),
    [anon_sym_GT_GT] = ACTIONS(5418),
    [anon_sym_SEMI] = ACTIONS(5416),
    [anon_sym___attribute__] = ACTIONS(5416),
    [anon_sym_LBRACE] = ACTIONS(5416),
    [anon_sym_RBRACE] = ACTIONS(5416),
    [anon_sym_signed] = ACTIONS(6034),
    [anon_sym_unsigned] = ACTIONS(6034),
    [anon_sym_long] = ACTIONS(6034),
    [anon_sym_short] = ACTIONS(6034),
    [anon_sym_LBRACK] = ACTIONS(5416),
    [anon_sym_RBRACK] = ACTIONS(5416),
    [anon_sym_EQ] = ACTIONS(5418),
    [anon_sym_COLON] = ACTIONS(5416),
    [anon_sym_QMARK] = ACTIONS(5416),
    [anon_sym_STAR_EQ] = ACTIONS(5416),
    [anon_sym_SLASH_EQ] = ACTIONS(5416),
    [anon_sym_PERCENT_EQ] = ACTIONS(5416),
    [anon_sym_PLUS_EQ] = ACTIONS(5416),
    [anon_sym_DASH_EQ] = ACTIONS(5416),
    [anon_sym_LT_LT_EQ] = ACTIONS(5416),
    [anon_sym_GT_GT_EQ] = ACTIONS(5416),
    [anon_sym_AMP_EQ] = ACTIONS(5416),
    [anon_sym_CARET_EQ] = ACTIONS(5416),
    [anon_sym_PIPE_EQ] = ACTIONS(5416),
    [anon_sym_and_eq] = ACTIONS(5416),
    [anon_sym_or_eq] = ACTIONS(5416),
    [anon_sym_xor_eq] = ACTIONS(5416),
    [anon_sym_LT_EQ_GT] = ACTIONS(5416),
    [anon_sym_or] = ACTIONS(5418),
    [anon_sym_and] = ACTIONS(5418),
    [anon_sym_bitor] = ACTIONS(5416),
    [anon_sym_xor] = ACTIONS(5418),
    [anon_sym_bitand] = ACTIONS(5416),
    [anon_sym_not_eq] = ACTIONS(5416),
    [anon_sym_DASH_DASH] = ACTIONS(5416),
    [anon_sym_PLUS_PLUS] = ACTIONS(5416),
    [anon_sym_DOT] = ACTIONS(5418),
    [anon_sym_DOT_STAR] = ACTIONS(5416),
    [anon_sym_DASH_GT] = ACTIONS(5416),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5416),
    [anon_sym_decltype] = ACTIONS(5416),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5416),
  },
  [2497] = {
    [sym_argument_list] = STATE(2738),
    [sym_subscript_argument_list] = STATE(2734),
    [sym_kernel_call_syntax] = STATE(8019),
    [sym_identifier] = ACTIONS(6096),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6098),
    [anon_sym_COMMA] = ACTIONS(6098),
    [anon_sym_RPAREN] = ACTIONS(6098),
    [aux_sym_preproc_if_token2] = ACTIONS(6098),
    [aux_sym_preproc_else_token1] = ACTIONS(6098),
    [aux_sym_preproc_elif_token1] = ACTIONS(6096),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6098),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6098),
    [anon_sym_LPAREN2] = ACTIONS(5644),
    [anon_sym_DASH] = ACTIONS(6096),
    [anon_sym_PLUS] = ACTIONS(6096),
    [anon_sym_STAR] = ACTIONS(6096),
    [anon_sym_SLASH] = ACTIONS(6096),
    [anon_sym_PERCENT] = ACTIONS(6096),
    [anon_sym_PIPE_PIPE] = ACTIONS(6098),
    [anon_sym_AMP_AMP] = ACTIONS(6098),
    [anon_sym_PIPE] = ACTIONS(6096),
    [anon_sym_CARET] = ACTIONS(6096),
    [anon_sym_AMP] = ACTIONS(6096),
    [anon_sym_EQ_EQ] = ACTIONS(6098),
    [anon_sym_BANG_EQ] = ACTIONS(6098),
    [anon_sym_GT] = ACTIONS(6096),
    [anon_sym_GT_EQ] = ACTIONS(6098),
    [anon_sym_LT_EQ] = ACTIONS(6096),
    [anon_sym_LT] = ACTIONS(6096),
    [anon_sym_LT_LT] = ACTIONS(6096),
    [anon_sym_GT_GT] = ACTIONS(6096),
    [anon_sym_SEMI] = ACTIONS(6098),
    [anon_sym___attribute__] = ACTIONS(6096),
    [anon_sym_RBRACE] = ACTIONS(6098),
    [anon_sym_LBRACK] = ACTIONS(6056),
    [anon_sym_RBRACK] = ACTIONS(6098),
    [anon_sym_EQ] = ACTIONS(6096),
    [anon_sym_QMARK] = ACTIONS(6098),
    [anon_sym_STAR_EQ] = ACTIONS(6098),
    [anon_sym_SLASH_EQ] = ACTIONS(6098),
    [anon_sym_PERCENT_EQ] = ACTIONS(6098),
    [anon_sym_PLUS_EQ] = ACTIONS(6098),
    [anon_sym_DASH_EQ] = ACTIONS(6098),
    [anon_sym_LT_LT_EQ] = ACTIONS(6098),
    [anon_sym_GT_GT_EQ] = ACTIONS(6098),
    [anon_sym_AMP_EQ] = ACTIONS(6098),
    [anon_sym_CARET_EQ] = ACTIONS(6098),
    [anon_sym_PIPE_EQ] = ACTIONS(6098),
    [anon_sym_and_eq] = ACTIONS(6096),
    [anon_sym_or_eq] = ACTIONS(6096),
    [anon_sym_xor_eq] = ACTIONS(6096),
    [anon_sym_LT_EQ_GT] = ACTIONS(6098),
    [anon_sym_or] = ACTIONS(6096),
    [anon_sym_and] = ACTIONS(6096),
    [anon_sym_bitor] = ACTIONS(6096),
    [anon_sym_xor] = ACTIONS(6096),
    [anon_sym_bitand] = ACTIONS(6096),
    [anon_sym_not_eq] = ACTIONS(6096),
    [anon_sym_DASH_DASH] = ACTIONS(6098),
    [anon_sym_PLUS_PLUS] = ACTIONS(6098),
    [anon_sym_DOT] = ACTIONS(6060),
    [anon_sym_DOT_STAR] = ACTIONS(6062),
    [anon_sym_DASH_GT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(3),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(6098),
  },
  [2498] = {
    [sym_ms_based_modifier] = STATE(8387),
    [sym__declarator] = STATE(6644),
    [sym__abstract_declarator] = STATE(6708),
    [sym_parenthesized_declarator] = STATE(6598),
    [sym_abstract_parenthesized_declarator] = STATE(6430),
    [sym_attributed_declarator] = STATE(6598),
    [sym_pointer_declarator] = STATE(6598),
    [sym_abstract_pointer_declarator] = STATE(6430),
    [sym_function_declarator] = STATE(6598),
    [sym_abstract_function_declarator] = STATE(6430),
    [sym_array_declarator] = STATE(6598),
    [sym_abstract_array_declarator] = STATE(6430),
    [sym_type_qualifier] = STATE(5008),
    [sym_alignas_qualifier] = STATE(4511),
    [sym_parameter_list] = STATE(2819),
    [sym_decltype] = STATE(8628),
    [sym_reference_declarator] = STATE(6598),
    [sym_abstract_reference_declarator] = STATE(6430),
    [sym_structured_binding_declarator] = STATE(6598),
    [sym__function_declarator_seq] = STATE(6416),
    [sym_template_type] = STATE(8628),
    [sym_template_function] = STATE(6598),
    [sym_destructor_name] = STATE(6598),
    [sym_dependent_type_identifier] = STATE(8628),
    [sym__scope_resolution] = STATE(6059),
    [sym_qualified_identifier] = STATE(6598),
    [sym_operator_name] = STATE(6598),
    [aux_sym__type_definition_type_repeat1] = STATE(5008),
    [sym_identifier] = ACTIONS(5482),
    [anon_sym_COMMA] = ACTIONS(6100),
    [anon_sym_RPAREN] = ACTIONS(6100),
    [anon_sym_LPAREN2] = ACTIONS(3957),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(5486),
    [anon_sym_AMP_AMP] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5490),
    [anon_sym___extension__] = ACTIONS(3171),
    [anon_sym___global__] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(5492),
    [anon_sym___based] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(5494),
    [anon_sym_EQ] = ACTIONS(6100),
    [anon_sym_const] = ACTIONS(3171),
    [anon_sym_constexpr] = ACTIONS(3171),
    [anon_sym_volatile] = ACTIONS(3171),
    [anon_sym_restrict] = ACTIONS(3171),
    [anon_sym___restrict__] = ACTIONS(3171),
    [anon_sym__Atomic] = ACTIONS(3171),
    [anon_sym__Noreturn] = ACTIONS(3171),
    [anon_sym_noreturn] = ACTIONS(3171),
    [anon_sym_mutable] = ACTIONS(3171),
    [anon_sym_constinit] = ACTIONS(3171),
    [anon_sym_consteval] = ACTIONS(3171),
    [anon_sym___shared__] = ACTIONS(3171),
    [anon_sym___local__] = ACTIONS(3171),
    [anon_sym___constant__] = ACTIONS(3171),
    [anon_sym___managed__] = ACTIONS(3171),
    [anon_sym___grid_constant__] = ACTIONS(3171),
    [anon_sym_alignas] = ACTIONS(3177),
    [anon_sym__Alignas] = ACTIONS(3177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2542),
    [anon_sym_template] = ACTIONS(1244),
    [anon_sym_GT2] = ACTIONS(6100),
    [anon_sym_operator] = ACTIONS(1883),
  },
  [2499] = {
    [sym_argument_list] = STATE(2738),
    [sym_subscript_argument_list] = STATE(2734),
    [sym_kernel_call_syntax] = STATE(8019),
    [sym_identifier] = ACTIONS(6102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6104),
    [anon_sym_COMMA] = ACTIONS(6104),
    [anon_sym_RPAREN] = ACTIONS(6104),
    [aux_sym_preproc_if_token2] = ACTIONS(6104),
    [aux_sym_preproc_else_token1] = ACTIONS(6104),
    [aux_sym_preproc_elif_token1] = ACTIONS(6102),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6104),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6104),
    [anon_sym_LPAREN2] = ACTIONS(5644),
    [anon_sym_DASH] = ACTIONS(6102),
    [anon_sym_PLUS] = ACTIONS(6102),
    [anon_sym_STAR] = ACTIONS(6102),
    [anon_sym_SLASH] = ACTIONS(6102),
    [anon_sym_PERCENT] = ACTIONS(6102),
    [anon_sym_PIPE_PIPE] = ACTIONS(6104),
    [anon_sym_AMP_AMP] = ACTIONS(6104),
    [anon_sym_PIPE] = ACTIONS(6102),
    [anon_sym_CARET] = ACTIONS(6102),
    [anon_sym_AMP] = ACTIONS(6102),
    [anon_sym_EQ_EQ] = ACTIONS(6104),
    [anon_sym_BANG_EQ] = ACTIONS(6104),
    [anon_sym_GT] = ACTIONS(6102),
    [anon_sym_GT_EQ] = ACTIONS(6104),
    [anon_sym_LT_EQ] = ACTIONS(6102),
    [anon_sym_LT] = ACTIONS(6102),
    [anon_sym_LT_LT] = ACTIONS(6102),
    [anon_sym_GT_GT] = ACTIONS(6102),
    [anon_sym_SEMI] = ACTIONS(6104),
    [anon_sym___attribute__] = ACTIONS(6102),
    [anon_sym_RBRACE] = ACTIONS(6104),
    [anon_sym_LBRACK] = ACTIONS(6056),
    [anon_sym_RBRACK] = ACTIONS(6104),
    [anon_sym_EQ] = ACTIONS(6102),
    [anon_sym_QMARK] = ACTIONS(6104),
    [anon_sym_STAR_EQ] = ACTIONS(6104),
    [anon_sym_SLASH_EQ] = ACTIONS(6104),
    [anon_sym_PERCENT_EQ] = ACTIONS(6104),
    [anon_sym_PLUS_EQ] = ACTIONS(6104),
    [anon_sym_DASH_EQ] = ACTIONS(6104),
    [anon_sym_LT_LT_EQ] = ACTIONS(6104),
    [anon_sym_GT_GT_EQ] = ACTIONS(6104),
    [anon_sym_AMP_EQ] = ACTIONS(6104),
    [anon_sym_CARET_EQ] = ACTIONS(6104),
    [anon_sym_PIPE_EQ] = ACTIONS(6104),
    [anon_sym_and_eq] = ACTIONS(6102),
    [anon_sym_or_eq] = ACTIONS(6102),
    [anon_sym_xor_eq] = ACTIONS(6102),
    [anon_sym_LT_EQ_GT] = ACTIONS(6104),
    [anon_sym_or] = ACTIONS(6102),
    [anon_sym_and] = ACTIONS(6102),
    [anon_sym_bitor] = ACTIONS(6102),
    [anon_sym_xor] = ACTIONS(6102),
    [anon_sym_bitand] = ACTIONS(6102),
    [anon_sym_not_eq] = ACTIONS(6102),
    [anon_sym_DASH_DASH] = ACTIONS(6058),
    [anon_sym_PLUS_PLUS] = ACTIONS(6058),
    [anon_sym_DOT] = ACTIONS(6060),
    [anon_sym_DOT_STAR] = ACTIONS(6062),
    [anon_sym_DASH_GT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(3),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(6104),
  },
  [2500] = {
    [sym_attribute_specifier] = STATE(2204),
    [sym_identifier] = ACTIONS(5716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5714),
    [anon_sym_COMMA] = ACTIONS(5714),
    [anon_sym_RPAREN] = ACTIONS(5714),
    [anon_sym_LPAREN2] = ACTIONS(5714),
    [anon_sym_TILDE] = ACTIONS(5714),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_AMP_AMP] = ACTIONS(5714),
    [anon_sym_AMP] = ACTIONS(5716),
    [anon_sym_SEMI] = ACTIONS(5714),
    [anon_sym___extension__] = ACTIONS(5716),
    [anon_sym___device__] = ACTIONS(5716),
    [anon_sym___host__] = ACTIONS(5716),
    [anon_sym___global__] = ACTIONS(5716),
    [anon_sym___forceinline__] = ACTIONS(5716),
    [anon_sym___noinline__] = ACTIONS(5716),
    [anon_sym_extern] = ACTIONS(5716),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5714),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5714),
    [anon_sym___declspec] = ACTIONS(5716),
    [anon_sym___based] = ACTIONS(5716),
    [anon_sym___cdecl] = ACTIONS(5716),
    [anon_sym___clrcall] = ACTIONS(5716),
    [anon_sym___stdcall] = ACTIONS(5716),
    [anon_sym___fastcall] = ACTIONS(5716),
    [anon_sym___thiscall] = ACTIONS(5716),
    [anon_sym___vectorcall] = ACTIONS(5716),
    [anon_sym_LBRACK] = ACTIONS(5716),
    [anon_sym_static] = ACTIONS(5716),
    [anon_sym_EQ] = ACTIONS(5714),
    [anon_sym_register] = ACTIONS(5716),
    [anon_sym_inline] = ACTIONS(5716),
    [anon_sym___inline] = ACTIONS(5716),
    [anon_sym___inline__] = ACTIONS(5716),
    [anon_sym___forceinline] = ACTIONS(5716),
    [anon_sym_thread_local] = ACTIONS(5716),
    [anon_sym___thread] = ACTIONS(5716),
    [anon_sym_const] = ACTIONS(5716),
    [anon_sym_constexpr] = ACTIONS(5716),
    [anon_sym_volatile] = ACTIONS(5716),
    [anon_sym_restrict] = ACTIONS(5716),
    [anon_sym___restrict__] = ACTIONS(5716),
    [anon_sym__Atomic] = ACTIONS(5716),
    [anon_sym__Noreturn] = ACTIONS(5716),
    [anon_sym_noreturn] = ACTIONS(5716),
    [anon_sym_mutable] = ACTIONS(5716),
    [anon_sym_constinit] = ACTIONS(5716),
    [anon_sym_consteval] = ACTIONS(5716),
    [anon_sym___shared__] = ACTIONS(5716),
    [anon_sym___local__] = ACTIONS(5716),
    [anon_sym___constant__] = ACTIONS(5716),
    [anon_sym___managed__] = ACTIONS(5716),
    [anon_sym___grid_constant__] = ACTIONS(5716),
    [anon_sym_alignas] = ACTIONS(5716),
    [anon_sym__Alignas] = ACTIONS(5716),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5716),
    [anon_sym_decltype] = ACTIONS(5716),
    [sym_virtual] = ACTIONS(5716),
    [anon_sym_template] = ACTIONS(5716),
    [anon_sym_GT2] = ACTIONS(5714),
    [anon_sym_operator] = ACTIONS(5716),
    [anon_sym___launch_bounds__] = ACTIONS(5716),
  },
  [2501] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5236),
    [anon_sym_COMMA] = ACTIONS(5236),
    [anon_sym_LPAREN2] = ACTIONS(5236),
    [anon_sym_DASH] = ACTIONS(5234),
    [anon_sym_PLUS] = ACTIONS(5234),
    [anon_sym_STAR] = ACTIONS(5236),
    [anon_sym_SLASH] = ACTIONS(5234),
    [anon_sym_PERCENT] = ACTIONS(5236),
    [anon_sym_PIPE_PIPE] = ACTIONS(5236),
    [anon_sym_AMP_AMP] = ACTIONS(5236),
    [anon_sym_PIPE] = ACTIONS(5234),
    [anon_sym_CARET] = ACTIONS(5236),
    [anon_sym_AMP] = ACTIONS(5234),
    [anon_sym_EQ_EQ] = ACTIONS(5236),
    [anon_sym_BANG_EQ] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5234),
    [anon_sym_GT_EQ] = ACTIONS(5234),
    [anon_sym_LT_EQ] = ACTIONS(5234),
    [anon_sym_LT] = ACTIONS(5234),
    [anon_sym_LT_LT] = ACTIONS(5234),
    [anon_sym_GT_GT] = ACTIONS(5234),
    [anon_sym___extension__] = ACTIONS(5236),
    [anon_sym___global__] = ACTIONS(5236),
    [anon_sym___attribute__] = ACTIONS(5236),
    [anon_sym_LBRACE] = ACTIONS(5236),
    [anon_sym_LBRACK] = ACTIONS(5236),
    [anon_sym_const] = ACTIONS(5234),
    [anon_sym_constexpr] = ACTIONS(5236),
    [anon_sym_volatile] = ACTIONS(5236),
    [anon_sym_restrict] = ACTIONS(5236),
    [anon_sym___restrict__] = ACTIONS(5236),
    [anon_sym__Atomic] = ACTIONS(5236),
    [anon_sym__Noreturn] = ACTIONS(5236),
    [anon_sym_noreturn] = ACTIONS(5236),
    [anon_sym_mutable] = ACTIONS(5236),
    [anon_sym_constinit] = ACTIONS(5236),
    [anon_sym_consteval] = ACTIONS(5236),
    [anon_sym___shared__] = ACTIONS(5236),
    [anon_sym___local__] = ACTIONS(5236),
    [anon_sym___constant__] = ACTIONS(5236),
    [anon_sym___managed__] = ACTIONS(5236),
    [anon_sym___grid_constant__] = ACTIONS(5236),
    [anon_sym_alignas] = ACTIONS(5236),
    [anon_sym__Alignas] = ACTIONS(5236),
    [anon_sym_QMARK] = ACTIONS(5236),
    [anon_sym_LT_EQ_GT] = ACTIONS(5236),
    [anon_sym_or] = ACTIONS(5236),
    [anon_sym_and] = ACTIONS(5236),
    [anon_sym_bitor] = ACTIONS(5236),
    [anon_sym_xor] = ACTIONS(5236),
    [anon_sym_bitand] = ACTIONS(5236),
    [anon_sym_not_eq] = ACTIONS(5236),
    [anon_sym_DASH_DASH] = ACTIONS(5236),
    [anon_sym_PLUS_PLUS] = ACTIONS(5236),
    [anon_sym_DOT] = ACTIONS(5234),
    [anon_sym_DOT_STAR] = ACTIONS(5236),
    [anon_sym_DASH_GT] = ACTIONS(5236),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5236),
    [anon_sym_decltype] = ACTIONS(5236),
    [anon_sym_final] = ACTIONS(5236),
    [anon_sym_override] = ACTIONS(5236),
    [anon_sym_GT2] = ACTIONS(5236),
    [anon_sym_requires] = ACTIONS(5236),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5236),
  },
  [2502] = {
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4144),
    [anon_sym_COMMA] = ACTIONS(4144),
    [anon_sym_RPAREN] = ACTIONS(4144),
    [aux_sym_preproc_if_token2] = ACTIONS(4144),
    [aux_sym_preproc_else_token1] = ACTIONS(4144),
    [aux_sym_preproc_elif_token1] = ACTIONS(4151),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4144),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4144),
    [anon_sym_LPAREN2] = ACTIONS(4144),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(4151),
    [anon_sym_STAR] = ACTIONS(4151),
    [anon_sym_SLASH] = ACTIONS(4151),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4144),
    [anon_sym_PIPE] = ACTIONS(4151),
    [anon_sym_CARET] = ACTIONS(4151),
    [anon_sym_AMP] = ACTIONS(4151),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT] = ACTIONS(4151),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4151),
    [anon_sym_LT] = ACTIONS(4151),
    [anon_sym_LT_LT] = ACTIONS(4151),
    [anon_sym_GT_GT] = ACTIONS(4151),
    [anon_sym_SEMI] = ACTIONS(4144),
    [anon_sym___attribute__] = ACTIONS(4151),
    [anon_sym_COLON_COLON] = ACTIONS(4149),
    [anon_sym_LBRACE] = ACTIONS(4149),
    [anon_sym_RBRACE] = ACTIONS(4144),
    [anon_sym_LBRACK] = ACTIONS(4144),
    [anon_sym_RBRACK] = ACTIONS(4144),
    [anon_sym_EQ] = ACTIONS(4151),
    [anon_sym_COLON] = ACTIONS(4151),
    [anon_sym_QMARK] = ACTIONS(4144),
    [anon_sym_STAR_EQ] = ACTIONS(4144),
    [anon_sym_SLASH_EQ] = ACTIONS(4144),
    [anon_sym_PERCENT_EQ] = ACTIONS(4144),
    [anon_sym_PLUS_EQ] = ACTIONS(4144),
    [anon_sym_DASH_EQ] = ACTIONS(4144),
    [anon_sym_LT_LT_EQ] = ACTIONS(4144),
    [anon_sym_GT_GT_EQ] = ACTIONS(4144),
    [anon_sym_AMP_EQ] = ACTIONS(4144),
    [anon_sym_CARET_EQ] = ACTIONS(4144),
    [anon_sym_PIPE_EQ] = ACTIONS(4144),
    [anon_sym_and_eq] = ACTIONS(4151),
    [anon_sym_or_eq] = ACTIONS(4151),
    [anon_sym_xor_eq] = ACTIONS(4151),
    [anon_sym_LT_EQ_GT] = ACTIONS(4144),
    [anon_sym_or] = ACTIONS(4151),
    [anon_sym_and] = ACTIONS(4151),
    [anon_sym_bitor] = ACTIONS(4151),
    [anon_sym_xor] = ACTIONS(4151),
    [anon_sym_bitand] = ACTIONS(4151),
    [anon_sym_not_eq] = ACTIONS(4151),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_DOT_STAR] = ACTIONS(4144),
    [anon_sym_DASH_GT] = ACTIONS(4144),
    [sym_comment] = ACTIONS(3),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(4144),
  },
  [2503] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2430),
    [sym_identifier] = ACTIONS(5192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5194),
    [anon_sym_COMMA] = ACTIONS(5194),
    [aux_sym_preproc_if_token2] = ACTIONS(5194),
    [aux_sym_preproc_else_token1] = ACTIONS(5194),
    [aux_sym_preproc_elif_token1] = ACTIONS(5192),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5194),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5194),
    [anon_sym_LPAREN2] = ACTIONS(5194),
    [anon_sym_DASH] = ACTIONS(5192),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_STAR] = ACTIONS(5192),
    [anon_sym_SLASH] = ACTIONS(5192),
    [anon_sym_PERCENT] = ACTIONS(5192),
    [anon_sym_PIPE_PIPE] = ACTIONS(5194),
    [anon_sym_AMP_AMP] = ACTIONS(5194),
    [anon_sym_PIPE] = ACTIONS(5192),
    [anon_sym_CARET] = ACTIONS(5192),
    [anon_sym_AMP] = ACTIONS(5192),
    [anon_sym_EQ_EQ] = ACTIONS(5194),
    [anon_sym_BANG_EQ] = ACTIONS(5194),
    [anon_sym_GT] = ACTIONS(5192),
    [anon_sym_GT_EQ] = ACTIONS(5194),
    [anon_sym_LT_EQ] = ACTIONS(5192),
    [anon_sym_LT] = ACTIONS(5192),
    [anon_sym_LT_LT] = ACTIONS(5192),
    [anon_sym_GT_GT] = ACTIONS(5192),
    [anon_sym_LBRACE] = ACTIONS(5194),
    [anon_sym_signed] = ACTIONS(6032),
    [anon_sym_unsigned] = ACTIONS(6032),
    [anon_sym_long] = ACTIONS(6032),
    [anon_sym_short] = ACTIONS(6032),
    [anon_sym_LBRACK] = ACTIONS(5194),
    [anon_sym_EQ] = ACTIONS(5192),
    [anon_sym_QMARK] = ACTIONS(5194),
    [anon_sym_STAR_EQ] = ACTIONS(5194),
    [anon_sym_SLASH_EQ] = ACTIONS(5194),
    [anon_sym_PERCENT_EQ] = ACTIONS(5194),
    [anon_sym_PLUS_EQ] = ACTIONS(5194),
    [anon_sym_DASH_EQ] = ACTIONS(5194),
    [anon_sym_LT_LT_EQ] = ACTIONS(5194),
    [anon_sym_GT_GT_EQ] = ACTIONS(5194),
    [anon_sym_AMP_EQ] = ACTIONS(5194),
    [anon_sym_CARET_EQ] = ACTIONS(5194),
    [anon_sym_PIPE_EQ] = ACTIONS(5194),
    [anon_sym_and_eq] = ACTIONS(5192),
    [anon_sym_or_eq] = ACTIONS(5192),
    [anon_sym_xor_eq] = ACTIONS(5192),
    [anon_sym_LT_EQ_GT] = ACTIONS(5194),
    [anon_sym_or] = ACTIONS(5192),
    [anon_sym_and] = ACTIONS(5192),
    [anon_sym_bitor] = ACTIONS(5192),
    [anon_sym_xor] = ACTIONS(5192),
    [anon_sym_bitand] = ACTIONS(5192),
    [anon_sym_not_eq] = ACTIONS(5192),
    [anon_sym_DASH_DASH] = ACTIONS(5194),
    [anon_sym_PLUS_PLUS] = ACTIONS(5194),
    [anon_sym_DOT] = ACTIONS(5192),
    [anon_sym_DOT_STAR] = ACTIONS(5194),
    [anon_sym_DASH_GT] = ACTIONS(5194),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5192),
    [anon_sym_decltype] = ACTIONS(5192),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5194),
  },
  [2504] = {
    [sym_argument_list] = STATE(2738),
    [sym_subscript_argument_list] = STATE(2734),
    [sym_kernel_call_syntax] = STATE(8019),
    [sym_identifier] = ACTIONS(6106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6108),
    [anon_sym_COMMA] = ACTIONS(6108),
    [anon_sym_RPAREN] = ACTIONS(6108),
    [aux_sym_preproc_if_token2] = ACTIONS(6108),
    [aux_sym_preproc_else_token1] = ACTIONS(6108),
    [aux_sym_preproc_elif_token1] = ACTIONS(6106),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6108),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6108),
    [anon_sym_LPAREN2] = ACTIONS(5644),
    [anon_sym_DASH] = ACTIONS(6106),
    [anon_sym_PLUS] = ACTIONS(6106),
    [anon_sym_STAR] = ACTIONS(6106),
    [anon_sym_SLASH] = ACTIONS(6106),
    [anon_sym_PERCENT] = ACTIONS(6106),
    [anon_sym_PIPE_PIPE] = ACTIONS(6108),
    [anon_sym_AMP_AMP] = ACTIONS(6108),
    [anon_sym_PIPE] = ACTIONS(6106),
    [anon_sym_CARET] = ACTIONS(6106),
    [anon_sym_AMP] = ACTIONS(6106),
    [anon_sym_EQ_EQ] = ACTIONS(6108),
    [anon_sym_BANG_EQ] = ACTIONS(6108),
    [anon_sym_GT] = ACTIONS(6106),
    [anon_sym_GT_EQ] = ACTIONS(6108),
    [anon_sym_LT_EQ] = ACTIONS(6106),
    [anon_sym_LT] = ACTIONS(6106),
    [anon_sym_LT_LT] = ACTIONS(6106),
    [anon_sym_GT_GT] = ACTIONS(6106),
    [anon_sym_SEMI] = ACTIONS(6108),
    [anon_sym___attribute__] = ACTIONS(6106),
    [anon_sym_RBRACE] = ACTIONS(6108),
    [anon_sym_LBRACK] = ACTIONS(6056),
    [anon_sym_RBRACK] = ACTIONS(6108),
    [anon_sym_EQ] = ACTIONS(6106),
    [anon_sym_QMARK] = ACTIONS(6108),
    [anon_sym_STAR_EQ] = ACTIONS(6108),
    [anon_sym_SLASH_EQ] = ACTIONS(6108),
    [anon_sym_PERCENT_EQ] = ACTIONS(6108),
    [anon_sym_PLUS_EQ] = ACTIONS(6108),
    [anon_sym_DASH_EQ] = ACTIONS(6108),
    [anon_sym_LT_LT_EQ] = ACTIONS(6108),
    [anon_sym_GT_GT_EQ] = ACTIONS(6108),
    [anon_sym_AMP_EQ] = ACTIONS(6108),
    [anon_sym_CARET_EQ] = ACTIONS(6108),
    [anon_sym_PIPE_EQ] = ACTIONS(6108),
    [anon_sym_and_eq] = ACTIONS(6106),
    [anon_sym_or_eq] = ACTIONS(6106),
    [anon_sym_xor_eq] = ACTIONS(6106),
    [anon_sym_LT_EQ_GT] = ACTIONS(6108),
    [anon_sym_or] = ACTIONS(6106),
    [anon_sym_and] = ACTIONS(6106),
    [anon_sym_bitor] = ACTIONS(6106),
    [anon_sym_xor] = ACTIONS(6106),
    [anon_sym_bitand] = ACTIONS(6106),
    [anon_sym_not_eq] = ACTIONS(6106),
    [anon_sym_DASH_DASH] = ACTIONS(6058),
    [anon_sym_PLUS_PLUS] = ACTIONS(6058),
    [anon_sym_DOT] = ACTIONS(6060),
    [anon_sym_DOT_STAR] = ACTIONS(6062),
    [anon_sym_DASH_GT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(3),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(6108),
  },
  [2505] = {
    [sym_argument_list] = STATE(2738),
    [sym_subscript_argument_list] = STATE(2734),
    [sym_kernel_call_syntax] = STATE(8019),
    [sym_identifier] = ACTIONS(6110),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6112),
    [anon_sym_COMMA] = ACTIONS(6112),
    [anon_sym_RPAREN] = ACTIONS(6112),
    [aux_sym_preproc_if_token2] = ACTIONS(6112),
    [aux_sym_preproc_else_token1] = ACTIONS(6112),
    [aux_sym_preproc_elif_token1] = ACTIONS(6110),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6112),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6112),
    [anon_sym_LPAREN2] = ACTIONS(5644),
    [anon_sym_DASH] = ACTIONS(6110),
    [anon_sym_PLUS] = ACTIONS(6110),
    [anon_sym_STAR] = ACTIONS(6110),
    [anon_sym_SLASH] = ACTIONS(6110),
    [anon_sym_PERCENT] = ACTIONS(6110),
    [anon_sym_PIPE_PIPE] = ACTIONS(6112),
    [anon_sym_AMP_AMP] = ACTIONS(6112),
    [anon_sym_PIPE] = ACTIONS(6110),
    [anon_sym_CARET] = ACTIONS(6110),
    [anon_sym_AMP] = ACTIONS(6110),
    [anon_sym_EQ_EQ] = ACTIONS(6112),
    [anon_sym_BANG_EQ] = ACTIONS(6112),
    [anon_sym_GT] = ACTIONS(6110),
    [anon_sym_GT_EQ] = ACTIONS(6112),
    [anon_sym_LT_EQ] = ACTIONS(6110),
    [anon_sym_LT] = ACTIONS(6110),
    [anon_sym_LT_LT] = ACTIONS(6110),
    [anon_sym_GT_GT] = ACTIONS(6110),
    [anon_sym_SEMI] = ACTIONS(6112),
    [anon_sym___attribute__] = ACTIONS(6110),
    [anon_sym_RBRACE] = ACTIONS(6112),
    [anon_sym_LBRACK] = ACTIONS(6056),
    [anon_sym_RBRACK] = ACTIONS(6112),
    [anon_sym_EQ] = ACTIONS(6110),
    [anon_sym_QMARK] = ACTIONS(6112),
    [anon_sym_STAR_EQ] = ACTIONS(6112),
    [anon_sym_SLASH_EQ] = ACTIONS(6112),
    [anon_sym_PERCENT_EQ] = ACTIONS(6112),
    [anon_sym_PLUS_EQ] = ACTIONS(6112),
    [anon_sym_DASH_EQ] = ACTIONS(6112),
    [anon_sym_LT_LT_EQ] = ACTIONS(6112),
    [anon_sym_GT_GT_EQ] = ACTIONS(6112),
    [anon_sym_AMP_EQ] = ACTIONS(6112),
    [anon_sym_CARET_EQ] = ACTIONS(6112),
    [anon_sym_PIPE_EQ] = ACTIONS(6112),
    [anon_sym_and_eq] = ACTIONS(6110),
    [anon_sym_or_eq] = ACTIONS(6110),
    [anon_sym_xor_eq] = ACTIONS(6110),
    [anon_sym_LT_EQ_GT] = ACTIONS(6112),
    [anon_sym_or] = ACTIONS(6110),
    [anon_sym_and] = ACTIONS(6110),
    [anon_sym_bitor] = ACTIONS(6110),
    [anon_sym_xor] = ACTIONS(6110),
    [anon_sym_bitand] = ACTIONS(6110),
    [anon_sym_not_eq] = ACTIONS(6110),
    [anon_sym_DASH_DASH] = ACTIONS(6058),
    [anon_sym_PLUS_PLUS] = ACTIONS(6058),
    [anon_sym_DOT] = ACTIONS(6060),
    [anon_sym_DOT_STAR] = ACTIONS(6062),
    [anon_sym_DASH_GT] = ACTIONS(6062),
    [sym_comment] = ACTIONS(3),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(6112),
  },
  [2506] = {
    [sym_decltype_auto] = STATE(2573),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5173),
    [anon_sym_COMMA] = ACTIONS(5173),
    [anon_sym_LPAREN2] = ACTIONS(5173),
    [anon_sym_DASH] = ACTIONS(5171),
    [anon_sym_PLUS] = ACTIONS(5171),
    [anon_sym_STAR] = ACTIONS(5173),
    [anon_sym_SLASH] = ACTIONS(5171),
    [anon_sym_PERCENT] = ACTIONS(5173),
    [anon_sym_PIPE_PIPE] = ACTIONS(5173),
    [anon_sym_AMP_AMP] = ACTIONS(5173),
    [anon_sym_PIPE] = ACTIONS(5171),
    [anon_sym_CARET] = ACTIONS(5173),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_EQ_EQ] = ACTIONS(5173),
    [anon_sym_BANG_EQ] = ACTIONS(5173),
    [anon_sym_GT] = ACTIONS(5171),
    [anon_sym_GT_EQ] = ACTIONS(5171),
    [anon_sym_LT_EQ] = ACTIONS(5171),
    [anon_sym_LT] = ACTIONS(5171),
    [anon_sym_LT_LT] = ACTIONS(5171),
    [anon_sym_GT_GT] = ACTIONS(5171),
    [anon_sym___extension__] = ACTIONS(5173),
    [anon_sym___global__] = ACTIONS(5173),
    [anon_sym_LBRACE] = ACTIONS(5173),
    [anon_sym_LBRACK] = ACTIONS(5173),
    [anon_sym_const] = ACTIONS(5171),
    [anon_sym_constexpr] = ACTIONS(5173),
    [anon_sym_volatile] = ACTIONS(5173),
    [anon_sym_restrict] = ACTIONS(5173),
    [anon_sym___restrict__] = ACTIONS(5173),
    [anon_sym__Atomic] = ACTIONS(5173),
    [anon_sym__Noreturn] = ACTIONS(5173),
    [anon_sym_noreturn] = ACTIONS(5173),
    [anon_sym_mutable] = ACTIONS(5173),
    [anon_sym_constinit] = ACTIONS(5173),
    [anon_sym_consteval] = ACTIONS(5173),
    [anon_sym___shared__] = ACTIONS(5173),
    [anon_sym___local__] = ACTIONS(5173),
    [anon_sym___constant__] = ACTIONS(5173),
    [anon_sym___managed__] = ACTIONS(5173),
    [anon_sym___grid_constant__] = ACTIONS(5173),
    [anon_sym_alignas] = ACTIONS(5173),
    [anon_sym__Alignas] = ACTIONS(5173),
    [anon_sym_QMARK] = ACTIONS(5173),
    [anon_sym_LT_EQ_GT] = ACTIONS(5173),
    [anon_sym_or] = ACTIONS(5173),
    [anon_sym_and] = ACTIONS(5173),
    [anon_sym_bitor] = ACTIONS(5173),
    [anon_sym_xor] = ACTIONS(5173),
    [anon_sym_bitand] = ACTIONS(5173),
    [anon_sym_not_eq] = ACTIONS(5173),
    [anon_sym_DASH_DASH] = ACTIONS(5173),
    [anon_sym_PLUS_PLUS] = ACTIONS(5173),
    [anon_sym_DOT] = ACTIONS(5171),
    [anon_sym_DOT_STAR] = ACTIONS(5173),
    [anon_sym_DASH_GT] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6114),
    [anon_sym_decltype] = ACTIONS(6116),
    [anon_sym_final] = ACTIONS(5173),
    [anon_sym_override] = ACTIONS(5173),
    [anon_sym_GT2] = ACTIONS(5173),
    [anon_sym_requires] = ACTIONS(5173),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5173),
  },
  [2507] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2470),
    [sym_identifier] = ACTIONS(6118),
    [anon_sym_COMMA] = ACTIONS(5325),
    [anon_sym_RPAREN] = ACTIONS(5325),
    [anon_sym_LPAREN2] = ACTIONS(5325),
    [anon_sym_STAR] = ACTIONS(5325),
    [anon_sym_AMP_AMP] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5327),
    [anon_sym_SEMI] = ACTIONS(5325),
    [anon_sym___extension__] = ACTIONS(5327),
    [anon_sym___device__] = ACTIONS(5327),
    [anon_sym___host__] = ACTIONS(5327),
    [anon_sym___global__] = ACTIONS(5327),
    [anon_sym___forceinline__] = ACTIONS(5327),
    [anon_sym___noinline__] = ACTIONS(5327),
    [anon_sym_extern] = ACTIONS(5327),
    [anon_sym___attribute__] = ACTIONS(5327),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5325),
    [anon_sym___declspec] = ACTIONS(5327),
    [anon_sym_LBRACE] = ACTIONS(5325),
    [anon_sym_signed] = ACTIONS(6120),
    [anon_sym_unsigned] = ACTIONS(6120),
    [anon_sym_long] = ACTIONS(6120),
    [anon_sym_short] = ACTIONS(6120),
    [anon_sym_LBRACK] = ACTIONS(5327),
    [anon_sym_static] = ACTIONS(5327),
    [anon_sym_EQ] = ACTIONS(5325),
    [anon_sym_register] = ACTIONS(5327),
    [anon_sym_inline] = ACTIONS(5327),
    [anon_sym___inline] = ACTIONS(5327),
    [anon_sym___inline__] = ACTIONS(5327),
    [anon_sym___forceinline] = ACTIONS(5327),
    [anon_sym_thread_local] = ACTIONS(5327),
    [anon_sym___thread] = ACTIONS(5327),
    [anon_sym_const] = ACTIONS(5327),
    [anon_sym_constexpr] = ACTIONS(5327),
    [anon_sym_volatile] = ACTIONS(5327),
    [anon_sym_restrict] = ACTIONS(5327),
    [anon_sym___restrict__] = ACTIONS(5327),
    [anon_sym__Atomic] = ACTIONS(5327),
    [anon_sym__Noreturn] = ACTIONS(5327),
    [anon_sym_noreturn] = ACTIONS(5327),
    [anon_sym_mutable] = ACTIONS(5327),
    [anon_sym_constinit] = ACTIONS(5327),
    [anon_sym_consteval] = ACTIONS(5327),
    [anon_sym___shared__] = ACTIONS(5327),
    [anon_sym___local__] = ACTIONS(5327),
    [anon_sym___constant__] = ACTIONS(5327),
    [anon_sym___managed__] = ACTIONS(5327),
    [anon_sym___grid_constant__] = ACTIONS(5327),
    [anon_sym_alignas] = ACTIONS(5327),
    [anon_sym__Alignas] = ACTIONS(5327),
    [sym_primitive_type] = ACTIONS(6122),
    [anon_sym_asm] = ACTIONS(5327),
    [anon_sym___asm__] = ACTIONS(5327),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5327),
    [anon_sym_decltype] = ACTIONS(5327),
    [anon_sym_final] = ACTIONS(5327),
    [anon_sym_override] = ACTIONS(5327),
    [sym_virtual] = ACTIONS(5327),
    [anon_sym_GT2] = ACTIONS(5325),
    [anon_sym_try] = ACTIONS(5327),
    [anon_sym_requires] = ACTIONS(5327),
    [anon_sym___launch_bounds__] = ACTIONS(5327),
  },
  [2508] = {
    [sym_identifier] = ACTIONS(5470),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5472),
    [anon_sym_COMMA] = ACTIONS(5472),
    [anon_sym_LPAREN2] = ACTIONS(5472),
    [anon_sym_DASH] = ACTIONS(5470),
    [anon_sym_PLUS] = ACTIONS(5470),
    [anon_sym_STAR] = ACTIONS(5470),
    [anon_sym_SLASH] = ACTIONS(5470),
    [anon_sym_PERCENT] = ACTIONS(5470),
    [anon_sym_PIPE_PIPE] = ACTIONS(5472),
    [anon_sym_AMP_AMP] = ACTIONS(5472),
    [anon_sym_PIPE] = ACTIONS(5470),
    [anon_sym_CARET] = ACTIONS(5470),
    [anon_sym_AMP] = ACTIONS(5470),
    [anon_sym_EQ_EQ] = ACTIONS(5472),
    [anon_sym_BANG_EQ] = ACTIONS(5472),
    [anon_sym_GT] = ACTIONS(5470),
    [anon_sym_GT_EQ] = ACTIONS(5472),
    [anon_sym_LT_EQ] = ACTIONS(5470),
    [anon_sym_LT] = ACTIONS(5470),
    [anon_sym_LT_LT] = ACTIONS(5470),
    [anon_sym_GT_GT] = ACTIONS(5470),
    [anon_sym_SEMI] = ACTIONS(5472),
    [anon_sym___attribute__] = ACTIONS(5470),
    [anon_sym_LBRACK] = ACTIONS(5472),
    [anon_sym_EQ] = ACTIONS(5470),
    [anon_sym_QMARK] = ACTIONS(5472),
    [anon_sym_STAR_EQ] = ACTIONS(5472),
    [anon_sym_SLASH_EQ] = ACTIONS(5472),
    [anon_sym_PERCENT_EQ] = ACTIONS(5472),
    [anon_sym_PLUS_EQ] = ACTIONS(5472),
    [anon_sym_DASH_EQ] = ACTIONS(5472),
    [anon_sym_LT_LT_EQ] = ACTIONS(5472),
    [anon_sym_GT_GT_EQ] = ACTIONS(5472),
    [anon_sym_AMP_EQ] = ACTIONS(5472),
    [anon_sym_CARET_EQ] = ACTIONS(5472),
    [anon_sym_PIPE_EQ] = ACTIONS(5472),
    [anon_sym_and_eq] = ACTIONS(5470),
    [anon_sym_or_eq] = ACTIONS(5470),
    [anon_sym_xor_eq] = ACTIONS(5470),
    [anon_sym_LT_EQ_GT] = ACTIONS(5472),
    [anon_sym_or] = ACTIONS(5470),
    [anon_sym_and] = ACTIONS(5470),
    [anon_sym_bitor] = ACTIONS(5470),
    [anon_sym_xor] = ACTIONS(5470),
    [anon_sym_bitand] = ACTIONS(5470),
    [anon_sym_not_eq] = ACTIONS(5470),
    [anon_sym_DASH_DASH] = ACTIONS(5472),
    [anon_sym_PLUS_PLUS] = ACTIONS(5472),
    [anon_sym_DOT] = ACTIONS(5470),
    [anon_sym_DOT_STAR] = ACTIONS(5472),
    [anon_sym_DASH_GT] = ACTIONS(5472),
    [anon_sym_L_DQUOTE] = ACTIONS(5472),
    [anon_sym_u_DQUOTE] = ACTIONS(5472),
    [anon_sym_U_DQUOTE] = ACTIONS(5472),
    [anon_sym_u8_DQUOTE] = ACTIONS(5472),
    [anon_sym_DQUOTE] = ACTIONS(5472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5472),
    [anon_sym_LR_DQUOTE] = ACTIONS(5472),
    [anon_sym_uR_DQUOTE] = ACTIONS(5472),
    [anon_sym_UR_DQUOTE] = ACTIONS(5472),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5472),
    [sym_literal_suffix] = ACTIONS(5470),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5472),
  },
  [2509] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5360),
    [anon_sym_COMMA] = ACTIONS(5360),
    [anon_sym_LPAREN2] = ACTIONS(5360),
    [anon_sym_DASH] = ACTIONS(5358),
    [anon_sym_PLUS] = ACTIONS(5358),
    [anon_sym_STAR] = ACTIONS(5360),
    [anon_sym_SLASH] = ACTIONS(5358),
    [anon_sym_PERCENT] = ACTIONS(5360),
    [anon_sym_PIPE_PIPE] = ACTIONS(5360),
    [anon_sym_AMP_AMP] = ACTIONS(5360),
    [anon_sym_PIPE] = ACTIONS(5358),
    [anon_sym_CARET] = ACTIONS(5360),
    [anon_sym_AMP] = ACTIONS(5358),
    [anon_sym_EQ_EQ] = ACTIONS(5360),
    [anon_sym_BANG_EQ] = ACTIONS(5360),
    [anon_sym_GT] = ACTIONS(5358),
    [anon_sym_GT_EQ] = ACTIONS(5358),
    [anon_sym_LT_EQ] = ACTIONS(5358),
    [anon_sym_LT] = ACTIONS(5358),
    [anon_sym_LT_LT] = ACTIONS(5358),
    [anon_sym_GT_GT] = ACTIONS(5358),
    [anon_sym___extension__] = ACTIONS(5360),
    [anon_sym___global__] = ACTIONS(5360),
    [anon_sym___attribute__] = ACTIONS(5360),
    [anon_sym_LBRACE] = ACTIONS(5360),
    [anon_sym_LBRACK] = ACTIONS(5360),
    [anon_sym_const] = ACTIONS(5358),
    [anon_sym_constexpr] = ACTIONS(5360),
    [anon_sym_volatile] = ACTIONS(5360),
    [anon_sym_restrict] = ACTIONS(5360),
    [anon_sym___restrict__] = ACTIONS(5360),
    [anon_sym__Atomic] = ACTIONS(5360),
    [anon_sym__Noreturn] = ACTIONS(5360),
    [anon_sym_noreturn] = ACTIONS(5360),
    [anon_sym_mutable] = ACTIONS(5360),
    [anon_sym_constinit] = ACTIONS(5360),
    [anon_sym_consteval] = ACTIONS(5360),
    [anon_sym___shared__] = ACTIONS(5360),
    [anon_sym___local__] = ACTIONS(5360),
    [anon_sym___constant__] = ACTIONS(5360),
    [anon_sym___managed__] = ACTIONS(5360),
    [anon_sym___grid_constant__] = ACTIONS(5360),
    [anon_sym_alignas] = ACTIONS(5360),
    [anon_sym__Alignas] = ACTIONS(5360),
    [anon_sym_QMARK] = ACTIONS(5360),
    [anon_sym_LT_EQ_GT] = ACTIONS(5360),
    [anon_sym_or] = ACTIONS(5360),
    [anon_sym_and] = ACTIONS(5360),
    [anon_sym_bitor] = ACTIONS(5360),
    [anon_sym_xor] = ACTIONS(5360),
    [anon_sym_bitand] = ACTIONS(5360),
    [anon_sym_not_eq] = ACTIONS(5360),
    [anon_sym_DASH_DASH] = ACTIONS(5360),
    [anon_sym_PLUS_PLUS] = ACTIONS(5360),
    [anon_sym_DOT] = ACTIONS(5358),
    [anon_sym_DOT_STAR] = ACTIONS(5360),
    [anon_sym_DASH_GT] = ACTIONS(5360),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5360),
    [anon_sym_decltype] = ACTIONS(5360),
    [anon_sym_final] = ACTIONS(5360),
    [anon_sym_override] = ACTIONS(5360),
    [anon_sym_GT2] = ACTIONS(5360),
    [anon_sym_requires] = ACTIONS(5360),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5360),
  },
  [2510] = {
    [sym_string_literal] = STATE(2489),
    [sym_raw_string_literal] = STATE(2489),
    [aux_sym_concatenated_string_repeat1] = STATE(2489),
    [sym_identifier] = ACTIONS(6124),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5307),
    [anon_sym_COMMA] = ACTIONS(5307),
    [anon_sym_RPAREN] = ACTIONS(5307),
    [anon_sym_LPAREN2] = ACTIONS(5307),
    [anon_sym_DASH] = ACTIONS(5309),
    [anon_sym_PLUS] = ACTIONS(5309),
    [anon_sym_STAR] = ACTIONS(5309),
    [anon_sym_SLASH] = ACTIONS(5309),
    [anon_sym_PERCENT] = ACTIONS(5309),
    [anon_sym_PIPE_PIPE] = ACTIONS(5307),
    [anon_sym_AMP_AMP] = ACTIONS(5307),
    [anon_sym_PIPE] = ACTIONS(5309),
    [anon_sym_CARET] = ACTIONS(5309),
    [anon_sym_AMP] = ACTIONS(5309),
    [anon_sym_EQ_EQ] = ACTIONS(5307),
    [anon_sym_BANG_EQ] = ACTIONS(5307),
    [anon_sym_GT] = ACTIONS(5309),
    [anon_sym_GT_EQ] = ACTIONS(5307),
    [anon_sym_LT_EQ] = ACTIONS(5309),
    [anon_sym_LT] = ACTIONS(5309),
    [anon_sym_LT_LT] = ACTIONS(5309),
    [anon_sym_GT_GT] = ACTIONS(5309),
    [anon_sym_LBRACK] = ACTIONS(5307),
    [anon_sym_EQ] = ACTIONS(5309),
    [anon_sym_QMARK] = ACTIONS(5307),
    [anon_sym_STAR_EQ] = ACTIONS(5307),
    [anon_sym_SLASH_EQ] = ACTIONS(5307),
    [anon_sym_PERCENT_EQ] = ACTIONS(5307),
    [anon_sym_PLUS_EQ] = ACTIONS(5307),
    [anon_sym_DASH_EQ] = ACTIONS(5307),
    [anon_sym_LT_LT_EQ] = ACTIONS(5307),
    [anon_sym_GT_GT_EQ] = ACTIONS(5307),
    [anon_sym_AMP_EQ] = ACTIONS(5307),
    [anon_sym_CARET_EQ] = ACTIONS(5307),
    [anon_sym_PIPE_EQ] = ACTIONS(5307),
    [anon_sym_LT_EQ_GT] = ACTIONS(5307),
    [anon_sym_or] = ACTIONS(5309),
    [anon_sym_and] = ACTIONS(5309),
    [anon_sym_bitor] = ACTIONS(5309),
    [anon_sym_xor] = ACTIONS(5309),
    [anon_sym_bitand] = ACTIONS(5309),
    [anon_sym_not_eq] = ACTIONS(5309),
    [anon_sym_DASH_DASH] = ACTIONS(5307),
    [anon_sym_PLUS_PLUS] = ACTIONS(5307),
    [anon_sym_DOT] = ACTIONS(5309),
    [anon_sym_DOT_STAR] = ACTIONS(5307),
    [anon_sym_DASH_GT] = ACTIONS(5309),
    [anon_sym_L_DQUOTE] = ACTIONS(3976),
    [anon_sym_u_DQUOTE] = ACTIONS(3976),
    [anon_sym_U_DQUOTE] = ACTIONS(3976),
    [anon_sym_u8_DQUOTE] = ACTIONS(3976),
    [anon_sym_DQUOTE] = ACTIONS(3976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3978),
    [anon_sym_LR_DQUOTE] = ACTIONS(3978),
    [anon_sym_uR_DQUOTE] = ACTIONS(3978),
    [anon_sym_UR_DQUOTE] = ACTIONS(3978),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3978),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5307),
    [sym_literal_suffix] = ACTIONS(5309),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5307),
  },
  [2511] = {
    [sym_template_argument_list] = STATE(2487),
    [sym_identifier] = ACTIONS(6126),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(6128),
    [anon_sym_RPAREN] = ACTIONS(6128),
    [aux_sym_preproc_if_token2] = ACTIONS(6128),
    [aux_sym_preproc_else_token1] = ACTIONS(6128),
    [aux_sym_preproc_elif_token1] = ACTIONS(6126),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6128),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6128),
    [anon_sym_LPAREN2] = ACTIONS(6128),
    [anon_sym_DASH] = ACTIONS(6126),
    [anon_sym_PLUS] = ACTIONS(6126),
    [anon_sym_STAR] = ACTIONS(6126),
    [anon_sym_SLASH] = ACTIONS(6126),
    [anon_sym_PERCENT] = ACTIONS(6126),
    [anon_sym_PIPE_PIPE] = ACTIONS(6128),
    [anon_sym_AMP_AMP] = ACTIONS(6128),
    [anon_sym_PIPE] = ACTIONS(6126),
    [anon_sym_CARET] = ACTIONS(6126),
    [anon_sym_AMP] = ACTIONS(6126),
    [anon_sym_EQ_EQ] = ACTIONS(6128),
    [anon_sym_BANG_EQ] = ACTIONS(6128),
    [anon_sym_GT] = ACTIONS(6126),
    [anon_sym_GT_EQ] = ACTIONS(6128),
    [anon_sym_LT_EQ] = ACTIONS(6126),
    [anon_sym_LT] = ACTIONS(6130),
    [anon_sym_LT_LT] = ACTIONS(6126),
    [anon_sym_GT_GT] = ACTIONS(6126),
    [anon_sym_SEMI] = ACTIONS(6128),
    [anon_sym___attribute__] = ACTIONS(6126),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_RBRACE] = ACTIONS(6128),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_RBRACK] = ACTIONS(6128),
    [anon_sym_EQ] = ACTIONS(6126),
    [anon_sym_COLON] = ACTIONS(6126),
    [anon_sym_QMARK] = ACTIONS(6128),
    [anon_sym_STAR_EQ] = ACTIONS(6128),
    [anon_sym_SLASH_EQ] = ACTIONS(6128),
    [anon_sym_PERCENT_EQ] = ACTIONS(6128),
    [anon_sym_PLUS_EQ] = ACTIONS(6128),
    [anon_sym_DASH_EQ] = ACTIONS(6128),
    [anon_sym_LT_LT_EQ] = ACTIONS(6128),
    [anon_sym_GT_GT_EQ] = ACTIONS(6128),
    [anon_sym_AMP_EQ] = ACTIONS(6128),
    [anon_sym_CARET_EQ] = ACTIONS(6128),
    [anon_sym_PIPE_EQ] = ACTIONS(6128),
    [anon_sym_and_eq] = ACTIONS(6126),
    [anon_sym_or_eq] = ACTIONS(6126),
    [anon_sym_xor_eq] = ACTIONS(6126),
    [anon_sym_LT_EQ_GT] = ACTIONS(6128),
    [anon_sym_or] = ACTIONS(6126),
    [anon_sym_and] = ACTIONS(6126),
    [anon_sym_bitor] = ACTIONS(6126),
    [anon_sym_xor] = ACTIONS(6126),
    [anon_sym_bitand] = ACTIONS(6126),
    [anon_sym_not_eq] = ACTIONS(6126),
    [anon_sym_DASH_DASH] = ACTIONS(6128),
    [anon_sym_PLUS_PLUS] = ACTIONS(6128),
    [anon_sym_DOT] = ACTIONS(6126),
    [anon_sym_DOT_STAR] = ACTIONS(6128),
    [anon_sym_DASH_GT] = ACTIONS(6128),
    [sym_comment] = ACTIONS(3),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(6128),
  },
  [2512] = {
    [sym_attribute_specifier] = STATE(2192),
    [sym_identifier] = ACTIONS(5658),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5656),
    [anon_sym_COMMA] = ACTIONS(5656),
    [anon_sym_RPAREN] = ACTIONS(5656),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_TILDE] = ACTIONS(5656),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5656),
    [anon_sym___extension__] = ACTIONS(5658),
    [anon_sym___device__] = ACTIONS(5658),
    [anon_sym___host__] = ACTIONS(5658),
    [anon_sym___global__] = ACTIONS(5658),
    [anon_sym___forceinline__] = ACTIONS(5658),
    [anon_sym___noinline__] = ACTIONS(5658),
    [anon_sym_extern] = ACTIONS(5658),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5656),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5656),
    [anon_sym___declspec] = ACTIONS(5658),
    [anon_sym___based] = ACTIONS(5658),
    [anon_sym___cdecl] = ACTIONS(5658),
    [anon_sym___clrcall] = ACTIONS(5658),
    [anon_sym___stdcall] = ACTIONS(5658),
    [anon_sym___fastcall] = ACTIONS(5658),
    [anon_sym___thiscall] = ACTIONS(5658),
    [anon_sym___vectorcall] = ACTIONS(5658),
    [anon_sym_LBRACK] = ACTIONS(5658),
    [anon_sym_static] = ACTIONS(5658),
    [anon_sym_EQ] = ACTIONS(5656),
    [anon_sym_register] = ACTIONS(5658),
    [anon_sym_inline] = ACTIONS(5658),
    [anon_sym___inline] = ACTIONS(5658),
    [anon_sym___inline__] = ACTIONS(5658),
    [anon_sym___forceinline] = ACTIONS(5658),
    [anon_sym_thread_local] = ACTIONS(5658),
    [anon_sym___thread] = ACTIONS(5658),
    [anon_sym_const] = ACTIONS(5658),
    [anon_sym_constexpr] = ACTIONS(5658),
    [anon_sym_volatile] = ACTIONS(5658),
    [anon_sym_restrict] = ACTIONS(5658),
    [anon_sym___restrict__] = ACTIONS(5658),
    [anon_sym__Atomic] = ACTIONS(5658),
    [anon_sym__Noreturn] = ACTIONS(5658),
    [anon_sym_noreturn] = ACTIONS(5658),
    [anon_sym_mutable] = ACTIONS(5658),
    [anon_sym_constinit] = ACTIONS(5658),
    [anon_sym_consteval] = ACTIONS(5658),
    [anon_sym___shared__] = ACTIONS(5658),
    [anon_sym___local__] = ACTIONS(5658),
    [anon_sym___constant__] = ACTIONS(5658),
    [anon_sym___managed__] = ACTIONS(5658),
    [anon_sym___grid_constant__] = ACTIONS(5658),
    [anon_sym_alignas] = ACTIONS(5658),
    [anon_sym__Alignas] = ACTIONS(5658),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5658),
    [anon_sym_decltype] = ACTIONS(5658),
    [sym_virtual] = ACTIONS(5658),
    [anon_sym_template] = ACTIONS(5658),
    [anon_sym_GT2] = ACTIONS(5656),
    [anon_sym_operator] = ACTIONS(5658),
    [anon_sym___launch_bounds__] = ACTIONS(5658),
  },
  [2513] = {
    [sym_identifier] = ACTIONS(5458),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5460),
    [anon_sym_COMMA] = ACTIONS(5460),
    [anon_sym_LPAREN2] = ACTIONS(5460),
    [anon_sym_DASH] = ACTIONS(5458),
    [anon_sym_PLUS] = ACTIONS(5458),
    [anon_sym_STAR] = ACTIONS(5458),
    [anon_sym_SLASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5458),
    [anon_sym_PIPE_PIPE] = ACTIONS(5460),
    [anon_sym_AMP_AMP] = ACTIONS(5460),
    [anon_sym_PIPE] = ACTIONS(5458),
    [anon_sym_CARET] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5458),
    [anon_sym_EQ_EQ] = ACTIONS(5460),
    [anon_sym_BANG_EQ] = ACTIONS(5460),
    [anon_sym_GT] = ACTIONS(5458),
    [anon_sym_GT_EQ] = ACTIONS(5460),
    [anon_sym_LT_EQ] = ACTIONS(5458),
    [anon_sym_LT] = ACTIONS(5458),
    [anon_sym_LT_LT] = ACTIONS(5458),
    [anon_sym_GT_GT] = ACTIONS(5458),
    [anon_sym_SEMI] = ACTIONS(5460),
    [anon_sym___attribute__] = ACTIONS(5458),
    [anon_sym_LBRACK] = ACTIONS(5460),
    [anon_sym_EQ] = ACTIONS(5458),
    [anon_sym_QMARK] = ACTIONS(5460),
    [anon_sym_STAR_EQ] = ACTIONS(5460),
    [anon_sym_SLASH_EQ] = ACTIONS(5460),
    [anon_sym_PERCENT_EQ] = ACTIONS(5460),
    [anon_sym_PLUS_EQ] = ACTIONS(5460),
    [anon_sym_DASH_EQ] = ACTIONS(5460),
    [anon_sym_LT_LT_EQ] = ACTIONS(5460),
    [anon_sym_GT_GT_EQ] = ACTIONS(5460),
    [anon_sym_AMP_EQ] = ACTIONS(5460),
    [anon_sym_CARET_EQ] = ACTIONS(5460),
    [anon_sym_PIPE_EQ] = ACTIONS(5460),
    [anon_sym_and_eq] = ACTIONS(5458),
    [anon_sym_or_eq] = ACTIONS(5458),
    [anon_sym_xor_eq] = ACTIONS(5458),
    [anon_sym_LT_EQ_GT] = ACTIONS(5460),
    [anon_sym_or] = ACTIONS(5458),
    [anon_sym_and] = ACTIONS(5458),
    [anon_sym_bitor] = ACTIONS(5458),
    [anon_sym_xor] = ACTIONS(5458),
    [anon_sym_bitand] = ACTIONS(5458),
    [anon_sym_not_eq] = ACTIONS(5458),
    [anon_sym_DASH_DASH] = ACTIONS(5460),
    [anon_sym_PLUS_PLUS] = ACTIONS(5460),
    [anon_sym_DOT] = ACTIONS(5458),
    [anon_sym_DOT_STAR] = ACTIONS(5460),
    [anon_sym_DASH_GT] = ACTIONS(5460),
    [anon_sym_L_DQUOTE] = ACTIONS(5460),
    [anon_sym_u_DQUOTE] = ACTIONS(5460),
    [anon_sym_U_DQUOTE] = ACTIONS(5460),
    [anon_sym_u8_DQUOTE] = ACTIONS(5460),
    [anon_sym_DQUOTE] = ACTIONS(5460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5460),
    [anon_sym_LR_DQUOTE] = ACTIONS(5460),
    [anon_sym_uR_DQUOTE] = ACTIONS(5460),
    [anon_sym_UR_DQUOTE] = ACTIONS(5460),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5460),
    [sym_literal_suffix] = ACTIONS(5458),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5460),
  },
  [2514] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5446),
    [anon_sym_COMMA] = ACTIONS(5446),
    [anon_sym_RPAREN] = ACTIONS(5446),
    [anon_sym_LPAREN2] = ACTIONS(5446),
    [anon_sym_DASH] = ACTIONS(5448),
    [anon_sym_PLUS] = ACTIONS(5448),
    [anon_sym_STAR] = ACTIONS(5448),
    [anon_sym_SLASH] = ACTIONS(5448),
    [anon_sym_PERCENT] = ACTIONS(5448),
    [anon_sym_PIPE_PIPE] = ACTIONS(5446),
    [anon_sym_AMP_AMP] = ACTIONS(5446),
    [anon_sym_PIPE] = ACTIONS(5448),
    [anon_sym_CARET] = ACTIONS(5448),
    [anon_sym_AMP] = ACTIONS(5448),
    [anon_sym_EQ_EQ] = ACTIONS(5446),
    [anon_sym_BANG_EQ] = ACTIONS(5446),
    [anon_sym_GT] = ACTIONS(5448),
    [anon_sym_GT_EQ] = ACTIONS(5446),
    [anon_sym_LT_EQ] = ACTIONS(5448),
    [anon_sym_LT] = ACTIONS(5448),
    [anon_sym_LT_LT] = ACTIONS(5448),
    [anon_sym_GT_GT] = ACTIONS(5448),
    [anon_sym_SEMI] = ACTIONS(5446),
    [anon_sym___attribute__] = ACTIONS(5446),
    [anon_sym_LBRACE] = ACTIONS(5446),
    [anon_sym_RBRACE] = ACTIONS(5446),
    [anon_sym_signed] = ACTIONS(6133),
    [anon_sym_unsigned] = ACTIONS(6133),
    [anon_sym_long] = ACTIONS(6133),
    [anon_sym_short] = ACTIONS(6133),
    [anon_sym_LBRACK] = ACTIONS(5446),
    [anon_sym_RBRACK] = ACTIONS(5446),
    [anon_sym_EQ] = ACTIONS(5448),
    [anon_sym_COLON] = ACTIONS(5446),
    [anon_sym_QMARK] = ACTIONS(5446),
    [anon_sym_STAR_EQ] = ACTIONS(5446),
    [anon_sym_SLASH_EQ] = ACTIONS(5446),
    [anon_sym_PERCENT_EQ] = ACTIONS(5446),
    [anon_sym_PLUS_EQ] = ACTIONS(5446),
    [anon_sym_DASH_EQ] = ACTIONS(5446),
    [anon_sym_LT_LT_EQ] = ACTIONS(5446),
    [anon_sym_GT_GT_EQ] = ACTIONS(5446),
    [anon_sym_AMP_EQ] = ACTIONS(5446),
    [anon_sym_CARET_EQ] = ACTIONS(5446),
    [anon_sym_PIPE_EQ] = ACTIONS(5446),
    [anon_sym_and_eq] = ACTIONS(5446),
    [anon_sym_or_eq] = ACTIONS(5446),
    [anon_sym_xor_eq] = ACTIONS(5446),
    [anon_sym_LT_EQ_GT] = ACTIONS(5446),
    [anon_sym_or] = ACTIONS(5448),
    [anon_sym_and] = ACTIONS(5448),
    [anon_sym_bitor] = ACTIONS(5446),
    [anon_sym_xor] = ACTIONS(5448),
    [anon_sym_bitand] = ACTIONS(5446),
    [anon_sym_not_eq] = ACTIONS(5446),
    [anon_sym_DASH_DASH] = ACTIONS(5446),
    [anon_sym_PLUS_PLUS] = ACTIONS(5446),
    [anon_sym_DOT] = ACTIONS(5448),
    [anon_sym_DOT_STAR] = ACTIONS(5446),
    [anon_sym_DASH_GT] = ACTIONS(5446),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5446),
    [anon_sym_decltype] = ACTIONS(5446),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5446),
  },
  [2515] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2496),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5440),
    [anon_sym_COMMA] = ACTIONS(5440),
    [anon_sym_RPAREN] = ACTIONS(5440),
    [anon_sym_LPAREN2] = ACTIONS(5440),
    [anon_sym_DASH] = ACTIONS(5442),
    [anon_sym_PLUS] = ACTIONS(5442),
    [anon_sym_STAR] = ACTIONS(5442),
    [anon_sym_SLASH] = ACTIONS(5442),
    [anon_sym_PERCENT] = ACTIONS(5442),
    [anon_sym_PIPE_PIPE] = ACTIONS(5440),
    [anon_sym_AMP_AMP] = ACTIONS(5440),
    [anon_sym_PIPE] = ACTIONS(5442),
    [anon_sym_CARET] = ACTIONS(5442),
    [anon_sym_AMP] = ACTIONS(5442),
    [anon_sym_EQ_EQ] = ACTIONS(5440),
    [anon_sym_BANG_EQ] = ACTIONS(5440),
    [anon_sym_GT] = ACTIONS(5442),
    [anon_sym_GT_EQ] = ACTIONS(5440),
    [anon_sym_LT_EQ] = ACTIONS(5442),
    [anon_sym_LT] = ACTIONS(5442),
    [anon_sym_LT_LT] = ACTIONS(5442),
    [anon_sym_GT_GT] = ACTIONS(5442),
    [anon_sym_SEMI] = ACTIONS(5440),
    [anon_sym___attribute__] = ACTIONS(5440),
    [anon_sym_LBRACE] = ACTIONS(5440),
    [anon_sym_RBRACE] = ACTIONS(5440),
    [anon_sym_signed] = ACTIONS(6135),
    [anon_sym_unsigned] = ACTIONS(6135),
    [anon_sym_long] = ACTIONS(6135),
    [anon_sym_short] = ACTIONS(6135),
    [anon_sym_LBRACK] = ACTIONS(5440),
    [anon_sym_RBRACK] = ACTIONS(5440),
    [anon_sym_EQ] = ACTIONS(5442),
    [anon_sym_COLON] = ACTIONS(5440),
    [anon_sym_QMARK] = ACTIONS(5440),
    [anon_sym_STAR_EQ] = ACTIONS(5440),
    [anon_sym_SLASH_EQ] = ACTIONS(5440),
    [anon_sym_PERCENT_EQ] = ACTIONS(5440),
    [anon_sym_PLUS_EQ] = ACTIONS(5440),
    [anon_sym_DASH_EQ] = ACTIONS(5440),
    [anon_sym_LT_LT_EQ] = ACTIONS(5440),
    [anon_sym_GT_GT_EQ] = ACTIONS(5440),
    [anon_sym_AMP_EQ] = ACTIONS(5440),
    [anon_sym_CARET_EQ] = ACTIONS(5440),
    [anon_sym_PIPE_EQ] = ACTIONS(5440),
    [anon_sym_and_eq] = ACTIONS(5440),
    [anon_sym_or_eq] = ACTIONS(5440),
    [anon_sym_xor_eq] = ACTIONS(5440),
    [anon_sym_LT_EQ_GT] = ACTIONS(5440),
    [anon_sym_or] = ACTIONS(5442),
    [anon_sym_and] = ACTIONS(5442),
    [anon_sym_bitor] = ACTIONS(5440),
    [anon_sym_xor] = ACTIONS(5442),
    [anon_sym_bitand] = ACTIONS(5440),
    [anon_sym_not_eq] = ACTIONS(5440),
    [anon_sym_DASH_DASH] = ACTIONS(5440),
    [anon_sym_PLUS_PLUS] = ACTIONS(5440),
    [anon_sym_DOT] = ACTIONS(5442),
    [anon_sym_DOT_STAR] = ACTIONS(5440),
    [anon_sym_DASH_GT] = ACTIONS(5440),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5440),
    [anon_sym_decltype] = ACTIONS(5440),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5440),
  },
  [2516] = {
    [sym_string_literal] = STATE(2347),
    [sym_raw_string_literal] = STATE(2347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3758),
    [anon_sym_LPAREN2] = ACTIONS(3758),
    [anon_sym_DASH] = ACTIONS(3766),
    [anon_sym_PLUS] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3766),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3758),
    [anon_sym_AMP_AMP] = ACTIONS(3758),
    [anon_sym_PIPE] = ACTIONS(3766),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3758),
    [anon_sym_BANG_EQ] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3758),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3766),
    [anon_sym_LBRACK] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_STAR_EQ] = ACTIONS(3758),
    [anon_sym_SLASH_EQ] = ACTIONS(3758),
    [anon_sym_PERCENT_EQ] = ACTIONS(3758),
    [anon_sym_PLUS_EQ] = ACTIONS(3758),
    [anon_sym_DASH_EQ] = ACTIONS(3758),
    [anon_sym_LT_LT_EQ] = ACTIONS(3758),
    [anon_sym_GT_GT_EQ] = ACTIONS(3758),
    [anon_sym_AMP_EQ] = ACTIONS(3758),
    [anon_sym_CARET_EQ] = ACTIONS(3758),
    [anon_sym_PIPE_EQ] = ACTIONS(3758),
    [anon_sym_and_eq] = ACTIONS(3766),
    [anon_sym_or_eq] = ACTIONS(3766),
    [anon_sym_xor_eq] = ACTIONS(3766),
    [anon_sym_LT_EQ_GT] = ACTIONS(3758),
    [anon_sym_or] = ACTIONS(3766),
    [anon_sym_and] = ACTIONS(3766),
    [anon_sym_bitor] = ACTIONS(3766),
    [anon_sym_xor] = ACTIONS(3766),
    [anon_sym_bitand] = ACTIONS(3766),
    [anon_sym_not_eq] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3758),
    [anon_sym_PLUS_PLUS] = ACTIONS(3758),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_DOT_STAR] = ACTIONS(3758),
    [anon_sym_DASH_GT] = ACTIONS(3758),
    [anon_sym_L_DQUOTE] = ACTIONS(5863),
    [anon_sym_u_DQUOTE] = ACTIONS(5863),
    [anon_sym_U_DQUOTE] = ACTIONS(5863),
    [anon_sym_u8_DQUOTE] = ACTIONS(5863),
    [anon_sym_DQUOTE] = ACTIONS(5863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5865),
    [anon_sym_LR_DQUOTE] = ACTIONS(5865),
    [anon_sym_uR_DQUOTE] = ACTIONS(5865),
    [anon_sym_UR_DQUOTE] = ACTIONS(5865),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5865),
    [sym_literal_suffix] = ACTIONS(6092),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(3758),
    [aux_sym_kernel_call_syntax_token2] = ACTIONS(3758),
  },
  [2517] = {
    [sym_attribute_specifier] = STATE(2171),
    [sym_identifier] = ACTIONS(5684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5682),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_RPAREN] = ACTIONS(5682),
    [anon_sym_LPAREN2] = ACTIONS(5682),
    [anon_sym_TILDE] = ACTIONS(5682),
    [anon_sym_STAR] = ACTIONS(5682),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_SEMI] = ACTIONS(5682),
    [anon_sym___extension__] = ACTIONS(5684),
    [anon_sym___device__] = ACTIONS(5684),
    [anon_sym___host__] = ACTIONS(5684),
    [anon_sym___global__] = ACTIONS(5684),
    [anon_sym___forceinline__] = ACTIONS(5684),
    [anon_sym___noinline__] = ACTIONS(5684),
    [anon_sym_extern] = ACTIONS(5684),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5682),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5682),
    [anon_sym___declspec] = ACTIONS(5684),
    [anon_sym___based] = ACTIONS(5684),
    [anon_sym___cdecl] = ACTIONS(5684),
    [anon_sym___clrcall] = ACTIONS(5684),
    [anon_sym___stdcall] = ACTIONS(5684),
    [anon_sym___fastcall] = ACTIONS(5684),
    [anon_sym___thiscall] = ACTIONS(5684),
    [anon_sym___vectorcall] = ACTIONS(5684),
    [anon_sym_LBRACK] = ACTIONS(5684),
    [anon_sym_static] = ACTIONS(5684),
    [anon_sym_EQ] = ACTIONS(5682),
    [anon_sym_register] = ACTIONS(5684),
    [anon_sym_inline] = ACTIONS(5684),
    [anon_sym___inline] = ACTIONS(5684),
    [anon_sym___inline__] = ACTIONS(5684),
    [anon_sym___forceinline] = ACTIONS(5684),
    [anon_sym_thread_local] = ACTIONS(5684),
    [anon_sym___thread] = ACTIONS(5684),
    [anon_sym_const] = ACTIONS(5684),
    [anon_sym_constexpr] = ACTIONS(5684),
    [anon_sym_volatile] = ACTIONS(5684),
    [anon_sym_restrict] = ACTIONS(5684),
    [anon_sym___restrict__] = ACTIONS(5684),
    [anon_sym__Atomic] = ACTIONS(5684),
    [anon_sym__Noreturn] = ACTIONS(5684),
    [anon_sym_noreturn] = ACTIONS(5684),
    [anon_sym_mutable] = ACTIONS(5684),
    [anon_sym_constinit] = ACTIONS(5684),
    [anon_sym_consteval] = ACTIONS(5684),
    [anon_sym___shared__] = ACTIONS(5684),
    [anon_sym___local__] = ACTIONS(5684),
    [anon_sym___constant__] = ACTIONS(5684),
    [anon_sym___managed__] = ACTIONS(5684),
    [anon_sym___grid_constant__] = ACTIONS(5684),
    [anon_sym_alignas] = ACTIONS(5684),
    [anon_sym__Alignas] = ACTIONS(5684),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5684),
    [anon_sym_decltype] = ACTIONS(5684),
    [sym_virtual] = ACTIONS(5684),
    [anon_sym_template] = ACTIONS(5684),
    [anon_sym_GT2] = ACTIONS(5682),
    [anon_sym_operator] = ACTIONS(5684),
    [anon_sym___launch_bounds__] = ACTIONS(5684),
  },
  [2518] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5432),
    [anon_sym_COMMA] = ACTIONS(5432),
    [anon_sym_RPAREN] = ACTIONS(5432),
    [anon_sym_LPAREN2] = ACTIONS(5432),
    [anon_sym_DASH] = ACTIONS(5434),
    [anon_sym_PLUS] = ACTIONS(5434),
    [anon_sym_STAR] = ACTIONS(5434),
    [anon_sym_SLASH] = ACTIONS(5434),
    [anon_sym_PERCENT] = ACTIONS(5434),
    [anon_sym_PIPE_PIPE] = ACTIONS(5432),
    [anon_sym_AMP_AMP] = ACTIONS(5432),
    [anon_sym_PIPE] = ACTIONS(5434),
    [anon_sym_CARET] = ACTIONS(5434),
    [anon_sym_AMP] = ACTIONS(5434),
    [anon_sym_EQ_EQ] = ACTIONS(5432),
    [anon_sym_BANG_EQ] = ACTIONS(5432),
    [anon_sym_GT] = ACTIONS(5434),
    [anon_sym_GT_EQ] = ACTIONS(5432),
    [anon_sym_LT_EQ] = ACTIONS(5434),
    [anon_sym_LT] = ACTIONS(5434),
    [anon_sym_LT_LT] = ACTIONS(5434),
    [anon_sym_GT_GT] = ACTIONS(5434),
    [anon_sym_SEMI] = ACTIONS(5432),
    [anon_sym___attribute__] = ACTIONS(5432),
    [anon_sym_LBRACE] = ACTIONS(5432),
    [anon_sym_RBRACE] = ACTIONS(5432),
    [anon_sym_signed] = ACTIONS(6034),
    [anon_sym_unsigned] = ACTIONS(6034),
    [anon_sym_long] = ACTIONS(6034),
    [anon_sym_short] = ACTIONS(6034),
    [anon_sym_LBRACK] = ACTIONS(5432),
    [anon_sym_RBRACK] = ACTIONS(5432),
    [anon_sym_EQ] = ACTIONS(5434),
    [anon_sym_COLON] = ACTIONS(5432),
    [anon_sym_QMARK] = ACTIONS(5432),
    [anon_sym_STAR_EQ] = ACTIONS(5432),
    [anon_sym_SLASH_EQ] = ACTIONS(5432),
    [anon_sym_PERCENT_EQ] = ACTIONS(5432),
    [anon_sym_PLUS_EQ] = ACTIONS(5432),
    [anon_sym_DASH_EQ] = ACTIONS(5432),
    [anon_sym_LT_LT_EQ] = ACTIONS(5432),
    [anon_sym_GT_GT_EQ] = ACTIONS(5432),
    [anon_sym_AMP_EQ] = ACTIONS(5432),
    [anon_sym_CARET_EQ] = ACTIONS(5432),
    [anon_sym_PIPE_EQ] = ACTIONS(5432),
    [anon_sym_and_eq] = ACTIONS(5432),
    [anon_sym_or_eq] = ACTIONS(5432),
    [anon_sym_xor_eq] = ACTIONS(5432),
    [anon_sym_LT_EQ_GT] = ACTIONS(5432),
    [anon_sym_or] = ACTIONS(5434),
    [anon_sym_and] = ACTIONS(5434),
    [anon_sym_bitor] = ACTIONS(5432),
    [anon_sym_xor] = ACTIONS(5434),
    [anon_sym_bitand] = ACTIONS(5432),
    [anon_sym_not_eq] = ACTIONS(5432),
    [anon_sym_DASH_DASH] = ACTIONS(5432),
    [anon_sym_PLUS_PLUS] = ACTIONS(5432),
    [anon_sym_DOT] = ACTIONS(5434),
    [anon_sym_DOT_STAR] = ACTIONS(5432),
    [anon_sym_DASH_GT] = ACTIONS(5432),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5432),
    [anon_sym_decltype] = ACTIONS(5432),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5432),
  },
  [2519] = {
    [sym_string_literal] = STATE(2510),
    [sym_raw_string_literal] = STATE(2510),
    [aux_sym_concatenated_string_repeat1] = STATE(2510),
    [sym_identifier] = ACTIONS(6137),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5346),
    [anon_sym_COMMA] = ACTIONS(5346),
    [anon_sym_RPAREN] = ACTIONS(5346),
    [anon_sym_LPAREN2] = ACTIONS(5346),
    [anon_sym_DASH] = ACTIONS(5348),
    [anon_sym_PLUS] = ACTIONS(5348),
    [anon_sym_STAR] = ACTIONS(5348),
    [anon_sym_SLASH] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [anon_sym_PIPE_PIPE] = ACTIONS(5346),
    [anon_sym_AMP_AMP] = ACTIONS(5346),
    [anon_sym_PIPE] = ACTIONS(5348),
    [anon_sym_CARET] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5348),
    [anon_sym_EQ_EQ] = ACTIONS(5346),
    [anon_sym_BANG_EQ] = ACTIONS(5346),
    [anon_sym_GT] = ACTIONS(5348),
    [anon_sym_GT_EQ] = ACTIONS(5346),
    [anon_sym_LT_EQ] = ACTIONS(5348),
    [anon_sym_LT] = ACTIONS(5348),
    [anon_sym_LT_LT] = ACTIONS(5348),
    [anon_sym_GT_GT] = ACTIONS(5348),
    [anon_sym_LBRACK] = ACTIONS(5346),
    [anon_sym_EQ] = ACTIONS(5348),
    [anon_sym_QMARK] = ACTIONS(5346),
    [anon_sym_STAR_EQ] = ACTIONS(5346),
    [anon_sym_SLASH_EQ] = ACTIONS(5346),
    [anon_sym_PERCENT_EQ] = ACTIONS(5346),
    [anon_sym_PLUS_EQ] = ACTIONS(5346),
    [anon_sym_DASH_EQ] = ACTIONS(5346),
    [anon_sym_LT_LT_EQ] = ACTIONS(5346),
    [anon_sym_GT_GT_EQ] = ACTIONS(5346),
    [anon_sym_AMP_EQ] = ACTIONS(5346),
    [anon_sym_CARET_EQ] = ACTIONS(5346),
    [anon_sym_PIPE_EQ] = ACTIONS(5346),
    [anon_sym_LT_EQ_GT] = ACTIONS(5346),
    [anon_sym_or] = ACTIONS(5348),
    [anon_sym_and] = ACTIONS(5348),
    [anon_sym_bitor] = ACTIONS(5348),
    [anon_sym_xor] = ACTIONS(5348),
    [anon_sym_bitand] = ACTIONS(5348),
    [anon_sym_not_eq] = ACTIONS(5348),
    [anon_sym_DASH_DASH] = ACTIONS(5346),
    [anon_sym_PLUS_PLUS] = ACTIONS(5346),
    [anon_sym_DOT] = ACTIONS(5348),
    [anon_sym_DOT_STAR] = ACTIONS(5346),
    [anon_sym_DASH_GT] = ACTIONS(5348),
    [anon_sym_L_DQUOTE] = ACTIONS(3976),
    [anon_sym_u_DQUOTE] = ACTIONS(3976),
    [anon_sym_U_DQUOTE] = ACTIONS(3976),
    [anon_sym_u8_DQUOTE] = ACTIONS(3976),
    [anon_sym_DQUOTE] = ACTIONS(3976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3978),
    [anon_sym_LR_DQUOTE] = ACTIONS(3978),
    [anon_sym_uR_DQUOTE] = ACTIONS(3978),
    [anon_sym_UR_DQUOTE] = ACTIONS(3978),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3978),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5346),
    [sym_literal_suffix] = ACTIONS(5348),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5346),
  },
  [2520] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5436),
    [anon_sym_COMMA] = ACTIONS(5436),
    [anon_sym_RPAREN] = ACTIONS(5436),
    [anon_sym_LPAREN2] = ACTIONS(5436),
    [anon_sym_DASH] = ACTIONS(5438),
    [anon_sym_PLUS] = ACTIONS(5438),
    [anon_sym_STAR] = ACTIONS(5438),
    [anon_sym_SLASH] = ACTIONS(5438),
    [anon_sym_PERCENT] = ACTIONS(5438),
    [anon_sym_PIPE_PIPE] = ACTIONS(5436),
    [anon_sym_AMP_AMP] = ACTIONS(5436),
    [anon_sym_PIPE] = ACTIONS(5438),
    [anon_sym_CARET] = ACTIONS(5438),
    [anon_sym_AMP] = ACTIONS(5438),
    [anon_sym_EQ_EQ] = ACTIONS(5436),
    [anon_sym_BANG_EQ] = ACTIONS(5436),
    [anon_sym_GT] = ACTIONS(5438),
    [anon_sym_GT_EQ] = ACTIONS(5436),
    [anon_sym_LT_EQ] = ACTIONS(5438),
    [anon_sym_LT] = ACTIONS(5438),
    [anon_sym_LT_LT] = ACTIONS(5438),
    [anon_sym_GT_GT] = ACTIONS(5438),
    [anon_sym_SEMI] = ACTIONS(5436),
    [anon_sym___attribute__] = ACTIONS(5436),
    [anon_sym_LBRACE] = ACTIONS(5436),
    [anon_sym_RBRACE] = ACTIONS(5436),
    [anon_sym_signed] = ACTIONS(6034),
    [anon_sym_unsigned] = ACTIONS(6034),
    [anon_sym_long] = ACTIONS(6034),
    [anon_sym_short] = ACTIONS(6034),
    [anon_sym_LBRACK] = ACTIONS(5436),
    [anon_sym_RBRACK] = ACTIONS(5436),
    [anon_sym_EQ] = ACTIONS(5438),
    [anon_sym_COLON] = ACTIONS(5436),
    [anon_sym_QMARK] = ACTIONS(5436),
    [anon_sym_STAR_EQ] = ACTIONS(5436),
    [anon_sym_SLASH_EQ] = ACTIONS(5436),
    [anon_sym_PERCENT_EQ] = ACTIONS(5436),
    [anon_sym_PLUS_EQ] = ACTIONS(5436),
    [anon_sym_DASH_EQ] = ACTIONS(5436),
    [anon_sym_LT_LT_EQ] = ACTIONS(5436),
    [anon_sym_GT_GT_EQ] = ACTIONS(5436),
    [anon_sym_AMP_EQ] = ACTIONS(5436),
    [anon_sym_CARET_EQ] = ACTIONS(5436),
    [anon_sym_PIPE_EQ] = ACTIONS(5436),
    [anon_sym_and_eq] = ACTIONS(5436),
    [anon_sym_or_eq] = ACTIONS(5436),
    [anon_sym_xor_eq] = ACTIONS(5436),
    [anon_sym_LT_EQ_GT] = ACTIONS(5436),
    [anon_sym_or] = ACTIONS(5438),
    [anon_sym_and] = ACTIONS(5438),
    [anon_sym_bitor] = ACTIONS(5436),
    [anon_sym_xor] = ACTIONS(5438),
    [anon_sym_bitand] = ACTIONS(5436),
    [anon_sym_not_eq] = ACTIONS(5436),
    [anon_sym_DASH_DASH] = ACTIONS(5436),
    [anon_sym_PLUS_PLUS] = ACTIONS(5436),
    [anon_sym_DOT] = ACTIONS(5438),
    [anon_sym_DOT_STAR] = ACTIONS(5436),
    [anon_sym_DASH_GT] = ACTIONS(5436),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5436),
    [anon_sym_decltype] = ACTIONS(5436),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5436),
  },
  [2521] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5194),
    [anon_sym_COMMA] = ACTIONS(5194),
    [anon_sym_RPAREN] = ACTIONS(5194),
    [anon_sym_LPAREN2] = ACTIONS(5194),
    [anon_sym_DASH] = ACTIONS(5192),
    [anon_sym_PLUS] = ACTIONS(5192),
    [anon_sym_STAR] = ACTIONS(5192),
    [anon_sym_SLASH] = ACTIONS(5192),
    [anon_sym_PERCENT] = ACTIONS(5192),
    [anon_sym_PIPE_PIPE] = ACTIONS(5194),
    [anon_sym_AMP_AMP] = ACTIONS(5194),
    [anon_sym_PIPE] = ACTIONS(5192),
    [anon_sym_CARET] = ACTIONS(5192),
    [anon_sym_AMP] = ACTIONS(5192),
    [anon_sym_EQ_EQ] = ACTIONS(5194),
    [anon_sym_BANG_EQ] = ACTIONS(5194),
    [anon_sym_GT] = ACTIONS(5192),
    [anon_sym_GT_EQ] = ACTIONS(5194),
    [anon_sym_LT_EQ] = ACTIONS(5192),
    [anon_sym_LT] = ACTIONS(5192),
    [anon_sym_LT_LT] = ACTIONS(5192),
    [anon_sym_GT_GT] = ACTIONS(5192),
    [anon_sym_SEMI] = ACTIONS(5194),
    [anon_sym___attribute__] = ACTIONS(5194),
    [anon_sym_LBRACE] = ACTIONS(5194),
    [anon_sym_RBRACE] = ACTIONS(5194),
    [anon_sym_signed] = ACTIONS(6094),
    [anon_sym_unsigned] = ACTIONS(6094),
    [anon_sym_long] = ACTIONS(6094),
    [anon_sym_short] = ACTIONS(6094),
    [anon_sym_LBRACK] = ACTIONS(5194),
    [anon_sym_RBRACK] = ACTIONS(5194),
    [anon_sym_EQ] = ACTIONS(5192),
    [anon_sym_COLON] = ACTIONS(5194),
    [anon_sym_QMARK] = ACTIONS(5194),
    [anon_sym_STAR_EQ] = ACTIONS(5194),
    [anon_sym_SLASH_EQ] = ACTIONS(5194),
    [anon_sym_PERCENT_EQ] = ACTIONS(5194),
    [anon_sym_PLUS_EQ] = ACTIONS(5194),
    [anon_sym_DASH_EQ] = ACTIONS(5194),
    [anon_sym_LT_LT_EQ] = ACTIONS(5194),
    [anon_sym_GT_GT_EQ] = ACTIONS(5194),
    [anon_sym_AMP_EQ] = ACTIONS(5194),
    [anon_sym_CARET_EQ] = ACTIONS(5194),
    [anon_sym_PIPE_EQ] = ACTIONS(5194),
    [anon_sym_and_eq] = ACTIONS(5194),
    [anon_sym_or_eq] = ACTIONS(5194),
    [anon_sym_xor_eq] = ACTIONS(5194),
    [anon_sym_LT_EQ_GT] = ACTIONS(5194),
    [anon_sym_or] = ACTIONS(5192),
    [anon_sym_and] = ACTIONS(5192),
    [anon_sym_bitor] = ACTIONS(5194),
    [anon_sym_xor] = ACTIONS(5192),
    [anon_sym_bitand] = ACTIONS(5194),
    [anon_sym_not_eq] = ACTIONS(5194),
    [anon_sym_DASH_DASH] = ACTIONS(5194),
    [anon_sym_PLUS_PLUS] = ACTIONS(5194),
    [anon_sym_DOT] = ACTIONS(5192),
    [anon_sym_DOT_STAR] = ACTIONS(5194),
    [anon_sym_DASH_GT] = ACTIONS(5194),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5194),
    [anon_sym_decltype] = ACTIONS(5194),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5194),
  },
  [2522] = {
    [sym_identifier] = ACTIONS(5470),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5472),
    [anon_sym_COMMA] = ACTIONS(5472),
    [anon_sym_RPAREN] = ACTIONS(5472),
    [anon_sym_LPAREN2] = ACTIONS(5472),
    [anon_sym_DASH] = ACTIONS(5470),
    [anon_sym_PLUS] = ACTIONS(5470),
    [anon_sym_STAR] = ACTIONS(5470),
    [anon_sym_SLASH] = ACTIONS(5470),
    [anon_sym_PERCENT] = ACTIONS(5470),
    [anon_sym_PIPE_PIPE] = ACTIONS(5472),
    [anon_sym_AMP_AMP] = ACTIONS(5472),
    [anon_sym_PIPE] = ACTIONS(5470),
    [anon_sym_CARET] = ACTIONS(5470),
    [anon_sym_AMP] = ACTIONS(5470),
    [anon_sym_EQ_EQ] = ACTIONS(5472),
    [anon_sym_BANG_EQ] = ACTIONS(5472),
    [anon_sym_GT] = ACTIONS(5470),
    [anon_sym_GT_EQ] = ACTIONS(5472),
    [anon_sym_LT_EQ] = ACTIONS(5470),
    [anon_sym_LT] = ACTIONS(5470),
    [anon_sym_LT_LT] = ACTIONS(5470),
    [anon_sym_GT_GT] = ACTIONS(5470),
    [anon_sym_LBRACK] = ACTIONS(5472),
    [anon_sym_EQ] = ACTIONS(5470),
    [anon_sym_QMARK] = ACTIONS(5472),
    [anon_sym_STAR_EQ] = ACTIONS(5472),
    [anon_sym_SLASH_EQ] = ACTIONS(5472),
    [anon_sym_PERCENT_EQ] = ACTIONS(5472),
    [anon_sym_PLUS_EQ] = ACTIONS(5472),
    [anon_sym_DASH_EQ] = ACTIONS(5472),
    [anon_sym_LT_LT_EQ] = ACTIONS(5472),
    [anon_sym_GT_GT_EQ] = ACTIONS(5472),
    [anon_sym_AMP_EQ] = ACTIONS(5472),
    [anon_sym_CARET_EQ] = ACTIONS(5472),
    [anon_sym_PIPE_EQ] = ACTIONS(5472),
    [anon_sym_and_eq] = ACTIONS(5470),
    [anon_sym_or_eq] = ACTIONS(5470),
    [anon_sym_xor_eq] = ACTIONS(5470),
    [anon_sym_LT_EQ_GT] = ACTIONS(5472),
    [anon_sym_or] = ACTIONS(5470),
    [anon_sym_and] = ACTIONS(5470),
    [anon_sym_bitor] = ACTIONS(5470),
    [anon_sym_xor] = ACTIONS(5470),
    [anon_sym_bitand] = ACTIONS(5470),
    [anon_sym_not_eq] = ACTIONS(5470),
    [anon_sym_DASH_DASH] = ACTIONS(5472),
    [anon_sym_PLUS_PLUS] = ACTIONS(5472),
    [anon_sym_DOT] = ACTIONS(5470),
    [anon_sym_DOT_STAR] = ACTIONS(5472),
    [anon_sym_DASH_GT] = ACTIONS(5470),
    [anon_sym_L_DQUOTE] = ACTIONS(5472),
    [anon_sym_u_DQUOTE] = ACTIONS(5472),
    [anon_sym_U_DQUOTE] = ACTIONS(5472),
    [anon_sym_u8_DQUOTE] = ACTIONS(5472),
    [anon_sym_DQUOTE] = ACTIONS(5472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5472),
    [anon_sym_LR_DQUOTE] = ACTIONS(5472),
    [anon_sym_uR_DQUOTE] = ACTIONS(5472),
    [anon_sym_UR_DQUOTE] = ACTIONS(5472),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5472),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5472),
    [sym_literal_suffix] = ACTIONS(5470),
    [aux_sym_kernel_call_syntax_token1] = ACTIONS(5472),
  },
  [2523] = {
    [sym_template_argument_list] = STATE(2297),
    [sym_identifier] = ACTIONS(5212),
    [anon_sym_LPAREN2] = ACTIONS(3782),
    [anon_sym_TILDE] = ACTIONS(3782),
    [anon_sym_STAR] = ACTIONS(3782),
    [anon_sym_AMP_AMP] = ACTIONS(3782),
    [anon_sym_AMP] = ACTIONS(5212),
    [anon_sym_LT] = ACTIONS(5534),
    [anon_sym_SEMI] = ACTIONS(3782),
    [anon_sym___extension__] = ACTIONS(5212),
    [anon_sym___device__] = ACTIONS(5212),
    [anon_sym___host__] = ACTIONS(5212),
    [anon_sym___global__] = ACTIONS(5212),
    [anon_sym___forceinline__] = ACTIONS(5212),
    [anon_sym___noinline__] = ACTIONS(5212),
    [anon_sym_extern] = ACTIONS(5212),
    [anon_sym___attribute__] = ACTIONS(5212),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3782),
    [anon_sym___declspec] = ACTIONS(5212),
    [anon_sym___based] = ACTIONS(5212),
    [anon_sym___cdecl] = ACTIONS(5212),
    [anon_sym___clrcall] = ACTIONS(5212),
    [anon_sym___stdcall] = ACTIONS(5212),
    [anon_sym___fastcall] = ACTIONS(5212),
    [anon_sym___thiscall] = ACTIONS(5212),
    [anon_sym___vectorcall] = ACTIONS(5212),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(5212),
    [anon_sym_static] = ACTIONS(5212),
    [anon_sym_register] = ACTIONS(5212),
    [anon_sym_inline] = ACTIONS(5212),
    [anon_sym___inline] = ACTIONS(5212),
    [anon_sym___inline__] = ACTIONS(5212),
    [anon_sym___forceinline] = ACTIONS(5212),
    [anon_sym_thread_local] = ACTIONS(5212),
    [anon_sym___thread] = ACTIONS(5212),
    [anon_sym_const] = ACTIONS(5212),
    [anon_sym_constexpr] = ACTIONS(5212),
    [anon_sym_volatile] = ACTIONS(5212),
    [anon_sym_restrict] = ACTIONS(5212),
    [anon_sym___restrict__] = ACTIONS(5212),
    [anon_sym__Atomic] = ACTIONS(5212),
    [anon_sym__Noreturn] = ACTIONS(5212),
    [anon_sym_noreturn] = ACTIONS(5212),
    [anon_sym_mutable] = ACTIONS(5212),
    [anon_sym_constinit] = ACTIONS(5212),
    [anon_sym_consteval] = ACTIONS(5212),
    [anon_sym___shared__] = ACTIONS(5212),
    [anon_sym___local__] = ACTIONS(5212),
    [anon_sym___constant__] = ACTIONS(5212),
    [anon_sym___managed__] = ACTIONS(5212),
    [anon_sym___grid_constant__] = ACTIONS(5212),
    [anon_sym_alignas] = ACTIONS(5212),
    [anon_sym__Alignas] = ACTIONS(5212),
    [anon_sym_COLON] = ACTIONS(5212),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5212),
    [anon_sym_decltype] = ACTIONS(5212),
    [anon_sym_final] = ACTIONS(5212),
    [anon_sym_override] = ACTIONS(5212),
    [sym_virtual] = ACTIONS(5212),
    [anon_sym_template] = ACTIONS(5212),
    [anon_sym_operator] = ACTIONS(5212),
    [anon_sym___launch_bounds__] = ACTIONS(5212),
  },
  [2524] = {
    [sym_attribute_specifier] = STATE(2174),
    [sym_identifier] = ACTIONS(5629),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5627),
    [anon_sym_COMMA] = ACTIONS(5627),
    [anon_sym_RPAREN] = ACTIONS(5627),
    [anon_sym_LPAREN2] = ACTIONS(5627),
    [anon_sym_TILDE] = ACTIONS(5627),
    [anon_sym_STAR] = ACTIONS(5627),
    [anon_sym_AMP_AMP] = ACTIONS(5627),
    [anon_sym_AMP] = ACTIONS(5629),
    [anon_sym_SEMI] = ACTIONS(5627),
    [anon_sym___extension__] = ACTIONS(5629),
    [anon_sym___device__] = ACTIONS(5629),
    [anon_sym___host__] = ACTIONS(5629),
    [anon_sym___global__] = ACTIONS(5629),
    [anon_sym___forceinline__] = ACTIONS(5629),
    [anon_sym___noinline__] = ACTIONS(5629),
    [anon_sym_extern] = ACTIONS(5629),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5627),
    [anon_sym___declspec] = ACTIONS(5629),
    [anon_sym___based] = ACTIONS(5629),
    [anon_sym___cdecl] = ACTIONS(5629),
    [anon_sym___clrcall] = ACTIONS(5629),
    [anon_sym___stdcall] = ACTIONS(5629),
    [anon_sym___fastcall] = ACTIONS(5629),
    [anon_sym___thiscall] = ACTIONS(5629),
    [anon_sym___vectorcall] = ACTIONS(5629),
    [anon_sym_LBRACK] = ACTIONS(5629),
    [anon_sym_static] = ACTIONS(5629),
    [anon_sym_EQ] = ACTIONS(5627),
    [anon_sym_register] = ACTIONS(5629),
    [anon_sym_inline] = ACTIONS(5629),
    [anon_sym___inline] = ACTIONS(5629),
    [anon_sym___inline__] = ACTIONS(5629),
    [anon_sym___forceinline] = ACTIONS(5629),
    [anon_sym_thread_local] = ACTIONS(5629),
    [anon_sym___thread] = ACTIONS(5629),
    [anon_sym_const] = ACTIONS(5629),
    [anon_sym_constexpr] = ACTIONS(5629),
    [anon_sym_volatile] = ACTIONS(5629),
    [anon_sym_restrict] = ACTIONS(5629),
    [anon_sym___restrict__] = ACTIONS(5629),
    [anon_sym__Atomic] = ACTIONS(5629),
    [anon_sym__Noreturn] = ACTIONS(5629),
    [anon_sym_noreturn] = ACTIONS(5629),
    [anon_sym_mutable] = ACTIONS(5629),
    [anon_sym_constinit] = ACTIONS(5629),
    [anon_sym_consteval] = ACTIONS(5629),
    [anon_sym___shared__] = ACTIONS(5629),
    [anon_sym___local__] = ACTIONS(5629),
    [anon_sym___constant__] = ACTIONS(5629),
    [anon_sym___managed__] = ACTIONS(5629),
    [anon_sym___grid_constant__] = ACTIONS(5629),
    [anon_sym_alignas] = ACTIONS(5629),
    [anon_sym__Alignas] = ACTIONS(5629),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5629),
    [anon_sym_decltype] = ACTIONS(5629),
    [sym_virtual] = ACTIONS(5629),
    [anon_sym_template] = ACTIONS(5629),
    [anon_sym_GT2] = ACTIONS(5627),
    [anon_sym_operator] = ACTIONS(5629),
    [anon_sym___launch_bounds__] = ACTIONS(5629),
  },
  [2525] = {
    [sym_template_argument_list] = STATE(2297),
    [sym_identifier] = ACTIONS(4000),
    [anon_sym_LPAREN2] = ACTIONS(4007),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_STAR] = ACTIONS(4007),
    [anon_sym_AMP_AMP] = ACTIONS(4007),
    [anon_sym_AMP] = ACTIONS(4000),
    [anon_sym_LT] = ACTIONS(5534),
    [anon_sym_SEMI] = ACTIONS(4007),
    [anon_sym___extension__] = ACTIONS(4000),
    [anon_sym___device__] = ACTIONS(4000),
    [anon_sym___host__] = ACTIONS(4000),
    [anon_sym___global__] = ACTIONS(4000),
    [anon_sym___forceinline__] = ACTIONS(4000),
    [anon_sym___noinline__] = ACTIONS(4000),
    [anon_sym_extern] = ACTIONS(4000),
    [anon_sym___attribute__] = ACTIONS(4000),
    [anon_sym_COLON_COLON] = ACTIONS(3777),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4007),
    [anon_sym___declspec] = ACTIONS(4000),
    [anon_sym___based] = ACTIONS(4000),
    [anon_sym___cdecl] = ACTIONS(4000),
    [anon_sym___clrcall] = ACTIONS(4000),
    [anon_sym___stdcall] = ACTIONS(4000),
    [anon_sym___fastcall] = ACTIONS(4000),
    [anon_sym___thiscall] = ACTIONS(4000),
    [anon_sym___vectorcall] = ACTIONS(4000),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4000),
    [anon_sym_static] = ACTIONS(4000),
    [anon_sym_register] = ACTIONS(4000),
    [anon_sym_inline] = ACTIONS(4000),
    [anon_sym___inline] = ACTIONS(4000),
    [anon_sym___inline__] = ACTIONS(4000),
    [anon_sym___forceinline] = ACTIONS(4000),
    [anon_sym_thread_local] = ACTIONS(4000),
    [anon_sym___thread] = ACTIONS(4000),
    [anon_sym_const] = ACTIONS(4000),
    [anon_sym_constexpr] = ACTIONS(4000),
    [anon_sym_volatile] = ACTIONS(4000),
    [anon_sym_restrict] = ACTIONS(4000),
    [anon_sym___restrict__] = ACTIONS(4000),
    [anon_sym__Atomic] = ACTIONS(4000),
    [anon_sym__Noreturn] = ACTIONS(4000),
    [anon_sym_noreturn] = ACTIONS(4000),
    [anon_sym_mutable] = ACTIONS(4000),
    [anon_sym_constinit] = ACTIONS(4000),
    [anon_sym_consteval] = ACTIONS(4000),
    [anon_sym___shared__] = ACTIONS(4000),
    [anon_sym___local__] = ACTIONS(4000),
    [anon_sym___constant__] = ACTIONS(4000),
    [anon_sym___managed__] = ACTIONS(4000),
    [anon_sym___grid_constant__] = ACTIONS(4000),
    [anon_sym_alignas] = ACTIONS(4000),
    [anon_sym__Alignas] = ACTIONS(4000),
    [anon_sym_COLON] = ACTIONS(4000),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4000),
    [anon_sym_decltype] = ACTIONS(4000),
    [anon_sym_final] = ACTIONS(4000),
    [anon_sym_override] = ACTIONS(4000),
    [sym_virtual] = ACTIONS(4000),
    [anon_sym_template] = ACTIONS(4000),
    [anon_sym_operator] = ACTIONS(4000),
    [anon_sym___launch_bounds__] = ACTIONS(4000),
  },
  [2526] = {
    [sym_attribute_specifier] = STATE(2164),
    [sym_identifier] = ACTIONS(5727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5725),
    [anon_sym_COMMA] = ACTIONS(5725),
    [anon_sym_RPAREN] = ACTIONS(5725),
    [anon_sym_LPAREN2] = ACTIONS(5725),
    [anon_sym_TILDE] = ACTIONS(5725),
    [anon_sym_STAR] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5725),
    [anon_sym_AMP] = ACTIONS(5727),
    [anon_sym_SEMI] = ACTIONS(5725),
    [anon_sym___extension__] = ACTIONS(5727),
    [anon_sym___device__] = ACTIONS(5727),
    [anon_sym___host__] = ACTIONS(5727),
    [anon_sym___global__] = ACTIONS(5727),
    [anon_sym___forceinline__] = ACTIONS(5727),
    [anon_sym___noinline__] = ACTIONS(5727),
    [anon_sym_extern] = ACTIONS(5727),
    [anon_sym___attribute__] = ACTIONS(5002),
    [anon_sym_COLON_COLON] = ACTIONS(5725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5725),
    [anon_sym___declspec] = ACTIONS(5727),
    [anon_sym___based] = ACTIONS(5727),
    [anon_sym___cdecl] = ACTIONS(5727),
    [anon_sym___clrcall] = ACTIONS(5727),
    [anon_sym___stdcall] = ACTIONS(5727),
    [anon_sym___fastcall] = ACTIONS(5727),
    [anon_sym___thiscall] = ACTIONS(5727),
    [anon_sym___vectorcall] = ACTIONS(5727),
    [anon_sym_LBRACK] = ACTIONS(5727),
    [anon_sym_static] = ACTIONS(5727),
    [anon_sym_EQ] = ACTIONS(5725),
    [anon_sym_register] = ACTIONS(5727),
    [anon_sym_inline] = ACTIONS(5727),
    [anon_sym___inline] = ACTIONS(5727),
    [anon_sym___inline__] = ACTIONS(5727),
    [anon_sym___forceinline] = ACTIONS(5727),
    [anon_sym_thread_local] = ACTIONS(5727),
    [anon_sym___thread] = ACTIONS(5727),
    [anon_sym_const] = ACTIONS(5727),
    [anon_sym_constexpr] = ACTIONS(5727),
    [anon_sym_volatile] = ACTIONS(5727),
    [anon_sym_restrict] = ACTIONS(5727),
    [anon_sym___restrict__] = ACTIONS(5727),
    [anon_sym__Atomic] = ACTIONS(5727),
    [anon_sym__Noreturn] = ACTIONS(5727),
    [anon_sym_noreturn] = ACTIONS(5727),
    [anon_sym_mutable] = ACTIONS(5727),
    [anon_sym_constinit] = ACTIONS(5727),
    [anon_sym_consteval] = ACTIONS(5727),
    [anon_sym___shared__] = ACTIONS(5727),
    [anon_sym___local__] = ACTIONS(5727),
    [anon_sym___constant__] = ACTIONS(5727),
    [anon_sym___managed__] = ACTIONS(5727),
    [anon_sym___grid_constant__] = ACTIONS(5727),
    [anon_sym_alignas] = ACTIONS(5727),
    [anon_sym__Alignas] = ACTIONS(5727),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5727),
    [anon_sym_decltype] = ACTIONS(5727),
    [sym_virtual] = ACTIONS(5727),
    [anon_sym_template] = ACTIONS(5727),
    [anon_sym_GT2] = ACTIONS(5725),
    [anon_sym_operator] = ACTIONS(5727),
    [anon_sym___launch_bounds__] = ACTIONS(5727),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5230), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5232), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [71] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5462), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5464), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6139), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6141), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5458), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5460), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5472), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5458), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5460), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6143), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6145), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5502), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [568] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5502), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6147), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6149), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6153), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6151), 51,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6155), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6157), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6161), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6147), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6149), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5502), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [1065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6165), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [1136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6167), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6169), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [1207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5735), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5733), 51,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [1278] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6171), 1,
      anon_sym_typedef,
    ACTIONS(2588), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2586), 56,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [1351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6147), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6149), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [1422] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6173), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6175), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [1493] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(6177), 1,
      anon_sym___attribute__,
    ACTIONS(6179), 1,
      anon_sym_LBRACE,
    STATE(2991), 1,
      sym_field_declaration_list,
    STATE(3157), 1,
      sym_attribute_specifier,
    STATE(7139), 1,
      sym_virtual_specifier,
    STATE(7889), 1,
      sym_base_class_clause,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5508), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5506), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [1580] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6181), 1,
      anon_sym_typedef,
    ACTIONS(2588), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2586), 56,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [1653] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5187), 1,
      anon_sym_LBRACE,
    ACTIONS(5194), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
    ACTIONS(5192), 51,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [1728] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2584), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5016), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(6183), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5258), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(5261), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [1805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5472), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [1876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5462), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5464), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [1947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5311), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5313), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [2018] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5297), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5299), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [2089] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6186), 1,
      anon_sym_typedef,
    ACTIONS(2588), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2586), 56,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [2162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5192), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5194), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [2233] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6188), 1,
      anon_sym_namespace,
    ACTIONS(5735), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5733), 56,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [2306] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5921), 1,
      anon_sym_LBRACE,
    ACTIONS(6190), 1,
      anon_sym_COLON,
    STATE(2175), 1,
      sym_attribute_specifier,
    STATE(2358), 1,
      sym__enum_base_clause,
    STATE(2478), 1,
      sym_enumerator_list,
    ACTIONS(6044), 7,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6042), 50,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [2389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5293), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5295), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [2460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5289), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5291), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [2531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5281), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5283), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [2602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5226), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5228), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [2673] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6192), 1,
      anon_sym_LT,
    STATE(2245), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2297), 1,
      sym_template_argument_list,
    ACTIONS(3784), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3764), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(3756), 45,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [2754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5222), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5224), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [2825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5285), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5287), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [2896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5462), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5464), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [2967] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6194), 1,
      anon_sym_namespace,
    ACTIONS(5735), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5733), 56,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [3040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5336), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5338), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [3111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5354), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5356), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [3182] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6196), 1,
      anon_sym_namespace,
    ACTIONS(5735), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5733), 56,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [3255] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LT,
    STATE(2502), 1,
      sym_template_argument_list,
    ACTIONS(6198), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6200), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [3330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5277), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5279), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [3401] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6205), 1,
      anon_sym_namespace,
    ACTIONS(5735), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5733), 56,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [3474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5370), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5372), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [3545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5336), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5338), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [3616] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5921), 1,
      anon_sym_LBRACE,
    ACTIONS(6190), 1,
      anon_sym_COLON,
    STATE(2184), 1,
      sym_attribute_specifier,
    STATE(2363), 1,
      sym__enum_base_clause,
    STATE(2517), 1,
      sym_enumerator_list,
    ACTIONS(6050), 7,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6048), 50,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [3699] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6207), 1,
      anon_sym_typedef,
    ACTIONS(2588), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2586), 56,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [3772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5382), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5384), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [3843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5378), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5380), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [3914] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    STATE(1651), 1,
      sym_template_argument_list,
    STATE(2756), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6209), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5530), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5532), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [3993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3648), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3650), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [4064] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6211), 1,
      anon_sym_typedef,
    ACTIONS(2588), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2586), 56,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [4137] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2584), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6183), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5018), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(5016), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_primitive_type,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [4212] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5187), 1,
      anon_sym_LBRACE,
    ACTIONS(5194), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
    ACTIONS(5192), 51,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [4285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5366), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5368), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [4356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5362), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5364), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [4427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5458), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5460), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [4498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5145), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5147), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [4569] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6213), 1,
      sym_identifier,
    ACTIONS(6217), 1,
      sym_primitive_type,
    STATE(2551), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6215), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5325), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(5327), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [4648] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    ACTIONS(6219), 1,
      anon_sym_LPAREN2,
    STATE(2219), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3673), 1,
      sym_argument_list,
    STATE(4160), 1,
      sym_initializer_list,
    ACTIONS(5617), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5194), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
    ACTIONS(5192), 45,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [4731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3652), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3654), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [4802] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6226), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6222), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6224), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [4875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5248), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [4946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5248), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [5017] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6228), 1,
      anon_sym_typedef,
    ACTIONS(2588), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2586), 56,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [5090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5254), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5256), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [5161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5301), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5303), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [5232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5192), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5194), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [5303] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6230), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6232), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [5374] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5250), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5252), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [5445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5248), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [5516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5352), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [5587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5194), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5192), 51,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [5658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5340), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5342), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [5729] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6234), 1,
      anon_sym_typedef,
    ACTIONS(2588), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2586), 56,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [5802] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5502), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [5873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6238), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6236), 51,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [5944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5462), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5464), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [6015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5472), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [6086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2588), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2586), 51,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [6157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5458), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5460), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [6228] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5319), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5321), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [6299] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5315), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5317), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [6370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5214), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5216), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [6441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5238), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5240), 50,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [6512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5472), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [6583] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6247), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6243), 4,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6245), 5,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_explicit,
      anon_sym_operator,
    ACTIONS(6250), 11,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_auto,
      anon_sym_typename,
    ACTIONS(6240), 40,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_template,
      anon_sym___launch_bounds__,
  [6659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6252), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6254), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [6729] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2694), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6256), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5374), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym___forceinline,
      anon_sym_const,
    ACTIONS(5376), 52,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym___launch_bounds__,
  [6803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5502), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [6873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5462), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5464), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [6943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6258), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6260), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [7013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5472), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [7083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6264), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [7153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3650), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3648), 56,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [7223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6266), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6268), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [7293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3766), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3758), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [7363] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2629), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6270), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5018), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(5016), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_primitive_type,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [7437] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(6273), 1,
      anon_sym___attribute__,
    ACTIONS(6275), 1,
      anon_sym_LBRACE,
    STATE(3033), 1,
      sym_field_declaration_list,
    STATE(3291), 1,
      sym_attribute_specifier,
    STATE(7244), 1,
      sym_virtual_specifier,
    STATE(7989), 1,
      sym_base_class_clause,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5508), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5506), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [7523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6153), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6151), 56,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [7593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3766), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3758), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [7663] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2711), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5016), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(6277), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5261), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5258), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [7739] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1867), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6280), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5424), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym___forceinline,
      anon_sym_const,
    ACTIONS(5422), 52,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym___launch_bounds__,
  [7813] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1867), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6280), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5418), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym___forceinline,
      anon_sym_const,
    ACTIONS(5416), 52,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym___launch_bounds__,
  [7887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3766), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3758), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [7957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6282), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6284), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [8027] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2694), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6256), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5192), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym___forceinline,
      anon_sym_const,
    ACTIONS(5194), 52,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym___launch_bounds__,
  [8101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6286), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6288), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [8171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1901), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(1899), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [8241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6290), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6292), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [8311] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6294), 1,
      sym_identifier,
    ACTIONS(6298), 1,
      sym_primitive_type,
    STATE(2696), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6296), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5325), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(5327), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_auto,
      anon_sym_decltype,
  [8389] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3957), 1,
      anon_sym_LPAREN2,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5494), 1,
      anon_sym_LBRACK,
    ACTIONS(5591), 1,
      anon_sym_STAR,
    ACTIONS(5593), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5595), 1,
      anon_sym_AMP,
    STATE(3079), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6644), 1,
      sym__declarator,
    STATE(6952), 1,
      sym__abstract_declarator,
    STATE(8387), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6100), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [8507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6222), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6224), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [8577] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    STATE(2203), 1,
      sym_attribute_specifier,
    STATE(2895), 1,
      sym_field_declaration_list,
    STATE(7349), 1,
      sym_virtual_specifier,
    STATE(8102), 1,
      sym_base_class_clause,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5508), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym___forceinline,
      anon_sym_const,
    ACTIONS(5506), 48,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym___launch_bounds__,
  [8663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1897), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(1895), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [8733] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4967), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4969), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [8803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6302), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6304), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [8873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3800), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3796), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [8943] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6306), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6308), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6310), 1,
      anon_sym_or,
    ACTIONS(6312), 1,
      anon_sym_and,
    ACTIONS(5390), 25,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5392), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [9021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6314), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6316), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [9091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6318), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6320), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [9161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6324), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [9231] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    STATE(1651), 1,
      sym_template_argument_list,
    STATE(2805), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6326), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5530), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5532), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [9309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3654), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3652), 56,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [9379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5458), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5460), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [9449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5502), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [9519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6328), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6330), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [9589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6332), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6334), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [9659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6336), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6338), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [9729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4921), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4923), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [9799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4953), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4955), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [9869] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6308), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6312), 1,
      anon_sym_and,
    ACTIONS(5402), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5404), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [9943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4913), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4915), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [10013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6340), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6342), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [10083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4925), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4927), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [10153] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 1,
      sym_literal_suffix,
    STATE(2519), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(3976), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3978), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5710), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5712), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [10231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4002), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [10301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6344), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6346), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [10371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4002), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [10441] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_LBRACE,
    ACTIONS(6348), 1,
      anon_sym___attribute__,
    ACTIONS(6350), 1,
      anon_sym_COLON,
    STATE(2286), 1,
      sym__enum_base_clause,
    STATE(2317), 1,
      sym_enumerator_list,
    STATE(2391), 1,
      sym_attribute_specifier,
    ACTIONS(6048), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6050), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
  [10523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4002), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [10593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4002), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [10663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4002), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [10733] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2634), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6352), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5448), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym___forceinline,
      anon_sym_const,
    ACTIONS(5446), 52,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym___launch_bounds__,
  [10807] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2635), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6354), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5442), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym___forceinline,
      anon_sym_const,
    ACTIONS(5440), 52,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym___launch_bounds__,
  [10881] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 1,
      sym_literal_suffix,
    STATE(2519), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(3976), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3978), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3766), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3758), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [10959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4002), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [11029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5458), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5460), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [11099] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    STATE(1651), 1,
      sym_template_argument_list,
    STATE(2812), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6356), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5530), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5532), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [11177] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6192), 1,
      anon_sym_LT,
    STATE(2297), 1,
      sym_template_argument_list,
    ACTIONS(4007), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4000), 48,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [11253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4947), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [11323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4947), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [11393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4947), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [11463] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3957), 1,
      anon_sym_LPAREN2,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5494), 1,
      anon_sym_LBRACK,
    ACTIONS(5619), 1,
      anon_sym_STAR,
    ACTIONS(5621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5623), 1,
      anon_sym_AMP,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6644), 1,
      sym__declarator,
    STATE(6955), 1,
      sym__abstract_declarator,
    STATE(8387), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6100), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [11581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6360), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [11651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4933), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4935), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [11721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4937), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4939), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [11791] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1867), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6280), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5434), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym___forceinline,
      anon_sym_const,
    ACTIONS(5432), 52,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym___launch_bounds__,
  [11865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6364), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [11935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6366), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6368), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [12005] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(6370), 1,
      anon_sym___attribute__,
    ACTIONS(6372), 1,
      anon_sym_LBRACE,
    STATE(3043), 1,
      sym_field_declaration_list,
    STATE(3402), 1,
      sym_attribute_specifier,
    STATE(7357), 1,
      sym_virtual_specifier,
    STATE(8145), 1,
      sym_base_class_clause,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5508), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5506), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [12091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5014), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(1962), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [12161] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1867), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6280), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5438), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym___forceinline,
      anon_sym_const,
    ACTIONS(5436), 52,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym___launch_bounds__,
  [12235] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3957), 1,
      anon_sym_LPAREN2,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5494), 1,
      anon_sym_LBRACK,
    ACTIONS(5619), 1,
      anon_sym_STAR,
    ACTIONS(5621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5623), 1,
      anon_sym_AMP,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6666), 1,
      sym__declarator,
    STATE(6960), 1,
      sym__abstract_declarator,
    STATE(8387), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5504), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [12353] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2629), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5016), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(6270), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5258), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(5261), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_auto,
      anon_sym_decltype,
  [12429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6238), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6236), 56,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [12499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6376), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [12569] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6192), 1,
      anon_sym_LT,
    ACTIONS(6380), 1,
      anon_sym_EQ,
    STATE(2245), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2297), 1,
      sym_template_argument_list,
    ACTIONS(6378), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(3784), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3764), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3756), 45,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [12653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4949), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4951), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [12723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6382), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6384), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [12793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6386), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6388), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [12863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6390), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6392), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [12933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6394), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6396), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [13003] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6192), 1,
      anon_sym_LT,
    STATE(2297), 1,
      sym_template_argument_list,
    ACTIONS(3782), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5212), 48,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [13079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6398), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6400), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [13149] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6402), 1,
      anon_sym_LT,
    STATE(2756), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2821), 1,
      sym_template_argument_list,
    ACTIONS(6209), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3756), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3764), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [13229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6404), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6406), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [13299] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6410), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [13369] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6412), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6414), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [13439] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2711), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6277), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5018), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
    ACTIONS(5016), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_primitive_type,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [13513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6416), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6418), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [13583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4929), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4931), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [13653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5735), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5733), 56,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [13723] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6420), 1,
      sym_identifier,
    ACTIONS(6424), 1,
      sym_primitive_type,
    STATE(2633), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6422), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5327), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5325), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [13801] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6439), 1,
      anon_sym___attribute__,
    ACTIONS(6442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6445), 1,
      anon_sym___declspec,
    ACTIONS(6451), 1,
      anon_sym_explicit,
    ACTIONS(6454), 1,
      anon_sym___launch_bounds__,
    STATE(2611), 1,
      sym_alignas_qualifier,
    ACTIONS(6448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6428), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    ACTIONS(6433), 6,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      sym_virtual,
    ACTIONS(6426), 7,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(6436), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(2716), 10,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_explicit_function_specifier,
      sym__constructor_specifiers,
      sym_launch_bounds,
      aux_sym_operator_cast_definition_repeat1,
    ACTIONS(6430), 17,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [13893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6457), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6459), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [13963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6461), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6463), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [14033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6465), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6467), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [14103] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5554), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6478), 1,
      anon_sym___attribute__,
    ACTIONS(6481), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6484), 1,
      anon_sym___declspec,
    ACTIONS(6490), 1,
      anon_sym___launch_bounds__,
    STATE(1830), 1,
      sym_alignas_qualifier,
    ACTIONS(6487), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6472), 6,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      sym_virtual,
    STATE(2720), 8,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_launch_bounds,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6475), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(5552), 14,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
    ACTIONS(6469), 17,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [14193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5751), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5749), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [14263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6493), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6495), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [14333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6497), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6499), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [14403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5829), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5827), 56,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [14473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6501), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6503), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [14543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6507), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [14613] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5772), 1,
      anon_sym_LBRACE,
    ACTIONS(6348), 1,
      anon_sym___attribute__,
    ACTIONS(6350), 1,
      anon_sym_COLON,
    STATE(2292), 1,
      sym__enum_base_clause,
    STATE(2372), 1,
      sym_enumerator_list,
    STATE(2411), 1,
      sym_attribute_specifier,
    ACTIONS(6042), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6044), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
  [14695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6509), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6511), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [14765] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5472), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [14835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6513), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6515), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [14905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6517), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6519), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [14975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5462), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5464), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [15045] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5993), 1,
      anon_sym_LBRACK,
    ACTIONS(6192), 1,
      anon_sym_LT,
    STATE(2245), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3061), 1,
      sym_template_argument_list,
    ACTIONS(3779), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3784), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3764), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_EQ,
    ACTIONS(3756), 44,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [15129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6521), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6523), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [15199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6525), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6527), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [15269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6531), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [15339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6533), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6535), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [15409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6507), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [15479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4941), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4943), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [15549] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3957), 1,
      anon_sym_LPAREN2,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5494), 1,
      anon_sym_LBRACK,
    ACTIONS(5591), 1,
      anon_sym_STAR,
    ACTIONS(5593), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5595), 1,
      anon_sym_AMP,
    STATE(3079), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6666), 1,
      sym__declarator,
    STATE(6951), 1,
      sym__abstract_declarator,
    STATE(8387), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5504), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [15667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6537), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6539), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [15737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6541), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6543), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [15807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4917), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4919), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [15877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4909), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4911), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [15947] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6402), 1,
      anon_sym_LT,
    STATE(2821), 1,
      sym_template_argument_list,
    ACTIONS(5212), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3782), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [16022] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6545), 1,
      anon_sym_LT,
    STATE(2812), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2841), 1,
      sym_template_argument_list,
    ACTIONS(6356), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3756), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3764), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [16101] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4142), 1,
      anon_sym_const,
    ACTIONS(4153), 1,
      anon_sym_AMP,
    ACTIONS(4146), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_GT2,
    ACTIONS(4151), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4144), 18,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(4149), 23,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
  [16178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5502), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [16247] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6547), 1,
      sym_identifier,
    STATE(2749), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(6550), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6553), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5269), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5267), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [16324] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3957), 1,
      anon_sym_LPAREN2,
    ACTIONS(3959), 1,
      anon_sym_STAR,
    ACTIONS(3961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3963), 1,
      anon_sym_AMP,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(5494), 1,
      anon_sym_LBRACK,
    ACTIONS(5631), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6100), 1,
      anon_sym_RPAREN,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6094), 1,
      sym__scope_resolution,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6764), 1,
      sym__declarator,
    STATE(6955), 1,
      sym__abstract_declarator,
    STATE(8796), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [16441] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2770), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6556), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5448), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5446), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [16514] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6558), 1,
      sym_identifier,
    STATE(2758), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(3594), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3598), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5348), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5346), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [16591] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6192), 1,
      anon_sym_LT,
    ACTIONS(6380), 1,
      anon_sym_EQ,
    STATE(2297), 1,
      sym_template_argument_list,
    ACTIONS(6378), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(3782), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(5212), 48,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [16670] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2762), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6560), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5442), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5440), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [16743] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6562), 1,
      anon_sym_LT,
    STATE(2805), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2869), 1,
      sym_template_argument_list,
    ACTIONS(6326), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3756), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3764), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [16822] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2584), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6564), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5434), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5432), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [16895] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5921), 1,
      anon_sym_LBRACE,
    ACTIONS(6566), 1,
      anon_sym_COLON,
    STATE(2175), 1,
      sym_attribute_specifier,
    STATE(2358), 1,
      sym__enum_base_clause,
    STATE(2478), 1,
      sym_enumerator_list,
    ACTIONS(6044), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6042), 44,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [16976] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 1,
      sym_identifier,
    STATE(2749), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(3594), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3598), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5309), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5307), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [17053] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    STATE(1651), 1,
      sym_template_argument_list,
    ACTIONS(5212), 6,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym___forceinline,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(3782), 52,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_try,
      anon_sym_requires,
      anon_sym___launch_bounds__,
  [17128] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6570), 1,
      anon_sym_LT,
    STATE(2821), 1,
      sym_template_argument_list,
    ACTIONS(4000), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4007), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [17203] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3957), 1,
      anon_sym_LPAREN2,
    ACTIONS(3959), 1,
      anon_sym_STAR,
    ACTIONS(3961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3963), 1,
      anon_sym_AMP,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(5494), 1,
      anon_sym_LBRACK,
    ACTIONS(5504), 1,
      anon_sym_RPAREN,
    ACTIONS(5631), 1,
      anon_sym_COLON_COLON,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6094), 1,
      sym__scope_resolution,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6714), 1,
      sym__declarator,
    STATE(6960), 1,
      sym__abstract_declarator,
    STATE(8796), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [17320] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2584), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6564), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5418), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5416), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [17393] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2584), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6564), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5438), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5436), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [17466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5458), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5460), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [17535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5472), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [17604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5462), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5464), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [17673] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    STATE(1651), 1,
      sym_template_argument_list,
    ACTIONS(4000), 6,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym___forceinline,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4007), 52,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_try,
      anon_sym_requires,
      anon_sym___launch_bounds__,
  [17748] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2763), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6573), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5374), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5376), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [17821] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5921), 1,
      anon_sym_LBRACE,
    ACTIONS(6566), 1,
      anon_sym_COLON,
    STATE(2184), 1,
      sym_attribute_specifier,
    STATE(2363), 1,
      sym__enum_base_clause,
    STATE(2517), 1,
      sym_enumerator_list,
    ACTIONS(6050), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6048), 44,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [17902] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2584), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6564), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5424), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5422), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [17975] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6575), 1,
      sym_identifier,
    ACTIONS(6579), 1,
      sym_primitive_type,
    STATE(2809), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6577), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5327), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5325), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [18051] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4011), 1,
      anon_sym_LBRACK,
    ACTIONS(5534), 1,
      anon_sym_LT,
    STATE(2938), 1,
      sym_template_argument_list,
    ACTIONS(4004), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4007), 4,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
    ACTIONS(4000), 50,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [18129] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2829), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6581), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5374), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5376), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [18201] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_AMP,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6454), 1,
      sym__declarator,
    STATE(8511), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2801), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3700), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [18315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5502), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [18383] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2120), 1,
      anon_sym_STAR,
    ACTIONS(2122), 1,
      anon_sym_AMP,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(5631), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6094), 1,
      sym__scope_resolution,
    STATE(6714), 1,
      sym__declarator,
    STATE(8796), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2830), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3640), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [18497] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6591), 1,
      anon_sym_STAR,
    ACTIONS(6593), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6595), 1,
      anon_sym_AMP,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6666), 1,
      sym__declarator,
    STATE(8387), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3752), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4023), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [18611] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6591), 1,
      anon_sym_STAR,
    ACTIONS(6593), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6595), 1,
      anon_sym_AMP,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6644), 1,
      sym__declarator,
    STATE(8387), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3786), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4023), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [18725] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    STATE(1651), 1,
      sym_template_argument_list,
    STATE(2908), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6597), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5530), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5532), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [18801] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2825), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6599), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5448), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5446), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [18873] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(6601), 1,
      anon_sym___attribute__,
    ACTIONS(6603), 1,
      anon_sym_LBRACE,
    STATE(3369), 1,
      sym_field_declaration_list,
    STATE(3625), 1,
      sym_attribute_specifier,
    STATE(7352), 1,
      sym_virtual_specifier,
    STATE(8008), 1,
      sym_base_class_clause,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5508), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5506), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [18957] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2824), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6605), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5442), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5440), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [19029] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2120), 1,
      anon_sym_STAR,
    ACTIONS(2122), 1,
      anon_sym_AMP,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(5631), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6094), 1,
      sym__scope_resolution,
    STATE(6714), 1,
      sym__declarator,
    STATE(8796), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3640), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4023), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [19143] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6714), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2799), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3840), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [19257] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2787), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6617), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5374), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5376), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [19329] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6627), 1,
      anon_sym_LBRACK,
    ACTIONS(6633), 1,
      anon_sym_DASH_GT,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6642), 1,
      anon_sym_requires,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(5326), 1,
      sym__function_attributes_start,
    STATE(5382), 1,
      sym_ref_qualifier,
    STATE(6136), 1,
      sym__function_attributes_end,
    STATE(6244), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6635), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4165), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4389), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6474), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5636), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6619), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [19447] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2629), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6645), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5438), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5436), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [19519] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2629), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6645), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5424), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5422), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [19591] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 1,
      anon_sym___attribute__,
    ACTIONS(6647), 1,
      anon_sym_LBRACE,
    ACTIONS(6649), 1,
      anon_sym_COLON,
    STATE(2935), 1,
      sym__enum_base_clause,
    STATE(2975), 1,
      sym_enumerator_list,
    STATE(3208), 1,
      sym_attribute_specifier,
    ACTIONS(6048), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6050), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [19671] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2629), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6645), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5418), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5416), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [19743] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6651), 1,
      anon_sym_STAR,
    ACTIONS(6653), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6655), 1,
      anon_sym_AMP,
    ACTIONS(6657), 1,
      anon_sym_COLON_COLON,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6064), 1,
      sym__scope_resolution,
    STATE(6484), 1,
      sym__declarator,
    STATE(8311), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3726), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4023), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [19857] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6545), 1,
      anon_sym_LT,
    STATE(2841), 1,
      sym_template_argument_list,
    ACTIONS(5212), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3782), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [19931] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2788), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6659), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5448), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5446), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [20003] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5185), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5187), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [20073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5460), 3,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(5458), 57,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_typename,
      anon_sym_template,
      anon_sym___launch_bounds__,
  [20141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 3,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(5500), 57,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_typename,
      anon_sym_template,
      anon_sym___launch_bounds__,
  [20209] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    STATE(1651), 1,
      sym_template_argument_list,
    STATE(2689), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5952), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3756), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym___forceinline,
      anon_sym_const,
    ACTIONS(3764), 47,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_try,
      anon_sym_requires,
      anon_sym___launch_bounds__,
  [20287] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6591), 1,
      anon_sym_STAR,
    ACTIONS(6593), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6595), 1,
      anon_sym_AMP,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6643), 1,
      sym__declarator,
    STATE(8387), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2777), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3651), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [20401] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6764), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3637), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4023), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [20515] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6714), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3840), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4023), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [20629] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_AMP,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6472), 1,
      sym__declarator,
    STATE(8511), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3636), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4023), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [20743] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5179), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5181), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [20813] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_AMP,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6451), 1,
      sym__declarator,
    STATE(8511), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2818), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3739), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [20927] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6591), 1,
      anon_sym_STAR,
    ACTIONS(6593), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6595), 1,
      anon_sym_AMP,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6666), 1,
      sym__declarator,
    STATE(8387), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2778), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3752), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [21041] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2711), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6661), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5434), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5432), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [21113] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5179), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5181), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [21183] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6651), 1,
      anon_sym_STAR,
    ACTIONS(6653), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6655), 1,
      anon_sym_AMP,
    ACTIONS(6657), 1,
      anon_sym_COLON_COLON,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6064), 1,
      sym__scope_resolution,
    STATE(6477), 1,
      sym__declarator,
    STATE(8311), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2810), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3838), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [21297] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6663), 1,
      anon_sym_STAR,
    ACTIONS(6665), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6667), 1,
      anon_sym_AMP,
    ACTIONS(6669), 1,
      anon_sym_COLON_COLON,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6119), 1,
      sym__scope_resolution,
    STATE(6889), 1,
      sym__declarator,
    STATE(8440), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3609), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4023), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [21411] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2823), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5016), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(6671), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5261), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5258), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [21485] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6651), 1,
      anon_sym_STAR,
    ACTIONS(6653), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6655), 1,
      anon_sym_AMP,
    ACTIONS(6657), 1,
      anon_sym_COLON_COLON,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6064), 1,
      sym__scope_resolution,
    STATE(6467), 1,
      sym__declarator,
    STATE(8311), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3711), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4023), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [21599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5196), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5198), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [21667] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2629), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6645), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5434), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5432), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [21739] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4142), 1,
      anon_sym_const,
    ACTIONS(4153), 1,
      anon_sym_AMP,
    ACTIONS(4146), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
    ACTIONS(4151), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_DOT,
    ACTIONS(4144), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(4149), 23,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
  [21815] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6744), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2800), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3697), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [21929] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6651), 1,
      anon_sym_STAR,
    ACTIONS(6653), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6655), 1,
      anon_sym_AMP,
    ACTIONS(6657), 1,
      anon_sym_COLON_COLON,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6064), 1,
      sym__scope_resolution,
    STATE(6467), 1,
      sym__declarator,
    STATE(8311), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2791), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3711), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [22043] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6663), 1,
      anon_sym_STAR,
    ACTIONS(6665), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6667), 1,
      anon_sym_AMP,
    ACTIONS(6669), 1,
      anon_sym_COLON_COLON,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6119), 1,
      sym__scope_resolution,
    STATE(6889), 1,
      sym__declarator,
    STATE(8440), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2822), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3609), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [22157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5458), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5460), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [22225] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_AMP,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6454), 1,
      sym__declarator,
    STATE(8511), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3700), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4023), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [22339] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6627), 1,
      anon_sym_LBRACK,
    ACTIONS(6633), 1,
      anon_sym_DASH_GT,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6676), 1,
      anon_sym_requires,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(5333), 1,
      sym__function_attributes_start,
    STATE(5381), 1,
      sym_ref_qualifier,
    STATE(6138), 1,
      sym__function_attributes_end,
    STATE(6254), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4165), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4389), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6474), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5632), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6619), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [22457] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6562), 1,
      anon_sym_LT,
    STATE(2869), 1,
      sym_template_argument_list,
    ACTIONS(5212), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3782), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [22531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4142), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4149), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [22599] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6663), 1,
      anon_sym_STAR,
    ACTIONS(6665), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6667), 1,
      anon_sym_AMP,
    ACTIONS(6669), 1,
      anon_sym_COLON_COLON,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6119), 1,
      sym__scope_resolution,
    STATE(6891), 1,
      sym__declarator,
    STATE(8440), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3618), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4023), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [22713] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2823), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6671), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5016), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      sym_primitive_type,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5018), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [22785] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2711), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6661), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5418), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5416), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [22857] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2711), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6661), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5424), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5422), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [22929] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6678), 1,
      anon_sym_LT,
    STATE(2841), 1,
      sym_template_argument_list,
    ACTIONS(4000), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4007), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [23003] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6663), 1,
      anon_sym_STAR,
    ACTIONS(6665), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6667), 1,
      anon_sym_AMP,
    ACTIONS(6669), 1,
      anon_sym_COLON_COLON,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6119), 1,
      sym__scope_resolution,
    STATE(6875), 1,
      sym__declarator,
    STATE(8440), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2808), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3653), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [23117] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6681), 1,
      anon_sym_LT,
    STATE(2869), 1,
      sym_template_argument_list,
    ACTIONS(4000), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4007), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [23191] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2711), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6661), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5438), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5436), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [23263] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2120), 1,
      anon_sym_STAR,
    ACTIONS(2122), 1,
      anon_sym_AMP,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(5631), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6094), 1,
      sym__scope_resolution,
    STATE(6764), 1,
      sym__declarator,
    STATE(8796), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3732), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4023), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [23377] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2120), 1,
      anon_sym_STAR,
    ACTIONS(2122), 1,
      anon_sym_AMP,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(5631), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6094), 1,
      sym__scope_resolution,
    STATE(6744), 1,
      sym__declarator,
    STATE(8796), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2783), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3611), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [23491] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 1,
      anon_sym___attribute__,
    ACTIONS(6647), 1,
      anon_sym_LBRACE,
    ACTIONS(6649), 1,
      anon_sym_COLON,
    STATE(2903), 1,
      sym__enum_base_clause,
    STATE(2979), 1,
      sym_enumerator_list,
    STATE(3154), 1,
      sym_attribute_specifier,
    ACTIONS(6042), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6044), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [23571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5462), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5464), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [23639] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2763), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6573), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5192), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5194), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [23711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5472), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [23779] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2790), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6684), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5442), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5440), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [23851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3988), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3990), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [23918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3996), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3998), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [23985] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6627), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6688), 1,
      anon_sym___attribute__,
    ACTIONS(6691), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(6698), 1,
      anon_sym_DASH_GT,
    ACTIONS(6703), 1,
      anon_sym_requires,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(5358), 1,
      sym__function_attributes_start,
    STATE(5386), 1,
      sym_ref_qualifier,
    STATE(6092), 1,
      sym__function_attributes_end,
    STATE(6105), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6700), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4312), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4485), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6177), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5651), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6619), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [24102] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6273), 1,
      anon_sym___attribute__,
    ACTIONS(6706), 1,
      anon_sym_LBRACE,
    ACTIONS(6708), 1,
      anon_sym_COLON,
    STATE(2971), 1,
      sym__enum_base_clause,
    STATE(3069), 1,
      sym_enumerator_list,
    STATE(3259), 1,
      sym_attribute_specifier,
    ACTIONS(6048), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6050), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [24181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4142), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4149), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [24248] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4810), 1,
      anon_sym_SEMI,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(5993), 1,
      anon_sym_LBRACK,
    STATE(2245), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3061), 1,
      sym_template_argument_list,
    ACTIONS(3779), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3764), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(3784), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3756), 44,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [24331] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6273), 1,
      anon_sym___attribute__,
    ACTIONS(6706), 1,
      anon_sym_LBRACE,
    ACTIONS(6708), 1,
      anon_sym_COLON,
    STATE(2953), 1,
      sym__enum_base_clause,
    STATE(3070), 1,
      sym_enumerator_list,
    STATE(3295), 1,
      sym_attribute_specifier,
    ACTIONS(6042), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6044), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [24410] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5185), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5187), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [24479] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5921), 1,
      anon_sym_LBRACE,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    STATE(2170), 1,
      sym_attribute_specifier,
    STATE(2936), 1,
      sym_enumerator_list,
    ACTIONS(5599), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym___forceinline,
      anon_sym_const,
    ACTIONS(5597), 50,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym___launch_bounds__,
  [24554] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2791), 1,
      anon_sym_LBRACE,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6712), 1,
      anon_sym_LBRACK,
    ACTIONS(6714), 1,
      sym_auto,
    ACTIONS(6716), 1,
      anon_sym_decltype,
    STATE(3127), 1,
      sym_decltype_auto,
    STATE(3149), 1,
      sym_new_declarator,
    STATE(3728), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5640), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5642), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [24637] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2791), 1,
      anon_sym_LBRACE,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6712), 1,
      anon_sym_LBRACK,
    ACTIONS(6714), 1,
      sym_auto,
    ACTIONS(6716), 1,
      anon_sym_decltype,
    STATE(3107), 1,
      sym_new_declarator,
    STATE(3127), 1,
      sym_decltype_auto,
    STATE(3806), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5690), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5692), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [24720] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5185), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5187), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [24789] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6627), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6688), 1,
      anon_sym___attribute__,
    ACTIONS(6691), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(6698), 1,
      anon_sym_DASH_GT,
    ACTIONS(6718), 1,
      anon_sym_requires,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(5351), 1,
      sym__function_attributes_start,
    STATE(5412), 1,
      sym_ref_qualifier,
    STATE(6038), 1,
      sym__function_attributes_end,
    STATE(6041), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4312), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4485), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6177), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5640), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6619), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [24906] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2787), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6617), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5192), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5194), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [24977] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6728), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6730), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6742), 1,
      anon_sym_GT_EQ,
    ACTIONS(6746), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6748), 1,
      anon_sym_or,
    ACTIONS(6750), 1,
      anon_sym_and,
    ACTIONS(6752), 1,
      anon_sym_not_eq,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6724), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6732), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6734), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6736), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6738), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6744), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6726), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6740), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6720), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6722), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      aux_sym_kernel_call_syntax_token1,
  [25090] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6726), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6066), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      aux_sym_kernel_call_syntax_token1,
  [25175] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2791), 1,
      anon_sym_LBRACE,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6712), 1,
      anon_sym_LBRACK,
    ACTIONS(6714), 1,
      sym_auto,
    ACTIONS(6716), 1,
      anon_sym_decltype,
    STATE(3127), 1,
      sym_decltype_auto,
    STATE(3192), 1,
      sym_new_declarator,
    STATE(3742), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5704), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5706), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [25258] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6728), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6730), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6742), 1,
      anon_sym_GT_EQ,
    ACTIONS(6746), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6748), 1,
      anon_sym_or,
    ACTIONS(6750), 1,
      anon_sym_and,
    ACTIONS(6752), 1,
      anon_sym_not_eq,
    ACTIONS(6756), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6760), 1,
      anon_sym_QMARK,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6724), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6732), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6734), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6736), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6738), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6744), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6726), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6740), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6754), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6758), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [25377] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6728), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6730), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6742), 1,
      anon_sym_GT_EQ,
    ACTIONS(6746), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6748), 1,
      anon_sym_or,
    ACTIONS(6750), 1,
      anon_sym_and,
    ACTIONS(6752), 1,
      anon_sym_not_eq,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6724), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6732), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6734), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6736), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6738), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6744), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6726), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6740), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6764), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6766), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      aux_sym_kernel_call_syntax_token1,
  [25490] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6728), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6730), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6742), 1,
      anon_sym_GT_EQ,
    ACTIONS(6746), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6748), 1,
      anon_sym_or,
    ACTIONS(6750), 1,
      anon_sym_and,
    ACTIONS(6752), 1,
      anon_sym_not_eq,
    ACTIONS(6756), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6760), 1,
      anon_sym_QMARK,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6724), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6732), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6734), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6736), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6738), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6744), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6726), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6740), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6768), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6770), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [25609] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6724), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6726), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6066), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      aux_sym_kernel_call_syntax_token1,
  [25696] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5921), 1,
      anon_sym_LBRACE,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    STATE(2199), 1,
      sym_attribute_specifier,
    STATE(2921), 1,
      sym_enumerator_list,
    ACTIONS(5612), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym___forceinline,
      anon_sym_const,
    ACTIONS(5610), 50,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym___launch_bounds__,
  [25771] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6728), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6730), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6742), 1,
      anon_sym_GT_EQ,
    ACTIONS(6746), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6748), 1,
      anon_sym_or,
    ACTIONS(6750), 1,
      anon_sym_and,
    ACTIONS(6752), 1,
      anon_sym_not_eq,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6724), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6732), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6734), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6736), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6738), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6744), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6726), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6740), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6772), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6774), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      aux_sym_kernel_call_syntax_token1,
  [25884] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6746), 1,
      anon_sym_LT_EQ_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6724), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6744), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6726), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6066), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      aux_sym_kernel_call_syntax_token1,
  [25975] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6742), 1,
      anon_sym_GT_EQ,
    ACTIONS(6746), 1,
      anon_sym_LT_EQ_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6724), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6744), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6726), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6740), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 15,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6066), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      aux_sym_kernel_call_syntax_token1,
  [26070] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6742), 1,
      anon_sym_GT_EQ,
    ACTIONS(6746), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6752), 1,
      anon_sym_not_eq,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6724), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6738), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6744), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6726), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6740), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 14,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      sym_identifier,
    ACTIONS(6066), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      aux_sym_kernel_call_syntax_token1,
  [26169] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6742), 1,
      anon_sym_GT_EQ,
    ACTIONS(6746), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6752), 1,
      anon_sym_not_eq,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6724), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6736), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6738), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6744), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6726), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6740), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 12,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      sym_identifier,
    ACTIONS(6066), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      aux_sym_kernel_call_syntax_token1,
  [26270] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6742), 1,
      anon_sym_GT_EQ,
    ACTIONS(6746), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6752), 1,
      anon_sym_not_eq,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6724), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6734), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6736), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6738), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6744), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6726), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6740), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 10,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      sym_identifier,
    ACTIONS(6066), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      aux_sym_kernel_call_syntax_token1,
  [26373] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6742), 1,
      anon_sym_GT_EQ,
    ACTIONS(6746), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6752), 1,
      anon_sym_not_eq,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6724), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6732), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6734), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6736), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6738), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6744), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6726), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6740), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 8,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
    ACTIONS(6066), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      aux_sym_kernel_call_syntax_token1,
  [26478] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6724), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6744), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6726), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6066), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      aux_sym_kernel_call_syntax_token1,
  [26567] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6730), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6742), 1,
      anon_sym_GT_EQ,
    ACTIONS(6746), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6750), 1,
      anon_sym_and,
    ACTIONS(6752), 1,
      anon_sym_not_eq,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6724), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6732), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6734), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6736), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6738), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6744), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6726), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6740), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 7,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      sym_identifier,
    ACTIONS(6066), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      aux_sym_kernel_call_syntax_token1,
  [26676] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5179), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5181), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [26745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4142), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4149), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [26812] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6776), 1,
      anon_sym_LT,
    STATE(2875), 1,
      sym_template_argument_list,
    STATE(2908), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6597), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3756), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3764), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [26889] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2829), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6581), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5192), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5194), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [26960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5196), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5198), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [27027] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5179), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5181), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [27096] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3984), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3986), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [27163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4142), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4149), 42,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [27230] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5179), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5181), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [27299] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4023), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [27366] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6370), 1,
      anon_sym___attribute__,
    ACTIONS(6778), 1,
      anon_sym_LBRACE,
    ACTIONS(6780), 1,
      anon_sym_COLON,
    STATE(2995), 1,
      sym__enum_base_clause,
    STATE(3019), 1,
      sym_enumerator_list,
    STATE(3357), 1,
      sym_attribute_specifier,
    ACTIONS(6048), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6050), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [27445] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5179), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5181), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [27514] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6370), 1,
      anon_sym___attribute__,
    ACTIONS(6778), 1,
      anon_sym_LBRACE,
    ACTIONS(6780), 1,
      anon_sym_COLON,
    STATE(2990), 1,
      sym__enum_base_clause,
    STATE(3059), 1,
      sym_enumerator_list,
    STATE(3408), 1,
      sym_attribute_specifier,
    ACTIONS(6042), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6044), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [27593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5179), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5181), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [27660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3980), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3982), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [27727] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6728), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6730), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6742), 1,
      anon_sym_GT_EQ,
    ACTIONS(6746), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6748), 1,
      anon_sym_or,
    ACTIONS(6750), 1,
      anon_sym_and,
    ACTIONS(6752), 1,
      anon_sym_not_eq,
    ACTIONS(6756), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6760), 1,
      anon_sym_QMARK,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6724), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6732), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6734), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6736), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6738), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6744), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6726), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6740), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6374), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6376), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [27846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4017), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4019), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [27913] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2791), 1,
      anon_sym_LBRACE,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6712), 1,
      anon_sym_LBRACK,
    ACTIONS(6714), 1,
      sym_auto,
    ACTIONS(6716), 1,
      anon_sym_decltype,
    STATE(3125), 1,
      sym_new_declarator,
    STATE(3127), 1,
      sym_decltype_auto,
    STATE(3829), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5664), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5666), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [27996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5196), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5198), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [28063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3992), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3994), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [28130] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6728), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6730), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6742), 1,
      anon_sym_GT_EQ,
    ACTIONS(6746), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6748), 1,
      anon_sym_or,
    ACTIONS(6750), 1,
      anon_sym_and,
    ACTIONS(6752), 1,
      anon_sym_not_eq,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6724), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6732), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6734), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6736), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6738), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6744), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6726), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6740), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6782), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6784), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      aux_sym_kernel_call_syntax_token1,
  [28243] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    STATE(2204), 1,
      sym_attribute_specifier,
    ACTIONS(5716), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym___forceinline,
      anon_sym_const,
    ACTIONS(5714), 51,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym___launch_bounds__,
  [28313] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    STATE(2206), 1,
      sym_attribute_specifier,
    ACTIONS(5696), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym___forceinline,
      anon_sym_const,
    ACTIONS(5694), 51,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym___launch_bounds__,
  [28383] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3289), 1,
      anon_sym_LBRACE,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(6788), 1,
      anon_sym_LBRACK,
    ACTIONS(6790), 1,
      sym_auto,
    ACTIONS(6792), 1,
      anon_sym_decltype,
    STATE(3392), 1,
      sym_new_declarator,
    STATE(3419), 1,
      sym_decltype_auto,
    STATE(4036), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5704), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5706), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [28465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5458), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5460), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [28531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5472), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [28597] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6776), 1,
      anon_sym_LT,
    STATE(2875), 1,
      sym_template_argument_list,
    ACTIONS(5212), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3782), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [28669] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    STATE(2208), 1,
      sym_attribute_specifier,
    ACTIONS(5723), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym___forceinline,
      anon_sym_const,
    ACTIONS(5721), 51,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym___launch_bounds__,
  [28739] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2823), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6794), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5438), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5436), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [28809] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6627), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6691), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6801), 1,
      anon_sym_DASH_GT,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(5376), 1,
      sym__function_attributes_start,
    STATE(5424), 1,
      sym_ref_qualifier,
    STATE(6041), 1,
      sym_trailing_return_type,
    STATE(6101), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6798), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4312), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4485), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6177), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5680), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6619), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [28925] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6803), 1,
      anon_sym_LT,
    STATE(3018), 1,
      sym_template_argument_list,
    ACTIONS(3782), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5212), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [28997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5502), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [29063] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3289), 1,
      anon_sym_LBRACE,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(6788), 1,
      anon_sym_LBRACK,
    ACTIONS(6790), 1,
      sym_auto,
    ACTIONS(6792), 1,
      anon_sym_decltype,
    STATE(3338), 1,
      sym_new_declarator,
    STATE(3419), 1,
      sym_decltype_auto,
    STATE(3991), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5640), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5642), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [29145] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    STATE(2196), 1,
      sym_attribute_specifier,
    ACTIONS(5700), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym___forceinline,
      anon_sym_const,
    ACTIONS(5698), 51,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym___launch_bounds__,
  [29215] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    STATE(2171), 1,
      sym_attribute_specifier,
    ACTIONS(5684), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym___forceinline,
      anon_sym_const,
    ACTIONS(5682), 51,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym___launch_bounds__,
  [29285] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 1,
      anon_sym___attribute__,
    ACTIONS(6647), 1,
      anon_sym_LBRACE,
    STATE(2955), 1,
      sym_enumerator_list,
    STATE(3205), 1,
      sym_attribute_specifier,
    ACTIONS(5612), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5610), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [29359] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6805), 1,
      anon_sym_LT,
    STATE(2875), 1,
      sym_template_argument_list,
    ACTIONS(4000), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4007), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [29431] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6803), 1,
      anon_sym_LT,
    STATE(3018), 1,
      sym_template_argument_list,
    ACTIONS(4007), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4000), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [29503] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3289), 1,
      anon_sym_LBRACE,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(6788), 1,
      anon_sym_LBRACK,
    ACTIONS(6790), 1,
      sym_auto,
    ACTIONS(6792), 1,
      anon_sym_decltype,
    STATE(3367), 1,
      sym_new_declarator,
    STATE(3419), 1,
      sym_decltype_auto,
    STATE(3939), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5690), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5692), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [29585] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6627), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6808), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6811), 1,
      anon_sym_DASH_GT,
    ACTIONS(6813), 1,
      anon_sym_requires,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(5365), 1,
      sym__function_attributes_start,
    STATE(5423), 1,
      sym_ref_qualifier,
    STATE(6091), 1,
      sym_trailing_return_type,
    STATE(6214), 1,
      sym__function_attributes_end,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4165), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4389), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6177), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5667), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6619), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [29701] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2823), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6794), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5434), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5432), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [29771] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6627), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6808), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6811), 1,
      anon_sym_DASH_GT,
    ACTIONS(6815), 1,
      anon_sym_requires,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(5364), 1,
      sym__function_attributes_start,
    STATE(5428), 1,
      sym_ref_qualifier,
    STATE(6089), 1,
      sym_trailing_return_type,
    STATE(6147), 1,
      sym__function_attributes_end,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6700), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4165), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4389), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6177), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5661), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6619), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [29887] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3289), 1,
      anon_sym_LBRACE,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(6788), 1,
      anon_sym_LBRACK,
    ACTIONS(6790), 1,
      sym_auto,
    ACTIONS(6792), 1,
      anon_sym_decltype,
    STATE(3342), 1,
      sym_new_declarator,
    STATE(3419), 1,
      sym_decltype_auto,
    STATE(3992), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5664), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5666), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [29969] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2896), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6818), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5374), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5376), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [30039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5179), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5181), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [30105] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6627), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6808), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6813), 1,
      anon_sym_requires,
    ACTIONS(6820), 1,
      anon_sym_DASH_GT,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(5373), 1,
      sym__function_attributes_start,
    STATE(5427), 1,
      sym_ref_qualifier,
    STATE(6091), 1,
      sym_trailing_return_type,
    STATE(6113), 1,
      sym__function_attributes_end,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6798), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4165), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4389), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6177), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5678), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6619), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [30221] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6627), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6691), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6822), 1,
      anon_sym_DASH_GT,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(5366), 1,
      sym__function_attributes_start,
    STATE(5416), 1,
      sym_ref_qualifier,
    STATE(6041), 1,
      sym_trailing_return_type,
    STATE(6170), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4312), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4485), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6177), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5659), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6619), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [30337] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    STATE(2187), 1,
      sym_attribute_specifier,
    ACTIONS(5635), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym___forceinline,
      anon_sym_const,
    ACTIONS(5633), 51,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym___launch_bounds__,
  [30407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5179), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5181), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [30473] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(6826), 1,
      anon_sym_LBRACK,
    ACTIONS(6828), 1,
      sym_auto,
    ACTIONS(6830), 1,
      anon_sym_decltype,
    STATE(3240), 1,
      sym_new_declarator,
    STATE(3303), 1,
      sym_decltype_auto,
    STATE(4018), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5664), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5666), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [30555] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2823), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6794), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5418), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5416), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [30625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5462), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5464), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [30691] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    STATE(2177), 1,
      sym_attribute_specifier,
    ACTIONS(5688), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym___forceinline,
      anon_sym_const,
    ACTIONS(5686), 51,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym___launch_bounds__,
  [30761] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    STATE(2169), 1,
      sym_attribute_specifier,
    ACTIONS(5670), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym___forceinline,
      anon_sym_const,
    ACTIONS(5668), 51,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym___launch_bounds__,
  [30831] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6627), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6691), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(6703), 1,
      anon_sym_requires,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6822), 1,
      anon_sym_DASH_GT,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(5363), 1,
      sym__function_attributes_start,
    STATE(5418), 1,
      sym_ref_qualifier,
    STATE(6105), 1,
      sym_trailing_return_type,
    STATE(6204), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6700), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4312), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4485), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6177), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5652), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6619), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [30947] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(6826), 1,
      anon_sym_LBRACK,
    ACTIONS(6828), 1,
      sym_auto,
    ACTIONS(6830), 1,
      anon_sym_decltype,
    STATE(3286), 1,
      sym_new_declarator,
    STATE(3303), 1,
      sym_decltype_auto,
    STATE(3950), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5704), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5706), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [31029] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6627), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6691), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(6703), 1,
      anon_sym_requires,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6801), 1,
      anon_sym_DASH_GT,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(5371), 1,
      sym__function_attributes_start,
    STATE(5430), 1,
      sym_ref_qualifier,
    STATE(6010), 1,
      sym__function_attributes_end,
    STATE(6105), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6700), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6798), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4312), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4485), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6177), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5672), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6619), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [31145] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5187), 1,
      anon_sym_SEMI,
    ACTIONS(5194), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5192), 51,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [31213] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    STATE(2164), 1,
      sym_attribute_specifier,
    ACTIONS(5727), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym___forceinline,
      anon_sym_const,
    ACTIONS(5725), 51,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym___launch_bounds__,
  [31283] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2939), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6832), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5448), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5446), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [31353] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2918), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6834), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5442), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5440), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [31423] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5187), 1,
      anon_sym_SEMI,
    ACTIONS(5194), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5192), 51,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [31493] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6627), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6808), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6815), 1,
      anon_sym_requires,
    ACTIONS(6820), 1,
      anon_sym_DASH_GT,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(5375), 1,
      sym__function_attributes_start,
    STATE(5419), 1,
      sym_ref_qualifier,
    STATE(6040), 1,
      sym__function_attributes_end,
    STATE(6089), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6700), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6798), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4165), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4389), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6177), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5656), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6619), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [31609] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    STATE(2198), 1,
      sym_attribute_specifier,
    ACTIONS(5676), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym___forceinline,
      anon_sym_const,
    ACTIONS(5674), 51,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym___launch_bounds__,
  [31679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6838), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6836), 53,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_typename,
      anon_sym_template,
      anon_sym___launch_bounds__,
  [31745] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(6826), 1,
      anon_sym_LBRACK,
    ACTIONS(6828), 1,
      sym_auto,
    ACTIONS(6830), 1,
      anon_sym_decltype,
    STATE(3265), 1,
      sym_new_declarator,
    STATE(3303), 1,
      sym_decltype_auto,
    STATE(3973), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5690), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5692), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [31827] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(6826), 1,
      anon_sym_LBRACK,
    ACTIONS(6828), 1,
      sym_auto,
    ACTIONS(6830), 1,
      anon_sym_decltype,
    STATE(3229), 1,
      sym_new_declarator,
    STATE(3303), 1,
      sym_decltype_auto,
    STATE(4043), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5640), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5642), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [31909] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 1,
      anon_sym___attribute__,
    ACTIONS(6647), 1,
      anon_sym_LBRACE,
    STATE(2956), 1,
      sym_enumerator_list,
    STATE(3184), 1,
      sym_attribute_specifier,
    ACTIONS(5599), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5597), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [31983] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    STATE(2192), 1,
      sym_attribute_specifier,
    ACTIONS(5658), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym___forceinline,
      anon_sym_const,
    ACTIONS(5656), 51,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym___launch_bounds__,
  [32053] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    STATE(2174), 1,
      sym_attribute_specifier,
    ACTIONS(5629), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym___forceinline,
      anon_sym_const,
    ACTIONS(5627), 51,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
      anon_sym___launch_bounds__,
  [32123] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4153), 1,
      anon_sym_LBRACK,
    ACTIONS(4146), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4149), 5,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
    ACTIONS(4142), 50,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [32193] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2823), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6794), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5424), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5422), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [32263] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym_literal_suffix,
    ACTIONS(3766), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3758), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [32330] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6627), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6840), 1,
      anon_sym_DASH_GT,
    ACTIONS(6842), 1,
      anon_sym_requires,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(5378), 1,
      sym__function_attributes_start,
    STATE(5566), 1,
      sym_ref_qualifier,
    STATE(6345), 1,
      sym__function_attributes_end,
    STATE(6429), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6635), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4165), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4389), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6474), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5699), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6619), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [32445] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6853), 1,
      anon_sym_GT_EQ,
    ACTIONS(6857), 1,
      anon_sym_LT_EQ_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6845), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6855), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6847), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6849), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6851), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      aux_sym_kernel_call_syntax_token1,
  [32540] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6853), 1,
      anon_sym_GT_EQ,
    ACTIONS(6857), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6859), 1,
      anon_sym_AMP,
    ACTIONS(6861), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6845), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6855), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6847), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6849), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6851), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      aux_sym_kernel_call_syntax_token1,
  [32639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4002), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
      aux_sym_kernel_call_syntax_token1,
  [32704] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6853), 1,
      anon_sym_GT_EQ,
    ACTIONS(6857), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6859), 1,
      anon_sym_AMP,
    ACTIONS(6861), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6845), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6855), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6863), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6847), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6849), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6851), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6066), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      aux_sym_kernel_call_syntax_token1,
  [32805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6264), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6262), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [32870] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6772), 1,
      anon_sym_EQ,
    ACTIONS(6853), 1,
      anon_sym_GT_EQ,
    ACTIONS(6857), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6859), 1,
      anon_sym_AMP,
    ACTIONS(6861), 1,
      anon_sym_bitand,
    ACTIONS(6865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6869), 1,
      anon_sym_PIPE,
    ACTIONS(6871), 1,
      anon_sym_or,
    ACTIONS(6873), 1,
      anon_sym_and,
    ACTIONS(6875), 1,
      anon_sym_bitor,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6845), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6855), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6863), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6847), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6849), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6851), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6774), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      aux_sym_kernel_call_syntax_token1,
  [32983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4002), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
      aux_sym_kernel_call_syntax_token1,
  [33048] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6601), 1,
      anon_sym___attribute__,
    ACTIONS(6877), 1,
      anon_sym_LBRACE,
    ACTIONS(6879), 1,
      anon_sym_COLON,
    STATE(3101), 1,
      sym__enum_base_clause,
    STATE(3463), 1,
      sym_enumerator_list,
    STATE(3780), 1,
      sym_attribute_specifier,
    ACTIONS(6048), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6050), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [33125] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4011), 1,
      anon_sym_LBRACK,
    ACTIONS(6192), 1,
      anon_sym_LT,
    STATE(3061), 1,
      sym_template_argument_list,
    ACTIONS(4004), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4007), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_EQ,
    ACTIONS(4000), 44,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [33200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3988), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3990), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [33265] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6782), 1,
      anon_sym_EQ,
    ACTIONS(6853), 1,
      anon_sym_GT_EQ,
    ACTIONS(6857), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6859), 1,
      anon_sym_AMP,
    ACTIONS(6861), 1,
      anon_sym_bitand,
    ACTIONS(6865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6869), 1,
      anon_sym_PIPE,
    ACTIONS(6871), 1,
      anon_sym_or,
    ACTIONS(6873), 1,
      anon_sym_and,
    ACTIONS(6875), 1,
      anon_sym_bitor,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6845), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6855), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6863), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6847), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6849), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6851), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6784), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      aux_sym_kernel_call_syntax_token1,
  [33378] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6273), 1,
      anon_sym___attribute__,
    ACTIONS(6706), 1,
      anon_sym_LBRACE,
    STATE(3082), 1,
      sym_enumerator_list,
    STATE(3256), 1,
      sym_attribute_specifier,
    ACTIONS(5612), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5610), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [33451] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6853), 1,
      anon_sym_GT_EQ,
    ACTIONS(6857), 1,
      anon_sym_LT_EQ_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6845), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6855), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6847), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6851), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [33544] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 1,
      anon_sym___attribute__,
    STATE(3182), 1,
      sym_attribute_specifier,
    ACTIONS(5670), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5668), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [33613] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 1,
      anon_sym___attribute__,
    STATE(3148), 1,
      sym_attribute_specifier,
    ACTIONS(5658), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5656), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [33682] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2896), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6818), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5192), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5194), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [33751] = 54,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6881), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6883), 1,
      anon_sym_COMMA,
    ACTIONS(6885), 1,
      anon_sym_RPAREN,
    ACTIONS(6887), 1,
      anon_sym_DASH,
    ACTIONS(6889), 1,
      anon_sym_PLUS,
    ACTIONS(6891), 1,
      anon_sym_STAR,
    ACTIONS(6893), 1,
      anon_sym_SLASH,
    ACTIONS(6895), 1,
      anon_sym_PERCENT,
    ACTIONS(6897), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6899), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6901), 1,
      anon_sym_PIPE,
    ACTIONS(6903), 1,
      anon_sym_CARET,
    ACTIONS(6905), 1,
      anon_sym_AMP,
    ACTIONS(6907), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6909), 1,
      anon_sym_BANG_EQ,
    ACTIONS(6911), 1,
      anon_sym_GT,
    ACTIONS(6913), 1,
      anon_sym_GT_EQ,
    ACTIONS(6915), 1,
      anon_sym_LT_EQ,
    ACTIONS(6917), 1,
      anon_sym_LT,
    ACTIONS(6919), 1,
      anon_sym_LT_LT,
    ACTIONS(6921), 1,
      anon_sym_GT_GT,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6925), 1,
      anon_sym_EQ,
    ACTIONS(6927), 1,
      anon_sym_QMARK,
    ACTIONS(6929), 1,
      anon_sym_STAR_EQ,
    ACTIONS(6931), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(6933), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(6935), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(6937), 1,
      anon_sym_DASH_EQ,
    ACTIONS(6939), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(6941), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(6943), 1,
      anon_sym_AMP_EQ,
    ACTIONS(6945), 1,
      anon_sym_CARET_EQ,
    ACTIONS(6947), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(6951), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6953), 1,
      anon_sym_or,
    ACTIONS(6955), 1,
      anon_sym_and,
    ACTIONS(6957), 1,
      anon_sym_bitor,
    ACTIONS(6959), 1,
      anon_sym_xor,
    ACTIONS(6961), 1,
      anon_sym_bitand,
    ACTIONS(6963), 1,
      anon_sym_not_eq,
    ACTIONS(6969), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6971), 1,
      anon_sym_DASH_GT_STAR,
    STATE(1339), 1,
      sym__binary_fold_operator,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(7957), 1,
      sym_kernel_call_syntax,
    STATE(8666), 1,
      sym__fold_operator,
    ACTIONS(6965), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6949), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [33918] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6857), 1,
      anon_sym_LT_EQ_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6845), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6855), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6847), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [34007] = 54,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6881), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6883), 1,
      anon_sym_COMMA,
    ACTIONS(6887), 1,
      anon_sym_DASH,
    ACTIONS(6889), 1,
      anon_sym_PLUS,
    ACTIONS(6891), 1,
      anon_sym_STAR,
    ACTIONS(6893), 1,
      anon_sym_SLASH,
    ACTIONS(6895), 1,
      anon_sym_PERCENT,
    ACTIONS(6897), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6899), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6901), 1,
      anon_sym_PIPE,
    ACTIONS(6903), 1,
      anon_sym_CARET,
    ACTIONS(6905), 1,
      anon_sym_AMP,
    ACTIONS(6907), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6909), 1,
      anon_sym_BANG_EQ,
    ACTIONS(6911), 1,
      anon_sym_GT,
    ACTIONS(6913), 1,
      anon_sym_GT_EQ,
    ACTIONS(6915), 1,
      anon_sym_LT_EQ,
    ACTIONS(6917), 1,
      anon_sym_LT,
    ACTIONS(6919), 1,
      anon_sym_LT_LT,
    ACTIONS(6921), 1,
      anon_sym_GT_GT,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6925), 1,
      anon_sym_EQ,
    ACTIONS(6927), 1,
      anon_sym_QMARK,
    ACTIONS(6929), 1,
      anon_sym_STAR_EQ,
    ACTIONS(6931), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(6933), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(6935), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(6937), 1,
      anon_sym_DASH_EQ,
    ACTIONS(6939), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(6941), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(6943), 1,
      anon_sym_AMP_EQ,
    ACTIONS(6945), 1,
      anon_sym_CARET_EQ,
    ACTIONS(6947), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(6951), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6953), 1,
      anon_sym_or,
    ACTIONS(6955), 1,
      anon_sym_and,
    ACTIONS(6957), 1,
      anon_sym_bitor,
    ACTIONS(6959), 1,
      anon_sym_xor,
    ACTIONS(6961), 1,
      anon_sym_bitand,
    ACTIONS(6963), 1,
      anon_sym_not_eq,
    ACTIONS(6969), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6971), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(6973), 1,
      anon_sym_RPAREN,
    STATE(1339), 1,
      sym__binary_fold_operator,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(7957), 1,
      sym_kernel_call_syntax,
    STATE(8666), 1,
      sym__fold_operator,
    ACTIONS(6965), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6949), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [34174] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6754), 1,
      anon_sym_EQ,
    ACTIONS(6756), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6853), 1,
      anon_sym_GT_EQ,
    ACTIONS(6857), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6859), 1,
      anon_sym_AMP,
    ACTIONS(6861), 1,
      anon_sym_bitand,
    ACTIONS(6865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6869), 1,
      anon_sym_PIPE,
    ACTIONS(6871), 1,
      anon_sym_or,
    ACTIONS(6873), 1,
      anon_sym_and,
    ACTIONS(6875), 1,
      anon_sym_bitor,
    ACTIONS(6975), 1,
      anon_sym_QMARK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6845), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6855), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6863), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6847), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6849), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6851), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6758), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [34293] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6627), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6808), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6977), 1,
      anon_sym_DASH_GT,
    ACTIONS(6979), 1,
      anon_sym_requires,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(5379), 1,
      sym__function_attributes_start,
    STATE(5545), 1,
      sym_ref_qualifier,
    STATE(6246), 1,
      sym__function_attributes_end,
    STATE(6443), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4165), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4389), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6177), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5690), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6619), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [34408] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6845), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6847), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [34493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6360), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6358), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [34558] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3984), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3986), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [34623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3980), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3982), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [34688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3996), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3998), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [34753] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6720), 1,
      anon_sym_EQ,
    ACTIONS(6853), 1,
      anon_sym_GT_EQ,
    ACTIONS(6857), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6859), 1,
      anon_sym_AMP,
    ACTIONS(6861), 1,
      anon_sym_bitand,
    ACTIONS(6865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6869), 1,
      anon_sym_PIPE,
    ACTIONS(6871), 1,
      anon_sym_or,
    ACTIONS(6873), 1,
      anon_sym_and,
    ACTIONS(6875), 1,
      anon_sym_bitor,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6845), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6855), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6863), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6847), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6849), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6851), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6722), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      aux_sym_kernel_call_syntax_token1,
  [34866] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6853), 1,
      anon_sym_GT_EQ,
    ACTIONS(6857), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6859), 1,
      anon_sym_AMP,
    ACTIONS(6861), 1,
      anon_sym_bitand,
    ACTIONS(6869), 1,
      anon_sym_PIPE,
    ACTIONS(6875), 1,
      anon_sym_bitor,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6845), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6855), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6863), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6064), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6847), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6849), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6851), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      aux_sym_kernel_call_syntax_token1,
  [34971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6981), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6983), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [35036] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6273), 1,
      anon_sym___attribute__,
    ACTIONS(6706), 1,
      anon_sym_LBRACE,
    STATE(3016), 1,
      sym_enumerator_list,
    STATE(3226), 1,
      sym_attribute_specifier,
    ACTIONS(5599), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5597), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [35109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6461), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6463), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
      aux_sym_kernel_call_syntax_token1,
  [35174] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6756), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6768), 1,
      anon_sym_EQ,
    ACTIONS(6853), 1,
      anon_sym_GT_EQ,
    ACTIONS(6857), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6859), 1,
      anon_sym_AMP,
    ACTIONS(6861), 1,
      anon_sym_bitand,
    ACTIONS(6865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6869), 1,
      anon_sym_PIPE,
    ACTIONS(6871), 1,
      anon_sym_or,
    ACTIONS(6873), 1,
      anon_sym_and,
    ACTIONS(6875), 1,
      anon_sym_bitor,
    ACTIONS(6975), 1,
      anon_sym_QMARK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6845), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6855), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6863), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6847), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6849), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6851), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6770), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [35293] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6627), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6808), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6977), 1,
      anon_sym_DASH_GT,
    ACTIONS(6985), 1,
      anon_sym_requires,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(5377), 1,
      sym__function_attributes_start,
    STATE(5525), 1,
      sym_ref_qualifier,
    STATE(6227), 1,
      sym__function_attributes_end,
    STATE(6418), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6700), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4165), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4389), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6177), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5688), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6619), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [35408] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 1,
      anon_sym___attribute__,
    STATE(3185), 1,
      sym_attribute_specifier,
    ACTIONS(5684), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5682), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [35477] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6374), 1,
      anon_sym_EQ,
    ACTIONS(6756), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6853), 1,
      anon_sym_GT_EQ,
    ACTIONS(6857), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6859), 1,
      anon_sym_AMP,
    ACTIONS(6861), 1,
      anon_sym_bitand,
    ACTIONS(6865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6869), 1,
      anon_sym_PIPE,
    ACTIONS(6871), 1,
      anon_sym_or,
    ACTIONS(6873), 1,
      anon_sym_and,
    ACTIONS(6875), 1,
      anon_sym_bitor,
    ACTIONS(6975), 1,
      anon_sym_QMARK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6845), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6855), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6863), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6847), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6849), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6851), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6376), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [35596] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 1,
      anon_sym___attribute__,
    STATE(3209), 1,
      sym_attribute_specifier,
    ACTIONS(5635), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5633), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [35665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4002), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
      aux_sym_kernel_call_syntax_token1,
  [35730] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 1,
      anon_sym___attribute__,
    STATE(3206), 1,
      sym_attribute_specifier,
    ACTIONS(5700), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5698), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [35799] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6845), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6855), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6847), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [35886] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3992), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3994), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [35951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6511), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6509), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [36016] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6764), 1,
      anon_sym_EQ,
    ACTIONS(6853), 1,
      anon_sym_GT_EQ,
    ACTIONS(6857), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6859), 1,
      anon_sym_AMP,
    ACTIONS(6861), 1,
      anon_sym_bitand,
    ACTIONS(6865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6869), 1,
      anon_sym_PIPE,
    ACTIONS(6871), 1,
      anon_sym_or,
    ACTIONS(6873), 1,
      anon_sym_and,
    ACTIONS(6875), 1,
      anon_sym_bitor,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6845), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6855), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6863), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6847), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6849), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6851), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6766), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      aux_sym_kernel_call_syntax_token1,
  [36129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6284), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6282), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [36194] = 54,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6881), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6883), 1,
      anon_sym_COMMA,
    ACTIONS(6887), 1,
      anon_sym_DASH,
    ACTIONS(6889), 1,
      anon_sym_PLUS,
    ACTIONS(6891), 1,
      anon_sym_STAR,
    ACTIONS(6893), 1,
      anon_sym_SLASH,
    ACTIONS(6895), 1,
      anon_sym_PERCENT,
    ACTIONS(6897), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6899), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6901), 1,
      anon_sym_PIPE,
    ACTIONS(6903), 1,
      anon_sym_CARET,
    ACTIONS(6905), 1,
      anon_sym_AMP,
    ACTIONS(6907), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6909), 1,
      anon_sym_BANG_EQ,
    ACTIONS(6911), 1,
      anon_sym_GT,
    ACTIONS(6913), 1,
      anon_sym_GT_EQ,
    ACTIONS(6915), 1,
      anon_sym_LT_EQ,
    ACTIONS(6917), 1,
      anon_sym_LT,
    ACTIONS(6919), 1,
      anon_sym_LT_LT,
    ACTIONS(6921), 1,
      anon_sym_GT_GT,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6925), 1,
      anon_sym_EQ,
    ACTIONS(6927), 1,
      anon_sym_QMARK,
    ACTIONS(6929), 1,
      anon_sym_STAR_EQ,
    ACTIONS(6931), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(6933), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(6935), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(6937), 1,
      anon_sym_DASH_EQ,
    ACTIONS(6939), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(6941), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(6943), 1,
      anon_sym_AMP_EQ,
    ACTIONS(6945), 1,
      anon_sym_CARET_EQ,
    ACTIONS(6947), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(6951), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6953), 1,
      anon_sym_or,
    ACTIONS(6955), 1,
      anon_sym_and,
    ACTIONS(6957), 1,
      anon_sym_bitor,
    ACTIONS(6959), 1,
      anon_sym_xor,
    ACTIONS(6961), 1,
      anon_sym_bitand,
    ACTIONS(6963), 1,
      anon_sym_not_eq,
    ACTIONS(6969), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6971), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(6988), 1,
      anon_sym_RPAREN,
    STATE(1339), 1,
      sym__binary_fold_operator,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(7957), 1,
      sym_kernel_call_syntax,
    STATE(8666), 1,
      sym__fold_operator,
    ACTIONS(6965), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6949), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [36361] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5185), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5187), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [36428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4023), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [36493] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6853), 1,
      anon_sym_GT_EQ,
    ACTIONS(6857), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6859), 1,
      anon_sym_AMP,
    ACTIONS(6861), 1,
      anon_sym_bitand,
    ACTIONS(6867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6869), 1,
      anon_sym_PIPE,
    ACTIONS(6873), 1,
      anon_sym_and,
    ACTIONS(6875), 1,
      anon_sym_bitor,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6064), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(6845), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6855), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6863), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6847), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6849), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6851), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      aux_sym_kernel_call_syntax_token1,
  [36602] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6627), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6840), 1,
      anon_sym_DASH_GT,
    ACTIONS(6990), 1,
      anon_sym_requires,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(5383), 1,
      sym__function_attributes_start,
    STATE(5556), 1,
      sym_ref_qualifier,
    STATE(6326), 1,
      sym__function_attributes_end,
    STATE(6478), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4165), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4389), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6474), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5689), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6619), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [36717] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6370), 1,
      anon_sym___attribute__,
    ACTIONS(6778), 1,
      anon_sym_LBRACE,
    STATE(3084), 1,
      sym_enumerator_list,
    STATE(3353), 1,
      sym_attribute_specifier,
    ACTIONS(5612), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5610), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [36790] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 1,
      anon_sym___attribute__,
    STATE(3200), 1,
      sym_attribute_specifier,
    ACTIONS(5723), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5721), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [36859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4017), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4019), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [36924] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 1,
      anon_sym___attribute__,
    STATE(3199), 1,
      sym_attribute_specifier,
    ACTIONS(5716), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5714), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [36993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5196), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5198), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [37058] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6370), 1,
      anon_sym___attribute__,
    ACTIONS(6778), 1,
      anon_sym_LBRACE,
    STATE(3067), 1,
      sym_enumerator_list,
    STATE(3335), 1,
      sym_attribute_specifier,
    ACTIONS(5599), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5597), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [37131] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 1,
      anon_sym___attribute__,
    STATE(3171), 1,
      sym_attribute_specifier,
    ACTIONS(5676), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5674), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [37200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4002), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
      aux_sym_kernel_call_syntax_token1,
  [37265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4002), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
      aux_sym_kernel_call_syntax_token1,
  [37330] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6601), 1,
      anon_sym___attribute__,
    ACTIONS(6877), 1,
      anon_sym_LBRACE,
    ACTIONS(6879), 1,
      anon_sym_COLON,
    STATE(3134), 1,
      sym__enum_base_clause,
    STATE(3363), 1,
      sym_enumerator_list,
    STATE(3613), 1,
      sym_attribute_specifier,
    ACTIONS(6042), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6044), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [37407] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym_literal_suffix,
    ACTIONS(5710), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5712), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [37474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4002), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
      aux_sym_kernel_call_syntax_token1,
  [37539] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5179), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5181), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [37606] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5179), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5181), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [37673] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 1,
      anon_sym___attribute__,
    STATE(3179), 1,
      sym_attribute_specifier,
    ACTIONS(5727), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5725), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [37742] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(6992), 1,
      anon_sym_LBRACK,
    STATE(2245), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4112), 1,
      sym_template_argument_list,
    ACTIONS(3779), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3764), 3,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
    ACTIONS(3784), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3756), 43,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [37821] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 1,
      anon_sym___attribute__,
    STATE(3156), 1,
      sym_attribute_specifier,
    ACTIONS(5696), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5694), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [37890] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 1,
      anon_sym___attribute__,
    STATE(3152), 1,
      sym_attribute_specifier,
    ACTIONS(5688), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5686), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [37959] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4149), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4151), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4144), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [38026] = 54,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6881), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6883), 1,
      anon_sym_COMMA,
    ACTIONS(6887), 1,
      anon_sym_DASH,
    ACTIONS(6889), 1,
      anon_sym_PLUS,
    ACTIONS(6891), 1,
      anon_sym_STAR,
    ACTIONS(6893), 1,
      anon_sym_SLASH,
    ACTIONS(6895), 1,
      anon_sym_PERCENT,
    ACTIONS(6897), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6899), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6901), 1,
      anon_sym_PIPE,
    ACTIONS(6903), 1,
      anon_sym_CARET,
    ACTIONS(6905), 1,
      anon_sym_AMP,
    ACTIONS(6907), 1,
      anon_sym_EQ_EQ,
    ACTIONS(6909), 1,
      anon_sym_BANG_EQ,
    ACTIONS(6911), 1,
      anon_sym_GT,
    ACTIONS(6913), 1,
      anon_sym_GT_EQ,
    ACTIONS(6915), 1,
      anon_sym_LT_EQ,
    ACTIONS(6917), 1,
      anon_sym_LT,
    ACTIONS(6919), 1,
      anon_sym_LT_LT,
    ACTIONS(6921), 1,
      anon_sym_GT_GT,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6925), 1,
      anon_sym_EQ,
    ACTIONS(6927), 1,
      anon_sym_QMARK,
    ACTIONS(6929), 1,
      anon_sym_STAR_EQ,
    ACTIONS(6931), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(6933), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(6935), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(6937), 1,
      anon_sym_DASH_EQ,
    ACTIONS(6939), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(6941), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(6943), 1,
      anon_sym_AMP_EQ,
    ACTIONS(6945), 1,
      anon_sym_CARET_EQ,
    ACTIONS(6947), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(6951), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6953), 1,
      anon_sym_or,
    ACTIONS(6955), 1,
      anon_sym_and,
    ACTIONS(6957), 1,
      anon_sym_bitor,
    ACTIONS(6959), 1,
      anon_sym_xor,
    ACTIONS(6961), 1,
      anon_sym_bitand,
    ACTIONS(6963), 1,
      anon_sym_not_eq,
    ACTIONS(6969), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6971), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(6994), 1,
      anon_sym_RPAREN,
    STATE(1339), 1,
      sym__binary_fold_operator,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(7957), 1,
      sym_kernel_call_syntax,
    STATE(8666), 1,
      sym__fold_operator,
    ACTIONS(6965), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6949), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [38193] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 1,
      anon_sym___attribute__,
    STATE(3180), 1,
      sym_attribute_specifier,
    ACTIONS(5629), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5627), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [38262] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6847), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [38345] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4007), 1,
      anon_sym_LBRACE,
    ACTIONS(4268), 1,
      anon_sym_LT,
    STATE(3113), 1,
      sym_template_argument_list,
    ACTIONS(4009), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4002), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [38417] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(2203), 1,
      sym_attribute_specifier,
    STATE(2475), 1,
      sym_field_declaration_list,
    STATE(7228), 1,
      sym_virtual_specifier,
    STATE(8034), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5506), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5508), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [38497] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6273), 1,
      anon_sym___attribute__,
    STATE(3216), 1,
      sym_attribute_specifier,
    ACTIONS(5676), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5674), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [38565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3988), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(3990), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [38629] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6273), 1,
      anon_sym___attribute__,
    STATE(3218), 1,
      sym_attribute_specifier,
    ACTIONS(5658), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5656), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [38697] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6370), 1,
      anon_sym___attribute__,
    STATE(3350), 1,
      sym_attribute_specifier,
    ACTIONS(5716), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5714), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [38765] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4142), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(4149), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [38829] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6370), 1,
      anon_sym___attribute__,
    STATE(3336), 1,
      sym_attribute_specifier,
    ACTIONS(5684), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5682), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [38897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5179), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5181), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [38961] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5181), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5179), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [39027] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    ACTIONS(6996), 1,
      anon_sym_LPAREN2,
    ACTIONS(6998), 1,
      anon_sym_LBRACK,
    ACTIONS(7000), 1,
      sym_auto,
    ACTIONS(7002), 1,
      anon_sym_decltype,
    STATE(3714), 1,
      sym_new_declarator,
    STATE(3817), 1,
      sym_decltype_auto,
    STATE(4157), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5640), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5642), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [39107] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6370), 1,
      anon_sym___attribute__,
    STATE(3332), 1,
      sym_attribute_specifier,
    ACTIONS(5727), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5725), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [39175] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6370), 1,
      anon_sym___attribute__,
    STATE(3404), 1,
      sym_attribute_specifier,
    ACTIONS(5696), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5694), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [39243] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6370), 1,
      anon_sym___attribute__,
    STATE(3333), 1,
      sym_attribute_specifier,
    ACTIONS(5629), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5627), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [39311] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5181), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5179), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [39377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5242), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5244), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [39441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6981), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6983), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [39505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7004), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(7006), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [39569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5234), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5236), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [39633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4017), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(4019), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [39697] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7008), 1,
      anon_sym_LPAREN2,
    ACTIONS(7010), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7012), 1,
      anon_sym_LBRACK,
    STATE(3504), 1,
      sym_parameter_list,
    STATE(3123), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5905), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5907), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [39771] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6273), 1,
      anon_sym___attribute__,
    STATE(3254), 1,
      sym_attribute_specifier,
    ACTIONS(5723), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5721), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [39839] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6273), 1,
      anon_sym___attribute__,
    STATE(3296), 1,
      sym_attribute_specifier,
    ACTIONS(5688), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5686), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [39907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5386), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5388), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [39971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7014), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(7016), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [40035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7018), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(7020), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [40099] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6714), 1,
      sym_auto,
    ACTIONS(6716), 1,
      anon_sym_decltype,
    STATE(3127), 1,
      sym_decltype_auto,
    ACTIONS(5171), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5173), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [40169] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7008), 1,
      anon_sym_LPAREN2,
    ACTIONS(7010), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7012), 1,
      anon_sym_LBRACK,
    STATE(3504), 1,
      sym_parameter_list,
    STATE(3123), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5843), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5845), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [40243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(4023), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [40307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3992), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(3994), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [40371] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7008), 1,
      anon_sym_LPAREN2,
    ACTIONS(7010), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7012), 1,
      anon_sym_LBRACK,
    STATE(3504), 1,
      sym_parameter_list,
    STATE(3123), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5923), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5925), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [40445] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6370), 1,
      anon_sym___attribute__,
    STATE(3351), 1,
      sym_attribute_specifier,
    ACTIONS(5723), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5721), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [40513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3996), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(3998), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [40577] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6273), 1,
      anon_sym___attribute__,
    STATE(3292), 1,
      sym_attribute_specifier,
    ACTIONS(5696), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5694), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [40645] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym_literal_suffix,
    ACTIONS(3766), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(3758), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [40711] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7008), 1,
      anon_sym_LPAREN2,
    ACTIONS(7010), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7012), 1,
      anon_sym_LBRACK,
    STATE(3504), 1,
      sym_parameter_list,
    STATE(3123), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5897), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5899), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [40785] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    ACTIONS(6996), 1,
      anon_sym_LPAREN2,
    ACTIONS(6998), 1,
      anon_sym_LBRACK,
    ACTIONS(7000), 1,
      sym_auto,
    ACTIONS(7002), 1,
      anon_sym_decltype,
    STATE(3817), 1,
      sym_decltype_auto,
    STATE(3819), 1,
      sym_new_declarator,
    STATE(4192), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5664), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5666), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [40865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3980), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(3982), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [40929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3984), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(3986), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [40993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7022), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(7024), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [41057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5196), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(5198), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [41121] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5192), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5194), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [41187] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5187), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5185), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [41253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5374), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5376), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [41317] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6627), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(7026), 1,
      anon_sym_DASH_GT,
    ACTIONS(7028), 1,
      anon_sym_requires,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(5398), 1,
      sym__function_attributes_start,
    STATE(5608), 1,
      sym_ref_qualifier,
    STATE(6388), 1,
      sym__function_attributes_end,
    STATE(6650), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6635), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4165), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4389), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6474), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5702), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6619), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [41431] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym_literal_suffix,
    ACTIONS(5710), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(5712), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [41497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5203), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5205), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [41561] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6370), 1,
      anon_sym___attribute__,
    STATE(3354), 1,
      sym_attribute_specifier,
    ACTIONS(5700), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5698), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [41629] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6273), 1,
      anon_sym___attribute__,
    STATE(3222), 1,
      sym_attribute_specifier,
    ACTIONS(5727), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5725), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [41697] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4144), 1,
      anon_sym_SEMI,
    ACTIONS(4153), 1,
      anon_sym_LBRACK,
    ACTIONS(4146), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4149), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
    ACTIONS(4142), 44,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [41767] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6370), 1,
      anon_sym___attribute__,
    STATE(3321), 1,
      sym_attribute_specifier,
    ACTIONS(5676), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5674), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [41835] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7008), 1,
      anon_sym_LPAREN2,
    ACTIONS(7010), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7012), 1,
      anon_sym_LBRACK,
    STATE(3504), 1,
      sym_parameter_list,
    STATE(3123), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5831), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5833), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [41909] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1996), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(1998), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [41973] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6370), 1,
      anon_sym___attribute__,
    STATE(3361), 1,
      sym_attribute_specifier,
    ACTIONS(5635), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5633), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [42041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5179), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(5181), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [42105] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6370), 1,
      anon_sym___attribute__,
    STATE(3322), 1,
      sym_attribute_specifier,
    ACTIONS(5658), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5656), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [42173] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5587), 4,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(5589), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(3758), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(3766), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
  [42241] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6273), 1,
      anon_sym___attribute__,
    STATE(3227), 1,
      sym_attribute_specifier,
    ACTIONS(5684), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5682), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [42309] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6273), 1,
      anon_sym___attribute__,
    STATE(3257), 1,
      sym_attribute_specifier,
    ACTIONS(5700), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5698), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [42377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2048), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(2050), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [42441] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6273), 1,
      anon_sym___attribute__,
    STATE(3252), 1,
      sym_attribute_specifier,
    ACTIONS(5716), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5714), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [42509] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5921), 1,
      anon_sym_LBRACE,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(7031), 1,
      anon_sym_COLON,
    STATE(2184), 1,
      sym_attribute_specifier,
    STATE(2845), 1,
      sym__enum_base_clause,
    STATE(2902), 1,
      sym_enumerator_list,
    ACTIONS(6048), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym___forceinline,
      anon_sym_const,
    ACTIONS(6050), 45,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_try,
      anon_sym_requires,
      anon_sym___launch_bounds__,
  [42585] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4007), 1,
      anon_sym_LBRACE,
    ACTIONS(4014), 1,
      anon_sym_LT,
    STATE(3008), 1,
      sym_template_argument_list,
    ACTIONS(4009), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4002), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [42657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5358), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5360), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [42721] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    ACTIONS(6996), 1,
      anon_sym_LPAREN2,
    ACTIONS(6998), 1,
      anon_sym_LBRACK,
    ACTIONS(7000), 1,
      sym_auto,
    ACTIONS(7002), 1,
      anon_sym_decltype,
    STATE(3763), 1,
      sym_new_declarator,
    STATE(3817), 1,
      sym_decltype_auto,
    STATE(4193), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5690), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5692), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [42801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7033), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
    ACTIONS(7035), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [42865] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5921), 1,
      anon_sym_LBRACE,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(7031), 1,
      anon_sym_COLON,
    STATE(2175), 1,
      sym_attribute_specifier,
    STATE(2858), 1,
      sym__enum_base_clause,
    STATE(2901), 1,
      sym_enumerator_list,
    ACTIONS(6042), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym___forceinline,
      anon_sym_const,
    ACTIONS(6044), 45,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_try,
      anon_sym_requires,
      anon_sym___launch_bounds__,
  [42941] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6627), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(7026), 1,
      anon_sym_DASH_GT,
    ACTIONS(7037), 1,
      anon_sym_requires,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(5394), 1,
      sym__function_attributes_start,
    STATE(5609), 1,
      sym_ref_qualifier,
    STATE(6381), 1,
      sym__function_attributes_end,
    STATE(6624), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4165), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4389), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6474), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5708), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6619), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [43055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5218), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5220), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [43119] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6273), 1,
      anon_sym___attribute__,
    STATE(3261), 1,
      sym_attribute_specifier,
    ACTIONS(5635), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5633), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [43187] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6273), 1,
      anon_sym___attribute__,
    STATE(3224), 1,
      sym_attribute_specifier,
    ACTIONS(5670), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5668), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [43255] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    ACTIONS(6996), 1,
      anon_sym_LPAREN2,
    ACTIONS(6998), 1,
      anon_sym_LBRACK,
    ACTIONS(7000), 1,
      sym_auto,
    ACTIONS(7002), 1,
      anon_sym_decltype,
    STATE(3656), 1,
      sym_new_declarator,
    STATE(3817), 1,
      sym_decltype_auto,
    STATE(4142), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5704), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5706), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [43335] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6370), 1,
      anon_sym___attribute__,
    STATE(3334), 1,
      sym_attribute_specifier,
    ACTIONS(5670), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5668), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [43403] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6273), 1,
      anon_sym___attribute__,
    STATE(3223), 1,
      sym_attribute_specifier,
    ACTIONS(5629), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5627), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [43471] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6370), 1,
      anon_sym___attribute__,
    STATE(3409), 1,
      sym_attribute_specifier,
    ACTIONS(5688), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5686), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [43539] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [43620] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4007), 1,
      anon_sym_LBRACE,
    ACTIONS(5155), 1,
      anon_sym_LT,
    STATE(3307), 1,
      sym_template_argument_list,
    ACTIONS(4009), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4002), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [43691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5301), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5303), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [43754] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(7957), 1,
      sym_kernel_call_syntax,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6068), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6070), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [43831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5192), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5194), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [43894] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7043), 1,
      anon_sym_LPAREN2,
    ACTIONS(7045), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7047), 1,
      anon_sym_LBRACK,
    STATE(3796), 1,
      sym_parameter_list,
    STATE(3426), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5843), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5845), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [43967] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7049), 1,
      anon_sym_LPAREN2,
    ACTIONS(7051), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7053), 1,
      anon_sym_LBRACK,
    STATE(3754), 1,
      sym_parameter_list,
    STATE(3448), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5897), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5899), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [44040] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(7957), 1,
      sym_kernel_call_syntax,
    ACTIONS(6965), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6052), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6054), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [44119] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7043), 1,
      anon_sym_LPAREN2,
    ACTIONS(7045), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7047), 1,
      anon_sym_LBRACK,
    STATE(3796), 1,
      sym_parameter_list,
    STATE(3426), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5923), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5925), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [44192] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym_literal_suffix,
    STATE(2752), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(3594), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3598), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3766), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3758), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [44263] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym_literal_suffix,
    STATE(2752), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(3594), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3598), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5710), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5712), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [44334] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7049), 1,
      anon_sym_LPAREN2,
    ACTIONS(7051), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7053), 1,
      anon_sym_LBRACK,
    STATE(3754), 1,
      sym_parameter_list,
    STATE(3448), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5905), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5907), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [44407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5192), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5194), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [44470] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7049), 1,
      anon_sym_LPAREN2,
    ACTIONS(7051), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7053), 1,
      anon_sym_LBRACK,
    STATE(3754), 1,
      sym_parameter_list,
    STATE(3448), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5831), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5833), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [44543] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6601), 1,
      anon_sym___attribute__,
    ACTIONS(6877), 1,
      anon_sym_LBRACE,
    STATE(3365), 1,
      sym_enumerator_list,
    STATE(3699), 1,
      sym_attribute_specifier,
    ACTIONS(5599), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5597), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [44614] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5192), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5194), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [44679] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(7957), 1,
      sym_kernel_call_syntax,
    ACTIONS(6965), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6110), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6112), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [44758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5145), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5147), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [44821] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6754), 1,
      anon_sym_EQ,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6881), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6927), 1,
      anon_sym_QMARK,
    ACTIONS(6951), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7059), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7061), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7063), 1,
      anon_sym_PIPE,
    ACTIONS(7067), 1,
      anon_sym_AMP,
    ACTIONS(7073), 1,
      anon_sym_GT_EQ,
    ACTIONS(7077), 1,
      anon_sym_or,
    ACTIONS(7079), 1,
      anon_sym_and,
    ACTIONS(7081), 1,
      anon_sym_bitor,
    ACTIONS(7083), 1,
      anon_sym_bitand,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(7957), 1,
      sym_kernel_call_syntax,
    ACTIONS(6965), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7065), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7075), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7057), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7069), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7071), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6758), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [44938] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7049), 1,
      anon_sym_LPAREN2,
    ACTIONS(7051), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7053), 1,
      anon_sym_LBRACK,
    STATE(3754), 1,
      sym_parameter_list,
    STATE(3448), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5843), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5845), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [45011] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2791), 1,
      anon_sym_LBRACE,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    STATE(3730), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5954), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5956), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [45080] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(7957), 1,
      sym_kernel_call_syntax,
    ACTIONS(6965), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6106), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6108), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [45159] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6754), 1,
      anon_sym_EQ,
    ACTIONS(6756), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7087), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7089), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7091), 1,
      anon_sym_PIPE,
    ACTIONS(7095), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_GT_EQ,
    ACTIONS(7105), 1,
      anon_sym_QMARK,
    ACTIONS(7107), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7109), 1,
      anon_sym_or,
    ACTIONS(7111), 1,
      anon_sym_and,
    ACTIONS(7113), 1,
      anon_sym_bitor,
    ACTIONS(7115), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7085), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7093), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7103), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7097), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7099), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6758), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [45276] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6764), 1,
      anon_sym_EQ,
    ACTIONS(7087), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7089), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7091), 1,
      anon_sym_PIPE,
    ACTIONS(7095), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_GT_EQ,
    ACTIONS(7107), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7109), 1,
      anon_sym_or,
    ACTIONS(7111), 1,
      anon_sym_and,
    ACTIONS(7113), 1,
      anon_sym_bitor,
    ACTIONS(7115), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7085), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7093), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7103), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7097), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7099), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6766), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      aux_sym_kernel_call_syntax_token1,
  [45387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5352), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [45450] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(7121), 1,
      anon_sym___declspec,
    ACTIONS(7123), 1,
      sym_auto,
    ACTIONS(7125), 1,
      anon_sym_decltype,
    ACTIONS(7127), 1,
      anon_sym___launch_bounds__,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2182), 1,
      sym_decltype_auto,
    ACTIONS(59), 2,
      anon_sym___inline,
      anon_sym___forceinline,
    ACTIONS(5426), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5428), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(7117), 6,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      sym_virtual,
    ACTIONS(7119), 7,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(3823), 8,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_launch_bounds,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6625), 16,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [45543] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4149), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4151), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4144), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [45608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5340), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5342), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [45671] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6756), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6768), 1,
      anon_sym_EQ,
    ACTIONS(7087), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7089), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7091), 1,
      anon_sym_PIPE,
    ACTIONS(7095), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_GT_EQ,
    ACTIONS(7105), 1,
      anon_sym_QMARK,
    ACTIONS(7107), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7109), 1,
      anon_sym_or,
    ACTIONS(7111), 1,
      anon_sym_and,
    ACTIONS(7113), 1,
      anon_sym_bitor,
    ACTIONS(7115), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7085), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7093), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7103), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7097), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7099), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6770), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [45788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5319), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5321), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [45851] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7049), 1,
      anon_sym_LPAREN2,
    ACTIONS(7051), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7053), 1,
      anon_sym_LBRACK,
    STATE(3754), 1,
      sym_parameter_list,
    STATE(3448), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5923), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5925), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [45924] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6720), 1,
      anon_sym_EQ,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6951), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7059), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7061), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7063), 1,
      anon_sym_PIPE,
    ACTIONS(7067), 1,
      anon_sym_AMP,
    ACTIONS(7073), 1,
      anon_sym_GT_EQ,
    ACTIONS(7077), 1,
      anon_sym_or,
    ACTIONS(7079), 1,
      anon_sym_and,
    ACTIONS(7081), 1,
      anon_sym_bitor,
    ACTIONS(7083), 1,
      anon_sym_bitand,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(7957), 1,
      sym_kernel_call_syntax,
    ACTIONS(6965), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7065), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7075), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7057), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7069), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7071), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6722), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [46035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5315), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5317), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [46098] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(7957), 1,
      sym_kernel_call_syntax,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6096), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6098), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [46175] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6772), 1,
      anon_sym_EQ,
    ACTIONS(7087), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7089), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7091), 1,
      anon_sym_PIPE,
    ACTIONS(7095), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_GT_EQ,
    ACTIONS(7107), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7109), 1,
      anon_sym_or,
    ACTIONS(7111), 1,
      anon_sym_and,
    ACTIONS(7113), 1,
      anon_sym_bitor,
    ACTIONS(7115), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7085), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7093), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7103), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7097), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7099), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6774), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      aux_sym_kernel_call_syntax_token1,
  [46286] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6772), 1,
      anon_sym_EQ,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6951), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7059), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7061), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7063), 1,
      anon_sym_PIPE,
    ACTIONS(7067), 1,
      anon_sym_AMP,
    ACTIONS(7073), 1,
      anon_sym_GT_EQ,
    ACTIONS(7077), 1,
      anon_sym_or,
    ACTIONS(7079), 1,
      anon_sym_and,
    ACTIONS(7081), 1,
      anon_sym_bitor,
    ACTIONS(7083), 1,
      anon_sym_bitand,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(7957), 1,
      sym_kernel_call_syntax,
    ACTIONS(6965), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7065), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7075), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7057), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7069), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7071), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6774), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [46397] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7010), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5968), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5970), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [46464] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7129), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3124), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5986), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5988), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [46531] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2791), 1,
      anon_sym_LBRACE,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    STATE(3645), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6012), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6014), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [46600] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(7957), 1,
      sym_kernel_call_syntax,
    ACTIONS(6965), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6102), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6104), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [46679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5277), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5279), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [46742] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(7101), 1,
      anon_sym_GT_EQ,
    ACTIONS(7107), 1,
      anon_sym_LT_EQ_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7085), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7103), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7099), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [46833] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7134), 1,
      anon_sym_RPAREN,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(7636), 1,
      sym_type_descriptor,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [46944] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(7101), 1,
      anon_sym_GT_EQ,
    ACTIONS(7107), 1,
      anon_sym_LT_EQ_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7085), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7103), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7097), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7099), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      aux_sym_kernel_call_syntax_token1,
  [47037] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(7095), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_GT_EQ,
    ACTIONS(7107), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7115), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7085), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7103), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7097), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7099), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      aux_sym_kernel_call_syntax_token1,
  [47134] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(7095), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_GT_EQ,
    ACTIONS(7107), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7115), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7085), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7093), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7103), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7097), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7099), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6066), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      aux_sym_kernel_call_syntax_token1,
  [47233] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(7091), 1,
      anon_sym_PIPE,
    ACTIONS(7095), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_GT_EQ,
    ACTIONS(7107), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7113), 1,
      anon_sym_bitor,
    ACTIONS(7115), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7085), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7093), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7103), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6064), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7097), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7099), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      aux_sym_kernel_call_syntax_token1,
  [47336] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6601), 1,
      anon_sym___attribute__,
    ACTIONS(6877), 1,
      anon_sym_LBRACE,
    STATE(3470), 1,
      sym_enumerator_list,
    STATE(3800), 1,
      sym_attribute_specifier,
    ACTIONS(5612), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5610), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [47407] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(7089), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7091), 1,
      anon_sym_PIPE,
    ACTIONS(7095), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_GT_EQ,
    ACTIONS(7107), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7111), 1,
      anon_sym_and,
    ACTIONS(7113), 1,
      anon_sym_bitor,
    ACTIONS(7115), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6064), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(7085), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7093), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7103), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7097), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7099), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      aux_sym_kernel_call_syntax_token1,
  [47514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5203), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5205), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [47577] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6374), 1,
      anon_sym_EQ,
    ACTIONS(6756), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7087), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7089), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7091), 1,
      anon_sym_PIPE,
    ACTIONS(7095), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_GT_EQ,
    ACTIONS(7105), 1,
      anon_sym_QMARK,
    ACTIONS(7107), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7109), 1,
      anon_sym_or,
    ACTIONS(7111), 1,
      anon_sym_and,
    ACTIONS(7113), 1,
      anon_sym_bitor,
    ACTIONS(7115), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7085), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7093), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7103), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7097), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7099), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6376), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [47694] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7142), 1,
      anon_sym_STAR,
    ACTIONS(7144), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6361), 1,
      sym__abstract_declarator,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7150), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7152), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3169), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4310), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5504), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [47793] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7085), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7103), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [47878] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7085), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [47961] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6951), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7073), 1,
      anon_sym_GT_EQ,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(7957), 1,
      sym_kernel_call_syntax,
    ACTIONS(6965), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7075), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7057), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7071), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [48052] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6782), 1,
      anon_sym_EQ,
    ACTIONS(7087), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7089), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7091), 1,
      anon_sym_PIPE,
    ACTIONS(7095), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_GT_EQ,
    ACTIONS(7107), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7109), 1,
      anon_sym_or,
    ACTIONS(7111), 1,
      anon_sym_and,
    ACTIONS(7113), 1,
      anon_sym_bitor,
    ACTIONS(7115), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7085), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7093), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7103), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7097), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7099), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6784), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      aux_sym_kernel_call_syntax_token1,
  [48163] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7142), 1,
      anon_sym_STAR,
    ACTIONS(7144), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6344), 1,
      sym__abstract_declarator,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7150), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7152), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3138), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4318), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5484), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [48262] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(7121), 1,
      anon_sym___declspec,
    ACTIONS(7123), 1,
      sym_auto,
    ACTIONS(7125), 1,
      anon_sym_decltype,
    ACTIONS(7127), 1,
      anon_sym___launch_bounds__,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2182), 1,
      sym_decltype_auto,
    ACTIONS(59), 2,
      anon_sym___inline,
      anon_sym___forceinline,
    ACTIONS(5406), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5408), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(7156), 6,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      sym_virtual,
    ACTIONS(7119), 7,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(3791), 8,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_launch_bounds,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6625), 16,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [48355] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7148), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7158), 1,
      anon_sym_STAR,
    ACTIONS(7160), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7162), 1,
      anon_sym_AMP,
    STATE(2839), 1,
      sym_parameter_list,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6301), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7150), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7152), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3169), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4296), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5504), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [48454] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7148), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7158), 1,
      anon_sym_STAR,
    ACTIONS(7160), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7162), 1,
      anon_sym_AMP,
    STATE(2839), 1,
      sym_parameter_list,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6307), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7150), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7152), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3145), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4286), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5484), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [48553] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5192), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5194), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [48618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5297), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5299), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [48681] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2791), 1,
      anon_sym_LBRACE,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    STATE(3608), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6024), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6026), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [48750] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      sym_auto,
    ACTIONS(6792), 1,
      anon_sym_decltype,
    STATE(3419), 1,
      sym_decltype_auto,
    ACTIONS(5171), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5173), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [48819] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6764), 1,
      anon_sym_EQ,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6951), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7059), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7061), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7063), 1,
      anon_sym_PIPE,
    ACTIONS(7067), 1,
      anon_sym_AMP,
    ACTIONS(7073), 1,
      anon_sym_GT_EQ,
    ACTIONS(7077), 1,
      anon_sym_or,
    ACTIONS(7079), 1,
      anon_sym_and,
    ACTIONS(7081), 1,
      anon_sym_bitor,
    ACTIONS(7083), 1,
      anon_sym_bitand,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(7957), 1,
      sym_kernel_call_syntax,
    ACTIONS(6965), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7065), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7075), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7057), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7069), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7071), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6766), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [48930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5214), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5216), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [48993] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7043), 1,
      anon_sym_LPAREN2,
    ACTIONS(7045), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7047), 1,
      anon_sym_LBRACK,
    STATE(3796), 1,
      sym_parameter_list,
    STATE(3426), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5897), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5899), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [49066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5238), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5240), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [49129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5248), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [49192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5250), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5252), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [49255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5254), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5256), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [49318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5248), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [49381] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5248), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [49444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5218), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5220), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [49507] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6720), 1,
      anon_sym_EQ,
    ACTIONS(7087), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7089), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7091), 1,
      anon_sym_PIPE,
    ACTIONS(7095), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_GT_EQ,
    ACTIONS(7107), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7109), 1,
      anon_sym_or,
    ACTIONS(7111), 1,
      anon_sym_and,
    ACTIONS(7113), 1,
      anon_sym_bitor,
    ACTIONS(7115), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7085), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7093), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7103), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7097), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7099), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6722), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      aux_sym_kernel_call_syntax_token1,
  [49618] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7148), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7164), 1,
      anon_sym_STAR,
    ACTIONS(7166), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7168), 1,
      anon_sym_AMP,
    STATE(2924), 1,
      sym_parameter_list,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6319), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7150), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7152), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3169), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4291), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5504), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [49717] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7148), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7164), 1,
      anon_sym_STAR,
    ACTIONS(7166), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7168), 1,
      anon_sym_AMP,
    STATE(2924), 1,
      sym_parameter_list,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6298), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7150), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7152), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3162), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4289), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5484), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [49816] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(7107), 1,
      anon_sym_LT_EQ_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7085), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7103), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7039), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [49903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5386), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5388), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [49966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5374), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5376), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [50029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5234), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5236), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [50092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5358), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5360), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [50155] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(7177), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3169), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(7174), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7172), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT2,
    ACTIONS(7170), 36,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [50226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5242), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5244), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [50289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5311), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5313), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [50352] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(7957), 1,
      sym_kernel_call_syntax,
    ACTIONS(6965), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7075), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7057), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [50437] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6782), 1,
      anon_sym_EQ,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6951), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7059), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7061), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7063), 1,
      anon_sym_PIPE,
    ACTIONS(7067), 1,
      anon_sym_AMP,
    ACTIONS(7073), 1,
      anon_sym_GT_EQ,
    ACTIONS(7077), 1,
      anon_sym_or,
    ACTIONS(7079), 1,
      anon_sym_and,
    ACTIONS(7081), 1,
      anon_sym_bitor,
    ACTIONS(7083), 1,
      anon_sym_bitand,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(7957), 1,
      sym_kernel_call_syntax,
    ACTIONS(6965), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7065), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7075), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7057), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7069), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7071), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6784), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [50548] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6828), 1,
      sym_auto,
    ACTIONS(6830), 1,
      anon_sym_decltype,
    STATE(3303), 1,
      sym_decltype_auto,
    ACTIONS(5171), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5173), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [50617] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(7957), 1,
      sym_kernel_call_syntax,
    ACTIONS(6965), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7057), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [50700] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6951), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(7957), 1,
      sym_kernel_call_syntax,
    ACTIONS(6965), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7075), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7057), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [50787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5358), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5360), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [50850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5293), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5295), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [50913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5289), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5291), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [50976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5281), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5283), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [51039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5242), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5244), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [51102] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5230), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5232), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [51165] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6768), 1,
      anon_sym_EQ,
    ACTIONS(6881), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6927), 1,
      anon_sym_QMARK,
    ACTIONS(6951), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7059), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7061), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7063), 1,
      anon_sym_PIPE,
    ACTIONS(7067), 1,
      anon_sym_AMP,
    ACTIONS(7073), 1,
      anon_sym_GT_EQ,
    ACTIONS(7077), 1,
      anon_sym_or,
    ACTIONS(7079), 1,
      anon_sym_and,
    ACTIONS(7081), 1,
      anon_sym_bitor,
    ACTIONS(7083), 1,
      anon_sym_bitand,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(7957), 1,
      sym_kernel_call_syntax,
    ACTIONS(6965), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7065), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7075), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7057), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7069), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7071), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6770), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [51282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5226), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5228), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [51345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5222), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5224), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [51408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5234), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5236), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [51471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5374), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5376), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [51534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5386), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5388), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [51597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5203), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5205), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [51660] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6951), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7073), 1,
      anon_sym_GT_EQ,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(7957), 1,
      sym_kernel_call_syntax,
    ACTIONS(6965), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7075), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7057), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7069), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7071), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [51753] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_EQ,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6881), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6927), 1,
      anon_sym_QMARK,
    ACTIONS(6951), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7059), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7061), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7063), 1,
      anon_sym_PIPE,
    ACTIONS(7067), 1,
      anon_sym_AMP,
    ACTIONS(7073), 1,
      anon_sym_GT_EQ,
    ACTIONS(7077), 1,
      anon_sym_or,
    ACTIONS(7079), 1,
      anon_sym_and,
    ACTIONS(7081), 1,
      anon_sym_bitor,
    ACTIONS(7083), 1,
      anon_sym_bitand,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(7957), 1,
      sym_kernel_call_syntax,
    ACTIONS(6965), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7065), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7075), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7057), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7069), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7071), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6376), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [51870] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2791), 1,
      anon_sym_LBRACE,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    STATE(3827), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5964), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5966), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [51939] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5218), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5220), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [52002] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6951), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7067), 1,
      anon_sym_AMP,
    ACTIONS(7073), 1,
      anon_sym_GT_EQ,
    ACTIONS(7083), 1,
      anon_sym_bitand,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(7957), 1,
      sym_kernel_call_syntax,
    ACTIONS(6965), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7075), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7057), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7069), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7071), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [52099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5285), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5287), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [52162] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(7957), 1,
      sym_kernel_call_syntax,
    ACTIONS(6965), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7057), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [52243] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(7957), 1,
      sym_kernel_call_syntax,
    ACTIONS(6965), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6064), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [52322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5336), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5338), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [52385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5354), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5356), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [52448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5370), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5372), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [52511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5336), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5338), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [52574] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6951), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7061), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7063), 1,
      anon_sym_PIPE,
    ACTIONS(7067), 1,
      anon_sym_AMP,
    ACTIONS(7073), 1,
      anon_sym_GT_EQ,
    ACTIONS(7079), 1,
      anon_sym_and,
    ACTIONS(7081), 1,
      anon_sym_bitor,
    ACTIONS(7083), 1,
      anon_sym_bitand,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(7957), 1,
      sym_kernel_call_syntax,
    ACTIONS(6064), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(6965), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7065), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7075), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7057), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7069), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7071), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [52681] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7043), 1,
      anon_sym_LPAREN2,
    ACTIONS(7045), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7047), 1,
      anon_sym_LBRACK,
    STATE(3796), 1,
      sym_parameter_list,
    STATE(3426), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5905), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5907), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [52754] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6951), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7063), 1,
      anon_sym_PIPE,
    ACTIONS(7067), 1,
      anon_sym_AMP,
    ACTIONS(7073), 1,
      anon_sym_GT_EQ,
    ACTIONS(7081), 1,
      anon_sym_bitor,
    ACTIONS(7083), 1,
      anon_sym_bitand,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(7957), 1,
      sym_kernel_call_syntax,
    ACTIONS(6965), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7065), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7075), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6064), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7057), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7069), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7071), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [52857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5382), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5384), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [52920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5378), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5380), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [52983] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6951), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7067), 1,
      anon_sym_AMP,
    ACTIONS(7073), 1,
      anon_sym_GT_EQ,
    ACTIONS(7083), 1,
      anon_sym_bitand,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(7957), 1,
      sym_kernel_call_syntax,
    ACTIONS(6965), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7055), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7065), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7075), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7057), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7069), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7071), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6066), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [53082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5366), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5368), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [53145] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5362), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5364), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [53208] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7043), 1,
      anon_sym_LPAREN2,
    ACTIONS(7045), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7047), 1,
      anon_sym_LBRACK,
    STATE(3796), 1,
      sym_parameter_list,
    STATE(3426), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5831), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5833), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [53281] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(7180), 1,
      sym_identifier,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7186), 1,
      sym_primitive_type,
    ACTIONS(7188), 1,
      anon_sym_enum,
    ACTIONS(7190), 1,
      anon_sym_class,
    ACTIONS(7192), 1,
      anon_sym_struct,
    ACTIONS(7194), 1,
      anon_sym_union,
    ACTIONS(7196), 1,
      sym_auto,
    ACTIONS(7198), 1,
      anon_sym_decltype,
    ACTIONS(7200), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(4292), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4454), 1,
      sym_type_specifier,
    STATE(4799), 1,
      sym_decltype_auto,
    STATE(6193), 1,
      sym_type_descriptor,
    STATE(6845), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2154), 2,
      sym_decltype,
      sym_template_type,
    STATE(3533), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7184), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4932), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [53389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5248), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [53451] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(8686), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [53559] = 53,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6969), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6971), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7202), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7204), 1,
      anon_sym_COMMA,
    ACTIONS(7206), 1,
      anon_sym_RPAREN,
    ACTIONS(7208), 1,
      anon_sym_DASH,
    ACTIONS(7210), 1,
      anon_sym_PLUS,
    ACTIONS(7212), 1,
      anon_sym_STAR,
    ACTIONS(7214), 1,
      anon_sym_SLASH,
    ACTIONS(7216), 1,
      anon_sym_PERCENT,
    ACTIONS(7218), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7222), 1,
      anon_sym_PIPE,
    ACTIONS(7224), 1,
      anon_sym_CARET,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7228), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7230), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7232), 1,
      anon_sym_GT,
    ACTIONS(7234), 1,
      anon_sym_GT_EQ,
    ACTIONS(7236), 1,
      anon_sym_LT_EQ,
    ACTIONS(7238), 1,
      anon_sym_LT,
    ACTIONS(7240), 1,
      anon_sym_LT_LT,
    ACTIONS(7242), 1,
      anon_sym_GT_GT,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7246), 1,
      anon_sym_QMARK,
    ACTIONS(7248), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7250), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7252), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7254), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7256), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7258), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7260), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7262), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7264), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7266), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7268), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7270), 1,
      anon_sym_or,
    ACTIONS(7272), 1,
      anon_sym_and,
    ACTIONS(7274), 1,
      anon_sym_bitor,
    ACTIONS(7276), 1,
      anon_sym_xor,
    ACTIONS(7278), 1,
      anon_sym_bitand,
    ACTIONS(7280), 1,
      anon_sym_not_eq,
    STATE(1339), 1,
      sym__binary_fold_operator,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    STATE(8666), 1,
      sym__fold_operator,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [53721] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7284), 1,
      sym_identifier,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7290), 1,
      sym_primitive_type,
    ACTIONS(7292), 1,
      anon_sym_enum,
    ACTIONS(7294), 1,
      anon_sym_class,
    ACTIONS(7296), 1,
      anon_sym_struct,
    ACTIONS(7298), 1,
      anon_sym_union,
    ACTIONS(7300), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(5281), 1,
      sym_type_specifier,
    STATE(5342), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5973), 1,
      sym__type_definition_type,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3503), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7288), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [53829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5311), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5313), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [53891] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7284), 1,
      sym_identifier,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7290), 1,
      sym_primitive_type,
    ACTIONS(7292), 1,
      anon_sym_enum,
    ACTIONS(7294), 1,
      anon_sym_class,
    ACTIONS(7296), 1,
      anon_sym_struct,
    ACTIONS(7298), 1,
      anon_sym_union,
    ACTIONS(7300), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(5281), 1,
      sym_type_specifier,
    STATE(5342), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5920), 1,
      sym__type_definition_type,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3503), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7288), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [53999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5297), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5299), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [54061] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6754), 1,
      anon_sym_EQ,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7302), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7308), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7310), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7312), 1,
      anon_sym_PIPE,
    ACTIONS(7316), 1,
      anon_sym_AMP,
    ACTIONS(7322), 1,
      anon_sym_GT_EQ,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7328), 1,
      anon_sym_QMARK,
    ACTIONS(7330), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7332), 1,
      anon_sym_or,
    ACTIONS(7334), 1,
      anon_sym_and,
    ACTIONS(7336), 1,
      anon_sym_bitor,
    ACTIONS(7338), 1,
      anon_sym_bitand,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(8154), 1,
      sym_kernel_call_syntax,
    ACTIONS(7304), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7314), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7324), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7340), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7306), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7318), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7320), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6758), 15,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      aux_sym_kernel_call_syntax_token2,
  [54177] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7350), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(7348), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(7346), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [54243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5293), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5295), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [54305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5289), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5291), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [54367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5281), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5283), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [54429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5230), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5232), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [54491] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4481), 1,
      sym_type_specifier,
    STATE(6503), 1,
      sym_type_descriptor,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3566), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [54599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5226), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5228), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [54661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5222), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5224), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [54723] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(9017), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [54831] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    STATE(3933), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6024), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6026), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [54899] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6764), 1,
      anon_sym_EQ,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7308), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7310), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7312), 1,
      anon_sym_PIPE,
    ACTIONS(7316), 1,
      anon_sym_AMP,
    ACTIONS(7322), 1,
      anon_sym_GT_EQ,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7330), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7332), 1,
      anon_sym_or,
    ACTIONS(7334), 1,
      anon_sym_and,
    ACTIONS(7336), 1,
      anon_sym_bitor,
    ACTIONS(7338), 1,
      anon_sym_bitand,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(8154), 1,
      sym_kernel_call_syntax,
    ACTIONS(7304), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7314), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7324), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7340), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7306), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7318), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7320), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6766), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [55009] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(9035), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [55117] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3578), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7354), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(3574), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(3572), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [55183] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6768), 1,
      anon_sym_EQ,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7302), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7308), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7310), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7312), 1,
      anon_sym_PIPE,
    ACTIONS(7316), 1,
      anon_sym_AMP,
    ACTIONS(7322), 1,
      anon_sym_GT_EQ,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7328), 1,
      anon_sym_QMARK,
    ACTIONS(7330), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7332), 1,
      anon_sym_or,
    ACTIONS(7334), 1,
      anon_sym_and,
    ACTIONS(7336), 1,
      anon_sym_bitor,
    ACTIONS(7338), 1,
      anon_sym_bitand,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(8154), 1,
      sym_kernel_call_syntax,
    ACTIONS(7304), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7314), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7324), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7340), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7306), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7318), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7320), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6770), 15,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      aux_sym_kernel_call_syntax_token2,
  [55299] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7284), 1,
      sym_identifier,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7290), 1,
      sym_primitive_type,
    ACTIONS(7292), 1,
      anon_sym_enum,
    ACTIONS(7294), 1,
      anon_sym_class,
    ACTIONS(7296), 1,
      anon_sym_struct,
    ACTIONS(7298), 1,
      anon_sym_union,
    ACTIONS(7300), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(5281), 1,
      sym_type_specifier,
    STATE(5342), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5900), 1,
      sym__type_definition_type,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3503), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7288), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [55407] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4830), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(8670), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3577), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [55515] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(7186), 1,
      sym_primitive_type,
    ACTIONS(7196), 1,
      sym_auto,
    ACTIONS(7198), 1,
      anon_sym_decltype,
    ACTIONS(7356), 1,
      sym_identifier,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7360), 1,
      anon_sym_enum,
    ACTIONS(7362), 1,
      anon_sym_class,
    ACTIONS(7364), 1,
      anon_sym_struct,
    ACTIONS(7366), 1,
      anon_sym_union,
    ACTIONS(7368), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(4213), 1,
      sym_type_specifier,
    STATE(4292), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4799), 1,
      sym_decltype_auto,
    STATE(6193), 1,
      sym_type_descriptor,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2154), 2,
      sym_decltype,
      sym_template_type,
    STATE(3518), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7184), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4932), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [55623] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(8650), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [55731] = 53,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6969), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6971), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7202), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7204), 1,
      anon_sym_COMMA,
    ACTIONS(7208), 1,
      anon_sym_DASH,
    ACTIONS(7210), 1,
      anon_sym_PLUS,
    ACTIONS(7212), 1,
      anon_sym_STAR,
    ACTIONS(7214), 1,
      anon_sym_SLASH,
    ACTIONS(7216), 1,
      anon_sym_PERCENT,
    ACTIONS(7218), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7222), 1,
      anon_sym_PIPE,
    ACTIONS(7224), 1,
      anon_sym_CARET,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7228), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7230), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7232), 1,
      anon_sym_GT,
    ACTIONS(7234), 1,
      anon_sym_GT_EQ,
    ACTIONS(7236), 1,
      anon_sym_LT_EQ,
    ACTIONS(7238), 1,
      anon_sym_LT,
    ACTIONS(7240), 1,
      anon_sym_LT_LT,
    ACTIONS(7242), 1,
      anon_sym_GT_GT,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7246), 1,
      anon_sym_QMARK,
    ACTIONS(7248), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7250), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7252), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7254), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7256), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7258), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7260), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7262), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7264), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7266), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7268), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7270), 1,
      anon_sym_or,
    ACTIONS(7272), 1,
      anon_sym_and,
    ACTIONS(7274), 1,
      anon_sym_bitor,
    ACTIONS(7276), 1,
      anon_sym_xor,
    ACTIONS(7278), 1,
      anon_sym_bitand,
    ACTIONS(7280), 1,
      anon_sym_not_eq,
    ACTIONS(7370), 1,
      anon_sym_RPAREN,
    STATE(1339), 1,
      sym__binary_fold_operator,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    STATE(8666), 1,
      sym__fold_operator,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [55893] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7378), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7376), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(7374), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(7372), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [55959] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    STATE(3936), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6012), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6014), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [56027] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6772), 1,
      anon_sym_EQ,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7308), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7310), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7312), 1,
      anon_sym_PIPE,
    ACTIONS(7316), 1,
      anon_sym_AMP,
    ACTIONS(7322), 1,
      anon_sym_GT_EQ,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7330), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7332), 1,
      anon_sym_or,
    ACTIONS(7334), 1,
      anon_sym_and,
    ACTIONS(7336), 1,
      anon_sym_bitor,
    ACTIONS(7338), 1,
      anon_sym_bitand,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(8154), 1,
      sym_kernel_call_syntax,
    ACTIONS(7304), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7314), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7324), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7340), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7306), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7318), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7320), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6774), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [56137] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3570), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7380), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(3548), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(3546), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [56203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5285), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5287), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [56265] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4830), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(8933), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3577), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [56373] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6052), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6054), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [56451] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8314), 1,
      sym_type_descriptor,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [56559] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(8929), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [56667] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(9014), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [56775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5336), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5338), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [56837] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(3173), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7386), 1,
      anon_sym_STAR,
    ACTIONS(7388), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7390), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    STATE(2786), 1,
      sym_parameter_list,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6448), 1,
      sym__abstract_declarator,
    ACTIONS(7394), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7396), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3315), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4348), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5484), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [56935] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(7402), 1,
      sym_identifier,
    ACTIONS(7404), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7408), 1,
      sym_primitive_type,
    ACTIONS(7410), 1,
      anon_sym_enum,
    ACTIONS(7412), 1,
      anon_sym_class,
    ACTIONS(7414), 1,
      anon_sym_struct,
    ACTIONS(7416), 1,
      anon_sym_union,
    ACTIONS(7418), 1,
      sym_auto,
    ACTIONS(7420), 1,
      anon_sym_decltype,
    ACTIONS(7422), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(4139), 1,
      sym_type_specifier,
    STATE(4392), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5173), 1,
      sym_qualified_type_identifier,
    STATE(5240), 1,
      sym_decltype_auto,
    STATE(6503), 1,
      sym_type_descriptor,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3529), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5166), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7406), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5243), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [57043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5354), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5356), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [57105] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(9043), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [57213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5370), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5372), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [57275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5336), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5338), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [57337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5382), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5384), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [57399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5378), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5380), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [57461] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(8907), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [57569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5366), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5368), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [57631] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 1,
      anon_sym_LT,
    STATE(3113), 1,
      sym_template_argument_list,
    ACTIONS(6198), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6200), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [57697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5362), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5364), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [57759] = 53,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6969), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6971), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7202), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7204), 1,
      anon_sym_COMMA,
    ACTIONS(7208), 1,
      anon_sym_DASH,
    ACTIONS(7210), 1,
      anon_sym_PLUS,
    ACTIONS(7212), 1,
      anon_sym_STAR,
    ACTIONS(7214), 1,
      anon_sym_SLASH,
    ACTIONS(7216), 1,
      anon_sym_PERCENT,
    ACTIONS(7218), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7222), 1,
      anon_sym_PIPE,
    ACTIONS(7224), 1,
      anon_sym_CARET,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7228), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7230), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7232), 1,
      anon_sym_GT,
    ACTIONS(7234), 1,
      anon_sym_GT_EQ,
    ACTIONS(7236), 1,
      anon_sym_LT_EQ,
    ACTIONS(7238), 1,
      anon_sym_LT,
    ACTIONS(7240), 1,
      anon_sym_LT_LT,
    ACTIONS(7242), 1,
      anon_sym_GT_GT,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7246), 1,
      anon_sym_QMARK,
    ACTIONS(7248), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7250), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7252), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7254), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7256), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7258), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7260), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7262), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7264), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7266), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7268), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7270), 1,
      anon_sym_or,
    ACTIONS(7272), 1,
      anon_sym_and,
    ACTIONS(7274), 1,
      anon_sym_bitor,
    ACTIONS(7276), 1,
      anon_sym_xor,
    ACTIONS(7278), 1,
      anon_sym_bitand,
    ACTIONS(7280), 1,
      anon_sym_not_eq,
    ACTIONS(7427), 1,
      anon_sym_RPAREN,
    STATE(1339), 1,
      sym__binary_fold_operator,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    STATE(8666), 1,
      sym__fold_operator,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [57921] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(8719), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [58029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5192), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5194), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [58091] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    STATE(4041), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5954), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5956), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [58159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5145), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5147), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [58221] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7284), 1,
      sym_identifier,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7290), 1,
      sym_primitive_type,
    ACTIONS(7292), 1,
      anon_sym_enum,
    ACTIONS(7294), 1,
      anon_sym_class,
    ACTIONS(7296), 1,
      anon_sym_struct,
    ACTIONS(7298), 1,
      anon_sym_union,
    ACTIONS(7300), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(5281), 1,
      sym_type_specifier,
    STATE(5342), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5919), 1,
      sym__type_definition_type,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3503), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7288), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [58329] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(8154), 1,
      sym_kernel_call_syntax,
    ACTIONS(7340), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6102), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6104), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [58407] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(8154), 1,
      sym_kernel_call_syntax,
    ACTIONS(7304), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7324), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7340), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7306), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [58491] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(8154), 1,
      sym_kernel_call_syntax,
    ACTIONS(7304), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7340), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7306), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [58573] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7330), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(8154), 1,
      sym_kernel_call_syntax,
    ACTIONS(7304), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7324), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7340), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7306), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [58659] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7322), 1,
      anon_sym_GT_EQ,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7330), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(8154), 1,
      sym_kernel_call_syntax,
    ACTIONS(7304), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7324), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7340), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7306), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7320), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [58749] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7322), 1,
      anon_sym_GT_EQ,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7330), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(8154), 1,
      sym_kernel_call_syntax,
    ACTIONS(7304), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7324), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7340), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7306), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7318), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7320), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [58841] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7316), 1,
      anon_sym_AMP,
    ACTIONS(7322), 1,
      anon_sym_GT_EQ,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7330), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7338), 1,
      anon_sym_bitand,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(8154), 1,
      sym_kernel_call_syntax,
    ACTIONS(7304), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7324), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7340), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7306), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7318), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7320), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [58937] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7316), 1,
      anon_sym_AMP,
    ACTIONS(7322), 1,
      anon_sym_GT_EQ,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7330), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7338), 1,
      anon_sym_bitand,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(8154), 1,
      sym_kernel_call_syntax,
    ACTIONS(7304), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7314), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7324), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7340), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7306), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7318), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7320), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6066), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [59035] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7312), 1,
      anon_sym_PIPE,
    ACTIONS(7316), 1,
      anon_sym_AMP,
    ACTIONS(7322), 1,
      anon_sym_GT_EQ,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7330), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7336), 1,
      anon_sym_bitor,
    ACTIONS(7338), 1,
      anon_sym_bitand,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(8154), 1,
      sym_kernel_call_syntax,
    ACTIONS(7304), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7314), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7324), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7340), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6064), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7306), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7318), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7320), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [59137] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7310), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7312), 1,
      anon_sym_PIPE,
    ACTIONS(7316), 1,
      anon_sym_AMP,
    ACTIONS(7322), 1,
      anon_sym_GT_EQ,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7330), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7334), 1,
      anon_sym_and,
    ACTIONS(7336), 1,
      anon_sym_bitor,
    ACTIONS(7338), 1,
      anon_sym_bitand,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(8154), 1,
      sym_kernel_call_syntax,
    ACTIONS(6064), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(7304), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7314), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7324), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7340), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7306), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7318), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7320), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [59243] = 53,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6969), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6971), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7202), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7204), 1,
      anon_sym_COMMA,
    ACTIONS(7208), 1,
      anon_sym_DASH,
    ACTIONS(7210), 1,
      anon_sym_PLUS,
    ACTIONS(7212), 1,
      anon_sym_STAR,
    ACTIONS(7214), 1,
      anon_sym_SLASH,
    ACTIONS(7216), 1,
      anon_sym_PERCENT,
    ACTIONS(7218), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7222), 1,
      anon_sym_PIPE,
    ACTIONS(7224), 1,
      anon_sym_CARET,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7228), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7230), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7232), 1,
      anon_sym_GT,
    ACTIONS(7234), 1,
      anon_sym_GT_EQ,
    ACTIONS(7236), 1,
      anon_sym_LT_EQ,
    ACTIONS(7238), 1,
      anon_sym_LT,
    ACTIONS(7240), 1,
      anon_sym_LT_LT,
    ACTIONS(7242), 1,
      anon_sym_GT_GT,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7246), 1,
      anon_sym_QMARK,
    ACTIONS(7248), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7250), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7252), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7254), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7256), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7258), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7260), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7262), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7264), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7266), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7268), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7270), 1,
      anon_sym_or,
    ACTIONS(7272), 1,
      anon_sym_and,
    ACTIONS(7274), 1,
      anon_sym_bitor,
    ACTIONS(7276), 1,
      anon_sym_xor,
    ACTIONS(7278), 1,
      anon_sym_bitand,
    ACTIONS(7280), 1,
      anon_sym_not_eq,
    ACTIONS(7429), 1,
      anon_sym_RPAREN,
    STATE(1339), 1,
      sym__binary_fold_operator,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    STATE(8666), 1,
      sym__fold_operator,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [59405] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(8154), 1,
      sym_kernel_call_syntax,
    ACTIONS(7340), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6064), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [59483] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6601), 1,
      anon_sym___attribute__,
    STATE(3612), 1,
      sym_attribute_specifier,
    ACTIONS(5688), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5686), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [59549] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(8154), 1,
      sym_kernel_call_syntax,
    ACTIONS(7340), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7306), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [59629] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6601), 1,
      anon_sym___attribute__,
    STATE(3624), 1,
      sym_attribute_specifier,
    ACTIONS(5696), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5694), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [59695] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6627), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6691), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(7431), 1,
      anon_sym_DASH_GT,
    ACTIONS(7433), 1,
      anon_sym_requires,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(5445), 1,
      sym__function_attributes_start,
    STATE(5650), 1,
      sym_ref_qualifier,
    STATE(6610), 1,
      sym__function_attributes_end,
    STATE(6760), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6619), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4312), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4485), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6177), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5762), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [59807] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7284), 1,
      sym_identifier,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7290), 1,
      sym_primitive_type,
    ACTIONS(7292), 1,
      anon_sym_enum,
    ACTIONS(7294), 1,
      anon_sym_class,
    ACTIONS(7296), 1,
      anon_sym_struct,
    ACTIONS(7298), 1,
      anon_sym_union,
    ACTIONS(7300), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(5281), 1,
      sym_type_specifier,
    STATE(5342), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5929), 1,
      sym__type_definition_type,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3503), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7288), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [59915] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2727), 1,
      anon_sym_enum,
    ACTIONS(2729), 1,
      anon_sym_class,
    ACTIONS(2731), 1,
      anon_sym_struct,
    ACTIONS(2733), 1,
      anon_sym_union,
    ACTIONS(2757), 1,
      sym_auto,
    ACTIONS(2759), 1,
      anon_sym_decltype,
    ACTIONS(2761), 1,
      anon_sym_typename,
    ACTIONS(7435), 1,
      sym_identifier,
    ACTIONS(7437), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7439), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2157), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2557), 1,
      sym_qualified_type_identifier,
    STATE(2598), 1,
      sym_decltype_auto,
    STATE(4431), 1,
      sym_type_specifier,
    STATE(6503), 1,
      sym_type_descriptor,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2477), 2,
      sym_decltype,
      sym_template_type,
    STATE(3513), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2723), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2599), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [60023] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    STATE(4014), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5964), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5966), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [60091] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_EQ,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7302), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7308), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7310), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7312), 1,
      anon_sym_PIPE,
    ACTIONS(7316), 1,
      anon_sym_AMP,
    ACTIONS(7322), 1,
      anon_sym_GT_EQ,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7328), 1,
      anon_sym_QMARK,
    ACTIONS(7330), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7332), 1,
      anon_sym_or,
    ACTIONS(7334), 1,
      anon_sym_and,
    ACTIONS(7336), 1,
      anon_sym_bitor,
    ACTIONS(7338), 1,
      anon_sym_bitand,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(8154), 1,
      sym_kernel_call_syntax,
    ACTIONS(7304), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7314), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7324), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7340), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7306), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7318), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7320), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6376), 15,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      aux_sym_kernel_call_syntax_token2,
  [60207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5145), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5147), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [60269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5248), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [60331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5248), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [60393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5254), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5256), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [60455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5250), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5252), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [60517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5248), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [60579] = 53,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6969), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6971), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7202), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7204), 1,
      anon_sym_COMMA,
    ACTIONS(7208), 1,
      anon_sym_DASH,
    ACTIONS(7210), 1,
      anon_sym_PLUS,
    ACTIONS(7212), 1,
      anon_sym_STAR,
    ACTIONS(7214), 1,
      anon_sym_SLASH,
    ACTIONS(7216), 1,
      anon_sym_PERCENT,
    ACTIONS(7218), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7222), 1,
      anon_sym_PIPE,
    ACTIONS(7224), 1,
      anon_sym_CARET,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7228), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7230), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7232), 1,
      anon_sym_GT,
    ACTIONS(7234), 1,
      anon_sym_GT_EQ,
    ACTIONS(7236), 1,
      anon_sym_LT_EQ,
    ACTIONS(7238), 1,
      anon_sym_LT,
    ACTIONS(7240), 1,
      anon_sym_LT_LT,
    ACTIONS(7242), 1,
      anon_sym_GT_GT,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7246), 1,
      anon_sym_QMARK,
    ACTIONS(7248), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7250), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7252), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7254), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7256), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7258), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7260), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7262), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7264), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7266), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7268), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7270), 1,
      anon_sym_or,
    ACTIONS(7272), 1,
      anon_sym_and,
    ACTIONS(7274), 1,
      anon_sym_bitor,
    ACTIONS(7276), 1,
      anon_sym_xor,
    ACTIONS(7278), 1,
      anon_sym_bitand,
    ACTIONS(7280), 1,
      anon_sym_not_eq,
    ACTIONS(7441), 1,
      anon_sym_RPAREN,
    STATE(1339), 1,
      sym__binary_fold_operator,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    STATE(8666), 1,
      sym__fold_operator,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [60741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5238), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5240), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [60803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5214), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5216), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [60865] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6782), 1,
      anon_sym_EQ,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7308), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7310), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7312), 1,
      anon_sym_PIPE,
    ACTIONS(7316), 1,
      anon_sym_AMP,
    ACTIONS(7322), 1,
      anon_sym_GT_EQ,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7330), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7332), 1,
      anon_sym_or,
    ACTIONS(7334), 1,
      anon_sym_and,
    ACTIONS(7336), 1,
      anon_sym_bitor,
    ACTIONS(7338), 1,
      anon_sym_bitand,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(8154), 1,
      sym_kernel_call_syntax,
    ACTIONS(7304), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7314), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7324), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7340), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7306), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7318), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7320), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6784), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [60975] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8449), 1,
      sym_type_descriptor,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [61083] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7284), 1,
      sym_identifier,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7290), 1,
      sym_primitive_type,
    ACTIONS(7292), 1,
      anon_sym_enum,
    ACTIONS(7294), 1,
      anon_sym_class,
    ACTIONS(7296), 1,
      anon_sym_struct,
    ACTIONS(7298), 1,
      anon_sym_union,
    ACTIONS(7300), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(5281), 1,
      sym_type_specifier,
    STATE(5342), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5930), 1,
      sym__type_definition_type,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3503), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7288), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [61191] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(8690), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [61299] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7284), 1,
      sym_identifier,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7290), 1,
      sym_primitive_type,
    ACTIONS(7292), 1,
      anon_sym_enum,
    ACTIONS(7294), 1,
      anon_sym_class,
    ACTIONS(7296), 1,
      anon_sym_struct,
    ACTIONS(7298), 1,
      anon_sym_union,
    ACTIONS(7300), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(5281), 1,
      sym_type_specifier,
    STATE(5342), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5931), 1,
      sym__type_definition_type,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3503), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7288), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [61407] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8619), 1,
      sym_type_descriptor,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [61515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5277), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5279), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [61577] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(8154), 1,
      sym_kernel_call_syntax,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6096), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6098), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [61653] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      anon_sym_EQ,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7308), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7310), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7312), 1,
      anon_sym_PIPE,
    ACTIONS(7316), 1,
      anon_sym_AMP,
    ACTIONS(7322), 1,
      anon_sym_GT_EQ,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7330), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7332), 1,
      anon_sym_or,
    ACTIONS(7334), 1,
      anon_sym_and,
    ACTIONS(7336), 1,
      anon_sym_bitor,
    ACTIONS(7338), 1,
      anon_sym_bitand,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(8154), 1,
      sym_kernel_call_syntax,
    ACTIONS(7304), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7314), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7324), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7340), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7306), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7318), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7320), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6722), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [61763] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8453), 1,
      sym_type_descriptor,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [61871] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4149), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4151), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4144), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [61935] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(8154), 1,
      sym_kernel_call_syntax,
    ACTIONS(7340), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6106), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6108), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [62013] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(8154), 1,
      sym_kernel_call_syntax,
    ACTIONS(7340), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6110), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6112), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [62091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5315), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5317), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [62153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5319), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5321), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [62215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5340), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5342), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [62277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5352), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [62339] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(8154), 1,
      sym_kernel_call_syntax,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6068), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6070), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [62415] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(3173), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7386), 1,
      anon_sym_STAR,
    ACTIONS(7388), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7390), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    STATE(2786), 1,
      sym_parameter_list,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6427), 1,
      sym__abstract_declarator,
    ACTIONS(7394), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7396), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4023), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4332), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5504), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [62513] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8437), 1,
      sym_type_descriptor,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [62621] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7284), 1,
      sym_identifier,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7290), 1,
      sym_primitive_type,
    ACTIONS(7292), 1,
      anon_sym_enum,
    ACTIONS(7294), 1,
      anon_sym_class,
    ACTIONS(7296), 1,
      anon_sym_struct,
    ACTIONS(7298), 1,
      anon_sym_union,
    ACTIONS(7300), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(5281), 1,
      sym_type_specifier,
    STATE(5342), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5969), 1,
      sym__type_definition_type,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3503), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7288), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [62729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5192), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5194), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [62791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5301), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5303), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [62853] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4002), 1,
      anon_sym_SEMI,
    ACTIONS(4011), 1,
      anon_sym_LBRACK,
    ACTIONS(5534), 1,
      anon_sym_LT,
    STATE(3061), 1,
      sym_template_argument_list,
    ACTIONS(4004), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4007), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(4000), 44,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [62927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5311), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5313), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [62989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5297), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5299), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [63051] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8025), 1,
      sym_kernel_call_syntax,
    ACTIONS(7445), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6052), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6054), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [63129] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(7451), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7457), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7459), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7461), 1,
      anon_sym_PIPE,
    ACTIONS(7465), 1,
      anon_sym_AMP,
    ACTIONS(7473), 1,
      anon_sym_QMARK,
    ACTIONS(7475), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7477), 1,
      anon_sym_or,
    ACTIONS(7479), 1,
      anon_sym_and,
    ACTIONS(7481), 1,
      anon_sym_bitor,
    ACTIONS(7483), 1,
      anon_sym_bitand,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8025), 1,
      sym_kernel_call_syntax,
    ACTIONS(6754), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7445), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7453), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7463), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7471), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7455), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7467), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7469), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6758), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [63243] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7284), 1,
      sym_identifier,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7290), 1,
      sym_primitive_type,
    ACTIONS(7292), 1,
      anon_sym_enum,
    ACTIONS(7294), 1,
      anon_sym_class,
    ACTIONS(7296), 1,
      anon_sym_struct,
    ACTIONS(7298), 1,
      anon_sym_union,
    ACTIONS(7300), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(5281), 1,
      sym_type_specifier,
    STATE(5342), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5993), 1,
      sym__type_definition_type,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3503), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7288), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [63351] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4830), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(9013), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3577), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [63459] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8357), 1,
      sym_type_descriptor,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [63567] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7485), 1,
      anon_sym_LT,
    STATE(3008), 1,
      sym_template_argument_list,
    ACTIONS(6198), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6200), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [63633] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4830), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8334), 1,
      sym_type_descriptor,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3577), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [63741] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7488), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6222), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6224), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [63805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5293), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5295), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [63867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5289), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5291), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [63929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5281), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5283), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [63991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5230), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5232), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [64053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5226), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5228), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [64115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5222), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5224), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [64177] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7490), 1,
      anon_sym_LT,
    STATE(3496), 1,
      sym_template_argument_list,
    ACTIONS(6126), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6128), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [64245] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3289), 1,
      anon_sym_LBRACE,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    STATE(3925), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6024), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6026), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [64313] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(7457), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7459), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7461), 1,
      anon_sym_PIPE,
    ACTIONS(7465), 1,
      anon_sym_AMP,
    ACTIONS(7475), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7477), 1,
      anon_sym_or,
    ACTIONS(7479), 1,
      anon_sym_and,
    ACTIONS(7481), 1,
      anon_sym_bitor,
    ACTIONS(7483), 1,
      anon_sym_bitand,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8025), 1,
      sym_kernel_call_syntax,
    ACTIONS(6764), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7445), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7453), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7463), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7471), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7455), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7467), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7469), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6766), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [64421] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(7186), 1,
      sym_primitive_type,
    ACTIONS(7196), 1,
      sym_auto,
    ACTIONS(7198), 1,
      anon_sym_decltype,
    ACTIONS(7356), 1,
      sym_identifier,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7360), 1,
      anon_sym_enum,
    ACTIONS(7362), 1,
      anon_sym_class,
    ACTIONS(7364), 1,
      anon_sym_struct,
    ACTIONS(7366), 1,
      anon_sym_union,
    ACTIONS(7368), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(4109), 1,
      sym_type_specifier,
    STATE(4292), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4799), 1,
      sym_decltype_auto,
    STATE(6193), 1,
      sym_type_descriptor,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2154), 2,
      sym_decltype,
      sym_template_type,
    STATE(3527), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7184), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4932), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [64529] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(7451), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7457), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7459), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7461), 1,
      anon_sym_PIPE,
    ACTIONS(7465), 1,
      anon_sym_AMP,
    ACTIONS(7473), 1,
      anon_sym_QMARK,
    ACTIONS(7475), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7477), 1,
      anon_sym_or,
    ACTIONS(7479), 1,
      anon_sym_and,
    ACTIONS(7481), 1,
      anon_sym_bitor,
    ACTIONS(7483), 1,
      anon_sym_bitand,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8025), 1,
      sym_kernel_call_syntax,
    ACTIONS(6768), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7445), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7453), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7463), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7471), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7455), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7467), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7469), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6770), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [64643] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3289), 1,
      anon_sym_LBRACE,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    STATE(3943), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6012), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6014), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [64711] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(7457), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7459), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7461), 1,
      anon_sym_PIPE,
    ACTIONS(7465), 1,
      anon_sym_AMP,
    ACTIONS(7475), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7477), 1,
      anon_sym_or,
    ACTIONS(7479), 1,
      anon_sym_and,
    ACTIONS(7481), 1,
      anon_sym_bitor,
    ACTIONS(7483), 1,
      anon_sym_bitand,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8025), 1,
      sym_kernel_call_syntax,
    ACTIONS(6772), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7445), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7453), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7463), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7471), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7455), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7467), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7469), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6774), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [64819] = 53,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6969), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6971), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7202), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7204), 1,
      anon_sym_COMMA,
    ACTIONS(7208), 1,
      anon_sym_DASH,
    ACTIONS(7210), 1,
      anon_sym_PLUS,
    ACTIONS(7212), 1,
      anon_sym_STAR,
    ACTIONS(7214), 1,
      anon_sym_SLASH,
    ACTIONS(7216), 1,
      anon_sym_PERCENT,
    ACTIONS(7218), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7222), 1,
      anon_sym_PIPE,
    ACTIONS(7224), 1,
      anon_sym_CARET,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7228), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7230), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7232), 1,
      anon_sym_GT,
    ACTIONS(7234), 1,
      anon_sym_GT_EQ,
    ACTIONS(7236), 1,
      anon_sym_LT_EQ,
    ACTIONS(7238), 1,
      anon_sym_LT,
    ACTIONS(7240), 1,
      anon_sym_LT_LT,
    ACTIONS(7242), 1,
      anon_sym_GT_GT,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7246), 1,
      anon_sym_QMARK,
    ACTIONS(7248), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7250), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7252), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7254), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7256), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7258), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7260), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7262), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7264), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7266), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7268), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7270), 1,
      anon_sym_or,
    ACTIONS(7272), 1,
      anon_sym_and,
    ACTIONS(7274), 1,
      anon_sym_bitor,
    ACTIONS(7276), 1,
      anon_sym_xor,
    ACTIONS(7278), 1,
      anon_sym_bitand,
    ACTIONS(7280), 1,
      anon_sym_not_eq,
    ACTIONS(7493), 1,
      anon_sym_RPAREN,
    STATE(1339), 1,
      sym__binary_fold_operator,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    STATE(8666), 1,
      sym__fold_operator,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [64981] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7284), 1,
      sym_identifier,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7290), 1,
      sym_primitive_type,
    ACTIONS(7292), 1,
      anon_sym_enum,
    ACTIONS(7294), 1,
      anon_sym_class,
    ACTIONS(7296), 1,
      anon_sym_struct,
    ACTIONS(7298), 1,
      anon_sym_union,
    ACTIONS(7300), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(5281), 1,
      sym_type_specifier,
    STATE(5342), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5977), 1,
      sym__type_definition_type,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3503), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7288), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [65089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5285), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5287), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [65151] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4337), 1,
      sym_type_specifier,
    STATE(6503), 1,
      sym_type_descriptor,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3526), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [65259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5336), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5338), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [65321] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8222), 1,
      sym_type_descriptor,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [65429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5354), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5356), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [65491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5370), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5372), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [65553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5336), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5338), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [65615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5382), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5384), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [65677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5378), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5380), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [65739] = 53,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6969), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6971), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7202), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7204), 1,
      anon_sym_COMMA,
    ACTIONS(7208), 1,
      anon_sym_DASH,
    ACTIONS(7210), 1,
      anon_sym_PLUS,
    ACTIONS(7212), 1,
      anon_sym_STAR,
    ACTIONS(7214), 1,
      anon_sym_SLASH,
    ACTIONS(7216), 1,
      anon_sym_PERCENT,
    ACTIONS(7218), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7222), 1,
      anon_sym_PIPE,
    ACTIONS(7224), 1,
      anon_sym_CARET,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7228), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7230), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7232), 1,
      anon_sym_GT,
    ACTIONS(7234), 1,
      anon_sym_GT_EQ,
    ACTIONS(7236), 1,
      anon_sym_LT_EQ,
    ACTIONS(7238), 1,
      anon_sym_LT,
    ACTIONS(7240), 1,
      anon_sym_LT_LT,
    ACTIONS(7242), 1,
      anon_sym_GT_GT,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7246), 1,
      anon_sym_QMARK,
    ACTIONS(7248), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7250), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7252), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7254), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7256), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7258), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7260), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7262), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7264), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7266), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7268), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7270), 1,
      anon_sym_or,
    ACTIONS(7272), 1,
      anon_sym_and,
    ACTIONS(7274), 1,
      anon_sym_bitor,
    ACTIONS(7276), 1,
      anon_sym_xor,
    ACTIONS(7278), 1,
      anon_sym_bitand,
    ACTIONS(7280), 1,
      anon_sym_not_eq,
    ACTIONS(7495), 1,
      anon_sym_RPAREN,
    STATE(1339), 1,
      sym__binary_fold_operator,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    STATE(8666), 1,
      sym__fold_operator,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [65901] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(9029), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [66009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5366), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5368), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [66071] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7284), 1,
      sym_identifier,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7290), 1,
      sym_primitive_type,
    ACTIONS(7292), 1,
      anon_sym_enum,
    ACTIONS(7294), 1,
      anon_sym_class,
    ACTIONS(7296), 1,
      anon_sym_struct,
    ACTIONS(7298), 1,
      anon_sym_union,
    ACTIONS(7300), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(5281), 1,
      sym_type_specifier,
    STATE(5342), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5945), 1,
      sym__type_definition_type,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3503), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7288), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [66179] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6601), 1,
      anon_sym___attribute__,
    STATE(3779), 1,
      sym_attribute_specifier,
    ACTIONS(5635), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5633), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [66245] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6601), 1,
      anon_sym___attribute__,
    STATE(3595), 1,
      sym_attribute_specifier,
    ACTIONS(5676), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5674), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [66311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5362), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5364), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [66373] = 53,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6969), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6971), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7202), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7204), 1,
      anon_sym_COMMA,
    ACTIONS(7208), 1,
      anon_sym_DASH,
    ACTIONS(7210), 1,
      anon_sym_PLUS,
    ACTIONS(7212), 1,
      anon_sym_STAR,
    ACTIONS(7214), 1,
      anon_sym_SLASH,
    ACTIONS(7216), 1,
      anon_sym_PERCENT,
    ACTIONS(7218), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7222), 1,
      anon_sym_PIPE,
    ACTIONS(7224), 1,
      anon_sym_CARET,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7228), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7230), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7232), 1,
      anon_sym_GT,
    ACTIONS(7234), 1,
      anon_sym_GT_EQ,
    ACTIONS(7236), 1,
      anon_sym_LT_EQ,
    ACTIONS(7238), 1,
      anon_sym_LT,
    ACTIONS(7240), 1,
      anon_sym_LT_LT,
    ACTIONS(7242), 1,
      anon_sym_GT_GT,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7246), 1,
      anon_sym_QMARK,
    ACTIONS(7248), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7250), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7252), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7254), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7256), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7258), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7260), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7262), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7264), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7266), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7268), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7270), 1,
      anon_sym_or,
    ACTIONS(7272), 1,
      anon_sym_and,
    ACTIONS(7274), 1,
      anon_sym_bitor,
    ACTIONS(7276), 1,
      anon_sym_xor,
    ACTIONS(7278), 1,
      anon_sym_bitand,
    ACTIONS(7280), 1,
      anon_sym_not_eq,
    ACTIONS(7497), 1,
      anon_sym_RPAREN,
    STATE(1339), 1,
      sym__binary_fold_operator,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    STATE(8666), 1,
      sym__fold_operator,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [66535] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6601), 1,
      anon_sym___attribute__,
    STATE(3793), 1,
      sym_attribute_specifier,
    ACTIONS(5700), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5698), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [66601] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7284), 1,
      sym_identifier,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7290), 1,
      sym_primitive_type,
    ACTIONS(7292), 1,
      anon_sym_enum,
    ACTIONS(7294), 1,
      anon_sym_class,
    ACTIONS(7296), 1,
      anon_sym_struct,
    ACTIONS(7298), 1,
      anon_sym_union,
    ACTIONS(7300), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(5281), 1,
      sym_type_specifier,
    STATE(5342), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5966), 1,
      sym__type_definition_type,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3503), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7288), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [66709] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6601), 1,
      anon_sym___attribute__,
    STATE(3593), 1,
      sym_attribute_specifier,
    ACTIONS(5658), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5656), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [66775] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(8668), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [66883] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3289), 1,
      anon_sym_LBRACE,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    STATE(3994), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5954), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5956), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [66951] = 53,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6969), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6971), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7202), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7204), 1,
      anon_sym_COMMA,
    ACTIONS(7208), 1,
      anon_sym_DASH,
    ACTIONS(7210), 1,
      anon_sym_PLUS,
    ACTIONS(7212), 1,
      anon_sym_STAR,
    ACTIONS(7214), 1,
      anon_sym_SLASH,
    ACTIONS(7216), 1,
      anon_sym_PERCENT,
    ACTIONS(7218), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7222), 1,
      anon_sym_PIPE,
    ACTIONS(7224), 1,
      anon_sym_CARET,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7228), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7230), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7232), 1,
      anon_sym_GT,
    ACTIONS(7234), 1,
      anon_sym_GT_EQ,
    ACTIONS(7236), 1,
      anon_sym_LT_EQ,
    ACTIONS(7238), 1,
      anon_sym_LT,
    ACTIONS(7240), 1,
      anon_sym_LT_LT,
    ACTIONS(7242), 1,
      anon_sym_GT_GT,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7246), 1,
      anon_sym_QMARK,
    ACTIONS(7248), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7250), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7252), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7254), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7256), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7258), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7260), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7262), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7264), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7266), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7268), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7270), 1,
      anon_sym_or,
    ACTIONS(7272), 1,
      anon_sym_and,
    ACTIONS(7274), 1,
      anon_sym_bitor,
    ACTIONS(7276), 1,
      anon_sym_xor,
    ACTIONS(7278), 1,
      anon_sym_bitand,
    ACTIONS(7280), 1,
      anon_sym_not_eq,
    ACTIONS(7499), 1,
      anon_sym_RPAREN,
    STATE(1339), 1,
      sym__binary_fold_operator,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    STATE(8666), 1,
      sym__fold_operator,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [67113] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6601), 1,
      anon_sym___attribute__,
    STATE(3809), 1,
      sym_attribute_specifier,
    ACTIONS(5723), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5721), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [67179] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6601), 1,
      anon_sym___attribute__,
    STATE(3811), 1,
      sym_attribute_specifier,
    ACTIONS(5716), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5714), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [67245] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8025), 1,
      sym_kernel_call_syntax,
    ACTIONS(7445), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6102), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6104), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [67323] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7501), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3372), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5986), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5988), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [67389] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6627), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6691), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(7431), 1,
      anon_sym_DASH_GT,
    ACTIONS(7504), 1,
      anon_sym_requires,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(5490), 1,
      sym__function_attributes_start,
    STATE(5643), 1,
      sym_ref_qualifier,
    STATE(6592), 1,
      sym__function_attributes_end,
    STATE(6741), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6619), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6700), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4312), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4485), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6177), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5747), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [67501] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7284), 1,
      sym_identifier,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7290), 1,
      sym_primitive_type,
    ACTIONS(7292), 1,
      anon_sym_enum,
    ACTIONS(7294), 1,
      anon_sym_class,
    ACTIONS(7296), 1,
      anon_sym_struct,
    ACTIONS(7298), 1,
      anon_sym_union,
    ACTIONS(7300), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(5281), 1,
      sym_type_specifier,
    STATE(5342), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5906), 1,
      sym__type_definition_type,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3503), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7288), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [67609] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8243), 1,
      sym_type_descriptor,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [67717] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8025), 1,
      sym_kernel_call_syntax,
    ACTIONS(7445), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7453), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7471), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7455), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [67801] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8025), 1,
      sym_kernel_call_syntax,
    ACTIONS(7445), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7453), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7455), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 14,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [67883] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(7475), 1,
      anon_sym_LT_EQ_GT,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8025), 1,
      sym_kernel_call_syntax,
    ACTIONS(7445), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7453), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7471), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7455), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [67969] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(7475), 1,
      anon_sym_LT_EQ_GT,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8025), 1,
      sym_kernel_call_syntax,
    ACTIONS(7445), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7453), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7471), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7455), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7469), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [68057] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(7475), 1,
      anon_sym_LT_EQ_GT,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8025), 1,
      sym_kernel_call_syntax,
    ACTIONS(7445), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7453), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7471), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7455), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7467), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7469), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [68147] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(7465), 1,
      anon_sym_AMP,
    ACTIONS(7475), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7483), 1,
      anon_sym_bitand,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8025), 1,
      sym_kernel_call_syntax,
    ACTIONS(7445), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7453), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7471), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7455), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7467), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7469), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [68241] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(7465), 1,
      anon_sym_AMP,
    ACTIONS(7475), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7483), 1,
      anon_sym_bitand,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8025), 1,
      sym_kernel_call_syntax,
    ACTIONS(7445), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7453), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7463), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7471), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7455), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7467), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7469), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 5,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6066), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [68337] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(7461), 1,
      anon_sym_PIPE,
    ACTIONS(7465), 1,
      anon_sym_AMP,
    ACTIONS(7475), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7481), 1,
      anon_sym_bitor,
    ACTIONS(7483), 1,
      anon_sym_bitand,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8025), 1,
      sym_kernel_call_syntax,
    ACTIONS(7445), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7453), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7463), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7471), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7455), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7467), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6064), 4,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7469), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [68437] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(7459), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7461), 1,
      anon_sym_PIPE,
    ACTIONS(7465), 1,
      anon_sym_AMP,
    ACTIONS(7475), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7479), 1,
      anon_sym_and,
    ACTIONS(7481), 1,
      anon_sym_bitor,
    ACTIONS(7483), 1,
      anon_sym_bitand,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8025), 1,
      sym_kernel_call_syntax,
    ACTIONS(7445), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7453), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7463), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7471), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6064), 3,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
    ACTIONS(7455), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7467), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7469), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [68541] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8025), 1,
      sym_kernel_call_syntax,
    ACTIONS(7445), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6064), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [68619] = 53,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6969), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6971), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7202), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7204), 1,
      anon_sym_COMMA,
    ACTIONS(7208), 1,
      anon_sym_DASH,
    ACTIONS(7210), 1,
      anon_sym_PLUS,
    ACTIONS(7212), 1,
      anon_sym_STAR,
    ACTIONS(7214), 1,
      anon_sym_SLASH,
    ACTIONS(7216), 1,
      anon_sym_PERCENT,
    ACTIONS(7218), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7222), 1,
      anon_sym_PIPE,
    ACTIONS(7224), 1,
      anon_sym_CARET,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7228), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7230), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7232), 1,
      anon_sym_GT,
    ACTIONS(7234), 1,
      anon_sym_GT_EQ,
    ACTIONS(7236), 1,
      anon_sym_LT_EQ,
    ACTIONS(7238), 1,
      anon_sym_LT,
    ACTIONS(7240), 1,
      anon_sym_LT_LT,
    ACTIONS(7242), 1,
      anon_sym_GT_GT,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7246), 1,
      anon_sym_QMARK,
    ACTIONS(7248), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7250), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7252), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7254), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7256), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7258), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7260), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7262), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7264), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7266), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7268), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7270), 1,
      anon_sym_or,
    ACTIONS(7272), 1,
      anon_sym_and,
    ACTIONS(7274), 1,
      anon_sym_bitor,
    ACTIONS(7276), 1,
      anon_sym_xor,
    ACTIONS(7278), 1,
      anon_sym_bitand,
    ACTIONS(7280), 1,
      anon_sym_not_eq,
    ACTIONS(7507), 1,
      anon_sym_RPAREN,
    STATE(1339), 1,
      sym__binary_fold_operator,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    STATE(8666), 1,
      sym__fold_operator,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [68781] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8025), 1,
      sym_kernel_call_syntax,
    ACTIONS(7445), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7455), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [68861] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(121), 1,
      sym_auto,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(3556), 1,
      sym_primitive_type,
    ACTIONS(7509), 1,
      sym_identifier,
    ACTIONS(7511), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7513), 1,
      anon_sym_enum,
    ACTIONS(7515), 1,
      anon_sym_class,
    ACTIONS(7517), 1,
      anon_sym_struct,
    ACTIONS(7519), 1,
      anon_sym_union,
    ACTIONS(7521), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2194), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(2507), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4051), 1,
      sym_type_specifier,
    STATE(6193), 1,
      sym_type_descriptor,
    STATE(6827), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2154), 2,
      sym_decltype,
      sym_template_type,
    STATE(3559), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3554), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2200), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [68969] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7284), 1,
      sym_identifier,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7290), 1,
      sym_primitive_type,
    ACTIONS(7292), 1,
      anon_sym_enum,
    ACTIONS(7294), 1,
      anon_sym_class,
    ACTIONS(7296), 1,
      anon_sym_struct,
    ACTIONS(7298), 1,
      anon_sym_union,
    ACTIONS(7300), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(5281), 1,
      sym_type_specifier,
    STATE(5342), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5922), 1,
      sym__type_definition_type,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3503), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7288), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [69077] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7523), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3390), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5986), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5988), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [69143] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7532), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7530), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(7528), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(7526), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [69209] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3289), 1,
      anon_sym_LBRACE,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    STATE(3990), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5964), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5966), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [69277] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6712), 1,
      anon_sym_LBRACK,
    STATE(3560), 1,
      sym_new_declarator,
    ACTIONS(6038), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6040), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [69343] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7284), 1,
      sym_identifier,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7290), 1,
      sym_primitive_type,
    ACTIONS(7292), 1,
      anon_sym_enum,
    ACTIONS(7294), 1,
      anon_sym_class,
    ACTIONS(7296), 1,
      anon_sym_struct,
    ACTIONS(7298), 1,
      anon_sym_union,
    ACTIONS(7300), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(5281), 1,
      sym_type_specifier,
    STATE(5342), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5933), 1,
      sym__type_definition_type,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3503), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7288), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [69451] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7284), 1,
      sym_identifier,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7290), 1,
      sym_primitive_type,
    ACTIONS(7292), 1,
      anon_sym_enum,
    ACTIONS(7294), 1,
      anon_sym_class,
    ACTIONS(7296), 1,
      anon_sym_struct,
    ACTIONS(7298), 1,
      anon_sym_union,
    ACTIONS(7300), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(5281), 1,
      sym_type_specifier,
    STATE(5342), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5964), 1,
      sym__type_definition_type,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3503), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7288), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [69559] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(7451), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7457), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7459), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7461), 1,
      anon_sym_PIPE,
    ACTIONS(7465), 1,
      anon_sym_AMP,
    ACTIONS(7473), 1,
      anon_sym_QMARK,
    ACTIONS(7475), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7477), 1,
      anon_sym_or,
    ACTIONS(7479), 1,
      anon_sym_and,
    ACTIONS(7481), 1,
      anon_sym_bitor,
    ACTIONS(7483), 1,
      anon_sym_bitand,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8025), 1,
      sym_kernel_call_syntax,
    ACTIONS(6374), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7445), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7453), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7463), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7471), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7455), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7467), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7469), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6376), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [69673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5248), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [69735] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7540), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7538), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(7536), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(7534), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [69801] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7284), 1,
      sym_identifier,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7290), 1,
      sym_primitive_type,
    ACTIONS(7292), 1,
      anon_sym_enum,
    ACTIONS(7294), 1,
      anon_sym_class,
    ACTIONS(7296), 1,
      anon_sym_struct,
    ACTIONS(7298), 1,
      anon_sym_union,
    ACTIONS(7300), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(5281), 1,
      sym_type_specifier,
    STATE(5342), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5897), 1,
      sym__type_definition_type,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3503), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7288), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [69909] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8450), 1,
      sym_type_descriptor,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [70017] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym_literal_suffix,
    STATE(2752), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(3594), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3598), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3766), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(3758), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [70087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5254), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5256), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [70149] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(9075), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [70257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5250), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5252), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [70319] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(8892), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [70427] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(121), 1,
      sym_auto,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(3544), 1,
      sym_identifier,
    ACTIONS(3552), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3556), 1,
      sym_primitive_type,
    ACTIONS(3558), 1,
      anon_sym_enum,
    ACTIONS(3560), 1,
      anon_sym_class,
    ACTIONS(3562), 1,
      anon_sym_struct,
    ACTIONS(3564), 1,
      anon_sym_union,
    ACTIONS(3566), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2194), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(2507), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4301), 1,
      sym_type_specifier,
    STATE(6193), 1,
      sym_type_descriptor,
    STATE(6810), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2154), 2,
      sym_decltype,
      sym_template_type,
    STATE(3522), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3554), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2200), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [70535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5248), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [70597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5238), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5240), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [70659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5214), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5216), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [70721] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym_literal_suffix,
    STATE(2752), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(3594), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3598), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5710), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(5712), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [70791] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7542), 1,
      anon_sym_LT,
    STATE(3496), 1,
      sym_template_argument_list,
    ACTIONS(6072), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6074), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [70859] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(8832), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [70967] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(121), 1,
      sym_auto,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(3556), 1,
      sym_primitive_type,
    ACTIONS(7509), 1,
      sym_identifier,
    ACTIONS(7511), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7513), 1,
      anon_sym_enum,
    ACTIONS(7515), 1,
      anon_sym_class,
    ACTIONS(7517), 1,
      anon_sym_struct,
    ACTIONS(7519), 1,
      anon_sym_union,
    ACTIONS(7521), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2194), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(2507), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4247), 1,
      sym_type_specifier,
    STATE(6193), 1,
      sym_type_descriptor,
    STATE(6827), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2154), 2,
      sym_decltype,
      sym_template_type,
    STATE(3515), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3554), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2200), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [71075] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(7457), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7459), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7461), 1,
      anon_sym_PIPE,
    ACTIONS(7465), 1,
      anon_sym_AMP,
    ACTIONS(7475), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7477), 1,
      anon_sym_or,
    ACTIONS(7479), 1,
      anon_sym_and,
    ACTIONS(7481), 1,
      anon_sym_bitor,
    ACTIONS(7483), 1,
      anon_sym_bitand,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8025), 1,
      sym_kernel_call_syntax,
    ACTIONS(6782), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7445), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7453), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7463), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7471), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7455), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7467), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7469), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6784), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [71183] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 1,
      anon_sym_LT,
    STATE(1831), 1,
      sym_template_argument_list,
    ACTIONS(6198), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6200), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [71249] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6068), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6070), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_kernel_call_syntax_token1,
  [71325] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(8154), 1,
      sym_kernel_call_syntax,
    ACTIONS(7340), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6052), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6054), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [71403] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6110), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6112), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [71481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5277), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5279), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [71543] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8567), 1,
      sym_type_descriptor,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [71651] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6627), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6990), 1,
      anon_sym_requires,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_DASH_GT,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(5494), 1,
      sym__function_attributes_start,
    STATE(5644), 1,
      sym_ref_qualifier,
    STATE(6478), 1,
      sym_trailing_return_type,
    STATE(6617), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6619), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4312), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4485), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6474), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5773), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [71763] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6106), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6108), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [71841] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8025), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6096), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6098), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [71917] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(7457), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7459), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7461), 1,
      anon_sym_PIPE,
    ACTIONS(7465), 1,
      anon_sym_AMP,
    ACTIONS(7475), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7477), 1,
      anon_sym_or,
    ACTIONS(7479), 1,
      anon_sym_and,
    ACTIONS(7481), 1,
      anon_sym_bitor,
    ACTIONS(7483), 1,
      anon_sym_bitand,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8025), 1,
      sym_kernel_call_syntax,
    ACTIONS(6720), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7445), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7453), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7463), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7471), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7455), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7467), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7469), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6722), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [72025] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7549), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6222), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6224), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [72089] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7045), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3372), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5968), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5970), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [72155] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8025), 1,
      sym_kernel_call_syntax,
    ACTIONS(7445), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6106), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6108), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [72233] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8025), 1,
      sym_kernel_call_syntax,
    ACTIONS(7445), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6110), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6112), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [72311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5315), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5317), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [72373] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7557), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7555), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(7553), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(7551), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [72439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5319), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5321), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [72501] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7284), 1,
      sym_identifier,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7290), 1,
      sym_primitive_type,
    ACTIONS(7292), 1,
      anon_sym_enum,
    ACTIONS(7294), 1,
      anon_sym_class,
    ACTIONS(7296), 1,
      anon_sym_struct,
    ACTIONS(7298), 1,
      anon_sym_union,
    ACTIONS(7300), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(5281), 1,
      sym_type_specifier,
    STATE(5342), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5940), 1,
      sym__type_definition_type,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3503), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7288), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [72609] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4007), 1,
      anon_sym_LBRACE,
    ACTIONS(5200), 1,
      anon_sym_LT,
    STATE(3521), 1,
      sym_template_argument_list,
    ACTIONS(4009), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4002), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [72679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5340), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5342), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [72741] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4830), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(8919), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3577), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [72849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5352), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [72911] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_type_descriptor,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [73019] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6720), 1,
      anon_sym_EQ,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(7563), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7565), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7567), 1,
      anon_sym_PIPE,
    ACTIONS(7571), 1,
      anon_sym_AMP,
    ACTIONS(7577), 1,
      anon_sym_GT_EQ,
    ACTIONS(7581), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7583), 1,
      anon_sym_or,
    ACTIONS(7585), 1,
      anon_sym_and,
    ACTIONS(7587), 1,
      anon_sym_bitor,
    ACTIONS(7589), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7559), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7569), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7579), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7561), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7573), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7575), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6722), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      aux_sym_kernel_call_syntax_token1,
  [73129] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6627), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6842), 1,
      anon_sym_requires,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_DASH_GT,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(5520), 1,
      sym__function_attributes_start,
    STATE(5638), 1,
      sym_ref_qualifier,
    STATE(6429), 1,
      sym_trailing_return_type,
    STATE(6647), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6619), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6635), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4312), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4485), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6474), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5776), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [73241] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4007), 1,
      anon_sym_LBRACE,
    ACTIONS(7591), 1,
      anon_sym_LT,
    STATE(3524), 1,
      sym_template_argument_list,
    ACTIONS(4009), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4002), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [73311] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6096), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6098), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_kernel_call_syntax_token1,
  [73387] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(7186), 1,
      sym_primitive_type,
    ACTIONS(7196), 1,
      sym_auto,
    ACTIONS(7198), 1,
      anon_sym_decltype,
    ACTIONS(7356), 1,
      sym_identifier,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7360), 1,
      anon_sym_enum,
    ACTIONS(7362), 1,
      anon_sym_class,
    ACTIONS(7364), 1,
      anon_sym_struct,
    ACTIONS(7366), 1,
      anon_sym_union,
    ACTIONS(7368), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(4087), 1,
      sym_type_specifier,
    STATE(4292), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4799), 1,
      sym_decltype_auto,
    STATE(6193), 1,
      sym_type_descriptor,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2154), 2,
      sym_decltype,
      sym_template_type,
    STATE(3578), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7184), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4932), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [73495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5192), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5194), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [73557] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8067), 1,
      sym_type_descriptor,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [73665] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8025), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6068), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6070), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [73741] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7485), 1,
      anon_sym_LT,
    STATE(906), 1,
      sym_template_argument_list,
    ACTIONS(6198), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6200), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [73807] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4830), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(8839), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3577), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [73915] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7051), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3390), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5968), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5970), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [73981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5192), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5194), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [74043] = 53,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(6969), 1,
      anon_sym_DOT_STAR,
    ACTIONS(6971), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7202), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7204), 1,
      anon_sym_COMMA,
    ACTIONS(7208), 1,
      anon_sym_DASH,
    ACTIONS(7210), 1,
      anon_sym_PLUS,
    ACTIONS(7212), 1,
      anon_sym_STAR,
    ACTIONS(7214), 1,
      anon_sym_SLASH,
    ACTIONS(7216), 1,
      anon_sym_PERCENT,
    ACTIONS(7218), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7222), 1,
      anon_sym_PIPE,
    ACTIONS(7224), 1,
      anon_sym_CARET,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7228), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7230), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7232), 1,
      anon_sym_GT,
    ACTIONS(7234), 1,
      anon_sym_GT_EQ,
    ACTIONS(7236), 1,
      anon_sym_LT_EQ,
    ACTIONS(7238), 1,
      anon_sym_LT,
    ACTIONS(7240), 1,
      anon_sym_LT_LT,
    ACTIONS(7242), 1,
      anon_sym_GT_GT,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7246), 1,
      anon_sym_QMARK,
    ACTIONS(7248), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7250), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7252), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7254), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7256), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7258), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7260), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7262), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7264), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7266), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7268), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7270), 1,
      anon_sym_or,
    ACTIONS(7272), 1,
      anon_sym_and,
    ACTIONS(7274), 1,
      anon_sym_bitor,
    ACTIONS(7276), 1,
      anon_sym_xor,
    ACTIONS(7278), 1,
      anon_sym_bitand,
    ACTIONS(7280), 1,
      anon_sym_not_eq,
    ACTIONS(7594), 1,
      anon_sym_RPAREN,
    STATE(1339), 1,
      sym__binary_fold_operator,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    STATE(8666), 1,
      sym__fold_operator,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [74205] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8411), 1,
      sym_type_descriptor,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [74313] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8448), 1,
      sym_type_descriptor,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [74421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5301), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5303), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [74483] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7559), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7561), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [74565] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(8914), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [74673] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6782), 1,
      anon_sym_EQ,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(7563), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7565), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7567), 1,
      anon_sym_PIPE,
    ACTIONS(7571), 1,
      anon_sym_AMP,
    ACTIONS(7577), 1,
      anon_sym_GT_EQ,
    ACTIONS(7581), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7583), 1,
      anon_sym_or,
    ACTIONS(7585), 1,
      anon_sym_and,
    ACTIONS(7587), 1,
      anon_sym_bitor,
    ACTIONS(7589), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7559), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7569), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7579), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7561), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7573), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7575), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6784), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      aux_sym_kernel_call_syntax_token1,
  [74783] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6193), 1,
      sym_type_descriptor,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [74891] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4830), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(8901), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3577), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [74999] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6374), 1,
      anon_sym_EQ,
    ACTIONS(6756), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(7563), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7565), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7567), 1,
      anon_sym_PIPE,
    ACTIONS(7571), 1,
      anon_sym_AMP,
    ACTIONS(7577), 1,
      anon_sym_GT_EQ,
    ACTIONS(7581), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7583), 1,
      anon_sym_or,
    ACTIONS(7585), 1,
      anon_sym_and,
    ACTIONS(7587), 1,
      anon_sym_bitor,
    ACTIONS(7589), 1,
      anon_sym_bitand,
    ACTIONS(7596), 1,
      anon_sym_QMARK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7559), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7569), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7579), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7561), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7573), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7575), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6376), 15,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [75115] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(8857), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [75223] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8408), 1,
      sym_type_descriptor,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [75331] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7561), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [75411] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6601), 1,
      anon_sym___attribute__,
    STATE(3706), 1,
      sym_attribute_specifier,
    ACTIONS(5684), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5682), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [75477] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6064), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [75555] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(7565), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7567), 1,
      anon_sym_PIPE,
    ACTIONS(7571), 1,
      anon_sym_AMP,
    ACTIONS(7577), 1,
      anon_sym_GT_EQ,
    ACTIONS(7581), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7585), 1,
      anon_sym_and,
    ACTIONS(7587), 1,
      anon_sym_bitor,
    ACTIONS(7589), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6064), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7559), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7569), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7579), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7561), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7573), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7575), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      aux_sym_kernel_call_syntax_token1,
  [75661] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6754), 1,
      anon_sym_EQ,
    ACTIONS(6756), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(7563), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7565), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7567), 1,
      anon_sym_PIPE,
    ACTIONS(7571), 1,
      anon_sym_AMP,
    ACTIONS(7577), 1,
      anon_sym_GT_EQ,
    ACTIONS(7581), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7583), 1,
      anon_sym_or,
    ACTIONS(7585), 1,
      anon_sym_and,
    ACTIONS(7587), 1,
      anon_sym_bitor,
    ACTIONS(7589), 1,
      anon_sym_bitand,
    ACTIONS(7596), 1,
      anon_sym_QMARK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7559), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7569), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7579), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7561), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7573), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7575), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6758), 15,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [75777] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6764), 1,
      anon_sym_EQ,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(7563), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7565), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7567), 1,
      anon_sym_PIPE,
    ACTIONS(7571), 1,
      anon_sym_AMP,
    ACTIONS(7577), 1,
      anon_sym_GT_EQ,
    ACTIONS(7581), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7583), 1,
      anon_sym_or,
    ACTIONS(7585), 1,
      anon_sym_and,
    ACTIONS(7587), 1,
      anon_sym_bitor,
    ACTIONS(7589), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7559), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7569), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7579), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7561), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7573), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7575), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6766), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      aux_sym_kernel_call_syntax_token1,
  [75887] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4830), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(8862), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3577), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [75995] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(7567), 1,
      anon_sym_PIPE,
    ACTIONS(7571), 1,
      anon_sym_AMP,
    ACTIONS(7577), 1,
      anon_sym_GT_EQ,
    ACTIONS(7581), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7587), 1,
      anon_sym_bitor,
    ACTIONS(7589), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7559), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7569), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7579), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6064), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7561), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7573), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7575), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      aux_sym_kernel_call_syntax_token1,
  [76097] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6601), 1,
      anon_sym___attribute__,
    STATE(3696), 1,
      sym_attribute_specifier,
    ACTIONS(5670), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5668), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [76163] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(8896), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [76271] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7598), 1,
      anon_sym_typedef,
    ACTIONS(2588), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2586), 51,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_typename,
      anon_sym_template,
      anon_sym___launch_bounds__,
  [76335] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6756), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6768), 1,
      anon_sym_EQ,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(7563), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7565), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7567), 1,
      anon_sym_PIPE,
    ACTIONS(7571), 1,
      anon_sym_AMP,
    ACTIONS(7577), 1,
      anon_sym_GT_EQ,
    ACTIONS(7581), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7583), 1,
      anon_sym_or,
    ACTIONS(7585), 1,
      anon_sym_and,
    ACTIONS(7587), 1,
      anon_sym_bitor,
    ACTIONS(7589), 1,
      anon_sym_bitand,
    ACTIONS(7596), 1,
      anon_sym_QMARK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7559), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7569), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7579), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7561), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7573), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7575), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6770), 15,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [76451] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8603), 1,
      sym_type_descriptor,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [76559] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(7571), 1,
      anon_sym_AMP,
    ACTIONS(7577), 1,
      anon_sym_GT_EQ,
    ACTIONS(7581), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7589), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7559), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7569), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7579), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7561), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7573), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7575), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6066), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      aux_sym_kernel_call_syntax_token1,
  [76657] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6601), 1,
      anon_sym___attribute__,
    STATE(3691), 1,
      sym_attribute_specifier,
    ACTIONS(5629), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5627), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [76723] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6756), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6853), 1,
      anon_sym_GT_EQ,
    ACTIONS(6857), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6859), 1,
      anon_sym_AMP,
    ACTIONS(6861), 1,
      anon_sym_bitand,
    ACTIONS(6865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6869), 1,
      anon_sym_PIPE,
    ACTIONS(6871), 1,
      anon_sym_or,
    ACTIONS(6873), 1,
      anon_sym_and,
    ACTIONS(6875), 1,
      anon_sym_bitor,
    ACTIONS(6973), 1,
      anon_sym_RPAREN,
    ACTIONS(6975), 1,
      anon_sym_QMARK,
    ACTIONS(7600), 1,
      anon_sym_COMMA,
    ACTIONS(7602), 1,
      anon_sym_EQ,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6845), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6855), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6863), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6847), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6849), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6851), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6949), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [76843] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6601), 1,
      anon_sym___attribute__,
    STATE(3690), 1,
      sym_attribute_specifier,
    ACTIONS(5727), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5725), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [76909] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6772), 1,
      anon_sym_EQ,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(7563), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7565), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7567), 1,
      anon_sym_PIPE,
    ACTIONS(7571), 1,
      anon_sym_AMP,
    ACTIONS(7577), 1,
      anon_sym_GT_EQ,
    ACTIONS(7581), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7583), 1,
      anon_sym_or,
    ACTIONS(7585), 1,
      anon_sym_and,
    ACTIONS(7587), 1,
      anon_sym_bitor,
    ACTIONS(7589), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7559), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7569), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7579), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7561), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7573), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7575), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6774), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      aux_sym_kernel_call_syntax_token1,
  [77019] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4830), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(8882), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3577), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [77127] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(7571), 1,
      anon_sym_AMP,
    ACTIONS(7577), 1,
      anon_sym_GT_EQ,
    ACTIONS(7581), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7589), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7559), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7579), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7561), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7573), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7575), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      aux_sym_kernel_call_syntax_token1,
  [77223] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(7577), 1,
      anon_sym_GT_EQ,
    ACTIONS(7581), 1,
      anon_sym_LT_EQ_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7559), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7579), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7561), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7573), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7575), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      aux_sym_kernel_call_syntax_token1,
  [77315] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4587), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(8877), 1,
      sym_type_descriptor,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(3568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [77423] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(7577), 1,
      anon_sym_GT_EQ,
    ACTIONS(7581), 1,
      anon_sym_LT_EQ_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7559), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7579), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7561), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7575), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [77513] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(7581), 1,
      anon_sym_LT_EQ_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7559), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7579), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7561), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [77599] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6102), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6104), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [77677] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8019), 1,
      sym_kernel_call_syntax,
    ACTIONS(6058), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7559), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7579), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7561), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6066), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [77761] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7604), 1,
      anon_sym_typedef,
    ACTIONS(2588), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2586), 51,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_typename,
      anon_sym_template,
      anon_sym___launch_bounds__,
  [77825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1978), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1976), 51,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_typename,
      anon_sym_template,
      anon_sym___launch_bounds__,
  [77886] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7148), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7606), 1,
      anon_sym_STAR,
    ACTIONS(7608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7610), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2909), 1,
      sym_parameter_list,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6554), 1,
      sym__abstract_declarator,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7150), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7152), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3169), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4364), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5504), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [77983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6981), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6983), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [78044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5203), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5205), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [78105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1982), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1980), 51,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_typename,
      anon_sym_template,
      anon_sym___launch_bounds__,
  [78166] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2344), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2342), 51,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_typename,
      anon_sym_template,
      anon_sym___launch_bounds__,
  [78227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5386), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5388), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [78288] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6079), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6081), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [78351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5374), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5376), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [78412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2062), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2060), 51,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_typename,
      anon_sym_template,
      anon_sym___launch_bounds__,
  [78473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2459), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2457), 51,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_typename,
      anon_sym_template,
      anon_sym___launch_bounds__,
  [78534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5358), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5360), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [78595] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    STATE(1651), 1,
      sym_template_argument_list,
    STATE(3856), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7612), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5530), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5532), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [78664] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7148), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7606), 1,
      anon_sym_STAR,
    ACTIONS(7608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7610), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2909), 1,
      sym_parameter_list,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6544), 1,
      sym__abstract_declarator,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7150), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7152), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3490), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4453), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5484), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [78761] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7284), 1,
      sym_identifier,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7290), 1,
      sym_primitive_type,
    ACTIONS(7292), 1,
      anon_sym_enum,
    ACTIONS(7294), 1,
      anon_sym_class,
    ACTIONS(7296), 1,
      anon_sym_struct,
    ACTIONS(7298), 1,
      anon_sym_union,
    ACTIONS(7300), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(5264), 1,
      sym_type_specifier,
    STATE(5342), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7288), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [78866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6028), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6030), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [78927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5958), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5960), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [78988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5945), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5947), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [79049] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7614), 1,
      anon_sym_LT,
    STATE(1852), 1,
      sym_template_argument_list,
    ACTIONS(6198), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6200), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [79114] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7614), 1,
      anon_sym_LT,
    STATE(3307), 1,
      sym_template_argument_list,
    ACTIONS(6198), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6200), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [79179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6222), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6224), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [79240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6461), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6463), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [79301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5751), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5749), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [79362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1950), 51,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_typename,
      anon_sym_template,
      anon_sym___launch_bounds__,
  [79423] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2727), 1,
      anon_sym_enum,
    ACTIONS(2729), 1,
      anon_sym_class,
    ACTIONS(2731), 1,
      anon_sym_struct,
    ACTIONS(2733), 1,
      anon_sym_union,
    ACTIONS(2757), 1,
      sym_auto,
    ACTIONS(2759), 1,
      anon_sym_decltype,
    ACTIONS(2761), 1,
      anon_sym_typename,
    ACTIONS(7435), 1,
      sym_identifier,
    ACTIONS(7437), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7439), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2157), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2557), 1,
      sym_qualified_type_identifier,
    STATE(2598), 1,
      sym_decltype_auto,
    STATE(4412), 1,
      sym_type_specifier,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2477), 2,
      sym_decltype,
      sym_template_type,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2723), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2599), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [79528] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3652), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3654), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [79589] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(121), 1,
      sym_auto,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(3556), 1,
      sym_primitive_type,
    ACTIONS(7509), 1,
      sym_identifier,
    ACTIONS(7511), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7513), 1,
      anon_sym_enum,
    ACTIONS(7515), 1,
      anon_sym_class,
    ACTIONS(7517), 1,
      anon_sym_struct,
    ACTIONS(7519), 1,
      anon_sym_union,
    ACTIONS(7521), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2194), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(2507), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4214), 1,
      sym_type_specifier,
    STATE(6827), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2154), 2,
      sym_decltype,
      sym_template_type,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3554), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2200), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [79694] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7148), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7617), 1,
      anon_sym_STAR,
    ACTIONS(7619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7621), 1,
      anon_sym_AMP,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6553), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7150), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7152), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3169), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4438), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5504), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [79791] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym_literal_suffix,
    ACTIONS(3766), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(3758), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [79854] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(7186), 1,
      sym_primitive_type,
    ACTIONS(7196), 1,
      sym_auto,
    ACTIONS(7198), 1,
      anon_sym_decltype,
    ACTIONS(7356), 1,
      sym_identifier,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7360), 1,
      anon_sym_enum,
    ACTIONS(7362), 1,
      anon_sym_class,
    ACTIONS(7364), 1,
      anon_sym_struct,
    ACTIONS(7366), 1,
      anon_sym_union,
    ACTIONS(7368), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(4238), 1,
      sym_type_specifier,
    STATE(4292), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4799), 1,
      sym_decltype_auto,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2154), 2,
      sym_decltype,
      sym_template_type,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7184), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4932), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [79959] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7623), 1,
      anon_sym_LT,
    STATE(3615), 1,
      sym_template_argument_list,
    ACTIONS(6126), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6128), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [80026] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym_literal_suffix,
    ACTIONS(5710), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(5712), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [80089] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4149), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4151), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4144), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [80152] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(121), 1,
      sym_auto,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(3544), 1,
      sym_identifier,
    ACTIONS(3552), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3556), 1,
      sym_primitive_type,
    ACTIONS(3558), 1,
      anon_sym_enum,
    ACTIONS(3560), 1,
      anon_sym_class,
    ACTIONS(3562), 1,
      anon_sym_struct,
    ACTIONS(3564), 1,
      anon_sym_union,
    ACTIONS(3566), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2194), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(2507), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4297), 1,
      sym_type_specifier,
    STATE(6810), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2154), 2,
      sym_decltype,
      sym_template_type,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3554), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2200), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [80257] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7148), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7617), 1,
      anon_sym_STAR,
    ACTIONS(7619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7621), 1,
      anon_sym_AMP,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6530), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7150), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7152), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3516), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4375), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5484), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [80354] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4149), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4151), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4144), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [80417] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5743), 1,
      anon_sym_LPAREN2,
    ACTIONS(5746), 1,
      anon_sym_LBRACK,
    ACTIONS(3766), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3758), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [80484] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4324), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [80589] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(7186), 1,
      sym_primitive_type,
    ACTIONS(7196), 1,
      sym_auto,
    ACTIONS(7198), 1,
      anon_sym_decltype,
    ACTIONS(7356), 1,
      sym_identifier,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7360), 1,
      anon_sym_enum,
    ACTIONS(7362), 1,
      anon_sym_class,
    ACTIONS(7364), 1,
      anon_sym_struct,
    ACTIONS(7366), 1,
      anon_sym_union,
    ACTIONS(7368), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(4058), 1,
      sym_type_specifier,
    STATE(4292), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4799), 1,
      sym_decltype_auto,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2154), 2,
      sym_decltype,
      sym_template_type,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7184), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4932), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [80694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6366), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6368), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [80755] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(7402), 1,
      sym_identifier,
    ACTIONS(7404), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7408), 1,
      sym_primitive_type,
    ACTIONS(7410), 1,
      anon_sym_enum,
    ACTIONS(7412), 1,
      anon_sym_class,
    ACTIONS(7414), 1,
      anon_sym_struct,
    ACTIONS(7416), 1,
      anon_sym_union,
    ACTIONS(7418), 1,
      sym_auto,
    ACTIONS(7420), 1,
      anon_sym_decltype,
    ACTIONS(7422), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(4153), 1,
      sym_type_specifier,
    STATE(4392), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5173), 1,
      sym_qualified_type_identifier,
    STATE(5240), 1,
      sym_decltype_auto,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5166), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7406), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5243), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [80860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6366), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6368), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [80921] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2727), 1,
      anon_sym_enum,
    ACTIONS(2729), 1,
      anon_sym_class,
    ACTIONS(2731), 1,
      anon_sym_struct,
    ACTIONS(2733), 1,
      anon_sym_union,
    ACTIONS(2757), 1,
      sym_auto,
    ACTIONS(2759), 1,
      anon_sym_decltype,
    ACTIONS(2761), 1,
      anon_sym_typename,
    ACTIONS(7435), 1,
      sym_identifier,
    ACTIONS(7437), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7439), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2157), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2557), 1,
      sym_qualified_type_identifier,
    STATE(2598), 1,
      sym_decltype_auto,
    STATE(4556), 1,
      sym_type_specifier,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2477), 2,
      sym_decltype,
      sym_template_type,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2723), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2599), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [81026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4002), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [81087] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(7180), 1,
      sym_identifier,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7186), 1,
      sym_primitive_type,
    ACTIONS(7188), 1,
      anon_sym_enum,
    ACTIONS(7190), 1,
      anon_sym_class,
    ACTIONS(7192), 1,
      anon_sym_struct,
    ACTIONS(7194), 1,
      anon_sym_union,
    ACTIONS(7196), 1,
      sym_auto,
    ACTIONS(7198), 1,
      anon_sym_decltype,
    ACTIONS(7200), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(4292), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4463), 1,
      sym_type_specifier,
    STATE(4799), 1,
      sym_decltype_auto,
    STATE(6845), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2154), 2,
      sym_decltype,
      sym_template_type,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7184), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4932), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [81192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4002), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [81253] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5743), 1,
      anon_sym_LPAREN2,
    ACTIONS(5746), 1,
      anon_sym_LBRACK,
    ACTIONS(3766), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3758), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [81320] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7626), 1,
      sym_identifier,
    STATE(3536), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(7629), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(7632), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5269), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5267), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [81389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2420), 51,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_typename,
      anon_sym_template,
      anon_sym___launch_bounds__,
  [81450] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3794), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(3766), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3758), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [81515] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5921), 1,
      anon_sym_LBRACE,
    ACTIONS(7635), 1,
      anon_sym_COLON,
    STATE(2184), 1,
      sym_attribute_specifier,
    STATE(2363), 1,
      sym__enum_base_clause,
    STATE(2517), 1,
      sym_enumerator_list,
    ACTIONS(6050), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6048), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [81588] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 1,
      sym_literal_suffix,
    ACTIONS(5710), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5712), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [81651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4002), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [81712] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6173), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6175), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [81773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5218), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5220), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [81834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5751), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5749), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [81895] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7637), 1,
      sym_identifier,
    STATE(3536), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(5812), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5814), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5309), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5307), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [81964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5242), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5244), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [82025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3648), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3650), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [82086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4002), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [82147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4002), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [82208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5996), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5998), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [82269] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7639), 1,
      anon_sym_LT,
    STATE(3709), 1,
      sym_template_argument_list,
    ACTIONS(6126), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6128), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [82336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5234), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5236), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [82397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6000), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6002), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [82458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5982), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5984), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [82519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6020), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6022), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [82580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6004), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6006), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [82641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5972), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5974), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [82702] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6008), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6010), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [82763] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(121), 1,
      sym_auto,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(3556), 1,
      sym_primitive_type,
    ACTIONS(7509), 1,
      sym_identifier,
    ACTIONS(7511), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7513), 1,
      anon_sym_enum,
    ACTIONS(7515), 1,
      anon_sym_class,
    ACTIONS(7517), 1,
      anon_sym_struct,
    ACTIONS(7519), 1,
      anon_sym_union,
    ACTIONS(7521), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2194), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(2507), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4062), 1,
      sym_type_specifier,
    STATE(6827), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2154), 2,
      sym_decltype,
      sym_template_type,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3554), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2200), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [82868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6165), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [82929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5976), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5978), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [82990] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7642), 1,
      sym_identifier,
    STATE(3545), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(5812), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5814), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5348), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5346), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [83059] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6222), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6224), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [83120] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(4810), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5743), 1,
      anon_sym_LPAREN2,
    ACTIONS(5746), 1,
      anon_sym_LBRACK,
    ACTIONS(3794), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(3766), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3758), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [83191] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6788), 1,
      anon_sym_LBRACK,
    STATE(3801), 1,
      sym_new_declarator,
    ACTIONS(6038), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6040), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [83256] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4503), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [83361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6155), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6157), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [83422] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4538), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [83527] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5746), 1,
      anon_sym_LBRACK,
    ACTIONS(5743), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    ACTIONS(3766), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3758), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [83594] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7000), 1,
      sym_auto,
    ACTIONS(7002), 1,
      anon_sym_decltype,
    STATE(3817), 1,
      sym_decltype_auto,
    ACTIONS(5171), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5173), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [83661] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7644), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6222), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6224), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [83724] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7646), 1,
      anon_sym_LT,
    STATE(3709), 1,
      sym_template_argument_list,
    ACTIONS(6072), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6074), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [83791] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5921), 1,
      anon_sym_LBRACE,
    ACTIONS(7635), 1,
      anon_sym_COLON,
    STATE(2175), 1,
      sym_attribute_specifier,
    STATE(2358), 1,
      sym__enum_base_clause,
    STATE(2478), 1,
      sym_enumerator_list,
    ACTIONS(6044), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6042), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [83864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6230), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6232), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [83925] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5746), 1,
      anon_sym_LBRACK,
    ACTIONS(5743), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    ACTIONS(3766), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3758), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [83992] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5192), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5194), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [84055] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4965), 1,
      sym_type_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [84160] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(7186), 1,
      sym_primitive_type,
    ACTIONS(7196), 1,
      sym_auto,
    ACTIONS(7198), 1,
      anon_sym_decltype,
    ACTIONS(7356), 1,
      sym_identifier,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7360), 1,
      anon_sym_enum,
    ACTIONS(7362), 1,
      anon_sym_class,
    ACTIONS(7364), 1,
      anon_sym_struct,
    ACTIONS(7366), 1,
      anon_sym_union,
    ACTIONS(7368), 1,
      anon_sym_typename,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(4059), 1,
      sym_type_specifier,
    STATE(4292), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4799), 1,
      sym_decltype_auto,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2154), 2,
      sym_decltype,
      sym_template_type,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7184), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4932), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [84265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6981), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(6983), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [84326] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 1,
      anon_sym_LT,
    STATE(991), 1,
      sym_template_argument_list,
    ACTIONS(6198), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6200), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [84391] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7485), 1,
      anon_sym_LT,
    STATE(990), 1,
      sym_template_argument_list,
    ACTIONS(6198), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6200), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [84456] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 1,
      sym_literal_suffix,
    ACTIONS(3766), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3758), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [84519] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6826), 1,
      anon_sym_LBRACK,
    STATE(3605), 1,
      sym_new_declarator,
    ACTIONS(6038), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6040), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [84584] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(7649), 1,
      anon_sym___attribute__,
    ACTIONS(7651), 1,
      anon_sym_LBRACE,
    STATE(4314), 1,
      sym_field_declaration_list,
    STATE(4358), 1,
      sym_attribute_specifier,
    STATE(7201), 1,
      sym_virtual_specifier,
    STATE(7925), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5508), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5506), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [84661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4002), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [84722] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7653), 1,
      anon_sym_LT,
    STATE(3615), 1,
      sym_template_argument_list,
    ACTIONS(6072), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6074), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [84789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4953), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4955), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [84849] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7268), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    ACTIONS(7666), 1,
      anon_sym_GT_EQ,
    ACTIONS(7670), 1,
      anon_sym_bitand,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7656), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7668), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6064), 3,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
    ACTIONS(7658), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7662), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7664), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [84943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5972), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5974), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [85003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6020), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6022), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [85063] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5808), 1,
      anon_sym_EQ,
    ACTIONS(5810), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(3766), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3758), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [85127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5982), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5984), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [85187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5297), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5299), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [85247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6000), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6002), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [85307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5311), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5313), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [85367] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7672), 1,
      sym_identifier,
    STATE(3596), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(7675), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(7678), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5269), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5267), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [85435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6493), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6495), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [85495] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6782), 1,
      anon_sym_EQ,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7268), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    ACTIONS(7666), 1,
      anon_sym_GT_EQ,
    ACTIONS(7670), 1,
      anon_sym_bitand,
    ACTIONS(7685), 1,
      anon_sym_PIPE,
    ACTIONS(7687), 1,
      anon_sym_CARET,
    ACTIONS(7689), 1,
      anon_sym_bitor,
    ACTIONS(7691), 1,
      anon_sym_xor,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7656), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7668), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7683), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7658), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7662), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7664), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6784), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [85601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6497), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6499), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [85661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6501), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6503), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [85721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6513), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6515), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [85781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6360), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [85841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6004), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6006), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [85901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5976), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5978), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [85961] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6165), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [86021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1897), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(1895), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [86081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5996), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5998), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [86141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6517), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6519), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [86201] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6663), 1,
      anon_sym_STAR,
    ACTIONS(6665), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6667), 1,
      anon_sym_AMP,
    ACTIONS(6669), 1,
      anon_sym_COLON_COLON,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6119), 1,
      sym__scope_resolution,
    STATE(6891), 1,
      sym__declarator,
    STATE(8440), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [86299] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1897), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1895), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [86359] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2120), 1,
      anon_sym_STAR,
    ACTIONS(2122), 1,
      anon_sym_AMP,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(5631), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6094), 1,
      sym__scope_resolution,
    STATE(6714), 1,
      sym__declarator,
    STATE(8796), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [86457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5214), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5216), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [86517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5238), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5240), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [86577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5462), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5464), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [86637] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6079), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6081), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [86699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6981), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6983), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [86759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4949), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4951), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [86819] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6663), 1,
      anon_sym_STAR,
    ACTIONS(6665), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6667), 1,
      anon_sym_AMP,
    ACTIONS(6669), 1,
      anon_sym_COLON_COLON,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6119), 1,
      sym__scope_resolution,
    STATE(6906), 1,
      sym__declarator,
    STATE(8440), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [86917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5751), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5749), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [86977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6139), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6141), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [87037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5248), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [87097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6173), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6175), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [87157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6509), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6511), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [87217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5250), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5252), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [87277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5254), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5256), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [87337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5145), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5147), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [87397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5248), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [87457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5248), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [87517] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7693), 1,
      anon_sym_LT,
    STATE(3524), 1,
      sym_template_argument_list,
    ACTIONS(6198), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6200), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [87581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3766), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3758), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [87641] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7485), 1,
      anon_sym_LT,
    STATE(1012), 1,
      sym_template_argument_list,
    ACTIONS(6198), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6200), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [87705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6457), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6459), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [87765] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6754), 1,
      anon_sym_EQ,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7202), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7246), 1,
      anon_sym_QMARK,
    ACTIONS(7268), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    ACTIONS(7666), 1,
      anon_sym_GT_EQ,
    ACTIONS(7670), 1,
      anon_sym_bitand,
    ACTIONS(7685), 1,
      anon_sym_PIPE,
    ACTIONS(7687), 1,
      anon_sym_CARET,
    ACTIONS(7689), 1,
      anon_sym_bitor,
    ACTIONS(7691), 1,
      anon_sym_xor,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7656), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7668), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7683), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7658), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7662), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7664), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6758), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [87877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6266), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6268), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [87937] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_EQ,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7202), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7246), 1,
      anon_sym_QMARK,
    ACTIONS(7268), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    ACTIONS(7666), 1,
      anon_sym_GT_EQ,
    ACTIONS(7670), 1,
      anon_sym_bitand,
    ACTIONS(7685), 1,
      anon_sym_PIPE,
    ACTIONS(7687), 1,
      anon_sym_CARET,
    ACTIONS(7689), 1,
      anon_sym_bitor,
    ACTIONS(7691), 1,
      anon_sym_xor,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7656), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7668), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7683), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7658), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7662), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7664), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6376), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [88049] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_AMP,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6475), 1,
      sym__declarator,
    STATE(8511), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [88147] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6747), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [88245] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7696), 1,
      sym_identifier,
    STATE(3834), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(4846), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4848), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5307), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(5309), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
  [88313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4941), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4943), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [88373] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2120), 1,
      anon_sym_STAR,
    ACTIONS(2122), 1,
      anon_sym_AMP,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(5631), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6094), 1,
      sym__scope_resolution,
    STATE(6764), 1,
      sym__declarator,
    STATE(8796), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [88471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6328), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6330), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [88531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6173), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6175), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [88591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5996), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5998), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [88651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4947), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [88711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6537), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6539), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [88771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4947), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [88831] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4009), 1,
      anon_sym_LBRACK,
    ACTIONS(5534), 1,
      anon_sym_LT,
    STATE(4112), 1,
      sym_template_argument_list,
    ACTIONS(4004), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4007), 3,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
    ACTIONS(4000), 43,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [88901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6004), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6006), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [88961] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4947), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [89021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6008), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6010), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [89081] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6591), 1,
      anon_sym_STAR,
    ACTIONS(6593), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6595), 1,
      anon_sym_AMP,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6666), 1,
      sym__declarator,
    STATE(8387), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [89179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4929), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4931), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [89239] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6663), 1,
      anon_sym_STAR,
    ACTIONS(6665), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6667), 1,
      anon_sym_AMP,
    ACTIONS(6669), 1,
      anon_sym_COLON_COLON,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6119), 1,
      sym__scope_resolution,
    STATE(6889), 1,
      sym__declarator,
    STATE(8440), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [89337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6282), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6284), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [89397] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7698), 1,
      sym_identifier,
    STATE(3596), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(5883), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5885), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5309), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5307), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [89465] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    ACTIONS(6996), 1,
      anon_sym_LPAREN2,
    STATE(4191), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5964), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5966), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [89531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4953), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4955), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [89591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6410), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [89651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4002), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [89711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6008), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6010), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [89771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6230), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6232), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [89831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7702), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT2,
    ACTIONS(7700), 41,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [89891] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6340), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6342), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [89951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7706), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT2,
    ACTIONS(7704), 41,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [90011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5976), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5978), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [90071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3652), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3654), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [90131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4947), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [90191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4909), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4911), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [90251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4947), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [90311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4947), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [90371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6366), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6368), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [90431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5502), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [90491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6507), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [90551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6167), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6169), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [90611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6230), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6232), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [90671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6533), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6535), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [90731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4913), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4915), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [90791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6290), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6292), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [90851] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7658), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6066), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [90929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5301), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5303), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [90989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6531), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [91049] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6064), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6066), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [91125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6525), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6527), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [91185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5192), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5194), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [91245] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_EQ,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7268), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    ACTIONS(7666), 1,
      anon_sym_GT_EQ,
    ACTIONS(7670), 1,
      anon_sym_bitand,
    ACTIONS(7685), 1,
      anon_sym_PIPE,
    ACTIONS(7687), 1,
      anon_sym_CARET,
    ACTIONS(7689), 1,
      anon_sym_bitor,
    ACTIONS(7691), 1,
      anon_sym_xor,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7656), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7668), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7683), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7658), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7662), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7664), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [91349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3766), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3758), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [91409] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_EQ,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7268), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    ACTIONS(7666), 1,
      anon_sym_GT_EQ,
    ACTIONS(7670), 1,
      anon_sym_bitand,
    ACTIONS(7685), 1,
      anon_sym_PIPE,
    ACTIONS(7687), 1,
      anon_sym_CARET,
    ACTIONS(7689), 1,
      anon_sym_bitor,
    ACTIONS(7691), 1,
      anon_sym_xor,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7656), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7668), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7658), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7662), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7664), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [91511] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7268), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    ACTIONS(7666), 1,
      anon_sym_GT_EQ,
    ACTIONS(7670), 1,
      anon_sym_bitand,
    ACTIONS(7687), 1,
      anon_sym_CARET,
    ACTIONS(7691), 1,
      anon_sym_xor,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    ACTIONS(6064), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7656), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7668), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7658), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7662), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7664), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [91609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5293), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5295), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [91669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5289), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5291), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [91729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5281), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5283), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [91789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6404), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6406), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [91849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4925), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4927), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [91909] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4921), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4923), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [91969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6465), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6467), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [92029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5230), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5232), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [92089] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6714), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [92187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6412), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6414), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [92247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5226), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5228), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [92307] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_AMP,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6472), 1,
      sym__declarator,
    STATE(8511), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [92405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4933), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4935), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [92465] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5821), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(3766), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3758), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [92527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5014), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1962), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [92587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3648), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3650), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [92647] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7268), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7666), 1,
      anon_sym_GT_EQ,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7656), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7668), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7658), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7662), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7664), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(6066), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [92737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5222), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5224), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [92797] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7268), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7666), 1,
      anon_sym_GT_EQ,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7656), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7668), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7658), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7664), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(6066), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [92885] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6068), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6070), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [92959] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6079), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6081), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [93021] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7268), 1,
      anon_sym_LT_EQ_GT,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7656), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7668), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7658), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(6066), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [93105] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6651), 1,
      anon_sym_STAR,
    ACTIONS(6653), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6655), 1,
      anon_sym_AMP,
    ACTIONS(6657), 1,
      anon_sym_COLON_COLON,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6064), 1,
      sym__scope_resolution,
    STATE(6484), 1,
      sym__declarator,
    STATE(8311), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [93203] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7656), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7658), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 9,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6066), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [93283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4937), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4939), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [93343] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    ACTIONS(6996), 1,
      anon_sym_LPAREN2,
    STATE(4159), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6024), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6026), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [93409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6398), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6400), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [93469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5192), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5194), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [93529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1901), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1899), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [93589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5472), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [93649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3766), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3758), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [93709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5352), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [93769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6983), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6981), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
  [93829] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7148), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7708), 1,
      anon_sym_STAR,
    ACTIONS(7710), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7712), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2974), 1,
      sym_parameter_list,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6665), 1,
      sym__abstract_declarator,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7150), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7152), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3748), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4468), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5484), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [93925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4967), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4969), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [93985] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6764), 1,
      anon_sym_EQ,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7268), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    ACTIONS(7666), 1,
      anon_sym_GT_EQ,
    ACTIONS(7670), 1,
      anon_sym_bitand,
    ACTIONS(7685), 1,
      anon_sym_PIPE,
    ACTIONS(7687), 1,
      anon_sym_CARET,
    ACTIONS(7689), 1,
      anon_sym_bitor,
    ACTIONS(7691), 1,
      anon_sym_xor,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7656), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7668), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7683), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7658), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7662), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7664), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6766), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [94091] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7656), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7668), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7658), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6064), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(6066), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [94173] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6651), 1,
      anon_sym_STAR,
    ACTIONS(6653), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6655), 1,
      anon_sym_AMP,
    ACTIONS(6657), 1,
      anon_sym_COLON_COLON,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6064), 1,
      sym__scope_resolution,
    STATE(6386), 1,
      sym__declarator,
    STATE(8311), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [94271] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5945), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5947), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [94331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6394), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6396), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [94391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5958), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5960), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [94451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6390), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6392), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [94511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6376), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [94571] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2120), 1,
      anon_sym_STAR,
    ACTIONS(2122), 1,
      anon_sym_AMP,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(5631), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6094), 1,
      sym__scope_resolution,
    STATE(6747), 1,
      sym__declarator,
    STATE(8796), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [94669] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7714), 1,
      sym_identifier,
    STATE(3655), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(5883), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5885), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5348), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5346), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [94737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6386), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6388), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [94797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5340), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5342), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [94857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4925), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4927), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [94917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6382), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6384), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [94977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5319), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5321), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [95037] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_AMP,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6454), 1,
      sym__declarator,
    STATE(8511), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [95135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5315), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5317), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [95195] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6461), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6463), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [95255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6416), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6418), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [95315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4917), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4919), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [95375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4002), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [95435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4929), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4931), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [95495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4949), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4951), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [95555] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7716), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6222), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6224), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [95617] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7148), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7708), 1,
      anon_sym_STAR,
    ACTIONS(7710), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7712), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2974), 1,
      sym_parameter_list,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6661), 1,
      sym__abstract_declarator,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7150), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7152), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3169), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4458), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5504), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [95713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6155), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6157), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [95773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4002), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [95833] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6768), 1,
      anon_sym_EQ,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7202), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7246), 1,
      anon_sym_QMARK,
    ACTIONS(7268), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    ACTIONS(7666), 1,
      anon_sym_GT_EQ,
    ACTIONS(7670), 1,
      anon_sym_bitand,
    ACTIONS(7685), 1,
      anon_sym_PIPE,
    ACTIONS(7687), 1,
      anon_sym_CARET,
    ACTIONS(7689), 1,
      anon_sym_bitor,
    ACTIONS(7691), 1,
      anon_sym_xor,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7656), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7668), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7683), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7658), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7662), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7664), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6770), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [95945] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6591), 1,
      anon_sym_STAR,
    ACTIONS(6593), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6595), 1,
      anon_sym_AMP,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6644), 1,
      sym__declarator,
    STATE(8387), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [96043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4002), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [96103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6028), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6030), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [96163] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6036), 1,
      sym_literal_suffix,
    ACTIONS(3758), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(3766), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
  [96225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3648), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3650), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [96285] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6469), 1,
      anon_sym_const,
    ACTIONS(7727), 1,
      anon_sym___attribute__,
    ACTIONS(7730), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7733), 1,
      anon_sym___declspec,
    ACTIONS(7739), 1,
      anon_sym___launch_bounds__,
    STATE(1830), 1,
      sym_alignas_qualifier,
    ACTIONS(5552), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(6475), 2,
      anon_sym___inline,
      anon_sym___forceinline,
    ACTIONS(7736), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5554), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(7721), 6,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      sym_virtual,
    ACTIONS(7724), 7,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(3757), 8,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_launch_bounds,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(7718), 16,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [96369] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4002), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [96429] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6036), 1,
      sym_literal_suffix,
    ACTIONS(5712), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(5710), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
  [96491] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6110), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6112), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [96567] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6106), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6108), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [96643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6302), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6304), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [96703] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    ACTIONS(6996), 1,
      anon_sym_LPAREN2,
    STATE(4194), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5954), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5956), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [96769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6286), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6288), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [96829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6541), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6543), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [96889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6252), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6254), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [96949] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7742), 1,
      anon_sym_LT,
    STATE(2053), 1,
      sym_template_argument_list,
    STATE(2132), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4812), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3756), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(3764), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
  [97019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4909), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4911), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [97079] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7744), 1,
      anon_sym_LT,
    STATE(1997), 1,
      sym_template_argument_list,
    ACTIONS(6198), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6200), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [97143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5458), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5460), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [97203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6521), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6523), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [97263] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7747), 1,
      sym_identifier,
    STATE(3638), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(4846), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4848), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5346), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(5348), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
  [97331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4917), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4919), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [97391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4937), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4939), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [97451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4933), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4935), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [97511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3652), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3654), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [97571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4002), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [97631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1901), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(1899), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [97691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5362), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5364), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [97751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5366), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5368), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [97811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6507), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [97871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4967), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4969), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [97931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6161), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [97991] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7749), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7751), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7753), 1,
      anon_sym_or,
    ACTIONS(7755), 1,
      anon_sym_and,
    ACTIONS(5390), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5392), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [98059] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6314), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6316), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [98119] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6591), 1,
      anon_sym_STAR,
    ACTIONS(6593), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6595), 1,
      anon_sym_AMP,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6668), 1,
      sym__declarator,
    STATE(8387), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [98217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6155), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6157), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [98277] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    STATE(1651), 1,
      sym_template_argument_list,
    STATE(2132), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4812), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5530), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(5532), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
  [98345] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6222), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6224), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [98407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6143), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6145), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [98467] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(7121), 1,
      anon_sym___declspec,
    ACTIONS(7127), 1,
      anon_sym___launch_bounds__,
    STATE(1830), 1,
      sym_alignas_qualifier,
    ACTIONS(59), 2,
      anon_sym___inline,
      anon_sym___forceinline,
    ACTIONS(5521), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5523), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(7759), 6,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      sym_virtual,
    ACTIONS(7119), 7,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(3757), 8,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_launch_bounds,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6625), 16,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [98551] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6720), 1,
      anon_sym_EQ,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7268), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    ACTIONS(7666), 1,
      anon_sym_GT_EQ,
    ACTIONS(7670), 1,
      anon_sym_bitand,
    ACTIONS(7685), 1,
      anon_sym_PIPE,
    ACTIONS(7687), 1,
      anon_sym_CARET,
    ACTIONS(7689), 1,
      anon_sym_bitor,
    ACTIONS(7691), 1,
      anon_sym_xor,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7656), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7668), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7683), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7658), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7662), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7664), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6722), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [98657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5378), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5380), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [98717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6264), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [98777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6147), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6149), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [98837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6028), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6030), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [98897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6147), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6149), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [98957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6000), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6002), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [99017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6147), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6149), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [99077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5382), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5384), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [99137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6165), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [99197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6222), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6224), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [99257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6364), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [99317] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6096), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6098), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [99391] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7744), 1,
      anon_sym_LT,
    STATE(3521), 1,
      sym_template_argument_list,
    ACTIONS(6198), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6200), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [99455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6344), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6346), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [99515] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6102), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6104), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [99591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5945), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5947), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [99651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5370), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5372), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [99711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6258), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6260), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [99771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5354), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5356), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [99831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5958), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5960), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [99891] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5336), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5338), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [99951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6318), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6320), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [100011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6324), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [100071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5336), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5338), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [100131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5277), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5279), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [100191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5982), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5984), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [100251] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    ACTIONS(6996), 1,
      anon_sym_LPAREN2,
    STATE(4135), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6012), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6014), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [100317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6020), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6022), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [100377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5972), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5974), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [100437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4941), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4943), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [100497] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(7121), 1,
      anon_sym___declspec,
    ACTIONS(7127), 1,
      anon_sym___launch_bounds__,
    STATE(1830), 1,
      sym_alignas_qualifier,
    ACTIONS(59), 2,
      anon_sym___inline,
      anon_sym___forceinline,
    ACTIONS(5536), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5538), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(7759), 6,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      sym_virtual,
    ACTIONS(7119), 7,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(3757), 8,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_launch_bounds,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6625), 16,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [100581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3800), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3796), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [100641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7763), 25,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(7761), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [100701] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    ACTIONS(6772), 1,
      anon_sym_EQ,
    ACTIONS(6923), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7268), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7660), 1,
      anon_sym_AMP,
    ACTIONS(7666), 1,
      anon_sym_GT_EQ,
    ACTIONS(7670), 1,
      anon_sym_bitand,
    ACTIONS(7685), 1,
      anon_sym_PIPE,
    ACTIONS(7687), 1,
      anon_sym_CARET,
    ACTIONS(7689), 1,
      anon_sym_bitor,
    ACTIONS(7691), 1,
      anon_sym_xor,
    STATE(3771), 1,
      sym_subscript_argument_list,
    STATE(3781), 1,
      sym_argument_list,
    STATE(8042), 1,
      sym_kernel_call_syntax,
    ACTIONS(6967), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7282), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7656), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7668), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7681), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7683), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7658), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7662), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7664), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6774), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [100807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6332), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6334), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [100867] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7765), 1,
      sym_identifier,
    ACTIONS(7770), 1,
      sym_primitive_type,
    STATE(3837), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7768), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5327), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5325), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [100935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6336), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6338), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [100995] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7772), 1,
      anon_sym_LT,
    STATE(2053), 1,
      sym_template_argument_list,
    STATE(3856), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7612), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3756), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(3764), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [101065] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6092), 1,
      sym_literal_suffix,
    ACTIONS(3766), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(3758), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [101127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4921), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4923), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [101187] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6092), 1,
      sym_literal_suffix,
    ACTIONS(5710), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(5712), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [101249] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7774), 1,
      sym_identifier,
    STATE(3834), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(7777), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(7780), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5267), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(5269), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
  [101317] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7751), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7755), 1,
      anon_sym_and,
    ACTIONS(5402), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5404), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [101381] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4913), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4915), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [101441] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5016), 1,
      sym_primitive_type,
    STATE(1710), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5020), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5261), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5258), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [101507] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6651), 1,
      anon_sym_STAR,
    ACTIONS(6653), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6655), 1,
      anon_sym_AMP,
    ACTIONS(6657), 1,
      anon_sym_COLON_COLON,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6064), 1,
      sym__scope_resolution,
    STATE(6467), 1,
      sym__declarator,
    STATE(8311), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [101605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5285), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5287), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [101665] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6764), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [101763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6507), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [101822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6302), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6304), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [101881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6264), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [101940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6222), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6224), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [101999] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3882), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7783), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5424), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5422), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [102062] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6139), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6141), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [102121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1897), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(1895), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [102180] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3858), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7785), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5374), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5376), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [102243] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3845), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7787), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5448), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5446), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [102306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6258), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6260), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [102365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3766), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3758), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [102424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6167), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6169), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [102483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6533), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6535), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [102542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6382), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6384), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [102601] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym_literal_suffix,
    STATE(3562), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(5812), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5814), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5710), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(5712), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [102668] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3882), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7783), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5434), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5432), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [102731] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5804), 1,
      anon_sym_EQ,
    ACTIONS(5806), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(3766), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3758), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [102794] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3882), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7783), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5438), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5436), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [102857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1901), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(1899), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [102916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3766), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3758), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [102975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3766), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3758), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [103034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6282), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6284), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [103093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6531), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [103152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6386), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6388), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [103211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6266), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6268), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [103270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3984), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3986), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [103329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3980), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3982), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [103388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3996), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3998), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [103447] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7789), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7791), 1,
      anon_sym_and,
    ACTIONS(5402), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5404), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [103510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3992), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3994), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [103569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4023), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [103628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4017), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4019), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [103687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6386), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6388), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [103746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6497), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6499), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [103805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6493), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6495), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [103864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3988), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3990), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [103923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5751), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5749), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [103982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6521), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6523), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [104041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6507), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [104100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6290), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6292), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [104159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6410), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [104218] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3882), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5016), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5018), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [104281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4913), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4915), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [104340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6507), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [104399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6465), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6467), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [104458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4921), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4923), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [104517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6252), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6254), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [104576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6398), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6400), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [104635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6457), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6459), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [104694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6324), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [104753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1901), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(1899), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [104812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3800), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3796), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [104871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6340), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6342), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [104930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1897), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(1895), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [104989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6404), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6406), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [105048] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5901), 1,
      anon_sym_EQ,
    ACTIONS(5903), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(3766), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3758), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [105111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6314), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6316), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [105170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6398), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6400), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [105229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6222), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6224), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [105288] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7772), 1,
      anon_sym_LT,
    STATE(2053), 1,
      sym_template_argument_list,
    ACTIONS(5212), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(3782), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [105353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6404), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6406), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [105412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6318), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6320), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [105471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6410), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [105530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6143), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6145), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [105589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6147), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6149), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [105648] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6457), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6459), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [105707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6509), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6511), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [105766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6382), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6384), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [105825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6501), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6503), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [105884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6509), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6511), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [105943] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(3173), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(7796), 1,
      anon_sym_STAR,
    ACTIONS(7798), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7800), 1,
      anon_sym_AMP,
    STATE(2941), 1,
      sym_parameter_list,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6725), 1,
      sym__abstract_declarator,
    ACTIONS(7394), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7396), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4013), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4478), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5484), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [106038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5014), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(1962), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [106097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6513), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6515), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [106156] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6286), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6288), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [106215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6465), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6467), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [106274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6147), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6149), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [106333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6461), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6463), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [106392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6264), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [106451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4913), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4915), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [106510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6266), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6268), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [106569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6493), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6495), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [106628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6360), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [106687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6143), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6145), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [106746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4921), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4923), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [106805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6517), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6519), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [106864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3766), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3758), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [106923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6147), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6149), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [106982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6497), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6499), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [107041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6501), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6503), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [107100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3766), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3758), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [107159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6513), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6515), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [107218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6258), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6260), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [107277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6517), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6519), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [107336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3766), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3758), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [107395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4941), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4943), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [107454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6537), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6539), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [107513] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3826), 1,
      anon_sym_SEMI,
    ACTIONS(4810), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5743), 1,
      anon_sym_LPAREN2,
    ACTIONS(5746), 1,
      anon_sym_LBRACK,
    ACTIONS(3794), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(3758), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(3766), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
  [107584] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym_literal_suffix,
    STATE(3562), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(5812), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5814), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3766), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(3758), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [107651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6344), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6346), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [107710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6533), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6535), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [107769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6302), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6304), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [107828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6364), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [107887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6537), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6539), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [107946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6290), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6292), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [108005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6531), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [108064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4929), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4931), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [108123] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4149), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4151), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4144), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [108184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6376), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [108243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6286), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6288), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [108302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6416), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6418), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [108361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4949), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4951), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [108420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4909), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4911), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [108479] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5194), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5192), 45,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [108540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4917), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4919), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [108599] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_LT,
    STATE(2115), 1,
      sym_template_argument_list,
    ACTIONS(6198), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6200), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [108662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4925), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4927), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [108721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6252), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6254), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [108780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5751), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5749), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [108839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6507), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [108898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6525), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6527), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [108957] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7804), 1,
      anon_sym_LPAREN2,
    ACTIONS(7806), 5,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7802), 45,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [109018] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6328), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6330), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [109077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6161), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [109136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6521), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6523), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [109195] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6541), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6543), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [109254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6461), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6463), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [109313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4967), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4969), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [109372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6360), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [109431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6364), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [109490] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7789), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7791), 1,
      anon_sym_and,
    ACTIONS(7808), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7810), 1,
      anon_sym_or,
    ACTIONS(5390), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5392), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [109557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6366), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6368), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [109616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6525), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6527), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [109675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6344), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6346), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [109734] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3800), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3796), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [109793] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7812), 1,
      anon_sym_LT,
    STATE(2053), 1,
      sym_template_argument_list,
    ACTIONS(4000), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4007), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [109858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6340), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6342), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [109917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4917), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4919), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [109976] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3979), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7815), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5442), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5440), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [110039] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3882), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7783), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5418), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5416), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [110102] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4909), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4911), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [110161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4002), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [110220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6541), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6543), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [110279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4002), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [110338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4002), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [110397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4002), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [110456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6412), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6414), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [110515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4002), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [110574] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5879), 1,
      anon_sym_EQ,
    ACTIONS(5881), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(3766), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3758), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [110637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4002), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [110696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6332), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6334), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [110755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6394), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6396), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [110814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6336), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6338), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [110873] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4842), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(4844), 12,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(3766), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3758), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [110936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6390), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6392), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [110995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4002), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [111054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4953), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4955), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [111113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4947), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [111172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4947), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [111231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4947), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [111290] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4002), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [111349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4967), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4969), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [111408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4002), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [111467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4002), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [111526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4002), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [111585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4002), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [111644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4947), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [111703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6318), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6320), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [111762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5014), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(1962), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [111821] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6324), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [111880] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4941), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4943), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [111939] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6147), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6149), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [111998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6147), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6149), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [112057] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(3173), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(7796), 1,
      anon_sym_STAR,
    ACTIONS(7798), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7800), 1,
      anon_sym_AMP,
    STATE(2941), 1,
      sym_parameter_list,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6735), 1,
      sym__abstract_declarator,
    ACTIONS(7394), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7396), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4023), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4486), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5504), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [112152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6332), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6334), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [112211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4937), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4939), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [112270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4933), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4935), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [112329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6147), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6149), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [112388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6336), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6338), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [112447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4947), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [112506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6328), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6330), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [112565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6139), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6141), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [112624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4937), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4939), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [112683] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(7820), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4023), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(7817), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7172), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(7170), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [112750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6167), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6169), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [112809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6366), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6368), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [112868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4933), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4935), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [112927] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7823), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7825), 1,
      anon_sym_and,
    ACTIONS(5402), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5404), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [112990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4947), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [113049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6376), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [113108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6412), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6414), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [113167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6282), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6284), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [113226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6314), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6316), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [113285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4953), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4955), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [113344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7829), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7827), 45,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [113403] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7823), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7825), 1,
      anon_sym_and,
    ACTIONS(7831), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7833), 1,
      anon_sym_or,
    ACTIONS(5390), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5392), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [113470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6416), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6418), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [113529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6161), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [113588] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6998), 1,
      anon_sym_LBRACK,
    STATE(4097), 1,
      sym_new_declarator,
    ACTIONS(6038), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6040), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [113651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4929), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4931), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [113710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4925), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4927), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [113769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6390), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6392), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [113828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4949), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4951), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [113887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6394), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6396), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [113946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5458), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5460), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [114004] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7839), 1,
      anon_sym_STAR,
    ACTIONS(7841), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7843), 1,
      anon_sym_AMP,
    ACTIONS(7849), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6922), 1,
      sym__type_declarator,
    STATE(8829), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4113), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4548), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [114098] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7851), 1,
      sym_identifier,
    ACTIONS(7853), 1,
      anon_sym_LPAREN2,
    ACTIONS(7855), 1,
      anon_sym_STAR,
    ACTIONS(7857), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7859), 1,
      anon_sym_AMP,
    ACTIONS(7863), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6310), 1,
      sym__type_declarator,
    STATE(6573), 1,
      sym_pointer_type_declarator,
    STATE(8472), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3169), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4576), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7861), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6565), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [114192] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6674), 1,
      sym__type_declarator,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4075), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4615), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [114286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5196), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5198), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [114344] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7871), 1,
      sym_identifier,
    ACTIONS(7873), 1,
      anon_sym_LPAREN2,
    ACTIONS(7875), 1,
      anon_sym_STAR,
    ACTIONS(7877), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7879), 1,
      anon_sym_AMP,
    ACTIONS(7883), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3153), 1,
      sym__type_declarator,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(3798), 1,
      sym_pointer_type_declarator,
    STATE(8717), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3169), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4599), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7881), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3820), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [114438] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7871), 1,
      sym_identifier,
    ACTIONS(7873), 1,
      anon_sym_LPAREN2,
    ACTIONS(7875), 1,
      anon_sym_STAR,
    ACTIONS(7877), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7879), 1,
      anon_sym_AMP,
    ACTIONS(7883), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3203), 1,
      sym__type_declarator,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(3798), 1,
      sym_pointer_type_declarator,
    STATE(8717), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3169), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4601), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7881), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3820), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [114532] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(7123), 1,
      sym_auto,
    ACTIONS(7125), 1,
      anon_sym_decltype,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7142), 1,
      anon_sym_STAR,
    ACTIONS(7144), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2182), 1,
      sym_decltype_auto,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6341), 1,
      sym__abstract_declarator,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4308), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7885), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [114622] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(3173), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_STAR,
    ACTIONS(7889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7891), 1,
      anon_sym_AMP,
    STATE(3056), 1,
      sym_parameter_list,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6768), 1,
      sym__abstract_declarator,
    ACTIONS(7394), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7396), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4076), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4547), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5484), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [114716] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7893), 1,
      anon_sym_STAR,
    ACTIONS(7895), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7897), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2341), 1,
      sym__type_declarator,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8989), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3169), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4600), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [114810] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7871), 1,
      sym_identifier,
    ACTIONS(7873), 1,
      anon_sym_LPAREN2,
    ACTIONS(7875), 1,
      anon_sym_STAR,
    ACTIONS(7877), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7879), 1,
      anon_sym_AMP,
    ACTIONS(7883), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3153), 1,
      sym__type_declarator,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(3798), 1,
      sym_pointer_type_declarator,
    STATE(8717), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4050), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4599), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7881), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3820), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [114904] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7649), 1,
      anon_sym___attribute__,
    ACTIONS(7899), 1,
      anon_sym_LBRACE,
    ACTIONS(7901), 1,
      anon_sym_COLON,
    STATE(4203), 1,
      sym__enum_base_clause,
    STATE(4303), 1,
      sym_enumerator_list,
    STATE(4384), 1,
      sym_attribute_specifier,
    ACTIONS(6048), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6050), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [114974] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7871), 1,
      sym_identifier,
    ACTIONS(7873), 1,
      anon_sym_LPAREN2,
    ACTIONS(7875), 1,
      anon_sym_STAR,
    ACTIONS(7877), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7879), 1,
      anon_sym_AMP,
    ACTIONS(7883), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3095), 1,
      sym__type_declarator,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(3798), 1,
      sym_pointer_type_declarator,
    STATE(8717), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4049), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4559), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7881), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3820), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [115068] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6036), 1,
      sym_literal_suffix,
    STATE(3772), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(4846), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4848), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5710), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(5712), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [115134] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7158), 1,
      anon_sym_STAR,
    ACTIONS(7160), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7162), 1,
      anon_sym_AMP,
    ACTIONS(7905), 1,
      sym_auto,
    ACTIONS(7907), 1,
      anon_sym_decltype,
    STATE(2839), 1,
      sym_parameter_list,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(4997), 1,
      sym_decltype_auto,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6303), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4294), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7903), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [115224] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7164), 1,
      anon_sym_STAR,
    ACTIONS(7166), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7168), 1,
      anon_sym_AMP,
    ACTIONS(7905), 1,
      sym_auto,
    ACTIONS(7907), 1,
      anon_sym_decltype,
    STATE(2924), 1,
      sym_parameter_list,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(4997), 1,
      sym_decltype_auto,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6313), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4290), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7903), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [115314] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6092), 1,
      sym_literal_suffix,
    STATE(3733), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(5883), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5885), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3766), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(3758), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [115380] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6036), 1,
      sym_literal_suffix,
    STATE(3772), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(4846), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4848), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3766), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(3758), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [115446] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(7123), 1,
      sym_auto,
    ACTIONS(7125), 1,
      anon_sym_decltype,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7142), 1,
      anon_sym_STAR,
    ACTIONS(7144), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2182), 1,
      sym_decltype_auto,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6356), 1,
      sym__abstract_declarator,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4317), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7903), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [115536] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7893), 1,
      anon_sym_STAR,
    ACTIONS(7895), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7897), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2364), 1,
      sym__type_declarator,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8989), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4053), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4546), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [115630] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 1,
      sym_literal_suffix,
    ACTIONS(5710), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5712), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [115690] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 1,
      sym_literal_suffix,
    ACTIONS(3766), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3758), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [115750] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7839), 1,
      anon_sym_STAR,
    ACTIONS(7841), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7843), 1,
      anon_sym_AMP,
    ACTIONS(7849), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6963), 1,
      sym__type_declarator,
    STATE(8829), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4067), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4555), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [115844] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7839), 1,
      anon_sym_STAR,
    ACTIONS(7841), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7843), 1,
      anon_sym_AMP,
    ACTIONS(7849), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6929), 1,
      sym__type_declarator,
    STATE(8829), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3169), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4568), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [115938] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7909), 1,
      sym_identifier,
    ACTIONS(7911), 1,
      anon_sym_LPAREN2,
    ACTIONS(7913), 1,
      anon_sym_STAR,
    ACTIONS(7915), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7917), 1,
      anon_sym_AMP,
    ACTIONS(7921), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3042), 1,
      sym__type_declarator,
    STATE(3553), 1,
      sym_pointer_type_declarator,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8790), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4095), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4545), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7919), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3555), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [116032] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6674), 1,
      sym__type_declarator,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3169), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4615), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [116126] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_LPAREN2,
    ACTIONS(7927), 1,
      anon_sym_STAR,
    ACTIONS(7929), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7931), 1,
      anon_sym_AMP,
    ACTIONS(7935), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3098), 1,
      sym__type_declarator,
    STATE(3594), 1,
      sym_pointer_type_declarator,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8279), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3169), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4561), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7933), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3590), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [116220] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_LPAREN2,
    ACTIONS(7927), 1,
      anon_sym_STAR,
    ACTIONS(7929), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7931), 1,
      anon_sym_AMP,
    ACTIONS(7935), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3093), 1,
      sym__type_declarator,
    STATE(3594), 1,
      sym_pointer_type_declarator,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8279), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3169), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4590), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7933), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3590), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [116314] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_LPAREN2,
    ACTIONS(7927), 1,
      anon_sym_STAR,
    ACTIONS(7929), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7931), 1,
      anon_sym_AMP,
    ACTIONS(7935), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3093), 1,
      sym__type_declarator,
    STATE(3594), 1,
      sym_pointer_type_declarator,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8279), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4070), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4590), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7933), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3590), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [116408] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_LPAREN2,
    ACTIONS(7927), 1,
      anon_sym_STAR,
    ACTIONS(7929), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7931), 1,
      anon_sym_AMP,
    ACTIONS(7935), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3117), 1,
      sym__type_declarator,
    STATE(3594), 1,
      sym_pointer_type_declarator,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8279), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4071), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4616), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7933), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3590), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [116502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5502), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [116560] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6673), 1,
      sym__type_declarator,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3169), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4607), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [116654] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(3173), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_STAR,
    ACTIONS(7889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7891), 1,
      anon_sym_AMP,
    STATE(3056), 1,
      sym_parameter_list,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6784), 1,
      sym__abstract_declarator,
    ACTIONS(7394), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7396), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4023), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4584), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5504), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [116748] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5179), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5181), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [116808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6981), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(6983), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [116866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5179), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5181), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [116926] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7851), 1,
      sym_identifier,
    ACTIONS(7853), 1,
      anon_sym_LPAREN2,
    ACTIONS(7855), 1,
      anon_sym_STAR,
    ACTIONS(7857), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7859), 1,
      anon_sym_AMP,
    ACTIONS(7863), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6340), 1,
      sym__type_declarator,
    STATE(6573), 1,
      sym_pointer_type_declarator,
    STATE(8472), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4091), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4549), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7861), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6565), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [117020] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6092), 1,
      sym_literal_suffix,
    STATE(3733), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(5883), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5885), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5710), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(5712), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [117086] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7893), 1,
      anon_sym_STAR,
    ACTIONS(7895), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7897), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2341), 1,
      sym__type_declarator,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8989), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4110), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4600), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [117180] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7649), 1,
      anon_sym___attribute__,
    ACTIONS(7899), 1,
      anon_sym_LBRACE,
    ACTIONS(7901), 1,
      anon_sym_COLON,
    STATE(4242), 1,
      sym__enum_base_clause,
    STATE(4313), 1,
      sym_enumerator_list,
    STATE(4370), 1,
      sym_attribute_specifier,
    ACTIONS(6042), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6044), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [117250] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7851), 1,
      sym_identifier,
    ACTIONS(7853), 1,
      anon_sym_LPAREN2,
    ACTIONS(7855), 1,
      anon_sym_STAR,
    ACTIONS(7857), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7859), 1,
      anon_sym_AMP,
    ACTIONS(7863), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6318), 1,
      sym__type_declarator,
    STATE(6573), 1,
      sym_pointer_type_declarator,
    STATE(8472), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4046), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4603), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7861), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6565), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [117344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5472), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [117402] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6615), 1,
      sym__type_declarator,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4069), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4569), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [117496] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7164), 1,
      anon_sym_STAR,
    ACTIONS(7166), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7168), 1,
      anon_sym_AMP,
    ACTIONS(7905), 1,
      sym_auto,
    ACTIONS(7907), 1,
      anon_sym_decltype,
    STATE(2924), 1,
      sym_parameter_list,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(4997), 1,
      sym_decltype_auto,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6335), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4284), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7885), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [117586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5462), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5464), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [117644] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7937), 1,
      anon_sym_LBRACK,
    STATE(4122), 1,
      sym_new_declarator,
    ACTIONS(6038), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6040), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [117706] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7909), 1,
      sym_identifier,
    ACTIONS(7911), 1,
      anon_sym_LPAREN2,
    ACTIONS(7913), 1,
      anon_sym_STAR,
    ACTIONS(7915), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7917), 1,
      anon_sym_AMP,
    ACTIONS(7921), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3032), 1,
      sym__type_declarator,
    STATE(3553), 1,
      sym_pointer_type_declarator,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8790), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3169), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4583), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7919), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3555), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [117800] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7851), 1,
      sym_identifier,
    ACTIONS(7853), 1,
      anon_sym_LPAREN2,
    ACTIONS(7855), 1,
      anon_sym_STAR,
    ACTIONS(7857), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7859), 1,
      anon_sym_AMP,
    ACTIONS(7863), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6318), 1,
      sym__type_declarator,
    STATE(6573), 1,
      sym_pointer_type_declarator,
    STATE(8472), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3169), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4603), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7861), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6565), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [117894] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3826), 1,
      anon_sym_SEMI,
    ACTIONS(3794), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(3766), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3758), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [117958] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7851), 1,
      sym_identifier,
    ACTIONS(7853), 1,
      anon_sym_LPAREN2,
    ACTIONS(7863), 1,
      sym_primitive_type,
    ACTIONS(7939), 1,
      anon_sym_STAR,
    ACTIONS(7941), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7943), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6537), 1,
      sym__type_declarator,
    STATE(6573), 1,
      sym_pointer_type_declarator,
    STATE(8211), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3169), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4598), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7861), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6565), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [118052] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7851), 1,
      sym_identifier,
    ACTIONS(7853), 1,
      anon_sym_LPAREN2,
    ACTIONS(7863), 1,
      sym_primitive_type,
    ACTIONS(7939), 1,
      anon_sym_STAR,
    ACTIONS(7941), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7943), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6535), 1,
      sym__type_declarator,
    STATE(6573), 1,
      sym_pointer_type_declarator,
    STATE(8211), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4093), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4596), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7861), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6565), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [118146] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7909), 1,
      sym_identifier,
    ACTIONS(7911), 1,
      anon_sym_LPAREN2,
    ACTIONS(7913), 1,
      anon_sym_STAR,
    ACTIONS(7915), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7917), 1,
      anon_sym_AMP,
    ACTIONS(7921), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3047), 1,
      sym__type_declarator,
    STATE(3553), 1,
      sym_pointer_type_declarator,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8790), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3169), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4557), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7919), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3555), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [118240] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7851), 1,
      sym_identifier,
    ACTIONS(7853), 1,
      anon_sym_LPAREN2,
    ACTIONS(7863), 1,
      sym_primitive_type,
    ACTIONS(7939), 1,
      anon_sym_STAR,
    ACTIONS(7941), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7943), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6537), 1,
      sym__type_declarator,
    STATE(6573), 1,
      sym_pointer_type_declarator,
    STATE(8211), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4101), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4598), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7861), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6565), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [118334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6165), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [118392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3984), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(3986), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [118450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3980), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(3982), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [118508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3996), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(3998), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [118566] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7851), 1,
      sym_identifier,
    ACTIONS(7853), 1,
      anon_sym_LPAREN2,
    ACTIONS(7863), 1,
      sym_primitive_type,
    ACTIONS(7939), 1,
      anon_sym_STAR,
    ACTIONS(7941), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7943), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6538), 1,
      sym__type_declarator,
    STATE(6573), 1,
      sym_pointer_type_declarator,
    STATE(8211), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3169), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4604), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7861), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6565), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [118660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3992), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(3994), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [118718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4023), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [118776] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5185), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5187), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [118836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4017), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4019), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [118894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3988), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(3990), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [118952] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7909), 1,
      sym_identifier,
    ACTIONS(7911), 1,
      anon_sym_LPAREN2,
    ACTIONS(7913), 1,
      anon_sym_STAR,
    ACTIONS(7915), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7917), 1,
      anon_sym_AMP,
    ACTIONS(7921), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3047), 1,
      sym__type_declarator,
    STATE(3553), 1,
      sym_pointer_type_declarator,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8790), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4090), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4557), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7919), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3555), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [119046] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4149), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4151), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4144), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [119106] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7158), 1,
      anon_sym_STAR,
    ACTIONS(7160), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7162), 1,
      anon_sym_AMP,
    ACTIONS(7905), 1,
      sym_auto,
    ACTIONS(7907), 1,
      anon_sym_decltype,
    STATE(2839), 1,
      sym_parameter_list,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(4997), 1,
      sym_decltype_auto,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6309), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4282), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7885), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [119196] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7893), 1,
      anon_sym_STAR,
    ACTIONS(7895), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7897), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2346), 1,
      sym__type_declarator,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8989), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3169), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4577), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [119290] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3858), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7785), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5192), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5194), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [119352] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4151), 1,
      anon_sym_LBRACK,
    ACTIONS(4146), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4149), 4,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
    ACTIONS(4142), 43,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___device__,
      anon_sym___host__,
      anon_sym___global__,
      anon_sym___forceinline__,
      anon_sym___noinline__,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_operator,
      anon_sym___launch_bounds__,
  [119414] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7839), 1,
      anon_sym_STAR,
    ACTIONS(7841), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7843), 1,
      anon_sym_AMP,
    ACTIONS(7849), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6963), 1,
      sym__type_declarator,
    STATE(8829), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7845), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3169), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4555), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7148), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [119508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4949), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4951), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [119565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4921), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4923), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [119622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6513), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6515), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [119679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6501), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6503), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [119736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6497), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6499), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [119793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6493), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6495), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [119850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5014), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1962), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [119907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5014), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(1962), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [119964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6165), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [120021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6465), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6467), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [120078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6457), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6459), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [120135] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(7937), 1,
      anon_sym_LBRACK,
    ACTIONS(7945), 1,
      anon_sym_LPAREN2,
    ACTIONS(7947), 1,
      sym_auto,
    ACTIONS(7949), 1,
      anon_sym_decltype,
    STATE(4306), 1,
      sym_new_declarator,
    STATE(4394), 1,
      sym_decltype_auto,
    STATE(4233), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5704), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5706), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [120208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6410), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [120265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6404), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6406), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [120322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6398), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6400), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [120379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6376), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [120436] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7148), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7951), 1,
      anon_sym_STAR,
    ACTIONS(7953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7955), 1,
      anon_sym_AMP,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6859), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7150), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7152), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4147), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4632), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5484), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [120529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6386), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6388), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [120586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6382), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6384), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [120643] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7957), 1,
      anon_sym_LT,
    STATE(2053), 1,
      sym_template_argument_list,
    ACTIONS(4000), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4007), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
  [120706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4941), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4943), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [120763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6537), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6539), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [120820] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(7937), 1,
      anon_sym_LBRACK,
    ACTIONS(7945), 1,
      anon_sym_LPAREN2,
    ACTIONS(7947), 1,
      sym_auto,
    ACTIONS(7949), 1,
      anon_sym_decltype,
    STATE(4281), 1,
      sym_new_declarator,
    STATE(4394), 1,
      sym_decltype_auto,
    STATE(4205), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5640), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5642), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [120893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6533), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6535), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [120950] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7960), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7962), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5390), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5392), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [121011] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7386), 1,
      anon_sym_STAR,
    ACTIONS(7388), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7390), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(7964), 1,
      sym_auto,
    ACTIONS(7966), 1,
      anon_sym_decltype,
    STATE(2786), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(5275), 1,
      sym_decltype_auto,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6470), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4344), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7885), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [121100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6531), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [121157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6525), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6527), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [121214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6416), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6418), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [121271] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4929), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4931), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [121328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6266), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6268), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [121385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4953), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4955), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [121442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3766), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3758), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [121499] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7148), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7951), 1,
      anon_sym_STAR,
    ACTIONS(7953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7955), 1,
      anon_sym_AMP,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(3662), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6824), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7150), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7152), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3169), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4718), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5504), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [121592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3766), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3758), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [121649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6509), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6511), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [121706] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(7937), 1,
      anon_sym_LBRACK,
    ACTIONS(7945), 1,
      anon_sym_LPAREN2,
    ACTIONS(7947), 1,
      sym_auto,
    ACTIONS(7949), 1,
      anon_sym_decltype,
    STATE(4287), 1,
      sym_new_declarator,
    STATE(4394), 1,
      sym_decltype_auto,
    STATE(4264), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5664), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5666), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [121779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6513), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6515), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [121836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4947), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [121893] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7386), 1,
      anon_sym_STAR,
    ACTIONS(7388), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7390), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(7964), 1,
      sym_auto,
    ACTIONS(7966), 1,
      anon_sym_decltype,
    STATE(2786), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(5275), 1,
      sym_decltype_auto,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6444), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4352), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7903), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [121982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1901), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1899), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [122039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4947), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [122096] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6412), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6414), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [122153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6394), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6396), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [122210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4947), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [122267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6517), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6519), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [122324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6290), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6292), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [122381] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6412), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6414), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [122438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6258), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6260), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [122495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4937), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4939), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [122552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4933), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4935), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [122609] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    STATE(1830), 1,
      sym_alignas_qualifier,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7970), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    STATE(4424), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4457), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6074), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
    ACTIONS(7968), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [122680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5502), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [122737] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7742), 1,
      anon_sym_LT,
    STATE(2053), 1,
      sym_template_argument_list,
    ACTIONS(5212), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(3782), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
  [122800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6541), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6543), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [122857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4909), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4911), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [122914] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5458), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5460), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [122971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5179), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5181), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [123028] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5472), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [123085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4917), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4919), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [123142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5462), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5464), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [123199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6264), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [123256] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5502), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [123313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5458), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5460), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [123370] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3826), 1,
      anon_sym_SEMI,
    ACTIONS(5708), 1,
      sym_literal_suffix,
    STATE(2752), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(3594), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3598), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(3766), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(3758), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [123437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5472), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [123494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5462), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5464), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [123551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4967), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4969), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [123608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5502), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [123665] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(7937), 1,
      anon_sym_LBRACK,
    ACTIONS(7945), 1,
      anon_sym_LPAREN2,
    ACTIONS(7947), 1,
      sym_auto,
    ACTIONS(7949), 1,
      anon_sym_decltype,
    STATE(4295), 1,
      sym_new_declarator,
    STATE(4394), 1,
      sym_decltype_auto,
    STATE(4258), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5690), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5692), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [123738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5458), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5460), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [123795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6364), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [123852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4925), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4927), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [123909] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5472), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [123966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1897), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1895), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [124023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6360), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [124080] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6340), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6342), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [124137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6332), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6334), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [124194] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6336), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6338), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [124251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6344), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6346), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [124308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6390), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6392), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [124365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6318), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6320), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [124422] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3800), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3796), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [124479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6324), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [124536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5462), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5464), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [124593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6258), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6260), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [124650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4913), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4915), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [124707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6282), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6284), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [124764] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7962), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5402), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5404), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
      aux_sym_kernel_call_syntax_token1,
  [124823] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7649), 1,
      anon_sym___attribute__,
    ACTIONS(7899), 1,
      anon_sym_LBRACE,
    STATE(4307), 1,
      sym_enumerator_list,
    STATE(4374), 1,
      sym_attribute_specifier,
    ACTIONS(5599), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5597), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [124887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5502), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [124943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6394), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6396), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [124999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5502), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [125055] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    STATE(1651), 1,
      sym_template_argument_list,
    STATE(4329), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7972), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5530), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5532), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [125119] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7974), 1,
      sym_identifier,
    ACTIONS(7978), 1,
      sym_primitive_type,
    STATE(4215), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7976), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5327), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5325), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [125183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6525), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6527), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [125239] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5510), 1,
      anon_sym___attribute__,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(7980), 1,
      anon_sym_COLON,
    STATE(1937), 1,
      sym_attribute_specifier,
    STATE(2186), 1,
      sym__enum_base_clause,
    STATE(2234), 1,
      sym_enumerator_list,
    ACTIONS(6042), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_DOT,
    ACTIONS(6044), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
  [125307] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6192), 1,
      anon_sym_LT,
    STATE(1651), 1,
      sym_template_argument_list,
    STATE(4430), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3756), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(7982), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3764), 36,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [125373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6541), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6543), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [125429] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7617), 1,
      anon_sym_STAR,
    ACTIONS(7619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7621), 1,
      anon_sym_AMP,
    ACTIONS(7905), 1,
      sym_auto,
    ACTIONS(7907), 1,
      anon_sym_decltype,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(4997), 1,
      sym_decltype_auto,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6528), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4428), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7885), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [125517] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(7123), 1,
      sym_auto,
    ACTIONS(7125), 1,
      anon_sym_decltype,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7606), 1,
      anon_sym_STAR,
    ACTIONS(7608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7610), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2182), 1,
      sym_decltype_auto,
    STATE(2909), 1,
      sym_parameter_list,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6552), 1,
      sym__abstract_declarator,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4398), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7903), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [125605] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4237), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5016), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(7984), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5261), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5258), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [125667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6390), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6392), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [125723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5472), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [125779] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(7987), 1,
      sym_identifier,
    ACTIONS(7989), 1,
      anon_sym_LPAREN2,
    ACTIONS(7991), 1,
      anon_sym_STAR,
    ACTIONS(7993), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7995), 1,
      anon_sym_AMP,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6894), 1,
      sym__field_declarator,
    STATE(7018), 1,
      sym_operator_name,
    STATE(8384), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4023), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4745), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6748), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [125869] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(7987), 1,
      sym_identifier,
    ACTIONS(7989), 1,
      anon_sym_LPAREN2,
    ACTIONS(7991), 1,
      anon_sym_STAR,
    ACTIONS(7993), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7995), 1,
      anon_sym_AMP,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6905), 1,
      sym__field_declarator,
    STATE(7018), 1,
      sym_operator_name,
    STATE(8384), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4218), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4782), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6748), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [125959] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(7987), 1,
      sym_identifier,
    ACTIONS(7989), 1,
      anon_sym_LPAREN2,
    ACTIONS(7991), 1,
      anon_sym_STAR,
    ACTIONS(7993), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7995), 1,
      anon_sym_AMP,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6905), 1,
      sym__field_declarator,
    STATE(7018), 1,
      sym_operator_name,
    STATE(8384), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4023), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4782), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6748), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [126049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5472), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [126105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5458), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5460), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [126161] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(7989), 1,
      anon_sym_LPAREN2,
    ACTIONS(7997), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_STAR,
    ACTIONS(8001), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8003), 1,
      anon_sym_AMP,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6439), 1,
      sym__field_declarator,
    STATE(6635), 1,
      sym_operator_name,
    STATE(8417), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4023), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4815), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6748), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [126251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6398), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6400), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [126307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6501), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6503), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [126363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6332), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6334), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [126419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5462), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5464), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [126475] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(7989), 1,
      anon_sym_LPAREN2,
    ACTIONS(7997), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_STAR,
    ACTIONS(8001), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8003), 1,
      anon_sym_AMP,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6465), 1,
      sym__field_declarator,
    STATE(6635), 1,
      sym_operator_name,
    STATE(8417), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4223), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4787), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6748), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [126565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6404), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6406), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [126621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6382), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6384), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [126677] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    STATE(1651), 1,
      sym_template_argument_list,
    STATE(4430), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5530), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(7982), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5532), 36,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [126743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6410), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [126799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6416), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6418), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [126855] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(3173), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8005), 1,
      anon_sym_STAR,
    ACTIONS(8007), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8009), 1,
      anon_sym_AMP,
    STATE(2819), 1,
      sym_parameter_list,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6745), 1,
      sym__abstract_declarator,
    ACTIONS(7394), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7396), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4023), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4970), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5504), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [126947] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6192), 1,
      anon_sym_LT,
    STATE(1651), 1,
      sym_template_argument_list,
    ACTIONS(5212), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(3782), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [127009] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6192), 1,
      anon_sym_LT,
    STATE(1651), 1,
      sym_template_argument_list,
    ACTIONS(4000), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4007), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [127071] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4237), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7984), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5018), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
    ACTIONS(5016), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      sym_primitive_type,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [127131] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7617), 1,
      anon_sym_STAR,
    ACTIONS(7619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7621), 1,
      anon_sym_AMP,
    ACTIONS(7905), 1,
      sym_auto,
    ACTIONS(7907), 1,
      anon_sym_decltype,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(4997), 1,
      sym_decltype_auto,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6576), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4365), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7903), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [127219] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(7989), 1,
      anon_sym_LPAREN2,
    ACTIONS(7997), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_STAR,
    ACTIONS(8001), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8003), 1,
      anon_sym_AMP,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6439), 1,
      sym__field_declarator,
    STATE(6635), 1,
      sym_operator_name,
    STATE(8417), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4261), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4815), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6748), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [127309] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6192), 1,
      anon_sym_LT,
    STATE(1651), 1,
      sym_template_argument_list,
    STATE(2689), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3756), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5952), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3764), 37,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [127375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6493), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6495), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [127431] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7649), 1,
      anon_sym___attribute__,
    ACTIONS(7899), 1,
      anon_sym_LBRACE,
    STATE(4293), 1,
      sym_enumerator_list,
    STATE(4401), 1,
      sym_attribute_specifier,
    ACTIONS(5612), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5610), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [127495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6266), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6268), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [127551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6340), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6342), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [127607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6324), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [127663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6364), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [127719] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(7123), 1,
      sym_auto,
    ACTIONS(7125), 1,
      anon_sym_decltype,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7606), 1,
      anon_sym_STAR,
    ACTIONS(7608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7610), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2182), 1,
      sym_decltype_auto,
    STATE(2909), 1,
      sym_parameter_list,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6542), 1,
      sym__abstract_declarator,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4444), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7885), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [127807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6497), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6499), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [127863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3800), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3796), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [127919] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(8011), 1,
      anon_sym___attribute__,
    ACTIONS(8013), 1,
      anon_sym_LBRACE,
    STATE(4539), 1,
      sym_field_declaration_list,
    STATE(4813), 1,
      sym_attribute_specifier,
    STATE(7296), 1,
      sym_virtual_specifier,
    STATE(8082), 1,
      sym_base_class_clause,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5508), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5506), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [127991] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(3173), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8005), 1,
      anon_sym_STAR,
    ACTIONS(8007), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8009), 1,
      anon_sym_AMP,
    STATE(2819), 1,
      sym_parameter_list,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6720), 1,
      sym__abstract_declarator,
    ACTIONS(7394), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7396), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4234), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4874), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5484), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [128083] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(7987), 1,
      sym_identifier,
    ACTIONS(7989), 1,
      anon_sym_LPAREN2,
    ACTIONS(7991), 1,
      anon_sym_STAR,
    ACTIONS(7993), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7995), 1,
      anon_sym_AMP,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6877), 1,
      sym__field_declarator,
    STATE(7018), 1,
      sym_operator_name,
    STATE(8384), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4220), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4927), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6748), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [128173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7702), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(7700), 35,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [128229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5458), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5460), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [128285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6376), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [128341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6386), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6388), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [128397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6517), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6519), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [128453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6344), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6346), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [128509] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    STATE(1651), 1,
      sym_template_argument_list,
    STATE(2230), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4840), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5530), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5532), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [128573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3766), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3758), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [128629] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(7989), 1,
      anon_sym_LPAREN2,
    ACTIONS(7997), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_STAR,
    ACTIONS(8001), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8003), 1,
      anon_sym_AMP,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6492), 1,
      sym__field_declarator,
    STATE(6635), 1,
      sym_operator_name,
    STATE(8417), 1,
      sym_ms_based_modifier,
    ACTIONS(3175), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4023), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4865), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3173), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6748), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [128719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6537), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6539), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [128775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5462), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5464), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      aux_sym_kernel_call_syntax_token1,
  [128831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6336), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6338), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [128887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6531), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [128943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3766), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3758), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [128999] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5510), 1,
      anon_sym___attribute__,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(7980), 1,
      anon_sym_COLON,
    STATE(2088), 1,
      sym_attribute_specifier,
    STATE(2168), 1,
      sym__enum_base_clause,
    STATE(2227), 1,
      sym_enumerator_list,
    ACTIONS(6048), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_DOT,
    ACTIONS(6050), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
  [129067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6457), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6459), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [129123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6290), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6292), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [129179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6318), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6320), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [129235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6533), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6535), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [129291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6465), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6467), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [129347] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8015), 1,
      anon_sym_STAR,
    ACTIONS(8017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8019), 1,
      anon_sym_AMP,
    ACTIONS(8023), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8029), 1,
      anon_sym_const,
    STATE(3439), 1,
      sym_parameter_list,
    STATE(5368), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5599), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6887), 1,
      sym__abstract_declarator,
    ACTIONS(8025), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8027), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8031), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4890), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5202), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(5504), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8021), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [129439] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8015), 1,
      anon_sym_STAR,
    ACTIONS(8017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8019), 1,
      anon_sym_AMP,
    ACTIONS(8023), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8029), 1,
      anon_sym_const,
    STATE(3439), 1,
      sym_parameter_list,
    STATE(5368), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5599), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6876), 1,
      sym__abstract_declarator,
    ACTIONS(8025), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8027), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8031), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4273), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5484), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8021), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [129531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7706), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(7704), 35,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [129587] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(7937), 1,
      anon_sym_LBRACK,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    ACTIONS(8035), 1,
      sym_auto,
    ACTIONS(8037), 1,
      anon_sym_decltype,
    STATE(2003), 1,
      sym_decltype_auto,
    STATE(4508), 1,
      sym_new_declarator,
    STATE(4264), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5664), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_DOT,
    ACTIONS(5666), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [129658] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(7937), 1,
      anon_sym_LBRACK,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    ACTIONS(8035), 1,
      sym_auto,
    ACTIONS(8037), 1,
      anon_sym_decltype,
    STATE(2003), 1,
      sym_decltype_auto,
    STATE(4507), 1,
      sym_new_declarator,
    STATE(4205), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5640), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_DOT,
    ACTIONS(5642), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [129729] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7649), 1,
      anon_sym___attribute__,
    STATE(4360), 1,
      sym_attribute_specifier,
    ACTIONS(5696), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5694), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [129788] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7649), 1,
      anon_sym___attribute__,
    STATE(4373), 1,
      sym_attribute_specifier,
    ACTIONS(5688), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5686), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [129847] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(7937), 1,
      anon_sym_LBRACK,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    ACTIONS(8035), 1,
      sym_auto,
    ACTIONS(8037), 1,
      anon_sym_decltype,
    STATE(2003), 1,
      sym_decltype_auto,
    STATE(4502), 1,
      sym_new_declarator,
    STATE(4258), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5690), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_DOT,
    ACTIONS(5692), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [129918] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(7945), 1,
      anon_sym_LPAREN2,
    STATE(4257), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6024), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6026), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [129979] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7158), 1,
      anon_sym_STAR,
    ACTIONS(7160), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7162), 1,
      anon_sym_AMP,
    STATE(2839), 1,
      sym_parameter_list,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6305), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4460), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8039), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [130060] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7649), 1,
      anon_sym___attribute__,
    STATE(4388), 1,
      sym_attribute_specifier,
    ACTIONS(5727), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5725), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [130119] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7164), 1,
      anon_sym_STAR,
    ACTIONS(7166), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7168), 1,
      anon_sym_AMP,
    STATE(2924), 1,
      sym_parameter_list,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6308), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4460), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8039), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [130200] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(3173), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8041), 1,
      anon_sym_STAR,
    ACTIONS(8043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8045), 1,
      anon_sym_AMP,
    STATE(3079), 1,
      sym_parameter_list,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6946), 1,
      sym__abstract_declarator,
    ACTIONS(7394), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7396), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4315), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5047), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5484), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [130291] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7158), 1,
      anon_sym_STAR,
    ACTIONS(7160), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7162), 1,
      anon_sym_AMP,
    STATE(2839), 1,
      sym_parameter_list,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6301), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4460), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5504), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [130372] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(7945), 1,
      anon_sym_LPAREN2,
    STATE(4262), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6012), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6014), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [130433] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7649), 1,
      anon_sym___attribute__,
    STATE(4380), 1,
      sym_attribute_specifier,
    ACTIONS(5629), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5627), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [130492] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7164), 1,
      anon_sym_STAR,
    ACTIONS(7166), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7168), 1,
      anon_sym_AMP,
    STATE(2924), 1,
      sym_parameter_list,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6319), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4460), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5504), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [130573] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7164), 1,
      anon_sym_STAR,
    ACTIONS(7166), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7168), 1,
      anon_sym_AMP,
    STATE(2924), 1,
      sym_parameter_list,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6320), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4460), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8047), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [130654] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7164), 1,
      anon_sym_STAR,
    ACTIONS(7166), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7168), 1,
      anon_sym_AMP,
    STATE(2924), 1,
      sym_parameter_list,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6327), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4460), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6100), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [130735] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8049), 1,
      sym_identifier,
    ACTIONS(8053), 1,
      sym_primitive_type,
    STATE(4300), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8051), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5325), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(5327), 31,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [130798] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7649), 1,
      anon_sym___attribute__,
    STATE(4378), 1,
      sym_attribute_specifier,
    ACTIONS(5670), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5668), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [130857] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7158), 1,
      anon_sym_STAR,
    ACTIONS(7160), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7162), 1,
      anon_sym_AMP,
    STATE(2839), 1,
      sym_parameter_list,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6294), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4460), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8047), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [130938] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(7945), 1,
      anon_sym_LPAREN2,
    STATE(4216), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5954), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5956), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [130999] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7158), 1,
      anon_sym_STAR,
    ACTIONS(7160), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7162), 1,
      anon_sym_AMP,
    STATE(2839), 1,
      sym_parameter_list,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6300), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4460), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6100), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [131080] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(7123), 1,
      sym_auto,
    ACTIONS(7125), 1,
      anon_sym_decltype,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7708), 1,
      anon_sym_STAR,
    ACTIONS(7710), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7712), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2182), 1,
      sym_decltype_auto,
    STATE(2974), 1,
      sym_parameter_list,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6616), 1,
      sym__abstract_declarator,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4465), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7903), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [131167] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8055), 1,
      anon_sym_LT,
    STATE(4329), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4356), 1,
      sym_template_argument_list,
    ACTIONS(7972), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3756), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3764), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [131232] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8057), 1,
      anon_sym_LT,
    STATE(2230), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2313), 1,
      sym_template_argument_list,
    ACTIONS(4840), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3756), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3764), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [131297] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4302), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5016), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(8059), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5258), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(5261), 31,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [131358] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(7123), 1,
      sym_auto,
    ACTIONS(7125), 1,
      anon_sym_decltype,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7708), 1,
      anon_sym_STAR,
    ACTIONS(7710), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7712), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2182), 1,
      sym_decltype_auto,
    STATE(2974), 1,
      sym_parameter_list,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6680), 1,
      sym__abstract_declarator,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4455), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7885), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [131445] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4302), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8059), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5018), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(5016), 33,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [131504] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7649), 1,
      anon_sym___attribute__,
    STATE(4372), 1,
      sym_attribute_specifier,
    ACTIONS(5684), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5682), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [131563] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7649), 1,
      anon_sym___attribute__,
    STATE(4420), 1,
      sym_attribute_specifier,
    ACTIONS(5676), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5674), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [131622] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(3173), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6960), 1,
      sym__abstract_declarator,
    ACTIONS(7394), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7396), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4023), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5128), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5504), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [131713] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(7945), 1,
      anon_sym_LPAREN2,
    STATE(4226), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5964), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5966), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [131774] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7649), 1,
      anon_sym___attribute__,
    STATE(4414), 1,
      sym_attribute_specifier,
    ACTIONS(5658), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5656), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [131833] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7142), 1,
      anon_sym_STAR,
    ACTIONS(7144), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6351), 1,
      sym__abstract_declarator,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4350), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8039), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [131914] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7649), 1,
      anon_sym___attribute__,
    STATE(4381), 1,
      sym_attribute_specifier,
    ACTIONS(5635), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5633), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [131973] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7142), 1,
      anon_sym_STAR,
    ACTIONS(7144), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6375), 1,
      sym__abstract_declarator,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4350), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6100), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [132054] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(3173), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6923), 1,
      sym__abstract_declarator,
    ACTIONS(7394), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7396), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4305), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5132), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5484), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [132145] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    STATE(4618), 1,
      sym_alignas_qualifier,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7970), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    STATE(4488), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4552), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6142), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
    ACTIONS(7968), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [132214] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7649), 1,
      anon_sym___attribute__,
    STATE(4395), 1,
      sym_attribute_specifier,
    ACTIONS(5700), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5698), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [132273] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7649), 1,
      anon_sym___attribute__,
    STATE(4409), 1,
      sym_attribute_specifier,
    ACTIONS(5723), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5721), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [132332] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(3173), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8041), 1,
      anon_sym_STAR,
    ACTIONS(8043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8045), 1,
      anon_sym_AMP,
    STATE(3079), 1,
      sym_parameter_list,
    STATE(4253), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6951), 1,
      sym__abstract_declarator,
    ACTIONS(7394), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7396), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4023), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5063), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5504), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [132423] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7649), 1,
      anon_sym___attribute__,
    STATE(4415), 1,
      sym_attribute_specifier,
    ACTIONS(5716), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5714), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [132482] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7142), 1,
      anon_sym_STAR,
    ACTIONS(7144), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6370), 1,
      sym__abstract_declarator,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4350), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8047), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [132563] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7142), 1,
      anon_sym_STAR,
    ACTIONS(7144), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6361), 1,
      sym__abstract_declarator,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4350), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5504), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [132644] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(7937), 1,
      anon_sym_LBRACK,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    ACTIONS(8035), 1,
      sym_auto,
    ACTIONS(8037), 1,
      anon_sym_decltype,
    STATE(2003), 1,
      sym_decltype_auto,
    STATE(4520), 1,
      sym_new_declarator,
    STATE(4233), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5704), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_DOT,
    ACTIONS(5706), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [132715] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6110), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6112), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      aux_sym_kernel_call_syntax_token1,
  [132785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5218), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5220), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [132839] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4237), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8064), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5418), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5416), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [132897] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4237), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8064), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5424), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5422), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [132955] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(7796), 1,
      anon_sym_STAR,
    ACTIONS(7798), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7800), 1,
      anon_sym_AMP,
    ACTIONS(8035), 1,
      sym_auto,
    ACTIONS(8037), 1,
      anon_sym_decltype,
    STATE(2003), 1,
      sym_decltype_auto,
    STATE(2941), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6726), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4528), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7903), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [133041] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4342), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8066), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5374), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5376), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [133099] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6106), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6108), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      aux_sym_kernel_call_syntax_token1,
  [133169] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4323), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8068), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5448), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5446), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [133227] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6068), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6070), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_kernel_call_syntax_token1,
  [133295] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4237), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8064), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5434), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5432), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [133353] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7947), 1,
      sym_auto,
    ACTIONS(7949), 1,
      anon_sym_decltype,
    STATE(4394), 1,
      sym_decltype_auto,
    ACTIONS(5171), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5173), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [133413] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4322), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8070), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5442), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5440), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [133471] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7386), 1,
      anon_sym_STAR,
    ACTIONS(7388), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7390), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    STATE(2786), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6419), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6100), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [133551] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5192), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5194), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [133607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5386), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5388), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [133661] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8055), 1,
      anon_sym_LT,
    STATE(4356), 1,
      sym_template_argument_list,
    ACTIONS(5212), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(3782), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [133721] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8057), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_template_argument_list,
    ACTIONS(5212), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(3782), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [133781] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(7796), 1,
      anon_sym_STAR,
    ACTIONS(7798), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7800), 1,
      anon_sym_AMP,
    ACTIONS(8035), 1,
      sym_auto,
    ACTIONS(8037), 1,
      anon_sym_decltype,
    STATE(2003), 1,
      sym_decltype_auto,
    STATE(2941), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6751), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4501), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7885), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [133867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5374), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5376), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [133921] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6102), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6104), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      aux_sym_kernel_call_syntax_token1,
  [133991] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6096), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6098), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_kernel_call_syntax_token1,
  [134059] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    STATE(1651), 1,
      sym_template_argument_list,
    STATE(4490), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5530), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(8072), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5532), 36,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [134123] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4237), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8064), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5438), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5436), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [134181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5242), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5244), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [134235] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7386), 1,
      anon_sym_STAR,
    ACTIONS(7388), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7390), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    STATE(2786), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6445), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8039), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [134315] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8074), 1,
      anon_sym_LT,
    STATE(4356), 1,
      sym_template_argument_list,
    ACTIONS(4000), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4007), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [134375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5358), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5360), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [134429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5203), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5205), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [134483] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7386), 1,
      anon_sym_STAR,
    ACTIONS(7388), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7390), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    STATE(2786), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6427), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5504), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [134563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5234), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5236), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [134617] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8084), 1,
      anon_sym_const,
    STATE(1830), 1,
      sym_alignas_qualifier,
    ACTIONS(8079), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(8087), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4350), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8081), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
    ACTIONS(8077), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [134681] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8090), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_template_argument_list,
    ACTIONS(4000), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4007), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [134741] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7386), 1,
      anon_sym_STAR,
    ACTIONS(7388), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7390), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    STATE(2786), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6426), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8047), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [134821] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6064), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6066), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      aux_sym_kernel_call_syntax_token1,
  [134891] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4426), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5374), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5376), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [134948] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8099), 1,
      anon_sym_SLASH,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8095), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8097), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6064), 14,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6066), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      aux_sym_kernel_call_syntax_token1,
  [135023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4142), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4149), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [135076] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8099), 1,
      anon_sym_SLASH,
    ACTIONS(8101), 1,
      anon_sym_LT_LT,
    ACTIONS(8103), 1,
      anon_sym_GT_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8095), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8097), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6064), 13,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6066), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      aux_sym_kernel_call_syntax_token1,
  [135155] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5254), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5256), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [135208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3984), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(3986), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [135261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5250), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5252), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [135314] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8099), 1,
      anon_sym_SLASH,
    ACTIONS(8101), 1,
      anon_sym_LT_LT,
    ACTIONS(8103), 1,
      anon_sym_GT_GT,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8107), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8113), 1,
      anon_sym_CARET,
    ACTIONS(8121), 1,
      anon_sym_GT_EQ,
    ACTIONS(8123), 1,
      anon_sym_QMARK,
    ACTIONS(8125), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8127), 1,
      anon_sym_or,
    ACTIONS(8129), 1,
      anon_sym_and,
    ACTIONS(8131), 1,
      anon_sym_xor,
    ACTIONS(8133), 1,
      anon_sym_not_eq,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6768), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8095), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8097), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8111), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8115), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8117), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8119), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6770), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [135425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3980), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(3982), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [135478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5248), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [135531] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7606), 1,
      anon_sym_STAR,
    ACTIONS(7608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7610), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2909), 1,
      sym_parameter_list,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6558), 1,
      sym__abstract_declarator,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4350), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6100), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [135610] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7617), 1,
      anon_sym_STAR,
    ACTIONS(7619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7621), 1,
      anon_sym_AMP,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6585), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4460), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8047), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [135689] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8099), 1,
      anon_sym_SLASH,
    ACTIONS(8101), 1,
      anon_sym_LT_LT,
    ACTIONS(8103), 1,
      anon_sym_GT_GT,
    ACTIONS(8113), 1,
      anon_sym_CARET,
    ACTIONS(8121), 1,
      anon_sym_GT_EQ,
    ACTIONS(8125), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8131), 1,
      anon_sym_xor,
    ACTIONS(8133), 1,
      anon_sym_not_eq,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8095), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8097), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8111), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8115), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8117), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8119), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 4,
      aux_sym_preproc_elif_token1,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
    ACTIONS(6066), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
  [135786] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(7937), 1,
      anon_sym_LBRACK,
    ACTIONS(7945), 1,
      anon_sym_LPAREN2,
    ACTIONS(8035), 1,
      sym_auto,
    ACTIONS(8037), 1,
      anon_sym_decltype,
    STATE(2003), 1,
      sym_decltype_auto,
    STATE(4295), 1,
      sym_new_declarator,
    STATE(4258), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5690), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_DOT,
    ACTIONS(5692), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [135855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3996), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(3998), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [135908] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8099), 1,
      anon_sym_SLASH,
    ACTIONS(8101), 1,
      anon_sym_LT_LT,
    ACTIONS(8103), 1,
      anon_sym_GT_GT,
    ACTIONS(8107), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8113), 1,
      anon_sym_CARET,
    ACTIONS(8121), 1,
      anon_sym_GT_EQ,
    ACTIONS(8125), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8127), 1,
      anon_sym_or,
    ACTIONS(8129), 1,
      anon_sym_and,
    ACTIONS(8131), 1,
      anon_sym_xor,
    ACTIONS(8133), 1,
      anon_sym_not_eq,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6772), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8095), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8097), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8111), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8115), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8117), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8119), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6774), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
  [136013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5238), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5240), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [136066] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 1,
      anon_sym___attribute__,
    ACTIONS(5913), 1,
      anon_sym_LBRACE,
    ACTIONS(8135), 1,
      anon_sym_COLON,
    STATE(2353), 1,
      sym__enum_base_clause,
    STATE(2384), 1,
      sym_enumerator_list,
    STATE(2616), 1,
      sym_attribute_specifier,
    ACTIONS(6042), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6044), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [136131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5222), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5224), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [136184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5214), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5216), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [136237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5226), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5228), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [136290] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7617), 1,
      anon_sym_STAR,
    ACTIONS(7619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7621), 1,
      anon_sym_AMP,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6553), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4460), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5504), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [136369] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8099), 1,
      anon_sym_SLASH,
    ACTIONS(8101), 1,
      anon_sym_LT_LT,
    ACTIONS(8103), 1,
      anon_sym_GT_GT,
    ACTIONS(8113), 1,
      anon_sym_CARET,
    ACTIONS(8121), 1,
      anon_sym_GT_EQ,
    ACTIONS(8125), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8131), 1,
      anon_sym_xor,
    ACTIONS(8133), 1,
      anon_sym_not_eq,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8095), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8097), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8115), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8117), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8119), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      sym_identifier,
    ACTIONS(6066), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
  [136464] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(7937), 1,
      anon_sym_LBRACK,
    ACTIONS(7945), 1,
      anon_sym_LPAREN2,
    ACTIONS(8035), 1,
      sym_auto,
    ACTIONS(8037), 1,
      anon_sym_decltype,
    STATE(2003), 1,
      sym_decltype_auto,
    STATE(4287), 1,
      sym_new_declarator,
    STATE(4264), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5664), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_DOT,
    ACTIONS(5666), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [136533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5230), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5232), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [136586] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8099), 1,
      anon_sym_SLASH,
    ACTIONS(8101), 1,
      anon_sym_LT_LT,
    ACTIONS(8103), 1,
      anon_sym_GT_GT,
    ACTIONS(8121), 1,
      anon_sym_GT_EQ,
    ACTIONS(8125), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8133), 1,
      anon_sym_not_eq,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8095), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8097), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8115), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8117), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8119), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 7,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      sym_identifier,
    ACTIONS(6066), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
  [136677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5281), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5283), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [136730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5362), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5364), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [136783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3992), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(3994), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [136836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4023), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [136889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5366), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5368), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [136942] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4443), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5448), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8137), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5446), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [136999] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4439), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5442), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8139), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5440), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [137056] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8099), 1,
      anon_sym_SLASH,
    ACTIONS(8101), 1,
      anon_sym_LT_LT,
    ACTIONS(8103), 1,
      anon_sym_GT_GT,
    ACTIONS(8109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8113), 1,
      anon_sym_CARET,
    ACTIONS(8121), 1,
      anon_sym_GT_EQ,
    ACTIONS(8125), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8129), 1,
      anon_sym_and,
    ACTIONS(8131), 1,
      anon_sym_xor,
    ACTIONS(8133), 1,
      anon_sym_not_eq,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8095), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8097), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8111), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8115), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8117), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6064), 3,
      aux_sym_preproc_elif_token1,
      anon_sym_or,
      sym_identifier,
    ACTIONS(8119), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
  [137157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5289), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5291), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [137210] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    STATE(1830), 1,
      sym_alignas_qualifier,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7970), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    STATE(4350), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
    ACTIONS(7968), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [137273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5293), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5295), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [137326] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8099), 1,
      anon_sym_SLASH,
    ACTIONS(8101), 1,
      anon_sym_LT_LT,
    ACTIONS(8103), 1,
      anon_sym_GT_GT,
    ACTIONS(8121), 1,
      anon_sym_GT_EQ,
    ACTIONS(8125), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8133), 1,
      anon_sym_not_eq,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8095), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8097), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8117), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8119), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 9,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      sym_identifier,
    ACTIONS(6066), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
  [137415] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8141), 1,
      sym_identifier,
    ACTIONS(8145), 1,
      sym_primitive_type,
    STATE(4405), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8143), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5325), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5327), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [137476] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8147), 1,
      anon_sym_LT,
    STATE(4490), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4492), 1,
      sym_template_argument_list,
    ACTIONS(3756), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(8072), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3764), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [137539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5277), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5279), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [137592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5378), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5380), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [137645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5319), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5321), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [137698] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(7937), 1,
      anon_sym_LBRACK,
    ACTIONS(7945), 1,
      anon_sym_LPAREN2,
    ACTIONS(8035), 1,
      sym_auto,
    ACTIONS(8037), 1,
      anon_sym_decltype,
    STATE(2003), 1,
      sym_decltype_auto,
    STATE(4281), 1,
      sym_new_declarator,
    STATE(4205), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5640), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_DOT,
    ACTIONS(5642), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [137767] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7606), 1,
      anon_sym_STAR,
    ACTIONS(7608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7610), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2909), 1,
      sym_parameter_list,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6555), 1,
      sym__abstract_declarator,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4350), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8047), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [137846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4017), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4019), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [137899] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8147), 1,
      anon_sym_LT,
    STATE(4492), 1,
      sym_template_argument_list,
    ACTIONS(5212), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(3782), 39,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [137958] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5382), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5384), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [138011] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(5504), 1,
      anon_sym_COLON,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8023), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8029), 1,
      anon_sym_const,
    ACTIONS(8149), 1,
      anon_sym_STAR,
    ACTIONS(8151), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8153), 1,
      anon_sym_AMP,
    STATE(3421), 1,
      sym_parameter_list,
    STATE(5368), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5599), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7063), 1,
      sym__abstract_declarator,
    ACTIONS(8025), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8027), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8031), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5202), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5300), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8021), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [138100] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4403), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8155), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5018), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5016), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [138157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5248), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [138210] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4403), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5016), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(8155), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5258), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5261), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [138269] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8099), 1,
      anon_sym_SLASH,
    ACTIONS(8101), 1,
      anon_sym_LT_LT,
    ACTIONS(8103), 1,
      anon_sym_GT_GT,
    ACTIONS(8107), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8113), 1,
      anon_sym_CARET,
    ACTIONS(8121), 1,
      anon_sym_GT_EQ,
    ACTIONS(8125), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8127), 1,
      anon_sym_or,
    ACTIONS(8129), 1,
      anon_sym_and,
    ACTIONS(8131), 1,
      anon_sym_xor,
    ACTIONS(8133), 1,
      anon_sym_not_eq,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6782), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8095), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8097), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8111), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8115), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8117), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8119), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6784), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
  [138374] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(5484), 1,
      anon_sym_COLON,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8023), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8029), 1,
      anon_sym_const,
    ACTIONS(8149), 1,
      anon_sym_STAR,
    ACTIONS(8151), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8153), 1,
      anon_sym_AMP,
    STATE(3421), 1,
      sym_parameter_list,
    STATE(5368), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5599), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7073), 1,
      sym__abstract_declarator,
    ACTIONS(8025), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8027), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8031), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4402), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5192), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8021), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [138463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5336), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5338), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [138516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5370), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5372), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [138569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5248), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [138622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5315), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5317), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [138675] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(6114), 1,
      sym_auto,
    ACTIONS(6116), 1,
      anon_sym_decltype,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_STAR,
    ACTIONS(7889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7891), 1,
      anon_sym_AMP,
    STATE(2573), 1,
      sym_decltype_auto,
    STATE(3056), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6769), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7903), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [138760] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8099), 1,
      anon_sym_SLASH,
    ACTIONS(8101), 1,
      anon_sym_LT_LT,
    ACTIONS(8103), 1,
      anon_sym_GT_GT,
    ACTIONS(8121), 1,
      anon_sym_GT_EQ,
    ACTIONS(8125), 1,
      anon_sym_LT_EQ_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8095), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8097), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8119), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6064), 10,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6066), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
  [138845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5297), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5299), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [138898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5354), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5356), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [138951] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5921), 1,
      anon_sym_LBRACE,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(8158), 1,
      anon_sym_COLON,
    STATE(2184), 1,
      sym_attribute_specifier,
    STATE(2845), 1,
      sym__enum_base_clause,
    STATE(2902), 1,
      sym_enumerator_list,
    ACTIONS(6048), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6050), 36,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [139016] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8099), 1,
      anon_sym_SLASH,
    ACTIONS(8101), 1,
      anon_sym_LT_LT,
    ACTIONS(8103), 1,
      anon_sym_GT_GT,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8107), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8113), 1,
      anon_sym_CARET,
    ACTIONS(8121), 1,
      anon_sym_GT_EQ,
    ACTIONS(8123), 1,
      anon_sym_QMARK,
    ACTIONS(8125), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8127), 1,
      anon_sym_or,
    ACTIONS(8129), 1,
      anon_sym_and,
    ACTIONS(8131), 1,
      anon_sym_xor,
    ACTIONS(8133), 1,
      anon_sym_not_eq,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8095), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8097), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8111), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8115), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8117), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8160), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8119), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8162), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [139127] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5185), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(5187), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [139182] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4426), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5192), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5194), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [139239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5311), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5313), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [139292] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym___attribute__,
    ACTIONS(8164), 1,
      anon_sym_LBRACE,
    ACTIONS(8166), 1,
      anon_sym_COLON,
    STATE(4524), 1,
      sym__enum_base_clause,
    STATE(4573), 1,
      sym_enumerator_list,
    STATE(4837), 1,
      sym_attribute_specifier,
    ACTIONS(6048), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6050), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [139357] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4342), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8066), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5192), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5194), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [139414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5196), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(5198), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [139467] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    STATE(1830), 1,
      sym_alignas_qualifier,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8170), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    STATE(4350), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
    ACTIONS(8168), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [139530] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8099), 1,
      anon_sym_SLASH,
    ACTIONS(8101), 1,
      anon_sym_LT_LT,
    ACTIONS(8103), 1,
      anon_sym_GT_GT,
    ACTIONS(8125), 1,
      anon_sym_LT_EQ_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8095), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8097), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6064), 13,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6066), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
  [139611] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4302), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5438), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8172), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5436), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [139668] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8099), 1,
      anon_sym_SLASH,
    ACTIONS(8101), 1,
      anon_sym_LT_LT,
    ACTIONS(8103), 1,
      anon_sym_GT_GT,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8107), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8113), 1,
      anon_sym_CARET,
    ACTIONS(8121), 1,
      anon_sym_GT_EQ,
    ACTIONS(8123), 1,
      anon_sym_QMARK,
    ACTIONS(8125), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8127), 1,
      anon_sym_or,
    ACTIONS(8129), 1,
      anon_sym_and,
    ACTIONS(8131), 1,
      anon_sym_xor,
    ACTIONS(8133), 1,
      anon_sym_not_eq,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6374), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8095), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8097), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8111), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8115), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8117), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8119), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6376), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [139779] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7617), 1,
      anon_sym_STAR,
    ACTIONS(7619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7621), 1,
      anon_sym_AMP,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6577), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4460), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8039), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [139858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5336), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5338), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [139911] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4302), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5434), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8172), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5432), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [139968] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(6114), 1,
      sym_auto,
    ACTIONS(6116), 1,
      anon_sym_decltype,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_STAR,
    ACTIONS(7889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7891), 1,
      anon_sym_AMP,
    STATE(2573), 1,
      sym_decltype_auto,
    STATE(3056), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6773), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4543), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7885), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [140053] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5921), 1,
      anon_sym_LBRACE,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(8158), 1,
      anon_sym_COLON,
    STATE(2175), 1,
      sym_attribute_specifier,
    STATE(2858), 1,
      sym__enum_base_clause,
    STATE(2901), 1,
      sym_enumerator_list,
    ACTIONS(6042), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6044), 36,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [140118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5179), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(5181), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [140173] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(7937), 1,
      anon_sym_LBRACK,
    ACTIONS(7945), 1,
      anon_sym_LPAREN2,
    ACTIONS(8035), 1,
      sym_auto,
    ACTIONS(8037), 1,
      anon_sym_decltype,
    STATE(2003), 1,
      sym_decltype_auto,
    STATE(4306), 1,
      sym_new_declarator,
    STATE(4233), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5704), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_DOT,
    ACTIONS(5706), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [140242] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5179), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(5181), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [140297] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym___attribute__,
    ACTIONS(8164), 1,
      anon_sym_LBRACE,
    ACTIONS(8166), 1,
      anon_sym_COLON,
    STATE(4477), 1,
      sym__enum_base_clause,
    STATE(4541), 1,
      sym_enumerator_list,
    STATE(4807), 1,
      sym_attribute_specifier,
    ACTIONS(6042), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6044), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [140362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5285), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5287), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [140415] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7617), 1,
      anon_sym_STAR,
    ACTIONS(7619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7621), 1,
      anon_sym_AMP,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6521), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4460), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6100), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [140494] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4302), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5418), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8172), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5416), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [140551] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8147), 1,
      anon_sym_LT,
    STATE(4492), 1,
      sym_template_argument_list,
    ACTIONS(4000), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4007), 39,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [140610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5352), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [140663] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8099), 1,
      anon_sym_SLASH,
    ACTIONS(8101), 1,
      anon_sym_LT_LT,
    ACTIONS(8103), 1,
      anon_sym_GT_GT,
    ACTIONS(8107), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8113), 1,
      anon_sym_CARET,
    ACTIONS(8121), 1,
      anon_sym_GT_EQ,
    ACTIONS(8125), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8127), 1,
      anon_sym_or,
    ACTIONS(8129), 1,
      anon_sym_and,
    ACTIONS(8131), 1,
      anon_sym_xor,
    ACTIONS(8133), 1,
      anon_sym_not_eq,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6764), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8095), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8097), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8111), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8115), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8117), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8119), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6766), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
  [140768] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4302), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5424), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8172), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5422), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [140825] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7606), 1,
      anon_sym_STAR,
    ACTIONS(7608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7610), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2909), 1,
      sym_parameter_list,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6550), 1,
      sym__abstract_declarator,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4350), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8039), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [140904] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 1,
      anon_sym___attribute__,
    ACTIONS(5913), 1,
      anon_sym_LBRACE,
    ACTIONS(8135), 1,
      anon_sym_COLON,
    STATE(2360), 1,
      sym__enum_base_clause,
    STATE(2374), 1,
      sym_enumerator_list,
    STATE(2586), 1,
      sym_attribute_specifier,
    ACTIONS(6048), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6050), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [140969] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8099), 1,
      anon_sym_SLASH,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8097), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6064), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6066), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      aux_sym_kernel_call_syntax_token1,
  [141042] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8099), 1,
      anon_sym_SLASH,
    ACTIONS(8101), 1,
      anon_sym_LT_LT,
    ACTIONS(8103), 1,
      anon_sym_GT_GT,
    ACTIONS(8107), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8113), 1,
      anon_sym_CARET,
    ACTIONS(8121), 1,
      anon_sym_GT_EQ,
    ACTIONS(8125), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8127), 1,
      anon_sym_or,
    ACTIONS(8129), 1,
      anon_sym_and,
    ACTIONS(8131), 1,
      anon_sym_xor,
    ACTIONS(8133), 1,
      anon_sym_not_eq,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6720), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8095), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8097), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8111), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8115), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8117), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8119), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6722), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
  [141147] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8099), 1,
      anon_sym_SLASH,
    ACTIONS(8101), 1,
      anon_sym_LT_LT,
    ACTIONS(8103), 1,
      anon_sym_GT_GT,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8107), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8113), 1,
      anon_sym_CARET,
    ACTIONS(8121), 1,
      anon_sym_GT_EQ,
    ACTIONS(8123), 1,
      anon_sym_QMARK,
    ACTIONS(8125), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8127), 1,
      anon_sym_or,
    ACTIONS(8129), 1,
      anon_sym_and,
    ACTIONS(8131), 1,
      anon_sym_xor,
    ACTIONS(8133), 1,
      anon_sym_not_eq,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6754), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8095), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8097), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8111), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8115), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8117), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8119), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6758), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [141258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3988), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(3990), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [141311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5301), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5303), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [141364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5340), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5342), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [141417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5192), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5194), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [141470] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7606), 1,
      anon_sym_STAR,
    ACTIONS(7608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7610), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2909), 1,
      sym_parameter_list,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6554), 1,
      sym__abstract_declarator,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4350), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5504), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [141549] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7905), 1,
      sym_auto,
    ACTIONS(7907), 1,
      anon_sym_decltype,
    ACTIONS(7951), 1,
      anon_sym_STAR,
    ACTIONS(7953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7955), 1,
      anon_sym_AMP,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(4997), 1,
      sym_decltype_auto,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6854), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4711), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7885), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [141633] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7708), 1,
      anon_sym_STAR,
    ACTIONS(7710), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7712), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2974), 1,
      sym_parameter_list,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6669), 1,
      sym__abstract_declarator,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4350), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8039), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [141711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6360), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [141763] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8178), 1,
      anon_sym___attribute__,
    STATE(4457), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(8176), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8174), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [141819] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7708), 1,
      anon_sym_STAR,
    ACTIONS(7710), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7712), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2974), 1,
      sym_parameter_list,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6663), 1,
      sym__abstract_declarator,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4350), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6100), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [141897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6264), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [141949] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8184), 1,
      anon_sym_const,
    STATE(4618), 1,
      sym_alignas_qualifier,
    ACTIONS(8079), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(8187), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4460), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8181), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
    ACTIONS(8077), 19,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [142011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5179), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5181), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [142063] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3716), 1,
      anon_sym_LBRACE,
    ACTIONS(8190), 1,
      anon_sym_LPAREN2,
    ACTIONS(8192), 1,
      anon_sym_LBRACK,
    ACTIONS(8194), 1,
      sym_auto,
    ACTIONS(8196), 1,
      anon_sym_decltype,
    STATE(4786), 1,
      sym_decltype_auto,
    STATE(4964), 1,
      sym_new_declarator,
    STATE(5251), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5664), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5666), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [142131] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7905), 1,
      sym_auto,
    ACTIONS(7907), 1,
      anon_sym_decltype,
    ACTIONS(7951), 1,
      anon_sym_STAR,
    ACTIONS(7953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7955), 1,
      anon_sym_AMP,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(4997), 1,
      sym_decltype_auto,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6844), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4721), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7903), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [142215] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym_LBRACE,
    ACTIONS(6114), 1,
      sym_auto,
    ACTIONS(6116), 1,
      anon_sym_decltype,
    ACTIONS(8198), 1,
      anon_sym_LPAREN2,
    ACTIONS(8200), 1,
      anon_sym_LBRACK,
    STATE(2573), 1,
      sym_decltype_auto,
    STATE(4919), 1,
      sym_new_declarator,
    STATE(5318), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5664), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5666), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [142283] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7708), 1,
      anon_sym_STAR,
    ACTIONS(7710), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7712), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2974), 1,
      sym_parameter_list,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6664), 1,
      sym__abstract_declarator,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4350), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8047), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [142361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6509), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6511), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [142413] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(8202), 1,
      anon_sym_LBRACE,
    STATE(4664), 1,
      sym_field_declaration_list,
    STATE(4808), 1,
      sym_attribute_specifier,
    STATE(7133), 1,
      sym_virtual_specifier,
    STATE(7847), 1,
      sym_base_class_clause,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5508), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5506), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_try,
      anon_sym_requires,
  [142481] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7708), 1,
      anon_sym_STAR,
    ACTIONS(7710), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7712), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2974), 1,
      sym_parameter_list,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6661), 1,
      sym__abstract_declarator,
    ACTIONS(6629), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4350), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5504), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6625), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [142559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6282), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6284), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [142611] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym_LBRACE,
    ACTIONS(6114), 1,
      sym_auto,
    ACTIONS(6116), 1,
      anon_sym_decltype,
    ACTIONS(8198), 1,
      anon_sym_LPAREN2,
    ACTIONS(8200), 1,
      anon_sym_LBRACK,
    STATE(2573), 1,
      sym_decltype_auto,
    STATE(4947), 1,
      sym_new_declarator,
    STATE(5323), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5690), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5692), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [142679] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    STATE(1651), 1,
      sym_template_argument_list,
    STATE(2132), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5530), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4812), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5532), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [142741] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym_LBRACE,
    ACTIONS(6114), 1,
      sym_auto,
    ACTIONS(6116), 1,
      anon_sym_decltype,
    ACTIONS(8198), 1,
      anon_sym_LPAREN2,
    ACTIONS(8200), 1,
      anon_sym_LBRACK,
    STATE(2573), 1,
      sym_decltype_auto,
    STATE(4914), 1,
      sym_new_declarator,
    STATE(5229), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5704), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5706), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [142809] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3716), 1,
      anon_sym_LBRACE,
    ACTIONS(8190), 1,
      anon_sym_LPAREN2,
    ACTIONS(8192), 1,
      anon_sym_LBRACK,
    ACTIONS(8194), 1,
      sym_auto,
    ACTIONS(8196), 1,
      anon_sym_decltype,
    STATE(4786), 1,
      sym_decltype_auto,
    STATE(4822), 1,
      sym_new_declarator,
    STATE(5177), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5690), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5692), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [142877] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3716), 1,
      anon_sym_LBRACE,
    ACTIONS(8190), 1,
      anon_sym_LPAREN2,
    ACTIONS(8192), 1,
      anon_sym_LBRACK,
    ACTIONS(8194), 1,
      sym_auto,
    ACTIONS(8196), 1,
      anon_sym_decltype,
    STATE(4786), 1,
      sym_decltype_auto,
    STATE(4981), 1,
      sym_new_declarator,
    STATE(5176), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5640), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5642), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [142945] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym_LBRACE,
    ACTIONS(6114), 1,
      sym_auto,
    ACTIONS(6116), 1,
      anon_sym_decltype,
    ACTIONS(8198), 1,
      anon_sym_LPAREN2,
    ACTIONS(8200), 1,
      anon_sym_LBRACK,
    STATE(2573), 1,
      sym_decltype_auto,
    STATE(4921), 1,
      sym_new_declarator,
    STATE(5261), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5640), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5642), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [143013] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3716), 1,
      anon_sym_LBRACE,
    ACTIONS(8190), 1,
      anon_sym_LPAREN2,
    ACTIONS(8192), 1,
      anon_sym_LBRACK,
    ACTIONS(8194), 1,
      sym_auto,
    ACTIONS(8196), 1,
      anon_sym_decltype,
    STATE(4763), 1,
      sym_new_declarator,
    STATE(4786), 1,
      sym_decltype_auto,
    STATE(5225), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5704), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5706), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [143081] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym___attribute__,
    ACTIONS(8164), 1,
      anon_sym_LBRACE,
    STATE(4579), 1,
      sym_enumerator_list,
    STATE(4844), 1,
      sym_attribute_specifier,
    ACTIONS(5612), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5610), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [143140] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(7796), 1,
      anon_sym_STAR,
    ACTIONS(7798), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7800), 1,
      anon_sym_AMP,
    STATE(2941), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6735), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5504), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [143217] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym_literal_suffix,
    ACTIONS(5710), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5712), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [143270] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3957), 1,
      anon_sym_LPAREN2,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5494), 1,
      anon_sym_LBRACK,
    ACTIONS(5619), 1,
      anon_sym_STAR,
    ACTIONS(8204), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8208), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8210), 1,
      anon_sym_AMP,
    ACTIONS(8212), 1,
      anon_sym_EQ,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6799), 1,
      sym__declarator,
    STATE(6983), 1,
      sym__abstract_declarator,
    STATE(7050), 1,
      sym_abstract_reference_declarator,
    STATE(7510), 1,
      sym_variadic_reference_declarator,
    STATE(7552), 1,
      sym_variadic_declarator,
    STATE(8387), 1,
      sym_ms_based_modifier,
    ACTIONS(8206), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [143371] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8015), 1,
      anon_sym_STAR,
    ACTIONS(8017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8019), 1,
      anon_sym_AMP,
    ACTIONS(8029), 1,
      anon_sym_const,
    ACTIONS(8035), 1,
      sym_auto,
    ACTIONS(8037), 1,
      anon_sym_decltype,
    STATE(2003), 1,
      sym_decltype_auto,
    STATE(3439), 1,
      sym_parameter_list,
    STATE(5599), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6899), 1,
      sym__abstract_declarator,
    ACTIONS(8031), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4882), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7885), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8021), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [143454] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym_literal_suffix,
    ACTIONS(3766), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3758), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [143507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6981), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6983), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [143558] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5151), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5149), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [143609] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    STATE(4618), 1,
      sym_alignas_qualifier,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7970), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    STATE(4460), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
    ACTIONS(7968), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [143670] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(7796), 1,
      anon_sym_STAR,
    ACTIONS(7798), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7800), 1,
      anon_sym_AMP,
    STATE(2941), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6692), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6100), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [143747] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6096), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
    ACTIONS(6098), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_kernel_call_syntax_token1,
  [143812] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    STATE(4618), 1,
      sym_alignas_qualifier,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8170), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    STATE(4460), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
    ACTIONS(8168), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [143873] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4403), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5438), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(8214), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5436), 36,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [143928] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4403), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5434), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(8214), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5432), 36,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [143983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5196), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(5198), 40,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [144034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4142), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4149), 40,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [144085] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4496), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5442), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(8216), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5440), 36,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [144140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6173), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6175), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [144191] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4497), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5448), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(8218), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5446), 36,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [144246] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4403), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5418), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(8214), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5416), 36,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [144301] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4403), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5424), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(8214), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5422), 36,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [144356] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6068), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
    ACTIONS(6070), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_kernel_call_syntax_token1,
  [144421] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4489), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5374), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(8220), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5376), 36,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [144476] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(8222), 1,
      anon_sym___attribute__,
    ACTIONS(8224), 1,
      anon_sym_LBRACE,
    STATE(5071), 1,
      sym_field_declaration_list,
    STATE(5303), 1,
      sym_attribute_specifier,
    STATE(7292), 1,
      sym_virtual_specifier,
    STATE(8074), 1,
      sym_base_class_clause,
    ACTIONS(5508), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5506), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [144543] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(7796), 1,
      anon_sym_STAR,
    ACTIONS(7798), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7800), 1,
      anon_sym_AMP,
    STATE(2941), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6694), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8039), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [144620] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    STATE(4216), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5954), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_DOT,
    ACTIONS(5956), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [144677] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8015), 1,
      anon_sym_STAR,
    ACTIONS(8017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8019), 1,
      anon_sym_AMP,
    ACTIONS(8029), 1,
      anon_sym_const,
    ACTIONS(8035), 1,
      sym_auto,
    ACTIONS(8037), 1,
      anon_sym_decltype,
    STATE(2003), 1,
      sym_decltype_auto,
    STATE(3439), 1,
      sym_parameter_list,
    STATE(5599), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6907), 1,
      sym__abstract_declarator,
    ACTIONS(8031), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4887), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7903), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8021), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [144760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6155), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6157), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [144811] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5179), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(5181), 39,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [144864] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(8226), 1,
      anon_sym_LBRACE,
    ACTIONS(8228), 1,
      anon_sym_COLON,
    STATE(4550), 1,
      sym__enum_base_clause,
    STATE(4702), 1,
      sym_enumerator_list,
    STATE(4794), 1,
      sym_attribute_specifier,
    ACTIONS(6042), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6044), 34,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [144927] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    STATE(4257), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6024), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_DOT,
    ACTIONS(6026), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [144984] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    STATE(4262), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6012), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_DOT,
    ACTIONS(6014), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [145041] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(8236), 1,
      anon_sym_SLASH,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8246), 1,
      anon_sym_AMP,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8254), 1,
      anon_sym_LT_LT,
    ACTIONS(8256), 1,
      anon_sym_GT_GT,
    ACTIONS(8258), 1,
      anon_sym_SEMI,
    ACTIONS(8260), 1,
      anon_sym_QMARK,
    ACTIONS(8262), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8264), 1,
      anon_sym_bitor,
    ACTIONS(8266), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7075), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    STATE(8329), 1,
      sym_attribute_specifier,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8232), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8234), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8238), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8240), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8244), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8248), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [145152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3988), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(3990), 40,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [145203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2588), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2586), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [145254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4017), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4019), 40,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [145305] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3957), 1,
      anon_sym_LPAREN2,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5494), 1,
      anon_sym_LBRACK,
    ACTIONS(5591), 1,
      anon_sym_STAR,
    ACTIONS(8204), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8208), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8210), 1,
      anon_sym_AMP,
    ACTIONS(8268), 1,
      anon_sym_EQ,
    STATE(3079), 1,
      sym_parameter_list,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6777), 1,
      sym__declarator,
    STATE(7022), 1,
      sym__abstract_declarator,
    STATE(7076), 1,
      sym_abstract_reference_declarator,
    STATE(7510), 1,
      sym_variadic_reference_declarator,
    STATE(7552), 1,
      sym_variadic_declarator,
    STATE(8387), 1,
      sym_ms_based_modifier,
    ACTIONS(8206), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [145406] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    STATE(1651), 1,
      sym_template_argument_list,
    STATE(2230), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5530), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(4840), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5532), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [145467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4023), 40,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [145518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3992), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(3994), 40,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [145569] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6106), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
    ACTIONS(6108), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [145636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3996), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(3998), 40,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [145687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3980), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(3982), 40,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [145738] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    STATE(4226), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5964), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_DOT,
    ACTIONS(5966), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [145795] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1830), 1,
      sym_alignas_qualifier,
    ACTIONS(8270), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8077), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    ACTIONS(8079), 16,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
    ACTIONS(8084), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [145854] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5179), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(5181), 39,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [145907] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6064), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
    ACTIONS(6066), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [145974] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym___attribute__,
    ACTIONS(8164), 1,
      anon_sym_LBRACE,
    STATE(4593), 1,
      sym_enumerator_list,
    STATE(4870), 1,
      sym_attribute_specifier,
    ACTIONS(5599), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5597), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [146033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5145), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5147), 40,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [146084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3984), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(3986), 40,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [146135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6230), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6232), 40,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [146186] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(7796), 1,
      anon_sym_STAR,
    ACTIONS(7798), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7800), 1,
      anon_sym_AMP,
    STATE(2941), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6721), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8047), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [146263] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(8236), 1,
      anon_sym_SLASH,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8246), 1,
      anon_sym_AMP,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8254), 1,
      anon_sym_LT_LT,
    ACTIONS(8256), 1,
      anon_sym_GT_GT,
    ACTIONS(8260), 1,
      anon_sym_QMARK,
    ACTIONS(8262), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8264), 1,
      anon_sym_bitor,
    ACTIONS(8266), 1,
      anon_sym_bitand,
    ACTIONS(8273), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7065), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    STATE(8980), 1,
      sym_attribute_specifier,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8232), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8234), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8238), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8240), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8244), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8248), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146374] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6110), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
    ACTIONS(6112), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [146441] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(8226), 1,
      anon_sym_LBRACE,
    ACTIONS(8228), 1,
      anon_sym_COLON,
    STATE(4597), 1,
      sym__enum_base_clause,
    STATE(4636), 1,
      sym_enumerator_list,
    STATE(4878), 1,
      sym_attribute_specifier,
    ACTIONS(6048), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6050), 34,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [146504] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5185), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(5187), 39,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [146557] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(8236), 1,
      anon_sym_SLASH,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8246), 1,
      anon_sym_AMP,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8254), 1,
      anon_sym_LT_LT,
    ACTIONS(8256), 1,
      anon_sym_GT_GT,
    ACTIONS(8260), 1,
      anon_sym_QMARK,
    ACTIONS(8262), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8264), 1,
      anon_sym_bitor,
    ACTIONS(8266), 1,
      anon_sym_bitand,
    ACTIONS(8275), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7033), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    STATE(8773), 1,
      sym_attribute_specifier,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8232), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8234), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8238), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8240), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8244), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8248), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146668] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8277), 1,
      anon_sym_LT,
    STATE(2053), 1,
      sym_template_argument_list,
    STATE(2132), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3756), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4812), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3764), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [146729] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6102), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
    ACTIONS(6104), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [146796] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3957), 1,
      anon_sym_LPAREN2,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5486), 1,
      anon_sym_STAR,
    ACTIONS(5488), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5490), 1,
      anon_sym_AMP,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5494), 1,
      anon_sym_LBRACK,
    ACTIONS(8204), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(2819), 1,
      sym_parameter_list,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6642), 1,
      sym__declarator,
    STATE(6734), 1,
      sym__abstract_declarator,
    STATE(7600), 1,
      sym_variadic_declarator,
    STATE(8387), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8279), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [146891] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym___attribute__,
    STATE(4812), 1,
      sym_attribute_specifier,
    ACTIONS(5696), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5694), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [146945] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8035), 1,
      sym_auto,
    ACTIONS(8037), 1,
      anon_sym_decltype,
    STATE(2003), 1,
      sym_decltype_auto,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6933), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5060), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7903), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [147027] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym___attribute__,
    STATE(4848), 1,
      sym_attribute_specifier,
    ACTIONS(5723), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5721), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [147081] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6774), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
  [147177] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym___attribute__,
    STATE(4843), 1,
      sym_attribute_specifier,
    ACTIONS(5700), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5698), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [147231] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym___attribute__,
    STATE(4836), 1,
      sym_attribute_specifier,
    ACTIONS(5635), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5633), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [147285] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_STAR,
    ACTIONS(7889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7891), 1,
      anon_sym_AMP,
    STATE(3056), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6770), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8039), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [147361] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6064), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [147437] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7909), 1,
      sym_identifier,
    ACTIONS(7911), 1,
      anon_sym_LPAREN2,
    ACTIONS(7913), 1,
      anon_sym_STAR,
    ACTIONS(7915), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7917), 1,
      anon_sym_AMP,
    ACTIONS(7921), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3047), 1,
      sym__type_declarator,
    STATE(3553), 1,
      sym_pointer_type_declarator,
    STATE(8790), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7919), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3555), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [147515] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7893), 1,
      anon_sym_STAR,
    ACTIONS(7895), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7897), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2341), 1,
      sym__type_declarator,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(8989), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [147593] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_STAR,
    ACTIONS(7889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7891), 1,
      anon_sym_AMP,
    STATE(3056), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6784), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5504), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [147669] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7839), 1,
      anon_sym_STAR,
    ACTIONS(7841), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7843), 1,
      anon_sym_AMP,
    ACTIONS(7849), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6963), 1,
      sym__type_declarator,
    STATE(8829), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [147747] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7851), 1,
      sym_identifier,
    ACTIONS(7853), 1,
      anon_sym_LPAREN2,
    ACTIONS(7855), 1,
      anon_sym_STAR,
    ACTIONS(7857), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7859), 1,
      anon_sym_AMP,
    ACTIONS(7863), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(6318), 1,
      sym__type_declarator,
    STATE(6573), 1,
      sym_pointer_type_declarator,
    STATE(8472), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7861), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6565), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [147825] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(8226), 1,
      anon_sym_LBRACE,
    STATE(4662), 1,
      sym_enumerator_list,
    STATE(4896), 1,
      sym_attribute_specifier,
    ACTIONS(5612), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5610), 35,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [147883] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym___attribute__,
    STATE(4806), 1,
      sym_attribute_specifier,
    ACTIONS(5688), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5686), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [147937] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8313), 1,
      anon_sym___attribute__,
    STATE(4552), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(8176), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8174), 36,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [147991] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8316), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_template_argument_list,
    ACTIONS(4000), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4007), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [148047] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym_literal_suffix,
    ACTIONS(5710), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(5712), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [148099] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7839), 1,
      anon_sym_STAR,
    ACTIONS(7841), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7843), 1,
      anon_sym_AMP,
    ACTIONS(7849), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6929), 1,
      sym__type_declarator,
    STATE(8829), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [148177] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(6114), 1,
      sym_auto,
    ACTIONS(6116), 1,
      anon_sym_decltype,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8041), 1,
      anon_sym_STAR,
    ACTIONS(8043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8045), 1,
      anon_sym_AMP,
    STATE(2573), 1,
      sym_decltype_auto,
    STATE(3079), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6939), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5037), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7903), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [148259] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7909), 1,
      sym_identifier,
    ACTIONS(7911), 1,
      anon_sym_LPAREN2,
    ACTIONS(7913), 1,
      anon_sym_STAR,
    ACTIONS(7915), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7917), 1,
      anon_sym_AMP,
    ACTIONS(7921), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3032), 1,
      sym__type_declarator,
    STATE(3553), 1,
      sym_pointer_type_declarator,
    STATE(8790), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7919), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3555), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [148337] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8318), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5402), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_DOT,
    ACTIONS(5404), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [148389] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7871), 1,
      sym_identifier,
    ACTIONS(7873), 1,
      anon_sym_LPAREN2,
    ACTIONS(7875), 1,
      anon_sym_STAR,
    ACTIONS(7877), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7879), 1,
      anon_sym_AMP,
    ACTIONS(7883), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3153), 1,
      sym__type_declarator,
    STATE(3798), 1,
      sym_pointer_type_declarator,
    STATE(8717), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7881), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3820), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [148467] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8222), 1,
      anon_sym___attribute__,
    ACTIONS(8320), 1,
      anon_sym_LBRACE,
    ACTIONS(8322), 1,
      anon_sym_COLON,
    STATE(4931), 1,
      sym__enum_base_clause,
    STATE(5076), 1,
      sym_enumerator_list,
    STATE(5292), 1,
      sym_attribute_specifier,
    ACTIONS(6042), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6044), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [148529] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_LPAREN2,
    ACTIONS(7927), 1,
      anon_sym_STAR,
    ACTIONS(7929), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7931), 1,
      anon_sym_AMP,
    ACTIONS(7935), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3100), 1,
      sym__type_declarator,
    STATE(3594), 1,
      sym_pointer_type_declarator,
    STATE(8279), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7933), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3590), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [148607] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6064), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
    ACTIONS(6066), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [148679] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6064), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [148757] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6064), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [148839] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6770), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [148941] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6064), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      aux_sym_kernel_call_syntax_token1,
  [149025] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6064), 1,
      anon_sym_PIPE,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      aux_sym_kernel_call_syntax_token1,
  [149113] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7839), 1,
      anon_sym_STAR,
    ACTIONS(7841), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7843), 1,
      anon_sym_AMP,
    ACTIONS(7849), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6938), 1,
      sym__type_declarator,
    STATE(8829), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [149191] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6674), 1,
      sym__type_declarator,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [149269] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6064), 1,
      anon_sym_PIPE,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      aux_sym_kernel_call_syntax_token1,
  [149359] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      aux_sym_kernel_call_syntax_token1,
  [149451] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      aux_sym_kernel_call_syntax_token1,
  [149545] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym___attribute__,
    STATE(4869), 1,
      sym_attribute_specifier,
    ACTIONS(5684), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5682), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [149599] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6766), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
  [149695] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6064), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
    ACTIONS(6066), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [149765] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7851), 1,
      sym_identifier,
    ACTIONS(7853), 1,
      anon_sym_LPAREN2,
    ACTIONS(7855), 1,
      anon_sym_STAR,
    ACTIONS(7857), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7859), 1,
      anon_sym_AMP,
    ACTIONS(7863), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(6312), 1,
      sym__type_declarator,
    STATE(6573), 1,
      sym_pointer_type_declarator,
    STATE(8472), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7861), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6565), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [149843] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7893), 1,
      anon_sym_STAR,
    ACTIONS(7895), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7897), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2309), 1,
      sym__type_declarator,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(8989), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [149921] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym___attribute__,
    STATE(4850), 1,
      sym_attribute_specifier,
    ACTIONS(5716), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5714), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [149975] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym___attribute__,
    STATE(4872), 1,
      sym_attribute_specifier,
    ACTIONS(5670), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5668), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [150029] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_STAR,
    ACTIONS(7889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7891), 1,
      anon_sym_AMP,
    STATE(3056), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6785), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8047), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [150105] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym___attribute__,
    STATE(4873), 1,
      sym_attribute_specifier,
    ACTIONS(5629), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5627), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [150159] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym___attribute__,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    STATE(1945), 1,
      sym_attribute_specifier,
    STATE(5356), 1,
      sym_field_declaration_list,
    STATE(7202), 1,
      sym_virtual_specifier,
    STATE(7954), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5506), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5508), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [150225] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7909), 1,
      sym_identifier,
    ACTIONS(7911), 1,
      anon_sym_LPAREN2,
    ACTIONS(7913), 1,
      anon_sym_STAR,
    ACTIONS(7915), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7917), 1,
      anon_sym_AMP,
    ACTIONS(7921), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3063), 1,
      sym__type_declarator,
    STATE(3553), 1,
      sym_pointer_type_declarator,
    STATE(8790), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7919), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3555), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [150303] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_STAR,
    ACTIONS(7889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7891), 1,
      anon_sym_AMP,
    STATE(3056), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6787), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6100), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [150379] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym___attribute__,
    STATE(4875), 1,
      sym_attribute_specifier,
    ACTIONS(5727), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5725), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [150433] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8326), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8330), 1,
      anon_sym_or,
    ACTIONS(8332), 1,
      anon_sym_and,
    ACTIONS(5390), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5392), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [150491] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8035), 1,
      sym_auto,
    ACTIONS(8037), 1,
      anon_sym_decltype,
    STATE(2003), 1,
      sym_decltype_auto,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6924), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5040), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7885), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [150573] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8332), 1,
      anon_sym_and,
    ACTIONS(5402), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5404), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [150627] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6722), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
  [150723] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_LPAREN2,
    ACTIONS(7927), 1,
      anon_sym_STAR,
    ACTIONS(7929), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7931), 1,
      anon_sym_AMP,
    ACTIONS(7935), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3098), 1,
      sym__type_declarator,
    STATE(3594), 1,
      sym_pointer_type_declarator,
    STATE(8279), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7933), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3590), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [150801] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(6114), 1,
      sym_auto,
    ACTIONS(6116), 1,
      anon_sym_decltype,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8041), 1,
      anon_sym_STAR,
    ACTIONS(8043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8045), 1,
      anon_sym_AMP,
    STATE(2573), 1,
      sym_decltype_auto,
    STATE(3079), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6950), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5042), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7885), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [150883] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8316), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_template_argument_list,
    ACTIONS(5212), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(3782), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [150939] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym___attribute__,
    STATE(4883), 1,
      sym_attribute_specifier,
    ACTIONS(5658), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5656), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [150993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6981), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6983), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [151043] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym___attribute__,
    STATE(4884), 1,
      sym_attribute_specifier,
    ACTIONS(5676), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5674), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [151097] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7851), 1,
      sym_identifier,
    ACTIONS(7853), 1,
      anon_sym_LPAREN2,
    ACTIONS(7863), 1,
      sym_primitive_type,
    ACTIONS(7939), 1,
      anon_sym_STAR,
    ACTIONS(7941), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7943), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(6537), 1,
      sym__type_declarator,
    STATE(6573), 1,
      sym_pointer_type_declarator,
    STATE(8211), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7861), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6565), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [151175] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(8226), 1,
      anon_sym_LBRACE,
    STATE(4676), 1,
      sym_enumerator_list,
    STATE(4977), 1,
      sym_attribute_specifier,
    ACTIONS(5599), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5597), 35,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [151233] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7851), 1,
      sym_identifier,
    ACTIONS(7853), 1,
      anon_sym_LPAREN2,
    ACTIONS(7863), 1,
      sym_primitive_type,
    ACTIONS(7939), 1,
      anon_sym_STAR,
    ACTIONS(7941), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7943), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(6538), 1,
      sym__type_declarator,
    STATE(6573), 1,
      sym_pointer_type_declarator,
    STATE(8211), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7861), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6565), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [151311] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7871), 1,
      sym_identifier,
    ACTIONS(7873), 1,
      anon_sym_LPAREN2,
    ACTIONS(7875), 1,
      anon_sym_STAR,
    ACTIONS(7877), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7879), 1,
      anon_sym_AMP,
    ACTIONS(7883), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3203), 1,
      sym__type_declarator,
    STATE(3798), 1,
      sym_pointer_type_declarator,
    STATE(8717), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7881), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3820), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [151389] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7893), 1,
      anon_sym_STAR,
    ACTIONS(7895), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7897), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2346), 1,
      sym__type_declarator,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(8989), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [151467] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7871), 1,
      sym_identifier,
    ACTIONS(7873), 1,
      anon_sym_LPAREN2,
    ACTIONS(7875), 1,
      anon_sym_STAR,
    ACTIONS(7877), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7879), 1,
      anon_sym_AMP,
    ACTIONS(7883), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3210), 1,
      sym__type_declarator,
    STATE(3798), 1,
      sym_pointer_type_declarator,
    STATE(8717), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7881), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3820), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [151545] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6758), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [151647] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7851), 1,
      sym_identifier,
    ACTIONS(7853), 1,
      anon_sym_LPAREN2,
    ACTIONS(7855), 1,
      anon_sym_STAR,
    ACTIONS(7857), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7859), 1,
      anon_sym_AMP,
    ACTIONS(7863), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(6310), 1,
      sym__type_declarator,
    STATE(6573), 1,
      sym_pointer_type_declarator,
    STATE(8472), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7861), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6565), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [151725] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7851), 1,
      sym_identifier,
    ACTIONS(7853), 1,
      anon_sym_LPAREN2,
    ACTIONS(7863), 1,
      sym_primitive_type,
    ACTIONS(7939), 1,
      anon_sym_STAR,
    ACTIONS(7941), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7943), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(6539), 1,
      sym__type_declarator,
    STATE(6573), 1,
      sym_pointer_type_declarator,
    STATE(8211), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7861), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6565), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [151803] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6784), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
  [151899] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8222), 1,
      anon_sym___attribute__,
    ACTIONS(8320), 1,
      anon_sym_LBRACE,
    ACTIONS(8322), 1,
      anon_sym_COLON,
    STATE(4955), 1,
      sym__enum_base_clause,
    STATE(5051), 1,
      sym_enumerator_list,
    STATE(5297), 1,
      sym_attribute_specifier,
    ACTIONS(6048), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6050), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [151961] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6626), 1,
      sym__type_declarator,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [152039] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8277), 1,
      anon_sym_LT,
    STATE(2053), 1,
      sym_template_argument_list,
    ACTIONS(4000), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4007), 36,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [152095] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4489), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5192), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(8220), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5194), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [152149] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8277), 1,
      anon_sym_LT,
    STATE(2053), 1,
      sym_template_argument_list,
    ACTIONS(5212), 3,
      anon_sym_AMP,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(3782), 36,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [152205] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8318), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8334), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(5390), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_DOT,
    ACTIONS(5392), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [152259] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6376), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [152361] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym_literal_suffix,
    ACTIONS(3766), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(3758), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [152413] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8336), 1,
      anon_sym_COMMA,
    ACTIONS(8338), 1,
      anon_sym_SEMI,
    ACTIONS(8340), 1,
      anon_sym_RBRACE,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7724), 1,
      aux_sym_initializer_list_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152521] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6673), 1,
      sym__type_declarator,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [152599] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_LPAREN2,
    ACTIONS(7927), 1,
      anon_sym_STAR,
    ACTIONS(7929), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7931), 1,
      anon_sym_AMP,
    ACTIONS(7935), 1,
      sym_primitive_type,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(3093), 1,
      sym__type_declarator,
    STATE(3594), 1,
      sym_pointer_type_declarator,
    STATE(8279), 1,
      sym_ms_based_modifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7933), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3590), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [152677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5179), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5181), 40,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [152727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2588), 38,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [152776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5242), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5244), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [152825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5149), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5151), 38,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [152874] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8342), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8368), 1,
      anon_sym_QMARK,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    ACTIONS(8378), 1,
      anon_sym_GT2,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(7525), 1,
      aux_sym_template_argument_list_repeat1,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152975] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    STATE(4920), 1,
      sym_attribute_specifier,
    ACTIONS(5716), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5714), 36,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [153028] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8342), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8368), 1,
      anon_sym_QMARK,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    ACTIONS(8380), 1,
      anon_sym_GT2,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(7706), 1,
      aux_sym_template_argument_list_repeat1,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153129] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8382), 1,
      anon_sym_COMMA,
    ACTIONS(8384), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7488), 1,
      aux_sym_generic_expression_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153234] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8388), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7394), 1,
      aux_sym_argument_list_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153339] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8342), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8368), 1,
      anon_sym_QMARK,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    ACTIONS(8390), 1,
      anon_sym_GT2,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(7407), 1,
      aux_sym_template_argument_list_repeat1,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153440] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8392), 1,
      anon_sym_COMMA,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8420), 1,
      anon_sym_RBRACK,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7798), 1,
      aux_sym_subscript_argument_list_repeat1,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153545] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5192), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5194), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [153596] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8236), 1,
      anon_sym_SLASH,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8246), 1,
      anon_sym_AMP,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8254), 1,
      anon_sym_LT_LT,
    ACTIONS(8256), 1,
      anon_sym_GT_GT,
    ACTIONS(8260), 1,
      anon_sym_QMARK,
    ACTIONS(8262), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8264), 1,
      anon_sym_bitor,
    ACTIONS(8266), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8232), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8234), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8238), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8240), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8244), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6376), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
    ACTIONS(8248), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153697] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8236), 1,
      anon_sym_SLASH,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8234), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6064), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
    ACTIONS(6066), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [153766] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8430), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7779), 1,
      aux_sym_argument_list_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153871] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7951), 1,
      anon_sym_STAR,
    ACTIONS(7953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7955), 1,
      anon_sym_AMP,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6824), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4460), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5504), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [153946] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8236), 1,
      anon_sym_SLASH,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8246), 1,
      anon_sym_AMP,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8254), 1,
      anon_sym_LT_LT,
    ACTIONS(8256), 1,
      anon_sym_GT_GT,
    ACTIONS(8260), 1,
      anon_sym_QMARK,
    ACTIONS(8262), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8264), 1,
      anon_sym_bitor,
    ACTIONS(8266), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8232), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8234), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8238), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8240), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8244), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6758), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
    ACTIONS(8248), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154047] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8432), 1,
      anon_sym_COMMA,
    ACTIONS(8434), 1,
      anon_sym_RBRACE,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7812), 1,
      aux_sym_initializer_list_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154152] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8436), 1,
      anon_sym_COMMA,
    ACTIONS(8438), 1,
      anon_sym_RBRACE,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7402), 1,
      aux_sym_initializer_list_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154257] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    STATE(4979), 1,
      sym_attribute_specifier,
    ACTIONS(5684), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5682), 36,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [154310] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8236), 1,
      anon_sym_SLASH,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8246), 1,
      anon_sym_AMP,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8254), 1,
      anon_sym_LT_LT,
    ACTIONS(8256), 1,
      anon_sym_GT_GT,
    ACTIONS(8262), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8264), 1,
      anon_sym_bitor,
    ACTIONS(8266), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8232), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8234), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8238), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8240), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8244), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8248), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6766), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
  [154405] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8440), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7397), 1,
      aux_sym_argument_list_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154510] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    STATE(4894), 1,
      sym_attribute_specifier,
    ACTIONS(5676), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5674), 36,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [154563] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8342), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8368), 1,
      anon_sym_QMARK,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    ACTIONS(8442), 1,
      anon_sym_GT2,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(7792), 1,
      aux_sym_template_argument_list_repeat1,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154664] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8444), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7431), 1,
      aux_sym_argument_list_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154769] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3957), 1,
      anon_sym_LPAREN2,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5486), 1,
      anon_sym_STAR,
    ACTIONS(5488), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5490), 1,
      anon_sym_AMP,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5494), 1,
      anon_sym_LBRACK,
    STATE(2819), 1,
      sym_parameter_list,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6642), 1,
      sym__declarator,
    STATE(6734), 1,
      sym__abstract_declarator,
    STATE(8387), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8279), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [154858] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8446), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7434), 1,
      aux_sym_argument_list_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154963] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8342), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8368), 1,
      anon_sym_QMARK,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    ACTIONS(8448), 1,
      anon_sym_GT2,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(7728), 1,
      aux_sym_template_argument_list_repeat1,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155064] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8342), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8368), 1,
      anon_sym_QMARK,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    ACTIONS(8450), 1,
      anon_sym_GT2,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(7726), 1,
      aux_sym_template_argument_list_repeat1,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155165] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8342), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8368), 1,
      anon_sym_QMARK,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    ACTIONS(8452), 1,
      anon_sym_GT2,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(7566), 1,
      aux_sym_template_argument_list_repeat1,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155266] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    STATE(4969), 1,
      sym_attribute_specifier,
    ACTIONS(5727), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5725), 36,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [155319] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8277), 1,
      anon_sym_LT,
    STATE(1651), 1,
      sym_template_argument_list,
    ACTIONS(4007), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(4000), 34,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [155374] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8342), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8368), 1,
      anon_sym_QMARK,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    ACTIONS(8454), 1,
      anon_sym_GT2,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(7749), 1,
      aux_sym_template_argument_list_repeat1,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155475] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8236), 1,
      anon_sym_SLASH,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8246), 1,
      anon_sym_AMP,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8254), 1,
      anon_sym_LT_LT,
    ACTIONS(8256), 1,
      anon_sym_GT_GT,
    ACTIONS(8260), 1,
      anon_sym_QMARK,
    ACTIONS(8262), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8264), 1,
      anon_sym_bitor,
    ACTIONS(8266), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8232), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8234), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8238), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8240), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8244), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6770), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
    ACTIONS(8248), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155576] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8456), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7437), 1,
      aux_sym_argument_list_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155681] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8342), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8368), 1,
      anon_sym_QMARK,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    ACTIONS(8458), 1,
      anon_sym_GT2,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(7683), 1,
      aux_sym_template_argument_list_repeat1,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155782] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8460), 1,
      anon_sym_COMMA,
    ACTIONS(8462), 1,
      anon_sym_RBRACE,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7548), 1,
      aux_sym_initializer_list_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155887] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8236), 1,
      anon_sym_SLASH,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8246), 1,
      anon_sym_AMP,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8254), 1,
      anon_sym_LT_LT,
    ACTIONS(8256), 1,
      anon_sym_GT_GT,
    ACTIONS(8262), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8264), 1,
      anon_sym_bitor,
    ACTIONS(8266), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8232), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8234), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8238), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8240), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8244), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8248), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6722), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
  [155982] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8236), 1,
      anon_sym_SLASH,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8246), 1,
      anon_sym_AMP,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8254), 1,
      anon_sym_LT_LT,
    ACTIONS(8256), 1,
      anon_sym_GT_GT,
    ACTIONS(8260), 1,
      anon_sym_QMARK,
    ACTIONS(8262), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8264), 1,
      anon_sym_bitor,
    ACTIONS(8266), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8232), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8234), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8238), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8240), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8244), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8248), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8464), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [156083] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8342), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8368), 1,
      anon_sym_QMARK,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    ACTIONS(8466), 1,
      anon_sym_GT2,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(7443), 1,
      aux_sym_template_argument_list_repeat1,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156184] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    STATE(4972), 1,
      sym_attribute_specifier,
    ACTIONS(5629), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5627), 36,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [156237] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8468), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7486), 1,
      aux_sym_argument_list_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156342] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8342), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8368), 1,
      anon_sym_QMARK,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    ACTIONS(8470), 1,
      anon_sym_GT2,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(7769), 1,
      aux_sym_template_argument_list_repeat1,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156443] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8474), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8472), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156546] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8236), 1,
      anon_sym_SLASH,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8246), 1,
      anon_sym_AMP,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8254), 1,
      anon_sym_LT_LT,
    ACTIONS(8256), 1,
      anon_sym_GT_GT,
    ACTIONS(8262), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8264), 1,
      anon_sym_bitor,
    ACTIONS(8266), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8232), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8234), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8238), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8240), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8244), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8248), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6774), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
  [156641] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    STATE(4974), 1,
      sym_attribute_specifier,
    ACTIONS(5670), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5668), 36,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [156694] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    ACTIONS(8476), 1,
      anon_sym_COMMA,
    ACTIONS(8478), 1,
      anon_sym_RBRACK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7382), 1,
      aux_sym_lambda_capture_specifier_repeat1,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156799] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    STATE(4903), 1,
      sym_attribute_specifier,
    ACTIONS(5723), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5721), 36,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [156852] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8382), 1,
      anon_sym_COMMA,
    ACTIONS(8480), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7687), 1,
      aux_sym_generic_expression_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156957] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8482), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7450), 1,
      aux_sym_argument_list_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157062] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8484), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7560), 1,
      aux_sym_argument_list_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157167] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8392), 1,
      anon_sym_COMMA,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    ACTIONS(8486), 1,
      anon_sym_RBRACK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7714), 1,
      aux_sym_subscript_argument_list_repeat1,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157272] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8382), 1,
      anon_sym_COMMA,
    ACTIONS(8488), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7380), 1,
      aux_sym_generic_expression_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157377] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8490), 1,
      anon_sym_COMMA,
    ACTIONS(8492), 1,
      anon_sym_RBRACE,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7478), 1,
      aux_sym_initializer_list_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157482] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8236), 1,
      anon_sym_SLASH,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8246), 1,
      anon_sym_AMP,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8254), 1,
      anon_sym_LT_LT,
    ACTIONS(8256), 1,
      anon_sym_GT_GT,
    ACTIONS(8262), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8264), 1,
      anon_sym_bitor,
    ACTIONS(8266), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8232), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8234), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8238), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8240), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8244), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8248), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6784), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
  [157577] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8342), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8368), 1,
      anon_sym_QMARK,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    ACTIONS(8494), 1,
      anon_sym_GT2,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(7789), 1,
      aux_sym_template_argument_list_repeat1,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157678] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8382), 1,
      anon_sym_COMMA,
    ACTIONS(8496), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7460), 1,
      aux_sym_generic_expression_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157783] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8342), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8368), 1,
      anon_sym_QMARK,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    ACTIONS(8498), 1,
      anon_sym_GT2,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(7469), 1,
      aux_sym_template_argument_list_repeat1,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5218), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5220), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [157933] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    STATE(4897), 1,
      sym_attribute_specifier,
    ACTIONS(5658), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5656), 36,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [157986] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8500), 1,
      anon_sym_COMMA,
    ACTIONS(8502), 1,
      anon_sym_RBRACE,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7611), 1,
      aux_sym_initializer_list_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158091] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7905), 1,
      sym_auto,
    ACTIONS(7907), 1,
      anon_sym_decltype,
    STATE(4997), 1,
      sym_decltype_auto,
    ACTIONS(5171), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5173), 35,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [158146] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8504), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7595), 1,
      aux_sym_argument_list_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158251] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8342), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8368), 1,
      anon_sym_QMARK,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    ACTIONS(8506), 1,
      anon_sym_GT2,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(7534), 1,
      aux_sym_template_argument_list_repeat1,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158352] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8508), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7472), 1,
      aux_sym_argument_list_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5386), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5388), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [158506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5374), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5376), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [158555] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8510), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7719), 1,
      aux_sym_argument_list_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5358), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5360), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [158709] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8342), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8368), 1,
      anon_sym_QMARK,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    ACTIONS(8512), 1,
      anon_sym_GT2,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(7809), 1,
      aux_sym_template_argument_list_repeat1,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158810] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    ACTIONS(8476), 1,
      anon_sym_COMMA,
    ACTIONS(8514), 1,
      anon_sym_RBRACK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7538), 1,
      aux_sym_lambda_capture_specifier_repeat1,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158915] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8382), 1,
      anon_sym_COMMA,
    ACTIONS(8516), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7630), 1,
      aux_sym_generic_expression_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159020] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7600), 1,
      anon_sym_COMMA,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8518), 1,
      anon_sym_RPAREN,
    ACTIONS(8520), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159125] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8522), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7648), 1,
      aux_sym_argument_list_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159230] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8524), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7699), 1,
      aux_sym_argument_list_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159335] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8316), 1,
      anon_sym_LT,
    STATE(2230), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2313), 1,
      sym_template_argument_list,
    ACTIONS(3756), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(4840), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3764), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [159394] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8526), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7668), 1,
      aux_sym_argument_list_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159499] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8342), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8368), 1,
      anon_sym_QMARK,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    ACTIONS(8528), 1,
      anon_sym_GT2,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(7658), 1,
      aux_sym_template_argument_list_repeat1,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159600] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    STATE(4863), 1,
      sym_attribute_specifier,
    ACTIONS(5635), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5633), 36,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [159653] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8236), 1,
      anon_sym_SLASH,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8246), 1,
      anon_sym_AMP,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8254), 1,
      anon_sym_LT_LT,
    ACTIONS(8256), 1,
      anon_sym_GT_GT,
    ACTIONS(8260), 1,
      anon_sym_QMARK,
    ACTIONS(8262), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8264), 1,
      anon_sym_bitor,
    ACTIONS(8266), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8232), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8234), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8238), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8240), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8244), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8248), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8530), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [159754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5234), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5236), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [159803] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    ACTIONS(8532), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8534), 1,
      anon_sym_COMMA,
    ACTIONS(8540), 1,
      anon_sym_SLASH,
    ACTIONS(8546), 1,
      anon_sym_PIPE,
    ACTIONS(8550), 1,
      anon_sym_AMP,
    ACTIONS(8556), 1,
      anon_sym_GT_EQ,
    ACTIONS(8560), 1,
      anon_sym_QMARK,
    ACTIONS(8562), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8564), 1,
      anon_sym_bitor,
    ACTIONS(8566), 1,
      anon_sym_bitand,
    ACTIONS(8570), 1,
      aux_sym_kernel_call_syntax_token2,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(7465), 1,
      aux_sym_lambda_capture_specifier_repeat1,
    STATE(7817), 1,
      sym_kernel_call_syntax,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8538), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8542), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8544), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8548), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8558), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8568), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8552), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8554), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159906] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8194), 1,
      sym_auto,
    ACTIONS(8196), 1,
      anon_sym_decltype,
    STATE(4786), 1,
      sym_decltype_auto,
    ACTIONS(5171), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5173), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [159961] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8572), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7713), 1,
      aux_sym_argument_list_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160066] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8342), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8368), 1,
      anon_sym_QMARK,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    ACTIONS(8574), 1,
      anon_sym_GT2,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(7602), 1,
      aux_sym_template_argument_list_repeat1,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160167] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    STATE(4895), 1,
      sym_attribute_specifier,
    ACTIONS(5700), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5698), 36,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [160220] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8576), 1,
      anon_sym_COMMA,
    ACTIONS(8579), 1,
      anon_sym_SEMI,
    ACTIONS(8581), 1,
      anon_sym_RBRACE,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160325] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8338), 1,
      anon_sym_SEMI,
    ACTIONS(8583), 1,
      anon_sym_COMMA,
    ACTIONS(8586), 1,
      anon_sym_RBRACE,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160430] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8236), 1,
      anon_sym_SLASH,
    ACTIONS(8254), 1,
      anon_sym_LT_LT,
    ACTIONS(8256), 1,
      anon_sym_GT_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8232), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8234), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6064), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [160505] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8382), 1,
      anon_sym_COMMA,
    ACTIONS(8588), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7426), 1,
      aux_sym_generic_expression_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160610] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8236), 1,
      anon_sym_SLASH,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8246), 1,
      anon_sym_AMP,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8254), 1,
      anon_sym_LT_LT,
    ACTIONS(8256), 1,
      anon_sym_GT_GT,
    ACTIONS(8262), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8264), 1,
      anon_sym_bitor,
    ACTIONS(8266), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8232), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8234), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8240), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8244), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8248), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      aux_sym_kernel_call_syntax_token1,
  [160703] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8342), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8368), 1,
      anon_sym_QMARK,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    ACTIONS(8590), 1,
      anon_sym_GT2,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(7623), 1,
      aux_sym_template_argument_list_repeat1,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160804] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8236), 1,
      anon_sym_SLASH,
    ACTIONS(8242), 1,
      anon_sym_PIPE,
    ACTIONS(8246), 1,
      anon_sym_AMP,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8254), 1,
      anon_sym_LT_LT,
    ACTIONS(8256), 1,
      anon_sym_GT_GT,
    ACTIONS(8262), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8264), 1,
      anon_sym_bitor,
    ACTIONS(8266), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8232), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8234), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8244), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8248), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      aux_sym_kernel_call_syntax_token1,
  [160895] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6064), 1,
      anon_sym_PIPE,
    ACTIONS(8236), 1,
      anon_sym_SLASH,
    ACTIONS(8246), 1,
      anon_sym_AMP,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8254), 1,
      anon_sym_LT_LT,
    ACTIONS(8256), 1,
      anon_sym_GT_GT,
    ACTIONS(8262), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8266), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8232), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8234), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8244), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8248), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      aux_sym_kernel_call_syntax_token1,
  [160984] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7951), 1,
      anon_sym_STAR,
    ACTIONS(7953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7955), 1,
      anon_sym_AMP,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6849), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4460), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8039), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [161059] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6064), 1,
      anon_sym_PIPE,
    ACTIONS(8236), 1,
      anon_sym_SLASH,
    ACTIONS(8246), 1,
      anon_sym_AMP,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8254), 1,
      anon_sym_LT_LT,
    ACTIONS(8256), 1,
      anon_sym_GT_GT,
    ACTIONS(8262), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8266), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8232), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8234), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8248), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      aux_sym_kernel_call_syntax_token1,
  [161146] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8592), 1,
      anon_sym_COMMA,
    ACTIONS(8594), 1,
      anon_sym_RBRACE,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7609), 1,
      aux_sym_initializer_list_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161251] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8382), 1,
      anon_sym_COMMA,
    ACTIONS(8596), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7616), 1,
      aux_sym_generic_expression_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161356] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    ACTIONS(8476), 1,
      anon_sym_COMMA,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8600), 1,
      anon_sym_RBRACK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7538), 1,
      aux_sym_lambda_capture_specifier_repeat1,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161461] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8602), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7608), 1,
      aux_sym_argument_list_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161566] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8392), 1,
      anon_sym_COMMA,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    ACTIONS(8604), 1,
      anon_sym_RBRACK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7415), 1,
      aux_sym_subscript_argument_list_repeat1,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161671] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7951), 1,
      anon_sym_STAR,
    ACTIONS(7953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7955), 1,
      anon_sym_AMP,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6856), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4460), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6100), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [161746] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8277), 1,
      anon_sym_LT,
    STATE(1651), 1,
      sym_template_argument_list,
    ACTIONS(3782), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(5212), 34,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [161801] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8382), 1,
      anon_sym_COMMA,
    ACTIONS(8606), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7511), 1,
      aux_sym_generic_expression_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161906] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_const,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7951), 1,
      anon_sym_STAR,
    ACTIONS(7953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7955), 1,
      anon_sym_AMP,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(4618), 1,
      sym_alignas_qualifier,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6838), 1,
      sym__abstract_declarator,
    ACTIONS(6696), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4460), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8047), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6686), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [161981] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8236), 1,
      anon_sym_SLASH,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8254), 1,
      anon_sym_LT_LT,
    ACTIONS(8256), 1,
      anon_sym_GT_GT,
    ACTIONS(8262), 1,
      anon_sym_LT_EQ_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6064), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8232), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8234), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8248), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      aux_sym_kernel_call_syntax_token1,
  [162064] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8340), 1,
      anon_sym_RBRACE,
    ACTIONS(8608), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7724), 1,
      aux_sym_initializer_list_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162169] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8610), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7716), 1,
      aux_sym_argument_list_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162274] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8236), 1,
      anon_sym_SLASH,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8254), 1,
      anon_sym_LT_LT,
    ACTIONS(8256), 1,
      anon_sym_GT_GT,
    ACTIONS(8262), 1,
      anon_sym_LT_EQ_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6064), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8232), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8234), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [162355] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8342), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8368), 1,
      anon_sym_QMARK,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    ACTIONS(8612), 1,
      anon_sym_GT2,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(7695), 1,
      aux_sym_template_argument_list_repeat1,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162456] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8614), 1,
      anon_sym_COMMA,
    ACTIONS(8616), 1,
      anon_sym_RBRACE,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7700), 1,
      aux_sym_initializer_list_repeat1,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5203), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5205), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [162610] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8236), 1,
      anon_sym_SLASH,
    ACTIONS(8254), 1,
      anon_sym_LT_LT,
    ACTIONS(8256), 1,
      anon_sym_GT_GT,
    ACTIONS(8262), 1,
      anon_sym_LT_EQ_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8232), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8234), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6064), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [162687] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7600), 1,
      anon_sym_COMMA,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8579), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162790] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    STATE(4803), 1,
      sym_attribute_specifier,
    ACTIONS(5696), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5694), 36,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [162843] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8236), 1,
      anon_sym_SLASH,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8232), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8234), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6064), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
    ACTIONS(6066), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [162914] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8392), 1,
      anon_sym_COMMA,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    ACTIONS(8618), 1,
      anon_sym_RBRACK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7502), 1,
      aux_sym_subscript_argument_list_repeat1,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163019] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    STATE(4798), 1,
      sym_attribute_specifier,
    ACTIONS(5688), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5686), 36,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [163072] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8579), 1,
      anon_sym_COLON,
    ACTIONS(8620), 1,
      anon_sym_COMMA,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8648), 1,
      anon_sym_QMARK,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8628), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163174] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      aux_sym_kernel_call_syntax_token1,
  [163264] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6774), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
  [163358] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7600), 1,
      anon_sym_COMMA,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8656), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163460] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7600), 1,
      anon_sym_COMMA,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8520), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4909), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4911), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [163610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4917), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4919), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [163658] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8620), 1,
      anon_sym_COMMA,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8648), 1,
      anon_sym_QMARK,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    ACTIONS(8658), 1,
      anon_sym_COLON,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8628), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163760] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7600), 1,
      anon_sym_COMMA,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8660), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163862] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5352), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [163910] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(7987), 1,
      sym_identifier,
    ACTIONS(7989), 1,
      anon_sym_LPAREN2,
    ACTIONS(7991), 1,
      anon_sym_STAR,
    ACTIONS(7993), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7995), 1,
      anon_sym_AMP,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6870), 1,
      sym__field_declarator,
    STATE(7018), 1,
      sym_operator_name,
    STATE(8384), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6748), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [163984] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    ACTIONS(8540), 1,
      anon_sym_SLASH,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(7817), 1,
      sym_kernel_call_syntax,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8538), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8568), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6064), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6066), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [164052] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6064), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [164124] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7600), 1,
      anon_sym_COMMA,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8662), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164226] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164326] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    STATE(1651), 1,
      sym_template_argument_list,
    STATE(4430), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3756), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(7982), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3764), 28,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [164384] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(7817), 1,
      sym_kernel_call_syntax,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8568), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6064), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6066), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [164448] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    ACTIONS(8540), 1,
      anon_sym_SLASH,
    ACTIONS(8546), 1,
      anon_sym_PIPE,
    ACTIONS(8550), 1,
      anon_sym_AMP,
    ACTIONS(8556), 1,
      anon_sym_GT_EQ,
    ACTIONS(8562), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8564), 1,
      anon_sym_bitor,
    ACTIONS(8566), 1,
      anon_sym_bitand,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(7817), 1,
      sym_kernel_call_syntax,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8538), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8544), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8548), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8558), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8568), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8552), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8554), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_or,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [164538] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8666), 1,
      anon_sym_COMMA,
    ACTIONS(8668), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164640] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_COMMA,
    ACTIONS(8672), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5301), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5303), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [164790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5192), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5194), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [164838] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    ACTIONS(8540), 1,
      anon_sym_SLASH,
    ACTIONS(8546), 1,
      anon_sym_PIPE,
    ACTIONS(8550), 1,
      anon_sym_AMP,
    ACTIONS(8556), 1,
      anon_sym_GT_EQ,
    ACTIONS(8562), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8564), 1,
      anon_sym_bitor,
    ACTIONS(8566), 1,
      anon_sym_bitand,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(7817), 1,
      sym_kernel_call_syntax,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8538), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8548), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8558), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8568), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8552), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8554), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [164926] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_PIPE,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    ACTIONS(8540), 1,
      anon_sym_SLASH,
    ACTIONS(8550), 1,
      anon_sym_AMP,
    ACTIONS(8556), 1,
      anon_sym_GT_EQ,
    ACTIONS(8562), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8566), 1,
      anon_sym_bitand,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(7817), 1,
      sym_kernel_call_syntax,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8538), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8548), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8558), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8568), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8552), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8554), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [165012] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_PIPE,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    ACTIONS(8540), 1,
      anon_sym_SLASH,
    ACTIONS(8550), 1,
      anon_sym_AMP,
    ACTIONS(8556), 1,
      anon_sym_GT_EQ,
    ACTIONS(8562), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8566), 1,
      anon_sym_bitand,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(7817), 1,
      sym_kernel_call_syntax,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8538), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8558), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8568), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8552), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8554), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [165096] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8620), 1,
      anon_sym_COMMA,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8648), 1,
      anon_sym_QMARK,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    ACTIONS(8674), 1,
      anon_sym_COLON,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8628), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165198] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    ACTIONS(8540), 1,
      anon_sym_SLASH,
    ACTIONS(8556), 1,
      anon_sym_GT_EQ,
    ACTIONS(8562), 1,
      anon_sym_LT_EQ_GT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(7817), 1,
      sym_kernel_call_syntax,
    ACTIONS(6064), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8538), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8558), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8568), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8552), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8554), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [165278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5340), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5342), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [165326] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3716), 1,
      anon_sym_LBRACE,
    ACTIONS(8190), 1,
      anon_sym_LPAREN2,
    STATE(5273), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5964), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5966), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [165380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5242), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5244), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [165428] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    ACTIONS(8540), 1,
      anon_sym_SLASH,
    ACTIONS(8556), 1,
      anon_sym_GT_EQ,
    ACTIONS(8562), 1,
      anon_sym_LT_EQ_GT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(7817), 1,
      sym_kernel_call_syntax,
    ACTIONS(6064), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8538), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8558), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8568), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8554), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [165506] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    ACTIONS(8540), 1,
      anon_sym_SLASH,
    ACTIONS(8562), 1,
      anon_sym_LT_EQ_GT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(7817), 1,
      sym_kernel_call_syntax,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8538), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8558), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8568), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6064), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [165580] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    ACTIONS(8540), 1,
      anon_sym_SLASH,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(7817), 1,
      sym_kernel_call_syntax,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8538), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8568), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6064), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6066), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [165650] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8676), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165750] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8342), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8368), 1,
      anon_sym_QMARK,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8678), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165846] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [165934] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    ACTIONS(8540), 1,
      anon_sym_SLASH,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(7817), 1,
      sym_kernel_call_syntax,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8538), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8558), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8568), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6064), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [166006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5319), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5321), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [166054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5352), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [166102] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5340), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5342), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [166150] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6068), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6070), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [166212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5319), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5321), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [166260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5315), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5317), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [166308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5248), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [166356] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6096), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
    ACTIONS(6098), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_kernel_call_syntax_token1,
  [166418] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8342), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8368), 1,
      anon_sym_QMARK,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(6376), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166514] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8342), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8368), 1,
      anon_sym_QMARK,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8680), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166610] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(7987), 1,
      sym_identifier,
    ACTIONS(7989), 1,
      anon_sym_LPAREN2,
    ACTIONS(7991), 1,
      anon_sym_STAR,
    ACTIONS(7993), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7995), 1,
      anon_sym_AMP,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6894), 1,
      sym__field_declarator,
    STATE(7018), 1,
      sym_operator_name,
    STATE(8384), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6748), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [166684] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8628), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6722), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
  [166778] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6106), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
    ACTIONS(6108), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [166842] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8682), 1,
      anon_sym_COMMA,
    ACTIONS(8684), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5277), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5279), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [166992] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(7989), 1,
      anon_sym_LPAREN2,
    ACTIONS(7997), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_STAR,
    ACTIONS(8001), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8003), 1,
      anon_sym_AMP,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6439), 1,
      sym__field_declarator,
    STATE(6635), 1,
      sym_operator_name,
    STATE(8417), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6748), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [167066] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8620), 1,
      anon_sym_COMMA,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8648), 1,
      anon_sym_QMARK,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    ACTIONS(8686), 1,
      anon_sym_COLON,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8628), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167168] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8342), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8368), 1,
      anon_sym_QMARK,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8664), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167264] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7600), 1,
      anon_sym_COMMA,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8688), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167366] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6110), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6112), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [167430] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6106), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6108), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [167494] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8690), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(6230), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6232), 35,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [167544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5238), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5240), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [167592] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6722), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [167682] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6102), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6104), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [167746] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7600), 1,
      anon_sym_COMMA,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8693), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5214), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5216), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [167896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5301), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5303), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [167944] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8472), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168044] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7600), 1,
      anon_sym_COMMA,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8695), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168146] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8342), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8368), 1,
      anon_sym_QMARK,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(6770), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5250), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5252), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [168290] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4947), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [168338] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(7817), 1,
      sym_kernel_call_syntax,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8568), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6102), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6104), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [168402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5214), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5216), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [168450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5238), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5240), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [168498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5254), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5256), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [168546] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5234), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5236), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [168594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5248), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [168642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5248), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [168690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5250), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5252), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [168738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5254), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5256), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [168786] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8620), 1,
      anon_sym_COMMA,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8648), 1,
      anon_sym_QMARK,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    ACTIONS(8697), 1,
      anon_sym_COLON,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8628), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168888] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(7989), 1,
      anon_sym_LPAREN2,
    ACTIONS(7997), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_STAR,
    ACTIONS(8001), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8003), 1,
      anon_sym_AMP,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6492), 1,
      sym__field_declarator,
    STATE(6635), 1,
      sym_operator_name,
    STATE(8417), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6748), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [168962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5248), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [169010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5248), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [169058] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7600), 1,
      anon_sym_COMMA,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8699), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169160] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7600), 1,
      anon_sym_COMMA,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8701), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5315), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5317), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [169310] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6096), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6098), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [169372] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3716), 1,
      anon_sym_LBRACE,
    ACTIONS(8190), 1,
      anon_sym_LPAREN2,
    STATE(5179), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5954), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5956), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [169426] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8703), 1,
      anon_sym_COMMA,
    ACTIONS(8705), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169528] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7600), 1,
      anon_sym_COMMA,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8707), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169630] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6758), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169730] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6784), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [169820] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6722), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
  [169914] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8620), 1,
      anon_sym_COMMA,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8648), 1,
      anon_sym_QMARK,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    ACTIONS(8709), 1,
      anon_sym_COLON,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8628), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [170016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5358), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5360), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [170064] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(7885), 1,
      anon_sym_COLON,
    ACTIONS(8029), 1,
      anon_sym_const,
    ACTIONS(8035), 1,
      sym_auto,
    ACTIONS(8037), 1,
      anon_sym_decltype,
    ACTIONS(8149), 1,
      anon_sym_STAR,
    ACTIONS(8151), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8153), 1,
      anon_sym_AMP,
    STATE(2003), 1,
      sym_decltype_auto,
    STATE(3421), 1,
      sym_parameter_list,
    STATE(5599), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7042), 1,
      sym__abstract_declarator,
    ACTIONS(8031), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5274), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8021), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [170144] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [170230] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(7817), 1,
      sym_kernel_call_syntax,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8568), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6110), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6112), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [170294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5145), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5147), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [170342] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    ACTIONS(8540), 1,
      anon_sym_SLASH,
    ACTIONS(8546), 1,
      anon_sym_PIPE,
    ACTIONS(8550), 1,
      anon_sym_AMP,
    ACTIONS(8556), 1,
      anon_sym_GT_EQ,
    ACTIONS(8562), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8564), 1,
      anon_sym_bitor,
    ACTIONS(8566), 1,
      anon_sym_bitand,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(7817), 1,
      sym_kernel_call_syntax,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8538), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8542), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8544), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8548), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8558), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8568), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8552), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8554), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6784), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [170434] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7600), 1,
      anon_sym_COMMA,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8711), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [170536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5362), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5364), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [170584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5366), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5368), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [170632] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8713), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [170732] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8715), 1,
      anon_sym_COMMA,
    ACTIONS(8717), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [170834] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7600), 1,
      anon_sym_COMMA,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8719), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [170936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4967), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4969), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [170984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4933), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4935), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [171032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5378), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5380), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [171080] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5382), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5384), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [171128] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8721), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [171228] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4937), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4939), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [171276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5336), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5338), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [171324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5370), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5372), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [171372] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7600), 1,
      anon_sym_COMMA,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8723), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [171474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5354), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5356), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [171522] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6064), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6066), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [171586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5336), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5338), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [171634] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6064), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6066), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [171702] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6784), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
  [171796] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7600), 1,
      anon_sym_COMMA,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8725), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [171898] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8620), 1,
      anon_sym_COMMA,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8648), 1,
      anon_sym_QMARK,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    ACTIONS(8727), 1,
      anon_sym_COLON,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8628), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172000] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8729), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5285), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5287), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [172148] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8731), 1,
      anon_sym_COMMA,
    ACTIONS(8733), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172250] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7600), 1,
      anon_sym_COMMA,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8735), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172352] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(7817), 1,
      sym_kernel_call_syntax,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8568), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6106), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6108), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [172416] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    ACTIONS(8532), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8540), 1,
      anon_sym_SLASH,
    ACTIONS(8546), 1,
      anon_sym_PIPE,
    ACTIONS(8550), 1,
      anon_sym_AMP,
    ACTIONS(8556), 1,
      anon_sym_GT_EQ,
    ACTIONS(8560), 1,
      anon_sym_QMARK,
    ACTIONS(8562), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8564), 1,
      anon_sym_bitor,
    ACTIONS(8566), 1,
      anon_sym_bitand,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(7817), 1,
      sym_kernel_call_syntax,
    ACTIONS(6376), 2,
      anon_sym_COMMA,
      aux_sym_kernel_call_syntax_token2,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8538), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8542), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8544), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8548), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8558), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8568), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8552), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8554), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5362), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5364), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [172562] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8737), 1,
      anon_sym_COMMA,
    ACTIONS(8739), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172664] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(7989), 1,
      anon_sym_LPAREN2,
    ACTIONS(7997), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_STAR,
    ACTIONS(8001), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8003), 1,
      anon_sym_AMP,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6404), 1,
      sym__field_declarator,
    STATE(6635), 1,
      sym_operator_name,
    STATE(8417), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6748), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [172738] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8620), 1,
      anon_sym_COMMA,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8648), 1,
      anon_sym_QMARK,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    ACTIONS(8741), 1,
      anon_sym_COLON,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8628), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172840] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8620), 1,
      anon_sym_COMMA,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8648), 1,
      anon_sym_QMARK,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    ACTIONS(8743), 1,
      anon_sym_COLON,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8628), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172942] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8745), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [173042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5222), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5224), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [173090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5226), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5228), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [173138] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6064), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [173212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5230), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5232), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [173260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5281), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5283), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [173308] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8005), 1,
      anon_sym_STAR,
    ACTIONS(8007), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8009), 1,
      anon_sym_AMP,
    STATE(2819), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6745), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5504), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [173382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5289), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5291), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [173430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5293), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5295), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [173478] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(7817), 1,
      sym_kernel_call_syntax,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6096), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6098), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [173540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5366), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5368), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [173588] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7600), 1,
      anon_sym_COMMA,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8747), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [173690] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8678), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [173790] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8678), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [173890] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8015), 1,
      anon_sym_STAR,
    ACTIONS(8017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8019), 1,
      anon_sym_AMP,
    ACTIONS(8029), 1,
      anon_sym_const,
    STATE(3439), 1,
      sym_parameter_list,
    STATE(5599), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6908), 1,
      sym__abstract_declarator,
    ACTIONS(8031), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5389), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8039), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8021), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [173964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5297), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5299), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [174012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5311), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5313), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [174060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1897), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(1895), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [174108] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8015), 1,
      anon_sym_STAR,
    ACTIONS(8017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8019), 1,
      anon_sym_AMP,
    ACTIONS(8029), 1,
      anon_sym_const,
    STATE(3439), 1,
      sym_parameter_list,
    STATE(5599), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6887), 1,
      sym__abstract_declarator,
    ACTIONS(8031), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5389), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5504), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8021), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [174182] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8015), 1,
      anon_sym_STAR,
    ACTIONS(8017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8019), 1,
      anon_sym_AMP,
    ACTIONS(8029), 1,
      anon_sym_const,
    STATE(3439), 1,
      sym_parameter_list,
    STATE(5599), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6900), 1,
      sym__abstract_declarator,
    ACTIONS(8031), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5389), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8047), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8021), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [174256] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8620), 1,
      anon_sym_COMMA,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8648), 1,
      anon_sym_QMARK,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    ACTIONS(8749), 1,
      anon_sym_COLON,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8628), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [174358] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6766), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [174448] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8015), 1,
      anon_sym_STAR,
    ACTIONS(8017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8019), 1,
      anon_sym_AMP,
    ACTIONS(8029), 1,
      anon_sym_const,
    STATE(3439), 1,
      sym_parameter_list,
    STATE(5599), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6909), 1,
      sym__abstract_declarator,
    ACTIONS(8031), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5389), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6100), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8021), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [174522] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7600), 1,
      anon_sym_COMMA,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8751), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [174624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4913), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4915), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [174672] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5374), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5376), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [174720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5311), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5313), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [174768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5378), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5380), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [174816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5382), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5384), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [174864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5297), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5299), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [174912] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_PIPE,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [174996] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8648), 1,
      anon_sym_QMARK,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6758), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8628), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [175096] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8628), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6766), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
  [175190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5386), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5388), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [175238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5336), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5338), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [175286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5370), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5372), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [175334] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8620), 1,
      anon_sym_COMMA,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8648), 1,
      anon_sym_QMARK,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    ACTIONS(8753), 1,
      anon_sym_COLON,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8628), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [175436] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6770), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [175536] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6064), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
    ACTIONS(6066), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [175604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4953), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4955), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [175652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4921), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4923), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [175700] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8755), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [175800] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8648), 1,
      anon_sym_QMARK,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6770), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8628), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [175900] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    ACTIONS(8532), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8540), 1,
      anon_sym_SLASH,
    ACTIONS(8546), 1,
      anon_sym_PIPE,
    ACTIONS(8550), 1,
      anon_sym_AMP,
    ACTIONS(8556), 1,
      anon_sym_GT_EQ,
    ACTIONS(8560), 1,
      anon_sym_QMARK,
    ACTIONS(8562), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8564), 1,
      anon_sym_bitor,
    ACTIONS(8566), 1,
      anon_sym_bitand,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(7817), 1,
      sym_kernel_call_syntax,
    ACTIONS(6758), 2,
      anon_sym_COMMA,
      aux_sym_kernel_call_syntax_token2,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8538), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8542), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8544), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8548), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8558), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8568), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8552), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8554), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [175998] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8628), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6774), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
  [176092] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7600), 1,
      anon_sym_COMMA,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8757), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [176194] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym_LBRACE,
    ACTIONS(8198), 1,
      anon_sym_LPAREN2,
    STATE(5325), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5964), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5966), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [176248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4941), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4943), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [176296] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      aux_sym_kernel_call_syntax_token1,
  [176388] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7600), 1,
      anon_sym_COMMA,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8759), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [176490] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7600), 1,
      anon_sym_COMMA,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8761), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [176592] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym_LBRACE,
    ACTIONS(8198), 1,
      anon_sym_LPAREN2,
    STATE(5180), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6012), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [176646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5354), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5356), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [176694] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym_LBRACE,
    ACTIONS(8198), 1,
      anon_sym_LPAREN2,
    STATE(5214), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6024), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6026), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [176748] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8342), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8368), 1,
      anon_sym_QMARK,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(6758), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [176844] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    ACTIONS(8532), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8540), 1,
      anon_sym_SLASH,
    ACTIONS(8546), 1,
      anon_sym_PIPE,
    ACTIONS(8550), 1,
      anon_sym_AMP,
    ACTIONS(8556), 1,
      anon_sym_GT_EQ,
    ACTIONS(8560), 1,
      anon_sym_QMARK,
    ACTIONS(8562), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8564), 1,
      anon_sym_bitor,
    ACTIONS(8566), 1,
      anon_sym_bitand,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(7817), 1,
      sym_kernel_call_syntax,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8538), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8542), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8544), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8548), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8558), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8568), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8755), 2,
      anon_sym_COMMA,
      aux_sym_kernel_call_syntax_token2,
    ACTIONS(8552), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8554), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [176942] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7600), 1,
      anon_sym_COMMA,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8338), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177044] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6102), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
    ACTIONS(6104), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [177108] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6064), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [177182] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(7987), 1,
      sym_identifier,
    ACTIONS(7989), 1,
      anon_sym_LPAREN2,
    ACTIONS(7991), 1,
      anon_sym_STAR,
    ACTIONS(7993), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7995), 1,
      anon_sym_AMP,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6905), 1,
      sym__field_declarator,
    STATE(7018), 1,
      sym_operator_name,
    STATE(8384), 1,
      sym_ms_based_modifier,
    ACTIONS(3177), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6748), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3171), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [177256] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8581), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177356] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8620), 1,
      anon_sym_COMMA,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8648), 1,
      anon_sym_QMARK,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    ACTIONS(8763), 1,
      anon_sym_COLON,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8628), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177458] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6064), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
    ACTIONS(6066), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [177528] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8222), 1,
      anon_sym___attribute__,
    ACTIONS(8320), 1,
      anon_sym_LBRACE,
    STATE(5043), 1,
      sym_enumerator_list,
    STATE(5282), 1,
      sym_attribute_specifier,
    ACTIONS(5612), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5610), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [177584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5192), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5194), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [177632] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6110), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
    ACTIONS(6112), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [177696] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6064), 1,
      anon_sym_PIPE,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      aux_sym_kernel_call_syntax_token1,
  [177784] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5336), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5338), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [177832] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6064), 8,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6066), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [177902] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8620), 1,
      anon_sym_COMMA,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8648), 1,
      anon_sym_QMARK,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    ACTIONS(8765), 1,
      anon_sym_COLON,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8628), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [178004] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6064), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [178080] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8342), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8368), 1,
      anon_sym_QMARK,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8678), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [178176] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8767), 1,
      anon_sym_COMMA,
    ACTIONS(8769), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [178278] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6068), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
    ACTIONS(6070), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_kernel_call_syntax_token1,
  [178340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4929), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4931), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [178388] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6064), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [178468] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6766), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
  [178562] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6064), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      aux_sym_kernel_call_syntax_token1,
  [178644] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6064), 1,
      anon_sym_PIPE,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      aux_sym_kernel_call_syntax_token1,
  [178730] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym_LBRACE,
    ACTIONS(8198), 1,
      anon_sym_LPAREN2,
    STATE(5259), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5954), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5956), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [178784] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6064), 1,
      anon_sym_PIPE,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      aux_sym_kernel_call_syntax_token1,
  [178872] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8356), 1,
      anon_sym_PIPE,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8372), 1,
      anon_sym_bitor,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8358), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6774), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [178962] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      aux_sym_kernel_call_syntax_token1,
  [179052] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      aux_sym_kernel_call_syntax_token1,
  [179144] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6064), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
    ACTIONS(6066), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [179208] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6064), 1,
      anon_sym_PIPE,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      aux_sym_kernel_call_syntax_token1,
  [179294] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6376), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [179394] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8222), 1,
      anon_sym___attribute__,
    ACTIONS(8320), 1,
      anon_sym_LBRACE,
    STATE(5022), 1,
      sym_enumerator_list,
    STATE(5208), 1,
      sym_attribute_specifier,
    ACTIONS(5599), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5597), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [179450] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8586), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [179550] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6064), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
    ACTIONS(6066), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [179618] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8648), 1,
      anon_sym_QMARK,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6376), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8628), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [179718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5285), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5287), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [179766] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6064), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [179840] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8628), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6784), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
  [179934] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    ACTIONS(8540), 1,
      anon_sym_SLASH,
    ACTIONS(8546), 1,
      anon_sym_PIPE,
    ACTIONS(8550), 1,
      anon_sym_AMP,
    ACTIONS(8556), 1,
      anon_sym_GT_EQ,
    ACTIONS(8562), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8564), 1,
      anon_sym_bitor,
    ACTIONS(8566), 1,
      anon_sym_bitand,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(7817), 1,
      sym_kernel_call_syntax,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8538), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8542), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8544), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8548), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8558), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8568), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8552), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8554), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6774), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [180026] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6064), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      aux_sym_kernel_call_syntax_token1,
  [180108] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3716), 1,
      anon_sym_LBRACE,
    ACTIONS(8190), 1,
      anon_sym_LPAREN2,
    STATE(5276), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6012), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6014), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [180162] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(7903), 1,
      anon_sym_COLON,
    ACTIONS(8029), 1,
      anon_sym_const,
    ACTIONS(8035), 1,
      sym_auto,
    ACTIONS(8037), 1,
      anon_sym_decltype,
    ACTIONS(8149), 1,
      anon_sym_STAR,
    ACTIONS(8151), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8153), 1,
      anon_sym_AMP,
    STATE(2003), 1,
      sym_decltype_auto,
    STATE(3421), 1,
      sym_parameter_list,
    STATE(5599), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7083), 1,
      sym__abstract_declarator,
    ACTIONS(8031), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5241), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8021), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [180242] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6064), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [180322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4947), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [180370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5293), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5295), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [180418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5289), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5291), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [180466] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8005), 1,
      anon_sym_STAR,
    ACTIONS(8007), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8009), 1,
      anon_sym_AMP,
    STATE(2819), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6708), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6100), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [180540] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_PIPE,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8360), 1,
      anon_sym_AMP,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8374), 1,
      anon_sym_bitand,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [180622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5281), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5283), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [180670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4949), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4951), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [180718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5230), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5232), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [180766] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(7817), 1,
      sym_kernel_call_syntax,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6068), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6070), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [180828] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    ACTIONS(8540), 1,
      anon_sym_SLASH,
    ACTIONS(8546), 1,
      anon_sym_PIPE,
    ACTIONS(8550), 1,
      anon_sym_AMP,
    ACTIONS(8556), 1,
      anon_sym_GT_EQ,
    ACTIONS(8562), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8564), 1,
      anon_sym_bitor,
    ACTIONS(8566), 1,
      anon_sym_bitand,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(7817), 1,
      sym_kernel_call_syntax,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8538), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8542), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8544), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8548), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8558), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8568), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8552), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8554), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6766), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [180920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5226), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5228), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [180968] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6064), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [181044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5222), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5224), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [181092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5218), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5220), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [181140] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3716), 1,
      anon_sym_LBRACE,
    ACTIONS(8190), 1,
      anon_sym_LPAREN2,
    STATE(5254), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6024), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6026), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [181194] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6064), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
    ACTIONS(6066), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      aux_sym_kernel_call_syntax_token1,
  [181264] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1901), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(1899), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [181312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5192), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5194), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [181360] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7600), 1,
      anon_sym_COMMA,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8771), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [181462] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(6064), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [181538] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8620), 1,
      anon_sym_COMMA,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8648), 1,
      anon_sym_QMARK,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    ACTIONS(8773), 1,
      anon_sym_COLON,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8628), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [181640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4925), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4927), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [181688] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8775), 1,
      anon_sym_COMMA,
    ACTIONS(8777), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [181790] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8162), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [181890] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    ACTIONS(8532), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8540), 1,
      anon_sym_SLASH,
    ACTIONS(8546), 1,
      anon_sym_PIPE,
    ACTIONS(8550), 1,
      anon_sym_AMP,
    ACTIONS(8556), 1,
      anon_sym_GT_EQ,
    ACTIONS(8560), 1,
      anon_sym_QMARK,
    ACTIONS(8562), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8564), 1,
      anon_sym_bitor,
    ACTIONS(8566), 1,
      anon_sym_bitand,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(7817), 1,
      sym_kernel_call_syntax,
    ACTIONS(6770), 2,
      anon_sym_COMMA,
      aux_sym_kernel_call_syntax_token2,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8538), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8542), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8544), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8548), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8558), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8568), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8552), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8554), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [181988] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    ACTIONS(7326), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_DOT,
    ACTIONS(8540), 1,
      anon_sym_SLASH,
    ACTIONS(8546), 1,
      anon_sym_PIPE,
    ACTIONS(8550), 1,
      anon_sym_AMP,
    ACTIONS(8556), 1,
      anon_sym_GT_EQ,
    ACTIONS(8562), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8564), 1,
      anon_sym_bitor,
    ACTIONS(8566), 1,
      anon_sym_bitand,
    STATE(3878), 1,
      sym_subscript_argument_list,
    STATE(3879), 1,
      sym_argument_list,
    STATE(7817), 1,
      sym_kernel_call_syntax,
    ACTIONS(7344), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8536), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8538), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8542), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8544), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8548), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8558), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8568), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8552), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8554), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6722), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [182080] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    ACTIONS(7443), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_DOT,
    ACTIONS(8350), 1,
      anon_sym_SLASH,
    ACTIONS(8370), 1,
      anon_sym_LT_EQ_GT,
    STATE(3959), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym_subscript_argument_list,
    STATE(8088), 1,
      sym_kernel_call_syntax,
    ACTIONS(6064), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7449), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8346), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8348), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8366), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8376), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8362), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8364), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6066), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [182158] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8620), 1,
      anon_sym_COMMA,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8648), 1,
      anon_sym_QMARK,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    ACTIONS(8779), 1,
      anon_sym_COLON,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8628), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [182260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5248), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [182308] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8620), 1,
      anon_sym_COMMA,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8648), 1,
      anon_sym_QMARK,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    ACTIONS(8781), 1,
      anon_sym_COLON,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8628), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [182410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5277), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5279), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [182458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4947), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
      aux_sym_kernel_call_syntax_token1,
  [182506] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5510), 1,
      anon_sym___attribute__,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(8783), 1,
      anon_sym_COLON,
    STATE(1937), 1,
      sym_attribute_specifier,
    STATE(2186), 1,
      sym__enum_base_clause,
    STATE(2234), 1,
      sym_enumerator_list,
    ACTIONS(6042), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6044), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [182565] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8785), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [182664] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1263), 1,
      sym__fold_operator,
    ACTIONS(8789), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(8787), 25,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [182713] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8200), 1,
      anon_sym_LBRACK,
    STATE(5152), 1,
      sym_new_declarator,
    ACTIONS(6038), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6040), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [182764] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym___attribute__,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(8791), 1,
      anon_sym_COLON,
    STATE(2088), 1,
      sym_attribute_specifier,
    STATE(5186), 1,
      sym__enum_base_clause,
    STATE(5348), 1,
      sym_enumerator_list,
    ACTIONS(6050), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6048), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [182823] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4641), 1,
      anon_sym_RBRACK,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [182922] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    ACTIONS(8793), 1,
      anon_sym_RBRACK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [183021] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8795), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [183120] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8797), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [183219] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4511), 1,
      sym_alignas_qualifier,
    ACTIONS(8802), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5008), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8079), 6,
      anon_sym_AMP,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(8077), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8799), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [183274] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8805), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [183373] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym_literal_suffix,
    ACTIONS(5710), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(5712), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [183422] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4619), 1,
      anon_sym_RBRACK,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [183521] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5708), 1,
      sym_literal_suffix,
    ACTIONS(3766), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(3758), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [183570] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8807), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [183669] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4625), 1,
      anon_sym_RBRACK,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [183768] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8809), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [183867] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3957), 1,
      anon_sym_LPAREN2,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5494), 1,
      anon_sym_LBRACK,
    ACTIONS(5619), 1,
      anon_sym_STAR,
    ACTIONS(5621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5623), 1,
      anon_sym_AMP,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6642), 1,
      sym__declarator,
    STATE(6925), 1,
      sym__abstract_declarator,
    STATE(8387), 1,
      sym_ms_based_modifier,
    ACTIONS(8279), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [183954] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8811), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [184053] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8813), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [184152] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8815), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [184251] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8817), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [184350] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    ACTIONS(8819), 1,
      anon_sym_RBRACK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [184449] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8222), 1,
      anon_sym___attribute__,
    STATE(5195), 1,
      sym_attribute_specifier,
    ACTIONS(5658), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5656), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [184500] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8821), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [184599] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8823), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [184698] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4664), 1,
      anon_sym_RBRACK,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [184797] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8825), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [184896] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4735), 1,
      anon_sym_RBRACK,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [184995] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8222), 1,
      anon_sym___attribute__,
    STATE(5196), 1,
      sym_attribute_specifier,
    ACTIONS(5676), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5674), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185046] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8827), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [185145] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8222), 1,
      anon_sym___attribute__,
    STATE(5181), 1,
      sym_attribute_specifier,
    ACTIONS(5727), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5725), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185196] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8829), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [185295] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8831), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [185394] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8833), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [185493] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4559), 1,
      anon_sym_RBRACK,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [185592] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8835), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [185691] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8222), 1,
      anon_sym___attribute__,
    STATE(5222), 1,
      sym_attribute_specifier,
    ACTIONS(5629), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5627), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185742] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8041), 1,
      anon_sym_STAR,
    ACTIONS(8043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8045), 1,
      anon_sym_AMP,
    STATE(3079), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6956), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8047), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [185815] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8837), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [185914] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8839), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [186013] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6928), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8039), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [186086] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8841), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [186185] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8041), 1,
      anon_sym_STAR,
    ACTIONS(8043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8045), 1,
      anon_sym_AMP,
    STATE(3079), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6943), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8039), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [186258] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8222), 1,
      anon_sym___attribute__,
    STATE(5213), 1,
      sym_attribute_specifier,
    ACTIONS(5670), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5668), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186309] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    ACTIONS(8843), 1,
      anon_sym_RBRACK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [186408] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8845), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [186507] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8847), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [186606] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8041), 1,
      anon_sym_STAR,
    ACTIONS(8043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8045), 1,
      anon_sym_AMP,
    STATE(3079), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6951), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5504), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [186679] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8648), 1,
      anon_sym_QMARK,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    ACTIONS(8849), 1,
      anon_sym_COLON,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8628), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [186778] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    ACTIONS(8851), 1,
      anon_sym_RBRACK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [186877] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8853), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [186976] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8222), 1,
      anon_sym___attribute__,
    STATE(5199), 1,
      sym_attribute_specifier,
    ACTIONS(5684), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5682), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187027] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8855), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [187126] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5510), 1,
      anon_sym___attribute__,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(8783), 1,
      anon_sym_COLON,
    STATE(2088), 1,
      sym_attribute_specifier,
    STATE(2168), 1,
      sym__enum_base_clause,
    STATE(2227), 1,
      sym_enumerator_list,
    ACTIONS(6048), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6050), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [187185] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8857), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [187284] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_RBRACK,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [187383] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8859), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [187482] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8861), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [187581] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8863), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [187680] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8865), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [187779] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6915), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8047), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [187852] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4565), 1,
      anon_sym_RBRACK,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [187951] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8867), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [188050] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8041), 1,
      anon_sym_STAR,
    ACTIONS(8043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8045), 1,
      anon_sym_AMP,
    STATE(3079), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6952), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6100), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [188123] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8869), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [188222] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    STATE(1651), 1,
      sym_template_argument_list,
    STATE(5332), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5532), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(5530), 31,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [188277] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8871), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [188376] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    ACTIONS(8873), 1,
      anon_sym_RBRACK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [188475] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8875), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [188574] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8877), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [188673] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8222), 1,
      anon_sym___attribute__,
    STATE(5231), 1,
      sym_attribute_specifier,
    ACTIONS(5716), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5714), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [188724] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8222), 1,
      anon_sym___attribute__,
    STATE(5239), 1,
      sym_attribute_specifier,
    ACTIONS(5723), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5721), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [188775] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8879), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [188874] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8881), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [188973] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym___attribute__,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(8791), 1,
      anon_sym_COLON,
    STATE(1937), 1,
      sym_attribute_specifier,
    STATE(5211), 1,
      sym__enum_base_clause,
    STATE(5355), 1,
      sym_enumerator_list,
    ACTIONS(6044), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6042), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [189032] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8883), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [189131] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8222), 1,
      anon_sym___attribute__,
    STATE(5288), 1,
      sym_attribute_specifier,
    ACTIONS(5700), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5698), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [189182] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8885), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [189281] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    ACTIONS(8887), 1,
      anon_sym_RBRACK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [189380] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4755), 1,
      anon_sym_RBRACK,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [189479] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4757), 1,
      anon_sym_RBRACK,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [189578] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8222), 1,
      anon_sym___attribute__,
    STATE(5298), 1,
      sym_attribute_specifier,
    ACTIONS(5635), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5633), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [189629] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8889), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [189728] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8192), 1,
      anon_sym_LBRACK,
    STATE(5161), 1,
      sym_new_declarator,
    ACTIONS(6038), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6040), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [189779] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8891), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [189878] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8648), 1,
      anon_sym_QMARK,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    ACTIONS(8893), 1,
      anon_sym_COLON,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8628), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [189977] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8895), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [190076] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8897), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [190175] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8899), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [190274] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8901), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [190373] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_RBRACK,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [190472] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5743), 1,
      anon_sym_LPAREN2,
    ACTIONS(5746), 1,
      anon_sym_LBRACK,
    ACTIONS(3766), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_DOT,
    ACTIONS(3758), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [190525] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8903), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [190624] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8905), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [190723] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8907), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [190822] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4651), 1,
      anon_sym_RBRACK,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [190921] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8909), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [191020] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8911), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [191119] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8222), 1,
      anon_sym___attribute__,
    STATE(5197), 1,
      sym_attribute_specifier,
    ACTIONS(5696), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5694), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [191170] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8913), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [191269] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    ACTIONS(8598), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8915), 1,
      anon_sym_RBRACK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [191368] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4561), 1,
      anon_sym_RBRACK,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [191467] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8222), 1,
      anon_sym___attribute__,
    STATE(5291), 1,
      sym_attribute_specifier,
    ACTIONS(5688), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5686), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [191518] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8917), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [191617] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8919), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [191716] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8921), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [191815] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3957), 1,
      anon_sym_LPAREN2,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5494), 1,
      anon_sym_LBRACK,
    ACTIONS(5591), 1,
      anon_sym_STAR,
    ACTIONS(5593), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5595), 1,
      anon_sym_AMP,
    STATE(3079), 1,
      sym_parameter_list,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6642), 1,
      sym__declarator,
    STATE(6947), 1,
      sym__abstract_declarator,
    STATE(8387), 1,
      sym_ms_based_modifier,
    ACTIONS(8279), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [191902] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8923), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [192001] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8925), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [192100] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    ACTIONS(8927), 1,
      anon_sym_RBRACK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [192199] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8929), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [192298] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4579), 1,
      anon_sym_RBRACK,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [192397] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4725), 1,
      anon_sym_RBRACK,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [192496] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8931), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [192595] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4723), 1,
      anon_sym_RBRACK,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [192694] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8933), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [192793] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4733), 1,
      anon_sym_RBRACK,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [192892] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8935), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [192991] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8648), 1,
      anon_sym_QMARK,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    ACTIONS(8937), 1,
      anon_sym_COLON,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8628), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [193090] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    ACTIONS(8939), 1,
      anon_sym_RBRACK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [193189] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8941), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [193288] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4595), 1,
      anon_sym_RBRACK,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [193387] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8943), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [193486] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4719), 1,
      anon_sym_RBRACK,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [193585] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8945), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [193684] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4569), 1,
      anon_sym_RBRACK,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [193783] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8947), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [193882] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4591), 1,
      anon_sym_RBRACK,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [193981] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6955), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6100), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [194054] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4551), 1,
      anon_sym_RBRACK,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [194153] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8949), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [194252] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8951), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [194351] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_const,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(4511), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6960), 1,
      sym__abstract_declarator,
    ACTIONS(7400), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5504), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7392), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [194424] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8953), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [194523] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8474), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [194622] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8648), 1,
      anon_sym_QMARK,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    ACTIONS(8955), 1,
      anon_sym_COLON,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8628), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [194721] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4149), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4151), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4144), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [194770] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8957), 1,
      anon_sym_RPAREN,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [194869] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8079), 1,
      anon_sym_AMP,
    ACTIONS(8799), 1,
      anon_sym_const,
    STATE(4511), 1,
      sym_alignas_qualifier,
    ACTIONS(8962), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5138), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8077), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8959), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [194926] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8965), 1,
      anon_sym_RBRACE,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [195025] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8626), 1,
      anon_sym_SLASH,
    ACTIONS(8632), 1,
      anon_sym_PIPE,
    ACTIONS(8636), 1,
      anon_sym_AMP,
    ACTIONS(8642), 1,
      anon_sym_GT_EQ,
    ACTIONS(8644), 1,
      anon_sym_LT_LT,
    ACTIONS(8646), 1,
      anon_sym_GT_GT,
    ACTIONS(8648), 1,
      anon_sym_QMARK,
    ACTIONS(8650), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8652), 1,
      anon_sym_bitor,
    ACTIONS(8654), 1,
      anon_sym_bitand,
    ACTIONS(8967), 1,
      anon_sym_COLON,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(7384), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8624), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8628), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8630), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8634), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8638), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8640), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [195124] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4149), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4151), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4144), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [195173] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8398), 1,
      anon_sym_SLASH,
    ACTIONS(8404), 1,
      anon_sym_PIPE,
    ACTIONS(8408), 1,
      anon_sym_AMP,
    ACTIONS(8414), 1,
      anon_sym_GT_EQ,
    ACTIONS(8416), 1,
      anon_sym_LT_LT,
    ACTIONS(8418), 1,
      anon_sym_GT_GT,
    ACTIONS(8422), 1,
      anon_sym_QMARK,
    ACTIONS(8424), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8426), 1,
      anon_sym_bitor,
    ACTIONS(8428), 1,
      anon_sym_bitand,
    ACTIONS(8969), 1,
      anon_sym_RBRACK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(7929), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8394), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8396), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8400), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8402), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8406), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8410), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8412), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [195272] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8971), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [195371] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 1,
      anon_sym___attribute__,
    ACTIONS(5913), 1,
      anon_sym_LBRACE,
    ACTIONS(8973), 1,
      anon_sym_COLON,
    STATE(2353), 1,
      sym__enum_base_clause,
    STATE(2384), 1,
      sym_enumerator_list,
    STATE(2616), 1,
      sym_attribute_specifier,
    ACTIONS(6042), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6044), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [195430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6981), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6983), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [195477] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 1,
      anon_sym___attribute__,
    ACTIONS(5913), 1,
      anon_sym_LBRACE,
    ACTIONS(8973), 1,
      anon_sym_COLON,
    STATE(2360), 1,
      sym__enum_base_clause,
    STATE(2374), 1,
      sym_enumerator_list,
    STATE(2586), 1,
      sym_attribute_specifier,
    ACTIONS(6048), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6050), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [195536] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8975), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [195635] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8977), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [195734] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    ACTIONS(8979), 1,
      anon_sym_SEMI,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [195833] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym_LBRACE,
    ACTIONS(8981), 1,
      anon_sym_LPAREN2,
    STATE(2236), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3884), 1,
      sym_argument_list,
    STATE(5246), 1,
      sym_initializer_list,
    ACTIONS(5192), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5702), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5194), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [195891] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5218), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5220), 36,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [195937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6165), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [195983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5386), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5388), 36,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [196029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5374), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5376), 36,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [196075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5358), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5360), 36,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [196121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6981), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6983), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [196167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5242), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5244), 36,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [196213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5234), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5236), 36,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [196259] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7964), 1,
      sym_auto,
    ACTIONS(7966), 1,
      anon_sym_decltype,
    STATE(5275), 1,
      sym_decltype_auto,
    ACTIONS(5171), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5173), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [196311] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6036), 1,
      sym_literal_suffix,
    ACTIONS(3766), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(3758), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [196359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6163), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6165), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [196405] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6092), 1,
      sym_literal_suffix,
    ACTIONS(5710), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(5712), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [196453] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6036), 1,
      sym_literal_suffix,
    ACTIONS(5710), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(5712), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [196501] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6092), 1,
      sym_literal_suffix,
    ACTIONS(3766), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(3758), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [196549] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    ACTIONS(6056), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_DOT,
    ACTIONS(6762), 1,
      aux_sym_kernel_call_syntax_token1,
    ACTIONS(8105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8285), 1,
      anon_sym_SLASH,
    ACTIONS(8291), 1,
      anon_sym_PIPE,
    ACTIONS(8295), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      anon_sym_GT_EQ,
    ACTIONS(8303), 1,
      anon_sym_LT_LT,
    ACTIONS(8305), 1,
      anon_sym_GT_GT,
    ACTIONS(8307), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8309), 1,
      anon_sym_bitor,
    ACTIONS(8311), 1,
      anon_sym_bitand,
    ACTIONS(8324), 1,
      anon_sym_QMARK,
    STATE(2734), 1,
      sym_subscript_argument_list,
    STATE(2738), 1,
      sym_argument_list,
    STATE(8032), 1,
      sym_kernel_call_syntax,
    ACTIONS(6062), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8062), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8283), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8287), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8289), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8293), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8297), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8299), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [196645] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5192), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5194), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [196693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5203), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5205), 36,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [196739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6981), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6983), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [196785] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3957), 1,
      anon_sym_LPAREN2,
    ACTIONS(3959), 1,
      anon_sym_STAR,
    ACTIONS(3961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3963), 1,
      anon_sym_AMP,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(5494), 1,
      anon_sym_LBRACK,
    ACTIONS(5631), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8279), 1,
      anon_sym_RPAREN,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym__scope_resolution,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6688), 1,
      sym__declarator,
    STATE(6925), 1,
      sym__abstract_declarator,
    STATE(8796), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [196871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6382), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6384), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [196916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6525), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6527), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [196961] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3766), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3758), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [197006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5192), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5194), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [197051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3766), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3758), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [197096] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8277), 1,
      anon_sym_LT,
    STATE(1651), 1,
      sym_template_argument_list,
    STATE(5332), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(3764), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(8984), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(3756), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [197151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6394), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6396), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [197196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6344), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6346), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [197241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6266), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6268), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [197286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6390), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6392), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [197331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6537), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6539), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [197376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5289), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5291), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [197421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5293), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5295), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [197466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5285), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5287), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [197511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4967), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4969), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [197556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3800), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3796), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [197601] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym___attribute__,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(1914), 1,
      sym_attribute_specifier,
    STATE(5353), 1,
      sym_enumerator_list,
    ACTIONS(5597), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5599), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [197654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5336), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5338), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [197699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6340), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6342), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [197744] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6282), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6284), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [197789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4925), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4927), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [197834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4937), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4939), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [197879] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(5504), 1,
      anon_sym_COLON,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8029), 1,
      anon_sym_const,
    ACTIONS(8149), 1,
      anon_sym_STAR,
    ACTIONS(8151), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8153), 1,
      anon_sym_AMP,
    STATE(3421), 1,
      sym_parameter_list,
    STATE(5599), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7063), 1,
      sym__abstract_declarator,
    ACTIONS(8031), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5389), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8021), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [197950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4933), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4935), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [197995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6525), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6527), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [198040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5297), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5299), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [198085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5311), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5313), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [198130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5250), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5252), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [198175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4949), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4951), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [198220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5222), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5224), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [198265] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_AMP,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(5593), 1,
      sym_ms_call_modifier,
    STATE(5917), 1,
      sym__declarator,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(7542), 1,
      sym_init_declarator,
    STATE(8511), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1839), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [198346] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_AMP,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(5626), 1,
      sym_ms_call_modifier,
    STATE(5983), 1,
      sym__declarator,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(7506), 1,
      sym_init_declarator,
    STATE(8511), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1839), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [198427] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8986), 1,
      sym_ms_restrict_modifier,
    STATE(5368), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(7170), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(8989), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8992), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(5202), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(7172), 27,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [198482] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_AMP,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(5580), 1,
      sym_ms_call_modifier,
    STATE(5939), 1,
      sym__declarator,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(7644), 1,
      sym_init_declarator,
    STATE(8511), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1839), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [198563] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3957), 1,
      anon_sym_LPAREN2,
    ACTIONS(3959), 1,
      anon_sym_STAR,
    ACTIONS(3961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3963), 1,
      anon_sym_AMP,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(5494), 1,
      anon_sym_LBRACK,
    ACTIONS(5631), 1,
      anon_sym_COLON_COLON,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6094), 1,
      sym__scope_resolution,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6882), 1,
      sym__declarator,
    STATE(7054), 1,
      sym__abstract_declarator,
    STATE(8796), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [198646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6318), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6320), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [198691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6324), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [198736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6258), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6260), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [198781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5226), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5228), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [198826] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4913), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4915), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [198871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6541), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6543), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [198916] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym___attribute__,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    STATE(2095), 1,
      sym_attribute_specifier,
    STATE(5349), 1,
      sym_enumerator_list,
    ACTIONS(5610), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5612), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [198969] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8995), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5402), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5404), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [199016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5230), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5232), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [199061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6517), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6519), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [199106] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8997), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8999), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5390), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5392), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [199155] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4929), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4931), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [199200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6412), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6414), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [199245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6513), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6515), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [199290] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3800), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3796), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [199335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6531), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [199380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4921), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4923), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [199425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5281), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5283), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [199470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6509), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6511), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [199515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6501), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6503), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [199560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6416), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [199605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6386), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6388), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [199650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6410), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [199695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6266), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6268), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [199740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6416), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6418), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [199785] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_AMP,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(5613), 1,
      sym_ms_call_modifier,
    STATE(5937), 1,
      sym__declarator,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(7635), 1,
      sym_init_declarator,
    STATE(8511), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1839), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [199866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5354), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5356), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [199911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6497), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6499), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [199956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6493), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6495), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [200001] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(8226), 1,
      anon_sym_LBRACE,
    ACTIONS(9001), 1,
      anon_sym_COLON,
    STATE(4550), 1,
      sym__enum_base_clause,
    STATE(4702), 1,
      sym_enumerator_list,
    STATE(4794), 1,
      sym_attribute_specifier,
    ACTIONS(6042), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6044), 28,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [200058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4953), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4955), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [200103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6364), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [200148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6376), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [200193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4947), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [200238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5370), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5372), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [200283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5301), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5303), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [200328] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8029), 1,
      anon_sym_const,
    ACTIONS(8047), 1,
      anon_sym_COLON,
    ACTIONS(8149), 1,
      anon_sym_STAR,
    ACTIONS(8151), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8153), 1,
      anon_sym_AMP,
    STATE(3421), 1,
      sym_parameter_list,
    STATE(5599), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7053), 1,
      sym__abstract_declarator,
    ACTIONS(8031), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5389), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8021), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [200399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5248), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [200444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5192), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5194), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [200489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4947), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [200534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6376), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [200579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6290), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6292), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [200624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6264), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [200669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6501), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6503), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [200714] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8999), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5402), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5404), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [200761] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3826), 1,
      anon_sym_SEMI,
    ACTIONS(4810), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5743), 1,
      anon_sym_LPAREN2,
    ACTIONS(5746), 1,
      anon_sym_LBRACK,
    ACTIONS(3766), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_DOT,
    ACTIONS(3758), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [200814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6336), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6338), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [200859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1901), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(1899), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [200904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6513), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6515), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [200949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6517), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6519), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [200994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3766), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3758), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [201039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5352), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [201084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4947), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [201129] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_AMP,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(5583), 1,
      sym_ms_call_modifier,
    STATE(5972), 1,
      sym__declarator,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(7813), 1,
      sym_init_declarator,
    STATE(8511), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1839), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [201210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6390), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6392), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [201255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3766), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3758), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [201300] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6394), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6396), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [201345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5340), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5342), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [201390] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(8226), 1,
      anon_sym_LBRACE,
    ACTIONS(9001), 1,
      anon_sym_COLON,
    STATE(4597), 1,
      sym__enum_base_clause,
    STATE(4636), 1,
      sym_enumerator_list,
    STATE(4878), 1,
      sym_attribute_specifier,
    ACTIONS(6048), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6050), 28,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [201447] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5175), 1,
      sym_auto,
    ACTIONS(5177), 1,
      anon_sym_decltype,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2003), 1,
      sym_decltype_auto,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5372), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9005), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(9003), 8,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [201506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5319), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5321), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [201551] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_AMP,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(5598), 1,
      sym_ms_call_modifier,
    STATE(5911), 1,
      sym__declarator,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(7612), 1,
      sym_init_declarator,
    STATE(8511), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1839), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [201632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5315), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5317), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [201677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6531), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [201722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6533), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6535), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [201767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6412), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6414), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [201812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6465), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6467), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [201857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4941), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4943), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [201902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6332), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6334), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [201947] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8029), 1,
      anon_sym_const,
    ACTIONS(8039), 1,
      anon_sym_COLON,
    ACTIONS(8149), 1,
      anon_sym_STAR,
    ACTIONS(8151), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8153), 1,
      anon_sym_AMP,
    STATE(3421), 1,
      sym_parameter_list,
    STATE(5599), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7059), 1,
      sym__abstract_declarator,
    ACTIONS(8031), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5389), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8021), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [202018] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5277), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5279), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [202063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6537), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6539), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [202108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5336), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5338), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [202153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6457), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6459), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [202198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6410), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [202243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1897), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(1895), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [202288] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5175), 1,
      sym_auto,
    ACTIONS(5177), 1,
      anon_sym_decltype,
    STATE(1830), 1,
      sym_alignas_qualifier,
    STATE(2003), 1,
      sym_decltype_auto,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5367), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9009), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(9007), 8,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [202347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5382), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5384), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [202392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6497), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6499), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [202437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6493), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6495), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [202482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6465), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6467), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [202527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6457), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6459), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [202572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6404), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6406), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [202617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5378), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5380), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [202662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6398), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6400), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [202707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4917), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4919), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [202752] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5214), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5216), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [202797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5238), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5240), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [202842] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6324), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [202887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6282), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6284), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [202932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5014), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(1962), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [202977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6258), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6260), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [203022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5366), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5368), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [203067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5362), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5364), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [203112] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3826), 1,
      anon_sym_SEMI,
    ACTIONS(5708), 1,
      sym_literal_suffix,
    ACTIONS(3766), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(3758), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [203161] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(6100), 1,
      anon_sym_COLON,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8029), 1,
      anon_sym_const,
    ACTIONS(8149), 1,
      anon_sym_STAR,
    ACTIONS(8151), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8153), 1,
      anon_sym_AMP,
    STATE(3421), 1,
      sym_parameter_list,
    STATE(5599), 1,
      sym_alignas_qualifier,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7039), 1,
      sym__abstract_declarator,
    ACTIONS(8031), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5389), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8021), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [203232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6364), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [203277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4909), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4911), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [203322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5254), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5256), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [203367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6318), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6320), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [203412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6290), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6292), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [203457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6533), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6535), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [203502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5014), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(1962), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [203547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5248), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [203592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6404), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6406), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [203637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5248), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [203682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6398), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6400), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [203727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6360), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [203772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6382), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6384), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [203817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6386), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6388), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [203862] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6340), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6342), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [203907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6358), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6360), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [203952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5145), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5147), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [203997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6336), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6338), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [204042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6541), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6543), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [204087] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_AMP,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(5630), 1,
      sym_ms_call_modifier,
    STATE(5892), 1,
      sym__declarator,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(7554), 1,
      sym_init_declarator,
    STATE(8511), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1839), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [204168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6262), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6264), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [204213] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8995), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9011), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(5390), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5392), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
      aux_sym_kernel_call_syntax_token2,
  [204262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6344), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6346), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [204307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6509), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6511), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [204352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6332), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6334), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
      aux_sym_kernel_call_syntax_token1,
  [204397] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6633), 1,
      anon_sym_DASH_GT,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9020), 1,
      anon_sym_requires,
    STATE(5384), 1,
      sym_ref_qualifier,
    STATE(6131), 1,
      sym__function_attributes_end,
    STATE(6241), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9017), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5633), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [204479] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5330), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5446), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9023), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5448), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [204527] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5331), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5440), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9026), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5442), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [204575] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(5627), 1,
      sym_ms_call_modifier,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6746), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1839), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [204653] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1867), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5422), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9029), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5424), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [204701] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1867), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5416), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9032), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5418), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [204749] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1867), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5432), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9035), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5434), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [204797] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6633), 1,
      anon_sym_DASH_GT,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6676), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    STATE(5380), 1,
      sym_ref_qualifier,
    STATE(6135), 1,
      sym__function_attributes_end,
    STATE(6271), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5635), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [204879] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5346), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5376), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(5374), 31,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [204925] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(5592), 1,
      sym_ms_call_modifier,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6681), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1839), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [205003] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(5597), 1,
      sym_ms_call_modifier,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6765), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1839), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [205081] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2120), 1,
      anon_sym_STAR,
    ACTIONS(2122), 1,
      anon_sym_AMP,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(5631), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(5602), 1,
      sym_ms_call_modifier,
    STATE(6094), 1,
      sym__scope_resolution,
    STATE(6903), 1,
      sym__declarator,
    STATE(8796), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1839), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [205159] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(5629), 1,
      sym_ms_call_modifier,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6755), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1839), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [205237] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(5614), 1,
      anon_sym_LPAREN2,
    STATE(2133), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2726), 1,
      sym_argument_list,
    STATE(4269), 1,
      sym_initializer_list,
    ACTIONS(5192), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5452), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5194), 25,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
  [205293] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(5624), 1,
      sym_ms_call_modifier,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6766), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1839), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [205371] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2791), 1,
      anon_sym_LBRACE,
    ACTIONS(6219), 1,
      anon_sym_LPAREN2,
    STATE(2133), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3673), 1,
      sym_argument_list,
    STATE(3678), 1,
      sym_initializer_list,
    ACTIONS(5192), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5452), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5194), 25,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
  [205427] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9038), 1,
      sym_identifier,
    ACTIONS(9044), 1,
      sym_primitive_type,
    STATE(5343), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5325), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9041), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5327), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
  [205479] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1867), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5258), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9047), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5261), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [205527] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3826), 1,
      anon_sym_SEMI,
    ACTIONS(3766), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_DOT,
    ACTIONS(3758), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      aux_sym_kernel_call_syntax_token1,
  [205573] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(5619), 1,
      sym_ms_call_modifier,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6762), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1839), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [205651] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1867), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5436), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9051), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5438), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___attribute__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [205699] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(5578), 1,
      sym_ms_call_modifier,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6690), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1839), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [205777] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym___attribute__,
    STATE(1909), 1,
      sym_attribute_specifier,
    ACTIONS(5682), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5684), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [205824] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym___attribute__,
    STATE(1916), 1,
      sym_attribute_specifier,
    ACTIONS(5668), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5670), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [205871] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym___attribute__,
    STATE(2035), 1,
      sym_attribute_specifier,
    ACTIONS(5674), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5676), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [205918] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6698), 1,
      anon_sym_DASH_GT,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9054), 1,
      anon_sym___attribute__,
    ACTIONS(9057), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5400), 1,
      sym_ref_qualifier,
    STATE(6037), 1,
      sym__function_attributes_end,
    STATE(6076), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5648), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [205999] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym___attribute__,
    STATE(1944), 1,
      sym_attribute_specifier,
    ACTIONS(5694), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5696), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [206046] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym___attribute__,
    STATE(2019), 1,
      sym_attribute_specifier,
    ACTIONS(5656), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5658), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [206093] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym___attribute__,
    STATE(2087), 1,
      sym_attribute_specifier,
    ACTIONS(5633), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5635), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [206140] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym___attribute__,
    STATE(2094), 1,
      sym_attribute_specifier,
    ACTIONS(5698), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5700), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [206187] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym___attribute__,
    STATE(2091), 1,
      sym_attribute_specifier,
    ACTIONS(5721), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5723), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [206234] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym___attribute__,
    STATE(2009), 1,
      sym_attribute_specifier,
    ACTIONS(5627), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5629), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [206281] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6698), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9054), 1,
      anon_sym___attribute__,
    ACTIONS(9057), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9063), 1,
      anon_sym_requires,
    STATE(5392), 1,
      sym_ref_qualifier,
    STATE(6019), 1,
      sym_trailing_return_type,
    STATE(6082), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5647), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [206362] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym___attribute__,
    STATE(1874), 1,
      sym_attribute_specifier,
    ACTIONS(5686), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5688), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [206409] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym___attribute__,
    STATE(2085), 1,
      sym_attribute_specifier,
    ACTIONS(5714), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5716), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [206456] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym___attribute__,
    STATE(2013), 1,
      sym_attribute_specifier,
    ACTIONS(5725), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5727), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [206503] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(121), 1,
      sym_auto,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1771), 1,
      anon_sym_enum,
    ACTIONS(1773), 1,
      anon_sym_class,
    ACTIONS(1775), 1,
      anon_sym_struct,
    ACTIONS(1777), 1,
      anon_sym_union,
    ACTIONS(1801), 1,
      anon_sym_typename,
    ACTIONS(2132), 1,
      sym_primitive_type,
    ACTIONS(4254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9066), 1,
      sym_identifier,
    ACTIONS(9068), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9072), 1,
      anon_sym_EQ,
    STATE(2160), 1,
      sym_type_specifier,
    STATE(2173), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2194), 1,
      sym_decltype_auto,
    STATE(2604), 1,
      sym_qualified_type_identifier,
    STATE(6858), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    ACTIONS(9070), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(2154), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(55), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2200), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [206587] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6822), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9057), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9063), 1,
      anon_sym_requires,
    STATE(5425), 1,
      sym_ref_qualifier,
    STATE(6019), 1,
      sym_trailing_return_type,
    STATE(6187), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5660), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [206667] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6811), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9074), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9077), 1,
      anon_sym_requires,
    STATE(5431), 1,
      sym_ref_qualifier,
    STATE(6088), 1,
      sym_trailing_return_type,
    STATE(6194), 1,
      sym__function_attributes_end,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5663), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [206747] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6811), 1,
      anon_sym_DASH_GT,
    ACTIONS(6813), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9074), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5422), 1,
      sym_ref_qualifier,
    STATE(6103), 1,
      sym_trailing_return_type,
    STATE(6213), 1,
      sym__function_attributes_end,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5679), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [206827] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6822), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9057), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5417), 1,
      sym_ref_qualifier,
    STATE(6076), 1,
      sym_trailing_return_type,
    STATE(6196), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5673), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [206907] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1830), 1,
      sym_alignas_qualifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9082), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(9080), 8,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [206957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7700), 3,
      anon_sym_AMP,
      sym_ms_restrict_modifier,
      anon_sym_const,
    ACTIONS(7702), 31,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [206999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7704), 3,
      anon_sym_AMP,
      sym_ms_restrict_modifier,
      anon_sym_const,
    ACTIONS(7706), 31,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [207041] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9068), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9072), 1,
      anon_sym_EQ,
    ACTIONS(9084), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2197), 1,
      sym__class_declaration,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5869), 1,
      sym_ms_declspec_modifier,
    STATE(6858), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9070), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(2161), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5859), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5621), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [207131] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6801), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9057), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9063), 1,
      anon_sym_requires,
    STATE(5429), 1,
      sym_ref_qualifier,
    STATE(6013), 1,
      sym__function_attributes_end,
    STATE(6019), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9086), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5670), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [207211] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1830), 1,
      sym_alignas_qualifier,
    ACTIONS(65), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9091), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(9089), 8,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(63), 18,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [207261] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6813), 1,
      anon_sym_requires,
    ACTIONS(6820), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9074), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5426), 1,
      sym_ref_qualifier,
    STATE(6103), 1,
      sym_trailing_return_type,
    STATE(6110), 1,
      sym__function_attributes_end,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9086), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5654), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [207341] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5346), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5194), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(9093), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5192), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [207387] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6820), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9074), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9077), 1,
      anon_sym_requires,
    STATE(5420), 1,
      sym_ref_qualifier,
    STATE(6024), 1,
      sym__function_attributes_end,
    STATE(6088), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9086), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5666), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [207467] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6801), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9057), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5421), 1,
      sym_ref_qualifier,
    STATE(6063), 1,
      sym__function_attributes_end,
    STATE(6076), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9086), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5665), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [207547] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6977), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9074), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9096), 1,
      anon_sym_requires,
    STATE(5498), 1,
      sym_ref_qualifier,
    STATE(6226), 1,
      sym__function_attributes_end,
    STATE(6422), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5692), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [207626] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6840), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9099), 1,
      anon_sym_requires,
    STATE(5440), 1,
      sym_ref_qualifier,
    STATE(6350), 1,
      sym__function_attributes_end,
    STATE(6412), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9017), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5701), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [207705] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6977), 1,
      anon_sym_DASH_GT,
    ACTIONS(6979), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9074), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5577), 1,
      sym_ref_qualifier,
    STATE(6270), 1,
      sym__function_attributes_end,
    STATE(6415), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5684), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [207784] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6633), 1,
      anon_sym_DASH_GT,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6676), 1,
      anon_sym_requires,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    STATE(6130), 1,
      sym__function_attributes_end,
    STATE(6282), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5637), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9102), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [207857] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6633), 1,
      anon_sym_DASH_GT,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6676), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    STATE(6135), 1,
      sym__function_attributes_end,
    STATE(6271), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5635), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [207930] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6633), 1,
      anon_sym_DASH_GT,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9020), 1,
      anon_sym_requires,
    STATE(6131), 1,
      sym__function_attributes_end,
    STATE(6241), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9017), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5633), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [208003] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6840), 1,
      anon_sym_DASH_GT,
    ACTIONS(6990), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    STATE(5473), 1,
      sym_ref_qualifier,
    STATE(6337), 1,
      sym__function_attributes_end,
    STATE(6500), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5682), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [208082] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6633), 1,
      anon_sym_DASH_GT,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9109), 1,
      anon_sym_requires,
    STATE(6141), 1,
      sym__function_attributes_end,
    STATE(6236), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9106), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5634), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9102), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [208155] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5187), 1,
      anon_sym_LBRACE,
    ACTIONS(5192), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5194), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [208200] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6698), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9054), 1,
      anon_sym___attribute__,
    ACTIONS(9057), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9063), 1,
      anon_sym_requires,
    STATE(6019), 1,
      sym_trailing_return_type,
    STATE(6082), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5647), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [208272] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    ACTIONS(9112), 1,
      sym_identifier,
    ACTIONS(9114), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9118), 1,
      sym_primitive_type,
    ACTIONS(9120), 1,
      anon_sym_enum,
    ACTIONS(9122), 1,
      anon_sym_class,
    ACTIONS(9124), 1,
      anon_sym_struct,
    ACTIONS(9126), 1,
      anon_sym_union,
    ACTIONS(9128), 1,
      sym_auto,
    ACTIONS(9130), 1,
      anon_sym_decltype,
    ACTIONS(9132), 1,
      anon_sym_typename,
    STATE(2642), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2906), 1,
      sym_type_specifier,
    STATE(3264), 1,
      sym_qualified_type_identifier,
    STATE(3453), 1,
      sym_decltype_auto,
    STATE(5539), 1,
      sym_argument_list,
    STATE(6861), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(3102), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9116), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3449), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [208352] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    ACTIONS(9134), 1,
      sym_identifier,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9140), 1,
      sym_primitive_type,
    ACTIONS(9142), 1,
      anon_sym_enum,
    ACTIONS(9144), 1,
      anon_sym_class,
    ACTIONS(9146), 1,
      anon_sym_struct,
    ACTIONS(9148), 1,
      anon_sym_union,
    ACTIONS(9150), 1,
      sym_auto,
    ACTIONS(9152), 1,
      anon_sym_decltype,
    ACTIONS(9154), 1,
      anon_sym_typename,
    STATE(2238), 1,
      sym_type_specifier,
    STATE(2367), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2390), 1,
      sym_decltype_auto,
    STATE(2412), 1,
      sym_qualified_type_identifier,
    STATE(5456), 1,
      sym_argument_list,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(2322), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9138), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2396), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [208432] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8079), 1,
      anon_sym_AMP,
    ACTIONS(9159), 1,
      anon_sym_const,
    STATE(5599), 1,
      sym_alignas_qualifier,
    ACTIONS(9162), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5389), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8077), 8,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(9156), 17,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
  [208482] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    ACTIONS(9134), 1,
      sym_identifier,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9140), 1,
      sym_primitive_type,
    ACTIONS(9142), 1,
      anon_sym_enum,
    ACTIONS(9144), 1,
      anon_sym_class,
    ACTIONS(9146), 1,
      anon_sym_struct,
    ACTIONS(9148), 1,
      anon_sym_union,
    ACTIONS(9150), 1,
      sym_auto,
    ACTIONS(9152), 1,
      anon_sym_decltype,
    ACTIONS(9154), 1,
      anon_sym_typename,
    STATE(2232), 1,
      sym_type_specifier,
    STATE(2367), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2390), 1,
      sym_decltype_auto,
    STATE(2412), 1,
      sym_qualified_type_identifier,
    STATE(5547), 1,
      sym_argument_list,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(2322), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9138), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2396), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [208562] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9144), 1,
      anon_sym_class,
    ACTIONS(9146), 1,
      anon_sym_struct,
    ACTIONS(9148), 1,
      anon_sym_union,
    ACTIONS(9150), 1,
      sym_auto,
    ACTIONS(9152), 1,
      anon_sym_decltype,
    ACTIONS(9165), 1,
      sym_identifier,
    ACTIONS(9169), 1,
      sym_primitive_type,
    ACTIONS(9171), 1,
      anon_sym_enum,
    ACTIONS(9173), 1,
      anon_sym_typename,
    STATE(2238), 1,
      sym_type_specifier,
    STATE(2324), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2390), 1,
      sym_decltype_auto,
    STATE(2412), 1,
      sym_qualified_type_identifier,
    STATE(5486), 1,
      sym_argument_list,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(2322), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9167), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2396), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [208642] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6698), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9175), 1,
      anon_sym___attribute__,
    ACTIONS(9178), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9184), 1,
      anon_sym_requires,
    STATE(6069), 1,
      sym__function_attributes_end,
    STATE(6107), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9181), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5646), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9102), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [208714] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    ACTIONS(9187), 1,
      sym_identifier,
    ACTIONS(9189), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9193), 1,
      sym_primitive_type,
    ACTIONS(9195), 1,
      anon_sym_enum,
    ACTIONS(9197), 1,
      anon_sym_class,
    ACTIONS(9199), 1,
      anon_sym_struct,
    ACTIONS(9201), 1,
      anon_sym_union,
    ACTIONS(9203), 1,
      sym_auto,
    ACTIONS(9205), 1,
      anon_sym_decltype,
    ACTIONS(9207), 1,
      anon_sym_typename,
    STATE(2590), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2853), 1,
      sym_type_specifier,
    STATE(3089), 1,
      sym_decltype_auto,
    STATE(3099), 1,
      sym_qualified_type_identifier,
    STATE(5546), 1,
      sym_argument_list,
    STATE(6836), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(3053), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9191), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3091), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [208794] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(7026), 1,
      anon_sym_DASH_GT,
    ACTIONS(7037), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    STATE(5605), 1,
      sym_ref_qualifier,
    STATE(6382), 1,
      sym__function_attributes_end,
    STATE(6629), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5703), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [208872] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    ACTIONS(9209), 1,
      sym_identifier,
    ACTIONS(9211), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9215), 1,
      sym_primitive_type,
    ACTIONS(9217), 1,
      anon_sym_enum,
    ACTIONS(9219), 1,
      anon_sym_class,
    ACTIONS(9221), 1,
      anon_sym_struct,
    ACTIONS(9223), 1,
      anon_sym_union,
    ACTIONS(9225), 1,
      sym_auto,
    ACTIONS(9227), 1,
      anon_sym_decltype,
    ACTIONS(9229), 1,
      anon_sym_typename,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(3828), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4125), 1,
      sym_type_specifier,
    STATE(4450), 1,
      sym_decltype_auto,
    STATE(5451), 1,
      sym_argument_list,
    STATE(6855), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(4333), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9213), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4452), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [208952] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7138), 1,
      sym_primitive_type,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    ACTIONS(9231), 1,
      sym_identifier,
    ACTIONS(9233), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9235), 1,
      anon_sym_enum,
    ACTIONS(9237), 1,
      anon_sym_class,
    ACTIONS(9239), 1,
      anon_sym_struct,
    ACTIONS(9241), 1,
      anon_sym_union,
    ACTIONS(9243), 1,
      anon_sym_typename,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4434), 1,
      sym_type_specifier,
    STATE(5512), 1,
      sym_argument_list,
    STATE(6864), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [209032] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5187), 1,
      anon_sym_LBRACE,
    ACTIONS(5192), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5194), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [209074] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(7026), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9245), 1,
      anon_sym_requires,
    STATE(5588), 1,
      sym_ref_qualifier,
    STATE(6389), 1,
      sym__function_attributes_end,
    STATE(6653), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9017), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5711), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [209152] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7138), 1,
      sym_primitive_type,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    ACTIONS(9231), 1,
      sym_identifier,
    ACTIONS(9233), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9235), 1,
      anon_sym_enum,
    ACTIONS(9237), 1,
      anon_sym_class,
    ACTIONS(9239), 1,
      anon_sym_struct,
    ACTIONS(9241), 1,
      anon_sym_union,
    ACTIONS(9243), 1,
      anon_sym_typename,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4367), 1,
      sym_type_specifier,
    STATE(5437), 1,
      sym_argument_list,
    STATE(6864), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [209232] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6698), 1,
      anon_sym_DASH_GT,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9175), 1,
      anon_sym___attribute__,
    ACTIONS(9178), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6027), 1,
      sym__function_attributes_end,
    STATE(6029), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5639), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9102), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [209304] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    ACTIONS(9209), 1,
      sym_identifier,
    ACTIONS(9211), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9215), 1,
      sym_primitive_type,
    ACTIONS(9217), 1,
      anon_sym_enum,
    ACTIONS(9219), 1,
      anon_sym_class,
    ACTIONS(9221), 1,
      anon_sym_struct,
    ACTIONS(9223), 1,
      anon_sym_union,
    ACTIONS(9225), 1,
      sym_auto,
    ACTIONS(9227), 1,
      anon_sym_decltype,
    ACTIONS(9229), 1,
      anon_sym_typename,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(3828), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4183), 1,
      sym_type_specifier,
    STATE(4450), 1,
      sym_decltype_auto,
    STATE(5448), 1,
      sym_argument_list,
    STATE(6855), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(4333), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9213), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4452), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [209384] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    ACTIONS(9248), 1,
      sym_identifier,
    ACTIONS(9250), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9254), 1,
      sym_primitive_type,
    ACTIONS(9256), 1,
      anon_sym_enum,
    ACTIONS(9258), 1,
      anon_sym_class,
    ACTIONS(9260), 1,
      anon_sym_struct,
    ACTIONS(9262), 1,
      anon_sym_union,
    ACTIONS(9264), 1,
      sym_auto,
    ACTIONS(9266), 1,
      anon_sym_decltype,
    ACTIONS(9268), 1,
      anon_sym_typename,
    STATE(2771), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3076), 1,
      sym_type_specifier,
    STATE(3680), 1,
      sym_decltype_auto,
    STATE(3716), 1,
      sym_qualified_type_identifier,
    STATE(5491), 1,
      sym_argument_list,
    STATE(6853), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(3576), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9252), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3684), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [209464] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9144), 1,
      anon_sym_class,
    ACTIONS(9146), 1,
      anon_sym_struct,
    ACTIONS(9148), 1,
      anon_sym_union,
    ACTIONS(9150), 1,
      sym_auto,
    ACTIONS(9152), 1,
      anon_sym_decltype,
    ACTIONS(9165), 1,
      sym_identifier,
    ACTIONS(9169), 1,
      sym_primitive_type,
    ACTIONS(9171), 1,
      anon_sym_enum,
    ACTIONS(9173), 1,
      anon_sym_typename,
    STATE(2232), 1,
      sym_type_specifier,
    STATE(2324), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2390), 1,
      sym_decltype_auto,
    STATE(2412), 1,
      sym_qualified_type_identifier,
    STATE(5487), 1,
      sym_argument_list,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(2322), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9167), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2396), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [209544] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7138), 1,
      sym_primitive_type,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    ACTIONS(9231), 1,
      sym_identifier,
    ACTIONS(9233), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9235), 1,
      anon_sym_enum,
    ACTIONS(9237), 1,
      anon_sym_class,
    ACTIONS(9239), 1,
      anon_sym_struct,
    ACTIONS(9241), 1,
      anon_sym_union,
    ACTIONS(9243), 1,
      anon_sym_typename,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4280), 1,
      sym_type_specifier,
    STATE(5518), 1,
      sym_argument_list,
    STATE(6864), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [209624] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7138), 1,
      sym_primitive_type,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    ACTIONS(9231), 1,
      sym_identifier,
    ACTIONS(9233), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9235), 1,
      anon_sym_enum,
    ACTIONS(9237), 1,
      anon_sym_class,
    ACTIONS(9239), 1,
      anon_sym_struct,
    ACTIONS(9241), 1,
      anon_sym_union,
    ACTIONS(9243), 1,
      anon_sym_typename,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4319), 1,
      sym_type_specifier,
    STATE(5567), 1,
      sym_argument_list,
    STATE(6864), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [209704] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    ACTIONS(9270), 1,
      sym_identifier,
    ACTIONS(9272), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9276), 1,
      sym_primitive_type,
    ACTIONS(9278), 1,
      anon_sym_enum,
    ACTIONS(9280), 1,
      anon_sym_class,
    ACTIONS(9282), 1,
      anon_sym_struct,
    ACTIONS(9284), 1,
      anon_sym_union,
    ACTIONS(9286), 1,
      sym_auto,
    ACTIONS(9288), 1,
      anon_sym_decltype,
    ACTIONS(9290), 1,
      anon_sym_typename,
    STATE(4208), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4473), 1,
      sym_type_specifier,
    STATE(4755), 1,
      sym_decltype_auto,
    STATE(4984), 1,
      sym_qualified_type_identifier,
    STATE(5447), 1,
      sym_argument_list,
    STATE(6829), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(4628), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9274), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4756), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [209784] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    ACTIONS(9187), 1,
      sym_identifier,
    ACTIONS(9189), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9193), 1,
      sym_primitive_type,
    ACTIONS(9195), 1,
      anon_sym_enum,
    ACTIONS(9197), 1,
      anon_sym_class,
    ACTIONS(9199), 1,
      anon_sym_struct,
    ACTIONS(9201), 1,
      anon_sym_union,
    ACTIONS(9203), 1,
      sym_auto,
    ACTIONS(9205), 1,
      anon_sym_decltype,
    ACTIONS(9207), 1,
      anon_sym_typename,
    STATE(2590), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2847), 1,
      sym_type_specifier,
    STATE(3089), 1,
      sym_decltype_auto,
    STATE(3099), 1,
      sym_qualified_type_identifier,
    STATE(5493), 1,
      sym_argument_list,
    STATE(6836), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(3053), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9191), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3091), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [209864] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    ACTIONS(9292), 1,
      sym_identifier,
    ACTIONS(9294), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9298), 1,
      sym_primitive_type,
    ACTIONS(9300), 1,
      anon_sym_enum,
    ACTIONS(9302), 1,
      anon_sym_class,
    ACTIONS(9304), 1,
      anon_sym_struct,
    ACTIONS(9306), 1,
      anon_sym_union,
    ACTIONS(9308), 1,
      sym_auto,
    ACTIONS(9310), 1,
      anon_sym_decltype,
    ACTIONS(9312), 1,
      anon_sym_typename,
    STATE(2715), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2933), 1,
      sym_type_specifier,
    STATE(3319), 1,
      sym_decltype_auto,
    STATE(3443), 1,
      sym_qualified_type_identifier,
    STATE(5472), 1,
      sym_argument_list,
    STATE(6809), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(3147), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9296), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3318), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [209944] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2757), 1,
      sym_auto,
    ACTIONS(2759), 1,
      anon_sym_decltype,
    ACTIONS(7439), 1,
      sym_primitive_type,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    ACTIONS(9314), 1,
      sym_identifier,
    ACTIONS(9316), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9318), 1,
      anon_sym_enum,
    ACTIONS(9320), 1,
      anon_sym_class,
    ACTIONS(9322), 1,
      anon_sym_struct,
    ACTIONS(9324), 1,
      anon_sym_union,
    ACTIONS(9326), 1,
      anon_sym_typename,
    STATE(2157), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2557), 1,
      sym_qualified_type_identifier,
    STATE(2598), 1,
      sym_decltype_auto,
    STATE(4470), 1,
      sym_type_specifier,
    STATE(5517), 1,
      sym_argument_list,
    STATE(6846), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(2477), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2723), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2599), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [210024] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2757), 1,
      sym_auto,
    ACTIONS(2759), 1,
      anon_sym_decltype,
    ACTIONS(7439), 1,
      sym_primitive_type,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    ACTIONS(9314), 1,
      sym_identifier,
    ACTIONS(9316), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9318), 1,
      anon_sym_enum,
    ACTIONS(9320), 1,
      anon_sym_class,
    ACTIONS(9322), 1,
      anon_sym_struct,
    ACTIONS(9324), 1,
      anon_sym_union,
    ACTIONS(9326), 1,
      anon_sym_typename,
    STATE(2157), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2557), 1,
      sym_qualified_type_identifier,
    STATE(2598), 1,
      sym_decltype_auto,
    STATE(4472), 1,
      sym_type_specifier,
    STATE(5452), 1,
      sym_argument_list,
    STATE(6846), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(2477), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2723), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2599), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [210104] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    ACTIONS(9248), 1,
      sym_identifier,
    ACTIONS(9250), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9254), 1,
      sym_primitive_type,
    ACTIONS(9256), 1,
      anon_sym_enum,
    ACTIONS(9258), 1,
      anon_sym_class,
    ACTIONS(9260), 1,
      anon_sym_struct,
    ACTIONS(9262), 1,
      anon_sym_union,
    ACTIONS(9264), 1,
      sym_auto,
    ACTIONS(9266), 1,
      anon_sym_decltype,
    ACTIONS(9268), 1,
      anon_sym_typename,
    STATE(2771), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3083), 1,
      sym_type_specifier,
    STATE(3680), 1,
      sym_decltype_auto,
    STATE(3716), 1,
      sym_qualified_type_identifier,
    STATE(5476), 1,
      sym_argument_list,
    STATE(6853), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(3576), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9252), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3684), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [210184] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6698), 1,
      anon_sym_DASH_GT,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9054), 1,
      anon_sym___attribute__,
    ACTIONS(9057), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6037), 1,
      sym__function_attributes_end,
    STATE(6076), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5648), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [210256] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    ACTIONS(9270), 1,
      sym_identifier,
    ACTIONS(9272), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9276), 1,
      sym_primitive_type,
    ACTIONS(9278), 1,
      anon_sym_enum,
    ACTIONS(9280), 1,
      anon_sym_class,
    ACTIONS(9282), 1,
      anon_sym_struct,
    ACTIONS(9284), 1,
      anon_sym_union,
    ACTIONS(9286), 1,
      sym_auto,
    ACTIONS(9288), 1,
      anon_sym_decltype,
    ACTIONS(9290), 1,
      anon_sym_typename,
    STATE(4208), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4476), 1,
      sym_type_specifier,
    STATE(4755), 1,
      sym_decltype_auto,
    STATE(4984), 1,
      sym_qualified_type_identifier,
    STATE(5443), 1,
      sym_argument_list,
    STATE(6829), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(4628), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9274), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4756), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [210336] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    ACTIONS(9292), 1,
      sym_identifier,
    ACTIONS(9294), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9298), 1,
      sym_primitive_type,
    ACTIONS(9300), 1,
      anon_sym_enum,
    ACTIONS(9302), 1,
      anon_sym_class,
    ACTIONS(9304), 1,
      anon_sym_struct,
    ACTIONS(9306), 1,
      anon_sym_union,
    ACTIONS(9308), 1,
      sym_auto,
    ACTIONS(9310), 1,
      anon_sym_decltype,
    ACTIONS(9312), 1,
      anon_sym_typename,
    STATE(2715), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2923), 1,
      sym_type_specifier,
    STATE(3319), 1,
      sym_decltype_auto,
    STATE(3443), 1,
      sym_qualified_type_identifier,
    STATE(5475), 1,
      sym_argument_list,
    STATE(6809), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(3147), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9296), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3318), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [210416] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    ACTIONS(9112), 1,
      sym_identifier,
    ACTIONS(9114), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9118), 1,
      sym_primitive_type,
    ACTIONS(9120), 1,
      anon_sym_enum,
    ACTIONS(9122), 1,
      anon_sym_class,
    ACTIONS(9124), 1,
      anon_sym_struct,
    ACTIONS(9126), 1,
      anon_sym_union,
    ACTIONS(9128), 1,
      sym_auto,
    ACTIONS(9130), 1,
      anon_sym_decltype,
    ACTIONS(9132), 1,
      anon_sym_typename,
    STATE(2642), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2891), 1,
      sym_type_specifier,
    STATE(3264), 1,
      sym_qualified_type_identifier,
    STATE(3453), 1,
      sym_decltype_auto,
    STATE(5548), 1,
      sym_argument_list,
    STATE(6861), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(3102), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9116), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3449), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [210496] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6822), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9057), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6076), 1,
      sym_trailing_return_type,
    STATE(6196), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5673), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [210567] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6822), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9178), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6029), 1,
      sym_trailing_return_type,
    STATE(6174), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5657), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9102), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [210638] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6822), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9057), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9063), 1,
      anon_sym_requires,
    STATE(6019), 1,
      sym_trailing_return_type,
    STATE(6187), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5660), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [210709] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6820), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9074), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9077), 1,
      anon_sym_requires,
    STATE(6024), 1,
      sym__function_attributes_end,
    STATE(6088), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9086), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5666), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [210780] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6820), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9328), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9334), 1,
      anon_sym_requires,
    STATE(6007), 1,
      sym__function_attributes_end,
    STATE(6086), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(9181), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9331), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5668), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9102), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [210851] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6801), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9178), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6029), 1,
      sym_trailing_return_type,
    STATE(6056), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9331), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5655), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9102), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [210922] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6811), 1,
      anon_sym_DASH_GT,
    ACTIONS(6813), 1,
      anon_sym_requires,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9328), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6023), 1,
      sym_trailing_return_type,
    STATE(6212), 1,
      sym__function_attributes_end,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5677), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9102), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [210993] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6811), 1,
      anon_sym_DASH_GT,
    ACTIONS(6813), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9074), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6103), 1,
      sym_trailing_return_type,
    STATE(6213), 1,
      sym__function_attributes_end,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5679), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [211064] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6801), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9057), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6063), 1,
      sym__function_attributes_end,
    STATE(6076), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9086), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5665), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [211135] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6822), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9178), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9184), 1,
      anon_sym_requires,
    STATE(6107), 1,
      sym_trailing_return_type,
    STATE(6146), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9181), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5676), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9102), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [211206] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6813), 1,
      anon_sym_requires,
    ACTIONS(6820), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9328), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6023), 1,
      sym_trailing_return_type,
    STATE(6106), 1,
      sym__function_attributes_end,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9331), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5671), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9102), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [211277] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6813), 1,
      anon_sym_requires,
    ACTIONS(6820), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9074), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6103), 1,
      sym_trailing_return_type,
    STATE(6110), 1,
      sym__function_attributes_end,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9086), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5654), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [211348] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6811), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9074), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9077), 1,
      anon_sym_requires,
    STATE(6088), 1,
      sym_trailing_return_type,
    STATE(6194), 1,
      sym__function_attributes_end,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5663), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [211419] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6801), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9178), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9184), 1,
      anon_sym_requires,
    STATE(6020), 1,
      sym__function_attributes_end,
    STATE(6107), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(9181), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9331), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5669), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9102), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [211490] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6801), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9057), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9063), 1,
      anon_sym_requires,
    STATE(6013), 1,
      sym__function_attributes_end,
    STATE(6019), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9086), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5670), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [211561] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6811), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9328), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9334), 1,
      anon_sym_requires,
    STATE(6086), 1,
      sym_trailing_return_type,
    STATE(6191), 1,
      sym__function_attributes_end,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9181), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5664), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9102), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [211632] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(8013), 1,
      anon_sym_LBRACE,
    ACTIONS(9272), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9337), 1,
      sym_identifier,
    STATE(4418), 1,
      sym_template_type,
    STATE(4537), 1,
      sym_field_declaration_list,
    STATE(4774), 1,
      sym__class_declaration_item,
    STATE(4776), 1,
      sym__class_declaration,
    STATE(5845), 1,
      sym_ms_declspec_modifier,
    STATE(6829), 1,
      sym__scope_resolution,
    STATE(7261), 1,
      sym_virtual_specifier,
    STATE(8010), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4250), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5850), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5614), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [211712] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2191), 1,
      sym__class_declaration,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5818), 1,
      sym_ms_declspec_modifier,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2161), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5784), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5623), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [211792] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(5654), 1,
      anon_sym_LBRACE,
    ACTIONS(9316), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9341), 1,
      sym_identifier,
    STATE(2361), 1,
      sym_template_type,
    STATE(2454), 1,
      sym_field_declaration_list,
    STATE(2605), 1,
      sym__class_declaration_item,
    STATE(2613), 1,
      sym__class_declaration,
    STATE(5889), 1,
      sym_ms_declspec_modifier,
    STATE(6846), 1,
      sym__scope_resolution,
    STATE(7226), 1,
      sym_virtual_specifier,
    STATE(8040), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2216), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5885), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5594), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [211872] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(5654), 1,
      anon_sym_LBRACE,
    ACTIONS(9316), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9341), 1,
      sym_identifier,
    STATE(2361), 1,
      sym_template_type,
    STATE(2454), 1,
      sym_field_declaration_list,
    STATE(2603), 1,
      sym__class_declaration,
    STATE(2605), 1,
      sym__class_declaration_item,
    STATE(5889), 1,
      sym_ms_declspec_modifier,
    STATE(6846), 1,
      sym__scope_resolution,
    STATE(7226), 1,
      sym_virtual_specifier,
    STATE(8040), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2216), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5885), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5594), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [211952] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(9112), 1,
      sym_identifier,
    ACTIONS(9114), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9118), 1,
      sym_primitive_type,
    ACTIONS(9120), 1,
      anon_sym_enum,
    ACTIONS(9122), 1,
      anon_sym_class,
    ACTIONS(9124), 1,
      anon_sym_struct,
    ACTIONS(9126), 1,
      anon_sym_union,
    ACTIONS(9128), 1,
      sym_auto,
    ACTIONS(9130), 1,
      anon_sym_decltype,
    ACTIONS(9132), 1,
      anon_sym_typename,
    STATE(2642), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3150), 1,
      sym_type_specifier,
    STATE(3264), 1,
      sym_qualified_type_identifier,
    STATE(3453), 1,
      sym_decltype_auto,
    STATE(6861), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(3102), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9116), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3449), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [212026] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7138), 1,
      sym_primitive_type,
    ACTIONS(9231), 1,
      sym_identifier,
    ACTIONS(9233), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9235), 1,
      anon_sym_enum,
    ACTIONS(9237), 1,
      anon_sym_class,
    ACTIONS(9239), 1,
      anon_sym_struct,
    ACTIONS(9241), 1,
      anon_sym_union,
    ACTIONS(9243), 1,
      anon_sym_typename,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4397), 1,
      sym_type_specifier,
    STATE(6864), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [212100] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9233), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9343), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(2064), 1,
      sym__class_declaration_item,
    STATE(2073), 1,
      sym__class_declaration,
    STATE(2233), 1,
      sym_field_declaration_list,
    STATE(5825), 1,
      sym_ms_declspec_modifier,
    STATE(6864), 1,
      sym__scope_resolution,
    STATE(7158), 1,
      sym_virtual_specifier,
    STATE(7915), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2149), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5840), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5628), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [212180] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9233), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9343), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(2046), 1,
      sym__class_declaration,
    STATE(2064), 1,
      sym__class_declaration_item,
    STATE(2233), 1,
      sym_field_declaration_list,
    STATE(5825), 1,
      sym_ms_declspec_modifier,
    STATE(6864), 1,
      sym__scope_resolution,
    STATE(7158), 1,
      sym_virtual_specifier,
    STATE(7915), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2149), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5840), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5628), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [212260] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6840), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9345), 1,
      anon_sym_requires,
    STATE(6362), 1,
      sym__function_attributes_end,
    STATE(6401), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9106), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5697), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9102), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [212330] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9233), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9343), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(2045), 1,
      sym__class_declaration,
    STATE(2064), 1,
      sym__class_declaration_item,
    STATE(2233), 1,
      sym_field_declaration_list,
    STATE(5825), 1,
      sym_ms_declspec_modifier,
    STATE(6864), 1,
      sym__scope_resolution,
    STATE(7158), 1,
      sym_virtual_specifier,
    STATE(7915), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2149), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5840), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5628), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [212410] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_AMP,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6199), 1,
      sym__declarator,
    STATE(7633), 1,
      sym_init_declarator,
    STATE(8511), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [212480] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(9270), 1,
      sym_identifier,
    ACTIONS(9272), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9276), 1,
      sym_primitive_type,
    ACTIONS(9278), 1,
      anon_sym_enum,
    ACTIONS(9280), 1,
      anon_sym_class,
    ACTIONS(9282), 1,
      anon_sym_struct,
    ACTIONS(9284), 1,
      anon_sym_union,
    ACTIONS(9286), 1,
      sym_auto,
    ACTIONS(9288), 1,
      anon_sym_decltype,
    ACTIONS(9290), 1,
      anon_sym_typename,
    STATE(4208), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4462), 1,
      sym_type_specifier,
    STATE(4755), 1,
      sym_decltype_auto,
    STATE(4984), 1,
      sym_qualified_type_identifier,
    STATE(6829), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(4628), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9274), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4756), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [212554] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(121), 1,
      sym_auto,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(3544), 1,
      sym_identifier,
    ACTIONS(3552), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3556), 1,
      sym_primitive_type,
    ACTIONS(3558), 1,
      anon_sym_enum,
    ACTIONS(3560), 1,
      anon_sym_class,
    ACTIONS(3562), 1,
      anon_sym_struct,
    ACTIONS(3564), 1,
      anon_sym_union,
    ACTIONS(3566), 1,
      anon_sym_typename,
    STATE(2160), 1,
      sym_type_specifier,
    STATE(2194), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(2507), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6810), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(2154), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(3554), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2200), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [212628] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(7431), 1,
      anon_sym_DASH_GT,
    ACTIONS(7433), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9057), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5649), 1,
      sym_ref_qualifier,
    STATE(6602), 1,
      sym__function_attributes_end,
    STATE(6700), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9013), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5735), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [212704] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_AMP,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6176), 1,
      sym__declarator,
    STATE(7635), 1,
      sym_init_declarator,
    STATE(8511), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [212774] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(9270), 1,
      sym_identifier,
    ACTIONS(9272), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9276), 1,
      sym_primitive_type,
    ACTIONS(9278), 1,
      anon_sym_enum,
    ACTIONS(9280), 1,
      anon_sym_class,
    ACTIONS(9282), 1,
      anon_sym_struct,
    ACTIONS(9284), 1,
      anon_sym_union,
    ACTIONS(9286), 1,
      sym_auto,
    ACTIONS(9288), 1,
      anon_sym_decltype,
    ACTIONS(9290), 1,
      anon_sym_typename,
    STATE(4208), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4474), 1,
      sym_type_specifier,
    STATE(4755), 1,
      sym_decltype_auto,
    STATE(4984), 1,
      sym_qualified_type_identifier,
    STATE(6829), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(4628), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9274), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4756), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [212848] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(9209), 1,
      sym_identifier,
    ACTIONS(9211), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9215), 1,
      sym_primitive_type,
    ACTIONS(9217), 1,
      anon_sym_enum,
    ACTIONS(9219), 1,
      anon_sym_class,
    ACTIONS(9221), 1,
      anon_sym_struct,
    ACTIONS(9223), 1,
      anon_sym_union,
    ACTIONS(9225), 1,
      sym_auto,
    ACTIONS(9227), 1,
      anon_sym_decltype,
    ACTIONS(9229), 1,
      anon_sym_typename,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(3828), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4136), 1,
      sym_type_specifier,
    STATE(4450), 1,
      sym_decltype_auto,
    STATE(6855), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(4333), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9213), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4452), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [212922] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6651), 1,
      anon_sym_STAR,
    ACTIONS(6653), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6655), 1,
      anon_sym_AMP,
    ACTIONS(6657), 1,
      anon_sym_COLON_COLON,
    STATE(6064), 1,
      sym__scope_resolution,
    STATE(6139), 1,
      sym__declarator,
    STATE(7633), 1,
      sym_init_declarator,
    STATE(8311), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [212992] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2197), 1,
      sym__class_declaration,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5818), 1,
      sym_ms_declspec_modifier,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2327), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5784), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5623), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [213072] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(9209), 1,
      sym_identifier,
    ACTIONS(9211), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9215), 1,
      sym_primitive_type,
    ACTIONS(9217), 1,
      anon_sym_enum,
    ACTIONS(9219), 1,
      anon_sym_class,
    ACTIONS(9221), 1,
      anon_sym_struct,
    ACTIONS(9223), 1,
      anon_sym_union,
    ACTIONS(9225), 1,
      sym_auto,
    ACTIONS(9227), 1,
      anon_sym_decltype,
    ACTIONS(9229), 1,
      anon_sym_typename,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(3828), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4150), 1,
      sym_type_specifier,
    STATE(4450), 1,
      sym_decltype_auto,
    STATE(6855), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(4333), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9213), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4452), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [213146] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2757), 1,
      sym_auto,
    ACTIONS(2759), 1,
      anon_sym_decltype,
    ACTIONS(7439), 1,
      sym_primitive_type,
    ACTIONS(9314), 1,
      sym_identifier,
    ACTIONS(9316), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9318), 1,
      anon_sym_enum,
    ACTIONS(9320), 1,
      anon_sym_class,
    ACTIONS(9322), 1,
      anon_sym_struct,
    ACTIONS(9324), 1,
      anon_sym_union,
    ACTIONS(9326), 1,
      anon_sym_typename,
    STATE(2157), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2557), 1,
      sym_qualified_type_identifier,
    STATE(2598), 1,
      sym_decltype_auto,
    STATE(4464), 1,
      sym_type_specifier,
    STATE(6846), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(2477), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2723), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2599), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [213220] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2191), 1,
      sym__class_declaration,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5818), 1,
      sym_ms_declspec_modifier,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2315), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5784), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5623), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [213300] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9348), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(2045), 1,
      sym__class_declaration,
    STATE(2064), 1,
      sym__class_declaration_item,
    STATE(2233), 1,
      sym_field_declaration_list,
    STATE(5827), 1,
      sym_ms_declspec_modifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(7158), 1,
      sym_virtual_specifier,
    STATE(7915), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2149), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5822), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5604), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [213380] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7138), 1,
      sym_primitive_type,
    ACTIONS(9231), 1,
      sym_identifier,
    ACTIONS(9233), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9235), 1,
      anon_sym_enum,
    ACTIONS(9237), 1,
      anon_sym_class,
    ACTIONS(9239), 1,
      anon_sym_struct,
    ACTIONS(9241), 1,
      anon_sym_union,
    ACTIONS(9243), 1,
      anon_sym_typename,
    STATE(1848), 1,
      sym_type_specifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(6864), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [213454] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(9134), 1,
      sym_identifier,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9140), 1,
      sym_primitive_type,
    ACTIONS(9142), 1,
      anon_sym_enum,
    ACTIONS(9144), 1,
      anon_sym_class,
    ACTIONS(9146), 1,
      anon_sym_struct,
    ACTIONS(9148), 1,
      anon_sym_union,
    ACTIONS(9150), 1,
      sym_auto,
    ACTIONS(9152), 1,
      anon_sym_decltype,
    ACTIONS(9154), 1,
      anon_sym_typename,
    STATE(2221), 1,
      sym_type_specifier,
    STATE(2367), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2390), 1,
      sym_decltype_auto,
    STATE(2412), 1,
      sym_qualified_type_identifier,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(2322), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9138), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2396), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [213528] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(9248), 1,
      sym_identifier,
    ACTIONS(9250), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9254), 1,
      sym_primitive_type,
    ACTIONS(9256), 1,
      anon_sym_enum,
    ACTIONS(9258), 1,
      anon_sym_class,
    ACTIONS(9260), 1,
      anon_sym_struct,
    ACTIONS(9262), 1,
      anon_sym_union,
    ACTIONS(9264), 1,
      sym_auto,
    ACTIONS(9266), 1,
      anon_sym_decltype,
    ACTIONS(9268), 1,
      anon_sym_typename,
    STATE(2771), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3570), 1,
      sym_type_specifier,
    STATE(3680), 1,
      sym_decltype_auto,
    STATE(3716), 1,
      sym_qualified_type_identifier,
    STATE(6853), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(3576), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9252), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3684), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [213602] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9348), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(2046), 1,
      sym__class_declaration,
    STATE(2064), 1,
      sym__class_declaration_item,
    STATE(2233), 1,
      sym_field_declaration_list,
    STATE(5827), 1,
      sym_ms_declspec_modifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(7158), 1,
      sym_virtual_specifier,
    STATE(7915), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2149), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5822), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5604), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [213682] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(5654), 1,
      anon_sym_LBRACE,
    ACTIONS(7437), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9350), 1,
      sym_identifier,
    STATE(2361), 1,
      sym_template_type,
    STATE(2454), 1,
      sym_field_declaration_list,
    STATE(2605), 1,
      sym__class_declaration_item,
    STATE(2614), 1,
      sym__class_declaration,
    STATE(5821), 1,
      sym_ms_declspec_modifier,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(7226), 1,
      sym_virtual_specifier,
    STATE(8040), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2216), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5826), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5585), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [213762] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(5654), 1,
      anon_sym_LBRACE,
    ACTIONS(7437), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9350), 1,
      sym_identifier,
    STATE(2361), 1,
      sym_template_type,
    STATE(2454), 1,
      sym_field_declaration_list,
    STATE(2605), 1,
      sym__class_declaration_item,
    STATE(2613), 1,
      sym__class_declaration,
    STATE(5821), 1,
      sym_ms_declspec_modifier,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(7226), 1,
      sym_virtual_specifier,
    STATE(8040), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2216), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5826), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5585), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [213842] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(5654), 1,
      anon_sym_LBRACE,
    ACTIONS(7437), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9350), 1,
      sym_identifier,
    STATE(2361), 1,
      sym_template_type,
    STATE(2454), 1,
      sym_field_declaration_list,
    STATE(2603), 1,
      sym__class_declaration,
    STATE(2605), 1,
      sym__class_declaration_item,
    STATE(5821), 1,
      sym_ms_declspec_modifier,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(7226), 1,
      sym_virtual_specifier,
    STATE(8040), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2216), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5826), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5585), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [213922] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9348), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(2064), 1,
      sym__class_declaration_item,
    STATE(2073), 1,
      sym__class_declaration,
    STATE(2233), 1,
      sym_field_declaration_list,
    STATE(5827), 1,
      sym_ms_declspec_modifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(7158), 1,
      sym_virtual_specifier,
    STATE(7915), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2149), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5822), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5604), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [214002] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2181), 1,
      sym__class_declaration,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5818), 1,
      sym_ms_declspec_modifier,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2333), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5784), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5623), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [214082] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2197), 1,
      sym__class_declaration,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5818), 1,
      sym_ms_declspec_modifier,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2333), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5784), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5623), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [214162] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2197), 1,
      sym__class_declaration,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5818), 1,
      sym_ms_declspec_modifier,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2161), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5784), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5623), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [214242] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2727), 1,
      anon_sym_enum,
    ACTIONS(2729), 1,
      anon_sym_class,
    ACTIONS(2731), 1,
      anon_sym_struct,
    ACTIONS(2733), 1,
      anon_sym_union,
    ACTIONS(2757), 1,
      sym_auto,
    ACTIONS(2759), 1,
      anon_sym_decltype,
    ACTIONS(2761), 1,
      anon_sym_typename,
    ACTIONS(7435), 1,
      sym_identifier,
    ACTIONS(7437), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7439), 1,
      sym_primitive_type,
    STATE(2157), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2506), 1,
      sym_type_specifier,
    STATE(2557), 1,
      sym_qualified_type_identifier,
    STATE(2598), 1,
      sym_decltype_auto,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(2477), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2723), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2599), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [214316] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9352), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2191), 1,
      sym__class_declaration,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5869), 1,
      sym_ms_declspec_modifier,
    STATE(6858), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2161), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5859), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5621), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [214396] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9352), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2181), 1,
      sym__class_declaration,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5869), 1,
      sym_ms_declspec_modifier,
    STATE(6858), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2161), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5859), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5621), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [214476] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9352), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2197), 1,
      sym__class_declaration,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5869), 1,
      sym_ms_declspec_modifier,
    STATE(6858), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2161), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5859), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5621), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [214556] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(9187), 1,
      sym_identifier,
    ACTIONS(9189), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9193), 1,
      sym_primitive_type,
    ACTIONS(9195), 1,
      anon_sym_enum,
    ACTIONS(9197), 1,
      anon_sym_class,
    ACTIONS(9199), 1,
      anon_sym_struct,
    ACTIONS(9201), 1,
      anon_sym_union,
    ACTIONS(9203), 1,
      sym_auto,
    ACTIONS(9205), 1,
      anon_sym_decltype,
    ACTIONS(9207), 1,
      anon_sym_typename,
    STATE(2590), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3038), 1,
      sym_type_specifier,
    STATE(3089), 1,
      sym_decltype_auto,
    STATE(3099), 1,
      sym_qualified_type_identifier,
    STATE(6836), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(3053), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9191), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3091), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [214630] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(121), 1,
      sym_auto,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(3556), 1,
      sym_primitive_type,
    ACTIONS(7509), 1,
      sym_identifier,
    ACTIONS(7511), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7513), 1,
      anon_sym_enum,
    ACTIONS(7515), 1,
      anon_sym_class,
    ACTIONS(7517), 1,
      anon_sym_struct,
    ACTIONS(7519), 1,
      anon_sym_union,
    ACTIONS(7521), 1,
      anon_sym_typename,
    STATE(2194), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(2507), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6827), 1,
      sym__scope_resolution,
    STATE(7038), 1,
      sym_type_specifier,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(2154), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(3554), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2200), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [214704] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(9292), 1,
      sym_identifier,
    ACTIONS(9294), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9298), 1,
      sym_primitive_type,
    ACTIONS(9300), 1,
      anon_sym_enum,
    ACTIONS(9302), 1,
      anon_sym_class,
    ACTIONS(9304), 1,
      anon_sym_struct,
    ACTIONS(9306), 1,
      anon_sym_union,
    ACTIONS(9308), 1,
      sym_auto,
    ACTIONS(9310), 1,
      anon_sym_decltype,
    ACTIONS(9312), 1,
      anon_sym_typename,
    STATE(2715), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2934), 1,
      sym_type_specifier,
    STATE(3319), 1,
      sym_decltype_auto,
    STATE(3443), 1,
      sym_qualified_type_identifier,
    STATE(6809), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(3147), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9296), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3318), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [214778] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6840), 1,
      anon_sym_DASH_GT,
    ACTIONS(6990), 1,
      anon_sym_requires,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    STATE(6376), 1,
      sym__function_attributes_end,
    STATE(6392), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5686), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9102), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [214848] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(9209), 1,
      sym_identifier,
    ACTIONS(9211), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9215), 1,
      sym_primitive_type,
    ACTIONS(9217), 1,
      anon_sym_enum,
    ACTIONS(9219), 1,
      anon_sym_class,
    ACTIONS(9221), 1,
      anon_sym_struct,
    ACTIONS(9223), 1,
      anon_sym_union,
    ACTIONS(9225), 1,
      sym_auto,
    ACTIONS(9227), 1,
      anon_sym_decltype,
    ACTIONS(9229), 1,
      anon_sym_typename,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(3828), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4330), 1,
      sym_type_specifier,
    STATE(4450), 1,
      sym_decltype_auto,
    STATE(6855), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(4333), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9213), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4452), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [214922] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(9292), 1,
      sym_identifier,
    ACTIONS(9294), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9298), 1,
      sym_primitive_type,
    ACTIONS(9300), 1,
      anon_sym_enum,
    ACTIONS(9302), 1,
      anon_sym_class,
    ACTIONS(9304), 1,
      anon_sym_struct,
    ACTIONS(9306), 1,
      anon_sym_union,
    ACTIONS(9308), 1,
      sym_auto,
    ACTIONS(9310), 1,
      anon_sym_decltype,
    ACTIONS(9312), 1,
      anon_sym_typename,
    STATE(2715), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2917), 1,
      sym_type_specifier,
    STATE(3319), 1,
      sym_decltype_auto,
    STATE(3443), 1,
      sym_qualified_type_identifier,
    STATE(6809), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(3147), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9296), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3318), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [214996] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(9248), 1,
      sym_identifier,
    ACTIONS(9250), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9254), 1,
      sym_primitive_type,
    ACTIONS(9256), 1,
      anon_sym_enum,
    ACTIONS(9258), 1,
      anon_sym_class,
    ACTIONS(9260), 1,
      anon_sym_struct,
    ACTIONS(9262), 1,
      anon_sym_union,
    ACTIONS(9264), 1,
      sym_auto,
    ACTIONS(9266), 1,
      anon_sym_decltype,
    ACTIONS(9268), 1,
      anon_sym_typename,
    STATE(2771), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3048), 1,
      sym_type_specifier,
    STATE(3680), 1,
      sym_decltype_auto,
    STATE(3716), 1,
      sym_qualified_type_identifier,
    STATE(6853), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(3576), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9252), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3684), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [215070] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(5654), 1,
      anon_sym_LBRACE,
    ACTIONS(9316), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9341), 1,
      sym_identifier,
    STATE(2361), 1,
      sym_template_type,
    STATE(2454), 1,
      sym_field_declaration_list,
    STATE(2605), 1,
      sym__class_declaration_item,
    STATE(2614), 1,
      sym__class_declaration,
    STATE(5889), 1,
      sym_ms_declspec_modifier,
    STATE(6846), 1,
      sym__scope_resolution,
    STATE(7226), 1,
      sym_virtual_specifier,
    STATE(8040), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2216), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5885), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5594), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [215150] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_AMP,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6266), 1,
      sym__declarator,
    STATE(8108), 1,
      sym_init_declarator,
    STATE(8511), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [215220] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6179), 1,
      anon_sym_LBRACE,
    ACTIONS(9189), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9354), 1,
      sym_identifier,
    STATE(2794), 1,
      sym_template_type,
    STATE(3006), 1,
      sym_field_declaration_list,
    STATE(3114), 1,
      sym__class_declaration_item,
    STATE(3119), 1,
      sym__class_declaration,
    STATE(5876), 1,
      sym_ms_declspec_modifier,
    STATE(6836), 1,
      sym__scope_resolution,
    STATE(7210), 1,
      sym_virtual_specifier,
    STATE(7996), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2548), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5842), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5611), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [215300] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2197), 1,
      sym__class_declaration,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5818), 1,
      sym_ms_declspec_modifier,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2331), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5784), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5623), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [215380] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2197), 1,
      sym__class_declaration,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5818), 1,
      sym_ms_declspec_modifier,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2310), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5784), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5623), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [215460] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2181), 1,
      sym__class_declaration,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5818), 1,
      sym_ms_declspec_modifier,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2331), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5784), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5623), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [215540] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2181), 1,
      sym__class_declaration,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5818), 1,
      sym_ms_declspec_modifier,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2310), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5784), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5623), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [215620] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      anon_sym_enum,
    ACTIONS(71), 1,
      anon_sym_class,
    ACTIONS(73), 1,
      anon_sym_struct,
    ACTIONS(75), 1,
      anon_sym_union,
    ACTIONS(121), 1,
      sym_auto,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(127), 1,
      anon_sym_typename,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2132), 1,
      sym_primitive_type,
    ACTIONS(4853), 1,
      sym_identifier,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    STATE(2160), 1,
      sym_type_specifier,
    STATE(2173), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2194), 1,
      sym_decltype_auto,
    STATE(2604), 1,
      sym_qualified_type_identifier,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(2154), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(55), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2200), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [215694] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(7186), 1,
      sym_primitive_type,
    ACTIONS(7196), 1,
      sym_auto,
    ACTIONS(7198), 1,
      anon_sym_decltype,
    ACTIONS(7356), 1,
      sym_identifier,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7360), 1,
      anon_sym_enum,
    ACTIONS(7362), 1,
      anon_sym_class,
    ACTIONS(7364), 1,
      anon_sym_struct,
    ACTIONS(7366), 1,
      anon_sym_union,
    ACTIONS(7368), 1,
      anon_sym_typename,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(4292), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4678), 1,
      sym_type_specifier,
    STATE(4799), 1,
      sym_decltype_auto,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(2154), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7184), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4932), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [215768] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9144), 1,
      anon_sym_class,
    ACTIONS(9146), 1,
      anon_sym_struct,
    ACTIONS(9148), 1,
      anon_sym_union,
    ACTIONS(9150), 1,
      sym_auto,
    ACTIONS(9152), 1,
      anon_sym_decltype,
    ACTIONS(9165), 1,
      sym_identifier,
    ACTIONS(9169), 1,
      sym_primitive_type,
    ACTIONS(9171), 1,
      anon_sym_enum,
    ACTIONS(9173), 1,
      anon_sym_typename,
    STATE(2221), 1,
      sym_type_specifier,
    STATE(2324), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2390), 1,
      sym_decltype_auto,
    STATE(2412), 1,
      sym_qualified_type_identifier,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(2322), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9167), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2396), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [215842] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9144), 1,
      anon_sym_class,
    ACTIONS(9146), 1,
      anon_sym_struct,
    ACTIONS(9148), 1,
      anon_sym_union,
    ACTIONS(9150), 1,
      sym_auto,
    ACTIONS(9152), 1,
      anon_sym_decltype,
    ACTIONS(9165), 1,
      sym_identifier,
    ACTIONS(9169), 1,
      sym_primitive_type,
    ACTIONS(9171), 1,
      anon_sym_enum,
    ACTIONS(9173), 1,
      anon_sym_typename,
    STATE(2215), 1,
      sym_type_specifier,
    STATE(2324), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2390), 1,
      sym_decltype_auto,
    STATE(2412), 1,
      sym_qualified_type_identifier,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(2322), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9167), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2396), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [215916] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2191), 1,
      sym__class_declaration,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5818), 1,
      sym_ms_declspec_modifier,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2310), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5784), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5623), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [215996] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(121), 1,
      sym_auto,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(3556), 1,
      sym_primitive_type,
    ACTIONS(7509), 1,
      sym_identifier,
    ACTIONS(7511), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7513), 1,
      anon_sym_enum,
    ACTIONS(7515), 1,
      anon_sym_class,
    ACTIONS(7517), 1,
      anon_sym_struct,
    ACTIONS(7519), 1,
      anon_sym_union,
    ACTIONS(7521), 1,
      anon_sym_typename,
    STATE(2194), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(2507), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6827), 1,
      sym__scope_resolution,
    STATE(7040), 1,
      sym_type_specifier,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(2154), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(3554), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2200), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [216070] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(7431), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9057), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9356), 1,
      anon_sym_requires,
    STATE(5642), 1,
      sym_ref_qualifier,
    STATE(6591), 1,
      sym__function_attributes_end,
    STATE(6738), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9013), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5752), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [216146] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(9248), 1,
      sym_identifier,
    ACTIONS(9250), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9254), 1,
      sym_primitive_type,
    ACTIONS(9256), 1,
      anon_sym_enum,
    ACTIONS(9258), 1,
      anon_sym_class,
    ACTIONS(9260), 1,
      anon_sym_struct,
    ACTIONS(9262), 1,
      anon_sym_union,
    ACTIONS(9264), 1,
      sym_auto,
    ACTIONS(9266), 1,
      anon_sym_decltype,
    ACTIONS(9268), 1,
      anon_sym_typename,
    STATE(2771), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3022), 1,
      sym_type_specifier,
    STATE(3680), 1,
      sym_decltype_auto,
    STATE(3716), 1,
      sym_qualified_type_identifier,
    STATE(6853), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(3576), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9252), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3684), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [216220] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2181), 1,
      sym__class_declaration,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5818), 1,
      sym_ms_declspec_modifier,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2327), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5784), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5623), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [216300] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(9187), 1,
      sym_identifier,
    ACTIONS(9189), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9193), 1,
      sym_primitive_type,
    ACTIONS(9195), 1,
      anon_sym_enum,
    ACTIONS(9197), 1,
      anon_sym_class,
    ACTIONS(9199), 1,
      anon_sym_struct,
    ACTIONS(9201), 1,
      anon_sym_union,
    ACTIONS(9203), 1,
      sym_auto,
    ACTIONS(9205), 1,
      anon_sym_decltype,
    ACTIONS(9207), 1,
      anon_sym_typename,
    STATE(2590), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2846), 1,
      sym_type_specifier,
    STATE(3089), 1,
      sym_decltype_auto,
    STATE(3099), 1,
      sym_qualified_type_identifier,
    STATE(6836), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(3053), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9191), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3091), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [216374] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6990), 1,
      anon_sym_requires,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    STATE(5641), 1,
      sym_ref_qualifier,
    STATE(6500), 1,
      sym_trailing_return_type,
    STATE(6619), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9013), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5716), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [216450] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8202), 1,
      anon_sym_LBRACE,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(4731), 1,
      sym_field_declaration_list,
    STATE(4762), 1,
      sym__class_declaration_item,
    STATE(4820), 1,
      sym__class_declaration,
    STATE(5877), 1,
      sym_ms_declspec_modifier,
    STATE(6845), 1,
      sym__scope_resolution,
    STATE(7094), 1,
      sym_virtual_specifier,
    STATE(7830), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4467), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5878), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5586), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [216530] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6179), 1,
      anon_sym_LBRACE,
    ACTIONS(9189), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9354), 1,
      sym_identifier,
    STATE(2794), 1,
      sym_template_type,
    STATE(3006), 1,
      sym_field_declaration_list,
    STATE(3114), 1,
      sym__class_declaration_item,
    STATE(3116), 1,
      sym__class_declaration,
    STATE(5876), 1,
      sym_ms_declspec_modifier,
    STATE(6836), 1,
      sym__scope_resolution,
    STATE(7210), 1,
      sym_virtual_specifier,
    STATE(7996), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2548), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5842), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5611), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [216610] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(121), 1,
      sym_auto,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2132), 1,
      sym_primitive_type,
    ACTIONS(2134), 1,
      anon_sym_enum,
    ACTIONS(2136), 1,
      anon_sym_class,
    ACTIONS(2138), 1,
      anon_sym_struct,
    ACTIONS(2140), 1,
      anon_sym_union,
    ACTIONS(2142), 1,
      anon_sym_typename,
    ACTIONS(4853), 1,
      sym_identifier,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    STATE(2160), 1,
      sym_type_specifier,
    STATE(2173), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2194), 1,
      sym_decltype_auto,
    STATE(2604), 1,
      sym_qualified_type_identifier,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(2154), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(55), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2200), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [216684] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6977), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9328), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9361), 1,
      anon_sym_requires,
    STATE(6253), 1,
      sym__function_attributes_end,
    STATE(6423), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9181), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5685), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9102), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [216754] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2191), 1,
      sym__class_declaration,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5818), 1,
      sym_ms_declspec_modifier,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2331), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5784), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5623), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [216834] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    ACTIONS(9364), 1,
      anon_sym_COLON_COLON,
    STATE(2113), 1,
      sym_template_type,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2191), 1,
      sym__class_declaration,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5871), 1,
      sym_ms_declspec_modifier,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3013), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5874), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5616), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [216914] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    ACTIONS(9364), 1,
      anon_sym_COLON_COLON,
    STATE(2113), 1,
      sym_template_type,
    STATE(2181), 1,
      sym__class_declaration,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5871), 1,
      sym_ms_declspec_modifier,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3013), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5874), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5616), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [216994] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    ACTIONS(9364), 1,
      anon_sym_COLON_COLON,
    STATE(2113), 1,
      sym_template_type,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2197), 1,
      sym__class_declaration,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5871), 1,
      sym_ms_declspec_modifier,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3013), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5874), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5616), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [217074] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2181), 1,
      sym__class_declaration,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5818), 1,
      sym_ms_declspec_modifier,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2161), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5784), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5623), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [217154] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6179), 1,
      anon_sym_LBRACE,
    ACTIONS(9189), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9354), 1,
      sym_identifier,
    STATE(2794), 1,
      sym_template_type,
    STATE(3006), 1,
      sym_field_declaration_list,
    STATE(3111), 1,
      sym__class_declaration,
    STATE(3114), 1,
      sym__class_declaration_item,
    STATE(5876), 1,
      sym_ms_declspec_modifier,
    STATE(6836), 1,
      sym__scope_resolution,
    STATE(7210), 1,
      sym_virtual_specifier,
    STATE(7996), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2548), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5842), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5611), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [217234] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_AMP,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6192), 1,
      sym__declarator,
    STATE(7506), 1,
      sym_init_declarator,
    STATE(8511), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [217304] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8202), 1,
      anon_sym_LBRACE,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(4731), 1,
      sym_field_declaration_list,
    STATE(4762), 1,
      sym__class_declaration_item,
    STATE(4772), 1,
      sym__class_declaration,
    STATE(5877), 1,
      sym_ms_declspec_modifier,
    STATE(6845), 1,
      sym__scope_resolution,
    STATE(7094), 1,
      sym_virtual_specifier,
    STATE(7830), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4467), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5878), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5586), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [217384] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8202), 1,
      anon_sym_LBRACE,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(4731), 1,
      sym_field_declaration_list,
    STATE(4744), 1,
      sym__class_declaration,
    STATE(4762), 1,
      sym__class_declaration_item,
    STATE(5877), 1,
      sym_ms_declspec_modifier,
    STATE(6845), 1,
      sym__scope_resolution,
    STATE(7094), 1,
      sym_virtual_specifier,
    STATE(7830), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4467), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5878), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5586), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [217464] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7651), 1,
      anon_sym_LBRACE,
    ACTIONS(9211), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9366), 1,
      sym_identifier,
    STATE(4104), 1,
      sym_template_type,
    STATE(4278), 1,
      sym_field_declaration_list,
    STATE(4411), 1,
      sym__class_declaration,
    STATE(4451), 1,
      sym__class_declaration_item,
    STATE(5864), 1,
      sym_ms_declspec_modifier,
    STATE(6855), 1,
      sym__scope_resolution,
    STATE(7207), 1,
      sym_virtual_specifier,
    STATE(7935), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3584), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5861), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5606), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [217544] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9368), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(2045), 1,
      sym__class_declaration,
    STATE(2064), 1,
      sym__class_declaration_item,
    STATE(5352), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(7193), 1,
      sym_virtual_specifier,
    STATE(7946), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4582), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5830), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5622), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [217624] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9368), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(2046), 1,
      sym__class_declaration,
    STATE(2064), 1,
      sym__class_declaration_item,
    STATE(5352), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(7193), 1,
      sym_virtual_specifier,
    STATE(7946), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4582), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5830), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5622), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [217704] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9368), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(2064), 1,
      sym__class_declaration_item,
    STATE(2073), 1,
      sym__class_declaration,
    STATE(5352), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(7193), 1,
      sym_virtual_specifier,
    STATE(7946), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4582), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5830), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5622), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [217784] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7138), 1,
      sym_primitive_type,
    ACTIONS(9231), 1,
      sym_identifier,
    ACTIONS(9233), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9235), 1,
      anon_sym_enum,
    ACTIONS(9237), 1,
      anon_sym_class,
    ACTIONS(9239), 1,
      anon_sym_struct,
    ACTIONS(9241), 1,
      anon_sym_union,
    ACTIONS(9243), 1,
      anon_sym_typename,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4377), 1,
      sym_type_specifier,
    STATE(6864), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [217858] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2191), 1,
      sym__class_declaration,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5818), 1,
      sym_ms_declspec_modifier,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2333), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5784), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5623), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [217938] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(9134), 1,
      sym_identifier,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9140), 1,
      sym_primitive_type,
    ACTIONS(9142), 1,
      anon_sym_enum,
    ACTIONS(9144), 1,
      anon_sym_class,
    ACTIONS(9146), 1,
      anon_sym_struct,
    ACTIONS(9148), 1,
      anon_sym_union,
    ACTIONS(9150), 1,
      sym_auto,
    ACTIONS(9152), 1,
      anon_sym_decltype,
    ACTIONS(9154), 1,
      anon_sym_typename,
    STATE(2345), 1,
      sym_type_specifier,
    STATE(2367), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2390), 1,
      sym_decltype_auto,
    STATE(2412), 1,
      sym_qualified_type_identifier,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(2322), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9138), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2396), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [218012] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(7402), 1,
      sym_identifier,
    ACTIONS(7404), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7408), 1,
      sym_primitive_type,
    ACTIONS(7410), 1,
      anon_sym_enum,
    ACTIONS(7412), 1,
      anon_sym_class,
    ACTIONS(7414), 1,
      anon_sym_struct,
    ACTIONS(7416), 1,
      anon_sym_union,
    ACTIONS(7418), 1,
      sym_auto,
    ACTIONS(7420), 1,
      anon_sym_decltype,
    ACTIONS(7422), 1,
      anon_sym_typename,
    STATE(4392), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5159), 1,
      sym_type_specifier,
    STATE(5173), 1,
      sym_qualified_type_identifier,
    STATE(5240), 1,
      sym_decltype_auto,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(5166), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7406), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5243), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [218086] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2191), 1,
      sym__class_declaration,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5818), 1,
      sym_ms_declspec_modifier,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2327), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5784), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5623), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [218166] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2757), 1,
      sym_auto,
    ACTIONS(2759), 1,
      anon_sym_decltype,
    ACTIONS(7439), 1,
      sym_primitive_type,
    ACTIONS(9314), 1,
      sym_identifier,
    ACTIONS(9316), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9318), 1,
      anon_sym_enum,
    ACTIONS(9320), 1,
      anon_sym_class,
    ACTIONS(9322), 1,
      anon_sym_struct,
    ACTIONS(9324), 1,
      anon_sym_union,
    ACTIONS(9326), 1,
      anon_sym_typename,
    STATE(2157), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2557), 1,
      sym_qualified_type_identifier,
    STATE(2598), 1,
      sym_decltype_auto,
    STATE(4475), 1,
      sym_type_specifier,
    STATE(6846), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(2477), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2723), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2599), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [218240] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7138), 1,
      sym_primitive_type,
    ACTIONS(9231), 1,
      sym_identifier,
    ACTIONS(9233), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9235), 1,
      anon_sym_enum,
    ACTIONS(9237), 1,
      anon_sym_class,
    ACTIONS(9239), 1,
      anon_sym_struct,
    ACTIONS(9241), 1,
      anon_sym_union,
    ACTIONS(9243), 1,
      anon_sym_typename,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4277), 1,
      sym_type_specifier,
    STATE(6864), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [218314] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(121), 1,
      sym_auto,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1771), 1,
      anon_sym_enum,
    ACTIONS(1773), 1,
      anon_sym_class,
    ACTIONS(1775), 1,
      anon_sym_struct,
    ACTIONS(1777), 1,
      anon_sym_union,
    ACTIONS(1801), 1,
      anon_sym_typename,
    ACTIONS(2132), 1,
      sym_primitive_type,
    ACTIONS(4244), 1,
      sym_identifier,
    ACTIONS(4254), 1,
      anon_sym_COLON_COLON,
    STATE(2160), 1,
      sym_type_specifier,
    STATE(2173), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2194), 1,
      sym_decltype_auto,
    STATE(2604), 1,
      sym_qualified_type_identifier,
    STATE(6858), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(2154), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(55), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2200), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [218388] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6623), 1,
      anon_sym_AMP,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9099), 1,
      anon_sym_requires,
    STATE(5645), 1,
      sym_ref_qualifier,
    STATE(6412), 1,
      sym_trailing_return_type,
    STATE(6652), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9013), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9017), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5770), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [218464] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6603), 1,
      anon_sym_LBRACE,
    ACTIONS(9250), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9370), 1,
      sym_identifier,
    STATE(2986), 1,
      sym_template_type,
    STATE(3282), 1,
      sym_field_declaration_list,
    STATE(3720), 1,
      sym__class_declaration,
    STATE(3735), 1,
      sym__class_declaration_item,
    STATE(5793), 1,
      sym_ms_declspec_modifier,
    STATE(6853), 1,
      sym__scope_resolution,
    STATE(7358), 1,
      sym_virtual_specifier,
    STATE(8063), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2781), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5796), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5596), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [218544] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6603), 1,
      anon_sym_LBRACE,
    ACTIONS(9250), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9370), 1,
      sym_identifier,
    STATE(2986), 1,
      sym_template_type,
    STATE(3282), 1,
      sym_field_declaration_list,
    STATE(3735), 1,
      sym__class_declaration_item,
    STATE(3738), 1,
      sym__class_declaration,
    STATE(5793), 1,
      sym_ms_declspec_modifier,
    STATE(6853), 1,
      sym__scope_resolution,
    STATE(7358), 1,
      sym_virtual_specifier,
    STATE(8063), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2781), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5796), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5596), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [218624] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(9270), 1,
      sym_identifier,
    ACTIONS(9272), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9276), 1,
      sym_primitive_type,
    ACTIONS(9278), 1,
      anon_sym_enum,
    ACTIONS(9280), 1,
      anon_sym_class,
    ACTIONS(9282), 1,
      anon_sym_struct,
    ACTIONS(9284), 1,
      anon_sym_union,
    ACTIONS(9286), 1,
      sym_auto,
    ACTIONS(9288), 1,
      anon_sym_decltype,
    ACTIONS(9290), 1,
      anon_sym_typename,
    STATE(4208), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4699), 1,
      sym_type_specifier,
    STATE(4755), 1,
      sym_decltype_auto,
    STATE(4984), 1,
      sym_qualified_type_identifier,
    STATE(6829), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(4628), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9274), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4756), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [218698] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6603), 1,
      anon_sym_LBRACE,
    ACTIONS(9250), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9370), 1,
      sym_identifier,
    STATE(2986), 1,
      sym_template_type,
    STATE(3282), 1,
      sym_field_declaration_list,
    STATE(3735), 1,
      sym__class_declaration_item,
    STATE(3740), 1,
      sym__class_declaration,
    STATE(5793), 1,
      sym_ms_declspec_modifier,
    STATE(6853), 1,
      sym__scope_resolution,
    STATE(7358), 1,
      sym_virtual_specifier,
    STATE(8063), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2781), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5796), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5596), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [218778] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6977), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9074), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9096), 1,
      anon_sym_requires,
    STATE(6226), 1,
      sym__function_attributes_end,
    STATE(6422), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5692), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [218848] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2757), 1,
      sym_auto,
    ACTIONS(2759), 1,
      anon_sym_decltype,
    ACTIONS(7439), 1,
      sym_primitive_type,
    ACTIONS(9314), 1,
      sym_identifier,
    ACTIONS(9316), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9318), 1,
      anon_sym_enum,
    ACTIONS(9320), 1,
      anon_sym_class,
    ACTIONS(9322), 1,
      anon_sym_struct,
    ACTIONS(9324), 1,
      anon_sym_union,
    ACTIONS(9326), 1,
      anon_sym_typename,
    STATE(2157), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2506), 1,
      sym_type_specifier,
    STATE(2557), 1,
      sym_qualified_type_identifier,
    STATE(2598), 1,
      sym_decltype_auto,
    STATE(6846), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(2477), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2723), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2599), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [218922] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9144), 1,
      anon_sym_class,
    ACTIONS(9146), 1,
      anon_sym_struct,
    ACTIONS(9148), 1,
      anon_sym_union,
    ACTIONS(9150), 1,
      sym_auto,
    ACTIONS(9152), 1,
      anon_sym_decltype,
    ACTIONS(9165), 1,
      sym_identifier,
    ACTIONS(9169), 1,
      sym_primitive_type,
    ACTIONS(9171), 1,
      anon_sym_enum,
    ACTIONS(9173), 1,
      anon_sym_typename,
    STATE(2324), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2345), 1,
      sym_type_specifier,
    STATE(2390), 1,
      sym_decltype_auto,
    STATE(2412), 1,
      sym_qualified_type_identifier,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(2322), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9167), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2396), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [218996] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(121), 1,
      sym_auto,
    ACTIONS(123), 1,
      anon_sym_decltype,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(3556), 1,
      sym_primitive_type,
    ACTIONS(7509), 1,
      sym_identifier,
    ACTIONS(7511), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7513), 1,
      anon_sym_enum,
    ACTIONS(7515), 1,
      anon_sym_class,
    ACTIONS(7517), 1,
      anon_sym_struct,
    ACTIONS(7519), 1,
      anon_sym_union,
    ACTIONS(7521), 1,
      anon_sym_typename,
    STATE(2160), 1,
      sym_type_specifier,
    STATE(2194), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(2507), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6827), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(2154), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(3554), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2200), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [219070] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7651), 1,
      anon_sym_LBRACE,
    ACTIONS(9211), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9366), 1,
      sym_identifier,
    STATE(4104), 1,
      sym_template_type,
    STATE(4278), 1,
      sym_field_declaration_list,
    STATE(4396), 1,
      sym__class_declaration,
    STATE(4451), 1,
      sym__class_declaration_item,
    STATE(5864), 1,
      sym_ms_declspec_modifier,
    STATE(6855), 1,
      sym__scope_resolution,
    STATE(7207), 1,
      sym_virtual_specifier,
    STATE(7935), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3584), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5861), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5606), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [219150] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7651), 1,
      anon_sym_LBRACE,
    ACTIONS(9211), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9366), 1,
      sym_identifier,
    STATE(4104), 1,
      sym_template_type,
    STATE(4278), 1,
      sym_field_declaration_list,
    STATE(4441), 1,
      sym__class_declaration,
    STATE(4451), 1,
      sym__class_declaration_item,
    STATE(5864), 1,
      sym_ms_declspec_modifier,
    STATE(6855), 1,
      sym__scope_resolution,
    STATE(7207), 1,
      sym_virtual_specifier,
    STATE(7935), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3584), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5861), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5606), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [219230] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_AMP,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6198), 1,
      sym__declarator,
    STATE(7644), 1,
      sym_init_declarator,
    STATE(8511), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [219300] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2197), 1,
      sym__class_declaration,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5818), 1,
      sym_ms_declspec_modifier,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2356), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5784), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5623), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [219380] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2181), 1,
      sym__class_declaration,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5818), 1,
      sym_ms_declspec_modifier,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2356), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5784), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5623), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [219460] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6275), 1,
      anon_sym_LBRACE,
    ACTIONS(9294), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9372), 1,
      sym_identifier,
    STATE(2848), 1,
      sym_template_type,
    STATE(3045), 1,
      sym_field_declaration_list,
    STATE(3310), 1,
      sym__class_declaration,
    STATE(3312), 1,
      sym__class_declaration_item,
    STATE(5783), 1,
      sym_ms_declspec_modifier,
    STATE(6809), 1,
      sym__scope_resolution,
    STATE(7262), 1,
      sym_virtual_specifier,
    STATE(8011), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2630), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5836), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5591), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [219540] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8202), 1,
      anon_sym_LBRACE,
    ACTIONS(9374), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(4731), 1,
      sym_field_declaration_list,
    STATE(4744), 1,
      sym__class_declaration,
    STATE(4762), 1,
      sym__class_declaration_item,
    STATE(5788), 1,
      sym_ms_declspec_modifier,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(7094), 1,
      sym_virtual_specifier,
    STATE(7830), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4467), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5789), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5579), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [219620] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2197), 1,
      sym__class_declaration,
    STATE(2890), 1,
      sym_field_declaration_list,
    STATE(5866), 1,
      sym_ms_declspec_modifier,
    STATE(6845), 1,
      sym__scope_resolution,
    STATE(7347), 1,
      sym_virtual_specifier,
    STATE(8099), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2645), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5860), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5582), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [219700] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2191), 1,
      sym__class_declaration,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5818), 1,
      sym_ms_declspec_modifier,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2356), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5784), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5623), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [219780] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8202), 1,
      anon_sym_LBRACE,
    ACTIONS(9374), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(4731), 1,
      sym_field_declaration_list,
    STATE(4762), 1,
      sym__class_declaration_item,
    STATE(4772), 1,
      sym__class_declaration,
    STATE(5788), 1,
      sym_ms_declspec_modifier,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(7094), 1,
      sym_virtual_specifier,
    STATE(7830), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4467), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5789), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5579), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [219860] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(9112), 1,
      sym_identifier,
    ACTIONS(9114), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9118), 1,
      sym_primitive_type,
    ACTIONS(9120), 1,
      anon_sym_enum,
    ACTIONS(9122), 1,
      anon_sym_class,
    ACTIONS(9124), 1,
      anon_sym_struct,
    ACTIONS(9126), 1,
      anon_sym_union,
    ACTIONS(9128), 1,
      sym_auto,
    ACTIONS(9130), 1,
      anon_sym_decltype,
    ACTIONS(9132), 1,
      anon_sym_typename,
    STATE(2642), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2900), 1,
      sym_type_specifier,
    STATE(3264), 1,
      sym_qualified_type_identifier,
    STATE(3453), 1,
      sym_decltype_auto,
    STATE(6861), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(3102), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9116), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3449), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [219934] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8202), 1,
      anon_sym_LBRACE,
    ACTIONS(9374), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(4731), 1,
      sym_field_declaration_list,
    STATE(4762), 1,
      sym__class_declaration_item,
    STATE(4820), 1,
      sym__class_declaration,
    STATE(5788), 1,
      sym_ms_declspec_modifier,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(7094), 1,
      sym_virtual_specifier,
    STATE(7830), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4467), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5789), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5579), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [220014] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6275), 1,
      anon_sym_LBRACE,
    ACTIONS(9294), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9372), 1,
      sym_identifier,
    STATE(2848), 1,
      sym_template_type,
    STATE(3045), 1,
      sym_field_declaration_list,
    STATE(3311), 1,
      sym__class_declaration,
    STATE(3312), 1,
      sym__class_declaration_item,
    STATE(5783), 1,
      sym_ms_declspec_modifier,
    STATE(6809), 1,
      sym__scope_resolution,
    STATE(7262), 1,
      sym_virtual_specifier,
    STATE(8011), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2630), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5836), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5591), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [220094] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2181), 1,
      sym__class_declaration,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2890), 1,
      sym_field_declaration_list,
    STATE(5866), 1,
      sym_ms_declspec_modifier,
    STATE(6845), 1,
      sym__scope_resolution,
    STATE(7347), 1,
      sym_virtual_specifier,
    STATE(8099), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2645), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5860), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5582), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [220174] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2191), 1,
      sym__class_declaration,
    STATE(2890), 1,
      sym_field_declaration_list,
    STATE(5866), 1,
      sym_ms_declspec_modifier,
    STATE(6845), 1,
      sym__scope_resolution,
    STATE(7347), 1,
      sym_virtual_specifier,
    STATE(8099), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2645), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5860), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5582), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [220254] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2191), 1,
      sym__class_declaration,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5818), 1,
      sym_ms_declspec_modifier,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2314), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5784), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5623), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [220334] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6977), 1,
      anon_sym_DASH_GT,
    ACTIONS(6979), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9074), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6270), 1,
      sym__function_attributes_end,
    STATE(6415), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5684), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [220404] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(9187), 1,
      sym_identifier,
    ACTIONS(9189), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9193), 1,
      sym_primitive_type,
    ACTIONS(9195), 1,
      anon_sym_enum,
    ACTIONS(9197), 1,
      anon_sym_class,
    ACTIONS(9199), 1,
      anon_sym_struct,
    ACTIONS(9201), 1,
      anon_sym_union,
    ACTIONS(9203), 1,
      sym_auto,
    ACTIONS(9205), 1,
      anon_sym_decltype,
    ACTIONS(9207), 1,
      anon_sym_typename,
    STATE(2590), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2885), 1,
      sym_type_specifier,
    STATE(3089), 1,
      sym_decltype_auto,
    STATE(3099), 1,
      sym_qualified_type_identifier,
    STATE(6836), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(3053), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9191), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3091), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [220478] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(9134), 1,
      sym_identifier,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9140), 1,
      sym_primitive_type,
    ACTIONS(9142), 1,
      anon_sym_enum,
    ACTIONS(9144), 1,
      anon_sym_class,
    ACTIONS(9146), 1,
      anon_sym_struct,
    ACTIONS(9148), 1,
      anon_sym_union,
    ACTIONS(9150), 1,
      sym_auto,
    ACTIONS(9152), 1,
      anon_sym_decltype,
    ACTIONS(9154), 1,
      anon_sym_typename,
    STATE(2215), 1,
      sym_type_specifier,
    STATE(2367), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2390), 1,
      sym_decltype_auto,
    STATE(2412), 1,
      sym_qualified_type_identifier,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(2322), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9138), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2396), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [220552] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(9112), 1,
      sym_identifier,
    ACTIONS(9114), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9118), 1,
      sym_primitive_type,
    ACTIONS(9120), 1,
      anon_sym_enum,
    ACTIONS(9122), 1,
      anon_sym_class,
    ACTIONS(9124), 1,
      anon_sym_struct,
    ACTIONS(9126), 1,
      anon_sym_union,
    ACTIONS(9128), 1,
      sym_auto,
    ACTIONS(9130), 1,
      anon_sym_decltype,
    ACTIONS(9132), 1,
      anon_sym_typename,
    STATE(2642), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2910), 1,
      sym_type_specifier,
    STATE(3264), 1,
      sym_qualified_type_identifier,
    STATE(3453), 1,
      sym_decltype_auto,
    STATE(6861), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(3102), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9116), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3449), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [220626] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6275), 1,
      anon_sym_LBRACE,
    ACTIONS(9294), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9372), 1,
      sym_identifier,
    STATE(2848), 1,
      sym_template_type,
    STATE(3045), 1,
      sym_field_declaration_list,
    STATE(3312), 1,
      sym__class_declaration_item,
    STATE(3313), 1,
      sym__class_declaration,
    STATE(5783), 1,
      sym_ms_declspec_modifier,
    STATE(6809), 1,
      sym__scope_resolution,
    STATE(7262), 1,
      sym_virtual_specifier,
    STATE(8011), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2630), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5836), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5591), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [220706] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7404), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8224), 1,
      anon_sym_LBRACE,
    ACTIONS(9376), 1,
      sym_identifier,
    STATE(4532), 1,
      sym_template_type,
    STATE(5098), 1,
      sym_field_declaration_list,
    STATE(5262), 1,
      sym__class_declaration_item,
    STATE(5267), 1,
      sym__class_declaration,
    STATE(5819), 1,
      sym_ms_declspec_modifier,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(7309), 1,
      sym_virtual_specifier,
    STATE(8090), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4500), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5817), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5601), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [220786] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2181), 1,
      sym__class_declaration,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5818), 1,
      sym_ms_declspec_modifier,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2314), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5784), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5623), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [220866] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7404), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8224), 1,
      anon_sym_LBRACE,
    ACTIONS(9376), 1,
      sym_identifier,
    STATE(4532), 1,
      sym_template_type,
    STATE(5098), 1,
      sym_field_declaration_list,
    STATE(5262), 1,
      sym__class_declaration_item,
    STATE(5265), 1,
      sym__class_declaration,
    STATE(5819), 1,
      sym_ms_declspec_modifier,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(7309), 1,
      sym_virtual_specifier,
    STATE(8090), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4500), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5817), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5601), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [220946] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1847), 1,
      anon_sym_enum,
    ACTIONS(1849), 1,
      anon_sym_class,
    ACTIONS(1851), 1,
      anon_sym_struct,
    ACTIONS(1853), 1,
      anon_sym_union,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(1881), 1,
      anon_sym_typename,
    ACTIONS(7132), 1,
      sym_identifier,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7138), 1,
      sym_primitive_type,
    STATE(1848), 1,
      sym_type_specifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [221020] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7284), 1,
      sym_identifier,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7290), 1,
      sym_primitive_type,
    ACTIONS(7292), 1,
      anon_sym_enum,
    ACTIONS(7294), 1,
      anon_sym_class,
    ACTIONS(7296), 1,
      anon_sym_struct,
    ACTIONS(7298), 1,
      anon_sym_union,
    ACTIONS(7300), 1,
      anon_sym_typename,
    STATE(1848), 1,
      sym_type_specifier,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(5342), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7288), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [221094] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(8013), 1,
      anon_sym_LBRACE,
    ACTIONS(9272), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9337), 1,
      sym_identifier,
    STATE(4418), 1,
      sym_template_type,
    STATE(4537), 1,
      sym_field_declaration_list,
    STATE(4773), 1,
      sym__class_declaration,
    STATE(4774), 1,
      sym__class_declaration_item,
    STATE(5845), 1,
      sym_ms_declspec_modifier,
    STATE(6829), 1,
      sym__scope_resolution,
    STATE(7261), 1,
      sym_virtual_specifier,
    STATE(8010), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4250), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5850), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5614), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [221174] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6840), 1,
      anon_sym_DASH_GT,
    ACTIONS(6990), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    STATE(6337), 1,
      sym__function_attributes_end,
    STATE(6500), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5682), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [221244] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(7180), 1,
      sym_identifier,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7186), 1,
      sym_primitive_type,
    ACTIONS(7188), 1,
      anon_sym_enum,
    ACTIONS(7190), 1,
      anon_sym_class,
    ACTIONS(7192), 1,
      anon_sym_struct,
    ACTIONS(7194), 1,
      anon_sym_union,
    ACTIONS(7196), 1,
      sym_auto,
    ACTIONS(7198), 1,
      anon_sym_decltype,
    ACTIONS(7200), 1,
      anon_sym_typename,
    STATE(2441), 1,
      sym_qualified_type_identifier,
    STATE(4292), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4678), 1,
      sym_type_specifier,
    STATE(4799), 1,
      sym_decltype_auto,
    STATE(6845), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(2154), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7184), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4932), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [221318] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(8013), 1,
      anon_sym_LBRACE,
    ACTIONS(9272), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9337), 1,
      sym_identifier,
    STATE(4418), 1,
      sym_template_type,
    STATE(4537), 1,
      sym_field_declaration_list,
    STATE(4774), 1,
      sym__class_declaration_item,
    STATE(4777), 1,
      sym__class_declaration,
    STATE(5845), 1,
      sym_ms_declspec_modifier,
    STATE(6829), 1,
      sym__scope_resolution,
    STATE(7261), 1,
      sym_virtual_specifier,
    STATE(8010), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4250), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5850), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5614), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [221398] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_AMP,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6219), 1,
      sym__declarator,
    STATE(7612), 1,
      sym_init_declarator,
    STATE(8511), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [221468] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(9292), 1,
      sym_identifier,
    ACTIONS(9294), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9298), 1,
      sym_primitive_type,
    ACTIONS(9300), 1,
      anon_sym_enum,
    ACTIONS(9302), 1,
      anon_sym_class,
    ACTIONS(9304), 1,
      anon_sym_struct,
    ACTIONS(9306), 1,
      anon_sym_union,
    ACTIONS(9308), 1,
      sym_auto,
    ACTIONS(9310), 1,
      anon_sym_decltype,
    ACTIONS(9312), 1,
      anon_sym_typename,
    STATE(2715), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3174), 1,
      sym_type_specifier,
    STATE(3319), 1,
      sym_decltype_auto,
    STATE(3443), 1,
      sym_qualified_type_identifier,
    STATE(6809), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(3147), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9296), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3318), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [221542] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6372), 1,
      anon_sym_LBRACE,
    ACTIONS(9114), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9378), 1,
      sym_identifier,
    STATE(2844), 1,
      sym_template_type,
    STATE(3024), 1,
      sym_field_declaration_list,
    STATE(3434), 1,
      sym__class_declaration_item,
    STATE(3436), 1,
      sym__class_declaration,
    STATE(5880), 1,
      sym_ms_declspec_modifier,
    STATE(6861), 1,
      sym__scope_resolution,
    STATE(7369), 1,
      sym_virtual_specifier,
    STATE(8162), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2692), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5886), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5607), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [221622] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6372), 1,
      anon_sym_LBRACE,
    ACTIONS(9114), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9378), 1,
      sym_identifier,
    STATE(2844), 1,
      sym_template_type,
    STATE(3024), 1,
      sym_field_declaration_list,
    STATE(3431), 1,
      sym__class_declaration,
    STATE(3434), 1,
      sym__class_declaration_item,
    STATE(5880), 1,
      sym_ms_declspec_modifier,
    STATE(6861), 1,
      sym__scope_resolution,
    STATE(7369), 1,
      sym_virtual_specifier,
    STATE(8162), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2692), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5886), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5607), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [221702] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6372), 1,
      anon_sym_LBRACE,
    ACTIONS(9114), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9378), 1,
      sym_identifier,
    STATE(2844), 1,
      sym_template_type,
    STATE(3024), 1,
      sym_field_declaration_list,
    STATE(3429), 1,
      sym__class_declaration,
    STATE(3434), 1,
      sym__class_declaration_item,
    STATE(5880), 1,
      sym_ms_declspec_modifier,
    STATE(6861), 1,
      sym__scope_resolution,
    STATE(7369), 1,
      sym_virtual_specifier,
    STATE(8162), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2692), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5886), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5607), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [221782] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_AMP,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6171), 1,
      sym__declarator,
    STATE(7633), 1,
      sym_init_declarator,
    STATE(8511), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [221852] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2197), 1,
      sym__class_declaration,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5818), 1,
      sym_ms_declspec_modifier,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2315), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5784), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5623), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [221932] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6840), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9099), 1,
      anon_sym_requires,
    STATE(6350), 1,
      sym__function_attributes_end,
    STATE(6412), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9017), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5701), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [222002] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1877), 1,
      sym_auto,
    ACTIONS(1879), 1,
      anon_sym_decltype,
    ACTIONS(7138), 1,
      sym_primitive_type,
    ACTIONS(9231), 1,
      sym_identifier,
    ACTIONS(9233), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9235), 1,
      anon_sym_enum,
    ACTIONS(9237), 1,
      anon_sym_class,
    ACTIONS(9239), 1,
      anon_sym_struct,
    ACTIONS(9241), 1,
      anon_sym_union,
    ACTIONS(9243), 1,
      anon_sym_typename,
    STATE(2021), 1,
      sym_decltype_auto,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2124), 1,
      sym_qualified_type_identifier,
    STATE(4276), 1,
      sym_type_specifier,
    STATE(6864), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_dependent_type_identifier,
    STATE(1859), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2024), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [222076] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9374), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2197), 1,
      sym__class_declaration,
    STATE(2890), 1,
      sym_field_declaration_list,
    STATE(5855), 1,
      sym_ms_declspec_modifier,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(7347), 1,
      sym_virtual_specifier,
    STATE(8099), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2645), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5853), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5620), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [222156] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9374), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2181), 1,
      sym__class_declaration,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2890), 1,
      sym_field_declaration_list,
    STATE(5855), 1,
      sym_ms_declspec_modifier,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(7347), 1,
      sym_virtual_specifier,
    STATE(8099), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2645), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5853), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5620), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [222236] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2181), 1,
      sym__class_declaration,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5818), 1,
      sym_ms_declspec_modifier,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2315), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5784), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5623), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [222316] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7404), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8224), 1,
      anon_sym_LBRACE,
    ACTIONS(9376), 1,
      sym_identifier,
    STATE(4532), 1,
      sym_template_type,
    STATE(5098), 1,
      sym_field_declaration_list,
    STATE(5256), 1,
      sym__class_declaration,
    STATE(5262), 1,
      sym__class_declaration_item,
    STATE(5819), 1,
      sym_ms_declspec_modifier,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(7309), 1,
      sym_virtual_specifier,
    STATE(8090), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4500), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5817), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5601), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [222396] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5548), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9380), 1,
      sym_identifier,
    STATE(2280), 1,
      sym_template_type,
    STATE(2335), 1,
      sym_field_declaration_list,
    STATE(2425), 1,
      sym__class_declaration_item,
    STATE(2427), 1,
      sym__class_declaration,
    STATE(5848), 1,
      sym_ms_declspec_modifier,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(7212), 1,
      sym_virtual_specifier,
    STATE(7999), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2158), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5849), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5615), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [222476] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5548), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9380), 1,
      sym_identifier,
    STATE(2280), 1,
      sym_template_type,
    STATE(2335), 1,
      sym_field_declaration_list,
    STATE(2425), 1,
      sym__class_declaration_item,
    STATE(2426), 1,
      sym__class_declaration,
    STATE(5848), 1,
      sym_ms_declspec_modifier,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(7212), 1,
      sym_virtual_specifier,
    STATE(7999), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2158), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5849), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5615), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [222556] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5548), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9380), 1,
      sym_identifier,
    STATE(2280), 1,
      sym_template_type,
    STATE(2335), 1,
      sym_field_declaration_list,
    STATE(2423), 1,
      sym__class_declaration,
    STATE(2425), 1,
      sym__class_declaration_item,
    STATE(5848), 1,
      sym_ms_declspec_modifier,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(7212), 1,
      sym_virtual_specifier,
    STATE(7999), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2158), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5849), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5615), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [222636] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9374), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2191), 1,
      sym__class_declaration,
    STATE(2890), 1,
      sym_field_declaration_list,
    STATE(5855), 1,
      sym_ms_declspec_modifier,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(7347), 1,
      sym_virtual_specifier,
    STATE(8099), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2645), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5853), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5620), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [222716] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2185), 1,
      sym__class_declaration_item,
    STATE(2197), 1,
      sym__class_declaration,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5818), 1,
      sym_ms_declspec_modifier,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2314), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5784), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5623), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [222796] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6977), 1,
      anon_sym_DASH_GT,
    ACTIONS(6979), 1,
      anon_sym_requires,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9328), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6281), 1,
      sym__function_attributes_end,
    STATE(6400), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5683), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9102), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [222866] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6740), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [222933] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8202), 1,
      anon_sym_LBRACE,
    ACTIONS(9374), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(4731), 1,
      sym_field_declaration_list,
    STATE(4995), 1,
      sym__class_declaration_item,
    STATE(5857), 1,
      sym_ms_declspec_modifier,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(7094), 1,
      sym_virtual_specifier,
    STATE(7830), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4467), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5858), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6289), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [223010] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6727), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [223077] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6663), 1,
      anon_sym_STAR,
    ACTIONS(6665), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6667), 1,
      anon_sym_AMP,
    ACTIONS(6669), 1,
      anon_sym_COLON_COLON,
    STATE(6119), 1,
      sym__scope_resolution,
    STATE(6901), 1,
      sym__declarator,
    STATE(8440), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [223144] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2166), 1,
      sym__class_declaration_item,
    STATE(2890), 1,
      sym_field_declaration_list,
    STATE(5879), 1,
      sym_ms_declspec_modifier,
    STATE(6845), 1,
      sym__scope_resolution,
    STATE(7347), 1,
      sym_virtual_specifier,
    STATE(8099), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2645), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5884), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6289), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [223221] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6759), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [223288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5149), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5151), 27,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [223325] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(5654), 1,
      anon_sym_LBRACE,
    ACTIONS(7437), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9350), 1,
      sym_identifier,
    STATE(2361), 1,
      sym_template_type,
    STATE(2454), 1,
      sym_field_declaration_list,
    STATE(2594), 1,
      sym__class_declaration_item,
    STATE(5868), 1,
      sym_ms_declspec_modifier,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(7226), 1,
      sym_virtual_specifier,
    STATE(8040), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2216), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5867), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6289), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [223402] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8202), 1,
      anon_sym_LBRACE,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(4731), 1,
      sym_field_declaration_list,
    STATE(4995), 1,
      sym__class_declaration_item,
    STATE(5833), 1,
      sym_ms_declspec_modifier,
    STATE(6845), 1,
      sym__scope_resolution,
    STATE(7094), 1,
      sym_virtual_specifier,
    STATE(7830), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4467), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5841), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6289), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [223479] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6591), 1,
      anon_sym_STAR,
    ACTIONS(6593), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6595), 1,
      anon_sym_AMP,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6779), 1,
      sym__declarator,
    STATE(8387), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [223546] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(7026), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9382), 1,
      anon_sym_requires,
    STATE(6390), 1,
      sym__function_attributes_end,
    STATE(6655), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9106), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5709), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9102), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [223615] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6663), 1,
      anon_sym_STAR,
    ACTIONS(6665), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6667), 1,
      anon_sym_AMP,
    ACTIONS(6669), 1,
      anon_sym_COLON_COLON,
    STATE(6119), 1,
      sym__scope_resolution,
    STATE(6890), 1,
      sym__declarator,
    STATE(8440), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [223682] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2120), 1,
      anon_sym_STAR,
    ACTIONS(2122), 1,
      anon_sym_AMP,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(5631), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(6094), 1,
      sym__scope_resolution,
    STATE(6883), 1,
      sym__declarator,
    STATE(8796), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [223749] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6275), 1,
      anon_sym_LBRACE,
    ACTIONS(9294), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9372), 1,
      sym_identifier,
    STATE(2848), 1,
      sym_template_type,
    STATE(3045), 1,
      sym_field_declaration_list,
    STATE(3289), 1,
      sym__class_declaration_item,
    STATE(5811), 1,
      sym_ms_declspec_modifier,
    STATE(6809), 1,
      sym__scope_resolution,
    STATE(7262), 1,
      sym_virtual_specifier,
    STATE(8011), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2630), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5807), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6289), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [223826] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6761), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [223893] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6718), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [223960] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(5654), 1,
      anon_sym_LBRACE,
    ACTIONS(9316), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9341), 1,
      sym_identifier,
    STATE(2361), 1,
      sym_template_type,
    STATE(2454), 1,
      sym_field_declaration_list,
    STATE(2594), 1,
      sym__class_declaration_item,
    STATE(5875), 1,
      sym_ms_declspec_modifier,
    STATE(6846), 1,
      sym__scope_resolution,
    STATE(7226), 1,
      sym_virtual_specifier,
    STATE(8040), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2216), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5883), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6289), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [224037] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6688), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [224104] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6603), 1,
      anon_sym_LBRACE,
    ACTIONS(9250), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9370), 1,
      sym_identifier,
    STATE(2986), 1,
      sym_template_type,
    STATE(3282), 1,
      sym_field_declaration_list,
    STATE(3628), 1,
      sym__class_declaration_item,
    STATE(5806), 1,
      sym_ms_declspec_modifier,
    STATE(6853), 1,
      sym__scope_resolution,
    STATE(7358), 1,
      sym_virtual_specifier,
    STATE(8063), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2781), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5804), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6289), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [224181] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6710), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [224248] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6756), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [224315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(2588), 27,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___global__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym___shared__,
      anon_sym___local__,
      anon_sym___constant__,
      anon_sym___managed__,
      anon_sym___grid_constant__,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [224352] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6651), 1,
      anon_sym_STAR,
    ACTIONS(6653), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6655), 1,
      anon_sym_AMP,
    ACTIONS(6657), 1,
      anon_sym_COLON_COLON,
    STATE(6064), 1,
      sym__scope_resolution,
    STATE(6479), 1,
      sym__declarator,
    STATE(8311), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [224419] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7404), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8224), 1,
      anon_sym_LBRACE,
    ACTIONS(9376), 1,
      sym_identifier,
    STATE(4532), 1,
      sym_template_type,
    STATE(5098), 1,
      sym_field_declaration_list,
    STATE(5310), 1,
      sym__class_declaration_item,
    STATE(5802), 1,
      sym_ms_declspec_modifier,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(7309), 1,
      sym_virtual_specifier,
    STATE(8090), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4500), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5801), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6289), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [224496] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2120), 1,
      anon_sym_STAR,
    ACTIONS(2122), 1,
      anon_sym_AMP,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(5631), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(6094), 1,
      sym__scope_resolution,
    STATE(6882), 1,
      sym__declarator,
    STATE(8796), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [224563] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6591), 1,
      anon_sym_STAR,
    ACTIONS(6593), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6595), 1,
      anon_sym_AMP,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6642), 1,
      sym__declarator,
    STATE(8387), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [224630] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9348), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(1951), 1,
      sym__class_declaration_item,
    STATE(2233), 1,
      sym_field_declaration_list,
    STATE(5816), 1,
      sym_ms_declspec_modifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(7158), 1,
      sym_virtual_specifier,
    STATE(7915), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2149), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5837), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6289), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [224707] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(7026), 1,
      anon_sym_DASH_GT,
    ACTIONS(7037), 1,
      anon_sym_requires,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    STATE(6383), 1,
      sym__function_attributes_end,
    STATE(6633), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5707), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9102), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [224776] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7651), 1,
      anon_sym_LBRACE,
    ACTIONS(9211), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9366), 1,
      sym_identifier,
    STATE(4104), 1,
      sym_template_type,
    STATE(4278), 1,
      sym_field_declaration_list,
    STATE(4410), 1,
      sym__class_declaration_item,
    STATE(5838), 1,
      sym_ms_declspec_modifier,
    STATE(6855), 1,
      sym__scope_resolution,
    STATE(7207), 1,
      sym_virtual_specifier,
    STATE(7935), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3584), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5847), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6289), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [224853] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6372), 1,
      anon_sym_LBRACE,
    ACTIONS(9114), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9378), 1,
      sym_identifier,
    STATE(2844), 1,
      sym_template_type,
    STATE(3024), 1,
      sym_field_declaration_list,
    STATE(3397), 1,
      sym__class_declaration_item,
    STATE(5888), 1,
      sym_ms_declspec_modifier,
    STATE(6861), 1,
      sym__scope_resolution,
    STATE(7369), 1,
      sym_virtual_specifier,
    STATE(8162), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2692), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5887), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6289), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [224930] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(7026), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9245), 1,
      anon_sym_requires,
    STATE(6389), 1,
      sym__function_attributes_end,
    STATE(6653), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9017), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5711), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [224999] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(7026), 1,
      anon_sym_DASH_GT,
    ACTIONS(7037), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    STATE(6382), 1,
      sym__function_attributes_end,
    STATE(6629), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5703), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9013), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [225068] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2120), 1,
      anon_sym_STAR,
    ACTIONS(2122), 1,
      anon_sym_AMP,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(5631), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(6094), 1,
      sym__scope_resolution,
    STATE(6865), 1,
      sym__declarator,
    STATE(8796), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [225135] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6179), 1,
      anon_sym_LBRACE,
    ACTIONS(9189), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9354), 1,
      sym_identifier,
    STATE(2794), 1,
      sym_template_type,
    STATE(3006), 1,
      sym_field_declaration_list,
    STATE(3159), 1,
      sym__class_declaration_item,
    STATE(5823), 1,
      sym_ms_declspec_modifier,
    STATE(6836), 1,
      sym__scope_resolution,
    STATE(7210), 1,
      sym_virtual_specifier,
    STATE(7996), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2548), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5824), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6289), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [225212] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2120), 1,
      anon_sym_STAR,
    ACTIONS(2122), 1,
      anon_sym_AMP,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(5631), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(6094), 1,
      sym__scope_resolution,
    STATE(6913), 1,
      sym__declarator,
    STATE(8796), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [225279] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6693), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [225346] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(8013), 1,
      anon_sym_LBRACE,
    ACTIONS(9272), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9337), 1,
      sym_identifier,
    STATE(4418), 1,
      sym_template_type,
    STATE(4537), 1,
      sym_field_declaration_list,
    STATE(4817), 1,
      sym__class_declaration_item,
    STATE(5852), 1,
      sym_ms_declspec_modifier,
    STATE(6829), 1,
      sym__scope_resolution,
    STATE(7261), 1,
      sym_virtual_specifier,
    STATE(8010), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4250), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5851), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6289), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [225423] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5548), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9380), 1,
      sym_identifier,
    STATE(2280), 1,
      sym_template_type,
    STATE(2335), 1,
      sym_field_declaration_list,
    STATE(2401), 1,
      sym__class_declaration_item,
    STATE(5873), 1,
      sym_ms_declspec_modifier,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(7212), 1,
      sym_virtual_specifier,
    STATE(7999), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2158), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5872), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6289), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [225500] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    ACTIONS(9364), 1,
      anon_sym_COLON_COLON,
    STATE(2113), 1,
      sym_template_type,
    STATE(2166), 1,
      sym__class_declaration_item,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5854), 1,
      sym_ms_declspec_modifier,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3013), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5835), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6289), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [225577] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6583), 1,
      anon_sym_STAR,
    ACTIONS(6585), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6587), 1,
      anon_sym_AMP,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6436), 1,
      sym__declarator,
    STATE(8511), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [225644] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2120), 1,
      anon_sym_STAR,
    ACTIONS(2122), 1,
      anon_sym_AMP,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(5631), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(6094), 1,
      sym__scope_resolution,
    STATE(6904), 1,
      sym__declarator,
    STATE(8796), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [225711] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6736), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [225778] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9374), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2166), 1,
      sym__class_declaration_item,
    STATE(2890), 1,
      sym_field_declaration_list,
    STATE(5809), 1,
      sym_ms_declspec_modifier,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(7347), 1,
      sym_virtual_specifier,
    STATE(8099), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2645), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5810), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6289), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [225855] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9352), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2166), 1,
      sym__class_declaration_item,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5862), 1,
      sym_ms_declspec_modifier,
    STATE(6858), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2161), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5882), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6289), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [225932] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9368), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(1951), 1,
      sym__class_declaration_item,
    STATE(5352), 1,
      sym_field_declaration_list,
    STATE(5795), 1,
      sym_ms_declspec_modifier,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(7193), 1,
      sym_virtual_specifier,
    STATE(7946), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4582), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5799), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6289), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [226009] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2166), 1,
      sym__class_declaration_item,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(5865), 1,
      sym_ms_declspec_modifier,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2161), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5834), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6289), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [226086] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6750), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [226153] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2120), 1,
      anon_sym_STAR,
    ACTIONS(2122), 1,
      anon_sym_AMP,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4994), 1,
      sym_identifier,
    ACTIONS(5631), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    STATE(6094), 1,
      sym__scope_resolution,
    STATE(6688), 1,
      sym__declarator,
    STATE(8796), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [226220] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6754), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [226287] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6716), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [226354] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5002), 1,
      anon_sym___attribute__,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5008), 1,
      anon_sym___declspec,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9233), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9343), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(1951), 1,
      sym__class_declaration_item,
    STATE(2233), 1,
      sym_field_declaration_list,
    STATE(5890), 1,
      sym_ms_declspec_modifier,
    STATE(6864), 1,
      sym__scope_resolution,
    STATE(7158), 1,
      sym_virtual_specifier,
    STATE(7915), 1,
      sym_base_class_clause,
    ACTIONS(5010), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2149), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5814), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6289), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [226431] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6695), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [226498] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2116), 1,
      anon_sym_LPAREN2,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6589), 1,
      anon_sym_LBRACK,
    ACTIONS(6607), 1,
      sym_identifier,
    ACTIONS(6609), 1,
      anon_sym_STAR,
    ACTIONS(6611), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6613), 1,
      anon_sym_AMP,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(6691), 1,
      sym__declarator,
    STATE(8212), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6598), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [226565] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9385), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5988), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(5986), 15,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      sym_virtual,
      anon_sym_template,
      anon_sym_try,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_requires,
  [226605] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6633), 1,
      anon_sym_DASH_GT,
    ACTIONS(6676), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    STATE(6135), 1,
      sym__function_attributes_end,
    STATE(6271), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [226667] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6633), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9109), 1,
      anon_sym_requires,
    STATE(6141), 1,
      sym__function_attributes_end,
    STATE(6236), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9106), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [226729] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6633), 1,
      anon_sym_DASH_GT,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9395), 1,
      anon_sym_requires,
    STATE(6134), 1,
      sym__function_attributes_end,
    STATE(6230), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9392), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6399), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [226791] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6633), 1,
      anon_sym_DASH_GT,
    ACTIONS(6676), 1,
      anon_sym_requires,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    STATE(6130), 1,
      sym__function_attributes_end,
    STATE(6282), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [226853] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6633), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9020), 1,
      anon_sym_requires,
    STATE(6131), 1,
      sym__function_attributes_end,
    STATE(6241), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9017), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [226915] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6633), 1,
      anon_sym_DASH_GT,
    ACTIONS(6676), 1,
      anon_sym_requires,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    STATE(6129), 1,
      sym__function_attributes_end,
    STATE(6273), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6399), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [226977] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9099), 1,
      anon_sym_requires,
    STATE(6412), 1,
      sym_trailing_return_type,
    STATE(6652), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9013), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9017), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5770), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [227044] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6698), 1,
      anon_sym_DASH_GT,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9398), 1,
      anon_sym___attribute__,
    ACTIONS(9401), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6036), 1,
      sym__function_attributes_end,
    STATE(6108), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [227105] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6698), 1,
      anon_sym_DASH_GT,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9054), 1,
      anon_sym___attribute__,
    ACTIONS(9057), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6037), 1,
      sym__function_attributes_end,
    STATE(6076), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [227166] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6990), 1,
      anon_sym_requires,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    STATE(6392), 1,
      sym_trailing_return_type,
    STATE(6620), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9102), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5724), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [227233] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(7431), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9178), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9404), 1,
      anon_sym_requires,
    STATE(6590), 1,
      sym__function_attributes_end,
    STATE(6737), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9102), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9181), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5766), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [227300] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(7431), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9057), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9356), 1,
      anon_sym_requires,
    STATE(6591), 1,
      sym__function_attributes_end,
    STATE(6738), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9013), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5752), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [227367] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6990), 1,
      anon_sym_requires,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    STATE(6500), 1,
      sym_trailing_return_type,
    STATE(6619), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9013), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5716), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [227434] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9345), 1,
      anon_sym_requires,
    STATE(6401), 1,
      sym_trailing_return_type,
    STATE(6654), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9102), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9106), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5779), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [227501] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6698), 1,
      anon_sym_DASH_GT,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9398), 1,
      anon_sym___attribute__,
    ACTIONS(9401), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9410), 1,
      anon_sym_requires,
    STATE(6066), 1,
      sym__function_attributes_end,
    STATE(6073), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9407), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [227562] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6698), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9175), 1,
      anon_sym___attribute__,
    ACTIONS(9178), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9184), 1,
      anon_sym_requires,
    STATE(6069), 1,
      sym__function_attributes_end,
    STATE(6107), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9181), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [227623] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6698), 1,
      anon_sym_DASH_GT,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9175), 1,
      anon_sym___attribute__,
    ACTIONS(9178), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6027), 1,
      sym__function_attributes_end,
    STATE(6029), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [227684] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(7431), 1,
      anon_sym_DASH_GT,
    ACTIONS(7433), 1,
      anon_sym_requires,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9178), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6597), 1,
      sym__function_attributes_end,
    STATE(6684), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9102), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5742), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [227751] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6638), 1,
      anon_sym_noexcept,
    ACTIONS(6640), 1,
      anon_sym_throw,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(7431), 1,
      anon_sym_DASH_GT,
    ACTIONS(7433), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9057), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6602), 1,
      sym__function_attributes_end,
    STATE(6700), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9013), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5735), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [227818] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6698), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9054), 1,
      anon_sym___attribute__,
    ACTIONS(9057), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9063), 1,
      anon_sym_requires,
    STATE(6019), 1,
      sym_trailing_return_type,
    STATE(6082), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [227879] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6822), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9057), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9063), 1,
      anon_sym_requires,
    STATE(6019), 1,
      sym_trailing_return_type,
    STATE(6187), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [227939] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6081), 1,
      sym_ms_call_modifier,
    STATE(6926), 1,
      sym__type_declarator,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(51), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [227997] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6813), 1,
      anon_sym_requires,
    ACTIONS(6820), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9328), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6023), 1,
      sym_trailing_return_type,
    STATE(6106), 1,
      sym__function_attributes_end,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9331), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [228057] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6801), 1,
      anon_sym_DASH_GT,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9401), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6097), 1,
      sym__function_attributes_end,
    STATE(6108), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9413), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [228117] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6820), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9074), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9077), 1,
      anon_sym_requires,
    STATE(6024), 1,
      sym__function_attributes_end,
    STATE(6088), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9086), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [228177] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6822), 1,
      anon_sym_DASH_GT,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9401), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6108), 1,
      sym_trailing_return_type,
    STATE(6168), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [228237] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6053), 1,
      sym_ms_call_modifier,
    STATE(6965), 1,
      sym__type_declarator,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(51), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [228295] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6822), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9057), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6076), 1,
      sym_trailing_return_type,
    STATE(6196), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [228355] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6822), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9178), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9184), 1,
      anon_sym_requires,
    STATE(6107), 1,
      sym_trailing_return_type,
    STATE(6146), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9181), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [228415] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6811), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9074), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9077), 1,
      anon_sym_requires,
    STATE(6088), 1,
      sym_trailing_return_type,
    STATE(6194), 1,
      sym__function_attributes_end,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [228475] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6104), 1,
      sym_ms_call_modifier,
    STATE(6931), 1,
      sym__type_declarator,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(51), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [228533] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6811), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9328), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9334), 1,
      anon_sym_requires,
    STATE(6086), 1,
      sym_trailing_return_type,
    STATE(6191), 1,
      sym__function_attributes_end,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9181), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [228593] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6811), 1,
      anon_sym_DASH_GT,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9416), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9419), 1,
      anon_sym_requires,
    STATE(6085), 1,
      sym_trailing_return_type,
    STATE(6190), 1,
      sym__function_attributes_end,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9407), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [228653] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6801), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9178), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6029), 1,
      sym_trailing_return_type,
    STATE(6056), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9331), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [228713] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6820), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9328), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9334), 1,
      anon_sym_requires,
    STATE(6007), 1,
      sym__function_attributes_end,
    STATE(6086), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(9181), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9331), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [228773] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6811), 1,
      anon_sym_DASH_GT,
    ACTIONS(6813), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9074), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6103), 1,
      sym_trailing_return_type,
    STATE(6213), 1,
      sym__function_attributes_end,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [228833] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6820), 1,
      anon_sym_DASH_GT,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9416), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9419), 1,
      anon_sym_requires,
    STATE(6001), 1,
      sym__function_attributes_end,
    STATE(6085), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(9407), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9413), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [228893] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6801), 1,
      anon_sym_DASH_GT,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9401), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9410), 1,
      anon_sym_requires,
    STATE(6049), 1,
      sym__function_attributes_end,
    STATE(6073), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(9407), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9413), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [228953] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6801), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9178), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9184), 1,
      anon_sym_requires,
    STATE(6020), 1,
      sym__function_attributes_end,
    STATE(6107), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(9181), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9331), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [229013] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6813), 1,
      anon_sym_requires,
    ACTIONS(6820), 1,
      anon_sym_DASH_GT,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9416), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6022), 1,
      sym_trailing_return_type,
    STATE(6102), 1,
      sym__function_attributes_end,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9413), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [229073] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6801), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9057), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9063), 1,
      anon_sym_requires,
    STATE(6013), 1,
      sym__function_attributes_end,
    STATE(6019), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9086), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [229133] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6822), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9178), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6029), 1,
      sym_trailing_return_type,
    STATE(6174), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [229193] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6011), 1,
      sym_ms_call_modifier,
    STATE(6949), 1,
      sym__type_declarator,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(51), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [229251] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6121), 1,
      sym_ms_call_modifier,
    STATE(6937), 1,
      sym__type_declarator,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(51), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [229309] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6822), 1,
      anon_sym_DASH_GT,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9401), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9410), 1,
      anon_sym_requires,
    STATE(6073), 1,
      sym_trailing_return_type,
    STATE(6165), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9407), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [229369] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6811), 1,
      anon_sym_DASH_GT,
    ACTIONS(6813), 1,
      anon_sym_requires,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9416), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6022), 1,
      sym_trailing_return_type,
    STATE(6206), 1,
      sym__function_attributes_end,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [229429] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6813), 1,
      anon_sym_requires,
    ACTIONS(6820), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9074), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6103), 1,
      sym_trailing_return_type,
    STATE(6110), 1,
      sym__function_attributes_end,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9086), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [229489] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6811), 1,
      anon_sym_DASH_GT,
    ACTIONS(6813), 1,
      anon_sym_requires,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9328), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6023), 1,
      sym_trailing_return_type,
    STATE(6212), 1,
      sym__function_attributes_end,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [229549] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6801), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9057), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6063), 1,
      sym__function_attributes_end,
    STATE(6076), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9086), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [229609] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9250), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9370), 1,
      sym_identifier,
    ACTIONS(9422), 1,
      anon_sym_LPAREN2,
    ACTIONS(9424), 1,
      anon_sym_LBRACE,
    ACTIONS(9428), 1,
      anon_sym_requires,
    STATE(2986), 1,
      sym_template_type,
    STATE(4181), 1,
      sym_requirement_seq,
    STATE(6183), 1,
      sym_lambda_capture_specifier,
    STATE(6853), 1,
      sym__scope_resolution,
    STATE(8083), 1,
      sym_requires_parameter_list,
    ACTIONS(9426), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4138), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [229670] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6840), 1,
      anon_sym_DASH_GT,
    ACTIONS(6990), 1,
      anon_sym_requires,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    STATE(6376), 1,
      sym__function_attributes_end,
    STATE(6392), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [229729] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6977), 1,
      anon_sym_DASH_GT,
    ACTIONS(6979), 1,
      anon_sym_requires,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9416), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6286), 1,
      sym__function_attributes_end,
    STATE(6396), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [229788] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6977), 1,
      anon_sym_DASH_GT,
    ACTIONS(6979), 1,
      anon_sym_requires,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9328), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6281), 1,
      sym__function_attributes_end,
    STATE(6400), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [229847] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6977), 1,
      anon_sym_DASH_GT,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9416), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9430), 1,
      anon_sym_requires,
    STATE(6274), 1,
      sym__function_attributes_end,
    STATE(6424), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9407), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [229906] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6840), 1,
      anon_sym_DASH_GT,
    ACTIONS(6990), 1,
      anon_sym_requires,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    STATE(6374), 1,
      sym__function_attributes_end,
    STATE(6403), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6399), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [229965] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9211), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9366), 1,
      sym_identifier,
    ACTIONS(9433), 1,
      anon_sym_LPAREN2,
    ACTIONS(9435), 1,
      anon_sym_LBRACE,
    ACTIONS(9439), 1,
      anon_sym_requires,
    STATE(3723), 1,
      sym_requirement_seq,
    STATE(4104), 1,
      sym_template_type,
    STATE(6182), 1,
      sym_lambda_capture_specifier,
    STATE(6855), 1,
      sym__scope_resolution,
    STATE(7912), 1,
      sym_requires_parameter_list,
    ACTIONS(9437), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4586), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [230026] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6977), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9074), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9096), 1,
      anon_sym_requires,
    STATE(6226), 1,
      sym__function_attributes_end,
    STATE(6422), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [230085] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6840), 1,
      anon_sym_DASH_GT,
    ACTIONS(6990), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    STATE(6337), 1,
      sym__function_attributes_end,
    STATE(6500), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [230144] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6977), 1,
      anon_sym_DASH_GT,
    ACTIONS(6979), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9074), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6270), 1,
      sym__function_attributes_end,
    STATE(6415), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [230203] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9233), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9343), 1,
      sym_identifier,
    ACTIONS(9433), 1,
      anon_sym_LPAREN2,
    ACTIONS(9435), 1,
      anon_sym_LBRACE,
    ACTIONS(9439), 1,
      anon_sym_requires,
    STATE(1851), 1,
      sym_template_type,
    STATE(3723), 1,
      sym_requirement_seq,
    STATE(6182), 1,
      sym_lambda_capture_specifier,
    STATE(6864), 1,
      sym__scope_resolution,
    STATE(7912), 1,
      sym_requires_parameter_list,
    ACTIONS(9441), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4611), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [230264] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6977), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9328), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9361), 1,
      anon_sym_requires,
    STATE(6253), 1,
      sym__function_attributes_end,
    STATE(6423), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9181), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [230323] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9316), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9341), 1,
      sym_identifier,
    ACTIONS(9443), 1,
      anon_sym_LPAREN2,
    ACTIONS(9445), 1,
      anon_sym_LBRACE,
    ACTIONS(9449), 1,
      anon_sym_requires,
    STATE(2361), 1,
      sym_template_type,
    STATE(4841), 1,
      sym_requirement_seq,
    STATE(6195), 1,
      sym_lambda_capture_specifier,
    STATE(6846), 1,
      sym__scope_resolution,
    STATE(7932), 1,
      sym_requires_parameter_list,
    ACTIONS(9447), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5215), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [230384] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9294), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9372), 1,
      sym_identifier,
    ACTIONS(9451), 1,
      anon_sym_LPAREN2,
    ACTIONS(9453), 1,
      anon_sym_LBRACE,
    ACTIONS(9457), 1,
      anon_sym_requires,
    STATE(2848), 1,
      sym_template_type,
    STATE(4001), 1,
      sym_requirement_seq,
    STATE(6189), 1,
      sym_lambda_capture_specifier,
    STATE(6809), 1,
      sym__scope_resolution,
    STATE(8086), 1,
      sym_requires_parameter_list,
    ACTIONS(9455), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3970), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [230445] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9380), 1,
      sym_identifier,
    ACTIONS(9459), 1,
      anon_sym_LPAREN2,
    ACTIONS(9461), 1,
      anon_sym_LBRACE,
    ACTIONS(9465), 1,
      anon_sym_requires,
    STATE(2280), 1,
      sym_template_type,
    STATE(2647), 1,
      sym_requirement_seq,
    STATE(6215), 1,
      sym_lambda_capture_specifier,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(7951), 1,
      sym_requires_parameter_list,
    ACTIONS(9463), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2650), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [230506] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9272), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9337), 1,
      sym_identifier,
    ACTIONS(9467), 1,
      anon_sym_LPAREN2,
    ACTIONS(9469), 1,
      anon_sym_LBRACE,
    ACTIONS(9473), 1,
      anon_sym_requires,
    STATE(4418), 1,
      sym_template_type,
    STATE(5184), 1,
      sym_requirement_seq,
    STATE(6164), 1,
      sym_lambda_capture_specifier,
    STATE(6829), 1,
      sym__scope_resolution,
    STATE(8048), 1,
      sym_requires_parameter_list,
    ACTIONS(9471), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5322), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [230567] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6840), 1,
      anon_sym_DASH_GT,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9475), 1,
      anon_sym_requires,
    STATE(6371), 1,
      sym__function_attributes_end,
    STATE(6398), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9392), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6399), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [230626] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9189), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9354), 1,
      sym_identifier,
    ACTIONS(9478), 1,
      anon_sym_LPAREN2,
    ACTIONS(9480), 1,
      anon_sym_LBRACE,
    ACTIONS(9484), 1,
      anon_sym_requires,
    STATE(2794), 1,
      sym_template_type,
    STATE(3782), 1,
      sym_requirement_seq,
    STATE(6157), 1,
      sym_lambda_capture_specifier,
    STATE(6836), 1,
      sym__scope_resolution,
    STATE(7923), 1,
      sym_requires_parameter_list,
    ACTIONS(9482), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3784), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [230687] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6840), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9099), 1,
      anon_sym_requires,
    STATE(6350), 1,
      sym__function_attributes_end,
    STATE(6412), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9017), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [230746] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9114), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9378), 1,
      sym_identifier,
    ACTIONS(9486), 1,
      anon_sym_LPAREN2,
    ACTIONS(9488), 1,
      anon_sym_LBRACE,
    ACTIONS(9492), 1,
      anon_sym_requires,
    STATE(2844), 1,
      sym_template_type,
    STATE(3967), 1,
      sym_requirement_seq,
    STATE(6169), 1,
      sym_lambda_capture_specifier,
    STATE(6861), 1,
      sym__scope_resolution,
    STATE(7820), 1,
      sym_requires_parameter_list,
    ACTIONS(9490), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4035), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [230807] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(6840), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9345), 1,
      anon_sym_requires,
    STATE(6362), 1,
      sym__function_attributes_end,
    STATE(6401), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9106), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [230866] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(7026), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9245), 1,
      anon_sym_requires,
    STATE(6389), 1,
      sym__function_attributes_end,
    STATE(6653), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9017), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [230924] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(7026), 1,
      anon_sym_DASH_GT,
    ACTIONS(7037), 1,
      anon_sym_requires,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    STATE(6383), 1,
      sym__function_attributes_end,
    STATE(6633), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [230982] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7142), 1,
      anon_sym_STAR,
    ACTIONS(7144), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6349), 1,
      sym__abstract_declarator,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8279), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [231030] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7158), 1,
      anon_sym_STAR,
    ACTIONS(7160), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7162), 1,
      anon_sym_AMP,
    STATE(2839), 1,
      sym_parameter_list,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6306), 1,
      sym__abstract_declarator,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8279), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [231078] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7164), 1,
      anon_sym_STAR,
    ACTIONS(7166), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7168), 1,
      anon_sym_AMP,
    STATE(2924), 1,
      sym_parameter_list,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6304), 1,
      sym__abstract_declarator,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8279), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [231126] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(7026), 1,
      anon_sym_DASH_GT,
    ACTIONS(7037), 1,
      anon_sym_requires,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    STATE(6384), 1,
      sym__function_attributes_end,
    STATE(6634), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6399), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [231184] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(7026), 1,
      anon_sym_DASH_GT,
    ACTIONS(7037), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    STATE(6382), 1,
      sym__function_attributes_end,
    STATE(6629), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [231242] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(7026), 1,
      anon_sym_DASH_GT,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9494), 1,
      anon_sym_requires,
    STATE(6393), 1,
      sym__function_attributes_end,
    STATE(6657), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9392), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6399), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [231300] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(7987), 1,
      sym_identifier,
    ACTIONS(7989), 1,
      anon_sym_LPAREN2,
    ACTIONS(7991), 1,
      anon_sym_STAR,
    ACTIONS(7993), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7995), 1,
      anon_sym_AMP,
    STATE(6218), 1,
      sym_ms_call_modifier,
    STATE(6897), 1,
      sym__field_declarator,
    STATE(7018), 1,
      sym_operator_name,
    STATE(8384), 1,
      sym_ms_based_modifier,
    ACTIONS(1839), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6748), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [231354] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(7026), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9382), 1,
      anon_sym_requires,
    STATE(6390), 1,
      sym__function_attributes_end,
    STATE(6655), 1,
      sym_trailing_return_type,
    STATE(6968), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9106), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5749), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6070), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [231412] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9499), 1,
      anon_sym_SEMI,
    ACTIONS(9501), 1,
      anon_sym_LBRACE,
    ACTIONS(9503), 1,
      anon_sym_LBRACK,
    ACTIONS(9505), 1,
      anon_sym_EQ,
    ACTIONS(9507), 1,
      anon_sym_COLON,
    ACTIONS(9509), 1,
      anon_sym_try,
    STATE(1875), 1,
      sym_delete_method_clause,
    STATE(1970), 1,
      sym_compound_statement,
    STATE(2004), 1,
      sym_try_statement,
    STATE(2006), 1,
      sym_pure_virtual_clause,
    STATE(2014), 1,
      sym_default_method_clause,
    STATE(2849), 1,
      sym_parameter_list,
    STATE(6683), 1,
      sym__function_declarator_seq,
    STATE(7028), 1,
      sym_initializer_list,
    STATE(7044), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7046), 1,
      sym_bitfield_clause,
    STATE(8263), 1,
      sym_attribute_specifier,
    STATE(6676), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [231483] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7386), 1,
      anon_sym_STAR,
    ACTIONS(7388), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7390), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    STATE(2786), 1,
      sym_parameter_list,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6447), 1,
      sym__abstract_declarator,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8279), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [231530] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9503), 1,
      anon_sym_LBRACK,
    ACTIONS(9507), 1,
      anon_sym_COLON,
    ACTIONS(9511), 1,
      anon_sym_SEMI,
    ACTIONS(9513), 1,
      anon_sym_LBRACE,
    ACTIONS(9515), 1,
      anon_sym_EQ,
    ACTIONS(9517), 1,
      anon_sym_try,
    STATE(1735), 1,
      sym_compound_statement,
    STATE(1736), 1,
      sym_default_method_clause,
    STATE(1737), 1,
      sym_delete_method_clause,
    STATE(1738), 1,
      sym_pure_virtual_clause,
    STATE(1740), 1,
      sym_try_statement,
    STATE(2849), 1,
      sym_parameter_list,
    STATE(6683), 1,
      sym__function_declarator_seq,
    STATE(7029), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7035), 1,
      sym_initializer_list,
    STATE(7036), 1,
      sym_bitfield_clause,
    STATE(8467), 1,
      sym_attribute_specifier,
    STATE(6676), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [231601] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9503), 1,
      anon_sym_LBRACK,
    ACTIONS(9507), 1,
      anon_sym_COLON,
    ACTIONS(9519), 1,
      anon_sym_SEMI,
    ACTIONS(9521), 1,
      anon_sym_LBRACE,
    ACTIONS(9523), 1,
      anon_sym_EQ,
    ACTIONS(9525), 1,
      anon_sym_try,
    STATE(1955), 1,
      sym_try_statement,
    STATE(1956), 1,
      sym_pure_virtual_clause,
    STATE(1957), 1,
      sym_delete_method_clause,
    STATE(1958), 1,
      sym_default_method_clause,
    STATE(1959), 1,
      sym_compound_statement,
    STATE(2849), 1,
      sym_parameter_list,
    STATE(6683), 1,
      sym__function_declarator_seq,
    STATE(7043), 1,
      sym_bitfield_clause,
    STATE(7080), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7081), 1,
      sym_initializer_list,
    STATE(9048), 1,
      sym_attribute_specifier,
    STATE(6676), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [231672] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6990), 1,
      anon_sym_requires,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    STATE(6392), 1,
      sym_trailing_return_type,
    STATE(6620), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9102), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
  [231728] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9272), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9337), 1,
      sym_identifier,
    ACTIONS(9473), 1,
      anon_sym_requires,
    ACTIONS(9527), 1,
      anon_sym_LPAREN2,
    STATE(4418), 1,
      sym_template_type,
    STATE(6164), 1,
      sym_lambda_capture_specifier,
    STATE(6829), 1,
      sym__scope_resolution,
    ACTIONS(9529), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5209), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [231780] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9533), 1,
      anon_sym_LPAREN2,
    STATE(5923), 1,
      sym_preproc_argument_list,
    ACTIONS(9535), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9531), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [231814] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7404), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9376), 1,
      sym_identifier,
    ACTIONS(9537), 1,
      anon_sym_LPAREN2,
    ACTIONS(9541), 1,
      anon_sym_requires,
    STATE(4532), 1,
      sym_template_type,
    STATE(6180), 1,
      sym_lambda_capture_specifier,
    STATE(6833), 1,
      sym__scope_resolution,
    ACTIONS(9539), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6276), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [231866] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7404), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9376), 1,
      sym_identifier,
    ACTIONS(9537), 1,
      anon_sym_LPAREN2,
    ACTIONS(9541), 1,
      anon_sym_requires,
    STATE(4532), 1,
      sym_template_type,
    STATE(6180), 1,
      sym_lambda_capture_specifier,
    STATE(6833), 1,
      sym__scope_resolution,
    ACTIONS(9543), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6239), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [231918] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9316), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9341), 1,
      sym_identifier,
    ACTIONS(9449), 1,
      anon_sym_requires,
    ACTIONS(9545), 1,
      anon_sym_LPAREN2,
    STATE(2361), 1,
      sym_template_type,
    STATE(6195), 1,
      sym_lambda_capture_specifier,
    STATE(6846), 1,
      sym__scope_resolution,
    ACTIONS(9547), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5249), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [231970] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9316), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9341), 1,
      sym_identifier,
    ACTIONS(9449), 1,
      anon_sym_requires,
    ACTIONS(9545), 1,
      anon_sym_LPAREN2,
    STATE(2361), 1,
      sym_template_type,
    STATE(6195), 1,
      sym_lambda_capture_specifier,
    STATE(6846), 1,
      sym__scope_resolution,
    ACTIONS(9549), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4892), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [232022] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7404), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9376), 1,
      sym_identifier,
    ACTIONS(9537), 1,
      anon_sym_LPAREN2,
    ACTIONS(9541), 1,
      anon_sym_requires,
    STATE(4532), 1,
      sym_template_type,
    STATE(6180), 1,
      sym_lambda_capture_specifier,
    STATE(6833), 1,
      sym__scope_resolution,
    ACTIONS(9551), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6249), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [232074] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6990), 1,
      anon_sym_requires,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_DASH_GT,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    STATE(6403), 1,
      sym_trailing_return_type,
    STATE(6621), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6399), 2,
      sym__function_postfix,
      sym_requires_clause,
  [232130] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9553), 1,
      sym_identifier,
    ACTIONS(9555), 1,
      anon_sym_LPAREN2,
    ACTIONS(9557), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9561), 1,
      anon_sym_requires,
    STATE(2109), 1,
      sym_template_type,
    STATE(6200), 1,
      sym_lambda_capture_specifier,
    STATE(6837), 1,
      sym__scope_resolution,
    ACTIONS(9559), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2126), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [232182] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7606), 1,
      anon_sym_STAR,
    ACTIONS(7608), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7610), 1,
      anon_sym_AMP,
    STATE(2909), 1,
      sym_parameter_list,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6547), 1,
      sym__abstract_declarator,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8279), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [232228] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9553), 1,
      sym_identifier,
    ACTIONS(9555), 1,
      anon_sym_LPAREN2,
    ACTIONS(9557), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9561), 1,
      anon_sym_requires,
    STATE(2109), 1,
      sym_template_type,
    STATE(6200), 1,
      sym_lambda_capture_specifier,
    STATE(6837), 1,
      sym__scope_resolution,
    ACTIONS(9563), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(1665), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [232280] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7511), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9374), 1,
      sym_identifier,
    ACTIONS(9555), 1,
      anon_sym_LPAREN2,
    ACTIONS(9561), 1,
      anon_sym_requires,
    STATE(2113), 1,
      sym_template_type,
    STATE(6221), 1,
      sym_lambda_capture_specifier,
    STATE(6827), 1,
      sym__scope_resolution,
    ACTIONS(9563), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(1665), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [232332] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9439), 1,
      anon_sym_requires,
    ACTIONS(9565), 1,
      sym_identifier,
    ACTIONS(9567), 1,
      anon_sym_LPAREN2,
    ACTIONS(9569), 1,
      anon_sym_COLON_COLON,
    STATE(1851), 1,
      sym_template_type,
    STATE(6182), 1,
      sym_lambda_capture_specifier,
    STATE(6847), 1,
      sym__scope_resolution,
    ACTIONS(9571), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6456), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [232384] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9439), 1,
      anon_sym_requires,
    ACTIONS(9565), 1,
      sym_identifier,
    ACTIONS(9567), 1,
      anon_sym_LPAREN2,
    ACTIONS(9569), 1,
      anon_sym_COLON_COLON,
    STATE(1851), 1,
      sym_template_type,
    STATE(6182), 1,
      sym_lambda_capture_specifier,
    STATE(6847), 1,
      sym__scope_resolution,
    ACTIONS(9573), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3677), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [232436] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3552), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    ACTIONS(9555), 1,
      anon_sym_LPAREN2,
    ACTIONS(9561), 1,
      anon_sym_requires,
    STATE(2113), 1,
      sym_template_type,
    STATE(6221), 1,
      sym_lambda_capture_specifier,
    STATE(6810), 1,
      sym__scope_resolution,
    ACTIONS(9575), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6446), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [232488] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3552), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    ACTIONS(9555), 1,
      anon_sym_LPAREN2,
    ACTIONS(9561), 1,
      anon_sym_requires,
    STATE(2113), 1,
      sym_template_type,
    STATE(6221), 1,
      sym_lambda_capture_specifier,
    STATE(6810), 1,
      sym__scope_resolution,
    ACTIONS(9563), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(1665), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [232540] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7511), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9374), 1,
      sym_identifier,
    ACTIONS(9555), 1,
      anon_sym_LPAREN2,
    ACTIONS(9561), 1,
      anon_sym_requires,
    STATE(2113), 1,
      sym_template_type,
    STATE(6221), 1,
      sym_lambda_capture_specifier,
    STATE(6827), 1,
      sym__scope_resolution,
    ACTIONS(9577), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6030), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [232592] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9250), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9370), 1,
      sym_identifier,
    ACTIONS(9428), 1,
      anon_sym_requires,
    ACTIONS(9579), 1,
      anon_sym_LPAREN2,
    STATE(2986), 1,
      sym_template_type,
    STATE(6183), 1,
      sym_lambda_capture_specifier,
    STATE(6853), 1,
      sym__scope_resolution,
    ACTIONS(9581), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4202), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [232644] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(7431), 1,
      anon_sym_DASH_GT,
    ACTIONS(7433), 1,
      anon_sym_requires,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9178), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6597), 1,
      sym__function_attributes_end,
    STATE(6684), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9102), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
  [232700] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9233), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9343), 1,
      sym_identifier,
    ACTIONS(9439), 1,
      anon_sym_requires,
    ACTIONS(9567), 1,
      anon_sym_LPAREN2,
    STATE(1851), 1,
      sym_template_type,
    STATE(6182), 1,
      sym_lambda_capture_specifier,
    STATE(6864), 1,
      sym__scope_resolution,
    ACTIONS(9573), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3677), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [232752] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9233), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9343), 1,
      sym_identifier,
    ACTIONS(9439), 1,
      anon_sym_requires,
    ACTIONS(9567), 1,
      anon_sym_LPAREN2,
    STATE(1851), 1,
      sym_template_type,
    STATE(6182), 1,
      sym_lambda_capture_specifier,
    STATE(6864), 1,
      sym__scope_resolution,
    ACTIONS(9583), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4558), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [232804] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9348), 1,
      sym_identifier,
    ACTIONS(9439), 1,
      anon_sym_requires,
    ACTIONS(9567), 1,
      anon_sym_LPAREN2,
    STATE(1851), 1,
      sym_template_type,
    STATE(6182), 1,
      sym_lambda_capture_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    ACTIONS(9585), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6814), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [232856] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9294), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9372), 1,
      sym_identifier,
    ACTIONS(9457), 1,
      anon_sym_requires,
    ACTIONS(9587), 1,
      anon_sym_LPAREN2,
    STATE(2848), 1,
      sym_template_type,
    STATE(6189), 1,
      sym_lambda_capture_specifier,
    STATE(6809), 1,
      sym__scope_resolution,
    ACTIONS(9589), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3869), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [232908] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9294), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9372), 1,
      sym_identifier,
    ACTIONS(9457), 1,
      anon_sym_requires,
    ACTIONS(9587), 1,
      anon_sym_LPAREN2,
    STATE(2848), 1,
      sym_template_type,
    STATE(6189), 1,
      sym_lambda_capture_specifier,
    STATE(6809), 1,
      sym__scope_resolution,
    ACTIONS(9591), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3919), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [232960] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9250), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9370), 1,
      sym_identifier,
    ACTIONS(9428), 1,
      anon_sym_requires,
    ACTIONS(9579), 1,
      anon_sym_LPAREN2,
    STATE(2986), 1,
      sym_template_type,
    STATE(6183), 1,
      sym_lambda_capture_specifier,
    STATE(6853), 1,
      sym__scope_resolution,
    ACTIONS(9593), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4200), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [233012] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(7431), 1,
      anon_sym_DASH_GT,
    ACTIONS(7433), 1,
      anon_sym_requires,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9401), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6594), 1,
      sym__function_attributes_end,
    STATE(6724), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
  [233068] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7617), 1,
      anon_sym_STAR,
    ACTIONS(7619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7621), 1,
      anon_sym_AMP,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6611), 1,
      sym__abstract_declarator,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8279), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [233114] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(131), 1,
      anon_sym_operator,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3608), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(9595), 1,
      sym_identifier,
    ACTIONS(9597), 1,
      anon_sym_template,
    STATE(2104), 1,
      sym_template_type,
    STATE(2112), 1,
      sym_dependent_type_identifier,
    STATE(2125), 1,
      sym_qualified_type_identifier,
    STATE(2944), 1,
      sym_pointer_type_declarator,
    STATE(2948), 1,
      sym_operator_name,
    STATE(2978), 1,
      sym_template_function,
    STATE(2997), 1,
      sym_qualified_identifier,
    STATE(2998), 1,
      sym_dependent_identifier,
    STATE(3001), 1,
      sym_destructor_name,
    STATE(5744), 1,
      sym__scope_resolution,
    STATE(7328), 1,
      sym_operator_cast,
    STATE(7346), 1,
      sym_qualified_operator_cast_identifier,
    STATE(8628), 1,
      sym_decltype,
    STATE(8639), 1,
      sym_ms_based_modifier,
  [233184] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9211), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9366), 1,
      sym_identifier,
    ACTIONS(9439), 1,
      anon_sym_requires,
    ACTIONS(9567), 1,
      anon_sym_LPAREN2,
    STATE(4104), 1,
      sym_template_type,
    STATE(6182), 1,
      sym_lambda_capture_specifier,
    STATE(6855), 1,
      sym__scope_resolution,
    ACTIONS(9599), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4588), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [233236] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9380), 1,
      sym_identifier,
    ACTIONS(9465), 1,
      anon_sym_requires,
    ACTIONS(9601), 1,
      anon_sym_LPAREN2,
    STATE(2280), 1,
      sym_template_type,
    STATE(6215), 1,
      sym_lambda_capture_specifier,
    STATE(6839), 1,
      sym__scope_resolution,
    ACTIONS(9603), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2664), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [233288] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(7431), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9057), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9356), 1,
      anon_sym_requires,
    STATE(6591), 1,
      sym__function_attributes_end,
    STATE(6738), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9013), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
  [233344] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9211), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9366), 1,
      sym_identifier,
    ACTIONS(9439), 1,
      anon_sym_requires,
    ACTIONS(9567), 1,
      anon_sym_LPAREN2,
    STATE(4104), 1,
      sym_template_type,
    STATE(6182), 1,
      sym_lambda_capture_specifier,
    STATE(6855), 1,
      sym__scope_resolution,
    ACTIONS(9573), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3677), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [233396] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(9607), 1,
      anon_sym_LBRACK,
    STATE(4457), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6074), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9605), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [233434] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(9611), 1,
      anon_sym_LBRACK,
    STATE(4457), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6057), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9609), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [233472] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(131), 1,
      anon_sym_operator,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2128), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(9613), 1,
      sym_identifier,
    ACTIONS(9615), 1,
      anon_sym_template,
    STATE(2104), 1,
      sym_template_type,
    STATE(2112), 1,
      sym_dependent_type_identifier,
    STATE(2125), 1,
      sym_qualified_type_identifier,
    STATE(2944), 1,
      sym_pointer_type_declarator,
    STATE(2948), 1,
      sym_operator_name,
    STATE(2978), 1,
      sym_template_function,
    STATE(2997), 1,
      sym_qualified_identifier,
    STATE(2998), 1,
      sym_dependent_identifier,
    STATE(3001), 1,
      sym_destructor_name,
    STATE(5751), 1,
      sym__scope_resolution,
    STATE(7328), 1,
      sym_operator_cast,
    STATE(7346), 1,
      sym_qualified_operator_cast_identifier,
    STATE(8628), 1,
      sym_decltype,
    STATE(8639), 1,
      sym_ms_based_modifier,
  [233542] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(7431), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9178), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9404), 1,
      anon_sym_requires,
    STATE(6590), 1,
      sym__function_attributes_end,
    STATE(6737), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9102), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9181), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
  [233598] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7511), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9374), 1,
      sym_identifier,
    ACTIONS(9555), 1,
      anon_sym_LPAREN2,
    ACTIONS(9561), 1,
      anon_sym_requires,
    STATE(2113), 1,
      sym_template_type,
    STATE(6221), 1,
      sym_lambda_capture_specifier,
    STATE(6827), 1,
      sym__scope_resolution,
    ACTIONS(9617), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6112), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [233650] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9553), 1,
      sym_identifier,
    ACTIONS(9555), 1,
      anon_sym_LPAREN2,
    ACTIONS(9557), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9561), 1,
      anon_sym_requires,
    STATE(2109), 1,
      sym_template_type,
    STATE(6200), 1,
      sym_lambda_capture_specifier,
    STATE(6837), 1,
      sym__scope_resolution,
    ACTIONS(9619), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2106), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [233702] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9439), 1,
      anon_sym_requires,
    ACTIONS(9565), 1,
      sym_identifier,
    ACTIONS(9567), 1,
      anon_sym_LPAREN2,
    ACTIONS(9569), 1,
      anon_sym_COLON_COLON,
    STATE(1851), 1,
      sym_template_type,
    STATE(6182), 1,
      sym_lambda_capture_specifier,
    STATE(6847), 1,
      sym__scope_resolution,
    ACTIONS(9621), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6488), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [233754] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9348), 1,
      sym_identifier,
    ACTIONS(9439), 1,
      anon_sym_requires,
    ACTIONS(9567), 1,
      anon_sym_LPAREN2,
    STATE(1851), 1,
      sym_template_type,
    STATE(6182), 1,
      sym_lambda_capture_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    ACTIONS(9573), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3677), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [233806] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9380), 1,
      sym_identifier,
    ACTIONS(9465), 1,
      anon_sym_requires,
    ACTIONS(9601), 1,
      anon_sym_LPAREN2,
    STATE(2280), 1,
      sym_template_type,
    STATE(6215), 1,
      sym_lambda_capture_specifier,
    STATE(6839), 1,
      sym__scope_resolution,
    ACTIONS(9623), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2663), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [233858] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7437), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9350), 1,
      sym_identifier,
    ACTIONS(9449), 1,
      anon_sym_requires,
    ACTIONS(9545), 1,
      anon_sym_LPAREN2,
    STATE(2361), 1,
      sym_template_type,
    STATE(6195), 1,
      sym_lambda_capture_specifier,
    STATE(6832), 1,
      sym__scope_resolution,
    ACTIONS(9625), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6671), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [233910] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7893), 1,
      anon_sym_STAR,
    ACTIONS(9627), 1,
      sym_identifier,
    ACTIONS(9629), 1,
      anon_sym_TILDE,
    ACTIONS(9631), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9633), 1,
      anon_sym_template,
    ACTIONS(9635), 1,
      anon_sym_operator,
    STATE(2104), 1,
      sym_template_type,
    STATE(2112), 1,
      sym_dependent_type_identifier,
    STATE(2125), 1,
      sym_qualified_type_identifier,
    STATE(2944), 1,
      sym_pointer_type_declarator,
    STATE(2948), 1,
      sym_operator_name,
    STATE(2978), 1,
      sym_template_function,
    STATE(2997), 1,
      sym_qualified_identifier,
    STATE(2998), 1,
      sym_dependent_identifier,
    STATE(3001), 1,
      sym_destructor_name,
    STATE(5759), 1,
      sym__scope_resolution,
    STATE(7328), 1,
      sym_operator_cast,
    STATE(7346), 1,
      sym_qualified_operator_cast_identifier,
    STATE(8628), 1,
      sym_decltype,
    STATE(8989), 1,
      sym_ms_based_modifier,
  [233980] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9374), 1,
      sym_identifier,
    ACTIONS(9637), 1,
      anon_sym_LPAREN2,
    ACTIONS(9641), 1,
      anon_sym_requires,
    STATE(2113), 1,
      sym_template_type,
    STATE(6178), 1,
      sym_lambda_capture_specifier,
    STATE(6831), 1,
      sym__scope_resolution,
    ACTIONS(9639), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6062), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [234032] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9114), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9378), 1,
      sym_identifier,
    ACTIONS(9492), 1,
      anon_sym_requires,
    ACTIONS(9643), 1,
      anon_sym_LPAREN2,
    STATE(2844), 1,
      sym_template_type,
    STATE(6169), 1,
      sym_lambda_capture_specifier,
    STATE(6861), 1,
      sym__scope_resolution,
    ACTIONS(9645), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4027), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [234084] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(7431), 1,
      anon_sym_DASH_GT,
    ACTIONS(7433), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9057), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6602), 1,
      sym__function_attributes_end,
    STATE(6700), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9013), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
  [234140] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9189), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9354), 1,
      sym_identifier,
    ACTIONS(9484), 1,
      anon_sym_requires,
    ACTIONS(9647), 1,
      anon_sym_LPAREN2,
    STATE(2794), 1,
      sym_template_type,
    STATE(6157), 1,
      sym_lambda_capture_specifier,
    STATE(6836), 1,
      sym__scope_resolution,
    ACTIONS(9649), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3835), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [234192] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9374), 1,
      sym_identifier,
    ACTIONS(9637), 1,
      anon_sym_LPAREN2,
    ACTIONS(9641), 1,
      anon_sym_requires,
    STATE(2113), 1,
      sym_template_type,
    STATE(6178), 1,
      sym_lambda_capture_specifier,
    STATE(6831), 1,
      sym__scope_resolution,
    ACTIONS(9651), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6045), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [234244] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9114), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9378), 1,
      sym_identifier,
    ACTIONS(9492), 1,
      anon_sym_requires,
    ACTIONS(9643), 1,
      anon_sym_LPAREN2,
    STATE(2844), 1,
      sym_template_type,
    STATE(6169), 1,
      sym_lambda_capture_specifier,
    STATE(6861), 1,
      sym__scope_resolution,
    ACTIONS(9653), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3883), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [234296] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(7431), 1,
      anon_sym_DASH_GT,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9401), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9655), 1,
      anon_sym_requires,
    STATE(6589), 1,
      sym__function_attributes_end,
    STATE(6732), 1,
      sym_trailing_return_type,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9407), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
  [234352] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    ACTIONS(9637), 1,
      anon_sym_LPAREN2,
    ACTIONS(9641), 1,
      anon_sym_requires,
    STATE(2113), 1,
      sym_template_type,
    STATE(6178), 1,
      sym_lambda_capture_specifier,
    STATE(6845), 1,
      sym__scope_resolution,
    ACTIONS(9639), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6062), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [234404] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    ACTIONS(9637), 1,
      anon_sym_LPAREN2,
    ACTIONS(9641), 1,
      anon_sym_requires,
    STATE(2113), 1,
      sym_template_type,
    STATE(6178), 1,
      sym_lambda_capture_specifier,
    STATE(6845), 1,
      sym__scope_resolution,
    ACTIONS(9658), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6715), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [234456] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7437), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9350), 1,
      sym_identifier,
    ACTIONS(9449), 1,
      anon_sym_requires,
    ACTIONS(9545), 1,
      anon_sym_LPAREN2,
    STATE(2361), 1,
      sym_template_type,
    STATE(6195), 1,
      sym_lambda_capture_specifier,
    STATE(6832), 1,
      sym__scope_resolution,
    ACTIONS(9660), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6656), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [234508] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9345), 1,
      anon_sym_requires,
    STATE(6401), 1,
      sym_trailing_return_type,
    STATE(6654), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9102), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9106), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
  [234564] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9374), 1,
      sym_identifier,
    ACTIONS(9637), 1,
      anon_sym_LPAREN2,
    ACTIONS(9641), 1,
      anon_sym_requires,
    STATE(2113), 1,
      sym_template_type,
    STATE(6178), 1,
      sym_lambda_capture_specifier,
    STATE(6831), 1,
      sym__scope_resolution,
    ACTIONS(9662), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6117), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [234616] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    ACTIONS(9637), 1,
      anon_sym_LPAREN2,
    ACTIONS(9641), 1,
      anon_sym_requires,
    STATE(2113), 1,
      sym_template_type,
    STATE(6178), 1,
      sym_lambda_capture_specifier,
    STATE(6845), 1,
      sym__scope_resolution,
    ACTIONS(9664), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6696), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [234668] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(6990), 1,
      anon_sym_requires,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    STATE(6500), 1,
      sym_trailing_return_type,
    STATE(6619), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9013), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
  [234724] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7437), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9350), 1,
      sym_identifier,
    ACTIONS(9449), 1,
      anon_sym_requires,
    ACTIONS(9545), 1,
      anon_sym_LPAREN2,
    STATE(2361), 1,
      sym_template_type,
    STATE(6195), 1,
      sym_lambda_capture_specifier,
    STATE(6832), 1,
      sym__scope_resolution,
    ACTIONS(9549), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4892), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [234776] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9272), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9337), 1,
      sym_identifier,
    ACTIONS(9473), 1,
      anon_sym_requires,
    ACTIONS(9527), 1,
      anon_sym_LPAREN2,
    STATE(4418), 1,
      sym_template_type,
    STATE(6164), 1,
      sym_lambda_capture_specifier,
    STATE(6829), 1,
      sym__scope_resolution,
    ACTIONS(9666), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5212), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [234828] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9099), 1,
      anon_sym_requires,
    STATE(6412), 1,
      sym_trailing_return_type,
    STATE(6652), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9013), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9017), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
  [234884] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9189), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9354), 1,
      sym_identifier,
    ACTIONS(9484), 1,
      anon_sym_requires,
    ACTIONS(9647), 1,
      anon_sym_LPAREN2,
    STATE(2794), 1,
      sym_template_type,
    STATE(6157), 1,
      sym_lambda_capture_specifier,
    STATE(6836), 1,
      sym__scope_resolution,
    ACTIONS(9668), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3836), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [234936] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3552), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    ACTIONS(9555), 1,
      anon_sym_LPAREN2,
    ACTIONS(9561), 1,
      anon_sym_requires,
    STATE(2113), 1,
      sym_template_type,
    STATE(6221), 1,
      sym_lambda_capture_specifier,
    STATE(6810), 1,
      sym__scope_resolution,
    ACTIONS(9670), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6428), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [234988] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_DASH_GT,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9475), 1,
      anon_sym_requires,
    STATE(6398), 1,
      sym_trailing_return_type,
    STATE(6659), 1,
      sym__function_attributes_end,
    STATE(6979), 1,
      sym_gnu_asm_expression,
    ACTIONS(6631), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9388), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9392), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5938), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6145), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6399), 2,
      sym__function_postfix,
      sym_requires_clause,
  [235044] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9348), 1,
      sym_identifier,
    ACTIONS(9439), 1,
      anon_sym_requires,
    ACTIONS(9567), 1,
      anon_sym_LPAREN2,
    STATE(1851), 1,
      sym_template_type,
    STATE(6182), 1,
      sym_lambda_capture_specifier,
    STATE(6818), 1,
      sym__scope_resolution,
    ACTIONS(9672), 2,
      sym_true,
      sym_false,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6862), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [235096] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    ACTIONS(9364), 1,
      anon_sym_COLON_COLON,
    STATE(2113), 1,
      sym_template_type,
    STATE(2180), 1,
      sym__class_declaration_item,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3013), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [235155] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7708), 1,
      anon_sym_STAR,
    ACTIONS(7710), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7712), 1,
      anon_sym_AMP,
    STATE(2974), 1,
      sym_parameter_list,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6670), 1,
      sym__abstract_declarator,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8279), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [235200] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6275), 1,
      anon_sym_LBRACE,
    ACTIONS(9294), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9372), 1,
      sym_identifier,
    STATE(2848), 1,
      sym_template_type,
    STATE(3045), 1,
      sym_field_declaration_list,
    STATE(3293), 1,
      sym__class_declaration_item,
    STATE(6809), 1,
      sym__scope_resolution,
    STATE(7262), 1,
      sym_virtual_specifier,
    STATE(8011), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2630), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5807), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [235259] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2189), 1,
      sym__class_declaration_item,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2161), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [235318] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6372), 1,
      anon_sym_LBRACE,
    ACTIONS(9114), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9378), 1,
      sym_identifier,
    STATE(2844), 1,
      sym_template_type,
    STATE(3024), 1,
      sym_field_declaration_list,
    STATE(3331), 1,
      sym__class_declaration_item,
    STATE(6861), 1,
      sym__scope_resolution,
    STATE(7369), 1,
      sym_virtual_specifier,
    STATE(8162), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2692), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [235377] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8202), 1,
      anon_sym_LBRACE,
    ACTIONS(9374), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(4731), 1,
      sym_field_declaration_list,
    STATE(4968), 1,
      sym__class_declaration_item,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(7094), 1,
      sym_virtual_specifier,
    STATE(7830), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4467), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [235436] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9374), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2180), 1,
      sym__class_declaration_item,
    STATE(2890), 1,
      sym_field_declaration_list,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(7347), 1,
      sym_virtual_specifier,
    STATE(8099), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2645), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [235495] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8202), 1,
      anon_sym_LBRACE,
    ACTIONS(9374), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(4731), 1,
      sym_field_declaration_list,
    STATE(4778), 1,
      sym__class_declaration_item,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(7094), 1,
      sym_virtual_specifier,
    STATE(7830), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4467), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5858), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [235554] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8202), 1,
      anon_sym_LBRACE,
    ACTIONS(9374), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(4731), 1,
      sym_field_declaration_list,
    STATE(4810), 1,
      sym__class_declaration_item,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(7094), 1,
      sym_virtual_specifier,
    STATE(7830), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4467), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [235613] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9674), 1,
      sym_identifier,
    ACTIONS(9676), 1,
      anon_sym_RPAREN,
    ACTIONS(9678), 1,
      anon_sym_LPAREN2,
    ACTIONS(9680), 1,
      anon_sym_defined,
    ACTIONS(9686), 1,
      sym_number_literal,
    ACTIONS(9682), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9684), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9688), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5839), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [235656] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7404), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8224), 1,
      anon_sym_LBRACE,
    ACTIONS(9376), 1,
      sym_identifier,
    STATE(4532), 1,
      sym_template_type,
    STATE(5098), 1,
      sym_field_declaration_list,
    STATE(5182), 1,
      sym__class_declaration_item,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(7309), 1,
      sym_virtual_specifier,
    STATE(8090), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4500), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [235715] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9674), 1,
      sym_identifier,
    ACTIONS(9678), 1,
      anon_sym_LPAREN2,
    ACTIONS(9680), 1,
      anon_sym_defined,
    ACTIONS(9690), 1,
      anon_sym_RPAREN,
    ACTIONS(9692), 1,
      sym_number_literal,
    ACTIONS(9682), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9684), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9688), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5800), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [235758] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6603), 1,
      anon_sym_LBRACE,
    ACTIONS(9250), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9370), 1,
      sym_identifier,
    STATE(2986), 1,
      sym_template_type,
    STATE(3282), 1,
      sym_field_declaration_list,
    STATE(3621), 1,
      sym__class_declaration_item,
    STATE(6853), 1,
      sym__scope_resolution,
    STATE(7358), 1,
      sym_virtual_specifier,
    STATE(8063), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2781), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5804), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [235817] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8202), 1,
      anon_sym_LBRACE,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(4731), 1,
      sym_field_declaration_list,
    STATE(4968), 1,
      sym__class_declaration_item,
    STATE(6845), 1,
      sym__scope_resolution,
    STATE(7094), 1,
      sym_virtual_specifier,
    STATE(7830), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4467), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [235876] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9368), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(2057), 1,
      sym__class_declaration_item,
    STATE(5352), 1,
      sym_field_declaration_list,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(7193), 1,
      sym_virtual_specifier,
    STATE(7946), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4582), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5805), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [235935] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6603), 1,
      anon_sym_LBRACE,
    ACTIONS(9250), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9370), 1,
      sym_identifier,
    STATE(2986), 1,
      sym_template_type,
    STATE(3282), 1,
      sym_field_declaration_list,
    STATE(3627), 1,
      sym__class_declaration_item,
    STATE(6853), 1,
      sym__scope_resolution,
    STATE(7358), 1,
      sym_virtual_specifier,
    STATE(8063), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2781), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [235994] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9694), 1,
      anon_sym_COMMA,
    ACTIONS(9696), 1,
      anon_sym_RPAREN,
    ACTIONS(9702), 1,
      anon_sym_SLASH,
    ACTIONS(9704), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9706), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9708), 1,
      anon_sym_PIPE,
    ACTIONS(9710), 1,
      anon_sym_CARET,
    ACTIONS(9712), 1,
      anon_sym_AMP,
    STATE(7400), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(9698), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9700), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9714), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9716), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9718), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [236049] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2180), 1,
      sym__class_declaration_item,
    STATE(2890), 1,
      sym_field_declaration_list,
    STATE(6845), 1,
      sym__scope_resolution,
    STATE(7347), 1,
      sym_virtual_specifier,
    STATE(8099), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2645), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [236108] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9368), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(2096), 1,
      sym__class_declaration_item,
    STATE(5352), 1,
      sym_field_declaration_list,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(7193), 1,
      sym_virtual_specifier,
    STATE(7946), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4582), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [236167] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9694), 1,
      anon_sym_COMMA,
    ACTIONS(9702), 1,
      anon_sym_SLASH,
    ACTIONS(9704), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9706), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9708), 1,
      anon_sym_PIPE,
    ACTIONS(9710), 1,
      anon_sym_CARET,
    ACTIONS(9712), 1,
      anon_sym_AMP,
    ACTIONS(9722), 1,
      anon_sym_RPAREN,
    STATE(7496), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(9698), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9700), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9714), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9716), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9718), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [236222] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7404), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8224), 1,
      anon_sym_LBRACE,
    ACTIONS(9376), 1,
      sym_identifier,
    STATE(4532), 1,
      sym_template_type,
    STATE(5098), 1,
      sym_field_declaration_list,
    STATE(5277), 1,
      sym__class_declaration_item,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(7309), 1,
      sym_virtual_specifier,
    STATE(8090), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4500), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [236281] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7404), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8224), 1,
      anon_sym_LBRACE,
    ACTIONS(9376), 1,
      sym_identifier,
    STATE(4532), 1,
      sym_template_type,
    STATE(5098), 1,
      sym_field_declaration_list,
    STATE(5187), 1,
      sym__class_declaration_item,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(7309), 1,
      sym_virtual_specifier,
    STATE(8090), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4500), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5791), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [236340] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(131), 1,
      anon_sym_operator,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5004), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(9724), 1,
      sym_identifier,
    ACTIONS(9726), 1,
      anon_sym_template,
    STATE(2944), 1,
      sym_pointer_type_declarator,
    STATE(2948), 1,
      sym_operator_name,
    STATE(2978), 1,
      sym_template_function,
    STATE(2997), 1,
      sym_qualified_identifier,
    STATE(2998), 1,
      sym_dependent_identifier,
    STATE(3001), 1,
      sym_destructor_name,
    STATE(5803), 1,
      sym__scope_resolution,
    STATE(7328), 1,
      sym_operator_cast,
    STATE(7346), 1,
      sym_qualified_operator_cast_identifier,
    STATE(8639), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [236403] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6603), 1,
      anon_sym_LBRACE,
    ACTIONS(9250), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9370), 1,
      sym_identifier,
    STATE(2986), 1,
      sym_template_type,
    STATE(3282), 1,
      sym_field_declaration_list,
    STATE(3816), 1,
      sym__class_declaration_item,
    STATE(6853), 1,
      sym__scope_resolution,
    STATE(7358), 1,
      sym_virtual_specifier,
    STATE(8063), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2781), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [236462] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9368), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(2016), 1,
      sym__class_declaration_item,
    STATE(5352), 1,
      sym_field_declaration_list,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(7193), 1,
      sym_virtual_specifier,
    STATE(7946), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4582), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [236521] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6603), 1,
      anon_sym_LBRACE,
    ACTIONS(9250), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9370), 1,
      sym_identifier,
    STATE(2986), 1,
      sym_template_type,
    STATE(3282), 1,
      sym_field_declaration_list,
    STATE(3813), 1,
      sym__class_declaration_item,
    STATE(6853), 1,
      sym__scope_resolution,
    STATE(7358), 1,
      sym_virtual_specifier,
    STATE(8063), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2781), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5808), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [236580] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6275), 1,
      anon_sym_LBRACE,
    ACTIONS(9294), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9372), 1,
      sym_identifier,
    STATE(2848), 1,
      sym_template_type,
    STATE(3045), 1,
      sym_field_declaration_list,
    STATE(3255), 1,
      sym__class_declaration_item,
    STATE(6809), 1,
      sym__scope_resolution,
    STATE(7262), 1,
      sym_virtual_specifier,
    STATE(8011), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2630), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [236639] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6603), 1,
      anon_sym_LBRACE,
    ACTIONS(9250), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9370), 1,
      sym_identifier,
    STATE(2986), 1,
      sym_template_type,
    STATE(3282), 1,
      sym_field_declaration_list,
    STATE(3689), 1,
      sym__class_declaration_item,
    STATE(6853), 1,
      sym__scope_resolution,
    STATE(7358), 1,
      sym_virtual_specifier,
    STATE(8063), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2781), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [236698] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9374), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2201), 1,
      sym__class_declaration_item,
    STATE(2890), 1,
      sym_field_declaration_list,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(7347), 1,
      sym_virtual_specifier,
    STATE(8099), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2645), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5787), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [236757] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9374), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2209), 1,
      sym__class_declaration_item,
    STATE(2890), 1,
      sym_field_declaration_list,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(7347), 1,
      sym_virtual_specifier,
    STATE(8099), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2645), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [236816] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6275), 1,
      anon_sym_LBRACE,
    ACTIONS(9294), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9372), 1,
      sym_identifier,
    STATE(2848), 1,
      sym_template_type,
    STATE(3045), 1,
      sym_field_declaration_list,
    STATE(3249), 1,
      sym__class_declaration_item,
    STATE(6809), 1,
      sym__scope_resolution,
    STATE(7262), 1,
      sym_virtual_specifier,
    STATE(8011), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2630), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5812), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [236875] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6275), 1,
      anon_sym_LBRACE,
    ACTIONS(9294), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9372), 1,
      sym_identifier,
    STATE(2848), 1,
      sym_template_type,
    STATE(3045), 1,
      sym_field_declaration_list,
    STATE(3221), 1,
      sym__class_declaration_item,
    STATE(6809), 1,
      sym__scope_resolution,
    STATE(7262), 1,
      sym_virtual_specifier,
    STATE(8011), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2630), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [236934] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6179), 1,
      anon_sym_LBRACE,
    ACTIONS(9189), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9354), 1,
      sym_identifier,
    STATE(2794), 1,
      sym_template_type,
    STATE(3006), 1,
      sym_field_declaration_list,
    STATE(3178), 1,
      sym__class_declaration_item,
    STATE(6836), 1,
      sym__scope_resolution,
    STATE(7210), 1,
      sym_virtual_specifier,
    STATE(7996), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2548), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [236993] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9233), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9343), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(2096), 1,
      sym__class_declaration_item,
    STATE(2233), 1,
      sym_field_declaration_list,
    STATE(6864), 1,
      sym__scope_resolution,
    STATE(7158), 1,
      sym_virtual_specifier,
    STATE(7915), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2149), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [237052] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9348), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(2016), 1,
      sym__class_declaration_item,
    STATE(2233), 1,
      sym_field_declaration_list,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(7158), 1,
      sym_virtual_specifier,
    STATE(7915), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2149), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [237111] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9348), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(2057), 1,
      sym__class_declaration_item,
    STATE(2233), 1,
      sym_field_declaration_list,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(7158), 1,
      sym_virtual_specifier,
    STATE(7915), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2149), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5815), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [237170] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7404), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8224), 1,
      anon_sym_LBRACE,
    ACTIONS(9376), 1,
      sym_identifier,
    STATE(4532), 1,
      sym_template_type,
    STATE(5098), 1,
      sym_field_declaration_list,
    STATE(5308), 1,
      sym__class_declaration_item,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(7309), 1,
      sym_virtual_specifier,
    STATE(8090), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4500), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [237229] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2179), 1,
      sym__class_declaration_item,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2161), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5834), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [237288] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7404), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8224), 1,
      anon_sym_LBRACE,
    ACTIONS(9376), 1,
      sym_identifier,
    STATE(4532), 1,
      sym_template_type,
    STATE(5098), 1,
      sym_field_declaration_list,
    STATE(5242), 1,
      sym__class_declaration_item,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(7309), 1,
      sym_virtual_specifier,
    STATE(8090), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4500), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5801), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [237347] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9233), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9343), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(2016), 1,
      sym__class_declaration_item,
    STATE(2233), 1,
      sym_field_declaration_list,
    STATE(6864), 1,
      sym__scope_resolution,
    STATE(7158), 1,
      sym_virtual_specifier,
    STATE(7915), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2149), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [237406] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(5654), 1,
      anon_sym_LBRACE,
    ACTIONS(7437), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9350), 1,
      sym_identifier,
    STATE(2361), 1,
      sym_template_type,
    STATE(2454), 1,
      sym_field_declaration_list,
    STATE(2602), 1,
      sym__class_declaration_item,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(7226), 1,
      sym_virtual_specifier,
    STATE(8040), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2216), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5867), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [237465] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9348), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(1948), 1,
      sym__class_declaration_item,
    STATE(2233), 1,
      sym_field_declaration_list,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(7158), 1,
      sym_virtual_specifier,
    STATE(7915), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2149), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [237524] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6179), 1,
      anon_sym_LBRACE,
    ACTIONS(9189), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9354), 1,
      sym_identifier,
    STATE(2794), 1,
      sym_template_type,
    STATE(3006), 1,
      sym_field_declaration_list,
    STATE(3198), 1,
      sym__class_declaration_item,
    STATE(6836), 1,
      sym__scope_resolution,
    STATE(7210), 1,
      sym_virtual_specifier,
    STATE(7996), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2548), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5813), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [237583] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6179), 1,
      anon_sym_LBRACE,
    ACTIONS(9189), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9354), 1,
      sym_identifier,
    STATE(2794), 1,
      sym_template_type,
    STATE(3006), 1,
      sym_field_declaration_list,
    STATE(3201), 1,
      sym__class_declaration_item,
    STATE(6836), 1,
      sym__scope_resolution,
    STATE(7210), 1,
      sym_virtual_specifier,
    STATE(7996), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2548), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [237642] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9233), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9343), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(1942), 1,
      sym__class_declaration_item,
    STATE(2233), 1,
      sym_field_declaration_list,
    STATE(6864), 1,
      sym__scope_resolution,
    STATE(7158), 1,
      sym_virtual_specifier,
    STATE(7915), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2149), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5814), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [237701] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(5654), 1,
      anon_sym_LBRACE,
    ACTIONS(7437), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9350), 1,
      sym_identifier,
    STATE(2361), 1,
      sym_template_type,
    STATE(2454), 1,
      sym_field_declaration_list,
    STATE(2595), 1,
      sym__class_declaration_item,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(7226), 1,
      sym_virtual_specifier,
    STATE(8040), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2216), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [237760] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9348), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(1942), 1,
      sym__class_declaration_item,
    STATE(2233), 1,
      sym_field_declaration_list,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(7158), 1,
      sym_virtual_specifier,
    STATE(7915), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2149), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5837), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [237819] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7651), 1,
      anon_sym_LBRACE,
    ACTIONS(9211), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9366), 1,
      sym_identifier,
    STATE(4104), 1,
      sym_template_type,
    STATE(4278), 1,
      sym_field_declaration_list,
    STATE(4390), 1,
      sym__class_declaration_item,
    STATE(6855), 1,
      sym__scope_resolution,
    STATE(7207), 1,
      sym_virtual_specifier,
    STATE(7935), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3584), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [237878] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2180), 1,
      sym__class_declaration_item,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2161), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [237937] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9368), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(1948), 1,
      sym__class_declaration_item,
    STATE(5352), 1,
      sym_field_declaration_list,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(7193), 1,
      sym_virtual_specifier,
    STATE(7946), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4582), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [237996] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9368), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(1942), 1,
      sym__class_declaration_item,
    STATE(5352), 1,
      sym_field_declaration_list,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(7193), 1,
      sym_virtual_specifier,
    STATE(7946), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4582), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5799), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9730), 1,
      anon_sym_LBRACK,
    ACTIONS(9728), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [238084] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8202), 1,
      anon_sym_LBRACE,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(4731), 1,
      sym_field_declaration_list,
    STATE(4935), 1,
      sym__class_declaration_item,
    STATE(6845), 1,
      sym__scope_resolution,
    STATE(7094), 1,
      sym_virtual_specifier,
    STATE(7830), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4467), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5794), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238143] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2209), 1,
      sym__class_declaration_item,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2161), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238202] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    ACTIONS(9364), 1,
      anon_sym_COLON_COLON,
    STATE(2113), 1,
      sym_template_type,
    STATE(2209), 1,
      sym__class_declaration_item,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3013), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238261] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6275), 1,
      anon_sym_LBRACE,
    ACTIONS(9294), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9372), 1,
      sym_identifier,
    STATE(2848), 1,
      sym_template_type,
    STATE(3045), 1,
      sym_field_declaration_list,
    STATE(3290), 1,
      sym__class_declaration_item,
    STATE(6809), 1,
      sym__scope_resolution,
    STATE(7262), 1,
      sym_virtual_specifier,
    STATE(8011), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2630), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238320] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9348), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(2096), 1,
      sym__class_declaration_item,
    STATE(2233), 1,
      sym_field_declaration_list,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(7158), 1,
      sym_virtual_specifier,
    STATE(7915), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2149), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238379] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7651), 1,
      anon_sym_LBRACE,
    ACTIONS(9211), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9366), 1,
      sym_identifier,
    STATE(4104), 1,
      sym_template_type,
    STATE(4278), 1,
      sym_field_declaration_list,
    STATE(4429), 1,
      sym__class_declaration_item,
    STATE(6855), 1,
      sym__scope_resolution,
    STATE(7207), 1,
      sym_virtual_specifier,
    STATE(7935), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3584), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5828), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238438] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9694), 1,
      anon_sym_COMMA,
    ACTIONS(9702), 1,
      anon_sym_SLASH,
    ACTIONS(9704), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9706), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9708), 1,
      anon_sym_PIPE,
    ACTIONS(9710), 1,
      anon_sym_CARET,
    ACTIONS(9712), 1,
      anon_sym_AMP,
    ACTIONS(9732), 1,
      anon_sym_RPAREN,
    STATE(7737), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(9698), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9700), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9714), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9716), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9718), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [238493] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9233), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9343), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(1948), 1,
      sym__class_declaration_item,
    STATE(2233), 1,
      sym_field_declaration_list,
    STATE(6864), 1,
      sym__scope_resolution,
    STATE(7158), 1,
      sym_virtual_specifier,
    STATE(7915), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2149), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238552] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8202), 1,
      anon_sym_LBRACE,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(4731), 1,
      sym_field_declaration_list,
    STATE(4902), 1,
      sym__class_declaration_item,
    STATE(6845), 1,
      sym__scope_resolution,
    STATE(7094), 1,
      sym_virtual_specifier,
    STATE(7830), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4467), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238611] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6179), 1,
      anon_sym_LBRACE,
    ACTIONS(9189), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9354), 1,
      sym_identifier,
    STATE(2794), 1,
      sym_template_type,
    STATE(3006), 1,
      sym_field_declaration_list,
    STATE(3158), 1,
      sym__class_declaration_item,
    STATE(6836), 1,
      sym__scope_resolution,
    STATE(7210), 1,
      sym_virtual_specifier,
    STATE(7996), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2548), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238670] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9674), 1,
      sym_identifier,
    ACTIONS(9678), 1,
      anon_sym_LPAREN2,
    ACTIONS(9680), 1,
      anon_sym_defined,
    ACTIONS(9734), 1,
      anon_sym_RPAREN,
    ACTIONS(9736), 1,
      sym_number_literal,
    ACTIONS(9682), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9684), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9688), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5797), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [238713] = 5,
    ACTIONS(9531), 1,
      anon_sym_LF,
    ACTIONS(9738), 1,
      anon_sym_LPAREN2,
    ACTIONS(9740), 1,
      sym_comment,
    STATE(6033), 1,
      sym_preproc_argument_list,
    ACTIONS(9535), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [238746] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(8013), 1,
      anon_sym_LBRACE,
    ACTIONS(9272), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9337), 1,
      sym_identifier,
    STATE(4418), 1,
      sym_template_type,
    STATE(4537), 1,
      sym_field_declaration_list,
    STATE(4811), 1,
      sym__class_declaration_item,
    STATE(6829), 1,
      sym__scope_resolution,
    STATE(7261), 1,
      sym_virtual_specifier,
    STATE(8010), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4250), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5851), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238805] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9352), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2180), 1,
      sym__class_declaration_item,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(6858), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2161), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238864] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7651), 1,
      anon_sym_LBRACE,
    ACTIONS(9211), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9366), 1,
      sym_identifier,
    STATE(4104), 1,
      sym_template_type,
    STATE(4278), 1,
      sym_field_declaration_list,
    STATE(4408), 1,
      sym__class_declaration_item,
    STATE(6855), 1,
      sym__scope_resolution,
    STATE(7207), 1,
      sym_virtual_specifier,
    STATE(7935), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3584), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238923] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5548), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9380), 1,
      sym_identifier,
    STATE(2280), 1,
      sym_template_type,
    STATE(2335), 1,
      sym_field_declaration_list,
    STATE(2406), 1,
      sym__class_declaration_item,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(7212), 1,
      sym_virtual_specifier,
    STATE(7999), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2158), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5872), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238982] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5548), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9380), 1,
      sym_identifier,
    STATE(2280), 1,
      sym_template_type,
    STATE(2335), 1,
      sym_field_declaration_list,
    STATE(2402), 1,
      sym__class_declaration_item,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(7212), 1,
      sym_virtual_specifier,
    STATE(7999), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2158), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239041] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(8013), 1,
      anon_sym_LBRACE,
    ACTIONS(9272), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9337), 1,
      sym_identifier,
    STATE(4418), 1,
      sym_template_type,
    STATE(4537), 1,
      sym_field_declaration_list,
    STATE(4816), 1,
      sym__class_declaration_item,
    STATE(6829), 1,
      sym__scope_resolution,
    STATE(7261), 1,
      sym_virtual_specifier,
    STATE(8010), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4250), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239100] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(8013), 1,
      anon_sym_LBRACE,
    ACTIONS(9272), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9337), 1,
      sym_identifier,
    STATE(4418), 1,
      sym_template_type,
    STATE(4537), 1,
      sym_field_declaration_list,
    STATE(4847), 1,
      sym__class_declaration_item,
    STATE(6829), 1,
      sym__scope_resolution,
    STATE(7261), 1,
      sym_virtual_specifier,
    STATE(8010), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4250), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239159] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(8013), 1,
      anon_sym_LBRACE,
    ACTIONS(9272), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9337), 1,
      sym_identifier,
    STATE(4418), 1,
      sym_template_type,
    STATE(4537), 1,
      sym_field_declaration_list,
    STATE(4852), 1,
      sym__class_declaration_item,
    STATE(6829), 1,
      sym__scope_resolution,
    STATE(7261), 1,
      sym_virtual_specifier,
    STATE(8010), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4250), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5856), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239218] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9374), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2189), 1,
      sym__class_declaration_item,
    STATE(2890), 1,
      sym_field_declaration_list,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(7347), 1,
      sym_virtual_specifier,
    STATE(8099), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2645), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239277] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    ACTIONS(9364), 1,
      anon_sym_COLON_COLON,
    STATE(2113), 1,
      sym_template_type,
    STATE(2201), 1,
      sym__class_declaration_item,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3013), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5781), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239336] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9374), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2179), 1,
      sym__class_declaration_item,
    STATE(2890), 1,
      sym_field_declaration_list,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(7347), 1,
      sym_virtual_specifier,
    STATE(8099), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2645), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5810), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239395] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(8013), 1,
      anon_sym_LBRACE,
    ACTIONS(9272), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9337), 1,
      sym_identifier,
    STATE(4418), 1,
      sym_template_type,
    STATE(4537), 1,
      sym_field_declaration_list,
    STATE(4876), 1,
      sym__class_declaration_item,
    STATE(6829), 1,
      sym__scope_resolution,
    STATE(7261), 1,
      sym_virtual_specifier,
    STATE(8010), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4250), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239454] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8202), 1,
      anon_sym_LBRACE,
    ACTIONS(9374), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(4731), 1,
      sym_field_declaration_list,
    STATE(4935), 1,
      sym__class_declaration_item,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(7094), 1,
      sym_virtual_specifier,
    STATE(7830), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4467), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5786), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239513] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8202), 1,
      anon_sym_LBRACE,
    ACTIONS(9374), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(4731), 1,
      sym_field_declaration_list,
    STATE(4902), 1,
      sym__class_declaration_item,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(7094), 1,
      sym_virtual_specifier,
    STATE(7830), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4467), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239572] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9352), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2189), 1,
      sym__class_declaration_item,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(6858), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2161), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239631] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2189), 1,
      sym__class_declaration_item,
    STATE(2890), 1,
      sym_field_declaration_list,
    STATE(6845), 1,
      sym__scope_resolution,
    STATE(7347), 1,
      sym_virtual_specifier,
    STATE(8099), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2645), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239690] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7651), 1,
      anon_sym_LBRACE,
    ACTIONS(9211), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9366), 1,
      sym_identifier,
    STATE(4104), 1,
      sym_template_type,
    STATE(4278), 1,
      sym_field_declaration_list,
    STATE(4404), 1,
      sym__class_declaration_item,
    STATE(6855), 1,
      sym__scope_resolution,
    STATE(7207), 1,
      sym_virtual_specifier,
    STATE(7935), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3584), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239749] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9352), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2201), 1,
      sym__class_declaration_item,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(6858), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2161), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5846), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239808] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(5654), 1,
      anon_sym_LBRACE,
    ACTIONS(9316), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9341), 1,
      sym_identifier,
    STATE(2361), 1,
      sym_template_type,
    STATE(2454), 1,
      sym_field_declaration_list,
    STATE(2560), 1,
      sym__class_declaration_item,
    STATE(6846), 1,
      sym__scope_resolution,
    STATE(7226), 1,
      sym_virtual_specifier,
    STATE(8040), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2216), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239867] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7651), 1,
      anon_sym_LBRACE,
    ACTIONS(9211), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9366), 1,
      sym_identifier,
    STATE(4104), 1,
      sym_template_type,
    STATE(4278), 1,
      sym_field_declaration_list,
    STATE(4363), 1,
      sym__class_declaration_item,
    STATE(6855), 1,
      sym__scope_resolution,
    STATE(7207), 1,
      sym_virtual_specifier,
    STATE(7935), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3584), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5847), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239926] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2201), 1,
      sym__class_declaration_item,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2161), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5829), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239985] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2179), 1,
      sym__class_declaration_item,
    STATE(2890), 1,
      sym_field_declaration_list,
    STATE(6845), 1,
      sym__scope_resolution,
    STATE(7347), 1,
      sym_virtual_specifier,
    STATE(8099), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2645), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5884), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [240044] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(5654), 1,
      anon_sym_LBRACE,
    ACTIONS(7437), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9350), 1,
      sym_identifier,
    STATE(2361), 1,
      sym_template_type,
    STATE(2454), 1,
      sym_field_declaration_list,
    STATE(2576), 1,
      sym__class_declaration_item,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(7226), 1,
      sym_virtual_specifier,
    STATE(8040), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2216), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [240103] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(5654), 1,
      anon_sym_LBRACE,
    ACTIONS(7437), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9350), 1,
      sym_identifier,
    STATE(2361), 1,
      sym_template_type,
    STATE(2454), 1,
      sym_field_declaration_list,
    STATE(2569), 1,
      sym__class_declaration_item,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(7226), 1,
      sym_virtual_specifier,
    STATE(8040), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2216), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5870), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [240162] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9352), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2179), 1,
      sym__class_declaration_item,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(6858), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2161), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5882), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [240221] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(5654), 1,
      anon_sym_LBRACE,
    ACTIONS(7437), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9350), 1,
      sym_identifier,
    STATE(2361), 1,
      sym_template_type,
    STATE(2454), 1,
      sym_field_declaration_list,
    STATE(2560), 1,
      sym__class_declaration_item,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(7226), 1,
      sym_virtual_specifier,
    STATE(8040), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2216), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [240280] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    ACTIONS(9364), 1,
      anon_sym_COLON_COLON,
    STATE(2113), 1,
      sym_template_type,
    STATE(2179), 1,
      sym__class_declaration_item,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3013), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5835), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [240339] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5548), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9380), 1,
      sym_identifier,
    STATE(2280), 1,
      sym_template_type,
    STATE(2335), 1,
      sym_field_declaration_list,
    STATE(2422), 1,
      sym__class_declaration_item,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(7212), 1,
      sym_virtual_specifier,
    STATE(7999), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2158), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [240398] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5548), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9380), 1,
      sym_identifier,
    STATE(2280), 1,
      sym_template_type,
    STATE(2335), 1,
      sym_field_declaration_list,
    STATE(2440), 1,
      sym__class_declaration_item,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(7212), 1,
      sym_virtual_specifier,
    STATE(7999), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2158), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5881), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [240457] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9339), 1,
      sym_identifier,
    ACTIONS(9364), 1,
      anon_sym_COLON_COLON,
    STATE(2113), 1,
      sym_template_type,
    STATE(2189), 1,
      sym__class_declaration_item,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3013), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [240516] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(5654), 1,
      anon_sym_LBRACE,
    ACTIONS(9316), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9341), 1,
      sym_identifier,
    STATE(2361), 1,
      sym_template_type,
    STATE(2454), 1,
      sym_field_declaration_list,
    STATE(2569), 1,
      sym__class_declaration_item,
    STATE(6846), 1,
      sym__scope_resolution,
    STATE(7226), 1,
      sym_virtual_specifier,
    STATE(8040), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2216), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5863), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [240575] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6179), 1,
      anon_sym_LBRACE,
    ACTIONS(9189), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9354), 1,
      sym_identifier,
    STATE(2794), 1,
      sym_template_type,
    STATE(3006), 1,
      sym_field_declaration_list,
    STATE(3155), 1,
      sym__class_declaration_item,
    STATE(6836), 1,
      sym__scope_resolution,
    STATE(7210), 1,
      sym_virtual_specifier,
    STATE(7996), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2548), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5824), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [240634] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8202), 1,
      anon_sym_LBRACE,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(4731), 1,
      sym_field_declaration_list,
    STATE(4778), 1,
      sym__class_declaration_item,
    STATE(6845), 1,
      sym__scope_resolution,
    STATE(7094), 1,
      sym_virtual_specifier,
    STATE(7830), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4467), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5841), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [240693] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8202), 1,
      anon_sym_LBRACE,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(4731), 1,
      sym_field_declaration_list,
    STATE(4810), 1,
      sym__class_declaration_item,
    STATE(6845), 1,
      sym__scope_resolution,
    STATE(7094), 1,
      sym_virtual_specifier,
    STATE(7830), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4467), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [240752] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2201), 1,
      sym__class_declaration_item,
    STATE(2890), 1,
      sym_field_declaration_list,
    STATE(6845), 1,
      sym__scope_resolution,
    STATE(7347), 1,
      sym_virtual_specifier,
    STATE(8099), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2645), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5798), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [240811] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6372), 1,
      anon_sym_LBRACE,
    ACTIONS(9114), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9378), 1,
      sym_identifier,
    STATE(2844), 1,
      sym_template_type,
    STATE(3024), 1,
      sym_field_declaration_list,
    STATE(3407), 1,
      sym__class_declaration_item,
    STATE(6861), 1,
      sym__scope_resolution,
    STATE(7369), 1,
      sym_virtual_specifier,
    STATE(8162), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2692), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5887), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [240870] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5548), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9380), 1,
      sym_identifier,
    STATE(2280), 1,
      sym_template_type,
    STATE(2335), 1,
      sym_field_declaration_list,
    STATE(2421), 1,
      sym__class_declaration_item,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(7212), 1,
      sym_virtual_specifier,
    STATE(7999), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2158), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [240929] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9352), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2209), 1,
      sym__class_declaration_item,
    STATE(2484), 1,
      sym_field_declaration_list,
    STATE(6858), 1,
      sym__scope_resolution,
    STATE(7348), 1,
      sym_virtual_specifier,
    STATE(7997), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2161), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [240988] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(5654), 1,
      anon_sym_LBRACE,
    ACTIONS(9316), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9341), 1,
      sym_identifier,
    STATE(2361), 1,
      sym_template_type,
    STATE(2454), 1,
      sym_field_declaration_list,
    STATE(2576), 1,
      sym__class_declaration_item,
    STATE(6846), 1,
      sym__scope_resolution,
    STATE(7226), 1,
      sym_virtual_specifier,
    STATE(8040), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2216), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [241047] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2209), 1,
      sym__class_declaration_item,
    STATE(2890), 1,
      sym_field_declaration_list,
    STATE(6845), 1,
      sym__scope_resolution,
    STATE(7347), 1,
      sym_virtual_specifier,
    STATE(8099), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2645), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [241106] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(5654), 1,
      anon_sym_LBRACE,
    ACTIONS(9316), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9341), 1,
      sym_identifier,
    STATE(2361), 1,
      sym_template_type,
    STATE(2454), 1,
      sym_field_declaration_list,
    STATE(2595), 1,
      sym__class_declaration_item,
    STATE(6846), 1,
      sym__scope_resolution,
    STATE(7226), 1,
      sym_virtual_specifier,
    STATE(8040), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2216), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [241165] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6372), 1,
      anon_sym_LBRACE,
    ACTIONS(9114), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9378), 1,
      sym_identifier,
    STATE(2844), 1,
      sym_template_type,
    STATE(3024), 1,
      sym_field_declaration_list,
    STATE(3212), 1,
      sym__class_declaration_item,
    STATE(6861), 1,
      sym__scope_resolution,
    STATE(7369), 1,
      sym_virtual_specifier,
    STATE(8162), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2692), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [241224] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6372), 1,
      anon_sym_LBRACE,
    ACTIONS(9114), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9378), 1,
      sym_identifier,
    STATE(2844), 1,
      sym_template_type,
    STATE(3024), 1,
      sym_field_declaration_list,
    STATE(3352), 1,
      sym__class_declaration_item,
    STATE(6861), 1,
      sym__scope_resolution,
    STATE(7369), 1,
      sym_virtual_specifier,
    STATE(8162), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2692), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [241283] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(6372), 1,
      anon_sym_LBRACE,
    ACTIONS(9114), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9378), 1,
      sym_identifier,
    STATE(2844), 1,
      sym_template_type,
    STATE(3024), 1,
      sym_field_declaration_list,
    STATE(3348), 1,
      sym__class_declaration_item,
    STATE(6861), 1,
      sym__scope_resolution,
    STATE(7369), 1,
      sym_virtual_specifier,
    STATE(8162), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2692), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5785), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [241342] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(5654), 1,
      anon_sym_LBRACE,
    ACTIONS(9316), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9341), 1,
      sym_identifier,
    STATE(2361), 1,
      sym_template_type,
    STATE(2454), 1,
      sym_field_declaration_list,
    STATE(2602), 1,
      sym__class_declaration_item,
    STATE(6846), 1,
      sym__scope_resolution,
    STATE(7226), 1,
      sym_virtual_specifier,
    STATE(8040), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2216), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5883), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [241401] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_COLON,
    ACTIONS(9233), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9343), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(2057), 1,
      sym__class_declaration_item,
    STATE(2233), 1,
      sym_field_declaration_list,
    STATE(6864), 1,
      sym__scope_resolution,
    STATE(7158), 1,
      sym_virtual_specifier,
    STATE(7915), 1,
      sym_base_class_clause,
    ACTIONS(5550), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2149), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5820), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [241460] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7893), 1,
      anon_sym_STAR,
    ACTIONS(9742), 1,
      sym_identifier,
    ACTIONS(9744), 1,
      anon_sym_TILDE,
    ACTIONS(9746), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9748), 1,
      anon_sym_template,
    ACTIONS(9750), 1,
      anon_sym_operator,
    STATE(2104), 1,
      sym_template_type,
    STATE(2112), 1,
      sym_dependent_type_identifier,
    STATE(2125), 1,
      sym_qualified_type_identifier,
    STATE(2668), 1,
      sym_pointer_type_declarator,
    STATE(2670), 1,
      sym_template_function,
    STATE(2672), 1,
      sym_destructor_name,
    STATE(2673), 1,
      sym_dependent_identifier,
    STATE(2674), 1,
      sym_qualified_identifier,
    STATE(2678), 1,
      sym_operator_name,
    STATE(5891), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
    STATE(8989), 1,
      sym_ms_based_modifier,
  [241524] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9525), 1,
      anon_sym_try,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(9754), 1,
      anon_sym_LPAREN2,
    ACTIONS(9756), 1,
      anon_sym_SEMI,
    ACTIONS(9758), 1,
      anon_sym_LBRACE,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(9762), 1,
      anon_sym_EQ,
    STATE(1928), 1,
      sym_compound_statement,
    STATE(1929), 1,
      sym_try_statement,
    STATE(2913), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(7492), 1,
      aux_sym_declaration_repeat1,
    STATE(7494), 1,
      sym_gnu_asm_expression,
    ACTIONS(9764), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8091), 2,
      sym_argument_list,
      sym_initializer_list,
  [241582] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9766), 1,
      sym_identifier,
    ACTIONS(9768), 1,
      anon_sym_LPAREN2,
    ACTIONS(9770), 1,
      anon_sym_defined,
    ACTIONS(9776), 1,
      sym_number_literal,
    ACTIONS(9772), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9778), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6050), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [241622] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym___attribute__,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(7989), 1,
      anon_sym_LPAREN2,
    ACTIONS(7997), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_STAR,
    ACTIONS(8001), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8003), 1,
      anon_sym_AMP,
    ACTIONS(9780), 1,
      anon_sym_SEMI,
    STATE(5712), 1,
      sym__field_declarator,
    STATE(6635), 1,
      sym_operator_name,
    STATE(8393), 1,
      sym_attribute_specifier,
    STATE(8417), 1,
      sym_ms_based_modifier,
    STATE(6748), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [241674] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9766), 1,
      sym_identifier,
    ACTIONS(9768), 1,
      anon_sym_LPAREN2,
    ACTIONS(9770), 1,
      anon_sym_defined,
    ACTIONS(9782), 1,
      sym_number_literal,
    ACTIONS(9772), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9778), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6078), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [241714] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7893), 1,
      anon_sym_STAR,
    ACTIONS(9744), 1,
      anon_sym_TILDE,
    ACTIONS(9750), 1,
      anon_sym_operator,
    ACTIONS(9784), 1,
      sym_identifier,
    ACTIONS(9786), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9788), 1,
      anon_sym_template,
    STATE(2104), 1,
      sym_template_type,
    STATE(2112), 1,
      sym_dependent_type_identifier,
    STATE(2125), 1,
      sym_qualified_type_identifier,
    STATE(2668), 1,
      sym_pointer_type_declarator,
    STATE(2670), 1,
      sym_template_function,
    STATE(2672), 1,
      sym_destructor_name,
    STATE(2673), 1,
      sym_dependent_identifier,
    STATE(2674), 1,
      sym_qualified_identifier,
    STATE(2678), 1,
      sym_operator_name,
    STATE(5896), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
    STATE(8989), 1,
      sym_ms_based_modifier,
  [241778] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6776), 1,
      sym__type_declarator,
    STATE(7106), 1,
      sym__type_definition_declarators,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [241828] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9766), 1,
      sym_identifier,
    ACTIONS(9768), 1,
      anon_sym_LPAREN2,
    ACTIONS(9770), 1,
      anon_sym_defined,
    ACTIONS(9790), 1,
      sym_number_literal,
    ACTIONS(9772), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9778), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6124), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [241868] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9674), 1,
      sym_identifier,
    ACTIONS(9678), 1,
      anon_sym_LPAREN2,
    ACTIONS(9680), 1,
      anon_sym_defined,
    ACTIONS(9792), 1,
      sym_number_literal,
    ACTIONS(9682), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9684), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9688), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6126), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [241908] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6776), 1,
      sym__type_declarator,
    STATE(7253), 1,
      sym__type_definition_declarators,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [241958] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9766), 1,
      sym_identifier,
    ACTIONS(9768), 1,
      anon_sym_LPAREN2,
    ACTIONS(9770), 1,
      anon_sym_defined,
    ACTIONS(9794), 1,
      sym_number_literal,
    ACTIONS(9772), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9778), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5998), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [241998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9798), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9796), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [242026] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9766), 1,
      sym_identifier,
    ACTIONS(9768), 1,
      anon_sym_LPAREN2,
    ACTIONS(9770), 1,
      anon_sym_defined,
    ACTIONS(9800), 1,
      sym_number_literal,
    ACTIONS(9772), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9778), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5999), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [242066] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9766), 1,
      sym_identifier,
    ACTIONS(9768), 1,
      anon_sym_LPAREN2,
    ACTIONS(9770), 1,
      anon_sym_defined,
    ACTIONS(9802), 1,
      sym_number_literal,
    ACTIONS(9772), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9778), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6000), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [242106] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7913), 1,
      anon_sym_STAR,
    ACTIONS(9804), 1,
      sym_identifier,
    ACTIONS(9806), 1,
      anon_sym_TILDE,
    ACTIONS(9808), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9810), 1,
      anon_sym_template,
    ACTIONS(9812), 1,
      anon_sym_operator,
    STATE(2104), 1,
      sym_template_type,
    STATE(2112), 1,
      sym_dependent_type_identifier,
    STATE(2125), 1,
      sym_qualified_type_identifier,
    STATE(3659), 1,
      sym_pointer_type_declarator,
    STATE(3744), 1,
      sym_operator_name,
    STATE(3750), 1,
      sym_qualified_identifier,
    STATE(3753), 1,
      sym_dependent_identifier,
    STATE(3758), 1,
      sym_destructor_name,
    STATE(3777), 1,
      sym_template_function,
    STATE(5905), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
    STATE(8790), 1,
      sym_ms_based_modifier,
  [242170] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6776), 1,
      sym__type_declarator,
    STATE(7099), 1,
      sym__type_definition_declarators,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [242220] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9766), 1,
      sym_identifier,
    ACTIONS(9768), 1,
      anon_sym_LPAREN2,
    ACTIONS(9770), 1,
      anon_sym_defined,
    ACTIONS(9814), 1,
      sym_number_literal,
    ACTIONS(9772), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9778), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6071), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [242260] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9766), 1,
      sym_identifier,
    ACTIONS(9768), 1,
      anon_sym_LPAREN2,
    ACTIONS(9770), 1,
      anon_sym_defined,
    ACTIONS(9816), 1,
      sym_number_literal,
    ACTIONS(9772), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9778), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6012), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [242300] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9766), 1,
      sym_identifier,
    ACTIONS(9768), 1,
      anon_sym_LPAREN2,
    ACTIONS(9770), 1,
      anon_sym_defined,
    ACTIONS(9818), 1,
      sym_number_literal,
    ACTIONS(9772), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9778), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6115), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [242340] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7875), 1,
      anon_sym_STAR,
    ACTIONS(9820), 1,
      sym_identifier,
    ACTIONS(9822), 1,
      anon_sym_TILDE,
    ACTIONS(9824), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9826), 1,
      anon_sym_template,
    ACTIONS(9828), 1,
      anon_sym_operator,
    STATE(2338), 1,
      sym_template_type,
    STATE(2339), 1,
      sym_dependent_type_identifier,
    STATE(2385), 1,
      sym_qualified_type_identifier,
    STATE(3995), 1,
      sym_operator_name,
    STATE(4000), 1,
      sym_qualified_identifier,
    STATE(4002), 1,
      sym_dependent_identifier,
    STATE(4003), 1,
      sym_destructor_name,
    STATE(4004), 1,
      sym_template_function,
    STATE(4005), 1,
      sym_pointer_type_declarator,
    STATE(5910), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
    STATE(8717), 1,
      sym_ms_based_modifier,
  [242404] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(9754), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(9762), 1,
      anon_sym_EQ,
    ACTIONS(9830), 1,
      anon_sym_SEMI,
    ACTIONS(9832), 1,
      anon_sym_LBRACE,
    ACTIONS(9834), 1,
      anon_sym_try,
    STATE(219), 1,
      sym_compound_statement,
    STATE(220), 1,
      sym_try_statement,
    STATE(2913), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(7663), 1,
      aux_sym_declaration_repeat1,
    STATE(7665), 1,
      sym_gnu_asm_expression,
    ACTIONS(9764), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8091), 2,
      sym_argument_list,
      sym_initializer_list,
  [242462] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9766), 1,
      sym_identifier,
    ACTIONS(9768), 1,
      anon_sym_LPAREN2,
    ACTIONS(9770), 1,
      anon_sym_defined,
    ACTIONS(9836), 1,
      sym_number_literal,
    ACTIONS(9772), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9778), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6014), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [242502] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9766), 1,
      sym_identifier,
    ACTIONS(9768), 1,
      anon_sym_LPAREN2,
    ACTIONS(9770), 1,
      anon_sym_defined,
    ACTIONS(9838), 1,
      sym_number_literal,
    ACTIONS(9772), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9778), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6015), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [242542] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7893), 1,
      anon_sym_STAR,
    ACTIONS(9744), 1,
      anon_sym_TILDE,
    ACTIONS(9750), 1,
      anon_sym_operator,
    ACTIONS(9840), 1,
      sym_identifier,
    ACTIONS(9842), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9844), 1,
      anon_sym_template,
    STATE(1849), 1,
      sym_dependent_type_identifier,
    STATE(1853), 1,
      sym_template_type,
    STATE(1972), 1,
      sym_qualified_type_identifier,
    STATE(2668), 1,
      sym_pointer_type_declarator,
    STATE(2670), 1,
      sym_template_function,
    STATE(2672), 1,
      sym_destructor_name,
    STATE(2673), 1,
      sym_dependent_identifier,
    STATE(2674), 1,
      sym_qualified_identifier,
    STATE(2678), 1,
      sym_operator_name,
    STATE(5914), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
    STATE(8989), 1,
      sym_ms_based_modifier,
  [242606] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7893), 1,
      anon_sym_STAR,
    ACTIONS(9629), 1,
      anon_sym_TILDE,
    ACTIONS(9846), 1,
      sym_identifier,
    ACTIONS(9848), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9850), 1,
      anon_sym_template,
    ACTIONS(9852), 1,
      anon_sym_operator,
    STATE(2104), 1,
      sym_template_type,
    STATE(2112), 1,
      sym_dependent_type_identifier,
    STATE(2125), 1,
      sym_qualified_type_identifier,
    STATE(2944), 1,
      sym_pointer_type_declarator,
    STATE(2948), 1,
      sym_operator_name,
    STATE(2978), 1,
      sym_template_function,
    STATE(2997), 1,
      sym_qualified_identifier,
    STATE(2998), 1,
      sym_dependent_identifier,
    STATE(3001), 1,
      sym_destructor_name,
    STATE(5915), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
    STATE(8989), 1,
      sym_ms_based_modifier,
  [242670] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9766), 1,
      sym_identifier,
    ACTIONS(9768), 1,
      anon_sym_LPAREN2,
    ACTIONS(9770), 1,
      anon_sym_defined,
    ACTIONS(9854), 1,
      sym_number_literal,
    ACTIONS(9772), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9778), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6079), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [242710] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9509), 1,
      anon_sym_try,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(9754), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(9762), 1,
      anon_sym_EQ,
    ACTIONS(9856), 1,
      anon_sym_SEMI,
    ACTIONS(9858), 1,
      anon_sym_LBRACE,
    STATE(2023), 1,
      sym_compound_statement,
    STATE(2025), 1,
      sym_try_statement,
    STATE(2913), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(7588), 1,
      sym_gnu_asm_expression,
    STATE(7590), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(9764), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8091), 2,
      sym_argument_list,
      sym_initializer_list,
  [242768] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9766), 1,
      sym_identifier,
    ACTIONS(9768), 1,
      anon_sym_LPAREN2,
    ACTIONS(9770), 1,
      anon_sym_defined,
    ACTIONS(9860), 1,
      sym_number_literal,
    ACTIONS(9772), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9778), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6016), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [242808] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6776), 1,
      sym__type_declarator,
    STATE(7336), 1,
      sym__type_definition_declarators,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [242858] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6776), 1,
      sym__type_declarator,
    STATE(7131), 1,
      sym__type_definition_declarators,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [242908] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9766), 1,
      sym_identifier,
    ACTIONS(9768), 1,
      anon_sym_LPAREN2,
    ACTIONS(9770), 1,
      anon_sym_defined,
    ACTIONS(9862), 1,
      sym_number_literal,
    ACTIONS(9772), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9778), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6017), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [242948] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6776), 1,
      sym__type_declarator,
    STATE(7155), 1,
      sym__type_definition_declarators,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [242998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9866), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9864), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [243026] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9766), 1,
      sym_identifier,
    ACTIONS(9768), 1,
      anon_sym_LPAREN2,
    ACTIONS(9770), 1,
      anon_sym_defined,
    ACTIONS(9868), 1,
      sym_number_literal,
    ACTIONS(9772), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9778), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6004), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [243066] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9766), 1,
      sym_identifier,
    ACTIONS(9768), 1,
      anon_sym_LPAREN2,
    ACTIONS(9770), 1,
      anon_sym_defined,
    ACTIONS(9870), 1,
      sym_number_literal,
    ACTIONS(9772), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9778), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6021), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [243106] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9766), 1,
      sym_identifier,
    ACTIONS(9768), 1,
      anon_sym_LPAREN2,
    ACTIONS(9770), 1,
      anon_sym_defined,
    ACTIONS(9872), 1,
      sym_number_literal,
    ACTIONS(9772), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9778), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6123), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [243146] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9674), 1,
      sym_identifier,
    ACTIONS(9678), 1,
      anon_sym_LPAREN2,
    ACTIONS(9680), 1,
      anon_sym_defined,
    ACTIONS(9874), 1,
      sym_number_literal,
    ACTIONS(9682), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9684), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9688), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5957), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [243186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9878), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9876), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [243214] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6776), 1,
      sym__type_declarator,
    STATE(7353), 1,
      sym__type_definition_declarators,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [243264] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6776), 1,
      sym__type_declarator,
    STATE(7317), 1,
      sym__type_definition_declarators,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [243314] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6776), 1,
      sym__type_declarator,
    STATE(7281), 1,
      sym__type_definition_declarators,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [243364] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(7796), 1,
      anon_sym_STAR,
    ACTIONS(7798), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7800), 1,
      anon_sym_AMP,
    STATE(2941), 1,
      sym_parameter_list,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6701), 1,
      sym__abstract_declarator,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8279), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [243408] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6776), 1,
      sym__type_declarator,
    STATE(7255), 1,
      sym__type_definition_declarators,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [243458] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7913), 1,
      anon_sym_STAR,
    ACTIONS(9806), 1,
      anon_sym_TILDE,
    ACTIONS(9812), 1,
      anon_sym_operator,
    ACTIONS(9880), 1,
      sym_identifier,
    ACTIONS(9882), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9884), 1,
      anon_sym_template,
    STATE(2104), 1,
      sym_template_type,
    STATE(2112), 1,
      sym_dependent_type_identifier,
    STATE(2125), 1,
      sym_qualified_type_identifier,
    STATE(3659), 1,
      sym_pointer_type_declarator,
    STATE(3744), 1,
      sym_operator_name,
    STATE(3750), 1,
      sym_qualified_identifier,
    STATE(3753), 1,
      sym_dependent_identifier,
    STATE(3758), 1,
      sym_destructor_name,
    STATE(3777), 1,
      sym_template_function,
    STATE(5934), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
    STATE(8790), 1,
      sym_ms_based_modifier,
  [243522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6981), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6983), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [243550] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7927), 1,
      anon_sym_STAR,
    ACTIONS(9886), 1,
      sym_identifier,
    ACTIONS(9888), 1,
      anon_sym_TILDE,
    ACTIONS(9890), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9892), 1,
      anon_sym_template,
    ACTIONS(9894), 1,
      anon_sym_operator,
    STATE(2104), 1,
      sym_template_type,
    STATE(2112), 1,
      sym_dependent_type_identifier,
    STATE(2125), 1,
      sym_qualified_type_identifier,
    STATE(3981), 1,
      sym_pointer_type_declarator,
    STATE(3983), 1,
      sym_template_function,
    STATE(3984), 1,
      sym_destructor_name,
    STATE(3985), 1,
      sym_dependent_identifier,
    STATE(3987), 1,
      sym_qualified_identifier,
    STATE(3989), 1,
      sym_operator_name,
    STATE(5936), 1,
      sym__scope_resolution,
    STATE(8279), 1,
      sym_ms_based_modifier,
    STATE(8628), 1,
      sym_decltype,
  [243614] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(9754), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(9762), 1,
      anon_sym_EQ,
    ACTIONS(9896), 1,
      anon_sym_SEMI,
    ACTIONS(9898), 1,
      anon_sym_LBRACE,
    ACTIONS(9900), 1,
      anon_sym_try,
    STATE(466), 1,
      sym_try_statement,
    STATE(471), 1,
      sym_compound_statement,
    STATE(2913), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(7390), 1,
      aux_sym_declaration_repeat1,
    STATE(7391), 1,
      sym_gnu_asm_expression,
    ACTIONS(9764), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8091), 2,
      sym_argument_list,
      sym_initializer_list,
  [243672] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9607), 1,
      anon_sym_LBRACK,
    STATE(4552), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6142), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9605), 13,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [243708] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(1821), 1,
      anon_sym_LBRACE,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(9754), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(9762), 1,
      anon_sym_EQ,
    ACTIONS(9902), 1,
      anon_sym_SEMI,
    ACTIONS(9904), 1,
      anon_sym_try,
    STATE(694), 1,
      sym_compound_statement,
    STATE(697), 1,
      sym_try_statement,
    STATE(2913), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(7495), 1,
      sym_gnu_asm_expression,
    STATE(7572), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(9764), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8091), 2,
      sym_argument_list,
      sym_initializer_list,
  [243766] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6776), 1,
      sym__type_declarator,
    STATE(7229), 1,
      sym__type_definition_declarators,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [243816] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7875), 1,
      anon_sym_STAR,
    ACTIONS(9822), 1,
      anon_sym_TILDE,
    ACTIONS(9828), 1,
      anon_sym_operator,
    ACTIONS(9906), 1,
      sym_identifier,
    ACTIONS(9908), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9910), 1,
      anon_sym_template,
    STATE(2104), 1,
      sym_template_type,
    STATE(2112), 1,
      sym_dependent_type_identifier,
    STATE(2125), 1,
      sym_qualified_type_identifier,
    STATE(3995), 1,
      sym_operator_name,
    STATE(4000), 1,
      sym_qualified_identifier,
    STATE(4002), 1,
      sym_dependent_identifier,
    STATE(4003), 1,
      sym_destructor_name,
    STATE(4004), 1,
      sym_template_function,
    STATE(4005), 1,
      sym_pointer_type_declarator,
    STATE(5941), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
    STATE(8717), 1,
      sym_ms_based_modifier,
  [243880] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9766), 1,
      sym_identifier,
    ACTIONS(9768), 1,
      anon_sym_LPAREN2,
    ACTIONS(9770), 1,
      anon_sym_defined,
    ACTIONS(9912), 1,
      sym_number_literal,
    ACTIONS(9772), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9778), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6100), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [243920] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7893), 1,
      anon_sym_STAR,
    ACTIONS(9744), 1,
      anon_sym_TILDE,
    ACTIONS(9750), 1,
      anon_sym_operator,
    ACTIONS(9914), 1,
      sym_identifier,
    ACTIONS(9916), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9918), 1,
      anon_sym_template,
    STATE(2104), 1,
      sym_template_type,
    STATE(2112), 1,
      sym_dependent_type_identifier,
    STATE(2125), 1,
      sym_qualified_type_identifier,
    STATE(2668), 1,
      sym_pointer_type_declarator,
    STATE(2670), 1,
      sym_template_function,
    STATE(2672), 1,
      sym_destructor_name,
    STATE(2673), 1,
      sym_dependent_identifier,
    STATE(2674), 1,
      sym_qualified_identifier,
    STATE(2678), 1,
      sym_operator_name,
    STATE(5943), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
    STATE(8989), 1,
      sym_ms_based_modifier,
  [243984] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym___attribute__,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(7989), 1,
      anon_sym_LPAREN2,
    ACTIONS(7997), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_STAR,
    ACTIONS(8001), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8003), 1,
      anon_sym_AMP,
    ACTIONS(9920), 1,
      anon_sym_SEMI,
    STATE(5714), 1,
      sym__field_declarator,
    STATE(6635), 1,
      sym_operator_name,
    STATE(8417), 1,
      sym_ms_based_modifier,
    STATE(8734), 1,
      sym_attribute_specifier,
    STATE(6748), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [244036] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6776), 1,
      sym__type_declarator,
    STATE(7305), 1,
      sym__type_definition_declarators,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [244086] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9611), 1,
      anon_sym_LBRACK,
    STATE(4552), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6128), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9609), 13,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [244122] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9766), 1,
      sym_identifier,
    ACTIONS(9768), 1,
      anon_sym_LPAREN2,
    ACTIONS(9770), 1,
      anon_sym_defined,
    ACTIONS(9922), 1,
      sym_number_literal,
    ACTIONS(9772), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9778), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6095), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [244162] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4262), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(9924), 1,
      sym_identifier,
    ACTIONS(9926), 1,
      anon_sym_template,
    STATE(2104), 1,
      sym_template_type,
    STATE(2112), 1,
      sym_dependent_type_identifier,
    STATE(2125), 1,
      sym_qualified_type_identifier,
    STATE(2944), 1,
      sym_pointer_type_declarator,
    STATE(2948), 1,
      sym_operator_name,
    STATE(2978), 1,
      sym_template_function,
    STATE(2997), 1,
      sym_qualified_identifier,
    STATE(2998), 1,
      sym_dependent_identifier,
    STATE(3001), 1,
      sym_destructor_name,
    STATE(5948), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
    STATE(8639), 1,
      sym_ms_based_modifier,
  [244226] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3965), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(9928), 1,
      sym_identifier,
    ACTIONS(9930), 1,
      anon_sym_template,
    STATE(2104), 1,
      sym_template_type,
    STATE(2112), 1,
      sym_dependent_type_identifier,
    STATE(2125), 1,
      sym_qualified_type_identifier,
    STATE(2944), 1,
      sym_pointer_type_declarator,
    STATE(2948), 1,
      sym_operator_name,
    STATE(2978), 1,
      sym_template_function,
    STATE(2997), 1,
      sym_qualified_identifier,
    STATE(2998), 1,
      sym_dependent_identifier,
    STATE(3001), 1,
      sym_destructor_name,
    STATE(5949), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
    STATE(8639), 1,
      sym_ms_based_modifier,
  [244290] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9674), 1,
      sym_identifier,
    ACTIONS(9678), 1,
      anon_sym_LPAREN2,
    ACTIONS(9680), 1,
      anon_sym_defined,
    ACTIONS(9932), 1,
      sym_number_literal,
    ACTIONS(9682), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9684), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9688), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5992), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [244330] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9674), 1,
      sym_identifier,
    ACTIONS(9678), 1,
      anon_sym_LPAREN2,
    ACTIONS(9680), 1,
      anon_sym_defined,
    ACTIONS(9934), 1,
      sym_number_literal,
    ACTIONS(9682), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9684), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9688), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6083), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [244370] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9674), 1,
      sym_identifier,
    ACTIONS(9678), 1,
      anon_sym_LPAREN2,
    ACTIONS(9680), 1,
      anon_sym_defined,
    ACTIONS(9936), 1,
      sym_number_literal,
    ACTIONS(9682), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9684), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9688), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5953), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [244410] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9702), 1,
      anon_sym_SLASH,
    ACTIONS(9698), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9700), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9940), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9938), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [244444] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9766), 1,
      sym_identifier,
    ACTIONS(9768), 1,
      anon_sym_LPAREN2,
    ACTIONS(9770), 1,
      anon_sym_defined,
    ACTIONS(9942), 1,
      sym_number_literal,
    ACTIONS(9772), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9778), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6075), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [244484] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9766), 1,
      sym_identifier,
    ACTIONS(9768), 1,
      anon_sym_LPAREN2,
    ACTIONS(9770), 1,
      anon_sym_defined,
    ACTIONS(9944), 1,
      sym_number_literal,
    ACTIONS(9772), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9778), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6031), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [244524] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9702), 1,
      anon_sym_SLASH,
    ACTIONS(9698), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9700), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9940), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9938), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [244560] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9702), 1,
      anon_sym_SLASH,
    ACTIONS(9698), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9700), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9716), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9718), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9940), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(9938), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [244600] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7913), 1,
      anon_sym_STAR,
    ACTIONS(9946), 1,
      sym_identifier,
    ACTIONS(9948), 1,
      anon_sym_TILDE,
    ACTIONS(9950), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9952), 1,
      anon_sym_template,
    ACTIONS(9954), 1,
      anon_sym_operator,
    STATE(1849), 1,
      sym_dependent_type_identifier,
    STATE(1853), 1,
      sym_template_type,
    STATE(1972), 1,
      sym_qualified_type_identifier,
    STATE(3532), 1,
      sym_pointer_type_declarator,
    STATE(3534), 1,
      sym_template_function,
    STATE(3541), 1,
      sym_destructor_name,
    STATE(3548), 1,
      sym_dependent_identifier,
    STATE(3549), 1,
      sym_qualified_identifier,
    STATE(3585), 1,
      sym_operator_name,
    STATE(5958), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
    STATE(8790), 1,
      sym_ms_based_modifier,
  [244664] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9702), 1,
      anon_sym_SLASH,
    ACTIONS(9698), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9700), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9714), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9716), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9718), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9940), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(9938), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [244706] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9674), 1,
      sym_identifier,
    ACTIONS(9678), 1,
      anon_sym_LPAREN2,
    ACTIONS(9680), 1,
      anon_sym_defined,
    ACTIONS(9956), 1,
      sym_number_literal,
    ACTIONS(9682), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9684), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9688), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5971), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [244746] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9702), 1,
      anon_sym_SLASH,
    ACTIONS(9712), 1,
      anon_sym_AMP,
    ACTIONS(9940), 1,
      anon_sym_PIPE,
    ACTIONS(9698), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9700), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9714), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9716), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9718), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9938), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [244790] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9766), 1,
      sym_identifier,
    ACTIONS(9768), 1,
      anon_sym_LPAREN2,
    ACTIONS(9770), 1,
      anon_sym_defined,
    ACTIONS(9958), 1,
      sym_number_literal,
    ACTIONS(9772), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9778), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6009), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [244830] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9674), 1,
      sym_identifier,
    ACTIONS(9678), 1,
      anon_sym_LPAREN2,
    ACTIONS(9680), 1,
      anon_sym_defined,
    ACTIONS(9960), 1,
      sym_number_literal,
    ACTIONS(9682), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9684), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9688), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5956), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [244870] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6776), 1,
      sym__type_declarator,
    STATE(7225), 1,
      sym__type_definition_declarators,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [244920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9964), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9962), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [244948] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6776), 1,
      sym__type_declarator,
    STATE(7166), 1,
      sym__type_definition_declarators,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [244998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9968), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9966), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [245026] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9702), 1,
      anon_sym_SLASH,
    ACTIONS(9710), 1,
      anon_sym_CARET,
    ACTIONS(9712), 1,
      anon_sym_AMP,
    ACTIONS(9940), 1,
      anon_sym_PIPE,
    ACTIONS(9698), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9700), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9714), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9716), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9718), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9938), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [245072] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6776), 1,
      sym__type_declarator,
    STATE(7116), 1,
      sym__type_definition_declarators,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [245122] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9702), 1,
      anon_sym_SLASH,
    ACTIONS(9708), 1,
      anon_sym_PIPE,
    ACTIONS(9710), 1,
      anon_sym_CARET,
    ACTIONS(9712), 1,
      anon_sym_AMP,
    ACTIONS(9698), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9700), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9714), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9716), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9718), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9938), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [245168] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9702), 1,
      anon_sym_SLASH,
    ACTIONS(9704), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9706), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9708), 1,
      anon_sym_PIPE,
    ACTIONS(9710), 1,
      anon_sym_CARET,
    ACTIONS(9712), 1,
      anon_sym_AMP,
    ACTIONS(9698), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9700), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9714), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9716), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9718), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9970), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [245218] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9517), 1,
      anon_sym_try,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(9754), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(9762), 1,
      anon_sym_EQ,
    ACTIONS(9972), 1,
      anon_sym_SEMI,
    ACTIONS(9974), 1,
      anon_sym_LBRACE,
    STATE(1812), 1,
      sym_try_statement,
    STATE(1813), 1,
      sym_compound_statement,
    STATE(2913), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(7747), 1,
      aux_sym_declaration_repeat1,
    STATE(7754), 1,
      sym_gnu_asm_expression,
    ACTIONS(9764), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8091), 2,
      sym_argument_list,
      sym_initializer_list,
  [245276] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6776), 1,
      sym__type_declarator,
    STATE(7283), 1,
      sym__type_definition_declarators,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [245326] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9702), 1,
      anon_sym_SLASH,
    ACTIONS(9706), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9708), 1,
      anon_sym_PIPE,
    ACTIONS(9710), 1,
      anon_sym_CARET,
    ACTIONS(9712), 1,
      anon_sym_AMP,
    ACTIONS(9698), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9700), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9714), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9716), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9718), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9938), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
  [245374] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9674), 1,
      sym_identifier,
    ACTIONS(9678), 1,
      anon_sym_LPAREN2,
    ACTIONS(9680), 1,
      anon_sym_defined,
    ACTIONS(9976), 1,
      sym_number_literal,
    ACTIONS(9682), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9684), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9688), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5959), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [245414] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9766), 1,
      sym_identifier,
    ACTIONS(9768), 1,
      anon_sym_LPAREN2,
    ACTIONS(9770), 1,
      anon_sym_defined,
    ACTIONS(9978), 1,
      sym_number_literal,
    ACTIONS(9772), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9778), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6127), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [245454] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6776), 1,
      sym__type_declarator,
    STATE(7239), 1,
      sym__type_definition_declarators,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [245504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9940), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9938), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [245532] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9702), 1,
      anon_sym_SLASH,
    ACTIONS(9700), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9940), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9938), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [245564] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(41), 1,
      anon_sym___attribute__,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(7989), 1,
      anon_sym_LPAREN2,
    ACTIONS(7997), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_STAR,
    ACTIONS(8001), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8003), 1,
      anon_sym_AMP,
    ACTIONS(9980), 1,
      anon_sym_SEMI,
    STATE(5715), 1,
      sym__field_declarator,
    STATE(6635), 1,
      sym_operator_name,
    STATE(8417), 1,
      sym_ms_based_modifier,
    STATE(8837), 1,
      sym_attribute_specifier,
    STATE(6748), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [245616] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7913), 1,
      anon_sym_STAR,
    ACTIONS(9948), 1,
      anon_sym_TILDE,
    ACTIONS(9954), 1,
      anon_sym_operator,
    ACTIONS(9982), 1,
      sym_identifier,
    ACTIONS(9984), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9986), 1,
      anon_sym_template,
    STATE(2104), 1,
      sym_template_type,
    STATE(2112), 1,
      sym_dependent_type_identifier,
    STATE(2125), 1,
      sym_qualified_type_identifier,
    STATE(3532), 1,
      sym_pointer_type_declarator,
    STATE(3534), 1,
      sym_template_function,
    STATE(3541), 1,
      sym_destructor_name,
    STATE(3548), 1,
      sym_dependent_identifier,
    STATE(3549), 1,
      sym_qualified_identifier,
    STATE(3585), 1,
      sym_operator_name,
    STATE(5981), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
    STATE(8790), 1,
      sym_ms_based_modifier,
  [245680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9990), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9988), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [245708] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(9754), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(9762), 1,
      anon_sym_EQ,
    ACTIONS(9992), 1,
      anon_sym_SEMI,
    ACTIONS(9994), 1,
      anon_sym_LBRACE,
    ACTIONS(9996), 1,
      anon_sym_try,
    STATE(487), 1,
      sym_try_statement,
    STATE(498), 1,
      sym_compound_statement,
    STATE(2913), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(7436), 1,
      aux_sym_declaration_repeat1,
    STATE(7456), 1,
      sym_gnu_asm_expression,
    ACTIONS(9764), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8091), 2,
      sym_argument_list,
      sym_initializer_list,
  [245766] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9674), 1,
      sym_identifier,
    ACTIONS(9678), 1,
      anon_sym_LPAREN2,
    ACTIONS(9680), 1,
      anon_sym_defined,
    ACTIONS(9998), 1,
      sym_number_literal,
    ACTIONS(9682), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9684), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9688), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5961), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [245806] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9674), 1,
      sym_identifier,
    ACTIONS(9678), 1,
      anon_sym_LPAREN2,
    ACTIONS(9680), 1,
      anon_sym_defined,
    ACTIONS(10000), 1,
      sym_number_literal,
    ACTIONS(9682), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9684), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9688), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5968), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [245846] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7913), 1,
      anon_sym_STAR,
    ACTIONS(9806), 1,
      anon_sym_TILDE,
    ACTIONS(9812), 1,
      anon_sym_operator,
    ACTIONS(10002), 1,
      sym_identifier,
    ACTIONS(10004), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10006), 1,
      anon_sym_template,
    STATE(1849), 1,
      sym_dependent_type_identifier,
    STATE(1853), 1,
      sym_template_type,
    STATE(1972), 1,
      sym_qualified_type_identifier,
    STATE(3659), 1,
      sym_pointer_type_declarator,
    STATE(3744), 1,
      sym_operator_name,
    STATE(3750), 1,
      sym_qualified_identifier,
    STATE(3753), 1,
      sym_dependent_identifier,
    STATE(3758), 1,
      sym_destructor_name,
    STATE(3777), 1,
      sym_template_function,
    STATE(5986), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
    STATE(8790), 1,
      sym_ms_based_modifier,
  [245910] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9766), 1,
      sym_identifier,
    ACTIONS(9768), 1,
      anon_sym_LPAREN2,
    ACTIONS(9770), 1,
      anon_sym_defined,
    ACTIONS(10008), 1,
      sym_number_literal,
    ACTIONS(9772), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9778), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6028), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [245950] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9674), 1,
      sym_identifier,
    ACTIONS(9678), 1,
      anon_sym_LPAREN2,
    ACTIONS(9680), 1,
      anon_sym_defined,
    ACTIONS(10010), 1,
      sym_number_literal,
    ACTIONS(9682), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9684), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9688), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5970), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [245990] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9674), 1,
      sym_identifier,
    ACTIONS(9678), 1,
      anon_sym_LPAREN2,
    ACTIONS(9680), 1,
      anon_sym_defined,
    ACTIONS(10012), 1,
      sym_number_literal,
    ACTIONS(9682), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9684), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9688), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5974), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [246030] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9674), 1,
      sym_identifier,
    ACTIONS(9678), 1,
      anon_sym_LPAREN2,
    ACTIONS(9680), 1,
      anon_sym_defined,
    ACTIONS(10014), 1,
      sym_number_literal,
    ACTIONS(9682), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9684), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9688), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5978), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [246070] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9674), 1,
      sym_identifier,
    ACTIONS(9678), 1,
      anon_sym_LPAREN2,
    ACTIONS(9680), 1,
      anon_sym_defined,
    ACTIONS(10016), 1,
      sym_number_literal,
    ACTIONS(9682), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9684), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9688), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5979), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [246110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10020), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10018), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [246138] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6776), 1,
      sym__type_declarator,
    STATE(7284), 1,
      sym__type_definition_declarators,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [246188] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9766), 1,
      sym_identifier,
    ACTIONS(9768), 1,
      anon_sym_LPAREN2,
    ACTIONS(9770), 1,
      anon_sym_defined,
    ACTIONS(10022), 1,
      sym_number_literal,
    ACTIONS(9772), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9774), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9778), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6055), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [246228] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10026), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10024), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [246256] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4949), 1,
      anon_sym_LBRACK,
    ACTIONS(4951), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [246283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1897), 1,
      anon_sym_LBRACK,
    ACTIONS(1895), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [246310] = 4,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(9938), 1,
      anon_sym_LF,
    ACTIONS(10028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9940), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [246339] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(9938), 1,
      anon_sym_LF,
    ACTIONS(9940), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [246366] = 12,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(9938), 1,
      anon_sym_LF,
    ACTIONS(9940), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10034), 1,
      anon_sym_PIPE,
    ACTIONS(10036), 1,
      anon_sym_CARET,
    ACTIONS(10038), 1,
      anon_sym_AMP,
    ACTIONS(10030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10044), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10042), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [246411] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6820), 1,
      anon_sym_DASH_GT,
    ACTIONS(10048), 1,
      anon_sym_LBRACK,
    ACTIONS(10053), 1,
      anon_sym_requires,
    STATE(6084), 1,
      sym_trailing_return_type,
    ACTIONS(10050), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6224), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [246450] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6813), 1,
      anon_sym_requires,
    ACTIONS(10058), 1,
      anon_sym_LBRACK,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6153), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10056), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [246485] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7871), 1,
      sym_identifier,
    ACTIONS(7873), 1,
      anon_sym_LPAREN2,
    ACTIONS(7875), 1,
      anon_sym_STAR,
    ACTIONS(7877), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7879), 1,
      anon_sym_AMP,
    ACTIONS(7883), 1,
      sym_primitive_type,
    STATE(3092), 1,
      sym__type_declarator,
    STATE(3798), 1,
      sym_pointer_type_declarator,
    STATE(8717), 1,
      sym_ms_based_modifier,
    ACTIONS(7881), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3820), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [246532] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(9938), 1,
      anon_sym_LF,
    ACTIONS(10030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9940), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [246563] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10062), 1,
      anon_sym_LBRACK,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6093), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(10060), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [246594] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(10058), 1,
      anon_sym_LBRACK,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6153), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10056), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [246629] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6820), 1,
      anon_sym_DASH_GT,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9419), 1,
      anon_sym_requires,
    STATE(6085), 1,
      sym_trailing_return_type,
    ACTIONS(9407), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [246668] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4941), 1,
      anon_sym_LBRACK,
    ACTIONS(4943), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [246695] = 12,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(10032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10034), 1,
      anon_sym_PIPE,
    ACTIONS(10036), 1,
      anon_sym_CARET,
    ACTIONS(10038), 1,
      anon_sym_AMP,
    ACTIONS(10064), 1,
      anon_sym_LF,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10044), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10042), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [246740] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6801), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9063), 1,
      anon_sym_requires,
    STATE(6019), 1,
      sym_trailing_return_type,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [246779] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6935), 1,
      sym__type_declarator,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [246826] = 10,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(9938), 1,
      anon_sym_LF,
    ACTIONS(10036), 1,
      anon_sym_CARET,
    ACTIONS(10038), 1,
      anon_sym_AMP,
    ACTIONS(10030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10044), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9940), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
    ACTIONS(10028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10042), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [246867] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6801), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9184), 1,
      anon_sym_requires,
    STATE(6107), 1,
      sym_trailing_return_type,
    ACTIONS(9181), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [246906] = 9,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(9938), 1,
      anon_sym_LF,
    ACTIONS(10038), 1,
      anon_sym_AMP,
    ACTIONS(10030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10044), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9940), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(10042), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [246945] = 8,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(9938), 1,
      anon_sym_LF,
    ACTIONS(10030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10044), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10042), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9940), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
  [246982] = 7,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(9938), 1,
      anon_sym_LF,
    ACTIONS(10030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10044), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10042), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(9940), 7,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [247017] = 6,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(9938), 1,
      anon_sym_LF,
    ACTIONS(10030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10044), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(9940), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [247050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4933), 1,
      anon_sym_LBRACK,
    ACTIONS(4935), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [247077] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9184), 1,
      anon_sym_requires,
    ACTIONS(9181), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [247112] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6801), 1,
      anon_sym_DASH_GT,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9410), 1,
      anon_sym_requires,
    STATE(6073), 1,
      sym_trailing_return_type,
    ACTIONS(9407), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [247151] = 12,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(10032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10034), 1,
      anon_sym_PIPE,
    ACTIONS(10036), 1,
      anon_sym_CARET,
    ACTIONS(10038), 1,
      anon_sym_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10068), 1,
      anon_sym_LF,
    ACTIONS(10030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10044), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10042), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [247196] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6813), 1,
      anon_sym_requires,
    ACTIONS(10048), 1,
      anon_sym_LBRACK,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6224), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [247231] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6813), 1,
      anon_sym_requires,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [247266] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6820), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9334), 1,
      anon_sym_requires,
    STATE(6086), 1,
      sym_trailing_return_type,
    ACTIONS(9181), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [247305] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(9962), 1,
      anon_sym_LF,
    ACTIONS(9964), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [247332] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4937), 1,
      anon_sym_LBRACK,
    ACTIONS(4939), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [247359] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6698), 1,
      anon_sym_DASH_GT,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    STATE(6108), 1,
      sym_trailing_return_type,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [247398] = 12,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(10032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10034), 1,
      anon_sym_PIPE,
    ACTIONS(10036), 1,
      anon_sym_CARET,
    ACTIONS(10038), 1,
      anon_sym_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10070), 1,
      anon_sym_LF,
    ACTIONS(10030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10044), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10042), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [247443] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [247478] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_LBRACK,
    ACTIONS(10072), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5404), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [247507] = 12,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(10032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10034), 1,
      anon_sym_PIPE,
    ACTIONS(10036), 1,
      anon_sym_CARET,
    ACTIONS(10038), 1,
      anon_sym_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10074), 1,
      anon_sym_LF,
    ACTIONS(10030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10044), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10042), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [247552] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_LF,
    ACTIONS(9798), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [247579] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(9864), 1,
      anon_sym_LF,
    ACTIONS(9866), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [247606] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7923), 1,
      sym_identifier,
    ACTIONS(7925), 1,
      anon_sym_LPAREN2,
    ACTIONS(7927), 1,
      anon_sym_STAR,
    ACTIONS(7929), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7931), 1,
      anon_sym_AMP,
    ACTIONS(7935), 1,
      sym_primitive_type,
    STATE(3106), 1,
      sym__type_declarator,
    STATE(3594), 1,
      sym_pointer_type_declarator,
    STATE(8279), 1,
      sym_ms_based_modifier,
    ACTIONS(7933), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3590), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [247653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_LBRACK,
    ACTIONS(4955), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [247680] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6698), 1,
      anon_sym_DASH_GT,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(10048), 1,
      anon_sym_LBRACK,
    STATE(6006), 1,
      sym_trailing_return_type,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6224), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [247719] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6698), 1,
      anon_sym_DASH_GT,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    STATE(6029), 1,
      sym_trailing_return_type,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [247758] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6698), 1,
      anon_sym_DASH_GT,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    STATE(6076), 1,
      sym_trailing_return_type,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [247797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10078), 1,
      anon_sym_LBRACK,
    ACTIONS(10076), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [247824] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6820), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9077), 1,
      anon_sym_requires,
    STATE(6088), 1,
      sym_trailing_return_type,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [247863] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [247898] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(10080), 1,
      sym_identifier,
    ACTIONS(10082), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10084), 1,
      anon_sym_template,
    STATE(2944), 1,
      sym_pointer_type_declarator,
    STATE(2948), 1,
      sym_operator_name,
    STATE(2978), 1,
      sym_template_function,
    STATE(2997), 1,
      sym_qualified_identifier,
    STATE(2998), 1,
      sym_dependent_identifier,
    STATE(3001), 1,
      sym_destructor_name,
    STATE(6042), 1,
      sym__scope_resolution,
    STATE(8639), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [247955] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7851), 1,
      sym_identifier,
    ACTIONS(7853), 1,
      anon_sym_LPAREN2,
    ACTIONS(7863), 1,
      sym_primitive_type,
    ACTIONS(7939), 1,
      anon_sym_STAR,
    ACTIONS(7941), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7943), 1,
      anon_sym_AMP,
    STATE(6536), 1,
      sym__type_declarator,
    STATE(6573), 1,
      sym_pointer_type_declarator,
    STATE(8211), 1,
      sym_ms_based_modifier,
    ACTIONS(7861), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6565), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [248002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10088), 1,
      anon_sym_LBRACK,
    ACTIONS(10086), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [248029] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_LBRACK,
    ACTIONS(10090), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5404), 16,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [248058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4921), 1,
      anon_sym_LBRACK,
    ACTIONS(4923), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [248085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10094), 1,
      anon_sym_LBRACK,
    ACTIONS(10092), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [248112] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7851), 1,
      sym_identifier,
    ACTIONS(7853), 1,
      anon_sym_LPAREN2,
    ACTIONS(7855), 1,
      anon_sym_STAR,
    ACTIONS(7857), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7859), 1,
      anon_sym_AMP,
    ACTIONS(7863), 1,
      sym_primitive_type,
    STATE(6339), 1,
      sym__type_declarator,
    STATE(6573), 1,
      sym_pointer_type_declarator,
    STATE(8472), 1,
      sym_ms_based_modifier,
    ACTIONS(7861), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6565), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [248159] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6801), 1,
      anon_sym_DASH_GT,
    ACTIONS(10048), 1,
      anon_sym_LBRACK,
    ACTIONS(10096), 1,
      anon_sym_requires,
    STATE(6060), 1,
      sym_trailing_return_type,
    ACTIONS(10050), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6224), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [248198] = 12,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(10032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10034), 1,
      anon_sym_PIPE,
    ACTIONS(10036), 1,
      anon_sym_CARET,
    ACTIONS(10038), 1,
      anon_sym_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10099), 1,
      anon_sym_LF,
    ACTIONS(10030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10044), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10042), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [248243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4917), 1,
      anon_sym_LBRACK,
    ACTIONS(4919), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [248270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4909), 1,
      anon_sym_LBRACK,
    ACTIONS(4911), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [248297] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6954), 1,
      sym__type_declarator,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [248344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1901), 1,
      anon_sym_LBRACK,
    ACTIONS(1899), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [248371] = 12,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(10032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10034), 1,
      anon_sym_PIPE,
    ACTIONS(10036), 1,
      anon_sym_CARET,
    ACTIONS(10038), 1,
      anon_sym_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10101), 1,
      anon_sym_LF,
    ACTIONS(10030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10044), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10042), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [248416] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(6801), 1,
      anon_sym_DASH_GT,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    STATE(6108), 1,
      sym_trailing_return_type,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [248455] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10105), 1,
      anon_sym_LBRACK,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10103), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [248486] = 3,
    ACTIONS(6983), 1,
      anon_sym_LF,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(6981), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [248513] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7855), 1,
      anon_sym_STAR,
    ACTIONS(10107), 1,
      sym_identifier,
    ACTIONS(10109), 1,
      anon_sym_template,
    STATE(6059), 1,
      sym__scope_resolution,
    STATE(6601), 1,
      sym_operator_name,
    STATE(6603), 1,
      sym_qualified_identifier,
    STATE(6605), 1,
      sym_dependent_identifier,
    STATE(6607), 1,
      sym_destructor_name,
    STATE(6608), 1,
      sym_template_function,
    STATE(6609), 1,
      sym_pointer_type_declarator,
    STATE(8472), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [248570] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10058), 1,
      anon_sym_LBRACK,
    ACTIONS(10114), 1,
      anon_sym_requires,
    ACTIONS(10111), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6153), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10056), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [248605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10119), 1,
      anon_sym_LBRACK,
    ACTIONS(10117), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [248632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4913), 1,
      anon_sym_LBRACK,
    ACTIONS(4915), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [248659] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(6801), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    STATE(6029), 1,
      sym_trailing_return_type,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [248698] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6657), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7939), 1,
      anon_sym_STAR,
    ACTIONS(10107), 1,
      sym_identifier,
    ACTIONS(10109), 1,
      anon_sym_template,
    STATE(6064), 1,
      sym__scope_resolution,
    STATE(6601), 1,
      sym_operator_name,
    STATE(6603), 1,
      sym_qualified_identifier,
    STATE(6605), 1,
      sym_dependent_identifier,
    STATE(6607), 1,
      sym_destructor_name,
    STATE(6608), 1,
      sym_template_function,
    STATE(6609), 1,
      sym_pointer_type_declarator,
    STATE(8211), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [248755] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(9988), 1,
      anon_sym_LF,
    ACTIONS(9990), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [248782] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6698), 1,
      anon_sym_DASH_GT,
    ACTIONS(10048), 1,
      anon_sym_LBRACK,
    ACTIONS(10096), 1,
      anon_sym_requires,
    STATE(6060), 1,
      sym_trailing_return_type,
    ACTIONS(10050), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6224), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [248821] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4929), 1,
      anon_sym_LBRACK,
    ACTIONS(4931), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [248848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10123), 1,
      anon_sym_LBRACK,
    ACTIONS(10121), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [248875] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6698), 1,
      anon_sym_DASH_GT,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9410), 1,
      anon_sym_requires,
    STATE(6073), 1,
      sym_trailing_return_type,
    ACTIONS(9407), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [248914] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9607), 1,
      anon_sym_LBRACK,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9605), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [248945] = 11,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(9938), 1,
      anon_sym_LF,
    ACTIONS(10034), 1,
      anon_sym_PIPE,
    ACTIONS(10036), 1,
      anon_sym_CARET,
    ACTIONS(10038), 1,
      anon_sym_AMP,
    ACTIONS(9940), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(10030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10044), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10042), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [248988] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6623), 1,
      sym__type_declarator,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [249035] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10048), 1,
      anon_sym_LBRACK,
    ACTIONS(10096), 1,
      anon_sym_requires,
    ACTIONS(10050), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6224), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [249070] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9611), 1,
      anon_sym_LBRACK,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9609), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [249101] = 12,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(10032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10034), 1,
      anon_sym_PIPE,
    ACTIONS(10036), 1,
      anon_sym_CARET,
    ACTIONS(10038), 1,
      anon_sym_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10125), 1,
      anon_sym_LF,
    ACTIONS(10030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10044), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10042), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [249146] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [249181] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(9876), 1,
      anon_sym_LF,
    ACTIONS(9878), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [249208] = 12,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(10032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10034), 1,
      anon_sym_PIPE,
    ACTIONS(10036), 1,
      anon_sym_CARET,
    ACTIONS(10038), 1,
      anon_sym_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10127), 1,
      anon_sym_LF,
    ACTIONS(10030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10044), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10042), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [249253] = 12,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(10032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10034), 1,
      anon_sym_PIPE,
    ACTIONS(10036), 1,
      anon_sym_CARET,
    ACTIONS(10038), 1,
      anon_sym_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10129), 1,
      anon_sym_LF,
    ACTIONS(10030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10044), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10042), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [249298] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6835), 1,
      sym__type_declarator,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [249345] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6964), 1,
      sym__type_declarator,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [249392] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6698), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9184), 1,
      anon_sym_requires,
    STATE(6107), 1,
      sym_trailing_return_type,
    ACTIONS(9181), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [249431] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9702), 1,
      anon_sym_SLASH,
    ACTIONS(9704), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9706), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9708), 1,
      anon_sym_PIPE,
    ACTIONS(9710), 1,
      anon_sym_CARET,
    ACTIONS(9712), 1,
      anon_sym_AMP,
    ACTIONS(10131), 1,
      anon_sym_RPAREN,
    ACTIONS(9698), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9700), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9714), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9716), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9718), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [249480] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10058), 1,
      anon_sym_LBRACK,
    ACTIONS(10133), 1,
      anon_sym_requires,
    ACTIONS(10111), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6153), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10056), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [249515] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10048), 1,
      anon_sym_LBRACK,
    ACTIONS(10053), 1,
      anon_sym_requires,
    ACTIONS(10050), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6224), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [249550] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9419), 1,
      anon_sym_requires,
    ACTIONS(9407), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [249585] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10138), 1,
      anon_sym_LPAREN2,
    ACTIONS(10140), 1,
      anon_sym_LBRACK,
    ACTIONS(10136), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [249614] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9334), 1,
      anon_sym_requires,
    ACTIONS(9181), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [249649] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9077), 1,
      anon_sym_requires,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [249684] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6615), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(10142), 1,
      sym_identifier,
    ACTIONS(10144), 1,
      anon_sym_template,
    STATE(2944), 1,
      sym_pointer_type_declarator,
    STATE(2948), 1,
      sym_operator_name,
    STATE(2978), 1,
      sym_template_function,
    STATE(2997), 1,
      sym_qualified_identifier,
    STATE(2998), 1,
      sym_dependent_identifier,
    STATE(3001), 1,
      sym_destructor_name,
    STATE(6090), 1,
      sym__scope_resolution,
    STATE(8639), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [249741] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6813), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [249776] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6698), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9063), 1,
      anon_sym_requires,
    STATE(6019), 1,
      sym_trailing_return_type,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [249815] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10148), 1,
      anon_sym_LBRACK,
    ACTIONS(10150), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6093), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(10146), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [249846] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5631), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(9724), 1,
      sym_identifier,
    ACTIONS(9726), 1,
      anon_sym_template,
    STATE(2944), 1,
      sym_pointer_type_declarator,
    STATE(2948), 1,
      sym_operator_name,
    STATE(2978), 1,
      sym_template_function,
    STATE(2997), 1,
      sym_qualified_identifier,
    STATE(2998), 1,
      sym_dependent_identifier,
    STATE(3001), 1,
      sym_destructor_name,
    STATE(6094), 1,
      sym__scope_resolution,
    STATE(8639), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [249903] = 12,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(10032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10034), 1,
      anon_sym_PIPE,
    ACTIONS(10036), 1,
      anon_sym_CARET,
    ACTIONS(10038), 1,
      anon_sym_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10153), 1,
      anon_sym_LF,
    ACTIONS(10030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10044), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10042), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [249948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 1,
      anon_sym_LBRACK,
    ACTIONS(4947), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [249975] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(6801), 1,
      anon_sym_DASH_GT,
    ACTIONS(10048), 1,
      anon_sym_LBRACK,
    STATE(6006), 1,
      sym_trailing_return_type,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6224), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [250014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 1,
      anon_sym_LBRACK,
    ACTIONS(4947), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [250041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 1,
      anon_sym_LBRACK,
    ACTIONS(4947), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [250068] = 12,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(10032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10034), 1,
      anon_sym_PIPE,
    ACTIONS(10036), 1,
      anon_sym_CARET,
    ACTIONS(10038), 1,
      anon_sym_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10155), 1,
      anon_sym_LF,
    ACTIONS(10030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10044), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10042), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [250113] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(6801), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    STATE(6076), 1,
      sym_trailing_return_type,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [250152] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6813), 1,
      anon_sym_requires,
    ACTIONS(6820), 1,
      anon_sym_DASH_GT,
    ACTIONS(10048), 1,
      anon_sym_LBRACK,
    STATE(6002), 1,
      sym_trailing_return_type,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6224), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [250191] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6813), 1,
      anon_sym_requires,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [250226] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6962), 1,
      sym__type_declarator,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [250273] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9063), 1,
      anon_sym_requires,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [250308] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6813), 1,
      anon_sym_requires,
    ACTIONS(6820), 1,
      anon_sym_DASH_GT,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    STATE(6022), 1,
      sym_trailing_return_type,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [250347] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9410), 1,
      anon_sym_requires,
    ACTIONS(9407), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [250382] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(10048), 1,
      anon_sym_LBRACK,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6224), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [250417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4925), 1,
      anon_sym_LBRACK,
    ACTIONS(4927), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [250444] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6813), 1,
      anon_sym_requires,
    ACTIONS(6820), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    STATE(6023), 1,
      sym_trailing_return_type,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [250483] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7909), 1,
      sym_identifier,
    ACTIONS(7911), 1,
      anon_sym_LPAREN2,
    ACTIONS(7913), 1,
      anon_sym_STAR,
    ACTIONS(7915), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7917), 1,
      anon_sym_AMP,
    ACTIONS(7921), 1,
      sym_primitive_type,
    STATE(3039), 1,
      sym__type_declarator,
    STATE(3553), 1,
      sym_pointer_type_declarator,
    STATE(8790), 1,
      sym_ms_based_modifier,
    ACTIONS(7919), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3555), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [250530] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5390), 1,
      anon_sym_LBRACK,
    ACTIONS(10072), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10157), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(5392), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [250561] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6813), 1,
      anon_sym_requires,
    ACTIONS(6820), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    STATE(6103), 1,
      sym_trailing_return_type,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [250600] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(9966), 1,
      anon_sym_LF,
    ACTIONS(9968), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [250627] = 12,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(10032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10034), 1,
      anon_sym_PIPE,
    ACTIONS(10036), 1,
      anon_sym_CARET,
    ACTIONS(10038), 1,
      anon_sym_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10159), 1,
      anon_sym_LF,
    ACTIONS(10030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10044), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10042), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [250672] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4967), 1,
      anon_sym_LBRACK,
    ACTIONS(4969), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [250699] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5390), 1,
      anon_sym_LBRACK,
    ACTIONS(10090), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10161), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(5392), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [250730] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7839), 1,
      anon_sym_STAR,
    ACTIONS(7841), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7843), 1,
      anon_sym_AMP,
    ACTIONS(7849), 1,
      sym_primitive_type,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6932), 1,
      sym__type_declarator,
    STATE(8829), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [250777] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2118), 1,
      anon_sym_TILDE,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6669), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7839), 1,
      anon_sym_STAR,
    ACTIONS(9724), 1,
      sym_identifier,
    ACTIONS(9726), 1,
      anon_sym_template,
    STATE(2944), 1,
      sym_pointer_type_declarator,
    STATE(2948), 1,
      sym_operator_name,
    STATE(2978), 1,
      sym_template_function,
    STATE(2997), 1,
      sym_qualified_identifier,
    STATE(2998), 1,
      sym_dependent_identifier,
    STATE(3001), 1,
      sym_destructor_name,
    STATE(6119), 1,
      sym__scope_resolution,
    STATE(8829), 1,
      sym_ms_based_modifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [250834] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_STAR,
    ACTIONS(7889), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7891), 1,
      anon_sym_AMP,
    STATE(3056), 1,
      sym_parameter_list,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6771), 1,
      sym__abstract_declarator,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8279), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [250877] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7865), 1,
      anon_sym_STAR,
    ACTIONS(7867), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7869), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(6958), 1,
      sym__type_declarator,
    STATE(8639), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [250924] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(7835), 1,
      sym_identifier,
    ACTIONS(7837), 1,
      anon_sym_LPAREN2,
    ACTIONS(7849), 1,
      sym_primitive_type,
    ACTIONS(7893), 1,
      anon_sym_STAR,
    ACTIONS(7895), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7897), 1,
      anon_sym_AMP,
    STATE(2312), 1,
      sym__type_declarator,
    STATE(2409), 1,
      sym_pointer_type_declarator,
    STATE(8989), 1,
      sym_ms_based_modifier,
    ACTIONS(7847), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2432), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [250971] = 12,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(10032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10034), 1,
      anon_sym_PIPE,
    ACTIONS(10036), 1,
      anon_sym_CARET,
    ACTIONS(10038), 1,
      anon_sym_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10163), 1,
      anon_sym_LF,
    ACTIONS(10030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10044), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10042), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [251016] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(10018), 1,
      anon_sym_LF,
    ACTIONS(10020), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [251043] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(10024), 1,
      anon_sym_LF,
    ACTIONS(10026), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [251070] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9702), 1,
      anon_sym_SLASH,
    ACTIONS(9704), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9706), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9708), 1,
      anon_sym_PIPE,
    ACTIONS(9710), 1,
      anon_sym_CARET,
    ACTIONS(9712), 1,
      anon_sym_AMP,
    ACTIONS(10165), 1,
      anon_sym_RPAREN,
    ACTIONS(9698), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9700), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9714), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9716), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9718), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [251119] = 12,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(10032), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10034), 1,
      anon_sym_PIPE,
    ACTIONS(10036), 1,
      anon_sym_CARET,
    ACTIONS(10038), 1,
      anon_sym_AMP,
    ACTIONS(10066), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10167), 1,
      anon_sym_LF,
    ACTIONS(10030), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10040), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10044), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10042), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [251164] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10105), 1,
      anon_sym_LBRACK,
    STATE(6133), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10103), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [251194] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6633), 1,
      anon_sym_DASH_GT,
    ACTIONS(6676), 1,
      anon_sym_requires,
    STATE(6284), 1,
      sym_trailing_return_type,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6405), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [251230] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6633), 1,
      anon_sym_DASH_GT,
    ACTIONS(6676), 1,
      anon_sym_requires,
    STATE(6273), 1,
      sym_trailing_return_type,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6399), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [251266] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6633), 1,
      anon_sym_DASH_GT,
    ACTIONS(9109), 1,
      anon_sym_requires,
    STATE(6236), 1,
      sym_trailing_return_type,
    ACTIONS(9106), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [251302] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 1,
      anon_sym_LPAREN2,
    ACTIONS(7154), 1,
      anon_sym_LBRACK,
    ACTIONS(7951), 1,
      anon_sym_STAR,
    ACTIONS(7953), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7955), 1,
      anon_sym_AMP,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(6167), 1,
      sym__function_declarator_seq,
    STATE(6863), 1,
      sym__abstract_declarator,
    ACTIONS(8279), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [251344] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5986), 1,
      anon_sym_LBRACK,
    ACTIONS(10169), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6133), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5988), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [251374] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6633), 1,
      anon_sym_DASH_GT,
    ACTIONS(10175), 1,
      anon_sym_requires,
    STATE(6228), 1,
      sym_trailing_return_type,
    ACTIONS(10172), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6405), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [251410] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6633), 1,
      anon_sym_DASH_GT,
    ACTIONS(6676), 1,
      anon_sym_requires,
    STATE(6282), 1,
      sym_trailing_return_type,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [251446] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6633), 1,
      anon_sym_DASH_GT,
    ACTIONS(9020), 1,
      anon_sym_requires,
    STATE(6241), 1,
      sym_trailing_return_type,
    ACTIONS(9017), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [251482] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3552), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9359), 1,
      sym_identifier,
    ACTIONS(10178), 1,
      sym_virtual,
    STATE(2113), 1,
      sym_template_type,
    STATE(6749), 1,
      sym_access_specifier,
    STATE(6810), 1,
      sym__scope_resolution,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7319), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10180), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [251530] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6633), 1,
      anon_sym_DASH_GT,
    ACTIONS(6676), 1,
      anon_sym_requires,
    STATE(6271), 1,
      sym_trailing_return_type,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [251566] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(9754), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(9762), 1,
      anon_sym_EQ,
    ACTIONS(10182), 1,
      anon_sym_SEMI,
    ACTIONS(10184), 1,
      anon_sym_COLON,
    STATE(2897), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(7731), 1,
      sym_gnu_asm_expression,
    STATE(7732), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(9764), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6622), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8091), 2,
      sym_argument_list,
      sym_initializer_list,
  [251618] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3552), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9359), 1,
      sym_identifier,
    ACTIONS(10186), 1,
      sym_virtual,
    STATE(2113), 1,
      sym_template_type,
    STATE(6711), 1,
      sym_access_specifier,
    STATE(6810), 1,
      sym__scope_resolution,
    STATE(6144), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7498), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10180), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [251666] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6633), 1,
      anon_sym_DASH_GT,
    ACTIONS(9395), 1,
      anon_sym_requires,
    STATE(6230), 1,
      sym_trailing_return_type,
    ACTIONS(9392), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6399), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [251702] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9611), 1,
      anon_sym_LBRACK,
    STATE(6133), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9609), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [251732] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3552), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9359), 1,
      sym_identifier,
    ACTIONS(10188), 1,
      sym_virtual,
    STATE(2113), 1,
      sym_template_type,
    STATE(6699), 1,
      sym_access_specifier,
    STATE(6810), 1,
      sym__scope_resolution,
    STATE(6137), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7256), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10180), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [251780] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3552), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9359), 1,
      sym_identifier,
    ACTIONS(10190), 1,
      sym_virtual,
    STATE(2113), 1,
      sym_template_type,
    STATE(6733), 1,
      sym_access_specifier,
    STATE(6810), 1,
      sym__scope_resolution,
    STATE(5631), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7734), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10180), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [251828] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9607), 1,
      anon_sym_LBRACK,
    STATE(6133), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9605), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [251858] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6822), 1,
      anon_sym_DASH_GT,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9410), 1,
      anon_sym_requires,
    STATE(6073), 1,
      sym_trailing_return_type,
    ACTIONS(9407), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [251895] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9077), 1,
      anon_sym_requires,
    STATE(6088), 1,
      sym_trailing_return_type,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [251932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10194), 1,
      anon_sym_LBRACK,
    ACTIONS(10192), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [251957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10198), 1,
      anon_sym_LBRACK,
    ACTIONS(10196), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [251982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10202), 1,
      anon_sym_LBRACK,
    ACTIONS(10200), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [252007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10206), 1,
      anon_sym_LBRACK,
    ACTIONS(10204), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [252032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10210), 1,
      anon_sym_LBRACK,
    ACTIONS(10208), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [252057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10214), 1,
      anon_sym_LBRACK,
    ACTIONS(10212), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [252082] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10216), 1,
      anon_sym_LBRACE,
    ACTIONS(10218), 1,
      anon_sym_requires,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(5290), 1,
      sym_compound_statement,
    STATE(6343), 1,
      sym_requires_clause,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7295), 1,
      sym_abstract_function_declarator,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [252131] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10218), 1,
      anon_sym_requires,
    ACTIONS(10220), 1,
      anon_sym_LBRACE,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(3977), 1,
      sym_compound_statement,
    STATE(6366), 1,
      sym_requires_clause,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7162), 1,
      sym_abstract_function_declarator,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [252180] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10222), 1,
      sym_identifier,
    STATE(6352), 1,
      sym_string_literal,
    STATE(6675), 1,
      sym_raw_string_literal,
    ACTIONS(10224), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(7270), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [252215] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10226), 1,
      anon_sym_LT,
    ACTIONS(10228), 1,
      anon_sym_LBRACE,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(3736), 1,
      sym_compound_statement,
    STATE(6205), 1,
      sym_template_parameter_list,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7240), 1,
      sym_abstract_function_declarator,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [252264] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10048), 1,
      anon_sym_LBRACK,
    ACTIONS(10046), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [252289] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10218), 1,
      anon_sym_requires,
    ACTIONS(10230), 1,
      anon_sym_LBRACE,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(4741), 1,
      sym_compound_statement,
    STATE(6363), 1,
      sym_requires_clause,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7102), 1,
      sym_abstract_function_declarator,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [252338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10234), 1,
      anon_sym_LBRACK,
    ACTIONS(10232), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [252363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10238), 1,
      anon_sym_LBRACK,
    ACTIONS(10236), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [252388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10242), 1,
      anon_sym_LBRACK,
    ACTIONS(10240), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [252413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10246), 1,
      anon_sym_LBRACK,
    ACTIONS(10244), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [252438] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10216), 1,
      anon_sym_LBRACE,
    ACTIONS(10226), 1,
      anon_sym_LT,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(5190), 1,
      sym_compound_statement,
    STATE(6154), 1,
      sym_template_parameter_list,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(7364), 1,
      sym_abstract_function_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [252487] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6822), 1,
      anon_sym_DASH_GT,
    ACTIONS(10048), 1,
      anon_sym_LBRACK,
    ACTIONS(10096), 1,
      anon_sym_requires,
    STATE(6060), 1,
      sym_trailing_return_type,
    ACTIONS(10050), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6224), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [252524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10250), 1,
      anon_sym_LBRACK,
    ACTIONS(10248), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [252549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10254), 1,
      anon_sym_LBRACK,
    ACTIONS(10252), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [252574] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(6822), 1,
      anon_sym_DASH_GT,
    ACTIONS(10048), 1,
      anon_sym_LBRACK,
    STATE(6006), 1,
      sym_trailing_return_type,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6224), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [252611] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10220), 1,
      anon_sym_LBRACE,
    ACTIONS(10226), 1,
      anon_sym_LT,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(3956), 1,
      sym_compound_statement,
    STATE(6155), 1,
      sym_template_parameter_list,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7109), 1,
      sym_abstract_function_declarator,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [252660] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(6822), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    STATE(6076), 1,
      sym_trailing_return_type,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [252697] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(9754), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(9762), 1,
      anon_sym_EQ,
    ACTIONS(10182), 1,
      anon_sym_SEMI,
    STATE(2913), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(7731), 1,
      sym_gnu_asm_expression,
    STATE(7732), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(9764), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8091), 2,
      sym_argument_list,
      sym_initializer_list,
  [252746] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10218), 1,
      anon_sym_requires,
    ACTIONS(10256), 1,
      anon_sym_LBRACE,
    STATE(2743), 1,
      sym_compound_statement,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6314), 1,
      sym_requires_clause,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7246), 1,
      sym_abstract_function_declarator,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [252795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9388), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [252820] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(6822), 1,
      anon_sym_DASH_GT,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    STATE(6108), 1,
      sym_trailing_return_type,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [252857] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10218), 1,
      anon_sym_requires,
    ACTIONS(10258), 1,
      anon_sym_LBRACE,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6260), 1,
      sym_compound_statement,
    STATE(6317), 1,
      sym_requires_clause,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7199), 1,
      sym_abstract_function_declarator,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [252906] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(9754), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(9762), 1,
      anon_sym_EQ,
    ACTIONS(9896), 1,
      anon_sym_SEMI,
    STATE(2913), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(7390), 1,
      aux_sym_declaration_repeat1,
    STATE(7391), 1,
      sym_gnu_asm_expression,
    ACTIONS(9764), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8091), 2,
      sym_argument_list,
      sym_initializer_list,
  [252955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9013), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [252980] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10226), 1,
      anon_sym_LT,
    ACTIONS(10260), 1,
      anon_sym_LBRACE,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6109), 1,
      sym_compound_statement,
    STATE(6179), 1,
      sym_template_parameter_list,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(7366), 1,
      sym_abstract_function_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [253029] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10218), 1,
      anon_sym_requires,
    ACTIONS(10260), 1,
      anon_sym_LBRACE,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6051), 1,
      sym_compound_statement,
    STATE(6299), 1,
      sym_requires_clause,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(7340), 1,
      sym_abstract_function_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [253078] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10226), 1,
      anon_sym_LT,
    ACTIONS(10258), 1,
      anon_sym_LBRACE,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6175), 1,
      sym_template_parameter_list,
    STATE(6231), 1,
      sym_compound_statement,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7204), 1,
      sym_abstract_function_declarator,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [253127] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5212), 1,
      anon_sym_COLON,
    ACTIONS(8277), 1,
      anon_sym_LT,
    STATE(2875), 1,
      sym_template_argument_list,
    ACTIONS(3782), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [253158] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10226), 1,
      anon_sym_LT,
    ACTIONS(10262), 1,
      anon_sym_LBRACE,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(3693), 1,
      sym_compound_statement,
    STATE(6202), 1,
      sym_template_parameter_list,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(7304), 1,
      sym_abstract_function_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [253207] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10226), 1,
      anon_sym_LT,
    ACTIONS(10264), 1,
      anon_sym_LBRACE,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(4186), 1,
      sym_compound_statement,
    STATE(6209), 1,
      sym_template_parameter_list,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7245), 1,
      sym_abstract_function_declarator,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [253256] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10268), 1,
      anon_sym_LBRACK,
    ACTIONS(10266), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [253281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10272), 1,
      anon_sym_LBRACK,
    ACTIONS(10270), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [253306] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8005), 1,
      anon_sym_STAR,
    ACTIONS(8007), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8009), 1,
      anon_sym_AMP,
    STATE(2819), 1,
      sym_parameter_list,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6734), 1,
      sym__abstract_declarator,
    ACTIONS(8279), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [253347] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6822), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9184), 1,
      anon_sym_requires,
    STATE(6107), 1,
      sym_trailing_return_type,
    ACTIONS(9181), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [253384] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10274), 1,
      sym_identifier,
    ACTIONS(5346), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(6216), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(10276), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10278), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [253415] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10226), 1,
      anon_sym_LT,
    ACTIONS(10280), 1,
      anon_sym_LBRACE,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(4040), 1,
      sym_compound_statement,
    STATE(6211), 1,
      sym_template_parameter_list,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(7300), 1,
      sym_abstract_function_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [253464] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      anon_sym_DASH_GT,
    ACTIONS(10048), 1,
      anon_sym_LBRACK,
    ACTIONS(10053), 1,
      anon_sym_requires,
    STATE(6084), 1,
      sym_trailing_return_type,
    ACTIONS(10050), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6224), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [253501] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      anon_sym_DASH_GT,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9419), 1,
      anon_sym_requires,
    STATE(6085), 1,
      sym_trailing_return_type,
    ACTIONS(9407), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [253538] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(9754), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(9762), 1,
      anon_sym_EQ,
    ACTIONS(9992), 1,
      anon_sym_SEMI,
    STATE(2913), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(7436), 1,
      aux_sym_declaration_repeat1,
    STATE(7456), 1,
      sym_gnu_asm_expression,
    ACTIONS(9764), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8091), 2,
      sym_argument_list,
      sym_initializer_list,
  [253587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10284), 1,
      anon_sym_LBRACK,
    ACTIONS(10282), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [253612] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9334), 1,
      anon_sym_requires,
    STATE(6086), 1,
      sym_trailing_return_type,
    ACTIONS(9181), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [253649] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10226), 1,
      anon_sym_LT,
    ACTIONS(10230), 1,
      anon_sym_LBRACE,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(4988), 1,
      sym_compound_statement,
    STATE(6159), 1,
      sym_template_parameter_list,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7175), 1,
      sym_abstract_function_declarator,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [253698] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6718), 1,
      anon_sym_requires,
    ACTIONS(6822), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    STATE(6029), 1,
      sym_trailing_return_type,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [253735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9102), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [253760] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(9754), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(9762), 1,
      anon_sym_EQ,
    ACTIONS(9902), 1,
      anon_sym_SEMI,
    STATE(2913), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(7495), 1,
      sym_gnu_asm_expression,
    STATE(7572), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(9764), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8091), 2,
      sym_argument_list,
      sym_initializer_list,
  [253809] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(9754), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(10182), 1,
      anon_sym_SEMI,
    ACTIONS(10286), 1,
      anon_sym_EQ,
    STATE(2913), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(7515), 1,
      sym_initializer_list,
    STATE(7731), 1,
      sym_gnu_asm_expression,
    STATE(7732), 1,
      aux_sym_declaration_repeat1,
    STATE(8091), 1,
      sym_argument_list,
    ACTIONS(9764), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [253860] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10226), 1,
      anon_sym_LT,
    ACTIONS(10288), 1,
      anon_sym_LBRACE,
    STATE(1668), 1,
      sym_compound_statement,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6223), 1,
      sym_template_parameter_list,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7277), 1,
      sym_abstract_function_declarator,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [253909] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8015), 1,
      anon_sym_STAR,
    ACTIONS(8017), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8019), 1,
      anon_sym_AMP,
    STATE(3439), 1,
      sym_parameter_list,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6879), 1,
      sym__abstract_declarator,
    ACTIONS(8279), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [253950] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10218), 1,
      anon_sym_requires,
    ACTIONS(10262), 1,
      anon_sym_LBRACE,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(3743), 1,
      sym_compound_statement,
    STATE(6296), 1,
      sym_requires_clause,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7274), 1,
      sym_abstract_function_declarator,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [253999] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(7987), 1,
      sym_identifier,
    ACTIONS(7989), 1,
      anon_sym_LPAREN2,
    ACTIONS(7991), 1,
      anon_sym_STAR,
    ACTIONS(7993), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7995), 1,
      anon_sym_AMP,
    STATE(6867), 1,
      sym__field_declarator,
    STATE(7018), 1,
      sym_operator_name,
    STATE(8384), 1,
      sym_ms_based_modifier,
    STATE(6748), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [254042] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6822), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9063), 1,
      anon_sym_requires,
    STATE(6019), 1,
      sym_trailing_return_type,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [254079] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10218), 1,
      anon_sym_requires,
    ACTIONS(10228), 1,
      anon_sym_LBRACE,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(3773), 1,
      sym_compound_statement,
    STATE(6373), 1,
      sym_requires_clause,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7288), 1,
      sym_abstract_function_declarator,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [254128] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      anon_sym_DASH_GT,
    ACTIONS(6813), 1,
      anon_sym_requires,
    ACTIONS(10048), 1,
      anon_sym_LBRACK,
    STATE(6002), 1,
      sym_trailing_return_type,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6224), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [254165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10292), 1,
      anon_sym_LBRACK,
    ACTIONS(10290), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [254190] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10218), 1,
      anon_sym_requires,
    STATE(1666), 1,
      sym_compound_statement,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6295), 1,
      sym_requires_clause,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7236), 1,
      sym_abstract_function_declarator,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [254239] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10218), 1,
      anon_sym_requires,
    ACTIONS(10264), 1,
      anon_sym_LBRACE,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(4173), 1,
      sym_compound_statement,
    STATE(6342), 1,
      sym_requires_clause,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7297), 1,
      sym_abstract_function_declarator,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [254288] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(7989), 1,
      anon_sym_LPAREN2,
    ACTIONS(7997), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_STAR,
    ACTIONS(8001), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8003), 1,
      anon_sym_AMP,
    STATE(6466), 1,
      sym__field_declarator,
    STATE(6635), 1,
      sym_operator_name,
    STATE(8417), 1,
      sym_ms_based_modifier,
    STATE(6748), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [254331] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10218), 1,
      anon_sym_requires,
    ACTIONS(10280), 1,
      anon_sym_LBRACE,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(3954), 1,
      sym_compound_statement,
    STATE(6302), 1,
      sym_requires_clause,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7287), 1,
      sym_abstract_function_declarator,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [254380] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      anon_sym_DASH_GT,
    ACTIONS(6813), 1,
      anon_sym_requires,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    STATE(6022), 1,
      sym_trailing_return_type,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [254417] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      anon_sym_DASH_GT,
    ACTIONS(6813), 1,
      anon_sym_requires,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    STATE(6023), 1,
      sym_trailing_return_type,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [254454] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      anon_sym_DASH_GT,
    ACTIONS(6813), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    STATE(6103), 1,
      sym_trailing_return_type,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [254491] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10226), 1,
      anon_sym_LT,
    ACTIONS(10256), 1,
      anon_sym_LBRACE,
    STATE(2666), 1,
      sym_compound_statement,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6172), 1,
      sym_template_parameter_list,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7147), 1,
      sym_abstract_function_declarator,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [254540] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10294), 1,
      sym_identifier,
    ACTIONS(5307), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(6222), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(10276), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10278), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [254571] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(7989), 1,
      anon_sym_LPAREN2,
    ACTIONS(7997), 1,
      sym_identifier,
    ACTIONS(7999), 1,
      anon_sym_STAR,
    ACTIONS(8001), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8003), 1,
      anon_sym_AMP,
    STATE(6367), 1,
      sym__field_declarator,
    STATE(6635), 1,
      sym_operator_name,
    STATE(8417), 1,
      sym_ms_based_modifier,
    STATE(6748), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [254614] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym___based,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(7987), 1,
      sym_identifier,
    ACTIONS(7989), 1,
      anon_sym_LPAREN2,
    ACTIONS(7991), 1,
      anon_sym_STAR,
    ACTIONS(7993), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7995), 1,
      anon_sym_AMP,
    STATE(6872), 1,
      sym__field_declarator,
    STATE(7018), 1,
      sym_operator_name,
    STATE(8384), 1,
      sym_ms_based_modifier,
    STATE(6748), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [254657] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(9754), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(9762), 1,
      anon_sym_EQ,
    ACTIONS(9830), 1,
      anon_sym_SEMI,
    STATE(2913), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(7663), 1,
      aux_sym_declaration_repeat1,
    STATE(7665), 1,
      sym_gnu_asm_expression,
    ACTIONS(9764), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8091), 2,
      sym_argument_list,
      sym_initializer_list,
  [254706] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4000), 1,
      anon_sym_COLON,
    ACTIONS(8277), 1,
      anon_sym_LT,
    STATE(2875), 1,
      sym_template_argument_list,
    ACTIONS(4007), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [254737] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10226), 1,
      anon_sym_LT,
    STATE(1668), 1,
      sym_compound_statement,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6208), 1,
      sym_template_parameter_list,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7247), 1,
      sym_abstract_function_declarator,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [254786] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10296), 1,
      sym_identifier,
    ACTIONS(5267), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(6222), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(10299), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10302), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [254817] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10218), 1,
      anon_sym_requires,
    ACTIONS(10288), 1,
      anon_sym_LBRACE,
    STATE(1666), 1,
      sym_compound_statement,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6332), 1,
      sym_requires_clause,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(7315), 1,
      sym_abstract_function_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [254866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10058), 1,
      anon_sym_LBRACK,
    ACTIONS(10056), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [254891] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9806), 1,
      anon_sym_TILDE,
    ACTIONS(10305), 1,
      sym_identifier,
    ACTIONS(10307), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10310), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10312), 1,
      anon_sym_template,
    STATE(6526), 1,
      sym__scope_resolution,
    STATE(7860), 1,
      sym_operator_name,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(3764), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [254933] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6977), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9361), 1,
      anon_sym_requires,
    STATE(6423), 1,
      sym_trailing_return_type,
    ACTIONS(9181), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [254969] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6977), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9096), 1,
      anon_sym_requires,
    STATE(6422), 1,
      sym_trailing_return_type,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [255005] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10317), 1,
      anon_sym_requires,
    ACTIONS(10314), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6410), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10056), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [255035] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7437), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10320), 1,
      sym_identifier,
    ACTIONS(10322), 1,
      sym_primitive_type,
    STATE(2157), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(2488), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2723), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [255075] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10175), 1,
      anon_sym_requires,
    ACTIONS(10172), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6405), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [255105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4927), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [255127] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10324), 1,
      sym_identifier,
    ACTIONS(10326), 1,
      sym_primitive_type,
    STATE(2324), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(2458), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9167), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [255167] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3552), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10328), 1,
      sym_identifier,
    ACTIONS(10330), 1,
      sym_primitive_type,
    STATE(2507), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6810), 1,
      sym__scope_resolution,
    STATE(2178), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(3554), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [255207] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10332), 1,
      sym_identifier,
    ACTIONS(10334), 1,
      sym_primitive_type,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(2093), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [255247] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6192), 1,
      anon_sym_LT,
    STATE(6387), 1,
      sym_template_argument_list,
    ACTIONS(6992), 2,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(4810), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [255277] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9395), 1,
      anon_sym_requires,
    ACTIONS(9392), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6399), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [255307] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6192), 1,
      anon_sym_LT,
    STATE(6387), 1,
      sym_template_argument_list,
    ACTIONS(4009), 2,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(4002), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [255337] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9189), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10336), 1,
      sym_identifier,
    ACTIONS(10338), 1,
      sym_primitive_type,
    STATE(2590), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6836), 1,
      sym__scope_resolution,
    STATE(3055), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9191), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [255377] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4915), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [255399] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10340), 1,
      sym_identifier,
    ACTIONS(10342), 1,
      sym_primitive_type,
    STATE(4292), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6845), 1,
      sym__scope_resolution,
    STATE(4893), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(7184), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [255439] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9109), 1,
      anon_sym_requires,
    ACTIONS(9106), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [255469] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4923), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [255491] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7404), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10344), 1,
      sym_identifier,
    ACTIONS(10346), 1,
      sym_primitive_type,
    STATE(4392), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(5154), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(7406), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [255531] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9020), 1,
      anon_sym_requires,
    ACTIONS(9017), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [255561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4947), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [255583] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6977), 1,
      anon_sym_DASH_GT,
    ACTIONS(6979), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    STATE(6415), 1,
      sym_trailing_return_type,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [255619] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4947), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [255641] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10348), 1,
      sym_identifier,
    ACTIONS(10350), 1,
      sym_primitive_type,
    STATE(2173), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6858), 1,
      sym__scope_resolution,
    STATE(2178), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(55), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [255681] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10352), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5392), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [255707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4931), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [255729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4951), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [255751] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6925), 1,
      sym__abstract_declarator,
    ACTIONS(8279), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [255791] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6977), 1,
      anon_sym_DASH_GT,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9430), 1,
      anon_sym_requires,
    STATE(6424), 1,
      sym_trailing_return_type,
    ACTIONS(9407), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [255827] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6676), 1,
      anon_sym_requires,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [255857] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9211), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10356), 1,
      sym_identifier,
    ACTIONS(10358), 1,
      sym_primitive_type,
    STATE(3828), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6855), 1,
      sym__scope_resolution,
    STATE(4338), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9213), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [255897] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4911), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [255919] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10360), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6257), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(10146), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [255945] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9233), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10334), 1,
      sym_primitive_type,
    ACTIONS(10363), 1,
      sym_identifier,
    STATE(2048), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6864), 1,
      sym__scope_resolution,
    STATE(2093), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [255985] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10340), 1,
      sym_identifier,
    ACTIONS(10342), 1,
      sym_primitive_type,
    STATE(4292), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(4893), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(7184), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [256025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4919), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [256047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3652), 1,
      anon_sym_LBRACK,
    ACTIONS(3654), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [256071] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7511), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10328), 1,
      sym_identifier,
    ACTIONS(10330), 1,
      sym_primitive_type,
    STATE(2507), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6827), 1,
      sym__scope_resolution,
    STATE(2178), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(3554), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [256111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3648), 1,
      anon_sym_LBRACK,
    ACTIONS(3650), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [256135] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8041), 1,
      anon_sym_STAR,
    ACTIONS(8043), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8045), 1,
      anon_sym_AMP,
    STATE(3079), 1,
      sym_parameter_list,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6947), 1,
      sym__abstract_declarator,
    ACTIONS(8279), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [256175] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6222), 1,
      anon_sym_LBRACK,
    ACTIONS(10365), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6224), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [256201] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(9754), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(9762), 1,
      anon_sym_EQ,
    STATE(2913), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(7948), 1,
      sym_gnu_asm_expression,
    ACTIONS(9764), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10367), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8091), 2,
      sym_argument_list,
      sym_initializer_list,
  [256245] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10348), 1,
      sym_identifier,
    ACTIONS(10350), 1,
      sym_primitive_type,
    STATE(2173), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(2178), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(55), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [256285] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9250), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10369), 1,
      sym_identifier,
    ACTIONS(10371), 1,
      sym_primitive_type,
    STATE(2771), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6853), 1,
      sym__scope_resolution,
    STATE(3497), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9252), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [256325] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9272), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10373), 1,
      sym_identifier,
    ACTIONS(10375), 1,
      sym_primitive_type,
    STATE(4208), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6829), 1,
      sym__scope_resolution,
    STATE(4683), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9274), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [256365] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6977), 1,
      anon_sym_DASH_GT,
    ACTIONS(6979), 1,
      anon_sym_requires,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    STATE(6400), 1,
      sym_trailing_return_type,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [256401] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6676), 1,
      anon_sym_requires,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [256431] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4955), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [256453] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6676), 1,
      anon_sym_requires,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6405), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [256483] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6977), 1,
      anon_sym_DASH_GT,
    ACTIONS(10048), 1,
      anon_sym_LBRACK,
    ACTIONS(10377), 1,
      anon_sym_requires,
    STATE(6378), 1,
      sym_trailing_return_type,
    ACTIONS(10050), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6224), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [256519] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6257), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(10060), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [256545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10354), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5404), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [256569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4935), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [256591] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10380), 1,
      sym_identifier,
    ACTIONS(10382), 1,
      sym_primitive_type,
    STATE(5342), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(2093), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(7288), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [256631] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10384), 1,
      sym_identifier,
    ACTIONS(10386), 1,
      sym_primitive_type,
    STATE(2367), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(2458), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9138), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [256671] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9114), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10388), 1,
      sym_identifier,
    ACTIONS(10390), 1,
      sym_primitive_type,
    STATE(2642), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6861), 1,
      sym__scope_resolution,
    STATE(3187), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9116), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [256711] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6977), 1,
      anon_sym_DASH_GT,
    ACTIONS(6979), 1,
      anon_sym_requires,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    STATE(6396), 1,
      sym_trailing_return_type,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [256747] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6676), 1,
      anon_sym_requires,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6399), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [256777] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4939), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [256799] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6676), 1,
      anon_sym_requires,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6410), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10056), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [256829] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1899), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [256851] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6977), 1,
      anon_sym_DASH_GT,
    ACTIONS(6979), 1,
      anon_sym_requires,
    ACTIONS(10048), 1,
      anon_sym_LBRACK,
    STATE(6506), 1,
      sym_trailing_return_type,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6224), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [256887] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9294), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10392), 1,
      sym_identifier,
    ACTIONS(10394), 1,
      sym_primitive_type,
    STATE(2715), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6809), 1,
      sym__scope_resolution,
    STATE(3166), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9296), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [256927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4943), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [256949] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10398), 1,
      anon_sym___attribute__,
    ACTIONS(10403), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(10401), 3,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    STATE(6289), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
    ACTIONS(10396), 7,
      anon_sym___declspec,
      anon_sym_COLON,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
  [256979] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4947), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [257001] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1895), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [257023] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9316), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10322), 1,
      sym_primitive_type,
    ACTIONS(10406), 1,
      sym_identifier,
    STATE(2157), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6846), 1,
      sym__scope_resolution,
    STATE(2488), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2723), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [257063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4969), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [257085] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2839), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10408), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [257114] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    STATE(1671), 1,
      sym_compound_statement,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7234), 1,
      sym_abstract_function_declarator,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [257157] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10262), 1,
      anon_sym_LBRACE,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(3713), 1,
      sym_compound_statement,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(7314), 1,
      sym_abstract_function_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [257200] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6192), 1,
      anon_sym_LT,
    ACTIONS(6198), 1,
      anon_sym_LBRACK,
    STATE(6387), 1,
      sym_template_argument_list,
    ACTIONS(6200), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [257227] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2924), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10412), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [257256] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10260), 1,
      anon_sym_LBRACE,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6026), 1,
      sym_compound_statement,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(7334), 1,
      sym_abstract_function_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [257299] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2839), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10414), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [257328] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2839), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10416), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [257357] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10280), 1,
      anon_sym_LBRACE,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(4022), 1,
      sym_compound_statement,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7285), 1,
      sym_abstract_function_declarator,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [257400] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2839), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10418), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [257429] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2924), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10420), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [257458] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2839), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10422), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [257487] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2839), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10420), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [257516] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2839), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10412), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [257545] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2924), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10422), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [257574] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2839), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10424), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [257603] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10426), 1,
      anon_sym_LBRACK,
    STATE(6520), 1,
      sym_parameter_list,
    STATE(6505), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5907), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [257634] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10222), 1,
      sym_identifier,
    STATE(6352), 1,
      sym_string_literal,
    STATE(6675), 1,
      sym_raw_string_literal,
    STATE(7473), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [257665] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10426), 1,
      anon_sym_LBRACK,
    STATE(6520), 1,
      sym_parameter_list,
    STATE(6505), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5833), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [257696] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2924), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10418), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [257725] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10256), 1,
      anon_sym_LBRACE,
    STATE(2688), 1,
      sym_compound_statement,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(7307), 1,
      sym_abstract_function_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [257768] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10222), 1,
      sym_identifier,
    STATE(6352), 1,
      sym_string_literal,
    STATE(6675), 1,
      sym_raw_string_literal,
    STATE(7704), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [257799] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10222), 1,
      sym_identifier,
    STATE(6352), 1,
      sym_string_literal,
    STATE(6675), 1,
      sym_raw_string_literal,
    STATE(7406), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [257830] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10258), 1,
      anon_sym_LBRACE,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6283), 1,
      sym_compound_statement,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7197), 1,
      sym_abstract_function_declarator,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [257873] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10426), 1,
      anon_sym_LBRACK,
    STATE(6520), 1,
      sym_parameter_list,
    STATE(6505), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5899), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [257904] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2924), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10416), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [257933] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2924), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10408), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [257962] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9822), 1,
      anon_sym_TILDE,
    ACTIONS(10428), 1,
      sym_identifier,
    ACTIONS(10430), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10432), 1,
      anon_sym_template,
    STATE(6561), 1,
      sym__scope_resolution,
    STATE(7869), 1,
      sym_operator_name,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(3949), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [258001] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10222), 1,
      sym_identifier,
    STATE(6352), 1,
      sym_string_literal,
    STATE(6675), 1,
      sym_raw_string_literal,
    STATE(7581), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [258032] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10222), 1,
      sym_identifier,
    STATE(6352), 1,
      sym_string_literal,
    STATE(6675), 1,
      sym_raw_string_literal,
    STATE(7794), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [258063] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10222), 1,
      sym_identifier,
    STATE(6352), 1,
      sym_string_literal,
    STATE(6675), 1,
      sym_raw_string_literal,
    STATE(7709), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [258094] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10222), 1,
      sym_identifier,
    STATE(6352), 1,
      sym_string_literal,
    STATE(6675), 1,
      sym_raw_string_literal,
    STATE(7413), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [258125] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6840), 1,
      anon_sym_DASH_GT,
    ACTIONS(6990), 1,
      anon_sym_requires,
    STATE(6500), 1,
      sym_trailing_return_type,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [258158] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2924), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10414), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [258187] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10222), 1,
      sym_identifier,
    STATE(6352), 1,
      sym_string_literal,
    STATE(6675), 1,
      sym_raw_string_literal,
    STATE(7620), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [258218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6222), 1,
      anon_sym_LBRACK,
    ACTIONS(6224), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [258241] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(10436), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10438), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10440), 1,
      aux_sym_preproc_elif_token1,
    STATE(6705), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(6706), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(6953), 1,
      sym_enumerator,
    ACTIONS(10442), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8238), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(8264), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [258280] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(10438), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10440), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10444), 1,
      aux_sym_preproc_if_token2,
    STATE(6717), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(6752), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(6953), 1,
      sym_enumerator,
    ACTIONS(10442), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8890), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(8893), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [258319] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10288), 1,
      anon_sym_LBRACE,
    STATE(1671), 1,
      sym_compound_statement,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(7337), 1,
      sym_abstract_function_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [258362] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9806), 1,
      anon_sym_TILDE,
    ACTIONS(10305), 1,
      sym_identifier,
    ACTIONS(10310), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10312), 1,
      anon_sym_template,
    STATE(6526), 1,
      sym__scope_resolution,
    STATE(7860), 1,
      sym_operator_name,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(3764), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [258401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6366), 1,
      anon_sym_LBRACK,
    ACTIONS(6368), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [258424] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2924), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10424), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [258453] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10222), 1,
      sym_identifier,
    STATE(6352), 1,
      sym_string_literal,
    STATE(6675), 1,
      sym_raw_string_literal,
    STATE(7763), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [258484] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6840), 1,
      anon_sym_DASH_GT,
    ACTIONS(6990), 1,
      anon_sym_requires,
    STATE(6392), 1,
      sym_trailing_return_type,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [258517] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10222), 1,
      sym_identifier,
    STATE(6352), 1,
      sym_string_literal,
    STATE(6675), 1,
      sym_raw_string_literal,
    STATE(7696), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [258548] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10426), 1,
      anon_sym_LBRACK,
    STATE(6520), 1,
      sym_parameter_list,
    STATE(6505), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5845), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [258579] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10426), 1,
      anon_sym_LBRACK,
    STATE(6520), 1,
      sym_parameter_list,
    STATE(6505), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5925), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [258610] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10424), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [258639] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10264), 1,
      anon_sym_LBRACE,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(4163), 1,
      sym_compound_statement,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(7321), 1,
      sym_abstract_function_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [258682] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10216), 1,
      anon_sym_LBRACE,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(5191), 1,
      sym_compound_statement,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7231), 1,
      sym_abstract_function_declarator,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [258725] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10412), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [258754] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6840), 1,
      anon_sym_DASH_GT,
    ACTIONS(9099), 1,
      anon_sym_requires,
    STATE(6412), 1,
      sym_trailing_return_type,
    ACTIONS(9017), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [258787] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10222), 1,
      sym_identifier,
    STATE(6352), 1,
      sym_string_literal,
    STATE(6675), 1,
      sym_raw_string_literal,
    STATE(7503), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [258818] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10222), 1,
      sym_identifier,
    STATE(6352), 1,
      sym_string_literal,
    STATE(6675), 1,
      sym_raw_string_literal,
    STATE(7470), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [258849] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9888), 1,
      anon_sym_TILDE,
    ACTIONS(10446), 1,
      sym_identifier,
    ACTIONS(10448), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10450), 1,
      anon_sym_template,
    STATE(6569), 1,
      sym__scope_resolution,
    STATE(8182), 1,
      sym_operator_name,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(3914), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [258888] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10420), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [258917] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6840), 1,
      anon_sym_DASH_GT,
    ACTIONS(9345), 1,
      anon_sym_requires,
    STATE(6401), 1,
      sym_trailing_return_type,
    ACTIONS(9106), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [258950] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10422), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [258979] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6188), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(5712), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(10276), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10278), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [259006] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10222), 1,
      sym_identifier,
    STATE(6352), 1,
      sym_string_literal,
    STATE(6675), 1,
      sym_raw_string_literal,
    STATE(7381), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [259037] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5986), 1,
      anon_sym_LBRACK,
    ACTIONS(10452), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6354), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5988), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [259064] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10222), 1,
      sym_identifier,
    STATE(6352), 1,
      sym_string_literal,
    STATE(6675), 1,
      sym_raw_string_literal,
    STATE(7568), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [259095] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10418), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [259124] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(10438), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10440), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10455), 1,
      aux_sym_preproc_if_token2,
    STATE(6682), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(6704), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(6953), 1,
      sym_enumerator,
    ACTIONS(10442), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8741), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(8742), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [259163] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10222), 1,
      sym_identifier,
    STATE(6352), 1,
      sym_string_literal,
    STATE(6675), 1,
      sym_raw_string_literal,
    STATE(7422), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [259194] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10222), 1,
      sym_identifier,
    STATE(6352), 1,
      sym_string_literal,
    STATE(6675), 1,
      sym_raw_string_literal,
    STATE(7442), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [259225] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10222), 1,
      sym_identifier,
    STATE(6352), 1,
      sym_string_literal,
    STATE(6675), 1,
      sym_raw_string_literal,
    STATE(7681), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [259256] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10416), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [259285] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6840), 1,
      anon_sym_DASH_GT,
    ACTIONS(9475), 1,
      anon_sym_requires,
    STATE(6398), 1,
      sym_trailing_return_type,
    ACTIONS(9392), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6399), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [259318] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10230), 1,
      anon_sym_LBRACE,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(4846), 1,
      sym_compound_statement,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7132), 1,
      sym_abstract_function_declarator,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [259361] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9744), 1,
      anon_sym_TILDE,
    ACTIONS(10457), 1,
      sym_identifier,
    ACTIONS(10459), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10461), 1,
      anon_sym_template,
    STATE(6523), 1,
      sym__scope_resolution,
    STATE(8190), 1,
      sym_operator_name,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(2639), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [259400] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(10438), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10440), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10463), 1,
      aux_sym_preproc_if_token2,
    STATE(6686), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(6743), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(6953), 1,
      sym_enumerator,
    ACTIONS(10442), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8526), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(8528), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [259439] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10220), 1,
      anon_sym_LBRACE,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(4015), 1,
      sym_compound_statement,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7192), 1,
      sym_abstract_function_declarator,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [259482] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9503), 1,
      anon_sym_LBRACK,
    ACTIONS(9507), 1,
      anon_sym_COLON,
    ACTIONS(10467), 1,
      anon_sym_EQ,
    STATE(2849), 1,
      sym_parameter_list,
    STATE(6683), 1,
      sym__function_declarator_seq,
    STATE(7589), 1,
      sym_initializer_list,
    STATE(7592), 1,
      sym_bitfield_clause,
    STATE(6676), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10465), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [259525] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9744), 1,
      anon_sym_TILDE,
    ACTIONS(10457), 1,
      sym_identifier,
    ACTIONS(10469), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10471), 1,
      anon_sym_template,
    STATE(6557), 1,
      sym__scope_resolution,
    STATE(8124), 1,
      sym_operator_name,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(2639), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [259564] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10222), 1,
      sym_identifier,
    STATE(6352), 1,
      sym_string_literal,
    STATE(6675), 1,
      sym_raw_string_literal,
    STATE(7718), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [259595] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10408), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [259624] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6840), 1,
      anon_sym_DASH_GT,
    ACTIONS(10473), 1,
      anon_sym_requires,
    STATE(6395), 1,
      sym_trailing_return_type,
    ACTIONS(10172), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6405), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [259657] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10222), 1,
      sym_identifier,
    STATE(6352), 1,
      sym_string_literal,
    STATE(6675), 1,
      sym_raw_string_literal,
    STATE(7528), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [259688] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(10228), 1,
      anon_sym_LBRACE,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(3774), 1,
      sym_compound_statement,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7086), 1,
      sym_abstract_function_declarator,
    STATE(7298), 1,
      sym__abstract_declarator,
    STATE(6430), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [259731] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6840), 1,
      anon_sym_DASH_GT,
    ACTIONS(6990), 1,
      anon_sym_requires,
    STATE(6406), 1,
      sym_trailing_return_type,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6405), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [259764] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10414), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [259793] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6840), 1,
      anon_sym_DASH_GT,
    ACTIONS(6990), 1,
      anon_sym_requires,
    STATE(6403), 1,
      sym_trailing_return_type,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6399), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [259826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9102), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [259846] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10058), 1,
      anon_sym_LBRACK,
    ACTIONS(10476), 1,
      anon_sym_requires,
    ACTIONS(10111), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6153), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10056), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [259876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10290), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [259896] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5913), 1,
      anon_sym_LBRACE,
    ACTIONS(7437), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9350), 1,
      sym_identifier,
    STATE(2361), 1,
      sym_template_type,
    STATE(2436), 1,
      sym_enumerator_list,
    STATE(6832), 1,
      sym__scope_resolution,
    ACTIONS(10479), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(5144), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [259936] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7026), 1,
      anon_sym_DASH_GT,
    ACTIONS(7037), 1,
      anon_sym_requires,
    STATE(6629), 1,
      sym_trailing_return_type,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [259968] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7026), 1,
      anon_sym_DASH_GT,
    ACTIONS(7037), 1,
      anon_sym_requires,
    STATE(6633), 1,
      sym_trailing_return_type,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [260000] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7026), 1,
      anon_sym_DASH_GT,
    ACTIONS(7037), 1,
      anon_sym_requires,
    STATE(6634), 1,
      sym_trailing_return_type,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6399), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [260032] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7026), 1,
      anon_sym_DASH_GT,
    ACTIONS(7037), 1,
      anon_sym_requires,
    STATE(6637), 1,
      sym_trailing_return_type,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6405), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [260064] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10222), 1,
      sym_identifier,
    STATE(8413), 1,
      sym_concatenated_string,
    STATE(6513), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [260092] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    STATE(2897), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6622), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10481), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [260124] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4151), 2,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(4144), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [260148] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7026), 1,
      anon_sym_DASH_GT,
    ACTIONS(9245), 1,
      anon_sym_requires,
    STATE(6653), 1,
      sym_trailing_return_type,
    ACTIONS(9017), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [260180] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7026), 1,
      anon_sym_DASH_GT,
    ACTIONS(9382), 1,
      anon_sym_requires,
    STATE(6655), 1,
      sym_trailing_return_type,
    ACTIONS(9106), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [260212] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7026), 1,
      anon_sym_DASH_GT,
    ACTIONS(9494), 1,
      anon_sym_requires,
    STATE(6657), 1,
      sym_trailing_return_type,
    ACTIONS(9392), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6399), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [260244] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9388), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [260264] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6990), 1,
      anon_sym_requires,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6399), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [260292] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7026), 1,
      anon_sym_DASH_GT,
    ACTIONS(10483), 1,
      anon_sym_requires,
    STATE(6662), 1,
      sym_trailing_return_type,
    ACTIONS(10172), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6405), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [260324] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 1,
      anon_sym_LBRACE,
    ACTIONS(6992), 1,
      anon_sym_LBRACK,
    ACTIONS(10486), 1,
      anon_sym_SEMI,
    ACTIONS(10488), 1,
      anon_sym_EQ,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    ACTIONS(10492), 1,
      anon_sym_try,
    STATE(467), 1,
      sym_compound_statement,
    STATE(8133), 1,
      sym_field_initializer_list,
    ACTIONS(4810), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(468), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [260362] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10494), 1,
      anon_sym_requires,
    ACTIONS(10314), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6410), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10056), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [260390] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_requires,
    ACTIONS(10048), 1,
      anon_sym_LBRACK,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6224), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [260420] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    ACTIONS(6992), 1,
      anon_sym_LBRACK,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    ACTIONS(10497), 1,
      anon_sym_SEMI,
    ACTIONS(10499), 1,
      anon_sym_EQ,
    ACTIONS(10501), 1,
      anon_sym_try,
    STATE(183), 1,
      sym_compound_statement,
    STATE(7945), 1,
      sym_field_initializer_list,
    ACTIONS(4810), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(189), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [260458] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10473), 1,
      anon_sym_requires,
    ACTIONS(10172), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6405), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [260486] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10046), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [260506] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_requires,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [260536] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9475), 1,
      anon_sym_requires,
    ACTIONS(9392), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6399), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [260564] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6647), 1,
      anon_sym_LBRACE,
    ACTIONS(9189), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9354), 1,
      sym_identifier,
    STATE(2794), 1,
      sym_template_type,
    STATE(3007), 1,
      sym_enumerator_list,
    STATE(6836), 1,
      sym__scope_resolution,
    ACTIONS(10503), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2832), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [260604] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6990), 1,
      anon_sym_requires,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6405), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [260632] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9503), 1,
      anon_sym_LBRACK,
    STATE(2849), 1,
      sym_parameter_list,
    STATE(6683), 1,
      sym__function_declarator_seq,
    STATE(6676), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10505), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [260664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10056), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [260684] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6990), 1,
      anon_sym_requires,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6410), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10056), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [260712] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5921), 1,
      anon_sym_LBRACE,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2492), 1,
      sym_enumerator_list,
    STATE(6816), 1,
      sym__scope_resolution,
    ACTIONS(10507), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2559), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [260752] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10222), 1,
      sym_identifier,
    STATE(8363), 1,
      sym_concatenated_string,
    STATE(6525), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [260780] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6706), 1,
      anon_sym_LBRACE,
    ACTIONS(9294), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9372), 1,
      sym_identifier,
    STATE(2848), 1,
      sym_template_type,
    STATE(3034), 1,
      sym_enumerator_list,
    STATE(6809), 1,
      sym__scope_resolution,
    ACTIONS(10509), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2843), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [260820] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10212), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [260840] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(6992), 1,
      anon_sym_LBRACK,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    ACTIONS(10511), 1,
      anon_sym_SEMI,
    ACTIONS(10513), 1,
      anon_sym_EQ,
    ACTIONS(10515), 1,
      anon_sym_try,
    STATE(765), 1,
      sym_compound_statement,
    STATE(7995), 1,
      sym_field_initializer_list,
    ACTIONS(4810), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(757), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [260878] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9345), 1,
      anon_sym_requires,
    ACTIONS(9106), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [260906] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5913), 1,
      anon_sym_LBRACE,
    ACTIONS(9316), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9341), 1,
      sym_identifier,
    STATE(2361), 1,
      sym_template_type,
    STATE(2436), 1,
      sym_enumerator_list,
    STATE(6846), 1,
      sym__scope_resolution,
    ACTIONS(10517), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4371), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [260946] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10222), 1,
      sym_identifier,
    STATE(8519), 1,
      sym_concatenated_string,
    STATE(6551), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [260974] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_requires,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [261004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10252), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [261024] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7899), 1,
      anon_sym_LBRACE,
    ACTIONS(9211), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9366), 1,
      sym_identifier,
    STATE(4104), 1,
      sym_template_type,
    STATE(4279), 1,
      sym_enumerator_list,
    STATE(6855), 1,
      sym__scope_resolution,
    ACTIONS(10519), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4083), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [261064] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9096), 1,
      anon_sym_requires,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [261094] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2786), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10414), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [261122] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6992), 1,
      anon_sym_LBRACK,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    ACTIONS(10523), 1,
      anon_sym_SEMI,
    ACTIONS(10525), 1,
      anon_sym_LBRACE,
    ACTIONS(10527), 1,
      anon_sym_EQ,
    ACTIONS(10529), 1,
      anon_sym_try,
    STATE(1925), 1,
      sym_compound_statement,
    STATE(7819), 1,
      sym_field_initializer_list,
    ACTIONS(4810), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1902), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [261160] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(619), 1,
      anon_sym_LBRACE,
    ACTIONS(6992), 1,
      anon_sym_LBRACK,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    ACTIONS(10531), 1,
      anon_sym_SEMI,
    ACTIONS(10533), 1,
      anon_sym_EQ,
    ACTIONS(10535), 1,
      anon_sym_try,
    STATE(571), 1,
      sym_compound_statement,
    STATE(7937), 1,
      sym_field_initializer_list,
    ACTIONS(4810), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(576), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [261198] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9361), 1,
      anon_sym_requires,
    ACTIONS(9181), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [261228] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9430), 1,
      anon_sym_requires,
    ACTIONS(9407), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [261258] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10048), 1,
      anon_sym_LBRACK,
    ACTIONS(10377), 1,
      anon_sym_requires,
    ACTIONS(10050), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6224), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [261288] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3552), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(6790), 1,
      sym_access_specifier,
    STATE(6810), 1,
      sym__scope_resolution,
    STATE(7250), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10180), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [261326] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2786), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10408), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [261354] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2786), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10416), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [261382] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5390), 1,
      anon_sym_LBRACK,
    ACTIONS(10537), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10539), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5392), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [261408] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9099), 1,
      anon_sym_requires,
    ACTIONS(9017), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [261436] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10248), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [261456] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6992), 1,
      anon_sym_LBRACK,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    ACTIONS(10541), 1,
      anon_sym_SEMI,
    ACTIONS(10543), 1,
      anon_sym_LBRACE,
    ACTIONS(10545), 1,
      anon_sym_EQ,
    ACTIONS(10547), 1,
      anon_sym_try,
    STATE(2079), 1,
      sym_compound_statement,
    STATE(7852), 1,
      sym_field_initializer_list,
    ACTIONS(4810), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2080), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [261494] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8226), 1,
      anon_sym_LBRACE,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(4734), 1,
      sym_enumerator_list,
    STATE(6845), 1,
      sym__scope_resolution,
    ACTIONS(10549), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(5234), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [261534] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10244), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [261554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10240), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [261574] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10236), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [261594] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    STATE(2913), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10551), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [261626] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6992), 1,
      anon_sym_LBRACK,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    ACTIONS(10553), 1,
      anon_sym_SEMI,
    ACTIONS(10555), 1,
      anon_sym_LBRACE,
    ACTIONS(10557), 1,
      anon_sym_EQ,
    ACTIONS(10559), 1,
      anon_sym_try,
    STATE(1810), 1,
      sym_compound_statement,
    STATE(7962), 1,
      sym_field_initializer_list,
    ACTIONS(4810), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1809), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [261664] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5772), 1,
      anon_sym_LBRACE,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9380), 1,
      sym_identifier,
    STATE(2280), 1,
      sym_template_type,
    STATE(2334), 1,
      sym_enumerator_list,
    STATE(6839), 1,
      sym__scope_resolution,
    ACTIONS(10561), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2467), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [261704] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9503), 1,
      anon_sym_LBRACK,
    STATE(2849), 1,
      sym_parameter_list,
    STATE(6683), 1,
      sym__function_declarator_seq,
    STATE(6676), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10563), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [261736] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7404), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8320), 1,
      anon_sym_LBRACE,
    ACTIONS(9376), 1,
      sym_identifier,
    STATE(4532), 1,
      sym_template_type,
    STATE(5102), 1,
      sym_enumerator_list,
    STATE(6833), 1,
      sym__scope_resolution,
    ACTIONS(10565), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4560), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [261776] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10232), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [261796] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10222), 1,
      sym_identifier,
    STATE(8478), 1,
      sym_concatenated_string,
    STATE(6509), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [261824] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [261854] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2786), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10418), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [261882] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2786), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10422), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [261910] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_LBRACK,
    ACTIONS(10539), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5404), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [261934] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2786), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10420), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [261962] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2786), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10412), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [261990] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10222), 1,
      sym_identifier,
    STATE(8429), 1,
      sym_concatenated_string,
    STATE(6545), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [262018] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9368), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(5359), 1,
      sym_enumerator_list,
    STATE(6821), 1,
      sym__scope_resolution,
    ACTIONS(10567), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(5074), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [262058] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    STATE(2913), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10569), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [262090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5462), 1,
      sym_identifier,
    ACTIONS(5464), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [262112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 1,
      sym_identifier,
    ACTIONS(5472), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [262134] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    STATE(2913), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10571), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [262166] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10222), 1,
      sym_identifier,
    STATE(8366), 1,
      sym_concatenated_string,
    STATE(6599), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [262194] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10573), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5404), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [262216] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6877), 1,
      anon_sym_LBRACE,
    ACTIONS(9250), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9370), 1,
      sym_identifier,
    STATE(2986), 1,
      sym_template_type,
    STATE(3280), 1,
      sym_enumerator_list,
    STATE(6853), 1,
      sym__scope_resolution,
    ACTIONS(10575), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2999), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [262256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10266), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [262276] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3552), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(6794), 1,
      sym_access_specifier,
    STATE(6810), 1,
      sym__scope_resolution,
    STATE(7564), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10180), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [262314] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(619), 1,
      anon_sym_LBRACE,
    ACTIONS(6992), 1,
      anon_sym_LBRACK,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    ACTIONS(10533), 1,
      anon_sym_EQ,
    ACTIONS(10535), 1,
      anon_sym_try,
    ACTIONS(10577), 1,
      anon_sym_SEMI,
    STATE(460), 1,
      sym_compound_statement,
    STATE(8014), 1,
      sym_field_initializer_list,
    ACTIONS(4810), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(592), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [262352] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10222), 1,
      sym_identifier,
    STATE(8266), 1,
      sym_concatenated_string,
    STATE(6584), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(151), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [262380] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 1,
      anon_sym_LBRACE,
    ACTIONS(6992), 1,
      anon_sym_LBRACK,
    ACTIONS(10488), 1,
      anon_sym_EQ,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    ACTIONS(10492), 1,
      anon_sym_try,
    ACTIONS(10579), 1,
      anon_sym_SEMI,
    STATE(486), 1,
      sym_compound_statement,
    STATE(8175), 1,
      sym_field_initializer_list,
    ACTIONS(4810), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(488), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [262418] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6992), 1,
      anon_sym_LBRACK,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    ACTIONS(10543), 1,
      anon_sym_LBRACE,
    ACTIONS(10545), 1,
      anon_sym_EQ,
    ACTIONS(10547), 1,
      anon_sym_try,
    ACTIONS(10581), 1,
      anon_sym_SEMI,
    STATE(1930), 1,
      sym_compound_statement,
    STATE(7930), 1,
      sym_field_initializer_list,
    ACTIONS(4810), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1931), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [262456] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6992), 1,
      anon_sym_LBRACK,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    ACTIONS(10555), 1,
      anon_sym_LBRACE,
    ACTIONS(10557), 1,
      anon_sym_EQ,
    ACTIONS(10559), 1,
      anon_sym_try,
    ACTIONS(10583), 1,
      anon_sym_SEMI,
    STATE(1793), 1,
      sym_compound_statement,
    STATE(8043), 1,
      sym_field_initializer_list,
    ACTIONS(4810), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1794), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [262494] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9503), 1,
      anon_sym_LBRACK,
    STATE(2849), 1,
      sym_parameter_list,
    STATE(6683), 1,
      sym__function_declarator_seq,
    STATE(6676), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10585), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [262526] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9503), 1,
      anon_sym_LBRACK,
    STATE(2849), 1,
      sym_parameter_list,
    STATE(6683), 1,
      sym__function_declarator_seq,
    STATE(6676), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10587), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [262558] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    STATE(2897), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6622), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10571), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [262590] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5921), 1,
      anon_sym_LBRACE,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2920), 1,
      sym_enumerator_list,
    STATE(6845), 1,
      sym__scope_resolution,
    ACTIONS(10589), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3078), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [262630] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3552), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(6780), 1,
      sym_access_specifier,
    STATE(6810), 1,
      sym__scope_resolution,
    STATE(7319), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10180), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [262668] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2786), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10424), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [262696] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3552), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(6797), 1,
      sym_access_specifier,
    STATE(6810), 1,
      sym__scope_resolution,
    STATE(7734), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10180), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [262734] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    STATE(2913), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10591), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [262766] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5921), 1,
      anon_sym_LBRACE,
    ACTIONS(9339), 1,
      sym_identifier,
    ACTIONS(9364), 1,
      anon_sym_COLON_COLON,
    STATE(2113), 1,
      sym_template_type,
    STATE(2492), 1,
      sym_enumerator_list,
    STATE(6823), 1,
      sym__scope_resolution,
    ACTIONS(10593), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3573), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [262806] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9013), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [262826] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    STATE(2913), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10481), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [262858] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8149), 1,
      anon_sym_STAR,
    ACTIONS(8151), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8153), 1,
      anon_sym_AMP,
    ACTIONS(8279), 1,
      anon_sym_COLON,
    STATE(3421), 1,
      sym_parameter_list,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7077), 1,
      sym__abstract_declarator,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [262896] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    STATE(2897), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6622), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10569), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [262928] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6990), 1,
      anon_sym_requires,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [262956] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    STATE(2897), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6622), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10551), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [262988] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10270), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [263008] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8226), 1,
      anon_sym_LBRACE,
    ACTIONS(9374), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(4734), 1,
      sym_enumerator_list,
    STATE(6831), 1,
      sym__scope_resolution,
    ACTIONS(10595), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4506), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [263048] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10599), 1,
      anon_sym_LBRACK,
    STATE(6354), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10597), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [263074] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    ACTIONS(6992), 1,
      anon_sym_LBRACK,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    ACTIONS(10499), 1,
      anon_sym_EQ,
    ACTIONS(10501), 1,
      anon_sym_try,
    ACTIONS(10601), 1,
      anon_sym_SEMI,
    STATE(226), 1,
      sym_compound_statement,
    STATE(7967), 1,
      sym_field_initializer_list,
    ACTIONS(4810), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(227), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [263112] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    STATE(2897), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6622), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10591), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [263144] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5921), 1,
      anon_sym_LBRACE,
    ACTIONS(9352), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2492), 1,
      sym_enumerator_list,
    STATE(6858), 1,
      sym__scope_resolution,
    ACTIONS(10603), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2757), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [263184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5458), 1,
      sym_identifier,
    ACTIONS(5460), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [263206] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(6992), 1,
      anon_sym_LBRACK,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    ACTIONS(10513), 1,
      anon_sym_EQ,
    ACTIONS(10515), 1,
      anon_sym_try,
    ACTIONS(10605), 1,
      anon_sym_SEMI,
    STATE(746), 1,
      sym_compound_statement,
    STATE(8169), 1,
      sym_field_initializer_list,
    ACTIONS(4810), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(743), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [263244] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10573), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10607), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(5392), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [263268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 1,
      sym_identifier,
    ACTIONS(5502), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [263290] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5921), 1,
      anon_sym_LBRACE,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9374), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2920), 1,
      sym_enumerator_list,
    STATE(6831), 1,
      sym__scope_resolution,
    ACTIONS(10609), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4432), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [263330] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(9233), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9343), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(2229), 1,
      sym_enumerator_list,
    STATE(6864), 1,
      sym__scope_resolution,
    ACTIONS(10611), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4210), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [263370] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9503), 1,
      anon_sym_LBRACK,
    STATE(2849), 1,
      sym_parameter_list,
    STATE(6683), 1,
      sym__function_declarator_seq,
    STATE(6676), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10613), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [263402] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10204), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [263422] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(8164), 1,
      anon_sym_LBRACE,
    ACTIONS(9272), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9337), 1,
      sym_identifier,
    STATE(4418), 1,
      sym_template_type,
    STATE(4551), 1,
      sym_enumerator_list,
    STATE(6829), 1,
      sym__scope_resolution,
    ACTIONS(10615), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4436), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [263462] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9348), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(2229), 1,
      sym_enumerator_list,
    STATE(6818), 1,
      sym__scope_resolution,
    ACTIONS(10617), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4999), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [263502] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6992), 1,
      anon_sym_LBRACK,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    ACTIONS(10525), 1,
      anon_sym_LBRACE,
    ACTIONS(10527), 1,
      anon_sym_EQ,
    ACTIONS(10529), 1,
      anon_sym_try,
    ACTIONS(10619), 1,
      anon_sym_SEMI,
    STATE(1934), 1,
      sym_compound_statement,
    STATE(7881), 1,
      sym_field_initializer_list,
    ACTIONS(4810), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1936), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [263540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10196), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [263560] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10192), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [263580] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10208), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [263600] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6990), 1,
      anon_sym_requires,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [263628] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5772), 1,
      anon_sym_LBRACE,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9380), 1,
      sym_identifier,
    STATE(2280), 1,
      sym_template_type,
    STATE(2334), 1,
      sym_enumerator_list,
    STATE(6839), 1,
      sym__scope_resolution,
    ACTIONS(10621), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2727), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [263668] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6778), 1,
      anon_sym_LBRACE,
    ACTIONS(9114), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9378), 1,
      sym_identifier,
    STATE(2844), 1,
      sym_template_type,
    STATE(3086), 1,
      sym_enumerator_list,
    STATE(6861), 1,
      sym__scope_resolution,
    ACTIONS(10623), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2880), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [263708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10282), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [263728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10200), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [263748] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5968), 1,
      anon_sym_LBRACK,
    STATE(6354), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5970), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [263774] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6979), 1,
      anon_sym_requires,
    ACTIONS(10058), 1,
      anon_sym_LBRACK,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6153), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10056), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [263804] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10627), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10631), 1,
      anon_sym_RBRACE,
    ACTIONS(10629), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8103), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8193), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6574), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [263837] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10627), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10633), 1,
      anon_sym_RBRACE,
    ACTIONS(10629), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7953), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8421), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6758), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [263870] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10635), 1,
      anon_sym_RPAREN,
    STATE(6188), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(10276), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10278), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [263895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10639), 1,
      anon_sym_LBRACK,
    ACTIONS(10637), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [263916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10643), 1,
      anon_sym_LBRACK,
    ACTIONS(10641), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [263937] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(619), 1,
      anon_sym_LBRACE,
    ACTIONS(6992), 1,
      anon_sym_LBRACK,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    ACTIONS(10533), 1,
      anon_sym_EQ,
    ACTIONS(10535), 1,
      anon_sym_try,
    STATE(571), 1,
      sym_compound_statement,
    STATE(7937), 1,
      sym_field_initializer_list,
    ACTIONS(4810), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(576), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [263972] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10645), 1,
      anon_sym_RPAREN,
    STATE(6188), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(10276), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10278), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [263997] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10627), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10647), 1,
      anon_sym_RBRACE,
    ACTIONS(10629), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7952), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8749), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6758), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [264030] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    ACTIONS(6992), 1,
      anon_sym_LBRACK,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    ACTIONS(10499), 1,
      anon_sym_EQ,
    ACTIONS(10501), 1,
      anon_sym_try,
    STATE(226), 1,
      sym_compound_statement,
    STATE(7967), 1,
      sym_field_initializer_list,
    ACTIONS(4810), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(227), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [264065] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10627), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10649), 1,
      anon_sym_RBRACE,
    ACTIONS(10629), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8147), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(9073), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6527), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [264098] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10627), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10651), 1,
      anon_sym_RBRACE,
    ACTIONS(10629), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8016), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8241), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6508), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [264131] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10627), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10653), 1,
      anon_sym_RBRACE,
    ACTIONS(10629), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8096), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8986), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6514), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [264164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10657), 1,
      anon_sym_LBRACK,
    ACTIONS(10655), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [264185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6028), 1,
      anon_sym_LBRACK,
    ACTIONS(6030), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [264206] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10414), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [264233] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10627), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10659), 1,
      anon_sym_RBRACE,
    ACTIONS(10629), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7821), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8549), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6758), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [264266] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(10459), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10461), 1,
      anon_sym_template,
    ACTIONS(10661), 1,
      sym_identifier,
    STATE(2536), 1,
      sym_dependent_field_identifier,
    STATE(2540), 1,
      sym_template_method,
    STATE(2546), 1,
      sym_qualified_field_identifier,
    STATE(6523), 1,
      sym__scope_resolution,
    STATE(8190), 1,
      sym_operator_name,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [264305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10665), 1,
      anon_sym_LBRACK,
    ACTIONS(10663), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [264326] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10667), 1,
      anon_sym_RPAREN,
    STATE(6188), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(10276), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10278), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [264351] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(10310), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10312), 1,
      anon_sym_template,
    ACTIONS(10669), 1,
      sym_identifier,
    STATE(3795), 1,
      sym_qualified_field_identifier,
    STATE(3797), 1,
      sym_dependent_field_identifier,
    STATE(3799), 1,
      sym_template_method,
    STATE(6526), 1,
      sym__scope_resolution,
    STATE(7860), 1,
      sym_operator_name,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [264390] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10627), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10671), 1,
      anon_sym_RBRACE,
    ACTIONS(10629), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8136), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(9038), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6758), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [264423] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10424), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [264450] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    ACTIONS(8005), 1,
      anon_sym_STAR,
    ACTIONS(8007), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8009), 1,
      anon_sym_AMP,
    STATE(2819), 1,
      sym_parameter_list,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(6911), 1,
      sym__abstract_declarator,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [264485] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10412), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [264512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10675), 1,
      anon_sym_LBRACK,
    ACTIONS(10673), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [264533] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(10677), 1,
      sym_identifier,
    ACTIONS(10679), 1,
      anon_sym_COLON_COLON,
    STATE(6600), 1,
      sym__scope_resolution,
    STATE(7614), 1,
      sym_field_initializer,
    STATE(7822), 1,
      sym_operator_name,
    STATE(7110), 2,
      sym_template_method,
      sym_qualified_field_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [264570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10683), 1,
      anon_sym_LBRACK,
    ACTIONS(10681), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [264591] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10627), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10685), 1,
      anon_sym_RBRACE,
    ACTIONS(10629), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7891), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8470), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6758), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [264624] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10426), 1,
      anon_sym_LBRACK,
    STATE(6520), 1,
      sym_parameter_list,
    STATE(6658), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5925), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [264653] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10426), 1,
      anon_sym_LBRACK,
    STATE(6520), 1,
      sym_parameter_list,
    STATE(6658), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5845), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [264682] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10426), 1,
      anon_sym_LBRACK,
    STATE(6520), 1,
      sym_parameter_list,
    STATE(6658), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5899), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [264711] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10426), 1,
      anon_sym_LBRACK,
    STATE(6520), 1,
      sym_parameter_list,
    STATE(6658), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5907), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [264740] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10426), 1,
      anon_sym_LBRACK,
    STATE(6520), 1,
      sym_parameter_list,
    STATE(6658), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5833), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [264769] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10627), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10687), 1,
      anon_sym_RBRACE,
    ACTIONS(10629), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8081), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8899), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6568), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [264802] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(6992), 1,
      anon_sym_LBRACK,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    ACTIONS(10513), 1,
      anon_sym_EQ,
    ACTIONS(10515), 1,
      anon_sym_try,
    STATE(746), 1,
      sym_compound_statement,
    STATE(8169), 1,
      sym_field_initializer_list,
    ACTIONS(4810), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(743), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [264837] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2909), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10424), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [264864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10691), 1,
      anon_sym_LBRACK,
    ACTIONS(10689), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [264885] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2909), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10412), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [264912] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10693), 1,
      anon_sym_RPAREN,
    STATE(6188), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(10276), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10278), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [264937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5958), 1,
      anon_sym_LBRACK,
    ACTIONS(5960), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [264958] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2909), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10420), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [264985] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10627), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10695), 1,
      anon_sym_RBRACE,
    ACTIONS(10629), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7894), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8674), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6758), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [265018] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5945), 1,
      anon_sym_LBRACK,
    ACTIONS(5947), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [265039] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2909), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10422), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [265066] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10697), 1,
      anon_sym_RPAREN,
    STATE(6188), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(10276), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10278), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [265091] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2909), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10418), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [265118] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10416), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [265145] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2909), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10416), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [265172] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2909), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10408), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [265199] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10627), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10699), 1,
      anon_sym_RBRACE,
    ACTIONS(10629), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7922), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8712), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6758), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [265232] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(10469), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10471), 1,
      anon_sym_template,
    ACTIONS(10661), 1,
      sym_identifier,
    STATE(2536), 1,
      sym_dependent_field_identifier,
    STATE(2540), 1,
      sym_template_method,
    STATE(2546), 1,
      sym_qualified_field_identifier,
    STATE(6557), 1,
      sym__scope_resolution,
    STATE(8124), 1,
      sym_operator_name,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [265271] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2909), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10414), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [265298] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(10677), 1,
      sym_identifier,
    ACTIONS(10679), 1,
      anon_sym_COLON_COLON,
    STATE(6600), 1,
      sym__scope_resolution,
    STATE(7822), 1,
      sym_operator_name,
    STATE(7911), 1,
      sym_field_initializer,
    STATE(7110), 2,
      sym_template_method,
      sym_qualified_field_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [265335] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10627), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10701), 1,
      anon_sym_RBRACE,
    ACTIONS(10629), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8041), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8834), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6758), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [265368] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(10430), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10432), 1,
      anon_sym_template,
    ACTIONS(10703), 1,
      sym_identifier,
    STATE(4011), 1,
      sym_template_method,
    STATE(4012), 1,
      sym_dependent_field_identifier,
    STATE(4017), 1,
      sym_qualified_field_identifier,
    STATE(6561), 1,
      sym__scope_resolution,
    STATE(7869), 1,
      sym_operator_name,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [265407] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7082), 1,
      sym__abstract_declarator,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [265442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5972), 1,
      anon_sym_LBRACK,
    ACTIONS(5974), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [265463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5996), 1,
      anon_sym_LBRACK,
    ACTIONS(5998), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [265484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6020), 1,
      anon_sym_LBRACK,
    ACTIONS(6022), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [265505] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10627), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10705), 1,
      anon_sym_RBRACE,
    ACTIONS(10629), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8110), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8990), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6758), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [265538] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10627), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10707), 1,
      anon_sym_RBRACE,
    ACTIONS(10629), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7927), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8720), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6556), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [265571] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10627), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10709), 1,
      anon_sym_RBRACE,
    ACTIONS(10629), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7936), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8860), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6758), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [265604] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(10448), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10450), 1,
      anon_sym_template,
    ACTIONS(10711), 1,
      sym_identifier,
    STATE(3905), 1,
      sym_qualified_field_identifier,
    STATE(3916), 1,
      sym_dependent_field_identifier,
    STATE(3927), 1,
      sym_template_method,
    STATE(6569), 1,
      sym__scope_resolution,
    STATE(8182), 1,
      sym_operator_name,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [265643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5982), 1,
      anon_sym_LBRACK,
    ACTIONS(5984), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [265664] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10627), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10713), 1,
      anon_sym_RBRACE,
    ACTIONS(10629), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7908), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8683), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6522), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [265697] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10627), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10715), 1,
      anon_sym_RBRACE,
    ACTIONS(10629), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8119), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8220), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6534), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [265730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6000), 1,
      anon_sym_LBRACK,
    ACTIONS(6002), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [265751] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10627), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10717), 1,
      anon_sym_RBRACE,
    ACTIONS(10629), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8158), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8204), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6758), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [265784] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5751), 1,
      anon_sym_LBRACK,
    ACTIONS(5749), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [265805] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10418), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [265832] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10422), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [265859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6004), 1,
      anon_sym_LBRACK,
    ACTIONS(6006), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [265880] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6008), 1,
      anon_sym_LBRACK,
    ACTIONS(6010), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [265901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6461), 1,
      anon_sym_LBRACK,
    ACTIONS(6463), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [265922] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10627), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10719), 1,
      anon_sym_RBRACE,
    ACTIONS(10629), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8001), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8775), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6593), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [265955] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    ACTIONS(6992), 1,
      anon_sym_LBRACK,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    ACTIONS(10499), 1,
      anon_sym_EQ,
    ACTIONS(10501), 1,
      anon_sym_try,
    STATE(183), 1,
      sym_compound_statement,
    STATE(7945), 1,
      sym_field_initializer_list,
    ACTIONS(4810), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(189), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [265990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10723), 1,
      anon_sym_LBRACK,
    ACTIONS(10721), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [266011] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10725), 1,
      anon_sym_RPAREN,
    STATE(6188), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(10276), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10278), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [266036] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10408), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [266063] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(619), 1,
      anon_sym_LBRACE,
    ACTIONS(6992), 1,
      anon_sym_LBRACK,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    ACTIONS(10533), 1,
      anon_sym_EQ,
    ACTIONS(10535), 1,
      anon_sym_try,
    STATE(460), 1,
      sym_compound_statement,
    STATE(8014), 1,
      sym_field_initializer_list,
    ACTIONS(4810), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(592), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [266098] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10627), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10727), 1,
      anon_sym_RBRACE,
    ACTIONS(10629), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8068), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8755), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6566), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [266131] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10627), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10729), 1,
      anon_sym_RBRACE,
    ACTIONS(10629), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7844), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8600), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6548), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [266164] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7431), 1,
      anon_sym_DASH_GT,
    ACTIONS(10048), 1,
      anon_sym_LBRACK,
    ACTIONS(10731), 1,
      anon_sym_requires,
    STATE(6730), 1,
      sym_trailing_return_type,
    ACTIONS(10050), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6224), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [266197] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7431), 1,
      anon_sym_DASH_GT,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9655), 1,
      anon_sym_requires,
    STATE(6732), 1,
      sym_trailing_return_type,
    ACTIONS(9407), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [266230] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7431), 1,
      anon_sym_DASH_GT,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9404), 1,
      anon_sym_requires,
    STATE(6737), 1,
      sym_trailing_return_type,
    ACTIONS(9181), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [266263] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7431), 1,
      anon_sym_DASH_GT,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9356), 1,
      anon_sym_requires,
    STATE(6738), 1,
      sym_trailing_return_type,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [266296] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10627), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10734), 1,
      anon_sym_RBRACE,
    ACTIONS(10629), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7971), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8758), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6758), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [266329] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7431), 1,
      anon_sym_DASH_GT,
    ACTIONS(7433), 1,
      anon_sym_requires,
    ACTIONS(10048), 1,
      anon_sym_LBRACK,
    STATE(6685), 1,
      sym_trailing_return_type,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6224), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [266362] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 1,
      anon_sym_LBRACE,
    ACTIONS(6992), 1,
      anon_sym_LBRACK,
    ACTIONS(10488), 1,
      anon_sym_EQ,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    ACTIONS(10492), 1,
      anon_sym_try,
    STATE(467), 1,
      sym_compound_statement,
    STATE(8133), 1,
      sym_field_initializer_list,
    ACTIONS(4810), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(468), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [266397] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4246), 1,
      anon_sym_LPAREN2,
    ACTIONS(4248), 1,
      anon_sym_STAR,
    ACTIONS(4250), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4252), 1,
      anon_sym_AMP,
    ACTIONS(7398), 1,
      anon_sym_LBRACK,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6416), 1,
      sym__function_declarator_seq,
    STATE(7054), 1,
      sym__abstract_declarator,
    STATE(6430), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [266432] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7431), 1,
      anon_sym_DASH_GT,
    ACTIONS(7433), 1,
      anon_sym_requires,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    STATE(6724), 1,
      sym_trailing_return_type,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [266465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6992), 1,
      anon_sym_LBRACK,
    ACTIONS(4810), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [266486] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10736), 1,
      anon_sym_RPAREN,
    STATE(6188), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(10276), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10278), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [266511] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(10679), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10738), 1,
      sym_identifier,
    ACTIONS(10740), 1,
      anon_sym_template,
    STATE(2536), 1,
      sym_dependent_field_identifier,
    STATE(2540), 1,
      sym_template_method,
    STATE(2546), 1,
      sym_qualified_field_identifier,
    STATE(6600), 1,
      sym__scope_resolution,
    STATE(7822), 1,
      sym_operator_name,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [266550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [266571] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7431), 1,
      anon_sym_DASH_GT,
    ACTIONS(7433), 1,
      anon_sym_requires,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    STATE(6684), 1,
      sym_trailing_return_type,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [266604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [266625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10744), 1,
      anon_sym_LBRACK,
    ACTIONS(10742), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [266646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [266667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5976), 1,
      anon_sym_LBRACK,
    ACTIONS(5978), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [266688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [266709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [266730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [266751] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7431), 1,
      anon_sym_DASH_GT,
    ACTIONS(7433), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    STATE(6700), 1,
      sym_trailing_return_type,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [266784] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10420), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [266811] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 1,
      anon_sym_LBRACE,
    ACTIONS(6992), 1,
      anon_sym_LBRACK,
    ACTIONS(10488), 1,
      anon_sym_EQ,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    ACTIONS(10492), 1,
      anon_sym_try,
    STATE(486), 1,
      sym_compound_statement,
    STATE(8175), 1,
      sym_field_initializer_list,
    ACTIONS(4810), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(488), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [266846] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(6992), 1,
      anon_sym_LBRACK,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    ACTIONS(10513), 1,
      anon_sym_EQ,
    ACTIONS(10515), 1,
      anon_sym_try,
    STATE(765), 1,
      sym_compound_statement,
    STATE(7995), 1,
      sym_field_initializer_list,
    ACTIONS(4810), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(757), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [266881] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10627), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10746), 1,
      anon_sym_RBRACE,
    ACTIONS(10629), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7865), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8636), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6560), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [266914] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5839), 1,
      anon_sym_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    STATE(2456), 1,
      sym_parameter_list,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5925), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_try,
  [266942] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2974), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10418), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [266968] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6990), 1,
      anon_sym_requires,
    ACTIONS(7547), 1,
      anon_sym_DASH_GT,
    STATE(6500), 1,
      sym_trailing_return_type,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [266998] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9368), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(5354), 1,
      sym_enumerator_list,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(5003), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [267034] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6990), 1,
      anon_sym_requires,
    ACTIONS(7547), 1,
      anon_sym_DASH_GT,
    STATE(6392), 1,
      sym_trailing_return_type,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [267064] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6990), 1,
      anon_sym_requires,
    ACTIONS(7547), 1,
      anon_sym_DASH_GT,
    STATE(6403), 1,
      sym_trailing_return_type,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6399), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [267094] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6990), 1,
      anon_sym_requires,
    ACTIONS(7547), 1,
      anon_sym_DASH_GT,
    STATE(6406), 1,
      sym_trailing_return_type,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6405), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [267124] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10599), 1,
      anon_sym_LBRACK,
    STATE(6133), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10597), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [267148] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5839), 1,
      anon_sym_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    STATE(2456), 1,
      sym_parameter_list,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5845), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_try,
  [267176] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7037), 1,
      anon_sym_requires,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [267202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6836), 6,
      anon_sym_AMP,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(6838), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
  [267222] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5839), 1,
      anon_sym_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    STATE(2456), 1,
      sym_parameter_list,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5833), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_try,
  [267250] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7899), 1,
      anon_sym_LBRACE,
    ACTIONS(9211), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9366), 1,
      sym_identifier,
    STATE(4104), 1,
      sym_template_type,
    STATE(4309), 1,
      sym_enumerator_list,
    STATE(6855), 1,
      sym__scope_resolution,
    STATE(4055), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [267286] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(9233), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9343), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(2213), 1,
      sym_enumerator_list,
    STATE(6864), 1,
      sym__scope_resolution,
    STATE(4267), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [267322] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7037), 1,
      anon_sym_requires,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [267348] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5921), 1,
      anon_sym_LBRACE,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9374), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2915), 1,
      sym_enumerator_list,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(4416), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [267384] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7404), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8320), 1,
      anon_sym_LBRACE,
    ACTIONS(9376), 1,
      sym_identifier,
    STATE(4532), 1,
      sym_template_type,
    STATE(5081), 1,
      sym_enumerator_list,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(4606), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [267420] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5772), 1,
      anon_sym_LBRACE,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9380), 1,
      sym_identifier,
    STATE(2280), 1,
      sym_template_type,
    STATE(2366), 1,
      sym_enumerator_list,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(2469), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [267456] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7037), 1,
      anon_sym_requires,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6399), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [267482] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7037), 1,
      anon_sym_requires,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6405), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [267508] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10750), 1,
      anon_sym_LT,
    ACTIONS(10752), 1,
      anon_sym_LBRACK,
    STATE(6722), 1,
      sym_template_argument_list,
    ACTIONS(10748), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [267532] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10750), 1,
      anon_sym_LT,
    ACTIONS(10756), 1,
      anon_sym_LBRACK,
    STATE(6707), 1,
      sym_template_argument_list,
    ACTIONS(10754), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [267556] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7037), 1,
      anon_sym_requires,
    ACTIONS(6674), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6410), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10056), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [267582] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5913), 1,
      anon_sym_LBRACE,
    ACTIONS(7437), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9350), 1,
      sym_identifier,
    STATE(2361), 1,
      sym_template_type,
    STATE(2399), 1,
      sym_enumerator_list,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(5146), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [267618] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8226), 1,
      anon_sym_LBRACE,
    ACTIONS(9374), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(4695), 1,
      sym_enumerator_list,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(4531), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [267654] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5601), 1,
      anon_sym_LBRACE,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9348), 1,
      sym_identifier,
    STATE(1851), 1,
      sym_template_type,
    STATE(2213), 1,
      sym_enumerator_list,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(5053), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [267690] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8226), 1,
      anon_sym_LBRACE,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(4695), 1,
      sym_enumerator_list,
    STATE(6845), 1,
      sym__scope_resolution,
    STATE(5263), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [267726] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    STATE(2907), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10551), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [267756] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    STATE(2907), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10569), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [267786] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    STATE(2907), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10591), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [267816] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5913), 1,
      anon_sym_LBRACE,
    ACTIONS(9316), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9341), 1,
      sym_identifier,
    STATE(2361), 1,
      sym_template_type,
    STATE(2399), 1,
      sym_enumerator_list,
    STATE(6846), 1,
      sym__scope_resolution,
    STATE(4445), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [267852] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5921), 1,
      anon_sym_LBRACE,
    ACTIONS(9339), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2468), 1,
      sym_enumerator_list,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(2577), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [267888] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7547), 1,
      anon_sym_DASH_GT,
    ACTIONS(9099), 1,
      anon_sym_requires,
    STATE(6412), 1,
      sym_trailing_return_type,
    ACTIONS(9017), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [267918] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6647), 1,
      anon_sym_LBRACE,
    ACTIONS(9189), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9354), 1,
      sym_identifier,
    STATE(2794), 1,
      sym_template_type,
    STATE(2977), 1,
      sym_enumerator_list,
    STATE(6836), 1,
      sym__scope_resolution,
    STATE(2789), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [267954] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6778), 1,
      anon_sym_LBRACE,
    ACTIONS(9114), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9378), 1,
      sym_identifier,
    STATE(2844), 1,
      sym_template_type,
    STATE(3065), 1,
      sym_enumerator_list,
    STATE(6861), 1,
      sym__scope_resolution,
    STATE(2878), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [267990] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9245), 1,
      anon_sym_requires,
    ACTIONS(9017), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6377), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [268016] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5921), 1,
      anon_sym_LBRACE,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2915), 1,
      sym_enumerator_list,
    STATE(6845), 1,
      sym__scope_resolution,
    STATE(3073), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [268052] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7547), 1,
      anon_sym_DASH_GT,
    ACTIONS(9345), 1,
      anon_sym_requires,
    STATE(6401), 1,
      sym_trailing_return_type,
    ACTIONS(9106), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [268082] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9382), 1,
      anon_sym_requires,
    ACTIONS(9106), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6391), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [268108] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7547), 1,
      anon_sym_DASH_GT,
    ACTIONS(9475), 1,
      anon_sym_requires,
    STATE(6398), 1,
      sym_trailing_return_type,
    ACTIONS(9392), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6399), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [268138] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9494), 1,
      anon_sym_requires,
    ACTIONS(9392), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6399), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [268164] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10758), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10760), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5392), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [268186] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10483), 1,
      anon_sym_requires,
    ACTIONS(10172), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6405), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [268212] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5968), 1,
      anon_sym_LBRACK,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6133), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5970), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [268236] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7547), 1,
      anon_sym_DASH_GT,
    ACTIONS(10473), 1,
      anon_sym_requires,
    STATE(6395), 1,
      sym_trailing_return_type,
    ACTIONS(10172), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6405), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [268266] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6706), 1,
      anon_sym_LBRACE,
    ACTIONS(9294), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9372), 1,
      sym_identifier,
    STATE(2848), 1,
      sym_template_type,
    STATE(3081), 1,
      sym_enumerator_list,
    STATE(6809), 1,
      sym__scope_resolution,
    STATE(2840), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [268302] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2974), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10416), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [268328] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10762), 1,
      anon_sym_requires,
    ACTIONS(10314), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6275), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6410), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10056), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [268354] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2974), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10414), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [268380] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2974), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10408), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [268406] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2974), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10412), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [268432] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    STATE(2907), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10571), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [268462] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5921), 1,
      anon_sym_LBRACE,
    ACTIONS(9352), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(2468), 1,
      sym_enumerator_list,
    STATE(6858), 1,
      sym__scope_resolution,
    STATE(2769), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [268498] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    STATE(2907), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10481), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
  [268528] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2974), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10422), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [268554] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2974), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10420), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [268580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10760), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5404), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [268600] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5772), 1,
      anon_sym_LBRACE,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9380), 1,
      sym_identifier,
    STATE(2280), 1,
      sym_template_type,
    STATE(2366), 1,
      sym_enumerator_list,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(2671), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [268636] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5839), 1,
      anon_sym_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    STATE(2456), 1,
      sym_parameter_list,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5907), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_try,
  [268664] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5839), 1,
      anon_sym_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    STATE(2456), 1,
      sym_parameter_list,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5899), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_try,
  [268692] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6188), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(10276), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10278), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [268714] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10767), 1,
      anon_sym_LBRACK,
    STATE(6133), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10765), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [268738] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(5921), 1,
      anon_sym_LBRACE,
    ACTIONS(9339), 1,
      sym_identifier,
    ACTIONS(9364), 1,
      anon_sym_COLON_COLON,
    STATE(2113), 1,
      sym_template_type,
    STATE(2468), 1,
      sym_enumerator_list,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(3539), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [268774] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(6877), 1,
      anon_sym_LBRACE,
    ACTIONS(9250), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9370), 1,
      sym_identifier,
    STATE(2986), 1,
      sym_template_type,
    STATE(3359), 1,
      sym_enumerator_list,
    STATE(6853), 1,
      sym__scope_resolution,
    STATE(2949), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [268810] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(8164), 1,
      anon_sym_LBRACE,
    ACTIONS(9272), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9337), 1,
      sym_identifier,
    STATE(4418), 1,
      sym_template_type,
    STATE(4542), 1,
      sym_enumerator_list,
    STATE(6829), 1,
      sym__scope_resolution,
    STATE(4421), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [268846] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(2974), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10424), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [268872] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9509), 1,
      anon_sym_try,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(10543), 1,
      anon_sym_LBRACE,
    STATE(2089), 1,
      sym_try_statement,
    STATE(2092), 1,
      sym_compound_statement,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [268907] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(10769), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10771), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10773), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10775), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6898), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8920), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [268936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10779), 1,
      anon_sym_LBRACK,
    ACTIONS(10777), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [268955] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7433), 1,
      anon_sym_requires,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [268982] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7433), 1,
      anon_sym_requires,
    ACTIONS(10058), 1,
      anon_sym_LBRACK,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6153), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10056), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [269009] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(10771), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10773), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10781), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10775), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6898), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8739), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [269038] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(10082), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10783), 1,
      sym_identifier,
    STATE(6042), 1,
      sym__scope_resolution,
    STATE(8621), 1,
      sym_qualified_identifier,
    ACTIONS(10785), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [269069] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10551), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [269098] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10789), 1,
      anon_sym_LBRACK,
    ACTIONS(10787), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [269117] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(9834), 1,
      anon_sym_try,
    STATE(274), 1,
      sym_compound_statement,
    STATE(275), 1,
      sym_try_statement,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [269152] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9525), 1,
      anon_sym_try,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(10525), 1,
      anon_sym_LBRACE,
    STATE(1968), 1,
      sym_compound_statement,
    STATE(1971), 1,
      sym_try_statement,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [269187] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2941), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10414), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [269212] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(619), 1,
      anon_sym_LBRACE,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(9900), 1,
      anon_sym_try,
    STATE(560), 1,
      sym_compound_statement,
    STATE(565), 1,
      sym_try_statement,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [269247] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2941), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10422), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [269272] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(9904), 1,
      anon_sym_try,
    STATE(771), 1,
      sym_compound_statement,
    STATE(775), 1,
      sym_try_statement,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [269307] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_LBRACK,
    ACTIONS(10791), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5404), 8,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [269328] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10455), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10793), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10795), 1,
      aux_sym_preproc_elif_token1,
    STATE(6704), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8562), 1,
      sym_enumerator,
    ACTIONS(10797), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8741), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [269359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10801), 1,
      anon_sym_LBRACK,
    ACTIONS(10799), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [269378] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3552), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    ACTIONS(10803), 1,
      sym_virtual,
    STATE(2113), 1,
      sym_template_type,
    STATE(6810), 1,
      sym__scope_resolution,
    STATE(7319), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [269411] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7433), 1,
      anon_sym_requires,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [269438] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2941), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10420), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [269463] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(10082), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10805), 1,
      sym_identifier,
    STATE(6042), 1,
      sym__scope_resolution,
    STATE(8704), 1,
      sym_qualified_identifier,
    ACTIONS(10807), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [269494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10811), 1,
      anon_sym_LBRACK,
    ACTIONS(10809), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [269513] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10793), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10795), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10813), 1,
      aux_sym_preproc_if_token2,
    STATE(6869), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8562), 1,
      sym_enumerator,
    ACTIONS(10797), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8908), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [269544] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(10771), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10773), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10815), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10775), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6898), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8601), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [269573] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10793), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10795), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10817), 1,
      aux_sym_preproc_if_token2,
    STATE(6869), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8562), 1,
      sym_enumerator,
    ACTIONS(10797), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8558), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [269604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6079), 1,
      anon_sym_LBRACK,
    ACTIONS(6081), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [269623] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2819), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10414), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [269648] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(10082), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10819), 1,
      sym_identifier,
    STATE(6042), 1,
      sym__scope_resolution,
    STATE(8542), 1,
      sym_qualified_identifier,
    ACTIONS(10821), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [269679] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(619), 1,
      anon_sym_LBRACE,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(9900), 1,
      anon_sym_try,
    STATE(542), 1,
      sym_try_statement,
    STATE(543), 1,
      sym_compound_statement,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [269714] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3552), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    ACTIONS(10823), 1,
      sym_virtual,
    STATE(2113), 1,
      sym_template_type,
    STATE(6810), 1,
      sym__scope_resolution,
    STATE(7734), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [269747] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10793), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10795), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10825), 1,
      aux_sym_preproc_if_token2,
    STATE(6706), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8562), 1,
      sym_enumerator,
    ACTIONS(10797), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8238), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [269778] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(10771), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10773), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10827), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10775), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6717), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8893), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [269807] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10571), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [269836] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5390), 1,
      anon_sym_LBRACK,
    ACTIONS(10791), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10829), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(5392), 6,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [269859] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9525), 1,
      anon_sym_try,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(10525), 1,
      anon_sym_LBRACE,
    STATE(1992), 1,
      sym_compound_statement,
    STATE(1994), 1,
      sym_try_statement,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [269894] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(10771), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10773), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10831), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10775), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6898), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(9055), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [269923] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9509), 1,
      anon_sym_try,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(10543), 1,
      anon_sym_LBRACE,
    STATE(2097), 1,
      sym_try_statement,
    STATE(2098), 1,
      sym_compound_statement,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [269958] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10444), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10793), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10795), 1,
      aux_sym_preproc_elif_token1,
    STATE(6752), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8562), 1,
      sym_enumerator,
    ACTIONS(10797), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8890), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [269989] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2819), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10412), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [270014] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2941), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10408), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [270039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6143), 1,
      anon_sym_LBRACK,
    ACTIONS(6145), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [270058] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(10082), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10833), 1,
      sym_identifier,
    STATE(6042), 1,
      sym__scope_resolution,
    STATE(8310), 1,
      sym_qualified_identifier,
    ACTIONS(10835), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [270089] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7433), 1,
      anon_sym_requires,
    ACTIONS(10048), 1,
      anon_sym_LBRACK,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6224), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [270116] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2941), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10412), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [270141] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2941), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10418), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [270166] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(9904), 1,
      anon_sym_try,
    STATE(702), 1,
      sym_compound_statement,
    STATE(703), 1,
      sym_try_statement,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [270201] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5968), 1,
      anon_sym_LBRACK,
    STATE(6354), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5970), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_try,
  [270224] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(10082), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10837), 1,
      sym_identifier,
    STATE(6042), 1,
      sym__scope_resolution,
    STATE(8740), 1,
      sym_qualified_identifier,
    ACTIONS(10839), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [270255] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10058), 1,
      anon_sym_LBRACK,
    ACTIONS(10841), 1,
      anon_sym_requires,
    ACTIONS(10111), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6153), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10056), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [270282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10846), 1,
      anon_sym_LBRACK,
    ACTIONS(10844), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [270301] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10048), 1,
      anon_sym_LBRACK,
    ACTIONS(10731), 1,
      anon_sym_requires,
    ACTIONS(10050), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6224), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10046), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [270328] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3552), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    ACTIONS(10848), 1,
      sym_virtual,
    STATE(2113), 1,
      sym_template_type,
    STATE(6810), 1,
      sym__scope_resolution,
    STATE(7564), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [270361] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2819), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10420), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [270386] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2941), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10416), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [270411] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9517), 1,
      anon_sym_try,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(10555), 1,
      anon_sym_LBRACE,
    STATE(1741), 1,
      sym_try_statement,
    STATE(1744), 1,
      sym_compound_statement,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [270446] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9390), 1,
      anon_sym_LBRACK,
    ACTIONS(9655), 1,
      anon_sym_requires,
    ACTIONS(9407), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6158), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9388), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [270473] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9404), 1,
      anon_sym_requires,
    ACTIONS(9181), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6173), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9102), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [270500] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(10082), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10850), 1,
      sym_identifier,
    STATE(6042), 1,
      sym__scope_resolution,
    STATE(8324), 1,
      sym_qualified_identifier,
    ACTIONS(10852), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [270531] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(9834), 1,
      anon_sym_try,
    STATE(298), 1,
      sym_try_statement,
    STATE(299), 1,
      sym_compound_statement,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [270566] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(9356), 1,
      anon_sym_requires,
    ACTIONS(9060), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [270593] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(10082), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10854), 1,
      sym_identifier,
    STATE(6042), 1,
      sym__scope_resolution,
    STATE(8395), 1,
      sym_qualified_identifier,
    ACTIONS(10856), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [270624] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10793), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10795), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10858), 1,
      aux_sym_preproc_if_token2,
    STATE(6869), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8562), 1,
      sym_enumerator,
    ACTIONS(10797), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8737), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [270655] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10569), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [270684] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2819), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10416), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [270709] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9525), 1,
      anon_sym_try,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(10525), 1,
      anon_sym_LBRACE,
    STATE(1976), 1,
      sym_compound_statement,
    STATE(1977), 1,
      sym_try_statement,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [270744] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10481), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [270773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10752), 1,
      anon_sym_LBRACK,
    ACTIONS(10748), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [270792] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3552), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    ACTIONS(10860), 1,
      sym_virtual,
    STATE(2113), 1,
      sym_template_type,
    STATE(6810), 1,
      sym__scope_resolution,
    STATE(7250), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [270825] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(659), 1,
      anon_sym_LBRACE,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(9996), 1,
      anon_sym_try,
    STATE(456), 1,
      sym_compound_statement,
    STATE(457), 1,
      sym_try_statement,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [270860] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2941), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10424), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [270885] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10793), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10795), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10862), 1,
      aux_sym_preproc_if_token2,
    STATE(6869), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8562), 1,
      sym_enumerator,
    ACTIONS(10797), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(9052), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [270916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10866), 1,
      anon_sym_LBRACK,
    ACTIONS(10864), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [270935] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(659), 1,
      anon_sym_LBRACE,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(9996), 1,
      anon_sym_try,
    STATE(449), 1,
      sym_try_statement,
    STATE(450), 1,
      sym_compound_statement,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [270970] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(9904), 1,
      anon_sym_try,
    STATE(707), 1,
      sym_compound_statement,
    STATE(714), 1,
      sym_try_statement,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [271005] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(9834), 1,
      anon_sym_try,
    STATE(264), 1,
      sym_compound_statement,
    STATE(266), 1,
      sym_try_statement,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [271040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10870), 1,
      anon_sym_LBRACK,
    ACTIONS(10868), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [271059] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(10875), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10881), 1,
      sym_preproc_directive,
    ACTIONS(10884), 1,
      anon_sym_RBRACE,
    ACTIONS(10878), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8248), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(6758), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [271088] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9517), 1,
      anon_sym_try,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(10555), 1,
      anon_sym_LBRACE,
    STATE(1792), 1,
      sym_try_statement,
    STATE(1797), 1,
      sym_compound_statement,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [271123] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7433), 1,
      anon_sym_requires,
    ACTIONS(9015), 1,
      anon_sym_LBRACK,
    ACTIONS(5516), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6005), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6197), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9013), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [271150] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9509), 1,
      anon_sym_try,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(10543), 1,
      anon_sym_LBRACE,
    STATE(2075), 1,
      sym_try_statement,
    STATE(2076), 1,
      sym_compound_statement,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [271185] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9517), 1,
      anon_sym_try,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(10555), 1,
      anon_sym_LBRACE,
    STATE(1783), 1,
      sym_try_statement,
    STATE(1785), 1,
      sym_compound_statement,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [271220] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(10771), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10773), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10886), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10775), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6682), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8742), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [271249] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10591), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [271278] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(619), 1,
      anon_sym_LBRACE,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(9900), 1,
      anon_sym_try,
    STATE(567), 1,
      sym_compound_statement,
    STATE(568), 1,
      sym_try_statement,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [271313] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(659), 1,
      anon_sym_LBRACE,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(9996), 1,
      anon_sym_try,
    STATE(447), 1,
      sym_try_statement,
    STATE(448), 1,
      sym_compound_statement,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [271348] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(10793), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10795), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10888), 1,
      aux_sym_preproc_if_token2,
    STATE(6743), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8562), 1,
      sym_enumerator,
    ACTIONS(10797), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8526), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [271379] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3056), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10412), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [271403] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3056), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10418), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [271427] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3056), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10422), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [271451] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3056), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10420), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [271475] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10892), 1,
      anon_sym_LBRACK,
    STATE(7159), 1,
      sym_gnu_asm_input_operand,
    STATE(8702), 1,
      sym_string_literal,
    ACTIONS(10890), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [271499] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3056), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10424), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [271523] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10896), 1,
      anon_sym_LBRACK,
    STATE(7263), 1,
      sym_gnu_asm_output_operand,
    STATE(8414), 1,
      sym_string_literal,
    ACTIONS(10894), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [271547] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10902), 1,
      anon_sym_delete,
    ACTIONS(10904), 1,
      anon_sym_new,
    ACTIONS(10900), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(10898), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [271569] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5839), 1,
      anon_sym_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10906), 1,
      anon_sym_COMMA,
    STATE(2456), 1,
      sym_parameter_list,
    STATE(7221), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(10908), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [271599] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(10912), 1,
      anon_sym_EQ,
    STATE(2907), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    ACTIONS(10910), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [271629] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10914), 1,
      anon_sym_delete,
    ACTIONS(10916), 1,
      anon_sym_new,
    ACTIONS(10900), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(10898), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [271651] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(10918), 1,
      anon_sym_EQ,
    STATE(2907), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(8678), 1,
      sym_initializer_list,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [271683] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3552), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(6810), 1,
      sym__scope_resolution,
    STATE(7250), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [271713] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10920), 1,
      anon_sym_delete,
    ACTIONS(10922), 1,
      anon_sym_new,
    ACTIONS(10900), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(10898), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [271735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3992), 1,
      anon_sym_LBRACK,
    ACTIONS(3994), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [271753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 1,
      anon_sym_LBRACK,
    ACTIONS(4023), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [271771] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3056), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10416), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [271795] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3056), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10408), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [271819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3980), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [271837] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3056), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10414), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [271861] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10904), 1,
      anon_sym_new,
    ACTIONS(10924), 1,
      anon_sym_delete,
    ACTIONS(10900), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(10898), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [271883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3984), 1,
      anon_sym_LBRACK,
    ACTIONS(3986), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [271901] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3552), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(6810), 1,
      sym__scope_resolution,
    STATE(7142), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [271931] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10926), 1,
      anon_sym_delete,
    ACTIONS(10928), 1,
      anon_sym_new,
    ACTIONS(10900), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(10898), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [271953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [271971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3996), 1,
      anon_sym_LBRACK,
    ACTIONS(3998), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [271989] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3552), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(6810), 1,
      sym__scope_resolution,
    STATE(7457), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [272019] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10930), 1,
      anon_sym_delete,
    ACTIONS(10932), 1,
      anon_sym_new,
    ACTIONS(10900), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(10898), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [272041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3988), 1,
      anon_sym_LBRACK,
    ACTIONS(3990), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [272059] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3552), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9359), 1,
      sym_identifier,
    STATE(2113), 1,
      sym_template_type,
    STATE(6810), 1,
      sym__scope_resolution,
    STATE(7564), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [272089] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10934), 1,
      anon_sym_delete,
    ACTIONS(10936), 1,
      anon_sym_new,
    ACTIONS(10900), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(10898), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [272111] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(10938), 1,
      anon_sym_EQ,
    STATE(2907), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    ACTIONS(10910), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [272141] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10922), 1,
      anon_sym_new,
    ACTIONS(10940), 1,
      anon_sym_delete,
    ACTIONS(10900), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(10898), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [272163] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10922), 1,
      anon_sym_new,
    ACTIONS(10942), 1,
      anon_sym_delete,
    ACTIONS(10900), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(10898), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [272185] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10944), 1,
      anon_sym_delete,
    ACTIONS(10946), 1,
      anon_sym_new,
    ACTIONS(10900), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(10898), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [272207] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10948), 1,
      anon_sym_delete,
    ACTIONS(10950), 1,
      anon_sym_new,
    ACTIONS(10900), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(10898), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [272229] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10952), 1,
      anon_sym_delete,
    ACTIONS(10954), 1,
      anon_sym_new,
    ACTIONS(10900), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(10898), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [272251] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10956), 1,
      anon_sym_delete,
    ACTIONS(10958), 1,
      anon_sym_new,
    ACTIONS(10900), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(10898), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [272273] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(10960), 1,
      sym_identifier,
    ACTIONS(10962), 1,
      anon_sym_COLON_COLON,
    STATE(3054), 1,
      sym_template_type,
    STATE(6848), 1,
      sym__scope_resolution,
    STATE(3036), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8628), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [272303] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10964), 1,
      anon_sym_delete,
    ACTIONS(10966), 1,
      anon_sym_new,
    ACTIONS(10900), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(10898), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [272325] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10932), 1,
      anon_sym_new,
    ACTIONS(10968), 1,
      anon_sym_delete,
    ACTIONS(10900), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(10898), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [272347] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9294), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10970), 1,
      sym_identifier,
    ACTIONS(10972), 1,
      anon_sym_template,
    STATE(2873), 1,
      sym_template_type,
    STATE(2876), 1,
      sym_dependent_type_identifier,
    STATE(2916), 1,
      sym_qualified_type_identifier,
    STATE(6809), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
  [272378] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(3552), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10974), 1,
      sym_identifier,
    STATE(2104), 1,
      sym_template_type,
    STATE(2112), 1,
      sym_dependent_type_identifier,
    STATE(2125), 1,
      sym_qualified_type_identifier,
    STATE(6810), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
  [272409] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4861), 1,
      anon_sym_LBRACE,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10976), 1,
      sym_identifier,
    ACTIONS(10978), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10980), 1,
      anon_sym_inline,
    STATE(517), 1,
      sym_declaration_list,
    STATE(6940), 1,
      sym_attribute_declaration,
    STATE(7909), 1,
      sym_nested_namespace_specifier,
    STATE(8573), 1,
      sym__namespace_specifier,
  [272440] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(10082), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10982), 1,
      sym_identifier,
    STATE(6042), 1,
      sym__scope_resolution,
    STATE(8703), 1,
      sym_qualified_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [272467] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(10082), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10984), 1,
      sym_identifier,
    STATE(6042), 1,
      sym__scope_resolution,
    STATE(8632), 1,
      sym_qualified_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [272494] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5390), 1,
      anon_sym_AMP,
    ACTIONS(10986), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10988), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5392), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [272515] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4857), 1,
      anon_sym_LBRACE,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10978), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10980), 1,
      anon_sym_inline,
    ACTIONS(10990), 1,
      sym_identifier,
    STATE(561), 1,
      sym_declaration_list,
    STATE(6919), 1,
      sym_attribute_declaration,
    STATE(7913), 1,
      sym_nested_namespace_specifier,
    STATE(8573), 1,
      sym__namespace_specifier,
  [272546] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4855), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10992), 1,
      sym_identifier,
    ACTIONS(10994), 1,
      anon_sym_template,
    STATE(2104), 1,
      sym_template_type,
    STATE(2112), 1,
      sym_dependent_type_identifier,
    STATE(2125), 1,
      sym_qualified_type_identifier,
    STATE(6816), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
  [272577] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4863), 1,
      anon_sym_LBRACE,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10978), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10980), 1,
      anon_sym_inline,
    ACTIONS(10996), 1,
      sym_identifier,
    STATE(193), 1,
      sym_declaration_list,
    STATE(6944), 1,
      sym_attribute_declaration,
    STATE(7864), 1,
      sym_nested_namespace_specifier,
    STATE(8573), 1,
      sym__namespace_specifier,
  [272608] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10998), 1,
      sym_identifier,
    ACTIONS(11000), 1,
      anon_sym_template,
    STATE(1849), 1,
      sym_dependent_type_identifier,
    STATE(1853), 1,
      sym_template_type,
    STATE(1972), 1,
      sym_qualified_type_identifier,
    STATE(6818), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
  [272639] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    STATE(3008), 1,
      sym_template_argument_list,
    ACTIONS(6992), 2,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(4810), 4,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [272662] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11004), 1,
      anon_sym_AMP,
    ACTIONS(11006), 2,
      anon_sym_EQ,
      anon_sym_DOT,
    ACTIONS(11002), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [272681] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11008), 1,
      sym_identifier,
    ACTIONS(11010), 1,
      anon_sym_template,
    STATE(1849), 1,
      sym_dependent_type_identifier,
    STATE(1853), 1,
      sym_template_type,
    STATE(1972), 1,
      sym_qualified_type_identifier,
    STATE(6821), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
  [272712] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4859), 1,
      anon_sym_LBRACE,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10978), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10980), 1,
      anon_sym_inline,
    ACTIONS(11012), 1,
      sym_identifier,
    STATE(696), 1,
      sym_declaration_list,
    STATE(6917), 1,
      sym_attribute_declaration,
    STATE(8057), 1,
      sym_nested_namespace_specifier,
    STATE(8573), 1,
      sym__namespace_specifier,
  [272743] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9364), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10992), 1,
      sym_identifier,
    ACTIONS(10994), 1,
      anon_sym_template,
    STATE(2104), 1,
      sym_template_type,
    STATE(2112), 1,
      sym_dependent_type_identifier,
    STATE(2472), 1,
      sym_qualified_type_identifier,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
  [272774] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10416), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [272797] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(10082), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11014), 1,
      sym_identifier,
    STATE(6042), 1,
      sym__scope_resolution,
    STATE(8227), 1,
      sym_qualified_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [272824] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(10082), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11016), 1,
      sym_identifier,
    STATE(6042), 1,
      sym__scope_resolution,
    STATE(8379), 1,
      sym_qualified_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [272851] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7511), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11018), 1,
      sym_identifier,
    ACTIONS(11020), 1,
      anon_sym_template,
    STATE(2104), 1,
      sym_template_type,
    STATE(2112), 1,
      sym_dependent_type_identifier,
    STATE(2125), 1,
      sym_qualified_type_identifier,
    STATE(6827), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
  [272882] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    STATE(3008), 1,
      sym_template_argument_list,
    ACTIONS(4009), 2,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(4002), 4,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [272905] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9272), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11022), 1,
      sym_identifier,
    ACTIONS(11024), 1,
      anon_sym_template,
    STATE(4433), 1,
      sym_dependent_type_identifier,
    STATE(4435), 1,
      sym_template_type,
    STATE(4461), 1,
      sym_qualified_type_identifier,
    STATE(6829), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
  [272936] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4857), 1,
      anon_sym_LBRACE,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10978), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10980), 1,
      anon_sym_inline,
    ACTIONS(11026), 1,
      sym_identifier,
    STATE(581), 1,
      sym_declaration_list,
    STATE(6966), 1,
      sym_attribute_declaration,
    STATE(8089), 1,
      sym_nested_namespace_specifier,
    STATE(8573), 1,
      sym__namespace_specifier,
  [272967] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7358), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11018), 1,
      sym_identifier,
    ACTIONS(11020), 1,
      anon_sym_template,
    STATE(2104), 1,
      sym_template_type,
    STATE(2112), 1,
      sym_dependent_type_identifier,
    STATE(2472), 1,
      sym_qualified_type_identifier,
    STATE(6831), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
  [272998] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7437), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11028), 1,
      sym_identifier,
    ACTIONS(11030), 1,
      anon_sym_template,
    STATE(2338), 1,
      sym_template_type,
    STATE(2339), 1,
      sym_dependent_type_identifier,
    STATE(2385), 1,
      sym_qualified_type_identifier,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
  [273029] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7404), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11032), 1,
      sym_identifier,
    ACTIONS(11034), 1,
      anon_sym_template,
    STATE(4505), 1,
      sym_dependent_type_identifier,
    STATE(4522), 1,
      sym_template_type,
    STATE(4617), 1,
      sym_qualified_type_identifier,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
  [273060] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(10082), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11036), 1,
      sym_identifier,
    STATE(6042), 1,
      sym__scope_resolution,
    STATE(8660), 1,
      sym_qualified_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [273087] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5839), 1,
      anon_sym_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    STATE(2456), 1,
      sym_parameter_list,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11038), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [273112] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9189), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11040), 1,
      sym_identifier,
    ACTIONS(11042), 1,
      anon_sym_template,
    STATE(2802), 1,
      sym_template_type,
    STATE(2806), 1,
      sym_dependent_type_identifier,
    STATE(2881), 1,
      sym_qualified_type_identifier,
    STATE(6836), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
  [273143] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9557), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11044), 1,
      sym_identifier,
    ACTIONS(11046), 1,
      anon_sym_template,
    STATE(2107), 1,
      sym_template_type,
    STATE(2110), 1,
      sym_dependent_type_identifier,
    STATE(2114), 1,
      sym_qualified_type_identifier,
    STATE(6837), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
  [273174] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10408), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [273197] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9136), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11048), 1,
      sym_identifier,
    ACTIONS(11050), 1,
      anon_sym_template,
    STATE(2262), 1,
      sym_template_type,
    STATE(2276), 1,
      sym_dependent_type_identifier,
    STATE(2307), 1,
      sym_qualified_type_identifier,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
  [273228] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(10082), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11052), 1,
      sym_identifier,
    STATE(6042), 1,
      sym__scope_resolution,
    STATE(9087), 1,
      sym_qualified_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [273255] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11054), 1,
      sym_identifier,
    ACTIONS(11058), 1,
      sym_system_lib_string,
    STATE(8500), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(11056), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [273276] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4863), 1,
      anon_sym_LBRACE,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10978), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10980), 1,
      anon_sym_inline,
    ACTIONS(11060), 1,
      sym_identifier,
    STATE(195), 1,
      sym_declaration_list,
    STATE(6916), 1,
      sym_attribute_declaration,
    STATE(7969), 1,
      sym_nested_namespace_specifier,
    STATE(8573), 1,
      sym__namespace_specifier,
  [273307] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(10082), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11062), 1,
      sym_identifier,
    STATE(6042), 1,
      sym__scope_resolution,
    STATE(8777), 1,
      sym_qualified_identifier,
    STATE(8628), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [273334] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10418), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [273357] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1244), 1,
      anon_sym_template,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(7182), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10974), 1,
      sym_identifier,
    STATE(2104), 1,
      sym_template_type,
    STATE(2112), 1,
      sym_dependent_type_identifier,
    STATE(2472), 1,
      sym_qualified_type_identifier,
    STATE(6845), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
  [273388] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9316), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11030), 1,
      anon_sym_template,
    ACTIONS(11064), 1,
      sym_identifier,
    STATE(2338), 1,
      sym_template_type,
    STATE(2339), 1,
      sym_dependent_type_identifier,
    STATE(2385), 1,
      sym_qualified_type_identifier,
    STATE(6846), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
  [273419] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9569), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11066), 1,
      sym_identifier,
    ACTIONS(11068), 1,
      anon_sym_template,
    STATE(1849), 1,
      sym_dependent_type_identifier,
    STATE(1853), 1,
      sym_template_type,
    STATE(1972), 1,
      sym_qualified_type_identifier,
    STATE(6847), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
  [273450] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(10962), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11070), 1,
      sym_identifier,
    ACTIONS(11072), 1,
      anon_sym_template,
    STATE(3021), 1,
      sym_dependent_type_identifier,
    STATE(3026), 1,
      sym_template_type,
    STATE(3066), 1,
      sym_qualified_type_identifier,
    STATE(6848), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
  [273481] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10422), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [273504] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11074), 1,
      sym_identifier,
    ACTIONS(11076), 1,
      sym_system_lib_string,
    STATE(8533), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(11056), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [273525] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4859), 1,
      anon_sym_LBRACE,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10978), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10980), 1,
      anon_sym_inline,
    ACTIONS(11078), 1,
      sym_identifier,
    STATE(767), 1,
      sym_declaration_list,
    STATE(6942), 1,
      sym_attribute_declaration,
    STATE(7842), 1,
      sym_nested_namespace_specifier,
    STATE(8573), 1,
      sym__namespace_specifier,
  [273556] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11080), 1,
      sym_identifier,
    ACTIONS(11082), 1,
      sym_system_lib_string,
    STATE(8273), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(11056), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [273577] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9250), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11084), 1,
      sym_identifier,
    ACTIONS(11086), 1,
      anon_sym_template,
    STATE(3002), 1,
      sym_dependent_type_identifier,
    STATE(3003), 1,
      sym_template_type,
    STATE(3020), 1,
      sym_qualified_type_identifier,
    STATE(6853), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
  [273608] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10424), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [273631] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9211), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11088), 1,
      sym_identifier,
    ACTIONS(11090), 1,
      anon_sym_template,
    STATE(4077), 1,
      sym_dependent_type_identifier,
    STATE(4079), 1,
      sym_template_type,
    STATE(4171), 1,
      sym_qualified_type_identifier,
    STATE(6855), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
  [273662] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10414), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [273685] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11092), 1,
      sym_identifier,
    ACTIONS(11094), 1,
      sym_system_lib_string,
    STATE(8793), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(11056), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [273706] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(4254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11096), 1,
      sym_identifier,
    ACTIONS(11098), 1,
      anon_sym_template,
    STATE(2104), 1,
      sym_template_type,
    STATE(2112), 1,
      sym_dependent_type_identifier,
    STATE(2125), 1,
      sym_qualified_type_identifier,
    STATE(6858), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
  [273737] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10412), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [273760] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4861), 1,
      anon_sym_LBRACE,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10978), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10980), 1,
      anon_sym_inline,
    ACTIONS(11100), 1,
      sym_identifier,
    STATE(535), 1,
      sym_declaration_list,
    STATE(6920), 1,
      sym_attribute_declaration,
    STATE(7942), 1,
      sym_nested_namespace_specifier,
    STATE(8573), 1,
      sym__namespace_specifier,
  [273791] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9114), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11102), 1,
      sym_identifier,
    ACTIONS(11104), 1,
      anon_sym_template,
    STATE(2868), 1,
      sym_template_type,
    STATE(2879), 1,
      sym_dependent_type_identifier,
    STATE(2912), 1,
      sym_qualified_type_identifier,
    STATE(6861), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
  [273822] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 1,
      anon_sym_AMP,
    ACTIONS(10988), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5404), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_or,
  [273841] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10410), 1,
      anon_sym_LBRACK,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(6184), 1,
      sym__function_declarator_seq,
    ACTIONS(10420), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [273864] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_decltype,
    ACTIONS(9233), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11000), 1,
      anon_sym_template,
    ACTIONS(11106), 1,
      sym_identifier,
    STATE(1849), 1,
      sym_dependent_type_identifier,
    STATE(1853), 1,
      sym_template_type,
    STATE(1972), 1,
      sym_qualified_type_identifier,
    STATE(6864), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_decltype,
  [273895] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(11108), 1,
      anon_sym_SEMI,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [273921] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(11110), 1,
      anon_sym_SEMI,
    ACTIONS(11112), 1,
      anon_sym_EQ,
    STATE(1651), 1,
      sym_template_argument_list,
    STATE(7128), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [273947] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9503), 1,
      anon_sym_LBRACK,
    ACTIONS(10587), 1,
      anon_sym_RPAREN,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6683), 1,
      sym__function_declarator_seq,
    STATE(7019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [273973] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(11114), 1,
      anon_sym_SEMI,
    ACTIONS(11116), 1,
      anon_sym_EQ,
    STATE(1651), 1,
      sym_template_argument_list,
    STATE(7223), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [273999] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11118), 1,
      sym_identifier,
    ACTIONS(11123), 1,
      aux_sym_preproc_elif_token1,
    STATE(6869), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8562), 1,
      sym_enumerator,
    ACTIONS(11121), 4,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [274021] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9503), 1,
      anon_sym_LBRACK,
    ACTIONS(10505), 1,
      anon_sym_RPAREN,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6683), 1,
      sym__function_declarator_seq,
    STATE(7019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274047] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10896), 1,
      anon_sym_LBRACK,
    STATE(7558), 1,
      sym_gnu_asm_output_operand,
    STATE(8414), 1,
      sym_string_literal,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [274067] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9503), 1,
      anon_sym_LBRACK,
    ACTIONS(11125), 1,
      anon_sym_RPAREN,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6683), 1,
      sym__function_declarator_seq,
    STATE(7019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274093] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(11127), 1,
      anon_sym_SEMI,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274119] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(11129), 1,
      anon_sym_SEMI,
    ACTIONS(11131), 1,
      anon_sym_EQ,
    STATE(1651), 1,
      sym_template_argument_list,
    STATE(7312), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274145] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(10569), 1,
      anon_sym_COLON,
    STATE(3283), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6622), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274171] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3439), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10412), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [274193] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9503), 1,
      anon_sym_LBRACK,
    ACTIONS(10585), 1,
      anon_sym_RPAREN,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6683), 1,
      sym__function_declarator_seq,
    STATE(7019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274219] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(11133), 1,
      anon_sym_SEMI,
    ACTIONS(11135), 1,
      anon_sym_EQ,
    STATE(1651), 1,
      sym_template_argument_list,
    STATE(7279), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274245] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3439), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10420), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [274267] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11139), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11141), 1,
      anon_sym_EQ,
    ACTIONS(11137), 6,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [274285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11145), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11143), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [274301] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(11147), 1,
      anon_sym_RPAREN,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274327] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(11149), 1,
      anon_sym_SEMI,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274353] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10892), 1,
      anon_sym_LBRACK,
    STATE(7439), 1,
      sym_gnu_asm_input_operand,
    STATE(8702), 1,
      sym_string_literal,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [274373] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(11151), 1,
      anon_sym_SEMI,
    ACTIONS(11153), 1,
      anon_sym_EQ,
    STATE(1651), 1,
      sym_template_argument_list,
    STATE(7320), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274399] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(11155), 1,
      anon_sym_SEMI,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274425] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3439), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10416), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [274447] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(11157), 1,
      anon_sym_SEMI,
    ACTIONS(11159), 1,
      anon_sym_EQ,
    STATE(1651), 1,
      sym_template_argument_list,
    STATE(7266), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274473] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(10571), 1,
      anon_sym_COLON,
    STATE(3283), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6622), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274499] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(10551), 1,
      anon_sym_COLON,
    STATE(3283), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6622), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274525] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(10591), 1,
      anon_sym_COLON,
    STATE(3283), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6622), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274551] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4009), 1,
      anon_sym_LBRACK,
    ACTIONS(5534), 1,
      anon_sym_LT,
    STATE(6387), 1,
      sym_template_argument_list,
    ACTIONS(4002), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [274573] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(11161), 1,
      anon_sym_SEMI,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274599] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9503), 1,
      anon_sym_LBRACK,
    ACTIONS(10613), 1,
      anon_sym_RPAREN,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6683), 1,
      sym__function_declarator_seq,
    STATE(7019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274625] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(6992), 1,
      anon_sym_LBRACK,
    STATE(6387), 1,
      sym_template_argument_list,
    ACTIONS(4810), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [274647] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(6198), 1,
      anon_sym_LBRACK,
    STATE(3008), 1,
      sym_template_argument_list,
    ACTIONS(6200), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [274667] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9503), 1,
      anon_sym_LBRACK,
    ACTIONS(11163), 1,
      anon_sym_RPAREN,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6683), 1,
      sym__function_declarator_seq,
    STATE(7019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274693] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11165), 1,
      sym_identifier,
    ACTIONS(11170), 1,
      aux_sym_preproc_elif_token1,
    STATE(6898), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    ACTIONS(11168), 4,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [274713] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3439), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10424), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [274735] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3439), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10408), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [274757] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(11172), 1,
      anon_sym_COLON,
    STATE(3283), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6622), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274783] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(11174), 1,
      anon_sym_SEMI,
    ACTIONS(11176), 1,
      anon_sym_EQ,
    STATE(1651), 1,
      sym_template_argument_list,
    STATE(7330), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274809] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(11178), 1,
      anon_sym_RPAREN,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274835] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(11180), 1,
      anon_sym_SEMI,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274861] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9503), 1,
      anon_sym_LBRACK,
    ACTIONS(10563), 1,
      anon_sym_RPAREN,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6683), 1,
      sym__function_declarator_seq,
    STATE(7019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274887] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(10481), 1,
      anon_sym_COLON,
    STATE(3283), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6622), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [274913] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3439), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10418), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [274935] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3439), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10422), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [274957] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3439), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10414), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [274979] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(11182), 1,
      anon_sym_SEMI,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [275005] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2819), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(11184), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [275027] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11188), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11186), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [275043] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    ACTIONS(11190), 1,
      anon_sym_SEMI,
    STATE(2962), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [275069] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11192), 1,
      anon_sym_LBRACK,
    ACTIONS(11195), 1,
      anon_sym_EQ,
    ACTIONS(11197), 1,
      anon_sym_DOT,
    STATE(6914), 4,
      sym_subscript_designator,
      sym_subscript_range_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
  [275088] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10408), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [275109] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4863), 1,
      anon_sym_LBRACE,
    ACTIONS(10978), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10980), 1,
      anon_sym_inline,
    ACTIONS(10996), 1,
      sym_identifier,
    STATE(193), 1,
      sym_declaration_list,
    STATE(7864), 1,
      sym_nested_namespace_specifier,
    STATE(8573), 1,
      sym__namespace_specifier,
  [275134] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4859), 1,
      anon_sym_LBRACE,
    ACTIONS(10978), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10980), 1,
      anon_sym_inline,
    ACTIONS(11200), 1,
      sym_identifier,
    STATE(733), 1,
      sym_declaration_list,
    STATE(7840), 1,
      sym_nested_namespace_specifier,
    STATE(8573), 1,
      sym__namespace_specifier,
  [275159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11004), 1,
      anon_sym_AMP,
    ACTIONS(11002), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [275174] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4857), 1,
      anon_sym_LBRACE,
    ACTIONS(10978), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10980), 1,
      anon_sym_inline,
    ACTIONS(11026), 1,
      sym_identifier,
    STATE(581), 1,
      sym_declaration_list,
    STATE(8089), 1,
      sym_nested_namespace_specifier,
    STATE(8573), 1,
      sym__namespace_specifier,
  [275199] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4861), 1,
      anon_sym_LBRACE,
    ACTIONS(10976), 1,
      sym_identifier,
    ACTIONS(10978), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10980), 1,
      anon_sym_inline,
    STATE(517), 1,
      sym_declaration_list,
    STATE(7909), 1,
      sym_nested_namespace_specifier,
    STATE(8573), 1,
      sym__namespace_specifier,
  [275224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5474), 1,
      anon_sym_AMP,
    ACTIONS(5476), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [275239] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5839), 1,
      anon_sym_LBRACK,
    ACTIONS(5925), 1,
      anon_sym_COLON,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    STATE(2456), 1,
      sym_parameter_list,
    STATE(7002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [275262] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10412), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [275283] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10424), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [275304] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10420), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [275325] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5839), 1,
      anon_sym_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(11202), 1,
      anon_sym_RPAREN,
    STATE(2456), 1,
      sym_parameter_list,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [275348] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(6198), 1,
      anon_sym_LBRACK,
    STATE(6387), 1,
      sym_template_argument_list,
    ACTIONS(6200), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [275367] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10422), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [275388] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5839), 1,
      anon_sym_LBRACK,
    ACTIONS(5907), 1,
      anon_sym_COLON,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    STATE(2456), 1,
      sym_parameter_list,
    STATE(7002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [275411] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(9760), 1,
      anon_sym_LBRACK,
    STATE(2914), 1,
      sym_parameter_list,
    STATE(6604), 1,
      sym__function_declarator_seq,
    STATE(6482), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [275434] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5839), 1,
      anon_sym_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(11204), 1,
      anon_sym_RPAREN,
    STATE(2456), 1,
      sym_parameter_list,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [275457] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5839), 1,
      anon_sym_LBRACK,
    ACTIONS(5845), 1,
      anon_sym_COLON,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    STATE(2456), 1,
      sym_parameter_list,
    STATE(7002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [275480] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10418), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [275501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11208), 1,
      anon_sym_AMP,
    ACTIONS(11206), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [275516] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5839), 1,
      anon_sym_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(11210), 1,
      anon_sym_RPAREN,
    STATE(2456), 1,
      sym_parameter_list,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [275539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5466), 1,
      anon_sym_AMP,
    ACTIONS(5468), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [275554] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5839), 1,
      anon_sym_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(11212), 1,
      anon_sym_RPAREN,
    STATE(2456), 1,
      sym_parameter_list,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [275577] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5833), 1,
      anon_sym_COLON,
    ACTIONS(5839), 1,
      anon_sym_LBRACK,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    STATE(2456), 1,
      sym_parameter_list,
    STATE(7002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [275600] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3079), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10418), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [275621] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4861), 1,
      anon_sym_LBRACE,
    ACTIONS(10978), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10980), 1,
      anon_sym_inline,
    ACTIONS(11214), 1,
      sym_identifier,
    STATE(462), 1,
      sym_declaration_list,
    STATE(7823), 1,
      sym_nested_namespace_specifier,
    STATE(8573), 1,
      sym__namespace_specifier,
  [275646] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11216), 1,
      anon_sym_LBRACK,
    ACTIONS(11218), 1,
      anon_sym_EQ,
    ACTIONS(11220), 1,
      anon_sym_DOT,
    STATE(6914), 4,
      sym_subscript_designator,
      sym_subscript_range_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
  [275665] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4859), 1,
      anon_sym_LBRACE,
    ACTIONS(10978), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10980), 1,
      anon_sym_inline,
    ACTIONS(11012), 1,
      sym_identifier,
    STATE(696), 1,
      sym_declaration_list,
    STATE(8057), 1,
      sym_nested_namespace_specifier,
    STATE(8573), 1,
      sym__namespace_specifier,
  [275690] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3079), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10422), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [275711] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4863), 1,
      anon_sym_LBRACE,
    ACTIONS(10978), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10980), 1,
      anon_sym_inline,
    ACTIONS(11222), 1,
      sym_identifier,
    STATE(248), 1,
      sym_declaration_list,
    STATE(8022), 1,
      sym_nested_namespace_specifier,
    STATE(8573), 1,
      sym__namespace_specifier,
  [275736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_AMP,
    ACTIONS(4347), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [275751] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3079), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10412), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [275772] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3079), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10420), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [275793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      anon_sym_AMP,
    ACTIONS(5456), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [275808] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5839), 1,
      anon_sym_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(11224), 1,
      anon_sym_RPAREN,
    STATE(2456), 1,
      sym_parameter_list,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [275831] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3079), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10424), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [275852] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3079), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10416), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [275873] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3079), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10414), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [275894] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11228), 1,
      anon_sym_COMMA,
    ACTIONS(11230), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11226), 5,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [275911] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5839), 1,
      anon_sym_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(11232), 1,
      anon_sym_RPAREN,
    STATE(2456), 1,
      sym_parameter_list,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [275934] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10414), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [275955] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3079), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10408), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [275976] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    STATE(2487), 1,
      sym_template_argument_list,
    STATE(7448), 2,
      sym_argument_list,
      sym_initializer_list,
  [275999] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5839), 1,
      anon_sym_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(11234), 1,
      anon_sym_RPAREN,
    STATE(2456), 1,
      sym_parameter_list,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [276022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11238), 1,
      anon_sym_AMP,
    ACTIONS(11236), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [276037] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10416), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [276058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11242), 1,
      anon_sym_AMP,
    ACTIONS(11240), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [276073] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5839), 1,
      anon_sym_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(11244), 1,
      anon_sym_RPAREN,
    STATE(2456), 1,
      sym_parameter_list,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [276096] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5839), 1,
      anon_sym_LBRACK,
    ACTIONS(5899), 1,
      anon_sym_COLON,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    STATE(2456), 1,
      sym_parameter_list,
    STATE(7002), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [276119] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5839), 1,
      anon_sym_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(11246), 1,
      anon_sym_RPAREN,
    STATE(2456), 1,
      sym_parameter_list,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [276142] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5839), 1,
      anon_sym_LBRACK,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(11248), 1,
      anon_sym_RPAREN,
    STATE(2456), 1,
      sym_parameter_list,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [276165] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4857), 1,
      anon_sym_LBRACE,
    ACTIONS(10978), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10980), 1,
      anon_sym_inline,
    ACTIONS(11250), 1,
      sym_identifier,
    STATE(519), 1,
      sym_declaration_list,
    STATE(7963), 1,
      sym_nested_namespace_specifier,
    STATE(8573), 1,
      sym__namespace_specifier,
  [276190] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11252), 1,
      anon_sym_LPAREN2,
    STATE(7005), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11254), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [276206] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5006), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    STATE(5750), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6074), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [276224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11256), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11258), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [276238] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11260), 1,
      anon_sym_LPAREN2,
    STATE(6967), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11254), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [276254] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11262), 1,
      anon_sym_LPAREN2,
    STATE(6972), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11254), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [276270] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11264), 1,
      anon_sym_LPAREN2,
    STATE(7005), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11254), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [276286] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11266), 1,
      anon_sym_LPAREN2,
    STATE(7005), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11254), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [276302] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11268), 1,
      anon_sym_LPAREN2,
    STATE(6977), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11254), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [276318] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11270), 1,
      anon_sym_LPAREN2,
    STATE(6973), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11254), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [276334] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11272), 1,
      anon_sym_LPAREN2,
    STATE(7005), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11254), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [276350] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11274), 1,
      anon_sym_LPAREN2,
    STATE(7005), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11254), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [276366] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11276), 1,
      anon_sym_LPAREN2,
    STATE(6984), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11254), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [276382] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6796), 1,
      anon_sym___attribute__,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5946), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6142), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [276400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11278), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11280), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [276414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11282), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11284), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [276428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10884), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11286), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [276442] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10910), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [276462] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11288), 1,
      anon_sym_LPAREN2,
    STATE(7005), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11254), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [276478] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11290), 1,
      anon_sym_LPAREN2,
    STATE(6976), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11254), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [276494] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(619), 1,
      anon_sym_LBRACE,
    ACTIONS(9900), 1,
      anon_sym_try,
    ACTIONS(11292), 1,
      anon_sym_SEMI,
    ACTIONS(11294), 1,
      anon_sym_EQ,
    STATE(477), 2,
      sym_compound_statement,
      sym_try_statement,
  [276514] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11296), 1,
      anon_sym_LPAREN2,
    STATE(7005), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11254), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [276530] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11298), 1,
      anon_sym_LPAREN2,
    STATE(7005), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11254), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [276546] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9525), 1,
      anon_sym_try,
    ACTIONS(10525), 1,
      anon_sym_LBRACE,
    ACTIONS(11300), 1,
      anon_sym_SEMI,
    ACTIONS(11302), 1,
      anon_sym_EQ,
    STATE(1877), 2,
      sym_compound_statement,
      sym_try_statement,
  [276566] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    ACTIONS(9834), 1,
      anon_sym_try,
    ACTIONS(11304), 1,
      anon_sym_SEMI,
    ACTIONS(11306), 1,
      anon_sym_EQ,
    STATE(231), 2,
      sym_compound_statement,
      sym_try_statement,
  [276586] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11308), 1,
      anon_sym_LPAREN2,
    STATE(7011), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11254), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [276602] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11310), 1,
      anon_sym_LPAREN2,
    STATE(6987), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11254), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [276618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(9025), 1,
      sym_string_literal,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [276632] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9517), 1,
      anon_sym_try,
    ACTIONS(10555), 1,
      anon_sym_LBRACE,
    ACTIONS(11312), 1,
      anon_sym_SEMI,
    ACTIONS(11314), 1,
      anon_sym_EQ,
    STATE(1721), 2,
      sym_compound_statement,
      sym_try_statement,
  [276652] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    ACTIONS(9834), 1,
      anon_sym_try,
    ACTIONS(11316), 1,
      anon_sym_SEMI,
    ACTIONS(11318), 1,
      anon_sym_EQ,
    STATE(194), 2,
      sym_compound_statement,
      sym_try_statement,
  [276672] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9509), 1,
      anon_sym_try,
    ACTIONS(10543), 1,
      anon_sym_LBRACE,
    ACTIONS(11320), 1,
      anon_sym_SEMI,
    ACTIONS(11322), 1,
      anon_sym_EQ,
    STATE(2082), 2,
      sym_compound_statement,
      sym_try_statement,
  [276692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11324), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11326), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [276706] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 1,
      anon_sym_LBRACE,
    ACTIONS(9996), 1,
      anon_sym_try,
    ACTIONS(11328), 1,
      anon_sym_SEMI,
    ACTIONS(11330), 1,
      anon_sym_EQ,
    STATE(491), 2,
      sym_compound_statement,
      sym_try_statement,
  [276726] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9509), 1,
      anon_sym_try,
    ACTIONS(10543), 1,
      anon_sym_LBRACE,
    ACTIONS(11332), 1,
      anon_sym_SEMI,
    ACTIONS(11334), 1,
      anon_sym_EQ,
    STATE(1898), 2,
      sym_compound_statement,
      sym_try_statement,
  [276746] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(619), 1,
      anon_sym_LBRACE,
    ACTIONS(9900), 1,
      anon_sym_try,
    ACTIONS(11336), 1,
      anon_sym_SEMI,
    ACTIONS(11338), 1,
      anon_sym_EQ,
    STATE(584), 2,
      sym_compound_statement,
      sym_try_statement,
  [276766] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9525), 1,
      anon_sym_try,
    ACTIONS(10525), 1,
      anon_sym_LBRACE,
    ACTIONS(11340), 1,
      anon_sym_SEMI,
    ACTIONS(11342), 1,
      anon_sym_EQ,
    STATE(1939), 2,
      sym_compound_statement,
      sym_try_statement,
  [276786] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5968), 1,
      anon_sym_LBRACK,
    ACTIONS(7545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5970), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(6133), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [276804] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(6198), 1,
      anon_sym_LBRACK,
    STATE(3061), 1,
      sym_template_argument_list,
    ACTIONS(6200), 3,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [276822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11278), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11280), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [276836] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11344), 1,
      anon_sym_LPAREN2,
    STATE(7005), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11346), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [276852] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(9904), 1,
      anon_sym_try,
    ACTIONS(11349), 1,
      anon_sym_SEMI,
    ACTIONS(11351), 1,
      anon_sym_EQ,
    STATE(698), 2,
      sym_compound_statement,
      sym_try_statement,
  [276872] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9517), 1,
      anon_sym_try,
    ACTIONS(10555), 1,
      anon_sym_LBRACE,
    ACTIONS(11353), 1,
      anon_sym_SEMI,
    ACTIONS(11355), 1,
      anon_sym_EQ,
    STATE(1806), 2,
      sym_compound_statement,
      sym_try_statement,
  [276892] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(10756), 1,
      anon_sym_LBRACK,
    STATE(6707), 1,
      sym_template_argument_list,
    ACTIONS(10754), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [276910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(9132), 1,
      sym_string_literal,
    ACTIONS(115), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [276924] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11357), 1,
      anon_sym_LPAREN2,
    STATE(6988), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11254), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [276940] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11359), 1,
      anon_sym_LPAREN2,
    STATE(7005), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11254), 3,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [276956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11282), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11284), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [276970] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6192), 1,
      anon_sym_LT,
    ACTIONS(6198), 1,
      anon_sym_LBRACK,
    STATE(3061), 1,
      sym_template_argument_list,
    ACTIONS(6200), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [276988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11361), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11363), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [277002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11365), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11367), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [277016] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(9904), 1,
      anon_sym_try,
    ACTIONS(11369), 1,
      anon_sym_SEMI,
    ACTIONS(11371), 1,
      anon_sym_EQ,
    STATE(737), 2,
      sym_compound_statement,
      sym_try_statement,
  [277036] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 1,
      anon_sym_LBRACE,
    ACTIONS(9996), 1,
      anon_sym_try,
    ACTIONS(11373), 1,
      anon_sym_SEMI,
    ACTIONS(11375), 1,
      anon_sym_EQ,
    STATE(470), 2,
      sym_compound_statement,
      sym_try_statement,
  [277056] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(10752), 1,
      anon_sym_LBRACK,
    STATE(6722), 1,
      sym_template_argument_list,
    ACTIONS(10748), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [277074] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10767), 1,
      anon_sym_LBRACK,
    ACTIONS(10765), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(6354), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [277092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11123), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11121), 5,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [277106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11377), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11379), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [277120] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3079), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
    ACTIONS(10910), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [277140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11381), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11383), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [277154] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(11385), 1,
      anon_sym_RPAREN,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
  [277173] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10978), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10980), 1,
      anon_sym_inline,
    ACTIONS(11387), 1,
      sym_identifier,
    STATE(8513), 1,
      sym_nested_namespace_specifier,
    STATE(8573), 1,
      sym__namespace_specifier,
  [277192] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10978), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10980), 1,
      anon_sym_inline,
    ACTIONS(11389), 1,
      sym_identifier,
    STATE(7531), 1,
      sym__namespace_specifier,
    STATE(8064), 1,
      sym_nested_namespace_specifier,
  [277211] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(11391), 1,
      anon_sym_RPAREN,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
  [277230] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(11393), 1,
      anon_sym_SEMI,
    STATE(7057), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8643), 1,
      sym_attribute_specifier,
  [277249] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(11395), 1,
      anon_sym_SEMI,
    STATE(7127), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8352), 1,
      sym_attribute_specifier,
  [277268] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10978), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10980), 1,
      anon_sym_inline,
    ACTIONS(11397), 1,
      sym_identifier,
    STATE(8317), 1,
      sym_nested_namespace_specifier,
    STATE(8573), 1,
      sym__namespace_specifier,
  [277287] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9068), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9072), 1,
      anon_sym_EQ,
    ACTIONS(11399), 1,
      sym_identifier,
    ACTIONS(9070), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [277304] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    ACTIONS(11403), 1,
      anon_sym_COLON_COLON,
    STATE(7900), 1,
      sym_argument_list,
    ACTIONS(11401), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [277321] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(11405), 1,
      anon_sym_SEMI,
    STATE(7127), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9002), 1,
      sym_attribute_specifier,
  [277340] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(11407), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
    STATE(2539), 1,
      sym_template_method,
    STATE(8190), 1,
      sym_operator_name,
  [277359] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(11409), 1,
      anon_sym_SEMI,
    STATE(7069), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8353), 1,
      sym_attribute_specifier,
  [277378] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(11411), 1,
      anon_sym_SEMI,
    STATE(7066), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8371), 1,
      sym_attribute_specifier,
  [277397] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(11413), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
    STATE(2539), 1,
      sym_template_method,
    STATE(7822), 1,
      sym_operator_name,
  [277416] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7123), 1,
      sym_auto,
    ACTIONS(7125), 1,
      anon_sym_decltype,
    STATE(2182), 1,
      sym_decltype_auto,
    ACTIONS(11415), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [277433] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10414), 1,
      anon_sym_COLON,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3421), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
  [277452] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7123), 1,
      sym_auto,
    ACTIONS(7125), 1,
      anon_sym_decltype,
    STATE(2182), 1,
      sym_decltype_auto,
    ACTIONS(11417), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [277469] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(11419), 1,
      anon_sym_SEMI,
    STATE(7127), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9003), 1,
      sym_attribute_specifier,
  [277488] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10424), 1,
      anon_sym_COLON,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3421), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
  [277507] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(11421), 1,
      anon_sym_SEMI,
    STATE(7070), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9012), 1,
      sym_attribute_specifier,
  [277526] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(11423), 1,
      anon_sym_SEMI,
    STATE(7127), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8645), 1,
      sym_attribute_specifier,
  [277545] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(6198), 1,
      anon_sym_LBRACK,
    STATE(2938), 1,
      sym_template_argument_list,
    ACTIONS(6200), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [277562] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(11425), 1,
      anon_sym_SEMI,
    STATE(7058), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8641), 1,
      sym_attribute_specifier,
  [277581] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(11427), 1,
      aux_sym_preproc_if_token2,
    STATE(6953), 1,
      sym_enumerator,
    STATE(7088), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(7227), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
  [277600] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10978), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10980), 1,
      anon_sym_inline,
    ACTIONS(11429), 1,
      sym_identifier,
    STATE(8568), 1,
      sym_nested_namespace_specifier,
    STATE(8573), 1,
      sym__namespace_specifier,
  [277619] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10978), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10980), 1,
      anon_sym_inline,
    ACTIONS(11431), 1,
      sym_identifier,
    STATE(8573), 1,
      sym__namespace_specifier,
    STATE(8887), 1,
      sym_nested_namespace_specifier,
  [277638] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11433), 1,
      anon_sym_EQ,
    ACTIONS(10248), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [277651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11437), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11435), 4,
      sym_identifier,
      anon_sym_decltype,
      sym_virtual,
      anon_sym_template,
  [277664] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(11439), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
    STATE(3963), 1,
      sym_template_method,
    STATE(8182), 1,
      sym_operator_name,
  [277683] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10408), 1,
      anon_sym_COLON,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3421), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
  [277702] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(11441), 1,
      anon_sym_RPAREN,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
  [277721] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    STATE(2487), 1,
      sym_template_argument_list,
    ACTIONS(6128), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
  [277738] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(11407), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
    STATE(2539), 1,
      sym_template_method,
    STATE(8124), 1,
      sym_operator_name,
  [277757] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(11443), 1,
      anon_sym_SEMI,
    STATE(7127), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8785), 1,
      sym_attribute_specifier,
  [277776] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(11445), 1,
      anon_sym_SEMI,
    STATE(7127), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8778), 1,
      sym_attribute_specifier,
  [277795] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10422), 1,
      anon_sym_COLON,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3421), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
  [277814] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(11447), 1,
      anon_sym_SEMI,
    STATE(7041), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8776), 1,
      sym_attribute_specifier,
  [277833] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(11449), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
    STATE(3783), 1,
      sym_template_method,
    STATE(7860), 1,
      sym_operator_name,
  [277852] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(11451), 1,
      anon_sym_SEMI,
    STATE(7127), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8931), 1,
      sym_attribute_specifier,
  [277871] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10416), 1,
      anon_sym_COLON,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3421), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
  [277890] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(11453), 1,
      anon_sym_SEMI,
    STATE(7078), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8327), 1,
      sym_attribute_specifier,
  [277909] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(11455), 1,
      anon_sym_SEMI,
    STATE(7127), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8934), 1,
      sym_attribute_specifier,
  [277928] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(11457), 1,
      anon_sym_SEMI,
    STATE(7127), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8318), 1,
      sym_attribute_specifier,
  [277947] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(6198), 1,
      anon_sym_LBRACK,
    STATE(4112), 1,
      sym_template_argument_list,
    ACTIONS(6200), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [277964] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(11459), 1,
      anon_sym_SEMI,
    STATE(7127), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8939), 1,
      sym_attribute_specifier,
  [277983] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(11461), 1,
      anon_sym_SEMI,
    STATE(7127), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8315), 1,
      sym_attribute_specifier,
  [278002] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(11463), 1,
      anon_sym_SEMI,
    STATE(7127), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8941), 1,
      sym_attribute_specifier,
  [278021] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1883), 1,
      anon_sym_operator,
    ACTIONS(11465), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
    STATE(4037), 1,
      sym_template_method,
    STATE(7869), 1,
      sym_operator_name,
  [278040] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(11467), 1,
      anon_sym_SEMI,
    STATE(7062), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8979), 1,
      sym_attribute_specifier,
  [278059] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10412), 1,
      anon_sym_COLON,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3421), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
  [278078] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10978), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10980), 1,
      anon_sym_inline,
    ACTIONS(11389), 1,
      sym_identifier,
    STATE(7605), 1,
      sym__namespace_specifier,
    STATE(7979), 1,
      sym_nested_namespace_specifier,
  [278097] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(11469), 1,
      anon_sym_SEMI,
    STATE(7127), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8301), 1,
      sym_attribute_specifier,
  [278116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11471), 1,
      anon_sym_EQ,
    ACTIONS(10248), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [278129] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10420), 1,
      anon_sym_COLON,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3421), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
  [278148] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(11473), 1,
      anon_sym_SEMI,
    STATE(7127), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8300), 1,
      sym_attribute_specifier,
  [278167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11475), 2,
      anon_sym_class,
      anon_sym_typename,
    STATE(7986), 3,
      sym_type_parameter_declaration,
      sym_variadic_type_parameter_declaration,
      sym_optional_type_parameter_declaration,
  [278180] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(11477), 1,
      anon_sym_SEMI,
    STATE(7127), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9009), 1,
      sym_attribute_specifier,
  [278199] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(8230), 1,
      anon_sym_COMMA,
    ACTIONS(11479), 1,
      anon_sym_SEMI,
    STATE(7068), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9010), 1,
      sym_attribute_specifier,
  [278218] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(11481), 1,
      anon_sym_RPAREN,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
  [278237] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10418), 1,
      anon_sym_COLON,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3421), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
  [278256] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11483), 1,
      anon_sym_DQUOTE,
    ACTIONS(11485), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11487), 1,
      sym_escape_sequence,
    STATE(7137), 1,
      aux_sym_string_literal_repeat1,
  [278272] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11489), 1,
      anon_sym_SEMI,
    STATE(4457), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [278286] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10228), 1,
      anon_sym_LBRACE,
    STATE(3639), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [278300] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    STATE(3673), 1,
      sym_argument_list,
    STATE(4160), 1,
      sym_initializer_list,
  [278316] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(11491), 1,
      aux_sym_preproc_if_token2,
    STATE(6898), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [278330] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2518), 1,
      anon_sym_LBRACE,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    STATE(2641), 1,
      sym_initializer_list,
    STATE(2726), 1,
      sym_argument_list,
  [278346] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11493), 1,
      anon_sym_DQUOTE,
    ACTIONS(11495), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11497), 1,
      sym_escape_sequence,
    STATE(7134), 1,
      aux_sym_string_literal_repeat1,
  [278362] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(11427), 1,
      aux_sym_preproc_if_token2,
    STATE(7227), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8562), 1,
      sym_enumerator,
  [278378] = 4,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11499), 1,
      anon_sym_SQUOTE,
    STATE(7092), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11501), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [278392] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11504), 1,
      anon_sym_SEMI,
    STATE(4457), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [278406] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(8202), 1,
      anon_sym_LBRACE,
    STATE(4622), 1,
      sym_field_declaration_list,
    STATE(7850), 1,
      sym_base_class_clause,
  [278422] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11506), 1,
      anon_sym_DQUOTE,
    ACTIONS(11508), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11510), 1,
      sym_escape_sequence,
    STATE(7090), 1,
      aux_sym_string_literal_repeat1,
  [278438] = 4,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11512), 1,
      anon_sym_SQUOTE,
    STATE(7092), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11514), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [278452] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11495), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11497), 1,
      sym_escape_sequence,
    ACTIONS(11516), 1,
      anon_sym_DQUOTE,
    STATE(7134), 1,
      aux_sym_string_literal_repeat1,
  [278468] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11495), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11497), 1,
      sym_escape_sequence,
    ACTIONS(11518), 1,
      anon_sym_DQUOTE,
    STATE(7134), 1,
      aux_sym_string_literal_repeat1,
  [278484] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11520), 1,
      anon_sym_SEMI,
    STATE(7143), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [278498] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11522), 1,
      anon_sym_DQUOTE,
    ACTIONS(11524), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11526), 1,
      sym_escape_sequence,
    STATE(7098), 1,
      aux_sym_string_literal_repeat1,
  [278514] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11495), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11497), 1,
      sym_escape_sequence,
    ACTIONS(11528), 1,
      anon_sym_DQUOTE,
    STATE(7134), 1,
      aux_sym_string_literal_repeat1,
  [278530] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10230), 1,
      anon_sym_LBRACE,
    STATE(4842), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [278544] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11530), 1,
      anon_sym_DQUOTE,
    ACTIONS(11532), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11534), 1,
      sym_escape_sequence,
    STATE(7101), 1,
      aux_sym_string_literal_repeat1,
  [278560] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11536), 1,
      anon_sym_LPAREN2,
    ACTIONS(11538), 1,
      anon_sym_LBRACE,
    STATE(6116), 1,
      sym_requirement_seq,
    STATE(8156), 1,
      sym_requires_parameter_list,
  [278576] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11495), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11497), 1,
      sym_escape_sequence,
    ACTIONS(11540), 1,
      anon_sym_DQUOTE,
    STATE(7134), 1,
      aux_sym_string_literal_repeat1,
  [278592] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11542), 1,
      anon_sym_SEMI,
    STATE(7232), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [278606] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11544), 1,
      anon_sym_DQUOTE,
    ACTIONS(11546), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11548), 1,
      sym_escape_sequence,
    STATE(7105), 1,
      aux_sym_string_literal_repeat1,
  [278622] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(11550), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11552), 1,
      anon_sym_GT2,
    STATE(7810), 1,
      aux_sym_template_argument_list_repeat1,
  [278638] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10220), 1,
      anon_sym_LBRACE,
    STATE(3980), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [278652] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    STATE(7420), 2,
      sym_argument_list,
      sym_initializer_list,
  [278666] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    STATE(7597), 1,
      sym_compound_statement,
    STATE(7895), 1,
      sym_field_initializer_list,
  [278682] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11554), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11556), 1,
      anon_sym_LPAREN,
    ACTIONS(11558), 1,
      sym_preproc_arg,
    STATE(8021), 1,
      sym_preproc_params,
  [278698] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4859), 1,
      anon_sym_LBRACE,
    ACTIONS(11560), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11562), 1,
      anon_sym_EQ,
    STATE(732), 1,
      sym_declaration_list,
  [278714] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11495), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11497), 1,
      sym_escape_sequence,
    ACTIONS(11564), 1,
      anon_sym_DQUOTE,
    STATE(7134), 1,
      aux_sym_string_literal_repeat1,
  [278730] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(11550), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11566), 1,
      anon_sym_GT2,
    STATE(7786), 1,
      aux_sym_template_argument_list_repeat1,
  [278746] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11568), 1,
      anon_sym_SEMI,
    STATE(7167), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [278760] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10434), 1,
      sym_identifier,
    ACTIONS(11570), 1,
      aux_sym_preproc_if_token2,
    STATE(7088), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [278774] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11572), 1,
      anon_sym___except,
    ACTIONS(11574), 1,
      anon_sym___finally,
    STATE(144), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [278788] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11576), 1,
      anon_sym_DQUOTE,
    ACTIONS(11578), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11580), 1,
      sym_escape_sequence,
    STATE(7114), 1,
      aux_sym_string_literal_repeat1,
  [278804] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    STATE(7739), 1,
      sym_compound_statement,
    STATE(7855), 1,
      sym_field_initializer_list,
  [278820] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11556), 1,
      anon_sym_LPAREN,
    ACTIONS(11582), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11584), 1,
      sym_preproc_arg,
    STATE(7827), 1,
      sym_preproc_params,
  [278836] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11586), 1,
      anon_sym_DQUOTE,
    ACTIONS(11588), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11590), 1,
      sym_escape_sequence,
    STATE(7344), 1,
      aux_sym_string_literal_repeat1,
  [278852] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(11550), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11592), 1,
      anon_sym_GT2,
    STATE(7790), 1,
      aux_sym_template_argument_list_repeat1,
  [278868] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11594), 1,
      anon_sym_DQUOTE,
    ACTIONS(11596), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11598), 1,
      sym_escape_sequence,
    STATE(7172), 1,
      aux_sym_string_literal_repeat1,
  [278884] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11495), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11497), 1,
      sym_escape_sequence,
    ACTIONS(11600), 1,
      anon_sym_DQUOTE,
    STATE(7134), 1,
      aux_sym_string_literal_repeat1,
  [278900] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11602), 1,
      anon_sym_SEMI,
    STATE(4457), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [278914] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11604), 1,
      anon_sym_COMMA,
    STATE(7127), 1,
      aux_sym_field_declaration_repeat1,
    ACTIONS(11607), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [278928] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11609), 1,
      anon_sym_EQ,
    STATE(6354), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [278942] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11611), 1,
      anon_sym_DQUOTE,
    ACTIONS(11613), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11615), 1,
      sym_escape_sequence,
    STATE(7097), 1,
      aux_sym_string_literal_repeat1,
  [278958] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11617), 1,
      anon_sym_DQUOTE,
    ACTIONS(11619), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11621), 1,
      sym_escape_sequence,
    STATE(7125), 1,
      aux_sym_string_literal_repeat1,
  [278974] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11623), 1,
      anon_sym_SEMI,
    STATE(7222), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [278988] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10230), 1,
      anon_sym_LBRACE,
    STATE(4915), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [279002] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(8202), 1,
      anon_sym_LBRACE,
    STATE(4657), 1,
      sym_field_declaration_list,
    STATE(7898), 1,
      sym_base_class_clause,
  [279018] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11625), 1,
      anon_sym_DQUOTE,
    ACTIONS(11627), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11630), 1,
      sym_escape_sequence,
    STATE(7134), 1,
      aux_sym_string_literal_repeat1,
  [279034] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(11633), 1,
      anon_sym_SEMI,
    STATE(1651), 1,
      sym_template_argument_list,
  [279050] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(11550), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11635), 1,
      anon_sym_GT2,
    STATE(7770), 1,
      aux_sym_template_argument_list_repeat1,
  [279066] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11495), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11497), 1,
      sym_escape_sequence,
    ACTIONS(11637), 1,
      anon_sym_DQUOTE,
    STATE(7134), 1,
      aux_sym_string_literal_repeat1,
  [279082] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(11550), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11639), 1,
      anon_sym_GT2,
    STATE(7562), 1,
      aux_sym_template_argument_list_repeat1,
  [279098] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(6179), 1,
      anon_sym_LBRACE,
    STATE(3010), 1,
      sym_field_declaration_list,
    STATE(8061), 1,
      sym_base_class_clause,
  [279114] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(11550), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11641), 1,
      anon_sym_GT2,
    STATE(7693), 1,
      aux_sym_template_argument_list_repeat1,
  [279130] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3289), 1,
      anon_sym_LBRACE,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    STATE(3884), 1,
      sym_argument_list,
    STATE(3944), 1,
      sym_initializer_list,
  [279146] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11643), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11645), 1,
      anon_sym_COMMA,
    ACTIONS(11647), 1,
      anon_sym_LBRACE,
    STATE(7570), 1,
      aux_sym_base_class_clause_repeat1,
  [279162] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11649), 1,
      anon_sym_SEMI,
    STATE(4457), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [279176] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    STATE(2726), 1,
      sym_argument_list,
    STATE(4269), 1,
      sym_initializer_list,
  [279192] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(11651), 1,
      anon_sym_SEMI,
    STATE(1651), 1,
      sym_template_argument_list,
  [279208] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11653), 1,
      anon_sym_EQ,
    STATE(7299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [279222] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10256), 1,
      anon_sym_LBRACE,
    STATE(2744), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [279236] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(5548), 1,
      anon_sym_LBRACE,
    STATE(2325), 1,
      sym_field_declaration_list,
    STATE(7825), 1,
      sym_base_class_clause,
  [279252] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4260), 1,
      anon_sym_LT,
    ACTIONS(11655), 1,
      sym_identifier,
    STATE(780), 1,
      sym_template_parameter_list,
    STATE(2111), 1,
      sym_template_type,
  [279268] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(11550), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11657), 1,
      anon_sym_GT2,
    STATE(7750), 1,
      aux_sym_template_argument_list_repeat1,
  [279284] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11659), 1,
      anon_sym___except,
    ACTIONS(11661), 1,
      anon_sym___finally,
    STATE(419), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [279298] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(11550), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11663), 1,
      anon_sym_GT2,
    STATE(7524), 1,
      aux_sym_template_argument_list_repeat1,
  [279314] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11665), 1,
      anon_sym_COMMA,
    STATE(7341), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(11667), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [279328] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11495), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11497), 1,
      sym_escape_sequence,
    ACTIONS(11669), 1,
      anon_sym_DQUOTE,
    STATE(7134), 1,
      aux_sym_string_literal_repeat1,
  [279344] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11671), 1,
      anon_sym_SEMI,
    STATE(7093), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [279358] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(11673), 1,
      anon_sym_SEMI,
    STATE(1651), 1,
      sym_template_argument_list,
  [279374] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11675), 1,
      anon_sym_DQUOTE,
    ACTIONS(11677), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11679), 1,
      sym_escape_sequence,
    STATE(7154), 1,
      aux_sym_string_literal_repeat1,
  [279390] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    STATE(2242), 1,
      sym_field_declaration_list,
    STATE(8138), 1,
      sym_base_class_clause,
  [279406] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11681), 1,
      anon_sym_COMMA,
    STATE(7267), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(11683), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [279420] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(11550), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11685), 1,
      anon_sym_GT2,
    STATE(7729), 1,
      aux_sym_template_argument_list_repeat1,
  [279436] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11495), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11497), 1,
      sym_escape_sequence,
    ACTIONS(11687), 1,
      anon_sym_DQUOTE,
    STATE(7134), 1,
      aux_sym_string_literal_repeat1,
  [279452] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10220), 1,
      anon_sym_LBRACE,
    STATE(4016), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [279466] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2791), 1,
      anon_sym_LBRACE,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    STATE(3673), 1,
      sym_argument_list,
    STATE(3678), 1,
      sym_initializer_list,
  [279482] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11556), 1,
      anon_sym_LPAREN,
    ACTIONS(11689), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11691), 1,
      sym_preproc_arg,
    STATE(8045), 1,
      sym_preproc_params,
  [279498] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11693), 1,
      anon_sym_SEMI,
    ACTIONS(11695), 1,
      anon_sym_DASH_GT,
    ACTIONS(11697), 1,
      anon_sym_noexcept,
    STATE(8716), 1,
      sym_trailing_return_type,
  [279514] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11699), 1,
      anon_sym_SEMI,
    STATE(7194), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [279528] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11701), 1,
      anon_sym_SEMI,
    STATE(4457), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [279542] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11703), 1,
      anon_sym_DQUOTE,
    ACTIONS(11705), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11707), 1,
      sym_escape_sequence,
    STATE(7161), 1,
      aux_sym_string_literal_repeat1,
  [279558] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4260), 1,
      anon_sym_LT,
    ACTIONS(11655), 1,
      sym_identifier,
    STATE(785), 1,
      sym_template_parameter_list,
    STATE(2111), 1,
      sym_template_type,
  [279574] = 4,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11709), 1,
      anon_sym_SQUOTE,
    STATE(7092), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11514), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [279588] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(11550), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11711), 1,
      anon_sym_GT2,
    STATE(7707), 1,
      aux_sym_template_argument_list_repeat1,
  [279604] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11495), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11497), 1,
      sym_escape_sequence,
    ACTIONS(11713), 1,
      anon_sym_DQUOTE,
    STATE(7134), 1,
      aux_sym_string_literal_repeat1,
  [279620] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9435), 1,
      anon_sym_LBRACE,
    ACTIONS(11536), 1,
      anon_sym_LPAREN2,
    STATE(3723), 1,
      sym_requirement_seq,
    STATE(7912), 1,
      sym_requires_parameter_list,
  [279636] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11495), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11497), 1,
      sym_escape_sequence,
    ACTIONS(11715), 1,
      anon_sym_DQUOTE,
    STATE(7134), 1,
      aux_sym_string_literal_repeat1,
  [279652] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10230), 1,
      anon_sym_LBRACE,
    STATE(4740), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [279666] = 4,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11717), 1,
      anon_sym_SQUOTE,
    STATE(7092), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11514), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [279680] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4260), 1,
      anon_sym_LT,
    ACTIONS(11655), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
    STATE(7079), 1,
      sym_template_parameter_list,
  [279696] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9445), 1,
      anon_sym_LBRACE,
    ACTIONS(11536), 1,
      anon_sym_LPAREN2,
    STATE(4841), 1,
      sym_requirement_seq,
    STATE(7932), 1,
      sym_requires_parameter_list,
  [279712] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    STATE(7395), 1,
      sym_compound_statement,
    STATE(7956), 1,
      sym_field_initializer_list,
  [279728] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11719), 1,
      anon_sym_DQUOTE,
    ACTIONS(11721), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11723), 1,
      sym_escape_sequence,
    STATE(7174), 1,
      aux_sym_string_literal_repeat1,
  [279744] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9461), 1,
      anon_sym_LBRACE,
    ACTIONS(11536), 1,
      anon_sym_LPAREN2,
    STATE(2647), 1,
      sym_requirement_seq,
    STATE(7951), 1,
      sym_requires_parameter_list,
  [279760] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    STATE(8181), 1,
      sym_argument_list,
    ACTIONS(11725), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [279774] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(11550), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11727), 1,
      anon_sym_GT2,
    STATE(7684), 1,
      aux_sym_template_argument_list_repeat1,
  [279790] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4857), 1,
      anon_sym_LBRACE,
    ACTIONS(11560), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11729), 1,
      anon_sym_EQ,
    STATE(509), 1,
      sym_declaration_list,
  [279806] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11495), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11497), 1,
      sym_escape_sequence,
    ACTIONS(11731), 1,
      anon_sym_DQUOTE,
    STATE(7134), 1,
      aux_sym_string_literal_repeat1,
  [279822] = 4,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11733), 1,
      anon_sym_SQUOTE,
    STATE(7092), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11514), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [279836] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4863), 1,
      anon_sym_LBRACE,
    ACTIONS(11560), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11735), 1,
      anon_sym_EQ,
    STATE(211), 1,
      sym_declaration_list,
  [279852] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11495), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11497), 1,
      sym_escape_sequence,
    ACTIONS(11737), 1,
      anon_sym_DQUOTE,
    STATE(7134), 1,
      aux_sym_string_literal_repeat1,
  [279868] = 4,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11739), 1,
      anon_sym_SQUOTE,
    STATE(7092), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11514), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [279882] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4861), 1,
      anon_sym_LBRACE,
    ACTIONS(11560), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11741), 1,
      anon_sym_EQ,
    STATE(504), 1,
      sym_declaration_list,
  [279898] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11743), 1,
      anon_sym_DQUOTE,
    ACTIONS(11745), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11747), 1,
      sym_escape_sequence,
    STATE(7185), 1,
      aux_sym_string_literal_repeat1,
  [279914] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10220), 1,
      anon_sym_LBRACE,
    STATE(3935), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [279928] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    STATE(5360), 1,
      sym_field_declaration_list,
    STATE(7961), 1,
      sym_base_class_clause,
  [279944] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11749), 1,
      anon_sym_SEMI,
    STATE(4457), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [279958] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11495), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11497), 1,
      sym_escape_sequence,
    ACTIONS(11751), 1,
      anon_sym_DQUOTE,
    STATE(7134), 1,
      aux_sym_string_literal_repeat1,
  [279974] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9480), 1,
      anon_sym_LBRACE,
    ACTIONS(11536), 1,
      anon_sym_LPAREN2,
    STATE(3782), 1,
      sym_requirement_seq,
    STATE(7923), 1,
      sym_requires_parameter_list,
  [279990] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10258), 1,
      anon_sym_LBRACE,
    STATE(6288), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [280004] = 4,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11753), 1,
      anon_sym_SQUOTE,
    STATE(7092), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11514), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [280018] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10258), 1,
      anon_sym_LBRACE,
    STATE(6277), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [280032] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(11550), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11755), 1,
      anon_sym_GT2,
    STATE(7659), 1,
      aux_sym_template_argument_list_repeat1,
  [280048] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(7651), 1,
      anon_sym_LBRACE,
    STATE(4288), 1,
      sym_field_declaration_list,
    STATE(7919), 1,
      sym_base_class_clause,
  [280064] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    STATE(5357), 1,
      sym_field_declaration_list,
    STATE(7982), 1,
      sym_base_class_clause,
  [280080] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11757), 1,
      anon_sym_DQUOTE,
    ACTIONS(11759), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11761), 1,
      sym_escape_sequence,
    STATE(7233), 1,
      aux_sym_string_literal_repeat1,
  [280096] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10258), 1,
      anon_sym_LBRACE,
    STATE(6256), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [280110] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11495), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11497), 1,
      sym_escape_sequence,
    ACTIONS(11763), 1,
      anon_sym_DQUOTE,
    STATE(7134), 1,
      aux_sym_string_literal_repeat1,
  [280126] = 4,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11765), 1,
      anon_sym_SQUOTE,
    STATE(7092), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11514), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [280140] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(7651), 1,
      anon_sym_LBRACE,
    STATE(4316), 1,
      sym_field_declaration_list,
    STATE(7924), 1,
      sym_base_class_clause,
  [280156] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    STATE(7383), 1,
      sym_compound_statement,
    STATE(7965), 1,
      sym_field_initializer_list,
  [280172] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11556), 1,
      anon_sym_LPAREN,
    ACTIONS(11767), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11769), 1,
      sym_preproc_arg,
    STATE(8092), 1,
      sym_preproc_params,
  [280188] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(6179), 1,
      anon_sym_LBRACE,
    STATE(2993), 1,
      sym_field_declaration_list,
    STATE(7892), 1,
      sym_base_class_clause,
  [280204] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11771), 1,
      anon_sym_DQUOTE,
    ACTIONS(11773), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11775), 1,
      sym_escape_sequence,
    STATE(7213), 1,
      aux_sym_string_literal_repeat1,
  [280220] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(5548), 1,
      anon_sym_LBRACE,
    STATE(2373), 1,
      sym_field_declaration_list,
    STATE(7902), 1,
      sym_base_class_clause,
  [280236] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11495), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11497), 1,
      sym_escape_sequence,
    ACTIONS(11777), 1,
      anon_sym_DQUOTE,
    STATE(7134), 1,
      aux_sym_string_literal_repeat1,
  [280252] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym_LBRACE,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    STATE(3884), 1,
      sym_argument_list,
    STATE(5246), 1,
      sym_initializer_list,
  [280268] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11779), 1,
      anon_sym_DQUOTE,
    ACTIONS(11781), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11783), 1,
      sym_escape_sequence,
    STATE(7205), 1,
      aux_sym_string_literal_repeat1,
  [280284] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(11785), 1,
      anon_sym_SEMI,
    STATE(1651), 1,
      sym_template_argument_list,
  [280300] = 4,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11787), 1,
      anon_sym_SQUOTE,
    STATE(7092), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11514), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [280314] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11789), 4,
      anon_sym_LPAREN2,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
  [280324] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4260), 1,
      anon_sym_LT,
    ACTIONS(11655), 1,
      sym_identifier,
    STATE(783), 1,
      sym_template_parameter_list,
    STATE(2111), 1,
      sym_template_type,
  [280340] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3716), 1,
      anon_sym_LBRACE,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    STATE(3841), 1,
      sym_argument_list,
    STATE(5305), 1,
      sym_initializer_list,
  [280356] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10906), 1,
      anon_sym_COMMA,
    STATE(7294), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(11791), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [280370] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11793), 1,
      anon_sym_SEMI,
    STATE(4457), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [280384] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11795), 1,
      anon_sym_EQ,
    STATE(6354), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [280398] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    STATE(7743), 1,
      sym_compound_statement,
    STATE(8002), 1,
      sym_field_initializer_list,
  [280414] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11797), 1,
      anon_sym_SEMI,
    STATE(7360), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [280428] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(5654), 1,
      anon_sym_LBRACE,
    STATE(2387), 1,
      sym_field_declaration_list,
    STATE(8107), 1,
      sym_base_class_clause,
  [280444] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10625), 1,
      sym_identifier,
    ACTIONS(11799), 1,
      aux_sym_preproc_if_token2,
    STATE(6869), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8562), 1,
      sym_enumerator,
  [280460] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(2524), 1,
      sym_field_declaration_list,
    STATE(7984), 1,
      sym_base_class_clause,
  [280476] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11801), 1,
      anon_sym_SEMI,
    STATE(7316), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [280490] = 4,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11803), 1,
      anon_sym_SQUOTE,
    STATE(7092), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11514), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [280504] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10216), 1,
      anon_sym_LBRACE,
    STATE(5272), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [280518] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11805), 1,
      anon_sym_SEMI,
    STATE(4457), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [280532] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11495), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11497), 1,
      sym_escape_sequence,
    ACTIONS(11807), 1,
      anon_sym_DQUOTE,
    STATE(7134), 1,
      aux_sym_string_literal_repeat1,
  [280548] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(1672), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [280562] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11556), 1,
      anon_sym_LPAREN,
    ACTIONS(11809), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11811), 1,
      sym_preproc_arg,
    STATE(7917), 1,
      sym_preproc_params,
  [280578] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(1670), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [280592] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    STATE(7758), 1,
      sym_compound_statement,
    STATE(8059), 1,
      sym_field_initializer_list,
  [280608] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11813), 1,
      anon_sym_DQUOTE,
    ACTIONS(11815), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11817), 1,
      sym_escape_sequence,
    STATE(7265), 1,
      aux_sym_string_literal_repeat1,
  [280624] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11819), 1,
      anon_sym_SEMI,
    STATE(7278), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [280638] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10228), 1,
      anon_sym_LBRACE,
    STATE(3768), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [280652] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(11550), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11821), 1,
      anon_sym_GT2,
    STATE(7603), 1,
      aux_sym_template_argument_list_repeat1,
  [280668] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11536), 1,
      anon_sym_LPAREN2,
    ACTIONS(11823), 1,
      anon_sym_LBRACE,
    STATE(1679), 1,
      sym_requirement_seq,
    STATE(8020), 1,
      sym_requires_parameter_list,
  [280684] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11556), 1,
      anon_sym_LPAREN,
    ACTIONS(11825), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11827), 1,
      sym_preproc_arg,
    STATE(7862), 1,
      sym_preproc_params,
  [280700] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(6275), 1,
      anon_sym_LBRACE,
    STATE(3085), 1,
      sym_field_declaration_list,
    STATE(7964), 1,
      sym_base_class_clause,
  [280716] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10264), 1,
      anon_sym_LBRACE,
    STATE(4169), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [280730] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10256), 1,
      anon_sym_LBRACE,
    STATE(2687), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [280744] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(1664), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [280758] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9453), 1,
      anon_sym_LBRACE,
    ACTIONS(11536), 1,
      anon_sym_LPAREN2,
    STATE(4001), 1,
      sym_requirement_seq,
    STATE(8086), 1,
      sym_requires_parameter_list,
  [280774] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11829), 1,
      anon_sym_SEMI,
    STATE(4457), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [280788] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11645), 1,
      anon_sym_COMMA,
    ACTIONS(11831), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11833), 1,
      anon_sym_LBRACE,
    STATE(7741), 1,
      aux_sym_base_class_clause_repeat1,
  [280804] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    STATE(3841), 1,
      sym_argument_list,
    STATE(3880), 1,
      sym_initializer_list,
  [280820] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11835), 1,
      anon_sym___except,
    ACTIONS(11837), 1,
      anon_sym___finally,
    STATE(336), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [280834] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11839), 1,
      anon_sym_SEMI,
    STATE(7126), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [280848] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11495), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11497), 1,
      sym_escape_sequence,
    ACTIONS(11841), 1,
      anon_sym_DQUOTE,
    STATE(7134), 1,
      aux_sym_string_literal_repeat1,
  [280864] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11843), 1,
      anon_sym_SEMI,
    STATE(7310), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [280878] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11645), 1,
      anon_sym_COMMA,
    ACTIONS(11845), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11847), 1,
      anon_sym_LBRACE,
    STATE(7371), 1,
      aux_sym_base_class_clause_repeat1,
  [280894] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4260), 1,
      anon_sym_LT,
    ACTIONS(11655), 1,
      sym_identifier,
    STATE(779), 1,
      sym_template_parameter_list,
    STATE(2111), 1,
      sym_template_type,
  [280910] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11849), 1,
      anon_sym_DQUOTE,
    ACTIONS(11851), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11853), 1,
      sym_escape_sequence,
    STATE(7195), 1,
      aux_sym_string_literal_repeat1,
  [280926] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11855), 1,
      anon_sym___except,
    ACTIONS(11857), 1,
      anon_sym___finally,
    STATE(845), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [280940] = 4,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11859), 1,
      anon_sym_SQUOTE,
    STATE(7092), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11514), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [280954] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(8013), 1,
      anon_sym_LBRACE,
    STATE(4578), 1,
      sym_field_declaration_list,
    STATE(8084), 1,
      sym_base_class_clause,
  [280970] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(6275), 1,
      anon_sym_LBRACE,
    STATE(3072), 1,
      sym_field_declaration_list,
    STATE(7985), 1,
      sym_base_class_clause,
  [280986] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11665), 1,
      anon_sym_COMMA,
    STATE(7153), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(11861), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [281000] = 4,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11863), 1,
      anon_sym_SQUOTE,
    STATE(7092), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11514), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [281014] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11495), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11497), 1,
      sym_escape_sequence,
    ACTIONS(11865), 1,
      anon_sym_DQUOTE,
    STATE(7134), 1,
      aux_sym_string_literal_repeat1,
  [281030] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11867), 1,
      anon_sym_EQ,
    STATE(6354), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281044] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11681), 1,
      anon_sym_COMMA,
    STATE(7362), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(11869), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [281058] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11871), 1,
      anon_sym_DQUOTE,
    ACTIONS(11873), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11875), 1,
      sym_escape_sequence,
    STATE(7188), 1,
      aux_sym_string_literal_repeat1,
  [281074] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11112), 1,
      anon_sym_EQ,
    STATE(7128), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281088] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11877), 1,
      anon_sym_COMMA,
    STATE(7367), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(11879), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [281102] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11881), 1,
      anon_sym_DQUOTE,
    ACTIONS(11883), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11885), 1,
      sym_escape_sequence,
    STATE(7254), 1,
      aux_sym_string_literal_repeat1,
  [281118] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9469), 1,
      anon_sym_LBRACE,
    ACTIONS(11536), 1,
      anon_sym_LPAREN2,
    STATE(5184), 1,
      sym_requirement_seq,
    STATE(8048), 1,
      sym_requires_parameter_list,
  [281134] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(5654), 1,
      anon_sym_LBRACE,
    STATE(2444), 1,
      sym_field_declaration_list,
    STATE(8157), 1,
      sym_base_class_clause,
  [281150] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10262), 1,
      anon_sym_LBRACE,
    STATE(3701), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [281164] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(11887), 1,
      anon_sym_SEMI,
    STATE(1651), 1,
      sym_template_argument_list,
  [281180] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4260), 1,
      anon_sym_LT,
    ACTIONS(11655), 1,
      sym_identifier,
    STATE(782), 1,
      sym_template_parameter_list,
    STATE(2111), 1,
      sym_template_type,
  [281196] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10288), 1,
      anon_sym_LBRACE,
    STATE(1664), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [281210] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11889), 1,
      anon_sym_SEMI,
    STATE(4457), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [281224] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11891), 1,
      anon_sym_EQ,
    STATE(6354), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281238] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11159), 1,
      anon_sym_EQ,
    STATE(7266), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281252] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11893), 1,
      anon_sym_SEMI,
    STATE(7318), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [281266] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4002), 1,
      anon_sym_SEMI,
    ACTIONS(5534), 1,
      anon_sym_LT,
    STATE(1831), 1,
      sym_template_argument_list,
  [281282] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11895), 1,
      anon_sym_SEMI,
    STATE(7249), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [281296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11897), 1,
      anon_sym_SEMI,
    STATE(7085), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [281310] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10280), 1,
      anon_sym_LBRACE,
    STATE(4010), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [281324] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    ACTIONS(10490), 1,
      anon_sym_COLON,
    STATE(7629), 1,
      sym_compound_statement,
    STATE(8112), 1,
      sym_field_initializer_list,
  [281340] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10280), 1,
      anon_sym_LBRACE,
    STATE(4026), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [281354] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10228), 1,
      anon_sym_LBRACE,
    STATE(3775), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [281368] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11899), 1,
      anon_sym_EQ,
    STATE(6354), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281382] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(11550), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11901), 1,
      anon_sym_GT2,
    STATE(7535), 1,
      aux_sym_template_argument_list_repeat1,
  [281398] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11903), 1,
      anon_sym___except,
    ACTIONS(11905), 1,
      anon_sym___finally,
    STATE(387), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [281412] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(8224), 1,
      anon_sym_LBRACE,
    STATE(5036), 1,
      sym_field_declaration_list,
    STATE(8060), 1,
      sym_base_class_clause,
  [281428] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11135), 1,
      anon_sym_EQ,
    STATE(7279), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281442] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11907), 1,
      anon_sym_COMMA,
    STATE(7294), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(11910), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [281456] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10216), 1,
      anon_sym_LBRACE,
    STATE(5193), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [281470] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(8013), 1,
      anon_sym_LBRACE,
    STATE(4581), 1,
      sym_field_declaration_list,
    STATE(8115), 1,
      sym_base_class_clause,
  [281486] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10264), 1,
      anon_sym_LBRACE,
    STATE(4164), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [281500] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2989), 1,
      sym_parameter_list,
    STATE(6458), 1,
      sym__function_declarator_seq,
  [281516] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11912), 1,
      anon_sym_EQ,
    STATE(6354), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281530] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10280), 1,
      anon_sym_LBRACE,
    STATE(3952), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [281544] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11131), 1,
      anon_sym_EQ,
    STATE(7312), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281558] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11536), 1,
      anon_sym_LPAREN2,
    ACTIONS(11914), 1,
      anon_sym_LBRACE,
    STATE(6293), 1,
      sym_requirement_seq,
    STATE(8007), 1,
      sym_requires_parameter_list,
  [281574] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(11550), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11916), 1,
      anon_sym_GT2,
    STATE(7468), 1,
      aux_sym_template_argument_list_repeat1,
  [281590] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10262), 1,
      anon_sym_LBRACE,
    STATE(3668), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [281604] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11918), 1,
      anon_sym_SEMI,
    STATE(7324), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [281618] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11495), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11497), 1,
      sym_escape_sequence,
    ACTIONS(11920), 1,
      anon_sym_DQUOTE,
    STATE(7134), 1,
      aux_sym_string_literal_repeat1,
  [281634] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10256), 1,
      anon_sym_LBRACE,
    STATE(2739), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [281648] = 4,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11922), 1,
      anon_sym_SQUOTE,
    STATE(7092), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11514), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [281662] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(8224), 1,
      anon_sym_LBRACE,
    STATE(5070), 1,
      sym_field_declaration_list,
    STATE(8072), 1,
      sym_base_class_clause,
  [281678] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11924), 1,
      anon_sym_SEMI,
    STATE(4457), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [281692] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4260), 1,
      anon_sym_LT,
    ACTIONS(11655), 1,
      sym_identifier,
    STATE(781), 1,
      sym_template_parameter_list,
    STATE(2111), 1,
      sym_template_type,
  [281708] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11926), 1,
      anon_sym_EQ,
    STATE(6354), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281722] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11153), 1,
      anon_sym_EQ,
    STATE(7320), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281736] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10262), 1,
      anon_sym_LBRACE,
    STATE(3822), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [281750] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10288), 1,
      anon_sym_LBRACE,
    STATE(1670), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [281764] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11928), 1,
      anon_sym_SEMI,
    STATE(4457), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [281778] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11930), 1,
      anon_sym_SEMI,
    STATE(7338), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [281792] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11932), 1,
      anon_sym_SEMI,
    STATE(4457), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [281806] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11645), 1,
      anon_sym_COMMA,
    ACTIONS(11934), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11936), 1,
      anon_sym_LBRACE,
    STATE(7484), 1,
      aux_sym_base_class_clause_repeat1,
  [281822] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11938), 1,
      anon_sym_EQ,
    STATE(6354), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281836] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10264), 1,
      anon_sym_LBRACE,
    STATE(4134), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [281850] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11940), 1,
      anon_sym_DQUOTE,
    ACTIONS(11942), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11944), 1,
      sym_escape_sequence,
    STATE(7306), 1,
      aux_sym_string_literal_repeat1,
  [281866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11176), 1,
      anon_sym_EQ,
    STATE(7330), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281880] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11946), 1,
      anon_sym_SEMI,
    STATE(4457), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [281894] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11948), 1,
      anon_sym_EQ,
    STATE(7289), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281908] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4260), 1,
      anon_sym_LT,
    ACTIONS(11655), 1,
      sym_identifier,
    STATE(784), 1,
      sym_template_parameter_list,
    STATE(2111), 1,
      sym_template_type,
  [281924] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(11550), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11950), 1,
      anon_sym_GT2,
    STATE(7409), 1,
      aux_sym_template_argument_list_repeat1,
  [281940] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11952), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [281950] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11116), 1,
      anon_sym_EQ,
    STATE(7223), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281964] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11954), 1,
      anon_sym_EQ,
    STATE(6354), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [281978] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(11956), 1,
      anon_sym_SEMI,
    STATE(1651), 1,
      sym_template_argument_list,
  [281994] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    STATE(2211), 1,
      sym_field_declaration_list,
    STATE(7940), 1,
      sym_base_class_clause,
  [282010] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11958), 1,
      anon_sym_SEMI,
    STATE(4457), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [282024] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_LBRACE,
    STATE(6008), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [282038] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11960), 1,
      anon_sym_SEMI,
    STATE(4457), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [282052] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11962), 1,
      anon_sym_SEMI,
    STATE(7333), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [282066] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10288), 1,
      anon_sym_LBRACE,
    STATE(1672), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [282080] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11964), 1,
      anon_sym_SEMI,
    STATE(4457), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [282094] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(11550), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11966), 1,
      anon_sym_GT2,
    STATE(7624), 1,
      aux_sym_template_argument_list_repeat1,
  [282110] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_LBRACE,
    STATE(6018), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [282124] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11968), 1,
      anon_sym_COMMA,
    STATE(7341), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(11971), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [282138] = 4,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11973), 1,
      anon_sym_SQUOTE,
    STATE(7092), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11514), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [282152] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11975), 1,
      anon_sym_DQUOTE,
    ACTIONS(11977), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11979), 1,
      sym_escape_sequence,
    STATE(7361), 1,
      aux_sym_string_literal_repeat1,
  [282168] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11495), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11497), 1,
      sym_escape_sequence,
    ACTIONS(11981), 1,
      anon_sym_DQUOTE,
    STATE(7134), 1,
      aux_sym_string_literal_repeat1,
  [282184] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(11550), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11983), 1,
      anon_sym_GT2,
    STATE(7736), 1,
      aux_sym_template_argument_list_repeat1,
  [282200] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11952), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [282210] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(2889), 1,
      sym_field_declaration_list,
    STATE(8111), 1,
      sym_base_class_clause,
  [282226] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(2500), 1,
      sym_field_declaration_list,
    STATE(8030), 1,
      sym_base_class_clause,
  [282242] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(2937), 1,
      sym_field_declaration_list,
    STATE(8114), 1,
      sym_base_class_clause,
  [282258] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11556), 1,
      anon_sym_LPAREN,
    ACTIONS(11985), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11987), 1,
      sym_preproc_arg,
    STATE(8037), 1,
      sym_preproc_params,
  [282274] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9488), 1,
      anon_sym_LBRACE,
    ACTIONS(11536), 1,
      anon_sym_LPAREN2,
    STATE(3967), 1,
      sym_requirement_seq,
    STATE(7820), 1,
      sym_requires_parameter_list,
  [282290] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(6603), 1,
      anon_sym_LBRACE,
    STATE(3476), 1,
      sym_field_declaration_list,
    STATE(7943), 1,
      sym_base_class_clause,
  [282306] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11989), 1,
      anon_sym_SEMI,
    STATE(7335), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [282320] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(11550), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11991), 1,
      anon_sym_GT2,
    STATE(7444), 1,
      aux_sym_template_argument_list_repeat1,
  [282336] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3777), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(11993), 1,
      anon_sym_SEMI,
    STATE(1651), 1,
      sym_template_argument_list,
  [282352] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11995), 1,
      anon_sym___except,
    ACTIONS(11997), 1,
      anon_sym___finally,
    STATE(336), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [282366] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(6372), 1,
      anon_sym_LBRACE,
    STATE(3025), 1,
      sym_field_declaration_list,
    STATE(8135), 1,
      sym_base_class_clause,
  [282382] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(6603), 1,
      anon_sym_LBRACE,
    STATE(3370), 1,
      sym_field_declaration_list,
    STATE(8006), 1,
      sym_base_class_clause,
  [282398] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9424), 1,
      anon_sym_LBRACE,
    ACTIONS(11536), 1,
      anon_sym_LPAREN2,
    STATE(4181), 1,
      sym_requirement_seq,
    STATE(8083), 1,
      sym_requires_parameter_list,
  [282414] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6300), 1,
      anon_sym___attribute__,
    ACTIONS(11999), 1,
      anon_sym_SEMI,
    STATE(4457), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [282428] = 5,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(11495), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11497), 1,
      sym_escape_sequence,
    ACTIONS(12001), 1,
      anon_sym_DQUOTE,
    STATE(7134), 1,
      aux_sym_string_literal_repeat1,
  [282444] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12003), 1,
      anon_sym_COMMA,
    STATE(7362), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(12006), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [282458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12008), 1,
      sym_identifier,
    ACTIONS(12010), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [282470] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10216), 1,
      anon_sym_LBRACE,
    STATE(5302), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [282484] = 4,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(12012), 1,
      anon_sym_SQUOTE,
    STATE(7092), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11514), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [282498] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10260), 1,
      anon_sym_LBRACE,
    STATE(6052), 1,
      sym_compound_statement,
    ACTIONS(10248), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [282512] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11877), 1,
      anon_sym_COMMA,
    STATE(7368), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(12014), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [282526] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12016), 1,
      anon_sym_COMMA,
    STATE(7368), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(12019), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [282540] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 1,
      anon_sym_COLON,
    ACTIONS(6372), 1,
      anon_sym_LBRACE,
    STATE(3017), 1,
      sym_field_declaration_list,
    STATE(8144), 1,
      sym_base_class_clause,
  [282556] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4859), 1,
      anon_sym_LBRACE,
    ACTIONS(11560), 1,
      anon_sym_COLON_COLON,
    STATE(736), 1,
      sym_declaration_list,
  [282569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11645), 1,
      anon_sym_COMMA,
    ACTIONS(11936), 1,
      anon_sym_LBRACE,
    STATE(7499), 1,
      aux_sym_base_class_clause_repeat1,
  [282582] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12021), 1,
      anon_sym_RPAREN,
    ACTIONS(12023), 1,
      anon_sym_COLON,
    STATE(7375), 1,
      sym_gnu_asm_clobber_list,
  [282595] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12025), 1,
      anon_sym_RPAREN,
    ACTIONS(12027), 1,
      anon_sym_COLON,
    STATE(7376), 1,
      sym_gnu_asm_input_operand_list,
  [282608] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12029), 1,
      anon_sym_COMMA,
    ACTIONS(12032), 1,
      anon_sym_RPAREN,
    STATE(7374), 1,
      aux_sym_generic_expression_repeat1,
  [282621] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12034), 1,
      anon_sym_RPAREN,
    ACTIONS(12036), 1,
      anon_sym_COLON,
    STATE(9134), 1,
      sym_gnu_asm_goto_list,
  [282634] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12023), 1,
      anon_sym_COLON,
    ACTIONS(12038), 1,
      anon_sym_RPAREN,
    STATE(7379), 1,
      sym_gnu_asm_clobber_list,
  [282647] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12040), 1,
      anon_sym_SEMI,
    STATE(7474), 1,
      aux_sym_declaration_repeat1,
  [282660] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12042), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [282669] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12036), 1,
      anon_sym_COLON,
    ACTIONS(12044), 1,
      anon_sym_RPAREN,
    STATE(9131), 1,
      sym_gnu_asm_goto_list,
  [282682] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8382), 1,
      anon_sym_COMMA,
    ACTIONS(12046), 1,
      anon_sym_RPAREN,
    STATE(7374), 1,
      aux_sym_generic_expression_repeat1,
  [282695] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12048), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [282704] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8476), 1,
      anon_sym_COMMA,
    ACTIONS(12050), 1,
      anon_sym_RBRACK,
    STATE(7778), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [282717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12052), 1,
      anon_sym_catch,
    STATE(305), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [282728] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12054), 1,
      anon_sym_LPAREN2,
    ACTIONS(12056), 1,
      anon_sym_constexpr,
    STATE(610), 1,
      sym_condition_clause,
  [282741] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12058), 1,
      anon_sym_COMMA,
    ACTIONS(12060), 1,
      anon_sym_RPAREN,
    STATE(7387), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [282754] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12062), 1,
      anon_sym_default,
    ACTIONS(12064), 1,
      anon_sym_delete,
    ACTIONS(12066), 1,
      anon_sym_0,
  [282767] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12068), 1,
      anon_sym_COMMA,
    ACTIONS(12071), 1,
      anon_sym_RPAREN,
    STATE(7387), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [282780] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12073), 1,
      anon_sym_COMMA,
    ACTIONS(12075), 1,
      anon_sym_RPAREN,
    STATE(7806), 1,
      aux_sym_parameter_list_repeat1,
  [282793] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12077), 1,
      anon_sym_SEMI,
    STATE(7474), 1,
      aux_sym_declaration_repeat1,
  [282806] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12079), 1,
      anon_sym_SEMI,
    STATE(7474), 1,
      aux_sym_declaration_repeat1,
  [282819] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12081), 1,
      anon_sym_SEMI,
    STATE(7593), 1,
      aux_sym_declaration_repeat1,
  [282832] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12073), 1,
      anon_sym_COMMA,
    ACTIONS(12083), 1,
      anon_sym_RPAREN,
    STATE(7419), 1,
      aux_sym_parameter_list_repeat1,
  [282845] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8713), 1,
      anon_sym_RPAREN,
    ACTIONS(12085), 1,
      anon_sym_COMMA,
    STATE(7393), 1,
      aux_sym_argument_list_repeat1,
  [282858] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(12088), 1,
      anon_sym_RPAREN,
    STATE(7393), 1,
      aux_sym_argument_list_repeat1,
  [282871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12090), 1,
      anon_sym_catch,
    STATE(307), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [282882] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12092), 1,
      anon_sym_COMMA,
    ACTIONS(12094), 1,
      anon_sym_RPAREN,
    STATE(7745), 1,
      aux_sym_preproc_params_repeat1,
  [282895] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8444), 1,
      anon_sym_RPAREN,
    STATE(7393), 1,
      aux_sym_argument_list_repeat1,
  [282908] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    STATE(7189), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12096), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [282919] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12098), 1,
      anon_sym_COMMA,
    ACTIONS(12100), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7412), 1,
      aux_sym_attribute_declaration_repeat1,
  [282932] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9694), 1,
      anon_sym_COMMA,
    ACTIONS(12102), 1,
      anon_sym_RPAREN,
    STATE(7722), 1,
      aux_sym_preproc_argument_list_repeat1,
  [282945] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12054), 1,
      anon_sym_LPAREN2,
    ACTIONS(12104), 1,
      anon_sym_constexpr,
    STATE(640), 1,
      sym_condition_clause,
  [282958] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4228), 1,
      anon_sym_RBRACE,
    ACTIONS(12106), 1,
      anon_sym_COMMA,
    STATE(7429), 1,
      aux_sym_initializer_list_repeat1,
  [282971] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12092), 1,
      anon_sym_COMMA,
    ACTIONS(12108), 1,
      anon_sym_RPAREN,
    STATE(7396), 1,
      aux_sym_preproc_params_repeat1,
  [282984] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12110), 1,
      anon_sym_COMMA,
    ACTIONS(12112), 1,
      anon_sym_GT2,
    STATE(7762), 1,
      aux_sym_template_parameter_list_repeat1,
  [282997] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12027), 1,
      anon_sym_COLON,
    ACTIONS(12114), 1,
      anon_sym_RPAREN,
    STATE(7438), 1,
      sym_gnu_asm_input_operand_list,
  [283010] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12116), 1,
      anon_sym_RPAREN,
    ACTIONS(12118), 1,
      anon_sym_COLON,
    STATE(7440), 1,
      sym_gnu_asm_output_operand_list,
  [283023] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12120), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [283036] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12122), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
    STATE(3510), 1,
      sym_template_function,
  [283049] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12124), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [283062] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12126), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [283075] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12128), 1,
      anon_sym_GT2,
    STATE(7755), 1,
      aux_sym_template_argument_list_repeat1,
  [283088] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12098), 1,
      anon_sym_COMMA,
    ACTIONS(12130), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7694), 1,
      aux_sym_attribute_declaration_repeat1,
  [283101] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12118), 1,
      anon_sym_COLON,
    ACTIONS(12132), 1,
      anon_sym_RPAREN,
    STATE(7676), 1,
      sym_gnu_asm_output_operand_list,
  [283114] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8456), 1,
      anon_sym_RPAREN,
    STATE(7437), 1,
      aux_sym_argument_list_repeat1,
  [283127] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8392), 1,
      anon_sym_COMMA,
    ACTIONS(12134), 1,
      anon_sym_RBRACK,
    STATE(7698), 1,
      aux_sym_subscript_argument_list_repeat1,
  [283140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12136), 1,
      anon_sym_catch,
    STATE(586), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [283151] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12138), 1,
      anon_sym_SEMI,
    STATE(7474), 1,
      aux_sym_declaration_repeat1,
  [283164] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12140), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [283173] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12073), 1,
      anon_sym_COMMA,
    ACTIONS(12142), 1,
      anon_sym_RPAREN,
    STATE(7628), 1,
      aux_sym_parameter_list_repeat1,
  [283186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12144), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12146), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [283197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12148), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [283206] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12118), 1,
      anon_sym_COLON,
    ACTIONS(12150), 1,
      anon_sym_RPAREN,
    STATE(7441), 1,
      sym_gnu_asm_output_operand_list,
  [283219] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12073), 1,
      anon_sym_COMMA,
    ACTIONS(12152), 1,
      anon_sym_RPAREN,
    STATE(7490), 1,
      aux_sym_parameter_list_repeat1,
  [283232] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12154), 1,
      anon_sym_GT2,
    STATE(7445), 1,
      aux_sym_template_argument_list_repeat1,
  [283245] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12156), 1,
      anon_sym_COMMA,
    ACTIONS(12158), 1,
      anon_sym_LBRACE,
    STATE(7679), 1,
      aux_sym_field_initializer_list_repeat1,
  [283258] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8382), 1,
      anon_sym_COMMA,
    ACTIONS(12160), 1,
      anon_sym_RPAREN,
    STATE(7374), 1,
      aux_sym_generic_expression_repeat1,
  [283271] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12090), 1,
      anon_sym_catch,
    STATE(306), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [283282] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1930), 1,
      anon_sym_while,
    ACTIONS(12162), 1,
      anon_sym_else,
    STATE(327), 1,
      sym_else_clause,
  [283295] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8581), 1,
      anon_sym_RBRACE,
    ACTIONS(12164), 1,
      anon_sym_COMMA,
    STATE(7429), 1,
      aux_sym_initializer_list_repeat1,
  [283308] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12058), 1,
      anon_sym_COMMA,
    ACTIONS(12167), 1,
      anon_sym_RPAREN,
    STATE(7385), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [283321] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(12169), 1,
      anon_sym_RPAREN,
    STATE(7393), 1,
      aux_sym_argument_list_repeat1,
  [283334] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12023), 1,
      anon_sym_COLON,
    ACTIONS(12171), 1,
      anon_sym_RPAREN,
    STATE(7461), 1,
      sym_gnu_asm_clobber_list,
  [283347] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12027), 1,
      anon_sym_COLON,
    ACTIONS(12173), 1,
      anon_sym_RPAREN,
    STATE(7462), 1,
      sym_gnu_asm_input_operand_list,
  [283360] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(12175), 1,
      anon_sym_RPAREN,
    STATE(7393), 1,
      aux_sym_argument_list_repeat1,
  [283373] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12177), 1,
      anon_sym_SEMI,
    STATE(7474), 1,
      aux_sym_declaration_repeat1,
  [283386] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12179), 1,
      anon_sym_SEMI,
    STATE(7474), 1,
      aux_sym_declaration_repeat1,
  [283399] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8482), 1,
      anon_sym_RPAREN,
    STATE(7393), 1,
      aux_sym_argument_list_repeat1,
  [283412] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12023), 1,
      anon_sym_COLON,
    ACTIONS(12181), 1,
      anon_sym_RPAREN,
    STATE(7446), 1,
      sym_gnu_asm_clobber_list,
  [283425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12183), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [283434] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12027), 1,
      anon_sym_COLON,
    ACTIONS(12185), 1,
      anon_sym_RPAREN,
    STATE(7453), 1,
      sym_gnu_asm_input_operand_list,
  [283447] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12027), 1,
      anon_sym_COLON,
    ACTIONS(12187), 1,
      anon_sym_RPAREN,
    STATE(7451), 1,
      sym_gnu_asm_input_operand_list,
  [283460] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12118), 1,
      anon_sym_COLON,
    ACTIONS(12189), 1,
      anon_sym_RPAREN,
    STATE(7452), 1,
      sym_gnu_asm_output_operand_list,
  [283473] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12191), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [283486] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12193), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [283499] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12195), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [283512] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12036), 1,
      anon_sym_COLON,
    ACTIONS(12197), 1,
      anon_sym_RPAREN,
    STATE(8234), 1,
      sym_gnu_asm_goto_list,
  [283525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12199), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [283534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12201), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12203), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [283545] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12205), 1,
      anon_sym_SEMI,
    STATE(7474), 1,
      aux_sym_declaration_repeat1,
  [283558] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(12207), 1,
      anon_sym_RPAREN,
    STATE(7393), 1,
      aux_sym_argument_list_repeat1,
  [283571] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12023), 1,
      anon_sym_COLON,
    ACTIONS(12209), 1,
      anon_sym_RPAREN,
    STATE(7454), 1,
      sym_gnu_asm_clobber_list,
  [283584] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12027), 1,
      anon_sym_COLON,
    ACTIONS(12211), 1,
      anon_sym_RPAREN,
    STATE(7455), 1,
      sym_gnu_asm_input_operand_list,
  [283597] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12023), 1,
      anon_sym_COLON,
    ACTIONS(12213), 1,
      anon_sym_RPAREN,
    STATE(7459), 1,
      sym_gnu_asm_clobber_list,
  [283610] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12036), 1,
      anon_sym_COLON,
    ACTIONS(12215), 1,
      anon_sym_RPAREN,
    STATE(8910), 1,
      sym_gnu_asm_goto_list,
  [283623] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12023), 1,
      anon_sym_COLON,
    ACTIONS(12217), 1,
      anon_sym_RPAREN,
    STATE(7458), 1,
      sym_gnu_asm_clobber_list,
  [283636] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12219), 1,
      anon_sym_SEMI,
    STATE(7417), 1,
      aux_sym_declaration_repeat1,
  [283649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12221), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12223), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [283660] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12036), 1,
      anon_sym_COLON,
    ACTIONS(12225), 1,
      anon_sym_RPAREN,
    STATE(9008), 1,
      sym_gnu_asm_goto_list,
  [283673] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12036), 1,
      anon_sym_COLON,
    ACTIONS(12227), 1,
      anon_sym_RPAREN,
    STATE(8240), 1,
      sym_gnu_asm_goto_list,
  [283686] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8382), 1,
      anon_sym_COMMA,
    ACTIONS(12229), 1,
      anon_sym_RPAREN,
    STATE(7374), 1,
      aux_sym_generic_expression_repeat1,
  [283699] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12036), 1,
      anon_sym_COLON,
    ACTIONS(12231), 1,
      anon_sym_RPAREN,
    STATE(8938), 1,
      sym_gnu_asm_goto_list,
  [283712] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12023), 1,
      anon_sym_COLON,
    ACTIONS(12233), 1,
      anon_sym_RPAREN,
    STATE(7483), 1,
      sym_gnu_asm_clobber_list,
  [283725] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12054), 1,
      anon_sym_LPAREN2,
    ACTIONS(12235), 1,
      anon_sym_constexpr,
    STATE(661), 1,
      sym_condition_clause,
  [283738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12237), 1,
      anon_sym_EQ,
    ACTIONS(11137), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [283749] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8534), 1,
      anon_sym_COMMA,
    ACTIONS(12239), 1,
      aux_sym_kernel_call_syntax_token2,
    STATE(7585), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [283762] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12241), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [283775] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12243), 1,
      anon_sym_GT2,
    STATE(7410), 1,
      aux_sym_template_argument_list_repeat1,
  [283788] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12245), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [283801] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12247), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [283814] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12118), 1,
      anon_sym_COLON,
    ACTIONS(12249), 1,
      anon_sym_RPAREN,
    STATE(7373), 1,
      sym_gnu_asm_output_operand_list,
  [283827] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12027), 1,
      anon_sym_COLON,
    ACTIONS(12251), 1,
      anon_sym_RPAREN,
    STATE(7372), 1,
      sym_gnu_asm_input_operand_list,
  [283840] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(12253), 1,
      anon_sym_RPAREN,
    STATE(7393), 1,
      aux_sym_argument_list_repeat1,
  [283853] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12118), 1,
      anon_sym_COLON,
    ACTIONS(12255), 1,
      anon_sym_RPAREN,
    STATE(7405), 1,
      sym_gnu_asm_output_operand_list,
  [283866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12257), 1,
      anon_sym_COMMA,
    ACTIONS(12260), 1,
      anon_sym_SEMI,
    STATE(7474), 1,
      aux_sym_declaration_repeat1,
  [283879] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12262), 1,
      anon_sym_SEMI,
    STATE(7474), 1,
      aux_sym_declaration_repeat1,
  [283892] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8436), 1,
      anon_sym_COMMA,
    ACTIONS(8438), 1,
      anon_sym_RBRACE,
    STATE(7402), 1,
      aux_sym_initializer_list_repeat1,
  [283905] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8440), 1,
      anon_sym_RPAREN,
    STATE(7397), 1,
      aux_sym_argument_list_repeat1,
  [283918] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4214), 1,
      anon_sym_RBRACE,
    ACTIONS(12264), 1,
      anon_sym_COMMA,
    STATE(7429), 1,
      aux_sym_initializer_list_repeat1,
  [283931] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8340), 1,
      anon_sym_RBRACE,
    ACTIONS(8608), 1,
      anon_sym_COMMA,
    STATE(7724), 1,
      aux_sym_initializer_list_repeat1,
  [283944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8464), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [283953] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12098), 1,
      anon_sym_COMMA,
    ACTIONS(12266), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7694), 1,
      aux_sym_attribute_declaration_repeat1,
  [283966] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11645), 1,
      anon_sym_COMMA,
    ACTIONS(11833), 1,
      anon_sym_LBRACE,
    STATE(7741), 1,
      aux_sym_base_class_clause_repeat1,
  [283979] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12036), 1,
      anon_sym_COLON,
    ACTIONS(12268), 1,
      anon_sym_RPAREN,
    STATE(8927), 1,
      sym_gnu_asm_goto_list,
  [283992] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11645), 1,
      anon_sym_COMMA,
    ACTIONS(11833), 1,
      anon_sym_LBRACE,
    STATE(7499), 1,
      aux_sym_base_class_clause_repeat1,
  [284005] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12270), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
    STATE(2972), 1,
      sym_template_function,
  [284018] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8446), 1,
      anon_sym_RPAREN,
    STATE(7393), 1,
      aux_sym_argument_list_repeat1,
  [284031] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8500), 1,
      anon_sym_COMMA,
    ACTIONS(8502), 1,
      anon_sym_RBRACE,
    STATE(7611), 1,
      aux_sym_initializer_list_repeat1,
  [284044] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8382), 1,
      anon_sym_COMMA,
    ACTIONS(12272), 1,
      anon_sym_RPAREN,
    STATE(7374), 1,
      aux_sym_generic_expression_repeat1,
  [284057] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12274), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
    STATE(2972), 1,
      sym_template_function,
  [284070] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12073), 1,
      anon_sym_COMMA,
    ACTIONS(12276), 1,
      anon_sym_RPAREN,
    STATE(7628), 1,
      aux_sym_parameter_list_repeat1,
  [284083] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12278), 1,
      anon_sym_SEMI,
    STATE(7474), 1,
      aux_sym_declaration_repeat1,
  [284096] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12280), 1,
      anon_sym_SEMI,
    STATE(7474), 1,
      aux_sym_declaration_repeat1,
  [284109] = 4,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(12282), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12284), 1,
      anon_sym_LPAREN2,
    STATE(8923), 1,
      sym_preproc_argument_list,
  [284122] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12286), 1,
      anon_sym_SEMI,
    STATE(7435), 1,
      aux_sym_declaration_repeat1,
  [284135] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12288), 1,
      anon_sym_SEMI,
    STATE(7475), 1,
      aux_sym_declaration_repeat1,
  [284148] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9694), 1,
      anon_sym_COMMA,
    ACTIONS(12290), 1,
      anon_sym_RPAREN,
    STATE(7722), 1,
      aux_sym_preproc_argument_list_repeat1,
  [284161] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    STATE(7217), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12292), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [284172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12294), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12296), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [284183] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12296), 1,
      anon_sym_LBRACE,
    ACTIONS(12298), 1,
      anon_sym_COMMA,
    STATE(7499), 1,
      aux_sym_base_class_clause_repeat1,
  [284196] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12301), 1,
      anon_sym_GT2,
    STATE(7466), 1,
      aux_sym_template_argument_list_repeat1,
  [284209] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12303), 1,
      anon_sym_COMMA,
    ACTIONS(12305), 1,
      anon_sym_RPAREN,
    STATE(7610), 1,
      aux_sym_requires_parameter_list_repeat1,
  [284222] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8392), 1,
      anon_sym_COMMA,
    ACTIONS(12307), 1,
      anon_sym_RBRACK,
    STATE(7698), 1,
      aux_sym_subscript_argument_list_repeat1,
  [284235] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12118), 1,
      anon_sym_COLON,
    ACTIONS(12309), 1,
      anon_sym_RPAREN,
    STATE(7471), 1,
      sym_gnu_asm_output_operand_list,
  [284248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12311), 1,
      anon_sym_catch,
    STATE(135), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [284259] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12313), 1,
      sym_identifier,
    STATE(1860), 1,
      sym_template_type,
    STATE(3741), 1,
      sym_template_function,
  [284272] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12315), 1,
      anon_sym_SEMI,
    STATE(7377), 1,
      aux_sym_declaration_repeat1,
  [284285] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12073), 1,
      anon_sym_COMMA,
    ACTIONS(12317), 1,
      anon_sym_RPAREN,
    STATE(7628), 1,
      aux_sym_parameter_list_repeat1,
  [284298] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12319), 1,
      anon_sym_SEMI,
    STATE(7474), 1,
      aux_sym_declaration_repeat1,
  [284311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8579), 3,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
  [284320] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12321), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [284329] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8382), 1,
      anon_sym_COMMA,
    ACTIONS(12323), 1,
      anon_sym_RPAREN,
    STATE(7374), 1,
      aux_sym_generic_expression_repeat1,
  [284342] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11645), 1,
      anon_sym_COMMA,
    ACTIONS(12325), 1,
      anon_sym_LBRACE,
    STATE(7499), 1,
      aux_sym_base_class_clause_repeat1,
  [284355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12329), 1,
      anon_sym_RPAREN,
    ACTIONS(12327), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [284366] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4857), 1,
      anon_sym_LBRACE,
    ACTIONS(11560), 1,
      anon_sym_COLON_COLON,
    STATE(515), 1,
      sym_declaration_list,
  [284379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12333), 1,
      anon_sym_RPAREN,
    ACTIONS(12331), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [284390] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12098), 1,
      anon_sym_COMMA,
    ACTIONS(12335), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7547), 1,
      aux_sym_attribute_declaration_repeat1,
  [284403] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12054), 1,
      anon_sym_LPAREN2,
    ACTIONS(12337), 1,
      anon_sym_constexpr,
    STATE(652), 1,
      sym_condition_clause,
  [284416] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12036), 1,
      anon_sym_COLON,
    ACTIONS(12339), 1,
      anon_sym_RPAREN,
    STATE(8292), 1,
      sym_gnu_asm_goto_list,
  [284429] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    STATE(7198), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12341), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [284440] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8490), 1,
      anon_sym_COMMA,
    ACTIONS(8492), 1,
      anon_sym_RBRACE,
    STATE(7478), 1,
      aux_sym_initializer_list_repeat1,
  [284453] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12343), 1,
      anon_sym_GT2,
    STATE(7536), 1,
      aux_sym_template_argument_list_repeat1,
  [284466] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12345), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [284479] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8504), 1,
      anon_sym_RPAREN,
    STATE(7595), 1,
      aux_sym_argument_list_repeat1,
  [284492] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12347), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [284505] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12349), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [284518] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12351), 1,
      anon_sym_COMMA,
    ACTIONS(12354), 1,
      anon_sym_RPAREN,
    STATE(7526), 1,
      aux_sym_throw_specifier_repeat1,
  [284531] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12098), 1,
      anon_sym_COMMA,
    ACTIONS(12356), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7692), 1,
      aux_sym_attribute_declaration_repeat1,
  [284544] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12118), 1,
      anon_sym_COLON,
    ACTIONS(12358), 1,
      anon_sym_RPAREN,
    STATE(7433), 1,
      sym_gnu_asm_output_operand_list,
  [284557] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5534), 1,
      anon_sym_LT,
    ACTIONS(6200), 1,
      anon_sym_SEMI,
    STATE(1831), 1,
      sym_template_argument_list,
  [284570] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8468), 1,
      anon_sym_RPAREN,
    STATE(7486), 1,
      aux_sym_argument_list_repeat1,
  [284583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12362), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12360), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [284594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12364), 1,
      anon_sym_catch,
    STATE(1829), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [284605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12366), 1,
      anon_sym_catch,
    STATE(807), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [284616] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12368), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [284629] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12370), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [284642] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12372), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [284655] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12036), 1,
      anon_sym_COLON,
    ACTIONS(12374), 1,
      anon_sym_RPAREN,
    STATE(9047), 1,
      sym_gnu_asm_goto_list,
  [284668] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8476), 1,
      anon_sym_COMMA,
    ACTIONS(12376), 1,
      anon_sym_RBRACK,
    STATE(7778), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [284681] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12110), 1,
      anon_sym_COMMA,
    ACTIONS(12378), 1,
      anon_sym_GT2,
    STATE(7606), 1,
      aux_sym_template_parameter_list_repeat1,
  [284694] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12098), 1,
      anon_sym_COMMA,
    ACTIONS(12380), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7694), 1,
      aux_sym_attribute_declaration_repeat1,
  [284707] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12303), 1,
      anon_sym_COMMA,
    ACTIONS(12382), 1,
      anon_sym_RPAREN,
    STATE(7501), 1,
      aux_sym_requires_parameter_list_repeat1,
  [284720] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12384), 1,
      anon_sym_SEMI,
    STATE(7594), 1,
      aux_sym_declaration_repeat1,
  [284733] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12098), 1,
      anon_sym_COMMA,
    ACTIONS(12386), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7694), 1,
      aux_sym_attribute_declaration_repeat1,
  [284746] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12388), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
    STATE(2972), 1,
      sym_template_function,
  [284759] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12390), 1,
      anon_sym_default,
    ACTIONS(12392), 1,
      anon_sym_delete,
    ACTIONS(12394), 1,
      anon_sym_0,
  [284772] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12098), 1,
      anon_sym_COMMA,
    ACTIONS(12396), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7772), 1,
      aux_sym_attribute_declaration_repeat1,
  [284785] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12098), 1,
      anon_sym_COMMA,
    ACTIONS(12398), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7694), 1,
      aux_sym_attribute_declaration_repeat1,
  [284798] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4242), 1,
      anon_sym_RBRACE,
    ACTIONS(12400), 1,
      anon_sym_COMMA,
    STATE(7429), 1,
      aux_sym_initializer_list_repeat1,
  [284811] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12402), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
    STATE(3741), 1,
      sym_template_function,
  [284824] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8602), 1,
      anon_sym_RPAREN,
    STATE(7608), 1,
      aux_sym_argument_list_repeat1,
  [284837] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12023), 1,
      anon_sym_COLON,
    ACTIONS(12404), 1,
      anon_sym_RPAREN,
    STATE(7518), 1,
      sym_gnu_asm_clobber_list,
  [284850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12321), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [284859] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12098), 1,
      anon_sym_COMMA,
    ACTIONS(12406), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7481), 1,
      aux_sym_attribute_declaration_repeat1,
  [284872] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12408), 1,
      anon_sym_SEMI,
    STATE(7491), 1,
      aux_sym_declaration_repeat1,
  [284885] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12036), 1,
      anon_sym_COLON,
    ACTIONS(12410), 1,
      anon_sym_RPAREN,
    STATE(8309), 1,
      sym_gnu_asm_goto_list,
  [284898] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8592), 1,
      anon_sym_COMMA,
    ACTIONS(8594), 1,
      anon_sym_RBRACE,
    STATE(7609), 1,
      aux_sym_initializer_list_repeat1,
  [284911] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12023), 1,
      anon_sym_COLON,
    ACTIONS(12412), 1,
      anon_sym_RPAREN,
    STATE(7715), 1,
      sym_gnu_asm_clobber_list,
  [284924] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12414), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [284933] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4863), 1,
      anon_sym_LBRACE,
    ACTIONS(11560), 1,
      anon_sym_COLON_COLON,
    STATE(258), 1,
      sym_declaration_list,
  [284946] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8508), 1,
      anon_sym_RPAREN,
    STATE(7393), 1,
      aux_sym_argument_list_repeat1,
  [284959] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12416), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [284972] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12418), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [284985] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11645), 1,
      anon_sym_COMMA,
    ACTIONS(12420), 1,
      anon_sym_LBRACE,
    STATE(7512), 1,
      aux_sym_base_class_clause_repeat1,
  [284998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12422), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12424), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [285009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12426), 1,
      anon_sym_catch,
    STATE(1825), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [285020] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12428), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [285033] = 4,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(12284), 1,
      anon_sym_LPAREN2,
    ACTIONS(12430), 1,
      aux_sym_preproc_include_token2,
    STATE(8923), 1,
      sym_preproc_argument_list,
  [285046] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12118), 1,
      anon_sym_COLON,
    ACTIONS(12432), 1,
      anon_sym_RPAREN,
    STATE(7569), 1,
      sym_gnu_asm_output_operand_list,
  [285059] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12027), 1,
      anon_sym_COLON,
    ACTIONS(12434), 1,
      anon_sym_RPAREN,
    STATE(7656), 1,
      sym_gnu_asm_input_operand_list,
  [285072] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11645), 1,
      anon_sym_COMMA,
    ACTIONS(12420), 1,
      anon_sym_LBRACE,
    STATE(7499), 1,
      aux_sym_base_class_clause_repeat1,
  [285085] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12027), 1,
      anon_sym_COLON,
    ACTIONS(12436), 1,
      anon_sym_RPAREN,
    STATE(7557), 1,
      sym_gnu_asm_input_operand_list,
  [285098] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12438), 1,
      anon_sym_SEMI,
    STATE(7474), 1,
      aux_sym_declaration_repeat1,
  [285111] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12098), 1,
      anon_sym_COMMA,
    ACTIONS(12440), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7543), 1,
      aux_sym_attribute_declaration_repeat1,
  [285124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11550), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12442), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [285135] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12027), 1,
      anon_sym_COLON,
    ACTIONS(12444), 1,
      anon_sym_RPAREN,
    STATE(7432), 1,
      sym_gnu_asm_input_operand_list,
  [285148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12446), 1,
      sym_identifier,
    ACTIONS(12448), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [285159] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12450), 1,
      sym_identifier,
    STATE(1860), 1,
      sym_template_type,
    STATE(2718), 1,
      sym_template_function,
  [285172] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12452), 1,
      anon_sym_COMMA,
    ACTIONS(12455), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [285185] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12098), 1,
      anon_sym_COMMA,
    ACTIONS(12457), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7667), 1,
      aux_sym_attribute_declaration_repeat1,
  [285198] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12459), 1,
      sym_identifier,
    STATE(1860), 1,
      sym_template_type,
    STATE(3510), 1,
      sym_template_function,
  [285211] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12118), 1,
      anon_sym_COLON,
    ACTIONS(12461), 1,
      anon_sym_RPAREN,
    STATE(7618), 1,
      sym_gnu_asm_output_operand_list,
  [285224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12463), 3,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
  [285233] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12465), 1,
      anon_sym_GT2,
    STATE(7627), 1,
      aux_sym_template_argument_list_repeat1,
  [285246] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11645), 1,
      anon_sym_COMMA,
    ACTIONS(11936), 1,
      anon_sym_LBRACE,
    STATE(7484), 1,
      aux_sym_base_class_clause_repeat1,
  [285259] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8755), 1,
      aux_sym_kernel_call_syntax_token2,
    ACTIONS(12467), 1,
      anon_sym_COMMA,
    STATE(7585), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [285272] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    STATE(7230), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12470), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [285283] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8572), 1,
      anon_sym_RPAREN,
    STATE(7713), 1,
      aux_sym_argument_list_repeat1,
  [285296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12472), 1,
      anon_sym_SEMI,
    STATE(7637), 1,
      aux_sym_declaration_repeat1,
  [285309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12474), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [285318] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12476), 1,
      anon_sym_SEMI,
    STATE(7474), 1,
      aux_sym_declaration_repeat1,
  [285331] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12478), 1,
      anon_sym_GT2,
    STATE(7604), 1,
      aux_sym_template_argument_list_repeat1,
  [285344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12480), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [285353] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12482), 1,
      anon_sym_SEMI,
    STATE(7474), 1,
      aux_sym_declaration_repeat1,
  [285366] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12484), 1,
      anon_sym_SEMI,
    STATE(7474), 1,
      aux_sym_declaration_repeat1,
  [285379] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8510), 1,
      anon_sym_RPAREN,
    STATE(7393), 1,
      aux_sym_argument_list_repeat1,
  [285392] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12486), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [285401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12488), 1,
      anon_sym_catch,
    STATE(1691), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [285412] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4857), 1,
      anon_sym_LBRACE,
    ACTIONS(11560), 1,
      anon_sym_COLON_COLON,
    STATE(603), 1,
      sym_declaration_list,
  [285425] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12490), 1,
      anon_sym_default,
    ACTIONS(12492), 1,
      anon_sym_delete,
    ACTIONS(12494), 1,
      anon_sym_0,
  [285438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12496), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [285447] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5825), 1,
      anon_sym_COMMA,
    ACTIONS(12498), 1,
      anon_sym_RBRACK,
    STATE(7757), 1,
      aux_sym_structured_binding_declarator_repeat1,
  [285460] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12500), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [285473] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12502), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [285486] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12504), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [285499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12362), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12506), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [285510] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12508), 1,
      anon_sym_COMMA,
    ACTIONS(12511), 1,
      anon_sym_GT2,
    STATE(7606), 1,
      aux_sym_template_parameter_list_repeat1,
  [285523] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11560), 3,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
  [285532] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8522), 1,
      anon_sym_RPAREN,
    STATE(7393), 1,
      aux_sym_argument_list_repeat1,
  [285545] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4220), 1,
      anon_sym_RBRACE,
    ACTIONS(12513), 1,
      anon_sym_COMMA,
    STATE(7429), 1,
      aux_sym_initializer_list_repeat1,
  [285558] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12515), 1,
      anon_sym_COMMA,
    ACTIONS(12518), 1,
      anon_sym_RPAREN,
    STATE(7610), 1,
      aux_sym_requires_parameter_list_repeat1,
  [285571] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4224), 1,
      anon_sym_RBRACE,
    ACTIONS(12520), 1,
      anon_sym_COMMA,
    STATE(7429), 1,
      aux_sym_initializer_list_repeat1,
  [285584] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12522), 1,
      anon_sym_SEMI,
    STATE(7662), 1,
      aux_sym_declaration_repeat1,
  [285597] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8392), 1,
      anon_sym_COMMA,
    ACTIONS(8604), 1,
      anon_sym_RBRACK,
    STATE(7415), 1,
      aux_sym_subscript_argument_list_repeat1,
  [285610] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12156), 1,
      anon_sym_COMMA,
    ACTIONS(12524), 1,
      anon_sym_LBRACE,
    STATE(7425), 1,
      aux_sym_field_initializer_list_repeat1,
  [285623] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12526), 1,
      anon_sym_default,
    ACTIONS(12528), 1,
      anon_sym_delete,
    ACTIONS(12530), 1,
      anon_sym_0,
  [285636] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8382), 1,
      anon_sym_COMMA,
    ACTIONS(12532), 1,
      anon_sym_RPAREN,
    STATE(7374), 1,
      aux_sym_generic_expression_repeat1,
  [285649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12090), 1,
      anon_sym_catch,
    STATE(244), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [285660] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12027), 1,
      anon_sym_COLON,
    ACTIONS(12534), 1,
      anon_sym_RPAREN,
    STATE(7657), 1,
      sym_gnu_asm_input_operand_list,
  [285673] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8392), 1,
      anon_sym_COMMA,
    ACTIONS(8618), 1,
      anon_sym_RBRACK,
    STATE(7502), 1,
      aux_sym_subscript_argument_list_repeat1,
  [285686] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12118), 1,
      anon_sym_COLON,
    ACTIONS(12536), 1,
      anon_sym_RPAREN,
    STATE(7661), 1,
      sym_gnu_asm_output_operand_list,
  [285699] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12538), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [285708] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8392), 1,
      anon_sym_COMMA,
    ACTIONS(8420), 1,
      anon_sym_RBRACK,
    STATE(7798), 1,
      aux_sym_subscript_argument_list_repeat1,
  [285721] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12540), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [285734] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12542), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [285747] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1936), 1,
      anon_sym_while,
    ACTIONS(12162), 1,
      anon_sym_else,
    STATE(369), 1,
      sym_else_clause,
  [285760] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12110), 1,
      anon_sym_COMMA,
    ACTIONS(12544), 1,
      anon_sym_GT2,
    STATE(7539), 1,
      aux_sym_template_parameter_list_repeat1,
  [285773] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12546), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [285786] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12548), 1,
      anon_sym_COMMA,
    ACTIONS(12551), 1,
      anon_sym_RPAREN,
    STATE(7628), 1,
      aux_sym_parameter_list_repeat1,
  [285799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12311), 1,
      anon_sym_catch,
    STATE(136), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [285810] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8382), 1,
      anon_sym_COMMA,
    ACTIONS(12553), 1,
      anon_sym_RPAREN,
    STATE(7374), 1,
      aux_sym_generic_expression_repeat1,
  [285823] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12036), 1,
      anon_sym_COLON,
    ACTIONS(12555), 1,
      anon_sym_RPAREN,
    STATE(8730), 1,
      sym_gnu_asm_goto_list,
  [285836] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    STATE(7365), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12557), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [285847] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12559), 1,
      anon_sym_SEMI,
    STATE(7735), 1,
      aux_sym_declaration_repeat1,
  [285860] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12036), 1,
      anon_sym_COLON,
    ACTIONS(12561), 1,
      anon_sym_RPAREN,
    STATE(8428), 1,
      sym_gnu_asm_goto_list,
  [285873] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12563), 1,
      anon_sym_SEMI,
    STATE(7389), 1,
      aux_sym_declaration_repeat1,
  [285886] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12565), 1,
      anon_sym_COMMA,
    ACTIONS(12567), 1,
      anon_sym_RPAREN,
    STATE(7649), 1,
      aux_sym_throw_specifier_repeat1,
  [285899] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12569), 1,
      anon_sym_SEMI,
    STATE(7474), 1,
      aux_sym_declaration_repeat1,
  [285912] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12571), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
    STATE(2972), 1,
      sym_template_function,
  [285925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12488), 1,
      anon_sym_catch,
    STATE(1690), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [285936] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12073), 1,
      anon_sym_COMMA,
    ACTIONS(12573), 1,
      anon_sym_RPAREN,
    STATE(7507), 1,
      aux_sym_parameter_list_repeat1,
  [285949] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12023), 1,
      anon_sym_COLON,
    ACTIONS(12575), 1,
      anon_sym_RPAREN,
    STATE(7634), 1,
      sym_gnu_asm_clobber_list,
  [285962] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12577), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
    STATE(2972), 1,
      sym_template_function,
  [285975] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12023), 1,
      anon_sym_COLON,
    ACTIONS(12579), 1,
      anon_sym_RPAREN,
    STATE(7631), 1,
      sym_gnu_asm_clobber_list,
  [285988] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12581), 1,
      anon_sym_SEMI,
    STATE(7449), 1,
      aux_sym_declaration_repeat1,
  [286001] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12036), 1,
      anon_sym_COLON,
    ACTIONS(12583), 1,
      anon_sym_RPAREN,
    STATE(8626), 1,
      sym_gnu_asm_goto_list,
  [286014] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12036), 1,
      anon_sym_COLON,
    ACTIONS(12585), 1,
      anon_sym_RPAREN,
    STATE(8439), 1,
      sym_gnu_asm_goto_list,
  [286027] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12587), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
    STATE(2972), 1,
      sym_template_function,
  [286040] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(12589), 1,
      anon_sym_RPAREN,
    STATE(7393), 1,
      aux_sym_argument_list_repeat1,
  [286053] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12565), 1,
      anon_sym_COMMA,
    ACTIONS(12591), 1,
      anon_sym_RPAREN,
    STATE(7526), 1,
      aux_sym_throw_specifier_repeat1,
  [286066] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12593), 1,
      anon_sym_GT2,
    STATE(7660), 1,
      aux_sym_template_argument_list_repeat1,
  [286079] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11695), 1,
      anon_sym_DASH_GT,
    ACTIONS(12595), 1,
      anon_sym_SEMI,
    STATE(8863), 1,
      sym_trailing_return_type,
  [286092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6380), 1,
      anon_sym_EQ,
    ACTIONS(6378), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [286103] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12027), 1,
      anon_sym_COLON,
    ACTIONS(12597), 1,
      anon_sym_RPAREN,
    STATE(7643), 1,
      sym_gnu_asm_input_operand_list,
  [286116] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12023), 1,
      anon_sym_COLON,
    ACTIONS(12599), 1,
      anon_sym_RPAREN,
    STATE(7645), 1,
      sym_gnu_asm_clobber_list,
  [286129] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12027), 1,
      anon_sym_COLON,
    ACTIONS(12601), 1,
      anon_sym_RPAREN,
    STATE(7551), 1,
      sym_gnu_asm_input_operand_list,
  [286142] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12023), 1,
      anon_sym_COLON,
    ACTIONS(12603), 1,
      anon_sym_RPAREN,
    STATE(7537), 1,
      sym_gnu_asm_clobber_list,
  [286155] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12023), 1,
      anon_sym_COLON,
    ACTIONS(12605), 1,
      anon_sym_RPAREN,
    STATE(7666), 1,
      sym_gnu_asm_clobber_list,
  [286168] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12607), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [286181] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12609), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [286194] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12611), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [286207] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12027), 1,
      anon_sym_COLON,
    ACTIONS(12613), 1,
      anon_sym_RPAREN,
    STATE(7670), 1,
      sym_gnu_asm_input_operand_list,
  [286220] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12615), 1,
      anon_sym_SEMI,
    STATE(7474), 1,
      aux_sym_declaration_repeat1,
  [286233] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12617), 1,
      anon_sym_SEMI,
    STATE(7474), 1,
      aux_sym_declaration_repeat1,
  [286246] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12619), 1,
      anon_sym_default,
    ACTIONS(12621), 1,
      anon_sym_delete,
    ACTIONS(12623), 1,
      anon_sym_0,
  [286259] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12625), 1,
      anon_sym_SEMI,
    STATE(7508), 1,
      aux_sym_declaration_repeat1,
  [286272] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12036), 1,
      anon_sym_COLON,
    ACTIONS(12627), 1,
      anon_sym_RPAREN,
    STATE(8457), 1,
      sym_gnu_asm_goto_list,
  [286285] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12098), 1,
      anon_sym_COMMA,
    ACTIONS(12629), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7694), 1,
      aux_sym_attribute_declaration_repeat1,
  [286298] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(12631), 1,
      anon_sym_RPAREN,
    STATE(7393), 1,
      aux_sym_argument_list_repeat1,
  [286311] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12633), 1,
      anon_sym_GT2,
    STATE(7522), 1,
      aux_sym_template_argument_list_repeat1,
  [286324] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12023), 1,
      anon_sym_COLON,
    ACTIONS(12635), 1,
      anon_sym_RPAREN,
    STATE(7680), 1,
      sym_gnu_asm_clobber_list,
  [286337] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12027), 1,
      anon_sym_COLON,
    ACTIONS(12637), 1,
      anon_sym_RPAREN,
    STATE(7641), 1,
      sym_gnu_asm_input_operand_list,
  [286350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12426), 1,
      anon_sym_catch,
    STATE(1818), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [286361] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12639), 1,
      anon_sym_SEMI,
    STATE(7474), 1,
      aux_sym_declaration_repeat1,
  [286374] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8430), 1,
      anon_sym_RPAREN,
    STATE(7779), 1,
      aux_sym_argument_list_repeat1,
  [286387] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4861), 1,
      anon_sym_LBRACE,
    ACTIONS(11560), 1,
      anon_sym_COLON_COLON,
    STATE(465), 1,
      sym_declaration_list,
  [286400] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12027), 1,
      anon_sym_COLON,
    ACTIONS(12641), 1,
      anon_sym_RPAREN,
    STATE(7677), 1,
      sym_gnu_asm_input_operand_list,
  [286413] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12023), 1,
      anon_sym_COLON,
    ACTIONS(12643), 1,
      anon_sym_RPAREN,
    STATE(7555), 1,
      sym_gnu_asm_clobber_list,
  [286426] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12645), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
    STATE(2718), 1,
      sym_template_function,
  [286439] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12647), 1,
      anon_sym_COMMA,
    ACTIONS(12650), 1,
      anon_sym_LBRACE,
    STATE(7679), 1,
      aux_sym_field_initializer_list_repeat1,
  [286452] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12036), 1,
      anon_sym_COLON,
    ACTIONS(12652), 1,
      anon_sym_RPAREN,
    STATE(8459), 1,
      sym_gnu_asm_goto_list,
  [286465] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12118), 1,
      anon_sym_COLON,
    ACTIONS(12654), 1,
      anon_sym_RPAREN,
    STATE(7575), 1,
      sym_gnu_asm_output_operand_list,
  [286478] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12656), 1,
      anon_sym_GT2,
    STATE(7685), 1,
      aux_sym_template_argument_list_repeat1,
  [286491] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12658), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [286504] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12660), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [286517] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12662), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [286530] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8432), 1,
      anon_sym_COMMA,
    ACTIONS(8434), 1,
      anon_sym_RBRACE,
    STATE(7812), 1,
      aux_sym_initializer_list_repeat1,
  [286543] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8382), 1,
      anon_sym_COMMA,
    ACTIONS(12664), 1,
      anon_sym_RPAREN,
    STATE(7374), 1,
      aux_sym_generic_expression_repeat1,
  [286556] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12666), 1,
      anon_sym_default,
    ACTIONS(12668), 1,
      anon_sym_delete,
    ACTIONS(12670), 1,
      anon_sym_0,
  [286569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12672), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [286582] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12023), 1,
      anon_sym_COLON,
    ACTIONS(12674), 1,
      anon_sym_RPAREN,
    STATE(7646), 1,
      sym_gnu_asm_clobber_list,
  [286595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12052), 1,
      anon_sym_catch,
    STATE(257), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [286606] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12098), 1,
      anon_sym_COMMA,
    ACTIONS(12676), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7694), 1,
      aux_sym_attribute_declaration_repeat1,
  [286619] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12678), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [286632] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12680), 1,
      anon_sym_COMMA,
    ACTIONS(12683), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7694), 1,
      aux_sym_attribute_declaration_repeat1,
  [286645] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12685), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [286658] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12118), 1,
      anon_sym_COLON,
    ACTIONS(12687), 1,
      anon_sym_RPAREN,
    STATE(7653), 1,
      sym_gnu_asm_output_operand_list,
  [286671] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12027), 1,
      anon_sym_COLON,
    ACTIONS(12689), 1,
      anon_sym_RPAREN,
    STATE(7654), 1,
      sym_gnu_asm_input_operand_list,
  [286684] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8745), 1,
      anon_sym_RBRACK,
    ACTIONS(12691), 1,
      anon_sym_COMMA,
    STATE(7698), 1,
      aux_sym_subscript_argument_list_repeat1,
  [286697] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(12694), 1,
      anon_sym_RPAREN,
    STATE(7393), 1,
      aux_sym_argument_list_repeat1,
  [286710] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4226), 1,
      anon_sym_RBRACE,
    ACTIONS(12696), 1,
      anon_sym_COMMA,
    STATE(7429), 1,
      aux_sym_initializer_list_repeat1,
  [286723] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12698), 1,
      sym_identifier,
    STATE(2342), 1,
      sym_template_type,
    STATE(3917), 1,
      sym_template_function,
  [286736] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12700), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
    STATE(2718), 1,
      sym_template_function,
  [286749] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12702), 1,
      anon_sym_GT2,
    STATE(7561), 1,
      aux_sym_template_argument_list_repeat1,
  [286762] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12118), 1,
      anon_sym_COLON,
    ACTIONS(12704), 1,
      anon_sym_RPAREN,
    STATE(7571), 1,
      sym_gnu_asm_output_operand_list,
  [286775] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12706), 1,
      anon_sym_GT2,
    STATE(7708), 1,
      aux_sym_template_argument_list_repeat1,
  [286788] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12708), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [286801] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12710), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [286814] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12712), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [286827] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12118), 1,
      anon_sym_COLON,
    ACTIONS(12714), 1,
      anon_sym_RPAREN,
    STATE(7797), 1,
      sym_gnu_asm_output_operand_list,
  [286840] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12054), 1,
      anon_sym_LPAREN2,
    ACTIONS(12716), 1,
      anon_sym_constexpr,
    STATE(657), 1,
      sym_condition_clause,
  [286853] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12098), 1,
      anon_sym_COMMA,
    ACTIONS(12718), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7799), 1,
      aux_sym_attribute_declaration_repeat1,
  [286866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12720), 1,
      anon_sym_GT2,
    STATE(7780), 1,
      aux_sym_template_argument_list_repeat1,
  [286879] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8388), 1,
      anon_sym_RPAREN,
    STATE(7393), 1,
      aux_sym_argument_list_repeat1,
  [286892] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8392), 1,
      anon_sym_COMMA,
    ACTIONS(12722), 1,
      anon_sym_RBRACK,
    STATE(7698), 1,
      aux_sym_subscript_argument_list_repeat1,
  [286905] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12036), 1,
      anon_sym_COLON,
    ACTIONS(12724), 1,
      anon_sym_RPAREN,
    STATE(8847), 1,
      sym_gnu_asm_goto_list,
  [286918] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8526), 1,
      anon_sym_RPAREN,
    STATE(7393), 1,
      aux_sym_argument_list_repeat1,
  [286931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12364), 1,
      anon_sym_catch,
    STATE(1826), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [286942] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12118), 1,
      anon_sym_COLON,
    ACTIONS(12726), 1,
      anon_sym_RPAREN,
    STATE(7655), 1,
      sym_gnu_asm_output_operand_list,
  [286955] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(12728), 1,
      anon_sym_RPAREN,
    STATE(7393), 1,
      aux_sym_argument_list_repeat1,
  [286968] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    STATE(7096), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12730), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [286979] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12073), 1,
      anon_sym_COMMA,
    ACTIONS(12732), 1,
      anon_sym_RPAREN,
    STATE(7628), 1,
      aux_sym_parameter_list_repeat1,
  [286992] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9970), 1,
      anon_sym_RPAREN,
    ACTIONS(12734), 1,
      anon_sym_COMMA,
    STATE(7722), 1,
      aux_sym_preproc_argument_list_repeat1,
  [287005] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12737), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
    STATE(2972), 1,
      sym_template_function,
  [287018] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4178), 1,
      anon_sym_RBRACE,
    ACTIONS(12739), 1,
      anon_sym_COMMA,
    STATE(7429), 1,
      aux_sym_initializer_list_repeat1,
  [287031] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12741), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [287040] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12743), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [287053] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12745), 1,
      anon_sym_GT2,
    STATE(7730), 1,
      aux_sym_template_argument_list_repeat1,
  [287066] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12747), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [287079] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12749), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [287092] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12751), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [287105] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12753), 1,
      anon_sym_SEMI,
    STATE(7742), 1,
      aux_sym_declaration_repeat1,
  [287118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12755), 1,
      anon_sym_SEMI,
    STATE(7474), 1,
      aux_sym_declaration_repeat1,
  [287131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12136), 1,
      anon_sym_catch,
    STATE(243), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [287142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12757), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12759), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [287153] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12761), 1,
      anon_sym_SEMI,
    STATE(7474), 1,
      aux_sym_declaration_repeat1,
  [287166] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12763), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [287179] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9694), 1,
      anon_sym_COMMA,
    ACTIONS(12765), 1,
      anon_sym_RPAREN,
    STATE(7722), 1,
      aux_sym_preproc_argument_list_repeat1,
  [287192] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12073), 1,
      anon_sym_COMMA,
    ACTIONS(12767), 1,
      anon_sym_RPAREN,
    STATE(7721), 1,
      aux_sym_parameter_list_repeat1,
  [287205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12426), 1,
      anon_sym_catch,
    STATE(1834), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [287216] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11645), 1,
      anon_sym_COMMA,
    ACTIONS(11647), 1,
      anon_sym_LBRACE,
    STATE(7570), 1,
      aux_sym_base_class_clause_repeat1,
  [287229] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11645), 1,
      anon_sym_COMMA,
    ACTIONS(11647), 1,
      anon_sym_LBRACE,
    STATE(7499), 1,
      aux_sym_base_class_clause_repeat1,
  [287242] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12769), 1,
      anon_sym_SEMI,
    STATE(7474), 1,
      aux_sym_declaration_repeat1,
  [287255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12364), 1,
      anon_sym_catch,
    STATE(1828), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [287266] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12771), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
    STATE(3741), 1,
      sym_template_function,
  [287279] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12773), 1,
      anon_sym_COMMA,
    ACTIONS(12776), 1,
      anon_sym_RPAREN,
    STATE(7745), 1,
      aux_sym_preproc_params_repeat1,
  [287292] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12778), 1,
      anon_sym_SEMI,
    STATE(7474), 1,
      aux_sym_declaration_repeat1,
  [287305] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12780), 1,
      anon_sym_SEMI,
    STATE(7474), 1,
      aux_sym_declaration_repeat1,
  [287318] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12782), 1,
      anon_sym_GT2,
    STATE(7751), 1,
      aux_sym_template_argument_list_repeat1,
  [287331] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12784), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [287344] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12786), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [287357] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12788), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [287370] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12790), 1,
      anon_sym_default,
    ACTIONS(12792), 1,
      anon_sym_delete,
    ACTIONS(12794), 1,
      anon_sym_0,
  [287383] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8460), 1,
      anon_sym_COMMA,
    ACTIONS(8462), 1,
      anon_sym_RBRACE,
    STATE(7548), 1,
      aux_sym_initializer_list_repeat1,
  [287396] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12796), 1,
      anon_sym_SEMI,
    STATE(7673), 1,
      aux_sym_declaration_repeat1,
  [287409] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12798), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [287422] = 4,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(12284), 1,
      anon_sym_LPAREN2,
    ACTIONS(12800), 1,
      aux_sym_preproc_include_token2,
    STATE(8923), 1,
      sym_preproc_argument_list,
  [287435] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12802), 1,
      anon_sym_COMMA,
    ACTIONS(12805), 1,
      anon_sym_RBRACK,
    STATE(7757), 1,
      aux_sym_structured_binding_declarator_repeat1,
  [287448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12136), 1,
      anon_sym_catch,
    STATE(479), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [287459] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4863), 1,
      anon_sym_LBRACE,
    ACTIONS(11560), 1,
      anon_sym_COLON_COLON,
    STATE(247), 1,
      sym_declaration_list,
  [287472] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12807), 1,
      anon_sym_GT2,
    STATE(7689), 1,
      aux_sym_template_argument_list_repeat1,
  [287485] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8484), 1,
      anon_sym_RPAREN,
    STATE(7560), 1,
      aux_sym_argument_list_repeat1,
  [287498] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12110), 1,
      anon_sym_COMMA,
    ACTIONS(12809), 1,
      anon_sym_GT2,
    STATE(7606), 1,
      aux_sym_template_parameter_list_repeat1,
  [287511] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12118), 1,
      anon_sym_COLON,
    ACTIONS(12811), 1,
      anon_sym_RPAREN,
    STATE(7697), 1,
      sym_gnu_asm_output_operand_list,
  [287524] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8392), 1,
      anon_sym_COMMA,
    ACTIONS(8486), 1,
      anon_sym_RBRACK,
    STATE(7714), 1,
      aux_sym_subscript_argument_list_repeat1,
  [287537] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12813), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
    STATE(2972), 1,
      sym_template_function,
  [287550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12311), 1,
      anon_sym_catch,
    STATE(133), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [287561] = 4,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(12284), 1,
      anon_sym_LPAREN2,
    ACTIONS(12815), 1,
      aux_sym_preproc_include_token2,
    STATE(8923), 1,
      sym_preproc_argument_list,
  [287574] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12817), 1,
      anon_sym_GT2,
    STATE(7771), 1,
      aux_sym_template_argument_list_repeat1,
  [287587] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12819), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [287600] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12821), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [287613] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12823), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [287626] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12098), 1,
      anon_sym_COMMA,
    ACTIONS(12825), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7694), 1,
      aux_sym_attribute_declaration_repeat1,
  [287639] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11006), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [287648] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    STATE(7170), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12827), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [287659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12052), 1,
      anon_sym_catch,
    STATE(309), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [287670] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12054), 1,
      anon_sym_LPAREN2,
    ACTIONS(12829), 1,
      anon_sym_constexpr,
    STATE(632), 1,
      sym_condition_clause,
  [287683] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12098), 1,
      anon_sym_COMMA,
    ACTIONS(12831), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7540), 1,
      aux_sym_attribute_declaration_repeat1,
  [287696] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8755), 1,
      anon_sym_RBRACK,
    ACTIONS(12833), 1,
      anon_sym_COMMA,
    STATE(7778), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [287709] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8524), 1,
      anon_sym_RPAREN,
    STATE(7393), 1,
      aux_sym_argument_list_repeat1,
  [287722] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12836), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [287735] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    STATE(7176), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12838), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [287746] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    STATE(7264), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12840), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [287757] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8614), 1,
      anon_sym_COMMA,
    ACTIONS(8616), 1,
      anon_sym_RBRACE,
    STATE(7700), 1,
      aux_sym_initializer_list_repeat1,
  [287770] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4859), 1,
      anon_sym_LBRACE,
    ACTIONS(11560), 1,
      anon_sym_COLON_COLON,
    STATE(766), 1,
      sym_declaration_list,
  [287783] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12842), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
    STATE(3966), 1,
      sym_template_function,
  [287796] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12844), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [287809] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    STATE(7186), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12846), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [287820] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12848), 1,
      anon_sym_GT2,
    STATE(7791), 1,
      aux_sym_template_argument_list_repeat1,
  [287833] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12850), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [287846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12852), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [287859] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12854), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [287872] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12856), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [287885] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    STATE(7206), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12858), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [287896] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12118), 1,
      anon_sym_COLON,
    ACTIONS(12860), 1,
      anon_sym_RPAREN,
    STATE(7671), 1,
      sym_gnu_asm_output_operand_list,
  [287909] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    STATE(7260), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12862), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [287920] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_COMMA,
    ACTIONS(8610), 1,
      anon_sym_RPAREN,
    STATE(7716), 1,
      aux_sym_argument_list_repeat1,
  [287933] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12027), 1,
      anon_sym_COLON,
    ACTIONS(12864), 1,
      anon_sym_RPAREN,
    STATE(7690), 1,
      sym_gnu_asm_input_operand_list,
  [287946] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8392), 1,
      anon_sym_COMMA,
    ACTIONS(12866), 1,
      anon_sym_RBRACK,
    STATE(7698), 1,
      aux_sym_subscript_argument_list_repeat1,
  [287959] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12098), 1,
      anon_sym_COMMA,
    ACTIONS(12868), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7694), 1,
      aux_sym_attribute_declaration_repeat1,
  [287972] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    STATE(7308), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12870), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [287983] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5825), 1,
      anon_sym_COMMA,
    ACTIONS(12872), 1,
      anon_sym_RBRACK,
    STATE(7601), 1,
      aux_sym_structured_binding_declarator_repeat1,
  [287996] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4861), 1,
      anon_sym_LBRACE,
    ACTIONS(11560), 1,
      anon_sym_COLON_COLON,
    STATE(442), 1,
      sym_declaration_list,
  [288009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12488), 1,
      anon_sym_catch,
    STATE(1692), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [288020] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12874), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
    STATE(2972), 1,
      sym_template_function,
  [288033] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12876), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
    STATE(3917), 1,
      sym_template_function,
  [288046] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12073), 1,
      anon_sym_COMMA,
    ACTIONS(12878), 1,
      anon_sym_RPAREN,
    STATE(7628), 1,
      aux_sym_parameter_list_repeat1,
  [288059] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12880), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
    STATE(6580), 1,
      sym_template_function,
  [288072] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12882), 1,
      anon_sym_GT2,
    STATE(7811), 1,
      aux_sym_template_argument_list_repeat1,
  [288085] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12884), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [288098] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12886), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [288111] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      anon_sym_COMMA,
    ACTIONS(12888), 1,
      anon_sym_GT2,
    STATE(7578), 1,
      aux_sym_template_argument_list_repeat1,
  [288124] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4222), 1,
      anon_sym_RBRACE,
    ACTIONS(12890), 1,
      anon_sym_COMMA,
    STATE(7429), 1,
      aux_sym_initializer_list_repeat1,
  [288137] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9752), 1,
      anon_sym_COMMA,
    ACTIONS(12892), 1,
      anon_sym_SEMI,
    STATE(7746), 1,
      aux_sym_declaration_repeat1,
  [288150] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12894), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
    STATE(2718), 1,
      sym_template_function,
  [288163] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    STATE(7342), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12896), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [288174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(619), 1,
      anon_sym_LBRACE,
    STATE(316), 1,
      sym_compound_statement,
  [288184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8190), 1,
      anon_sym_LPAREN2,
    STATE(5319), 1,
      sym_argument_list,
  [288194] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    STATE(9077), 1,
      sym_argument_list,
  [288204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10525), 1,
      anon_sym_LBRACE,
    STATE(1933), 1,
      sym_compound_statement,
  [288214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9488), 1,
      anon_sym_LBRACE,
    STATE(4042), 1,
      sym_requirement_seq,
  [288224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12898), 1,
      anon_sym_COMMA,
    ACTIONS(12900), 1,
      anon_sym_RBRACE,
  [288234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5534), 1,
      anon_sym_LT,
    STATE(2533), 1,
      sym_template_argument_list,
  [288244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4861), 1,
      anon_sym_LBRACE,
    STATE(443), 1,
      sym_declaration_list,
  [288254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12902), 1,
      sym_identifier,
    STATE(7399), 1,
      sym_attribute,
  [288264] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5548), 1,
      anon_sym_LBRACE,
    STATE(2354), 1,
      sym_field_declaration_list,
  [288274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5534), 1,
      anon_sym_LT,
    STATE(2297), 1,
      sym_template_argument_list,
  [288284] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(12904), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12906), 1,
      sym_preproc_arg,
  [288294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    STATE(8118), 1,
      sym_parameter_list,
  [288304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6192), 1,
      anon_sym_LT,
    STATE(2297), 1,
      sym_template_argument_list,
  [288314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8202), 1,
      anon_sym_LBRACE,
    STATE(4622), 1,
      sym_field_declaration_list,
  [288324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11655), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
  [288334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12908), 1,
      anon_sym_LT,
    STATE(3496), 1,
      sym_template_argument_list,
  [288344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    STATE(8905), 1,
      sym_argument_list,
  [288354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    STATE(157), 1,
      sym_compound_statement,
  [288364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    STATE(8782), 1,
      sym_argument_list,
  [288374] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    STATE(8723), 1,
      sym_argument_list,
  [288384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11560), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12910), 1,
      anon_sym_SEMI,
  [288394] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    STATE(8825), 1,
      sym_argument_list,
  [288404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12902), 1,
      sym_identifier,
    STATE(7777), 1,
      sym_attribute,
  [288414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4859), 1,
      anon_sym_LBRACE,
    STATE(768), 1,
      sym_declaration_list,
  [288424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(7565), 1,
      sym_compound_statement,
  [288434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4859), 1,
      anon_sym_LBRACE,
    STATE(728), 1,
      sym_declaration_list,
  [288444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12902), 1,
      sym_identifier,
    STATE(7573), 1,
      sym_attribute,
  [288454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10695), 1,
      anon_sym_RBRACE,
    ACTIONS(12898), 1,
      anon_sym_COMMA,
  [288464] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8581), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [288472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12054), 1,
      anon_sym_LPAREN2,
    STATE(7884), 1,
      sym_condition_clause,
  [288482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8202), 1,
      anon_sym_LBRACE,
    STATE(4657), 1,
      sym_field_declaration_list,
  [288492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12054), 1,
      anon_sym_LPAREN2,
    STATE(630), 1,
      sym_condition_clause,
  [288502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 1,
      anon_sym_LBRACE,
    STATE(324), 1,
      sym_compound_statement,
  [288512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8202), 1,
      anon_sym_LBRACE,
    STATE(4647), 1,
      sym_field_declaration_list,
  [288522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12912), 1,
      sym_identifier,
    ACTIONS(12914), 1,
      anon_sym_LPAREN2,
  [288532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10543), 1,
      anon_sym_LBRACE,
    STATE(1966), 1,
      sym_compound_statement,
  [288542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(7691), 1,
      sym_compound_statement,
  [288552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11560), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12916), 1,
      anon_sym_SEMI,
  [288562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(7672), 1,
      sym_compound_statement,
  [288572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12918), 1,
      sym_identifier,
    STATE(1860), 1,
      sym_template_type,
  [288582] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(12920), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12922), 1,
      sym_preproc_arg,
  [288592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    STATE(7906), 1,
      sym_parameter_list,
  [288602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12924), 1,
      sym_identifier,
    ACTIONS(12926), 1,
      anon_sym_LPAREN2,
  [288612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12908), 1,
      anon_sym_LT,
    STATE(3790), 1,
      sym_template_argument_list,
  [288622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(7252), 1,
      sym_compound_statement,
  [288632] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(12928), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12930), 1,
      sym_preproc_arg,
  [288642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12932), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
  [288652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4863), 1,
      anon_sym_LBRACE,
    STATE(249), 1,
      sym_declaration_list,
  [288662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10701), 1,
      anon_sym_RBRACE,
    ACTIONS(12898), 1,
      anon_sym_COMMA,
  [288672] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12934), 1,
      anon_sym_LT,
    STATE(2053), 1,
      sym_template_argument_list,
  [288682] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(12936), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12938), 1,
      sym_preproc_arg,
  [288692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2791), 1,
      anon_sym_LBRACE,
    STATE(3678), 1,
      sym_initializer_list,
  [288702] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12940), 1,
      anon_sym_LT,
    STATE(3904), 1,
      sym_template_argument_list,
  [288712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12805), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [288720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12942), 1,
      sym_identifier,
    STATE(2994), 1,
      sym_template_type,
  [288730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12054), 1,
      anon_sym_LPAREN2,
    STATE(628), 1,
      sym_condition_clause,
  [288740] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12776), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [288748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    STATE(8840), 1,
      sym_argument_list,
  [288758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    STATE(8557), 1,
      sym_argument_list,
  [288768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3289), 1,
      anon_sym_LBRACE,
    STATE(3944), 1,
      sym_initializer_list,
  [288778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12944), 1,
      anon_sym_LT,
    STATE(2869), 1,
      sym_template_argument_list,
  [288788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(7291), 1,
      sym_compound_statement,
  [288798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(619), 1,
      anon_sym_LBRACE,
    STATE(435), 1,
      sym_compound_statement,
  [288808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(7803), 1,
      sym_compound_statement,
  [288818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10525), 1,
      anon_sym_LBRACE,
    STATE(1984), 1,
      sym_compound_statement,
  [288828] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12759), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [288836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12902), 1,
      sym_identifier,
    STATE(7711), 1,
      sym_attribute,
  [288846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(619), 1,
      anon_sym_LBRACE,
    STATE(326), 1,
      sym_compound_statement,
  [288856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12054), 1,
      anon_sym_LPAREN2,
    STATE(608), 1,
      sym_condition_clause,
  [288866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12054), 1,
      anon_sym_LPAREN2,
    STATE(615), 1,
      sym_condition_clause,
  [288876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(421), 1,
      sym_compound_statement,
  [288886] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12946), 1,
      anon_sym_LPAREN2,
    STATE(8186), 1,
      sym_parenthesized_expression,
  [288896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6179), 1,
      anon_sym_LBRACE,
    STATE(3010), 1,
      sym_field_declaration_list,
  [288906] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(12948), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12950), 1,
      sym_preproc_arg,
  [288916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12898), 1,
      anon_sym_COMMA,
    ACTIONS(12952), 1,
      anon_sym_RBRACE,
  [288926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6179), 1,
      anon_sym_LBRACE,
    STATE(3004), 1,
      sym_field_declaration_list,
  [288936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12946), 1,
      anon_sym_LPAREN2,
    STATE(7921), 1,
      sym_parenthesized_expression,
  [288946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12898), 1,
      anon_sym_COMMA,
    ACTIONS(12954), 1,
      anon_sym_RBRACE,
  [288956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(7639), 1,
      sym_compound_statement,
  [288966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_LT,
    STATE(4492), 1,
      sym_template_argument_list,
  [288976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    STATE(177), 1,
      sym_compound_statement,
  [288986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8202), 1,
      anon_sym_LBRACE,
    STATE(4639), 1,
      sym_field_declaration_list,
  [288996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    STATE(7934), 1,
      sym_parameter_list,
  [289006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12956), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [289014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12902), 1,
      sym_identifier,
    STATE(7905), 1,
      sym_attribute,
  [289024] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5548), 1,
      anon_sym_LBRACE,
    STATE(2351), 1,
      sym_field_declaration_list,
  [289034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8745), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [289042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5548), 1,
      anon_sym_LBRACE,
    STATE(2325), 1,
      sym_field_declaration_list,
  [289052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12683), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [289060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10555), 1,
      anon_sym_LBRACE,
    STATE(1714), 1,
      sym_compound_statement,
  [289070] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12958), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [289078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10659), 1,
      anon_sym_RBRACE,
    ACTIONS(12898), 1,
      anon_sym_COMMA,
  [289088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4861), 1,
      anon_sym_LBRACE,
    STATE(461), 1,
      sym_declaration_list,
  [289098] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12940), 1,
      anon_sym_LT,
    STATE(2841), 1,
      sym_template_argument_list,
  [289108] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12650), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [289116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9435), 1,
      anon_sym_LBRACE,
    STATE(3617), 1,
      sym_requirement_seq,
  [289126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4857), 1,
      anon_sym_LBRACE,
    STATE(495), 1,
      sym_declaration_list,
  [289136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12960), 1,
      sym_identifier,
    STATE(4048), 1,
      sym_template_type,
  [289146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    STATE(2242), 1,
      sym_field_declaration_list,
  [289156] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8277), 1,
      anon_sym_LT,
    STATE(2053), 1,
      sym_template_argument_list,
  [289166] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(12962), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12964), 1,
      sym_preproc_arg,
  [289176] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12966), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [289184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7651), 1,
      anon_sym_LBRACE,
    STATE(4304), 1,
      sym_field_declaration_list,
  [289194] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12940), 1,
      anon_sym_LT,
    STATE(3709), 1,
      sym_template_argument_list,
  [289204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      anon_sym_LBRACE,
    STATE(878), 1,
      sym_compound_statement,
  [289214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12898), 1,
      anon_sym_COMMA,
    ACTIONS(12968), 1,
      anon_sym_RBRACE,
  [289224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9480), 1,
      anon_sym_LBRACE,
    STATE(3746), 1,
      sym_requirement_seq,
  [289234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7651), 1,
      anon_sym_LBRACE,
    STATE(4283), 1,
      sym_field_declaration_list,
  [289244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7651), 1,
      anon_sym_LBRACE,
    STATE(4288), 1,
      sym_field_declaration_list,
  [289254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    STATE(8337), 1,
      sym_argument_list,
  [289264] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10699), 1,
      anon_sym_RBRACE,
    ACTIONS(12898), 1,
      anon_sym_COMMA,
  [289274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8277), 1,
      anon_sym_LT,
    STATE(2875), 1,
      sym_template_argument_list,
  [289284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7945), 1,
      anon_sym_LPAREN2,
    STATE(4212), 1,
      sym_argument_list,
  [289294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10543), 1,
      anon_sym_LBRACE,
    STATE(2043), 1,
      sym_compound_statement,
  [289304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(7533), 1,
      sym_compound_statement,
  [289314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9445), 1,
      anon_sym_LBRACE,
    STATE(4973), 1,
      sym_requirement_seq,
  [289324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12902), 1,
      sym_identifier,
    STATE(7516), 1,
      sym_attribute,
  [289334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      anon_sym_LBRACE,
    STATE(817), 1,
      sym_compound_statement,
  [289344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7651), 1,
      anon_sym_LBRACE,
    STATE(4316), 1,
      sym_field_declaration_list,
  [289354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12898), 1,
      anon_sym_COMMA,
    ACTIONS(12970), 1,
      anon_sym_RBRACE,
  [289364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(619), 1,
      anon_sym_LBRACE,
    STATE(464), 1,
      sym_compound_statement,
  [289374] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12551), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [289382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12972), 1,
      sym_identifier,
    STATE(2886), 1,
      sym_template_type,
  [289392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    STATE(2224), 1,
      sym_field_declaration_list,
  [289402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5534), 1,
      anon_sym_LT,
    STATE(1651), 1,
      sym_template_argument_list,
  [289412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4861), 1,
      anon_sym_LBRACE,
    STATE(500), 1,
      sym_declaration_list,
  [289422] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6603), 1,
      anon_sym_LBRACE,
    STATE(3360), 1,
      sym_field_declaration_list,
  [289432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12946), 1,
      anon_sym_LPAREN2,
    STATE(8732), 1,
      sym_parenthesized_expression,
  [289442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    STATE(222), 1,
      sym_compound_statement,
  [289452] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    STATE(5360), 1,
      sym_field_declaration_list,
  [289462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    STATE(8047), 1,
      sym_parameter_list,
  [289472] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12974), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [289480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12946), 1,
      anon_sym_LPAREN2,
    STATE(8137), 1,
      sym_parenthesized_expression,
  [289490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    STATE(7816), 1,
      sym_parameter_list,
  [289500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9461), 1,
      anon_sym_LBRACE,
    STATE(2700), 1,
      sym_requirement_seq,
  [289510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12898), 1,
      anon_sym_COMMA,
    ACTIONS(12976), 1,
      anon_sym_RBRACE,
  [289520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12898), 1,
      anon_sym_COMMA,
    ACTIONS(12978), 1,
      anon_sym_RBRACE,
  [289530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    STATE(5357), 1,
      sym_field_declaration_list,
  [289540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      anon_sym_LBRACE,
    STATE(859), 1,
      sym_compound_statement,
  [289550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(7427), 1,
      sym_compound_statement,
  [289560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_LPAREN2,
    STATE(3765), 1,
      sym_argument_list,
  [289570] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12518), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [289578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    STATE(8150), 1,
      sym_parameter_list,
  [289588] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12946), 1,
      anon_sym_LPAREN2,
    STATE(8198), 1,
      sym_parenthesized_expression,
  [289598] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    STATE(5361), 1,
      sym_field_declaration_list,
  [289608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10555), 1,
      anon_sym_LBRACE,
    STATE(1760), 1,
      sym_compound_statement,
  [289618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4857), 1,
      anon_sym_LBRACE,
    STATE(595), 1,
      sym_declaration_list,
  [289628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6275), 1,
      anon_sym_LBRACE,
    STATE(3014), 1,
      sym_field_declaration_list,
  [289638] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(7775), 1,
      sym_compound_statement,
  [289648] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(343), 1,
      sym_compound_statement,
  [289658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    STATE(302), 1,
      sym_compound_statement,
  [289668] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12946), 1,
      anon_sym_LPAREN2,
    STATE(8351), 1,
      sym_parenthesized_expression,
  [289678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4863), 1,
      anon_sym_LBRACE,
    STATE(214), 1,
      sym_declaration_list,
  [289688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(7259), 1,
      sym_compound_statement,
  [289698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12898), 1,
      anon_sym_COMMA,
    ACTIONS(12980), 1,
      anon_sym_RBRACE,
  [289708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    STATE(8271), 1,
      sym_argument_list,
  [289718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12054), 1,
      anon_sym_LPAREN2,
    STATE(609), 1,
      sym_condition_clause,
  [289728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(435), 1,
      sym_compound_statement,
  [289738] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(12982), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12984), 1,
      sym_preproc_arg,
  [289748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12946), 1,
      anon_sym_LPAREN2,
    STATE(7887), 1,
      sym_parenthesized_expression,
  [289758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8518), 1,
      anon_sym_RPAREN,
    ACTIONS(8520), 1,
      anon_sym_SEMI,
  [289768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 1,
      anon_sym_LBRACE,
    STATE(386), 1,
      sym_compound_statement,
  [289778] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12506), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [289786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      anon_sym_LBRACE,
    STATE(3880), 1,
      sym_initializer_list,
  [289796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12986), 1,
      sym_identifier,
    STATE(3052), 1,
      sym_template_type,
  [289806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    STATE(5350), 1,
      sym_field_declaration_list,
  [289816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(7532), 1,
      sym_compound_statement,
  [289826] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(2474), 1,
      sym_field_declaration_list,
  [289836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6275), 1,
      anon_sym_LBRACE,
    STATE(3060), 1,
      sym_field_declaration_list,
  [289846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12988), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [289854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12054), 1,
      anon_sym_LPAREN2,
    STATE(8044), 1,
      sym_condition_clause,
  [289864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12902), 1,
      sym_identifier,
    STATE(7553), 1,
      sym_attribute,
  [289874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6275), 1,
      anon_sym_LBRACE,
    STATE(3085), 1,
      sym_field_declaration_list,
  [289884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    STATE(176), 1,
      sym_compound_statement,
  [289894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12511), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [289902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3454), 1,
      anon_sym_LBRACE,
    STATE(4160), 1,
      sym_initializer_list,
  [289912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12054), 1,
      anon_sym_LPAREN2,
    STATE(621), 1,
      sym_condition_clause,
  [289922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12990), 1,
      sym_identifier,
    STATE(2342), 1,
      sym_template_type,
  [289932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(735), 1,
      sym_compound_statement,
  [289942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6179), 1,
      anon_sym_LBRACE,
    STATE(2993), 1,
      sym_field_declaration_list,
  [289952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(2500), 1,
      sym_field_declaration_list,
  [289962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12946), 1,
      anon_sym_LPAREN2,
    STATE(7897), 1,
      sym_parenthesized_expression,
  [289972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5548), 1,
      anon_sym_LBRACE,
    STATE(2373), 1,
      sym_field_declaration_list,
  [289982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12992), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [289990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10734), 1,
      anon_sym_RBRACE,
    ACTIONS(12898), 1,
      anon_sym_COMMA,
  [290000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(7717), 1,
      sym_compound_statement,
  [290010] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12994), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [290018] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12996), 1,
      anon_sym_LT,
    STATE(4356), 1,
      sym_template_argument_list,
  [290028] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    STATE(4269), 1,
      sym_initializer_list,
  [290038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6603), 1,
      anon_sym_LBRACE,
    STATE(3478), 1,
      sym_field_declaration_list,
  [290048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11914), 1,
      anon_sym_LBRACE,
    STATE(6251), 1,
      sym_requirement_seq,
  [290058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6603), 1,
      anon_sym_LBRACE,
    STATE(3476), 1,
      sym_field_declaration_list,
  [290068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12998), 1,
      sym_identifier,
    STATE(2254), 1,
      sym_template_type,
  [290078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8013), 1,
      anon_sym_LBRACE,
    STATE(4578), 1,
      sym_field_declaration_list,
  [290088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6275), 1,
      anon_sym_LBRACE,
    STATE(3072), 1,
      sym_field_declaration_list,
  [290098] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13000), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [290106] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12424), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [290114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(619), 1,
      anon_sym_LBRACE,
    STATE(587), 1,
      sym_compound_statement,
  [290124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 1,
      anon_sym_LBRACE,
    STATE(5246), 1,
      sym_initializer_list,
  [290134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10633), 1,
      anon_sym_RBRACE,
    ACTIONS(12898), 1,
      anon_sym_COMMA,
  [290144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13002), 1,
      sym_identifier,
    STATE(4491), 1,
      sym_template_type,
  [290154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13004), 1,
      anon_sym_LPAREN2,
    ACTIONS(13006), 1,
      sym_raw_string_delimiter,
  [290164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 1,
      anon_sym_LPAREN2,
    STATE(2742), 1,
      sym_argument_list,
  [290174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11823), 1,
      anon_sym_LBRACE,
    STATE(1674), 1,
      sym_requirement_seq,
  [290184] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(13008), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13010), 1,
      sym_preproc_arg,
  [290194] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4863), 1,
      anon_sym_LBRACE,
    STATE(251), 1,
      sym_declaration_list,
  [290204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    STATE(7849), 1,
      sym_parameter_list,
  [290214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8277), 1,
      anon_sym_LT,
    STATE(1651), 1,
      sym_template_argument_list,
  [290224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN2,
    STATE(3982), 1,
      sym_argument_list,
  [290234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12946), 1,
      anon_sym_LPAREN2,
    STATE(8539), 1,
      sym_parenthesized_expression,
  [290244] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6384), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [290252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6400), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [290260] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6406), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [290268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(2526), 1,
      sym_field_declaration_list,
  [290278] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [290286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    STATE(4212), 1,
      sym_argument_list,
  [290296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6467), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [290304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(2524), 1,
      sym_field_declaration_list,
  [290314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13012), 1,
      anon_sym_LT,
    STATE(2259), 1,
      sym_template_argument_list,
  [290324] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6495), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [290332] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(13014), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13016), 1,
      sym_preproc_arg,
  [290342] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6499), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [290350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8316), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_template_argument_list,
  [290360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5654), 1,
      anon_sym_LBRACE,
    STATE(2387), 1,
      sym_field_declaration_list,
  [290370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12898), 1,
      anon_sym_COMMA,
    ACTIONS(13018), 1,
      anon_sym_RBRACE,
  [290380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6996), 1,
      anon_sym_LPAREN2,
    STATE(4168), 1,
      sym_argument_list,
  [290390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10555), 1,
      anon_sym_LBRACE,
    STATE(1811), 1,
      sym_compound_statement,
  [290400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      anon_sym_LBRACE,
    STATE(862), 1,
      sym_compound_statement,
  [290410] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(13020), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13022), 1,
      sym_preproc_arg,
  [290420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(7733), 1,
      sym_compound_statement,
  [290430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(323), 1,
      sym_compound_statement,
  [290440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9469), 1,
      anon_sym_LBRACE,
    STATE(5198), 1,
      sym_requirement_seq,
  [290450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13024), 1,
      sym_identifier,
    ACTIONS(13026), 1,
      anon_sym_RPAREN,
  [290460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6535), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [290468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    STATE(8468), 1,
      sym_argument_list,
  [290478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12054), 1,
      anon_sym_LPAREN2,
    STATE(625), 1,
      sym_condition_clause,
  [290488] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6531), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [290496] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(13028), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13030), 1,
      sym_preproc_arg,
  [290506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(7151), 1,
      sym_compound_statement,
  [290516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11560), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13032), 1,
      anon_sym_SEMI,
  [290526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4859), 1,
      anon_sym_LBRACE,
    STATE(730), 1,
      sym_declaration_list,
  [290536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    STATE(8701), 1,
      sym_argument_list,
  [290546] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(7416), 1,
      sym_compound_statement,
  [290556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8224), 1,
      anon_sym_LBRACE,
    STATE(5028), 1,
      sym_field_declaration_list,
  [290566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6179), 1,
      anon_sym_LBRACE,
    STATE(2996), 1,
      sym_field_declaration_list,
  [290576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13034), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
  [290586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6603), 1,
      anon_sym_LBRACE,
    STATE(3370), 1,
      sym_field_declaration_list,
  [290596] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12360), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [290604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6803), 1,
      anon_sym_LT,
    STATE(3018), 1,
      sym_template_argument_list,
  [290614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(7617), 1,
      sym_compound_statement,
  [290624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12354), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [290632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10705), 1,
      anon_sym_RBRACE,
    ACTIONS(12898), 1,
      anon_sym_COMMA,
  [290642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12054), 1,
      anon_sym_LPAREN2,
    STATE(651), 1,
      sym_condition_clause,
  [290652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12054), 1,
      anon_sym_LPAREN2,
    STATE(7978), 1,
      sym_condition_clause,
  [290662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    STATE(138), 1,
      sym_compound_statement,
  [290672] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8224), 1,
      anon_sym_LBRACE,
    STATE(5030), 1,
      sym_field_declaration_list,
  [290682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12902), 1,
      sym_identifier,
    STATE(7579), 1,
      sym_attribute,
  [290692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8224), 1,
      anon_sym_LBRACE,
    STATE(5036), 1,
      sym_field_declaration_list,
  [290702] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11560), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13036), 1,
      anon_sym_SEMI,
  [290712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6324), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [290720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(7356), 1,
      sym_compound_statement,
  [290730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6192), 1,
      anon_sym_LT,
    STATE(1651), 1,
      sym_template_argument_list,
  [290740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13038), 1,
      sym_identifier,
    STATE(1860), 1,
      sym_template_type,
  [290750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13040), 1,
      sym_identifier,
    STATE(2811), 1,
      sym_template_type,
  [290760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10709), 1,
      anon_sym_RBRACE,
    ACTIONS(12898), 1,
      anon_sym_COMMA,
  [290770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8013), 1,
      anon_sym_LBRACE,
    STATE(4581), 1,
      sym_field_declaration_list,
  [290780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9424), 1,
      anon_sym_LBRACE,
    STATE(4114), 1,
      sym_requirement_seq,
  [290790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8013), 1,
      anon_sym_LBRACE,
    STATE(4585), 1,
      sym_field_declaration_list,
  [290800] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(13042), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13044), 1,
      sym_preproc_arg,
  [290810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9453), 1,
      anon_sym_LBRACE,
    STATE(3951), 1,
      sym_requirement_seq,
  [290820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5534), 1,
      anon_sym_LT,
    STATE(2487), 1,
      sym_template_argument_list,
  [290830] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8198), 1,
      anon_sym_LPAREN2,
    STATE(5210), 1,
      sym_argument_list,
  [290840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4857), 1,
      anon_sym_LBRACE,
    STATE(520), 1,
      sym_declaration_list,
  [290850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8224), 1,
      anon_sym_LBRACE,
    STATE(5070), 1,
      sym_field_declaration_list,
  [290860] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12331), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [290868] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(13046), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13048), 1,
      sym_preproc_arg,
  [290878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12908), 1,
      anon_sym_LT,
    STATE(2821), 1,
      sym_template_argument_list,
  [290888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(353), 1,
      sym_compound_statement,
  [290898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13050), 1,
      sym_identifier,
    STATE(2120), 1,
      sym_template_type,
  [290908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10647), 1,
      anon_sym_RBRACE,
    ACTIONS(12898), 1,
      anon_sym_COMMA,
  [290918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2518), 1,
      anon_sym_LBRACE,
    STATE(2641), 1,
      sym_initializer_list,
  [290928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13052), 1,
      anon_sym_LPAREN2,
    ACTIONS(13054), 1,
      sym_raw_string_delimiter,
  [290938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(2889), 1,
      sym_field_declaration_list,
  [290948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3716), 1,
      anon_sym_LBRACE,
    STATE(5305), 1,
      sym_initializer_list,
  [290958] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13056), 1,
      sym_identifier,
    STATE(2872), 1,
      sym_template_type,
  [290968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(2937), 1,
      sym_field_declaration_list,
  [290978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10717), 1,
      anon_sym_RBRACE,
    ACTIONS(12898), 1,
      anon_sym_COMMA,
  [290988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5654), 1,
      anon_sym_LBRACE,
    STATE(2444), 1,
      sym_field_declaration_list,
  [290998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12946), 1,
      anon_sym_LPAREN2,
    STATE(8191), 1,
      sym_parenthesized_expression,
  [291008] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13058), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [291016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5654), 1,
      anon_sym_LBRACE,
    STATE(2448), 1,
      sym_field_declaration_list,
  [291026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10367), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [291034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8472), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [291042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12898), 1,
      anon_sym_COMMA,
    ACTIONS(13060), 1,
      anon_sym_RBRACE,
  [291052] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(2926), 1,
      sym_field_declaration_list,
  [291062] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(7504), 1,
      sym_compound_statement,
  [291072] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(13062), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13064), 1,
      sym_preproc_arg,
  [291082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(2931), 1,
      sym_field_declaration_list,
  [291092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8013), 1,
      anon_sym_LBRACE,
    STATE(4595), 1,
      sym_field_declaration_list,
  [291102] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13066), 1,
      sym_identifier,
    STATE(1860), 1,
      sym_template_type,
  [291112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12054), 1,
      anon_sym_LPAREN2,
    STATE(658), 1,
      sym_condition_clause,
  [291122] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10525), 1,
      anon_sym_LBRACE,
    STATE(1858), 1,
      sym_compound_statement,
  [291132] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10685), 1,
      anon_sym_RBRACE,
    ACTIONS(12898), 1,
      anon_sym_COMMA,
  [291142] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4514), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [291150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12054), 1,
      anon_sym_LPAREN2,
    STATE(611), 1,
      sym_condition_clause,
  [291160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5210), 1,
      anon_sym_LT,
    STATE(1651), 1,
      sym_template_argument_list,
  [291170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_LPAREN2,
    STATE(8071), 1,
      sym_parameter_list,
  [291180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13068), 1,
      anon_sym_LT,
    STATE(2533), 1,
      sym_template_argument_list,
  [291190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12054), 1,
      anon_sym_LPAREN2,
    STATE(7966), 1,
      sym_condition_clause,
  [291200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    STATE(2211), 1,
      sym_field_declaration_list,
  [291210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12946), 1,
      anon_sym_LPAREN2,
    STATE(8853), 1,
      sym_parenthesized_expression,
  [291220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8514), 1,
      anon_sym_RBRACK,
    ACTIONS(13070), 1,
      anon_sym_COMMA,
  [291230] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12223), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [291238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    STATE(8302), 1,
      sym_argument_list,
  [291248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12902), 1,
      sym_identifier,
    STATE(7527), 1,
      sym_attribute,
  [291258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13072), 1,
      anon_sym_LPAREN2,
    ACTIONS(13074), 1,
      sym_raw_string_delimiter,
  [291268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 1,
      anon_sym_LBRACE,
    STATE(484), 1,
      sym_compound_statement,
  [291278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13076), 1,
      anon_sym_LPAREN2,
    ACTIONS(13078), 1,
      sym_raw_string_delimiter,
  [291288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6372), 1,
      anon_sym_LBRACE,
    STATE(3062), 1,
      sym_field_declaration_list,
  [291298] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12898), 1,
      anon_sym_COMMA,
    ACTIONS(13080), 1,
      anon_sym_RBRACE,
  [291308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 1,
      anon_sym_LBRACE,
    STATE(429), 1,
      sym_compound_statement,
  [291318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5512), 1,
      anon_sym_LBRACE,
    STATE(2246), 1,
      sym_field_declaration_list,
  [291328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13082), 1,
      anon_sym_LPAREN2,
    ACTIONS(13084), 1,
      sym_raw_string_delimiter,
  [291338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12944), 1,
      anon_sym_LT,
    STATE(3615), 1,
      sym_template_argument_list,
  [291348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13086), 1,
      anon_sym_LPAREN2,
    ACTIONS(13088), 1,
      sym_raw_string_delimiter,
  [291358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13090), 1,
      anon_sym_LPAREN2,
    ACTIONS(13092), 1,
      sym_raw_string_delimiter,
  [291368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13094), 1,
      anon_sym_LPAREN2,
    ACTIONS(13096), 1,
      sym_raw_string_delimiter,
  [291378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6372), 1,
      anon_sym_LBRACE,
    STATE(3023), 1,
      sym_field_declaration_list,
  [291388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6372), 1,
      anon_sym_LBRACE,
    STATE(3025), 1,
      sym_field_declaration_list,
  [291398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13098), 1,
      anon_sym_LPAREN2,
    ACTIONS(13100), 1,
      sym_raw_string_delimiter,
  [291408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10671), 1,
      anon_sym_RBRACE,
    ACTIONS(12898), 1,
      anon_sym_COMMA,
  [291418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13012), 1,
      anon_sym_LT,
    STATE(2487), 1,
      sym_template_argument_list,
  [291428] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(13102), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13104), 1,
      sym_preproc_arg,
  [291438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10543), 1,
      anon_sym_LBRACE,
    STATE(1854), 1,
      sym_compound_statement,
  [291448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13106), 1,
      anon_sym_LPAREN2,
    ACTIONS(13108), 1,
      sym_raw_string_delimiter,
  [291458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13110), 1,
      anon_sym_LPAREN2,
    ACTIONS(13112), 1,
      sym_raw_string_delimiter,
  [291468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13114), 1,
      anon_sym_LT,
    STATE(2875), 1,
      sym_template_argument_list,
  [291478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6824), 1,
      anon_sym_LPAREN2,
    STATE(3965), 1,
      sym_argument_list,
  [291488] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13116), 1,
      anon_sym_LPAREN2,
    ACTIONS(13118), 1,
      sym_raw_string_delimiter,
  [291498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11538), 1,
      anon_sym_LBRACE,
    STATE(5996), 1,
      sym_requirement_seq,
  [291508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5654), 1,
      anon_sym_LBRACE,
    STATE(2451), 1,
      sym_field_declaration_list,
  [291518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12898), 1,
      anon_sym_COMMA,
    ACTIONS(13120), 1,
      anon_sym_RBRACE,
  [291528] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13122), 1,
      anon_sym_LPAREN2,
    ACTIONS(13124), 1,
      sym_raw_string_delimiter,
  [291538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 1,
      anon_sym_LBRACE,
    STATE(400), 1,
      sym_compound_statement,
  [291548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12902), 1,
      sym_identifier,
    STATE(7546), 1,
      sym_attribute,
  [291558] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6372), 1,
      anon_sym_LBRACE,
    STATE(3017), 1,
      sym_field_declaration_list,
  [291568] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12054), 1,
      anon_sym_LPAREN2,
    STATE(7990), 1,
      sym_condition_clause,
  [291578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13126), 1,
      anon_sym_LPAREN2,
    ACTIONS(13128), 1,
      sym_raw_string_delimiter,
  [291588] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12054), 1,
      anon_sym_LPAREN2,
    STATE(605), 1,
      sym_condition_clause,
  [291598] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13130), 1,
      anon_sym_LPAREN2,
    ACTIONS(13132), 1,
      sym_raw_string_delimiter,
  [291608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13134), 1,
      anon_sym_LPAREN2,
    ACTIONS(13136), 1,
      sym_raw_string_delimiter,
  [291618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(7766), 1,
      sym_compound_statement,
  [291628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(679), 1,
      sym_compound_statement,
  [291638] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13138), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [291646] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(13140), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13142), 1,
      sym_preproc_arg,
  [291656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13144), 1,
      anon_sym_LPAREN2,
    ACTIONS(13146), 1,
      sym_raw_string_delimiter,
  [291666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13148), 1,
      sym_identifier,
    STATE(2111), 1,
      sym_template_type,
  [291676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8729), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [291684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(659), 1,
      anon_sym_LBRACE,
    STATE(507), 1,
      sym_compound_statement,
  [291694] = 3,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(13150), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13152), 1,
      sym_preproc_arg,
  [291704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8033), 1,
      anon_sym_LPAREN2,
    STATE(8613), 1,
      sym_argument_list,
  [291714] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(7118), 1,
      sym_compound_statement,
  [291724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12054), 1,
      anon_sym_LPAREN2,
    STATE(660), 1,
      sym_condition_clause,
  [291734] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13154), 1,
      anon_sym_LPAREN2,
    ACTIONS(13156), 1,
      sym_raw_string_delimiter,
  [291744] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13158), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [291752] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12944), 1,
      anon_sym_LT,
    STATE(3923), 1,
      sym_template_argument_list,
  [291762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13160), 1,
      anon_sym_LPAREN2,
    ACTIONS(13162), 1,
      sym_raw_string_delimiter,
  [291772] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8713), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [291780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13164), 1,
      anon_sym_LPAREN2,
    ACTIONS(13166), 1,
      sym_raw_string_delimiter,
  [291790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(619), 1,
      anon_sym_LBRACE,
    STATE(421), 1,
      sym_compound_statement,
  [291800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13168), 1,
      anon_sym_LPAREN2,
    ACTIONS(13170), 1,
      sym_raw_string_delimiter,
  [291810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13172), 1,
      sym_identifier,
    STATE(4423), 1,
      sym_template_type,
  [291820] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13174), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [291828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13012), 1,
      anon_sym_LT,
    STATE(2533), 1,
      sym_template_argument_list,
  [291838] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACE,
    STATE(425), 1,
      sym_compound_statement,
  [291848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8586), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [291856] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10717), 1,
      anon_sym_RBRACE,
  [291863] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13176), 1,
      sym_auto,
  [291870] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(9966), 1,
      aux_sym_preproc_include_token2,
  [291877] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13178), 1,
      anon_sym_RPAREN,
  [291884] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8781), 1,
      anon_sym_COLON,
  [291891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13180), 1,
      anon_sym_SEMI,
  [291898] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(13182), 1,
      aux_sym_preproc_include_token2,
  [291905] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13184), 1,
      sym_auto,
  [291912] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13186), 1,
      anon_sym_LPAREN2,
  [291919] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13188), 1,
      sym_identifier,
  [291926] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13190), 1,
      anon_sym_SEMI,
  [291933] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13120), 1,
      anon_sym_RBRACE,
  [291940] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13192), 1,
      anon_sym_SEMI,
  [291947] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13194), 1,
      sym_identifier,
  [291954] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13196), 1,
      sym_identifier,
  [291961] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13198), 1,
      anon_sym_DQUOTE,
  [291968] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13200), 1,
      anon_sym_SEMI,
  [291975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13202), 1,
      anon_sym_SEMI,
  [291982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13204), 1,
      anon_sym_STAR,
  [291989] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13206), 1,
      anon_sym_STAR,
  [291996] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(9962), 1,
      aux_sym_preproc_include_token2,
  [292003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13208), 1,
      aux_sym_preproc_if_token2,
  [292010] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13210), 1,
      anon_sym_LPAREN2,
  [292017] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13212), 1,
      anon_sym_SEMI,
  [292024] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13214), 1,
      anon_sym_RPAREN,
  [292031] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13216), 1,
      aux_sym_preproc_if_token2,
  [292038] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(13218), 1,
      aux_sym_preproc_include_token2,
  [292045] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10685), 1,
      anon_sym_RBRACE,
  [292052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13220), 1,
      sym_identifier,
  [292059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13222), 1,
      anon_sym_SEMI,
  [292066] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11437), 1,
      anon_sym_COLON,
  [292073] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_SEMI,
  [292080] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13226), 1,
      sym_identifier,
  [292087] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13228), 1,
      anon_sym_COLON,
  [292094] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11887), 1,
      anon_sym_SEMI,
  [292101] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13230), 1,
      anon_sym_DQUOTE,
  [292108] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13232), 1,
      anon_sym_RPAREN,
  [292115] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13234), 1,
      anon_sym_RPAREN,
  [292122] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13236), 1,
      sym_identifier,
  [292129] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13238), 1,
      anon_sym_RPAREN,
  [292136] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13240), 1,
      sym_identifier,
  [292143] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13242), 1,
      anon_sym_RPAREN,
  [292150] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4388), 1,
      anon_sym_DOT_DOT_DOT,
  [292157] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13244), 1,
      anon_sym_RPAREN,
  [292164] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13246), 1,
      sym_identifier,
  [292171] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13248), 1,
      aux_sym_preproc_if_token2,
  [292178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13250), 1,
      anon_sym_RPAREN,
  [292185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13252), 1,
      anon_sym_RPAREN,
  [292192] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10633), 1,
      anon_sym_RBRACE,
  [292199] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13254), 1,
      anon_sym_RPAREN,
  [292206] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13256), 1,
      anon_sym_RPAREN,
  [292213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13258), 1,
      anon_sym_RPAREN,
  [292220] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13260), 1,
      aux_sym_preproc_if_token2,
  [292227] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13262), 1,
      sym_identifier,
  [292234] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8765), 1,
      anon_sym_COLON,
  [292241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12898), 1,
      anon_sym_COMMA,
  [292248] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13264), 1,
      anon_sym_SEMI,
  [292255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13266), 1,
      sym_identifier,
  [292262] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13268), 1,
      aux_sym_preproc_if_token2,
  [292269] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13270), 1,
      sym_identifier,
  [292276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_PLUS,
  [292283] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13274), 1,
      aux_sym_preproc_if_token2,
  [292290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13276), 1,
      anon_sym_COLON,
  [292297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13278), 1,
      anon_sym_RPAREN,
  [292304] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4445), 1,
      anon_sym_DOT_DOT_DOT,
  [292311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13280), 1,
      sym_identifier,
  [292318] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8338), 1,
      anon_sym_SEMI,
  [292325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4410), 1,
      anon_sym_DOT_DOT_DOT,
  [292332] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8438), 1,
      anon_sym_RBRACE,
  [292339] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8797), 1,
      anon_sym_RPAREN,
  [292346] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13282), 1,
      anon_sym_SEMI,
  [292353] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13284), 1,
      aux_sym_preproc_if_token2,
  [292360] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13286), 1,
      anon_sym_SEMI,
  [292367] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10725), 1,
      anon_sym_RPAREN,
  [292374] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4407), 1,
      anon_sym_DOT_DOT_DOT,
  [292381] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13288), 1,
      sym_raw_string_delimiter,
  [292388] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4402), 1,
      anon_sym_DOT_DOT_DOT,
  [292395] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4397), 1,
      anon_sym_DOT_DOT_DOT,
  [292402] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13290), 1,
      anon_sym_RPAREN,
  [292409] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13292), 1,
      anon_sym_SEMI,
  [292416] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(12282), 1,
      aux_sym_preproc_include_token2,
  [292423] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(13294), 1,
      aux_sym_preproc_include_token2,
  [292430] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4394), 1,
      anon_sym_DOT_DOT_DOT,
  [292437] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4391), 1,
      anon_sym_DOT_DOT_DOT,
  [292444] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_COMMA,
  [292451] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(13296), 1,
      aux_sym_preproc_include_token2,
  [292458] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13298), 1,
      anon_sym_STAR,
  [292465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4385), 1,
      anon_sym_DOT_DOT_DOT,
  [292472] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13300), 1,
      anon_sym_RPAREN,
  [292479] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13302), 1,
      anon_sym_RPAREN,
  [292486] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13304), 1,
      anon_sym_RPAREN,
  [292493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8719), 1,
      anon_sym_SEMI,
  [292500] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4375), 1,
      anon_sym_DOT_DOT_DOT,
  [292507] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4534), 1,
      anon_sym_DOT_DOT_DOT,
  [292514] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(13306), 1,
      aux_sym_preproc_include_token2,
  [292521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13308), 1,
      anon_sym_LBRACE,
  [292528] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13310), 1,
      anon_sym_RPAREN,
  [292535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4382), 1,
      anon_sym_DOT_DOT_DOT,
  [292542] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13312), 1,
      anon_sym_RPAREN,
  [292549] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13314), 1,
      anon_sym_RPAREN,
  [292556] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6885), 1,
      anon_sym_RPAREN,
  [292563] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13316), 1,
      sym_identifier,
  [292570] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13318), 1,
      sym_identifier,
  [292577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13320), 1,
      anon_sym_RPAREN,
  [292584] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13322), 1,
      anon_sym_SEMI,
  [292591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13324), 1,
      sym_identifier,
  [292598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13326), 1,
      anon_sym_RPAREN,
  [292605] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13328), 1,
      anon_sym_SEMI,
  [292612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13330), 1,
      anon_sym_SEMI,
  [292619] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13332), 1,
      anon_sym_STAR,
  [292626] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8520), 1,
      anon_sym_SEMI,
  [292633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13334), 1,
      sym_identifier,
  [292640] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13336), 1,
      sym_identifier,
  [292647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13338), 1,
      sym_identifier,
  [292654] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8340), 1,
      anon_sym_RBRACE,
  [292661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13340), 1,
      anon_sym_RPAREN,
  [292668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13342), 1,
      anon_sym_RPAREN,
  [292675] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11129), 1,
      anon_sym_SEMI,
  [292682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13344), 1,
      anon_sym_STAR,
  [292689] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13346), 1,
      anon_sym_RPAREN,
  [292696] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13348), 1,
      anon_sym_RPAREN,
  [292703] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13350), 1,
      anon_sym_SEMI,
  [292710] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13352), 1,
      anon_sym_SEMI,
  [292717] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7644), 1,
      sym_identifier,
  [292724] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13354), 1,
      anon_sym_SEMI,
  [292731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13356), 1,
      anon_sym_SEMI,
  [292738] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8953), 1,
      anon_sym_RPAREN,
  [292745] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13358), 1,
      anon_sym_SEMI,
  [292752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7716), 1,
      sym_identifier,
  [292759] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8751), 1,
      anon_sym_SEMI,
  [292766] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13360), 1,
      sym_identifier,
  [292773] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11151), 1,
      anon_sym_SEMI,
  [292780] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8761), 1,
      anon_sym_RPAREN,
  [292787] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8759), 1,
      anon_sym_RPAREN,
  [292794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13362), 1,
      anon_sym_SEMI,
  [292801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8747), 1,
      anon_sym_SEMI,
  [292808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13364), 1,
      anon_sym_SEMI,
  [292815] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13366), 1,
      anon_sym_RPAREN,
  [292822] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(13368), 1,
      aux_sym_preproc_include_token2,
  [292829] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13370), 1,
      anon_sym_DQUOTE,
  [292836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13372), 1,
      anon_sym_LPAREN2,
  [292843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13374), 1,
      anon_sym_COLON,
  [292850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13376), 1,
      sym_identifier,
  [292857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13378), 1,
      aux_sym_preproc_if_token2,
  [292864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13380), 1,
      anon_sym_RPAREN,
  [292871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8725), 1,
      anon_sym_SEMI,
  [292878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13382), 1,
      anon_sym_SEMI,
  [292885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13384), 1,
      anon_sym_RPAREN,
  [292892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13386), 1,
      anon_sym_RPAREN,
  [292899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13388), 1,
      anon_sym_RPAREN,
  [292906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13390), 1,
      sym_identifier,
  [292913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13392), 1,
      anon_sym_SEMI,
  [292920] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13394), 1,
      anon_sym_DQUOTE,
  [292927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13396), 1,
      anon_sym_SEMI,
  [292934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8951), 1,
      anon_sym_RPAREN,
  [292941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13398), 1,
      sym_identifier,
  [292948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8594), 1,
      anon_sym_RBRACE,
  [292955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13400), 1,
      anon_sym_RPAREN,
  [292962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13402), 1,
      anon_sym_SEMI,
  [292969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13404), 1,
      anon_sym_SEMI,
  [292976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13406), 1,
      anon_sym_SEMI,
  [292983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13408), 1,
      anon_sym_RPAREN,
  [292990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13410), 1,
      anon_sym_RPAREN,
  [292997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13412), 1,
      anon_sym_RPAREN,
  [293004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13414), 1,
      anon_sym_RPAREN,
  [293011] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13416), 1,
      sym_raw_string_delimiter,
  [293018] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13418), 1,
      anon_sym_RPAREN,
  [293025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13420), 1,
      anon_sym_RPAREN,
  [293032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13422), 1,
      anon_sym_RPAREN,
  [293039] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13424), 1,
      sym_identifier,
  [293046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10667), 1,
      anon_sym_RPAREN,
  [293053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8701), 1,
      anon_sym_SEMI,
  [293060] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(13426), 1,
      aux_sym_preproc_include_token2,
  [293067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10736), 1,
      anon_sym_RPAREN,
  [293074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8711), 1,
      anon_sym_SEMI,
  [293081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13428), 1,
      sym_raw_string_delimiter,
  [293088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13430), 1,
      anon_sym_COLON,
  [293095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13432), 1,
      anon_sym_RPAREN,
  [293102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13434), 1,
      anon_sym_SEMI,
  [293109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13436), 1,
      sym_identifier,
  [293116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      anon_sym_SEMI,
  [293123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13438), 1,
      anon_sym_SEMI,
  [293130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13440), 1,
      anon_sym_SEMI,
  [293137] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13442), 1,
      sym_identifier,
  [293144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13444), 1,
      anon_sym_SEMI,
  [293151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8656), 1,
      anon_sym_RPAREN,
  [293158] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11956), 1,
      anon_sym_SEMI,
  [293165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13446), 1,
      sym_identifier,
  [293172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13448), 1,
      sym_identifier,
  [293179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13450), 1,
      sym_identifier,
  [293186] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_DASH,
  [293193] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13452), 1,
      anon_sym_STAR,
  [293200] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13454), 1,
      anon_sym_COLON,
  [293207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8518), 1,
      anon_sym_RPAREN,
  [293214] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13456), 1,
      anon_sym_STAR,
  [293221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13458), 1,
      aux_sym_preproc_if_token2,
  [293228] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7549), 1,
      sym_identifier,
  [293235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13460), 1,
      anon_sym_SEMI,
  [293242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4721), 1,
      anon_sym_SEMI,
  [293249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13462), 1,
      anon_sym_SEMI,
  [293256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13464), 1,
      anon_sym_SEMI,
  [293263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13466), 1,
      sym_auto,
  [293270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11157), 1,
      anon_sym_SEMI,
  [293277] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13468), 1,
      sym_identifier,
  [293284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13470), 1,
      anon_sym_RPAREN,
  [293291] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8674), 1,
      anon_sym_COLON,
  [293298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8688), 1,
      anon_sym_SEMI,
  [293305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8741), 1,
      anon_sym_COLON,
  [293312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13472), 1,
      anon_sym_RPAREN,
  [293319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13474), 1,
      anon_sym_LPAREN2,
  [293326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_EQ_EQ,
  [293333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13476), 1,
      sym_identifier,
  [293340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8697), 1,
      anon_sym_COLON,
  [293347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13478), 1,
      sym_identifier,
  [293354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13480), 1,
      anon_sym_RPAREN,
  [293361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13482), 1,
      anon_sym_SEMI,
  [293368] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13484), 1,
      anon_sym_SEMI,
  [293375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13486), 1,
      sym_identifier,
  [293382] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13488), 1,
      anon_sym_RPAREN,
  [293389] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(13490), 1,
      aux_sym_preproc_include_token2,
  [293396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10645), 1,
      anon_sym_RPAREN,
  [293403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13492), 1,
      anon_sym_LPAREN2,
  [293410] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13494), 1,
      sym_raw_string_delimiter,
  [293417] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13496), 1,
      anon_sym_RPAREN,
  [293424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13498), 1,
      anon_sym_STAR,
  [293431] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13500), 1,
      anon_sym_LBRACE,
  [293438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_STAR,
  [293445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13502), 1,
      anon_sym_RPAREN,
  [293452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12978), 1,
      anon_sym_RBRACE,
  [293459] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13504), 1,
      anon_sym_while,
  [293466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13506), 1,
      anon_sym_SEMI,
  [293473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13508), 1,
      anon_sym_RPAREN,
  [293480] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13510), 1,
      sym_identifier,
  [293487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13512), 1,
      sym_identifier,
  [293494] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13514), 1,
      anon_sym_RPAREN,
  [293501] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13516), 1,
      anon_sym_RPAREN,
  [293508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10693), 1,
      anon_sym_RPAREN,
  [293515] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13518), 1,
      anon_sym_RPAREN,
  [293522] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13520), 1,
      sym_raw_string_delimiter,
  [293529] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13522), 1,
      anon_sym_RPAREN,
  [293536] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13524), 1,
      sym_identifier,
  [293543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13526), 1,
      sym_identifier,
  [293550] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8693), 1,
      anon_sym_SEMI,
  [293557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13528), 1,
      anon_sym_SEMI,
  [293564] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13530), 1,
      anon_sym_SEMI,
  [293571] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13532), 1,
      anon_sym_SEMI,
  [293578] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13534), 1,
      anon_sym_RPAREN,
  [293585] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13536), 1,
      anon_sym_STAR,
  [293592] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13538), 1,
      sym_auto,
  [293599] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13540), 1,
      anon_sym_SLASH,
  [293606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13542), 1,
      anon_sym_DQUOTE,
  [293613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13544), 1,
      anon_sym_DQUOTE,
  [293620] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13546), 1,
      anon_sym_SEMI,
  [293627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13548), 1,
      anon_sym_LPAREN2,
  [293634] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13550), 1,
      sym_identifier,
  [293641] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13552), 1,
      anon_sym_COMMA,
  [293648] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13554), 1,
      anon_sym_SEMI,
  [293655] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13556), 1,
      anon_sym_SEMI,
  [293662] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13558), 1,
      anon_sym_RPAREN,
  [293669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13560), 1,
      anon_sym_RPAREN,
  [293676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13562), 1,
      anon_sym_SEMI,
  [293683] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13564), 1,
      anon_sym_LPAREN2,
  [293690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13566), 1,
      anon_sym_SEMI,
  [293697] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13568), 1,
      anon_sym_DQUOTE,
  [293704] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13570), 1,
      anon_sym_RPAREN,
  [293711] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13572), 1,
      anon_sym_LPAREN2,
  [293718] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13574), 1,
      anon_sym_RPAREN,
  [293725] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13576), 1,
      sym_identifier,
  [293732] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13578), 1,
      anon_sym_RPAREN,
  [293739] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13580), 1,
      anon_sym_RPAREN,
  [293746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13582), 1,
      sym_identifier,
  [293753] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13584), 1,
      anon_sym_LPAREN2,
  [293760] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13586), 1,
      anon_sym_LPAREN2,
  [293767] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13588), 1,
      anon_sym_RPAREN,
  [293774] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13590), 1,
      anon_sym_SEMI,
  [293781] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13592), 1,
      anon_sym_RPAREN,
  [293788] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_PERCENT,
  [293795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12952), 1,
      anon_sym_RBRACE,
  [293802] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13594), 1,
      aux_sym_preproc_if_token2,
  [293809] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13596), 1,
      anon_sym_STAR,
  [293816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_PIPE_PIPE,
  [293823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13598), 1,
      aux_sym_preproc_if_token2,
  [293830] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13600), 1,
      sym_identifier,
  [293837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13602), 1,
      aux_sym_preproc_if_token2,
  [293844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13604), 1,
      aux_sym_preproc_if_token2,
  [293851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10635), 1,
      anon_sym_RPAREN,
  [293858] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13606), 1,
      anon_sym_RPAREN,
  [293865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13608), 1,
      sym_raw_string_delimiter,
  [293872] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13610), 1,
      anon_sym_RPAREN,
  [293879] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13612), 1,
      sym_identifier,
  [293886] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13614), 1,
      anon_sym_SEMI,
  [293893] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13616), 1,
      anon_sym_SEMI,
  [293900] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_PIPE,
  [293907] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_CARET,
  [293914] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(9876), 1,
      aux_sym_preproc_include_token2,
  [293921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13618), 1,
      aux_sym_preproc_if_token2,
  [293928] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13620), 1,
      sym_identifier,
  [293935] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10365), 1,
      sym_identifier,
  [293942] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(13622), 1,
      aux_sym_preproc_include_token2,
  [293949] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(13624), 1,
      aux_sym_preproc_include_token2,
  [293956] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13626), 1,
      anon_sym_RPAREN,
  [293963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13628), 1,
      anon_sym_RPAREN,
  [293970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13630), 1,
      aux_sym_preproc_if_token2,
  [293977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13632), 1,
      anon_sym_RPAREN,
  [293984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8757), 1,
      anon_sym_SEMI,
  [293991] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13634), 1,
      anon_sym_LPAREN2,
  [293998] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6973), 1,
      anon_sym_RPAREN,
  [294005] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(12800), 1,
      aux_sym_preproc_include_token2,
  [294012] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13636), 1,
      anon_sym_RPAREN,
  [294019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13638), 1,
      sym_identifier,
  [294026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13640), 1,
      anon_sym_DQUOTE,
  [294033] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13642), 1,
      anon_sym_RPAREN,
  [294040] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13644), 1,
      aux_sym_preproc_if_token2,
  [294047] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13646), 1,
      aux_sym_preproc_if_token2,
  [294054] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13648), 1,
      anon_sym_RPAREN,
  [294061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13650), 1,
      anon_sym_RPAREN,
  [294068] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13652), 1,
      anon_sym_RPAREN,
  [294075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13654), 1,
      anon_sym_SEMI,
  [294082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13656), 1,
      anon_sym_STAR,
  [294089] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13658), 1,
      anon_sym_SEMI,
  [294096] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13660), 1,
      anon_sym_SEMI,
  [294103] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6994), 1,
      anon_sym_RPAREN,
  [294110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_AMP,
  [294117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13662), 1,
      sym_identifier,
  [294124] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13664), 1,
      anon_sym_RPAREN,
  [294131] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13666), 1,
      anon_sym_RPAREN,
  [294138] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10697), 1,
      anon_sym_RPAREN,
  [294145] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13668), 1,
      sym_identifier,
  [294152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13670), 1,
      sym_raw_string_delimiter,
  [294159] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13672), 1,
      anon_sym_RPAREN,
  [294166] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13674), 1,
      anon_sym_RPAREN,
  [294173] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13676), 1,
      anon_sym_RPAREN,
  [294180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13678), 1,
      anon_sym_RPAREN,
  [294187] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13680), 1,
      aux_sym_preproc_if_token2,
  [294194] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13682), 1,
      sym_identifier,
  [294201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13684), 1,
      aux_sym_preproc_if_token2,
  [294208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_BANG_EQ,
  [294215] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_AMP_AMP,
  [294222] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13686), 1,
      anon_sym_LPAREN2,
  [294229] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13688), 1,
      sym_identifier,
  [294236] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(12815), 1,
      aux_sym_preproc_include_token2,
  [294243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13690), 1,
      sym_identifier,
  [294250] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13692), 1,
      sym_identifier,
  [294257] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13694), 1,
      sym_identifier,
  [294264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13696), 1,
      anon_sym_RPAREN,
  [294271] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13698), 1,
      anon_sym_RPAREN,
  [294278] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13700), 1,
      anon_sym_SEMI,
  [294285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13702), 1,
      sym_identifier,
  [294292] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      sym_identifier,
  [294299] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11174), 1,
      anon_sym_SEMI,
  [294306] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13704), 1,
      sym_raw_string_delimiter,
  [294313] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13706), 1,
      anon_sym_SEMI,
  [294320] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13708), 1,
      anon_sym_DQUOTE,
  [294327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13710), 1,
      anon_sym_DQUOTE,
  [294334] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13712), 1,
      anon_sym_RBRACE,
  [294341] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13714), 1,
      anon_sym_DQUOTE,
  [294348] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12900), 1,
      anon_sym_RBRACE,
  [294355] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13716), 1,
      anon_sym_DQUOTE,
  [294362] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13718), 1,
      anon_sym_LPAREN2,
  [294369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13720), 1,
      anon_sym_DQUOTE,
  [294376] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13722), 1,
      anon_sym_DQUOTE,
  [294383] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(13724), 1,
      aux_sym_preproc_include_token2,
  [294390] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13726), 1,
      sym_identifier,
  [294397] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13728), 1,
      anon_sym_RPAREN,
  [294404] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13730), 1,
      anon_sym_RPAREN,
  [294411] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13732), 1,
      aux_sym_preproc_if_token2,
  [294418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13734), 1,
      sym_raw_string_delimiter,
  [294425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13736), 1,
      anon_sym_DQUOTE,
  [294432] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13738), 1,
      anon_sym_SEMI,
  [294439] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11228), 1,
      anon_sym_COMMA,
  [294446] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13740), 1,
      anon_sym_LPAREN2,
  [294453] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13742), 1,
      anon_sym_RPAREN,
  [294460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13744), 1,
      sym_identifier,
  [294467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13746), 1,
      sym_raw_string_delimiter,
  [294474] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13748), 1,
      anon_sym_SEMI,
  [294481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13750), 1,
      anon_sym_SEMI,
  [294488] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(13752), 1,
      aux_sym_preproc_include_token2,
  [294495] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13754), 1,
      anon_sym_LPAREN2,
  [294502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13756), 1,
      anon_sym_RPAREN,
  [294509] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13758), 1,
      sym_raw_string_delimiter,
  [294516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12362), 1,
      anon_sym_COLON_COLON,
  [294523] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13760), 1,
      anon_sym_DQUOTE,
  [294530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13762), 1,
      anon_sym_RBRACE,
  [294537] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13764), 1,
      anon_sym_LPAREN2,
  [294544] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13766), 1,
      anon_sym_RPAREN,
  [294551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13768), 1,
      sym_raw_string_delimiter,
  [294558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13770), 1,
      anon_sym_DQUOTE,
  [294565] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13772), 1,
      anon_sym_RPAREN,
  [294572] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13774), 1,
      sym_raw_string_delimiter,
  [294579] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8616), 1,
      anon_sym_RBRACE,
  [294586] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13776), 1,
      anon_sym_RPAREN,
  [294593] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13778), 1,
      sym_raw_string_delimiter,
  [294600] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13780), 1,
      anon_sym_RPAREN,
  [294607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13782), 1,
      sym_raw_string_delimiter,
  [294614] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13784), 1,
      anon_sym_RPAREN,
  [294621] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13786), 1,
      sym_raw_string_delimiter,
  [294628] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13788), 1,
      anon_sym_RPAREN,
  [294635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13790), 1,
      sym_raw_string_delimiter,
  [294642] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13792), 1,
      anon_sym_RPAREN,
  [294649] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13794), 1,
      sym_raw_string_delimiter,
  [294656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13796), 1,
      anon_sym_RPAREN,
  [294663] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13798), 1,
      sym_raw_string_delimiter,
  [294670] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13800), 1,
      anon_sym_RPAREN,
  [294677] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13802), 1,
      sym_raw_string_delimiter,
  [294684] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13804), 1,
      anon_sym_RPAREN,
  [294691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13806), 1,
      sym_raw_string_delimiter,
  [294698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13808), 1,
      aux_sym_preproc_if_token2,
  [294705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10695), 1,
      anon_sym_RBRACE,
  [294712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13810), 1,
      aux_sym_preproc_if_token2,
  [294719] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13812), 1,
      anon_sym_LPAREN2,
  [294726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13814), 1,
      anon_sym_RPAREN,
  [294733] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13816), 1,
      anon_sym_LPAREN2,
  [294740] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13818), 1,
      anon_sym_LPAREN2,
  [294747] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13820), 1,
      anon_sym_LPAREN2,
  [294754] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13822), 1,
      aux_sym_preproc_if_token2,
  [294761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_GT_EQ,
  [294768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13824), 1,
      anon_sym_LPAREN2,
  [294775] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(13826), 1,
      aux_sym_preproc_include_token2,
  [294782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13828), 1,
      anon_sym_LPAREN2,
  [294789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13830), 1,
      anon_sym_RPAREN,
  [294796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13832), 1,
      anon_sym_RPAREN,
  [294803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13834), 1,
      anon_sym_LPAREN2,
  [294810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13836), 1,
      anon_sym_DQUOTE,
  [294817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13838), 1,
      anon_sym_RPAREN,
  [294824] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13840), 1,
      anon_sym_DQUOTE,
  [294831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8749), 1,
      anon_sym_COLON,
  [294838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13842), 1,
      anon_sym_RPAREN,
  [294845] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13844), 1,
      anon_sym_SEMI,
  [294852] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11114), 1,
      anon_sym_SEMI,
  [294859] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13846), 1,
      anon_sym_EQ,
  [294866] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13848), 1,
      anon_sym_RPAREN,
  [294873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13850), 1,
      aux_sym_preproc_if_token2,
  [294880] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13852), 1,
      sym_identifier,
  [294887] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13854), 1,
      anon_sym_RPAREN,
  [294894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13856), 1,
      anon_sym_while,
  [294901] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5183), 1,
      anon_sym_COLON_COLON,
  [294908] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13858), 1,
      anon_sym_LPAREN2,
  [294915] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8909), 1,
      anon_sym_RPAREN,
  [294922] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8462), 1,
      anon_sym_RBRACE,
  [294929] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11651), 1,
      anon_sym_SEMI,
  [294936] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13860), 1,
      anon_sym_DQUOTE,
  [294943] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13862), 1,
      anon_sym_EQ,
  [294950] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13864), 1,
      sym_raw_string_content,
  [294957] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10701), 1,
      anon_sym_RBRACE,
  [294964] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13866), 1,
      sym_auto,
  [294971] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13868), 1,
      anon_sym_DQUOTE,
  [294978] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13870), 1,
      anon_sym_STAR,
  [294985] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13872), 1,
      anon_sym_SEMI,
  [294992] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13874), 1,
      anon_sym_SEMI,
  [294999] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13876), 1,
      anon_sym_SEMI,
  [295006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13878), 1,
      anon_sym_SEMI,
  [295013] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4597), 1,
      anon_sym_SEMI,
  [295020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13880), 1,
      anon_sym_SEMI,
  [295027] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13882), 1,
      anon_sym_SEMI,
  [295034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4543), 1,
      anon_sym_SEMI,
  [295041] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13884), 1,
      anon_sym_SEMI,
  [295048] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13886), 1,
      sym_identifier,
  [295055] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13888), 1,
      anon_sym_COMMA,
  [295062] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13890), 1,
      anon_sym_LPAREN2,
  [295069] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13892), 1,
      sym_auto,
  [295076] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(13894), 1,
      aux_sym_preproc_include_token2,
  [295083] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8779), 1,
      anon_sym_COLON,
  [295090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8686), 1,
      anon_sym_COLON,
  [295097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13896), 1,
      anon_sym_DQUOTE,
  [295104] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13898), 1,
      anon_sym_COLON,
  [295111] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13900), 1,
      anon_sym_DQUOTE,
  [295118] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(13902), 1,
      aux_sym_preproc_include_token2,
  [295125] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11633), 1,
      anon_sym_SEMI,
  [295132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13904), 1,
      anon_sym_SEMI,
  [295139] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13906), 1,
      anon_sym_RPAREN,
  [295146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8771), 1,
      anon_sym_SEMI,
  [295153] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13908), 1,
      anon_sym_SEMI,
  [295160] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13910), 1,
      anon_sym_RPAREN,
  [295167] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13912), 1,
      anon_sym_DOT_DOT_DOT,
  [295174] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13914), 1,
      anon_sym_DQUOTE,
  [295181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13916), 1,
      anon_sym_SEMI,
  [295188] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13918), 1,
      anon_sym_RPAREN,
  [295195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13920), 1,
      anon_sym_COLON,
  [295202] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13922), 1,
      anon_sym_SEMI,
  [295209] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13924), 1,
      anon_sym_DQUOTE,
  [295216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13926), 1,
      anon_sym_SEMI,
  [295223] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12954), 1,
      anon_sym_RBRACE,
  [295230] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13928), 1,
      anon_sym_RPAREN,
  [295237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13930), 1,
      anon_sym_RPAREN,
  [295244] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13932), 1,
      anon_sym_RPAREN,
  [295251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12333), 1,
      anon_sym_RPAREN,
  [295258] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8735), 1,
      anon_sym_RPAREN,
  [295265] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8723), 1,
      anon_sym_RPAREN,
  [295272] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8925), 1,
      anon_sym_RPAREN,
  [295279] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13934), 1,
      anon_sym_RPAREN,
  [295286] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10659), 1,
      anon_sym_RBRACE,
  [295293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7488), 1,
      sym_identifier,
  [295300] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13936), 1,
      anon_sym_DQUOTE,
  [295307] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13938), 1,
      anon_sym_RPAREN,
  [295314] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8434), 1,
      anon_sym_RBRACE,
  [295321] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8889), 1,
      anon_sym_RPAREN,
  [295328] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13940), 1,
      anon_sym_DQUOTE,
  [295335] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13942), 1,
      anon_sym_SEMI,
  [295342] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8662), 1,
      anon_sym_RPAREN,
  [295349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13944), 1,
      anon_sym_SEMI,
  [295356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13946), 1,
      anon_sym_RBRACK,
  [295363] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13948), 1,
      anon_sym_DQUOTE,
  [295370] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_LT_EQ,
  [295377] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13950), 1,
      anon_sym_RPAREN,
  [295384] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13952), 1,
      anon_sym_RPAREN,
  [295391] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13954), 1,
      anon_sym_RPAREN,
  [295398] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13956), 1,
      sym_identifier,
  [295405] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13958), 1,
      sym_identifier,
  [295412] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13960), 1,
      anon_sym_RPAREN,
  [295419] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_LPAREN2,
  [295426] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11673), 1,
      anon_sym_SEMI,
  [295433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11110), 1,
      anon_sym_SEMI,
  [295440] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13964), 1,
      anon_sym_DOT_DOT_DOT,
  [295447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_LT,
  [295454] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13967), 1,
      aux_sym_preproc_if_token2,
  [295461] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13969), 1,
      anon_sym_DQUOTE,
  [295468] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13971), 1,
      anon_sym_RPAREN,
  [295475] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13973), 1,
      anon_sym_DQUOTE,
  [295482] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(13975), 1,
      aux_sym_preproc_include_token2,
  [295489] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12968), 1,
      anon_sym_RBRACE,
  [295496] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13977), 1,
      anon_sym_SEMI,
  [295503] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13979), 1,
      anon_sym_DQUOTE,
  [295510] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13981), 1,
      sym_auto,
  [295517] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12595), 1,
      anon_sym_SEMI,
  [295524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13983), 1,
      anon_sym_STAR,
  [295531] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13985), 1,
      anon_sym_RPAREN,
  [295538] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13987), 1,
      anon_sym_SEMI,
  [295545] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10699), 1,
      anon_sym_RBRACE,
  [295552] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13989), 1,
      anon_sym_SEMI,
  [295559] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13991), 1,
      anon_sym_SEMI,
  [295566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13993), 1,
      anon_sym_RPAREN,
  [295573] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13995), 1,
      anon_sym_SEMI,
  [295580] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13997), 1,
      anon_sym_SEMI,
  [295587] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13999), 1,
      anon_sym_DQUOTE,
  [295594] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14001), 1,
      aux_sym_preproc_if_token2,
  [295601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_LT_LT,
  [295608] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14003), 1,
      anon_sym_DQUOTE,
  [295615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14005), 1,
      anon_sym_RPAREN,
  [295622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14007), 1,
      anon_sym_RPAREN,
  [295629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14009), 1,
      anon_sym_SEMI,
  [295636] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_GT_GT,
  [295643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14011), 1,
      anon_sym_SEMI,
  [295650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14013), 1,
      anon_sym_RBRACE,
  [295657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8658), 1,
      anon_sym_COLON,
  [295664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14015), 1,
      aux_sym_preproc_if_token2,
  [295671] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14017), 1,
      anon_sym_RBRACE,
  [295678] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14019), 1,
      aux_sym_preproc_if_token2,
  [295685] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11133), 1,
      anon_sym_SEMI,
  [295692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14021), 1,
      aux_sym_preproc_if_token2,
  [295699] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14023), 1,
      aux_sym_preproc_if_token2,
  [295706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14025), 1,
      aux_sym_preproc_if_token2,
  [295713] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14027), 1,
      sym_identifier,
  [295720] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6226), 1,
      sym_identifier,
  [295727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14029), 1,
      anon_sym_SEMI,
  [295734] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_EQ,
  [295741] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14031), 1,
      sym_raw_string_content,
  [295748] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12976), 1,
      anon_sym_RBRACE,
  [295755] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8839), 1,
      anon_sym_RPAREN,
  [295762] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_GT_GT_EQ,
  [295769] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14033), 1,
      anon_sym_SEMI,
  [295776] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14035), 1,
      aux_sym_preproc_if_token2,
  [295783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8695), 1,
      anon_sym_SEMI,
  [295790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10705), 1,
      anon_sym_RBRACE,
  [295797] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14037), 1,
      anon_sym_RBRACE,
  [295804] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14039), 1,
      anon_sym_DQUOTE,
  [295811] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12980), 1,
      anon_sym_RBRACE,
  [295818] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14041), 1,
      sym_auto,
  [295825] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14043), 1,
      aux_sym_preproc_if_token2,
  [295832] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8660), 1,
      anon_sym_RPAREN,
  [295839] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(14045), 1,
      aux_sym_preproc_include_token2,
  [295846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_STAR_EQ,
  [295853] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14047), 1,
      anon_sym_RPAREN,
  [295860] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14049), 1,
      anon_sym_RPAREN,
  [295867] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14051), 1,
      aux_sym_preproc_if_token2,
  [295874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14053), 1,
      anon_sym_RPAREN,
  [295881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14055), 1,
      anon_sym_RPAREN,
  [295888] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14057), 1,
      anon_sym_SEMI,
  [295895] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8699), 1,
      anon_sym_SEMI,
  [295902] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14059), 1,
      aux_sym_preproc_if_token2,
  [295909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14061), 1,
      anon_sym_SEMI,
  [295916] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14063), 1,
      anon_sym_SEMI,
  [295923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14065), 1,
      anon_sym_RPAREN,
  [295930] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10734), 1,
      anon_sym_RBRACE,
  [295937] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14067), 1,
      anon_sym_SEMI,
  [295944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11785), 1,
      anon_sym_SEMI,
  [295951] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14069), 1,
      anon_sym_SEMI,
  [295958] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14071), 1,
      sym_identifier,
  [295965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14073), 1,
      anon_sym_RPAREN,
  [295972] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14075), 1,
      anon_sym_RPAREN,
  [295979] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14077), 1,
      anon_sym_RPAREN,
  [295986] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14079), 1,
      anon_sym_RPAREN,
  [295993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14081), 1,
      anon_sym_RPAREN,
  [296000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14083), 1,
      anon_sym_SEMI,
  [296007] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14085), 1,
      anon_sym_RPAREN,
  [296014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6988), 1,
      anon_sym_RPAREN,
  [296021] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_SLASH_EQ,
  [296028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14087), 1,
      anon_sym_LPAREN2,
  [296035] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14089), 1,
      anon_sym_STAR,
  [296042] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(14091), 1,
      aux_sym_preproc_include_token2,
  [296049] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14093), 1,
      aux_sym_preproc_if_token2,
  [296056] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(12430), 1,
      aux_sym_preproc_include_token2,
  [296063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14095), 1,
      anon_sym_RPAREN,
  [296070] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_PERCENT_EQ,
  [296077] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14097), 1,
      anon_sym_STAR,
  [296084] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14099), 1,
      aux_sym_preproc_if_token2,
  [296091] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14101), 1,
      sym_raw_string_content,
  [296098] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14103), 1,
      anon_sym_RPAREN,
  [296105] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(14105), 1,
      aux_sym_preproc_include_token2,
  [296112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14107), 1,
      ts_builtin_sym_end,
  [296119] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8949), 1,
      anon_sym_RPAREN,
  [296126] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14109), 1,
      anon_sym_LPAREN2,
  [296133] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(14111), 1,
      aux_sym_preproc_include_token2,
  [296140] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14113), 1,
      anon_sym_LPAREN2,
  [296147] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14115), 1,
      anon_sym_LPAREN2,
  [296154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14117), 1,
      anon_sym_LPAREN2,
  [296161] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14119), 1,
      anon_sym_RPAREN,
  [296168] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14121), 1,
      anon_sym_LPAREN2,
  [296175] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14123), 1,
      anon_sym_RPAREN,
  [296182] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14125), 1,
      anon_sym_LPAREN2,
  [296189] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14127), 1,
      anon_sym_RPAREN,
  [296196] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14129), 1,
      anon_sym_RPAREN,
  [296203] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14131), 1,
      sym_identifier,
  [296210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14133), 1,
      anon_sym_RPAREN,
  [296217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14135), 1,
      sym_identifier,
  [296224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14137), 1,
      aux_sym_preproc_if_token2,
  [296231] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14139), 1,
      anon_sym_RPAREN,
  [296238] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14141), 1,
      anon_sym_while,
  [296245] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14143), 1,
      anon_sym_LPAREN2,
  [296252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14145), 1,
      anon_sym_LPAREN2,
  [296259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14147), 1,
      anon_sym_RPAREN,
  [296266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14149), 1,
      anon_sym_SEMI,
  [296273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14151), 1,
      anon_sym_SEMI,
  [296280] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14153), 1,
      anon_sym_RPAREN,
  [296287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14155), 1,
      anon_sym_EQ,
  [296294] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14157), 1,
      sym_raw_string_content,
  [296301] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14159), 1,
      anon_sym_RBRACK,
  [296308] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14161), 1,
      anon_sym_STAR,
  [296315] = 2,
    ACTIONS(5502), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(9740), 1,
      sym_comment,
  [296322] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14163), 1,
      anon_sym_LBRACE,
  [296329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14165), 1,
      anon_sym_COMMA,
  [296336] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14167), 1,
      anon_sym_COLON,
  [296343] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13018), 1,
      anon_sym_RBRACE,
  [296350] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8763), 1,
      anon_sym_COLON,
  [296357] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14169), 1,
      anon_sym_SEMI,
  [296364] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14171), 1,
      anon_sym_SEMI,
  [296371] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14173), 1,
      anon_sym_RPAREN,
  [296378] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14175), 1,
      anon_sym_COLON,
  [296385] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14177), 1,
      anon_sym_RPAREN,
  [296392] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_DASH_GT_STAR,
  [296399] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14179), 1,
      anon_sym_LPAREN2,
  [296406] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14181), 1,
      anon_sym_LPAREN2,
  [296413] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14183), 1,
      anon_sym_LPAREN2,
  [296420] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14185), 1,
      anon_sym_DQUOTE,
  [296427] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14187), 1,
      anon_sym_LPAREN2,
  [296434] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14189), 1,
      anon_sym_RPAREN,
  [296441] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(14191), 1,
      aux_sym_preproc_include_token2,
  [296448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14193), 1,
      anon_sym_while,
  [296455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14195), 1,
      anon_sym_LPAREN2,
  [296462] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14197), 1,
      anon_sym_LPAREN2,
  [296469] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14199), 1,
      anon_sym_DQUOTE,
  [296476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14201), 1,
      anon_sym_SEMI,
  [296483] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14203), 1,
      anon_sym_LPAREN2,
  [296490] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14205), 1,
      anon_sym_EQ,
  [296497] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14207), 1,
      sym_raw_string_content,
  [296504] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14209), 1,
      anon_sym_COMMA,
  [296511] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14211), 1,
      anon_sym_RPAREN,
  [296518] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14213), 1,
      anon_sym_SEMI,
  [296525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12970), 1,
      anon_sym_RBRACE,
  [296532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14215), 1,
      anon_sym_RPAREN,
  [296539] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14217), 1,
      anon_sym_COLON,
  [296546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14219), 1,
      anon_sym_SEMI,
  [296553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14221), 1,
      anon_sym_LPAREN2,
  [296560] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14223), 1,
      anon_sym_LPAREN2,
  [296567] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14225), 1,
      anon_sym_LPAREN2,
  [296574] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8492), 1,
      anon_sym_RBRACE,
  [296581] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14227), 1,
      anon_sym_LPAREN2,
  [296588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8727), 1,
      anon_sym_COLON,
  [296595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14229), 1,
      anon_sym_RPAREN,
  [296602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14231), 1,
      anon_sym_while,
  [296609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14233), 1,
      anon_sym_LPAREN2,
  [296616] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14235), 1,
      sym_auto,
  [296623] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_PLUS_EQ,
  [296630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14237), 1,
      anon_sym_EQ,
  [296637] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14239), 1,
      sym_raw_string_content,
  [296644] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14241), 1,
      anon_sym_COMMA,
  [296651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_DOT_STAR,
  [296658] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14243), 1,
      anon_sym_RPAREN,
  [296665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14245), 1,
      anon_sym_RPAREN,
  [296672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14247), 1,
      anon_sym_RPAREN,
  [296679] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14249), 1,
      anon_sym_COLON,
  [296686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14251), 1,
      anon_sym_RPAREN,
  [296693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14253), 1,
      anon_sym_LPAREN2,
  [296700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14255), 1,
      anon_sym_LPAREN2,
  [296707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14257), 1,
      anon_sym_LPAREN2,
  [296714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14259), 1,
      anon_sym_SEMI,
  [296721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14261), 1,
      anon_sym_LPAREN2,
  [296728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14263), 1,
      anon_sym_RBRACE,
  [296735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14265), 1,
      aux_sym_preproc_if_token2,
  [296742] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14267), 1,
      anon_sym_LPAREN2,
  [296749] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14269), 1,
      anon_sym_SEMI,
  [296756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      aux_sym_preproc_if_token2,
  [296763] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14273), 1,
      anon_sym_EQ,
  [296770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14275), 1,
      sym_raw_string_content,
  [296777] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14277), 1,
      anon_sym_COMMA,
  [296784] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14279), 1,
      anon_sym_SEMI,
  [296791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14281), 1,
      anon_sym_DQUOTE,
  [296798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10709), 1,
      anon_sym_RBRACE,
  [296805] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14283), 1,
      anon_sym_RPAREN,
  [296812] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14285), 1,
      anon_sym_COLON,
  [296819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14287), 1,
      anon_sym_RPAREN,
  [296826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14289), 1,
      anon_sym_LPAREN2,
  [296833] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14291), 1,
      anon_sym_LPAREN2,
  [296840] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14293), 1,
      anon_sym_RPAREN,
  [296847] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14295), 1,
      anon_sym_LPAREN2,
  [296854] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14297), 1,
      anon_sym_RPAREN,
  [296861] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14299), 1,
      aux_sym_preproc_if_token2,
  [296868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14301), 1,
      anon_sym_LPAREN2,
  [296875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14303), 1,
      anon_sym_RPAREN,
  [296882] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14305), 1,
      anon_sym_RPAREN,
  [296889] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14307), 1,
      anon_sym_EQ,
  [296896] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14309), 1,
      sym_raw_string_content,
  [296903] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14311), 1,
      anon_sym_COMMA,
  [296910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8835), 1,
      anon_sym_RPAREN,
  [296917] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14313), 1,
      aux_sym_preproc_if_token2,
  [296924] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_LT_LT_EQ,
  [296931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14315), 1,
      anon_sym_RPAREN,
  [296938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14317), 1,
      anon_sym_COLON,
  [296945] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14319), 1,
      aux_sym_preproc_if_token2,
  [296952] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14321), 1,
      anon_sym_LPAREN2,
  [296959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14323), 1,
      anon_sym_LPAREN2,
  [296966] = 2,
    ACTIONS(9740), 1,
      sym_comment,
    ACTIONS(9864), 1,
      aux_sym_preproc_include_token2,
  [296973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14325), 1,
      anon_sym_LPAREN2,
  [296980] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14327), 1,
      sym_auto,
  [296987] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14329), 1,
      anon_sym_LPAREN2,
  [296994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14331), 1,
      anon_sym_RPAREN,
  [297001] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14333), 1,
      sym_raw_string_content,
  [297008] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14335), 1,
      anon_sym_COMMA,
  [297015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8743), 1,
      anon_sym_COLON,
  [297022] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14337), 1,
      anon_sym_SEMI,
  [297029] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14339), 1,
      anon_sym_RPAREN,
  [297036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14341), 1,
      anon_sym_COLON,
  [297043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14343), 1,
      anon_sym_SEMI,
  [297050] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14345), 1,
      anon_sym_LPAREN2,
  [297057] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8502), 1,
      anon_sym_RBRACE,
  [297064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14347), 1,
      anon_sym_LPAREN2,
  [297071] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14349), 1,
      anon_sym_RPAREN,
  [297078] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14351), 1,
      anon_sym_SEMI,
  [297085] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14353), 1,
      sym_raw_string_content,
  [297092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14355), 1,
      anon_sym_SEMI,
  [297099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14357), 1,
      anon_sym_RPAREN,
  [297106] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14359), 1,
      anon_sym_LPAREN2,
  [297113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14361), 1,
      anon_sym_LPAREN2,
  [297120] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14363), 1,
      sym_raw_string_content,
  [297127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14365), 1,
      anon_sym_RPAREN,
  [297134] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14367), 1,
      anon_sym_LPAREN2,
  [297141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14369), 1,
      anon_sym_LPAREN2,
  [297148] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14371), 1,
      sym_raw_string_content,
  [297155] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14373), 1,
      anon_sym_RPAREN,
  [297162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14375), 1,
      anon_sym_LPAREN2,
  [297169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14377), 1,
      anon_sym_LPAREN2,
  [297176] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14379), 1,
      sym_raw_string_content,
  [297183] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14381), 1,
      anon_sym_RPAREN,
  [297190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14383), 1,
      sym_raw_string_content,
  [297197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14385), 1,
      anon_sym_RPAREN,
  [297204] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14387), 1,
      sym_raw_string_content,
  [297211] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14389), 1,
      anon_sym_RPAREN,
  [297218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14391), 1,
      sym_raw_string_content,
  [297225] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14393), 1,
      anon_sym_RPAREN,
  [297232] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14395), 1,
      sym_raw_string_content,
  [297239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14397), 1,
      anon_sym_RPAREN,
  [297246] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14399), 1,
      sym_raw_string_content,
  [297253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14401), 1,
      anon_sym_RPAREN,
  [297260] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14403), 1,
      sym_raw_string_content,
  [297267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14405), 1,
      anon_sym_RPAREN,
  [297274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14407), 1,
      sym_raw_string_content,
  [297281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14409), 1,
      anon_sym_RPAREN,
  [297288] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14411), 1,
      sym_raw_string_content,
  [297295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14413), 1,
      anon_sym_RPAREN,
  [297302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14415), 1,
      sym_raw_string_content,
  [297309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14417), 1,
      anon_sym_RPAREN,
  [297316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14419), 1,
      aux_sym_preproc_if_token2,
  [297323] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14421), 1,
      aux_sym_preproc_if_token2,
  [297330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14423), 1,
      anon_sym_LPAREN2,
  [297337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14425), 1,
      anon_sym_LPAREN2,
  [297344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14427), 1,
      sym_identifier,
  [297351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14429), 1,
      anon_sym_RPAREN,
  [297358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14431), 1,
      anon_sym_SEMI,
  [297365] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14433), 1,
      anon_sym_SEMI,
  [297372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14435), 1,
      aux_sym_preproc_if_token2,
  [297379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14437), 1,
      anon_sym_RPAREN,
  [297386] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14439), 1,
      anon_sym_RPAREN,
  [297393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14441), 1,
      anon_sym_DQUOTE,
  [297400] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14443), 1,
      anon_sym_RPAREN,
  [297407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10647), 1,
      anon_sym_RBRACE,
  [297414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14445), 1,
      sym_identifier,
  [297421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14447), 1,
      sym_raw_string_content,
  [297428] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14449), 1,
      anon_sym_STAR,
  [297435] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13060), 1,
      anon_sym_RBRACE,
  [297442] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14451), 1,
      anon_sym_LPAREN2,
  [297449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14453), 1,
      anon_sym_LPAREN2,
  [297456] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14455), 1,
      anon_sym_LPAREN2,
  [297463] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14457), 1,
      sym_identifier,
  [297470] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14459), 1,
      anon_sym_SEMI,
  [297477] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14461), 1,
      anon_sym_SEMI,
  [297484] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14463), 1,
      anon_sym_LPAREN2,
  [297491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14465), 1,
      anon_sym_RPAREN,
  [297498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14467), 1,
      anon_sym_COLON,
  [297505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_not_eq,
  [297512] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14469), 1,
      anon_sym_COLON,
  [297519] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14471), 1,
      anon_sym_SEMI,
  [297526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14473), 1,
      anon_sym_SEMI,
  [297533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_bitand,
  [297540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_xor,
  [297547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_DASH_EQ,
  [297554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14475), 1,
      anon_sym_LPAREN2,
  [297561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14477), 1,
      anon_sym_RPAREN,
  [297568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14479), 1,
      anon_sym_SEMI,
  [297575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14481), 1,
      anon_sym_SEMI,
  [297582] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14483), 1,
      anon_sym_RPAREN,
  [297589] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14485), 1,
      anon_sym_SEMI,
  [297596] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14487), 1,
      anon_sym_COLON,
  [297603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14489), 1,
      anon_sym_SEMI,
  [297610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14491), 1,
      anon_sym_LPAREN2,
  [297617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14493), 1,
      anon_sym_DQUOTE,
  [297624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14495), 1,
      anon_sym_SEMI,
  [297631] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8709), 1,
      anon_sym_COLON,
  [297638] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14497), 1,
      aux_sym_preproc_if_token2,
  [297645] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14499), 1,
      aux_sym_preproc_if_token2,
  [297652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14501), 1,
      anon_sym_LPAREN2,
  [297659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14503), 1,
      anon_sym_LPAREN2,
  [297666] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14505), 1,
      sym_identifier,
  [297673] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14507), 1,
      anon_sym_DQUOTE,
  [297680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14509), 1,
      anon_sym_LPAREN2,
  [297687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14511), 1,
      sym_identifier,
  [297694] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14513), 1,
      sym_raw_string_content,
  [297701] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8773), 1,
      anon_sym_COLON,
  [297708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14515), 1,
      anon_sym_SEMI,
  [297715] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14517), 1,
      anon_sym_LPAREN2,
  [297722] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14519), 1,
      anon_sym_LPAREN2,
  [297729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14521), 1,
      anon_sym_LPAREN2,
  [297736] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14523), 1,
      sym_identifier,
  [297743] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14525), 1,
      anon_sym_DQUOTE,
  [297750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14527), 1,
      anon_sym_SEMI,
  [297757] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14529), 1,
      sym_identifier,
  [297764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14531), 1,
      sym_raw_string_content,
  [297771] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13080), 1,
      anon_sym_RBRACE,
  [297778] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_GT,
  [297785] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14533), 1,
      anon_sym_RPAREN,
  [297792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14535), 1,
      anon_sym_LPAREN2,
  [297799] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14537), 1,
      sym_identifier,
  [297806] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14539), 1,
      anon_sym_SEMI,
  [297813] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8753), 1,
      anon_sym_COLON,
  [297820] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14541), 1,
      sym_identifier,
  [297827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14543), 1,
      sym_raw_string_content,
  [297834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14545), 1,
      anon_sym_RPAREN,
  [297841] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14547), 1,
      anon_sym_SEMI,
  [297848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14549), 1,
      anon_sym_LPAREN2,
  [297855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14551), 1,
      sym_identifier,
  [297862] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_bitor,
  [297869] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14553), 1,
      aux_sym_preproc_if_token2,
  [297876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14555), 1,
      sym_identifier,
  [297883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14557), 1,
      sym_raw_string_content,
  [297890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14559), 1,
      aux_sym_preproc_if_token2,
  [297897] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14561), 1,
      aux_sym_preproc_if_token2,
  [297904] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14563), 1,
      anon_sym_LPAREN2,
  [297911] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14565), 1,
      sym_identifier,
  [297918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14567), 1,
      sym_auto,
  [297925] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_and,
  [297932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14569), 1,
      sym_identifier,
  [297939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14571), 1,
      sym_raw_string_content,
  [297946] = 2,
    ACTIONS(5460), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(9740), 1,
      sym_comment,
  [297953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14573), 1,
      aux_sym_preproc_if_token2,
  [297960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14575), 1,
      anon_sym_RPAREN,
  [297967] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14577), 1,
      anon_sym_RPAREN,
  [297974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14579), 1,
      sym_identifier,
  [297981] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14581), 1,
      sym_raw_string_content,
  [297988] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14583), 1,
      anon_sym_RPAREN,
  [297995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14585), 1,
      anon_sym_RPAREN,
  [298002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14587), 1,
      anon_sym_RPAREN,
  [298009] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14589), 1,
      sym_raw_string_content,
  [298016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10671), 1,
      anon_sym_RBRACE,
  [298023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14591), 1,
      sym_raw_string_content,
  [298030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14593), 1,
      anon_sym_RPAREN,
  [298037] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14595), 1,
      sym_raw_string_content,
  [298044] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14597), 1,
      anon_sym_RPAREN,
  [298051] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14599), 1,
      sym_raw_string_content,
  [298058] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14601), 1,
      anon_sym_RPAREN,
  [298065] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14603), 1,
      sym_raw_string_content,
  [298072] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_or,
  [298079] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14605), 1,
      sym_raw_string_content,
  [298086] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_PIPE_EQ,
  [298093] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14607), 1,
      sym_raw_string_content,
  [298100] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_CARET_EQ,
  [298107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14609), 1,
      sym_raw_string_content,
  [298114] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11993), 1,
      anon_sym_SEMI,
  [298121] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14611), 1,
      sym_raw_string_content,
  [298128] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_AMP_EQ,
  [298135] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14613), 1,
      sym_raw_string_content,
  [298142] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14615), 1,
      anon_sym_RPAREN,
  [298149] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14617), 1,
      sym_raw_string_content,
  [298156] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14619), 1,
      anon_sym_RPAREN,
  [298163] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14621), 1,
      sym_raw_string_content,
  [298170] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14623), 1,
      anon_sym_RPAREN,
  [298177] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14625), 1,
      sym_raw_string_content,
  [298184] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14627), 1,
      anon_sym_LPAREN2,
  [298191] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14629), 1,
      anon_sym_LPAREN2,
  [298198] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14631), 1,
      anon_sym_RPAREN,
  [298205] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14633), 1,
      anon_sym_LPAREN2,
  [298212] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14635), 1,
      anon_sym_LPAREN2,
  [298219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14637), 1,
      anon_sym_SEMI,
  [298226] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14639), 1,
      anon_sym_LPAREN2,
  [298233] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14641), 1,
      anon_sym_LPAREN2,
  [298240] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14643), 1,
      anon_sym_RPAREN,
  [298247] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14645), 1,
      anon_sym_LPAREN2,
  [298254] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14647), 1,
      anon_sym_LPAREN2,
  [298261] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14649), 1,
      anon_sym_SEMI,
  [298268] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14651), 1,
      anon_sym_LPAREN2,
  [298275] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14653), 1,
      anon_sym_LPAREN2,
  [298282] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14655), 1,
      sym_identifier,
  [298289] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14657), 1,
      anon_sym_LPAREN2,
  [298296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14659), 1,
      anon_sym_LPAREN2,
  [298303] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14661), 1,
      anon_sym_SEMI,
  [298310] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14663), 1,
      anon_sym_LPAREN2,
  [298317] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14665), 1,
      anon_sym_LPAREN2,
  [298324] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14667), 1,
      sym_auto,
  [298331] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14669), 1,
      anon_sym_LPAREN2,
  [298338] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14671), 1,
      anon_sym_LPAREN2,
  [298345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14673), 1,
      anon_sym_LPAREN2,
  [298352] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14675), 1,
      anon_sym_LPAREN2,
  [298359] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14677), 1,
      anon_sym_LPAREN2,
  [298366] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14679), 1,
      anon_sym_LPAREN2,
  [298373] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14681), 1,
      anon_sym_LPAREN2,
  [298380] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14683), 1,
      anon_sym_LPAREN2,
  [298387] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14685), 1,
      anon_sym_LPAREN2,
  [298394] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14687), 1,
      anon_sym_LPAREN2,
  [298401] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14689), 1,
      anon_sym_LPAREN2,
  [298408] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14691), 1,
      anon_sym_LPAREN2,
  [298415] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14693), 1,
      anon_sym_LPAREN2,
  [298422] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14695), 1,
      anon_sym_RPAREN,
  [298429] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14697), 1,
      anon_sym_LPAREN2,
  [298436] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14699), 1,
      sym_identifier,
  [298443] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14701), 1,
      anon_sym_RPAREN,
  [298450] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14703), 1,
      sym_identifier,
  [298457] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14705), 1,
      anon_sym_DQUOTE,
  [298464] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14707), 1,
      sym_identifier,
  [298471] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14709), 1,
      anon_sym_LPAREN2,
  [298478] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14711), 1,
      anon_sym_LPAREN2,
  [298485] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14713), 1,
      anon_sym_LPAREN2,
  [298492] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14715), 1,
      anon_sym_LPAREN2,
  [298499] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14717), 1,
      anon_sym_LPAREN2,
  [298506] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14719), 1,
      anon_sym_LPAREN2,
  [298513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14721), 1,
      anon_sym_LPAREN2,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2527)] = 0,
  [SMALL_STATE(2528)] = 71,
  [SMALL_STATE(2529)] = 142,
  [SMALL_STATE(2530)] = 213,
  [SMALL_STATE(2531)] = 284,
  [SMALL_STATE(2532)] = 355,
  [SMALL_STATE(2533)] = 426,
  [SMALL_STATE(2534)] = 497,
  [SMALL_STATE(2535)] = 568,
  [SMALL_STATE(2536)] = 639,
  [SMALL_STATE(2537)] = 710,
  [SMALL_STATE(2538)] = 781,
  [SMALL_STATE(2539)] = 852,
  [SMALL_STATE(2540)] = 923,
  [SMALL_STATE(2541)] = 994,
  [SMALL_STATE(2542)] = 1065,
  [SMALL_STATE(2543)] = 1136,
  [SMALL_STATE(2544)] = 1207,
  [SMALL_STATE(2545)] = 1278,
  [SMALL_STATE(2546)] = 1351,
  [SMALL_STATE(2547)] = 1422,
  [SMALL_STATE(2548)] = 1493,
  [SMALL_STATE(2549)] = 1580,
  [SMALL_STATE(2550)] = 1653,
  [SMALL_STATE(2551)] = 1728,
  [SMALL_STATE(2552)] = 1805,
  [SMALL_STATE(2553)] = 1876,
  [SMALL_STATE(2554)] = 1947,
  [SMALL_STATE(2555)] = 2018,
  [SMALL_STATE(2556)] = 2089,
  [SMALL_STATE(2557)] = 2162,
  [SMALL_STATE(2558)] = 2233,
  [SMALL_STATE(2559)] = 2306,
  [SMALL_STATE(2560)] = 2389,
  [SMALL_STATE(2561)] = 2460,
  [SMALL_STATE(2562)] = 2531,
  [SMALL_STATE(2563)] = 2602,
  [SMALL_STATE(2564)] = 2673,
  [SMALL_STATE(2565)] = 2754,
  [SMALL_STATE(2566)] = 2825,
  [SMALL_STATE(2567)] = 2896,
  [SMALL_STATE(2568)] = 2967,
  [SMALL_STATE(2569)] = 3040,
  [SMALL_STATE(2570)] = 3111,
  [SMALL_STATE(2571)] = 3182,
  [SMALL_STATE(2572)] = 3255,
  [SMALL_STATE(2573)] = 3330,
  [SMALL_STATE(2574)] = 3401,
  [SMALL_STATE(2575)] = 3474,
  [SMALL_STATE(2576)] = 3545,
  [SMALL_STATE(2577)] = 3616,
  [SMALL_STATE(2578)] = 3699,
  [SMALL_STATE(2579)] = 3772,
  [SMALL_STATE(2580)] = 3843,
  [SMALL_STATE(2581)] = 3914,
  [SMALL_STATE(2582)] = 3993,
  [SMALL_STATE(2583)] = 4064,
  [SMALL_STATE(2584)] = 4137,
  [SMALL_STATE(2585)] = 4212,
  [SMALL_STATE(2586)] = 4285,
  [SMALL_STATE(2587)] = 4356,
  [SMALL_STATE(2588)] = 4427,
  [SMALL_STATE(2589)] = 4498,
  [SMALL_STATE(2590)] = 4569,
  [SMALL_STATE(2591)] = 4648,
  [SMALL_STATE(2592)] = 4731,
  [SMALL_STATE(2593)] = 4802,
  [SMALL_STATE(2594)] = 4875,
  [SMALL_STATE(2595)] = 4946,
  [SMALL_STATE(2596)] = 5017,
  [SMALL_STATE(2597)] = 5090,
  [SMALL_STATE(2598)] = 5161,
  [SMALL_STATE(2599)] = 5232,
  [SMALL_STATE(2600)] = 5303,
  [SMALL_STATE(2601)] = 5374,
  [SMALL_STATE(2602)] = 5445,
  [SMALL_STATE(2603)] = 5516,
  [SMALL_STATE(2604)] = 5587,
  [SMALL_STATE(2605)] = 5658,
  [SMALL_STATE(2606)] = 5729,
  [SMALL_STATE(2607)] = 5802,
  [SMALL_STATE(2608)] = 5873,
  [SMALL_STATE(2609)] = 5944,
  [SMALL_STATE(2610)] = 6015,
  [SMALL_STATE(2611)] = 6086,
  [SMALL_STATE(2612)] = 6157,
  [SMALL_STATE(2613)] = 6228,
  [SMALL_STATE(2614)] = 6299,
  [SMALL_STATE(2615)] = 6370,
  [SMALL_STATE(2616)] = 6441,
  [SMALL_STATE(2617)] = 6512,
  [SMALL_STATE(2618)] = 6583,
  [SMALL_STATE(2619)] = 6659,
  [SMALL_STATE(2620)] = 6729,
  [SMALL_STATE(2621)] = 6803,
  [SMALL_STATE(2622)] = 6873,
  [SMALL_STATE(2623)] = 6943,
  [SMALL_STATE(2624)] = 7013,
  [SMALL_STATE(2625)] = 7083,
  [SMALL_STATE(2626)] = 7153,
  [SMALL_STATE(2627)] = 7223,
  [SMALL_STATE(2628)] = 7293,
  [SMALL_STATE(2629)] = 7363,
  [SMALL_STATE(2630)] = 7437,
  [SMALL_STATE(2631)] = 7523,
  [SMALL_STATE(2632)] = 7593,
  [SMALL_STATE(2633)] = 7663,
  [SMALL_STATE(2634)] = 7739,
  [SMALL_STATE(2635)] = 7813,
  [SMALL_STATE(2636)] = 7887,
  [SMALL_STATE(2637)] = 7957,
  [SMALL_STATE(2638)] = 8027,
  [SMALL_STATE(2639)] = 8101,
  [SMALL_STATE(2640)] = 8171,
  [SMALL_STATE(2641)] = 8241,
  [SMALL_STATE(2642)] = 8311,
  [SMALL_STATE(2643)] = 8389,
  [SMALL_STATE(2644)] = 8507,
  [SMALL_STATE(2645)] = 8577,
  [SMALL_STATE(2646)] = 8663,
  [SMALL_STATE(2647)] = 8733,
  [SMALL_STATE(2648)] = 8803,
  [SMALL_STATE(2649)] = 8873,
  [SMALL_STATE(2650)] = 8943,
  [SMALL_STATE(2651)] = 9021,
  [SMALL_STATE(2652)] = 9091,
  [SMALL_STATE(2653)] = 9161,
  [SMALL_STATE(2654)] = 9231,
  [SMALL_STATE(2655)] = 9309,
  [SMALL_STATE(2656)] = 9379,
  [SMALL_STATE(2657)] = 9449,
  [SMALL_STATE(2658)] = 9519,
  [SMALL_STATE(2659)] = 9589,
  [SMALL_STATE(2660)] = 9659,
  [SMALL_STATE(2661)] = 9729,
  [SMALL_STATE(2662)] = 9799,
  [SMALL_STATE(2663)] = 9869,
  [SMALL_STATE(2664)] = 9943,
  [SMALL_STATE(2665)] = 10013,
  [SMALL_STATE(2666)] = 10083,
  [SMALL_STATE(2667)] = 10153,
  [SMALL_STATE(2668)] = 10231,
  [SMALL_STATE(2669)] = 10301,
  [SMALL_STATE(2670)] = 10371,
  [SMALL_STATE(2671)] = 10441,
  [SMALL_STATE(2672)] = 10523,
  [SMALL_STATE(2673)] = 10593,
  [SMALL_STATE(2674)] = 10663,
  [SMALL_STATE(2675)] = 10733,
  [SMALL_STATE(2676)] = 10807,
  [SMALL_STATE(2677)] = 10881,
  [SMALL_STATE(2678)] = 10959,
  [SMALL_STATE(2679)] = 11029,
  [SMALL_STATE(2680)] = 11099,
  [SMALL_STATE(2681)] = 11177,
  [SMALL_STATE(2682)] = 11253,
  [SMALL_STATE(2683)] = 11323,
  [SMALL_STATE(2684)] = 11393,
  [SMALL_STATE(2685)] = 11463,
  [SMALL_STATE(2686)] = 11581,
  [SMALL_STATE(2687)] = 11651,
  [SMALL_STATE(2688)] = 11721,
  [SMALL_STATE(2689)] = 11791,
  [SMALL_STATE(2690)] = 11865,
  [SMALL_STATE(2691)] = 11935,
  [SMALL_STATE(2692)] = 12005,
  [SMALL_STATE(2693)] = 12091,
  [SMALL_STATE(2694)] = 12161,
  [SMALL_STATE(2695)] = 12235,
  [SMALL_STATE(2696)] = 12353,
  [SMALL_STATE(2697)] = 12429,
  [SMALL_STATE(2698)] = 12499,
  [SMALL_STATE(2699)] = 12569,
  [SMALL_STATE(2700)] = 12653,
  [SMALL_STATE(2701)] = 12723,
  [SMALL_STATE(2702)] = 12793,
  [SMALL_STATE(2703)] = 12863,
  [SMALL_STATE(2704)] = 12933,
  [SMALL_STATE(2705)] = 13003,
  [SMALL_STATE(2706)] = 13079,
  [SMALL_STATE(2707)] = 13149,
  [SMALL_STATE(2708)] = 13229,
  [SMALL_STATE(2709)] = 13299,
  [SMALL_STATE(2710)] = 13369,
  [SMALL_STATE(2711)] = 13439,
  [SMALL_STATE(2712)] = 13513,
  [SMALL_STATE(2713)] = 13583,
  [SMALL_STATE(2714)] = 13653,
  [SMALL_STATE(2715)] = 13723,
  [SMALL_STATE(2716)] = 13801,
  [SMALL_STATE(2717)] = 13893,
  [SMALL_STATE(2718)] = 13963,
  [SMALL_STATE(2719)] = 14033,
  [SMALL_STATE(2720)] = 14103,
  [SMALL_STATE(2721)] = 14193,
  [SMALL_STATE(2722)] = 14263,
  [SMALL_STATE(2723)] = 14333,
  [SMALL_STATE(2724)] = 14403,
  [SMALL_STATE(2725)] = 14473,
  [SMALL_STATE(2726)] = 14543,
  [SMALL_STATE(2727)] = 14613,
  [SMALL_STATE(2728)] = 14695,
  [SMALL_STATE(2729)] = 14765,
  [SMALL_STATE(2730)] = 14835,
  [SMALL_STATE(2731)] = 14905,
  [SMALL_STATE(2732)] = 14975,
  [SMALL_STATE(2733)] = 15045,
  [SMALL_STATE(2734)] = 15129,
  [SMALL_STATE(2735)] = 15199,
  [SMALL_STATE(2736)] = 15269,
  [SMALL_STATE(2737)] = 15339,
  [SMALL_STATE(2738)] = 15409,
  [SMALL_STATE(2739)] = 15479,
  [SMALL_STATE(2740)] = 15549,
  [SMALL_STATE(2741)] = 15667,
  [SMALL_STATE(2742)] = 15737,
  [SMALL_STATE(2743)] = 15807,
  [SMALL_STATE(2744)] = 15877,
  [SMALL_STATE(2745)] = 15947,
  [SMALL_STATE(2746)] = 16022,
  [SMALL_STATE(2747)] = 16101,
  [SMALL_STATE(2748)] = 16178,
  [SMALL_STATE(2749)] = 16247,
  [SMALL_STATE(2750)] = 16324,
  [SMALL_STATE(2751)] = 16441,
  [SMALL_STATE(2752)] = 16514,
  [SMALL_STATE(2753)] = 16591,
  [SMALL_STATE(2754)] = 16670,
  [SMALL_STATE(2755)] = 16743,
  [SMALL_STATE(2756)] = 16822,
  [SMALL_STATE(2757)] = 16895,
  [SMALL_STATE(2758)] = 16976,
  [SMALL_STATE(2759)] = 17053,
  [SMALL_STATE(2760)] = 17128,
  [SMALL_STATE(2761)] = 17203,
  [SMALL_STATE(2762)] = 17320,
  [SMALL_STATE(2763)] = 17393,
  [SMALL_STATE(2764)] = 17466,
  [SMALL_STATE(2765)] = 17535,
  [SMALL_STATE(2766)] = 17604,
  [SMALL_STATE(2767)] = 17673,
  [SMALL_STATE(2768)] = 17748,
  [SMALL_STATE(2769)] = 17821,
  [SMALL_STATE(2770)] = 17902,
  [SMALL_STATE(2771)] = 17975,
  [SMALL_STATE(2772)] = 18051,
  [SMALL_STATE(2773)] = 18129,
  [SMALL_STATE(2774)] = 18201,
  [SMALL_STATE(2775)] = 18315,
  [SMALL_STATE(2776)] = 18383,
  [SMALL_STATE(2777)] = 18497,
  [SMALL_STATE(2778)] = 18611,
  [SMALL_STATE(2779)] = 18725,
  [SMALL_STATE(2780)] = 18801,
  [SMALL_STATE(2781)] = 18873,
  [SMALL_STATE(2782)] = 18957,
  [SMALL_STATE(2783)] = 19029,
  [SMALL_STATE(2784)] = 19143,
  [SMALL_STATE(2785)] = 19257,
  [SMALL_STATE(2786)] = 19329,
  [SMALL_STATE(2787)] = 19447,
  [SMALL_STATE(2788)] = 19519,
  [SMALL_STATE(2789)] = 19591,
  [SMALL_STATE(2790)] = 19671,
  [SMALL_STATE(2791)] = 19743,
  [SMALL_STATE(2792)] = 19857,
  [SMALL_STATE(2793)] = 19931,
  [SMALL_STATE(2794)] = 20003,
  [SMALL_STATE(2795)] = 20073,
  [SMALL_STATE(2796)] = 20141,
  [SMALL_STATE(2797)] = 20209,
  [SMALL_STATE(2798)] = 20287,
  [SMALL_STATE(2799)] = 20401,
  [SMALL_STATE(2800)] = 20515,
  [SMALL_STATE(2801)] = 20629,
  [SMALL_STATE(2802)] = 20743,
  [SMALL_STATE(2803)] = 20813,
  [SMALL_STATE(2804)] = 20927,
  [SMALL_STATE(2805)] = 21041,
  [SMALL_STATE(2806)] = 21113,
  [SMALL_STATE(2807)] = 21183,
  [SMALL_STATE(2808)] = 21297,
  [SMALL_STATE(2809)] = 21411,
  [SMALL_STATE(2810)] = 21485,
  [SMALL_STATE(2811)] = 21599,
  [SMALL_STATE(2812)] = 21667,
  [SMALL_STATE(2813)] = 21739,
  [SMALL_STATE(2814)] = 21815,
  [SMALL_STATE(2815)] = 21929,
  [SMALL_STATE(2816)] = 22043,
  [SMALL_STATE(2817)] = 22157,
  [SMALL_STATE(2818)] = 22225,
  [SMALL_STATE(2819)] = 22339,
  [SMALL_STATE(2820)] = 22457,
  [SMALL_STATE(2821)] = 22531,
  [SMALL_STATE(2822)] = 22599,
  [SMALL_STATE(2823)] = 22713,
  [SMALL_STATE(2824)] = 22785,
  [SMALL_STATE(2825)] = 22857,
  [SMALL_STATE(2826)] = 22929,
  [SMALL_STATE(2827)] = 23003,
  [SMALL_STATE(2828)] = 23117,
  [SMALL_STATE(2829)] = 23191,
  [SMALL_STATE(2830)] = 23263,
  [SMALL_STATE(2831)] = 23377,
  [SMALL_STATE(2832)] = 23491,
  [SMALL_STATE(2833)] = 23571,
  [SMALL_STATE(2834)] = 23639,
  [SMALL_STATE(2835)] = 23711,
  [SMALL_STATE(2836)] = 23779,
  [SMALL_STATE(2837)] = 23851,
  [SMALL_STATE(2838)] = 23918,
  [SMALL_STATE(2839)] = 23985,
  [SMALL_STATE(2840)] = 24102,
  [SMALL_STATE(2841)] = 24181,
  [SMALL_STATE(2842)] = 24248,
  [SMALL_STATE(2843)] = 24331,
  [SMALL_STATE(2844)] = 24410,
  [SMALL_STATE(2845)] = 24479,
  [SMALL_STATE(2846)] = 24554,
  [SMALL_STATE(2847)] = 24637,
  [SMALL_STATE(2848)] = 24720,
  [SMALL_STATE(2849)] = 24789,
  [SMALL_STATE(2850)] = 24906,
  [SMALL_STATE(2851)] = 24977,
  [SMALL_STATE(2852)] = 25090,
  [SMALL_STATE(2853)] = 25175,
  [SMALL_STATE(2854)] = 25258,
  [SMALL_STATE(2855)] = 25377,
  [SMALL_STATE(2856)] = 25490,
  [SMALL_STATE(2857)] = 25609,
  [SMALL_STATE(2858)] = 25696,
  [SMALL_STATE(2859)] = 25771,
  [SMALL_STATE(2860)] = 25884,
  [SMALL_STATE(2861)] = 25975,
  [SMALL_STATE(2862)] = 26070,
  [SMALL_STATE(2863)] = 26169,
  [SMALL_STATE(2864)] = 26270,
  [SMALL_STATE(2865)] = 26373,
  [SMALL_STATE(2866)] = 26478,
  [SMALL_STATE(2867)] = 26567,
  [SMALL_STATE(2868)] = 26676,
  [SMALL_STATE(2869)] = 26745,
  [SMALL_STATE(2870)] = 26812,
  [SMALL_STATE(2871)] = 26889,
  [SMALL_STATE(2872)] = 26960,
  [SMALL_STATE(2873)] = 27027,
  [SMALL_STATE(2874)] = 27096,
  [SMALL_STATE(2875)] = 27163,
  [SMALL_STATE(2876)] = 27230,
  [SMALL_STATE(2877)] = 27299,
  [SMALL_STATE(2878)] = 27366,
  [SMALL_STATE(2879)] = 27445,
  [SMALL_STATE(2880)] = 27514,
  [SMALL_STATE(2881)] = 27593,
  [SMALL_STATE(2882)] = 27660,
  [SMALL_STATE(2883)] = 27727,
  [SMALL_STATE(2884)] = 27846,
  [SMALL_STATE(2885)] = 27913,
  [SMALL_STATE(2886)] = 27996,
  [SMALL_STATE(2887)] = 28063,
  [SMALL_STATE(2888)] = 28130,
  [SMALL_STATE(2889)] = 28243,
  [SMALL_STATE(2890)] = 28313,
  [SMALL_STATE(2891)] = 28383,
  [SMALL_STATE(2892)] = 28465,
  [SMALL_STATE(2893)] = 28531,
  [SMALL_STATE(2894)] = 28597,
  [SMALL_STATE(2895)] = 28669,
  [SMALL_STATE(2896)] = 28739,
  [SMALL_STATE(2897)] = 28809,
  [SMALL_STATE(2898)] = 28925,
  [SMALL_STATE(2899)] = 28997,
  [SMALL_STATE(2900)] = 29063,
  [SMALL_STATE(2901)] = 29145,
  [SMALL_STATE(2902)] = 29215,
  [SMALL_STATE(2903)] = 29285,
  [SMALL_STATE(2904)] = 29359,
  [SMALL_STATE(2905)] = 29431,
  [SMALL_STATE(2906)] = 29503,
  [SMALL_STATE(2907)] = 29585,
  [SMALL_STATE(2908)] = 29701,
  [SMALL_STATE(2909)] = 29771,
  [SMALL_STATE(2910)] = 29887,
  [SMALL_STATE(2911)] = 29969,
  [SMALL_STATE(2912)] = 30039,
  [SMALL_STATE(2913)] = 30105,
  [SMALL_STATE(2914)] = 30221,
  [SMALL_STATE(2915)] = 30337,
  [SMALL_STATE(2916)] = 30407,
  [SMALL_STATE(2917)] = 30473,
  [SMALL_STATE(2918)] = 30555,
  [SMALL_STATE(2919)] = 30625,
  [SMALL_STATE(2920)] = 30691,
  [SMALL_STATE(2921)] = 30761,
  [SMALL_STATE(2922)] = 30831,
  [SMALL_STATE(2923)] = 30947,
  [SMALL_STATE(2924)] = 31029,
  [SMALL_STATE(2925)] = 31145,
  [SMALL_STATE(2926)] = 31213,
  [SMALL_STATE(2927)] = 31283,
  [SMALL_STATE(2928)] = 31353,
  [SMALL_STATE(2929)] = 31423,
  [SMALL_STATE(2930)] = 31493,
  [SMALL_STATE(2931)] = 31609,
  [SMALL_STATE(2932)] = 31679,
  [SMALL_STATE(2933)] = 31745,
  [SMALL_STATE(2934)] = 31827,
  [SMALL_STATE(2935)] = 31909,
  [SMALL_STATE(2936)] = 31983,
  [SMALL_STATE(2937)] = 32053,
  [SMALL_STATE(2938)] = 32123,
  [SMALL_STATE(2939)] = 32193,
  [SMALL_STATE(2940)] = 32263,
  [SMALL_STATE(2941)] = 32330,
  [SMALL_STATE(2942)] = 32445,
  [SMALL_STATE(2943)] = 32540,
  [SMALL_STATE(2944)] = 32639,
  [SMALL_STATE(2945)] = 32704,
  [SMALL_STATE(2946)] = 32805,
  [SMALL_STATE(2947)] = 32870,
  [SMALL_STATE(2948)] = 32983,
  [SMALL_STATE(2949)] = 33048,
  [SMALL_STATE(2950)] = 33125,
  [SMALL_STATE(2951)] = 33200,
  [SMALL_STATE(2952)] = 33265,
  [SMALL_STATE(2953)] = 33378,
  [SMALL_STATE(2954)] = 33451,
  [SMALL_STATE(2955)] = 33544,
  [SMALL_STATE(2956)] = 33613,
  [SMALL_STATE(2957)] = 33682,
  [SMALL_STATE(2958)] = 33751,
  [SMALL_STATE(2959)] = 33918,
  [SMALL_STATE(2960)] = 34007,
  [SMALL_STATE(2961)] = 34174,
  [SMALL_STATE(2962)] = 34293,
  [SMALL_STATE(2963)] = 34408,
  [SMALL_STATE(2964)] = 34493,
  [SMALL_STATE(2965)] = 34558,
  [SMALL_STATE(2966)] = 34623,
  [SMALL_STATE(2967)] = 34688,
  [SMALL_STATE(2968)] = 34753,
  [SMALL_STATE(2969)] = 34866,
  [SMALL_STATE(2970)] = 34971,
  [SMALL_STATE(2971)] = 35036,
  [SMALL_STATE(2972)] = 35109,
  [SMALL_STATE(2973)] = 35174,
  [SMALL_STATE(2974)] = 35293,
  [SMALL_STATE(2975)] = 35408,
  [SMALL_STATE(2976)] = 35477,
  [SMALL_STATE(2977)] = 35596,
  [SMALL_STATE(2978)] = 35665,
  [SMALL_STATE(2979)] = 35730,
  [SMALL_STATE(2980)] = 35799,
  [SMALL_STATE(2981)] = 35886,
  [SMALL_STATE(2982)] = 35951,
  [SMALL_STATE(2983)] = 36016,
  [SMALL_STATE(2984)] = 36129,
  [SMALL_STATE(2985)] = 36194,
  [SMALL_STATE(2986)] = 36361,
  [SMALL_STATE(2987)] = 36428,
  [SMALL_STATE(2988)] = 36493,
  [SMALL_STATE(2989)] = 36602,
  [SMALL_STATE(2990)] = 36717,
  [SMALL_STATE(2991)] = 36790,
  [SMALL_STATE(2992)] = 36859,
  [SMALL_STATE(2993)] = 36924,
  [SMALL_STATE(2994)] = 36993,
  [SMALL_STATE(2995)] = 37058,
  [SMALL_STATE(2996)] = 37131,
  [SMALL_STATE(2997)] = 37200,
  [SMALL_STATE(2998)] = 37265,
  [SMALL_STATE(2999)] = 37330,
  [SMALL_STATE(3000)] = 37407,
  [SMALL_STATE(3001)] = 37474,
  [SMALL_STATE(3002)] = 37539,
  [SMALL_STATE(3003)] = 37606,
  [SMALL_STATE(3004)] = 37673,
  [SMALL_STATE(3005)] = 37742,
  [SMALL_STATE(3006)] = 37821,
  [SMALL_STATE(3007)] = 37890,
  [SMALL_STATE(3008)] = 37959,
  [SMALL_STATE(3009)] = 38026,
  [SMALL_STATE(3010)] = 38193,
  [SMALL_STATE(3011)] = 38262,
  [SMALL_STATE(3012)] = 38345,
  [SMALL_STATE(3013)] = 38417,
  [SMALL_STATE(3014)] = 38497,
  [SMALL_STATE(3015)] = 38565,
  [SMALL_STATE(3016)] = 38629,
  [SMALL_STATE(3017)] = 38697,
  [SMALL_STATE(3018)] = 38765,
  [SMALL_STATE(3019)] = 38829,
  [SMALL_STATE(3020)] = 38897,
  [SMALL_STATE(3021)] = 38961,
  [SMALL_STATE(3022)] = 39027,
  [SMALL_STATE(3023)] = 39107,
  [SMALL_STATE(3024)] = 39175,
  [SMALL_STATE(3025)] = 39243,
  [SMALL_STATE(3026)] = 39311,
  [SMALL_STATE(3027)] = 39377,
  [SMALL_STATE(3028)] = 39441,
  [SMALL_STATE(3029)] = 39505,
  [SMALL_STATE(3030)] = 39569,
  [SMALL_STATE(3031)] = 39633,
  [SMALL_STATE(3032)] = 39697,
  [SMALL_STATE(3033)] = 39771,
  [SMALL_STATE(3034)] = 39839,
  [SMALL_STATE(3035)] = 39907,
  [SMALL_STATE(3036)] = 39971,
  [SMALL_STATE(3037)] = 40035,
  [SMALL_STATE(3038)] = 40099,
  [SMALL_STATE(3039)] = 40169,
  [SMALL_STATE(3040)] = 40243,
  [SMALL_STATE(3041)] = 40307,
  [SMALL_STATE(3042)] = 40371,
  [SMALL_STATE(3043)] = 40445,
  [SMALL_STATE(3044)] = 40513,
  [SMALL_STATE(3045)] = 40577,
  [SMALL_STATE(3046)] = 40645,
  [SMALL_STATE(3047)] = 40711,
  [SMALL_STATE(3048)] = 40785,
  [SMALL_STATE(3049)] = 40865,
  [SMALL_STATE(3050)] = 40929,
  [SMALL_STATE(3051)] = 40993,
  [SMALL_STATE(3052)] = 41057,
  [SMALL_STATE(3053)] = 41121,
  [SMALL_STATE(3054)] = 41187,
  [SMALL_STATE(3055)] = 41253,
  [SMALL_STATE(3056)] = 41317,
  [SMALL_STATE(3057)] = 41431,
  [SMALL_STATE(3058)] = 41497,
  [SMALL_STATE(3059)] = 41561,
  [SMALL_STATE(3060)] = 41629,
  [SMALL_STATE(3061)] = 41697,
  [SMALL_STATE(3062)] = 41767,
  [SMALL_STATE(3063)] = 41835,
  [SMALL_STATE(3064)] = 41909,
  [SMALL_STATE(3065)] = 41973,
  [SMALL_STATE(3066)] = 42041,
  [SMALL_STATE(3067)] = 42105,
  [SMALL_STATE(3068)] = 42173,
  [SMALL_STATE(3069)] = 42241,
  [SMALL_STATE(3070)] = 42309,
  [SMALL_STATE(3071)] = 42377,
  [SMALL_STATE(3072)] = 42441,
  [SMALL_STATE(3073)] = 42509,
  [SMALL_STATE(3074)] = 42585,
  [SMALL_STATE(3075)] = 42657,
  [SMALL_STATE(3076)] = 42721,
  [SMALL_STATE(3077)] = 42801,
  [SMALL_STATE(3078)] = 42865,
  [SMALL_STATE(3079)] = 42941,
  [SMALL_STATE(3080)] = 43055,
  [SMALL_STATE(3081)] = 43119,
  [SMALL_STATE(3082)] = 43187,
  [SMALL_STATE(3083)] = 43255,
  [SMALL_STATE(3084)] = 43335,
  [SMALL_STATE(3085)] = 43403,
  [SMALL_STATE(3086)] = 43471,
  [SMALL_STATE(3087)] = 43539,
  [SMALL_STATE(3088)] = 43620,
  [SMALL_STATE(3089)] = 43691,
  [SMALL_STATE(3090)] = 43754,
  [SMALL_STATE(3091)] = 43831,
  [SMALL_STATE(3092)] = 43894,
  [SMALL_STATE(3093)] = 43967,
  [SMALL_STATE(3094)] = 44040,
  [SMALL_STATE(3095)] = 44119,
  [SMALL_STATE(3096)] = 44192,
  [SMALL_STATE(3097)] = 44263,
  [SMALL_STATE(3098)] = 44334,
  [SMALL_STATE(3099)] = 44407,
  [SMALL_STATE(3100)] = 44470,
  [SMALL_STATE(3101)] = 44543,
  [SMALL_STATE(3102)] = 44614,
  [SMALL_STATE(3103)] = 44679,
  [SMALL_STATE(3104)] = 44758,
  [SMALL_STATE(3105)] = 44821,
  [SMALL_STATE(3106)] = 44938,
  [SMALL_STATE(3107)] = 45011,
  [SMALL_STATE(3108)] = 45080,
  [SMALL_STATE(3109)] = 45159,
  [SMALL_STATE(3110)] = 45276,
  [SMALL_STATE(3111)] = 45387,
  [SMALL_STATE(3112)] = 45450,
  [SMALL_STATE(3113)] = 45543,
  [SMALL_STATE(3114)] = 45608,
  [SMALL_STATE(3115)] = 45671,
  [SMALL_STATE(3116)] = 45788,
  [SMALL_STATE(3117)] = 45851,
  [SMALL_STATE(3118)] = 45924,
  [SMALL_STATE(3119)] = 46035,
  [SMALL_STATE(3120)] = 46098,
  [SMALL_STATE(3121)] = 46175,
  [SMALL_STATE(3122)] = 46286,
  [SMALL_STATE(3123)] = 46397,
  [SMALL_STATE(3124)] = 46464,
  [SMALL_STATE(3125)] = 46531,
  [SMALL_STATE(3126)] = 46600,
  [SMALL_STATE(3127)] = 46679,
  [SMALL_STATE(3128)] = 46742,
  [SMALL_STATE(3129)] = 46833,
  [SMALL_STATE(3130)] = 46944,
  [SMALL_STATE(3131)] = 47037,
  [SMALL_STATE(3132)] = 47134,
  [SMALL_STATE(3133)] = 47233,
  [SMALL_STATE(3134)] = 47336,
  [SMALL_STATE(3135)] = 47407,
  [SMALL_STATE(3136)] = 47514,
  [SMALL_STATE(3137)] = 47577,
  [SMALL_STATE(3138)] = 47694,
  [SMALL_STATE(3139)] = 47793,
  [SMALL_STATE(3140)] = 47878,
  [SMALL_STATE(3141)] = 47961,
  [SMALL_STATE(3142)] = 48052,
  [SMALL_STATE(3143)] = 48163,
  [SMALL_STATE(3144)] = 48262,
  [SMALL_STATE(3145)] = 48355,
  [SMALL_STATE(3146)] = 48454,
  [SMALL_STATE(3147)] = 48553,
  [SMALL_STATE(3148)] = 48618,
  [SMALL_STATE(3149)] = 48681,
  [SMALL_STATE(3150)] = 48750,
  [SMALL_STATE(3151)] = 48819,
  [SMALL_STATE(3152)] = 48930,
  [SMALL_STATE(3153)] = 48993,
  [SMALL_STATE(3154)] = 49066,
  [SMALL_STATE(3155)] = 49129,
  [SMALL_STATE(3156)] = 49192,
  [SMALL_STATE(3157)] = 49255,
  [SMALL_STATE(3158)] = 49318,
  [SMALL_STATE(3159)] = 49381,
  [SMALL_STATE(3160)] = 49444,
  [SMALL_STATE(3161)] = 49507,
  [SMALL_STATE(3162)] = 49618,
  [SMALL_STATE(3163)] = 49717,
  [SMALL_STATE(3164)] = 49816,
  [SMALL_STATE(3165)] = 49903,
  [SMALL_STATE(3166)] = 49966,
  [SMALL_STATE(3167)] = 50029,
  [SMALL_STATE(3168)] = 50092,
  [SMALL_STATE(3169)] = 50155,
  [SMALL_STATE(3170)] = 50226,
  [SMALL_STATE(3171)] = 50289,
  [SMALL_STATE(3172)] = 50352,
  [SMALL_STATE(3173)] = 50437,
  [SMALL_STATE(3174)] = 50548,
  [SMALL_STATE(3175)] = 50617,
  [SMALL_STATE(3176)] = 50700,
  [SMALL_STATE(3177)] = 50787,
  [SMALL_STATE(3178)] = 50850,
  [SMALL_STATE(3179)] = 50913,
  [SMALL_STATE(3180)] = 50976,
  [SMALL_STATE(3181)] = 51039,
  [SMALL_STATE(3182)] = 51102,
  [SMALL_STATE(3183)] = 51165,
  [SMALL_STATE(3184)] = 51282,
  [SMALL_STATE(3185)] = 51345,
  [SMALL_STATE(3186)] = 51408,
  [SMALL_STATE(3187)] = 51471,
  [SMALL_STATE(3188)] = 51534,
  [SMALL_STATE(3189)] = 51597,
  [SMALL_STATE(3190)] = 51660,
  [SMALL_STATE(3191)] = 51753,
  [SMALL_STATE(3192)] = 51870,
  [SMALL_STATE(3193)] = 51939,
  [SMALL_STATE(3194)] = 52002,
  [SMALL_STATE(3195)] = 52099,
  [SMALL_STATE(3196)] = 52162,
  [SMALL_STATE(3197)] = 52243,
  [SMALL_STATE(3198)] = 52322,
  [SMALL_STATE(3199)] = 52385,
  [SMALL_STATE(3200)] = 52448,
  [SMALL_STATE(3201)] = 52511,
  [SMALL_STATE(3202)] = 52574,
  [SMALL_STATE(3203)] = 52681,
  [SMALL_STATE(3204)] = 52754,
  [SMALL_STATE(3205)] = 52857,
  [SMALL_STATE(3206)] = 52920,
  [SMALL_STATE(3207)] = 52983,
  [SMALL_STATE(3208)] = 53082,
  [SMALL_STATE(3209)] = 53145,
  [SMALL_STATE(3210)] = 53208,
  [SMALL_STATE(3211)] = 53281,
  [SMALL_STATE(3212)] = 53389,
  [SMALL_STATE(3213)] = 53451,
  [SMALL_STATE(3214)] = 53559,
  [SMALL_STATE(3215)] = 53721,
  [SMALL_STATE(3216)] = 53829,
  [SMALL_STATE(3217)] = 53891,
  [SMALL_STATE(3218)] = 53999,
  [SMALL_STATE(3219)] = 54061,
  [SMALL_STATE(3220)] = 54177,
  [SMALL_STATE(3221)] = 54243,
  [SMALL_STATE(3222)] = 54305,
  [SMALL_STATE(3223)] = 54367,
  [SMALL_STATE(3224)] = 54429,
  [SMALL_STATE(3225)] = 54491,
  [SMALL_STATE(3226)] = 54599,
  [SMALL_STATE(3227)] = 54661,
  [SMALL_STATE(3228)] = 54723,
  [SMALL_STATE(3229)] = 54831,
  [SMALL_STATE(3230)] = 54899,
  [SMALL_STATE(3231)] = 55009,
  [SMALL_STATE(3232)] = 55117,
  [SMALL_STATE(3233)] = 55183,
  [SMALL_STATE(3234)] = 55299,
  [SMALL_STATE(3235)] = 55407,
  [SMALL_STATE(3236)] = 55515,
  [SMALL_STATE(3237)] = 55623,
  [SMALL_STATE(3238)] = 55731,
  [SMALL_STATE(3239)] = 55893,
  [SMALL_STATE(3240)] = 55959,
  [SMALL_STATE(3241)] = 56027,
  [SMALL_STATE(3242)] = 56137,
  [SMALL_STATE(3243)] = 56203,
  [SMALL_STATE(3244)] = 56265,
  [SMALL_STATE(3245)] = 56373,
  [SMALL_STATE(3246)] = 56451,
  [SMALL_STATE(3247)] = 56559,
  [SMALL_STATE(3248)] = 56667,
  [SMALL_STATE(3249)] = 56775,
  [SMALL_STATE(3250)] = 56837,
  [SMALL_STATE(3251)] = 56935,
  [SMALL_STATE(3252)] = 57043,
  [SMALL_STATE(3253)] = 57105,
  [SMALL_STATE(3254)] = 57213,
  [SMALL_STATE(3255)] = 57275,
  [SMALL_STATE(3256)] = 57337,
  [SMALL_STATE(3257)] = 57399,
  [SMALL_STATE(3258)] = 57461,
  [SMALL_STATE(3259)] = 57569,
  [SMALL_STATE(3260)] = 57631,
  [SMALL_STATE(3261)] = 57697,
  [SMALL_STATE(3262)] = 57759,
  [SMALL_STATE(3263)] = 57921,
  [SMALL_STATE(3264)] = 58029,
  [SMALL_STATE(3265)] = 58091,
  [SMALL_STATE(3266)] = 58159,
  [SMALL_STATE(3267)] = 58221,
  [SMALL_STATE(3268)] = 58329,
  [SMALL_STATE(3269)] = 58407,
  [SMALL_STATE(3270)] = 58491,
  [SMALL_STATE(3271)] = 58573,
  [SMALL_STATE(3272)] = 58659,
  [SMALL_STATE(3273)] = 58749,
  [SMALL_STATE(3274)] = 58841,
  [SMALL_STATE(3275)] = 58937,
  [SMALL_STATE(3276)] = 59035,
  [SMALL_STATE(3277)] = 59137,
  [SMALL_STATE(3278)] = 59243,
  [SMALL_STATE(3279)] = 59405,
  [SMALL_STATE(3280)] = 59483,
  [SMALL_STATE(3281)] = 59549,
  [SMALL_STATE(3282)] = 59629,
  [SMALL_STATE(3283)] = 59695,
  [SMALL_STATE(3284)] = 59807,
  [SMALL_STATE(3285)] = 59915,
  [SMALL_STATE(3286)] = 60023,
  [SMALL_STATE(3287)] = 60091,
  [SMALL_STATE(3288)] = 60207,
  [SMALL_STATE(3289)] = 60269,
  [SMALL_STATE(3290)] = 60331,
  [SMALL_STATE(3291)] = 60393,
  [SMALL_STATE(3292)] = 60455,
  [SMALL_STATE(3293)] = 60517,
  [SMALL_STATE(3294)] = 60579,
  [SMALL_STATE(3295)] = 60741,
  [SMALL_STATE(3296)] = 60803,
  [SMALL_STATE(3297)] = 60865,
  [SMALL_STATE(3298)] = 60975,
  [SMALL_STATE(3299)] = 61083,
  [SMALL_STATE(3300)] = 61191,
  [SMALL_STATE(3301)] = 61299,
  [SMALL_STATE(3302)] = 61407,
  [SMALL_STATE(3303)] = 61515,
  [SMALL_STATE(3304)] = 61577,
  [SMALL_STATE(3305)] = 61653,
  [SMALL_STATE(3306)] = 61763,
  [SMALL_STATE(3307)] = 61871,
  [SMALL_STATE(3308)] = 61935,
  [SMALL_STATE(3309)] = 62013,
  [SMALL_STATE(3310)] = 62091,
  [SMALL_STATE(3311)] = 62153,
  [SMALL_STATE(3312)] = 62215,
  [SMALL_STATE(3313)] = 62277,
  [SMALL_STATE(3314)] = 62339,
  [SMALL_STATE(3315)] = 62415,
  [SMALL_STATE(3316)] = 62513,
  [SMALL_STATE(3317)] = 62621,
  [SMALL_STATE(3318)] = 62729,
  [SMALL_STATE(3319)] = 62791,
  [SMALL_STATE(3320)] = 62853,
  [SMALL_STATE(3321)] = 62927,
  [SMALL_STATE(3322)] = 62989,
  [SMALL_STATE(3323)] = 63051,
  [SMALL_STATE(3324)] = 63129,
  [SMALL_STATE(3325)] = 63243,
  [SMALL_STATE(3326)] = 63351,
  [SMALL_STATE(3327)] = 63459,
  [SMALL_STATE(3328)] = 63567,
  [SMALL_STATE(3329)] = 63633,
  [SMALL_STATE(3330)] = 63741,
  [SMALL_STATE(3331)] = 63805,
  [SMALL_STATE(3332)] = 63867,
  [SMALL_STATE(3333)] = 63929,
  [SMALL_STATE(3334)] = 63991,
  [SMALL_STATE(3335)] = 64053,
  [SMALL_STATE(3336)] = 64115,
  [SMALL_STATE(3337)] = 64177,
  [SMALL_STATE(3338)] = 64245,
  [SMALL_STATE(3339)] = 64313,
  [SMALL_STATE(3340)] = 64421,
  [SMALL_STATE(3341)] = 64529,
  [SMALL_STATE(3342)] = 64643,
  [SMALL_STATE(3343)] = 64711,
  [SMALL_STATE(3344)] = 64819,
  [SMALL_STATE(3345)] = 64981,
  [SMALL_STATE(3346)] = 65089,
  [SMALL_STATE(3347)] = 65151,
  [SMALL_STATE(3348)] = 65259,
  [SMALL_STATE(3349)] = 65321,
  [SMALL_STATE(3350)] = 65429,
  [SMALL_STATE(3351)] = 65491,
  [SMALL_STATE(3352)] = 65553,
  [SMALL_STATE(3353)] = 65615,
  [SMALL_STATE(3354)] = 65677,
  [SMALL_STATE(3355)] = 65739,
  [SMALL_STATE(3356)] = 65901,
  [SMALL_STATE(3357)] = 66009,
  [SMALL_STATE(3358)] = 66071,
  [SMALL_STATE(3359)] = 66179,
  [SMALL_STATE(3360)] = 66245,
  [SMALL_STATE(3361)] = 66311,
  [SMALL_STATE(3362)] = 66373,
  [SMALL_STATE(3363)] = 66535,
  [SMALL_STATE(3364)] = 66601,
  [SMALL_STATE(3365)] = 66709,
  [SMALL_STATE(3366)] = 66775,
  [SMALL_STATE(3367)] = 66883,
  [SMALL_STATE(3368)] = 66951,
  [SMALL_STATE(3369)] = 67113,
  [SMALL_STATE(3370)] = 67179,
  [SMALL_STATE(3371)] = 67245,
  [SMALL_STATE(3372)] = 67323,
  [SMALL_STATE(3373)] = 67389,
  [SMALL_STATE(3374)] = 67501,
  [SMALL_STATE(3375)] = 67609,
  [SMALL_STATE(3376)] = 67717,
  [SMALL_STATE(3377)] = 67801,
  [SMALL_STATE(3378)] = 67883,
  [SMALL_STATE(3379)] = 67969,
  [SMALL_STATE(3380)] = 68057,
  [SMALL_STATE(3381)] = 68147,
  [SMALL_STATE(3382)] = 68241,
  [SMALL_STATE(3383)] = 68337,
  [SMALL_STATE(3384)] = 68437,
  [SMALL_STATE(3385)] = 68541,
  [SMALL_STATE(3386)] = 68619,
  [SMALL_STATE(3387)] = 68781,
  [SMALL_STATE(3388)] = 68861,
  [SMALL_STATE(3389)] = 68969,
  [SMALL_STATE(3390)] = 69077,
  [SMALL_STATE(3391)] = 69143,
  [SMALL_STATE(3392)] = 69209,
  [SMALL_STATE(3393)] = 69277,
  [SMALL_STATE(3394)] = 69343,
  [SMALL_STATE(3395)] = 69451,
  [SMALL_STATE(3396)] = 69559,
  [SMALL_STATE(3397)] = 69673,
  [SMALL_STATE(3398)] = 69735,
  [SMALL_STATE(3399)] = 69801,
  [SMALL_STATE(3400)] = 69909,
  [SMALL_STATE(3401)] = 70017,
  [SMALL_STATE(3402)] = 70087,
  [SMALL_STATE(3403)] = 70149,
  [SMALL_STATE(3404)] = 70257,
  [SMALL_STATE(3405)] = 70319,
  [SMALL_STATE(3406)] = 70427,
  [SMALL_STATE(3407)] = 70535,
  [SMALL_STATE(3408)] = 70597,
  [SMALL_STATE(3409)] = 70659,
  [SMALL_STATE(3410)] = 70721,
  [SMALL_STATE(3411)] = 70791,
  [SMALL_STATE(3412)] = 70859,
  [SMALL_STATE(3413)] = 70967,
  [SMALL_STATE(3414)] = 71075,
  [SMALL_STATE(3415)] = 71183,
  [SMALL_STATE(3416)] = 71249,
  [SMALL_STATE(3417)] = 71325,
  [SMALL_STATE(3418)] = 71403,
  [SMALL_STATE(3419)] = 71481,
  [SMALL_STATE(3420)] = 71543,
  [SMALL_STATE(3421)] = 71651,
  [SMALL_STATE(3422)] = 71763,
  [SMALL_STATE(3423)] = 71841,
  [SMALL_STATE(3424)] = 71917,
  [SMALL_STATE(3425)] = 72025,
  [SMALL_STATE(3426)] = 72089,
  [SMALL_STATE(3427)] = 72155,
  [SMALL_STATE(3428)] = 72233,
  [SMALL_STATE(3429)] = 72311,
  [SMALL_STATE(3430)] = 72373,
  [SMALL_STATE(3431)] = 72439,
  [SMALL_STATE(3432)] = 72501,
  [SMALL_STATE(3433)] = 72609,
  [SMALL_STATE(3434)] = 72679,
  [SMALL_STATE(3435)] = 72741,
  [SMALL_STATE(3436)] = 72849,
  [SMALL_STATE(3437)] = 72911,
  [SMALL_STATE(3438)] = 73019,
  [SMALL_STATE(3439)] = 73129,
  [SMALL_STATE(3440)] = 73241,
  [SMALL_STATE(3441)] = 73311,
  [SMALL_STATE(3442)] = 73387,
  [SMALL_STATE(3443)] = 73495,
  [SMALL_STATE(3444)] = 73557,
  [SMALL_STATE(3445)] = 73665,
  [SMALL_STATE(3446)] = 73741,
  [SMALL_STATE(3447)] = 73807,
  [SMALL_STATE(3448)] = 73915,
  [SMALL_STATE(3449)] = 73981,
  [SMALL_STATE(3450)] = 74043,
  [SMALL_STATE(3451)] = 74205,
  [SMALL_STATE(3452)] = 74313,
  [SMALL_STATE(3453)] = 74421,
  [SMALL_STATE(3454)] = 74483,
  [SMALL_STATE(3455)] = 74565,
  [SMALL_STATE(3456)] = 74673,
  [SMALL_STATE(3457)] = 74783,
  [SMALL_STATE(3458)] = 74891,
  [SMALL_STATE(3459)] = 74999,
  [SMALL_STATE(3460)] = 75115,
  [SMALL_STATE(3461)] = 75223,
  [SMALL_STATE(3462)] = 75331,
  [SMALL_STATE(3463)] = 75411,
  [SMALL_STATE(3464)] = 75477,
  [SMALL_STATE(3465)] = 75555,
  [SMALL_STATE(3466)] = 75661,
  [SMALL_STATE(3467)] = 75777,
  [SMALL_STATE(3468)] = 75887,
  [SMALL_STATE(3469)] = 75995,
  [SMALL_STATE(3470)] = 76097,
  [SMALL_STATE(3471)] = 76163,
  [SMALL_STATE(3472)] = 76271,
  [SMALL_STATE(3473)] = 76335,
  [SMALL_STATE(3474)] = 76451,
  [SMALL_STATE(3475)] = 76559,
  [SMALL_STATE(3476)] = 76657,
  [SMALL_STATE(3477)] = 76723,
  [SMALL_STATE(3478)] = 76843,
  [SMALL_STATE(3479)] = 76909,
  [SMALL_STATE(3480)] = 77019,
  [SMALL_STATE(3481)] = 77127,
  [SMALL_STATE(3482)] = 77223,
  [SMALL_STATE(3483)] = 77315,
  [SMALL_STATE(3484)] = 77423,
  [SMALL_STATE(3485)] = 77513,
  [SMALL_STATE(3486)] = 77599,
  [SMALL_STATE(3487)] = 77677,
  [SMALL_STATE(3488)] = 77761,
  [SMALL_STATE(3489)] = 77825,
  [SMALL_STATE(3490)] = 77886,
  [SMALL_STATE(3491)] = 77983,
  [SMALL_STATE(3492)] = 78044,
  [SMALL_STATE(3493)] = 78105,
  [SMALL_STATE(3494)] = 78166,
  [SMALL_STATE(3495)] = 78227,
  [SMALL_STATE(3496)] = 78288,
  [SMALL_STATE(3497)] = 78351,
  [SMALL_STATE(3498)] = 78412,
  [SMALL_STATE(3499)] = 78473,
  [SMALL_STATE(3500)] = 78534,
  [SMALL_STATE(3501)] = 78595,
  [SMALL_STATE(3502)] = 78664,
  [SMALL_STATE(3503)] = 78761,
  [SMALL_STATE(3504)] = 78866,
  [SMALL_STATE(3505)] = 78927,
  [SMALL_STATE(3506)] = 78988,
  [SMALL_STATE(3507)] = 79049,
  [SMALL_STATE(3508)] = 79114,
  [SMALL_STATE(3509)] = 79179,
  [SMALL_STATE(3510)] = 79240,
  [SMALL_STATE(3511)] = 79301,
  [SMALL_STATE(3512)] = 79362,
  [SMALL_STATE(3513)] = 79423,
  [SMALL_STATE(3514)] = 79528,
  [SMALL_STATE(3515)] = 79589,
  [SMALL_STATE(3516)] = 79694,
  [SMALL_STATE(3517)] = 79791,
  [SMALL_STATE(3518)] = 79854,
  [SMALL_STATE(3519)] = 79959,
  [SMALL_STATE(3520)] = 80026,
  [SMALL_STATE(3521)] = 80089,
  [SMALL_STATE(3522)] = 80152,
  [SMALL_STATE(3523)] = 80257,
  [SMALL_STATE(3524)] = 80354,
  [SMALL_STATE(3525)] = 80417,
  [SMALL_STATE(3526)] = 80484,
  [SMALL_STATE(3527)] = 80589,
  [SMALL_STATE(3528)] = 80694,
  [SMALL_STATE(3529)] = 80755,
  [SMALL_STATE(3530)] = 80860,
  [SMALL_STATE(3531)] = 80921,
  [SMALL_STATE(3532)] = 81026,
  [SMALL_STATE(3533)] = 81087,
  [SMALL_STATE(3534)] = 81192,
  [SMALL_STATE(3535)] = 81253,
  [SMALL_STATE(3536)] = 81320,
  [SMALL_STATE(3537)] = 81389,
  [SMALL_STATE(3538)] = 81450,
  [SMALL_STATE(3539)] = 81515,
  [SMALL_STATE(3540)] = 81588,
  [SMALL_STATE(3541)] = 81651,
  [SMALL_STATE(3542)] = 81712,
  [SMALL_STATE(3543)] = 81773,
  [SMALL_STATE(3544)] = 81834,
  [SMALL_STATE(3545)] = 81895,
  [SMALL_STATE(3546)] = 81964,
  [SMALL_STATE(3547)] = 82025,
  [SMALL_STATE(3548)] = 82086,
  [SMALL_STATE(3549)] = 82147,
  [SMALL_STATE(3550)] = 82208,
  [SMALL_STATE(3551)] = 82269,
  [SMALL_STATE(3552)] = 82336,
  [SMALL_STATE(3553)] = 82397,
  [SMALL_STATE(3554)] = 82458,
  [SMALL_STATE(3555)] = 82519,
  [SMALL_STATE(3556)] = 82580,
  [SMALL_STATE(3557)] = 82641,
  [SMALL_STATE(3558)] = 82702,
  [SMALL_STATE(3559)] = 82763,
  [SMALL_STATE(3560)] = 82868,
  [SMALL_STATE(3561)] = 82929,
  [SMALL_STATE(3562)] = 82990,
  [SMALL_STATE(3563)] = 83059,
  [SMALL_STATE(3564)] = 83120,
  [SMALL_STATE(3565)] = 83191,
  [SMALL_STATE(3566)] = 83256,
  [SMALL_STATE(3567)] = 83361,
  [SMALL_STATE(3568)] = 83422,
  [SMALL_STATE(3569)] = 83527,
  [SMALL_STATE(3570)] = 83594,
  [SMALL_STATE(3571)] = 83661,
  [SMALL_STATE(3572)] = 83724,
  [SMALL_STATE(3573)] = 83791,
  [SMALL_STATE(3574)] = 83864,
  [SMALL_STATE(3575)] = 83925,
  [SMALL_STATE(3576)] = 83992,
  [SMALL_STATE(3577)] = 84055,
  [SMALL_STATE(3578)] = 84160,
  [SMALL_STATE(3579)] = 84265,
  [SMALL_STATE(3580)] = 84326,
  [SMALL_STATE(3581)] = 84391,
  [SMALL_STATE(3582)] = 84456,
  [SMALL_STATE(3583)] = 84519,
  [SMALL_STATE(3584)] = 84584,
  [SMALL_STATE(3585)] = 84661,
  [SMALL_STATE(3586)] = 84722,
  [SMALL_STATE(3587)] = 84789,
  [SMALL_STATE(3588)] = 84849,
  [SMALL_STATE(3589)] = 84943,
  [SMALL_STATE(3590)] = 85003,
  [SMALL_STATE(3591)] = 85063,
  [SMALL_STATE(3592)] = 85127,
  [SMALL_STATE(3593)] = 85187,
  [SMALL_STATE(3594)] = 85247,
  [SMALL_STATE(3595)] = 85307,
  [SMALL_STATE(3596)] = 85367,
  [SMALL_STATE(3597)] = 85435,
  [SMALL_STATE(3598)] = 85495,
  [SMALL_STATE(3599)] = 85601,
  [SMALL_STATE(3600)] = 85661,
  [SMALL_STATE(3601)] = 85721,
  [SMALL_STATE(3602)] = 85781,
  [SMALL_STATE(3603)] = 85841,
  [SMALL_STATE(3604)] = 85901,
  [SMALL_STATE(3605)] = 85961,
  [SMALL_STATE(3606)] = 86021,
  [SMALL_STATE(3607)] = 86081,
  [SMALL_STATE(3608)] = 86141,
  [SMALL_STATE(3609)] = 86201,
  [SMALL_STATE(3610)] = 86299,
  [SMALL_STATE(3611)] = 86359,
  [SMALL_STATE(3612)] = 86457,
  [SMALL_STATE(3613)] = 86517,
  [SMALL_STATE(3614)] = 86577,
  [SMALL_STATE(3615)] = 86637,
  [SMALL_STATE(3616)] = 86699,
  [SMALL_STATE(3617)] = 86759,
  [SMALL_STATE(3618)] = 86819,
  [SMALL_STATE(3619)] = 86917,
  [SMALL_STATE(3620)] = 86977,
  [SMALL_STATE(3621)] = 87037,
  [SMALL_STATE(3622)] = 87097,
  [SMALL_STATE(3623)] = 87157,
  [SMALL_STATE(3624)] = 87217,
  [SMALL_STATE(3625)] = 87277,
  [SMALL_STATE(3626)] = 87337,
  [SMALL_STATE(3627)] = 87397,
  [SMALL_STATE(3628)] = 87457,
  [SMALL_STATE(3629)] = 87517,
  [SMALL_STATE(3630)] = 87581,
  [SMALL_STATE(3631)] = 87641,
  [SMALL_STATE(3632)] = 87705,
  [SMALL_STATE(3633)] = 87765,
  [SMALL_STATE(3634)] = 87877,
  [SMALL_STATE(3635)] = 87937,
  [SMALL_STATE(3636)] = 88049,
  [SMALL_STATE(3637)] = 88147,
  [SMALL_STATE(3638)] = 88245,
  [SMALL_STATE(3639)] = 88313,
  [SMALL_STATE(3640)] = 88373,
  [SMALL_STATE(3641)] = 88471,
  [SMALL_STATE(3642)] = 88531,
  [SMALL_STATE(3643)] = 88591,
  [SMALL_STATE(3644)] = 88651,
  [SMALL_STATE(3645)] = 88711,
  [SMALL_STATE(3646)] = 88771,
  [SMALL_STATE(3647)] = 88831,
  [SMALL_STATE(3648)] = 88901,
  [SMALL_STATE(3649)] = 88961,
  [SMALL_STATE(3650)] = 89021,
  [SMALL_STATE(3651)] = 89081,
  [SMALL_STATE(3652)] = 89179,
  [SMALL_STATE(3653)] = 89239,
  [SMALL_STATE(3654)] = 89337,
  [SMALL_STATE(3655)] = 89397,
  [SMALL_STATE(3656)] = 89465,
  [SMALL_STATE(3657)] = 89531,
  [SMALL_STATE(3658)] = 89591,
  [SMALL_STATE(3659)] = 89651,
  [SMALL_STATE(3660)] = 89711,
  [SMALL_STATE(3661)] = 89771,
  [SMALL_STATE(3662)] = 89831,
  [SMALL_STATE(3663)] = 89891,
  [SMALL_STATE(3664)] = 89951,
  [SMALL_STATE(3665)] = 90011,
  [SMALL_STATE(3666)] = 90071,
  [SMALL_STATE(3667)] = 90131,
  [SMALL_STATE(3668)] = 90191,
  [SMALL_STATE(3669)] = 90251,
  [SMALL_STATE(3670)] = 90311,
  [SMALL_STATE(3671)] = 90371,
  [SMALL_STATE(3672)] = 90431,
  [SMALL_STATE(3673)] = 90491,
  [SMALL_STATE(3674)] = 90551,
  [SMALL_STATE(3675)] = 90611,
  [SMALL_STATE(3676)] = 90671,
  [SMALL_STATE(3677)] = 90731,
  [SMALL_STATE(3678)] = 90791,
  [SMALL_STATE(3679)] = 90851,
  [SMALL_STATE(3680)] = 90929,
  [SMALL_STATE(3681)] = 90989,
  [SMALL_STATE(3682)] = 91049,
  [SMALL_STATE(3683)] = 91125,
  [SMALL_STATE(3684)] = 91185,
  [SMALL_STATE(3685)] = 91245,
  [SMALL_STATE(3686)] = 91349,
  [SMALL_STATE(3687)] = 91409,
  [SMALL_STATE(3688)] = 91511,
  [SMALL_STATE(3689)] = 91609,
  [SMALL_STATE(3690)] = 91669,
  [SMALL_STATE(3691)] = 91729,
  [SMALL_STATE(3692)] = 91789,
  [SMALL_STATE(3693)] = 91849,
  [SMALL_STATE(3694)] = 91909,
  [SMALL_STATE(3695)] = 91969,
  [SMALL_STATE(3696)] = 92029,
  [SMALL_STATE(3697)] = 92089,
  [SMALL_STATE(3698)] = 92187,
  [SMALL_STATE(3699)] = 92247,
  [SMALL_STATE(3700)] = 92307,
  [SMALL_STATE(3701)] = 92405,
  [SMALL_STATE(3702)] = 92465,
  [SMALL_STATE(3703)] = 92527,
  [SMALL_STATE(3704)] = 92587,
  [SMALL_STATE(3705)] = 92647,
  [SMALL_STATE(3706)] = 92737,
  [SMALL_STATE(3707)] = 92797,
  [SMALL_STATE(3708)] = 92885,
  [SMALL_STATE(3709)] = 92959,
  [SMALL_STATE(3710)] = 93021,
  [SMALL_STATE(3711)] = 93105,
  [SMALL_STATE(3712)] = 93203,
  [SMALL_STATE(3713)] = 93283,
  [SMALL_STATE(3714)] = 93343,
  [SMALL_STATE(3715)] = 93409,
  [SMALL_STATE(3716)] = 93469,
  [SMALL_STATE(3717)] = 93529,
  [SMALL_STATE(3718)] = 93589,
  [SMALL_STATE(3719)] = 93649,
  [SMALL_STATE(3720)] = 93709,
  [SMALL_STATE(3721)] = 93769,
  [SMALL_STATE(3722)] = 93829,
  [SMALL_STATE(3723)] = 93925,
  [SMALL_STATE(3724)] = 93985,
  [SMALL_STATE(3725)] = 94091,
  [SMALL_STATE(3726)] = 94173,
  [SMALL_STATE(3727)] = 94271,
  [SMALL_STATE(3728)] = 94331,
  [SMALL_STATE(3729)] = 94391,
  [SMALL_STATE(3730)] = 94451,
  [SMALL_STATE(3731)] = 94511,
  [SMALL_STATE(3732)] = 94571,
  [SMALL_STATE(3733)] = 94669,
  [SMALL_STATE(3734)] = 94737,
  [SMALL_STATE(3735)] = 94797,
  [SMALL_STATE(3736)] = 94857,
  [SMALL_STATE(3737)] = 94917,
  [SMALL_STATE(3738)] = 94977,
  [SMALL_STATE(3739)] = 95037,
  [SMALL_STATE(3740)] = 95135,
  [SMALL_STATE(3741)] = 95195,
  [SMALL_STATE(3742)] = 95255,
  [SMALL_STATE(3743)] = 95315,
  [SMALL_STATE(3744)] = 95375,
  [SMALL_STATE(3745)] = 95435,
  [SMALL_STATE(3746)] = 95495,
  [SMALL_STATE(3747)] = 95555,
  [SMALL_STATE(3748)] = 95617,
  [SMALL_STATE(3749)] = 95713,
  [SMALL_STATE(3750)] = 95773,
  [SMALL_STATE(3751)] = 95833,
  [SMALL_STATE(3752)] = 95945,
  [SMALL_STATE(3753)] = 96043,
  [SMALL_STATE(3754)] = 96103,
  [SMALL_STATE(3755)] = 96163,
  [SMALL_STATE(3756)] = 96225,
  [SMALL_STATE(3757)] = 96285,
  [SMALL_STATE(3758)] = 96369,
  [SMALL_STATE(3759)] = 96429,
  [SMALL_STATE(3760)] = 96491,
  [SMALL_STATE(3761)] = 96567,
  [SMALL_STATE(3762)] = 96643,
  [SMALL_STATE(3763)] = 96703,
  [SMALL_STATE(3764)] = 96769,
  [SMALL_STATE(3765)] = 96829,
  [SMALL_STATE(3766)] = 96889,
  [SMALL_STATE(3767)] = 96949,
  [SMALL_STATE(3768)] = 97019,
  [SMALL_STATE(3769)] = 97079,
  [SMALL_STATE(3770)] = 97143,
  [SMALL_STATE(3771)] = 97203,
  [SMALL_STATE(3772)] = 97263,
  [SMALL_STATE(3773)] = 97331,
  [SMALL_STATE(3774)] = 97391,
  [SMALL_STATE(3775)] = 97451,
  [SMALL_STATE(3776)] = 97511,
  [SMALL_STATE(3777)] = 97571,
  [SMALL_STATE(3778)] = 97631,
  [SMALL_STATE(3779)] = 97691,
  [SMALL_STATE(3780)] = 97751,
  [SMALL_STATE(3781)] = 97811,
  [SMALL_STATE(3782)] = 97871,
  [SMALL_STATE(3783)] = 97931,
  [SMALL_STATE(3784)] = 97991,
  [SMALL_STATE(3785)] = 98059,
  [SMALL_STATE(3786)] = 98119,
  [SMALL_STATE(3787)] = 98217,
  [SMALL_STATE(3788)] = 98277,
  [SMALL_STATE(3789)] = 98345,
  [SMALL_STATE(3790)] = 98407,
  [SMALL_STATE(3791)] = 98467,
  [SMALL_STATE(3792)] = 98551,
  [SMALL_STATE(3793)] = 98657,
  [SMALL_STATE(3794)] = 98717,
  [SMALL_STATE(3795)] = 98777,
  [SMALL_STATE(3796)] = 98837,
  [SMALL_STATE(3797)] = 98897,
  [SMALL_STATE(3798)] = 98957,
  [SMALL_STATE(3799)] = 99017,
  [SMALL_STATE(3800)] = 99077,
  [SMALL_STATE(3801)] = 99137,
  [SMALL_STATE(3802)] = 99197,
  [SMALL_STATE(3803)] = 99257,
  [SMALL_STATE(3804)] = 99317,
  [SMALL_STATE(3805)] = 99391,
  [SMALL_STATE(3806)] = 99455,
  [SMALL_STATE(3807)] = 99515,
  [SMALL_STATE(3808)] = 99591,
  [SMALL_STATE(3809)] = 99651,
  [SMALL_STATE(3810)] = 99711,
  [SMALL_STATE(3811)] = 99771,
  [SMALL_STATE(3812)] = 99831,
  [SMALL_STATE(3813)] = 99891,
  [SMALL_STATE(3814)] = 99951,
  [SMALL_STATE(3815)] = 100011,
  [SMALL_STATE(3816)] = 100071,
  [SMALL_STATE(3817)] = 100131,
  [SMALL_STATE(3818)] = 100191,
  [SMALL_STATE(3819)] = 100251,
  [SMALL_STATE(3820)] = 100317,
  [SMALL_STATE(3821)] = 100377,
  [SMALL_STATE(3822)] = 100437,
  [SMALL_STATE(3823)] = 100497,
  [SMALL_STATE(3824)] = 100581,
  [SMALL_STATE(3825)] = 100641,
  [SMALL_STATE(3826)] = 100701,
  [SMALL_STATE(3827)] = 100807,
  [SMALL_STATE(3828)] = 100867,
  [SMALL_STATE(3829)] = 100935,
  [SMALL_STATE(3830)] = 100995,
  [SMALL_STATE(3831)] = 101065,
  [SMALL_STATE(3832)] = 101127,
  [SMALL_STATE(3833)] = 101187,
  [SMALL_STATE(3834)] = 101249,
  [SMALL_STATE(3835)] = 101317,
  [SMALL_STATE(3836)] = 101381,
  [SMALL_STATE(3837)] = 101441,
  [SMALL_STATE(3838)] = 101507,
  [SMALL_STATE(3839)] = 101605,
  [SMALL_STATE(3840)] = 101665,
  [SMALL_STATE(3841)] = 101763,
  [SMALL_STATE(3842)] = 101822,
  [SMALL_STATE(3843)] = 101881,
  [SMALL_STATE(3844)] = 101940,
  [SMALL_STATE(3845)] = 101999,
  [SMALL_STATE(3846)] = 102062,
  [SMALL_STATE(3847)] = 102121,
  [SMALL_STATE(3848)] = 102180,
  [SMALL_STATE(3849)] = 102243,
  [SMALL_STATE(3850)] = 102306,
  [SMALL_STATE(3851)] = 102365,
  [SMALL_STATE(3852)] = 102424,
  [SMALL_STATE(3853)] = 102483,
  [SMALL_STATE(3854)] = 102542,
  [SMALL_STATE(3855)] = 102601,
  [SMALL_STATE(3856)] = 102668,
  [SMALL_STATE(3857)] = 102731,
  [SMALL_STATE(3858)] = 102794,
  [SMALL_STATE(3859)] = 102857,
  [SMALL_STATE(3860)] = 102916,
  [SMALL_STATE(3861)] = 102975,
  [SMALL_STATE(3862)] = 103034,
  [SMALL_STATE(3863)] = 103093,
  [SMALL_STATE(3864)] = 103152,
  [SMALL_STATE(3865)] = 103211,
  [SMALL_STATE(3866)] = 103270,
  [SMALL_STATE(3867)] = 103329,
  [SMALL_STATE(3868)] = 103388,
  [SMALL_STATE(3869)] = 103447,
  [SMALL_STATE(3870)] = 103510,
  [SMALL_STATE(3871)] = 103569,
  [SMALL_STATE(3872)] = 103628,
  [SMALL_STATE(3873)] = 103687,
  [SMALL_STATE(3874)] = 103746,
  [SMALL_STATE(3875)] = 103805,
  [SMALL_STATE(3876)] = 103864,
  [SMALL_STATE(3877)] = 103923,
  [SMALL_STATE(3878)] = 103982,
  [SMALL_STATE(3879)] = 104041,
  [SMALL_STATE(3880)] = 104100,
  [SMALL_STATE(3881)] = 104159,
  [SMALL_STATE(3882)] = 104218,
  [SMALL_STATE(3883)] = 104281,
  [SMALL_STATE(3884)] = 104340,
  [SMALL_STATE(3885)] = 104399,
  [SMALL_STATE(3886)] = 104458,
  [SMALL_STATE(3887)] = 104517,
  [SMALL_STATE(3888)] = 104576,
  [SMALL_STATE(3889)] = 104635,
  [SMALL_STATE(3890)] = 104694,
  [SMALL_STATE(3891)] = 104753,
  [SMALL_STATE(3892)] = 104812,
  [SMALL_STATE(3893)] = 104871,
  [SMALL_STATE(3894)] = 104930,
  [SMALL_STATE(3895)] = 104989,
  [SMALL_STATE(3896)] = 105048,
  [SMALL_STATE(3897)] = 105111,
  [SMALL_STATE(3898)] = 105170,
  [SMALL_STATE(3899)] = 105229,
  [SMALL_STATE(3900)] = 105288,
  [SMALL_STATE(3901)] = 105353,
  [SMALL_STATE(3902)] = 105412,
  [SMALL_STATE(3903)] = 105471,
  [SMALL_STATE(3904)] = 105530,
  [SMALL_STATE(3905)] = 105589,
  [SMALL_STATE(3906)] = 105648,
  [SMALL_STATE(3907)] = 105707,
  [SMALL_STATE(3908)] = 105766,
  [SMALL_STATE(3909)] = 105825,
  [SMALL_STATE(3910)] = 105884,
  [SMALL_STATE(3911)] = 105943,
  [SMALL_STATE(3912)] = 106038,
  [SMALL_STATE(3913)] = 106097,
  [SMALL_STATE(3914)] = 106156,
  [SMALL_STATE(3915)] = 106215,
  [SMALL_STATE(3916)] = 106274,
  [SMALL_STATE(3917)] = 106333,
  [SMALL_STATE(3918)] = 106392,
  [SMALL_STATE(3919)] = 106451,
  [SMALL_STATE(3920)] = 106510,
  [SMALL_STATE(3921)] = 106569,
  [SMALL_STATE(3922)] = 106628,
  [SMALL_STATE(3923)] = 106687,
  [SMALL_STATE(3924)] = 106746,
  [SMALL_STATE(3925)] = 106805,
  [SMALL_STATE(3926)] = 106864,
  [SMALL_STATE(3927)] = 106923,
  [SMALL_STATE(3928)] = 106982,
  [SMALL_STATE(3929)] = 107041,
  [SMALL_STATE(3930)] = 107100,
  [SMALL_STATE(3931)] = 107159,
  [SMALL_STATE(3932)] = 107218,
  [SMALL_STATE(3933)] = 107277,
  [SMALL_STATE(3934)] = 107336,
  [SMALL_STATE(3935)] = 107395,
  [SMALL_STATE(3936)] = 107454,
  [SMALL_STATE(3937)] = 107513,
  [SMALL_STATE(3938)] = 107584,
  [SMALL_STATE(3939)] = 107651,
  [SMALL_STATE(3940)] = 107710,
  [SMALL_STATE(3941)] = 107769,
  [SMALL_STATE(3942)] = 107828,
  [SMALL_STATE(3943)] = 107887,
  [SMALL_STATE(3944)] = 107946,
  [SMALL_STATE(3945)] = 108005,
  [SMALL_STATE(3946)] = 108064,
  [SMALL_STATE(3947)] = 108123,
  [SMALL_STATE(3948)] = 108184,
  [SMALL_STATE(3949)] = 108243,
  [SMALL_STATE(3950)] = 108302,
  [SMALL_STATE(3951)] = 108361,
  [SMALL_STATE(3952)] = 108420,
  [SMALL_STATE(3953)] = 108479,
  [SMALL_STATE(3954)] = 108540,
  [SMALL_STATE(3955)] = 108599,
  [SMALL_STATE(3956)] = 108662,
  [SMALL_STATE(3957)] = 108721,
  [SMALL_STATE(3958)] = 108780,
  [SMALL_STATE(3959)] = 108839,
  [SMALL_STATE(3960)] = 108898,
  [SMALL_STATE(3961)] = 108957,
  [SMALL_STATE(3962)] = 109018,
  [SMALL_STATE(3963)] = 109077,
  [SMALL_STATE(3964)] = 109136,
  [SMALL_STATE(3965)] = 109195,
  [SMALL_STATE(3966)] = 109254,
  [SMALL_STATE(3967)] = 109313,
  [SMALL_STATE(3968)] = 109372,
  [SMALL_STATE(3969)] = 109431,
  [SMALL_STATE(3970)] = 109490,
  [SMALL_STATE(3971)] = 109557,
  [SMALL_STATE(3972)] = 109616,
  [SMALL_STATE(3973)] = 109675,
  [SMALL_STATE(3974)] = 109734,
  [SMALL_STATE(3975)] = 109793,
  [SMALL_STATE(3976)] = 109858,
  [SMALL_STATE(3977)] = 109917,
  [SMALL_STATE(3978)] = 109976,
  [SMALL_STATE(3979)] = 110039,
  [SMALL_STATE(3980)] = 110102,
  [SMALL_STATE(3981)] = 110161,
  [SMALL_STATE(3982)] = 110220,
  [SMALL_STATE(3983)] = 110279,
  [SMALL_STATE(3984)] = 110338,
  [SMALL_STATE(3985)] = 110397,
  [SMALL_STATE(3986)] = 110456,
  [SMALL_STATE(3987)] = 110515,
  [SMALL_STATE(3988)] = 110574,
  [SMALL_STATE(3989)] = 110637,
  [SMALL_STATE(3990)] = 110696,
  [SMALL_STATE(3991)] = 110755,
  [SMALL_STATE(3992)] = 110814,
  [SMALL_STATE(3993)] = 110873,
  [SMALL_STATE(3994)] = 110936,
  [SMALL_STATE(3995)] = 110995,
  [SMALL_STATE(3996)] = 111054,
  [SMALL_STATE(3997)] = 111113,
  [SMALL_STATE(3998)] = 111172,
  [SMALL_STATE(3999)] = 111231,
  [SMALL_STATE(4000)] = 111290,
  [SMALL_STATE(4001)] = 111349,
  [SMALL_STATE(4002)] = 111408,
  [SMALL_STATE(4003)] = 111467,
  [SMALL_STATE(4004)] = 111526,
  [SMALL_STATE(4005)] = 111585,
  [SMALL_STATE(4006)] = 111644,
  [SMALL_STATE(4007)] = 111703,
  [SMALL_STATE(4008)] = 111762,
  [SMALL_STATE(4009)] = 111821,
  [SMALL_STATE(4010)] = 111880,
  [SMALL_STATE(4011)] = 111939,
  [SMALL_STATE(4012)] = 111998,
  [SMALL_STATE(4013)] = 112057,
  [SMALL_STATE(4014)] = 112152,
  [SMALL_STATE(4015)] = 112211,
  [SMALL_STATE(4016)] = 112270,
  [SMALL_STATE(4017)] = 112329,
  [SMALL_STATE(4018)] = 112388,
  [SMALL_STATE(4019)] = 112447,
  [SMALL_STATE(4020)] = 112506,
  [SMALL_STATE(4021)] = 112565,
  [SMALL_STATE(4022)] = 112624,
  [SMALL_STATE(4023)] = 112683,
  [SMALL_STATE(4024)] = 112750,
  [SMALL_STATE(4025)] = 112809,
  [SMALL_STATE(4026)] = 112868,
  [SMALL_STATE(4027)] = 112927,
  [SMALL_STATE(4028)] = 112990,
  [SMALL_STATE(4029)] = 113049,
  [SMALL_STATE(4030)] = 113108,
  [SMALL_STATE(4031)] = 113167,
  [SMALL_STATE(4032)] = 113226,
  [SMALL_STATE(4033)] = 113285,
  [SMALL_STATE(4034)] = 113344,
  [SMALL_STATE(4035)] = 113403,
  [SMALL_STATE(4036)] = 113470,
  [SMALL_STATE(4037)] = 113529,
  [SMALL_STATE(4038)] = 113588,
  [SMALL_STATE(4039)] = 113651,
  [SMALL_STATE(4040)] = 113710,
  [SMALL_STATE(4041)] = 113769,
  [SMALL_STATE(4042)] = 113828,
  [SMALL_STATE(4043)] = 113887,
  [SMALL_STATE(4044)] = 113946,
  [SMALL_STATE(4045)] = 114004,
  [SMALL_STATE(4046)] = 114098,
  [SMALL_STATE(4047)] = 114192,
  [SMALL_STATE(4048)] = 114286,
  [SMALL_STATE(4049)] = 114344,
  [SMALL_STATE(4050)] = 114438,
  [SMALL_STATE(4051)] = 114532,
  [SMALL_STATE(4052)] = 114622,
  [SMALL_STATE(4053)] = 114716,
  [SMALL_STATE(4054)] = 114810,
  [SMALL_STATE(4055)] = 114904,
  [SMALL_STATE(4056)] = 114974,
  [SMALL_STATE(4057)] = 115068,
  [SMALL_STATE(4058)] = 115134,
  [SMALL_STATE(4059)] = 115224,
  [SMALL_STATE(4060)] = 115314,
  [SMALL_STATE(4061)] = 115380,
  [SMALL_STATE(4062)] = 115446,
  [SMALL_STATE(4063)] = 115536,
  [SMALL_STATE(4064)] = 115630,
  [SMALL_STATE(4065)] = 115690,
  [SMALL_STATE(4066)] = 115750,
  [SMALL_STATE(4067)] = 115844,
  [SMALL_STATE(4068)] = 115938,
  [SMALL_STATE(4069)] = 116032,
  [SMALL_STATE(4070)] = 116126,
  [SMALL_STATE(4071)] = 116220,
  [SMALL_STATE(4072)] = 116314,
  [SMALL_STATE(4073)] = 116408,
  [SMALL_STATE(4074)] = 116502,
  [SMALL_STATE(4075)] = 116560,
  [SMALL_STATE(4076)] = 116654,
  [SMALL_STATE(4077)] = 116748,
  [SMALL_STATE(4078)] = 116808,
  [SMALL_STATE(4079)] = 116866,
  [SMALL_STATE(4080)] = 116926,
  [SMALL_STATE(4081)] = 117020,
  [SMALL_STATE(4082)] = 117086,
  [SMALL_STATE(4083)] = 117180,
  [SMALL_STATE(4084)] = 117250,
  [SMALL_STATE(4085)] = 117344,
  [SMALL_STATE(4086)] = 117402,
  [SMALL_STATE(4087)] = 117496,
  [SMALL_STATE(4088)] = 117586,
  [SMALL_STATE(4089)] = 117644,
  [SMALL_STATE(4090)] = 117706,
  [SMALL_STATE(4091)] = 117800,
  [SMALL_STATE(4092)] = 117894,
  [SMALL_STATE(4093)] = 117958,
  [SMALL_STATE(4094)] = 118052,
  [SMALL_STATE(4095)] = 118146,
  [SMALL_STATE(4096)] = 118240,
  [SMALL_STATE(4097)] = 118334,
  [SMALL_STATE(4098)] = 118392,
  [SMALL_STATE(4099)] = 118450,
  [SMALL_STATE(4100)] = 118508,
  [SMALL_STATE(4101)] = 118566,
  [SMALL_STATE(4102)] = 118660,
  [SMALL_STATE(4103)] = 118718,
  [SMALL_STATE(4104)] = 118776,
  [SMALL_STATE(4105)] = 118836,
  [SMALL_STATE(4106)] = 118894,
  [SMALL_STATE(4107)] = 118952,
  [SMALL_STATE(4108)] = 119046,
  [SMALL_STATE(4109)] = 119106,
  [SMALL_STATE(4110)] = 119196,
  [SMALL_STATE(4111)] = 119290,
  [SMALL_STATE(4112)] = 119352,
  [SMALL_STATE(4113)] = 119414,
  [SMALL_STATE(4114)] = 119508,
  [SMALL_STATE(4115)] = 119565,
  [SMALL_STATE(4116)] = 119622,
  [SMALL_STATE(4117)] = 119679,
  [SMALL_STATE(4118)] = 119736,
  [SMALL_STATE(4119)] = 119793,
  [SMALL_STATE(4120)] = 119850,
  [SMALL_STATE(4121)] = 119907,
  [SMALL_STATE(4122)] = 119964,
  [SMALL_STATE(4123)] = 120021,
  [SMALL_STATE(4124)] = 120078,
  [SMALL_STATE(4125)] = 120135,
  [SMALL_STATE(4126)] = 120208,
  [SMALL_STATE(4127)] = 120265,
  [SMALL_STATE(4128)] = 120322,
  [SMALL_STATE(4129)] = 120379,
  [SMALL_STATE(4130)] = 120436,
  [SMALL_STATE(4131)] = 120529,
  [SMALL_STATE(4132)] = 120586,
  [SMALL_STATE(4133)] = 120643,
  [SMALL_STATE(4134)] = 120706,
  [SMALL_STATE(4135)] = 120763,
  [SMALL_STATE(4136)] = 120820,
  [SMALL_STATE(4137)] = 120893,
  [SMALL_STATE(4138)] = 120950,
  [SMALL_STATE(4139)] = 121011,
  [SMALL_STATE(4140)] = 121100,
  [SMALL_STATE(4141)] = 121157,
  [SMALL_STATE(4142)] = 121214,
  [SMALL_STATE(4143)] = 121271,
  [SMALL_STATE(4144)] = 121328,
  [SMALL_STATE(4145)] = 121385,
  [SMALL_STATE(4146)] = 121442,
  [SMALL_STATE(4147)] = 121499,
  [SMALL_STATE(4148)] = 121592,
  [SMALL_STATE(4149)] = 121649,
  [SMALL_STATE(4150)] = 121706,
  [SMALL_STATE(4151)] = 121779,
  [SMALL_STATE(4152)] = 121836,
  [SMALL_STATE(4153)] = 121893,
  [SMALL_STATE(4154)] = 121982,
  [SMALL_STATE(4155)] = 122039,
  [SMALL_STATE(4156)] = 122096,
  [SMALL_STATE(4157)] = 122153,
  [SMALL_STATE(4158)] = 122210,
  [SMALL_STATE(4159)] = 122267,
  [SMALL_STATE(4160)] = 122324,
  [SMALL_STATE(4161)] = 122381,
  [SMALL_STATE(4162)] = 122438,
  [SMALL_STATE(4163)] = 122495,
  [SMALL_STATE(4164)] = 122552,
  [SMALL_STATE(4165)] = 122609,
  [SMALL_STATE(4166)] = 122680,
  [SMALL_STATE(4167)] = 122737,
  [SMALL_STATE(4168)] = 122800,
  [SMALL_STATE(4169)] = 122857,
  [SMALL_STATE(4170)] = 122914,
  [SMALL_STATE(4171)] = 122971,
  [SMALL_STATE(4172)] = 123028,
  [SMALL_STATE(4173)] = 123085,
  [SMALL_STATE(4174)] = 123142,
  [SMALL_STATE(4175)] = 123199,
  [SMALL_STATE(4176)] = 123256,
  [SMALL_STATE(4177)] = 123313,
  [SMALL_STATE(4178)] = 123370,
  [SMALL_STATE(4179)] = 123437,
  [SMALL_STATE(4180)] = 123494,
  [SMALL_STATE(4181)] = 123551,
  [SMALL_STATE(4182)] = 123608,
  [SMALL_STATE(4183)] = 123665,
  [SMALL_STATE(4184)] = 123738,
  [SMALL_STATE(4185)] = 123795,
  [SMALL_STATE(4186)] = 123852,
  [SMALL_STATE(4187)] = 123909,
  [SMALL_STATE(4188)] = 123966,
  [SMALL_STATE(4189)] = 124023,
  [SMALL_STATE(4190)] = 124080,
  [SMALL_STATE(4191)] = 124137,
  [SMALL_STATE(4192)] = 124194,
  [SMALL_STATE(4193)] = 124251,
  [SMALL_STATE(4194)] = 124308,
  [SMALL_STATE(4195)] = 124365,
  [SMALL_STATE(4196)] = 124422,
  [SMALL_STATE(4197)] = 124479,
  [SMALL_STATE(4198)] = 124536,
  [SMALL_STATE(4199)] = 124593,
  [SMALL_STATE(4200)] = 124650,
  [SMALL_STATE(4201)] = 124707,
  [SMALL_STATE(4202)] = 124764,
  [SMALL_STATE(4203)] = 124823,
  [SMALL_STATE(4204)] = 124887,
  [SMALL_STATE(4205)] = 124943,
  [SMALL_STATE(4206)] = 124999,
  [SMALL_STATE(4207)] = 125055,
  [SMALL_STATE(4208)] = 125119,
  [SMALL_STATE(4209)] = 125183,
  [SMALL_STATE(4210)] = 125239,
  [SMALL_STATE(4211)] = 125307,
  [SMALL_STATE(4212)] = 125373,
  [SMALL_STATE(4213)] = 125429,
  [SMALL_STATE(4214)] = 125517,
  [SMALL_STATE(4215)] = 125605,
  [SMALL_STATE(4216)] = 125667,
  [SMALL_STATE(4217)] = 125723,
  [SMALL_STATE(4218)] = 125779,
  [SMALL_STATE(4219)] = 125869,
  [SMALL_STATE(4220)] = 125959,
  [SMALL_STATE(4221)] = 126049,
  [SMALL_STATE(4222)] = 126105,
  [SMALL_STATE(4223)] = 126161,
  [SMALL_STATE(4224)] = 126251,
  [SMALL_STATE(4225)] = 126307,
  [SMALL_STATE(4226)] = 126363,
  [SMALL_STATE(4227)] = 126419,
  [SMALL_STATE(4228)] = 126475,
  [SMALL_STATE(4229)] = 126565,
  [SMALL_STATE(4230)] = 126621,
  [SMALL_STATE(4231)] = 126677,
  [SMALL_STATE(4232)] = 126743,
  [SMALL_STATE(4233)] = 126799,
  [SMALL_STATE(4234)] = 126855,
  [SMALL_STATE(4235)] = 126947,
  [SMALL_STATE(4236)] = 127009,
  [SMALL_STATE(4237)] = 127071,
  [SMALL_STATE(4238)] = 127131,
  [SMALL_STATE(4239)] = 127219,
  [SMALL_STATE(4240)] = 127309,
  [SMALL_STATE(4241)] = 127375,
  [SMALL_STATE(4242)] = 127431,
  [SMALL_STATE(4243)] = 127495,
  [SMALL_STATE(4244)] = 127551,
  [SMALL_STATE(4245)] = 127607,
  [SMALL_STATE(4246)] = 127663,
  [SMALL_STATE(4247)] = 127719,
  [SMALL_STATE(4248)] = 127807,
  [SMALL_STATE(4249)] = 127863,
  [SMALL_STATE(4250)] = 127919,
  [SMALL_STATE(4251)] = 127991,
  [SMALL_STATE(4252)] = 128083,
  [SMALL_STATE(4253)] = 128173,
  [SMALL_STATE(4254)] = 128229,
  [SMALL_STATE(4255)] = 128285,
  [SMALL_STATE(4256)] = 128341,
  [SMALL_STATE(4257)] = 128397,
  [SMALL_STATE(4258)] = 128453,
  [SMALL_STATE(4259)] = 128509,
  [SMALL_STATE(4260)] = 128573,
  [SMALL_STATE(4261)] = 128629,
  [SMALL_STATE(4262)] = 128719,
  [SMALL_STATE(4263)] = 128775,
  [SMALL_STATE(4264)] = 128831,
  [SMALL_STATE(4265)] = 128887,
  [SMALL_STATE(4266)] = 128943,
  [SMALL_STATE(4267)] = 128999,
  [SMALL_STATE(4268)] = 129067,
  [SMALL_STATE(4269)] = 129123,
  [SMALL_STATE(4270)] = 129179,
  [SMALL_STATE(4271)] = 129235,
  [SMALL_STATE(4272)] = 129291,
  [SMALL_STATE(4273)] = 129347,
  [SMALL_STATE(4274)] = 129439,
  [SMALL_STATE(4275)] = 129531,
  [SMALL_STATE(4276)] = 129587,
  [SMALL_STATE(4277)] = 129658,
  [SMALL_STATE(4278)] = 129729,
  [SMALL_STATE(4279)] = 129788,
  [SMALL_STATE(4280)] = 129847,
  [SMALL_STATE(4281)] = 129918,
  [SMALL_STATE(4282)] = 129979,
  [SMALL_STATE(4283)] = 130060,
  [SMALL_STATE(4284)] = 130119,
  [SMALL_STATE(4285)] = 130200,
  [SMALL_STATE(4286)] = 130291,
  [SMALL_STATE(4287)] = 130372,
  [SMALL_STATE(4288)] = 130433,
  [SMALL_STATE(4289)] = 130492,
  [SMALL_STATE(4290)] = 130573,
  [SMALL_STATE(4291)] = 130654,
  [SMALL_STATE(4292)] = 130735,
  [SMALL_STATE(4293)] = 130798,
  [SMALL_STATE(4294)] = 130857,
  [SMALL_STATE(4295)] = 130938,
  [SMALL_STATE(4296)] = 130999,
  [SMALL_STATE(4297)] = 131080,
  [SMALL_STATE(4298)] = 131167,
  [SMALL_STATE(4299)] = 131232,
  [SMALL_STATE(4300)] = 131297,
  [SMALL_STATE(4301)] = 131358,
  [SMALL_STATE(4302)] = 131445,
  [SMALL_STATE(4303)] = 131504,
  [SMALL_STATE(4304)] = 131563,
  [SMALL_STATE(4305)] = 131622,
  [SMALL_STATE(4306)] = 131713,
  [SMALL_STATE(4307)] = 131774,
  [SMALL_STATE(4308)] = 131833,
  [SMALL_STATE(4309)] = 131914,
  [SMALL_STATE(4310)] = 131973,
  [SMALL_STATE(4311)] = 132054,
  [SMALL_STATE(4312)] = 132145,
  [SMALL_STATE(4313)] = 132214,
  [SMALL_STATE(4314)] = 132273,
  [SMALL_STATE(4315)] = 132332,
  [SMALL_STATE(4316)] = 132423,
  [SMALL_STATE(4317)] = 132482,
  [SMALL_STATE(4318)] = 132563,
  [SMALL_STATE(4319)] = 132644,
  [SMALL_STATE(4320)] = 132715,
  [SMALL_STATE(4321)] = 132785,
  [SMALL_STATE(4322)] = 132839,
  [SMALL_STATE(4323)] = 132897,
  [SMALL_STATE(4324)] = 132955,
  [SMALL_STATE(4325)] = 133041,
  [SMALL_STATE(4326)] = 133099,
  [SMALL_STATE(4327)] = 133169,
  [SMALL_STATE(4328)] = 133227,
  [SMALL_STATE(4329)] = 133295,
  [SMALL_STATE(4330)] = 133353,
  [SMALL_STATE(4331)] = 133413,
  [SMALL_STATE(4332)] = 133471,
  [SMALL_STATE(4333)] = 133551,
  [SMALL_STATE(4334)] = 133607,
  [SMALL_STATE(4335)] = 133661,
  [SMALL_STATE(4336)] = 133721,
  [SMALL_STATE(4337)] = 133781,
  [SMALL_STATE(4338)] = 133867,
  [SMALL_STATE(4339)] = 133921,
  [SMALL_STATE(4340)] = 133991,
  [SMALL_STATE(4341)] = 134059,
  [SMALL_STATE(4342)] = 134123,
  [SMALL_STATE(4343)] = 134181,
  [SMALL_STATE(4344)] = 134235,
  [SMALL_STATE(4345)] = 134315,
  [SMALL_STATE(4346)] = 134375,
  [SMALL_STATE(4347)] = 134429,
  [SMALL_STATE(4348)] = 134483,
  [SMALL_STATE(4349)] = 134563,
  [SMALL_STATE(4350)] = 134617,
  [SMALL_STATE(4351)] = 134681,
  [SMALL_STATE(4352)] = 134741,
  [SMALL_STATE(4353)] = 134821,
  [SMALL_STATE(4354)] = 134891,
  [SMALL_STATE(4355)] = 134948,
  [SMALL_STATE(4356)] = 135023,
  [SMALL_STATE(4357)] = 135076,
  [SMALL_STATE(4358)] = 135155,
  [SMALL_STATE(4359)] = 135208,
  [SMALL_STATE(4360)] = 135261,
  [SMALL_STATE(4361)] = 135314,
  [SMALL_STATE(4362)] = 135425,
  [SMALL_STATE(4363)] = 135478,
  [SMALL_STATE(4364)] = 135531,
  [SMALL_STATE(4365)] = 135610,
  [SMALL_STATE(4366)] = 135689,
  [SMALL_STATE(4367)] = 135786,
  [SMALL_STATE(4368)] = 135855,
  [SMALL_STATE(4369)] = 135908,
  [SMALL_STATE(4370)] = 136013,
  [SMALL_STATE(4371)] = 136066,
  [SMALL_STATE(4372)] = 136131,
  [SMALL_STATE(4373)] = 136184,
  [SMALL_STATE(4374)] = 136237,
  [SMALL_STATE(4375)] = 136290,
  [SMALL_STATE(4376)] = 136369,
  [SMALL_STATE(4377)] = 136464,
  [SMALL_STATE(4378)] = 136533,
  [SMALL_STATE(4379)] = 136586,
  [SMALL_STATE(4380)] = 136677,
  [SMALL_STATE(4381)] = 136730,
  [SMALL_STATE(4382)] = 136783,
  [SMALL_STATE(4383)] = 136836,
  [SMALL_STATE(4384)] = 136889,
  [SMALL_STATE(4385)] = 136942,
  [SMALL_STATE(4386)] = 136999,
  [SMALL_STATE(4387)] = 137056,
  [SMALL_STATE(4388)] = 137157,
  [SMALL_STATE(4389)] = 137210,
  [SMALL_STATE(4390)] = 137273,
  [SMALL_STATE(4391)] = 137326,
  [SMALL_STATE(4392)] = 137415,
  [SMALL_STATE(4393)] = 137476,
  [SMALL_STATE(4394)] = 137539,
  [SMALL_STATE(4395)] = 137592,
  [SMALL_STATE(4396)] = 137645,
  [SMALL_STATE(4397)] = 137698,
  [SMALL_STATE(4398)] = 137767,
  [SMALL_STATE(4399)] = 137846,
  [SMALL_STATE(4400)] = 137899,
  [SMALL_STATE(4401)] = 137958,
  [SMALL_STATE(4402)] = 138011,
  [SMALL_STATE(4403)] = 138100,
  [SMALL_STATE(4404)] = 138157,
  [SMALL_STATE(4405)] = 138210,
  [SMALL_STATE(4406)] = 138269,
  [SMALL_STATE(4407)] = 138374,
  [SMALL_STATE(4408)] = 138463,
  [SMALL_STATE(4409)] = 138516,
  [SMALL_STATE(4410)] = 138569,
  [SMALL_STATE(4411)] = 138622,
  [SMALL_STATE(4412)] = 138675,
  [SMALL_STATE(4413)] = 138760,
  [SMALL_STATE(4414)] = 138845,
  [SMALL_STATE(4415)] = 138898,
  [SMALL_STATE(4416)] = 138951,
  [SMALL_STATE(4417)] = 139016,
  [SMALL_STATE(4418)] = 139127,
  [SMALL_STATE(4419)] = 139182,
  [SMALL_STATE(4420)] = 139239,
  [SMALL_STATE(4421)] = 139292,
  [SMALL_STATE(4422)] = 139357,
  [SMALL_STATE(4423)] = 139414,
  [SMALL_STATE(4424)] = 139467,
  [SMALL_STATE(4425)] = 139530,
  [SMALL_STATE(4426)] = 139611,
  [SMALL_STATE(4427)] = 139668,
  [SMALL_STATE(4428)] = 139779,
  [SMALL_STATE(4429)] = 139858,
  [SMALL_STATE(4430)] = 139911,
  [SMALL_STATE(4431)] = 139968,
  [SMALL_STATE(4432)] = 140053,
  [SMALL_STATE(4433)] = 140118,
  [SMALL_STATE(4434)] = 140173,
  [SMALL_STATE(4435)] = 140242,
  [SMALL_STATE(4436)] = 140297,
  [SMALL_STATE(4437)] = 140362,
  [SMALL_STATE(4438)] = 140415,
  [SMALL_STATE(4439)] = 140494,
  [SMALL_STATE(4440)] = 140551,
  [SMALL_STATE(4441)] = 140610,
  [SMALL_STATE(4442)] = 140663,
  [SMALL_STATE(4443)] = 140768,
  [SMALL_STATE(4444)] = 140825,
  [SMALL_STATE(4445)] = 140904,
  [SMALL_STATE(4446)] = 140969,
  [SMALL_STATE(4447)] = 141042,
  [SMALL_STATE(4448)] = 141147,
  [SMALL_STATE(4449)] = 141258,
  [SMALL_STATE(4450)] = 141311,
  [SMALL_STATE(4451)] = 141364,
  [SMALL_STATE(4452)] = 141417,
  [SMALL_STATE(4453)] = 141470,
  [SMALL_STATE(4454)] = 141549,
  [SMALL_STATE(4455)] = 141633,
  [SMALL_STATE(4456)] = 141711,
  [SMALL_STATE(4457)] = 141763,
  [SMALL_STATE(4458)] = 141819,
  [SMALL_STATE(4459)] = 141897,
  [SMALL_STATE(4460)] = 141949,
  [SMALL_STATE(4461)] = 142011,
  [SMALL_STATE(4462)] = 142063,
  [SMALL_STATE(4463)] = 142131,
  [SMALL_STATE(4464)] = 142215,
  [SMALL_STATE(4465)] = 142283,
  [SMALL_STATE(4466)] = 142361,
  [SMALL_STATE(4467)] = 142413,
  [SMALL_STATE(4468)] = 142481,
  [SMALL_STATE(4469)] = 142559,
  [SMALL_STATE(4470)] = 142611,
  [SMALL_STATE(4471)] = 142679,
  [SMALL_STATE(4472)] = 142741,
  [SMALL_STATE(4473)] = 142809,
  [SMALL_STATE(4474)] = 142877,
  [SMALL_STATE(4475)] = 142945,
  [SMALL_STATE(4476)] = 143013,
  [SMALL_STATE(4477)] = 143081,
  [SMALL_STATE(4478)] = 143140,
  [SMALL_STATE(4479)] = 143217,
  [SMALL_STATE(4480)] = 143270,
  [SMALL_STATE(4481)] = 143371,
  [SMALL_STATE(4482)] = 143454,
  [SMALL_STATE(4483)] = 143507,
  [SMALL_STATE(4484)] = 143558,
  [SMALL_STATE(4485)] = 143609,
  [SMALL_STATE(4486)] = 143670,
  [SMALL_STATE(4487)] = 143747,
  [SMALL_STATE(4488)] = 143812,
  [SMALL_STATE(4489)] = 143873,
  [SMALL_STATE(4490)] = 143928,
  [SMALL_STATE(4491)] = 143983,
  [SMALL_STATE(4492)] = 144034,
  [SMALL_STATE(4493)] = 144085,
  [SMALL_STATE(4494)] = 144140,
  [SMALL_STATE(4495)] = 144191,
  [SMALL_STATE(4496)] = 144246,
  [SMALL_STATE(4497)] = 144301,
  [SMALL_STATE(4498)] = 144356,
  [SMALL_STATE(4499)] = 144421,
  [SMALL_STATE(4500)] = 144476,
  [SMALL_STATE(4501)] = 144543,
  [SMALL_STATE(4502)] = 144620,
  [SMALL_STATE(4503)] = 144677,
  [SMALL_STATE(4504)] = 144760,
  [SMALL_STATE(4505)] = 144811,
  [SMALL_STATE(4506)] = 144864,
  [SMALL_STATE(4507)] = 144927,
  [SMALL_STATE(4508)] = 144984,
  [SMALL_STATE(4509)] = 145041,
  [SMALL_STATE(4510)] = 145152,
  [SMALL_STATE(4511)] = 145203,
  [SMALL_STATE(4512)] = 145254,
  [SMALL_STATE(4513)] = 145305,
  [SMALL_STATE(4514)] = 145406,
  [SMALL_STATE(4515)] = 145467,
  [SMALL_STATE(4516)] = 145518,
  [SMALL_STATE(4517)] = 145569,
  [SMALL_STATE(4518)] = 145636,
  [SMALL_STATE(4519)] = 145687,
  [SMALL_STATE(4520)] = 145738,
  [SMALL_STATE(4521)] = 145795,
  [SMALL_STATE(4522)] = 145854,
  [SMALL_STATE(4523)] = 145907,
  [SMALL_STATE(4524)] = 145974,
  [SMALL_STATE(4525)] = 146033,
  [SMALL_STATE(4526)] = 146084,
  [SMALL_STATE(4527)] = 146135,
  [SMALL_STATE(4528)] = 146186,
  [SMALL_STATE(4529)] = 146263,
  [SMALL_STATE(4530)] = 146374,
  [SMALL_STATE(4531)] = 146441,
  [SMALL_STATE(4532)] = 146504,
  [SMALL_STATE(4533)] = 146557,
  [SMALL_STATE(4534)] = 146668,
  [SMALL_STATE(4535)] = 146729,
  [SMALL_STATE(4536)] = 146796,
  [SMALL_STATE(4537)] = 146891,
  [SMALL_STATE(4538)] = 146945,
  [SMALL_STATE(4539)] = 147027,
  [SMALL_STATE(4540)] = 147081,
  [SMALL_STATE(4541)] = 147177,
  [SMALL_STATE(4542)] = 147231,
  [SMALL_STATE(4543)] = 147285,
  [SMALL_STATE(4544)] = 147361,
  [SMALL_STATE(4545)] = 147437,
  [SMALL_STATE(4546)] = 147515,
  [SMALL_STATE(4547)] = 147593,
  [SMALL_STATE(4548)] = 147669,
  [SMALL_STATE(4549)] = 147747,
  [SMALL_STATE(4550)] = 147825,
  [SMALL_STATE(4551)] = 147883,
  [SMALL_STATE(4552)] = 147937,
  [SMALL_STATE(4553)] = 147991,
  [SMALL_STATE(4554)] = 148047,
  [SMALL_STATE(4555)] = 148099,
  [SMALL_STATE(4556)] = 148177,
  [SMALL_STATE(4557)] = 148259,
  [SMALL_STATE(4558)] = 148337,
  [SMALL_STATE(4559)] = 148389,
  [SMALL_STATE(4560)] = 148467,
  [SMALL_STATE(4561)] = 148529,
  [SMALL_STATE(4562)] = 148607,
  [SMALL_STATE(4563)] = 148679,
  [SMALL_STATE(4564)] = 148757,
  [SMALL_STATE(4565)] = 148839,
  [SMALL_STATE(4566)] = 148941,
  [SMALL_STATE(4567)] = 149025,
  [SMALL_STATE(4568)] = 149113,
  [SMALL_STATE(4569)] = 149191,
  [SMALL_STATE(4570)] = 149269,
  [SMALL_STATE(4571)] = 149359,
  [SMALL_STATE(4572)] = 149451,
  [SMALL_STATE(4573)] = 149545,
  [SMALL_STATE(4574)] = 149599,
  [SMALL_STATE(4575)] = 149695,
  [SMALL_STATE(4576)] = 149765,
  [SMALL_STATE(4577)] = 149843,
  [SMALL_STATE(4578)] = 149921,
  [SMALL_STATE(4579)] = 149975,
  [SMALL_STATE(4580)] = 150029,
  [SMALL_STATE(4581)] = 150105,
  [SMALL_STATE(4582)] = 150159,
  [SMALL_STATE(4583)] = 150225,
  [SMALL_STATE(4584)] = 150303,
  [SMALL_STATE(4585)] = 150379,
  [SMALL_STATE(4586)] = 150433,
  [SMALL_STATE(4587)] = 150491,
  [SMALL_STATE(4588)] = 150573,
  [SMALL_STATE(4589)] = 150627,
  [SMALL_STATE(4590)] = 150723,
  [SMALL_STATE(4591)] = 150801,
  [SMALL_STATE(4592)] = 150883,
  [SMALL_STATE(4593)] = 150939,
  [SMALL_STATE(4594)] = 150993,
  [SMALL_STATE(4595)] = 151043,
  [SMALL_STATE(4596)] = 151097,
  [SMALL_STATE(4597)] = 151175,
  [SMALL_STATE(4598)] = 151233,
  [SMALL_STATE(4599)] = 151311,
  [SMALL_STATE(4600)] = 151389,
  [SMALL_STATE(4601)] = 151467,
  [SMALL_STATE(4602)] = 151545,
  [SMALL_STATE(4603)] = 151647,
  [SMALL_STATE(4604)] = 151725,
  [SMALL_STATE(4605)] = 151803,
  [SMALL_STATE(4606)] = 151899,
  [SMALL_STATE(4607)] = 151961,
  [SMALL_STATE(4608)] = 152039,
  [SMALL_STATE(4609)] = 152095,
  [SMALL_STATE(4610)] = 152149,
  [SMALL_STATE(4611)] = 152205,
  [SMALL_STATE(4612)] = 152259,
  [SMALL_STATE(4613)] = 152361,
  [SMALL_STATE(4614)] = 152413,
  [SMALL_STATE(4615)] = 152521,
  [SMALL_STATE(4616)] = 152599,
  [SMALL_STATE(4617)] = 152677,
  [SMALL_STATE(4618)] = 152727,
  [SMALL_STATE(4619)] = 152776,
  [SMALL_STATE(4620)] = 152825,
  [SMALL_STATE(4621)] = 152874,
  [SMALL_STATE(4622)] = 152975,
  [SMALL_STATE(4623)] = 153028,
  [SMALL_STATE(4624)] = 153129,
  [SMALL_STATE(4625)] = 153234,
  [SMALL_STATE(4626)] = 153339,
  [SMALL_STATE(4627)] = 153440,
  [SMALL_STATE(4628)] = 153545,
  [SMALL_STATE(4629)] = 153596,
  [SMALL_STATE(4630)] = 153697,
  [SMALL_STATE(4631)] = 153766,
  [SMALL_STATE(4632)] = 153871,
  [SMALL_STATE(4633)] = 153946,
  [SMALL_STATE(4634)] = 154047,
  [SMALL_STATE(4635)] = 154152,
  [SMALL_STATE(4636)] = 154257,
  [SMALL_STATE(4637)] = 154310,
  [SMALL_STATE(4638)] = 154405,
  [SMALL_STATE(4639)] = 154510,
  [SMALL_STATE(4640)] = 154563,
  [SMALL_STATE(4641)] = 154664,
  [SMALL_STATE(4642)] = 154769,
  [SMALL_STATE(4643)] = 154858,
  [SMALL_STATE(4644)] = 154963,
  [SMALL_STATE(4645)] = 155064,
  [SMALL_STATE(4646)] = 155165,
  [SMALL_STATE(4647)] = 155266,
  [SMALL_STATE(4648)] = 155319,
  [SMALL_STATE(4649)] = 155374,
  [SMALL_STATE(4650)] = 155475,
  [SMALL_STATE(4651)] = 155576,
  [SMALL_STATE(4652)] = 155681,
  [SMALL_STATE(4653)] = 155782,
  [SMALL_STATE(4654)] = 155887,
  [SMALL_STATE(4655)] = 155982,
  [SMALL_STATE(4656)] = 156083,
  [SMALL_STATE(4657)] = 156184,
  [SMALL_STATE(4658)] = 156237,
  [SMALL_STATE(4659)] = 156342,
  [SMALL_STATE(4660)] = 156443,
  [SMALL_STATE(4661)] = 156546,
  [SMALL_STATE(4662)] = 156641,
  [SMALL_STATE(4663)] = 156694,
  [SMALL_STATE(4664)] = 156799,
  [SMALL_STATE(4665)] = 156852,
  [SMALL_STATE(4666)] = 156957,
  [SMALL_STATE(4667)] = 157062,
  [SMALL_STATE(4668)] = 157167,
  [SMALL_STATE(4669)] = 157272,
  [SMALL_STATE(4670)] = 157377,
  [SMALL_STATE(4671)] = 157482,
  [SMALL_STATE(4672)] = 157577,
  [SMALL_STATE(4673)] = 157678,
  [SMALL_STATE(4674)] = 157783,
  [SMALL_STATE(4675)] = 157884,
  [SMALL_STATE(4676)] = 157933,
  [SMALL_STATE(4677)] = 157986,
  [SMALL_STATE(4678)] = 158091,
  [SMALL_STATE(4679)] = 158146,
  [SMALL_STATE(4680)] = 158251,
  [SMALL_STATE(4681)] = 158352,
  [SMALL_STATE(4682)] = 158457,
  [SMALL_STATE(4683)] = 158506,
  [SMALL_STATE(4684)] = 158555,
  [SMALL_STATE(4685)] = 158660,
  [SMALL_STATE(4686)] = 158709,
  [SMALL_STATE(4687)] = 158810,
  [SMALL_STATE(4688)] = 158915,
  [SMALL_STATE(4689)] = 159020,
  [SMALL_STATE(4690)] = 159125,
  [SMALL_STATE(4691)] = 159230,
  [SMALL_STATE(4692)] = 159335,
  [SMALL_STATE(4693)] = 159394,
  [SMALL_STATE(4694)] = 159499,
  [SMALL_STATE(4695)] = 159600,
  [SMALL_STATE(4696)] = 159653,
  [SMALL_STATE(4697)] = 159754,
  [SMALL_STATE(4698)] = 159803,
  [SMALL_STATE(4699)] = 159906,
  [SMALL_STATE(4700)] = 159961,
  [SMALL_STATE(4701)] = 160066,
  [SMALL_STATE(4702)] = 160167,
  [SMALL_STATE(4703)] = 160220,
  [SMALL_STATE(4704)] = 160325,
  [SMALL_STATE(4705)] = 160430,
  [SMALL_STATE(4706)] = 160505,
  [SMALL_STATE(4707)] = 160610,
  [SMALL_STATE(4708)] = 160703,
  [SMALL_STATE(4709)] = 160804,
  [SMALL_STATE(4710)] = 160895,
  [SMALL_STATE(4711)] = 160984,
  [SMALL_STATE(4712)] = 161059,
  [SMALL_STATE(4713)] = 161146,
  [SMALL_STATE(4714)] = 161251,
  [SMALL_STATE(4715)] = 161356,
  [SMALL_STATE(4716)] = 161461,
  [SMALL_STATE(4717)] = 161566,
  [SMALL_STATE(4718)] = 161671,
  [SMALL_STATE(4719)] = 161746,
  [SMALL_STATE(4720)] = 161801,
  [SMALL_STATE(4721)] = 161906,
  [SMALL_STATE(4722)] = 161981,
  [SMALL_STATE(4723)] = 162064,
  [SMALL_STATE(4724)] = 162169,
  [SMALL_STATE(4725)] = 162274,
  [SMALL_STATE(4726)] = 162355,
  [SMALL_STATE(4727)] = 162456,
  [SMALL_STATE(4728)] = 162561,
  [SMALL_STATE(4729)] = 162610,
  [SMALL_STATE(4730)] = 162687,
  [SMALL_STATE(4731)] = 162790,
  [SMALL_STATE(4732)] = 162843,
  [SMALL_STATE(4733)] = 162914,
  [SMALL_STATE(4734)] = 163019,
  [SMALL_STATE(4735)] = 163072,
  [SMALL_STATE(4736)] = 163174,
  [SMALL_STATE(4737)] = 163264,
  [SMALL_STATE(4738)] = 163358,
  [SMALL_STATE(4739)] = 163460,
  [SMALL_STATE(4740)] = 163562,
  [SMALL_STATE(4741)] = 163610,
  [SMALL_STATE(4742)] = 163658,
  [SMALL_STATE(4743)] = 163760,
  [SMALL_STATE(4744)] = 163862,
  [SMALL_STATE(4745)] = 163910,
  [SMALL_STATE(4746)] = 163984,
  [SMALL_STATE(4747)] = 164052,
  [SMALL_STATE(4748)] = 164124,
  [SMALL_STATE(4749)] = 164226,
  [SMALL_STATE(4750)] = 164326,
  [SMALL_STATE(4751)] = 164384,
  [SMALL_STATE(4752)] = 164448,
  [SMALL_STATE(4753)] = 164538,
  [SMALL_STATE(4754)] = 164640,
  [SMALL_STATE(4755)] = 164742,
  [SMALL_STATE(4756)] = 164790,
  [SMALL_STATE(4757)] = 164838,
  [SMALL_STATE(4758)] = 164926,
  [SMALL_STATE(4759)] = 165012,
  [SMALL_STATE(4760)] = 165096,
  [SMALL_STATE(4761)] = 165198,
  [SMALL_STATE(4762)] = 165278,
  [SMALL_STATE(4763)] = 165326,
  [SMALL_STATE(4764)] = 165380,
  [SMALL_STATE(4765)] = 165428,
  [SMALL_STATE(4766)] = 165506,
  [SMALL_STATE(4767)] = 165580,
  [SMALL_STATE(4768)] = 165650,
  [SMALL_STATE(4769)] = 165750,
  [SMALL_STATE(4770)] = 165846,
  [SMALL_STATE(4771)] = 165934,
  [SMALL_STATE(4772)] = 166006,
  [SMALL_STATE(4773)] = 166054,
  [SMALL_STATE(4774)] = 166102,
  [SMALL_STATE(4775)] = 166150,
  [SMALL_STATE(4776)] = 166212,
  [SMALL_STATE(4777)] = 166260,
  [SMALL_STATE(4778)] = 166308,
  [SMALL_STATE(4779)] = 166356,
  [SMALL_STATE(4780)] = 166418,
  [SMALL_STATE(4781)] = 166514,
  [SMALL_STATE(4782)] = 166610,
  [SMALL_STATE(4783)] = 166684,
  [SMALL_STATE(4784)] = 166778,
  [SMALL_STATE(4785)] = 166842,
  [SMALL_STATE(4786)] = 166944,
  [SMALL_STATE(4787)] = 166992,
  [SMALL_STATE(4788)] = 167066,
  [SMALL_STATE(4789)] = 167168,
  [SMALL_STATE(4790)] = 167264,
  [SMALL_STATE(4791)] = 167366,
  [SMALL_STATE(4792)] = 167430,
  [SMALL_STATE(4793)] = 167494,
  [SMALL_STATE(4794)] = 167544,
  [SMALL_STATE(4795)] = 167592,
  [SMALL_STATE(4796)] = 167682,
  [SMALL_STATE(4797)] = 167746,
  [SMALL_STATE(4798)] = 167848,
  [SMALL_STATE(4799)] = 167896,
  [SMALL_STATE(4800)] = 167944,
  [SMALL_STATE(4801)] = 168044,
  [SMALL_STATE(4802)] = 168146,
  [SMALL_STATE(4803)] = 168242,
  [SMALL_STATE(4804)] = 168290,
  [SMALL_STATE(4805)] = 168338,
  [SMALL_STATE(4806)] = 168402,
  [SMALL_STATE(4807)] = 168450,
  [SMALL_STATE(4808)] = 168498,
  [SMALL_STATE(4809)] = 168546,
  [SMALL_STATE(4810)] = 168594,
  [SMALL_STATE(4811)] = 168642,
  [SMALL_STATE(4812)] = 168690,
  [SMALL_STATE(4813)] = 168738,
  [SMALL_STATE(4814)] = 168786,
  [SMALL_STATE(4815)] = 168888,
  [SMALL_STATE(4816)] = 168962,
  [SMALL_STATE(4817)] = 169010,
  [SMALL_STATE(4818)] = 169058,
  [SMALL_STATE(4819)] = 169160,
  [SMALL_STATE(4820)] = 169262,
  [SMALL_STATE(4821)] = 169310,
  [SMALL_STATE(4822)] = 169372,
  [SMALL_STATE(4823)] = 169426,
  [SMALL_STATE(4824)] = 169528,
  [SMALL_STATE(4825)] = 169630,
  [SMALL_STATE(4826)] = 169730,
  [SMALL_STATE(4827)] = 169820,
  [SMALL_STATE(4828)] = 169914,
  [SMALL_STATE(4829)] = 170016,
  [SMALL_STATE(4830)] = 170064,
  [SMALL_STATE(4831)] = 170144,
  [SMALL_STATE(4832)] = 170230,
  [SMALL_STATE(4833)] = 170294,
  [SMALL_STATE(4834)] = 170342,
  [SMALL_STATE(4835)] = 170434,
  [SMALL_STATE(4836)] = 170536,
  [SMALL_STATE(4837)] = 170584,
  [SMALL_STATE(4838)] = 170632,
  [SMALL_STATE(4839)] = 170732,
  [SMALL_STATE(4840)] = 170834,
  [SMALL_STATE(4841)] = 170936,
  [SMALL_STATE(4842)] = 170984,
  [SMALL_STATE(4843)] = 171032,
  [SMALL_STATE(4844)] = 171080,
  [SMALL_STATE(4845)] = 171128,
  [SMALL_STATE(4846)] = 171228,
  [SMALL_STATE(4847)] = 171276,
  [SMALL_STATE(4848)] = 171324,
  [SMALL_STATE(4849)] = 171372,
  [SMALL_STATE(4850)] = 171474,
  [SMALL_STATE(4851)] = 171522,
  [SMALL_STATE(4852)] = 171586,
  [SMALL_STATE(4853)] = 171634,
  [SMALL_STATE(4854)] = 171702,
  [SMALL_STATE(4855)] = 171796,
  [SMALL_STATE(4856)] = 171898,
  [SMALL_STATE(4857)] = 172000,
  [SMALL_STATE(4858)] = 172100,
  [SMALL_STATE(4859)] = 172148,
  [SMALL_STATE(4860)] = 172250,
  [SMALL_STATE(4861)] = 172352,
  [SMALL_STATE(4862)] = 172416,
  [SMALL_STATE(4863)] = 172514,
  [SMALL_STATE(4864)] = 172562,
  [SMALL_STATE(4865)] = 172664,
  [SMALL_STATE(4866)] = 172738,
  [SMALL_STATE(4867)] = 172840,
  [SMALL_STATE(4868)] = 172942,
  [SMALL_STATE(4869)] = 173042,
  [SMALL_STATE(4870)] = 173090,
  [SMALL_STATE(4871)] = 173138,
  [SMALL_STATE(4872)] = 173212,
  [SMALL_STATE(4873)] = 173260,
  [SMALL_STATE(4874)] = 173308,
  [SMALL_STATE(4875)] = 173382,
  [SMALL_STATE(4876)] = 173430,
  [SMALL_STATE(4877)] = 173478,
  [SMALL_STATE(4878)] = 173540,
  [SMALL_STATE(4879)] = 173588,
  [SMALL_STATE(4880)] = 173690,
  [SMALL_STATE(4881)] = 173790,
  [SMALL_STATE(4882)] = 173890,
  [SMALL_STATE(4883)] = 173964,
  [SMALL_STATE(4884)] = 174012,
  [SMALL_STATE(4885)] = 174060,
  [SMALL_STATE(4886)] = 174108,
  [SMALL_STATE(4887)] = 174182,
  [SMALL_STATE(4888)] = 174256,
  [SMALL_STATE(4889)] = 174358,
  [SMALL_STATE(4890)] = 174448,
  [SMALL_STATE(4891)] = 174522,
  [SMALL_STATE(4892)] = 174624,
  [SMALL_STATE(4893)] = 174672,
  [SMALL_STATE(4894)] = 174720,
  [SMALL_STATE(4895)] = 174768,
  [SMALL_STATE(4896)] = 174816,
  [SMALL_STATE(4897)] = 174864,
  [SMALL_STATE(4898)] = 174912,
  [SMALL_STATE(4899)] = 174996,
  [SMALL_STATE(4900)] = 175096,
  [SMALL_STATE(4901)] = 175190,
  [SMALL_STATE(4902)] = 175238,
  [SMALL_STATE(4903)] = 175286,
  [SMALL_STATE(4904)] = 175334,
  [SMALL_STATE(4905)] = 175436,
  [SMALL_STATE(4906)] = 175536,
  [SMALL_STATE(4907)] = 175604,
  [SMALL_STATE(4908)] = 175652,
  [SMALL_STATE(4909)] = 175700,
  [SMALL_STATE(4910)] = 175800,
  [SMALL_STATE(4911)] = 175900,
  [SMALL_STATE(4912)] = 175998,
  [SMALL_STATE(4913)] = 176092,
  [SMALL_STATE(4914)] = 176194,
  [SMALL_STATE(4915)] = 176248,
  [SMALL_STATE(4916)] = 176296,
  [SMALL_STATE(4917)] = 176388,
  [SMALL_STATE(4918)] = 176490,
  [SMALL_STATE(4919)] = 176592,
  [SMALL_STATE(4920)] = 176646,
  [SMALL_STATE(4921)] = 176694,
  [SMALL_STATE(4922)] = 176748,
  [SMALL_STATE(4923)] = 176844,
  [SMALL_STATE(4924)] = 176942,
  [SMALL_STATE(4925)] = 177044,
  [SMALL_STATE(4926)] = 177108,
  [SMALL_STATE(4927)] = 177182,
  [SMALL_STATE(4928)] = 177256,
  [SMALL_STATE(4929)] = 177356,
  [SMALL_STATE(4930)] = 177458,
  [SMALL_STATE(4931)] = 177528,
  [SMALL_STATE(4932)] = 177584,
  [SMALL_STATE(4933)] = 177632,
  [SMALL_STATE(4934)] = 177696,
  [SMALL_STATE(4935)] = 177784,
  [SMALL_STATE(4936)] = 177832,
  [SMALL_STATE(4937)] = 177902,
  [SMALL_STATE(4938)] = 178004,
  [SMALL_STATE(4939)] = 178080,
  [SMALL_STATE(4940)] = 178176,
  [SMALL_STATE(4941)] = 178278,
  [SMALL_STATE(4942)] = 178340,
  [SMALL_STATE(4943)] = 178388,
  [SMALL_STATE(4944)] = 178468,
  [SMALL_STATE(4945)] = 178562,
  [SMALL_STATE(4946)] = 178644,
  [SMALL_STATE(4947)] = 178730,
  [SMALL_STATE(4948)] = 178784,
  [SMALL_STATE(4949)] = 178872,
  [SMALL_STATE(4950)] = 178962,
  [SMALL_STATE(4951)] = 179052,
  [SMALL_STATE(4952)] = 179144,
  [SMALL_STATE(4953)] = 179208,
  [SMALL_STATE(4954)] = 179294,
  [SMALL_STATE(4955)] = 179394,
  [SMALL_STATE(4956)] = 179450,
  [SMALL_STATE(4957)] = 179550,
  [SMALL_STATE(4958)] = 179618,
  [SMALL_STATE(4959)] = 179718,
  [SMALL_STATE(4960)] = 179766,
  [SMALL_STATE(4961)] = 179840,
  [SMALL_STATE(4962)] = 179934,
  [SMALL_STATE(4963)] = 180026,
  [SMALL_STATE(4964)] = 180108,
  [SMALL_STATE(4965)] = 180162,
  [SMALL_STATE(4966)] = 180242,
  [SMALL_STATE(4967)] = 180322,
  [SMALL_STATE(4968)] = 180370,
  [SMALL_STATE(4969)] = 180418,
  [SMALL_STATE(4970)] = 180466,
  [SMALL_STATE(4971)] = 180540,
  [SMALL_STATE(4972)] = 180622,
  [SMALL_STATE(4973)] = 180670,
  [SMALL_STATE(4974)] = 180718,
  [SMALL_STATE(4975)] = 180766,
  [SMALL_STATE(4976)] = 180828,
  [SMALL_STATE(4977)] = 180920,
  [SMALL_STATE(4978)] = 180968,
  [SMALL_STATE(4979)] = 181044,
  [SMALL_STATE(4980)] = 181092,
  [SMALL_STATE(4981)] = 181140,
  [SMALL_STATE(4982)] = 181194,
  [SMALL_STATE(4983)] = 181264,
  [SMALL_STATE(4984)] = 181312,
  [SMALL_STATE(4985)] = 181360,
  [SMALL_STATE(4986)] = 181462,
  [SMALL_STATE(4987)] = 181538,
  [SMALL_STATE(4988)] = 181640,
  [SMALL_STATE(4989)] = 181688,
  [SMALL_STATE(4990)] = 181790,
  [SMALL_STATE(4991)] = 181890,
  [SMALL_STATE(4992)] = 181988,
  [SMALL_STATE(4993)] = 182080,
  [SMALL_STATE(4994)] = 182158,
  [SMALL_STATE(4995)] = 182260,
  [SMALL_STATE(4996)] = 182308,
  [SMALL_STATE(4997)] = 182410,
  [SMALL_STATE(4998)] = 182458,
  [SMALL_STATE(4999)] = 182506,
  [SMALL_STATE(5000)] = 182565,
  [SMALL_STATE(5001)] = 182664,
  [SMALL_STATE(5002)] = 182713,
  [SMALL_STATE(5003)] = 182764,
  [SMALL_STATE(5004)] = 182823,
  [SMALL_STATE(5005)] = 182922,
  [SMALL_STATE(5006)] = 183021,
  [SMALL_STATE(5007)] = 183120,
  [SMALL_STATE(5008)] = 183219,
  [SMALL_STATE(5009)] = 183274,
  [SMALL_STATE(5010)] = 183373,
  [SMALL_STATE(5011)] = 183422,
  [SMALL_STATE(5012)] = 183521,
  [SMALL_STATE(5013)] = 183570,
  [SMALL_STATE(5014)] = 183669,
  [SMALL_STATE(5015)] = 183768,
  [SMALL_STATE(5016)] = 183867,
  [SMALL_STATE(5017)] = 183954,
  [SMALL_STATE(5018)] = 184053,
  [SMALL_STATE(5019)] = 184152,
  [SMALL_STATE(5020)] = 184251,
  [SMALL_STATE(5021)] = 184350,
  [SMALL_STATE(5022)] = 184449,
  [SMALL_STATE(5023)] = 184500,
  [SMALL_STATE(5024)] = 184599,
  [SMALL_STATE(5025)] = 184698,
  [SMALL_STATE(5026)] = 184797,
  [SMALL_STATE(5027)] = 184896,
  [SMALL_STATE(5028)] = 184995,
  [SMALL_STATE(5029)] = 185046,
  [SMALL_STATE(5030)] = 185145,
  [SMALL_STATE(5031)] = 185196,
  [SMALL_STATE(5032)] = 185295,
  [SMALL_STATE(5033)] = 185394,
  [SMALL_STATE(5034)] = 185493,
  [SMALL_STATE(5035)] = 185592,
  [SMALL_STATE(5036)] = 185691,
  [SMALL_STATE(5037)] = 185742,
  [SMALL_STATE(5038)] = 185815,
  [SMALL_STATE(5039)] = 185914,
  [SMALL_STATE(5040)] = 186013,
  [SMALL_STATE(5041)] = 186086,
  [SMALL_STATE(5042)] = 186185,
  [SMALL_STATE(5043)] = 186258,
  [SMALL_STATE(5044)] = 186309,
  [SMALL_STATE(5045)] = 186408,
  [SMALL_STATE(5046)] = 186507,
  [SMALL_STATE(5047)] = 186606,
  [SMALL_STATE(5048)] = 186679,
  [SMALL_STATE(5049)] = 186778,
  [SMALL_STATE(5050)] = 186877,
  [SMALL_STATE(5051)] = 186976,
  [SMALL_STATE(5052)] = 187027,
  [SMALL_STATE(5053)] = 187126,
  [SMALL_STATE(5054)] = 187185,
  [SMALL_STATE(5055)] = 187284,
  [SMALL_STATE(5056)] = 187383,
  [SMALL_STATE(5057)] = 187482,
  [SMALL_STATE(5058)] = 187581,
  [SMALL_STATE(5059)] = 187680,
  [SMALL_STATE(5060)] = 187779,
  [SMALL_STATE(5061)] = 187852,
  [SMALL_STATE(5062)] = 187951,
  [SMALL_STATE(5063)] = 188050,
  [SMALL_STATE(5064)] = 188123,
  [SMALL_STATE(5065)] = 188222,
  [SMALL_STATE(5066)] = 188277,
  [SMALL_STATE(5067)] = 188376,
  [SMALL_STATE(5068)] = 188475,
  [SMALL_STATE(5069)] = 188574,
  [SMALL_STATE(5070)] = 188673,
  [SMALL_STATE(5071)] = 188724,
  [SMALL_STATE(5072)] = 188775,
  [SMALL_STATE(5073)] = 188874,
  [SMALL_STATE(5074)] = 188973,
  [SMALL_STATE(5075)] = 189032,
  [SMALL_STATE(5076)] = 189131,
  [SMALL_STATE(5077)] = 189182,
  [SMALL_STATE(5078)] = 189281,
  [SMALL_STATE(5079)] = 189380,
  [SMALL_STATE(5080)] = 189479,
  [SMALL_STATE(5081)] = 189578,
  [SMALL_STATE(5082)] = 189629,
  [SMALL_STATE(5083)] = 189728,
  [SMALL_STATE(5084)] = 189779,
  [SMALL_STATE(5085)] = 189878,
  [SMALL_STATE(5086)] = 189977,
  [SMALL_STATE(5087)] = 190076,
  [SMALL_STATE(5088)] = 190175,
  [SMALL_STATE(5089)] = 190274,
  [SMALL_STATE(5090)] = 190373,
  [SMALL_STATE(5091)] = 190472,
  [SMALL_STATE(5092)] = 190525,
  [SMALL_STATE(5093)] = 190624,
  [SMALL_STATE(5094)] = 190723,
  [SMALL_STATE(5095)] = 190822,
  [SMALL_STATE(5096)] = 190921,
  [SMALL_STATE(5097)] = 191020,
  [SMALL_STATE(5098)] = 191119,
  [SMALL_STATE(5099)] = 191170,
  [SMALL_STATE(5100)] = 191269,
  [SMALL_STATE(5101)] = 191368,
  [SMALL_STATE(5102)] = 191467,
  [SMALL_STATE(5103)] = 191518,
  [SMALL_STATE(5104)] = 191617,
  [SMALL_STATE(5105)] = 191716,
  [SMALL_STATE(5106)] = 191815,
  [SMALL_STATE(5107)] = 191902,
  [SMALL_STATE(5108)] = 192001,
  [SMALL_STATE(5109)] = 192100,
  [SMALL_STATE(5110)] = 192199,
  [SMALL_STATE(5111)] = 192298,
  [SMALL_STATE(5112)] = 192397,
  [SMALL_STATE(5113)] = 192496,
  [SMALL_STATE(5114)] = 192595,
  [SMALL_STATE(5115)] = 192694,
  [SMALL_STATE(5116)] = 192793,
  [SMALL_STATE(5117)] = 192892,
  [SMALL_STATE(5118)] = 192991,
  [SMALL_STATE(5119)] = 193090,
  [SMALL_STATE(5120)] = 193189,
  [SMALL_STATE(5121)] = 193288,
  [SMALL_STATE(5122)] = 193387,
  [SMALL_STATE(5123)] = 193486,
  [SMALL_STATE(5124)] = 193585,
  [SMALL_STATE(5125)] = 193684,
  [SMALL_STATE(5126)] = 193783,
  [SMALL_STATE(5127)] = 193882,
  [SMALL_STATE(5128)] = 193981,
  [SMALL_STATE(5129)] = 194054,
  [SMALL_STATE(5130)] = 194153,
  [SMALL_STATE(5131)] = 194252,
  [SMALL_STATE(5132)] = 194351,
  [SMALL_STATE(5133)] = 194424,
  [SMALL_STATE(5134)] = 194523,
  [SMALL_STATE(5135)] = 194622,
  [SMALL_STATE(5136)] = 194721,
  [SMALL_STATE(5137)] = 194770,
  [SMALL_STATE(5138)] = 194869,
  [SMALL_STATE(5139)] = 194926,
  [SMALL_STATE(5140)] = 195025,
  [SMALL_STATE(5141)] = 195124,
  [SMALL_STATE(5142)] = 195173,
  [SMALL_STATE(5143)] = 195272,
  [SMALL_STATE(5144)] = 195371,
  [SMALL_STATE(5145)] = 195430,
  [SMALL_STATE(5146)] = 195477,
  [SMALL_STATE(5147)] = 195536,
  [SMALL_STATE(5148)] = 195635,
  [SMALL_STATE(5149)] = 195734,
  [SMALL_STATE(5150)] = 195833,
  [SMALL_STATE(5151)] = 195891,
  [SMALL_STATE(5152)] = 195937,
  [SMALL_STATE(5153)] = 195983,
  [SMALL_STATE(5154)] = 196029,
  [SMALL_STATE(5155)] = 196075,
  [SMALL_STATE(5156)] = 196121,
  [SMALL_STATE(5157)] = 196167,
  [SMALL_STATE(5158)] = 196213,
  [SMALL_STATE(5159)] = 196259,
  [SMALL_STATE(5160)] = 196311,
  [SMALL_STATE(5161)] = 196359,
  [SMALL_STATE(5162)] = 196405,
  [SMALL_STATE(5163)] = 196453,
  [SMALL_STATE(5164)] = 196501,
  [SMALL_STATE(5165)] = 196549,
  [SMALL_STATE(5166)] = 196645,
  [SMALL_STATE(5167)] = 196693,
  [SMALL_STATE(5168)] = 196739,
  [SMALL_STATE(5169)] = 196785,
  [SMALL_STATE(5170)] = 196871,
  [SMALL_STATE(5171)] = 196916,
  [SMALL_STATE(5172)] = 196961,
  [SMALL_STATE(5173)] = 197006,
  [SMALL_STATE(5174)] = 197051,
  [SMALL_STATE(5175)] = 197096,
  [SMALL_STATE(5176)] = 197151,
  [SMALL_STATE(5177)] = 197196,
  [SMALL_STATE(5178)] = 197241,
  [SMALL_STATE(5179)] = 197286,
  [SMALL_STATE(5180)] = 197331,
  [SMALL_STATE(5181)] = 197376,
  [SMALL_STATE(5182)] = 197421,
  [SMALL_STATE(5183)] = 197466,
  [SMALL_STATE(5184)] = 197511,
  [SMALL_STATE(5185)] = 197556,
  [SMALL_STATE(5186)] = 197601,
  [SMALL_STATE(5187)] = 197654,
  [SMALL_STATE(5188)] = 197699,
  [SMALL_STATE(5189)] = 197744,
  [SMALL_STATE(5190)] = 197789,
  [SMALL_STATE(5191)] = 197834,
  [SMALL_STATE(5192)] = 197879,
  [SMALL_STATE(5193)] = 197950,
  [SMALL_STATE(5194)] = 197995,
  [SMALL_STATE(5195)] = 198040,
  [SMALL_STATE(5196)] = 198085,
  [SMALL_STATE(5197)] = 198130,
  [SMALL_STATE(5198)] = 198175,
  [SMALL_STATE(5199)] = 198220,
  [SMALL_STATE(5200)] = 198265,
  [SMALL_STATE(5201)] = 198346,
  [SMALL_STATE(5202)] = 198427,
  [SMALL_STATE(5203)] = 198482,
  [SMALL_STATE(5204)] = 198563,
  [SMALL_STATE(5205)] = 198646,
  [SMALL_STATE(5206)] = 198691,
  [SMALL_STATE(5207)] = 198736,
  [SMALL_STATE(5208)] = 198781,
  [SMALL_STATE(5209)] = 198826,
  [SMALL_STATE(5210)] = 198871,
  [SMALL_STATE(5211)] = 198916,
  [SMALL_STATE(5212)] = 198969,
  [SMALL_STATE(5213)] = 199016,
  [SMALL_STATE(5214)] = 199061,
  [SMALL_STATE(5215)] = 199106,
  [SMALL_STATE(5216)] = 199155,
  [SMALL_STATE(5217)] = 199200,
  [SMALL_STATE(5218)] = 199245,
  [SMALL_STATE(5219)] = 199290,
  [SMALL_STATE(5220)] = 199335,
  [SMALL_STATE(5221)] = 199380,
  [SMALL_STATE(5222)] = 199425,
  [SMALL_STATE(5223)] = 199470,
  [SMALL_STATE(5224)] = 199515,
  [SMALL_STATE(5225)] = 199560,
  [SMALL_STATE(5226)] = 199605,
  [SMALL_STATE(5227)] = 199650,
  [SMALL_STATE(5228)] = 199695,
  [SMALL_STATE(5229)] = 199740,
  [SMALL_STATE(5230)] = 199785,
  [SMALL_STATE(5231)] = 199866,
  [SMALL_STATE(5232)] = 199911,
  [SMALL_STATE(5233)] = 199956,
  [SMALL_STATE(5234)] = 200001,
  [SMALL_STATE(5235)] = 200058,
  [SMALL_STATE(5236)] = 200103,
  [SMALL_STATE(5237)] = 200148,
  [SMALL_STATE(5238)] = 200193,
  [SMALL_STATE(5239)] = 200238,
  [SMALL_STATE(5240)] = 200283,
  [SMALL_STATE(5241)] = 200328,
  [SMALL_STATE(5242)] = 200399,
  [SMALL_STATE(5243)] = 200444,
  [SMALL_STATE(5244)] = 200489,
  [SMALL_STATE(5245)] = 200534,
  [SMALL_STATE(5246)] = 200579,
  [SMALL_STATE(5247)] = 200624,
  [SMALL_STATE(5248)] = 200669,
  [SMALL_STATE(5249)] = 200714,
  [SMALL_STATE(5250)] = 200761,
  [SMALL_STATE(5251)] = 200814,
  [SMALL_STATE(5252)] = 200859,
  [SMALL_STATE(5253)] = 200904,
  [SMALL_STATE(5254)] = 200949,
  [SMALL_STATE(5255)] = 200994,
  [SMALL_STATE(5256)] = 201039,
  [SMALL_STATE(5257)] = 201084,
  [SMALL_STATE(5258)] = 201129,
  [SMALL_STATE(5259)] = 201210,
  [SMALL_STATE(5260)] = 201255,
  [SMALL_STATE(5261)] = 201300,
  [SMALL_STATE(5262)] = 201345,
  [SMALL_STATE(5263)] = 201390,
  [SMALL_STATE(5264)] = 201447,
  [SMALL_STATE(5265)] = 201506,
  [SMALL_STATE(5266)] = 201551,
  [SMALL_STATE(5267)] = 201632,
  [SMALL_STATE(5268)] = 201677,
  [SMALL_STATE(5269)] = 201722,
  [SMALL_STATE(5270)] = 201767,
  [SMALL_STATE(5271)] = 201812,
  [SMALL_STATE(5272)] = 201857,
  [SMALL_STATE(5273)] = 201902,
  [SMALL_STATE(5274)] = 201947,
  [SMALL_STATE(5275)] = 202018,
  [SMALL_STATE(5276)] = 202063,
  [SMALL_STATE(5277)] = 202108,
  [SMALL_STATE(5278)] = 202153,
  [SMALL_STATE(5279)] = 202198,
  [SMALL_STATE(5280)] = 202243,
  [SMALL_STATE(5281)] = 202288,
  [SMALL_STATE(5282)] = 202347,
  [SMALL_STATE(5283)] = 202392,
  [SMALL_STATE(5284)] = 202437,
  [SMALL_STATE(5285)] = 202482,
  [SMALL_STATE(5286)] = 202527,
  [SMALL_STATE(5287)] = 202572,
  [SMALL_STATE(5288)] = 202617,
  [SMALL_STATE(5289)] = 202662,
  [SMALL_STATE(5290)] = 202707,
  [SMALL_STATE(5291)] = 202752,
  [SMALL_STATE(5292)] = 202797,
  [SMALL_STATE(5293)] = 202842,
  [SMALL_STATE(5294)] = 202887,
  [SMALL_STATE(5295)] = 202932,
  [SMALL_STATE(5296)] = 202977,
  [SMALL_STATE(5297)] = 203022,
  [SMALL_STATE(5298)] = 203067,
  [SMALL_STATE(5299)] = 203112,
  [SMALL_STATE(5300)] = 203161,
  [SMALL_STATE(5301)] = 203232,
  [SMALL_STATE(5302)] = 203277,
  [SMALL_STATE(5303)] = 203322,
  [SMALL_STATE(5304)] = 203367,
  [SMALL_STATE(5305)] = 203412,
  [SMALL_STATE(5306)] = 203457,
  [SMALL_STATE(5307)] = 203502,
  [SMALL_STATE(5308)] = 203547,
  [SMALL_STATE(5309)] = 203592,
  [SMALL_STATE(5310)] = 203637,
  [SMALL_STATE(5311)] = 203682,
  [SMALL_STATE(5312)] = 203727,
  [SMALL_STATE(5313)] = 203772,
  [SMALL_STATE(5314)] = 203817,
  [SMALL_STATE(5315)] = 203862,
  [SMALL_STATE(5316)] = 203907,
  [SMALL_STATE(5317)] = 203952,
  [SMALL_STATE(5318)] = 203997,
  [SMALL_STATE(5319)] = 204042,
  [SMALL_STATE(5320)] = 204087,
  [SMALL_STATE(5321)] = 204168,
  [SMALL_STATE(5322)] = 204213,
  [SMALL_STATE(5323)] = 204262,
  [SMALL_STATE(5324)] = 204307,
  [SMALL_STATE(5325)] = 204352,
  [SMALL_STATE(5326)] = 204397,
  [SMALL_STATE(5327)] = 204479,
  [SMALL_STATE(5328)] = 204527,
  [SMALL_STATE(5329)] = 204575,
  [SMALL_STATE(5330)] = 204653,
  [SMALL_STATE(5331)] = 204701,
  [SMALL_STATE(5332)] = 204749,
  [SMALL_STATE(5333)] = 204797,
  [SMALL_STATE(5334)] = 204879,
  [SMALL_STATE(5335)] = 204925,
  [SMALL_STATE(5336)] = 205003,
  [SMALL_STATE(5337)] = 205081,
  [SMALL_STATE(5338)] = 205159,
  [SMALL_STATE(5339)] = 205237,
  [SMALL_STATE(5340)] = 205293,
  [SMALL_STATE(5341)] = 205371,
  [SMALL_STATE(5342)] = 205427,
  [SMALL_STATE(5343)] = 205479,
  [SMALL_STATE(5344)] = 205527,
  [SMALL_STATE(5345)] = 205573,
  [SMALL_STATE(5346)] = 205651,
  [SMALL_STATE(5347)] = 205699,
  [SMALL_STATE(5348)] = 205777,
  [SMALL_STATE(5349)] = 205824,
  [SMALL_STATE(5350)] = 205871,
  [SMALL_STATE(5351)] = 205918,
  [SMALL_STATE(5352)] = 205999,
  [SMALL_STATE(5353)] = 206046,
  [SMALL_STATE(5354)] = 206093,
  [SMALL_STATE(5355)] = 206140,
  [SMALL_STATE(5356)] = 206187,
  [SMALL_STATE(5357)] = 206234,
  [SMALL_STATE(5358)] = 206281,
  [SMALL_STATE(5359)] = 206362,
  [SMALL_STATE(5360)] = 206409,
  [SMALL_STATE(5361)] = 206456,
  [SMALL_STATE(5362)] = 206503,
  [SMALL_STATE(5363)] = 206587,
  [SMALL_STATE(5364)] = 206667,
  [SMALL_STATE(5365)] = 206747,
  [SMALL_STATE(5366)] = 206827,
  [SMALL_STATE(5367)] = 206907,
  [SMALL_STATE(5368)] = 206957,
  [SMALL_STATE(5369)] = 206999,
  [SMALL_STATE(5370)] = 207041,
  [SMALL_STATE(5371)] = 207131,
  [SMALL_STATE(5372)] = 207211,
  [SMALL_STATE(5373)] = 207261,
  [SMALL_STATE(5374)] = 207341,
  [SMALL_STATE(5375)] = 207387,
  [SMALL_STATE(5376)] = 207467,
  [SMALL_STATE(5377)] = 207547,
  [SMALL_STATE(5378)] = 207626,
  [SMALL_STATE(5379)] = 207705,
  [SMALL_STATE(5380)] = 207784,
  [SMALL_STATE(5381)] = 207857,
  [SMALL_STATE(5382)] = 207930,
  [SMALL_STATE(5383)] = 208003,
  [SMALL_STATE(5384)] = 208082,
  [SMALL_STATE(5385)] = 208155,
  [SMALL_STATE(5386)] = 208200,
  [SMALL_STATE(5387)] = 208272,
  [SMALL_STATE(5388)] = 208352,
  [SMALL_STATE(5389)] = 208432,
  [SMALL_STATE(5390)] = 208482,
  [SMALL_STATE(5391)] = 208562,
  [SMALL_STATE(5392)] = 208642,
  [SMALL_STATE(5393)] = 208714,
  [SMALL_STATE(5394)] = 208794,
  [SMALL_STATE(5395)] = 208872,
  [SMALL_STATE(5396)] = 208952,
  [SMALL_STATE(5397)] = 209032,
  [SMALL_STATE(5398)] = 209074,
  [SMALL_STATE(5399)] = 209152,
  [SMALL_STATE(5400)] = 209232,
  [SMALL_STATE(5401)] = 209304,
  [SMALL_STATE(5402)] = 209384,
  [SMALL_STATE(5403)] = 209464,
  [SMALL_STATE(5404)] = 209544,
  [SMALL_STATE(5405)] = 209624,
  [SMALL_STATE(5406)] = 209704,
  [SMALL_STATE(5407)] = 209784,
  [SMALL_STATE(5408)] = 209864,
  [SMALL_STATE(5409)] = 209944,
  [SMALL_STATE(5410)] = 210024,
  [SMALL_STATE(5411)] = 210104,
  [SMALL_STATE(5412)] = 210184,
  [SMALL_STATE(5413)] = 210256,
  [SMALL_STATE(5414)] = 210336,
  [SMALL_STATE(5415)] = 210416,
  [SMALL_STATE(5416)] = 210496,
  [SMALL_STATE(5417)] = 210567,
  [SMALL_STATE(5418)] = 210638,
  [SMALL_STATE(5419)] = 210709,
  [SMALL_STATE(5420)] = 210780,
  [SMALL_STATE(5421)] = 210851,
  [SMALL_STATE(5422)] = 210922,
  [SMALL_STATE(5423)] = 210993,
  [SMALL_STATE(5424)] = 211064,
  [SMALL_STATE(5425)] = 211135,
  [SMALL_STATE(5426)] = 211206,
  [SMALL_STATE(5427)] = 211277,
  [SMALL_STATE(5428)] = 211348,
  [SMALL_STATE(5429)] = 211419,
  [SMALL_STATE(5430)] = 211490,
  [SMALL_STATE(5431)] = 211561,
  [SMALL_STATE(5432)] = 211632,
  [SMALL_STATE(5433)] = 211712,
  [SMALL_STATE(5434)] = 211792,
  [SMALL_STATE(5435)] = 211872,
  [SMALL_STATE(5436)] = 211952,
  [SMALL_STATE(5437)] = 212026,
  [SMALL_STATE(5438)] = 212100,
  [SMALL_STATE(5439)] = 212180,
  [SMALL_STATE(5440)] = 212260,
  [SMALL_STATE(5441)] = 212330,
  [SMALL_STATE(5442)] = 212410,
  [SMALL_STATE(5443)] = 212480,
  [SMALL_STATE(5444)] = 212554,
  [SMALL_STATE(5445)] = 212628,
  [SMALL_STATE(5446)] = 212704,
  [SMALL_STATE(5447)] = 212774,
  [SMALL_STATE(5448)] = 212848,
  [SMALL_STATE(5449)] = 212922,
  [SMALL_STATE(5450)] = 212992,
  [SMALL_STATE(5451)] = 213072,
  [SMALL_STATE(5452)] = 213146,
  [SMALL_STATE(5453)] = 213220,
  [SMALL_STATE(5454)] = 213300,
  [SMALL_STATE(5455)] = 213380,
  [SMALL_STATE(5456)] = 213454,
  [SMALL_STATE(5457)] = 213528,
  [SMALL_STATE(5458)] = 213602,
  [SMALL_STATE(5459)] = 213682,
  [SMALL_STATE(5460)] = 213762,
  [SMALL_STATE(5461)] = 213842,
  [SMALL_STATE(5462)] = 213922,
  [SMALL_STATE(5463)] = 214002,
  [SMALL_STATE(5464)] = 214082,
  [SMALL_STATE(5465)] = 214162,
  [SMALL_STATE(5466)] = 214242,
  [SMALL_STATE(5467)] = 214316,
  [SMALL_STATE(5468)] = 214396,
  [SMALL_STATE(5469)] = 214476,
  [SMALL_STATE(5470)] = 214556,
  [SMALL_STATE(5471)] = 214630,
  [SMALL_STATE(5472)] = 214704,
  [SMALL_STATE(5473)] = 214778,
  [SMALL_STATE(5474)] = 214848,
  [SMALL_STATE(5475)] = 214922,
  [SMALL_STATE(5476)] = 214996,
  [SMALL_STATE(5477)] = 215070,
  [SMALL_STATE(5478)] = 215150,
  [SMALL_STATE(5479)] = 215220,
  [SMALL_STATE(5480)] = 215300,
  [SMALL_STATE(5481)] = 215380,
  [SMALL_STATE(5482)] = 215460,
  [SMALL_STATE(5483)] = 215540,
  [SMALL_STATE(5484)] = 215620,
  [SMALL_STATE(5485)] = 215694,
  [SMALL_STATE(5486)] = 215768,
  [SMALL_STATE(5487)] = 215842,
  [SMALL_STATE(5488)] = 215916,
  [SMALL_STATE(5489)] = 215996,
  [SMALL_STATE(5490)] = 216070,
  [SMALL_STATE(5491)] = 216146,
  [SMALL_STATE(5492)] = 216220,
  [SMALL_STATE(5493)] = 216300,
  [SMALL_STATE(5494)] = 216374,
  [SMALL_STATE(5495)] = 216450,
  [SMALL_STATE(5496)] = 216530,
  [SMALL_STATE(5497)] = 216610,
  [SMALL_STATE(5498)] = 216684,
  [SMALL_STATE(5499)] = 216754,
  [SMALL_STATE(5500)] = 216834,
  [SMALL_STATE(5501)] = 216914,
  [SMALL_STATE(5502)] = 216994,
  [SMALL_STATE(5503)] = 217074,
  [SMALL_STATE(5504)] = 217154,
  [SMALL_STATE(5505)] = 217234,
  [SMALL_STATE(5506)] = 217304,
  [SMALL_STATE(5507)] = 217384,
  [SMALL_STATE(5508)] = 217464,
  [SMALL_STATE(5509)] = 217544,
  [SMALL_STATE(5510)] = 217624,
  [SMALL_STATE(5511)] = 217704,
  [SMALL_STATE(5512)] = 217784,
  [SMALL_STATE(5513)] = 217858,
  [SMALL_STATE(5514)] = 217938,
  [SMALL_STATE(5515)] = 218012,
  [SMALL_STATE(5516)] = 218086,
  [SMALL_STATE(5517)] = 218166,
  [SMALL_STATE(5518)] = 218240,
  [SMALL_STATE(5519)] = 218314,
  [SMALL_STATE(5520)] = 218388,
  [SMALL_STATE(5521)] = 218464,
  [SMALL_STATE(5522)] = 218544,
  [SMALL_STATE(5523)] = 218624,
  [SMALL_STATE(5524)] = 218698,
  [SMALL_STATE(5525)] = 218778,
  [SMALL_STATE(5526)] = 218848,
  [SMALL_STATE(5527)] = 218922,
  [SMALL_STATE(5528)] = 218996,
  [SMALL_STATE(5529)] = 219070,
  [SMALL_STATE(5530)] = 219150,
  [SMALL_STATE(5531)] = 219230,
  [SMALL_STATE(5532)] = 219300,
  [SMALL_STATE(5533)] = 219380,
  [SMALL_STATE(5534)] = 219460,
  [SMALL_STATE(5535)] = 219540,
  [SMALL_STATE(5536)] = 219620,
  [SMALL_STATE(5537)] = 219700,
  [SMALL_STATE(5538)] = 219780,
  [SMALL_STATE(5539)] = 219860,
  [SMALL_STATE(5540)] = 219934,
  [SMALL_STATE(5541)] = 220014,
  [SMALL_STATE(5542)] = 220094,
  [SMALL_STATE(5543)] = 220174,
  [SMALL_STATE(5544)] = 220254,
  [SMALL_STATE(5545)] = 220334,
  [SMALL_STATE(5546)] = 220404,
  [SMALL_STATE(5547)] = 220478,
  [SMALL_STATE(5548)] = 220552,
  [SMALL_STATE(5549)] = 220626,
  [SMALL_STATE(5550)] = 220706,
  [SMALL_STATE(5551)] = 220786,
  [SMALL_STATE(5552)] = 220866,
  [SMALL_STATE(5553)] = 220946,
  [SMALL_STATE(5554)] = 221020,
  [SMALL_STATE(5555)] = 221094,
  [SMALL_STATE(5556)] = 221174,
  [SMALL_STATE(5557)] = 221244,
  [SMALL_STATE(5558)] = 221318,
  [SMALL_STATE(5559)] = 221398,
  [SMALL_STATE(5560)] = 221468,
  [SMALL_STATE(5561)] = 221542,
  [SMALL_STATE(5562)] = 221622,
  [SMALL_STATE(5563)] = 221702,
  [SMALL_STATE(5564)] = 221782,
  [SMALL_STATE(5565)] = 221852,
  [SMALL_STATE(5566)] = 221932,
  [SMALL_STATE(5567)] = 222002,
  [SMALL_STATE(5568)] = 222076,
  [SMALL_STATE(5569)] = 222156,
  [SMALL_STATE(5570)] = 222236,
  [SMALL_STATE(5571)] = 222316,
  [SMALL_STATE(5572)] = 222396,
  [SMALL_STATE(5573)] = 222476,
  [SMALL_STATE(5574)] = 222556,
  [SMALL_STATE(5575)] = 222636,
  [SMALL_STATE(5576)] = 222716,
  [SMALL_STATE(5577)] = 222796,
  [SMALL_STATE(5578)] = 222866,
  [SMALL_STATE(5579)] = 222933,
  [SMALL_STATE(5580)] = 223010,
  [SMALL_STATE(5581)] = 223077,
  [SMALL_STATE(5582)] = 223144,
  [SMALL_STATE(5583)] = 223221,
  [SMALL_STATE(5584)] = 223288,
  [SMALL_STATE(5585)] = 223325,
  [SMALL_STATE(5586)] = 223402,
  [SMALL_STATE(5587)] = 223479,
  [SMALL_STATE(5588)] = 223546,
  [SMALL_STATE(5589)] = 223615,
  [SMALL_STATE(5590)] = 223682,
  [SMALL_STATE(5591)] = 223749,
  [SMALL_STATE(5592)] = 223826,
  [SMALL_STATE(5593)] = 223893,
  [SMALL_STATE(5594)] = 223960,
  [SMALL_STATE(5595)] = 224037,
  [SMALL_STATE(5596)] = 224104,
  [SMALL_STATE(5597)] = 224181,
  [SMALL_STATE(5598)] = 224248,
  [SMALL_STATE(5599)] = 224315,
  [SMALL_STATE(5600)] = 224352,
  [SMALL_STATE(5601)] = 224419,
  [SMALL_STATE(5602)] = 224496,
  [SMALL_STATE(5603)] = 224563,
  [SMALL_STATE(5604)] = 224630,
  [SMALL_STATE(5605)] = 224707,
  [SMALL_STATE(5606)] = 224776,
  [SMALL_STATE(5607)] = 224853,
  [SMALL_STATE(5608)] = 224930,
  [SMALL_STATE(5609)] = 224999,
  [SMALL_STATE(5610)] = 225068,
  [SMALL_STATE(5611)] = 225135,
  [SMALL_STATE(5612)] = 225212,
  [SMALL_STATE(5613)] = 225279,
  [SMALL_STATE(5614)] = 225346,
  [SMALL_STATE(5615)] = 225423,
  [SMALL_STATE(5616)] = 225500,
  [SMALL_STATE(5617)] = 225577,
  [SMALL_STATE(5618)] = 225644,
  [SMALL_STATE(5619)] = 225711,
  [SMALL_STATE(5620)] = 225778,
  [SMALL_STATE(5621)] = 225855,
  [SMALL_STATE(5622)] = 225932,
  [SMALL_STATE(5623)] = 226009,
  [SMALL_STATE(5624)] = 226086,
  [SMALL_STATE(5625)] = 226153,
  [SMALL_STATE(5626)] = 226220,
  [SMALL_STATE(5627)] = 226287,
  [SMALL_STATE(5628)] = 226354,
  [SMALL_STATE(5629)] = 226431,
  [SMALL_STATE(5630)] = 226498,
  [SMALL_STATE(5631)] = 226565,
  [SMALL_STATE(5632)] = 226605,
  [SMALL_STATE(5633)] = 226667,
  [SMALL_STATE(5634)] = 226729,
  [SMALL_STATE(5635)] = 226791,
  [SMALL_STATE(5636)] = 226853,
  [SMALL_STATE(5637)] = 226915,
  [SMALL_STATE(5638)] = 226977,
  [SMALL_STATE(5639)] = 227044,
  [SMALL_STATE(5640)] = 227105,
  [SMALL_STATE(5641)] = 227166,
  [SMALL_STATE(5642)] = 227233,
  [SMALL_STATE(5643)] = 227300,
  [SMALL_STATE(5644)] = 227367,
  [SMALL_STATE(5645)] = 227434,
  [SMALL_STATE(5646)] = 227501,
  [SMALL_STATE(5647)] = 227562,
  [SMALL_STATE(5648)] = 227623,
  [SMALL_STATE(5649)] = 227684,
  [SMALL_STATE(5650)] = 227751,
  [SMALL_STATE(5651)] = 227818,
  [SMALL_STATE(5652)] = 227879,
  [SMALL_STATE(5653)] = 227939,
  [SMALL_STATE(5654)] = 227997,
  [SMALL_STATE(5655)] = 228057,
  [SMALL_STATE(5656)] = 228117,
  [SMALL_STATE(5657)] = 228177,
  [SMALL_STATE(5658)] = 228237,
  [SMALL_STATE(5659)] = 228295,
  [SMALL_STATE(5660)] = 228355,
  [SMALL_STATE(5661)] = 228415,
  [SMALL_STATE(5662)] = 228475,
  [SMALL_STATE(5663)] = 228533,
  [SMALL_STATE(5664)] = 228593,
  [SMALL_STATE(5665)] = 228653,
  [SMALL_STATE(5666)] = 228713,
  [SMALL_STATE(5667)] = 228773,
  [SMALL_STATE(5668)] = 228833,
  [SMALL_STATE(5669)] = 228893,
  [SMALL_STATE(5670)] = 228953,
  [SMALL_STATE(5671)] = 229013,
  [SMALL_STATE(5672)] = 229073,
  [SMALL_STATE(5673)] = 229133,
  [SMALL_STATE(5674)] = 229193,
  [SMALL_STATE(5675)] = 229251,
  [SMALL_STATE(5676)] = 229309,
  [SMALL_STATE(5677)] = 229369,
  [SMALL_STATE(5678)] = 229429,
  [SMALL_STATE(5679)] = 229489,
  [SMALL_STATE(5680)] = 229549,
  [SMALL_STATE(5681)] = 229609,
  [SMALL_STATE(5682)] = 229670,
  [SMALL_STATE(5683)] = 229729,
  [SMALL_STATE(5684)] = 229788,
  [SMALL_STATE(5685)] = 229847,
  [SMALL_STATE(5686)] = 229906,
  [SMALL_STATE(5687)] = 229965,
  [SMALL_STATE(5688)] = 230026,
  [SMALL_STATE(5689)] = 230085,
  [SMALL_STATE(5690)] = 230144,
  [SMALL_STATE(5691)] = 230203,
  [SMALL_STATE(5692)] = 230264,
  [SMALL_STATE(5693)] = 230323,
  [SMALL_STATE(5694)] = 230384,
  [SMALL_STATE(5695)] = 230445,
  [SMALL_STATE(5696)] = 230506,
  [SMALL_STATE(5697)] = 230567,
  [SMALL_STATE(5698)] = 230626,
  [SMALL_STATE(5699)] = 230687,
  [SMALL_STATE(5700)] = 230746,
  [SMALL_STATE(5701)] = 230807,
  [SMALL_STATE(5702)] = 230866,
  [SMALL_STATE(5703)] = 230924,
  [SMALL_STATE(5704)] = 230982,
  [SMALL_STATE(5705)] = 231030,
  [SMALL_STATE(5706)] = 231078,
  [SMALL_STATE(5707)] = 231126,
  [SMALL_STATE(5708)] = 231184,
  [SMALL_STATE(5709)] = 231242,
  [SMALL_STATE(5710)] = 231300,
  [SMALL_STATE(5711)] = 231354,
  [SMALL_STATE(5712)] = 231412,
  [SMALL_STATE(5713)] = 231483,
  [SMALL_STATE(5714)] = 231530,
  [SMALL_STATE(5715)] = 231601,
  [SMALL_STATE(5716)] = 231672,
  [SMALL_STATE(5717)] = 231728,
  [SMALL_STATE(5718)] = 231780,
  [SMALL_STATE(5719)] = 231814,
  [SMALL_STATE(5720)] = 231866,
  [SMALL_STATE(5721)] = 231918,
  [SMALL_STATE(5722)] = 231970,
  [SMALL_STATE(5723)] = 232022,
  [SMALL_STATE(5724)] = 232074,
  [SMALL_STATE(5725)] = 232130,
  [SMALL_STATE(5726)] = 232182,
  [SMALL_STATE(5727)] = 232228,
  [SMALL_STATE(5728)] = 232280,
  [SMALL_STATE(5729)] = 232332,
  [SMALL_STATE(5730)] = 232384,
  [SMALL_STATE(5731)] = 232436,
  [SMALL_STATE(5732)] = 232488,
  [SMALL_STATE(5733)] = 232540,
  [SMALL_STATE(5734)] = 232592,
  [SMALL_STATE(5735)] = 232644,
  [SMALL_STATE(5736)] = 232700,
  [SMALL_STATE(5737)] = 232752,
  [SMALL_STATE(5738)] = 232804,
  [SMALL_STATE(5739)] = 232856,
  [SMALL_STATE(5740)] = 232908,
  [SMALL_STATE(5741)] = 232960,
  [SMALL_STATE(5742)] = 233012,
  [SMALL_STATE(5743)] = 233068,
  [SMALL_STATE(5744)] = 233114,
  [SMALL_STATE(5745)] = 233184,
  [SMALL_STATE(5746)] = 233236,
  [SMALL_STATE(5747)] = 233288,
  [SMALL_STATE(5748)] = 233344,
  [SMALL_STATE(5749)] = 233396,
  [SMALL_STATE(5750)] = 233434,
  [SMALL_STATE(5751)] = 233472,
  [SMALL_STATE(5752)] = 233542,
  [SMALL_STATE(5753)] = 233598,
  [SMALL_STATE(5754)] = 233650,
  [SMALL_STATE(5755)] = 233702,
  [SMALL_STATE(5756)] = 233754,
  [SMALL_STATE(5757)] = 233806,
  [SMALL_STATE(5758)] = 233858,
  [SMALL_STATE(5759)] = 233910,
  [SMALL_STATE(5760)] = 233980,
  [SMALL_STATE(5761)] = 234032,
  [SMALL_STATE(5762)] = 234084,
  [SMALL_STATE(5763)] = 234140,
  [SMALL_STATE(5764)] = 234192,
  [SMALL_STATE(5765)] = 234244,
  [SMALL_STATE(5766)] = 234296,
  [SMALL_STATE(5767)] = 234352,
  [SMALL_STATE(5768)] = 234404,
  [SMALL_STATE(5769)] = 234456,
  [SMALL_STATE(5770)] = 234508,
  [SMALL_STATE(5771)] = 234564,
  [SMALL_STATE(5772)] = 234616,
  [SMALL_STATE(5773)] = 234668,
  [SMALL_STATE(5774)] = 234724,
  [SMALL_STATE(5775)] = 234776,
  [SMALL_STATE(5776)] = 234828,
  [SMALL_STATE(5777)] = 234884,
  [SMALL_STATE(5778)] = 234936,
  [SMALL_STATE(5779)] = 234988,
  [SMALL_STATE(5780)] = 235044,
  [SMALL_STATE(5781)] = 235096,
  [SMALL_STATE(5782)] = 235155,
  [SMALL_STATE(5783)] = 235200,
  [SMALL_STATE(5784)] = 235259,
  [SMALL_STATE(5785)] = 235318,
  [SMALL_STATE(5786)] = 235377,
  [SMALL_STATE(5787)] = 235436,
  [SMALL_STATE(5788)] = 235495,
  [SMALL_STATE(5789)] = 235554,
  [SMALL_STATE(5790)] = 235613,
  [SMALL_STATE(5791)] = 235656,
  [SMALL_STATE(5792)] = 235715,
  [SMALL_STATE(5793)] = 235758,
  [SMALL_STATE(5794)] = 235817,
  [SMALL_STATE(5795)] = 235876,
  [SMALL_STATE(5796)] = 235935,
  [SMALL_STATE(5797)] = 235994,
  [SMALL_STATE(5798)] = 236049,
  [SMALL_STATE(5799)] = 236108,
  [SMALL_STATE(5800)] = 236167,
  [SMALL_STATE(5801)] = 236222,
  [SMALL_STATE(5802)] = 236281,
  [SMALL_STATE(5803)] = 236340,
  [SMALL_STATE(5804)] = 236403,
  [SMALL_STATE(5805)] = 236462,
  [SMALL_STATE(5806)] = 236521,
  [SMALL_STATE(5807)] = 236580,
  [SMALL_STATE(5808)] = 236639,
  [SMALL_STATE(5809)] = 236698,
  [SMALL_STATE(5810)] = 236757,
  [SMALL_STATE(5811)] = 236816,
  [SMALL_STATE(5812)] = 236875,
  [SMALL_STATE(5813)] = 236934,
  [SMALL_STATE(5814)] = 236993,
  [SMALL_STATE(5815)] = 237052,
  [SMALL_STATE(5816)] = 237111,
  [SMALL_STATE(5817)] = 237170,
  [SMALL_STATE(5818)] = 237229,
  [SMALL_STATE(5819)] = 237288,
  [SMALL_STATE(5820)] = 237347,
  [SMALL_STATE(5821)] = 237406,
  [SMALL_STATE(5822)] = 237465,
  [SMALL_STATE(5823)] = 237524,
  [SMALL_STATE(5824)] = 237583,
  [SMALL_STATE(5825)] = 237642,
  [SMALL_STATE(5826)] = 237701,
  [SMALL_STATE(5827)] = 237760,
  [SMALL_STATE(5828)] = 237819,
  [SMALL_STATE(5829)] = 237878,
  [SMALL_STATE(5830)] = 237937,
  [SMALL_STATE(5831)] = 237996,
  [SMALL_STATE(5832)] = 238055,
  [SMALL_STATE(5833)] = 238084,
  [SMALL_STATE(5834)] = 238143,
  [SMALL_STATE(5835)] = 238202,
  [SMALL_STATE(5836)] = 238261,
  [SMALL_STATE(5837)] = 238320,
  [SMALL_STATE(5838)] = 238379,
  [SMALL_STATE(5839)] = 238438,
  [SMALL_STATE(5840)] = 238493,
  [SMALL_STATE(5841)] = 238552,
  [SMALL_STATE(5842)] = 238611,
  [SMALL_STATE(5843)] = 238670,
  [SMALL_STATE(5844)] = 238713,
  [SMALL_STATE(5845)] = 238746,
  [SMALL_STATE(5846)] = 238805,
  [SMALL_STATE(5847)] = 238864,
  [SMALL_STATE(5848)] = 238923,
  [SMALL_STATE(5849)] = 238982,
  [SMALL_STATE(5850)] = 239041,
  [SMALL_STATE(5851)] = 239100,
  [SMALL_STATE(5852)] = 239159,
  [SMALL_STATE(5853)] = 239218,
  [SMALL_STATE(5854)] = 239277,
  [SMALL_STATE(5855)] = 239336,
  [SMALL_STATE(5856)] = 239395,
  [SMALL_STATE(5857)] = 239454,
  [SMALL_STATE(5858)] = 239513,
  [SMALL_STATE(5859)] = 239572,
  [SMALL_STATE(5860)] = 239631,
  [SMALL_STATE(5861)] = 239690,
  [SMALL_STATE(5862)] = 239749,
  [SMALL_STATE(5863)] = 239808,
  [SMALL_STATE(5864)] = 239867,
  [SMALL_STATE(5865)] = 239926,
  [SMALL_STATE(5866)] = 239985,
  [SMALL_STATE(5867)] = 240044,
  [SMALL_STATE(5868)] = 240103,
  [SMALL_STATE(5869)] = 240162,
  [SMALL_STATE(5870)] = 240221,
  [SMALL_STATE(5871)] = 240280,
  [SMALL_STATE(5872)] = 240339,
  [SMALL_STATE(5873)] = 240398,
  [SMALL_STATE(5874)] = 240457,
  [SMALL_STATE(5875)] = 240516,
  [SMALL_STATE(5876)] = 240575,
  [SMALL_STATE(5877)] = 240634,
  [SMALL_STATE(5878)] = 240693,
  [SMALL_STATE(5879)] = 240752,
  [SMALL_STATE(5880)] = 240811,
  [SMALL_STATE(5881)] = 240870,
  [SMALL_STATE(5882)] = 240929,
  [SMALL_STATE(5883)] = 240988,
  [SMALL_STATE(5884)] = 241047,
  [SMALL_STATE(5885)] = 241106,
  [SMALL_STATE(5886)] = 241165,
  [SMALL_STATE(5887)] = 241224,
  [SMALL_STATE(5888)] = 241283,
  [SMALL_STATE(5889)] = 241342,
  [SMALL_STATE(5890)] = 241401,
  [SMALL_STATE(5891)] = 241460,
  [SMALL_STATE(5892)] = 241524,
  [SMALL_STATE(5893)] = 241582,
  [SMALL_STATE(5894)] = 241622,
  [SMALL_STATE(5895)] = 241674,
  [SMALL_STATE(5896)] = 241714,
  [SMALL_STATE(5897)] = 241778,
  [SMALL_STATE(5898)] = 241828,
  [SMALL_STATE(5899)] = 241868,
  [SMALL_STATE(5900)] = 241908,
  [SMALL_STATE(5901)] = 241958,
  [SMALL_STATE(5902)] = 241998,
  [SMALL_STATE(5903)] = 242026,
  [SMALL_STATE(5904)] = 242066,
  [SMALL_STATE(5905)] = 242106,
  [SMALL_STATE(5906)] = 242170,
  [SMALL_STATE(5907)] = 242220,
  [SMALL_STATE(5908)] = 242260,
  [SMALL_STATE(5909)] = 242300,
  [SMALL_STATE(5910)] = 242340,
  [SMALL_STATE(5911)] = 242404,
  [SMALL_STATE(5912)] = 242462,
  [SMALL_STATE(5913)] = 242502,
  [SMALL_STATE(5914)] = 242542,
  [SMALL_STATE(5915)] = 242606,
  [SMALL_STATE(5916)] = 242670,
  [SMALL_STATE(5917)] = 242710,
  [SMALL_STATE(5918)] = 242768,
  [SMALL_STATE(5919)] = 242808,
  [SMALL_STATE(5920)] = 242858,
  [SMALL_STATE(5921)] = 242908,
  [SMALL_STATE(5922)] = 242948,
  [SMALL_STATE(5923)] = 242998,
  [SMALL_STATE(5924)] = 243026,
  [SMALL_STATE(5925)] = 243066,
  [SMALL_STATE(5926)] = 243106,
  [SMALL_STATE(5927)] = 243146,
  [SMALL_STATE(5928)] = 243186,
  [SMALL_STATE(5929)] = 243214,
  [SMALL_STATE(5930)] = 243264,
  [SMALL_STATE(5931)] = 243314,
  [SMALL_STATE(5932)] = 243364,
  [SMALL_STATE(5933)] = 243408,
  [SMALL_STATE(5934)] = 243458,
  [SMALL_STATE(5935)] = 243522,
  [SMALL_STATE(5936)] = 243550,
  [SMALL_STATE(5937)] = 243614,
  [SMALL_STATE(5938)] = 243672,
  [SMALL_STATE(5939)] = 243708,
  [SMALL_STATE(5940)] = 243766,
  [SMALL_STATE(5941)] = 243816,
  [SMALL_STATE(5942)] = 243880,
  [SMALL_STATE(5943)] = 243920,
  [SMALL_STATE(5944)] = 243984,
  [SMALL_STATE(5945)] = 244036,
  [SMALL_STATE(5946)] = 244086,
  [SMALL_STATE(5947)] = 244122,
  [SMALL_STATE(5948)] = 244162,
  [SMALL_STATE(5949)] = 244226,
  [SMALL_STATE(5950)] = 244290,
  [SMALL_STATE(5951)] = 244330,
  [SMALL_STATE(5952)] = 244370,
  [SMALL_STATE(5953)] = 244410,
  [SMALL_STATE(5954)] = 244444,
  [SMALL_STATE(5955)] = 244484,
  [SMALL_STATE(5956)] = 244524,
  [SMALL_STATE(5957)] = 244560,
  [SMALL_STATE(5958)] = 244600,
  [SMALL_STATE(5959)] = 244664,
  [SMALL_STATE(5960)] = 244706,
  [SMALL_STATE(5961)] = 244746,
  [SMALL_STATE(5962)] = 244790,
  [SMALL_STATE(5963)] = 244830,
  [SMALL_STATE(5964)] = 244870,
  [SMALL_STATE(5965)] = 244920,
  [SMALL_STATE(5966)] = 244948,
  [SMALL_STATE(5967)] = 244998,
  [SMALL_STATE(5968)] = 245026,
  [SMALL_STATE(5969)] = 245072,
  [SMALL_STATE(5970)] = 245122,
  [SMALL_STATE(5971)] = 245168,
  [SMALL_STATE(5972)] = 245218,
  [SMALL_STATE(5973)] = 245276,
  [SMALL_STATE(5974)] = 245326,
  [SMALL_STATE(5975)] = 245374,
  [SMALL_STATE(5976)] = 245414,
  [SMALL_STATE(5977)] = 245454,
  [SMALL_STATE(5978)] = 245504,
  [SMALL_STATE(5979)] = 245532,
  [SMALL_STATE(5980)] = 245564,
  [SMALL_STATE(5981)] = 245616,
  [SMALL_STATE(5982)] = 245680,
  [SMALL_STATE(5983)] = 245708,
  [SMALL_STATE(5984)] = 245766,
  [SMALL_STATE(5985)] = 245806,
  [SMALL_STATE(5986)] = 245846,
  [SMALL_STATE(5987)] = 245910,
  [SMALL_STATE(5988)] = 245950,
  [SMALL_STATE(5989)] = 245990,
  [SMALL_STATE(5990)] = 246030,
  [SMALL_STATE(5991)] = 246070,
  [SMALL_STATE(5992)] = 246110,
  [SMALL_STATE(5993)] = 246138,
  [SMALL_STATE(5994)] = 246188,
  [SMALL_STATE(5995)] = 246228,
  [SMALL_STATE(5996)] = 246256,
  [SMALL_STATE(5997)] = 246283,
  [SMALL_STATE(5998)] = 246310,
  [SMALL_STATE(5999)] = 246339,
  [SMALL_STATE(6000)] = 246366,
  [SMALL_STATE(6001)] = 246411,
  [SMALL_STATE(6002)] = 246450,
  [SMALL_STATE(6003)] = 246485,
  [SMALL_STATE(6004)] = 246532,
  [SMALL_STATE(6005)] = 246563,
  [SMALL_STATE(6006)] = 246594,
  [SMALL_STATE(6007)] = 246629,
  [SMALL_STATE(6008)] = 246668,
  [SMALL_STATE(6009)] = 246695,
  [SMALL_STATE(6010)] = 246740,
  [SMALL_STATE(6011)] = 246779,
  [SMALL_STATE(6012)] = 246826,
  [SMALL_STATE(6013)] = 246867,
  [SMALL_STATE(6014)] = 246906,
  [SMALL_STATE(6015)] = 246945,
  [SMALL_STATE(6016)] = 246982,
  [SMALL_STATE(6017)] = 247017,
  [SMALL_STATE(6018)] = 247050,
  [SMALL_STATE(6019)] = 247077,
  [SMALL_STATE(6020)] = 247112,
  [SMALL_STATE(6021)] = 247151,
  [SMALL_STATE(6022)] = 247196,
  [SMALL_STATE(6023)] = 247231,
  [SMALL_STATE(6024)] = 247266,
  [SMALL_STATE(6025)] = 247305,
  [SMALL_STATE(6026)] = 247332,
  [SMALL_STATE(6027)] = 247359,
  [SMALL_STATE(6028)] = 247398,
  [SMALL_STATE(6029)] = 247443,
  [SMALL_STATE(6030)] = 247478,
  [SMALL_STATE(6031)] = 247507,
  [SMALL_STATE(6032)] = 247552,
  [SMALL_STATE(6033)] = 247579,
  [SMALL_STATE(6034)] = 247606,
  [SMALL_STATE(6035)] = 247653,
  [SMALL_STATE(6036)] = 247680,
  [SMALL_STATE(6037)] = 247719,
  [SMALL_STATE(6038)] = 247758,
  [SMALL_STATE(6039)] = 247797,
  [SMALL_STATE(6040)] = 247824,
  [SMALL_STATE(6041)] = 247863,
  [SMALL_STATE(6042)] = 247898,
  [SMALL_STATE(6043)] = 247955,
  [SMALL_STATE(6044)] = 248002,
  [SMALL_STATE(6045)] = 248029,
  [SMALL_STATE(6046)] = 248058,
  [SMALL_STATE(6047)] = 248085,
  [SMALL_STATE(6048)] = 248112,
  [SMALL_STATE(6049)] = 248159,
  [SMALL_STATE(6050)] = 248198,
  [SMALL_STATE(6051)] = 248243,
  [SMALL_STATE(6052)] = 248270,
  [SMALL_STATE(6053)] = 248297,
  [SMALL_STATE(6054)] = 248344,
  [SMALL_STATE(6055)] = 248371,
  [SMALL_STATE(6056)] = 248416,
  [SMALL_STATE(6057)] = 248455,
  [SMALL_STATE(6058)] = 248486,
  [SMALL_STATE(6059)] = 248513,
  [SMALL_STATE(6060)] = 248570,
  [SMALL_STATE(6061)] = 248605,
  [SMALL_STATE(6062)] = 248632,
  [SMALL_STATE(6063)] = 248659,
  [SMALL_STATE(6064)] = 248698,
  [SMALL_STATE(6065)] = 248755,
  [SMALL_STATE(6066)] = 248782,
  [SMALL_STATE(6067)] = 248821,
  [SMALL_STATE(6068)] = 248848,
  [SMALL_STATE(6069)] = 248875,
  [SMALL_STATE(6070)] = 248914,
  [SMALL_STATE(6071)] = 248945,
  [SMALL_STATE(6072)] = 248988,
  [SMALL_STATE(6073)] = 249035,
  [SMALL_STATE(6074)] = 249070,
  [SMALL_STATE(6075)] = 249101,
  [SMALL_STATE(6076)] = 249146,
  [SMALL_STATE(6077)] = 249181,
  [SMALL_STATE(6078)] = 249208,
  [SMALL_STATE(6079)] = 249253,
  [SMALL_STATE(6080)] = 249298,
  [SMALL_STATE(6081)] = 249345,
  [SMALL_STATE(6082)] = 249392,
  [SMALL_STATE(6083)] = 249431,
  [SMALL_STATE(6084)] = 249480,
  [SMALL_STATE(6085)] = 249515,
  [SMALL_STATE(6086)] = 249550,
  [SMALL_STATE(6087)] = 249585,
  [SMALL_STATE(6088)] = 249614,
  [SMALL_STATE(6089)] = 249649,
  [SMALL_STATE(6090)] = 249684,
  [SMALL_STATE(6091)] = 249741,
  [SMALL_STATE(6092)] = 249776,
  [SMALL_STATE(6093)] = 249815,
  [SMALL_STATE(6094)] = 249846,
  [SMALL_STATE(6095)] = 249903,
  [SMALL_STATE(6096)] = 249948,
  [SMALL_STATE(6097)] = 249975,
  [SMALL_STATE(6098)] = 250014,
  [SMALL_STATE(6099)] = 250041,
  [SMALL_STATE(6100)] = 250068,
  [SMALL_STATE(6101)] = 250113,
  [SMALL_STATE(6102)] = 250152,
  [SMALL_STATE(6103)] = 250191,
  [SMALL_STATE(6104)] = 250226,
  [SMALL_STATE(6105)] = 250273,
  [SMALL_STATE(6106)] = 250308,
  [SMALL_STATE(6107)] = 250347,
  [SMALL_STATE(6108)] = 250382,
  [SMALL_STATE(6109)] = 250417,
  [SMALL_STATE(6110)] = 250444,
  [SMALL_STATE(6111)] = 250483,
  [SMALL_STATE(6112)] = 250530,
  [SMALL_STATE(6113)] = 250561,
  [SMALL_STATE(6114)] = 250600,
  [SMALL_STATE(6115)] = 250627,
  [SMALL_STATE(6116)] = 250672,
  [SMALL_STATE(6117)] = 250699,
  [SMALL_STATE(6118)] = 250730,
  [SMALL_STATE(6119)] = 250777,
  [SMALL_STATE(6120)] = 250834,
  [SMALL_STATE(6121)] = 250877,
  [SMALL_STATE(6122)] = 250924,
  [SMALL_STATE(6123)] = 250971,
  [SMALL_STATE(6124)] = 251016,
  [SMALL_STATE(6125)] = 251043,
  [SMALL_STATE(6126)] = 251070,
  [SMALL_STATE(6127)] = 251119,
  [SMALL_STATE(6128)] = 251164,
  [SMALL_STATE(6129)] = 251194,
  [SMALL_STATE(6130)] = 251230,
  [SMALL_STATE(6131)] = 251266,
  [SMALL_STATE(6132)] = 251302,
  [SMALL_STATE(6133)] = 251344,
  [SMALL_STATE(6134)] = 251374,
  [SMALL_STATE(6135)] = 251410,
  [SMALL_STATE(6136)] = 251446,
  [SMALL_STATE(6137)] = 251482,
  [SMALL_STATE(6138)] = 251530,
  [SMALL_STATE(6139)] = 251566,
  [SMALL_STATE(6140)] = 251618,
  [SMALL_STATE(6141)] = 251666,
  [SMALL_STATE(6142)] = 251702,
  [SMALL_STATE(6143)] = 251732,
  [SMALL_STATE(6144)] = 251780,
  [SMALL_STATE(6145)] = 251828,
  [SMALL_STATE(6146)] = 251858,
  [SMALL_STATE(6147)] = 251895,
  [SMALL_STATE(6148)] = 251932,
  [SMALL_STATE(6149)] = 251957,
  [SMALL_STATE(6150)] = 251982,
  [SMALL_STATE(6151)] = 252007,
  [SMALL_STATE(6152)] = 252032,
  [SMALL_STATE(6153)] = 252057,
  [SMALL_STATE(6154)] = 252082,
  [SMALL_STATE(6155)] = 252131,
  [SMALL_STATE(6156)] = 252180,
  [SMALL_STATE(6157)] = 252215,
  [SMALL_STATE(6158)] = 252264,
  [SMALL_STATE(6159)] = 252289,
  [SMALL_STATE(6160)] = 252338,
  [SMALL_STATE(6161)] = 252363,
  [SMALL_STATE(6162)] = 252388,
  [SMALL_STATE(6163)] = 252413,
  [SMALL_STATE(6164)] = 252438,
  [SMALL_STATE(6165)] = 252487,
  [SMALL_STATE(6166)] = 252524,
  [SMALL_STATE(6167)] = 252549,
  [SMALL_STATE(6168)] = 252574,
  [SMALL_STATE(6169)] = 252611,
  [SMALL_STATE(6170)] = 252660,
  [SMALL_STATE(6171)] = 252697,
  [SMALL_STATE(6172)] = 252746,
  [SMALL_STATE(6173)] = 252795,
  [SMALL_STATE(6174)] = 252820,
  [SMALL_STATE(6175)] = 252857,
  [SMALL_STATE(6176)] = 252906,
  [SMALL_STATE(6177)] = 252955,
  [SMALL_STATE(6178)] = 252980,
  [SMALL_STATE(6179)] = 253029,
  [SMALL_STATE(6180)] = 253078,
  [SMALL_STATE(6181)] = 253127,
  [SMALL_STATE(6182)] = 253158,
  [SMALL_STATE(6183)] = 253207,
  [SMALL_STATE(6184)] = 253256,
  [SMALL_STATE(6185)] = 253281,
  [SMALL_STATE(6186)] = 253306,
  [SMALL_STATE(6187)] = 253347,
  [SMALL_STATE(6188)] = 253384,
  [SMALL_STATE(6189)] = 253415,
  [SMALL_STATE(6190)] = 253464,
  [SMALL_STATE(6191)] = 253501,
  [SMALL_STATE(6192)] = 253538,
  [SMALL_STATE(6193)] = 253587,
  [SMALL_STATE(6194)] = 253612,
  [SMALL_STATE(6195)] = 253649,
  [SMALL_STATE(6196)] = 253698,
  [SMALL_STATE(6197)] = 253735,
  [SMALL_STATE(6198)] = 253760,
  [SMALL_STATE(6199)] = 253809,
  [SMALL_STATE(6200)] = 253860,
  [SMALL_STATE(6201)] = 253909,
  [SMALL_STATE(6202)] = 253950,
  [SMALL_STATE(6203)] = 253999,
  [SMALL_STATE(6204)] = 254042,
  [SMALL_STATE(6205)] = 254079,
  [SMALL_STATE(6206)] = 254128,
  [SMALL_STATE(6207)] = 254165,
  [SMALL_STATE(6208)] = 254190,
  [SMALL_STATE(6209)] = 254239,
  [SMALL_STATE(6210)] = 254288,
  [SMALL_STATE(6211)] = 254331,
  [SMALL_STATE(6212)] = 254380,
  [SMALL_STATE(6213)] = 254417,
  [SMALL_STATE(6214)] = 254454,
  [SMALL_STATE(6215)] = 254491,
  [SMALL_STATE(6216)] = 254540,
  [SMALL_STATE(6217)] = 254571,
  [SMALL_STATE(6218)] = 254614,
  [SMALL_STATE(6219)] = 254657,
  [SMALL_STATE(6220)] = 254706,
  [SMALL_STATE(6221)] = 254737,
  [SMALL_STATE(6222)] = 254786,
  [SMALL_STATE(6223)] = 254817,
  [SMALL_STATE(6224)] = 254866,
  [SMALL_STATE(6225)] = 254891,
  [SMALL_STATE(6226)] = 254933,
  [SMALL_STATE(6227)] = 254969,
  [SMALL_STATE(6228)] = 255005,
  [SMALL_STATE(6229)] = 255035,
  [SMALL_STATE(6230)] = 255075,
  [SMALL_STATE(6231)] = 255105,
  [SMALL_STATE(6232)] = 255127,
  [SMALL_STATE(6233)] = 255167,
  [SMALL_STATE(6234)] = 255207,
  [SMALL_STATE(6235)] = 255247,
  [SMALL_STATE(6236)] = 255277,
  [SMALL_STATE(6237)] = 255307,
  [SMALL_STATE(6238)] = 255337,
  [SMALL_STATE(6239)] = 255377,
  [SMALL_STATE(6240)] = 255399,
  [SMALL_STATE(6241)] = 255439,
  [SMALL_STATE(6242)] = 255469,
  [SMALL_STATE(6243)] = 255491,
  [SMALL_STATE(6244)] = 255531,
  [SMALL_STATE(6245)] = 255561,
  [SMALL_STATE(6246)] = 255583,
  [SMALL_STATE(6247)] = 255619,
  [SMALL_STATE(6248)] = 255641,
  [SMALL_STATE(6249)] = 255681,
  [SMALL_STATE(6250)] = 255707,
  [SMALL_STATE(6251)] = 255729,
  [SMALL_STATE(6252)] = 255751,
  [SMALL_STATE(6253)] = 255791,
  [SMALL_STATE(6254)] = 255827,
  [SMALL_STATE(6255)] = 255857,
  [SMALL_STATE(6256)] = 255897,
  [SMALL_STATE(6257)] = 255919,
  [SMALL_STATE(6258)] = 255945,
  [SMALL_STATE(6259)] = 255985,
  [SMALL_STATE(6260)] = 256025,
  [SMALL_STATE(6261)] = 256047,
  [SMALL_STATE(6262)] = 256071,
  [SMALL_STATE(6263)] = 256111,
  [SMALL_STATE(6264)] = 256135,
  [SMALL_STATE(6265)] = 256175,
  [SMALL_STATE(6266)] = 256201,
  [SMALL_STATE(6267)] = 256245,
  [SMALL_STATE(6268)] = 256285,
  [SMALL_STATE(6269)] = 256325,
  [SMALL_STATE(6270)] = 256365,
  [SMALL_STATE(6271)] = 256401,
  [SMALL_STATE(6272)] = 256431,
  [SMALL_STATE(6273)] = 256453,
  [SMALL_STATE(6274)] = 256483,
  [SMALL_STATE(6275)] = 256519,
  [SMALL_STATE(6276)] = 256545,
  [SMALL_STATE(6277)] = 256569,
  [SMALL_STATE(6278)] = 256591,
  [SMALL_STATE(6279)] = 256631,
  [SMALL_STATE(6280)] = 256671,
  [SMALL_STATE(6281)] = 256711,
  [SMALL_STATE(6282)] = 256747,
  [SMALL_STATE(6283)] = 256777,
  [SMALL_STATE(6284)] = 256799,
  [SMALL_STATE(6285)] = 256829,
  [SMALL_STATE(6286)] = 256851,
  [SMALL_STATE(6287)] = 256887,
  [SMALL_STATE(6288)] = 256927,
  [SMALL_STATE(6289)] = 256949,
  [SMALL_STATE(6290)] = 256979,
  [SMALL_STATE(6291)] = 257001,
  [SMALL_STATE(6292)] = 257023,
  [SMALL_STATE(6293)] = 257063,
  [SMALL_STATE(6294)] = 257085,
  [SMALL_STATE(6295)] = 257114,
  [SMALL_STATE(6296)] = 257157,
  [SMALL_STATE(6297)] = 257200,
  [SMALL_STATE(6298)] = 257227,
  [SMALL_STATE(6299)] = 257256,
  [SMALL_STATE(6300)] = 257299,
  [SMALL_STATE(6301)] = 257328,
  [SMALL_STATE(6302)] = 257357,
  [SMALL_STATE(6303)] = 257400,
  [SMALL_STATE(6304)] = 257429,
  [SMALL_STATE(6305)] = 257458,
  [SMALL_STATE(6306)] = 257487,
  [SMALL_STATE(6307)] = 257516,
  [SMALL_STATE(6308)] = 257545,
  [SMALL_STATE(6309)] = 257574,
  [SMALL_STATE(6310)] = 257603,
  [SMALL_STATE(6311)] = 257634,
  [SMALL_STATE(6312)] = 257665,
  [SMALL_STATE(6313)] = 257696,
  [SMALL_STATE(6314)] = 257725,
  [SMALL_STATE(6315)] = 257768,
  [SMALL_STATE(6316)] = 257799,
  [SMALL_STATE(6317)] = 257830,
  [SMALL_STATE(6318)] = 257873,
  [SMALL_STATE(6319)] = 257904,
  [SMALL_STATE(6320)] = 257933,
  [SMALL_STATE(6321)] = 257962,
  [SMALL_STATE(6322)] = 258001,
  [SMALL_STATE(6323)] = 258032,
  [SMALL_STATE(6324)] = 258063,
  [SMALL_STATE(6325)] = 258094,
  [SMALL_STATE(6326)] = 258125,
  [SMALL_STATE(6327)] = 258158,
  [SMALL_STATE(6328)] = 258187,
  [SMALL_STATE(6329)] = 258218,
  [SMALL_STATE(6330)] = 258241,
  [SMALL_STATE(6331)] = 258280,
  [SMALL_STATE(6332)] = 258319,
  [SMALL_STATE(6333)] = 258362,
  [SMALL_STATE(6334)] = 258401,
  [SMALL_STATE(6335)] = 258424,
  [SMALL_STATE(6336)] = 258453,
  [SMALL_STATE(6337)] = 258484,
  [SMALL_STATE(6338)] = 258517,
  [SMALL_STATE(6339)] = 258548,
  [SMALL_STATE(6340)] = 258579,
  [SMALL_STATE(6341)] = 258610,
  [SMALL_STATE(6342)] = 258639,
  [SMALL_STATE(6343)] = 258682,
  [SMALL_STATE(6344)] = 258725,
  [SMALL_STATE(6345)] = 258754,
  [SMALL_STATE(6346)] = 258787,
  [SMALL_STATE(6347)] = 258818,
  [SMALL_STATE(6348)] = 258849,
  [SMALL_STATE(6349)] = 258888,
  [SMALL_STATE(6350)] = 258917,
  [SMALL_STATE(6351)] = 258950,
  [SMALL_STATE(6352)] = 258979,
  [SMALL_STATE(6353)] = 259006,
  [SMALL_STATE(6354)] = 259037,
  [SMALL_STATE(6355)] = 259064,
  [SMALL_STATE(6356)] = 259095,
  [SMALL_STATE(6357)] = 259124,
  [SMALL_STATE(6358)] = 259163,
  [SMALL_STATE(6359)] = 259194,
  [SMALL_STATE(6360)] = 259225,
  [SMALL_STATE(6361)] = 259256,
  [SMALL_STATE(6362)] = 259285,
  [SMALL_STATE(6363)] = 259318,
  [SMALL_STATE(6364)] = 259361,
  [SMALL_STATE(6365)] = 259400,
  [SMALL_STATE(6366)] = 259439,
  [SMALL_STATE(6367)] = 259482,
  [SMALL_STATE(6368)] = 259525,
  [SMALL_STATE(6369)] = 259564,
  [SMALL_STATE(6370)] = 259595,
  [SMALL_STATE(6371)] = 259624,
  [SMALL_STATE(6372)] = 259657,
  [SMALL_STATE(6373)] = 259688,
  [SMALL_STATE(6374)] = 259731,
  [SMALL_STATE(6375)] = 259764,
  [SMALL_STATE(6376)] = 259793,
  [SMALL_STATE(6377)] = 259826,
  [SMALL_STATE(6378)] = 259846,
  [SMALL_STATE(6379)] = 259876,
  [SMALL_STATE(6380)] = 259896,
  [SMALL_STATE(6381)] = 259936,
  [SMALL_STATE(6382)] = 259968,
  [SMALL_STATE(6383)] = 260000,
  [SMALL_STATE(6384)] = 260032,
  [SMALL_STATE(6385)] = 260064,
  [SMALL_STATE(6386)] = 260092,
  [SMALL_STATE(6387)] = 260124,
  [SMALL_STATE(6388)] = 260148,
  [SMALL_STATE(6389)] = 260180,
  [SMALL_STATE(6390)] = 260212,
  [SMALL_STATE(6391)] = 260244,
  [SMALL_STATE(6392)] = 260264,
  [SMALL_STATE(6393)] = 260292,
  [SMALL_STATE(6394)] = 260324,
  [SMALL_STATE(6395)] = 260362,
  [SMALL_STATE(6396)] = 260390,
  [SMALL_STATE(6397)] = 260420,
  [SMALL_STATE(6398)] = 260458,
  [SMALL_STATE(6399)] = 260486,
  [SMALL_STATE(6400)] = 260506,
  [SMALL_STATE(6401)] = 260536,
  [SMALL_STATE(6402)] = 260564,
  [SMALL_STATE(6403)] = 260604,
  [SMALL_STATE(6404)] = 260632,
  [SMALL_STATE(6405)] = 260664,
  [SMALL_STATE(6406)] = 260684,
  [SMALL_STATE(6407)] = 260712,
  [SMALL_STATE(6408)] = 260752,
  [SMALL_STATE(6409)] = 260780,
  [SMALL_STATE(6410)] = 260820,
  [SMALL_STATE(6411)] = 260840,
  [SMALL_STATE(6412)] = 260878,
  [SMALL_STATE(6413)] = 260906,
  [SMALL_STATE(6414)] = 260946,
  [SMALL_STATE(6415)] = 260974,
  [SMALL_STATE(6416)] = 261004,
  [SMALL_STATE(6417)] = 261024,
  [SMALL_STATE(6418)] = 261064,
  [SMALL_STATE(6419)] = 261094,
  [SMALL_STATE(6420)] = 261122,
  [SMALL_STATE(6421)] = 261160,
  [SMALL_STATE(6422)] = 261198,
  [SMALL_STATE(6423)] = 261228,
  [SMALL_STATE(6424)] = 261258,
  [SMALL_STATE(6425)] = 261288,
  [SMALL_STATE(6426)] = 261326,
  [SMALL_STATE(6427)] = 261354,
  [SMALL_STATE(6428)] = 261382,
  [SMALL_STATE(6429)] = 261408,
  [SMALL_STATE(6430)] = 261436,
  [SMALL_STATE(6431)] = 261456,
  [SMALL_STATE(6432)] = 261494,
  [SMALL_STATE(6433)] = 261534,
  [SMALL_STATE(6434)] = 261554,
  [SMALL_STATE(6435)] = 261574,
  [SMALL_STATE(6436)] = 261594,
  [SMALL_STATE(6437)] = 261626,
  [SMALL_STATE(6438)] = 261664,
  [SMALL_STATE(6439)] = 261704,
  [SMALL_STATE(6440)] = 261736,
  [SMALL_STATE(6441)] = 261776,
  [SMALL_STATE(6442)] = 261796,
  [SMALL_STATE(6443)] = 261824,
  [SMALL_STATE(6444)] = 261854,
  [SMALL_STATE(6445)] = 261882,
  [SMALL_STATE(6446)] = 261910,
  [SMALL_STATE(6447)] = 261934,
  [SMALL_STATE(6448)] = 261962,
  [SMALL_STATE(6449)] = 261990,
  [SMALL_STATE(6450)] = 262018,
  [SMALL_STATE(6451)] = 262058,
  [SMALL_STATE(6452)] = 262090,
  [SMALL_STATE(6453)] = 262112,
  [SMALL_STATE(6454)] = 262134,
  [SMALL_STATE(6455)] = 262166,
  [SMALL_STATE(6456)] = 262194,
  [SMALL_STATE(6457)] = 262216,
  [SMALL_STATE(6458)] = 262256,
  [SMALL_STATE(6459)] = 262276,
  [SMALL_STATE(6460)] = 262314,
  [SMALL_STATE(6461)] = 262352,
  [SMALL_STATE(6462)] = 262380,
  [SMALL_STATE(6463)] = 262418,
  [SMALL_STATE(6464)] = 262456,
  [SMALL_STATE(6465)] = 262494,
  [SMALL_STATE(6466)] = 262526,
  [SMALL_STATE(6467)] = 262558,
  [SMALL_STATE(6468)] = 262590,
  [SMALL_STATE(6469)] = 262630,
  [SMALL_STATE(6470)] = 262668,
  [SMALL_STATE(6471)] = 262696,
  [SMALL_STATE(6472)] = 262734,
  [SMALL_STATE(6473)] = 262766,
  [SMALL_STATE(6474)] = 262806,
  [SMALL_STATE(6475)] = 262826,
  [SMALL_STATE(6476)] = 262858,
  [SMALL_STATE(6477)] = 262896,
  [SMALL_STATE(6478)] = 262928,
  [SMALL_STATE(6479)] = 262956,
  [SMALL_STATE(6480)] = 262988,
  [SMALL_STATE(6481)] = 263008,
  [SMALL_STATE(6482)] = 263048,
  [SMALL_STATE(6483)] = 263074,
  [SMALL_STATE(6484)] = 263112,
  [SMALL_STATE(6485)] = 263144,
  [SMALL_STATE(6486)] = 263184,
  [SMALL_STATE(6487)] = 263206,
  [SMALL_STATE(6488)] = 263244,
  [SMALL_STATE(6489)] = 263268,
  [SMALL_STATE(6490)] = 263290,
  [SMALL_STATE(6491)] = 263330,
  [SMALL_STATE(6492)] = 263370,
  [SMALL_STATE(6493)] = 263402,
  [SMALL_STATE(6494)] = 263422,
  [SMALL_STATE(6495)] = 263462,
  [SMALL_STATE(6496)] = 263502,
  [SMALL_STATE(6497)] = 263540,
  [SMALL_STATE(6498)] = 263560,
  [SMALL_STATE(6499)] = 263580,
  [SMALL_STATE(6500)] = 263600,
  [SMALL_STATE(6501)] = 263628,
  [SMALL_STATE(6502)] = 263668,
  [SMALL_STATE(6503)] = 263708,
  [SMALL_STATE(6504)] = 263728,
  [SMALL_STATE(6505)] = 263748,
  [SMALL_STATE(6506)] = 263774,
  [SMALL_STATE(6507)] = 263804,
  [SMALL_STATE(6508)] = 263837,
  [SMALL_STATE(6509)] = 263870,
  [SMALL_STATE(6510)] = 263895,
  [SMALL_STATE(6511)] = 263916,
  [SMALL_STATE(6512)] = 263937,
  [SMALL_STATE(6513)] = 263972,
  [SMALL_STATE(6514)] = 263997,
  [SMALL_STATE(6515)] = 264030,
  [SMALL_STATE(6516)] = 264065,
  [SMALL_STATE(6517)] = 264098,
  [SMALL_STATE(6518)] = 264131,
  [SMALL_STATE(6519)] = 264164,
  [SMALL_STATE(6520)] = 264185,
  [SMALL_STATE(6521)] = 264206,
  [SMALL_STATE(6522)] = 264233,
  [SMALL_STATE(6523)] = 264266,
  [SMALL_STATE(6524)] = 264305,
  [SMALL_STATE(6525)] = 264326,
  [SMALL_STATE(6526)] = 264351,
  [SMALL_STATE(6527)] = 264390,
  [SMALL_STATE(6528)] = 264423,
  [SMALL_STATE(6529)] = 264450,
  [SMALL_STATE(6530)] = 264485,
  [SMALL_STATE(6531)] = 264512,
  [SMALL_STATE(6532)] = 264533,
  [SMALL_STATE(6533)] = 264570,
  [SMALL_STATE(6534)] = 264591,
  [SMALL_STATE(6535)] = 264624,
  [SMALL_STATE(6536)] = 264653,
  [SMALL_STATE(6537)] = 264682,
  [SMALL_STATE(6538)] = 264711,
  [SMALL_STATE(6539)] = 264740,
  [SMALL_STATE(6540)] = 264769,
  [SMALL_STATE(6541)] = 264802,
  [SMALL_STATE(6542)] = 264837,
  [SMALL_STATE(6543)] = 264864,
  [SMALL_STATE(6544)] = 264885,
  [SMALL_STATE(6545)] = 264912,
  [SMALL_STATE(6546)] = 264937,
  [SMALL_STATE(6547)] = 264958,
  [SMALL_STATE(6548)] = 264985,
  [SMALL_STATE(6549)] = 265018,
  [SMALL_STATE(6550)] = 265039,
  [SMALL_STATE(6551)] = 265066,
  [SMALL_STATE(6552)] = 265091,
  [SMALL_STATE(6553)] = 265118,
  [SMALL_STATE(6554)] = 265145,
  [SMALL_STATE(6555)] = 265172,
  [SMALL_STATE(6556)] = 265199,
  [SMALL_STATE(6557)] = 265232,
  [SMALL_STATE(6558)] = 265271,
  [SMALL_STATE(6559)] = 265298,
  [SMALL_STATE(6560)] = 265335,
  [SMALL_STATE(6561)] = 265368,
  [SMALL_STATE(6562)] = 265407,
  [SMALL_STATE(6563)] = 265442,
  [SMALL_STATE(6564)] = 265463,
  [SMALL_STATE(6565)] = 265484,
  [SMALL_STATE(6566)] = 265505,
  [SMALL_STATE(6567)] = 265538,
  [SMALL_STATE(6568)] = 265571,
  [SMALL_STATE(6569)] = 265604,
  [SMALL_STATE(6570)] = 265643,
  [SMALL_STATE(6571)] = 265664,
  [SMALL_STATE(6572)] = 265697,
  [SMALL_STATE(6573)] = 265730,
  [SMALL_STATE(6574)] = 265751,
  [SMALL_STATE(6575)] = 265784,
  [SMALL_STATE(6576)] = 265805,
  [SMALL_STATE(6577)] = 265832,
  [SMALL_STATE(6578)] = 265859,
  [SMALL_STATE(6579)] = 265880,
  [SMALL_STATE(6580)] = 265901,
  [SMALL_STATE(6581)] = 265922,
  [SMALL_STATE(6582)] = 265955,
  [SMALL_STATE(6583)] = 265990,
  [SMALL_STATE(6584)] = 266011,
  [SMALL_STATE(6585)] = 266036,
  [SMALL_STATE(6586)] = 266063,
  [SMALL_STATE(6587)] = 266098,
  [SMALL_STATE(6588)] = 266131,
  [SMALL_STATE(6589)] = 266164,
  [SMALL_STATE(6590)] = 266197,
  [SMALL_STATE(6591)] = 266230,
  [SMALL_STATE(6592)] = 266263,
  [SMALL_STATE(6593)] = 266296,
  [SMALL_STATE(6594)] = 266329,
  [SMALL_STATE(6595)] = 266362,
  [SMALL_STATE(6596)] = 266397,
  [SMALL_STATE(6597)] = 266432,
  [SMALL_STATE(6598)] = 266465,
  [SMALL_STATE(6599)] = 266486,
  [SMALL_STATE(6600)] = 266511,
  [SMALL_STATE(6601)] = 266550,
  [SMALL_STATE(6602)] = 266571,
  [SMALL_STATE(6603)] = 266604,
  [SMALL_STATE(6604)] = 266625,
  [SMALL_STATE(6605)] = 266646,
  [SMALL_STATE(6606)] = 266667,
  [SMALL_STATE(6607)] = 266688,
  [SMALL_STATE(6608)] = 266709,
  [SMALL_STATE(6609)] = 266730,
  [SMALL_STATE(6610)] = 266751,
  [SMALL_STATE(6611)] = 266784,
  [SMALL_STATE(6612)] = 266811,
  [SMALL_STATE(6613)] = 266846,
  [SMALL_STATE(6614)] = 266881,
  [SMALL_STATE(6615)] = 266914,
  [SMALL_STATE(6616)] = 266942,
  [SMALL_STATE(6617)] = 266968,
  [SMALL_STATE(6618)] = 266998,
  [SMALL_STATE(6619)] = 267034,
  [SMALL_STATE(6620)] = 267064,
  [SMALL_STATE(6621)] = 267094,
  [SMALL_STATE(6622)] = 267124,
  [SMALL_STATE(6623)] = 267148,
  [SMALL_STATE(6624)] = 267176,
  [SMALL_STATE(6625)] = 267202,
  [SMALL_STATE(6626)] = 267222,
  [SMALL_STATE(6627)] = 267250,
  [SMALL_STATE(6628)] = 267286,
  [SMALL_STATE(6629)] = 267322,
  [SMALL_STATE(6630)] = 267348,
  [SMALL_STATE(6631)] = 267384,
  [SMALL_STATE(6632)] = 267420,
  [SMALL_STATE(6633)] = 267456,
  [SMALL_STATE(6634)] = 267482,
  [SMALL_STATE(6635)] = 267508,
  [SMALL_STATE(6636)] = 267532,
  [SMALL_STATE(6637)] = 267556,
  [SMALL_STATE(6638)] = 267582,
  [SMALL_STATE(6639)] = 267618,
  [SMALL_STATE(6640)] = 267654,
  [SMALL_STATE(6641)] = 267690,
  [SMALL_STATE(6642)] = 267726,
  [SMALL_STATE(6643)] = 267756,
  [SMALL_STATE(6644)] = 267786,
  [SMALL_STATE(6645)] = 267816,
  [SMALL_STATE(6646)] = 267852,
  [SMALL_STATE(6647)] = 267888,
  [SMALL_STATE(6648)] = 267918,
  [SMALL_STATE(6649)] = 267954,
  [SMALL_STATE(6650)] = 267990,
  [SMALL_STATE(6651)] = 268016,
  [SMALL_STATE(6652)] = 268052,
  [SMALL_STATE(6653)] = 268082,
  [SMALL_STATE(6654)] = 268108,
  [SMALL_STATE(6655)] = 268138,
  [SMALL_STATE(6656)] = 268164,
  [SMALL_STATE(6657)] = 268186,
  [SMALL_STATE(6658)] = 268212,
  [SMALL_STATE(6659)] = 268236,
  [SMALL_STATE(6660)] = 268266,
  [SMALL_STATE(6661)] = 268302,
  [SMALL_STATE(6662)] = 268328,
  [SMALL_STATE(6663)] = 268354,
  [SMALL_STATE(6664)] = 268380,
  [SMALL_STATE(6665)] = 268406,
  [SMALL_STATE(6666)] = 268432,
  [SMALL_STATE(6667)] = 268462,
  [SMALL_STATE(6668)] = 268498,
  [SMALL_STATE(6669)] = 268528,
  [SMALL_STATE(6670)] = 268554,
  [SMALL_STATE(6671)] = 268580,
  [SMALL_STATE(6672)] = 268600,
  [SMALL_STATE(6673)] = 268636,
  [SMALL_STATE(6674)] = 268664,
  [SMALL_STATE(6675)] = 268692,
  [SMALL_STATE(6676)] = 268714,
  [SMALL_STATE(6677)] = 268738,
  [SMALL_STATE(6678)] = 268774,
  [SMALL_STATE(6679)] = 268810,
  [SMALL_STATE(6680)] = 268846,
  [SMALL_STATE(6681)] = 268872,
  [SMALL_STATE(6682)] = 268907,
  [SMALL_STATE(6683)] = 268936,
  [SMALL_STATE(6684)] = 268955,
  [SMALL_STATE(6685)] = 268982,
  [SMALL_STATE(6686)] = 269009,
  [SMALL_STATE(6687)] = 269038,
  [SMALL_STATE(6688)] = 269069,
  [SMALL_STATE(6689)] = 269098,
  [SMALL_STATE(6690)] = 269117,
  [SMALL_STATE(6691)] = 269152,
  [SMALL_STATE(6692)] = 269187,
  [SMALL_STATE(6693)] = 269212,
  [SMALL_STATE(6694)] = 269247,
  [SMALL_STATE(6695)] = 269272,
  [SMALL_STATE(6696)] = 269307,
  [SMALL_STATE(6697)] = 269328,
  [SMALL_STATE(6698)] = 269359,
  [SMALL_STATE(6699)] = 269378,
  [SMALL_STATE(6700)] = 269411,
  [SMALL_STATE(6701)] = 269438,
  [SMALL_STATE(6702)] = 269463,
  [SMALL_STATE(6703)] = 269494,
  [SMALL_STATE(6704)] = 269513,
  [SMALL_STATE(6705)] = 269544,
  [SMALL_STATE(6706)] = 269573,
  [SMALL_STATE(6707)] = 269604,
  [SMALL_STATE(6708)] = 269623,
  [SMALL_STATE(6709)] = 269648,
  [SMALL_STATE(6710)] = 269679,
  [SMALL_STATE(6711)] = 269714,
  [SMALL_STATE(6712)] = 269747,
  [SMALL_STATE(6713)] = 269778,
  [SMALL_STATE(6714)] = 269807,
  [SMALL_STATE(6715)] = 269836,
  [SMALL_STATE(6716)] = 269859,
  [SMALL_STATE(6717)] = 269894,
  [SMALL_STATE(6718)] = 269923,
  [SMALL_STATE(6719)] = 269958,
  [SMALL_STATE(6720)] = 269989,
  [SMALL_STATE(6721)] = 270014,
  [SMALL_STATE(6722)] = 270039,
  [SMALL_STATE(6723)] = 270058,
  [SMALL_STATE(6724)] = 270089,
  [SMALL_STATE(6725)] = 270116,
  [SMALL_STATE(6726)] = 270141,
  [SMALL_STATE(6727)] = 270166,
  [SMALL_STATE(6728)] = 270201,
  [SMALL_STATE(6729)] = 270224,
  [SMALL_STATE(6730)] = 270255,
  [SMALL_STATE(6731)] = 270282,
  [SMALL_STATE(6732)] = 270301,
  [SMALL_STATE(6733)] = 270328,
  [SMALL_STATE(6734)] = 270361,
  [SMALL_STATE(6735)] = 270386,
  [SMALL_STATE(6736)] = 270411,
  [SMALL_STATE(6737)] = 270446,
  [SMALL_STATE(6738)] = 270473,
  [SMALL_STATE(6739)] = 270500,
  [SMALL_STATE(6740)] = 270531,
  [SMALL_STATE(6741)] = 270566,
  [SMALL_STATE(6742)] = 270593,
  [SMALL_STATE(6743)] = 270624,
  [SMALL_STATE(6744)] = 270655,
  [SMALL_STATE(6745)] = 270684,
  [SMALL_STATE(6746)] = 270709,
  [SMALL_STATE(6747)] = 270744,
  [SMALL_STATE(6748)] = 270773,
  [SMALL_STATE(6749)] = 270792,
  [SMALL_STATE(6750)] = 270825,
  [SMALL_STATE(6751)] = 270860,
  [SMALL_STATE(6752)] = 270885,
  [SMALL_STATE(6753)] = 270916,
  [SMALL_STATE(6754)] = 270935,
  [SMALL_STATE(6755)] = 270970,
  [SMALL_STATE(6756)] = 271005,
  [SMALL_STATE(6757)] = 271040,
  [SMALL_STATE(6758)] = 271059,
  [SMALL_STATE(6759)] = 271088,
  [SMALL_STATE(6760)] = 271123,
  [SMALL_STATE(6761)] = 271150,
  [SMALL_STATE(6762)] = 271185,
  [SMALL_STATE(6763)] = 271220,
  [SMALL_STATE(6764)] = 271249,
  [SMALL_STATE(6765)] = 271278,
  [SMALL_STATE(6766)] = 271313,
  [SMALL_STATE(6767)] = 271348,
  [SMALL_STATE(6768)] = 271379,
  [SMALL_STATE(6769)] = 271403,
  [SMALL_STATE(6770)] = 271427,
  [SMALL_STATE(6771)] = 271451,
  [SMALL_STATE(6772)] = 271475,
  [SMALL_STATE(6773)] = 271499,
  [SMALL_STATE(6774)] = 271523,
  [SMALL_STATE(6775)] = 271547,
  [SMALL_STATE(6776)] = 271569,
  [SMALL_STATE(6777)] = 271599,
  [SMALL_STATE(6778)] = 271629,
  [SMALL_STATE(6779)] = 271651,
  [SMALL_STATE(6780)] = 271683,
  [SMALL_STATE(6781)] = 271713,
  [SMALL_STATE(6782)] = 271735,
  [SMALL_STATE(6783)] = 271753,
  [SMALL_STATE(6784)] = 271771,
  [SMALL_STATE(6785)] = 271795,
  [SMALL_STATE(6786)] = 271819,
  [SMALL_STATE(6787)] = 271837,
  [SMALL_STATE(6788)] = 271861,
  [SMALL_STATE(6789)] = 271883,
  [SMALL_STATE(6790)] = 271901,
  [SMALL_STATE(6791)] = 271931,
  [SMALL_STATE(6792)] = 271953,
  [SMALL_STATE(6793)] = 271971,
  [SMALL_STATE(6794)] = 271989,
  [SMALL_STATE(6795)] = 272019,
  [SMALL_STATE(6796)] = 272041,
  [SMALL_STATE(6797)] = 272059,
  [SMALL_STATE(6798)] = 272089,
  [SMALL_STATE(6799)] = 272111,
  [SMALL_STATE(6800)] = 272141,
  [SMALL_STATE(6801)] = 272163,
  [SMALL_STATE(6802)] = 272185,
  [SMALL_STATE(6803)] = 272207,
  [SMALL_STATE(6804)] = 272229,
  [SMALL_STATE(6805)] = 272251,
  [SMALL_STATE(6806)] = 272273,
  [SMALL_STATE(6807)] = 272303,
  [SMALL_STATE(6808)] = 272325,
  [SMALL_STATE(6809)] = 272347,
  [SMALL_STATE(6810)] = 272378,
  [SMALL_STATE(6811)] = 272409,
  [SMALL_STATE(6812)] = 272440,
  [SMALL_STATE(6813)] = 272467,
  [SMALL_STATE(6814)] = 272494,
  [SMALL_STATE(6815)] = 272515,
  [SMALL_STATE(6816)] = 272546,
  [SMALL_STATE(6817)] = 272577,
  [SMALL_STATE(6818)] = 272608,
  [SMALL_STATE(6819)] = 272639,
  [SMALL_STATE(6820)] = 272662,
  [SMALL_STATE(6821)] = 272681,
  [SMALL_STATE(6822)] = 272712,
  [SMALL_STATE(6823)] = 272743,
  [SMALL_STATE(6824)] = 272774,
  [SMALL_STATE(6825)] = 272797,
  [SMALL_STATE(6826)] = 272824,
  [SMALL_STATE(6827)] = 272851,
  [SMALL_STATE(6828)] = 272882,
  [SMALL_STATE(6829)] = 272905,
  [SMALL_STATE(6830)] = 272936,
  [SMALL_STATE(6831)] = 272967,
  [SMALL_STATE(6832)] = 272998,
  [SMALL_STATE(6833)] = 273029,
  [SMALL_STATE(6834)] = 273060,
  [SMALL_STATE(6835)] = 273087,
  [SMALL_STATE(6836)] = 273112,
  [SMALL_STATE(6837)] = 273143,
  [SMALL_STATE(6838)] = 273174,
  [SMALL_STATE(6839)] = 273197,
  [SMALL_STATE(6840)] = 273228,
  [SMALL_STATE(6841)] = 273255,
  [SMALL_STATE(6842)] = 273276,
  [SMALL_STATE(6843)] = 273307,
  [SMALL_STATE(6844)] = 273334,
  [SMALL_STATE(6845)] = 273357,
  [SMALL_STATE(6846)] = 273388,
  [SMALL_STATE(6847)] = 273419,
  [SMALL_STATE(6848)] = 273450,
  [SMALL_STATE(6849)] = 273481,
  [SMALL_STATE(6850)] = 273504,
  [SMALL_STATE(6851)] = 273525,
  [SMALL_STATE(6852)] = 273556,
  [SMALL_STATE(6853)] = 273577,
  [SMALL_STATE(6854)] = 273608,
  [SMALL_STATE(6855)] = 273631,
  [SMALL_STATE(6856)] = 273662,
  [SMALL_STATE(6857)] = 273685,
  [SMALL_STATE(6858)] = 273706,
  [SMALL_STATE(6859)] = 273737,
  [SMALL_STATE(6860)] = 273760,
  [SMALL_STATE(6861)] = 273791,
  [SMALL_STATE(6862)] = 273822,
  [SMALL_STATE(6863)] = 273841,
  [SMALL_STATE(6864)] = 273864,
  [SMALL_STATE(6865)] = 273895,
  [SMALL_STATE(6866)] = 273921,
  [SMALL_STATE(6867)] = 273947,
  [SMALL_STATE(6868)] = 273973,
  [SMALL_STATE(6869)] = 273999,
  [SMALL_STATE(6870)] = 274021,
  [SMALL_STATE(6871)] = 274047,
  [SMALL_STATE(6872)] = 274067,
  [SMALL_STATE(6873)] = 274093,
  [SMALL_STATE(6874)] = 274119,
  [SMALL_STATE(6875)] = 274145,
  [SMALL_STATE(6876)] = 274171,
  [SMALL_STATE(6877)] = 274193,
  [SMALL_STATE(6878)] = 274219,
  [SMALL_STATE(6879)] = 274245,
  [SMALL_STATE(6880)] = 274267,
  [SMALL_STATE(6881)] = 274285,
  [SMALL_STATE(6882)] = 274301,
  [SMALL_STATE(6883)] = 274327,
  [SMALL_STATE(6884)] = 274353,
  [SMALL_STATE(6885)] = 274373,
  [SMALL_STATE(6886)] = 274399,
  [SMALL_STATE(6887)] = 274425,
  [SMALL_STATE(6888)] = 274447,
  [SMALL_STATE(6889)] = 274473,
  [SMALL_STATE(6890)] = 274499,
  [SMALL_STATE(6891)] = 274525,
  [SMALL_STATE(6892)] = 274551,
  [SMALL_STATE(6893)] = 274573,
  [SMALL_STATE(6894)] = 274599,
  [SMALL_STATE(6895)] = 274625,
  [SMALL_STATE(6896)] = 274647,
  [SMALL_STATE(6897)] = 274667,
  [SMALL_STATE(6898)] = 274693,
  [SMALL_STATE(6899)] = 274713,
  [SMALL_STATE(6900)] = 274735,
  [SMALL_STATE(6901)] = 274757,
  [SMALL_STATE(6902)] = 274783,
  [SMALL_STATE(6903)] = 274809,
  [SMALL_STATE(6904)] = 274835,
  [SMALL_STATE(6905)] = 274861,
  [SMALL_STATE(6906)] = 274887,
  [SMALL_STATE(6907)] = 274913,
  [SMALL_STATE(6908)] = 274935,
  [SMALL_STATE(6909)] = 274957,
  [SMALL_STATE(6910)] = 274979,
  [SMALL_STATE(6911)] = 275005,
  [SMALL_STATE(6912)] = 275027,
  [SMALL_STATE(6913)] = 275043,
  [SMALL_STATE(6914)] = 275069,
  [SMALL_STATE(6915)] = 275088,
  [SMALL_STATE(6916)] = 275109,
  [SMALL_STATE(6917)] = 275134,
  [SMALL_STATE(6918)] = 275159,
  [SMALL_STATE(6919)] = 275174,
  [SMALL_STATE(6920)] = 275199,
  [SMALL_STATE(6921)] = 275224,
  [SMALL_STATE(6922)] = 275239,
  [SMALL_STATE(6923)] = 275262,
  [SMALL_STATE(6924)] = 275283,
  [SMALL_STATE(6925)] = 275304,
  [SMALL_STATE(6926)] = 275325,
  [SMALL_STATE(6927)] = 275348,
  [SMALL_STATE(6928)] = 275367,
  [SMALL_STATE(6929)] = 275388,
  [SMALL_STATE(6930)] = 275411,
  [SMALL_STATE(6931)] = 275434,
  [SMALL_STATE(6932)] = 275457,
  [SMALL_STATE(6933)] = 275480,
  [SMALL_STATE(6934)] = 275501,
  [SMALL_STATE(6935)] = 275516,
  [SMALL_STATE(6936)] = 275539,
  [SMALL_STATE(6937)] = 275554,
  [SMALL_STATE(6938)] = 275577,
  [SMALL_STATE(6939)] = 275600,
  [SMALL_STATE(6940)] = 275621,
  [SMALL_STATE(6941)] = 275646,
  [SMALL_STATE(6942)] = 275665,
  [SMALL_STATE(6943)] = 275690,
  [SMALL_STATE(6944)] = 275711,
  [SMALL_STATE(6945)] = 275736,
  [SMALL_STATE(6946)] = 275751,
  [SMALL_STATE(6947)] = 275772,
  [SMALL_STATE(6948)] = 275793,
  [SMALL_STATE(6949)] = 275808,
  [SMALL_STATE(6950)] = 275831,
  [SMALL_STATE(6951)] = 275852,
  [SMALL_STATE(6952)] = 275873,
  [SMALL_STATE(6953)] = 275894,
  [SMALL_STATE(6954)] = 275911,
  [SMALL_STATE(6955)] = 275934,
  [SMALL_STATE(6956)] = 275955,
  [SMALL_STATE(6957)] = 275976,
  [SMALL_STATE(6958)] = 275999,
  [SMALL_STATE(6959)] = 276022,
  [SMALL_STATE(6960)] = 276037,
  [SMALL_STATE(6961)] = 276058,
  [SMALL_STATE(6962)] = 276073,
  [SMALL_STATE(6963)] = 276096,
  [SMALL_STATE(6964)] = 276119,
  [SMALL_STATE(6965)] = 276142,
  [SMALL_STATE(6966)] = 276165,
  [SMALL_STATE(6967)] = 276190,
  [SMALL_STATE(6968)] = 276206,
  [SMALL_STATE(6969)] = 276224,
  [SMALL_STATE(6970)] = 276238,
  [SMALL_STATE(6971)] = 276254,
  [SMALL_STATE(6972)] = 276270,
  [SMALL_STATE(6973)] = 276286,
  [SMALL_STATE(6974)] = 276302,
  [SMALL_STATE(6975)] = 276318,
  [SMALL_STATE(6976)] = 276334,
  [SMALL_STATE(6977)] = 276350,
  [SMALL_STATE(6978)] = 276366,
  [SMALL_STATE(6979)] = 276382,
  [SMALL_STATE(6980)] = 276400,
  [SMALL_STATE(6981)] = 276414,
  [SMALL_STATE(6982)] = 276428,
  [SMALL_STATE(6983)] = 276442,
  [SMALL_STATE(6984)] = 276462,
  [SMALL_STATE(6985)] = 276478,
  [SMALL_STATE(6986)] = 276494,
  [SMALL_STATE(6987)] = 276514,
  [SMALL_STATE(6988)] = 276530,
  [SMALL_STATE(6989)] = 276546,
  [SMALL_STATE(6990)] = 276566,
  [SMALL_STATE(6991)] = 276586,
  [SMALL_STATE(6992)] = 276602,
  [SMALL_STATE(6993)] = 276618,
  [SMALL_STATE(6994)] = 276632,
  [SMALL_STATE(6995)] = 276652,
  [SMALL_STATE(6996)] = 276672,
  [SMALL_STATE(6997)] = 276692,
  [SMALL_STATE(6998)] = 276706,
  [SMALL_STATE(6999)] = 276726,
  [SMALL_STATE(7000)] = 276746,
  [SMALL_STATE(7001)] = 276766,
  [SMALL_STATE(7002)] = 276786,
  [SMALL_STATE(7003)] = 276804,
  [SMALL_STATE(7004)] = 276822,
  [SMALL_STATE(7005)] = 276836,
  [SMALL_STATE(7006)] = 276852,
  [SMALL_STATE(7007)] = 276872,
  [SMALL_STATE(7008)] = 276892,
  [SMALL_STATE(7009)] = 276910,
  [SMALL_STATE(7010)] = 276924,
  [SMALL_STATE(7011)] = 276940,
  [SMALL_STATE(7012)] = 276956,
  [SMALL_STATE(7013)] = 276970,
  [SMALL_STATE(7014)] = 276988,
  [SMALL_STATE(7015)] = 277002,
  [SMALL_STATE(7016)] = 277016,
  [SMALL_STATE(7017)] = 277036,
  [SMALL_STATE(7018)] = 277056,
  [SMALL_STATE(7019)] = 277074,
  [SMALL_STATE(7020)] = 277092,
  [SMALL_STATE(7021)] = 277106,
  [SMALL_STATE(7022)] = 277120,
  [SMALL_STATE(7023)] = 277140,
  [SMALL_STATE(7024)] = 277154,
  [SMALL_STATE(7025)] = 277173,
  [SMALL_STATE(7026)] = 277192,
  [SMALL_STATE(7027)] = 277211,
  [SMALL_STATE(7028)] = 277230,
  [SMALL_STATE(7029)] = 277249,
  [SMALL_STATE(7030)] = 277268,
  [SMALL_STATE(7031)] = 277287,
  [SMALL_STATE(7032)] = 277304,
  [SMALL_STATE(7033)] = 277321,
  [SMALL_STATE(7034)] = 277340,
  [SMALL_STATE(7035)] = 277359,
  [SMALL_STATE(7036)] = 277378,
  [SMALL_STATE(7037)] = 277397,
  [SMALL_STATE(7038)] = 277416,
  [SMALL_STATE(7039)] = 277433,
  [SMALL_STATE(7040)] = 277452,
  [SMALL_STATE(7041)] = 277469,
  [SMALL_STATE(7042)] = 277488,
  [SMALL_STATE(7043)] = 277507,
  [SMALL_STATE(7044)] = 277526,
  [SMALL_STATE(7045)] = 277545,
  [SMALL_STATE(7046)] = 277562,
  [SMALL_STATE(7047)] = 277581,
  [SMALL_STATE(7048)] = 277600,
  [SMALL_STATE(7049)] = 277619,
  [SMALL_STATE(7050)] = 277638,
  [SMALL_STATE(7051)] = 277651,
  [SMALL_STATE(7052)] = 277664,
  [SMALL_STATE(7053)] = 277683,
  [SMALL_STATE(7054)] = 277702,
  [SMALL_STATE(7055)] = 277721,
  [SMALL_STATE(7056)] = 277738,
  [SMALL_STATE(7057)] = 277757,
  [SMALL_STATE(7058)] = 277776,
  [SMALL_STATE(7059)] = 277795,
  [SMALL_STATE(7060)] = 277814,
  [SMALL_STATE(7061)] = 277833,
  [SMALL_STATE(7062)] = 277852,
  [SMALL_STATE(7063)] = 277871,
  [SMALL_STATE(7064)] = 277890,
  [SMALL_STATE(7065)] = 277909,
  [SMALL_STATE(7066)] = 277928,
  [SMALL_STATE(7067)] = 277947,
  [SMALL_STATE(7068)] = 277964,
  [SMALL_STATE(7069)] = 277983,
  [SMALL_STATE(7070)] = 278002,
  [SMALL_STATE(7071)] = 278021,
  [SMALL_STATE(7072)] = 278040,
  [SMALL_STATE(7073)] = 278059,
  [SMALL_STATE(7074)] = 278078,
  [SMALL_STATE(7075)] = 278097,
  [SMALL_STATE(7076)] = 278116,
  [SMALL_STATE(7077)] = 278129,
  [SMALL_STATE(7078)] = 278148,
  [SMALL_STATE(7079)] = 278167,
  [SMALL_STATE(7080)] = 278180,
  [SMALL_STATE(7081)] = 278199,
  [SMALL_STATE(7082)] = 278218,
  [SMALL_STATE(7083)] = 278237,
  [SMALL_STATE(7084)] = 278256,
  [SMALL_STATE(7085)] = 278272,
  [SMALL_STATE(7086)] = 278286,
  [SMALL_STATE(7087)] = 278300,
  [SMALL_STATE(7088)] = 278316,
  [SMALL_STATE(7089)] = 278330,
  [SMALL_STATE(7090)] = 278346,
  [SMALL_STATE(7091)] = 278362,
  [SMALL_STATE(7092)] = 278378,
  [SMALL_STATE(7093)] = 278392,
  [SMALL_STATE(7094)] = 278406,
  [SMALL_STATE(7095)] = 278422,
  [SMALL_STATE(7096)] = 278438,
  [SMALL_STATE(7097)] = 278452,
  [SMALL_STATE(7098)] = 278468,
  [SMALL_STATE(7099)] = 278484,
  [SMALL_STATE(7100)] = 278498,
  [SMALL_STATE(7101)] = 278514,
  [SMALL_STATE(7102)] = 278530,
  [SMALL_STATE(7103)] = 278544,
  [SMALL_STATE(7104)] = 278560,
  [SMALL_STATE(7105)] = 278576,
  [SMALL_STATE(7106)] = 278592,
  [SMALL_STATE(7107)] = 278606,
  [SMALL_STATE(7108)] = 278622,
  [SMALL_STATE(7109)] = 278638,
  [SMALL_STATE(7110)] = 278652,
  [SMALL_STATE(7111)] = 278666,
  [SMALL_STATE(7112)] = 278682,
  [SMALL_STATE(7113)] = 278698,
  [SMALL_STATE(7114)] = 278714,
  [SMALL_STATE(7115)] = 278730,
  [SMALL_STATE(7116)] = 278746,
  [SMALL_STATE(7117)] = 278760,
  [SMALL_STATE(7118)] = 278774,
  [SMALL_STATE(7119)] = 278788,
  [SMALL_STATE(7120)] = 278804,
  [SMALL_STATE(7121)] = 278820,
  [SMALL_STATE(7122)] = 278836,
  [SMALL_STATE(7123)] = 278852,
  [SMALL_STATE(7124)] = 278868,
  [SMALL_STATE(7125)] = 278884,
  [SMALL_STATE(7126)] = 278900,
  [SMALL_STATE(7127)] = 278914,
  [SMALL_STATE(7128)] = 278928,
  [SMALL_STATE(7129)] = 278942,
  [SMALL_STATE(7130)] = 278958,
  [SMALL_STATE(7131)] = 278974,
  [SMALL_STATE(7132)] = 278988,
  [SMALL_STATE(7133)] = 279002,
  [SMALL_STATE(7134)] = 279018,
  [SMALL_STATE(7135)] = 279034,
  [SMALL_STATE(7136)] = 279050,
  [SMALL_STATE(7137)] = 279066,
  [SMALL_STATE(7138)] = 279082,
  [SMALL_STATE(7139)] = 279098,
  [SMALL_STATE(7140)] = 279114,
  [SMALL_STATE(7141)] = 279130,
  [SMALL_STATE(7142)] = 279146,
  [SMALL_STATE(7143)] = 279162,
  [SMALL_STATE(7144)] = 279176,
  [SMALL_STATE(7145)] = 279192,
  [SMALL_STATE(7146)] = 279208,
  [SMALL_STATE(7147)] = 279222,
  [SMALL_STATE(7148)] = 279236,
  [SMALL_STATE(7149)] = 279252,
  [SMALL_STATE(7150)] = 279268,
  [SMALL_STATE(7151)] = 279284,
  [SMALL_STATE(7152)] = 279298,
  [SMALL_STATE(7153)] = 279314,
  [SMALL_STATE(7154)] = 279328,
  [SMALL_STATE(7155)] = 279344,
  [SMALL_STATE(7156)] = 279358,
  [SMALL_STATE(7157)] = 279374,
  [SMALL_STATE(7158)] = 279390,
  [SMALL_STATE(7159)] = 279406,
  [SMALL_STATE(7160)] = 279420,
  [SMALL_STATE(7161)] = 279436,
  [SMALL_STATE(7162)] = 279452,
  [SMALL_STATE(7163)] = 279466,
  [SMALL_STATE(7164)] = 279482,
  [SMALL_STATE(7165)] = 279498,
  [SMALL_STATE(7166)] = 279514,
  [SMALL_STATE(7167)] = 279528,
  [SMALL_STATE(7168)] = 279542,
  [SMALL_STATE(7169)] = 279558,
  [SMALL_STATE(7170)] = 279574,
  [SMALL_STATE(7171)] = 279588,
  [SMALL_STATE(7172)] = 279604,
  [SMALL_STATE(7173)] = 279620,
  [SMALL_STATE(7174)] = 279636,
  [SMALL_STATE(7175)] = 279652,
  [SMALL_STATE(7176)] = 279666,
  [SMALL_STATE(7177)] = 279680,
  [SMALL_STATE(7178)] = 279696,
  [SMALL_STATE(7179)] = 279712,
  [SMALL_STATE(7180)] = 279728,
  [SMALL_STATE(7181)] = 279744,
  [SMALL_STATE(7182)] = 279760,
  [SMALL_STATE(7183)] = 279774,
  [SMALL_STATE(7184)] = 279790,
  [SMALL_STATE(7185)] = 279806,
  [SMALL_STATE(7186)] = 279822,
  [SMALL_STATE(7187)] = 279836,
  [SMALL_STATE(7188)] = 279852,
  [SMALL_STATE(7189)] = 279868,
  [SMALL_STATE(7190)] = 279882,
  [SMALL_STATE(7191)] = 279898,
  [SMALL_STATE(7192)] = 279914,
  [SMALL_STATE(7193)] = 279928,
  [SMALL_STATE(7194)] = 279944,
  [SMALL_STATE(7195)] = 279958,
  [SMALL_STATE(7196)] = 279974,
  [SMALL_STATE(7197)] = 279990,
  [SMALL_STATE(7198)] = 280004,
  [SMALL_STATE(7199)] = 280018,
  [SMALL_STATE(7200)] = 280032,
  [SMALL_STATE(7201)] = 280048,
  [SMALL_STATE(7202)] = 280064,
  [SMALL_STATE(7203)] = 280080,
  [SMALL_STATE(7204)] = 280096,
  [SMALL_STATE(7205)] = 280110,
  [SMALL_STATE(7206)] = 280126,
  [SMALL_STATE(7207)] = 280140,
  [SMALL_STATE(7208)] = 280156,
  [SMALL_STATE(7209)] = 280172,
  [SMALL_STATE(7210)] = 280188,
  [SMALL_STATE(7211)] = 280204,
  [SMALL_STATE(7212)] = 280220,
  [SMALL_STATE(7213)] = 280236,
  [SMALL_STATE(7214)] = 280252,
  [SMALL_STATE(7215)] = 280268,
  [SMALL_STATE(7216)] = 280284,
  [SMALL_STATE(7217)] = 280300,
  [SMALL_STATE(7218)] = 280314,
  [SMALL_STATE(7219)] = 280324,
  [SMALL_STATE(7220)] = 280340,
  [SMALL_STATE(7221)] = 280356,
  [SMALL_STATE(7222)] = 280370,
  [SMALL_STATE(7223)] = 280384,
  [SMALL_STATE(7224)] = 280398,
  [SMALL_STATE(7225)] = 280414,
  [SMALL_STATE(7226)] = 280428,
  [SMALL_STATE(7227)] = 280444,
  [SMALL_STATE(7228)] = 280460,
  [SMALL_STATE(7229)] = 280476,
  [SMALL_STATE(7230)] = 280490,
  [SMALL_STATE(7231)] = 280504,
  [SMALL_STATE(7232)] = 280518,
  [SMALL_STATE(7233)] = 280532,
  [SMALL_STATE(7234)] = 280548,
  [SMALL_STATE(7235)] = 280562,
  [SMALL_STATE(7236)] = 280578,
  [SMALL_STATE(7237)] = 280592,
  [SMALL_STATE(7238)] = 280608,
  [SMALL_STATE(7239)] = 280624,
  [SMALL_STATE(7240)] = 280638,
  [SMALL_STATE(7241)] = 280652,
  [SMALL_STATE(7242)] = 280668,
  [SMALL_STATE(7243)] = 280684,
  [SMALL_STATE(7244)] = 280700,
  [SMALL_STATE(7245)] = 280716,
  [SMALL_STATE(7246)] = 280730,
  [SMALL_STATE(7247)] = 280744,
  [SMALL_STATE(7248)] = 280758,
  [SMALL_STATE(7249)] = 280774,
  [SMALL_STATE(7250)] = 280788,
  [SMALL_STATE(7251)] = 280804,
  [SMALL_STATE(7252)] = 280820,
  [SMALL_STATE(7253)] = 280834,
  [SMALL_STATE(7254)] = 280848,
  [SMALL_STATE(7255)] = 280864,
  [SMALL_STATE(7256)] = 280878,
  [SMALL_STATE(7257)] = 280894,
  [SMALL_STATE(7258)] = 280910,
  [SMALL_STATE(7259)] = 280926,
  [SMALL_STATE(7260)] = 280940,
  [SMALL_STATE(7261)] = 280954,
  [SMALL_STATE(7262)] = 280970,
  [SMALL_STATE(7263)] = 280986,
  [SMALL_STATE(7264)] = 281000,
  [SMALL_STATE(7265)] = 281014,
  [SMALL_STATE(7266)] = 281030,
  [SMALL_STATE(7267)] = 281044,
  [SMALL_STATE(7268)] = 281058,
  [SMALL_STATE(7269)] = 281074,
  [SMALL_STATE(7270)] = 281088,
  [SMALL_STATE(7271)] = 281102,
  [SMALL_STATE(7272)] = 281118,
  [SMALL_STATE(7273)] = 281134,
  [SMALL_STATE(7274)] = 281150,
  [SMALL_STATE(7275)] = 281164,
  [SMALL_STATE(7276)] = 281180,
  [SMALL_STATE(7277)] = 281196,
  [SMALL_STATE(7278)] = 281210,
  [SMALL_STATE(7279)] = 281224,
  [SMALL_STATE(7280)] = 281238,
  [SMALL_STATE(7281)] = 281252,
  [SMALL_STATE(7282)] = 281266,
  [SMALL_STATE(7283)] = 281282,
  [SMALL_STATE(7284)] = 281296,
  [SMALL_STATE(7285)] = 281310,
  [SMALL_STATE(7286)] = 281324,
  [SMALL_STATE(7287)] = 281340,
  [SMALL_STATE(7288)] = 281354,
  [SMALL_STATE(7289)] = 281368,
  [SMALL_STATE(7290)] = 281382,
  [SMALL_STATE(7291)] = 281398,
  [SMALL_STATE(7292)] = 281412,
  [SMALL_STATE(7293)] = 281428,
  [SMALL_STATE(7294)] = 281442,
  [SMALL_STATE(7295)] = 281456,
  [SMALL_STATE(7296)] = 281470,
  [SMALL_STATE(7297)] = 281486,
  [SMALL_STATE(7298)] = 281500,
  [SMALL_STATE(7299)] = 281516,
  [SMALL_STATE(7300)] = 281530,
  [SMALL_STATE(7301)] = 281544,
  [SMALL_STATE(7302)] = 281558,
  [SMALL_STATE(7303)] = 281574,
  [SMALL_STATE(7304)] = 281590,
  [SMALL_STATE(7305)] = 281604,
  [SMALL_STATE(7306)] = 281618,
  [SMALL_STATE(7307)] = 281634,
  [SMALL_STATE(7308)] = 281648,
  [SMALL_STATE(7309)] = 281662,
  [SMALL_STATE(7310)] = 281678,
  [SMALL_STATE(7311)] = 281692,
  [SMALL_STATE(7312)] = 281708,
  [SMALL_STATE(7313)] = 281722,
  [SMALL_STATE(7314)] = 281736,
  [SMALL_STATE(7315)] = 281750,
  [SMALL_STATE(7316)] = 281764,
  [SMALL_STATE(7317)] = 281778,
  [SMALL_STATE(7318)] = 281792,
  [SMALL_STATE(7319)] = 281806,
  [SMALL_STATE(7320)] = 281822,
  [SMALL_STATE(7321)] = 281836,
  [SMALL_STATE(7322)] = 281850,
  [SMALL_STATE(7323)] = 281866,
  [SMALL_STATE(7324)] = 281880,
  [SMALL_STATE(7325)] = 281894,
  [SMALL_STATE(7326)] = 281908,
  [SMALL_STATE(7327)] = 281924,
  [SMALL_STATE(7328)] = 281940,
  [SMALL_STATE(7329)] = 281950,
  [SMALL_STATE(7330)] = 281964,
  [SMALL_STATE(7331)] = 281978,
  [SMALL_STATE(7332)] = 281994,
  [SMALL_STATE(7333)] = 282010,
  [SMALL_STATE(7334)] = 282024,
  [SMALL_STATE(7335)] = 282038,
  [SMALL_STATE(7336)] = 282052,
  [SMALL_STATE(7337)] = 282066,
  [SMALL_STATE(7338)] = 282080,
  [SMALL_STATE(7339)] = 282094,
  [SMALL_STATE(7340)] = 282110,
  [SMALL_STATE(7341)] = 282124,
  [SMALL_STATE(7342)] = 282138,
  [SMALL_STATE(7343)] = 282152,
  [SMALL_STATE(7344)] = 282168,
  [SMALL_STATE(7345)] = 282184,
  [SMALL_STATE(7346)] = 282200,
  [SMALL_STATE(7347)] = 282210,
  [SMALL_STATE(7348)] = 282226,
  [SMALL_STATE(7349)] = 282242,
  [SMALL_STATE(7350)] = 282258,
  [SMALL_STATE(7351)] = 282274,
  [SMALL_STATE(7352)] = 282290,
  [SMALL_STATE(7353)] = 282306,
  [SMALL_STATE(7354)] = 282320,
  [SMALL_STATE(7355)] = 282336,
  [SMALL_STATE(7356)] = 282352,
  [SMALL_STATE(7357)] = 282366,
  [SMALL_STATE(7358)] = 282382,
  [SMALL_STATE(7359)] = 282398,
  [SMALL_STATE(7360)] = 282414,
  [SMALL_STATE(7361)] = 282428,
  [SMALL_STATE(7362)] = 282444,
  [SMALL_STATE(7363)] = 282458,
  [SMALL_STATE(7364)] = 282470,
  [SMALL_STATE(7365)] = 282484,
  [SMALL_STATE(7366)] = 282498,
  [SMALL_STATE(7367)] = 282512,
  [SMALL_STATE(7368)] = 282526,
  [SMALL_STATE(7369)] = 282540,
  [SMALL_STATE(7370)] = 282556,
  [SMALL_STATE(7371)] = 282569,
  [SMALL_STATE(7372)] = 282582,
  [SMALL_STATE(7373)] = 282595,
  [SMALL_STATE(7374)] = 282608,
  [SMALL_STATE(7375)] = 282621,
  [SMALL_STATE(7376)] = 282634,
  [SMALL_STATE(7377)] = 282647,
  [SMALL_STATE(7378)] = 282660,
  [SMALL_STATE(7379)] = 282669,
  [SMALL_STATE(7380)] = 282682,
  [SMALL_STATE(7381)] = 282695,
  [SMALL_STATE(7382)] = 282704,
  [SMALL_STATE(7383)] = 282717,
  [SMALL_STATE(7384)] = 282728,
  [SMALL_STATE(7385)] = 282741,
  [SMALL_STATE(7386)] = 282754,
  [SMALL_STATE(7387)] = 282767,
  [SMALL_STATE(7388)] = 282780,
  [SMALL_STATE(7389)] = 282793,
  [SMALL_STATE(7390)] = 282806,
  [SMALL_STATE(7391)] = 282819,
  [SMALL_STATE(7392)] = 282832,
  [SMALL_STATE(7393)] = 282845,
  [SMALL_STATE(7394)] = 282858,
  [SMALL_STATE(7395)] = 282871,
  [SMALL_STATE(7396)] = 282882,
  [SMALL_STATE(7397)] = 282895,
  [SMALL_STATE(7398)] = 282908,
  [SMALL_STATE(7399)] = 282919,
  [SMALL_STATE(7400)] = 282932,
  [SMALL_STATE(7401)] = 282945,
  [SMALL_STATE(7402)] = 282958,
  [SMALL_STATE(7403)] = 282971,
  [SMALL_STATE(7404)] = 282984,
  [SMALL_STATE(7405)] = 282997,
  [SMALL_STATE(7406)] = 283010,
  [SMALL_STATE(7407)] = 283023,
  [SMALL_STATE(7408)] = 283036,
  [SMALL_STATE(7409)] = 283049,
  [SMALL_STATE(7410)] = 283062,
  [SMALL_STATE(7411)] = 283075,
  [SMALL_STATE(7412)] = 283088,
  [SMALL_STATE(7413)] = 283101,
  [SMALL_STATE(7414)] = 283114,
  [SMALL_STATE(7415)] = 283127,
  [SMALL_STATE(7416)] = 283140,
  [SMALL_STATE(7417)] = 283151,
  [SMALL_STATE(7418)] = 283164,
  [SMALL_STATE(7419)] = 283173,
  [SMALL_STATE(7420)] = 283186,
  [SMALL_STATE(7421)] = 283197,
  [SMALL_STATE(7422)] = 283206,
  [SMALL_STATE(7423)] = 283219,
  [SMALL_STATE(7424)] = 283232,
  [SMALL_STATE(7425)] = 283245,
  [SMALL_STATE(7426)] = 283258,
  [SMALL_STATE(7427)] = 283271,
  [SMALL_STATE(7428)] = 283282,
  [SMALL_STATE(7429)] = 283295,
  [SMALL_STATE(7430)] = 283308,
  [SMALL_STATE(7431)] = 283321,
  [SMALL_STATE(7432)] = 283334,
  [SMALL_STATE(7433)] = 283347,
  [SMALL_STATE(7434)] = 283360,
  [SMALL_STATE(7435)] = 283373,
  [SMALL_STATE(7436)] = 283386,
  [SMALL_STATE(7437)] = 283399,
  [SMALL_STATE(7438)] = 283412,
  [SMALL_STATE(7439)] = 283425,
  [SMALL_STATE(7440)] = 283434,
  [SMALL_STATE(7441)] = 283447,
  [SMALL_STATE(7442)] = 283460,
  [SMALL_STATE(7443)] = 283473,
  [SMALL_STATE(7444)] = 283486,
  [SMALL_STATE(7445)] = 283499,
  [SMALL_STATE(7446)] = 283512,
  [SMALL_STATE(7447)] = 283525,
  [SMALL_STATE(7448)] = 283534,
  [SMALL_STATE(7449)] = 283545,
  [SMALL_STATE(7450)] = 283558,
  [SMALL_STATE(7451)] = 283571,
  [SMALL_STATE(7452)] = 283584,
  [SMALL_STATE(7453)] = 283597,
  [SMALL_STATE(7454)] = 283610,
  [SMALL_STATE(7455)] = 283623,
  [SMALL_STATE(7456)] = 283636,
  [SMALL_STATE(7457)] = 283649,
  [SMALL_STATE(7458)] = 283660,
  [SMALL_STATE(7459)] = 283673,
  [SMALL_STATE(7460)] = 283686,
  [SMALL_STATE(7461)] = 283699,
  [SMALL_STATE(7462)] = 283712,
  [SMALL_STATE(7463)] = 283725,
  [SMALL_STATE(7464)] = 283738,
  [SMALL_STATE(7465)] = 283749,
  [SMALL_STATE(7466)] = 283762,
  [SMALL_STATE(7467)] = 283775,
  [SMALL_STATE(7468)] = 283788,
  [SMALL_STATE(7469)] = 283801,
  [SMALL_STATE(7470)] = 283814,
  [SMALL_STATE(7471)] = 283827,
  [SMALL_STATE(7472)] = 283840,
  [SMALL_STATE(7473)] = 283853,
  [SMALL_STATE(7474)] = 283866,
  [SMALL_STATE(7475)] = 283879,
  [SMALL_STATE(7476)] = 283892,
  [SMALL_STATE(7477)] = 283905,
  [SMALL_STATE(7478)] = 283918,
  [SMALL_STATE(7479)] = 283931,
  [SMALL_STATE(7480)] = 283944,
  [SMALL_STATE(7481)] = 283953,
  [SMALL_STATE(7482)] = 283966,
  [SMALL_STATE(7483)] = 283979,
  [SMALL_STATE(7484)] = 283992,
  [SMALL_STATE(7485)] = 284005,
  [SMALL_STATE(7486)] = 284018,
  [SMALL_STATE(7487)] = 284031,
  [SMALL_STATE(7488)] = 284044,
  [SMALL_STATE(7489)] = 284057,
  [SMALL_STATE(7490)] = 284070,
  [SMALL_STATE(7491)] = 284083,
  [SMALL_STATE(7492)] = 284096,
  [SMALL_STATE(7493)] = 284109,
  [SMALL_STATE(7494)] = 284122,
  [SMALL_STATE(7495)] = 284135,
  [SMALL_STATE(7496)] = 284148,
  [SMALL_STATE(7497)] = 284161,
  [SMALL_STATE(7498)] = 284172,
  [SMALL_STATE(7499)] = 284183,
  [SMALL_STATE(7500)] = 284196,
  [SMALL_STATE(7501)] = 284209,
  [SMALL_STATE(7502)] = 284222,
  [SMALL_STATE(7503)] = 284235,
  [SMALL_STATE(7504)] = 284248,
  [SMALL_STATE(7505)] = 284259,
  [SMALL_STATE(7506)] = 284272,
  [SMALL_STATE(7507)] = 284285,
  [SMALL_STATE(7508)] = 284298,
  [SMALL_STATE(7509)] = 284311,
  [SMALL_STATE(7510)] = 284320,
  [SMALL_STATE(7511)] = 284329,
  [SMALL_STATE(7512)] = 284342,
  [SMALL_STATE(7513)] = 284355,
  [SMALL_STATE(7514)] = 284366,
  [SMALL_STATE(7515)] = 284379,
  [SMALL_STATE(7516)] = 284390,
  [SMALL_STATE(7517)] = 284403,
  [SMALL_STATE(7518)] = 284416,
  [SMALL_STATE(7519)] = 284429,
  [SMALL_STATE(7520)] = 284440,
  [SMALL_STATE(7521)] = 284453,
  [SMALL_STATE(7522)] = 284466,
  [SMALL_STATE(7523)] = 284479,
  [SMALL_STATE(7524)] = 284492,
  [SMALL_STATE(7525)] = 284505,
  [SMALL_STATE(7526)] = 284518,
  [SMALL_STATE(7527)] = 284531,
  [SMALL_STATE(7528)] = 284544,
  [SMALL_STATE(7529)] = 284557,
  [SMALL_STATE(7530)] = 284570,
  [SMALL_STATE(7531)] = 284583,
  [SMALL_STATE(7532)] = 284594,
  [SMALL_STATE(7533)] = 284605,
  [SMALL_STATE(7534)] = 284616,
  [SMALL_STATE(7535)] = 284629,
  [SMALL_STATE(7536)] = 284642,
  [SMALL_STATE(7537)] = 284655,
  [SMALL_STATE(7538)] = 284668,
  [SMALL_STATE(7539)] = 284681,
  [SMALL_STATE(7540)] = 284694,
  [SMALL_STATE(7541)] = 284707,
  [SMALL_STATE(7542)] = 284720,
  [SMALL_STATE(7543)] = 284733,
  [SMALL_STATE(7544)] = 284746,
  [SMALL_STATE(7545)] = 284759,
  [SMALL_STATE(7546)] = 284772,
  [SMALL_STATE(7547)] = 284785,
  [SMALL_STATE(7548)] = 284798,
  [SMALL_STATE(7549)] = 284811,
  [SMALL_STATE(7550)] = 284824,
  [SMALL_STATE(7551)] = 284837,
  [SMALL_STATE(7552)] = 284850,
  [SMALL_STATE(7553)] = 284859,
  [SMALL_STATE(7554)] = 284872,
  [SMALL_STATE(7555)] = 284885,
  [SMALL_STATE(7556)] = 284898,
  [SMALL_STATE(7557)] = 284911,
  [SMALL_STATE(7558)] = 284924,
  [SMALL_STATE(7559)] = 284933,
  [SMALL_STATE(7560)] = 284946,
  [SMALL_STATE(7561)] = 284959,
  [SMALL_STATE(7562)] = 284972,
  [SMALL_STATE(7563)] = 284985,
  [SMALL_STATE(7564)] = 284998,
  [SMALL_STATE(7565)] = 285009,
  [SMALL_STATE(7566)] = 285020,
  [SMALL_STATE(7567)] = 285033,
  [SMALL_STATE(7568)] = 285046,
  [SMALL_STATE(7569)] = 285059,
  [SMALL_STATE(7570)] = 285072,
  [SMALL_STATE(7571)] = 285085,
  [SMALL_STATE(7572)] = 285098,
  [SMALL_STATE(7573)] = 285111,
  [SMALL_STATE(7574)] = 285124,
  [SMALL_STATE(7575)] = 285135,
  [SMALL_STATE(7576)] = 285148,
  [SMALL_STATE(7577)] = 285159,
  [SMALL_STATE(7578)] = 285172,
  [SMALL_STATE(7579)] = 285185,
  [SMALL_STATE(7580)] = 285198,
  [SMALL_STATE(7581)] = 285211,
  [SMALL_STATE(7582)] = 285224,
  [SMALL_STATE(7583)] = 285233,
  [SMALL_STATE(7584)] = 285246,
  [SMALL_STATE(7585)] = 285259,
  [SMALL_STATE(7586)] = 285272,
  [SMALL_STATE(7587)] = 285283,
  [SMALL_STATE(7588)] = 285296,
  [SMALL_STATE(7589)] = 285309,
  [SMALL_STATE(7590)] = 285318,
  [SMALL_STATE(7591)] = 285331,
  [SMALL_STATE(7592)] = 285344,
  [SMALL_STATE(7593)] = 285353,
  [SMALL_STATE(7594)] = 285366,
  [SMALL_STATE(7595)] = 285379,
  [SMALL_STATE(7596)] = 285392,
  [SMALL_STATE(7597)] = 285401,
  [SMALL_STATE(7598)] = 285412,
  [SMALL_STATE(7599)] = 285425,
  [SMALL_STATE(7600)] = 285438,
  [SMALL_STATE(7601)] = 285447,
  [SMALL_STATE(7602)] = 285460,
  [SMALL_STATE(7603)] = 285473,
  [SMALL_STATE(7604)] = 285486,
  [SMALL_STATE(7605)] = 285499,
  [SMALL_STATE(7606)] = 285510,
  [SMALL_STATE(7607)] = 285523,
  [SMALL_STATE(7608)] = 285532,
  [SMALL_STATE(7609)] = 285545,
  [SMALL_STATE(7610)] = 285558,
  [SMALL_STATE(7611)] = 285571,
  [SMALL_STATE(7612)] = 285584,
  [SMALL_STATE(7613)] = 285597,
  [SMALL_STATE(7614)] = 285610,
  [SMALL_STATE(7615)] = 285623,
  [SMALL_STATE(7616)] = 285636,
  [SMALL_STATE(7617)] = 285649,
  [SMALL_STATE(7618)] = 285660,
  [SMALL_STATE(7619)] = 285673,
  [SMALL_STATE(7620)] = 285686,
  [SMALL_STATE(7621)] = 285699,
  [SMALL_STATE(7622)] = 285708,
  [SMALL_STATE(7623)] = 285721,
  [SMALL_STATE(7624)] = 285734,
  [SMALL_STATE(7625)] = 285747,
  [SMALL_STATE(7626)] = 285760,
  [SMALL_STATE(7627)] = 285773,
  [SMALL_STATE(7628)] = 285786,
  [SMALL_STATE(7629)] = 285799,
  [SMALL_STATE(7630)] = 285810,
  [SMALL_STATE(7631)] = 285823,
  [SMALL_STATE(7632)] = 285836,
  [SMALL_STATE(7633)] = 285847,
  [SMALL_STATE(7634)] = 285860,
  [SMALL_STATE(7635)] = 285873,
  [SMALL_STATE(7636)] = 285886,
  [SMALL_STATE(7637)] = 285899,
  [SMALL_STATE(7638)] = 285912,
  [SMALL_STATE(7639)] = 285925,
  [SMALL_STATE(7640)] = 285936,
  [SMALL_STATE(7641)] = 285949,
  [SMALL_STATE(7642)] = 285962,
  [SMALL_STATE(7643)] = 285975,
  [SMALL_STATE(7644)] = 285988,
  [SMALL_STATE(7645)] = 286001,
  [SMALL_STATE(7646)] = 286014,
  [SMALL_STATE(7647)] = 286027,
  [SMALL_STATE(7648)] = 286040,
  [SMALL_STATE(7649)] = 286053,
  [SMALL_STATE(7650)] = 286066,
  [SMALL_STATE(7651)] = 286079,
  [SMALL_STATE(7652)] = 286092,
  [SMALL_STATE(7653)] = 286103,
  [SMALL_STATE(7654)] = 286116,
  [SMALL_STATE(7655)] = 286129,
  [SMALL_STATE(7656)] = 286142,
  [SMALL_STATE(7657)] = 286155,
  [SMALL_STATE(7658)] = 286168,
  [SMALL_STATE(7659)] = 286181,
  [SMALL_STATE(7660)] = 286194,
  [SMALL_STATE(7661)] = 286207,
  [SMALL_STATE(7662)] = 286220,
  [SMALL_STATE(7663)] = 286233,
  [SMALL_STATE(7664)] = 286246,
  [SMALL_STATE(7665)] = 286259,
  [SMALL_STATE(7666)] = 286272,
  [SMALL_STATE(7667)] = 286285,
  [SMALL_STATE(7668)] = 286298,
  [SMALL_STATE(7669)] = 286311,
  [SMALL_STATE(7670)] = 286324,
  [SMALL_STATE(7671)] = 286337,
  [SMALL_STATE(7672)] = 286350,
  [SMALL_STATE(7673)] = 286361,
  [SMALL_STATE(7674)] = 286374,
  [SMALL_STATE(7675)] = 286387,
  [SMALL_STATE(7676)] = 286400,
  [SMALL_STATE(7677)] = 286413,
  [SMALL_STATE(7678)] = 286426,
  [SMALL_STATE(7679)] = 286439,
  [SMALL_STATE(7680)] = 286452,
  [SMALL_STATE(7681)] = 286465,
  [SMALL_STATE(7682)] = 286478,
  [SMALL_STATE(7683)] = 286491,
  [SMALL_STATE(7684)] = 286504,
  [SMALL_STATE(7685)] = 286517,
  [SMALL_STATE(7686)] = 286530,
  [SMALL_STATE(7687)] = 286543,
  [SMALL_STATE(7688)] = 286556,
  [SMALL_STATE(7689)] = 286569,
  [SMALL_STATE(7690)] = 286582,
  [SMALL_STATE(7691)] = 286595,
  [SMALL_STATE(7692)] = 286606,
  [SMALL_STATE(7693)] = 286619,
  [SMALL_STATE(7694)] = 286632,
  [SMALL_STATE(7695)] = 286645,
  [SMALL_STATE(7696)] = 286658,
  [SMALL_STATE(7697)] = 286671,
  [SMALL_STATE(7698)] = 286684,
  [SMALL_STATE(7699)] = 286697,
  [SMALL_STATE(7700)] = 286710,
  [SMALL_STATE(7701)] = 286723,
  [SMALL_STATE(7702)] = 286736,
  [SMALL_STATE(7703)] = 286749,
  [SMALL_STATE(7704)] = 286762,
  [SMALL_STATE(7705)] = 286775,
  [SMALL_STATE(7706)] = 286788,
  [SMALL_STATE(7707)] = 286801,
  [SMALL_STATE(7708)] = 286814,
  [SMALL_STATE(7709)] = 286827,
  [SMALL_STATE(7710)] = 286840,
  [SMALL_STATE(7711)] = 286853,
  [SMALL_STATE(7712)] = 286866,
  [SMALL_STATE(7713)] = 286879,
  [SMALL_STATE(7714)] = 286892,
  [SMALL_STATE(7715)] = 286905,
  [SMALL_STATE(7716)] = 286918,
  [SMALL_STATE(7717)] = 286931,
  [SMALL_STATE(7718)] = 286942,
  [SMALL_STATE(7719)] = 286955,
  [SMALL_STATE(7720)] = 286968,
  [SMALL_STATE(7721)] = 286979,
  [SMALL_STATE(7722)] = 286992,
  [SMALL_STATE(7723)] = 287005,
  [SMALL_STATE(7724)] = 287018,
  [SMALL_STATE(7725)] = 287031,
  [SMALL_STATE(7726)] = 287040,
  [SMALL_STATE(7727)] = 287053,
  [SMALL_STATE(7728)] = 287066,
  [SMALL_STATE(7729)] = 287079,
  [SMALL_STATE(7730)] = 287092,
  [SMALL_STATE(7731)] = 287105,
  [SMALL_STATE(7732)] = 287118,
  [SMALL_STATE(7733)] = 287131,
  [SMALL_STATE(7734)] = 287142,
  [SMALL_STATE(7735)] = 287153,
  [SMALL_STATE(7736)] = 287166,
  [SMALL_STATE(7737)] = 287179,
  [SMALL_STATE(7738)] = 287192,
  [SMALL_STATE(7739)] = 287205,
  [SMALL_STATE(7740)] = 287216,
  [SMALL_STATE(7741)] = 287229,
  [SMALL_STATE(7742)] = 287242,
  [SMALL_STATE(7743)] = 287255,
  [SMALL_STATE(7744)] = 287266,
  [SMALL_STATE(7745)] = 287279,
  [SMALL_STATE(7746)] = 287292,
  [SMALL_STATE(7747)] = 287305,
  [SMALL_STATE(7748)] = 287318,
  [SMALL_STATE(7749)] = 287331,
  [SMALL_STATE(7750)] = 287344,
  [SMALL_STATE(7751)] = 287357,
  [SMALL_STATE(7752)] = 287370,
  [SMALL_STATE(7753)] = 287383,
  [SMALL_STATE(7754)] = 287396,
  [SMALL_STATE(7755)] = 287409,
  [SMALL_STATE(7756)] = 287422,
  [SMALL_STATE(7757)] = 287435,
  [SMALL_STATE(7758)] = 287448,
  [SMALL_STATE(7759)] = 287459,
  [SMALL_STATE(7760)] = 287472,
  [SMALL_STATE(7761)] = 287485,
  [SMALL_STATE(7762)] = 287498,
  [SMALL_STATE(7763)] = 287511,
  [SMALL_STATE(7764)] = 287524,
  [SMALL_STATE(7765)] = 287537,
  [SMALL_STATE(7766)] = 287550,
  [SMALL_STATE(7767)] = 287561,
  [SMALL_STATE(7768)] = 287574,
  [SMALL_STATE(7769)] = 287587,
  [SMALL_STATE(7770)] = 287600,
  [SMALL_STATE(7771)] = 287613,
  [SMALL_STATE(7772)] = 287626,
  [SMALL_STATE(7773)] = 287639,
  [SMALL_STATE(7774)] = 287648,
  [SMALL_STATE(7775)] = 287659,
  [SMALL_STATE(7776)] = 287670,
  [SMALL_STATE(7777)] = 287683,
  [SMALL_STATE(7778)] = 287696,
  [SMALL_STATE(7779)] = 287709,
  [SMALL_STATE(7780)] = 287722,
  [SMALL_STATE(7781)] = 287735,
  [SMALL_STATE(7782)] = 287746,
  [SMALL_STATE(7783)] = 287757,
  [SMALL_STATE(7784)] = 287770,
  [SMALL_STATE(7785)] = 287783,
  [SMALL_STATE(7786)] = 287796,
  [SMALL_STATE(7787)] = 287809,
  [SMALL_STATE(7788)] = 287820,
  [SMALL_STATE(7789)] = 287833,
  [SMALL_STATE(7790)] = 287846,
  [SMALL_STATE(7791)] = 287859,
  [SMALL_STATE(7792)] = 287872,
  [SMALL_STATE(7793)] = 287885,
  [SMALL_STATE(7794)] = 287896,
  [SMALL_STATE(7795)] = 287909,
  [SMALL_STATE(7796)] = 287920,
  [SMALL_STATE(7797)] = 287933,
  [SMALL_STATE(7798)] = 287946,
  [SMALL_STATE(7799)] = 287959,
  [SMALL_STATE(7800)] = 287972,
  [SMALL_STATE(7801)] = 287983,
  [SMALL_STATE(7802)] = 287996,
  [SMALL_STATE(7803)] = 288009,
  [SMALL_STATE(7804)] = 288020,
  [SMALL_STATE(7805)] = 288033,
  [SMALL_STATE(7806)] = 288046,
  [SMALL_STATE(7807)] = 288059,
  [SMALL_STATE(7808)] = 288072,
  [SMALL_STATE(7809)] = 288085,
  [SMALL_STATE(7810)] = 288098,
  [SMALL_STATE(7811)] = 288111,
  [SMALL_STATE(7812)] = 288124,
  [SMALL_STATE(7813)] = 288137,
  [SMALL_STATE(7814)] = 288150,
  [SMALL_STATE(7815)] = 288163,
  [SMALL_STATE(7816)] = 288174,
  [SMALL_STATE(7817)] = 288184,
  [SMALL_STATE(7818)] = 288194,
  [SMALL_STATE(7819)] = 288204,
  [SMALL_STATE(7820)] = 288214,
  [SMALL_STATE(7821)] = 288224,
  [SMALL_STATE(7822)] = 288234,
  [SMALL_STATE(7823)] = 288244,
  [SMALL_STATE(7824)] = 288254,
  [SMALL_STATE(7825)] = 288264,
  [SMALL_STATE(7826)] = 288274,
  [SMALL_STATE(7827)] = 288284,
  [SMALL_STATE(7828)] = 288294,
  [SMALL_STATE(7829)] = 288304,
  [SMALL_STATE(7830)] = 288314,
  [SMALL_STATE(7831)] = 288324,
  [SMALL_STATE(7832)] = 288334,
  [SMALL_STATE(7833)] = 288344,
  [SMALL_STATE(7834)] = 288354,
  [SMALL_STATE(7835)] = 288364,
  [SMALL_STATE(7836)] = 288374,
  [SMALL_STATE(7837)] = 288384,
  [SMALL_STATE(7838)] = 288394,
  [SMALL_STATE(7839)] = 288404,
  [SMALL_STATE(7840)] = 288414,
  [SMALL_STATE(7841)] = 288424,
  [SMALL_STATE(7842)] = 288434,
  [SMALL_STATE(7843)] = 288444,
  [SMALL_STATE(7844)] = 288454,
  [SMALL_STATE(7845)] = 288464,
  [SMALL_STATE(7846)] = 288472,
  [SMALL_STATE(7847)] = 288482,
  [SMALL_STATE(7848)] = 288492,
  [SMALL_STATE(7849)] = 288502,
  [SMALL_STATE(7850)] = 288512,
  [SMALL_STATE(7851)] = 288522,
  [SMALL_STATE(7852)] = 288532,
  [SMALL_STATE(7853)] = 288542,
  [SMALL_STATE(7854)] = 288552,
  [SMALL_STATE(7855)] = 288562,
  [SMALL_STATE(7856)] = 288572,
  [SMALL_STATE(7857)] = 288582,
  [SMALL_STATE(7858)] = 288592,
  [SMALL_STATE(7859)] = 288602,
  [SMALL_STATE(7860)] = 288612,
  [SMALL_STATE(7861)] = 288622,
  [SMALL_STATE(7862)] = 288632,
  [SMALL_STATE(7863)] = 288642,
  [SMALL_STATE(7864)] = 288652,
  [SMALL_STATE(7865)] = 288662,
  [SMALL_STATE(7866)] = 288672,
  [SMALL_STATE(7867)] = 288682,
  [SMALL_STATE(7868)] = 288692,
  [SMALL_STATE(7869)] = 288702,
  [SMALL_STATE(7870)] = 288712,
  [SMALL_STATE(7871)] = 288720,
  [SMALL_STATE(7872)] = 288730,
  [SMALL_STATE(7873)] = 288740,
  [SMALL_STATE(7874)] = 288748,
  [SMALL_STATE(7875)] = 288758,
  [SMALL_STATE(7876)] = 288768,
  [SMALL_STATE(7877)] = 288778,
  [SMALL_STATE(7878)] = 288788,
  [SMALL_STATE(7879)] = 288798,
  [SMALL_STATE(7880)] = 288808,
  [SMALL_STATE(7881)] = 288818,
  [SMALL_STATE(7882)] = 288828,
  [SMALL_STATE(7883)] = 288836,
  [SMALL_STATE(7884)] = 288846,
  [SMALL_STATE(7885)] = 288856,
  [SMALL_STATE(7886)] = 288866,
  [SMALL_STATE(7887)] = 288876,
  [SMALL_STATE(7888)] = 288886,
  [SMALL_STATE(7889)] = 288896,
  [SMALL_STATE(7890)] = 288906,
  [SMALL_STATE(7891)] = 288916,
  [SMALL_STATE(7892)] = 288926,
  [SMALL_STATE(7893)] = 288936,
  [SMALL_STATE(7894)] = 288946,
  [SMALL_STATE(7895)] = 288956,
  [SMALL_STATE(7896)] = 288966,
  [SMALL_STATE(7897)] = 288976,
  [SMALL_STATE(7898)] = 288986,
  [SMALL_STATE(7899)] = 288996,
  [SMALL_STATE(7900)] = 289006,
  [SMALL_STATE(7901)] = 289014,
  [SMALL_STATE(7902)] = 289024,
  [SMALL_STATE(7903)] = 289034,
  [SMALL_STATE(7904)] = 289042,
  [SMALL_STATE(7905)] = 289052,
  [SMALL_STATE(7906)] = 289060,
  [SMALL_STATE(7907)] = 289070,
  [SMALL_STATE(7908)] = 289078,
  [SMALL_STATE(7909)] = 289088,
  [SMALL_STATE(7910)] = 289098,
  [SMALL_STATE(7911)] = 289108,
  [SMALL_STATE(7912)] = 289116,
  [SMALL_STATE(7913)] = 289126,
  [SMALL_STATE(7914)] = 289136,
  [SMALL_STATE(7915)] = 289146,
  [SMALL_STATE(7916)] = 289156,
  [SMALL_STATE(7917)] = 289166,
  [SMALL_STATE(7918)] = 289176,
  [SMALL_STATE(7919)] = 289184,
  [SMALL_STATE(7920)] = 289194,
  [SMALL_STATE(7921)] = 289204,
  [SMALL_STATE(7922)] = 289214,
  [SMALL_STATE(7923)] = 289224,
  [SMALL_STATE(7924)] = 289234,
  [SMALL_STATE(7925)] = 289244,
  [SMALL_STATE(7926)] = 289254,
  [SMALL_STATE(7927)] = 289264,
  [SMALL_STATE(7928)] = 289274,
  [SMALL_STATE(7929)] = 289284,
  [SMALL_STATE(7930)] = 289294,
  [SMALL_STATE(7931)] = 289304,
  [SMALL_STATE(7932)] = 289314,
  [SMALL_STATE(7933)] = 289324,
  [SMALL_STATE(7934)] = 289334,
  [SMALL_STATE(7935)] = 289344,
  [SMALL_STATE(7936)] = 289354,
  [SMALL_STATE(7937)] = 289364,
  [SMALL_STATE(7938)] = 289374,
  [SMALL_STATE(7939)] = 289382,
  [SMALL_STATE(7940)] = 289392,
  [SMALL_STATE(7941)] = 289402,
  [SMALL_STATE(7942)] = 289412,
  [SMALL_STATE(7943)] = 289422,
  [SMALL_STATE(7944)] = 289432,
  [SMALL_STATE(7945)] = 289442,
  [SMALL_STATE(7946)] = 289452,
  [SMALL_STATE(7947)] = 289462,
  [SMALL_STATE(7948)] = 289472,
  [SMALL_STATE(7949)] = 289480,
  [SMALL_STATE(7950)] = 289490,
  [SMALL_STATE(7951)] = 289500,
  [SMALL_STATE(7952)] = 289510,
  [SMALL_STATE(7953)] = 289520,
  [SMALL_STATE(7954)] = 289530,
  [SMALL_STATE(7955)] = 289540,
  [SMALL_STATE(7956)] = 289550,
  [SMALL_STATE(7957)] = 289560,
  [SMALL_STATE(7958)] = 289570,
  [SMALL_STATE(7959)] = 289578,
  [SMALL_STATE(7960)] = 289588,
  [SMALL_STATE(7961)] = 289598,
  [SMALL_STATE(7962)] = 289608,
  [SMALL_STATE(7963)] = 289618,
  [SMALL_STATE(7964)] = 289628,
  [SMALL_STATE(7965)] = 289638,
  [SMALL_STATE(7966)] = 289648,
  [SMALL_STATE(7967)] = 289658,
  [SMALL_STATE(7968)] = 289668,
  [SMALL_STATE(7969)] = 289678,
  [SMALL_STATE(7970)] = 289688,
  [SMALL_STATE(7971)] = 289698,
  [SMALL_STATE(7972)] = 289708,
  [SMALL_STATE(7973)] = 289718,
  [SMALL_STATE(7974)] = 289728,
  [SMALL_STATE(7975)] = 289738,
  [SMALL_STATE(7976)] = 289748,
  [SMALL_STATE(7977)] = 289758,
  [SMALL_STATE(7978)] = 289768,
  [SMALL_STATE(7979)] = 289778,
  [SMALL_STATE(7980)] = 289786,
  [SMALL_STATE(7981)] = 289796,
  [SMALL_STATE(7982)] = 289806,
  [SMALL_STATE(7983)] = 289816,
  [SMALL_STATE(7984)] = 289826,
  [SMALL_STATE(7985)] = 289836,
  [SMALL_STATE(7986)] = 289846,
  [SMALL_STATE(7987)] = 289854,
  [SMALL_STATE(7988)] = 289864,
  [SMALL_STATE(7989)] = 289874,
  [SMALL_STATE(7990)] = 289884,
  [SMALL_STATE(7991)] = 289894,
  [SMALL_STATE(7992)] = 289902,
  [SMALL_STATE(7993)] = 289912,
  [SMALL_STATE(7994)] = 289922,
  [SMALL_STATE(7995)] = 289932,
  [SMALL_STATE(7996)] = 289942,
  [SMALL_STATE(7997)] = 289952,
  [SMALL_STATE(7998)] = 289962,
  [SMALL_STATE(7999)] = 289972,
  [SMALL_STATE(8000)] = 289982,
  [SMALL_STATE(8001)] = 289990,
  [SMALL_STATE(8002)] = 290000,
  [SMALL_STATE(8003)] = 290010,
  [SMALL_STATE(8004)] = 290018,
  [SMALL_STATE(8005)] = 290028,
  [SMALL_STATE(8006)] = 290038,
  [SMALL_STATE(8007)] = 290048,
  [SMALL_STATE(8008)] = 290058,
  [SMALL_STATE(8009)] = 290068,
  [SMALL_STATE(8010)] = 290078,
  [SMALL_STATE(8011)] = 290088,
  [SMALL_STATE(8012)] = 290098,
  [SMALL_STATE(8013)] = 290106,
  [SMALL_STATE(8014)] = 290114,
  [SMALL_STATE(8015)] = 290124,
  [SMALL_STATE(8016)] = 290134,
  [SMALL_STATE(8017)] = 290144,
  [SMALL_STATE(8018)] = 290154,
  [SMALL_STATE(8019)] = 290164,
  [SMALL_STATE(8020)] = 290174,
  [SMALL_STATE(8021)] = 290184,
  [SMALL_STATE(8022)] = 290194,
  [SMALL_STATE(8023)] = 290204,
  [SMALL_STATE(8024)] = 290214,
  [SMALL_STATE(8025)] = 290224,
  [SMALL_STATE(8026)] = 290234,
  [SMALL_STATE(8027)] = 290244,
  [SMALL_STATE(8028)] = 290252,
  [SMALL_STATE(8029)] = 290260,
  [SMALL_STATE(8030)] = 290268,
  [SMALL_STATE(8031)] = 290278,
  [SMALL_STATE(8032)] = 290286,
  [SMALL_STATE(8033)] = 290296,
  [SMALL_STATE(8034)] = 290304,
  [SMALL_STATE(8035)] = 290314,
  [SMALL_STATE(8036)] = 290324,
  [SMALL_STATE(8037)] = 290332,
  [SMALL_STATE(8038)] = 290342,
  [SMALL_STATE(8039)] = 290350,
  [SMALL_STATE(8040)] = 290360,
  [SMALL_STATE(8041)] = 290370,
  [SMALL_STATE(8042)] = 290380,
  [SMALL_STATE(8043)] = 290390,
  [SMALL_STATE(8044)] = 290400,
  [SMALL_STATE(8045)] = 290410,
  [SMALL_STATE(8046)] = 290420,
  [SMALL_STATE(8047)] = 290430,
  [SMALL_STATE(8048)] = 290440,
  [SMALL_STATE(8049)] = 290450,
  [SMALL_STATE(8050)] = 290460,
  [SMALL_STATE(8051)] = 290468,
  [SMALL_STATE(8052)] = 290478,
  [SMALL_STATE(8053)] = 290488,
  [SMALL_STATE(8054)] = 290496,
  [SMALL_STATE(8055)] = 290506,
  [SMALL_STATE(8056)] = 290516,
  [SMALL_STATE(8057)] = 290526,
  [SMALL_STATE(8058)] = 290536,
  [SMALL_STATE(8059)] = 290546,
  [SMALL_STATE(8060)] = 290556,
  [SMALL_STATE(8061)] = 290566,
  [SMALL_STATE(8062)] = 290576,
  [SMALL_STATE(8063)] = 290586,
  [SMALL_STATE(8064)] = 290596,
  [SMALL_STATE(8065)] = 290604,
  [SMALL_STATE(8066)] = 290614,
  [SMALL_STATE(8067)] = 290624,
  [SMALL_STATE(8068)] = 290632,
  [SMALL_STATE(8069)] = 290642,
  [SMALL_STATE(8070)] = 290652,
  [SMALL_STATE(8071)] = 290662,
  [SMALL_STATE(8072)] = 290672,
  [SMALL_STATE(8073)] = 290682,
  [SMALL_STATE(8074)] = 290692,
  [SMALL_STATE(8075)] = 290702,
  [SMALL_STATE(8076)] = 290712,
  [SMALL_STATE(8077)] = 290720,
  [SMALL_STATE(8078)] = 290730,
  [SMALL_STATE(8079)] = 290740,
  [SMALL_STATE(8080)] = 290750,
  [SMALL_STATE(8081)] = 290760,
  [SMALL_STATE(8082)] = 290770,
  [SMALL_STATE(8083)] = 290780,
  [SMALL_STATE(8084)] = 290790,
  [SMALL_STATE(8085)] = 290800,
  [SMALL_STATE(8086)] = 290810,
  [SMALL_STATE(8087)] = 290820,
  [SMALL_STATE(8088)] = 290830,
  [SMALL_STATE(8089)] = 290840,
  [SMALL_STATE(8090)] = 290850,
  [SMALL_STATE(8091)] = 290860,
  [SMALL_STATE(8092)] = 290868,
  [SMALL_STATE(8093)] = 290878,
  [SMALL_STATE(8094)] = 290888,
  [SMALL_STATE(8095)] = 290898,
  [SMALL_STATE(8096)] = 290908,
  [SMALL_STATE(8097)] = 290918,
  [SMALL_STATE(8098)] = 290928,
  [SMALL_STATE(8099)] = 290938,
  [SMALL_STATE(8100)] = 290948,
  [SMALL_STATE(8101)] = 290958,
  [SMALL_STATE(8102)] = 290968,
  [SMALL_STATE(8103)] = 290978,
  [SMALL_STATE(8104)] = 290988,
  [SMALL_STATE(8105)] = 290998,
  [SMALL_STATE(8106)] = 291008,
  [SMALL_STATE(8107)] = 291016,
  [SMALL_STATE(8108)] = 291026,
  [SMALL_STATE(8109)] = 291034,
  [SMALL_STATE(8110)] = 291042,
  [SMALL_STATE(8111)] = 291052,
  [SMALL_STATE(8112)] = 291062,
  [SMALL_STATE(8113)] = 291072,
  [SMALL_STATE(8114)] = 291082,
  [SMALL_STATE(8115)] = 291092,
  [SMALL_STATE(8116)] = 291102,
  [SMALL_STATE(8117)] = 291112,
  [SMALL_STATE(8118)] = 291122,
  [SMALL_STATE(8119)] = 291132,
  [SMALL_STATE(8120)] = 291142,
  [SMALL_STATE(8121)] = 291150,
  [SMALL_STATE(8122)] = 291160,
  [SMALL_STATE(8123)] = 291170,
  [SMALL_STATE(8124)] = 291180,
  [SMALL_STATE(8125)] = 291190,
  [SMALL_STATE(8126)] = 291200,
  [SMALL_STATE(8127)] = 291210,
  [SMALL_STATE(8128)] = 291220,
  [SMALL_STATE(8129)] = 291230,
  [SMALL_STATE(8130)] = 291238,
  [SMALL_STATE(8131)] = 291248,
  [SMALL_STATE(8132)] = 291258,
  [SMALL_STATE(8133)] = 291268,
  [SMALL_STATE(8134)] = 291278,
  [SMALL_STATE(8135)] = 291288,
  [SMALL_STATE(8136)] = 291298,
  [SMALL_STATE(8137)] = 291308,
  [SMALL_STATE(8138)] = 291318,
  [SMALL_STATE(8139)] = 291328,
  [SMALL_STATE(8140)] = 291338,
  [SMALL_STATE(8141)] = 291348,
  [SMALL_STATE(8142)] = 291358,
  [SMALL_STATE(8143)] = 291368,
  [SMALL_STATE(8144)] = 291378,
  [SMALL_STATE(8145)] = 291388,
  [SMALL_STATE(8146)] = 291398,
  [SMALL_STATE(8147)] = 291408,
  [SMALL_STATE(8148)] = 291418,
  [SMALL_STATE(8149)] = 291428,
  [SMALL_STATE(8150)] = 291438,
  [SMALL_STATE(8151)] = 291448,
  [SMALL_STATE(8152)] = 291458,
  [SMALL_STATE(8153)] = 291468,
  [SMALL_STATE(8154)] = 291478,
  [SMALL_STATE(8155)] = 291488,
  [SMALL_STATE(8156)] = 291498,
  [SMALL_STATE(8157)] = 291508,
  [SMALL_STATE(8158)] = 291518,
  [SMALL_STATE(8159)] = 291528,
  [SMALL_STATE(8160)] = 291538,
  [SMALL_STATE(8161)] = 291548,
  [SMALL_STATE(8162)] = 291558,
  [SMALL_STATE(8163)] = 291568,
  [SMALL_STATE(8164)] = 291578,
  [SMALL_STATE(8165)] = 291588,
  [SMALL_STATE(8166)] = 291598,
  [SMALL_STATE(8167)] = 291608,
  [SMALL_STATE(8168)] = 291618,
  [SMALL_STATE(8169)] = 291628,
  [SMALL_STATE(8170)] = 291638,
  [SMALL_STATE(8171)] = 291646,
  [SMALL_STATE(8172)] = 291656,
  [SMALL_STATE(8173)] = 291666,
  [SMALL_STATE(8174)] = 291676,
  [SMALL_STATE(8175)] = 291684,
  [SMALL_STATE(8176)] = 291694,
  [SMALL_STATE(8177)] = 291704,
  [SMALL_STATE(8178)] = 291714,
  [SMALL_STATE(8179)] = 291724,
  [SMALL_STATE(8180)] = 291734,
  [SMALL_STATE(8181)] = 291744,
  [SMALL_STATE(8182)] = 291752,
  [SMALL_STATE(8183)] = 291762,
  [SMALL_STATE(8184)] = 291772,
  [SMALL_STATE(8185)] = 291780,
  [SMALL_STATE(8186)] = 291790,
  [SMALL_STATE(8187)] = 291800,
  [SMALL_STATE(8188)] = 291810,
  [SMALL_STATE(8189)] = 291820,
  [SMALL_STATE(8190)] = 291828,
  [SMALL_STATE(8191)] = 291838,
  [SMALL_STATE(8192)] = 291848,
  [SMALL_STATE(8193)] = 291856,
  [SMALL_STATE(8194)] = 291863,
  [SMALL_STATE(8195)] = 291870,
  [SMALL_STATE(8196)] = 291877,
  [SMALL_STATE(8197)] = 291884,
  [SMALL_STATE(8198)] = 291891,
  [SMALL_STATE(8199)] = 291898,
  [SMALL_STATE(8200)] = 291905,
  [SMALL_STATE(8201)] = 291912,
  [SMALL_STATE(8202)] = 291919,
  [SMALL_STATE(8203)] = 291926,
  [SMALL_STATE(8204)] = 291933,
  [SMALL_STATE(8205)] = 291940,
  [SMALL_STATE(8206)] = 291947,
  [SMALL_STATE(8207)] = 291954,
  [SMALL_STATE(8208)] = 291961,
  [SMALL_STATE(8209)] = 291968,
  [SMALL_STATE(8210)] = 291975,
  [SMALL_STATE(8211)] = 291982,
  [SMALL_STATE(8212)] = 291989,
  [SMALL_STATE(8213)] = 291996,
  [SMALL_STATE(8214)] = 292003,
  [SMALL_STATE(8215)] = 292010,
  [SMALL_STATE(8216)] = 292017,
  [SMALL_STATE(8217)] = 292024,
  [SMALL_STATE(8218)] = 292031,
  [SMALL_STATE(8219)] = 292038,
  [SMALL_STATE(8220)] = 292045,
  [SMALL_STATE(8221)] = 292052,
  [SMALL_STATE(8222)] = 292059,
  [SMALL_STATE(8223)] = 292066,
  [SMALL_STATE(8224)] = 292073,
  [SMALL_STATE(8225)] = 292080,
  [SMALL_STATE(8226)] = 292087,
  [SMALL_STATE(8227)] = 292094,
  [SMALL_STATE(8228)] = 292101,
  [SMALL_STATE(8229)] = 292108,
  [SMALL_STATE(8230)] = 292115,
  [SMALL_STATE(8231)] = 292122,
  [SMALL_STATE(8232)] = 292129,
  [SMALL_STATE(8233)] = 292136,
  [SMALL_STATE(8234)] = 292143,
  [SMALL_STATE(8235)] = 292150,
  [SMALL_STATE(8236)] = 292157,
  [SMALL_STATE(8237)] = 292164,
  [SMALL_STATE(8238)] = 292171,
  [SMALL_STATE(8239)] = 292178,
  [SMALL_STATE(8240)] = 292185,
  [SMALL_STATE(8241)] = 292192,
  [SMALL_STATE(8242)] = 292199,
  [SMALL_STATE(8243)] = 292206,
  [SMALL_STATE(8244)] = 292213,
  [SMALL_STATE(8245)] = 292220,
  [SMALL_STATE(8246)] = 292227,
  [SMALL_STATE(8247)] = 292234,
  [SMALL_STATE(8248)] = 292241,
  [SMALL_STATE(8249)] = 292248,
  [SMALL_STATE(8250)] = 292255,
  [SMALL_STATE(8251)] = 292262,
  [SMALL_STATE(8252)] = 292269,
  [SMALL_STATE(8253)] = 292276,
  [SMALL_STATE(8254)] = 292283,
  [SMALL_STATE(8255)] = 292290,
  [SMALL_STATE(8256)] = 292297,
  [SMALL_STATE(8257)] = 292304,
  [SMALL_STATE(8258)] = 292311,
  [SMALL_STATE(8259)] = 292318,
  [SMALL_STATE(8260)] = 292325,
  [SMALL_STATE(8261)] = 292332,
  [SMALL_STATE(8262)] = 292339,
  [SMALL_STATE(8263)] = 292346,
  [SMALL_STATE(8264)] = 292353,
  [SMALL_STATE(8265)] = 292360,
  [SMALL_STATE(8266)] = 292367,
  [SMALL_STATE(8267)] = 292374,
  [SMALL_STATE(8268)] = 292381,
  [SMALL_STATE(8269)] = 292388,
  [SMALL_STATE(8270)] = 292395,
  [SMALL_STATE(8271)] = 292402,
  [SMALL_STATE(8272)] = 292409,
  [SMALL_STATE(8273)] = 292416,
  [SMALL_STATE(8274)] = 292423,
  [SMALL_STATE(8275)] = 292430,
  [SMALL_STATE(8276)] = 292437,
  [SMALL_STATE(8277)] = 292444,
  [SMALL_STATE(8278)] = 292451,
  [SMALL_STATE(8279)] = 292458,
  [SMALL_STATE(8280)] = 292465,
  [SMALL_STATE(8281)] = 292472,
  [SMALL_STATE(8282)] = 292479,
  [SMALL_STATE(8283)] = 292486,
  [SMALL_STATE(8284)] = 292493,
  [SMALL_STATE(8285)] = 292500,
  [SMALL_STATE(8286)] = 292507,
  [SMALL_STATE(8287)] = 292514,
  [SMALL_STATE(8288)] = 292521,
  [SMALL_STATE(8289)] = 292528,
  [SMALL_STATE(8290)] = 292535,
  [SMALL_STATE(8291)] = 292542,
  [SMALL_STATE(8292)] = 292549,
  [SMALL_STATE(8293)] = 292556,
  [SMALL_STATE(8294)] = 292563,
  [SMALL_STATE(8295)] = 292570,
  [SMALL_STATE(8296)] = 292577,
  [SMALL_STATE(8297)] = 292584,
  [SMALL_STATE(8298)] = 292591,
  [SMALL_STATE(8299)] = 292598,
  [SMALL_STATE(8300)] = 292605,
  [SMALL_STATE(8301)] = 292612,
  [SMALL_STATE(8302)] = 292619,
  [SMALL_STATE(8303)] = 292626,
  [SMALL_STATE(8304)] = 292633,
  [SMALL_STATE(8305)] = 292640,
  [SMALL_STATE(8306)] = 292647,
  [SMALL_STATE(8307)] = 292654,
  [SMALL_STATE(8308)] = 292661,
  [SMALL_STATE(8309)] = 292668,
  [SMALL_STATE(8310)] = 292675,
  [SMALL_STATE(8311)] = 292682,
  [SMALL_STATE(8312)] = 292689,
  [SMALL_STATE(8313)] = 292696,
  [SMALL_STATE(8314)] = 292703,
  [SMALL_STATE(8315)] = 292710,
  [SMALL_STATE(8316)] = 292717,
  [SMALL_STATE(8317)] = 292724,
  [SMALL_STATE(8318)] = 292731,
  [SMALL_STATE(8319)] = 292738,
  [SMALL_STATE(8320)] = 292745,
  [SMALL_STATE(8321)] = 292752,
  [SMALL_STATE(8322)] = 292759,
  [SMALL_STATE(8323)] = 292766,
  [SMALL_STATE(8324)] = 292773,
  [SMALL_STATE(8325)] = 292780,
  [SMALL_STATE(8326)] = 292787,
  [SMALL_STATE(8327)] = 292794,
  [SMALL_STATE(8328)] = 292801,
  [SMALL_STATE(8329)] = 292808,
  [SMALL_STATE(8330)] = 292815,
  [SMALL_STATE(8331)] = 292822,
  [SMALL_STATE(8332)] = 292829,
  [SMALL_STATE(8333)] = 292836,
  [SMALL_STATE(8334)] = 292843,
  [SMALL_STATE(8335)] = 292850,
  [SMALL_STATE(8336)] = 292857,
  [SMALL_STATE(8337)] = 292864,
  [SMALL_STATE(8338)] = 292871,
  [SMALL_STATE(8339)] = 292878,
  [SMALL_STATE(8340)] = 292885,
  [SMALL_STATE(8341)] = 292892,
  [SMALL_STATE(8342)] = 292899,
  [SMALL_STATE(8343)] = 292906,
  [SMALL_STATE(8344)] = 292913,
  [SMALL_STATE(8345)] = 292920,
  [SMALL_STATE(8346)] = 292927,
  [SMALL_STATE(8347)] = 292934,
  [SMALL_STATE(8348)] = 292941,
  [SMALL_STATE(8349)] = 292948,
  [SMALL_STATE(8350)] = 292955,
  [SMALL_STATE(8351)] = 292962,
  [SMALL_STATE(8352)] = 292969,
  [SMALL_STATE(8353)] = 292976,
  [SMALL_STATE(8354)] = 292983,
  [SMALL_STATE(8355)] = 292990,
  [SMALL_STATE(8356)] = 292997,
  [SMALL_STATE(8357)] = 293004,
  [SMALL_STATE(8358)] = 293011,
  [SMALL_STATE(8359)] = 293018,
  [SMALL_STATE(8360)] = 293025,
  [SMALL_STATE(8361)] = 293032,
  [SMALL_STATE(8362)] = 293039,
  [SMALL_STATE(8363)] = 293046,
  [SMALL_STATE(8364)] = 293053,
  [SMALL_STATE(8365)] = 293060,
  [SMALL_STATE(8366)] = 293067,
  [SMALL_STATE(8367)] = 293074,
  [SMALL_STATE(8368)] = 293081,
  [SMALL_STATE(8369)] = 293088,
  [SMALL_STATE(8370)] = 293095,
  [SMALL_STATE(8371)] = 293102,
  [SMALL_STATE(8372)] = 293109,
  [SMALL_STATE(8373)] = 293116,
  [SMALL_STATE(8374)] = 293123,
  [SMALL_STATE(8375)] = 293130,
  [SMALL_STATE(8376)] = 293137,
  [SMALL_STATE(8377)] = 293144,
  [SMALL_STATE(8378)] = 293151,
  [SMALL_STATE(8379)] = 293158,
  [SMALL_STATE(8380)] = 293165,
  [SMALL_STATE(8381)] = 293172,
  [SMALL_STATE(8382)] = 293179,
  [SMALL_STATE(8383)] = 293186,
  [SMALL_STATE(8384)] = 293193,
  [SMALL_STATE(8385)] = 293200,
  [SMALL_STATE(8386)] = 293207,
  [SMALL_STATE(8387)] = 293214,
  [SMALL_STATE(8388)] = 293221,
  [SMALL_STATE(8389)] = 293228,
  [SMALL_STATE(8390)] = 293235,
  [SMALL_STATE(8391)] = 293242,
  [SMALL_STATE(8392)] = 293249,
  [SMALL_STATE(8393)] = 293256,
  [SMALL_STATE(8394)] = 293263,
  [SMALL_STATE(8395)] = 293270,
  [SMALL_STATE(8396)] = 293277,
  [SMALL_STATE(8397)] = 293284,
  [SMALL_STATE(8398)] = 293291,
  [SMALL_STATE(8399)] = 293298,
  [SMALL_STATE(8400)] = 293305,
  [SMALL_STATE(8401)] = 293312,
  [SMALL_STATE(8402)] = 293319,
  [SMALL_STATE(8403)] = 293326,
  [SMALL_STATE(8404)] = 293333,
  [SMALL_STATE(8405)] = 293340,
  [SMALL_STATE(8406)] = 293347,
  [SMALL_STATE(8407)] = 293354,
  [SMALL_STATE(8408)] = 293361,
  [SMALL_STATE(8409)] = 293368,
  [SMALL_STATE(8410)] = 293375,
  [SMALL_STATE(8411)] = 293382,
  [SMALL_STATE(8412)] = 293389,
  [SMALL_STATE(8413)] = 293396,
  [SMALL_STATE(8414)] = 293403,
  [SMALL_STATE(8415)] = 293410,
  [SMALL_STATE(8416)] = 293417,
  [SMALL_STATE(8417)] = 293424,
  [SMALL_STATE(8418)] = 293431,
  [SMALL_STATE(8419)] = 293438,
  [SMALL_STATE(8420)] = 293445,
  [SMALL_STATE(8421)] = 293452,
  [SMALL_STATE(8422)] = 293459,
  [SMALL_STATE(8423)] = 293466,
  [SMALL_STATE(8424)] = 293473,
  [SMALL_STATE(8425)] = 293480,
  [SMALL_STATE(8426)] = 293487,
  [SMALL_STATE(8427)] = 293494,
  [SMALL_STATE(8428)] = 293501,
  [SMALL_STATE(8429)] = 293508,
  [SMALL_STATE(8430)] = 293515,
  [SMALL_STATE(8431)] = 293522,
  [SMALL_STATE(8432)] = 293529,
  [SMALL_STATE(8433)] = 293536,
  [SMALL_STATE(8434)] = 293543,
  [SMALL_STATE(8435)] = 293550,
  [SMALL_STATE(8436)] = 293557,
  [SMALL_STATE(8437)] = 293564,
  [SMALL_STATE(8438)] = 293571,
  [SMALL_STATE(8439)] = 293578,
  [SMALL_STATE(8440)] = 293585,
  [SMALL_STATE(8441)] = 293592,
  [SMALL_STATE(8442)] = 293599,
  [SMALL_STATE(8443)] = 293606,
  [SMALL_STATE(8444)] = 293613,
  [SMALL_STATE(8445)] = 293620,
  [SMALL_STATE(8446)] = 293627,
  [SMALL_STATE(8447)] = 293634,
  [SMALL_STATE(8448)] = 293641,
  [SMALL_STATE(8449)] = 293648,
  [SMALL_STATE(8450)] = 293655,
  [SMALL_STATE(8451)] = 293662,
  [SMALL_STATE(8452)] = 293669,
  [SMALL_STATE(8453)] = 293676,
  [SMALL_STATE(8454)] = 293683,
  [SMALL_STATE(8455)] = 293690,
  [SMALL_STATE(8456)] = 293697,
  [SMALL_STATE(8457)] = 293704,
  [SMALL_STATE(8458)] = 293711,
  [SMALL_STATE(8459)] = 293718,
  [SMALL_STATE(8460)] = 293725,
  [SMALL_STATE(8461)] = 293732,
  [SMALL_STATE(8462)] = 293739,
  [SMALL_STATE(8463)] = 293746,
  [SMALL_STATE(8464)] = 293753,
  [SMALL_STATE(8465)] = 293760,
  [SMALL_STATE(8466)] = 293767,
  [SMALL_STATE(8467)] = 293774,
  [SMALL_STATE(8468)] = 293781,
  [SMALL_STATE(8469)] = 293788,
  [SMALL_STATE(8470)] = 293795,
  [SMALL_STATE(8471)] = 293802,
  [SMALL_STATE(8472)] = 293809,
  [SMALL_STATE(8473)] = 293816,
  [SMALL_STATE(8474)] = 293823,
  [SMALL_STATE(8475)] = 293830,
  [SMALL_STATE(8476)] = 293837,
  [SMALL_STATE(8477)] = 293844,
  [SMALL_STATE(8478)] = 293851,
  [SMALL_STATE(8479)] = 293858,
  [SMALL_STATE(8480)] = 293865,
  [SMALL_STATE(8481)] = 293872,
  [SMALL_STATE(8482)] = 293879,
  [SMALL_STATE(8483)] = 293886,
  [SMALL_STATE(8484)] = 293893,
  [SMALL_STATE(8485)] = 293900,
  [SMALL_STATE(8486)] = 293907,
  [SMALL_STATE(8487)] = 293914,
  [SMALL_STATE(8488)] = 293921,
  [SMALL_STATE(8489)] = 293928,
  [SMALL_STATE(8490)] = 293935,
  [SMALL_STATE(8491)] = 293942,
  [SMALL_STATE(8492)] = 293949,
  [SMALL_STATE(8493)] = 293956,
  [SMALL_STATE(8494)] = 293963,
  [SMALL_STATE(8495)] = 293970,
  [SMALL_STATE(8496)] = 293977,
  [SMALL_STATE(8497)] = 293984,
  [SMALL_STATE(8498)] = 293991,
  [SMALL_STATE(8499)] = 293998,
  [SMALL_STATE(8500)] = 294005,
  [SMALL_STATE(8501)] = 294012,
  [SMALL_STATE(8502)] = 294019,
  [SMALL_STATE(8503)] = 294026,
  [SMALL_STATE(8504)] = 294033,
  [SMALL_STATE(8505)] = 294040,
  [SMALL_STATE(8506)] = 294047,
  [SMALL_STATE(8507)] = 294054,
  [SMALL_STATE(8508)] = 294061,
  [SMALL_STATE(8509)] = 294068,
  [SMALL_STATE(8510)] = 294075,
  [SMALL_STATE(8511)] = 294082,
  [SMALL_STATE(8512)] = 294089,
  [SMALL_STATE(8513)] = 294096,
  [SMALL_STATE(8514)] = 294103,
  [SMALL_STATE(8515)] = 294110,
  [SMALL_STATE(8516)] = 294117,
  [SMALL_STATE(8517)] = 294124,
  [SMALL_STATE(8518)] = 294131,
  [SMALL_STATE(8519)] = 294138,
  [SMALL_STATE(8520)] = 294145,
  [SMALL_STATE(8521)] = 294152,
  [SMALL_STATE(8522)] = 294159,
  [SMALL_STATE(8523)] = 294166,
  [SMALL_STATE(8524)] = 294173,
  [SMALL_STATE(8525)] = 294180,
  [SMALL_STATE(8526)] = 294187,
  [SMALL_STATE(8527)] = 294194,
  [SMALL_STATE(8528)] = 294201,
  [SMALL_STATE(8529)] = 294208,
  [SMALL_STATE(8530)] = 294215,
  [SMALL_STATE(8531)] = 294222,
  [SMALL_STATE(8532)] = 294229,
  [SMALL_STATE(8533)] = 294236,
  [SMALL_STATE(8534)] = 294243,
  [SMALL_STATE(8535)] = 294250,
  [SMALL_STATE(8536)] = 294257,
  [SMALL_STATE(8537)] = 294264,
  [SMALL_STATE(8538)] = 294271,
  [SMALL_STATE(8539)] = 294278,
  [SMALL_STATE(8540)] = 294285,
  [SMALL_STATE(8541)] = 294292,
  [SMALL_STATE(8542)] = 294299,
  [SMALL_STATE(8543)] = 294306,
  [SMALL_STATE(8544)] = 294313,
  [SMALL_STATE(8545)] = 294320,
  [SMALL_STATE(8546)] = 294327,
  [SMALL_STATE(8547)] = 294334,
  [SMALL_STATE(8548)] = 294341,
  [SMALL_STATE(8549)] = 294348,
  [SMALL_STATE(8550)] = 294355,
  [SMALL_STATE(8551)] = 294362,
  [SMALL_STATE(8552)] = 294369,
  [SMALL_STATE(8553)] = 294376,
  [SMALL_STATE(8554)] = 294383,
  [SMALL_STATE(8555)] = 294390,
  [SMALL_STATE(8556)] = 294397,
  [SMALL_STATE(8557)] = 294404,
  [SMALL_STATE(8558)] = 294411,
  [SMALL_STATE(8559)] = 294418,
  [SMALL_STATE(8560)] = 294425,
  [SMALL_STATE(8561)] = 294432,
  [SMALL_STATE(8562)] = 294439,
  [SMALL_STATE(8563)] = 294446,
  [SMALL_STATE(8564)] = 294453,
  [SMALL_STATE(8565)] = 294460,
  [SMALL_STATE(8566)] = 294467,
  [SMALL_STATE(8567)] = 294474,
  [SMALL_STATE(8568)] = 294481,
  [SMALL_STATE(8569)] = 294488,
  [SMALL_STATE(8570)] = 294495,
  [SMALL_STATE(8571)] = 294502,
  [SMALL_STATE(8572)] = 294509,
  [SMALL_STATE(8573)] = 294516,
  [SMALL_STATE(8574)] = 294523,
  [SMALL_STATE(8575)] = 294530,
  [SMALL_STATE(8576)] = 294537,
  [SMALL_STATE(8577)] = 294544,
  [SMALL_STATE(8578)] = 294551,
  [SMALL_STATE(8579)] = 294558,
  [SMALL_STATE(8580)] = 294565,
  [SMALL_STATE(8581)] = 294572,
  [SMALL_STATE(8582)] = 294579,
  [SMALL_STATE(8583)] = 294586,
  [SMALL_STATE(8584)] = 294593,
  [SMALL_STATE(8585)] = 294600,
  [SMALL_STATE(8586)] = 294607,
  [SMALL_STATE(8587)] = 294614,
  [SMALL_STATE(8588)] = 294621,
  [SMALL_STATE(8589)] = 294628,
  [SMALL_STATE(8590)] = 294635,
  [SMALL_STATE(8591)] = 294642,
  [SMALL_STATE(8592)] = 294649,
  [SMALL_STATE(8593)] = 294656,
  [SMALL_STATE(8594)] = 294663,
  [SMALL_STATE(8595)] = 294670,
  [SMALL_STATE(8596)] = 294677,
  [SMALL_STATE(8597)] = 294684,
  [SMALL_STATE(8598)] = 294691,
  [SMALL_STATE(8599)] = 294698,
  [SMALL_STATE(8600)] = 294705,
  [SMALL_STATE(8601)] = 294712,
  [SMALL_STATE(8602)] = 294719,
  [SMALL_STATE(8603)] = 294726,
  [SMALL_STATE(8604)] = 294733,
  [SMALL_STATE(8605)] = 294740,
  [SMALL_STATE(8606)] = 294747,
  [SMALL_STATE(8607)] = 294754,
  [SMALL_STATE(8608)] = 294761,
  [SMALL_STATE(8609)] = 294768,
  [SMALL_STATE(8610)] = 294775,
  [SMALL_STATE(8611)] = 294782,
  [SMALL_STATE(8612)] = 294789,
  [SMALL_STATE(8613)] = 294796,
  [SMALL_STATE(8614)] = 294803,
  [SMALL_STATE(8615)] = 294810,
  [SMALL_STATE(8616)] = 294817,
  [SMALL_STATE(8617)] = 294824,
  [SMALL_STATE(8618)] = 294831,
  [SMALL_STATE(8619)] = 294838,
  [SMALL_STATE(8620)] = 294845,
  [SMALL_STATE(8621)] = 294852,
  [SMALL_STATE(8622)] = 294859,
  [SMALL_STATE(8623)] = 294866,
  [SMALL_STATE(8624)] = 294873,
  [SMALL_STATE(8625)] = 294880,
  [SMALL_STATE(8626)] = 294887,
  [SMALL_STATE(8627)] = 294894,
  [SMALL_STATE(8628)] = 294901,
  [SMALL_STATE(8629)] = 294908,
  [SMALL_STATE(8630)] = 294915,
  [SMALL_STATE(8631)] = 294922,
  [SMALL_STATE(8632)] = 294929,
  [SMALL_STATE(8633)] = 294936,
  [SMALL_STATE(8634)] = 294943,
  [SMALL_STATE(8635)] = 294950,
  [SMALL_STATE(8636)] = 294957,
  [SMALL_STATE(8637)] = 294964,
  [SMALL_STATE(8638)] = 294971,
  [SMALL_STATE(8639)] = 294978,
  [SMALL_STATE(8640)] = 294985,
  [SMALL_STATE(8641)] = 294992,
  [SMALL_STATE(8642)] = 294999,
  [SMALL_STATE(8643)] = 295006,
  [SMALL_STATE(8644)] = 295013,
  [SMALL_STATE(8645)] = 295020,
  [SMALL_STATE(8646)] = 295027,
  [SMALL_STATE(8647)] = 295034,
  [SMALL_STATE(8648)] = 295041,
  [SMALL_STATE(8649)] = 295048,
  [SMALL_STATE(8650)] = 295055,
  [SMALL_STATE(8651)] = 295062,
  [SMALL_STATE(8652)] = 295069,
  [SMALL_STATE(8653)] = 295076,
  [SMALL_STATE(8654)] = 295083,
  [SMALL_STATE(8655)] = 295090,
  [SMALL_STATE(8656)] = 295097,
  [SMALL_STATE(8657)] = 295104,
  [SMALL_STATE(8658)] = 295111,
  [SMALL_STATE(8659)] = 295118,
  [SMALL_STATE(8660)] = 295125,
  [SMALL_STATE(8661)] = 295132,
  [SMALL_STATE(8662)] = 295139,
  [SMALL_STATE(8663)] = 295146,
  [SMALL_STATE(8664)] = 295153,
  [SMALL_STATE(8665)] = 295160,
  [SMALL_STATE(8666)] = 295167,
  [SMALL_STATE(8667)] = 295174,
  [SMALL_STATE(8668)] = 295181,
  [SMALL_STATE(8669)] = 295188,
  [SMALL_STATE(8670)] = 295195,
  [SMALL_STATE(8671)] = 295202,
  [SMALL_STATE(8672)] = 295209,
  [SMALL_STATE(8673)] = 295216,
  [SMALL_STATE(8674)] = 295223,
  [SMALL_STATE(8675)] = 295230,
  [SMALL_STATE(8676)] = 295237,
  [SMALL_STATE(8677)] = 295244,
  [SMALL_STATE(8678)] = 295251,
  [SMALL_STATE(8679)] = 295258,
  [SMALL_STATE(8680)] = 295265,
  [SMALL_STATE(8681)] = 295272,
  [SMALL_STATE(8682)] = 295279,
  [SMALL_STATE(8683)] = 295286,
  [SMALL_STATE(8684)] = 295293,
  [SMALL_STATE(8685)] = 295300,
  [SMALL_STATE(8686)] = 295307,
  [SMALL_STATE(8687)] = 295314,
  [SMALL_STATE(8688)] = 295321,
  [SMALL_STATE(8689)] = 295328,
  [SMALL_STATE(8690)] = 295335,
  [SMALL_STATE(8691)] = 295342,
  [SMALL_STATE(8692)] = 295349,
  [SMALL_STATE(8693)] = 295356,
  [SMALL_STATE(8694)] = 295363,
  [SMALL_STATE(8695)] = 295370,
  [SMALL_STATE(8696)] = 295377,
  [SMALL_STATE(8697)] = 295384,
  [SMALL_STATE(8698)] = 295391,
  [SMALL_STATE(8699)] = 295398,
  [SMALL_STATE(8700)] = 295405,
  [SMALL_STATE(8701)] = 295412,
  [SMALL_STATE(8702)] = 295419,
  [SMALL_STATE(8703)] = 295426,
  [SMALL_STATE(8704)] = 295433,
  [SMALL_STATE(8705)] = 295440,
  [SMALL_STATE(8706)] = 295447,
  [SMALL_STATE(8707)] = 295454,
  [SMALL_STATE(8708)] = 295461,
  [SMALL_STATE(8709)] = 295468,
  [SMALL_STATE(8710)] = 295475,
  [SMALL_STATE(8711)] = 295482,
  [SMALL_STATE(8712)] = 295489,
  [SMALL_STATE(8713)] = 295496,
  [SMALL_STATE(8714)] = 295503,
  [SMALL_STATE(8715)] = 295510,
  [SMALL_STATE(8716)] = 295517,
  [SMALL_STATE(8717)] = 295524,
  [SMALL_STATE(8718)] = 295531,
  [SMALL_STATE(8719)] = 295538,
  [SMALL_STATE(8720)] = 295545,
  [SMALL_STATE(8721)] = 295552,
  [SMALL_STATE(8722)] = 295559,
  [SMALL_STATE(8723)] = 295566,
  [SMALL_STATE(8724)] = 295573,
  [SMALL_STATE(8725)] = 295580,
  [SMALL_STATE(8726)] = 295587,
  [SMALL_STATE(8727)] = 295594,
  [SMALL_STATE(8728)] = 295601,
  [SMALL_STATE(8729)] = 295608,
  [SMALL_STATE(8730)] = 295615,
  [SMALL_STATE(8731)] = 295622,
  [SMALL_STATE(8732)] = 295629,
  [SMALL_STATE(8733)] = 295636,
  [SMALL_STATE(8734)] = 295643,
  [SMALL_STATE(8735)] = 295650,
  [SMALL_STATE(8736)] = 295657,
  [SMALL_STATE(8737)] = 295664,
  [SMALL_STATE(8738)] = 295671,
  [SMALL_STATE(8739)] = 295678,
  [SMALL_STATE(8740)] = 295685,
  [SMALL_STATE(8741)] = 295692,
  [SMALL_STATE(8742)] = 295699,
  [SMALL_STATE(8743)] = 295706,
  [SMALL_STATE(8744)] = 295713,
  [SMALL_STATE(8745)] = 295720,
  [SMALL_STATE(8746)] = 295727,
  [SMALL_STATE(8747)] = 295734,
  [SMALL_STATE(8748)] = 295741,
  [SMALL_STATE(8749)] = 295748,
  [SMALL_STATE(8750)] = 295755,
  [SMALL_STATE(8751)] = 295762,
  [SMALL_STATE(8752)] = 295769,
  [SMALL_STATE(8753)] = 295776,
  [SMALL_STATE(8754)] = 295783,
  [SMALL_STATE(8755)] = 295790,
  [SMALL_STATE(8756)] = 295797,
  [SMALL_STATE(8757)] = 295804,
  [SMALL_STATE(8758)] = 295811,
  [SMALL_STATE(8759)] = 295818,
  [SMALL_STATE(8760)] = 295825,
  [SMALL_STATE(8761)] = 295832,
  [SMALL_STATE(8762)] = 295839,
  [SMALL_STATE(8763)] = 295846,
  [SMALL_STATE(8764)] = 295853,
  [SMALL_STATE(8765)] = 295860,
  [SMALL_STATE(8766)] = 295867,
  [SMALL_STATE(8767)] = 295874,
  [SMALL_STATE(8768)] = 295881,
  [SMALL_STATE(8769)] = 295888,
  [SMALL_STATE(8770)] = 295895,
  [SMALL_STATE(8771)] = 295902,
  [SMALL_STATE(8772)] = 295909,
  [SMALL_STATE(8773)] = 295916,
  [SMALL_STATE(8774)] = 295923,
  [SMALL_STATE(8775)] = 295930,
  [SMALL_STATE(8776)] = 295937,
  [SMALL_STATE(8777)] = 295944,
  [SMALL_STATE(8778)] = 295951,
  [SMALL_STATE(8779)] = 295958,
  [SMALL_STATE(8780)] = 295965,
  [SMALL_STATE(8781)] = 295972,
  [SMALL_STATE(8782)] = 295979,
  [SMALL_STATE(8783)] = 295986,
  [SMALL_STATE(8784)] = 295993,
  [SMALL_STATE(8785)] = 296000,
  [SMALL_STATE(8786)] = 296007,
  [SMALL_STATE(8787)] = 296014,
  [SMALL_STATE(8788)] = 296021,
  [SMALL_STATE(8789)] = 296028,
  [SMALL_STATE(8790)] = 296035,
  [SMALL_STATE(8791)] = 296042,
  [SMALL_STATE(8792)] = 296049,
  [SMALL_STATE(8793)] = 296056,
  [SMALL_STATE(8794)] = 296063,
  [SMALL_STATE(8795)] = 296070,
  [SMALL_STATE(8796)] = 296077,
  [SMALL_STATE(8797)] = 296084,
  [SMALL_STATE(8798)] = 296091,
  [SMALL_STATE(8799)] = 296098,
  [SMALL_STATE(8800)] = 296105,
  [SMALL_STATE(8801)] = 296112,
  [SMALL_STATE(8802)] = 296119,
  [SMALL_STATE(8803)] = 296126,
  [SMALL_STATE(8804)] = 296133,
  [SMALL_STATE(8805)] = 296140,
  [SMALL_STATE(8806)] = 296147,
  [SMALL_STATE(8807)] = 296154,
  [SMALL_STATE(8808)] = 296161,
  [SMALL_STATE(8809)] = 296168,
  [SMALL_STATE(8810)] = 296175,
  [SMALL_STATE(8811)] = 296182,
  [SMALL_STATE(8812)] = 296189,
  [SMALL_STATE(8813)] = 296196,
  [SMALL_STATE(8814)] = 296203,
  [SMALL_STATE(8815)] = 296210,
  [SMALL_STATE(8816)] = 296217,
  [SMALL_STATE(8817)] = 296224,
  [SMALL_STATE(8818)] = 296231,
  [SMALL_STATE(8819)] = 296238,
  [SMALL_STATE(8820)] = 296245,
  [SMALL_STATE(8821)] = 296252,
  [SMALL_STATE(8822)] = 296259,
  [SMALL_STATE(8823)] = 296266,
  [SMALL_STATE(8824)] = 296273,
  [SMALL_STATE(8825)] = 296280,
  [SMALL_STATE(8826)] = 296287,
  [SMALL_STATE(8827)] = 296294,
  [SMALL_STATE(8828)] = 296301,
  [SMALL_STATE(8829)] = 296308,
  [SMALL_STATE(8830)] = 296315,
  [SMALL_STATE(8831)] = 296322,
  [SMALL_STATE(8832)] = 296329,
  [SMALL_STATE(8833)] = 296336,
  [SMALL_STATE(8834)] = 296343,
  [SMALL_STATE(8835)] = 296350,
  [SMALL_STATE(8836)] = 296357,
  [SMALL_STATE(8837)] = 296364,
  [SMALL_STATE(8838)] = 296371,
  [SMALL_STATE(8839)] = 296378,
  [SMALL_STATE(8840)] = 296385,
  [SMALL_STATE(8841)] = 296392,
  [SMALL_STATE(8842)] = 296399,
  [SMALL_STATE(8843)] = 296406,
  [SMALL_STATE(8844)] = 296413,
  [SMALL_STATE(8845)] = 296420,
  [SMALL_STATE(8846)] = 296427,
  [SMALL_STATE(8847)] = 296434,
  [SMALL_STATE(8848)] = 296441,
  [SMALL_STATE(8849)] = 296448,
  [SMALL_STATE(8850)] = 296455,
  [SMALL_STATE(8851)] = 296462,
  [SMALL_STATE(8852)] = 296469,
  [SMALL_STATE(8853)] = 296476,
  [SMALL_STATE(8854)] = 296483,
  [SMALL_STATE(8855)] = 296490,
  [SMALL_STATE(8856)] = 296497,
  [SMALL_STATE(8857)] = 296504,
  [SMALL_STATE(8858)] = 296511,
  [SMALL_STATE(8859)] = 296518,
  [SMALL_STATE(8860)] = 296525,
  [SMALL_STATE(8861)] = 296532,
  [SMALL_STATE(8862)] = 296539,
  [SMALL_STATE(8863)] = 296546,
  [SMALL_STATE(8864)] = 296553,
  [SMALL_STATE(8865)] = 296560,
  [SMALL_STATE(8866)] = 296567,
  [SMALL_STATE(8867)] = 296574,
  [SMALL_STATE(8868)] = 296581,
  [SMALL_STATE(8869)] = 296588,
  [SMALL_STATE(8870)] = 296595,
  [SMALL_STATE(8871)] = 296602,
  [SMALL_STATE(8872)] = 296609,
  [SMALL_STATE(8873)] = 296616,
  [SMALL_STATE(8874)] = 296623,
  [SMALL_STATE(8875)] = 296630,
  [SMALL_STATE(8876)] = 296637,
  [SMALL_STATE(8877)] = 296644,
  [SMALL_STATE(8878)] = 296651,
  [SMALL_STATE(8879)] = 296658,
  [SMALL_STATE(8880)] = 296665,
  [SMALL_STATE(8881)] = 296672,
  [SMALL_STATE(8882)] = 296679,
  [SMALL_STATE(8883)] = 296686,
  [SMALL_STATE(8884)] = 296693,
  [SMALL_STATE(8885)] = 296700,
  [SMALL_STATE(8886)] = 296707,
  [SMALL_STATE(8887)] = 296714,
  [SMALL_STATE(8888)] = 296721,
  [SMALL_STATE(8889)] = 296728,
  [SMALL_STATE(8890)] = 296735,
  [SMALL_STATE(8891)] = 296742,
  [SMALL_STATE(8892)] = 296749,
  [SMALL_STATE(8893)] = 296756,
  [SMALL_STATE(8894)] = 296763,
  [SMALL_STATE(8895)] = 296770,
  [SMALL_STATE(8896)] = 296777,
  [SMALL_STATE(8897)] = 296784,
  [SMALL_STATE(8898)] = 296791,
  [SMALL_STATE(8899)] = 296798,
  [SMALL_STATE(8900)] = 296805,
  [SMALL_STATE(8901)] = 296812,
  [SMALL_STATE(8902)] = 296819,
  [SMALL_STATE(8903)] = 296826,
  [SMALL_STATE(8904)] = 296833,
  [SMALL_STATE(8905)] = 296840,
  [SMALL_STATE(8906)] = 296847,
  [SMALL_STATE(8907)] = 296854,
  [SMALL_STATE(8908)] = 296861,
  [SMALL_STATE(8909)] = 296868,
  [SMALL_STATE(8910)] = 296875,
  [SMALL_STATE(8911)] = 296882,
  [SMALL_STATE(8912)] = 296889,
  [SMALL_STATE(8913)] = 296896,
  [SMALL_STATE(8914)] = 296903,
  [SMALL_STATE(8915)] = 296910,
  [SMALL_STATE(8916)] = 296917,
  [SMALL_STATE(8917)] = 296924,
  [SMALL_STATE(8918)] = 296931,
  [SMALL_STATE(8919)] = 296938,
  [SMALL_STATE(8920)] = 296945,
  [SMALL_STATE(8921)] = 296952,
  [SMALL_STATE(8922)] = 296959,
  [SMALL_STATE(8923)] = 296966,
  [SMALL_STATE(8924)] = 296973,
  [SMALL_STATE(8925)] = 296980,
  [SMALL_STATE(8926)] = 296987,
  [SMALL_STATE(8927)] = 296994,
  [SMALL_STATE(8928)] = 297001,
  [SMALL_STATE(8929)] = 297008,
  [SMALL_STATE(8930)] = 297015,
  [SMALL_STATE(8931)] = 297022,
  [SMALL_STATE(8932)] = 297029,
  [SMALL_STATE(8933)] = 297036,
  [SMALL_STATE(8934)] = 297043,
  [SMALL_STATE(8935)] = 297050,
  [SMALL_STATE(8936)] = 297057,
  [SMALL_STATE(8937)] = 297064,
  [SMALL_STATE(8938)] = 297071,
  [SMALL_STATE(8939)] = 297078,
  [SMALL_STATE(8940)] = 297085,
  [SMALL_STATE(8941)] = 297092,
  [SMALL_STATE(8942)] = 297099,
  [SMALL_STATE(8943)] = 297106,
  [SMALL_STATE(8944)] = 297113,
  [SMALL_STATE(8945)] = 297120,
  [SMALL_STATE(8946)] = 297127,
  [SMALL_STATE(8947)] = 297134,
  [SMALL_STATE(8948)] = 297141,
  [SMALL_STATE(8949)] = 297148,
  [SMALL_STATE(8950)] = 297155,
  [SMALL_STATE(8951)] = 297162,
  [SMALL_STATE(8952)] = 297169,
  [SMALL_STATE(8953)] = 297176,
  [SMALL_STATE(8954)] = 297183,
  [SMALL_STATE(8955)] = 297190,
  [SMALL_STATE(8956)] = 297197,
  [SMALL_STATE(8957)] = 297204,
  [SMALL_STATE(8958)] = 297211,
  [SMALL_STATE(8959)] = 297218,
  [SMALL_STATE(8960)] = 297225,
  [SMALL_STATE(8961)] = 297232,
  [SMALL_STATE(8962)] = 297239,
  [SMALL_STATE(8963)] = 297246,
  [SMALL_STATE(8964)] = 297253,
  [SMALL_STATE(8965)] = 297260,
  [SMALL_STATE(8966)] = 297267,
  [SMALL_STATE(8967)] = 297274,
  [SMALL_STATE(8968)] = 297281,
  [SMALL_STATE(8969)] = 297288,
  [SMALL_STATE(8970)] = 297295,
  [SMALL_STATE(8971)] = 297302,
  [SMALL_STATE(8972)] = 297309,
  [SMALL_STATE(8973)] = 297316,
  [SMALL_STATE(8974)] = 297323,
  [SMALL_STATE(8975)] = 297330,
  [SMALL_STATE(8976)] = 297337,
  [SMALL_STATE(8977)] = 297344,
  [SMALL_STATE(8978)] = 297351,
  [SMALL_STATE(8979)] = 297358,
  [SMALL_STATE(8980)] = 297365,
  [SMALL_STATE(8981)] = 297372,
  [SMALL_STATE(8982)] = 297379,
  [SMALL_STATE(8983)] = 297386,
  [SMALL_STATE(8984)] = 297393,
  [SMALL_STATE(8985)] = 297400,
  [SMALL_STATE(8986)] = 297407,
  [SMALL_STATE(8987)] = 297414,
  [SMALL_STATE(8988)] = 297421,
  [SMALL_STATE(8989)] = 297428,
  [SMALL_STATE(8990)] = 297435,
  [SMALL_STATE(8991)] = 297442,
  [SMALL_STATE(8992)] = 297449,
  [SMALL_STATE(8993)] = 297456,
  [SMALL_STATE(8994)] = 297463,
  [SMALL_STATE(8995)] = 297470,
  [SMALL_STATE(8996)] = 297477,
  [SMALL_STATE(8997)] = 297484,
  [SMALL_STATE(8998)] = 297491,
  [SMALL_STATE(8999)] = 297498,
  [SMALL_STATE(9000)] = 297505,
  [SMALL_STATE(9001)] = 297512,
  [SMALL_STATE(9002)] = 297519,
  [SMALL_STATE(9003)] = 297526,
  [SMALL_STATE(9004)] = 297533,
  [SMALL_STATE(9005)] = 297540,
  [SMALL_STATE(9006)] = 297547,
  [SMALL_STATE(9007)] = 297554,
  [SMALL_STATE(9008)] = 297561,
  [SMALL_STATE(9009)] = 297568,
  [SMALL_STATE(9010)] = 297575,
  [SMALL_STATE(9011)] = 297582,
  [SMALL_STATE(9012)] = 297589,
  [SMALL_STATE(9013)] = 297596,
  [SMALL_STATE(9014)] = 297603,
  [SMALL_STATE(9015)] = 297610,
  [SMALL_STATE(9016)] = 297617,
  [SMALL_STATE(9017)] = 297624,
  [SMALL_STATE(9018)] = 297631,
  [SMALL_STATE(9019)] = 297638,
  [SMALL_STATE(9020)] = 297645,
  [SMALL_STATE(9021)] = 297652,
  [SMALL_STATE(9022)] = 297659,
  [SMALL_STATE(9023)] = 297666,
  [SMALL_STATE(9024)] = 297673,
  [SMALL_STATE(9025)] = 297680,
  [SMALL_STATE(9026)] = 297687,
  [SMALL_STATE(9027)] = 297694,
  [SMALL_STATE(9028)] = 297701,
  [SMALL_STATE(9029)] = 297708,
  [SMALL_STATE(9030)] = 297715,
  [SMALL_STATE(9031)] = 297722,
  [SMALL_STATE(9032)] = 297729,
  [SMALL_STATE(9033)] = 297736,
  [SMALL_STATE(9034)] = 297743,
  [SMALL_STATE(9035)] = 297750,
  [SMALL_STATE(9036)] = 297757,
  [SMALL_STATE(9037)] = 297764,
  [SMALL_STATE(9038)] = 297771,
  [SMALL_STATE(9039)] = 297778,
  [SMALL_STATE(9040)] = 297785,
  [SMALL_STATE(9041)] = 297792,
  [SMALL_STATE(9042)] = 297799,
  [SMALL_STATE(9043)] = 297806,
  [SMALL_STATE(9044)] = 297813,
  [SMALL_STATE(9045)] = 297820,
  [SMALL_STATE(9046)] = 297827,
  [SMALL_STATE(9047)] = 297834,
  [SMALL_STATE(9048)] = 297841,
  [SMALL_STATE(9049)] = 297848,
  [SMALL_STATE(9050)] = 297855,
  [SMALL_STATE(9051)] = 297862,
  [SMALL_STATE(9052)] = 297869,
  [SMALL_STATE(9053)] = 297876,
  [SMALL_STATE(9054)] = 297883,
  [SMALL_STATE(9055)] = 297890,
  [SMALL_STATE(9056)] = 297897,
  [SMALL_STATE(9057)] = 297904,
  [SMALL_STATE(9058)] = 297911,
  [SMALL_STATE(9059)] = 297918,
  [SMALL_STATE(9060)] = 297925,
  [SMALL_STATE(9061)] = 297932,
  [SMALL_STATE(9062)] = 297939,
  [SMALL_STATE(9063)] = 297946,
  [SMALL_STATE(9064)] = 297953,
  [SMALL_STATE(9065)] = 297960,
  [SMALL_STATE(9066)] = 297967,
  [SMALL_STATE(9067)] = 297974,
  [SMALL_STATE(9068)] = 297981,
  [SMALL_STATE(9069)] = 297988,
  [SMALL_STATE(9070)] = 297995,
  [SMALL_STATE(9071)] = 298002,
  [SMALL_STATE(9072)] = 298009,
  [SMALL_STATE(9073)] = 298016,
  [SMALL_STATE(9074)] = 298023,
  [SMALL_STATE(9075)] = 298030,
  [SMALL_STATE(9076)] = 298037,
  [SMALL_STATE(9077)] = 298044,
  [SMALL_STATE(9078)] = 298051,
  [SMALL_STATE(9079)] = 298058,
  [SMALL_STATE(9080)] = 298065,
  [SMALL_STATE(9081)] = 298072,
  [SMALL_STATE(9082)] = 298079,
  [SMALL_STATE(9083)] = 298086,
  [SMALL_STATE(9084)] = 298093,
  [SMALL_STATE(9085)] = 298100,
  [SMALL_STATE(9086)] = 298107,
  [SMALL_STATE(9087)] = 298114,
  [SMALL_STATE(9088)] = 298121,
  [SMALL_STATE(9089)] = 298128,
  [SMALL_STATE(9090)] = 298135,
  [SMALL_STATE(9091)] = 298142,
  [SMALL_STATE(9092)] = 298149,
  [SMALL_STATE(9093)] = 298156,
  [SMALL_STATE(9094)] = 298163,
  [SMALL_STATE(9095)] = 298170,
  [SMALL_STATE(9096)] = 298177,
  [SMALL_STATE(9097)] = 298184,
  [SMALL_STATE(9098)] = 298191,
  [SMALL_STATE(9099)] = 298198,
  [SMALL_STATE(9100)] = 298205,
  [SMALL_STATE(9101)] = 298212,
  [SMALL_STATE(9102)] = 298219,
  [SMALL_STATE(9103)] = 298226,
  [SMALL_STATE(9104)] = 298233,
  [SMALL_STATE(9105)] = 298240,
  [SMALL_STATE(9106)] = 298247,
  [SMALL_STATE(9107)] = 298254,
  [SMALL_STATE(9108)] = 298261,
  [SMALL_STATE(9109)] = 298268,
  [SMALL_STATE(9110)] = 298275,
  [SMALL_STATE(9111)] = 298282,
  [SMALL_STATE(9112)] = 298289,
  [SMALL_STATE(9113)] = 298296,
  [SMALL_STATE(9114)] = 298303,
  [SMALL_STATE(9115)] = 298310,
  [SMALL_STATE(9116)] = 298317,
  [SMALL_STATE(9117)] = 298324,
  [SMALL_STATE(9118)] = 298331,
  [SMALL_STATE(9119)] = 298338,
  [SMALL_STATE(9120)] = 298345,
  [SMALL_STATE(9121)] = 298352,
  [SMALL_STATE(9122)] = 298359,
  [SMALL_STATE(9123)] = 298366,
  [SMALL_STATE(9124)] = 298373,
  [SMALL_STATE(9125)] = 298380,
  [SMALL_STATE(9126)] = 298387,
  [SMALL_STATE(9127)] = 298394,
  [SMALL_STATE(9128)] = 298401,
  [SMALL_STATE(9129)] = 298408,
  [SMALL_STATE(9130)] = 298415,
  [SMALL_STATE(9131)] = 298422,
  [SMALL_STATE(9132)] = 298429,
  [SMALL_STATE(9133)] = 298436,
  [SMALL_STATE(9134)] = 298443,
  [SMALL_STATE(9135)] = 298450,
  [SMALL_STATE(9136)] = 298457,
  [SMALL_STATE(9137)] = 298464,
  [SMALL_STATE(9138)] = 298471,
  [SMALL_STATE(9139)] = 298478,
  [SMALL_STATE(9140)] = 298485,
  [SMALL_STATE(9141)] = 298492,
  [SMALL_STATE(9142)] = 298499,
  [SMALL_STATE(9143)] = 298506,
  [SMALL_STATE(9144)] = 298513,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6850),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9137),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5987),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9135),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8085),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1375),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5625),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2606),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3217),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2618),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2265),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9030),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6788),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8131),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9015),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8130),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2932),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2173),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1003),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2714),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2568),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1830),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9007),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2195),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6407),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5465),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5503),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5433),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7463),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8125),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8999),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8117),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8997),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(994),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8996),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8995),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8994),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1207),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8993),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8992),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8991),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6991),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5299),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7497),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7211),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5344),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4243),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2194),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8850),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3961),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5484),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(950),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8046),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1621),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1206),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6851),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6687),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8820),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8816),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1204),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1617),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8018),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1615),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5405),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5691),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8807),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6841),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8536),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8307),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5893),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8535),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7857),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2545),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3215),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2266),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2574),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7710),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7846),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1392),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8369),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7886),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8606),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(995),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8483),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8484),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8520),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8077),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8272),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8305),
  [219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4613),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4266),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(951),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7853),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1151),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6815),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6702),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8976),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8977),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1155),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1395),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6852),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8206),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5955),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(499),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8207),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5925),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8744),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8176),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2578),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3399),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2267),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2558),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7776),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8163),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1479),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8833),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7848),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(649),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8975),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(992),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8265),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8249),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8202),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8178),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8344),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(949),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8168),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1161),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6842),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6742),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9022),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9023),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1160),
  [335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1455),
  [337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif, 4, 0, 79),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(242),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(512),
  [349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(280),
  [357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(445),
  [363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(687),
  [365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef, 2, 0, 10),
  [367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(597),
  [369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif, 3, 0, 79),
  [371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef, 3, 0, 10),
  [373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(596),
  [375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(806),
  [378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6852),
  [381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8206),
  [384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5955),
  [387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0),
  [389] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8207),
  [392] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8176),
  [395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(128),
  [398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1375),
  [401] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1382),
  [404] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1375),
  [407] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(659),
  [410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5625),
  [413] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(887),
  [416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(159),
  [419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2578),
  [422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3399),
  [425] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2618),
  [428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2267),
  [431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9030),
  [434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6788),
  [437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8131),
  [440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9015),
  [443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8130),
  [446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2932),
  [449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(56),
  [452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2173),
  [455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1003),
  [458] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2714),
  [461] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2558),
  [464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1830),
  [467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9007),
  [470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2195),
  [473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6407),
  [476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5465),
  [479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5503),
  [482] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5433),
  [485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7776),
  [488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8163),
  [491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1479),
  [494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8833),
  [497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7848),
  [500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(649),
  [503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8975),
  [506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(992),
  [509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8265),
  [512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8249),
  [515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8202),
  [518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8178),
  [521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8344),
  [524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1637),
  [527] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1207),
  [530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8993),
  [533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8992),
  [536] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8991),
  [539] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6991),
  [542] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(4613),
  [545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7497),
  [548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7211),
  [551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(4266),
  [554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(4243),
  [557] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2194),
  [560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8850),
  [563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3961),
  [566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5484),
  [569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(949),
  [572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(777),
  [575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8168),
  [578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1621),
  [581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1161),
  [584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6842),
  [587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6742),
  [590] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9022),
  [593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9023),
  [596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1160),
  [599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1455),
  [602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8018),
  [605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1615),
  [608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5405),
  [611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5691),
  [614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8807),
  [617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(805),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4983),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6054),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3606),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3778),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6857),
  [641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8376),
  [643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5947),
  [645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else, 2, 0, 0),
  [647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8295),
  [649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7975),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2596),
  [655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3317),
  [657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2251),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2571),
  [663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7401),
  [665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8070),
  [667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1508),
  [669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8385),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8165),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9021),
  [677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(976),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8824),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8823),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8304),
  [685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8055),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8772),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(952),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8066),
  [693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1181),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6860),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6723),
  [699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9041),
  [701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9033),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1481),
  [707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3847),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3717),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3859),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3610),
  [723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5280),
  [729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5252),
  [731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2640),
  [739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [745] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(805),
  [748] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6841),
  [751] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8536),
  [754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5893),
  [757] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8535),
  [760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7857),
  [763] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(339),
  [766] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2545),
  [769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3215),
  [772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2266),
  [775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(55),
  [778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0),
  [780] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2574),
  [783] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7710),
  [786] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7846),
  [789] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1392),
  [792] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8369),
  [795] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7886),
  [798] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(636),
  [801] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8606),
  [804] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(995),
  [807] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8483),
  [810] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8484),
  [813] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8520),
  [816] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8077),
  [819] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8272),
  [822] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(951),
  [825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7853),
  [828] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1151),
  [831] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6815),
  [834] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6702),
  [837] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8976),
  [840] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8977),
  [843] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1155),
  [846] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1395),
  [849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4885),
  [853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4188),
  [855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6291),
  [861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6285),
  [865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(804),
  [868] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6857),
  [871] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8376),
  [874] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5947),
  [877] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8295),
  [880] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7975),
  [883] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(374),
  [886] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2596),
  [889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3317),
  [892] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2251),
  [895] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(66),
  [898] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2571),
  [901] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7401),
  [904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8070),
  [907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1508),
  [910] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8385),
  [913] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8165),
  [916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(653),
  [919] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9021),
  [922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(976),
  [925] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8824),
  [928] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8823),
  [931] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8304),
  [934] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8055),
  [937] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8772),
  [940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(952),
  [943] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8066),
  [946] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1181),
  [949] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6860),
  [952] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6723),
  [955] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9041),
  [958] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9033),
  [961] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1178),
  [964] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1481),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4154),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5997),
  [971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else, 1, 0, 0),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3894),
  [983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3891),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0),
  [993] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(808),
  [996] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6850),
  [999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9137),
  [1002] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5987),
  [1005] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9135),
  [1008] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8085),
  [1011] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(128),
  [1014] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1375),
  [1017] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1382),
  [1020] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1375),
  [1023] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(659),
  [1026] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5625),
  [1029] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(887),
  [1032] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2606),
  [1035] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3217),
  [1038] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2618),
  [1041] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2265),
  [1044] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9030),
  [1047] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6788),
  [1050] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8131),
  [1053] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9015),
  [1056] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8130),
  [1059] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2932),
  [1062] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(39),
  [1065] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2173),
  [1068] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1003),
  [1071] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2714),
  [1074] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2568),
  [1077] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1830),
  [1080] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9007),
  [1083] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2195),
  [1086] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6407),
  [1089] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5465),
  [1092] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5503),
  [1095] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5433),
  [1098] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7463),
  [1101] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8125),
  [1104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1506),
  [1107] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8999),
  [1110] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8117),
  [1113] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(618),
  [1116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8997),
  [1119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(994),
  [1122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8996),
  [1125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8995),
  [1128] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8994),
  [1131] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1637),
  [1134] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1207),
  [1137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8993),
  [1140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8992),
  [1143] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8991),
  [1146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6991),
  [1149] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5299),
  [1152] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7497),
  [1155] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7211),
  [1158] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5344),
  [1161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4243),
  [1164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2194),
  [1167] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8850),
  [1170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3961),
  [1173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5484),
  [1176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(950),
  [1179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(777),
  [1182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8046),
  [1185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1621),
  [1188] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1206),
  [1191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6851),
  [1194] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6687),
  [1197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8820),
  [1200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8816),
  [1203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1204),
  [1206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1617),
  [1209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8018),
  [1212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1615),
  [1215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5405),
  [1218] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5691),
  [1221] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8807),
  [1224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 1, 0, 0),
  [1226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(884),
  [1228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 2, 0, 0),
  [1230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [1232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [1234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 2, 0, 0),
  [1236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1534),
  [1238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1841),
  [1240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8161),
  [1242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1082),
  [1244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7831),
  [1246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, 0, 0),
  [1248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3, 0, 0),
  [1250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 4, 0, 14),
  [1252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 4, 0, 14),
  [1254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, 0, 14),
  [1256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3, 0, 14),
  [1258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(884),
  [1261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0),
  [1263] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(255),
  [1266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1375),
  [1269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1375),
  [1272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1534),
  [1275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0),
  [1277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1534),
  [1280] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(159),
  [1283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2578),
  [1286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3399),
  [1289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1841),
  [1292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2714),
  [1295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9030),
  [1298] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6788),
  [1301] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8161),
  [1304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9015),
  [1307] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(56),
  [1310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2173),
  [1313] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1082),
  [1316] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1830),
  [1319] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9007),
  [1322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2195),
  [1325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6407),
  [1328] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5465),
  [1331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5503),
  [1334] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5433),
  [1337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7776),
  [1340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8163),
  [1343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7848),
  [1346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(649),
  [1349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8975),
  [1352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(992),
  [1355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8265),
  [1358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8249),
  [1361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8202),
  [1364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8178),
  [1367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8344),
  [1370] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1637),
  [1373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1207),
  [1376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8993),
  [1379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8992),
  [1382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8991),
  [1385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6991),
  [1388] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4613),
  [1391] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7497),
  [1394] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7211),
  [1397] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4266),
  [1400] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4243),
  [1403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2194),
  [1406] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8850),
  [1409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5484),
  [1412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7831),
  [1415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8168),
  [1418] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1621),
  [1421] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1161),
  [1424] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1160),
  [1427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1455),
  [1430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8018),
  [1433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1615),
  [1436] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5405),
  [1439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5691),
  [1442] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8807),
  [1445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [1447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(881),
  [1449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(881),
  [1452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(339),
  [1455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2545),
  [1458] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3215),
  [1461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(55),
  [1464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7710),
  [1467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7846),
  [1470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7886),
  [1473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(636),
  [1476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8606),
  [1479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(995),
  [1482] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8483),
  [1485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8484),
  [1488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8520),
  [1491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8077),
  [1494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8272),
  [1497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7853),
  [1500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1151),
  [1503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1155),
  [1506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1395),
  [1509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(880),
  [1512] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(374),
  [1515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2596),
  [1518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3317),
  [1521] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(66),
  [1524] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7401),
  [1527] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8070),
  [1530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8165),
  [1533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(653),
  [1536] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9021),
  [1539] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(976),
  [1542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8824),
  [1545] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8823),
  [1548] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8304),
  [1551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8055),
  [1554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8772),
  [1557] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8066),
  [1560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1181),
  [1563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1178),
  [1566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1481),
  [1569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [1571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [1573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7878),
  [1575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8620),
  [1577] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(883),
  [1580] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(418),
  [1583] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2606),
  [1586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3217),
  [1589] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(39),
  [1592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7463),
  [1595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8125),
  [1598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8117),
  [1601] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(618),
  [1604] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8997),
  [1607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(994),
  [1610] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8996),
  [1613] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8995),
  [1616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8994),
  [1619] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7878),
  [1622] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8620),
  [1625] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8046),
  [1628] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1206),
  [1631] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1204),
  [1634] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1617),
  [1637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [1639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [1641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3488),
  [1643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3394),
  [1645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [1647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7517),
  [1649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7987),
  [1651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8069),
  [1653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [1655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9031),
  [1657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(971),
  [1659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8377),
  [1661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8375),
  [1663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8381),
  [1665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7970),
  [1667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8339),
  [1669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7931),
  [1671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1179),
  [1673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1176),
  [1675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1509),
  [1677] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(879),
  [1680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(848),
  [1683] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3488),
  [1686] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3394),
  [1689] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(80),
  [1692] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7517),
  [1695] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7987),
  [1698] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8069),
  [1701] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(655),
  [1704] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9031),
  [1707] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(971),
  [1710] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8377),
  [1713] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8375),
  [1716] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8381),
  [1719] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7970),
  [1722] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8339),
  [1725] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7931),
  [1728] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1179),
  [1731] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1176),
  [1734] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1509),
  [1737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [1739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [1741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3472),
  [1743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3345),
  [1745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8073),
  [1747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8987),
  [1749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8372),
  [1751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [1753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5001),
  [1755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8831),
  [1757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [1759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [1761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1301),
  [1763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [1765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1847),
  [1767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6805),
  [1769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2591),
  [1771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6485),
  [1773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5469),
  [1775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5468),
  [1777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5467),
  [1779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [1781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [1783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8866),
  [1785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9106),
  [1787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9141),
  [1789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6975),
  [1791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4065),
  [1793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7720),
  [1795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7322),
  [1797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4146),
  [1799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4144),
  [1801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5519),
  [1803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1282),
  [1805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8143),
  [1807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1325),
  [1809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5411),
  [1811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5681),
  [1813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [1815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7423),
  [1817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4793),
  [1819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [1821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [1823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1562),
  [1825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [1827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [1829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [1831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [1833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [1835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(888),
  [1837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6807),
  [1839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6625),
  [1841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2048),
  [1843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [1845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5341),
  [1847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6495),
  [1849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5462),
  [1851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5458),
  [1853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5454),
  [1855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [1857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1144),
  [1859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8609),
  [1861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9097),
  [1863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9138),
  [1865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7010),
  [1867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3582),
  [1869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7398),
  [1871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7268),
  [1873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3719),
  [1875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3634),
  [1877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2021),
  [1879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8611),
  [1881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5553),
  [1883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3232),
  [1885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1353),
  [1887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8098),
  [1889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1335),
  [1891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5393),
  [1893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5698),
  [1895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 3, 0, 0),
  [1897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 3, 0, 0),
  [1899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 2, 0, 0),
  [1901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 2, 0, 0),
  [1903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, 0, 9),
  [1905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, 0, 9),
  [1907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8123),
  [1909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0),
  [1911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0),
  [1913] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8123),
  [1916] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_try_statement, 4, 0, 46),
  [1918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_try_statement, 4, 0, 46),
  [1920] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_try_statement, 3, 0, 9),
  [1922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_try_statement, 3, 0, 9),
  [1924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 3, 0, 160),
  [1926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 3, 0, 160),
  [1928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, 0, 51),
  [1930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, 0, 51),
  [1932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(607),
  [1934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 104),
  [1936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 104),
  [1938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, 0, 147),
  [1940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, 0, 147),
  [1942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 4, 0, 115),
  [1944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 4, 0, 115),
  [1946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_try_statement, 3, 0, 9),
  [1948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_try_statement, 3, 0, 9),
  [1950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 4, 0, 86),
  [1952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 4, 0, 86),
  [1954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 4, 0, 114),
  [1956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 4, 0, 114),
  [1958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 105),
  [1960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 105),
  [1962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 2, 0, 0),
  [1964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 3, 0, 66),
  [1966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 3, 0, 66),
  [1968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_yield_statement, 3, 0, 0),
  [1970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_yield_statement, 3, 0, 0),
  [1972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_return_statement, 3, 0, 0),
  [1974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_return_statement, 3, 0, 0),
  [1976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, 0, 132),
  [1978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, 0, 132),
  [1980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, 0, 86),
  [1982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, 0, 86),
  [1984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3, 0, 0),
  [1986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3, 0, 0),
  [1988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_finally_clause, 2, 0, 9),
  [1990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_finally_clause, 2, 0, 9),
  [1992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 146),
  [1994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 146),
  [1996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [1998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [2000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 0),
  [2002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [2004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, 0, 55),
  [2006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, 0, 55),
  [2008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 3, 0, 53),
  [2010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 3, 0, 53),
  [2012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2, 0, 0),
  [2014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2, 0, 0),
  [2016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2, 0, 0),
  [2018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [2020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2, 0, 0),
  [2022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2, 0, 0),
  [2024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [2026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [2028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 2, 0, 0),
  [2030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 2, 0, 0),
  [2032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_return_statement, 2, 0, 0),
  [2034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_return_statement, 2, 0, 0),
  [2036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_statement, 2, 0, 0),
  [2038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_statement, 2, 0, 0),
  [2040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 5, 0, 151),
  [2042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, 0, 151),
  [2044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_leave_statement, 2, 0, 0),
  [2046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_leave_statement, 2, 0, 0),
  [2048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [2050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [2052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_range_loop, 5, 0, 152),
  [2054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_range_loop, 5, 0, 152),
  [2056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 5, 0, 168),
  [2058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 5, 0, 168),
  [2060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 6, 0, 132),
  [2062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 6, 0, 132),
  [2064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, 0, 52),
  [2066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, 0, 52),
  [2068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_except_clause, 3, 0, 178),
  [2070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_except_clause, 3, 0, 178),
  [2072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3, 0, 0),
  [2074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3, 0, 0),
  [2076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, 0, 52),
  [2078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, 0, 52),
  [2080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concept_definition, 5, 0, 10),
  [2082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concept_definition, 5, 0, 10),
  [2084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1641),
  [2086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [2088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [2090] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_friend_declaration, 3, 0, 0),
  [2092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_friend_declaration, 3, 0, 0),
  [2094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 2, 0, 25),
  [2096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 2, 0, 25),
  [2098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3005),
  [2100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8433),
  [2102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5976),
  [2104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2038),
  [2106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8434),
  [2108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [2110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5942),
  [2112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8250),
  [2114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8113),
  [2116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5337),
  [2118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8406),
  [2120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2831),
  [2122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5625),
  [2124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2549),
  [2126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3301),
  [2128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5751),
  [2130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8396),
  [2132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2258),
  [2134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6473),
  [2136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5502),
  [2138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5501),
  [2140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5500),
  [2142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5497),
  [2144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7219),
  [2146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1652),
  [2148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8223),
  [2150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6739),
  [2152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9049),
  [2154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call, 3, 0, 38),
  [2156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call, 3, 0, 38),
  [2158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_linkage_specification, 3, 0, 44),
  [2160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_linkage_specification, 3, 0, 44),
  [2162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_declaration, 3, 0, 5),
  [2164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_declaration, 3, 0, 5),
  [2166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__block_item, 1, 0, 0), REDUCE(sym_statement, 1, 0, 0),
  [2169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__block_item, 1, 0, 0), REDUCE(sym_statement, 1, 0, 0),
  [2172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 2, 0, 26),
  [2174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 2, 0, 26),
  [2176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__empty_declaration, 2, 0, 0),
  [2178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__empty_declaration, 2, 0, 0),
  [2180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 2, 0, 26),
  [2182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 2, 0, 26),
  [2184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8023),
  [2187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, 0, 46),
  [2189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, 0, 46),
  [2191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_definition, 2, 0, 25),
  [2193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_definition, 2, 0, 25),
  [2195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 2, 0, 9),
  [2197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 2, 0, 9),
  [2199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_include, 3, 0, 37),
  [2201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_include, 3, 0, 37),
  [2203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_def, 3, 0, 10),
  [2205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_def, 3, 0, 10),
  [2207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 2, 0, 10),
  [2209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1911),
  [2211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 3, 0, 10),
  [2213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 3, 0, 10),
  [2215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_alias_definition, 5, 0, 162),
  [2217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_alias_definition, 5, 0, 162),
  [2219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1919),
  [2221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_instantiation, 3, 0, 5),
  [2223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_instantiation, 3, 0, 5),
  [2225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1921),
  [2227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_alias_definition, 5, 0, 161),
  [2229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_alias_definition, 5, 0, 161),
  [2231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_declaration, 3, 0, 57),
  [2233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_declaration, 3, 0, 57),
  [2235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call, 2, 0, 3),
  [2237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call, 2, 0, 3),
  [2239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_declaration, 2, 0, 26),
  [2241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_declaration, 2, 0, 26),
  [2243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 2, 0, 0),
  [2245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 2, 0, 0),
  [2247] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, 0, 60),
  [2249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, 0, 60),
  [2251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, 0, 48),
  [2253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, 0, 48),
  [2255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_declaration, 3, 0, 0),
  [2257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_declaration, 3, 0, 0),
  [2259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_friend_declaration, 2, 0, 0),
  [2261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_friend_declaration, 2, 0, 0),
  [2263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2049),
  [2265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1962),
  [2267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 3, 0, 67),
  [2269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 3, 0, 67),
  [2271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_friend_declaration, 4, 0, 0),
  [2273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_friend_declaration, 4, 0, 0),
  [2275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 69),
  [2277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 69),
  [2279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7950),
  [2282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2052),
  [2284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 76),
  [2286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 76),
  [2288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 5),
  [2290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 5),
  [2292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 3, 0, 5),
  [2294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 3, 0, 5),
  [2296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_definition, 3, 0, 76),
  [2298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_definition, 3, 0, 76),
  [2300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_def, 4, 0, 77),
  [2302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_def, 4, 0, 77),
  [2304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_function_def, 4, 0, 78),
  [2306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_function_def, 4, 0, 78),
  [2308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 4, 0, 79),
  [2310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 4, 0, 79),
  [2312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 4, 0, 80),
  [2314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, 0, 80),
  [2316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 4, 0, 10),
  [2318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, 0, 10),
  [2320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7947),
  [2322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8023),
  [2324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2078),
  [2326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 4, 0, 93),
  [2328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 4, 0, 93),
  [2330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 4, 0, 94),
  [2332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 4, 0, 94),
  [2334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 4, 0, 95),
  [2336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 4, 0, 95),
  [2338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 5, 0, 137),
  [2340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 5, 0, 137),
  [2342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_declaration, 5, 0, 163),
  [2344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_declaration, 5, 0, 163),
  [2346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7950),
  [2348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 5, 0, 136),
  [2350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 5, 0, 136),
  [2352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_instantiation, 4, 0, 58),
  [2354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_instantiation, 4, 0, 58),
  [2356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_declaration, 4, 0, 57),
  [2358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_declaration, 4, 0, 57),
  [2360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 3, 0, 10),
  [2362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 3, 0, 0),
  [2364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 3, 0, 0),
  [2366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_declaration, 4, 0, 0),
  [2368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_declaration, 4, 0, 0),
  [2370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, 0, 112),
  [2372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, 0, 112),
  [2374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1750),
  [2376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 5, 0, 129),
  [2378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 5, 0, 129),
  [2380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 3, 0, 79),
  [2382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1745),
  [2384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, 0, 117),
  [2386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, 0, 117),
  [2388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_method_clause, 3, 0, 0),
  [2390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_method_clause, 3, 0, 0),
  [2392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_method_clause, 3, 0, 0),
  [2394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_method_clause, 3, 0, 0),
  [2396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pure_virtual_clause, 3, 0, 0),
  [2398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pure_virtual_clause, 3, 0, 0),
  [2400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, 0, 79),
  [2402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, 0, 79),
  [2404] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7947),
  [2407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [2409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_assert_declaration, 5, 0, 164),
  [2411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_assert_declaration, 5, 0, 164),
  [2413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1725),
  [2415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(2253),
  [2418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [2420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0),
  [2422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(6788),
  [2425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_statement, 1, 0, 0),
  [2427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(7144),
  [2430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(8465),
  [2433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(7831),
  [2436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_assert_declaration, 7, 0, 205),
  [2438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_assert_declaration, 7, 0, 205),
  [2440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(2253),
  [2443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [2445] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(6788),
  [2448] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(7144),
  [2451] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(8465),
  [2454] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(7831),
  [2457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_declaration, 6, 0, 194),
  [2459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_declaration, 6, 0, 194),
  [2461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 4, 0, 122),
  [2463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 4, 0, 122),
  [2465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, 0, 128),
  [2467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, 0, 128),
  [2469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 6, 0, 176),
  [2471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 6, 0, 176),
  [2473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 5, 0, 175),
  [2475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 5, 0, 175),
  [2477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_function_def, 5, 0, 127),
  [2479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_function_def, 5, 0, 127),
  [2481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, 0, 79),
  [2483] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(2253),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [2488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(6788),
  [2491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(7144),
  [2494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(8465),
  [2497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(7831),
  [2500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, 0, 170),
  [2502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, 0, 170),
  [2504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 4, 0, 126),
  [2506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 4, 0, 126),
  [2508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 4, 0, 45),
  [2510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 4, 0, 45),
  [2512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1378),
  [2514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [2516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6802),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [2520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7089),
  [2522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1162),
  [2524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8809),
  [2526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9100),
  [2528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9139),
  [2530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6992),
  [2532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2940),
  [2534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7781),
  [2536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7238),
  [2538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2628),
  [2540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2627),
  [2542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8465),
  [2544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1388),
  [2546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8141),
  [2548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1593),
  [2550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5391),
  [2552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5695),
  [2554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [2556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(664),
  [2558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1855),
  [2560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1373),
  [2562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [2564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6801),
  [2566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1164),
  [2568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3046),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7519),
  [2572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7258),
  [2574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [2576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8132),
  [2578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1513),
  [2580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5388),
  [2582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [2584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2253),
  [2586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0),
  [2588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0),
  [2590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7144),
  [2592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3005),
  [2595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8433),
  [2598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5976),
  [2601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0),
  [2603] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8434),
  [2606] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8113),
  [2609] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5337),
  [2612] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8406),
  [2615] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2831),
  [2618] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5625),
  [2621] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5625),
  [2624] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2549),
  [2627] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3301),
  [2630] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2618),
  [2633] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2714),
  [2636] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9030),
  [2639] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5751),
  [2642] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8073),
  [2645] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9015),
  [2648] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8130),
  [2651] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2173),
  [2654] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8396),
  [2657] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1830),
  [2660] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9007),
  [2663] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2258),
  [2666] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6473),
  [2669] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5502),
  [2672] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5501),
  [2675] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5500),
  [2678] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2194),
  [2681] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8850),
  [2684] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3961),
  [2687] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5497),
  [2690] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7219),
  [2693] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(777),
  [2696] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1652),
  [2699] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8223),
  [2702] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6739),
  [2705] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9049),
  [2708] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8807),
  [2711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1642),
  [2713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [2715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [2717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1458),
  [2719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [2721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6803),
  [2723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2157),
  [2725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5150),
  [2727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6380),
  [2729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5461),
  [2731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5460),
  [2733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5459),
  [2735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [2737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [2739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8844),
  [2741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9103),
  [2743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9140),
  [2745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6985),
  [2747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5160),
  [2749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7632),
  [2751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7122),
  [2753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5174),
  [2755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5178),
  [2757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2598),
  [2759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8868),
  [2761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5466),
  [2763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [2765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1340),
  [2767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8142),
  [2769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1338),
  [2771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5410),
  [2773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5693),
  [2775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6796),
  [2777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2264),
  [2779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [2781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [2783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [2785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [2787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4449),
  [2789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2304),
  [2791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [2793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7163),
  [2795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [2797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [2799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2284),
  [2801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1347),
  [2803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [2805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6781),
  [2807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1184),
  [2809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3517),
  [2811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7787),
  [2813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7103),
  [2815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1344),
  [2817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8183),
  [2819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1345),
  [2821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [2823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3876),
  [2825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [2827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [2829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [2831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2951),
  [2833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4106),
  [2835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3015),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2837),
  [2839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4510),
  [2841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2299),
  [2843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2301),
  [2845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2293),
  [2847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2289),
  [2849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7384),
  [2851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1451),
  [2853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8226),
  [2855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8121),
  [2857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8806),
  [2859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7861),
  [2861] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2264),
  [2864] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(255),
  [2867] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1375),
  [2870] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1375),
  [2873] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1534),
  [2876] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(339),
  [2879] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6788),
  [2882] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8161),
  [2885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(55),
  [2888] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1082),
  [2891] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7144),
  [2894] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7710),
  [2897] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7846),
  [2900] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1392),
  [2903] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8369),
  [2906] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7886),
  [2909] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(636),
  [2912] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8606),
  [2915] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(995),
  [2918] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8483),
  [2921] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8484),
  [2924] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8520),
  [2927] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8077),
  [2930] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8272),
  [2933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1637),
  [2936] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1207),
  [2939] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8993),
  [2942] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8992),
  [2945] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8991),
  [2948] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6991),
  [2951] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(4613),
  [2954] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7497),
  [2957] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7211),
  [2960] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(4266),
  [2963] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(4243),
  [2966] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8465),
  [2969] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7831),
  [2972] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7853),
  [2975] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1621),
  [2978] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1151),
  [2981] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1155),
  [2984] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1395),
  [2987] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8018),
  [2990] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1615),
  [2993] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(5405),
  [2996] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(5691),
  [2999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2295),
  [3001] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2289),
  [3004] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(39),
  [3007] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7384),
  [3010] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8125),
  [3013] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1451),
  [3016] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8226),
  [3019] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8121),
  [3022] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(618),
  [3025] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8806),
  [3028] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(994),
  [3031] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8996),
  [3034] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8995),
  [3037] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8994),
  [3040] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7861),
  [3043] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8046),
  [3046] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1206),
  [3049] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1204),
  [3052] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1617),
  [3055] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2293),
  [3058] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(159),
  [3061] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(56),
  [3064] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7776),
  [3067] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8163),
  [3070] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1479),
  [3073] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8833),
  [3076] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7848),
  [3079] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(649),
  [3082] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8975),
  [3085] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(992),
  [3088] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8265),
  [3091] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8249),
  [3094] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8202),
  [3097] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8178),
  [3100] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8344),
  [3103] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8168),
  [3106] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1161),
  [3109] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1160),
  [3112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1455),
  [3115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2295),
  [3118] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(848),
  [3121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(80),
  [3124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7517),
  [3127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7987),
  [3130] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8069),
  [3133] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(655),
  [3136] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9031),
  [3139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(971),
  [3142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8377),
  [3145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8375),
  [3148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8381),
  [3151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7970),
  [3154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8339),
  [3157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7931),
  [3160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1179),
  [3163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1176),
  [3166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1509),
  [3169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2260),
  [3171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4511),
  [3173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4253),
  [3175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4275),
  [3177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8605),
  [3179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2323),
  [3181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1271),
  [3183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [3185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6778),
  [3187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [3189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7251),
  [3191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1258),
  [3193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8922),
  [3195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9115),
  [3197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9144),
  [3199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6978),
  [3201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3831),
  [3203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7800),
  [3205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7157),
  [3207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3860),
  [3209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3865),
  [3211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1519),
  [3213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8164),
  [3215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1516),
  [3217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5414),
  [3219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5694),
  [3221] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2299),
  [3224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(374),
  [3227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(66),
  [3230] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7401),
  [3233] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8070),
  [3236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1508),
  [3239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8385),
  [3242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8165),
  [3245] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(653),
  [3248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9021),
  [3251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(976),
  [3254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8824),
  [3257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8823),
  [3260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8304),
  [3263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8055),
  [3266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8772),
  [3269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8066),
  [3272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1181),
  [3275] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1178),
  [3278] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1481),
  [3281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2368),
  [3283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1418),
  [3285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [3287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6798),
  [3289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [3291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7141),
  [3293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [3295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8904),
  [3297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9112),
  [3299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9143),
  [3301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6974),
  [3303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3755),
  [3305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7815),
  [3307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7191),
  [3309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3926),
  [3311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3920),
  [3313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1620),
  [3315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8152),
  [3317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1626),
  [3319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5415),
  [3321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5700),
  [3323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2273),
  [3325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [3327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [3329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [3331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1583),
  [3333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [3335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6800),
  [3337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1193),
  [3339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1489),
  [3341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1482),
  [3343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2301),
  [3346] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(418),
  [3349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7463),
  [3352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1506),
  [3355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8999),
  [3358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8117),
  [3361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8997),
  [3364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7878),
  [3367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8620),
  [3370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1643),
  [3372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5339),
  [3374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8294),
  [3376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5954),
  [3378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8221),
  [3380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8054),
  [3382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2583),
  [3384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3389),
  [3386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [3388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7311),
  [3390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1657),
  [3392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6729),
  [3394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9032),
  [3396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3188),
  [3398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5157),
  [3400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3546),
  [3402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [3404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__top_level_item, 1, 0, 0), REDUCE(sym__top_level_statement, 1, 0, 0),
  [3407] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__top_level_item, 1, 0, 0), REDUCE(sym__top_level_statement, 1, 0, 0),
  [3410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4682),
  [3412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8294),
  [3415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5954),
  [3418] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8221),
  [3421] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8054),
  [3424] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2583),
  [3427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3389),
  [3430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0),
  [3432] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7311),
  [3435] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1657),
  [3438] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6729),
  [3441] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9032),
  [3444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3495),
  [3446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5153),
  [3448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2473),
  [3450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4619),
  [3452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2300),
  [3454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [3456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7087),
  [3458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [3460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3035),
  [3462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4764),
  [3464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8482),
  [3466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5962),
  [3468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else_in_field_declaration_list, 2, 0, 0),
  [3470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8225),
  [3472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7890),
  [3474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2556),
  [3476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3284),
  [3478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7149),
  [3480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1653),
  [3482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6709),
  [3484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9057),
  [3486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [3488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2483),
  [3490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [3492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3170),
  [3494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3181),
  [3496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4901),
  [3498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [3500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_expression_statement, 2, 0, 0),
  [3502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_expression_statement, 2, 0, 0),
  [3504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3027),
  [3506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8482),
  [3509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5962),
  [3512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8225),
  [3515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7890),
  [3518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2556),
  [3521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3284),
  [3524] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7149),
  [3527] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1653),
  [3530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6709),
  [3533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9057),
  [3536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3165),
  [3538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4334),
  [3540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4343),
  [3542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else_in_field_declaration_list, 1, 0, 0),
  [3544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2797),
  [3546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3563),
  [3548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3563),
  [3550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1840),
  [3552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6810),
  [3554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2507),
  [3556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2638),
  [3558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6468),
  [3560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5536),
  [3562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5542),
  [3564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5543),
  [3566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5444),
  [3568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3330),
  [3570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8684),
  [3572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6329),
  [3574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6329),
  [3576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6265),
  [3578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8490),
  [3580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1319),
  [3582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [3584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6791),
  [3586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [3588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [3590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4482),
  [3592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7793),
  [3594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7343),
  [3596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1381),
  [3598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8134),
  [3600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1385),
  [3602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5395),
  [3604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5687),
  [3606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2403),
  [3608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5744),
  [3610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7257),
  [3612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1649),
  [3614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9026),
  [3616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5754),
  [3618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9067),
  [3620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9058),
  [3622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9045),
  [3624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9042),
  [3626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7276),
  [3628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1660),
  [3630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9036),
  [3632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9061),
  [3634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9050),
  [3636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7326),
  [3638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1655),
  [3640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8649),
  [3642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7169),
  [3644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1656),
  [3646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9053),
  [3648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_declaration, 4, 0, 0),
  [3650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_declaration, 4, 0, 0),
  [3652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_declaration, 3, 0, 0),
  [3654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_declaration, 3, 0, 0),
  [3656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2296),
  [3658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1314),
  [3660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [3662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6775),
  [3664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [3666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5012),
  [3668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7795),
  [3670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7107),
  [3672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1400),
  [3674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8180),
  [3676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1398),
  [3678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2359),
  [3680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1568),
  [3682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [3684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6808),
  [3686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1191),
  [3688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1571),
  [3690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1572),
  [3692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5396),
  [3694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2344),
  [3696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1611),
  [3698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [3700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6795),
  [3702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1197),
  [3704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1616),
  [3706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1619),
  [3708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2328),
  [3710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1628),
  [3712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [3714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6804),
  [3716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [3718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7220),
  [3720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [3722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8886),
  [3724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9109),
  [3726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9142),
  [3728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6971),
  [3730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5164),
  [3732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7782),
  [3734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7271),
  [3736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5255),
  [3738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5228),
  [3740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [3742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8146),
  [3744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1565),
  [3746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5413),
  [3748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5696),
  [3750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2365),
  [3752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [3754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7214),
  [3756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 1),
  [3758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [3760] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0),
  [3764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 1),
  [3766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [3768] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0),
  [3771] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0),
  [3774] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(564),
  [3777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6881),
  [3779] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1),
  [3782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_name, 1, 0, 1),
  [3784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2245),
  [3786] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0),
  [3790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [3792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [3794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [3796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_pack_expansion, 2, 0, 28),
  [3798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [3800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_pack_expansion, 2, 0, 28),
  [3802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [3804] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declaration_modifiers, 1, 0, 0), REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [3807] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declaration_modifiers, 1, 0, 0), REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [3810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [3812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [3814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_modifiers, 1, 0, 0),
  [3816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_modifiers, 1, 0, 0),
  [3818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [3820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(639),
  [3822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(626),
  [3824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7899),
  [3826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [3828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(631),
  [3830] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7899),
  [3833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [3835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2108),
  [3837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [3839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6757),
  [3841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8843),
  [3843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [3845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [3847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6549),
  [3849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [3851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1846),
  [3853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3660),
  [3855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [3857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(822),
  [3859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3808),
  [3861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2303),
  [3863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [3865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [3867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6480),
  [3869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [3871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [3873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3727),
  [3875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [3877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [3879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2377),
  [3881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [3883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2414),
  [3885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [3887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [3889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6185),
  [3891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(617),
  [3893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [3895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6435),
  [3897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [3899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3650),
  [3901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [3903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [3905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6441),
  [3907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [3909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6161),
  [3911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [3913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6504),
  [3915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [3917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [3919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6160),
  [3921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [3923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6579),
  [3925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [3927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3558),
  [3929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [3931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6698),
  [3933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [3935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6150),
  [3937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [3939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(831),
  [3941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3506),
  [3943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [3945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(837),
  [3947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6510),
  [3949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [3951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6533),
  [3953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2733),
  [3955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4527),
  [3957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [3959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [3961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5169),
  [3963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5169),
  [3965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5949),
  [3967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(814),
  [3969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(645),
  [3971] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(524),
  [3974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1089),
  [3976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7168),
  [3978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8159),
  [3980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 4, 3, 0),
  [3982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 4, 3, 0),
  [3984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 4, 2, 0),
  [3986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 4, 2, 0),
  [3988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 2, 0, 0),
  [3990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 2, 0, 0),
  [3992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 3, 2, 0),
  [3994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 3, 2, 0),
  [3996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 4, 1, 0),
  [3998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 4, 1, 0),
  [4000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35),
  [4002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_identifier, 2, 0, 34),
  [4004] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_qualified_identifier, 2, 0, 34), REDUCE(sym_qualified_type_identifier, 2, 0, 35),
  [4007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35),
  [4009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34),
  [4011] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34), REDUCE(sym_qualified_type_identifier, 2, 0, 35),
  [4014] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34), SHIFT(548),
  [4017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 3, 1, 0),
  [4019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 3, 1, 0),
  [4021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 3, 3, 0),
  [4023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 3, 3, 0),
  [4025] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(2253),
  [4028] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(255),
  [4031] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1375),
  [4034] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1375),
  [4037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1534),
  [4040] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(3064),
  [4043] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(6788),
  [4046] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1300),
  [4049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0),
  [4051] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1082),
  [4054] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(7144),
  [4057] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1637),
  [4060] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1207),
  [4063] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(8993),
  [4066] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(8992),
  [4069] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(8991),
  [4072] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(6991),
  [4075] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(4613),
  [4078] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(7497),
  [4081] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(7211),
  [4084] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(4266),
  [4087] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(4243),
  [4090] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(8465),
  [4093] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(6806),
  [4096] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(7831),
  [4099] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1621),
  [4102] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(8018),
  [4105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1615),
  [4108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(5405),
  [4111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(5691),
  [4114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3064),
  [4116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [4118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6272),
  [4120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6806),
  [4122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6035),
  [4124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2257),
  [4126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8631),
  [4128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2693),
  [4130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [4132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3745),
  [4134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4145),
  [4136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2713),
  [4138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3657),
  [4140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3946),
  [4142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_type, 2, 0, 16),
  [4144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_function, 2, 0, 17),
  [4146] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_template_type, 2, 0, 16), REDUCE(sym_template_function, 2, 0, 17),
  [4149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_type, 2, 0, 16),
  [4151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_function, 2, 0, 17),
  [4153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_template_type, 2, 0, 16), REDUCE(sym_template_function, 2, 0, 17),
  [4156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8349),
  [4158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5307),
  [4160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3996),
  [4162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8261),
  [4164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4120),
  [4166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5216),
  [4168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4121),
  [4170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6067),
  [4172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8936),
  [4174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3703),
  [4176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4143),
  [4178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4161),
  [4180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4907),
  [4182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4039),
  [4184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3652),
  [4186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [4188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8687),
  [4190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5295),
  [4192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [4194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8867),
  [4196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3912),
  [4198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4942),
  [4200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4033),
  [4202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3587),
  [4204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5235),
  [4206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6250),
  [4208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8582),
  [4210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4008),
  [4212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2662),
  [4214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4030),
  [4216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4116),
  [4218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3913),
  [4220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5217),
  [4222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5270),
  [4224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3698),
  [4226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3986),
  [4228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4156),
  [4230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2730),
  [4232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4151),
  [4234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3601),
  [4236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5218),
  [4238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3931),
  [4240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5253),
  [4242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2710),
  [4244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2564),
  [4246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [4248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4311),
  [4250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6252),
  [4252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6252),
  [4254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6858),
  [4256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [4258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2842),
  [4260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [4262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5948),
  [4264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5223),
  [4266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1560),
  [4268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34), SHIFT(575),
  [4271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3907),
  [4273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1526),
  [4275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3623),
  [4277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1463),
  [4279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3910),
  [4281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1515),
  [4283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4149),
  [4285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1555),
  [4287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5324),
  [4289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1545),
  [4291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2982),
  [4293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1493),
  [4295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4466),
  [4297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1501),
  [4299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [4301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1433),
  [4303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1303),
  [4305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [4307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [4309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [4311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8646),
  [4313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [4315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5012),
  [4317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1168),
  [4319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8642),
  [4321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [4323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8640),
  [4325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1140),
  [4327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8648),
  [4329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8390),
  [4331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [4333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8392),
  [4335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [4337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [4339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [4341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [4343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [4345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8120),
  [4347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 2, 0, 0),
  [4349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 2, 0, 0),
  [4351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [4353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [4355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [4357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [4359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [4361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2294),
  [4363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6945),
  [4365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [4367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [4369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3762),
  [4371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [4373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [4375] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8747),
  [4378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [4380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [4382] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8763),
  [4385] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8788),
  [4388] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8795),
  [4391] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8874),
  [4394] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(9006),
  [4397] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8917),
  [4400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [4402] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8751),
  [4405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [4407] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(9089),
  [4410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(9085),
  [4413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [4415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2163),
  [4417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [4419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [4421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [4423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [4425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [4427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3842),
  [4429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [4431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [4433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3941),
  [4435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [4437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [4439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [4441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [4443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [4445] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(9083),
  [4448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [4450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [4452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [4454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [4456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [4458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [4460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [4462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [4464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [4466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [4468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2648),
  [4470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [4472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [4474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [4476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [4478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [4480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1580),
  [4482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1443),
  [4484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 1, 187),
  [4486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [4488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [4490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [4492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1405),
  [4494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1440),
  [4496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1367),
  [4498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1581),
  [4500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1268),
  [4502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 106),
  [4504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1411),
  [4506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [4508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1438),
  [4510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 150),
  [4512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [4514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_default_capture, 1, 0, 0),
  [4516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1608),
  [4518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [4520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 79),
  [4522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1539),
  [4524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1613),
  [4526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1522),
  [4528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 2, 1, 106),
  [4530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1358),
  [4532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 2, 1, 0),
  [4534] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8277),
  [4537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1285),
  [4539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [4541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [4543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [4545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [4547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8909),
  [4549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [4551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3665),
  [4553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8698),
  [4555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8629),
  [4557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [4559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6499),
  [4561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3603),
  [4563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9079),
  [4565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [4567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [4569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6434),
  [4571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6047),
  [4573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8697),
  [4575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [4577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8911),
  [4579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6543),
  [4581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6731),
  [4583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [4585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [4587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8821),
  [4589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [4591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6498),
  [4593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [4595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6493),
  [4597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [4599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8662),
  [4601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8236),
  [4603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8370),
  [4605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [4607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8623),
  [4609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [4611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [4613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8872),
  [4615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [4617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [4619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6578),
  [4621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9066),
  [4623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [4625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6531),
  [4627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8879),
  [4629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8851),
  [4631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [4633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8764),
  [4635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8718),
  [4637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8446),
  [4639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [4641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6606),
  [4643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [4645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8891),
  [4647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [4649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [4651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6703),
  [4653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [4655] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(9000),
  [4658] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(9004),
  [4661] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(9005),
  [4664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [4666] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(9051),
  [4669] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(9060),
  [4672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [4674] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(9081),
  [4677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [4679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [4681] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8733),
  [4684] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8728),
  [4687] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8706),
  [4690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8695),
  [4693] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8608),
  [4696] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(9039),
  [4699] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8529),
  [4702] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8403),
  [4705] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8515),
  [4708] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8486),
  [4711] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8485),
  [4714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [4716] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8530),
  [4719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3648),
  [4721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [4723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3561),
  [4725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6152),
  [4727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8473),
  [4730] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8469),
  [4733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3604),
  [4735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6162),
  [4737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3556),
  [4739] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8442),
  [4742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8419),
  [4745] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8253),
  [4748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8383),
  [4751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8926),
  [4753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [4755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6148),
  [4757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6151),
  [4759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [4761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [4763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [4765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [4767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [4769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [4771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [4773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2270),
  [4775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [4777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [4779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2281),
  [4781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [4783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [4785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [4787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [4789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2261),
  [4791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [4793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [4795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [4797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [4799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [4801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [4803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [4805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [4807] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(575),
  [4810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0),
  [4812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [4814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7129),
  [4816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8139),
  [4818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [4820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [4822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [4824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [4826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [4828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [4830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [4832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [4834] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(528),
  [4837] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(508),
  [4840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [4842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1105),
  [4844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [4846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7180),
  [4848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8155),
  [4850] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(555),
  [4853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2442),
  [4855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6816),
  [4857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [4859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [4861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [4863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [4865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2375),
  [4867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5565),
  [4869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5570),
  [4871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5453),
  [4873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5532),
  [4875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5533),
  [4877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5537),
  [4879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5576),
  [4881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5551),
  [4883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5544),
  [4885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5480),
  [4887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5482),
  [4889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5499),
  [4891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5464),
  [4893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5463),
  [4895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5513),
  [4897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5450),
  [4899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5492),
  [4901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5516),
  [4903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5481),
  [4905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5483),
  [4907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5488),
  [4909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 3, 0, 73),
  [4911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 3, 0, 73),
  [4913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint_conjunction, 3, 0, 54),
  [4915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_conjunction, 3, 0, 54),
  [4917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 3, 0, 74),
  [4919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 3, 0, 74),
  [4921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__requirement_clause_constraint, 3, 0, 0),
  [4923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__requirement_clause_constraint, 3, 0, 0),
  [4925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 2, 0, 32),
  [4927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 2, 0, 32),
  [4929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requirement_seq, 2, 0, 0),
  [4931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requirement_seq, 2, 0, 0),
  [4933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 4, 0, 124),
  [4935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 4, 0, 124),
  [4937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 4, 0, 125),
  [4939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 4, 0, 125),
  [4941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 5, 0, 174),
  [4943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 5, 0, 174),
  [4945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fold_expression, 3, 0, 40),
  [4947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fold_expression, 3, 0, 40),
  [4949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requires_expression, 3, 0, 65),
  [4951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_expression, 3, 0, 65),
  [4953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requirement_seq, 3, 0, 0),
  [4955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requirement_seq, 3, 0, 0),
  [4957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5370),
  [4959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5362),
  [4961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7177),
  [4963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [4965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6948),
  [4967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requires_expression, 2, 0, 21),
  [4969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_expression, 2, 0, 21),
  [4971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7640),
  [4973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3574),
  [4975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7392),
  [4977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3661),
  [4979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7738),
  [4981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3675),
  [4983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7388),
  [4985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2600),
  [4987] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7858),
  [4990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7858),
  [4992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7938),
  [4994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6819),
  [4996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2611),
  [4998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2716),
  [5000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2544),
  [5002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8602),
  [5004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5803),
  [5006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7839),
  [5008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8604),
  [5010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8805),
  [5012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8614),
  [5014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 2, 0, 0),
  [5016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [5018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [5020] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(1710),
  [5023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 179),
  [5025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 179),
  [5027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, 0, 10),
  [5029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, 0, 10),
  [5031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, 0, 56),
  [5033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 56),
  [5035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, 0, 66),
  [5037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 66),
  [5039] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_method_definition, 3, 0, 67),
  [5041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_method_definition, 3, 0, 67),
  [5043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_method_definition, 3, 0, 66),
  [5045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_method_definition, 3, 0, 66),
  [5047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, 0, 79),
  [5049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, 0, 79),
  [5051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 80),
  [5053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 80),
  [5055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 10),
  [5057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 10),
  [5059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 66),
  [5061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 66),
  [5063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 180),
  [5065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 180),
  [5067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 128),
  [5069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 128),
  [5071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 79),
  [5073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 79),
  [5075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, 0, 129),
  [5077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, 0, 129),
  [5079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 193),
  [5081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 193),
  [5083] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declaration_list_item, 2, 0, 0),
  [5085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declaration_list_item, 2, 0, 0),
  [5087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, 0, 56),
  [5089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, 0, 56),
  [5091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 66),
  [5093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 66),
  [5095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 197),
  [5097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 197),
  [5099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 179),
  [5101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 179),
  [5103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 198),
  [5105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 198),
  [5107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 180),
  [5109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 180),
  [5111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 6, 0, 176),
  [5113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 6, 0, 176),
  [5115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, 0, 193),
  [5117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, 0, 193),
  [5119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, 0, 207),
  [5121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, 0, 207),
  [5123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, 0, 197),
  [5125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, 0, 197),
  [5127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, 0, 198),
  [5129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, 0, 198),
  [5131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 7, 0, 207),
  [5133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 7, 0, 207),
  [5135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7828),
  [5138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7828),
  [5140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7959),
  [5143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7959),
  [5145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_specifier, 4, 0, 0),
  [5147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_specifier, 4, 0, 0),
  [5149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alignas_qualifier, 4, 0, 0),
  [5151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alignas_qualifier, 4, 0, 0),
  [5153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2720),
  [5155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34), SHIFT(528),
  [5158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0),
  [5160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0),
  [5162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(2108),
  [5165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(1846),
  [5168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(8843),
  [5171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_type, 2, -1, 0),
  [5173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_type, 2, -1, 0),
  [5175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2003),
  [5177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8458),
  [5179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34),
  [5181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34),
  [5183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6912),
  [5185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_name, 1, 0, 0),
  [5187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_name, 1, 0, 0),
  [5189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(480),
  [5192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 0),
  [5194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0),
  [5196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_type_identifier, 2, 0, 0),
  [5198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_type_identifier, 2, 0, 0),
  [5200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34), SHIFT(440),
  [5203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decltype, 4, 0, 0),
  [5205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decltype, 4, 0, 0),
  [5207] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(1867),
  [5210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [5212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_name, 1, 0, 1),
  [5214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 9),
  [5216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 9),
  [5218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 4, 0, 0),
  [5220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 4, 0, 0),
  [5222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 95),
  [5224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 95),
  [5226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 97),
  [5228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 97),
  [5230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 100),
  [5232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 100),
  [5234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 2, 0, 0),
  [5236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 2, 0, 0),
  [5238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 10),
  [5240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 10),
  [5242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 2, 0, 0),
  [5244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 2, 0, 0),
  [5246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 2, 0, 12),
  [5248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 2, 0, 12),
  [5250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, 0, 11),
  [5252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, 0, 11),
  [5254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, 0, 6),
  [5256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, 0, 6),
  [5258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [5261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [5264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2001),
  [5267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0),
  [5269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0),
  [5271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7238),
  [5274] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8141),
  [5277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_placeholder_type_specifier, 2, 0, 27),
  [5279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_placeholder_type_specifier, 2, 0, 27),
  [5281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 4, 0, 103),
  [5283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 4, 0, 103),
  [5285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decltype_auto, 4, 0, 0),
  [5287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decltype_auto, 4, 0, 0),
  [5289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 4, 0, 46),
  [5291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 4, 0, 46),
  [5293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 4, 0, 143),
  [5295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 4, 0, 143),
  [5297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 6, 0, 141),
  [5299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 6, 0, 141),
  [5301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_placeholder_type_specifier, 1, 0, 0),
  [5303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_placeholder_type_specifier, 1, 0, 0),
  [5305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2001),
  [5307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 3, 0, 0),
  [5309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 3, 0, 0),
  [5311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 5, 0, 142),
  [5313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 5, 0, 142),
  [5315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 2, 0, 12),
  [5317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 2, 0, 12),
  [5319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 2, 0, 12),
  [5321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 2, 0, 12),
  [5323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2135),
  [5325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 1, 0, 0),
  [5327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0),
  [5329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1952),
  [5331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2134),
  [5333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34), SHIFT(480),
  [5336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 3, 0, 102),
  [5338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 3, 0, 102),
  [5340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 1, 0, 13),
  [5342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 1, 0, 13),
  [5344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2026),
  [5346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 2, 0, 0),
  [5348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 2, 0, 0),
  [5350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_specifier, 2, 0, 12),
  [5352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_specifier, 2, 0, 12),
  [5354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, 0, 9),
  [5356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, 0, 9),
  [5358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 3, 0, 0),
  [5360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 3, 0, 0),
  [5362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 46),
  [5364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 46),
  [5366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 47),
  [5368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 47),
  [5370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, 0, 50),
  [5372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, 0, 50),
  [5374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__enum_base_clause, 2, 0, 98),
  [5376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_base_clause, 2, 0, 98),
  [5378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 48),
  [5380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 48),
  [5382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 49),
  [5384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 49),
  [5386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 3, 0, 0),
  [5388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 3, 0, 0),
  [5390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requires_clause, 2, 0, 22),
  [5392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_clause, 2, 0, 22),
  [5394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5725),
  [5396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5727),
  [5398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5725),
  [5400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5727),
  [5402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint_disjunction, 3, 0, 54),
  [5404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_disjunction, 3, 0, 54),
  [5406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 2, 0, 20),
  [5408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 2, 0, 20),
  [5410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2151),
  [5412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2182),
  [5414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8789),
  [5416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, 0, 20),
  [5418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 20),
  [5420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [5422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, -1, 36),
  [5424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 36),
  [5426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 1, 0, 2),
  [5428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 1, 0, 2),
  [5430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2156),
  [5432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, -1, 18),
  [5434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 18),
  [5436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 2),
  [5438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 2),
  [5440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 20),
  [5442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 20),
  [5444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [5446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, -1, 36),
  [5448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 36),
  [5450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [5452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [5454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_parameter_list, 2, 0, 0),
  [5456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter_list, 2, 0, 0),
  [5458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 2, 0, 0),
  [5460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 2, 0, 0),
  [5462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_string_literal, 5, 0, 0),
  [5464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string_literal, 5, 0, 0),
  [5466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_parameter_list, 4, 0, 0),
  [5468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter_list, 4, 0, 0),
  [5470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_string_literal, 7, 0, 206),
  [5472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string_literal, 7, 0, 206),
  [5474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_parameter_list, 3, 0, 0),
  [5476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter_list, 3, 0, 0),
  [5478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition_clause, 4, 0, 145),
  [5480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_clause, 4, 0, 145),
  [5482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6235),
  [5484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 1, 1, 0),
  [5486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2145),
  [5488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4642),
  [5490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4642),
  [5492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6059),
  [5494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [5496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition_clause, 3, 0, 14),
  [5498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_clause, 3, 0, 14),
  [5500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 3, 0, 0),
  [5502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 3, 0, 0),
  [5504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 0),
  [5506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 1, 0, 6),
  [5508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 1, 0, 6),
  [5510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8842),
  [5512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [5514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6143),
  [5516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6207),
  [5518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2162),
  [5521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 3, 0, 20),
  [5523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 3, 0, 20),
  [5525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2159),
  [5527] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2152),
  [5530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__enum_base_clause, 2, 0, 99),
  [5532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_base_clause, 2, 0, 99),
  [5534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [5536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 2, 0, 2),
  [5538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 2, 0, 2),
  [5540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2223),
  [5542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2150),
  [5544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2225),
  [5546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8884),
  [5548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [5550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6207),
  [5552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0),
  [5554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0),
  [5556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2611),
  [5559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2159),
  [5562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2544),
  [5565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8602),
  [5568] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(7839),
  [5571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8604),
  [5574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8805),
  [5577] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8614),
  [5580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [5582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6143),
  [5584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(590),
  [5587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [5589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [5591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [5593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5106),
  [5595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5106),
  [5597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 97),
  [5599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 97),
  [5601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6518),
  [5603] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(2220),
  [5606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2202),
  [5608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2218),
  [5610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 49),
  [5612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 49),
  [5614] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(966),
  [5617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2219),
  [5619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [5621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5016),
  [5623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5016),
  [5625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2243),
  [5627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, 0, 103),
  [5629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, 0, 103),
  [5631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6094),
  [5633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 46),
  [5635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 46),
  [5637] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(480),
  [5640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 91),
  [5642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 91),
  [5644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [5646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [5648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2460),
  [5650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8333),
  [5652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8903),
  [5654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [5656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 141),
  [5658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 141),
  [5660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2235),
  [5662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2210),
  [5664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 63),
  [5666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 63),
  [5668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 100),
  [5670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 100),
  [5672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [5674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 4, 0, 142),
  [5676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 4, 0, 142),
  [5678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [5680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [5682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 95),
  [5684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 95),
  [5686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 2, 0, 9),
  [5688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 2, 0, 9),
  [5690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 45),
  [5692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 45),
  [5694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 1, 0, 11),
  [5696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 1, 0, 11),
  [5698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 48),
  [5700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 48),
  [5702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [5704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, 0, 20),
  [5706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, 0, 20),
  [5708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2619),
  [5710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string, 1, 0, 0),
  [5712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string, 1, 0, 0),
  [5714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, 0, 9),
  [5716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, 0, 9),
  [5718] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2243),
  [5721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, 0, 50),
  [5723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, 0, 50),
  [5725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, 0, 46),
  [5727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, 0, 46),
  [5729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(480),
  [5731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [5733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_storage_class_specifier, 1, 0, 0),
  [5735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_storage_class_specifier, 1, 0, 0),
  [5737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7203),
  [5739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [5741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1120),
  [5743] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_expression, 1, 0, 0),
  [5746] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_expression, 1, 0, 0),
  [5749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_destructor_name, 2, 0, 0),
  [5751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_destructor_name, 2, 0, 0),
  [5753] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(548),
  [5756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [5758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [5760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [5762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [5764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [5766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7095),
  [5768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8187),
  [5770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2438),
  [5772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6571),
  [5774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2290),
  [5776] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2288),
  [5779] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7095),
  [5782] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8187),
  [5785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(612),
  [5787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2290),
  [5790] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7129),
  [5793] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8139),
  [5796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2287),
  [5798] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(8252),
  [5801] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(6511),
  [5804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1125),
  [5806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [5808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1097),
  [5810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [5812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7100),
  [5814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8185),
  [5816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2302),
  [5818] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(589),
  [5821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [5823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2288),
  [5825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8252),
  [5827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_declspec_modifier, 4, 0, 0),
  [5829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_declspec_modifier, 4, 0, 0),
  [5831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 5, 1, 169),
  [5833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 5, 1, 169),
  [5835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [5837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7933),
  [5839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [5841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [5843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_type_declarator, 2, 1, 0),
  [5845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_type_declarator, 2, 1, 0),
  [5847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [5849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [5851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2320),
  [5854] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7130),
  [5857] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8167),
  [5860] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(600),
  [5863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7119),
  [5865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8172),
  [5867] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(2382),
  [5870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2321),
  [5872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2418),
  [5874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [5876] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(533),
  [5879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1092),
  [5881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [5883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7084),
  [5885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8166),
  [5887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [5889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [5891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2349),
  [5893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7130),
  [5895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8167),
  [5897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 3, 1, 41),
  [5899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 3, 1, 41),
  [5901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1099),
  [5903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [5905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 4, 1, 85),
  [5907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 4, 1, 85),
  [5909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2357),
  [5911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2320),
  [5913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6507),
  [5915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [5917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [5919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2370),
  [5921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6572),
  [5923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 2, 1, 5),
  [5925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 2, 1, 5),
  [5927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2514),
  [5929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2308),
  [5931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2515),
  [5933] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(440),
  [5936] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2370),
  [5939] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7119),
  [5942] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8172),
  [5945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 3, 0, 26),
  [5947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 3, 0, 26),
  [5949] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2378),
  [5952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2689),
  [5954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 90),
  [5956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 90),
  [5958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type_declarator, 3, -10, 0),
  [5960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type_declarator, 3, -10, 0),
  [5962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2455),
  [5964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 62),
  [5966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 62),
  [5968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_type_declarator, 2, 0, 0),
  [5970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_type_declarator, 2, 0, 0),
  [5972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 42),
  [5974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 42),
  [5976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 5, 0, 171),
  [5978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 5, 0, 171),
  [5980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3766),
  [5982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 1),
  [5984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 1),
  [5986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0),
  [5988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0),
  [5990] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7933),
  [5993] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1),
  [5996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type_declarator, 4, -10, 0),
  [5998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type_declarator, 4, -10, 0),
  [6000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 43),
  [6002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 43),
  [6004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 4, 0, 118),
  [6006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 4, 0, 118),
  [6008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 4, 0, 26),
  [6010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 4, 0, 26),
  [6012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 111),
  [6014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 111),
  [6016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2447),
  [6018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2378),
  [6020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 0),
  [6022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 0),
  [6024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, 0, 135),
  [6026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, 0, 135),
  [6028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type_declarator, 2, 0, 87),
  [6030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type_declarator, 2, 0, 87),
  [6032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2430),
  [6034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [6036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3887),
  [6038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_declarator, 3, 0, 165),
  [6040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_declarator, 3, 0, 165),
  [6042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 2, 0, 10),
  [6044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 2, 0, 10),
  [6046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6232),
  [6048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 47),
  [6050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 47),
  [6052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_expression, 2, 0, 4),
  [6054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_expression, 2, 0, 4),
  [6056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [6058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2665),
  [6060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6364),
  [6062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6364),
  [6064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 54),
  [6066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 54),
  [6068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 4),
  [6070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 4),
  [6072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, 1, 70),
  [6074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, 1, 70),
  [6076] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_field_expression, 3, 1, 70), SHIFT(480),
  [6079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_method, 2, 0, 119),
  [6081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_method, 2, 0, 119),
  [6083] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2489),
  [6086] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7168),
  [6089] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8159),
  [6092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3957),
  [6094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [6096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_await_expression, 2, 0, 4),
  [6098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_await_expression, 2, 0, 4),
  [6100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 0),
  [6102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, 0, 84),
  [6104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, 0, 84),
  [6106] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 2, 0, 14),
  [6108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 2, 0, 14),
  [6110] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 4),
  [6112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, 0, 4),
  [6114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [6116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8402),
  [6118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2675),
  [6120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2470),
  [6122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2676),
  [6124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2489),
  [6126] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 1, 120),
  [6128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_field_identifier, 2, 1, 120),
  [6130] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 1, 120), SHIFT(480),
  [6133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [6135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [6137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2510),
  [6139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [6141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [6143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_method, 2, 0, 17),
  [6145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_method, 2, 0, 17),
  [6147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 0, 34),
  [6149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_field_identifier, 2, 0, 34),
  [6151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_launch_bounds, 4, 0, 0),
  [6153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_launch_bounds, 4, 0, 0),
  [6155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [6157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [6159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_field_identifier, 2, 0, 0),
  [6161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_field_identifier, 2, 0, 0),
  [6163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_declarator, 4, 0, 165),
  [6165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_declarator, 4, 0, 165),
  [6167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 40),
  [6169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 40),
  [6171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3234),
  [6173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 4, 0, 0),
  [6175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4, 0, 0),
  [6177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8864),
  [6179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [6181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3299),
  [6183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2584),
  [6186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3267),
  [6188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6817),
  [6190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6267),
  [6192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [6194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6822),
  [6196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6811),
  [6198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 75),
  [6200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_identifier, 3, 0, 75),
  [6202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 75), SHIFT(480),
  [6205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6830),
  [6207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3395),
  [6209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2756),
  [6211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3374),
  [6213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2751),
  [6215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2551),
  [6217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2754),
  [6219] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(956),
  [6222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_name, 2, 0, 0),
  [6224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_name, 2, 0, 0),
  [6226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2691),
  [6228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3364),
  [6230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [6232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [6234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3432),
  [6236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_launch_bounds, 6, 0, 0),
  [6238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_launch_bounds, 6, 0, 0),
  [6240] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__constructor_specifiers, 1, 0, 0), REDUCE(aux_sym__declaration_specifiers_repeat1, 1, 0, 0),
  [6243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constructor_specifiers, 1, 0, 0),
  [6245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__constructor_specifiers, 1, 0, 0),
  [6247] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__constructor_specifiers, 1, 0, 0), REDUCE(aux_sym__declaration_specifiers_repeat1, 1, 0, 0),
  [6250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 1, 0, 0),
  [6252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_user_defined_literal, 2, 0, 0),
  [6254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_user_defined_literal, 2, 0, 0),
  [6256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2694),
  [6258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 3, 0, 0),
  [6260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 3, 0, 0),
  [6262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 0),
  [6264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 0),
  [6266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_null, 1, 0, 0),
  [6268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_null, 1, 0, 0),
  [6270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2629),
  [6273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8951),
  [6275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [6277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2711),
  [6280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [6282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5, 0, 0),
  [6284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5, 0, 0),
  [6286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, 0, 71),
  [6288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, 0, 71),
  [6290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_literal_expression, 2, 0, 8),
  [6292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_literal_expression, 2, 0, 8),
  [6294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2793),
  [6296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2696),
  [6298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2836),
  [6300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9030),
  [6302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_argument_list, 2, 0, 0),
  [6304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_argument_list, 2, 0, 0),
  [6306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5757),
  [6308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5746),
  [6310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5757),
  [6312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5746),
  [6314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_argument_list, 3, 0, 0),
  [6316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_argument_list, 3, 0, 0),
  [6318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alignof_expression, 4, 0, 45),
  [6320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alignof_expression, 4, 0, 45),
  [6322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 4, 0, 107),
  [6324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 4, 0, 107),
  [6326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2805),
  [6328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_argument_list, 4, 0, 0),
  [6330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_argument_list, 4, 0, 0),
  [6332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 109),
  [6334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 109),
  [6336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 110),
  [6338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 110),
  [6340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 29),
  [6342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, 0, 29),
  [6344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 89),
  [6346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 89),
  [6348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8884),
  [6350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6279),
  [6352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [6354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [6356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2812),
  [6358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, 0, 0),
  [6360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, 0, 0),
  [6362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_literal_expression, 4, 0, 84),
  [6364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_literal_expression, 4, 0, 84),
  [6366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_name, 3, 0, 0),
  [6368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_name, 3, 0, 0),
  [6370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8943),
  [6372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [6374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, 0, 54),
  [6376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, 0, 54),
  [6378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_declaration, 2, 0, 108),
  [6380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5489),
  [6382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 9, 0, 215),
  [6384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 9, 0, 215),
  [6386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_expression, 9, 0, 0),
  [6388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_expression, 9, 0, 0),
  [6390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, 0, 133),
  [6392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, 0, 133),
  [6394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, 0, 134),
  [6396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, 0, 134),
  [6398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 8, 0, 212),
  [6400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 8, 0, 212),
  [6402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [6404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 8, 0, 211),
  [6406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 8, 0, 211),
  [6408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_expression, 8, 0, 0),
  [6410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_expression, 8, 0, 0),
  [6412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 4, 0, 0),
  [6414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 4, 0, 0),
  [6416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 61),
  [6418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 61),
  [6420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2780),
  [6422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2633),
  [6424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2782),
  [6426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0),
  [6428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0),
  [6430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2611),
  [6433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2716),
  [6436] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2544),
  [6439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8602),
  [6442] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(7839),
  [6445] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8604),
  [6448] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8805),
  [6451] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(3961),
  [6454] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8614),
  [6457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 7, 0, 204),
  [6459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 7, 0, 204),
  [6461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_identifier, 2, 0, 0),
  [6463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_identifier, 2, 0, 0),
  [6465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 7, 0, 203),
  [6467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 7, 0, 203),
  [6469] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(1830),
  [6472] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2720),
  [6475] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2714),
  [6478] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(9030),
  [6481] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8073),
  [6484] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(9015),
  [6487] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(9007),
  [6490] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8807),
  [6493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 6, 0, 191),
  [6495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 6, 0, 191),
  [6497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 6, 0, 190),
  [6499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 6, 0, 190),
  [6501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_offsetof_expression, 6, 0, 188),
  [6503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_offsetof_expression, 6, 0, 188),
  [6505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, 0, 7),
  [6507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, 0, 7),
  [6509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2, 0, 0),
  [6511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2, 0, 0),
  [6513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 5, 0, 0),
  [6515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 5, 0, 0),
  [6517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 6, 0, 177),
  [6519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 6, 0, 177),
  [6521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 2, 0, 30),
  [6523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 2, 0, 30),
  [6525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 5, 0, 153),
  [6527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 5, 0, 153),
  [6529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 5, 0, 155),
  [6531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 5, 0, 155),
  [6533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 5, 0, 156),
  [6535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 5, 0, 156),
  [6537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, 0, 166),
  [6539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, 0, 166),
  [6541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_kernel_call_expression, 3, 0, 72),
  [6543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_kernel_call_expression, 3, 0, 72),
  [6545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(440),
  [6547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2749),
  [6550] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7343),
  [6553] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8134),
  [6556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2770),
  [6558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2758),
  [6560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2762),
  [6562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(600),
  [6564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [6566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6248),
  [6568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2749),
  [6570] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(528),
  [6573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2763),
  [6575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2927),
  [6577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2809),
  [6579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2928),
  [6581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2829),
  [6583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2803),
  [6585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5617),
  [6587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5617),
  [6589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8396),
  [6591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2798),
  [6593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5603),
  [6595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5603),
  [6597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2908),
  [6599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2825),
  [6601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8921),
  [6603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [6605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2824),
  [6607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6895),
  [6609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2814),
  [6611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5595),
  [6613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5595),
  [6615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6090),
  [6617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2787),
  [6619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23),
  [6621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5832),
  [6623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5832),
  [6625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [6627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 1, 0, 23),
  [6629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9007),
  [6631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6970),
  [6633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3251),
  [6635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(6379),
  [6638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6087),
  [6640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8854),
  [6642] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5723),
  [6645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [6647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6614),
  [6649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6238),
  [6651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2807),
  [6653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5600),
  [6655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5600),
  [6657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6064),
  [6659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2788),
  [6661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [6663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2827),
  [6665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5589),
  [6667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5589),
  [6669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6119),
  [6671] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2823),
  [6674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6379),
  [6676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5723),
  [6678] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(440),
  [6681] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(600),
  [6684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2790),
  [6686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4618),
  [6688] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(8803),
  [6691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(7988),
  [6694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4618),
  [6696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8865),
  [6698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3340),
  [6700] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(6207),
  [6703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5771),
  [6706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6581),
  [6708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6287),
  [6710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [6712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [6714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3127),
  [6716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8215),
  [6718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5771),
  [6720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 2, 0, 0),
  [6722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 2, 0, 0),
  [6724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1283),
  [6726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1274),
  [6728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [6730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [6732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [6734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1281),
  [6736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1491),
  [6738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [6740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1266),
  [6742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [6744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1267),
  [6746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [6748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1264),
  [6750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [6752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [6754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 5, 0, 172),
  [6756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2649),
  [6758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, 0, 172),
  [6760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [6762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [6764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 5, 0, 0),
  [6766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 5, 0, 0),
  [6768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 4, 0, 121),
  [6770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 4, 0, 121),
  [6772] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 4, 0, 0),
  [6774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 4, 0, 0),
  [6776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(589),
  [6778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6516),
  [6780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6280),
  [6782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 3, 0, 0),
  [6784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 3, 0, 0),
  [6786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [6788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [6790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3419),
  [6792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8551),
  [6794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2823),
  [6796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8803),
  [6798] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(6970),
  [6801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3442),
  [6803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [6805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(589),
  [6808] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(7839),
  [6811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3413),
  [6813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5753),
  [6815] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5753),
  [6818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2896),
  [6820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3388),
  [6822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3236),
  [6824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [6826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [6828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [6830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8570),
  [6832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2939),
  [6834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2918),
  [6836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_call_modifier, 1, 0, 0),
  [6838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_call_modifier, 1, 0, 0),
  [6840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3347),
  [6842] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5755),
  [6845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1408),
  [6847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1429),
  [6849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [6851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1457),
  [6853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [6855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1465),
  [6857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [6859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1453),
  [6861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [6863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1444),
  [6865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [6867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [6869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1436),
  [6871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1432),
  [6873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1435),
  [6875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [6877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6517),
  [6879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6268),
  [6881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3824),
  [6883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [6885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4021),
  [6887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1253),
  [6889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1252),
  [6891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1251),
  [6893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1250),
  [6895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1245),
  [6897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [6899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [6901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1242),
  [6903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1241),
  [6905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [6907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [6909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [6911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [6913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [6915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [6917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [6919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1228),
  [6921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1227),
  [6923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [6925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [6927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [6929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [6931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [6933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [6935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [6937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [6939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [6941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [6943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [6945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [6947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [6949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [6951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [6953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1205),
  [6955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1203),
  [6957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [6959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1200),
  [6961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [6963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [6965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3663),
  [6967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6333),
  [6969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6225),
  [6971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8705),
  [6973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [6975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [6977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3406),
  [6979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5778),
  [6981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_char_literal, 3, 0, 0),
  [6983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_char_literal, 3, 0, 0),
  [6985] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5778),
  [6988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3846),
  [6990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5755),
  [6992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0),
  [6994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3620),
  [6996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [6998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [7000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3817),
  [7002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8454),
  [7004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_requirement, 6, 0, 0),
  [7006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_requirement, 6, 0, 0),
  [7008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [7010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7883),
  [7012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [7014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_requirement, 2, 0, 0),
  [7016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_requirement, 2, 0, 0),
  [7018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_requirement, 5, 0, 0),
  [7020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_requirement, 5, 0, 0),
  [7022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__requirement, 1, 0, 64),
  [7024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__requirement, 1, 0, 64),
  [7026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3285),
  [7028] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5769),
  [7031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6233),
  [7033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_requirement, 4, 0, 0),
  [7035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_requirement, 4, 0, 0),
  [7037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5769),
  [7039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1468),
  [7041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6333),
  [7043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [7045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7843),
  [7047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [7049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [7051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7824),
  [7053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [7055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1497),
  [7057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1496),
  [7059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [7061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [7063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1262),
  [7065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1490),
  [7067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1488),
  [7069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [7071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1486),
  [7073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [7075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1485),
  [7077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1495),
  [7079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1494),
  [7081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [7083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [7085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1473),
  [7087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [7089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [7091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1459),
  [7093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1442),
  [7095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1434),
  [7097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [7099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1423),
  [7101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [7103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1422),
  [7105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [7107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [7109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1464),
  [7111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1462),
  [7113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [7115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [7117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3823),
  [7119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2714),
  [7121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9015),
  [7123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [7125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8789),
  [7127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8807),
  [7129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7883),
  [7132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4534),
  [7134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6039),
  [7136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6818),
  [7138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2136),
  [7140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [7142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3143),
  [7144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5704),
  [7146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5704),
  [7148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3662),
  [7150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3662),
  [7152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3664),
  [7154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(819),
  [7156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3791),
  [7158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [7160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5705),
  [7162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5705),
  [7164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3163),
  [7166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5706),
  [7168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5706),
  [7170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0),
  [7172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0),
  [7174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(3662),
  [7177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(3664),
  [7180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4750),
  [7182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6845),
  [7184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4292),
  [7186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4419),
  [7188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6432),
  [7190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5507),
  [7192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5506),
  [7194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5495),
  [7196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4799),
  [7198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8906),
  [7200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5557),
  [7202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4196),
  [7204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8286),
  [7206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4115),
  [7208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1257),
  [7210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1256),
  [7212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1255),
  [7214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1254),
  [7216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1246),
  [7218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [7220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [7222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1224),
  [7224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1223),
  [7226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1222),
  [7228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [7230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [7232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1219),
  [7234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [7236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1217),
  [7238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [7240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [7242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1214),
  [7244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8285),
  [7246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [7248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8290),
  [7250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8280),
  [7252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8235),
  [7254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8276),
  [7256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8275),
  [7258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8270),
  [7260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8269),
  [7262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8267),
  [7264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8260),
  [7266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8257),
  [7268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [7270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [7272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [7274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [7276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [7278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [7280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [7282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4190),
  [7284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5175),
  [7286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6821),
  [7288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5342),
  [7290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5374),
  [7292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6450),
  [7294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5511),
  [7296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5510),
  [7298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5509),
  [7300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5554),
  [7302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3892),
  [7304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1529),
  [7306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1533),
  [7308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [7310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [7312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1557),
  [7314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1570),
  [7316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1574),
  [7318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [7320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1577),
  [7322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [7324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1585),
  [7326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [7328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [7330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [7332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1540),
  [7334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1543),
  [7336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [7338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [7340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3893),
  [7342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6348),
  [7344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6348),
  [7346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3844),
  [7348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3844),
  [7350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3747),
  [7352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8321),
  [7354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6265),
  [7356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4211),
  [7358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6831),
  [7360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6481),
  [7362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5535),
  [7364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5538),
  [7366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5540),
  [7368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5485),
  [7370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3694),
  [7372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3899),
  [7374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3899),
  [7376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3789),
  [7378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8541),
  [7380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3330),
  [7382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6368),
  [7384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6368),
  [7386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3250),
  [7388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5713),
  [7390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5713),
  [7392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4511),
  [7394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4253),
  [7396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4275),
  [7398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [7400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8605),
  [7402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4393),
  [7404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6833),
  [7406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4392),
  [7408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4609),
  [7410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6440),
  [7412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5571),
  [7414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5552),
  [7416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5550),
  [7418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5240),
  [7420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8944),
  [7422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5515),
  [7424] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 75), SHIFT(575),
  [7427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2661),
  [7429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4908),
  [7431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3211),
  [7433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5768),
  [7435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4692),
  [7437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6832),
  [7439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2263),
  [7441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6046),
  [7443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [7445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3976),
  [7447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6321),
  [7449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6321),
  [7451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3974),
  [7453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [7455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1286),
  [7457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [7459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [7461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1272),
  [7463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1270),
  [7465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1284),
  [7467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [7469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1289),
  [7471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1295),
  [7473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [7475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [7477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [7479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1275),
  [7481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [7483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [7485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 75), SHIFT(548),
  [7488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3528),
  [7490] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 1, 120), SHIFT(528),
  [7493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5221),
  [7495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3832),
  [7497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3886),
  [7499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6242),
  [7501] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7843),
  [7504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5768),
  [7507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3924),
  [7509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4240),
  [7511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6827),
  [7513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6490),
  [7515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5568),
  [7517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5569),
  [7519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5575),
  [7521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5528),
  [7523] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7824),
  [7526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3802),
  [7528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3802),
  [7530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3571),
  [7532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8316),
  [7534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3509),
  [7536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3509),
  [7538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3425),
  [7540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8389),
  [7542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_field_expression, 3, 1, 70), SHIFT(528),
  [7545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7988),
  [7547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3225),
  [7549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3530),
  [7551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [7553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2644),
  [7555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [7557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8745),
  [7559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1638),
  [7561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1639),
  [7563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [7565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [7567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1602),
  [7569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1594),
  [7571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1587),
  [7573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [7575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1502),
  [7577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [7579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1498),
  [7581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [7583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1609),
  [7585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1605),
  [7587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [7589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [7591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34), SHIFT(600),
  [7594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [7596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [7598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3325),
  [7600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [7602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1121),
  [7604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3358),
  [7606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3502),
  [7608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5726),
  [7610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5726),
  [7612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3856),
  [7614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 75), SHIFT(528),
  [7617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3523),
  [7619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5743),
  [7621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5743),
  [7623] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 1, 120), SHIFT(600),
  [7626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(3536),
  [7629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7100),
  [7632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8185),
  [7635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6267),
  [7637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3536),
  [7639] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 1, 120), SHIFT(440),
  [7642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3545),
  [7644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3671),
  [7646] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_field_expression, 3, 1, 70), SHIFT(440),
  [7649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8842),
  [7651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [7653] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_field_expression, 3, 1, 70), SHIFT(600),
  [7656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1324),
  [7658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1322),
  [7660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [7662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [7664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1307),
  [7666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [7668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1306),
  [7670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [7672] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(3596),
  [7675] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7084),
  [7678] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8166),
  [7681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [7683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [7685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1315),
  [7687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1313),
  [7689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [7691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [7693] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 75), SHIFT(600),
  [7696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3834),
  [7698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3596),
  [7700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_pointer_modifier, 1, 0, 0),
  [7702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_pointer_modifier, 1, 0, 0),
  [7704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_unaligned_ptr_modifier, 1, 0, 0),
  [7706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_unaligned_ptr_modifier, 1, 0, 0),
  [7708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3722),
  [7710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5782),
  [7712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5782),
  [7714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3655),
  [7716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3971),
  [7718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(1830),
  [7721] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(3757),
  [7724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2714),
  [7727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(9030),
  [7730] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8131),
  [7733] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(9015),
  [7736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(9007),
  [7739] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8807),
  [7742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(555),
  [7744] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 75), SHIFT(440),
  [7747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3638),
  [7749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5763),
  [7751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5777),
  [7753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5763),
  [7755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5777),
  [7757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4025),
  [7759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3757),
  [7761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__binary_fold_operator, 3, 0, 130),
  [7763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__binary_fold_operator, 3, 0, 130),
  [7765] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(3849),
  [7768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3837),
  [7770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3978),
  [7772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [7774] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(3834),
  [7777] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7180),
  [7780] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8155),
  [7783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3882),
  [7785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3858),
  [7787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3845),
  [7789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5740),
  [7791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5740),
  [7793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(3882),
  [7796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3911),
  [7798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5932),
  [7800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5932),
  [7802] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_function_specifier, 1, 0, 0),
  [7804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [7806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_function_specifier, 1, 0, 0),
  [7808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5739),
  [7810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5739),
  [7812] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(590),
  [7815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3979),
  [7817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(4253),
  [7820] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(4275),
  [7823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5765),
  [7825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5765),
  [7827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_function_specifier, 4, 0, 0),
  [7829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_function_specifier, 4, 0, 0),
  [7831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5761),
  [7833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5761),
  [7835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2398),
  [7837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5653),
  [7839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4045),
  [7841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6118),
  [7843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6118),
  [7845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3664),
  [7847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2389),
  [7849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2432),
  [7851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6570),
  [7853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5674),
  [7855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4080),
  [7857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6048),
  [7859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6048),
  [7861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6563),
  [7863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6565),
  [7865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4086),
  [7867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6072),
  [7869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6072),
  [7871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3818),
  [7873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5662),
  [7875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4056),
  [7877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6003),
  [7879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6003),
  [7881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3821),
  [7883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3820),
  [7885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 1, 0, 2),
  [7887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4052),
  [7889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6120),
  [7891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6120),
  [7893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4063),
  [7895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6122),
  [7897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6122),
  [7899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6567),
  [7901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6255),
  [7903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, 0, 20),
  [7905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4997),
  [7907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8498),
  [7909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3554),
  [7911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5675),
  [7913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4068),
  [7915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6111),
  [7917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6111),
  [7919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3557),
  [7921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3555),
  [7923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3592),
  [7925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5658),
  [7927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4073),
  [7929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6034),
  [7931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6034),
  [7933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3589),
  [7935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3590),
  [7937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [7939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4094),
  [7941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6043),
  [7943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6043),
  [7945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [7947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4394),
  [7949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8576),
  [7951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4130),
  [7953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6132),
  [7955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6132),
  [7957] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(555),
  [7960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5734),
  [7962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5741),
  [7964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5275),
  [7966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8563),
  [7968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_start, 1, 0, 0),
  [7970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_start, 1, 0, 0),
  [7972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4329),
  [7974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4327),
  [7976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4215),
  [7978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4331),
  [7980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6258),
  [7982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4430),
  [7984] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(4237),
  [7987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7008),
  [7989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5710),
  [7991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4252),
  [7993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6203),
  [7995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6203),
  [7997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6636),
  [7999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4228),
  [8001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6210),
  [8003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6210),
  [8005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4251),
  [8007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6186),
  [8009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6186),
  [8011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8935),
  [8013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [8015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4274),
  [8017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6201),
  [8019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6201),
  [8021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5599),
  [8023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5368),
  [8025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5368),
  [8027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5369),
  [8029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5599),
  [8031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8885),
  [8033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [8035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [8037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8458),
  [8039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, 0, 2),
  [8041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4285),
  [8043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6264),
  [8045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6264),
  [8047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, 0, 20),
  [8049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4385),
  [8051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4300),
  [8053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4386),
  [8055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [8057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(508),
  [8059] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(4302),
  [8062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4244),
  [8064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4237),
  [8066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4342),
  [8068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4323),
  [8070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4322),
  [8072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4490),
  [8074] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(533),
  [8077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0),
  [8079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0),
  [8081] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1830),
  [8084] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1830),
  [8087] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(9007),
  [8090] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(508),
  [8093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4426),
  [8095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1447),
  [8097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [8099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1449),
  [8101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1474),
  [8103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [8105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4249),
  [8107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [8109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [8111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1454),
  [8113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [8115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1334),
  [8117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [8119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1472),
  [8121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [8123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [8125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [8127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1450),
  [8129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1452),
  [8131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1460),
  [8133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1471),
  [8135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6292),
  [8137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4443),
  [8139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4439),
  [8141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4495),
  [8143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4405),
  [8145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4493),
  [8147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [8149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4407),
  [8151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6476),
  [8153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6476),
  [8155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(4403),
  [8158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6262),
  [8160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator, 3, 0, 140),
  [8162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 3, 0, 140),
  [8164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6587),
  [8166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6269),
  [8168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_start, 2, 0, 0),
  [8170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_start, 2, 0, 0),
  [8172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4302),
  [8174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0),
  [8176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0),
  [8178] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(9030),
  [8181] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4618),
  [8184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4618),
  [8187] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8865),
  [8190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [8192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [8194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4786),
  [8196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8531),
  [8198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [8200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [8202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [8204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7363),
  [8206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 1, 0, 56),
  [8208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4536),
  [8210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4536),
  [8212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [8214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4403),
  [8216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4496),
  [8218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4497),
  [8220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4489),
  [8222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8947),
  [8224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [8226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6588),
  [8228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6259),
  [8230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6217),
  [8232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1352),
  [8234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [8236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1350),
  [8238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [8240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [8242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1336),
  [8244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [8246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1331),
  [8248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [8250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1328),
  [8252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [8254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [8256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [8258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [8260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [8262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [8264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [8266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [8268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [8270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(9007),
  [8273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [8275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [8277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [8279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_reference_declarator, 1, 0, 0),
  [8281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1370),
  [8283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [8285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1369),
  [8287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [8289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [8291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1364),
  [8293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [8295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1359),
  [8297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [8299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1357),
  [8301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [8303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1354),
  [8305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [8307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [8309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [8311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [8313] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8803),
  [8316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [8318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5736),
  [8320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6540),
  [8322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6243),
  [8324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [8326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5745),
  [8328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5748),
  [8330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5745),
  [8332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5748),
  [8334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5737),
  [8336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [8338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [8340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4162),
  [8342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5219),
  [8344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [8346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1296),
  [8348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [8350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [8352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [8354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [8356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1309),
  [8358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [8360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1326),
  [8362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [8364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1317),
  [8366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1332),
  [8368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [8370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [8372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [8374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [8376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5315),
  [8378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [8380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [8382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3326),
  [8384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2709),
  [8386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [8388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2964),
  [8390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [8392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [8394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1406),
  [8396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [8398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1343),
  [8400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [8402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [8404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1414),
  [8406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [8408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1416),
  [8410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [8412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1420),
  [8414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [8416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1421),
  [8418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [8420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3785),
  [8422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [8424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [8426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [8428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [8430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4459),
  [8432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [8434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5296),
  [8436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [8438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4199),
  [8440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3843),
  [8442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [8444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3922),
  [8446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4189),
  [8448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2992),
  [8450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [8452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [8454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3031),
  [8456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5321),
  [8458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [8460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [8462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2623),
  [8464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 4, 0, 175),
  [8466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [8468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4175),
  [8470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2884),
  [8472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_declarator, 3, 0, 113),
  [8474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_declaration, 4, 0, 182),
  [8476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [8478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6959),
  [8480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5227),
  [8482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5312),
  [8484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3794),
  [8486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3897),
  [8488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3903),
  [8490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [8492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3850),
  [8494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4512),
  [8496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4126),
  [8498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [8500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [8502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3810),
  [8504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [8506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4399),
  [8508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3602),
  [8510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2686),
  [8512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4105),
  [8514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6918),
  [8516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [8518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [8520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [8522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3968),
  [8524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4456),
  [8526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5316),
  [8528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3872),
  [8530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitfield_clause, 2, 0, 0),
  [8532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5185),
  [8534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [8536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1582),
  [8538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [8540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1470),
  [8542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [8544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [8546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1623),
  [8548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [8550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1629),
  [8552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [8554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1614),
  [8556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [8558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1597),
  [8560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [8562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [8564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [8566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [8568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5188),
  [8570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8201),
  [8572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2946),
  [8574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6792),
  [8576] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2, 0, 0), SHIFT(1185),
  [8579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comma_expression, 3, 0, 82),
  [8581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2, 0, 0),
  [8583] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_initializer_pair, 3, 0, 138), SHIFT(1185),
  [8586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_pair, 3, 0, 138),
  [8588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4232),
  [8590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [8592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [8594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5207),
  [8596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5279),
  [8598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [8600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6820),
  [8602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3918),
  [8604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2651),
  [8606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3658),
  [8608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [8610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5247),
  [8612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [8614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [8616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3932),
  [8618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4032),
  [8620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [8622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1588),
  [8624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [8626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1589),
  [8628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [8630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [8632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1554),
  [8634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [8636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1598),
  [8638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [8640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1600),
  [8642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [8644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1603),
  [8646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [8648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [8650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [8652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [8654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [8656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [8658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [8660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 5, 1, 199),
  [8662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 1, 186),
  [8664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter_declaration, 3, 0, 159),
  [8666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6414),
  [8668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8692),
  [8670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6408),
  [8672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8561),
  [8674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [8676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 3, 0, 0),
  [8678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter_declaration, 4, 0, 193),
  [8680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 1, 0),
  [8682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6455),
  [8684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8510),
  [8686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [8688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [8690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter_list, 2, 0, 0), REDUCE(sym_argument_list, 2, 0, 0),
  [8693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [8695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [8697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [8699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3071),
  [8701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [8703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6449),
  [8705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8216),
  [8707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [8709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [8711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [8713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0),
  [8715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6385),
  [8717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8297),
  [8719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [8721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 4, 0, 0),
  [8723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 1, 184),
  [8725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [8727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [8729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_pair, 3, 0, 139),
  [8731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6442),
  [8733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8438),
  [8735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 1, 183),
  [8737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6461),
  [8739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8897),
  [8741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [8743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [8745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subscript_argument_list_repeat1, 2, 0, 0),
  [8747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [8749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [8751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [8753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [8755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_lambda_capture_specifier_repeat1, 2, 0, 0),
  [8757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [8759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 149),
  [8761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 148),
  [8763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [8765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [8767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [8769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [8771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [8773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [8775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [8777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [8779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [8781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [8783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6234),
  [8785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4728),
  [8787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [8789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1263),
  [8791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6278),
  [8793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3583),
  [8795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3244),
  [8797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4620),
  [8799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4511),
  [8802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8605),
  [8805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3435),
  [8807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [8809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3458),
  [8811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2495),
  [8813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [8815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3480),
  [8817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3468),
  [8819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [8821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [8823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5167),
  [8825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3447),
  [8827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [8829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [8831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3235),
  [8833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [8835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4484),
  [8837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3189),
  [8839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assignment_expression_lhs, 3, 0, 54),
  [8841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7421),
  [8843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7621),
  [8845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__binary_fold, 3, 0, 83),
  [8847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [8849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [8851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3565),
  [8853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7378),
  [8855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [8857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [8859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [8861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [8863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [8865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4347),
  [8867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [8869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [8871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [8873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3393),
  [8875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4034),
  [8877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [8879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [8881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [8883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [8885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3058),
  [8887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4038),
  [8889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [8891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [8893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [8895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [8897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [8899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [8901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [8903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [8905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [8907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [8909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [8911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6068),
  [8913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [8915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7773),
  [8917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1983),
  [8919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [8921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [8923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2608),
  [8925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_range_loop_body, 4, 0, 185),
  [8927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5083),
  [8929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [8931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [8933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [8935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [8937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [8939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5002),
  [8941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2697),
  [8943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [8945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3492),
  [8947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3329),
  [8949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_range_loop_body, 5, 0, 200),
  [8951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5584),
  [8953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [8955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [8957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unary_left_fold, 3, 0, 54),
  [8959] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4511),
  [8962] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8605),
  [8965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7165),
  [8967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [8969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4089),
  [8971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [8973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6229),
  [8975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [8977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [8979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [8981] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(957),
  [8984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5332),
  [8986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(5368),
  [8989] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(5368),
  [8992] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(5369),
  [8995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5717),
  [8997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5721),
  [8999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5722),
  [9001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6240),
  [9003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 2, 0, 20),
  [9005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 2, 0, 20),
  [9007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 1, 0, 2),
  [9009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 1, 0, 2),
  [9011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5775),
  [9013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23),
  [9015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 2, 0, 23),
  [9017] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(6379),
  [9020] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5723),
  [9023] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 36), SHIFT(5330),
  [9026] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 20), SHIFT(5331),
  [9029] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 36), SHIFT(1867),
  [9032] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 20), SHIFT(1867),
  [9035] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 18), SHIFT(1867),
  [9038] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(5327),
  [9041] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(5343),
  [9044] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(5328),
  [9047] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT(1867),
  [9051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 2), SHIFT(1867),
  [9054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(8803),
  [9057] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(7988),
  [9060] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(6207),
  [9063] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5771),
  [9066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2699),
  [9068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7576),
  [9070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_declaration, 1, 0, 0),
  [9072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5471),
  [9074] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(7839),
  [9077] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5753),
  [9080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 2, 0, 2),
  [9082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 2, 0, 2),
  [9084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2753),
  [9086] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(6970),
  [9089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 3, 0, 20),
  [9091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 3, 0, 20),
  [9093] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(5346),
  [9096] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5778),
  [9099] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5755),
  [9102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23),
  [9104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 3, 0, 23),
  [9106] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(6379),
  [9109] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5723),
  [9112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2746),
  [9114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6861),
  [9116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2642),
  [9118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2850),
  [9120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6502),
  [9122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5561),
  [9124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5562),
  [9126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5563),
  [9128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3453),
  [9130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8937),
  [9132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5436),
  [9134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2371),
  [9136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6839),
  [9138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2367),
  [9140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2521),
  [9142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6501),
  [9144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5574),
  [9146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5573),
  [9148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5572),
  [9150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2390),
  [9152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8846),
  [9154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5514),
  [9156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5599),
  [9159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5599),
  [9162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8885),
  [9165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2326),
  [9167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2324),
  [9169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2503),
  [9171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6438),
  [9173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5527),
  [9175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(8803),
  [9178] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(7988),
  [9181] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(6207),
  [9184] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5771),
  [9187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2707),
  [9189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6836),
  [9191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2590),
  [9193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2834),
  [9195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6402),
  [9197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5504),
  [9199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5496),
  [9201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5479),
  [9203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3089),
  [9205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8811),
  [9207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5470),
  [9209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3830),
  [9211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6855),
  [9213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3828),
  [9215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4111),
  [9217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6417),
  [9219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5530),
  [9221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5529),
  [9223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5508),
  [9225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4450),
  [9227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8952),
  [9229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5474),
  [9231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3767),
  [9233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6864),
  [9235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6491),
  [9237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5438),
  [9239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5439),
  [9241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5441),
  [9243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5455),
  [9245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5769),
  [9248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2870),
  [9250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6853),
  [9252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2771),
  [9254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2957),
  [9256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6457),
  [9258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5521),
  [9260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5522),
  [9262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5524),
  [9264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3680),
  [9266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8888),
  [9268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5457),
  [9270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4298),
  [9272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6829),
  [9274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4208),
  [9276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4422),
  [9278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6494),
  [9280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5555),
  [9282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5432),
  [9284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5558),
  [9286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4755),
  [9288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8924),
  [9290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5523),
  [9292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2755),
  [9294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6809),
  [9296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2715),
  [9298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2871),
  [9300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6409),
  [9302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5549),
  [9304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5541),
  [9306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5534),
  [9308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3319),
  [9310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8948),
  [9312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5560),
  [9314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4299),
  [9316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6846),
  [9318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6413),
  [9320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5435),
  [9322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5434),
  [9324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5477),
  [9326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5526),
  [9328] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(7839),
  [9331] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(6970),
  [9334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5753),
  [9337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4335),
  [9339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2523),
  [9341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4336),
  [9343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4167),
  [9345] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5755),
  [9348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4610),
  [9350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4592),
  [9352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2705),
  [9354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2745),
  [9356] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5768),
  [9359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2759),
  [9361] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5778),
  [9364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6823),
  [9366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3900),
  [9368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4719),
  [9370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2894),
  [9372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2820),
  [9374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4235),
  [9376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4400),
  [9378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2792),
  [9380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2247),
  [9382] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5769),
  [9385] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7839),
  [9388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23),
  [9390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 4, 0, 23),
  [9392] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(6379),
  [9395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5723),
  [9398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(8803),
  [9401] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(7988),
  [9404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5768),
  [9407] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(6207),
  [9410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5771),
  [9413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(6970),
  [9416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(7839),
  [9419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5753),
  [9422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [9424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [9426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4138),
  [9428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7359),
  [9430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5778),
  [9433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [9435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [9437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4586),
  [9439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7173),
  [9441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4611),
  [9443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [9445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [9447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5215),
  [9449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7178),
  [9451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [9453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [9455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3970),
  [9457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7248),
  [9459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [9461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [9463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2650),
  [9465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7181),
  [9467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [9469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [9471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5322),
  [9473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7272),
  [9475] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5755),
  [9478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [9480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [9482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3784),
  [9484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7196),
  [9486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [9488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [9490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4035),
  [9492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7351),
  [9494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5769),
  [9497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [9499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [9501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [9503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [9505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [9507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [9509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7983),
  [9511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [9513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [9515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [9517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7880),
  [9519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [9521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [9523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [9525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7841),
  [9527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [9529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5209),
  [9531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__preproc_expression, 1, 0, 0),
  [9533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5792),
  [9535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__preproc_expression, 1, 0, 0),
  [9537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [9539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6276),
  [9541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7302),
  [9543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6239),
  [9545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [9547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5249),
  [9549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4892),
  [9551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6249),
  [9553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1871),
  [9555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [9557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6837),
  [9559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2126),
  [9561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7242),
  [9563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1665),
  [9565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6181),
  [9567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [9569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6847),
  [9571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6456),
  [9573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3677),
  [9575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6446),
  [9577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6030),
  [9579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [9581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4202),
  [9583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4558),
  [9585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6814),
  [9587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [9589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3869),
  [9591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3919),
  [9593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4200),
  [9595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2772),
  [9597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7723),
  [9599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4588),
  [9601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [9603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2664),
  [9605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_end, 1, 0, 0),
  [9607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_end, 1, 0, 0),
  [9609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_end, 2, 0, 0),
  [9611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_end, 2, 0, 0),
  [9613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3647),
  [9615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7638),
  [9617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6112),
  [9619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2106),
  [9621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6488),
  [9623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2663),
  [9625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6671),
  [9627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [9629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8565),
  [9631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5759),
  [9633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7485),
  [9635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(776),
  [9637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [9639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6062),
  [9641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7104),
  [9643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [9645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4027),
  [9647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [9649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3835),
  [9651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6045),
  [9653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3883),
  [9655] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5768),
  [9658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6715),
  [9660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6656),
  [9662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6117),
  [9664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6696),
  [9666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5212),
  [9668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3836),
  [9670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6428),
  [9672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6862),
  [9674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5718),
  [9676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6025),
  [9678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5951),
  [9680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7859),
  [9682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5950),
  [9684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5950),
  [9686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5839),
  [9688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7586),
  [9690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5965),
  [9692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5800),
  [9694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5960),
  [9696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8195),
  [9698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5991),
  [9700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5990),
  [9702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5990),
  [9704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5989),
  [9706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5988),
  [9708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5985),
  [9710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5984),
  [9712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5975),
  [9714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5927),
  [9716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5963),
  [9718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5963),
  [9720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5952),
  [9722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5967),
  [9724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6828),
  [9726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7642),
  [9728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_qualifier, 1, 0, 0),
  [9730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ref_qualifier, 1, 0, 0),
  [9732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6114),
  [9734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8213),
  [9736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5797),
  [9738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5790),
  [9740] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [9742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2435),
  [9744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8779),
  [9746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5891),
  [9748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7702),
  [9750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3430),
  [9752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5478),
  [9754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [9756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [9758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [9760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [9762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [9764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6991),
  [9766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5844),
  [9768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5899),
  [9770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7851),
  [9772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5898),
  [9774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5898),
  [9776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6050),
  [9778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7774),
  [9780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [9782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6078),
  [9784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(960),
  [9786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5896),
  [9788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7678),
  [9790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6124),
  [9792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6126),
  [9794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5998),
  [9796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_defined, 4, 0, 0),
  [9798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_defined, 4, 0, 0),
  [9800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5999),
  [9802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6000),
  [9804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3088),
  [9806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8348),
  [9808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5905),
  [9810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7549),
  [9812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3391),
  [9814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6071),
  [9816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6012),
  [9818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6115),
  [9820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1862),
  [9822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8298),
  [9824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5910),
  [9826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7701),
  [9828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3220),
  [9830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [9832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [9834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8168),
  [9836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6014),
  [9838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6015),
  [9840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2050),
  [9842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5914),
  [9844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7577),
  [9846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3074),
  [9848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5915),
  [9850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7647),
  [9852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3242),
  [9854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6079),
  [9856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2002),
  [9858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [9860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6016),
  [9862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6017),
  [9864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call_expression, 2, 0, 7),
  [9866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call_expression, 2, 0, 7),
  [9868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6004),
  [9870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6021),
  [9872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6123),
  [9874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5957),
  [9876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 4, 0, 0),
  [9878] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 4, 0, 0),
  [9880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [9882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5934),
  [9884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7744),
  [9886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3440),
  [9888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8527),
  [9890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5936),
  [9892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7785),
  [9894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3239),
  [9896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [9898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [9900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7853),
  [9902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [9904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8046),
  [9906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3433),
  [9908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5941),
  [9910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7805),
  [9912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6100),
  [9914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(988),
  [9916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5943),
  [9918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7814),
  [9920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [9922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6095),
  [9924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3320),
  [9926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7489),
  [9928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2950),
  [9930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7804),
  [9932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5992),
  [9934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6083),
  [9936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5953),
  [9938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_binary_expression, 3, 0, 54),
  [9940] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_binary_expression, 3, 0, 54),
  [9942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6075),
  [9944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6031),
  [9946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1836),
  [9948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8323),
  [9950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5958),
  [9952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7580),
  [9954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3398),
  [9956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5971),
  [9958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6009),
  [9960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5956),
  [9962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 2, 0, 0),
  [9964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 2, 0, 0),
  [9966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 3, 0, 0),
  [9968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 3, 0, 0),
  [9970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_argument_list_repeat1, 2, 0, 0),
  [9972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [9974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [9976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5959),
  [9978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6127),
  [9980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [9982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3012),
  [9984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5981),
  [9986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7408),
  [9988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_parenthesized_expression, 3, 0, 0),
  [9990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_parenthesized_expression, 3, 0, 0),
  [9992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [9994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [9996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8066),
  [9998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5961),
  [10000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5968),
  [10002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1844),
  [10004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5986),
  [10006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7505),
  [10008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6028),
  [10010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5970),
  [10012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5974),
  [10014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5978),
  [10016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5979),
  [10018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_unary_expression, 2, 0, 4),
  [10020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_unary_expression, 2, 0, 4),
  [10022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6055),
  [10024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_defined, 2, 0, 0),
  [10026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_defined, 2, 0, 0),
  [10028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5903),
  [10030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5901),
  [10032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5907),
  [10034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5908),
  [10036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5912),
  [10038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5913),
  [10040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5918),
  [10042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5921),
  [10044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5924),
  [10046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23),
  [10048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 5, 0, 23),
  [10050] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(6207),
  [10053] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5753),
  [10056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23),
  [10058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 6, 0, 23),
  [10060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_postfix, 1, 0, 0),
  [10062] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_postfix, 1, 0, 0),
  [10064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [10066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5904),
  [10068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [10070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [10072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5728),
  [10074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [10076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_specifier, 3, 0, 0),
  [10078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_specifier, 3, 0, 0),
  [10080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7282),
  [10082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6042),
  [10084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7544),
  [10086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_specifier, 4, 0, 0),
  [10088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_specifier, 4, 0, 0),
  [10090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5760),
  [10092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_noexcept, 3, 0, 0),
  [10094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_noexcept, 3, 0, 0),
  [10096] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5771),
  [10099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [10101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6365),
  [10103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_end, 3, 0, 0),
  [10105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_end, 3, 0, 0),
  [10107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6237),
  [10109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7807),
  [10111] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(6207),
  [10114] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5771),
  [10117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_specifier, 5, 0, 0),
  [10119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_specifier, 5, 0, 0),
  [10121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_noexcept, 4, 0, 0),
  [10123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_noexcept, 4, 0, 0),
  [10125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [10127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6713),
  [10129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6719),
  [10131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5982),
  [10133] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5753),
  [10136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_noexcept, 1, 0, 0),
  [10138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [10140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_noexcept, 1, 0, 0),
  [10142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6892),
  [10144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7765),
  [10146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_postfix_repeat1, 2, 0, 0),
  [10148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__function_postfix_repeat1, 2, 0, 0),
  [10150] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_postfix_repeat1, 2, 0, 0), SHIFT_REPEAT(6207),
  [10153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [10155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [10157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5733),
  [10159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6331),
  [10161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5764),
  [10163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6767),
  [10165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6065),
  [10167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [10169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7988),
  [10172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(6379),
  [10175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5723),
  [10178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6425),
  [10180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7051),
  [10182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [10184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [10186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6471),
  [10188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6469),
  [10190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6459),
  [10192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, 0, 173),
  [10194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 4, 0, 173),
  [10196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_parenthesized_declarator, 4, 0, 0),
  [10198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_parenthesized_declarator, 4, 0, 0),
  [10200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, 0, 26),
  [10202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 4, 0, 26),
  [10204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, 0, 118),
  [10206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 4, 0, 118),
  [10208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 5, 0, 171),
  [10210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 5, 0, 171),
  [10212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 23),
  [10214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 7, 0, 23),
  [10216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [10218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5738),
  [10220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [10222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6675),
  [10224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 1, 0, 0),
  [10226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [10228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [10230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [10232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, 0, 26),
  [10234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 3, 0, 26),
  [10236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, 0, 0),
  [10238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 3, 0, 0),
  [10240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, 0, 123),
  [10242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 3, 0, 123),
  [10244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_parenthesized_declarator, 3, 0, 0),
  [10246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_parenthesized_declarator, 3, 0, 0),
  [10248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__abstract_declarator, 1, 0, 0),
  [10250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__abstract_declarator, 1, 0, 0),
  [10252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_function_declarator, 1, 0, 33),
  [10254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_function_declarator, 1, 0, 33),
  [10256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [10258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [10260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [10262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [10264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [10266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_function_declarator, 2, 0, 24),
  [10268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_function_declarator, 2, 0, 24),
  [10270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 2, 0, 0),
  [10272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 2, 0, 0),
  [10274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6216),
  [10276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7215),
  [10278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8151),
  [10280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [10282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trailing_return_type, 2, 0, 0),
  [10284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trailing_return_type, 2, 0, 0),
  [10286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [10288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [10290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_virtual_specifier, 1, 0, 0),
  [10292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_virtual_specifier, 1, 0, 0),
  [10294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6222),
  [10296] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(6222),
  [10299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7215),
  [10302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8151),
  [10305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3411),
  [10307] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8878),
  [10310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6526),
  [10312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7061),
  [10314] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(6379),
  [10317] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5723),
  [10320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4514),
  [10322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2237),
  [10324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2285),
  [10326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2457),
  [10328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2379),
  [10330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2620),
  [10332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4471),
  [10334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2137),
  [10336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2581),
  [10338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2768),
  [10340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4231),
  [10342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4354),
  [10344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4341),
  [10346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4499),
  [10348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2153),
  [10350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2228),
  [10352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5719),
  [10354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5720),
  [10356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3501),
  [10358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3848),
  [10360] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_postfix_repeat1, 2, 0, 0), SHIFT_REPEAT(6379),
  [10363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3788),
  [10365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6334),
  [10367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 5),
  [10369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2779),
  [10371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2911),
  [10373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4207),
  [10375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4325),
  [10377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5778),
  [10380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5065),
  [10382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5334),
  [10384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2355),
  [10386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2491),
  [10388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2680),
  [10390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2785),
  [10392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2654),
  [10394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2773),
  [10396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__class_declaration_repeat1, 2, 0, 0),
  [10398] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__class_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(8602),
  [10401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__class_declaration_repeat1, 2, 0, 0),
  [10403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__class_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(8805),
  [10406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4259),
  [10408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 4, 0, 131),
  [10410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(829),
  [10412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 5),
  [10414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 4, 1, 85),
  [10416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 41),
  [10418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, 0, 62),
  [10420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_reference_declarator, 2, 0, 0),
  [10422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, 0, 81),
  [10424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, 0, 39),
  [10426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [10428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3572),
  [10430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6561),
  [10432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7071),
  [10434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6880),
  [10436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6981),
  [10438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7047),
  [10440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5909),
  [10442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8237),
  [10444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 3, 0, 79),
  [10446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3586),
  [10448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6569),
  [10450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7052),
  [10452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(8131),
  [10455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 2, 0, 10),
  [10457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2485),
  [10459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6523),
  [10461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7034),
  [10463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7004),
  [10465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 5),
  [10467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [10469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6557),
  [10471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7056),
  [10473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5755),
  [10476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5778),
  [10479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6638),
  [10481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 5, 1, 169),
  [10483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5769),
  [10486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [10488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7599),
  [10490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6532),
  [10492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7179),
  [10494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5755),
  [10497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [10499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7386),
  [10501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7286),
  [10503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6648),
  [10505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 5, 1, 169),
  [10507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6646),
  [10509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6660),
  [10511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [10513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7615),
  [10515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7237),
  [10517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6645),
  [10519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6627),
  [10521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [10523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [10525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [10527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7752),
  [10529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7120),
  [10531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [10533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7688),
  [10535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7208),
  [10537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5731),
  [10539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5732),
  [10541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [10543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [10545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7545),
  [10547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7224),
  [10549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6641),
  [10551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_declarator, 2, 1, 0),
  [10553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [10555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [10557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7664),
  [10559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7111),
  [10561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6632),
  [10563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 3, 1, 41),
  [10565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6631),
  [10567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6618),
  [10569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 2, 1, 5),
  [10571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 3, 1, 41),
  [10573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5730),
  [10575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6678),
  [10577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [10579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [10581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [10583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [10585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 2, 1, 5),
  [10587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_field_declarator, 2, 1, 0),
  [10589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6651),
  [10591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 4, 1, 85),
  [10593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6677),
  [10595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6639),
  [10597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_declarator, 2, 0, 0),
  [10599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_declarator, 2, 0, 0),
  [10601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [10603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6667),
  [10605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [10607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5729),
  [10609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6630),
  [10611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6628),
  [10613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 4, 1, 85),
  [10615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6679),
  [10617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6640),
  [10619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [10621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6672),
  [10623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6649),
  [10625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7464),
  [10627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5994),
  [10629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8233),
  [10631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [10633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3500),
  [10635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8455),
  [10637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 3, 0, 26),
  [10639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 3, 0, 26),
  [10641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structured_binding_declarator, 3, -1, 0),
  [10643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_structured_binding_declarator, 3, -1, 0),
  [10645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8713),
  [10647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [10649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3167),
  [10651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3552),
  [10653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [10655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structured_binding_declarator, 4, -1, 0),
  [10657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_structured_binding_declarator, 4, -1, 0),
  [10659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [10661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2511),
  [10663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_declarator, 4, -10, 0),
  [10665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_declarator, 4, -10, 0),
  [10667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8346),
  [10669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3337),
  [10671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3177),
  [10673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 4, 0, 118),
  [10675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 4, 0, 118),
  [10677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6957),
  [10679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6600),
  [10681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 4, 0, 26),
  [10683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 4, 0, 26),
  [10685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [10687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5158),
  [10689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 5, 0, 171),
  [10691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 5, 0, 171),
  [10693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8224),
  [10695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4829),
  [10697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8725),
  [10699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4346),
  [10701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3075),
  [10703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3551),
  [10705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4685),
  [10707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4349),
  [10709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5155),
  [10711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3519),
  [10713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [10715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [10717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [10719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3186),
  [10721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_declarator, 3, -10, 0),
  [10723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_declarator, 3, -10, 0),
  [10725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8859),
  [10727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4697),
  [10729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4809),
  [10731] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5768),
  [10734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3168),
  [10736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8445),
  [10738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7055),
  [10740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7037),
  [10742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 2, 1, 24),
  [10744] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declarator, 2, 1, 24),
  [10746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3030),
  [10748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1, 0, 0),
  [10750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [10752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declarator, 1, 0, 0),
  [10754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1, 0, 101),
  [10756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declarator, 1, 0, 101),
  [10758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5758),
  [10760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5774),
  [10762] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5769),
  [10765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_field_declarator, 2, 0, 0),
  [10767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_field_declarator, 2, 0, 0),
  [10769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 3, 0, 10),
  [10771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7117),
  [10773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5895),
  [10775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8625),
  [10777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_field_declarator, 2, 1, 24),
  [10779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_field_declarator, 2, 1, 24),
  [10781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8738),
  [10783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6868),
  [10785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6843),
  [10787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_field_declarator, 4, -10, 0),
  [10789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_field_declarator, 4, -10, 0),
  [10791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5767),
  [10793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7091),
  [10795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5916),
  [10797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8555),
  [10799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 4, 0, 26),
  [10801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 4, 0, 26),
  [10803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6780),
  [10805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6866),
  [10807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6840),
  [10809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 5, 0, 171),
  [10811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 5, 0, 171),
  [10813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 3, 0, 10),
  [10815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8575),
  [10817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6969),
  [10819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6902),
  [10821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6813),
  [10823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6797),
  [10825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7012),
  [10827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 3, 0, 79),
  [10829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5772),
  [10831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 4, 0, 79),
  [10833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6874),
  [10835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6825),
  [10837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6878),
  [10839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6834),
  [10841] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5768),
  [10844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 4, 0, 118),
  [10846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 4, 0, 118),
  [10848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6794),
  [10850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6885),
  [10852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6826),
  [10854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6888),
  [10856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6812),
  [10858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7021),
  [10860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6790),
  [10862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 4, 0, 79),
  [10864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_field_declarator, 3, -10, 0),
  [10866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_field_declarator, 3, -10, 0),
  [10868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 3, 0, 26),
  [10870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 3, 0, 26),
  [10872] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7464),
  [10875] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5926),
  [10878] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8246),
  [10881] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8085),
  [10884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0),
  [10886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 2, 0, 10),
  [10888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6980),
  [10890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 1, 0, 0),
  [10892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8700),
  [10894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 1, 0, 0),
  [10896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8335),
  [10898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__scope_resolution, 1, 0, 0),
  [10900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scope_resolution, 1, 0, 0),
  [10902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1380),
  [10904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5404),
  [10906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6080),
  [10908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_declarators, 1, 0, 26),
  [10910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 2, 0, 66),
  [10912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [10914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1510),
  [10916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5408),
  [10918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [10920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1528),
  [10922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5390),
  [10924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [10926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1413),
  [10928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5401),
  [10930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1586),
  [10932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5399),
  [10934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1627),
  [10936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5387),
  [10938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [10940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1480),
  [10942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [10944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [10946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5403),
  [10948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1337),
  [10950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5409),
  [10952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1566),
  [10954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5406),
  [10956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1330),
  [10958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5402),
  [10960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2898),
  [10962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6848),
  [10964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1393),
  [10966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5407),
  [10968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1397),
  [10970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2828),
  [10972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7939),
  [10974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2767),
  [10976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7675),
  [10978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7074),
  [10980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8532),
  [10982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7156),
  [10984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7145),
  [10986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5780),
  [10988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5756),
  [10990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7184),
  [10992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2525),
  [10994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7863),
  [10996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7759),
  [10998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4608),
  [11000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8116),
  [11002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 3, 0, 0),
  [11004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 3, 0, 0),
  [11006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_designator, 3, 0, 0),
  [11008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4648),
  [11010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7856),
  [11012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7370),
  [11014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7275),
  [11016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7331),
  [11018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4236),
  [11020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8062),
  [11022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4345),
  [11024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8188),
  [11026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7514),
  [11028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4553),
  [11030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7994),
  [11032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4440),
  [11034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8017),
  [11036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7135),
  [11038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 5),
  [11040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2760),
  [11042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8080),
  [11044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1868),
  [11046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8095),
  [11048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2214),
  [11050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8009),
  [11052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7355),
  [11054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7756),
  [11056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7124),
  [11058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8500),
  [11060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7187),
  [11062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7216),
  [11064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4351),
  [11066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6220),
  [11068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8079),
  [11070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2905),
  [11072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7981),
  [11074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7767),
  [11076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8533),
  [11078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7113),
  [11080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7493),
  [11082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8273),
  [11084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2904),
  [11086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7871),
  [11088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3975),
  [11090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7914),
  [11092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7567),
  [11094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8793),
  [11096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2681),
  [11098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8173),
  [11100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7190),
  [11102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2826),
  [11104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8101),
  [11106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4133),
  [11108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [11110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [11112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3420),
  [11114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [11116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3246),
  [11118] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7464),
  [11121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2, 0, 0),
  [11123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2, 0, 0),
  [11125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6689),
  [11127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [11129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [11131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3300),
  [11133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [11135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3437),
  [11137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 1, 0, 6),
  [11139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator, 1, 0, 6),
  [11141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [11143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__scope_resolution, 2, 0, 15),
  [11145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scope_resolution, 2, 0, 15),
  [11147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6524),
  [11149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [11151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [11153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3253),
  [11155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [11157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [11159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3405),
  [11161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [11163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6753),
  [11165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2, 0, 0), SHIFT_REPEAT(6880),
  [11168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2, 0, 0),
  [11170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2, 0, 0),
  [11172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [11174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [11176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [11178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6583),
  [11180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [11182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [11184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast, 3, 0, 58),
  [11186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__scope_resolution, 2, 0, 31),
  [11188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scope_resolution, 2, 0, 31),
  [11190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [11192] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2, 0, 0), SHIFT_REPEAT(1401),
  [11195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2, 0, 0),
  [11197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2, 0, 0), SHIFT_REPEAT(8305),
  [11200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7784),
  [11202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [11204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3812),
  [11206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 6, 0, 0),
  [11208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 6, 0, 0),
  [11210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6564),
  [11212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3505),
  [11214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7802),
  [11216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [11218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [11220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8305),
  [11222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7559),
  [11224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6546),
  [11226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 1, 0, 0),
  [11228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7020),
  [11230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 1, 0, 0),
  [11232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3607),
  [11234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3550),
  [11236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 5, 0, 0),
  [11238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 5, 0, 0),
  [11240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 4, 0, 0),
  [11242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 4, 0, 0),
  [11244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3643),
  [11246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [11248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3729),
  [11250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7598),
  [11252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6328),
  [11254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7218),
  [11256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 10),
  [11258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 10),
  [11260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6322),
  [11262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6336),
  [11264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6338),
  [11266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6316),
  [11268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6346),
  [11270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6311),
  [11272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6323),
  [11274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6347),
  [11276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6358),
  [11278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 4, 0, 79),
  [11280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 4, 0, 79),
  [11282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 3, 0, 10),
  [11284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 3, 0, 10),
  [11286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0),
  [11288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6359),
  [11290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6324),
  [11292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [11294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [11296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6372),
  [11298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6369),
  [11300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [11302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [11304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [11306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [11308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6315),
  [11310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6360),
  [11312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [11314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [11316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [11318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [11320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [11322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [11324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 6, 0, 176),
  [11326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 6, 0, 176),
  [11328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [11330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [11332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [11334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [11336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [11338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [11340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [11342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [11344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_expression_repeat1, 2, 0, 0),
  [11346] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(7218),
  [11349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [11351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [11353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [11355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [11357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6325),
  [11359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6355),
  [11361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 5, 0, 129),
  [11363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 5, 0, 129),
  [11365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 80),
  [11367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 80),
  [11369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [11371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [11373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [11375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [11377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 79),
  [11379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 79),
  [11381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 128),
  [11383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 128),
  [11385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6163),
  [11387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7854),
  [11389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7607),
  [11391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6433),
  [11393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2061),
  [11395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [11397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8056),
  [11399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7652),
  [11401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, 0, 6),
  [11403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8463),
  [11405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [11407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8148),
  [11409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [11411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [11413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8087),
  [11415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type_parameter_declaration, 3, 0, 158),
  [11417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type_parameter_declaration, 4, 0, 192),
  [11419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [11421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [11423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [11425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [11427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list, 1, 0, 0),
  [11429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7837),
  [11431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8075),
  [11433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [11435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_access_specifier, 1, 0, 0),
  [11437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_access_specifier, 1, 0, 0),
  [11439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8140),
  [11441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6497),
  [11443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [11445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [11447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [11449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7832),
  [11451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [11453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [11455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [11457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [11459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [11461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [11463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [11465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7920),
  [11467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [11469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [11471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [11473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [11475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7031),
  [11477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [11479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [11481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6149),
  [11483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4177),
  [11485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7137),
  [11487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7137),
  [11489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3498),
  [11491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list_no_comma, 2, 0, 0),
  [11493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2493),
  [11495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7134),
  [11497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7134),
  [11499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_char_literal_repeat1, 2, 0, 0),
  [11501] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_char_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(7092),
  [11504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [11506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2513),
  [11508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7090),
  [11510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7090),
  [11512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4078),
  [11514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7092),
  [11516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2486),
  [11518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4074),
  [11520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [11522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4044),
  [11524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7098),
  [11526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7098),
  [11528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2607),
  [11530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2612),
  [11532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7101),
  [11534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7101),
  [11536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [11538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [11540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4166),
  [11542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [11544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4170),
  [11546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7105),
  [11548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7105),
  [11550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8012),
  [11552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4103),
  [11554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [11556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7513),
  [11558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8804),
  [11560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__namespace_specifier, 1, 0, 19),
  [11562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7030),
  [11564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2541),
  [11566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [11568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [11570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list_no_comma, 1, 0, 0),
  [11572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7998),
  [11574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7834),
  [11576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2530),
  [11578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7114),
  [11580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7114),
  [11582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [11584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8554),
  [11586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4222),
  [11588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7344),
  [11590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7344),
  [11592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4515),
  [11594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9063),
  [11596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7172),
  [11598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7172),
  [11600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2535),
  [11602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [11604] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 181), SHIFT_REPEAT(6217),
  [11607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 181),
  [11609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3298),
  [11611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2476),
  [11613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7097),
  [11615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7097),
  [11617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2532),
  [11619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7125),
  [11621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7125),
  [11623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [11625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0),
  [11627] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(7134),
  [11630] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(7134),
  [11633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [11635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2877),
  [11637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4176),
  [11639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [11641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [11643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7563),
  [11645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6140),
  [11647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 5, 0, 0),
  [11649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [11651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1967),
  [11653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3316),
  [11655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7941),
  [11657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3040),
  [11659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7949),
  [11661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8160),
  [11663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [11665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6871),
  [11667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 3, 0, 189),
  [11669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2621),
  [11671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [11673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [11675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2656),
  [11677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7154),
  [11679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7154),
  [11681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6884),
  [11683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 2, 0, 154),
  [11685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2987),
  [11687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2748),
  [11689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [11691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8848),
  [11693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [11695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3457),
  [11697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7651),
  [11699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [11701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [11703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2764),
  [11705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7161),
  [11707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7161),
  [11709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6058),
  [11711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [11713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8830),
  [11715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4182),
  [11717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2970),
  [11719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4184),
  [11721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7174),
  [11723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7174),
  [11725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, 0, 92),
  [11727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [11729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7048),
  [11731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2657),
  [11733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3491),
  [11735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7049),
  [11737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2534),
  [11739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3579),
  [11741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7025),
  [11743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2679),
  [11745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7185),
  [11747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7185),
  [11749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [11751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2369),
  [11753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3028),
  [11755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3871),
  [11757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2795),
  [11759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7233),
  [11761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7233),
  [11763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6489),
  [11765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4483),
  [11767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [11769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8278),
  [11771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3770),
  [11773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7213),
  [11775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7213),
  [11777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3672),
  [11779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6486),
  [11781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7205),
  [11783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7205),
  [11785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [11787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4594),
  [11789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_qualifier, 1, 0, 0),
  [11791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_declarators, 2, 0, 88),
  [11793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [11795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3461),
  [11797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [11799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list, 2, 0, 0),
  [11801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [11803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5935),
  [11805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [11807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2796),
  [11809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [11811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8711),
  [11813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2139),
  [11815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7265),
  [11817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7265),
  [11819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3512),
  [11821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6783),
  [11823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [11825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [11827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8491),
  [11829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [11831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7740),
  [11833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 4, 0, 0),
  [11835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7976),
  [11837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7974),
  [11839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [11841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4206),
  [11843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [11845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7584),
  [11847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 2, 0, 0),
  [11849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2340),
  [11851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7195),
  [11853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7195),
  [11855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7893),
  [11857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7955),
  [11859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5145),
  [11861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 2, 0, 154),
  [11863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5156),
  [11865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2147),
  [11867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3356),
  [11869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 3, 0, 189),
  [11871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2588),
  [11873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7188),
  [11875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7188),
  [11877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6353),
  [11879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 2, 0, 202),
  [11881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4254),
  [11883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7254),
  [11885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7254),
  [11887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [11889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3493),
  [11891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3400),
  [11893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [11895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [11897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3489),
  [11899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3349),
  [11901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4383),
  [11903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8105),
  [11905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8094),
  [11907] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 116), SHIFT_REPEAT(6080),
  [11910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 116),
  [11912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3306),
  [11914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [11916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [11918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [11920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2775),
  [11922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3616),
  [11924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [11926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3263),
  [11928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [11930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [11932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [11934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7482),
  [11936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 3, 0, 0),
  [11938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3248),
  [11940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2817),
  [11942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7306),
  [11944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7306),
  [11946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [11948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3366),
  [11950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [11952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_operator_cast_identifier, 2, 0, 34),
  [11954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3228),
  [11956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [11958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [11960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [11962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [11964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [11966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [11968] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, 0, 201), SHIFT_REPEAT(6871),
  [11971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, 0, 201),
  [11973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3721),
  [11975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2892),
  [11977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7361),
  [11979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7361),
  [11981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4204),
  [11983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [11985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [11987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8331),
  [11989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [11991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [11993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [11995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7888),
  [11997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7879),
  [11999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [12001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2899),
  [12003] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, 0, 201), SHIFT_REPEAT(6884),
  [12006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, 0, 201),
  [12008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7596),
  [12010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_declarator, 1, 0, 0),
  [12012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5168),
  [12014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 3, 0, 209),
  [12016] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, 0, 213), SHIFT_REPEAT(6353),
  [12019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, 0, 213),
  [12021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3928),
  [12023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6156),
  [12025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3921),
  [12027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6772),
  [12029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3326),
  [12032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 2, 0, 0),
  [12034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3915),
  [12036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8049),
  [12038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3906),
  [12040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [12042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand, 4, 0, 208),
  [12044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3888),
  [12046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3864),
  [12048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, 0, 202),
  [12050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6934),
  [12052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7950),
  [12054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [12056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7993),
  [12058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9111),
  [12060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 3, 0, 214),
  [12062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8721),
  [12064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8722),
  [12066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8724),
  [12068] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, 0, 216), SHIFT_REPEAT(9111),
  [12071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, 0, 216),
  [12073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [12075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [12077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [12079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [12081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [12083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3787),
  [12085] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(967),
  [12088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2984),
  [12090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8023),
  [12092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8170),
  [12094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7867),
  [12096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7189),
  [12098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7901),
  [12100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3666),
  [12102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8487),
  [12104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8179),
  [12106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [12108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8171),
  [12110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [12112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6921),
  [12114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4140),
  [12116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4137),
  [12118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6774),
  [12120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [12122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3260),
  [12124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [12126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [12128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [12130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3756),
  [12132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3815),
  [12134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [12136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7947),
  [12138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [12140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand, 7, 0, 217),
  [12142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3642),
  [12144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7907),
  [12146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 2, 0, 0),
  [12148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand, 7, 0, 217),
  [12150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3890),
  [12152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4504),
  [12154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [12156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6559),
  [12158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 3, 0, 0),
  [12160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4256),
  [12162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [12164] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2, 0, 0), SHIFT_REPEAT(946),
  [12167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 2, 0, 210),
  [12169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4031),
  [12171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2723),
  [12173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2722),
  [12175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4201),
  [12177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [12179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [12181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4118),
  [12183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, 0, 154),
  [12185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4119),
  [12187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3863),
  [12189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3853),
  [12191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [12193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [12195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [12197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4123),
  [12199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand, 4, 0, 208),
  [12201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7918),
  [12203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 2, 0, 101),
  [12205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [12207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5294),
  [12209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3874),
  [12211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3875),
  [12213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4124),
  [12215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3885),
  [12217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3889),
  [12219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [12221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8106),
  [12223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 5, 0, 0),
  [12225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3898),
  [12227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4128),
  [12229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4131),
  [12231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2719),
  [12233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [12235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7973),
  [12237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [12239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8464),
  [12241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [12243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [12245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [12247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [12249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3940),
  [12251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3945),
  [12253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3654),
  [12255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4197),
  [12257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 116), SHIFT_REPEAT(5478),
  [12260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 116),
  [12262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [12264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [12266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6263),
  [12268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2706),
  [12270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3446),
  [12272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [12274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7003),
  [12276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4494),
  [12278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [12280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2033),
  [12282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [12284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5843),
  [12286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [12288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [12290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5928),
  [12292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7217),
  [12294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7882),
  [12296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 2, 0, 0),
  [12298] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(6140),
  [12301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [12303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [12305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8418),
  [12307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3962),
  [12309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4009),
  [12311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8123),
  [12313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3507),
  [12315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [12317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3542),
  [12319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [12321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter_declaration, 2, 0, 66),
  [12323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3734),
  [12325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 7, 0, 0),
  [12327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7403),
  [12329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8149),
  [12331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_declarator, 2, 0, 68),
  [12333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_declaration, 3, 0, 144),
  [12335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2592),
  [12337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8052),
  [12339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3715),
  [12341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7198),
  [12343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4382),
  [12345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [12347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [12349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [12351] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_throw_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(3444),
  [12354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_throw_specifier_repeat1, 2, 0, 0),
  [12356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [12358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2737),
  [12360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_namespace_specifier, 3, 0, 0),
  [12362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7026),
  [12364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7959),
  [12366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7899),
  [12368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4368),
  [12370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4362),
  [12372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4359),
  [12374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4224),
  [12376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6961),
  [12378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [12380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [12382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8288),
  [12384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [12386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3704),
  [12388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7529),
  [12390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8646),
  [12392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8644),
  [12394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8642),
  [12396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [12398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [12400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [12402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3508),
  [12404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3632),
  [12406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6261),
  [12408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [12410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3695),
  [12412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4248),
  [12414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, 0, 154),
  [12416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [12418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [12420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 6, 0, 0),
  [12422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8129),
  [12424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 4, 0, 0),
  [12426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7828),
  [12428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [12430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [12432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4271),
  [12434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4241),
  [12436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4265),
  [12438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [12440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3776),
  [12442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 3, 0),
  [12444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2736),
  [12446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8000),
  [12448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_type_parameter_declaration, 2, 0, 0),
  [12450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3955),
  [12452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(650),
  [12455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 0, 0),
  [12457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2655),
  [12459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3415),
  [12461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8076),
  [12463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__namespace_specifier, 2, 0, 59),
  [12465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [12467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_lambda_capture_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(1606),
  [12470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7230),
  [12472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [12474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 3, 0, 196),
  [12476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1981),
  [12478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6782),
  [12480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 3, 0, 5),
  [12482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [12484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [12486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_declarator, 2, 0, 0),
  [12488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7858),
  [12490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8210),
  [12492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8209),
  [12494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8205),
  [12496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_reference_declarator, 2, 0, 0),
  [12498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6519),
  [12500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6793),
  [12502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6786),
  [12504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6789),
  [12506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_namespace_specifier, 2, 0, 0),
  [12508] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1683),
  [12511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_parameter_list_repeat1, 2, 0, 0),
  [12513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [12515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requires_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1696),
  [12518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_requires_parameter_list_repeat1, 2, 0, 0),
  [12520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [12522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [12524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 2, 0, 0),
  [12526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8673),
  [12528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8671),
  [12530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8661),
  [12532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5314),
  [12534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8053),
  [12536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8050),
  [12538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_range_designator, 5, 0, 195),
  [12540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [12542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [12544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [12546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [12548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1694),
  [12551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0),
  [12553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3873),
  [12555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5289),
  [12557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7365),
  [12559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [12561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5311),
  [12563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [12565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3444),
  [12567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6044),
  [12569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [12571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7067),
  [12573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3567),
  [12575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5278),
  [12577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6896),
  [12579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5286),
  [12581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [12583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5285),
  [12585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5271),
  [12587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3328),
  [12589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3862),
  [12591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6061),
  [12593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3870),
  [12595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3037),
  [12597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5284),
  [12599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5283),
  [12601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3597),
  [12603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4268),
  [12605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8038),
  [12607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3868),
  [12609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3867),
  [12611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3866),
  [12613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8036),
  [12615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [12617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [12619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8390),
  [12621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8391),
  [12623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8392),
  [12625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [12627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8033),
  [12629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [12631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5189),
  [12633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [12635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8031),
  [12637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5233),
  [12639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [12641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3681),
  [12643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3599),
  [12645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3581),
  [12647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_initializer_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6559),
  [12650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_initializer_list_repeat1, 2, 0, 0),
  [12652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8028),
  [12654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2653),
  [12656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [12658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [12660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [12662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [12664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5226),
  [12666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9102),
  [12668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9108),
  [12670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9114),
  [12672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [12674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5232),
  [12676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [12678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [12680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(7901),
  [12683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_declaration_repeat1, 2, 0, 0),
  [12685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [12687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5269),
  [12689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5268),
  [12691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subscript_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1127),
  [12694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4469),
  [12696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [12698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3769),
  [12700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [12702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [12704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4245),
  [12706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [12708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [12710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [12712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [12714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5206),
  [12716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7872),
  [12718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3514),
  [12720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [12722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4020),
  [12724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4272),
  [12726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3676),
  [12728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2637),
  [12730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7096),
  [12732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3622),
  [12734] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5960),
  [12737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7045),
  [12739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [12741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_designator, 2, 0, 96),
  [12743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [12745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2981),
  [12747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2967),
  [12749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2966),
  [12751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2965),
  [12753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [12755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [12757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8013),
  [12759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 3, 0, 0),
  [12761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [12763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [12765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6077),
  [12767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3749),
  [12769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [12771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3580),
  [12773] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_params_repeat1, 2, 0, 0), SHIFT_REPEAT(8170),
  [12776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_params_repeat1, 2, 0, 0),
  [12778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [12780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [12782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3041),
  [12784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3044),
  [12786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3049),
  [12788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3050),
  [12790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8640),
  [12792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8647),
  [12794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8648),
  [12796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [12798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [12800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [12802] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_structured_binding_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(8252),
  [12805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_structured_binding_declarator_repeat1, 2, 0, 0),
  [12807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [12809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6936),
  [12811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5293),
  [12813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6927),
  [12815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [12817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2887),
  [12819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2838),
  [12821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2882),
  [12823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2874),
  [12825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [12827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7170),
  [12829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7885),
  [12831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [12833] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_lambda_capture_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(1547),
  [12836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [12838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7176),
  [12840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7264),
  [12842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3629),
  [12844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [12846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7186),
  [12848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4516),
  [12850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4518),
  [12852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4519),
  [12854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4526),
  [12856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [12858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7206),
  [12860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5306),
  [12862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7260),
  [12864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5220),
  [12866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3641),
  [12868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3547),
  [12870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7308),
  [12872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6511),
  [12874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7013),
  [12876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3805),
  [12878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [12880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6297),
  [12882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4102),
  [12884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4100),
  [12886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4099),
  [12888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4098),
  [12890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [12892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [12894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3631),
  [12896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7342),
  [12898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6982),
  [12900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [12902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7032),
  [12904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [12906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8659),
  [12908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [12910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [12912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6125),
  [12914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8814),
  [12916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [12918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8024),
  [12920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [12922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8653),
  [12924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5995),
  [12926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8447),
  [12928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [12930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8762),
  [12932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7826),
  [12934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [12936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 4, 0, 0),
  [12938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 4, 0, 0),
  [12940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [12942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8153),
  [12944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [12946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [12948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [12950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8492),
  [12952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [12954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4980),
  [12956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, 0, 6),
  [12958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 3, 0, 0),
  [12960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7866),
  [12962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [12964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8610),
  [12966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 3, 0, 101),
  [12968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4321),
  [12970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5151),
  [12972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7877),
  [12974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 3, 0, 167),
  [12976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [12978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3543),
  [12980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3160),
  [12982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [12984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8365),
  [12986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8065),
  [12988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_template_parameter_declaration, 3, 0, 57),
  [12990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8039),
  [12992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_type_parameter_declaration, 3, 0, 157),
  [12994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 2, 0),
  [12996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [12998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8035),
  [13000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_pack_expansion, 2, 0, 28),
  [13002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7896),
  [13004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8748),
  [13006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8651),
  [13008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [13010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8800),
  [13012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [13014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [13016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8412),
  [13018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3080),
  [13020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [13022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8199),
  [13024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7430),
  [13026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 1, 0, 0),
  [13028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [13030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8791),
  [13032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [13034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8078),
  [13036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [13038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7928),
  [13040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8093),
  [13042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [13044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8569),
  [13046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [13048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8219),
  [13050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8122),
  [13052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8635),
  [13054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9098),
  [13056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7910),
  [13058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 6, 0, 0),
  [13060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4675),
  [13062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [13064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8274),
  [13066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7916),
  [13068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [13070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [13072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8827),
  [13074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9101),
  [13076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8856),
  [13078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9104),
  [13080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3193),
  [13082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8876),
  [13084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9107),
  [13086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8895),
  [13088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9110),
  [13090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8913),
  [13092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9113),
  [13094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8928),
  [13096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9116),
  [13098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8940),
  [13100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9118),
  [13102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 2, 0, 0),
  [13104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 2, 0, 0),
  [13106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8945),
  [13108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9119),
  [13110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8949),
  [13112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9120),
  [13114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [13116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8953),
  [13118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9121),
  [13120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [13122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8955),
  [13124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9122),
  [13126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8957),
  [13128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9123),
  [13130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8959),
  [13132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9124),
  [13134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8961),
  [13136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9125),
  [13138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7873),
  [13140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 3, 0, 0),
  [13142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 3, 0, 0),
  [13144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8963),
  [13146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9126),
  [13148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7829),
  [13150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [13152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8287),
  [13154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8965),
  [13156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9127),
  [13158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 4, 0, 92),
  [13160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8967),
  [13162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9128),
  [13164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8969),
  [13166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9129),
  [13168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8971),
  [13170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9130),
  [13172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8004),
  [13174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, 0, 210),
  [13176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8697),
  [13178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4141),
  [13180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [13182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [13184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8236),
  [13186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_kernel_call_syntax, 3, 0, 0),
  [13188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8374),
  [13190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [13192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [13194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7243),
  [13196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [13198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2466),
  [13200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [13202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [13204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4096),
  [13206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2784),
  [13208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [13210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8194),
  [13212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [13214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [13216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef, 3, 0, 80),
  [13218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [13220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [13222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [13224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [13226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [13228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [13230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [13232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [13234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [13236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8858),
  [13238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [13240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6330),
  [13242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4127),
  [13244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [13246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6357),
  [13248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7015),
  [13250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8898),
  [13252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4132),
  [13254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6032),
  [13256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4195),
  [13258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [13260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [13262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6712),
  [13264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [13266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [13268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [13270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7870),
  [13272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3825),
  [13274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [13276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [13278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3929),
  [13280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9040),
  [13282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [13284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8547),
  [13286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [13288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8984),
  [13290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3104),
  [13292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [13294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [13296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [13298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4072),
  [13300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4117),
  [13302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5238),
  [13304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5244),
  [13306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [13308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_parameter_list, 3, 0, 0),
  [13310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5257),
  [13312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8415),
  [13314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3737),
  [13316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7235),
  [13318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [13320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [13322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [13324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3877),
  [13326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2682),
  [13328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [13330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [13332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_based_modifier, 2, 0, 0),
  [13334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8752),
  [13336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7725),
  [13338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8451),
  [13340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2683),
  [13342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3692),
  [13344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2815),
  [13346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2684),
  [13348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4024),
  [13350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [13352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [13354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [13356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [13358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [13360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3511),
  [13362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [13364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [13366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4225),
  [13368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [13370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3614),
  [13372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8637),
  [13374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [13376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8693),
  [13378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [13380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [13382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [13384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [13386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [13388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [13390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8537),
  [13392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [13394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [13396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [13398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3619),
  [13400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8503),
  [13402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [13404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [13406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [13408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4152),
  [13410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4209),
  [13412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [13414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5304),
  [13416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8345),
  [13418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4155),
  [13420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4158),
  [13422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [13424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8461),
  [13426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [13428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8443),
  [13430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [13432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3839),
  [13434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [13436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7325),
  [13438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [13440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [13442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7209),
  [13444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [13446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8330),
  [13448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8320),
  [13450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8462),
  [13452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4219),
  [13454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [13456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2804),
  [13458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [13460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [13462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [13464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [13466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8370),
  [13468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7801),
  [13470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [13472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [13474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8200),
  [13476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8355),
  [13478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6575),
  [13480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [13482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [13484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [13486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8196),
  [13488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4270),
  [13490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [13492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8699),
  [13494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8714),
  [13496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8208),
  [13498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4239),
  [13500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_parameter_list, 4, 0, 0),
  [13502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8560),
  [13504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7968),
  [13506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [13508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [13510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8696),
  [13512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8281),
  [13514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [13516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5313),
  [13518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [13520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8228),
  [13522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5194),
  [13524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7350),
  [13526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [13528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [13530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3494),
  [13532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [13534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5309),
  [13536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2816),
  [13538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8698),
  [13540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3825),
  [13542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2893),
  [13544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [13546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [13548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8404),
  [13550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8799),
  [13552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8380),
  [13554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [13556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1941),
  [13558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2724),
  [13560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5248),
  [13562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3499),
  [13564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8394),
  [13566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [13568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [13570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8029),
  [13572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9117),
  [13574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8027),
  [13576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8432),
  [13578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5224),
  [13580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3600),
  [13582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7182),
  [13584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_kernel_call_syntax, 4, 0, 0),
  [13586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [13588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8444),
  [13590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [13592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [13594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [13596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4084),
  [13598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [13600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8452),
  [13602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [13604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [13606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [13608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8456),
  [13610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [13612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7121),
  [13614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [13616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [13618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [13620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8870),
  [13622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [13624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [13626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [13628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3997),
  [13630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 4, 0, 128),
  [13632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3998),
  [13634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8652),
  [13636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3644),
  [13638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8675),
  [13640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2919),
  [13642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3999),
  [13644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [13646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef, 4, 0, 129),
  [13648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3646),
  [13650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8694),
  [13652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3649),
  [13654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [13656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2774),
  [13658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [13660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [13662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8709),
  [13664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [13666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3667),
  [13668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8664),
  [13670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8726),
  [13672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [13674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3669),
  [13676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3670),
  [13678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3674),
  [13680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7023),
  [13682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3958),
  [13684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8735),
  [13686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8925),
  [13688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7582),
  [13690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8998),
  [13692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [13694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7112),
  [13696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5171),
  [13698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9024),
  [13700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [13702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8256),
  [13704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9136),
  [13706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [13708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [13710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [13712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 4, 0, 80),
  [13714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4085),
  [13716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4088),
  [13718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9059),
  [13720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2610),
  [13722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [13724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [13726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6697),
  [13728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9034),
  [13730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2589),
  [13732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7014),
  [13734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9016),
  [13736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [13738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [13740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8873),
  [13742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8852),
  [13744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3544),
  [13746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8845),
  [13748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [13750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [13752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [13754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8759),
  [13756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8757),
  [13758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8729),
  [13760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4172),
  [13762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 4, 0, 10),
  [13764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8715),
  [13766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8710),
  [13768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8708),
  [13770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4174),
  [13772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8689),
  [13774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8685),
  [13776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8672),
  [13778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8667),
  [13780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8658),
  [13782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8656),
  [13784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8638),
  [13786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8633),
  [13788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8617),
  [13790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8615),
  [13792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8579),
  [13794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8574),
  [13796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8553),
  [13798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8552),
  [13800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8550),
  [13802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8548),
  [13804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8546),
  [13806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8545),
  [13808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [13810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8756),
  [13812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7874),
  [13814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5205),
  [13816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8489),
  [13818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [13820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [13822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [13824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3403),
  [13826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [13828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [13830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [13832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4525),
  [13834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [13836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [13838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [13840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [13842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3902),
  [13844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [13846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [13848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4959),
  [13850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [13852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6763),
  [13854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5287),
  [13856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7944),
  [13858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8425),
  [13860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [13862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [13864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8420),
  [13866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8662),
  [13868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [13870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4047),
  [13872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [13874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [13876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [13878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [13880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1993),
  [13882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [13884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [13886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7329),
  [13888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8382),
  [13890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8798),
  [13892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8623),
  [13894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [13896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4179),
  [13898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [13900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4180),
  [13902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [13904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [13906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [13908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [13910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8358),
  [13912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8822),
  [13914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2624),
  [13916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [13918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [13920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [13922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [13924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2622),
  [13926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [13928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3960),
  [13930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [13932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [13934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [13936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2765),
  [13938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2652),
  [13940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2766),
  [13942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [13944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [13946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6993),
  [13948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4263),
  [13950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3683),
  [13952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3195),
  [13954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [13956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8818),
  [13958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8828),
  [13960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [13962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [13964] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8841),
  [13967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [13969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4187),
  [13971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3909),
  [13973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4198),
  [13975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [13977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [13979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3718),
  [13981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8718),
  [13983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4054),
  [13985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4437),
  [13987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [13989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [13991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [13993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3288),
  [13995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [13997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [13999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4221),
  [14001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 5, 0, 176),
  [14003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2729),
  [14005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5170),
  [14007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4804),
  [14009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [14011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [14013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 5, 0, 128),
  [14015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6997),
  [14017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 5, 0, 79),
  [14019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8889),
  [14021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 3, 0, 80),
  [14023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 3, 0, 80),
  [14025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [14027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [14029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [14031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8810),
  [14033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [14035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 3, 0, 80),
  [14037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 5, 0, 129),
  [14039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [14041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8764),
  [14043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [14045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [14047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3243),
  [14049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [14051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [14053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [14055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [14057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [14059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [14061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [14063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [14065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [14067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [14069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [14071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2721),
  [14073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3852),
  [14075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4967),
  [14077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5317),
  [14079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [14081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4998),
  [14083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [14085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [14087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8441),
  [14089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4107),
  [14091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [14093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [14095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [14097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2776),
  [14099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [14101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8291),
  [14103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5902),
  [14105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [14107] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [14109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8177),
  [14111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [14113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [14115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [14117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [14119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6247),
  [14121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [14123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8332),
  [14125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [14127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6245),
  [14129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6290),
  [14131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8242),
  [14133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [14135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8622),
  [14137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [14139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7447),
  [14141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8127),
  [14143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [14145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8231),
  [14147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unary_right_fold, 3, 0, 54),
  [14149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [14151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [14153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3626),
  [14155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [14157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8239),
  [14159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7009),
  [14161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4066),
  [14163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_parameter_list, 2, 0, 0),
  [14165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8258),
  [14167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [14169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [14171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [14173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8268),
  [14175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [14177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [14179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8058),
  [14181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [14183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3474),
  [14185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6453),
  [14187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [14189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4229),
  [14191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [14193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8026),
  [14195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [14197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8343),
  [14199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6452),
  [14201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [14203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [14205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [14207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8350),
  [14209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8362),
  [14211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2735),
  [14213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [14215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8368),
  [14217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [14219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3029),
  [14221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7972),
  [14223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [14225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3375),
  [14227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [14229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [14231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7960),
  [14233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8410),
  [14235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8879),
  [14237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [14239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8416),
  [14241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8426),
  [14243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5183),
  [14245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [14247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8431),
  [14249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [14251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [14253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7926),
  [14255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [14257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [14259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [14261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [14263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 6, 0, 176),
  [14265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 4, 0, 128),
  [14267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8460),
  [14269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [14271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 4, 0, 128),
  [14273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [14275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8466),
  [14277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8475),
  [14279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [14281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [14283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8480),
  [14285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [14287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [14289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7875),
  [14291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3302),
  [14293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3266),
  [14295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [14297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4007),
  [14299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 4, 0, 129),
  [14301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8502),
  [14303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3895),
  [14305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4858),
  [14307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [14309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8508),
  [14311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8516),
  [14313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [14315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8521),
  [14317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [14319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 4, 0, 129),
  [14321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7838),
  [14323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [14325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [14327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8911),
  [14329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8534),
  [14331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2701),
  [14333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8538),
  [14335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8540),
  [14337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [14339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8543),
  [14341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [14343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [14345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7818),
  [14347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [14349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2708),
  [14351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [14353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8556),
  [14355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [14357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8559),
  [14359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7833),
  [14361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [14363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8564),
  [14365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8566),
  [14367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7835),
  [14369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [14371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8571),
  [14373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8572),
  [14375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7836),
  [14377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [14379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8577),
  [14381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8578),
  [14383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8580),
  [14385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8581),
  [14387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8583),
  [14389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8584),
  [14391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8585),
  [14393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8586),
  [14395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8587),
  [14397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8588),
  [14399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8589),
  [14401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8590),
  [14403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8591),
  [14405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8592),
  [14407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8593),
  [14409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8594),
  [14411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8595),
  [14413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8596),
  [14415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8597),
  [14417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8598),
  [14419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, 0, 128),
  [14421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 4, 0, 129),
  [14423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [14425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [14427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8634),
  [14429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4006),
  [14431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [14433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [14435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [14437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4019),
  [14439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4028),
  [14441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [14443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [14445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7146),
  [14447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8665),
  [14449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4082),
  [14451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [14453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3452),
  [14455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3451),
  [14457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8436),
  [14459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [14461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [14463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [14465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3972),
  [14467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [14469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [14471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [14473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [14475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [14477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3908),
  [14479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [14481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [14483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [14485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [14487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [14489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [14491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8306),
  [14493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4217),
  [14495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [14497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [14499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [14501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [14503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [14505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8826),
  [14507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2833),
  [14509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9133),
  [14511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7269),
  [14513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8838),
  [14515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [14517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8051),
  [14519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [14521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [14523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8855),
  [14525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4227),
  [14527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [14529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7280),
  [14531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8861),
  [14533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2725),
  [14535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [14537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8875),
  [14539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [14541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7293),
  [14543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8881),
  [14545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4230),
  [14547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [14549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [14551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8894),
  [14553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 5, 0, 176),
  [14555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7301),
  [14557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8900),
  [14559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 5, 0, 176),
  [14561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 5, 0, 176),
  [14563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [14565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8912),
  [14567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9066),
  [14569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7313),
  [14571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8918),
  [14573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [14575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [14577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [14579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7323),
  [14581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8932),
  [14583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [14585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [14587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [14589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8942),
  [14591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8946),
  [14593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3814),
  [14595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8950),
  [14597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4833),
  [14599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8954),
  [14601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [14603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8956),
  [14605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8958),
  [14607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8960),
  [14609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8962),
  [14611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8964),
  [14613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8966),
  [14615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6096),
  [14617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8968),
  [14619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6098),
  [14621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8970),
  [14623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6099),
  [14625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8972),
  [14627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3237),
  [14629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8988),
  [14631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [14633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3412),
  [14635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9027),
  [14637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [14639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3460),
  [14641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9037),
  [14643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7418),
  [14645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3483),
  [14647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9046),
  [14649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [14651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3471),
  [14653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9054),
  [14655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8189),
  [14657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3455),
  [14659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9062),
  [14661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [14663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3247),
  [14665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9068),
  [14667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9079),
  [14669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9072),
  [14671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9074),
  [14673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9076),
  [14675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9078),
  [14677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9080),
  [14679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9082),
  [14681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9084),
  [14683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9086),
  [14685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9088),
  [14687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9090),
  [14689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9092),
  [14691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9094),
  [14693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9096),
  [14695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3854),
  [14697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [14699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9105),
  [14701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3901),
  [14703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [14705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2835),
  [14707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7164),
  [14709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [14711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [14713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [14715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [14717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [14719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [14721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token_raw_string_delimiter = 0,
  ts_external_token_raw_string_content = 1,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_raw_string_delimiter] = sym_raw_string_delimiter,
  [ts_external_token_raw_string_content] = sym_raw_string_content,
};

static const bool ts_external_scanner_states[4][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_raw_string_delimiter] = true,
    [ts_external_token_raw_string_content] = true,
  },
  [2] = {
    [ts_external_token_raw_string_delimiter] = true,
  },
  [3] = {
    [ts_external_token_raw_string_content] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_cuda_external_scanner_create(void);
void tree_sitter_cuda_external_scanner_destroy(void *);
bool tree_sitter_cuda_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_cuda_external_scanner_serialize(void *, char *);
void tree_sitter_cuda_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_cuda(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_cuda_external_scanner_create,
      tree_sitter_cuda_external_scanner_destroy,
      tree_sitter_cuda_external_scanner_scan,
      tree_sitter_cuda_external_scanner_serialize,
      tree_sitter_cuda_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
